from kolya import parameters
import math

def X_DeltaBR_KIN_MS_HO(elcut,par,hqe, flagmb4 = 1, flagmb5 = 1):
    """ Higher order 1/mb^4 and 1/mb^5 corrections to DeltaBR (with Elcut in historical basis) """ 
    y=2*elcut/par.mbkin
    r=par.mcMS/par.mbkin

    m1=hqe.m1/par.mbkin**4
    m2=hqe.m2/par.mbkin**4
    m3=hqe.m3/par.mbkin**4
    m4=hqe.m4/par.mbkin**4
    m5=hqe.m5/par.mbkin**4
    m6=hqe.m6/par.mbkin**4
    m7=hqe.m7/par.mbkin**4
    m8=hqe.m8/par.mbkin**4
    m9=hqe.m9/par.mbkin**4
    r1=hqe.r1/par.mbkin**5
    r2=hqe.r2/par.mbkin**5
    r3=hqe.r3/par.mbkin**5
    r4=hqe.r4/par.mbkin**5
    r5=hqe.r5/par.mbkin**5
    r6=hqe.r6/par.mbkin**5
    r7=hqe.r7/par.mbkin**5
    r8=hqe.r8/par.mbkin**5
    r9=hqe.r9/par.mbkin**5
    r10=hqe.r10/par.mbkin**5
    r11=hqe.r11/par.mbkin**5
    r12=hqe.r12/par.mbkin**5
    r13=hqe.r13/par.mbkin**5
    r14=hqe.r14/par.mbkin**5
    r15=hqe.r15/par.mbkin**5
    r16=hqe.r16/par.mbkin**5
    r17=hqe.r17/par.mbkin**5
    r18=hqe.r18/par.mbkin**5

    logy=math.log((1-y)/r**2)
    lr=math.log(r)

    res = 0
    if flagmb4 == 1:
        res +=((m1*(-40*r**2-5*r**8+5*(1+y**4)-(4*r**6*(-10+60*y-150*y**2+200*y**3
            -145*y**4+90*y**5-29*y**6+4*y**7))/(-1+y)**6+2*r**4*(30*logy+(y*(
            -30+135*y-235*y**2+185*y**3-103*y**4+24*y**5))/(-1+y)**5)))/40)

        res +=((m2*(165*r**8*(-1+y)**6+12*logy*(8+27*r**4)*(-1+y)**6+(-1+y)**6*(
            -533+96*y+48*y**2-64*y**3+3*y**4)-24*r**2*(-1+y)**3*(43-129*y+129*y**2
            -31*y**3-16*y**4+8*y**5)+4*r**6*(14-84*y+210*y**2-64*y**3-141*y**4
            +222*y**5-121*y**6+24*y**7)+6*r**4*(-120+774*y-2097*y**2+2986*y**3
            -2432*y**4+1152*y**5-295*y**6+32*y**7)))/(72*(-1+y)**6))

        res +=(-1/18*(m3*(24*logy*(-1+y)**5-54*r**8*(-1+y)**5+2*(-1+y)**4*(13-25*y
            +6*y**2-y**3+y**4)-6*r**2*(-1+y)**2*(12-36*y+36*y**2-15*y**3-y**4
            +2*y**5)+r**6*(-152+760*y-1520*y**2+1730*y**3-1090*y**4+353*y**5
            -45*y**6)+3*r**4*(48-240*y+480*y**2-530*y**3+340*y**4-113*y**5+15*y**6)))/(
            -1+y)**5)

        res +=((m4*(19*r**8*(-1+y)**5+12*logy*(4+r**4)*(-1+y)**5+(-1+y)**4*(67-115*y
            +24*y**2+7*y**4+y**5)+8*r**2*(-1+y)**2*(-7+21*y-21*y**2+6*y**3-3*y**4
            +2*y**5)+4*r**6*(14-70*y+140*y**2-162*y**3+95*y**4-28*y**5+3*y**6)
            -2*r**4*(24-114*y+213*y**2-245*y**3+169*y**4-53*y**5+6*y**6)))/(24*(
            -1+y)**5))

        res +=((m5*(-195*r**8*(-1+y)**5+12*logy*(16+27*r**4)*(-1+y)**5-24*r**2*(-1
            +y)**3*(-31+62*y-31*y**2-6*y**3+2*y**4)+(-1+y)**4*(397-589*y+96*y**2
            +176*y**3+13*y**4+3*y**5)-4*r**6*(214-1070*y+2140*y**2-2344*y**3
            +1355*y**4-379*y**5+36*y**6)+6*r**4*(168-894*y+1923*y**2-2223*y**3
            +1469*y**4-523*y**5+80*y**6)))/(72*(-1+y)**5))

        res +=((m6*(-1125*r**8*(-1+y)**5+60*logy*(-8+9*r**4)*(-1+y)**5+5*(-1+y)**5*(257
            -96*y-48*y**2+16*y**3+9*y**4)-24*r**2*(-1+y)**2*(-75+225*y-225*y**2
            +145*y**3-120*y**4+42*y**5)+6*r**4*(240-1290*y+2805*y**2-3145*y**3
            +1895*y**4-577*y**5+72*y**6)-4*r**6*(770-3850*y+7700*y**2-8600*y**3
            +5785*y**4-2021*y**5+288*y**6)))/(360*(-1+y)**5))

        res +=(-1/30*(m7*y**3*(10*(-1+y)**5+6*r**2*(-1+y)**2*(5-5*y+2*y**2)-3*r**4*(10
            -10*y-y**2+y**3)+r**6*(10+10*y-11*y**2+3*y**3)))/(-1+y)**5)

        res +=((m8*(-15*r**8*(-1+y)**5+5*(-1+y)**5*(3+8*y**3+3*y**4)-24*r**2*(-1
            +y)**2*(-5+15*y-15*y**2-5*y**4+4*y**5)-4*r**6*(30-150*y+300*y**2
            -250*y**3+245*y**4-112*y**5+21*y**6)+6*r**4*(-1+y)*(30*logy*(-1+y)**4
            +y*(30-105*y+110*y**2-55*y**3+14*y**4))))/(480*(-1+y)**5))

        res +=((m9*(60*logy*(-1+y)**5-15*r**8*(-1+y)**5+5*(-1+y)**4*(25-37*y+6*y**2
            +8*y**3+10*y**4)+6*r**2*(-1+y)**2*(-40+120*y-120*y**2+45*y**3-25*y**4
            +18*y**5)+r**6*(-80+400*y-800*y**2+890*y**3-460*y**4+101*y**5-3*y**6)
            +3*r**4*(60-300*y+600*y**2-650*y**3+415*y**4-146*y**5+21*y**6)))/(90*(
            -1+y)**5))
    if flagmb5 == 1:
        res +=((r1*(-35085*r**8*(-1+y)**7+300*logy*(4+9*r**4)*(-1+y)**7+5*(-1+y)**5*(
            -1127+2494*y-1487*y**2+1184*y**3-1435*y**4+662*y**5+45*y**6)+24*r**2*(
            -1+y)**3*(-175+700*y-1050*y**2-170*y**3+1705*y**4-1514*y**5+432*y**6)
            -20*r**6*(2930-20510*y+61530*y**2-110206*y**3+126235*y**4-94137*y**5
            +43841*y**6-11591*y**7+1332*y**8)+6*r**4*(2280-16410*y+50805*y**2
            -99905*y**3+135020*y**4-122850*y**5+71087*y**6-23339*y**7+3312*y**8)))/(1800*(
            -1+y)**7))

        res +=(-1/150*(r2*(1020*(-1+y)**7+680*r**10*(-1+y)**7-5*r**2*(-1+y)**5*(160
            +420*logy*(-1+y)**2+100*y-470*y**2+312*y**3-145*y**4+26*y**5-5*y**6)
            -2*r**4*(-1+y)**3*(-200+800*y-1200*y**2+330*y**3+505*y**4-294*y**5
            +17*y**6)+r**6*(-1+y)*(-600+900*logy*(-1+y)**6+4500*y-13950*y**2
            +20060*y**3-15255*y**4+7320*y**5-2309*y**6+354*y**7)+10*r**8*(70-490*y
            +1470*y**2-2806*y**3+3445*y**4-2568*y**5+1176*y**6-308*y**7+35*y**8)))/(r**2*(
            -1+y)**7))

        res +=((r3*(3240/r**2-3165*r**8+(5*(-835-600*logy*(-1+y)**2+1070*y+65*y**2
            -284*y**3-65*y**4+118*y**5+15*y**6))/(-1+y)**2+(12*r**2*(200-800*y
            +1200*y**2-1035*y**3+915*y**4-597*y**5+171*y**6))/(-1+y)**4+(18*r**4*(
            -450+150*logy*(-1+y)**6+2850*y-7575*y**2+11240*y**3-10595*y**4+6405*y**5
            -2236*y**6+341*y**7))/(-1+y)**6-(10*r**6*(980-6860*y+20580*y**2-35398*y**3
            +38770*y**4-27219*y**5+11753*y**6-2819*y**7+285*y**8))/(-1+y)**7))/450)

        res +=((r4*(-3060*(-1+y)**7+4410*r**10*(-1+y)**7-5*r**2*(-1+y)**5*(-1310+60*logy*(
            -1+y)**2+2680*y-1400*y**2-316*y**3+335*y**4-58*y**5+15*y**6)-6*r**4*(
            -1+y)**3*(600-2400*y+3600*y**2-2380*y**3+795*y**4-256*y**5+83*y**6)
            -3*r**6*(-1+y)*(-2400+900*logy*(-1+y)**6+15300*y-40950*y**2+62560*y**3
            -60005*y**4+36270*y**5-12559*y**6+1904*y**7)+10*r**8*(1150-8050*y
            +24150*y**2-42032*y**3+46265*y**4-32721*y**5+14287*y**6-3481*y**7+360*y**8)))/(450*r**2*(
            -1+y)**7))

        res +=(-1/1800*(r5*(-2880*(-1+y)**7+1905*r**10*(-1+y)**7+5*r**2*(-1+y)**5*(
            -485+1680*logy*(-1+y)**2+2650*y-3005*y**2+1328*y**3-745*y**4+194*y**5
            +15*y**6)+24*r**4*(-1+y)**3*(125-500*y+750*y**2-540*y**3+485*y**4
            -288*y**5+64*y**6)-6*r**6*(-1+y)*(-1500+450*logy*(-1+y)**6+9450*y
            -24975*y**2+37790*y**3-33770*y**4+17340*y**5-5111*y**6+656*y**7)+20*r**8*(430
            -3010*y+9030*y**2-15578*y**3+16415*y**4-10425*y**5+3913*y**6-751*y**7
            +48*y**8)))/(r**2*(-1+y)**7))

        res +=((r6*(6480*(-1+y)**7+10095*r**10*(-1+y)**7-5*r**2*(-1+y)**5*(2875-1200*logy*(
            -1+y)**2-6950*y+4675*y**2+1088*y**3-1825*y**4+674*y**5+15*y**6)
            -24*r**4*(-1+y)**3*(-275+1100*y-1650*y**2+610*y**3+560*y**4-538*y**5
            +139*y**6)+18*r**6*(-1+y)*(300+150*logy*(-1+y)**6-1650*y+3675*y**2
            -5070*y**3+4410*y**4-2220*y**5+563*y**6-48*y**7)+20*r**8*(710-4970*y
            +14910*y**2-27022*y**3+31885*y**4-24435*y**5+11627*y**6-3149*y**7+372*y**8)))/(1800*r**2*(
            -1+y)**7))

        res +=(-1/1800*(r7*(720*(-1+y)**7+5655*r**10*(-1+y)**7+5*r**2*(-1+y)**5*(-35
            +1680*logy*(-1+y)**2+1750*y-2555*y**2+608*y**3+305*y**4-226*y**5
            -15*y**6)-24*r**4*(-1+y)**3*(125-500*y+750*y**2-310*y**3-60*y**4
            +38*y**5+11*y**6)+6*r**6*(-1+y)*(-300+450*logy*(-1+y)**6+2250*y
            -6975*y**2+13910*y**3-17030*y**4+12660*y**5-5339*y**6+944*y**7)+20*r**8*(70
            -490*y+1470*y**2-3518*y**3+6545*y**4-7215*y**5+4543*y**6-1561*y**7
            +228*y**8)))/(r**2*(-1+y)**7))

        res +=((r8*(-2985*r**8*(-1+y)**6+60*logy*(4+9*r**4)*(-1+y)**6+24*r**2*(-1
            +y)**2*(-155+620*y-930*y**2+670*y**3-175*y**4-42*y**5+24*y**6)+(
            -1+y)**4*(985-1730*y+625*y**2+800*y**3-955*y**4+278*y**5+45*y**6)
            +6*r**4*(120-630*y+1305*y**2-1370*y**3-150*y**4+1572*y**5-1087*y**6
            +240*y**7)-4*r**6*(-1250+7500*y-18750*y**2+27280*y**3-26715*y**4+16014*y**5
            -5315*y**6+756*y**7)))/(360*(-1+y)**6))

        res +=((r9*(40*(-1+y)**6+110*r**10*(-1+y)**6-r**2*(-1+y)**4*(-210+180*logy*(
            -1+y)**2+600*y-480*y**2+360*y**3-485*y**4+198*y**5+5*y**6)-4*r**4*(
            -1+y)**2*(110-440*y+660*y**2-650*y**3+725*y**4-580*y**5+172*y**6)
            -r**6*(-1+y)*(560+180*logy*(-1+y)**5-2980*y+6410*y**2-7850*y**3
            +6415*y**4-3281*y**5+714*y**6)+2*r**8*(-240+1440*y-3600*y**2+4990*y**3
            -4165*y**4+2031*y**5-517*y**6+51*y**7)))/(30*r**2*(-1+y)**6))

        res +=(-1/30*(r10*(-60*(-1+y)**6+105*r**10*(-1+y)**6+r**2*(-1+y)**4*(115-120*logy*(
            -1+y)**2-350*y+295*y**2+140*y**3-325*y**4+122*y**5+5*y**6)+2*r**6*(
            -1+y)*(150+90*logy*(-1+y)**5-840*y+1905*y**2-2135*y**3+1600*y**4
            -869*y**5+207*y**6)+2*r**4*(-1+y)**2*(60-240*y+360*y**2-420*y**3
            +665*y**4-664*y**5+215*y**6)+2*r**8*(10-60*y+150*y**2+140*y**3-260*y**4
            +201*y**5-86*y**6+15*y**7)))/(r**2*(-1+y)**6))

        res +=(-1/30*(r11*(20*(-1+y)**6+255*r**10*(-1+y)**6-r**2*(-1+y)**4*(275-120*logy*(
            -1+y)**2-670*y+455*y**2+300*y**3-565*y**4+186*y**5+5*y**6)-2*r**4*(
            -1+y)**2*(-120+480*y-720*y**2+180*y**3+805*y**4-920*y**5+283*y**6)
            -2*r**6*(-1+y)*(290+90*logy*(-1+y)**5-1540*y+3305*y**2-4095*y**3
            +3300*y**4-1641*y**5+351*y**6)+2*r**8*(-410+2460*y-6150*y**2+8700*y**3
            -7420*y**4+3711*y**5-986*y**6+105*y**7)))/(r**2*(-1+y)**6))

        res +=((r12*(-60/r**2-265*r**8+(2*r**2*(-200+600*y-600*y**2+600*y**3-815*y**4
            +349*y**5))/(-1+y)**3+(5*(-31+48*logy*(-1+y)**2+110*y-103*y**2
            +76*y**3-97*y**4+42*y**5+y**6))/(-1+y)**2+(2*r**4*(390+90*logy*(-1
            +y)**5-2040*y+4305*y**2-5195*y**3+4105*y**4-1982*y**5+411*y**6))/(
            -1+y)**5-(2*r**6*(-430+2580*y-6450*y**2+9120*y**3-7770*y**4+3879*y**5
            -1028*y**6+109*y**7))/(-1+y)**6))/30)

        res +=((r13*(120*(-1+y)**5+675*r**10*(-1+y)**5-r**2*(-1+y)**3*(55+240*logy*(
            -1+y)**2+130*y-305*y**2+1940*y**3-2905*y**4+1046*y**5+15*y**6)+10*r**8*(224
            -1120*y+2240*y**2-2498*y**3+1540*y**4-479*y**5+57*y**6)-6*r**6*(310
            +90*logy*(-1+y)**5-1640*y+3505*y**2-4435*y**3+3905*y**4-2212*y**5
            +519*y**6)-12*r**4*(-30+150*y-300*y**2+635*y**3-1465*y**4+1947*y**5
            -1217*y**6+280*y**7)))/(90*r**2*(-1+y)**5))

        res +=((r14*(60*(-1+y)**6+630*r**10*(-1+y)**6-6*r**4*(-1+y)**2*(60-240*y
            +360*y**2-260*y**3+105*y**4-20*y**5+y**6)-r**2*(-1+y)**4*(-130+300*logy*(
            -1+y)**2+560*y-580*y**2+100*y**3+115*y**4-74*y**5+15*y**6)-3*r**6*(
            -1+y)*(520+180*logy*(-1+y)**5-2780*y+6010*y**2-7110*y**3+5095*y**4
            -2039*y**5+352*y**6)+2*r**8*(-1010+6060*y-15150*y**2+21310*y**3-18375*y**4
            +9390*y**5-2573*y**6+288*y**7)))/(90*r**2*(-1+y)**6))

        res +=((r15*(-240*(-1+y)**6+195*r**10*(-1+y)**6+6*r**6*(-1+y)**2*(-260+90*logy*(
            -1+y)**4+1130*y-1875*y**2+1730*y**3-1455*y**4+472*y**5)-r**2*(-1
            +y)**4*(-245+240*logy*(-1+y)**2+730*y-605*y**2-1480*y**3+2255*y**4
            -766*y**5+15*y**6)+24*r**4*(-1+y)**2*(35-140*y+210*y**2-270*y**3
            +480*y**4-440*y**5+134*y**6)+4*r**8*(130-780*y+1950*y**2-2540*y**3
            +1275*y**4-78*y**5-197*y**6+60*y**7)))/(180*r**2*(-1+y)**6))

        res +=((r16*(-240*(-1+y)**5+1275*r**10*(-1+y)**5-r**2*(-1+y)**3*(-845+240*logy*(
            -1+y)**2+1930*y-1205*y**2-3520*y**3+5375*y**4-1774*y**5+15*y**6)
            +20*r**8*(22-110*y+220*y**2-484*y**3+485*y**4-241*y**5+48*y**6)+6*r**6*(380
            +90*logy*(-1+y)**5-1990*y+4205*y**2-5665*y**3+6165*y**4-4071*y**5
            +1024*y**6)+24*r**4*(-35+175*y-350*y**2+770*y**3-1770*y**4+2262*y**5
            -1355*y**6+303*y**7)))/(360*r**2*(-1+y)**5))

        res +=((r17*(505*r**8*(-1+y)**6+60*logy*(4+3*r**4)*(-1+y)**6-(-1+y)**4*(385
            -1010*y+745*y**2-355*y**4+198*y**5+5*y**6)-8*r**2*(-1+y)**2*(-115
            +460*y-690*y**2+570*y**3-265*y**4+38*y**5+8*y**6)+6*r**4*(-100+630*y
            -1665*y**2+2490*y**3-2250*y**4+1212*y**5-365*y**6+48*y**7)+4*r**6*(
            -110+660*y-1650*y**2+2700*y**3-2935*y**4+1878*y**5-663*y**6+100*y**7)))/(120*(
            -1+y)**6))

        res +=(-1/60*(r18*(-40*(-1+y)**6+485*r**10*(-1+y)**6+4*r**4*(-1+y)**3*(-70
            +210*y-210*y**2+560*y**3-775*y**4+299*y**5)-5*r**2*(-1+y)**4*(-23
            +46*y-23*y**2-112*y**3+157*y**4-50*y**5+y**6)+2*r**6*(-1+y)*(220
            +90*logy*(-1+y)**5-1190*y+2605*y**2-3505*y**3+3615*y**4-2301*y**5
            +568*y**6)+4*r**8*(-100+600*y-1500*y**2+2510*y**3-2705*y**4+1716*y**5
            -601*y**6+90*y**7)))/(r**2*(-1+y)**6))

    return res