from kolya import parameters
from kolya import NLOpartonic as nlo
import math

def moment_1_KIN_MS(elcut, par, hqe, wc, **kwargs):
    y=2*elcut/par.mbkin
    r=par.mcMS/par.mbkin
    mu0=par.scale_mcMS/par.mbkin
    muWC=par.scale_mbkin/par.mbkin
    api=par.alphas/math.pi

    rhoD=hqe.rhoD/par.mbkin**3
    rhoLS=hqe.rhoLS/par.mbkin**3
    muG=hqe.muG/par.mbkin**2

    mupi=hqe.mupi/par.mbkin**2

    logy =math.log((1-y)/r**2)

    res = 0
    if wc.ReVL != 0:
      resNP = 0
      resNP +=((api*(60*logy*r**4*(3+r**2)*(-1+y)**4+(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(0,'SM',y/2,r))/(1440*logy**2*r**8*(
          -1+y)**4+240*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1+y)**4
          -(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(
          -5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y
          -13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(0,'VL',y/2,r))/(2880*logy**2*r**8*(
          -1+y)**4+480*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2)-(2*api*(-1+y)**2*nlo.X1El(1,'SM',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          )
      resNP += ((api*(-1+y)**2*nlo.X1El(1,'VL',y/2,r))/(12*logy*r**4*(-1+y)**2-r**8*(
          -1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.ReVL

    if wc.ReVR != 0:
      resNP = 0
      resNP +=((-720*logy**2*r**7*(1+r**2+r**4)*(-1+y)**4-12*logy*r**3*(-1+y)**2*(18*r**10*(
          -1+y)**2+3*r**12*(-1+y)**2+15*r**4*(-1+y)**3*(9+y-3*y**2+y**3)
          +20*r**6*y*(6-9*y+2*y**2+y**3)+(-1+y)**4*(-3-6*y-9*y**2+8*y**3)
          -5*r**8*(-27+30*y+9*y**2-16*y**3+2*y**4)+2*r**2*(-1+y)**3*(9+9*y
          +9*y**2-11*y**3+4*y**4))-r*(-1+y)**2*(-1+r**2+y)**2*(1+r**12*(-1
          +y)**2-16*y**3+30*y**4-16*y**5+y**8+2*r**10*(63-109*y+38*y**2+3*y**3)
          +r**8*(27-20*y+34*y**2+24*y**3+15*y**4)+2*r**2*(-1+y)**2*(63+109*y
          +147*y**2-130*y**3+18*y**4+3*y**5)+4*r**6*(463-463*y-79*y**2+220*y**3
          -41*y**4+5*y**5)+r**4*(27-34*y+41*y**2-264*y**3+301*y**4-86*y**5
          +15*y**6)))/(1440*logy**2*r**8*(-1+y)**4+240*logy*r**4*(-1+y)**2*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))+10*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(17280*logy**3*r**11*(
          -1+r**2+3*r**4)*(-1+y)**6-288*logy**2*r**7*(-1+y)**4*(-46*r**12*(-1+y)**2
          -5*r**10*(17-34*y+17*y**2+2*y**3)+30*r**8*(-11+4*y+16*y**2-12*y**3
          +y**4)+10*(-1+y)**3*(5+5*y+5*y**2-12*y**3+4*y**4)-10*r**6*(-48
          +114*y-75*y**2+19*y**3-12*y**4+7*y**5)+3*r**2*(-1+y)**2*(7+60*y**3
          -45*y**4+8*y**5)-10*r**4*(-1-16*y+26*y**2-3*y**3-2*y**4-8*y**5+4*y**6))
          +24*logy*r**3*(-1+y)**2*(-1+r**2+y)**2*(3*r**16*(-1+y)**4-3*r**14*(-1
          +y)**2*(-47+96*y-51*y**2+8*y**3)-r**12*(-1+y)**2*(-2278+3740*y-1207*y**2
          -204*y**3+5*y**4)+3*(-1+y)**5*(3+9*y+18*y**2+4*y**3-5*y**4-17*y**5
          +8*y**6)-r**6*(-1+y)**2*(-1511+2404*y+1423*y**2-9220*y**3+6915*y**4
          -904*y**5-339*y**6+32*y**7)+r**2*(-1+y)**4*(-139-296*y-471*y**2+150*y**3
          +91*y**4+266*y**5-221*y**6+40*y**7)+r**4*(-1+y)**3*(2002+1098*y+821*y**2
          -5543*y**3+2932*y**4-120*y**5-191*y**6+41*y**7)+r**10*(703-3408*y
          +6959*y**2-6098*y**3+1285*y**4+930*y**5-431*y**6+80*y**7)+r**8*(3994
          -6914*y-1145*y**2+8730*y**3-5365*y**4+116*y**5+679*y**6-120*y**7
          +25*y**8))-2*r*(-1+y)**2*(-1+r**2+y)**3*(r**18*(-1+y)**4-r**16*(-1
          +y)**2*(233-427*y+173*y**2+y**3)-6*r**14*(485-1768*y+2347*y**2-1397*y**3
          +378*y**4-41*y**5+6*y**6)-(-1+y)**6*(-1-5*y-15*y**2-17*y**3-11*y**4
          +5*y**5+3*y**6+y**7)-2*r**12*(10745-33161*y+33819*y**2-8292*y**3
          -6305*y**4+3415*y**5-371*y**6+70*y**7)+r**10*(31960-91444*y+67560*y**2
          +9738*y**3-23354*y**4+3980*y**5+428*y**6+78*y**7-266*y**8)-3*r**2*(
          -1+y)**4*(-157-436*y-820*y**2-106*y**3+212*y**4+652*y**5-376*y**6
          +26*y**7+5*y**8)-2*r**4*(-1+y)**3*(593+1006*y+1524*y**2-1527*y**3
          -133*y**4-1280*y**5+1318*y**6-339*y**7+38*y**8)-2*r**6*(-1+y)**2*(
          -11527-1114*y+656*y**2+32337*y**3-25445*y**4+1422*y**5+3234*y**6
          -741*y**7+98*y**8)-6*r**8*(9660-20738*y+7976*y**2+12301*y**3-12124*y**4
          +1985*y**5+1148*y**6-141*y**7-116*y**8+49*y**9))))/(-25920*logy**3*r**12*(
          -1+y)**6+15*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -6480*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-540*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*muWC*(-138240*logy**3*r**11*(
          -1+r**4)*(-1+y)**6-4608*logy**2*r**7*(-1+y)**3*(12*r**12*(-1+y)**3+2*r**10*(
          -4+12*y-12*y**2-6*y**3+5*y**4)+r**2*(-1+y)**3*(8-25*y**3+2*y**5)
          -5*r**8*(8-6*y-21*y**2+38*y**3-18*y**4+2*y**5)-(-1+y)**3*(-12+15*y**3
          -10*y**4+2*y**5)+5*r**6*(24-72*y+72*y**2-27*y**3-y**4+2*y**5)+5*r**4*(
          -8+42*y-69*y**2+53*y**3-32*y**4+24*y**5-12*y**6+2*y**7))-192*logy*r**3*(
          -1+y)*(-1+r**2+y)**2*(3*r**16*(-1+y)**5-2*r**14*(-1+y)**2*(35-108*y
          +114*y**2-38*y**3+3*y**4)-r**12*(-1+y)**2*(1070-2780*y+2217*y**2
          -305*y**3-161*y**4+11*y**5)-(-1+y)**6*(-3-9*y-18*y**2+8*y**3+3*y**4
          -5*y**5+4*y**6)-r**4*(-1+y)**3*(1070-430*y-133*y**2-894*y**3+837*y**4
          -258*y**5+177*y**6-50*y**7+y**8)-2*r**6*(-1+y)**2*(101-476*y+78*y**2
          +1894*y**3-2180*y**4+684*y**5+56*y**6-38*y**7+y**8)+2*r**2*(-1+y)**4*(35
          +38*y+41*y**2-38*y**3-35*y**4-14*y**5+39*y**6-18*y**7+2*y**8)+2*r**10*(101
          -130*y-787*y**2+1338*y**3-195*y**4-594*y**5+309*y**6-62*y**7+10*y**8)
          +r**8*y*(-2534+8869*y-14685*y**2+14455*y**3-7685*y**4+1269*y**5+511*y**6
          -225*y**7+25*y**8))-32*r*(-1+y)*(-1+r**2+y)**3*(-((-1+y)**6*y**3*(9
          +8*y-2*y**2+4*y**3+y**4))+r**16*(-1+y)**2*(-88+246*y-219*y**2+53*y**3
          +y**4)+r**14*(-512+2386*y-4415*y**2+3813*y**3-1380*y**4+98*y**5+13*y**6
          +7*y**7)+r**12*(-5568+22782*y-34707*y**2+21666*y**3-1145*y**4-4636*y**5
          +1673*y**6-166*y**7+21*y**8)+r**2*(-1+y)**4*(88+158*y+219*y**2-433*y**3
          +61*y**4+11*y**5-57*y**6+19*y**7-7*y**8+y**9)+r**4*(-1+y)**3*(-512
          -338*y-329*y**2-651*y**3+1589*y**4-19*y**5-1175*y**6+489*y**7-81*y**8
          +7*y**9)+r**6*(-1+y)**2*(5568-5058*y-741*y**2-5973*y**3+9949*y**4
          -4943*y**5+663*y**6+81*y**7-107*y**8+21*y**9)+r**10*(11240-43342*y
          +56765*y**2-32751*y**3+8419*y**4+565*y**5-1987*y**6+717*y**7-141*y**8
          +35*y**9)+r**8*(-11240+35338*y-32753*y**2-11440*y**3+40520*y**4-23300*y**5
          +202*y**6+3628*y**7-920*y**8-70*y**9+35*y**10))))/(-77760*logy**3*r**12*(
          -1+y)**6+45*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -19440*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-1620*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((muG*(-8640*logy**3*r**9*(-6+7*r**2
          +9*r**4+3*r**6)*(-1+y)**6-144*logy**2*r**5*(-1+y)**3*(-186*r**14*(-1+y)**3
          +r**12*(-347+1041*y-1041*y**2+717*y**3-170*y**4)-4*(-1+y)**4*(-6
          -6*y-6*y**2-y**3+4*y**4)+2*r**10*(-757+2001*y-1596*y**2+612*y**3
          -145*y**4+35*y**5)+2*r**2*(-1+y)**3*(89-15*y**3-150*y**4+56*y**5)
          -10*r**8*(8+138*y-381*y**2+264*y**3-45*y**4-7*y**5+3*y**6)+r**4*(
          -1+y)**2*(-781+1861*y-540*y**2-1020*y**3+635*y**4-279*y**5+64*y**6)
          -10*r**6*(-269+933*y-1122*y**2+549*y**3-91*y**4-2*y**5+2*y**7))+12*logy*r*(
          -1+y)*(-1+r**2+y)**2*(21*r**18*(-1+y)**5-r**16*(-1+y)**2*(523-1611*y
          +1695*y**2-547*y**3+60*y**4)-r**14*(-1+y)**2*(7066-17822*y+13365*y**2
          -793*y**3-1367*y**4+71*y**5)+2*(-1+y)**6*(3+9*y+18*y**2+4*y**3
          -5*y**4-17*y**5+8*y**6)+r**2*(-1+y)**5*(-59-130*y-213*y**2-142*y**3
          -107*y**4-108*y**5+143*y**6+16*y**7)+r**6*(-1+y)**3*(1722-4112*y
          -1613*y**2+4864*y**3-10121*y**4+9092*y**5-2079*y**6+12*y**7+35*y**8)
          -r**8*(-1+y)**2*(15439-38547*y+18951*y**2+31065*y**3-35551*y**4+15715*y**5
          -4299*y**6+63*y**7+44*y**8)+r**4*(-1+y)**4*(431-15*y-155*y**2+201*y**3
          +755*y**4+1169*y**5-275*y**6-255*y**7+64*y**8)+r**12*(15741-64085*y
          +91243*y**2-58141*y**3+17849*y**4-2997*y**5+779*y**6-789*y**7+200*y**8)
          +r**10*(36614-159732*y+261333*y**2-211537*y**3+95213*y**4-19991*y**5
          -7345*y**6+7205*y**7-1935*y**8+175*y**9))+r*(-1+y)*(-1+r**2+y)**3*(7*r**18*(
          -1+y)**5+r**16*(-1+y)**2*(-1193+3348*y-3012*y**2+672*y**3+45*y**4)
          +2*r**14*(-3359+15331*y-27545*y**2+22436*y**3-7341*y**4+725*y**5-225*y**6
          +78*y**7)+2*r**12*(-35273+142582*y-213488*y**2+125359*y**3+6073*y**4
          -37452*y**5+12718*y**6-1509*y**7+190*y**8)-(-1+y)**5*(321+891*y
          +1674*y**2+480*y**3-144*y**4-974*y**5+374*y**6-176*y**7-49*y**8+3*y**9)
          +r**2*(-1+y)**4*(-1009-1835*y-2304*y**2+2162*y**3+4998*y**4+7616*y**5
          -4124*y**6+274*y**7+207*y**8+15*y**9)+2*r**4*(-1+y)**3*(-6689-2681*y
          -1574*y**2+3479*y**3-3046*y**4-1765*y**5+786*y**6+3393*y**7-741*y**8
          +78*y**9)+2*r**6*(-1+y)**2*(-13961+26391*y+3774*y**2-40113*y**3+55998*y**4
          -68371*y**5+29992*y**6+1679*y**7-1499*y**8+230*y**9)+2*r**10*(144212
          -554578*y+738686*y**2-403607*y**3+27670*y**4+79015*y**5-42684*y**6
          +7173*y**7-1008*y**8+321*y**9)+2*r**8*(-41204+159550*y-203822*y**2
          -21935*y**3+267155*y**4-197507*y**5+24595*y**6+17547*y**7-3755*y**8
          -975*y**9+351*y**10))))/(-103680*logy**3*r**12*(-1+y)**6+60*(r**8*(-1+y)**2
          -6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y
          -4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3-25920*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -2160*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2))
      resNP += ((api*muWC**2*(-25920*logy**3*r**11*(-1+r**2+3*r**4)*(
          -1+y)**6-144*logy**2*r**7*(-1+y)**2*(138*r**12*(-1+y)**4+10*(-1+y)**4*(15
          -3*y**3-10*y**4+4*y**5)+5*r**10*(51-204*y+306*y**2-150*y**3+7*y**4
          +14*y**5)+r**2*(-1+y)**4*(-63-60*y**3-275*y**4+88*y**5)-10*r**8*(-99
          +234*y-27*y**2-408*y**3+409*y**4-138*y**5+11*y**6)-10*r**6*(144-630*y
          +1053*y**2-825*y**3+227*y**4+50*y**5-34*y**6+3*y**7)+10*r**4*(-3-42*y
          +171*y**2-357*y**3+508*y**4-481*y**5+282*y**6-88*y**7+10*y**8))-12*logy*r**3*(
          -1+r**2+y)**2*(9*r**16*(-1+y)**6-3*r**14*(-1+y)**2*(-141+570*y-870*y**2
          +570*y**3-169*y**4+16*y**5)-r**12*(-1+y)**2*(-6834+24888*y-32895*y**2
          +17370*y**3-2114*y**4-770*y**5+43*y**6)-(-1+y)**5*(-27-27*y-27*y**2
          +303*y**3-209*y**4+23*y**5+143*y**6-227*y**7+88*y**8)+r**6*(-1+y)**2*(4533
          -16278*y+14688*y**2+16746*y**3-26670*y**4+4526*y**5+8264*y**6-4130*y**7
          +289*y**8+32*y**9)-r**2*(-1+y)**4*(417+54*y+54*y**2-228*y**3-1392*y**4
          +746*y**5+554*y**6-36*y**7-169*y**8+40*y**9)-r**4*(-1+y)**3*(-6006
          +8718*y-1881*y**2-3723*y**3+9079*y**4-10207*y**5+2801*y**6+1587*y**7
          -649*y**8+41*y**9)+r**10*(2109-14442*y+43434*y**2-59088*y**3+35648*y**4
          -4406*y**5-6218*y**6+3768*y**7-773*y**8+88*y**9)+r**8*(11982-44706*y
          +50031*y**2+36798*y**3-141426*y**4+131528*y**5-48882*y**6+1906*y**7
          +3764*y**8-1102*y**9+107*y**10))+r*(-1+r**2+y)**3*(3*r**18*(-1+y)**6
          +r**16*(-1+y)**2*(-699+2679*y-3780*y**2+2220*y**3-509*y**4+5*y**5)
          +(-1+y)**7*(-3-12*y-30*y**2+138*y**3+154*y**4+48*y**5+138*y**6
          +42*y**7+5*y**8)-2*r**14*(4365-24642*y+57312*y**2-68355*y**3+43765*y**4
          -14504*y**5+1968*y**6+13*y**7+18*y**8)-2*r**12*(32235-163953*y+332658*y**2
          -328737*y**3+140360*y**4+9895*y**5-30318*y**6+8793*y**7-527*y**8+74*y**9)
          -2*r**6*(-1+y)**2*(-34581+65820*y-25929*y**2+3645*y**3-7123*y**4-3115*y**5
          +8651*y**6+2967*y**7-3980*y**8+115*y**9+10*y**10)+2*r**4*(-1+y)**3*(
          -1779+540*y-315*y**2-14709*y**3+32287*y**4-20223*y**5-5763*y**6+8149*y**7
          -1140*y**8+51*y**9+22*y**10)+r**2*(-1+y)**4*(1413+1098*y+945*y**2
          -9930*y**3+5416*y**4-2206*y**5-2092*y**6+6338*y**7-2765*y**8+316*y**9
          +27*y**10)-2*r**10*(-47940+233046*y-423612*y**2+408927*y**3-222425*y**4
          +51399*y**5+6885*y**6-4655*y**7+1473*y**8-333*y**9+115*y**10)-2*r**8*(86940
          -360522*y+532008*y**2-192741*y**3-292376*y**4+307426*y**5-46632*y**6
          -65436*y**7+38588*y**8-7272*y**9-64*y**10+81*y**11))))/(-77760*logy**3*r**12*(
          -1+y)**6+45*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -19440*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-1620*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((mupi*(25920*logy**3*r**11*(1+r**2
          +r**4)*(-1+y)**6-144*logy**2*r**7*(-1+y)**2*(6*r**12*(-1+y)**4-2*(-1
          +y)**5*(-3-3*y-3*y**2-78*y**3+32*y**4)+r**10*(-159+636*y-954*y**2
          +606*y**3-299*y**4+50*y**5)-r**2*(-1+y)**4*(-159+240*y**3-275*y**4
          +64*y**5)-10*r**8*(51-150*y+117*y**2+54*y**3-73*y**4+18*y**5+y**6)
          +10*r**6*y*(-54+189*y-231*y**2+71*y**3+32*y**4-22*y**5+3*y**6)+10*r**4*(51
          -258*y+495*y**2-375*y**3+2*y**4+145*y**5-66*y**6+4*y**7+2*y**8))
          -12*logy*r**3*(-1+r**2+y)**2*(9*r**16*(-1+y)**6+3*r**14*(-1+y)**2*(-1
          -2*y+18*y**2-38*y**3-5*y**4+4*y**5)-r**12*(-1+y)**2*(414-1788*y
          +2913*y**2-2238*y**3+1250*y**4-262*y**5+23*y**6)+(-1+y)**5*(-9-9*y
          -9*y**2+93*y**3-23*y**4+41*y**5+41*y**6-149*y**7+64*y**8)+r**10*(
          -3321+17214*y-35550*y**2+33588*y**3-17252*y**4+9194*y**5-4618*y**6
          +684*y**7-91*y**8+32*y**9)+r**4*(-1+y)**3*(414-282*y-99*y**2-8289*y**3
          +19465*y**4-16777*y**5+5411*y**6+225*y**7-343*y**8+35*y**9)-r**6*(
          -1+y)**2*(3321-9354*y+8040*y**2-5046*y**3+22218*y**4-29842*y**5+15800*y**6
          -3002*y**7-179*y**8+44*y**9)+r**2*(-1+y)**4*(-3+18*y+18*y**2+720*y**3
          -1428*y**4+494*y**5-82*y**6+648*y**7-409*y**8+64*y**9)+r**8*(-11982
          +59910*y-118449*y**2+104526*y**3-33414*y**4+1312*y**5-4842*y**6+2642*y**7
          +652*y**8-398*y**9+43*y**10))-r*(-1+r**2+y)**3*(3*r**18*(-1+y)**6
          +r**16*(-1+y)**2*(357-1329*y+1800*y**2-1044*y**3+115*y**4+17*y**5)
          +(-1+y)**7*(-3-12*y-30*y**2+30*y**3+58*y**4+72*y**5+90*y**6+30*y**7
          +5*y**8)+2*r**14*(-1293+7254*y-16506*y**2+18987*y**3-12607*y**4+5636*y**5
          -1458*y**6+23*y**7+24*y**8)+2*r**12*(1173-6147*y+12276*y**2-9501*y**3
          -3494*y**4+11051*y**5-7536*y**6+2241*y**7-595*y**8+52*y**9)+r**2*(
          -1+y)**4*(357+258*y+213*y**2-2106*y**3-512*y**4-1606*y**5-1276*y**6
          +5426*y**7-2453*y**8+220*y**9+39*y**10)+2*r**4*(-1+y)**3*(1293-504*y
          -369*y**2-12777*y**3+18847*y**4-10575*y**5+1173*y**6-1835*y**7+2280*y**8
          -477*y**9+64*y**10)+2*r**10*(-19500+94446*y-177030*y**2+128169*y**3
          -24595*y**4-4275*y**5+8427*y**6-11569*y**7+3675*y**8-723*y**9+95*y**10)
          +2*r**6*(-1+y)**2*(1173-2064*y+27*y**2+27747*y**3-88409*y**4+92467*y**5
          -42287*y**6+525*y**7+5108*y**8-883*y**9+116*y**10)+2*r**8*(-19500+81054*y
          -123462*y**2+64863*y**3-19384*y**4+75494*y**5-94380*y**6+44880*y**7
          -11300*y**8+2172*y**9-566*y**10+129*y**11))))/(-103680*logy**3*r**12*(-1
          +y)**6+60*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -25920*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-2160*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((rhoLS*(8640*logy**3*r**9*(-2+7*r**2
          +9*r**4+3*r**6)*(-1+y)**6-144*logy**2*r**5*(-1+y)**2*(198*r**14*(-1+y)**4
          +4*(-1+y)**5*(-1-y-y**2-6*y**3+4*y**4)-10*r**2*(-1+y)**4*(-9+25*y**3
          -30*y**4+8*y**5)+5*r**12*(-79+316*y-474*y**2+406*y**3-171*y**4+26*y**5)
          -2*r**10*(747-2718*y+3537*y**2-2148*y**3+497*y**4-30*y**5+25*y**6)
          -r**4*(-1+y)**3*(-333+693*y-180*y**2-180*y**3+55*y**4-27*y**5+32*y**6)
          +10*r**8*(18-234*y+675*y**2-785*y**3+425*y**4-76*y**5-14*y**6+3*y**7)
          -10*r**6*(-175+826*y-1491*y**2+1311*y**3-536*y**4+21*y**5+60*y**6
          -18*y**7+2*y**8))-12*logy*r*(-1+r**2+y)**2*(9*r**18*(-1+y)**6-r**16*(
          -1+y)**2*(-647+2606*y-3954*y**2+2570*y**3-731*y**4+84*y**5)+2*(
          -1+y)**7*(3+9*y+18*y**2+4*y**3-5*y**4-17*y**5+8*y**6)-r**14*(-1
          +y)**2*(-7258+25592*y-32191*y**2+14742*y**3-14*y**4-1214*y**5+31*y**6)
          -r**2*(-1+y)**5*(49+37*y+25*y**2-149*y**3-13*y**4-17*y**5+235*y**6
          -143*y**7+16*y**8)-r**8*(-1+y)**2*(-9667+33338*y-32458*y**2-6474*y**3
          +21696*y**4-11866*y**5+5262*y**6-1594*y**7-25*y**8+28*y**9)+r**4*(
          -1+y)**4*(-787+182*y+116*y**2+892*y**3-42*y**4-878*y**5+148*y**6
          +604*y**7-307*y**8+32*y**9)+r**6*(-1+y)**3*(4566-5430*y+873*y**2
          -7353*y**3+19313*y**4-18157*y**5+7167*y**6-623*y**7-279*y**8+43*y**9)
          +r**12*(-18153+93114*y-184968*y**2+186392*y**3-96694*y**4+17414*y**5
          +3824*y**6+168*y**7-1185*y**8+208*y**9)+r**10*(-30838+164946*y-352653*y**2
          +396430*y**3-241970*y**4+55148*y**5+25266*y**6-22350*y**7+7352*y**8
          -1438*y**9+107*y**10))-r*(-1+r**2+y)**3*(3*r**18*(-1+y)**6-r**16*(
          -1+y)**2*(-877+3409*y-4920*y**2+2908*y**3-615*y**4+11*y**5)-2*r**14*(
          -5483+30282*y-68364*y**2+77881*y**3-46079*y**4+13374*y**5-1574*y**6
          +15*y**7+8*y**8)+r**2*(-1+y)**5*(-1333-1655*y-1440*y**2+2042*y**3
          +2082*y**4+2524*y**5-3388*y**6+898*y**7+7*y**8+23*y**9)+2*r**12*(28269
          -139899*y+274422*y**2-252739*y**3+80584*y**4+38205*y**5-36634*y**6
          +8815*y**7-637*y**8+94*y**9)+(-1+y)**5*(165+258*y+315*y**2-1018*y**3
          -268*y**4-358*y**5+1184*y**6-598*y**7+55*y**8+20*y**9+5*y**10)+2*r**4*(
          -1+y)**3*(10405-6216*y-2535*y**2-10449*y**3+9587*y**4+4557*y**5-711*y**6
          -7843*y**7+4800*y**8-817*y**9+62*y**10)+2*r**6*(-1+y)**2*(-5283+7680*y
          -7539*y**2+33587*y**3-80197*y**4+114749*y**5-73465*y**6+9701*y**7+7072*y**8
          -2317*y**9+212*y**10)+2*r**10*(-135892+651342*y-1186944*y**2+1050969*y**3
          -392351*y**4-63249*y**5+104289*y**6-24953*y**7+291*y**8-797*y**9+295*y**10)
          +2*r**8*(43364-201546*y+341268*y**2-188643*y**3-81280*y**4+82470*y**5
          +55584*y**6-75116*y**7+25660*y**8+172*y**9-2292*y**10+359*y**11))))/(
          -103680*logy**3*r**12*(-1+y)**6+60*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)
          -2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(
          -1-y-y**2+y**3))**3-25920*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-2160*logy*r**4*(-1+y)**2*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*muWC**3*(
          -17280*logy**3*r**12*(24+58*r**2+25*r**4+27*r**6+9*r**8)*(-1+y)**7-288*logy**2*r**8*(
          -1+y)**2*(366*r**16*(-1+y)**5+24*(-1+y)**7*(-3-6*y-9*y**2+8*y**3)
          +4*r**2*(-1+y)**6*(79+79*y+79*y**2-136*y**3+84*y**4)+10*r**4*(-1
          +y)**5*(-723+432*y+216*y**2-89*y**3-22*y**4+24*y**5)+5*r**14*(-169
          +845*y-1690*y**2+1480*y**3-671*y**4+91*y**5+18*y**6)-6*r**12*(-169
          +1115*y-2905*y**2+4175*y**3-3035*y**4+1139*y**5-215*y**6+15*y**7)
          +3*r**6*(-1+y)**3*(-1087+5654*y-6307*y**2+360*y**3+2665*y**4-1278*y**5
          +121*y**6+32*y**7)-2*r**10*(2406-9600*y+13125*y**2-3860*y**3-6450*y**4
          +6789*y**5-2350*y**6+135*y**7+45*y**8)+10*r**8*(-587+2485*y-3845*y**2
          +2566*y**3-495*y**4-147*y**5-53*y**6+110*y**7-40*y**8+6*y**9))+24*logy*r**6*(27*r**22*(
          -1+y)**7+r**20*(-1+y)**2*(1129-5645*y+11290*y**2-10948*y**3+5987*y**4
          -1759*y**5+234*y**6)-6*(-1+y)**9*(-5-10*y-15*y**2-26*y**3+19*y**4
          +24*y**5-51*y**6+24*y**7)+r**18*(-1+y)**2*(19245-87441*y+152922*y**2
          -122680*y**3+39117*y**4+4035*y**5-4340*y**6+390*y**7)-r**2*(-1+y)**8*(
          -4613-2885*y-2021*y**2+22837*y**3-16615*y**4+233*y**5+2665*y**6-489*y**7
          +48*y**8)+r**4*(-1+y)**7*(-1353+7584*y+3792*y**2-8330*y**3-10690*y**4
          +13452*y**5-5572*y**6+1918*y**7-777*y**8+96*y**9)-2*r**16*(17103-129861*y
          +425073*y**2-806503*y**3+944321*y**4-681004*y**5+290980*y**6-64001*y**7
          +2488*y**8+1137*y**9+27*y**10)-2*r**10*(-1+y)**3*(-121017+554508*y
          -945642*y**2+700840*y**3-129344*y**4-137465*y**5+83063*y**6-9712*y**7
          +821*y**8-1455*y**9+123*y**10)+2*r**8*(-1+y)**4*(-48450+106218*y+15120*y**2
          -201438*y**3+190078*y**4-35451*y**5-42463*y**6+21086*y**7-660*y**8
          -815*y**9+135*y**10)+r**6*(-1+y)**5*(-121581+416682*y-433701*y**2
          -28484*y**3+364518*y**4-238002*y**5+26140*y**6+15732*y**7+1359*y**8
          -2504*y**9+321*y**10)-2*r**12*(-1+y)**2*(-130887+596691*y-1078182*y**2
          +1001606*y**3-464394*y**4+54813*y**5+22709*y**6-5658*y**7+5949*y**8
          -3256*y**9+369*y**10)-2*r**14*(18249-115575*y+294417*y**2-362085*y**3
          +129044*y**4+202909*y**5-286952*y**6+162843*y**7-53305*y**8+12686*y**9
          -2573*y**10+342*y**11))-2*r**6*(-1+r**2+y)**2*(3*r**20*(-1+y)**7+2*r**18*(
          -1+y)**2*(311-1390*y+2366*y**2-2084*y**3+673*y**4-50*y**5+6*y**6)
          +r**16*(-37713+249853*y-700114*y**2+1061204*y**3-953616*y**4+527326*y**5
          -176450*y**6+32672*y**7-2763*y**8+81*y**9)-3*(-1+y)**7*(-687-1254*y
          -1761*y**2-98*y**3+2092*y**4+1834*y**5-4736*y**6+2010*y**7-149*y**8
          +20*y**9+9*y**10)+4*r**14*(-38353+222752*y-523939*y**2+614955*y**3
          -320455*y**4-44902*y**5+156399*y**6-84505*y**7+18296*y**8-1304*y**9
          +96*y**10)-2*r**2*(-1+y)**5*(44473-29379*y-10176*y**2-186400*y**3
          +348112*y**4-174258*y**5-13384*y**6+21406*y**7+1863*y**8-2171*y**9
          +304*y**10+90*y**11)-4*r**6*(-1+y)**3*(372817-1224241*y+1322787*y**2
          -194670*y**3-615582*y**4+434535*y**5-52857*y**6-31812*y**7-5973*y**8
          +5756*y**9+64*y**10+96*y**11)+2*r**8*(-1+y)**2*(-696401+2439555*y
          -2821881*y**2+535559*y**3+1381984*y**4-946998*y**5-88114*y**6+189736*y**7
          +6789*y**8-16073*y**9-617*y**10+141*y**11)+2*r**12*(234497-1496351*y
          +3987231*y**2-6046395*y**3+5404620*y**4-2586786*y**5+379146*y**6+210864*y**7
          -121365*y**8+24385*y**9-2041*y**10+435*y**11)-r**4*(-1+y)**4*(216063
          -263965*y-14439*y**2-362759*y**3+948506*y**4-494010*y**5-140870*y**6
          +147614*y**7-27177*y**8-233*y**9+909*y**10+441*y**11)+4*r**10*(-61944
          +422746*y-1214503*y**2+2003675*y**3-2123998*y**4+1394189*y**5-410440*y**6
          -65497*y**7+59744*y**8-2503*y**9-821*y**10-882*y**11+234*y**12))))/(
          -699840*logy**3*r**17*(-1+y)**7+405*r**5*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2
          -3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)
          -(-1+y)**3*(-1-y-y**2+y**3))**3-174960*logy**2*r**13*(-1+y)**5*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-14580*logy*r**9*(
          -1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((rhoD*(8640*logy**3*r**12*(24+58*r**2+25*r**4+27*r**6+9*r**8)*(-1+y)**7
          +144*logy**2*r**8*(-1+y)**2*(366*r**16*(-1+y)**5+24*(-1+y)**7*(-3-6*y
          -9*y**2+8*y**3)+4*r**2*(-1+y)**6*(79+79*y+79*y**2-136*y**3+84*y**4)
          +10*r**4*(-1+y)**5*(-723+432*y+216*y**2-89*y**3-22*y**4+24*y**5)
          +5*r**14*(-169+845*y-1690*y**2+1480*y**3-671*y**4+91*y**5+18*y**6)
          -6*r**12*(-169+1115*y-2905*y**2+4175*y**3-3035*y**4+1139*y**5-215*y**6
          +15*y**7)+3*r**6*(-1+y)**3*(-1087+5654*y-6307*y**2+360*y**3+2665*y**4
          -1278*y**5+121*y**6+32*y**7)-2*r**10*(2406-9600*y+13125*y**2-3860*y**3
          -6450*y**4+6789*y**5-2350*y**6+135*y**7+45*y**8)+10*r**8*(-587+2485*y
          -3845*y**2+2566*y**3-495*y**4-147*y**5-53*y**6+110*y**7-40*y**8+6*y**9))
          -12*logy*r**6*(27*r**22*(-1+y)**7+r**20*(-1+y)**2*(1129-5645*y+11290*y**2
          -10948*y**3+5987*y**4-1759*y**5+234*y**6)-6*(-1+y)**9*(-5-10*y-15*y**2
          -26*y**3+19*y**4+24*y**5-51*y**6+24*y**7)+r**18*(-1+y)**2*(19245-87441*y
          +152922*y**2-122680*y**3+39117*y**4+4035*y**5-4340*y**6+390*y**7)-r**2*(
          -1+y)**8*(-4613-2885*y-2021*y**2+22837*y**3-16615*y**4+233*y**5+2665*y**6
          -489*y**7+48*y**8)+r**4*(-1+y)**7*(-1353+7584*y+3792*y**2-8330*y**3
          -10690*y**4+13452*y**5-5572*y**6+1918*y**7-777*y**8+96*y**9)-2*r**16*(17103
          -129861*y+425073*y**2-806503*y**3+944321*y**4-681004*y**5+290980*y**6
          -64001*y**7+2488*y**8+1137*y**9+27*y**10)-2*r**10*(-1+y)**3*(-121017
          +554508*y-945642*y**2+700840*y**3-129344*y**4-137465*y**5+83063*y**6
          -9712*y**7+821*y**8-1455*y**9+123*y**10)+2*r**8*(-1+y)**4*(-48450+106218*y
          +15120*y**2-201438*y**3+190078*y**4-35451*y**5-42463*y**6+21086*y**7
          -660*y**8-815*y**9+135*y**10)+r**6*(-1+y)**5*(-121581+416682*y-433701*y**2
          -28484*y**3+364518*y**4-238002*y**5+26140*y**6+15732*y**7+1359*y**8
          -2504*y**9+321*y**10)-2*r**12*(-1+y)**2*(-130887+596691*y-1078182*y**2
          +1001606*y**3-464394*y**4+54813*y**5+22709*y**6-5658*y**7+5949*y**8
          -3256*y**9+369*y**10)-2*r**14*(18249-115575*y+294417*y**2-362085*y**3
          +129044*y**4+202909*y**5-286952*y**6+162843*y**7-53305*y**8+12686*y**9
          -2573*y**10+342*y**11))+r**6*(-1+r**2+y)**2*(3*r**20*(-1+y)**7+2*r**18*(
          -1+y)**2*(311-1390*y+2366*y**2-2084*y**3+673*y**4-50*y**5+6*y**6)
          +r**16*(-37713+249853*y-700114*y**2+1061204*y**3-953616*y**4+527326*y**5
          -176450*y**6+32672*y**7-2763*y**8+81*y**9)-3*(-1+y)**7*(-687-1254*y
          -1761*y**2-98*y**3+2092*y**4+1834*y**5-4736*y**6+2010*y**7-149*y**8
          +20*y**9+9*y**10)+4*r**14*(-38353+222752*y-523939*y**2+614955*y**3
          -320455*y**4-44902*y**5+156399*y**6-84505*y**7+18296*y**8-1304*y**9
          +96*y**10)-2*r**2*(-1+y)**5*(44473-29379*y-10176*y**2-186400*y**3
          +348112*y**4-174258*y**5-13384*y**6+21406*y**7+1863*y**8-2171*y**9
          +304*y**10+90*y**11)-4*r**6*(-1+y)**3*(372817-1224241*y+1322787*y**2
          -194670*y**3-615582*y**4+434535*y**5-52857*y**6-31812*y**7-5973*y**8
          +5756*y**9+64*y**10+96*y**11)+2*r**8*(-1+y)**2*(-696401+2439555*y
          -2821881*y**2+535559*y**3+1381984*y**4-946998*y**5-88114*y**6+189736*y**7
          +6789*y**8-16073*y**9-617*y**10+141*y**11)+2*r**12*(234497-1496351*y
          +3987231*y**2-6046395*y**3+5404620*y**4-2586786*y**5+379146*y**6+210864*y**7
          -121365*y**8+24385*y**9-2041*y**10+435*y**11)-r**4*(-1+y)**4*(216063
          -263965*y-14439*y**2-362759*y**3+948506*y**4-494010*y**5-140870*y**6
          +147614*y**7-27177*y**8-233*y**9+909*y**10+441*y**11)+4*r**10*(-61944
          +422746*y-1214503*y**2+2003675*y**3-2123998*y**4+1394189*y**5-410440*y**6
          -65497*y**7+59744*y**8-2503*y**9-821*y**10-882*y**11+234*y**12))))/(
          -311040*logy**3*r**17*(-1+y)**7+180*r**5*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2
          -3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)
          -(-1+y)**3*(-1-y-y**2+y**3))**3-77760*logy**2*r**13*(-1+y)**5*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-6480*logy*r**9*(
          -1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(8640*logy**3*r**11*(-1+r**2+3*r**4)*(-1+y)**6-144*logy**2*r**7*(
          -1+y)**4*(-46*r**12*(-1+y)**2-5*r**10*(17-34*y+17*y**2+2*y**3)+30*r**8*(
          -11+4*y+16*y**2-12*y**3+y**4)+10*(-1+y)**3*(5+5*y+5*y**2-12*y**3
          +4*y**4)-10*r**6*(-48+114*y-75*y**2+19*y**3-12*y**4+7*y**5)+3*r**2*(
          -1+y)**2*(7+60*y**3-45*y**4+8*y**5)-10*r**4*(-1-16*y+26*y**2-3*y**3
          -2*y**4-8*y**5+4*y**6))+12*logy*r**3*(-1+y)**2*(-1+r**2+y)**2*(3*r**16*(
          -1+y)**4-3*r**14*(-1+y)**2*(-47+96*y-51*y**2+8*y**3)-r**12*(-1+y)**2*(
          -2278+3740*y-1207*y**2-204*y**3+5*y**4)+3*(-1+y)**5*(3+9*y+18*y**2
          +4*y**3-5*y**4-17*y**5+8*y**6)-r**6*(-1+y)**2*(-1511+2404*y+1423*y**2
          -9220*y**3+6915*y**4-904*y**5-339*y**6+32*y**7)+r**2*(-1+y)**4*(-139
          -296*y-471*y**2+150*y**3+91*y**4+266*y**5-221*y**6+40*y**7)+r**4*(
          -1+y)**3*(2002+1098*y+821*y**2-5543*y**3+2932*y**4-120*y**5-191*y**6
          +41*y**7)+r**10*(703-3408*y+6959*y**2-6098*y**3+1285*y**4+930*y**5
          -431*y**6+80*y**7)+r**8*(3994-6914*y-1145*y**2+8730*y**3-5365*y**4
          +116*y**5+679*y**6-120*y**7+25*y**8))-r*(-1+y)**2*(-1+r**2+y)**3*(r**18*(
          -1+y)**4-r**16*(-1+y)**2*(233-427*y+173*y**2+y**3)-6*r**14*(485
          -1768*y+2347*y**2-1397*y**3+378*y**4-41*y**5+6*y**6)-(-1+y)**6*(
          -1-5*y-15*y**2-17*y**3-11*y**4+5*y**5+3*y**6+y**7)-2*r**12*(10745
          -33161*y+33819*y**2-8292*y**3-6305*y**4+3415*y**5-371*y**6+70*y**7)
          +r**10*(31960-91444*y+67560*y**2+9738*y**3-23354*y**4+3980*y**5+428*y**6
          +78*y**7-266*y**8)-3*r**2*(-1+y)**4*(-157-436*y-820*y**2-106*y**3
          +212*y**4+652*y**5-376*y**6+26*y**7+5*y**8)-2*r**4*(-1+y)**3*(593
          +1006*y+1524*y**2-1527*y**3-133*y**4-1280*y**5+1318*y**6-339*y**7
          +38*y**8)-2*r**6*(-1+y)**2*(-11527-1114*y+656*y**2+32337*y**3-25445*y**4
          +1422*y**5+3234*y**6-741*y**7+98*y**8)-6*r**8*(9660-20738*y+7976*y**2
          +12301*y**3-12124*y**4+1985*y**5+1148*y**6-141*y**7-116*y**8+49*y**9)))*math.log(mu0**2/r**2))/(
          -17280*logy**3*r**12*(-1+y)**6+10*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)
          -2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(
          -1-y-y**2+y**3))**3-4320*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-360*logy*r**4*(-1+y)**2*(-(r**8*(-1
          +y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-720*logy**2*r**7*(4
          +5*r**2+2*r**4)*(-1+y)**6-24*logy*r**3*(-1+y)**4*(8*r**10*(-1+y)**2
          +3*r**12*(-1+y)**2-5*r**8*(-44+64*y-8*y**2-13*y**3+2*y**4)+2*(-1
          +y)**3*(-1-y-y**2-6*y**3+4*y**4)+5*r**6*(26+8*y-64*y**2+21*y**3
          +7*y**4)+r**2*(-1+y)**2*(-58+35*y**3-15*y**4+8*y**5)+5*r**4*(-61+170*y
          -133*y**2+y**3+31*y**4-11*y**5+3*y**6))-r*(-1+y)**3*(-1+r**2+y)**2*(7*r**12*(
          -1+y)**3+2*r**10*(-81+214*y-174*y**2+35*y**3+6*y**4)+r**8*(-169
          +509*y-558*y**2+220*y**3+3*y**4-5*y**5)-4*r**6*(1431-2992*y+1413*y**2
          +518*y**3-447*y**4+47*y**5)+(-1+y)**3*(-13-26*y-39*y**2-54*y**3
          -9*y**4+4*y**5+17*y**6)+2*r**2*(-1+y)**2*(-61-72*y-71*y**2+319*y**3
          -256*y**4+55*y**5+26*y**6)+r**4*(-1749+2827*y-705*y**2+335*y**3-1195*y**4
          +489*y**5-47*y**6+45*y**7)))*nlo.X1El(0,'SM',y/2,r))/(-17280*logy**3*r**12*(
          -1+y)**6+10*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -4320*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-360*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1
          +y)**4-(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1
          +y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(0,'VR',y/2,r))/(2880*logy**2*r**8*(-1+y)**4+480*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(-24*logy*r**3*(1+r**2)*(-1+y)**4-4*r*(-1+y)**3*(r**6*(-1+y)
          +3*r**2*(-1+y)**2*(3+y)+3*r**4*(-3+y+y**2)+(-1+y)**2*(1+y+y**2)))*nlo.X1El(1,'SM',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(1,'VR',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.ReVR

    if wc.SL2 != 0:
      resNP = 0
      resNP +=((rhoD*(360*logy**2*r**4*(3+5*r**2+6*r**4)*(-1+y)**4+6*logy*(-1+y)**2*(89*r**10*(
          -1+y)**2+28*r**12*(-1+y)**2+3*(-1+y)**4*(-3-6*y-9*y**2+8*y**3)
          -10*r**4*(-1+y)**2*(53-36*y-18*y**2+10*y**3)+5*r**8*(163-182*y-53*y**2
          +80*y**3)+r**2*(-1+y)**3*(23+23*y+23*y**2-77*y**3+48*y**4)-10*r**6*(37
          -134*y+127*y**2-10*y**3-22*y**4+2*y**5))-(-1+y)**2*(-1+r**2+y)**2*(5*r**12*(
          -1+y)**2+r**10*(-57+104*y-37*y**2)+r**8*(-272+480*y-213*y**2+28*y**3
          -23*y**4)-2*r**6*(226-341*y+124*y**2+122*y**3-52*y**4+11*y**5)+r**4*(
          -4377+3844*y+1015*y**2-666*y**3-667*y**4+14*y**5-3*y**6)-3*(-1
          +y)**2*(60+102*y+135*y**2-168*y**3+24*y**4+6*y**5+y**6)-r**2*(-293
          +114*y+129*y**2-234*y**3+541*y**4-306*y**5+47*y**6+2*y**7))))/(25920*logy**2*r**8*(
          -1+y)**4+4320*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+180*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*muWC**3*(-720*logy**2*r**4*(3+5*r**2
          +6*r**4)*(-1+y)**4-12*logy*(-1+y)**2*(89*r**10*(-1+y)**2+28*r**12*(
          -1+y)**2+3*(-1+y)**4*(-3-6*y-9*y**2+8*y**3)-10*r**4*(-1+y)**2*(53
          -36*y-18*y**2+10*y**3)+5*r**8*(163-182*y-53*y**2+80*y**3)+r**2*(
          -1+y)**3*(23+23*y+23*y**2-77*y**3+48*y**4)-10*r**6*(37-134*y+127*y**2
          -10*y**3-22*y**4+2*y**5))+2*(-1+y)**2*(-1+r**2+y)**2*(5*r**12*(-1
          +y)**2+r**10*(-57+104*y-37*y**2)+r**8*(-272+480*y-213*y**2+28*y**3
          -23*y**4)-2*r**6*(226-341*y+124*y**2+122*y**3-52*y**4+11*y**5)+r**4*(
          -4377+3844*y+1015*y**2-666*y**3-667*y**4+14*y**5-3*y**6)-3*(-1
          +y)**2*(60+102*y+135*y**2-168*y**3+24*y**4+6*y**5+y**6)-r**2*(-293
          +114*y+129*y**2-234*y**3+541*y**4-306*y**5+47*y**6+2*y**7))))/(58320*logy**2*r**8*(
          -1+y)**4+9720*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+405*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((muG*(-360*logy**2*r**6*(1+3*r**2)*(
          -1+y)**4+6*logy*(-1+y)**2*(-85*r**10*(-1+y)**2-11*r**12*(-1+y)**2
          -10*r**6*(-1+y)**2*(-29+12*y+6*y**2+2*y**3)-10*r**8*(25-14*y-29*y**2
          +20*y**3)+5*r**4*(-1+y)**2*(17-8*y**3+3*y**4)+r**2*(-1+y)**3*(29+29*y
          +29*y**2-71*y**3+24*y**4))+(-1+y)**2*(-1+r**2+y)**2*(r**12*(-1+y)**2
          +r**10*(-9+16*y-5*y**2)-2*r**8*(113-201*y+78*y**2-10*y**3+5*y**4)
          -6*(-3+20*y**3-25*y**4+8*y**5)-2*r**6*(128-169*y+59*y**2+97*y**3
          -35*y**4+10*y**5)+r**4*(-1281+824*y+449*y**2+54*y**3-401*y**4+70*y**5
          -15*y**6)-r**2*(-313+138*y+51*y**2+840*y**3-1075*y**4+378*y**5-23*y**6
          +4*y**7))))/(8640*logy**2*r**8*(-1+y)**4+1440*logy*r**4*(-1+y)**2*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))+60*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((rhoLS*(
          -360*logy**2*r**6*(1+r**2)*(-1+y)**4+6*logy*r**2*(-1+y)*(17*r**10*(-1
          +y)**3-(-1+y)**5*(-3-6*y-9*y**2+8*y**3)+5*r**8*(17-51*y+51*y**2
          -21*y**3+2*y**4)-10*r**6*(-9+15*y+3*y**2-11*y**3+3*y**4)-5*r**2*(
          -1+y)**3*(-5-4*y**3+3*y**4)+10*r**4*(-13+51*y-69*y**2+39*y**3-9*y**4
          +y**5))-(-1+r**2+y)**2*(2*r**12*(-1+y)**4-(-1+y)**3*(1+y+y**2
          -29*y**3+16*y**4)+r**10*(-33+128*y-182*y**2+112*y**3-28*y**4+3*y**5)
          +r**8*(-37+108*y-107*y**2+28*y**3+20*y**4-9*y**5-3*y**6)+r**2*(-1
          +y)**2*(61-16*y-7*y**2-120*y**3+222*y**4-112*y**5+12*y**6)+r**6*(588
          -1910*y+2030*y**2-840*y**3+92*y**4-9*y**5+46*y**6-7*y**7)+r**4*(138
          -338*y+260*y**2-100*y**3-158*y**4+399*y**5-245*y**6+47*y**7-3*y**8))))/(2880*logy**2*r**8*(
          -1+y)**4+480*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1+y)**4
          -(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(
          -5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y
          -13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(0,'SL2',y/2,r))/(2880*logy**2*r**8*(
          -1+y)**4+480*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(60*logy*r**4*(3+r**2)*(-1+y)**4
          +(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(
          -5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y
          -13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(0,'SM',y/2,r))/(11520*logy**2*r**8*(
          -1+y)**4+1920*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+80*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(1,'SL2',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -(api*(-1+y)**2*nlo.X1El(1,'SM',y/2,r))/(48*logy*r**4*(-1+y)**2+4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))))
      res += resNP*wc.SL2

    if wc.SR2 != 0:
      resNP = 0
      resNP +=((rhoD*(360*logy**2*r**4*(3+5*r**2+6*r**4)*(-1+y)**4+6*logy*(-1+y)**2*(89*r**10*(
          -1+y)**2+28*r**12*(-1+y)**2+3*(-1+y)**4*(-3-6*y-9*y**2+8*y**3)
          -10*r**4*(-1+y)**2*(53-36*y-18*y**2+10*y**3)+5*r**8*(163-182*y-53*y**2
          +80*y**3)+r**2*(-1+y)**3*(23+23*y+23*y**2-77*y**3+48*y**4)-10*r**6*(37
          -134*y+127*y**2-10*y**3-22*y**4+2*y**5))-(-1+y)**2*(-1+r**2+y)**2*(5*r**12*(
          -1+y)**2+r**10*(-57+104*y-37*y**2)+r**8*(-272+480*y-213*y**2+28*y**3
          -23*y**4)-2*r**6*(226-341*y+124*y**2+122*y**3-52*y**4+11*y**5)+r**4*(
          -4377+3844*y+1015*y**2-666*y**3-667*y**4+14*y**5-3*y**6)-3*(-1
          +y)**2*(60+102*y+135*y**2-168*y**3+24*y**4+6*y**5+y**6)-r**2*(-293
          +114*y+129*y**2-234*y**3+541*y**4-306*y**5+47*y**6+2*y**7))))/(25920*logy**2*r**8*(
          -1+y)**4+4320*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+180*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*muWC**3*(-720*logy**2*r**4*(3+5*r**2
          +6*r**4)*(-1+y)**4-12*logy*(-1+y)**2*(89*r**10*(-1+y)**2+28*r**12*(
          -1+y)**2+3*(-1+y)**4*(-3-6*y-9*y**2+8*y**3)-10*r**4*(-1+y)**2*(53
          -36*y-18*y**2+10*y**3)+5*r**8*(163-182*y-53*y**2+80*y**3)+r**2*(
          -1+y)**3*(23+23*y+23*y**2-77*y**3+48*y**4)-10*r**6*(37-134*y+127*y**2
          -10*y**3-22*y**4+2*y**5))+2*(-1+y)**2*(-1+r**2+y)**2*(5*r**12*(-1
          +y)**2+r**10*(-57+104*y-37*y**2)+r**8*(-272+480*y-213*y**2+28*y**3
          -23*y**4)-2*r**6*(226-341*y+124*y**2+122*y**3-52*y**4+11*y**5)+r**4*(
          -4377+3844*y+1015*y**2-666*y**3-667*y**4+14*y**5-3*y**6)-3*(-1
          +y)**2*(60+102*y+135*y**2-168*y**3+24*y**4+6*y**5+y**6)-r**2*(-293
          +114*y+129*y**2-234*y**3+541*y**4-306*y**5+47*y**6+2*y**7))))/(58320*logy**2*r**8*(
          -1+y)**4+9720*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+405*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((muG*(-360*logy**2*r**6*(1+3*r**2)*(
          -1+y)**4+6*logy*(-1+y)**2*(-85*r**10*(-1+y)**2-11*r**12*(-1+y)**2
          -10*r**6*(-1+y)**2*(-29+12*y+6*y**2+2*y**3)-10*r**8*(25-14*y-29*y**2
          +20*y**3)+5*r**4*(-1+y)**2*(17-8*y**3+3*y**4)+r**2*(-1+y)**3*(29+29*y
          +29*y**2-71*y**3+24*y**4))+(-1+y)**2*(-1+r**2+y)**2*(r**12*(-1+y)**2
          +r**10*(-9+16*y-5*y**2)-2*r**8*(113-201*y+78*y**2-10*y**3+5*y**4)
          -6*(-3+20*y**3-25*y**4+8*y**5)-2*r**6*(128-169*y+59*y**2+97*y**3
          -35*y**4+10*y**5)+r**4*(-1281+824*y+449*y**2+54*y**3-401*y**4+70*y**5
          -15*y**6)-r**2*(-313+138*y+51*y**2+840*y**3-1075*y**4+378*y**5-23*y**6
          +4*y**7))))/(8640*logy**2*r**8*(-1+y)**4+1440*logy*r**4*(-1+y)**2*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))+60*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((rhoLS*(
          -360*logy**2*r**6*(1+r**2)*(-1+y)**4+6*logy*r**2*(-1+y)*(17*r**10*(-1
          +y)**3-(-1+y)**5*(-3-6*y-9*y**2+8*y**3)+5*r**8*(17-51*y+51*y**2
          -21*y**3+2*y**4)-10*r**6*(-9+15*y+3*y**2-11*y**3+3*y**4)-5*r**2*(
          -1+y)**3*(-5-4*y**3+3*y**4)+10*r**4*(-13+51*y-69*y**2+39*y**3-9*y**4
          +y**5))-(-1+r**2+y)**2*(2*r**12*(-1+y)**4-(-1+y)**3*(1+y+y**2
          -29*y**3+16*y**4)+r**10*(-33+128*y-182*y**2+112*y**3-28*y**4+3*y**5)
          +r**8*(-37+108*y-107*y**2+28*y**3+20*y**4-9*y**5-3*y**6)+r**2*(-1
          +y)**2*(61-16*y-7*y**2-120*y**3+222*y**4-112*y**5+12*y**6)+r**6*(588
          -1910*y+2030*y**2-840*y**3+92*y**4-9*y**5+46*y**6-7*y**7)+r**4*(138
          -338*y+260*y**2-100*y**3-158*y**4+399*y**5-245*y**6+47*y**7-3*y**8))))/(2880*logy**2*r**8*(
          -1+y)**4+480*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(60*logy*r**4*(3+r**2)*(-1+y)**4
          +(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(
          -5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y
          -13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(0,'SM',y/2,r))/(11520*logy**2*r**8*(
          -1+y)**4+1920*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+80*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1+y)**4
          -(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(
          -5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y
          -13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(0,'SR2',y/2,r))/(2880*logy**2*r**8*(
          -1+y)**4+480*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2)-(api*(-1+y)**2*nlo.X1El(1,'SM',y/2,r))/(48*logy*r**4*(
          -1+y)**2+4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
          )
      resNP += ((api*(-1+y)**2*nlo.X1El(1,'SR2',y/2,r))/(12*logy*r**4*(-1+y)**2-r**8*(
          -1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.SR2

    if wc.VL2 != 0:
      resNP = 0
      resNP +=((api*(-180*logy*r**4*(3+r**2)*(-1+y)**4-3*(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(0,'SM',y/2,r))/(2880*logy**2*r**8*(
          -1+y)**4+480*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(60*logy*r**4*(3+r**2)*(-1+y)**4
          +(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(
          -5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y
          -13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(0,'VL',y/2,r))/(1440*logy**2*r**8*(
          -1+y)**4+240*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1+y)**4
          -(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(
          -5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y
          -13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(0,'VL2',y/2,r))/(2880*logy**2*r**8*(
          -1+y)**4+480*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2)+(3*api*(-1+y)**2*nlo.X1El(1,'SM',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -(2*api*(-1+y)**2*nlo.X1El(1,'VL',y/2,r))/(12*logy*r**4*(-1+y)**2-r**8*(
          -1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      resNP += ((api*(-1+y)**2*nlo.X1El(1,'VL2',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.VL2

    if wc.SLSR != 0:
      resNP = 0
      resNP +=((720*logy**2*r**7*(1+r**2+r**4)*(-1+y)**4+12*logy*r**3*(-1+y)**2*(18*r**10*(
          -1+y)**2+3*r**12*(-1+y)**2+15*r**4*(-1+y)**3*(9+y-3*y**2+y**3)
          +20*r**6*y*(6-9*y+2*y**2+y**3)+(-1+y)**4*(-3-6*y-9*y**2+8*y**3)
          -5*r**8*(-27+30*y+9*y**2-16*y**3+2*y**4)+2*r**2*(-1+y)**3*(9+9*y
          +9*y**2-11*y**3+4*y**4))+r*(-1+y)**2*(-1+r**2+y)**2*(1+r**12*(-1
          +y)**2-16*y**3+30*y**4-16*y**5+y**8+2*r**10*(63-109*y+38*y**2+3*y**3)
          +r**8*(27-20*y+34*y**2+24*y**3+15*y**4)+2*r**2*(-1+y)**2*(63+109*y
          +147*y**2-130*y**3+18*y**4+3*y**5)+4*r**6*(463-463*y-79*y**2+220*y**3
          -41*y**4+5*y**5)+r**4*(27-34*y+41*y**2-264*y**3+301*y**4-86*y**5
          +15*y**6)))/(2880*logy**2*r**8*(-1+y)**4+480*logy*r**4*(-1+y)**2*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))+20*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-8640*logy**3*r**11*(
          -1+r**2+3*r**4)*(-1+y)**6+144*logy**2*r**7*(-1+y)**4*(-46*r**12*(-1+y)**2
          -5*r**10*(17-34*y+17*y**2+2*y**3)+30*r**8*(-11+4*y+16*y**2-12*y**3
          +y**4)+10*(-1+y)**3*(5+5*y+5*y**2-12*y**3+4*y**4)-10*r**6*(-48
          +114*y-75*y**2+19*y**3-12*y**4+7*y**5)+3*r**2*(-1+y)**2*(7+60*y**3
          -45*y**4+8*y**5)-10*r**4*(-1-16*y+26*y**2-3*y**3-2*y**4-8*y**5+4*y**6))
          -12*logy*r**3*(-1+y)**2*(-1+r**2+y)**2*(3*r**16*(-1+y)**4-3*r**14*(-1
          +y)**2*(-47+96*y-51*y**2+8*y**3)-r**12*(-1+y)**2*(-2278+3740*y-1207*y**2
          -204*y**3+5*y**4)+3*(-1+y)**5*(3+9*y+18*y**2+4*y**3-5*y**4-17*y**5
          +8*y**6)-r**6*(-1+y)**2*(-1511+2404*y+1423*y**2-9220*y**3+6915*y**4
          -904*y**5-339*y**6+32*y**7)+r**2*(-1+y)**4*(-139-296*y-471*y**2+150*y**3
          +91*y**4+266*y**5-221*y**6+40*y**7)+r**4*(-1+y)**3*(2002+1098*y+821*y**2
          -5543*y**3+2932*y**4-120*y**5-191*y**6+41*y**7)+r**10*(703-3408*y
          +6959*y**2-6098*y**3+1285*y**4+930*y**5-431*y**6+80*y**7)+r**8*(3994
          -6914*y-1145*y**2+8730*y**3-5365*y**4+116*y**5+679*y**6-120*y**7
          +25*y**8))+r*(-1+y)**2*(-1+r**2+y)**3*(r**18*(-1+y)**4-r**16*(-1+y)**2*(233
          -427*y+173*y**2+y**3)-6*r**14*(485-1768*y+2347*y**2-1397*y**3+378*y**4
          -41*y**5+6*y**6)-(-1+y)**6*(-1-5*y-15*y**2-17*y**3-11*y**4+5*y**5
          +3*y**6+y**7)-2*r**12*(10745-33161*y+33819*y**2-8292*y**3-6305*y**4
          +3415*y**5-371*y**6+70*y**7)+r**10*(31960-91444*y+67560*y**2+9738*y**3
          -23354*y**4+3980*y**5+428*y**6+78*y**7-266*y**8)-3*r**2*(-1+y)**4*(
          -157-436*y-820*y**2-106*y**3+212*y**4+652*y**5-376*y**6+26*y**7
          +5*y**8)-2*r**4*(-1+y)**3*(593+1006*y+1524*y**2-1527*y**3-133*y**4
          -1280*y**5+1318*y**6-339*y**7+38*y**8)-2*r**6*(-1+y)**2*(-11527-1114*y
          +656*y**2+32337*y**3-25445*y**4+1422*y**5+3234*y**6-741*y**7+98*y**8)
          -6*r**8*(9660-20738*y+7976*y**2+12301*y**3-12124*y**4+1985*y**5+1148*y**6
          -141*y**7-116*y**8+49*y**9))))/(-25920*logy**3*r**12*(-1+y)**6+15*(r**8*(
          -1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3-6480*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -540*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(
          -1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y
          -y**2+y**3))**2))
      resNP += ((api*muWC*(69120*logy**3*r**11*(-1+r**4)*(-1+y)**6+2304*logy**2*r**7*(
          -1+y)**3*(12*r**12*(-1+y)**3+2*r**10*(-4+12*y-12*y**2-6*y**3+5*y**4)
          +r**2*(-1+y)**3*(8-25*y**3+2*y**5)-5*r**8*(8-6*y-21*y**2+38*y**3
          -18*y**4+2*y**5)-(-1+y)**3*(-12+15*y**3-10*y**4+2*y**5)+5*r**6*(24
          -72*y+72*y**2-27*y**3-y**4+2*y**5)+5*r**4*(-8+42*y-69*y**2+53*y**3
          -32*y**4+24*y**5-12*y**6+2*y**7))+96*logy*r**3*(-1+y)*(-1+r**2+y)**2*(3*r**16*(
          -1+y)**5-2*r**14*(-1+y)**2*(35-108*y+114*y**2-38*y**3+3*y**4)-r**12*(
          -1+y)**2*(1070-2780*y+2217*y**2-305*y**3-161*y**4+11*y**5)-(-1
          +y)**6*(-3-9*y-18*y**2+8*y**3+3*y**4-5*y**5+4*y**6)-r**4*(-1+y)**3*(1070
          -430*y-133*y**2-894*y**3+837*y**4-258*y**5+177*y**6-50*y**7+y**8)
          -2*r**6*(-1+y)**2*(101-476*y+78*y**2+1894*y**3-2180*y**4+684*y**5
          +56*y**6-38*y**7+y**8)+2*r**2*(-1+y)**4*(35+38*y+41*y**2-38*y**3
          -35*y**4-14*y**5+39*y**6-18*y**7+2*y**8)+2*r**10*(101-130*y-787*y**2
          +1338*y**3-195*y**4-594*y**5+309*y**6-62*y**7+10*y**8)+r**8*y*(-2534
          +8869*y-14685*y**2+14455*y**3-7685*y**4+1269*y**5+511*y**6-225*y**7
          +25*y**8))+16*r*(-1+y)*(-1+r**2+y)**3*(-((-1+y)**6*y**3*(9+8*y-2*y**2
          +4*y**3+y**4))+r**16*(-1+y)**2*(-88+246*y-219*y**2+53*y**3+y**4)
          +r**14*(-512+2386*y-4415*y**2+3813*y**3-1380*y**4+98*y**5+13*y**6
          +7*y**7)+r**12*(-5568+22782*y-34707*y**2+21666*y**3-1145*y**4-4636*y**5
          +1673*y**6-166*y**7+21*y**8)+r**2*(-1+y)**4*(88+158*y+219*y**2-433*y**3
          +61*y**4+11*y**5-57*y**6+19*y**7-7*y**8+y**9)+r**4*(-1+y)**3*(-512
          -338*y-329*y**2-651*y**3+1589*y**4-19*y**5-1175*y**6+489*y**7-81*y**8
          +7*y**9)+r**6*(-1+y)**2*(5568-5058*y-741*y**2-5973*y**3+9949*y**4
          -4943*y**5+663*y**6+81*y**7-107*y**8+21*y**9)+r**10*(11240-43342*y
          +56765*y**2-32751*y**3+8419*y**4+565*y**5-1987*y**6+717*y**7-141*y**8
          +35*y**9)+r**8*(-11240+35338*y-32753*y**2-11440*y**3+40520*y**4-23300*y**5
          +202*y**6+3628*y**7-920*y**8-70*y**9+35*y**10))))/(-77760*logy**3*r**12*(
          -1+y)**6+45*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -19440*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-1620*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((muG*(8640*logy**3*r**9*(2+11*r**2
          +21*r**4+3*r**6)*(-1+y)**6-144*logy**2*r**5*(-1+y)**3*(186*r**14*(-1+y)**3
          -4*(-1+y)**4*(2+2*y+2*y**2-23*y**3+12*y**4)+r**12*(403-1209*y
          +1209*y**2-773*y**3+170*y**4)+r**10*(2058-5634*y+4824*y**2-1888*y**3
          +410*y**4-70*y**5)-2*r**2*(-1+y)**3*(-99+125*y**3-270*y**4+104*y**5)
          +10*r**8*(132-18*y-549*y**2+608*y**3-213*y**4+17*y**5+3*y**6)-r**4*(
          -1+y)**2*(339-699*y+180*y**2+500*y**3-765*y**4+81*y**5+64*y**6)
          +10*r**6*(-305+1113*y-1410*y**2+749*y**3-195*y**4+66*y**5-20*y**6
          +2*y**7))-12*logy*r*(-1+y)*(-1+r**2+y)**2*(21*r**18*(-1+y)**5-r**16*(
          -1+y)**2*(655-2007*y+2091*y**2-679*y**3+60*y**4)-r**14*(-1+y)**2*(6206
          -15506*y+11577*y**2-413*y**3-1415*y**4+71*y**5)-6*(-1+y)**6*(3+9*y
          +18*y**2+4*y**3-5*y**4-17*y**5+8*y**6)-r**2*(-1+y)**5*(127+218*y
          +273*y**2-394*y**3+159*y**4+380*y**5-403*y**6+80*y**7)+r**6*(-1+y)**3*(
          -3210+2496*y+39*y**2-2272*y**3-10277*y**4+12868*y**5-3043*y**6+44*y**7
          +35*y**8)-r**8*(-1+y)**2*(-20461+29617*y-7005*y**2+4629*y**3-5187*y**4
          +2799*y**5-759*y**6-477*y**7+44*y**8)+r**4*(-1+y)**4*(1211+1237*y
          +1305*y**2-6411*y**3+4463*y**4-363*y**5+801*y**6-547*y**7+64*y**8)
          +r**12*(19473-82857*y+129399*y**2-98329*y**3+41533*y**4-11273*y**5
          +2759*y**6-1105*y**7+200*y**8)+r**10*(42338-181528*y+291425*y**2-228749*y**3
          +96881*y**4-17907*y**5-7661*y**6+6881*y**7-1855*y**8+175*y**9))+r*(
          -1+y)*(-1+r**2+y)**3*(9*r**18*(-1+y)**5+r**16*(-1+y)**2*(1553-4380*y
          +3948*y**2-1000*y**3+19*y**4)+r**14*(7934-36190*y+65186*y**2-53184*y**3
          +16170*y**4+382*y**5-414*y**6-84*y**7)-2*r**12*(-22617+86010*y-116892*y**2
          +47699*y**3+34237*y**4-40000*y**5+11834*y**6-1273*y**7+202*y**8)-(
          -1+y)**5*(711+1917*y+3510*y**2-16*y**3-1600*y**4-3698*y**5+2634*y**6
          -96*y**7-7*y**8+5*y**9)-r**2*(-1+y)**4*(8479+13517*y+16416*y**2-22750*y**3
          +2806*y**4+4976*y**5-892*y**6+674*y**7+15*y**8+39*y**9)-2*r**4*(-1
          +y)**3*(7183+3451*y-1046*y**2+2247*y**3-18598*y**4+15635*y**5-8174*y**6
          +5697*y**7-837*y**8+82*y**9)-2*r**6*(-1+y)**2*(46359-37077*y-11730*y**2
          +12791*y**3+37718*y**4-66203*y**5+24408*y**6+3591*y**7-1555*y**8+218*y**9)
          -2*r**10*(131588-500326*y+657806*y**2-365487*y**3+50926*y**4+41167*y**5
          -23500*y**6+3837*y**7-1176*y**8+365*y**9)-2*r**8*(12548-45862*y+73358*y**2
          -130415*y**3+148675*y**4-26251*y**5-66933*y**6+42027*y**7-6355*y**8
          -1155*y**9+363*y**10))))/(-207360*logy**3*r**12*(-1+y)**6+120*(r**8*(-1
          +y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3-51840*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -4320*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2))
      resNP += ((rhoLS*(-25920*logy**3*r**9*(2+5*r**2+7*r**4+r**6)*(
          -1+y)**6-144*logy**2*r**5*(-1+y)**2*(-198*r**14*(-1+y)**4+12*(-1+y)**5*(
          -1-y-y**2-6*y**3+4*y**4)+r**12*(471-1884*y+2826*y**2-2334*y**3
          +931*y**4-130*y**5)+2*r**2*(-1+y)**4*(-213+225*y**3-250*y**4+88*y**5)
          +2*r**10*(939-3486*y+4689*y**2-2976*y**3+809*y**4-90*y**5+25*y**6)
          +r**4*(-1+y)**3*(1167-2247*y+540*y**2+900*y**3-725*y**4+153*y**5
          +32*y**6)-10*r**8*(-174+318*y+279*y**2-1005*y**3+817*y**4-224*y**5
          -2*y**6+3*y**7)+10*r**6*(-231+1194*y-2331*y**2+2175*y**3-952*y**4
          +133*y**5+12*y**6-2*y**7+2*y**8))+12*logy*r*(-1+r**2+y)**2*(9*r**18*(
          -1+y)**6-3*r**16*(-1+y)**2*(-273+1098*y-1662*y**2+1086*y**3-301*y**4
          +28*y**5)-6*(-1+y)**7*(3+9*y+18*y**2+4*y**3-5*y**4-17*y**5+8*y**6)
          -r**14*(-1+y)**2*(-5898+20496*y-25407*y**2+10974*y**3+754*y**4-1262*y**5
          +31*y**6)-r**2*(-1+y)**5*(-39-3*y+33*y**2+507*y**3-581*y**4-217*y**5
          +707*y**6-479*y**7+112*y**8)-r**8*(-1+y)**2*(32913-90006*y+78702*y**2
          -18426*y**3-9264*y**4+3814*y**5+166*y**6+566*y**7-253*y**8+28*y**9)
          +r**4*(-1+y)**4*(-1167-330*y-132*y**2+7596*y**3-9522*y**4+4402*y**5
          -1700*y**6+1212*y**7-431*y**8+32*y**9)+r**6*(-1+y)**3*(10518-17790*y
          +5409*y**2-1017*y**3+16193*y**4-22709*y**5+11287*y**6-1599*y**7-215*y**8
          +43*y**9)+r**12*(-19965+104538*y-215856*y**2+232968*y**3-139486*y**4
          +42214*y**5-5432*y**6+2424*y**7-1493*y**8+208*y**9)+r**10*(-39342+209106*y
          -444861*y**2+494886*y**3-297162*y**4+67772*y**5+28146*y**6-25382*y**7
          +8216*y**8-1486*y**9+107*y**10))-r*(-1+r**2+y)**3*(33*r**18*(-1+y)**6
          +r**16*(-1+y)**2*(-1617+6261*y-8928*y**2+5412*y**3-1307*y**4+95*y**5)
          -2*r**14*(4911-26874*y+60336*y**2-67821*y**3+38119*y**4-8822*y**5
          -174*y**6+253*y**7+12*y**8)-r**2*(-1+y)**5*(7575+12477*y+15480*y**2
          -21702*y**3+1330*y**4+1380*y**5-964*y**6+1186*y**7-229*y**8+27*y**9)
          -2*r**12*(18153-85671*y+156834*y**2-121587*y**3+1712*y**4+63457*y**5
          -42270*y**6+11031*y**7-1385*y**8+206*y**9)-(-1+y)**5*(-807-1398*y
          -1881*y**2+3534*y**3+1724*y**4+2306*y**5-6232*y**6+2706*y**7-149*y**8
          -44*y**9+y**10)-2*r**4*(-1+y)**3*(-4287+3024*y+3249*y**2-6957*y**3
          +20219*y**4-26871*y**5+21009*y**6-12487*y**7+4668*y**8-789*y**9+62*y**10)
          -2*r**6*(-1+y)**2*(-73863+146808*y-59643*y**2-16929*y**3-53353*y**4
          +118841*y**5-67453*y**6+5625*y**7+5848*y**8-1841*y**9+160*y**10)-2*r**10*(
          -122748+585486*y-1063332*y**2+954237*y**3-385955*y**4-26637*y**5+85629*y**6
          -26021*y**7+3687*y**8-1689*y**9+343*y**10)+r**8*(45096-232956*y+500688*y**2
          -617658*y**3+378184*y**4+99292*y**5-339816*y**6+225168*y**7-61456*y**8
          -48*y**9+4088*y**10-582*y**11))))/(-207360*logy**3*r**12*(-1+y)**6+120*(r**8*(
          -1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3-51840*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -4320*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2))
      resNP += ((api*muWC**2*(25920*logy**3*r**11*(-1+r**2+3*r**4)*(
          -1+y)**6+144*logy**2*r**7*(-1+y)**2*(138*r**12*(-1+y)**4+10*(-1+y)**4*(15
          -3*y**3-10*y**4+4*y**5)+5*r**10*(51-204*y+306*y**2-150*y**3+7*y**4
          +14*y**5)+r**2*(-1+y)**4*(-63-60*y**3-275*y**4+88*y**5)-10*r**8*(-99
          +234*y-27*y**2-408*y**3+409*y**4-138*y**5+11*y**6)-10*r**6*(144-630*y
          +1053*y**2-825*y**3+227*y**4+50*y**5-34*y**6+3*y**7)+10*r**4*(-3-42*y
          +171*y**2-357*y**3+508*y**4-481*y**5+282*y**6-88*y**7+10*y**8))+12*logy*r**3*(
          -1+r**2+y)**2*(9*r**16*(-1+y)**6-3*r**14*(-1+y)**2*(-141+570*y-870*y**2
          +570*y**3-169*y**4+16*y**5)-r**12*(-1+y)**2*(-6834+24888*y-32895*y**2
          +17370*y**3-2114*y**4-770*y**5+43*y**6)-(-1+y)**5*(-27-27*y-27*y**2
          +303*y**3-209*y**4+23*y**5+143*y**6-227*y**7+88*y**8)+r**6*(-1+y)**2*(4533
          -16278*y+14688*y**2+16746*y**3-26670*y**4+4526*y**5+8264*y**6-4130*y**7
          +289*y**8+32*y**9)-r**2*(-1+y)**4*(417+54*y+54*y**2-228*y**3-1392*y**4
          +746*y**5+554*y**6-36*y**7-169*y**8+40*y**9)-r**4*(-1+y)**3*(-6006
          +8718*y-1881*y**2-3723*y**3+9079*y**4-10207*y**5+2801*y**6+1587*y**7
          -649*y**8+41*y**9)+r**10*(2109-14442*y+43434*y**2-59088*y**3+35648*y**4
          -4406*y**5-6218*y**6+3768*y**7-773*y**8+88*y**9)+r**8*(11982-44706*y
          +50031*y**2+36798*y**3-141426*y**4+131528*y**5-48882*y**6+1906*y**7
          +3764*y**8-1102*y**9+107*y**10))-r*(-1+r**2+y)**3*(3*r**18*(-1+y)**6
          +r**16*(-1+y)**2*(-699+2679*y-3780*y**2+2220*y**3-509*y**4+5*y**5)
          +(-1+y)**7*(-3-12*y-30*y**2+138*y**3+154*y**4+48*y**5+138*y**6
          +42*y**7+5*y**8)-2*r**14*(4365-24642*y+57312*y**2-68355*y**3+43765*y**4
          -14504*y**5+1968*y**6+13*y**7+18*y**8)-2*r**12*(32235-163953*y+332658*y**2
          -328737*y**3+140360*y**4+9895*y**5-30318*y**6+8793*y**7-527*y**8+74*y**9)
          -2*r**6*(-1+y)**2*(-34581+65820*y-25929*y**2+3645*y**3-7123*y**4-3115*y**5
          +8651*y**6+2967*y**7-3980*y**8+115*y**9+10*y**10)+2*r**4*(-1+y)**3*(
          -1779+540*y-315*y**2-14709*y**3+32287*y**4-20223*y**5-5763*y**6+8149*y**7
          -1140*y**8+51*y**9+22*y**10)+r**2*(-1+y)**4*(1413+1098*y+945*y**2
          -9930*y**3+5416*y**4-2206*y**5-2092*y**6+6338*y**7-2765*y**8+316*y**9
          +27*y**10)-2*r**10*(-47940+233046*y-423612*y**2+408927*y**3-222425*y**4
          +51399*y**5+6885*y**6-4655*y**7+1473*y**8-333*y**9+115*y**10)-2*r**8*(86940
          -360522*y+532008*y**2-192741*y**3-292376*y**4+307426*y**5-46632*y**6
          -65436*y**7+38588*y**8-7272*y**9-64*y**10+81*y**11))))/(-155520*logy**3*r**12*(
          -1+y)**6+90*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -38880*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-3240*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((mupi*(-25920*logy**3*r**11*(1+r**2
          +r**4)*(-1+y)**6+144*logy**2*r**7*(-1+y)**2*(6*r**12*(-1+y)**4-2*(-1
          +y)**5*(-3-3*y-3*y**2-78*y**3+32*y**4)+r**10*(-159+636*y-954*y**2
          +606*y**3-299*y**4+50*y**5)-r**2*(-1+y)**4*(-159+240*y**3-275*y**4
          +64*y**5)-10*r**8*(51-150*y+117*y**2+54*y**3-73*y**4+18*y**5+y**6)
          +10*r**6*y*(-54+189*y-231*y**2+71*y**3+32*y**4-22*y**5+3*y**6)+10*r**4*(51
          -258*y+495*y**2-375*y**3+2*y**4+145*y**5-66*y**6+4*y**7+2*y**8))
          +12*logy*r**3*(-1+r**2+y)**2*(9*r**16*(-1+y)**6+3*r**14*(-1+y)**2*(-1
          -2*y+18*y**2-38*y**3-5*y**4+4*y**5)-r**12*(-1+y)**2*(414-1788*y
          +2913*y**2-2238*y**3+1250*y**4-262*y**5+23*y**6)+(-1+y)**5*(-9-9*y
          -9*y**2+93*y**3-23*y**4+41*y**5+41*y**6-149*y**7+64*y**8)+r**10*(
          -3321+17214*y-35550*y**2+33588*y**3-17252*y**4+9194*y**5-4618*y**6
          +684*y**7-91*y**8+32*y**9)+r**4*(-1+y)**3*(414-282*y-99*y**2-8289*y**3
          +19465*y**4-16777*y**5+5411*y**6+225*y**7-343*y**8+35*y**9)-r**6*(
          -1+y)**2*(3321-9354*y+8040*y**2-5046*y**3+22218*y**4-29842*y**5+15800*y**6
          -3002*y**7-179*y**8+44*y**9)+r**2*(-1+y)**4*(-3+18*y+18*y**2+720*y**3
          -1428*y**4+494*y**5-82*y**6+648*y**7-409*y**8+64*y**9)+r**8*(-11982
          +59910*y-118449*y**2+104526*y**3-33414*y**4+1312*y**5-4842*y**6+2642*y**7
          +652*y**8-398*y**9+43*y**10))+r*(-1+r**2+y)**3*(3*r**18*(-1+y)**6
          +r**16*(-1+y)**2*(357-1329*y+1800*y**2-1044*y**3+115*y**4+17*y**5)
          +(-1+y)**7*(-3-12*y-30*y**2+30*y**3+58*y**4+72*y**5+90*y**6+30*y**7
          +5*y**8)+2*r**14*(-1293+7254*y-16506*y**2+18987*y**3-12607*y**4+5636*y**5
          -1458*y**6+23*y**7+24*y**8)+2*r**12*(1173-6147*y+12276*y**2-9501*y**3
          -3494*y**4+11051*y**5-7536*y**6+2241*y**7-595*y**8+52*y**9)+r**2*(
          -1+y)**4*(357+258*y+213*y**2-2106*y**3-512*y**4-1606*y**5-1276*y**6
          +5426*y**7-2453*y**8+220*y**9+39*y**10)+2*r**4*(-1+y)**3*(1293-504*y
          -369*y**2-12777*y**3+18847*y**4-10575*y**5+1173*y**6-1835*y**7+2280*y**8
          -477*y**9+64*y**10)+2*r**10*(-19500+94446*y-177030*y**2+128169*y**3
          -24595*y**4-4275*y**5+8427*y**6-11569*y**7+3675*y**8-723*y**9+95*y**10)
          +2*r**6*(-1+y)**2*(1173-2064*y+27*y**2+27747*y**3-88409*y**4+92467*y**5
          -42287*y**6+525*y**7+5108*y**8-883*y**9+116*y**10)+2*r**8*(-19500+81054*y
          -123462*y**2+64863*y**3-19384*y**4+75494*y**5-94380*y**6+44880*y**7
          -11300*y**8+2172*y**9-566*y**10+129*y**11))))/(-207360*logy**3*r**12*(-1
          +y)**6+120*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -51840*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-4320*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*muWC**3*(8640*logy**3*r**12*(24
          +70*r**2+49*r**4+63*r**6+9*r**8)*(-1+y)**7+144*logy**2*r**8*(-1+y)**2*(366*r**16*(
          -1+y)**5+24*(-1+y)**7*(-3-6*y-9*y**2+8*y**3)+4*r**2*(-1+y)**6*(73
          +73*y+73*y**2-172*y**3+108*y**4)+2*r**4*(-1+y)**5*(-3879+2160*y
          +1080*y**2-145*y**3-470*y**4+264*y**5)+r**14*(-533+2665*y-5330*y**2
          +4280*y**3-1795*y**4+143*y**5+90*y**6)-6*r**12*(327-1365*y+2055*y**2
          -845*y**3-375*y**4+463*y**5-155*y**6+15*y**7)+3*r**6*(-1+y)**3*(-2007
          +8214*y-8307*y**2+200*y**3+3585*y**4-1798*y**5+241*y**6+32*y**7)
          -2*r**10*(4506-16860*y+19545*y**2+1060*y**3-18630*y**4+14409*y**5
          -3970*y**6+135*y**7+45*y**8)+10*r**8*(-227+253*y+1699*y**2-4394*y**3
          +3969*y**4-1311*y**5-113*y**6+146*y**7-28*y**8+6*y**9))-12*logy*r**6*(27*r**22*(
          -1+y)**7+r**20*(-1+y)**2*(1309-6545*y+13090*y**2-12748*y**3+6887*y**4
          -1939*y**5+234*y**6)-6*(-1+y)**9*(-11-22*y-33*y**2+2*y**3+37*y**4
          +48*y**5-101*y**6+40*y**7)+r**18*(-1+y)**2*(15621-69321*y+116682*y**2
          -85936*y**3+19485*y**4+9171*y**5-4844*y**6+390*y**7)-r**2*(-1+y)**8*(
          -4733-3005*y-2141*y**2+23653*y**3-17191*y**4+137*y**5+3529*y**6-1425*y**7
          +336*y**8)+r**4*(-1+y)**7*(-2301+7008*y+3504*y**2+3766*y**3-28474*y**4
          +23556*y**5-10060*y**6+4582*y**7-1557*y**8+96*y**9)-2*r**16*(9825-75171*y
          +247899*y**2-481657*y**3+572783*y**4-406186*y**5+159970*y**6-25847*y**7
          -3248*y**8+1365*y**9+27*y**10)-2*r**10*(-1+y)**3*(-167649+697836*y
          -1048314*y**2+603712*y**3+46696*y**4-231293*y**5+116855*y**6-28840*y**7
          +7349*y**8-1755*y**9+123*y**10)+2*r**8*(-1+y)**4*(-18078-18018*y+201996*y**2
          -312282*y**3+177130*y**4+28677*y**5-95827*y**6+47330*y**7-7356*y**8
          -347*y**9+135*y**10)+r**6*(-1+y)**5*(-130125+446442*y-461253*y**2
          -46916*y**3+408054*y**4-248778*y**5+7420*y**6+28644*y**7-609*y**8-2720*y**9
          +321*y**10)-2*r**12*(-1+y)**2*(-117267+478191*y-754062*y**2+622958*y**3
          -308418*y**4+108393*y**5-42451*y**6+9222*y**7+5937*y**8-3112*y**9+369*y**10)
          +r**14*(2574+29070*y-232578*y**2+645546*y**3-883672*y**4+651070*y**5
          -260696*y**6+42618*y**7+16754*y**8-14788*y**9+4786*y**10-684*y**11))
          -r**6*(-1+r**2+y)**2*(45*r**20*(-1+y)**7+2*r**18*(-1+y)**2*(289-1562*y
          +3394*y**2-3604*y**3+2351*y**4-814*y**5+114*y**6)+r**16*(28257-183805*y
          +503482*y**2-733772*y**3+616248*y**4-301750*y**5+76442*y**6-3560*y**7
          -2349*y**8+327*y**9)+3*(-1+y)**7*(-1215-2166*y-2985*y**2+2430*y**3
          +3196*y**4+3322*y**5-8912*y**6+3866*y**7-245*y**8-12*y**9+y**10)-4*r**14*(
          -40201+241328*y-597079*y**2+772683*y**3-533587*y**4+146558*y**5+41439*y**6
          -40609*y**7+8804*y**8-356*y**9+60*y**10)+2*r**2*(-1+y)**5*(51409-31251*y
          -11472*y**2-222256*y**3+396376*y**4-192354*y**5-9904*y**6+22462*y**7
          -3321*y**8+805*y**9-56*y**10+42*y**11)+4*r**6*(-1+y)**3*(433033-1392121*y
          +1465191*y**2-192834*y**3-680178*y**4+466551*y**5-51189*y**6-45996*y**7
          +5031*y**8+3812*y**9-488*y**10+108*y**11)-2*r**8*(-1+y)**2*(-629681
          +1963443*y-1728681*y**2-492889*y**3+1595128*y**4-611142*y**5-406762*y**6
          +368776*y**7-78963*y**8+6103*y**9-1793*y**10+141*y**11)+r**4*(-1+y)**4*(259311
          -318829*y-12423*y**2-361607*y**3+859946*y**4-257562*y**5-356630*y**6
          +253118*y**7-67689*y**8+13447*y**9-1347*y**10+345*y**11)-2*r**12*(185441
          -1200959*y+3265767*y**2-5166339*y**3+4940196*y**4-2696130*y**5+692946*y**6
          +15888*y**7-66381*y**8+20929*y**9-3721*y**10+603*y**11)-4*r**10*(-123480
          +728002*y-1765339*y**2+2331347*y**3-1869046*y**4+876257*y**5-78292*y**6
          -189805*y**7+118532*y**8-36355*y**9+10507*y**10-2646*y**11+318*y**12))))/(
          -699840*logy**3*r**17*(-1+y)**7+405*r**5*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2
          -3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)
          -(-1+y)**3*(-1-y-y**2+y**3))**3-174960*logy**2*r**13*(-1+y)**5*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-14580*logy*r**9*(
          -1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((rhoD*(-8640*logy**3*r**12*(24+70*r**2+49*r**4+63*r**6+9*r**8)*(-1+y)**7
          -144*logy**2*r**8*(-1+y)**2*(366*r**16*(-1+y)**5+24*(-1+y)**7*(-3-6*y
          -9*y**2+8*y**3)+4*r**2*(-1+y)**6*(73+73*y+73*y**2-172*y**3+108*y**4)
          +2*r**4*(-1+y)**5*(-3879+2160*y+1080*y**2-145*y**3-470*y**4+264*y**5)
          +r**14*(-533+2665*y-5330*y**2+4280*y**3-1795*y**4+143*y**5+90*y**6)
          -6*r**12*(327-1365*y+2055*y**2-845*y**3-375*y**4+463*y**5-155*y**6
          +15*y**7)+3*r**6*(-1+y)**3*(-2007+8214*y-8307*y**2+200*y**3+3585*y**4
          -1798*y**5+241*y**6+32*y**7)-2*r**10*(4506-16860*y+19545*y**2+1060*y**3
          -18630*y**4+14409*y**5-3970*y**6+135*y**7+45*y**8)+10*r**8*(-227+253*y
          +1699*y**2-4394*y**3+3969*y**4-1311*y**5-113*y**6+146*y**7-28*y**8
          +6*y**9))+12*logy*r**6*(27*r**22*(-1+y)**7+r**20*(-1+y)**2*(1309-6545*y
          +13090*y**2-12748*y**3+6887*y**4-1939*y**5+234*y**6)-6*(-1+y)**9*(
          -11-22*y-33*y**2+2*y**3+37*y**4+48*y**5-101*y**6+40*y**7)+r**18*(
          -1+y)**2*(15621-69321*y+116682*y**2-85936*y**3+19485*y**4+9171*y**5
          -4844*y**6+390*y**7)-r**2*(-1+y)**8*(-4733-3005*y-2141*y**2+23653*y**3
          -17191*y**4+137*y**5+3529*y**6-1425*y**7+336*y**8)+r**4*(-1+y)**7*(
          -2301+7008*y+3504*y**2+3766*y**3-28474*y**4+23556*y**5-10060*y**6
          +4582*y**7-1557*y**8+96*y**9)-2*r**16*(9825-75171*y+247899*y**2-481657*y**3
          +572783*y**4-406186*y**5+159970*y**6-25847*y**7-3248*y**8+1365*y**9
          +27*y**10)-2*r**10*(-1+y)**3*(-167649+697836*y-1048314*y**2+603712*y**3
          +46696*y**4-231293*y**5+116855*y**6-28840*y**7+7349*y**8-1755*y**9
          +123*y**10)+2*r**8*(-1+y)**4*(-18078-18018*y+201996*y**2-312282*y**3
          +177130*y**4+28677*y**5-95827*y**6+47330*y**7-7356*y**8-347*y**9+135*y**10)
          +r**6*(-1+y)**5*(-130125+446442*y-461253*y**2-46916*y**3+408054*y**4
          -248778*y**5+7420*y**6+28644*y**7-609*y**8-2720*y**9+321*y**10)-2*r**12*(
          -1+y)**2*(-117267+478191*y-754062*y**2+622958*y**3-308418*y**4+108393*y**5
          -42451*y**6+9222*y**7+5937*y**8-3112*y**9+369*y**10)+r**14*(2574+29070*y
          -232578*y**2+645546*y**3-883672*y**4+651070*y**5-260696*y**6+42618*y**7
          +16754*y**8-14788*y**9+4786*y**10-684*y**11))+r**6*(-1+r**2+y)**2*(45*r**20*(
          -1+y)**7+2*r**18*(-1+y)**2*(289-1562*y+3394*y**2-3604*y**3+2351*y**4
          -814*y**5+114*y**6)+r**16*(28257-183805*y+503482*y**2-733772*y**3
          +616248*y**4-301750*y**5+76442*y**6-3560*y**7-2349*y**8+327*y**9)+3*(
          -1+y)**7*(-1215-2166*y-2985*y**2+2430*y**3+3196*y**4+3322*y**5-8912*y**6
          +3866*y**7-245*y**8-12*y**9+y**10)-4*r**14*(-40201+241328*y-597079*y**2
          +772683*y**3-533587*y**4+146558*y**5+41439*y**6-40609*y**7+8804*y**8
          -356*y**9+60*y**10)+2*r**2*(-1+y)**5*(51409-31251*y-11472*y**2-222256*y**3
          +396376*y**4-192354*y**5-9904*y**6+22462*y**7-3321*y**8+805*y**9-56*y**10
          +42*y**11)+4*r**6*(-1+y)**3*(433033-1392121*y+1465191*y**2-192834*y**3
          -680178*y**4+466551*y**5-51189*y**6-45996*y**7+5031*y**8+3812*y**9
          -488*y**10+108*y**11)-2*r**8*(-1+y)**2*(-629681+1963443*y-1728681*y**2
          -492889*y**3+1595128*y**4-611142*y**5-406762*y**6+368776*y**7-78963*y**8
          +6103*y**9-1793*y**10+141*y**11)+r**4*(-1+y)**4*(259311-318829*y-12423*y**2
          -361607*y**3+859946*y**4-257562*y**5-356630*y**6+253118*y**7-67689*y**8
          +13447*y**9-1347*y**10+345*y**11)-2*r**12*(185441-1200959*y+3265767*y**2
          -5166339*y**3+4940196*y**4-2696130*y**5+692946*y**6+15888*y**7-66381*y**8
          +20929*y**9-3721*y**10+603*y**11)-4*r**10*(-123480+728002*y-1765339*y**2
          +2331347*y**3-1869046*y**4+876257*y**5-78292*y**6-189805*y**7+118532*y**8
          -36355*y**9+10507*y**10-2646*y**11+318*y**12))))/(-622080*logy**3*r**17*(
          -1+y)**7+360*r**5*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(
          -1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**3-155520*logy**2*r**13*(-1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-12960*logy*r**9*(-1+y)**3*(-(r**8*(-1
          +y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-8640*logy**3*r**11*(
          -1+r**2+3*r**4)*(-1+y)**6+144*logy**2*r**7*(-1+y)**4*(-46*r**12*(-1+y)**2
          -5*r**10*(17-34*y+17*y**2+2*y**3)+30*r**8*(-11+4*y+16*y**2-12*y**3
          +y**4)+10*(-1+y)**3*(5+5*y+5*y**2-12*y**3+4*y**4)-10*r**6*(-48
          +114*y-75*y**2+19*y**3-12*y**4+7*y**5)+3*r**2*(-1+y)**2*(7+60*y**3
          -45*y**4+8*y**5)-10*r**4*(-1-16*y+26*y**2-3*y**3-2*y**4-8*y**5+4*y**6))
          -12*logy*r**3*(-1+y)**2*(-1+r**2+y)**2*(3*r**16*(-1+y)**4-3*r**14*(-1
          +y)**2*(-47+96*y-51*y**2+8*y**3)-r**12*(-1+y)**2*(-2278+3740*y-1207*y**2
          -204*y**3+5*y**4)+3*(-1+y)**5*(3+9*y+18*y**2+4*y**3-5*y**4-17*y**5
          +8*y**6)-r**6*(-1+y)**2*(-1511+2404*y+1423*y**2-9220*y**3+6915*y**4
          -904*y**5-339*y**6+32*y**7)+r**2*(-1+y)**4*(-139-296*y-471*y**2+150*y**3
          +91*y**4+266*y**5-221*y**6+40*y**7)+r**4*(-1+y)**3*(2002+1098*y+821*y**2
          -5543*y**3+2932*y**4-120*y**5-191*y**6+41*y**7)+r**10*(703-3408*y
          +6959*y**2-6098*y**3+1285*y**4+930*y**5-431*y**6+80*y**7)+r**8*(3994
          -6914*y-1145*y**2+8730*y**3-5365*y**4+116*y**5+679*y**6-120*y**7
          +25*y**8))+r*(-1+y)**2*(-1+r**2+y)**3*(r**18*(-1+y)**4-r**16*(-1+y)**2*(233
          -427*y+173*y**2+y**3)-6*r**14*(485-1768*y+2347*y**2-1397*y**3+378*y**4
          -41*y**5+6*y**6)-(-1+y)**6*(-1-5*y-15*y**2-17*y**3-11*y**4+5*y**5
          +3*y**6+y**7)-2*r**12*(10745-33161*y+33819*y**2-8292*y**3-6305*y**4
          +3415*y**5-371*y**6+70*y**7)+r**10*(31960-91444*y+67560*y**2+9738*y**3
          -23354*y**4+3980*y**5+428*y**6+78*y**7-266*y**8)-3*r**2*(-1+y)**4*(
          -157-436*y-820*y**2-106*y**3+212*y**4+652*y**5-376*y**6+26*y**7
          +5*y**8)-2*r**4*(-1+y)**3*(593+1006*y+1524*y**2-1527*y**3-133*y**4
          -1280*y**5+1318*y**6-339*y**7+38*y**8)-2*r**6*(-1+y)**2*(-11527-1114*y
          +656*y**2+32337*y**3-25445*y**4+1422*y**5+3234*y**6-741*y**7+98*y**8)
          -6*r**8*(9660-20738*y+7976*y**2+12301*y**3-12124*y**4+1985*y**5+1148*y**6
          -141*y**7-116*y**8+49*y**9)))*math.log(mu0**2/r**2))/(-34560*logy**3*r**12*(-1
          +y)**6+20*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -8640*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-720*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1
          +y)**4-(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1
          +y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(0,'SLSR',y/2,r))/(2880*logy**2*r**8*(-1+y)**4+480*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(720*logy**2*r**7*(4+5*r**2+2*r**4)*(-1+y)**6+24*logy*r**3*(-1
          +y)**4*(8*r**10*(-1+y)**2+3*r**12*(-1+y)**2-5*r**8*(-44+64*y-8*y**2
          -13*y**3+2*y**4)+2*(-1+y)**3*(-1-y-y**2-6*y**3+4*y**4)+5*r**6*(26
          +8*y-64*y**2+21*y**3+7*y**4)+r**2*(-1+y)**2*(-58+35*y**3-15*y**4
          +8*y**5)+5*r**4*(-61+170*y-133*y**2+y**3+31*y**4-11*y**5+3*y**6))
          +r*(-1+y)**3*(-1+r**2+y)**2*(7*r**12*(-1+y)**3+2*r**10*(-81+214*y
          -174*y**2+35*y**3+6*y**4)+r**8*(-169+509*y-558*y**2+220*y**3+3*y**4
          -5*y**5)-4*r**6*(1431-2992*y+1413*y**2+518*y**3-447*y**4+47*y**5)
          +(-1+y)**3*(-13-26*y-39*y**2-54*y**3-9*y**4+4*y**5+17*y**6)+2*r**2*(
          -1+y)**2*(-61-72*y-71*y**2+319*y**3-256*y**4+55*y**5+26*y**6)+r**4*(
          -1749+2827*y-705*y**2+335*y**3-1195*y**4+489*y**5-47*y**6+45*y**7)))*nlo.X1El(0,'SM',y/2,r))/(
          -34560*logy**3*r**12*(-1+y)**6+20*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)
          -2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(
          -1-y-y**2+y**3))**3-8640*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-720*logy*r**4*(-1+y)**2*(-(r**8*(-1
          +y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1
          +y)**2*nlo.X1El(1,'SLSR',y/2,r))/(12*logy*r**4*(-1+y)**2-r**8*(-1+y)**2
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      resNP += ((api*(12*logy*r**3*(1
          +r**2)*(-1+y)**4+2*r*(-1+y)**3*(r**6*(-1+y)+3*r**2*(-1+y)**2*(3+y)
          +3*r**4*(-3+y+y**2)+(-1+y)**2*(1+y+y**2)))*nlo.X1El(1,'SM',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      res += resNP*wc.SLSR

    if wc.VR2 != 0:
      resNP = 0
      resNP +=((8640*logy**3*r**10*(4+7*r**2+7*r**4+4*r**6)*(-1+y)**6+144*logy**2*r**6*(
          -1+y)**4*(135*r**12*(-1+y)**2+12*r**14*(-1+y)**2+4*(-1+y)**4*(-3-6*y
          -9*y**2+8*y**3)+r**10*(927-1134*y-153*y**2+450*y**3-40*y**4)+10*r**8*(42
          +42*y-147*y**2+54*y**3+14*y**4)+5*r**2*(-1+y)**3*(27+27*y+27*y**2
          -39*y**3+16*y**4)+r**4*(-1+y)**2*(-927+720*y+360*y**2-120*y**3-35*y**4
          +32*y**5)+10*r**6*(-42+210*y-231*y**2+4*y**3+86*y**4-33*y**5+6*y**6))
          +12*logy*r**4*(-1+y)**3*(-1+r**2+y)**2*(21*r**14*(-1+y)**3+3*r**12*(
          -341+941*y-825*y**2+211*y**3+14*y**4)+r**10*(-3465+8667*y-6606*y**2
          +562*y**3+851*y**4-9*y**5)+(-1+y)**4*(-21-63*y-126*y**2-30*y**3
          -9*y**4+33*y**5+16*y**6)-r**8*(19251-37179*y+14454*y**2+10882*y**3
          -7325*y**4+217*y**5+20*y**6)+r**2*(-1+y)**3*(1023+1800*y+2475*y**2
          -2272*y**3+341*y**4-64*y**5+97*y**6)+r**4*(-1+y)**2*(-3465-1737*y
          -1404*y**2+8618*y**3-3745*y**4-13*y**5+186*y**6)+r**6*(-19251+39825*y
          -18423*y**2-9483*y**3+7827*y**4-177*y**5-433*y**6+115*y**7))+(-1
          +y)**2*(-1+r**2+y)**3*(r**20*(-1+y)**4+r**18*(-1+y)**2*(-20+37*y-14*y**2
          +7*y**3)+r**16*(1225-4591*y+6246*y**2-3676*y**3+857*y**4-65*y**5
          +20*y**6)-(-1+y)**6*(-1-5*y-15*y**2-17*y**3-11*y**4+5*y**5+3*y**6
          +y**7)+2*r**14*(5608-17977*y+19392*y**2-6228*y**3-1972*y**4+1127*y**5
          -4*y**6+14*y**7)-r**2*(-1+y)**5*(-20-77*y-185*y**2-145*y**3-69*y**4
          +53*y**5-31*y**6-7*y**7+y**8)-r**4*(-1+y)**4*(-1225-3366*y-6246*y**2
          -1552*y**3-658*y**4+1426*y**5-62*y**6-84*y**7+7*y**8)+2*r**12*(6763
          -18631*y+17127*y**2-1324*y**3-5708*y**4+997*y**5+723*y**6+126*y**7
          +7*y**8)-2*r**6*(-1+y)**3*(5608+6761*y+7023*y**2-21292*y**3+4000*y**4
          +661*y**5+339*y**6-150*y**7+10*y**8)-2*r**8*(-1+y)**2*(-6763+1658*y
          -154*y**2+16125*y**3-14495*y**4-426*y**5+1014*y**6-273*y**7+14*y**8)
          -2*r**10*(-69092+172730*y-112866*y**2-47225*y**3+80736*y**4-22337*y**5
          -2586*y**6+913*y**7-280*y**8+7*y**9)))/(34560*logy**3*r**12*(-1+y)**6
          -20*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)
          +2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3+8640*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +720*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(
          -1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y
          -y**2+y**3))**2))
      resNP += ((api*(207360*logy**4*r**14*(-4+7*r**4+8*r**6)*(-1+y)**8
          +13824*logy**3*r**10*(-1+y)**6*(32*r**14*(-1+y)**2+5*r**12*(21-42*y+21*y**2
          +2*y**3)-4*r**10*(-94+68*y+86*y**2-80*y**3+5*y**4)-2*(-1+y)**3*(17
          +17*y+17*y**2-38*y**3+12*y**4)-10*r**2*(-1+y)**2*(-4+25*y**3-19*y**4
          +4*y**5)+5*r**8*(-54+192*y-180*y**2+58*y**3-13*y**4+10*y**5)+10*r**6*(
          -40+80*y-40*y**2+3*y**3+6*y**4-9*y**5+4*y**6)+r**4*(83-406*y+443*y**2
          -70*y**3+60*y**4-188*y**5+86*y**6-8*y**7))+576*logy**2*r**6*(-1+y)**4*(
          -1+r**2+y)**2*(12*r**18*(-1+y)**4-3*r**16*(-1+y)**2*(-109+226*y-125*y**2
          +12*y**3)-2*r**14*(-1+y)**2*(-2445+4077*y-1413*y**2-219*y**3+10*y**4)
          +6*(-1+y)**5*(3+9*y+18*y**2+4*y**3-5*y**4-17*y**5+8*y**6)+4*r**2*(
          -1+y)**4*(-87-183*y-288*y**2+66*y**3+83*y**4+197*y**5-170*y**6+32*y**7)
          +r**12*(7179-27006*y+38763*y**2-23004*y**3+1691*y**4+3054*y**5-747*y**6
          +120*y**7)+4*r**10*(4041-10092*y+7365*y**2+1059*y**3-3712*y**4+1526*y**5
          -257*y**6+90*y**7+5*y**8)+2*r**6*(-1+y)**2*(-963-837*y-909*y**2+14109*y**3
          -13939*y**4+3409*y**5+513*y**6-255*y**7+42*y**8)+r**4*(-1+y)**3*(4359
          +2643*y+2205*y**2-12387*y**3+5543*y**4-901*y**5+1015*y**6-537*y**7
          +80*y**8)+r**8*(1839+2100*y-16998*y**2+37488*y**3-49812*y**4+34556*y**5
          -7830*y**6-2592*y**7+1317*y**8-68*y**9))+96*logy*r**4*(-1+y)**3*(-1
          +r**2+y)**3*(7*r**20*(-1+y)**5+3*r**18*(-1+y)**3*(211-381*y+153*y**2
          +5*y**3)+r**16*(-6890+32302*y-59804*y**2+54416*y**3-23991*y**4+3749*y**5
          +199*y**6+19*y**7)+r**14*(-44234+181012*y-277994*y**2+179586*y**3
          -17191*y**4-32052*y**5+11038*y**6-254*y**7+89*y**8)+2*(-1+y)**6*(6
          +24*y+60*y**2+51*y**3+21*y**4-42*y**5-16*y**6-13*y**7+5*y**8+4*y**9)
          +r**2*(-1+y)**5*(-857-2391*y-4530*y**2-932*y**3+985*y**4+3749*y**5
          -2026*y**6+204*y**7-148*y**8+66*y**9)+r**4*(-1+y)**4*(5623+9461*y
          +13134*y**2-13412*y**3-6945*y**4-12185*y**5+16566*y**6-4328*y**7-298*y**8
          +184*y**9)+r**12*(-7488+43836*y-116322*y**2+132936*y**3-36957*y**4
          -43017*y**5+34630*y**6-9236*y**7+1237*y**8+221*y**9)+r**6*(-1+y)**3*(
          -38394-1170*y+1554*y**2+121788*y**3-101625*y**4+15363*y**5+434*y**6
          +3140*y**7-1309*y**8+259*y**9)+r**8*(-1+y)**2*(-30578+54846*y+16410*y**2
          -218476*y**3+252473*y**4-72479*y**5-24278*y**6+14448*y**7-1751*y**8
          +265*y**9)+r**10*(-50096+85372*y+59614*y**2-235262*y**3+191435*y**4
          -26252*y**5-50425*y**6+32098*y**7-7211*y**8+452*y**9+275*y**10))-2*r**2*(
          -1+y)**2*(-1+r**2+y)**4*(r**24*(-1+y)**6+4*r**22*(-1+y)**4*(-7+13*y
          -5*y**2+y**3)-2*r**20*(-1+y)**2*(571-2170*y+3049*y**2-1788*y**3+279*y**4
          +34*y**5+3*y**6)-4*r**18*(12203-66707*y+148412*y**2-170346*y**3+103908*y**4
          -29262*y**5+1002*y**6+766*y**7-9*y**8+17*y**9)+r**16*(-170209+859738*y
          -1753573*y**2+1798472*y**3-895558*y**4+119060*y**5+48022*y**6+288*y**7
          -6169*y**8-54*y**9-177*y**10)+(-1+y)**7*(-1-5*y-15*y**2+93*y**3
          +202*y**4+210*y**5+34*y**6-54*y**7+63*y**8-37*y**9-11*y**10+y**11)
          +4*r**2*(-1+y)**6*(625+2357*y+5607*y**2+5137*y**3+2648*y**4-3012*y**5
          -1226*y**6-1132*y**7+843*y**8+71*y**9-41*y**10+3*y**11)+8*r**10*(-1
          +y)**2*(-330395+534169*y+5387*y**2-566955*y**3+427566*y**4-42270*y**5
          -69638*y**6+26596*y**7-7427*y**8+1565*y**9-753*y**10+15*y**11)-8*r**14*(140387
          -641833*y+1126765*y**2-846561*y**3+49056*y**4+345336*y**5-219946*y**6
          +50570*y**7-4675*y**8+709*y**9+165*y**10+27*y**11)+2*r**4*(-1+y)**5*(
          -25797-61537*y-103239*y**2+28885*y**3+57712*y**4+101608*y**5-90498*y**6
          +8970*y**7+105*y**8+2149*y**9-467*y**10+29*y**11)+4*r**6*(-1+y)**4*(24157
          +24505*y+31611*y**2-102063*y**3-15018*y**4-64986*y**5+129566*y**6
          -49774*y**7-2227*y**8+3545*y**9-713*y**10+37*y**11)+r**8*(-1+y)**3*(
          -1089311+462325*y+314951*y**2+3213675*y**3-4256526*y**4+865722*y**5
          +665518*y**6-236810*y**7-36659*y**8+20081*y**9-5253*y**10+207*y**11)
          -4*r**12*(-401483+1776636*y-2776778*y**2+1480012*y**3+608913*y**4-1104648*y**5
          +523798*y**6-124092*y**7+17073*y**8+676*y**9-1136*y**10+1008*y**11
          +21*y**12))))/(311040*logy**4*r**16*(-1+y)**8+103680*logy**3*r**12*(-1+y)**6*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))+12960*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          +720*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(
          -1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y
          -y**2+y**3))**3+15*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(
          -1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y
          -y**2+y**3))**4))
      resNP += ((api*muWC*(-414720*logy**4*r**14*(-12-7*r**2+7*r**4+12*r**6)*(
          -1+y)**8-27648*logy**3*r**10*(-1+y)**5*(66*r**14*(-1+y)**3+5*r**2*(-1
          +y)**3*(29-52*y**3+12*y**4)+5*r**12*(-29+87*y-87*y**2+5*y**3+12*y**4)
          +r**10*(-459+657*y+423*y**2-1361*y**3+660*y**4-50*y**5)-2*(-1+y)**3*(
          -33+40*y**3-30*y**4+8*y**5)+5*r**8*(134-486*y+612*y**2-340*y**3
          +33*y**4+21*y**5)+5*r**6*(134-318*y+192*y**2+76*y**3-207*y**4+175*y**5
          -76*y**6+12*y**7)+r**4*(-459+2097*y-3177*y**2+2039*y**3-690*y**4
          +314*y**5-92*y**6-48*y**7+16*y**8))-1152*logy**2*r**6*(-1+y)**3*(-1
          +r**2+y)**2*(30*r**18*(-1+y)**5-3*r**16*(-1+y)**2*(225-695*y+735*y**2
          -253*y**3+12*y**4)-r**14*(-1+y)**2*(9249-24405*y+20187*y**2-2949*y**3
          -1480*y**4+98*y**5)-2*(-1+y)**5*(15+30*y+45*y**2-76*y**3+7*y**4
          +10*y**5-27*y**6+16*y**7)-r**2*(-1+y)**4*(-675-735*y-795*y**2+1089*y**3
          +197*y**4+345*y**5-517*y**6+191*y**7)+r**12*(-9105+45489*y-93543*y**2
          +81871*y**3-14997*y**4-17267*y**5+8227*y**6-995*y**7+120*y**8)-r**6*(
          -1+y)**2*(-9105+9141*y-2673*y**2+32279*y**3-43691*y**4+17565*y**5
          -3111*y**6+2033*y**7-544*y**8+6*y**9)+r**4*(-1+y)**3*(-9249+3342*y
          +876*y**2+9858*y**3-8292*y**4+2734*y**5-3262*y**6+1654*y**7-353*y**8
          +32*y**9)+r**10*(-14325+41559*y-35607*y**2-39003*y**3+105561*y**4
          -76235*y**5+15875*y**6+3295*y**7-1490*y**8+170*y**9)+r**8*(14325-73041*y
          +145794*y**2-184578*y**3+184480*y**4-123460*y**5+34566*y**6+7806*y**7
          -7077*y**8+1205*y**9-20*y**10))-192*logy*r**4*(-1+y)**2*(-1+r**2+y)**3*(19*r**20*(
          -1+y)**6+r**18*(-1+y)**3*(-1490+4167*y-3741*y**2+909*y**3+57*y**4)
          -(-1+y)**7*(-19-76*y-190*y**2-128*y**3-89*y**4-48*y**5+54*y**6
          +36*y**7+20*y**8)+r**16*(12513-71145*y+167361*y**2-203881*y**3+130318*y**4
          -36557*y**5+109*y**6+1227*y**7+55*y**8)+r**14*(82628-418386*y+846072*y**2
          -814950*y**3+291668*y**4+98265*y**5-109420*y**6+24374*y**7-336*y**8
          +85*y**9)+r**2*(-1+y)**5*(1490+2677*y+3741*y**2-4914*y**3+808*y**4
          -385*y**5-1157*y**6+726*y**7+38*y**8-152*y**9+8*y**10)+r**4*(-1+y)**4*(
          -12513-8580*y-7911*y**2+17162*y**3+9252*y**4+2563*y**5-20301*y**6
          +8594*y**7-955*y**8-191*y**9+40*y**10)+r**6*(-1+y)**3*(82628-77382*y
          -6438*y**2-64078*y**3+94026*y**4-58379*y**5+53467*y**6-33966*y**7+7330*y**8
          -823*y**9+135*y**10)+r**12*(-23090+77298*y-7872*y**2-91634*y**3-76842*y**4
          +249665*y**5-151273*y**6+22134*y**7+2228*y**8-407*y**9+273*y**10)+r**8*(
          -1+y)**2*(23090-84332*y+28974*y**2+351750*y**3-550072*y**4+273433*y**5
          -28123*y**6-10674*y**7+1330*y**8-1013*y**9+317*y**10)+r**10*y*(179928
          -719712*y+1363922*y**2-1516052*y**3+862591*y**4-18550*y**5-262261*y**6
          +132720*y**7-22711*y**8-294*y**9+419*y**10))+4*(-1+y)*(-1+r**2+y)**4*(r**26*(
          -1+y)**7+r**24*(-1+y)**4*(29-83*y+75*y**2-33*y**3+4*y**4)-2*r**22*(
          -1+y)**2*(-1821+8705*y-16433*y**2+14973*y**3-6253*y**4+745*y**5+73*y**6
          +3*y**7)-2*r**20*(-50203+322545*y-872870*y**2+1273784*y**3-1057772*y**4
          +471776*y**5-81058*y**6-9766*y**7+3381*y**8+117*y**9+34*y**10)-(-1
          +y)**8*(-1-5*y-15*y**2-51*y**3-70*y**4-30*y**5+18*y**6+26*y**7-49*y**8
          +11*y**9+5*y**10+y**11)-r**18*(-266837+1611107*y-4098115*y**2+5398621*y**3
          -3502390*y**4+495658*y**5+638594*y**6-289054*y**7+2523*y**8+9411*y**9
          +625*y**10+177*y**11)+r**16*(2212407-12331301*y+27861873*y**2-30683747*y**3
          +12953706*y**4+5760874*y**5-8942206*y**6+3669562*y**7-503121*y**8+3955*y**9
          +885*y**10-2031*y**11-216*y**12)+r**2*(-1+y)**7*(29+112*y+270*y**2
          +536*y**3+427*y**4-32*y**5-288*y**6+176*y**7+583*y**8-80*y**9+34*y**10
          -8*y**11+y**12)+2*r**4*(-1+y)**6*(-1821-5063*y-9549*y**2+4523*y**3
          +1738*y**4+4376*y**5+7142*y**6+994*y**7+y**8-869*y**9+331*y**10-49*y**11
          +6*y**12)+2*r**6*(-1+y)**5*(50203+71530*y+84720*y**2-151226*y**3+33053*y**4
          -3312*y**5+11818*y**6+23988*y**7+2627*y**8-6850*y**9+1982*y**10-322*y**11
          +29*y**12)+4*r**12*(-1+y)**2*(1062273-2762873*y+1605669*y**2+2499733*y**3
          -3969846*y**4+1463020*y**5+423878*y**6-353426*y**7+63063*y**8-5171*y**9
          +5001*y**10-1431*y**11+30*y**12)+r**8*(-1+y)**4*(-266837-10085*y-45135*y**2
          +981*y**3+903354*y**4-19802*y**5-1057390*y**6+711850*y**7-95673*y**8
          -18657*y**9+10989*y**10-2223*y**11+148*y**12)+r**10*(-1+y)**3*(2212407
          -3155548*y+334614*y**2-1766812*y**3+4977465*y**4-3767848*y**5+1597612*y**6
          -474616*y**7+116529*y**8-18364*y**9+17838*y**10-4524*y**11+207*y**12)
          -4*r**14*(1062273-5735311*y+12009202*y**2-12480454*y**3+6279253*y**4
          -108535*y**5-2342338*y**6+2002210*y**7-819743*y**8+133637*y**9+3388*y**10
          -4704*y**11+1101*y**12+21*y**13))))/(933120*logy**4*r**16*(-1+y)**8+311040*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +38880*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+2160*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+45*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((muG*(-103680*logy**4*r**12*(-32+24*r**2
          +73*r**4+69*r**6+12*r**8)*(-1+y)**8-6912*logy**3*r**8*(-1+y)**5*(-246*r**16*(
          -1+y)**3+r**14*(-221+663*y-663*y**2+761*y**3-240*y**4)-4*(-1+y)**4*(
          -7-7*y-7*y**2-7*y**3+8*y**4)+r**12*(-2898+7974*y-6894*y**2+2918*y**3
          -520*y**4+70*y**5)+r**2*(-1+y)**3*(287-140*y**3-365*y**4+128*y**5)
          +r**10*(-2583+3609*y+2601*y**2-4267*y**3+1115*y**4+235*y**5-60*y**6)
          +r**4*(-1+y)**2*(-1524+3444*y-960*y**2-2240*y**3+2115*y**4-1211*y**5
          +256*y**6)-5*r**8*(-548+2520*y-3834*y**2+2166*y**3-329*y**4-19*y**5
          -28*y**6+12*y**7)+r**6*(4499-14937*y+17097*y**2-7919*y**3+1600*y**4
          -744*y**5+722*y**6-382*y**7+64*y**8))+288*logy**2*r**4*(-1+y)**3*(-1
          +r**2+y)**2*(114*r**20*(-1+y)**5-3*r**18*(-1+y)**2*(817-2527*y+2679*y**2
          -909*y**3+60*y**4)-r**16*(-1+y)**2*(28389-72585*y+56619*y**2-3349*y**3
          -5908*y**4+334*y**5)+8*(-1+y)**6*(3+9*y+18*y**2+4*y**3-5*y**4-17*y**5
          +8*y**6)+4*r**2*(-1+y)**5*(-72-156*y-252*y**2-182*y**3-69*y**4-24*y**5
          +63*y**6+32*y**7)+r**4*(-1+y)**4*(963-429*y-741*y**2+4651*y**3+1111*y**4
          +5423*y**5-1475*y**6-723*y**7+320*y**8)+r**14*(40989-162549*y+215541*y**2
          -139669*y**3+75001*y**4-39193*y**5+11155*y**6-2875*y**7+600*y**8)+r**8*(
          -1+y)**2*(-70827+195687*y-107559*y**2-190711*y**3+287731*y**4-181477*y**5
          +62719*y**6-6425*y**7-508*y**8+150*y**9)+r**6*(-1+y)**3*(11349-19182*y
          -7842*y**2+19570*y**3-45282*y**4+41410*y**5-11264*y**6+4326*y**7-1801*y**8
          +256*y**9)+r**12*(211479-890121*y+1371561*y**2-993247*y**3+358525*y**4
          -51187*y**5-20325*y**6+16755*y**7-4990*y**8+550*y**9)+r**10*(174747
          -736587*y+1181664*y**2-1011236*y**3+625042*y**4-335114*y**5+118784*y**6
          -13712*y**7-6277*y**8+2885*y**9-196*y**10))+48*logy*r**2*(-1+y)**2*(
          -1+r**2+y)**3*(61*r**22*(-1+y)**6+r**20*(-1+y)**3*(-5669+15822*y-14136*y**2
          +3266*y**3+227*y**4)+(-1+y)**7*(9+36*y+90*y**2+68*y**3+16*y**4
          -84*y**5-22*y**6-12*y**7+19*y**8)+r**18*(38709-218664*y+510747*y**2
          -612702*y**3+378466*y**4-97790*y**5-1921*y**6+2832*y**7+323*y**8)+r**16*(219799
          -1080663*y+2098497*y**2-1836671*y**3+368633*y**4+539558*y**5-380685*y**6
          +71827*y**7-736*y**8+441*y**9)+r**2*(-1+y)**6*(-1075-2964*y-5550*y**2
          -1620*y**3+301*y**4+2795*y**5-2590*y**6+300*y**7+514*y**8+57*y**9
          +32*y**10)+r**4*(-1+y)**5*(171-150*y+99*y**2+9764*y**3+12332*y**4
          +21213*y**5-7465*y**6+236*y**7-1159*y**8+553*y**9+166*y**10)+r**6*(
          -1+y)**4*(-23931-12396*y-15069*y**2-21608*y**3-10770*y**4-15649*y**5
          +32915*y**6+26256*y**7-15867*y**8+1073*y**9+446*y**10)+r**8*(-1+y)**3*(
          -63634+196446*y+4398*y**2-414804*y**3+608968*y**4-650375*y**5+351763*y**6
          -82684*y**7+30218*y**8-7579*y**9+963*y**10)+r**14*(-669986+3106782*y
          -5317260*y**2+4269648*y**3-1598344*y**4+147269*y**5+108227*y**6-31136*y**7
          -17174*y**8+3493*y**9+1041*y**10)+r**10*(-1+y)**2*(377758-1233226*y
          +973278*y**2+1386784*y**3-2683574*y**4+1705629*y**5-593951*y**6+62824*y**7
          +51892*y**8-14711*y**9+1617*y**10)+r**12*(-1271898+6190464*y-11625450*y**2
          +10955008*y**3-5414596*y**4+714425*y**5+1212474*y**6-1110119*y**7+406158*y**8
          -54253*y**9-3936*y**10+1723*y**11))-(-1+y)*(-1+r**2+y)**4*(5*r**26*(
          -1+y)**7+5*r**24*(-1+y)**4*(27-77*y+69*y**2-31*y**3+4*y**4)-2*r**22*(
          -1+y)**2*(-5985+28721*y-54537*y**2+49641*y**3-20121*y**4+1897*y**5
          +329*y**6+15*y**7)+r**20*(374018-2391486*y+6427788*y**2-9277376*y**3
          +7560728*y**4-3254464*y**5+502524*y**6+81604*y**7-21758*y**8-918*y**9
          -340*y**10)+r**18*(466697-2678279*y+6528903*y**2-7802097*y**3+3404158*y**4
          +1675006*y**5-2132826*y**6+424582*y**7+149849*y**8-34135*y**9-2573*y**10
          -885*y**11)+(-1+y)**8*(51+255*y+765*y**2+1241*y**3+1170*y**4-70*y**5
          -918*y**6-1006*y**7+99*y**8+79*y**9+65*y**10+29*y**11)+r**16*(6326357
          -35012335*y+78315635*y**2-83349145*y**3+28166926*y**4+27102782*y**5
          -32896378*y**6+13353774*y**7-2139395*y**8+132697*y**9+12799*y**10-9437*y**11
          -1080*y**12)+r**2*(-1+y)**7*(3537+13512*y+32406*y**2+32336*y**3+17543*y**4
          -17088*y**5-13408*y**6-10608*y**7+3283*y**8-1736*y**9-262*y**10+160*y**11
          +5*y**12)+2*r**4*(-1+y)**6*(-19127-38337*y-53931*y**2+50949*y**3+12186*y**4
          -46368*y**5-147214*y**6-12378*y**7+37227*y**8-7531*y**9+53*y**10-39*y**11
          +30*y**12)+2*r**6*(-1+y)**5*(-11353+30654*y+101712*y**2+408818*y**3
          +211121*y**4+215688*y**5-560190*y**6+3388*y**7+2735*y**8-7054*y**9
          +5062*y**10-1526*y**11+145*y**12)+4*r**12*(-1+y)**2*(1452155-5185471*y
          +5286467*y**2+5981363*y**3-14891750*y**4+8461628*y**5-159070*y**6-1138134*y**7
          +462949*y**8-133181*y**9+29431*y**10-7337*y**11+150*y**12)+r**8*(-1
          +y)**4*(-1165199-32407*y+31019*y**2+1486599*y**3-689066*y**4+900578*y**5
          -545626*y**6+1458510*y**7-1315307*y**8+88469*y**9+41023*y**10-11813*y**11
          +740*y**12)+r**10*(-1+y)**3*(-2445389+6582436*y-1422098*y**2-13222076*y**3
          +20988029*y**4-22711112*y**5+16461820*y**6-3513912*y**7-727243*y**8
          -82204*y**9+87878*y**10-23884*y**11+1035*y**12)-4*r**14*(7346557-39377751*y
          +82642662*y**2-84187002*y**3+35059021*y**4+11212805*y**5-21913002*y**6
          +11979074*y**7-2866003*y**8+16461*y**9+109152*y**10-27516*y**11+5437*y**12
          +105*y**13))))/(2488320*logy**4*r**16*(-1+y)**8+829440*logy**3*r**12*(-1
          +y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +103680*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+5760*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+120*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*muWC**2*(-311040*logy**4*r**14*(
          -4+7*r**4+8*r**6)*(-1+y)**8-6912*logy**3*r**10*(-1+y)**4*(96*r**14*(-1
          +y)**4+2*(-1+y)**4*(51-15*y**3-20*y**4+4*y**5)+15*r**12*(21-84*y
          +126*y**2-70*y**3+9*y**4+4*y**5)+5*r**2*(-1+y)**4*(24-24*y**3-49*y**4
          +16*y**5)+r**10*(1128-3072*y+1728*y**2+2658*y**3-3352*y**4+1175*y**5
          -70*y**6)-5*r**8*(162-900*y+1854*y**2-1830*y**3+716*y**4+26*y**5
          -73*y**6+6*y**7)+5*r**6*(-240+960*y-1440*y**2+810*y**3+335*y**4-747*y**5
          +454*y**6-126*y**7+12*y**8)+r**4*(249-1716*y+4014*y**2-4806*y**3
          +3334*y**4-1064*y**5-554*y**6+896*y**7-409*y**8+56*y**9))-288*logy**2*r**6*(
          -1+y)**2*(-1+r**2+y)**2*(36*r**18*(-1+y)**6-9*r**16*(-1+y)**2*(-109
          +444*y-686*y**2+464*y**3-133*y**4+8*y**5)-2*r**14*(-1+y)**2*(-7335
          +26901*y-36036*y**2+19062*y**3-2239*y**4-934*y**5+56*y**6)-2*(-1
          +y)**5*(-27-27*y-27*y**2+219*y**3-133*y**4+19*y**5+139*y**6-231*y**7
          +88*y**8)-2*r**2*(-1+y)**4*(522+54*y+54*y**2-936*y**3-217*y**4+114*y**5
          +202*y**6+622*y**7-523*y**8+128*y**9)+r**12*(21537-124092*y+299862*y**2
          -357312*y**3+200248*y**4-23664*y**5-27374*y**6+12456*y**7-1493*y**8
          +132*y**9)-2*r**6*(-1+y)**2*(2889-3267*y+594*y**2-12792*y**3+6514*y**4
          +19571*y**5-20355*y**6+2755*y**7+2802*y**8-743*y**9+42*y**10)-r**4*(
          -1+y)**3*(-13077+18225*y-3834*y**2-2898*y**3+13500*y**4-18312*y**5
          +2344*y**6+4776*y**7-657*y**8-387*y**9+80*y**10)+2*r**10*(24246-109044*y
          +189540*y**2-111960*y**3-67905*y**4+123996*y**5-54281*y**6+2049*y**7
          +4518*y**8-1113*y**9+104*y**10)+r**8*(5517-4734*y-58077*y**2+245952*y**3
          -419614*y**4+325708*y**5-64456*y**6-70820*y**7+52441*y**8-12558*y**9
          +573*y**10+68*y**11))-48*logy*r**4*(-1+y)*(-1+r**2+y)**3*(21*r**20*(
          -1+y)**7+r**18*(-1+y)**3*(1899-7227*y+10134*y**2-5916*y**3+1199*y**4
          +58*y**5)+r**16*(-20670+138246*y-393894*y**2+611556*y**3-552678*y**4
          +286057*y**5-73999*y**6+3941*y**7+1417*y**8+24*y**9)+r**14*(-132702
          +808440*y-2052756*y**2+2719062*y**3-1864599*y**4+427690*y**5+236693*y**6
          -175502*y**7+33497*y**8+178*y**9-y**10)-(-1+y)**6*(-36-72*y-108*y**2
          +324*y**3+19*y**4+130*y**5+373*y**6-420*y**7-47*y**8-122*y**9+103*y**10
          +16*y**11)-r**2*(-1+y)**5*(2571+2031*y+1815*y**2-14481*y**3+8679*y**4
          -3422*y**5-6353*y**6+14234*y**7-6038*y**8+419*y**9-74*y**10+139*y**11)
          -r**6*(-1+y)**3*(115182-226854*y+103500*y**2+68502*y**3-246339*y**4
          +256903*y**5-29479*y**6-115169*y**7+60277*y**8-3709*y**9-1125*y**10
          +151*y**11)+r**12*(-22464+176436*y-634446*y**2+956208*y**3-473937*y**4
          -274961*y**5+433928*y**6-191222*y**7+26071*y**8+4163*y**9-792*y**10
          +256*y**11)-r**4*(-1+y)**4*(-16869+5355*y+495*y**2+4281*y**3+42957*y**4
          -38323*y**5-16002*y**6+1888*y**7+18106*y**8-5406*y**9-643*y**10+321*y**11)
          +r**8*(-1+y)**2*(-91734+348006*y-371580*y**2-347058*y**3+807447*y**4
          -309263*y**5-163712*y**6+121436*y**7+9853*y**8-15433*y**9-470*y**10
          +388*y**11)+r**10*(-150288+556692*y-483678*y**2-1249350*y**3+3522795*y**4
          -3348056*y**5+930350*y**6+705992*y**7-683976*y**8+227344*y**9-26012*y**10
          -2398*y**11+585*y**12))+(-1+r**2+y)**4*(3*r**26*(-1+y)**8+4*r**24*(
          -1+y)**4*(-21+81*y-114*y**2+78*y**3-25*y**4+4*y**5)-4*(-1+y)**9*y**3*(
          -18-35*y-35*y**2-17*y**3-7*y**4-25*y**5+11*y**6+5*y**7+y**8)+2*r**22*(
          -1+y)**2*(-1713+9936*y-23880*y**2+29760*y**3-19682*y**4+6012*y**5
          -252*y**6-204*y**7+11*y**8)-4*r**20*(36609-273339*y+882087*y**2-1595379*y**3
          +1754237*y**4-1185165*y**5+465210*y**6-85228*y**7-586*y**8+1386*y**9
          +183*y**10+9*y**11)-r**2*(-1+y)**8*(-3-12*y-30*y**2-972*y**3-1269*y**4
          -1096*y**5+152*y**6-632*y**7-1177*y**8+52*y**9-266*y**10-28*y**11
          +y**12)-r**18*(510627-3600468*y+10929774*y**2-18091476*y**3+17064021*y**4
          -8342312*y**5+857160*y**6+1102712*y**7-470975*y**8+30076*y**9+9018*y**10
          +1212*y**11+151*y**12)-4*r**4*(-1+y)**6*(-1875-3321*y-4554*y**2+14436*y**3
          +202*y**4+7578*y**5+9799*y**6-12487*y**7-2276*y**8-5422*y**9+4155*y**10
          -513*y**11-83*y**12+y**13)+2*r**6*(-1+y)**5*(-77391-29829*y-17886*y**2
          +322782*y**3-267313*y**4+50969*y**5+103576*y**6-356512*y**7+236683*y**8
          +441*y**9-17594*y**10+1154*y**11+517*y**12+3*y**13)+4*r**8*(-1+y)**4*(72471
          -71427*y+20274*y**2+317958*y**3-1080125*y**4+802214*y**5+201682*y**6
          -439522*y**7+68389*y**8+43521*y**9+952*y**10-784*y**11+301*y**12+16*y**13)
          +8*r**12*(-1+y)**2*(-991185+3584877*y-4180038*y**2-431580*y**3+4525250*y**4
          -2825336*y**5-346060*y**6+952078*y**7-332638*y**8+10146*y**9+7634*y**10
          +2218*y**11-403*y**12+17*y**13)-4*r**16*(842322-5535642*y+15304908*y**2
          -22322586*y**3+16874507*y**4-3503432*y**5-4537480*y**6+4038664*y**7
          -1297192*y**8+121470*y**9+15620*y**10-1598*y**11+635*y**12+44*y**13)
          +r**10*(-1+y)**3*(-3267933+7922841*y-5097030*y**2+157974*y**3+1601441*y**4
          -1550597*y**5-803572*y**6+2742532*y**7-2024755*y**8+356151*y**9+91610*y**10
          -602*y**11-529*y**12+149*y**13)-4*r**14*(-1204449+7738806*y-20194599*y**2
          +28674012*y**3-23593381*y**4+8900570*y**5+3241099*y**6-6361024*y**7
          +3802927*y**8-1158914*y**9+141797*y**10+19244*y**11-7097*y**12+1002*y**13
          +7*y**14))))/(933120*logy**4*r**16*(-1+y)**8+311040*logy**3*r**12*(-1+y)**6*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))+38880*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          +2160*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**3+45*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**4))
      resNP += ((mupi*(311040*logy**4*r**14*(4+7*r**2+7*r**4+4*r**6)*(
          -1+y)**8-6912*logy**3*r**10*(-1+y)**4*(6*r**14*(-1+y)**4+15*r**12*(-13
          +52*y-78*y**2+48*y**3-25*y**4+4*y**5)-5*r**2*(-1+y)**4*(-39+108*y**3
          -134*y**4+32*y**5)-2*(-1+y)**4*(3+90*y**3-130*y**4+32*y**5)+r**10*(
          -879+2796*y-2754*y**2+36*y**3+641*y**4-220*y**5-10*y**6)+5*r**8*(
          -78+60*y+414*y**2-804*y**3+313*y**4+88*y**5-83*y**6+12*y**7)+5*r**6*(78
          -564*y+1350*y**2-1272*y**3+179*y**4+348*y**5-155*y**6-12*y**7+12*y**8)
          +r**4*(879-4236*y+7794*y**2-6036*y**3+1519*y**4-884*y**5+2326*y**6
          -1924*y**7+626*y**8-64*y**9))-288*logy**2*r**6*(-1+y)**2*(-1+r**2+y)**2*(18*r**18*(
          -1+y)**6+9*r**16*(-1+y)**2*(7-32*y+58*y**2-60*y**3-y**4+4*y**5)
          -r**14*(-1+y)**2*(1593-6642*y+10368*y**2-6840*y**3+4549*y**4-998*y**5
          +70*y**6)+2*(-1+y)**5*(-9-9*y-9*y**2+75*y**3-17*y**4+47*y**5+167*y**6
          -333*y**7+128*y**8)+r**12*(-15759+84402*y-182628*y**2+188382*y**3
          -109892*y**4+54138*y**5-21734*y**6+2754*y**7-359*y**8+96*y**9)+r**2*(
          -1+y)**4*(63+36*y+36*y**2+1908*y**3-3544*y**4+900*y**5-1778*y**6
          +4612*y**7-2665*y**8+512*y**9)+r**10*(-54009+268524*y-526662*y**2
          +458028*y**3-162072*y**4+49404*y**5-59206*y**6+29544*y**7-3717*y**8
          -528*y**9+94*y**10)+r**6*(-1+y)**2*(-15759+41670*y-33066*y**2+53688*y**3
          -201854*y**4+262052*y**5-143448*y**6+26452*y**7+3477*y**8-1322*y**9
          +150*y**10)+r**4*(-1+y)**3*(1593-1323*y-270*y**2-32742*y**3+81450*y**4
          -69702*y**5+22676*y**6-5196*y**7+4707*y**8-1929*y**9+256*y**10)+r**8*(
          -54009+271566*y-540351*y**2+499212*y**3-267946*y**4+272404*y**5-345166*y**6
          +221920*y**7-60233*y**8+270*y**9+2529*y**10-196*y**11))-48*logy*r**4*(
          -1+y)*(-1+r**2+y)**3*(15*r**20*(-1+y)**7+r**18*(-1+y)**3*(672-2517*y
          +3456*y**2-2118*y**3+158*y**4+55*y**5)+r**16*(3801-25518*y+72270*y**2
          -109386*y**3+102759*y**4-71489*y**5+38000*y**6-11236*y**7+682*y**8
          +117*y**9)+r**14*(17520-113838*y+312138*y**2-455058*y**3+409344*y**4
          -275171*y**5+149669*y**6-50378*y**7+7136*y**8-1619*y**9+257*y**10)
          +(-1+y)**6*(-15-30*y-45*y**2+120*y**3+107*y**4+254*y**5+563*y**6
          -480*y**7-100*y**8-232*y**9+146*y**10+32*y**11)+r**8*(-1+y)**2*(114198
          -373746*y+403242*y**2-274212*y**3+1090572*y**4-1851989*y**5+1232092*y**6
          -295219*y**7-55718*y**8+37895*y**9-3050*y**10+175*y**11)+r**2*(-1+y)**5*(672
          +501*y+438*y**2-2997*y**3+192*y**4-3265*y**5-10390*y**6+22819*y**7
          -10012*y**8+1408*y**9-628*y**10+302*y**11)+r**12*(114198-654036*y
          +1524402*y**2-1661130*y**3+903498*y**4-429599*y**5+334958*y**6-137777*y**7
          +7576*y**8-421*y**9-456*y**10+307*y**11)+r**6*(-1+y)**3*(-17520+26322*y
          -5832*y**2+309924*y**3-966990*y**4+971021*y**5-394496*y**6+31961*y**7
          -3334*y**8+17041*y**9-5124*y**10+707*y**11)+r**4*(-1+y)**4*(3801-1089*y
          -1017*y**2-66657*y**3+109644*y**4-56579*y**5+36588*y**6-82909*y**7
          +64859*y**8-13104*y**9-1979*y**10+762*y**11)+r**10*(300576-1653168*y
          +3666276*y**2-3752202*y**3+1594332*y**4-439817*y**5+782723*y**6-680851*y**7
          +183009*y**8+11605*y**9-15227*y**10+2657*y**11+87*y**12))-(-1+r**2
          +y)**4*(3*r**26*(-1+y)**8+r**24*(-1+y)**4*(-81+312*y-438*y**2+300*y**3
          -89*y**4+20*y**5)+2*r**22*(-1+y)**2*(2037-11706*y+27654*y**2-34698*y**3
          +24314*y**4-8970*y**5+1512*y**6-198*y**7+31*y**8)-(-1+y)**9*(3+15*y
          +45*y**2+9*y**3-70*y**4-190*y**5-190*y**6-134*y**7-53*y**8+55*y**9
          +25*y**10+5*y**11)+2*r**20*(4173-24888*y+57897*y**2-58446*y**3-22280*y**4
          +152016*y**5-202338*y**6+127036*y**7-37097*y**8+4248*y**9-483*y**10
          +66*y**11)-r**2*(-1+y)**8*(81+312*y+750*y**2-336*y**3-1257*y**4-2288*y**5
          -560*y**6-736*y**7-605*y**8-136*y**9-430*y**10-80*y**11+5*y**12)+r**18*(
          -220743+1567104*y-4731882*y**2+7692744*y**3-7425009*y**4+4690480*y**5
          -2143128*y**6+577520*y**7+67219*y**8-80816*y**9+8322*y**10-1080*y**11
          +229*y**12)-4*r**12*(-1+y)**2*(777921-2864070*y+3614526*y**2-955872*y**3
          +1307737*y**4-4997254*y**5+4501666*y**6-1476400*y**7+81085*y**8+164118*y**9
          -61052*y**10+10424*y**11-2771*y**12+22*y**13)-2*r**4*(-1+y)**6*(-2037
          -3558*y-4758*y**2+15528*y**3+9163*y**4+22398*y**5+30898*y**6-31504*y**7
          -6125*y**8-19078*y**9+13020*y**10-912*y**11-497*y**12+22*y**13)-2*r**6*(
          -1+y)**5*(4173-4323*y-3798*y**2+62274*y**3-18211*y**4+7157*y**5-252542*y**6
          +676514*y**7-409283*y**8+27549*y**9+8692*y**10+4604*y**11-2087*y**12
          +81*y**13)+r**16*(-101355+654012*y-1859742*y**2+2943828*y**3-4083697*y**4
          +6448960*y**5-7809400*y**6+5525992*y**7-2140513*y**8+549468*y**9-134170*y**10
          +4036*y**11+365*y**12+296*y**13)-r**8*(-1+y)**4*(220743-198840*y-57042*y**2
          -2682012*y**3+5933881*y**4-3648244*y**5+1499308*y**6-1791544*y**7+1875457*y**8
          -579216*y**9-96554*y**10+45908*y**11-9521*y**12+316*y**13)-r**10*(-1
          +y)**3*(-101355+258183*y-276426*y**2+5988330*y**3-23435713*y**4+29337133*y**5
          -14489236*y**6+731620*y**7+2276075*y**8-307623*y**9-291826*y**10+68290*y**11
          -13135*y**12+323*y**13)+4*r**14*(-777921+4915140*y-12844341*y**2+16120944*y**3
          -9092359*y**4+1362224*y**5+219211*y**6-311596*y**7+860005*y**8-542312*y**9
          +107153*y**10-14212*y**11-3221*y**12+1236*y**13+49*y**14))))/(2488320*logy**4*r**16*(
          -1+y)**8+829440*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+103680*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+5760*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +120*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((rhoLS*(103680*logy**4*r**12*(-16+36*r**2+77*r**4+69*r**6+12*r**8)*(
          -1+y)**8-6912*logy**3*r**8*(-1+y)**4*(258*r**16*(-1+y)**4+8*(-1+y)**5*(
          -1-y-y**2-6*y**3+4*y**4)+4*r**14*(-64+256*y-384*y**2+421*y**3
          -229*y**4+45*y**5)-2*r**2*(-1+y)**4*(-8+110*y**3-175*y**4+48*y**5)
          -2*r**12*(1453-5452*y+7458*y**2-4912*y**3+1313*y**4-80*y**5+25*y**6)
          -r**4*(-1+y)**3*(-604+1564*y-480*y**2-1180*y**3+1415*y**4-771*y**5
          +176*y**6)+5*r**8*(444-2700*y+5898*y**2-5912*y**3+2659*y**4-188*y**5
          -193*y**6+28*y**7)+r**10*(-2498+5852*y-498*y**2-7748*y**3+7207*y**4
          -1680*y**5-305*y**6+60*y**7)+r**6*(3762-17208*y+30132*y**2-24728*y**3
          +7437*y**4+2728*y**5-2832*y**6+728*y**7+13*y**8-32*y**9))-288*logy**2*r**4*(
          -1+y)**2*(-1+r**2+y)**2*(90*r**20*(-1+y)**6-r**18*(-1+y)**2*(-2717
          +11048*y-17022*y**2+11444*y**3-3221*y**4+252*y**5)+8*(-1+y)**7*(3
          +9*y+18*y**2+4*y**3-5*y**4-17*y**5+8*y**6)-r**16*(-1+y)**2*(-29333
          +104370*y-133708*y**2+61432*y**3+55*y**4-5122*y**5+206*y**6)+2*r**2*(
          -1+y)**5*(-19+5*y+29*y**2+201*y**3-159*y**4-55*y**5-159*y**6+117*y**7)
          +r**4*(-1+y)**4*(-2227+604*y+244*y**2-260*y**3+5096*y**4-5428*y**5
          +1166*y**6+1196*y**7-535*y**8+64*y**9)+r**6*(-1+y)**4*(-12367-2122*y
          -2152*y**2+34130*y**3-53156*y**4+28022*y**5-5234*y**6+1846*y**7-1035*y**8
          +128*y**9)+r**14*(-45817+229342*y-432996*y**2+425770*y**3-240828*y**4
          +71926*y**5-9454*y**6+6094*y**7-4061*y**8+624*y**9)+r**8*(-1+y)**2*(23099
          -114814*y+145094*y**2+56720*y**3-262778*y**4+274620*y**5-154912*y**6
          +43396*y**7-2409*y**8-1190*y**9+174*y**10)+r**12*(-208207+1086228*y
          -2235606*y**2+2346668*y**3-1244360*y**4+163436*y**5+161058*y**6-82912*y**7
          +17425*y**8-3456*y**9+326*y**10)+r**10*(-171115+891146*y-1873773*y**2
          +2080196*y**3-1252078*y**4+276004*y**5+129446*y**6-106776*y**7+34765*y**8
          -9646*y**9+1947*y**10-116*y**11))-48*logy*r**2*(-1+y)*(-1+r**2+y)**3*(36*r**22*(
          -1+y)**7+2*r**20*(-1+y)**3*(2669-10190*y+14340*y**2-8360*y**3+1654*y**4
          +34*y**5)+2*(-1+y)**8*(7+28*y+70*y**2+64*y**3+28*y**4-52*y**5-26*y**6
          -16*y**7+17*y**8)+r**18*(-45062+297872*y-837186*y**2+1272794*y**3
          -1109233*y**4+537449*y**5-121164*y**6+1788*y**7+2717*y**8+25*y**9)
          +r**16*(-213314+1258826*y-3071454*y**2+3782364*y**3-2128694*y**4-64727*y**5
          +734157*y**6-350256*y**7+53240*y**8-511*y**9+369*y**10)+r**2*(-1+y)**6*(530
          +814*y+996*y**2-3320*y**3-797*y**4-966*y**5+4883*y**6-2688*y**7-157*y**8
          +240*y**9+9*y**10+16*y**11)+r**4*(-1+y)**5*(218-1582*y-2518*y**2
          -5046*y**3+7688*y**4-381*y**5+8722*y**6-10485*y**7+3058*y**8+1119*y**9
          -880*y**10+207*y**11)+r**6*(-1+y)**4*(48708-25578*y-5856*y**2-50306*y**3
          +23122*y**4+43925*y**5-19474*y**6-37121*y**7+29210*y**8-2167*y**9-2622*y**10
          +559*y**11)+r**8*(-1+y)**3*(-104596+132454*y-30036*y**2+342926*y**3
          -929946*y**4+1152887*y**5-699920*y**6+188239*y**7-38454*y**8+21947*y**9
          -6376*y**10+715*y**11)+r**10*(-1+y)**2*(-231212+1025542*y-1370300*y**2
          -233046*y**3+1967764*y**4-2061351*y**5+1292708*y**6-452949*y**7+2060*y**8
          +46833*y**9-11372*y**10+963*y**11)+r**14*(709312-4009810*y+8992476*y**2
          -10437074*y**3+6378822*y**4-1333829*y**5-676558*y**6+389441*y**7+24114*y**8
          -40769*y**9+898*y**10+1217*y**11)+r**12*(1169940-6863658*y+16388406*y**2
          -20672546*y**3+13799364*y**4-2356955*y**5-3908727*y**6+3661235*y**7
          -1535621*y**8+357369*y**9-33227*y**10-7037*y**11+1457*y**12))+(-1
          +r**2+y)**4*(9*r**26*(-1+y)**8+r**24*(-1+y)**4*(-163+616*y-834*y**2
          +580*y**3-219*y**4+44*y**5)+2*r**22*(-1+y)**2*(-4669+27458*y-67086*y**2
          +85146*y**3-57582*y**4+18570*y**5-1664*y**6-210*y**7+13*y**8)-2*r**20*(187605
          -1390848*y+4447721*y**2-7936750*y**3+8537532*y**4-5549560*y**5+2016490*y**6
          -290060*y**7-34181*y**8+12648*y**9-639*y**10+138*y**11)+r**18*(-726061
          +4926368*y-14375198*y**2+22284216*y**3-18270211*y**4+5782672*y**5+1872488*y**6
          -1746256*y**7+106897*y**8+190416*y**9-47146*y**10+3608*y**11-833*y**12)
          +(-1+y)**8*(33+132*y+330*y**2+372*y**3+323*y**4+120*y**5-48*y**6
          -184*y**7-261*y**8+132*y**9+6*y**10+4*y**11+y**12)+r**2*(-1+y)**7*(
          -629-1347*y-1950*y**2+7334*y**3+8805*y**4+11771*y**5-9808*y**6-2176*y**7
          -5519*y**8+6519*y**9-1090*y**10-310*y**11-81*y**12+y**13)+2*r**4*(
          -1+y)**6*(15683+19634*y+20658*y**2-98048*y**3+11319*y**4+5438*y**5
          +110082*y**6-90312*y**7-1789*y**8+14698*y**9-2300*y**10+208*y**11-485*y**12
          +14*y**13)+2*r**6*(-1+y)**5*(-11691-67923*y-79414*y**2-90758*y**3
          +257529*y**4-48079*y**5+243010*y**6-387454*y**7+181709*y**8+19333*y**9
          -42508*y**10+12292*y**11-2459*y**12+93*y**13)+4*r**12*(-1+y)**2*(-1470103
          +6379266*y-9302266*y**2+781568*y**3+9582085*y**4-7856158*y**5+1365418*y**6
          +886232*y**7-631579*y**8+220382*y**9-66172*y**10+33808*y**11-6639*y**12
          +158*y**13)+r**8*(-1+y)**4*(1954955-2131992*y-157450*y**2-1867084*y**3
          +3130213*y**4-724948*y**5-161540*y**6-2291800*y**7+2654909*y**8-576016*y**9
          -234946*y**10+93796*y**11-14109*y**12+572*y**13)+r**10*(-1+y)**3*(-497711
          -169509*y+176542*y**2+8965282*y**3-23850109*y**4+36371353*y**5-31256068*y**6
          +10427380*y**7+1034959*y**8-706811*y**9-289514*y**10+154106*y**11-24819*y**12
          +919*y**13)-r**16*(5377417-34802388*y+94473706*y**2-132490748*y**3
          +88162211*y**4+2356960*y**5-49142152*y**6+36678568*y**7-12709157*y**8
          +2375116*y**9-299762*y**10+20564*y**11+585*y**12+1000*y**13)-4*r**14*(
          -7078889+44796188*y-116242805*y**2+158697744*y**3-112825163*y**4+19041176*y**5
          +36762655*y**6-34389988*y**7+13495869*y**8-2385432*y**9+126897*y**10
          +15988*y**11-17969*y**12+3652*y**13+77*y**14))))/(2488320*logy**4*r**16*(
          -1+y)**8+829440*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+103680*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+5760*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +120*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((rhoD*(103680*logy**4*r**10*(144+484*r**2+544*r**4+391*r**6+207*r**8
          +36*r**10)*(-1+y)**9+6912*logy**3*r**6*(-1+y)**4*(486*r**18*(-1+y)**5
          +36*(-1+y)**7*(-3-6*y-9*y**2+8*y**3)+r**2*(-1+y)**6*(997+997*y
          +997*y**2-1783*y**3+912*y**4)+5*r**4*(-1+y)**5*(-3049+1728*y+864*y**2
          +208*y**3-441*y**4+192*y**5)+r**16*(-1463+7315*y-14630*y**2+13010*y**3
          -5875*y**4+743*y**5+180*y**6)-15*r**14*(39-51*y-258*y**2+994*y**3
          -981*y**4+457*y**5-102*y**6+6*y**7)+r**6*(-1+y)**3*(-21343+71726*y
          -64903*y**2+1760*y**3+18655*y**4-4742*y**5-961*y**6+528*y**7)+r**10*(
          -17013+61605*y-64560*y**2-15740*y**3+72295*y**4-46427*y**5+7460*y**6
          +2180*y**7-520*y**8)+r**12*(-13027+52715*y-74380*y**2+27380*y**3+26395*y**4
          -29963*y**5+10010*y**6-510*y**7-180*y**8)+r**8*(-5119-7045*y+95690*y**2
          -197590*y**3+154330*y**4-11522*y**5-56320*y**6+35100*y**7-8025*y**8
          +405*y**9+96*y**10))-288*logy**2*r**4*(-1+y)**2*(-90*r**24*(-1+y)**7+r**22*(
          -1+y)**2*(4595-22975*y+45950*y**2-44582*y**3+22975*y**4-5459*y**5
          +360*y**6)-6*(-1+y)**9*(41+82*y+123*y**2-236*y**3-21*y**4-62*y**5
          -83*y**6+96*y**7)+r**20*(-1+y)**2*(71527-322643*y+557806*y**2-424806*y**3
          +113075*y**4+31721*y**5-19540*y**6+1260*y**7)-4*r**2*(-1+y)**8*(-5093
          -3149*y-2177*y**2+26445*y**3-19258*y**4+590*y**5+2856*y**6-646*y**7
          +192*y**8)+r**4*(-1+y)**7*(-77755+71784*y+35892*y**2+149264*y**3-312990*y**4
          +147576*y**5-3454*y**6-12528*y**7-21*y**8+192*y**9)+6*r**18*(-7028
          +66752*y-261702*y**2+594050*y**3-802454*y**4+640882*y**5-291457*y**6
          +61547*y**7+2589*y**8-2839*y**9+60*y**10)+3*r**6*(-1+y)**5*(-251997
          +869874*y-904497*y**2-16736*y**3+570174*y**4-252740*y**5-67824*y**6
          +65564*y**7-11533*y**8+446*y**9-619*y**10+128*y**11)-6*r**12*(-1+y)**2*(17547
          -291891*y+953412*y**2-1134860*y**3+340372*y**4+412784*y**5-414299*y**6
          +116563*y**7+2070*y**8+1138*y**9-2466*y**10+170*y**11)+2*r**10*(-1
          +y)**3*(758814-3219540*y+4610358*y**2-1748420*y**3-1805518*y**4+1964256*y**5
          -418205*y**6-215308*y**7+104730*y**8-11432*y**9-895*y**10+540*y**11)
          +2*r**8*(-1+y)**4*(-66891-567675*y+2242917*y**2-2267411*y**3-129228*y**4
          +1587312*y**5-932643*y**6+103473*y**7+51904*y**8-6996*y**9-3227*y**10
          +645*y**11)-2*r**16*(77133-560991*y+1717803*y**2-2884841*y**3+2618399*y**4
          -979845*y**5-240704*y**6+380744*y**7-160443*y**8+36721*y**9-6184*y**10
          +1008*y**11)-2*r**14*(-511275+3109953*y-7912017*y**2+10839683*y**3
          -8456642*y**4+3378870*y**5-210477*y**6-273033*y**7+16757*y**8-4883*y**9
          +35870*y**10-14186*y**11+1380*y**12))+48*logy*(-1+y)*(-1+r**2+y)**2*(21*r**26*(
          -1+y)**8+r**24*(-1+y)**3*(-6097+29447*y-56320*y**2+51202*y**3-23567*y**4
          +3961*y**5+198*y**6)+r**2*(-1+y)**9*(-121-357*y-702*y**2-506*y**3
          -356*y**4-72*y**5-262*y**6+262*y**7+185*y**8+9*y**9)-3*(-1+y)**10*(1
          +4*y+10*y**2+8*y**3+12*y**4+20*y**5+10*y**6-8*y**7-33*y**8+16*y**9)
          +r**22*(116888-890040*y+2938905*y**2-5432840*y**3+6144096*y**4-4369560*y**5
          +1905466*y**6-450168*y**7+33720*y**8+3296*y**9+237*y**10)+r**20*(660380
          -4557208*y+13281515*y**2-20603936*y**3+17291820*y**4-5789080*y**5-2491438*y**6
          +3330896*y**7-1308016*y**8+180736*y**9+4715*y**10-384*y**11)-r**4*(
          -1+y)**8*(7388+11588*y+14085*y**2-42768*y**3+10720*y**4+2064*y**5
          -17540*y**6+18604*y**7-6680*y**8-1160*y**9+591*y**10+48*y**11)+2*r**12*(
          -1+y)**3*(622752-5539150*y+14461889*y**2-14643803*y**3+2286502*y**4
          +7210918*y**5-6019249*y**6+1462123*y**7+239766*y**8-125304*y**9+22958*y**10
          -10518*y**11+396*y**12)+r**18*(-677625+5234600*y-17413207*y**2+34645780*y**3
          -43307840*y**4+32507992*y**5-12651772*y**6+743992*y**7+1450845*y**8
          -605256*y**9+72551*y**10+5724*y**11+576*y**12)-r**6*(-1+y)**6*(301312
          -235828*y-70237*y**2-1460302*y**3+2953307*y**4-1629004*y**5-155660*y**6
          +399668*y**7-109152*y**8+7616*y**9-243*y**10-1870*y**11+873*y**12)
          +2*r**14*(-1+y)**2*(4227828-19268198*y+33129825*y**2-23857198*y**3
          +465793*y**4+10361826*y**5-5742403*y**6+280304*y**7+405763*y**8+22268*y**9
          +11168*y**10-25846*y**11+3150*y**12)-r**8*(-1+y)**5*(-443265+1256945*y
          -754263*y**2+830005*y**3-3590518*y**4+4619916*y**5-2010998*y**6-58802*y**7
          +128417*y**8+50683*y**9-6623*y**10-11951*y**11+3294*y**12)-r**10*(-1
          +y)**4*(5742357-21664232*y+26929580*y**2-4009660*y**3-18789003*y**4
          +15308788*y**5-1602018*y**6-2635732*y**7+760061*y**8+114988*y**9-30606*y**10
          -12152*y**11+4149*y**12)+r**16*(-821709+6299858*y-20785477*y**2+39775236*y**3
          -45999544*y**4+30355712*y**5-9332840*y**6-615596*y**7+2143245*y**8-1482722*y**9
          +495241*y**10-3784*y**11-32468*y**12+4848*y**13))-(-1+r**2+y)**3*(33*r**28*(
          -1+y)**9+r**26*(-1+y)**4*(1004-4921*y+9545*y**2-9578*y**3+5158*y**4
          -1541*y**5+237*y**6)+r**24*(-1+y)**2*(-8129+54998*y-157068*y**2+258336*y**3
          -273494*y**4+196436*y**5-99136*y**6+34860*y**7-7229*y**8+618*y**9)
          +2*r**22*(351848-3009063*y+11336085*y**2-24574713*y**3+33786999*y**4
          -30666006*y**5+18493318*y**6-7229552*y**7+1736296*y**8-258063*y**9+40433*y**10
          -7435*y**11+237*y**12)+r**20*(3165419-24674097*y+83054946*y**2-153371518*y**3
          +164268433*y**4-94866891*y**5+13336372*y**6+20379672*y**7-15497227*y**8
          +4800805*y**9-645334*y**10+61942*y**11-15441*y**12-921*y**13)-3*(-1
          +y)**9*(-141-375*y-678*y**2+38*y**3-703*y**4-773*y**5+2080*y**6+2288*y**7
          +2345*y**8-6117*y**9+2614*y**10-230*y**11-45*y**12+17*y**13)-r**2*(
          -1+y)**8*(-26164-45395*y-60957*y**2+55094*y**3+39302*y**4+65423*y**5
          -49079*y**6+62096*y**7-28084*y**8-26377*y**9+25441*y**10-3574*y**11
          -1870*y**12-99*y**13+3*y**14)-r**4*(-1+y)**7*(-624055-197872*y-36115*y**2
          +3387288*y**3-3973251*y**4+837624*y**5+1561753*y**6-2373148*y**7+2067591*y**8
          -599068*y**9-156141*y**10+104644*y**11-15341*y**12-3148*y**13+39*y**14)
          -2*r**6*(-1+y)**6*(4842440-6508497*y-356787*y**2-21942022*y**3+57497570*y**4
          -41710011*y**5-91185*y**6+10283370*y**7-1280262*y**8-930377*y**9-116799*y**10
          +139740*y**11-13220*y**12-6971*y**13+51*y**14)+12*r**14*(-1+y)**2*(3472272
          -20548303*y+49472939*y**2-62974922*y**3+42201254*y**4-3577781*y**5
          -19155727*y**6+14349770*y**7-2505934*y**8-1107223*y**9+568847*y**10
          -159964*y**11+32668*y**12-2673*y**13+57*y**14)+r**8*(-1+y)**5*(-8835373
          +3596299*y+16436112*y**2+27963010*y**3-85854955*y**4+40918089*y**5
          +36733890*y**6-34511436*y**7+4126341*y**8+1469173*y**9-403276*y**10
          +208602*y**11-33757*y**12+27463*y**13+138*y**14)+3*r**10*(-1+y)**4*(
          -53723892+209907227*y-285544323*y**2+89335850*y**3+152392682*y**4-160409615*y**5
          +40454319*y**6+16149812*y**7-6837776*y**8-1706331*y**9-45757*y**10+387442*y**11
          -28374*y**12+7583*y**13+353*y**14)+3*r**12*(-1+y)**3*(-49145935+186221974*y
          -231865705*y**2+34111628*y**3+161785985*y**4-117291718*y**5-16714881*y**6
          +43450512*y**7-5488381*y**8-6378110*y**9+1168549*y**10+130388*y**11
          +36635*y**12-2338*y**13+597*y**14)-3*r**18*(-5070740+36964441*y-114187225*y**2
          +188246334*y**3-165109362*y**4+45231555*y**5+56701477*y**6-69690136*y**7
          +33768004*y**8-6758125*y**9-420763*y**10+359706*y**11-43902*y**12+5393*y**13
          +783*y**14)-3*r**16*(15186583-119297246*y+404845061*y**2-791082200*y**3
          +953276367*y**4-669152666*y**5+176640361*y**6+114503876*y**7-126884635*y**8
          +49695766*y**9-6653737*y**10-1856488*y**11+896597*y**12-127294*y**13
          +9115*y**14+540*y**15))))/(7464960*logy**4*r**16*(-1+y)**9+2488320*logy**3*r**12*(
          -1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +311040*logy**2*r**8*(-1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+17280*logy*r**4*(-1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+360*(-1+y)*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*muWC**3*(-103680*logy**4*r**10*(144
          +484*r**2+544*r**4+391*r**6+207*r**8+36*r**10)*(-1+y)**9-6912*logy**3*r**6*(
          -1+y)**4*(486*r**18*(-1+y)**5+36*(-1+y)**7*(-3-6*y-9*y**2+8*y**3)
          +r**2*(-1+y)**6*(997+997*y+997*y**2-1783*y**3+912*y**4)+5*r**4*(-1
          +y)**5*(-3049+1728*y+864*y**2+208*y**3-441*y**4+192*y**5)+r**16*(
          -1463+7315*y-14630*y**2+13010*y**3-5875*y**4+743*y**5+180*y**6)-15*r**14*(39
          -51*y-258*y**2+994*y**3-981*y**4+457*y**5-102*y**6+6*y**7)+r**6*(
          -1+y)**3*(-21343+71726*y-64903*y**2+1760*y**3+18655*y**4-4742*y**5
          -961*y**6+528*y**7)+r**10*(-17013+61605*y-64560*y**2-15740*y**3+72295*y**4
          -46427*y**5+7460*y**6+2180*y**7-520*y**8)+r**12*(-13027+52715*y-74380*y**2
          +27380*y**3+26395*y**4-29963*y**5+10010*y**6-510*y**7-180*y**8)+r**8*(
          -5119-7045*y+95690*y**2-197590*y**3+154330*y**4-11522*y**5-56320*y**6
          +35100*y**7-8025*y**8+405*y**9+96*y**10))+288*logy**2*r**4*(-1+y)**2*(
          -90*r**24*(-1+y)**7+r**22*(-1+y)**2*(4595-22975*y+45950*y**2-44582*y**3
          +22975*y**4-5459*y**5+360*y**6)-6*(-1+y)**9*(41+82*y+123*y**2-236*y**3
          -21*y**4-62*y**5-83*y**6+96*y**7)+r**20*(-1+y)**2*(71527-322643*y
          +557806*y**2-424806*y**3+113075*y**4+31721*y**5-19540*y**6+1260*y**7)
          -4*r**2*(-1+y)**8*(-5093-3149*y-2177*y**2+26445*y**3-19258*y**4+590*y**5
          +2856*y**6-646*y**7+192*y**8)+r**4*(-1+y)**7*(-77755+71784*y+35892*y**2
          +149264*y**3-312990*y**4+147576*y**5-3454*y**6-12528*y**7-21*y**8+192*y**9)
          +6*r**18*(-7028+66752*y-261702*y**2+594050*y**3-802454*y**4+640882*y**5
          -291457*y**6+61547*y**7+2589*y**8-2839*y**9+60*y**10)+3*r**6*(-1+y)**5*(
          -251997+869874*y-904497*y**2-16736*y**3+570174*y**4-252740*y**5-67824*y**6
          +65564*y**7-11533*y**8+446*y**9-619*y**10+128*y**11)-6*r**12*(-1+y)**2*(17547
          -291891*y+953412*y**2-1134860*y**3+340372*y**4+412784*y**5-414299*y**6
          +116563*y**7+2070*y**8+1138*y**9-2466*y**10+170*y**11)+2*r**10*(-1
          +y)**3*(758814-3219540*y+4610358*y**2-1748420*y**3-1805518*y**4+1964256*y**5
          -418205*y**6-215308*y**7+104730*y**8-11432*y**9-895*y**10+540*y**11)
          +2*r**8*(-1+y)**4*(-66891-567675*y+2242917*y**2-2267411*y**3-129228*y**4
          +1587312*y**5-932643*y**6+103473*y**7+51904*y**8-6996*y**9-3227*y**10
          +645*y**11)-2*r**16*(77133-560991*y+1717803*y**2-2884841*y**3+2618399*y**4
          -979845*y**5-240704*y**6+380744*y**7-160443*y**8+36721*y**9-6184*y**10
          +1008*y**11)-2*r**14*(-511275+3109953*y-7912017*y**2+10839683*y**3
          -8456642*y**4+3378870*y**5-210477*y**6-273033*y**7+16757*y**8-4883*y**9
          +35870*y**10-14186*y**11+1380*y**12))-48*logy*(-1+y)*(-1+r**2+y)**2*(21*r**26*(
          -1+y)**8+r**24*(-1+y)**3*(-6097+29447*y-56320*y**2+51202*y**3-23567*y**4
          +3961*y**5+198*y**6)+r**2*(-1+y)**9*(-121-357*y-702*y**2-506*y**3
          -356*y**4-72*y**5-262*y**6+262*y**7+185*y**8+9*y**9)-3*(-1+y)**10*(1
          +4*y+10*y**2+8*y**3+12*y**4+20*y**5+10*y**6-8*y**7-33*y**8+16*y**9)
          +r**22*(116888-890040*y+2938905*y**2-5432840*y**3+6144096*y**4-4369560*y**5
          +1905466*y**6-450168*y**7+33720*y**8+3296*y**9+237*y**10)+r**20*(660380
          -4557208*y+13281515*y**2-20603936*y**3+17291820*y**4-5789080*y**5-2491438*y**6
          +3330896*y**7-1308016*y**8+180736*y**9+4715*y**10-384*y**11)-r**4*(
          -1+y)**8*(7388+11588*y+14085*y**2-42768*y**3+10720*y**4+2064*y**5
          -17540*y**6+18604*y**7-6680*y**8-1160*y**9+591*y**10+48*y**11)+2*r**12*(
          -1+y)**3*(622752-5539150*y+14461889*y**2-14643803*y**3+2286502*y**4
          +7210918*y**5-6019249*y**6+1462123*y**7+239766*y**8-125304*y**9+22958*y**10
          -10518*y**11+396*y**12)+r**18*(-677625+5234600*y-17413207*y**2+34645780*y**3
          -43307840*y**4+32507992*y**5-12651772*y**6+743992*y**7+1450845*y**8
          -605256*y**9+72551*y**10+5724*y**11+576*y**12)-r**6*(-1+y)**6*(301312
          -235828*y-70237*y**2-1460302*y**3+2953307*y**4-1629004*y**5-155660*y**6
          +399668*y**7-109152*y**8+7616*y**9-243*y**10-1870*y**11+873*y**12)
          +2*r**14*(-1+y)**2*(4227828-19268198*y+33129825*y**2-23857198*y**3
          +465793*y**4+10361826*y**5-5742403*y**6+280304*y**7+405763*y**8+22268*y**9
          +11168*y**10-25846*y**11+3150*y**12)-r**8*(-1+y)**5*(-443265+1256945*y
          -754263*y**2+830005*y**3-3590518*y**4+4619916*y**5-2010998*y**6-58802*y**7
          +128417*y**8+50683*y**9-6623*y**10-11951*y**11+3294*y**12)-r**10*(-1
          +y)**4*(5742357-21664232*y+26929580*y**2-4009660*y**3-18789003*y**4
          +15308788*y**5-1602018*y**6-2635732*y**7+760061*y**8+114988*y**9-30606*y**10
          -12152*y**11+4149*y**12)+r**16*(-821709+6299858*y-20785477*y**2+39775236*y**3
          -45999544*y**4+30355712*y**5-9332840*y**6-615596*y**7+2143245*y**8-1482722*y**9
          +495241*y**10-3784*y**11-32468*y**12+4848*y**13))+(-1+r**2+y)**3*(33*r**28*(
          -1+y)**9+r**26*(-1+y)**4*(1004-4921*y+9545*y**2-9578*y**3+5158*y**4
          -1541*y**5+237*y**6)+r**24*(-1+y)**2*(-8129+54998*y-157068*y**2+258336*y**3
          -273494*y**4+196436*y**5-99136*y**6+34860*y**7-7229*y**8+618*y**9)
          +2*r**22*(351848-3009063*y+11336085*y**2-24574713*y**3+33786999*y**4
          -30666006*y**5+18493318*y**6-7229552*y**7+1736296*y**8-258063*y**9+40433*y**10
          -7435*y**11+237*y**12)+r**20*(3165419-24674097*y+83054946*y**2-153371518*y**3
          +164268433*y**4-94866891*y**5+13336372*y**6+20379672*y**7-15497227*y**8
          +4800805*y**9-645334*y**10+61942*y**11-15441*y**12-921*y**13)-3*(-1
          +y)**9*(-141-375*y-678*y**2+38*y**3-703*y**4-773*y**5+2080*y**6+2288*y**7
          +2345*y**8-6117*y**9+2614*y**10-230*y**11-45*y**12+17*y**13)-r**2*(
          -1+y)**8*(-26164-45395*y-60957*y**2+55094*y**3+39302*y**4+65423*y**5
          -49079*y**6+62096*y**7-28084*y**8-26377*y**9+25441*y**10-3574*y**11
          -1870*y**12-99*y**13+3*y**14)-r**4*(-1+y)**7*(-624055-197872*y-36115*y**2
          +3387288*y**3-3973251*y**4+837624*y**5+1561753*y**6-2373148*y**7+2067591*y**8
          -599068*y**9-156141*y**10+104644*y**11-15341*y**12-3148*y**13+39*y**14)
          -2*r**6*(-1+y)**6*(4842440-6508497*y-356787*y**2-21942022*y**3+57497570*y**4
          -41710011*y**5-91185*y**6+10283370*y**7-1280262*y**8-930377*y**9-116799*y**10
          +139740*y**11-13220*y**12-6971*y**13+51*y**14)+12*r**14*(-1+y)**2*(3472272
          -20548303*y+49472939*y**2-62974922*y**3+42201254*y**4-3577781*y**5
          -19155727*y**6+14349770*y**7-2505934*y**8-1107223*y**9+568847*y**10
          -159964*y**11+32668*y**12-2673*y**13+57*y**14)+r**8*(-1+y)**5*(-8835373
          +3596299*y+16436112*y**2+27963010*y**3-85854955*y**4+40918089*y**5
          +36733890*y**6-34511436*y**7+4126341*y**8+1469173*y**9-403276*y**10
          +208602*y**11-33757*y**12+27463*y**13+138*y**14)+3*r**10*(-1+y)**4*(
          -53723892+209907227*y-285544323*y**2+89335850*y**3+152392682*y**4-160409615*y**5
          +40454319*y**6+16149812*y**7-6837776*y**8-1706331*y**9-45757*y**10+387442*y**11
          -28374*y**12+7583*y**13+353*y**14)+3*r**12*(-1+y)**3*(-49145935+186221974*y
          -231865705*y**2+34111628*y**3+161785985*y**4-117291718*y**5-16714881*y**6
          +43450512*y**7-5488381*y**8-6378110*y**9+1168549*y**10+130388*y**11
          +36635*y**12-2338*y**13+597*y**14)-3*r**18*(-5070740+36964441*y-114187225*y**2
          +188246334*y**3-165109362*y**4+45231555*y**5+56701477*y**6-69690136*y**7
          +33768004*y**8-6758125*y**9-420763*y**10+359706*y**11-43902*y**12+5393*y**13
          +783*y**14)-3*r**16*(15186583-119297246*y+404845061*y**2-791082200*y**3
          +953276367*y**4-669152666*y**5+176640361*y**6+114503876*y**7-126884635*y**8
          +49695766*y**9-6653737*y**10-1856488*y**11+896597*y**12-127294*y**13
          +9115*y**14+540*y**15))))/(8398080*logy**4*r**16*(-1+y)**9+2799360*logy**3*r**12*(
          -1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +349920*logy**2*r**8*(-1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+19440*logy*r**4*(-1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+405*(-1+y)*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(103680*logy**4*r**14*(-4+7*r**4
          +8*r**6)*(-1+y)**8+6912*logy**3*r**10*(-1+y)**6*(32*r**14*(-1+y)**2+5*r**12*(21
          -42*y+21*y**2+2*y**3)-4*r**10*(-94+68*y+86*y**2-80*y**3+5*y**4)
          -2*(-1+y)**3*(17+17*y+17*y**2-38*y**3+12*y**4)-10*r**2*(-1+y)**2*(
          -4+25*y**3-19*y**4+4*y**5)+5*r**8*(-54+192*y-180*y**2+58*y**3-13*y**4
          +10*y**5)+10*r**6*(-40+80*y-40*y**2+3*y**3+6*y**4-9*y**5+4*y**6)
          +r**4*(83-406*y+443*y**2-70*y**3+60*y**4-188*y**5+86*y**6-8*y**7))
          +288*logy**2*r**6*(-1+y)**4*(-1+r**2+y)**2*(12*r**18*(-1+y)**4-3*r**16*(
          -1+y)**2*(-109+226*y-125*y**2+12*y**3)-2*r**14*(-1+y)**2*(-2445+4077*y
          -1413*y**2-219*y**3+10*y**4)+6*(-1+y)**5*(3+9*y+18*y**2+4*y**3
          -5*y**4-17*y**5+8*y**6)+4*r**2*(-1+y)**4*(-87-183*y-288*y**2+66*y**3
          +83*y**4+197*y**5-170*y**6+32*y**7)+r**12*(7179-27006*y+38763*y**2
          -23004*y**3+1691*y**4+3054*y**5-747*y**6+120*y**7)+4*r**10*(4041-10092*y
          +7365*y**2+1059*y**3-3712*y**4+1526*y**5-257*y**6+90*y**7+5*y**8)
          +2*r**6*(-1+y)**2*(-963-837*y-909*y**2+14109*y**3-13939*y**4+3409*y**5
          +513*y**6-255*y**7+42*y**8)+r**4*(-1+y)**3*(4359+2643*y+2205*y**2
          -12387*y**3+5543*y**4-901*y**5+1015*y**6-537*y**7+80*y**8)+r**8*(1839
          +2100*y-16998*y**2+37488*y**3-49812*y**4+34556*y**5-7830*y**6-2592*y**7
          +1317*y**8-68*y**9))+48*logy*r**4*(-1+y)**3*(-1+r**2+y)**3*(7*r**20*(
          -1+y)**5+3*r**18*(-1+y)**3*(211-381*y+153*y**2+5*y**3)+r**16*(-6890
          +32302*y-59804*y**2+54416*y**3-23991*y**4+3749*y**5+199*y**6+19*y**7)
          +r**14*(-44234+181012*y-277994*y**2+179586*y**3-17191*y**4-32052*y**5
          +11038*y**6-254*y**7+89*y**8)+2*(-1+y)**6*(6+24*y+60*y**2+51*y**3
          +21*y**4-42*y**5-16*y**6-13*y**7+5*y**8+4*y**9)+r**2*(-1+y)**5*(-857
          -2391*y-4530*y**2-932*y**3+985*y**4+3749*y**5-2026*y**6+204*y**7
          -148*y**8+66*y**9)+r**4*(-1+y)**4*(5623+9461*y+13134*y**2-13412*y**3
          -6945*y**4-12185*y**5+16566*y**6-4328*y**7-298*y**8+184*y**9)+r**12*(
          -7488+43836*y-116322*y**2+132936*y**3-36957*y**4-43017*y**5+34630*y**6
          -9236*y**7+1237*y**8+221*y**9)+r**6*(-1+y)**3*(-38394-1170*y+1554*y**2
          +121788*y**3-101625*y**4+15363*y**5+434*y**6+3140*y**7-1309*y**8+259*y**9)
          +r**8*(-1+y)**2*(-30578+54846*y+16410*y**2-218476*y**3+252473*y**4
          -72479*y**5-24278*y**6+14448*y**7-1751*y**8+265*y**9)+r**10*(-50096
          +85372*y+59614*y**2-235262*y**3+191435*y**4-26252*y**5-50425*y**6
          +32098*y**7-7211*y**8+452*y**9+275*y**10))-r**2*(-1+y)**2*(-1+r**2
          +y)**4*(r**24*(-1+y)**6+4*r**22*(-1+y)**4*(-7+13*y-5*y**2+y**3)-2*r**20*(
          -1+y)**2*(571-2170*y+3049*y**2-1788*y**3+279*y**4+34*y**5+3*y**6)
          -4*r**18*(12203-66707*y+148412*y**2-170346*y**3+103908*y**4-29262*y**5
          +1002*y**6+766*y**7-9*y**8+17*y**9)+r**16*(-170209+859738*y-1753573*y**2
          +1798472*y**3-895558*y**4+119060*y**5+48022*y**6+288*y**7-6169*y**8
          -54*y**9-177*y**10)+(-1+y)**7*(-1-5*y-15*y**2+93*y**3+202*y**4
          +210*y**5+34*y**6-54*y**7+63*y**8-37*y**9-11*y**10+y**11)+4*r**2*(
          -1+y)**6*(625+2357*y+5607*y**2+5137*y**3+2648*y**4-3012*y**5-1226*y**6
          -1132*y**7+843*y**8+71*y**9-41*y**10+3*y**11)+8*r**10*(-1+y)**2*(-330395
          +534169*y+5387*y**2-566955*y**3+427566*y**4-42270*y**5-69638*y**6
          +26596*y**7-7427*y**8+1565*y**9-753*y**10+15*y**11)-8*r**14*(140387
          -641833*y+1126765*y**2-846561*y**3+49056*y**4+345336*y**5-219946*y**6
          +50570*y**7-4675*y**8+709*y**9+165*y**10+27*y**11)+2*r**4*(-1+y)**5*(
          -25797-61537*y-103239*y**2+28885*y**3+57712*y**4+101608*y**5-90498*y**6
          +8970*y**7+105*y**8+2149*y**9-467*y**10+29*y**11)+4*r**6*(-1+y)**4*(24157
          +24505*y+31611*y**2-102063*y**3-15018*y**4-64986*y**5+129566*y**6
          -49774*y**7-2227*y**8+3545*y**9-713*y**10+37*y**11)+r**8*(-1+y)**3*(
          -1089311+462325*y+314951*y**2+3213675*y**3-4256526*y**4+865722*y**5
          +665518*y**6-236810*y**7-36659*y**8+20081*y**9-5253*y**10+207*y**11)
          -4*r**12*(-401483+1776636*y-2776778*y**2+1480012*y**3+608913*y**4-1104648*y**5
          +523798*y**6-124092*y**7+17073*y**8+676*y**9-1136*y**10+1008*y**11
          +21*y**12)))*math.log(mu0**2/r**2))/(207360*logy**4*r**16*(-1+y)**8+69120*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +8640*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+480*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+10*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(-8640*logy**3*r**10*(10+20*r**2
          +17*r**4+6*r**6)*(-1+y)**8-144*logy**2*r**6*(-1+y)**6*(155*r**12*(-1+y)**2
          +18*r**14*(-1+y)**2+r**10*(1818-2556*y+198*y**2+610*y**3-60*y**4)
          +2*(-1+y)**3*(-1-y-y**2-41*y**3+24*y**4)+10*r**8*(201-96*y-258*y**2
          +124*y**3+28*y**4)+10*r**2*(-1+y)**2*(-39+47*y**3-30*y**4+10*y**5)
          +10*r**6*(-103+566*y-643*y**2+64*y**3+140*y**4-37*y**5+9*y**6)+r**4*(
          -2583+6966*y-5283*y**2+140*y**3+705*y**4+138*y**5-131*y**6+48*y**7))
          -12*logy*r**4*(-1+y)**4*(-1+r**2+y)**2*(49*r**14*(-1+y)**4+2*r**12*(
          -1+y)**2*(586-1005*y+360*y**2+33*y**3)-r**10*(-1+y)**2*(-5415+8688*y
          -2706*y**2-920*y**3+93*y**4)-2*(-1+y)**4*(23+46*y+69*y**2+138*y**3
          +23*y**4-53*y**6+4*y**7)-2*r**8*(-20597+62840*y-61851*y**2+12064*y**3
          +13199*y**4-5694*y**5+19*y**6+30*y**7)+r**2*(-1+y)**3*(-1237-1193*y
          -1125*y**2+5351*y**3-3239*y**4+813*y**5-31*y**6+101*y**7)+2*r**4*(
          -1+y)**2*(6180-3441*y-1146*y**2-7549*y**3+7956*y**4-1959*y**5-38*y**6
          +177*y**7)+r**6*(53099-159664*y+153452*y**2-30640*y**3-24930*y**4
          +7216*y**5+1844*y**6-672*y**7+295*y**8))+(-1+y)**4*(-1+r**2+y)**3*(r**20*(
          -1+y)**4-r**18*(-1+y)**2*(45-87*y+39*y**2+5*y**3)-2*r**16*(655-2392*y
          +3162*y**2-1745*y**3+305*y**4+7*y**5+12*y**6)-2*r**14*(7067-22973*y
          +25428*y**2-9172*y**3-1545*y**4+1191*y**5-12*y**6+6*y**7)+2*r**12*(
          -17402+53024*y-54363*y**2+13768*y**3+9043*y**4-3576*y**5-335*y**6
          -138*y**7+19*y**8)+2*(-1+y)**5*(2+8*y+20*y**2+25*y**3+21*y**4+4*y**5
          -8*y**6-11*y**7-7*y**8+6*y**9)+2*r**10*(-147658+379090*y-263769*y**2
          -56529*y**3+119577*y**4-24007*y**5-7121*y**6+1697*y**7-389*y**8+9*y**9)
          -2*r**6*(-1+y)**2*(8957+3227*y+1343*y**2-35887*y**3+28653*y**4-6461*y**5
          -625*y**6+655*y**7+236*y**8+22*y**9)+r**4*(-1+y)**3*(1085+2299*y
          +3390*y**2-4446*y**3+468*y**4-1540*y**5+2110*y**6-1042*y**7-197*y**8
          +33*y**9)+r**2*(-1+y)**4*(145+423*y+822*y**2+816*y**3+488*y**4-10*y**5
          -234*y**6-144*y**7-69*y**8+43*y**9)-2*r**8*(46727-99746*y+50112*y**2
          -20880*y**3+74828*y**4-65172*y**5+10516*y**6+4518*y**7-1305*y**8+372*y**9
          +30*y**10)))*nlo.X1El(0,'SM',y/2,r))/(207360*logy**4*r**16*(-1+y)**8+69120*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +8640*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+480*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+10*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(-720*logy**2*r**7*(4+5*r**2
          +2*r**4)*(-1+y)**6-24*logy*r**3*(-1+y)**4*(8*r**10*(-1+y)**2+3*r**12*(
          -1+y)**2-5*r**8*(-44+64*y-8*y**2-13*y**3+2*y**4)+2*(-1+y)**3*(
          -1-y-y**2-6*y**3+4*y**4)+5*r**6*(26+8*y-64*y**2+21*y**3+7*y**4)
          +r**2*(-1+y)**2*(-58+35*y**3-15*y**4+8*y**5)+5*r**4*(-61+170*y-133*y**2
          +y**3+31*y**4-11*y**5+3*y**6))-r*(-1+y)**3*(-1+r**2+y)**2*(7*r**12*(
          -1+y)**3+2*r**10*(-81+214*y-174*y**2+35*y**3+6*y**4)+r**8*(-169
          +509*y-558*y**2+220*y**3+3*y**4-5*y**5)-4*r**6*(1431-2992*y+1413*y**2
          +518*y**3-447*y**4+47*y**5)+(-1+y)**3*(-13-26*y-39*y**2-54*y**3
          -9*y**4+4*y**5+17*y**6)+2*r**2*(-1+y)**2*(-61-72*y-71*y**2+319*y**3
          -256*y**4+55*y**5+26*y**6)+r**4*(-1749+2827*y-705*y**2+335*y**3-1195*y**4
          +489*y**5-47*y**6+45*y**7)))*nlo.X1El(0,'VR',y/2,r))/(-17280*logy**3*r**12*(
          -1+y)**6+10*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -4320*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-360*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1
          +y)**4-(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1
          +y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(0,'VR2',y/2,r))/(2880*logy**2*r**8*(-1+y)**4+480*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(144*logy**2*r**6*(4+7*r**2+4*r**4)*(-1+y)**6+24*logy*r**4*(-1
          +y)**4*(9*r**8*(-1+y)**2+21*r**4*y*(4-6*y+y**2+y**3)+3*r**2*(-1+y)**2*(
          -24+16*y+8*y**2+y**3)-(-1+y)**3*(-9-9*y-9*y**2+2*y**3)+r**6*(72
          -96*y+25*y**3))-(-1+y)**4*(-1+r**2+y)**2*(1+r**12*(-1+y)**2-6*y**3
          +4*y**4+8*y**6-10*y**7+3*y**8+r**10*(-30+58*y-26*y**2)-r**8*(285
          -412*y+74*y**2+62*y**3+7*y**4)-4*r**6*(383-383*y-56*y**2+84*y**3
          +15*y**4+2*y**5)+r**4*(-285+158*y+53*y**2+324*y**3-215*y**4-38*y**5
          +3*y**6)+2*r**2*(-15+y+y**2+40*y**3-17*y**4-y**5-13*y**6+4*y**7)))*nlo.X1El(1,'SM',y/2,r))/(1728*logy**3*r**12*(
          -1+y)**6-(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +432*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+36*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-24*logy*r**3*(1+r**2)*(-1
          +y)**4-4*r*(-1+y)**3*(r**6*(-1+y)+3*r**2*(-1+y)**2*(3+y)+3*r**4*(
          -3+y+y**2)+(-1+y)**2*(1+y+y**2)))*nlo.X1El(1,'VR',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(1,'VR2',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.VR2

    if wc.VLVR != 0:
      resNP = 0
      resNP +=((720*logy**2*r**7*(1+r**2+r**4)*(-1+y)**4+12*logy*r**3*(-1+y)**2*(18*r**10*(
          -1+y)**2+3*r**12*(-1+y)**2+15*r**4*(-1+y)**3*(9+y-3*y**2+y**3)
          +20*r**6*y*(6-9*y+2*y**2+y**3)+(-1+y)**4*(-3-6*y-9*y**2+8*y**3)
          -5*r**8*(-27+30*y+9*y**2-16*y**3+2*y**4)+2*r**2*(-1+y)**3*(9+9*y
          +9*y**2-11*y**3+4*y**4))+r*(-1+y)**2*(-1+r**2+y)**2*(1+r**12*(-1
          +y)**2-16*y**3+30*y**4-16*y**5+y**8+2*r**10*(63-109*y+38*y**2+3*y**3)
          +r**8*(27-20*y+34*y**2+24*y**3+15*y**4)+2*r**2*(-1+y)**2*(63+109*y
          +147*y**2-130*y**3+18*y**4+3*y**5)+4*r**6*(463-463*y-79*y**2+220*y**3
          -41*y**4+5*y**5)+r**4*(27-34*y+41*y**2-264*y**3+301*y**4-86*y**5
          +15*y**6)))/(1440*logy**2*r**8*(-1+y)**4+240*logy*r**4*(-1+y)**2*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))+10*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-17280*logy**3*r**11*(
          -1+r**2+3*r**4)*(-1+y)**6+288*logy**2*r**7*(-1+y)**4*(-46*r**12*(-1+y)**2
          -5*r**10*(17-34*y+17*y**2+2*y**3)+30*r**8*(-11+4*y+16*y**2-12*y**3
          +y**4)+10*(-1+y)**3*(5+5*y+5*y**2-12*y**3+4*y**4)-10*r**6*(-48
          +114*y-75*y**2+19*y**3-12*y**4+7*y**5)+3*r**2*(-1+y)**2*(7+60*y**3
          -45*y**4+8*y**5)-10*r**4*(-1-16*y+26*y**2-3*y**3-2*y**4-8*y**5+4*y**6))
          -24*logy*r**3*(-1+y)**2*(-1+r**2+y)**2*(3*r**16*(-1+y)**4-3*r**14*(-1
          +y)**2*(-47+96*y-51*y**2+8*y**3)-r**12*(-1+y)**2*(-2278+3740*y-1207*y**2
          -204*y**3+5*y**4)+3*(-1+y)**5*(3+9*y+18*y**2+4*y**3-5*y**4-17*y**5
          +8*y**6)-r**6*(-1+y)**2*(-1511+2404*y+1423*y**2-9220*y**3+6915*y**4
          -904*y**5-339*y**6+32*y**7)+r**2*(-1+y)**4*(-139-296*y-471*y**2+150*y**3
          +91*y**4+266*y**5-221*y**6+40*y**7)+r**4*(-1+y)**3*(2002+1098*y+821*y**2
          -5543*y**3+2932*y**4-120*y**5-191*y**6+41*y**7)+r**10*(703-3408*y
          +6959*y**2-6098*y**3+1285*y**4+930*y**5-431*y**6+80*y**7)+r**8*(3994
          -6914*y-1145*y**2+8730*y**3-5365*y**4+116*y**5+679*y**6-120*y**7
          +25*y**8))+2*r*(-1+y)**2*(-1+r**2+y)**3*(r**18*(-1+y)**4-r**16*(-1
          +y)**2*(233-427*y+173*y**2+y**3)-6*r**14*(485-1768*y+2347*y**2-1397*y**3
          +378*y**4-41*y**5+6*y**6)-(-1+y)**6*(-1-5*y-15*y**2-17*y**3-11*y**4
          +5*y**5+3*y**6+y**7)-2*r**12*(10745-33161*y+33819*y**2-8292*y**3
          -6305*y**4+3415*y**5-371*y**6+70*y**7)+r**10*(31960-91444*y+67560*y**2
          +9738*y**3-23354*y**4+3980*y**5+428*y**6+78*y**7-266*y**8)-3*r**2*(
          -1+y)**4*(-157-436*y-820*y**2-106*y**3+212*y**4+652*y**5-376*y**6
          +26*y**7+5*y**8)-2*r**4*(-1+y)**3*(593+1006*y+1524*y**2-1527*y**3
          -133*y**4-1280*y**5+1318*y**6-339*y**7+38*y**8)-2*r**6*(-1+y)**2*(
          -11527-1114*y+656*y**2+32337*y**3-25445*y**4+1422*y**5+3234*y**6
          -741*y**7+98*y**8)-6*r**8*(9660-20738*y+7976*y**2+12301*y**3-12124*y**4
          +1985*y**5+1148*y**6-141*y**7-116*y**8+49*y**9))))/(-25920*logy**3*r**12*(
          -1+y)**6+15*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -6480*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-540*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*muWC*(138240*logy**3*r**11*(-1
          +r**4)*(-1+y)**6+4608*logy**2*r**7*(-1+y)**3*(12*r**12*(-1+y)**3+2*r**10*(
          -4+12*y-12*y**2-6*y**3+5*y**4)+r**2*(-1+y)**3*(8-25*y**3+2*y**5)
          -5*r**8*(8-6*y-21*y**2+38*y**3-18*y**4+2*y**5)-(-1+y)**3*(-12+15*y**3
          -10*y**4+2*y**5)+5*r**6*(24-72*y+72*y**2-27*y**3-y**4+2*y**5)+5*r**4*(
          -8+42*y-69*y**2+53*y**3-32*y**4+24*y**5-12*y**6+2*y**7))+192*logy*r**3*(
          -1+y)*(-1+r**2+y)**2*(3*r**16*(-1+y)**5-2*r**14*(-1+y)**2*(35-108*y
          +114*y**2-38*y**3+3*y**4)-r**12*(-1+y)**2*(1070-2780*y+2217*y**2
          -305*y**3-161*y**4+11*y**5)-(-1+y)**6*(-3-9*y-18*y**2+8*y**3+3*y**4
          -5*y**5+4*y**6)-r**4*(-1+y)**3*(1070-430*y-133*y**2-894*y**3+837*y**4
          -258*y**5+177*y**6-50*y**7+y**8)-2*r**6*(-1+y)**2*(101-476*y+78*y**2
          +1894*y**3-2180*y**4+684*y**5+56*y**6-38*y**7+y**8)+2*r**2*(-1+y)**4*(35
          +38*y+41*y**2-38*y**3-35*y**4-14*y**5+39*y**6-18*y**7+2*y**8)+2*r**10*(101
          -130*y-787*y**2+1338*y**3-195*y**4-594*y**5+309*y**6-62*y**7+10*y**8)
          +r**8*y*(-2534+8869*y-14685*y**2+14455*y**3-7685*y**4+1269*y**5+511*y**6
          -225*y**7+25*y**8))+32*r*(-1+y)*(-1+r**2+y)**3*(-((-1+y)**6*y**3*(9
          +8*y-2*y**2+4*y**3+y**4))+r**16*(-1+y)**2*(-88+246*y-219*y**2+53*y**3
          +y**4)+r**14*(-512+2386*y-4415*y**2+3813*y**3-1380*y**4+98*y**5+13*y**6
          +7*y**7)+r**12*(-5568+22782*y-34707*y**2+21666*y**3-1145*y**4-4636*y**5
          +1673*y**6-166*y**7+21*y**8)+r**2*(-1+y)**4*(88+158*y+219*y**2-433*y**3
          +61*y**4+11*y**5-57*y**6+19*y**7-7*y**8+y**9)+r**4*(-1+y)**3*(-512
          -338*y-329*y**2-651*y**3+1589*y**4-19*y**5-1175*y**6+489*y**7-81*y**8
          +7*y**9)+r**6*(-1+y)**2*(5568-5058*y-741*y**2-5973*y**3+9949*y**4
          -4943*y**5+663*y**6+81*y**7-107*y**8+21*y**9)+r**10*(11240-43342*y
          +56765*y**2-32751*y**3+8419*y**4+565*y**5-1987*y**6+717*y**7-141*y**8
          +35*y**9)+r**8*(-11240+35338*y-32753*y**2-11440*y**3+40520*y**4-23300*y**5
          +202*y**6+3628*y**7-920*y**8-70*y**9+35*y**10))))/(-77760*logy**3*r**12*(
          -1+y)**6+45*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -19440*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-1620*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((muG*(8640*logy**3*r**9*(-6+7*r**2
          +9*r**4+3*r**6)*(-1+y)**6+144*logy**2*r**5*(-1+y)**3*(-186*r**14*(-1+y)**3
          +r**12*(-347+1041*y-1041*y**2+717*y**3-170*y**4)-4*(-1+y)**4*(-6
          -6*y-6*y**2-y**3+4*y**4)+2*r**10*(-757+2001*y-1596*y**2+612*y**3
          -145*y**4+35*y**5)+2*r**2*(-1+y)**3*(89-15*y**3-150*y**4+56*y**5)
          -10*r**8*(8+138*y-381*y**2+264*y**3-45*y**4-7*y**5+3*y**6)+r**4*(
          -1+y)**2*(-781+1861*y-540*y**2-1020*y**3+635*y**4-279*y**5+64*y**6)
          -10*r**6*(-269+933*y-1122*y**2+549*y**3-91*y**4-2*y**5+2*y**7))-12*logy*r*(
          -1+y)*(-1+r**2+y)**2*(21*r**18*(-1+y)**5-r**16*(-1+y)**2*(523-1611*y
          +1695*y**2-547*y**3+60*y**4)-r**14*(-1+y)**2*(7066-17822*y+13365*y**2
          -793*y**3-1367*y**4+71*y**5)+2*(-1+y)**6*(3+9*y+18*y**2+4*y**3
          -5*y**4-17*y**5+8*y**6)+r**2*(-1+y)**5*(-59-130*y-213*y**2-142*y**3
          -107*y**4-108*y**5+143*y**6+16*y**7)+r**6*(-1+y)**3*(1722-4112*y
          -1613*y**2+4864*y**3-10121*y**4+9092*y**5-2079*y**6+12*y**7+35*y**8)
          -r**8*(-1+y)**2*(15439-38547*y+18951*y**2+31065*y**3-35551*y**4+15715*y**5
          -4299*y**6+63*y**7+44*y**8)+r**4*(-1+y)**4*(431-15*y-155*y**2+201*y**3
          +755*y**4+1169*y**5-275*y**6-255*y**7+64*y**8)+r**12*(15741-64085*y
          +91243*y**2-58141*y**3+17849*y**4-2997*y**5+779*y**6-789*y**7+200*y**8)
          +r**10*(36614-159732*y+261333*y**2-211537*y**3+95213*y**4-19991*y**5
          -7345*y**6+7205*y**7-1935*y**8+175*y**9))-r*(-1+y)*(-1+r**2+y)**3*(7*r**18*(
          -1+y)**5+r**16*(-1+y)**2*(-1193+3348*y-3012*y**2+672*y**3+45*y**4)
          +2*r**14*(-3359+15331*y-27545*y**2+22436*y**3-7341*y**4+725*y**5-225*y**6
          +78*y**7)+2*r**12*(-35273+142582*y-213488*y**2+125359*y**3+6073*y**4
          -37452*y**5+12718*y**6-1509*y**7+190*y**8)-(-1+y)**5*(321+891*y
          +1674*y**2+480*y**3-144*y**4-974*y**5+374*y**6-176*y**7-49*y**8+3*y**9)
          +r**2*(-1+y)**4*(-1009-1835*y-2304*y**2+2162*y**3+4998*y**4+7616*y**5
          -4124*y**6+274*y**7+207*y**8+15*y**9)+2*r**4*(-1+y)**3*(-6689-2681*y
          -1574*y**2+3479*y**3-3046*y**4-1765*y**5+786*y**6+3393*y**7-741*y**8
          +78*y**9)+2*r**6*(-1+y)**2*(-13961+26391*y+3774*y**2-40113*y**3+55998*y**4
          -68371*y**5+29992*y**6+1679*y**7-1499*y**8+230*y**9)+2*r**10*(144212
          -554578*y+738686*y**2-403607*y**3+27670*y**4+79015*y**5-42684*y**6
          +7173*y**7-1008*y**8+321*y**9)+2*r**8*(-41204+159550*y-203822*y**2
          -21935*y**3+267155*y**4-197507*y**5+24595*y**6+17547*y**7-3755*y**8
          -975*y**9+351*y**10))))/(-103680*logy**3*r**12*(-1+y)**6+60*(r**8*(-1+y)**2
          -6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y
          -4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3-25920*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -2160*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2))
      resNP += ((api*muWC**2*(25920*logy**3*r**11*(-1+r**2+3*r**4)*(
          -1+y)**6+144*logy**2*r**7*(-1+y)**2*(138*r**12*(-1+y)**4+10*(-1+y)**4*(15
          -3*y**3-10*y**4+4*y**5)+5*r**10*(51-204*y+306*y**2-150*y**3+7*y**4
          +14*y**5)+r**2*(-1+y)**4*(-63-60*y**3-275*y**4+88*y**5)-10*r**8*(-99
          +234*y-27*y**2-408*y**3+409*y**4-138*y**5+11*y**6)-10*r**6*(144-630*y
          +1053*y**2-825*y**3+227*y**4+50*y**5-34*y**6+3*y**7)+10*r**4*(-3-42*y
          +171*y**2-357*y**3+508*y**4-481*y**5+282*y**6-88*y**7+10*y**8))+12*logy*r**3*(
          -1+r**2+y)**2*(9*r**16*(-1+y)**6-3*r**14*(-1+y)**2*(-141+570*y-870*y**2
          +570*y**3-169*y**4+16*y**5)-r**12*(-1+y)**2*(-6834+24888*y-32895*y**2
          +17370*y**3-2114*y**4-770*y**5+43*y**6)-(-1+y)**5*(-27-27*y-27*y**2
          +303*y**3-209*y**4+23*y**5+143*y**6-227*y**7+88*y**8)+r**6*(-1+y)**2*(4533
          -16278*y+14688*y**2+16746*y**3-26670*y**4+4526*y**5+8264*y**6-4130*y**7
          +289*y**8+32*y**9)-r**2*(-1+y)**4*(417+54*y+54*y**2-228*y**3-1392*y**4
          +746*y**5+554*y**6-36*y**7-169*y**8+40*y**9)-r**4*(-1+y)**3*(-6006
          +8718*y-1881*y**2-3723*y**3+9079*y**4-10207*y**5+2801*y**6+1587*y**7
          -649*y**8+41*y**9)+r**10*(2109-14442*y+43434*y**2-59088*y**3+35648*y**4
          -4406*y**5-6218*y**6+3768*y**7-773*y**8+88*y**9)+r**8*(11982-44706*y
          +50031*y**2+36798*y**3-141426*y**4+131528*y**5-48882*y**6+1906*y**7
          +3764*y**8-1102*y**9+107*y**10))-r*(-1+r**2+y)**3*(3*r**18*(-1+y)**6
          +r**16*(-1+y)**2*(-699+2679*y-3780*y**2+2220*y**3-509*y**4+5*y**5)
          +(-1+y)**7*(-3-12*y-30*y**2+138*y**3+154*y**4+48*y**5+138*y**6
          +42*y**7+5*y**8)-2*r**14*(4365-24642*y+57312*y**2-68355*y**3+43765*y**4
          -14504*y**5+1968*y**6+13*y**7+18*y**8)-2*r**12*(32235-163953*y+332658*y**2
          -328737*y**3+140360*y**4+9895*y**5-30318*y**6+8793*y**7-527*y**8+74*y**9)
          -2*r**6*(-1+y)**2*(-34581+65820*y-25929*y**2+3645*y**3-7123*y**4-3115*y**5
          +8651*y**6+2967*y**7-3980*y**8+115*y**9+10*y**10)+2*r**4*(-1+y)**3*(
          -1779+540*y-315*y**2-14709*y**3+32287*y**4-20223*y**5-5763*y**6+8149*y**7
          -1140*y**8+51*y**9+22*y**10)+r**2*(-1+y)**4*(1413+1098*y+945*y**2
          -9930*y**3+5416*y**4-2206*y**5-2092*y**6+6338*y**7-2765*y**8+316*y**9
          +27*y**10)-2*r**10*(-47940+233046*y-423612*y**2+408927*y**3-222425*y**4
          +51399*y**5+6885*y**6-4655*y**7+1473*y**8-333*y**9+115*y**10)-2*r**8*(86940
          -360522*y+532008*y**2-192741*y**3-292376*y**4+307426*y**5-46632*y**6
          -65436*y**7+38588*y**8-7272*y**9-64*y**10+81*y**11))))/(-77760*logy**3*r**12*(
          -1+y)**6+45*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -19440*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-1620*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((mupi*(-25920*logy**3*r**11*(1+r**2
          +r**4)*(-1+y)**6+144*logy**2*r**7*(-1+y)**2*(6*r**12*(-1+y)**4-2*(-1
          +y)**5*(-3-3*y-3*y**2-78*y**3+32*y**4)+r**10*(-159+636*y-954*y**2
          +606*y**3-299*y**4+50*y**5)-r**2*(-1+y)**4*(-159+240*y**3-275*y**4
          +64*y**5)-10*r**8*(51-150*y+117*y**2+54*y**3-73*y**4+18*y**5+y**6)
          +10*r**6*y*(-54+189*y-231*y**2+71*y**3+32*y**4-22*y**5+3*y**6)+10*r**4*(51
          -258*y+495*y**2-375*y**3+2*y**4+145*y**5-66*y**6+4*y**7+2*y**8))
          +12*logy*r**3*(-1+r**2+y)**2*(9*r**16*(-1+y)**6+3*r**14*(-1+y)**2*(-1
          -2*y+18*y**2-38*y**3-5*y**4+4*y**5)-r**12*(-1+y)**2*(414-1788*y
          +2913*y**2-2238*y**3+1250*y**4-262*y**5+23*y**6)+(-1+y)**5*(-9-9*y
          -9*y**2+93*y**3-23*y**4+41*y**5+41*y**6-149*y**7+64*y**8)+r**10*(
          -3321+17214*y-35550*y**2+33588*y**3-17252*y**4+9194*y**5-4618*y**6
          +684*y**7-91*y**8+32*y**9)+r**4*(-1+y)**3*(414-282*y-99*y**2-8289*y**3
          +19465*y**4-16777*y**5+5411*y**6+225*y**7-343*y**8+35*y**9)-r**6*(
          -1+y)**2*(3321-9354*y+8040*y**2-5046*y**3+22218*y**4-29842*y**5+15800*y**6
          -3002*y**7-179*y**8+44*y**9)+r**2*(-1+y)**4*(-3+18*y+18*y**2+720*y**3
          -1428*y**4+494*y**5-82*y**6+648*y**7-409*y**8+64*y**9)+r**8*(-11982
          +59910*y-118449*y**2+104526*y**3-33414*y**4+1312*y**5-4842*y**6+2642*y**7
          +652*y**8-398*y**9+43*y**10))+r*(-1+r**2+y)**3*(3*r**18*(-1+y)**6
          +r**16*(-1+y)**2*(357-1329*y+1800*y**2-1044*y**3+115*y**4+17*y**5)
          +(-1+y)**7*(-3-12*y-30*y**2+30*y**3+58*y**4+72*y**5+90*y**6+30*y**7
          +5*y**8)+2*r**14*(-1293+7254*y-16506*y**2+18987*y**3-12607*y**4+5636*y**5
          -1458*y**6+23*y**7+24*y**8)+2*r**12*(1173-6147*y+12276*y**2-9501*y**3
          -3494*y**4+11051*y**5-7536*y**6+2241*y**7-595*y**8+52*y**9)+r**2*(
          -1+y)**4*(357+258*y+213*y**2-2106*y**3-512*y**4-1606*y**5-1276*y**6
          +5426*y**7-2453*y**8+220*y**9+39*y**10)+2*r**4*(-1+y)**3*(1293-504*y
          -369*y**2-12777*y**3+18847*y**4-10575*y**5+1173*y**6-1835*y**7+2280*y**8
          -477*y**9+64*y**10)+2*r**10*(-19500+94446*y-177030*y**2+128169*y**3
          -24595*y**4-4275*y**5+8427*y**6-11569*y**7+3675*y**8-723*y**9+95*y**10)
          +2*r**6*(-1+y)**2*(1173-2064*y+27*y**2+27747*y**3-88409*y**4+92467*y**5
          -42287*y**6+525*y**7+5108*y**8-883*y**9+116*y**10)+2*r**8*(-19500+81054*y
          -123462*y**2+64863*y**3-19384*y**4+75494*y**5-94380*y**6+44880*y**7
          -11300*y**8+2172*y**9-566*y**10+129*y**11))))/(-103680*logy**3*r**12*(-1
          +y)**6+60*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -25920*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-2160*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((rhoLS*(-8640*logy**3*r**9*(-2+7*r**2
          +9*r**4+3*r**6)*(-1+y)**6+144*logy**2*r**5*(-1+y)**2*(198*r**14*(-1+y)**4
          +4*(-1+y)**5*(-1-y-y**2-6*y**3+4*y**4)-10*r**2*(-1+y)**4*(-9+25*y**3
          -30*y**4+8*y**5)+5*r**12*(-79+316*y-474*y**2+406*y**3-171*y**4+26*y**5)
          -2*r**10*(747-2718*y+3537*y**2-2148*y**3+497*y**4-30*y**5+25*y**6)
          -r**4*(-1+y)**3*(-333+693*y-180*y**2-180*y**3+55*y**4-27*y**5+32*y**6)
          +10*r**8*(18-234*y+675*y**2-785*y**3+425*y**4-76*y**5-14*y**6+3*y**7)
          -10*r**6*(-175+826*y-1491*y**2+1311*y**3-536*y**4+21*y**5+60*y**6
          -18*y**7+2*y**8))+12*logy*r*(-1+r**2+y)**2*(9*r**18*(-1+y)**6-r**16*(
          -1+y)**2*(-647+2606*y-3954*y**2+2570*y**3-731*y**4+84*y**5)+2*(
          -1+y)**7*(3+9*y+18*y**2+4*y**3-5*y**4-17*y**5+8*y**6)-r**14*(-1
          +y)**2*(-7258+25592*y-32191*y**2+14742*y**3-14*y**4-1214*y**5+31*y**6)
          -r**2*(-1+y)**5*(49+37*y+25*y**2-149*y**3-13*y**4-17*y**5+235*y**6
          -143*y**7+16*y**8)-r**8*(-1+y)**2*(-9667+33338*y-32458*y**2-6474*y**3
          +21696*y**4-11866*y**5+5262*y**6-1594*y**7-25*y**8+28*y**9)+r**4*(
          -1+y)**4*(-787+182*y+116*y**2+892*y**3-42*y**4-878*y**5+148*y**6
          +604*y**7-307*y**8+32*y**9)+r**6*(-1+y)**3*(4566-5430*y+873*y**2
          -7353*y**3+19313*y**4-18157*y**5+7167*y**6-623*y**7-279*y**8+43*y**9)
          +r**12*(-18153+93114*y-184968*y**2+186392*y**3-96694*y**4+17414*y**5
          +3824*y**6+168*y**7-1185*y**8+208*y**9)+r**10*(-30838+164946*y-352653*y**2
          +396430*y**3-241970*y**4+55148*y**5+25266*y**6-22350*y**7+7352*y**8
          -1438*y**9+107*y**10))+r*(-1+r**2+y)**3*(3*r**18*(-1+y)**6-r**16*(
          -1+y)**2*(-877+3409*y-4920*y**2+2908*y**3-615*y**4+11*y**5)-2*r**14*(
          -5483+30282*y-68364*y**2+77881*y**3-46079*y**4+13374*y**5-1574*y**6
          +15*y**7+8*y**8)+r**2*(-1+y)**5*(-1333-1655*y-1440*y**2+2042*y**3
          +2082*y**4+2524*y**5-3388*y**6+898*y**7+7*y**8+23*y**9)+2*r**12*(28269
          -139899*y+274422*y**2-252739*y**3+80584*y**4+38205*y**5-36634*y**6
          +8815*y**7-637*y**8+94*y**9)+(-1+y)**5*(165+258*y+315*y**2-1018*y**3
          -268*y**4-358*y**5+1184*y**6-598*y**7+55*y**8+20*y**9+5*y**10)+2*r**4*(
          -1+y)**3*(10405-6216*y-2535*y**2-10449*y**3+9587*y**4+4557*y**5-711*y**6
          -7843*y**7+4800*y**8-817*y**9+62*y**10)+2*r**6*(-1+y)**2*(-5283+7680*y
          -7539*y**2+33587*y**3-80197*y**4+114749*y**5-73465*y**6+9701*y**7+7072*y**8
          -2317*y**9+212*y**10)+2*r**10*(-135892+651342*y-1186944*y**2+1050969*y**3
          -392351*y**4-63249*y**5+104289*y**6-24953*y**7+291*y**8-797*y**9+295*y**10)
          +2*r**8*(43364-201546*y+341268*y**2-188643*y**3-81280*y**4+82470*y**5
          +55584*y**6-75116*y**7+25660*y**8+172*y**9-2292*y**10+359*y**11))))/(
          -103680*logy**3*r**12*(-1+y)**6+60*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)
          -2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(
          -1-y-y**2+y**3))**3-25920*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-2160*logy*r**4*(-1+y)**2*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((rhoD*(
          -8640*logy**3*r**14*(24+58*r**2+25*r**4+27*r**6+9*r**8)*(-1+y)**7-144*logy**2*r**10*(
          -1+y)**2*(366*r**16*(-1+y)**5+24*(-1+y)**7*(-3-6*y-9*y**2+8*y**3)
          +4*r**2*(-1+y)**6*(79+79*y+79*y**2-136*y**3+84*y**4)+10*r**4*(-1
          +y)**5*(-723+432*y+216*y**2-89*y**3-22*y**4+24*y**5)+5*r**14*(-169
          +845*y-1690*y**2+1480*y**3-671*y**4+91*y**5+18*y**6)-6*r**12*(-169
          +1115*y-2905*y**2+4175*y**3-3035*y**4+1139*y**5-215*y**6+15*y**7)
          +3*r**6*(-1+y)**3*(-1087+5654*y-6307*y**2+360*y**3+2665*y**4-1278*y**5
          +121*y**6+32*y**7)-2*r**10*(2406-9600*y+13125*y**2-3860*y**3-6450*y**4
          +6789*y**5-2350*y**6+135*y**7+45*y**8)+10*r**8*(-587+2485*y-3845*y**2
          +2566*y**3-495*y**4-147*y**5-53*y**6+110*y**7-40*y**8+6*y**9))+12*logy*r**8*(27*r**22*(
          -1+y)**7+r**20*(-1+y)**2*(1129-5645*y+11290*y**2-10948*y**3+5987*y**4
          -1759*y**5+234*y**6)-6*(-1+y)**9*(-5-10*y-15*y**2-26*y**3+19*y**4
          +24*y**5-51*y**6+24*y**7)+r**18*(-1+y)**2*(19245-87441*y+152922*y**2
          -122680*y**3+39117*y**4+4035*y**5-4340*y**6+390*y**7)-r**2*(-1+y)**8*(
          -4613-2885*y-2021*y**2+22837*y**3-16615*y**4+233*y**5+2665*y**6-489*y**7
          +48*y**8)+r**4*(-1+y)**7*(-1353+7584*y+3792*y**2-8330*y**3-10690*y**4
          +13452*y**5-5572*y**6+1918*y**7-777*y**8+96*y**9)-2*r**16*(17103-129861*y
          +425073*y**2-806503*y**3+944321*y**4-681004*y**5+290980*y**6-64001*y**7
          +2488*y**8+1137*y**9+27*y**10)-2*r**10*(-1+y)**3*(-121017+554508*y
          -945642*y**2+700840*y**3-129344*y**4-137465*y**5+83063*y**6-9712*y**7
          +821*y**8-1455*y**9+123*y**10)+2*r**8*(-1+y)**4*(-48450+106218*y+15120*y**2
          -201438*y**3+190078*y**4-35451*y**5-42463*y**6+21086*y**7-660*y**8
          -815*y**9+135*y**10)+r**6*(-1+y)**5*(-121581+416682*y-433701*y**2
          -28484*y**3+364518*y**4-238002*y**5+26140*y**6+15732*y**7+1359*y**8
          -2504*y**9+321*y**10)-2*r**12*(-1+y)**2*(-130887+596691*y-1078182*y**2
          +1001606*y**3-464394*y**4+54813*y**5+22709*y**6-5658*y**7+5949*y**8
          -3256*y**9+369*y**10)-2*r**14*(18249-115575*y+294417*y**2-362085*y**3
          +129044*y**4+202909*y**5-286952*y**6+162843*y**7-53305*y**8+12686*y**9
          -2573*y**10+342*y**11))-r**8*(-1+r**2+y)**2*(3*r**20*(-1+y)**7+2*r**18*(
          -1+y)**2*(311-1390*y+2366*y**2-2084*y**3+673*y**4-50*y**5+6*y**6)
          +r**16*(-37713+249853*y-700114*y**2+1061204*y**3-953616*y**4+527326*y**5
          -176450*y**6+32672*y**7-2763*y**8+81*y**9)-3*(-1+y)**7*(-687-1254*y
          -1761*y**2-98*y**3+2092*y**4+1834*y**5-4736*y**6+2010*y**7-149*y**8
          +20*y**9+9*y**10)+4*r**14*(-38353+222752*y-523939*y**2+614955*y**3
          -320455*y**4-44902*y**5+156399*y**6-84505*y**7+18296*y**8-1304*y**9
          +96*y**10)-2*r**2*(-1+y)**5*(44473-29379*y-10176*y**2-186400*y**3
          +348112*y**4-174258*y**5-13384*y**6+21406*y**7+1863*y**8-2171*y**9
          +304*y**10+90*y**11)-4*r**6*(-1+y)**3*(372817-1224241*y+1322787*y**2
          -194670*y**3-615582*y**4+434535*y**5-52857*y**6-31812*y**7-5973*y**8
          +5756*y**9+64*y**10+96*y**11)+2*r**8*(-1+y)**2*(-696401+2439555*y
          -2821881*y**2+535559*y**3+1381984*y**4-946998*y**5-88114*y**6+189736*y**7
          +6789*y**8-16073*y**9-617*y**10+141*y**11)+2*r**12*(234497-1496351*y
          +3987231*y**2-6046395*y**3+5404620*y**4-2586786*y**5+379146*y**6+210864*y**7
          -121365*y**8+24385*y**9-2041*y**10+435*y**11)-r**4*(-1+y)**4*(216063
          -263965*y-14439*y**2-362759*y**3+948506*y**4-494010*y**5-140870*y**6
          +147614*y**7-27177*y**8-233*y**9+909*y**10+441*y**11)+4*r**10*(-61944
          +422746*y-1214503*y**2+2003675*y**3-2123998*y**4+1394189*y**5-410440*y**6
          -65497*y**7+59744*y**8-2503*y**9-821*y**10-882*y**11+234*y**12))))/(
          -311040*logy**3*r**19*(-1+y)**7+180*r**7*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2
          -3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)
          -(-1+y)**3*(-1-y-y**2+y**3))**3-77760*logy**2*r**15*(-1+y)**5*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-6480*logy*r**11*(
          -1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*muWC**3*(17280*logy**3*r**14*(24+58*r**2+25*r**4+27*r**6+9*r**8)*(
          -1+y)**7+288*logy**2*r**10*(-1+y)**2*(366*r**16*(-1+y)**5+24*(-1+y)**7*(
          -3-6*y-9*y**2+8*y**3)+4*r**2*(-1+y)**6*(79+79*y+79*y**2-136*y**3
          +84*y**4)+10*r**4*(-1+y)**5*(-723+432*y+216*y**2-89*y**3-22*y**4
          +24*y**5)+5*r**14*(-169+845*y-1690*y**2+1480*y**3-671*y**4+91*y**5
          +18*y**6)-6*r**12*(-169+1115*y-2905*y**2+4175*y**3-3035*y**4+1139*y**5
          -215*y**6+15*y**7)+3*r**6*(-1+y)**3*(-1087+5654*y-6307*y**2+360*y**3
          +2665*y**4-1278*y**5+121*y**6+32*y**7)-2*r**10*(2406-9600*y+13125*y**2
          -3860*y**3-6450*y**4+6789*y**5-2350*y**6+135*y**7+45*y**8)+10*r**8*(
          -587+2485*y-3845*y**2+2566*y**3-495*y**4-147*y**5-53*y**6+110*y**7
          -40*y**8+6*y**9))-24*logy*r**8*(27*r**22*(-1+y)**7+r**20*(-1+y)**2*(1129
          -5645*y+11290*y**2-10948*y**3+5987*y**4-1759*y**5+234*y**6)-6*(-1
          +y)**9*(-5-10*y-15*y**2-26*y**3+19*y**4+24*y**5-51*y**6+24*y**7)
          +r**18*(-1+y)**2*(19245-87441*y+152922*y**2-122680*y**3+39117*y**4
          +4035*y**5-4340*y**6+390*y**7)-r**2*(-1+y)**8*(-4613-2885*y-2021*y**2
          +22837*y**3-16615*y**4+233*y**5+2665*y**6-489*y**7+48*y**8)+r**4*(
          -1+y)**7*(-1353+7584*y+3792*y**2-8330*y**3-10690*y**4+13452*y**5
          -5572*y**6+1918*y**7-777*y**8+96*y**9)-2*r**16*(17103-129861*y+425073*y**2
          -806503*y**3+944321*y**4-681004*y**5+290980*y**6-64001*y**7+2488*y**8
          +1137*y**9+27*y**10)-2*r**10*(-1+y)**3*(-121017+554508*y-945642*y**2
          +700840*y**3-129344*y**4-137465*y**5+83063*y**6-9712*y**7+821*y**8
          -1455*y**9+123*y**10)+2*r**8*(-1+y)**4*(-48450+106218*y+15120*y**2
          -201438*y**3+190078*y**4-35451*y**5-42463*y**6+21086*y**7-660*y**8
          -815*y**9+135*y**10)+r**6*(-1+y)**5*(-121581+416682*y-433701*y**2
          -28484*y**3+364518*y**4-238002*y**5+26140*y**6+15732*y**7+1359*y**8
          -2504*y**9+321*y**10)-2*r**12*(-1+y)**2*(-130887+596691*y-1078182*y**2
          +1001606*y**3-464394*y**4+54813*y**5+22709*y**6-5658*y**7+5949*y**8
          -3256*y**9+369*y**10)-2*r**14*(18249-115575*y+294417*y**2-362085*y**3
          +129044*y**4+202909*y**5-286952*y**6+162843*y**7-53305*y**8+12686*y**9
          -2573*y**10+342*y**11))+2*r**8*(-1+r**2+y)**2*(3*r**20*(-1+y)**7+2*r**18*(
          -1+y)**2*(311-1390*y+2366*y**2-2084*y**3+673*y**4-50*y**5+6*y**6)
          +r**16*(-37713+249853*y-700114*y**2+1061204*y**3-953616*y**4+527326*y**5
          -176450*y**6+32672*y**7-2763*y**8+81*y**9)-3*(-1+y)**7*(-687-1254*y
          -1761*y**2-98*y**3+2092*y**4+1834*y**5-4736*y**6+2010*y**7-149*y**8
          +20*y**9+9*y**10)+4*r**14*(-38353+222752*y-523939*y**2+614955*y**3
          -320455*y**4-44902*y**5+156399*y**6-84505*y**7+18296*y**8-1304*y**9
          +96*y**10)-2*r**2*(-1+y)**5*(44473-29379*y-10176*y**2-186400*y**3
          +348112*y**4-174258*y**5-13384*y**6+21406*y**7+1863*y**8-2171*y**9
          +304*y**10+90*y**11)-4*r**6*(-1+y)**3*(372817-1224241*y+1322787*y**2
          -194670*y**3-615582*y**4+434535*y**5-52857*y**6-31812*y**7-5973*y**8
          +5756*y**9+64*y**10+96*y**11)+2*r**8*(-1+y)**2*(-696401+2439555*y
          -2821881*y**2+535559*y**3+1381984*y**4-946998*y**5-88114*y**6+189736*y**7
          +6789*y**8-16073*y**9-617*y**10+141*y**11)+2*r**12*(234497-1496351*y
          +3987231*y**2-6046395*y**3+5404620*y**4-2586786*y**5+379146*y**6+210864*y**7
          -121365*y**8+24385*y**9-2041*y**10+435*y**11)-r**4*(-1+y)**4*(216063
          -263965*y-14439*y**2-362759*y**3+948506*y**4-494010*y**5-140870*y**6
          +147614*y**7-27177*y**8-233*y**9+909*y**10+441*y**11)+4*r**10*(-61944
          +422746*y-1214503*y**2+2003675*y**3-2123998*y**4+1394189*y**5-410440*y**6
          -65497*y**7+59744*y**8-2503*y**9-821*y**10-882*y**11+234*y**12))))/(
          -699840*logy**3*r**19*(-1+y)**7+405*r**7*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2
          -3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)
          -(-1+y)**3*(-1-y-y**2+y**3))**3-174960*logy**2*r**15*(-1+y)**5*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-14580*logy*r**11*(
          -1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(-8640*logy**3*r**11*(-1+r**2+3*r**4)*(-1+y)**6+144*logy**2*r**7*(
          -1+y)**4*(-46*r**12*(-1+y)**2-5*r**10*(17-34*y+17*y**2+2*y**3)+30*r**8*(
          -11+4*y+16*y**2-12*y**3+y**4)+10*(-1+y)**3*(5+5*y+5*y**2-12*y**3
          +4*y**4)-10*r**6*(-48+114*y-75*y**2+19*y**3-12*y**4+7*y**5)+3*r**2*(
          -1+y)**2*(7+60*y**3-45*y**4+8*y**5)-10*r**4*(-1-16*y+26*y**2-3*y**3
          -2*y**4-8*y**5+4*y**6))-12*logy*r**3*(-1+y)**2*(-1+r**2+y)**2*(3*r**16*(
          -1+y)**4-3*r**14*(-1+y)**2*(-47+96*y-51*y**2+8*y**3)-r**12*(-1+y)**2*(
          -2278+3740*y-1207*y**2-204*y**3+5*y**4)+3*(-1+y)**5*(3+9*y+18*y**2
          +4*y**3-5*y**4-17*y**5+8*y**6)-r**6*(-1+y)**2*(-1511+2404*y+1423*y**2
          -9220*y**3+6915*y**4-904*y**5-339*y**6+32*y**7)+r**2*(-1+y)**4*(-139
          -296*y-471*y**2+150*y**3+91*y**4+266*y**5-221*y**6+40*y**7)+r**4*(
          -1+y)**3*(2002+1098*y+821*y**2-5543*y**3+2932*y**4-120*y**5-191*y**6
          +41*y**7)+r**10*(703-3408*y+6959*y**2-6098*y**3+1285*y**4+930*y**5
          -431*y**6+80*y**7)+r**8*(3994-6914*y-1145*y**2+8730*y**3-5365*y**4
          +116*y**5+679*y**6-120*y**7+25*y**8))+r*(-1+y)**2*(-1+r**2+y)**3*(r**18*(
          -1+y)**4-r**16*(-1+y)**2*(233-427*y+173*y**2+y**3)-6*r**14*(485
          -1768*y+2347*y**2-1397*y**3+378*y**4-41*y**5+6*y**6)-(-1+y)**6*(
          -1-5*y-15*y**2-17*y**3-11*y**4+5*y**5+3*y**6+y**7)-2*r**12*(10745
          -33161*y+33819*y**2-8292*y**3-6305*y**4+3415*y**5-371*y**6+70*y**7)
          +r**10*(31960-91444*y+67560*y**2+9738*y**3-23354*y**4+3980*y**5+428*y**6
          +78*y**7-266*y**8)-3*r**2*(-1+y)**4*(-157-436*y-820*y**2-106*y**3
          +212*y**4+652*y**5-376*y**6+26*y**7+5*y**8)-2*r**4*(-1+y)**3*(593
          +1006*y+1524*y**2-1527*y**3-133*y**4-1280*y**5+1318*y**6-339*y**7
          +38*y**8)-2*r**6*(-1+y)**2*(-11527-1114*y+656*y**2+32337*y**3-25445*y**4
          +1422*y**5+3234*y**6-741*y**7+98*y**8)-6*r**8*(9660-20738*y+7976*y**2
          +12301*y**3-12124*y**4+1985*y**5+1148*y**6-141*y**7-116*y**8+49*y**9)))*math.log(mu0**2/r**2))/(
          -17280*logy**3*r**12*(-1+y)**6+10*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)
          -2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(
          -1-y-y**2+y**3))**3-4320*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-360*logy*r**4*(-1+y)**2*(-(r**8*(-1
          +y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(2160*logy**2*r**7*(4
          +5*r**2+2*r**4)*(-1+y)**6+72*logy*r**3*(-1+y)**4*(8*r**10*(-1+y)**2
          +3*r**12*(-1+y)**2-5*r**8*(-44+64*y-8*y**2-13*y**3+2*y**4)+2*(-1
          +y)**3*(-1-y-y**2-6*y**3+4*y**4)+5*r**6*(26+8*y-64*y**2+21*y**3
          +7*y**4)+r**2*(-1+y)**2*(-58+35*y**3-15*y**4+8*y**5)+5*r**4*(-61+170*y
          -133*y**2+y**3+31*y**4-11*y**5+3*y**6))+3*r*(-1+y)**3*(-1+r**2+y)**2*(7*r**12*(
          -1+y)**3+2*r**10*(-81+214*y-174*y**2+35*y**3+6*y**4)+r**8*(-169
          +509*y-558*y**2+220*y**3+3*y**4-5*y**5)-4*r**6*(1431-2992*y+1413*y**2
          +518*y**3-447*y**4+47*y**5)+(-1+y)**3*(-13-26*y-39*y**2-54*y**3
          -9*y**4+4*y**5+17*y**6)+2*r**2*(-1+y)**2*(-61-72*y-71*y**2+319*y**3
          -256*y**4+55*y**5+26*y**6)+r**4*(-1749+2827*y-705*y**2+335*y**3-1195*y**4
          +489*y**5-47*y**6+45*y**7)))*nlo.X1El(0,'SM',y/2,r))/(-17280*logy**3*r**12*(
          -1+y)**6+10*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -4320*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-360*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-720*logy**2*r**7*(4+5*r**2
          +2*r**4)*(-1+y)**6-24*logy*r**3*(-1+y)**4*(8*r**10*(-1+y)**2+3*r**12*(
          -1+y)**2-5*r**8*(-44+64*y-8*y**2-13*y**3+2*y**4)+2*(-1+y)**3*(
          -1-y-y**2-6*y**3+4*y**4)+5*r**6*(26+8*y-64*y**2+21*y**3+7*y**4)
          +r**2*(-1+y)**2*(-58+35*y**3-15*y**4+8*y**5)+5*r**4*(-61+170*y-133*y**2
          +y**3+31*y**4-11*y**5+3*y**6))-r*(-1+y)**3*(-1+r**2+y)**2*(7*r**12*(
          -1+y)**3+2*r**10*(-81+214*y-174*y**2+35*y**3+6*y**4)+r**8*(-169
          +509*y-558*y**2+220*y**3+3*y**4-5*y**5)-4*r**6*(1431-2992*y+1413*y**2
          +518*y**3-447*y**4+47*y**5)+(-1+y)**3*(-13-26*y-39*y**2-54*y**3
          -9*y**4+4*y**5+17*y**6)+2*r**2*(-1+y)**2*(-61-72*y-71*y**2+319*y**3
          -256*y**4+55*y**5+26*y**6)+r**4*(-1749+2827*y-705*y**2+335*y**3-1195*y**4
          +489*y**5-47*y**6+45*y**7)))*nlo.X1El(0,'VL',y/2,r))/(-17280*logy**3*r**12*(
          -1+y)**6+10*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -4320*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-360*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1
          +y)**4-(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1
          +y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(0,'VLVR',y/2,r))/(2880*logy**2*r**8*(-1+y)**4+480*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(60*logy*r**4*(3+r**2)*(-1+y)**4+(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(0,'VR',y/2,r))/(1440*logy**2*r**8*(
          -1+y)**4+240*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(72*logy*r**3*(1+r**2)*(-1+y)**4
          +12*r*(-1+y)**3*(r**6*(-1+y)+3*r**2*(-1+y)**2*(3+y)+3*r**4*(-3+y
          +y**2)+(-1+y)**2*(1+y+y**2)))*nlo.X1El(1,'SM',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-24*logy*r**3*(1+r**2)*(-1+y)**4
          -4*r*(-1+y)**3*(r**6*(-1+y)+3*r**2*(-1+y)**2*(3+y)+3*r**4*(-3+y
          +y**2)+(-1+y)**2*(1+y+y**2)))*nlo.X1El(1,'VL',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(1,'VLVR',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -(2*api*(-1+y)**2*nlo.X1El(1,'VR',y/2,r))/(12*logy*r**4*(-1+y)**2-r**8*(
          -1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.VLVR

    if wc.SLT != 0:
      resNP = 0
      resNP +=((720*logy**2*r**8*(1+r**2)*(-1+y)**4-24*logy*r**4*(-1+y)**3*(-25*r**8*(
          -1+y)+3*r**10*(-1+y)-30*r**4*(2-4*y+y**2+y**3)-10*r**6*(-6+3*y**2
          +y**3)+(-1+y)**3*(-3-6*y-9*y**2+8*y**3)+5*r**2*(-5+5*y+8*y**3
          -11*y**4+3*y**5))+(-1+y)**2*(-1+r**2+y)**2*(1+r**14*(-1+y)**2-16*y**3
          +30*y**4-16*y**5+y**8+r**12*(-21+40*y-17*y**2+6*y**3)+r**10*(-3
          -26*y+28*y**2-54*y**3+15*y**4)+r**2*(-1+y)**3*(21+61*y+118*y**2
          -2*y**3+y**4+y**5)+r**4*(-1+y)**2*(-3+26*y+54*y**2+352*y**3-15*y**4
          +6*y**5)+r**8*(743-984*y+54*y**2+332*y**3-85*y**4+20*y**5)+r**6*(743
          -502*y-187*y**2-732*y**3+733*y**4-70*y**5+15*y**6)))/(2880*logy**2*r**8*(
          -1+y)**4+480*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-17280*logy**3*r**14*(-1+y)**6
          -288*logy**2*r**8*(-1+y)**4*(-3*r**10*(-1+y)**2+30*r**4*(-1+y)**2*(-4
          +y**3)+10*r**8*(8-16*y+8*y**2+y**3)+10*r**6*(4+10*y-23*y**2+9*y**3
          +2*y**4)+8*(-1+y)**3*(-1-y-y**2-6*y**3+4*y**4)+5*r**2*(-1+y)**2*(
          -1-22*y**3+11*y**4))+24*logy*r**4*(-1+y)**3*(-1+r**2+y)**2*(r**14*(
          -1+y)**3-2*r**12*(21-64*y+66*y**2-46*y**3+23*y**4)+r**10*(445-1321*y
          +1254*y**2-498*y**3+173*y**4-53*y**5)+8*(-1+y)**4*(1+3*y+6*y**2
          +5*y**3-y**4-8*y**5+4*y**6)-2*r**4*(-1+y)**2*(173+134*y+131*y**2
          +306*y**3-659*y**4+148*y**5+7*y**6)+4*r**8*(237-468*y+207*y**2+182*y**3
          -53*y**4-100*y**5+15*y**6)+r**2*(-1+y)**3*(65+114*y+147*y**2+376*y**3
          -65*y**4-106*y**5+29*y**6)+r**6*(1213-1755*y+105*y**2+1905*y**3-2925*y**4
          +2147*y**5-745*y**6+55*y**7))+2*r**2*(-1+y)**2*(-1+r**2+y)**3*(r**18*(
          -1+y)**4+3*r**16*(-1+y)**2*(-7+13*y-5*y**2+y**3)-2*r**14*(-155+584*y
          -792*y**2+492*y**3-149*y**4+4*y**6)+r**12*(-1350+5046*y-6576*y**2
          +2664*y**3+934*y**4-966*y**5+224*y**6-56*y**7)-(-1+y)**5*(-7-28*y
          -70*y**2-130*y**3-78*y**4+88*y**5-14*y**6-2*y**7+y**8)-6*r**4*(-1
          +y)**3*(377+550*y+617*y**2+252*y**3-773*y**4-310*y**5+395*y**6-36*y**7
          +8*y**8)-r**2*(-1+y)**4*(173+444*y+786*y**2-512*y**3-952*y**4-1060*y**5
          +910*y**6-40*y**7+11*y**8)-6*r**10*(246-710*y+703*y**2-1012*y**3
          +1925*y**4-1702*y**5+641*y**6-112*y**7+21*y**8)-2*r**6*(-1+y)**2*(1491
          +786*y-261*y**2-3492*y**3+3829*y**4-1582*y**5+1493*y**6-280*y**7
          +56*y**8)-2*r**8*(2602-6112*y+3513*y**2+9743*y**3-20467*y**4+15483*y**5
          -6773*y**6+2417*y**7-483*y**8+77*y**9))))/(-25920*logy**3*r**12*(-1+y)**6
          +15*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)
          +2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3-6480*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -540*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(
          -1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y
          -y**2+y**3))**2))
      resNP += ((api*muWC*(-34560*logy**3*r**12*(-1+r**2)*(-1+y)**6+2880*logy**2*r**8*(
          -1+y)**3*(-(r**10*(-1+y)**3)+r**8*(15-45*y+45*y**2+3*y**3-10*y**4)
          +r**2*(-1+y)**3*(-15+12*y**3+5*y**4)+(-1+y)**3*(-1-14*y**3+11*y**4)
          -2*r**6*(8-42*y+69*y**2-47*y**3+2*y**4+6*y**5)+2*r**4*(-8+6*y+21*y**2
          -41*y**3+30*y**4-9*y**5+y**6))-48*logy*r**4*(-1+y)**2*(-1+r**2+y)**2*(
          -9*r**14*(-1+y)**4+(-1+y)**5*(-9-27*y-54*y**2+18*y**3+19*y**4+13*y**5)
          +r**12*(23-74*y+66*y**2+36*y**3-121*y**4+70*y**5)+r**2*(-1+y)**4*(
          -23-28*y-15*y**2-173*y**4-76*y**5+35*y**6)+r**10*(791-3072*y+4411*y**2
          -2592*y**3+769*y**4-472*y**5+165*y**6)+5*r**8*(-53+298*y-503*y**2
          +1116*y**3-1055*y**4+214*y**5+27*y**6+4*y**7)+r**4*(-1+y)**2*(-791
          +92*y+59*y**2-2450*y**3+3035*y**4-1264*y**5+113*y**6+6*y**7)-5*r**6*(
          -53+20*y+192*y**2-484*y**3+426*y**4-260*y**5+296*y**6-156*y**7+19*y**8))
          +4*(-1+y)*(-1+r**2+y)**3*(r**20*(-1+y)**5+r**18*(-1+y)**2*(14-39*y
          +33*y**2-19*y**3+3*y**4)-r**16*(483-2268*y+4155*y**2-3834*y**3+1943*y**4
          -522*y**5+3*y**6+8*y**7)+r**14*(3612-16482*y+28710*y**2-23184*y**3
          +7372*y**4+538*y**5-902*y**6+232*y**7-56*y**8)+(-1+y)**6*(1+4*y
          +10*y**2+38*y**3+26*y**4-24*y**5+18*y**6+6*y**7+y**8)-r**2*(-1+y)**5*(
          -14-39*y-72*y**2-444*y**3-92*y**4+222*y**5-264*y**6-12*y**7-6*y**8
          +y**9)-r**4*(-1+y)**4*(-483-819*y-1068*y**2+186*y**3+686*y**4+176*y**5
          -2020*y**6+254*y**7-43*y**8+11*y**9)-2*r**6*(-1+y)**3*(-1806-1017*y
          -468*y**2+739*y**3-302*y**4-711*y**5-1120*y**6+245*y**7-104*y**8+24*y**9)
          -2*r**8*(-1+y)**2*(-753-117*y+1194*y**2+14193*y**3-21686*y**4+7773*y**5
          -2838*y**6+1011*y**7-273*y**8+56*y**9)-2*r**12*(753-3882*y+6804*y**2
          -6907*y**3+74*y**4+9111*y**5-8432*y**6+2599*y**7-343*y**8+63*y**9)
          -2*r**10*y*(-786+2358*y-23151*y**2+51289*y**3-46899*y**4+26181*y**5
          -11721*y**6+3135*y**7-483*y**8+77*y**9))))/(77760*logy**3*r**12*(-1+y)**6
          -45*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)
          +2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3+19440*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +1620*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2))
      resNP += ((api*muWC**2*(25920*logy**3*r**14*(-1+y)**6-144*logy**2*r**8*(
          -1+y)**2*(9*r**10*(-1+y)**4+5*r**2*(-1+y)**4*(3-30*y**3+11*y**4)-10*r**8*(24
          -96*y+144*y**2-81*y**3+10*y**4+5*y**5)+4*(-1+y)**4*(-6-25*y**4
          +16*y**5)-10*r**6*(12+6*y-117*y**2+195*y**3-91*y**4-13*y**5+14*y**6)
          -30*r**4*(-12+48*y-72*y**2+35*y**3+14*y**4-12*y**5-4*y**6+3*y**7))
          +12*logy*r**4*(-1+y)*(-1+r**2+y)**2*(-3*r**14*(-1+y)**5+2*r**12*(63
          -318*y+645*y**2-678*y**3+463*y**4-236*y**5+61*y**6)+r**10*(-1335
          +6633*y-13023*y**2+12309*y**3-6341*y**4+2387*y**5-805*y**6+175*y**7)
          +8*(-1+y)**4*(-3-3*y-3*y**2+36*y**3-31*y**4-3*y**5-3*y**6-8*y**7
          +8*y**8)-4*r**8*(711-2826*y+4140*y**2-660*y**3-2818*y**4+1844*y**5
          -186*y**6-134*y**7+9*y**8)+2*r**4*(-1+y)**2*(519-636*y+108*y**2+1734*y**3
          -1244*y**4-764*y**5+780*y**6-310*y**7+53*y**8)+r**2*(-1+y)**3*(-195
          +48*y+48*y**2+1428*y**3-2534*y**4+1456*y**5+48*y**6-532*y**7+153*y**8)
          -r**6*(3639-12543*y+14484*y**2-5940*y**3+7278*y**4-12422*y**5+5180*y**6
          +948*y**7-693*y**8+69*y**9))-(-1+r**2+y)**3*(3*r**20*(-1+y)**6+4*(
          -1+y)**7*y**3*(18+17*y+18*y**3+6*y**4+y**5)+r**18*(-1+y)**2*(-63
          +243*y-342*y**2+240*y**3-79*y**4+13*y**5)+2*r**16*(465-2682*y+6345*y**2
          -8088*y**3+6157*y**4-2912*y**5+783*y**6-98*y**7+6*y**8)+r**2*(-1+y)**6*(
          -21-63*y-126*y**2+1140*y**3+460*y**4-26*y**5+798*y**6-12*y**7+9*y**8
          +y**9)-2*r**14*(2025-11619*y+27027*y**2-33237*y**3+22495*y**4-7481*y**5
          +489*y**6+153*y**7+12*y**8+16*y**9)+r**12*(-4428+21636*y-42642*y**2
          +26784*y**3+864*y**4+14840*y**5-32952*y**6+19952*y**7-4828*y**8+388*y**9
          -94*y**10)+r**4*(-1+y)**4*(-519-294*y-213*y**2-888*y**3+1178*y**4
          -1748*y**5-4598*y**6+3640*y**7+821*y**8-22*y**9+3*y**10)-2*r**6*(-1
          +y)**3*(3393-1836*y-954*y**2-6600*y**3+18444*y**4-9344*y**5+3222*y**6
          -728*y**7-1061*y**8+20*y**9+4*y**10)-2*r**8*(-1+y)**2*(4473-6588*y
          -1026*y**2-24360*y**3+56176*y**4-24024*y**5-340*y**6+1560*y**7-429*y**8
          -68*y**9+26*y**10)-2*r**10*(7806-33948*y+55017*y**2-10281*y**3-64504*y**4
          +76964*y**5-47706*y**6+22590*y**7-7742*y**8+2016*y**9-263*y**10+51*y**11))))/(
          -77760*logy**3*r**12*(-1+y)**6+45*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)
          -2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(
          -1-y-y**2+y**3))**3-19440*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-1620*logy*r**4*(-1+y)**2*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((mupi*(
          -25920*logy**3*r**12*(1+r**2)*(-1+y)**6+144*logy**2*r**8*(-1+y)**2*(33*r**10*(
          -1+y)**4+5*r**2*(-1+y)**4*(51-96*y**3+7*y**4)+5*r**8*(-51+204*y
          -306*y**2+198*y**3-79*y**4+10*y**5)+(-1+y)**4*(-33+210*y**3-365*y**4
          +128*y**5)-10*r**6*(48-138*y+99*y**2+42*y**3-35*y**4-14*y**5+10*y**6)
          -30*r**4*(-16+82*y-159*y**2+132*y**3-43*y**4+15*y**5-18*y**6+7*y**7))
          -12*logy*r**4*(-1+y)*(-1+r**2+y)**2*(21*r**14*(-1+y)**5+r**12*(321
          -1563*y+3000*y**2-2802*y**3+1381*y**4-371*y**5+34*y**6)+r**10*(-297
          +1677*y-3597*y**2+3609*y**3-2599*y**4+1051*y**5+301*y**6-145*y**7)
          +r**8*(-6483+27873*y-45135*y**2+29565*y**3-10021*y**4+4283*y**5-1317*y**6
          +727*y**7-132*y**8)+(-1+y)**4*(-21-21*y-21*y**2+279*y**3-283*y**4
          -27*y**5-27*y**6-167*y**7+128*y**8)+r**4*(-1+y)**2*(-297+105*y+333*y**2
          -591*y**3+11479*y**4-15953*y**5+7251*y**6-1561*y**7+194*y**8)+r**2*(
          -1+y)**3*(-321+42*y+42*y**2+2850*y**3-4504*y**4+2102*y**5+54*y**6
          -626*y**7+201*y**8)+r**6*(-6483+23991*y-31548*y**2+22020*y**3-28206*y**4
          +35134*y**5-18700*y**6+4884*y**7-1239*y**8+147*y**9))+(-1+r**2+y)**3*(3*r**20*(
          -1+y)**6+r**18*(-1+y)**2*(-84+327*y-468*y**2+324*y**3-92*y**4+17*y**5)
          +(-1+y)**7*(-3-12*y-30*y**2+30*y**3+58*y**4+72*y**5+90*y**6+30*y**7
          +5*y**8)+r**16*(411-2475*y+6111*y**2-8385*y**3+7297*y**4-4253*y**5
          +1557*y**6-407*y**7+48*y**8)+r**2*(-1+y)**6*(-84-243*y-468*y**2+948*y**3
          +644*y**4+614*y**5+804*y**6-60*y**7+5*y**9)+2*r**14*(1368-6903*y
          +13734*y**2-11367*y**3+844*y**4+4711*y**5-3138*y**6+1395*y**7-456*y**8
          +52*y**9)+r**4*(-1+y)**4*(411+420*y+321*y**2-5538*y**3+856*y**4-1966*y**5
          -2608*y**6+458*y**7+2533*y**8-206*y**9+39*y**10)+2*r**6*(-1+y)**3*(
          -1368+1305*y+261*y**2+9579*y**3-33765*y**4+19915*y**5-5217*y**6-2639*y**7
          +3169*y**8-424*y**9+64*y**10)+2*r**12*(-6687+35541*y-74700*y**2+67917*y**3
          -20079*y**4-12271*y**5+19677*y**6-13141*y**7+3998*y**8-830*y**9+95*y**10)
          +2*r**8*(-1+y)**2*(-6687+11268*y-1881*y**2+9723*y**3-4715*y**4-40329*y**5
          +32513*y**6-14667*y**7+4710*y**8-851*y**9+116*y**10)+2*r**10*(-15612
          +70254*y-119466*y**2+97089*y**3-94312*y**4+140636*y**5-123828*y**6
          +68526*y**7-29084*y**8+6822*y**9-1154*y**10+129*y**11))))/(-207360*logy**3*r**12*(
          -1+y)**6+120*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -51840*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-4320*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((muG*(-8640*logy**3*r**10*(4+19*r**2
          +3*r**4)*(-1+y)**6+144*logy**2*r**6*(-1+y)**3*(73*r**12*(-1+y)**3+40*(
          -1+y)**4*(1+y+y**2)+5*r**10*(23-69*y+69*y**2-97*y**3+34*y**4)
          +5*r**4*(-1+y)**2*(-419+563*y-72*y**2+112*y**3-119*y**4+7*y**5)-10*r**8*(
          -232+642*y-561*y**2+197*y**3-36*y**4+10*y**5)+r**2*(-1+y)**3*(187
          +730*y**3-585*y**4+128*y**5)-10*r**6*(12-378*y+891*y**2-749*y**3
          +288*y**4-93*y**5+29*y**6))-12*logy*r**2*(-1+y)**2*(-1+r**2+y)**2*(53*r**16*(
          -1+y)**4+r**14*(-425+1594*y-2126*y**2+1076*y**3+135*y**4-254*y**5)
          +r**12*(-3811+14236*y-19551*y**2+11112*y**3-3717*y**4+2388*y**5-657*y**6)
          -20*(-1+y)**4*(-1-2*y-3*y**2-2*y**3-y**4+y**6)+r**10*(17363-61830*y
          +75865*y**2-53420*y**3+27345*y**4-7098*y**5+835*y**6-100*y**7)+r**2*(
          -1+y)**3*(251+211*y+171*y**2+175*y**3+93*y**4+197*y**5-1043*y**6
          +217*y**7+128*y**8)+r**4*(-1+y)**2*(-1477+498*y+78*y**2+6874*y**3
          -5620*y**4+862*y**5-1278*y**6+102*y**7+201*y**8)+r**8*(30223-91308*y
          +88940*y**2-39540*y**3+25150*y**4-21868*y**5+11748*y**6-3860*y**7+435*y**8)
          +r**6*(14465-34914*y+23020*y**2+18412*y**3-61878*y**4+73880*y**5-44836*y**6
          +14380*y**7-2787*y**8+258*y**9))-(-1+y)*(-1+r**2+y)**3*(5*r**20*(
          -1+y)**5+r**18*(-1+y)**2*(48-129*y+99*y**2-73*y**3+15*y**4)+r**16*(
          -2073+9600*y-17253*y**2+15542*y**3-7693*y**4+2010*y**5+67*y**6-40*y**7)
          -2*r**14*(-10636+47903*y-82159*y**2+66572*y**3-24068*y**4+1329*y**5
          +1947*y**6-628*y**7+140*y**8)-(-1+y)**5*(-9-27*y-54*y**2-124*y**3
          -268*y**4-422*y**5+246*y**6+108*y**7+53*y**8+17*y**9)-2*r**12*(13851
          -65490*y+113598*y**2-99299*y**3+28764*y**4+34483*y**5-36066*y**6+10791*y**7
          -1747*y**8+315*y**9)-r**2*(-1+y)**4*(536+859*y+1089*y**2-1056*y**3
          -2216*y**4-2946*y**5+4226*y**6+376*y**7+56*y**8+31*y**9+5*y**10)-r**4*(
          -1+y)**3*(9435+5028*y+2673*y**2-13834*y**3-952*y**4+1122*y**5-5776*y**6
          +5394*y**7+2901*y**8-286*y**9+55*y**10)-2*r**6*(-1+y)**2*(11580-3087*y
          -5631*y**2+33007*y**3-47629*y**4+22075*y**5-14893*y**6+4581*y**7+4013*y**8
          -776*y**9+120*y**10)-2*r**10*(54972-208470*y+279108*y**2-242797*y**3
          +262391*y**4-247365*y**5+151427*y**6-61131*y**7+13989*y**8-2509*y**9
          +385*y**10)-2*r**8*(45983-147103*y+153749*y**2-1500*y**3-196870*y**4
          +293518*y**5-214682*y**6+88336*y**7-29365*y**8+9765*y**9-2111*y**10
          +280*y**11))))/(207360*logy**3*r**12*(-1+y)**6-120*(r**8*(-1+y)**2-6*r**4*y*(2
          -3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)
          -(-1+y)**3*(-1-y-y**2+y**3))**3+51840*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))+4320*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((rhoLS*(-25920*logy**3*r**12*(1+r**2)*(-1+y)**6+144*logy**2*r**8*(-1+y)**2*(69*r**10*(
          -1+y)**4+5*r**2*(-1+y)**4*(-9-96*y**3+11*y**4)+5*r**8*(-63+252*y
          -378*y**2+342*y**3-155*y**4+26*y**5)+(-1+y)**4*(51+210*y**3-265*y**4
          +64*y**5)-10*r**6*(60-186*y+171*y**2-54*y**3+5*y**4-22*y**5+14*y**6)
          -30*r**4*(-28+130*y-231*y**2+212*y**3-115*y**4+47*y**5-22*y**6+7*y**7))
          -12*logy*r**4*(-1+y)*(-1+r**2+y)**2*(45*r**14*(-1+y)**5+r**12*(537
          -2595*y+4920*y**2-4506*y**3+1541*y**4+413*y**5-310*y**6)+r**10*(1167
          -5163*y+9003*y**2-6735*y**3+4009*y**4-4645*y**5+2957*y**6-593*y**7)
          +r**8*(-11019+47529*y-76455*y**2+74589*y**3-50285*y**4+20803*y**5
          -5421*y**6+887*y**7+12*y**8)+(-1+y)**4*(99+99*y+99*y**2-393*y**3
          +61*y**4-3*y**5-3*y**6-103*y**7+64*y**8)+r**2*(-1+y)**3*(951-198*y
          -198*y**2-510*y**3-272*y**4+262*y**5+6*y**6-274*y**7+153*y**8)+r**4*(
          -1+y)**2*(831-1311*y-315*y**2-6111*y**3+16535*y**4-17497*y**5+8859*y**6
          -1913*y**7+202*y**8)+r**6*(-3579+12063*y-13884*y**2+22404*y**3-47694*y**4
          +58238*y**5-40604*y**6+16068*y**7-3375*y**8+363*y**9))-(-1+r**2+y)**3*(9*r**20*(
          -1+y)**6+r**18*(-1+y)**2*(-60+213*y-252*y**2+204*y**3-116*y**4+35*y**5)
          +r**16*(1161-6273*y+13581*y**2-15795*y**3+11563*y**4-5831*y**5+1503*y**6
          -5*y**7)-(-1+y)**6*(-33-99*y-198*y**2-108*y**3-116*y**4-94*y**5
          +150*y**6+12*y**7+5*y**8+y**9)-2*r**14*(7032-37575*y+80190*y**2-87387*y**3
          +47900*y**4-6985*y**5-6330*y**6+3447*y**7-648*y**8+116*y**9)-r**2*(
          -1+y)**5*(-636-1173*y-1611*y**2+888*y**3-208*y**4-114*y**5+1234*y**6
          -288*y**7-12*y**8-y**9+y**10)-r**4*(-1+y)**4*(-2673-2052*y-1035*y**2
          -618*y**3+1256*y**4+1522*y**5+2872*y**6-4430*y**7+2129*y**8-358*y**9
          +27*y**10)-2*r**6*(-1+y)**3*(1224-2007*y+621*y**2+351*y**3-897*y**4
          +10715*y**5-5145*y**6-5731*y**7+4109*y**8-920*y**9+80*y**10)-2*r**8*(
          -1+y)**2*(3333-9984*y+5319*y**2-18729*y**3+78017*y**4-86409*y**5
          +55537*y**6-25527*y**7+7950*y**8-2047*y**9+220*y**10)-2*r**12*(-14355
          +76653*y-159768*y**2+177633*y**3-83019*y**4-51671*y**5+94533*y**6
          -50057*y**7+12166*y**8-1918*y**9+283*y**10)-2*r**10*(-19116+82170*y
          -129690*y**2+187329*y**3-342920*y**4+456616*y**5-388908*y**6+213090*y**7
          -71164*y**8+15150*y**9-2890*y**10+333*y**11))))/(-207360*logy**3*r**12*(
          -1+y)**6+120*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -51840*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-4320*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((rhoD*(8640*logy**3*r**8*(12+28*r**2
          +9*r**4+9*r**6)*(-1+y)**7-144*logy**2*r**4*(-1+y)**2*(27*r**14*(-1+y)**5
          -40*r**2*(-1+y)**5*(-11+18*y**3+2*y**4)+24*(-1+y)**6*(3+3*y+3*y**2
          -22*y**3+8*y**4)-5*r**12*(-193+965*y-1930*y**2+1720*y**3-791*y**4
          +115*y**5+18*y**6)+5*r**6*(-1+y)**3*(-23-962*y+1489*y**2-832*y**3
          +545*y**4-370*y**5+33*y**6)+r**4*(-1+y)**4*(-4013+6173*y-1080*y**2
          -1150*y**3+505*y**4-987*y**5+192*y**6)-2*r**10*(176-1690*y+5405*y**2
          -8345*y**3+5545*y**4-1121*y**5-390*y**6+180*y**7)-10*r**8*(-368+1678*y
          -2951*y**2+2745*y**3-1615*y**4+644*y**5-85*y**6-87*y**7+39*y**8))
          +12*logy*(-1+y)*(15*r**22*(-1+y)**6+12*(-1+y)**9*(-1-3*y-6*y**2
          -9*y**4-17*y**5+16*y**6)+4*r**2*(-1+y)**8*(-49-98*y-147*y**2+272*y**3
          -189*y**4-266*y**5+297*y**6)+r**20*(-1009+6054*y-15135*y**2+20168*y**3
          -16911*y**4+10014*y**5-3937*y**6+756*y**7)+r**4*(-1+y)**7*(2561+833*y
          -31*y**2-18123*y**3+13855*y**4-185*y**5-2321*y**6+1179*y**7+192*y**8)
          +4*r**18*(2731-16548*y+41856*y**2-55890*y**3+44971*y**4-24408*y**5
          +9830*y**6-3058*y**7+516*y**8)+r**6*(-1+y)**6*(27775-10560*y-5280*y**2
          -47568*y**3+35926*y**4+8832*y**5-14632*y**6+3344*y**7+843*y**8)-2*r**12*(
          -1+y)**2*(-15353+17252*y+52722*y**2-134052*y**3+174448*y**4-114034*y**5
          +38726*y**6-9204*y**7+925*y**8+90*y**9)+4*r**10*(-1+y)**3*(26042-78816*y
          +64731*y**2+625*y**3-37226*y**4+32250*y**5-16623*y**6+6719*y**7-1836*y**8
          +294*y**9)+4*r**8*(-1+y)**4*(6814-37706*y+49411*y**2-10724*y**3-17406*y**4
          +8799*y**5+2137*y**6-2002*y**7-364*y**8+381*y**9)+4*r**16*(-4385+32100*y
          -97620*y**2+170702*y**3-170491*y**4+100281*y**5-38334*y**6+10366*y**7
          -2346*y**8+387*y**9)+r**14*(28786-181164*y+497694*y**2-892488*y**3
          +1116020*y**4-875568*y**5+384604*y**6-82904*y**7+2898*y**8+2380*y**9
          -258*y**10))-(-1+r**2+y)**2*(33*r**22*(-1+y)**7+r**20*(-1+y)**2*(701
          -3439*y+6680*y**2-6812*y**3+3775*y**4-1205*y**5+204*y**6)+r**18*(
          -7741+53031*y-154478*y**2+253026*y**3-259094*y**4+174326*y**5-77798*y**6
          +22946*y**7-4281*y**8+447*y**9)+3*(-1+y)**7*(141+234*y+303*y**2
          -434*y**3+1068*y**4+442*y**5-4024*y**6+2362*y**7-241*y**8-28*y**9
          +17*y**10)+r**16*(34609-239865*y+705674*y**2-1173560*y**3+1200760*y**4
          -773574*y**5+315734*y**6-90376*y**7+22879*y**8-4465*y**9+264*y**10)
          +r**2*(-1+y)**6*(6763+3853*y+2263*y**2-28659*y**3+54700*y**4-5000*y**5
          -84924*y**6+56968*y**7-7391*y**8-781*y**9+285*y**10+3*y**11)+r**4*(
          -1+y)**5*(-4837+22324*y-437*y**2+198772*y**3-342726*y**4+197896*y**5
          -92006*y**6+19536*y**7+2515*y**8+764*y**9+563*y**10+36*y**11)+r**6*(
          -1+y)**4*(-254329+542039*y-231399*y**2+455629*y**3-1000366*y**4+603522*y**5
          +126958*y**6-264106*y**7+56127*y**8+5375*y**9+801*y**10+69*y**11)-2*r**8*(
          -1+y)**3*(-2757+208756*y-511867*y**2+209046*y**3+374954*y**4-458266*y**5
          +8070*y**6+163358*y**7-40021*y**8-42*y**9-1235*y**10+84*y**11)-2*r**14*(3891
          -53407*y+238081*y**2-638391*y**3+940516*y**4-727592*y**5+254520*y**6
          +8560*y**7-36491*y**8+8835*y**9-709*y**10+267*y**11)-2*r**10*(-1+y)**2*(
          -131561+508247*y-692497*y**2+404345*y**3+242226*y**4-602770*y**5+226022*y**6
          +53910*y**7-40921*y**8+12139*y**9-3053*y**10+393*y**11)-2*r**12*(17105
          -108027*y+271831*y**2-293261*y**3-239900*y**4+848056*y**5-609212*y**6
          +21820*y**7+162259*y**8-92437*y**9+25237*y**10-4023*y**11+552*y**12))))/(622080*logy**3*r**12*(
          -1+y)**7-360*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(
          -1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**3+155520*logy**2*r**8*(-1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+12960*logy*r**4*(-1+y)**3*(-(r**8*(-1
          +y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*muWC**3*(
          -8640*logy**3*r**8*(12+28*r**2+9*r**4+9*r**6)*(-1+y)**7+144*logy**2*r**4*(
          -1+y)**2*(27*r**14*(-1+y)**5-40*r**2*(-1+y)**5*(-11+18*y**3+2*y**4)
          +24*(-1+y)**6*(3+3*y+3*y**2-22*y**3+8*y**4)-5*r**12*(-193+965*y
          -1930*y**2+1720*y**3-791*y**4+115*y**5+18*y**6)+5*r**6*(-1+y)**3*(
          -23-962*y+1489*y**2-832*y**3+545*y**4-370*y**5+33*y**6)+r**4*(-1
          +y)**4*(-4013+6173*y-1080*y**2-1150*y**3+505*y**4-987*y**5+192*y**6)
          -2*r**10*(176-1690*y+5405*y**2-8345*y**3+5545*y**4-1121*y**5-390*y**6
          +180*y**7)-10*r**8*(-368+1678*y-2951*y**2+2745*y**3-1615*y**4+644*y**5
          -85*y**6-87*y**7+39*y**8))-12*logy*(-1+y)*(15*r**22*(-1+y)**6+12*(
          -1+y)**9*(-1-3*y-6*y**2-9*y**4-17*y**5+16*y**6)+4*r**2*(-1+y)**8*(
          -49-98*y-147*y**2+272*y**3-189*y**4-266*y**5+297*y**6)+r**20*(-1009
          +6054*y-15135*y**2+20168*y**3-16911*y**4+10014*y**5-3937*y**6+756*y**7)
          +r**4*(-1+y)**7*(2561+833*y-31*y**2-18123*y**3+13855*y**4-185*y**5
          -2321*y**6+1179*y**7+192*y**8)+4*r**18*(2731-16548*y+41856*y**2-55890*y**3
          +44971*y**4-24408*y**5+9830*y**6-3058*y**7+516*y**8)+r**6*(-1+y)**6*(27775
          -10560*y-5280*y**2-47568*y**3+35926*y**4+8832*y**5-14632*y**6+3344*y**7
          +843*y**8)-2*r**12*(-1+y)**2*(-15353+17252*y+52722*y**2-134052*y**3
          +174448*y**4-114034*y**5+38726*y**6-9204*y**7+925*y**8+90*y**9)+4*r**10*(
          -1+y)**3*(26042-78816*y+64731*y**2+625*y**3-37226*y**4+32250*y**5
          -16623*y**6+6719*y**7-1836*y**8+294*y**9)+4*r**8*(-1+y)**4*(6814-37706*y
          +49411*y**2-10724*y**3-17406*y**4+8799*y**5+2137*y**6-2002*y**7-364*y**8
          +381*y**9)+4*r**16*(-4385+32100*y-97620*y**2+170702*y**3-170491*y**4
          +100281*y**5-38334*y**6+10366*y**7-2346*y**8+387*y**9)+r**14*(28786
          -181164*y+497694*y**2-892488*y**3+1116020*y**4-875568*y**5+384604*y**6
          -82904*y**7+2898*y**8+2380*y**9-258*y**10))+(-1+r**2+y)**2*(33*r**22*(
          -1+y)**7+r**20*(-1+y)**2*(701-3439*y+6680*y**2-6812*y**3+3775*y**4
          -1205*y**5+204*y**6)+r**18*(-7741+53031*y-154478*y**2+253026*y**3
          -259094*y**4+174326*y**5-77798*y**6+22946*y**7-4281*y**8+447*y**9)
          +3*(-1+y)**7*(141+234*y+303*y**2-434*y**3+1068*y**4+442*y**5-4024*y**6
          +2362*y**7-241*y**8-28*y**9+17*y**10)+r**16*(34609-239865*y+705674*y**2
          -1173560*y**3+1200760*y**4-773574*y**5+315734*y**6-90376*y**7+22879*y**8
          -4465*y**9+264*y**10)+r**2*(-1+y)**6*(6763+3853*y+2263*y**2-28659*y**3
          +54700*y**4-5000*y**5-84924*y**6+56968*y**7-7391*y**8-781*y**9+285*y**10
          +3*y**11)+r**4*(-1+y)**5*(-4837+22324*y-437*y**2+198772*y**3-342726*y**4
          +197896*y**5-92006*y**6+19536*y**7+2515*y**8+764*y**9+563*y**10+36*y**11)
          +r**6*(-1+y)**4*(-254329+542039*y-231399*y**2+455629*y**3-1000366*y**4
          +603522*y**5+126958*y**6-264106*y**7+56127*y**8+5375*y**9+801*y**10
          +69*y**11)-2*r**8*(-1+y)**3*(-2757+208756*y-511867*y**2+209046*y**3
          +374954*y**4-458266*y**5+8070*y**6+163358*y**7-40021*y**8-42*y**9-1235*y**10
          +84*y**11)-2*r**14*(3891-53407*y+238081*y**2-638391*y**3+940516*y**4
          -727592*y**5+254520*y**6+8560*y**7-36491*y**8+8835*y**9-709*y**10+267*y**11)
          -2*r**10*(-1+y)**2*(-131561+508247*y-692497*y**2+404345*y**3+242226*y**4
          -602770*y**5+226022*y**6+53910*y**7-40921*y**8+12139*y**9-3053*y**10
          +393*y**11)-2*r**12*(17105-108027*y+271831*y**2-293261*y**3-239900*y**4
          +848056*y**5-609212*y**6+21820*y**7+162259*y**8-92437*y**9+25237*y**10
          -4023*y**11+552*y**12))))/(699840*logy**3*r**12*(-1+y)**7-405*(-1+y)*(r**8*(
          -1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3+174960*logy**2*r**8*(
          -1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +14580*logy*r**4*(-1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2))
      resNP += ((api*(-8640*logy**3*r**14*(-1+y)**6-144*logy**2*r**8*(
          -1+y)**4*(-3*r**10*(-1+y)**2+30*r**4*(-1+y)**2*(-4+y**3)+10*r**8*(8
          -16*y+8*y**2+y**3)+10*r**6*(4+10*y-23*y**2+9*y**3+2*y**4)+8*(
          -1+y)**3*(-1-y-y**2-6*y**3+4*y**4)+5*r**2*(-1+y)**2*(-1-22*y**3
          +11*y**4))+12*logy*r**4*(-1+y)**3*(-1+r**2+y)**2*(r**14*(-1+y)**3-2*r**12*(21
          -64*y+66*y**2-46*y**3+23*y**4)+r**10*(445-1321*y+1254*y**2-498*y**3
          +173*y**4-53*y**5)+8*(-1+y)**4*(1+3*y+6*y**2+5*y**3-y**4-8*y**5
          +4*y**6)-2*r**4*(-1+y)**2*(173+134*y+131*y**2+306*y**3-659*y**4+148*y**5
          +7*y**6)+4*r**8*(237-468*y+207*y**2+182*y**3-53*y**4-100*y**5+15*y**6)
          +r**2*(-1+y)**3*(65+114*y+147*y**2+376*y**3-65*y**4-106*y**5+29*y**6)
          +r**6*(1213-1755*y+105*y**2+1905*y**3-2925*y**4+2147*y**5-745*y**6
          +55*y**7))+r**2*(-1+y)**2*(-1+r**2+y)**3*(r**18*(-1+y)**4+3*r**16*(
          -1+y)**2*(-7+13*y-5*y**2+y**3)-2*r**14*(-155+584*y-792*y**2+492*y**3
          -149*y**4+4*y**6)+r**12*(-1350+5046*y-6576*y**2+2664*y**3+934*y**4
          -966*y**5+224*y**6-56*y**7)-(-1+y)**5*(-7-28*y-70*y**2-130*y**3
          -78*y**4+88*y**5-14*y**6-2*y**7+y**8)-6*r**4*(-1+y)**3*(377+550*y
          +617*y**2+252*y**3-773*y**4-310*y**5+395*y**6-36*y**7+8*y**8)-r**2*(
          -1+y)**4*(173+444*y+786*y**2-512*y**3-952*y**4-1060*y**5+910*y**6
          -40*y**7+11*y**8)-6*r**10*(246-710*y+703*y**2-1012*y**3+1925*y**4
          -1702*y**5+641*y**6-112*y**7+21*y**8)-2*r**6*(-1+y)**2*(1491+786*y
          -261*y**2-3492*y**3+3829*y**4-1582*y**5+1493*y**6-280*y**7+56*y**8)
          -2*r**8*(2602-6112*y+3513*y**2+9743*y**3-20467*y**4+15483*y**5-6773*y**6
          +2417*y**7-483*y**8+77*y**9)))*math.log(mu0**2/r**2))/(-17280*logy**3*r**12*(-1
          +y)**6+10*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -4320*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-360*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1
          +y)**4-(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1
          +y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(0,'SLT',y/2,r))/(2880*logy**2*r**8*(-1+y)**4+480*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(-720*logy**2*r**8*(1+r**2)*(-1+y)**6+24*logy*r**4*(-1+y)**4*(3*r**10*(
          -1+y)**2-5*r**8*(5-10*y+5*y**2+y**3)+5*r**2*(-1+y)**2*(5-16*y**3
          +2*y**4)-5*r**6*(12-12*y-6*y**2+4*y**3+5*y**4)+(-1+y)**3*(3+3*y
          +3*y**2-32*y**3+8*y**4)-15*r**4*(-4+12*y-10*y**2-2*y**3+3*y**4+y**5))
          -(-1+y)**2*(-1+r**2+y)**2*(r**14*(-1+y)**4+r**12*(-1+y)**2*(-21+40*y
          -17*y**2+12*y**3)+r**10*(-1+y)**2*(-3-26*y+28*y**2-90*y**3+21*y**4)
          +r**8*(743-2470*y+2765*y**2-330*y**3-1465*y**4+832*y**5-115*y**6)
          +(-1+y)**4*(1+2*y+3*y**2-26*y**3-11*y**4-12*y**5-13*y**6+16*y**7)
          +r**4*(-1+y)**2*(-3+32*y-y**2+360*y**3-1265*y**4+568*y**5+33*y**6
          +36*y**7)+r**2*(-1+y)**3*(21+19*y+17*y**2-341*y**3+109*y**4-17*y**5
          -15*y**6+47*y**7)+r**6*(743-1988*y+1560*y**2-1500*y**3+3930*y**4
          -3948*y**5+1188*y**6+20*y**7-5*y**8)))*nlo.X1El(0,'SM',y/2,r))/(34560*logy**3*r**12*(
          -1+y)**6-20*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +8640*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+720*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(1,'SLT',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +(2*api*(-1+y)**2*y**3*(-1+r**2+y)**3*nlo.X1El(1,'SM',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      res += resNP*wc.SLT

    if wc.T2 != 0:
      resNP = 0
      resNP +=((-1440*logy**2*r**8*(1+r**2)*(-1+y)**4+48*logy*r**4*(-1+y)**3*(-25*r**8*(
          -1+y)+3*r**10*(-1+y)-30*r**4*(2-4*y+y**2+y**3)-10*r**6*(-6+3*y**2
          +y**3)+(-1+y)**3*(-3-6*y-9*y**2+8*y**3)+5*r**2*(-5+5*y+8*y**3
          -11*y**4+3*y**5))-2*(-1+y)**2*(-1+r**2+y)**2*(1+r**14*(-1+y)**2
          -16*y**3+30*y**4-16*y**5+y**8+r**12*(-21+40*y-17*y**2+6*y**3)+r**10*(
          -3-26*y+28*y**2-54*y**3+15*y**4)+r**2*(-1+y)**3*(21+61*y+118*y**2
          -2*y**3+y**4+y**5)+r**4*(-1+y)**2*(-3+26*y+54*y**2+352*y**3-15*y**4
          +6*y**5)+r**8*(743-984*y+54*y**2+332*y**3-85*y**4+20*y**5)+r**6*(743
          -502*y-187*y**2-732*y**3+733*y**4-70*y**5+15*y**6)))/(720*logy**2*r**8*(
          -1+y)**4+120*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(138240*logy**3*r**14*(-1+y)**6
          +2304*logy**2*r**8*(-1+y)**4*(-3*r**10*(-1+y)**2+30*r**4*(-1+y)**2*(-4
          +y**3)+10*r**8*(8-16*y+8*y**2+y**3)+10*r**6*(4+10*y-23*y**2+9*y**3
          +2*y**4)+8*(-1+y)**3*(-1-y-y**2-6*y**3+4*y**4)+5*r**2*(-1+y)**2*(
          -1-22*y**3+11*y**4))-192*logy*r**4*(-1+y)**3*(-1+r**2+y)**2*(r**14*(
          -1+y)**3-2*r**12*(21-64*y+66*y**2-46*y**3+23*y**4)+r**10*(445-1321*y
          +1254*y**2-498*y**3+173*y**4-53*y**5)+8*(-1+y)**4*(1+3*y+6*y**2
          +5*y**3-y**4-8*y**5+4*y**6)-2*r**4*(-1+y)**2*(173+134*y+131*y**2
          +306*y**3-659*y**4+148*y**5+7*y**6)+4*r**8*(237-468*y+207*y**2+182*y**3
          -53*y**4-100*y**5+15*y**6)+r**2*(-1+y)**3*(65+114*y+147*y**2+376*y**3
          -65*y**4-106*y**5+29*y**6)+r**6*(1213-1755*y+105*y**2+1905*y**3-2925*y**4
          +2147*y**5-745*y**6+55*y**7))-16*r**2*(-1+y)**2*(-1+r**2+y)**3*(r**18*(
          -1+y)**4+3*r**16*(-1+y)**2*(-7+13*y-5*y**2+y**3)-2*r**14*(-155+584*y
          -792*y**2+492*y**3-149*y**4+4*y**6)+r**12*(-1350+5046*y-6576*y**2
          +2664*y**3+934*y**4-966*y**5+224*y**6-56*y**7)-(-1+y)**5*(-7-28*y
          -70*y**2-130*y**3-78*y**4+88*y**5-14*y**6-2*y**7+y**8)-6*r**4*(-1
          +y)**3*(377+550*y+617*y**2+252*y**3-773*y**4-310*y**5+395*y**6-36*y**7
          +8*y**8)-r**2*(-1+y)**4*(173+444*y+786*y**2-512*y**3-952*y**4-1060*y**5
          +910*y**6-40*y**7+11*y**8)-6*r**10*(246-710*y+703*y**2-1012*y**3
          +1925*y**4-1702*y**5+641*y**6-112*y**7+21*y**8)-2*r**6*(-1+y)**2*(1491
          +786*y-261*y**2-3492*y**3+3829*y**4-1582*y**5+1493*y**6-280*y**7
          +56*y**8)-2*r**8*(2602-6112*y+3513*y**2+9743*y**3-20467*y**4+15483*y**5
          -6773*y**6+2417*y**7-483*y**8+77*y**9))))/(-25920*logy**3*r**12*(-1+y)**6
          +15*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)
          +2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3-6480*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -540*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(
          -1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y
          -y**2+y**3))**2))
      resNP += ((api*muWC*(276480*logy**3*r**12*(-1+r**2)*(-1+y)**6-23040*logy**2*r**8*(
          -1+y)**3*(-(r**10*(-1+y)**3)+r**8*(15-45*y+45*y**2+3*y**3-10*y**4)
          +r**2*(-1+y)**3*(-15+12*y**3+5*y**4)+(-1+y)**3*(-1-14*y**3+11*y**4)
          -2*r**6*(8-42*y+69*y**2-47*y**3+2*y**4+6*y**5)+2*r**4*(-8+6*y+21*y**2
          -41*y**3+30*y**4-9*y**5+y**6))+384*logy*r**4*(-1+y)**2*(-1+r**2+y)**2*(
          -9*r**14*(-1+y)**4+(-1+y)**5*(-9-27*y-54*y**2+18*y**3+19*y**4+13*y**5)
          +r**12*(23-74*y+66*y**2+36*y**3-121*y**4+70*y**5)+r**2*(-1+y)**4*(
          -23-28*y-15*y**2-173*y**4-76*y**5+35*y**6)+r**10*(791-3072*y+4411*y**2
          -2592*y**3+769*y**4-472*y**5+165*y**6)+5*r**8*(-53+298*y-503*y**2
          +1116*y**3-1055*y**4+214*y**5+27*y**6+4*y**7)+r**4*(-1+y)**2*(-791
          +92*y+59*y**2-2450*y**3+3035*y**4-1264*y**5+113*y**6+6*y**7)-5*r**6*(
          -53+20*y+192*y**2-484*y**3+426*y**4-260*y**5+296*y**6-156*y**7+19*y**8))
          -32*(-1+y)*(-1+r**2+y)**3*(r**20*(-1+y)**5+r**18*(-1+y)**2*(14-39*y
          +33*y**2-19*y**3+3*y**4)-r**16*(483-2268*y+4155*y**2-3834*y**3+1943*y**4
          -522*y**5+3*y**6+8*y**7)+r**14*(3612-16482*y+28710*y**2-23184*y**3
          +7372*y**4+538*y**5-902*y**6+232*y**7-56*y**8)+(-1+y)**6*(1+4*y
          +10*y**2+38*y**3+26*y**4-24*y**5+18*y**6+6*y**7+y**8)-r**2*(-1+y)**5*(
          -14-39*y-72*y**2-444*y**3-92*y**4+222*y**5-264*y**6-12*y**7-6*y**8
          +y**9)-r**4*(-1+y)**4*(-483-819*y-1068*y**2+186*y**3+686*y**4+176*y**5
          -2020*y**6+254*y**7-43*y**8+11*y**9)-2*r**6*(-1+y)**3*(-1806-1017*y
          -468*y**2+739*y**3-302*y**4-711*y**5-1120*y**6+245*y**7-104*y**8+24*y**9)
          -2*r**8*(-1+y)**2*(-753-117*y+1194*y**2+14193*y**3-21686*y**4+7773*y**5
          -2838*y**6+1011*y**7-273*y**8+56*y**9)-2*r**12*(753-3882*y+6804*y**2
          -6907*y**3+74*y**4+9111*y**5-8432*y**6+2599*y**7-343*y**8+63*y**9)
          -2*r**10*y*(-786+2358*y-23151*y**2+51289*y**3-46899*y**4+26181*y**5
          -11721*y**6+3135*y**7-483*y**8+77*y**9))))/(77760*logy**3*r**12*(-1+y)**6
          -45*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)
          +2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3+19440*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +1620*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2))
      resNP += ((muG*(8640*logy**3*r**10*(-10+r**2+3*r**4)*(-1
          +y)**6-144*logy**2*r**6*(-1+y)**3*(73*r**12*(-1+y)**3+4*(-1+y)**4*(-13
          -13*y-13*y**2+2*y**3+12*y**4)+r**10*(387-1161*y+1161*y**2-757*y**3
          +170*y**4)+5*r**4*(-1+y)**2*(153-513*y+180*y**2+284*y**3-123*y**4
          +7*y**5)-10*r**8*(-48+90*y-9*y**2-5*y**3-18*y**4+10*y**5)+r**2*(
          -1+y)**3*(-753+1250*y**3-705*y**4+128*y**5)-10*r**6*(226-696*y+723*y**2
          -349*y**3+184*y**4-117*y**5+29*y**6))+12*logy*r**2*(-1+y)**2*(-1+r**2
          +y)**2*(53*r**16*(-1+y)**4-r**14*(651-2498*y+3482*y**2-1980*y**3+91*y**4
          +254*y**5)+r**12*(-773+2536*y-3131*y**2+1076*y**3-1295*y**4+2244*y**5
          -657*y**6)-2*(-1+y)**5*(-1-3*y-6*y**2-28*y**3-25*y**4-21*y**5+24*y**6)
          +r**10*(14153-48086*y+55575*y**2-39676*y**3+22063*y**4-6066*y**5+1097*y**6
          -100*y**7)+r**2*(-1+y)**4*(399+794*y+1185*y**2+216*y**3-851*y**4
          -1402*y**5+531*y**6+128*y**7)+r**4*(-1+y)**3*(2083+2537*y+2373*y**2
          -7421*y**3+329*y**4-1989*y**5+487*y**6+201*y**7)+r**6*(-1+y)**2*(-14237
          +12204*y+3105*y**2+28618*y**3-33327*y**4+9880*y**5-2781*y**6+258*y**7)
          +r**8*(-9819+38552*y-50930*y**2+5400*y**3+37340*y**4-29236*y**5+12398*y**6
          -4140*y**7+435*y**8))+(-1+y)*(-1+r**2+y)**3*(5*r**20*(-1+y)**5+r**18*(
          -1+y)**2*(4+3*y-33*y**2-29*y**3+15*y**4)+r**16*(-1009+4412*y-7273*y**2
          +5902*y**3-2733*y**4+646*y**5+255*y**6-40*y**7)-(-1+y)**6*(-39-156*y
          -390*y**2-554*y**3-358*y**4+232*y**5+226*y**6+118*y**7+41*y**8)-2*r**14*(
          -8136+35577*y-58575*y**2+43286*y**3-10056*y**4-4441*y**5+3363*y**6
          -758*y**7+140*y**8)-r**2*(-1+y)**5*(-1084-3159*y-6120*y**2-3328*y**3
          +1360*y**4+7130*y**5-392*y**6+424*y**7+124*y**8+5*y**9)-r**4*(-1+y)**4*(
          -2147-5923*y-9108*y**2+1846*y**3-5418*y**4-4028*y**5+13652*y**6+3282*y**7
          -131*y**8+55*y**9)-2*r**6*(-1+y)**3*(11144+2681*y-376*y**2-58259*y**3
          +13346*y**4-11753*y**5+15500*y**6+3227*y**7-630*y**8+120*y**9)-2*r**8*(
          -1+y)**2*(-36405+60453*y-7350*y**2+46427*y**3-136886*y**4+65819*y**5
          -12854*y**6+5449*y**7-1493*y**8+280*y**9)-2*r**12*(24031-105488*y
          +170464*y**2-125905*y**3+13354*y**4+56321*y**5-43796*y**6+11677*y**7
          -1773*y**8+315*y**9)-2*r**10*(5780-1408*y-37468*y**2-50113*y**3+265687*y**4
          -310213*y**5+182987*y**6-66511*y**7+13301*y**8-2427*y**9+385*y**10))))/(25920*logy**3*r**12*(
          -1+y)**6-15*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +6480*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+540*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*muWC**2*(-207360*logy**3*r**14*(
          -1+y)**6+1152*logy**2*r**8*(-1+y)**2*(9*r**10*(-1+y)**4+5*r**2*(-1+y)**4*(3
          -30*y**3+11*y**4)-10*r**8*(24-96*y+144*y**2-81*y**3+10*y**4+5*y**5)
          +4*(-1+y)**4*(-6-25*y**4+16*y**5)-10*r**6*(12+6*y-117*y**2+195*y**3
          -91*y**4-13*y**5+14*y**6)-30*r**4*(-12+48*y-72*y**2+35*y**3+14*y**4
          -12*y**5-4*y**6+3*y**7))-96*logy*r**4*(-1+y)*(-1+r**2+y)**2*(-3*r**14*(
          -1+y)**5+2*r**12*(63-318*y+645*y**2-678*y**3+463*y**4-236*y**5+61*y**6)
          +r**10*(-1335+6633*y-13023*y**2+12309*y**3-6341*y**4+2387*y**5-805*y**6
          +175*y**7)+8*(-1+y)**4*(-3-3*y-3*y**2+36*y**3-31*y**4-3*y**5-3*y**6
          -8*y**7+8*y**8)-4*r**8*(711-2826*y+4140*y**2-660*y**3-2818*y**4+1844*y**5
          -186*y**6-134*y**7+9*y**8)+2*r**4*(-1+y)**2*(519-636*y+108*y**2+1734*y**3
          -1244*y**4-764*y**5+780*y**6-310*y**7+53*y**8)+r**2*(-1+y)**3*(-195
          +48*y+48*y**2+1428*y**3-2534*y**4+1456*y**5+48*y**6-532*y**7+153*y**8)
          -r**6*(3639-12543*y+14484*y**2-5940*y**3+7278*y**4-12422*y**5+5180*y**6
          +948*y**7-693*y**8+69*y**9))+8*(-1+r**2+y)**3*(3*r**20*(-1+y)**6+4*(
          -1+y)**7*y**3*(18+17*y+18*y**3+6*y**4+y**5)+r**18*(-1+y)**2*(-63
          +243*y-342*y**2+240*y**3-79*y**4+13*y**5)+2*r**16*(465-2682*y+6345*y**2
          -8088*y**3+6157*y**4-2912*y**5+783*y**6-98*y**7+6*y**8)+r**2*(-1+y)**6*(
          -21-63*y-126*y**2+1140*y**3+460*y**4-26*y**5+798*y**6-12*y**7+9*y**8
          +y**9)-2*r**14*(2025-11619*y+27027*y**2-33237*y**3+22495*y**4-7481*y**5
          +489*y**6+153*y**7+12*y**8+16*y**9)+r**12*(-4428+21636*y-42642*y**2
          +26784*y**3+864*y**4+14840*y**5-32952*y**6+19952*y**7-4828*y**8+388*y**9
          -94*y**10)+r**4*(-1+y)**4*(-519-294*y-213*y**2-888*y**3+1178*y**4
          -1748*y**5-4598*y**6+3640*y**7+821*y**8-22*y**9+3*y**10)-2*r**6*(-1
          +y)**3*(3393-1836*y-954*y**2-6600*y**3+18444*y**4-9344*y**5+3222*y**6
          -728*y**7-1061*y**8+20*y**9+4*y**10)-2*r**8*(-1+y)**2*(4473-6588*y
          -1026*y**2-24360*y**3+56176*y**4-24024*y**5-340*y**6+1560*y**7-429*y**8
          -68*y**9+26*y**10)-2*r**10*(7806-33948*y+55017*y**2-10281*y**3-64504*y**4
          +76964*y**5-47706*y**6+22590*y**7-7742*y**8+2016*y**9-263*y**10+51*y**11))))/(
          -77760*logy**3*r**12*(-1+y)**6+45*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)
          -2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(
          -1-y-y**2+y**3))**3-19440*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-1620*logy*r**4*(-1+y)**2*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((mupi*(25920*logy**3*r**12*(1
          +r**2)*(-1+y)**6-144*logy**2*r**8*(-1+y)**2*(33*r**10*(-1+y)**4+5*r**2*(
          -1+y)**4*(51-96*y**3+7*y**4)+5*r**8*(-51+204*y-306*y**2+198*y**3
          -79*y**4+10*y**5)+(-1+y)**4*(-33+210*y**3-365*y**4+128*y**5)-10*r**6*(48
          -138*y+99*y**2+42*y**3-35*y**4-14*y**5+10*y**6)-30*r**4*(-16+82*y
          -159*y**2+132*y**3-43*y**4+15*y**5-18*y**6+7*y**7))+12*logy*r**4*(
          -1+y)*(-1+r**2+y)**2*(21*r**14*(-1+y)**5+r**12*(321-1563*y+3000*y**2
          -2802*y**3+1381*y**4-371*y**5+34*y**6)+r**10*(-297+1677*y-3597*y**2
          +3609*y**3-2599*y**4+1051*y**5+301*y**6-145*y**7)+r**8*(-6483+27873*y
          -45135*y**2+29565*y**3-10021*y**4+4283*y**5-1317*y**6+727*y**7-132*y**8)
          +(-1+y)**4*(-21-21*y-21*y**2+279*y**3-283*y**4-27*y**5-27*y**6
          -167*y**7+128*y**8)+r**4*(-1+y)**2*(-297+105*y+333*y**2-591*y**3
          +11479*y**4-15953*y**5+7251*y**6-1561*y**7+194*y**8)+r**2*(-1+y)**3*(
          -321+42*y+42*y**2+2850*y**3-4504*y**4+2102*y**5+54*y**6-626*y**7
          +201*y**8)+r**6*(-6483+23991*y-31548*y**2+22020*y**3-28206*y**4+35134*y**5
          -18700*y**6+4884*y**7-1239*y**8+147*y**9))-(-1+r**2+y)**3*(3*r**20*(
          -1+y)**6+r**18*(-1+y)**2*(-84+327*y-468*y**2+324*y**3-92*y**4+17*y**5)
          +(-1+y)**7*(-3-12*y-30*y**2+30*y**3+58*y**4+72*y**5+90*y**6+30*y**7
          +5*y**8)+r**16*(411-2475*y+6111*y**2-8385*y**3+7297*y**4-4253*y**5
          +1557*y**6-407*y**7+48*y**8)+r**2*(-1+y)**6*(-84-243*y-468*y**2+948*y**3
          +644*y**4+614*y**5+804*y**6-60*y**7+5*y**9)+2*r**14*(1368-6903*y
          +13734*y**2-11367*y**3+844*y**4+4711*y**5-3138*y**6+1395*y**7-456*y**8
          +52*y**9)+r**4*(-1+y)**4*(411+420*y+321*y**2-5538*y**3+856*y**4-1966*y**5
          -2608*y**6+458*y**7+2533*y**8-206*y**9+39*y**10)+2*r**6*(-1+y)**3*(
          -1368+1305*y+261*y**2+9579*y**3-33765*y**4+19915*y**5-5217*y**6-2639*y**7
          +3169*y**8-424*y**9+64*y**10)+2*r**12*(-6687+35541*y-74700*y**2+67917*y**3
          -20079*y**4-12271*y**5+19677*y**6-13141*y**7+3998*y**8-830*y**9+95*y**10)
          +2*r**8*(-1+y)**2*(-6687+11268*y-1881*y**2+9723*y**3-4715*y**4-40329*y**5
          +32513*y**6-14667*y**7+4710*y**8-851*y**9+116*y**10)+2*r**10*(-15612
          +70254*y-119466*y**2+97089*y**3-94312*y**4+140636*y**5-123828*y**6
          +68526*y**7-29084*y**8+6822*y**9-1154*y**10+129*y**11))))/(-25920*logy**3*r**12*(
          -1+y)**6+15*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -6480*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-540*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((rhoLS*(25920*logy**3*r**10*(-2-r**2
          +r**4)*(-1+y)**6-144*logy**2*r**6*(-1+y)**2*(69*r**12*(-1+y)**4+12*(
          -1+y)**5*(-1-y-y**2-6*y**3+4*y**4)+r**2*(-1+y)**4*(-309+90*y**3
          -145*y**4+64*y**5)+r**10*(-447+1788*y-2682*y**2+2238*y**3-907*y**4
          +130*y**5)+5*r**4*(-1+y)**2*(-213+642*y-537*y**2+48*y**3+167*y**4
          -106*y**5+11*y**6)-10*r**8*(-12+102*y-261*y**2+252*y**3-97*y**4-10*y**5
          +14*y**6)-30*r**6*(-54+198*y-261*y**2+164*y**3-69*y**4+37*y**5-22*y**6
          +7*y**7))+12*logy*r**2*(-1+y)*(-1+r**2+y)**2*(45*r**16*(-1+y)**5+r**14*(663
          -3225*y+6180*y**2-5766*y**3+2171*y**4+287*y**5-310*y**6)-6*(-1+y)**6*(3
          +9*y+18*y**2+4*y**3-5*y**4-17*y**5+8*y**6)-r**12*(351-2175*y+4917*y**2
          -6297*y**3+2153*y**4+3319*y**5-2861*y**6+593*y**7)+r**10*(-10269+43395*y
          -68241*y**2+66495*y**3-45815*y**4+19717*y**5-5559*y**6+1025*y**7+12*y**8)
          +r**2*(-1+y)**4*(69+33*y-3*y**2-1395*y**3+679*y**4+75*y**5+111*y**6
          -193*y**7+64*y**8)+r**4*(-1+y)**2*(135+255*y-198*y**2+78*y**3+2396*y**4
          -4776*y**5+2734*y**6-278*y**7-379*y**8+153*y**9)+r**8*(12903-58119*y
          +97806*y**2-61566*y**3-15720*y**4+50420*y**5-37358*y**6+14622*y**7
          -3231*y**8+363*y**9)+r**6*(9873-36087*y+46650*y**2-30912*y**3+28886*y**4
          -43850*y**5+46372*y**6-30480*y**7+11537*y**8-2191*y**9+202*y**10))
          +(-1+r**2+y)**3*(9*r**20*(-1+y)**6+r**18*(-1+y)**2*(-36+117*y-108*y**2
          +108*y**3-92*y**4+35*y**5)+r**16*(597-2961*y+5553*y**2-5499*y**3
          +4123*y**4-2843*y**5+879*y**6+55*y**7)-2*r**14*(5952-31149*y+64620*y**2
          -67461*y**3+33098*y**4-241*y**5-8214*y**6+3675*y**7-636*y**8+116*y**9)
          +r**12*(41670-219222*y+452664*y**2-490122*y**3+235950*y**4+86758*y**5
          -186018*y**6+97306*y**7-23036*y**8+3656*y**9-566*y**10)-(-1+y)**5*(45
          +90*y+135*y**2-426*y**3-148*y**4-190*y**5+296*y**6-54*y**7+7*y**8
          +4*y**9+y**10)-r**2*(-1+y)**4*(-12+69*y+42*y**2-2523*y**3+1432*y**4
          +86*y**5-4096*y**6+5194*y**7-1764*y**8+133*y**9-2*y**10+y**11)-r**4*(
          -1+y)**3*(-879+783*y+99*y**2+8847*y**3-27890*y**4+13366*y**5-3798*y**6
          +13254*y**7-10663*y**8+3195*y**9-421*y**10+27*y**11)-2*r**6*(-1+y)**2*(3600
          -3483*y-1206*y**2+1290*y**3-7200*y**4-10142*y**5+24578*y**6-4202*y**7
          -10056*y**8+5521*y**9-1060*y**10+80*y**11)-2*r**10*(3396-34884*y+107928*y**2
          -57219*y**3-200744*y**4+402430*y**5-366198*y**6+199638*y**7-65800*y**8
          +14070*y**9-2830*y**10+333*y**11)-2*r**8*(33681-149364*y+245736*y**2
          -206181*y**3+176798*y**4-245932*y**5+264648*y**6-187106*y**7+97141*y**8
          -39208*y**9+12096*y**10-2529*y**11+220*y**12))))/(-25920*logy**3*r**12*(
          -1+y)**6+15*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -6480*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-540*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*muWC**3*(69120*logy**3*r**8*(18
          +38*r**2+21*r**4+9*r**6)*(-1+y)**7-1152*logy**2*r**4*(-1+y)**2*(27*r**14*(
          -1+y)**5+12*(-1+y)**6*(7+7*y+7*y**2-38*y**3+12*y**4)-4*r**2*(-1
          +y)**5*(-169+220*y**3-30*y**4+24*y**5)+r**12*(961-4805*y+9610*y**2
          -8560*y**3+3935*y**4-571*y**5-90*y**6)+5*r**6*(-1+y)**3*(173-1714*y
          +2225*y**2-944*y**3+505*y**4-386*y**5+33*y**6)+r**4*(-1+y)**4*(-5413
          +8653*y-1620*y**2-1730*y**3+785*y**4-1047*y**5+192*y**6)+r**10*(256
          +340*y-4730*y**2+10490*y**3-7690*y**4+1274*y**5+900*y**6-360*y**7)
          -10*r**8*(-568+2462*y-3979*y**2+3019*y**3-1109*y**4+202*y**5+21*y**6
          -87*y**7+39*y**8))+96*logy*(-1+y)*(15*r**22*(-1+y)**6+6*(-1+y)**9*(1
          +3*y+6*y**2+4*y**3-23*y**4-51*y**5+40*y**6)+2*r**2*(-1+y)**8*(-49
          -98*y-147*y**2+388*y**3-385*y**4-534*y**5+517*y**6+48*y**7)+r**20*(
          -1085+6510*y-16275*y**2+21688*y**3-18051*y**4+10470*y**5-4013*y**6
          +756*y**7)+r**4*(-1+y)**7*(2533+517*y-491*y**2-14671*y**3+10535*y**4
          +971*y**5-2769*y**6+1383*y**7+192*y**8)+r**6*(-1+y)**6*(32759-16224*y
          -8112*y**2-39352*y**3+33018*y**4+7416*y**5-13804*y**6+3336*y**7+843*y**8)
          +2*r**18*(5731-34710*y+87747*y**2-117236*y**3+94281*y**4-50886*y**5
          +20233*y**6-6192*y**7+1032*y**8)-2*r**12*(-1+y)**2*(-19729+10756*y
          +97506*y**2-184120*y**3+182182*y**4-98664*y**5+30536*y**6-7754*y**7
          +717*y**8+90*y**9)+4*r**10*(-1+y)**3*(39961-114693*y+86388*y**2+10960*y**3
          -47790*y**4+31752*y**5-16055*y**6+7173*y**7-1830*y**8+294*y**9)+4*r**8*(
          -1+y)**4*(13757-59992*y+72194*y**2-16896*y**3-19716*y**4+10716*y**5
          +513*y**6-1195*y**7-422*y**8+381*y**9)+2*r**16*(-8567+62934*y-191931*y**2
          +336490*y**3-336165*y**4+197196*y**5-75065*y**6+20310*y**7-4656*y**8
          +774*y**9)-2*r**14*(-20989+122862*y-307659*y**2+487456*y**3-547368*y**4
          +399420*y**5-163902*y**6+30584*y**7+869*y**8-1402*y**9+129*y**10))
          -8*(-1+r**2+y)**2*(33*r**22*(-1+y)**7+r**20*(-1+y)**2*(721-3539*y
          +6880*y**2-7012*y**3+3875*y**4-1225*y**5+204*y**6)+r**18*(-8129+55707*y
          -162346*y**2+265846*y**3-271674*y**4+181874*y**5-80474*y**6+23454*y**7
          -4321*y**8+447*y**9)+3*(-1+y)**7*(-99-174*y-237*y**2+718*y**3+1548*y**4
          +1090*y**5-5912*y**6+3226*y**7-289*y**8-44*y**9+13*y**10)+r**16*(35345
          -245193*y+721966*y**2-1201324*y**3+1229988*y**4-793250*y**5+323842*y**6
          -91908*y**7+22723*y**8-4373*y**9+264*y**10)+r**2*(-1+y)**6*(-169-895*y
          -1105*y**2+3077*y**3+38564*y**4-2992*y**5-89652*y**6+58480*y**7-6403*y**8
          -1081*y**9+253*y**10+3*y**11)+r**4*(-1+y)**5*(-31721+32708*y+6023*y**2
          +224252*y**3-331246*y**4+144920*y**5-62838*y**6+17368*y**7+1967*y**8
          +396*y**9+535*y**10+36*y**11)+r**6*(-1+y)**4*(-386825+779023*y-304839*y**2
          +403845*y**3-992238*y**4+599586*y**5+144534*y**6-257106*y**7+47391*y**8
          +6167*y**9+713*y**10+69*y**11)-2*r**8*(-1+y)**3*(-14493+349160*y-798623*y**2
          +386530*y**3+396538*y**4-502970*y**5+11586*y**6+160034*y**7-35645*y**8
          -1006*y**9-1115*y**10+84*y**11)-2*r**14*(363-30659*y+176081*y**2-544411*y**3
          +851156*y**4-667864*y**5+221916*y**6+24124*y**7-42187*y**8+10159*y**9
          -865*y**10+267*y**11)-2*r**10*(-1+y)**2*(-197941+750799*y-991097*y**2
          +510517*y**3+291226*y**4-628922*y**5+208914*y**6+67994*y**7-44549*y**8
          +12123*y**9-2977*y**10+393*y**11)-2*r**12*(19549-125235*y+324071*y**2
          -385509*y**3-126096*y**4+731088*y**5-502560*y**6-55140*y**7+199947*y**8
          -103381*y**9+26841*y**10-4127*y**11+552*y**12))))/(699840*logy**3*r**12*(
          -1+y)**7-405*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(
          -1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**3+174960*logy**2*r**8*(-1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+14580*logy*r**4*(-1+y)**3*(-(r**8*(-1
          +y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((rhoD*(-8640*logy**3*r**8*(18
          +38*r**2+21*r**4+9*r**6)*(-1+y)**7+144*logy**2*r**4*(-1+y)**2*(27*r**14*(
          -1+y)**5+12*(-1+y)**6*(7+7*y+7*y**2-38*y**3+12*y**4)-4*r**2*(-1
          +y)**5*(-169+220*y**3-30*y**4+24*y**5)+r**12*(961-4805*y+9610*y**2
          -8560*y**3+3935*y**4-571*y**5-90*y**6)+5*r**6*(-1+y)**3*(173-1714*y
          +2225*y**2-944*y**3+505*y**4-386*y**5+33*y**6)+r**4*(-1+y)**4*(-5413
          +8653*y-1620*y**2-1730*y**3+785*y**4-1047*y**5+192*y**6)+r**10*(256
          +340*y-4730*y**2+10490*y**3-7690*y**4+1274*y**5+900*y**6-360*y**7)
          -10*r**8*(-568+2462*y-3979*y**2+3019*y**3-1109*y**4+202*y**5+21*y**6
          -87*y**7+39*y**8))-12*logy*(-1+y)*(15*r**22*(-1+y)**6+6*(-1+y)**9*(1
          +3*y+6*y**2+4*y**3-23*y**4-51*y**5+40*y**6)+2*r**2*(-1+y)**8*(-49
          -98*y-147*y**2+388*y**3-385*y**4-534*y**5+517*y**6+48*y**7)+r**20*(
          -1085+6510*y-16275*y**2+21688*y**3-18051*y**4+10470*y**5-4013*y**6
          +756*y**7)+r**4*(-1+y)**7*(2533+517*y-491*y**2-14671*y**3+10535*y**4
          +971*y**5-2769*y**6+1383*y**7+192*y**8)+r**6*(-1+y)**6*(32759-16224*y
          -8112*y**2-39352*y**3+33018*y**4+7416*y**5-13804*y**6+3336*y**7+843*y**8)
          +2*r**18*(5731-34710*y+87747*y**2-117236*y**3+94281*y**4-50886*y**5
          +20233*y**6-6192*y**7+1032*y**8)-2*r**12*(-1+y)**2*(-19729+10756*y
          +97506*y**2-184120*y**3+182182*y**4-98664*y**5+30536*y**6-7754*y**7
          +717*y**8+90*y**9)+4*r**10*(-1+y)**3*(39961-114693*y+86388*y**2+10960*y**3
          -47790*y**4+31752*y**5-16055*y**6+7173*y**7-1830*y**8+294*y**9)+4*r**8*(
          -1+y)**4*(13757-59992*y+72194*y**2-16896*y**3-19716*y**4+10716*y**5
          +513*y**6-1195*y**7-422*y**8+381*y**9)+2*r**16*(-8567+62934*y-191931*y**2
          +336490*y**3-336165*y**4+197196*y**5-75065*y**6+20310*y**7-4656*y**8
          +774*y**9)-2*r**14*(-20989+122862*y-307659*y**2+487456*y**3-547368*y**4
          +399420*y**5-163902*y**6+30584*y**7+869*y**8-1402*y**9+129*y**10))
          +(-1+r**2+y)**2*(33*r**22*(-1+y)**7+r**20*(-1+y)**2*(721-3539*y+6880*y**2
          -7012*y**3+3875*y**4-1225*y**5+204*y**6)+r**18*(-8129+55707*y-162346*y**2
          +265846*y**3-271674*y**4+181874*y**5-80474*y**6+23454*y**7-4321*y**8
          +447*y**9)+3*(-1+y)**7*(-99-174*y-237*y**2+718*y**3+1548*y**4+1090*y**5
          -5912*y**6+3226*y**7-289*y**8-44*y**9+13*y**10)+r**16*(35345-245193*y
          +721966*y**2-1201324*y**3+1229988*y**4-793250*y**5+323842*y**6-91908*y**7
          +22723*y**8-4373*y**9+264*y**10)+r**2*(-1+y)**6*(-169-895*y-1105*y**2
          +3077*y**3+38564*y**4-2992*y**5-89652*y**6+58480*y**7-6403*y**8-1081*y**9
          +253*y**10+3*y**11)+r**4*(-1+y)**5*(-31721+32708*y+6023*y**2+224252*y**3
          -331246*y**4+144920*y**5-62838*y**6+17368*y**7+1967*y**8+396*y**9+535*y**10
          +36*y**11)+r**6*(-1+y)**4*(-386825+779023*y-304839*y**2+403845*y**3
          -992238*y**4+599586*y**5+144534*y**6-257106*y**7+47391*y**8+6167*y**9
          +713*y**10+69*y**11)-2*r**8*(-1+y)**3*(-14493+349160*y-798623*y**2
          +386530*y**3+396538*y**4-502970*y**5+11586*y**6+160034*y**7-35645*y**8
          -1006*y**9-1115*y**10+84*y**11)-2*r**14*(363-30659*y+176081*y**2-544411*y**3
          +851156*y**4-667864*y**5+221916*y**6+24124*y**7-42187*y**8+10159*y**9
          -865*y**10+267*y**11)-2*r**10*(-1+y)**2*(-197941+750799*y-991097*y**2
          +510517*y**3+291226*y**4-628922*y**5+208914*y**6+67994*y**7-44549*y**8
          +12123*y**9-2977*y**10+393*y**11)-2*r**12*(19549-125235*y+324071*y**2
          -385509*y**3-126096*y**4+731088*y**5-502560*y**6-55140*y**7+199947*y**8
          -103381*y**9+26841*y**10-4127*y**11+552*y**12))))/(77760*logy**3*r**12*(
          -1+y)**7-45*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(
          -1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**3+19440*logy**2*r**8*(-1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+1620*logy*r**4*(-1+y)**3*(-(r**8*(-1
          +y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(34560*logy**3*r**14*(
          -1+y)**6+576*logy**2*r**8*(-1+y)**4*(-3*r**10*(-1+y)**2+30*r**4*(-1+y)**2*(
          -4+y**3)+10*r**8*(8-16*y+8*y**2+y**3)+10*r**6*(4+10*y-23*y**2
          +9*y**3+2*y**4)+8*(-1+y)**3*(-1-y-y**2-6*y**3+4*y**4)+5*r**2*(
          -1+y)**2*(-1-22*y**3+11*y**4))-48*logy*r**4*(-1+y)**3*(-1+r**2+y)**2*(r**14*(
          -1+y)**3-2*r**12*(21-64*y+66*y**2-46*y**3+23*y**4)+r**10*(445-1321*y
          +1254*y**2-498*y**3+173*y**4-53*y**5)+8*(-1+y)**4*(1+3*y+6*y**2
          +5*y**3-y**4-8*y**5+4*y**6)-2*r**4*(-1+y)**2*(173+134*y+131*y**2
          +306*y**3-659*y**4+148*y**5+7*y**6)+4*r**8*(237-468*y+207*y**2+182*y**3
          -53*y**4-100*y**5+15*y**6)+r**2*(-1+y)**3*(65+114*y+147*y**2+376*y**3
          -65*y**4-106*y**5+29*y**6)+r**6*(1213-1755*y+105*y**2+1905*y**3-2925*y**4
          +2147*y**5-745*y**6+55*y**7))-4*r**2*(-1+y)**2*(-1+r**2+y)**3*(r**18*(
          -1+y)**4+3*r**16*(-1+y)**2*(-7+13*y-5*y**2+y**3)-2*r**14*(-155+584*y
          -792*y**2+492*y**3-149*y**4+4*y**6)+r**12*(-1350+5046*y-6576*y**2
          +2664*y**3+934*y**4-966*y**5+224*y**6-56*y**7)-(-1+y)**5*(-7-28*y
          -70*y**2-130*y**3-78*y**4+88*y**5-14*y**6-2*y**7+y**8)-6*r**4*(-1
          +y)**3*(377+550*y+617*y**2+252*y**3-773*y**4-310*y**5+395*y**6-36*y**7
          +8*y**8)-r**2*(-1+y)**4*(173+444*y+786*y**2-512*y**3-952*y**4-1060*y**5
          +910*y**6-40*y**7+11*y**8)-6*r**10*(246-710*y+703*y**2-1012*y**3
          +1925*y**4-1702*y**5+641*y**6-112*y**7+21*y**8)-2*r**6*(-1+y)**2*(1491
          +786*y-261*y**2-3492*y**3+3829*y**4-1582*y**5+1493*y**6-280*y**7
          +56*y**8)-2*r**8*(2602-6112*y+3513*y**2+9743*y**3-20467*y**4+15483*y**5
          -6773*y**6+2417*y**7-483*y**8+77*y**9)))*math.log(mu0**2/r**2))/(-8640*logy**3*r**12*(
          -1+y)**6+5*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -2160*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-180*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(720*logy**2*r**8*(11+5*r**2)*(
          -1+y)**6-24*logy*r**4*(-1+y)**4*(9*r**10*(-1+y)**2+5*r**8*(-13+26*y
          -13*y**2+y**3)-5*r**2*(-1+y)**2*(-67+38*y**3+2*y**4)+(-1+y)**3*(39
          +39*y+39*y**2-76*y**3+4*y**4)-5*r**6*(120-180*y+30*y**2+14*y**3
          +7*y**4)-15*r**4*(-24+92*y-90*y**2+12*y**3+7*y**4+3*y**5))-(-1
          +y)**2*(-1+r**2+y)**2*(7*r**14*(-1+y)**4-r**12*(-1+y)**2*(57-100*y
          +29*y**2+24*y**3)-r**10*(-1+y)**2*(-759+1202*y-256*y**2-258*y**3
          +81*y**4)+r**8*(-4969+17330*y-20755*y**2+8250*y**3+1835*y**4-2156*y**5
          +425*y**6)-r**4*(-1+y)**2*(711+196*y-203*y**2+1620*y**3-3475*y**4
          +1004*y**5+339*y**6+48*y**7)-(-1+y)**4*(23+46*y+69*y**2-10*y**3
          -25*y**4-48*y**5-71*y**6+56*y**7)-r**2*(-1+y)**3*(393+347*y+301*y**2
          -865*y**3-55*y**4-73*y**5-27*y**6+139*y**7)+r**6*(-6919+19324*y-16320*y**2
          +5940*y**3-8130*y**4+8604*y**5-2244*y**6-340*y**7+85*y**8)))*nlo.X1El(0,'SM',y/2,r))/(8640*logy**3*r**12*(
          -1+y)**6-5*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +2160*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+180*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1
          +y)**4-(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1
          +y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(0,'T2',y/2,r))/(2880*logy**2*r**8*(-1+y)**4+480*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(-144*logy*r**4*(-1+y)**4-4*(-1+y)**2*(-3*r**8*(-1+y)**2-2*r**6*(
          -12+24*y-12*y**2+y**3)+6*r**4*y*(6-9*y+y**2+2*y**3)+6*r**2*(-1
          +y)**2*(-4+3*y**3)+(-1+y)**3*(-3-3*y-3*y**2+7*y**3)))*nlo.X1El(1,'SM',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(1,'T2',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.T2

    if wc.SRT != 0:
      resNP = 0
      resNP +=((rhoLS*(-720*logy**2*r**5*(1+3*r**2)*(-1+y)**4+60*logy*r*(-1+y)**2*(-41*r**8*(
          -1+y)**2+5*r**10*(-1+y)**2+2*r**4*(-1+y)**2*(29-12*y-6*y**2+y**3)
          -(-1+y)**3*(-1-y-y**2+y**3)-2*r**6*(13+10*y-41*y**2+20*y**3)
          -r**2*(-1+y)**2*(-5-4*y**3+3*y**4))-2*r*(-1+y)**2*(-1+r**2+y)**2*(
          -85+5*r**10*(-1+y)**2+30*y+15*y**2+159*y**3-136*y**4+9*y**5+4*y**6
          +4*y**7+r**8*(-75+140*y-55*y**2+9*y**3)+r**6*(160-330*y+120*y**2
          -56*y**3+y**4)-r**4*(-880+1010*y+50*y**2-434*y**3-17*y**4+y**5)
          +r**2*(555-260*y-155*y**2+174*y**3-82*y**4+32*y**5+6*y**6))))/(2160*logy**2*r**8*(
          -1+y)**4+360*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+15*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      res += resNP*wc.SRT

    return res*par.mbkin**1


def moment_2_KIN_MS(elcut, par, hqe, wc, **kwargs):
    y=2*elcut/par.mbkin
    r=par.mcMS/par.mbkin
    mu0=par.scale_mcMS/par.mbkin
    muWC=par.scale_mbkin/par.mbkin
    api=par.alphas/math.pi

    rhoD=hqe.rhoD/par.mbkin**3
    rhoLS=hqe.rhoLS/par.mbkin**3
    muG=hqe.muG/par.mbkin**2

    mupi=hqe.mupi/par.mbkin**2

    logy =math.log((1-y)/r**2)

    res = 0
    if wc.ReVL != 0:
      resNP = 0
      resNP +=((api*(-3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6-120*logy*r**4*(
          -1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(-67+98*y
          -13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3-2*y**4
          +y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)+2*r**2*(
          -1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y-421*y**2
          +40*y**3+73*y**4-32*y**5+9*y**6))-(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(
          -1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1
          +y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(
          -4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y
          +45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)
          +2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5
          -56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(0,'SM',y/2,r))/(518400*logy**3*r**12*(
          -1+y)**6-300*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +129600*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+10800*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2
          +3*r**4)*(-1+y)**6+120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(
          -1+y)**2-5*r**8*(-67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y
          -18*y**2+22*y**3-2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3
          -16*y**4+2*y**5)+2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(
          -151+482*y-421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(
          -1+r**2+y)**2*(7*r**16*(-1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2
          +27*y**3)-r**12*(-1+y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)
          +2*r**10*(-1+y)**2*(-4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)
          +5*r**8*(13422-43158*y+45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6
          -284*y**7+33*y**8)+2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3
          -2300*y**4+277*y**5-56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436
          -542*y+757*y**2+11016*y**3-25545*y**4+20466*y**5-4753*y**6-652*y**7
          +89*y**8)+(-1+y)**4*(67+134*y+201*y**2+428*y**3-55*y**4-22*y**5
          -89*y**6-156*y**7+92*y**8)-2*r**6*(-17964+49281*y-40854*y**2+5986*y**3
          +8446*y**4-11636*y**5+9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(0,'VL',y/2,r))/(1036800*logy**3*r**12*(
          -1+y)**6-600*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +259200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(60*logy*r**4*(3+r**2)*(-1
          +y)**4+(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1
          +y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(1,'SM',y/2,r))/(720*logy**2*r**8*(-1+y)**4+120*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1+y)**4-(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(1,'VL',y/2,r))/(1440*logy**2*r**8*(
          -1+y)**4+240*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2)-(2*api*(-1+y)**2*nlo.X1El(2,'SM',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          )
      resNP += ((api*(-1+y)**2*nlo.X1El(2,'VL',y/2,r))/(12*logy*r**4*(-1+y)**2-r**8*(
          -1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.ReVL

    if wc.ReVR != 0:
      resNP = 0
      resNP +=((-43200*logy**3*r**11*(3+4*r**2+4*r**4+3*r**6)*(-1+y)**6-720*logy**2*r**7*(
          -1+y)**4*(71*r**12*(-1+y)**2+22*r**14*(-1+y)**2+r**10*(627-714*y-183*y**2
          +380*y**3-60*y**4)-2*(-1+y)**4*(11+22*y+33*y**2-46*y**3+10*y**4)
          +10*r**8*(13+46*y-95*y**2+40*y**3-y**4+2*y**5)+r**4*(-1+y)**2*(-627
          +540*y+270*y**2-320*y**3+95*y**4+12*y**5)-r**2*(-1+y)**3*(-71-71*y
          -71*y**2+189*y**3-136*y**4+20*y**5)+10*r**6*(-13+98*y-121*y**2-6*y**3
          +75*y**4-42*y**5+9*y**6))-12*logy*r**3*(-1+y)**3*(-1+r**2+y)**2*(7*r**18*(
          -1+y)**3+r**16*(-296+902*y-930*y**2+378*y**3-54*y**4)+r**14*(-5915
          +15711*y-12984*y**2+2576*y**3+691*y**4-79*y**5)+(-1+y)**5*(7+28*y
          +70*y**2+120*y**3-5*y**4-212*y**5+92*y**6)+r**12*(-6509+18163*y-17985*y**2
          +4515*y**3+2610*y**4-946*y**5+152*y**6)+2*r**2*(-1+y)**4*(-148-451*y
          -916*y**2+260*y**3+30*y**4+413*y**5-234*y**6+46*y**7)-r**6*(-1+y)**2*(6509
          +5145*y+6331*y**2-36325*y**3+24015*y**4-2669*y**5-1095*y**6+89*y**7)
          +r**4*(-1+y)**3*(5915+9796*y+12984*y**2-25840*y**3+9875*y**4+920*y**5
          -906*y**6+156*y**7)+r**10*(-62873+113873*y-33585*y**2-49785*y**3+33325*y**4
          -1717*y**5-1203*y**6+165*y**7)-r**8*(62873-137619*y+69204*y**2+59092*y**3
          -78525*y**4+25977*y**5+594*y**6-1754*y**7+158*y**8))+r*(-1+y)**2*(
          -1+r**2+y)**3*(r**20*(-1+y)**4+r**18*(-1+y)**2*(-488+889*y-356*y**2
          +5*y**3)+3*r**16*(-2157+7903*y-10562*y**2+6308*y**3-1637*y**4+105*y**5)
          -(-1+y)**8*(-1-7*y-28*y**2+12*y**3+77*y**4+23*y**5+4*y**6)-2*r**14*(30632
          -95657*y+98760*y**2-24035*y**3-19975*y**4+10938*y**5-993*y**6+30*y**7)
          -r**2*(-1+y)**5*(-488-1865*y-4487*y**2-3675*y**3+885*y**4+7413*y**5
          -3505*y**6+287*y**7+35*y**8)-3*r**4*(-1+y)**4*(2157+5746*y+10562*y**2
          -7610*y**3+2650*y**4-1242*y**5+1034*y**6-342*y**7+45*y**8)-2*r**12*(
          -25939+77785*y-59421*y**2-7885*y**3+22140*y**4-8381*y**5+2055*y**6
          +141*y**7+105*y**8)-2*r**6*(-1+y)**3*(-30632-34393*y-33735*y**2+161245*y**3
          -76500*y**4-8743*y**5+11613*y**6-1905*y**7+150*y**8)-2*r**8*(-1+y)**2*(
          -25939+32*y+18332*y**2+2980*y**3+8365*y**4-3866*y**5+3348*y**6-762*y**7
          +210*y**8)-6*r**10*(95352-238380*y+152376*y**2+88800*y**3-151233*y**4
          +52083*y**5+4570*y**6-4006*y**7+375*y**8+63*y**9)))/(-518400*logy**3*r**12*(
          -1+y)**6+300*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -129600*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-10800*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(518400*logy**4*r**15*(-3+4*r**2
          +12*r**4+15*r**6)*(-1+y)**8+8640*logy**3*r**11*(-1+y)**6*(303*r**14*(-1
          +y)**2+r**12*(557-1114*y+557*y**2+30*y**3)-5*r**10*(-575+430*y+505*y**2
          -494*y**3+60*y**4)+5*(-1+y)**3*(-55-55*y-55*y**2+191*y**3-112*y**4
          +20*y**5)+5*r**8*(-307+1190*y-1171*y**2+418*y**3-138*y**4+78*y**5)
          +r**2*(-1+y)**2*(-127-1150*y**3+1235*y**4-468*y**5+60*y**6)+5*r**6*(
          -431+1054*y-719*y**2+24*y**3+261*y**4-216*y**5+69*y**6)-r**4*(193
          +334*y-887*y**2+90*y**3+65*y**4+422*y**5-229*y**6+12*y**7))+144*logy**2*r**7*(
          -1+y)**4*(-1+r**2+y)**2*(421*r**18*(-1+y)**4-r**16*(-1+y)**2*(-8359
          +17560*y-10043*y**2+1942*y**3)-r**14*(-1+y)**2*(-97092+157204*y-51665*y**2
          -8304*y**3+257*y**4)-(-1+y)**5*(-833-2499*y-4998*y**2-310*y**3+2875*y**4
          +6693*y**5-6656*y**6+1528*y**7)+r**12*(90740-365364*y+577249*y**2
          -390800*y**3+34450*y**4+85820*y**5-37231*y**6+5636*y**7)+r**10*(330718
          -834456*y+612923*y**2+76590*y**3-295775*y**4+135422*y**5-35089*y**6
          +12372*y**7-1205*y**8)+r**4*(-1+y)**3*(71732+35808*y+27133*y**2-280753*y**3
          +233150*y**4-65902*y**5+8477*y**6-4393*y**7+1448*y**8)-r**2*(-1+y)**4*(5955
          +13576*y+22863*y**2-17954*y**3-3525*y**4-21670*y**5+30919*y**6-12508*y**7
          +1544*y**8)+r**6*(-1+y)**2*(31676-80900*y-42833*y**2+450852*y**3-487085*y**4
          +156424*y**5+21985*y**6-22172*y**7+4153*y**8)+r**8*(124314-274276*y
          +43999*y**2+557844*y**3-902951*y**4+566186*y**5-48799*y**6-104024*y**7
          +41281*y**8-3574*y**9))-12*logy*r**3*(-1+y)**3*(-1+r**2+y)**3*(7*r**24*(
          -1+y)**5+r**22*(-1+y)**3*(-638+1255*y-596*y**2+117*y**3)+r**20*(41204
          -197809*y+375995*y**2-355352*y**3+169948*y**4-35831*y**5+2077*y**6
          -232*y**7)+r**18*(266802-1248795*y+2320737*y**2-2166320*y**3+1038942*y**4
          -209565*y**5-9373*y**6+8280*y**7-708*y**8)-3*(-1+y)**7*(-7-35*y
          -105*y**2-211*y**3-157*y**4+167*y**5+245*y**6+115*y**7-304*y**8+92*y**9)
          +r**16*(1649289-6631428*y+9935031*y**2-6068242*y**3+135207*y**4+1487256*y**5
          -557277*y**6+59584*y**7-10458*y**8+1038*y**9)+r**6*(-1+y)**4*(-93074
          -191473*y-326709*y**2+577618*y**3-54374*y**4+583036*y**5-945652*y**6
          +443414*y**7-54328*y**8-5971*y**9+313*y**10)-r**8*(-1+y)**3*(-1309037
          +127984*y+230971*y**2+4783034*y**3-6140644*y**4+2022854*y**5+573716*y**6
          -495686*y**7+90621*y**8-1146*y**9+333*y**10)-r**2*(-1+y)**6*(1630+6583*y
          +16615*y**2+13053*y**3+909*y**4-23115*y**5+3937*y**6-2025*y**7+6857*y**8
          -3304*y**9+460*y**10)-r**4*(-1+y)**5*(-54428-148245*y-276534*y**2
          +71552*y**3+161266*y**4+317382*y**5-422970*y**6+133144*y**7+218*y**8
          -5401*y**9+816*y**10)+2*r**14*(-143350+139205*y+1127837*y**2-2245586*y**3
          +632752*y**4+1501882*y**5-1387310*y**6+398858*y**7-7974*y**8-15447*y**9
          +933*y**10)-2*r**10*(-1+y)**2*(-873366+1625157*y+179697*y**2-3995173*y**3
          +4164601*y**4-786855*y**5-774507*y**6+330283*y**7+3383*y**8-13536*y**9
          +1716*y**10)-2*r**12*(-1439316+3375459*y-1031061*y**2-3340418*y**3
          +2857764*y**4+755592*y**5-1973258*y**6+968046*y**7-192972*y**8+22321*y**9
          -3141*y**10+984*y**11))+r*(-1+y)**2*(-1+r**2+y)**4*(3*r**26*(-1+y)**6
          +r**24*(-1+y)**4*(-383+670*y-233*y**2+14*y**3)+2*r**22*(-1+y)**2*(18151
          -68058*y+92798*y**2-57364*y**3+16997*y**4-2124*y**5+10*y**6)+(-1
          +y)**10*(1+8*y+36*y**2+22*y**3-68*y**4-140*y**5-92*y**6+50*y**7
          +19*y**8+4*y**9)+2*r**20*(293461-1581600*y+3465875*y**2-3918644*y**3
          +2354738*y**4-643781*y**5+5465*y**6+24790*y**7-951*y**8+47*y**9)+r**18*(1227213
          -6151010*y+12628771*y**2-13582384*y**3+7823874*y**4-1756328*y**5-539390*y**6
          +456244*y**7-119051*y**8+14886*y**9+775*y**10)+r**2*(-1+y)**7*(1597
          +7729*y+22545*y**2+35921*y**3+20674*y**4-35858*y**5-29894*y**6-11870*y**7
          +39569*y**8-13959*y**9+661*y**10+85*y**11)+2*r**4*(-1+y)**6*(-24275
          -90386*y-213624*y**2-100138*y**3+21373*y**4+245107*y**5-124271*y**6
          +33439*y**7-37702*y**8+21687*y**9-4517*y**10+307*y**11)+2*r**6*(-1
          +y)**5*(318561+719501*y+1162698*y**2-1119772*y**3-994436*y**4-1411174*y**5
          +2889940*y**6-1153918*y**7-10753*y**8+85061*y**9-15282*y**10+1174*y**11)
          +4*r**12*(-1+y)**2*(8162815-13671650*y+576456*y**2+10153426*y**3-2301285*y**4
          -5517227*y**5+3240765*y**6+74209*y**7-424376*y**8+123675*y**9-13203*y**10
          +2295*y**11)+r**16*(10942159-49558070*y+85612431*y**2-61013654*y**3
          -3208512*y**4+33347098*y**5-20646876*y**6+4824454*y**7-325871*y**8+27612*y**9
          -6147*y**10+2976*y**11)+r**8*(-1+y)**4*(874927+790618*y+9369*y**2
          -765350*y**3-2072958*y**4+4727512*y**5-3492258*y**6+1065616*y**7-91625*y**8
          +49638*y**9-25839*y**10+5550*y**11)+r**10*(-1+y)**3*(12993683-5255233*y
          -4892007*y**2-37712275*y**3+58851726*y**4-18161794*y**5-10672230*y**6
          +7244402*y**7-1001185*y**8+8019*y**9-16179*y**10+8673*y**11)+4*r**14*(
          -4530563+19404840*y-28996867*y**2+13603930*y**3+7129940*y**4-8005778*y**5
          +264788*y**6+1140190*y**7+379035*y**8-535990*y**9+161451*y**10-16608*y**11
          +1632*y**12))))/(4665600*logy**4*r**16*(-1+y)**8+1555200*logy**3*r**12*(-1
          +y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +194400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+10800*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+225*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*muWC*(-2073600*logy**4*r**15*(
          -9-4*r**2+4*r**4+9*r**6)*(-1+y)**8-34560*logy**3*r**11*(-1+y)**5*(289*r**14*(
          -1+y)**3+5*r**12*(-43+129*y-129*y**2-29*y**3+36*y**4)+r**10*(-1341
          +1863*y+1377*y**2-4199*y**3+2260*y**4-300*y**5)-5*r**2*(-1+y)**3*(
          -43+156*y**3-61*y**4+4*y**6)+5*r**8*(369-1299*y+1587*y**2-913*y**3
          +202*y**4-30*y**5+16*y**6)+(-1+y)**3*(289-720*y**3+765*y**4-264*y**5
          +20*y**6)+5*r**6*(369-915*y+627*y**2+127*y**3-639*y**4+669*y**5-337*y**6
          +63*y**7)+r**4*(-1341+6183*y-9423*y**2+5981*y**3-1885*y**4+1011*y**5
          -593*y**6+43*y**7+24*y**8))+576*logy**2*r**7*(-1+y)**3*(-1+r**2+y)**2*(
          -627*r**18*(-1+y)**5+r**16*(-1+y)**2*(7157-22725*y+25233*y**2-9639*y**3
          +1214*y**4)+r**14*(-1+y)**2*(84412-216784*y+171771*y**2-21569*y**3
          -16309*y**4+1919*y**5)+r**12*(29532-189312*y+496143*y**2-530203*y**3
          +138710*y**4+140058*y**5-109853*y**6+30777*y**7-3852*y**8)-(-1+y)**5*(
          -627-1254*y-1881*y**2+3972*y**3-365*y**4+242*y**5-951*y**6+256*y**7
          +8*y**8)+r**10*(103202-284626*y+219221*y**2+300583*y**3-761945*y**4
          +575833*y**5-133419*y**6-35221*y**7+21137*y**8-2765*y**9)+r**2*(-1
          +y)**4*(-7157-8411*y-9665*y**2+22901*y**3-1773*y**4+4577*y**5-16609*y**6
          +10105*y**7-1576*y**8+8*y**9)+r**6*(-1+y)**2*(-29532-12120*y+7437*y**2
          +341629*y**3-507409*y**4+245247*y**5-38965*y**6+7803*y**7-3539*y**8
          +249*y**9)-r**4*(-1+y)**3*(-84412+36452*y+8561*y**2+167410*y**3-222901*y**4
          +112952*y**5-56537*y**6+31554*y**7-10395*y**8+1216*y**9)+r**8*(-103202
          +540990*y-1116495*y**2+1499655*y**3-1632985*y**4+1198139*y**5-352315*y**6
          -135955*y**7+133795*y**8-34265*y**9+2638*y**10))-48*logy*r**3*(-1+y)**2*(
          -1+r**2+y)**3*(7*r**24*(-1+y)**6-r**22*(-1+y)**3*(1134-3423*y+3465*y**2
          -1141*y**3+129*y**4)+r**20*(47816-275271*y+655056*y**2-820249*y**3
          +565086*y**4-199221*y**5+25400*y**6+1477*y**7-94*y**8)+r**18*(179938
          -1039683*y+2514552*y**2-3174711*y**3+2129372*y**4-649047*y**5+8044*y**6
          +37819*y**7-6818*y**8+534*y**9)-(-1+y)**7*(-7-28*y-70*y**2-172*y**3
          +554*y**4+1340*y**5-1882*y**6+20*y**7+777*y**8-424*y**9+92*y**10)
          +r**16*(1479163-7348959*y+14456961*y**2-13329861*y**3+4013953*y**4
          +2619231*y**5-2536881*y**6+692089*y**7-43944*y**8-1908*y**9+156*y**10)
          +r**4*(-1+y)**5*(47816+84007*y+116139*y**2-243946*y**3+44472*y**4
          -20048*y**5+66932*y**6-34794*y**7+12436*y**8-7687*y**9+1237*y**10+36*y**11)
          +2*r**12*y*(1662147-6648588*y+11954695*y**2-11886770*y**3+5136873*y**4
          +2122280*y**5-3938126*y**6+1992595*y**7-409330*y**8+8662*y**9+5493*y**10
          +69*y**11)+r**2*(-1+y)**6*(-1134-3423*y-6888*y**2+6006*y**3+66*y**4
          +2844*y**5+6876*y**6-6482*y**7-1336*y**8+2499*y**9-920*y**10+92*y**11)
          -r**6*(-1+y)**4*(179938+139993*y+155200*y**2-415367*y**3-212296*y**4
          -69772*y**5+861598*y**6-660760*y**7+169362*y**8-1829*y**9-3586*y**10
          +119*y**11)-2*r**14*(508358-1948797*y+1903188*y**2+296223*y**3-458736*y**4
          -1580193*y**5+2000031*y**6-858523*y**7+116332*y**8+26806*y**9-10605*y**10
          +516*y**11)+2*r**10*(-1+y)**2*(508358-1609709*y+885924*y**2+3467994*y**3
          -5928658*y**4+2931421*y**5+207351*y**6-569809*y**7+105466*y**8+19488*y**9
          -7929*y**10+903*y**11)+r**8*(-1+y)**3*(1479163-1526019*y-100389*y**2
          -2256693*y**3+4770486*y**4-3671352*y**5+1837320*y**6-708896*y**7+103883*y**8
          +27299*y**9-9711*y**10+909*y**11))-4*r*(-1+y)*(-1+r**2+y)**4*(r**26*(
          -1+y)**7+r**24*(-1+y)**4*(-607+1741*y-1623*y**2+397*y**3+4*y**4)
          +2*r**22*(-1+y)**2*(-21213+100435*y-187240*y**2+169300*y**3-74827*y**4
          +15041*y**5-1060*y**6+4*y**7)-(-1+y)**10*(-1-7*y-28*y**2-256*y**3
          -272*y**4+748*y**5+484*y**6-160*y**7+113*y**8+19*y**9)+2*r**20*(-306011
          +1934403*y-5140021*y**2+7342779*y**3-5918146*y**4+2467104*y**5-269235*y**6
          -157911*y**7+49189*y**8-2431*y**9+40*y**10)+r**18*(-176143+1106485*y
          -3429335*y**2+5331245*y**3-3172206*y**4-1324650*y**5+2792790*y**6-1350390*y**7
          +246665*y**8-28159*y**9+5573*y**10+525*y**11)+r**2*(-1+y)**7*(-607
          -2348*y-5712*y**2-828*y**3+19929*y**4+38708*y**5-50984*y**6+2644*y**7
          +15383*y**8-9304*y**9+1664*y**10-168*y**11+23*y**12)+2*r**4*(-1+y)**6*(21213
          +58009*y+108018*y**2-86216*y**3+41355*y**4-14581*y**5-169733*y**6
          +121375*y**7+21236*y**8-47960*y**9+15023*y**10-1851*y**11+112*y**12)
          +2*r**6*(-1+y)**5*(-306011-404348*y-462519*y**2+1506852*y**3-295842*y**4
          +6792*y**5-982382*y**6+831936*y**7-276347*y**8+21172*y**9+11749*y**10
          -4340*y**11+488*y**12)+4*r**12*(-1+y)**2*(-6346689+17071783*y-10978878*y**2
          -10263152*y**3+14988257*y**4-94405*y**5-8153331*y**6+4236809*y**7-269898*y**8
          -358772*y**9+98019*y**10-10107*y**11+1164*y**12)+r**16*(-11967921+66603547*y
          -149453787*y**2+163672189*y**3-69211024*y**4-32018008*y**5+52388880*y**6
          -24035080*y**7+3854121*y**8+282109*y**9-127461*y**10+5883*y**11+1752*y**12)
          +r**8*(-1+y)**4*(176143+49627*y+539055*y**2+2406075*y**3-7161634*y**4
          -140806*y**5+8888730*y**6-6641230*y**7+1252215*y**8+200259*y**9-64257*y**10
          -8277*y**11+2500*y**12)+r**10*(-1+y)**3*(-11967921+17171900*y-1158846*y**2
          +17932700*y**3-54254627*y**4+45517864*y**5-13589364*y**6-1282184*y**7
          +1713465*y**8-509908*y**9+83682*y**10-19716*y**11+4155*y**12)+4*r**14*(6346689
          -33701729*y+69183689*y**2-67740245*y**3+26935954*y**4+6087624*y**5
          -11723480*y**6+6678956*y**7-2864807*y**8+1051471*y**9-308593*y**10+60849*y**11
          -7260*y**12+882*y**13))))/(13996800*logy**4*r**16*(-1+y)**8+4665600*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +583200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+32400*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+675*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((muG*(-518400*logy**4*r**13*(-15+2*r**2
          +7*r**4+13*r**6+9*r**8)*(-1+y)**8+8640*logy**3*r**9*(-1+y)**5*(485*r**16*(
          -1+y)**3+3*r**14*(364-1092*y+1092*y**2-649*y**3+135*y**4)+r**12*(3596
          -8628*y+5388*y**2-1191*y**3+105*y**4-120*y**5)-(-1+y)**4*(17+17*y
          +17*y**2+287*y**3-208*y**4+20*y**5)+r**10*(-948+5964*y-10644*y**2
          +5263*y**3-225*y**4-375*y**5+115*y**6)+r**2*(-1+y)**3*(-364-575*y**3
          +1690*y**4-846*y**5+140*y**6)-5*r**8*(554-1998*y+2502*y**2-956*y**3
          -251*y**4+438*y**5-226*y**6+27*y**7)+r**4*(-1+y)**2*(3548-7148*y
          +1800*y**2+4375*y**3-4735*y**4+3072*y**5-902*y**6+80*y**7)-5*r**6*(876
          -2724*y+2868*y**2-1213*y**3+153*y**4+18*y**5+160*y**6-180*y**7+42*y**8))
          -144*logy**2*r**5*(-1+y)**3*(-1+r**2+y)**2*(-1249*r**20*(-1+y)**5+2*r**18*(
          -1+y)**2*(5663-18238*y+20736*y**2-7845*y**3+1234*y**4)+r**16*(-1
          +y)**2*(105315-253795*y+176892*y**2+12019*y**3-35104*y**4+3273*y**5)
          +(-1+y)**6*(-283-849*y-1698*y**2-170*y**3+425*y**4+1503*y**5-736*y**6
          +8*y**7)+2*r**2*(-1+y)**5*(-76+131*y+621*y**2+4449*y**3+1010*y**4
          +1966*y**5-1161*y**6-2046*y**7+756*y**8)-2*r**14*(114213-442195*y
          +569834*y**2-293872*y**3+67755*y**4-46488*y**5+47575*y**6-23064*y**7
          +3742*y**8)-2*r**6*(-1+y)**3*(10845-29300*y-12011*y**2+131282*y**3
          -270261*y**4+221785*y**5-78815*y**6+15126*y**7-2112*y**8+386*y**9)
          +r**4*(-1+y)**4*(531+3329*y+3748*y**2-62177*y**3+43824*y**4-22476*y**5
          -7379*y**6+17422*y**7-9758*y**8+1536*y**9)-r**8*(-1+y)**2*(-529704
          +1246024*y-591528*y**2-1058205*y**3+1699308*y**4-1183301*y**5+444496*y**6
          -60277*y**7-3950*y**8+1537*y**9)-r**12*(611172-2498432*y+3643768*y**2
          -2349133*y**3+549110*y**4+225458*y**5-317923*y**6+170592*y**7-43667*y**8
          +4055*y**9)+2*r**10*(-87843+478723*y-1006943*y**2+1285011*y**3-1146900*y**4
          +612955*y**5-113658*y**6-53967*y**7+47829*y**8-17085*y**9+1878*y**10))
          +12*logy*r*(-1+y)**2*(-1+r**2+y)**3*(7*r**26*(-1+y)**6-r**24*(-1+y)**3*(2365
          -7116*y+7158*y**2-2249*y**3+252*y**4)+r**22*(90482-520032*y+1235100*y**2
          -1540770*y**3+1052915*y**4-364422*y**5+43672*y**6+3080*y**7-25*y**8)
          +(-1+y)**8*(-7-35*y-105*y**2-211*y**3-157*y**4+167*y**5+245*y**6
          +115*y**7-304*y**8+92*y**9)+r**20*(146870-857982*y+2138868*y**2-2716350*y**3
          +1699317*y**4-357693*y**5-104096*y**6+62614*y**7-12703*y**8+1155*y**9)
          +r**18*(1790613-8633490*y+16236417*y**2-13338951*y**3+1266462*y**4
          +5895762*y**5-4156710*y**6+984223*y**7-41569*y**8-2472*y**9-285*y**10)
          +r**2*(-1+y)**7*(589+2377*y+5995*y**2+4622*y**3+1489*y**4-5441*y**5
          +1293*y**6-640*y**7-1602*y**8+926*y**9+92*y**10)-r**8*(-1+y)**4*(229893
          +129417*y+119427*y**2+505472*y**3-779612*y**4+48565*y**5+560603*y**6
          -758367*y**7+403613*y**8-87158*y**9+1112*y**10+335*y**11)+r**4*(-1
          +y)**6*(-13530-35586*y-64602*y**2+2284*y**3+6323*y**4+22164*y**5-48642*y**6
          +11032*y**7+15221*y**8-1558*y**9-1774*y**10+368*y**11)+r**6*(-1+y)**5*(
          -50818-62402*y-49938*y**2+304296*y**3+67109*y**4+213688*y**5-156780*y**6
          -163342*y**7+143859*y**8-21974*y**9-1060*y**10+462*y**11)+r**10*(-1
          +y)**3*(-231857+1109763*y+35817*y**2-7113689*y**3+13964378*y**4-13176045*y**5
          +6337277*y**6-1029097*y**7-272851*y**8+171062*y**9-26088*y**10+1530*y**11)
          -r**16*(5427505-23821155*y+36965343*y**2-22749161*y**3+1002851*y**4
          +4020618*y**5-41686*y**6-1287268*y**7+424226*y**8+72509*y**9-43263*y**10
          +2481*y**11)+r**12*(-1+y)**2*(7874852-21001940*y+13806708*y**2+14116280*y**3
          -26868568*y**4+16893521*y**5-5199085*y**6+75527*y**7+473070*y**8-2037*y**9
          -33153*y**10+4425*y**11)+r**14*(-7281140+36557352*y-70991640*y**2+68905620*y**3
          -30371288*y**4-9252735*y**5+25783670*y**6-19162816*y**7+6689455*y**8
          -802947*y**9-95920*y**10+21198*y**11+1191*y**12))-r*(-1+y)*(-1+r**2
          +y)**4*(11*r**26*(-1+y)**7+r**24*(-1+y)**4*(1191-3445*y+3231*y**2-816*y**3
          +59*y**4)+2*r**22*(-1+y)**2*(43559-205923*y+383123*y**2-343334*y**3
          +148077*y**4-28764*y**5+2130*y**6+32*y**7)+r**20*(999074-6232462*y
          +16287640*y**2-22672254*y**3+17369854*y**4-6270241*y**5-109719*y**6
          +821504*y**7-200562*y**8+8725*y**9-359*y**10)+r**18*(-1578905+9579535*y
          -23094919*y**2+29830827*y**3-23582126*y**4+12092130*y**5-3509920*y**6
          +55234*y**7+189253*y**8+25401*y**9-10695*y**10-1815*y**11)+r**16*(18977573
          -106512835*y+241057093*y**2-265733760*y**3+111167883*y**4+57509221*y**5
          -91527831*y**6+42066485*y**7-6700060*y**8-496498*y**9+207906*y**10+1491*y**11
          -4668*y**12)+(-1+y)**8*(-605-2941*y-8613*y**2-13048*y**3-7819*y**4
          +11885*y**5+9913*y**6+4377*y**7-9802*y**8+2964*y**9-600*y**10-117*y**11
          +6*y**12)-r**2*(-1+y)**7*(-13695-50048*y-116530*y**2-71766*y**3-35291*y**4
          +42916*y**5-95022*y**6+17494*y**7+96441*y**8-34624*y**9+664*y**10+820*y**11
          +41*y**12)-r**4*(-1+y)**6*(110126+218066*y+314122*y**2-431716*y**3
          -30586*y**4+273191*y**5+502971*y**6-145273*y**7-90399*y**8-18649*y**9
          +54083*y**10-8947*y**11+611*y**12)-2*r**6*(-1+y)**5*(303679+138354*y
          -136736*y**2-2093905*y**3+185326*y**4-305979*y**5+1245580*y**6+883589*y**7
          -1281925*y**8+337529*y**9+42860*y**10-14524*y**11+1352*y**12)-2*r**12*(
          -1+y)**2*(-18297286+57751118*y-52444922*y**2-20269452*y**3+53827974*y**4
          -8070785*y**5-25014633*y**6+13197251*y**7-69253*y**8-1481479*y**9+403101*y**10
          -44685*y**11+5451*y**12)-r**8*(-1+y)**4*(3985775-264365*y-905749*y**2
          -5578804*y**3-163743*y**4-2738644*y**5+10959660*y**6-8666246*y**7+2281999*y**8
          +272493*y**9-7971*y**10-29370*y**11+6565*y**12)-r**10*(-1+y)**3*(7516451
          -14475244*y+591070*y**2+49327344*y**3-109195143*y**4+117320068*y**5
          -62597340*y**6+5377472*y**7+7830761*y**8-2323912*y**9+278046*y**10-41976*y**11
          +10203*y**12)-4*r**14*(16847155-89252541*y+184051054*y**2-179050769*y**3
          +59107305*y**4+43669904*y**5-56397383*y**6+26497675*y**7-6039969*y**8
          +797775*y**9-341749*y**10+129564*y**11-20109*y**12+2088*y**13))))/(18662400*logy**4*r**16*(
          -1+y)**8+6220800*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+777600*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+43200*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +900*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((mupi*(518400*logy**4*r**15*(3+4*r**2+4*r**4+9*r**6)*(-1+y)**8+8640*logy**3*r**11*(
          -1+y)**4*(25*r**14*(-1+y)**4-3*r**12*(-193+772*y-1158*y**2+757*y**3
          -313*y**4+45*y**5)+r**10*(1517-3908*y+1542*y**2+4367*y**3-4223*y**4
          +1275*y**5-60*y**6)-r**2*(-1+y)**4*(9-1045*y**3+1755*y**4-714*y**5
          +80*y**6)-(-1+y)**4*(67-915*y**3+1335*y**4-582*y**5+80*y**6)-5*r**8*(221
          -1076*y+1998*y**2-1811*y**3+527*y**4+114*y**5-86*y**6+11*y**7)+5*r**6*(
          -25+292*y-822*y**2+636*y**3+786*y**4-1599*y**5+1066*y**6-307*y**7
          +27*y**8)+5*r**4*(-163+796*y-1482*y**2+861*y**3+594*y**4-747*y**5
          -212*y**6+596*y**7-285*y**8+42*y**9))-144*logy**2*r**7*(-1+y)**2*(-1
          +r**2+y)**2*(349*r**18*(-1+y)**6+r**16*(-1+y)**2*(-1993+7274*y-9166*y**2
          +3714*y**3-2161*y**4+472*y**5)-r**14*(-1+y)**2*(24220-95668*y+141675*y**2
          -94935*y**3+37540*y**4-9085*y**5+1413*y**6)+r**12*(-77212+401780*y
          -840723*y**2+834174*y**3-427119*y**4+146922*y**5-42425*y**6+3088*y**7
          -2309*y**8+824*y**9)-(-1+y)**5*(319+319*y+319*y**2-3031*y**3+2159*y**4
          -1549*y**5-4949*y**6+12001*y**7-7724*y**8+1536*y**9)+r**4*(-1+y)**3*(14500
          -19432*y+5073*y**2-294607*y**3+803463*y**4-799227*y**5+336287*y**6
          -43483*y**7-2793*y**8-1453*y**9+772*y**10)+r**10*(-217714+1017436*y
          -1820559*y**2+1199811*y**3+213456*y**4-555276*y**5+163554*y**6-24811*y**7
          +33984*y**8-14296*y**9+1415*y**10)-r**2*(-1+y)**4*(3883-638*y-638*y**2
          -40533*y**3+66542*y**4-34084*y**5+26298*y**6-48827*y**7+39243*y**8
          -13382*y**9+1536*y**10)+r**6*(-1+y)**2*(-1252-7884*y+10651*y**2+280741*y**3
          -1190414*y**4+1669285*y**5-1058606*y**6+278099*y**7+1724*y**8-12381*y**9
          +1537*y**10)+r**8*(-91894+515064*y-1140015*y**2+958830*y**3-70260*y**4
          +92748*y**5-833008*y**6+879380*y**7-356890*y**8+37450*y**9+10311*y**10
          -1716*y**11))-12*logy*r**3*(-1+y)*(-1+r**2+y)**3*(r**24*(-1+y)**7-r**22*(
          -1+y)**3*(-1094+4379*y-6576*y**2+4675*y**3-1258*y**4+120*y**5)+r**20*(
          -10908+71265*y-197625*y**2+298431*y**3-252828*y**4+100698*y**5+3701*y**6
          -16883*y**7+4372*y**8-223*y**9)+(-1+y)**8*(-91-364*y-910*y**2-1171*y**3
          -346*y**4+1568*y**5-106*y**6+1025*y**7-579*y**8-694*y**9+368*y**10)
          +r**18*(161206-1052977*y+2895351*y**2-4300267*y**3+3811624*y**4-2181513*y**5
          +866264*y**6-226679*y**7+28864*y**8-2332*y**9+459*y**10)+r**16*(238999
          -1499866*y+3999624*y**2-5798573*y**3+5002436*y**4-2768661*y**5+1135161*y**6
          -363744*y**7+44473*y**8+17519*y**9-8013*y**10+645*y**11)+r**14*(781564
          -4161730*y+8759046*y**2-7423408*y**3+918454*y**4+1433865*y**5-35862*y**6
          -79134*y**7-270487*y**8+120371*y**9-34774*y**10+8412*y**11-717*y**12)
          -r**6*(-1+y)**4*(-131146+97155*y+34395*y**2+1535148*y**3-3112476*y**4
          +2096133*y**5-799698*y**6+1002060*y**7-1051343*y**8+452326*y**9-69087*y**10
          -1002*y**11+335*y**12)+r**2*(-1+y)**6*(-314-901*y-1761*y**2+9230*y**3
          -5213*y**4+6195*y**5+26452*y**6-38002*y**7+7585*y**8-112*y**9+5079*y**10
          -2606*y**11+368*y**12)+r**8*(-1+y)**3*(-142789+194506*y-101634*y**2
          +4957474*y**3-15970501*y**4+18304377*y**5-9134256*y**6+1060770*y**7
          +910126*y**8-444509*y**9+91432*y**10-8010*y**11+414*y**12)+r**4*(-1
          +y)**5*(3468-2973*y-5040*y**2-4193*y**3+19999*y**4-26063*y**5-316456*y**6
          +702848*y**7-512567*y**8+138846*y**9-870*y**10-4061*y**11+462*y**12)
          +r**10*(-1+y)**2*(-524156+1394914*y-982190*y**2-446468*y**3+7676296*y**4
          -15939119*y**5+13103202*y**6-4400982*y**7-43487*y**8+310999*y**9-1250*y**10
          -13656*y**11+1497*y**12)+r**12*(2540328-13592634*y+28990290*y**2-25242890*y**3
          -1253362*y**4+16658793*y**5-9138897*y**6+676116*y**7+241247*y**8+147772*y**9
          +1539*y**10-35634*y**11+7479*y**12-147*y**13))+r*(-1+r**2+y)**4*(13*r**26*(
          -1+y)**8+r**24*(-1+y)**4*(-945+3716*y-5420*y**2+3595*y**3-891*y**4
          +77*y**5)+2*r**22*(-1+y)**2*(-11863+66472*y-152905*y**2+187449*y**3
          -124705*y**4+38111*y**5-2727*y**6-558*y**7+66*y**8)+r**20*(55190-486924*y
          +1829696*y**2-3946658*y**3+5626702*y**4-5713879*y**5+4137062*y**6-1986863*y**7
          +555556*y**8-72209*y**9+3202*y**10-155*y**11)+r**18*(1495075-10292292*y
          +29970316*y**2-46705370*y**3+41208755*y**4-19937448*y**5+4204156*y**6
          +577134*y**7-768875*y**8+269440*y**9-26192*y**10+2776*y**11-1075*y**12)
          -(-1+y)**9*(-17-85*y-255*y**2-744*y**3-549*y**4+567*y**5-405*y**6
          +435*y**7-136*y**8-286*y**9+200*y**10+65*y**11+10*y**12)+r**16*(-1437823
          +10058580*y-28950346*y**2+42111489*y**3-28136339*y**4-1891802*y**5
          +17510248*y**6-12452992*y**7+2852475*y**8+795054*y**9-551670*y**10+95127*y**11
          +7503*y**12-2304*y**13)-r**2*(-1+y)**7*(-4275-11801*y-22100*y**2+8142*y**3
          +29187*y**4+63219*y**5-38992*y**6+14334*y**7-57835*y**8+153*y**9+39816*y**10
          -14952*y**11+991*y**12+113*y**13)-r**4*(-1+y)**6*(-30694-49080*y-56926*y**2
          -7906*y**3+212614*y**4-8655*y**5-978686*y**6+1228086*y**7-492632*y**8
          +67336*y**9-32476*y**10+27996*y**11-5520*y**12+543*y**13)-2*r**6*(-1
          +y)**5*(-87695-11653*y+20161*y**2-254708*y**3+497937*y**4-362071*y**5
          +1093127*y**6-3266915*y**7+3169002*y**8-1132242*y**9+46936*y**10+56091*y**11
          -8116*y**12+746*y**13)-2*r**12*(-1+y)**2*(-2246338+7092384*y-6419290*y**2
          -7404870*y**3+11838406*y**4+2981821*y**5-8395520*y**6+1864844*y**7-5808*y**8
          +819384*y**9-692958*y**10+206466*y**11-25524*y**12+1803*y**13)-r**8*(
          -1+y)**4*(-2044225+2123228*y+461668*y**2+14257259*y**3-35523705*y**4
          +26612747*y**5-8042956*y**6+2819158*y**7-3314019*y**8+1700390*y**9-340352*y**10
          +76623*y**11-11291*y**12+2675*y**13)-r**10*(-1+y)**3*(-3957373+8297577*y
          -2479474*y**2-19960482*y**3+72810721*y**4-106070525*y**5+69645160*y**6
          -13425004*y**7-10015863*y**8+6574059*y**9-1439742*y**10+196998*y**11
          -21117*y**12+3465*y**13)-4*r**14*(-1962419+12277838*y-31553462*y**2
          +37490399*y**3-14030425*y**4-11977611*y**5+14606814*y**6-5878378*y**7
          +1124672*y**8+10881*y**9-68730*y**10-81507*y**11+51690*y**12-10566*y**13
          +804*y**14))))/(18662400*logy**4*r**16*(-1+y)**8+6220800*logy**3*r**12*(-1
          +y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +777600*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+43200*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+900*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*muWC**2*(-518400*logy**4*r**15*(
          -21-4*r**2+20*r**4+45*r**6)*(-1+y)**8-8640*logy**3*r**11*(-1+y)**4*(917*r**14*(
          -1+y)**4+3*r**12*(601-2404*y+3606*y**2-2014*y**3+301*y**4+90*y**5)
          +r**10*(7057-17428*y+4542*y**2+25462*y**3-27823*y**4+10230*y**5-1020*y**6)
          -(-1+y)**4*(-733+330*y**3+375*y**4-372*y**5+100*y**6)-r**2*(-1+y)**4*(
          -627+250*y**3+2595*y**4-1428*y**5+220*y**6)+5*r**8*(-1549+7156*y
          -12654*y**2+11122*y**3-4399*y**4+468*y**5+34*y**6+26*y**7)+5*r**6*(
          -1157+4436*y-6270*y**2+2772*y**3+3870*y**4-7122*y**5+5150*y**6-1814*y**7
          +243*y**8)+r**4*(2393-14612*y+31998*y**2-37602*y**3+29538*y**4-16158*y**5
          +2692*y**6+4052*y**7-2793*y**8+492*y**9))-144*logy**2*r**7*(-1+y)**2*(
          -1+r**2+y)**2*(1183*r**18*(-1+y)**6-r**16*(-1+y)**2*(-25457+104194*y
          -162206*y**2+112044*y**3-36881*y**4+4586*y**5)-r**14*(-1+y)**2*(-301676
          +1094924*y-1449015*y**2+769890*y**3-90860*y**4-36514*y**5+2931*y**6)
          +(-1+y)**5*(2519+2519*y+2519*y**2-23621*y**3+17329*y**4-4919*y**5
          -6319*y**6+20381*y**7-14704*y**8+3096*y**9)+r**12*(243020-1460092*y
          +3737811*y**2-4747386*y**3+2860977*y**4-289800*y**5-664883*y**6+415714*y**7
          -99269*y**8+9908*y**9)+r**4*(-1+y)**3*(224236-323728*y+73527*y**2
          +112667*y**3-435993*y**4+590895*y**5-164107*y**6-177307*y**7+131433*y**8
          -31927*y**9+2104*y**10)+r**2*(-1+y)**4*(-13705-5038*y-5038*y**2+16632*y**3
          +59062*y**4-49118*y**5-10962*y**6-17512*y**7+43443*y**8-22012*y**9
          +3048*y**10)-r**6*(-1+y)**2*(86092-68004*y-37369*y**2-441094*y**3
          +166286*y**4+1080602*y**5-1264576*y**6+415894*y**7+37474*y**8-36126*y**9
          +3821*y**10)+r**10*(745034-3198356*y+5152659*y**2-2155536*y**3-3614496*y**4
          +5123886*y**5-2454864*y**6+344216*y**7+101106*y**8-43114*y**9+5465*y**10)
          -r**8*(125818-902448*y+2692425*y**2-5930790*y**3+9257400*y**4-8307876*y**5
          +2985346*y**6+1109680*y**7-1523030*y**8+579080*y**9-90087*y**10+4482*y**11))
          -12*logy*r**3*(-1+y)*(-1+r**2+y)**3*(19*r**24*(-1+y)**7-r**22*(-1+y)**3*(
          -1214+4913*y-7512*y**2+4468*y**3-1294*y**4+147*y**5)+r**20*(-121632
          +826731*y-2395731*y**2+3829053*y**3-3650349*y**4+2091525*y**5-681265*y**6
          +105535*y**7-4031*y**8+164*y**9)+r**18*(-862226+5764817*y-16453407*y**2
          +25668323*y**3-23535497*y**4+12698283*y**5-3703801*y**6+364033*y**7
          +76183*y**8-17392*y**9+684*y**10)-(-1+y)**8*(-203-812*y-2030*y**2
          -2858*y**3+970*y**4+7156*y**5-5858*y**6+2110*y**7+1173*y**8-2660*y**9
          +1012*y**10)+r**16*(-4915487+29484098*y-73417008*y**2+94957612*y**3
          -62036314*y**4+9721488*y**5+13198014*y**6-8959422*y**7+2119153*y**8
          -161146*y**9+9834*y**10-822*y**11)+r**6*(-1+y)**4*(277522+74475*y
          +114411*y**2+1358595*y**3-5615739*y**4+4619838*y**5+1194714*y**6-2562954*y**7
          +387680*y**8+391079*y**9-143445*y**10+9111*y**11+313*y**12)-r**2*(-1
          +y)**6*(-4030-8669*y-13917*y**2+57142*y**3-28246*y**4+20724*y**5+65000*y**6
          -116078*y**7+30608*y**8+11281*y**9-99*y**10-2176*y**11+460*y**12)-r**4*(
          -1+y)**5*(150384+102627*y+86316*y**2-1088641*y**3+905252*y**4-245686*y**5
          -371972*y**6+1100518*y**7-883444*y**8+217323*y**9+25032*y**10-11725*y**11
          +816*y**12)-2*r**14*(-743510+3209735*y-2796909*y**2-2602513*y**3+3183331*y**4
          +4798236*y**5-10776534*y**6+8496528*y**7-3195052*y**8+388949*y**9+77459*y**10
          -24951*y**11+831*y**12)+2*r**10*(-1+y)**2*(-1000918+4959287*y-6504709*y**2
          -7299742*y**3+20513660*y**4-10641118*y**5-4930992*y**6+6732462*y**7
          -1982338*y**8-53065*y**9+83501*y**10-12840*y**11+1212*y**12)+r**8*(
          -1+y)**3*(-4151911+8626534*y-4073622*y**2-3446036*y**3+10859465*y**4
          -11283240*y**5+1742496*y**6+5517108*y**7-4258589*y**8+1118770*y**9-71834*y**10
          -15840*y**11+1899*y**12)+2*r**12*(-2540328+8606193*y-4058085*y**2-30566959*y**3
          +72777757*y**4-67729722*y**5+18182676*y**6+17505102*y**7-18033410*y**8
          +7058003*y**9-1255515*y**10+45141*y**11+8793*y**12+354*y**13))-r*(
          -1+r**2+y)**4*(29*r**26*(-1+y)**8+r**24*(-1+y)**4*(-69+388*y-748*y**2
          +1130*y**3-603*y**4+166*y**5)+2*r**22*(-1+y)**2*(39913-232000*y+557215*y**2
          -694722*y**3+482971*y**4-193382*y**5+42849*y**6-4308*y**7+144*y**8)
          -2*r**20*(-973223+7208166*y-23052968*y**2+41395058*y**3-45409477*y**4
          +30869629*y**5-12346079*y**6+2320835*y**7+65744*y**8-82651*y**9+4211*y**10
          +35*y**11)+r**18*(3518579-24432468*y+73548092*y**2-119692480*y**3+107927863*y**4
          -45417564*y**5-3944008*y**6+13583808*y**7-6328915*y**8+1363352*y**9
          -153580*y**10+20696*y**11-575*y**12)-(-1+y)**9*(-37-185*y-555*y**2
          -2109*y**3-462*y**4+4242*y**5-4662*y**6-270*y**7+2479*y**8-1673*y**9
          +625*y**10+187*y**11+20*y**12)-2*r**6*(-1+y)**5*(-1093423-318317*y
          -134191*y**2+5398697*y**3-4412208*y**4+183760*y**5-781268*y**6-1090876*y**7
          +3013155*y**8-1371927*y**9+65603*y**10+63915*y**11-1748*y**12+28*y**13)
          -r**2*(-1+y)**7*(-10371-28825*y-54292*y**2+30936*y**3+120645*y**4
          +182775*y**5-347060*y**6+189552*y**7-77453*y**8-73755*y**9+112536*y**10
          -35400*y**11+2555*y**12+157*y**13)-2*r**4*(-1+y)**6*(32945+61308*y
          +93101*y**2-590608*y**3+595327*y**4-176463*y**5-1444142*y**6+2101410*y**7
          -793049*y**8-140252*y**9+156473*y**10-22626*y**11+369*y**12+207*y**13)
          +r**16*(33028117-215597244*y+590271310*y**2-855154950*y**3+642376961*y**4
          -115362652*y**5-218200168*y**6+204365896*y**7-77962653*y**8+12306144*y**9
          +125370*y**10-209778*y**11+27399*y**12+648*y**13)+4*r**12*(-1+y)**2*(21286405
          -77347800*y+90571273*y**2+5257692*y**3-87592633*y**4+42266165*y**5
          +32572298*y**6-39035264*y**7+13525929*y**8-552762*y**9-677415*y**10
          +117912*y**11-8289*y**12+1689*y**13)+r**8*(-1+y)**4*(3560021-3866908*y
          -2391620*y**2-34115578*y**3+99750537*y**4-74287978*y**5-11002696*y**6
          +40951564*y**7-17052297*y**8-244912*y**9+1474252*y**10-321186*y**11
          -9749*y**12+2150*y**13)+r**10*(-1+y)**3*(43818509-104014617*y+59951186*y**2
          -17353674*y**3+70940539*y**4-87176423*y**5+38031364*y**6-10071532*y**7
          +11044779*y**8-6477999*y**9+1098714*y**10-83802*y**11-29379*y**12+5535*y**13)
          +4*r**14*(-15115229+95589578*y-245549330*y**2+335791004*y**3-255967747*y**4
          +86500212*y**5+24219684*y**6-43450552*y**7+26381945*y**8-11770596*y**9
          +4217652*y**10-945312*y**11+100947*y**12-3294*y**13+1038*y**14))))/(27993600*logy**4*r**16*(
          -1+y)**8+9331200*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+1166400*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+64800*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +1350*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((rhoLS*(518400*logy**4*r**13*(-3+26*r**2+41*r**4+29*r**6+9*r**8)*(-1
          +y)**8-8640*logy**3*r**9*(-1+y)**4*(541*r**16*(-1+y)**4-(-1+y)**5*(-7
          -7*y-7*y**2+143*y**3-112*y**4+20*y**5)+3*r**14*(-376+1504*y-2256*y**2
          +1849*y**3-736*y**4+105*y**5)-r**12*(4804-17056*y+21264*y**2-11771*y**3
          +1934*y**4+255*y**5+60*y**6)+r**2*(-1+y)**4*(264-1115*y**3+1720*y**4
          -774*y**5+100*y**6)+r**4*(-1+y)**3*(-508-212*y+360*y**2+1395*y**3
          -2055*y**4+1368*y**5-478*y**6+40*y**7)+r**10*(-4208+9872*y-888*y**2
          -12403*y**3+10852*y**4-2370*y**5-440*y**6+95*y**7)-5*r**8*(-234+2904*y
          -8292*y**2+9542*y**3-4491*y**4-41*y**5+806*y**6-293*y**7+45*y**8)
          +r**6*(7664-36896*y+67824*y**2-58941*y**3+21144*y**4+2571*y**5-4514*y**6
          +1076*y**7+186*y**8-114*y**9))+144*logy**2*r**5*(-1+y)**2*(-1+r**2+y)**2*(
          -977*r**20*(-1+y)**6+2*r**18*(-1+y)**2*(-7155+29597*y-46838*y**2+32677*y**3
          -10863*y**4+1652*y**5)+r**16*(-1+y)**2*(-120875+416694*y-509647*y**2
          +210193*y**3+28143*y**4-31477*y**5+1809*y**6)+(-1+y)**7*(-103-309*y
          -618*y**2+70*y**3+125*y**4+483*y**5-256*y**6+8*y**7)+2*r**6*(-1+y)**4*(60935
          -18292*y-5113*y**2-131688*y**3+254168*y**4-176195*y**5+45267*y**6
          +1068*y**7-1657*y**8+182*y**9)+2*r**2*(-1+y)**5*(-120-223*y-326*y**2
          +756*y**3+733*y**4-650*y**5-1147*y**6+2731*y**7-1826*y**8+372*y**9)
          -2*r**14*(-137465+684488*y-1295217*y**2+1206860*y**3-547776*y**4+83145*y**5
          -21873*y**6+52447*y**7-26885*y**8+3776*y**9)+r**12*(883480-4599756*y
          +9450108*y**2-9840993*y**3+5002941*y**4-211860*y**5-1243189*y**6+723687*y**7
          -197097*y**8+31834*y**9-2155*y**10)+r**4*(-1+y)**4*(3865+1946*y+1625*y**2
          -1951*y**3-18347*y**4+22332*y**5+1619*y**6-23585*y**7+18166*y**8-5838*y**9
          +768*y**10)-r**8*(-1+y)**2*(-168580+267704*y-52156*y**2+496229*y**3
          -1381321*y**4+1500949*y**5-884149*y**6+281921*y**7-27179*y**8-8019*y**9
          +1301*y**10)+2*r**10*(443147-2327890*y+4935426*y**2-5537374*y**3+3446041*y**4
          -878053*y**5-351629*y**6+394069*y**7-156156*y**8+39954*y**9-8549*y**10
          +1014*y**11))+12*logy*r*(-1+y)*(-1+r**2+y)**3*(r**26*(-1+y)**7+r**24*(
          -1+y)**3*(-1713+6849*y-10266*y**2+6307*y**3-1549*y**4+126*y**5)+r**22*(84518
          -573314*y+1658412*y**2-2643258*y**3+2504675*y**4-1416413*y**5+449760*y**6
          -66950*y**7+2931*y**8-361*y**9)-(-1+y)**9*(-7-35*y-105*y**2-211*y**3
          -157*y**4+167*y**5+245*y**6+115*y**7-304*y**8+92*y**9)+r**20*(288778
          -1913248*y+5430318*y**2-8308942*y**3+7243009*y**4-3497718*y**5+767855*y**6
          +43144*y**7-67601*y**8+15188*y**9-783*y**10)+r**2*(-1+y)**7*(-63-168*y
          -294*y**2-1273*y**3-127*y**4+60*y**5+3226*y**6-2901*y**7-1792*y**8
          +3242*y**9-1202*y**10+92*y**11)+r**18*(1801025-10464311*y+24980619*y**2
          -29879764*y**3+15448783*y**4+3065718*y**5-8433866*y**6+4313261*y**7
          -897056*y**8+76697*y**9-12633*y**10+1527*y**11)+r**8*(-1+y)**4*(-262465
          +59256*y+7530*y**2+142483*y**3+130048*y**4-107385*y**5-330136*y**6
          +740778*y**7-644758*y**8+259567*y**9-43000*y**10+1185*y**11+97*y**12)
          -r**4*(-1+y)**6*(8182+13724*y+17904*y**2-46166*y**3-3357*y**4-15967*y**5
          +46398*y**6-19878*y**7-4039*y**8-863*y**9+5300*y**10-2022*y**11+184*y**12)
          -r**6*(-1+y)**5*(-5786-21932*y-34484*y**2+180566*y**3-103887*y**4
          -58155*y**5-40864*y**6+263194*y**7-238271*y**8+83117*y**9-5454*y**10
          -2834*y**11+390*y**12)-r**10*(-1+y)**3*(-2714111+4910852*y-1834662*y**2
          +4767882*y**3-16197395*y**4+21732029*y**5-14305098*y**6+3837044*y**7
          +565428*y**8-648935*y**9+173922*y**10-20784*y**11+828*y**12)+r**16*(
          -6808553+37801340*y-82762890*y**2+90980664*y**3-47924048*y**4+3112163*y**5
          +8358468*y**6-2029456*y**7-1081734*y**8+252883*y**9+167040*y**10-51258*y**11
          +2181*y**12)-r**12*(-1+y)**2*(-138604+2176880*y-3407608*y**2-7437556*y**3
          +20406856*y**4-18653159*y**5+9504926*y**6-2797998*y**7+54141*y**8+114449*y**9
          +79108*y**10-38976*y**11+3741*y**12)+r**14*(-10141196+60351980*y-146601552*y**2
          +188901380*y**3-128464828*y**4+17227763*y**5+51236795*y**6-50535992*y**7
          +22580903*y**8-4801842*y**9+128913*y**10+125980*y**11-6051*y**12-2253*y**13))
          +r*(-1+r**2+y)**4*(27*r**26*(-1+y)**8+r**24*(-1+y)**4*(-681+2628*y
          -3696*y**2+1959*y**3-421*y**4+79*y**5)-2*r**22*(-1+y)**2*(38235-220446*y
          +524766*y**2-647895*y**3+438394*y**4-162293*y**5+31194*y**6-2646*y**7
          +31*y**8)+r**20*(-1011654+7366968*y-23098410*y**2+40360698*y**3-42401186*y**4
          +26627503*y**5-8847276*y**6+604877*y**7+529164*y**8-137487*y**9+6498*y**10
          -415*y**11)+r**18*(113985-1056864*y+3203046*y**2-7078806*y**3+13430763*y**4
          -17184964*y**5+12776734*y**6-5274406*y**7+1407001*y**8-457308*y**9+139984*y**10
          -15060*y**11-505*y**12)-(-1+y)**8*(-171-600*y-1332*y**2-975*y**3
          +4897*y**4+11392*y**5-3896*y**6-4612*y**7-8985*y**8+11238*y**9-3676*y**10
          +251*y**11+59*y**12+10*y**13)-r**2*(-1+y)**7*(-1305-2559*y-3078*y**2
          -15024*y**3+22651*y**4+15539*y**5+48386*y**6-95236*y**7-42303*y**8
          +104469*y**9-44584*y**10+5728*y**11+49*y**12+67*y**13)-r**4*(-1+y)**6*(
          -161034-220020*y-244608*y**2+1070490*y**3-89944*y**4+65863*y**5-727148*y**6
          +243724*y**7+130314*y**8+129354*y**9-208244*y**10+77138*y**11-8776*y**12
          +491*y**13)-2*r**6*(-1+y)**5*(-134979+101349*y+212862*y**2-50121*y**3
          +405816*y**4-12520*y**5-389869*y**6-1186541*y**7+2033512*y**8-958496*y**9
          +20179*y**10+93510*y**11-18921*y**12+1219*y**13)-r**16*(14935059-97267248*y
          +264925140*y**2-379210449*y**3+274960627*y**4-32700094*y**5-113031856*y**6
          +97099096*y**7-34215767*y**8+4133578*y**9+528100*y**10-155271*y**11
          +5049*y**12+1236*y**13)-2*r**12*(-1+y)**2*(9292770-36762756*y+46589520*y**2
          +588918*y**3-33494356*y**4-10997645*y**5+52339168*y**6-33964636*y**7
          +4576670*y**8+3718286*y**9-1841440*y**10+311718*y**11-35244*y**12+4827*y**13)
          -r**8*(-1+y)**4*(-4187025+3756756*y+894420*y**2+1570863*y**3+281209*y**4
          +805193*y**5-7502752*y**6+8573770*y**7-3347783*y**8-298934*y**9+295612*y**10
          +121071*y**11-61905*y**12+6705*y**13)-r**10*(-1+y)**3*(13567293-33145281*y
          +22935558*y**2-36365226*y**3+120423899*y**4-185753351*y**5+142298272*y**6
          -42156604*y**7-9437629*y**8+8921801*y**9-1775182*y**10+183534*y**11
          -64059*y**12+10575*y**13)-4*r**14*(-17431983+109648452*y-282407799*y**2
          +380700273*y**3-264821033*y**4+42406147*y**5+81567360*y**6-71877664*y**7
          +26520717*y**8-5175495*y**9+1366446*y**10-620767*y**11+137793*y**12
          -13650*y**13+1203*y**14))))/(18662400*logy**4*r**16*(-1+y)**8+6220800*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +777600*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+43200*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+900*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*muWC**3*(-1036800*logy**4*r**16*(18
          +45*r**2+44*r**4+37*r**6+29*r**8+9*r**10)*(-1+y)**9-17280*logy**3*r**12*(
          -1+y)**4*(409*r**18*(-1+y)**5-4*(-1+y)**7*(31+62*y+93*y**2-116*y**3
          +20*y**4)-5*r**2*(-1+y)**6*(-91-91*y-91*y**2+307*y**3-216*y**4+28*y**5)
          -5*r**4*(-1+y)**5*(1254-864*y-432*y**2+305*y**3+92*y**4-142*y**5
          +20*y**6)+r**16*(-922+4610*y-9220*y**2+8455*y**3-4025*y**4+697*y**5
          +45*y**6)-5*r**14*(96-48*y-984*y**2+2901*y**3-2993*y**4+1513*y**5
          -385*y**6+36*y**7)-5*r**12*(1238-4798*y+6116*y**2-729*y**3-4425*y**4
          +3876*y**5-1268*y**6+123*y**7+3*y**8)-r**6*(-1+y)**3*(6472-23744*y
          +22672*y**2+485*y**3-10690*y**4+5033*y**5-326*y**6-302*y**7+40*y**8)
          +r**10*(-3254+7390*y+7420*y**2-38330*y**3+43045*y**4-17876*y**5-1735*y**6
          +4325*y**7-1570*y**8+225*y**9)+r**8*(-2066-230*y+26860*y**2-57965*y**3
          +41315*y**4+6977*y**5-27425*y**6+15810*y**7-3240*y**8-150*y**9+114*y**10))
          -288*logy**2*r**8*(-1+y)**2*(3*r**26*(-1+y)**7+2*(-1+y)**11*(41+164*y
          +410*y**2+420*y**3-55*y**4-856*y**5+376*y**6)-2*r**24*(-1+y)**2*(6752
          -33760*y+67520*y**2-66325*y**3+36065*y**4-10297*y**5+1285*y**6)-r**22*(
          -1+y)**2*(119848-525620*y+867190*y**2-605025*y**3+88555*y**4+105847*y**5
          -48595*y**6+4680*y**7)+r**2*(-1+y)**9*(763+1526*y+2289*y**2-9048*y**3
          +3085*y**4-198*y**5+919*y**6-1464*y**7+728*y**8)+2*r**4*(-1+y)**8*(
          -24592-13432*y-7852*y**2+151713*y**3-148597*y**4+24557*y**5+24937*y**6
          -10628*y**7+622*y**8+372*y**9)+10*r**8*(-1+y)**6*(-76674+189534*y
          -95310*y**2-150392*y**3+219469*y**4-81184*y**5-16626*y**6+16853*y**7
          -1506*y**8-994*y**9+190*y**10)+r**6*(-1+y)**7*(-952-81900*y-40950*y**2
          +26485*y**3+342460*y**4-352046*y**5+71650*y**6+40855*y**7-14100*y**8
          -1270*y**9+768*y**10)+2*r**20*(64844-536888*y+1901094*y**2-3895180*y**3
          +4896885*y**4-3802489*y**5+1792618*y**6-478739*y**7+57320*y**8-2550*y**9
          +1085*y**10)+r**10*(-1+y)**4*(210819+532503*y-3251943*y**2+4008601*y**3
          -633700*y**4-2409129*y**5+2049277*y**6-479852*y**7-114791*y**8+70590*y**9
          -9570*y**10+195*y**11)-2*r**12*(-1+y)**3*(557268-2415012*y+3519198*y**2
          -1218267*y**3-2072347*y**4+2779232*y**5-1363323*y**6+212632*y**7+19497*y**8
          +11852*y**9-9945*y**10+1465*y**11)-r**14*(-1+y)**2*(-481488+2993160*y
          -6651420*y**2+5437670*y**3+317230*y**4-2573919*y**5+374875*y**6+1320750*y**7
          -1001090*y**8+294975*y**9-36663*y**10+1720*y**11)+5*r**18*(26783-204761*y
          +635883*y**2-1047581*y**3+823003*y**4-1684*y**5-554726*y**6+504407*y**7
          -245922*y**8+78321*y**9-16333*y**10+1810*y**11)+2*r**16*(-560637+3367359*y
          -8465427*y**2+11487650*y**3-9134325*y**4+4486459*y**5-1849938*y**6+1284604*y**7
          -904950*y**8+321025*y**9-19672*y**10-14671*y**11+2523*y**12))-24*logy*r**6*(
          -1+y)*(-1+r**2+y)**2*(31*r**28*(-1+y)**8+r**26*(-1+y)**3*(1404-6958*y
          +13730*y**2-14373*y**3+7701*y**4-2067*y**5+235*y**6)+(-1+y)**10*(67
          +268*y+670*y**2+602*y**3+594*y**4+12*y**5-1798*y**6+290*y**7+1223*y**8
          -1004*y**9+276*y**10)+r**24*(38965-308902*y+1068605*y**2-2107927*y**3
          +2617336*y**4-2134497*y**5+1152692*y**6-402097*y**7+85243*y**8-10017*y**9
          +599*y**10)-2*r**22*(-263346+1982240*y-6456439*y**2+11754426*y**3-13086408*y**4
          +9181729*y**5-3978045*y**6+938384*y**7-51856*y**8-24807*y**9+4102*y**10
          +20*y**11)+r**20*(1738075-11508408*y+31602510*y**2-44470591*y**3+28937680*y**4
          +3547403*y**5-21493552*y**6+17117503*y**7-6677069*y**8+1328245*y**9
          -137238*y**10+17320*y**11-1878*y**12)+r**2*(-1+y)**8*(-5656-9210*y
          -11646*y**2+46095*y**3+40248*y**4+12443*y**5-230906*y**6+225039*y**7
          -58960*y**8-17613*y**9+12548*y**10-2074*y**11+92*y**12)+r**18*(-2077664
          +15629362*y-50570750*y**2+97717349*y**3-121001872*y**4+95667129*y**5
          -47822410*y**6+15854191*y**7-4133512*y**8+753137*y**9+94780*y**10-117752*y**11
          +31364*y**12-1752*y**13)-r**4*(-1+y)**7*(-34343-23273*y-19190*y**2
          +453375*y**3-684927*y**4+321429*y**5+98717*y**6-146503*y**7+15776*y**8
          +32932*y**9-22111*y**10+8176*y**11-1842*y**12+184*y**13)-2*r**6*(-1
          +y)**6*(600526-571540*y-147817*y**2-3369472*y**3+8230297*y**4-5917763*y**5
          -33855*y**6+1963247*y**7-799495*y**8-4082*y**9+53692*y**10-2065*y**11
          -2260*y**12+287*y**13)-r**8*(-1+y)**5*(1083183-1164359*y-360918*y**2
          +120867*y**3-1718798*y**4+6762413*y**5-7316726*y**6+2864950*y**7-67585*y**8
          -220327*y**9+41304*y**10+3035*y**11-532*y**12+293*y**13)+r**10*(-1
          +y)**4*(-11671692+45008182*y-57202420*y**2-1020481*y**3+74279032*y**4
          -76147071*y**5+25531500*y**6+5294552*y**7-4701436*y**8-89092*y**9+497928*y**10
          -72367*y**11-7192*y**12+757*y**13)+2*r**14*(-1+y)**2*(9902364-44900240*y
          +76738542*y**2-54657656*y**3+601894*y**4+24269816*y**5-15285750*y**6
          +4214174*y**7-2033504*y**8+1619571*y**9-527920*y**10+52640*y**11-3706*y**12
          +975*y**13)+r**12*(-1+y)**3*(5597011-29632399*y+58885634*y**2-52773168*y**3
          +19043301*y**4-235369*y**5-1501394*y**6-261212*y**7+1348853*y**8-978111*y**9
          +335728*y**10-44332*y**11-9317*y**12+1575*y**13)+r**16*(-2602919+20860778*y
          -71482573*y**2+141065504*y**3-165386714*y**4+96945672*y**5+10540078*y**6
          -68334544*y**7+62257319*y**8-32808502*y**9+10710897*y**10-1865616*y**11
          +91122*y**12+8772*y**13+726*y**14))-2*r**6*(-1+r**2+y)**3*(35*r**28*(
          -1+y)**9+r**26*(-1+y)**4*(648-3507*y+7629*y**2-8831*y**3+5373*y**4
          -1740*y**5+252*y**6)+r**24*(-1+y)**2*(11801-67970*y+154506*y**2-193087*y**3
          +121790*y**4+2543*y**5-50356*y**6+29093*y**7-7233*y**8+673*y**9)+r**22*(
          -974064+8278230*y-30942018*y**2+66746122*y**3-91865078*y**4+84164285*y**5
          -51723793*y**6+20717627*y**7-4923131*y**8+501109*y**9+28355*y**10-9181*y**11
          +577*y**12)+r**20*(-2315215+16950477*y-52318242*y**2+82471902*y**3
          -59456481*y**4-8323948*y**5+54452186*y**6-49218374*y**7+22932391*y**8
          -5787699*y**9+604808*y**10+13712*y**11+121*y**12-838*y**13)-(-1+y)**10*(4097
          +15584*y+37352*y**2+33613*y**3+16579*y**4-32060*y**5-56056*y**6+20996*y**7
          +53739*y**8-49094*y**9+13288*y**10-513*y**11+57*y**12+18*y**13)+r**18*(
          -9724408+69721959*y-210880581*y**2+342949125*y**3-295685375*y**4+56026269*y**5
          +172693989*y**6-224731622*y**7+143586084*y**8-55587155*y**9+13617799*y**10
          -2218503*y**11+219003*y**12+5991*y**13-2175*y**14)-r**2*(-1+y)**8*(
          -135544-191729*y-216309*y**2+1024977*y**3+434781*y**4+42951*y**5-3505137*y**6
          +3834078*y**7-1215780*y**8-195719*y**9+141683*y**10+1921*y**11-6049*y**12
          +913*y**13+163*y**14)+r**8*(-1+y)**5*(34298757-67362351*y+22854834*y**2
          -56013035*y**3+211318390*y**4-207288766*y**5+21508609*y**6+67222958*y**7
          -28475231*y**8-2515995*y**9+3090964*y**10-213763*y**11-90612*y**12-10824*y**13
          +465*y**14)-r**4*(-1+y)**7*(-155061-239904*y-163233*y**2-1308632*y**3
          +8786811*y**4-6717087*y**5-7837372*y**6+12804572*y**7-5257057*y**8-403398*y**9
          +732273*y**10-136084*y**11+7291*y**12+1509*y**13+572*y**14)-r**6*(-1
          +y)**6*(-11676016+14962650*y+906030*y**2+53708412*y**3-146251428*y**4
          +119420013*y**5-12823583*y**6-29065118*y**7+11007302*y**8+1303050*y**9
          -998682*y**10-55582*y**11+68598*y**12+1151*y**13+803*y**14)+2*r**14*(
          -1+y)**2*(-8070720+45446802*y-104242554*y**2+143374092*y**3-152738988*y**4
          +130895965*y**5-74238351*y**6+21252628*y**7+996084*y**8-5776510*y**9
          +3844500*y**10-1030136*y**11+86676*y**12+399*y**13+1713*y**14)+r**10*(
          -1+y)**4*(128273912-466440805*y+581458187*y**2-135082233*y**3-339191901*y**4
          +340344908*y**5-124555580*y**6+10842002*y**7-198362*y**8+4945067*y**9
          -2049325*y**10+369695*y**11-60409*y**12-25450*y**13+3494*y**14)+r**12*(
          -1+y)**3*(106364505-426858138*y+600487167*y**2-188294164*y**3-407792671*y**4
          +525083532*y**5-253084679*y**6+49416980*y**7-18392933*y**8+17516982*y**9
          -5331727*y**10+477272*y**11-32637*y**12-17328*y**13+5439*y**14)+r**16*(29879661
          -232609470*y+781932285*y**2-1531830067*y**3+1894776453*y**4-1419635575*y**5
          +448590087*y**6+253142446*y**7-397881841*y**8+252184188*y**9-101756625*y**10
          +27432573*y**11-4608361*y**12+379233*y**13+5589*y**14-576*y**15))))/(41990400*logy**4*r**21*(
          -1+y)**9+13996800*logy**3*r**17*(-1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+1749600*logy**2*r**13*(-1+y)**5*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+97200*logy*r**9*(
          -1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +2025*r**5*(-1+y)*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(
          -1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y
          -y**2+y**3))**4))
      resNP += ((rhoD*(518400*logy**4*r**16*(18+45*r**2+44*r**4+37*r**6
          +29*r**8+9*r**10)*(-1+y)**9+8640*logy**3*r**12*(-1+y)**4*(409*r**18*(-1
          +y)**5-4*(-1+y)**7*(31+62*y+93*y**2-116*y**3+20*y**4)-5*r**2*(-1
          +y)**6*(-91-91*y-91*y**2+307*y**3-216*y**4+28*y**5)-5*r**4*(-1+y)**5*(1254
          -864*y-432*y**2+305*y**3+92*y**4-142*y**5+20*y**6)+r**16*(-922+4610*y
          -9220*y**2+8455*y**3-4025*y**4+697*y**5+45*y**6)-5*r**14*(96-48*y
          -984*y**2+2901*y**3-2993*y**4+1513*y**5-385*y**6+36*y**7)-5*r**12*(1238
          -4798*y+6116*y**2-729*y**3-4425*y**4+3876*y**5-1268*y**6+123*y**7
          +3*y**8)-r**6*(-1+y)**3*(6472-23744*y+22672*y**2+485*y**3-10690*y**4
          +5033*y**5-326*y**6-302*y**7+40*y**8)+r**10*(-3254+7390*y+7420*y**2
          -38330*y**3+43045*y**4-17876*y**5-1735*y**6+4325*y**7-1570*y**8+225*y**9)
          +r**8*(-2066-230*y+26860*y**2-57965*y**3+41315*y**4+6977*y**5-27425*y**6
          +15810*y**7-3240*y**8-150*y**9+114*y**10))+144*logy**2*r**8*(-1+y)**2*(3*r**26*(
          -1+y)**7+2*(-1+y)**11*(41+164*y+410*y**2+420*y**3-55*y**4-856*y**5
          +376*y**6)-2*r**24*(-1+y)**2*(6752-33760*y+67520*y**2-66325*y**3+36065*y**4
          -10297*y**5+1285*y**6)-r**22*(-1+y)**2*(119848-525620*y+867190*y**2
          -605025*y**3+88555*y**4+105847*y**5-48595*y**6+4680*y**7)+r**2*(-1
          +y)**9*(763+1526*y+2289*y**2-9048*y**3+3085*y**4-198*y**5+919*y**6
          -1464*y**7+728*y**8)+2*r**4*(-1+y)**8*(-24592-13432*y-7852*y**2+151713*y**3
          -148597*y**4+24557*y**5+24937*y**6-10628*y**7+622*y**8+372*y**9)+10*r**8*(
          -1+y)**6*(-76674+189534*y-95310*y**2-150392*y**3+219469*y**4-81184*y**5
          -16626*y**6+16853*y**7-1506*y**8-994*y**9+190*y**10)+r**6*(-1+y)**7*(
          -952-81900*y-40950*y**2+26485*y**3+342460*y**4-352046*y**5+71650*y**6
          +40855*y**7-14100*y**8-1270*y**9+768*y**10)+2*r**20*(64844-536888*y
          +1901094*y**2-3895180*y**3+4896885*y**4-3802489*y**5+1792618*y**6-478739*y**7
          +57320*y**8-2550*y**9+1085*y**10)+r**10*(-1+y)**4*(210819+532503*y
          -3251943*y**2+4008601*y**3-633700*y**4-2409129*y**5+2049277*y**6-479852*y**7
          -114791*y**8+70590*y**9-9570*y**10+195*y**11)-2*r**12*(-1+y)**3*(557268
          -2415012*y+3519198*y**2-1218267*y**3-2072347*y**4+2779232*y**5-1363323*y**6
          +212632*y**7+19497*y**8+11852*y**9-9945*y**10+1465*y**11)-r**14*(-1
          +y)**2*(-481488+2993160*y-6651420*y**2+5437670*y**3+317230*y**4-2573919*y**5
          +374875*y**6+1320750*y**7-1001090*y**8+294975*y**9-36663*y**10+1720*y**11)
          +5*r**18*(26783-204761*y+635883*y**2-1047581*y**3+823003*y**4-1684*y**5
          -554726*y**6+504407*y**7-245922*y**8+78321*y**9-16333*y**10+1810*y**11)
          +2*r**16*(-560637+3367359*y-8465427*y**2+11487650*y**3-9134325*y**4
          +4486459*y**5-1849938*y**6+1284604*y**7-904950*y**8+321025*y**9-19672*y**10
          -14671*y**11+2523*y**12))+12*logy*r**6*(-1+y)*(-1+r**2+y)**2*(31*r**28*(
          -1+y)**8+r**26*(-1+y)**3*(1404-6958*y+13730*y**2-14373*y**3+7701*y**4
          -2067*y**5+235*y**6)+(-1+y)**10*(67+268*y+670*y**2+602*y**3+594*y**4
          +12*y**5-1798*y**6+290*y**7+1223*y**8-1004*y**9+276*y**10)+r**24*(38965
          -308902*y+1068605*y**2-2107927*y**3+2617336*y**4-2134497*y**5+1152692*y**6
          -402097*y**7+85243*y**8-10017*y**9+599*y**10)-2*r**22*(-263346+1982240*y
          -6456439*y**2+11754426*y**3-13086408*y**4+9181729*y**5-3978045*y**6
          +938384*y**7-51856*y**8-24807*y**9+4102*y**10+20*y**11)+r**20*(1738075
          -11508408*y+31602510*y**2-44470591*y**3+28937680*y**4+3547403*y**5
          -21493552*y**6+17117503*y**7-6677069*y**8+1328245*y**9-137238*y**10
          +17320*y**11-1878*y**12)+r**2*(-1+y)**8*(-5656-9210*y-11646*y**2+46095*y**3
          +40248*y**4+12443*y**5-230906*y**6+225039*y**7-58960*y**8-17613*y**9
          +12548*y**10-2074*y**11+92*y**12)+r**18*(-2077664+15629362*y-50570750*y**2
          +97717349*y**3-121001872*y**4+95667129*y**5-47822410*y**6+15854191*y**7
          -4133512*y**8+753137*y**9+94780*y**10-117752*y**11+31364*y**12-1752*y**13)
          -r**4*(-1+y)**7*(-34343-23273*y-19190*y**2+453375*y**3-684927*y**4
          +321429*y**5+98717*y**6-146503*y**7+15776*y**8+32932*y**9-22111*y**10
          +8176*y**11-1842*y**12+184*y**13)-2*r**6*(-1+y)**6*(600526-571540*y
          -147817*y**2-3369472*y**3+8230297*y**4-5917763*y**5-33855*y**6+1963247*y**7
          -799495*y**8-4082*y**9+53692*y**10-2065*y**11-2260*y**12+287*y**13)
          -r**8*(-1+y)**5*(1083183-1164359*y-360918*y**2+120867*y**3-1718798*y**4
          +6762413*y**5-7316726*y**6+2864950*y**7-67585*y**8-220327*y**9+41304*y**10
          +3035*y**11-532*y**12+293*y**13)+r**10*(-1+y)**4*(-11671692+45008182*y
          -57202420*y**2-1020481*y**3+74279032*y**4-76147071*y**5+25531500*y**6
          +5294552*y**7-4701436*y**8-89092*y**9+497928*y**10-72367*y**11-7192*y**12
          +757*y**13)+2*r**14*(-1+y)**2*(9902364-44900240*y+76738542*y**2-54657656*y**3
          +601894*y**4+24269816*y**5-15285750*y**6+4214174*y**7-2033504*y**8+1619571*y**9
          -527920*y**10+52640*y**11-3706*y**12+975*y**13)+r**12*(-1+y)**3*(5597011
          -29632399*y+58885634*y**2-52773168*y**3+19043301*y**4-235369*y**5-1501394*y**6
          -261212*y**7+1348853*y**8-978111*y**9+335728*y**10-44332*y**11-9317*y**12
          +1575*y**13)+r**16*(-2602919+20860778*y-71482573*y**2+141065504*y**3
          -165386714*y**4+96945672*y**5+10540078*y**6-68334544*y**7+62257319*y**8
          -32808502*y**9+10710897*y**10-1865616*y**11+91122*y**12+8772*y**13+726*y**14))
          +r**6*(-1+r**2+y)**3*(35*r**28*(-1+y)**9+r**26*(-1+y)**4*(648-3507*y
          +7629*y**2-8831*y**3+5373*y**4-1740*y**5+252*y**6)+r**24*(-1+y)**2*(11801
          -67970*y+154506*y**2-193087*y**3+121790*y**4+2543*y**5-50356*y**6
          +29093*y**7-7233*y**8+673*y**9)+r**22*(-974064+8278230*y-30942018*y**2
          +66746122*y**3-91865078*y**4+84164285*y**5-51723793*y**6+20717627*y**7
          -4923131*y**8+501109*y**9+28355*y**10-9181*y**11+577*y**12)+r**20*(
          -2315215+16950477*y-52318242*y**2+82471902*y**3-59456481*y**4-8323948*y**5
          +54452186*y**6-49218374*y**7+22932391*y**8-5787699*y**9+604808*y**10
          +13712*y**11+121*y**12-838*y**13)-(-1+y)**10*(4097+15584*y+37352*y**2
          +33613*y**3+16579*y**4-32060*y**5-56056*y**6+20996*y**7+53739*y**8
          -49094*y**9+13288*y**10-513*y**11+57*y**12+18*y**13)+r**18*(-9724408
          +69721959*y-210880581*y**2+342949125*y**3-295685375*y**4+56026269*y**5
          +172693989*y**6-224731622*y**7+143586084*y**8-55587155*y**9+13617799*y**10
          -2218503*y**11+219003*y**12+5991*y**13-2175*y**14)-r**2*(-1+y)**8*(
          -135544-191729*y-216309*y**2+1024977*y**3+434781*y**4+42951*y**5-3505137*y**6
          +3834078*y**7-1215780*y**8-195719*y**9+141683*y**10+1921*y**11-6049*y**12
          +913*y**13+163*y**14)+r**8*(-1+y)**5*(34298757-67362351*y+22854834*y**2
          -56013035*y**3+211318390*y**4-207288766*y**5+21508609*y**6+67222958*y**7
          -28475231*y**8-2515995*y**9+3090964*y**10-213763*y**11-90612*y**12-10824*y**13
          +465*y**14)-r**4*(-1+y)**7*(-155061-239904*y-163233*y**2-1308632*y**3
          +8786811*y**4-6717087*y**5-7837372*y**6+12804572*y**7-5257057*y**8-403398*y**9
          +732273*y**10-136084*y**11+7291*y**12+1509*y**13+572*y**14)-r**6*(-1
          +y)**6*(-11676016+14962650*y+906030*y**2+53708412*y**3-146251428*y**4
          +119420013*y**5-12823583*y**6-29065118*y**7+11007302*y**8+1303050*y**9
          -998682*y**10-55582*y**11+68598*y**12+1151*y**13+803*y**14)+2*r**14*(
          -1+y)**2*(-8070720+45446802*y-104242554*y**2+143374092*y**3-152738988*y**4
          +130895965*y**5-74238351*y**6+21252628*y**7+996084*y**8-5776510*y**9
          +3844500*y**10-1030136*y**11+86676*y**12+399*y**13+1713*y**14)+r**10*(
          -1+y)**4*(128273912-466440805*y+581458187*y**2-135082233*y**3-339191901*y**4
          +340344908*y**5-124555580*y**6+10842002*y**7-198362*y**8+4945067*y**9
          -2049325*y**10+369695*y**11-60409*y**12-25450*y**13+3494*y**14)+r**12*(
          -1+y)**3*(106364505-426858138*y+600487167*y**2-188294164*y**3-407792671*y**4
          +525083532*y**5-253084679*y**6+49416980*y**7-18392933*y**8+17516982*y**9
          -5331727*y**10+477272*y**11-32637*y**12-17328*y**13+5439*y**14)+r**16*(29879661
          -232609470*y+781932285*y**2-1531830067*y**3+1894776453*y**4-1419635575*y**5
          +448590087*y**6+253142446*y**7-397881841*y**8+252184188*y**9-101756625*y**10
          +27432573*y**11-4608361*y**12+379233*y**13+5589*y**14-576*y**15))))/(18662400*logy**4*r**21*(
          -1+y)**9+6220800*logy**3*r**17*(-1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+777600*logy**2*r**13*(-1+y)**5*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+43200*logy*r**9*(
          -1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +900*r**5*(-1+y)*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(
          -1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y
          -y**2+y**3))**4))
      resNP += ((api*(518400*logy**4*r**15*(-3+4*r**2+12*r**4+15*r**6)*(
          -1+y)**8+8640*logy**3*r**11*(-1+y)**6*(303*r**14*(-1+y)**2+r**12*(557
          -1114*y+557*y**2+30*y**3)-5*r**10*(-575+430*y+505*y**2-494*y**3
          +60*y**4)+5*(-1+y)**3*(-55-55*y-55*y**2+191*y**3-112*y**4+20*y**5)
          +5*r**8*(-307+1190*y-1171*y**2+418*y**3-138*y**4+78*y**5)+r**2*(-1
          +y)**2*(-127-1150*y**3+1235*y**4-468*y**5+60*y**6)+5*r**6*(-431+1054*y
          -719*y**2+24*y**3+261*y**4-216*y**5+69*y**6)-r**4*(193+334*y-887*y**2
          +90*y**3+65*y**4+422*y**5-229*y**6+12*y**7))+144*logy**2*r**7*(-1+y)**4*(
          -1+r**2+y)**2*(421*r**18*(-1+y)**4-r**16*(-1+y)**2*(-8359+17560*y
          -10043*y**2+1942*y**3)-r**14*(-1+y)**2*(-97092+157204*y-51665*y**2
          -8304*y**3+257*y**4)-(-1+y)**5*(-833-2499*y-4998*y**2-310*y**3+2875*y**4
          +6693*y**5-6656*y**6+1528*y**7)+r**12*(90740-365364*y+577249*y**2
          -390800*y**3+34450*y**4+85820*y**5-37231*y**6+5636*y**7)+r**10*(330718
          -834456*y+612923*y**2+76590*y**3-295775*y**4+135422*y**5-35089*y**6
          +12372*y**7-1205*y**8)+r**4*(-1+y)**3*(71732+35808*y+27133*y**2-280753*y**3
          +233150*y**4-65902*y**5+8477*y**6-4393*y**7+1448*y**8)-r**2*(-1+y)**4*(5955
          +13576*y+22863*y**2-17954*y**3-3525*y**4-21670*y**5+30919*y**6-12508*y**7
          +1544*y**8)+r**6*(-1+y)**2*(31676-80900*y-42833*y**2+450852*y**3-487085*y**4
          +156424*y**5+21985*y**6-22172*y**7+4153*y**8)+r**8*(124314-274276*y
          +43999*y**2+557844*y**3-902951*y**4+566186*y**5-48799*y**6-104024*y**7
          +41281*y**8-3574*y**9))-12*logy*r**3*(-1+y)**3*(-1+r**2+y)**3*(7*r**24*(
          -1+y)**5+r**22*(-1+y)**3*(-638+1255*y-596*y**2+117*y**3)+r**20*(41204
          -197809*y+375995*y**2-355352*y**3+169948*y**4-35831*y**5+2077*y**6
          -232*y**7)+r**18*(266802-1248795*y+2320737*y**2-2166320*y**3+1038942*y**4
          -209565*y**5-9373*y**6+8280*y**7-708*y**8)-3*(-1+y)**7*(-7-35*y
          -105*y**2-211*y**3-157*y**4+167*y**5+245*y**6+115*y**7-304*y**8+92*y**9)
          +r**16*(1649289-6631428*y+9935031*y**2-6068242*y**3+135207*y**4+1487256*y**5
          -557277*y**6+59584*y**7-10458*y**8+1038*y**9)+r**6*(-1+y)**4*(-93074
          -191473*y-326709*y**2+577618*y**3-54374*y**4+583036*y**5-945652*y**6
          +443414*y**7-54328*y**8-5971*y**9+313*y**10)-r**8*(-1+y)**3*(-1309037
          +127984*y+230971*y**2+4783034*y**3-6140644*y**4+2022854*y**5+573716*y**6
          -495686*y**7+90621*y**8-1146*y**9+333*y**10)-r**2*(-1+y)**6*(1630+6583*y
          +16615*y**2+13053*y**3+909*y**4-23115*y**5+3937*y**6-2025*y**7+6857*y**8
          -3304*y**9+460*y**10)-r**4*(-1+y)**5*(-54428-148245*y-276534*y**2
          +71552*y**3+161266*y**4+317382*y**5-422970*y**6+133144*y**7+218*y**8
          -5401*y**9+816*y**10)+2*r**14*(-143350+139205*y+1127837*y**2-2245586*y**3
          +632752*y**4+1501882*y**5-1387310*y**6+398858*y**7-7974*y**8-15447*y**9
          +933*y**10)-2*r**10*(-1+y)**2*(-873366+1625157*y+179697*y**2-3995173*y**3
          +4164601*y**4-786855*y**5-774507*y**6+330283*y**7+3383*y**8-13536*y**9
          +1716*y**10)-2*r**12*(-1439316+3375459*y-1031061*y**2-3340418*y**3
          +2857764*y**4+755592*y**5-1973258*y**6+968046*y**7-192972*y**8+22321*y**9
          -3141*y**10+984*y**11))+r*(-1+y)**2*(-1+r**2+y)**4*(3*r**26*(-1+y)**6
          +r**24*(-1+y)**4*(-383+670*y-233*y**2+14*y**3)+2*r**22*(-1+y)**2*(18151
          -68058*y+92798*y**2-57364*y**3+16997*y**4-2124*y**5+10*y**6)+(-1
          +y)**10*(1+8*y+36*y**2+22*y**3-68*y**4-140*y**5-92*y**6+50*y**7
          +19*y**8+4*y**9)+2*r**20*(293461-1581600*y+3465875*y**2-3918644*y**3
          +2354738*y**4-643781*y**5+5465*y**6+24790*y**7-951*y**8+47*y**9)+r**18*(1227213
          -6151010*y+12628771*y**2-13582384*y**3+7823874*y**4-1756328*y**5-539390*y**6
          +456244*y**7-119051*y**8+14886*y**9+775*y**10)+r**2*(-1+y)**7*(1597
          +7729*y+22545*y**2+35921*y**3+20674*y**4-35858*y**5-29894*y**6-11870*y**7
          +39569*y**8-13959*y**9+661*y**10+85*y**11)+2*r**4*(-1+y)**6*(-24275
          -90386*y-213624*y**2-100138*y**3+21373*y**4+245107*y**5-124271*y**6
          +33439*y**7-37702*y**8+21687*y**9-4517*y**10+307*y**11)+2*r**6*(-1
          +y)**5*(318561+719501*y+1162698*y**2-1119772*y**3-994436*y**4-1411174*y**5
          +2889940*y**6-1153918*y**7-10753*y**8+85061*y**9-15282*y**10+1174*y**11)
          +4*r**12*(-1+y)**2*(8162815-13671650*y+576456*y**2+10153426*y**3-2301285*y**4
          -5517227*y**5+3240765*y**6+74209*y**7-424376*y**8+123675*y**9-13203*y**10
          +2295*y**11)+r**16*(10942159-49558070*y+85612431*y**2-61013654*y**3
          -3208512*y**4+33347098*y**5-20646876*y**6+4824454*y**7-325871*y**8+27612*y**9
          -6147*y**10+2976*y**11)+r**8*(-1+y)**4*(874927+790618*y+9369*y**2
          -765350*y**3-2072958*y**4+4727512*y**5-3492258*y**6+1065616*y**7-91625*y**8
          +49638*y**9-25839*y**10+5550*y**11)+r**10*(-1+y)**3*(12993683-5255233*y
          -4892007*y**2-37712275*y**3+58851726*y**4-18161794*y**5-10672230*y**6
          +7244402*y**7-1001185*y**8+8019*y**9-16179*y**10+8673*y**11)+4*r**14*(
          -4530563+19404840*y-28996867*y**2+13603930*y**3+7129940*y**4-8005778*y**5
          +264788*y**6+1140190*y**7+379035*y**8-535990*y**9+161451*y**10-16608*y**11
          +1632*y**12)))*math.log(mu0**2/r**2))/(6220800*logy**4*r**16*(-1+y)**8+2073600*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +259200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+14400*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+300*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(-21600*logy**3*r**11*(27+41*r**2
          +29*r**4+9*r**6)*(-1+y)**8-720*logy**2*r**7*(-1+y)**6*(74*r**12*(-1+y)**2
          +31*r**14*(-1+y)**2+r**10*(1389-1968*y+174*y**2+485*y**3-90*y**4)
          +5*r**8*(443-364*y-340*y**2+242*y**3+y**4+4*y**5)-(-1+y)**3*(11
          +11*y+11*y**2+251*y**3-184*y**4+20*y**5)-r**2*(-1+y)**2*(599-455*y**3
          +430*y**4-234*y**5+20*y**6)+5*r**6*(-17+772*y-1124*y**2+168*y**3
          +255*y**4-105*y**5+27*y**6)+r**4*(-3036+8502*y-6681*y**2-50*y**3
          +1860*y**4-744*y**5+113*y**6+36*y**7))-6*logy*r**3*(-1+y)**4*(-1+r**2
          +y)**2*(41*r**18*(-1+y)**4-r**16*(-1+y)**2*(-643+1368*y-807*y**2+162*y**3)
          -r**14*(-1+y)**2*(-15790+25508*y-7489*y**2-1926*y**3+257*y**4)+r**12*(
          -1+y)**2*(22492-45292*y+26723*y**2+338*y**3-2257*y**4+556*y**5)+(
          -1+y)**4*(11+22*y+33*y**2+604*y**3-95*y**4+94*y**5+683*y**6-1128*y**7
          +376*y**8)+r**10*(325264-987788*y+962749*y**2-168480*y**3-240815*y**4
          +115216*y**5-2237*y**6-4404*y**7+495*y**8)+r**2*(-1+y)**3*(1217+1195*y
          +1173*y**2+10851*y**3-12281*y**4+853*y**5-4525*y**6+5397*y**7-1856*y**8
          +376*y**9)+r**4*(-1+y)**2*(18460+228*y-1059*y**2-127026*y**3+222587*y**4
          -138000*y**5+21407*y**6+9694*y**7-3339*y**8+648*y**9)-r**8*(-592234
          +1816036*y-1796019*y**2+337456*y**3+482771*y**4-315066*y**5+67539*y**6
          +5044*y**7-6881*y**8+754*y**9)+r**6*(171082-446136*y+345989*y**2-173976*y**3
          +407904*y**4-548040*y**5+323186*y**6-83264*y**7-1874*y**8+5496*y**9
          -367*y**10))-r*(-1+y)**3*(-1+r**2+y)**3*(11*r**20*(-1+y)**5-r**18*(
          -1+y)**3*(-887+1561*y-584*y**2+20*y**3)-r**14*(-1+y)**2*(98866-215370*y
          +117060*y**2+18665*y**3-23400*y**4+2019*y**5+60*y**6)-6*r**16*(829
          -3910*y+7345*y**2-6960*y**3+3400*y**4-689*y**5-40*y**6+25*y**7)+r**12*(56552
          -202342*y+195188*y**2+67937*y**3-212345*y**4+111118*y**5-11938*y**6
          -5343*y**7+783*y**8+390*y**9)+(-1+y)**5*(56+168*y+336*y**2+869*y**3
          +572*y**4+363*y**5+82*y**6-561*y**7-144*y**8-47*y**9+106*y**10)+3*r**10*(
          -502676+1833106*y-2306948*y**2+790633*y**3+694954*y**4-671513*y**5
          +142444*y**6+32823*y**7-14458*y**8+871*y**9+164*y**10)+3*r**4*(-1+y)**3*(2543
          +3408*y+3113*y**2-42897*y**3+52608*y**4-18023*y**5+5142*y**6-7563*y**7
          +2797*y**8-133*y**9+205*y**10)+r**6*(-1+y)**2*(-128446+85278*y+28872*y**2
          +551901*y**3-1196170*y**4+902511*y**5-195488*y**6-103457*y**7+56364*y**8
          -5265*y**9+300*y**10)+r**2*(-1+y)**4*(1603+3104*y+4470*y**2+2351*y**3
          +1462*y**4-2943*y**5-16354*y**6+18205*y**7-7701*y**8+763*y**9+440*y**10)
          +r**8*(-598858+1924148*y-2036302*y**2+663653*y**3-36127*y**4+208109*y**5
          -130003*y**6+28427*y**7-47803*y**8+28227*y**9-3651*y**10+180*y**11)))*nlo.X1El(0,'SM',y/2,r))/(3110400*logy**4*r**16*(
          -1+y)**8+1036800*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+129600*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+7200*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +150*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6+120*logy*r**4*(
          -1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(-67+98*y
          -13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3-2*y**4
          +y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)+2*r**2*(
          -1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y-421*y**2
          +40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(
          -1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1
          +y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(
          -4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y
          +45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)
          +2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5
          -56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(0,'VR',y/2,r))/(1036800*logy**3*r**12*(
          -1+y)**6-600*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +259200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-720*logy**2*r**7*(4+5*r**2
          +2*r**4)*(-1+y)**6-24*logy*r**3*(-1+y)**4*(8*r**10*(-1+y)**2+3*r**12*(
          -1+y)**2-5*r**8*(-44+64*y-8*y**2-13*y**3+2*y**4)+2*(-1+y)**3*(
          -1-y-y**2-6*y**3+4*y**4)+5*r**6*(26+8*y-64*y**2+21*y**3+7*y**4)
          +r**2*(-1+y)**2*(-58+35*y**3-15*y**4+8*y**5)+5*r**4*(-61+170*y-133*y**2
          +y**3+31*y**4-11*y**5+3*y**6))-r*(-1+y)**3*(-1+r**2+y)**2*(7*r**12*(
          -1+y)**3+2*r**10*(-81+214*y-174*y**2+35*y**3+6*y**4)+r**8*(-169
          +509*y-558*y**2+220*y**3+3*y**4-5*y**5)-4*r**6*(1431-2992*y+1413*y**2
          +518*y**3-447*y**4+47*y**5)+(-1+y)**3*(-13-26*y-39*y**2-54*y**3
          -9*y**4+4*y**5+17*y**6)+2*r**2*(-1+y)**2*(-61-72*y-71*y**2+319*y**3
          -256*y**4+55*y**5+26*y**6)+r**4*(-1749+2827*y-705*y**2+335*y**3-1195*y**4
          +489*y**5-47*y**6+45*y**7)))*nlo.X1El(1,'SM',y/2,r))/(-8640*logy**3*r**12*(
          -1+y)**6+5*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -2160*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-180*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1
          +y)**4-(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1
          +y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(1,'VR',y/2,r))/(1440*logy**2*r**8*(-1+y)**4+240*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(-24*logy*r**3*(1+r**2)*(-1+y)**4-4*r*(-1+y)**3*(r**6*(-1+y)
          +3*r**2*(-1+y)**2*(3+y)+3*r**4*(-3+y+y**2)+(-1+y)**2*(1+y+y**2)))*nlo.X1El(2,'SM',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(2,'VR',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.ReVR

    if wc.SL2 != 0:
      resNP = 0
      resNP +=((muG*(21600*logy**3*r**10*(1+2*r**2+3*r**4)*(-1+y)**6+720*logy**2*r**6*(
          -1+y)**4*(50*r**10*(-1+y)**2+13*r**12*(-1+y)**2-5*r**8*(-45+36*y+36*y**2
          -34*y**3+3*y**4)+5*r**4*(-1+y)**2*(-25+18*y+9*y**2-12*y**3+6*y**4)
          +5*(-1+y)**3*(-3-3*y-3*y**2+11*y**3-8*y**4+2*y**5)+10*r**6*(-13
          +44*y-40*y**2+9*y**3-y**4+2*y**5)+2*r**2*(-1+y)**2*(-24+25*y**3
          -25*y**4+9*y**5))-6*logy*r**2*(-1+y)**3*(-1+r**2+y)**2*(17*r**16*(-1
          +y)**3+2*r**14*(288-847*y+813*y**2-287*y**3+33*y**4)+r**12*(6814
          -18440*y+15945*y**2-4435*y**3+285*y**4-169*y**5)-2*r**10*(-4386+11411*y
          -10170*y**2+1240*y**3+2640*y**4-859*y**5+124*y**6)-2*r**2*(-1+y)**3*(
          -142-351*y-627*y**2+920*y**3-600*y**4+297*y**5-139*y**6+42*y**7)
          +5*r**8*(8236-13694*y+3087*y**2+5295*y**3-3070*y**4+744*y**5-421*y**6
          +63*y**7)+(-1+y)**4*(-67-201*y-402*y**2-130*y**3+225*y**4+547*y**5
          -464*y**6+92*y**7)-r**4*(-1+y)**2*(4246+1348*y+451*y**2-14185*y**3
          +15460*y**4-4966*y**5-273*y**6+319*y**7)+2*r**6*(6036-12793*y+4053*y**2
          +9369*y**3-5805*y**4-5091*y**5+5863*y**6-1733*y**7+101*y**8))+(-1
          +y)**2*(-1+r**2+y)**3*(2*r**20*(-1+y)**4+2*r**18*(-1+y)**2*(-23+43*y
          -17*y**2+4*y**3)+r**16*(312-1218*y+1713*y**2-1138*y**3+436*y**4-92*y**5
          +7*y**6)+2*(-1+y)**5*(7+28*y+70*y**2+120*y**3-5*y**4-212*y**5+92*y**6)
          -r**14*(-6330+22770*y-29511*y**2+16621*y**3-3764*y**4+66*y**5+21*y**6
          +7*y**7)+r**12*(26298-80748*y+83091*y**2-27132*y**3-2675*y**4-1078*y**5
          +1623*y**6+14*y**7+7*y**8)+r**2*(-1+y)**4*(-1328-3624*y-6729*y**2
          +1623*y**3+2943*y**4+5433*y**5-6131*y**6+1649*y**7-43*y**8+7*y**9)
          +r**4*(-1+y)**3*(-3540-5160*y-4929*y**2+1137*y**3+15117*y**4-4695*y**5
          -5095*y**6+2779*y**7-257*y**8+43*y**9)+r**10*(-18-1746*y+18153*y**2
          +11083*y**3-79087*y**4+76433*y**5-29289*y**6+5537*y**7-343*y**8+77*y**9)
          +r**6*(-1+y)**2*(-38442-4266*y+4707*y**2+93893*y**3-87757*y**4+17807*y**5
          +2441*y**6+1523*y**7-613*y**8+107*y**9)+r**8*(132966-286548*y+119907*y**2
          +80278*y**3+33940*y**4-158304*y**5+97588*y**6-23722*y**7+4602*y**8
          -840*y**9+133*y**10))))/(1036800*logy**3*r**12*(-1+y)**6-600*(r**8*(-1
          +y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3+259200*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2))
      resNP += ((rhoD*(-21600*logy**3*r**8*(3+6*r**2+7*r**4+6*r**6)*(
          -1+y)**6+720*logy**2*r**4*(-1+y)**4*(-42*r**12*(-1+y)**2-33*r**14*(-1
          +y)**2+(-1+y)**4*(11+22*y+33*y**2-46*y**3+10*y**4)+2*r**10*(-318
          +366*y+87*y**2-170*y**3+15*y**4)-5*r**8*(-1+128*y-190*y**2+56*y**3
          +11*y**4+2*y**5)+2*r**2*(-1+y)**3*(-11-11*y-11*y**2+59*y**3-51*y**4
          +10*y**5)-r**4*(-1+y)**2*(-378+270*y+135*y**2-70*y**3-65*y**4+48*y**5)
          -5*r**6*(-59+226*y-221*y**2-24*y**3+135*y**4-72*y**5+15*y**6))-6*logy*(
          -1+y)**3*(-1+r**2+y)**2*(-126*r**18*(-1+y)**3-3*r**16*(745-2151*y
          +1983*y**2-633*y**3+56*y**4)+2*r**14*(-5333+14148*y-12237*y**2+3233*y**3
          -32*y**4+221*y**5)+(-1+y)**5*(7+28*y+70*y**2+120*y**3-5*y**4-212*y**5
          +92*y**6)+r**12*(-11472+34046*y-36375*y**2+10705*y**3+5535*y**4-2543*y**5
          +104*y**6)+2*r**6*(-1+y)**2*(-1375-2234*y-3396*y**2+24605*y**3-20205*y**4
          +4030*y**5+444*y**6+31*y**7)-r**4*(-1+y)**3*(-5944-9638*y-12423*y**2
          +29440*y**3-11230*y**4-626*y**5+233*y**6+88*y**7)+2*r**2*(-1+y)**4*(
          -94-289*y-592*y**2+210*y**3+60*y**4+319*y**5-306*y**6+92*y**7)-2*r**10*(62389
          -113134*y+34905*y**2+36265*y**3-17635*y**4-824*y**5-951*y**6+185*y**7)
          +r**8*(-79686+171108*y-79623*y**2-53939*y**3+30780*y**4+28966*y**5
          -20103*y**6+2153*y**7+344*y**8))-(-1+y)**2*(-1+r**2+y)**3*(15*r**20*(
          -1+y)**4+r**18*(-1+y)**2*(-344+643*y-254*y**2+45*y**3)+r**16*(1897
          -7357*y+10170*y**2-6552*y**3+2421*y**4-463*y**5+4*y**6)+r**14*(13098
          -44442*y+53499*y**2-25694*y**3+2716*y**4+258*y**5+363*y**6-98*y**7)
          +r**12*(37504-117364*y+128331*y**2-47727*y**3-4260*y**4+2226*y**5
          +339*y**6+989*y**7-38*y**8)+(-1+y)**5*(-195-738*y-1761*y**2-2092*y**3
          +611*y**4+4010*y**5-2247*y**6+176*y**7+32*y**8+4*y**9)+r**4*(-1+y)**3*(
          -38017-44843*y-44349*y**2+205866*y**3-92587*y**4-6068*y**5+2073*y**6
          +2214*y**7+104*y**8+7*y**9)+r**2*(-1+y)**4*(1686+4473*y+8235*y**2
          -12692*y**3+4773*y**4+564*y**5+1477*y**6-1280*y**7+157*y**8+7*y**9)
          +r**6*(-1+y)**2*(-70682-4322*y+26623*y**2+6430*y**3+60421*y**4-42548*y**5
          +857*y**6+5342*y**7-595*y**8+74*y**9)+r**10*(-1070-6748*y+41829*y**2
          -16682*y**3-66089*y**4+65900*y**5-17617*y**6+1086*y**7-173*y**8+164*y**9)
          +r**8*(454884-1078686*y+610629*y**2+306079*y**3-286791*y**4-93729*y**5
          +94491*y**6-8199*y**7+2451*y**8-1329*y**9+200*y**10))))/(3110400*logy**3*r**12*(
          -1+y)**6-1800*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +777600*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+64800*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*muWC**3*(21600*logy**3*r**8*(3
          +6*r**2+7*r**4+6*r**6)*(-1+y)**6-720*logy**2*r**4*(-1+y)**4*(-42*r**12*(
          -1+y)**2-33*r**14*(-1+y)**2+(-1+y)**4*(11+22*y+33*y**2-46*y**3
          +10*y**4)+2*r**10*(-318+366*y+87*y**2-170*y**3+15*y**4)-5*r**8*(-1
          +128*y-190*y**2+56*y**3+11*y**4+2*y**5)+2*r**2*(-1+y)**3*(-11-11*y
          -11*y**2+59*y**3-51*y**4+10*y**5)-r**4*(-1+y)**2*(-378+270*y+135*y**2
          -70*y**3-65*y**4+48*y**5)-5*r**6*(-59+226*y-221*y**2-24*y**3+135*y**4
          -72*y**5+15*y**6))+6*logy*(-1+y)**3*(-1+r**2+y)**2*(-126*r**18*(-1
          +y)**3-3*r**16*(745-2151*y+1983*y**2-633*y**3+56*y**4)+2*r**14*(-5333
          +14148*y-12237*y**2+3233*y**3-32*y**4+221*y**5)+(-1+y)**5*(7+28*y
          +70*y**2+120*y**3-5*y**4-212*y**5+92*y**6)+r**12*(-11472+34046*y
          -36375*y**2+10705*y**3+5535*y**4-2543*y**5+104*y**6)+2*r**6*(-1+y)**2*(
          -1375-2234*y-3396*y**2+24605*y**3-20205*y**4+4030*y**5+444*y**6+31*y**7)
          -r**4*(-1+y)**3*(-5944-9638*y-12423*y**2+29440*y**3-11230*y**4-626*y**5
          +233*y**6+88*y**7)+2*r**2*(-1+y)**4*(-94-289*y-592*y**2+210*y**3
          +60*y**4+319*y**5-306*y**6+92*y**7)-2*r**10*(62389-113134*y+34905*y**2
          +36265*y**3-17635*y**4-824*y**5-951*y**6+185*y**7)+r**8*(-79686+171108*y
          -79623*y**2-53939*y**3+30780*y**4+28966*y**5-20103*y**6+2153*y**7+344*y**8))
          +(-1+y)**2*(-1+r**2+y)**3*(15*r**20*(-1+y)**4+r**18*(-1+y)**2*(-344
          +643*y-254*y**2+45*y**3)+r**16*(1897-7357*y+10170*y**2-6552*y**3
          +2421*y**4-463*y**5+4*y**6)+r**14*(13098-44442*y+53499*y**2-25694*y**3
          +2716*y**4+258*y**5+363*y**6-98*y**7)+r**12*(37504-117364*y+128331*y**2
          -47727*y**3-4260*y**4+2226*y**5+339*y**6+989*y**7-38*y**8)+(-1+y)**5*(
          -195-738*y-1761*y**2-2092*y**3+611*y**4+4010*y**5-2247*y**6+176*y**7
          +32*y**8+4*y**9)+r**4*(-1+y)**3*(-38017-44843*y-44349*y**2+205866*y**3
          -92587*y**4-6068*y**5+2073*y**6+2214*y**7+104*y**8+7*y**9)+r**2*(-1
          +y)**4*(1686+4473*y+8235*y**2-12692*y**3+4773*y**4+564*y**5+1477*y**6
          -1280*y**7+157*y**8+7*y**9)+r**6*(-1+y)**2*(-70682-4322*y+26623*y**2
          +6430*y**3+60421*y**4-42548*y**5+857*y**6+5342*y**7-595*y**8+74*y**9)
          +r**10*(-1070-6748*y+41829*y**2-16682*y**3-66089*y**4+65900*y**5-17617*y**6
          +1086*y**7-173*y**8+164*y**9)+r**8*(454884-1078686*y+610629*y**2+306079*y**3
          -286791*y**4-93729*y**5+94491*y**6-8199*y**7+2451*y**8-1329*y**9+200*y**10))))/(3499200*logy**3*r**12*(
          -1+y)**6-2025*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +874800*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+72900*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((rhoLS*(21600*logy**3*r**10*(1+3*r**4)*(
          -1+y)**6-720*logy**2*r**6*(-1+y)**3*(29*r**12*(-1+y)**3+3*r**10*(57-171*y
          +171*y**2-67*y**3+5*y**4)+5*r**8*(13+15*y-96*y**2+94*y**3-33*y**4
          +3*y**5)-5*r**6*(38-114*y+114*y**2-28*y**3-10*y**4+3*y**5)-r**2*(
          -1+y)**3*(19-10*y**4+6*y**5)+(-1+y)**4*(-21-21*y-21*y**2+89*y**3
          -56*y**4+10*y**5)-5*r**4*(3-27*y+54*y**2-22*y**3-57*y**4+87*y**5
          -47*y**6+9*y**7))+6*logy*r**2*(-1+y)*(-1+r**2+y)**2*(47*r**16*(-1+y)**5
          +2*r**14*(-1+y)**2*(1023-3022*y+2928*y**2-992*y**3+173*y**4)-r**12*(
          -1+y)**2*(426-4240*y+6825*y**2-5475*y**3+2465*y**4+79*y**5)+2*r**6*(
          -1+y)**2*(7801-13458*y+2148*y**2+9304*y**3-5870*y**4+1614*y**5-342*y**6
          -188*y**7+41*y**8)+2*r**2*(-1+y)**4*(-547-504*y-461*y**2+2972*y**3
          -2325*y**4+622*y**5+179*y**6-264*y**7+78*y**8)-r**4*(-1+y)**3*(-7366
          +2938*y+547*y**2+36296*y**3-58495*y**4+33466*y**5-7443*y**6+268*y**7
          +89*y**8)+(-1+y)**5*(-43-86*y-129*y**2+8*y**3-125*y**4+18*y**5
          +461*y**6-396*y**7+92*y**8)-2*r**10*(14469-57212*y+79837*y**2-40524*y**3
          -6635*y**4+12186*y**5-393*y**6-2152*y**7+324*y**8)-5*r**8*(4604-18606*y
          +27951*y**2-17117*y**3-4821*y**4+18387*y**5-15103*y**6+5365*y**7-667*y**8
          +7*y**9))-(-1+y)*(-1+r**2+y)**3*(12*r**20*(-1+y)**5+r**18*(-1+y)**2*(291
          -837*y+765*y**2-267*y**3+41*y**4)+r**16*(-3247+15680*y-29626*y**2
          +28011*y**3-14328*y**4+4065*y**5-531*y**6+16*y**7)+(-1+y)**5*(31
          +93*y+186*y**2-40*y**3+175*y**4+159*y**5-488*y**6+184*y**7)+r**14*(1720
          -11690*y+27409*y**2-34108*y**3+25469*y**4-9751*y**5+679*y**6+305*y**7
          -93*y**8)-r**2*(-1+y)**4*(-43-251*y-495*y**2+3792*y**3-1253*y**4
          -997*y**5-2739*y**6+4080*y**7-1482*y**8+88*y**9)-r**12*(7288-30746*y
          +51079*y**2-37873*y**3+515*y**4+22892*y**5-16749*y**6+5471*y**7-1387*y**8
          +110*y**9)+r**4*(-1+y)**3*(-12260-5990*y-3461*y**2+48024*y**3-44796*y**4
          +18183*y**5+145*y**6-8604*y**7+4686*y**8-549*y**9+22*y**10)+r**10*(135698
          -488692*y+590321*y**2-215920*y**3-131140*y**4+146855*y**5-43538*y**6
          +4844*y**7-3720*y**8+645*y**9+47*y**10)+r**6*(-1+y)**2*(3752-13686*y
          +8427*y**2-117816*y**3+249434*y**4-192963*y**5+56126*y**6-6332*y**7
          +3696*y**8-1239*y**9+101*y**10)+r**8*(-56786+204754*y-233975*y**2
          +78599*y**3-104250*y**4+306405*y**5-286210*y**6+102315*y**7-11194*y**8
          +1295*y**9-1109*y**10+156*y**11))))/(1036800*logy**3*r**12*(-1+y)**6-600*(r**8*(
          -1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3+259200*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2))
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1
          +y)**6+120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2
          -5*r**8*(-67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2
          +22*y**3-2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4
          +2*y**5)+2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151
          +482*y-421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(-1
          +r**2+y)**2*(7*r**16*(-1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2
          +27*y**3)-r**12*(-1+y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)
          +2*r**10*(-1+y)**2*(-4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)
          +5*r**8*(13422-43158*y+45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6
          -284*y**7+33*y**8)+2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3
          -2300*y**4+277*y**5-56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436
          -542*y+757*y**2+11016*y**3-25545*y**4+20466*y**5-4753*y**6-652*y**7
          +89*y**8)+(-1+y)**4*(67+134*y+201*y**2+428*y**3-55*y**4-22*y**5
          -89*y**6-156*y**7+92*y**8)-2*r**6*(-17964+49281*y-40854*y**2+5986*y**3
          +8446*y**4-11636*y**5+9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(0,'SL2',y/2,r))/(1036800*logy**3*r**12*(
          -1+y)**6-600*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +259200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-3600*logy**2*r**8*(15+10*r**2
          +3*r**4)*(-1+y)**6-120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(
          -1+y)**2-5*r**8*(-67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y
          -18*y**2+22*y**3-2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3
          -16*y**4+2*y**5)+2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(
          -151+482*y-421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))-(-1+y)**2*(
          -1+r**2+y)**2*(7*r**16*(-1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2
          +27*y**3)-r**12*(-1+y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)
          +2*r**10*(-1+y)**2*(-4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)
          +5*r**8*(13422-43158*y+45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6
          -284*y**7+33*y**8)+2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3
          -2300*y**4+277*y**5-56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436
          -542*y+757*y**2+11016*y**3-25545*y**4+20466*y**5-4753*y**6-652*y**7
          +89*y**8)+(-1+y)**4*(67+134*y+201*y**2+428*y**3-55*y**4-22*y**5
          -89*y**6-156*y**7+92*y**8)-2*r**6*(-17964+49281*y-40854*y**2+5986*y**3
          +8446*y**4-11636*y**5+9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(0,'SM',y/2,r))/(4147200*logy**3*r**12*(
          -1+y)**6-2400*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +1036800*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+86400*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1
          +y)**4-(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1
          +y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(1,'SL2',y/2,r))/(1440*logy**2*r**8*(-1+y)**4+240*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(60*logy*r**4*(3+r**2)*(-1+y)**4+(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(1,'SM',y/2,r))/(5760*logy**2*r**8*(
          -1+y)**4+960*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+40*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(2,'SL2',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -(api*(-1+y)**2*nlo.X1El(2,'SM',y/2,r))/(48*logy*r**4*(-1+y)**2+4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))))
      res += resNP*wc.SL2

    if wc.SR2 != 0:
      resNP = 0
      resNP +=((muG*(21600*logy**3*r**10*(1+2*r**2+3*r**4)*(-1+y)**6+720*logy**2*r**6*(
          -1+y)**4*(50*r**10*(-1+y)**2+13*r**12*(-1+y)**2-5*r**8*(-45+36*y+36*y**2
          -34*y**3+3*y**4)+5*r**4*(-1+y)**2*(-25+18*y+9*y**2-12*y**3+6*y**4)
          +5*(-1+y)**3*(-3-3*y-3*y**2+11*y**3-8*y**4+2*y**5)+10*r**6*(-13
          +44*y-40*y**2+9*y**3-y**4+2*y**5)+2*r**2*(-1+y)**2*(-24+25*y**3
          -25*y**4+9*y**5))-6*logy*r**2*(-1+y)**3*(-1+r**2+y)**2*(17*r**16*(-1
          +y)**3+2*r**14*(288-847*y+813*y**2-287*y**3+33*y**4)+r**12*(6814
          -18440*y+15945*y**2-4435*y**3+285*y**4-169*y**5)-2*r**10*(-4386+11411*y
          -10170*y**2+1240*y**3+2640*y**4-859*y**5+124*y**6)-2*r**2*(-1+y)**3*(
          -142-351*y-627*y**2+920*y**3-600*y**4+297*y**5-139*y**6+42*y**7)
          +5*r**8*(8236-13694*y+3087*y**2+5295*y**3-3070*y**4+744*y**5-421*y**6
          +63*y**7)+(-1+y)**4*(-67-201*y-402*y**2-130*y**3+225*y**4+547*y**5
          -464*y**6+92*y**7)-r**4*(-1+y)**2*(4246+1348*y+451*y**2-14185*y**3
          +15460*y**4-4966*y**5-273*y**6+319*y**7)+2*r**6*(6036-12793*y+4053*y**2
          +9369*y**3-5805*y**4-5091*y**5+5863*y**6-1733*y**7+101*y**8))+(-1
          +y)**2*(-1+r**2+y)**3*(2*r**20*(-1+y)**4+2*r**18*(-1+y)**2*(-23+43*y
          -17*y**2+4*y**3)+r**16*(312-1218*y+1713*y**2-1138*y**3+436*y**4-92*y**5
          +7*y**6)+2*(-1+y)**5*(7+28*y+70*y**2+120*y**3-5*y**4-212*y**5+92*y**6)
          -r**14*(-6330+22770*y-29511*y**2+16621*y**3-3764*y**4+66*y**5+21*y**6
          +7*y**7)+r**12*(26298-80748*y+83091*y**2-27132*y**3-2675*y**4-1078*y**5
          +1623*y**6+14*y**7+7*y**8)+r**2*(-1+y)**4*(-1328-3624*y-6729*y**2
          +1623*y**3+2943*y**4+5433*y**5-6131*y**6+1649*y**7-43*y**8+7*y**9)
          +r**4*(-1+y)**3*(-3540-5160*y-4929*y**2+1137*y**3+15117*y**4-4695*y**5
          -5095*y**6+2779*y**7-257*y**8+43*y**9)+r**10*(-18-1746*y+18153*y**2
          +11083*y**3-79087*y**4+76433*y**5-29289*y**6+5537*y**7-343*y**8+77*y**9)
          +r**6*(-1+y)**2*(-38442-4266*y+4707*y**2+93893*y**3-87757*y**4+17807*y**5
          +2441*y**6+1523*y**7-613*y**8+107*y**9)+r**8*(132966-286548*y+119907*y**2
          +80278*y**3+33940*y**4-158304*y**5+97588*y**6-23722*y**7+4602*y**8
          -840*y**9+133*y**10))))/(1036800*logy**3*r**12*(-1+y)**6-600*(r**8*(-1
          +y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3+259200*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2))
      resNP += ((rhoD*(-21600*logy**3*r**8*(3+6*r**2+7*r**4+6*r**6)*(
          -1+y)**6+720*logy**2*r**4*(-1+y)**4*(-42*r**12*(-1+y)**2-33*r**14*(-1
          +y)**2+(-1+y)**4*(11+22*y+33*y**2-46*y**3+10*y**4)+2*r**10*(-318
          +366*y+87*y**2-170*y**3+15*y**4)-5*r**8*(-1+128*y-190*y**2+56*y**3
          +11*y**4+2*y**5)+2*r**2*(-1+y)**3*(-11-11*y-11*y**2+59*y**3-51*y**4
          +10*y**5)-r**4*(-1+y)**2*(-378+270*y+135*y**2-70*y**3-65*y**4+48*y**5)
          -5*r**6*(-59+226*y-221*y**2-24*y**3+135*y**4-72*y**5+15*y**6))-6*logy*(
          -1+y)**3*(-1+r**2+y)**2*(-126*r**18*(-1+y)**3-3*r**16*(745-2151*y
          +1983*y**2-633*y**3+56*y**4)+2*r**14*(-5333+14148*y-12237*y**2+3233*y**3
          -32*y**4+221*y**5)+(-1+y)**5*(7+28*y+70*y**2+120*y**3-5*y**4-212*y**5
          +92*y**6)+r**12*(-11472+34046*y-36375*y**2+10705*y**3+5535*y**4-2543*y**5
          +104*y**6)+2*r**6*(-1+y)**2*(-1375-2234*y-3396*y**2+24605*y**3-20205*y**4
          +4030*y**5+444*y**6+31*y**7)-r**4*(-1+y)**3*(-5944-9638*y-12423*y**2
          +29440*y**3-11230*y**4-626*y**5+233*y**6+88*y**7)+2*r**2*(-1+y)**4*(
          -94-289*y-592*y**2+210*y**3+60*y**4+319*y**5-306*y**6+92*y**7)-2*r**10*(62389
          -113134*y+34905*y**2+36265*y**3-17635*y**4-824*y**5-951*y**6+185*y**7)
          +r**8*(-79686+171108*y-79623*y**2-53939*y**3+30780*y**4+28966*y**5
          -20103*y**6+2153*y**7+344*y**8))-(-1+y)**2*(-1+r**2+y)**3*(15*r**20*(
          -1+y)**4+r**18*(-1+y)**2*(-344+643*y-254*y**2+45*y**3)+r**16*(1897
          -7357*y+10170*y**2-6552*y**3+2421*y**4-463*y**5+4*y**6)+r**14*(13098
          -44442*y+53499*y**2-25694*y**3+2716*y**4+258*y**5+363*y**6-98*y**7)
          +r**12*(37504-117364*y+128331*y**2-47727*y**3-4260*y**4+2226*y**5
          +339*y**6+989*y**7-38*y**8)+(-1+y)**5*(-195-738*y-1761*y**2-2092*y**3
          +611*y**4+4010*y**5-2247*y**6+176*y**7+32*y**8+4*y**9)+r**4*(-1+y)**3*(
          -38017-44843*y-44349*y**2+205866*y**3-92587*y**4-6068*y**5+2073*y**6
          +2214*y**7+104*y**8+7*y**9)+r**2*(-1+y)**4*(1686+4473*y+8235*y**2
          -12692*y**3+4773*y**4+564*y**5+1477*y**6-1280*y**7+157*y**8+7*y**9)
          +r**6*(-1+y)**2*(-70682-4322*y+26623*y**2+6430*y**3+60421*y**4-42548*y**5
          +857*y**6+5342*y**7-595*y**8+74*y**9)+r**10*(-1070-6748*y+41829*y**2
          -16682*y**3-66089*y**4+65900*y**5-17617*y**6+1086*y**7-173*y**8+164*y**9)
          +r**8*(454884-1078686*y+610629*y**2+306079*y**3-286791*y**4-93729*y**5
          +94491*y**6-8199*y**7+2451*y**8-1329*y**9+200*y**10))))/(3110400*logy**3*r**12*(
          -1+y)**6-1800*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +777600*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+64800*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*muWC**3*(21600*logy**3*r**8*(3
          +6*r**2+7*r**4+6*r**6)*(-1+y)**6-720*logy**2*r**4*(-1+y)**4*(-42*r**12*(
          -1+y)**2-33*r**14*(-1+y)**2+(-1+y)**4*(11+22*y+33*y**2-46*y**3
          +10*y**4)+2*r**10*(-318+366*y+87*y**2-170*y**3+15*y**4)-5*r**8*(-1
          +128*y-190*y**2+56*y**3+11*y**4+2*y**5)+2*r**2*(-1+y)**3*(-11-11*y
          -11*y**2+59*y**3-51*y**4+10*y**5)-r**4*(-1+y)**2*(-378+270*y+135*y**2
          -70*y**3-65*y**4+48*y**5)-5*r**6*(-59+226*y-221*y**2-24*y**3+135*y**4
          -72*y**5+15*y**6))+6*logy*(-1+y)**3*(-1+r**2+y)**2*(-126*r**18*(-1
          +y)**3-3*r**16*(745-2151*y+1983*y**2-633*y**3+56*y**4)+2*r**14*(-5333
          +14148*y-12237*y**2+3233*y**3-32*y**4+221*y**5)+(-1+y)**5*(7+28*y
          +70*y**2+120*y**3-5*y**4-212*y**5+92*y**6)+r**12*(-11472+34046*y
          -36375*y**2+10705*y**3+5535*y**4-2543*y**5+104*y**6)+2*r**6*(-1+y)**2*(
          -1375-2234*y-3396*y**2+24605*y**3-20205*y**4+4030*y**5+444*y**6+31*y**7)
          -r**4*(-1+y)**3*(-5944-9638*y-12423*y**2+29440*y**3-11230*y**4-626*y**5
          +233*y**6+88*y**7)+2*r**2*(-1+y)**4*(-94-289*y-592*y**2+210*y**3
          +60*y**4+319*y**5-306*y**6+92*y**7)-2*r**10*(62389-113134*y+34905*y**2
          +36265*y**3-17635*y**4-824*y**5-951*y**6+185*y**7)+r**8*(-79686+171108*y
          -79623*y**2-53939*y**3+30780*y**4+28966*y**5-20103*y**6+2153*y**7+344*y**8))
          +(-1+y)**2*(-1+r**2+y)**3*(15*r**20*(-1+y)**4+r**18*(-1+y)**2*(-344
          +643*y-254*y**2+45*y**3)+r**16*(1897-7357*y+10170*y**2-6552*y**3
          +2421*y**4-463*y**5+4*y**6)+r**14*(13098-44442*y+53499*y**2-25694*y**3
          +2716*y**4+258*y**5+363*y**6-98*y**7)+r**12*(37504-117364*y+128331*y**2
          -47727*y**3-4260*y**4+2226*y**5+339*y**6+989*y**7-38*y**8)+(-1+y)**5*(
          -195-738*y-1761*y**2-2092*y**3+611*y**4+4010*y**5-2247*y**6+176*y**7
          +32*y**8+4*y**9)+r**4*(-1+y)**3*(-38017-44843*y-44349*y**2+205866*y**3
          -92587*y**4-6068*y**5+2073*y**6+2214*y**7+104*y**8+7*y**9)+r**2*(-1
          +y)**4*(1686+4473*y+8235*y**2-12692*y**3+4773*y**4+564*y**5+1477*y**6
          -1280*y**7+157*y**8+7*y**9)+r**6*(-1+y)**2*(-70682-4322*y+26623*y**2
          +6430*y**3+60421*y**4-42548*y**5+857*y**6+5342*y**7-595*y**8+74*y**9)
          +r**10*(-1070-6748*y+41829*y**2-16682*y**3-66089*y**4+65900*y**5-17617*y**6
          +1086*y**7-173*y**8+164*y**9)+r**8*(454884-1078686*y+610629*y**2+306079*y**3
          -286791*y**4-93729*y**5+94491*y**6-8199*y**7+2451*y**8-1329*y**9+200*y**10))))/(3499200*logy**3*r**12*(
          -1+y)**6-2025*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +874800*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+72900*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((rhoLS*(21600*logy**3*r**10*(1+3*r**4)*(
          -1+y)**6-720*logy**2*r**6*(-1+y)**3*(29*r**12*(-1+y)**3+3*r**10*(57-171*y
          +171*y**2-67*y**3+5*y**4)+5*r**8*(13+15*y-96*y**2+94*y**3-33*y**4
          +3*y**5)-5*r**6*(38-114*y+114*y**2-28*y**3-10*y**4+3*y**5)-r**2*(
          -1+y)**3*(19-10*y**4+6*y**5)+(-1+y)**4*(-21-21*y-21*y**2+89*y**3
          -56*y**4+10*y**5)-5*r**4*(3-27*y+54*y**2-22*y**3-57*y**4+87*y**5
          -47*y**6+9*y**7))+6*logy*r**2*(-1+y)*(-1+r**2+y)**2*(47*r**16*(-1+y)**5
          +2*r**14*(-1+y)**2*(1023-3022*y+2928*y**2-992*y**3+173*y**4)-r**12*(
          -1+y)**2*(426-4240*y+6825*y**2-5475*y**3+2465*y**4+79*y**5)+2*r**6*(
          -1+y)**2*(7801-13458*y+2148*y**2+9304*y**3-5870*y**4+1614*y**5-342*y**6
          -188*y**7+41*y**8)+2*r**2*(-1+y)**4*(-547-504*y-461*y**2+2972*y**3
          -2325*y**4+622*y**5+179*y**6-264*y**7+78*y**8)-r**4*(-1+y)**3*(-7366
          +2938*y+547*y**2+36296*y**3-58495*y**4+33466*y**5-7443*y**6+268*y**7
          +89*y**8)+(-1+y)**5*(-43-86*y-129*y**2+8*y**3-125*y**4+18*y**5
          +461*y**6-396*y**7+92*y**8)-2*r**10*(14469-57212*y+79837*y**2-40524*y**3
          -6635*y**4+12186*y**5-393*y**6-2152*y**7+324*y**8)-5*r**8*(4604-18606*y
          +27951*y**2-17117*y**3-4821*y**4+18387*y**5-15103*y**6+5365*y**7-667*y**8
          +7*y**9))-(-1+y)*(-1+r**2+y)**3*(12*r**20*(-1+y)**5+r**18*(-1+y)**2*(291
          -837*y+765*y**2-267*y**3+41*y**4)+r**16*(-3247+15680*y-29626*y**2
          +28011*y**3-14328*y**4+4065*y**5-531*y**6+16*y**7)+(-1+y)**5*(31
          +93*y+186*y**2-40*y**3+175*y**4+159*y**5-488*y**6+184*y**7)+r**14*(1720
          -11690*y+27409*y**2-34108*y**3+25469*y**4-9751*y**5+679*y**6+305*y**7
          -93*y**8)-r**2*(-1+y)**4*(-43-251*y-495*y**2+3792*y**3-1253*y**4
          -997*y**5-2739*y**6+4080*y**7-1482*y**8+88*y**9)-r**12*(7288-30746*y
          +51079*y**2-37873*y**3+515*y**4+22892*y**5-16749*y**6+5471*y**7-1387*y**8
          +110*y**9)+r**4*(-1+y)**3*(-12260-5990*y-3461*y**2+48024*y**3-44796*y**4
          +18183*y**5+145*y**6-8604*y**7+4686*y**8-549*y**9+22*y**10)+r**10*(135698
          -488692*y+590321*y**2-215920*y**3-131140*y**4+146855*y**5-43538*y**6
          +4844*y**7-3720*y**8+645*y**9+47*y**10)+r**6*(-1+y)**2*(3752-13686*y
          +8427*y**2-117816*y**3+249434*y**4-192963*y**5+56126*y**6-6332*y**7
          +3696*y**8-1239*y**9+101*y**10)+r**8*(-56786+204754*y-233975*y**2
          +78599*y**3-104250*y**4+306405*y**5-286210*y**6+102315*y**7-11194*y**8
          +1295*y**9-1109*y**10+156*y**11))))/(1036800*logy**3*r**12*(-1+y)**6-600*(r**8*(
          -1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3+259200*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2))
      resNP += ((api*(-3600*logy**2*r**8*(15+10*r**2+3*r**4)*(
          -1+y)**6-120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2
          -5*r**8*(-67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2
          +22*y**3-2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4
          +2*y**5)+2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151
          +482*y-421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))-(-1+y)**2*(-1
          +r**2+y)**2*(7*r**16*(-1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2
          +27*y**3)-r**12*(-1+y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)
          +2*r**10*(-1+y)**2*(-4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)
          +5*r**8*(13422-43158*y+45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6
          -284*y**7+33*y**8)+2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3
          -2300*y**4+277*y**5-56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436
          -542*y+757*y**2+11016*y**3-25545*y**4+20466*y**5-4753*y**6-652*y**7
          +89*y**8)+(-1+y)**4*(67+134*y+201*y**2+428*y**3-55*y**4-22*y**5
          -89*y**6-156*y**7+92*y**8)-2*r**6*(-17964+49281*y-40854*y**2+5986*y**3
          +8446*y**4-11636*y**5+9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(0,'SM',y/2,r))/(4147200*logy**3*r**12*(
          -1+y)**6-2400*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +1036800*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+86400*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2
          +3*r**4)*(-1+y)**6+120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(
          -1+y)**2-5*r**8*(-67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y
          -18*y**2+22*y**3-2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3
          -16*y**4+2*y**5)+2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(
          -151+482*y-421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(
          -1+r**2+y)**2*(7*r**16*(-1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2
          +27*y**3)-r**12*(-1+y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)
          +2*r**10*(-1+y)**2*(-4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)
          +5*r**8*(13422-43158*y+45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6
          -284*y**7+33*y**8)+2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3
          -2300*y**4+277*y**5-56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436
          -542*y+757*y**2+11016*y**3-25545*y**4+20466*y**5-4753*y**6-652*y**7
          +89*y**8)+(-1+y)**4*(67+134*y+201*y**2+428*y**3-55*y**4-22*y**5
          -89*y**6-156*y**7+92*y**8)-2*r**6*(-17964+49281*y-40854*y**2+5986*y**3
          +8446*y**4-11636*y**5+9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(0,'SR2',y/2,r))/(1036800*logy**3*r**12*(
          -1+y)**6-600*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +259200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(60*logy*r**4*(3+r**2)*(-1
          +y)**4+(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1
          +y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(1,'SM',y/2,r))/(5760*logy**2*r**8*(-1+y)**4+960*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +40*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1+y)**4-(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(1,'SR2',y/2,r))/(1440*logy**2*r**8*(
          -1+y)**4+240*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2)-(api*(-1+y)**2*nlo.X1El(2,'SM',y/2,r))/(48*logy*r**4*(
          -1+y)**2+4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
          )
      resNP += ((api*(-1+y)**2*nlo.X1El(2,'SR2',y/2,r))/(12*logy*r**4*(-1+y)**2-r**8*(
          -1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.SR2

    if wc.VL2 != 0:
      resNP = 0
      resNP +=((api*(3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6+120*logy*r**4*(-1
          +y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(-67+98*y-13*y**2
          -20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3-2*y**4+y**5)-5*(
          -1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)+2*r**2*(-1+y)**2*(
          -163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y-421*y**2+40*y**3
          +73*y**4-32*y**5+9*y**6))+(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(-1+y)**4
          -2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1+y)**2*(-3356
          +5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(-4416+6165*y
          +15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y+45699*y**2
          -12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)+2*r**2*(
          -1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5-56*y**6
          +11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(0,'SM',y/2,r))/(345600*logy**3*r**12*(
          -1+y)**6-200*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +86400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+7200*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-3600*logy**2*r**8*(15+10*r**2
          +3*r**4)*(-1+y)**6-120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(
          -1+y)**2-5*r**8*(-67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y
          -18*y**2+22*y**3-2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3
          -16*y**4+2*y**5)+2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(
          -151+482*y-421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))-(-1+y)**2*(
          -1+r**2+y)**2*(7*r**16*(-1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2
          +27*y**3)-r**12*(-1+y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)
          +2*r**10*(-1+y)**2*(-4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)
          +5*r**8*(13422-43158*y+45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6
          -284*y**7+33*y**8)+2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3
          -2300*y**4+277*y**5-56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436
          -542*y+757*y**2+11016*y**3-25545*y**4+20466*y**5-4753*y**6-652*y**7
          +89*y**8)+(-1+y)**4*(67+134*y+201*y**2+428*y**3-55*y**4-22*y**5
          -89*y**6-156*y**7+92*y**8)-2*r**6*(-17964+49281*y-40854*y**2+5986*y**3
          +8446*y**4-11636*y**5+9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(0,'VL',y/2,r))/(518400*logy**3*r**12*(
          -1+y)**6-300*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +129600*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+10800*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2
          +3*r**4)*(-1+y)**6+120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(
          -1+y)**2-5*r**8*(-67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y
          -18*y**2+22*y**3-2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3
          -16*y**4+2*y**5)+2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(
          -151+482*y-421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(
          -1+r**2+y)**2*(7*r**16*(-1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2
          +27*y**3)-r**12*(-1+y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)
          +2*r**10*(-1+y)**2*(-4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)
          +5*r**8*(13422-43158*y+45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6
          -284*y**7+33*y**8)+2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3
          -2300*y**4+277*y**5-56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436
          -542*y+757*y**2+11016*y**3-25545*y**4+20466*y**5-4753*y**6-652*y**7
          +89*y**8)+(-1+y)**4*(67+134*y+201*y**2+428*y**3-55*y**4-22*y**5
          -89*y**6-156*y**7+92*y**8)-2*r**6*(-17964+49281*y-40854*y**2+5986*y**3
          +8446*y**4-11636*y**5+9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(0,'VL2',y/2,r))/(1036800*logy**3*r**12*(
          -1+y)**6-600*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +259200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-180*logy*r**4*(3+r**2)*(-1
          +y)**4-3*(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(
          -1+y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(1,'SM',y/2,r))/(1440*logy**2*r**8*(-1+y)**4+240*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(60*logy*r**4*(3+r**2)*(-1+y)**4+(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(1,'VL',y/2,r))/(720*logy**2*r**8*(
          -1+y)**4+120*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1+y)**4
          -(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(
          -5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y
          -13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(1,'VL2',y/2,r))/(1440*logy**2*r**8*(
          -1+y)**4+240*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2)+(3*api*(-1+y)**2*nlo.X1El(2,'SM',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -(2*api*(-1+y)**2*nlo.X1El(2,'VL',y/2,r))/(12*logy*r**4*(-1+y)**2-r**8*(
          -1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      resNP += ((api*(-1+y)**2*nlo.X1El(2,'VL2',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.VL2

    if wc.SLSR != 0:
      resNP = 0
      resNP +=((43200*logy**3*r**11*(3+4*r**2+4*r**4+3*r**6)*(-1+y)**6+720*logy**2*r**7*(
          -1+y)**4*(71*r**12*(-1+y)**2+22*r**14*(-1+y)**2+r**10*(627-714*y-183*y**2
          +380*y**3-60*y**4)-2*(-1+y)**4*(11+22*y+33*y**2-46*y**3+10*y**4)
          +10*r**8*(13+46*y-95*y**2+40*y**3-y**4+2*y**5)+r**4*(-1+y)**2*(-627
          +540*y+270*y**2-320*y**3+95*y**4+12*y**5)-r**2*(-1+y)**3*(-71-71*y
          -71*y**2+189*y**3-136*y**4+20*y**5)+10*r**6*(-13+98*y-121*y**2-6*y**3
          +75*y**4-42*y**5+9*y**6))+12*logy*r**3*(-1+y)**3*(-1+r**2+y)**2*(7*r**18*(
          -1+y)**3+r**16*(-296+902*y-930*y**2+378*y**3-54*y**4)+r**14*(-5915
          +15711*y-12984*y**2+2576*y**3+691*y**4-79*y**5)+(-1+y)**5*(7+28*y
          +70*y**2+120*y**3-5*y**4-212*y**5+92*y**6)+r**12*(-6509+18163*y-17985*y**2
          +4515*y**3+2610*y**4-946*y**5+152*y**6)+2*r**2*(-1+y)**4*(-148-451*y
          -916*y**2+260*y**3+30*y**4+413*y**5-234*y**6+46*y**7)-r**6*(-1+y)**2*(6509
          +5145*y+6331*y**2-36325*y**3+24015*y**4-2669*y**5-1095*y**6+89*y**7)
          +r**4*(-1+y)**3*(5915+9796*y+12984*y**2-25840*y**3+9875*y**4+920*y**5
          -906*y**6+156*y**7)+r**10*(-62873+113873*y-33585*y**2-49785*y**3+33325*y**4
          -1717*y**5-1203*y**6+165*y**7)-r**8*(62873-137619*y+69204*y**2+59092*y**3
          -78525*y**4+25977*y**5+594*y**6-1754*y**7+158*y**8))-r*(-1+y)**2*(
          -1+r**2+y)**3*(r**20*(-1+y)**4+r**18*(-1+y)**2*(-488+889*y-356*y**2
          +5*y**3)+3*r**16*(-2157+7903*y-10562*y**2+6308*y**3-1637*y**4+105*y**5)
          -(-1+y)**8*(-1-7*y-28*y**2+12*y**3+77*y**4+23*y**5+4*y**6)-2*r**14*(30632
          -95657*y+98760*y**2-24035*y**3-19975*y**4+10938*y**5-993*y**6+30*y**7)
          -r**2*(-1+y)**5*(-488-1865*y-4487*y**2-3675*y**3+885*y**4+7413*y**5
          -3505*y**6+287*y**7+35*y**8)-3*r**4*(-1+y)**4*(2157+5746*y+10562*y**2
          -7610*y**3+2650*y**4-1242*y**5+1034*y**6-342*y**7+45*y**8)-2*r**12*(
          -25939+77785*y-59421*y**2-7885*y**3+22140*y**4-8381*y**5+2055*y**6
          +141*y**7+105*y**8)-2*r**6*(-1+y)**3*(-30632-34393*y-33735*y**2+161245*y**3
          -76500*y**4-8743*y**5+11613*y**6-1905*y**7+150*y**8)-2*r**8*(-1+y)**2*(
          -25939+32*y+18332*y**2+2980*y**3+8365*y**4-3866*y**5+3348*y**6-762*y**7
          +210*y**8)-6*r**10*(95352-238380*y+152376*y**2+88800*y**3-151233*y**4
          +52083*y**5+4570*y**6-4006*y**7+375*y**8+63*y**9)))/(-1036800*logy**3*r**12*(
          -1+y)**6+600*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -259200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-518400*logy**4*r**15*(-3+4*r**2
          +12*r**4+15*r**6)*(-1+y)**8-8640*logy**3*r**11*(-1+y)**6*(303*r**14*(-1
          +y)**2+r**12*(557-1114*y+557*y**2+30*y**3)-5*r**10*(-575+430*y+505*y**2
          -494*y**3+60*y**4)+5*(-1+y)**3*(-55-55*y-55*y**2+191*y**3-112*y**4
          +20*y**5)+5*r**8*(-307+1190*y-1171*y**2+418*y**3-138*y**4+78*y**5)
          +r**2*(-1+y)**2*(-127-1150*y**3+1235*y**4-468*y**5+60*y**6)+5*r**6*(
          -431+1054*y-719*y**2+24*y**3+261*y**4-216*y**5+69*y**6)-r**4*(193
          +334*y-887*y**2+90*y**3+65*y**4+422*y**5-229*y**6+12*y**7))-144*logy**2*r**7*(
          -1+y)**4*(-1+r**2+y)**2*(421*r**18*(-1+y)**4-r**16*(-1+y)**2*(-8359
          +17560*y-10043*y**2+1942*y**3)-r**14*(-1+y)**2*(-97092+157204*y-51665*y**2
          -8304*y**3+257*y**4)-(-1+y)**5*(-833-2499*y-4998*y**2-310*y**3+2875*y**4
          +6693*y**5-6656*y**6+1528*y**7)+r**12*(90740-365364*y+577249*y**2
          -390800*y**3+34450*y**4+85820*y**5-37231*y**6+5636*y**7)+r**10*(330718
          -834456*y+612923*y**2+76590*y**3-295775*y**4+135422*y**5-35089*y**6
          +12372*y**7-1205*y**8)+r**4*(-1+y)**3*(71732+35808*y+27133*y**2-280753*y**3
          +233150*y**4-65902*y**5+8477*y**6-4393*y**7+1448*y**8)-r**2*(-1+y)**4*(5955
          +13576*y+22863*y**2-17954*y**3-3525*y**4-21670*y**5+30919*y**6-12508*y**7
          +1544*y**8)+r**6*(-1+y)**2*(31676-80900*y-42833*y**2+450852*y**3-487085*y**4
          +156424*y**5+21985*y**6-22172*y**7+4153*y**8)+r**8*(124314-274276*y
          +43999*y**2+557844*y**3-902951*y**4+566186*y**5-48799*y**6-104024*y**7
          +41281*y**8-3574*y**9))+12*logy*r**3*(-1+y)**3*(-1+r**2+y)**3*(7*r**24*(
          -1+y)**5+r**22*(-1+y)**3*(-638+1255*y-596*y**2+117*y**3)+r**20*(41204
          -197809*y+375995*y**2-355352*y**3+169948*y**4-35831*y**5+2077*y**6
          -232*y**7)+r**18*(266802-1248795*y+2320737*y**2-2166320*y**3+1038942*y**4
          -209565*y**5-9373*y**6+8280*y**7-708*y**8)-3*(-1+y)**7*(-7-35*y
          -105*y**2-211*y**3-157*y**4+167*y**5+245*y**6+115*y**7-304*y**8+92*y**9)
          +r**16*(1649289-6631428*y+9935031*y**2-6068242*y**3+135207*y**4+1487256*y**5
          -557277*y**6+59584*y**7-10458*y**8+1038*y**9)+r**6*(-1+y)**4*(-93074
          -191473*y-326709*y**2+577618*y**3-54374*y**4+583036*y**5-945652*y**6
          +443414*y**7-54328*y**8-5971*y**9+313*y**10)-r**8*(-1+y)**3*(-1309037
          +127984*y+230971*y**2+4783034*y**3-6140644*y**4+2022854*y**5+573716*y**6
          -495686*y**7+90621*y**8-1146*y**9+333*y**10)-r**2*(-1+y)**6*(1630+6583*y
          +16615*y**2+13053*y**3+909*y**4-23115*y**5+3937*y**6-2025*y**7+6857*y**8
          -3304*y**9+460*y**10)-r**4*(-1+y)**5*(-54428-148245*y-276534*y**2
          +71552*y**3+161266*y**4+317382*y**5-422970*y**6+133144*y**7+218*y**8
          -5401*y**9+816*y**10)+2*r**14*(-143350+139205*y+1127837*y**2-2245586*y**3
          +632752*y**4+1501882*y**5-1387310*y**6+398858*y**7-7974*y**8-15447*y**9
          +933*y**10)-2*r**10*(-1+y)**2*(-873366+1625157*y+179697*y**2-3995173*y**3
          +4164601*y**4-786855*y**5-774507*y**6+330283*y**7+3383*y**8-13536*y**9
          +1716*y**10)-2*r**12*(-1439316+3375459*y-1031061*y**2-3340418*y**3
          +2857764*y**4+755592*y**5-1973258*y**6+968046*y**7-192972*y**8+22321*y**9
          -3141*y**10+984*y**11))-r*(-1+y)**2*(-1+r**2+y)**4*(3*r**26*(-1+y)**6
          +r**24*(-1+y)**4*(-383+670*y-233*y**2+14*y**3)+2*r**22*(-1+y)**2*(18151
          -68058*y+92798*y**2-57364*y**3+16997*y**4-2124*y**5+10*y**6)+(-1
          +y)**10*(1+8*y+36*y**2+22*y**3-68*y**4-140*y**5-92*y**6+50*y**7
          +19*y**8+4*y**9)+2*r**20*(293461-1581600*y+3465875*y**2-3918644*y**3
          +2354738*y**4-643781*y**5+5465*y**6+24790*y**7-951*y**8+47*y**9)+r**18*(1227213
          -6151010*y+12628771*y**2-13582384*y**3+7823874*y**4-1756328*y**5-539390*y**6
          +456244*y**7-119051*y**8+14886*y**9+775*y**10)+r**2*(-1+y)**7*(1597
          +7729*y+22545*y**2+35921*y**3+20674*y**4-35858*y**5-29894*y**6-11870*y**7
          +39569*y**8-13959*y**9+661*y**10+85*y**11)+2*r**4*(-1+y)**6*(-24275
          -90386*y-213624*y**2-100138*y**3+21373*y**4+245107*y**5-124271*y**6
          +33439*y**7-37702*y**8+21687*y**9-4517*y**10+307*y**11)+2*r**6*(-1
          +y)**5*(318561+719501*y+1162698*y**2-1119772*y**3-994436*y**4-1411174*y**5
          +2889940*y**6-1153918*y**7-10753*y**8+85061*y**9-15282*y**10+1174*y**11)
          +4*r**12*(-1+y)**2*(8162815-13671650*y+576456*y**2+10153426*y**3-2301285*y**4
          -5517227*y**5+3240765*y**6+74209*y**7-424376*y**8+123675*y**9-13203*y**10
          +2295*y**11)+r**16*(10942159-49558070*y+85612431*y**2-61013654*y**3
          -3208512*y**4+33347098*y**5-20646876*y**6+4824454*y**7-325871*y**8+27612*y**9
          -6147*y**10+2976*y**11)+r**8*(-1+y)**4*(874927+790618*y+9369*y**2
          -765350*y**3-2072958*y**4+4727512*y**5-3492258*y**6+1065616*y**7-91625*y**8
          +49638*y**9-25839*y**10+5550*y**11)+r**10*(-1+y)**3*(12993683-5255233*y
          -4892007*y**2-37712275*y**3+58851726*y**4-18161794*y**5-10672230*y**6
          +7244402*y**7-1001185*y**8+8019*y**9-16179*y**10+8673*y**11)+4*r**14*(
          -4530563+19404840*y-28996867*y**2+13603930*y**3+7129940*y**4-8005778*y**5
          +264788*y**6+1140190*y**7+379035*y**8-535990*y**9+161451*y**10-16608*y**11
          +1632*y**12))))/(9331200*logy**4*r**16*(-1+y)**8+3110400*logy**3*r**12*(-1
          +y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +388800*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+450*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*muWC*(1036800*logy**4*r**15*(
          -9-4*r**2+4*r**4+9*r**6)*(-1+y)**8+17280*logy**3*r**11*(-1+y)**5*(289*r**14*(
          -1+y)**3+5*r**12*(-43+129*y-129*y**2-29*y**3+36*y**4)+r**10*(-1341
          +1863*y+1377*y**2-4199*y**3+2260*y**4-300*y**5)-5*r**2*(-1+y)**3*(
          -43+156*y**3-61*y**4+4*y**6)+5*r**8*(369-1299*y+1587*y**2-913*y**3
          +202*y**4-30*y**5+16*y**6)+(-1+y)**3*(289-720*y**3+765*y**4-264*y**5
          +20*y**6)+5*r**6*(369-915*y+627*y**2+127*y**3-639*y**4+669*y**5-337*y**6
          +63*y**7)+r**4*(-1341+6183*y-9423*y**2+5981*y**3-1885*y**4+1011*y**5
          -593*y**6+43*y**7+24*y**8))-288*logy**2*r**7*(-1+y)**3*(-1+r**2+y)**2*(
          -627*r**18*(-1+y)**5+r**16*(-1+y)**2*(7157-22725*y+25233*y**2-9639*y**3
          +1214*y**4)+r**14*(-1+y)**2*(84412-216784*y+171771*y**2-21569*y**3
          -16309*y**4+1919*y**5)+r**12*(29532-189312*y+496143*y**2-530203*y**3
          +138710*y**4+140058*y**5-109853*y**6+30777*y**7-3852*y**8)-(-1+y)**5*(
          -627-1254*y-1881*y**2+3972*y**3-365*y**4+242*y**5-951*y**6+256*y**7
          +8*y**8)+r**10*(103202-284626*y+219221*y**2+300583*y**3-761945*y**4
          +575833*y**5-133419*y**6-35221*y**7+21137*y**8-2765*y**9)+r**2*(-1
          +y)**4*(-7157-8411*y-9665*y**2+22901*y**3-1773*y**4+4577*y**5-16609*y**6
          +10105*y**7-1576*y**8+8*y**9)+r**6*(-1+y)**2*(-29532-12120*y+7437*y**2
          +341629*y**3-507409*y**4+245247*y**5-38965*y**6+7803*y**7-3539*y**8
          +249*y**9)-r**4*(-1+y)**3*(-84412+36452*y+8561*y**2+167410*y**3-222901*y**4
          +112952*y**5-56537*y**6+31554*y**7-10395*y**8+1216*y**9)+r**8*(-103202
          +540990*y-1116495*y**2+1499655*y**3-1632985*y**4+1198139*y**5-352315*y**6
          -135955*y**7+133795*y**8-34265*y**9+2638*y**10))+24*logy*r**3*(-1+y)**2*(
          -1+r**2+y)**3*(7*r**24*(-1+y)**6-r**22*(-1+y)**3*(1134-3423*y+3465*y**2
          -1141*y**3+129*y**4)+r**20*(47816-275271*y+655056*y**2-820249*y**3
          +565086*y**4-199221*y**5+25400*y**6+1477*y**7-94*y**8)+r**18*(179938
          -1039683*y+2514552*y**2-3174711*y**3+2129372*y**4-649047*y**5+8044*y**6
          +37819*y**7-6818*y**8+534*y**9)-(-1+y)**7*(-7-28*y-70*y**2-172*y**3
          +554*y**4+1340*y**5-1882*y**6+20*y**7+777*y**8-424*y**9+92*y**10)
          +r**16*(1479163-7348959*y+14456961*y**2-13329861*y**3+4013953*y**4
          +2619231*y**5-2536881*y**6+692089*y**7-43944*y**8-1908*y**9+156*y**10)
          +r**4*(-1+y)**5*(47816+84007*y+116139*y**2-243946*y**3+44472*y**4
          -20048*y**5+66932*y**6-34794*y**7+12436*y**8-7687*y**9+1237*y**10+36*y**11)
          +2*r**12*y*(1662147-6648588*y+11954695*y**2-11886770*y**3+5136873*y**4
          +2122280*y**5-3938126*y**6+1992595*y**7-409330*y**8+8662*y**9+5493*y**10
          +69*y**11)+r**2*(-1+y)**6*(-1134-3423*y-6888*y**2+6006*y**3+66*y**4
          +2844*y**5+6876*y**6-6482*y**7-1336*y**8+2499*y**9-920*y**10+92*y**11)
          -r**6*(-1+y)**4*(179938+139993*y+155200*y**2-415367*y**3-212296*y**4
          -69772*y**5+861598*y**6-660760*y**7+169362*y**8-1829*y**9-3586*y**10
          +119*y**11)-2*r**14*(508358-1948797*y+1903188*y**2+296223*y**3-458736*y**4
          -1580193*y**5+2000031*y**6-858523*y**7+116332*y**8+26806*y**9-10605*y**10
          +516*y**11)+2*r**10*(-1+y)**2*(508358-1609709*y+885924*y**2+3467994*y**3
          -5928658*y**4+2931421*y**5+207351*y**6-569809*y**7+105466*y**8+19488*y**9
          -7929*y**10+903*y**11)+r**8*(-1+y)**3*(1479163-1526019*y-100389*y**2
          -2256693*y**3+4770486*y**4-3671352*y**5+1837320*y**6-708896*y**7+103883*y**8
          +27299*y**9-9711*y**10+909*y**11))+2*r*(-1+y)*(-1+r**2+y)**4*(r**26*(
          -1+y)**7+r**24*(-1+y)**4*(-607+1741*y-1623*y**2+397*y**3+4*y**4)
          +2*r**22*(-1+y)**2*(-21213+100435*y-187240*y**2+169300*y**3-74827*y**4
          +15041*y**5-1060*y**6+4*y**7)-(-1+y)**10*(-1-7*y-28*y**2-256*y**3
          -272*y**4+748*y**5+484*y**6-160*y**7+113*y**8+19*y**9)+2*r**20*(-306011
          +1934403*y-5140021*y**2+7342779*y**3-5918146*y**4+2467104*y**5-269235*y**6
          -157911*y**7+49189*y**8-2431*y**9+40*y**10)+r**18*(-176143+1106485*y
          -3429335*y**2+5331245*y**3-3172206*y**4-1324650*y**5+2792790*y**6-1350390*y**7
          +246665*y**8-28159*y**9+5573*y**10+525*y**11)+r**2*(-1+y)**7*(-607
          -2348*y-5712*y**2-828*y**3+19929*y**4+38708*y**5-50984*y**6+2644*y**7
          +15383*y**8-9304*y**9+1664*y**10-168*y**11+23*y**12)+2*r**4*(-1+y)**6*(21213
          +58009*y+108018*y**2-86216*y**3+41355*y**4-14581*y**5-169733*y**6
          +121375*y**7+21236*y**8-47960*y**9+15023*y**10-1851*y**11+112*y**12)
          +2*r**6*(-1+y)**5*(-306011-404348*y-462519*y**2+1506852*y**3-295842*y**4
          +6792*y**5-982382*y**6+831936*y**7-276347*y**8+21172*y**9+11749*y**10
          -4340*y**11+488*y**12)+4*r**12*(-1+y)**2*(-6346689+17071783*y-10978878*y**2
          -10263152*y**3+14988257*y**4-94405*y**5-8153331*y**6+4236809*y**7-269898*y**8
          -358772*y**9+98019*y**10-10107*y**11+1164*y**12)+r**16*(-11967921+66603547*y
          -149453787*y**2+163672189*y**3-69211024*y**4-32018008*y**5+52388880*y**6
          -24035080*y**7+3854121*y**8+282109*y**9-127461*y**10+5883*y**11+1752*y**12)
          +r**8*(-1+y)**4*(176143+49627*y+539055*y**2+2406075*y**3-7161634*y**4
          -140806*y**5+8888730*y**6-6641230*y**7+1252215*y**8+200259*y**9-64257*y**10
          -8277*y**11+2500*y**12)+r**10*(-1+y)**3*(-11967921+17171900*y-1158846*y**2
          +17932700*y**3-54254627*y**4+45517864*y**5-13589364*y**6-1282184*y**7
          +1713465*y**8-509908*y**9+83682*y**10-19716*y**11+4155*y**12)+4*r**14*(6346689
          -33701729*y+69183689*y**2-67740245*y**3+26935954*y**4+6087624*y**5
          -11723480*y**6+6678956*y**7-2864807*y**8+1051471*y**9-308593*y**10+60849*y**11
          -7260*y**12+882*y**13))))/(13996800*logy**4*r**16*(-1+y)**8+4665600*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +583200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+32400*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+675*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((muG*(518400*logy**4*r**13*(-3+12*r**2
          +19*r**4+31*r**6+9*r**8)*(-1+y)**8-8640*logy**3*r**9*(-1+y)**5*(485*r**16*(
          -1+y)**3+15*r**14*(86-258*y+258*y**2-143*y**3+27*y**4)+r**12*(4484
          -11292*y+8052*y**2-2259*y**3+285*y**4-120*y**5)+15*(-1+y)**4*(-3
          -3*y-3*y**2+19*y**3-16*y**4+4*y**5)+5*r**10*(454+126*y-2358*y**2
          +2293*y**3-741*y**4+33*y**5+23*y**6)+r**2*(-1+y)**3*(214-1275*y**3
          +2700*y**4-1494*y**5+260*y**6)+5*r**4*(-1+y)**2*(156-300*y+72*y**2
          +231*y**3-327*y**4+408*y**5-166*y**6+16*y**7)-5*r**8*(838-3426*y
          +4794*y**2-2568*y**3+429*y**4+138*y**5-142*y**6+27*y**7)-5*r**6*(778
          -2910*y+3774*y**2-1747*y**3-633*y**4+1236*y**5-486*y**6-54*y**7+42*y**8))
          -144*logy**2*r**5*(-1+y)**3*(-1+r**2+y)**2*(1249*r**20*(-1+y)**5-2*r**18*(
          -1+y)**2*(6382-20395*y+22893*y**2-8564*y**3+1234*y**4)-r**16*(-1
          +y)**2*(92303-217635*y+146484*y**2+20843*y**3-36668*y**4+3273*y**5)
          +3*(-1+y)**6*(-43-129*y-258*y**2+150*y**3+25*y**4+143*y**5-96*y**6
          +8*y**7)-2*r**2*(-1+y)**5*(1303+2477*y+3522*y**2-5807*y**3+3335*y**4
          +2892*y**5-1422*y**6-1782*y**7+732*y**8)+2*r**14*(149999-614879*y
          +903217*y**2-619497*y**3+235915*y**4-92294*y**5+55894*y**6-24597*y**7
          +3742*y**8)+2*r**6*(-1+y)**3*(-32009+4566*y-4536*y**2+173250*y**3
          -370476*y**4+293679*y**5-101586*y**6+21126*y**7-3475*y**8+386*y**9)
          -r**4*(-1+y)**4*(-20317-17171*y-17688*y**2+137207*y**3-155696*y**4
          +44472*y**5-4359*y**6+10598*y**7-8382*y**8+1536*y**9)+r**8*(-1+y)**2*(
          -135296+347980*y-134544*y**2-457533*y**3+793008*y**4-799209*y**5+422040*y**6
          -75061*y**7-2522*y**8+1537*y**9)+r**12*(726484-3010164*y+4547436*y**2
          -3143621*y**3+865150*y**4+242926*y**5-384271*y**6+193184*y**7-46179*y**8
          +4055*y**9)-2*r**10*(-298559+1227841*y-1910816*y**2+1490522*y**3-641985*y**4
          +83106*y**5+118859*y**6-111634*y**7+59578*y**8-18790*y**9+1878*y**10))
          -12*logy*r*(-1+y)**2*(-1+r**2+y)**3*(7*r**26*(-1+y)**6-r**24*(-1+y)**3*(2339
          -7038*y+7080*y**2-2223*y**3+252*y**4)+r**22*(96636-556878*y+1326942*y**2
          -1664436*y**3+1150689*y**4-410712*y**5+56382*y**6+1402*y**7-25*y**8)
          -3*(-1+y)**8*(-7-35*y-105*y**2-211*y**3-157*y**4+167*y**5+245*y**6
          +115*y**7-304*y**8+92*y**9)+r**20*(156980-902514*y+2210850*y**2-2734110*y**3
          +1588443*y**4-183777*y**5-214478*y**6+92878*y**7-15427*y**8+1155*y**9)
          +r**18*(1248395-5706672*y+9856275*y**2-6174445*y**3-3104052*y**4+7317540*y**5
          -4426048*y**6+1052485*y**7-65245*y**8+2052*y**9-285*y**10)-r**2*(-1
          +y)**7*(73+355*y+1045*y**2-2038*y**3+215*y**4+1877*y**5-3725*y**6
          -640*y**7+5548*y**8-3270*y**9+460*y**10)-r**8*(-1+y)**4*(385015+236893*y
          +280717*y**2-2739560*y**3+3351148*y**4-1939403*y**5+1048627*y**6-754087*y**7
          +292435*y**8-40858*y**9-4762*y**10+335*y**11)+r**4*(-1+y)**6*(1412
          +1422*y-1110*y**2-27860*y**3-9237*y**4-24876*y**5+20890*y**6-4520*y**7
          -4705*y**8+11162*y**9-4046*y**10+368*y**11)+r**6*(-1+y)**5*(134484
          +205002*y+249876*y**2-757788*y**3+604809*y**4+258780*y**5-276504*y**6
          -154906*y**7+164393*y**8-24694*y**9-1614*y**10+462*y**11)+r**10*(-1
          +y)**3*(478171-529509*y+243993*y**2-3394681*y**3+10825014*y**4-13330869*y**5
          +7049249*y**6-1178633*y**7-267259*y**8+166006*y**9-24012*y**10+1530*y**11)
          -r**16*(6115393-27530919*y+45339879*y**2-32740357*y**3+7303131*y**4
          +2602566*y**5-764422*y**6-540824*y**7+73802*y**8+164629*y**9-52359*y**10
          +2481*y**11)+r**12*(-1+y)**2*(1447496-5599604*y+4461276*y**2+6862760*y**3
          -13072196*y**4+9060897*y**5-3291961*y**6+25079*y**7+297910*y**8+70651*y**9
          -42333*y**10+4425*y**11)+r**14*(-7590696+37293300*y-70794804*y**2+66672896*y**3
          -27063252*y**4-11957427*y**5+26871210*y**6-19056052*y**7+6433039*y**8
          -733163*y**9-94392*y**10+18150*y**11+1191*y**12))-r*(-1+y)*(-1+r**2
          +y)**4*(17*r**26*(-1+y)**7+r**24*(-1+y)**4*(-339+1001*y-1011*y**2+44*y**3
          +85*y**4)+2*r**22*(-1+y)**2*(-51379+243531*y-453925*y**2+410388*y**3
          -182733*y**4+38528*y**5-3364*y**6+54*y**7)+r**20*(-1003330+6247982*y
          -16307168*y**2+22676926*y**3-17347118*y**4+6228969*y**5+139647*y**6
          -830528*y**7+201218*y**8-7773*y**9-25*y**10)+r**18*(1651093-10203419*y
          +25289039*y**2-34512099*y**3+30725334*y**4-19969858*y**5+9370384*y**6
          -2777994*y**7+550039*y**8-140429*y**9+23375*y**10+535*y**11)+(-1+y)**8*(
          -1079-5143*y-14799*y**2-24740*y**3-14317*y**4+23979*y**5+28511*y**6
          +8399*y**7-40250*y**8+15912*y**9-460*y**10-23*y**11+10*y**12)+r**2*(
          -1+y)**7*(-9987-36760*y-84374*y**2-173110*y**3+14941*y**4+196812*y**5
          -81342*y**6-36114*y**7+47005*y**8-15216*y**9+5740*y**10+92*y**11+113*y**12)
          +r**4*(-1+y)**6*(-33650-47246*y-19966*y**2-226804*y**3+783038*y**4
          +1112367*y**5-1073133*y**6+65151*y**7+296009*y**8-227713*y**9+100403*y**10
          -10331*y**11+675*y**12)+2*r**6*(-1+y)**5*(-1010773-1174194*y-1136302*y**2
          +4911295*y**3-3407364*y**4-321795*y**5+667136*y**6+1374341*y**7-1216125*y**8
          +217669*y**9+74598*y**10-15372*y**11+1286*y**12)+r**16*(-13502689+74287943*y
          -163422737*y**2+169816460*y**3-52854883*y**4-62903869*y**5+75374095*y**6
          -30668477*y**7+2886080*y**8+1293318*y**9-338382*y**10+17577*y**11+3564*y**12)
          +2*r**12*(-1+y)**2*(-11257382+33781774*y-26101282*y**2-20654588*y**3
          +29218726*y**4+12766279*y**5-29656681*y**6+11098859*y**7+1371403*y**8
          -1773951*y**9+419733*y**10-48213*y**11+6123*y**12)+r**8*(-1+y)**4*(
          -1941653-170353*y+1855087*y**2-5073552*y**3+11068697*y**4-19849948*y**5
          +18627748*y**6-8042942*y**7+436907*y**8+883513*y**9-54879*y**10-33510*y**11
          +6485*y**12)+r**10*(-1+y)**3*(-9853049+11733364*y+1004894*y**2+16901344*y**3
          -76005635*y**4+100054900*y**5-54242188*y**6+3193616*y**7+6656581*y**8
          -1545720*y**9+175854*y**10-51096*y**11+10935*y**12)+4*r**14*(15203951
          -79636509*y+161933876*y**2-155119763*y**3+50616627*y**4+36060342*y**5
          -46277299*y**6+22170207*y**7-5914457*y**8+1353043*y**9-511023*y**10
          +137178*y**11-18363*y**12+2190*y**13))))/(37324800*logy**4*r**16*(-1+y)**8
          +12441600*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+1555200*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+86400*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +1800*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((mupi*(-518400*logy**4*r**15*(3+4*r**2+4*r**4+9*r**6)*(-1+y)**8-8640*logy**3*r**11*(
          -1+y)**4*(25*r**14*(-1+y)**4-3*r**12*(-193+772*y-1158*y**2+757*y**3
          -313*y**4+45*y**5)+r**10*(1517-3908*y+1542*y**2+4367*y**3-4223*y**4
          +1275*y**5-60*y**6)-r**2*(-1+y)**4*(9-1045*y**3+1755*y**4-714*y**5
          +80*y**6)-(-1+y)**4*(67-915*y**3+1335*y**4-582*y**5+80*y**6)-5*r**8*(221
          -1076*y+1998*y**2-1811*y**3+527*y**4+114*y**5-86*y**6+11*y**7)+5*r**6*(
          -25+292*y-822*y**2+636*y**3+786*y**4-1599*y**5+1066*y**6-307*y**7
          +27*y**8)+5*r**4*(-163+796*y-1482*y**2+861*y**3+594*y**4-747*y**5
          -212*y**6+596*y**7-285*y**8+42*y**9))+144*logy**2*r**7*(-1+y)**2*(-1
          +r**2+y)**2*(349*r**18*(-1+y)**6+r**16*(-1+y)**2*(-1993+7274*y-9166*y**2
          +3714*y**3-2161*y**4+472*y**5)-r**14*(-1+y)**2*(24220-95668*y+141675*y**2
          -94935*y**3+37540*y**4-9085*y**5+1413*y**6)+r**12*(-77212+401780*y
          -840723*y**2+834174*y**3-427119*y**4+146922*y**5-42425*y**6+3088*y**7
          -2309*y**8+824*y**9)-(-1+y)**5*(319+319*y+319*y**2-3031*y**3+2159*y**4
          -1549*y**5-4949*y**6+12001*y**7-7724*y**8+1536*y**9)+r**4*(-1+y)**3*(14500
          -19432*y+5073*y**2-294607*y**3+803463*y**4-799227*y**5+336287*y**6
          -43483*y**7-2793*y**8-1453*y**9+772*y**10)+r**10*(-217714+1017436*y
          -1820559*y**2+1199811*y**3+213456*y**4-555276*y**5+163554*y**6-24811*y**7
          +33984*y**8-14296*y**9+1415*y**10)-r**2*(-1+y)**4*(3883-638*y-638*y**2
          -40533*y**3+66542*y**4-34084*y**5+26298*y**6-48827*y**7+39243*y**8
          -13382*y**9+1536*y**10)+r**6*(-1+y)**2*(-1252-7884*y+10651*y**2+280741*y**3
          -1190414*y**4+1669285*y**5-1058606*y**6+278099*y**7+1724*y**8-12381*y**9
          +1537*y**10)+r**8*(-91894+515064*y-1140015*y**2+958830*y**3-70260*y**4
          +92748*y**5-833008*y**6+879380*y**7-356890*y**8+37450*y**9+10311*y**10
          -1716*y**11))+12*logy*r**3*(-1+y)*(-1+r**2+y)**3*(r**24*(-1+y)**7-r**22*(
          -1+y)**3*(-1094+4379*y-6576*y**2+4675*y**3-1258*y**4+120*y**5)+r**20*(
          -10908+71265*y-197625*y**2+298431*y**3-252828*y**4+100698*y**5+3701*y**6
          -16883*y**7+4372*y**8-223*y**9)+(-1+y)**8*(-91-364*y-910*y**2-1171*y**3
          -346*y**4+1568*y**5-106*y**6+1025*y**7-579*y**8-694*y**9+368*y**10)
          +r**18*(161206-1052977*y+2895351*y**2-4300267*y**3+3811624*y**4-2181513*y**5
          +866264*y**6-226679*y**7+28864*y**8-2332*y**9+459*y**10)+r**16*(238999
          -1499866*y+3999624*y**2-5798573*y**3+5002436*y**4-2768661*y**5+1135161*y**6
          -363744*y**7+44473*y**8+17519*y**9-8013*y**10+645*y**11)+r**14*(781564
          -4161730*y+8759046*y**2-7423408*y**3+918454*y**4+1433865*y**5-35862*y**6
          -79134*y**7-270487*y**8+120371*y**9-34774*y**10+8412*y**11-717*y**12)
          -r**6*(-1+y)**4*(-131146+97155*y+34395*y**2+1535148*y**3-3112476*y**4
          +2096133*y**5-799698*y**6+1002060*y**7-1051343*y**8+452326*y**9-69087*y**10
          -1002*y**11+335*y**12)+r**2*(-1+y)**6*(-314-901*y-1761*y**2+9230*y**3
          -5213*y**4+6195*y**5+26452*y**6-38002*y**7+7585*y**8-112*y**9+5079*y**10
          -2606*y**11+368*y**12)+r**8*(-1+y)**3*(-142789+194506*y-101634*y**2
          +4957474*y**3-15970501*y**4+18304377*y**5-9134256*y**6+1060770*y**7
          +910126*y**8-444509*y**9+91432*y**10-8010*y**11+414*y**12)+r**4*(-1
          +y)**5*(3468-2973*y-5040*y**2-4193*y**3+19999*y**4-26063*y**5-316456*y**6
          +702848*y**7-512567*y**8+138846*y**9-870*y**10-4061*y**11+462*y**12)
          +r**10*(-1+y)**2*(-524156+1394914*y-982190*y**2-446468*y**3+7676296*y**4
          -15939119*y**5+13103202*y**6-4400982*y**7-43487*y**8+310999*y**9-1250*y**10
          -13656*y**11+1497*y**12)+r**12*(2540328-13592634*y+28990290*y**2-25242890*y**3
          -1253362*y**4+16658793*y**5-9138897*y**6+676116*y**7+241247*y**8+147772*y**9
          +1539*y**10-35634*y**11+7479*y**12-147*y**13))-r*(-1+r**2+y)**4*(13*r**26*(
          -1+y)**8+r**24*(-1+y)**4*(-945+3716*y-5420*y**2+3595*y**3-891*y**4
          +77*y**5)+2*r**22*(-1+y)**2*(-11863+66472*y-152905*y**2+187449*y**3
          -124705*y**4+38111*y**5-2727*y**6-558*y**7+66*y**8)+r**20*(55190-486924*y
          +1829696*y**2-3946658*y**3+5626702*y**4-5713879*y**5+4137062*y**6-1986863*y**7
          +555556*y**8-72209*y**9+3202*y**10-155*y**11)+r**18*(1495075-10292292*y
          +29970316*y**2-46705370*y**3+41208755*y**4-19937448*y**5+4204156*y**6
          +577134*y**7-768875*y**8+269440*y**9-26192*y**10+2776*y**11-1075*y**12)
          -(-1+y)**9*(-17-85*y-255*y**2-744*y**3-549*y**4+567*y**5-405*y**6
          +435*y**7-136*y**8-286*y**9+200*y**10+65*y**11+10*y**12)+r**16*(-1437823
          +10058580*y-28950346*y**2+42111489*y**3-28136339*y**4-1891802*y**5
          +17510248*y**6-12452992*y**7+2852475*y**8+795054*y**9-551670*y**10+95127*y**11
          +7503*y**12-2304*y**13)-r**2*(-1+y)**7*(-4275-11801*y-22100*y**2+8142*y**3
          +29187*y**4+63219*y**5-38992*y**6+14334*y**7-57835*y**8+153*y**9+39816*y**10
          -14952*y**11+991*y**12+113*y**13)-r**4*(-1+y)**6*(-30694-49080*y-56926*y**2
          -7906*y**3+212614*y**4-8655*y**5-978686*y**6+1228086*y**7-492632*y**8
          +67336*y**9-32476*y**10+27996*y**11-5520*y**12+543*y**13)-2*r**6*(-1
          +y)**5*(-87695-11653*y+20161*y**2-254708*y**3+497937*y**4-362071*y**5
          +1093127*y**6-3266915*y**7+3169002*y**8-1132242*y**9+46936*y**10+56091*y**11
          -8116*y**12+746*y**13)-2*r**12*(-1+y)**2*(-2246338+7092384*y-6419290*y**2
          -7404870*y**3+11838406*y**4+2981821*y**5-8395520*y**6+1864844*y**7-5808*y**8
          +819384*y**9-692958*y**10+206466*y**11-25524*y**12+1803*y**13)-r**8*(
          -1+y)**4*(-2044225+2123228*y+461668*y**2+14257259*y**3-35523705*y**4
          +26612747*y**5-8042956*y**6+2819158*y**7-3314019*y**8+1700390*y**9-340352*y**10
          +76623*y**11-11291*y**12+2675*y**13)-r**10*(-1+y)**3*(-3957373+8297577*y
          -2479474*y**2-19960482*y**3+72810721*y**4-106070525*y**5+69645160*y**6
          -13425004*y**7-10015863*y**8+6574059*y**9-1439742*y**10+196998*y**11
          -21117*y**12+3465*y**13)-4*r**14*(-1962419+12277838*y-31553462*y**2
          +37490399*y**3-14030425*y**4-11977611*y**5+14606814*y**6-5878378*y**7
          +1124672*y**8+10881*y**9-68730*y**10-81507*y**11+51690*y**12-10566*y**13
          +804*y**14))))/(37324800*logy**4*r**16*(-1+y)**8+12441600*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +1555200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+86400*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+1800*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*muWC**2*(518400*logy**4*r**15*(
          -21-4*r**2+20*r**4+45*r**6)*(-1+y)**8+8640*logy**3*r**11*(-1+y)**4*(917*r**14*(
          -1+y)**4+3*r**12*(601-2404*y+3606*y**2-2014*y**3+301*y**4+90*y**5)
          +r**10*(7057-17428*y+4542*y**2+25462*y**3-27823*y**4+10230*y**5-1020*y**6)
          -(-1+y)**4*(-733+330*y**3+375*y**4-372*y**5+100*y**6)-r**2*(-1+y)**4*(
          -627+250*y**3+2595*y**4-1428*y**5+220*y**6)+5*r**8*(-1549+7156*y
          -12654*y**2+11122*y**3-4399*y**4+468*y**5+34*y**6+26*y**7)+5*r**6*(
          -1157+4436*y-6270*y**2+2772*y**3+3870*y**4-7122*y**5+5150*y**6-1814*y**7
          +243*y**8)+r**4*(2393-14612*y+31998*y**2-37602*y**3+29538*y**4-16158*y**5
          +2692*y**6+4052*y**7-2793*y**8+492*y**9))+144*logy**2*r**7*(-1+y)**2*(
          -1+r**2+y)**2*(1183*r**18*(-1+y)**6-r**16*(-1+y)**2*(-25457+104194*y
          -162206*y**2+112044*y**3-36881*y**4+4586*y**5)-r**14*(-1+y)**2*(-301676
          +1094924*y-1449015*y**2+769890*y**3-90860*y**4-36514*y**5+2931*y**6)
          +(-1+y)**5*(2519+2519*y+2519*y**2-23621*y**3+17329*y**4-4919*y**5
          -6319*y**6+20381*y**7-14704*y**8+3096*y**9)+r**12*(243020-1460092*y
          +3737811*y**2-4747386*y**3+2860977*y**4-289800*y**5-664883*y**6+415714*y**7
          -99269*y**8+9908*y**9)+r**4*(-1+y)**3*(224236-323728*y+73527*y**2
          +112667*y**3-435993*y**4+590895*y**5-164107*y**6-177307*y**7+131433*y**8
          -31927*y**9+2104*y**10)+r**2*(-1+y)**4*(-13705-5038*y-5038*y**2+16632*y**3
          +59062*y**4-49118*y**5-10962*y**6-17512*y**7+43443*y**8-22012*y**9
          +3048*y**10)-r**6*(-1+y)**2*(86092-68004*y-37369*y**2-441094*y**3
          +166286*y**4+1080602*y**5-1264576*y**6+415894*y**7+37474*y**8-36126*y**9
          +3821*y**10)+r**10*(745034-3198356*y+5152659*y**2-2155536*y**3-3614496*y**4
          +5123886*y**5-2454864*y**6+344216*y**7+101106*y**8-43114*y**9+5465*y**10)
          -r**8*(125818-902448*y+2692425*y**2-5930790*y**3+9257400*y**4-8307876*y**5
          +2985346*y**6+1109680*y**7-1523030*y**8+579080*y**9-90087*y**10+4482*y**11))
          +12*logy*r**3*(-1+y)*(-1+r**2+y)**3*(19*r**24*(-1+y)**7-r**22*(-1+y)**3*(
          -1214+4913*y-7512*y**2+4468*y**3-1294*y**4+147*y**5)+r**20*(-121632
          +826731*y-2395731*y**2+3829053*y**3-3650349*y**4+2091525*y**5-681265*y**6
          +105535*y**7-4031*y**8+164*y**9)+r**18*(-862226+5764817*y-16453407*y**2
          +25668323*y**3-23535497*y**4+12698283*y**5-3703801*y**6+364033*y**7
          +76183*y**8-17392*y**9+684*y**10)-(-1+y)**8*(-203-812*y-2030*y**2
          -2858*y**3+970*y**4+7156*y**5-5858*y**6+2110*y**7+1173*y**8-2660*y**9
          +1012*y**10)+r**16*(-4915487+29484098*y-73417008*y**2+94957612*y**3
          -62036314*y**4+9721488*y**5+13198014*y**6-8959422*y**7+2119153*y**8
          -161146*y**9+9834*y**10-822*y**11)+r**6*(-1+y)**4*(277522+74475*y
          +114411*y**2+1358595*y**3-5615739*y**4+4619838*y**5+1194714*y**6-2562954*y**7
          +387680*y**8+391079*y**9-143445*y**10+9111*y**11+313*y**12)-r**2*(-1
          +y)**6*(-4030-8669*y-13917*y**2+57142*y**3-28246*y**4+20724*y**5+65000*y**6
          -116078*y**7+30608*y**8+11281*y**9-99*y**10-2176*y**11+460*y**12)-r**4*(
          -1+y)**5*(150384+102627*y+86316*y**2-1088641*y**3+905252*y**4-245686*y**5
          -371972*y**6+1100518*y**7-883444*y**8+217323*y**9+25032*y**10-11725*y**11
          +816*y**12)-2*r**14*(-743510+3209735*y-2796909*y**2-2602513*y**3+3183331*y**4
          +4798236*y**5-10776534*y**6+8496528*y**7-3195052*y**8+388949*y**9+77459*y**10
          -24951*y**11+831*y**12)+2*r**10*(-1+y)**2*(-1000918+4959287*y-6504709*y**2
          -7299742*y**3+20513660*y**4-10641118*y**5-4930992*y**6+6732462*y**7
          -1982338*y**8-53065*y**9+83501*y**10-12840*y**11+1212*y**12)+r**8*(
          -1+y)**3*(-4151911+8626534*y-4073622*y**2-3446036*y**3+10859465*y**4
          -11283240*y**5+1742496*y**6+5517108*y**7-4258589*y**8+1118770*y**9-71834*y**10
          -15840*y**11+1899*y**12)+2*r**12*(-2540328+8606193*y-4058085*y**2-30566959*y**3
          +72777757*y**4-67729722*y**5+18182676*y**6+17505102*y**7-18033410*y**8
          +7058003*y**9-1255515*y**10+45141*y**11+8793*y**12+354*y**13))+r*(
          -1+r**2+y)**4*(29*r**26*(-1+y)**8+r**24*(-1+y)**4*(-69+388*y-748*y**2
          +1130*y**3-603*y**4+166*y**5)+2*r**22*(-1+y)**2*(39913-232000*y+557215*y**2
          -694722*y**3+482971*y**4-193382*y**5+42849*y**6-4308*y**7+144*y**8)
          -2*r**20*(-973223+7208166*y-23052968*y**2+41395058*y**3-45409477*y**4
          +30869629*y**5-12346079*y**6+2320835*y**7+65744*y**8-82651*y**9+4211*y**10
          +35*y**11)+r**18*(3518579-24432468*y+73548092*y**2-119692480*y**3+107927863*y**4
          -45417564*y**5-3944008*y**6+13583808*y**7-6328915*y**8+1363352*y**9
          -153580*y**10+20696*y**11-575*y**12)-(-1+y)**9*(-37-185*y-555*y**2
          -2109*y**3-462*y**4+4242*y**5-4662*y**6-270*y**7+2479*y**8-1673*y**9
          +625*y**10+187*y**11+20*y**12)-2*r**6*(-1+y)**5*(-1093423-318317*y
          -134191*y**2+5398697*y**3-4412208*y**4+183760*y**5-781268*y**6-1090876*y**7
          +3013155*y**8-1371927*y**9+65603*y**10+63915*y**11-1748*y**12+28*y**13)
          -r**2*(-1+y)**7*(-10371-28825*y-54292*y**2+30936*y**3+120645*y**4
          +182775*y**5-347060*y**6+189552*y**7-77453*y**8-73755*y**9+112536*y**10
          -35400*y**11+2555*y**12+157*y**13)-2*r**4*(-1+y)**6*(32945+61308*y
          +93101*y**2-590608*y**3+595327*y**4-176463*y**5-1444142*y**6+2101410*y**7
          -793049*y**8-140252*y**9+156473*y**10-22626*y**11+369*y**12+207*y**13)
          +r**16*(33028117-215597244*y+590271310*y**2-855154950*y**3+642376961*y**4
          -115362652*y**5-218200168*y**6+204365896*y**7-77962653*y**8+12306144*y**9
          +125370*y**10-209778*y**11+27399*y**12+648*y**13)+4*r**12*(-1+y)**2*(21286405
          -77347800*y+90571273*y**2+5257692*y**3-87592633*y**4+42266165*y**5
          +32572298*y**6-39035264*y**7+13525929*y**8-552762*y**9-677415*y**10
          +117912*y**11-8289*y**12+1689*y**13)+r**8*(-1+y)**4*(3560021-3866908*y
          -2391620*y**2-34115578*y**3+99750537*y**4-74287978*y**5-11002696*y**6
          +40951564*y**7-17052297*y**8-244912*y**9+1474252*y**10-321186*y**11
          -9749*y**12+2150*y**13)+r**10*(-1+y)**3*(43818509-104014617*y+59951186*y**2
          -17353674*y**3+70940539*y**4-87176423*y**5+38031364*y**6-10071532*y**7
          +11044779*y**8-6477999*y**9+1098714*y**10-83802*y**11-29379*y**12+5535*y**13)
          +4*r**14*(-15115229+95589578*y-245549330*y**2+335791004*y**3-255967747*y**4
          +86500212*y**5+24219684*y**6-43450552*y**7+26381945*y**8-11770596*y**9
          +4217652*y**10-945312*y**11+100947*y**12-3294*y**13+1038*y**14))))/(55987200*logy**4*r**16*(
          -1+y)**8+18662400*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+2332800*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+129600*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +2700*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((rhoLS*(-518400*logy**4*r**13*(9+42*r**2+59*r**4+47*r**6+9*r**8)*(-1
          +y)**8+8640*logy**3*r**9*(-1+y)**4*(541*r**16*(-1+y)**4+3*(-1+y)**5*(
          -7-7*y-7*y**2+143*y**3-112*y**4+20*y**5)+3*r**14*(-464+1856*y-2784*y**2
          +2201*y**3-824*y**4+105*y**5)-5*r**12*(1064-3824*y+4872*y**2-2803*y**3
          +562*y**4+15*y**5+12*y**6)+5*r**2*(-1+y)**4*(160-363*y**3+564*y**4
          -294*y**5+44*y**6)+r**4*(-1+y)**3*(-3792+5952*y-1080*y**2-1045*y**3
          -395*y**4+1212*y**5-622*y**6+40*y**7)+r**10*(-8536+22864*y-11736*y**2
          -15011*y**3+18644*y**4-5730*y**5-80*y**6+95*y**7)-5*r**8*(-302+4040*y
          -11724*y**2+13770*y**3-6975*y**4+771*y**5+542*y**6-221*y**7+45*y**8)
          +r**6*(8584-44416*y+86784*y**2-77841*y**3+23844*y**4+12411*y**5-13354*y**6
          +4456*y**7-354*y**8-114*y**9))+144*logy**2*r**5*(-1+y)**2*(-1+r**2+y)**2*(977*r**20*(
          -1+y)**6-2*r**18*(-1+y)**2*(-8249+33973*y-53402*y**2+37053*y**3-11957*y**4
          +1652*y**5)-r**16*(-1+y)**2*(-99163+334222*y-396879*y**2+143481*y**3
          +44591*y**4-33221*y**5+1809*y**6)+3*(-1+y)**7*(-103-309*y-618*y**2
          +70*y**3+125*y**4+483*y**5-256*y**6+8*y**7)-2*r**6*(-1+y)**4*(106249
          -50148*y-12513*y**2-201226*y**3+393998*y**4-268609*y**5+71293*y**6
          -4392*y**7-159*y**8+182*y**9)-2*r**2*(-1+y)**5*(-1484-1175*y-866*y**2
          +13448*y**3-11623*y**4+734*y**5+925*y**6+1291*y**7-1298*y**8+348*y**9)
          +2*r**14*(-163831+838448*y-1673889*y**2+1713138*y**3-944706*y**4+269421*y**5
          -76733*y**6+64909*y**7-29033*y**8+3776*y**9)-r**4*(-1+y)**4*(22973
          +1538*y+2501*y**2-219291*y**3+381577*y**4-245396*y**5+64407*y**6-15181*y**7
          +11286*y**8-4582*y**9+768*y**10)+r**8*(-1+y)**2*(-664208+1834056*y
          -1628464*y**2+541661*y**3-383149*y**4+852377*y**5-823201*y**6+349729*y**7
          -46211*y**8-7191*y**9+1301*y**10)+r**12*(-989492+5192420*y-10830768*y**2
          +11575749*y**3-6242169*y**4+645432*y**5+1267785*y**6-809267*y**7+225201*y**8
          -34046*y**9+2155*y**10)-2*r**10*(741373-3741834*y+7526532*y**2-7643358*y**3
          +3797997*y**4-252699*y**5-815735*y**6+546313*y**7-205922*y**8+56948*y**9
          -10629*y**10+1014*y**11))+12*logy*r*(-1+y)*(-1+r**2+y)**3*(-(r**26*(
          -1+y)**7)-r**24*(-1+y)**3*(-1177+4705*y-7050*y**2+4163*y**3-1013*y**4
          +126*y**5)-3*(-1+y)**9*(-7-35*y-105*y**2-211*y**3-157*y**4+167*y**5
          +245*y**6+115*y**7-304*y**8+92*y**9)+r**22*(-100722+685134*y-1987440*y**2
          +3180786*y**3-3036315*y**4+1741977*y**5-570980*y**6+92678*y**7-5479*y**8
          +361*y**9)+r**20*(-248878+1628440*y-4576902*y**2+6879010*y**3-5725201*y**4
          +2397258*y**5-210767*y**6-224260*y**7+96413*y**8-15896*y**9+783*y**10)
          -r**2*(-1+y)**7*(-635-1968*y-4062*y**2+3123*y**3+153*y**4+4008*y**5
          +2634*y**6-3633*y**7-6148*y**8+8542*y**9-3858*y**10+644*y**11)-r**18*(1241437
          -6943075*y+15699399*y**2-16659428*y**3+4521407*y**4+8330538*y**5-9959262*y**6
          +4732341*y**7-1075412*y**8+130073*y**9-19545*y**10+1527*y**11)+r**16*(7077821
          -39703532*y+88782450*y**2-101823968*y**3+59565680*y**4-10009551*y**5
          -7185420*y**6+3355476*y**7-66662*y**8+189505*y**9-252680*y**10+56262*y**11
          -2181*y**12)-r**8*(-1+y)**4*(-409457+79632*y-50334*y**2+3773067*y**3
          -7679640*y**4+6300939*y**5-2856600*y**6+1257222*y**7-613462*y**8+165035*y**9
          -12552*y**10-747*y**11+97*y**12)+r**4*(-1+y)**6*(-7630-9812*y-10380*y**2
          +53686*y**3-12949*y**4+20781*y**5-88570*y**6+67966*y**7-2371*y**8-21491*y**9
          +13104*y**10-3118*y**11+184*y**12)+r**6*(-1+y)**5*(-186798-98124*y
          -59544*y**2+1490402*y**3-1663855*y**4+420077*y**5+151504*y**6+90634*y**7
          -213907*y**8+97005*y**9-9234*y**10-2950*y**11+390*y**12)+r**10*(-1
          +y)**3*(-3640919+7592132*y-3724230*y**2+2399426*y**3-12714491*y**4
          +22156437*y**5-16679250*y**6+4930092*y**7+456044*y**8-656599*y**9+167042*y**10
          -19512*y**11+828*y**12)+r**12*(-1+y)**2*(7702652-24374752*y+26532080*y**2
          -13105468*y**3+6081104*y**4-6770923*y**5+5966958*y**6-2450106*y**7+313493*y**8
          -131299*y**9+142676*y**10-43956*y**11+3741*y**12)+r**14*(11267652-66518004*y
          +160294344*y**2-204379156*y**3+136887292*y**4-17449011*y**5-53832843*y**6
          +52107192*y**7-22958087*y**8+4850618*y**9-178281*y**10-94668*y**11+699*y**12
          +2253*y**13))+r*(-1+r**2+y)**4*(91*r**26*(-1+y)**8+r**24*(-1+y)**4*(
          -2901+11228*y-15908*y**2+10513*y**3-3225*y**4+425*y**5)+2*r**22*(
          -1+y)**2*(57845-334394*y+795626*y**2-990573*y**3+691844*y**4-276493*y**5
          +62262*y**6-6996*y**7+219*y**8)+r**20*(990770-7154904*y+22239998*y**2
          -38434118*y**3+39636394*y**4-23902759*y**5+6982820*y**6+230635*y**7
          -737504*y**8+150679*y**9-398*y**10-893*y**11)+r**18*(-597503+4574736*y
          -14171930*y**2+26620930*y**3-36155377*y**4+36327072*y**5-25525586*y**6
          +12144570*y**7-4250735*y**8+1326112*y**9-342584*y**10+48580*y**11-1885*y**12)
          +(-1+y)**8*(1423+5440*y+13096*y**2+12597*y**3-10281*y**4-43488*y**5
          -5568*y**6+20244*y**7+50261*y**8-55674*y**9+16320*y**10-657*y**11-115*y**12
          +2*y**13)+r**2*(-1+y)**7*(-3303-7729*y-14026*y**2+111096*y**3-131703*y**4
          -89427*y**5+188146*y**6-33348*y**7-50729*y**8+44583*y**9-30900*y**10
          +10968*y**11-901*y**12+73*y**13)+r**4*(-1+y)**6*(16642-47244*y-115712*y**2
          +284902*y**3-725092*y**4-12453*y**5+2006900*y**6-1664364*y**7+26558*y**8
          +512522*y**9-299924*y**10+83454*y**11-9084*y**12+495*y**13)+2*r**6*(
          -1+y)**5*(1228883+115075*y-109630*y**2-8262667*y**3+11045646*y**4
          -3503744*y**5+324079*y**6-2316457*y**7+2335974*y**8-773826*y**9-33949*y**10
          +82356*y**11-15683*y**12+943*y**13)+r**16*(10610345-67800792*y+179793512*y**2
          -245544573*y**3+156192877*y**4+18101674*y**5-108667928*y**6+79784792*y**7
          -24298629*y**8+664578*y**9+1503816*y**10-361515*y**11+27591*y**12+1452*y**13)
          +r**8*(-1+y)**4*(1986973-2689964*y-1833664*y**2+5822575*y**3-15324693*y**4
          +33867721*y**5-33375272*y**6+14834594*y**7-1290405*y**8-1637582*y**9
          +504536*y**10+88311*y**11-50995*y**12+5065*y**13)+2*r**12*(-1+y)**2*(
          -3674+3836292*y-18373424*y**2+38849946*y**3-21463048*y**4-38021773*y**5
          +62153912*y**6-30827432*y**7+958026*y**8+5004858*y**9-2135208*y**10
          +395166*y**11-53784*y**12+5943*y**13)+r**10*(-1+y)**3*(33430723-82379679*y
          +51421402*y**2-9897606*y**3+77596397*y**4-160856473*y**5+128549144*y**6
          -34887020*y**7-9516483*y**8+7561983*y**9-1549530*y**10+233850*y**11
          -72717*y**12+9609*y**13)+4*r**14*(-15820849+98993476*y-253612129*y**2
          +341178931*y**3-239297177*y**4+42374403*y**5+70703346*y**6-66276410*y**7
          +27212605*y**8-6933693*y**9+2095866*y**10-761967*y**11+161979*y**12
          -20436*y**13+2055*y**14))))/(37324800*logy**4*r**16*(-1+y)**8+12441600*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +1555200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+86400*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+1800*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((rhoD*(-518400*logy**4*r**16*(18+51*r**2
          +58*r**4+55*r**6+47*r**8+9*r**10)*(-1+y)**9-8640*logy**3*r**12*(-1+y)**4*(409*r**18*(
          -1+y)**5-4*(-1+y)**7*(31+62*y+93*y**2-116*y**3+20*y**4)-r**2*(
          -1+y)**6*(-469-469*y-469*y**2+1821*y**3-1304*y**4+180*y**5)-5*r**4*(
          -1+y)**5*(1316-864*y-432*y**2+145*y**3+346*y**4-286*y**5+44*y**6)
          +r**16*(-808+4040*y-8080*y**2+7315*y**3-3455*y**4+583*y**5+45*y**6)
          -5*r**14*(414-1638*y+2196*y**2-315*y**3-1295*y**4+1087*y**5-349*y**6
          +36*y**7)+r**12*(-9884+38140*y-48080*y**2+5785*y**3+34795*y**4-29906*y**5
          +9280*y**6-795*y**7-15*y**8)-r**6*(-1+y)**3*(8438-29116*y+26798*y**2
          +625*y**3-11660*y**4+4717*y**5+316*y**6-518*y**7+40*y**8)+r**10*(-2364
          -1380*y+35760*y**2-81570*y**3+77015*y**4-31066*y**5+565*y**6+3845*y**7
          -1390*y**8+225*y**9)+r**8*(-76-13540*y+61880*y**2-102425*y**3+63575*y**4
          +17237*y**5-49305*y**6+29810*y**7-7750*y**8+480*y**9+114*y**10))-144*logy**2*r**8*(
          -1+y)**2*(3*r**26*(-1+y)**7+2*(-1+y)**11*(41+164*y+410*y**2+420*y**3
          -55*y**4-856*y**5+376*y**6)-2*r**24*(-1+y)**2*(6853-34265*y+68530*y**2
          -67335*y**3+36570*y**4-10398*y**5+1285*y**6)-r**22*(-1+y)**2*(111802
          -485390*y+786730*y**2-523245*y**3+44365*y**4+117853*y**5-49915*y**6
          +4680*y**7)+r**2*(-1+y)**9*(557+1114*y+1671*y**2-7672*y**3+3195*y**4
          +518*y**5-559*y**6-936*y**7+712*y**8)+2*r**4*(-1+y)**8*(-25333-14173*y
          -8593*y**2+158172*y**3-153828*y**4+25518*y**5+25698*y**6-11867*y**7
          +1158*y**8+348*y**9)+10*r**8*(-1+y)**6*(-80799+199239*y-98100*y**2
          -156234*y**3+210673*y**4-53976*y**5-38868*y**6+25711*y**7-4001*y**8
          -475*y**9+190*y**10)+r**6*(-1+y)**7*(8818-84420*y-42210*y**2-85275*y**3
          +568580*y**4-512726*y**5+111710*y**6+44055*y**7-18150*y**8-150*y**9
          +768*y**10)+r**20*(81398-715226*y+2654718*y**2-5710750*y**3+7435880*y**4
          -5862188*y**5+2739786*y**6-697208*y**7+69580*y**8-2160*y**9+2170*y**10)
          +r**10*(-1+y)**4*(21759+1453563*y-4833423*y**2+4717321*y**3+655300*y**4
          -4592409*y**5+3470517*y**6-929172*y**7-33811*y**8+45890*y**9-2730*y**10
          +195*y**11)-2*r**12*(-1+y)**3*(559242-2243808*y+2752992*y**2+95297*y**3
          -3078923*y**4+2876668*y**5-884627*y**6-224812*y**7+196483*y**8-18172*y**9
          -9555*y**10+1465*y**11)-r**14*(-1+y)**2*(-1004172+5446380*y-10768560*y**2
          +7508010*y**3+2648130*y**4-6883531*y**5+3583655*y**6-233510*y**7-449530*y**8
          +174775*y**9-27567*y**10+1720*y**11)+5*r**18*(-10147-3491*y+232413*y**2
          -788907*y**3+1132281*y**4-739022*y**5+81464*y**6+213597*y**7-175286*y**8
          +70653*y**9-16165*y**10+1810*y**11)+2*r**16*(-590727+3245529*y-7130727*y**2
          +7692170*y**3-3844085*y**4+557319*y**5-472718*y**6+1203004*y**7-909020*y**8
          +254235*y**9+10408*y**10-17911*y**11+2523*y**12))-12*logy*r**6*(-1+y)*(
          -1+r**2+y)**2*(31*r**28*(-1+y)**8+r**26*(-1+y)**3*(1514-7508*y+14830*y**2
          -15473*y**3+8251*y**4-2177*y**5+235*y**6)+(-1+y)**10*(81+324*y+810*y**2
          +814*y**3+486*y**4-636*y**5-1954*y**6+550*y**7+2061*y**8-1796*y**9
          +460*y**10)+r**24*(42499-336954*y+1165797*y**2-2301115*y**3+2861060*y**4
          -2338661*y**5+1268204*y**6-445869*y**7+95681*y**8-11241*y**9+599*y**10)
          -2*r**22*(-240352+1799288*y-5821654*y**2+10490206*y**3-11483866*y**4
          +7824601*y**5-3193133*y**6+627604*y**7+30344*y**8-38239*y**9+5181*y**10
          +20*y**11)+r**20*(1834623-12379072*y+35000636*y**2-52106207*y**3+39994380*y**4
          -7348469*y**5-14044088*y**6+13647927*y**7-5659293*y**8+1179565*y**9
          -137484*y**10+19360*y**11-1878*y**12)+r**2*(-1+y)**8*(-5318-8506*y
          -10548*y**2+41623*y**3+41768*y**4+10459*y**5-226650*y**6+224519*y**7
          -57258*y**8-25053*y**9+20074*y**10-5354*y**11+644*y**12)+r**18*(-1364530
          +10603618*y-35650844*y**2+73777885*y**3-99237036*y**4+85598857*y**5
          -46992386*y**6+16829015*y**7-3970038*y**8+193761*y**9+385778*y**10-188872*y**11
          +38144*y**12-1752*y**13)-r**4*(-1+y)**7*(-26243-19413*y-17056*y**2
          +382865*y**3-616627*y**4+291129*y**5+184717*y**6-259791*y**7+60376*y**8
          +47372*y**9-42021*y**10+16006*y**11-3098*y**12+184*y**13)-2*r**6*(-1
          +y)**6*(647008-592832*y-158294*y**2-3736934*y**3+8993640*y**4-6462619*y**5
          +34187*y**6+2112779*y**7-908803*y**8+18130*y**9+60271*y**10-4935*y**11
          -2185*y**12+287*y**13)-r**8*(-1+y)**5*(964449-923865*y-468624*y**2
          +2176781*y**3-8747034*y**4+15983785*y**5-13327050*y**6+5002626*y**7
          -441759*y**8-311201*y**9+140006*y**10-21995*y**11+388*y**12+293*y**13)
          +r**10*(-1+y)**4*(-12154654+47113502*y-59931844*y**2-1961161*y**3+78251286*y**4
          -75748959*y**5+19600172*y**6+10677576*y**7-6999266*y**8+588244*y**9
          +317768*y**10-47319*y**11-5902*y**12+757*y**13)+2*r**14*(-1+y)**2*(10643072
          -46050568*y+72773700*y**2-42165924*y**3-11638564*y**4+26457312*y**5
          -10073582*y**6-859770*y**7+406644*y**8+838259*y**9-389694*y**10+55380*y**11
          -6040*y**12+975*y**13)+r**12*(-1+y)**3*(9616411-47656615*y+89343566*y**2
          -72045356*y**3+9983437*y**4+25243711*y**5-22222858*y**6+8920732*y**7
          -1069339*y**8-546927*y**9+235868*y**10-17032*y**11-10373*y**12+1575*y**13)
          +r**16*(-145845+5859550*y-35063963*y**2+101248124*y**3-161523654*y**4
          +141346204*y**5-51462066*y**6-21803324*y**7+38204109*y**8-23154862*y**9
          +7699791*y**10-1242544*y**11+27542*y**12+10212*y**13+726*y**14))-r**6*(
          -1+r**2+y)**3*(63*r**28*(-1+y)**9+r**26*(-1+y)**4*(1600-8183*y+16729*y**2
          -17767*y**3+10061*y**4-3040*y**5+424*y**6)+r**24*(-1+y)**2*(-1523+23846*y
          -114642*y**2+247149*y**3-322246*y**4+291067*y**5-172232*y**6+61321*y**7
          -11969*y**8+989*y**9)+r**22*(-888736+7506390*y-27854346*y**2+59540238*y**3
          -80965970*y**4+72943925*y**5-43700377*y**6+16732187*y**7-3572027*y**8
          +198941*y**9+70067*y**10-11617*y**11+365*y**12)+r**20*(-2306955+17168121*y
          -54372162*y**2+90044154*y**3-75045629*y**4+11635364*y**5+38125074*y**6
          -41046870*y**7+20972203*y**8-6025071*y**9+931696*y**10-89980*y**11+17357*y**12
          -2502*y**13)-(-1+y)**10*(4933+18760*y+44956*y**2+41269*y**3+8579*y**4
          -61828*y**5-57384*y**6+34588*y**7+86599*y**8-86294*y**9+24420*y**10
          -961*y**11-39*y**12+2*y**13)+r**18*(-10871696+79156179*y-244457601*y**2
          +411548065*y**3-386830555*y**4+143330589*y**5+104444493*y**6-176709358*y**7
          +113926628*y**8-40999911*y**9+8218347*y**10-721947*y**11-82961*y**12
          +44687*y**13-4559*y**14)-r**2*(-1+y)**8*(-132816-187989*y-211665*y**2
          +925509*y**3+593977*y**4+27743*y**5-3593825*y**6+3833206*y**7-1188644*y**8
          -185867*y**9+161623*y**10-32971*y**11+6939*y**12-95*y**13+75*y**14)
          +r**8*(-1+y)**5*(37455241-72142939*y+23037366*y**2-54190003*y**3+196978282*y**4
          -166813490*y**5-22498571*y**6+89973518*y**7-34386371*y**8-2348095*y**9
          +4017584*y**10-762715*y**11+11576*y**12-7236*y**13+253*y**14)-r**4*(
          -1+y)**7*(-238121-232232*y-137045*y**2-947740*y**3+8801131*y**4-6908291*y**5
          -9343420*y**6+15092132*y**7-6143365*y**8-667462*y**9+1094957*y**10-304088*y**11
          +51363*y**12-3055*y**13+436*y**14)-r**6*(-1+y)**6*(-13116992+16236666*y
          +1257510*y**2+62581512*y**3-166636376*y**4+135119289*y**5-18338091*y**6
          -27726774*y**7+11298526*y**8+617010*y**9-821002*y**10-41810*y**11+85154*y**12
          -7893*y**13+871*y**14)+2*r**14*(-1+y)**2*(-13896528+72523698*y-149422914*y**2
          +165222408*y**3-125483760*y**4+86802793*y**5-52379691*y**6+20879380*y**7
          -3305916*y**8-3306574*y**9+2918220*y**10-827252*y**11+81624*y**12-6477*y**13
          +2589*y**14)+r**10*(-1+y)**4*(139548288-502630449*y+619173279*y**2
          -131386153*y**3-386443957*y**4+389532880*y**5-143839016*y**6+6741506*y**7
          +8271598*y**8+32791*y**9-153953*y**10-299105*y**11+124815*y**12-43470*y**13
          +4146*y**14)+r**12*(-1+y)**3*(100424205-380986674*y+481134603*y**2
          -56997964*y**3-431950819*y**4+430565580*y**5-138948947*y**6-18007180*y**7
          +8331031*y**8+9575214*y**9-3867115*y**10+202736*y**11+116247*y**12-50832*y**13
          +7515*y**14)+r**16*(27184833-214363134*y+732113493*y**2-1470077107*y**3
          +1892876457*y**4-1535992135*y**5+654520695*y**6+46993030*y**7-256460581*y**8
          +181331820*y**9-75265641*y**10+20008029*y**11-3015853*y**12+115713*y**13
          +31653*y**14-1272*y**15))))/(37324800*logy**4*r**21*(-1+y)**9+12441600*logy**3*r**17*(
          -1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +1555200*logy**2*r**13*(-1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+86400*logy*r**9*(-1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+1800*r**5*(-1+y)*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*muWC**3*(518400*logy**4*r**16*(18
          +51*r**2+58*r**4+55*r**6+47*r**8+9*r**10)*(-1+y)**9+8640*logy**3*r**12*(
          -1+y)**4*(409*r**18*(-1+y)**5-4*(-1+y)**7*(31+62*y+93*y**2-116*y**3
          +20*y**4)-r**2*(-1+y)**6*(-469-469*y-469*y**2+1821*y**3-1304*y**4
          +180*y**5)-5*r**4*(-1+y)**5*(1316-864*y-432*y**2+145*y**3+346*y**4
          -286*y**5+44*y**6)+r**16*(-808+4040*y-8080*y**2+7315*y**3-3455*y**4
          +583*y**5+45*y**6)-5*r**14*(414-1638*y+2196*y**2-315*y**3-1295*y**4
          +1087*y**5-349*y**6+36*y**7)+r**12*(-9884+38140*y-48080*y**2+5785*y**3
          +34795*y**4-29906*y**5+9280*y**6-795*y**7-15*y**8)-r**6*(-1+y)**3*(8438
          -29116*y+26798*y**2+625*y**3-11660*y**4+4717*y**5+316*y**6-518*y**7
          +40*y**8)+r**10*(-2364-1380*y+35760*y**2-81570*y**3+77015*y**4-31066*y**5
          +565*y**6+3845*y**7-1390*y**8+225*y**9)+r**8*(-76-13540*y+61880*y**2
          -102425*y**3+63575*y**4+17237*y**5-49305*y**6+29810*y**7-7750*y**8
          +480*y**9+114*y**10))+144*logy**2*r**8*(-1+y)**2*(3*r**26*(-1+y)**7+2*(
          -1+y)**11*(41+164*y+410*y**2+420*y**3-55*y**4-856*y**5+376*y**6)
          -2*r**24*(-1+y)**2*(6853-34265*y+68530*y**2-67335*y**3+36570*y**4
          -10398*y**5+1285*y**6)-r**22*(-1+y)**2*(111802-485390*y+786730*y**2
          -523245*y**3+44365*y**4+117853*y**5-49915*y**6+4680*y**7)+r**2*(-1
          +y)**9*(557+1114*y+1671*y**2-7672*y**3+3195*y**4+518*y**5-559*y**6
          -936*y**7+712*y**8)+2*r**4*(-1+y)**8*(-25333-14173*y-8593*y**2+158172*y**3
          -153828*y**4+25518*y**5+25698*y**6-11867*y**7+1158*y**8+348*y**9)+10*r**8*(
          -1+y)**6*(-80799+199239*y-98100*y**2-156234*y**3+210673*y**4-53976*y**5
          -38868*y**6+25711*y**7-4001*y**8-475*y**9+190*y**10)+r**6*(-1+y)**7*(8818
          -84420*y-42210*y**2-85275*y**3+568580*y**4-512726*y**5+111710*y**6
          +44055*y**7-18150*y**8-150*y**9+768*y**10)+r**20*(81398-715226*y+2654718*y**2
          -5710750*y**3+7435880*y**4-5862188*y**5+2739786*y**6-697208*y**7+69580*y**8
          -2160*y**9+2170*y**10)+r**10*(-1+y)**4*(21759+1453563*y-4833423*y**2
          +4717321*y**3+655300*y**4-4592409*y**5+3470517*y**6-929172*y**7-33811*y**8
          +45890*y**9-2730*y**10+195*y**11)-2*r**12*(-1+y)**3*(559242-2243808*y
          +2752992*y**2+95297*y**3-3078923*y**4+2876668*y**5-884627*y**6-224812*y**7
          +196483*y**8-18172*y**9-9555*y**10+1465*y**11)-r**14*(-1+y)**2*(-1004172
          +5446380*y-10768560*y**2+7508010*y**3+2648130*y**4-6883531*y**5+3583655*y**6
          -233510*y**7-449530*y**8+174775*y**9-27567*y**10+1720*y**11)+5*r**18*(
          -10147-3491*y+232413*y**2-788907*y**3+1132281*y**4-739022*y**5+81464*y**6
          +213597*y**7-175286*y**8+70653*y**9-16165*y**10+1810*y**11)+2*r**16*(
          -590727+3245529*y-7130727*y**2+7692170*y**3-3844085*y**4+557319*y**5
          -472718*y**6+1203004*y**7-909020*y**8+254235*y**9+10408*y**10-17911*y**11
          +2523*y**12))+12*logy*r**6*(-1+y)*(-1+r**2+y)**2*(31*r**28*(-1+y)**8
          +r**26*(-1+y)**3*(1514-7508*y+14830*y**2-15473*y**3+8251*y**4-2177*y**5
          +235*y**6)+(-1+y)**10*(81+324*y+810*y**2+814*y**3+486*y**4-636*y**5
          -1954*y**6+550*y**7+2061*y**8-1796*y**9+460*y**10)+r**24*(42499-336954*y
          +1165797*y**2-2301115*y**3+2861060*y**4-2338661*y**5+1268204*y**6-445869*y**7
          +95681*y**8-11241*y**9+599*y**10)-2*r**22*(-240352+1799288*y-5821654*y**2
          +10490206*y**3-11483866*y**4+7824601*y**5-3193133*y**6+627604*y**7+30344*y**8
          -38239*y**9+5181*y**10+20*y**11)+r**20*(1834623-12379072*y+35000636*y**2
          -52106207*y**3+39994380*y**4-7348469*y**5-14044088*y**6+13647927*y**7
          -5659293*y**8+1179565*y**9-137484*y**10+19360*y**11-1878*y**12)+r**2*(
          -1+y)**8*(-5318-8506*y-10548*y**2+41623*y**3+41768*y**4+10459*y**5
          -226650*y**6+224519*y**7-57258*y**8-25053*y**9+20074*y**10-5354*y**11
          +644*y**12)+r**18*(-1364530+10603618*y-35650844*y**2+73777885*y**3
          -99237036*y**4+85598857*y**5-46992386*y**6+16829015*y**7-3970038*y**8
          +193761*y**9+385778*y**10-188872*y**11+38144*y**12-1752*y**13)-r**4*(
          -1+y)**7*(-26243-19413*y-17056*y**2+382865*y**3-616627*y**4+291129*y**5
          +184717*y**6-259791*y**7+60376*y**8+47372*y**9-42021*y**10+16006*y**11
          -3098*y**12+184*y**13)-2*r**6*(-1+y)**6*(647008-592832*y-158294*y**2
          -3736934*y**3+8993640*y**4-6462619*y**5+34187*y**6+2112779*y**7-908803*y**8
          +18130*y**9+60271*y**10-4935*y**11-2185*y**12+287*y**13)-r**8*(-1+y)**5*(964449
          -923865*y-468624*y**2+2176781*y**3-8747034*y**4+15983785*y**5-13327050*y**6
          +5002626*y**7-441759*y**8-311201*y**9+140006*y**10-21995*y**11+388*y**12
          +293*y**13)+r**10*(-1+y)**4*(-12154654+47113502*y-59931844*y**2-1961161*y**3
          +78251286*y**4-75748959*y**5+19600172*y**6+10677576*y**7-6999266*y**8
          +588244*y**9+317768*y**10-47319*y**11-5902*y**12+757*y**13)+2*r**14*(
          -1+y)**2*(10643072-46050568*y+72773700*y**2-42165924*y**3-11638564*y**4
          +26457312*y**5-10073582*y**6-859770*y**7+406644*y**8+838259*y**9-389694*y**10
          +55380*y**11-6040*y**12+975*y**13)+r**12*(-1+y)**3*(9616411-47656615*y
          +89343566*y**2-72045356*y**3+9983437*y**4+25243711*y**5-22222858*y**6
          +8920732*y**7-1069339*y**8-546927*y**9+235868*y**10-17032*y**11-10373*y**12
          +1575*y**13)+r**16*(-145845+5859550*y-35063963*y**2+101248124*y**3
          -161523654*y**4+141346204*y**5-51462066*y**6-21803324*y**7+38204109*y**8
          -23154862*y**9+7699791*y**10-1242544*y**11+27542*y**12+10212*y**13+726*y**14))
          +r**6*(-1+r**2+y)**3*(63*r**28*(-1+y)**9+r**26*(-1+y)**4*(1600-8183*y
          +16729*y**2-17767*y**3+10061*y**4-3040*y**5+424*y**6)+r**24*(-1+y)**2*(
          -1523+23846*y-114642*y**2+247149*y**3-322246*y**4+291067*y**5-172232*y**6
          +61321*y**7-11969*y**8+989*y**9)+r**22*(-888736+7506390*y-27854346*y**2
          +59540238*y**3-80965970*y**4+72943925*y**5-43700377*y**6+16732187*y**7
          -3572027*y**8+198941*y**9+70067*y**10-11617*y**11+365*y**12)+r**20*(
          -2306955+17168121*y-54372162*y**2+90044154*y**3-75045629*y**4+11635364*y**5
          +38125074*y**6-41046870*y**7+20972203*y**8-6025071*y**9+931696*y**10
          -89980*y**11+17357*y**12-2502*y**13)-(-1+y)**10*(4933+18760*y+44956*y**2
          +41269*y**3+8579*y**4-61828*y**5-57384*y**6+34588*y**7+86599*y**8-86294*y**9
          +24420*y**10-961*y**11-39*y**12+2*y**13)+r**18*(-10871696+79156179*y
          -244457601*y**2+411548065*y**3-386830555*y**4+143330589*y**5+104444493*y**6
          -176709358*y**7+113926628*y**8-40999911*y**9+8218347*y**10-721947*y**11
          -82961*y**12+44687*y**13-4559*y**14)-r**2*(-1+y)**8*(-132816-187989*y
          -211665*y**2+925509*y**3+593977*y**4+27743*y**5-3593825*y**6+3833206*y**7
          -1188644*y**8-185867*y**9+161623*y**10-32971*y**11+6939*y**12-95*y**13
          +75*y**14)+r**8*(-1+y)**5*(37455241-72142939*y+23037366*y**2-54190003*y**3
          +196978282*y**4-166813490*y**5-22498571*y**6+89973518*y**7-34386371*y**8
          -2348095*y**9+4017584*y**10-762715*y**11+11576*y**12-7236*y**13+253*y**14)
          -r**4*(-1+y)**7*(-238121-232232*y-137045*y**2-947740*y**3+8801131*y**4
          -6908291*y**5-9343420*y**6+15092132*y**7-6143365*y**8-667462*y**9+1094957*y**10
          -304088*y**11+51363*y**12-3055*y**13+436*y**14)-r**6*(-1+y)**6*(-13116992
          +16236666*y+1257510*y**2+62581512*y**3-166636376*y**4+135119289*y**5
          -18338091*y**6-27726774*y**7+11298526*y**8+617010*y**9-821002*y**10
          -41810*y**11+85154*y**12-7893*y**13+871*y**14)+2*r**14*(-1+y)**2*(-13896528
          +72523698*y-149422914*y**2+165222408*y**3-125483760*y**4+86802793*y**5
          -52379691*y**6+20879380*y**7-3305916*y**8-3306574*y**9+2918220*y**10
          -827252*y**11+81624*y**12-6477*y**13+2589*y**14)+r**10*(-1+y)**4*(139548288
          -502630449*y+619173279*y**2-131386153*y**3-386443957*y**4+389532880*y**5
          -143839016*y**6+6741506*y**7+8271598*y**8+32791*y**9-153953*y**10-299105*y**11
          +124815*y**12-43470*y**13+4146*y**14)+r**12*(-1+y)**3*(100424205-380986674*y
          +481134603*y**2-56997964*y**3-431950819*y**4+430565580*y**5-138948947*y**6
          -18007180*y**7+8331031*y**8+9575214*y**9-3867115*y**10+202736*y**11
          +116247*y**12-50832*y**13+7515*y**14)+r**16*(27184833-214363134*y+732113493*y**2
          -1470077107*y**3+1892876457*y**4-1535992135*y**5+654520695*y**6+46993030*y**7
          -256460581*y**8+181331820*y**9-75265641*y**10+20008029*y**11-3015853*y**12
          +115713*y**13+31653*y**14-1272*y**15))))/(41990400*logy**4*r**21*(-1+y)**9
          +13996800*logy**3*r**17*(-1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+1749600*logy**2*r**13*(-1+y)**5*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+97200*logy*r**9*(
          -1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +2025*r**5*(-1+y)*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(
          -1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y
          -y**2+y**3))**4))
      resNP += ((api*(-518400*logy**4*r**15*(-3+4*r**2+12*r**4+15*r**6)*(
          -1+y)**8-8640*logy**3*r**11*(-1+y)**6*(303*r**14*(-1+y)**2+r**12*(557
          -1114*y+557*y**2+30*y**3)-5*r**10*(-575+430*y+505*y**2-494*y**3
          +60*y**4)+5*(-1+y)**3*(-55-55*y-55*y**2+191*y**3-112*y**4+20*y**5)
          +5*r**8*(-307+1190*y-1171*y**2+418*y**3-138*y**4+78*y**5)+r**2*(-1
          +y)**2*(-127-1150*y**3+1235*y**4-468*y**5+60*y**6)+5*r**6*(-431+1054*y
          -719*y**2+24*y**3+261*y**4-216*y**5+69*y**6)-r**4*(193+334*y-887*y**2
          +90*y**3+65*y**4+422*y**5-229*y**6+12*y**7))-144*logy**2*r**7*(-1+y)**4*(
          -1+r**2+y)**2*(421*r**18*(-1+y)**4-r**16*(-1+y)**2*(-8359+17560*y
          -10043*y**2+1942*y**3)-r**14*(-1+y)**2*(-97092+157204*y-51665*y**2
          -8304*y**3+257*y**4)-(-1+y)**5*(-833-2499*y-4998*y**2-310*y**3+2875*y**4
          +6693*y**5-6656*y**6+1528*y**7)+r**12*(90740-365364*y+577249*y**2
          -390800*y**3+34450*y**4+85820*y**5-37231*y**6+5636*y**7)+r**10*(330718
          -834456*y+612923*y**2+76590*y**3-295775*y**4+135422*y**5-35089*y**6
          +12372*y**7-1205*y**8)+r**4*(-1+y)**3*(71732+35808*y+27133*y**2-280753*y**3
          +233150*y**4-65902*y**5+8477*y**6-4393*y**7+1448*y**8)-r**2*(-1+y)**4*(5955
          +13576*y+22863*y**2-17954*y**3-3525*y**4-21670*y**5+30919*y**6-12508*y**7
          +1544*y**8)+r**6*(-1+y)**2*(31676-80900*y-42833*y**2+450852*y**3-487085*y**4
          +156424*y**5+21985*y**6-22172*y**7+4153*y**8)+r**8*(124314-274276*y
          +43999*y**2+557844*y**3-902951*y**4+566186*y**5-48799*y**6-104024*y**7
          +41281*y**8-3574*y**9))+12*logy*r**3*(-1+y)**3*(-1+r**2+y)**3*(7*r**24*(
          -1+y)**5+r**22*(-1+y)**3*(-638+1255*y-596*y**2+117*y**3)+r**20*(41204
          -197809*y+375995*y**2-355352*y**3+169948*y**4-35831*y**5+2077*y**6
          -232*y**7)+r**18*(266802-1248795*y+2320737*y**2-2166320*y**3+1038942*y**4
          -209565*y**5-9373*y**6+8280*y**7-708*y**8)-3*(-1+y)**7*(-7-35*y
          -105*y**2-211*y**3-157*y**4+167*y**5+245*y**6+115*y**7-304*y**8+92*y**9)
          +r**16*(1649289-6631428*y+9935031*y**2-6068242*y**3+135207*y**4+1487256*y**5
          -557277*y**6+59584*y**7-10458*y**8+1038*y**9)+r**6*(-1+y)**4*(-93074
          -191473*y-326709*y**2+577618*y**3-54374*y**4+583036*y**5-945652*y**6
          +443414*y**7-54328*y**8-5971*y**9+313*y**10)-r**8*(-1+y)**3*(-1309037
          +127984*y+230971*y**2+4783034*y**3-6140644*y**4+2022854*y**5+573716*y**6
          -495686*y**7+90621*y**8-1146*y**9+333*y**10)-r**2*(-1+y)**6*(1630+6583*y
          +16615*y**2+13053*y**3+909*y**4-23115*y**5+3937*y**6-2025*y**7+6857*y**8
          -3304*y**9+460*y**10)-r**4*(-1+y)**5*(-54428-148245*y-276534*y**2
          +71552*y**3+161266*y**4+317382*y**5-422970*y**6+133144*y**7+218*y**8
          -5401*y**9+816*y**10)+2*r**14*(-143350+139205*y+1127837*y**2-2245586*y**3
          +632752*y**4+1501882*y**5-1387310*y**6+398858*y**7-7974*y**8-15447*y**9
          +933*y**10)-2*r**10*(-1+y)**2*(-873366+1625157*y+179697*y**2-3995173*y**3
          +4164601*y**4-786855*y**5-774507*y**6+330283*y**7+3383*y**8-13536*y**9
          +1716*y**10)-2*r**12*(-1439316+3375459*y-1031061*y**2-3340418*y**3
          +2857764*y**4+755592*y**5-1973258*y**6+968046*y**7-192972*y**8+22321*y**9
          -3141*y**10+984*y**11))-r*(-1+y)**2*(-1+r**2+y)**4*(3*r**26*(-1+y)**6
          +r**24*(-1+y)**4*(-383+670*y-233*y**2+14*y**3)+2*r**22*(-1+y)**2*(18151
          -68058*y+92798*y**2-57364*y**3+16997*y**4-2124*y**5+10*y**6)+(-1
          +y)**10*(1+8*y+36*y**2+22*y**3-68*y**4-140*y**5-92*y**6+50*y**7
          +19*y**8+4*y**9)+2*r**20*(293461-1581600*y+3465875*y**2-3918644*y**3
          +2354738*y**4-643781*y**5+5465*y**6+24790*y**7-951*y**8+47*y**9)+r**18*(1227213
          -6151010*y+12628771*y**2-13582384*y**3+7823874*y**4-1756328*y**5-539390*y**6
          +456244*y**7-119051*y**8+14886*y**9+775*y**10)+r**2*(-1+y)**7*(1597
          +7729*y+22545*y**2+35921*y**3+20674*y**4-35858*y**5-29894*y**6-11870*y**7
          +39569*y**8-13959*y**9+661*y**10+85*y**11)+2*r**4*(-1+y)**6*(-24275
          -90386*y-213624*y**2-100138*y**3+21373*y**4+245107*y**5-124271*y**6
          +33439*y**7-37702*y**8+21687*y**9-4517*y**10+307*y**11)+2*r**6*(-1
          +y)**5*(318561+719501*y+1162698*y**2-1119772*y**3-994436*y**4-1411174*y**5
          +2889940*y**6-1153918*y**7-10753*y**8+85061*y**9-15282*y**10+1174*y**11)
          +4*r**12*(-1+y)**2*(8162815-13671650*y+576456*y**2+10153426*y**3-2301285*y**4
          -5517227*y**5+3240765*y**6+74209*y**7-424376*y**8+123675*y**9-13203*y**10
          +2295*y**11)+r**16*(10942159-49558070*y+85612431*y**2-61013654*y**3
          -3208512*y**4+33347098*y**5-20646876*y**6+4824454*y**7-325871*y**8+27612*y**9
          -6147*y**10+2976*y**11)+r**8*(-1+y)**4*(874927+790618*y+9369*y**2
          -765350*y**3-2072958*y**4+4727512*y**5-3492258*y**6+1065616*y**7-91625*y**8
          +49638*y**9-25839*y**10+5550*y**11)+r**10*(-1+y)**3*(12993683-5255233*y
          -4892007*y**2-37712275*y**3+58851726*y**4-18161794*y**5-10672230*y**6
          +7244402*y**7-1001185*y**8+8019*y**9-16179*y**10+8673*y**11)+4*r**14*(
          -4530563+19404840*y-28996867*y**2+13603930*y**3+7129940*y**4-8005778*y**5
          +264788*y**6+1140190*y**7+379035*y**8-535990*y**9+161451*y**10-16608*y**11
          +1632*y**12)))*math.log(mu0**2/r**2))/(12441600*logy**4*r**16*(-1+y)**8+4147200*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +518400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+28800*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+600*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2
          +3*r**4)*(-1+y)**6+120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(
          -1+y)**2-5*r**8*(-67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y
          -18*y**2+22*y**3-2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3
          -16*y**4+2*y**5)+2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(
          -151+482*y-421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(
          -1+r**2+y)**2*(7*r**16*(-1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2
          +27*y**3)-r**12*(-1+y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)
          +2*r**10*(-1+y)**2*(-4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)
          +5*r**8*(13422-43158*y+45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6
          -284*y**7+33*y**8)+2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3
          -2300*y**4+277*y**5-56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436
          -542*y+757*y**2+11016*y**3-25545*y**4+20466*y**5-4753*y**6-652*y**7
          +89*y**8)+(-1+y)**4*(67+134*y+201*y**2+428*y**3-55*y**4-22*y**5
          -89*y**6-156*y**7+92*y**8)-2*r**6*(-17964+49281*y-40854*y**2+5986*y**3
          +8446*y**4-11636*y**5+9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(0,'SLSR',y/2,r))/(1036800*logy**3*r**12*(
          -1+y)**6-600*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +259200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(21600*logy**3*r**11*(27+41*r**2
          +29*r**4+9*r**6)*(-1+y)**8+720*logy**2*r**7*(-1+y)**6*(74*r**12*(-1+y)**2
          +31*r**14*(-1+y)**2+r**10*(1389-1968*y+174*y**2+485*y**3-90*y**4)
          +5*r**8*(443-364*y-340*y**2+242*y**3+y**4+4*y**5)-(-1+y)**3*(11
          +11*y+11*y**2+251*y**3-184*y**4+20*y**5)-r**2*(-1+y)**2*(599-455*y**3
          +430*y**4-234*y**5+20*y**6)+5*r**6*(-17+772*y-1124*y**2+168*y**3
          +255*y**4-105*y**5+27*y**6)+r**4*(-3036+8502*y-6681*y**2-50*y**3
          +1860*y**4-744*y**5+113*y**6+36*y**7))+6*logy*r**3*(-1+y)**4*(-1+r**2
          +y)**2*(41*r**18*(-1+y)**4-r**16*(-1+y)**2*(-643+1368*y-807*y**2+162*y**3)
          -r**14*(-1+y)**2*(-15790+25508*y-7489*y**2-1926*y**3+257*y**4)+r**12*(
          -1+y)**2*(22492-45292*y+26723*y**2+338*y**3-2257*y**4+556*y**5)+(
          -1+y)**4*(11+22*y+33*y**2+604*y**3-95*y**4+94*y**5+683*y**6-1128*y**7
          +376*y**8)+r**10*(325264-987788*y+962749*y**2-168480*y**3-240815*y**4
          +115216*y**5-2237*y**6-4404*y**7+495*y**8)+r**2*(-1+y)**3*(1217+1195*y
          +1173*y**2+10851*y**3-12281*y**4+853*y**5-4525*y**6+5397*y**7-1856*y**8
          +376*y**9)+r**4*(-1+y)**2*(18460+228*y-1059*y**2-127026*y**3+222587*y**4
          -138000*y**5+21407*y**6+9694*y**7-3339*y**8+648*y**9)-r**8*(-592234
          +1816036*y-1796019*y**2+337456*y**3+482771*y**4-315066*y**5+67539*y**6
          +5044*y**7-6881*y**8+754*y**9)+r**6*(171082-446136*y+345989*y**2-173976*y**3
          +407904*y**4-548040*y**5+323186*y**6-83264*y**7-1874*y**8+5496*y**9
          -367*y**10))+r*(-1+y)**3*(-1+r**2+y)**3*(11*r**20*(-1+y)**5-r**18*(
          -1+y)**3*(-887+1561*y-584*y**2+20*y**3)-r**14*(-1+y)**2*(98866-215370*y
          +117060*y**2+18665*y**3-23400*y**4+2019*y**5+60*y**6)-6*r**16*(829
          -3910*y+7345*y**2-6960*y**3+3400*y**4-689*y**5-40*y**6+25*y**7)+r**12*(56552
          -202342*y+195188*y**2+67937*y**3-212345*y**4+111118*y**5-11938*y**6
          -5343*y**7+783*y**8+390*y**9)+(-1+y)**5*(56+168*y+336*y**2+869*y**3
          +572*y**4+363*y**5+82*y**6-561*y**7-144*y**8-47*y**9+106*y**10)+3*r**10*(
          -502676+1833106*y-2306948*y**2+790633*y**3+694954*y**4-671513*y**5
          +142444*y**6+32823*y**7-14458*y**8+871*y**9+164*y**10)+3*r**4*(-1+y)**3*(2543
          +3408*y+3113*y**2-42897*y**3+52608*y**4-18023*y**5+5142*y**6-7563*y**7
          +2797*y**8-133*y**9+205*y**10)+r**6*(-1+y)**2*(-128446+85278*y+28872*y**2
          +551901*y**3-1196170*y**4+902511*y**5-195488*y**6-103457*y**7+56364*y**8
          -5265*y**9+300*y**10)+r**2*(-1+y)**4*(1603+3104*y+4470*y**2+2351*y**3
          +1462*y**4-2943*y**5-16354*y**6+18205*y**7-7701*y**8+763*y**9+440*y**10)
          +r**8*(-598858+1924148*y-2036302*y**2+663653*y**3-36127*y**4+208109*y**5
          -130003*y**6+28427*y**7-47803*y**8+28227*y**9-3651*y**10+180*y**11)))*nlo.X1El(0,'SM',y/2,r))/(6220800*logy**4*r**16*(
          -1+y)**8+2073600*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+259200*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+14400*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +300*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1+y)**4-(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(1,'SLSR',y/2,r))/(1440*logy**2*r**8*(
          -1+y)**4+240*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(720*logy**2*r**7*(4+5*r**2+2*r**4)*(
          -1+y)**6+24*logy*r**3*(-1+y)**4*(8*r**10*(-1+y)**2+3*r**12*(-1+y)**2
          -5*r**8*(-44+64*y-8*y**2-13*y**3+2*y**4)+2*(-1+y)**3*(-1-y-y**2
          -6*y**3+4*y**4)+5*r**6*(26+8*y-64*y**2+21*y**3+7*y**4)+r**2*(-1
          +y)**2*(-58+35*y**3-15*y**4+8*y**5)+5*r**4*(-61+170*y-133*y**2+y**3
          +31*y**4-11*y**5+3*y**6))+r*(-1+y)**3*(-1+r**2+y)**2*(7*r**12*(-1
          +y)**3+2*r**10*(-81+214*y-174*y**2+35*y**3+6*y**4)+r**8*(-169+509*y
          -558*y**2+220*y**3+3*y**4-5*y**5)-4*r**6*(1431-2992*y+1413*y**2+518*y**3
          -447*y**4+47*y**5)+(-1+y)**3*(-13-26*y-39*y**2-54*y**3-9*y**4+4*y**5
          +17*y**6)+2*r**2*(-1+y)**2*(-61-72*y-71*y**2+319*y**3-256*y**4+55*y**5
          +26*y**6)+r**4*(-1749+2827*y-705*y**2+335*y**3-1195*y**4+489*y**5
          -47*y**6+45*y**7)))*nlo.X1El(1,'SM',y/2,r))/(-17280*logy**3*r**12*(-1+y)**6
          +10*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)
          +2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3-4320*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -360*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(
          -1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y
          -y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(2,'SLSR',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          )
      resNP += ((api*(12*logy*r**3*(1+r**2)*(-1+y)**4+2*r*(-1+y)**3*(r**6*(-1+y)
          +3*r**2*(-1+y)**2*(3+y)+3*r**4*(-3+y+y**2)+(-1+y)**2*(1+y+y**2)))*nlo.X1El(2,'SM',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      res += resNP*wc.SLSR

    if wc.VR2 != 0:
      resNP = 0
      resNP +=((-518400*logy**4*r**14*(18+37*r**2+46*r**4+37*r**6+18*r**8)*(-1+y)**8
          -17280*logy**3*r**10*(-1+y)**6*(385*r**14*(-1+y)**2+62*r**16*(-1+y)**2
          -2*(-1+y)**4*(31+62*y+93*y**2-116*y**3+20*y**4)-5*r**12*(-564+696*y
          +84*y**2-287*y**3+36*y**4)-5*r**2*(-1+y)**3*(-77-77*y-77*y**2+198*y**3
          -130*y**4+20*y**5)+r**10*(2317-194*y-4343*y**2+2365*y**3+85*y**4
          +40*y**5)+5*r**8*y*(1104-1656*y+236*y**2+558*y**3-261*y**4+54*y**5)
          -5*r**4*(-1+y)**2*(564-432*y-216*y**2+43*y**3+114*y**4-78*y**5+8*y**6)
          +r**6*(-2317+9074*y-8977*y**2-380*y**3+3965*y**4-1543*y**5+106*y**6
          +72*y**7))-288*logy**2*r**6*(-1+y)**4*(-1+r**2+y)**2*(41*r**20*(-1+y)**4
          -2*r**18*(-1+y)**2*(-718+1477*y-800*y**2+81*y**3)-r**16*(-1+y)**2*(
          -27307+46408*y-16598*y**2-2085*y**3+257*y**4)+r**14*(-1+y)**2*(84208
          -134364*y+44148*y**2+20465*y**3-5063*y**4+556*y**5)+(-1+y)**6*(41
          +164*y+410*y**2+420*y**3-55*y**4-856*y**5+376*y**6)+r**2*(-1+y)**5*(
          -1436-4390*y-8944*y**2-195*y**3+1340*y**4+6341*y**5-3910*y**6+744*y**7)
          -r**8*(-1+y)**2*(-430204+453696*y+34110*y**2-47007*y**3-157145*y**4
          +87754*y**5-1976*y**6-6545*y**7+367*y**8)+r**4*(-1+y)**4*(27307+46408*y
          +63006*y**2-108701*y**3+37575*y**4-1897*y**5+4922*y**6-2446*y**7+376*y**8)
          +r**12*(430204-1267120*y+1186026*y**2-114775*y**3-412585*y**4+188961*y**5
          -7010*y**6-3796*y**7+495*y**8)+r**6*(-1+y)**3*(-84208-50156*y-44148*y**2
          +328997*y**3-237670*y**4+33268*y**5+19866*y**6-5747*y**7+648*y**8)
          -r**10*(-598408+1795224*y-1692578*y**2+62491*y**3+817961*y**4-428237*y**5
          +10971*y**6+44988*y**7-13166*y**8+754*y**9))-24*logy*r**4*(-1+y)**4*(
          -1+r**2+y)**3*(35*r**22*(-1+y)**4+r**20*(-1+y)**2*(4777-8675*y+3511*y**2
          +32*y**3)+r**18*(68841-254352*y+343980*y**2-200558*y**3+40669*y**4
          +2170*y**5-250*y**6)-r**16*(-559235+1767083*y-1875096*y**2+550589*y**3
          +267259*y**4-155406*y**5+7246*y**6+360*y**7)+r**14*(884954-2726672*y
          +2935668*y**2-715360*y**3-833120*y**4+516396*y**5-62528*y**6+9052*y**7
          +510*y**8)+(-1+y)**6*(35+175*y+525*y**2+812*y**3+323*y**4-1225*y**5
          +35*y**6-110*y**7+38*y**8+92*y**9)+r**2*(-1+y)**5*(-4777-18229*y
          -43867*y**2-34337*y**3+3545*y**4+61547*y**5-28261*y**6+3697*y**7-1108*y**8
          +590*y**9)+2*r**8*(-1+y)**2*(442477+35905*y+68593*y**2-1985690*y**3
          +2117995*y**4-316367*y**5-319675*y**6+121962*y**7-9800*y**8+750*y**9)
          +2*r**12*(2610679-6201127*y+3627234*y**2+2260089*y**3-3061770*y**4
          +498591*y**5+419502*y**6-138189*y**7+13541*y**8+750*y**9)+r**4*(-1
          +y)**4*(68841+185511*y+343980*y**2-121447*y**3-35640*y**4-199791*y**5
          +190504*y**6-41665*y**7-1753*y**8+1460*y**9)+r**6*(-1+y)**3*(-559235
          -648613*y-667248*y**2+2976336*y**3-1496310*y**4-83790*y**5+147528*y**6
          +7848*y**7-8731*y**8+1815*y**9)+2*r**10*(2610679-6852268*y+4929516*y**2
          +1876654*y**3-3982894*y**4+1230264*y**5+420908*y**6-278566*y**7+45081*y**8
          -136*y**9+762*y**10))+(-1+y)**2*(-1+r**2+y)**4*(r**28*(-1+y)**6+2*r**26*(
          -1+y)**4*(-15+28*y-11*y**2+3*y**3)+r**24*(-1+y)**2*(-3781+14400*y
          -20200*y**2+11962*y**3-2151*y**4-98*y**5+4*y**6)+(-1+y)**10*(1+8*y
          +36*y**2+22*y**3-68*y**4-140*y**5-92*y**6+50*y**7+19*y**8+4*y**9)
          -2*r**22*(100894-555240*y+1245902*y**2-1449132*y**3+907262*y**4-274543*y**5
          +19782*y**6+4946*y**7-24*y**8+33*y**9)+r**20*(-1044615+5322410*y-10891633*y**2
          +11105532*y**3-5336678*y**4+424806*y**5+553496*y**6-117616*y**7-16871*y**8
          +484*y**9-275*y**10)+2*r**2*(-1+y)**9*(15+103*y+404*y**2+151*y**3
          -671*y**4-1286*y**5-582*y**6+377*y**7-100*y**8-13*y**9+2*y**10)-4*r**14*(
          -1+y)**2*(15694242-31388484*y+10283696*y**2+20794284*y**3-18087988*y**4
          +839719*y**5+3221486*y**6-811871*y**7+67966*y**8+1083*y**9+3234*y**10
          +33*y**11)+r**4*(-1+y)**7*(3781+18181*y+52781*y**2+86141*y**3+43086*y**4
          -91888*y**5-16350*y**6-24916*y**7+14349*y**8+1739*y**9-543*y**10+39*y**11)
          +2*r**6*(-1+y)**6*(-100894-353452*y-791556*y**2-394040*y**3+127740*y**4
          +849719*y**5-603266*y**6+71001*y**7+1350*y**8+9145*y**9-1430*y**10
          +83*y**11)-2*r**18*(3750833-17410768*y+31137111*y**2-24152911*y**3
          +2304190*y**4+8977361*y**5-5758076*y**6+1173619*y**7-30819*y**8+8475*y**9
          +121*y**10+264*y**11)+2*r**10*(-1+y)**4*(-3750833-2407436*y-1409805*y**2
          +21166497*y**3-16860850*y**4-1402946*y**5+3849266*y**6-806480*y**7-86837*y**8
          +37130*y**9-7381*y**10+275*y**11)+r**12*(-1+y)**3*(294837-1125855*y
          +3239471*y**2-10062837*y**3+15962138*y**4-5594642*y**5-3746338*y**6
          +1845634*y**7-387743*y**8+41097*y**9-17325*y**10+363*y**11)+r**8*(-1
          +y)**5*(1044615+2188565*y+3380658*y**2-5913488*y**3+124350*y**4-1998154*y**5
          +2473044*y**6-754588*y**7-48637*y**8+55045*y**9-8206*y**10+396*y**11)
          -r**16*(294837-348330*y+1684421*y**2-4284698*y**3+3156800*y**4-1984762*y**5
          +4807228*y**6-4913254*y**7+1687563*y**8-117340*y**9+12255*y**10+4752*y**11
          +528*y**12)))/(12441600*logy**4*r**16*(-1+y)**8+4147200*logy**3*r**12*(-1
          +y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +518400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+28800*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+600*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(12441600*logy**5*r**18*(-9+23*r**4
          +37*r**6+27*r**8)*(-1+y)**10+207360*logy**4*r**14*(-1+y)**8*(535*r**16*(
          -1+y)**2+5*r**14*(347-694*y+347*y**2+18*y**3)-5*r**12*(-1557+1494*y
          +873*y**2-1097*y**3+108*y**4)+3*(-1+y)**3*(-167-167*y-167*y**2+523*y**3
          -272*y**4+40*y**5)+2*r**10*(47+5456*y-8278*y**2+3580*y**3-545*y**4
          +355*y**5)+10*r**2*(-1+y)**2*(43-396*y**3+402*y**4-150*y**5+20*y**6)
          +25*r**6*(-219+438*y-219*y**2-10*y**3+93*y**4-102*y**5+37*y**6)+5*r**8*(
          -1300+3980*y-3370*y**2+546*y**3+609*y**4-435*y**5+153*y**6)+5*r**4*(179
          -898*y+989*y**2-277*y**3+551*y**4-943*y**5+485*y**6-94*y**7+8*y**8))
          +3456*logy**3*r**10*(-1+y)**6*(-1+r**2+y)**2*(1217*r**20*(-1+y)**4-2*r**18*(
          -1+y)**2*(-10369+21955*y-12803*y**2+1767*y**3)-r**16*(-1+y)**2*(-247659
          +410828*y-146530*y**2-18988*y**3+1349*y**4)-45*(-1+y)**5*(-39-117*y
          -234*y**2-10*y**3+125*y**4+299*y**5-288*y**6+64*y**7)+2*r**14*(245995
          -916994*y+1282684*y**2-732665*y**3+31790*y**4+124345*y**5-39646*y**6
          +5366*y**7)+r**12*(1318276-3709912*y+3447246*y**2-545260*y**3-993285*y**4
          +603624*y**5-149878*y**6+37574*y**7-1785*y**8)-2*r**2*(-1+y)**4*(8998
          +19751*y+32259*y**2-21213*y**3-12075*y**4-31698*y**5+50474*y**6-21734*y**7
          +2988*y**8)+2*r**6*(-1+y)**2*(-60027-37996*y-35935*y**2+791551*y**3
          -961018*y**4+382552*y**5-36404*y**6+1885*y**7-6751*y**8+1968*y**9)
          -r**4*(-1+y)**3*(-190085-109347*y-93994*y**2+723774*y**3-499733*y**4
          +167305*y**5-135558*y**6+98564*y**7-29004*y**8+2528*y**9)-2*r**10*(
          -478309+1232036*y-857179*y**2-591849*y**3+1377471*y**4-864346*y**5
          +111884*y**6+111424*y**7-47356*y**8+3599*y**9)+r**8*(101392-80644*y
          -501894*y**2+2126496*y**3-3881489*y**4+3345102*y**5-1077631*y**6-230156*y**7
          +260679*y**8-70236*y**9+8381*y**10))+288*logy**2*r**6*(-1+y)**4*(-1+r**2
          +y)**3*(41*r**26*(-1+y)**6-r**24*(-1+y)**4*(-4095+8313*y-4341*y**2
          +529*y**3)+2*r**22*(-1+y)**2*(76051-288502*y+404574*y**2-248745*y**3
          +57443*y**4-743*y**5+82*y**6)+2*r**20*(-1+y)**2*(550294-2040343*y
          +2802840*y**2-1681754*y**3+340818*y**4+43535*y**5-14493*y**6+1278*y**7)
          -r**18*(-1+y)**2*(-6562987+20316322*y-21259584*y**2+6221014*y**3+3009971*y**4
          -1867056*y**5+180306*y**6-27852*y**7+1866*y**8)+3*(-1+y)**8*(-41-205*y
          -615*y**2-953*y**3-611*y**4+901*y**5+955*y**6+425*y**7-1232*y**8+376*y**9)
          +r**2*(-1+y)**7*(6323+25661*y+65075*y**2+54325*y**3+10545*y**4-83577*y**5
          -7091*y**6-8525*y**7+41860*y**8-19420*y**9+2424*y**10)+r**16*(6242711
          -33497961*y+74911065*y**2-83693061*y**3+37136037*y**4+15126021*y**5
          -26018187*y**6+11687475*y**7-1802394*y**8-194592*y**9+109308*y**10-5622*y**11)
          +2*r**4*(-1+y)**6*(-88242-242805*y-457932*y**2+81626*y**3+253657*y**4
          +550563*y**5-663545*y**6+206292*y**7-41206*y**8+27238*y**9-9136*y**10
          +940*y**11)-r**8*(-1+y)**4*(4746587-71713*y-134299*y**2-18942509*y**3
          +20914450*y**4-8016062*y**5+3579952*y**6-2864836*y**7+955289*y**8-6325*y**9
          -41375*y**10+1441*y**11)-r**10*(-1+y)**3*(1477535-5099517*y-1011747*y**2
          +35286345*y**3-52268202*y**4+23709630*y**5+2900748*y**6-5249448*y**7
          +1201395*y**8+55407*y**9-56865*y**10+1719*y**11)+2*r**6*(-1+y)**5*(364501
          +647879*y+952830*y**2-1617433*y**3-369714*y**4-1295138*y**5+3000665*y**6
          -1655925*y**7+230953*y**8+58609*y**9-18083*y**10+1756*y**11)+2*r**12*(
          -1+y)**2*(4090748-6249260*y-3242364*y**2+19351490*y**3-23305613*y**4
          +8600073*y**5+4691618*y**6-4766846*y**7+1080690*y**8+71523*y**9-34791*y**10
          +3882*y**11)+2*r**14*(7816482-30554838*y+43667928*y**2-20214020*y**3
          -14380353*y**4+21976572*y**5-8929767*y**6-488936*y**7+1612935*y**8-641872*y**9
          +146681*y**10-13050*y**11+2238*y**12))+24*logy*r**4*(-1+y)**4*(-1+r**2
          +y)**4*(-5*r**28*(-1+y)**6-r**26*(-1+y)**4*(-6909+12814*y-5393*y**2
          +168*y**3)-2*r**24*(-1+y)**2*(-144764+543232*y-748111*y**2+457549*y**3
          -115967*y**4+6591*y**5+177*y**6)+2*r**22*(2118879-11431282*y+25125532*y**2
          -28458584*y**3+16957472*y**4-4383322*y**5-146105*y**6+223587*y**7-7886*y**8
          +289*y**9)+r**20*(14202397-73187318*y+153599257*y**2-163743508*y**3
          +84636562*y**4-7472154*y**5-12948550*y**6+5740960*y**7-934105*y**8+112600*y**9
          +2339*y**10)+r**18*(74860815-336435726*y+579178623*y**2-421151124*y**3
          +8718694*y**4+182853884*y**5-107782584*y**6+18493622*y**7+1749109*y**8
          -619404*y**9+127751*y**10+3340*y**11)+2*(-1+y)**8*(-33-198*y-693*y**2
          -1561*y**3-1637*y**4+651*y**5+1919*y**6+1811*y**7-1534*y**8+47*y**9
          -218*y**10-46*y**11+92*y**12)+r**2*(-1+y)**7*(15943+77027*y+224493*y**2
          +305421*y**3+183106*y**4-265162*y**5-228440*y**6-110346*y**7+285839*y**8
          -98081*y**9+12319*y**10-5427*y**11+1508*y**12)+2*r**16*(-1566273-9046878*y
          +73788333*y**2-135019123*y**3+56444031*y**4+84655067*y**5-103882559*y**6
          +34214595*y**7+4959468*y**8-5735061*y**9+1287686*y**10-35088*y**11+4002*y**12)
          +r**4*(-1+y)**6*(-356061-1333576*y-3173474*y**2-1982260*y**3+112941*y**4
          +4142750*y**5-647272*y**6+228658*y**7-1901605*y**8+1139754*y**9-175154*y**10
          -15022*y**11+5321*y**12)+2*r**6*(-1+y)**5*(2061929+4734767*y+7809217*y**2
          -7167823*y**3-6538694*y**4-10026442*y**5+19716291*y**6-8291768*y**7
          +664048*y**8-69781*y**9+168048*y**10-44553*y**11+5961*y**12)+2*r**8*(
          -1+y)**4*(-3072090-4192852*y-6323947*y**2+21975491*y**3-1322124*y**4
          +16621130*y**5-49289531*y**6+33066462*y**7-4759641*y**8-2477046*y**9
          +937050*y**10-109337*y**11+10635*y**12)+r**10*(-1+y)**3*(57720901-35523123*y
          -17821821*y**2-194227997*y**3+349461666*y**4-167402494*y**5-13373942*y**6
          +29416638*y**7-5325423*y**8-952831*y**9+564923*y**10-122145*y**11+31048*y**12)
          +r**12*(-1+y)**2*(77354565-173100420*y+27988938*y**2+427122916*y**3
          -622333653*y**4+244944892*y**5+119355188*y**6-117973884*y**7+20520399*y**8
          +5333088*y**9-1650782*y**10+76992*y**11+32361*y**12)+4*r**14*(25679397
          -66368310*y+20269050*y**2+97330768*y**3-110881267*y**4-2391692*y**5
          +81062497*y**6-60951047*y**7+16533144*y**8+855627*y**9-1432295*y**10
          +300923*y**11-12018*y**12+5223*y**13))+2*r**2*(-1+y)**2*(-1+r**2+y)**5*(r**32*(
          -1+y)**8+r**30*(-1+y)**6*(-36+67*y-26*y**2+6*y**3)+r**28*(-1+y)**4*(886
          -3429*y+4841*y**2-3139*y**3+1001*y**4-120*y**5+10*y**6)+r**26*(-1
          +y)**2*(210280-1183087*y+2729760*y**2-3298449*y**3+2193942*y**4-757814*y**5
          +104468*y**6+1375*y**7-58*y**8+7*y**9)+r**24*(3837190-28195991*y+89407483*y**2
          -159553458*y**3+174838154*y**4-119838193*y**5+49475985*y**6-10702519*y**7
          +643511*y**8+84172*y**9+3892*y**10+373*y**11+121*y**12)-(-1+y)**11*(
          -1-8*y-36*y**2-425*y**3-865*y**4+270*y**5+1774*y**6+2120*y**7-351*y**8
          -744*y**9+342*y**10-135*y**11-23*y**12+2*y**13)+r**22*(29424292-201225661*y
          +585815036*y**2-932806779*y**3+853881510*y**4-403171490*y**5+23544900*y**6
          +74778918*y**7-35978948*y**8+5961987*y**9-271440*y**10+43853*y**11+1178*y**12
          +724*y**13)+r**14*(-1+y)**3*(-1007519780+2171387467*y-656565203*y**2
          -1885368439*y**3+1555648085*y**4+401038022*y**5-898942320*y**6+255729234*y**7
          +87800742*y**8-55897177*y**9+7654973*y**10+1876373*y**11-481991*y**12
          +115192*y**13+22*y**14)-r**2*(-1+y)**9*(-4464-25997*y-88631*y**2-167241*y**3
          -167061*y**4+36119*y**5+157811*y**6+176034*y**7-77222*y**8-1387*y**9
          -42205*y**10+11511*y**11+3627*y**12-527*y**13+33*y**14)-r**4*(-1+y)**8*(385390
          +1757167*y+4871973*y**2+5838049*y**3+2911053*y**4-5686196*y**5-3210730*y**6
          -1123926*y**7+5269672*y**8-2295097*y**9+209061*y**10-48787*y**11+37533*y**12
          -4186*y**13+224*y**14)+3*r**16*(-1+y)**2*(-191271216+735804675*y-903225273*y**2
          +150580031*y**3+520303177*y**4-377353823*y**5+47532215*y**6+13854338*y**7
          +12567556*y**8-8946715*y**9+1191119*y**10+437175*y**11-58365*y**12+23903*y**13
          +803*y**14)-r**6*(-1+y)**7*(-3442852-11255843*y-24131541*y**2-2581949*y**3
          +12184227*y**4+38070188*y**5-20422930*y**6+3140726*y**7-14462494*y**8
          +11014045*y**9-2301121*y**10-232257*y**11+149655*y**12-18302*y**13+848*y**14)
          +r**20*(36600102-235324837*y+655150025*y**2-1014244371*y**3+905336865*y**4
          -382731080*y**5-66043694*y**6+170681682*y**7-89395480*y**8+23519515*y**9
          -3907847*y**10+236601*y**11+115953*y**12+5786*y**13+1980*y**14)-r**8*(
          -1+y)**6*(28204918+49827153*y+66968643*y**2-156312179*y**3-68492811*y**4
          -80584247*y**5+337603261*y**6-194072402*y**7+3982294*y**8+19719931*y**9
          -2650201*y**10-981259*y**11+343319*y**12-50805*y**13+1985*y**14)-r**12*(
          -1+y)**4*(403382574-370397609*y-148060003*y**2-1068040795*y**3+2492527789*y**4
          -1270672398*y**5-495105696*y**6+614154810*y**7-135344880*y**8-25868709*y**9
          +13843469*y**10-3341135*y**11+614293*y**12-125620*y**13+2310*y**14)
          -r**10*(-1+y)**5*(22727240+12947651*y-22146519*y**2-14386757*y**3-12616429*y**4
          +212555873*y**5-384086879*y**6+239956906*y**7-31718870*y**8-25827079*y**9
          +11502887*y**10-2718317*y**11+536643*y**12-95653*y**13+2903*y**14)+r**18*(394136512
          -2380286847*y+5896647282*y**2-7261867406*y**3+3508996308*y**4+1947508656*y**5
          -3802055028*y**6+2144208753*y**7-371654136*y**8-144688943*y**9+83718522*y**10
          -16049940*y**11+1308020*y**12+50142*y**13+25080*y**14+3025*y**15))))/(
          -55987200*logy**5*r**20*(-1+y)**10+225*(r**8*(-1+y)**2-6*r**4*y*(2-3*y
          +y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(
          -1+y)**3*(-1-y-y**2+y**3))**5-23328000*logy**4*r**16*(-1+y)**8*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-3888000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          -324000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**3-13500*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2
          -3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)
          +r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*muWC*(24883200*logy**5*r**18*(
          -36-37*r**2+37*r**6+36*r**8)*(-1+y)**10-414720*logy**4*r**14*(-1+y)**7*(
          -1036*r**16*(-1+y)**3-5*r**14*(-433+1299*y-1299*y**2+145*y**3+144*y**4)
          +5*r**2*(-1+y)**3*(-433+1043*y**3-619*y**4+150*y**5)+5*r**12*(1736
          -3048*y-192*y**2+3747*y**3-2093*y**4+216*y**5)-4*(-1+y)**3*(259
          -600*y**3+645*y**4-234*y**5+20*y**6)-r**10*(5381-27243*y+43893*y**2
          -32906*y**3+8235*y**4+60*y**5+200*y**6)-5*r**8*(2600-7800*y+7800*y**2
          -2248*y**3-2720*y**4+3183*y**5-1433*y**6+252*y**7)+r**6*(-5381+5043*y
          +11607*y**2-19289*y**3+15715*y**4-11274*y**5+4552*y**6-37*y**7-216*y**8)
          +5*r**4*(1736-7368*y+10608*y**2-6203*y**3+1521*y**4-579*y**5+113*y**6
          +282*y**7-126*y**8+16*y**9))+13824*logy**3*r**10*(-1+y)**5*(-1+r**2
          +y)**2*(1486*r**20*(-1+y)**5-r**18*(-1+y)**2*(19367-61073*y+67017*y**2
          -25083*y**3+2172*y**4)-r**16*(-1+y)**2*(218872-574002*y+475392*y**2
          -71759*y**3-38995*y**4+4342*y**5)-2*(-1+y)**5*(743+1486*y+2229*y**2
          -3908*y**3-95*y**4-638*y**5+1619*y**6-624*y**7+88*y**8)+r**2*(-1+y)**4*(19367
          +22339*y+25311*y**2-64642*y**3+10080*y**4-16512*y**5+48191*y**6-28781*y**7
          +4372*y**8)+r**14*(-306022+1501120*y-2987867*y**2+2644654*y**3-637355*y**4
          -481383*y**5+322765*y**6-68418*y**7+7256*y**8)+r**10*y*(-405782+1420237*y
          -3245154*y**2+4827350*y**3-3710476*y**4+932947*y**5+467703*y**6-370081*y**7
          +83090*y**8-5084*y**9)+r**12*(-608442+2199544*y-3006842*y**2+869475*y**3
          +2001345*y**4-2069873*y**5+607311*y**6+33667*y**7-41055*y**8+5970*y**9)
          +r**4*(-1+y)**3*(-218872+82614*y+15996*y**2+461733*y**3-576630*y**4
          +293636*y**5-182224*y**6+114044*y**7-37068*y**8+3320*y**9+176*y**10)
          +r**6*(-1+y)**2*(306022-335012*y+72597*y**2-1032884*y**3+1778150*y**4
          -1054755*y**5+364442*y**6-212067*y**7+110339*y**8-28095*y**9+2688*y**10)
          +r**8*(608442-2667992*y+4646410*y**2-5104855*y**3+4948685*y**4-3664259*y**5
          +1223419*y**6+205565*y**7-219095*y**8+15640*y**9+8642*y**10-602*y**11))
          +1152*logy**2*r**6*(-1+y)**3*(-1+r**2+y)**3*(82*r**26*(-1+y)**7-r**24*(
          -1+y)**4*(5209-15873*y+16365*y**2-5739*y**3+446*y**4)-r**22*(-1+y)**2*(164293
          -783842*y+1482055*y**2-1369624*y**3+600551*y**4-86470*y**5-8051*y**6
          +608*y**7)+r**20*(-1+y)**2*(-914795+4332019*y-8185274*y**2+7353518*y**3
          -2802823*y**4+49415*y**5+196931*y**6-27849*y**7+1908*y**8)-2*(-1+y)**9*(41
          +205*y+615*y**2+899*y**3+287*y**4-1471*y**5+395*y**6+295*y**7-454*y**8
          +188*y**9)+r**18*(-1+y)**2*(-5654787+22896972*y-34852995*y**2+20943776*y**3
          +1190979*y**4-6706944*y**5+2238040*y**6-96515*y**7-13098*y**8+1272*y**9)
          -r**2*(-1+y)**7*(5209+15873*y+32238*y**2-8902*y**3-11940*y**4-31962*y**5
          +5077*y**6+7882*y**7+5682*y**8-4905*y**9+1198*y**10)+r**16*(-2382588
          +17248722*y-54494820*y**2+84124288*y**3-51686566*y**4-19953330*y**5
          +50260022*y**6-29612322*y**7+6518017*y**8+339981*y**9-447817*y**10+88461*y**11
          -3648*y**12)+r**6*(-1+y)**5*(-914795-672839*y-677987*y**2+3084413*y**3
          -574956*y**4+628794*y**5-3321776*y**6+2547052*y**7-711758*y**8+80771*y**9
          -22134*y**10+3595*y**11+220*y**12)+r**4*(-1+y)**6*(164293+290963*y
          +407250*y**2-740690*y**3+83840*y**4-167100*y**5+291939*y**6-95601*y**7
          +63850*y**8-80160*y**9+30042*y**10-4902*y**11+376*y**12)-r**8*(-1+y)**4*(
          -5654787+5376963*y+187023*y**2+9392399*y**3-16623006*y**4+12263772*y**5
          -9906672*y**6+7444684*y**7-2644974*y**8+171106*y**9+121950*y**10-23736*y**11
          +578*y**12)+r**10*(-1+y)**3*(-2382588+1811982*y-466230*y**2+25095986*y**3
          -49206884*y**4+34375344*y**5-11427386*y**6+4247532*y**7-2261401*y**8
          +383424*y**9+72019*y**10-23706*y**11+2358*y**12)+r**12*(-1+y)**2*(3725734
          -21637010*y+45638662*y**2-69747282*y**3+76331346*y**4-37008486*y**5
          -10769206*y**6+19542266*y**7-6980893*y**8+207119*y**9+318067*y**10-55809*y**11
          +4692*y**12)-r**14*(3725734-11894596*y+6669006*y**2+38853508*y**3-111028858*y**4
          +132692250*y**5-67132722*y**6-9304556*y**7+28498307*y**8-13353297*y**9
          +2257371*y**10+70083*y**11-53250*y**12+1020*y**13))+48*logy*r**4*(-1
          +y)**3*(-1+r**2+y)**4*(61*r**28*(-1+y)**7-2*r**26*(-1+y)**4*(11426-32432*y
          +29724*y**2-8117*y**3+29*y**4)-r**24*(-1+y)**2*(645589-3065629*y+5756160*y**2
          -5251830*y**3+2284767*y**4-371807*y**5-4658*y**6+876*y**7)-2*r**22*(4180808
          -26532644*y+70941906*y**2-102024214*y**3+82505054*y**4-33965243*y**5
          +3055737*y**6+2530139*y**7-711409*y**8+21250*y**9+256*y**10)+r**20*(
          -20346577+126496319*y-334419085*y**2+465016931*y**3-331296190*y**4
          +69549720*y**5+58396276*y**6-41989080*y**7+9242229*y**8-726185*y**9
          +90987*y**10+4175*y**11)-(-1+y)**8*(-61-305*y-915*y**2-1505*y**3
          +2444*y**4+10296*y**5-7766*y**6-2192*y**7+5885*y**8-5959*y**9+885*y**10
          +281*y**11+312*y**12)+2*r**18*(-66290858+361049412*y-792995214*y**2
          +827091323*y**3-264718381*y**4-282911645*y**5+327670667*y**6-117814502*y**7
          +2652952*y**8+7648626*y**9-1543152*y**10+121626*y**11+5346*y**12)+2*r**2*(
          -1+y)**7*(-11426-43858*y-106014*y**2-44115*y**3+93484*y**4+261006*y**5
          -218864*y**6+39389*y**7+61686*y**8-68534*y**9+18650*y**10+172*y**11
          -1340*y**12+64*y**13)+r**4*(-1+y)**6*(645589+1774451*y+3336120*y**2
          -1309368*y**3-510159*y**4-2627571*y**5-475698*y**6+1607040*y**7+867219*y**8
          -1276181*y**9+350782*y**10-32508*y**11-5765*y**12+1249*y**13)+2*r**6*(
          -1+y)**5*(-4180808-5628604*y-6619410*y**2+20416792*y**3-5362494*y**4
          +2531663*y**5-8729886*y**6+4617185*y**7-3093748*y**8+3007209*y**9-1362540*y**10
          +242495*y**11-27290*y**12+3036*y**13)+4*r**14*y*(-72698556+327143502*y
          -667692054*y**2+755565682*y**3-369902187*y**4-193060197*y**5+412175795*y**6
          -247357145*y**7+51528571*y**8+10116997*y**9-6831317*y**10+1052303*y**11
          -47256*y**12+5862*y**13)+2*r**10*(-1+y)**3*(-66290858+102986594*y-18806760*y**2
          +70019285*y**3-219988378*y**4+233767015*y**5-176365424*y**6+102567420*y**7
          -26249270*y**8-6450932*y**9+4574128*y**10-637445*y**11-39350*y**12+14675*y**13)
          +r**16*(80487111-353420325*y+448161861*y**2-99621849*y**3+27697432*y**4
          -450908288*y**5+533721262*y**6-164730792*y**7-64324055*y**8+55267973*y**9
          -14321943*y**10+1469473*y**11+18276*y**12+15864*y**13)+r**8*(-1+y)**4*(20346577
          +4416857*y+7136145*y**2-60242965*y**3-11287402*y**4-8968124*y**5+151615312*y**6
          -152259348*y**7+50546719*y**8-1545713*y**9-2681753*y**10+656761*y**11
          -127622*y**12+17156*y**13)+r**12*(-1+y)**2*(-80487111+290476563*y-227858694*y**2
          -676969194*y**3+1522146559*y**4-1050566639*y**5+99552016*y**6+178287108*y**7
          -56670977*y**8-6294079*y**9+3609750*y**10-259274*y**11-69519*y**12+31491*y**13))
          +4*(-1+y)*(-1+r**2+y)**5*(r**34*(-1+y)**9+r**32*(-1+y)**6*(35-100*y
          +90*y**2-33*y**3+6*y**4)+r**30*(-1+y)**4*(-5350+25848*y-49371*y**2
          +46495*y**3-21461*y**4+3741*y**5-124*y**6+10*y**7)+r**28*(-1+y)**2*(
          -595670+3921314*y-10927377*y**2+16601512*y**3-14715253*y**4+7495403*y**5
          -1958022*y**6+163576*y**7+14235*y**8+99*y**9+7*y**10)+(-1+y)**12*(1
          +8*y+36*y**2+155*y**3+233*y**4-226*y**5-658*y**6-568*y**7+271*y**8
          +280*y**9-242*y**10+53*y**11+15*y**12+2*y**13)+r**26*(-7280042+60503284*y
          -221186907*y**2+464029727*y**3-610242144*y**4+513889162*y**5-268302099*y**6
          +75995657*y**7-5372273*y**8-2445511*y**9+388110*y**10+22040*y**11+1355*y**12
          +121*y**13)-r**2*(-1+y)**11*(-35-240*y-940*y**2-3110*y**3-3430*y**4
          +4520*y**5+10676*y**6+7796*y**7-6897*y**8+200*y**9+4382*y**10-814*y**11
          +66*y**12-16*y**13+2*y**14)+r**24*(-57629210+449706614*y-1526218875*y**2
          +2911424704*y**3-3333477289*y**4+2184212817*y**5-545131644*y**6-283211434*y**7
          +278562668*y**8-88515564*y**9+10378359*y**10-151074*y**11+42835*y**12
          +4449*y**13+724*y**14)+r**16*(-1+y)**3*(1581333428-4988188758*y+4343230947*y**2
          +2858506433*y**3-7164015957*y**4+2657602776*y**5+2674896677*y**6-2507558148*y**7
          +381532140*y**8+284708266*y**9-123452601*y**10+9780021*y**11+2367301*y**12
          -643668*y**13+116721*y**14+22*y**15)-r**4*(-1+y)**9*(5350+25848*y
          +75219*y**2+86583*y**3-123015*y**4-484982*y**5+234592*y**6+66951*y**7
          -75372*y**8+124280*y**9-15901*y**10+23785*y**11-15315*y**12+2654*y**13
          -310*y**14+33*y**15)-r**6*(-1+y)**8*(-595670-2134304*y-4871759*y**2
          -1370093*y**3+2390227*y**4+7508281*y**5-5395464*y**6+1908710*y**7+925284*y**8
          -1306874*y**9+609105*y**10+105063*y**11-107441*y**12+21569*y**13-2858*y**14
          +224*y**15)-r**8*(-1+y)**7*(7280042+16823032*y+27871117*y**2-23497191*y**3
          +2063725*y**4-18244074*y**5-17440147*y**6+36128058*y**7+11319906*y**8
          -23917736*y**9+9271569*y**10-861715*y**11-250945*y**12+94330*y**13-14019*y**14
          +848*y**15)+r**22*(-13872862+99886608*y-357663435*y**2+698716671*y**3
          -591802761*y**4-265301563*y**5+1088165276*y**6-1009723734*y**7+394895820*y**8
          -20140874*y**9-28957235*y**10+6023291*y**11-325701*y**12+88069*y**13
          +12850*y**14+1980*y**15)-r**10*(-1+y)**6*(-57629210-46302144*y-38192601*y**2
          +317694485*y**3-132415965*y**4+11261213*y**5-193990583*y**6+219655377*y**7
          -97863406*y**8+38993940*y**9-13325513*y**10+3109257*y**11-806091*y**12
          +272351*y**13-42295*y**14+1985*y**15)-r**14*(-1+y)**4*(-797519086+1546585432*y
          -492799295*y**2+840119507*y**3-3741438273*y**4+4301712957*y**5-1945860894*y**6
          +130990116*y**7+295374480*y**8-175395422*y**9+47150189*y**10+455267*y**11
          -2790161*y**12+755673*y**13-118800*y**14+2310*y**15)+r**18*(-1+y)**2*(1581333428
          -7662478666*y+13703245625*y**2-10522946561*y**3+984727473*y**4+4596110571*y**5
          -4323798447*y**6+2210811189*y**7-600180944*y**8-28710486*y**9+65805297*y**10
          -17339317*y**11+2197091*y**12-258995*y**13+80333*y**14+2409*y**15)-r**12*(
          -1+y)**5*(13872862-11096288*y+46897315*y**2+146101407*y**3-642180763*y**4
          +129055034*y**5+1108180218*y**6-1149631471*y**7+357741632*y**8+51938020*y**9
          -50436089*y**10+11763865*y**11-2131699*y**12+550146*y**13-85092*y**14
          +2903*y**15)+r**20*(-797519086+5631086342*y-16830802935*y**2+26741817948*y**3
          -21785682290*y**4+3052960963*y**5+11493515790*y**6-11470422051*y**7+4436556299*y**8
          -97497460*y**9-537515431*y**10+188122698*y**11-25825444*y**12+1162883*y**13
          +3560*y**14+35189*y**15+3025*y**16))))/(167961600*logy**5*r**20*(-1+y)**10
          -675*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)
          +2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5+69984000*logy**4*r**16*(
          -1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +11664000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2+972000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3+40500*logy*(
          -1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(
          -4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2
          +y**3))**4))
      resNP += ((muG*(6220800*logy**5*r**16*(-108-14*r**2+125*r**4+220*r**6
          +187*r**8+54*r**10)*(-1+y)**10-103680*logy**4*r**12*(-1+y)**7*(3362*r**18*(
          -1+y)**3+3*r**16*(1553-4659*y+4659*y**2-3773*y**3+1020*y**4)+r**14*(39368
          -101904*y+77604*y**2-26443*y**3+2945*y**4-720*y**5)-4*(-1+y)**4*(19
          +19*y+19*y**2+589*y**3-416*y**4+40*y**5)+2*r**2*(-1+y)**3*(-1921
          -110*y**3+4075*y**4-2004*y**5+320*y**6)+r**12*(37053-55059*y-29091*y**2
          +49872*y**3-12255*y**4-3240*y**5+820*y**6)-r**10*(20464-127392*y+226392*y**2
          -129604*y**3+8990*y**4+15495*y**5-5645*y**6+450*y**7)+r**4*(-1+y)**2*(31267
          -63667*y+16200*y**2+44165*y**3-55560*y**4+39853*y**5-12458*y**6+1280*y**7)
          +r**8*(-52903+196209*y-252459*y**2+116393*y**3+3345*y**4-19812*y**5
          +2046*y**6+4949*y**7-1368*y**8)+r**6*(-39384+113952*y-107652*y**2
          +51459*y**3-54405*y**4+75759*y**5-65777*y**6+32562*y**7-6834*y**8+320*y**9))
          +3456*logy**3*r**8*(-1+y)**5*(-1+r**2+y)**2*(-5807*r**22*(-1+y)**5+r**20*(
          -1+y)**2*(60551-193267*y+216495*y**2-80533*y**3+8754*y**4)+r**18*(
          -1+y)**2*(531493-1323755*y+1001448*y**2+1401*y**3-155916*y**4+14579*y**5)
          -2*(-1+y)**6*(539+1617*y+3234*y**2+430*y**3-625*y**4-2619*y**5+848*y**6
          +176*y**7)+r**16*(-791588+3010038*y-3642855*y**2+1986762*y**3-1186585*y**4
          +1063363*y**5-572733*y**6+187500*y**7-27652*y**8)+r**2*(-1+y)**5*(1473
          +5102*y+10887*y**2+40268*y**3+7795*y**4+13062*y**5-3027*y**6-20272*y**7
          +6112*y**8)+r**4*(-1+y)**4*(26949+30967*y+27191*y**2-413304*y**3+313542*y**4
          -148904*y**5-89777*y**6+150669*y**7-77916*y**8+13008*y**9)-r**14*(4637424
          -18942594*y+27732042*y**2-18133257*y**3+4889840*y**4+279296*y**5-848901*y**6
          +465443*y**7-140458*y**8+16665*y**9)-r**8*(-1+y)**2*(-2635882+6659220*y
          -3462327*y**2-6776614*y**3+12563654*y**4-10098669*y**5+4312110*y**6
          -824393*y**7+98069*y**8-26249*y**9+4656*y**10)+r**6*(-1+y)**3*(-287313
          +394004*y+165251*y**2-807485*y**3+1979341*y**4-1887170*y**5+828111*y**6
          -372696*y**7+175130*y**8-51056*y**9+5408*y**10)+r**12*(-5281884+22113582*y
          -34238373*y**2+26021328*y**3-11401580*y**4+3041416*y**5+277623*y**6
          -875407*y**7+504007*y**8-148320*y**9+13858*y**10)-r**10*(1186548-5330190*y
          +10061856*y**2-15554097*y**3+23021270*y**4-24351694*y**5+16343364*y**6
          -6664446*y**7+1230232*y**8+122515*y**9-72569*y**10+7211*y**11))-288*logy**2*r**4*(
          -1+y)**3*(-1+r**2+y)**3*(287*r**28*(-1+y)**7-r**26*(-1+y)**4*(19986
          -60819*y+62541*y**2-21535*y**3+1867*y**4)-r**24*(-1+y)**2*(603979
          -2871662*y+5404873*y**2-4946792*y**3+2118893*y**4-280726*y**5-32625*y**6
          +1660*y**7)+r**22*(-1+y)**2*(-2072243+9845083*y-18832418*y**2+16616198*y**3
          -5509663*y**4-585061*y**5+644947*y**6-99873*y**7+8280*y**8)+2*(-1
          +y)**9*(-41-205*y-615*y**2-953*y**3-611*y**4+901*y**5+955*y**6+425*y**7
          -1232*y**8+376*y**9)+r**20*(-1+y)**2*(-11365628+43394989*y-60588815*y**2
          +25093648*y**3+19402196*y**4-21770461*y**5+5658992*y**6-51239*y**7-42132*y**8
          +1950*y**9)+r**2*(-1+y)**8*(3783+15378*y+39060*y**2+34084*y**3+16764*y**4
          -26682*y**5-4288*y**6-7160*y**7-1599*y**8+1156*y**9+1504*y**10)+r**4*(
          -1+y)**7*(-79038-209901*y-385272*y**2-30122*y**3-19992*y**4+69810*y**5
          -302361*y**6+57542*y**7+162257*y**8-32983*y**9-10882*y**10+2592*y**11)
          +r**18*(31440835-170924944*y+360210060*y**2-379675932*y**3+221996794*y**4
          -97012720*y**5+58943080*y**6-34245994*y**7+9671532*y**8+659601*y**9
          -1396055*y**10+342309*y**11-16566*y**12)+r**6*(-1+y)**6*(-162123-167373*y
          -62574*y**2+1883982*y**3+59734*y**4+1174484*y**5-54591*y**6-1464909*y**7
          +853308*y**8-115244*y**9+62764*y**10-27766*y**11+3008*y**12)-r**10*(
          -1+y)**4*(3469944-11361147*y-232941*y**2+45585219*y**3-89045805*y**4
          +92176668*y**5-53764450*y**6+19623276*y**7-6797599*y**8+1725120*y**9
          -151892*y**10-41268*y**11+3175*y**12)+r**8*(-1+y)**5*(-125737-766405*y
          -1261237*y**2-7715517*y**3+9792134*y**4-2065006*y**5-5797638*y**6+10153980*y**7
          -6583768*y**8+1824601*y**9-56532*y**10-35847*y**11+4172*y**12)+r**12*(
          -1+y)**3*(47611555-143454622*y+108271872*y**2+148638974*y**3-349474319*y**4
          +301678812*y**5-142022840*y**6+27722408*y**7+5823176*y**8-3801316*y**9
          +828713*y**10-79218*y**11+5355*y**12)+r**14*(-1+y)**2*(42774526-175256378*y
          +269123806*y**2-266390714*y**3+216076876*y**4-104627330*y**5+4527276*y**6
          +20080134*y**7-11333291*y**8+2587559*y**9+357129*y**10-192633*y**11
          +21840*y**12)+r**16*(91105744-515954548*y+1166353134*y**2-1343009848*y**3
          +786018208*y**4-103830792*y**5-211237424*y**6+211853822*y**7-106103333*y**8
          +26358217*y**9-575187*y**10-1167623*y**11+188214*y**12+1416*y**13))
          -12*logy*r**2*(-1+y)**3*(-1+r**2+y)**4*(129*r**30*(-1+y)**7+2*r**28*(
          -1+y)**4*(-41810+118800*y-108984*y**2+28753*y**3+91*y**4)-r**26*(
          -1+y)**2*(2442205-11572917*y+21664248*y**2-19612906*y**3+8418507*y**4
          -1383019*y**5+9882*y**6+1340*y**7)+4*(-1+y)**10*(7+49*y+196*y**2
          +562*y**3+870*y**4+396*y**5-324*y**6-746*y**7+83*y**8+75*y**9+32*y**10)
          -2*r**24*(13709266-86034722*y+226828884*y**2-318933996*y**3+246585588*y**4
          -89473941*y**5-1470711*y**6+11293239*y**7-2541615*y**8+45452*y**9+756*y**10)
          +r**22*(-17218013+110872275*y-323362417*y**2+472038287*y**3-280303102*y**4
          -77027716*y**5+195431284*y**6-98759768*y**7+21179953*y**8-3363593*y**9
          +598159*y**10+12251*y**11)+2*r**20*(-139471126+733131928*y-1526930474*y**2
          +1369322779*y**3+28319807*y**4-1150786809*y**5+968961505*y**6-283025000*y**7
          -23887874*y**8+29272368*y**9-5527200*y**10+429662*y**11+21434*y**12)
          +r**2*(-1+y)**8*(21069+101521*y+295059*y**2+405765*y**3+263880*y**4
          -285676*y**5-257370*y**6-134716*y**7+272679*y**8-124005*y**9+11107*y**10
          +8479*y**11+1272*y**12+736*y**13)+2*r**4*(-1+y)**7*(-169782-628562*y
          -1483638*y**2-1081759*y**3-647320*y**4+394294*y**5-840114*y**6+32677*y**7
          +726510*y**8-120830*y**9+18208*y**10-29384*y**11+7296*y**12+2104*y**13)
          +r**6*(-1+y)**6*(2561025+5146375*y+7593840*y**2-6802304*y**3+1877949*y**4
          +9447733*y**5+17123750*y**6-6948028*y**7-10558281*y**8+4535771*y**9
          +1604542*y**10-649240*y**11+26063*y**12+14805*y**13)+2*r**8*(-1+y)**5*(3036158
          -1672336*y-8313900*y**2-38975472*y**3+13176878*y**4-4777353*y**5+9066008*y**6
          +36497761*y**7-36951784*y**8+12485457*y**9-2458680*y**10+1010143*y**11
          -204456*y**12+22376*y**13)+2*r**12*(-1+y)**3*(34291918-141360334*y
          +47786052*y**2+723756213*y**3-1619088094*y**4+1755361087*y**5-1121355988*y**6
          +328989836*y**7+24145026*y**8-41992916*y**9+12391120*y**10-242053*y**11
          -391698*y**12+73131*y**13)+r**18*(1056398631-5256193237*y+9764065413*y**2
          -8060178957*y**3+1846250196*y**4+1566980284*y**5-1182829714*y**6+286380076*y**7
          -32948227*y**8+28960809*y**9-25593055*y**10+6524641*y**11-389844*y**12
          +75384*y**13)+r**10*(-1+y)**4*(32749673+17914337*y+17820753*y**2+24401071*y**3
          -197020278*y**4-32536220*y**5+343205336*y**6-429125356*y**7+303150255*y**8
          -93945177*y**9+1592767*y**10+6228317*y**11-1174642*y**12+99764*y**13)
          +r**14*(-1+y)**2*(-980333987+3274073951*y-3114402030*y**2-2482304418*y**3
          +7630399835*y**4-6509679491*y**5+2500270736*y**6-93496564*y**7-433877253*y**8
          +199611325*y**9-19583762*y**10-1877962*y**11-42651*y**12+143871*y**13)
          +4*r**16*(372928225-2038977983*y+4409049373*y**2-4821440805*y**3+2459955716*y**4
          +491424323*y**5-1979948957*y**6+1697904087*y**7-680119694*y**8+44199094*y**9
          +66523002*y**10-24729530*y**11+3387625*y**12-181686*y**13+27210*y**14))
          -(-1+y)*(-1+r**2+y)**5*(5*r**34*(-1+y)**9+r**32*(-1+y)**6*(147-416*y
          +366*y**2-137*y**3+30*y**4)+r**30*(-1+y)**4*(-14206+68772*y-131619*y**2
          +123889*y**3-56443*y**4+8871*y**5-374*y**6+50*y**7)+r**28*(-1+y)**2*(
          -2296534+15141070*y-42259893*y**2+64242030*y**3-56860197*y**4+28844769*y**5
          -7505666*y**6+652086*y**7+39967*y**8+1453*y**9+35*y**10)-(-1+y)**12*(
          -1-8*y-36*y**2+435*y**3+2387*y**4+6166*y**5+6678*y**6+528*y**7-5951*y**8
          -5480*y**9+1422*y**10+597*y**11+245*y**12+58*y**13)+r**26*(-24878658
          +205149464*y-743058795*y**2+1539547841*y**3-1988207022*y**4+1627708068*y**5
          -809464741*y**6+205312499*y**7-3950495*y**8-9313345*y**9+1073720*y**10
          +74404*y**11+8855*y**12+605*y**13)+r**24*(-173072042+1334260826*y-4463756271*y**2
          +8334781722*y**3-9168990329*y**4+5428000913*y**5-635408280*y**6-1413261050*y**7
          +1016619420*y**8-288953152*y**9+29921983*y**10-313732*y**11+132315*y**12
          +24457*y**13+3620*y**14)-r**2*(-1+y)**10*(-3201-18875*y-65072*y**2
          -137044*y**3-151022*y**4+13618*y**5+165224*y**6+227676*y**7-13787*y**8
          -35729*y**9-92602*y**10+23926*y**11-4414*y**12-334*y**13+426*y**14
          +10*y**15)+r**16*(-1+y)**3*(3654957796-13686774546*y+16162690011*y**2
          +4323058915*y**3-24539344515*y**4+15109353756*y**5+4738173949*y**6-7824919920*y**7
          +1855116612*y**8+555540950*y**9-329946957*y**10+37832247*y**11+10824779*y**12
          -3249432*y**13+573045*y**14+110*y**15)-r**4*(-1+y)**9*(496934+2247516*y
          +6179619*y**2+7600157*y**3+4601799*y**4-4586184*y**5-1517830*y**6-120721*y**7
          +3361336*y**8-3308032*y**9-467225*y**10+499879*y**11-53733*y**12+11252*y**13
          -132*y**14+165*y**15)-r**6*(-1+y)**8*(-1517294-4241924*y-8117927*y**2
          +4370445*y**3-3384899*y**4-15659033*y**5-34178678*y**6-744926*y**7+29078984*y**8
          -15714346*y**9+353237*y**10-191903*y**11+3913*y**12+101431*y**13-13400*y**14
          +1120*y**15)-r**8*(-1+y)**7*(23496954+45517780*y+68275237*y**2-45179629*y**3
          +33081199*y**4+67923454*y**5+62480785*y**6-116834146*y**7-57189134*y**8
          +25405804*y**9+25681237*y**10-14759345*y**11+629869*y**12+439618*y**13
          -74323*y**14+4240*y**15)+r**22*(314616682-2396193636*y+7673272989*y**2
          -13710025343*y**3+15246227481*y**4-11060899773*y**5+5081194510*y**6-962668874*y**7
          -519971152*y**8+434050054*y**9-96750079*y**10-5140339*y**11+2054205*y**12
          +172315*y**13+63060*y**14+9900*y**15)-r**10*(-1+y)**6*(67519694-30340092*y
          -116476233*y**2-490003117*y**3+485963721*y**4+192043533*y**5+10976061*y**6
          +446124121*y**7-869253154*y**8+397765744*y**9-47073657*y**10-7570289*y**11
          -3111093*y**12+1323551*y**13-223515*y**14+9925*y**15)-r**14*(-1+y)**4*(791816922
          -2226893516*y+972033337*y**2+7568730365*y**3-19404892367*y**4+23145923143*y**5
          -14942294928*y**6+2826299664*y**7+2812817436*y**8-1725200094*y**9+226191185*y**10
          +38094389*y**11-20738711*y**12+3820019*y**13-596794*y**14+11550*y**15)
          +r**18*(-1+y)**2*(9259075220-44661677470*y+80370279281*y**2-60489076371*y**3
          -1739245537*y**4+38257018583*y**5-29969296639*y**6+9380917797*y**7+607955932*y**8
          -1408118994*y**9+366448217*y**10-38284311*y**11+5810537*y**12-1494991*y**13
          +387101*y**14+12045*y**15)-r**12*(-1+y)**5*(393820510-171394556*y-132064253*y**2
          -757245243*y**3+342064795*y**4-609938780*y**5+2899002528*y**6-3213788951*y**7
          +1687751164*y**8-324724884*y**9-112230045*y**10+54874623*y**11-15508421*y**12
          +2774124*y**13-438726*y**14+14515*y**15)+r**20*(-2392019886+17043145042*y
          -51379844019*y**2+82042281934*y**3-66151085194*y**4+6227375643*y**5+40374409618*y**6
          -39358651793*y**7+15224922223*y**8-330416376*y**9-1892384771*y**10+693708200*y**11
          -108186308*y**12+6911763*y**13-348500*y**14+167299*y**15+15125*y**16))))/(447897600*logy**5*r**20*(
          -1+y)**10-1800*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5+186624000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+31104000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+2592000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +108000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*muWC**2*(-6220800*logy**5*r**18*(-39-25*r**2+41*r**4
          +95*r**6+81*r**8)*(-1+y)**10-103680*logy**4*r**14*(-1+y)**6*(1613*r**16*(
          -1+y)**4+18*r**14*(297-1188*y+1782*y**2-1053*y**3+187*y**4+35*y**5)
          +r**12*(21667-62368*y+44952*y**2+33877*y**3-55053*y**4+21470*y**5
          -1800*y**6)-(-1+y)**4*(-1411+1050*y**3-195*y**4-24*y**5+40*y**6)
          -2*r**2*(-1+y)**4*(-1194+905*y**3+2120*y**4-1176*y**5+200*y**6)+r**10*(
          -5356+49924*y-131886*y**2+159174*y**3-82566*y**4+12165*y**5+2105*y**6
          +10*y**7)+5*r**8*(-4272+19548*y-34242*y**2+26450*y**3-459*y**4-13934*y**5
          +10370*y**6-3335*y**7+423*y**8)+r**6*(-13178+45212*y-52818*y**2+5442*y**3
          +53192*y**4-59507*y**5+23843*y**6+3068*y**7-5182*y**8+1008*y**9)+r**4*(7469
          -41576*y+85764*y**2-88381*y**3+43954*y**4+10506*y**5-44714*y**6+43121*y**7
          -19929*y**8+4066*y**9-280*y**10))-1728*logy**3*r**10*(-1+y)**4*(-1+r**2
          +y)**2*(3571*r**20*(-1+y)**6-2*r**18*(-1+y)**2*(-31287+128719*y-202006*y**2
          +141104*y**3-44231*y**4+4101*y**5)-r**16*(-1+y)**2*(-756917+2772838*y
          -3726455*y**2+2010700*y**3-256535*y**4-93588*y**5+8407*y**6)+5*(-1
          +y)**5*(1057+1057*y+1057*y**2-8515*y**3+5367*y**4-1449*y**5-2329*y**6
          +7571*y**7-5152*y**8+976*y**9)+2*r**14*(723020-4132542*y+9843606*y**2
          -11797581*y**3+6871162*y**4-942685*y**5-1032338*y**6+573924*y**7-107929*y**8
          +9238*y**9)+r**4*(-1+y)**4*(-581755+231194*y+46019*y**2+114244*y**3
          +436279*y**4-275726*y**5-246429*y**6+77556*y**7+82216*y**8-47784*y**9
          +5936*y**10)+2*r**2*(-1+y)**4*(-24219-5285*y-5285*y**2+70220*y**3
          -13795*y**4-297*y**5-16855*y**6-57005*y**7+86265*y**8-40620*y**9+5976*y**10)
          +r**12*(3509248-16666172*y+31472118*y**2-24919092*y**3+8243*y**4+13089702*y**5
          -8081153*y**6+1495922*y**7+209547*y**8-105148*y**9+13485*y**10)+2*r**6*(
          -1+y)**2*(-337216+664154*y-389410*y**2+518815*y**3+198460*y**4-1950408*y**5
          +1837022*y**6-199360*y**7-451735*y**8+216020*y**9-36271*y**10+1704*y**11)
          -2*r**10*(-872512+3757262*y-5845800*y**2+184515*y**3+10264825*y**4
          -12046561*y**5+4275531*y**6+1747300*y**7-2111390*y**8+740075*y**9-105177*y**10
          +4057*y**11)+r**8*(-705464+4156756*y-10524222*y**2+17912040*y**3-19831625*y**4
          +7514178*y**5+10329588*y**6-15141836*y**7+7677260*y**8-1173650*y**9
          -323664*y**10+119656*y**11-9017*y**12))+144*logy**2*r**6*(-1+y)**2*(-1
          +r**2+y)**3*(-163*r**26*(-1+y)**8+r**24*(-1+y)**4*(-11495+46469*y-70926*y**2
          +47524*y**3-13935*y**4+1139*y**5)+2*r**22*(-1+y)**2*(-225818+1308117*y
          -3139152*y**2+3967404*y**3-2775608*y**4+1017879*y**5-149190*y**6-3288*y**7
          +376*y**8)-2*r**20*(-1+y)**2*(1702992-9722283*y+23008800*y**2-28255981*y**3
          +18694843*y**4-6029229*y**5+384179*y**6+250411*y**7-40491*y**8+2184*y**9)
          -r**18*(-1+y)**2*(19792501-100732608*y+205857765*y**2-202428624*y**3
          +79978885*y**4+15546858*y**5-24262039*y**6+6728046*y**7-306952*y**8
          -15378*y**9+1446*y**10)+(-1+y)**8*(509+1527*y+3054*y**2-840*y**3
          -8396*y**4-13302*y**5+26802*y**6-16264*y**7+1055*y**8+15911*y**9-15392*y**10
          +4136*y**11)+r**2*(-1+y)**7*(-18649-38825*y-60528*y**2+148056*y**3
          +12604*y**4+100406*y**5+19878*y**6-185810*y**7+21899*y**8-19279*y**9
          +75988*y**10-35088*y**11+4848*y**12)+2*r**4*(-1+y)**6*(250006+183613*y
          +166312*y**2-1634605*y**3+1284682*y**4-482123*y**5-627737*y**6+1998911*y**7
          -1465730*y**8+252758*y**9+71347*y**10+1274*y**11-8198*y**12+940*y**13)
          -r**8*(-1+y)**4*(-15136091+30025181*y-14394282*y**2-7914616*y**3+38719555*y**4
          -46256571*y**5-601656*y**6+35766298*y**7-21002785*y**8+966965*y**9+2263952*y**10
          -608350*y**11+25859*y**12+1441*y**13)+2*r**6*(-1+y)**5*(-1071768+188259*y
          -68859*y**2+1527738*y**3+2317913*y**4-2963805*y**5-1499264*y**6-317745*y**7
          +3757011*y**8-2324263*y**9+261493*y**10+144670*y**11-32786*y**12+1756*y**13)
          -2*r**12*(-1+y)**2*(4323574-7849608*y-20067348*y**2+122418706*y**3
          -205124265*y**4+117457839*y**5+45362134*y**6-95274741*y**7+47413020*y**8
          -6805595*y**9-1707818*y**10+584899*y**11-54381*y**12+3384*y**13)+r**16*(
          -16910033+124577929*y-402351614*y**2+695588168*y**3-638042344*y**4
          +200724314*y**5+179217370*y**6-229465198*y**7+107523353*y**8-20624441*y**9
          -1296326*y**10+1258346*y**11-211578*y**12+7254*y**13)-r**10*(-1+y)**3*(2971615
          +296401*y-6882146*y**2-37836694*y**3+46975313*y**4+45642167*y**5-82306508*y**6
          +15408950*y**7+29560991*y**8-18287993*y**9+2908468*y**10+252542*y**11
          -112329*y**12+8223*y**13)+2*r**14*(-18823726+107437226*y-249473098*y**2
          +242239366*y**3+55304977*y**4-361852568*y**5+322337745*y**6-61077023*y**7
          -89663330*y**8+75546881*y**9-25589296*y**10+3584834*y**11+94396*y**12
          -68016*y**13+1632*y**14))-12*logy*r**4*(-1+y)**2*(-1+r**2+y)**4*(65*r**28*(
          -1+y)**8-r**26*(-1+y)**4*(-21967+84216*y-119150*y**2+70968*y**3-16063*y**4
          +106*y**5)-r**24*(-1+y)**2*(-811259+4675890*y-11143799*y**2+13878902*y**3
          -9551683*y**4+3535956*y**5-586549*y**6+10552*y**7+1788*y**8)-2*r**22*(
          -6516227+48236870*y-154404965*y**2+276955710*y**3-301240972*y**4+199260761*y**5
          -73565467*y**6+9694420*y**7+2349763*y**8-793417*y**9+19360*y**10+1704*y**11)
          +r**20*(43682021-312056476*y+963390540*y**2-1635067316*y**3+1606309825*y**4
          -846011884*y**5+117925880*y**6+120695152*y**7-73927405*y**8+16242924*y**9
          -1323438*y**10+108580*y**11+2317*y**12)-(-1+y)**9*(-403-2015*y-6045*y**2
          -9511*y**3-2076*y**4+19468*y**5-11656*y**6+6514*y**7+16703*y**8-19009*y**9
          +445*y**10-2159*y**11+2376*y**12+368*y**13)+r**18*(221732545-1436168728*y
          +3906749250*y**2-5551394236*y**3+3902033827*y**4-299549728*y**5-1685785490*y**6
          +1295514948*y**7-375927129*y**8+6955508*y**9+18894468*y**10-3161232*y**11
          +193137*y**12+14260*y**13)-r**2*(-1+y)**7*(-58049-163543*y-311986*y**2
          +246622*y**3+660193*y**4+989959*y**5-1551494*y**6+905030*y**7-371203*y**8
          -890941*y**9+1003180*y**10-290128*y**11+21951*y**12-5999*y**13+3608*y**14)
          -2*r**6*(-1+y)**5*(-6145597-1874847*y-1210936*y**2+33041582*y**3-33614549*y**4
          +11015316*y**5+14521912*y**6-48422080*y**7+42512695*y**8-7664829*y**9
          -5450304*y**10+2247630*y**11-70369*y**12-35752*y**13+5328*y**14)+r**8*(
          -1+y)**4*(-19129615+10821588*y-5278988*y**2-38300534*y**3+286169447*y**4
          -282972540*y**5-90945558*y**6+222344032*y**7-33539723*y**8-57749712*y**9
          +19117350*y**10+3021350*y**11-1702309*y**12+50392*y**13+7220*y**14)
          -r**4*(-1+y)**6*(921193+1616402*y+2270689*y**2-7065920*y**3+2249625*y**4
          -3790714*y**5-5550199*y**6+14921668*y**7-4849385*y**8-617498*y**9-1826319*y**10
          +1634252*y**11-248437*y**12-33190*y**13+10833*y**14)+r**16*(-33052953
          +121025868*y+108589746*y**2-681834422*y**3+477159537*y**4+717611072*y**5
          -1332694152*y**6+726504682*y**7+39738391*y**8-240149080*y**9+121528746*y**10
          -25794336*y**11+2050637*y**12+35376*y**13+17688*y**14)+r**12*(-1+y)**2*(150275715
          -679880250*y+963395229*y**2+485674132*y**3-2335084677*y**4+1659823610*y**5
          +326003517*y**6-837019688*y**7+223861105*y**8+111430178*y**9-64224645*y**10
          +6844188*y**11+173369*y**12-87042*y**13+20259*y**14)+r**10*(-1+y)**3*(187054223
          -484623535*y+349348778*y**2+123225342*y**3-627489743*y**4+653568569*y**5
          +96601374*y**6-684972712*y**7+492396665*y**8-86981821*y**9-44499062*y**10
          +21351586*y**11-2968521*y**12-50917*y**13+23774*y**14)+4*r**14*(54881901
          -215966982*y+185191461*y**2+625077214*y**3-1861407229*y**4+1913042711*y**5
          -346115108*y**6-1080093026*y**7+1124937333*y**8-474729314*y**9+59568247*y**10
          +24798570*y**11-10334785*y**12+1164223*y**13-18792*y**14+3576*y**15))
          -(-1+r**2+y)**5*(8*r**34*(-1+y)**10+r**32*(-1+y)**6*(-263+1012*y
          -1418*y**2+911*y**3-293*y**4+54*y**5)+r**30*(-1+y)**4*(8483-48843*y
          +115425*y**2-144354*y**3+102774*y**4-41545*y**5+9379*y**6-1114*y**7
          +113*y**8)-r**28*(-1+y)**2*(-566325+4307356*y-14219207*y**2+26426099*y**3
          -30070160*y**4+21342104*y**5-9143126*y**6+2084271*y**7-140853*y**8-20548*y**9
          +79*y**10+46*y**11)+r**26*(11399445-106867723*y+447203620*y**2-1095640329*y**3
          +1734214628*y**4-1846178799*y**5+1331497046*y**6-635085898*y**7+185348663*y**8
          -25623893*y**9-813612*y**10+571243*y**11-32964*y**12+8391*y**13-538*y**14)
          +r**24*(91826331-811744360*y+3176021155*y**2-7175238183*y**3+10208728261*y**4
          -9265956729*y**5+4993522273*y**6-1032263974*y**7-506729423*y**8+431782212*y**9
          -121356701*y**10+10477601*y**11+1048803*y**12-133575*y**13+19781*y**14
          -592*y**15)+2*(-1+y)**11*(5+30*y+105*y**2+335*y**3+335*y**4-285*y**5
          -69*y**6+105*y**7+730*y**8-727*y**9-234*y**10+584*y**11-390*y**12
          +50*y**13+22*y**14+4*y**15)+r**2*(-1+y)**10*(367+1785*y+5205*y**2
          +13760*y**3+6830*y**4-17702*y**5-7710*y**6+7407*y**7+34973*y**8-44495*y**9
          +14445*y**10+10098*y**11-11412*y**12+2812*y**13-700*y**14-65*y**15
          +2*y**16)+r**4*(-1+y)**9*(31177+118087*y+281233*y**2+223252*y**3-408250*y**4
          -1153639*y**5+1025729*y**6-590195*y**7+206943*y**8+799481*y**9-415367*y**10
          +48862*y**11-257178*y**12+111655*y**13-5131*y**14-1071*y**15+12*y**16)
          -r**6*(-1+y)**8*(1099575+2751401*y+4802777*y**2-7612474*y**3-8164028*y**4
          -12140821*y**5+17675899*y**6-9614768*y**7+6281498*y**8+11076779*y**9
          -15989987*y**10+6039742*y**11+138646*y**12-269559*y**13-9481*y**14+4788*y**15
          +13*y**16)-r**8*(-1+y)**7*(-8999871-11895977*y-14324031*y**2+57857322*y**3
          -52943052*y**4+28926754*y**5+113239994*y**6-255375661*y**7+121105725*y**8
          +27738145*y**9-18715887*y**10-4282718*y**11+2841482*y**12-1282*y**13
          -71348*y**14+9289*y**15+316*y**16)+r**16*(-1+y)**3*(-2768498485+11428662361*y
          -16162679181*y**2+2443346222*y**3+15938110024*y**4-12827617728*y**5-3737202352*y**6
          +9535198189*y**7-4243972233*y**8-128131841*y**9+686967689*y**10-202369398*y**11
          +16299592*y**12+439616*y**13-330228*y**14+66979*y**15+374*y**16)+r**22*(105255331
          -880981763*y+3296733613*y**2-6968988314*y**3+8645681348*y**4-5510355637*y**5
          -84940405*y**6+3218801260*y**7-2728475466*y**8+1122379319*y**9-236727755*y**10
          +25697398*y**11-5751558*y**12+1727305*y**13-82957*y**14+23856*y**15
          +825*y**16)-r**10*(-1+y)**6*(89547609-19051129*y-15329285*y**2-426596740*y**3
          +491963202*y**4-140475324*y**5-65911236*y**6+299505091*y**7-434484647*y**8
          +144165311*y**9+86453973*y**10-57389322*y**11+8191614*y**12+768542*y**13
          -31748*y**14+2867*y**15+1222*y**16)-r**14*(-1+y)**4*(1319512207-3828716431*y
          +3202724577*y**2-690293030*y**3+1232236444*y**4-2917987635*y**5+2932287637*y**6
          -2117907762*y**7+1156424628*y**8-235866061*y**9-194293817*y**10+121680366*y**11
          -16435060*y**12-397393*y**13+581547*y**14-58630*y**15+2013*y**16)-r**12*(
          -1+y)**5*(74827495-109583927*y-75815513*y**2-934551800*y**3+3729274306*y**4
          -3587464939*y**5-578442371*y**6+2819201303*y**7-1450775139*y**8-81722557*y**9
          +259897037*y**10-59519554*y**11+2230700*y**12+719399*y**13+296911*y**14
          -24853*y**15+2302*y**16)+r**18*(-1+y)**2*(-1854491699+10879970883*y
          -25137236841*y**2+29644225432*y**3-16398327398*y**4-2504493270*y**5+11861882754*y**6
          -10016493831*y**7+4512509483*y**8-988540133*y**9-66278733*y**10+103967830*y**11
          -19813128*y**12+206920*y**13+127556*y**14+46937*y**15+2838*y**16)+r**20*(1173082541
          -9424739978*y+32845649634*y**2-63617572601*y**3+71030877762*y**4-37419667805*y**5
          -9582341144*y**6+29917936080*y**7-20343170774*y**8+5226641506*y**9+1039480492*y**10
          -1129266099*y**11+319716780*y**12-37931875*y**13+1143122*y**14+134452*y**15
          +25091*y**16+2816*y**17))))/(-167961600*logy**5*r**20*(-1+y)**10+675*(r**8*(
          -1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5-69984000*logy**4*r**16*(
          -1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -11664000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2-972000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3-40500*logy*(
          -1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(
          -4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2
          +y**3))**4))
      resNP += ((mupi*(6220800*logy**5*r**18*(30+61*r**2+82*r**4+79*r**6+54*r**8)*(
          -1+y)**10+103680*logy**4*r**14*(-1+y)**6*(118*r**16*(-1+y)**4-2*(-1
          +y)**5*(-143-143*y-143*y**2+2407*y**3-1268*y**4+160*y**5)-3*r**14*(
          -1399+5596*y-8394*y**2+5416*y**3-2239*y**4+300*y**5)+r**12*(17294
          -52976*y+47064*y**2+8669*y**3-22506*y**4+8305*y**5-360*y**6)-r**2*(
          -1+y)**4*(1719-12025*y**3+17765*y**4-6954*y**5+800*y**6)+r**10*(5431
          +1976*y-50364*y**2+87951*y**3-41709*y**4-195*y**5+4630*y**6-580*y**7)
          +5*r**8*(-744+7896*y-21684*y**2+22756*y**3-2334*y**4-10159*y**5+6892*y**6
          -1615*y**7+90*y**8)+r**6*(-10213+59152*y-125328*y**2+103572*y**3+1372*y**4
          -38047*y**5+208*y**6+19903*y**7-9827*y**8+1368*y**9)+r**4*(-11102+53408*y
          -98112*y**2+75403*y**3-27952*y**4+52512*y**5-99808*y**6+83707*y**7
          -33738*y**8+6002*y**9-320*y**10))-3456*logy**3*r**10*(-1+y)**4*(-1+r**2
          +y)**2*(887*r**20*(-1+y)**6+r**18*(-1+y)**2*(-4473+16118*y-19742*y**2
          +5908*y**3-6697*y**4+1686*y**5)-r**16*(-1+y)**2*(100301-394216*y+578273*y**2
          -369247*y**3+158243*y**4-36423*y**5+4619*y**6)+r**14*(-527974+2843658*y
          -6220251*y**2+6697599*y**3-3896297*y**4+1417454*y**5-347768*y**6+25701*y**7
          -11164*y**8+3292*y**9)-(-1+y)**5*(827+827*y+827*y**2-5753*y**3+3957*y**4
          -3987*y**5-25187*y**6+51313*y**7-30032*y**8+5408*y**9)+r**12*(-1683922
          +8242214*y-15852960*y**2+13290141*y**3-3403853*y**4-876048*y**5+49601*y**6
          +225010*y**7+14619*y**8-35927*y**9+4425*y**10)-r**4*(-1+y)**4*(74861
          -16648*y-1969*y**2-1270955*y**3+2166169*y**4-1156634*y**5+300243*y**6
          -264576*y**7+193420*y**8-57744*y**9+5408*y**10)-r**2*(-1+y)**4*(9663
          -1654*y-1654*y**2-129419*y**3+196576*y**4-80370*y**5+160399*y**6-344926*y**7
          +271989*y**8-94356*y**9+11952*y**10)+r**10*(-1745024+8731870*y-17169657*y**2
          +14365203*y**3-3687862*y**4+1520356*y**5-5379207*y**6+4890332*y**7-1709428*y**8
          +120637*y**9+54168*y**10-7138*y**11)+r**6*(-1+y)**2*(-243634+594794*y
          -444007*y**2+2278813*y**3-8830022*y**4+12399531*y**5-7931635*y**6+2128247*y**7
          -63748*y**8-16738*y**9-19807*y**10+4656*y**11)+r**8*(-1119862+5672546*y
          -11418984*y**2+11341755*y**3-10328995*y**4+18324654*y**5-24992622*y**6
          +18195398*y**7-6403280*y**8+469445*y**9+344658*y**10-91924*y**11+7211*y**12))
          -288*logy**2*r**6*(-1+y)**2*(-1+r**2+y)**3*(83*r**26*(-1+y)**8-r**24*(
          -1+y)**4*(-4132+16777*y-25788*y**2+18788*y**3-4620*y**4+199*y**5)
          -r**22*(-1+y)**2*(-41243+228171*y-519387*y**2+620229*y**3-359309*y**4
          +25305*y**5+63123*y**6-19401*y**7+1072*y**8)+r**20*(-1+y)**2*(-661599
          +3704124*y-8465721*y**2+9895586*y**3-6920663*y**4+3501744*y**5-1210906*y**6
          +173518*y**7-8289*y**8+1356*y**9)+r**18*(-1+y)**2*(-2828140+15077331*y
          -32607864*y**2+35038311*y**3-20720494*y**4+8146911*y**5-2572913*y**6
          +275619*y**7+56701*y**8-27732*y**9+2370*y**10)+(-1+y)**8*(263+789*y
          +1578*y**2-84*y**3-3020*y**4-6426*y**5+5058*y**6-4468*y**7+4949*y**8
          +7565*y**9-10412*y**10+3008*y**11)+r**2*(-1+y)**7*(-3022-6833*y-11433*y**2
          +24636*y**3+3490*y**4+40340*y**5+130995*y**6-177395*y**7+15299*y**8
          -51040*y**9+94297*y**10-38682*y**11+4848*y**12)-r**10*(-1+y)**3*(-4176149
          +12880111*y-13716782*y**2+38849954*y**3-175933297*y**4+296388851*y**5
          -219714698*y**6+62433704*y**7+10034192*y**8-10353518*y**9+1974253*y**10
          -34633*y**11-34137*y**12+1149*y**13)+r**4*(-1+y)**6*(7133-12784*y
          -16237*y**2+174610*y**3+95774*y**4-211426*y**5-2632591*y**6+5160442*y**7
          -3409813*y**8+937546*y**9-187912*y**10+107380*y**11-32230*y**12+3008*y**13)
          -r**8*(-1+y)**4*(1828270-3070069*y+1175538*y**2-35530744*y**3+116765770*y**4
          -132916905*y**5+65909676*y**6-16287770*y**7+9266189*y**8-7481275*y**9
          +2411420*y**10-171292*y**11-47083*y**12+3175*y**13)-r**16*(9762269-65683999*y
          +187120988*y**2-279730844*y**3+230609782*y**4-105524606*y**5+31422686*y**6
          -10151834*y**7+867664*y**8+2090333*y**9-1067068*y**10+350488*y**11-64749*y**12
          +3690*y**13)+r**6*(-1+y)**5*(600849-349350*y-122274*y**2-8231724*y**3
          +15613933*y**4-9538860*y**5+8853182*y**6-18241974*y**7+17290452*y**8
          -7026113*y**9+831701*y**10+212153*y**11-55447*y**12+4172*y**13)+r**12*(
          -1+y)**2*(-19824350+91787448*y-161692320*y**2+101320420*y**3-27987354*y**4
          +105103818*y**5-169442108*y**6+99615066*y**7-15256563*y**8-7952846*y**9
          +3082792*y**10-48170*y**11-72741*y**12+7308*y**13)+r**14*(-26470250
          +168013462*y-443255390*y**2+581032238*y**3-339037144*y**4+7458188*y**5
          +45200574*y**6+51330452*y**7-65918071*y**8+25538950*y**9-4346588*y**10
          +607804*y**11-181207*y**12+26778*y**13+204*y**14))-12*logy*r**4*(-1
          +y)**2*(-1+r**2+y)**4*(53*r**28*(-1+y)**8+2*r**26*(-1+y)**4*(12311-47358*y
          +67318*y**2-42555*y**3+8375*y**4+19*y**5)+r**24*(-1+y)**2*(314249-1781874*y
          +4177769*y**2-5266166*y**3+3506425*y**4-897810*y**5-71651*y**6+37706*y**7
          +948*y**8)+2*r**22*(-490030+4333384*y-16386280*y**2+35013060*y**3-48894140*y**4
          +49110631*y**5-36067994*y**6+17812046*y**7-5025118*y**8+611143*y**9
          -24262*y**10+2640*y**11)+r**20*(-26324311+183584264*y-544034868*y**2
          +871826584*y**3-823680287*y**4+489486038*y**5-202391428*y**6+59765764*y**7
          -5839117*y**8-2580606*y**9+195360*y**10+43276*y**11+7891*y**12)+(-1
          +y)**9*(-623-3115*y-9345*y**2-14507*y**3-11484*y**4+8048*y**5-14*y**6
          +19604*y**7+15751*y**8-20141*y**9-1765*y**10-5161*y**11+3816*y**12
          +736*y**13)+2*r**18*(-22859971+154147918*y-444615372*y**2+691134625*y**3
          -626604715*y**4+354129520*y**5-145961446*y**6+40940559*y**7+14524767*y**8
          -21942530*y**9+8680866*y**10-1833102*y**11+155703*y**12+1778*y**13)
          +2*r**2*(-1+y)**7*(-23771-66247*y-125518*y**2+60925*y**3+247396*y**4
          +487393*y**5-111884*y**6+130271*y**7-438094*y**8-500281*y**9+741628*y**10
          -234694*y**11+26487*y**12-10211*y**13+3800*y**14)+r**16*(-175355427
          +1059670572*y-2621926050*y**2+3007019974*y**3-1336276917*y**4+595016*y**5
          -288500346*y**6+642346798*y**7-380696993*y**8+121522076*y**9-34287744*y**10
          +4214424*y**11+252317*y**12-63516*y**13+12216*y**14)+2*r**6*(-1+y)**5*(251230
          +593694*y+550546*y**2-15025442*y**3+10108760*y**4-1651839*y**5+62828471*y**6
          -136885373*y**7+108158189*y**8-33632529*y**9+2208639*y**10-319845*y**11
          +668617*y**12-162482*y**13+19764*y**14)+2*r**10*(-1+y)**3*(11818351
          -23208821*y+16031284*y**2-389703477*y**3+1497512732*y**4-2014834748*y**5
          +1133795943*y**6-151825820*y**7-105946595*y**8+27586807*y**9+11423882*y**10
          -5716867*y**11+1174236*y**12-111158*y**13+20251*y**14)+r**4*(-1+y)**6*(
          -94381-153782*y-143629*y**2-195376*y**3+2101623*y**4-1229192*y**5
          -17556017*y**6+23595122*y**7-7479307*y**8+5195204*y**9-8533527*y**10
          +4418374*y**11-577103*y**12-87422*y**13+25413*y**14)+r**8*(-1+y)**4*(
          -22780501+26145984*y+2400112*y**2+278738398*y**3-719205583*y**4+558987246*y**5
          -299859192*y**6+466935916*y**7-541338755*y**8+271776720*y**9-34826580*y**10
          -16058242*y**11+5757767*y**12-535118*y**13+37028*y**14)+r**12*(-1+y)**2*(
          -59090097+246869478*y-371784687*y**2+375983236*y**3-1927177905*y**4
          +4398492374*y**5-4102362999*y**6+1437834100*y**7+257152045*y**8-373991050*y**9
          +98737803*y**10-2081304*y**11-916003*y**12-128946*y**13+53955*y**14)
          +4*r**14*(-109763802+650029632*y-1569909096*y**2+1734352240*y**3-546958750*y**4
          -449681815*y**5+161704246*y**6+344478076*y**7-271275846*y**8+52801480*y**9
          +5098228*y**10+1247802*y**11-2981290*y**12+970231*y**13-121770*y**14
          +10434*y**15))+(-1+r**2+y)**5*(13*r**34*(-1+y)**10+r**32*(-1+y)**6*(
          -421+1619*y-2266*y**2+1453*y**3-469*y**4+90*y**5)+r**30*(-1+y)**4*(916
          -4092*y+5193*y**2-1110*y**3+1680*y**4-7484*y**5+7163*y**6-1826*y**7
          +196*y**8)-r**28*(-1+y)**2*(654360-4936240*y+16107659*y**2-29734469*y**3
          +33809975*y**4-23947760*y**5+10074023*y**6-2196252*y**7+166317*y**8
          +1312*y**9+434*y**10+113*y**11)+r**26*(958764-10385468*y+49336667*y**2
          -135630756*y**3+245613643*y**4-319963680*y**5+316420309*y**6-237278528*y**7
          +126593536*y**8-42467500*y**9+6873639*y**10+44276*y**11-127983*y**12
          +13080*y**13-1439*y**14)+r**24*(10765032-101481248*y+424265843*y**2
          -1037545629*y**3+1682750543*y**4-1978843140*y**5+1799011163*y**6-1278767318*y**7
          +671863460*y**8-237670272*y**9+53968367*y**10-10633097*y**11+2679333*y**12
          -382308*y**13+28387*y**14-3356*y**15)+(-1+y)**11*(17+102*y+357*y**2
          +1067*y**3+1463*y**4+471*y**5-357*y**6-1146*y**7+673*y**8-418*y**9
          +657*y**10-115*y**11-561*y**12+125*y**13+55*y**14+10*y**15)+r**22*(168892076
          -1420685116*y+5220817097*y**2-10768836310*y**3+13419804400*y**4-10041207680*y**5
          +3890519707*y**6+143935490*y**7-1243092270*y**8+999648556*y**9-499904593*y**10
          +156336374*y**11-30550092*y**12+4695920*y**13-391571*y**14+15102*y**15
          -4290*y**16)+r**2*(-1+y)**10*(629+3060*y+8925*y**2+23110*y**3+19210*y**4
          -10594*y**5-20802*y**6-12294*y**7+34507*y**8-23620*y**9+20145*y**10
          -7938*y**11-4596*y**12+2738*y**13-1100*y**14-190*y**15+10*y**16)+r**4*(
          -1+y)**9*(46304+174680*y+414353*y**2+412412*y**3-187706*y**4-1221377*y**5
          -107264*y**6-677467*y**7+840855*y**8+1000006*y**9-410191*y**10-21334*y**11
          -397056*y**12+169403*y**13-1370*y**14-3171*y**15+123*y**16)+r**6*(-1
          +y)**8*(-412140-886900*y-1393189*y**2+4719950*y**3+5047096*y**4+8927480*y**5
          +3359437*y**6-2682986*y**7-9612718*y**8-15457084*y**9+26232037*y**10
          -10567358*y**11+360220*y**12+152088*y**13+92243*y**14-18822*y**15+646*y**16)
          +r**16*(-1+y)**3*(-792996686+3148758164*y-4331099247*y**2+432518902*y**3
          +1808652878*y**4+3809620743*y**5-7422523001*y**6+3523031903*y**7+179326398*y**8
          -546735304*y**9+149452777*y**10-5040930*y**11+10361024*y**12-8153675*y**13
          +1620711*y**14-216139*y**15+682*y**16)-r**18*(-1+y)**2*(-1035016886
          +5971494516*y-13822699191*y**2+13390125694*y**3-1726367306*y**4-5825162754*y**5
          +3035961546*y**6+429158754*y**7-592042567*y**8+262668892*y**9-150989883*y**10
          +41498182*y**11-18982968*y**12+6954418*y**13-1273096*y**14+139898*y**15
          +1551*y**16)+r**8*(-1+y)**7*(-3840384-4837016*y-4496193*y**2+38390280*y**3
          +29203356*y**4+3069889*y**5-228891769*y**6+350046707*y**7-167786994*y**8
          +50236636*y**9-62136141*y**10+38965288*y**11-7515274*y**12-1033261*y**13
          +467743*y**14-63179*y**15+1912*y**16)+r**14*(-1+y)**4*(-246467156+625119308*y
          -287294973*y**2-2618170346*y**3+11280200452*y**4-18293478420*y**5+12878146279*y**6
          -1994737506*y**7-2806002348*y**8+1884041828*y**9-279049199*y**10-103275966*y**11
          +42606404*y**12-9842716*y**13+1460325*y**14-246070*y**15+2904*y**16)
          +r**10*(-1+y)**6*(-6207588+4121060*y+6329941*y**2-214467778*y**3+366404946*y**4
          -150080886*y**5+747577860*y**6-1839948062*y**7+1821525643*y**8-698902660*y**9
          -15949587*y**10+65474334*y**11-4637184*y**12-4772410*y**13+1007434*y**14
          -138574*y**15+3511*y**16)+r**12*(-1+y)**5*(-191273576+294075304*y-22349783*y**2
          +1571491324*y**3-5093702102*y**4+4861222487*y**5-1780490810*y**6+1135032461*y**7
          -1620569031*y**8+1080855950*y**9-212671747*y**10-67560754*y**11+37225292*y**12
          -9484333*y**13+1311892*y**14-214279*y**15+4105*y**16)-r**20*(46392176
          -436336328*y+1694368563*y**2-3482717447*y**3+3520745190*y**4+323405851*y**5
          -6156982193*y**6+9055941363*y**7-7034593502*y**8+3148878265*y**9-758907071*y**10
          +81617811*y**11+2410866*y**12-5101231*y**13+1191725*y**14-363791*y**15
          +46310*y**16+3443*y**17))))/(-447897600*logy**5*r**20*(-1+y)**10+1800*(r**8*(
          -1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5-186624000*logy**4*r**16*(
          -1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -31104000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2-2592000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3-108000*logy*(
          -1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(
          -4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2
          +y**3))**4))
      resNP += ((rhoLS*(6220800*logy**5*r**16*(-36+142*r**2+357*r**4+410*r**6
          +251*r**8+54*r**10)*(-1+y)**10-103680*logy**4*r**12*(-1+y)**6*(3658*r**18*(
          -1+y)**4-4*(-1+y)**5*(-17-17*y-17*y**2+373*y**3-272*y**4+40*y**5)
          +9*r**16*(-533+2132*y-3198*y**2+3032*y**3-1453*y**4+260*y**5)-5*r**14*(9038
          -32912*y+42888*y**2-25879*y**3+5454*y**4+241*y**5+72*y**6)+2*r**2*(
          -1+y)**4*(571-3230*y**3+5035*y**4-2076*y**5+240*y**6)+5*r**4*(-1+y)**3*(221
          -2381*y+1080*y**2+5085*y**3-8370*y**4+5847*y**5-1874*y**6+176*y**7)
          +r**12*(-67447+194488*y-141132*y**2-45127*y**3+97633*y**4-28305*y**5
          -3710*y**6+740*y**7)-r**10*(13232+70072*y-351108*y**2+480492*y**3
          -256398*y**4+14745*y**5+31180*y**6-8875*y**7+1170*y**8)+r**8*(59177
          -343808*y+729912*y**2-701108*y**3+257992*y**4+56083*y**5-74872*y**6
          +19833*y**7-257*y**8-792*y**9)+r**6*(67862-314048*y+556272*y**2-465123*y**3
          +171072*y**4-23232*y**5+31328*y**6-39827*y**7+19698*y**8-4162*y**9
          +160*y**10))+3456*logy**3*r**8*(-1+y)**4*(-1+r**2+y)**2*(-5191*r**22*(
          -1+y)**6+r**20*(-1+y)**2*(-69215+287242*y-456818*y**2+321372*y**3
          -101583*y**4+11802*y**5)+r**18*(-1+y)**2*(-587951+2061656*y-2602167*y**2
          +1136863*y**3+78543*y**4-137801*y**5+9307*y**6)-2*(-1+y)**7*(269+807*y
          +1614*y**2+70*y**3-175*y**4-1089*y**5+128*y**6+176*y**7)+r**16*(916356
          -4475702*y+8098725*y**2-7429445*y**3+3913481*y**4-1403926*y**5+706802*y**6
          -524195*y**7+209990*y**8-27836*y**9)+r**2*(-1+y)**5*(-469-1545*y-2621*y**2
          -3577*y**3+13957*y**4-4391*y**5-11915*y**6+26561*y**7-17608*y**8+3408*y**9)
          +r**14*(5612278-28924466*y+58546176*y**2-59658171*y**3+29359753*y**4
          -1500708*y**5-5670149*y**6+2673284*y**7-549519*y**8+93807*y**9-8985*y**10)
          +r**4*(-1+y)**4*(19947+10174*y+7708*y**2+76727*y**3-307124*y**4+259406*y**5
          +52861*y**6-237348*y**7+165033*y**8-52616*y**9+7032*y**10)+r**8*(-1
          +y)**2*(659226-444406*y-961943*y**2-3638663*y**3+13028882*y**4-16175645*y**5
          +10399499*y**6-3420297*y**7+367848*y**8+63528*y**9-10971*y**10+192*y**11)
          +r**6*(-1+y)**3*(-474569+553381*y-81315*y**2+1405948*y**3-3869154*y**4
          +4113447*y**5-2106585*y**6+548665*y**7-132098*y**8+66204*y**9-21228*y**10
          +2704*y**11)+r**12*(8500172-43823266*y+89857359*y**2-93576837*y**3
          +47635362*y**4-2442688*y**5-11100603*y**6+6424566*y**7-1812588*y**8
          +386963*y**9-71584*y**10+7394*y**11)+r**10*(5682802-28678430*y+58421784*y**2
          -63814473*y**3+43429407*y**4-23737302*y**5+15122982*y**6-9820426*y**7
          +4170048*y**8-703957*y**9-135850*y**10+69698*y**11-6283*y**12))-288*logy**2*r**4*(
          -1+y)**2*(-1+r**2+y)**3*(163*r**28*(-1+y)**8-r**26*(-1+y)**4*(-17920
          +72169*y-109476*y**2+72612*y**3-20360*y**4+1751*y**5)+r**24*(-1+y)**2*(595515
          -3440463*y+8231379*y**2-10347303*y**3+7154241*y**4-2558853*y**5+357817*y**6
          +6043*y**7+184*y**8)+2*(-1+y)**10*(-41-205*y-615*y**2-953*y**3-611*y**4
          +901*y**5+955*y**6+425*y**7-1232*y**8+376*y**9)+r**22*(-1+y)**2*(2611775
          -14832828*y+35037849*y**2-42190874*y**3+26187379*y**4-6921060*y**5
          -426964*y**6+635526*y**7-117525*y**8+7572*y**9)+r**2*(-1+y)**8*(-787
          -2607*y-5706*y**2+4760*y**3+3476*y**4+11346*y**5-8498*y**6+6096*y**7
          -1425*y**8-5771*y**9+2716*y**10)-r**20*(-1+y)**2*(-12085798+58346055*y
          -111292866*y**2+92534925*y**3-11423308*y**4-34003113*y**5+22242019*y**6
          -4627623*y**7+169363*y**8-23112*y**9+3558*y**10)+r**4*(-1+y)**7*(45704
          +74647*y+97005*y**2-272698*y**3-14068*y**4-85366*y**5+289153*y**6
          -136173*y**7-61737*y**8+45198*y**9+6257*y**10-4590*y**11+168*y**12)
          +r**18*(-38024583+249119187*y-672285900*y**2+981509024*y**3-836695526*y**4
          +403422490*y**5-88181718*y**6+4769962*y**7-9932414*y**8+6414131*y**9
          +1244968*y**10-1694124*y**11+354153*y**12-14850*y**13)-r**10*(-1+y)**4*(15705286
          -26700037*y+9685350*y**2-41161192*y**3+130120750*y**4-169829073*y**5
          +111850704*y**6-34416694*y**7+2611469*y**8+273085*y**9+137752*y**10
          +29088*y**11-20651*y**12+863*y**13)+r**6*(-1+y)**6*(-100861-204328*y
          -273523*y**2+689182*y**3+319042*y**4-447110*y**5-1132759*y**6+2417578*y**7
          -1746691*y**8+659518*y**9-222114*y**10+91872*y**11-21610*y**12+1504*y**13)
          +r**12*(-1+y)**3*(10230433-8071895*y-18329450*y**2-79295758*y**3+304871237*y**4
          -414873043*y**5+307662702*y**6-120814992*y**7+10310416*y**8+10422058*y**9
          -4004405*y**10+560073*y**11-43803*y**12+2427*y**13)+r**8*(-1+y)**5*(2133925
          -312042*y+36534*y**2-3038074*y**3-2064001*y**4+4784064*y**5+3506670*y**6
          -12089366*y**7+10913452*y**8-4580709*y**9+713621*y**10+90827*y**11-39693*y**12
          +3292*y**13)+r**14*(-1+y)**2*(-91455906+435868320*y-815316384*y**2
          +790421860*y**3-384601074*y**4+3613362*y**5+111690168*y**6-62378602*y**7
          +17164001*y**8-4284766*y**9+337924*y**10+524962*y**11-192069*y**12+17604*y**13)
          +r**16*(-112061604+753447096*y-2117928102*y**2+3226429830*y**3-2767783440*y**4
          +1033509648*y**5+404181822*y**6-729628832*y**7+415491135*y**8-121076808*y**9
          +14128376*y**10+2269812*y**11-1073151*y**12+87510*y**13+6708*y**14))
          -12*logy*r**2*(-1+y)**2*(-1+r**2+y)**4*(-175*r**30*(-1+y)**8-2*r**28*(
          -1+y)**4*(-30727+118646*y-169270*y**2+101029*y**3-22127*y**4+559*y**5)
          -r**26*(-1+y)**2*(-2426133+13933930*y-33055733*y**2+40892170*y**3-27767465*y**4
          +10047298*y**5-1678681*y**6+72906*y**7+1304*y**8)+8*(-1+y)**10*(-11
          -66*y-231*y**2-513*y**3-589*y**4+27*y**5+555*y**6+691*y**7-272*y**8
          -101*y**9-196*y**10+106*y**11)+2*r**24*(14020806-102414920*y+322729936*y**2
          -566047688*y**3+593023720*y**4-364647299*y**5+111380914*y**6-307452*y**7
          -9831670*y**8+2174865*y**9-78554*y**10+2262*y**11)+r**22*(36576421-259909560*y
          +812877196*y**2-1368289032*y**3+1244461541*y**4-470072398*y**5-148170752*y**6
          +239728584*y**7-111576405*y**8+28782502*y**9-4982220*y**10+504760*y**11
          +10803*y**12)+2*r**20*(128807829-797205418*y+2039914548*y**2-2554179873*y**3
          +1106501397*y**4+1063947704*y**5-1752480622*y**6+968421871*y**7-184817697*y**8
          -39651442*y**9+25106082*y**10-4673100*y**11+406631*y**12+3490*y**13)
          +r**2*(-1+y)**8*(-10093-36788*y-84978*y**2-20914*y**3+132361*y**4
          +337412*y**5-123578*y**6-130746*y**7-270975*y**8+383756*y**9-123784*y**10
          -12024*y**11+7759*y**12+224*y**13+368*y**14)+2*r**4*(-1+y)**7*(38125
          +113881*y+229770*y**2-242285*y**3-85346*y**4-411043*y**5+513872*y**6
          -500177*y**7-86406*y**8+565559*y**9-344052*y**10+51292*y**11+25717*y**12
          -13159*y**13+2652*y**14)+2*r**8*(-1+y)**5*(3304082+5590482*y+6234726*y**2
          -21610458*y**3+3049944*y**4+6748307*y**5+17574997*y**6-54754653*y**7
          +56343857*y**8-28709145*y**9+9398831*y**10-3170589*y**11+1041217*y**12
          -190704*y**13+17906*y**14)+r**6*(-1+y)**6*(-2825977-3762174*y-4311273*y**2
          +18935760*y**3-2661389*y**4+771708*y**5-18813689*y**6+13320618*y**7
          +3248081*y**8-2391172*y**9-2438731*y**10+1459918*y**11-2155*y**12-107986*y**13
          +18861*y**14)+r**18*(-1246594455+7583627452*y-18593648650*y**2+23466190610*y**3
          -14728746045*y**4+1248254032*y**5+4813609078*y**6-3343724122*y**7+835204747*y**8
          -55339404*y**9+54797648*y**10-37523740*y**11+5400637*y**12+68868*y**13
          +26544*y**14)+2*r**12*(-1+y)**3*(194898159-437890125*y+264547212*y**2
          -540536279*y**3+1865065686*y**4-2881246210*y**5+2297434501*y**6-807592568*y**7
          -83763095*y**8+168743291*y**9-55683834*y**10+6328379*y**11+1387926*y**12
          -599516*y**13+62473*y**14)+r**10*(-1+y)**4*(-84823185+71422944*y+4572048*y**2
          +105563458*y**3-55306767*y**4+9940178*y**5-203536892*y**6+428717956*y**7
          -427672295*y**8+209891192*y**9-30143508*y**10-14160382*y**11+6607431*y**12
          -1004858*y**13+66280*y**14)+r**14*(-1+y)**2*(127176323-836493202*y
          +1446987197*y**2+1125709364*y**3-5991721901*y**4+7776298902*y**5-5424911219*y**6
          +2065158148*y**7-18078551*y**8-362878722*y**9+115577215*y**10+1125576*y**11
          -3015895*y**12-574338*y**13+155103*y**14)+4*r**16*(-443634724+2853650952*y
          -7596303828*y**2+10795706082*y**3-8073511306*y**4+1078348451*y**5+4156174546*y**6
          -4543676010*y**7+2254254768*y**8-449456404*y**9-92464400*y**10+77814872*y**11
          -18441082*y**12+1608265*y**13-95190*y**14+25008*y**15))-(-1+r**2+y)**5*(19*r**34*(
          -1+y)**10+r**32*(-1+y)**6*(-635+2445*y-3430*y**2+2207*y**3-707*y**4
          +126*y**5)+r**30*(-1+y)**4*(6264-36604*y+87315*y**2-110954*y**3+83256*y**4
          -38756*y**5+12713*y**6-2854*y**7+256*y**8)-r**28*(-1+y)**2*(-1955284
          +14935164*y-49507251*y**2+92438117*y**3-105780659*y**4+75688340*y**5
          -33016043*y**6+8032708*y**7-827549*y**8-10384*y**9+2242*y**10+71*y**11)
          +r**26*(27126240-251218116*y+1036826805*y**2-2496757644*y**3+3860356085*y**4
          -3971840304*y**5+2717494259*y**6-1186171008*y**7+289300948*y**8-19335396*y**9
          -7066791*y**10+1298236*y**11-22049*y**12+8008*y**13-713*y**14)-(-1
          +y)**11*(-107-642*y-2247*y**2-4577*y**3-5333*y**4-741*y**5+2655*y**6
          +4446*y**7-43*y**8+1222*y**9-699*y**10-1943*y**11+771*y**12+25*y**13
          +11*y**14+2*y**15)+r**24*(172380308-1502890652*y+5789713581*y**2-12806729627*y**3
          +17610881449*y**4-14974204596*y**5+6801814917*y**6-87113890*y**7-1823233056*y**8
          +1067612564*y**9-279079167*y**10+32271913*y**11-1633773*y**12+205076*y**13
          +9725*y**14+988*y**15)-r**2*(-1+y)**10*(-1471-7876*y-24663*y**2-46730*y**3
          -87190*y**4-112786*y**5-13938*y**6+60170*y**7+155887*y**8-40556*y**9
          +3357*y**10-73858*y**11+45188*y**12-5502*y**13-1044*y**14-190*y**15
          +2*y**16)-r**4*(-1+y)**9*(-214716-729872*y-1583227*y**2-163020*y**3
          +2189958*y**4+5004103*y**5-3706220*y**6-1300911*y**7-2428093*y**8+5707198*y**9
          -2445387*y**10-314998*y**11+309248*y**12-34717*y**13+4154*y**14-3175*y**15
          +75*y**16)-r**6*(-1+y)**8*(441344+1353620*y+2923895*y**2-7714322*y**3
          +1780008*y**4-4293160*y**5+7786257*y**6-13105762*y**7-2262854*y**8+21872924*y**9
          -16879295*y**10+3566770*y**11+1111652*y**12-790024*y**13+167703*y**14
          -22654*y**15+698*y**16)+r**16*(-1+y)**3*(-2186466974+10068196004*y
          -15950952813*y**2+3270509002*y**3+15935728490*y**4-11640362703*y**5-6912866015*y**6
          +11056605857*y**7-3172376778*y**8-1464027784*y**9+1258108819*y**10-310106598*y**11
          -3362584*y**12+14073931*y**13-3390831*y**14+446963*y**15+814*y**16)
          -r**8*(-1+y)**7*(-33890892-36106368*y-35187213*y**2+207737184*y**3
          -76339220*y**4-24673295*y**5-160241089*y**6+166477339*y**7+14322690*y**8
          -8189716*y**9-64337545*y**10+41851736*y**11-3818066*y**12-3254949*y**13
          +853071*y**14-94043*y**15+3176*y**16)+r**22*(-170745264+1505380580*y
          -5668160189*y**2+12423304182*y**3-18033145632*y**4+18350207744*y**5-13016142295*y**6
          +5825509830*y**7-1039970234*y**8-379465300*y**9+239746221*y**10-39280070*y**11
          +5966884*y**12-4011728*y**13+800647*y**14-10166*y**15+7590*y**16)-r**10*(
          -1+y)**6*(1195960+59677036*y+63884833*y**2-122406354*y**3-102718366*y**4
          -25719702*y**5+155933884*y**6-620668126*y**7+1095701159*y**8-755921148*y**9
          +191333601*y**10+4577086*y**11+1711168*y**12-7683850*y**13+2146034*y**14
          -252414*y**15+8399*y**16)-r**14*(-1+y)**4*(1318255816-3740388716*y
          +3453076191*y**2-6156073418*y**3+20361110084*y**4-35401311204*y**5+32168144035*y**6
          -12310307178*y**7-3072777084*y**8+4625675948*y**9-1376158891*y**10+3555090*y**11
          +75551972*y**12-20463068*y**13+4221033*y**14-559966*y**15+10956*y**16)
          +r**18*(-1+y)**2*(-9448304122+54876451932*y-126970476603*y**2+145011643118*y**3
          -64970536714*y**4-35641194066*y**5+66754738602*y**6-38073628590*y**7
          +7861614109*y**8+1455704756*y**9-924606543*y**10+113778758*y**11-8804112*y**12
          +3365378*y**13-1158512*y**14+202906*y**15+12903*y**16)-r**12*(-1+y)**5*(
          -641768052+953417344*y-105229379*y**2+432264276*y**3-871778694*y**4
          +843893807*y**5-2026111422*y**6+3001687345*y**7-2383250955*y**8+850086006*y**9
          +101409977*y**10-171912370*y**11+56535444*y**12-15205221*y**13+3530248*y**14
          -456867*y**15+13313*y**16)+r**20*(1898777948-15244737324*y+52960238887*y**2
          -101504244443*y**3+109818814942*y**4-50134007181*y**5-28628297309*y**6
          +58818024539*y**7-37907116750*y**8+9705084861*y**9+1615708277*y**10-1864957129*y**11
          +522482562*y**12-53776487*y**13-2655183*y**14+633401*y**15+11682*y**16
          +14707*y**17))))/(-447897600*logy**5*r**20*(-1+y)**10+1800*(r**8*(-1+y)**2
          -6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y
          -4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5-186624000*logy**4*r**16*(
          -1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -31104000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2-2592000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3-108000*logy*(
          -1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(
          -4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2
          +y**3))**4))
      resNP += ((rhoD*(-6220800*logy**5*r**14*(144+496*r**2+690*r**4+667*r**6
          +474*r**8+251*r**10+54*r**12)*(-1+y)**11-103680*logy**4*r**10*(-1+y)**6*(2662*r**20*(
          -1+y)**5-480*(-1+y)**7*(2+4*y+6*y**2-7*y**3+y**4)-4*r**2*(-1+y)**6*(
          -1548-1548*y-1548*y**2+4837*y**3-3118*y**4+380*y**5)+r**18*(-9103
          +45515*y-91030*y**2+84730*y**3-40295*y**4+6763*y**5+540*y**6)-2*r**4*(
          -1+y)**5*(35419-21600*y-10800*y**2-5460*y**3+14155*y**4-7664*y**5
          +800*y**6)-5*r**16*(2642-9970*y+11840*y**2+3233*y**3-13067*y**4+9283*y**5
          -2713*y**6+216*y**7)+r**14*(-69003+269715*y-351180*y**2+59525*y**3
          +221540*y**4-196582*y**5+61085*y**6-4200*y**7-420*y**8)-5*r**6*(-1
          +y)**3*(24143-78046*y+68783*y**2+1003*y**3-22697*y**4+3931*y**5+4181*y**6
          -2050*y**7+176*y**8)+r**12*(-86352+289560*y-223620*y**2-282300*y**3
          +550850*y**4-308143*y**5+33485*y**6+27555*y**7-9525*y**8+1170*y**9)
          +r**10*(-53953+69665*y+360920*y**2-1014440*y**3+924040*y**4-185609*y**5
          -236045*y**6+170295*y**7-39600*y**8+1055*y**9+792*y**10)+r**8*(35578
          -384890*y+1287280*y**2-1915875*y**3+1219755*y**4+58164*y**5-542740*y**6
          +298785*y**7-52275*y**8-7080*y**9+3458*y**10-160*y**11))-3456*logy**3*r**6*(
          -1+y)**4*(1849*r**28*(-1+y)**7+24*(-1+y)**11*(17+68*y+170*y**2+150*y**3
          -25*y**4-322*y**5+142*y**6)-r**26*(-1+y)**2*(53197-265985*y+531970*y**2
          -518150*y**3+270125*y**4-66937*y**5+5380*y**6)-r**24*(-1+y)**2*(570184
          -2531480*y+4264360*y**2-3064415*y**3+579875*y**4+427961*y**5-208725*y**6
          +17640*y**7)+10*r**2*(-1+y)**9*(776+1552*y+2328*y**2-5417*y**3-379*y**4
          -1911*y**5+5127*y**6-3290*y**7+844*y**8)+r**4*(-1+y)**8*(-255069-139869*y
          -82269*y**2+1603581*y**3-1514049*y**4+229059*y**5+190699*y**6-35111*y**7
          -19196*y**8+8224*y**9)+5*r**22*(-17229-97869*y+1058259*y**2-3591608*y**3
          +6037076*y**4-5661891*y**5+3056876*y**6-883411*y**7+87192*y**8+8049*y**9
          +356*y**10)+r**6*(-1+y)**7*(623817-743040*y-371520*y**2-2061305*y**3
          +5472640*y**4-3569034*y**5+183135*y**6+614620*y**7-172965*y**8-3480*y**9
          +7032*y**10)+r**20*(683557-6370099*y+23686497*y**2-48020785*y**3+53922475*y**4
          -30002362*y**5+2421524*y**6+7220898*y**7-4896525*y**8+1578960*y**9-291590*y**10
          +31850*y**11)-5*r**12*(-1+y)**3*(1850461-6547972*y+5630214*y**2+4595380*y**3
          -9386435*y**4+2653657*y**5+3373002*y**6-2634160*y**7+373743*y**8+200453*y**9
          -69280*y**10+3108*y**11+639*y**12)+r**8*(-1+y)**5*(5401464-19303488*y
          +20744304*y**2+1867825*y**3-17067970*y**4+7170407*y**5+4395726*y**6
          -3878908*y**7+348050*y**8+452470*y**9-131996*y**10+3012*y**11+2704*y**12)
          +r**10*(-1+y)**4*(-1848149+20030247*y-50686947*y**2+40465029*y**3+15976770*y**4
          -46275741*y**5+26593953*y**6-1909643*y**7-3775644*y**8+1431015*y**9
          -103925*y**10-31715*y**11+5600*y**12)-r**14*(-1+y)**2*(-5879978+35874250*y
          -75928400*y**2+53173930*y**3+32116850*y**4-76548569*y**5+47031165*y**6
          -7107875*y**7-4532165*y**8+1870915*y**9-31838*y**10-91375*y**11+13940*y**12)
          +r**18*(-6023662+33885274*y-77192562*y**2+88467220*y**3-52187640*y**4
          +16421099*y**5-10650023*y**6+15166759*y**7-11231895*y**8+3624640*y**9
          -176412*y**10-148026*y**11+24228*y**12)-r**16*(944136+3753288*y-38995704*y**2
          +98457750*y**3-104816370*y**4+28548093*y**5+40017579*y**6-36712542*y**7
          +3508670*y**8+9956520*y**9-5882854*y**10+1337233*y**11-119079*y**12
          +3280*y**13))+288*logy**2*r**4*(-1+y)**2*(-1+r**2+y)**2*(-37*r**30*(-1
          +y)**9+r**28*(-1+y)**4*(3027-15209*y+30640*y**2-28132*y**3+14993*y**4
          -4147*y**5+460*y**6)-r**26*(-1+y)**2*(-329065+2243019*y-6520706*y**2
          +10421366*y**3-9944546*y**4+5747710*y**5-1907214*y**6+304058*y**7-13205*y**8
          +503*y**9)-10*(-1+y)**11*(-12-48*y-120*y**2-37*y**3+399*y**4+912*y**5
          -938*y**6+299*y**7+351*y**8-730*y**9+284*y**10)-r**24*(-1+y)**2*(-3218416
          +21144950*y-58799287*y**2+87878583*y**3-76219779*y**4+38154219*y**5
          -9296096*y**6-51400*y**7+483172*y**8-66886*y**9+3140*y**10)+r**22*(
          -1+y)**2*(15003941-87572177*y+207699183*y**2-240726445*y**3+115521919*y**4
          +30142263*y**5-66908597*y**6+33314650*y**7-6488377*y**8+216269*y**9
          +9589*y**10+982*y**11)-r**2*(-1+y)**9*(-44477-74506*y-97431*y**2+391184*y**3
          +224512*y**4+117624*y**5-1647200*y**6+1618928*y**7-444179*y**8-123582*y**9
          +99383*y**10-22464*y**11+3008*y**12)+r**4*(-1+y)**8*(-568347-348805*y
          -254615*y**2+5366565*y**3-5270348*y**4+1800258*y**5-4028217*y**6+5933864*y**7
          -3150403*y**8+391823*y**9+172684*y**10-46013*y**11-1814*y**12+168*y**13)
          +r**6*(-1+y)**7*(9183553-8559380*y-2105843*y**2-55221494*y**3+131800670*y**4
          -94402242*y**5+3841710*y**6+24095919*y**7-8199915*y**8-1403084*y**9
          +1159449*y**10-245985*y**11+69044*y**12-18706*y**13+1504*y**14)+r**10*(
          -1+y)**5*(114547501-450612956*y+583805371*y**2-72492032*y**3-490039723*y**4
          +401448746*y**5-6838181*y**6-123852134*y**7+44724293*y**8+6639469*y**9
          -6531967*y**10+990562*y**11+24273*y**12-4151*y**13+2429*y**14)+r**8*(
          -1+y)**6*(-13497456+35623674*y-20137125*y**2+55453549*y**3-226153347*y**4
          +302105551*y**5-140697697*y**6-28441713*y**7+49757023*y**8-13669804*y**9
          -1063690*y**10+678908*y**11+121248*y**12-55017*y**13+4796*y**14)-r**16*(
          -1+y)**2*(-136669688+696713436*y-1345427206*y**2+993700308*y**3+272750486*y**4
          -952079178*y**5+553162588*y**6+2858812*y**7-123302494*y**8+29146325*y**9
          +12670606*y**10-5568684*y**11+342244*y**12+23581*y**13+5464*y**14)-r**12*(
          -1+y)**4*(101608039-590167081*y+1232582906*y**2-936689782*y**3-376795703*y**4
          +1172356787*y**5-770146944*y**6+97043344*y**7+116231725*y**8-51267350*y**9
          +2642614*y**10+1620850*y**11+114235*y**12-127248*y**13+7108*y**14)+r**20*(1866159
          -3738403*y-35771451*y**2+246487981*y**3-674715750*y**4+1020339690*y**5
          -944540707*y**6+557907800*y**7-207895273*y**8+40967118*y**9+1659326*y**10
          -3424845*y**11+1033456*y**12-176853*y**13+8152*y**14)-r**14*(-1+y)**3*(98256631
          -351062606*y+329132757*y**2+216596280*y**3-604858931*y**4+408501348*y**5
          -80864313*y**6-11864672*y**7-23730941*y**8+28802971*y**9-9261669*y**10
          +555984*y**11+374245*y**12-135009*y**13+11425*y**14)+r**18*(-15897471
          +153403397*y-640906119*y**2+1582392185*y**3-2468200738*y**4+2363946564*y**5
          -1161025528*y**6-98199280*y**7+593433199*y**8-472792582*y**9+213862026*y**10
          -56596999*y**11+6121474*y**12+651321*y**13-196195*y**14+4746*y**15))
          -12*logy*(-1+y)**2*(-1+r**2+y)**3*(211*r**34*(-1+y)**9+r**32*(-1+y)**4*(1329
          -7788*y+18117*y**2-30110*y**3+18913*y**4-6914*y**5+1413*y**6)-r**30*(
          -1+y)**2*(861791-5882111*y+17114103*y**2-27007141*y**3+25478615*y**4
          -15013261*y**5+5381107*y**6-1037485*y**7+77652*y**8+602*y**9)+r**28*(
          -23045471+194049066*y-718512045*y**2+1527281470*y**3-2048094908*y**4
          +1791469026*y**5-1012535578*y**6+344224392*y**7-53676825*y**8-2807988*y**9
          +1635143*y**10+14754*y**11-14156*y**12)-4*(-1+y)**12*(-4-24*y-84*y**2
          -169*y**3-151*y**4+123*y**5+89*y**6+7*y**7-161*y**8+241*y**9+131*y**10
          -290*y**11+92*y**12)-4*r**2*(-1+y)**11*(-197-973*y-2883*y**2-4229*y**3
          -2484*y**4+4090*y**5+3808*y**6+726*y**7-5361*y**8+4539*y**9-473*y**10
          -905*y**11+142*y**12)-r**26*(78885347-611260395*y+2044356312*y**2-3738293256*y**3
          +3918763319*y**4-2098654407*y**5+27029162*y**6+767962122*y**7-543604627*y**8
          +183193011*y**9-30871490*y**10+2767118*y**11-368519*y**12+18223*y**13)
          +r**24*(-309808915+2206039380*y-6587415585*y**2+10164561926*y**3-7306870293*y**4
          -1069853730*y**5+7082495135*y**6-6608756380*y**7+3094792253*y**8-698399606*y**9
          +12035265*y**10+23962870*y**11-3264125*y**12+191716*y**13+19689*y**14)
          -r**4*(-1+y)**9*(4015+3969*y-5238*y**2-226652*y**3-448121*y**4-214665*y**5
          +2273558*y**6-1906372*y**7-107701*y**8+1605687*y**9-1461008*y**10+550768*y**11
          -69585*y**12-16607*y**13+4784*y**14+368*y**15)-r**6*(-1+y)**8*(-3249775
          -4368623*y-4757568*y**2+29287098*y**3+3487133*y**4-376343*y**5-92238256*y**6
          +112467570*y**7-36975367*y**8-11253471*y**9+9970950*y**10-2123516*y**11
          +117313*y**12+22349*y**13-20062*y**14+7368*y**15)-r**12*(-1+y)**5*(
          -29997373-219249467*y+457746900*y**2-376836822*y**3+1772411147*y**4
          -3927651473*y**5+3332143154*y**6-578475280*y**7-787877511*y**8+440307787*y**9
          -49415736*y**10-2424142*y**11-5640655*y**12+1671873*y**13+69786*y**14
          +19412*y**15)+r**18*(-1+y)**2*(-3792860245+18927845863*y-36281869125*y**2
          +29275135315*y**3+1013037551*y**4-21081385413*y**5+17003602571*y**6-5771684293*y**7
          +999486757*y**8-583469407*y**9+276417525*y**10+38048501*y**11-40004727*y**12
          +3912053*y**13+67101*y**14+33573*y**15)-r**8*(-1+y)**7*(20194991+532733*y
          -3081019*y**2-191698639*y**3+309708183*y**4-147002807*y**5+50759819*y**6
          -103045769*y**7+86890239*y**8-21857249*y**9+371645*y**10-3376357*y**11
          +2078923*y**12-33805*y**13-156909*y**14+34021*y**15)+r**22*(303907757
          -2477559555*y+8754049812*y**2-18640317602*y**3+25426921977*y**4-21044104827*y**5
          +8021198976*y**6+2374188634*y**7-4914210055*y**8+3192046865*y**9-1289445426*y**10
          +343229164*y**11-57752511*y**12+6137037*y**13-370322*y**14+52876*y**15)
          -r**10*(-1+y)**6*(-266172959+399887829*y-2666553*y**2+1402065139*y**3
          -4384228347*y**4+4015685457*y**5-325875715*y**6-1611698947*y**7+869200493*y**8
          -16472539*y**9-94990145*y**10+16528831*y**11+2144005*y**12+51933*y**13
          -263739*y**14+59657*y**15)+r**14*(-1+y)**4*(2481388611-10800296229*y
          +16343731758*y**2-3735492464*y**3-18137334705*y**4+22910795179*y**5-8937924128*y**6
          -2707389898*y**7+3277682513*y**8-537019423*y**9-240199570*y**10+57282092*y**11
          +14199205*y**12-3236479*y**13-659572*y**14+68310*y**15)+r**16*(-1+y)**3*(
          -770208547+5581164687*y-14488313931*y**2+16506720477*y**3-5196792091*y**4
          -6652937241*y**5+7704999321*y**6-2693657811*y**7-566761309*y**8+767313149*y**9
          -204409021*y**10+8734927*y**11+6375187*y**12-1492963*y**13-536793*y**14
          +83959*y**15)+r**20*(390332141-3404023674*y+12821620599*y**2-27913338586*y**3
          +36486960901*y**4-24954031480*y**5+209289933*y**6+16225476530*y**7-16083434047*y**8
          +8217902616*y**9-1981666429*y**10-292810340*y**11+368629621*y**12-100529902*y**13
          +9728513*y**14-138412*y**15+32016*y**16))-(-1+r**2+y)**4*(51*r**36*(
          -1+y)**11+r**34*(-1+y)**6*(1590-7746*y+14880*y**2-14483*y**3+7741*y**4
          -2393*y**5+403*y**6)+r**32*(-1+y)**4*(-28877+193451*y-547377*y**2
          +856634*y**3-820076*y**4+505599*y**5-208837*y**6+57952*y**7-10469*y**8
          +1152*y**9)+r**30*(-1+y)**2*(206684-1737388*y+6356772*y**2-13789490*y**3
          +19859490*y**4-19795159*y**5+13938179*y**6-7144951*y**7+2746127*y**8
          -760141*y**9+129521*y**10-11143*y**11+795*y**12)+r**28*(-20896360+218814500*y
          -1034158902*y**2+2903391188*y**3-5380653644*y**4+6929848013*y**5-6360115423*y**6
          +4188494120*y**7-1957615924*y**8+626764050*y**9-126787460*y**10+12965404*y**11
          +152744*y**12-241331*y**13+44153*y**14-3208*y**15)+(-1+y)**13*(-839
          -4842*y-16371*y**2-30165*y**3-29437*y**4+4503*y**5+4703*y**6+7282*y**7
          -3755*y**8+35274*y**9+6677*y**10-38471*y**11+15239*y**12-975*y**13
          -57*y**14+34*y**15)+r**26*(-158246748+1536708556*y-6656688124*y**2
          +16829512282*y**3-27257680082*y**4+29019077073*y**5-19557118543*y**6
          +6685510691*y**7+900268395*y**8-2165072268*y**9+1018453868*y**10-197297870*y**11
          -4594962*y**12+8399263*y**13-1375265*y**14+144577*y**15-8523*y**16)
          +r**2*(-1+y)**12*(-54214-258450*y-742890*y**2-1021395*y**3-670875*y**4
          +641377*y**5+632717*y**6+302720*y**7-698884*y**8+663050*y**9-206142*y**10
          -115869*y**11+76875*y**12-11601*y**13-1965*y**14-56*y**15+2*y**16)
          +r**4*(-1+y)**10*(408321+972547*y+1538958*y**2-4765692*y**3-7300162*y**4
          -3117845*y**5+34919665*y**6-35029251*y**7+1935977*y**8+25367020*y**9
          -24291132*y**10+11228682*y**11-2162432*y**12-363485*y**13+194557*y**14
          -19019*y**15-3144*y**16+35*y**17)+r**6*(-1+y)**9*(-35698468-33780504*y
          -25997976*y**2+317553098*y**3-93143232*y**4-55601045*y**5-791585630*y**6
          +1209637154*y**7-487102034*y**8-102246641*y**9+104007172*y**10-2143610*y**11
          -8082188*y**12-504639*y**13+519058*y**14-10034*y**15-19006*y**16+125*y**17)
          -r**8*(-1+y)**8*(-50494968+86667484*y+46975654*y**2+681083972*y**3
          -2267294206*y**4+1920083101*y**5+766233277*y**6-1976493573*y**7+832554805*y**8
          +152091826*y**9-233923108*y**10+74333698*y**11-8529464*y**12-650687*y**13
          +1149425*y**14-223185*y**15+53321*y**16+228*y**17)-r**16*(-1+y)**4*(15114830994
          -66586279650*y+104785494660*y**2-42200675312*y**3-74141135102*y**4+108094474433*y**5
          -50466706267*y**6-387808267*y**7+5833153183*y**8+1161473368*y**9-867046134*y**10
          -524479102*y**11+244761748*y**12-5023391*y**13-7940611*y**14+2088537*y**15
          -141911*y**16+2024*y**17)-r**10*(-1+y)**7*(1686097564-3129258088*y
          +701054792*y**2-7495127542*y**3+27100897036*y**4-28877556607*y**5+5593512296*y**6
          +10549646142*y**7-6909104208*y**8+240779155*y**9+715825992*y**10-22900678*y**11
          -70418364*y**12+3640475*y**13+4919384*y**14-476594*y**15+72980*y**16
          +2665*y**17)-r**24*(178719712-1448273988*y+4888236522*y**2-7654130468*y**3
          +1394670614*y**4+16691263255*y**5-33942947489*y**6+35703198649*y**7-23791951657*y**8
          +10745229606*y**9-3563216308*y**10+1070359366*y**11-364888760*y**12+113773875*y**13
          -22040405*y**14+2153381*y**15-171509*y**16+6004*y**17)-r**12*(-1+y)**6*(3387186896
          -7362287540*y+2677335538*y**2-6049105676*y**3+27966763118*y**4-31220635691*y**5
          +2829986871*y**6+15784668119*y**7-8023558599*y**8-1304479374*y**9+1610545812*y**10
          -156693202*y**11-96187236*y**12+15929765*y**13+2826131*y**14+320663*y**15
          +15901*y**16+7704*y**17)-r**14*(-1+y)**5*(17458649876-74267610024*y
          +113982821928*y**2-47268313058*y**3-70853230328*y**4+103424158849*y**5
          -48109005982*y**6-1265930490*y**7+10161099710*y**8-3354431731*y**9+178398716*y**10
          -102389118*y**11+35585300*y**12+18872603*y**13-7032486*y**14+2023354*y**15
          -100366*y**16+10047*y**17)+r**18*(-1+y)**3*(2878233008-17809717664*y
          +45308307384*y**2-63071170680*y**3+52216681644*y**4-20178548117*y**5
          -10250091900*y**6+19866519532*y**7-11653430412*y**8+3407874797*y**9-1052325176*y**10
          +409834476*y**11-52155020*y**12+2083337*y**13-2232436*y**14-16960*y**15
          +53548*y**16+12639*y**17)+r**20*(-1+y)**2*(4155244138-30676352782*y
          +96460559202*y**2-173021188332*y**3+183345229822*y**4-91788037395*y**5
          -26819074413*y**6+76216782015*y**7-54144942411*y**8+18591992930*y**9
          -1347884524*y**10-1601740058*y**11+678225268*y**12-99149307*y**13+1850503*y**14
          +807671*y**15-13057*y**16+17930*y**17)+r**22*(-1648605588+14614190492*y
          -56759041760*y**2+124983523770*y**3-165890082226*y**4+121367688271*y**5
          -14012697885*y**6-66477258600*y**7+70777307956*y**8-31896661755*y**9
          +1271708225*y**10+6633204154*y**11-3947841466*y**12+1166331833*y**13
          -201090059*y**14+20181332*y**15-921716*y**16+57751*y**17+7271*y**18))))/(447897600*logy**5*r**20*(
          -1+y)**11-1800*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(
          -1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5+186624000*logy**4*r**16*(-1+y)**9*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+31104000*logy**3*r**12*(-1+y)**7*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+2592000*logy**2*r**8*(
          -1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +108000*logy*(-1+y)**3*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*muWC**3*(6220800*logy**5*r**14*(144+496*r**2+690*r**4
          +667*r**6+474*r**8+251*r**10+54*r**12)*(-1+y)**11+103680*logy**4*r**10*(
          -1+y)**6*(2662*r**20*(-1+y)**5-480*(-1+y)**7*(2+4*y+6*y**2-7*y**3
          +y**4)-4*r**2*(-1+y)**6*(-1548-1548*y-1548*y**2+4837*y**3-3118*y**4
          +380*y**5)+r**18*(-9103+45515*y-91030*y**2+84730*y**3-40295*y**4+6763*y**5
          +540*y**6)-2*r**4*(-1+y)**5*(35419-21600*y-10800*y**2-5460*y**3+14155*y**4
          -7664*y**5+800*y**6)-5*r**16*(2642-9970*y+11840*y**2+3233*y**3-13067*y**4
          +9283*y**5-2713*y**6+216*y**7)+r**14*(-69003+269715*y-351180*y**2
          +59525*y**3+221540*y**4-196582*y**5+61085*y**6-4200*y**7-420*y**8)
          -5*r**6*(-1+y)**3*(24143-78046*y+68783*y**2+1003*y**3-22697*y**4+3931*y**5
          +4181*y**6-2050*y**7+176*y**8)+r**12*(-86352+289560*y-223620*y**2
          -282300*y**3+550850*y**4-308143*y**5+33485*y**6+27555*y**7-9525*y**8
          +1170*y**9)+r**10*(-53953+69665*y+360920*y**2-1014440*y**3+924040*y**4
          -185609*y**5-236045*y**6+170295*y**7-39600*y**8+1055*y**9+792*y**10)
          +r**8*(35578-384890*y+1287280*y**2-1915875*y**3+1219755*y**4+58164*y**5
          -542740*y**6+298785*y**7-52275*y**8-7080*y**9+3458*y**10-160*y**11))
          +3456*logy**3*r**6*(-1+y)**4*(1849*r**28*(-1+y)**7+24*(-1+y)**11*(17
          +68*y+170*y**2+150*y**3-25*y**4-322*y**5+142*y**6)-r**26*(-1+y)**2*(53197
          -265985*y+531970*y**2-518150*y**3+270125*y**4-66937*y**5+5380*y**6)
          -r**24*(-1+y)**2*(570184-2531480*y+4264360*y**2-3064415*y**3+579875*y**4
          +427961*y**5-208725*y**6+17640*y**7)+10*r**2*(-1+y)**9*(776+1552*y
          +2328*y**2-5417*y**3-379*y**4-1911*y**5+5127*y**6-3290*y**7+844*y**8)
          +r**4*(-1+y)**8*(-255069-139869*y-82269*y**2+1603581*y**3-1514049*y**4
          +229059*y**5+190699*y**6-35111*y**7-19196*y**8+8224*y**9)+5*r**22*(
          -17229-97869*y+1058259*y**2-3591608*y**3+6037076*y**4-5661891*y**5
          +3056876*y**6-883411*y**7+87192*y**8+8049*y**9+356*y**10)+r**6*(-1
          +y)**7*(623817-743040*y-371520*y**2-2061305*y**3+5472640*y**4-3569034*y**5
          +183135*y**6+614620*y**7-172965*y**8-3480*y**9+7032*y**10)+r**20*(683557
          -6370099*y+23686497*y**2-48020785*y**3+53922475*y**4-30002362*y**5
          +2421524*y**6+7220898*y**7-4896525*y**8+1578960*y**9-291590*y**10+31850*y**11)
          -5*r**12*(-1+y)**3*(1850461-6547972*y+5630214*y**2+4595380*y**3-9386435*y**4
          +2653657*y**5+3373002*y**6-2634160*y**7+373743*y**8+200453*y**9-69280*y**10
          +3108*y**11+639*y**12)+r**8*(-1+y)**5*(5401464-19303488*y+20744304*y**2
          +1867825*y**3-17067970*y**4+7170407*y**5+4395726*y**6-3878908*y**7+348050*y**8
          +452470*y**9-131996*y**10+3012*y**11+2704*y**12)+r**10*(-1+y)**4*(-1848149
          +20030247*y-50686947*y**2+40465029*y**3+15976770*y**4-46275741*y**5
          +26593953*y**6-1909643*y**7-3775644*y**8+1431015*y**9-103925*y**10-31715*y**11
          +5600*y**12)-r**14*(-1+y)**2*(-5879978+35874250*y-75928400*y**2+53173930*y**3
          +32116850*y**4-76548569*y**5+47031165*y**6-7107875*y**7-4532165*y**8
          +1870915*y**9-31838*y**10-91375*y**11+13940*y**12)+r**18*(-6023662+33885274*y
          -77192562*y**2+88467220*y**3-52187640*y**4+16421099*y**5-10650023*y**6
          +15166759*y**7-11231895*y**8+3624640*y**9-176412*y**10-148026*y**11
          +24228*y**12)-r**16*(944136+3753288*y-38995704*y**2+98457750*y**3-104816370*y**4
          +28548093*y**5+40017579*y**6-36712542*y**7+3508670*y**8+9956520*y**9
          -5882854*y**10+1337233*y**11-119079*y**12+3280*y**13))-288*logy**2*r**4*(
          -1+y)**2*(-1+r**2+y)**2*(-37*r**30*(-1+y)**9+r**28*(-1+y)**4*(3027
          -15209*y+30640*y**2-28132*y**3+14993*y**4-4147*y**5+460*y**6)-r**26*(
          -1+y)**2*(-329065+2243019*y-6520706*y**2+10421366*y**3-9944546*y**4
          +5747710*y**5-1907214*y**6+304058*y**7-13205*y**8+503*y**9)-10*(-1
          +y)**11*(-12-48*y-120*y**2-37*y**3+399*y**4+912*y**5-938*y**6+299*y**7
          +351*y**8-730*y**9+284*y**10)-r**24*(-1+y)**2*(-3218416+21144950*y
          -58799287*y**2+87878583*y**3-76219779*y**4+38154219*y**5-9296096*y**6
          -51400*y**7+483172*y**8-66886*y**9+3140*y**10)+r**22*(-1+y)**2*(15003941
          -87572177*y+207699183*y**2-240726445*y**3+115521919*y**4+30142263*y**5
          -66908597*y**6+33314650*y**7-6488377*y**8+216269*y**9+9589*y**10+982*y**11)
          -r**2*(-1+y)**9*(-44477-74506*y-97431*y**2+391184*y**3+224512*y**4
          +117624*y**5-1647200*y**6+1618928*y**7-444179*y**8-123582*y**9+99383*y**10
          -22464*y**11+3008*y**12)+r**4*(-1+y)**8*(-568347-348805*y-254615*y**2
          +5366565*y**3-5270348*y**4+1800258*y**5-4028217*y**6+5933864*y**7-3150403*y**8
          +391823*y**9+172684*y**10-46013*y**11-1814*y**12+168*y**13)+r**6*(-1
          +y)**7*(9183553-8559380*y-2105843*y**2-55221494*y**3+131800670*y**4
          -94402242*y**5+3841710*y**6+24095919*y**7-8199915*y**8-1403084*y**9
          +1159449*y**10-245985*y**11+69044*y**12-18706*y**13+1504*y**14)+r**10*(
          -1+y)**5*(114547501-450612956*y+583805371*y**2-72492032*y**3-490039723*y**4
          +401448746*y**5-6838181*y**6-123852134*y**7+44724293*y**8+6639469*y**9
          -6531967*y**10+990562*y**11+24273*y**12-4151*y**13+2429*y**14)+r**8*(
          -1+y)**6*(-13497456+35623674*y-20137125*y**2+55453549*y**3-226153347*y**4
          +302105551*y**5-140697697*y**6-28441713*y**7+49757023*y**8-13669804*y**9
          -1063690*y**10+678908*y**11+121248*y**12-55017*y**13+4796*y**14)-r**16*(
          -1+y)**2*(-136669688+696713436*y-1345427206*y**2+993700308*y**3+272750486*y**4
          -952079178*y**5+553162588*y**6+2858812*y**7-123302494*y**8+29146325*y**9
          +12670606*y**10-5568684*y**11+342244*y**12+23581*y**13+5464*y**14)-r**12*(
          -1+y)**4*(101608039-590167081*y+1232582906*y**2-936689782*y**3-376795703*y**4
          +1172356787*y**5-770146944*y**6+97043344*y**7+116231725*y**8-51267350*y**9
          +2642614*y**10+1620850*y**11+114235*y**12-127248*y**13+7108*y**14)+r**20*(1866159
          -3738403*y-35771451*y**2+246487981*y**3-674715750*y**4+1020339690*y**5
          -944540707*y**6+557907800*y**7-207895273*y**8+40967118*y**9+1659326*y**10
          -3424845*y**11+1033456*y**12-176853*y**13+8152*y**14)-r**14*(-1+y)**3*(98256631
          -351062606*y+329132757*y**2+216596280*y**3-604858931*y**4+408501348*y**5
          -80864313*y**6-11864672*y**7-23730941*y**8+28802971*y**9-9261669*y**10
          +555984*y**11+374245*y**12-135009*y**13+11425*y**14)+r**18*(-15897471
          +153403397*y-640906119*y**2+1582392185*y**3-2468200738*y**4+2363946564*y**5
          -1161025528*y**6-98199280*y**7+593433199*y**8-472792582*y**9+213862026*y**10
          -56596999*y**11+6121474*y**12+651321*y**13-196195*y**14+4746*y**15))
          +12*logy*(-1+y)**2*(-1+r**2+y)**3*(211*r**34*(-1+y)**9+r**32*(-1+y)**4*(1329
          -7788*y+18117*y**2-30110*y**3+18913*y**4-6914*y**5+1413*y**6)-r**30*(
          -1+y)**2*(861791-5882111*y+17114103*y**2-27007141*y**3+25478615*y**4
          -15013261*y**5+5381107*y**6-1037485*y**7+77652*y**8+602*y**9)+r**28*(
          -23045471+194049066*y-718512045*y**2+1527281470*y**3-2048094908*y**4
          +1791469026*y**5-1012535578*y**6+344224392*y**7-53676825*y**8-2807988*y**9
          +1635143*y**10+14754*y**11-14156*y**12)-4*(-1+y)**12*(-4-24*y-84*y**2
          -169*y**3-151*y**4+123*y**5+89*y**6+7*y**7-161*y**8+241*y**9+131*y**10
          -290*y**11+92*y**12)-4*r**2*(-1+y)**11*(-197-973*y-2883*y**2-4229*y**3
          -2484*y**4+4090*y**5+3808*y**6+726*y**7-5361*y**8+4539*y**9-473*y**10
          -905*y**11+142*y**12)-r**26*(78885347-611260395*y+2044356312*y**2-3738293256*y**3
          +3918763319*y**4-2098654407*y**5+27029162*y**6+767962122*y**7-543604627*y**8
          +183193011*y**9-30871490*y**10+2767118*y**11-368519*y**12+18223*y**13)
          +r**24*(-309808915+2206039380*y-6587415585*y**2+10164561926*y**3-7306870293*y**4
          -1069853730*y**5+7082495135*y**6-6608756380*y**7+3094792253*y**8-698399606*y**9
          +12035265*y**10+23962870*y**11-3264125*y**12+191716*y**13+19689*y**14)
          -r**4*(-1+y)**9*(4015+3969*y-5238*y**2-226652*y**3-448121*y**4-214665*y**5
          +2273558*y**6-1906372*y**7-107701*y**8+1605687*y**9-1461008*y**10+550768*y**11
          -69585*y**12-16607*y**13+4784*y**14+368*y**15)-r**6*(-1+y)**8*(-3249775
          -4368623*y-4757568*y**2+29287098*y**3+3487133*y**4-376343*y**5-92238256*y**6
          +112467570*y**7-36975367*y**8-11253471*y**9+9970950*y**10-2123516*y**11
          +117313*y**12+22349*y**13-20062*y**14+7368*y**15)-r**12*(-1+y)**5*(
          -29997373-219249467*y+457746900*y**2-376836822*y**3+1772411147*y**4
          -3927651473*y**5+3332143154*y**6-578475280*y**7-787877511*y**8+440307787*y**9
          -49415736*y**10-2424142*y**11-5640655*y**12+1671873*y**13+69786*y**14
          +19412*y**15)+r**18*(-1+y)**2*(-3792860245+18927845863*y-36281869125*y**2
          +29275135315*y**3+1013037551*y**4-21081385413*y**5+17003602571*y**6-5771684293*y**7
          +999486757*y**8-583469407*y**9+276417525*y**10+38048501*y**11-40004727*y**12
          +3912053*y**13+67101*y**14+33573*y**15)-r**8*(-1+y)**7*(20194991+532733*y
          -3081019*y**2-191698639*y**3+309708183*y**4-147002807*y**5+50759819*y**6
          -103045769*y**7+86890239*y**8-21857249*y**9+371645*y**10-3376357*y**11
          +2078923*y**12-33805*y**13-156909*y**14+34021*y**15)+r**22*(303907757
          -2477559555*y+8754049812*y**2-18640317602*y**3+25426921977*y**4-21044104827*y**5
          +8021198976*y**6+2374188634*y**7-4914210055*y**8+3192046865*y**9-1289445426*y**10
          +343229164*y**11-57752511*y**12+6137037*y**13-370322*y**14+52876*y**15)
          -r**10*(-1+y)**6*(-266172959+399887829*y-2666553*y**2+1402065139*y**3
          -4384228347*y**4+4015685457*y**5-325875715*y**6-1611698947*y**7+869200493*y**8
          -16472539*y**9-94990145*y**10+16528831*y**11+2144005*y**12+51933*y**13
          -263739*y**14+59657*y**15)+r**14*(-1+y)**4*(2481388611-10800296229*y
          +16343731758*y**2-3735492464*y**3-18137334705*y**4+22910795179*y**5-8937924128*y**6
          -2707389898*y**7+3277682513*y**8-537019423*y**9-240199570*y**10+57282092*y**11
          +14199205*y**12-3236479*y**13-659572*y**14+68310*y**15)+r**16*(-1+y)**3*(
          -770208547+5581164687*y-14488313931*y**2+16506720477*y**3-5196792091*y**4
          -6652937241*y**5+7704999321*y**6-2693657811*y**7-566761309*y**8+767313149*y**9
          -204409021*y**10+8734927*y**11+6375187*y**12-1492963*y**13-536793*y**14
          +83959*y**15)+r**20*(390332141-3404023674*y+12821620599*y**2-27913338586*y**3
          +36486960901*y**4-24954031480*y**5+209289933*y**6+16225476530*y**7-16083434047*y**8
          +8217902616*y**9-1981666429*y**10-292810340*y**11+368629621*y**12-100529902*y**13
          +9728513*y**14-138412*y**15+32016*y**16))+(-1+r**2+y)**4*(51*r**36*(
          -1+y)**11+r**34*(-1+y)**6*(1590-7746*y+14880*y**2-14483*y**3+7741*y**4
          -2393*y**5+403*y**6)+r**32*(-1+y)**4*(-28877+193451*y-547377*y**2
          +856634*y**3-820076*y**4+505599*y**5-208837*y**6+57952*y**7-10469*y**8
          +1152*y**9)+r**30*(-1+y)**2*(206684-1737388*y+6356772*y**2-13789490*y**3
          +19859490*y**4-19795159*y**5+13938179*y**6-7144951*y**7+2746127*y**8
          -760141*y**9+129521*y**10-11143*y**11+795*y**12)+r**28*(-20896360+218814500*y
          -1034158902*y**2+2903391188*y**3-5380653644*y**4+6929848013*y**5-6360115423*y**6
          +4188494120*y**7-1957615924*y**8+626764050*y**9-126787460*y**10+12965404*y**11
          +152744*y**12-241331*y**13+44153*y**14-3208*y**15)+(-1+y)**13*(-839
          -4842*y-16371*y**2-30165*y**3-29437*y**4+4503*y**5+4703*y**6+7282*y**7
          -3755*y**8+35274*y**9+6677*y**10-38471*y**11+15239*y**12-975*y**13
          -57*y**14+34*y**15)+r**26*(-158246748+1536708556*y-6656688124*y**2
          +16829512282*y**3-27257680082*y**4+29019077073*y**5-19557118543*y**6
          +6685510691*y**7+900268395*y**8-2165072268*y**9+1018453868*y**10-197297870*y**11
          -4594962*y**12+8399263*y**13-1375265*y**14+144577*y**15-8523*y**16)
          +r**2*(-1+y)**12*(-54214-258450*y-742890*y**2-1021395*y**3-670875*y**4
          +641377*y**5+632717*y**6+302720*y**7-698884*y**8+663050*y**9-206142*y**10
          -115869*y**11+76875*y**12-11601*y**13-1965*y**14-56*y**15+2*y**16)
          +r**4*(-1+y)**10*(408321+972547*y+1538958*y**2-4765692*y**3-7300162*y**4
          -3117845*y**5+34919665*y**6-35029251*y**7+1935977*y**8+25367020*y**9
          -24291132*y**10+11228682*y**11-2162432*y**12-363485*y**13+194557*y**14
          -19019*y**15-3144*y**16+35*y**17)+r**6*(-1+y)**9*(-35698468-33780504*y
          -25997976*y**2+317553098*y**3-93143232*y**4-55601045*y**5-791585630*y**6
          +1209637154*y**7-487102034*y**8-102246641*y**9+104007172*y**10-2143610*y**11
          -8082188*y**12-504639*y**13+519058*y**14-10034*y**15-19006*y**16+125*y**17)
          -r**8*(-1+y)**8*(-50494968+86667484*y+46975654*y**2+681083972*y**3
          -2267294206*y**4+1920083101*y**5+766233277*y**6-1976493573*y**7+832554805*y**8
          +152091826*y**9-233923108*y**10+74333698*y**11-8529464*y**12-650687*y**13
          +1149425*y**14-223185*y**15+53321*y**16+228*y**17)-r**16*(-1+y)**4*(15114830994
          -66586279650*y+104785494660*y**2-42200675312*y**3-74141135102*y**4+108094474433*y**5
          -50466706267*y**6-387808267*y**7+5833153183*y**8+1161473368*y**9-867046134*y**10
          -524479102*y**11+244761748*y**12-5023391*y**13-7940611*y**14+2088537*y**15
          -141911*y**16+2024*y**17)-r**10*(-1+y)**7*(1686097564-3129258088*y
          +701054792*y**2-7495127542*y**3+27100897036*y**4-28877556607*y**5+5593512296*y**6
          +10549646142*y**7-6909104208*y**8+240779155*y**9+715825992*y**10-22900678*y**11
          -70418364*y**12+3640475*y**13+4919384*y**14-476594*y**15+72980*y**16
          +2665*y**17)-r**24*(178719712-1448273988*y+4888236522*y**2-7654130468*y**3
          +1394670614*y**4+16691263255*y**5-33942947489*y**6+35703198649*y**7-23791951657*y**8
          +10745229606*y**9-3563216308*y**10+1070359366*y**11-364888760*y**12+113773875*y**13
          -22040405*y**14+2153381*y**15-171509*y**16+6004*y**17)-r**12*(-1+y)**6*(3387186896
          -7362287540*y+2677335538*y**2-6049105676*y**3+27966763118*y**4-31220635691*y**5
          +2829986871*y**6+15784668119*y**7-8023558599*y**8-1304479374*y**9+1610545812*y**10
          -156693202*y**11-96187236*y**12+15929765*y**13+2826131*y**14+320663*y**15
          +15901*y**16+7704*y**17)-r**14*(-1+y)**5*(17458649876-74267610024*y
          +113982821928*y**2-47268313058*y**3-70853230328*y**4+103424158849*y**5
          -48109005982*y**6-1265930490*y**7+10161099710*y**8-3354431731*y**9+178398716*y**10
          -102389118*y**11+35585300*y**12+18872603*y**13-7032486*y**14+2023354*y**15
          -100366*y**16+10047*y**17)+r**18*(-1+y)**3*(2878233008-17809717664*y
          +45308307384*y**2-63071170680*y**3+52216681644*y**4-20178548117*y**5
          -10250091900*y**6+19866519532*y**7-11653430412*y**8+3407874797*y**9-1052325176*y**10
          +409834476*y**11-52155020*y**12+2083337*y**13-2232436*y**14-16960*y**15
          +53548*y**16+12639*y**17)+r**20*(-1+y)**2*(4155244138-30676352782*y
          +96460559202*y**2-173021188332*y**3+183345229822*y**4-91788037395*y**5
          -26819074413*y**6+76216782015*y**7-54144942411*y**8+18591992930*y**9
          -1347884524*y**10-1601740058*y**11+678225268*y**12-99149307*y**13+1850503*y**14
          +807671*y**15-13057*y**16+17930*y**17)+r**22*(-1648605588+14614190492*y
          -56759041760*y**2+124983523770*y**3-165890082226*y**4+121367688271*y**5
          -14012697885*y**6-66477258600*y**7+70777307956*y**8-31896661755*y**9
          +1271708225*y**10+6633204154*y**11-3947841466*y**12+1166331833*y**13
          -201090059*y**14+20181332*y**15-921716*y**16+57751*y**17+7271*y**18))))/(503884800*logy**5*r**20*(
          -1+y)**11-2025*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(
          -1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5+209952000*logy**4*r**16*(-1+y)**9*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+34992000*logy**3*r**12*(-1+y)**7*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+2916000*logy**2*r**8*(
          -1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +121500*logy*(-1+y)**3*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*(6220800*logy**5*r**18*(-9+23*r**4+37*r**6+27*r**8)*(
          -1+y)**10+103680*logy**4*r**14*(-1+y)**8*(535*r**16*(-1+y)**2+5*r**14*(347
          -694*y+347*y**2+18*y**3)-5*r**12*(-1557+1494*y+873*y**2-1097*y**3
          +108*y**4)+3*(-1+y)**3*(-167-167*y-167*y**2+523*y**3-272*y**4+40*y**5)
          +2*r**10*(47+5456*y-8278*y**2+3580*y**3-545*y**4+355*y**5)+10*r**2*(
          -1+y)**2*(43-396*y**3+402*y**4-150*y**5+20*y**6)+25*r**6*(-219+438*y
          -219*y**2-10*y**3+93*y**4-102*y**5+37*y**6)+5*r**8*(-1300+3980*y
          -3370*y**2+546*y**3+609*y**4-435*y**5+153*y**6)+5*r**4*(179-898*y
          +989*y**2-277*y**3+551*y**4-943*y**5+485*y**6-94*y**7+8*y**8))+1728*logy**3*r**10*(
          -1+y)**6*(-1+r**2+y)**2*(1217*r**20*(-1+y)**4-2*r**18*(-1+y)**2*(-10369
          +21955*y-12803*y**2+1767*y**3)-r**16*(-1+y)**2*(-247659+410828*y
          -146530*y**2-18988*y**3+1349*y**4)-45*(-1+y)**5*(-39-117*y-234*y**2
          -10*y**3+125*y**4+299*y**5-288*y**6+64*y**7)+2*r**14*(245995-916994*y
          +1282684*y**2-732665*y**3+31790*y**4+124345*y**5-39646*y**6+5366*y**7)
          +r**12*(1318276-3709912*y+3447246*y**2-545260*y**3-993285*y**4+603624*y**5
          -149878*y**6+37574*y**7-1785*y**8)-2*r**2*(-1+y)**4*(8998+19751*y
          +32259*y**2-21213*y**3-12075*y**4-31698*y**5+50474*y**6-21734*y**7
          +2988*y**8)+2*r**6*(-1+y)**2*(-60027-37996*y-35935*y**2+791551*y**3
          -961018*y**4+382552*y**5-36404*y**6+1885*y**7-6751*y**8+1968*y**9)
          -r**4*(-1+y)**3*(-190085-109347*y-93994*y**2+723774*y**3-499733*y**4
          +167305*y**5-135558*y**6+98564*y**7-29004*y**8+2528*y**9)-2*r**10*(
          -478309+1232036*y-857179*y**2-591849*y**3+1377471*y**4-864346*y**5
          +111884*y**6+111424*y**7-47356*y**8+3599*y**9)+r**8*(101392-80644*y
          -501894*y**2+2126496*y**3-3881489*y**4+3345102*y**5-1077631*y**6-230156*y**7
          +260679*y**8-70236*y**9+8381*y**10))+144*logy**2*r**6*(-1+y)**4*(-1+r**2
          +y)**3*(41*r**26*(-1+y)**6-r**24*(-1+y)**4*(-4095+8313*y-4341*y**2
          +529*y**3)+2*r**22*(-1+y)**2*(76051-288502*y+404574*y**2-248745*y**3
          +57443*y**4-743*y**5+82*y**6)+2*r**20*(-1+y)**2*(550294-2040343*y
          +2802840*y**2-1681754*y**3+340818*y**4+43535*y**5-14493*y**6+1278*y**7)
          -r**18*(-1+y)**2*(-6562987+20316322*y-21259584*y**2+6221014*y**3+3009971*y**4
          -1867056*y**5+180306*y**6-27852*y**7+1866*y**8)+3*(-1+y)**8*(-41-205*y
          -615*y**2-953*y**3-611*y**4+901*y**5+955*y**6+425*y**7-1232*y**8+376*y**9)
          +r**2*(-1+y)**7*(6323+25661*y+65075*y**2+54325*y**3+10545*y**4-83577*y**5
          -7091*y**6-8525*y**7+41860*y**8-19420*y**9+2424*y**10)+r**16*(6242711
          -33497961*y+74911065*y**2-83693061*y**3+37136037*y**4+15126021*y**5
          -26018187*y**6+11687475*y**7-1802394*y**8-194592*y**9+109308*y**10-5622*y**11)
          +2*r**4*(-1+y)**6*(-88242-242805*y-457932*y**2+81626*y**3+253657*y**4
          +550563*y**5-663545*y**6+206292*y**7-41206*y**8+27238*y**9-9136*y**10
          +940*y**11)-r**8*(-1+y)**4*(4746587-71713*y-134299*y**2-18942509*y**3
          +20914450*y**4-8016062*y**5+3579952*y**6-2864836*y**7+955289*y**8-6325*y**9
          -41375*y**10+1441*y**11)-r**10*(-1+y)**3*(1477535-5099517*y-1011747*y**2
          +35286345*y**3-52268202*y**4+23709630*y**5+2900748*y**6-5249448*y**7
          +1201395*y**8+55407*y**9-56865*y**10+1719*y**11)+2*r**6*(-1+y)**5*(364501
          +647879*y+952830*y**2-1617433*y**3-369714*y**4-1295138*y**5+3000665*y**6
          -1655925*y**7+230953*y**8+58609*y**9-18083*y**10+1756*y**11)+2*r**12*(
          -1+y)**2*(4090748-6249260*y-3242364*y**2+19351490*y**3-23305613*y**4
          +8600073*y**5+4691618*y**6-4766846*y**7+1080690*y**8+71523*y**9-34791*y**10
          +3882*y**11)+2*r**14*(7816482-30554838*y+43667928*y**2-20214020*y**3
          -14380353*y**4+21976572*y**5-8929767*y**6-488936*y**7+1612935*y**8-641872*y**9
          +146681*y**10-13050*y**11+2238*y**12))+12*logy*r**4*(-1+y)**4*(-1+r**2
          +y)**4*(-5*r**28*(-1+y)**6-r**26*(-1+y)**4*(-6909+12814*y-5393*y**2
          +168*y**3)-2*r**24*(-1+y)**2*(-144764+543232*y-748111*y**2+457549*y**3
          -115967*y**4+6591*y**5+177*y**6)+2*r**22*(2118879-11431282*y+25125532*y**2
          -28458584*y**3+16957472*y**4-4383322*y**5-146105*y**6+223587*y**7-7886*y**8
          +289*y**9)+r**20*(14202397-73187318*y+153599257*y**2-163743508*y**3
          +84636562*y**4-7472154*y**5-12948550*y**6+5740960*y**7-934105*y**8+112600*y**9
          +2339*y**10)+r**18*(74860815-336435726*y+579178623*y**2-421151124*y**3
          +8718694*y**4+182853884*y**5-107782584*y**6+18493622*y**7+1749109*y**8
          -619404*y**9+127751*y**10+3340*y**11)+2*(-1+y)**8*(-33-198*y-693*y**2
          -1561*y**3-1637*y**4+651*y**5+1919*y**6+1811*y**7-1534*y**8+47*y**9
          -218*y**10-46*y**11+92*y**12)+r**2*(-1+y)**7*(15943+77027*y+224493*y**2
          +305421*y**3+183106*y**4-265162*y**5-228440*y**6-110346*y**7+285839*y**8
          -98081*y**9+12319*y**10-5427*y**11+1508*y**12)+2*r**16*(-1566273-9046878*y
          +73788333*y**2-135019123*y**3+56444031*y**4+84655067*y**5-103882559*y**6
          +34214595*y**7+4959468*y**8-5735061*y**9+1287686*y**10-35088*y**11+4002*y**12)
          +r**4*(-1+y)**6*(-356061-1333576*y-3173474*y**2-1982260*y**3+112941*y**4
          +4142750*y**5-647272*y**6+228658*y**7-1901605*y**8+1139754*y**9-175154*y**10
          -15022*y**11+5321*y**12)+2*r**6*(-1+y)**5*(2061929+4734767*y+7809217*y**2
          -7167823*y**3-6538694*y**4-10026442*y**5+19716291*y**6-8291768*y**7
          +664048*y**8-69781*y**9+168048*y**10-44553*y**11+5961*y**12)+2*r**8*(
          -1+y)**4*(-3072090-4192852*y-6323947*y**2+21975491*y**3-1322124*y**4
          +16621130*y**5-49289531*y**6+33066462*y**7-4759641*y**8-2477046*y**9
          +937050*y**10-109337*y**11+10635*y**12)+r**10*(-1+y)**3*(57720901-35523123*y
          -17821821*y**2-194227997*y**3+349461666*y**4-167402494*y**5-13373942*y**6
          +29416638*y**7-5325423*y**8-952831*y**9+564923*y**10-122145*y**11+31048*y**12)
          +r**12*(-1+y)**2*(77354565-173100420*y+27988938*y**2+427122916*y**3
          -622333653*y**4+244944892*y**5+119355188*y**6-117973884*y**7+20520399*y**8
          +5333088*y**9-1650782*y**10+76992*y**11+32361*y**12)+4*r**14*(25679397
          -66368310*y+20269050*y**2+97330768*y**3-110881267*y**4-2391692*y**5
          +81062497*y**6-60951047*y**7+16533144*y**8+855627*y**9-1432295*y**10
          +300923*y**11-12018*y**12+5223*y**13))+r**2*(-1+y)**2*(-1+r**2+y)**5*(r**32*(
          -1+y)**8+r**30*(-1+y)**6*(-36+67*y-26*y**2+6*y**3)+r**28*(-1+y)**4*(886
          -3429*y+4841*y**2-3139*y**3+1001*y**4-120*y**5+10*y**6)+r**26*(-1
          +y)**2*(210280-1183087*y+2729760*y**2-3298449*y**3+2193942*y**4-757814*y**5
          +104468*y**6+1375*y**7-58*y**8+7*y**9)+r**24*(3837190-28195991*y+89407483*y**2
          -159553458*y**3+174838154*y**4-119838193*y**5+49475985*y**6-10702519*y**7
          +643511*y**8+84172*y**9+3892*y**10+373*y**11+121*y**12)-(-1+y)**11*(
          -1-8*y-36*y**2-425*y**3-865*y**4+270*y**5+1774*y**6+2120*y**7-351*y**8
          -744*y**9+342*y**10-135*y**11-23*y**12+2*y**13)+r**22*(29424292-201225661*y
          +585815036*y**2-932806779*y**3+853881510*y**4-403171490*y**5+23544900*y**6
          +74778918*y**7-35978948*y**8+5961987*y**9-271440*y**10+43853*y**11+1178*y**12
          +724*y**13)+r**14*(-1+y)**3*(-1007519780+2171387467*y-656565203*y**2
          -1885368439*y**3+1555648085*y**4+401038022*y**5-898942320*y**6+255729234*y**7
          +87800742*y**8-55897177*y**9+7654973*y**10+1876373*y**11-481991*y**12
          +115192*y**13+22*y**14)-r**2*(-1+y)**9*(-4464-25997*y-88631*y**2-167241*y**3
          -167061*y**4+36119*y**5+157811*y**6+176034*y**7-77222*y**8-1387*y**9
          -42205*y**10+11511*y**11+3627*y**12-527*y**13+33*y**14)-r**4*(-1+y)**8*(385390
          +1757167*y+4871973*y**2+5838049*y**3+2911053*y**4-5686196*y**5-3210730*y**6
          -1123926*y**7+5269672*y**8-2295097*y**9+209061*y**10-48787*y**11+37533*y**12
          -4186*y**13+224*y**14)+3*r**16*(-1+y)**2*(-191271216+735804675*y-903225273*y**2
          +150580031*y**3+520303177*y**4-377353823*y**5+47532215*y**6+13854338*y**7
          +12567556*y**8-8946715*y**9+1191119*y**10+437175*y**11-58365*y**12+23903*y**13
          +803*y**14)-r**6*(-1+y)**7*(-3442852-11255843*y-24131541*y**2-2581949*y**3
          +12184227*y**4+38070188*y**5-20422930*y**6+3140726*y**7-14462494*y**8
          +11014045*y**9-2301121*y**10-232257*y**11+149655*y**12-18302*y**13+848*y**14)
          +r**20*(36600102-235324837*y+655150025*y**2-1014244371*y**3+905336865*y**4
          -382731080*y**5-66043694*y**6+170681682*y**7-89395480*y**8+23519515*y**9
          -3907847*y**10+236601*y**11+115953*y**12+5786*y**13+1980*y**14)-r**8*(
          -1+y)**6*(28204918+49827153*y+66968643*y**2-156312179*y**3-68492811*y**4
          -80584247*y**5+337603261*y**6-194072402*y**7+3982294*y**8+19719931*y**9
          -2650201*y**10-981259*y**11+343319*y**12-50805*y**13+1985*y**14)-r**12*(
          -1+y)**4*(403382574-370397609*y-148060003*y**2-1068040795*y**3+2492527789*y**4
          -1270672398*y**5-495105696*y**6+614154810*y**7-135344880*y**8-25868709*y**9
          +13843469*y**10-3341135*y**11+614293*y**12-125620*y**13+2310*y**14)
          -r**10*(-1+y)**5*(22727240+12947651*y-22146519*y**2-14386757*y**3-12616429*y**4
          +212555873*y**5-384086879*y**6+239956906*y**7-31718870*y**8-25827079*y**9
          +11502887*y**10-2718317*y**11+536643*y**12-95653*y**13+2903*y**14)+r**18*(394136512
          -2380286847*y+5896647282*y**2-7261867406*y**3+3508996308*y**4+1947508656*y**5
          -3802055028*y**6+2144208753*y**7-371654136*y**8-144688943*y**9+83718522*y**10
          -16049940*y**11+1308020*y**12+50142*y**13+25080*y**14+3025*y**15)))*math.log(mu0**2/r**2))/(
          -37324800*logy**5*r**20*(-1+y)**10+150*(r**8*(-1+y)**2-6*r**4*y*(2-3*y
          +y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(
          -1+y)**3*(-1-y-y**2+y**3))**5-15552000*logy**4*r**16*(-1+y)**8*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-2592000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          -216000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**3-9000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2
          -3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)
          +r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(518400*logy**4*r**14*(168
          +381*r**2+418*r**4+255*r**6+72*r**8)*(-1+y)**10+17280*logy**3*r**10*(
          -1+y)**8*(1313*r**14*(-1+y)**2+240*r**16*(-1+y)**2-15*r**12*(-988+1400*y
          -124*y**2-347*y**3+48*y**4)-24*(-1+y)**3*(-2-2*y-2*y**2+78*y**3
          -52*y**4+5*y**5)+r**10*(27453-24306*y-18447*y**2+14915*y**3+435*y**4
          +120*y**5)-5*r**2*(-1+y)**2*(901-1365*y**3+1374*y**4-600*y**5+50*y**6)
          +5*r**8*(2280+5472*y-12768*y**2+3068*y**3+2552*y**4-889*y**5+216*y**6)
          +15*r**6*(-1451+5950*y-6023*y**2+348*y**3+1551*y**4-501*y**5+62*y**6
          +24*y**7)+r**4*(-28908+77976*y-59148*y**2+2335*y**3+4680*y**4+7503*y**5
          -6466*y**6+2148*y**7-120*y**8))+288*logy**2*r**6*(-1+y)**6*(-1+r**2
          +y)**2*(204*r**20*(-1+y)**4-12*r**18*(-1+y)**2*(-427+888*y-495*y**2
          +54*y**3)-r**16*(-1+y)**2*(-98058+163572*y-55182*y**2-8795*y**3+1068*y**4)
          +r**14*(-1+y)**2*(371022-626076*y+230652*y**2+55595*y**3-19327*y**4
          +2424*y**5)+12*(-1+y)**4*(-3-6*y-9*y**2+88*y**3-45*y**4+8*y**5
          +411*y**6-486*y**7+142*y**8)+r**12*(2533086-7811280*y+7921674*y**2
          -1820325*y**3-1592930*y**4+804169*y**5-19560*y**6-17814*y**7+1980*y**8)
          -r**10*(-5267442+15926196*y-15397182*y**2+2453929*y**3+4173609*y**4
          -2082363*y**5+114159*y**6+127722*y**7-50704*y**8+3576*y**9)+r**2*(-1
          +y)**3*(1326+1398*y+1470*y**2+54757*y**3-48276*y**4+4044*y**5-46278*y**6
          +53775*y**7-21162*y**8+3746*y**9)-r**8*(-4499586+13448976*y-12888564*y**2
          +3089191*y**3+465406*y**4+1523593*y**5-1552776*y**6+425939*y**7+16784*y**8
          -31831*y**9+1668*y**10)+r**4*(-1+y)**2*(127038-11364*y-7152*y**2-855115*y**3
          +1384382*y**4-790452*y**5+169204*y**6-33333*y**7+32180*y**8-9892*y**9
          +1704*y**10)+r**6*(1075002-2726832*y+2044446*y**2-2057439*y**3+6031091*y**4
          -7979923*y**5+4769055*y**6-1120271*y**7-154811*y**8+143409*y**9-26679*y**10
          +2952*y**11))+24*logy*r**4*(-1+y)**4*(-1+r**2+y)**3*(315*r**22*(-1+y)**6
          -r**20*(-1+y)**4*(-19813+35675*y-14359*y**2+130*y**3)-r**18*(-1+y)**2*(
          -210069+772788*y-1041600*y**2+598782*y**3-107061*y**4-16470*y**5+2810*y**6)
          -r**16*(-1+y)**2*(-2260995+7253307*y-7886664*y**2+2641771*y**3+736351*y**4
          -511934*y**5+28634*y**6+1050*y**7)+2*r**14*(-1+y)**2*(2493553-8018104*y
          +9009846*y**2-3120440*y**3-1180790*y**4+916612*y**5-108206*y**6+1024*y**7
          +3855*y**8)+5*(-1+y)**6*(63+189*y+378*y**2+1351*y**3+824*y**4+621*y**5
          +1304*y**6-1465*y**7-223*y**8-266*y**9+174*y**10+50*y**11)+2*r**8*(
          -1+y)**2*(8020993-16913941*y+8458620*y**2-7999269*y**3+27062342*y**4
          -28843343*y**5+10494516*y**6+1232625*y**7-2038261*y**8+519128*y**9-10630*y**10
          +120*y**11)+r**2*(-1+y)**5*(17507+33205*y+47526*y**2+82532*y**3+25408*y**4
          -26700*y**5-428290*y**6+424634*y**7-157247*y**8+33627*y**9-8872*y**10
          +3470*y**11)+2*r**12*(17179311-78203385*y+135540423*y**2-98296904*y**3
          +1873844*y**4+40002240*y**5-19838840*y**6-22118*y**7+2229259*y**8-497389*y**9
          +30379*y**10+3480*y**11)+r**4*(-1+y)**4*(269949+251061*y+220311*y**2
          -2838154*y**3+2733486*y**4-929382*y**5+1587834*y**6-2137756*y**7+1036809*y**8
          -146531*y**9-20837*y**10+11010*y**11)+r**6*(-1+y)**3*(-3424035+2257953*y
          +646767*y**2+17755891*y**3-35928490*y**4+24721974*y**5-5272118*y**6
          -1471982*y**7+682969*y**8+27125*y**9-24629*y**10+11775*y**11)-2*r**10*(
          -25122951+114193854*y-197387919*y**2+143714186*y**3-6400124*y**4-53257692*y**5
          +26485248*y**6+936704*y**7-4577711*y**8+1659574*y**9-224157*y**10-20602*y**11
          +1590*y**12))+(-1+y)**4*(-1+r**2+y)**4*(r**28*(-1+y)**6+2*r**26*(-1
          +y)**4*(35-72*y+39*y**2+51*y**3)+r**24*(-1+y)**2*(30289-113880*y
          +156420*y**2-93710*y**3+22367*y**4-1618*y**5+220*y**6)-2*r**22*(-309546
          +1676460*y-3693678*y**2+4185664*y**3-2488454*y**4+639011*y**5+22098*y**6
          -32406*y**7+740*y**8+231*y**9)+r**20*(3593445-18633750*y+39037527*y**2
          -41239972*y**3+21309074*y**4-2814686*y**5-1885532*y**6+660216*y**7-34795*y**8
          +9744*y**9-1271*y**10)+2*r**18*(16754577-79118952*y+144867639*y**2
          -119944249*y**3+26830010*y**4+25099249*y**5-17591524*y**6+2801631*y**7
          +381489*y**8-87765*y**9+8609*y**10+486*y**11)+r**16*(21553093-100847610*y
          +196220109*y**2-189940934*y**3+75613988*y**4+9974110*y**5-12205540*y**6
          -2172438*y**7+1793419*y**8-34148*y**9+40167*y**10+1500*y**11+4284*y**12)
          -(-1+y)**7*(-89-445*y-1335*y**2-2397*y**3-3190*y**4-2906*y**5-510*y**6
          +1402*y**7+2691*y**8+195*y**9+85*y**10-445*y**11-532*y**12+276*y**13)
          +2*r**6*(-1+y)**4*(115866+314316*y+489954*y**2-1998752*y**3+266684*y**4
          -263591*y**5+5800956*y**6-7181948*y**7+3041546*y**8-416874*y**9+29410*y**10
          -19812*y**11+12704*y**12+341*y**13)+4*r**14*(101510398-417346012*y
          +617811474*y**2-292117772*y**3-193554056*y**4+272304755*y**5-77910692*y**6
          -27246140*y**7+19851382*y**8-3314724*y**9-33838*y**10+70764*y**11+996*y**12
          +465*y**13)-2*r**2*(-1+y)**6*(-1895-7402*y-18060*y**2-28771*y**3-30145*y**4
          -19970*y**5+4772*y**6+15204*y**7+16575*y**8-4100*y**9+880*y**10-1945*y**11
          -1359*y**12+616*y**13)-2*r**10*(-1+y)**2*(-22997157+28859130*y-333534*y**2
          +95892305*y**3-257671977*y**4+222046289*y**5-52107140*y**6-32877074*y**7
          +22866529*y**8-3066668*y**9-911342*y**10+200385*y**11-41107*y**12+961*y**13)
          -r**4*(-1+y)**5*(-65561-189439*y-361500*y**2-240972*y**3-206513*y**4
          +81211*y**5+875152*y**6-283928*y**7+147477*y**8-253737*y**9+110060*y**10
          -15868*y**11-8267*y**12+1485*y**13)+r**8*(-1+y)**3*(-7461315-2074635*y
          -356127*y**2+60469211*y**3-76635676*y**4+32492758*y**5-20570998*y**6
          +26802710*y**7-15049987*y**8+1765721*y**9+1026677*y**10-275697*y**11
          +60162*y**12+1596*y**13)+r**12*(151837363-562423394*y+730610293*y**2
          -381031244*y**3+205018899*y**4-403635626*y**5+376014785*y**6-100491192*y**7
          -37900671*y**8+27965810*y**9-7177897*y**10+1253524*y**11-93111*y**12
          +55530*y**13-3069*y**14)))*nlo.X1El(0,'SM',y/2,r))/(149299200*logy**5*r**20*(
          -1+y)**10-600*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5
          +62208000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+10368000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+864000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +36000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*(-21600*logy**3*r**11*(27+41*r**2+29*r**4+9*r**6)*(
          -1+y)**8-720*logy**2*r**7*(-1+y)**6*(74*r**12*(-1+y)**2+31*r**14*(-1
          +y)**2+r**10*(1389-1968*y+174*y**2+485*y**3-90*y**4)+5*r**8*(443
          -364*y-340*y**2+242*y**3+y**4+4*y**5)-(-1+y)**3*(11+11*y+11*y**2
          +251*y**3-184*y**4+20*y**5)-r**2*(-1+y)**2*(599-455*y**3+430*y**4
          -234*y**5+20*y**6)+5*r**6*(-17+772*y-1124*y**2+168*y**3+255*y**4
          -105*y**5+27*y**6)+r**4*(-3036+8502*y-6681*y**2-50*y**3+1860*y**4
          -744*y**5+113*y**6+36*y**7))-6*logy*r**3*(-1+y)**4*(-1+r**2+y)**2*(41*r**18*(
          -1+y)**4-r**16*(-1+y)**2*(-643+1368*y-807*y**2+162*y**3)-r**14*(
          -1+y)**2*(-15790+25508*y-7489*y**2-1926*y**3+257*y**4)+r**12*(-1
          +y)**2*(22492-45292*y+26723*y**2+338*y**3-2257*y**4+556*y**5)+(-1
          +y)**4*(11+22*y+33*y**2+604*y**3-95*y**4+94*y**5+683*y**6-1128*y**7
          +376*y**8)+r**10*(325264-987788*y+962749*y**2-168480*y**3-240815*y**4
          +115216*y**5-2237*y**6-4404*y**7+495*y**8)+r**2*(-1+y)**3*(1217+1195*y
          +1173*y**2+10851*y**3-12281*y**4+853*y**5-4525*y**6+5397*y**7-1856*y**8
          +376*y**9)+r**4*(-1+y)**2*(18460+228*y-1059*y**2-127026*y**3+222587*y**4
          -138000*y**5+21407*y**6+9694*y**7-3339*y**8+648*y**9)-r**8*(-592234
          +1816036*y-1796019*y**2+337456*y**3+482771*y**4-315066*y**5+67539*y**6
          +5044*y**7-6881*y**8+754*y**9)+r**6*(171082-446136*y+345989*y**2-173976*y**3
          +407904*y**4-548040*y**5+323186*y**6-83264*y**7-1874*y**8+5496*y**9
          -367*y**10))-r*(-1+y)**3*(-1+r**2+y)**3*(11*r**20*(-1+y)**5-r**18*(
          -1+y)**3*(-887+1561*y-584*y**2+20*y**3)-r**14*(-1+y)**2*(98866-215370*y
          +117060*y**2+18665*y**3-23400*y**4+2019*y**5+60*y**6)-6*r**16*(829
          -3910*y+7345*y**2-6960*y**3+3400*y**4-689*y**5-40*y**6+25*y**7)+r**12*(56552
          -202342*y+195188*y**2+67937*y**3-212345*y**4+111118*y**5-11938*y**6
          -5343*y**7+783*y**8+390*y**9)+(-1+y)**5*(56+168*y+336*y**2+869*y**3
          +572*y**4+363*y**5+82*y**6-561*y**7-144*y**8-47*y**9+106*y**10)+3*r**10*(
          -502676+1833106*y-2306948*y**2+790633*y**3+694954*y**4-671513*y**5
          +142444*y**6+32823*y**7-14458*y**8+871*y**9+164*y**10)+3*r**4*(-1+y)**3*(2543
          +3408*y+3113*y**2-42897*y**3+52608*y**4-18023*y**5+5142*y**6-7563*y**7
          +2797*y**8-133*y**9+205*y**10)+r**6*(-1+y)**2*(-128446+85278*y+28872*y**2
          +551901*y**3-1196170*y**4+902511*y**5-195488*y**6-103457*y**7+56364*y**8
          -5265*y**9+300*y**10)+r**2*(-1+y)**4*(1603+3104*y+4470*y**2+2351*y**3
          +1462*y**4-2943*y**5-16354*y**6+18205*y**7-7701*y**8+763*y**9+440*y**10)
          +r**8*(-598858+1924148*y-2036302*y**2+663653*y**3-36127*y**4+208109*y**5
          -130003*y**6+28427*y**7-47803*y**8+28227*y**9-3651*y**10+180*y**11)))*nlo.X1El(0,'VR',y/2,r))/(3110400*logy**4*r**16*(
          -1+y)**8+1036800*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+129600*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+7200*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +150*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6+120*logy*r**4*(
          -1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(-67+98*y
          -13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3-2*y**4
          +y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)+2*r**2*(
          -1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y-421*y**2
          +40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(
          -1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1
          +y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(
          -4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y
          +45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)
          +2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5
          -56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(0,'VR2',y/2,r))/(1036800*logy**3*r**12*(
          -1+y)**6-600*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +259200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-8640*logy**3*r**10*(10+20*r**2
          +17*r**4+6*r**6)*(-1+y)**8-144*logy**2*r**6*(-1+y)**6*(155*r**12*(-1+y)**2
          +18*r**14*(-1+y)**2+r**10*(1818-2556*y+198*y**2+610*y**3-60*y**4)
          +2*(-1+y)**3*(-1-y-y**2-41*y**3+24*y**4)+10*r**8*(201-96*y-258*y**2
          +124*y**3+28*y**4)+10*r**2*(-1+y)**2*(-39+47*y**3-30*y**4+10*y**5)
          +10*r**6*(-103+566*y-643*y**2+64*y**3+140*y**4-37*y**5+9*y**6)+r**4*(
          -2583+6966*y-5283*y**2+140*y**3+705*y**4+138*y**5-131*y**6+48*y**7))
          -12*logy*r**4*(-1+y)**4*(-1+r**2+y)**2*(49*r**14*(-1+y)**4+2*r**12*(
          -1+y)**2*(586-1005*y+360*y**2+33*y**3)-r**10*(-1+y)**2*(-5415+8688*y
          -2706*y**2-920*y**3+93*y**4)-2*(-1+y)**4*(23+46*y+69*y**2+138*y**3
          +23*y**4-53*y**6+4*y**7)-2*r**8*(-20597+62840*y-61851*y**2+12064*y**3
          +13199*y**4-5694*y**5+19*y**6+30*y**7)+r**2*(-1+y)**3*(-1237-1193*y
          -1125*y**2+5351*y**3-3239*y**4+813*y**5-31*y**6+101*y**7)+2*r**4*(
          -1+y)**2*(6180-3441*y-1146*y**2-7549*y**3+7956*y**4-1959*y**5-38*y**6
          +177*y**7)+r**6*(53099-159664*y+153452*y**2-30640*y**3-24930*y**4
          +7216*y**5+1844*y**6-672*y**7+295*y**8))+(-1+y)**4*(-1+r**2+y)**3*(r**20*(
          -1+y)**4-r**18*(-1+y)**2*(45-87*y+39*y**2+5*y**3)-2*r**16*(655-2392*y
          +3162*y**2-1745*y**3+305*y**4+7*y**5+12*y**6)-2*r**14*(7067-22973*y
          +25428*y**2-9172*y**3-1545*y**4+1191*y**5-12*y**6+6*y**7)+2*r**12*(
          -17402+53024*y-54363*y**2+13768*y**3+9043*y**4-3576*y**5-335*y**6
          -138*y**7+19*y**8)+2*(-1+y)**5*(2+8*y+20*y**2+25*y**3+21*y**4+4*y**5
          -8*y**6-11*y**7-7*y**8+6*y**9)+2*r**10*(-147658+379090*y-263769*y**2
          -56529*y**3+119577*y**4-24007*y**5-7121*y**6+1697*y**7-389*y**8+9*y**9)
          -2*r**6*(-1+y)**2*(8957+3227*y+1343*y**2-35887*y**3+28653*y**4-6461*y**5
          -625*y**6+655*y**7+236*y**8+22*y**9)+r**4*(-1+y)**3*(1085+2299*y
          +3390*y**2-4446*y**3+468*y**4-1540*y**5+2110*y**6-1042*y**7-197*y**8
          +33*y**9)+r**2*(-1+y)**4*(145+423*y+822*y**2+816*y**3+488*y**4-10*y**5
          -234*y**6-144*y**7-69*y**8+43*y**9)-2*r**8*(46727-99746*y+50112*y**2
          -20880*y**3+74828*y**4-65172*y**5+10516*y**6+4518*y**7-1305*y**8+372*y**9
          +30*y**10)))*nlo.X1El(1,'SM',y/2,r))/(103680*logy**4*r**16*(-1+y)**8+34560*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +4320*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+240*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+5*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(-720*logy**2*r**7*(4+5*r**2
          +2*r**4)*(-1+y)**6-24*logy*r**3*(-1+y)**4*(8*r**10*(-1+y)**2+3*r**12*(
          -1+y)**2-5*r**8*(-44+64*y-8*y**2-13*y**3+2*y**4)+2*(-1+y)**3*(
          -1-y-y**2-6*y**3+4*y**4)+5*r**6*(26+8*y-64*y**2+21*y**3+7*y**4)
          +r**2*(-1+y)**2*(-58+35*y**3-15*y**4+8*y**5)+5*r**4*(-61+170*y-133*y**2
          +y**3+31*y**4-11*y**5+3*y**6))-r*(-1+y)**3*(-1+r**2+y)**2*(7*r**12*(
          -1+y)**3+2*r**10*(-81+214*y-174*y**2+35*y**3+6*y**4)+r**8*(-169
          +509*y-558*y**2+220*y**3+3*y**4-5*y**5)-4*r**6*(1431-2992*y+1413*y**2
          +518*y**3-447*y**4+47*y**5)+(-1+y)**3*(-13-26*y-39*y**2-54*y**3
          -9*y**4+4*y**5+17*y**6)+2*r**2*(-1+y)**2*(-61-72*y-71*y**2+319*y**3
          -256*y**4+55*y**5+26*y**6)+r**4*(-1749+2827*y-705*y**2+335*y**3-1195*y**4
          +489*y**5-47*y**6+45*y**7)))*nlo.X1El(1,'VR',y/2,r))/(-8640*logy**3*r**12*(
          -1+y)**6+5*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -2160*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-180*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1
          +y)**4-(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1
          +y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(1,'VR2',y/2,r))/(1440*logy**2*r**8*(-1+y)**4+240*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(144*logy**2*r**6*(4+7*r**2+4*r**4)*(-1+y)**6+24*logy*r**4*(-1
          +y)**4*(9*r**8*(-1+y)**2+21*r**4*y*(4-6*y+y**2+y**3)+3*r**2*(-1+y)**2*(
          -24+16*y+8*y**2+y**3)-(-1+y)**3*(-9-9*y-9*y**2+2*y**3)+r**6*(72
          -96*y+25*y**3))-(-1+y)**4*(-1+r**2+y)**2*(1+r**12*(-1+y)**2-6*y**3
          +4*y**4+8*y**6-10*y**7+3*y**8+r**10*(-30+58*y-26*y**2)-r**8*(285
          -412*y+74*y**2+62*y**3+7*y**4)-4*r**6*(383-383*y-56*y**2+84*y**3
          +15*y**4+2*y**5)+r**4*(-285+158*y+53*y**2+324*y**3-215*y**4-38*y**5
          +3*y**6)+2*r**2*(-15+y+y**2+40*y**3-17*y**4-y**5-13*y**6+4*y**7)))*nlo.X1El(2,'SM',y/2,r))/(1728*logy**3*r**12*(
          -1+y)**6-(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +432*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+36*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-24*logy*r**3*(1+r**2)*(-1
          +y)**4-4*r*(-1+y)**3*(r**6*(-1+y)+3*r**2*(-1+y)**2*(3+y)+3*r**4*(
          -3+y+y**2)+(-1+y)**2*(1+y+y**2)))*nlo.X1El(2,'VR',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(2,'VR2',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.VR2

    if wc.VLVR != 0:
      resNP = 0
      resNP +=((43200*logy**3*r**11*(3+4*r**2+4*r**4+3*r**6)*(-1+y)**6+720*logy**2*r**7*(
          -1+y)**4*(71*r**12*(-1+y)**2+22*r**14*(-1+y)**2+r**10*(627-714*y-183*y**2
          +380*y**3-60*y**4)-2*(-1+y)**4*(11+22*y+33*y**2-46*y**3+10*y**4)
          +10*r**8*(13+46*y-95*y**2+40*y**3-y**4+2*y**5)+r**4*(-1+y)**2*(-627
          +540*y+270*y**2-320*y**3+95*y**4+12*y**5)-r**2*(-1+y)**3*(-71-71*y
          -71*y**2+189*y**3-136*y**4+20*y**5)+10*r**6*(-13+98*y-121*y**2-6*y**3
          +75*y**4-42*y**5+9*y**6))+12*logy*r**3*(-1+y)**3*(-1+r**2+y)**2*(7*r**18*(
          -1+y)**3+r**16*(-296+902*y-930*y**2+378*y**3-54*y**4)+r**14*(-5915
          +15711*y-12984*y**2+2576*y**3+691*y**4-79*y**5)+(-1+y)**5*(7+28*y
          +70*y**2+120*y**3-5*y**4-212*y**5+92*y**6)+r**12*(-6509+18163*y-17985*y**2
          +4515*y**3+2610*y**4-946*y**5+152*y**6)+2*r**2*(-1+y)**4*(-148-451*y
          -916*y**2+260*y**3+30*y**4+413*y**5-234*y**6+46*y**7)-r**6*(-1+y)**2*(6509
          +5145*y+6331*y**2-36325*y**3+24015*y**4-2669*y**5-1095*y**6+89*y**7)
          +r**4*(-1+y)**3*(5915+9796*y+12984*y**2-25840*y**3+9875*y**4+920*y**5
          -906*y**6+156*y**7)+r**10*(-62873+113873*y-33585*y**2-49785*y**3+33325*y**4
          -1717*y**5-1203*y**6+165*y**7)-r**8*(62873-137619*y+69204*y**2+59092*y**3
          -78525*y**4+25977*y**5+594*y**6-1754*y**7+158*y**8))-r*(-1+y)**2*(
          -1+r**2+y)**3*(r**20*(-1+y)**4+r**18*(-1+y)**2*(-488+889*y-356*y**2
          +5*y**3)+3*r**16*(-2157+7903*y-10562*y**2+6308*y**3-1637*y**4+105*y**5)
          -(-1+y)**8*(-1-7*y-28*y**2+12*y**3+77*y**4+23*y**5+4*y**6)-2*r**14*(30632
          -95657*y+98760*y**2-24035*y**3-19975*y**4+10938*y**5-993*y**6+30*y**7)
          -r**2*(-1+y)**5*(-488-1865*y-4487*y**2-3675*y**3+885*y**4+7413*y**5
          -3505*y**6+287*y**7+35*y**8)-3*r**4*(-1+y)**4*(2157+5746*y+10562*y**2
          -7610*y**3+2650*y**4-1242*y**5+1034*y**6-342*y**7+45*y**8)-2*r**12*(
          -25939+77785*y-59421*y**2-7885*y**3+22140*y**4-8381*y**5+2055*y**6
          +141*y**7+105*y**8)-2*r**6*(-1+y)**3*(-30632-34393*y-33735*y**2+161245*y**3
          -76500*y**4-8743*y**5+11613*y**6-1905*y**7+150*y**8)-2*r**8*(-1+y)**2*(
          -25939+32*y+18332*y**2+2980*y**3+8365*y**4-3866*y**5+3348*y**6-762*y**7
          +210*y**8)-6*r**10*(95352-238380*y+152376*y**2+88800*y**3-151233*y**4
          +52083*y**5+4570*y**6-4006*y**7+375*y**8+63*y**9)))/(-518400*logy**3*r**12*(
          -1+y)**6+300*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -129600*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-10800*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-518400*logy**4*r**15*(-3+4*r**2
          +12*r**4+15*r**6)*(-1+y)**8-8640*logy**3*r**11*(-1+y)**6*(303*r**14*(-1
          +y)**2+r**12*(557-1114*y+557*y**2+30*y**3)-5*r**10*(-575+430*y+505*y**2
          -494*y**3+60*y**4)+5*(-1+y)**3*(-55-55*y-55*y**2+191*y**3-112*y**4
          +20*y**5)+5*r**8*(-307+1190*y-1171*y**2+418*y**3-138*y**4+78*y**5)
          +r**2*(-1+y)**2*(-127-1150*y**3+1235*y**4-468*y**5+60*y**6)+5*r**6*(
          -431+1054*y-719*y**2+24*y**3+261*y**4-216*y**5+69*y**6)-r**4*(193
          +334*y-887*y**2+90*y**3+65*y**4+422*y**5-229*y**6+12*y**7))-144*logy**2*r**7*(
          -1+y)**4*(-1+r**2+y)**2*(421*r**18*(-1+y)**4-r**16*(-1+y)**2*(-8359
          +17560*y-10043*y**2+1942*y**3)-r**14*(-1+y)**2*(-97092+157204*y-51665*y**2
          -8304*y**3+257*y**4)-(-1+y)**5*(-833-2499*y-4998*y**2-310*y**3+2875*y**4
          +6693*y**5-6656*y**6+1528*y**7)+r**12*(90740-365364*y+577249*y**2
          -390800*y**3+34450*y**4+85820*y**5-37231*y**6+5636*y**7)+r**10*(330718
          -834456*y+612923*y**2+76590*y**3-295775*y**4+135422*y**5-35089*y**6
          +12372*y**7-1205*y**8)+r**4*(-1+y)**3*(71732+35808*y+27133*y**2-280753*y**3
          +233150*y**4-65902*y**5+8477*y**6-4393*y**7+1448*y**8)-r**2*(-1+y)**4*(5955
          +13576*y+22863*y**2-17954*y**3-3525*y**4-21670*y**5+30919*y**6-12508*y**7
          +1544*y**8)+r**6*(-1+y)**2*(31676-80900*y-42833*y**2+450852*y**3-487085*y**4
          +156424*y**5+21985*y**6-22172*y**7+4153*y**8)+r**8*(124314-274276*y
          +43999*y**2+557844*y**3-902951*y**4+566186*y**5-48799*y**6-104024*y**7
          +41281*y**8-3574*y**9))+12*logy*r**3*(-1+y)**3*(-1+r**2+y)**3*(7*r**24*(
          -1+y)**5+r**22*(-1+y)**3*(-638+1255*y-596*y**2+117*y**3)+r**20*(41204
          -197809*y+375995*y**2-355352*y**3+169948*y**4-35831*y**5+2077*y**6
          -232*y**7)+r**18*(266802-1248795*y+2320737*y**2-2166320*y**3+1038942*y**4
          -209565*y**5-9373*y**6+8280*y**7-708*y**8)-3*(-1+y)**7*(-7-35*y
          -105*y**2-211*y**3-157*y**4+167*y**5+245*y**6+115*y**7-304*y**8+92*y**9)
          +r**16*(1649289-6631428*y+9935031*y**2-6068242*y**3+135207*y**4+1487256*y**5
          -557277*y**6+59584*y**7-10458*y**8+1038*y**9)+r**6*(-1+y)**4*(-93074
          -191473*y-326709*y**2+577618*y**3-54374*y**4+583036*y**5-945652*y**6
          +443414*y**7-54328*y**8-5971*y**9+313*y**10)-r**8*(-1+y)**3*(-1309037
          +127984*y+230971*y**2+4783034*y**3-6140644*y**4+2022854*y**5+573716*y**6
          -495686*y**7+90621*y**8-1146*y**9+333*y**10)-r**2*(-1+y)**6*(1630+6583*y
          +16615*y**2+13053*y**3+909*y**4-23115*y**5+3937*y**6-2025*y**7+6857*y**8
          -3304*y**9+460*y**10)-r**4*(-1+y)**5*(-54428-148245*y-276534*y**2
          +71552*y**3+161266*y**4+317382*y**5-422970*y**6+133144*y**7+218*y**8
          -5401*y**9+816*y**10)+2*r**14*(-143350+139205*y+1127837*y**2-2245586*y**3
          +632752*y**4+1501882*y**5-1387310*y**6+398858*y**7-7974*y**8-15447*y**9
          +933*y**10)-2*r**10*(-1+y)**2*(-873366+1625157*y+179697*y**2-3995173*y**3
          +4164601*y**4-786855*y**5-774507*y**6+330283*y**7+3383*y**8-13536*y**9
          +1716*y**10)-2*r**12*(-1439316+3375459*y-1031061*y**2-3340418*y**3
          +2857764*y**4+755592*y**5-1973258*y**6+968046*y**7-192972*y**8+22321*y**9
          -3141*y**10+984*y**11))-r*(-1+y)**2*(-1+r**2+y)**4*(3*r**26*(-1+y)**6
          +r**24*(-1+y)**4*(-383+670*y-233*y**2+14*y**3)+2*r**22*(-1+y)**2*(18151
          -68058*y+92798*y**2-57364*y**3+16997*y**4-2124*y**5+10*y**6)+(-1
          +y)**10*(1+8*y+36*y**2+22*y**3-68*y**4-140*y**5-92*y**6+50*y**7
          +19*y**8+4*y**9)+2*r**20*(293461-1581600*y+3465875*y**2-3918644*y**3
          +2354738*y**4-643781*y**5+5465*y**6+24790*y**7-951*y**8+47*y**9)+r**18*(1227213
          -6151010*y+12628771*y**2-13582384*y**3+7823874*y**4-1756328*y**5-539390*y**6
          +456244*y**7-119051*y**8+14886*y**9+775*y**10)+r**2*(-1+y)**7*(1597
          +7729*y+22545*y**2+35921*y**3+20674*y**4-35858*y**5-29894*y**6-11870*y**7
          +39569*y**8-13959*y**9+661*y**10+85*y**11)+2*r**4*(-1+y)**6*(-24275
          -90386*y-213624*y**2-100138*y**3+21373*y**4+245107*y**5-124271*y**6
          +33439*y**7-37702*y**8+21687*y**9-4517*y**10+307*y**11)+2*r**6*(-1
          +y)**5*(318561+719501*y+1162698*y**2-1119772*y**3-994436*y**4-1411174*y**5
          +2889940*y**6-1153918*y**7-10753*y**8+85061*y**9-15282*y**10+1174*y**11)
          +4*r**12*(-1+y)**2*(8162815-13671650*y+576456*y**2+10153426*y**3-2301285*y**4
          -5517227*y**5+3240765*y**6+74209*y**7-424376*y**8+123675*y**9-13203*y**10
          +2295*y**11)+r**16*(10942159-49558070*y+85612431*y**2-61013654*y**3
          -3208512*y**4+33347098*y**5-20646876*y**6+4824454*y**7-325871*y**8+27612*y**9
          -6147*y**10+2976*y**11)+r**8*(-1+y)**4*(874927+790618*y+9369*y**2
          -765350*y**3-2072958*y**4+4727512*y**5-3492258*y**6+1065616*y**7-91625*y**8
          +49638*y**9-25839*y**10+5550*y**11)+r**10*(-1+y)**3*(12993683-5255233*y
          -4892007*y**2-37712275*y**3+58851726*y**4-18161794*y**5-10672230*y**6
          +7244402*y**7-1001185*y**8+8019*y**9-16179*y**10+8673*y**11)+4*r**14*(
          -4530563+19404840*y-28996867*y**2+13603930*y**3+7129940*y**4-8005778*y**5
          +264788*y**6+1140190*y**7+379035*y**8-535990*y**9+161451*y**10-16608*y**11
          +1632*y**12))))/(4665600*logy**4*r**16*(-1+y)**8+1555200*logy**3*r**12*(-1
          +y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +194400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+10800*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+225*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*muWC*(2073600*logy**4*r**15*(
          -9-4*r**2+4*r**4+9*r**6)*(-1+y)**8+34560*logy**3*r**11*(-1+y)**5*(289*r**14*(
          -1+y)**3+5*r**12*(-43+129*y-129*y**2-29*y**3+36*y**4)+r**10*(-1341
          +1863*y+1377*y**2-4199*y**3+2260*y**4-300*y**5)-5*r**2*(-1+y)**3*(
          -43+156*y**3-61*y**4+4*y**6)+5*r**8*(369-1299*y+1587*y**2-913*y**3
          +202*y**4-30*y**5+16*y**6)+(-1+y)**3*(289-720*y**3+765*y**4-264*y**5
          +20*y**6)+5*r**6*(369-915*y+627*y**2+127*y**3-639*y**4+669*y**5-337*y**6
          +63*y**7)+r**4*(-1341+6183*y-9423*y**2+5981*y**3-1885*y**4+1011*y**5
          -593*y**6+43*y**7+24*y**8))-576*logy**2*r**7*(-1+y)**3*(-1+r**2+y)**2*(
          -627*r**18*(-1+y)**5+r**16*(-1+y)**2*(7157-22725*y+25233*y**2-9639*y**3
          +1214*y**4)+r**14*(-1+y)**2*(84412-216784*y+171771*y**2-21569*y**3
          -16309*y**4+1919*y**5)+r**12*(29532-189312*y+496143*y**2-530203*y**3
          +138710*y**4+140058*y**5-109853*y**6+30777*y**7-3852*y**8)-(-1+y)**5*(
          -627-1254*y-1881*y**2+3972*y**3-365*y**4+242*y**5-951*y**6+256*y**7
          +8*y**8)+r**10*(103202-284626*y+219221*y**2+300583*y**3-761945*y**4
          +575833*y**5-133419*y**6-35221*y**7+21137*y**8-2765*y**9)+r**2*(-1
          +y)**4*(-7157-8411*y-9665*y**2+22901*y**3-1773*y**4+4577*y**5-16609*y**6
          +10105*y**7-1576*y**8+8*y**9)+r**6*(-1+y)**2*(-29532-12120*y+7437*y**2
          +341629*y**3-507409*y**4+245247*y**5-38965*y**6+7803*y**7-3539*y**8
          +249*y**9)-r**4*(-1+y)**3*(-84412+36452*y+8561*y**2+167410*y**3-222901*y**4
          +112952*y**5-56537*y**6+31554*y**7-10395*y**8+1216*y**9)+r**8*(-103202
          +540990*y-1116495*y**2+1499655*y**3-1632985*y**4+1198139*y**5-352315*y**6
          -135955*y**7+133795*y**8-34265*y**9+2638*y**10))+48*logy*r**3*(-1+y)**2*(
          -1+r**2+y)**3*(7*r**24*(-1+y)**6-r**22*(-1+y)**3*(1134-3423*y+3465*y**2
          -1141*y**3+129*y**4)+r**20*(47816-275271*y+655056*y**2-820249*y**3
          +565086*y**4-199221*y**5+25400*y**6+1477*y**7-94*y**8)+r**18*(179938
          -1039683*y+2514552*y**2-3174711*y**3+2129372*y**4-649047*y**5+8044*y**6
          +37819*y**7-6818*y**8+534*y**9)-(-1+y)**7*(-7-28*y-70*y**2-172*y**3
          +554*y**4+1340*y**5-1882*y**6+20*y**7+777*y**8-424*y**9+92*y**10)
          +r**16*(1479163-7348959*y+14456961*y**2-13329861*y**3+4013953*y**4
          +2619231*y**5-2536881*y**6+692089*y**7-43944*y**8-1908*y**9+156*y**10)
          +r**4*(-1+y)**5*(47816+84007*y+116139*y**2-243946*y**3+44472*y**4
          -20048*y**5+66932*y**6-34794*y**7+12436*y**8-7687*y**9+1237*y**10+36*y**11)
          +2*r**12*y*(1662147-6648588*y+11954695*y**2-11886770*y**3+5136873*y**4
          +2122280*y**5-3938126*y**6+1992595*y**7-409330*y**8+8662*y**9+5493*y**10
          +69*y**11)+r**2*(-1+y)**6*(-1134-3423*y-6888*y**2+6006*y**3+66*y**4
          +2844*y**5+6876*y**6-6482*y**7-1336*y**8+2499*y**9-920*y**10+92*y**11)
          -r**6*(-1+y)**4*(179938+139993*y+155200*y**2-415367*y**3-212296*y**4
          -69772*y**5+861598*y**6-660760*y**7+169362*y**8-1829*y**9-3586*y**10
          +119*y**11)-2*r**14*(508358-1948797*y+1903188*y**2+296223*y**3-458736*y**4
          -1580193*y**5+2000031*y**6-858523*y**7+116332*y**8+26806*y**9-10605*y**10
          +516*y**11)+2*r**10*(-1+y)**2*(508358-1609709*y+885924*y**2+3467994*y**3
          -5928658*y**4+2931421*y**5+207351*y**6-569809*y**7+105466*y**8+19488*y**9
          -7929*y**10+903*y**11)+r**8*(-1+y)**3*(1479163-1526019*y-100389*y**2
          -2256693*y**3+4770486*y**4-3671352*y**5+1837320*y**6-708896*y**7+103883*y**8
          +27299*y**9-9711*y**10+909*y**11))+4*r*(-1+y)*(-1+r**2+y)**4*(r**26*(
          -1+y)**7+r**24*(-1+y)**4*(-607+1741*y-1623*y**2+397*y**3+4*y**4)
          +2*r**22*(-1+y)**2*(-21213+100435*y-187240*y**2+169300*y**3-74827*y**4
          +15041*y**5-1060*y**6+4*y**7)-(-1+y)**10*(-1-7*y-28*y**2-256*y**3
          -272*y**4+748*y**5+484*y**6-160*y**7+113*y**8+19*y**9)+2*r**20*(-306011
          +1934403*y-5140021*y**2+7342779*y**3-5918146*y**4+2467104*y**5-269235*y**6
          -157911*y**7+49189*y**8-2431*y**9+40*y**10)+r**18*(-176143+1106485*y
          -3429335*y**2+5331245*y**3-3172206*y**4-1324650*y**5+2792790*y**6-1350390*y**7
          +246665*y**8-28159*y**9+5573*y**10+525*y**11)+r**2*(-1+y)**7*(-607
          -2348*y-5712*y**2-828*y**3+19929*y**4+38708*y**5-50984*y**6+2644*y**7
          +15383*y**8-9304*y**9+1664*y**10-168*y**11+23*y**12)+2*r**4*(-1+y)**6*(21213
          +58009*y+108018*y**2-86216*y**3+41355*y**4-14581*y**5-169733*y**6
          +121375*y**7+21236*y**8-47960*y**9+15023*y**10-1851*y**11+112*y**12)
          +2*r**6*(-1+y)**5*(-306011-404348*y-462519*y**2+1506852*y**3-295842*y**4
          +6792*y**5-982382*y**6+831936*y**7-276347*y**8+21172*y**9+11749*y**10
          -4340*y**11+488*y**12)+4*r**12*(-1+y)**2*(-6346689+17071783*y-10978878*y**2
          -10263152*y**3+14988257*y**4-94405*y**5-8153331*y**6+4236809*y**7-269898*y**8
          -358772*y**9+98019*y**10-10107*y**11+1164*y**12)+r**16*(-11967921+66603547*y
          -149453787*y**2+163672189*y**3-69211024*y**4-32018008*y**5+52388880*y**6
          -24035080*y**7+3854121*y**8+282109*y**9-127461*y**10+5883*y**11+1752*y**12)
          +r**8*(-1+y)**4*(176143+49627*y+539055*y**2+2406075*y**3-7161634*y**4
          -140806*y**5+8888730*y**6-6641230*y**7+1252215*y**8+200259*y**9-64257*y**10
          -8277*y**11+2500*y**12)+r**10*(-1+y)**3*(-11967921+17171900*y-1158846*y**2
          +17932700*y**3-54254627*y**4+45517864*y**5-13589364*y**6-1282184*y**7
          +1713465*y**8-509908*y**9+83682*y**10-19716*y**11+4155*y**12)+4*r**14*(6346689
          -33701729*y+69183689*y**2-67740245*y**3+26935954*y**4+6087624*y**5
          -11723480*y**6+6678956*y**7-2864807*y**8+1051471*y**9-308593*y**10+60849*y**11
          -7260*y**12+882*y**13))))/(13996800*logy**4*r**16*(-1+y)**8+4665600*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +583200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+32400*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+675*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((muG*(518400*logy**4*r**13*(-15+2*r**2
          +7*r**4+13*r**6+9*r**8)*(-1+y)**8-8640*logy**3*r**9*(-1+y)**5*(485*r**16*(
          -1+y)**3+3*r**14*(364-1092*y+1092*y**2-649*y**3+135*y**4)+r**12*(3596
          -8628*y+5388*y**2-1191*y**3+105*y**4-120*y**5)-(-1+y)**4*(17+17*y
          +17*y**2+287*y**3-208*y**4+20*y**5)+r**10*(-948+5964*y-10644*y**2
          +5263*y**3-225*y**4-375*y**5+115*y**6)+r**2*(-1+y)**3*(-364-575*y**3
          +1690*y**4-846*y**5+140*y**6)-5*r**8*(554-1998*y+2502*y**2-956*y**3
          -251*y**4+438*y**5-226*y**6+27*y**7)+r**4*(-1+y)**2*(3548-7148*y
          +1800*y**2+4375*y**3-4735*y**4+3072*y**5-902*y**6+80*y**7)-5*r**6*(876
          -2724*y+2868*y**2-1213*y**3+153*y**4+18*y**5+160*y**6-180*y**7+42*y**8))
          +144*logy**2*r**5*(-1+y)**3*(-1+r**2+y)**2*(-1249*r**20*(-1+y)**5+2*r**18*(
          -1+y)**2*(5663-18238*y+20736*y**2-7845*y**3+1234*y**4)+r**16*(-1
          +y)**2*(105315-253795*y+176892*y**2+12019*y**3-35104*y**4+3273*y**5)
          +(-1+y)**6*(-283-849*y-1698*y**2-170*y**3+425*y**4+1503*y**5-736*y**6
          +8*y**7)+2*r**2*(-1+y)**5*(-76+131*y+621*y**2+4449*y**3+1010*y**4
          +1966*y**5-1161*y**6-2046*y**7+756*y**8)-2*r**14*(114213-442195*y
          +569834*y**2-293872*y**3+67755*y**4-46488*y**5+47575*y**6-23064*y**7
          +3742*y**8)-2*r**6*(-1+y)**3*(10845-29300*y-12011*y**2+131282*y**3
          -270261*y**4+221785*y**5-78815*y**6+15126*y**7-2112*y**8+386*y**9)
          +r**4*(-1+y)**4*(531+3329*y+3748*y**2-62177*y**3+43824*y**4-22476*y**5
          -7379*y**6+17422*y**7-9758*y**8+1536*y**9)-r**8*(-1+y)**2*(-529704
          +1246024*y-591528*y**2-1058205*y**3+1699308*y**4-1183301*y**5+444496*y**6
          -60277*y**7-3950*y**8+1537*y**9)-r**12*(611172-2498432*y+3643768*y**2
          -2349133*y**3+549110*y**4+225458*y**5-317923*y**6+170592*y**7-43667*y**8
          +4055*y**9)+2*r**10*(-87843+478723*y-1006943*y**2+1285011*y**3-1146900*y**4
          +612955*y**5-113658*y**6-53967*y**7+47829*y**8-17085*y**9+1878*y**10))
          -12*logy*r*(-1+y)**2*(-1+r**2+y)**3*(7*r**26*(-1+y)**6-r**24*(-1+y)**3*(2365
          -7116*y+7158*y**2-2249*y**3+252*y**4)+r**22*(90482-520032*y+1235100*y**2
          -1540770*y**3+1052915*y**4-364422*y**5+43672*y**6+3080*y**7-25*y**8)
          +(-1+y)**8*(-7-35*y-105*y**2-211*y**3-157*y**4+167*y**5+245*y**6
          +115*y**7-304*y**8+92*y**9)+r**20*(146870-857982*y+2138868*y**2-2716350*y**3
          +1699317*y**4-357693*y**5-104096*y**6+62614*y**7-12703*y**8+1155*y**9)
          +r**18*(1790613-8633490*y+16236417*y**2-13338951*y**3+1266462*y**4
          +5895762*y**5-4156710*y**6+984223*y**7-41569*y**8-2472*y**9-285*y**10)
          +r**2*(-1+y)**7*(589+2377*y+5995*y**2+4622*y**3+1489*y**4-5441*y**5
          +1293*y**6-640*y**7-1602*y**8+926*y**9+92*y**10)-r**8*(-1+y)**4*(229893
          +129417*y+119427*y**2+505472*y**3-779612*y**4+48565*y**5+560603*y**6
          -758367*y**7+403613*y**8-87158*y**9+1112*y**10+335*y**11)+r**4*(-1
          +y)**6*(-13530-35586*y-64602*y**2+2284*y**3+6323*y**4+22164*y**5-48642*y**6
          +11032*y**7+15221*y**8-1558*y**9-1774*y**10+368*y**11)+r**6*(-1+y)**5*(
          -50818-62402*y-49938*y**2+304296*y**3+67109*y**4+213688*y**5-156780*y**6
          -163342*y**7+143859*y**8-21974*y**9-1060*y**10+462*y**11)+r**10*(-1
          +y)**3*(-231857+1109763*y+35817*y**2-7113689*y**3+13964378*y**4-13176045*y**5
          +6337277*y**6-1029097*y**7-272851*y**8+171062*y**9-26088*y**10+1530*y**11)
          -r**16*(5427505-23821155*y+36965343*y**2-22749161*y**3+1002851*y**4
          +4020618*y**5-41686*y**6-1287268*y**7+424226*y**8+72509*y**9-43263*y**10
          +2481*y**11)+r**12*(-1+y)**2*(7874852-21001940*y+13806708*y**2+14116280*y**3
          -26868568*y**4+16893521*y**5-5199085*y**6+75527*y**7+473070*y**8-2037*y**9
          -33153*y**10+4425*y**11)+r**14*(-7281140+36557352*y-70991640*y**2+68905620*y**3
          -30371288*y**4-9252735*y**5+25783670*y**6-19162816*y**7+6689455*y**8
          -802947*y**9-95920*y**10+21198*y**11+1191*y**12))+r*(-1+y)*(-1+r**2
          +y)**4*(11*r**26*(-1+y)**7+r**24*(-1+y)**4*(1191-3445*y+3231*y**2-816*y**3
          +59*y**4)+2*r**22*(-1+y)**2*(43559-205923*y+383123*y**2-343334*y**3
          +148077*y**4-28764*y**5+2130*y**6+32*y**7)+r**20*(999074-6232462*y
          +16287640*y**2-22672254*y**3+17369854*y**4-6270241*y**5-109719*y**6
          +821504*y**7-200562*y**8+8725*y**9-359*y**10)+r**18*(-1578905+9579535*y
          -23094919*y**2+29830827*y**3-23582126*y**4+12092130*y**5-3509920*y**6
          +55234*y**7+189253*y**8+25401*y**9-10695*y**10-1815*y**11)+r**16*(18977573
          -106512835*y+241057093*y**2-265733760*y**3+111167883*y**4+57509221*y**5
          -91527831*y**6+42066485*y**7-6700060*y**8-496498*y**9+207906*y**10+1491*y**11
          -4668*y**12)+(-1+y)**8*(-605-2941*y-8613*y**2-13048*y**3-7819*y**4
          +11885*y**5+9913*y**6+4377*y**7-9802*y**8+2964*y**9-600*y**10-117*y**11
          +6*y**12)-r**2*(-1+y)**7*(-13695-50048*y-116530*y**2-71766*y**3-35291*y**4
          +42916*y**5-95022*y**6+17494*y**7+96441*y**8-34624*y**9+664*y**10+820*y**11
          +41*y**12)-r**4*(-1+y)**6*(110126+218066*y+314122*y**2-431716*y**3
          -30586*y**4+273191*y**5+502971*y**6-145273*y**7-90399*y**8-18649*y**9
          +54083*y**10-8947*y**11+611*y**12)-2*r**6*(-1+y)**5*(303679+138354*y
          -136736*y**2-2093905*y**3+185326*y**4-305979*y**5+1245580*y**6+883589*y**7
          -1281925*y**8+337529*y**9+42860*y**10-14524*y**11+1352*y**12)-2*r**12*(
          -1+y)**2*(-18297286+57751118*y-52444922*y**2-20269452*y**3+53827974*y**4
          -8070785*y**5-25014633*y**6+13197251*y**7-69253*y**8-1481479*y**9+403101*y**10
          -44685*y**11+5451*y**12)-r**8*(-1+y)**4*(3985775-264365*y-905749*y**2
          -5578804*y**3-163743*y**4-2738644*y**5+10959660*y**6-8666246*y**7+2281999*y**8
          +272493*y**9-7971*y**10-29370*y**11+6565*y**12)-r**10*(-1+y)**3*(7516451
          -14475244*y+591070*y**2+49327344*y**3-109195143*y**4+117320068*y**5
          -62597340*y**6+5377472*y**7+7830761*y**8-2323912*y**9+278046*y**10-41976*y**11
          +10203*y**12)-4*r**14*(16847155-89252541*y+184051054*y**2-179050769*y**3
          +59107305*y**4+43669904*y**5-56397383*y**6+26497675*y**7-6039969*y**8
          +797775*y**9-341749*y**10+129564*y**11-20109*y**12+2088*y**13))))/(18662400*logy**4*r**16*(
          -1+y)**8+6220800*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+777600*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+43200*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +900*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((mupi*(-518400*logy**4*r**15*(3+4*r**2+4*r**4+9*r**6)*(-1+y)**8-8640*logy**3*r**11*(
          -1+y)**4*(25*r**14*(-1+y)**4-3*r**12*(-193+772*y-1158*y**2+757*y**3
          -313*y**4+45*y**5)+r**10*(1517-3908*y+1542*y**2+4367*y**3-4223*y**4
          +1275*y**5-60*y**6)-r**2*(-1+y)**4*(9-1045*y**3+1755*y**4-714*y**5
          +80*y**6)-(-1+y)**4*(67-915*y**3+1335*y**4-582*y**5+80*y**6)-5*r**8*(221
          -1076*y+1998*y**2-1811*y**3+527*y**4+114*y**5-86*y**6+11*y**7)+5*r**6*(
          -25+292*y-822*y**2+636*y**3+786*y**4-1599*y**5+1066*y**6-307*y**7
          +27*y**8)+5*r**4*(-163+796*y-1482*y**2+861*y**3+594*y**4-747*y**5
          -212*y**6+596*y**7-285*y**8+42*y**9))+144*logy**2*r**7*(-1+y)**2*(-1
          +r**2+y)**2*(349*r**18*(-1+y)**6+r**16*(-1+y)**2*(-1993+7274*y-9166*y**2
          +3714*y**3-2161*y**4+472*y**5)-r**14*(-1+y)**2*(24220-95668*y+141675*y**2
          -94935*y**3+37540*y**4-9085*y**5+1413*y**6)+r**12*(-77212+401780*y
          -840723*y**2+834174*y**3-427119*y**4+146922*y**5-42425*y**6+3088*y**7
          -2309*y**8+824*y**9)-(-1+y)**5*(319+319*y+319*y**2-3031*y**3+2159*y**4
          -1549*y**5-4949*y**6+12001*y**7-7724*y**8+1536*y**9)+r**4*(-1+y)**3*(14500
          -19432*y+5073*y**2-294607*y**3+803463*y**4-799227*y**5+336287*y**6
          -43483*y**7-2793*y**8-1453*y**9+772*y**10)+r**10*(-217714+1017436*y
          -1820559*y**2+1199811*y**3+213456*y**4-555276*y**5+163554*y**6-24811*y**7
          +33984*y**8-14296*y**9+1415*y**10)-r**2*(-1+y)**4*(3883-638*y-638*y**2
          -40533*y**3+66542*y**4-34084*y**5+26298*y**6-48827*y**7+39243*y**8
          -13382*y**9+1536*y**10)+r**6*(-1+y)**2*(-1252-7884*y+10651*y**2+280741*y**3
          -1190414*y**4+1669285*y**5-1058606*y**6+278099*y**7+1724*y**8-12381*y**9
          +1537*y**10)+r**8*(-91894+515064*y-1140015*y**2+958830*y**3-70260*y**4
          +92748*y**5-833008*y**6+879380*y**7-356890*y**8+37450*y**9+10311*y**10
          -1716*y**11))+12*logy*r**3*(-1+y)*(-1+r**2+y)**3*(r**24*(-1+y)**7-r**22*(
          -1+y)**3*(-1094+4379*y-6576*y**2+4675*y**3-1258*y**4+120*y**5)+r**20*(
          -10908+71265*y-197625*y**2+298431*y**3-252828*y**4+100698*y**5+3701*y**6
          -16883*y**7+4372*y**8-223*y**9)+(-1+y)**8*(-91-364*y-910*y**2-1171*y**3
          -346*y**4+1568*y**5-106*y**6+1025*y**7-579*y**8-694*y**9+368*y**10)
          +r**18*(161206-1052977*y+2895351*y**2-4300267*y**3+3811624*y**4-2181513*y**5
          +866264*y**6-226679*y**7+28864*y**8-2332*y**9+459*y**10)+r**16*(238999
          -1499866*y+3999624*y**2-5798573*y**3+5002436*y**4-2768661*y**5+1135161*y**6
          -363744*y**7+44473*y**8+17519*y**9-8013*y**10+645*y**11)+r**14*(781564
          -4161730*y+8759046*y**2-7423408*y**3+918454*y**4+1433865*y**5-35862*y**6
          -79134*y**7-270487*y**8+120371*y**9-34774*y**10+8412*y**11-717*y**12)
          -r**6*(-1+y)**4*(-131146+97155*y+34395*y**2+1535148*y**3-3112476*y**4
          +2096133*y**5-799698*y**6+1002060*y**7-1051343*y**8+452326*y**9-69087*y**10
          -1002*y**11+335*y**12)+r**2*(-1+y)**6*(-314-901*y-1761*y**2+9230*y**3
          -5213*y**4+6195*y**5+26452*y**6-38002*y**7+7585*y**8-112*y**9+5079*y**10
          -2606*y**11+368*y**12)+r**8*(-1+y)**3*(-142789+194506*y-101634*y**2
          +4957474*y**3-15970501*y**4+18304377*y**5-9134256*y**6+1060770*y**7
          +910126*y**8-444509*y**9+91432*y**10-8010*y**11+414*y**12)+r**4*(-1
          +y)**5*(3468-2973*y-5040*y**2-4193*y**3+19999*y**4-26063*y**5-316456*y**6
          +702848*y**7-512567*y**8+138846*y**9-870*y**10-4061*y**11+462*y**12)
          +r**10*(-1+y)**2*(-524156+1394914*y-982190*y**2-446468*y**3+7676296*y**4
          -15939119*y**5+13103202*y**6-4400982*y**7-43487*y**8+310999*y**9-1250*y**10
          -13656*y**11+1497*y**12)+r**12*(2540328-13592634*y+28990290*y**2-25242890*y**3
          -1253362*y**4+16658793*y**5-9138897*y**6+676116*y**7+241247*y**8+147772*y**9
          +1539*y**10-35634*y**11+7479*y**12-147*y**13))-r*(-1+r**2+y)**4*(13*r**26*(
          -1+y)**8+r**24*(-1+y)**4*(-945+3716*y-5420*y**2+3595*y**3-891*y**4
          +77*y**5)+2*r**22*(-1+y)**2*(-11863+66472*y-152905*y**2+187449*y**3
          -124705*y**4+38111*y**5-2727*y**6-558*y**7+66*y**8)+r**20*(55190-486924*y
          +1829696*y**2-3946658*y**3+5626702*y**4-5713879*y**5+4137062*y**6-1986863*y**7
          +555556*y**8-72209*y**9+3202*y**10-155*y**11)+r**18*(1495075-10292292*y
          +29970316*y**2-46705370*y**3+41208755*y**4-19937448*y**5+4204156*y**6
          +577134*y**7-768875*y**8+269440*y**9-26192*y**10+2776*y**11-1075*y**12)
          -(-1+y)**9*(-17-85*y-255*y**2-744*y**3-549*y**4+567*y**5-405*y**6
          +435*y**7-136*y**8-286*y**9+200*y**10+65*y**11+10*y**12)+r**16*(-1437823
          +10058580*y-28950346*y**2+42111489*y**3-28136339*y**4-1891802*y**5
          +17510248*y**6-12452992*y**7+2852475*y**8+795054*y**9-551670*y**10+95127*y**11
          +7503*y**12-2304*y**13)-r**2*(-1+y)**7*(-4275-11801*y-22100*y**2+8142*y**3
          +29187*y**4+63219*y**5-38992*y**6+14334*y**7-57835*y**8+153*y**9+39816*y**10
          -14952*y**11+991*y**12+113*y**13)-r**4*(-1+y)**6*(-30694-49080*y-56926*y**2
          -7906*y**3+212614*y**4-8655*y**5-978686*y**6+1228086*y**7-492632*y**8
          +67336*y**9-32476*y**10+27996*y**11-5520*y**12+543*y**13)-2*r**6*(-1
          +y)**5*(-87695-11653*y+20161*y**2-254708*y**3+497937*y**4-362071*y**5
          +1093127*y**6-3266915*y**7+3169002*y**8-1132242*y**9+46936*y**10+56091*y**11
          -8116*y**12+746*y**13)-2*r**12*(-1+y)**2*(-2246338+7092384*y-6419290*y**2
          -7404870*y**3+11838406*y**4+2981821*y**5-8395520*y**6+1864844*y**7-5808*y**8
          +819384*y**9-692958*y**10+206466*y**11-25524*y**12+1803*y**13)-r**8*(
          -1+y)**4*(-2044225+2123228*y+461668*y**2+14257259*y**3-35523705*y**4
          +26612747*y**5-8042956*y**6+2819158*y**7-3314019*y**8+1700390*y**9-340352*y**10
          +76623*y**11-11291*y**12+2675*y**13)-r**10*(-1+y)**3*(-3957373+8297577*y
          -2479474*y**2-19960482*y**3+72810721*y**4-106070525*y**5+69645160*y**6
          -13425004*y**7-10015863*y**8+6574059*y**9-1439742*y**10+196998*y**11
          -21117*y**12+3465*y**13)-4*r**14*(-1962419+12277838*y-31553462*y**2
          +37490399*y**3-14030425*y**4-11977611*y**5+14606814*y**6-5878378*y**7
          +1124672*y**8+10881*y**9-68730*y**10-81507*y**11+51690*y**12-10566*y**13
          +804*y**14))))/(18662400*logy**4*r**16*(-1+y)**8+6220800*logy**3*r**12*(-1
          +y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +777600*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+43200*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+900*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*muWC**2*(518400*logy**4*r**15*(
          -21-4*r**2+20*r**4+45*r**6)*(-1+y)**8+8640*logy**3*r**11*(-1+y)**4*(917*r**14*(
          -1+y)**4+3*r**12*(601-2404*y+3606*y**2-2014*y**3+301*y**4+90*y**5)
          +r**10*(7057-17428*y+4542*y**2+25462*y**3-27823*y**4+10230*y**5-1020*y**6)
          -(-1+y)**4*(-733+330*y**3+375*y**4-372*y**5+100*y**6)-r**2*(-1+y)**4*(
          -627+250*y**3+2595*y**4-1428*y**5+220*y**6)+5*r**8*(-1549+7156*y
          -12654*y**2+11122*y**3-4399*y**4+468*y**5+34*y**6+26*y**7)+5*r**6*(
          -1157+4436*y-6270*y**2+2772*y**3+3870*y**4-7122*y**5+5150*y**6-1814*y**7
          +243*y**8)+r**4*(2393-14612*y+31998*y**2-37602*y**3+29538*y**4-16158*y**5
          +2692*y**6+4052*y**7-2793*y**8+492*y**9))+144*logy**2*r**7*(-1+y)**2*(
          -1+r**2+y)**2*(1183*r**18*(-1+y)**6-r**16*(-1+y)**2*(-25457+104194*y
          -162206*y**2+112044*y**3-36881*y**4+4586*y**5)-r**14*(-1+y)**2*(-301676
          +1094924*y-1449015*y**2+769890*y**3-90860*y**4-36514*y**5+2931*y**6)
          +(-1+y)**5*(2519+2519*y+2519*y**2-23621*y**3+17329*y**4-4919*y**5
          -6319*y**6+20381*y**7-14704*y**8+3096*y**9)+r**12*(243020-1460092*y
          +3737811*y**2-4747386*y**3+2860977*y**4-289800*y**5-664883*y**6+415714*y**7
          -99269*y**8+9908*y**9)+r**4*(-1+y)**3*(224236-323728*y+73527*y**2
          +112667*y**3-435993*y**4+590895*y**5-164107*y**6-177307*y**7+131433*y**8
          -31927*y**9+2104*y**10)+r**2*(-1+y)**4*(-13705-5038*y-5038*y**2+16632*y**3
          +59062*y**4-49118*y**5-10962*y**6-17512*y**7+43443*y**8-22012*y**9
          +3048*y**10)-r**6*(-1+y)**2*(86092-68004*y-37369*y**2-441094*y**3
          +166286*y**4+1080602*y**5-1264576*y**6+415894*y**7+37474*y**8-36126*y**9
          +3821*y**10)+r**10*(745034-3198356*y+5152659*y**2-2155536*y**3-3614496*y**4
          +5123886*y**5-2454864*y**6+344216*y**7+101106*y**8-43114*y**9+5465*y**10)
          -r**8*(125818-902448*y+2692425*y**2-5930790*y**3+9257400*y**4-8307876*y**5
          +2985346*y**6+1109680*y**7-1523030*y**8+579080*y**9-90087*y**10+4482*y**11))
          +12*logy*r**3*(-1+y)*(-1+r**2+y)**3*(19*r**24*(-1+y)**7-r**22*(-1+y)**3*(
          -1214+4913*y-7512*y**2+4468*y**3-1294*y**4+147*y**5)+r**20*(-121632
          +826731*y-2395731*y**2+3829053*y**3-3650349*y**4+2091525*y**5-681265*y**6
          +105535*y**7-4031*y**8+164*y**9)+r**18*(-862226+5764817*y-16453407*y**2
          +25668323*y**3-23535497*y**4+12698283*y**5-3703801*y**6+364033*y**7
          +76183*y**8-17392*y**9+684*y**10)-(-1+y)**8*(-203-812*y-2030*y**2
          -2858*y**3+970*y**4+7156*y**5-5858*y**6+2110*y**7+1173*y**8-2660*y**9
          +1012*y**10)+r**16*(-4915487+29484098*y-73417008*y**2+94957612*y**3
          -62036314*y**4+9721488*y**5+13198014*y**6-8959422*y**7+2119153*y**8
          -161146*y**9+9834*y**10-822*y**11)+r**6*(-1+y)**4*(277522+74475*y
          +114411*y**2+1358595*y**3-5615739*y**4+4619838*y**5+1194714*y**6-2562954*y**7
          +387680*y**8+391079*y**9-143445*y**10+9111*y**11+313*y**12)-r**2*(-1
          +y)**6*(-4030-8669*y-13917*y**2+57142*y**3-28246*y**4+20724*y**5+65000*y**6
          -116078*y**7+30608*y**8+11281*y**9-99*y**10-2176*y**11+460*y**12)-r**4*(
          -1+y)**5*(150384+102627*y+86316*y**2-1088641*y**3+905252*y**4-245686*y**5
          -371972*y**6+1100518*y**7-883444*y**8+217323*y**9+25032*y**10-11725*y**11
          +816*y**12)-2*r**14*(-743510+3209735*y-2796909*y**2-2602513*y**3+3183331*y**4
          +4798236*y**5-10776534*y**6+8496528*y**7-3195052*y**8+388949*y**9+77459*y**10
          -24951*y**11+831*y**12)+2*r**10*(-1+y)**2*(-1000918+4959287*y-6504709*y**2
          -7299742*y**3+20513660*y**4-10641118*y**5-4930992*y**6+6732462*y**7
          -1982338*y**8-53065*y**9+83501*y**10-12840*y**11+1212*y**12)+r**8*(
          -1+y)**3*(-4151911+8626534*y-4073622*y**2-3446036*y**3+10859465*y**4
          -11283240*y**5+1742496*y**6+5517108*y**7-4258589*y**8+1118770*y**9-71834*y**10
          -15840*y**11+1899*y**12)+2*r**12*(-2540328+8606193*y-4058085*y**2-30566959*y**3
          +72777757*y**4-67729722*y**5+18182676*y**6+17505102*y**7-18033410*y**8
          +7058003*y**9-1255515*y**10+45141*y**11+8793*y**12+354*y**13))+r*(
          -1+r**2+y)**4*(29*r**26*(-1+y)**8+r**24*(-1+y)**4*(-69+388*y-748*y**2
          +1130*y**3-603*y**4+166*y**5)+2*r**22*(-1+y)**2*(39913-232000*y+557215*y**2
          -694722*y**3+482971*y**4-193382*y**5+42849*y**6-4308*y**7+144*y**8)
          -2*r**20*(-973223+7208166*y-23052968*y**2+41395058*y**3-45409477*y**4
          +30869629*y**5-12346079*y**6+2320835*y**7+65744*y**8-82651*y**9+4211*y**10
          +35*y**11)+r**18*(3518579-24432468*y+73548092*y**2-119692480*y**3+107927863*y**4
          -45417564*y**5-3944008*y**6+13583808*y**7-6328915*y**8+1363352*y**9
          -153580*y**10+20696*y**11-575*y**12)-(-1+y)**9*(-37-185*y-555*y**2
          -2109*y**3-462*y**4+4242*y**5-4662*y**6-270*y**7+2479*y**8-1673*y**9
          +625*y**10+187*y**11+20*y**12)-2*r**6*(-1+y)**5*(-1093423-318317*y
          -134191*y**2+5398697*y**3-4412208*y**4+183760*y**5-781268*y**6-1090876*y**7
          +3013155*y**8-1371927*y**9+65603*y**10+63915*y**11-1748*y**12+28*y**13)
          -r**2*(-1+y)**7*(-10371-28825*y-54292*y**2+30936*y**3+120645*y**4
          +182775*y**5-347060*y**6+189552*y**7-77453*y**8-73755*y**9+112536*y**10
          -35400*y**11+2555*y**12+157*y**13)-2*r**4*(-1+y)**6*(32945+61308*y
          +93101*y**2-590608*y**3+595327*y**4-176463*y**5-1444142*y**6+2101410*y**7
          -793049*y**8-140252*y**9+156473*y**10-22626*y**11+369*y**12+207*y**13)
          +r**16*(33028117-215597244*y+590271310*y**2-855154950*y**3+642376961*y**4
          -115362652*y**5-218200168*y**6+204365896*y**7-77962653*y**8+12306144*y**9
          +125370*y**10-209778*y**11+27399*y**12+648*y**13)+4*r**12*(-1+y)**2*(21286405
          -77347800*y+90571273*y**2+5257692*y**3-87592633*y**4+42266165*y**5
          +32572298*y**6-39035264*y**7+13525929*y**8-552762*y**9-677415*y**10
          +117912*y**11-8289*y**12+1689*y**13)+r**8*(-1+y)**4*(3560021-3866908*y
          -2391620*y**2-34115578*y**3+99750537*y**4-74287978*y**5-11002696*y**6
          +40951564*y**7-17052297*y**8-244912*y**9+1474252*y**10-321186*y**11
          -9749*y**12+2150*y**13)+r**10*(-1+y)**3*(43818509-104014617*y+59951186*y**2
          -17353674*y**3+70940539*y**4-87176423*y**5+38031364*y**6-10071532*y**7
          +11044779*y**8-6477999*y**9+1098714*y**10-83802*y**11-29379*y**12+5535*y**13)
          +4*r**14*(-15115229+95589578*y-245549330*y**2+335791004*y**3-255967747*y**4
          +86500212*y**5+24219684*y**6-43450552*y**7+26381945*y**8-11770596*y**9
          +4217652*y**10-945312*y**11+100947*y**12-3294*y**13+1038*y**14))))/(27993600*logy**4*r**16*(
          -1+y)**8+9331200*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+1166400*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+64800*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +1350*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((rhoLS*(-518400*logy**4*r**13*(-3+26*r**2+41*r**4+29*r**6+9*r**8)*(-1
          +y)**8+8640*logy**3*r**9*(-1+y)**4*(541*r**16*(-1+y)**4-(-1+y)**5*(-7
          -7*y-7*y**2+143*y**3-112*y**4+20*y**5)+3*r**14*(-376+1504*y-2256*y**2
          +1849*y**3-736*y**4+105*y**5)-r**12*(4804-17056*y+21264*y**2-11771*y**3
          +1934*y**4+255*y**5+60*y**6)+r**2*(-1+y)**4*(264-1115*y**3+1720*y**4
          -774*y**5+100*y**6)+r**4*(-1+y)**3*(-508-212*y+360*y**2+1395*y**3
          -2055*y**4+1368*y**5-478*y**6+40*y**7)+r**10*(-4208+9872*y-888*y**2
          -12403*y**3+10852*y**4-2370*y**5-440*y**6+95*y**7)-5*r**8*(-234+2904*y
          -8292*y**2+9542*y**3-4491*y**4-41*y**5+806*y**6-293*y**7+45*y**8)
          +r**6*(7664-36896*y+67824*y**2-58941*y**3+21144*y**4+2571*y**5-4514*y**6
          +1076*y**7+186*y**8-114*y**9))-144*logy**2*r**5*(-1+y)**2*(-1+r**2+y)**2*(
          -977*r**20*(-1+y)**6+2*r**18*(-1+y)**2*(-7155+29597*y-46838*y**2+32677*y**3
          -10863*y**4+1652*y**5)+r**16*(-1+y)**2*(-120875+416694*y-509647*y**2
          +210193*y**3+28143*y**4-31477*y**5+1809*y**6)+(-1+y)**7*(-103-309*y
          -618*y**2+70*y**3+125*y**4+483*y**5-256*y**6+8*y**7)+2*r**6*(-1+y)**4*(60935
          -18292*y-5113*y**2-131688*y**3+254168*y**4-176195*y**5+45267*y**6
          +1068*y**7-1657*y**8+182*y**9)+2*r**2*(-1+y)**5*(-120-223*y-326*y**2
          +756*y**3+733*y**4-650*y**5-1147*y**6+2731*y**7-1826*y**8+372*y**9)
          -2*r**14*(-137465+684488*y-1295217*y**2+1206860*y**3-547776*y**4+83145*y**5
          -21873*y**6+52447*y**7-26885*y**8+3776*y**9)+r**12*(883480-4599756*y
          +9450108*y**2-9840993*y**3+5002941*y**4-211860*y**5-1243189*y**6+723687*y**7
          -197097*y**8+31834*y**9-2155*y**10)+r**4*(-1+y)**4*(3865+1946*y+1625*y**2
          -1951*y**3-18347*y**4+22332*y**5+1619*y**6-23585*y**7+18166*y**8-5838*y**9
          +768*y**10)-r**8*(-1+y)**2*(-168580+267704*y-52156*y**2+496229*y**3
          -1381321*y**4+1500949*y**5-884149*y**6+281921*y**7-27179*y**8-8019*y**9
          +1301*y**10)+2*r**10*(443147-2327890*y+4935426*y**2-5537374*y**3+3446041*y**4
          -878053*y**5-351629*y**6+394069*y**7-156156*y**8+39954*y**9-8549*y**10
          +1014*y**11))-12*logy*r*(-1+y)*(-1+r**2+y)**3*(r**26*(-1+y)**7+r**24*(
          -1+y)**3*(-1713+6849*y-10266*y**2+6307*y**3-1549*y**4+126*y**5)+r**22*(84518
          -573314*y+1658412*y**2-2643258*y**3+2504675*y**4-1416413*y**5+449760*y**6
          -66950*y**7+2931*y**8-361*y**9)-(-1+y)**9*(-7-35*y-105*y**2-211*y**3
          -157*y**4+167*y**5+245*y**6+115*y**7-304*y**8+92*y**9)+r**20*(288778
          -1913248*y+5430318*y**2-8308942*y**3+7243009*y**4-3497718*y**5+767855*y**6
          +43144*y**7-67601*y**8+15188*y**9-783*y**10)+r**2*(-1+y)**7*(-63-168*y
          -294*y**2-1273*y**3-127*y**4+60*y**5+3226*y**6-2901*y**7-1792*y**8
          +3242*y**9-1202*y**10+92*y**11)+r**18*(1801025-10464311*y+24980619*y**2
          -29879764*y**3+15448783*y**4+3065718*y**5-8433866*y**6+4313261*y**7
          -897056*y**8+76697*y**9-12633*y**10+1527*y**11)+r**8*(-1+y)**4*(-262465
          +59256*y+7530*y**2+142483*y**3+130048*y**4-107385*y**5-330136*y**6
          +740778*y**7-644758*y**8+259567*y**9-43000*y**10+1185*y**11+97*y**12)
          -r**4*(-1+y)**6*(8182+13724*y+17904*y**2-46166*y**3-3357*y**4-15967*y**5
          +46398*y**6-19878*y**7-4039*y**8-863*y**9+5300*y**10-2022*y**11+184*y**12)
          -r**6*(-1+y)**5*(-5786-21932*y-34484*y**2+180566*y**3-103887*y**4
          -58155*y**5-40864*y**6+263194*y**7-238271*y**8+83117*y**9-5454*y**10
          -2834*y**11+390*y**12)-r**10*(-1+y)**3*(-2714111+4910852*y-1834662*y**2
          +4767882*y**3-16197395*y**4+21732029*y**5-14305098*y**6+3837044*y**7
          +565428*y**8-648935*y**9+173922*y**10-20784*y**11+828*y**12)+r**16*(
          -6808553+37801340*y-82762890*y**2+90980664*y**3-47924048*y**4+3112163*y**5
          +8358468*y**6-2029456*y**7-1081734*y**8+252883*y**9+167040*y**10-51258*y**11
          +2181*y**12)-r**12*(-1+y)**2*(-138604+2176880*y-3407608*y**2-7437556*y**3
          +20406856*y**4-18653159*y**5+9504926*y**6-2797998*y**7+54141*y**8+114449*y**9
          +79108*y**10-38976*y**11+3741*y**12)+r**14*(-10141196+60351980*y-146601552*y**2
          +188901380*y**3-128464828*y**4+17227763*y**5+51236795*y**6-50535992*y**7
          +22580903*y**8-4801842*y**9+128913*y**10+125980*y**11-6051*y**12-2253*y**13))
          -r*(-1+r**2+y)**4*(27*r**26*(-1+y)**8+r**24*(-1+y)**4*(-681+2628*y
          -3696*y**2+1959*y**3-421*y**4+79*y**5)-2*r**22*(-1+y)**2*(38235-220446*y
          +524766*y**2-647895*y**3+438394*y**4-162293*y**5+31194*y**6-2646*y**7
          +31*y**8)+r**20*(-1011654+7366968*y-23098410*y**2+40360698*y**3-42401186*y**4
          +26627503*y**5-8847276*y**6+604877*y**7+529164*y**8-137487*y**9+6498*y**10
          -415*y**11)+r**18*(113985-1056864*y+3203046*y**2-7078806*y**3+13430763*y**4
          -17184964*y**5+12776734*y**6-5274406*y**7+1407001*y**8-457308*y**9+139984*y**10
          -15060*y**11-505*y**12)-(-1+y)**8*(-171-600*y-1332*y**2-975*y**3
          +4897*y**4+11392*y**5-3896*y**6-4612*y**7-8985*y**8+11238*y**9-3676*y**10
          +251*y**11+59*y**12+10*y**13)-r**2*(-1+y)**7*(-1305-2559*y-3078*y**2
          -15024*y**3+22651*y**4+15539*y**5+48386*y**6-95236*y**7-42303*y**8
          +104469*y**9-44584*y**10+5728*y**11+49*y**12+67*y**13)-r**4*(-1+y)**6*(
          -161034-220020*y-244608*y**2+1070490*y**3-89944*y**4+65863*y**5-727148*y**6
          +243724*y**7+130314*y**8+129354*y**9-208244*y**10+77138*y**11-8776*y**12
          +491*y**13)-2*r**6*(-1+y)**5*(-134979+101349*y+212862*y**2-50121*y**3
          +405816*y**4-12520*y**5-389869*y**6-1186541*y**7+2033512*y**8-958496*y**9
          +20179*y**10+93510*y**11-18921*y**12+1219*y**13)-r**16*(14935059-97267248*y
          +264925140*y**2-379210449*y**3+274960627*y**4-32700094*y**5-113031856*y**6
          +97099096*y**7-34215767*y**8+4133578*y**9+528100*y**10-155271*y**11
          +5049*y**12+1236*y**13)-2*r**12*(-1+y)**2*(9292770-36762756*y+46589520*y**2
          +588918*y**3-33494356*y**4-10997645*y**5+52339168*y**6-33964636*y**7
          +4576670*y**8+3718286*y**9-1841440*y**10+311718*y**11-35244*y**12+4827*y**13)
          -r**8*(-1+y)**4*(-4187025+3756756*y+894420*y**2+1570863*y**3+281209*y**4
          +805193*y**5-7502752*y**6+8573770*y**7-3347783*y**8-298934*y**9+295612*y**10
          +121071*y**11-61905*y**12+6705*y**13)-r**10*(-1+y)**3*(13567293-33145281*y
          +22935558*y**2-36365226*y**3+120423899*y**4-185753351*y**5+142298272*y**6
          -42156604*y**7-9437629*y**8+8921801*y**9-1775182*y**10+183534*y**11
          -64059*y**12+10575*y**13)-4*r**14*(-17431983+109648452*y-282407799*y**2
          +380700273*y**3-264821033*y**4+42406147*y**5+81567360*y**6-71877664*y**7
          +26520717*y**8-5175495*y**9+1366446*y**10-620767*y**11+137793*y**12
          -13650*y**13+1203*y**14))))/(18662400*logy**4*r**16*(-1+y)**8+6220800*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +777600*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+43200*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+900*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((rhoD*(-518400*logy**4*r**18*(18+45*r**2
          +44*r**4+37*r**6+29*r**8+9*r**10)*(-1+y)**9-8640*logy**3*r**14*(-1+y)**4*(409*r**18*(
          -1+y)**5-4*(-1+y)**7*(31+62*y+93*y**2-116*y**3+20*y**4)-5*r**2*(
          -1+y)**6*(-91-91*y-91*y**2+307*y**3-216*y**4+28*y**5)-5*r**4*(-1
          +y)**5*(1254-864*y-432*y**2+305*y**3+92*y**4-142*y**5+20*y**6)+r**16*(
          -922+4610*y-9220*y**2+8455*y**3-4025*y**4+697*y**5+45*y**6)-5*r**14*(96
          -48*y-984*y**2+2901*y**3-2993*y**4+1513*y**5-385*y**6+36*y**7)-5*r**12*(1238
          -4798*y+6116*y**2-729*y**3-4425*y**4+3876*y**5-1268*y**6+123*y**7
          +3*y**8)-r**6*(-1+y)**3*(6472-23744*y+22672*y**2+485*y**3-10690*y**4
          +5033*y**5-326*y**6-302*y**7+40*y**8)+r**10*(-3254+7390*y+7420*y**2
          -38330*y**3+43045*y**4-17876*y**5-1735*y**6+4325*y**7-1570*y**8+225*y**9)
          +r**8*(-2066-230*y+26860*y**2-57965*y**3+41315*y**4+6977*y**5-27425*y**6
          +15810*y**7-3240*y**8-150*y**9+114*y**10))-144*logy**2*r**10*(-1+y)**2*(3*r**26*(
          -1+y)**7+2*(-1+y)**11*(41+164*y+410*y**2+420*y**3-55*y**4-856*y**5
          +376*y**6)-2*r**24*(-1+y)**2*(6752-33760*y+67520*y**2-66325*y**3+36065*y**4
          -10297*y**5+1285*y**6)-r**22*(-1+y)**2*(119848-525620*y+867190*y**2
          -605025*y**3+88555*y**4+105847*y**5-48595*y**6+4680*y**7)+r**2*(-1
          +y)**9*(763+1526*y+2289*y**2-9048*y**3+3085*y**4-198*y**5+919*y**6
          -1464*y**7+728*y**8)+2*r**4*(-1+y)**8*(-24592-13432*y-7852*y**2+151713*y**3
          -148597*y**4+24557*y**5+24937*y**6-10628*y**7+622*y**8+372*y**9)+10*r**8*(
          -1+y)**6*(-76674+189534*y-95310*y**2-150392*y**3+219469*y**4-81184*y**5
          -16626*y**6+16853*y**7-1506*y**8-994*y**9+190*y**10)+r**6*(-1+y)**7*(
          -952-81900*y-40950*y**2+26485*y**3+342460*y**4-352046*y**5+71650*y**6
          +40855*y**7-14100*y**8-1270*y**9+768*y**10)+2*r**20*(64844-536888*y
          +1901094*y**2-3895180*y**3+4896885*y**4-3802489*y**5+1792618*y**6-478739*y**7
          +57320*y**8-2550*y**9+1085*y**10)+r**10*(-1+y)**4*(210819+532503*y
          -3251943*y**2+4008601*y**3-633700*y**4-2409129*y**5+2049277*y**6-479852*y**7
          -114791*y**8+70590*y**9-9570*y**10+195*y**11)-2*r**12*(-1+y)**3*(557268
          -2415012*y+3519198*y**2-1218267*y**3-2072347*y**4+2779232*y**5-1363323*y**6
          +212632*y**7+19497*y**8+11852*y**9-9945*y**10+1465*y**11)-r**14*(-1
          +y)**2*(-481488+2993160*y-6651420*y**2+5437670*y**3+317230*y**4-2573919*y**5
          +374875*y**6+1320750*y**7-1001090*y**8+294975*y**9-36663*y**10+1720*y**11)
          +5*r**18*(26783-204761*y+635883*y**2-1047581*y**3+823003*y**4-1684*y**5
          -554726*y**6+504407*y**7-245922*y**8+78321*y**9-16333*y**10+1810*y**11)
          +2*r**16*(-560637+3367359*y-8465427*y**2+11487650*y**3-9134325*y**4
          +4486459*y**5-1849938*y**6+1284604*y**7-904950*y**8+321025*y**9-19672*y**10
          -14671*y**11+2523*y**12))-12*logy*r**8*(-1+y)*(-1+r**2+y)**2*(31*r**28*(
          -1+y)**8+r**26*(-1+y)**3*(1404-6958*y+13730*y**2-14373*y**3+7701*y**4
          -2067*y**5+235*y**6)+(-1+y)**10*(67+268*y+670*y**2+602*y**3+594*y**4
          +12*y**5-1798*y**6+290*y**7+1223*y**8-1004*y**9+276*y**10)+r**24*(38965
          -308902*y+1068605*y**2-2107927*y**3+2617336*y**4-2134497*y**5+1152692*y**6
          -402097*y**7+85243*y**8-10017*y**9+599*y**10)-2*r**22*(-263346+1982240*y
          -6456439*y**2+11754426*y**3-13086408*y**4+9181729*y**5-3978045*y**6
          +938384*y**7-51856*y**8-24807*y**9+4102*y**10+20*y**11)+r**20*(1738075
          -11508408*y+31602510*y**2-44470591*y**3+28937680*y**4+3547403*y**5
          -21493552*y**6+17117503*y**7-6677069*y**8+1328245*y**9-137238*y**10
          +17320*y**11-1878*y**12)+r**2*(-1+y)**8*(-5656-9210*y-11646*y**2+46095*y**3
          +40248*y**4+12443*y**5-230906*y**6+225039*y**7-58960*y**8-17613*y**9
          +12548*y**10-2074*y**11+92*y**12)+r**18*(-2077664+15629362*y-50570750*y**2
          +97717349*y**3-121001872*y**4+95667129*y**5-47822410*y**6+15854191*y**7
          -4133512*y**8+753137*y**9+94780*y**10-117752*y**11+31364*y**12-1752*y**13)
          -r**4*(-1+y)**7*(-34343-23273*y-19190*y**2+453375*y**3-684927*y**4
          +321429*y**5+98717*y**6-146503*y**7+15776*y**8+32932*y**9-22111*y**10
          +8176*y**11-1842*y**12+184*y**13)-2*r**6*(-1+y)**6*(600526-571540*y
          -147817*y**2-3369472*y**3+8230297*y**4-5917763*y**5-33855*y**6+1963247*y**7
          -799495*y**8-4082*y**9+53692*y**10-2065*y**11-2260*y**12+287*y**13)
          -r**8*(-1+y)**5*(1083183-1164359*y-360918*y**2+120867*y**3-1718798*y**4
          +6762413*y**5-7316726*y**6+2864950*y**7-67585*y**8-220327*y**9+41304*y**10
          +3035*y**11-532*y**12+293*y**13)+r**10*(-1+y)**4*(-11671692+45008182*y
          -57202420*y**2-1020481*y**3+74279032*y**4-76147071*y**5+25531500*y**6
          +5294552*y**7-4701436*y**8-89092*y**9+497928*y**10-72367*y**11-7192*y**12
          +757*y**13)+2*r**14*(-1+y)**2*(9902364-44900240*y+76738542*y**2-54657656*y**3
          +601894*y**4+24269816*y**5-15285750*y**6+4214174*y**7-2033504*y**8+1619571*y**9
          -527920*y**10+52640*y**11-3706*y**12+975*y**13)+r**12*(-1+y)**3*(5597011
          -29632399*y+58885634*y**2-52773168*y**3+19043301*y**4-235369*y**5-1501394*y**6
          -261212*y**7+1348853*y**8-978111*y**9+335728*y**10-44332*y**11-9317*y**12
          +1575*y**13)+r**16*(-2602919+20860778*y-71482573*y**2+141065504*y**3
          -165386714*y**4+96945672*y**5+10540078*y**6-68334544*y**7+62257319*y**8
          -32808502*y**9+10710897*y**10-1865616*y**11+91122*y**12+8772*y**13+726*y**14))
          -r**8*(-1+r**2+y)**3*(35*r**28*(-1+y)**9+r**26*(-1+y)**4*(648-3507*y
          +7629*y**2-8831*y**3+5373*y**4-1740*y**5+252*y**6)+r**24*(-1+y)**2*(11801
          -67970*y+154506*y**2-193087*y**3+121790*y**4+2543*y**5-50356*y**6
          +29093*y**7-7233*y**8+673*y**9)+r**22*(-974064+8278230*y-30942018*y**2
          +66746122*y**3-91865078*y**4+84164285*y**5-51723793*y**6+20717627*y**7
          -4923131*y**8+501109*y**9+28355*y**10-9181*y**11+577*y**12)+r**20*(
          -2315215+16950477*y-52318242*y**2+82471902*y**3-59456481*y**4-8323948*y**5
          +54452186*y**6-49218374*y**7+22932391*y**8-5787699*y**9+604808*y**10
          +13712*y**11+121*y**12-838*y**13)-(-1+y)**10*(4097+15584*y+37352*y**2
          +33613*y**3+16579*y**4-32060*y**5-56056*y**6+20996*y**7+53739*y**8
          -49094*y**9+13288*y**10-513*y**11+57*y**12+18*y**13)+r**18*(-9724408
          +69721959*y-210880581*y**2+342949125*y**3-295685375*y**4+56026269*y**5
          +172693989*y**6-224731622*y**7+143586084*y**8-55587155*y**9+13617799*y**10
          -2218503*y**11+219003*y**12+5991*y**13-2175*y**14)-r**2*(-1+y)**8*(
          -135544-191729*y-216309*y**2+1024977*y**3+434781*y**4+42951*y**5-3505137*y**6
          +3834078*y**7-1215780*y**8-195719*y**9+141683*y**10+1921*y**11-6049*y**12
          +913*y**13+163*y**14)+r**8*(-1+y)**5*(34298757-67362351*y+22854834*y**2
          -56013035*y**3+211318390*y**4-207288766*y**5+21508609*y**6+67222958*y**7
          -28475231*y**8-2515995*y**9+3090964*y**10-213763*y**11-90612*y**12-10824*y**13
          +465*y**14)-r**4*(-1+y)**7*(-155061-239904*y-163233*y**2-1308632*y**3
          +8786811*y**4-6717087*y**5-7837372*y**6+12804572*y**7-5257057*y**8-403398*y**9
          +732273*y**10-136084*y**11+7291*y**12+1509*y**13+572*y**14)-r**6*(-1
          +y)**6*(-11676016+14962650*y+906030*y**2+53708412*y**3-146251428*y**4
          +119420013*y**5-12823583*y**6-29065118*y**7+11007302*y**8+1303050*y**9
          -998682*y**10-55582*y**11+68598*y**12+1151*y**13+803*y**14)+2*r**14*(
          -1+y)**2*(-8070720+45446802*y-104242554*y**2+143374092*y**3-152738988*y**4
          +130895965*y**5-74238351*y**6+21252628*y**7+996084*y**8-5776510*y**9
          +3844500*y**10-1030136*y**11+86676*y**12+399*y**13+1713*y**14)+r**10*(
          -1+y)**4*(128273912-466440805*y+581458187*y**2-135082233*y**3-339191901*y**4
          +340344908*y**5-124555580*y**6+10842002*y**7-198362*y**8+4945067*y**9
          -2049325*y**10+369695*y**11-60409*y**12-25450*y**13+3494*y**14)+r**12*(
          -1+y)**3*(106364505-426858138*y+600487167*y**2-188294164*y**3-407792671*y**4
          +525083532*y**5-253084679*y**6+49416980*y**7-18392933*y**8+17516982*y**9
          -5331727*y**10+477272*y**11-32637*y**12-17328*y**13+5439*y**14)+r**16*(29879661
          -232609470*y+781932285*y**2-1531830067*y**3+1894776453*y**4-1419635575*y**5
          +448590087*y**6+253142446*y**7-397881841*y**8+252184188*y**9-101756625*y**10
          +27432573*y**11-4608361*y**12+379233*y**13+5589*y**14-576*y**15))))/(18662400*logy**4*r**23*(
          -1+y)**9+6220800*logy**3*r**19*(-1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+777600*logy**2*r**15*(-1+y)**5*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+43200*logy*r**11*(
          -1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +900*r**7*(-1+y)*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(
          -1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y
          -y**2+y**3))**4))
      resNP += ((api*muWC**3*(1036800*logy**4*r**18*(18+45*r**2+44*r**4
          +37*r**6+29*r**8+9*r**10)*(-1+y)**9+17280*logy**3*r**14*(-1+y)**4*(409*r**18*(
          -1+y)**5-4*(-1+y)**7*(31+62*y+93*y**2-116*y**3+20*y**4)-5*r**2*(
          -1+y)**6*(-91-91*y-91*y**2+307*y**3-216*y**4+28*y**5)-5*r**4*(-1
          +y)**5*(1254-864*y-432*y**2+305*y**3+92*y**4-142*y**5+20*y**6)+r**16*(
          -922+4610*y-9220*y**2+8455*y**3-4025*y**4+697*y**5+45*y**6)-5*r**14*(96
          -48*y-984*y**2+2901*y**3-2993*y**4+1513*y**5-385*y**6+36*y**7)-5*r**12*(1238
          -4798*y+6116*y**2-729*y**3-4425*y**4+3876*y**5-1268*y**6+123*y**7
          +3*y**8)-r**6*(-1+y)**3*(6472-23744*y+22672*y**2+485*y**3-10690*y**4
          +5033*y**5-326*y**6-302*y**7+40*y**8)+r**10*(-3254+7390*y+7420*y**2
          -38330*y**3+43045*y**4-17876*y**5-1735*y**6+4325*y**7-1570*y**8+225*y**9)
          +r**8*(-2066-230*y+26860*y**2-57965*y**3+41315*y**4+6977*y**5-27425*y**6
          +15810*y**7-3240*y**8-150*y**9+114*y**10))+288*logy**2*r**10*(-1+y)**2*(3*r**26*(
          -1+y)**7+2*(-1+y)**11*(41+164*y+410*y**2+420*y**3-55*y**4-856*y**5
          +376*y**6)-2*r**24*(-1+y)**2*(6752-33760*y+67520*y**2-66325*y**3+36065*y**4
          -10297*y**5+1285*y**6)-r**22*(-1+y)**2*(119848-525620*y+867190*y**2
          -605025*y**3+88555*y**4+105847*y**5-48595*y**6+4680*y**7)+r**2*(-1
          +y)**9*(763+1526*y+2289*y**2-9048*y**3+3085*y**4-198*y**5+919*y**6
          -1464*y**7+728*y**8)+2*r**4*(-1+y)**8*(-24592-13432*y-7852*y**2+151713*y**3
          -148597*y**4+24557*y**5+24937*y**6-10628*y**7+622*y**8+372*y**9)+10*r**8*(
          -1+y)**6*(-76674+189534*y-95310*y**2-150392*y**3+219469*y**4-81184*y**5
          -16626*y**6+16853*y**7-1506*y**8-994*y**9+190*y**10)+r**6*(-1+y)**7*(
          -952-81900*y-40950*y**2+26485*y**3+342460*y**4-352046*y**5+71650*y**6
          +40855*y**7-14100*y**8-1270*y**9+768*y**10)+2*r**20*(64844-536888*y
          +1901094*y**2-3895180*y**3+4896885*y**4-3802489*y**5+1792618*y**6-478739*y**7
          +57320*y**8-2550*y**9+1085*y**10)+r**10*(-1+y)**4*(210819+532503*y
          -3251943*y**2+4008601*y**3-633700*y**4-2409129*y**5+2049277*y**6-479852*y**7
          -114791*y**8+70590*y**9-9570*y**10+195*y**11)-2*r**12*(-1+y)**3*(557268
          -2415012*y+3519198*y**2-1218267*y**3-2072347*y**4+2779232*y**5-1363323*y**6
          +212632*y**7+19497*y**8+11852*y**9-9945*y**10+1465*y**11)-r**14*(-1
          +y)**2*(-481488+2993160*y-6651420*y**2+5437670*y**3+317230*y**4-2573919*y**5
          +374875*y**6+1320750*y**7-1001090*y**8+294975*y**9-36663*y**10+1720*y**11)
          +5*r**18*(26783-204761*y+635883*y**2-1047581*y**3+823003*y**4-1684*y**5
          -554726*y**6+504407*y**7-245922*y**8+78321*y**9-16333*y**10+1810*y**11)
          +2*r**16*(-560637+3367359*y-8465427*y**2+11487650*y**3-9134325*y**4
          +4486459*y**5-1849938*y**6+1284604*y**7-904950*y**8+321025*y**9-19672*y**10
          -14671*y**11+2523*y**12))+24*logy*r**8*(-1+y)*(-1+r**2+y)**2*(31*r**28*(
          -1+y)**8+r**26*(-1+y)**3*(1404-6958*y+13730*y**2-14373*y**3+7701*y**4
          -2067*y**5+235*y**6)+(-1+y)**10*(67+268*y+670*y**2+602*y**3+594*y**4
          +12*y**5-1798*y**6+290*y**7+1223*y**8-1004*y**9+276*y**10)+r**24*(38965
          -308902*y+1068605*y**2-2107927*y**3+2617336*y**4-2134497*y**5+1152692*y**6
          -402097*y**7+85243*y**8-10017*y**9+599*y**10)-2*r**22*(-263346+1982240*y
          -6456439*y**2+11754426*y**3-13086408*y**4+9181729*y**5-3978045*y**6
          +938384*y**7-51856*y**8-24807*y**9+4102*y**10+20*y**11)+r**20*(1738075
          -11508408*y+31602510*y**2-44470591*y**3+28937680*y**4+3547403*y**5
          -21493552*y**6+17117503*y**7-6677069*y**8+1328245*y**9-137238*y**10
          +17320*y**11-1878*y**12)+r**2*(-1+y)**8*(-5656-9210*y-11646*y**2+46095*y**3
          +40248*y**4+12443*y**5-230906*y**6+225039*y**7-58960*y**8-17613*y**9
          +12548*y**10-2074*y**11+92*y**12)+r**18*(-2077664+15629362*y-50570750*y**2
          +97717349*y**3-121001872*y**4+95667129*y**5-47822410*y**6+15854191*y**7
          -4133512*y**8+753137*y**9+94780*y**10-117752*y**11+31364*y**12-1752*y**13)
          -r**4*(-1+y)**7*(-34343-23273*y-19190*y**2+453375*y**3-684927*y**4
          +321429*y**5+98717*y**6-146503*y**7+15776*y**8+32932*y**9-22111*y**10
          +8176*y**11-1842*y**12+184*y**13)-2*r**6*(-1+y)**6*(600526-571540*y
          -147817*y**2-3369472*y**3+8230297*y**4-5917763*y**5-33855*y**6+1963247*y**7
          -799495*y**8-4082*y**9+53692*y**10-2065*y**11-2260*y**12+287*y**13)
          -r**8*(-1+y)**5*(1083183-1164359*y-360918*y**2+120867*y**3-1718798*y**4
          +6762413*y**5-7316726*y**6+2864950*y**7-67585*y**8-220327*y**9+41304*y**10
          +3035*y**11-532*y**12+293*y**13)+r**10*(-1+y)**4*(-11671692+45008182*y
          -57202420*y**2-1020481*y**3+74279032*y**4-76147071*y**5+25531500*y**6
          +5294552*y**7-4701436*y**8-89092*y**9+497928*y**10-72367*y**11-7192*y**12
          +757*y**13)+2*r**14*(-1+y)**2*(9902364-44900240*y+76738542*y**2-54657656*y**3
          +601894*y**4+24269816*y**5-15285750*y**6+4214174*y**7-2033504*y**8+1619571*y**9
          -527920*y**10+52640*y**11-3706*y**12+975*y**13)+r**12*(-1+y)**3*(5597011
          -29632399*y+58885634*y**2-52773168*y**3+19043301*y**4-235369*y**5-1501394*y**6
          -261212*y**7+1348853*y**8-978111*y**9+335728*y**10-44332*y**11-9317*y**12
          +1575*y**13)+r**16*(-2602919+20860778*y-71482573*y**2+141065504*y**3
          -165386714*y**4+96945672*y**5+10540078*y**6-68334544*y**7+62257319*y**8
          -32808502*y**9+10710897*y**10-1865616*y**11+91122*y**12+8772*y**13+726*y**14))
          +2*r**8*(-1+r**2+y)**3*(35*r**28*(-1+y)**9+r**26*(-1+y)**4*(648-3507*y
          +7629*y**2-8831*y**3+5373*y**4-1740*y**5+252*y**6)+r**24*(-1+y)**2*(11801
          -67970*y+154506*y**2-193087*y**3+121790*y**4+2543*y**5-50356*y**6
          +29093*y**7-7233*y**8+673*y**9)+r**22*(-974064+8278230*y-30942018*y**2
          +66746122*y**3-91865078*y**4+84164285*y**5-51723793*y**6+20717627*y**7
          -4923131*y**8+501109*y**9+28355*y**10-9181*y**11+577*y**12)+r**20*(
          -2315215+16950477*y-52318242*y**2+82471902*y**3-59456481*y**4-8323948*y**5
          +54452186*y**6-49218374*y**7+22932391*y**8-5787699*y**9+604808*y**10
          +13712*y**11+121*y**12-838*y**13)-(-1+y)**10*(4097+15584*y+37352*y**2
          +33613*y**3+16579*y**4-32060*y**5-56056*y**6+20996*y**7+53739*y**8
          -49094*y**9+13288*y**10-513*y**11+57*y**12+18*y**13)+r**18*(-9724408
          +69721959*y-210880581*y**2+342949125*y**3-295685375*y**4+56026269*y**5
          +172693989*y**6-224731622*y**7+143586084*y**8-55587155*y**9+13617799*y**10
          -2218503*y**11+219003*y**12+5991*y**13-2175*y**14)-r**2*(-1+y)**8*(
          -135544-191729*y-216309*y**2+1024977*y**3+434781*y**4+42951*y**5-3505137*y**6
          +3834078*y**7-1215780*y**8-195719*y**9+141683*y**10+1921*y**11-6049*y**12
          +913*y**13+163*y**14)+r**8*(-1+y)**5*(34298757-67362351*y+22854834*y**2
          -56013035*y**3+211318390*y**4-207288766*y**5+21508609*y**6+67222958*y**7
          -28475231*y**8-2515995*y**9+3090964*y**10-213763*y**11-90612*y**12-10824*y**13
          +465*y**14)-r**4*(-1+y)**7*(-155061-239904*y-163233*y**2-1308632*y**3
          +8786811*y**4-6717087*y**5-7837372*y**6+12804572*y**7-5257057*y**8-403398*y**9
          +732273*y**10-136084*y**11+7291*y**12+1509*y**13+572*y**14)-r**6*(-1
          +y)**6*(-11676016+14962650*y+906030*y**2+53708412*y**3-146251428*y**4
          +119420013*y**5-12823583*y**6-29065118*y**7+11007302*y**8+1303050*y**9
          -998682*y**10-55582*y**11+68598*y**12+1151*y**13+803*y**14)+2*r**14*(
          -1+y)**2*(-8070720+45446802*y-104242554*y**2+143374092*y**3-152738988*y**4
          +130895965*y**5-74238351*y**6+21252628*y**7+996084*y**8-5776510*y**9
          +3844500*y**10-1030136*y**11+86676*y**12+399*y**13+1713*y**14)+r**10*(
          -1+y)**4*(128273912-466440805*y+581458187*y**2-135082233*y**3-339191901*y**4
          +340344908*y**5-124555580*y**6+10842002*y**7-198362*y**8+4945067*y**9
          -2049325*y**10+369695*y**11-60409*y**12-25450*y**13+3494*y**14)+r**12*(
          -1+y)**3*(106364505-426858138*y+600487167*y**2-188294164*y**3-407792671*y**4
          +525083532*y**5-253084679*y**6+49416980*y**7-18392933*y**8+17516982*y**9
          -5331727*y**10+477272*y**11-32637*y**12-17328*y**13+5439*y**14)+r**16*(29879661
          -232609470*y+781932285*y**2-1531830067*y**3+1894776453*y**4-1419635575*y**5
          +448590087*y**6+253142446*y**7-397881841*y**8+252184188*y**9-101756625*y**10
          +27432573*y**11-4608361*y**12+379233*y**13+5589*y**14-576*y**15))))/(41990400*logy**4*r**23*(
          -1+y)**9+13996800*logy**3*r**19*(-1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+1749600*logy**2*r**15*(-1+y)**5*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+97200*logy*r**11*(
          -1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +2025*r**7*(-1+y)*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(
          -1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y
          -y**2+y**3))**4))
      resNP += ((api*(-518400*logy**4*r**15*(-3+4*r**2+12*r**4+15*r**6)*(
          -1+y)**8-8640*logy**3*r**11*(-1+y)**6*(303*r**14*(-1+y)**2+r**12*(557
          -1114*y+557*y**2+30*y**3)-5*r**10*(-575+430*y+505*y**2-494*y**3
          +60*y**4)+5*(-1+y)**3*(-55-55*y-55*y**2+191*y**3-112*y**4+20*y**5)
          +5*r**8*(-307+1190*y-1171*y**2+418*y**3-138*y**4+78*y**5)+r**2*(-1
          +y)**2*(-127-1150*y**3+1235*y**4-468*y**5+60*y**6)+5*r**6*(-431+1054*y
          -719*y**2+24*y**3+261*y**4-216*y**5+69*y**6)-r**4*(193+334*y-887*y**2
          +90*y**3+65*y**4+422*y**5-229*y**6+12*y**7))-144*logy**2*r**7*(-1+y)**4*(
          -1+r**2+y)**2*(421*r**18*(-1+y)**4-r**16*(-1+y)**2*(-8359+17560*y
          -10043*y**2+1942*y**3)-r**14*(-1+y)**2*(-97092+157204*y-51665*y**2
          -8304*y**3+257*y**4)-(-1+y)**5*(-833-2499*y-4998*y**2-310*y**3+2875*y**4
          +6693*y**5-6656*y**6+1528*y**7)+r**12*(90740-365364*y+577249*y**2
          -390800*y**3+34450*y**4+85820*y**5-37231*y**6+5636*y**7)+r**10*(330718
          -834456*y+612923*y**2+76590*y**3-295775*y**4+135422*y**5-35089*y**6
          +12372*y**7-1205*y**8)+r**4*(-1+y)**3*(71732+35808*y+27133*y**2-280753*y**3
          +233150*y**4-65902*y**5+8477*y**6-4393*y**7+1448*y**8)-r**2*(-1+y)**4*(5955
          +13576*y+22863*y**2-17954*y**3-3525*y**4-21670*y**5+30919*y**6-12508*y**7
          +1544*y**8)+r**6*(-1+y)**2*(31676-80900*y-42833*y**2+450852*y**3-487085*y**4
          +156424*y**5+21985*y**6-22172*y**7+4153*y**8)+r**8*(124314-274276*y
          +43999*y**2+557844*y**3-902951*y**4+566186*y**5-48799*y**6-104024*y**7
          +41281*y**8-3574*y**9))+12*logy*r**3*(-1+y)**3*(-1+r**2+y)**3*(7*r**24*(
          -1+y)**5+r**22*(-1+y)**3*(-638+1255*y-596*y**2+117*y**3)+r**20*(41204
          -197809*y+375995*y**2-355352*y**3+169948*y**4-35831*y**5+2077*y**6
          -232*y**7)+r**18*(266802-1248795*y+2320737*y**2-2166320*y**3+1038942*y**4
          -209565*y**5-9373*y**6+8280*y**7-708*y**8)-3*(-1+y)**7*(-7-35*y
          -105*y**2-211*y**3-157*y**4+167*y**5+245*y**6+115*y**7-304*y**8+92*y**9)
          +r**16*(1649289-6631428*y+9935031*y**2-6068242*y**3+135207*y**4+1487256*y**5
          -557277*y**6+59584*y**7-10458*y**8+1038*y**9)+r**6*(-1+y)**4*(-93074
          -191473*y-326709*y**2+577618*y**3-54374*y**4+583036*y**5-945652*y**6
          +443414*y**7-54328*y**8-5971*y**9+313*y**10)-r**8*(-1+y)**3*(-1309037
          +127984*y+230971*y**2+4783034*y**3-6140644*y**4+2022854*y**5+573716*y**6
          -495686*y**7+90621*y**8-1146*y**9+333*y**10)-r**2*(-1+y)**6*(1630+6583*y
          +16615*y**2+13053*y**3+909*y**4-23115*y**5+3937*y**6-2025*y**7+6857*y**8
          -3304*y**9+460*y**10)-r**4*(-1+y)**5*(-54428-148245*y-276534*y**2
          +71552*y**3+161266*y**4+317382*y**5-422970*y**6+133144*y**7+218*y**8
          -5401*y**9+816*y**10)+2*r**14*(-143350+139205*y+1127837*y**2-2245586*y**3
          +632752*y**4+1501882*y**5-1387310*y**6+398858*y**7-7974*y**8-15447*y**9
          +933*y**10)-2*r**10*(-1+y)**2*(-873366+1625157*y+179697*y**2-3995173*y**3
          +4164601*y**4-786855*y**5-774507*y**6+330283*y**7+3383*y**8-13536*y**9
          +1716*y**10)-2*r**12*(-1439316+3375459*y-1031061*y**2-3340418*y**3
          +2857764*y**4+755592*y**5-1973258*y**6+968046*y**7-192972*y**8+22321*y**9
          -3141*y**10+984*y**11))-r*(-1+y)**2*(-1+r**2+y)**4*(3*r**26*(-1+y)**6
          +r**24*(-1+y)**4*(-383+670*y-233*y**2+14*y**3)+2*r**22*(-1+y)**2*(18151
          -68058*y+92798*y**2-57364*y**3+16997*y**4-2124*y**5+10*y**6)+(-1
          +y)**10*(1+8*y+36*y**2+22*y**3-68*y**4-140*y**5-92*y**6+50*y**7
          +19*y**8+4*y**9)+2*r**20*(293461-1581600*y+3465875*y**2-3918644*y**3
          +2354738*y**4-643781*y**5+5465*y**6+24790*y**7-951*y**8+47*y**9)+r**18*(1227213
          -6151010*y+12628771*y**2-13582384*y**3+7823874*y**4-1756328*y**5-539390*y**6
          +456244*y**7-119051*y**8+14886*y**9+775*y**10)+r**2*(-1+y)**7*(1597
          +7729*y+22545*y**2+35921*y**3+20674*y**4-35858*y**5-29894*y**6-11870*y**7
          +39569*y**8-13959*y**9+661*y**10+85*y**11)+2*r**4*(-1+y)**6*(-24275
          -90386*y-213624*y**2-100138*y**3+21373*y**4+245107*y**5-124271*y**6
          +33439*y**7-37702*y**8+21687*y**9-4517*y**10+307*y**11)+2*r**6*(-1
          +y)**5*(318561+719501*y+1162698*y**2-1119772*y**3-994436*y**4-1411174*y**5
          +2889940*y**6-1153918*y**7-10753*y**8+85061*y**9-15282*y**10+1174*y**11)
          +4*r**12*(-1+y)**2*(8162815-13671650*y+576456*y**2+10153426*y**3-2301285*y**4
          -5517227*y**5+3240765*y**6+74209*y**7-424376*y**8+123675*y**9-13203*y**10
          +2295*y**11)+r**16*(10942159-49558070*y+85612431*y**2-61013654*y**3
          -3208512*y**4+33347098*y**5-20646876*y**6+4824454*y**7-325871*y**8+27612*y**9
          -6147*y**10+2976*y**11)+r**8*(-1+y)**4*(874927+790618*y+9369*y**2
          -765350*y**3-2072958*y**4+4727512*y**5-3492258*y**6+1065616*y**7-91625*y**8
          +49638*y**9-25839*y**10+5550*y**11)+r**10*(-1+y)**3*(12993683-5255233*y
          -4892007*y**2-37712275*y**3+58851726*y**4-18161794*y**5-10672230*y**6
          +7244402*y**7-1001185*y**8+8019*y**9-16179*y**10+8673*y**11)+4*r**14*(
          -4530563+19404840*y-28996867*y**2+13603930*y**3+7129940*y**4-8005778*y**5
          +264788*y**6+1140190*y**7+379035*y**8-535990*y**9+161451*y**10-16608*y**11
          +1632*y**12)))*math.log(mu0**2/r**2))/(6220800*logy**4*r**16*(-1+y)**8+2073600*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +259200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+14400*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+300*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(21600*logy**3*r**11*(27+41*r**2
          +29*r**4+9*r**6)*(-1+y)**8+720*logy**2*r**7*(-1+y)**6*(74*r**12*(-1+y)**2
          +31*r**14*(-1+y)**2+r**10*(1389-1968*y+174*y**2+485*y**3-90*y**4)
          +5*r**8*(443-364*y-340*y**2+242*y**3+y**4+4*y**5)-(-1+y)**3*(11
          +11*y+11*y**2+251*y**3-184*y**4+20*y**5)-r**2*(-1+y)**2*(599-455*y**3
          +430*y**4-234*y**5+20*y**6)+5*r**6*(-17+772*y-1124*y**2+168*y**3
          +255*y**4-105*y**5+27*y**6)+r**4*(-3036+8502*y-6681*y**2-50*y**3
          +1860*y**4-744*y**5+113*y**6+36*y**7))+6*logy*r**3*(-1+y)**4*(-1+r**2
          +y)**2*(41*r**18*(-1+y)**4-r**16*(-1+y)**2*(-643+1368*y-807*y**2+162*y**3)
          -r**14*(-1+y)**2*(-15790+25508*y-7489*y**2-1926*y**3+257*y**4)+r**12*(
          -1+y)**2*(22492-45292*y+26723*y**2+338*y**3-2257*y**4+556*y**5)+(
          -1+y)**4*(11+22*y+33*y**2+604*y**3-95*y**4+94*y**5+683*y**6-1128*y**7
          +376*y**8)+r**10*(325264-987788*y+962749*y**2-168480*y**3-240815*y**4
          +115216*y**5-2237*y**6-4404*y**7+495*y**8)+r**2*(-1+y)**3*(1217+1195*y
          +1173*y**2+10851*y**3-12281*y**4+853*y**5-4525*y**6+5397*y**7-1856*y**8
          +376*y**9)+r**4*(-1+y)**2*(18460+228*y-1059*y**2-127026*y**3+222587*y**4
          -138000*y**5+21407*y**6+9694*y**7-3339*y**8+648*y**9)-r**8*(-592234
          +1816036*y-1796019*y**2+337456*y**3+482771*y**4-315066*y**5+67539*y**6
          +5044*y**7-6881*y**8+754*y**9)+r**6*(171082-446136*y+345989*y**2-173976*y**3
          +407904*y**4-548040*y**5+323186*y**6-83264*y**7-1874*y**8+5496*y**9
          -367*y**10))+r*(-1+y)**3*(-1+r**2+y)**3*(11*r**20*(-1+y)**5-r**18*(
          -1+y)**3*(-887+1561*y-584*y**2+20*y**3)-r**14*(-1+y)**2*(98866-215370*y
          +117060*y**2+18665*y**3-23400*y**4+2019*y**5+60*y**6)-6*r**16*(829
          -3910*y+7345*y**2-6960*y**3+3400*y**4-689*y**5-40*y**6+25*y**7)+r**12*(56552
          -202342*y+195188*y**2+67937*y**3-212345*y**4+111118*y**5-11938*y**6
          -5343*y**7+783*y**8+390*y**9)+(-1+y)**5*(56+168*y+336*y**2+869*y**3
          +572*y**4+363*y**5+82*y**6-561*y**7-144*y**8-47*y**9+106*y**10)+3*r**10*(
          -502676+1833106*y-2306948*y**2+790633*y**3+694954*y**4-671513*y**5
          +142444*y**6+32823*y**7-14458*y**8+871*y**9+164*y**10)+3*r**4*(-1+y)**3*(2543
          +3408*y+3113*y**2-42897*y**3+52608*y**4-18023*y**5+5142*y**6-7563*y**7
          +2797*y**8-133*y**9+205*y**10)+r**6*(-1+y)**2*(-128446+85278*y+28872*y**2
          +551901*y**3-1196170*y**4+902511*y**5-195488*y**6-103457*y**7+56364*y**8
          -5265*y**9+300*y**10)+r**2*(-1+y)**4*(1603+3104*y+4470*y**2+2351*y**3
          +1462*y**4-2943*y**5-16354*y**6+18205*y**7-7701*y**8+763*y**9+440*y**10)
          +r**8*(-598858+1924148*y-2036302*y**2+663653*y**3-36127*y**4+208109*y**5
          -130003*y**6+28427*y**7-47803*y**8+28227*y**9-3651*y**10+180*y**11)))*nlo.X1El(0,'SM',y/2,r))/(1036800*logy**4*r**16*(
          -1+y)**8+345600*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+43200*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+2400*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +50*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-21600*logy**3*r**11*(27+41*r**2+29*r**4+9*r**6)*(-1+y)**8-720*logy**2*r**7*(
          -1+y)**6*(74*r**12*(-1+y)**2+31*r**14*(-1+y)**2+r**10*(1389-1968*y
          +174*y**2+485*y**3-90*y**4)+5*r**8*(443-364*y-340*y**2+242*y**3+y**4
          +4*y**5)-(-1+y)**3*(11+11*y+11*y**2+251*y**3-184*y**4+20*y**5)
          -r**2*(-1+y)**2*(599-455*y**3+430*y**4-234*y**5+20*y**6)+5*r**6*(-17
          +772*y-1124*y**2+168*y**3+255*y**4-105*y**5+27*y**6)+r**4*(-3036
          +8502*y-6681*y**2-50*y**3+1860*y**4-744*y**5+113*y**6+36*y**7))-6*logy*r**3*(
          -1+y)**4*(-1+r**2+y)**2*(41*r**18*(-1+y)**4-r**16*(-1+y)**2*(-643+1368*y
          -807*y**2+162*y**3)-r**14*(-1+y)**2*(-15790+25508*y-7489*y**2-1926*y**3
          +257*y**4)+r**12*(-1+y)**2*(22492-45292*y+26723*y**2+338*y**3-2257*y**4
          +556*y**5)+(-1+y)**4*(11+22*y+33*y**2+604*y**3-95*y**4+94*y**5
          +683*y**6-1128*y**7+376*y**8)+r**10*(325264-987788*y+962749*y**2-168480*y**3
          -240815*y**4+115216*y**5-2237*y**6-4404*y**7+495*y**8)+r**2*(-1+y)**3*(1217
          +1195*y+1173*y**2+10851*y**3-12281*y**4+853*y**5-4525*y**6+5397*y**7
          -1856*y**8+376*y**9)+r**4*(-1+y)**2*(18460+228*y-1059*y**2-127026*y**3
          +222587*y**4-138000*y**5+21407*y**6+9694*y**7-3339*y**8+648*y**9)-r**8*(
          -592234+1816036*y-1796019*y**2+337456*y**3+482771*y**4-315066*y**5
          +67539*y**6+5044*y**7-6881*y**8+754*y**9)+r**6*(171082-446136*y+345989*y**2
          -173976*y**3+407904*y**4-548040*y**5+323186*y**6-83264*y**7-1874*y**8
          +5496*y**9-367*y**10))-r*(-1+y)**3*(-1+r**2+y)**3*(11*r**20*(-1+y)**5
          -r**18*(-1+y)**3*(-887+1561*y-584*y**2+20*y**3)-r**14*(-1+y)**2*(98866
          -215370*y+117060*y**2+18665*y**3-23400*y**4+2019*y**5+60*y**6)-6*r**16*(829
          -3910*y+7345*y**2-6960*y**3+3400*y**4-689*y**5-40*y**6+25*y**7)+r**12*(56552
          -202342*y+195188*y**2+67937*y**3-212345*y**4+111118*y**5-11938*y**6
          -5343*y**7+783*y**8+390*y**9)+(-1+y)**5*(56+168*y+336*y**2+869*y**3
          +572*y**4+363*y**5+82*y**6-561*y**7-144*y**8-47*y**9+106*y**10)+3*r**10*(
          -502676+1833106*y-2306948*y**2+790633*y**3+694954*y**4-671513*y**5
          +142444*y**6+32823*y**7-14458*y**8+871*y**9+164*y**10)+3*r**4*(-1+y)**3*(2543
          +3408*y+3113*y**2-42897*y**3+52608*y**4-18023*y**5+5142*y**6-7563*y**7
          +2797*y**8-133*y**9+205*y**10)+r**6*(-1+y)**2*(-128446+85278*y+28872*y**2
          +551901*y**3-1196170*y**4+902511*y**5-195488*y**6-103457*y**7+56364*y**8
          -5265*y**9+300*y**10)+r**2*(-1+y)**4*(1603+3104*y+4470*y**2+2351*y**3
          +1462*y**4-2943*y**5-16354*y**6+18205*y**7-7701*y**8+763*y**9+440*y**10)
          +r**8*(-598858+1924148*y-2036302*y**2+663653*y**3-36127*y**4+208109*y**5
          -130003*y**6+28427*y**7-47803*y**8+28227*y**9-3651*y**10+180*y**11)))*nlo.X1El(0,'VL',y/2,r))/(3110400*logy**4*r**16*(
          -1+y)**8+1036800*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+129600*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+7200*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +150*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6+120*logy*r**4*(
          -1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(-67+98*y
          -13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3-2*y**4
          +y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)+2*r**2*(
          -1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y-421*y**2
          +40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(
          -1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1
          +y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(
          -4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y
          +45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)
          +2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5
          -56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(0,'VLVR',y/2,r))/(1036800*logy**3*r**12*(
          -1+y)**6-600*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +259200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-3600*logy**2*r**8*(15+10*r**2
          +3*r**4)*(-1+y)**6-120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(
          -1+y)**2-5*r**8*(-67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y
          -18*y**2+22*y**3-2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3
          -16*y**4+2*y**5)+2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(
          -151+482*y-421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))-(-1+y)**2*(
          -1+r**2+y)**2*(7*r**16*(-1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2
          +27*y**3)-r**12*(-1+y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)
          +2*r**10*(-1+y)**2*(-4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)
          +5*r**8*(13422-43158*y+45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6
          -284*y**7+33*y**8)+2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3
          -2300*y**4+277*y**5-56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436
          -542*y+757*y**2+11016*y**3-25545*y**4+20466*y**5-4753*y**6-652*y**7
          +89*y**8)+(-1+y)**4*(67+134*y+201*y**2+428*y**3-55*y**4-22*y**5
          -89*y**6-156*y**7+92*y**8)-2*r**6*(-17964+49281*y-40854*y**2+5986*y**3
          +8446*y**4-11636*y**5+9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(0,'VR',y/2,r))/(518400*logy**3*r**12*(
          -1+y)**6-300*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +129600*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+10800*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(2160*logy**2*r**7*(4+5*r**2
          +2*r**4)*(-1+y)**6+72*logy*r**3*(-1+y)**4*(8*r**10*(-1+y)**2+3*r**12*(
          -1+y)**2-5*r**8*(-44+64*y-8*y**2-13*y**3+2*y**4)+2*(-1+y)**3*(
          -1-y-y**2-6*y**3+4*y**4)+5*r**6*(26+8*y-64*y**2+21*y**3+7*y**4)
          +r**2*(-1+y)**2*(-58+35*y**3-15*y**4+8*y**5)+5*r**4*(-61+170*y-133*y**2
          +y**3+31*y**4-11*y**5+3*y**6))+3*r*(-1+y)**3*(-1+r**2+y)**2*(7*r**12*(
          -1+y)**3+2*r**10*(-81+214*y-174*y**2+35*y**3+6*y**4)+r**8*(-169
          +509*y-558*y**2+220*y**3+3*y**4-5*y**5)-4*r**6*(1431-2992*y+1413*y**2
          +518*y**3-447*y**4+47*y**5)+(-1+y)**3*(-13-26*y-39*y**2-54*y**3
          -9*y**4+4*y**5+17*y**6)+2*r**2*(-1+y)**2*(-61-72*y-71*y**2+319*y**3
          -256*y**4+55*y**5+26*y**6)+r**4*(-1749+2827*y-705*y**2+335*y**3-1195*y**4
          +489*y**5-47*y**6+45*y**7)))*nlo.X1El(1,'SM',y/2,r))/(-8640*logy**3*r**12*(
          -1+y)**6+5*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -2160*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-180*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-720*logy**2*r**7*(4+5*r**2
          +2*r**4)*(-1+y)**6-24*logy*r**3*(-1+y)**4*(8*r**10*(-1+y)**2+3*r**12*(
          -1+y)**2-5*r**8*(-44+64*y-8*y**2-13*y**3+2*y**4)+2*(-1+y)**3*(
          -1-y-y**2-6*y**3+4*y**4)+5*r**6*(26+8*y-64*y**2+21*y**3+7*y**4)
          +r**2*(-1+y)**2*(-58+35*y**3-15*y**4+8*y**5)+5*r**4*(-61+170*y-133*y**2
          +y**3+31*y**4-11*y**5+3*y**6))-r*(-1+y)**3*(-1+r**2+y)**2*(7*r**12*(
          -1+y)**3+2*r**10*(-81+214*y-174*y**2+35*y**3+6*y**4)+r**8*(-169
          +509*y-558*y**2+220*y**3+3*y**4-5*y**5)-4*r**6*(1431-2992*y+1413*y**2
          +518*y**3-447*y**4+47*y**5)+(-1+y)**3*(-13-26*y-39*y**2-54*y**3
          -9*y**4+4*y**5+17*y**6)+2*r**2*(-1+y)**2*(-61-72*y-71*y**2+319*y**3
          -256*y**4+55*y**5+26*y**6)+r**4*(-1749+2827*y-705*y**2+335*y**3-1195*y**4
          +489*y**5-47*y**6+45*y**7)))*nlo.X1El(1,'VL',y/2,r))/(-8640*logy**3*r**12*(
          -1+y)**6+5*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -2160*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-180*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1
          +y)**4-(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1
          +y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(1,'VLVR',y/2,r))/(1440*logy**2*r**8*(-1+y)**4+240*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(60*logy*r**4*(3+r**2)*(-1+y)**4+(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(1,'VR',y/2,r))/(720*logy**2*r**8*(
          -1+y)**4+120*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(72*logy*r**3*(1+r**2)*(-1+y)**4
          +12*r*(-1+y)**3*(r**6*(-1+y)+3*r**2*(-1+y)**2*(3+y)+3*r**4*(-3+y
          +y**2)+(-1+y)**2*(1+y+y**2)))*nlo.X1El(2,'SM',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-24*logy*r**3*(1+r**2)*(-1+y)**4
          -4*r*(-1+y)**3*(r**6*(-1+y)+3*r**2*(-1+y)**2*(3+y)+3*r**4*(-3+y
          +y**2)+(-1+y)**2*(1+y+y**2)))*nlo.X1El(2,'VL',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(2,'VLVR',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -(2*api*(-1+y)**2*nlo.X1El(2,'VR',y/2,r))/(12*logy*r**4*(-1+y)**2-r**8*(
          -1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.VLVR

    if wc.SLT != 0:
      resNP = 0
      resNP +=((-43200*logy**3*r**12*(3+4*r**2+3*r**4)*(-1+y)**6-720*logy**2*r**8*(-1
          +y)**4*(164*r**10*(-1+y)**2-11*r**12*(-1+y)**2+20*r**6*y*(36-54*y+10*y**2
          +7*y**3+y**4)+5*r**8*(121-134*y-41*y**2+52*y**3+6*y**4)+5*r**4*(
          -1+y)**2*(-121+108*y+54*y**2-20*y**3+9*y**4)+4*r**2*(-1+y)**3*(41
          +41*y+41*y**2-49*y**3+21*y**4)+(-1+y)**4*(11+22*y+33*y**2-76*y**3
          +40*y**4))+12*logy*r**4*(-1+y)**4*(-1+r**2+y)**2*(19*r**16*(-1+y)**2
          +r**14*(218-474*y+294*y**2-238*y**3)+r**12*(-1148+3142*y-2123*y**2
          +1572*y**3-443*y**4)+2*r**10*(-10537+13465*y-515*y**2-3615*y**3-300*y**4
          +202*y**5)+2*r**2*(-1+y)**3*(-109-346*y-730*y**2+1380*y**3-365*y**4
          -406*y**5+76*y**6)+5*r**8*(-12806+12806*y+1421*y**2-3000*y**3+544*y**4
          -1006*y**5+161*y**6)+(-1+y)**4*(19+76*y+190*y**2+500*y**3+115*y**4
          -584*y**5+184*y**6)-r**4*(-1+y)**2*(1148+3142*y+5265*y**2+9440*y**3
          -6750*y**4+122*y**5+533*y**6)-2*r**6*(10537-7609*y-2413*y**2-14055*y**3
          +20335*y**4-8087*y**5+1149*y**6+143*y**7))+(-1+y)**2*(-1+r**2+y)**3*(r**22*(
          -1+y)**4+r**20*(-1+y)**2*(-25+47*y-19*y**2+5*y**3)+r**18*(1387-5248*y
          +7242*y**2-4568*y**3+1347*y**4-40*y**5)-(-1+y)**8*(-1-7*y-28*y**2
          +12*y**3+77*y**4+23*y**5+4*y**6)-r**2*(-1+y)**7*(-25-147*y-504*y**2
          +620*y**3+1465*y**4+15*y**5+12*y**6+4*y**7)-5*r**16*(1175-4451*y
          +5934*y**2-2618*y**3-493*y**4+585*y**5-48*y**6+12*y**7)-5*r**6*(-1
          +y)**4*(1175+3276*y+5934*y**2+10472*y**3-3694*y**4-3756*y**5+2766*y**6
          -120*y**7+27*y**8)-r**4*(-1+y)**5*(1387+5248*y+12490*y**2+5220*y**3
          -90*y**4-7872*y**5+5282*y**6-100*y**7+35*y**8)-2*r**14*(631-3826*y
          +8355*y**2-25440*y**3+42470*y**4-30206*y**5+8211*y**6-600*y**7+105*y**8)
          -2*r**8*(-1+y)**3*(-631-2564*y-5160*y**2-6000*y**3+20785*y**4-4*y**5
          +4704*y**6-780*y**7+150*y**8)-2*r**10*(-1+y)**2*(105113-18136*y-30544*y**2
          -110660*y**3+98965*y**4-5768*y**5+2496*y**6-1176*y**7+210*y**8)-2*r**12*(105113
          -297203*y+248523*y**2+60251*y**3-224574*y**4+142492*y**5-42657*y**6
          +9147*y**7-1281*y**8+189*y**9)))/(1036800*logy**3*r**12*(-1+y)**6-600*(r**8*(
          -1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3+259200*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2))
      resNP += ((api*(-1036800*logy**4*r**18*(2+3*r**2)*(-1+y)**8
          -17280*logy**3*r**12*(-1+y)**6*(8*r**12*(-1+y)**2+r**10*(236-472*y+236*y**2
          +15*y**3)+20*r**4*(-1+y)**2*(-13-2*y**3+3*y**4)+10*r**8*(49-26*y
          -59*y**2+39*y**3+3*y**4)+5*r**6*(-96+288*y-240*y**2+56*y**3-16*y**4
          +17*y**5)-2*(-1+y)**3*(17+17*y+17*y**2+32*y**3-58*y**4+20*y**5)
          -r**2*(-1+y)**2*(28+275*y**3-210*y**4+42*y**5))-288*logy**2*r**8*(-1
          +y)**4*(-1+r**2+y)**2*(-112*r**16*(-1+y)**4+r**14*(-1+y)**2*(336-448*y
          -112*y**2+779*y**3)+2*r**12*(-1+y)**2*(5492-10488*y+4692*y**2-923*y**3
          +327*y**4)+r**10*(34832-116384*y+137352*y**2-53995*y**3-7700*y**4
          +1113*y**5+5874*y**6-992*y**7)-2*r**4*(-1+y)**3*(-4328-2824*y-2628*y**2
          +955*y**3+12920*y**4-7362*y**5+224*y**6+143*y**7)+4*(-1+y)**5*(-37
          -111*y-222*y**2-75*y**3+255*y**4+522*y**5-674*y**6+192*y**7)+r**2*(
          -1+y)**4*(-1704-3112*y-4224*y**2-4685*y**3+5060*y**4+1659*y**5-2238*y**6
          +494*y**7)+r**6*(-1+y)**2*(14392-13224*y-8808*y**2+51485*y**3-45300*y**4
          +15498*y**5-4296*y**6+1503*y**7)+20*r**8*(2889-7286*y+4949*y**2+1597*y**3
          -3480*y**4+1751*y**5-534*y**6+76*y**7+38*y**8))+24*logy*r**4*(-1+y)**4*(
          -1+r**2+y)**3*(4*r**22*(-1+y)**4-r**20*(-1+y)**2*(-232+476*y-256*y**2
          +141*y**3)+r**18*(5842-21388*y+28500*y**2-17497*y**3+5041*y**4+297*y**5
          -35*y**6)+r**16*(-56190+201150*y-252012*y**2+106908*y**3+10278*y**4
          -7917*y**5-4822*y**6+405*y**7)-r**14*(172832-572672*y+668172*y**2
          -364570*y**3+151390*y**4-71187*y**5+10757*y**6+3193*y**7+885*y**8)
          +r**12*(-257592+594240*y-362844*y**2-273896*y**3+332492*y**4+91047*y**5
          -155240*y**6+13954*y**7+8256*y**8-2217*y**9)+3*r**2*(-1+y)**5*(114
          +478*y+1250*y**2+1451*y**3-748*y**4-4034*y**5+3342*y**6-85*y**7-286*y**8
          +18*y**9)+2*(-1+y)**6*(-11-55*y-165*y**2-282*y**3-327*y**4-99*y**5
          +445*y**6+280*y**7-378*y**8+92*y**9)+r**6*(-1+y)**3*(-64860-86340*y
          -91452*y**2+22742*y**3+205360*y**4-3735*y**5-138280*y**6+75692*y**7
          -14232*y**8+405*y**9)-r**4*(-1+y)**4*(1648+2484*y+1956*y**2-42873*y**3
          -36750*y**4-31968*y**5+94636*y**6-41501*y**7+2158*y**8+710*y**9)+r**8*(
          -1+y)**2*(79828+23284*y+46960*y**2-160382*y**3-244580*y**4+252787*y**5
          -34724*y**6+20860*y**7-21548*y**8+2415*y**9)+r**10*(-526140+1054488*y
          -364260*y**2-884652*y**3+1588572*y**4-1448373*y**5+754697*y**6-177150*y**7
          +6522*y**8-4097*y**9+393*y**10))-2*r**2*(-1+y)**2*(-1+r**2+y)**4*(r**26*(
          -1+y)**6+r**24*(-1+y)**4*(-30+56*y-22*y**2+5*y**3)+2*r**22*(-1+y)**2*(95
          -346*y+427*y**2-262*y**3+139*y**4-40*y**5+3*y**6)+r**20*(-11200+63724*y
          -148648*y**2+189734*y**3-152060*y**4+81815*y**5-27896*y**6+4984*y**7
          -100*y**8+7*y**9)+(-1+y)**9*(2+14*y+56*y**2+183*y**3-21*y**4-1152*y**5
          -562*y**6+561*y**7-41*y**8-2*y**9+2*y**10)+r**18*(4819-57694*y+205219*y**2
          -366080*y**3+421190*y**4-365714*y**5+227244*y**6-81324*y**7+11995*y**8
          -740*y**9+125*y**10)+r**2*(-1+y)**7*(-1365-6553*y-18975*y**2-31755*y**3
          -22058*y**4+22800*y**5+16342*y**6+5060*y**7-19025*y**8+6433*y**9-135*y**10
          +31*y**11)+r**4*(-1+y)**6*(-4208-15748*y-35552*y**2-94102*y**3-117872*y**4
          -79735*y**5+227758*y**6-45033*y**7-46508*y**8+19887*y**9-1082*y**10
          +195*y**11)+2*r**6*(-1+y)**5*(-12655-20203*y-19115*y**2+182603*y**3
          +49330*y**4+84968*y**5-341790*y**6+184970*y**7-36723*y**8+15015*y**9
          -2143*y**10+343*y**11)+r**16*(613514-3054860*y+5956370*y**2-5264689*y**3
          +1136020*y**4+1608863*y**5-1339062*y**6+393305*y**7-66186*y**8+20985*y**9
          -4272*y**10+612*y**11)+2*r**12*(-1+y)**2*(735160-1415188*y+429808*y**2
          +2776762*y**3-4251088*y**4+2293345*y**5-725958*y**6+470677*y**7-243012*y**8
          +69573*y**9-8010*y**10+1131*y**11)+r**8*(-1+y)**4*(-772394-700752*y
          -494858*y**2+1619339*y**3+1485220*y**4-539206*y**5-1879128*y**6+1318028*y**7
          -286194*y**8+68410*y**9-10190*y**10+1525*y**11)+r**10*(-1+y)**3*(-1192727
          +94877*y+800407*y**2+1158787*y**3-1253062*y**4+216010*y**5-1080906*y**6
          +1480858*y**7-588387*y**8+137577*y**9-15693*y**10+2259*y**11)+4*r**14*(17897
          -45844*y+72820*y**2-506376*y**3+1636829*y**4-2411669*y**5+1845685*y**6
          -754510*y**7+181801*y**8-53229*y**9+19257*y**10-3036*y**11+375*y**12))))/(4665600*logy**4*r**16*(
          -1+y)**8+1555200*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+194400*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+10800*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +225*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*muWC*(6220800*logy**4*r**16*(-1+r**4)*(-1+y)**8+34560*logy**3*r**12*(
          -1+y)**5*(42*r**12*(-1+y)**3+r**10*(-208+624*y-624*y**2+13*y**3+105*y**4)
          +5*r**8*(-46-6*y+222*y**2-297*y**3+87*y**4+12*y**5)+3*(-1+y)**3*(14
          +55*y**3-80*y**4+26*y**5)+r**2*(-1+y)**3*(208-315*y**3+42*y**5)+15*r**6*(64
          -192*y+192*y**2-64*y**3-16*y**4+9*y**5+y**6)+5*r**4*(-46+282*y
          -498*y**2+398*y**3-222*y**4+147*y**5-73*y**6+12*y**7))-2880*logy**2*r**8*(
          -1+y)**3*(-1+r**2+y)**2*(52*r**16*(-1+y)**5-r**14*(-1+y)**2*(-408+1120*y
          -912*y**2-25*y**3+251*y**4)-r**12*(-1+y)**2*(-3928+10984*y-9984*y**2
          +2373*y**3-599*y**4+390*y**5)+(-1+y)**5*(-52-104*y-156*y**2+215*y**3
          +112*y**4+231*y**5-450*y**6+174*y**7)+r**2*(-1+y)**4*(-408-304*y
          -200*y**2-565*y**3+481*y**4+345*y**5+507*y**6-506*y**7+130*y**8)+r**8*y*(11048
          -38668*y+67955*y**2-72455*y**3+43555*y**4-14653*y**5+4498*y**6-1420*y**7
          +140*y**8)-r**4*(-1+y)**3*(-3928+800*y+200*y**2-5635*y**3+13986*y**4
          -9546*y**5+1636*y**6-409*y**7+146*y**8)+r**10*(4088-18496*y+34304*y**2
          -20035*y**3-11393*y**4+13531*y**5-183*y**6-2056*y**7+320*y**8)-r**6*(
          -1+y)**2*(4088-6032*y+3144*y**2-12543*y**3+12905*y**4-4458*y**5+2382*y**6
          -2189*y**7+543*y**8))-48*logy*r**4*(-1+y)**3*(-1+r**2+y)**3*(26*r**22*(
          -1+y)**5-r**20*(-1+y)**2*(574-1800*y+1956*y**2-753*y**3+345*y**4)
          +r**18*(-7490+33010*y-55976*y**2+47036*y**3-19447*y**4+125*y**5+4037*y**6
          -735*y**7)+r**16*(121050-538260*y+911874*y**2-677983*y**3+139052*y**4
          +65597*y**5-20013*y**6-4762*y**7+405*y**8)+(-1+y)**6*(26+104*y+260*y**2
          +425*y**3-730*y**4-2296*y**5+1916*y**6+165*y**7-480*y**8+110*y**9)
          +r**14*(252660-1088100*y+1836624*y**2-1407072*y**3+559950*y**4-322140*y**5
          +220125*y**6-30459*y**7-12763*y**8+375*y**9)+r**12*(-268548+1250520*y
          -2026836*y**2+2675214*y**3-2722128*y**4+1090476*y**5+227315*y**6-214814*y**7
          +24166*y**8+7428*y**9-2793*y**10)-r**4*(-1+y)**4*(-7490-10540*y-12426*y**2
          +58279*y**3+36947*y**4+12285*y**5-145330*y**6+93941*y**7-19979*y**8
          +363*y**9+250*y**10)-r**2*(-1+y)**5*(574+1800*y+3756*y**2-2084*y**3
          +5013*y**4+1272*y**5-12260*y**6+6744*y**7+1379*y**8-1988*y**9+294*y**10)
          +r**8*(-1+y)**2*(-252660+175200*y-10824*y**2-362034*y**3+1287918*y**4
          -1071150*y**5+205935*y**6+66174*y**7+3284*y**8-10058*y**9+615*y**10)
          +r**6*(-1+y)**3*(121050+54060*y+23394*y**2-28416*y**3-123558*y**4
          +85710*y**5-12875*y**6+10136*y**7+22766*y**8-13122*y**9+1155*y**10)
          +r**10*(268548-629316*y+163224*y**2+1750400*y**3-3619288*y**4+3573674*y**5
          -2450339*y**6+1296801*y**7-388250*y**8+21888*y**9+15553*y**10-2895*y**11))
          +4*(-1+y)*(-1+r**2+y)**4*(r**28*(-1+y)**7+r**26*(-1+y)**4*(28-80*y
          +72*y**2-27*y**3+5*y**4)+r**24*(-1+y)**2*(1175-5671*y+10876*y**2
          -9951*y**3+4184*y**4-740*y**5-87*y**6+6*y**7)-(-1+y)**10*(-1-7*y
          -28*y**2-121*y**3-91*y**4+410*y**5+218*y**6-151*y**7+72*y**8+17*y**9
          +2*y**10)+r**22*(6992-46552*y+132700*y**2-216026*y**3+232266*y**4
          -180129*y**5+99971*y**6-35452*y**7+6568*y**8-105*y**9+7*y**10)+r**2*(
          -1+y)**9*(28+164*y+560*y**2+2455*y**3+638*y**4-8695*y**5-1260*y**6
          +2331*y**7-1594*y**8-57*y**9-12*y**10+2*y**11)+r**20*(20491-79133*y
          +48395*y**2+210005*y**3-566004*y**4+821595*y**5-841953*y**6+557984*y**7
          -200401*y**8+28728*y**9-792*y**10+125*y**11)+2*r**14*(-1+y)**2*y*(-110264
          +275660*y-6453718*y**2+13838274*y**3-11449245*y**4+5085751*y**5-1874981*y**6
          +630593*y**7-213729*y**8+59055*y**9-8127*y**10+1131*y**11)+r**4*(-1
          +y)**7*(1175+4496*y+10876*y**2-1602*y**3+1007*y**4-13175*y**5-22704*y**6
          +5183*y**7+9607*y**8-11637*y**9+1280*y**10-137*y**11+31*y**12)+r**6*(
          -1+y)**6*(-6992-18584*y-34996*y**2+16662*y**3-43934*y**4-49591*y**5
          +38531*y**6-59219*y**7-20837*y**8-681*y**9+1633*y**10-987*y**11+195*y**12)
          +r**18*(-1385908+8231096*y-20033036*y**2+24823567*y**3-14526489*y**4
          +80661*y**5+5361113*y**6-3472291*y**7+1138793*y**8-254701*y**9+42267*y**10
          -4484*y**11+612*y**12)+r**8*(-1+y)**5*(20491-23322*y-63227*y**2-784463*y**3
          -325784*y**4-99422*y**5+1765094*y**6-1583224*y**7+355023*y**8-52356*y**9
          +15101*y**10-3997*y**11+686*y**12)+r**10*(-1+y)**4*(1385908-84352*y
          -333824*y**2-1996653*y**3-535461*y**4+1579602*y**5+1049726*y**6-2317756*y**7
          +1158208*y**8-395734*y**9+78630*y**10-9819*y**11+1525*y**12)+r**12*(
          -1+y)**3*(1121139-1041452*y-1153750*y**2-3793048*y**3+11269785*y**4
          -7358754*y**5+970840*y**6-1162214*y**7+1427993*y**8-685830*y**9+143790*y**10
          -15558*y**11+2259*y**12)+r**16*(1121139-6806521*y+16141457*y**2-18245376*y**3
          +4352183*y**4+16988505*y**5-26696779*y**6+19140477*y**7-7203994*y**8
          +1367132*y**9-216534*y**10+69315*y**11-12504*y**12+1500*y**13))))/(13996800*logy**4*r**16*(
          -1+y)**8+4665600*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+583200*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+32400*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +675*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((mupi*(-518400*logy**4*r**16*(3+4*r**2+9*r**4)*(-1+y)**8+8640*logy**3*r**12*(
          -1+y)**4*(80*r**12*(-1+y)**4-5*r**2*(-1+y)**4*(-24+283*y**3-180*y**4
          +6*y**5)+9*r**10*(-104+416*y-624*y**2+411*y**3-144*y**4+15*y**5)
          -5*r**8*(240-528*y-72*y**2+1019*y**3-686*y**4+69*y**5+42*y**6)-(
          -1+y)**4*(-16-195*y**3+870*y**4-714*y**5+160*y**6)-5*r**6*(-240+1152*y
          -2112*y**2+1756*y**3-496*y**4+69*y**5-136*y**6+61*y**7)+15*r**4*(48
          -240*y+456*y**2-292*y**3-116*y**4+213*y**5-62*y**6-13*y**7+6*y**8))
          -144*logy**2*r**8*(-1+y)**2*(-1+r**2+y)**2*(138*r**16*(-1+y)**6+r**14*(
          -1+y)**2*(-5244+20700*y-30360*y**2+20155*y**3-6460*y**4+819*y**5)
          -r**12*(-1+y)**2*(-19404+81804*y-126390*y**2+90185*y**3-45300*y**4
          +7159*y**5+486*y**6)+r**10*(128292-658668*y+1341612*y**2-1278693*y**3
          +565082*y**4-129552*y**5+50218*y**6-25577*y**7+8888*y**8-402*y**9)
          -r**2*(-1+y)**4*(-3036+804*y+804*y**2-20581*y**3+76354*y**4-74744*y**5
          +12266*y**6+15691*y**7-6424*y**8+366*y**9)-r**6*(-1+y)**2*(-9852+36828*y
          -41592*y**2+146723*y**3-533612*y**4+555297*y**5-238968*y**6+50917*y**7
          -8608*y**8+867*y**9)-(-1+y)**5*(-402-402*y-402*y**2-197*y**3+7393*y**4
          -1733*y**5-14333*y**6+22042*y**7-13538*y**8+3072*y**9)+r**4*(-1+y)**3*(
          -2484+96*y-234*y**2+75861*y**3+38141*y**4-277236*y**5+232024*y**6
          -49931*y**7-11161*y**8+3924*y**9)-5*r**8*(-37608+180732*y-339966*y**2
          +279745*y**3-82318*y**4+10722*y**5-9984*y**6-12481*y**7+14908*y**8
          -4014*y**9+264*y**10))-12*logy*r**4*(-1+y)**2*(-1+r**2+y)**3*(24*r**22*(
          -1+y)**6-r**20*(-1+y)**2*(-1280+5192*y-7968*y**2+6745*y**3-2344*y**4
          +621*y**5)+r**18*(-24672+147432*y-364680*y**2+494082*y**3-405123*y**4
          +211092*y**5-73114*y**6+19266*y**7-2603*y**8)+r**16*(28200-221640*y
          +674400*y**2-1113923*y**3+1132749*y**4-739743*y**5+294352*y**6-78393*y**7
          +16375*y**8-1497*y**9)+(-1+y)**7*(-264-1056*y-2640*y**2-4249*y**3
          -490*y**4+6488*y**5-1344*y**6+2595*y**7-2326*y**8-950*y**9+736*y**10)
          +r**14*(370672-1895376*y+3812376*y**2-3686700*y**3+2182926*y**4-1285104*y**5
          +668571*y**6-213516*y**7+103780*y**8-33056*y**9+3027*y**10)+r**2*(-1
          +y)**5*(4480+8168*y+11064*y**2+15706*y**3-69853*y**4-31233*y**5+129700*y**6
          -126154*y**7+52259*y**8-1477*y**9-6022*y**10+1362*y**11)+r**4*(-1+y)**4*(8928
          +5928*y-312*y**2+174691*y**3-181796*y**4+66070*y**5-250145*y**6+553447*y**7
          -498646*y**8+178336*y**9-22553*y**10+1452*y**11)+r**12*(1613856-7387488*y
          +12873384*y**2-8048594*y**3-1098618*y**4+4083270*y**5-3674633*y**6+2544051*y**7
          -1052476*y**8+295268*y**9-39081*y**10+1461*y**11)+r**8*(-1+y)**2*(-270128
          +444032*y-60168*y**2-1324350*y**3+1770396*y**4+1488078*y**5-2800179*y**6
          +1460403*y**7-277490*y**8-24696*y**9-7495*y**10+1797*y**11)+r**6*(-1
          +y)**3*(-94200+49080*y+12240*y**2+295172*y**3+1316490*y**4-2269854*y**5
          +586907*y**6+887025*y**7-741512*y**8+214660*y**9-37161*y**10+3153*y**11)
          +r**10*(946656-3712896*y+5197176*y**2-3468272*y**3+7602276*y**4-16938792*y**5
          +16581537*y**6-8576166*y**7+3108967*y**8-832636*y**9+85071*y**10+8714*y**11
          -1635*y**12))-(-1+r**2+y)**4*(13*r**28*(-1+y)**8+r**26*(-1+y)**4*(
          -416+1612*y-2288*y**2+1485*y**3-464*y**4+77*y**5)+r**24*(-1+y)**2*(9025
          -52250*y+124249*y**2-157937*y**3+116049*y**4-49766*y**5+12761*y**6
          -1639*y**7+132*y**8)-r**22*(73944-572712*y+1916940*y**2-3620710*y**3
          +4254876*y**4-3249379*y**5+1642532*y**6-550925*y**7+119420*y**8-13501*y**9
          +80*y**10+155*y**11)+r**20*(119097-971904*y+3385980*y**2-6347806*y**3
          +6787365*y**4-3838681*y**5+382614*y**6+1138375*y**7-972019*y**8+390245*y**9
          -79306*y**10+9995*y**11-1075*y**12)-(-1+y)**9*(-17-85*y-255*y**2
          -744*y**3-549*y**4+567*y**5-405*y**6+435*y**7-136*y**8-286*y**9+200*y**10
          +65*y**11+10*y**12)+r**18*(-25800+49284*y+335148*y**2-3495329*y**3
          +12940800*y**4-25476086*y**5+30224972*y**6-23384380*y**7+12701368*y**8
          -5042510*y**9+1371136*y**10-226931*y**11+27032*y**12-2304*y**13)-r**2*(
          -1+y)**8*(-664-2588*y-6300*y**2-15641*y**3+376*y**4+23236*y**5-18832*y**6
          +13280*y**7-7904*y**8-3426*y**9+5388*y**10-135*y**11+10*y**13)-r**4*(
          -1+y)**7*(-1805-5995*y-11736*y**2-109686*y**3+7049*y**4+27452*y**5
          -70533*y**6+108457*y**7+57428*y**8-73114*y**9-5907*y**10+18933*y**11
          -656*y**12+113*y**13)-r**6*(-1+y)**6*(68664+91368*y+99780*y**2-606854*y**3
          -697380*y**4-204401*y**5+1840834*y**6-2004080*y**7+1166786*y**8-294190*y**9
          -45878*y**10+60878*y**11-4070*y**12+543*y**13)-r**8*(-1+y)**5*(478467
          +142635*y-38397*y**2-756188*y**3-3555685*y**4+2618272*y**5+367280*y**6
          +776498*y**7-3079749*y**8+1841725*y**9-372319*y**10+111270*y**11-12501*y**12
          +1492*y**13)-2*r**14*(-1+y)**2*(-2566280+9638840*y-12371676*y**2+3669046*y**3
          -7406856*y**4+21374713*y**5-19897636*y**6+10927172*y**7-5193534*y**8
          +1646376*y**9-517368*y**10+129666*y**11-20466*y**12+1803*y**13)-r**10*(
          -1+y)**4*(817200-447636*y-622536*y**2+1778005*y**3+3945712*y**4-12727609*y**5
          +6097180*y**6+4143886*y**7-8468280*y**8+4667258*y**9-1086236*y**10+202941*y**11
          -24560*y**12+2675*y**13)-r**12*(-1+y)**3*(481735-61363*y-1370202*y**2
          -5515178*y**3+20888997*y**4-11259875*y**5-7189006*y**6+8530922*y**7
          -6773877*y**8+3667953*y**9-1289700*y**10+273084*y**11-35355*y**12+3465*y**13)
          +r**16*(3060685-20091332*y+54935374*y**2-73025687*y**3+34051265*y**4
          +36718666*y**5-79800104*y**6+77414256*y**7-50081609*y**8+22347546*y**9
          -6881406*y**10+1612071*y**11-298365*y**12+41856*y**13-3216*y**14))))/(37324800*logy**4*r**16*(
          -1+y)**8+12441600*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+1555200*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+86400*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +1800*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*muWC**2*(518400*logy**4*r**16*(-3+2*r**2+9*r**4)*(-1+y)**8+8640*logy**3*r**12*(
          -1+y)**4*(23*r**12*(-1+y)**4+15*r**10*(52-208*y+312*y**2-187*y**3
          +34*y**4+6*y**5)+r**2*(-1+y)**4*(252+235*y**3-450*y**4+78*y**5)+5*(
          -1+y)**4*(11+30*y**3+15*y**4-48*y**5+16*y**6)+5*r**8*(189-324*y
          -378*y**2+1288*y**3-919*y**4+147*y**5+39*y**6)+5*r**6*(-408+1728*y
          -2784*y**2+2030*y**3-464*y**4-78*y**5-32*y**6+35*y**7)+15*r**4*(-1
          -44*y+162*y**2-302*y**3+368*y**4-291*y**5+141*y**6-36*y**7+3*y**8))
          -144*logy**2*r**8*(-1+y)**2*(-1+r**2+y)**2*(321*r**16*(-1+y)**6-r**14*(
          -1+y)**2*(438-1110*y+60*y**2+3425*y**3-5300*y**4+2292*y**5)-r**12*(
          -1+y)**2*(39162-152742*y+220455*y**2-137770*y**3+44940*y**4-10997*y**5
          +2682*y**6)+r**2*(-1+y)**4*(1542-378*y-378*y**2-7553*y**3+30332*y**4
          -36352*y**5+4918*y**6+15443*y**7-7982*y**8+1158*y**9)+(-1+y)**5*(189
          +189*y+189*y**2-2881*y**3+4469*y**4-1759*y**5-2059*y**6+6341*y**7
          -5464*y**8+1536*y**9)+r**10*(-94806+498714*y-1066806*y**2+1046889*y**3
          -347356*y**4-122154*y**5+77746*y**6+26836*y**7-22264*y**8+2601*y**9)
          -r**4*(-1+y)**3*(28218-35412*y+4383*y**2+81693*y**3-128087*y**4+37872*y**5
          +32147*y**6-9628*y**7-9743*y**8+3057*y**9)-r**6*(-1+y)**2*(-25734+57486*y
          -48024*y**2+44291*y**3+75946*y**4-147426*y**5+68184*y**6+8824*y**7
          -16186*y**8+3639*y**9)+5*r**8*(-18804+73794*y-95409*y**2-20062*y**3
          +169456*y**4-168654*y**5+82320*y**6-34967*y**7+16331*y**8-4347*y**9
          +342*y**10))+12*logy*r**4*(-1+y)**2*(-1+r**2+y)**3*(-27*r**22*(-1+y)**6
          +r**20*(-1+y)**2*(-221+965*y-1650*y**2+691*y**3-475*y**4+207*y**5)
          +r**18*(-23571+134466*y-315819*y**2+401559*y**3-302286*y**4+134904*y**5
          -30689*y**6+2475*y**7-199*y**8)+r**16*(195675-1099785*y+2512401*y**2
          -2941747*y**3+1791927*y**4-480054*y**5+18761*y**6-16320*y**7+15938*y**8
          -1356*y**9)+(-1+y)**7*(-171-684*y-1710*y**2-2762*y**3+850*y**4+6688*y**5
          -3546*y**6+1050*y**7-443*y**8-640*y**9+368*y**10)+r**14*(564326-2958828*y
          +6293274*y**2-6708894*y**3+4041996*y**4-1965687*y**5+1147683*y**6-482634*y**7
          +78434*y**8+3179*y**9+951*y**10)-r**8*(-1+y)**2*(514054-863806*y+309120*y**2
          +1188990*y**3-3360126*y**4+2794563*y**5-515538*y**6-520560*y**7+233080*y**8
          +32361*y**9-12262*y**10+24*y**11)-r**6*(-1+y)**3*(-134475+75945*y
          +39879*y**2-69871*y**3-515532*y**4+821025*y**5-145576*y**6-478029*y**7
          +351811*y**8-53498*y**9-2835*y**10+156*y**11)+r**4*(-1+y)**4*(15699
          +7539*y+2673*y**2-18712*y**3-58900*y**4+70028*y**5+111350*y**6-82183*y**7
          -78443*y**8+58655*y**9-11107*y**10+1101*y**11)+r**2*(-1+y)**5*(1379
          +2245*y+2598*y**2+16613*y**3-45572*y**4-10005*y**5+85148*y**6-91583*y**7
          +34177*y**8+4312*y**9-6434*y**10+1122*y**11)+r**12*(404106-1415142*y
          +1520658*y**2+3028778*y**3-8645322*y**4+7760541*y**5-3132058*y**6+608832*y**7
          -167768*y**8+122527*y**9-34872*y**10+4920*y**11)+r**10*(876150-3203244*y
          +3787398*y**2+646628*y**3-4253394*y**4+2320047*y**5-745251*y**6+1332627*y**7
          -973093*y**8+198889*y**9+33033*y**10-23315*y**11+3525*y**12))+(-1
          +r**2+y)**4*(8*r**28*(-1+y)**8+r**26*(-1+y)**4*(-250+968*y-1372*y**2
          +891*y**3-280*y**4+46*y**5)+r**24*(-1+y)**2*(2750-15856*y+37304*y**2
          -47728*y**3+36822*y**4-17497*y**5+5401*y**6-959*y**7+75*y**8)-r**22*(47460
          -366672*y+1227348*y**2-2333444*y**3+2799876*y**4-2243282*y**5+1241416*y**6
          -478597*y**7+122740*y**8-16760*y**9+208*y**10+67*y**11)+r**20*(28812
          -336516*y+1501698*y**2-3416318*y**3+4557696*y**4-4000739*y**5+2686629*y**6
          -1530718*y**7+651568*y**8-148571*y**9+4627*y**10+3622*y**11-350*y**12)
          -2*(-1+y)**9*(-5-25*y-75*y**2-240*y**3-45*y**4+495*y**5-621*y**6
          -24*y**7+410*y**8-280*y**9+80*y**10+26*y**11+4*y**12)+r**18*(2065962
          -14400864*y+42563772*y**2-69032569*y**3+65495484*y**4-34648768*y**5
          +7191808*y**6+1557916*y**7-565942*y**8-431014*y**9+240116*y**10-43339*y**11
          +5872*y**12-234*y**13)-r**2*(-1+y)**8*(-374-1456*y-3540*y**2-10069*y**3
          +5756*y**4+22892*y**5-34568*y**6+12406*y**7+7322*y**8-9906*y**9+4932*y**10
          -21*y**11+24*y**12+2*y**13)-r**4*(-1+y)**7*(860+1984*y+3702*y**2
          -73560*y**3+7438*y**4-7547*y**5-49560*y**6+96059*y**7+35350*y**8-68423*y**9
          +16422*y**10+7341*y**11-76*y**12+10*y**13)+r**6*(-1+y)**6*(-23844-28296*y
          -25272*y**2+225940*y**3+439584*y**4+110686*y**5-1052600*y**6+1148665*y**7
          -640966*y**8+116861*y**9+19468*y**10-26509*y**11+262*y**12+21*y**13)
          +r**8*(-1+y)**5*(-269970-5598*y+79056*y**2+1459948*y**3+1089824*y**4
          -1648679*y**5-2980414*y**6+4634228*y**7-1367496*y**8-309794*y**9+84974*y**10
          -26988*y**11-774*y**12+283*y**13)+2*r**14*(-1+y)**2*(1283140-4654024*y
          +5606952*y**2+8259544*y**3-26734560*y**4+27243922*y**5-14853676*y**6
          +4977512*y**7-1161594*y**8+443295*y**9-150492*y**10+35940*y**11-3654*y**12
          +795*y**13)+2*r**12*(-1+y)**3*(-961288+1637284*y+426774*y**2+3358268*y**3
          -16519374*y**4+16786373*y**5-4449944*y**6-532940*y**7-249186*y**8+668379*y**9
          -299790*y**10+51240*y**11-4524*y**12+828*y**13)+r**10*(-1+y)**4*(-2487462
          +2429208*y+685476*y**2+1605241*y**3-4164644*y**4+3191210*y**5-2253776*y**6
          +2979280*y**7-979806*y**8-2716*y**9-168428*y**10+31203*y**11-4736*y**12
          +950*y**13)+2*r**16*(-75683+922912*y-3477140*y**2+7533703*y**3-8435353*y**4
          -297575*y**5+12813937*y**6-15024378*y**7+7237951*y**8-841458*y**9-532602*y**10
          +188631*y**11-13227*y**12-39*y**13+321*y**14))))/(13996800*logy**4*r**16*(
          -1+y)**8+4665600*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+583200*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+32400*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +675*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((muG*(518400*logy**4*r**16*(21+28*r**2+9*r**4)*(-1+y)**8+8640*logy**3*r**10*(
          -1+y)**5*(-290*r**14*(-1+y)**3+24*(-1+y)**4*(1+y+y**2-14*y**3+6*y**4)
          -9*r**12*(104-312*y+312*y**2-199*y**3+45*y**4)+r**10*(-4434+11142*y
          -7902*y**2+2119*y**3-525*y**4+300*y**5)+5*r**4*(-1+y)**2*(264-264*y
          -131*y**3+11*y**4+6*y**5+6*y**6)+5*r**8*(-408-120*y+2136*y**2-2200*y**3
          +864*y**4-255*y**5+73*y**6)+r**2*(-1+y)**3*(14-1395*y**3+1140*y**4
          -594*y**5+160*y**6)-15*r**6*(-386+1494*y-1998*y**2+1146*y**3-370*y**4
          +183*y**5-81*y**6+12*y**7))-144*logy**2*r**6*(-1+y)**3*(-1+r**2+y)**2*(
          -1068*r**18*(-1+y)**5+r**16*(-1+y)**2*(-14784+42216*y-37944*y**2+7511*y**3
          +3651*y**4)+r**14*(-1+y)**2*(-51036+128340*y-101700*y**2+6695*y**3
          -6805*y**4+5406*y**5)-240*(-1+y)**5*(-1-2*y-3*y**2+9*y**3+4*y**4
          +5*y**5-9*y**6+2*y**7)+r**12*(269112-1151976*y+1821696*y**2-1484337*y**3
          +775465*y**4-265427*y**5+25231*y**6+11404*y**7-3168*y**8)+5*r**10*(140820
          -590148*y+923976*y**2-722945*y**3+365685*y**4-167337*y**5+59551*y**6
          -9378*y**7-572*y**8+348*y**9)+r**4*(-1+y)**3*(-7896+2304*y+864*y**2
          +44719*y**3-93166*y**4+26096*y**5+34746*y**6-6689*y**7-3144*y**8+366*y**9)
          +r**2*(-1+y)**4*(1248+768*y+288*y**2-18907*y**3+12983*y**4-943*y**5
          -6463*y**6+17492*y**7-12538*y**8+3072*y**9)-r**6*(-1+y)**2*(-23244
          +11556*y+3276*y**2-290529*y**3+724291*y**4-634356*y**5+270294*y**6
          -60951*y**7-5071*y**8+4134*y**9)+r**8*(312192-1117800*y+1429920*y**2
          -814615*y**3+279095*y**4-149659*y**5+157875*y**6-188795*y**7+121615*y**8
          -33995*y**9+4167*y**10))+12*logy*r**2*(-1+y)**3*(-1+r**2+y)**3*(162*r**24*(
          -1+y)**5-r**22*(-1+y)**2*(2702-8592*y+9564*y**2-3573*y**3+1509*y**4)
          -r**20*(1698+8550*y-54432*y**2+92298*y**3-78327*y**4+51105*y**5-27447*y**6
          +3755*y**7)+r**18*(483210-2073180*y+3341082*y**2-2265605*y**3+230020*y**4
          +424405*y**5-150705*y**6-5012*y**7+585*y**8)-120*(-1+y)**6*(1+4*y
          +10*y**2+9*y**3+5*y**4-4*y**5-2*y**6-3*y**7-2*y**8+2*y**9)+r**16*(18428
          +25964*y+41000*y**2+90628*y**3+176050*y**4-910838*y**5+634711*y**6
          +37175*y**7-68513*y**8+1395*y**9)+r**14*(-5671380+21961032*y-30075780*y**2
          +21219010*y**3-10402208*y**4+2906686*y**5+1026823*y**6-1091790*y**7
          +320470*y**8+2238*y**9-9501*y**10)+r**2*(-1+y)**5*(-1914-5382*y-10044*y**2
          +5405*y**3+9429*y**4+13146*y**5-17124*y**6+5249*y**7+15175*y**8-13574*y**9
          +1298*y**10+736*y**11)+r**4*(-1+y)**4*(3502+6626*y+11532*y**2-20210*y**3
          -5437*y**4-13473*y**5+50912*y**6-50182*y**7+33085*y**8-21063*y**9+946*y**10
          +1362*y**11)+r**6*(-1+y)**3*(69918+29838*y+9090*y**2-591943*y**3+625184*y**4
          +4100*y**5-402293*y**6+657075*y**7-660392*y**8+253656*y**9-34703*y**10
          +2070*y**11)+r**8*(-1+y)**2*(-74850+19830*y-41742*y**2-394514*y**3
          +216474*y**4-149958*y**5+859335*y**6-25183*y**7-766286*y**8+396326*y**9
          -86967*y**10+6735*y**11)-r**12*(3776652-12603132*y+14201784*y**2-10682392*y**3
          +13529432*y**4-14454688*y**5+9822589*y**6-4787529*y**7+1167022*y**8
          +89898*y**9-75359*y**10+8523*y**11)+r**10*(-931972+2217080*y-1445692*y**2
          -4513642*y**3+18345098*y**4-27831358*y**5+20009073*y**6-6796628*y**7
          +927267*y**8+92702*y**9-44945*y**10-31978*y**11+4995*y**12))-(-1+y)*(
          -1+r**2+y)**4*(5*r**28*(-1+y)**7+r**26*(-1+y)**4*(88-244*y+204*y**2
          -83*y**3+25*y**4)+r**24*(-1+y)**2*(9385-45313*y+86712*y**2-80405*y**3
          +35808*y**4-7124*y**5-133*y**6+30*y**7)+r**22*(-31008+213552*y-616452*y**2
          +959654*y**3-836110*y**4+360115*y**5-22417*y**6-40260*y**7+13992*y**8
          +99*y**9+35*y**10)+r**20*(30195-70461*y-220857*y**2+1018189*y**3-1956176*y**4
          +2828933*y**5-3146027*y**6+2215504*y**7-811017*y**8+109858*y**9-3566*y**10
          +625*y**11)+(-1+y)**8*(91+455*y+1365*y**2+1636*y**3+707*y**4-1761*y**5
          +1715*y**6+431*y**7-3956*y**8+1158*y**9+380*y**10+145*y**11+34*y**12)
          +r**18*(-4840344+28104012*y-66375816*y**2+78177287*y**3-38727109*y**4
          -11931731*y**5+28646573*y**6-18190979*y**7+6331233*y**8-1366481*y**9
          +199115*y**10-22820*y**11+3060*y**12)+r**2*(-1+y)**7*(-2200-7724*y
          -17340*y**2-21425*y**3-28020*y**4-25792*y**5+50524*y**6+4416*y**7-52300*y**8
          +27130*y**9+2672*y**10+345*y**11+104*y**12+10*y**13)+r**4*(-1+y)**6*(
          -57335-141313*y-236856*y**2+82366*y**3+56535*y**4+63904*y**5-136281*y**6
          +114879*y**7+179854*y**8-194370*y**9+46681*y**10+21099*y**11-918*y**12
          +155*y**13)+r**6*(-1+y)**5*(-239520-322416*y-286524*y**2+704510*y**3
          -295164*y**4-457483*y**5+595990*y**6-650738*y**7+1165210*y**8-738556*y**9
          +145998*y**10+73516*y**11-7798*y**12+975*y**13)+r**8*(-1+y)**4*(-114861
          -152421*y+116283*y**2-2344768*y**3+4472611*y**4-1092778*y**5-4250724*y**6
          +6645682*y**7-6430617*y**8+3054749*y**9-507091*y**10+179970*y**11-28265*y**12
          +3430*y**13)+r**16*(11542057-67432555*y+157299723*y**2-182853180*y**3
          +84383801*y**4+55094783*y**5-115766397*y**6+83255323*y**7-30639450*y**8
          +5975704*y**9-1163070*y**10+359217*y**11-63456*y**12+7500*y**13)+r**10*(
          -1+y)**3*(-2065704+1395204*y+614760*y**2-7283887*y**3+13829756*y**4
          -8818547*y**5+4371396*y**6+4339562*y**7-14745168*y**8+10134094*y**9
          -2565044*y**10+452685*y**11-62732*y**12+7625*y**13)+r**12*(-1+y)**2*(3624073
          -7940125*y+5003082*y**2+17289066*y**3-71196925*y**4+92696459*y**5-43046430*y**6
          +5614930*y**7-8222871*y**8+9049255*y**9-3638952*y**10+730320*y**11-93177*y**12
          +11295*y**13)+2*r**14*(8798720-43965952*y+85121660*y**2-101113230*y**3
          +129972178*y**4-177659727*y**5+168414167*y**6-97434412*y**7+35047978*y**8
          -9260428*y**9+3154402*y**10-1394730*y**11+366552*y**12-52833*y**13+5655*y**14))))/(37324800*logy**4*r**16*(
          -1+y)**8+12441600*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+1555200*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+86400*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +1800*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((rhoLS*(-518400*logy**4*r**16*(27+20*r**2+9*r**4)*(-1+y)**8+8640*logy**3*r**12*(
          -1+y)**4*(292*r**12*(-1+y)**4-r**2*(-1+y)**4*(-2448+2215*y**3-540*y**4
          +78*y**5)+3*r**10*(-352+1408*y-2112*y**2+1753*y**3-712*y**4+105*y**5)
          -5*r**8*(648-2160*y+2376*y**2-1085*y**3+158*y**4-87*y**5+66*y**6)
          -(-1+y)**4*(64-1155*y**3+1290*y**4-474*y**5+80*y**6)-5*r**6*(528
          -1152*y-192*y**2+1892*y**3-1376*y**4+225*y**5-32*y**6+53*y**7)+15*r**4*(284
          -1568*y+3216*y**2-3180*y**3+1620*y**4-519*y**5+226*y**6-85*y**7+6*y**8))
          -144*logy**2*r**8*(-1+y)**2*(-1+r**2+y)**2*(1074*r**16*(-1+y)**6-r**14*(
          -1+y)**2*(15492-59820*y+84360*y**2-47855*y**3+3020*y**4+4413*y**5)
          -r**12*(-1+y)**2*(40128-136788*y+168930*y**2-66395*y**3+14520*y**4
          -13633*y**5+4698*y**6)-r**2*(-1+y)**4*(7572+252*y+252*y**2-63713*y**3
          +75242*y**4-26272*y**5+2698*y**6+12623*y**7-9512*y**8+1158*y**9)-r**6*(
          -1+y)**2*(-335076+920364*y-793656*y**2+597319*y**3-864676*y**4+815121*y**5
          -390384*y**6+113621*y**7-23744*y**8+1311*y**9)-(-1+y)**5*(-126-126*y
          -126*y**2+899*y**3-1111*y**4-949*y**5-3949*y**6+12326*y**7-8074*y**8
          +1536*y**9)+r**10*(228276-1175604*y+2367396*y**2-2567409*y**3+1670386*y**4
          -604896*y**5+60674*y**6+29039*y**7-11816*y**8+2754*y**9)+r**4*(-1+y)**3*(
          -91392+95268*y+6138*y**2-143907*y**3+419053*y**4-515148*y**5+292652*y**6
          -75583*y**7+2347*y**8+3372*y**9)-5*r**8*(-123420+648876*y-1367190*y**2
          +1570421*y**3-1157342*y**4+632754*y**5-280944*y**6+91087*y**7-12724*y**8
          -1986*y**9+468*y**10))-12*logy*r**4*(-1+y)**2*(-1+r**2+y)**3*(180*r**22*(
          -1+y)**6-r**20*(-1+y)**2*(-2812+11788*y-19032*y**2+12497*y**3-4532*y**4
          +1125*y**5)+r**18*(-5376+49056*y-167472*y**2+273642*y**3-242583*y**4
          +138540*y**5-69650*y**6+24090*y**7-1927*y**8)+r**16*(-423120+2199840*y
          -4544832*y**2+4483061*y**3-1638999*y**4-608907*y**5+715088*y**6-162165*y**7
          -12613*y**8+1767*y**9)+r**14*(-101224+574752*y-1642584*y**2+2291364*y**3
          -2748426*y**4+3530856*y**5-2717097*y**6+746364*y**7+90356*y**8-50464*y**9
          -1497*y**10)+r**12*(5126472-25009128*y+47212200*y**2-48960514*y**3
          +32070798*y**4-12485778*y**5+913091*y**6+1990395*y**7-1258436*y**8+265732*y**9
          +36291*y**10-11523*y**11)+(-1+y)**6*(-336-1008*y-2016*y**2+257*y**3
          +5973*y**4+11154*y**5-10880*y**6+2061*y**7+53*y**8-148*y**9-678*y**10
          +368*y**11)+r**2*(-1+y)**5*(-6208-11408*y-15600*y**2+20186*y**3+42583*y**4
          +36507*y**5-64804*y**6+4030*y**7+5239*y**8-113*y**9-1934*y**10+1122*y**11)
          +r**4*(-1+y)**4*(-91716-71076*y-53964*y**2+430727*y**3-138820*y**4
          -73702*y**5-242317*y**6+555779*y**7-466442*y**8+164840*y**9-21937*y**10
          +2028*y**11)+r**8*(-1+y)**2*(1403936-2517584*y+947568*y**2+809898*y**3
          -5003604*y**4+7912518*y**5-5926959*y**6+2437947*y**7-524938*y**8+90144*y**9
          -29099*y**10+4773*y**11)+r**6*(-1+y)**3*(-384180+72780*y+122868*y**2
          -658760*y**3+1569882*y**4-1677078*y**5+726823*y**6+681237*y**7-934420*y**8
          +378608*y**9-62577*y**10+5217*y**11)+r**10*(3374784-15068016*y+25755408*y**2
          -28525984*y**3+34695516*y**4-41887728*y**5+36591765*y**6-21104166*y**7
          +7325699*y**8-1104596*y**9-117981*y**10+72106*y**11-6807*y**12))+(
          -1+r**2+y)**4*(19*r**28*(-1+y)**8+r**26*(-1+y)**4*(-296+1108*y-1472*y**2
          +927*y**3-368*y**4+107*y**5)+r**24*(-1+y)**2*(-9605+56578*y-138653*y**2
          +176869*y**3-121677*y**4+42562*y**5-4705*y**6-913*y**7+168*y**8)+r**22*(50136
          -397464*y+1362924*y**2-2657702*y**3+3204348*y**4-2406467*y**5+1060180*y**6
          -214201*y**7-14900*y**8+12235*y**9+304*y**10-113*y**11)+r**20*(-132729
          +929424*y-2746644*y**2+4855022*y**3-5728461*y**4+3910145*y**5-3546*y**6
          -2588891*y**7+2140043*y**8-711349*y**9+79694*y**10+497*y**11-325*y**12)
          +(-1+y)**9*(107+535*y+1605*y**2+2544*y**3+1719*y**4-1917*y**5+87*y**6
          -897*y**7-1064*y**8+826*y**9+40*y**10+13*y**11+2*y**12)+r**2*(-1+y)**8*(2992
          +11540*y+27780*y**2+27371*y**3-5080*y**4-57100*y**5+22912*y**6-9200*y**7
          -4888*y**8+10470*y**9-1572*y**10-27*y**11+2*y**13)+r**4*(-1+y)**7*(31475
          +86917*y+157872*y**2+74946*y**3-39647*y**4-98996*y**5-3993*y**6-6079*y**7
          +17416*y**8+36142*y**9-35319*y**10+13221*y**11-1228*y**12+73*y**13)
          +r**6*(-1+y)**6*(199608+355320*y+443556*y**2-151702*y**3+173916*y**4
          +285743*y**5-701326*y**6-43252*y**7+438490*y**8-88466*y**9-120886*y**10
          +67426*y**11-9454*y**12+627*y**13)+r**18*(4809504-33000084*y+95672052*y**2
          -150124307*y**3+130599696*y**4-46493546*y**5-23844316*y**6+38610452*y**7
          -22008416*y**8+6910294*y**9-1281968*y**10+160255*y**11-14584*y**12+1368*y**13)
          +r**8*(-1+y)**5*(103503+449559*y+254799*y**2+3775124*y**3-2765489*y**4
          +907556*y**5-3561272*y**6+6289498*y**7-5296353*y**8+2341889*y**9-683699*y**10
          +184398*y**11-32937*y**12+2624*y**13)+2*r**14*(-1+y)**2*(-7923400+31899112*y
          -45984300*y**2+54329846*y**3-84072360*y**4+101381081*y**5-76731620*y**6
          +36678748*y**7-11477814*y**8+3549660*y**9-1351176*y**10+306618*y**11
          -42378*y**12+4983*y**13)+r**10*(-1+y)**4*(-3730344+3850092*y+784008*y**2
          +1213913*y**3+3803072*y**4-12087953*y**5+8798588*y**6+9762398*y**7-17012208*y**8
          +8980138*y**9-2366188*y**10+414585*y**11-68176*y**12+6475*y**13)+r**12*(
          -1+y)**3*(3542183-9318131*y+8546358*y**2-549178*y**3-28626699*y**4
          +46631165*y**5-30800486*y**6+21283522*y**7-18539421*y**8+10824609*y**9
          -3669228*y**10+660612*y**11-92595*y**12+10089*y**13)+r**16*(-10695617
          +73017556*y-207171686*y**2+316275931*y**3-252030637*y**4+20585830*y**5
          +184502032*y**6-213351000*y**7+121750981*y**8-39993042*y**9+8517462*y**10
          -1741203*y**11+383121*y**12-55512*y**13+5784*y**14))))/(37324800*logy**4*r**16*(
          -1+y)**8+12441600*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+1555200*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+86400*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +1800*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((rhoD*(-518400*logy**4*r**12*(12+28*r**2+29*r**4+20*r**6+9*r**8)*(-1
          +y)**9-8640*logy**3*r**8*(-1+y)**4*(58*r**16*(-1+y)**5+20*(-1+y)**6*(
          -2-2*y-2*y**2+19*y**3-14*y**4+4*y**5)+4*r**2*(-1+y)**5*(-139+225*y**3
          -55*y**4+14*y**5)+r**14*(-996+4980*y-9960*y**2+9195*y**3-4395*y**4
          +771*y**5+45*y**6)+r**6*(-1+y)**3*(-3588+13896*y-13668*y**2+3635*y**3
          -1630*y**4+2333*y**5-636*y**6+78*y**7)+r**4*(-1+y)**4*(4366-7246*y
          +1440*y**2+2015*y**3-1415*y**4+1494*y**5-554*y**6+80*y**7)+r**12*(
          -1166+3670*y-1940*y**2-6595*y**3+8955*y**4-3969*y**5+305*y**6+180*y**7)
          +5*r**10*(-828+3180*y-3960*y**2+796*y**3+1628*y**4-1009*y**5+133*y**6
          -57*y**7+45*y**8)+5*r**8*(-422+718*y+2044*y**2-6232*y**3+5784*y**4
          -2025*y**5+201*y**6-163*y**7+95*y**8))+144*logy**2*r**4*(-1+y)**2*(436*r**24*(
          -1+y)**7-5*r**22*(-1+y)**2*(-12+60*y-120*y**2-355*y**3+1859*y**4
          -2011*y**5+683*y**6)+20*r**2*(-1+y)**9*(15+30*y+45*y**2-346*y**3
          +661*y**4+488*y**5-905*y**6+212*y**7)+4*(-1+y)**10*(-29-87*y-174*y**2
          +615*y**4+1059*y**5-1468*y**6+384*y**7)-r**20*(-1+y)**2*(-76044+369780*y
          -713460*y**2+676695*y**3-377645*y**4+145339*y**5-51165*y**6+11220*y**7)
          +5*r**6*(-1+y)**7*(-25676+20016*y+10008*y**2+34325*y**3-46116*y**4
          -1482*y**5+20928*y**6-8457*y**7-2232*y**8+846*y**9)+r**4*(-1+y)**8*(444
          +7644*y+11244*y**2+55089*y**3-93361*y**4+25321*y**5+20361*y**6-16124*y**7
          -2154*y**8+1536*y**9)+5*r**8*(-1+y)**5*(-90612+338400*y-378216*y**2
          +55016*y**3+165928*y**4-122635*y**5+44594*y**6-15732*y**7+8124*y**8
          -3385*y**9+138*y**10)-5*r**18*(9692-103700*y+436596*y**2-1034476*y**3
          +1454812*y**4-1243625*y**5+664031*y**6-227648*y**7+52396*y**8-9855*y**9
          +1457*y**10)-5*r**12*(-1+y)**3*(-158952+711768*y-1094292*y**2+704014*y**3
          -348400*y**4+373141*y**5-308036*y**6+119834*y**7-15332*y**8-3413*y**9
          +1528*y**10)+r**14*(-1+y)**2*(501192-1760760*y+2090520*y**2-1555990*y**3
          +1620610*y**4-1593479*y**5+1138595*y**6-577010*y**7+198250*y**8-43925*y**9
          +2997*y**10)-r**10*(-1+y)**4*(421128-617544*y-956016*y**2+2243512*y**3
          -2033000*y**4+1671257*y**5-1219271*y**6+530856*y**7-97292*y**8-11125*y**9
          +8095*y**10)+5*r**16*(21204-106452*y+211320*y**2-245240*y**3+347412*y**4
          -523495*y**5+440321*y**6-143190*y**7-30820*y**8+39363*y**9-11349*y**10
          +926*y**11))+12*logy*(-1+y)**2*(-1+r**2+y)**2*(130*r**28*(-1+y)**7
          +r**26*(-1+y)**2*(2008-9780*y+18780*y**2-21129*y**3+12269*y**4-4249*y**5
          +813*y**6)-4*(-1+y)**10*(4+20*y+60*y**2+93*y**3+18*y**4-174*y**5
          +160*y**6+25*y**7-198*y**8+92*y**9)-4*r**2*(-1+y)**9*(19+68*y+150*y**2
          +139*y**3-1626*y**4-3464*y**5+3862*y**6-65*y**7-1469*y**8+686*y**9)
          +r**24*(-60812+411464*y-1183134*y**2+1917741*y**3-1940827*y**4+1281004*y**5
          -557202*y**6+160831*y**7-30449*y**8+3624*y**9)+r**22*(432228-2927216*y
          +8404556*y**2-13330953*y**3+12705627*y**4-7477148*y**5+2772324*y**6
          -773723*y**7+236061*y**8-59064*y**9+5148*y**10)-r**20*(-660906+3576386*y
          -7441232*y**2+5865537*y**3+477417*y**4-2710654*y**5+78996*y**6+1542347*y**7
          -946267*y**8+187868*y**9-10480*y**10+4188*y**11)-2*r**14*(-1+y)**2*(
          -2634668+6734744*y-2046616*y**2-6140737*y**3+7097285*y**4-5970181*y**5
          +4830099*y**6-2868276*y**7+770242*y**8+246645*y**9-156371*y**10+15137*y**11
          +297*y**12)-r**4*(-1+y)**7*(9926+17188*y+23130*y**2-75521*y**3-65804*y**4
          -35149*y**5+397794*y**6-381973*y**7+105746*y**8+17629*y**9-13952*y**10
          +2218*y**11+368*y**12)+2*r**12*(-1+y)**3*(3495927-13228888*y+16753972*y**2
          -6338925*y**3-2354153*y**4+3336069*y**5-1160892*y**6-722966*y**7+683865*y**8
          -227197*y**9+58764*y**10-8925*y**11+649*y**12)-r**6*(-1+y)**6*(49084
          +41880*y+33728*y**2-139663*y**3-639121*y**4+378031*y**5+1327777*y**6
          -1499623*y**7+424203*y**8+74881*y**9-50185*y**10+3918*y**11+1490*y**12)
          -r**10*(-1+y)**4*(2291040-5391956*y+2705508*y**2-1417851*y**3+5290785*y**4
          -4846866*y**5-1879246*y**6+5348134*y**7-2337454*y**8-110550*y**9+206126*y**10
          -27783*y**11+1713*y**12)-r**8*(-1+y)**5*(54708-90292*y+1142*y**2-1455053*y**3
          +3239484*y**4-2697954*y**5+761496*y**6+559206*y**7-374892*y**8-56614*y**9
          +66746*y**10-13509*y**11+2532*y**12)-2*r**18*(502114-3705366*y+11357456*y**2
          -21513639*y**3+24408037*y**4-16781712*y**5+9079058*y**6-5619007*y**7
          +3211649*y**8-1324772*y**9+371788*y**10-68432*y**11+8026*y**12)-2*r**16*(
          -1983988+11094384*y-24928670*y**2+29873071*y**3-24373435*y**4+18282222*y**5
          -13111010*y**6+8562341*y**7-5257927*y**8+2425150*y**9-741074*y**10+202306*y**11
          -49296*y**12+5926*y**13))-(-1+r**2+y)**3*(51*r**30*(-1+y)**9+r**28*(
          -1+y)**4*(1511-7402*y+14345*y**2-14101*y**3+7550*y**4-2263*y**5+352*y**6)
          +r**26*(-1+y)**2*(-18121+124027*y-360327*y**2+587211*y**3-594966*y**4
          +393402*y**5-175405*y**6+51717*y**7-9221*y**8+851*y**9)-(-1+y)**11*(839
          +4003*y+11529*y**2+15472*y**3+6439*y**4-14885*y**5+19215*y**6-5173*y**7
          -25172*y**8+14286*y**9-964*y**10-23*y**11+34*y**12)+r**24*(158557-1399566*y
          +5453535*y**2-12349111*y**3+18123490*y**4-18269689*y**5+13096993*y**6
          -6799413*y**7+2554614*y**8-673753*y**9+115648*y**10-10692*y**11+347*y**12)
          -r**2*(-1+y)**10*(11435+42503*y+99101*y**2+55159*y**3-154285*y**4
          -322969*y**5+499671*y**6-132545*y**7-249376*y**8+156020*y**9-14176*y**10
          -394*y**11+254*y**12+2*y**13)-r**22*(268747-2700243*y+11820768*y**2
          -29151072*y**3+45207561*y**4-47077237*y**5+34563343*y**6-18538417*y**7
          +7290910*y**8-1949856*y**9+254705*y**10+29305*y**11-17026*y**12+2352*y**13)
          +r**20*(-3441601+26875434*y-90365745*y**2+172597083*y**3-206203230*y**4
          +159647549*y**5-81663805*y**6+31710122*y**7-15962551*y**8+11003528*y**9
          -5686733*y**10+1825171*y**11-383922*y**12+58473*y**13-4973*y**14)-r**4*(
          -1+y)**8*(79571+71098*y+44583*y**2-675425*y**3+234278*y**4+42801*y**5
          +2318065*y**6-3174438*y**7+1499829*y**8-520736*y**9+135063*y**10-913*y**11
          +6290*y**12+701*y**13+33*y**14)-r**6*(-1+y)**7*(978671+238994*y-56869*y**2
          -3651512*y**3-3019583*y**4+6210010*y**5+15307666*y**6-24719760*y**7
          +9463771*y**8+439194*y**9-880571*y**10+116320*y**11+32949*y**12+1426*y**13
          +94*y**14)+r**8*(-1+y)**6*(-3571217+2852832*y+947292*y**2+19170479*y**3
          -35350399*y**4+15932948*y**5-18892971*y**6+28710632*y**7-13051805*y**8
          +755002*y**9+870264*y**10-159271*y**11-44139*y**12-5934*y**13+287*y**14)
          +r**10*(-1+y)**5*(-24631213+59984512*y-36151860*y**2+31393590*y**3
          -95169834*y**4+80751452*y**5-5787713*y**6-26948404*y**7+12800607*y**8
          +956048*y**9-528814*y**10-299794*y**11+59744*y**12-22572*y**13+2251*y**14)
          +r**16*(-1+y)**2*(1769325-9986676*y+22088166*y**2-23022739*y**3-39497831*y**4
          +106598572*y**5-72036414*y**6+4878476*y**7+13624411*y**8-7950306*y**9
          +2449138*y**10-470185*y**11+64383*y**12-1302*y**13+2982*y**14)+r**12*(
          -1+y)**4*(5162157-55686222*y+132764859*y**2-74617407*y**3-94369016*y**4
          +143667843*y**5-39891700*y**6-53919606*y**7+43985861*y**8-11590480*y**9
          +3498595*y**10-1484123*y**11+304542*y**12-47349*y**13+5646*y**14)+r**14*(
          -1+y)**3*(27960561-117238278*y+176662791*y**2-101910772*y**3-50156051*y**4
          +143394094*y**5-87596659*y**6-17759320*y**7+41744939*y**8-22830098*y**9
          +8921225*y**10-2454148*y**11+411039*y**12-47862*y**13+6939*y**14)+r**18*(2649031
          -25546323*y+105284406*y**2-263827760*y**3+436395590*y**4-479374300*y**5
          +347184450*y**6-169983542*y**7+69699341*y**8-37689393*y**9+22962320*y**10
          -10029102*y**11+2670886*y**12-449216*y**13+56648*y**14-3036*y**15))))/(37324800*logy**4*r**16*(
          -1+y)**9+12441600*logy**3*r**12*(-1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+1555200*logy**2*r**8*(-1+y)**5*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+86400*logy*r**4*(
          -1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +1800*(-1+y)*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1
          +y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y
          -y**2+y**3))**4))
      resNP += ((api*muWC**3*(518400*logy**4*r**12*(12+28*r**2+29*r**4
          +20*r**6+9*r**8)*(-1+y)**9+8640*logy**3*r**8*(-1+y)**4*(58*r**16*(-1+y)**5
          +20*(-1+y)**6*(-2-2*y-2*y**2+19*y**3-14*y**4+4*y**5)+4*r**2*(-1
          +y)**5*(-139+225*y**3-55*y**4+14*y**5)+r**14*(-996+4980*y-9960*y**2
          +9195*y**3-4395*y**4+771*y**5+45*y**6)+r**6*(-1+y)**3*(-3588+13896*y
          -13668*y**2+3635*y**3-1630*y**4+2333*y**5-636*y**6+78*y**7)+r**4*(
          -1+y)**4*(4366-7246*y+1440*y**2+2015*y**3-1415*y**4+1494*y**5-554*y**6
          +80*y**7)+r**12*(-1166+3670*y-1940*y**2-6595*y**3+8955*y**4-3969*y**5
          +305*y**6+180*y**7)+5*r**10*(-828+3180*y-3960*y**2+796*y**3+1628*y**4
          -1009*y**5+133*y**6-57*y**7+45*y**8)+5*r**8*(-422+718*y+2044*y**2
          -6232*y**3+5784*y**4-2025*y**5+201*y**6-163*y**7+95*y**8))-144*logy**2*r**4*(
          -1+y)**2*(436*r**24*(-1+y)**7-5*r**22*(-1+y)**2*(-12+60*y-120*y**2
          -355*y**3+1859*y**4-2011*y**5+683*y**6)+20*r**2*(-1+y)**9*(15+30*y
          +45*y**2-346*y**3+661*y**4+488*y**5-905*y**6+212*y**7)+4*(-1+y)**10*(
          -29-87*y-174*y**2+615*y**4+1059*y**5-1468*y**6+384*y**7)-r**20*(
          -1+y)**2*(-76044+369780*y-713460*y**2+676695*y**3-377645*y**4+145339*y**5
          -51165*y**6+11220*y**7)+5*r**6*(-1+y)**7*(-25676+20016*y+10008*y**2
          +34325*y**3-46116*y**4-1482*y**5+20928*y**6-8457*y**7-2232*y**8+846*y**9)
          +r**4*(-1+y)**8*(444+7644*y+11244*y**2+55089*y**3-93361*y**4+25321*y**5
          +20361*y**6-16124*y**7-2154*y**8+1536*y**9)+5*r**8*(-1+y)**5*(-90612
          +338400*y-378216*y**2+55016*y**3+165928*y**4-122635*y**5+44594*y**6
          -15732*y**7+8124*y**8-3385*y**9+138*y**10)-5*r**18*(9692-103700*y
          +436596*y**2-1034476*y**3+1454812*y**4-1243625*y**5+664031*y**6-227648*y**7
          +52396*y**8-9855*y**9+1457*y**10)-5*r**12*(-1+y)**3*(-158952+711768*y
          -1094292*y**2+704014*y**3-348400*y**4+373141*y**5-308036*y**6+119834*y**7
          -15332*y**8-3413*y**9+1528*y**10)+r**14*(-1+y)**2*(501192-1760760*y
          +2090520*y**2-1555990*y**3+1620610*y**4-1593479*y**5+1138595*y**6-577010*y**7
          +198250*y**8-43925*y**9+2997*y**10)-r**10*(-1+y)**4*(421128-617544*y
          -956016*y**2+2243512*y**3-2033000*y**4+1671257*y**5-1219271*y**6+530856*y**7
          -97292*y**8-11125*y**9+8095*y**10)+5*r**16*(21204-106452*y+211320*y**2
          -245240*y**3+347412*y**4-523495*y**5+440321*y**6-143190*y**7-30820*y**8
          +39363*y**9-11349*y**10+926*y**11))-12*logy*(-1+y)**2*(-1+r**2+y)**2*(130*r**28*(
          -1+y)**7+r**26*(-1+y)**2*(2008-9780*y+18780*y**2-21129*y**3+12269*y**4
          -4249*y**5+813*y**6)-4*(-1+y)**10*(4+20*y+60*y**2+93*y**3+18*y**4
          -174*y**5+160*y**6+25*y**7-198*y**8+92*y**9)-4*r**2*(-1+y)**9*(19
          +68*y+150*y**2+139*y**3-1626*y**4-3464*y**5+3862*y**6-65*y**7-1469*y**8
          +686*y**9)+r**24*(-60812+411464*y-1183134*y**2+1917741*y**3-1940827*y**4
          +1281004*y**5-557202*y**6+160831*y**7-30449*y**8+3624*y**9)+r**22*(432228
          -2927216*y+8404556*y**2-13330953*y**3+12705627*y**4-7477148*y**5+2772324*y**6
          -773723*y**7+236061*y**8-59064*y**9+5148*y**10)-r**20*(-660906+3576386*y
          -7441232*y**2+5865537*y**3+477417*y**4-2710654*y**5+78996*y**6+1542347*y**7
          -946267*y**8+187868*y**9-10480*y**10+4188*y**11)-2*r**14*(-1+y)**2*(
          -2634668+6734744*y-2046616*y**2-6140737*y**3+7097285*y**4-5970181*y**5
          +4830099*y**6-2868276*y**7+770242*y**8+246645*y**9-156371*y**10+15137*y**11
          +297*y**12)-r**4*(-1+y)**7*(9926+17188*y+23130*y**2-75521*y**3-65804*y**4
          -35149*y**5+397794*y**6-381973*y**7+105746*y**8+17629*y**9-13952*y**10
          +2218*y**11+368*y**12)+2*r**12*(-1+y)**3*(3495927-13228888*y+16753972*y**2
          -6338925*y**3-2354153*y**4+3336069*y**5-1160892*y**6-722966*y**7+683865*y**8
          -227197*y**9+58764*y**10-8925*y**11+649*y**12)-r**6*(-1+y)**6*(49084
          +41880*y+33728*y**2-139663*y**3-639121*y**4+378031*y**5+1327777*y**6
          -1499623*y**7+424203*y**8+74881*y**9-50185*y**10+3918*y**11+1490*y**12)
          -r**10*(-1+y)**4*(2291040-5391956*y+2705508*y**2-1417851*y**3+5290785*y**4
          -4846866*y**5-1879246*y**6+5348134*y**7-2337454*y**8-110550*y**9+206126*y**10
          -27783*y**11+1713*y**12)-r**8*(-1+y)**5*(54708-90292*y+1142*y**2-1455053*y**3
          +3239484*y**4-2697954*y**5+761496*y**6+559206*y**7-374892*y**8-56614*y**9
          +66746*y**10-13509*y**11+2532*y**12)-2*r**18*(502114-3705366*y+11357456*y**2
          -21513639*y**3+24408037*y**4-16781712*y**5+9079058*y**6-5619007*y**7
          +3211649*y**8-1324772*y**9+371788*y**10-68432*y**11+8026*y**12)-2*r**16*(
          -1983988+11094384*y-24928670*y**2+29873071*y**3-24373435*y**4+18282222*y**5
          -13111010*y**6+8562341*y**7-5257927*y**8+2425150*y**9-741074*y**10+202306*y**11
          -49296*y**12+5926*y**13))+(-1+r**2+y)**3*(51*r**30*(-1+y)**9+r**28*(
          -1+y)**4*(1511-7402*y+14345*y**2-14101*y**3+7550*y**4-2263*y**5+352*y**6)
          +r**26*(-1+y)**2*(-18121+124027*y-360327*y**2+587211*y**3-594966*y**4
          +393402*y**5-175405*y**6+51717*y**7-9221*y**8+851*y**9)-(-1+y)**11*(839
          +4003*y+11529*y**2+15472*y**3+6439*y**4-14885*y**5+19215*y**6-5173*y**7
          -25172*y**8+14286*y**9-964*y**10-23*y**11+34*y**12)+r**24*(158557-1399566*y
          +5453535*y**2-12349111*y**3+18123490*y**4-18269689*y**5+13096993*y**6
          -6799413*y**7+2554614*y**8-673753*y**9+115648*y**10-10692*y**11+347*y**12)
          -r**2*(-1+y)**10*(11435+42503*y+99101*y**2+55159*y**3-154285*y**4
          -322969*y**5+499671*y**6-132545*y**7-249376*y**8+156020*y**9-14176*y**10
          -394*y**11+254*y**12+2*y**13)-r**22*(268747-2700243*y+11820768*y**2
          -29151072*y**3+45207561*y**4-47077237*y**5+34563343*y**6-18538417*y**7
          +7290910*y**8-1949856*y**9+254705*y**10+29305*y**11-17026*y**12+2352*y**13)
          +r**20*(-3441601+26875434*y-90365745*y**2+172597083*y**3-206203230*y**4
          +159647549*y**5-81663805*y**6+31710122*y**7-15962551*y**8+11003528*y**9
          -5686733*y**10+1825171*y**11-383922*y**12+58473*y**13-4973*y**14)-r**4*(
          -1+y)**8*(79571+71098*y+44583*y**2-675425*y**3+234278*y**4+42801*y**5
          +2318065*y**6-3174438*y**7+1499829*y**8-520736*y**9+135063*y**10-913*y**11
          +6290*y**12+701*y**13+33*y**14)-r**6*(-1+y)**7*(978671+238994*y-56869*y**2
          -3651512*y**3-3019583*y**4+6210010*y**5+15307666*y**6-24719760*y**7
          +9463771*y**8+439194*y**9-880571*y**10+116320*y**11+32949*y**12+1426*y**13
          +94*y**14)+r**8*(-1+y)**6*(-3571217+2852832*y+947292*y**2+19170479*y**3
          -35350399*y**4+15932948*y**5-18892971*y**6+28710632*y**7-13051805*y**8
          +755002*y**9+870264*y**10-159271*y**11-44139*y**12-5934*y**13+287*y**14)
          +r**10*(-1+y)**5*(-24631213+59984512*y-36151860*y**2+31393590*y**3
          -95169834*y**4+80751452*y**5-5787713*y**6-26948404*y**7+12800607*y**8
          +956048*y**9-528814*y**10-299794*y**11+59744*y**12-22572*y**13+2251*y**14)
          +r**16*(-1+y)**2*(1769325-9986676*y+22088166*y**2-23022739*y**3-39497831*y**4
          +106598572*y**5-72036414*y**6+4878476*y**7+13624411*y**8-7950306*y**9
          +2449138*y**10-470185*y**11+64383*y**12-1302*y**13+2982*y**14)+r**12*(
          -1+y)**4*(5162157-55686222*y+132764859*y**2-74617407*y**3-94369016*y**4
          +143667843*y**5-39891700*y**6-53919606*y**7+43985861*y**8-11590480*y**9
          +3498595*y**10-1484123*y**11+304542*y**12-47349*y**13+5646*y**14)+r**14*(
          -1+y)**3*(27960561-117238278*y+176662791*y**2-101910772*y**3-50156051*y**4
          +143394094*y**5-87596659*y**6-17759320*y**7+41744939*y**8-22830098*y**9
          +8921225*y**10-2454148*y**11+411039*y**12-47862*y**13+6939*y**14)+r**18*(2649031
          -25546323*y+105284406*y**2-263827760*y**3+436395590*y**4-479374300*y**5
          +347184450*y**6-169983542*y**7+69699341*y**8-37689393*y**9+22962320*y**10
          -10029102*y**11+2670886*y**12-449216*y**13+56648*y**14-3036*y**15))))/(41990400*logy**4*r**16*(
          -1+y)**9+13996800*logy**3*r**12*(-1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+1749600*logy**2*r**8*(-1+y)**5*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+97200*logy*r**4*(
          -1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +2025*(-1+y)*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1
          +y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y
          -y**2+y**3))**4))
      resNP += ((api*(-518400*logy**4*r**18*(2+3*r**2)*(-1+y)**8-8640*logy**3*r**12*(
          -1+y)**6*(8*r**12*(-1+y)**2+r**10*(236-472*y+236*y**2+15*y**3)+20*r**4*(
          -1+y)**2*(-13-2*y**3+3*y**4)+10*r**8*(49-26*y-59*y**2+39*y**3+3*y**4)
          +5*r**6*(-96+288*y-240*y**2+56*y**3-16*y**4+17*y**5)-2*(-1+y)**3*(17
          +17*y+17*y**2+32*y**3-58*y**4+20*y**5)-r**2*(-1+y)**2*(28+275*y**3
          -210*y**4+42*y**5))-144*logy**2*r**8*(-1+y)**4*(-1+r**2+y)**2*(-112*r**16*(
          -1+y)**4+r**14*(-1+y)**2*(336-448*y-112*y**2+779*y**3)+2*r**12*(
          -1+y)**2*(5492-10488*y+4692*y**2-923*y**3+327*y**4)+r**10*(34832
          -116384*y+137352*y**2-53995*y**3-7700*y**4+1113*y**5+5874*y**6-992*y**7)
          -2*r**4*(-1+y)**3*(-4328-2824*y-2628*y**2+955*y**3+12920*y**4-7362*y**5
          +224*y**6+143*y**7)+4*(-1+y)**5*(-37-111*y-222*y**2-75*y**3+255*y**4
          +522*y**5-674*y**6+192*y**7)+r**2*(-1+y)**4*(-1704-3112*y-4224*y**2
          -4685*y**3+5060*y**4+1659*y**5-2238*y**6+494*y**7)+r**6*(-1+y)**2*(14392
          -13224*y-8808*y**2+51485*y**3-45300*y**4+15498*y**5-4296*y**6+1503*y**7)
          +20*r**8*(2889-7286*y+4949*y**2+1597*y**3-3480*y**4+1751*y**5-534*y**6
          +76*y**7+38*y**8))+12*logy*r**4*(-1+y)**4*(-1+r**2+y)**3*(4*r**22*(-1
          +y)**4-r**20*(-1+y)**2*(-232+476*y-256*y**2+141*y**3)+r**18*(5842
          -21388*y+28500*y**2-17497*y**3+5041*y**4+297*y**5-35*y**6)+r**16*(
          -56190+201150*y-252012*y**2+106908*y**3+10278*y**4-7917*y**5-4822*y**6
          +405*y**7)-r**14*(172832-572672*y+668172*y**2-364570*y**3+151390*y**4
          -71187*y**5+10757*y**6+3193*y**7+885*y**8)+r**12*(-257592+594240*y
          -362844*y**2-273896*y**3+332492*y**4+91047*y**5-155240*y**6+13954*y**7
          +8256*y**8-2217*y**9)+3*r**2*(-1+y)**5*(114+478*y+1250*y**2+1451*y**3
          -748*y**4-4034*y**5+3342*y**6-85*y**7-286*y**8+18*y**9)+2*(-1+y)**6*(
          -11-55*y-165*y**2-282*y**3-327*y**4-99*y**5+445*y**6+280*y**7-378*y**8
          +92*y**9)+r**6*(-1+y)**3*(-64860-86340*y-91452*y**2+22742*y**3+205360*y**4
          -3735*y**5-138280*y**6+75692*y**7-14232*y**8+405*y**9)-r**4*(-1+y)**4*(1648
          +2484*y+1956*y**2-42873*y**3-36750*y**4-31968*y**5+94636*y**6-41501*y**7
          +2158*y**8+710*y**9)+r**8*(-1+y)**2*(79828+23284*y+46960*y**2-160382*y**3
          -244580*y**4+252787*y**5-34724*y**6+20860*y**7-21548*y**8+2415*y**9)
          +r**10*(-526140+1054488*y-364260*y**2-884652*y**3+1588572*y**4-1448373*y**5
          +754697*y**6-177150*y**7+6522*y**8-4097*y**9+393*y**10))-r**2*(-1+y)**2*(
          -1+r**2+y)**4*(r**26*(-1+y)**6+r**24*(-1+y)**4*(-30+56*y-22*y**2
          +5*y**3)+2*r**22*(-1+y)**2*(95-346*y+427*y**2-262*y**3+139*y**4-40*y**5
          +3*y**6)+r**20*(-11200+63724*y-148648*y**2+189734*y**3-152060*y**4
          +81815*y**5-27896*y**6+4984*y**7-100*y**8+7*y**9)+(-1+y)**9*(2+14*y
          +56*y**2+183*y**3-21*y**4-1152*y**5-562*y**6+561*y**7-41*y**8-2*y**9
          +2*y**10)+r**18*(4819-57694*y+205219*y**2-366080*y**3+421190*y**4
          -365714*y**5+227244*y**6-81324*y**7+11995*y**8-740*y**9+125*y**10)
          +r**2*(-1+y)**7*(-1365-6553*y-18975*y**2-31755*y**3-22058*y**4+22800*y**5
          +16342*y**6+5060*y**7-19025*y**8+6433*y**9-135*y**10+31*y**11)+r**4*(
          -1+y)**6*(-4208-15748*y-35552*y**2-94102*y**3-117872*y**4-79735*y**5
          +227758*y**6-45033*y**7-46508*y**8+19887*y**9-1082*y**10+195*y**11)
          +2*r**6*(-1+y)**5*(-12655-20203*y-19115*y**2+182603*y**3+49330*y**4
          +84968*y**5-341790*y**6+184970*y**7-36723*y**8+15015*y**9-2143*y**10
          +343*y**11)+r**16*(613514-3054860*y+5956370*y**2-5264689*y**3+1136020*y**4
          +1608863*y**5-1339062*y**6+393305*y**7-66186*y**8+20985*y**9-4272*y**10
          +612*y**11)+2*r**12*(-1+y)**2*(735160-1415188*y+429808*y**2+2776762*y**3
          -4251088*y**4+2293345*y**5-725958*y**6+470677*y**7-243012*y**8+69573*y**9
          -8010*y**10+1131*y**11)+r**8*(-1+y)**4*(-772394-700752*y-494858*y**2
          +1619339*y**3+1485220*y**4-539206*y**5-1879128*y**6+1318028*y**7-286194*y**8
          +68410*y**9-10190*y**10+1525*y**11)+r**10*(-1+y)**3*(-1192727+94877*y
          +800407*y**2+1158787*y**3-1253062*y**4+216010*y**5-1080906*y**6+1480858*y**7
          -588387*y**8+137577*y**9-15693*y**10+2259*y**11)+4*r**14*(17897-45844*y
          +72820*y**2-506376*y**3+1636829*y**4-2411669*y**5+1845685*y**6-754510*y**7
          +181801*y**8-53229*y**9+19257*y**10-3036*y**11+375*y**12)))*math.log(mu0**2/r**2))/(3110400*logy**4*r**16*(
          -1+y)**8+1036800*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+129600*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+7200*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +150*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6+120*logy*r**4*(
          -1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(-67+98*y
          -13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3-2*y**4
          +y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)+2*r**2*(
          -1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y-421*y**2
          +40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(
          -1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1
          +y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(
          -4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y
          +45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)
          +2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5
          -56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(0,'SLT',y/2,r))/(1036800*logy**3*r**12*(
          -1+y)**6-600*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +259200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(43200*logy**3*r**12*(6+8*r**2
          +3*r**4)*(-1+y)**8+720*logy**2*r**8*(-1+y)**6*(-10*r**12*(-1+y)**2+r**10*(112
          -224*y+112*y**2+15*y**3)+5*r**8*(197-286*y+35*y**2+45*y**3+15*y**4)
          +5*r**2*(-1+y)**2*(-80+131*y**3-30*y**4+6*y**5)+5*r**6*(96+96*y-336*y**2
          +74*y**3+68*y**4+11*y**5)+(-1+y)**3*(-43-43*y-43*y**2+272*y**3
          -118*y**4+20*y**5)+5*r**4*(-242+700*y-566*y**2+14*y**3+56*y**4+35*y**5
          +3*y**6))-12*logy*r**4*(-1+y)**4*(-1+r**2+y)**2*(29*r**16*(-1+y)**4
          -2*r**14*(-1+y)**2*(31-33*y-27*y**2+164*y**3)-r**12*(-1+y)**2*(-1667
          +2068*y+178*y**2-1662*y**3+543*y**4)+2*r**10*(-12542+43014*y-50602*y**2
          +17365*y**3+7030*y**4-3863*y**5-604*y**6+302*y**7)+5*r**8*(-20857+64512*y
          -65192*y**2+16974*y**3+6060*y**4-918*y**5+558*y**6-1088*y**7+131*y**8)
          +2*(-1+y)**4*(-38-76*y-114*y**2+393*y**3-15*y**4+123*y**5+911*y**6
          -926*y**7+192*y**8)+2*r**2*(-1+y)**3*(-824-748*y-672*y**2+6839*y**3
          -3535*y**4+1139*y**5+863*y**6-1488*y**7+226*y**8)-r**4*(-1+y)**2*(1423
          +2016*y-336*y**2+19362*y**3-59740*y**4+33812*y**5-1556*y**6-1354*y**7
          +973*y**8)-2*r**6*(28007-75003*y+59332*y**2-34883*y**3+79412*y**4
          -85107*y**5+30828*y**6-2207*y**7-967*y**8+588*y**9))+(-1+y)**2*(-1
          +r**2+y)**3*(4*r**22*(-1+y)**6+r**20*(-1+y)**4*(-100+188*y-76*y**2
          +27*y**3)-r**18*(-1+y)**2*(47-128*y+192*y**2-98*y**3-193*y**4+270*y**5
          +10*y**6)-5*r**16*(-1+y)**2*(-103+247*y-96*y**2-1823*y**3+3011*y**4
          -1146*y**5-102*y**6+36*y**7)-2*r**14*(-1+y)**2*(6199-14434*y+5025*y**2
          +36260*y**3-64175*y**4+36546*y**5-5871*y**6-780*y**7+30*y**8)+10*r**6*(
          -1+y)**3*(1111-1227*y-198*y**2-11894*y**3+29778*y**4-20526*y**5+378*y**6
          +11606*y**7-11533*y**8+3765*y**9-72*y**10+12*y**11)+(-1+y)**6*(-11
          -33*y-66*y**2+173*y**3+132*y**4+213*y**5+676*y**6-349*y**7-13*y**8
          -72*y**9-142*y**10+92*y**11)+2*r**8*(-1+y)**2*(34076-53144*y+5346*y**2
          +8891*y**3-118364*y**4+284559*y**5-183226*y**6+34579*y**7-23016*y**8
          +16839*y**9-2160*y**10+120*y**11)+2*r**12*(150583-744759*y+1435932*y**2
          -1179323*y**3-24558*y**4+823686*y**5-648750*y**6+211988*y**7-24157*y**8
          +453*y**9-1074*y**10+279*y**11)+r**2*(-1+y)**5*(-335-637*y-906*y**2
          +4904*y**3-236*y**4+1704*y**5+7298*y**6-10754*y**7+2811*y**8-299*y**9
          -304*y**10+354*y**11)+r**4*(-1+y)**4*(-2522-2462*y-2012*y**2+27083*y**3
          -8452*y**4+2072*y**5-17188*y**6+41702*y**7-41818*y**8+12142*y**9+40*y**10
          +415*y**11)+4*r**10*(97604-419274*y+670329*y**2-550167*y**3+542478*y**4
          -847980*y**5+799206*y**6-331290*y**7+27942*y**8+9922*y**9+2751*y**10
          -1707*y**11+186*y**12)))*nlo.X1El(0,'SM',y/2,r))/(6220800*logy**4*r**16*(-1
          +y)**8+2073600*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+259200*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+14400*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +300*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1+y)**4-(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(1,'SLT',y/2,r))/(1440*logy**2*r**8*(
          -1+y)**4+240*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-720*logy**2*r**8*(1+r**2)*(-1
          +y)**6+24*logy*r**4*(-1+y)**4*(3*r**10*(-1+y)**2-5*r**8*(5-10*y+5*y**2
          +y**3)+5*r**2*(-1+y)**2*(5-16*y**3+2*y**4)-5*r**6*(12-12*y-6*y**2
          +4*y**3+5*y**4)+(-1+y)**3*(3+3*y+3*y**2-32*y**3+8*y**4)-15*r**4*(
          -4+12*y-10*y**2-2*y**3+3*y**4+y**5))-(-1+y)**2*(-1+r**2+y)**2*(r**14*(
          -1+y)**4+r**12*(-1+y)**2*(-21+40*y-17*y**2+12*y**3)+r**10*(-1+y)**2*(
          -3-26*y+28*y**2-90*y**3+21*y**4)+r**8*(743-2470*y+2765*y**2-330*y**3
          -1465*y**4+832*y**5-115*y**6)+(-1+y)**4*(1+2*y+3*y**2-26*y**3-11*y**4
          -12*y**5-13*y**6+16*y**7)+r**4*(-1+y)**2*(-3+32*y-y**2+360*y**3
          -1265*y**4+568*y**5+33*y**6+36*y**7)+r**2*(-1+y)**3*(21+19*y+17*y**2
          -341*y**3+109*y**4-17*y**5-15*y**6+47*y**7)+r**6*(743-1988*y+1560*y**2
          -1500*y**3+3930*y**4-3948*y**5+1188*y**6+20*y**7-5*y**8)))*nlo.X1El(1,'SM',y/2,r))/(17280*logy**3*r**12*(
          -1+y)**6-10*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +4320*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+360*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(2,'SLT',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +(2*api*(-1+y)**2*y**3*(-1+r**2+y)**3*nlo.X1El(2,'SM',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      res += resNP*wc.SLT

    if wc.T2 != 0:
      resNP = 0
      resNP +=((43200*logy**3*r**12*(3+4*r**2+3*r**4)*(-1+y)**6+720*logy**2*r**8*(-1+y)**4*(164*r**10*(
          -1+y)**2-11*r**12*(-1+y)**2+20*r**6*y*(36-54*y+10*y**2+7*y**3+y**4)
          +5*r**8*(121-134*y-41*y**2+52*y**3+6*y**4)+5*r**4*(-1+y)**2*(-121
          +108*y+54*y**2-20*y**3+9*y**4)+4*r**2*(-1+y)**3*(41+41*y+41*y**2
          -49*y**3+21*y**4)+(-1+y)**4*(11+22*y+33*y**2-76*y**3+40*y**4))
          -12*logy*r**4*(-1+y)**4*(-1+r**2+y)**2*(19*r**16*(-1+y)**2+r**14*(218
          -474*y+294*y**2-238*y**3)+r**12*(-1148+3142*y-2123*y**2+1572*y**3
          -443*y**4)+2*r**10*(-10537+13465*y-515*y**2-3615*y**3-300*y**4+202*y**5)
          +2*r**2*(-1+y)**3*(-109-346*y-730*y**2+1380*y**3-365*y**4-406*y**5
          +76*y**6)+5*r**8*(-12806+12806*y+1421*y**2-3000*y**3+544*y**4-1006*y**5
          +161*y**6)+(-1+y)**4*(19+76*y+190*y**2+500*y**3+115*y**4-584*y**5
          +184*y**6)-r**4*(-1+y)**2*(1148+3142*y+5265*y**2+9440*y**3-6750*y**4
          +122*y**5+533*y**6)-2*r**6*(10537-7609*y-2413*y**2-14055*y**3+20335*y**4
          -8087*y**5+1149*y**6+143*y**7))-(-1+y)**2*(-1+r**2+y)**3*(r**22*(-1
          +y)**4+r**20*(-1+y)**2*(-25+47*y-19*y**2+5*y**3)+r**18*(1387-5248*y
          +7242*y**2-4568*y**3+1347*y**4-40*y**5)-(-1+y)**8*(-1-7*y-28*y**2
          +12*y**3+77*y**4+23*y**5+4*y**6)-r**2*(-1+y)**7*(-25-147*y-504*y**2
          +620*y**3+1465*y**4+15*y**5+12*y**6+4*y**7)-5*r**16*(1175-4451*y
          +5934*y**2-2618*y**3-493*y**4+585*y**5-48*y**6+12*y**7)-5*r**6*(-1
          +y)**4*(1175+3276*y+5934*y**2+10472*y**3-3694*y**4-3756*y**5+2766*y**6
          -120*y**7+27*y**8)-r**4*(-1+y)**5*(1387+5248*y+12490*y**2+5220*y**3
          -90*y**4-7872*y**5+5282*y**6-100*y**7+35*y**8)-2*r**14*(631-3826*y
          +8355*y**2-25440*y**3+42470*y**4-30206*y**5+8211*y**6-600*y**7+105*y**8)
          -2*r**8*(-1+y)**3*(-631-2564*y-5160*y**2-6000*y**3+20785*y**4-4*y**5
          +4704*y**6-780*y**7+150*y**8)-2*r**10*(-1+y)**2*(105113-18136*y-30544*y**2
          -110660*y**3+98965*y**4-5768*y**5+2496*y**6-1176*y**7+210*y**8)-2*r**12*(105113
          -297203*y+248523*y**2+60251*y**3-224574*y**4+142492*y**5-42657*y**6
          +9147*y**7-1281*y**8+189*y**9)))/(129600*logy**3*r**12*(-1+y)**6-75*(r**8*(
          -1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3+32400*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +2700*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2))
      resNP += ((api*(8294400*logy**4*r**18*(2+3*r**2)*(-1+y)**8
          +138240*logy**3*r**12*(-1+y)**6*(8*r**12*(-1+y)**2+r**10*(236-472*y+236*y**2
          +15*y**3)+20*r**4*(-1+y)**2*(-13-2*y**3+3*y**4)+10*r**8*(49-26*y
          -59*y**2+39*y**3+3*y**4)+5*r**6*(-96+288*y-240*y**2+56*y**3-16*y**4
          +17*y**5)-2*(-1+y)**3*(17+17*y+17*y**2+32*y**3-58*y**4+20*y**5)
          -r**2*(-1+y)**2*(28+275*y**3-210*y**4+42*y**5))+2304*logy**2*r**8*(-1
          +y)**4*(-1+r**2+y)**2*(-112*r**16*(-1+y)**4+r**14*(-1+y)**2*(336-448*y
          -112*y**2+779*y**3)+2*r**12*(-1+y)**2*(5492-10488*y+4692*y**2-923*y**3
          +327*y**4)+r**10*(34832-116384*y+137352*y**2-53995*y**3-7700*y**4
          +1113*y**5+5874*y**6-992*y**7)-2*r**4*(-1+y)**3*(-4328-2824*y-2628*y**2
          +955*y**3+12920*y**4-7362*y**5+224*y**6+143*y**7)+4*(-1+y)**5*(-37
          -111*y-222*y**2-75*y**3+255*y**4+522*y**5-674*y**6+192*y**7)+r**2*(
          -1+y)**4*(-1704-3112*y-4224*y**2-4685*y**3+5060*y**4+1659*y**5-2238*y**6
          +494*y**7)+r**6*(-1+y)**2*(14392-13224*y-8808*y**2+51485*y**3-45300*y**4
          +15498*y**5-4296*y**6+1503*y**7)+20*r**8*(2889-7286*y+4949*y**2+1597*y**3
          -3480*y**4+1751*y**5-534*y**6+76*y**7+38*y**8))-192*logy*r**4*(-1+y)**4*(
          -1+r**2+y)**3*(4*r**22*(-1+y)**4-r**20*(-1+y)**2*(-232+476*y-256*y**2
          +141*y**3)+r**18*(5842-21388*y+28500*y**2-17497*y**3+5041*y**4+297*y**5
          -35*y**6)+r**16*(-56190+201150*y-252012*y**2+106908*y**3+10278*y**4
          -7917*y**5-4822*y**6+405*y**7)-r**14*(172832-572672*y+668172*y**2
          -364570*y**3+151390*y**4-71187*y**5+10757*y**6+3193*y**7+885*y**8)
          +r**12*(-257592+594240*y-362844*y**2-273896*y**3+332492*y**4+91047*y**5
          -155240*y**6+13954*y**7+8256*y**8-2217*y**9)+3*r**2*(-1+y)**5*(114
          +478*y+1250*y**2+1451*y**3-748*y**4-4034*y**5+3342*y**6-85*y**7-286*y**8
          +18*y**9)+2*(-1+y)**6*(-11-55*y-165*y**2-282*y**3-327*y**4-99*y**5
          +445*y**6+280*y**7-378*y**8+92*y**9)+r**6*(-1+y)**3*(-64860-86340*y
          -91452*y**2+22742*y**3+205360*y**4-3735*y**5-138280*y**6+75692*y**7
          -14232*y**8+405*y**9)-r**4*(-1+y)**4*(1648+2484*y+1956*y**2-42873*y**3
          -36750*y**4-31968*y**5+94636*y**6-41501*y**7+2158*y**8+710*y**9)+r**8*(
          -1+y)**2*(79828+23284*y+46960*y**2-160382*y**3-244580*y**4+252787*y**5
          -34724*y**6+20860*y**7-21548*y**8+2415*y**9)+r**10*(-526140+1054488*y
          -364260*y**2-884652*y**3+1588572*y**4-1448373*y**5+754697*y**6-177150*y**7
          +6522*y**8-4097*y**9+393*y**10))+16*r**2*(-1+y)**2*(-1+r**2+y)**4*(r**26*(
          -1+y)**6+r**24*(-1+y)**4*(-30+56*y-22*y**2+5*y**3)+2*r**22*(-1+y)**2*(95
          -346*y+427*y**2-262*y**3+139*y**4-40*y**5+3*y**6)+r**20*(-11200+63724*y
          -148648*y**2+189734*y**3-152060*y**4+81815*y**5-27896*y**6+4984*y**7
          -100*y**8+7*y**9)+(-1+y)**9*(2+14*y+56*y**2+183*y**3-21*y**4-1152*y**5
          -562*y**6+561*y**7-41*y**8-2*y**9+2*y**10)+r**18*(4819-57694*y+205219*y**2
          -366080*y**3+421190*y**4-365714*y**5+227244*y**6-81324*y**7+11995*y**8
          -740*y**9+125*y**10)+r**2*(-1+y)**7*(-1365-6553*y-18975*y**2-31755*y**3
          -22058*y**4+22800*y**5+16342*y**6+5060*y**7-19025*y**8+6433*y**9-135*y**10
          +31*y**11)+r**4*(-1+y)**6*(-4208-15748*y-35552*y**2-94102*y**3-117872*y**4
          -79735*y**5+227758*y**6-45033*y**7-46508*y**8+19887*y**9-1082*y**10
          +195*y**11)+2*r**6*(-1+y)**5*(-12655-20203*y-19115*y**2+182603*y**3
          +49330*y**4+84968*y**5-341790*y**6+184970*y**7-36723*y**8+15015*y**9
          -2143*y**10+343*y**11)+r**16*(613514-3054860*y+5956370*y**2-5264689*y**3
          +1136020*y**4+1608863*y**5-1339062*y**6+393305*y**7-66186*y**8+20985*y**9
          -4272*y**10+612*y**11)+2*r**12*(-1+y)**2*(735160-1415188*y+429808*y**2
          +2776762*y**3-4251088*y**4+2293345*y**5-725958*y**6+470677*y**7-243012*y**8
          +69573*y**9-8010*y**10+1131*y**11)+r**8*(-1+y)**4*(-772394-700752*y
          -494858*y**2+1619339*y**3+1485220*y**4-539206*y**5-1879128*y**6+1318028*y**7
          -286194*y**8+68410*y**9-10190*y**10+1525*y**11)+r**10*(-1+y)**3*(-1192727
          +94877*y+800407*y**2+1158787*y**3-1253062*y**4+216010*y**5-1080906*y**6
          +1480858*y**7-588387*y**8+137577*y**9-15693*y**10+2259*y**11)+4*r**14*(17897
          -45844*y+72820*y**2-506376*y**3+1636829*y**4-2411669*y**5+1845685*y**6
          -754510*y**7+181801*y**8-53229*y**9+19257*y**10-3036*y**11+375*y**12))))/(4665600*logy**4*r**16*(
          -1+y)**8+1555200*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+194400*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+10800*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +225*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*muWC*(-49766400*logy**4*r**16*(-1+r**4)*(-1+y)**8-276480*logy**3*r**12*(
          -1+y)**5*(42*r**12*(-1+y)**3+r**10*(-208+624*y-624*y**2+13*y**3+105*y**4)
          +5*r**8*(-46-6*y+222*y**2-297*y**3+87*y**4+12*y**5)+3*(-1+y)**3*(14
          +55*y**3-80*y**4+26*y**5)+r**2*(-1+y)**3*(208-315*y**3+42*y**5)+15*r**6*(64
          -192*y+192*y**2-64*y**3-16*y**4+9*y**5+y**6)+5*r**4*(-46+282*y
          -498*y**2+398*y**3-222*y**4+147*y**5-73*y**6+12*y**7))+23040*logy**2*r**8*(
          -1+y)**3*(-1+r**2+y)**2*(52*r**16*(-1+y)**5-r**14*(-1+y)**2*(-408+1120*y
          -912*y**2-25*y**3+251*y**4)-r**12*(-1+y)**2*(-3928+10984*y-9984*y**2
          +2373*y**3-599*y**4+390*y**5)+(-1+y)**5*(-52-104*y-156*y**2+215*y**3
          +112*y**4+231*y**5-450*y**6+174*y**7)+r**2*(-1+y)**4*(-408-304*y
          -200*y**2-565*y**3+481*y**4+345*y**5+507*y**6-506*y**7+130*y**8)+r**8*y*(11048
          -38668*y+67955*y**2-72455*y**3+43555*y**4-14653*y**5+4498*y**6-1420*y**7
          +140*y**8)-r**4*(-1+y)**3*(-3928+800*y+200*y**2-5635*y**3+13986*y**4
          -9546*y**5+1636*y**6-409*y**7+146*y**8)+r**10*(4088-18496*y+34304*y**2
          -20035*y**3-11393*y**4+13531*y**5-183*y**6-2056*y**7+320*y**8)-r**6*(
          -1+y)**2*(4088-6032*y+3144*y**2-12543*y**3+12905*y**4-4458*y**5+2382*y**6
          -2189*y**7+543*y**8))+384*logy*r**4*(-1+y)**3*(-1+r**2+y)**3*(26*r**22*(
          -1+y)**5-r**20*(-1+y)**2*(574-1800*y+1956*y**2-753*y**3+345*y**4)
          +r**18*(-7490+33010*y-55976*y**2+47036*y**3-19447*y**4+125*y**5+4037*y**6
          -735*y**7)+r**16*(121050-538260*y+911874*y**2-677983*y**3+139052*y**4
          +65597*y**5-20013*y**6-4762*y**7+405*y**8)+(-1+y)**6*(26+104*y+260*y**2
          +425*y**3-730*y**4-2296*y**5+1916*y**6+165*y**7-480*y**8+110*y**9)
          +r**14*(252660-1088100*y+1836624*y**2-1407072*y**3+559950*y**4-322140*y**5
          +220125*y**6-30459*y**7-12763*y**8+375*y**9)+r**12*(-268548+1250520*y
          -2026836*y**2+2675214*y**3-2722128*y**4+1090476*y**5+227315*y**6-214814*y**7
          +24166*y**8+7428*y**9-2793*y**10)-r**4*(-1+y)**4*(-7490-10540*y-12426*y**2
          +58279*y**3+36947*y**4+12285*y**5-145330*y**6+93941*y**7-19979*y**8
          +363*y**9+250*y**10)-r**2*(-1+y)**5*(574+1800*y+3756*y**2-2084*y**3
          +5013*y**4+1272*y**5-12260*y**6+6744*y**7+1379*y**8-1988*y**9+294*y**10)
          +r**8*(-1+y)**2*(-252660+175200*y-10824*y**2-362034*y**3+1287918*y**4
          -1071150*y**5+205935*y**6+66174*y**7+3284*y**8-10058*y**9+615*y**10)
          +r**6*(-1+y)**3*(121050+54060*y+23394*y**2-28416*y**3-123558*y**4
          +85710*y**5-12875*y**6+10136*y**7+22766*y**8-13122*y**9+1155*y**10)
          +r**10*(268548-629316*y+163224*y**2+1750400*y**3-3619288*y**4+3573674*y**5
          -2450339*y**6+1296801*y**7-388250*y**8+21888*y**9+15553*y**10-2895*y**11))
          -32*(-1+y)*(-1+r**2+y)**4*(r**28*(-1+y)**7+r**26*(-1+y)**4*(28-80*y
          +72*y**2-27*y**3+5*y**4)+r**24*(-1+y)**2*(1175-5671*y+10876*y**2
          -9951*y**3+4184*y**4-740*y**5-87*y**6+6*y**7)-(-1+y)**10*(-1-7*y
          -28*y**2-121*y**3-91*y**4+410*y**5+218*y**6-151*y**7+72*y**8+17*y**9
          +2*y**10)+r**22*(6992-46552*y+132700*y**2-216026*y**3+232266*y**4
          -180129*y**5+99971*y**6-35452*y**7+6568*y**8-105*y**9+7*y**10)+r**2*(
          -1+y)**9*(28+164*y+560*y**2+2455*y**3+638*y**4-8695*y**5-1260*y**6
          +2331*y**7-1594*y**8-57*y**9-12*y**10+2*y**11)+r**20*(20491-79133*y
          +48395*y**2+210005*y**3-566004*y**4+821595*y**5-841953*y**6+557984*y**7
          -200401*y**8+28728*y**9-792*y**10+125*y**11)+2*r**14*(-1+y)**2*y*(-110264
          +275660*y-6453718*y**2+13838274*y**3-11449245*y**4+5085751*y**5-1874981*y**6
          +630593*y**7-213729*y**8+59055*y**9-8127*y**10+1131*y**11)+r**4*(-1
          +y)**7*(1175+4496*y+10876*y**2-1602*y**3+1007*y**4-13175*y**5-22704*y**6
          +5183*y**7+9607*y**8-11637*y**9+1280*y**10-137*y**11+31*y**12)+r**6*(
          -1+y)**6*(-6992-18584*y-34996*y**2+16662*y**3-43934*y**4-49591*y**5
          +38531*y**6-59219*y**7-20837*y**8-681*y**9+1633*y**10-987*y**11+195*y**12)
          +r**18*(-1385908+8231096*y-20033036*y**2+24823567*y**3-14526489*y**4
          +80661*y**5+5361113*y**6-3472291*y**7+1138793*y**8-254701*y**9+42267*y**10
          -4484*y**11+612*y**12)+r**8*(-1+y)**5*(20491-23322*y-63227*y**2-784463*y**3
          -325784*y**4-99422*y**5+1765094*y**6-1583224*y**7+355023*y**8-52356*y**9
          +15101*y**10-3997*y**11+686*y**12)+r**10*(-1+y)**4*(1385908-84352*y
          -333824*y**2-1996653*y**3-535461*y**4+1579602*y**5+1049726*y**6-2317756*y**7
          +1158208*y**8-395734*y**9+78630*y**10-9819*y**11+1525*y**12)+r**12*(
          -1+y)**3*(1121139-1041452*y-1153750*y**2-3793048*y**3+11269785*y**4
          -7358754*y**5+970840*y**6-1162214*y**7+1427993*y**8-685830*y**9+143790*y**10
          -15558*y**11+2259*y**12)+r**16*(1121139-6806521*y+16141457*y**2-18245376*y**3
          +4352183*y**4+16988505*y**5-26696779*y**6+19140477*y**7-7203994*y**8
          +1367132*y**9-216534*y**10+69315*y**11-12504*y**12+1500*y**13))))/(13996800*logy**4*r**16*(
          -1+y)**8+4665600*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+583200*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+32400*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +675*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((muG*(-518400*logy**4*r**14*(-21-9*r**2+r**4+9*r**6)*(-1+y)**8-8640*logy**3*r**10*(
          -1+y)**5*(-290*r**14*(-1+y)**3-3*r**12*(443-1329*y+1329*y**2-728*y**3
          +135*y**4)+3*(-1+y)**4*(29+29*y+29*y**2+59*y**3-96*y**4+20*y**5)
          +r**10*(-1512+2376*y+864*y**2-1073*y**3-255*y**4+300*y**5)+5*r**4*(
          -1+y)**2*(-819+1827*y-504*y**2-863*y**3+536*y**4-165*y**5+6*y**6)
          +5*r**8*(741-2271*y+2343*y**2-787*y**3+264*y**4-273*y**5+73*y**6)
          +r**2*(-1+y)**3*(1556-3165*y**3+2790*y**4-1206*y**5+160*y**6)-15*r**6*(
          -294+738*y-522*y**2+178*y**3-278*y**4+237*y**5-71*y**6+12*y**7))
          +144*logy**2*r**6*(-1+y)**3*(-1+r**2+y)**2*(-1068*r**18*(-1+y)**5+r**16*(
          -1+y)**2*(-16185+46419*y-42147*y**2+8912*y**3+3651*y**4)+r**14*(-1
          +y)**2*(-25308+53958*y-32922*y**2-16627*y**3-3607*y**4+5406*y**5)
          -3*(-1+y)**6*(-43-129*y-258*y**2+270*y**3+265*y**4+503*y**5-416*y**6
          +8*y**7)+r**12*(247314-1020900*y+1524453*y**2-1134192*y**3+524605*y**4
          -149669*y**5-1940*y**6+11497*y**7-3168*y**8)+r**4*(-1+y)**4*(-21522
          -31212*y-32685*y**2+182504*y**3-129765*y**4+75397*y**5-16748*y**6
          +1665*y**7+366*y**8)+r**2*(-1+y)**5*(-2856-5970*y-9342*y**2-11717*y**3
          +7220*y**4+7341*y**5+4120*y**6-7618*y**7+3072*y**8)-r**6*(-1+y)**3*(
          -262020+211686*y+65328*y**2+543471*y**3-824650*y**4+398840*y**5-93496*y**6
          -1843*y**7+4134*y**8)+r**8*(-1+y)**2*(-567048+1256214*y-658809*y**2
          -377392*y**3+390375*y**4-210702*y**5+136161*y**6-31766*y**7+4167*y**8)
          +r**10*(208716-863358*y+1348788*y**2-1448911*y**3+1515045*y**4-1058631*y**5
          +313643*y**6-8028*y**7-9004*y**8+1740*y**9))-12*logy*r**2*(-1+y)**3*(
          -1+r**2+y)**3*(162*r**24*(-1+y)**5-r**22*(-1+y)**2*(2885-9141*y+10113*y**2
          -3756*y**3+1509*y**4)+r**20*(8943-61206*y+158097*y**2-197376*y**3
          +138516*y**4-71475*y**5+31056*y**6-3755*y**7)+r**18*(401361-1661685*y
          +2527056*y**2-1419041*y**3-308981*y**4+648688*y**5-203301*y**6+118*y**7
          +585*y**8)-3*(-1+y)**7*(13+65*y+195*y**2+289*y**3+303*y**4+67*y**5
          -135*y**6-225*y**7-64*y**8+92*y**9)+r**16*(-248917+993014*y-1115221*y**2
          +295258*y**3+872515*y**4-1480958*y**5+745546*y**6+61031*y**7-77663*y**8
          +1395*y**9)+r**14*(-4465206+16885674*y-22386852*y**2+15988666*y**3
          -8305718*y**4+1404832*y**5+2276611*y**6-1668138*y**7+480034*y**8-14802*y**9
          -9501*y**10)+r**2*(-1+y)**6*(-687-2631*y-6285*y**2-2354*y**3+193*y**4
          +10531*y**5+15361*y**6+6200*y**7-17486*y**8+2922*y**9+736*y**10)+r**4*(
          -1+y)**5*(15377+44979*y+88968*y**2+15536*y**3-26193*y**4-89394*y**5
          +72676*y**6-8788*y**7-26666*y**8+3043*y**9+1362*y**10)+r**6*(-1+y)**4*(71547
          +166659*y+255150*y**2-697259*y**3+257873*y**4-155727*y**5+168386*y**6
          -426145*y**7+222754*y**8-39008*y**9+2070*y**10)+r**10*(-1+y)**2*(3954398
          -5371170*y-84414*y**2-4544344*y**3+12446130*y**4-7029228*y**5+1420065*y**6
          -172496*y**7-162106*y**8-8230*y**9+4995*y**10)+r**8*(-1+y)**3*(-398544
          -120222*y-828*y**2+3944642*y**3-3758398*y**4+2063984*y**5-885673*y**6
          -308382*y**7+273488*y**8-82902*y**9+6735*y**10)-r**12*(-3354402+13825932*y
          -20090514*y**2+2700884*y**3+23120978*y**4-27227068*y**5+16651255*y**6
          -7474341*y**7+1895146*y**8+23262*y**9-79655*y**10+8523*y**11))+(-1
          +y)*(-1+r**2+y)**4*(5*r**28*(-1+y)**7+r**26*(-1+y)**4*(16-28*y-12*y**2
          -11*y**3+25*y**4)+r**24*(-1+y)**2*(11725-56725*y+108672*y**2-101585*y**3
          +46608*y**4-10004*y**5+239*y**6+30*y**7)+r**22*(-67728+463716*y-1339062*y**2
          +2117348*y**3-1968136*y**4+1061425*y**5-297703*y**6+24726*y**7+6042*y**8
          +537*y**9+35*y**10)+(-1+y)**10*(-5-35*y-140*y**2-385*y**3-1399*y**4
          -3298*y**5-1766*y**6+1889*y**7+1144*y**8+393*y**9+82*y**10)+r**20*(198615
          -1237089*y+3180207*y**2-4436471*y**3+3328276*y**4-346063*y**5-2004527*y**6
          +2001652*y**7-797505*y**8+112138*y**9-4658*y**10+625*y**11)+r**2*(-1
          +y)**8*(-1760-8352*y-23946*y**2-34321*y**3-22675*y**4+9417*y**5-31075*y**6
          -21919*y**7+44061*y**8-2845*y**9+1833*y**10+372*y**11+10*y**12)+r**4*(
          -1+y)**7*(-49741-184128*y-428940*y**2-305554*y**3-53557*y**4+443995*y**5
          +201124*y**6+75325*y**7-236421*y**8+99057*y**9+24956*y**10-271*y**11
          +155*y**12)+r**6*(-1+y)**6*(-163920-492156*y-917310*y**2-235388*y**3
          -8486*y**4+549869*y**5+1150987*y**6+94845*y**7-735577*y**8+345111*y**9
          +70611*y**10-6361*y**11+975*y**12)+r**18*(-4727232+27633048*y-65848962*y**2
          +78038645*y**3-37563349*y**4-15799703*y**5+33683897*y**6-21596963*y**7
          +7623825*y**8-1650401*y**9+236705*y**10-26570*y**11+3060*y**12)+r**8*(
          -1+y)**5*(182313+162138*y+160563*y**2-8466245*y**3+4967196*y**4-1749098*y**5
          +2653042*y**6-4589688*y**7+3010485*y**8-248276*y**9+143075*y**10-23935*y**11
          +3430*y**12)+2*r**14*(-1+y)**2*(1617392-108804*y-8614746*y**2-18736572*y**3
          +66533110*y**4-64518793*y**5+29829155*y**6-7862729*y**7+1511257*y**8
          -857625*y**9+291441*y**10-41541*y**11+5655*y**12)+r**10*(-1+y)**4*(
          -3458160+797604*y+1277304*y**2+19763863*y**3-25928953*y**4+13499218*y**5
          -9040658*y**6-5213524*y**7+8383892*y**8-2171642*y**9+364782*y**10-52551*y**11
          +7625*y**12)+r**12*(-1+y)**3*(18777887-37875900*y+11214162*y**2-3399048*y**3
          +50850901*y**4-44245318*y**5+1248176*y**6+77278*y**7+5714533*y**8-2971866*y**9
          +627486*y**10-78786*y**11+11295*y**12)+r**16*(13516129-78174547*y+180636963*y**2
          -203702172*y**3+76122053*y**4+96030827*y**5-161832897*y**6+110920519*y**7
          -40662678*y**8+8396932*y**9-1611666*y**10+420309*y**11-67272*y**12+7500*y**13))))/(4665600*logy**4*r**16*(
          -1+y)**8+1555200*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+194400*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+10800*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +225*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((mupi*(518400*logy**4*r**16*(3+4*r**2+9*r**4)*(-1+y)**8-8640*logy**3*r**12*(
          -1+y)**4*(80*r**12*(-1+y)**4-5*r**2*(-1+y)**4*(-24+283*y**3-180*y**4
          +6*y**5)+9*r**10*(-104+416*y-624*y**2+411*y**3-144*y**4+15*y**5)
          -5*r**8*(240-528*y-72*y**2+1019*y**3-686*y**4+69*y**5+42*y**6)-(
          -1+y)**4*(-16-195*y**3+870*y**4-714*y**5+160*y**6)-5*r**6*(-240+1152*y
          -2112*y**2+1756*y**3-496*y**4+69*y**5-136*y**6+61*y**7)+15*r**4*(48
          -240*y+456*y**2-292*y**3-116*y**4+213*y**5-62*y**6-13*y**7+6*y**8))
          +144*logy**2*r**8*(-1+y)**2*(-1+r**2+y)**2*(138*r**16*(-1+y)**6+r**14*(
          -1+y)**2*(-5244+20700*y-30360*y**2+20155*y**3-6460*y**4+819*y**5)
          -r**12*(-1+y)**2*(-19404+81804*y-126390*y**2+90185*y**3-45300*y**4
          +7159*y**5+486*y**6)+r**10*(128292-658668*y+1341612*y**2-1278693*y**3
          +565082*y**4-129552*y**5+50218*y**6-25577*y**7+8888*y**8-402*y**9)
          -r**2*(-1+y)**4*(-3036+804*y+804*y**2-20581*y**3+76354*y**4-74744*y**5
          +12266*y**6+15691*y**7-6424*y**8+366*y**9)-r**6*(-1+y)**2*(-9852+36828*y
          -41592*y**2+146723*y**3-533612*y**4+555297*y**5-238968*y**6+50917*y**7
          -8608*y**8+867*y**9)-(-1+y)**5*(-402-402*y-402*y**2-197*y**3+7393*y**4
          -1733*y**5-14333*y**6+22042*y**7-13538*y**8+3072*y**9)+r**4*(-1+y)**3*(
          -2484+96*y-234*y**2+75861*y**3+38141*y**4-277236*y**5+232024*y**6
          -49931*y**7-11161*y**8+3924*y**9)-5*r**8*(-37608+180732*y-339966*y**2
          +279745*y**3-82318*y**4+10722*y**5-9984*y**6-12481*y**7+14908*y**8
          -4014*y**9+264*y**10))+12*logy*r**4*(-1+y)**2*(-1+r**2+y)**3*(24*r**22*(
          -1+y)**6-r**20*(-1+y)**2*(-1280+5192*y-7968*y**2+6745*y**3-2344*y**4
          +621*y**5)+r**18*(-24672+147432*y-364680*y**2+494082*y**3-405123*y**4
          +211092*y**5-73114*y**6+19266*y**7-2603*y**8)+r**16*(28200-221640*y
          +674400*y**2-1113923*y**3+1132749*y**4-739743*y**5+294352*y**6-78393*y**7
          +16375*y**8-1497*y**9)+(-1+y)**7*(-264-1056*y-2640*y**2-4249*y**3
          -490*y**4+6488*y**5-1344*y**6+2595*y**7-2326*y**8-950*y**9+736*y**10)
          +r**14*(370672-1895376*y+3812376*y**2-3686700*y**3+2182926*y**4-1285104*y**5
          +668571*y**6-213516*y**7+103780*y**8-33056*y**9+3027*y**10)+r**2*(-1
          +y)**5*(4480+8168*y+11064*y**2+15706*y**3-69853*y**4-31233*y**5+129700*y**6
          -126154*y**7+52259*y**8-1477*y**9-6022*y**10+1362*y**11)+r**4*(-1+y)**4*(8928
          +5928*y-312*y**2+174691*y**3-181796*y**4+66070*y**5-250145*y**6+553447*y**7
          -498646*y**8+178336*y**9-22553*y**10+1452*y**11)+r**12*(1613856-7387488*y
          +12873384*y**2-8048594*y**3-1098618*y**4+4083270*y**5-3674633*y**6+2544051*y**7
          -1052476*y**8+295268*y**9-39081*y**10+1461*y**11)+r**8*(-1+y)**2*(-270128
          +444032*y-60168*y**2-1324350*y**3+1770396*y**4+1488078*y**5-2800179*y**6
          +1460403*y**7-277490*y**8-24696*y**9-7495*y**10+1797*y**11)+r**6*(-1
          +y)**3*(-94200+49080*y+12240*y**2+295172*y**3+1316490*y**4-2269854*y**5
          +586907*y**6+887025*y**7-741512*y**8+214660*y**9-37161*y**10+3153*y**11)
          +r**10*(946656-3712896*y+5197176*y**2-3468272*y**3+7602276*y**4-16938792*y**5
          +16581537*y**6-8576166*y**7+3108967*y**8-832636*y**9+85071*y**10+8714*y**11
          -1635*y**12))+(-1+r**2+y)**4*(13*r**28*(-1+y)**8+r**26*(-1+y)**4*(
          -416+1612*y-2288*y**2+1485*y**3-464*y**4+77*y**5)+r**24*(-1+y)**2*(9025
          -52250*y+124249*y**2-157937*y**3+116049*y**4-49766*y**5+12761*y**6
          -1639*y**7+132*y**8)-r**22*(73944-572712*y+1916940*y**2-3620710*y**3
          +4254876*y**4-3249379*y**5+1642532*y**6-550925*y**7+119420*y**8-13501*y**9
          +80*y**10+155*y**11)+r**20*(119097-971904*y+3385980*y**2-6347806*y**3
          +6787365*y**4-3838681*y**5+382614*y**6+1138375*y**7-972019*y**8+390245*y**9
          -79306*y**10+9995*y**11-1075*y**12)-(-1+y)**9*(-17-85*y-255*y**2
          -744*y**3-549*y**4+567*y**5-405*y**6+435*y**7-136*y**8-286*y**9+200*y**10
          +65*y**11+10*y**12)+r**18*(-25800+49284*y+335148*y**2-3495329*y**3
          +12940800*y**4-25476086*y**5+30224972*y**6-23384380*y**7+12701368*y**8
          -5042510*y**9+1371136*y**10-226931*y**11+27032*y**12-2304*y**13)-r**2*(
          -1+y)**8*(-664-2588*y-6300*y**2-15641*y**3+376*y**4+23236*y**5-18832*y**6
          +13280*y**7-7904*y**8-3426*y**9+5388*y**10-135*y**11+10*y**13)-r**4*(
          -1+y)**7*(-1805-5995*y-11736*y**2-109686*y**3+7049*y**4+27452*y**5
          -70533*y**6+108457*y**7+57428*y**8-73114*y**9-5907*y**10+18933*y**11
          -656*y**12+113*y**13)-r**6*(-1+y)**6*(68664+91368*y+99780*y**2-606854*y**3
          -697380*y**4-204401*y**5+1840834*y**6-2004080*y**7+1166786*y**8-294190*y**9
          -45878*y**10+60878*y**11-4070*y**12+543*y**13)-r**8*(-1+y)**5*(478467
          +142635*y-38397*y**2-756188*y**3-3555685*y**4+2618272*y**5+367280*y**6
          +776498*y**7-3079749*y**8+1841725*y**9-372319*y**10+111270*y**11-12501*y**12
          +1492*y**13)-2*r**14*(-1+y)**2*(-2566280+9638840*y-12371676*y**2+3669046*y**3
          -7406856*y**4+21374713*y**5-19897636*y**6+10927172*y**7-5193534*y**8
          +1646376*y**9-517368*y**10+129666*y**11-20466*y**12+1803*y**13)-r**10*(
          -1+y)**4*(817200-447636*y-622536*y**2+1778005*y**3+3945712*y**4-12727609*y**5
          +6097180*y**6+4143886*y**7-8468280*y**8+4667258*y**9-1086236*y**10+202941*y**11
          -24560*y**12+2675*y**13)-r**12*(-1+y)**3*(481735-61363*y-1370202*y**2
          -5515178*y**3+20888997*y**4-11259875*y**5-7189006*y**6+8530922*y**7
          -6773877*y**8+3667953*y**9-1289700*y**10+273084*y**11-35355*y**12+3465*y**13)
          +r**16*(3060685-20091332*y+54935374*y**2-73025687*y**3+34051265*y**4
          +36718666*y**5-79800104*y**6+77414256*y**7-50081609*y**8+22347546*y**9
          -6881406*y**10+1612071*y**11-298365*y**12+41856*y**13-3216*y**14))))/(4665600*logy**4*r**16*(
          -1+y)**8+1555200*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+194400*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+10800*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +225*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*muWC**2*(-4147200*logy**4*r**16*(-3+2*r**2+9*r**4)*(-1+y)**8-69120*logy**3*r**12*(
          -1+y)**4*(23*r**12*(-1+y)**4+15*r**10*(52-208*y+312*y**2-187*y**3
          +34*y**4+6*y**5)+r**2*(-1+y)**4*(252+235*y**3-450*y**4+78*y**5)+5*(
          -1+y)**4*(11+30*y**3+15*y**4-48*y**5+16*y**6)+5*r**8*(189-324*y
          -378*y**2+1288*y**3-919*y**4+147*y**5+39*y**6)+5*r**6*(-408+1728*y
          -2784*y**2+2030*y**3-464*y**4-78*y**5-32*y**6+35*y**7)+15*r**4*(-1
          -44*y+162*y**2-302*y**3+368*y**4-291*y**5+141*y**6-36*y**7+3*y**8))
          +1152*logy**2*r**8*(-1+y)**2*(-1+r**2+y)**2*(321*r**16*(-1+y)**6-r**14*(
          -1+y)**2*(438-1110*y+60*y**2+3425*y**3-5300*y**4+2292*y**5)-r**12*(
          -1+y)**2*(39162-152742*y+220455*y**2-137770*y**3+44940*y**4-10997*y**5
          +2682*y**6)+r**2*(-1+y)**4*(1542-378*y-378*y**2-7553*y**3+30332*y**4
          -36352*y**5+4918*y**6+15443*y**7-7982*y**8+1158*y**9)+(-1+y)**5*(189
          +189*y+189*y**2-2881*y**3+4469*y**4-1759*y**5-2059*y**6+6341*y**7
          -5464*y**8+1536*y**9)+r**10*(-94806+498714*y-1066806*y**2+1046889*y**3
          -347356*y**4-122154*y**5+77746*y**6+26836*y**7-22264*y**8+2601*y**9)
          -r**4*(-1+y)**3*(28218-35412*y+4383*y**2+81693*y**3-128087*y**4+37872*y**5
          +32147*y**6-9628*y**7-9743*y**8+3057*y**9)-r**6*(-1+y)**2*(-25734+57486*y
          -48024*y**2+44291*y**3+75946*y**4-147426*y**5+68184*y**6+8824*y**7
          -16186*y**8+3639*y**9)+5*r**8*(-18804+73794*y-95409*y**2-20062*y**3
          +169456*y**4-168654*y**5+82320*y**6-34967*y**7+16331*y**8-4347*y**9
          +342*y**10))-96*logy*r**4*(-1+y)**2*(-1+r**2+y)**3*(-27*r**22*(-1+y)**6
          +r**20*(-1+y)**2*(-221+965*y-1650*y**2+691*y**3-475*y**4+207*y**5)
          +r**18*(-23571+134466*y-315819*y**2+401559*y**3-302286*y**4+134904*y**5
          -30689*y**6+2475*y**7-199*y**8)+r**16*(195675-1099785*y+2512401*y**2
          -2941747*y**3+1791927*y**4-480054*y**5+18761*y**6-16320*y**7+15938*y**8
          -1356*y**9)+(-1+y)**7*(-171-684*y-1710*y**2-2762*y**3+850*y**4+6688*y**5
          -3546*y**6+1050*y**7-443*y**8-640*y**9+368*y**10)+r**14*(564326-2958828*y
          +6293274*y**2-6708894*y**3+4041996*y**4-1965687*y**5+1147683*y**6-482634*y**7
          +78434*y**8+3179*y**9+951*y**10)-r**8*(-1+y)**2*(514054-863806*y+309120*y**2
          +1188990*y**3-3360126*y**4+2794563*y**5-515538*y**6-520560*y**7+233080*y**8
          +32361*y**9-12262*y**10+24*y**11)-r**6*(-1+y)**3*(-134475+75945*y
          +39879*y**2-69871*y**3-515532*y**4+821025*y**5-145576*y**6-478029*y**7
          +351811*y**8-53498*y**9-2835*y**10+156*y**11)+r**4*(-1+y)**4*(15699
          +7539*y+2673*y**2-18712*y**3-58900*y**4+70028*y**5+111350*y**6-82183*y**7
          -78443*y**8+58655*y**9-11107*y**10+1101*y**11)+r**2*(-1+y)**5*(1379
          +2245*y+2598*y**2+16613*y**3-45572*y**4-10005*y**5+85148*y**6-91583*y**7
          +34177*y**8+4312*y**9-6434*y**10+1122*y**11)+r**12*(404106-1415142*y
          +1520658*y**2+3028778*y**3-8645322*y**4+7760541*y**5-3132058*y**6+608832*y**7
          -167768*y**8+122527*y**9-34872*y**10+4920*y**11)+r**10*(876150-3203244*y
          +3787398*y**2+646628*y**3-4253394*y**4+2320047*y**5-745251*y**6+1332627*y**7
          -973093*y**8+198889*y**9+33033*y**10-23315*y**11+3525*y**12))-8*(-1
          +r**2+y)**4*(8*r**28*(-1+y)**8+r**26*(-1+y)**4*(-250+968*y-1372*y**2
          +891*y**3-280*y**4+46*y**5)+r**24*(-1+y)**2*(2750-15856*y+37304*y**2
          -47728*y**3+36822*y**4-17497*y**5+5401*y**6-959*y**7+75*y**8)-r**22*(47460
          -366672*y+1227348*y**2-2333444*y**3+2799876*y**4-2243282*y**5+1241416*y**6
          -478597*y**7+122740*y**8-16760*y**9+208*y**10+67*y**11)+r**20*(28812
          -336516*y+1501698*y**2-3416318*y**3+4557696*y**4-4000739*y**5+2686629*y**6
          -1530718*y**7+651568*y**8-148571*y**9+4627*y**10+3622*y**11-350*y**12)
          -2*(-1+y)**9*(-5-25*y-75*y**2-240*y**3-45*y**4+495*y**5-621*y**6
          -24*y**7+410*y**8-280*y**9+80*y**10+26*y**11+4*y**12)+r**18*(2065962
          -14400864*y+42563772*y**2-69032569*y**3+65495484*y**4-34648768*y**5
          +7191808*y**6+1557916*y**7-565942*y**8-431014*y**9+240116*y**10-43339*y**11
          +5872*y**12-234*y**13)-r**2*(-1+y)**8*(-374-1456*y-3540*y**2-10069*y**3
          +5756*y**4+22892*y**5-34568*y**6+12406*y**7+7322*y**8-9906*y**9+4932*y**10
          -21*y**11+24*y**12+2*y**13)-r**4*(-1+y)**7*(860+1984*y+3702*y**2
          -73560*y**3+7438*y**4-7547*y**5-49560*y**6+96059*y**7+35350*y**8-68423*y**9
          +16422*y**10+7341*y**11-76*y**12+10*y**13)+r**6*(-1+y)**6*(-23844-28296*y
          -25272*y**2+225940*y**3+439584*y**4+110686*y**5-1052600*y**6+1148665*y**7
          -640966*y**8+116861*y**9+19468*y**10-26509*y**11+262*y**12+21*y**13)
          +r**8*(-1+y)**5*(-269970-5598*y+79056*y**2+1459948*y**3+1089824*y**4
          -1648679*y**5-2980414*y**6+4634228*y**7-1367496*y**8-309794*y**9+84974*y**10
          -26988*y**11-774*y**12+283*y**13)+2*r**14*(-1+y)**2*(1283140-4654024*y
          +5606952*y**2+8259544*y**3-26734560*y**4+27243922*y**5-14853676*y**6
          +4977512*y**7-1161594*y**8+443295*y**9-150492*y**10+35940*y**11-3654*y**12
          +795*y**13)+2*r**12*(-1+y)**3*(-961288+1637284*y+426774*y**2+3358268*y**3
          -16519374*y**4+16786373*y**5-4449944*y**6-532940*y**7-249186*y**8+668379*y**9
          -299790*y**10+51240*y**11-4524*y**12+828*y**13)+r**10*(-1+y)**4*(-2487462
          +2429208*y+685476*y**2+1605241*y**3-4164644*y**4+3191210*y**5-2253776*y**6
          +2979280*y**7-979806*y**8-2716*y**9-168428*y**10+31203*y**11-4736*y**12
          +950*y**13)+2*r**16*(-75683+922912*y-3477140*y**2+7533703*y**3-8435353*y**4
          -297575*y**5+12813937*y**6-15024378*y**7+7237951*y**8-841458*y**9-532602*y**10
          +188631*y**11-13227*y**12-39*y**13+321*y**14))))/(13996800*logy**4*r**16*(
          -1+y)**8+4665600*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+583200*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+32400*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +675*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*muWC**3*(-4147200*logy**4*r**12*(15+34*r**2+36*r**4+26*r**6+9*r**8)*(
          -1+y)**9-69120*logy**3*r**8*(-1+y)**4*(58*r**16*(-1+y)**5+3*(-1+y)**6*(
          -11-11*y-11*y**2+79*y**3-56*y**4+20*y**5)-10*r**2*(-1+y)**5*(69
          -115*y**3+63*y**4-30*y**5+4*y**6)+3*r**14*(-344+1720*y-3440*y**2
          +3185*y**3-1525*y**4+269*y**5+15*y**6)+3*r**6*(-1+y)**3*(-1436+5592*y
          -5516*y**2+1185*y**3-90*y**4+521*y**5-152*y**6+26*y**7)+5*r**12*(-291
          +1023*y-966*y**2-729*y**3+1466*y**4-700*y**5+49*y**6+36*y**7)+r**4*(
          -1+y)**4*(5327-8927*y+1800*y**2+2435*y**3-1470*y**4+1303*y**5-458*y**6
          +80*y**7)+5*r**8*(-417+357*y+3606*y**2-8956*y**3+8121*y**4-3018*y**5
          +409*y**6-213*y**7+111*y**8)+r**10*(-5662+22070*y-28540*y**2+7610*y**3
          +10880*y**4-8233*y**5+1635*y**6-345*y**7+225*y**8))+1152*logy**2*r**4*(
          -1+y)**2*(436*r**24*(-1+y)**7-r**22*(-1+y)**2*(396-1980*y+3960*y**2
          -6335*y**3+11575*y**4-10511*y**5+3415*y**6)+(-1+y)**10*(-219-657*y
          -1314*y**2+70*y**3+2585*y**4+4719*y**5-6128*y**6+1544*y**7)-r**20*(
          -1+y)**2*(-80751+393315*y-760530*y**2+724845*y**3-404420*y**4+153286*y**5
          -52245*y**6+11220*y**7)+2*r**2*(-1+y)**9*(-267-534*y-801*y**2-1138*y**3
          +6075*y**4+4972*y**5-8831*y**6+1916*y**7+8*y**8)+5*r**6*(-1+y)**7*(
          -29168+24840*y+12420*y**2+27333*y**3-48556*y**4+6798*y**5+16620*y**6
          -7225*y**7-2588*y**8+846*y**9)+r**4*(-1+y)**8*(3999+9939*y+12909*y**2
          +11094*y**3-40896*y**4+7326*y**5+20796*y**6-15389*y**7-2514*y**8+1536*y**9)
          +5*r**8*(-1+y)**5*(-111018+413808*y-463476*y**2+53300*y**3+244024*y**4
          -187379*y**5+64886*y**6-17852*y**7+9050*y**8-3861*y**9+138*y**10)-5*r**18*(9078
          -100698*y+432126*y**2-1036150*y**3+1468086*y**4-1261211*y**5+675029*y**6
          -230838*y**7+52600*y**8-9799*y**9+1457*y**10)+r**14*(-1+y)**2*(613212
          -2046900*y+2107500*y**2-981730*y**3+1009850*y**4-1440319*y**5+1217815*y**6
          -618510*y**7+200670*y**8-43585*y**9+2997*y**10)-r**12*(-1+y)**3*(-1023438
          +4469052*y-6676578*y**2+3870162*y**3-1191558*y**4+1313853*y**5-1299822*y**6
          +507558*y**7-47632*y**8-19937*y**9+7640*y**10)-r**10*(-1+y)**4*(476232
          -653256*y-1244304*y**2+2787328*y**3-2366200*y**4+1653573*y**5-1074339*y**6
          +441364*y**7-76288*y**8-11605*y**9+8095*y**10)+5*r**16*(29337-152979*y
          +314487*y**2-343217*y**3+345813*y**4-425362*y**5+334258*y**6-84297*y**7
          -50638*y**8+43417*y**9-11745*y**10+926*y**11))+96*logy*(-1+y)**2*(
          -1+r**2+y)**2*(130*r**28*(-1+y)**7+r**26*(-1+y)**2*(2164-10560*y+20340*y**2
          -22689*y**3+13049*y**4-4405*y**5+813*y**6)-(-1+y)**10*(9+45*y+135*y**2
          +161*y**3-85*y**4-529*y**5+885*y**6+215*y**7-1096*y**8+460*y**9)+r**24*(
          -64773+438879*y-1264131*y**2+2050676*y**3-2072802*y**4+1361785*y**5
          -586897*y**6+166868*y**7-30989*y**8+3624*y**9)-2*r**2*(-1+y)**9*(104
          +407*y+995*y**2+382*y**3-3171*y**4-7191*y**5+7613*y**6-180*y**7-2617*y**8
          +1066*y**9+92*y**10)+r**22*(443924-3012422*y+8668506*y**2-13790909*y**3
          +13208559*y**4-7839994*y**5+2945410*y**6-824123*y**7+242797*y**8-59056*y**9
          +5148*y**10)+r**20*(758172-4181950*y+9013213*y**2-8054650*y**3+1268036*y**4
          +1922405*y**5+123063*y**6-1595678*y**7+973840*y**8-197371*y**9+11908*y**10
          -4188*y**11)-2*r**14*(-1+y)**2*(-3367436+8630546*y-2786566*y**2-8046775*y**3
          +8959939*y**4-5821469*y**5+3949433*y**6-2396016*y**7+604700*y**8+299771*y**9
          -164275*y**10+15451*y**11+297*y**12)-r**4*(-1+y)**7*(13976+23094*y
          +29955*y**2-101879*y**3-63110*y**4-44783*y**5+434610*y**6-404743*y**7
          +105154*y**8+22005*y**9-15553*y**10+2506*y**11+368*y**12)+2*r**12*(
          -1+y)**3*(4506841-16750982*y+20891725*y**2-7446347*y**3-3968579*y**4
          +4966817*y**5-1855810*y**6-546014*y**7+681597*y**8-243531*y**9+59797*y**10
          -8863*y**11+649*y**12)-r**6*(-1+y)**6*(96812+66158*y+46598*y**2-484553*y**3
          -248131*y**4+248965*y**5+1294611*y**6-1450793*y**7+405573*y**8+74301*y**9
          -48457*y**10+3826*y**11+1490*y**12)-r**10*(-1+y)**4*(2538988-6165708*y
          +3201648*y**2-229739*y**3+3578197*y**4-4756542*y**5-1060366*y**6+4923174*y**7
          -2248406*y**8-137122*y**9+213074*y**10-27311*y**11+1713*y**12)-r**8*(
          -1+y)**5*(41229-59434*y-3883*y**2-677213*y**3+1292534*y**4-948426*y**5
          +4150*y**6+751966*y**7-391127*y**8-75064*y**9+73117*y**10-13381*y**11
          +2532*y**12)-2*r**18*(503212-3741287*y+11546356*y**2-21971844*y**3
          +25057312*y**4-17393798*y**5+9516710*y**6-5886702*y**7+3347694*y**8
          -1371347*y**9+379586*y**10-68718*y**11+8026*y**12)+r**16*(4726273-26284321*y
          +58417236*y**2-67421532*y**3+48745730*y**4-30075498*y**5+19753926*y**6
          -13878134*y**7+9526149*y**8-4645005*y**9+1446210*y**10-396410*y**11
          +97228*y**12-11852*y**13))-8*(-1+r**2+y)**3*(51*r**30*(-1+y)**9+r**28*(
          -1+y)**4*(1541-7552*y+14645*y**2-14401*y**3+7700*y**4-2293*y**5+352*y**6)
          +r**26*(-1+y)**2*(-19049+130433*y-379185*y**2+618041*y**3-625496*y**4
          +412140*y**5-182411*y**6+53215*y**7-9371*y**8+851*y**9)-(-1+y)**11*(449
          +2137*y+6141*y**2+6680*y**3+1431*y**4-6305*y**5+28147*y**6-2517*y**7
          -37270*y**8+19204*y**9-1244*y**10-79*y**11+26*y**12)+r**24*(167855
          -1482426*y+5780109*y**2-13099747*y**3+19241118*y**4-19402569*y**5+13897021*y**6
          -7194877*y**7+2689240*y**8-703661*y**9+119430*y**10-10880*y**11+347*y**12)
          -r**2*(-1+y)**10*(11687+43013*y+99713*y**2+19127*y**3-149871*y**4
          -282945*y**5+511099*y**6-140197*y**7-265324*y**8+159886*y**9-11992*y**10
          -822*y**11+224*y**12+2*y**13)-r**22*(272663-2755947*y+12122646*y**2
          -30055346*y**3+46941297*y**4-49358493*y**5+36680475*y**6-19917165*y**7
          +7898154*y**8-2116432*y**9+277855*y**10+29047*y**11-17266*y**12+2352*y**13)
          +r**20*(-3581695+28028136*y-94503687*y**2+181109727*y**3-217270670*y**4
          +169074459*y**5-86898757*y**6+33502646*y**7-16298193*y**8+11069958*y**9
          -5750799*y**10+1862531*y**11-393034*y**12+59151*y**13-4973*y**14)-r**4*(
          -1+y)**8*(128629+120872*y+83781*y**2-879613*y**3+43490*y**4-19225*y**5
          +3078625*y**6-3656018*y**7+1487459*y**8-461738*y**9+127801*y**10+583*y**11
          +5462*y**12+659*y**13+33*y**14)-r**6*(-1+y)**7*(1725187+313942*y-166787*y**2
          -8139920*y**3+2318631*y**4+4324314*y**5+16295318*y**6-25487544*y**7
          +9437339*y**8+562070*y**9-850561*y**10+93440*y**11+34011*y**12+1266*y**13
          +94*y**14)+r**8*(-1+y)**6*(-5638483+4259064*y+1763112*y**2+20872371*y**3
          -33170445*y**4+6351816*y**5-11772027*y**6+27318032*y**7-13277667*y**8
          +811178*y**9+821932*y**10-119587*y**11-50309*y**12-5274*y**13+287*y**14)
          +r**10*(-1+y)**5*(-31306597+74430838*y-43016424*y**2+24253730*y**3
          -83289790*y**4+71492750*y**5-838513*y**6-27702556*y**7+11797911*y**8
          +1353194*y**9-500778*y**10-300310*y**11+53780*y**12-21486*y**13+2251*y**14)
          +r**16*(-1+y)**2*(2901987-17030520*y+40178052*y**2-48045591*y**3-18324835*y**4
          +92987992*y**5-62464774*y**6-2037256*y**7+17055253*y**8-8822442*y**9
          +2519676*y**10-481201*y**11+73419*y**12-2742*y**13+2982*y**14)+r**12*(
          -1+y)**4*(6276975-69922584*y+167343243*y**2-103210203*y**3-95594710*y**4
          +157778861*y**5-45517908*y**6-54177366*y**7+43970907*y**8-11524686*y**9
          +3636739*y**10-1545743*y**11+311508*y**12-47079*y**13+5646*y**14)+r**14*(
          -1+y)**3*(34806201-146699358*y+222767835*y**2-128220228*y**3-56481639*y**4
          +155124798*y**5-86735203*y**6-23826040*y**7+45175491*y**8-23793370*y**9
          +9129061*y**10-2526004*y**11+429075*y**12-49158*y**13+6939*y**14)+r**18*(2077867
          -21260901*y+91531038*y**2-239495262*y**3+411217548*y**4-465077004*y**5
          +344473484*y**6-171477338*y**7+70755813*y**8-38164971*y**9+23332548*y**10
          -10242748*y**11+2733060*y**12-456676*y**13+56578*y**14-3036*y**15))))/(41990400*logy**4*r**16*(
          -1+y)**9+13996800*logy**3*r**12*(-1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+1749600*logy**2*r**8*(-1+y)**5*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+97200*logy*r**4*(
          -1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +2025*(-1+y)*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1
          +y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y
          -y**2+y**3))**4))
      resNP += ((rhoD*(518400*logy**4*r**12*(15+34*r**2+36*r**4+26*r**6
          +9*r**8)*(-1+y)**9+8640*logy**3*r**8*(-1+y)**4*(58*r**16*(-1+y)**5+3*(
          -1+y)**6*(-11-11*y-11*y**2+79*y**3-56*y**4+20*y**5)-10*r**2*(-1
          +y)**5*(69-115*y**3+63*y**4-30*y**5+4*y**6)+3*r**14*(-344+1720*y
          -3440*y**2+3185*y**3-1525*y**4+269*y**5+15*y**6)+3*r**6*(-1+y)**3*(
          -1436+5592*y-5516*y**2+1185*y**3-90*y**4+521*y**5-152*y**6+26*y**7)
          +5*r**12*(-291+1023*y-966*y**2-729*y**3+1466*y**4-700*y**5+49*y**6
          +36*y**7)+r**4*(-1+y)**4*(5327-8927*y+1800*y**2+2435*y**3-1470*y**4
          +1303*y**5-458*y**6+80*y**7)+5*r**8*(-417+357*y+3606*y**2-8956*y**3
          +8121*y**4-3018*y**5+409*y**6-213*y**7+111*y**8)+r**10*(-5662+22070*y
          -28540*y**2+7610*y**3+10880*y**4-8233*y**5+1635*y**6-345*y**7+225*y**8))
          -144*logy**2*r**4*(-1+y)**2*(436*r**24*(-1+y)**7-r**22*(-1+y)**2*(396
          -1980*y+3960*y**2-6335*y**3+11575*y**4-10511*y**5+3415*y**6)+(-1
          +y)**10*(-219-657*y-1314*y**2+70*y**3+2585*y**4+4719*y**5-6128*y**6
          +1544*y**7)-r**20*(-1+y)**2*(-80751+393315*y-760530*y**2+724845*y**3
          -404420*y**4+153286*y**5-52245*y**6+11220*y**7)+2*r**2*(-1+y)**9*(-267
          -534*y-801*y**2-1138*y**3+6075*y**4+4972*y**5-8831*y**6+1916*y**7
          +8*y**8)+5*r**6*(-1+y)**7*(-29168+24840*y+12420*y**2+27333*y**3-48556*y**4
          +6798*y**5+16620*y**6-7225*y**7-2588*y**8+846*y**9)+r**4*(-1+y)**8*(3999
          +9939*y+12909*y**2+11094*y**3-40896*y**4+7326*y**5+20796*y**6-15389*y**7
          -2514*y**8+1536*y**9)+5*r**8*(-1+y)**5*(-111018+413808*y-463476*y**2
          +53300*y**3+244024*y**4-187379*y**5+64886*y**6-17852*y**7+9050*y**8
          -3861*y**9+138*y**10)-5*r**18*(9078-100698*y+432126*y**2-1036150*y**3
          +1468086*y**4-1261211*y**5+675029*y**6-230838*y**7+52600*y**8-9799*y**9
          +1457*y**10)+r**14*(-1+y)**2*(613212-2046900*y+2107500*y**2-981730*y**3
          +1009850*y**4-1440319*y**5+1217815*y**6-618510*y**7+200670*y**8-43585*y**9
          +2997*y**10)-r**12*(-1+y)**3*(-1023438+4469052*y-6676578*y**2+3870162*y**3
          -1191558*y**4+1313853*y**5-1299822*y**6+507558*y**7-47632*y**8-19937*y**9
          +7640*y**10)-r**10*(-1+y)**4*(476232-653256*y-1244304*y**2+2787328*y**3
          -2366200*y**4+1653573*y**5-1074339*y**6+441364*y**7-76288*y**8-11605*y**9
          +8095*y**10)+5*r**16*(29337-152979*y+314487*y**2-343217*y**3+345813*y**4
          -425362*y**5+334258*y**6-84297*y**7-50638*y**8+43417*y**9-11745*y**10
          +926*y**11))-12*logy*(-1+y)**2*(-1+r**2+y)**2*(130*r**28*(-1+y)**7
          +r**26*(-1+y)**2*(2164-10560*y+20340*y**2-22689*y**3+13049*y**4-4405*y**5
          +813*y**6)-(-1+y)**10*(9+45*y+135*y**2+161*y**3-85*y**4-529*y**5
          +885*y**6+215*y**7-1096*y**8+460*y**9)+r**24*(-64773+438879*y-1264131*y**2
          +2050676*y**3-2072802*y**4+1361785*y**5-586897*y**6+166868*y**7-30989*y**8
          +3624*y**9)-2*r**2*(-1+y)**9*(104+407*y+995*y**2+382*y**3-3171*y**4
          -7191*y**5+7613*y**6-180*y**7-2617*y**8+1066*y**9+92*y**10)+r**22*(443924
          -3012422*y+8668506*y**2-13790909*y**3+13208559*y**4-7839994*y**5+2945410*y**6
          -824123*y**7+242797*y**8-59056*y**9+5148*y**10)+r**20*(758172-4181950*y
          +9013213*y**2-8054650*y**3+1268036*y**4+1922405*y**5+123063*y**6-1595678*y**7
          +973840*y**8-197371*y**9+11908*y**10-4188*y**11)-2*r**14*(-1+y)**2*(
          -3367436+8630546*y-2786566*y**2-8046775*y**3+8959939*y**4-5821469*y**5
          +3949433*y**6-2396016*y**7+604700*y**8+299771*y**9-164275*y**10+15451*y**11
          +297*y**12)-r**4*(-1+y)**7*(13976+23094*y+29955*y**2-101879*y**3-63110*y**4
          -44783*y**5+434610*y**6-404743*y**7+105154*y**8+22005*y**9-15553*y**10
          +2506*y**11+368*y**12)+2*r**12*(-1+y)**3*(4506841-16750982*y+20891725*y**2
          -7446347*y**3-3968579*y**4+4966817*y**5-1855810*y**6-546014*y**7+681597*y**8
          -243531*y**9+59797*y**10-8863*y**11+649*y**12)-r**6*(-1+y)**6*(96812
          +66158*y+46598*y**2-484553*y**3-248131*y**4+248965*y**5+1294611*y**6
          -1450793*y**7+405573*y**8+74301*y**9-48457*y**10+3826*y**11+1490*y**12)
          -r**10*(-1+y)**4*(2538988-6165708*y+3201648*y**2-229739*y**3+3578197*y**4
          -4756542*y**5-1060366*y**6+4923174*y**7-2248406*y**8-137122*y**9+213074*y**10
          -27311*y**11+1713*y**12)-r**8*(-1+y)**5*(41229-59434*y-3883*y**2-677213*y**3
          +1292534*y**4-948426*y**5+4150*y**6+751966*y**7-391127*y**8-75064*y**9
          +73117*y**10-13381*y**11+2532*y**12)-2*r**18*(503212-3741287*y+11546356*y**2
          -21971844*y**3+25057312*y**4-17393798*y**5+9516710*y**6-5886702*y**7
          +3347694*y**8-1371347*y**9+379586*y**10-68718*y**11+8026*y**12)+r**16*(4726273
          -26284321*y+58417236*y**2-67421532*y**3+48745730*y**4-30075498*y**5
          +19753926*y**6-13878134*y**7+9526149*y**8-4645005*y**9+1446210*y**10
          -396410*y**11+97228*y**12-11852*y**13))+(-1+r**2+y)**3*(51*r**30*(-1
          +y)**9+r**28*(-1+y)**4*(1541-7552*y+14645*y**2-14401*y**3+7700*y**4
          -2293*y**5+352*y**6)+r**26*(-1+y)**2*(-19049+130433*y-379185*y**2
          +618041*y**3-625496*y**4+412140*y**5-182411*y**6+53215*y**7-9371*y**8
          +851*y**9)-(-1+y)**11*(449+2137*y+6141*y**2+6680*y**3+1431*y**4
          -6305*y**5+28147*y**6-2517*y**7-37270*y**8+19204*y**9-1244*y**10-79*y**11
          +26*y**12)+r**24*(167855-1482426*y+5780109*y**2-13099747*y**3+19241118*y**4
          -19402569*y**5+13897021*y**6-7194877*y**7+2689240*y**8-703661*y**9+119430*y**10
          -10880*y**11+347*y**12)-r**2*(-1+y)**10*(11687+43013*y+99713*y**2
          +19127*y**3-149871*y**4-282945*y**5+511099*y**6-140197*y**7-265324*y**8
          +159886*y**9-11992*y**10-822*y**11+224*y**12+2*y**13)-r**22*(272663
          -2755947*y+12122646*y**2-30055346*y**3+46941297*y**4-49358493*y**5
          +36680475*y**6-19917165*y**7+7898154*y**8-2116432*y**9+277855*y**10
          +29047*y**11-17266*y**12+2352*y**13)+r**20*(-3581695+28028136*y-94503687*y**2
          +181109727*y**3-217270670*y**4+169074459*y**5-86898757*y**6+33502646*y**7
          -16298193*y**8+11069958*y**9-5750799*y**10+1862531*y**11-393034*y**12
          +59151*y**13-4973*y**14)-r**4*(-1+y)**8*(128629+120872*y+83781*y**2
          -879613*y**3+43490*y**4-19225*y**5+3078625*y**6-3656018*y**7+1487459*y**8
          -461738*y**9+127801*y**10+583*y**11+5462*y**12+659*y**13+33*y**14)
          -r**6*(-1+y)**7*(1725187+313942*y-166787*y**2-8139920*y**3+2318631*y**4
          +4324314*y**5+16295318*y**6-25487544*y**7+9437339*y**8+562070*y**9-850561*y**10
          +93440*y**11+34011*y**12+1266*y**13+94*y**14)+r**8*(-1+y)**6*(-5638483
          +4259064*y+1763112*y**2+20872371*y**3-33170445*y**4+6351816*y**5-11772027*y**6
          +27318032*y**7-13277667*y**8+811178*y**9+821932*y**10-119587*y**11-50309*y**12
          -5274*y**13+287*y**14)+r**10*(-1+y)**5*(-31306597+74430838*y-43016424*y**2
          +24253730*y**3-83289790*y**4+71492750*y**5-838513*y**6-27702556*y**7
          +11797911*y**8+1353194*y**9-500778*y**10-300310*y**11+53780*y**12-21486*y**13
          +2251*y**14)+r**16*(-1+y)**2*(2901987-17030520*y+40178052*y**2-48045591*y**3
          -18324835*y**4+92987992*y**5-62464774*y**6-2037256*y**7+17055253*y**8
          -8822442*y**9+2519676*y**10-481201*y**11+73419*y**12-2742*y**13+2982*y**14)
          +r**12*(-1+y)**4*(6276975-69922584*y+167343243*y**2-103210203*y**3
          -95594710*y**4+157778861*y**5-45517908*y**6-54177366*y**7+43970907*y**8
          -11524686*y**9+3636739*y**10-1545743*y**11+311508*y**12-47079*y**13
          +5646*y**14)+r**14*(-1+y)**3*(34806201-146699358*y+222767835*y**2-128220228*y**3
          -56481639*y**4+155124798*y**5-86735203*y**6-23826040*y**7+45175491*y**8
          -23793370*y**9+9129061*y**10-2526004*y**11+429075*y**12-49158*y**13
          +6939*y**14)+r**18*(2077867-21260901*y+91531038*y**2-239495262*y**3
          +411217548*y**4-465077004*y**5+344473484*y**6-171477338*y**7+70755813*y**8
          -38164971*y**9+23332548*y**10-10242748*y**11+2733060*y**12-456676*y**13
          +56578*y**14-3036*y**15))))/(4665600*logy**4*r**16*(-1+y)**9+1555200*logy**3*r**12*(
          -1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +194400*logy**2*r**8*(-1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+10800*logy*r**4*(-1+y)**3*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+225*(-1+y)*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((rhoLS*(518400*logy**4*r**14*(-3+27*r**2
          +11*r**4+9*r**6)*(-1+y)**8-8640*logy**3*r**10*(-1+y)**4*(292*r**14*(-1
          +y)**4-3*(-1+y)**5*(-37-37*y-37*y**2+173*y**3-112*y**4+20*y**5)
          +15*r**12*(-85+340*y-510*y**2+409*y**3-157*y**4+21*y**5)+r**10*(-1854
          +5256*y-3564*y**2-389*y**3+1046*y**4+255*y**5-330*y**6)-5*r**2*(-1
          +y)**4*(14-237*y**3+270*y**4-102*y**5+16*y**6)-5*r**8*(453-1284*y
          +870*y**2+254*y**3-341*y**4-45*y**5-14*y**6+53*y**7)-r**4*(-1+y)**2*(
          -2403+4086*y-1323*y**2+2455*y**3-6665*y**4+4693*y**5-1011*y**6+78*y**7)
          +15*r**6*(192-1200*y+2664*y**2-2828*y**3+1548*y**4-511*y**5+208*y**6
          -79*y**7+6*y**8))+144*logy**2*r**6*(-1+y)**2*(-1+r**2+y)**2*(1074*r**18*(
          -1+y)**6-r**16*(-1+y)**2*(16503-63864*y+90426*y**2-51899*y**3+4031*y**4
          +4413*y**5)-r**14*(-1+y)**2*(23640-72858*y+78090*y**2-9275*y**3-690*y**4
          -12145*y**5+4698*y**6)+3*(-1+y)**6*(253+506*y+759*y**2-688*y**3
          -205*y**4-658*y**5+889*y**6-264*y**7+8*y**8)-r**2*(-1+y)**5*(-7758
          -6240*y-4722*y**2+37841*y**3-28921*y**4+2723*y**5+5*y**6+9662*y**7
          -7426*y**8+1536*y**9)+r**12*(209478-1054350*y+2051307*y**2-2124681*y**3
          +1297531*y**4-407418*y**5-2365*y**6+37703*y**7-11159*y**8+2754*y**9)
          +r**10*(456636-2445594*y+5292216*y**2-6447259*y**3+5288026*y**4-3250596*y**5
          +1487544*y**6-433691*y**7+42734*y**8+12324*y**9-2340*y**10)-r**4*(-1
          +y)**3*(-33990+39972*y-7713*y**2+217532*y**3-529228*y**4+476817*y**5
          -207287*y**6+39098*y**7+12028*y**8-9287*y**9+1158*y**10)+r**6*(-1+y)**2*(141048
          -311514*y+165426*y**2+215001*y**3-665134*y**4+996955*y**5-849386*y**6
          +387849*y**7-80726*y**8-1091*y**9+3372*y**10)+r**8*(223296-1040466*y
          +1893915*y**2-2093215*y**3+2594130*y**4-3676992*y**5+3662902*y**6-2210090*y**7
          +809490*y**8-189930*y**9+28271*y**10-1311*y**11))+12*logy*r**2*(-1+y)*(
          -1+r**2+y)**3*(180*r**24*(-1+y)**7-r**22*(-1+y)**3*(-3025+12640*y
          -20310*y**2+13349*y**3-4745*y**4+1125*y**5)+r**20*(14247-115890*y
          +398346*y**2-739626*y**3+812193*y**4-561981*y**5+275036*y**6-107840*y**7
          +27442*y**8-1927*y**9)+r**18*(360381-2185497*y+5449977*y**2-6899300*y**3
          +3976769*y**4+358377*y**5-1912388*y**6+1035428*y**7-171890*y**8-13624*y**9
          +1767*y**10)-3*(-1+y)**7*(43+129*y+258*y**2+164*y**3+160*y**4-30*y**5
          -346*y**6-208*y**7-139*y**8+765*y**9-488*y**10+92*y**11)-r**16*(9431
          +110596*y-1150170*y**2+3277614*y**3-5730954*y**4+7824924*y**5-7395753*y**6
          +3822555*y**7-658639*y**8-163986*y**9+52885*y**10+1497*y**11)+r**14*(
          -4616478+27139554*y-65194290*y**2+87839608*y**3-75879190*y**4+42849840*y**5
          -12417923*y**6-2335672*y**7+4142987*y**8-1850010*y**9+289993*y**10+44304*y**11
          -11523*y**12)+r**2*(-1+y)**6*(-4035-7683*y-10944*y**2+15349*y**3-4870*y**4
          +6411*y**5+8918*y**6-9179*y**7+1021*y**8-2460*y**9+3494*y**10-1790*y**11
          +368*y**12)+r**4*(-1+y)**5*(5977-521*y+1315*y**2-21647*y**3-83975*y**4
          -5300*y**5+289987*y**6-258572*y**7+62892*y**8+2325*y**9+378*y**10-2981*y**11
          +1122*y**12)+r**6*(-1+y)**4*(389871-197625*y-81651*y**2-1775786*y**3
          +2930067*y**4-1494372*y**5+512043*y**6-809682*y**7+973426*y**8-599107*y**9
          +179856*y**10-23068*y**11+2028*y**12)+r**10*(-1+y)**2*(-1697786+5116054*y
          -4951016*y**2+782394*y**3+4179156*y**4-9178926*y**5+10778799*y**6-7302882*y**7
          +2720161*y**8-507196*y**9+85577*y**10-30908*y**11+4773*y**12)+r**8*(
          -1+y)**3*(606966-763194*y-200388*y**2+2620244*y**3-6986564*y**4+9140064*y**5
          -6307993*y**6+1608196*y**7+1108621*y**8-1170006*y**9+421565*y**10-67128*y**11
          +5217*y**12)-r**12*(1423950-7682028*y+17041104*y**2-28175848*y**3+50891644*y**4
          -79983642*y**5+87485793*y**6-64421157*y**7+31614671*y**8-9502789*y**9
          +1197947*y**10+185065*y**11-81517*y**12+6807*y**13))-(-1+r**2+y)**4*(19*r**28*(
          -1+y)**8+r**26*(-1+y)**4*(-224+820*y-1040*y**2+639*y**3-296*y**4
          +107*y**5)+r**24*(-1+y)**2*(-11855+69790*y-170675*y**2+218197*y**3
          -152217*y**4+55504*y**5-7693*y**6-595*y**7+168*y**8)+r**22*(81336-640908*y
          +2186718*y**2-4243994*y**3+5122740*y**4-3925343*y**5+1856992*y**6-487633*y**7
          +43288*y**8+5623*y**9+574*y**10-113*y**11)-r**20*(267129-1992432*y
          +6371196*y**2-11888582*y**3+14375661*y**4-11004395*y**5+3960504*y**6
          +1123139*y**7-1815143*y**8+681859*y**9-82424*y**10+283*y**11+325*y**12)
          +(-1+y)**8*(79+316*y+790*y**2+309*y**3+2193*y**4+4284*y**5-2688*y**6
          -936*y**7-2611*y**8+2142*y**9-318*y**10+27*y**11+11*y**12+2*y**13)
          +r**18*(4787352-33050328*y+96556374*y**2-153258167*y**3+136296306*y**4
          -52525370*y**5-20288242*y**6+37871540*y**7-22422566*y**8+7266094*y**9
          -1403912*y**10+182095*y**11-16144*y**12+1368*y**13)+r**2*(-1+y)**7*(
          -1432-3064*y-4438*y**2-21665*y**3+24597*y**4+44550*y**5-49586*y**6
          +31182*y**7-8578*y**8-46084*y**9+43782*y**10-10965*y**11+501*y**12
          -2*y**13+2*y**14)+r**4*(-1+y)**6*(-104531-156146*y-183683*y**2+237510*y**3
          +204545*y**4+272007*y**5-390257*y**6+78400*y**7-60977*y**8-59388*y**9
          +165259*y**10-88182*y**11+18403*y**12-1433*y**13+73*y**14)+r**6*(-1
          +y)**5*(-694008-400524*y-135642*y**2+2174272*y**3-1882408*y**4+411247*y**5
          +2151957*y**6-2865342*y**7+691822*y**8+418416*y**9+38786*y**10-230738*y**11
          +87554*y**12-10819*y**13+627*y**14)+r**8*(-1+y)**4*(909459-2195904*y
          +623964*y**2-11281013*y**3+25485553*y**4-19219351*y**5+10200400*y**6
          -12525294*y**7+13365469*y**8-7864142*y**9+2826772*y**10-833501*y**11
          +226335*y**12-36971*y**13+2624*y**14)+r**16*(-11724179+79779340*y-225903338*y**2
          +343993867*y**3-273570997*y**4+24298978*y**5+194318488*y**6-224793876*y**7
          +128560711*y**8-42743202*y**9+9343026*y**10-1908783*y**11+399609*y**12
          -55428*y**13+5784*y**14)+r**10*(-1+y)**3*(6845520-15571044*y+7249056*y**2
          +4134835*y**3-12021723*y**4+31082773*y**5-39639853*y**6+11353398*y**7
          +22770986*y**8-25135822*y**9+10978682*y**10-2645953*y**11+469801*y**12
          -75131*y**13+6475*y**14)+r**12*(-1+y)**2*(-206663+2130202*y-7868393*y**2
          +10592848*y**3+12240233*y**4-46208252*y**5+46120939*y**6-31793760*y**7
          +31660411*y**8-27277722*y**9+14035365*y**10-4173096*y**11+719763*y**12
          -100764*y**13+10089*y**14)+2*r**14*(-5061592+29235180*y-68392854*y**2
          +109201290*y**3-187116112*y**4+309000019*y**5-369699594*y**6+297836449*y**7
          -163243888*y**8+63316168*y**9-20006370*y**10+6579414*y**11-1988160*y**12
          +386193*y**13-51126*y**14+4983*y**15))))/(4665600*logy**4*r**16*(-1+y)**8
          +1555200*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+194400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2+10800*logy*r**4*(-1+y)**2*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3+225*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(2073600*logy**4*r**18*(2
          +3*r**2)*(-1+y)**8+34560*logy**3*r**12*(-1+y)**6*(8*r**12*(-1+y)**2+r**10*(236
          -472*y+236*y**2+15*y**3)+20*r**4*(-1+y)**2*(-13-2*y**3+3*y**4)+10*r**8*(49
          -26*y-59*y**2+39*y**3+3*y**4)+5*r**6*(-96+288*y-240*y**2+56*y**3
          -16*y**4+17*y**5)-2*(-1+y)**3*(17+17*y+17*y**2+32*y**3-58*y**4
          +20*y**5)-r**2*(-1+y)**2*(28+275*y**3-210*y**4+42*y**5))+576*logy**2*r**8*(
          -1+y)**4*(-1+r**2+y)**2*(-112*r**16*(-1+y)**4+r**14*(-1+y)**2*(336
          -448*y-112*y**2+779*y**3)+2*r**12*(-1+y)**2*(5492-10488*y+4692*y**2
          -923*y**3+327*y**4)+r**10*(34832-116384*y+137352*y**2-53995*y**3-7700*y**4
          +1113*y**5+5874*y**6-992*y**7)-2*r**4*(-1+y)**3*(-4328-2824*y-2628*y**2
          +955*y**3+12920*y**4-7362*y**5+224*y**6+143*y**7)+4*(-1+y)**5*(-37
          -111*y-222*y**2-75*y**3+255*y**4+522*y**5-674*y**6+192*y**7)+r**2*(
          -1+y)**4*(-1704-3112*y-4224*y**2-4685*y**3+5060*y**4+1659*y**5-2238*y**6
          +494*y**7)+r**6*(-1+y)**2*(14392-13224*y-8808*y**2+51485*y**3-45300*y**4
          +15498*y**5-4296*y**6+1503*y**7)+20*r**8*(2889-7286*y+4949*y**2+1597*y**3
          -3480*y**4+1751*y**5-534*y**6+76*y**7+38*y**8))-48*logy*r**4*(-1+y)**4*(
          -1+r**2+y)**3*(4*r**22*(-1+y)**4-r**20*(-1+y)**2*(-232+476*y-256*y**2
          +141*y**3)+r**18*(5842-21388*y+28500*y**2-17497*y**3+5041*y**4+297*y**5
          -35*y**6)+r**16*(-56190+201150*y-252012*y**2+106908*y**3+10278*y**4
          -7917*y**5-4822*y**6+405*y**7)-r**14*(172832-572672*y+668172*y**2
          -364570*y**3+151390*y**4-71187*y**5+10757*y**6+3193*y**7+885*y**8)
          +r**12*(-257592+594240*y-362844*y**2-273896*y**3+332492*y**4+91047*y**5
          -155240*y**6+13954*y**7+8256*y**8-2217*y**9)+3*r**2*(-1+y)**5*(114
          +478*y+1250*y**2+1451*y**3-748*y**4-4034*y**5+3342*y**6-85*y**7-286*y**8
          +18*y**9)+2*(-1+y)**6*(-11-55*y-165*y**2-282*y**3-327*y**4-99*y**5
          +445*y**6+280*y**7-378*y**8+92*y**9)+r**6*(-1+y)**3*(-64860-86340*y
          -91452*y**2+22742*y**3+205360*y**4-3735*y**5-138280*y**6+75692*y**7
          -14232*y**8+405*y**9)-r**4*(-1+y)**4*(1648+2484*y+1956*y**2-42873*y**3
          -36750*y**4-31968*y**5+94636*y**6-41501*y**7+2158*y**8+710*y**9)+r**8*(
          -1+y)**2*(79828+23284*y+46960*y**2-160382*y**3-244580*y**4+252787*y**5
          -34724*y**6+20860*y**7-21548*y**8+2415*y**9)+r**10*(-526140+1054488*y
          -364260*y**2-884652*y**3+1588572*y**4-1448373*y**5+754697*y**6-177150*y**7
          +6522*y**8-4097*y**9+393*y**10))+4*r**2*(-1+y)**2*(-1+r**2+y)**4*(r**26*(
          -1+y)**6+r**24*(-1+y)**4*(-30+56*y-22*y**2+5*y**3)+2*r**22*(-1+y)**2*(95
          -346*y+427*y**2-262*y**3+139*y**4-40*y**5+3*y**6)+r**20*(-11200+63724*y
          -148648*y**2+189734*y**3-152060*y**4+81815*y**5-27896*y**6+4984*y**7
          -100*y**8+7*y**9)+(-1+y)**9*(2+14*y+56*y**2+183*y**3-21*y**4-1152*y**5
          -562*y**6+561*y**7-41*y**8-2*y**9+2*y**10)+r**18*(4819-57694*y+205219*y**2
          -366080*y**3+421190*y**4-365714*y**5+227244*y**6-81324*y**7+11995*y**8
          -740*y**9+125*y**10)+r**2*(-1+y)**7*(-1365-6553*y-18975*y**2-31755*y**3
          -22058*y**4+22800*y**5+16342*y**6+5060*y**7-19025*y**8+6433*y**9-135*y**10
          +31*y**11)+r**4*(-1+y)**6*(-4208-15748*y-35552*y**2-94102*y**3-117872*y**4
          -79735*y**5+227758*y**6-45033*y**7-46508*y**8+19887*y**9-1082*y**10
          +195*y**11)+2*r**6*(-1+y)**5*(-12655-20203*y-19115*y**2+182603*y**3
          +49330*y**4+84968*y**5-341790*y**6+184970*y**7-36723*y**8+15015*y**9
          -2143*y**10+343*y**11)+r**16*(613514-3054860*y+5956370*y**2-5264689*y**3
          +1136020*y**4+1608863*y**5-1339062*y**6+393305*y**7-66186*y**8+20985*y**9
          -4272*y**10+612*y**11)+2*r**12*(-1+y)**2*(735160-1415188*y+429808*y**2
          +2776762*y**3-4251088*y**4+2293345*y**5-725958*y**6+470677*y**7-243012*y**8
          +69573*y**9-8010*y**10+1131*y**11)+r**8*(-1+y)**4*(-772394-700752*y
          -494858*y**2+1619339*y**3+1485220*y**4-539206*y**5-1879128*y**6+1318028*y**7
          -286194*y**8+68410*y**9-10190*y**10+1525*y**11)+r**10*(-1+y)**3*(-1192727
          +94877*y+800407*y**2+1158787*y**3-1253062*y**4+216010*y**5-1080906*y**6
          +1480858*y**7-588387*y**8+137577*y**9-15693*y**10+2259*y**11)+4*r**14*(17897
          -45844*y+72820*y**2-506376*y**3+1636829*y**4-2411669*y**5+1845685*y**6
          -754510*y**7+181801*y**8-53229*y**9+19257*y**10-3036*y**11+375*y**12)))*math.log(mu0**2/r**2))/(1555200*logy**4*r**16*(
          -1+y)**8+518400*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+64800*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+3600*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +75*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-43200*logy**3*r**12*(69+62*r**2+21*r**4)*(-1+y)**8-720*logy**2*r**8*(
          -1+y)**6*(-19*r**12*(-1+y)**2+r**10*(598-1196*y+598*y**2-30*y**3)
          +5*r**8*(1385-2014*y+251*y**2+294*y**3+24*y**4)+(-1+y)**3*(-547
          -547*y-547*y**2+803*y**3+8*y**4+20*y**5)+10*r**6*(768-420*y-906*y**2
          +334*y**3+106*y**4+37*y**5)+2*r**2*(-1+y)**2*(-2603+1325*y**3-15*y**4
          +78*y**5)+5*r**4*(-2105+6694*y-5831*y**2+608*y**3+587*y**4-28*y**5
          +75*y**6))+60*logy*r**4*(-1+y)**4*(-1+r**2+y)**2*(85*r**16*(-1+y)**4
          -10*r**14*(-1+y)**2*(52-87*y+18*y**2+23*y**3)-r**12*(-1+y)**2*(-832
          +338*y+1337*y**2-1740*y**3+633*y**4)+r**10*(-22520+75846*y-86866*y**2
          +31372*y**3+7828*y**4-5486*y**5-706*y**6+452*y**7)+2*r**2*(-1+y)**3*(
          -2476-2225*y-1974*y**2+4291*y**3+802*y**4+763*y**5+592*y**6-1329*y**7
          +116*y**8)+(-1+y)**4*(-251-502*y-753*y**2-288*y**3-21*y**4+270*y**5
          +2441*y**6-1928*y**7+312*y**8)+r**8*(-180346+572094*y-600935*y**2
          +187440*y**3+46515*y**4-30654*y**5+10371*y**6-6080*y**7+875*y**8)-r**4*(
          -1+y)**2*(9056+3726*y-2085*y**2+15180*y**3-35075*y**4+7414*y**5+7289*y**6
          -2240*y**7+1055*y**8)-2*r**6*(60748-166485*y+136862*y**2-42220*y**3
          +52270*y**4-58698*y**5+17490*y**6+368*y**7-770*y**8+435*y**9))+(-1
          +y)**2*(-1+r**2+y)**3*(5*r**22*(-1+y)**6-r**20*(-1+y)**4*(-325+665*y
          -355*y**2+249*y**3)-5*r**18*(-1+y)**2*(-1921+6862*y-8754*y**2+3988*y**3
          +551*y**4-834*y**5+76*y**6)+5*r**16*(-1+y)**2*(-19903+68431*y-79962*y**2
          +27112*y**3+11417*y**4-7419*y**5+60*y**6+216*y**7)+10*r**14*(-1+y)**2*(36599
          -117140*y+117591*y**2-3488*y**3-68260*y**4+41904*y**5-5793*y**6-1452*y**7
          +159*y**8)-10*r**8*(-1+y)**2*(92281-157201*y+31779*y**2+39421*y**3
          -115243*y**4+190311*y**5-50717*y**6-43039*y**7-1926*y**8+14958*y**9
          -2502*y**10+78*y**11)+5*r**6*(-1+y)**3*(-17297+30723*y+855*y**2+82843*y**3
          -131580*y**4+27948*y**5+46788*y**6-111988*y**7+112349*y**8-35583*y**9
          -459*y**10+201*y**11)-10*r**12*(231065-1170729*y+2325762*y**2-2118118*y**3
          +496677*y**4+698205*y**5-659037*y**6+215455*y**7-14450*y**8-5160*y**9
          -33*y**10+243*y**11)-5*r**4*(-1+y)**4*(-9841-9019*y-6985*y**2+21595*y**3
          +4624*y**4+3532*y**5-27104*y**6+55144*y**7-47951*y**8+11135*y**9+953*y**10
          +317*y**11)-5*r**2*(-1+y)**5*(-1327-2507*y-3540*y**2+94*y**3+1604*y**4
          +3108*y**5+10654*y**6-11086*y**7+1995*y**8-505*y**9-362*y**10+432*y**11)
          -(-1+y)**6*(-245-735*y-1470*y**2-1396*y**3-792*y**4+402*y**5+4486*y**6
          -760*y**7+341*y**8-363*y**9-1312*y**10+644*y**11)-2*r**10*(1869325
          -8193240*y+13460310*y**2-10374114*y**3+5643726*y**4-5982624*y**5+5456766*y**6
          -1801944*y**7-329361*y**8+259424*y**9+8724*y**10-19326*y**11+2334*y**12)))*nlo.X1El(0,'SM',y/2,r))/(3110400*logy**4*r**16*(
          -1+y)**8+1036800*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+129600*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+7200*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +150*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6+120*logy*r**4*(
          -1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(-67+98*y
          -13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3-2*y**4
          +y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)+2*r**2*(
          -1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y-421*y**2
          +40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(
          -1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1
          +y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(
          -4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y
          +45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)
          +2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5
          -56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(0,'T2',y/2,r))/(1036800*logy**3*r**12*(
          -1+y)**6-600*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +259200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+21600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(1440*logy**2*r**8*(11+5*r**2)*(
          -1+y)**6-48*logy*r**4*(-1+y)**4*(9*r**10*(-1+y)**2+5*r**8*(-13+26*y
          -13*y**2+y**3)-5*r**2*(-1+y)**2*(-67+38*y**3+2*y**4)+(-1+y)**3*(39
          +39*y+39*y**2-76*y**3+4*y**4)-5*r**6*(120-180*y+30*y**2+14*y**3
          +7*y**4)-15*r**4*(-24+92*y-90*y**2+12*y**3+7*y**4+3*y**5))-2*(-1
          +y)**2*(-1+r**2+y)**2*(7*r**14*(-1+y)**4-r**12*(-1+y)**2*(57-100*y
          +29*y**2+24*y**3)-r**10*(-1+y)**2*(-759+1202*y-256*y**2-258*y**3
          +81*y**4)+r**8*(-4969+17330*y-20755*y**2+8250*y**3+1835*y**4-2156*y**5
          +425*y**6)-r**4*(-1+y)**2*(711+196*y-203*y**2+1620*y**3-3475*y**4
          +1004*y**5+339*y**6+48*y**7)-(-1+y)**4*(23+46*y+69*y**2-10*y**3
          -25*y**4-48*y**5-71*y**6+56*y**7)-r**2*(-1+y)**3*(393+347*y+301*y**2
          -865*y**3-55*y**4-73*y**5-27*y**6+139*y**7)+r**6*(-6919+19324*y-16320*y**2
          +5940*y**3-8130*y**4+8604*y**5-2244*y**6-340*y**7+85*y**8)))*nlo.X1El(1,'SM',y/2,r))/(8640*logy**3*r**12*(
          -1+y)**6-5*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +2160*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+180*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-60*logy*r**4*(3+r**2)*(-1
          +y)**4-(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1
          +y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(1,'T2',y/2,r))/(1440*logy**2*r**8*(-1+y)**4+240*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(-144*logy*r**4*(-1+y)**4-4*(-1+y)**2*(-3*r**8*(-1+y)**2-2*r**6*(
          -12+24*y-12*y**2+y**3)+6*r**4*y*(6-9*y+y**2+2*y**3)+6*r**2*(-1
          +y)**2*(-4+3*y**3)+(-1+y)**3*(-3-3*y-3*y**2+7*y**3)))*nlo.X1El(2,'SM',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(2,'T2',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.T2

    if wc.SRT != 0:
      resNP = 0
      resNP +=((rhoLS*(-21600*logy**3*r**9*(1+2*r**2+3*r**4)*(-1+y)**6-720*logy**2*r**5*(
          -1+y)**4*(124*r**10*(-1+y)**2-13*r**12*(-1+y)**2-5*r**8*(-35+16*y
          +46*y**2-34*y**3+3*y**4)+(-1+y)**3*(-1-y-y**2-6*y**3+4*y**4)+5*r**4*(
          -1+y)**2*(-23+18*y+9*y**2-19*y**3+9*y**4)+5*r**6*(-30+96*y-84*y**2
          +15*y**3+4*y**4+y**5)+r**2*(-1+y)**2*(-22+25*y**3-30*y**4+12*y**5))
          -30*logy*r*(-1+y)**3*(-1+r**2+y)**2*(15*r**16*(-1+y)**3+r**14*(272
          -786*y+726*y**2-268*y**3+56*y**4)-r**12*(654-2072*y+2025*y**2-861*y**3
          +233*y**4+21*y**5)+(-1+y)**4*(3+9*y+18*y**2+4*y**3-5*y**4-17*y**5
          +8*y**6)-2*r**10*(2418-5299*y+2826*y**2+1011*y**3-819*y**4-177*y**5
          +40*y**6)+r**4*(-1+y)**2*(-90-140*y-157*y**2+1045*y**3-724*y**4+22*y**5
          +63*y**6+y**7)+r**8*(-6748+12278*y-4347*y**2-6501*y**3+7730*y**4
          -3106*y**5+449*y**6+5*y**7)+2*r**2*(-1+y)**3*(2+y-3*y**2-23*y**3
          +10*y**4+26*y**5-35*y**6+12*y**7)+2*r**6*(-444+833*y-285*y**2-552*y**3
          +268*y**4+637*y**5-605*y**6+148*y**7))+r*(-1+y)**2*(-1+r**2+y)**3*(10*r**18*(
          -1+y)**4+3*r**16*(-1+y)**2*(-80+150*y-60*y**2+11*y**3)+r**14*(1730
          -6680*y+9255*y**2-6034*y**3+2242*y**4-382*y**5+9*y**6)+r**12*(190
          +2450*y-7815*y**2+7449*y**3-2566*y**4-531*y**5+249*y**6-86*y**7)
          +r**10*(-20250+64020*y-64275*y**2+26392*y**3-12575*y**4+11470*y**5
          -4635*y**6+1170*y**7-117*y**8)-5*r**8*(14306-36962*y+26373*y**2+15165*y**3
          -31637*y**4+15102*y**5-3041*y**6+1073*y**7-185*y**8+6*y**9)-r**4*(
          -1+y)**2*(-6450-2490*y+315*y**2-5279*y**3+20169*y**4-7770*y**5-2155*y**6
          +585*y**7+369*y**8+6*y**9)-(-1+y)**4*(-330-900*y-1665*y**2-18*y**3
          +663*y**4+1515*y**5-1075*y**6+80*y**7+23*y**8+7*y**9)-r**2*(-1+y)**3*(
          -2560-4100*y-4905*y**2+8181*y**3-301*y**4-1445*y**5+1525*y**6-985*y**7
          +169*y**8+21*y**9)+r**6*(-43730+85760*y-31755*y**2-56378*y**3+76746*y**4
          -26598*y**5-15100*y**6+15130*y**7-4032*y**8-66*y**9+23*y**10))))/(-129600*logy**3*r**12*(
          -1+y)**6+75*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -32400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-2700*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      res += resNP*wc.SRT

    return res*par.mbkin**2


def moment_3_KIN_MS(elcut, par, hqe, wc, **kwargs):
    y=2*elcut/par.mbkin
    r=par.mcMS/par.mbkin
    mu0=par.scale_mcMS/par.mbkin
    muWC=par.scale_mbkin/par.mbkin
    api=par.alphas/math.pi

    rhoD=hqe.rhoD/par.mbkin**3
    rhoLS=hqe.rhoLS/par.mbkin**3
    muG=hqe.muG/par.mbkin**2

    mupi=hqe.mupi/par.mbkin**2

    logy =math.log((1-y)/r**2)

    res = 0
    if wc.ReVL != 0:
      resNP = 0
      resNP +=((api*(1512000*logy**3*r**12*(19+19*r**2+11*r**4+3*r**6)*(-1+y)**8+3600*logy**2*r**8*(
          -1+y)**6*(175*r**12*(-1+y)**2+255*r**14*(-1+y)**2-7*r**10*(-897+1254*y
          -87*y**2-340*y**3+90*y**4)+35*r**8*(405-414*y-189*y**2+204*y**3-38*y**4
          +8*y**5)-35*r**2*(-1+y)**2*(213-5*y**4-32*y**5+4*y**6)+35*r**6*(275
          +134*y-751*y**2+196*y**3+143*y**4-82*y**5+25*y**6)+35*r**4*(-669
          +2022*y-1695*y**2+52*y**3+495*y**4-282*y**5+77*y**6)+(-1+y)**3*(
          -361-361*y-361*y**2-4001*y**3+3804*y**4-900*y**5+80*y**6))+60*logy*r**4*(
          -1+y)**4*(-1+r**2+y)**2*(355*r**18*(-1+y)**4-r**16*(-1+y)**2*(-1153
          +3016*y-2573*y**2+1470*y**3)-r**14*(-1+y)**2*(-64706+101828*y-25903*y**2
          -10734*y**3+1755*y**4)+r**12*(-1+y)**2*(8214-66656*y+94159*y**2-16866*y**3
          -12551*y**4+5180*y**5)+r**10*(692212-2030424*y+1848647*y**2-169180*y**3
          -586485*y**4+241888*y**5+27709*y**6-25452*y**7+2485*y**8)+r**2*(-1
          +y)**3*(19399+17793*y+16187*y**2+142341*y**3-189095*y**4+52111*y**5
          -17483*y**6+7323*y**7+1544*y**8+280*y**9)-5*r**8*(-436732+1374912*y
          -1414175*y**2+301728*y**3+420651*y**4-337498*y**5+90783*y**6+5140*y**7
          -8743*y**8+1414*y**9)-(-1+y)**4*(-803-1606*y-2409*y**2-13492*y**3
          +4295*y**4-1662*y**5-7059*y**6+18944*y**7-10248*y**8+1440*y**9)+r**4*(
          -1+y)**2*(115834+6128*y-13123*y**2-627214*y**3+1390935*y**4-1107204*y**5
          +299327*y**6+34778*y**7-29781*y**8+5920*y**9)+r**6*(883662-2380808*y
          +1934387*y**2-460068*y**3+323372*y**4-509292*y**5+263858*y**6-41212*y**7
          -26282*y**8+12628*y**9-245*y**10))-(-1+y)**2*(-1+r**2+y)**3*(23*r**24*(
          -1+y)**6+r**22*(-1+y)**4*(-1636+3203*y-1498*y**2+611*y**3)-r**20*(
          -1+y)**2*(53282-196667*y+264360*y**2-147190*y**3+20590*y**4+6593*y**5
          +32*y**6)-5*r**18*(-1+y)**2*(-10084+25495*y-2964*y**2-59086*y**3+67984*y**4
          -18137*y**5-3136*y**6+768*y**7)-5*r**16*(-1+y)**2*(981683-3134849*y
          +3304164*y**2-878638*y**3-577695*y**4+335767*y**5-23846*y**6-7224*y**7
          +78*y**8)+2*r**14*(-1+y)**2*(5042852-15034913*y+12846762*y**2+344847*y**3
          -4593008*y**4+1133298*y**5+522238*y**6-184337*y**7-20172*y**8+5433*y**9)
          +r**4*(-1+y)**4*(239598+215739*y+172968*y**2+711145*y**3-1068910*y**4
          -13636*y**5-698198*y**6+2381464*y**7-2629420*y**8+1381385*y**9-259362*y**10
          -13441*y**11+668*y**12)+5*r**6*(-1+y)**3*(61652+93801*y-18903*y**2
          -1950935*y**3+5284025*y**4-5051584*y**5+1856368*y**6+72856*y**7-504180*y**8
          +374135*y**9-110233*y**10+4191*y**11+807*y**12)-(-1+y)**6*(-863-2589*y
          -5178*y**2-18310*y**3-7640*y**4-6544*y**5-7722*y**6+26426*y**7-4265*y**8
          +1565*y**9-668*y**10-3764*y**11+1552*y**12)-5*r**8*(-1+y)**2*(1495819
          -2607070*y+733134*y**2-3703654*y**3+14693541*y**4-21082902*y**5+14135366*y**6
          -3338562*y**7-900021*y**8+514084*y**9-5492*y**10-19896*y**11+1653*y**12)
          +2*r**12*(-24565894+116636943*y-212534784*y**2+167628370*y**3-16908815*y**4
          -61310837*y**5+33962579*y**6+2466173*y**7-7236645*y**8+1921290*y**9
          +4081*y**10-50547*y**11+2086*y**12)-r**2*(-1+y)**5*(-24876-47163*y
          -66861*y**2-298290*y**3+176270*y**4-4768*y**5-46084*y**6+399422*y**7
          -301510*y**8+50555*y**9-6031*y**10-2428*y**11+3764*y**12)-2*r**10*(13546628
          -58709229*y+95512344*y**2-62747978*y**3-12826120*y**4+65626674*y**5
          -74365612*y**6+48658242*y**7-16017164*y**8+210745*y**9+1369948*y**10
          -237784*y**11-27336*y**12+6642*y**13)))*nlo.X1El(0,'SM',y/2,r))/(290304000*logy**4*r**16*(
          -1+y)**8+96768000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+12096000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+672000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +14000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-1512000*logy**3*r**12*(19+19*r**2+11*r**4+3*r**6)*(-1+y)**8-3600*logy**2*r**8*(
          -1+y)**6*(175*r**12*(-1+y)**2+255*r**14*(-1+y)**2-7*r**10*(-897+1254*y
          -87*y**2-340*y**3+90*y**4)+35*r**8*(405-414*y-189*y**2+204*y**3-38*y**4
          +8*y**5)-35*r**2*(-1+y)**2*(213-5*y**4-32*y**5+4*y**6)+35*r**6*(275
          +134*y-751*y**2+196*y**3+143*y**4-82*y**5+25*y**6)+35*r**4*(-669
          +2022*y-1695*y**2+52*y**3+495*y**4-282*y**5+77*y**6)+(-1+y)**3*(
          -361-361*y-361*y**2-4001*y**3+3804*y**4-900*y**5+80*y**6))-60*logy*r**4*(
          -1+y)**4*(-1+r**2+y)**2*(355*r**18*(-1+y)**4-r**16*(-1+y)**2*(-1153
          +3016*y-2573*y**2+1470*y**3)-r**14*(-1+y)**2*(-64706+101828*y-25903*y**2
          -10734*y**3+1755*y**4)+r**12*(-1+y)**2*(8214-66656*y+94159*y**2-16866*y**3
          -12551*y**4+5180*y**5)+r**10*(692212-2030424*y+1848647*y**2-169180*y**3
          -586485*y**4+241888*y**5+27709*y**6-25452*y**7+2485*y**8)+r**2*(-1
          +y)**3*(19399+17793*y+16187*y**2+142341*y**3-189095*y**4+52111*y**5
          -17483*y**6+7323*y**7+1544*y**8+280*y**9)-5*r**8*(-436732+1374912*y
          -1414175*y**2+301728*y**3+420651*y**4-337498*y**5+90783*y**6+5140*y**7
          -8743*y**8+1414*y**9)-(-1+y)**4*(-803-1606*y-2409*y**2-13492*y**3
          +4295*y**4-1662*y**5-7059*y**6+18944*y**7-10248*y**8+1440*y**9)+r**4*(
          -1+y)**2*(115834+6128*y-13123*y**2-627214*y**3+1390935*y**4-1107204*y**5
          +299327*y**6+34778*y**7-29781*y**8+5920*y**9)+r**6*(883662-2380808*y
          +1934387*y**2-460068*y**3+323372*y**4-509292*y**5+263858*y**6-41212*y**7
          -26282*y**8+12628*y**9-245*y**10))+(-1+y)**2*(-1+r**2+y)**3*(23*r**24*(
          -1+y)**6+r**22*(-1+y)**4*(-1636+3203*y-1498*y**2+611*y**3)-r**20*(
          -1+y)**2*(53282-196667*y+264360*y**2-147190*y**3+20590*y**4+6593*y**5
          +32*y**6)-5*r**18*(-1+y)**2*(-10084+25495*y-2964*y**2-59086*y**3+67984*y**4
          -18137*y**5-3136*y**6+768*y**7)-5*r**16*(-1+y)**2*(981683-3134849*y
          +3304164*y**2-878638*y**3-577695*y**4+335767*y**5-23846*y**6-7224*y**7
          +78*y**8)+2*r**14*(-1+y)**2*(5042852-15034913*y+12846762*y**2+344847*y**3
          -4593008*y**4+1133298*y**5+522238*y**6-184337*y**7-20172*y**8+5433*y**9)
          +r**4*(-1+y)**4*(239598+215739*y+172968*y**2+711145*y**3-1068910*y**4
          -13636*y**5-698198*y**6+2381464*y**7-2629420*y**8+1381385*y**9-259362*y**10
          -13441*y**11+668*y**12)+5*r**6*(-1+y)**3*(61652+93801*y-18903*y**2
          -1950935*y**3+5284025*y**4-5051584*y**5+1856368*y**6+72856*y**7-504180*y**8
          +374135*y**9-110233*y**10+4191*y**11+807*y**12)-(-1+y)**6*(-863-2589*y
          -5178*y**2-18310*y**3-7640*y**4-6544*y**5-7722*y**6+26426*y**7-4265*y**8
          +1565*y**9-668*y**10-3764*y**11+1552*y**12)-5*r**8*(-1+y)**2*(1495819
          -2607070*y+733134*y**2-3703654*y**3+14693541*y**4-21082902*y**5+14135366*y**6
          -3338562*y**7-900021*y**8+514084*y**9-5492*y**10-19896*y**11+1653*y**12)
          +2*r**12*(-24565894+116636943*y-212534784*y**2+167628370*y**3-16908815*y**4
          -61310837*y**5+33962579*y**6+2466173*y**7-7236645*y**8+1921290*y**9
          +4081*y**10-50547*y**11+2086*y**12)-r**2*(-1+y)**5*(-24876-47163*y
          -66861*y**2-298290*y**3+176270*y**4-4768*y**5-46084*y**6+399422*y**7
          -301510*y**8+50555*y**9-6031*y**10-2428*y**11+3764*y**12)-2*r**10*(13546628
          -58709229*y+95512344*y**2-62747978*y**3-12826120*y**4+65626674*y**5
          -74365612*y**6+48658242*y**7-16017164*y**8+210745*y**9+1369948*y**10
          -237784*y**11-27336*y**12+6642*y**13)))*nlo.X1El(0,'VL',y/2,r))/(580608000*logy**4*r**16*(
          -1+y)**8+193536000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+24192000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+1344000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +28000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6-120*logy*r**4*(
          -1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(-67+98*y
          -13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3-2*y**4
          +y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)+2*r**2*(
          -1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y-421*y**2
          +40*y**3+73*y**4-32*y**5+9*y**6))-(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(
          -1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1
          +y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(
          -4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y
          +45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)
          +2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5
          -56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(1,'SM',y/2,r))/(172800*logy**3*r**12*(
          -1+y)**6-100*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +43200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+3600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2
          +3*r**4)*(-1+y)**6+120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(
          -1+y)**2-5*r**8*(-67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y
          -18*y**2+22*y**3-2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3
          -16*y**4+2*y**5)+2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(
          -151+482*y-421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(
          -1+r**2+y)**2*(7*r**16*(-1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2
          +27*y**3)-r**12*(-1+y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)
          +2*r**10*(-1+y)**2*(-4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)
          +5*r**8*(13422-43158*y+45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6
          -284*y**7+33*y**8)+2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3
          -2300*y**4+277*y**5-56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436
          -542*y+757*y**2+11016*y**3-25545*y**4+20466*y**5-4753*y**6-652*y**7
          +89*y**8)+(-1+y)**4*(67+134*y+201*y**2+428*y**3-55*y**4-22*y**5
          -89*y**6-156*y**7+92*y**8)-2*r**6*(-17964+49281*y-40854*y**2+5986*y**3
          +8446*y**4-11636*y**5+9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(1,'VL',y/2,r))/(345600*logy**3*r**12*(
          -1+y)**6-200*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +86400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+7200*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(180*logy*r**4*(3+r**2)*(-1
          +y)**4+3*(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(
          -1+y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(2,'SM',y/2,r))/(1440*logy**2*r**8*(-1+y)**4+240*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(-180*logy*r**4*(3+r**2)*(-1+y)**4-3*(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(2,'VL',y/2,r))/(2880*logy**2*r**8*(
          -1+y)**4+480*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2)-(2*api*(-1+y)**2*nlo.X1El(3,'SM',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          )
      resNP += ((api*(-1+y)**2*nlo.X1El(3,'VL',y/2,r))/(12*logy*r**4*(-1+y)**2-r**8*(
          -1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.ReVL

    if wc.ReVR != 0:
      resNP = 0
      resNP +=((-18144000*logy**4*r**15*(3+5*r**2+6*r**4+5*r**6+3*r**8)*(-1+y)**8-43200*logy**3*r**11*(
          -1+y)**6*(654*r**14*(-1+y)**2+255*r**16*(-1+y)**2-14*r**12*(-431+502*y
          +109*y**2-260*y**3+45*y**4)+70*r**10*(49+22*y-131*y**2+76*y**3-10*y**4
          +4*y**5)+5*(-1+y)**4*(-51-102*y-153*y**2+272*y**3-108*y**4+16*y**5)
          +35*r**8*y*(288-432*y+60*y**2+183*y**3-110*y**4+25*y**5)-14*r**4*(
          -1+y)**2*(431-360*y-180*y**2+180*y**3+5*y**4-56*y**5+10*y**6)+70*r**6*(
          -49+218*y-229*y**2-28*y**3+161*y**4-94*y**5+21*y**6)+2*r**2*(-1
          +y)**3*(327+327*y+327*y**2-1353*y**3+1272*y**4-380*y**5+40*y**6))
          -720*logy**2*r**7*(-1+y)**4*(-1+r**2+y)**2*(355*r**20*(-1+y)**4-2*r**18*(
          -1+y)**2*(-2981+6317*y-3691*y**2+735*y**3)-r**16*(-1+y)**2*(-86699
          +140132*y-44182*y**2-11156*y**3+1755*y**4)+4*r**14*(-1+y)**2*(33314
          -60756*y+29814*y**2+9734*y**3-6926*y**4+1295*y**5)-5*(-1+y)**6*(
          -71-284*y-710*y**2-732*y**3+385*y**4+1920*y**5-1496*y**6+288*y**7)
          -r**8*(-1+y)**2*(-875618+1006716*y+35262*y**2-399460*y**3-55425*y**4
          +155008*y**5-28036*y**6-7392*y**7+245*y**8)+r**4*(-1+y)**4*(86699+140132*y
          +184314*y**2-519020*y**3+307265*y**4-30004*y**5-20682*y**6+5016*y**7
          +280*y**8)-2*r**2*(-1+y)**5*(2981+9298*y+19306*y**2-8980*y**3-535*y**4
          -15286*y**5+16032*y**6-6036*y**7+720*y**8)+4*r**6*(-1+y)**3*(-33314
          -27442*y-29814*y**2+225880*y**3-210320*y**4+50239*y**5+18562*y**6
          -10321*y**7+1480*y**8)+r**12*(875618-2495756*y+2198298*y**2+15580*y**3
          -1030835*y**4+469812*y**5-15434*y**6-18368*y**7+2485*y**8)-10*r**10*(
          -112262+336786*y-312016*y**2-35502*y**3+253087*y**4-159185*y**5+17376*y**6
          +18282*y**7-7273*y**8+707*y**9))-12*logy*r**3*(-1+y)**4*(-1+r**2+y)**3*(
          -23*r**26*(-1+y)**4-r**24*(-1+y)**2*(-3133+6197*y-2995*y**2+611*y**3)
          +2*r**22*(76629-289881*y+403815*y**2-246210*y**3+56870*y**4-739*y**5
          +16*y**6)+(-1+y)**9*(23+184*y+828*y**2+2220*y**3+2385*y**4-2648*y**5
          -2444*y**6+1552*y**7)+r**20*(959802-3550272*y+4872810*y**2-3009270*y**3
          +714220*y**4+56318*y**5-42248*y**6+3840*y**7)+5*r**18*(1663455-5091138*y
          +5107956*y**2-1048588*y**3-1239885*y**4+659370*y**5-56672*y**6-3536*y**7
          +78*y**8)+r**16*(2486271-11092779*y+20175996*y**2-11574184*y**3-6344209*y**4
          +9127829*y**5-2831696*y**6+93304*y**7+124334*y**8-10866*y**9)+4*r**14*(13652071
          -30491371*y+14420529*y**2+16436514*y**3-17888981*y**4+1278122*y**5
          +4169546*y**6-1441654*y**7+85336*y**8+24181*y**9-1043*y**10)-2*r**6*(
          -1+y)**4*(-479901-1295235*y-2436405*y**2+2960540*y**3-1005865*y**4
          +1537992*y**5-1954765*y**6+849680*y**7-110290*y**8-8585*y**9+334*y**10)
          -5*r**8*(-1+y)**3*(1663455+1764228*y+1680273*y**2-11498712*y**3+9055028*y**4
          -480332*y**5-2095868*y**6+837952*y**7-79063*y**8-10568*y**9+807*y**10)
          +r**2*(-1+y)**6*(3133+15596*y+46581*y**2+86106*y**3+18831*y**4-147960*y**5
          +46579*y**6-16206*y**7+26244*y**8-10456*y**9+1552*y**10)+2*r**4*(-1
          +y)**5*(-76629-289881*y-693696*y**2-342781*y**3+343274*y**4+1274397*y**5
          -1218794*y**6+316221*y**7+18631*y**8-15124*y**9+1882*y**10)+r**10*(
          -1+y)**2*(2486271+3633966*y+5449251*y**2-44281684*y**3+50060916*y**4
          -10065636*y**5-8464816*y**6+3767124*y**7-172391*y**8-69266*y**9+8265*y**10)
          +4*r**12*(13652071-37768984*y+28975755*y**2+17441955*y**3-42235475*y**4
          +22634753*y**5+358338*y**6-4335980*y**7+1343470*y**8-41275*y**9-27949*y**10
          +3321*y**11))+r*(-1+y)**2*(-1+r**2+y)**4*(11*r**28*(-1+y)**6+2*r**26*(
          -1+y)**4*(64-12*y-99*y**2+62*y**3)+r**24*(-1+y)**2*(-137663+512776*y
          -694128*y**2+425652*y**3-123903*y**4+13540*y**5+606*y**6)+2*r**22*(
          -1056216+5674136*y-12386346*y**2+13861178*y**3-8030117*y**4+1837506*y**5
          +255284*y**6-163254*y**7+8427*y**8+802*y**9)-(-1+y)**10*(-11-88*y
          -396*y**2-1944*y**3-2722*y**4+2192*y**5+1068*y**6-1624*y**7+549*y**8
          +152*y**9+24*y**10)+r**20*(-4657909+23553238*y-48724099*y**2+52324784*y**3
          -29055878*y**4+4884028*y**5+3360382*y**6-2134256*y**7+508811*y**8-72402*y**9
          +2101*y**10)-2*r**2*(-1+y)**8*(-64-268*y-601*y**2+23704*y**3+44379*y**4
          +22382*y**5-95355*y**6-55424*y**7+106221*y**8-32854*y**9+1732*y**10
          +148*y**11)-2*r**18*(30490976-140160916*y+246164665*y**2-178347140*y**3
          -10616045*y**4+102405998*y**5-62794823*y**6+12157560*y**7+1251665*y**8
          -619030*y**9+59826*y**10+264*y**11)-r**4*(-1+y)**7*(-137663-650439*y
          -1857343*y**2-2202523*y**3-2698*y**4+4178318*y**5-2324730*y**6+506118*y**7
          -105927*y**8+69673*y**9-22455*y**10+1669*y**11)-2*r**6*(-1+y)**6*(1056216
          +3561704*y+7768426*y**2+40786*y**3-4540589*y**4-12024726*y**5+15713133*y**6
          -4801476*y**7-353311*y**8+364114*y**9-53115*y**10+2838*y**11)-4*r**14*(
          -1+y)**2*(106429256-212858512*y+65363586*y**2+158063546*y**3-137939579*y**4
          +489454*y**5+34665615*y**6-9039436*y**7-1038571*y**8+647154*y**9-54935*y**10
          +4422*y**11)-2*r**10*(-1+y)**4*(30490976+18197012*y+8627773*y**2-191623022*y**3
          +189615758*y**4-7585204*y**5-55763136*y**6+22682452*y**7-1742978*y**8
          -282208*y**9+7303*y**10+10274*y**11)-r**8*(-1+y)**5*(-4657909-9579511*y
          -15591350*y**2+64989010*y**3-46308370*y**4+7352978*y**5+6239772*y**6
          -883100*y**7-1204385*y**8+545645*y**9-103694*y**10+12914*y**11)-r**12*(
          -1+y)**3*(81164329-47358347*y-61007109*y**2-57512129*y**3+145233746*y**4
          -53090422*y**5-17764770*y**6+20070934*y**7-4805771*y**8+618129*y**9
          -55657*y**10+23067*y**11)+r**16*(81164329-358463298*y+561202793*y**2
          -288346520*y**3-159003650*y**4+260614332*y**5-116557094*y**6+22459984*y**7
          -5222355*y**8+3116150*y**9-1047811*y**10+91192*y**11-8052*y**12)))/(290304000*logy**4*r**16*(
          -1+y)**8+96768000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+12096000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+672000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +14000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(217728000*logy**5*r**19*(-3+5*r**2+18*r**4+25*r**6+21*r**8)*(-1
          +y)**10+518400*logy**4*r**15*(-1+y)**8*(3750*r**16*(-1+y)**2+r**14*(6971
          -13942*y+6971*y**2+210*y**3)-14*r**12*(-2912+2674*y+1813*y**2-2210*y**3
          +315*y**4)+175*r**10*(-7+314*y-457*y**2+212*y**3-56*y**4+26*y**5)
          -50*(-1+y)**3*(57+57*y+57*y**2-244*y**3+190*y**4-62*y**5+8*y**6)
          +70*r**8*(-340+1220*y-1150*y**2+175*y**3+317*y**4-238*y**5+72*y**6)
          +35*r**6*(-737+1774*y-1187*y**2-50*y**3+583*y**4-476*y**5+147*y**6)
          -r**2*(-1+y)**2*(943+14560*y**3-18725*y**4+9912*y**5-2520*y**6+240*y**7)
          +14*r**4*(-184-82*y+491*y**2-210*y**3+440*y**4-801*y**5+412*y**6
          -76*y**7+10*y**8))+17280*logy**3*r**11*(-1+y)**6*(-1+r**2+y)**2*(5850*r**20*(
          -1+y)**4-r**18*(-1+y)**2*(-72583+156866*y-95983*y**2+20465*y**3)
          -r**16*(-1+y)**2*(-741876+1190618*y-398158*y**2-62129*y**3+2965*y**4)
          +r**14*(1013744-3959074*y+5919965*y**2-3711320*y**3+171300*y**4+896226*y**5
          -384461*y**6+56070*y**7)+35*(-1+y)**5*(246+738*y+1476*y**2-253*y**3
          -1162*y**4-2295*y**5+3626*y**6-1634*y**7+248*y**8)-2*r**12*(-1693211
          +4649297*y-4137246*y**2+451020*y**3+1421455*y**4-928399*y**5+309408*y**6
          -90279*y**7+10255*y**8)+r**6*(-1+y)**2*(51064-456902*y-234653*y**2
          +3729116*y**3-4954405*y**4+2425366*y**5-298943*y**6-113792*y**7+23489*y**8
          +3960*y**9)-2*r**4*(-1+y)**3*(-231852-111019*y-88601*y**2+1109682*y**3
          -1155315*y**4+545202*y**5-227381*y**6+127776*y**7-46257*y**8+6015*y**9)
          -5*r**10*(-533790+1433974*y-1083583*y**2-624082*y**3+1646249*y**4-1052972*y**5
          +105213*y**6+170339*y**7-70343*y**8+6545*y**9)+r**2*(-1+y)**4*(-41557
          -100334*y-176331*y**2+197747*y**3+13145*y**4+245127*y**5-481611*y**6
          +303096*y**7-80672*y**8+7640*y**9)+r**8*(889382-2213818*y+808892*y**2
          +4744922*y**3-9789178*y**4+8058358*y**5-2013732*y**6-1347567*y**7+1172603*y**8
          -353997*y**9+44135*y**10))+288*logy**2*r**7*(-1+y)**4*(-1+r**2+y)**3*(669*r**26*(
          -1+y)**6-r**24*(-1+y)**4*(-118314+238635*y-122328*y**2+25912*y**3)
          +r**22*(-1+y)**2*(3167785-11975089*y+16753020*y**2-10415430*y**3+2633185*y**4
          -163425*y**5+26454*y**6)+r**20*(-1+y)**2*(15589697-58101152*y+81125520*y**2
          -51480280*y**3+12295665*y**4+1624808*y**5-1143358*y**6+120650*y**7)
          -5*r**18*(-1+y)**2*(-18466988+55662707*y-55831650*y**2+13544638*y**3
          +10603714*y**4-6287825*y**5+1049118*y**6-236132*y**7+31298*y**8)-(
          -1+y)**8*(6063+30315*y+90945*y**2+143090*y**3+80475*y**4-173951*y**5
          -202665*y**6-19220*y**7+334410*y**8-202250*y**9+35288*y**10)+r**16*(46245657
          -280978617*y+721782105*y**2-919197130*y**3+436678695*y**4+278084151*y**5
          -480834901*y**6+240888970*y**7-37438720*y**8-8517570*y**9+3532192*y**10
          -237832*y**11)+r**4*(-1+y)**6*(-3345211-8987232*y-16688940*y**2+10693540*y**3
          +12777260*y**4+23309612*y**5-50514186*y**6+28623440*y**7-5548365*y**8
          -154310*y**9+101674*y**10+6218*y**11)-5*r**8*(-1+y)**4*(11502308-1898611*y
          -1819120*y**2-50284312*y**3+78291632*y**4-44334412*y**5+9881548*y**6
          +226730*y**7-1220008*y**8+798633*y**9-221456*y**10+11568*y**11)-r**2*(
          -1+y)**7*(-161070-662469*y-1701645*y**2-1099015*y**3+358515*y**4+3185615*y**5
          -1525767*y**6+586395*y**7-1596885*y**8+1288110*y**9-392720*y**10+40936*y**11)
          +2*r**12*(-1+y)**2*(69275405-133172846*y+1040115*y**2+265979180*y**3
          -323162495*y**4+80477520*y**5+113588437*y**6-89772815*y**7+17157020*y**8
          +3425245*y**9-1409850*y**10+136334*y**11)+r**6*(-1+y)**5*(4985051+11477074*y
          +20380875*y**2-44879090*y**3+7535340*y**4-51188752*y**5+115984152*y**6
          -82748400*y**7+20834365*y**8+1283010*y**9-1375099*y**10+175474*y**11)
          -r**10*(-1+y)**3*(49005141-114721545*y-2397465*y**2+445650725*y**3
          -660713610*y**4+298317888*y**5+85588070*y**6-122963360*y**7+31831025*y**8
          +3928485*y**9-2839229*y**10+261875*y**11)+2*r**14*(109977961-426210609*y
          +598273968*y**2-264236790*y**3-199371795*y**4+288817653*y**5-122776787*y**6
          +8618729*y**7+13624740*y**8-11120080*y**9+5710061*y**10-1474379*y**11
          +167328*y**12))+12*logy*r**3*(-1+y)**4*(-1+r**2+y)**4*(69*r**32*(-1+y)**6
          +r**30*(-1+y)**4*(-5181+10086*y-4629*y**2+910*y**3)+2*r**28*(-1+y)**2*(217572
          -844008*y+1208685*y**2-796093*y**3+250841*y**4-33535*y**5+3158*y**6)
          +r**26*(14514773-83097582*y+196451973*y**2-248020986*y**3+180551617*y**4
          -76011548*y**5+17132107*y**6-1463878*y**7-70654*y**8+178*y**9)+r**24*(146352860
          -780131516*y+1692810174*y**2-1890025322*y**3+1102554407*y**4-264630208*y**5
          -27308279*y**6+22744626*y**7-2863463*y**8+443668*y**9-40947*y**10)+3*(
          -1+y)**11*(-23-207*y-1035*y**2-3209*y**3-5249*y**4-1129*y**5+4927*y**6
          +5925*y**7-1756*y**8-3996*y**9+1552*y**10)+r**22*(323369043-1679334598*y
          +3602060705*y**2-4025291722*y**3+2260869658*y**4-208832576*y**5-525519870*y**6
          +324158270*y**7-77665293*y**8+6100662*y**9+527413*y**10-27292*y**11)
          +2*r**20*(1070224308-4721605544*y+7887558711*y**2-5283712565*y**3-631020121*y**4
          +3063105392*y**5-1688443900*y**6+282976679*y**7+30043735*y**8-11606384*y**9
          +2686245*y**10-481386*y**11+43830*y**12)-r**6*(-1+y)**6*(12879047+48451484*y
          +116459156*y**2+25032582*y**3-50846705*y**4-206117534*y**5+190894492*y**6
          -82901202*y**7+95345261*y**8-79385670*y**9+27739112*y**10-3332276*y**11
          -67979*y**12+232*y**13)+r**2*(-1+y)**8*(-14649-87618*y-305697*y**2
          -681498*y**3-741218*y**4+168370*y**5+1141658*y**6+854386*y**7-1291837*y**8
          +299568*y**9-186321*y**10+208360*y**11-71264*y**12+7760*y**13)+2*r**4*(
          -1+y)**7*(612420+2945748*y+8560599*y**2+10999556*y**3+3835642*y**4
          -17059173*y**5-8250144*y**6+439669*y**7+20416300*y**8-14771417*y**9
          +3249753*y**10+52171*y**11-85418*y**12+9294*y**13)+r**8*(-1+y)**5*(136852196
          +298437944*y+473415734*y**2-776373268*y**3-415559709*y**4-642407881*y**5
          +2321167888*y**6-1642070332*y**7+296905542*y**8+120680834*y**9-59792190*y**10
          +8109968*y**11-207477*y**12+22751*y**13)-r**14*(-1+y)**2*(-2484294705
          +6091052608*y-1651177246*y**2-12337836914*y**3+16585630377*y**4-3636030298*y**5
          -6435083324*y**6+4144917944*y**7+65151105*y**8-708026952*y**9+194307578*y**10
          -10814734*y**11-1977673*y**12+40234*y**13)+r**18*(-950862723+2762654018*y
          -15453047*y**2-6245243566*y**3+3408697062*y**4+6985428478*y**5-9409889794*y**6
          +3434791906*y**7+628322649*y**8-768620412*y**9+181062145*y**10-7446524*y**11
          -882884*y**12+60692*y**13)+2*r**12*(-1+y)**3*(827108244-611921812*y
          -359771423*y**2-2570705756*y**3+6146942587*y**4-3924736436*y**5-488771374*y**6
          +1636171258*y**7-678495906*y**8+70611438*y**9+12083317*y**10-416714*y**11
          -576685*y**12+96262*y**13)+r**10*(-1+y)**4*(78378471-39250750*y-256842083*y**2
          +417379774*y**3-253724376*y**4+1697948302*y**5-3239842886*y**6+2138906180*y**7
          -347185449*y**8-165329074*y**9+57483977*y**10+872086*y**11-1674422*y**12
          +170250*y**13)+r**16*(3555781374-9915875416*y+5266988984*y**2+9321952402*y**3
          -9851297549*y**4-5690391848*y**5+13651916377*y**6-7907840578*y**7+1413193406*y**8
          +205825878*y**9-31100576*y**10-20382336*y**11-807231*y**12+2152042*y**13
          -114929*y**14))+r*(-1+y)**2*(-1+r**2+y)**5*(55*r**34*(-1+y)**8+r**32*(
          -1+y)**6*(-1169+2891*y-1861*y**2+515*y**3)+r**30*(-1+y)**4*(-71688
          +230978*y-241019*y**2+81710*y**3+5480*y**4-9660*y**5+1739*y**6)+r**28*(
          -1+y)**2*(13989368-78411814*y+179753715*y**2-217874419*y**3+151044829*y**4
          -60283689*y**5+12996773*y**6-1364661*y**7+89763*y**8+1175*y**9)+r**26*(147065776
          -1066771378*y+3337324439*y**2-5883029418*y**3+6391698101*y**4-4372256826*y**5
          +1811257308*y**6-377185494*y**7-5007352*y**8+20570364*y**9-3835275*y**10
          +217680*y**11-8725*y**12)+(-1+y)**12*(11+99*y+495*y**2+2417*y**3
          +4974*y**4+2078*y**5-2482*y**6-4358*y**7+2199*y**8+1991*y**9-2349*y**10
          +373*y**11+128*y**12+24*y**13)-r**24*(-914987072+6189236306*y-17808643741*y**2
          +27926204153*y**3-24813074145*y**4+10531144441*y**5+1064266542*y**6-3550943102*y**7
          +1707773462*y**8-369468700*y**9+44192911*y**10-5943643*y**11+328523*y**12
          +26065*y**13)+r**2*(-1+y)**10*(1475+9552*y+35530*y**2-32010*y**3-385125*y**4
          -953460*y**5+340516*y**6+1311040*y**7+511145*y**8-802420*y**9-970190*y**10
          +1006282*y**11-249495*y**12+8440*y**13+720*y**14)+r**4*(-1+y)**9*(760128
          +4378378*y+14777413*y**2+27866194*y**3+23237302*y**4-20033664*y**5
          -32522809*y**6-17969404*y**7+43973404*y**8-17544502*y**9+4056011*y**10
          -2462694*y**11+1053566*y**12-176548*y**13+7225*y**14)-r**22*(-268400208
          +1711048238*y-5373777709*y**2+10796926442*y**3-13841834620*y**4+9274618956*y**5
          +471788059*y**6-6237063452*y**7+4942948616*y**8-1645542530*y**9+105268177*y**10
          +84572178*y**11-21436364*y**12+790792*y**13+9425*y**14)+r**6*(-1+y)**8*(
          -20887424-93357290*y-255121929*y**2-242414574*y**3-8186684*y**4+520893844*y**5
          +45438071*y**6-69001676*y**7-480696536*y**8+436760934*y**9-116014195*y**10
          -2660006*y**11+5432580*y**12-784240*y**13+39125*y**14)+r**8*(-1+y)**7*(80508472
          +260842614*y+569840915*y**2-450974846*y**3-445144694*y**4-1045230298*y**5
          +2128136423*y**6-1423625124*y**7+572765588*y**8-194339206*y**9+66130001*y**10
          -18628062*y**11+4923434*y**12-1180342*y**13+135125*y**14)+r**10*(-1
          +y)**6*(-997350440-1691176054*y-2161565359*y**2+6458255650*y**3+1869540616*y**4
          +2512289854*y**5-16959642473*y**6+13895644552*y**7-2294697416*y**8-1630468478*y**9
          +768549711*y**10-105849498*y**11+6637832*y**12-1702234*y**13+321737*y**14)
          +r**18*(-1+y)**2*(-21464732546+80084335418*y-94166632275*y**2+11006026918*y**3
          +49762915502*y**4-16290011486*y**5-20044465389*y**6+9592091992*y**7+5410988386*y**8
          -4937597702*y**9+1210156907*y**10-49186654*y**11-10484542*y**12+485546*y**13
          +353925*y**14)+r**12*(-1+y)**5*(-2962785336-1299152086*y+822920757*y**2
          +10415132474*y**3-3496526810*y**4-12294826868*y**5+9029674107*y**6+2033454036*y**7
          -3873416148*y**8+966167730*y**9+277409179*y**10-174440046*y**11+36926182*y**12
          -4405576*y**13+548405*y**14)+r**16*(-1+y)**3*(-36057039998+78996220630*y
          -25665244733*y**2-53907218698*y**3+16916999192*y**4+57885030698*y**5
          -49074055893*y**6+3290362788*y**7+11342421858*y**8-5353479742*y**9+1037638625*y**10
          -122180362*y**11+26619220*y**12-3790610*y**13+597025*y**14)+r**14*(-1
          +y)**4*(-15844558024+14193547926*y+7326717511*y**2+38252996058*y**3
          -97714128676*y**4+53843946232*y**5+20577360027*y**6-28618156188*y**7
          +6467116728*y**8+1429901446*y**9-381702483*y**10-155945278*y**11+61356852*y**12
          -6717236*y**13+677105*y**14)+r**20*(12414648592-74537652958*y+182652788711*y**2
          -219150562991*y**3+94072277508*y**4+76732714698*y**5-124636788589*y**6
          +62473124073*y**7-5095455208*y**8-7606391946*y**9+3016296133*y**10-313264053*y**11
          -27675884*y**12+5452574*y**13+376513*y**14+112827*y**15))))/(-2612736000*logy**5*r**20*(
          -1+y)**10+10500*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-1088640000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-181440000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-15120000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -630000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*muWC*(-435456000*logy**5*r**19*(-6-5*r**2+5*r**6
          +6*r**8)*(-1+y)**10-1036800*logy**4*r**15*(-1+y)**7*(1650*r**16*(-1+y)**3
          +r**14*(-1507+4521*y-4521*y**2-173*y**3+840*y**4)-14*r**12*(682-1146*y
          -204*y**2+1623*y**3-955*y**4+135*y**5)+35*r**10*(193-879*y+1329*y**2
          -993*y**3+330*y**4-68*y**5+20*y**6)-10*(-1+y)**3*(-165+595*y**3-784*y**4
          +378*y**5-70*y**6+4*y**7)+70*r**8*(170-510*y+510*y**2-145*y**3-223*y**4
          +289*y**5-146*y**6+28*y**7)+r**2*(-1+y)**3*(1507-6230*y**3+5075*y**4
          -1652*y**5+40*y**7)+35*r**6*(193-279*y-171*y**2+477*y**3-503*y**4
          +459*y**5-247*y**6+47*y**7)-14*r**4*(682-2946*y+4296*y**2-2437*y**3
          +315*y**4+73*y**5-49*y**6+114*y**7-58*y**8+10*y**9))-172800*logy**3*r**11*(
          -1+y)**5*(-1+r**2+y)**2*(723*r**20*(-1+y)**5-r**18*(-1+y)**2*(5707
          -18567*y+21459*y**2-9009*y**3+1354*y**4)-r**16*(-1+y)**2*(60279-154097*y
          +122586*y**2-15539*y**3-12603*y**4+1760*y**5)+r**14*(-48134+258720*y
          -571533*y**2+560707*y**3-154096*y**4-131510*y**5+114907*y**6-34885*y**7
          +4354*y**8)+r**10*y*(-83698+292943*y-714609*y**2+1163617*y**3-988421*y**4
          +283353*y**5+152425*y**6-143235*y**7+39767*y**8-3612*y**9)+(-1+y)**5*(
          -723-1446*y-2169*y**2+4691*y**3+222*y**4+1395*y**5-5664*y**6+4002*y**7
          -990*y**8+52*y**9)+r**12*(-124852+433658*y-568504*y**2+127758*y**3
          +453503*y**4-477945*y**5+164298*y**6-2176*y**7-9723*y**8+1603*y**9)
          -r**2*(-1+y)**4*(-5707-7153*y-8599*y**2+29867*y**3-11485*y**4+9817*y**5
          -28619*y**6+23373*y**7-6932*y**8+556*y**9+52*y**10)-r**4*(-1+y)**3*(60279
          -26740*y-4771*y**2-189298*y**3+306473*y**4-200264*y**5+97971*y**6
          -54288*y**7+23694*y**8-5002*y**9+346*y**10)+r**6*(-1+y)**2*(48134-30084*y
          -57*y**2-317809*y**3+591227*y**4-404089*y**5+144529*y**6-64003*y**7
          +38519*y**8-13047*y**9+1640*y**10)+r**8*(124852-565158*y+1028754*y**2
          -1222326*y**3+1303981*y**4-1053479*y**5+384867*y**6+101486*y**7-148079*y**8
          +53299*y**9-8953*y**10+756*y**11))-576*logy**2*r**7*(-1+y)**3*(-1+r**2
          +y)**3*(1683*r**26*(-1+y)**7-r**24*(-1+y)**4*(69846-214587*y+224685*y**2
          -83633*y**3+12349*y**4)-r**22*(-1+y)**2*(1628249-7705132*y+14437373*y**2
          -13232895*y**3+5772655*y**4-829354*y**5-90293*y**6+8997*y**7)+r**20*(
          -1+y)**2*(-5143687+25030769*y-49379212*y**2+46947335*y**3-19598590*y**4
          +683547*y**5+1969306*y**6-573183*y**7+56265*y**8)+5*r**18*(-1+y)**2*(
          -7492324+29560079*y-43248313*y**2+23811101*y**3+4382982*y**4-10596656*y**5
          +3849833*y**6-312923*y**7-22950*y**8+1831*y**9)+(-1+y)**9*(-1683-8415*y
          -25245*y**2-37660*y**3-3015*y**4+83121*y**5-36785*y**6-11380*y**7+15960*y**8
          -7810*y**9+1412*y**10)+r**16*(689871+24727458*y-166094874*y**2+358927835*y**3
          -272062175*y**4-123323652*y**5+371389724*y**6-270789792*y**7+81771565*y**8
          +63150*y**9-6901444*y**10+1700493*y**11-112159*y**12)-r**2*(-1+y)**7*(69846
          +214587*y+439272*y**2-225085*y**3-187005*y**4-610102*y**5+372016*y**6
          +171591*y**7+113985*y**8-316795*y**9+158806*y**10-27528*y**11+1412*y**12)
          +r**10*(-1+y)**3*(689871-30246426*y+26313720*y**2+183591460*y**3-394989985*y**4
          +295242648*y**5-78305318*y**6-4649085*y**7+1763090*y**8+1567560*y**9
          -411344*y**10+7719*y**11+7090*y**12)+r**6*(-1+y)**5*(-5143687-4456021*y
          -5149027*y**2+27367720*y**3-11265135*y**4+10328034*y**5-41948368*y**6
          +42744519*y**7-17562020*y**8+2518535*y**9+161103*y**10-83011*y**11+9358*y**12)
          -5*r**8*(-1+y)**4*(-7492324+7901541*y+68763*y**2+18273051*y**3-41444589*y**4
          +37205514*y**5-23877004*y**6+14013353*y**7-5024851*y**8+75079*y**9+559805*y**10
          -148122*y**11+10184*y**12)+r**4*(-1+y)**6*(1628249+2820385*y+3911856*y**2
          -10341605*y**3+1955835*y**4-2239578*y**5+9411320*y**6-7768677*y**7+3274580*y**8
          -1481035*y**9+629354*y**10-147430*y**11+12746*y**12)+r**12*(-1+y)**2*(20351278
          -125582414*y+279984826*y**2-442509860*y**3+489004930*y**4-222594116*y**5
          -132391042*y**6+209846683*y**7-89802315*y**8+6939770*y**9+5451238*y**10
          -1563619*y**11+134641*y**12)+r**14*(-20351278+57579088*y-7971522*y**2
          -240186858*y**3+576297420*y**4-634782114*y**5+276440174*y**6+115697349*y**7
          -202217364*y**8+98833055*y**9-20271908*y**10+743413*y**11+179198*y**12
          +11347*y**13))+24*logy*r**3*(-1+y)**3*(-1+r**2+y)**4*(r**30*(-1+y)**4*(2367
          -7101*y+7101*y**2-2119*y**3+248*y**4)-2*r**28*(-1+y)**2*(-207498+1001832*y
          -1916886*y**2+1810091*y**3-852186*y**4+176532*y**5-9426*y**6+581*y**7)
          +2*(-1+y)**11*y**3*(267+3113*y+10358*y**2-1168*y**3-14895*y**4+4573*y**5
          +3562*y**6-1998*y**7+388*y**8)+r**26*(6848455-46175245*y+132887205*y**2
          -210976287*y**3+199478003*y**4-112918861*y**5+36115435*y**6-5319365*y**7
          -14418*y**8+82502*y**9-3424*y**10)+2*r**24*(35400632-221541388*y+582848054*y**2
          -821722949*y**3+643898580*y**4-242394826*y**5-1561452*y**6+34460576*y**7
          -10166566*y**8+808760*y**9-26536*y**10+3315*y**11)+r**22*(61247643-412515509*y
          +1227863919*y**2-1936952829*y**3+1560720230*y**4-355324274*y**5-408531590*y**6
          +374767462*y**7-131997781*y**8+21529935*y**9-636829*y**10-333561*y**11
          +17584*y**12)-2*r**20*(-474333138+2535639376*y-5399101858*y**2+5318711155*y**3
          -1234312358*y**4-2453641283*y**5+2542151378*y**6-887048555*y**7-24484402*y**8
          +97664793*y**9-23290194*y**10+1732606*y**11+21748*y**12+3732*y**13)
          +r**18*(-858789357+3753131767*y-5013289367*y**2+889533185*y**3+1973068214*y**4
          +1872648182*y**5-5439805286*y**6+3538972422*y**7-395290117*y**8-544624025*y**9
          +273772925*y**10-46150231*y**11+503220*y**12+408332*y**13-29864*y**14)
          -2*r**4*(-1+y)**7*(-207498-794334*y-1916886*y**2-647347*y**3+2090887*y**4
          +5429883*y**5-6115155*y**6+1211249*y**7+697271*y**8-432267*y**9+51615*y**10
          +88414*y**11-57388*y**12+6226*y**13+330*y**14)+2*r**16*y*(1076812520
          -4845656340*y+9301785407*y**2-8806175888*y**3+1555363036*y**4+6264822350*y**5
          -7860118680*y**6+4249700576*y**7-842301634*y**8-216396682*y**9+146826855*y**10
          -26058780*y**11+1479442*y**12-82828*y**13+646*y**14)-r**2*(-1+y)**8*(2367
          +11835*y+35505*y**2+64281*y**3-155302*y**4-482862*y**5+670722*y**6
          -115538*y**7-390145*y**8+451051*y**9-163555*y**10-18807*y**11+28208*y**12
          -8536*y**13+776*y**14)+r**6*(-1+y)**6*(-6848455-18781425*y-35452200*y**2
          +29920348*y**3+2025161*y**4+37113315*y**5-6085620*y**6-33014040*y**7
          -11481061*y**8+42201173*y**9-23615660*y**10+4984220*y**11-169285*y**12
          -47687*y**13+1216*y**14)-2*r**8*(-1+y)**5*(-35400632-44538228*y-50688822*y**2
          +241965915*y**3-93308961*y**4+23399867*y**5-214154291*y**6+255139872*y**7
          -139396842*y**8+48942360*y**9-11784460*y**10+725569*y**11+396975*y**12
          -85923*y**13+6601*y**14)+r**14*(-1+y)**2*(858789357-3117183089*y+2787468994*y**2
          +4641057758*y**3-11499880853*y**4+7364978793*y**5+1239511180*y**6-3449614796*y**7
          +1110657731*y**8+284283633*y**9-248626550*y**10+50815534*y**11-1136123*y**12
          -653289*y**13+13720*y**14)-2*r**12*(-1+y)**3*(-474333138+784692590*y
          -146261500*y**2+753342291*y**3-2817613867*y**4+3331325413*y**5-2004053833*y**6
          +606165272*y**7+83974450*y**8-196398954*y**9+88997900*y**10-16769407*y**11
          +894903*y**12+10659*y**13+14221*y**14)-r**10*(-1+y)**4*(61247643+45029651*y
          +84001019*y**2-331660149*y**3-168573084*y**4-198755472*y**5+1732904842*y**6
          -1942887634*y**7+770380967*y**8-6234253*y**9-75370021*y**10+15272007*y**11
          +706490*y**12-453718*y**13+41712*y**14))-2*r*(-1+y)*(-1+r**2+y)**5*(11*r**34*(
          -1+y)**9+r**32*(-1+y)**6*(661-1928*y+1818*y**2-588*y**3+95*y**4)
          +r**30*(-1+y)**4*(-172110+828896*y-1577197*y**2+1460761*y**3-670830*y**4
          +151296*y**5-14651*y**6+255*y**7)-r**28*(-1+y)**2*(8719198-56883330*y
          +156883043*y**2-236047922*y**3+208321104*y**4-107378082*y**5+29619416*y**6
          -3078022*y**7-144362*y**8+9612*y**9+225*y**10)-(-1+y)**12*(-11-88*y
          -396*y**2-854*y**3-5901*y**4-19180*y**5+7768*y**6+26628*y**7-22997*y**8
          -3624*y**9+9716*y**10-2830*y**11+493*y**12+76*y**13)-r**26*(56893562
          -469305532*y+1705597977*y**2-3561789325*y**3+4667427053*y**4-3916557089*y**5
          +2026144780*y**6-543369428*y**7+1826010*y**8+43926712*y**9-12117653*y**10
          +1404377*y**11-89969*y**12+2925*y**13)-r**24*(478084378-3694875518*y
          +12393895569*y**2-23295971946*y**3+26060590370*y**4-16104629946*y**5
          +2551642003*y**6+3932405816*y**7-3288969162*y**8+1133698378*y**9-171491977*y**10
          +5012770*y**11+701470*y**12-76162*y**13+6357*y**14)+r**2*(-1+y)**10*(
          -661-3911*y-13496*y**2+28370*y**3+39145*y**4-132643*y**5-689828*y**6
          +187812*y**7+1555245*y**8-1091465*y**9-211896*y**10+411814*y**11-152641*y**12
          +18835*y**13-780*y**14+100*y**15)+r**22*(673596282-5014800248*y+15526414467*y**2
          -26174260623*y**3+26351699814*y**4-16615076124*y**5+7247943111*y**6-2829964779*y**7
          +972552786*y**8-4212148*y**9-233546923*y**10+134036687*y**11-40345138*y**12
          +6179912*y**13-189791*y**14+715*y**15)+r**4*(-1+y)**9*(-172110-828896*y
          -2406093*y**2-2382675*y**3+4498746*y**4+13794708*y**5-19600851*y**6
          +7197363*y**7+12110562*y**8-16539700*y**9+5479481*y**10+1272647*y**11
          -1347070*y**12+326288*y**13-31721*y**14+1321*y**15)+r**6*(-1+y)**8*(8719198
          +30725736*y+69273977*y**2+4877811*y**3-45790630*y**4-128503220*y**5
          +108357829*y**6+14222527*y**7+9043534*y**8-58114484*y**9+36777847*y**10
          -9551515*y**11+362346*y**12+437680*y**13-106661*y**14+8025*y**15)+r**8*(
          -1+y)**7*(-56893562-127944160*y-212473747*y**2+368360783*y**3-145295116*y**4
          +191058340*y**5+181801511*y**6-411904785*y**7-169225910*y**8+479124748*y**9
          -257053553*y**10+45692249*y**11+1152332*y**12-486048*y**13-182707*y**14
          +29625*y**15)+r**10*(-1+y)**6*(478084378+348284872*y+264414399*y**2
          -3369219631*y**3+1736907296*y**4+45368608*y**5+3891445775*y**6-6154747289*y**7
          +3406267126*y**8-636371648*y**9-142820391*y**10+89944903*y**11-17987760*y**12
          +2410280*y**13-518823*y**14+73905*y**15)+r**18*(-1+y)**2*(14380443136
          -68738031830*y+120784182151*y**2-86198329259*y**3-2457423682*y**4+40381669490*y**5
          -21234707233*y**6+2635247975*y**7-233118740*y**8+1152018026*y**9-715181251*y**10
          +166833063*y**11-11506426*y**12-663126*y**13-64819*y**14+96525*y**15)
          +r**12*(-1+y)**5*(673596282-373970008*y-716491373*y**2-3330793819*y**3
          +8126443262*y**4-745860244*y**5-11068087539*y**6+10052802411*y**7-1622995242*y**8
          -1907929824*y**9+951342517*y**10-70261453*y**11-46540238*y**12+11720236*y**13
          -1313813*y**14+130845*y**15)+r**16*(-1+y)**3*(14380443136-46305513258*y
          +42270367149*y**2+14991052747*y**3-38111300310*y**4-10518213450*y**5
          +49786263943*y**6-32961847521*y**7+3035222388*y**8+5902353002*y**9-2951704461*y**10
          +535577865*y**11-31993678*y**12+1737690*y**13-758967*y**14+153725*y**15)
          +r**14*(-1+y)**4*(7064801654-13704410432*y+3841552249*y**2-10289187445*y**3
          +47481067702*y**4-56678576516*y**5+22625195653*y**6+4709108391*y**7-7074897006*y**8
          +2272353160*y**9-364850341*y**10+108413729*y**11-53520590*y**12+12980876*y**13
          -1606537*y**14+167453*y**15)+r**20*(-7064801654+49878804454*y-148539128337*y**2
          +234847231250*y**3-190815640871*y**4+28005388490*y**5+97920702637*y**6
          -97952080946*y**7+36636185955*y**8+1561785842*y**9-6388167263*y**10+2122833974*y**11
          -183513217*y**12-36930530*y**13+7523779*y**14-228598*y**15+35035*y**16))))/(
          -1959552000*logy**5*r**20*(-1+y)**10+7875*(r**8*(-1+y)**2-6*r**4*y*(2
          -3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)
          -(-1+y)**3*(-1-y-y**2+y**3))**5-816480000*logy**4*r**16*(-1+y)**8*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-136080000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          -11340000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**3-472500*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2
          -3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)
          +r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((muG*(-217728000*logy**5*r**17*(
          -42-21*r**2-11*r**4+14*r**6+31*r**8+27*r**10)*(-1+y)**10+518400*logy**4*r**13*(
          -1+y)**7*(9398*r**18*(-1+y)**3+35*r**16*(637-1911*y+1911*y**2-1099*y**3
          +222*y**4)-2*r**14*(-39428+89934*y-47409*y**2+1593*y**3+4445*y**4
          +315*y**5)+4*(-1+y)**4*(194+194*y+194*y**2-3621*y**3+2854*y**4-590*y**5
          +40*y**6)+35*r**12*(-483+3309*y-6099*y**2+2717*y**3+44*y**4-218*y**5
          +50*y**6)-70*r**2*(-1+y)**3*(97+239*y**3-648*y**4+424*y**5-134*y**6
          +16*y**7)-14*r**10*(5544-18732*y+21882*y**2-5759*y**3-4960*y**4+5975*y**5
          -3070*y**6+470*y**7)-7*r**8*(8081-20943*y+15993*y**2+679*y**3-5185*y**4
          +4639*y**5-707*y**6-1933*y**7+576*y**8)-r**4*(-1+y)**2*(-96289+184489*y
          -44100*y**2-123060*y**3+164675*y**4-130431*y**5+52976*y**6-10160*y**7
          +640*y**8)+70*r**6*(-636+1278*y-333*y**2+133*y**3-1646*y**4+2515*y**5
          -2319*y**6+1340*y**7-370*y**8+38*y**9))+17280*logy**3*r**9*(-1+y)**5*(
          -1+r**2+y)**2*(27842*r**22*(-1+y)**5-r**20*(-1+y)**2*(139939-475501*y
          +586869*y**2-251836*y**3+47729*y**4)-r**18*(-1+y)**2*(1202104-2814114*y
          +1877124*y**2+310807*y**3-510840*y**4+54219*y**5)-2*(-1+y)**6*(-2343
          -7029*y-14058*y**2+415*y**3-155*y**4+7948*y**5+3094*y**6-4142*y**7
          +520*y**8)+r**16*(2488762-9284160*y+10967961*y**2-4552277*y**3+991750*y**4
          -1962892*y**5+2040355*y**6-903041*y**7+140042*y**8)+2*r**14*(4313579
          -16971652*y+23072753*y**2-12355200*y**3+329405*y**4+2996986*y**5-2140233*y**6
          +875007*y**7-196000*y**8+15855*y**9)+r**2*(-1+y)**5*(16526+23680*y
          +21462*y**2-229013*y**3+34325*y**4-85461*y**5-44765*y**6+211728*y**7
          -114922*y**8+19440*y**9)+r**12*(3551678-16838460*y+29048517*y**2-28420153*y**3
          +18855775*y**4-5439685*y**5-3154745*y**6+3638828*y**7-1821502*y**8+573720*y**9
          -67473*y**10)-r**8*(-1+y)**2*(8949136-21148746*y+10440651*y**2+20113543*y**3
          -39132605*y**4+33931015*y**5-16157919*y**6+3516659*y**7-35383*y**8-127335*y**9
          +12184*y**10)-2*r**6*(-1+y)**3*(-218726+305957*y+138086*y**2-1724133*y**3
          +4626545*y**4-4911123*y**5+2626743*y**6-944471*y**7+323413*y**8-106950*y**9
          +15909*y**10)+r**4*(-1+y)**4*(-182723-113283*y-76345*y**2+2181956*y**3
          -2281830*y**4+649398*y**5+802088*y**6-1081765*y**7+636244*y**8-172060*y**9
          +16320*y**10)+r**10*(-3968562+13327224*y-11656278*y**2-20554674*y**3
          +62492920*y**4-71438192*y**5+46526410*y**6-17503077*y**7+1978444*y**8
          +1224850*y**9-484526*y**10+55461*y**11))-288*logy**2*r**5*(-1+y)**3*(
          -1+r**2+y)**3*(-13141*r**28*(-1+y)**7+r**26*(-1+y)**4*(548348-1684467*y
          +1763313*y**2-641502*y**3+100908*y**4)+r**24*(-1+y)**2*(11143043-52388122*y
          +97379591*y**2-87809250*y**3+36620695*y**4-4172368*y**5-933973*y**6
          +56384*y**7)-r**22*(-1+y)**2*(-9487371+52349871*y-122952180*y**2+127052430*y**3
          -45148765*y**4-11310629*y**5+13112374*y**6-4131150*y**7+440920*y**8)
          +r**20*(-1+y)**2*(140326162-518627219*y+681070267*y**2-219623830*y**3
          -304349810*y**4+307657113*y**5-84484501*y**6+6868*y**7+1384170*y**8
          +7780*y**9)+2*(-1+y)**9*(2334+11670*y+35010*y**2+54175*y**3+30060*y**4
          -62058*y**5-47470*y**6-19685*y**7+77550*y**8-31910*y**9+2824*y**10)
          +r**2*(-1+y)**8*(-80519-336080*y-875210*y**2-568875*y**3-417575*y**4
          +392258*y**5-106450*y**6+125585*y**7+534700*y**8-173700*y**9-177414*y**10
          +59280*y**11)+r**6*(-1+y)**6*(5927663+5882269*y+2920728*y**2-50723190*y**3
          +25259030*y**4-17699856*y**5-26954018*y**6+81069264*y**7-63055085*y**8
          +19369045*y**9-2179732*y**10-57776*y**11+11658*y**12)+r**4*(-1+y)**7*(1195432
          +2998377*y+5270664*y**2-697840*y**3+1460380*y**4+1228816*y**5+1769386*y**6
          -399088*y**7-2795060*y**8+461195*y**9+1026102*y**10-548588*y**11+76224*y**12)
          +r**12*(-1+y)**3*(-909586273+2566982290*y-1838422020*y**2-2265951710*y**3
          +5447471795*y**4-4753693494*y**5+2140225450*y**6-285565560*y**7-208164515*y**8
          +114910880*y**9-22538558*y**10+757410*y**11+120305*y**12)-r**8*(-1+y)**5*(11431671
          -9648537*y-16923279*y**2-222312505*y**3+337384400*y**4-54373972*y**5
          -248970156*y**6+320062398*y**7-203860945*y**8+67467125*y**9-7305649*y**10
          -763557*y**11+170006*y**12)+r**10*(-1+y)**4*(6325006-65526555*y+561435*y**2
          +777597650*y**3-1906854780*y**4+2168609748*y**5-1323220300*y**6+391283560*y**7
          -9199650*y**8-36042195*y**9+14398871*y**10-3272220*y**11+249430*y**12)
          -2*r**14*(-1+y)**2*(-39199507-100111807*y+634941821*y**2-1363290245*y**3
          +1369992805*y**4-423905561*y**5-345131221*y**6+385338833*y**7-154498880*y**8
          +10192295*y**9+16330643*y**10-5230797*y**11+473621*y**12)+r**18*(-375769187
          +1944432254*y-3771026202*y**2+3285179875*y**3-1058288645*y**4+115570044*y**5
          -589331928*y**6+704064599*y**7-268394650*y**8-22063230*y**9+47088118*y**10
          -12142926*y**11+821878*y**12)-2*r**16*(390508943-2177796134*y+4767023289*y**2
          -5089430153*y**3+2208067520*y**4+986643894*y**5-2187897922*y**6+1682190032*y**7
          -711184414*y**8+118705655*y**9+24187413*y**10-11908619*y**11+749579*y**12
          +140917*y**13))+12*logy*r*(-1+y)**3*(-1+r**2+y)**4*(69*r**34*(-1+y)**7
          -r**32*(-1+y)**4*(14403-43485*y+44037*y**2-10573*y**3+578*y**4)+2*r**30*(
          -1+y)**2*(-1688448+8155800*y-15610317*y**2+14725170*y**3-6918972*y**4
          +1446294*y**5-85771*y**6+6644*y**7)+2*(-1+y)**12*(-23-207*y-1035*y**2
          -3209*y**3-5249*y**4-1129*y**5+4927*y**6+5925*y**7-1756*y**8-3996*y**9
          +1552*y**10)+r**28*(-48930895+329130265*y-944944869*y**2+1493340593*y**3
          -1399225705*y**4+779819483*y**5-243653285*y**6+34722439*y**7+318752*y**8
          -637500*y**9+20722*y**10)+r**26*(-409831092+2516289160*y-6463669882*y**2
          +8759171824*y**3-6281600469*y**4+1666614539*y**5+700737587*y**6-631190453*y**7
          +153453581*y**8-10593191*y**9+575123*y**10-80727*y**11)+r**24*(522908059
          -2828954337*y+5607875059*y**2-5127033983*y**3+2419346594*y**4-1451764592*y**5
          +1791165692*y**6-1420825998*y**7+622393783*y**8-141941559*y**9+5636953*y**10
          +2783125*y**11-132796*y**12)+r**2*(-1+y)**9*(-12835-76826*y-268247*y**2
          -579710*y**3-604564*y**4+189946*y**5+775668*y**6+674790*y**7-922069*y**8
          +241064*y**9+26139*y**10-98192*y**11+35732*y**12+3104*y**13)+2*r**22*(
          -2287883112+12017238816*y-24755844031*y**2+22138363376*y**3-640969014*y**4
          -16152305043*y**5+13330810808*y**6-3084221371*y**7-1279357678*y**8+865260709*y**9
          -162751425*y**10+8599971*y**11+121772*y**12+66222*y**13)-r**8*(-1+y)**6*(
          -47062225-96369475*y-145305796*y**2+110987966*y**3-16556229*y**4-118855987*y**5
          -110957362*y**6+138017790*y**7-6052489*y**8+45114101*y**9-93696138*y**10
          +46163612*y**11-8535769*y**12+196473*y**13+7528*y**14)+2*r**6*(-1+y)**7*(
          -1664184-6281768*y-15404831*y**2-5753601*y**3-16119164*y**4-15797985*y**5
          -21188367*y**6+6969679*y**7+43716319*y**8-19165735*y**9-8613856*y**10
          +6086910*y**11-635023*y**12-45668*y**13+11274*y**14)+r**4*(-1+y)**8*(821971
          +3936947*y+11403689*y**2+14028119*y**3+6538956*y**4-15984932*y**5-4600604*y**6
          -1145888*y**7+10801417*y**8-7865647*y**9+817611*y**10+932657*y**11-52576*y**12
          -72136*y**13+12416*y**14)+r**10*(-1+y)**5*(237745924+47532324*y-215181766*y**2
          -1800066902*y**3+1561396109*y**4-134096652*y**5-1567728317*y**6+4123524668*y**7
          -3963036450*y**8+1615159628*y**9-168306672*y**10-67339582*y**11+23444873*y**12
          -2269148*y**13+101963*y**14)-r**16*(-1+y)**2*(21738576251-68048226203*y
          +60884286174*y**2+35516813944*y**3-111363591119*y**4+85091138195*y**5
          -19051539902*y**6-11946761536*y**7+9203657249*y**8-969063285*y**9-1090103746*y**10
          +338565280*y**11-9929013*y**12-5320843*y**13+122554*y**14)+2*r**14*(
          -1+y)**3*(-208722032-489866296*y+373155051*y**2+12843399061*y**3-34522093597*y**4
          +39946039559*y**5-24079960108*y**6+4557858448*y**7+3824358328*y**8-2992779816*y**9
          +839425273*y**10-71527921*y**11-3053999*y**12-243539*y**13+181588*y**14)
          +r**20*(12331522641-57976558551*y+96632501647*y**2-56833420023*y**3
          -19091543336*y**4+34656298136*y**5-1460600620*y**6-15180424196*y**7+7647105879*y**8
          +96438935*y**9-1149377927*y**10+298213371*y**11-7851376*y**12-3144456*y**13
          +239876*y**14)+r**12*(-1+y)**4*(162609067+188305103*y+148155819*y**2
          +3325811273*y**3-7729842406*y**4+50487418*y**5+10541916856*y**6-11414956526*y**7
          +6197327951*y**8-1583092741*y**9-30655685*y**10+82652541*y**11+5901332*y**12
          -4596524*y**13+420522*y**14)+r**18*(13347092570-76922780090*y+175381064248*y**2
          -198885819826*y**3+84799408315*y**4+82050583519*y**5-168003761285*y**6
          +131859586999*y**7-48278680188*y**8-207281660*y**9+6945014042*y**10-2353780300*y**11
          +275010103*y**12-7493961*y**13+1960195*y**14-122681*y**15))+r*(-1+y)*(
          -1+r**2+y)**5*(213*r**34*(-1+y)**9+r**32*(-1+y)**6*(8683-25812*y+24924*y**2
          -8784*y**3+1569*y**4)+r**30*(-1+y)**4*(-1353172+6549846*y-12537537*y**2
          +11591589*y**3-5215438*y**4+1133324*y**5-107745*y**6+3333*y**7)-r**28*(
          -1+y)**2*(69861412-455056978*y+1252415811*y**2-1877978130*y**3+1648618656*y**4
          -844069602*y**5+231883558*y**6-24855326*y**7-560220*y**8-55436*y**9
          +5055*y**10)+r**26*(-306504612+2486704922*y-8882755911*y**2+18118228327*y**3
          -22833669713*y**4+17790914209*y**5-7744973558*y**6+933462802*y**7+781186158*y**8
          -426906532*y**9+95394533*y**10-11900209*y**11+914239*y**12-38655*y**13)
          +r**24*(-2706526532+20701452158*y-68573142333*y**2+126346224034*y**3
          -135624273306*y**4+73958982950*y**5+2569997351*y**6-33545229876*y**7
          +23347645416*y**8-7506421198*y**9+1060288297*y**10-27167694*y**11-2308426*y**12
          +322890*y**13-67731*y**14)-(-1+y)**11*(-629-3851*y-13472*y**2+60874*y**3
          +309343*y**4+602455*y**5-319568*y**6-1011116*y**7-162103*y**8+516739*y**9
          +554552*y**10-520006*y**11+114413*y**12-13871*y**13-1832*y**14+72*y**15)
          +r**2*(-1+y)**10*(630763+3627965*y+12229226*y**2+21635516*y**3+18699065*y**4
          -11510323*y**5-19383536*y**6-12920428*y**7+23907457*y**8-12291141*y**9
          -2284034*y**10+6096696*y**11-1577173*y**12-373*y**13+19576*y**14+744*y**15)
          +r**4*(-1+y)**9*(-10391692-45092010*y-120255609*y**2-112951367*y**3
          -27388760*y**4+156168646*y**5-103536521*y**6-46872563*y**7-512532*y**8
          +73298874*y**9-14078347*y**10-4841869*y**11-2384328*y**12+2392874*y**13
          -329139*y**14+14343*y**15)+r**22*(10321187492-76740444690*y+241254518919*y**2
          -416737095083*y**3+422938262134*y**4-236069613728*y**5+33967010569*y**6
          +49368355951*y**7-41103343800*y**8+16101175326*y**9-4086441871*y**10
          +1058737571*y**11-326031570*y**12+56036708*y**13-2063985*y**14+30057*y**15)
          +r**6*(-1+y)**8*(-4212292-11697574*y-6915547*y**2-98028769*y**3+398903362*y**4
          +730711432*y**5+67292571*y**6-301795963*y**7-911044344*y**8+671776714*y**9
          +219344515*y**10-237553847*y**11+38822410*y**12+6352388*y**13-1428051*y**14
          +88995*y**15)+r**8*(-1+y)**7*(-534135228-1021749118*y-1458365839*y**2
          +1409562915*y**3+695100716*y**4-19820064*y**5-1725217059*y**6+2195326953*y**7
          -2171769100*y**8+2200870698*y**9-1130949653*y**10+235166277*y**11-2573764*y**12
          +7212660*y**13-2481689*y**14+317295*y**15)+3*r**16*(-1+y)**3*(30544946682
          -109886124776*y+124308837987*y**2+2605689109*y**3-86155274422*y**4-8255344902*y**5
          +109597159319*y**6-77642418337*y**7+5705678134*y**8+15383465556*y**9
          -7226707935*y**10+1198653107*y**11-49810650*y**12+6566682*y**13-2982459*y**14
          +498905*y**15)+r**10*(-1+y)**6*(-2731381604-519792546*y+1474745523*y**2
          +13914983197*y**3-14766173898*y**4-2059541346*y**5+13636560149*y**6-31555905739*y**7
          +35670508148*y**8-15771149282*y**9+848772161*y**10+1298530547*y**11-312171734*y**12
          +38231030*y**13-5291545*y**14+756939*y**15)+r**18*(-1+y)**2*(136379381234
          -653074539256*y+1159210816607*y**2-823666339195*y**3-114521166928*y**4
          +578489700692*y**5-345477710923*y**6+29395513721*y**7+49488570070*y**8
          -15554963644*y**9-3617981891*y**10+2334437179*y**11-268528328*y**12-6655600*y**13
          -680353*y**14+978615*y**15)+r**12*(-1+y)**5*(-7151044612+3514201550*y
          +3689079191*y**2+1851825905*y**3+12529149232*y**4+6451154754*y**5-68836006377*y**6
          +63376767321*y**7-8668696572*y**8-13547951366*y**9+6113980501*y**10+111693427*y**11
          -477479312*y**12+114094742*y**13-12859491*y**14+1291107*y**15)+r**14*(
          -1+y)**4*(-8584005772+20080648130*y-4798453003*y**2-142517315049*y**3
          +421507702050*y**4-530784880524*y**5+306363421443*y**6-14009248191*y**7
          -85074008544*y**8+43540017298*y**9-6753037253*y**10+211162777*y**11-253698006*y**12
          +119264568*y**13-16870323*y**14+1620399*y**15)+r**20*(-48793549420+348777055370*y
          -1052120461755*y**2+1690270919754*y**3-1414715455317*y**4+270602712990*y**5
          +647494086589*y**6-678657193690*y**7+259726523347*y**8+6000907414*y**9
          -39642139465*y**10+11601619222*y**11-159593255*y**12-445780926*y**13
          +61639303*y**14-1682630*y**15+392469*y**16))))/(-20901888000*logy**5*r**20*(
          -1+y)**10+84000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-8709120000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-1451520000*logy**3*r**12*(-1+y)**6*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-120960000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -5040000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*muWC**2*(-217728000*logy**5*r**19*(-33-25*r**2
          +10*r**4+43*r**6+63*r**8)*(-1+y)**10-518400*logy**4*r**15*(-1+y)**6*(11422*r**16*(
          -1+y)**4+3*r**14*(7299-29196*y+43794*y**2-25626*y**3+4639*y**4+770*y**5)
          -14*r**12*(-7126+19054*y-9681*y**2-18406*y**3+23694*y**4-9380*y**5
          +1035*y**6)+10*(-1+y)**4*(793-987*y**3+434*y**4+252*y**5-238*y**6
          +40*y**7)+35*r**10*(-2041+10744*y-21276*y**2+21416*y**3-10575*y**4
          +2426*y**5-404*y**6+118*y**7)+r**2*(-1+y)**4*(11811-6720*y**3-30065*y**4
          +25144*y**5-8120*y**6+880*y**7)+70*r**8*(-1164+4956*y-8034*y**2+5433*y**3
          +1835*y**4-6219*y**5+4893*y**6-1794*y**7+256*y**8)+7*r**6*(-7191+21264*y
          -16896*y**2-13386*y**3+45824*y**4-51284*y**5+28566*y**6-4934*y**7-1819*y**8
          +576*y**9)-14*r**4*(-3602+19358*y-38937*y**2+39138*y**3-20077*y**4
          -1183*y**5+15422*y**6-17333*y**7+9412*y**8-2448*y**9+250*y**10))-17280*logy**3*r**11*(
          -1+y)**4*(-1+r**2+y)**2*(16708*r**20*(-1+y)**6-r**18*(-1+y)**2*(-227761
          +944460*y-1500230*y**2+1083215*y**3-380295*y**4+52291*y**5)-r**16*(
          -1+y)**2*(-2283286+8251442*y-10908352*y**2+5790883*y**3-651257*y**4
          -299021*y**5+28011*y**6)+r**14*(2715616-15980286*y+39580491*y**2-49532708*y**3
          +29908747*y**4-2815486*y**5-7569679*y**6+4829254*y**7-1213707*y**8+121858*y**9)
          -(-1+y)**5*(-22808-22808*y-22808*y**2+217237*y**3-181808*y**4+72068*y**5
          +48478*y**6-241047*y**7+243458*y**8-98422*y**9+14760*y**10)+2*r**12*(3727013
          -16936009*y+30096339*y**2-20100843*y**3-7254360*y**4+19625597*y**5
          -11847826*y**6+2873966*y**7-74002*y**8-90225*y**9+16050*y**10)+r**10*(1327010
          -4620214*y+3456423*y**2+22374898*y**3-66300502*y**4+74194328*y**5-31818434*y**6
          -8291323*y**7+15212172*y**8-6667858*y**9+1264447*y**10-86847*y**11)
          +2*r**4*(-1+y)**3*(780603-1116304*y+272112*y**2-224308*y**3-376463*y**4
          +1439431*y**5-470875*y**6-795707*y**7+589578*y**8-68527*y**9-46559*y**10
          +10719*y**11)-r**2*(-1+y)**4*(117291+45616*y+45616*y**2-408929*y**3
          -79164*y**4+296864*y**5-15336*y**6+487769*y**7-971211*y**8+651424*y**9
          -181520*y**10+17880*y**11)+r**6*(-1+y)**2*(-1748376+3414662*y-1912067*y**2
          +3019488*y**3+885338*y**4-13262440*y**5+15071304*y**6-3885888*y**7-3138198*y**8
          +2465722*y**9-655929*y**10+61384*y**11)+r**8*(-3266726+17908342*y-41201466*y**2
          +60370480*y**3-61432100*y**4+27382572*y**5+24762246*y**6-46594003*y**7
          +30066765*y**8-8901330*y**9+813424*y**10+107807*y**11-16011*y**12))
          -288*logy**2*r**7*(-1+y)**2*(-1+r**2+y)**3*(3977*r**26*(-1+y)**8-r**24*(
          -1+y)**4*(-298732+1206859*y-1840116*y**2+1223069*y**3-398126*y**4
          +55086*y**5)+r**22*(-1+y)**2*(9663455-55881417*y+133883529*y**2-169673237*y**3
          +120440705*y**4-46292395*y**5+8102027*y**6-328799*y**7+23732*y**8)+r**20*(
          -1+y)**2*(50332871-287891298*y+685177503*y**2-851265716*y**3+578960385*y**4
          -199422456*y**5+15966993*y**6+11121982*y**7-3170124*y**8+234560*y**9)
          -5*r**18*(-1+y)**2*(-54184870+270289461*y-538145910*y**2+507814103*y**3
          -169676432*y**4-80688761*y**5+88639914*y**6-27379779*y**7+3197914*y**8
          -296240*y**9+26560*y**10)+(-1+y)**8*(-29659-88977*y-177954*y**2+51235*y**3
          +543230*y**4+773003*y**5-1923496*y**6+1390083*y**7-498535*y**8-577030*y**9
          +1003606*y**10-508202*y**11+84696*y**12)+r**16*(80246041-691831703*y
          +2641667968*y**2-5218106131*y**3+5162487410*y**4-1074129937*y**5-3318208484*y**6
          +4154021549*y**7-2281573413*y**8+563088490*y**9+16884096*y**10-42639738*y**11
          +8642758*y**12-464906*y**13)-5*r**8*(-1+y)**4*(40421250-83407191*y
          +42079458*y**2+19087059*y**3-109031778*y**4+148837686*y**5+1347612*y**6
          -161905098*y**7+137546556*y**8-39581267*y**9-3030726*y**10+4131299*y**11
          -747900*y**12+39040*y**13)+r**2*(-1+y)**7*(306180+701337*y+1185471*y**2
          -3967838*y**3+2305190*y**4-3004620*y**5-4511014*y**6+12652208*y**7-6379714*y**8
          +271035*y**9-936185*y**10+1427702*y**11-565504*y**12+67752*y**13)+r**4*(
          -1+y)**6*(-9232933-6135010*y-5267761*y**2+71200704*y**3-70871210*y**4
          +25914806*y**5+34751750*y**6-115069008*y**7+114691137*y**8-41279690*y**9
          -3187473*y**10+5773760*y**11-1335206*y**12+88134*y**13)-r**6*(-1+y)**5*(
          -20866293-3488496*y-5974074*y**2+20532078*y**3+184736085*y**4-237657864*y**5
          -34158348*y**6+101960708*y**7+67523339*y**8-111676310*y**9+42537482*y**10
          -3315606*y**11-854559*y**12+113858*y**13)+r**10*(-1+y)**3*(55133987
          -33586609*y-91043758*y**2-514150790*y**3+884949385*y**4+368324851*y**5
          -1370144452*y**6+713001376*y**7+172653255*y**8-285987385*y**9+99245562*y**10
          -11908314*y**11-503443*y**12+156335*y**13)+2*r**12*(-1+y)**2*(-42417025
          +300214752*y-879978984*y**2+2095086332*y**3-3155960880*y**4+2075295150*y**5
          +498720726*y**6-1718161397*y**7+1100817826*y**8-268618995*y**9-11923700*y**10
          +18887997*y**11-3632219*y**12+259417*y**13)+2*r**14*(199759963-1072518113*y
          +2260362901*y**2-1582170445*y**3-2051878561*y**4+5159422199*y**5-3985332744*y**6
          +407509578*y**7+1523965890*y**8-1243521113*y**9+469583988*y**10-93537393*y**11
          +8637996*y**12-344745*y**13+60599*y**14))-12*logy*r**3*(-1+y)**2*(-1
          +r**2+y)**4*(387*r**32*(-1+y)**8+r**30*(-1+y)**4*(-3943+14224*y-17466*y**2
          +13714*y**3-4275*y**4+722*y**5)+2*r**28*(-1+y)**2*(588506-3428476*y
          +8261889*y**2-10432585*y**3+7340224*y**4-2858790*y**5+540017*y**6-30325*y**7
          +1300*y**8)-r**26*(-40447079+313740424*y-1060298290*y**2+2033708670*y**3
          -2428597558*y**4+1870321432*y**5-931419172*y**6+290815480*y**7-51681675*y**8
          +3765648*y**9+66862*y**10+1258*y**11)+r**24*(473158420-3473373628*y
          +11017471558*y**2-19597494990*y**3+21167772051*y**4-13903914600*y**5
          +5038517384*y**6-553139280*y**7-249470510*y**8+87726244*y**9-7439990*y**10
          +277374*y**11-15633*y**12)+r**22*(984376489-7039774052*y+21911621312*y**2
          -37549977326*y**3+37121153677*y**4-19135859554*y**5+1192488540*y**6+4998236334*y**7
          -3416131293*y**8+1103312298*y**9-184009060*y**10+13632112*y**11+54879*y**12
          +2044*y**13)+2*r**20*(3018174774-19194347840*y+50912212521*y**2-69556721661*y**3
          +43752240100*y**4+6232950255*y**5-31557975677*y**6+22684380861*y**7-6762791845*y**8
          +128415823*y**9+443654746*y**10-109826508*y**11+11853943*y**12-510194*y**13
          +12702*y**14)-(-1+y)**9*(-1573-7865*y-23595*y**2-43281*y**3-77858*y**4
          -32094*y**5+485030*y**6-187610*y**7-607893*y**8+805611*y**9-419883*y**10
          +22635*y**11+123580*y**12-80276*y**13+17072*y**14)+r**6*(-1+y)**6*(
          -21464901-43298250*y-68760985*y**2+263465290*y**3-312703957*y**4+219060802*y**5
          +789705123*y**6-1698601232*y**7+988564953*y**8+54490502*y**9-217866883*y**10
          +33990302*y**11+18825617*y**12-6317118*y**13+378505*y**14+232*y**15)
          -r**2*(-1+y)**8*(86387+351840*y+895330*y**2+771942*y**3-2495971*y**4
          -5544884*y**5+10411140*y**6-8293080*y**7+619581*y**8+8861772*y**9-7742838*y**10
          +1443570*y**11+374275*y**12-11048*y**13-43776*y**14+7760*y**15)-2*r**4*(
          -1+y)**7*(-2017110-5515434*y-10322849*y**2+13439206*y**3+23348989*y**4
          +34357987*y**5-81196094*y**6+50829946*y**7-22019974*y**8-24355480*y**9
          +52741829*y**10-31320022*y**11+6365903*y**12+239943*y**13-148134*y**14
          +9294*y**15)-r**18*(3873848929-20599303912*y+37338494298*y**2-24292416126*y**3
          -837979793*y**4-8413641516*y**5+37617842616*y**6-37749136164*y**7+11421636959*y**8
          +6132369428*y**9-6319862838*y**10+2076013646*y**11-278580159*y**12+7259792*y**13
          +72340*y**14+30500*y**15)+r**8*(-1+y)**5*(447823708+90870976*y+34040846*y**2
          -2744121552*y**3+3068420659*y**4-767634697*y**5-1088135033*y**6+3345365777*y**7
          -3962133022*y**8+1717123806*y**9+154491364*y**10-363371918*y**11+106299327*y**12
          -10342501*y**13-146665*y**14+36925*y**15)+r**14*(-1+y)**2*(2327500675
          -14221107094*y+24696683421*y**2+14298503706*y**3-80617912701*y**4+69657866682*y**5
          +9807445661*y**6-47297433434*y**7+24135432241*y**8+581588710*y**9-4456572561*y**10
          +1533320758*y**11-192987287*y**12-3206122*y**13+2125591*y**14+51754*y**15)
          +2*r**12*(-1+y)**3*(2686642682-7326944850*y+5457785455*y**2+1789396598*y**3
          -7084229804*y**4+5002821682*y**5+5091800785*y**6-12115347620*y**7+8992631734*y**8
          -2503965582*y**9-418527475*y**10+458038890*y**11-110849260*y**12+7844518*y**13
          -47589*y**14+51836*y**15)+r**10*(-1+y)**4*(3066093-432760036*y-257567936*y**2
          -2424850694*y**3+15102474731*y**4-16799101164*y**5-2990717878*y**6+15789849522*y**7
          -8321398077*y**8-821616812*y**9+1962521564*y**10-567924586*y**11+37313189*y**12
          +4343996*y**13-818694*y**14+70782*y**15)+r**16*(5116233322-16649001932*y
          -2200855190*y**2+104583439350*y**3-230047744371*y**4+202065446412*y**5
          +2813179868*y**6-171161108140*y**7+164283050565*y**8-71655184488*y**9
          +11390459990*y**10+2840757490*y**11-1650266445*y**12+296869960*y**13
          -27679516*y**14+2451876*y**15-48751*y**16))+r*(-1+r**2+y)**5*(35*r**34*(
          -1+y)**10-r**32*(-1+y)**6*(20753-78193*y+107564*y**2-63800*y**3+13263*y**4
          +65*y**5)-r**30*(-1+y)**4*(-324004+1797762*y-4027569*y**2+5055070*y**3
          -3850965*y**4+1635742*y**5-355071*y**6+28386*y**7+2129*y**8)-r**28*(
          -1+y)**2*(39120724-297367890*y+979283553*y**2-1820500021*y**3+2095117198*y**4
          -1544754418*y**5+728492380*y**6-209941552*y**7+32595862*y**8-1928972*y**9
          -565*y**10+8981*y**11)+r**26*(-438309788+4077738650*y-16933940673*y**2
          +41178094542*y**3-64754704928*y**4+68678931914*y**5-49661294611*y**6
          +24069153860*y**7-7351161736*y**8+1157385622*y**9+4895629*y**10-28884034*y**11
          +1863668*y**12+278774*y**13-13289*y**14)+(-1+y)**13*(113+904*y+4068*y**2
          +16070*y**3-18177*y**4-182544*y**5+48*y**6+153204*y**7-172921*y**8
          +22192*y**9+53316*y**10-21642*y**11+9113*y**12+1736*y**13+120*y**14)
          +r**24*(-3059920116+26807489830*y-103837119655*y**2+232182367431*y**3
          -326593275712*y**4+291022335388*y**5-148325551231*y**6+17901193061*y**7
          +30169035076*y**8-22632637666*y**9+7557059339*y**10-1298504919*y**11
          +117433424*y**12-10794752*y**13+748283*y**14+7819*y**15)+r**2*(-1+y)**10*(112155
          +541334*y+1575117*y**2+2883766*y**3+1169061*y**4-4925668*y**5-7978489*y**6
          +3560584*y**7+15685381*y**8-18886874*y**9+11059499*y**10-2945666*y**11
          -2736501*y**12+2677928*y**13-648287*y**14+31364*y**15+1296*y**16)+r**6*(
          -1+y)**8*(62162532+148271066*y+249690899*y**2-506275282*y**3-299734805*y**4
          -613230458*y**5+1050114983*y**6+112137066*y**7+10513543*y**8-242570986*y**9
          -418248831*y**10+556597490*y**11-188525015*y**12+13639114*y**13+2562341*y**14
          -107018*y**15+3361*y**16)+r**4*(-1+y)**9*(-2137884-8056226*y-19333975*y**2
          +5511014*y**3+69070163*y**4+113949870*y**5-279892291*y**6+253984538*y**7
          -10043365*y**8-307520158*y**9+285229555*y**10-77405982*y**11-10336263*y**12
          +8922226*y**13-1102905*y**14-11266*y**15+4949*y**16)-r**8*(-1+y)**7*(70260236
          +155537790*y+297343617*y**2-1032505814*y**3+3573944627*y**4-2209540308*y**5
          -10894470065*y**6+21328328340*y**7-13115328243*y**8-71669090*y**9+3553789007*y**10
          -1500042406*y**11+136009693*y**12+41872632*y**13-8573087*y**14-419160*y**15
          +38231*y**16)+r**22*(227682396-2581452578*y+9691614161*y**2-23349831382*y**3
          +51402484217*y**4-98726505846*y**5+139171334405*y**6-135098361274*y**7
          +89857678277*y**8-40750226686*y**9+11872686427*y**10-1594437018*y**11
          -245325837*y**12+144820630*y**13-22164081*y**14+121898*y**15+50291*y**16)
          -r**18*(-1+y)**2*(-71713776938+414557615550*y-943677483351*y**2+1063417687662*y**3
          -507064888451*y**4-146066257436*y**5+345165697395*y**6-217147185840*y**7
          +87340073419*y**8-35222611650*y**9+13492300479*y**10-2605285882*y**11
          -60020309*y**12+98054144*y**13-14296699*y**14+1737820*y**15+120087*y**16)
          -r**10*(-1+y)**6*(-4004617780+1002948218*y+1095292667*y**2+21078159266*y**3
          -22597056641*y**4-133906720*y**5-5753778779*y**6+18224179804*y**7-3978194519*y**8
          -6941797950*y**9+2704298653*y**10+914689922*y**11-666841671*y**12+109582628*y**13
          -6250909*y**14-1574528*y**15+164339*y**16)-r**16*(-1+y)**3*(-91275686294
          +378118719458*y-536039678913*y**2+107906028694*y**3+433963650965*y**4
          -255742217904*y**5-326969810891*y**6+474668030888*y**7-204408564501*y**8
          -6992561518*y**9+38993379457*y**10-14924926170*y**11+2468736875*y**12
          -188923268*y**13+6750603*y**14-581284*y**15+341803*y**16)-r**12*(-1
          +y)**5*(-9994102348+15052316018*y+2329882799*y**2+47197871202*y**3-183337171635*y**4
          +179084314750*y**5+13946233231*y**6-128329307654*y**7+73819934985*y**8
          +872318974*y**9-15924003467*y**10+6126340678*y**11-790092345*y**12-43567662*y**13
          +11189261*y**14-2343010*y**15+346223*y**16)-r**14*(-1+y)**4*(-53406991772
          +152804611862*y-120357853035*y**2+37497778522*y**3-160977617331*y**4
          +304457997150*y**5-209815651523*y**6+44263599154*y**7+5348416605*y**8
          +4982648066*y**9-3448515545*y**10-1326372306*y**11+1137602831*y**12-280496502*y**13
          +24792615*y**14-2232058*y**15+443267*y**16)+r**20*(-37309129596+299212060786*y
          -1038435675577*y**2+2003336813873*y**3-2229073989935*y**4+1157357218159*y**5
          +353785937259*y**6-1021419035999*y**7+701088665829*y**8-174866210805*y**9
          -51859725355*y**10+52123318939*y**11-16027555661*y**12+2174871973*y**13
          -84852935*y**14-1012333*y**15-1732909*y**16+34287*y**17))))/(-15676416000*logy**5*r**20*(
          -1+y)**10+63000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-6531840000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-1088640000*logy**3*r**12*(-1+y)**6*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-90720000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -3780000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((rhoLS*(217728000*logy**5*r**17*(-6+71*r**2+129*r**4
          +146*r**6+95*r**8+27*r**10)*(-1+y)**10+518400*logy**4*r**13*(-1+y)**6*(
          -10894*r**18*(-1+y)**4-5*r**16*(-4787+19148*y-28722*y**2+23054*y**3
          -8903*y**4+1218*y**5)+r**14*(118448-417092*y+512238*y**2-267852*y**3
          +27868*y**4+15680*y**5-630*y**6)-20*(-1+y)**5*(15+15*y+15*y**2-202*y**3
          +190*y**4-62*y**5+8*y**6)-7*r**12*(-21781+58624*y-30936*y**2-33216*y**3
          +42229*y**4-12710*y**5-340*y**6+170*y**7)+2*r**2*(-1+y)**4*(-4201+21805*y**3
          -34510*y**4+18536*y**5-4130*y**6+400*y**7)+70*r**10*(472+2492*y-12498*y**2
          +17017*y**3-8801*y**4-49*y**5+1797*y**6-708*y**7+116*y**8)+r**4*(-1
          +y)**3*(16763-4163*y-6300*y**2-63700*y**3+132195*y**4-110383*y**5
          +42448*y**6-5920*y**7+320*y**8)+7*r**8*(-16293+103872*y-233208*y**2
          +229842*y**3-77948*y**4-36572*y**5+42578*y**6-14702*y**7+1423*y**8
          +288*y**9)-70*r**6*(2544-12306*y+22719*y**2-19506*y**3+6393*y**4+955*y**5
          -168*y**6-1411*y**7+1046*y**8-288*y**9+22*y**10))-17280*logy**3*r**9*(
          -1+y)**4*(-1+r**2+y)**2*(25246*r**22*(-1+y)**6-r**20*(-1+y)**2*(-190205
          +811312*y-1343198*y**2+1001817*y**3-372103*y**4+64057*y**5)-r**18*(
          -1+y)**2*(-1428628+4838134*y-5795634*y**2+2162321*y**3+580701*y**4
          -456611*y**5+28137*y**6)-10*(-1+y)**7*(-92-276*y-552*y**2+181*y**3
          -276*y**4+65*y**5+798*y**6-582*y**7+104*y**8)+r**16*(-3450924+17159746*y
          -32510361*y**2+30649630*y**3-15016611*y**4+4321314*y**5-2758851*y**6
          +2551516*y**7-1040185*y**8+138826*y**9)+2*r**14*(-7151703+36698903*y
          -73940211*y**2+74119845*y**3-33652849*y**4-2941477*y**5+11261157*y**6
          -5357904*y**7+1106975*y**8-108911*y**9+1875*y**10)+r**2*(-1+y)**5*(7686
          +9526*y+11366*y**2-61809*y**3-11504*y**4+54464*y**5+159954*y**6-393711*y**7
          +305114*y**8-98666*y**9+11280*y**10)-2*r**6*(-1+y)**3*(-1027468+1378203*y
          -284349*y**2+3755511*y**3-11121974*y**4+12745632*y**5-7284960*y**6+2068594*y**7
          -215656*y**8+7639*y**9-17239*y**10+5517*y**11)+r**4*(-1+y)**4*(-108779
          -53212*y-37972*y**2+533883*y**3-270092*y**4-152564*y**5-444828*y**6
          +1196517*y**7-1023513*y**8+445912*y**9-99812*y**10+8160*y**11)-r**8*(
          -1+y)**2*(3291188-6157774*y+2650859*y**2-13450756*y**3+43596054*y**4
          -58663912*y**5+41572072*y**6-15400854*y**7+1879416*y**8+588036*y**9
          -233281*y**10+26552*y**11)-r**12*(20728170-106478482*y+217201689*y**2
          -222973326*y**3+105472214*y**4+11165204*y**5-45963642*y**6+28267761*y**7
          -9005544*y**8+1782946*y**9-270859*y**10+29769*y**11)+r**10*(-15910070
          +80986702*y-166327542*y**2+181921460*y**3-121249950*y**4+62036520*y**5
          -37584934*y**6+25359179*y**7-11417015*y**8+1779170*y**9+707320*y**10
          -337623*y**11+36783*y**12))+288*logy**2*r**5*(-1+y)**2*(-1+r**2+y)**3*(
          -7193*r**28*(-1+y)**8+r**26*(-1+y)**4*(-509106+2058003*y-3140952*y**2
          +2097343*y**3-648832*y**4+91584*y**5)-r**24*(-1+y)**2*(11457121-65747343*y
          +156199815*y**2-195321563*y**3+134912725*y**4-48645901*y**5+6992193*y**6
          +56975*y**7+33578*y**8)-r**22*(-1+y)**2*(22311583-131008578*y+326406927*y**2
          -413557342*y**3+271974525*y**4-78519998*y**5-7799427*y**6+14248588*y**7
          -4386988*y**8+375410*y**9)+2*(-1+y)**10*(899+4495*y+13485*y**2+20820*y**3
          +8675*y**4-30523*y**5-14045*y**6-4810*y**7+34430*y**8-18750*y**9+2824*y**10)
          +r**20*(-1+y)**2*(-139899962+646320561*y-1150651566*y**2+806435137*y**3
          +162411410*y**4-612884203*y**5+361621164*y**6-79812729*y**7+5498348*y**8
          -1325770*y**9+267410*y**10)+r**2*(-1+y)**8*(12057+41565*y+93918*y**2
          -111555*y**3-55130*y**4-299639*y**5+405780*y**6-210411*y**7-154595*y**8
          +260030*y**9-8718*y**10-78470*y**11+21168*y**12)+r**4*(-1+y)**7*(-480424
          -836813*y-1162755*y**2+4054772*y**3-951770*y**4+1107518*y**5-4443694*y**6
          +3242770*y**7+434366*y**8+154295*y**9-1828919*y**10+1287082*y**11-355540*y**12
          +38112*y**13)+r**6*(-1+y)**6*(5248269+5182026*y+5487441*y**2-48681566*y**3
          +33244250*y**4+7489132*y**5+42200438*y**6-130310282*y**7+124879347*y**8
          -55108800*y**9+9847449*y**10+447736*y**11-391034*y**12+45594*y**13)
          -r**8*(-1+y)**5*(37560487-3901656*y+1338546*y**2-173980342*y**3+222492375*y**4
          -138390714*y**5+187970252*y**6-294758522*y**7+265300939*y**8-137009000*y**9
          +37398002*y**10-3077596*y**11-628849*y**12+85078*y**13)+r**10*(-1+y)**4*(284081864
          -545190539*y+245513430*y**2-914444375*y**3+3159962300*y**4-4466917248*y**5
          +3215258428*y**6-1075159180*y**7-47494610*y**8+181698475*y**9-69762266*y**10
          +13291311*y**11-1471050*y**12+88460*y**13)+r**12*(-1+y)**3*(-230547851
          +462372625*y-213113594*y**2+1370934770*y**3-4634231605*y**4+6602408897*y**5
          -5118613980*y**6+2081316298*y**7-150181935*y**8-247810145*y**9+105794254*y**10
          -14817620*y**11-34529*y**12+132415*y**13)-2*r**14*(-1+y)**2*(-601800761
          +2892125268*y-5464757880*y**2+5300072178*y**3-2358788790*y**4-629286888*y**5
          +1656848474*y**6-1087480970*y**7+343817914*y**8-22490660*y**9-34772926*y**10
          +19344308*y**11-4453475*y**12+349708*y**13)+r**18*(558959281-3623887253*y
          +9673799908*y**2-13796939081*y**3+11123345370*y**4-4734792527*y**5+884177936*y**6
          -408248991*y**7+527190927*y**8-188767920*y**9-58286304*y**10+54334192*y**11
          -11635942*y**12+666404*y**13)-2*r**16*(-673205706+4512884532*y-12625173465*y**2
          +18984502458*y**3-15517549479*y**4+4067111052*y**5+5227816726*y**6-6783648560*y**7
          +3751923284*y**8-1048942432*y**9+78949529*y**10+31773592*y**11-5630525*y**12
          -1058442*y**13+247436*y**14))-12*logy*r*(-1+y)**2*(-1+r**2+y)**4*(525*r**34*(
          -1+y)**8+r**32*(-1+y)**4*(-12257+46928*y-65142*y**2+49502*y**3-19093*y**4
          +3038*y**5)+2*r**30*(-1+y)**2*(1276242-7461356*y+18055995*y**2-23012203*y**3
          +16420126*y**4-6506058*y**5+1312831*y**6-110271*y**7+6454*y**8)+2*(
          -1+y)**13*(-23-207*y-1035*y**2-3209*y**3-5249*y**4-1129*y**5+4927*y**6
          +5925*y**7-1756*y**8-3996*y**9+1552*y**10)-r**28*(-52678747+406810632*y
          -1368948214*y**2+2609896230*y**3-3082743250*y**4+2325767548*y**5-1116573512*y**6
          +328119284*y**7-52768635*y**8+2842860*y**9+244054*y**10+7750*y**11)
          +r**26*(442597960-3186937516*y+9883183354*y**2-17022569330*y**3+17397902033*y**4
          -10167759704*y**5+2517301632*y**6+569005008*y**7-554229950*y**8+132325852*y**9
          -11803466*y**10+1142794*y**11-84267*y**12)+r**24*(-182680591+1115855036*y
          -2309604564*y**2+2225436050*y**3-1682771141*y**4+2471779098*y**5-3599011364*y**6
          +3448243018*y**7-2208286393*y**8+899771126*y**9-191731072*y**10+10809188*y**11
          +1335381*y**12-17372*y**13)-r**2*(-1+y)**9*(81+589*y+2319*y**2+5389*y**3
          +123294*y**4+292738*y**5+11142*y**6-276618*y**7-606483*y**8+936677*y**9
          -269269*y**10-236131*y**11+207524*y**12-54356*y**13+3104*y**14)+2*r**22*(1840655330
          -11175077216*y+27585130263*y**2-32324226507*y**3+9845385538*y**4+20743462565*y**5
          -28599421693*y**6+14860783079*y**7-1932528161*y**8-1430925611*y**9+703210580*y**10
          -125647716*y**11+12034733*y**12-1206082*y**13+92898*y**14)-r**16*(-1
          +y)**2*(-1323430095+9847859438*y-17332453701*y**2-16789640970*y**3+81079799347*y**4
          -97627403754*y**5+53950993941*y**6-9283766446*y**7-5281584573*y**8+1754220398*y**9
          +1790889625*y**10-1249557154*y**11+214910297*y**12+17628718*y**13-5486345*y**14
          +1274*y**15)+r**8*(-1+y)**6*(-39914893-59275930*y-74008141*y**2+366518274*y**3
          -178229551*y**4+1973394*y**5-227758787*y**6+318163080*y**7-129371115*y**8
          +99860670*y**9-163742651*y**10+114189742*y**11-35271289*y**12+4673466*y**13
          -188469*y**14+2200*y**15)+r**4*(-1+y)**8*(-309631-1151712*y-2704942*y**2
          -1206366*y**3+3517815*y**4+9728800*y**5-7200936*y**6+417004*y**7-5645293*y**8
          +7566280*y**9-3242802*y**10+390098*y**11-201387*y**12+253784*y**13-76920*y**14
          +6208*y**15)+2*r**6*(-1+y)**7*(241690+1011558*y+2588879*y**2-6065290*y**3
          -2747173*y**4-11547759*y**5+32747116*y**6-22764256*y**7-11183788*y**8
          +16551998*y**9+1348835*y**10-7066424*y**11+2710527*y**12-157597*y**13
          -72950*y**14+8634*y**15)+r**20*(-16760084757+99625720776*y-236259243870*y**2
          +278797607510*y**3-143316304843*y**4-26006894752*y**5+71566466436*y**6
          -27960430352*y**7-2784664887*y**8+2013576464*y**9+2421297078*y**10-1594186762*y**11
          +286258247*y**12-2943848*y**13-1843596*y**14+31156*y**15)+r**10*(-1
          +y)**5*(297638848+184827652*y+164105134*y**2-2378080964*y**3+2322158841*y**4
          -316590819*y**5+1456577725*y**6-5473932189*y**7+6626000482*y**8-3731453818*y**9
          +818321248*y**10+128989098*y**11-107902395*y**12+22308857*y**13-1907723*y**14
          +56023*y**15)+2*r**14*(-1+y)**3*(3605844314-8895573522*y+6038413553*y**2
          -10608711026*y**3+40580574830*y**4-67967031360*y**5+57366869369*y**6
          -21118553726*y**7-3952758618*y**8+7500103130*y**9-3180097197*y**10+573130178*y**11
          -18597102*y**12-2980456*y**13-1264285*y**14+215918*y**15)+r**12*(-1
          +y)**4*(-945407559+725159180*y-79992940*y**2+3662773154*y**3-5947559701*y**4
          +7058758216*y**5-10003697550*y**6+10349002830*y**7-6681771673*y**8+2600659092*y**9
          -469067640*y**10-12984530*y**11-14847515*y**12+21566344*y**13-5065566*y**14
          +327858*y**15)-r**18*(21976990054-143773554404*y+389702336458*y**2-560905622850*y**3
          +405174382445*y**4+14980794900*y**5-346589899052*y**6+363527940004*y**7
          -183443694535*y**8+34556440000*y**9+11148666598*y**10-7972429094*y**11
          +1768281563*y**12-169702640*y**13+24596380*y**14-5801852*y**15+276025*y**16))
          -r*(-1+r**2+y)**5*(985*r**34*(-1+y)**10+r**32*(-1+y)**6*(-16991+69339*y
          -104296*y**2+74316*y**3-29421*y**4+6705*y**5)+r**30*(-1+y)**4*(494100
          -3025354*y+7688907*y**2-9845710*y**3+6724627*y**4-2641618*y**5+672481*y**6
          -122214*y**7+16261*y**8)+r**28*(-1+y)**2*(62985860-475788326*y+1556578849*y**2
          -2870721361*y**3+3264079414*y**4-2357146562*y**5+1073052596*y**6-292551760*y**7
          +41916950*y**8-2353360*y**9+63931*y**10+9049*y**11)+r**26*(411083540
          -3765521182*y+15382873205*y**2-36618002038*y**3+55772611220*y**4-56142066274*y**5
          +37028156131*y**6-14933570768*y**7+2720571892*y**8+433054234*y**9-367594941*y**10
          +87700966*y**11-9729532*y**12+434566*y**13-34619*y**14)+r**24*(2644397876
          -22842906722*y+87067162215*y**2-190464012339*y**3+258533320208*y**4
          -214414825696*y**5+87677728627*y**6+15586633539*y**7-42435839372*y**8
          +25182572790*y**9-7690493139*y**10+1272065115*y**11-129785384*y**12+14807356*y**13
          -609303*y**14-81371*y**15)+r**22*(-7960660004+67793515606*y-249991715477*y**2
          +528584048026*y**3-708017031937*y**4+616284408718*y**5-330384772341*y**6
          +78104216954*y**7+23416916423*y**8-24774620526*y**9+8622554761*y**10
          -2483048946*y**11+1140423573*y**12-387508374*y**13+54158113*y**14-1000450*y**15
          -52119*y**16)+(-1+y)**11*(-3361-19614*y-66993*y**2-96566*y**3+19301*y**4
          +243848*y**5-563287*y**6-244764*y**7+501897*y**8+484178*y**9-82423*y**10
          -774494*y**11+556507*y**12-130556*y**13+7071*y**14+1136*y**15+120*y**16)
          +r**2*(-1+y)**10*(-44071-205074*y-571377*y**2-83890*y**3+3724099*y**4
          +8206444*y**5-4562931*y**6-5328836*y**7-9543265*y**8+24125662*y**9-11087775*y**10
          -6937666*y**11+7744413*y**12-2288120*y**13+208739*y**14+2552*y**15+1096*y**16)
          +r**4*(-1+y)**9*(6055084+20709838*y+45333163*y**2+13126054*y**3-63575287*y**4
          -155107826*y**5+171014127*y**6-46363942*y**7+46383041*y**8-36464622*y**9
          -6448751*y**10-1161774*y**11+19481379*y**12-13231470*y**13+3388309*y**14
          -292882*y**15+11559*y**16)+r**6*(-1+y)**8*(13974340+20958658*y+8722849*y**2
          +228784350*y**3-155651939*y**4-17363262*y**5-463002311*y**6+589361686*y**7
          +306143069*y**8-499139258*y**9-144366597*y**10+345233322*y**11-120684385*y**12
          -7973994*y**13+11524747*y**14-1689406*y**15+80131*y**16)+r**8*(-1+y)**7*(626920460
          +725954866*y+714074541*y**2-4242178194*y**3+2557569951*y**4-39176568*y**5
          +1274396183*y**6-2551880696*y**7+2722357389*y**8-2826251766*y**9+2091059507*y**10
          -803702698*y**11+120951105*y**12-20835620*y**13+18069865*y**14-4263724*y**15
          +319399*y**16)+r**18*(-1+y)**2*(-141945549850+819502852842*y-1879534868163*y**2
          +2102898082522*y**3-876046141243*y**4-560473771396*y**5+895641248831*y**6
          -418359128292*y**7+31994796303*y**8+30824611178*y**9+1658897459*y**10
          -7347429446*y**11+1720421155*y**12+41635600*y**13-45114735*y**14+1484912*y**15
          +532323*y**16)+r**10*(-1+y)**6*(-1110308012-145358082*y-476421577*y**2
          +12434343430*y**3-16392609721*y**4+7372165800*y**5-10934043279*y**6+39613422800*y**7
          -56285474939*y**8+35930684038*y**9-7970661663*y**10-2220776290*y**11
          +1515943177*y**12-290549516*y**13+41293783*y**14-7911700*y**15+789751*y**16)
          +r**16*(-1+y)**3*(-50259739670+221875855046*y-336374935917*y**2+118381062970*y**3
          +96614739737*y**4+195493959036*y**5-598972063787*y**6+497895104132*y**7
          -114828520797*y**8-77106584626*y**9+62906283061*y**10-18013197246*y**11
          +2103110735*y**12-113084048*y**13+34813539*y**14-8815552*y**15+1069387*y**16)
          +r**12*(-1+y)**5*(4759126884-6758300578*y+1666263491*y**2-5765432882*y**3
          +9062699945*y**4-33476945270*y**5+78714334163*y**6-61740023962*y**7-4716267651*y**8
          +33712790850*y**9-18170767967*y**10+1609291018*y**11+1735562171*y**12
          -667529642*y**13+109985705*y**14-13575422*y**15+1285147*y**16)+r**14*(
          -1+y)**4*(-34995628852+104498558546*y-94896544599*y**2+120122385958*y**3
          -448999262459*y**4+828280366758*y**5-740618315451*y**6+272685810546*y**7
          +63476586177*y**8-97964450834*y**9+32882284123*y**10-3933679398*y**11
          +835271903*y**12-559052710*y**13+136589943*y**14-16410354*y**15+1418703*y**16)
          +r**20*(37421294476-302047001254*y+1052535059073*y**2-2036410516313*y**3
          +2278384878463*y**4-1220361350511*y**5-271469389547*y**6+927683228231*y**7
          -626887820509*y**8+143437191709*y**9+49381607659*y**10-40312316219*y**11
          +8909898629*y**12-62533453*y**13-212616097*y**14+8115501*y**15+2137645*y**16
          +132517*y**17))))/(-20901888000*logy**5*r**20*(-1+y)**10+84000*(r**8*(-1
          +y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5-8709120000*logy**4*r**16*(
          -1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -1451520000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2-120960000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3-5040000*logy*(
          -1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(
          -4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2
          +y**3))**4))
      resNP += ((mupi*(217728000*logy**5*r**19*(3+5*r**2+10*r**4+13*r**6+27*r**8)*(
          -1+y)**10+518400*logy**4*r**15*(-1+y)**6*(1522*r**16*(-1+y)**4-15*r**14*(
          -857+3428*y-5142*y**2+3386*y**3-1333*y**4+182*y**5)-14*r**12*(-3034
          +8086*y-4029*y**2-7444*y**3+8226*y**4-2840*y**5+225*y**6)-35*r**10*(883
          -4312*y+8028*y**2-7484*y**3+2637*y**4-38*y**5-124*y**6+2*y**7)+10*(
          -1+y)**4*(-197+2583*y**3-4270*y**4+2520*y**5-658*y**6+64*y**7)+r**2*(
          -1+y)**4*(2769+30660*y**3-60515*y**4+35056*y**5-8120*y**6+640*y**7)
          +70*r**8*(-144+876*y-1914*y**2+1503*y**3+1367*y**4-3147*y**5+2283*y**6
          -750*y**7+88*y**8)+7*r**6*(-1401+7104*y-13656*y**2+6054*y**3+16424*y**4
          -22424*y**5+7386*y**6+3886*y**7-3229*y**8+576*y**9)-70*r**4*(98-482*y
          +903*y**2-252*y**3-713*y**4-527*y**5+2938*y**6-3271*y**7+1676*y**8
          -408*y**9+38*y**10))-17280*logy**3*r**11*(-1+y)**4*(-1+r**2+y)**2*(4982*r**20*(
          -1+y)**6+r**18*(-1+y)**2*(-56551+216240*y-299450*y**2+169175*y**3
          -69405*y**4+11671*y**5)-r**16*(-1+y)**2*(474916-1820162*y+2607862*y**2
          -1647133*y**3+563177*y**4-131869*y**5+24789*y**6)+r**14*(-1271596+6774666*y
          -14672901*y**2+15565508*y**3-8464657*y**4+2137906*y**5+177169*y**6-335494*y**7
          +36537*y**8+8762*y**9)+2*r**12*(-1854233+8558359*y-15063909*y**2+9656913*y**3
          +2368185*y**4-5653877*y**5+2214181*y**6-376856*y**7+187207*y**8-79665*y**9
          +7995*y**10)+(-1+y)**5*(-1118-1118*y-1118*y**2+11437*y**3-47738*y**4
          +36878*y**5+260248*y**6-531027*y**7+393218*y**8-129682*y**9+16320*y**10)
          +r**10*(-1327010+7131154*y-14755653*y**2+7851662*y**3+9953722*y**4
          -9633188*y**5-6334786*y**6+12219163*y**7-6342372*y**8+1177798*y**9+36923*y**10
          -21513*y**11)-r**6*(-1+y)**2*(-304356+1068122*y-1011257*y**2-6513072*y**3
          +28156418*y**4-43121920*y**5+31529844*y**6-10141848*y**7-62538*y**8
          +918742*y**9-215319*y**10+12184*y**11)-2*r**4*(-1+y)**3*(-123582+188981*y
          -57423*y**2+2543597*y**3-7813028*y**4+9040486*y**5-4944400*y**6+1488178*y**7
          -580152*y**8+361913*y**9-126779*y**10+15909*y**11)+r**2*(-1+y)**4*(
          -53919+2236*y+2236*y**2+745051*y**3-1319724*y**4+935924*y**5-1168416*y**6
          +2047529*y**7-1880361*y**8+876064*y**9-196640*y**10+16320*y**11)+r**8*(
          -478834+2791958*y-6615894*y**2+7161920*y**3-14357110*y**4+43341228*y**5
          -67912626*y**6+55095433*y**7-22579815*y**8+2859990*y**9+1054136*y**10
          -399077*y**11+38691*y**12))-288*logy**2*r**7*(-1+y)**2*(-1+r**2+y)**3*(6121*r**26*(
          -1+y)**8-r**24*(-1+y)**4*(-120344+499739*y-795516*y**2+626839*y**3
          -177766*y**4+19008*y**5)-r**22*(-1+y)**2*(-106039+118869*y+1028499*y**2
          -3651629*y**3+6407405*y**4-6680341*y**5+3667661*y**6-924539*y**7+77714*y**8)
          +r**20*(-1+y)**2*(-19470749+106844562*y-238717617*y**2+273306434*y**3
          -179684835*y**4+77729634*y**5-23681547*y**6+4132952*y**7-606564*y**8
          +103030*y**9)+5*r**18*(-1+y)**2*(-9230926+47975043*y-101295558*y**2
          +105457619*y**3-53107718*y**4+9189067*y**5+1960980*y**6-2403243*y**7
          +1458076*y**8-444926*y**9+37546*y**10)-(-1+y)**8*(-19561-58683*y
          -117366*y**2+24745*y**3+260870*y**4+464057*y**5-687244*y**6+518217*y**7
          -510145*y**8-270370*y**9+805654*y**10-444398*y**11+76224*y**12)+r**16*(
          -84385267+547606181*y-1496733976*y**2+2067969877*y**3-1376547350*y**4
          +181698799*y**5+349928228*y**6-300944453*y**7+166205271*y**8-72838000*y**9
          +24903468*y**10-8971884*y**11+2233154*y**12-208048*y**13)-r**4*(-1+y)**6*(536561
          +1017806*y+1281065*y**2-14320062*y**3+2913430*y**4+742328*y**5+104657138*y**6
          -218148990*y**7+180950679*y**8-69813380*y**9+9474861*y**10+1113056*y**11
          -374150*y**12+11658*y**13)-5*r**8*(-1+y)**4*(4532694-8955999*y+4917210*y**2
          -128312787*y**3+467337618*y**4-620738304*y**5+365147496*y**6-65437044*y**7
          -23317332*y**8+8981687*y**9+122370*y**10+116263*y**11-201936*y**12+22064*y**13)
          -r**2*(-1+y)**7*(-112896-167109*y-162639*y**2+18304*y**3+2076710*y**4
          -466038*y**5-10403722*y**6+13854758*y**7-6034078*y**8+2855715*y**9-3789791*y**10
          +2545706*y**11-739144*y**12+76224*y**13)-r**10*(-1+y)**3*(59273213-219204391*y
          +248317118*y**2+429515650*y**3-2586539285*y**4+4509720649*y**5-3611432248*y**6
          +1154938774*y**7+211126305*y**8-287160565*y**9+87372138*y**10-9393936*y**11
          -507217*y**12+113795*y**13)+2*r**12*(-1+y)**2*(-18636809+137586324*y
          -336722736*y**2+72397726*y**3+361416510*y**4+59501988*y**5-769329948*y**6
          +691448222*y**7-201870832*y**8-21607260*y**9+16389296*y**10+2156574*y**11
          -1462561*y**12+144506*y**13)+r**6*(-1+y)**5*(9995829-7614492*y-1816038*y**2
          -174568404*y**3+416533215*y**4-367216878*y**5+279500064*y**6-406196614*y**7
          +429362573*y**8-232159640*y**9+56682074*y**10-1850922*y**11-1408773*y**12
          +170006*y**13)-2*r**14*(138706129-838727015*y+2063711071*y**2-2278816453*y**3
          +397574273*y**4+1526183597*y**5-1251665880*y**6-74718897*y**7+570221751*y**8
          -340369856*y**9+112269099*y**10-30491430*y**11+6945351*y**12-848298*y**13
          +26558*y**14))-12*logy*r**3*(-1+y)**2*(-1+r**2+y)**4*(-387*r**32*(-1
          +y)**8-r**30*(-1+y)**4*(-18145+71032*y-102678*y**2+69034*y**3-18477*y**4
          +2210*y**5)+2*r**28*(-1+y)**2*(656482-3827504*y+9250419*y**2-11929277*y**3
          +8633438*y**4-3313518*y**5+575731*y**6-29717*y**7+2186*y**8)+r**26*(643651
          -4401776*y+14076410*y**2-29472282*y**3+34128182*y**4-4059752*y**5-37213396*y**6
          +42206680*y**7-19851993*y**8+4347168*y**9-448694*y**10+21802*y**11)
          +r**24*(-48350836+390069388*y-1364798254*y**2+2742642954*y**3-3580313703*y**4
          +3268393728*y**5-2148516896*y**6+985403616*y**7-286055194*y**8+43977668*y**9
          -2583562*y**10+80838*y**11-24147*y**12)-r**22*(616890631-4197195140*y
          +12069344744*y**2-18561076838*y**3+16135115323*y**4-7639592530*y**5+1511732436*y**6
          +298442022*y**7-375539835*y**8+182146002*y**9-51008476*y**10+11812504*y**11
          -2051991*y**12+107548*y**13)+2*r**20*(-172175946+1134512756*y-3303765117*y**2
          +5249843583*y**3-4434099022*y**4+1083023295*y**5+1583219711*y**6-2109181263*y**7
          +1587406927*y**8-861310993*y**9+282075176*y**10-40310292*y**11-1588795*y**12
          +618290*y**13+9690*y**14)+(-1+y)**9*(-1573-7865*y-23595*y**2-40077*y**3
          -50114*y**4-10254*y**5+206990*y**6+11230*y**7-183141*y**8+161523*y**9
          -228723*y**10+172575*y**11-5060*y**12-42332*y**13+12416*y**14)-r**6*(
          -1+y)**6*(19625829+28299570*y+31263665*y**2-128769998*y**3-145332835*y**4
          +8531878*y**5+1048898733*y**6-1537030712*y**7+859367079*y**8-267602902*y**9
          +177034115*y**10-137608978*y**11+49746647*y**12-7046706*y**13+85087*y**14
          +7528*y**15)+2*r**4*(-1+y)**7*(-772122-1994418*y-3587537*y**2+5821972*y**3
          +6919585*y**4+14324011*y**5-11925866*y**6+6871522*y**7-18936106*y**8
          -17578252*y**9+49838537*y**10-31540816*y**11+7240715*y**12-141741*y**13
          -112758*y**14+11274*y**15)+r**2*(-1+y)**8*(72185+295032*y+753310*y**2
          +599286*y**3-1178473*y**4-3579524*y**5+3489636*y**6-3575520*y**7+2267223*y**8
          +3814596*y**9-4055202*y**10+575082*y**11+92185*y**12+209416*y**13-99648*y**14
          +12416*y**15)+2*r**12*(-1+y)**3*(159356146-227209518*y+127939085*y**2
          -7187019344*y**3+28509966752*y**4-41896457362*y**5+26920474691*y**6-3545967010*y**7
          -5859486802*y**8+4186206006*y**9-1293853649*y**10+176564952*y**11+4863400*y**12
          -2539054*y**13+26217*y**14+33490*y**15)+r**8*(-1+y)**5*(-23016124+18780176*y
          +39766282*y**2-767735292*y**3+954877853*y**4-632871239*y**5+3938784929*y**6
          -8976895733*y**7+8696573590*y**8-3977194230*y**9+574230476*y**10+213251570*y**11
          -102356199*y**12+16137277*y**13-963623*y**14+42287*y**15)-r**14*(-1
          +y)**2*(-2825235467+9634727582*y-10731229077*y**2+3176971122*y**3+16227718965*y**4
          -43531291194*y**5+46560251339*y**6-19162677578*y**7-3226202921*y**8+5539833298*y**9
          -1259111463*y**10-263331746*y**11+118722655*y**12-6103126*y**13-1876463*y**14
          +134074*y**15)+r**10*(-1+y)**4*(-370551951+530067988*y+23739728*y**2
          +4918817702*y**3-16080997121*y**4+16980195492*y**5-8599244006*y**6+6264905334*y**7
          -7958213529*y**8+5481308132*y**9-1547706956*y**10+24072418*y**11+50079913*y**12
          +2617252*y**13-2153886*y**14+179490*y**15)+r**18*(-1278887213+7072222832*y
          -15260032506*y**2+11124519186*y**3+5663230381*y**4-9016161708*y**5-6256878192*y**6
          +16123530084*y**7-12183938275*y**8+5236365980*y**9-1409481138*y**10+156474710*y**11
          +1340547*y**12+6690464*y**13-2556836*y**14+209684*y**15)+r**16*(-5116233322
          +29570752172*y-68868771130*y**2+65185861614*y**3+12752208831*y**4-77726979324*y**5
          +53700331900*y**6+1661815780*y**7-18965219493*y**8+10551157968*y**9-3879600566*y**10
          +1517924954*y**11-424361175*y**12+33588704*y**13+8932276*y**14-1450188*y**15
          +40999*y**16))-r*(-1+r**2+y)**5*(101*r**34*(-1+y)**10+r**32*(-1+y)**6*(
          -24719+93727*y-130040*y**2+78236*y**3-17361*y**4+505*y**5)-r**30*(
          -1+y)**4*(-1356664+7803798*y-18464127*y**2+23282818*y**3-16640511*y**4
          +6568498*y**5-1350753*y**6+117822*y**7+599*y**8)-r**28*(-1+y)**2*(-13194464
          +96247278*y-303314685*y**2+537085769*y**3-571096958*y**4+349440698*y**5
          -93492608*y**6-13756924*y**7+14993902*y**8-2852816*y**9+55757*y**10
          +10331*y**11)+r**26*(-96948416+920544086*y-3884519619*y**2+9573770730*y**3
          -15379406660*y**4+17175027062*y**5-14005083397*y**6+8652068612*y**7-4079989108*y**8
          +1409989834*y**9-331370561*y**10+52248146*y**11-7102408*y**12+836138*y**13
          -30839*y**14)+(-1+y)**13*(179+1432*y+6444*y**2+21194*y**3+17229*y**4
          -67464*y**5-46560*y**6-6564*y**7-34939*y**8+43936*y**9-4980*y**10-4662*y**11
          +6155*y**12+1280*y**13+120*y**14)-r**24*(191413848-1769730454*y+7304493133*y**2
          -18043162341*y**3+30453901816*y**4-38031013492*y**5+36387919537*y**6
          -26185775939*y**7+13159214792*y**8-3903367574*y**9+274082791*y**10+239476437*y**11
          -91565624*y**12+15460544*y**13-1243397*y**14+30323*y**15)+r**2*(-1+y)**10*(116121
          +560834*y+1632627*y**2+2632570*y**3+1104411*y**4-3894940*y**5-4635379*y**6
          -1705256*y**7+7480783*y**8-3006614*y**9+5782085*y**10-6687926*y**11
          +650229*y**12+1649072*y**13-530597*y**14+26084*y**15+1896*y**16)+r**4*(
          -1+y)**9*(-1105224-4115510*y-9870793*y**2+5370506*y**3+27781637*y**4
          +58174098*y**5-79518937*y**6+93195254*y**7-39522559*y**8-135618586*y**9
          +153114469*y**10-52164978*y**11+5382039*y**12-1117922*y**13+1045149*y**14
          -209518*y**15+12875*y**16)+r**6*(-1+y)**8*(9847344+16231838*y+18401453*y**2
          -119898286*y**3+4275841*y**4-116954918*y**5-371051311*y**6+676948878*y**7
          +41587501*y**8+160377122*y**9-987602817*y**10+834573662*y**11-248008181*y**12
          +13187110*y**13+5828387*y**14-795134*y**15+51511*y**16)+r**22*(-3813895296
          +31548926602*y-113555674129*y**2+226854219158*y**3-263753278405*y**4
          +159074149782*y**5-4006781005*y**6-74630913934*y**7+67042572887*y**8
          -34889637082*y**9+13248695077*y**10-3799938678*y**11+800965113*y**12
          -134329670*y**13+16054137*y**14-1021138*y**15+54581*y**16)+r**8*(-1
          +y)**7*(271101136+270765798*y+209833905*y**2-2452501366*y**3-492009233*y**4
          +191419572*y**5+10950011039*y**6-17766090564*y**7+11659254993*y**8-3818434858*y**9
          +863280799*y**10-316432406*y**11+131229809*y**12-32042352*y**13+6753041*y**14
          -854832*y**15+139519*y**16)+r**10*(-1+y)**6*(1136111512-224151182*y
          -592069829*y**2+723644914*y**3-8039704921*y**4+10283138848*y**5-17322684223*y**6
          +42052978580*y**7-53387891971*y**8+31197630594*y**9-5665606195*y**10
          -2311281686*y**11+1314437649*y**12-231970868*y**13+23825527*y**14-1981840*y**15
          +279091*y**16)+r**12*(-1+y)**5*(5952524656-8766918278*y-274754609*y**2
          -31512056526*y**3+114593749149*y**4-125850493714*y**5+47987130539*y**6
          +1603967954*y**7-3765149067*y**8+837288518*y**9-1231630579*y**10+3283142*y**11
          +647765055*y**12-305995182*y**13+67015033*y**14-6324938*y**15+438847*y**16)
          +r**18*(-1+y)**2*(-14568881878+84153234246*y-193455800535*y**2+178477380798*y**3
          +4619454989*y**4-110968301596*y**5+24532562943*y**6+73927454592*y**7
          -70129873129*y**8+26911791054*y**9-2289104817*y**10-2686800002*y**11
          +1130057243*y**12-163113944*y**13+10706857*y**14-2705884*y**15+459063*y**16)
          +r**14*(-1+y)**4*(11018181848-28189339346*y+15082076949*y**2+47286659642*y**3
          -185643913551*y**4+320499868158*y**5-266006981491*y**6+63232924418*y**7
          +65355615777*y**8-61066149062*y**9+19271736551*y**10-1513212114*y**11
          -165996917*y**12-118512294*y**13+62731863*y**14-8411882*y**15+561451*y**16)
          +r**16*(-1+y)**3*(4993027478-14002981094*y+4584396471*y**2+55769857718*y**3
          -115349532623*y**4+90183696744*y**5-34857053467*y**6+21820637896*y**7
          -11573854953*y**8-10210222166*y**9+14130965321*y**10-5998767786*y**11
          +936692383*y**12-13464940*y**13+8229339*y**14-4894868*y**15+580547*y**16)
          +r**20*(5079680328-42449575862*y+152071921169*y**2-296981343649*y**3
          +324903242791*y**4-155568958007*y**5-65705947623*y**6+153817665499*y**7
          -106440935577*y**8+35580189873*y**9-4160006725*y**10+1057311517*y**11
          -2189472515*y**12+1295375851*y**13-351578789*y**14+45501929*y**15-3314707*y**16
          +244497*y**17))))/(-20901888000*logy**5*r**20*(-1+y)**10+84000*(r**8*(-1
          +y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5-8709120000*logy**4*r**16*(
          -1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -1451520000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2-120960000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3-5040000*logy*(
          -1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(
          -4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2
          +y**3))**4))
      resNP += ((rhoD*(217728000*logy**5*r**20*(144+390*r**2+473*r**4+479*r**6
          +378*r**8+285*r**10+81*r**12)*(-1+y)**11+518400*logy**4*r**16*(-1+y)**6*(30318*r**20*(
          -1+y)**5+96*(-1+y)**7*(-118-236*y-354*y**2+543*y**3-170*y**4+20*y**5)
          +45*r**18*(-1521+7605*y-15210*y**2+14272*y**3-6919*y**4+1283*y**5
          +42*y**6)+28*r**2*(-1+y)**6*(1379+1379*y+1379*y**2-6466*y**3+5414*y**4
          -1330*y**5+120*y**6)+10*r**4*(-1+y)**5*(-42555+30240*y+15120*y**2
          -5257*y**3-14854*y**4+12936*y**5-2758*y**6+240*y**7)-42*r**16*(2704
          -9470*y+8815*y**2+8745*y**3-19060*y**4+12836*y**5-3895*y**6+405*y**7)
          +5*r**14*(-91601+338305*y-377360*y**2-91696*y**3+472337*y**4-366955*y**5
          +119490*y**6-14574*y**7+630*y**8)+r**6*(-1+y)**3*(-556333+1931666*y
          -1784833*y**2-122920*y**3+893935*y**4-305522*y**5-109081*y**6+85968*y**7
          -13680*y**8+960*y**9)+14*r**12*(-20528+45940*y+49870*y**2-256085*y**3
          +294350*y**4-130042*y**5-5360*y**6+27795*y**7-10800*y**8+1620*y**9)
          +7*r**10*(-26745-9975*y+379200*y**2-841390*y**3+663730*y**4+4516*y**5
          -353210*y**6+242300*y**7-66895*y**8+4725*y**9+864*y**10)-70*r**8*(-1616
          +22270*y-80015*y**2+120827*y**3-69757*y**4-22822*y**5+54561*y**6-28023*y**7
          +3069*y**8+2250*y**9-810*y**10+66*y**11))-17280*logy**3*r**12*(-1+y)**4*(
          -20922*r**28*(-1+y)**7+r**26*(-1+y)**2*(709121-3545605*y+7091210*y**2
          -6992075*y**3+3786280*y**4-1063076*y**5+127425*y**6)+24*(-1+y)**11*(
          -433-1732*y-4330*y**2-3440*y**3+1855*y**4+9868*y**5-7268*y**6+1280*y**7)
          +r**24*(-1+y)**2*(5007812-21400900*y+33706400*y**2-20443235*y**3-1143740*y**4
          +7072018*y**5-2796900*y**6+284865*y**7)+2*r**2*(-1+y)**9*(-40798-81596*y
          -122394*y**2+447193*y**3-164315*y**4+94753*y**5-340369*y**6+365784*y**7
          -155198*y**8+20040*y**9)+r**22*(-1929959+21723113*y-93916239*y**2+224921680*y**3
          -318473530*y**4+273701004*y**5-143606408*y**6+44618294*y**7-7571805*y**8
          +862245*y**9-151995*y**10)+r**4*(-1+y)**8*(2557842+1198482*y+518802*y**2
          -18695603*y**3+22606712*y**4-6498592*y**5-3809882*y**6+2796483*y**7
          -337202*y**8-171382*y**9+33840*y**10)+r**20*(-3893778+40884606*y-160146378*y**2
          +331980085*y**3-371881700*y**4+189678328*y**5+24677744*y**6-97298992*y**7
          +66002510*y**8-24419010*y**9+5254890*y**10-552705*y**11)+r**6*(-1+y)**7*(
          -1072281+4633440*y+2316720*y**2+6136805*y**3-36104790*y**4+34983942*y**5
          -7374710*y**6-6316135*y**7+3821405*y**8-500500*y**9-126276*y**10+24480*y**11)
          +r**18*(39397946-220825022*y+506022966*y**2-596953070*y**3+401255150*y**4
          -221922312*y**5+215142134*y**6-223249057*y**7+143738205*y**8-49227350*y**9
          +6396856*y**10+582843*y**11-182889*y**12)+r**8*(-1+y)**5*(-30910932
          +112887864*y-125653932*y**2-33079385*y**3+188472765*y**4-148143036*y**5
          +19677262*y**6+29725169*y**7-13791355*y**8-679940*y**9+1833358*y**10
          -416696*y**11+15858*y**12)+r**14*(-1+y)**2*(-17880754+111869570*y-219549640*y**2
          +46641710*y**3+364474590*y**4-510501252*y**5+253256030*y**6+29510665*y**7
          -91867295*y**8+39558450*y**9-5643054*y**10-293235*y**11+96615*y**12)
          -r**10*(-1+y)**4*(-3953161+78619443*y-227899383*y**2+201695126*y**3
          +78581945*y**4-270341154*y**5+178860892*y**6-16387727*y**7-34019176*y**8
          +16441035*y**9-2017225*y**10-457995*y**11+121380*y**12)-r**12*(-1+y)**3*(
          -44731162+165350248*y-161278572*y**2-82253522*y**3+222772688*y**4-76043508*y**5
          -78940798*y**6+61168367*y**7+4695237*y**8-18361748*y**9+7705210*y**10
          -1541985*y**11+149145*y**12)+r**16*(-15286352+141491504*y-497551152*y**2
          +844751290*y**3-634615980*y**4-59945746*y**5+462603302*y**6-283137711*y**7
          -27557320*y**8+124216505*y**9-73259702*y**10+21352469*y**11-3275412*y**12
          +214305*y**13))+288*logy**2*r**8*(-1+y)**2*(-1+r**2+y)**2*(-4119*r**32*(
          -1+y)**9-r**30*(-1+y)**4*(117601-579767*y+1134820*y**2-714895*y**3
          +356660*y**4-135286*y**5+28707*y**6)+48*(-1+y)**13*(-31-186*y-651*y**2
          -1521*y**3-2251*y**4-1044*y**5+4811*y**6+3251*y**7-5804*y**8+1676*y**9)
          +r**28*(-1+y)**2*(-23532207+161186453*y-471273998*y**2+763012465*y**3
          -748015638*y**4+456531677*y**5-170289958*y**6+36578263*y**7-4257735*y**8
          +310278*y**9)+r**26*(-1+y)**2*(-165187086+1068427280*y-2914135571*y**2
          +4247492985*y**3-3557856657*y**4+1675600445*y**5-329021975*y**6-66304439*y**7
          +49491525*y**8-9165703*y**9+480396*y**10)+2*r**2*(-1+y)**11*(-19931
          -81212*y-206750*y**2-37415*y**3+695745*y**4+1423002*y**5-2176146*y**6
          +757525*y**7-4960*y**8-72120*y**9+1454*y**10+14808*y**11)-r**24*(-1
          +y)**2*(587595515-3322846555*y+7512065501*y**2-7929694473*y**3+2382368483*y**4
          +3252732719*y**5-4015308165*y**6+1966034909*y**7-480787642*y**8+63564052*y**9
          -8584524*y**10+940980*y**11)+r**4*(-1+y)**9*(-5035285-8282710*y-10682019*y**2
          +49640549*y**3+21607365*y**4+7726845*y**5-231977705*y**6+291103103*y**7
          -125234678*y**8-3473215*y**9+20207740*y**10-5985260*y**11+405766*y**12
          +63504*y**13)+r**22*(111135799-1300774491*y+6361171263*y**2-19247563608*y**3
          +38322673547*y**4-51014615073*y**5+46390001497*y**6-29329849381*y**7
          +12577022196*y**8-2926154484*y**9-304475626*y**10+515445669*y**11-182761982*y**12
          +30090312*y**13-1681638*y**14)-r**14*(-1+y)**4*(-2678474605+15196488935*y
          -31069669942*y**2+21140965357*y**3+16984505800*y**4-38970872270*y**5
          +23521962805*y**6-184814606*y**7-6158317389*y**8+2322292645*y**9+167117850*y**10
          -288405815*y**11+63628298*y**12-4228518*y**13+73455*y**14)+r**6*(-1
          +y)**8*(21766589+13491459*y+10817923*y**2-311087462*y**3+473269991*y**4
          -277578953*y**5+211969267*y**6-338214911*y**7+289177324*y**8-100025702*y**9
          +612714*y**10+6503349*y**11+220288*y**12-700212*y**13+114336*y**14)
          -r**10*(-1+y)**6*(328402+276743644*y-308877861*y**2+1627495323*y**3
          -6939501683*y**4+10586010441*y**5-6214254048*y**6-506633298*y**7+2438936524*y**8
          -1090937944*y**9+77810457*y**10+63944479*y**11-13293691*y**12-115197*y**13
          +118452*y**14)+r**8*(-1+y)**7*(-417309643+441711352*y+96909553*y**2
          +2789942400*y**3-7724984962*y**4+6765275386*y**5-722960954*y**6-2589738716*y**7
          +1667341665*y**8-210644306*y**9-143146493*y**10+49922852*y**11+17388*y**12
          -2082640*y**13+251118*y**14)-r**12*(-1+y)**5*(3148064095-12807804780*y
          +17222587457*y**2+339160469*y**3-25139883846*y**4+26994608275*y**5-8623132850*y**6
          -4308763694*y**7+4234788127*y**8-853218148*y**9-263985045*y**10+121325705*y**11
          -410088*y**12-4913971*y**13+546294*y**14)+2*r**18*(-1+y)**2*(-2182068843
          +10846502057*y-20002733057*y**2+12180229110*y**3+9044587273*y**4-16718067004*y**5
          +4869785456*y**6+6265496654*y**7-6152960440*y**8+1837717854*y**9+166527697*y**10
          -243525788*y**11+66562678*y**12-10172295*y**13+891648*y**14)+r**16*(
          -1+y)**3*(1877144503-6810554542*y+6558361341*y**2+4593740456*y**3-15082836863*y**4
          +15454400394*y**5-10281149241*y**6+6060214158*y**7-4210643957*y**8+2823911006*y**9
          -1243056697*y**10+274881658*y**11-5129499*y**12-9190674*y**13+1083957*y**14)
          +r**20*(636211515-6233268773*y+26217300051*y**2-64554162872*y**3+99732703918*y**4
          -92956445614*y**5+39197248656*y**6+17129842598*y**7-38082809861*y**8
          +28950245609*y**9-13269855117*y**10+3784266642*y**11-574191324*y**12
          +19607858*y**13+2984898*y**14+321816*y**15))+12*logy*r**6*(-1+y)**2*(
          -1+r**2+y)**3*(2385*r**36*(-1+y)**9+r**34*(-1+y)**4*(4438-15035*y
          +8605*y**2-7288*y**3-2530*y**4-3589*y**5+3495*y**6)-r**32*(-1+y)**2*(
          -2491451+17248604*y-51064146*y**2+85681398*y**3-88176200*y**4+56088302*y**5
          -21974638*y**6+5199666*y**7-699965*y**8+42510*y**9)+r**30*(-91045171
          +806478891*y-3164596020*y**2+7196033430*y**3-10527368964*y**4+10455102822*y**5
          -7250043512*y**6+3537076000*y**7-1196071895*y**8+268877919*y**9-37243876*y**10
          +2828186*y**11-123810*y**12)+6*(-1+y)**12*(-479-2874*y-10059*y**2
          -21754*y**3-22220*y**4+2478*y**5-24612*y**6+45538*y**7+91223*y**8-100380*y**9
          -15849*y**10+50736*y**11-24404*y**12+4656*y**13)+r**28*(-1297093657
          +10804504842*y-39498501285*y**2+82881916850*y**3-109708797067*y**4+94495028487*y**5
          -52025855470*y**6+16441778256*y**7-1587747491*y**8-745672988*y**9+267874315*y**10
          -28431082*y**11+623759*y**12+74931*y**13)+r**2*(-1+y)**11*(-149851-669209*y
          -1803201*y**2-3241737*y**3+1105042*y**4+14973482*y**5+24084858*y**6
          -17621938*y**7-46988811*y**8+49404171*y**9-13003081*y**10-2352149*y**11
          +1841764*y**12-296652*y**13+9312*y**14)+r**26*(-3320893729+24981006333*y
          -80351001114*y**2+137547871200*y**3-124709737570*y**4+35464740297*y**5
          +47062492187*y**6-65228593382*y**7+41051574885*y**8-15933772587*y**9
          +4085707162*y**10-741101370*y**11+105447566*y**12-10831195*y**13+585717*y**14)
          +r**24*(-10894629155+74902721634*y-212084291757*y**2+296903853586*y**3
          -144590861919*y**4-184053250740*y**5+389954689171*y**6-328658786732*y**7
          +149995275007*y**8-30871281718*y**9-3546044511*y**10+3822227970*y**11
          -1044982061*y**12+165401432*y**13-14157463*y**14+341256*y**15)+r**22*(12487598309
          -97518919725*y+329262130092*y**2-670269823606*y**3+889144509747*y**4
          -745114329063*y**5+324531334798*y**6+39153372784*y**7-173715808205*y**8
          +149739353149*y**9-81060692808*y**10+28788685602*y**11-6188098851*y**12
          +696852311*y**13-39034546*y**14+7690212*y**15-916200*y**16)-r**4*(-1
          +y)**9*(4542736+12084339*y+21841824*y**2-67970558*y**3-112231740*y**4
          -53018331*y**5+722874116*y**6-833237908*y**7+213841856*y**8+259840085*y**9
          -229885776*y**10+60477546*y**11+3216684*y**12-5256173*y**13+1391980*y**14
          -209304*y**15+18624*y**16)+3*r**18*(-1+y)**2*(-43950324567+219623486423*y
          -422183591507*y**2+342543770843*y**3+5493835476*y**4-224230426807*y**5
          +164303042813*y**6-47415575361*y**7+19282659724*y**8-27772234307*y**9
          +19749007755*y**10-6541370595*y**11+1039413068*y**12-48735517*y**13-17574869*y**14
          +3560969*y**15+40459*y**16)-r**8*(-1+y)**7*(161114983-195484457*y-128872697*y**2
          -6427999167*y**3+20066946361*y**4-18126859127*y**5-2457298207*y**6+12395901039*y**7
          -4222140891*y**8-3107194327*y**9+2768809985*y**10-817666465*y**11+107793783*y**12
          -9884617*y**13+2815991*y**14-296591*y**15+58404*y**16)+r**10*(-1+y)**6*(12810803317
          -19904117355*y+422398845*y**2-69674645025*y**3+239301546688*y**4-249137114817*y**5
          +35854208361*y**6+123719667731*y**7-96765483784*y**8+19435568935*y**9
          +6987541139*y**10-3161729191*y**11-184287376*y**12+247327909*y**13-33627673*y**14
          -273739*y**15+64035*y**16)-r**6*(-1+y)**8*(-305935391-382261441*y-390406776*y**2
          +3121060894*y**3-258201181*y**4-256107267*y**5-10672992758*y**6+16517899884*y**7
          -8217510861*y**8-525821231*y**9+1955581564*y**10-619197954*y**11+8414317*y**12
          +23629267*y**13-977838*y**14-603656*y**15+70428*y**16)+r**12*(-1+y)**5*(17188599611
          -35732655503*y+12839871054*y**2+529725916*y**3+20252464970*y**4+1275377991*y**5
          -68338822370*y**6+86580119406*y**7-41206078128*y**8+1430506159*y**9+6012472634*y**10
          -1618649712*y**11-332260810*y**12+220370137*y**13-34964454*y**14-536986*y**15
          +212085*y**16)+r**14*(-1+y)**4*(74778589231-333685997963*y+514989425902*y**2
          -46359761312*y**3-862154272285*y**4+1145020889327*y**5-542642251472*y**6
          -72419864334*y**7+171651198339*y**8-44406894445*y**9-10466692282*y**10
          +4676072348*y**11+790198757*y**12-488671127*y**13+49961980*y**14-4188526*y**15
          +593862*y**16)+r**16*(-1+y)**3*(-43241153723+218083294017*y-430416458433*y**2
          +417798877717*y**3-230658283203*y**4+164792768859*y**5-192455352299*y**6
          +135931978407*y**7-44744278503*y**8-1544975833*y**9+13525407777*y**10
          -10888004397*y**11+4659026651*y**12-1024045539*y**13+88489611*y**14-4999663*y**15
          +940554*y**16)+r**20*(20850856853-179712888828*y+666014600475*y**2-1412007391970*y**3
          +1775170124842*y**4-1074274961997*y**5-335602832247*y**6+1286041276000*y**7
          -1232356178110*y**8+659199218021*y**9-191248568755*y**10+4903307238*y**11
          +19439442250*y**12-7746647395*y**13+1514930287*y**14-208263876*y**15
          +25170837*y**16-1193625*y**17))-r**6*(-1+r**2+y)**4*(2067*r**36*(-1+y)**11
          +2*r**34*(-1+y)**6*(125444-608776*y+1169375*y**2-1118060*y**3+542104*y**4
          -118508*y**5+7725*y**6)+r**32*(-1+y)**4*(-5982045+40854395*y-118630973*y**2
          +192958045*y**3-191689167*y**4+118855079*y**5-45926587*y**6+10625875*y**7
          -1254924*y**8+36222*y**9)-2*r**30*(-1+y)**2*(-20776472+190482824*y
          -772556330*y**2+1813221794*y**3-2751171915*y**4+2869975006*y**5-2121739986*y**6
          +1111936426*y**7-402331444*y**8+95136330*y**9-13273404*y**10+837092*y**11
          +9519*y**12)-2*r**28*(-681920348+7041453266*y-32763050009*y**2+90380144265*y**3
          -164268176595*y**4+207188128556*y**5-186147240428*y**6+120201584995*y**7
          -55376712068*y**8+17693105724*y**9-3693903355*y**10+461020977*y**11-41624261*y**12
          +9047038*y**13-1918984*y**14+128427*y**15)+3*(-1+y)**13*(-65405-380934*y
          -1298781*y**2-2633070*y**3-2949463*y**4-434656*y**5+838405*y**6+5689788*y**7
          +4056141*y**8-8092558*y**9-833907*y**10+4804738*y**11-2540657*y**12
          +490004*y**13-11029*y**14+1168*y**15+216*y**16)-2*r**26*(-3861325232
          +36960026440*y-157376751358*y**2+390510445482*y**3-618769062035*y**4
          +636757670658*y**5-394488509186*y**6+82788088218*y**7+90375385761*y**8
          -101855341072*y**9+52324234826*y**10-16154229734*y**11+3197238795*y**12
          -464598538*y**13+62440662*y**14-6219022*y**15+236535*y**16)+2*r**2*(
          -1+y)**11*(1507964+4757564*y+9432359*y**2+9604249*y**3-53905684*y**4
          -122594302*y**5+13619701*y**6+285924397*y**7+161329464*y**8-686984380*y**9
          +499514349*y**10-112672337*y**11-22264944*y**12+12684462*y**13-611561*y**14
          -222261*y**15+37072*y**16+3888*y**17)-2*r**8*(-1+y)**8*(-4224143788
          -1066477398*y+872207111*y**2+11126784149*y**3+45160254356*y**4-87332047649*y**5
          -49138390375*y**6+186918968437*y**7-126919211646*y**8+7954862275*y**9
          +24746128749*y**10-9034860629*y**11+64365100*y**12+400590097*y**13-38866381*y**14
          -4195637*y**15-1241398*y**16+18627*y**17)+r**4*(-1+y)**10*(-61393503
          -139182805*y-219966730*y**2+1237717458*y**3+515911584*y**4-685523110*y**5
          -8314891558*y**6+14258608790*y**7-4389878262*y**8-7139651264*y**9+7070978178*y**10
          -2195502170*y**11-45902576*y**12+165098654*y**13-27834770*y**14+1517810*y**15
          +96933*y**16+37341*y**17)+2*r**6*(-1+y)**9*(1464920120+1194516048*y
          +754973114*y**2-13925170620*y**3+6280146273*y**4+1032211787*y**5+38223106908*y**6
          -67011672722*y**7+38340491103*y**8-2084158843*y**9-5776198306*y**10+1446357868*y**11
          +298386235*y**12-120712783*y**13-2336180*y**14+4511074*y**15+38701*y**16
          +38223*y**17)+6*r**18*(-1+y)**3*(-5688777288+29453191312*y-60131707324*y**2
          +111887846934*y**3-266747706249*y**4+467968825821*y**5-482123798830*y**6
          +266699282602*y**7-39805523581*y**8-57687485385*y**9+58491539524*y**10
          -30438694394*y**11+10120510865*y**12-2318519553*y**13+360826934*y**14
          -27484982*y**15-1007763*y**16+49357*y**17)-2*r**24*(-1965996608+11631350130*y
          -14750416223*y**2-87349632429*y**3+444913916736*y**4-995712164255*y**5
          +1347136909815*y**6-1196071387309*y**7+714899954466*y**8-286127018579*y**9
          +73261128787*y**10-9941054587*y**11-346255960*y**12+598724263*y**13-222100507*y**14
          +48487301*y**15-4164058*y**16+55017*y**17)-2*r**10*(-1+y)**7*(-53655411728
          +90603728664*y-14216217446*y**2+226511127504*y**3-788077545569*y**4
          +830741959193*y**5-199589808972*y**6-250752971612*y**7+200467786707*y**8
          -38221508317*y**9-8300562942*y**10+1196571392*y**11+2088527037*y**12
          -821148961*y**13+105580336*y**14-3708948*y**15-4333759*y**16+305421*y**17)
          +2*r**20*(-1+y)**2*(-76459574539+555574094789*y-1716597672307*y**2+3082512391279*y**3
          -3414711621718*y**4+2031223095293*y**5+66761920171*y**6-1261123992035*y**7
          +1173814463772*y**8-588687107029*y**9+169674834591*y**10-17339857619*y**11
          -5286835494*y**12+1847759499*y**13-176118503*y**14+15243255*y**15-7643141*y**16
          +659736*y**17)-2*r**16*(-1+y)**4*(-324900788359+1503293922787*y-2581126151622*y**2
          +1383088010810*y**3+1594329362989*y**4-3115980525732*y**5+2147348315840*y**6
          -691567553774*y**7+128293008969*y**8-75340910714*y**9+17929303850*y**10
          +31060534638*y**11-23938590437*y**12+7411090196*y**13-1157003700*y**14
          +71811766*y**15-1139290*y**16+717783*y**17)-2*r**12*(-1+y)**6*(-150594725608
          +377744241522*y-228887342059*y**2+238362972935*y**3-1098324676314*y**4
          +1536391866865*y**5-550651245077*y**6-517925408843*y**7+533380181046*y**8
          -124878748091*y**9-30575711325*y**10+12391723489*y**11+3636814114*y**12
          -2134741581*y**13+316575005*y**14-19970557*y**15-5855734*y**16+810213*y**17)
          -2*r**14*(-1+y)**5*(-402984850488+1629870622880*y-2342594446314*y**2
          +830160455092*y**3+1402981379395*y**4-1729095834615*y**5+647859218396*y**6
          -19414080822*y**7+35662214397*y**8-95315778429*y**9+49230889390*y**10
          -5635895256*y**11-2893708123*y**12+1188759911*y**13-166073616*y**14-5638262*y**15
          -3846045*y**16+1108509*y**17)+2*r**22*(31283721816-276622538920*y+1071827807538*y**2
          -2381937226142*y**3+3269255411193*y**4-2620706335726*y**5+660474769005*y**6
          +1033797854106*y**7-1339033870451*y**8+667119064294*y**9-30528464491*y**10
          -161504744570*y**11+104570525379*y**12-33532095842*y**13+6129539663*y**14
          -629079074*y**15+40163935*y**16-4931598*y**17+429885*y**18))))/(-62705664000*logy**5*r**25*(
          -1+y)**11-26127360000*logy**4*r**21*(-1+y)**9*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-4354560000*logy**3*r**17*(-1+y)**7*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-362880000*logy**2*r**13*(
          -1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +252000*(-1+y)*(r**9*(-1+y)**2-6*r**5*y*(2-3*y+y**2)-2*r**3*(-1
          +y)**2*(-4+y**3)+2*r**7*(-4+8*y-4*y**2+y**3)-r*(-1+y)**3*(-1-y
          -y**2+y**3))**5-15120000*logy*r**5*(-1+y)**3*(-(r**9*(-1+y)**2)+6*r**5*y*(2
          -3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)
          +r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*muWC**3*(-217728000*logy**5*r**20*(144
          +390*r**2+473*r**4+479*r**6+378*r**8+285*r**10+81*r**12)*(-1+y)**11
          -518400*logy**4*r**16*(-1+y)**6*(30318*r**20*(-1+y)**5+96*(-1+y)**7*(
          -118-236*y-354*y**2+543*y**3-170*y**4+20*y**5)+45*r**18*(-1521+7605*y
          -15210*y**2+14272*y**3-6919*y**4+1283*y**5+42*y**6)+28*r**2*(-1+y)**6*(1379
          +1379*y+1379*y**2-6466*y**3+5414*y**4-1330*y**5+120*y**6)+10*r**4*(
          -1+y)**5*(-42555+30240*y+15120*y**2-5257*y**3-14854*y**4+12936*y**5
          -2758*y**6+240*y**7)-42*r**16*(2704-9470*y+8815*y**2+8745*y**3-19060*y**4
          +12836*y**5-3895*y**6+405*y**7)+5*r**14*(-91601+338305*y-377360*y**2
          -91696*y**3+472337*y**4-366955*y**5+119490*y**6-14574*y**7+630*y**8)
          +r**6*(-1+y)**3*(-556333+1931666*y-1784833*y**2-122920*y**3+893935*y**4
          -305522*y**5-109081*y**6+85968*y**7-13680*y**8+960*y**9)+14*r**12*(
          -20528+45940*y+49870*y**2-256085*y**3+294350*y**4-130042*y**5-5360*y**6
          +27795*y**7-10800*y**8+1620*y**9)+7*r**10*(-26745-9975*y+379200*y**2
          -841390*y**3+663730*y**4+4516*y**5-353210*y**6+242300*y**7-66895*y**8
          +4725*y**9+864*y**10)-70*r**8*(-1616+22270*y-80015*y**2+120827*y**3
          -69757*y**4-22822*y**5+54561*y**6-28023*y**7+3069*y**8+2250*y**9-810*y**10
          +66*y**11))+17280*logy**3*r**12*(-1+y)**4*(-20922*r**28*(-1+y)**7+r**26*(
          -1+y)**2*(709121-3545605*y+7091210*y**2-6992075*y**3+3786280*y**4
          -1063076*y**5+127425*y**6)+24*(-1+y)**11*(-433-1732*y-4330*y**2-3440*y**3
          +1855*y**4+9868*y**5-7268*y**6+1280*y**7)+r**24*(-1+y)**2*(5007812
          -21400900*y+33706400*y**2-20443235*y**3-1143740*y**4+7072018*y**5-2796900*y**6
          +284865*y**7)+2*r**2*(-1+y)**9*(-40798-81596*y-122394*y**2+447193*y**3
          -164315*y**4+94753*y**5-340369*y**6+365784*y**7-155198*y**8+20040*y**9)
          +r**22*(-1929959+21723113*y-93916239*y**2+224921680*y**3-318473530*y**4
          +273701004*y**5-143606408*y**6+44618294*y**7-7571805*y**8+862245*y**9
          -151995*y**10)+r**4*(-1+y)**8*(2557842+1198482*y+518802*y**2-18695603*y**3
          +22606712*y**4-6498592*y**5-3809882*y**6+2796483*y**7-337202*y**8-171382*y**9
          +33840*y**10)+r**20*(-3893778+40884606*y-160146378*y**2+331980085*y**3
          -371881700*y**4+189678328*y**5+24677744*y**6-97298992*y**7+66002510*y**8
          -24419010*y**9+5254890*y**10-552705*y**11)+r**6*(-1+y)**7*(-1072281
          +4633440*y+2316720*y**2+6136805*y**3-36104790*y**4+34983942*y**5-7374710*y**6
          -6316135*y**7+3821405*y**8-500500*y**9-126276*y**10+24480*y**11)+r**18*(39397946
          -220825022*y+506022966*y**2-596953070*y**3+401255150*y**4-221922312*y**5
          +215142134*y**6-223249057*y**7+143738205*y**8-49227350*y**9+6396856*y**10
          +582843*y**11-182889*y**12)+r**8*(-1+y)**5*(-30910932+112887864*y-125653932*y**2
          -33079385*y**3+188472765*y**4-148143036*y**5+19677262*y**6+29725169*y**7
          -13791355*y**8-679940*y**9+1833358*y**10-416696*y**11+15858*y**12)+r**14*(
          -1+y)**2*(-17880754+111869570*y-219549640*y**2+46641710*y**3+364474590*y**4
          -510501252*y**5+253256030*y**6+29510665*y**7-91867295*y**8+39558450*y**9
          -5643054*y**10-293235*y**11+96615*y**12)-r**10*(-1+y)**4*(-3953161+78619443*y
          -227899383*y**2+201695126*y**3+78581945*y**4-270341154*y**5+178860892*y**6
          -16387727*y**7-34019176*y**8+16441035*y**9-2017225*y**10-457995*y**11
          +121380*y**12)-r**12*(-1+y)**3*(-44731162+165350248*y-161278572*y**2
          -82253522*y**3+222772688*y**4-76043508*y**5-78940798*y**6+61168367*y**7
          +4695237*y**8-18361748*y**9+7705210*y**10-1541985*y**11+149145*y**12)
          +r**16*(-15286352+141491504*y-497551152*y**2+844751290*y**3-634615980*y**4
          -59945746*y**5+462603302*y**6-283137711*y**7-27557320*y**8+124216505*y**9
          -73259702*y**10+21352469*y**11-3275412*y**12+214305*y**13))-288*logy**2*r**8*(
          -1+y)**2*(-1+r**2+y)**2*(-4119*r**32*(-1+y)**9-r**30*(-1+y)**4*(117601
          -579767*y+1134820*y**2-714895*y**3+356660*y**4-135286*y**5+28707*y**6)
          +48*(-1+y)**13*(-31-186*y-651*y**2-1521*y**3-2251*y**4-1044*y**5
          +4811*y**6+3251*y**7-5804*y**8+1676*y**9)+r**28*(-1+y)**2*(-23532207
          +161186453*y-471273998*y**2+763012465*y**3-748015638*y**4+456531677*y**5
          -170289958*y**6+36578263*y**7-4257735*y**8+310278*y**9)+r**26*(-1+y)**2*(
          -165187086+1068427280*y-2914135571*y**2+4247492985*y**3-3557856657*y**4
          +1675600445*y**5-329021975*y**6-66304439*y**7+49491525*y**8-9165703*y**9
          +480396*y**10)+2*r**2*(-1+y)**11*(-19931-81212*y-206750*y**2-37415*y**3
          +695745*y**4+1423002*y**5-2176146*y**6+757525*y**7-4960*y**8-72120*y**9
          +1454*y**10+14808*y**11)-r**24*(-1+y)**2*(587595515-3322846555*y+7512065501*y**2
          -7929694473*y**3+2382368483*y**4+3252732719*y**5-4015308165*y**6+1966034909*y**7
          -480787642*y**8+63564052*y**9-8584524*y**10+940980*y**11)+r**4*(-1+y)**9*(
          -5035285-8282710*y-10682019*y**2+49640549*y**3+21607365*y**4+7726845*y**5
          -231977705*y**6+291103103*y**7-125234678*y**8-3473215*y**9+20207740*y**10
          -5985260*y**11+405766*y**12+63504*y**13)+r**22*(111135799-1300774491*y
          +6361171263*y**2-19247563608*y**3+38322673547*y**4-51014615073*y**5+46390001497*y**6
          -29329849381*y**7+12577022196*y**8-2926154484*y**9-304475626*y**10+515445669*y**11
          -182761982*y**12+30090312*y**13-1681638*y**14)-r**14*(-1+y)**4*(-2678474605
          +15196488935*y-31069669942*y**2+21140965357*y**3+16984505800*y**4-38970872270*y**5
          +23521962805*y**6-184814606*y**7-6158317389*y**8+2322292645*y**9+167117850*y**10
          -288405815*y**11+63628298*y**12-4228518*y**13+73455*y**14)+r**6*(-1
          +y)**8*(21766589+13491459*y+10817923*y**2-311087462*y**3+473269991*y**4
          -277578953*y**5+211969267*y**6-338214911*y**7+289177324*y**8-100025702*y**9
          +612714*y**10+6503349*y**11+220288*y**12-700212*y**13+114336*y**14)
          -r**10*(-1+y)**6*(328402+276743644*y-308877861*y**2+1627495323*y**3
          -6939501683*y**4+10586010441*y**5-6214254048*y**6-506633298*y**7+2438936524*y**8
          -1090937944*y**9+77810457*y**10+63944479*y**11-13293691*y**12-115197*y**13
          +118452*y**14)+r**8*(-1+y)**7*(-417309643+441711352*y+96909553*y**2
          +2789942400*y**3-7724984962*y**4+6765275386*y**5-722960954*y**6-2589738716*y**7
          +1667341665*y**8-210644306*y**9-143146493*y**10+49922852*y**11+17388*y**12
          -2082640*y**13+251118*y**14)-r**12*(-1+y)**5*(3148064095-12807804780*y
          +17222587457*y**2+339160469*y**3-25139883846*y**4+26994608275*y**5-8623132850*y**6
          -4308763694*y**7+4234788127*y**8-853218148*y**9-263985045*y**10+121325705*y**11
          -410088*y**12-4913971*y**13+546294*y**14)+2*r**18*(-1+y)**2*(-2182068843
          +10846502057*y-20002733057*y**2+12180229110*y**3+9044587273*y**4-16718067004*y**5
          +4869785456*y**6+6265496654*y**7-6152960440*y**8+1837717854*y**9+166527697*y**10
          -243525788*y**11+66562678*y**12-10172295*y**13+891648*y**14)+r**16*(
          -1+y)**3*(1877144503-6810554542*y+6558361341*y**2+4593740456*y**3-15082836863*y**4
          +15454400394*y**5-10281149241*y**6+6060214158*y**7-4210643957*y**8+2823911006*y**9
          -1243056697*y**10+274881658*y**11-5129499*y**12-9190674*y**13+1083957*y**14)
          +r**20*(636211515-6233268773*y+26217300051*y**2-64554162872*y**3+99732703918*y**4
          -92956445614*y**5+39197248656*y**6+17129842598*y**7-38082809861*y**8
          +28950245609*y**9-13269855117*y**10+3784266642*y**11-574191324*y**12
          +19607858*y**13+2984898*y**14+321816*y**15))-12*logy*r**6*(-1+y)**2*(
          -1+r**2+y)**3*(2385*r**36*(-1+y)**9+r**34*(-1+y)**4*(4438-15035*y
          +8605*y**2-7288*y**3-2530*y**4-3589*y**5+3495*y**6)-r**32*(-1+y)**2*(
          -2491451+17248604*y-51064146*y**2+85681398*y**3-88176200*y**4+56088302*y**5
          -21974638*y**6+5199666*y**7-699965*y**8+42510*y**9)+r**30*(-91045171
          +806478891*y-3164596020*y**2+7196033430*y**3-10527368964*y**4+10455102822*y**5
          -7250043512*y**6+3537076000*y**7-1196071895*y**8+268877919*y**9-37243876*y**10
          +2828186*y**11-123810*y**12)+6*(-1+y)**12*(-479-2874*y-10059*y**2
          -21754*y**3-22220*y**4+2478*y**5-24612*y**6+45538*y**7+91223*y**8-100380*y**9
          -15849*y**10+50736*y**11-24404*y**12+4656*y**13)+r**28*(-1297093657
          +10804504842*y-39498501285*y**2+82881916850*y**3-109708797067*y**4+94495028487*y**5
          -52025855470*y**6+16441778256*y**7-1587747491*y**8-745672988*y**9+267874315*y**10
          -28431082*y**11+623759*y**12+74931*y**13)+r**2*(-1+y)**11*(-149851-669209*y
          -1803201*y**2-3241737*y**3+1105042*y**4+14973482*y**5+24084858*y**6
          -17621938*y**7-46988811*y**8+49404171*y**9-13003081*y**10-2352149*y**11
          +1841764*y**12-296652*y**13+9312*y**14)+r**26*(-3320893729+24981006333*y
          -80351001114*y**2+137547871200*y**3-124709737570*y**4+35464740297*y**5
          +47062492187*y**6-65228593382*y**7+41051574885*y**8-15933772587*y**9
          +4085707162*y**10-741101370*y**11+105447566*y**12-10831195*y**13+585717*y**14)
          +r**24*(-10894629155+74902721634*y-212084291757*y**2+296903853586*y**3
          -144590861919*y**4-184053250740*y**5+389954689171*y**6-328658786732*y**7
          +149995275007*y**8-30871281718*y**9-3546044511*y**10+3822227970*y**11
          -1044982061*y**12+165401432*y**13-14157463*y**14+341256*y**15)+r**22*(12487598309
          -97518919725*y+329262130092*y**2-670269823606*y**3+889144509747*y**4
          -745114329063*y**5+324531334798*y**6+39153372784*y**7-173715808205*y**8
          +149739353149*y**9-81060692808*y**10+28788685602*y**11-6188098851*y**12
          +696852311*y**13-39034546*y**14+7690212*y**15-916200*y**16)-r**4*(-1
          +y)**9*(4542736+12084339*y+21841824*y**2-67970558*y**3-112231740*y**4
          -53018331*y**5+722874116*y**6-833237908*y**7+213841856*y**8+259840085*y**9
          -229885776*y**10+60477546*y**11+3216684*y**12-5256173*y**13+1391980*y**14
          -209304*y**15+18624*y**16)+3*r**18*(-1+y)**2*(-43950324567+219623486423*y
          -422183591507*y**2+342543770843*y**3+5493835476*y**4-224230426807*y**5
          +164303042813*y**6-47415575361*y**7+19282659724*y**8-27772234307*y**9
          +19749007755*y**10-6541370595*y**11+1039413068*y**12-48735517*y**13-17574869*y**14
          +3560969*y**15+40459*y**16)-r**8*(-1+y)**7*(161114983-195484457*y-128872697*y**2
          -6427999167*y**3+20066946361*y**4-18126859127*y**5-2457298207*y**6+12395901039*y**7
          -4222140891*y**8-3107194327*y**9+2768809985*y**10-817666465*y**11+107793783*y**12
          -9884617*y**13+2815991*y**14-296591*y**15+58404*y**16)+r**10*(-1+y)**6*(12810803317
          -19904117355*y+422398845*y**2-69674645025*y**3+239301546688*y**4-249137114817*y**5
          +35854208361*y**6+123719667731*y**7-96765483784*y**8+19435568935*y**9
          +6987541139*y**10-3161729191*y**11-184287376*y**12+247327909*y**13-33627673*y**14
          -273739*y**15+64035*y**16)-r**6*(-1+y)**8*(-305935391-382261441*y-390406776*y**2
          +3121060894*y**3-258201181*y**4-256107267*y**5-10672992758*y**6+16517899884*y**7
          -8217510861*y**8-525821231*y**9+1955581564*y**10-619197954*y**11+8414317*y**12
          +23629267*y**13-977838*y**14-603656*y**15+70428*y**16)+r**12*(-1+y)**5*(17188599611
          -35732655503*y+12839871054*y**2+529725916*y**3+20252464970*y**4+1275377991*y**5
          -68338822370*y**6+86580119406*y**7-41206078128*y**8+1430506159*y**9+6012472634*y**10
          -1618649712*y**11-332260810*y**12+220370137*y**13-34964454*y**14-536986*y**15
          +212085*y**16)+r**14*(-1+y)**4*(74778589231-333685997963*y+514989425902*y**2
          -46359761312*y**3-862154272285*y**4+1145020889327*y**5-542642251472*y**6
          -72419864334*y**7+171651198339*y**8-44406894445*y**9-10466692282*y**10
          +4676072348*y**11+790198757*y**12-488671127*y**13+49961980*y**14-4188526*y**15
          +593862*y**16)+r**16*(-1+y)**3*(-43241153723+218083294017*y-430416458433*y**2
          +417798877717*y**3-230658283203*y**4+164792768859*y**5-192455352299*y**6
          +135931978407*y**7-44744278503*y**8-1544975833*y**9+13525407777*y**10
          -10888004397*y**11+4659026651*y**12-1024045539*y**13+88489611*y**14-4999663*y**15
          +940554*y**16)+r**20*(20850856853-179712888828*y+666014600475*y**2-1412007391970*y**3
          +1775170124842*y**4-1074274961997*y**5-335602832247*y**6+1286041276000*y**7
          -1232356178110*y**8+659199218021*y**9-191248568755*y**10+4903307238*y**11
          +19439442250*y**12-7746647395*y**13+1514930287*y**14-208263876*y**15
          +25170837*y**16-1193625*y**17))+r**6*(-1+r**2+y)**4*(2067*r**36*(-1+y)**11
          +2*r**34*(-1+y)**6*(125444-608776*y+1169375*y**2-1118060*y**3+542104*y**4
          -118508*y**5+7725*y**6)+r**32*(-1+y)**4*(-5982045+40854395*y-118630973*y**2
          +192958045*y**3-191689167*y**4+118855079*y**5-45926587*y**6+10625875*y**7
          -1254924*y**8+36222*y**9)-2*r**30*(-1+y)**2*(-20776472+190482824*y
          -772556330*y**2+1813221794*y**3-2751171915*y**4+2869975006*y**5-2121739986*y**6
          +1111936426*y**7-402331444*y**8+95136330*y**9-13273404*y**10+837092*y**11
          +9519*y**12)-2*r**28*(-681920348+7041453266*y-32763050009*y**2+90380144265*y**3
          -164268176595*y**4+207188128556*y**5-186147240428*y**6+120201584995*y**7
          -55376712068*y**8+17693105724*y**9-3693903355*y**10+461020977*y**11-41624261*y**12
          +9047038*y**13-1918984*y**14+128427*y**15)+3*(-1+y)**13*(-65405-380934*y
          -1298781*y**2-2633070*y**3-2949463*y**4-434656*y**5+838405*y**6+5689788*y**7
          +4056141*y**8-8092558*y**9-833907*y**10+4804738*y**11-2540657*y**12
          +490004*y**13-11029*y**14+1168*y**15+216*y**16)-2*r**26*(-3861325232
          +36960026440*y-157376751358*y**2+390510445482*y**3-618769062035*y**4
          +636757670658*y**5-394488509186*y**6+82788088218*y**7+90375385761*y**8
          -101855341072*y**9+52324234826*y**10-16154229734*y**11+3197238795*y**12
          -464598538*y**13+62440662*y**14-6219022*y**15+236535*y**16)+2*r**2*(
          -1+y)**11*(1507964+4757564*y+9432359*y**2+9604249*y**3-53905684*y**4
          -122594302*y**5+13619701*y**6+285924397*y**7+161329464*y**8-686984380*y**9
          +499514349*y**10-112672337*y**11-22264944*y**12+12684462*y**13-611561*y**14
          -222261*y**15+37072*y**16+3888*y**17)-2*r**8*(-1+y)**8*(-4224143788
          -1066477398*y+872207111*y**2+11126784149*y**3+45160254356*y**4-87332047649*y**5
          -49138390375*y**6+186918968437*y**7-126919211646*y**8+7954862275*y**9
          +24746128749*y**10-9034860629*y**11+64365100*y**12+400590097*y**13-38866381*y**14
          -4195637*y**15-1241398*y**16+18627*y**17)+r**4*(-1+y)**10*(-61393503
          -139182805*y-219966730*y**2+1237717458*y**3+515911584*y**4-685523110*y**5
          -8314891558*y**6+14258608790*y**7-4389878262*y**8-7139651264*y**9+7070978178*y**10
          -2195502170*y**11-45902576*y**12+165098654*y**13-27834770*y**14+1517810*y**15
          +96933*y**16+37341*y**17)+2*r**6*(-1+y)**9*(1464920120+1194516048*y
          +754973114*y**2-13925170620*y**3+6280146273*y**4+1032211787*y**5+38223106908*y**6
          -67011672722*y**7+38340491103*y**8-2084158843*y**9-5776198306*y**10+1446357868*y**11
          +298386235*y**12-120712783*y**13-2336180*y**14+4511074*y**15+38701*y**16
          +38223*y**17)+6*r**18*(-1+y)**3*(-5688777288+29453191312*y-60131707324*y**2
          +111887846934*y**3-266747706249*y**4+467968825821*y**5-482123798830*y**6
          +266699282602*y**7-39805523581*y**8-57687485385*y**9+58491539524*y**10
          -30438694394*y**11+10120510865*y**12-2318519553*y**13+360826934*y**14
          -27484982*y**15-1007763*y**16+49357*y**17)-2*r**24*(-1965996608+11631350130*y
          -14750416223*y**2-87349632429*y**3+444913916736*y**4-995712164255*y**5
          +1347136909815*y**6-1196071387309*y**7+714899954466*y**8-286127018579*y**9
          +73261128787*y**10-9941054587*y**11-346255960*y**12+598724263*y**13-222100507*y**14
          +48487301*y**15-4164058*y**16+55017*y**17)-2*r**10*(-1+y)**7*(-53655411728
          +90603728664*y-14216217446*y**2+226511127504*y**3-788077545569*y**4
          +830741959193*y**5-199589808972*y**6-250752971612*y**7+200467786707*y**8
          -38221508317*y**9-8300562942*y**10+1196571392*y**11+2088527037*y**12
          -821148961*y**13+105580336*y**14-3708948*y**15-4333759*y**16+305421*y**17)
          +2*r**20*(-1+y)**2*(-76459574539+555574094789*y-1716597672307*y**2+3082512391279*y**3
          -3414711621718*y**4+2031223095293*y**5+66761920171*y**6-1261123992035*y**7
          +1173814463772*y**8-588687107029*y**9+169674834591*y**10-17339857619*y**11
          -5286835494*y**12+1847759499*y**13-176118503*y**14+15243255*y**15-7643141*y**16
          +659736*y**17)-2*r**16*(-1+y)**4*(-324900788359+1503293922787*y-2581126151622*y**2
          +1383088010810*y**3+1594329362989*y**4-3115980525732*y**5+2147348315840*y**6
          -691567553774*y**7+128293008969*y**8-75340910714*y**9+17929303850*y**10
          +31060534638*y**11-23938590437*y**12+7411090196*y**13-1157003700*y**14
          +71811766*y**15-1139290*y**16+717783*y**17)-2*r**12*(-1+y)**6*(-150594725608
          +377744241522*y-228887342059*y**2+238362972935*y**3-1098324676314*y**4
          +1536391866865*y**5-550651245077*y**6-517925408843*y**7+533380181046*y**8
          -124878748091*y**9-30575711325*y**10+12391723489*y**11+3636814114*y**12
          -2134741581*y**13+316575005*y**14-19970557*y**15-5855734*y**16+810213*y**17)
          -2*r**14*(-1+y)**5*(-402984850488+1629870622880*y-2342594446314*y**2
          +830160455092*y**3+1402981379395*y**4-1729095834615*y**5+647859218396*y**6
          -19414080822*y**7+35662214397*y**8-95315778429*y**9+49230889390*y**10
          -5635895256*y**11-2893708123*y**12+1188759911*y**13-166073616*y**14-5638262*y**15
          -3846045*y**16+1108509*y**17)+2*r**22*(31283721816-276622538920*y+1071827807538*y**2
          -2381937226142*y**3+3269255411193*y**4-2620706335726*y**5+660474769005*y**6
          +1033797854106*y**7-1339033870451*y**8+667119064294*y**9-30528464491*y**10
          -161504744570*y**11+104570525379*y**12-33532095842*y**13+6129539663*y**14
          -629079074*y**15+40163935*y**16-4931598*y**17+429885*y**18))))/(-70543872000*logy**5*r**25*(
          -1+y)**11-29393280000*logy**4*r**21*(-1+y)**9*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-4898880000*logy**3*r**17*(-1+y)**7*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-408240000*logy**2*r**13*(
          -1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +283500*(-1+y)*(r**9*(-1+y)**2-6*r**5*y*(2-3*y+y**2)-2*r**3*(-1
          +y)**2*(-4+y**3)+2*r**7*(-4+8*y-4*y**2+y**3)-r*(-1+y)**3*(-1-y
          -y**2+y**3))**5-17010000*logy*r**5*(-1+y)**3*(-(r**9*(-1+y)**2)+6*r**5*y*(2
          -3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)
          +r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(217728000*logy**5*r**19*(-3
          +5*r**2+18*r**4+25*r**6+21*r**8)*(-1+y)**10+518400*logy**4*r**15*(-1
          +y)**8*(3750*r**16*(-1+y)**2+r**14*(6971-13942*y+6971*y**2+210*y**3)
          -14*r**12*(-2912+2674*y+1813*y**2-2210*y**3+315*y**4)+175*r**10*(-7
          +314*y-457*y**2+212*y**3-56*y**4+26*y**5)-50*(-1+y)**3*(57+57*y
          +57*y**2-244*y**3+190*y**4-62*y**5+8*y**6)+70*r**8*(-340+1220*y-1150*y**2
          +175*y**3+317*y**4-238*y**5+72*y**6)+35*r**6*(-737+1774*y-1187*y**2
          -50*y**3+583*y**4-476*y**5+147*y**6)-r**2*(-1+y)**2*(943+14560*y**3
          -18725*y**4+9912*y**5-2520*y**6+240*y**7)+14*r**4*(-184-82*y+491*y**2
          -210*y**3+440*y**4-801*y**5+412*y**6-76*y**7+10*y**8))+17280*logy**3*r**11*(
          -1+y)**6*(-1+r**2+y)**2*(5850*r**20*(-1+y)**4-r**18*(-1+y)**2*(-72583
          +156866*y-95983*y**2+20465*y**3)-r**16*(-1+y)**2*(-741876+1190618*y
          -398158*y**2-62129*y**3+2965*y**4)+r**14*(1013744-3959074*y+5919965*y**2
          -3711320*y**3+171300*y**4+896226*y**5-384461*y**6+56070*y**7)+35*(
          -1+y)**5*(246+738*y+1476*y**2-253*y**3-1162*y**4-2295*y**5+3626*y**6
          -1634*y**7+248*y**8)-2*r**12*(-1693211+4649297*y-4137246*y**2+451020*y**3
          +1421455*y**4-928399*y**5+309408*y**6-90279*y**7+10255*y**8)+r**6*(
          -1+y)**2*(51064-456902*y-234653*y**2+3729116*y**3-4954405*y**4+2425366*y**5
          -298943*y**6-113792*y**7+23489*y**8+3960*y**9)-2*r**4*(-1+y)**3*(-231852
          -111019*y-88601*y**2+1109682*y**3-1155315*y**4+545202*y**5-227381*y**6
          +127776*y**7-46257*y**8+6015*y**9)-5*r**10*(-533790+1433974*y-1083583*y**2
          -624082*y**3+1646249*y**4-1052972*y**5+105213*y**6+170339*y**7-70343*y**8
          +6545*y**9)+r**2*(-1+y)**4*(-41557-100334*y-176331*y**2+197747*y**3
          +13145*y**4+245127*y**5-481611*y**6+303096*y**7-80672*y**8+7640*y**9)
          +r**8*(889382-2213818*y+808892*y**2+4744922*y**3-9789178*y**4+8058358*y**5
          -2013732*y**6-1347567*y**7+1172603*y**8-353997*y**9+44135*y**10))+288*logy**2*r**7*(
          -1+y)**4*(-1+r**2+y)**3*(669*r**26*(-1+y)**6-r**24*(-1+y)**4*(-118314
          +238635*y-122328*y**2+25912*y**3)+r**22*(-1+y)**2*(3167785-11975089*y
          +16753020*y**2-10415430*y**3+2633185*y**4-163425*y**5+26454*y**6)+r**20*(
          -1+y)**2*(15589697-58101152*y+81125520*y**2-51480280*y**3+12295665*y**4
          +1624808*y**5-1143358*y**6+120650*y**7)-5*r**18*(-1+y)**2*(-18466988
          +55662707*y-55831650*y**2+13544638*y**3+10603714*y**4-6287825*y**5
          +1049118*y**6-236132*y**7+31298*y**8)-(-1+y)**8*(6063+30315*y+90945*y**2
          +143090*y**3+80475*y**4-173951*y**5-202665*y**6-19220*y**7+334410*y**8
          -202250*y**9+35288*y**10)+r**16*(46245657-280978617*y+721782105*y**2
          -919197130*y**3+436678695*y**4+278084151*y**5-480834901*y**6+240888970*y**7
          -37438720*y**8-8517570*y**9+3532192*y**10-237832*y**11)+r**4*(-1+y)**6*(
          -3345211-8987232*y-16688940*y**2+10693540*y**3+12777260*y**4+23309612*y**5
          -50514186*y**6+28623440*y**7-5548365*y**8-154310*y**9+101674*y**10+6218*y**11)
          -5*r**8*(-1+y)**4*(11502308-1898611*y-1819120*y**2-50284312*y**3+78291632*y**4
          -44334412*y**5+9881548*y**6+226730*y**7-1220008*y**8+798633*y**9-221456*y**10
          +11568*y**11)-r**2*(-1+y)**7*(-161070-662469*y-1701645*y**2-1099015*y**3
          +358515*y**4+3185615*y**5-1525767*y**6+586395*y**7-1596885*y**8+1288110*y**9
          -392720*y**10+40936*y**11)+2*r**12*(-1+y)**2*(69275405-133172846*y
          +1040115*y**2+265979180*y**3-323162495*y**4+80477520*y**5+113588437*y**6
          -89772815*y**7+17157020*y**8+3425245*y**9-1409850*y**10+136334*y**11)
          +r**6*(-1+y)**5*(4985051+11477074*y+20380875*y**2-44879090*y**3+7535340*y**4
          -51188752*y**5+115984152*y**6-82748400*y**7+20834365*y**8+1283010*y**9
          -1375099*y**10+175474*y**11)-r**10*(-1+y)**3*(49005141-114721545*y
          -2397465*y**2+445650725*y**3-660713610*y**4+298317888*y**5+85588070*y**6
          -122963360*y**7+31831025*y**8+3928485*y**9-2839229*y**10+261875*y**11)
          +2*r**14*(109977961-426210609*y+598273968*y**2-264236790*y**3-199371795*y**4
          +288817653*y**5-122776787*y**6+8618729*y**7+13624740*y**8-11120080*y**9
          +5710061*y**10-1474379*y**11+167328*y**12))+12*logy*r**3*(-1+y)**4*(
          -1+r**2+y)**4*(69*r**32*(-1+y)**6+r**30*(-1+y)**4*(-5181+10086*y-4629*y**2
          +910*y**3)+2*r**28*(-1+y)**2*(217572-844008*y+1208685*y**2-796093*y**3
          +250841*y**4-33535*y**5+3158*y**6)+r**26*(14514773-83097582*y+196451973*y**2
          -248020986*y**3+180551617*y**4-76011548*y**5+17132107*y**6-1463878*y**7
          -70654*y**8+178*y**9)+r**24*(146352860-780131516*y+1692810174*y**2
          -1890025322*y**3+1102554407*y**4-264630208*y**5-27308279*y**6+22744626*y**7
          -2863463*y**8+443668*y**9-40947*y**10)+3*(-1+y)**11*(-23-207*y-1035*y**2
          -3209*y**3-5249*y**4-1129*y**5+4927*y**6+5925*y**7-1756*y**8-3996*y**9
          +1552*y**10)+r**22*(323369043-1679334598*y+3602060705*y**2-4025291722*y**3
          +2260869658*y**4-208832576*y**5-525519870*y**6+324158270*y**7-77665293*y**8
          +6100662*y**9+527413*y**10-27292*y**11)+2*r**20*(1070224308-4721605544*y
          +7887558711*y**2-5283712565*y**3-631020121*y**4+3063105392*y**5-1688443900*y**6
          +282976679*y**7+30043735*y**8-11606384*y**9+2686245*y**10-481386*y**11
          +43830*y**12)-r**6*(-1+y)**6*(12879047+48451484*y+116459156*y**2+25032582*y**3
          -50846705*y**4-206117534*y**5+190894492*y**6-82901202*y**7+95345261*y**8
          -79385670*y**9+27739112*y**10-3332276*y**11-67979*y**12+232*y**13)+r**2*(
          -1+y)**8*(-14649-87618*y-305697*y**2-681498*y**3-741218*y**4+168370*y**5
          +1141658*y**6+854386*y**7-1291837*y**8+299568*y**9-186321*y**10+208360*y**11
          -71264*y**12+7760*y**13)+2*r**4*(-1+y)**7*(612420+2945748*y+8560599*y**2
          +10999556*y**3+3835642*y**4-17059173*y**5-8250144*y**6+439669*y**7+20416300*y**8
          -14771417*y**9+3249753*y**10+52171*y**11-85418*y**12+9294*y**13)+r**8*(
          -1+y)**5*(136852196+298437944*y+473415734*y**2-776373268*y**3-415559709*y**4
          -642407881*y**5+2321167888*y**6-1642070332*y**7+296905542*y**8+120680834*y**9
          -59792190*y**10+8109968*y**11-207477*y**12+22751*y**13)-r**14*(-1+y)**2*(
          -2484294705+6091052608*y-1651177246*y**2-12337836914*y**3+16585630377*y**4
          -3636030298*y**5-6435083324*y**6+4144917944*y**7+65151105*y**8-708026952*y**9
          +194307578*y**10-10814734*y**11-1977673*y**12+40234*y**13)+r**18*(-950862723
          +2762654018*y-15453047*y**2-6245243566*y**3+3408697062*y**4+6985428478*y**5
          -9409889794*y**6+3434791906*y**7+628322649*y**8-768620412*y**9+181062145*y**10
          -7446524*y**11-882884*y**12+60692*y**13)+2*r**12*(-1+y)**3*(827108244
          -611921812*y-359771423*y**2-2570705756*y**3+6146942587*y**4-3924736436*y**5
          -488771374*y**6+1636171258*y**7-678495906*y**8+70611438*y**9+12083317*y**10
          -416714*y**11-576685*y**12+96262*y**13)+r**10*(-1+y)**4*(78378471-39250750*y
          -256842083*y**2+417379774*y**3-253724376*y**4+1697948302*y**5-3239842886*y**6
          +2138906180*y**7-347185449*y**8-165329074*y**9+57483977*y**10+872086*y**11
          -1674422*y**12+170250*y**13)+r**16*(3555781374-9915875416*y+5266988984*y**2
          +9321952402*y**3-9851297549*y**4-5690391848*y**5+13651916377*y**6-7907840578*y**7
          +1413193406*y**8+205825878*y**9-31100576*y**10-20382336*y**11-807231*y**12
          +2152042*y**13-114929*y**14))+r*(-1+y)**2*(-1+r**2+y)**5*(55*r**34*(
          -1+y)**8+r**32*(-1+y)**6*(-1169+2891*y-1861*y**2+515*y**3)+r**30*(
          -1+y)**4*(-71688+230978*y-241019*y**2+81710*y**3+5480*y**4-9660*y**5
          +1739*y**6)+r**28*(-1+y)**2*(13989368-78411814*y+179753715*y**2-217874419*y**3
          +151044829*y**4-60283689*y**5+12996773*y**6-1364661*y**7+89763*y**8
          +1175*y**9)+r**26*(147065776-1066771378*y+3337324439*y**2-5883029418*y**3
          +6391698101*y**4-4372256826*y**5+1811257308*y**6-377185494*y**7-5007352*y**8
          +20570364*y**9-3835275*y**10+217680*y**11-8725*y**12)+(-1+y)**12*(11
          +99*y+495*y**2+2417*y**3+4974*y**4+2078*y**5-2482*y**6-4358*y**7
          +2199*y**8+1991*y**9-2349*y**10+373*y**11+128*y**12+24*y**13)-r**24*(
          -914987072+6189236306*y-17808643741*y**2+27926204153*y**3-24813074145*y**4
          +10531144441*y**5+1064266542*y**6-3550943102*y**7+1707773462*y**8-369468700*y**9
          +44192911*y**10-5943643*y**11+328523*y**12+26065*y**13)+r**2*(-1+y)**10*(1475
          +9552*y+35530*y**2-32010*y**3-385125*y**4-953460*y**5+340516*y**6
          +1311040*y**7+511145*y**8-802420*y**9-970190*y**10+1006282*y**11-249495*y**12
          +8440*y**13+720*y**14)+r**4*(-1+y)**9*(760128+4378378*y+14777413*y**2
          +27866194*y**3+23237302*y**4-20033664*y**5-32522809*y**6-17969404*y**7
          +43973404*y**8-17544502*y**9+4056011*y**10-2462694*y**11+1053566*y**12
          -176548*y**13+7225*y**14)-r**22*(-268400208+1711048238*y-5373777709*y**2
          +10796926442*y**3-13841834620*y**4+9274618956*y**5+471788059*y**6-6237063452*y**7
          +4942948616*y**8-1645542530*y**9+105268177*y**10+84572178*y**11-21436364*y**12
          +790792*y**13+9425*y**14)+r**6*(-1+y)**8*(-20887424-93357290*y-255121929*y**2
          -242414574*y**3-8186684*y**4+520893844*y**5+45438071*y**6-69001676*y**7
          -480696536*y**8+436760934*y**9-116014195*y**10-2660006*y**11+5432580*y**12
          -784240*y**13+39125*y**14)+r**8*(-1+y)**7*(80508472+260842614*y+569840915*y**2
          -450974846*y**3-445144694*y**4-1045230298*y**5+2128136423*y**6-1423625124*y**7
          +572765588*y**8-194339206*y**9+66130001*y**10-18628062*y**11+4923434*y**12
          -1180342*y**13+135125*y**14)+r**10*(-1+y)**6*(-997350440-1691176054*y
          -2161565359*y**2+6458255650*y**3+1869540616*y**4+2512289854*y**5-16959642473*y**6
          +13895644552*y**7-2294697416*y**8-1630468478*y**9+768549711*y**10-105849498*y**11
          +6637832*y**12-1702234*y**13+321737*y**14)+r**18*(-1+y)**2*(-21464732546
          +80084335418*y-94166632275*y**2+11006026918*y**3+49762915502*y**4-16290011486*y**5
          -20044465389*y**6+9592091992*y**7+5410988386*y**8-4937597702*y**9+1210156907*y**10
          -49186654*y**11-10484542*y**12+485546*y**13+353925*y**14)+r**12*(-1
          +y)**5*(-2962785336-1299152086*y+822920757*y**2+10415132474*y**3-3496526810*y**4
          -12294826868*y**5+9029674107*y**6+2033454036*y**7-3873416148*y**8+966167730*y**9
          +277409179*y**10-174440046*y**11+36926182*y**12-4405576*y**13+548405*y**14)
          +r**16*(-1+y)**3*(-36057039998+78996220630*y-25665244733*y**2-53907218698*y**3
          +16916999192*y**4+57885030698*y**5-49074055893*y**6+3290362788*y**7+11342421858*y**8
          -5353479742*y**9+1037638625*y**10-122180362*y**11+26619220*y**12-3790610*y**13
          +597025*y**14)+r**14*(-1+y)**4*(-15844558024+14193547926*y+7326717511*y**2
          +38252996058*y**3-97714128676*y**4+53843946232*y**5+20577360027*y**6
          -28618156188*y**7+6467116728*y**8+1429901446*y**9-381702483*y**10-155945278*y**11
          +61356852*y**12-6717236*y**13+677105*y**14)+r**20*(12414648592-74537652958*y
          +182652788711*y**2-219150562991*y**3+94072277508*y**4+76732714698*y**5
          -124636788589*y**6+62473124073*y**7-5095455208*y**8-7606391946*y**9+3016296133*y**10
          -313264053*y**11-27675884*y**12+5452574*y**13+376513*y**14+112827*y**15)))*math.log(mu0**2/r**2))/(
          -3483648000*logy**5*r**20*(-1+y)**10+14000*(r**8*(-1+y)**2-6*r**4*y*(2
          -3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)
          -(-1+y)**3*(-1-y-y**2+y**3))**5-1451520000*logy**4*r**16*(-1+y)**8*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-241920000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          -20160000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**3-840000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2
          -3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)
          +r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(-18144000*logy**4*r**15*(46
          +83*r**2+80*r**4+45*r**6+12*r**8)*(-1+y)**10-86400*logy**3*r**11*(-1
          +y)**8*(1312*r**14*(-1+y)**2+472*r**16*(-1+y)**2-7*r**12*(-2429+3418*y
          -269*y**2-915*y**3+180*y**4)+7*r**10*(5216-5032*y-2884*y**2+2905*y**3
          -285*y**4+60*y**5)+35*r**8*(681+558*y-2199*y**2+682*y**3+382*y**4
          -191*y**5+52*y**6)+(-1+y)**3*(87+87*y+87*y**2-6283*y**3+5092*y**4
          -1040*y**5+80*y**6)+7*r**6*(-2936+15832*y-17876*y**2+1180*y**3+5670*y**4
          -2799*y**5+623*y**6+36*y**7)+r**2*(-1+y)**2*(-9208+10605*y**3-13965*y**4
          +8148*y**5-1330*y**6+80*y**7)-7*r**4*(7041-19602*y+15321*y**2+195*y**3
          -4015*y**4+719*y**5+777*y**6-476*y**7+40*y**8))-1440*logy**2*r**7*(-1
          +y)**6*(-1+r**2+y)**2*(866*r**20*(-1+y)**4-r**18*(-1+y)**2*(-7971+17674*y
          -11435*y**2+2772*y**3)-r**16*(-1+y)**2*(-170979+274672*y-81485*y**2
          -21775*y**3+3722*y**4)+r**14*(-1+y)**2*(378732-711016*y+348065*y**2
          +39601*y**3-47388*y**4+10416*y**5)+r**12*(2867580-8799676*y+8910451*y**2
          -2043295*y**3-1903700*y**4+1043875*y**5-41719*y**6-40026*y**7+5110*y**8)
          -(-1+y)**4*(177+354*y+531*y**2-9712*y**3+5415*y**4-1802*y**5-33379*y**6
          +48344*y**7-20888*y**8+2560*y**9)-r**10*(-7035366+21252160*y-20428801*y**2
          +2528581*y**3+7278746*y**4-4340659*y**5+592290*y**6+273526*y**7-134981*y**8
          +15204*y**9)+r**8*(7375734-22440244*y+22051981*y**2-4522609*y**3-4385409*y**4
          +1517943*y**5+968569*y**6-674081*y**7+95859*y**8+21959*y**9-1302*y**10)
          +r**4*(-1+y)**2*(274698-22864*y-15565*y**2-2227211*y**3+4252003*y**4
          -2935604*y**5+673869*y**6+104695*y**7-63509*y**8+8152*y**9+1736*y**10)
          -r**2*(-1+y)**3*(-3425-3779*y-4133*y**2-244042*y**3+251339*y**4-61155*y**5
          +142909*y**6-187762*y**7+102322*y**8-28434*y**9+2560*y**10)+r**6*(2001276
          -5149120*y+3949567*y**2-3385243*y**3+10069747*y**4-14621355*y**5+10004337*y**6
          -2962467*y**7-223457*y**8+413953*y**9-110046*y**10+12808*y**11))-24*logy*r**3*(
          -1+y)**4*(-1+r**2+y)**3*(124*r**26*(-1+y)**6-4*r**24*(-1+y)**4*(-2024
          +4141*y-2210*y**2+473*y**3)-r**22*(-1+y)**2*(-279741+1039704*y-1414110*y**2
          +821525*y**3-158995*y**4-10219*y**5+836*y**6)+r**20*(-1+y)**2*(1216919
          -4671119*y+6783810*y**2-4611640*y**3+1315345*y**4+66951*y**5-103246*y**6
          +11680*y**7)+5*r**18*(-1+y)**2*(3952987-12399292*y+12901560*y**2-3536353*y**3
          -1971707*y**4+1145121*y**5-79870*y**6-14022*y**7+456*y**8)-r**16*(-1
          +y)**2*(-16243217+61756553*y-90149592*y**2+52232158*y**3+2938233*y**4
          -15611383*y**5+5658772*y**6-216308*y**7-306908*y**8+31992*y**9)-2*r**14*(
          -99397639+447087702*y-760883973*y**2+525679005*y**3+35335160*y**4-260518422*y**5
          +116802196*y**6+13873056*y**7-22950255*y**8+5024990*y**9+58611*y**10
          -117823*y**11+3892*y**12)+(-1+y)**6*(89+267*y+534*y**2-6200*y**3
          +620*y**4-1938*y**5-39474*y**6+42512*y**7-13925*y**8-14745*y**9+41724*y**10
          -30168*y**11+6704*y**12)-r**6*(-1+y)**3*(3291509-291267*y-428253*y**2
          -50003974*y**3+110194635*y**4-89557158*y**5+42837394*y**6-37227984*y**7
          +35101883*y**8-17433835*y**9+4115699*y**10-219202*y**11-101963*y**12
          +2516*y**13)-10*r**8*(-1+y)**2*(-3378079+5716129*y-1713420*y**2+18827756*y**3
          -64928536*y**4+83530232*y**5-48091744*y**6+5561134*y**7+8279937*y**8
          -4716339*y**9+975972*y**10-12410*y**11-32314*y**12+2682*y**13)+r**2*(
          -1+y)**5*(-2391-5049*y-7974*y**2-318101*y**3+195315*y**4-48283*y**5
          -522397*y**6+1220773*y**7-684678*y**8+225860*y**9-268901*y**10+171496*y**11
          -46374*y**12+6704*y**13)+r**4*(-1+y)**4*(-243649-214969*y-196375*y**2
          -1583377*y**3+1295300*y**4+1045358*y**5+9828958*y**6-23915370*y**7+21064319*y**8
          -8489725*y**9+897241*y**10+416211*y**11-130930*y**12+17008*y**13)+2*r**12*(196237109
          -904195479*y+1589045601*y**2-1157042431*y**3-66406220*y**4+702358182*y**5
          -470010022*y**6+91351038*y**7+42602047*y**8-30238155*y**9+6282709*y**10
          +208501*y**11-221264*y**12+21384*y**13)+2*r**10*(69385171-289251138*y
          +449968683*y**2-348654421*y**3+309773170*y**4-531778662*y**5+614392506*y**6
          -358809186*y**7+70005447*y**8+33530690*y**9-22644759*y**10+3930507*y**11
          +245128*y**12-99526*y**13+6390*y**14))+r*(-1+y)**3*(-1+r**2+y)**4*(29*r**28*(
          -1+y)**7+2*r**26*(-1+y)**5*(-9679+17812*y-7331*y**2+803*y**3)+r**24*(
          -1+y)**3*(-416467+1545904*y-2105392*y**2+1321998*y**3-395457*y**4
          +34010*y**5+4964*y**6)+2*r**22*(3729334-23521398*y+62275708*y**2-88696836*y**3
          +71352580*y**4-29491797*y**5+2675613*y**6+2411082*y**7-787624*y**8+53085*y**9
          +253*y**10)+r**20*(9712151-63445793*y+180316883*y**2-291967077*y**3
          +291693498*y**4-175201964*y**5+48861214*y**6+7787392*y**7-10333673*y**8
          +2819277*y**9-232537*y**10-9371*y**11)+2*r**18*(170110489-970748873*y
          +2251511909*y**2-2607457140*y**3+1328041785*y**4+179521477*y**5-578525259*y**6
          +262463037*y**7-25598860*y**8-12427060*y**9+3343934*y**10-238593*y**11
          +3154*y**12)+r**16*(-332810921+1798678843*y-3699927499*y**2+3185081187*y**3
          +6873470*y**4-2151467458*y**5+1564284754*y**6-312374462*y**7-99702549*y**8
          +34289955*y**9+12628729*y**10-5920197*y**11+337536*y**12+28612*y**13)
          -4*r**14*(-763803634+3953792250*y-8007121780*y**2+7155626336*y**3-727122542*y**4
          -3991872507*y**5+3100911685*y**6-434505120*y**7-504310742*y**8+243271074*y**9
          -13497184*y**10-14529260*y**11+3372450*y**12-172669*y**13+3643*y**14)
          -(-1+y)**7*(-1219-4876*y-12190*y**2-53726*y**3-57599*y**4-60452*y**5
          -100308*y**6+64600*y**7+28027*y**8+27928*y**9+40246*y**10-31866*y**11
          -6585*y**12-3976*y**13+3996*y**14)-2*r**2*(-1+y)**6*(-28999-83491*y
          -160504*y**2-509763*y**3-291798*y**4-141107*y**5+856942*y**6-335092*y**7
          +514091*y**8+656701*y**9-1729794*y**10+1115399*y**11-309054*y**12+15897*y**13
          +10572*y**14)-2*r**6*(-1+y)**4*(-1747494-2692674*y-2217888*y**2+52654704*y**3
          -70516058*y**4+25629523*y**5-96509077*y**6+252384516*y**7-254549278*y**8
          +116511436*y**9-13147154*y**10-9611124*y**11+3714622*y**12-348301*y**13
          +24247*y**14)-r**4*(-1+y)**5*(-1031203-1894810*y-2581795*y**2+3056192*y**3
          -7588199*y**4+5658616*y**5+39989175*y**6-72121960*y**7+47385311*y**8
          -15138362*y**9+4687187*y**10-2631640*y**11+745355*y**12-89028*y**13
          +43161*y**14)-2*r**10*(-1+y)**2*(-207985809+481541039*y-286500000*y**2
          +903503009*y**3-3590310564*y**4+5467058788*y**5-3683170003*y**6+499750230*y**7
          +846157067*y**8-533705057*y**9+100893146*y**10+6724089*y**11-3308230*y**12
          +60174*y**13+48121*y**14)-r**8*(-1+y)**3*(81688601-63125904*y-18246624*y**2
          -824402394*y**3+2199417281*y**4-2172958442*y**5+946134068*y**6-139090092*y**7
          -20820877*y**8+21920348*y**9-4309184*y**10-10996314*y**11+6408691*y**12
          -838754*y**13+59596*y**14)+r**12*(1245892009-5951388223*y+10981863373*y**2
          -8856690651*y**3+612412525*y**4+5215282129*y**5-5578071319*y**6+3153249589*y**7
          -512278213*y**8-784685165*y**9+649390375*y**10-190326833*y**11+12655663*y**12
          +2907739*y**13-123485*y**14-89513*y**15)))*nlo.X1El(0,'SM',y/2,r))/(-3483648000*logy**5*r**20*(
          -1+y)**10+14000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-1451520000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-241920000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-20160000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -840000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*(-1512000*logy**3*r**12*(19+19*r**2+11*r**4
          +3*r**6)*(-1+y)**8-3600*logy**2*r**8*(-1+y)**6*(175*r**12*(-1+y)**2+255*r**14*(
          -1+y)**2-7*r**10*(-897+1254*y-87*y**2-340*y**3+90*y**4)+35*r**8*(405
          -414*y-189*y**2+204*y**3-38*y**4+8*y**5)-35*r**2*(-1+y)**2*(213-5*y**4
          -32*y**5+4*y**6)+35*r**6*(275+134*y-751*y**2+196*y**3+143*y**4-82*y**5
          +25*y**6)+35*r**4*(-669+2022*y-1695*y**2+52*y**3+495*y**4-282*y**5
          +77*y**6)+(-1+y)**3*(-361-361*y-361*y**2-4001*y**3+3804*y**4-900*y**5
          +80*y**6))-60*logy*r**4*(-1+y)**4*(-1+r**2+y)**2*(355*r**18*(-1+y)**4
          -r**16*(-1+y)**2*(-1153+3016*y-2573*y**2+1470*y**3)-r**14*(-1+y)**2*(
          -64706+101828*y-25903*y**2-10734*y**3+1755*y**4)+r**12*(-1+y)**2*(8214
          -66656*y+94159*y**2-16866*y**3-12551*y**4+5180*y**5)+r**10*(692212
          -2030424*y+1848647*y**2-169180*y**3-586485*y**4+241888*y**5+27709*y**6
          -25452*y**7+2485*y**8)+r**2*(-1+y)**3*(19399+17793*y+16187*y**2+142341*y**3
          -189095*y**4+52111*y**5-17483*y**6+7323*y**7+1544*y**8+280*y**9)-5*r**8*(
          -436732+1374912*y-1414175*y**2+301728*y**3+420651*y**4-337498*y**5
          +90783*y**6+5140*y**7-8743*y**8+1414*y**9)-(-1+y)**4*(-803-1606*y
          -2409*y**2-13492*y**3+4295*y**4-1662*y**5-7059*y**6+18944*y**7-10248*y**8
          +1440*y**9)+r**4*(-1+y)**2*(115834+6128*y-13123*y**2-627214*y**3+1390935*y**4
          -1107204*y**5+299327*y**6+34778*y**7-29781*y**8+5920*y**9)+r**6*(883662
          -2380808*y+1934387*y**2-460068*y**3+323372*y**4-509292*y**5+263858*y**6
          -41212*y**7-26282*y**8+12628*y**9-245*y**10))+(-1+y)**2*(-1+r**2
          +y)**3*(23*r**24*(-1+y)**6+r**22*(-1+y)**4*(-1636+3203*y-1498*y**2
          +611*y**3)-r**20*(-1+y)**2*(53282-196667*y+264360*y**2-147190*y**3
          +20590*y**4+6593*y**5+32*y**6)-5*r**18*(-1+y)**2*(-10084+25495*y-2964*y**2
          -59086*y**3+67984*y**4-18137*y**5-3136*y**6+768*y**7)-5*r**16*(-1+y)**2*(981683
          -3134849*y+3304164*y**2-878638*y**3-577695*y**4+335767*y**5-23846*y**6
          -7224*y**7+78*y**8)+2*r**14*(-1+y)**2*(5042852-15034913*y+12846762*y**2
          +344847*y**3-4593008*y**4+1133298*y**5+522238*y**6-184337*y**7-20172*y**8
          +5433*y**9)+r**4*(-1+y)**4*(239598+215739*y+172968*y**2+711145*y**3
          -1068910*y**4-13636*y**5-698198*y**6+2381464*y**7-2629420*y**8+1381385*y**9
          -259362*y**10-13441*y**11+668*y**12)+5*r**6*(-1+y)**3*(61652+93801*y
          -18903*y**2-1950935*y**3+5284025*y**4-5051584*y**5+1856368*y**6+72856*y**7
          -504180*y**8+374135*y**9-110233*y**10+4191*y**11+807*y**12)-(-1+y)**6*(
          -863-2589*y-5178*y**2-18310*y**3-7640*y**4-6544*y**5-7722*y**6+26426*y**7
          -4265*y**8+1565*y**9-668*y**10-3764*y**11+1552*y**12)-5*r**8*(-1+y)**2*(1495819
          -2607070*y+733134*y**2-3703654*y**3+14693541*y**4-21082902*y**5+14135366*y**6
          -3338562*y**7-900021*y**8+514084*y**9-5492*y**10-19896*y**11+1653*y**12)
          +2*r**12*(-24565894+116636943*y-212534784*y**2+167628370*y**3-16908815*y**4
          -61310837*y**5+33962579*y**6+2466173*y**7-7236645*y**8+1921290*y**9
          +4081*y**10-50547*y**11+2086*y**12)-r**2*(-1+y)**5*(-24876-47163*y
          -66861*y**2-298290*y**3+176270*y**4-4768*y**5-46084*y**6+399422*y**7
          -301510*y**8+50555*y**9-6031*y**10-2428*y**11+3764*y**12)-2*r**10*(13546628
          -58709229*y+95512344*y**2-62747978*y**3-12826120*y**4+65626674*y**5
          -74365612*y**6+48658242*y**7-16017164*y**8+210745*y**9+1369948*y**10
          -237784*y**11-27336*y**12+6642*y**13)))*nlo.X1El(0,'VR',y/2,r))/(580608000*logy**4*r**16*(
          -1+y)**8+193536000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+24192000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+1344000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +28000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-21600*logy**3*r**11*(27+41*r**2+29*r**4+9*r**6)*(-1+y)**8-720*logy**2*r**7*(
          -1+y)**6*(74*r**12*(-1+y)**2+31*r**14*(-1+y)**2+r**10*(1389-1968*y
          +174*y**2+485*y**3-90*y**4)+5*r**8*(443-364*y-340*y**2+242*y**3+y**4
          +4*y**5)-(-1+y)**3*(11+11*y+11*y**2+251*y**3-184*y**4+20*y**5)
          -r**2*(-1+y)**2*(599-455*y**3+430*y**4-234*y**5+20*y**6)+5*r**6*(-17
          +772*y-1124*y**2+168*y**3+255*y**4-105*y**5+27*y**6)+r**4*(-3036
          +8502*y-6681*y**2-50*y**3+1860*y**4-744*y**5+113*y**6+36*y**7))-6*logy*r**3*(
          -1+y)**4*(-1+r**2+y)**2*(41*r**18*(-1+y)**4-r**16*(-1+y)**2*(-643+1368*y
          -807*y**2+162*y**3)-r**14*(-1+y)**2*(-15790+25508*y-7489*y**2-1926*y**3
          +257*y**4)+r**12*(-1+y)**2*(22492-45292*y+26723*y**2+338*y**3-2257*y**4
          +556*y**5)+(-1+y)**4*(11+22*y+33*y**2+604*y**3-95*y**4+94*y**5
          +683*y**6-1128*y**7+376*y**8)+r**10*(325264-987788*y+962749*y**2-168480*y**3
          -240815*y**4+115216*y**5-2237*y**6-4404*y**7+495*y**8)+r**2*(-1+y)**3*(1217
          +1195*y+1173*y**2+10851*y**3-12281*y**4+853*y**5-4525*y**6+5397*y**7
          -1856*y**8+376*y**9)+r**4*(-1+y)**2*(18460+228*y-1059*y**2-127026*y**3
          +222587*y**4-138000*y**5+21407*y**6+9694*y**7-3339*y**8+648*y**9)-r**8*(
          -592234+1816036*y-1796019*y**2+337456*y**3+482771*y**4-315066*y**5
          +67539*y**6+5044*y**7-6881*y**8+754*y**9)+r**6*(171082-446136*y+345989*y**2
          -173976*y**3+407904*y**4-548040*y**5+323186*y**6-83264*y**7-1874*y**8
          +5496*y**9-367*y**10))-r*(-1+y)**3*(-1+r**2+y)**3*(11*r**20*(-1+y)**5
          -r**18*(-1+y)**3*(-887+1561*y-584*y**2+20*y**3)-r**14*(-1+y)**2*(98866
          -215370*y+117060*y**2+18665*y**3-23400*y**4+2019*y**5+60*y**6)-6*r**16*(829
          -3910*y+7345*y**2-6960*y**3+3400*y**4-689*y**5-40*y**6+25*y**7)+r**12*(56552
          -202342*y+195188*y**2+67937*y**3-212345*y**4+111118*y**5-11938*y**6
          -5343*y**7+783*y**8+390*y**9)+(-1+y)**5*(56+168*y+336*y**2+869*y**3
          +572*y**4+363*y**5+82*y**6-561*y**7-144*y**8-47*y**9+106*y**10)+3*r**10*(
          -502676+1833106*y-2306948*y**2+790633*y**3+694954*y**4-671513*y**5
          +142444*y**6+32823*y**7-14458*y**8+871*y**9+164*y**10)+3*r**4*(-1+y)**3*(2543
          +3408*y+3113*y**2-42897*y**3+52608*y**4-18023*y**5+5142*y**6-7563*y**7
          +2797*y**8-133*y**9+205*y**10)+r**6*(-1+y)**2*(-128446+85278*y+28872*y**2
          +551901*y**3-1196170*y**4+902511*y**5-195488*y**6-103457*y**7+56364*y**8
          -5265*y**9+300*y**10)+r**2*(-1+y)**4*(1603+3104*y+4470*y**2+2351*y**3
          +1462*y**4-2943*y**5-16354*y**6+18205*y**7-7701*y**8+763*y**9+440*y**10)
          +r**8*(-598858+1924148*y-2036302*y**2+663653*y**3-36127*y**4+208109*y**5
          -130003*y**6+28427*y**7-47803*y**8+28227*y**9-3651*y**10+180*y**11)))*nlo.X1El(1,'SM',y/2,r))/(1036800*logy**4*r**16*(
          -1+y)**8+345600*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+43200*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+2400*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +50*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6+120*logy*r**4*(
          -1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(-67+98*y
          -13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3-2*y**4
          +y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)+2*r**2*(
          -1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y-421*y**2
          +40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(
          -1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1
          +y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(
          -4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y
          +45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)
          +2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5
          -56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(1,'VR',y/2,r))/(345600*logy**3*r**12*(
          -1+y)**6-200*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +86400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+7200*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-2160*logy**2*r**7*(4+5*r**2
          +2*r**4)*(-1+y)**6-72*logy*r**3*(-1+y)**4*(8*r**10*(-1+y)**2+3*r**12*(
          -1+y)**2-5*r**8*(-44+64*y-8*y**2-13*y**3+2*y**4)+2*(-1+y)**3*(
          -1-y-y**2-6*y**3+4*y**4)+5*r**6*(26+8*y-64*y**2+21*y**3+7*y**4)
          +r**2*(-1+y)**2*(-58+35*y**3-15*y**4+8*y**5)+5*r**4*(-61+170*y-133*y**2
          +y**3+31*y**4-11*y**5+3*y**6))-3*r*(-1+y)**3*(-1+r**2+y)**2*(7*r**12*(
          -1+y)**3+2*r**10*(-81+214*y-174*y**2+35*y**3+6*y**4)+r**8*(-169
          +509*y-558*y**2+220*y**3+3*y**4-5*y**5)-4*r**6*(1431-2992*y+1413*y**2
          +518*y**3-447*y**4+47*y**5)+(-1+y)**3*(-13-26*y-39*y**2-54*y**3
          -9*y**4+4*y**5+17*y**6)+2*r**2*(-1+y)**2*(-61-72*y-71*y**2+319*y**3
          -256*y**4+55*y**5+26*y**6)+r**4*(-1749+2827*y-705*y**2+335*y**3-1195*y**4
          +489*y**5-47*y**6+45*y**7)))*nlo.X1El(2,'SM',y/2,r))/(-17280*logy**3*r**12*(
          -1+y)**6+10*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -4320*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-360*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-180*logy*r**4*(3+r**2)*(-1
          +y)**4-3*(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(
          -1+y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(2,'VR',y/2,r))/(2880*logy**2*r**8*(-1+y)**4+480*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(-24*logy*r**3*(1+r**2)*(-1+y)**4-4*r*(-1+y)**3*(r**6*(-1+y)
          +3*r**2*(-1+y)**2*(3+y)+3*r**4*(-3+y+y**2)+(-1+y)**2*(1+y+y**2)))*nlo.X1El(3,'SM',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(3,'VR',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.ReVR

    if wc.SL2 != 0:
      resNP = 0
      resNP +=((rhoD*(9072000*logy**4*r**12*(9+21*r**2+29*r**4+27*r**6+18*r**8)*(-1+y)**8
          +21600*logy**3*r**8*(-1+y)**6*(2319*r**14*(-1+y)**2+2160*r**16*(-1+y)**2
          -35*r**12*(-1037+1210*y+259*y**2-576*y**3+72*y**4)+15*(-1+y)**4*(
          -51-102*y-153*y**2+272*y**3-108*y**4+16*y**5)+35*r**10*(383+530*y
          -1561*y**2+724*y**3-24*y**4+36*y**5)+5*r**2*(-1+y)**3*(313+313*y
          +313*y**2-2123*y**3+2140*y**4-716*y**5+96*y**6)+35*r**8*(-209+1810*y
          -2297*y**2+148*y**3+1060*y**4-596*y**5+132*y**6)-7*r**4*(-1+y)**2*(2977
          -2160*y-1080*y**2+160*y**3+1585*y**4-1272*y**5+240*y**6)+35*r**6*(
          -677+2362*y-2189*y**2-304*y**3+1391*y**4-694*y**5+87*y**6+24*y**7))
          -360*logy**2*r**4*(-1+y)**4*(-1+r**2+y)**2*(1664*r**20*(-1+y)**4+r**18*(
          -1+y)**2*(-89831+176334*y-83175*y**2+13412*y**3)-r**16*(-1+y)**2*(531761
          -851056*y+296237*y**2+46710*y**3+11028*y**4)-r**14*(-1+y)**2*(616736
          -1278308*y+785827*y**2+144702*y**3-167053*y**4+17516*y**5)+15*(-1
          +y)**6*(-71-284*y-710*y**2-732*y**3+385*y**4+1920*y**5-1496*y**6
          +288*y**7)+r**12*(-5145296+14520172*y-12568151*y**2+365100*y**3+4379910*y**4
          -1463884*y**5-111587*y**6+20556*y**7-2420*y**8)+r**2*(-1+y)**5*(12799
          +40527*y+85314*y**2-47710*y**3-8165*y**4-77829*y**5+112408*y**6-54584*y**7
          +8640*y**8)-r**6*(-1+y)**3*(-347984-353780*y-407513*y**2+3700817*y**3
          -3841030*y**4+1198314*y**5+130795*y**6-113587*y**7+14368*y**8)+r**8*(
          -1+y)**2*(-3141014+3468656*y+244565*y**2+104098*y**3-3138720*y**4
          +2468324*y**5-468391*y**6-90870*y**7+15752*y**8)-r**4*(-1+y)**4*(267584
          +425196*y+544881*y**2-1729796*y**3+1000170*y**4-128824*y**5+41529*y**6
          -62016*y**7+18576*y**8)-r**10*(5572394-16766936*y+15605649*y**2+659244*y**3
          -9488271*y**4+4587616*y**5+484251*y**6-802204*y**7+143481*y**8+4776*y**9))
          +6*logy*(-1+y)**4*(-1+r**2+y)**3*(3992*r**26*(-1+y)**4+r**24*(-1+y)**2*(
          -128263+244550*y-104311*y**2+26224*y**3)+3*r**22*(557940-2174049*y
          +3091500*y**2-2067470*y**3+749280*y**4-139545*y**5+9544*y**6)+r**20*(10657876
          -36700111*y+45389070*y**2-23346670*y**3+3369100*y**4+372249*y**5+125466*y**6
          -86580*y**7)+3*(-1+y)**9*(23+184*y+828*y**2+2220*y**3+2385*y**4
          -2648*y**5-2444*y**6+1552*y**7)-5*r**18*(-8161908+25093815*y-26347824*y**2
          +7601248*y**3+4135920*y**4-2694997*y**5+603460*y**6-259546*y**7+23112*y**8)
          +r**16*(12561001-60895219*y+114704916*y**2-67758244*y**3-30470359*y**4
          +38784449*y**5-3134606*y**6-3618366*y**7+356144*y**8+121284*y**9)-r**4*(
          -1+y)**5*(406132+1518181*y+3593071*y**2+2001731*y**3-2575929*y**4
          -7863573*y**5+8300969*y**6-2273671*y**7-45331*y**8+45604*y**9+816*y**10)
          +r**6*(-1+y)**4*(1845532+5112765*y+9868800*y**2-16975200*y**3+6076520*y**4
          -8459124*y**5+15161360*y**6-9033900*y**7+1828500*y**8-14445*y**9+7192*y**10)
          +r**2*(-1+y)**6*(7220+35893*y+107058*y**2+186713*y**3+35888*y**4-329857*y**5
          +94682*y**6-21833*y**7+73112*y**8-44188*y**9+9312*y**10)+5*r**8*(-1
          +y)**3*(-5871047-6342631*y-5874078*y**2+42478344*y**3-32665820*y**4
          +2530124*y**5+3755526*y**6+96828*y**7-502369*y**8+29215*y**9+12508*y**10)
          -2*r**10*(-1+y)**2*(1323016-8332139*y-12403934*y**2+108219971*y**3
          -139923744*y**4+50853444*y**5+7739114*y**6-8153191*y**7+1748504*y**8
          -320381*y**9+15840*y**10)+2*r**14*(162549828-365648661*y+182303844*y**2
          +148809294*y**3-150821896*y**4+4361143*y**5+23831136*y**6-4432944*y**7
          +1450456*y**8-559604*y**9+71904*y**10)+r**12*(209346360-574895826*y
          +424034100*y**2+221808700*y**3-402205260*y**4+14325710*y**5+177415182*y**6
          -69702100*y**7-5174000*y**8+5065760*y**9+58330*y**10-76956*y**11))-(
          -1+y)**2*(-1+r**2+y)**4*(455*r**28*(-1+y)**6+2*r**26*(-1+y)**4*(-7509
          +14108*y-5689*y**2+1155*y**3)+r**24*(-1+y)**2*(195401-747304*y+1027780*y**2
          -662694*y**3+242427*y**4-43778*y**5+3008*y**6)-r**22*(894128-5387042*y
          +13218023*y**2-17344790*y**3+13563281*y**4-6597978*y**5+1914117*y**6
          -294858*y**7+14635*y**8+3684*y**9)+r**20*(-8953885+47279176*y-100912474*y**2
          +112329542*y**3-70644441*y**4+26417222*y**5-7221511*y**6+2224794*y**7
          -679042*y**8+122346*y**9-12127*y**10)-5*r**18*(6085906-29600266*y+57582865*y**2
          -54039792*y**3+18670730*y**4+8834492*y**5-11313420*y**6+4721820*y**7
          -1143428*y**8+225630*y**9-33933*y**10+996*y**11)-3*(-1+y)**8*(-205
          -1092*y-3408*y**2+4388*y**3+41628*y**4+75288*y**5-124038*y**6-60516*y**7
          +120737*y**8-41228*y**9+2142*y**10+280*y**11+24*y**12)-r**2*(-1+y)**7*(
          -145198-680624*y-1928883*y**2-2411187*y**3+655858*y**4+5523914*y**5
          -4039464*y**6+576524*y**7+124212*y**8+132342*y**9-81541*y**10+5863*y**11
          +184*y**12)-r**4*(-1+y)**6*(2860239+9539590*y+20542691*y**2+919574*y**3
          -18132411*y**4-41564794*y**5+56473284*y**6-18264838*y**7+377251*y**8
          +153436*y**9+64905*y**10+8776*y**11+297*y**12)-5*r**8*(-1+y)**4*(26128705
          +18018270*y+9413785*y**2-164538358*y**3+147814358*y**4-8515344*y**5
          -21857354*y**6+352068*y**7+2381713*y**8-72838*y**9+42409*y**10-22886*y**11
          +3072*y**12)-r**6*(-1+y)**5*(-1617328-3318382*y-7071365*y**2+94002585*y**3
          -87204930*y**4+3475666*y**5+7817844*y**6+15560260*y**7-8662810*y**8
          +45180*y**9+437937*y**10-28237*y**11+3580*y**12)+r**16*(-108790379+495027304*y
          -873788590*y**2+681013640*y**3-107522560*y**4-161736012*y**5+76532302*y**6
          +3064860*y**7-2015165*y**8-1727740*y**9-51984*y**10-16356*y**11+10680*y**12)
          -2*r**10*(-1+y)**3*(125506585-58120711*y-79181594*y**2-53281201*y**3
          +44679229*y**4+83396634*y**5-35716234*y**6-28325118*y**7+19879001*y**8
          -2889679*y**9+230856*y**10-63405*y**11+13637*y**12)-r**12*(-1+y)**2*(1013415899
          -1892876248*y+424814884*y**2+1154077576*y**3-505849979*y**4-394842672*y**5
          +244688852*y**6-3233652*y**7+3838649*y**8-6810296*y**9+1076448*y**10
          +27996*y**11+18543*y**12)+2*r**14*(51533744-208162194*y+266932211*y**2
          -79197822*y**3-14924925*y**4-119605978*y**5+147791288*y**6-27702242*y**7
          -28585396*y**8+13195100*y**9-1177291*y**10-22344*y**11-76719*y**12+2568*y**13))))/(5225472000*logy**4*r**16*(
          -1+y)**8+1741824000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+217728000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+12096000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +252000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*muWC**3*(-9072000*logy**4*r**12*(9+21*r**2+29*r**4+27*r**6+18*r**8)*(
          -1+y)**8-21600*logy**3*r**8*(-1+y)**6*(2319*r**14*(-1+y)**2+2160*r**16*(
          -1+y)**2-35*r**12*(-1037+1210*y+259*y**2-576*y**3+72*y**4)+15*(
          -1+y)**4*(-51-102*y-153*y**2+272*y**3-108*y**4+16*y**5)+35*r**10*(383
          +530*y-1561*y**2+724*y**3-24*y**4+36*y**5)+5*r**2*(-1+y)**3*(313
          +313*y+313*y**2-2123*y**3+2140*y**4-716*y**5+96*y**6)+35*r**8*(-209
          +1810*y-2297*y**2+148*y**3+1060*y**4-596*y**5+132*y**6)-7*r**4*(-1
          +y)**2*(2977-2160*y-1080*y**2+160*y**3+1585*y**4-1272*y**5+240*y**6)
          +35*r**6*(-677+2362*y-2189*y**2-304*y**3+1391*y**4-694*y**5+87*y**6
          +24*y**7))+360*logy**2*r**4*(-1+y)**4*(-1+r**2+y)**2*(1664*r**20*(-1+y)**4
          +r**18*(-1+y)**2*(-89831+176334*y-83175*y**2+13412*y**3)-r**16*(-1
          +y)**2*(531761-851056*y+296237*y**2+46710*y**3+11028*y**4)-r**14*(
          -1+y)**2*(616736-1278308*y+785827*y**2+144702*y**3-167053*y**4+17516*y**5)
          +15*(-1+y)**6*(-71-284*y-710*y**2-732*y**3+385*y**4+1920*y**5-1496*y**6
          +288*y**7)+r**12*(-5145296+14520172*y-12568151*y**2+365100*y**3+4379910*y**4
          -1463884*y**5-111587*y**6+20556*y**7-2420*y**8)+r**2*(-1+y)**5*(12799
          +40527*y+85314*y**2-47710*y**3-8165*y**4-77829*y**5+112408*y**6-54584*y**7
          +8640*y**8)-r**6*(-1+y)**3*(-347984-353780*y-407513*y**2+3700817*y**3
          -3841030*y**4+1198314*y**5+130795*y**6-113587*y**7+14368*y**8)+r**8*(
          -1+y)**2*(-3141014+3468656*y+244565*y**2+104098*y**3-3138720*y**4
          +2468324*y**5-468391*y**6-90870*y**7+15752*y**8)-r**4*(-1+y)**4*(267584
          +425196*y+544881*y**2-1729796*y**3+1000170*y**4-128824*y**5+41529*y**6
          -62016*y**7+18576*y**8)-r**10*(5572394-16766936*y+15605649*y**2+659244*y**3
          -9488271*y**4+4587616*y**5+484251*y**6-802204*y**7+143481*y**8+4776*y**9))
          -6*logy*(-1+y)**4*(-1+r**2+y)**3*(3992*r**26*(-1+y)**4+r**24*(-1+y)**2*(
          -128263+244550*y-104311*y**2+26224*y**3)+3*r**22*(557940-2174049*y
          +3091500*y**2-2067470*y**3+749280*y**4-139545*y**5+9544*y**6)+r**20*(10657876
          -36700111*y+45389070*y**2-23346670*y**3+3369100*y**4+372249*y**5+125466*y**6
          -86580*y**7)+3*(-1+y)**9*(23+184*y+828*y**2+2220*y**3+2385*y**4
          -2648*y**5-2444*y**6+1552*y**7)-5*r**18*(-8161908+25093815*y-26347824*y**2
          +7601248*y**3+4135920*y**4-2694997*y**5+603460*y**6-259546*y**7+23112*y**8)
          +r**16*(12561001-60895219*y+114704916*y**2-67758244*y**3-30470359*y**4
          +38784449*y**5-3134606*y**6-3618366*y**7+356144*y**8+121284*y**9)-r**4*(
          -1+y)**5*(406132+1518181*y+3593071*y**2+2001731*y**3-2575929*y**4
          -7863573*y**5+8300969*y**6-2273671*y**7-45331*y**8+45604*y**9+816*y**10)
          +r**6*(-1+y)**4*(1845532+5112765*y+9868800*y**2-16975200*y**3+6076520*y**4
          -8459124*y**5+15161360*y**6-9033900*y**7+1828500*y**8-14445*y**9+7192*y**10)
          +r**2*(-1+y)**6*(7220+35893*y+107058*y**2+186713*y**3+35888*y**4-329857*y**5
          +94682*y**6-21833*y**7+73112*y**8-44188*y**9+9312*y**10)+5*r**8*(-1
          +y)**3*(-5871047-6342631*y-5874078*y**2+42478344*y**3-32665820*y**4
          +2530124*y**5+3755526*y**6+96828*y**7-502369*y**8+29215*y**9+12508*y**10)
          -2*r**10*(-1+y)**2*(1323016-8332139*y-12403934*y**2+108219971*y**3
          -139923744*y**4+50853444*y**5+7739114*y**6-8153191*y**7+1748504*y**8
          -320381*y**9+15840*y**10)+2*r**14*(162549828-365648661*y+182303844*y**2
          +148809294*y**3-150821896*y**4+4361143*y**5+23831136*y**6-4432944*y**7
          +1450456*y**8-559604*y**9+71904*y**10)+r**12*(209346360-574895826*y
          +424034100*y**2+221808700*y**3-402205260*y**4+14325710*y**5+177415182*y**6
          -69702100*y**7-5174000*y**8+5065760*y**9+58330*y**10-76956*y**11))+(
          -1+y)**2*(-1+r**2+y)**4*(455*r**28*(-1+y)**6+2*r**26*(-1+y)**4*(-7509
          +14108*y-5689*y**2+1155*y**3)+r**24*(-1+y)**2*(195401-747304*y+1027780*y**2
          -662694*y**3+242427*y**4-43778*y**5+3008*y**6)-r**22*(894128-5387042*y
          +13218023*y**2-17344790*y**3+13563281*y**4-6597978*y**5+1914117*y**6
          -294858*y**7+14635*y**8+3684*y**9)+r**20*(-8953885+47279176*y-100912474*y**2
          +112329542*y**3-70644441*y**4+26417222*y**5-7221511*y**6+2224794*y**7
          -679042*y**8+122346*y**9-12127*y**10)-5*r**18*(6085906-29600266*y+57582865*y**2
          -54039792*y**3+18670730*y**4+8834492*y**5-11313420*y**6+4721820*y**7
          -1143428*y**8+225630*y**9-33933*y**10+996*y**11)-3*(-1+y)**8*(-205
          -1092*y-3408*y**2+4388*y**3+41628*y**4+75288*y**5-124038*y**6-60516*y**7
          +120737*y**8-41228*y**9+2142*y**10+280*y**11+24*y**12)-r**2*(-1+y)**7*(
          -145198-680624*y-1928883*y**2-2411187*y**3+655858*y**4+5523914*y**5
          -4039464*y**6+576524*y**7+124212*y**8+132342*y**9-81541*y**10+5863*y**11
          +184*y**12)-r**4*(-1+y)**6*(2860239+9539590*y+20542691*y**2+919574*y**3
          -18132411*y**4-41564794*y**5+56473284*y**6-18264838*y**7+377251*y**8
          +153436*y**9+64905*y**10+8776*y**11+297*y**12)-5*r**8*(-1+y)**4*(26128705
          +18018270*y+9413785*y**2-164538358*y**3+147814358*y**4-8515344*y**5
          -21857354*y**6+352068*y**7+2381713*y**8-72838*y**9+42409*y**10-22886*y**11
          +3072*y**12)-r**6*(-1+y)**5*(-1617328-3318382*y-7071365*y**2+94002585*y**3
          -87204930*y**4+3475666*y**5+7817844*y**6+15560260*y**7-8662810*y**8
          +45180*y**9+437937*y**10-28237*y**11+3580*y**12)+r**16*(-108790379+495027304*y
          -873788590*y**2+681013640*y**3-107522560*y**4-161736012*y**5+76532302*y**6
          +3064860*y**7-2015165*y**8-1727740*y**9-51984*y**10-16356*y**11+10680*y**12)
          -2*r**10*(-1+y)**3*(125506585-58120711*y-79181594*y**2-53281201*y**3
          +44679229*y**4+83396634*y**5-35716234*y**6-28325118*y**7+19879001*y**8
          -2889679*y**9+230856*y**10-63405*y**11+13637*y**12)-r**12*(-1+y)**2*(1013415899
          -1892876248*y+424814884*y**2+1154077576*y**3-505849979*y**4-394842672*y**5
          +244688852*y**6-3233652*y**7+3838649*y**8-6810296*y**9+1076448*y**10
          +27996*y**11+18543*y**12)+2*r**14*(51533744-208162194*y+266932211*y**2
          -79197822*y**3-14924925*y**4-119605978*y**5+147791288*y**6-27702242*y**7
          -28585396*y**8+13195100*y**9-1177291*y**10-22344*y**11-76719*y**12+2568*y**13))))/(5878656000*logy**4*r**16*(
          -1+y)**8+1959552000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+244944000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+13608000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +283500*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((muG*(-9072000*logy**4*r**14*(3+7*r**2+9*r**4+9*r**6)*(-1+y)**8-21600*logy**3*r**10*(
          -1+y)**6*(2457*r**12*(-1+y)**2+873*r**14*(-1+y)**2-7*r**10*(-2033+1906*y
          +1207*y**2-1440*y**3+180*y**4)+7*r**4*(-1+y)**2*(-1079+720*y+360*y**2
          -400*y**3+165*y**4+24*y**5)+35*r**8*(-59+550*y-707*y**2+260*y**3
          -48*y**4+36*y**5)+35*r**6*(-187+710*y-691*y**2-16*y**3+365*y**4-226*y**5
          +57*y**6)-7*r**2*(-1+y)**2*(281-400*y**3+575*y**4-336*y**5+60*y**6)
          -(-1+y)**3*(569+569*y+569*y**2-2371*y**3+2564*y**4-1300*y**5+240*y**6))
          -360*logy**2*r**6*(-1+y)**4*(-1+r**2+y)**2*(509*r**18*(-1+y)**4-r**16*(
          -1+y)**2*(-28759+58536*y-30795*y**2+5278*y**3)+r**14*(-1+y)**2*(286564
          -474524*y+169453*y**2+7950*y**3+3417*y**4)+r**12*(-1+y)**2*(436804
          -748732*y+340373*y**2+152778*y**3-85967*y**4+14644*y**5)+r**10*(1905754
          -5210768*y+4314559*y**2+165120*y**3-2021925*y**4+1049276*y**5-263147*y**6
          +72156*y**7-8225*y**8)-r**4*(-1+y)**3*(-104084-17960*y+5107*y**2+342437*y**3
          -564490*y**4+376254*y**5-100985*y**6+1433*y**7+688*y**8)-r**2*(-1+y)**4*(4199
          +16296*y+36291*y**2-51416*y**3+69645*y**4-70744*y**5+43569*y**6-14016*y**7
          +1176*y**8)+(-1+y)**5*(3949+11847*y+23694*y**2-1630*y**3-20255*y**4
          -36549*y**5+58408*y**6-26984*y**7+4320*y**8)+r**6*(-1+y)**2*(364396
          -373684*y-130525*y**2+188878*y**3+290385*y**4-479356*y**5+282629*y**6
          -87150*y**7+15827*y**8)+r**8*(1323046-3902164*y+3446331*y**2+854616*y**3
          -3513279*y**4+2176454*y**5-184611*y**6-290756*y**7+93009*y**8-2646*y**9))
          -6*logy*r**2*(-1+y)**4*(-1+r**2+y)**3*(79*r**24*(-1+y)**4+r**22*(-1
          +y)**2*(-6068+11899*y-5594*y**2+2963*y**3)+3*r**20*(186168-718323*y
          +1021950*y**2-670930*y**3+218060*y**4-36523*y**5+4398*y**6)-5*r**18*(
          -961900+3476677*y-4595184*y**2+2671468*y**3-583132*y**4-33507*y**5
          +15936*y**6+1242*y**7)-5*r**16*(-4589367+13994709*y-14272812*y**2+4054724*y**3
          +1793625*y**4-1051283*y**5+207566*y**6-92078*y**7+11196*y**8)+2*r**14*(5871556
          -20791339*y+29955516*y**2-7645174*y**3-22315264*y**4+19952819*y**5
          -4797686*y**6-153066*y**7+203174*y**8+2964*y**9)-5*r**6*(-1+y)**3*(406588
          +413003*y+150153*y**2-839928*y**3-1499000*y**4+2667176*y**5-875268*y**6
          -542508*y**7+430088*y**8-92495*y**9+3391*y**10)-(-1+y)**6*(911+4555*y
          +13665*y**2+28745*y**3+27905*y**4-11467*y**5-65605*y**6-11765*y**7
          +70580*y**8-34180*y**9+4656*y**10)+r**2*(-1+y)**5*(44548+180925*y
          +459145*y**2+315575*y**3-229365*y**4-957501*y**5+923375*y**6-328795*y**7
          +74525*y**8-28460*y**9+8028*y**10)-5*r**8*(-1+y)**2*(2415095-902512*y
          -1268185*y**2-4345166*y**3+10299780*y**4-6327012*y**5-212918*y**6+1061470*y**7
          +19141*y**8-143140*y**9+16647*y**10)+r**4*(-1+y)**4*(-947416-2504745*y
          -4576890*y**2+3457560*y**3+2694640*y**4+5112792*y**5-11553830*y**6+6555540*y**7
          -1164060*y**8-93915*y**9+38324*y**10)+2*r**12*(52234008-109510575*y
          +45358230*y**2+53856510*y**3-54143690*y**4+13001759*y**5-1092825*y**6
          +987420*y**7+514640*y**8-353710*y**9+58233*y**10)+2*r**10*(17929716
          -49612671*y+31350600*y**2+38259400*y**3-47733540*y**4-22415827*y**5
          +57966552*y**6-31101175*y**7+4783600*y**8+767990*y**9-209864*y**10+15219*y**11))
          +(-1+y)**2*(-1+r**2+y)**4*(34*r**28*(-1+y)**6+2*r**26*(-1+y)**4*(-579
          +1090*y-443*y**2+111*y**3)+r**24*(-1+y)**2*(21706-82802*y+114251*y**2
          -74238*y**3+27168*y**4-4852*y**5+547*y**6)-6*(-1+y)**10*(23+184*y
          +828*y**2+2220*y**3+2385*y**4-2648*y**5-2444*y**6+1552*y**7)+r**22*(
          -266164+1550590*y-3705133*y**2+4716946*y**3-3500239*y**4+1560654*y**5
          -416175*y**6+70758*y**7-9401*y**8+564*y**9)+r**20*(-4061918+22038746*y
          -48719903*y**2+56495590*y**3-36924960*y**4+13704808*y**5-2940686*y**6
          +483198*y**7-60410*y**8-6150*y**9+85*y**10)-r**18*(14538058-72286258*y
          +144366475*y**2-142520580*y**3+60107210*y**4+11222504*y**5-24225984*y**6
          +10719600*y**7-2048420*y**8+171090*y**9-2187*y**10+492*y**11)-r**2*(
          -1+y)**7*(36106+174512*y+508215*y**2+855039*y**3+326414*y**4-1201418*y**5
          -384600*y**6-22916*y**7+902136*y**8-530214*y**9+93937*y**10-1387*y**11
          +176*y**12)-2*r**16*(30657167-136707568*y+232882306*y**2-170912882*y**3
          +20284618*y**4+39662544*y**5-14157151*y**6-2657304*y**7+304082*y**8
          +694432*y**9-63411*y**10-9006*y**11+1173*y**12)-r**4*(-1+y)**6*(-406566
          -1497382*y-3534383*y**2+848194*y**3+1989879*y**4+3965206*y**5-9002082*y**6
          +4918870*y**7+109556*y**8-765904*y**9+193185*y**10-12136*y**11+1563*y**12)
          -r**6*(-1+y)**5*(4797292+10204762*y+15680981*y**2-23281137*y**3-10886442*y**4
          -22390966*y**5+58564584*y**6-33597424*y**7+6115162*y**8+17292*y**9+108099*y**10
          -46271*y**11+6068*y**12)-2*r**12*(-1+y)**2*(150456821-249988078*y+14820385*y**2
          +121412434*y**3+89060974*y**4-202283388*y**5+91908350*y**6-10687266*y**7
          +3491291*y**8-2841374*y**9+745317*y**10-55272*y**11+7806*y**12)-2*r**10*(
          -1+y)**3*(53952803-19448627*y-25316932*y**2-113864477*y**3+167890853*y**4
          -38138778*y**5-25284458*y**6-2635638*y**7+14303827*y**8-5384903*y**9
          +871650*y**10-66465*y**11+9145*y**12)-r**8*(-1+y)**4*(25387426+23575158*y
          +13486711*y**2-100344250*y**3-3498235*y**4+63506328*y**5+23834254*y**6
          -57192612*y**7+24852400*y**8-4189990*y**9+623371*y**10-99962*y**11+13401*y**12)
          -2*r**14*(-19649764+77734686*y-89714929*y**2+42354738*y**3-129757125*y**4
          +307192958*y**5-293767612*y**6+121862038*y**7-11368396*y**8-6518500*y**9
          +1550981*y**10+109176*y**11-32259*y**12+4008*y**13))))/(1741824000*logy**4*r**16*(
          -1+y)**8+580608000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+72576000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+4032000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +84000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((rhoLS*(-9072000*logy**4*r**14*(1+r**2+r**4+3*r**6)*(-1+y)**8+21600*logy**3*r**10*(
          -1+y)**5*(375*r**14*(-1+y)**3+7*r**12*(349-1047*y+1047*y**2-409*y**3
          +30*y**4)+7*r**10*(409-507*y-573*y**2+1051*y**3-490*y**4+60*y**5)
          -35*r**8*(101-351*y+423*y**2-181*y**3+20*y**4-6*y**5+4*y**6)+7*r**2*(
          -1+y)**3*(-31-80*y**3+165*y**4-104*y**5+20*y**6)-(-1+y)**4*(353
          +353*y+353*y**2-2027*y**3+1788*y**4-620*y**5+80*y**6)-35*r**4*(41
          -171*y+243*y**2-113*y**3-61*y**4+99*y**5-45*y**6+7*y**7)-35*r**6*(
          -5-33*y+105*y**2-7*y**3-217*y**4+281*y**5-145*y**6+27*y**7))+1800*logy**2*r**6*(
          -1+y)**3*(-1+r**2+y)**2*(131*r**18*(-1+y)**5-r**16*(-1+y)**2*(2971
          -9175*y+9699*y**2-3985*y**3+1000*y**4)+r**14*(-1+y)**2*(128-7680*y
          +15129*y**2-13847*y**3+5857*y**4+259*y**5)+r**12*(68120-273704*y+394495*y**2
          -219223*y**3-9824*y**4+46724*y**5+2011*y**6-10805*y**7+1646*y**8)-r**2*(
          -1+y)**4*(-2141-2311*y-2481*y**2+18057*y**3-19113*y**4+11449*y**5
          -6541*y**6+3069*y**7-744*y**8+56*y**9)+(-1+y)**5*(-85-170*y-255*y**2
          +796*y**3+1321*y**4+614*y**5-5581*y**6+5424*y**7-2072*y**8+288*y**9)
          +r**6*(-1+y)**2*(-7648+28112*y-9681*y**2-121485*y**3+229937*y**4-174557*y**5
          +53973*y**6+771*y**7-3565*y**8+503*y**9)-r**10*(-90086+342258*y-456435*y**2
          +170779*y**3+224867*y**4-349043*y**5+211173*y**6-56939*y**7+3397*y**8
          +589*y**9)-r**4*(-1+y)**3*(16808-8256*y-1647*y**2-110810*y**3+223805*y**4
          -172604*y**5+53805*y**6+3286*y**7-6411*y**8+1184*y**9)+r**8*(14822
          -95854*y+217973*y**2-223685*y**3+41637*y**4+142395*y**5-138921*y**6
          +41207*y**7+3875*y**8-3947*y**9+498*y**10))-6*logy*r**2*(-1+y)**2*(
          -1+r**2+y)**3*(-913*r**24*(-1+y)**6-r**22*(-1+y)**3*(13666-38259*y
          +32781*y**2-14029*y**3+2291*y**4)+r**20*(-574318+3329049*y-7958394*y**2
          +10124383*y**3-7391760*y**4+3117333*y**5-717284*y**6+76859*y**7-5868*y**8)
          +5*r**18*(98102-623913*y+1558584*y**2-2107289*y**3+1753196*y**4-920467*y**5
          +286038*y**6-57989*y**7+12984*y**8+754*y**9)+5*r**16*(19213-429525*y
          +1689447*y**2-3321223*y**3+4201689*y**4-3629969*y**5+1985465*y**6-625547*y**7
          +158128*y**8-53664*y**9+5986*y**10)-r**4*(-1+y)**5*(213442+413363*y
          +618825*y**2-2217830*y**3+174480*y**4-620354*y**5+4841694*y**6-5543250*y**7
          +2610230*y**8-531405*y**9+33137*y**10+668*y**11)+5*r**6*(-1+y)**4*(248682
          +117123*y+102228*y**2-2073605*y**3+3341858*y**4-2494682*y**5+647046*y**6
          +451362*y**7-419500*y**8+125847*y**9-16330*y**10+771*y**11)+(-1+y)**7*(1073
          +4292*y+10730*y**2+9720*y**3+560*y**4-14596*y**5+8106*y**6-13280*y**7
          +855*y**8+13640*y**9-8652*y**10+1552*y**11)+5*r**8*(-1+y)**3*(-1471693
          +1402473*y+45087*y**2+9325355*y**3-21582962*y**4+18646192*y**5-6363262*y**6
          -680482*y**7+1206975*y**8-310533*y**9+8431*y**10+2619*y**11)+2*r**14*(11550598
          -49797303*y+76834320*y**2-39753845*y**3-23470420*y**4+40963049*y**5
          -19169244*y**6+2937855*y**7-782230*y**8+821670*y**9-179872*y**10+3422*y**11)
          +r**2*(-1+y)**6*(13566+37479*y+68520*y**2-5670*y**3-218630*y**4-240542*y**5
          +653932*y**6-415570*y**7+78020*y**8+32755*y**9-21624*y**10+3764*y**11)
          -2*r**10*(-1+y)**2*(7487942-17313857*y+7835700*y**2+14463280*y**3-19873900*y**4
          +7328351*y**5+2553274*y**6-2671875*y**7-159930*y**8+702150*y**9-187018*y**10
          +10883*y**11)-2*r**12*(-9654934+46049313*y-84881454*y**2+64941555*y**3
          +19801790*y**4-92326457*y**5+86981609*y**6-34164372*y**7+397970*y**8
          +3490110*y**9-539209*y**10-117397*y**11+21476*y**12))-(-1+y)*(-1
          +r**2+y)**4*(93*r**28*(-1+y)**7+r**26*(-1+y)**4*(3151-9081*y+8337*y**2
          -2901*y**3+471*y**4)+r**24*(-1+y)**2*(-37627+181381*y-340691*y**2
          +326123*y**3-178816*y**4+58267*y**5-9880*y**6+563*y**7)+r**22*(403138
          -2760208*y+8003071*y**2-12836493*y**3+12547427*y**4-7788878*y**5+3090083*y**6
          -752531*y**7+97033*y**8-602*y**9-1040*y**10)-(-1+y)**8*(-291-1455*y
          -4365*y**2-7915*y**3-1545*y**4+13787*y**5-12295*y**6+6915*y**7+8040*y**8
          -10980*y**9+3104*y**10)-r**20*(-1525671+8784583*y-20661908*y**2+24786416*y**3
          -14401460*y**4+1097301*y**5+3428107*y**6-1714687*y**7+94189*y**8+146140*y**9
          -34625*y**10+3015*y**11)+r**18*(-7448139+44986343*y-110147694*y**2
          +142562980*y**3-106042665*y**4+46896283*y**5-15036906*y**6+7851038*y**7
          -5566530*y**8+2342990*y**9-446244*y**10+42438*y**11-894*y**12)+r**2*(
          -1+y)**7*(-15603-57138*y-132879*y**2-42662*y**3-100807*y**4-59646*y**5
          +315969*y**6-6674*y**7-95738*y**8-81968*y**9+100774*y**10-27656*y**11
          +1028*y**12)-r**4*(-1+y)**6*(340867+884067*y+1551387*y**2-1219429*y**3
          -1747746*y**4-1944065*y**5+5715745*y**6-4345210*y**7+1467272*y**8+138021*y**9
          -369152*y**10+125263*y**11-9277*y**12+257*y**13)-r**6*(-1+y)**5*(-66494
          -77270*y-427203*y**2+9218596*y**3-9223633*y**4+3994875*y**5-15456993*y**6
          +23831433*y**7-14345275*y**8+3815083*y**9-654956*y**10+207863*y**11
          -33830*y**12+1804*y**13)-r**12*(-1+y)**2*(-50031609+151679041*y-122681512*y**2
          +11194444*y**3-115735541*y**4+292001887*y**5-225648978*y**6+51074158*y**7
          +14385191*y**8-7799609*y**9+990022*y**10-179838*y**11+29379*y**12+1965*y**13)
          +r**16*(17561193-100862815*y+232837201*y**2-268834437*y**3+144856641*y**4
          -5174485*y**5-24570749*y**6-8329341*y**7+20751370*y**8-9943966*y**9
          +1845692*y**10-99686*y**11-19860*y**12+4242*y**13)-r**8*(-1+y)**4*(7875793
          +625591*y-665416*y**2-39183478*y**3+66681810*y**4-58015911*y**5+12541598*y**6
          +30877732*y**7-30566809*y**8+10531315*y**9-1420682*y**10+234786*y**11
          -60366*y**12+5037*y**13)-r**10*(-1+y)**3*(-7922487+19897820*y-11048360*y**2
          +118878150*y**3-326197320*y**4+326137349*y**5-125551250*y**6-1406010*y**7
          +7081135*y**8+2988170*y**9-1492762*y**10+182680*y**11-41580*y**12+6465*y**13)
          +2*r**14*(-50140578+257590840*y-510696815*y**2+449002389*y**3-61109087*y**4
          -207586284*y**5+152175950*y**6-8785015*y**7-31650383*y**8+11215434*y**9
          +785837*y**10-999640*y**11+231630*y**12-36456*y**13+2178*y**14))))/(580608000*logy**4*r**16*(
          -1+y)**8+193536000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+24192000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+1344000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +28000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-1512000*logy**3*r**12*(19+19*r**2+11*r**4+3*r**6)*(-1+y)**8-3600*logy**2*r**8*(
          -1+y)**6*(175*r**12*(-1+y)**2+255*r**14*(-1+y)**2-7*r**10*(-897+1254*y
          -87*y**2-340*y**3+90*y**4)+35*r**8*(405-414*y-189*y**2+204*y**3-38*y**4
          +8*y**5)-35*r**2*(-1+y)**2*(213-5*y**4-32*y**5+4*y**6)+35*r**6*(275
          +134*y-751*y**2+196*y**3+143*y**4-82*y**5+25*y**6)+35*r**4*(-669
          +2022*y-1695*y**2+52*y**3+495*y**4-282*y**5+77*y**6)+(-1+y)**3*(
          -361-361*y-361*y**2-4001*y**3+3804*y**4-900*y**5+80*y**6))-60*logy*r**4*(
          -1+y)**4*(-1+r**2+y)**2*(355*r**18*(-1+y)**4-r**16*(-1+y)**2*(-1153
          +3016*y-2573*y**2+1470*y**3)-r**14*(-1+y)**2*(-64706+101828*y-25903*y**2
          -10734*y**3+1755*y**4)+r**12*(-1+y)**2*(8214-66656*y+94159*y**2-16866*y**3
          -12551*y**4+5180*y**5)+r**10*(692212-2030424*y+1848647*y**2-169180*y**3
          -586485*y**4+241888*y**5+27709*y**6-25452*y**7+2485*y**8)+r**2*(-1
          +y)**3*(19399+17793*y+16187*y**2+142341*y**3-189095*y**4+52111*y**5
          -17483*y**6+7323*y**7+1544*y**8+280*y**9)-5*r**8*(-436732+1374912*y
          -1414175*y**2+301728*y**3+420651*y**4-337498*y**5+90783*y**6+5140*y**7
          -8743*y**8+1414*y**9)-(-1+y)**4*(-803-1606*y-2409*y**2-13492*y**3
          +4295*y**4-1662*y**5-7059*y**6+18944*y**7-10248*y**8+1440*y**9)+r**4*(
          -1+y)**2*(115834+6128*y-13123*y**2-627214*y**3+1390935*y**4-1107204*y**5
          +299327*y**6+34778*y**7-29781*y**8+5920*y**9)+r**6*(883662-2380808*y
          +1934387*y**2-460068*y**3+323372*y**4-509292*y**5+263858*y**6-41212*y**7
          -26282*y**8+12628*y**9-245*y**10))+(-1+y)**2*(-1+r**2+y)**3*(23*r**24*(
          -1+y)**6+r**22*(-1+y)**4*(-1636+3203*y-1498*y**2+611*y**3)-r**20*(
          -1+y)**2*(53282-196667*y+264360*y**2-147190*y**3+20590*y**4+6593*y**5
          +32*y**6)-5*r**18*(-1+y)**2*(-10084+25495*y-2964*y**2-59086*y**3+67984*y**4
          -18137*y**5-3136*y**6+768*y**7)-5*r**16*(-1+y)**2*(981683-3134849*y
          +3304164*y**2-878638*y**3-577695*y**4+335767*y**5-23846*y**6-7224*y**7
          +78*y**8)+2*r**14*(-1+y)**2*(5042852-15034913*y+12846762*y**2+344847*y**3
          -4593008*y**4+1133298*y**5+522238*y**6-184337*y**7-20172*y**8+5433*y**9)
          +r**4*(-1+y)**4*(239598+215739*y+172968*y**2+711145*y**3-1068910*y**4
          -13636*y**5-698198*y**6+2381464*y**7-2629420*y**8+1381385*y**9-259362*y**10
          -13441*y**11+668*y**12)+5*r**6*(-1+y)**3*(61652+93801*y-18903*y**2
          -1950935*y**3+5284025*y**4-5051584*y**5+1856368*y**6+72856*y**7-504180*y**8
          +374135*y**9-110233*y**10+4191*y**11+807*y**12)-(-1+y)**6*(-863-2589*y
          -5178*y**2-18310*y**3-7640*y**4-6544*y**5-7722*y**6+26426*y**7-4265*y**8
          +1565*y**9-668*y**10-3764*y**11+1552*y**12)-5*r**8*(-1+y)**2*(1495819
          -2607070*y+733134*y**2-3703654*y**3+14693541*y**4-21082902*y**5+14135366*y**6
          -3338562*y**7-900021*y**8+514084*y**9-5492*y**10-19896*y**11+1653*y**12)
          +2*r**12*(-24565894+116636943*y-212534784*y**2+167628370*y**3-16908815*y**4
          -61310837*y**5+33962579*y**6+2466173*y**7-7236645*y**8+1921290*y**9
          +4081*y**10-50547*y**11+2086*y**12)-r**2*(-1+y)**5*(-24876-47163*y
          -66861*y**2-298290*y**3+176270*y**4-4768*y**5-46084*y**6+399422*y**7
          -301510*y**8+50555*y**9-6031*y**10-2428*y**11+3764*y**12)-2*r**10*(13546628
          -58709229*y+95512344*y**2-62747978*y**3-12826120*y**4+65626674*y**5
          -74365612*y**6+48658242*y**7-16017164*y**8+210745*y**9+1369948*y**10
          -237784*y**11-27336*y**12+6642*y**13)))*nlo.X1El(0,'SL2',y/2,r))/(580608000*logy**4*r**16*(
          -1+y)**8+193536000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+24192000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+1344000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +28000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(1512000*logy**3*r**12*(19+19*r**2+11*r**4+3*r**6)*(-1+y)**8+3600*logy**2*r**8*(
          -1+y)**6*(175*r**12*(-1+y)**2+255*r**14*(-1+y)**2-7*r**10*(-897+1254*y
          -87*y**2-340*y**3+90*y**4)+35*r**8*(405-414*y-189*y**2+204*y**3-38*y**4
          +8*y**5)-35*r**2*(-1+y)**2*(213-5*y**4-32*y**5+4*y**6)+35*r**6*(275
          +134*y-751*y**2+196*y**3+143*y**4-82*y**5+25*y**6)+35*r**4*(-669
          +2022*y-1695*y**2+52*y**3+495*y**4-282*y**5+77*y**6)+(-1+y)**3*(
          -361-361*y-361*y**2-4001*y**3+3804*y**4-900*y**5+80*y**6))+60*logy*r**4*(
          -1+y)**4*(-1+r**2+y)**2*(355*r**18*(-1+y)**4-r**16*(-1+y)**2*(-1153
          +3016*y-2573*y**2+1470*y**3)-r**14*(-1+y)**2*(-64706+101828*y-25903*y**2
          -10734*y**3+1755*y**4)+r**12*(-1+y)**2*(8214-66656*y+94159*y**2-16866*y**3
          -12551*y**4+5180*y**5)+r**10*(692212-2030424*y+1848647*y**2-169180*y**3
          -586485*y**4+241888*y**5+27709*y**6-25452*y**7+2485*y**8)+r**2*(-1
          +y)**3*(19399+17793*y+16187*y**2+142341*y**3-189095*y**4+52111*y**5
          -17483*y**6+7323*y**7+1544*y**8+280*y**9)-5*r**8*(-436732+1374912*y
          -1414175*y**2+301728*y**3+420651*y**4-337498*y**5+90783*y**6+5140*y**7
          -8743*y**8+1414*y**9)-(-1+y)**4*(-803-1606*y-2409*y**2-13492*y**3
          +4295*y**4-1662*y**5-7059*y**6+18944*y**7-10248*y**8+1440*y**9)+r**4*(
          -1+y)**2*(115834+6128*y-13123*y**2-627214*y**3+1390935*y**4-1107204*y**5
          +299327*y**6+34778*y**7-29781*y**8+5920*y**9)+r**6*(883662-2380808*y
          +1934387*y**2-460068*y**3+323372*y**4-509292*y**5+263858*y**6-41212*y**7
          -26282*y**8+12628*y**9-245*y**10))-(-1+y)**2*(-1+r**2+y)**3*(23*r**24*(
          -1+y)**6+r**22*(-1+y)**4*(-1636+3203*y-1498*y**2+611*y**3)-r**20*(
          -1+y)**2*(53282-196667*y+264360*y**2-147190*y**3+20590*y**4+6593*y**5
          +32*y**6)-5*r**18*(-1+y)**2*(-10084+25495*y-2964*y**2-59086*y**3+67984*y**4
          -18137*y**5-3136*y**6+768*y**7)-5*r**16*(-1+y)**2*(981683-3134849*y
          +3304164*y**2-878638*y**3-577695*y**4+335767*y**5-23846*y**6-7224*y**7
          +78*y**8)+2*r**14*(-1+y)**2*(5042852-15034913*y+12846762*y**2+344847*y**3
          -4593008*y**4+1133298*y**5+522238*y**6-184337*y**7-20172*y**8+5433*y**9)
          +r**4*(-1+y)**4*(239598+215739*y+172968*y**2+711145*y**3-1068910*y**4
          -13636*y**5-698198*y**6+2381464*y**7-2629420*y**8+1381385*y**9-259362*y**10
          -13441*y**11+668*y**12)+5*r**6*(-1+y)**3*(61652+93801*y-18903*y**2
          -1950935*y**3+5284025*y**4-5051584*y**5+1856368*y**6+72856*y**7-504180*y**8
          +374135*y**9-110233*y**10+4191*y**11+807*y**12)-(-1+y)**6*(-863-2589*y
          -5178*y**2-18310*y**3-7640*y**4-6544*y**5-7722*y**6+26426*y**7-4265*y**8
          +1565*y**9-668*y**10-3764*y**11+1552*y**12)-5*r**8*(-1+y)**2*(1495819
          -2607070*y+733134*y**2-3703654*y**3+14693541*y**4-21082902*y**5+14135366*y**6
          -3338562*y**7-900021*y**8+514084*y**9-5492*y**10-19896*y**11+1653*y**12)
          +2*r**12*(-24565894+116636943*y-212534784*y**2+167628370*y**3-16908815*y**4
          -61310837*y**5+33962579*y**6+2466173*y**7-7236645*y**8+1921290*y**9
          +4081*y**10-50547*y**11+2086*y**12)-r**2*(-1+y)**5*(-24876-47163*y
          -66861*y**2-298290*y**3+176270*y**4-4768*y**5-46084*y**6+399422*y**7
          -301510*y**8+50555*y**9-6031*y**10-2428*y**11+3764*y**12)-2*r**10*(13546628
          -58709229*y+95512344*y**2-62747978*y**3-12826120*y**4+65626674*y**5
          -74365612*y**6+48658242*y**7-16017164*y**8+210745*y**9+1369948*y**10
          -237784*y**11-27336*y**12+6642*y**13)))*nlo.X1El(0,'SM',y/2,r))/(2322432000*logy**4*r**16*(
          -1+y)**8+774144000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+96768000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+5376000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +112000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6+120*logy*r**4*(
          -1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(-67+98*y
          -13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3-2*y**4
          +y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)+2*r**2*(
          -1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y-421*y**2
          +40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(
          -1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1
          +y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(
          -4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y
          +45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)
          +2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5
          -56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(1,'SL2',y/2,r))/(345600*logy**3*r**12*(
          -1+y)**6-200*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +86400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+7200*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-3600*logy**2*r**8*(15+10*r**2
          +3*r**4)*(-1+y)**6-120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(
          -1+y)**2-5*r**8*(-67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y
          -18*y**2+22*y**3-2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3
          -16*y**4+2*y**5)+2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(
          -151+482*y-421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))-(-1+y)**2*(
          -1+r**2+y)**2*(7*r**16*(-1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2
          +27*y**3)-r**12*(-1+y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)
          +2*r**10*(-1+y)**2*(-4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)
          +5*r**8*(13422-43158*y+45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6
          -284*y**7+33*y**8)+2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3
          -2300*y**4+277*y**5-56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436
          -542*y+757*y**2+11016*y**3-25545*y**4+20466*y**5-4753*y**6-652*y**7
          +89*y**8)+(-1+y)**4*(67+134*y+201*y**2+428*y**3-55*y**4-22*y**5
          -89*y**6-156*y**7+92*y**8)-2*r**6*(-17964+49281*y-40854*y**2+5986*y**3
          +8446*y**4-11636*y**5+9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(1,'SM',y/2,r))/(1382400*logy**3*r**12*(
          -1+y)**6-800*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +345600*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+28800*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-180*logy*r**4*(3+r**2)*(-1
          +y)**4-3*(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(
          -1+y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(2,'SL2',y/2,r))/(2880*logy**2*r**8*(-1+y)**4+480*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(180*logy*r**4*(3+r**2)*(-1+y)**4+3*(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(2,'SM',y/2,r))/(11520*logy**2*r**8*(
          -1+y)**4+1920*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+80*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(3,'SL2',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -(api*(-1+y)**2*nlo.X1El(3,'SM',y/2,r))/(48*logy*r**4*(-1+y)**2+4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))))
      res += resNP*wc.SL2

    if wc.SR2 != 0:
      resNP = 0
      resNP +=((rhoD*(9072000*logy**4*r**12*(9+21*r**2+29*r**4+27*r**6+18*r**8)*(-1+y)**8
          +21600*logy**3*r**8*(-1+y)**6*(2319*r**14*(-1+y)**2+2160*r**16*(-1+y)**2
          -35*r**12*(-1037+1210*y+259*y**2-576*y**3+72*y**4)+15*(-1+y)**4*(
          -51-102*y-153*y**2+272*y**3-108*y**4+16*y**5)+35*r**10*(383+530*y
          -1561*y**2+724*y**3-24*y**4+36*y**5)+5*r**2*(-1+y)**3*(313+313*y
          +313*y**2-2123*y**3+2140*y**4-716*y**5+96*y**6)+35*r**8*(-209+1810*y
          -2297*y**2+148*y**3+1060*y**4-596*y**5+132*y**6)-7*r**4*(-1+y)**2*(2977
          -2160*y-1080*y**2+160*y**3+1585*y**4-1272*y**5+240*y**6)+35*r**6*(
          -677+2362*y-2189*y**2-304*y**3+1391*y**4-694*y**5+87*y**6+24*y**7))
          -360*logy**2*r**4*(-1+y)**4*(-1+r**2+y)**2*(1664*r**20*(-1+y)**4+r**18*(
          -1+y)**2*(-89831+176334*y-83175*y**2+13412*y**3)-r**16*(-1+y)**2*(531761
          -851056*y+296237*y**2+46710*y**3+11028*y**4)-r**14*(-1+y)**2*(616736
          -1278308*y+785827*y**2+144702*y**3-167053*y**4+17516*y**5)+15*(-1
          +y)**6*(-71-284*y-710*y**2-732*y**3+385*y**4+1920*y**5-1496*y**6
          +288*y**7)+r**12*(-5145296+14520172*y-12568151*y**2+365100*y**3+4379910*y**4
          -1463884*y**5-111587*y**6+20556*y**7-2420*y**8)+r**2*(-1+y)**5*(12799
          +40527*y+85314*y**2-47710*y**3-8165*y**4-77829*y**5+112408*y**6-54584*y**7
          +8640*y**8)-r**6*(-1+y)**3*(-347984-353780*y-407513*y**2+3700817*y**3
          -3841030*y**4+1198314*y**5+130795*y**6-113587*y**7+14368*y**8)+r**8*(
          -1+y)**2*(-3141014+3468656*y+244565*y**2+104098*y**3-3138720*y**4
          +2468324*y**5-468391*y**6-90870*y**7+15752*y**8)-r**4*(-1+y)**4*(267584
          +425196*y+544881*y**2-1729796*y**3+1000170*y**4-128824*y**5+41529*y**6
          -62016*y**7+18576*y**8)-r**10*(5572394-16766936*y+15605649*y**2+659244*y**3
          -9488271*y**4+4587616*y**5+484251*y**6-802204*y**7+143481*y**8+4776*y**9))
          +6*logy*(-1+y)**4*(-1+r**2+y)**3*(3992*r**26*(-1+y)**4+r**24*(-1+y)**2*(
          -128263+244550*y-104311*y**2+26224*y**3)+3*r**22*(557940-2174049*y
          +3091500*y**2-2067470*y**3+749280*y**4-139545*y**5+9544*y**6)+r**20*(10657876
          -36700111*y+45389070*y**2-23346670*y**3+3369100*y**4+372249*y**5+125466*y**6
          -86580*y**7)+3*(-1+y)**9*(23+184*y+828*y**2+2220*y**3+2385*y**4
          -2648*y**5-2444*y**6+1552*y**7)-5*r**18*(-8161908+25093815*y-26347824*y**2
          +7601248*y**3+4135920*y**4-2694997*y**5+603460*y**6-259546*y**7+23112*y**8)
          +r**16*(12561001-60895219*y+114704916*y**2-67758244*y**3-30470359*y**4
          +38784449*y**5-3134606*y**6-3618366*y**7+356144*y**8+121284*y**9)-r**4*(
          -1+y)**5*(406132+1518181*y+3593071*y**2+2001731*y**3-2575929*y**4
          -7863573*y**5+8300969*y**6-2273671*y**7-45331*y**8+45604*y**9+816*y**10)
          +r**6*(-1+y)**4*(1845532+5112765*y+9868800*y**2-16975200*y**3+6076520*y**4
          -8459124*y**5+15161360*y**6-9033900*y**7+1828500*y**8-14445*y**9+7192*y**10)
          +r**2*(-1+y)**6*(7220+35893*y+107058*y**2+186713*y**3+35888*y**4-329857*y**5
          +94682*y**6-21833*y**7+73112*y**8-44188*y**9+9312*y**10)+5*r**8*(-1
          +y)**3*(-5871047-6342631*y-5874078*y**2+42478344*y**3-32665820*y**4
          +2530124*y**5+3755526*y**6+96828*y**7-502369*y**8+29215*y**9+12508*y**10)
          -2*r**10*(-1+y)**2*(1323016-8332139*y-12403934*y**2+108219971*y**3
          -139923744*y**4+50853444*y**5+7739114*y**6-8153191*y**7+1748504*y**8
          -320381*y**9+15840*y**10)+2*r**14*(162549828-365648661*y+182303844*y**2
          +148809294*y**3-150821896*y**4+4361143*y**5+23831136*y**6-4432944*y**7
          +1450456*y**8-559604*y**9+71904*y**10)+r**12*(209346360-574895826*y
          +424034100*y**2+221808700*y**3-402205260*y**4+14325710*y**5+177415182*y**6
          -69702100*y**7-5174000*y**8+5065760*y**9+58330*y**10-76956*y**11))-(
          -1+y)**2*(-1+r**2+y)**4*(455*r**28*(-1+y)**6+2*r**26*(-1+y)**4*(-7509
          +14108*y-5689*y**2+1155*y**3)+r**24*(-1+y)**2*(195401-747304*y+1027780*y**2
          -662694*y**3+242427*y**4-43778*y**5+3008*y**6)-r**22*(894128-5387042*y
          +13218023*y**2-17344790*y**3+13563281*y**4-6597978*y**5+1914117*y**6
          -294858*y**7+14635*y**8+3684*y**9)+r**20*(-8953885+47279176*y-100912474*y**2
          +112329542*y**3-70644441*y**4+26417222*y**5-7221511*y**6+2224794*y**7
          -679042*y**8+122346*y**9-12127*y**10)-5*r**18*(6085906-29600266*y+57582865*y**2
          -54039792*y**3+18670730*y**4+8834492*y**5-11313420*y**6+4721820*y**7
          -1143428*y**8+225630*y**9-33933*y**10+996*y**11)-3*(-1+y)**8*(-205
          -1092*y-3408*y**2+4388*y**3+41628*y**4+75288*y**5-124038*y**6-60516*y**7
          +120737*y**8-41228*y**9+2142*y**10+280*y**11+24*y**12)-r**2*(-1+y)**7*(
          -145198-680624*y-1928883*y**2-2411187*y**3+655858*y**4+5523914*y**5
          -4039464*y**6+576524*y**7+124212*y**8+132342*y**9-81541*y**10+5863*y**11
          +184*y**12)-r**4*(-1+y)**6*(2860239+9539590*y+20542691*y**2+919574*y**3
          -18132411*y**4-41564794*y**5+56473284*y**6-18264838*y**7+377251*y**8
          +153436*y**9+64905*y**10+8776*y**11+297*y**12)-5*r**8*(-1+y)**4*(26128705
          +18018270*y+9413785*y**2-164538358*y**3+147814358*y**4-8515344*y**5
          -21857354*y**6+352068*y**7+2381713*y**8-72838*y**9+42409*y**10-22886*y**11
          +3072*y**12)-r**6*(-1+y)**5*(-1617328-3318382*y-7071365*y**2+94002585*y**3
          -87204930*y**4+3475666*y**5+7817844*y**6+15560260*y**7-8662810*y**8
          +45180*y**9+437937*y**10-28237*y**11+3580*y**12)+r**16*(-108790379+495027304*y
          -873788590*y**2+681013640*y**3-107522560*y**4-161736012*y**5+76532302*y**6
          +3064860*y**7-2015165*y**8-1727740*y**9-51984*y**10-16356*y**11+10680*y**12)
          -2*r**10*(-1+y)**3*(125506585-58120711*y-79181594*y**2-53281201*y**3
          +44679229*y**4+83396634*y**5-35716234*y**6-28325118*y**7+19879001*y**8
          -2889679*y**9+230856*y**10-63405*y**11+13637*y**12)-r**12*(-1+y)**2*(1013415899
          -1892876248*y+424814884*y**2+1154077576*y**3-505849979*y**4-394842672*y**5
          +244688852*y**6-3233652*y**7+3838649*y**8-6810296*y**9+1076448*y**10
          +27996*y**11+18543*y**12)+2*r**14*(51533744-208162194*y+266932211*y**2
          -79197822*y**3-14924925*y**4-119605978*y**5+147791288*y**6-27702242*y**7
          -28585396*y**8+13195100*y**9-1177291*y**10-22344*y**11-76719*y**12+2568*y**13))))/(5225472000*logy**4*r**16*(
          -1+y)**8+1741824000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+217728000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+12096000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +252000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*muWC**3*(-9072000*logy**4*r**12*(9+21*r**2+29*r**4+27*r**6+18*r**8)*(
          -1+y)**8-21600*logy**3*r**8*(-1+y)**6*(2319*r**14*(-1+y)**2+2160*r**16*(
          -1+y)**2-35*r**12*(-1037+1210*y+259*y**2-576*y**3+72*y**4)+15*(
          -1+y)**4*(-51-102*y-153*y**2+272*y**3-108*y**4+16*y**5)+35*r**10*(383
          +530*y-1561*y**2+724*y**3-24*y**4+36*y**5)+5*r**2*(-1+y)**3*(313
          +313*y+313*y**2-2123*y**3+2140*y**4-716*y**5+96*y**6)+35*r**8*(-209
          +1810*y-2297*y**2+148*y**3+1060*y**4-596*y**5+132*y**6)-7*r**4*(-1
          +y)**2*(2977-2160*y-1080*y**2+160*y**3+1585*y**4-1272*y**5+240*y**6)
          +35*r**6*(-677+2362*y-2189*y**2-304*y**3+1391*y**4-694*y**5+87*y**6
          +24*y**7))+360*logy**2*r**4*(-1+y)**4*(-1+r**2+y)**2*(1664*r**20*(-1+y)**4
          +r**18*(-1+y)**2*(-89831+176334*y-83175*y**2+13412*y**3)-r**16*(-1
          +y)**2*(531761-851056*y+296237*y**2+46710*y**3+11028*y**4)-r**14*(
          -1+y)**2*(616736-1278308*y+785827*y**2+144702*y**3-167053*y**4+17516*y**5)
          +15*(-1+y)**6*(-71-284*y-710*y**2-732*y**3+385*y**4+1920*y**5-1496*y**6
          +288*y**7)+r**12*(-5145296+14520172*y-12568151*y**2+365100*y**3+4379910*y**4
          -1463884*y**5-111587*y**6+20556*y**7-2420*y**8)+r**2*(-1+y)**5*(12799
          +40527*y+85314*y**2-47710*y**3-8165*y**4-77829*y**5+112408*y**6-54584*y**7
          +8640*y**8)-r**6*(-1+y)**3*(-347984-353780*y-407513*y**2+3700817*y**3
          -3841030*y**4+1198314*y**5+130795*y**6-113587*y**7+14368*y**8)+r**8*(
          -1+y)**2*(-3141014+3468656*y+244565*y**2+104098*y**3-3138720*y**4
          +2468324*y**5-468391*y**6-90870*y**7+15752*y**8)-r**4*(-1+y)**4*(267584
          +425196*y+544881*y**2-1729796*y**3+1000170*y**4-128824*y**5+41529*y**6
          -62016*y**7+18576*y**8)-r**10*(5572394-16766936*y+15605649*y**2+659244*y**3
          -9488271*y**4+4587616*y**5+484251*y**6-802204*y**7+143481*y**8+4776*y**9))
          -6*logy*(-1+y)**4*(-1+r**2+y)**3*(3992*r**26*(-1+y)**4+r**24*(-1+y)**2*(
          -128263+244550*y-104311*y**2+26224*y**3)+3*r**22*(557940-2174049*y
          +3091500*y**2-2067470*y**3+749280*y**4-139545*y**5+9544*y**6)+r**20*(10657876
          -36700111*y+45389070*y**2-23346670*y**3+3369100*y**4+372249*y**5+125466*y**6
          -86580*y**7)+3*(-1+y)**9*(23+184*y+828*y**2+2220*y**3+2385*y**4
          -2648*y**5-2444*y**6+1552*y**7)-5*r**18*(-8161908+25093815*y-26347824*y**2
          +7601248*y**3+4135920*y**4-2694997*y**5+603460*y**6-259546*y**7+23112*y**8)
          +r**16*(12561001-60895219*y+114704916*y**2-67758244*y**3-30470359*y**4
          +38784449*y**5-3134606*y**6-3618366*y**7+356144*y**8+121284*y**9)-r**4*(
          -1+y)**5*(406132+1518181*y+3593071*y**2+2001731*y**3-2575929*y**4
          -7863573*y**5+8300969*y**6-2273671*y**7-45331*y**8+45604*y**9+816*y**10)
          +r**6*(-1+y)**4*(1845532+5112765*y+9868800*y**2-16975200*y**3+6076520*y**4
          -8459124*y**5+15161360*y**6-9033900*y**7+1828500*y**8-14445*y**9+7192*y**10)
          +r**2*(-1+y)**6*(7220+35893*y+107058*y**2+186713*y**3+35888*y**4-329857*y**5
          +94682*y**6-21833*y**7+73112*y**8-44188*y**9+9312*y**10)+5*r**8*(-1
          +y)**3*(-5871047-6342631*y-5874078*y**2+42478344*y**3-32665820*y**4
          +2530124*y**5+3755526*y**6+96828*y**7-502369*y**8+29215*y**9+12508*y**10)
          -2*r**10*(-1+y)**2*(1323016-8332139*y-12403934*y**2+108219971*y**3
          -139923744*y**4+50853444*y**5+7739114*y**6-8153191*y**7+1748504*y**8
          -320381*y**9+15840*y**10)+2*r**14*(162549828-365648661*y+182303844*y**2
          +148809294*y**3-150821896*y**4+4361143*y**5+23831136*y**6-4432944*y**7
          +1450456*y**8-559604*y**9+71904*y**10)+r**12*(209346360-574895826*y
          +424034100*y**2+221808700*y**3-402205260*y**4+14325710*y**5+177415182*y**6
          -69702100*y**7-5174000*y**8+5065760*y**9+58330*y**10-76956*y**11))+(
          -1+y)**2*(-1+r**2+y)**4*(455*r**28*(-1+y)**6+2*r**26*(-1+y)**4*(-7509
          +14108*y-5689*y**2+1155*y**3)+r**24*(-1+y)**2*(195401-747304*y+1027780*y**2
          -662694*y**3+242427*y**4-43778*y**5+3008*y**6)-r**22*(894128-5387042*y
          +13218023*y**2-17344790*y**3+13563281*y**4-6597978*y**5+1914117*y**6
          -294858*y**7+14635*y**8+3684*y**9)+r**20*(-8953885+47279176*y-100912474*y**2
          +112329542*y**3-70644441*y**4+26417222*y**5-7221511*y**6+2224794*y**7
          -679042*y**8+122346*y**9-12127*y**10)-5*r**18*(6085906-29600266*y+57582865*y**2
          -54039792*y**3+18670730*y**4+8834492*y**5-11313420*y**6+4721820*y**7
          -1143428*y**8+225630*y**9-33933*y**10+996*y**11)-3*(-1+y)**8*(-205
          -1092*y-3408*y**2+4388*y**3+41628*y**4+75288*y**5-124038*y**6-60516*y**7
          +120737*y**8-41228*y**9+2142*y**10+280*y**11+24*y**12)-r**2*(-1+y)**7*(
          -145198-680624*y-1928883*y**2-2411187*y**3+655858*y**4+5523914*y**5
          -4039464*y**6+576524*y**7+124212*y**8+132342*y**9-81541*y**10+5863*y**11
          +184*y**12)-r**4*(-1+y)**6*(2860239+9539590*y+20542691*y**2+919574*y**3
          -18132411*y**4-41564794*y**5+56473284*y**6-18264838*y**7+377251*y**8
          +153436*y**9+64905*y**10+8776*y**11+297*y**12)-5*r**8*(-1+y)**4*(26128705
          +18018270*y+9413785*y**2-164538358*y**3+147814358*y**4-8515344*y**5
          -21857354*y**6+352068*y**7+2381713*y**8-72838*y**9+42409*y**10-22886*y**11
          +3072*y**12)-r**6*(-1+y)**5*(-1617328-3318382*y-7071365*y**2+94002585*y**3
          -87204930*y**4+3475666*y**5+7817844*y**6+15560260*y**7-8662810*y**8
          +45180*y**9+437937*y**10-28237*y**11+3580*y**12)+r**16*(-108790379+495027304*y
          -873788590*y**2+681013640*y**3-107522560*y**4-161736012*y**5+76532302*y**6
          +3064860*y**7-2015165*y**8-1727740*y**9-51984*y**10-16356*y**11+10680*y**12)
          -2*r**10*(-1+y)**3*(125506585-58120711*y-79181594*y**2-53281201*y**3
          +44679229*y**4+83396634*y**5-35716234*y**6-28325118*y**7+19879001*y**8
          -2889679*y**9+230856*y**10-63405*y**11+13637*y**12)-r**12*(-1+y)**2*(1013415899
          -1892876248*y+424814884*y**2+1154077576*y**3-505849979*y**4-394842672*y**5
          +244688852*y**6-3233652*y**7+3838649*y**8-6810296*y**9+1076448*y**10
          +27996*y**11+18543*y**12)+2*r**14*(51533744-208162194*y+266932211*y**2
          -79197822*y**3-14924925*y**4-119605978*y**5+147791288*y**6-27702242*y**7
          -28585396*y**8+13195100*y**9-1177291*y**10-22344*y**11-76719*y**12+2568*y**13))))/(5878656000*logy**4*r**16*(
          -1+y)**8+1959552000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+244944000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+13608000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +283500*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((muG*(-9072000*logy**4*r**14*(3+7*r**2+9*r**4+9*r**6)*(-1+y)**8-21600*logy**3*r**10*(
          -1+y)**6*(2457*r**12*(-1+y)**2+873*r**14*(-1+y)**2-7*r**10*(-2033+1906*y
          +1207*y**2-1440*y**3+180*y**4)+7*r**4*(-1+y)**2*(-1079+720*y+360*y**2
          -400*y**3+165*y**4+24*y**5)+35*r**8*(-59+550*y-707*y**2+260*y**3
          -48*y**4+36*y**5)+35*r**6*(-187+710*y-691*y**2-16*y**3+365*y**4-226*y**5
          +57*y**6)-7*r**2*(-1+y)**2*(281-400*y**3+575*y**4-336*y**5+60*y**6)
          -(-1+y)**3*(569+569*y+569*y**2-2371*y**3+2564*y**4-1300*y**5+240*y**6))
          -360*logy**2*r**6*(-1+y)**4*(-1+r**2+y)**2*(509*r**18*(-1+y)**4-r**16*(
          -1+y)**2*(-28759+58536*y-30795*y**2+5278*y**3)+r**14*(-1+y)**2*(286564
          -474524*y+169453*y**2+7950*y**3+3417*y**4)+r**12*(-1+y)**2*(436804
          -748732*y+340373*y**2+152778*y**3-85967*y**4+14644*y**5)+r**10*(1905754
          -5210768*y+4314559*y**2+165120*y**3-2021925*y**4+1049276*y**5-263147*y**6
          +72156*y**7-8225*y**8)-r**4*(-1+y)**3*(-104084-17960*y+5107*y**2+342437*y**3
          -564490*y**4+376254*y**5-100985*y**6+1433*y**7+688*y**8)-r**2*(-1+y)**4*(4199
          +16296*y+36291*y**2-51416*y**3+69645*y**4-70744*y**5+43569*y**6-14016*y**7
          +1176*y**8)+(-1+y)**5*(3949+11847*y+23694*y**2-1630*y**3-20255*y**4
          -36549*y**5+58408*y**6-26984*y**7+4320*y**8)+r**6*(-1+y)**2*(364396
          -373684*y-130525*y**2+188878*y**3+290385*y**4-479356*y**5+282629*y**6
          -87150*y**7+15827*y**8)+r**8*(1323046-3902164*y+3446331*y**2+854616*y**3
          -3513279*y**4+2176454*y**5-184611*y**6-290756*y**7+93009*y**8-2646*y**9))
          -6*logy*r**2*(-1+y)**4*(-1+r**2+y)**3*(79*r**24*(-1+y)**4+r**22*(-1
          +y)**2*(-6068+11899*y-5594*y**2+2963*y**3)+3*r**20*(186168-718323*y
          +1021950*y**2-670930*y**3+218060*y**4-36523*y**5+4398*y**6)-5*r**18*(
          -961900+3476677*y-4595184*y**2+2671468*y**3-583132*y**4-33507*y**5
          +15936*y**6+1242*y**7)-5*r**16*(-4589367+13994709*y-14272812*y**2+4054724*y**3
          +1793625*y**4-1051283*y**5+207566*y**6-92078*y**7+11196*y**8)+2*r**14*(5871556
          -20791339*y+29955516*y**2-7645174*y**3-22315264*y**4+19952819*y**5
          -4797686*y**6-153066*y**7+203174*y**8+2964*y**9)-5*r**6*(-1+y)**3*(406588
          +413003*y+150153*y**2-839928*y**3-1499000*y**4+2667176*y**5-875268*y**6
          -542508*y**7+430088*y**8-92495*y**9+3391*y**10)-(-1+y)**6*(911+4555*y
          +13665*y**2+28745*y**3+27905*y**4-11467*y**5-65605*y**6-11765*y**7
          +70580*y**8-34180*y**9+4656*y**10)+r**2*(-1+y)**5*(44548+180925*y
          +459145*y**2+315575*y**3-229365*y**4-957501*y**5+923375*y**6-328795*y**7
          +74525*y**8-28460*y**9+8028*y**10)-5*r**8*(-1+y)**2*(2415095-902512*y
          -1268185*y**2-4345166*y**3+10299780*y**4-6327012*y**5-212918*y**6+1061470*y**7
          +19141*y**8-143140*y**9+16647*y**10)+r**4*(-1+y)**4*(-947416-2504745*y
          -4576890*y**2+3457560*y**3+2694640*y**4+5112792*y**5-11553830*y**6+6555540*y**7
          -1164060*y**8-93915*y**9+38324*y**10)+2*r**12*(52234008-109510575*y
          +45358230*y**2+53856510*y**3-54143690*y**4+13001759*y**5-1092825*y**6
          +987420*y**7+514640*y**8-353710*y**9+58233*y**10)+2*r**10*(17929716
          -49612671*y+31350600*y**2+38259400*y**3-47733540*y**4-22415827*y**5
          +57966552*y**6-31101175*y**7+4783600*y**8+767990*y**9-209864*y**10+15219*y**11))
          +(-1+y)**2*(-1+r**2+y)**4*(34*r**28*(-1+y)**6+2*r**26*(-1+y)**4*(-579
          +1090*y-443*y**2+111*y**3)+r**24*(-1+y)**2*(21706-82802*y+114251*y**2
          -74238*y**3+27168*y**4-4852*y**5+547*y**6)-6*(-1+y)**10*(23+184*y
          +828*y**2+2220*y**3+2385*y**4-2648*y**5-2444*y**6+1552*y**7)+r**22*(
          -266164+1550590*y-3705133*y**2+4716946*y**3-3500239*y**4+1560654*y**5
          -416175*y**6+70758*y**7-9401*y**8+564*y**9)+r**20*(-4061918+22038746*y
          -48719903*y**2+56495590*y**3-36924960*y**4+13704808*y**5-2940686*y**6
          +483198*y**7-60410*y**8-6150*y**9+85*y**10)-r**18*(14538058-72286258*y
          +144366475*y**2-142520580*y**3+60107210*y**4+11222504*y**5-24225984*y**6
          +10719600*y**7-2048420*y**8+171090*y**9-2187*y**10+492*y**11)-r**2*(
          -1+y)**7*(36106+174512*y+508215*y**2+855039*y**3+326414*y**4-1201418*y**5
          -384600*y**6-22916*y**7+902136*y**8-530214*y**9+93937*y**10-1387*y**11
          +176*y**12)-2*r**16*(30657167-136707568*y+232882306*y**2-170912882*y**3
          +20284618*y**4+39662544*y**5-14157151*y**6-2657304*y**7+304082*y**8
          +694432*y**9-63411*y**10-9006*y**11+1173*y**12)-r**4*(-1+y)**6*(-406566
          -1497382*y-3534383*y**2+848194*y**3+1989879*y**4+3965206*y**5-9002082*y**6
          +4918870*y**7+109556*y**8-765904*y**9+193185*y**10-12136*y**11+1563*y**12)
          -r**6*(-1+y)**5*(4797292+10204762*y+15680981*y**2-23281137*y**3-10886442*y**4
          -22390966*y**5+58564584*y**6-33597424*y**7+6115162*y**8+17292*y**9+108099*y**10
          -46271*y**11+6068*y**12)-2*r**12*(-1+y)**2*(150456821-249988078*y+14820385*y**2
          +121412434*y**3+89060974*y**4-202283388*y**5+91908350*y**6-10687266*y**7
          +3491291*y**8-2841374*y**9+745317*y**10-55272*y**11+7806*y**12)-2*r**10*(
          -1+y)**3*(53952803-19448627*y-25316932*y**2-113864477*y**3+167890853*y**4
          -38138778*y**5-25284458*y**6-2635638*y**7+14303827*y**8-5384903*y**9
          +871650*y**10-66465*y**11+9145*y**12)-r**8*(-1+y)**4*(25387426+23575158*y
          +13486711*y**2-100344250*y**3-3498235*y**4+63506328*y**5+23834254*y**6
          -57192612*y**7+24852400*y**8-4189990*y**9+623371*y**10-99962*y**11+13401*y**12)
          -2*r**14*(-19649764+77734686*y-89714929*y**2+42354738*y**3-129757125*y**4
          +307192958*y**5-293767612*y**6+121862038*y**7-11368396*y**8-6518500*y**9
          +1550981*y**10+109176*y**11-32259*y**12+4008*y**13))))/(1741824000*logy**4*r**16*(
          -1+y)**8+580608000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+72576000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+4032000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +84000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((rhoLS*(-9072000*logy**4*r**14*(1+r**2+r**4+3*r**6)*(-1+y)**8+21600*logy**3*r**10*(
          -1+y)**5*(375*r**14*(-1+y)**3+7*r**12*(349-1047*y+1047*y**2-409*y**3
          +30*y**4)+7*r**10*(409-507*y-573*y**2+1051*y**3-490*y**4+60*y**5)
          -35*r**8*(101-351*y+423*y**2-181*y**3+20*y**4-6*y**5+4*y**6)+7*r**2*(
          -1+y)**3*(-31-80*y**3+165*y**4-104*y**5+20*y**6)-(-1+y)**4*(353
          +353*y+353*y**2-2027*y**3+1788*y**4-620*y**5+80*y**6)-35*r**4*(41
          -171*y+243*y**2-113*y**3-61*y**4+99*y**5-45*y**6+7*y**7)-35*r**6*(
          -5-33*y+105*y**2-7*y**3-217*y**4+281*y**5-145*y**6+27*y**7))+1800*logy**2*r**6*(
          -1+y)**3*(-1+r**2+y)**2*(131*r**18*(-1+y)**5-r**16*(-1+y)**2*(2971
          -9175*y+9699*y**2-3985*y**3+1000*y**4)+r**14*(-1+y)**2*(128-7680*y
          +15129*y**2-13847*y**3+5857*y**4+259*y**5)+r**12*(68120-273704*y+394495*y**2
          -219223*y**3-9824*y**4+46724*y**5+2011*y**6-10805*y**7+1646*y**8)-r**2*(
          -1+y)**4*(-2141-2311*y-2481*y**2+18057*y**3-19113*y**4+11449*y**5
          -6541*y**6+3069*y**7-744*y**8+56*y**9)+(-1+y)**5*(-85-170*y-255*y**2
          +796*y**3+1321*y**4+614*y**5-5581*y**6+5424*y**7-2072*y**8+288*y**9)
          +r**6*(-1+y)**2*(-7648+28112*y-9681*y**2-121485*y**3+229937*y**4-174557*y**5
          +53973*y**6+771*y**7-3565*y**8+503*y**9)-r**10*(-90086+342258*y-456435*y**2
          +170779*y**3+224867*y**4-349043*y**5+211173*y**6-56939*y**7+3397*y**8
          +589*y**9)-r**4*(-1+y)**3*(16808-8256*y-1647*y**2-110810*y**3+223805*y**4
          -172604*y**5+53805*y**6+3286*y**7-6411*y**8+1184*y**9)+r**8*(14822
          -95854*y+217973*y**2-223685*y**3+41637*y**4+142395*y**5-138921*y**6
          +41207*y**7+3875*y**8-3947*y**9+498*y**10))-6*logy*r**2*(-1+y)**2*(
          -1+r**2+y)**3*(-913*r**24*(-1+y)**6-r**22*(-1+y)**3*(13666-38259*y
          +32781*y**2-14029*y**3+2291*y**4)+r**20*(-574318+3329049*y-7958394*y**2
          +10124383*y**3-7391760*y**4+3117333*y**5-717284*y**6+76859*y**7-5868*y**8)
          +5*r**18*(98102-623913*y+1558584*y**2-2107289*y**3+1753196*y**4-920467*y**5
          +286038*y**6-57989*y**7+12984*y**8+754*y**9)+5*r**16*(19213-429525*y
          +1689447*y**2-3321223*y**3+4201689*y**4-3629969*y**5+1985465*y**6-625547*y**7
          +158128*y**8-53664*y**9+5986*y**10)-r**4*(-1+y)**5*(213442+413363*y
          +618825*y**2-2217830*y**3+174480*y**4-620354*y**5+4841694*y**6-5543250*y**7
          +2610230*y**8-531405*y**9+33137*y**10+668*y**11)+5*r**6*(-1+y)**4*(248682
          +117123*y+102228*y**2-2073605*y**3+3341858*y**4-2494682*y**5+647046*y**6
          +451362*y**7-419500*y**8+125847*y**9-16330*y**10+771*y**11)+(-1+y)**7*(1073
          +4292*y+10730*y**2+9720*y**3+560*y**4-14596*y**5+8106*y**6-13280*y**7
          +855*y**8+13640*y**9-8652*y**10+1552*y**11)+5*r**8*(-1+y)**3*(-1471693
          +1402473*y+45087*y**2+9325355*y**3-21582962*y**4+18646192*y**5-6363262*y**6
          -680482*y**7+1206975*y**8-310533*y**9+8431*y**10+2619*y**11)+2*r**14*(11550598
          -49797303*y+76834320*y**2-39753845*y**3-23470420*y**4+40963049*y**5
          -19169244*y**6+2937855*y**7-782230*y**8+821670*y**9-179872*y**10+3422*y**11)
          +r**2*(-1+y)**6*(13566+37479*y+68520*y**2-5670*y**3-218630*y**4-240542*y**5
          +653932*y**6-415570*y**7+78020*y**8+32755*y**9-21624*y**10+3764*y**11)
          -2*r**10*(-1+y)**2*(7487942-17313857*y+7835700*y**2+14463280*y**3-19873900*y**4
          +7328351*y**5+2553274*y**6-2671875*y**7-159930*y**8+702150*y**9-187018*y**10
          +10883*y**11)-2*r**12*(-9654934+46049313*y-84881454*y**2+64941555*y**3
          +19801790*y**4-92326457*y**5+86981609*y**6-34164372*y**7+397970*y**8
          +3490110*y**9-539209*y**10-117397*y**11+21476*y**12))-(-1+y)*(-1
          +r**2+y)**4*(93*r**28*(-1+y)**7+r**26*(-1+y)**4*(3151-9081*y+8337*y**2
          -2901*y**3+471*y**4)+r**24*(-1+y)**2*(-37627+181381*y-340691*y**2
          +326123*y**3-178816*y**4+58267*y**5-9880*y**6+563*y**7)+r**22*(403138
          -2760208*y+8003071*y**2-12836493*y**3+12547427*y**4-7788878*y**5+3090083*y**6
          -752531*y**7+97033*y**8-602*y**9-1040*y**10)-(-1+y)**8*(-291-1455*y
          -4365*y**2-7915*y**3-1545*y**4+13787*y**5-12295*y**6+6915*y**7+8040*y**8
          -10980*y**9+3104*y**10)-r**20*(-1525671+8784583*y-20661908*y**2+24786416*y**3
          -14401460*y**4+1097301*y**5+3428107*y**6-1714687*y**7+94189*y**8+146140*y**9
          -34625*y**10+3015*y**11)+r**18*(-7448139+44986343*y-110147694*y**2
          +142562980*y**3-106042665*y**4+46896283*y**5-15036906*y**6+7851038*y**7
          -5566530*y**8+2342990*y**9-446244*y**10+42438*y**11-894*y**12)+r**2*(
          -1+y)**7*(-15603-57138*y-132879*y**2-42662*y**3-100807*y**4-59646*y**5
          +315969*y**6-6674*y**7-95738*y**8-81968*y**9+100774*y**10-27656*y**11
          +1028*y**12)-r**4*(-1+y)**6*(340867+884067*y+1551387*y**2-1219429*y**3
          -1747746*y**4-1944065*y**5+5715745*y**6-4345210*y**7+1467272*y**8+138021*y**9
          -369152*y**10+125263*y**11-9277*y**12+257*y**13)-r**6*(-1+y)**5*(-66494
          -77270*y-427203*y**2+9218596*y**3-9223633*y**4+3994875*y**5-15456993*y**6
          +23831433*y**7-14345275*y**8+3815083*y**9-654956*y**10+207863*y**11
          -33830*y**12+1804*y**13)-r**12*(-1+y)**2*(-50031609+151679041*y-122681512*y**2
          +11194444*y**3-115735541*y**4+292001887*y**5-225648978*y**6+51074158*y**7
          +14385191*y**8-7799609*y**9+990022*y**10-179838*y**11+29379*y**12+1965*y**13)
          +r**16*(17561193-100862815*y+232837201*y**2-268834437*y**3+144856641*y**4
          -5174485*y**5-24570749*y**6-8329341*y**7+20751370*y**8-9943966*y**9
          +1845692*y**10-99686*y**11-19860*y**12+4242*y**13)-r**8*(-1+y)**4*(7875793
          +625591*y-665416*y**2-39183478*y**3+66681810*y**4-58015911*y**5+12541598*y**6
          +30877732*y**7-30566809*y**8+10531315*y**9-1420682*y**10+234786*y**11
          -60366*y**12+5037*y**13)-r**10*(-1+y)**3*(-7922487+19897820*y-11048360*y**2
          +118878150*y**3-326197320*y**4+326137349*y**5-125551250*y**6-1406010*y**7
          +7081135*y**8+2988170*y**9-1492762*y**10+182680*y**11-41580*y**12+6465*y**13)
          +2*r**14*(-50140578+257590840*y-510696815*y**2+449002389*y**3-61109087*y**4
          -207586284*y**5+152175950*y**6-8785015*y**7-31650383*y**8+11215434*y**9
          +785837*y**10-999640*y**11+231630*y**12-36456*y**13+2178*y**14))))/(580608000*logy**4*r**16*(
          -1+y)**8+193536000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+24192000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+1344000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +28000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(1512000*logy**3*r**12*(19+19*r**2+11*r**4+3*r**6)*(-1+y)**8+3600*logy**2*r**8*(
          -1+y)**6*(175*r**12*(-1+y)**2+255*r**14*(-1+y)**2-7*r**10*(-897+1254*y
          -87*y**2-340*y**3+90*y**4)+35*r**8*(405-414*y-189*y**2+204*y**3-38*y**4
          +8*y**5)-35*r**2*(-1+y)**2*(213-5*y**4-32*y**5+4*y**6)+35*r**6*(275
          +134*y-751*y**2+196*y**3+143*y**4-82*y**5+25*y**6)+35*r**4*(-669
          +2022*y-1695*y**2+52*y**3+495*y**4-282*y**5+77*y**6)+(-1+y)**3*(
          -361-361*y-361*y**2-4001*y**3+3804*y**4-900*y**5+80*y**6))+60*logy*r**4*(
          -1+y)**4*(-1+r**2+y)**2*(355*r**18*(-1+y)**4-r**16*(-1+y)**2*(-1153
          +3016*y-2573*y**2+1470*y**3)-r**14*(-1+y)**2*(-64706+101828*y-25903*y**2
          -10734*y**3+1755*y**4)+r**12*(-1+y)**2*(8214-66656*y+94159*y**2-16866*y**3
          -12551*y**4+5180*y**5)+r**10*(692212-2030424*y+1848647*y**2-169180*y**3
          -586485*y**4+241888*y**5+27709*y**6-25452*y**7+2485*y**8)+r**2*(-1
          +y)**3*(19399+17793*y+16187*y**2+142341*y**3-189095*y**4+52111*y**5
          -17483*y**6+7323*y**7+1544*y**8+280*y**9)-5*r**8*(-436732+1374912*y
          -1414175*y**2+301728*y**3+420651*y**4-337498*y**5+90783*y**6+5140*y**7
          -8743*y**8+1414*y**9)-(-1+y)**4*(-803-1606*y-2409*y**2-13492*y**3
          +4295*y**4-1662*y**5-7059*y**6+18944*y**7-10248*y**8+1440*y**9)+r**4*(
          -1+y)**2*(115834+6128*y-13123*y**2-627214*y**3+1390935*y**4-1107204*y**5
          +299327*y**6+34778*y**7-29781*y**8+5920*y**9)+r**6*(883662-2380808*y
          +1934387*y**2-460068*y**3+323372*y**4-509292*y**5+263858*y**6-41212*y**7
          -26282*y**8+12628*y**9-245*y**10))-(-1+y)**2*(-1+r**2+y)**3*(23*r**24*(
          -1+y)**6+r**22*(-1+y)**4*(-1636+3203*y-1498*y**2+611*y**3)-r**20*(
          -1+y)**2*(53282-196667*y+264360*y**2-147190*y**3+20590*y**4+6593*y**5
          +32*y**6)-5*r**18*(-1+y)**2*(-10084+25495*y-2964*y**2-59086*y**3+67984*y**4
          -18137*y**5-3136*y**6+768*y**7)-5*r**16*(-1+y)**2*(981683-3134849*y
          +3304164*y**2-878638*y**3-577695*y**4+335767*y**5-23846*y**6-7224*y**7
          +78*y**8)+2*r**14*(-1+y)**2*(5042852-15034913*y+12846762*y**2+344847*y**3
          -4593008*y**4+1133298*y**5+522238*y**6-184337*y**7-20172*y**8+5433*y**9)
          +r**4*(-1+y)**4*(239598+215739*y+172968*y**2+711145*y**3-1068910*y**4
          -13636*y**5-698198*y**6+2381464*y**7-2629420*y**8+1381385*y**9-259362*y**10
          -13441*y**11+668*y**12)+5*r**6*(-1+y)**3*(61652+93801*y-18903*y**2
          -1950935*y**3+5284025*y**4-5051584*y**5+1856368*y**6+72856*y**7-504180*y**8
          +374135*y**9-110233*y**10+4191*y**11+807*y**12)-(-1+y)**6*(-863-2589*y
          -5178*y**2-18310*y**3-7640*y**4-6544*y**5-7722*y**6+26426*y**7-4265*y**8
          +1565*y**9-668*y**10-3764*y**11+1552*y**12)-5*r**8*(-1+y)**2*(1495819
          -2607070*y+733134*y**2-3703654*y**3+14693541*y**4-21082902*y**5+14135366*y**6
          -3338562*y**7-900021*y**8+514084*y**9-5492*y**10-19896*y**11+1653*y**12)
          +2*r**12*(-24565894+116636943*y-212534784*y**2+167628370*y**3-16908815*y**4
          -61310837*y**5+33962579*y**6+2466173*y**7-7236645*y**8+1921290*y**9
          +4081*y**10-50547*y**11+2086*y**12)-r**2*(-1+y)**5*(-24876-47163*y
          -66861*y**2-298290*y**3+176270*y**4-4768*y**5-46084*y**6+399422*y**7
          -301510*y**8+50555*y**9-6031*y**10-2428*y**11+3764*y**12)-2*r**10*(13546628
          -58709229*y+95512344*y**2-62747978*y**3-12826120*y**4+65626674*y**5
          -74365612*y**6+48658242*y**7-16017164*y**8+210745*y**9+1369948*y**10
          -237784*y**11-27336*y**12+6642*y**13)))*nlo.X1El(0,'SM',y/2,r))/(2322432000*logy**4*r**16*(
          -1+y)**8+774144000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+96768000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+5376000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +112000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-1512000*logy**3*r**12*(19+19*r**2+11*r**4+3*r**6)*(-1+y)**8-3600*logy**2*r**8*(
          -1+y)**6*(175*r**12*(-1+y)**2+255*r**14*(-1+y)**2-7*r**10*(-897+1254*y
          -87*y**2-340*y**3+90*y**4)+35*r**8*(405-414*y-189*y**2+204*y**3-38*y**4
          +8*y**5)-35*r**2*(-1+y)**2*(213-5*y**4-32*y**5+4*y**6)+35*r**6*(275
          +134*y-751*y**2+196*y**3+143*y**4-82*y**5+25*y**6)+35*r**4*(-669
          +2022*y-1695*y**2+52*y**3+495*y**4-282*y**5+77*y**6)+(-1+y)**3*(
          -361-361*y-361*y**2-4001*y**3+3804*y**4-900*y**5+80*y**6))-60*logy*r**4*(
          -1+y)**4*(-1+r**2+y)**2*(355*r**18*(-1+y)**4-r**16*(-1+y)**2*(-1153
          +3016*y-2573*y**2+1470*y**3)-r**14*(-1+y)**2*(-64706+101828*y-25903*y**2
          -10734*y**3+1755*y**4)+r**12*(-1+y)**2*(8214-66656*y+94159*y**2-16866*y**3
          -12551*y**4+5180*y**5)+r**10*(692212-2030424*y+1848647*y**2-169180*y**3
          -586485*y**4+241888*y**5+27709*y**6-25452*y**7+2485*y**8)+r**2*(-1
          +y)**3*(19399+17793*y+16187*y**2+142341*y**3-189095*y**4+52111*y**5
          -17483*y**6+7323*y**7+1544*y**8+280*y**9)-5*r**8*(-436732+1374912*y
          -1414175*y**2+301728*y**3+420651*y**4-337498*y**5+90783*y**6+5140*y**7
          -8743*y**8+1414*y**9)-(-1+y)**4*(-803-1606*y-2409*y**2-13492*y**3
          +4295*y**4-1662*y**5-7059*y**6+18944*y**7-10248*y**8+1440*y**9)+r**4*(
          -1+y)**2*(115834+6128*y-13123*y**2-627214*y**3+1390935*y**4-1107204*y**5
          +299327*y**6+34778*y**7-29781*y**8+5920*y**9)+r**6*(883662-2380808*y
          +1934387*y**2-460068*y**3+323372*y**4-509292*y**5+263858*y**6-41212*y**7
          -26282*y**8+12628*y**9-245*y**10))+(-1+y)**2*(-1+r**2+y)**3*(23*r**24*(
          -1+y)**6+r**22*(-1+y)**4*(-1636+3203*y-1498*y**2+611*y**3)-r**20*(
          -1+y)**2*(53282-196667*y+264360*y**2-147190*y**3+20590*y**4+6593*y**5
          +32*y**6)-5*r**18*(-1+y)**2*(-10084+25495*y-2964*y**2-59086*y**3+67984*y**4
          -18137*y**5-3136*y**6+768*y**7)-5*r**16*(-1+y)**2*(981683-3134849*y
          +3304164*y**2-878638*y**3-577695*y**4+335767*y**5-23846*y**6-7224*y**7
          +78*y**8)+2*r**14*(-1+y)**2*(5042852-15034913*y+12846762*y**2+344847*y**3
          -4593008*y**4+1133298*y**5+522238*y**6-184337*y**7-20172*y**8+5433*y**9)
          +r**4*(-1+y)**4*(239598+215739*y+172968*y**2+711145*y**3-1068910*y**4
          -13636*y**5-698198*y**6+2381464*y**7-2629420*y**8+1381385*y**9-259362*y**10
          -13441*y**11+668*y**12)+5*r**6*(-1+y)**3*(61652+93801*y-18903*y**2
          -1950935*y**3+5284025*y**4-5051584*y**5+1856368*y**6+72856*y**7-504180*y**8
          +374135*y**9-110233*y**10+4191*y**11+807*y**12)-(-1+y)**6*(-863-2589*y
          -5178*y**2-18310*y**3-7640*y**4-6544*y**5-7722*y**6+26426*y**7-4265*y**8
          +1565*y**9-668*y**10-3764*y**11+1552*y**12)-5*r**8*(-1+y)**2*(1495819
          -2607070*y+733134*y**2-3703654*y**3+14693541*y**4-21082902*y**5+14135366*y**6
          -3338562*y**7-900021*y**8+514084*y**9-5492*y**10-19896*y**11+1653*y**12)
          +2*r**12*(-24565894+116636943*y-212534784*y**2+167628370*y**3-16908815*y**4
          -61310837*y**5+33962579*y**6+2466173*y**7-7236645*y**8+1921290*y**9
          +4081*y**10-50547*y**11+2086*y**12)-r**2*(-1+y)**5*(-24876-47163*y
          -66861*y**2-298290*y**3+176270*y**4-4768*y**5-46084*y**6+399422*y**7
          -301510*y**8+50555*y**9-6031*y**10-2428*y**11+3764*y**12)-2*r**10*(13546628
          -58709229*y+95512344*y**2-62747978*y**3-12826120*y**4+65626674*y**5
          -74365612*y**6+48658242*y**7-16017164*y**8+210745*y**9+1369948*y**10
          -237784*y**11-27336*y**12+6642*y**13)))*nlo.X1El(0,'SR2',y/2,r))/(580608000*logy**4*r**16*(
          -1+y)**8+193536000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+24192000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+1344000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +28000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6-120*logy*r**4*(
          -1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(-67+98*y
          -13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3-2*y**4
          +y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)+2*r**2*(
          -1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y-421*y**2
          +40*y**3+73*y**4-32*y**5+9*y**6))-(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(
          -1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1
          +y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(
          -4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y
          +45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)
          +2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5
          -56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(1,'SM',y/2,r))/(1382400*logy**3*r**12*(
          -1+y)**6-800*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +345600*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+28800*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2
          +3*r**4)*(-1+y)**6+120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(
          -1+y)**2-5*r**8*(-67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y
          -18*y**2+22*y**3-2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3
          -16*y**4+2*y**5)+2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(
          -151+482*y-421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(
          -1+r**2+y)**2*(7*r**16*(-1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2
          +27*y**3)-r**12*(-1+y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)
          +2*r**10*(-1+y)**2*(-4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)
          +5*r**8*(13422-43158*y+45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6
          -284*y**7+33*y**8)+2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3
          -2300*y**4+277*y**5-56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436
          -542*y+757*y**2+11016*y**3-25545*y**4+20466*y**5-4753*y**6-652*y**7
          +89*y**8)+(-1+y)**4*(67+134*y+201*y**2+428*y**3-55*y**4-22*y**5
          -89*y**6-156*y**7+92*y**8)-2*r**6*(-17964+49281*y-40854*y**2+5986*y**3
          +8446*y**4-11636*y**5+9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(1,'SR2',y/2,r))/(345600*logy**3*r**12*(
          -1+y)**6-200*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +86400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+7200*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(180*logy*r**4*(3+r**2)*(-1
          +y)**4+3*(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(
          -1+y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(2,'SM',y/2,r))/(11520*logy**2*r**8*(-1+y)**4+1920*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +80*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(-180*logy*r**4*(3+r**2)*(-1+y)**4-3*(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(2,'SR2',y/2,r))/(2880*logy**2*r**8*(
          -1+y)**4+480*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2)-(api*(-1+y)**2*nlo.X1El(3,'SM',y/2,r))/(48*logy*r**4*(
          -1+y)**2+4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
          )
      resNP += ((api*(-1+y)**2*nlo.X1El(3,'SR2',y/2,r))/(12*logy*r**4*(-1+y)**2-r**8*(
          -1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.SR2

    if wc.VL2 != 0:
      resNP = 0
      resNP +=((api*(-4536000*logy**3*r**12*(19+19*r**2+11*r**4+3*r**6)*(-1+y)**8-10800*logy**2*r**8*(
          -1+y)**6*(175*r**12*(-1+y)**2+255*r**14*(-1+y)**2-7*r**10*(-897+1254*y
          -87*y**2-340*y**3+90*y**4)+35*r**8*(405-414*y-189*y**2+204*y**3-38*y**4
          +8*y**5)-35*r**2*(-1+y)**2*(213-5*y**4-32*y**5+4*y**6)+35*r**6*(275
          +134*y-751*y**2+196*y**3+143*y**4-82*y**5+25*y**6)+35*r**4*(-669
          +2022*y-1695*y**2+52*y**3+495*y**4-282*y**5+77*y**6)+(-1+y)**3*(
          -361-361*y-361*y**2-4001*y**3+3804*y**4-900*y**5+80*y**6))-180*logy*r**4*(
          -1+y)**4*(-1+r**2+y)**2*(355*r**18*(-1+y)**4-r**16*(-1+y)**2*(-1153
          +3016*y-2573*y**2+1470*y**3)-r**14*(-1+y)**2*(-64706+101828*y-25903*y**2
          -10734*y**3+1755*y**4)+r**12*(-1+y)**2*(8214-66656*y+94159*y**2-16866*y**3
          -12551*y**4+5180*y**5)+r**10*(692212-2030424*y+1848647*y**2-169180*y**3
          -586485*y**4+241888*y**5+27709*y**6-25452*y**7+2485*y**8)+r**2*(-1
          +y)**3*(19399+17793*y+16187*y**2+142341*y**3-189095*y**4+52111*y**5
          -17483*y**6+7323*y**7+1544*y**8+280*y**9)-5*r**8*(-436732+1374912*y
          -1414175*y**2+301728*y**3+420651*y**4-337498*y**5+90783*y**6+5140*y**7
          -8743*y**8+1414*y**9)-(-1+y)**4*(-803-1606*y-2409*y**2-13492*y**3
          +4295*y**4-1662*y**5-7059*y**6+18944*y**7-10248*y**8+1440*y**9)+r**4*(
          -1+y)**2*(115834+6128*y-13123*y**2-627214*y**3+1390935*y**4-1107204*y**5
          +299327*y**6+34778*y**7-29781*y**8+5920*y**9)+r**6*(883662-2380808*y
          +1934387*y**2-460068*y**3+323372*y**4-509292*y**5+263858*y**6-41212*y**7
          -26282*y**8+12628*y**9-245*y**10))+3*(-1+y)**2*(-1+r**2+y)**3*(23*r**24*(
          -1+y)**6+r**22*(-1+y)**4*(-1636+3203*y-1498*y**2+611*y**3)-r**20*(
          -1+y)**2*(53282-196667*y+264360*y**2-147190*y**3+20590*y**4+6593*y**5
          +32*y**6)-5*r**18*(-1+y)**2*(-10084+25495*y-2964*y**2-59086*y**3+67984*y**4
          -18137*y**5-3136*y**6+768*y**7)-5*r**16*(-1+y)**2*(981683-3134849*y
          +3304164*y**2-878638*y**3-577695*y**4+335767*y**5-23846*y**6-7224*y**7
          +78*y**8)+2*r**14*(-1+y)**2*(5042852-15034913*y+12846762*y**2+344847*y**3
          -4593008*y**4+1133298*y**5+522238*y**6-184337*y**7-20172*y**8+5433*y**9)
          +r**4*(-1+y)**4*(239598+215739*y+172968*y**2+711145*y**3-1068910*y**4
          -13636*y**5-698198*y**6+2381464*y**7-2629420*y**8+1381385*y**9-259362*y**10
          -13441*y**11+668*y**12)+5*r**6*(-1+y)**3*(61652+93801*y-18903*y**2
          -1950935*y**3+5284025*y**4-5051584*y**5+1856368*y**6+72856*y**7-504180*y**8
          +374135*y**9-110233*y**10+4191*y**11+807*y**12)-(-1+y)**6*(-863-2589*y
          -5178*y**2-18310*y**3-7640*y**4-6544*y**5-7722*y**6+26426*y**7-4265*y**8
          +1565*y**9-668*y**10-3764*y**11+1552*y**12)-5*r**8*(-1+y)**2*(1495819
          -2607070*y+733134*y**2-3703654*y**3+14693541*y**4-21082902*y**5+14135366*y**6
          -3338562*y**7-900021*y**8+514084*y**9-5492*y**10-19896*y**11+1653*y**12)
          +2*r**12*(-24565894+116636943*y-212534784*y**2+167628370*y**3-16908815*y**4
          -61310837*y**5+33962579*y**6+2466173*y**7-7236645*y**8+1921290*y**9
          +4081*y**10-50547*y**11+2086*y**12)-r**2*(-1+y)**5*(-24876-47163*y
          -66861*y**2-298290*y**3+176270*y**4-4768*y**5-46084*y**6+399422*y**7
          -301510*y**8+50555*y**9-6031*y**10-2428*y**11+3764*y**12)-2*r**10*(13546628
          -58709229*y+95512344*y**2-62747978*y**3-12826120*y**4+65626674*y**5
          -74365612*y**6+48658242*y**7-16017164*y**8+210745*y**9+1369948*y**10
          -237784*y**11-27336*y**12+6642*y**13)))*nlo.X1El(0,'SM',y/2,r))/(580608000*logy**4*r**16*(
          -1+y)**8+193536000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+24192000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+1344000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +28000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(1512000*logy**3*r**12*(19+19*r**2+11*r**4+3*r**6)*(-1+y)**8+3600*logy**2*r**8*(
          -1+y)**6*(175*r**12*(-1+y)**2+255*r**14*(-1+y)**2-7*r**10*(-897+1254*y
          -87*y**2-340*y**3+90*y**4)+35*r**8*(405-414*y-189*y**2+204*y**3-38*y**4
          +8*y**5)-35*r**2*(-1+y)**2*(213-5*y**4-32*y**5+4*y**6)+35*r**6*(275
          +134*y-751*y**2+196*y**3+143*y**4-82*y**5+25*y**6)+35*r**4*(-669
          +2022*y-1695*y**2+52*y**3+495*y**4-282*y**5+77*y**6)+(-1+y)**3*(
          -361-361*y-361*y**2-4001*y**3+3804*y**4-900*y**5+80*y**6))+60*logy*r**4*(
          -1+y)**4*(-1+r**2+y)**2*(355*r**18*(-1+y)**4-r**16*(-1+y)**2*(-1153
          +3016*y-2573*y**2+1470*y**3)-r**14*(-1+y)**2*(-64706+101828*y-25903*y**2
          -10734*y**3+1755*y**4)+r**12*(-1+y)**2*(8214-66656*y+94159*y**2-16866*y**3
          -12551*y**4+5180*y**5)+r**10*(692212-2030424*y+1848647*y**2-169180*y**3
          -586485*y**4+241888*y**5+27709*y**6-25452*y**7+2485*y**8)+r**2*(-1
          +y)**3*(19399+17793*y+16187*y**2+142341*y**3-189095*y**4+52111*y**5
          -17483*y**6+7323*y**7+1544*y**8+280*y**9)-5*r**8*(-436732+1374912*y
          -1414175*y**2+301728*y**3+420651*y**4-337498*y**5+90783*y**6+5140*y**7
          -8743*y**8+1414*y**9)-(-1+y)**4*(-803-1606*y-2409*y**2-13492*y**3
          +4295*y**4-1662*y**5-7059*y**6+18944*y**7-10248*y**8+1440*y**9)+r**4*(
          -1+y)**2*(115834+6128*y-13123*y**2-627214*y**3+1390935*y**4-1107204*y**5
          +299327*y**6+34778*y**7-29781*y**8+5920*y**9)+r**6*(883662-2380808*y
          +1934387*y**2-460068*y**3+323372*y**4-509292*y**5+263858*y**6-41212*y**7
          -26282*y**8+12628*y**9-245*y**10))-(-1+y)**2*(-1+r**2+y)**3*(23*r**24*(
          -1+y)**6+r**22*(-1+y)**4*(-1636+3203*y-1498*y**2+611*y**3)-r**20*(
          -1+y)**2*(53282-196667*y+264360*y**2-147190*y**3+20590*y**4+6593*y**5
          +32*y**6)-5*r**18*(-1+y)**2*(-10084+25495*y-2964*y**2-59086*y**3+67984*y**4
          -18137*y**5-3136*y**6+768*y**7)-5*r**16*(-1+y)**2*(981683-3134849*y
          +3304164*y**2-878638*y**3-577695*y**4+335767*y**5-23846*y**6-7224*y**7
          +78*y**8)+2*r**14*(-1+y)**2*(5042852-15034913*y+12846762*y**2+344847*y**3
          -4593008*y**4+1133298*y**5+522238*y**6-184337*y**7-20172*y**8+5433*y**9)
          +r**4*(-1+y)**4*(239598+215739*y+172968*y**2+711145*y**3-1068910*y**4
          -13636*y**5-698198*y**6+2381464*y**7-2629420*y**8+1381385*y**9-259362*y**10
          -13441*y**11+668*y**12)+5*r**6*(-1+y)**3*(61652+93801*y-18903*y**2
          -1950935*y**3+5284025*y**4-5051584*y**5+1856368*y**6+72856*y**7-504180*y**8
          +374135*y**9-110233*y**10+4191*y**11+807*y**12)-(-1+y)**6*(-863-2589*y
          -5178*y**2-18310*y**3-7640*y**4-6544*y**5-7722*y**6+26426*y**7-4265*y**8
          +1565*y**9-668*y**10-3764*y**11+1552*y**12)-5*r**8*(-1+y)**2*(1495819
          -2607070*y+733134*y**2-3703654*y**3+14693541*y**4-21082902*y**5+14135366*y**6
          -3338562*y**7-900021*y**8+514084*y**9-5492*y**10-19896*y**11+1653*y**12)
          +2*r**12*(-24565894+116636943*y-212534784*y**2+167628370*y**3-16908815*y**4
          -61310837*y**5+33962579*y**6+2466173*y**7-7236645*y**8+1921290*y**9
          +4081*y**10-50547*y**11+2086*y**12)-r**2*(-1+y)**5*(-24876-47163*y
          -66861*y**2-298290*y**3+176270*y**4-4768*y**5-46084*y**6+399422*y**7
          -301510*y**8+50555*y**9-6031*y**10-2428*y**11+3764*y**12)-2*r**10*(13546628
          -58709229*y+95512344*y**2-62747978*y**3-12826120*y**4+65626674*y**5
          -74365612*y**6+48658242*y**7-16017164*y**8+210745*y**9+1369948*y**10
          -237784*y**11-27336*y**12+6642*y**13)))*nlo.X1El(0,'VL',y/2,r))/(290304000*logy**4*r**16*(
          -1+y)**8+96768000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+12096000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+672000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +14000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-1512000*logy**3*r**12*(19+19*r**2+11*r**4+3*r**6)*(-1+y)**8-3600*logy**2*r**8*(
          -1+y)**6*(175*r**12*(-1+y)**2+255*r**14*(-1+y)**2-7*r**10*(-897+1254*y
          -87*y**2-340*y**3+90*y**4)+35*r**8*(405-414*y-189*y**2+204*y**3-38*y**4
          +8*y**5)-35*r**2*(-1+y)**2*(213-5*y**4-32*y**5+4*y**6)+35*r**6*(275
          +134*y-751*y**2+196*y**3+143*y**4-82*y**5+25*y**6)+35*r**4*(-669
          +2022*y-1695*y**2+52*y**3+495*y**4-282*y**5+77*y**6)+(-1+y)**3*(
          -361-361*y-361*y**2-4001*y**3+3804*y**4-900*y**5+80*y**6))-60*logy*r**4*(
          -1+y)**4*(-1+r**2+y)**2*(355*r**18*(-1+y)**4-r**16*(-1+y)**2*(-1153
          +3016*y-2573*y**2+1470*y**3)-r**14*(-1+y)**2*(-64706+101828*y-25903*y**2
          -10734*y**3+1755*y**4)+r**12*(-1+y)**2*(8214-66656*y+94159*y**2-16866*y**3
          -12551*y**4+5180*y**5)+r**10*(692212-2030424*y+1848647*y**2-169180*y**3
          -586485*y**4+241888*y**5+27709*y**6-25452*y**7+2485*y**8)+r**2*(-1
          +y)**3*(19399+17793*y+16187*y**2+142341*y**3-189095*y**4+52111*y**5
          -17483*y**6+7323*y**7+1544*y**8+280*y**9)-5*r**8*(-436732+1374912*y
          -1414175*y**2+301728*y**3+420651*y**4-337498*y**5+90783*y**6+5140*y**7
          -8743*y**8+1414*y**9)-(-1+y)**4*(-803-1606*y-2409*y**2-13492*y**3
          +4295*y**4-1662*y**5-7059*y**6+18944*y**7-10248*y**8+1440*y**9)+r**4*(
          -1+y)**2*(115834+6128*y-13123*y**2-627214*y**3+1390935*y**4-1107204*y**5
          +299327*y**6+34778*y**7-29781*y**8+5920*y**9)+r**6*(883662-2380808*y
          +1934387*y**2-460068*y**3+323372*y**4-509292*y**5+263858*y**6-41212*y**7
          -26282*y**8+12628*y**9-245*y**10))+(-1+y)**2*(-1+r**2+y)**3*(23*r**24*(
          -1+y)**6+r**22*(-1+y)**4*(-1636+3203*y-1498*y**2+611*y**3)-r**20*(
          -1+y)**2*(53282-196667*y+264360*y**2-147190*y**3+20590*y**4+6593*y**5
          +32*y**6)-5*r**18*(-1+y)**2*(-10084+25495*y-2964*y**2-59086*y**3+67984*y**4
          -18137*y**5-3136*y**6+768*y**7)-5*r**16*(-1+y)**2*(981683-3134849*y
          +3304164*y**2-878638*y**3-577695*y**4+335767*y**5-23846*y**6-7224*y**7
          +78*y**8)+2*r**14*(-1+y)**2*(5042852-15034913*y+12846762*y**2+344847*y**3
          -4593008*y**4+1133298*y**5+522238*y**6-184337*y**7-20172*y**8+5433*y**9)
          +r**4*(-1+y)**4*(239598+215739*y+172968*y**2+711145*y**3-1068910*y**4
          -13636*y**5-698198*y**6+2381464*y**7-2629420*y**8+1381385*y**9-259362*y**10
          -13441*y**11+668*y**12)+5*r**6*(-1+y)**3*(61652+93801*y-18903*y**2
          -1950935*y**3+5284025*y**4-5051584*y**5+1856368*y**6+72856*y**7-504180*y**8
          +374135*y**9-110233*y**10+4191*y**11+807*y**12)-(-1+y)**6*(-863-2589*y
          -5178*y**2-18310*y**3-7640*y**4-6544*y**5-7722*y**6+26426*y**7-4265*y**8
          +1565*y**9-668*y**10-3764*y**11+1552*y**12)-5*r**8*(-1+y)**2*(1495819
          -2607070*y+733134*y**2-3703654*y**3+14693541*y**4-21082902*y**5+14135366*y**6
          -3338562*y**7-900021*y**8+514084*y**9-5492*y**10-19896*y**11+1653*y**12)
          +2*r**12*(-24565894+116636943*y-212534784*y**2+167628370*y**3-16908815*y**4
          -61310837*y**5+33962579*y**6+2466173*y**7-7236645*y**8+1921290*y**9
          +4081*y**10-50547*y**11+2086*y**12)-r**2*(-1+y)**5*(-24876-47163*y
          -66861*y**2-298290*y**3+176270*y**4-4768*y**5-46084*y**6+399422*y**7
          -301510*y**8+50555*y**9-6031*y**10-2428*y**11+3764*y**12)-2*r**10*(13546628
          -58709229*y+95512344*y**2-62747978*y**3-12826120*y**4+65626674*y**5
          -74365612*y**6+48658242*y**7-16017164*y**8+210745*y**9+1369948*y**10
          -237784*y**11-27336*y**12+6642*y**13)))*nlo.X1El(0,'VL2',y/2,r))/(580608000*logy**4*r**16*(
          -1+y)**8+193536000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+24192000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+1344000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +28000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(10800*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6+360*logy*r**4*(
          -1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(-67+98*y
          -13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3-2*y**4
          +y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)+2*r**2*(
          -1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y-421*y**2
          +40*y**3+73*y**4-32*y**5+9*y**6))+3*(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(
          -1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1
          +y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(
          -4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y
          +45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)
          +2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5
          -56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(1,'SM',y/2,r))/(345600*logy**3*r**12*(
          -1+y)**6-200*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +86400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+7200*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-3600*logy**2*r**8*(15+10*r**2
          +3*r**4)*(-1+y)**6-120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(
          -1+y)**2-5*r**8*(-67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y
          -18*y**2+22*y**3-2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3
          -16*y**4+2*y**5)+2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(
          -151+482*y-421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))-(-1+y)**2*(
          -1+r**2+y)**2*(7*r**16*(-1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2
          +27*y**3)-r**12*(-1+y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)
          +2*r**10*(-1+y)**2*(-4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)
          +5*r**8*(13422-43158*y+45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6
          -284*y**7+33*y**8)+2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3
          -2300*y**4+277*y**5-56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436
          -542*y+757*y**2+11016*y**3-25545*y**4+20466*y**5-4753*y**6-652*y**7
          +89*y**8)+(-1+y)**4*(67+134*y+201*y**2+428*y**3-55*y**4-22*y**5
          -89*y**6-156*y**7+92*y**8)-2*r**6*(-17964+49281*y-40854*y**2+5986*y**3
          +8446*y**4-11636*y**5+9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(1,'VL',y/2,r))/(172800*logy**3*r**12*(
          -1+y)**6-100*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +43200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+3600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2
          +3*r**4)*(-1+y)**6+120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(
          -1+y)**2-5*r**8*(-67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y
          -18*y**2+22*y**3-2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3
          -16*y**4+2*y**5)+2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(
          -151+482*y-421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(
          -1+r**2+y)**2*(7*r**16*(-1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2
          +27*y**3)-r**12*(-1+y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)
          +2*r**10*(-1+y)**2*(-4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)
          +5*r**8*(13422-43158*y+45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6
          -284*y**7+33*y**8)+2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3
          -2300*y**4+277*y**5-56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436
          -542*y+757*y**2+11016*y**3-25545*y**4+20466*y**5-4753*y**6-652*y**7
          +89*y**8)+(-1+y)**4*(67+134*y+201*y**2+428*y**3-55*y**4-22*y**5
          -89*y**6-156*y**7+92*y**8)-2*r**6*(-17964+49281*y-40854*y**2+5986*y**3
          +8446*y**4-11636*y**5+9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(1,'VL2',y/2,r))/(345600*logy**3*r**12*(
          -1+y)**6-200*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +86400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+7200*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-540*logy*r**4*(3+r**2)*(-1
          +y)**4-9*(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(
          -1+y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(2,'SM',y/2,r))/(2880*logy**2*r**8*(-1+y)**4+480*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(180*logy*r**4*(3+r**2)*(-1+y)**4+3*(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(2,'VL',y/2,r))/(1440*logy**2*r**8*(
          -1+y)**4+240*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-180*logy*r**4*(3+r**2)*(-1+y)**4
          -3*(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(
          -5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y
          -13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(2,'VL2',y/2,r))/(2880*logy**2*r**8*(
          -1+y)**4+480*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2)+(3*api*(-1+y)**2*nlo.X1El(3,'SM',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -(2*api*(-1+y)**2*nlo.X1El(3,'VL',y/2,r))/(12*logy*r**4*(-1+y)**2-r**8*(
          -1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      resNP += ((api*(-1+y)**2*nlo.X1El(3,'VL2',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.VL2

    if wc.SLSR != 0:
      resNP = 0
      resNP +=((18144000*logy**4*r**15*(3+5*r**2+6*r**4+5*r**6+3*r**8)*(-1+y)**8+43200*logy**3*r**11*(
          -1+y)**6*(654*r**14*(-1+y)**2+255*r**16*(-1+y)**2-14*r**12*(-431+502*y
          +109*y**2-260*y**3+45*y**4)+70*r**10*(49+22*y-131*y**2+76*y**3-10*y**4
          +4*y**5)+5*(-1+y)**4*(-51-102*y-153*y**2+272*y**3-108*y**4+16*y**5)
          +35*r**8*y*(288-432*y+60*y**2+183*y**3-110*y**4+25*y**5)-14*r**4*(
          -1+y)**2*(431-360*y-180*y**2+180*y**3+5*y**4-56*y**5+10*y**6)+70*r**6*(
          -49+218*y-229*y**2-28*y**3+161*y**4-94*y**5+21*y**6)+2*r**2*(-1
          +y)**3*(327+327*y+327*y**2-1353*y**3+1272*y**4-380*y**5+40*y**6))
          +720*logy**2*r**7*(-1+y)**4*(-1+r**2+y)**2*(355*r**20*(-1+y)**4-2*r**18*(
          -1+y)**2*(-2981+6317*y-3691*y**2+735*y**3)-r**16*(-1+y)**2*(-86699
          +140132*y-44182*y**2-11156*y**3+1755*y**4)+4*r**14*(-1+y)**2*(33314
          -60756*y+29814*y**2+9734*y**3-6926*y**4+1295*y**5)-5*(-1+y)**6*(
          -71-284*y-710*y**2-732*y**3+385*y**4+1920*y**5-1496*y**6+288*y**7)
          -r**8*(-1+y)**2*(-875618+1006716*y+35262*y**2-399460*y**3-55425*y**4
          +155008*y**5-28036*y**6-7392*y**7+245*y**8)+r**4*(-1+y)**4*(86699+140132*y
          +184314*y**2-519020*y**3+307265*y**4-30004*y**5-20682*y**6+5016*y**7
          +280*y**8)-2*r**2*(-1+y)**5*(2981+9298*y+19306*y**2-8980*y**3-535*y**4
          -15286*y**5+16032*y**6-6036*y**7+720*y**8)+4*r**6*(-1+y)**3*(-33314
          -27442*y-29814*y**2+225880*y**3-210320*y**4+50239*y**5+18562*y**6
          -10321*y**7+1480*y**8)+r**12*(875618-2495756*y+2198298*y**2+15580*y**3
          -1030835*y**4+469812*y**5-15434*y**6-18368*y**7+2485*y**8)-10*r**10*(
          -112262+336786*y-312016*y**2-35502*y**3+253087*y**4-159185*y**5+17376*y**6
          +18282*y**7-7273*y**8+707*y**9))+12*logy*r**3*(-1+y)**4*(-1+r**2+y)**3*(
          -23*r**26*(-1+y)**4-r**24*(-1+y)**2*(-3133+6197*y-2995*y**2+611*y**3)
          +2*r**22*(76629-289881*y+403815*y**2-246210*y**3+56870*y**4-739*y**5
          +16*y**6)+(-1+y)**9*(23+184*y+828*y**2+2220*y**3+2385*y**4-2648*y**5
          -2444*y**6+1552*y**7)+r**20*(959802-3550272*y+4872810*y**2-3009270*y**3
          +714220*y**4+56318*y**5-42248*y**6+3840*y**7)+5*r**18*(1663455-5091138*y
          +5107956*y**2-1048588*y**3-1239885*y**4+659370*y**5-56672*y**6-3536*y**7
          +78*y**8)+r**16*(2486271-11092779*y+20175996*y**2-11574184*y**3-6344209*y**4
          +9127829*y**5-2831696*y**6+93304*y**7+124334*y**8-10866*y**9)+4*r**14*(13652071
          -30491371*y+14420529*y**2+16436514*y**3-17888981*y**4+1278122*y**5
          +4169546*y**6-1441654*y**7+85336*y**8+24181*y**9-1043*y**10)-2*r**6*(
          -1+y)**4*(-479901-1295235*y-2436405*y**2+2960540*y**3-1005865*y**4
          +1537992*y**5-1954765*y**6+849680*y**7-110290*y**8-8585*y**9+334*y**10)
          -5*r**8*(-1+y)**3*(1663455+1764228*y+1680273*y**2-11498712*y**3+9055028*y**4
          -480332*y**5-2095868*y**6+837952*y**7-79063*y**8-10568*y**9+807*y**10)
          +r**2*(-1+y)**6*(3133+15596*y+46581*y**2+86106*y**3+18831*y**4-147960*y**5
          +46579*y**6-16206*y**7+26244*y**8-10456*y**9+1552*y**10)+2*r**4*(-1
          +y)**5*(-76629-289881*y-693696*y**2-342781*y**3+343274*y**4+1274397*y**5
          -1218794*y**6+316221*y**7+18631*y**8-15124*y**9+1882*y**10)+r**10*(
          -1+y)**2*(2486271+3633966*y+5449251*y**2-44281684*y**3+50060916*y**4
          -10065636*y**5-8464816*y**6+3767124*y**7-172391*y**8-69266*y**9+8265*y**10)
          +4*r**12*(13652071-37768984*y+28975755*y**2+17441955*y**3-42235475*y**4
          +22634753*y**5+358338*y**6-4335980*y**7+1343470*y**8-41275*y**9-27949*y**10
          +3321*y**11))-r*(-1+y)**2*(-1+r**2+y)**4*(11*r**28*(-1+y)**6+2*r**26*(
          -1+y)**4*(64-12*y-99*y**2+62*y**3)+r**24*(-1+y)**2*(-137663+512776*y
          -694128*y**2+425652*y**3-123903*y**4+13540*y**5+606*y**6)+2*r**22*(
          -1056216+5674136*y-12386346*y**2+13861178*y**3-8030117*y**4+1837506*y**5
          +255284*y**6-163254*y**7+8427*y**8+802*y**9)-(-1+y)**10*(-11-88*y
          -396*y**2-1944*y**3-2722*y**4+2192*y**5+1068*y**6-1624*y**7+549*y**8
          +152*y**9+24*y**10)+r**20*(-4657909+23553238*y-48724099*y**2+52324784*y**3
          -29055878*y**4+4884028*y**5+3360382*y**6-2134256*y**7+508811*y**8-72402*y**9
          +2101*y**10)-2*r**2*(-1+y)**8*(-64-268*y-601*y**2+23704*y**3+44379*y**4
          +22382*y**5-95355*y**6-55424*y**7+106221*y**8-32854*y**9+1732*y**10
          +148*y**11)-2*r**18*(30490976-140160916*y+246164665*y**2-178347140*y**3
          -10616045*y**4+102405998*y**5-62794823*y**6+12157560*y**7+1251665*y**8
          -619030*y**9+59826*y**10+264*y**11)-r**4*(-1+y)**7*(-137663-650439*y
          -1857343*y**2-2202523*y**3-2698*y**4+4178318*y**5-2324730*y**6+506118*y**7
          -105927*y**8+69673*y**9-22455*y**10+1669*y**11)-2*r**6*(-1+y)**6*(1056216
          +3561704*y+7768426*y**2+40786*y**3-4540589*y**4-12024726*y**5+15713133*y**6
          -4801476*y**7-353311*y**8+364114*y**9-53115*y**10+2838*y**11)-4*r**14*(
          -1+y)**2*(106429256-212858512*y+65363586*y**2+158063546*y**3-137939579*y**4
          +489454*y**5+34665615*y**6-9039436*y**7-1038571*y**8+647154*y**9-54935*y**10
          +4422*y**11)-2*r**10*(-1+y)**4*(30490976+18197012*y+8627773*y**2-191623022*y**3
          +189615758*y**4-7585204*y**5-55763136*y**6+22682452*y**7-1742978*y**8
          -282208*y**9+7303*y**10+10274*y**11)-r**8*(-1+y)**5*(-4657909-9579511*y
          -15591350*y**2+64989010*y**3-46308370*y**4+7352978*y**5+6239772*y**6
          -883100*y**7-1204385*y**8+545645*y**9-103694*y**10+12914*y**11)-r**12*(
          -1+y)**3*(81164329-47358347*y-61007109*y**2-57512129*y**3+145233746*y**4
          -53090422*y**5-17764770*y**6+20070934*y**7-4805771*y**8+618129*y**9
          -55657*y**10+23067*y**11)+r**16*(81164329-358463298*y+561202793*y**2
          -288346520*y**3-159003650*y**4+260614332*y**5-116557094*y**6+22459984*y**7
          -5222355*y**8+3116150*y**9-1047811*y**10+91192*y**11-8052*y**12)))/(580608000*logy**4*r**16*(
          -1+y)**8+193536000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+24192000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+1344000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +28000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-217728000*logy**5*r**19*(-3+5*r**2+18*r**4+25*r**6+21*r**8)*(
          -1+y)**10-518400*logy**4*r**15*(-1+y)**8*(3750*r**16*(-1+y)**2+r**14*(6971
          -13942*y+6971*y**2+210*y**3)-14*r**12*(-2912+2674*y+1813*y**2-2210*y**3
          +315*y**4)+175*r**10*(-7+314*y-457*y**2+212*y**3-56*y**4+26*y**5)
          -50*(-1+y)**3*(57+57*y+57*y**2-244*y**3+190*y**4-62*y**5+8*y**6)
          +70*r**8*(-340+1220*y-1150*y**2+175*y**3+317*y**4-238*y**5+72*y**6)
          +35*r**6*(-737+1774*y-1187*y**2-50*y**3+583*y**4-476*y**5+147*y**6)
          -r**2*(-1+y)**2*(943+14560*y**3-18725*y**4+9912*y**5-2520*y**6+240*y**7)
          +14*r**4*(-184-82*y+491*y**2-210*y**3+440*y**4-801*y**5+412*y**6
          -76*y**7+10*y**8))-17280*logy**3*r**11*(-1+y)**6*(-1+r**2+y)**2*(5850*r**20*(
          -1+y)**4-r**18*(-1+y)**2*(-72583+156866*y-95983*y**2+20465*y**3)
          -r**16*(-1+y)**2*(-741876+1190618*y-398158*y**2-62129*y**3+2965*y**4)
          +r**14*(1013744-3959074*y+5919965*y**2-3711320*y**3+171300*y**4+896226*y**5
          -384461*y**6+56070*y**7)+35*(-1+y)**5*(246+738*y+1476*y**2-253*y**3
          -1162*y**4-2295*y**5+3626*y**6-1634*y**7+248*y**8)-2*r**12*(-1693211
          +4649297*y-4137246*y**2+451020*y**3+1421455*y**4-928399*y**5+309408*y**6
          -90279*y**7+10255*y**8)+r**6*(-1+y)**2*(51064-456902*y-234653*y**2
          +3729116*y**3-4954405*y**4+2425366*y**5-298943*y**6-113792*y**7+23489*y**8
          +3960*y**9)-2*r**4*(-1+y)**3*(-231852-111019*y-88601*y**2+1109682*y**3
          -1155315*y**4+545202*y**5-227381*y**6+127776*y**7-46257*y**8+6015*y**9)
          -5*r**10*(-533790+1433974*y-1083583*y**2-624082*y**3+1646249*y**4-1052972*y**5
          +105213*y**6+170339*y**7-70343*y**8+6545*y**9)+r**2*(-1+y)**4*(-41557
          -100334*y-176331*y**2+197747*y**3+13145*y**4+245127*y**5-481611*y**6
          +303096*y**7-80672*y**8+7640*y**9)+r**8*(889382-2213818*y+808892*y**2
          +4744922*y**3-9789178*y**4+8058358*y**5-2013732*y**6-1347567*y**7+1172603*y**8
          -353997*y**9+44135*y**10))-288*logy**2*r**7*(-1+y)**4*(-1+r**2+y)**3*(669*r**26*(
          -1+y)**6-r**24*(-1+y)**4*(-118314+238635*y-122328*y**2+25912*y**3)
          +r**22*(-1+y)**2*(3167785-11975089*y+16753020*y**2-10415430*y**3+2633185*y**4
          -163425*y**5+26454*y**6)+r**20*(-1+y)**2*(15589697-58101152*y+81125520*y**2
          -51480280*y**3+12295665*y**4+1624808*y**5-1143358*y**6+120650*y**7)
          -5*r**18*(-1+y)**2*(-18466988+55662707*y-55831650*y**2+13544638*y**3
          +10603714*y**4-6287825*y**5+1049118*y**6-236132*y**7+31298*y**8)-(
          -1+y)**8*(6063+30315*y+90945*y**2+143090*y**3+80475*y**4-173951*y**5
          -202665*y**6-19220*y**7+334410*y**8-202250*y**9+35288*y**10)+r**16*(46245657
          -280978617*y+721782105*y**2-919197130*y**3+436678695*y**4+278084151*y**5
          -480834901*y**6+240888970*y**7-37438720*y**8-8517570*y**9+3532192*y**10
          -237832*y**11)+r**4*(-1+y)**6*(-3345211-8987232*y-16688940*y**2+10693540*y**3
          +12777260*y**4+23309612*y**5-50514186*y**6+28623440*y**7-5548365*y**8
          -154310*y**9+101674*y**10+6218*y**11)-5*r**8*(-1+y)**4*(11502308-1898611*y
          -1819120*y**2-50284312*y**3+78291632*y**4-44334412*y**5+9881548*y**6
          +226730*y**7-1220008*y**8+798633*y**9-221456*y**10+11568*y**11)-r**2*(
          -1+y)**7*(-161070-662469*y-1701645*y**2-1099015*y**3+358515*y**4+3185615*y**5
          -1525767*y**6+586395*y**7-1596885*y**8+1288110*y**9-392720*y**10+40936*y**11)
          +2*r**12*(-1+y)**2*(69275405-133172846*y+1040115*y**2+265979180*y**3
          -323162495*y**4+80477520*y**5+113588437*y**6-89772815*y**7+17157020*y**8
          +3425245*y**9-1409850*y**10+136334*y**11)+r**6*(-1+y)**5*(4985051+11477074*y
          +20380875*y**2-44879090*y**3+7535340*y**4-51188752*y**5+115984152*y**6
          -82748400*y**7+20834365*y**8+1283010*y**9-1375099*y**10+175474*y**11)
          -r**10*(-1+y)**3*(49005141-114721545*y-2397465*y**2+445650725*y**3
          -660713610*y**4+298317888*y**5+85588070*y**6-122963360*y**7+31831025*y**8
          +3928485*y**9-2839229*y**10+261875*y**11)+2*r**14*(109977961-426210609*y
          +598273968*y**2-264236790*y**3-199371795*y**4+288817653*y**5-122776787*y**6
          +8618729*y**7+13624740*y**8-11120080*y**9+5710061*y**10-1474379*y**11
          +167328*y**12))-12*logy*r**3*(-1+y)**4*(-1+r**2+y)**4*(69*r**32*(-1+y)**6
          +r**30*(-1+y)**4*(-5181+10086*y-4629*y**2+910*y**3)+2*r**28*(-1+y)**2*(217572
          -844008*y+1208685*y**2-796093*y**3+250841*y**4-33535*y**5+3158*y**6)
          +r**26*(14514773-83097582*y+196451973*y**2-248020986*y**3+180551617*y**4
          -76011548*y**5+17132107*y**6-1463878*y**7-70654*y**8+178*y**9)+r**24*(146352860
          -780131516*y+1692810174*y**2-1890025322*y**3+1102554407*y**4-264630208*y**5
          -27308279*y**6+22744626*y**7-2863463*y**8+443668*y**9-40947*y**10)+3*(
          -1+y)**11*(-23-207*y-1035*y**2-3209*y**3-5249*y**4-1129*y**5+4927*y**6
          +5925*y**7-1756*y**8-3996*y**9+1552*y**10)+r**22*(323369043-1679334598*y
          +3602060705*y**2-4025291722*y**3+2260869658*y**4-208832576*y**5-525519870*y**6
          +324158270*y**7-77665293*y**8+6100662*y**9+527413*y**10-27292*y**11)
          +2*r**20*(1070224308-4721605544*y+7887558711*y**2-5283712565*y**3-631020121*y**4
          +3063105392*y**5-1688443900*y**6+282976679*y**7+30043735*y**8-11606384*y**9
          +2686245*y**10-481386*y**11+43830*y**12)-r**6*(-1+y)**6*(12879047+48451484*y
          +116459156*y**2+25032582*y**3-50846705*y**4-206117534*y**5+190894492*y**6
          -82901202*y**7+95345261*y**8-79385670*y**9+27739112*y**10-3332276*y**11
          -67979*y**12+232*y**13)+r**2*(-1+y)**8*(-14649-87618*y-305697*y**2
          -681498*y**3-741218*y**4+168370*y**5+1141658*y**6+854386*y**7-1291837*y**8
          +299568*y**9-186321*y**10+208360*y**11-71264*y**12+7760*y**13)+2*r**4*(
          -1+y)**7*(612420+2945748*y+8560599*y**2+10999556*y**3+3835642*y**4
          -17059173*y**5-8250144*y**6+439669*y**7+20416300*y**8-14771417*y**9
          +3249753*y**10+52171*y**11-85418*y**12+9294*y**13)+r**8*(-1+y)**5*(136852196
          +298437944*y+473415734*y**2-776373268*y**3-415559709*y**4-642407881*y**5
          +2321167888*y**6-1642070332*y**7+296905542*y**8+120680834*y**9-59792190*y**10
          +8109968*y**11-207477*y**12+22751*y**13)-r**14*(-1+y)**2*(-2484294705
          +6091052608*y-1651177246*y**2-12337836914*y**3+16585630377*y**4-3636030298*y**5
          -6435083324*y**6+4144917944*y**7+65151105*y**8-708026952*y**9+194307578*y**10
          -10814734*y**11-1977673*y**12+40234*y**13)+r**18*(-950862723+2762654018*y
          -15453047*y**2-6245243566*y**3+3408697062*y**4+6985428478*y**5-9409889794*y**6
          +3434791906*y**7+628322649*y**8-768620412*y**9+181062145*y**10-7446524*y**11
          -882884*y**12+60692*y**13)+2*r**12*(-1+y)**3*(827108244-611921812*y
          -359771423*y**2-2570705756*y**3+6146942587*y**4-3924736436*y**5-488771374*y**6
          +1636171258*y**7-678495906*y**8+70611438*y**9+12083317*y**10-416714*y**11
          -576685*y**12+96262*y**13)+r**10*(-1+y)**4*(78378471-39250750*y-256842083*y**2
          +417379774*y**3-253724376*y**4+1697948302*y**5-3239842886*y**6+2138906180*y**7
          -347185449*y**8-165329074*y**9+57483977*y**10+872086*y**11-1674422*y**12
          +170250*y**13)+r**16*(3555781374-9915875416*y+5266988984*y**2+9321952402*y**3
          -9851297549*y**4-5690391848*y**5+13651916377*y**6-7907840578*y**7+1413193406*y**8
          +205825878*y**9-31100576*y**10-20382336*y**11-807231*y**12+2152042*y**13
          -114929*y**14))-r*(-1+y)**2*(-1+r**2+y)**5*(55*r**34*(-1+y)**8+r**32*(
          -1+y)**6*(-1169+2891*y-1861*y**2+515*y**3)+r**30*(-1+y)**4*(-71688
          +230978*y-241019*y**2+81710*y**3+5480*y**4-9660*y**5+1739*y**6)+r**28*(
          -1+y)**2*(13989368-78411814*y+179753715*y**2-217874419*y**3+151044829*y**4
          -60283689*y**5+12996773*y**6-1364661*y**7+89763*y**8+1175*y**9)+r**26*(147065776
          -1066771378*y+3337324439*y**2-5883029418*y**3+6391698101*y**4-4372256826*y**5
          +1811257308*y**6-377185494*y**7-5007352*y**8+20570364*y**9-3835275*y**10
          +217680*y**11-8725*y**12)+(-1+y)**12*(11+99*y+495*y**2+2417*y**3
          +4974*y**4+2078*y**5-2482*y**6-4358*y**7+2199*y**8+1991*y**9-2349*y**10
          +373*y**11+128*y**12+24*y**13)-r**24*(-914987072+6189236306*y-17808643741*y**2
          +27926204153*y**3-24813074145*y**4+10531144441*y**5+1064266542*y**6-3550943102*y**7
          +1707773462*y**8-369468700*y**9+44192911*y**10-5943643*y**11+328523*y**12
          +26065*y**13)+r**2*(-1+y)**10*(1475+9552*y+35530*y**2-32010*y**3-385125*y**4
          -953460*y**5+340516*y**6+1311040*y**7+511145*y**8-802420*y**9-970190*y**10
          +1006282*y**11-249495*y**12+8440*y**13+720*y**14)+r**4*(-1+y)**9*(760128
          +4378378*y+14777413*y**2+27866194*y**3+23237302*y**4-20033664*y**5
          -32522809*y**6-17969404*y**7+43973404*y**8-17544502*y**9+4056011*y**10
          -2462694*y**11+1053566*y**12-176548*y**13+7225*y**14)-r**22*(-268400208
          +1711048238*y-5373777709*y**2+10796926442*y**3-13841834620*y**4+9274618956*y**5
          +471788059*y**6-6237063452*y**7+4942948616*y**8-1645542530*y**9+105268177*y**10
          +84572178*y**11-21436364*y**12+790792*y**13+9425*y**14)+r**6*(-1+y)**8*(
          -20887424-93357290*y-255121929*y**2-242414574*y**3-8186684*y**4+520893844*y**5
          +45438071*y**6-69001676*y**7-480696536*y**8+436760934*y**9-116014195*y**10
          -2660006*y**11+5432580*y**12-784240*y**13+39125*y**14)+r**8*(-1+y)**7*(80508472
          +260842614*y+569840915*y**2-450974846*y**3-445144694*y**4-1045230298*y**5
          +2128136423*y**6-1423625124*y**7+572765588*y**8-194339206*y**9+66130001*y**10
          -18628062*y**11+4923434*y**12-1180342*y**13+135125*y**14)+r**10*(-1
          +y)**6*(-997350440-1691176054*y-2161565359*y**2+6458255650*y**3+1869540616*y**4
          +2512289854*y**5-16959642473*y**6+13895644552*y**7-2294697416*y**8-1630468478*y**9
          +768549711*y**10-105849498*y**11+6637832*y**12-1702234*y**13+321737*y**14)
          +r**18*(-1+y)**2*(-21464732546+80084335418*y-94166632275*y**2+11006026918*y**3
          +49762915502*y**4-16290011486*y**5-20044465389*y**6+9592091992*y**7+5410988386*y**8
          -4937597702*y**9+1210156907*y**10-49186654*y**11-10484542*y**12+485546*y**13
          +353925*y**14)+r**12*(-1+y)**5*(-2962785336-1299152086*y+822920757*y**2
          +10415132474*y**3-3496526810*y**4-12294826868*y**5+9029674107*y**6+2033454036*y**7
          -3873416148*y**8+966167730*y**9+277409179*y**10-174440046*y**11+36926182*y**12
          -4405576*y**13+548405*y**14)+r**16*(-1+y)**3*(-36057039998+78996220630*y
          -25665244733*y**2-53907218698*y**3+16916999192*y**4+57885030698*y**5
          -49074055893*y**6+3290362788*y**7+11342421858*y**8-5353479742*y**9+1037638625*y**10
          -122180362*y**11+26619220*y**12-3790610*y**13+597025*y**14)+r**14*(-1
          +y)**4*(-15844558024+14193547926*y+7326717511*y**2+38252996058*y**3
          -97714128676*y**4+53843946232*y**5+20577360027*y**6-28618156188*y**7
          +6467116728*y**8+1429901446*y**9-381702483*y**10-155945278*y**11+61356852*y**12
          -6717236*y**13+677105*y**14)+r**20*(12414648592-74537652958*y+182652788711*y**2
          -219150562991*y**3+94072277508*y**4+76732714698*y**5-124636788589*y**6
          +62473124073*y**7-5095455208*y**8-7606391946*y**9+3016296133*y**10-313264053*y**11
          -27675884*y**12+5452574*y**13+376513*y**14+112827*y**15))))/(-5225472000*logy**5*r**20*(
          -1+y)**10+21000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-2177280000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-362880000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-30240000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -1260000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*muWC*(217728000*logy**5*r**19*(-6-5*r**2+5*r**6
          +6*r**8)*(-1+y)**10+518400*logy**4*r**15*(-1+y)**7*(1650*r**16*(-1+y)**3
          +r**14*(-1507+4521*y-4521*y**2-173*y**3+840*y**4)-14*r**12*(682-1146*y
          -204*y**2+1623*y**3-955*y**4+135*y**5)+35*r**10*(193-879*y+1329*y**2
          -993*y**3+330*y**4-68*y**5+20*y**6)-10*(-1+y)**3*(-165+595*y**3-784*y**4
          +378*y**5-70*y**6+4*y**7)+70*r**8*(170-510*y+510*y**2-145*y**3-223*y**4
          +289*y**5-146*y**6+28*y**7)+r**2*(-1+y)**3*(1507-6230*y**3+5075*y**4
          -1652*y**5+40*y**7)+35*r**6*(193-279*y-171*y**2+477*y**3-503*y**4
          +459*y**5-247*y**6+47*y**7)-14*r**4*(682-2946*y+4296*y**2-2437*y**3
          +315*y**4+73*y**5-49*y**6+114*y**7-58*y**8+10*y**9))+86400*logy**3*r**11*(
          -1+y)**5*(-1+r**2+y)**2*(723*r**20*(-1+y)**5-r**18*(-1+y)**2*(5707
          -18567*y+21459*y**2-9009*y**3+1354*y**4)-r**16*(-1+y)**2*(60279-154097*y
          +122586*y**2-15539*y**3-12603*y**4+1760*y**5)+r**14*(-48134+258720*y
          -571533*y**2+560707*y**3-154096*y**4-131510*y**5+114907*y**6-34885*y**7
          +4354*y**8)+r**10*y*(-83698+292943*y-714609*y**2+1163617*y**3-988421*y**4
          +283353*y**5+152425*y**6-143235*y**7+39767*y**8-3612*y**9)+(-1+y)**5*(
          -723-1446*y-2169*y**2+4691*y**3+222*y**4+1395*y**5-5664*y**6+4002*y**7
          -990*y**8+52*y**9)+r**12*(-124852+433658*y-568504*y**2+127758*y**3
          +453503*y**4-477945*y**5+164298*y**6-2176*y**7-9723*y**8+1603*y**9)
          -r**2*(-1+y)**4*(-5707-7153*y-8599*y**2+29867*y**3-11485*y**4+9817*y**5
          -28619*y**6+23373*y**7-6932*y**8+556*y**9+52*y**10)-r**4*(-1+y)**3*(60279
          -26740*y-4771*y**2-189298*y**3+306473*y**4-200264*y**5+97971*y**6
          -54288*y**7+23694*y**8-5002*y**9+346*y**10)+r**6*(-1+y)**2*(48134-30084*y
          -57*y**2-317809*y**3+591227*y**4-404089*y**5+144529*y**6-64003*y**7
          +38519*y**8-13047*y**9+1640*y**10)+r**8*(124852-565158*y+1028754*y**2
          -1222326*y**3+1303981*y**4-1053479*y**5+384867*y**6+101486*y**7-148079*y**8
          +53299*y**9-8953*y**10+756*y**11))+288*logy**2*r**7*(-1+y)**3*(-1+r**2
          +y)**3*(1683*r**26*(-1+y)**7-r**24*(-1+y)**4*(69846-214587*y+224685*y**2
          -83633*y**3+12349*y**4)-r**22*(-1+y)**2*(1628249-7705132*y+14437373*y**2
          -13232895*y**3+5772655*y**4-829354*y**5-90293*y**6+8997*y**7)+r**20*(
          -1+y)**2*(-5143687+25030769*y-49379212*y**2+46947335*y**3-19598590*y**4
          +683547*y**5+1969306*y**6-573183*y**7+56265*y**8)+5*r**18*(-1+y)**2*(
          -7492324+29560079*y-43248313*y**2+23811101*y**3+4382982*y**4-10596656*y**5
          +3849833*y**6-312923*y**7-22950*y**8+1831*y**9)+(-1+y)**9*(-1683-8415*y
          -25245*y**2-37660*y**3-3015*y**4+83121*y**5-36785*y**6-11380*y**7+15960*y**8
          -7810*y**9+1412*y**10)+r**16*(689871+24727458*y-166094874*y**2+358927835*y**3
          -272062175*y**4-123323652*y**5+371389724*y**6-270789792*y**7+81771565*y**8
          +63150*y**9-6901444*y**10+1700493*y**11-112159*y**12)-r**2*(-1+y)**7*(69846
          +214587*y+439272*y**2-225085*y**3-187005*y**4-610102*y**5+372016*y**6
          +171591*y**7+113985*y**8-316795*y**9+158806*y**10-27528*y**11+1412*y**12)
          +r**10*(-1+y)**3*(689871-30246426*y+26313720*y**2+183591460*y**3-394989985*y**4
          +295242648*y**5-78305318*y**6-4649085*y**7+1763090*y**8+1567560*y**9
          -411344*y**10+7719*y**11+7090*y**12)+r**6*(-1+y)**5*(-5143687-4456021*y
          -5149027*y**2+27367720*y**3-11265135*y**4+10328034*y**5-41948368*y**6
          +42744519*y**7-17562020*y**8+2518535*y**9+161103*y**10-83011*y**11+9358*y**12)
          -5*r**8*(-1+y)**4*(-7492324+7901541*y+68763*y**2+18273051*y**3-41444589*y**4
          +37205514*y**5-23877004*y**6+14013353*y**7-5024851*y**8+75079*y**9+559805*y**10
          -148122*y**11+10184*y**12)+r**4*(-1+y)**6*(1628249+2820385*y+3911856*y**2
          -10341605*y**3+1955835*y**4-2239578*y**5+9411320*y**6-7768677*y**7+3274580*y**8
          -1481035*y**9+629354*y**10-147430*y**11+12746*y**12)+r**12*(-1+y)**2*(20351278
          -125582414*y+279984826*y**2-442509860*y**3+489004930*y**4-222594116*y**5
          -132391042*y**6+209846683*y**7-89802315*y**8+6939770*y**9+5451238*y**10
          -1563619*y**11+134641*y**12)+r**14*(-20351278+57579088*y-7971522*y**2
          -240186858*y**3+576297420*y**4-634782114*y**5+276440174*y**6+115697349*y**7
          -202217364*y**8+98833055*y**9-20271908*y**10+743413*y**11+179198*y**12
          +11347*y**13))-12*logy*r**3*(-1+y)**3*(-1+r**2+y)**4*(r**30*(-1+y)**4*(2367
          -7101*y+7101*y**2-2119*y**3+248*y**4)-2*r**28*(-1+y)**2*(-207498+1001832*y
          -1916886*y**2+1810091*y**3-852186*y**4+176532*y**5-9426*y**6+581*y**7)
          +2*(-1+y)**11*y**3*(267+3113*y+10358*y**2-1168*y**3-14895*y**4+4573*y**5
          +3562*y**6-1998*y**7+388*y**8)+r**26*(6848455-46175245*y+132887205*y**2
          -210976287*y**3+199478003*y**4-112918861*y**5+36115435*y**6-5319365*y**7
          -14418*y**8+82502*y**9-3424*y**10)+2*r**24*(35400632-221541388*y+582848054*y**2
          -821722949*y**3+643898580*y**4-242394826*y**5-1561452*y**6+34460576*y**7
          -10166566*y**8+808760*y**9-26536*y**10+3315*y**11)+r**22*(61247643-412515509*y
          +1227863919*y**2-1936952829*y**3+1560720230*y**4-355324274*y**5-408531590*y**6
          +374767462*y**7-131997781*y**8+21529935*y**9-636829*y**10-333561*y**11
          +17584*y**12)-2*r**20*(-474333138+2535639376*y-5399101858*y**2+5318711155*y**3
          -1234312358*y**4-2453641283*y**5+2542151378*y**6-887048555*y**7-24484402*y**8
          +97664793*y**9-23290194*y**10+1732606*y**11+21748*y**12+3732*y**13)
          +r**18*(-858789357+3753131767*y-5013289367*y**2+889533185*y**3+1973068214*y**4
          +1872648182*y**5-5439805286*y**6+3538972422*y**7-395290117*y**8-544624025*y**9
          +273772925*y**10-46150231*y**11+503220*y**12+408332*y**13-29864*y**14)
          -2*r**4*(-1+y)**7*(-207498-794334*y-1916886*y**2-647347*y**3+2090887*y**4
          +5429883*y**5-6115155*y**6+1211249*y**7+697271*y**8-432267*y**9+51615*y**10
          +88414*y**11-57388*y**12+6226*y**13+330*y**14)+2*r**16*y*(1076812520
          -4845656340*y+9301785407*y**2-8806175888*y**3+1555363036*y**4+6264822350*y**5
          -7860118680*y**6+4249700576*y**7-842301634*y**8-216396682*y**9+146826855*y**10
          -26058780*y**11+1479442*y**12-82828*y**13+646*y**14)-r**2*(-1+y)**8*(2367
          +11835*y+35505*y**2+64281*y**3-155302*y**4-482862*y**5+670722*y**6
          -115538*y**7-390145*y**8+451051*y**9-163555*y**10-18807*y**11+28208*y**12
          -8536*y**13+776*y**14)+r**6*(-1+y)**6*(-6848455-18781425*y-35452200*y**2
          +29920348*y**3+2025161*y**4+37113315*y**5-6085620*y**6-33014040*y**7
          -11481061*y**8+42201173*y**9-23615660*y**10+4984220*y**11-169285*y**12
          -47687*y**13+1216*y**14)-2*r**8*(-1+y)**5*(-35400632-44538228*y-50688822*y**2
          +241965915*y**3-93308961*y**4+23399867*y**5-214154291*y**6+255139872*y**7
          -139396842*y**8+48942360*y**9-11784460*y**10+725569*y**11+396975*y**12
          -85923*y**13+6601*y**14)+r**14*(-1+y)**2*(858789357-3117183089*y+2787468994*y**2
          +4641057758*y**3-11499880853*y**4+7364978793*y**5+1239511180*y**6-3449614796*y**7
          +1110657731*y**8+284283633*y**9-248626550*y**10+50815534*y**11-1136123*y**12
          -653289*y**13+13720*y**14)-2*r**12*(-1+y)**3*(-474333138+784692590*y
          -146261500*y**2+753342291*y**3-2817613867*y**4+3331325413*y**5-2004053833*y**6
          +606165272*y**7+83974450*y**8-196398954*y**9+88997900*y**10-16769407*y**11
          +894903*y**12+10659*y**13+14221*y**14)-r**10*(-1+y)**4*(61247643+45029651*y
          +84001019*y**2-331660149*y**3-168573084*y**4-198755472*y**5+1732904842*y**6
          -1942887634*y**7+770380967*y**8-6234253*y**9-75370021*y**10+15272007*y**11
          +706490*y**12-453718*y**13+41712*y**14))+r*(-1+y)*(-1+r**2+y)**5*(11*r**34*(
          -1+y)**9+r**32*(-1+y)**6*(661-1928*y+1818*y**2-588*y**3+95*y**4)
          +r**30*(-1+y)**4*(-172110+828896*y-1577197*y**2+1460761*y**3-670830*y**4
          +151296*y**5-14651*y**6+255*y**7)-r**28*(-1+y)**2*(8719198-56883330*y
          +156883043*y**2-236047922*y**3+208321104*y**4-107378082*y**5+29619416*y**6
          -3078022*y**7-144362*y**8+9612*y**9+225*y**10)-(-1+y)**12*(-11-88*y
          -396*y**2-854*y**3-5901*y**4-19180*y**5+7768*y**6+26628*y**7-22997*y**8
          -3624*y**9+9716*y**10-2830*y**11+493*y**12+76*y**13)-r**26*(56893562
          -469305532*y+1705597977*y**2-3561789325*y**3+4667427053*y**4-3916557089*y**5
          +2026144780*y**6-543369428*y**7+1826010*y**8+43926712*y**9-12117653*y**10
          +1404377*y**11-89969*y**12+2925*y**13)-r**24*(478084378-3694875518*y
          +12393895569*y**2-23295971946*y**3+26060590370*y**4-16104629946*y**5
          +2551642003*y**6+3932405816*y**7-3288969162*y**8+1133698378*y**9-171491977*y**10
          +5012770*y**11+701470*y**12-76162*y**13+6357*y**14)+r**2*(-1+y)**10*(
          -661-3911*y-13496*y**2+28370*y**3+39145*y**4-132643*y**5-689828*y**6
          +187812*y**7+1555245*y**8-1091465*y**9-211896*y**10+411814*y**11-152641*y**12
          +18835*y**13-780*y**14+100*y**15)+r**22*(673596282-5014800248*y+15526414467*y**2
          -26174260623*y**3+26351699814*y**4-16615076124*y**5+7247943111*y**6-2829964779*y**7
          +972552786*y**8-4212148*y**9-233546923*y**10+134036687*y**11-40345138*y**12
          +6179912*y**13-189791*y**14+715*y**15)+r**4*(-1+y)**9*(-172110-828896*y
          -2406093*y**2-2382675*y**3+4498746*y**4+13794708*y**5-19600851*y**6
          +7197363*y**7+12110562*y**8-16539700*y**9+5479481*y**10+1272647*y**11
          -1347070*y**12+326288*y**13-31721*y**14+1321*y**15)+r**6*(-1+y)**8*(8719198
          +30725736*y+69273977*y**2+4877811*y**3-45790630*y**4-128503220*y**5
          +108357829*y**6+14222527*y**7+9043534*y**8-58114484*y**9+36777847*y**10
          -9551515*y**11+362346*y**12+437680*y**13-106661*y**14+8025*y**15)+r**8*(
          -1+y)**7*(-56893562-127944160*y-212473747*y**2+368360783*y**3-145295116*y**4
          +191058340*y**5+181801511*y**6-411904785*y**7-169225910*y**8+479124748*y**9
          -257053553*y**10+45692249*y**11+1152332*y**12-486048*y**13-182707*y**14
          +29625*y**15)+r**10*(-1+y)**6*(478084378+348284872*y+264414399*y**2
          -3369219631*y**3+1736907296*y**4+45368608*y**5+3891445775*y**6-6154747289*y**7
          +3406267126*y**8-636371648*y**9-142820391*y**10+89944903*y**11-17987760*y**12
          +2410280*y**13-518823*y**14+73905*y**15)+r**18*(-1+y)**2*(14380443136
          -68738031830*y+120784182151*y**2-86198329259*y**3-2457423682*y**4+40381669490*y**5
          -21234707233*y**6+2635247975*y**7-233118740*y**8+1152018026*y**9-715181251*y**10
          +166833063*y**11-11506426*y**12-663126*y**13-64819*y**14+96525*y**15)
          +r**12*(-1+y)**5*(673596282-373970008*y-716491373*y**2-3330793819*y**3
          +8126443262*y**4-745860244*y**5-11068087539*y**6+10052802411*y**7-1622995242*y**8
          -1907929824*y**9+951342517*y**10-70261453*y**11-46540238*y**12+11720236*y**13
          -1313813*y**14+130845*y**15)+r**16*(-1+y)**3*(14380443136-46305513258*y
          +42270367149*y**2+14991052747*y**3-38111300310*y**4-10518213450*y**5
          +49786263943*y**6-32961847521*y**7+3035222388*y**8+5902353002*y**9-2951704461*y**10
          +535577865*y**11-31993678*y**12+1737690*y**13-758967*y**14+153725*y**15)
          +r**14*(-1+y)**4*(7064801654-13704410432*y+3841552249*y**2-10289187445*y**3
          +47481067702*y**4-56678576516*y**5+22625195653*y**6+4709108391*y**7-7074897006*y**8
          +2272353160*y**9-364850341*y**10+108413729*y**11-53520590*y**12+12980876*y**13
          -1606537*y**14+167453*y**15)+r**20*(-7064801654+49878804454*y-148539128337*y**2
          +234847231250*y**3-190815640871*y**4+28005388490*y**5+97920702637*y**6
          -97952080946*y**7+36636185955*y**8+1561785842*y**9-6388167263*y**10+2122833974*y**11
          -183513217*y**12-36930530*y**13+7523779*y**14-228598*y**15+35035*y**16))))/(
          -1959552000*logy**5*r**20*(-1+y)**10+7875*(r**8*(-1+y)**2-6*r**4*y*(2
          -3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)
          -(-1+y)**3*(-1-y-y**2+y**3))**5-816480000*logy**4*r**16*(-1+y)**8*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-136080000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          -11340000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**3-472500*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2
          -3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)
          +r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((muG*(217728000*logy**5*r**17*(-18
          +7*r**2+25*r**4+50*r**6+67*r**8+27*r**10)*(-1+y)**10+518400*logy**4*r**13*(
          -1+y)**7*(-9398*r**18*(-1+y)**3+r**16*(-26503+79509*y-79509*y**2+42673*y**3
          -7770*y**4)+10*r**14*(-9288+22194*y-13689*y**2+1973*y**3+637*y**4
          +63*y**5)+4*(-1+y)**4*(106+106*y+106*y**2-419*y**3+946*y**4-650*y**5
          +120*y**6)-7*r**12*(6961-783*y-29367*y**2+27849*y**3-8660*y**4+350*y**5
          +250*y**6)+14*r**10*(5684-24552*y+35802*y**2-18099*y**3+700*y**4+3875*y**5
          -2530*y**6+470*y**7)+2*r**2*(-1+y)**3*(-921+16905*y**3-37800*y**4+26376*y**5
          -8330*y**6+1040*y**7)+5*r**4*(-1+y)**2*(-8685+16245*y-3780*y**2-13300*y**3
          +22911*y**4-23611*y**5+10976*y**6-2144*y**7+128*y**8)+7*r**8*(9201
          -35103*y+46353*y**2-18881*y**3-11665*y**4+20079*y**5-9107*y**6-253*y**7
          +576*y**8)-14*r**6*(-3992+13026*y-14601*y**2+6797*y**3-950*y**4+1787*y**5
          -5911*y**6+5456*y**7-1802*y**8+190*y**9))-17280*logy**3*r**9*(-1+y)**5*(
          -1+r**2+y)**2*(27842*r**22*(-1+y)**5-r**20*(-1+y)**2*(148843-502213*y
          +613581*y**2-260740*y**3+47729*y**4)-r**18*(-1+y)**2*(1060824-2408082*y
          +1506708*y**2+443163*y**3-537532*y**4+54219*y**5)+2*(-1+y)**6*(503
          +1509*y+3018*y**2+3205*y**3-5365*y**4-6648*y**5+12866*y**6-7498*y**7
          +1560*y**8)+r**16*(3388506-13542672*y+18990129*y**2-12098477*y**3+4608930*y**4
          -2775856*y**5+2141567*y**6-925669*y**7+140042*y**8)+2*r**14*(5121723
          -20698092*y+29936241*y**2-18599712*y**3+2780155*y**4+3332952*y**5-2850223*y**6
          +1128849*y**7-227248*y**8+15855*y**9)+r**2*(-1+y)**5*(-25122-52256*y
          -81402*y**2+142415*y**3-111655*y**4-30593*y**5-179649*y**6+328832*y**7
          -160450*y**8+25680*y**9)+r**12*(9312990-38185356*y+57348813*y**2-40139865*y**3
          +10584515*y**4+6223823*y**5-8813269*y**6+5202872*y**7-2160190*y**8+619640*y**9
          -67473*y**10)-r**8*(-1+y)**2*(3919856-10029018*y+4742067*y**2+14507527*y**3
          -30783673*y**4+30716955*y**5-16509287*y**6+4217003*y**7-313507*y**8
          -79707*y**9+12184*y**10)-2*r**6*(-1+y)**3*(289882+5277*y+75798*y**2
          -3237829*y**3+7674931*y**4-7056891*y**5+3031663*y**6-720643*y**7+194599*y**8
          -86846*y**9+15909*y**10)+r**4*(-1+y)**4*(140549+141925*y+171759*y**2
          -1153484*y**3+1884966*y**4-1209294*y**5+753260*y**6-742889*y**7+521964*y**8
          -161076*y**9+16320*y**10)+r**10*(1373982-7619976*y+17345562*y**2-28376474*y**3
          +38195500*y**4-39893420*y**5+31729950*y**6-16950277*y**7+4020184*y**8
          +538710*y**9-419202*y**10+55461*y**11))-288*logy**2*r**5*(-1+y)**3*(-1
          +r**2+y)**3*(13141*r**28*(-1+y)**7-r**26*(-1+y)**4*(572496-1756911*y
          +1835757*y**2-665650*y**3+100908*y**4)-r**24*(-1+y)**2*(11298819-53239446*y
          +99299571*y**2-90117590*y**3+38202435*y**4-4768784*y**5-835389*y**6
          +56384*y**7)+r**22*(-1+y)**2*(-8590515+46802643*y-109615128*y**2+109398650*y**3
          -30172625*y**4-19312445*y**5+15359222*y**6-4385222*y**7+440920*y**8)
          -r**20*(-1+y)**2*(103463914-355992863*y+405334639*y**2+6398990*y**3
          -397842470*y**4+328432161*y**5-88861597*y**6+1370116*y**7+1056330*y**8
          +7780*y**9)+2*(-1+y)**9*(1262+6310*y+18930*y**2+29105*y**3+4640*y**4
          -60034*y**5-8710*y**6+445*y**7+60170*y**8-43090*y**9+8472*y**10)-r**2*(
          -1+y)**8*(-49155-189048*y-453690*y**2-614295*y**3+215965*y**4+935570*y**5
          -1467794*y**6+263365*y**7+1171020*y**8-727140*y**9+49810*y**10+25392*y**11)
          +r**18*(468614247-2521303614*y+5284203522*y**2-5421932095*y**3+2727521985*y**4
          -686960564*y**5+454875808*y**6-474823419*y**7+154304370*y**8+57817390*y**9
          -54460158*y**10+12824406*y**11-821878*y**12)-r**6*(-1+y)**6*(-7620809
          -13080439*y-18451812*y**2+60721510*y**3-64831110*y**4+2543428*y**5
          -25301262*y**6+90588204*y**7-75169385*y**8+25314485*y**9-3792444*y**10
          +157976*y**11+11658*y**12)-r**4*(-1+y)**7*(800656+2360781*y+4714584*y**2
          -426060*y**3-3080780*y**4-2995812*y**5+15968618*y**6-11636908*y**7+2180060*y**8
          -1283045*y**9+1497206*y**10-601524*y**11+76224*y**12)-r**12*(-1+y)**3*(
          -475223665+1354062874*y-928499700*y**2-1437682550*y**3+3530242595*y**4
          -3600134790*y**5+2060559882*y**6-474341480*y**7-125750275*y**8+98097480*y**9
          -19495470*y**10+334794*y**11+120305*y**12)+r**8*(-1+y)**5*(-23285369
          -18687797*y-24366359*y**2+207566975*y**3-350839360*y**4+310928108*y**5
          -221097676*y**6+205381478*y**7-151635425*y**8+55706385*y**9-5121689*y**10
          -1078277*y**11+170006*y**12)-r**10*(-1+y)**4*(-70788038+39098985*y
          -13210905*y**2+806219270*y**3-2121009420*y**4+2406326916*y**5-1401742300*y**6
          +374512600*y**7+18162130*y**8-50810455*y**9+18431547*y**10-3689760*y**11
          +249430*y**12)+2*r**14*(-1+y)**2*(179284069-755642411*y+1210188241*y**2
          -1174769105*y**3+690846865*y**4+8727847*y**5-375342293*y**6+297106213*y**7
          -104096820*y**8-6032965*y**9+19857759*y**10-5595021*y**11+473621*y**12)
          +2*r**16*(431959331-2425228490*y+5403782757*y**2-5980837613*y**3+2844450380*y**4
          +975698898*y**5-2606607310*y**6+2079502616*y**7-896781354*y**8+168418095*y**9
          +15362021*y**10-10394175*y**11+533927*y**12+140917*y**13))-12*logy*r*(
          -1+y)**3*(-1+r**2+y)**4*(69*r**34*(-1+y)**7-r**32*(-1+y)**4*(13951
          -42129*y+42681*y**2-10121*y**3+578*y**4)+2*r**30*(-1+y)**2*(-1726766
          +8346486*y-15988977*y**2+15111186*y**3-7137150*y**4+1515720*y**5-96743*y**6
          +6644*y**7)-6*(-1+y)**12*(-23-207*y-1035*y**2-3209*y**3-5249*y**4
          -1129*y**5+4927*y**6+5925*y**7-1756*y**8-3996*y**9+1552*y**10)+r**28*(
          -52754771+355043029*y-1019840721*y**2+1613146901*y**3-1514015941*y**4
          +845945759*y**5-265024729*y**6+37801891*y**7+266144*y**8-628284*y**9
          +20722*y**10)+r**26*(-392736192+2403588748*y-6153863278*y**2+8297044868*y**3
          -5870532753*y**4+1435434447*y**5+792455839*y**6-663674697*y**7+164407477*y**8
          -12940527*y**9+772795*y**10-80727*y**11)+r**24*(590761815-3322297253*y
          +7139535295*y**2-7875089987*y**3+5662183618*y**4-4108184064*y**5+3280727668*y**6
          -1945662454*y**7+716223307*y**8-143487123*y**9+4095269*y**10+2782705*y**11
          -132796*y**12)-r**2*(-1+y)**9*(-9105-54078*y-187341*y**2-383898*y**3
          -174988*y**4+678862*y**5-14932*y**6-15886*y**7-40647*y**8-73912*y**9
          -239607*y**10+368560*y**11-148548*y**12+15520*y**13)+2*r**22*(-1684132574
          +8530788178*y-16541194269*y**2+12218033366*y**3+5350699890*y**4-17028110311*y**5
          +12282698096*y**6-2416585679*y**7-1455334968*y**8+906136455*y**9-178542795*y**10
          +12875121*y**11-266732*y**12+66222*y**13)-r**8*(-1+y)**6*(-37128869
          -100195343*y-192411332*y**2+223819502*y**3-108255537*y**4+10930713*y**5
          -391817994*y**6+552553894*y**7-404722989*y**8+280533609*y**9-160273394*y**10
          +47443012*y**11-5930037*y**12-96763*y**13+7528*y**14)+2*r**6*(-1+y)**7*(
          -3770854-13620112*y-31149751*y**2-23528349*y**3+24348182*y**4+51844451*y**5
          -107118603*y**6+26330795*y**7+49783641*y**8-24135331*y**9-6284172*y**10
          +5419390*y**11-487469*y**12-73092*y**13+11274*y**14)+r**4*(-1+y)**8*(
          -163113-730281*y-1994187*y**2-1031533*y**3+2471004*y**4+9206364*y**5
          +4443140*y**6-1331408*y**7-19408731*y**8+15355805*y**9-3569601*y**10
          -561659*y**11+688720*y**12-166936*y**13+12416*y**14)+r**10*(-1+y)**5*(
          -302563672-376652724*y-443459882*y**2+2539243570*y**3-3295760795*y**4
          +809833116*y**5-226969045*y**6+3468836796*y**7-4072736958*y**8+1705298132*y**9
          -164849044*y**10-70557606*y**11+22986761*y**12-2110612*y**13+101963*y**14)
          -r**16*(-1+y)**2*(10894733191-36657505527*y+34507763654*y**2+23241846336*y**3
          -72946900403*y**4+58832157911*y**5-15282968798*y**6-7244201360*y**7+5664937781*y**8
          +308559799*y**9-1279033002*y**10+303633800*y**11+5565231*y**12-6439167*y**13
          +122554*y**14)+2*r**14*(-1+y)**3*(-600351846+925389176*y-382956425*y**2
          +8086868689*y**3-26572161639*y**4+36080428595*y**5-24161570764*y**6+4990324448*y**7
          +3779262310*y**8-2953288424*y**9+796743901*y**10-62283437*y**11-2129773*y**12
          -574399*y**13+181588*y**14)+r**20*(13366536797-64115492811*y+112335989059*y**2
          -78126426963*y**3-5641367688*y**4+37231866792*y**5-13508888892*y**6-4584255972*y**7
          +2458393627*y**8+1607750187*y**9-1334986539*y**10+272200503*y**11+1377888*y**12
          -3535864*y**13+239876*y**14)+r**12*(-1+y)**4*(420741279+284823635*y
          +468102751*y**2-4814285603*y**3+7477683538*y**4-10154116622*y**5+11703999376*y**6
          -8781166006*y**7+3892248707*y**8-561697185*y**9-253302257*y**10+85169489*y**11
          +13746580*y**12-5444204*y**13+420522*y**14)+r**18*(13119911102-74387164358*y
          +166978963012*y**2-185988647422*y**3+74641343987*y**4+84116805575*y**5
          -161926638029*y**6+122219993151*y**7-41026904536*y**8-3178300184*y**9
          +7582022854*y**10-2444052488*y**11+308722487*y**12-19156617*y**13+3224147*y**14
          -122681*y**15))-r*(-1+y)*(-1+r**2+y)**5*(29*r**34*(-1+y)**9+r**32*(
          -1+y)**6*(2051-6836*y+7788*y**2-3024*y**3+601*y**4)+r**30*(-1+y)**4*(
          -1216164+5902470*y-11350305*y**2+10511173*y**3-4688414*y**4+995900*y**5
          -93665*y**6+3205*y**7)+r**28*(-1+y)**2*(-75230836+491075938*y-1354782843*y**2
          +2039232906*y**3-1803546600*y**4+938143562*y**5-267707182*y**6+32748614*y**7
          -130220*y**8-16844*y**9+4705*y**10)+r**26*(-323910740+2622753674*y
          -9347865543*y**2+19008889871*y**3-23819512337*y**4+18295910089*y**5-7582508294*y**6
          +482865394*y**7+1100579214*y**8-537717428*y**9+111270581*y**10-11232505*y**11
          +547919*y**12-13895*y**13)+r**24*(-2377067316+18007882254*y-58974452613*y**2
          +106827983938*y**3-110768536346*y**4+53554580646*y**5+13223215263*y**6
          -36911344116*y**7+24018830744*y**8-7718736126*y**9+1181188465*y**10-67928622*y**11
          +4281974*y**12-61462*y**13-60683*y**14)+r**22*(9990981652-74330080098*y
          +234084959367*y**2-407234375323*y**3+423497611334*y**4-258095984976*y**5
          +70587820361*y**6+18188792031*y**7-26360641704*y**8+13198345902*y**9
          -4708920399*y**10+1549703187*y**11-428171298*y**12+61783252*y**13-1502961*y**14
          -40327*y**15)+(-1+y)**11*(-3123-20205*y-75024*y**2-65834*y**3+409385*y**4
          +1459185*y**5+157424*y**6-1500628*y**7-2138913*y**8+1783509*y**9+1870168*y**10
          -2090394*y**11+562827*y**12-12153*y**13-344*y**14+120*y**15)+r**2*(
          -1+y)**10*(-281741-1567227*y-5116110*y**2-7515092*y**3+4075969*y**4
          +28665013*y**5-7796056*y**6-9852460*y**7-9889991*y**8+10687347*y**9
          -4375018*y**10+2950408*y**11-1141405*y**12+254883*y**13+3584*y**14+1896*y**15)
          +r**4*(-1+y)**9*(-1451996-7931850*y-24628353*y**2-54474151*y**3-2902936*y**4
          +22526454*y**5-253473217*y**6+11754429*y**7+347432700*y**8-242627430*y**9
          +48263133*y**10+19427667*y**11-15544776*y**12+4752826*y**13-378459*y**14
          +15959*y**15)+r**6*(-1+y)**8*(108724620+352329834*y+738045669*y**2
          +143778671*y**3-601933902*y**4-993848456*y**5+2151077211*y**6-746723979*y**7
          -483213128*y**8+62637818*y**9+413894531*y**10-211669895*y**11+15939610*y**12
          +10846932*y**13-1531091*y**14+85555*y**15)+r**8*(-1+y)**7*(-44565164
          -149203518*y-435280647*y**2+2015191819*y**3-3665779380*y**4-427643168*y**5
          +2522590005*y**6+2603184753*y**7-5846124124*y**8+4334275274*y**9-1511491773*y**10
          +171250013*y**11+29412444*y**12+6437780*y**13-2738769*y**14+308455*y**15)
          +r**10*(-1+y)**6*(2827067980+2261705742*y+1642524675*y**2-18885572411*y**3
          +21201445062*y**4-8227021490*y**5+7972764021*y**6-28725609075*y**7+32450011812*y**8
          -12680340594*y**9-225016335*y**10+1305081387*y**11-248900550*y**12+32235174*y**13
          -5964793*y**14+773395*y**15)+r**18*(-1+y)**2*(124306924722-588441042936*y
          +1028385103071*y**2-712033391267*y**3-117355160560*y**4+508459739604*y**5
          -294922907515*y**6+24146068961*y**7+39322137462*y**8-11208967452*y**9
          -2904919811*y**10+1365843651*y**11+1294968*y**12-38635920*y**13+1425487*y**14
          +887535*y**15)+r**12*(-1+y)**5*(3675314412-2018699922*y-4213988529*y**2
          +4002869473*y**3-4352206672*y**4+48830267794*y**5-93301053121*y**6+54200430393*y**7
          +7327739124*y**8-20012287686*y**9+6622319901*y**10+423255843*y**11-555697264*y**12
          +120866278*y**13-13993867*y**14+1375843*y**15)+r**16*(-1+y)**3*(72790502830
          -254354756712*y+269325829713*y**2+33619181527*y**3-179036367474*y**4
          -99164981922*y**5+321162186877*y**6-187537271883*y**7-8920456446*y**8
          +50394558956*y**9-20268757893*y**10+2864684385*y**11-33150430*y**12+10193694*y**13
          -8233257*y**14+1542035*y**15)+r**14*(-1+y)**4*(15583691524-27091002030*y
          +4801207509*y**2-75916451497*y**3+318449162258*y**4-450499135900*y**5
          +268135702211*y**6-9715818207*y**7-73511076720*y**8+34487549570*y**9
          -4479320421*y**10+338486169*y**11-392770502*y**12+134811592*y**13-17658803*y**14
          +1743247*y**15)+r**20*(-39218864764+278184447610*y-830176234563*y**2
          +1311347277362*y**3-1059947393109*y**4+151401546894*y**5+531358052405*y**6
          -502786701234*y**7+152467702291*y**8+41746801318*y**9-45871253921*y**10
          +12128590030*y**11-312835303*y**12-365269678*y**13+43511791*y**14+369266*y**15
          +253605*y**16))))/(-41803776000*logy**5*r**20*(-1+y)**10+168000*(r**8*(-1
          +y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5-17418240000*logy**4*r**16*(
          -1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -2903040000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2-241920000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3-10080000*logy*(
          -1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(
          -4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2
          +y**3))**4))
      resNP += ((api*muWC**2*(217728000*logy**5*r**19*(-33-25*r**2+10*r**4+43*r**6
          +63*r**8)*(-1+y)**10+518400*logy**4*r**15*(-1+y)**6*(11422*r**16*(-1+y)**4
          +3*r**14*(7299-29196*y+43794*y**2-25626*y**3+4639*y**4+770*y**5)-14*r**12*(
          -7126+19054*y-9681*y**2-18406*y**3+23694*y**4-9380*y**5+1035*y**6)
          +10*(-1+y)**4*(793-987*y**3+434*y**4+252*y**5-238*y**6+40*y**7)+35*r**10*(
          -2041+10744*y-21276*y**2+21416*y**3-10575*y**4+2426*y**5-404*y**6
          +118*y**7)+r**2*(-1+y)**4*(11811-6720*y**3-30065*y**4+25144*y**5-8120*y**6
          +880*y**7)+70*r**8*(-1164+4956*y-8034*y**2+5433*y**3+1835*y**4-6219*y**5
          +4893*y**6-1794*y**7+256*y**8)+7*r**6*(-7191+21264*y-16896*y**2-13386*y**3
          +45824*y**4-51284*y**5+28566*y**6-4934*y**7-1819*y**8+576*y**9)-14*r**4*(
          -3602+19358*y-38937*y**2+39138*y**3-20077*y**4-1183*y**5+15422*y**6
          -17333*y**7+9412*y**8-2448*y**9+250*y**10))+17280*logy**3*r**11*(-1+y)**4*(
          -1+r**2+y)**2*(16708*r**20*(-1+y)**6-r**18*(-1+y)**2*(-227761+944460*y
          -1500230*y**2+1083215*y**3-380295*y**4+52291*y**5)-r**16*(-1+y)**2*(
          -2283286+8251442*y-10908352*y**2+5790883*y**3-651257*y**4-299021*y**5
          +28011*y**6)+r**14*(2715616-15980286*y+39580491*y**2-49532708*y**3
          +29908747*y**4-2815486*y**5-7569679*y**6+4829254*y**7-1213707*y**8+121858*y**9)
          -(-1+y)**5*(-22808-22808*y-22808*y**2+217237*y**3-181808*y**4+72068*y**5
          +48478*y**6-241047*y**7+243458*y**8-98422*y**9+14760*y**10)+2*r**12*(3727013
          -16936009*y+30096339*y**2-20100843*y**3-7254360*y**4+19625597*y**5
          -11847826*y**6+2873966*y**7-74002*y**8-90225*y**9+16050*y**10)+r**10*(1327010
          -4620214*y+3456423*y**2+22374898*y**3-66300502*y**4+74194328*y**5-31818434*y**6
          -8291323*y**7+15212172*y**8-6667858*y**9+1264447*y**10-86847*y**11)
          +2*r**4*(-1+y)**3*(780603-1116304*y+272112*y**2-224308*y**3-376463*y**4
          +1439431*y**5-470875*y**6-795707*y**7+589578*y**8-68527*y**9-46559*y**10
          +10719*y**11)-r**2*(-1+y)**4*(117291+45616*y+45616*y**2-408929*y**3
          -79164*y**4+296864*y**5-15336*y**6+487769*y**7-971211*y**8+651424*y**9
          -181520*y**10+17880*y**11)+r**6*(-1+y)**2*(-1748376+3414662*y-1912067*y**2
          +3019488*y**3+885338*y**4-13262440*y**5+15071304*y**6-3885888*y**7-3138198*y**8
          +2465722*y**9-655929*y**10+61384*y**11)+r**8*(-3266726+17908342*y-41201466*y**2
          +60370480*y**3-61432100*y**4+27382572*y**5+24762246*y**6-46594003*y**7
          +30066765*y**8-8901330*y**9+813424*y**10+107807*y**11-16011*y**12))
          +288*logy**2*r**7*(-1+y)**2*(-1+r**2+y)**3*(3977*r**26*(-1+y)**8-r**24*(
          -1+y)**4*(-298732+1206859*y-1840116*y**2+1223069*y**3-398126*y**4
          +55086*y**5)+r**22*(-1+y)**2*(9663455-55881417*y+133883529*y**2-169673237*y**3
          +120440705*y**4-46292395*y**5+8102027*y**6-328799*y**7+23732*y**8)+r**20*(
          -1+y)**2*(50332871-287891298*y+685177503*y**2-851265716*y**3+578960385*y**4
          -199422456*y**5+15966993*y**6+11121982*y**7-3170124*y**8+234560*y**9)
          -5*r**18*(-1+y)**2*(-54184870+270289461*y-538145910*y**2+507814103*y**3
          -169676432*y**4-80688761*y**5+88639914*y**6-27379779*y**7+3197914*y**8
          -296240*y**9+26560*y**10)+(-1+y)**8*(-29659-88977*y-177954*y**2+51235*y**3
          +543230*y**4+773003*y**5-1923496*y**6+1390083*y**7-498535*y**8-577030*y**9
          +1003606*y**10-508202*y**11+84696*y**12)+r**16*(80246041-691831703*y
          +2641667968*y**2-5218106131*y**3+5162487410*y**4-1074129937*y**5-3318208484*y**6
          +4154021549*y**7-2281573413*y**8+563088490*y**9+16884096*y**10-42639738*y**11
          +8642758*y**12-464906*y**13)-5*r**8*(-1+y)**4*(40421250-83407191*y
          +42079458*y**2+19087059*y**3-109031778*y**4+148837686*y**5+1347612*y**6
          -161905098*y**7+137546556*y**8-39581267*y**9-3030726*y**10+4131299*y**11
          -747900*y**12+39040*y**13)+r**2*(-1+y)**7*(306180+701337*y+1185471*y**2
          -3967838*y**3+2305190*y**4-3004620*y**5-4511014*y**6+12652208*y**7-6379714*y**8
          +271035*y**9-936185*y**10+1427702*y**11-565504*y**12+67752*y**13)+r**4*(
          -1+y)**6*(-9232933-6135010*y-5267761*y**2+71200704*y**3-70871210*y**4
          +25914806*y**5+34751750*y**6-115069008*y**7+114691137*y**8-41279690*y**9
          -3187473*y**10+5773760*y**11-1335206*y**12+88134*y**13)-r**6*(-1+y)**5*(
          -20866293-3488496*y-5974074*y**2+20532078*y**3+184736085*y**4-237657864*y**5
          -34158348*y**6+101960708*y**7+67523339*y**8-111676310*y**9+42537482*y**10
          -3315606*y**11-854559*y**12+113858*y**13)+r**10*(-1+y)**3*(55133987
          -33586609*y-91043758*y**2-514150790*y**3+884949385*y**4+368324851*y**5
          -1370144452*y**6+713001376*y**7+172653255*y**8-285987385*y**9+99245562*y**10
          -11908314*y**11-503443*y**12+156335*y**13)+2*r**12*(-1+y)**2*(-42417025
          +300214752*y-879978984*y**2+2095086332*y**3-3155960880*y**4+2075295150*y**5
          +498720726*y**6-1718161397*y**7+1100817826*y**8-268618995*y**9-11923700*y**10
          +18887997*y**11-3632219*y**12+259417*y**13)+2*r**14*(199759963-1072518113*y
          +2260362901*y**2-1582170445*y**3-2051878561*y**4+5159422199*y**5-3985332744*y**6
          +407509578*y**7+1523965890*y**8-1243521113*y**9+469583988*y**10-93537393*y**11
          +8637996*y**12-344745*y**13+60599*y**14))+12*logy*r**3*(-1+y)**2*(-1
          +r**2+y)**4*(387*r**32*(-1+y)**8+r**30*(-1+y)**4*(-3943+14224*y-17466*y**2
          +13714*y**3-4275*y**4+722*y**5)+2*r**28*(-1+y)**2*(588506-3428476*y
          +8261889*y**2-10432585*y**3+7340224*y**4-2858790*y**5+540017*y**6-30325*y**7
          +1300*y**8)-r**26*(-40447079+313740424*y-1060298290*y**2+2033708670*y**3
          -2428597558*y**4+1870321432*y**5-931419172*y**6+290815480*y**7-51681675*y**8
          +3765648*y**9+66862*y**10+1258*y**11)+r**24*(473158420-3473373628*y
          +11017471558*y**2-19597494990*y**3+21167772051*y**4-13903914600*y**5
          +5038517384*y**6-553139280*y**7-249470510*y**8+87726244*y**9-7439990*y**10
          +277374*y**11-15633*y**12)+r**22*(984376489-7039774052*y+21911621312*y**2
          -37549977326*y**3+37121153677*y**4-19135859554*y**5+1192488540*y**6+4998236334*y**7
          -3416131293*y**8+1103312298*y**9-184009060*y**10+13632112*y**11+54879*y**12
          +2044*y**13)+2*r**20*(3018174774-19194347840*y+50912212521*y**2-69556721661*y**3
          +43752240100*y**4+6232950255*y**5-31557975677*y**6+22684380861*y**7-6762791845*y**8
          +128415823*y**9+443654746*y**10-109826508*y**11+11853943*y**12-510194*y**13
          +12702*y**14)-(-1+y)**9*(-1573-7865*y-23595*y**2-43281*y**3-77858*y**4
          -32094*y**5+485030*y**6-187610*y**7-607893*y**8+805611*y**9-419883*y**10
          +22635*y**11+123580*y**12-80276*y**13+17072*y**14)+r**6*(-1+y)**6*(
          -21464901-43298250*y-68760985*y**2+263465290*y**3-312703957*y**4+219060802*y**5
          +789705123*y**6-1698601232*y**7+988564953*y**8+54490502*y**9-217866883*y**10
          +33990302*y**11+18825617*y**12-6317118*y**13+378505*y**14+232*y**15)
          -r**2*(-1+y)**8*(86387+351840*y+895330*y**2+771942*y**3-2495971*y**4
          -5544884*y**5+10411140*y**6-8293080*y**7+619581*y**8+8861772*y**9-7742838*y**10
          +1443570*y**11+374275*y**12-11048*y**13-43776*y**14+7760*y**15)-2*r**4*(
          -1+y)**7*(-2017110-5515434*y-10322849*y**2+13439206*y**3+23348989*y**4
          +34357987*y**5-81196094*y**6+50829946*y**7-22019974*y**8-24355480*y**9
          +52741829*y**10-31320022*y**11+6365903*y**12+239943*y**13-148134*y**14
          +9294*y**15)-r**18*(3873848929-20599303912*y+37338494298*y**2-24292416126*y**3
          -837979793*y**4-8413641516*y**5+37617842616*y**6-37749136164*y**7+11421636959*y**8
          +6132369428*y**9-6319862838*y**10+2076013646*y**11-278580159*y**12+7259792*y**13
          +72340*y**14+30500*y**15)+r**8*(-1+y)**5*(447823708+90870976*y+34040846*y**2
          -2744121552*y**3+3068420659*y**4-767634697*y**5-1088135033*y**6+3345365777*y**7
          -3962133022*y**8+1717123806*y**9+154491364*y**10-363371918*y**11+106299327*y**12
          -10342501*y**13-146665*y**14+36925*y**15)+r**14*(-1+y)**2*(2327500675
          -14221107094*y+24696683421*y**2+14298503706*y**3-80617912701*y**4+69657866682*y**5
          +9807445661*y**6-47297433434*y**7+24135432241*y**8+581588710*y**9-4456572561*y**10
          +1533320758*y**11-192987287*y**12-3206122*y**13+2125591*y**14+51754*y**15)
          +2*r**12*(-1+y)**3*(2686642682-7326944850*y+5457785455*y**2+1789396598*y**3
          -7084229804*y**4+5002821682*y**5+5091800785*y**6-12115347620*y**7+8992631734*y**8
          -2503965582*y**9-418527475*y**10+458038890*y**11-110849260*y**12+7844518*y**13
          -47589*y**14+51836*y**15)+r**10*(-1+y)**4*(3066093-432760036*y-257567936*y**2
          -2424850694*y**3+15102474731*y**4-16799101164*y**5-2990717878*y**6+15789849522*y**7
          -8321398077*y**8-821616812*y**9+1962521564*y**10-567924586*y**11+37313189*y**12
          +4343996*y**13-818694*y**14+70782*y**15)+r**16*(5116233322-16649001932*y
          -2200855190*y**2+104583439350*y**3-230047744371*y**4+202065446412*y**5
          +2813179868*y**6-171161108140*y**7+164283050565*y**8-71655184488*y**9
          +11390459990*y**10+2840757490*y**11-1650266445*y**12+296869960*y**13
          -27679516*y**14+2451876*y**15-48751*y**16))-r*(-1+r**2+y)**5*(35*r**34*(
          -1+y)**10-r**32*(-1+y)**6*(20753-78193*y+107564*y**2-63800*y**3+13263*y**4
          +65*y**5)-r**30*(-1+y)**4*(-324004+1797762*y-4027569*y**2+5055070*y**3
          -3850965*y**4+1635742*y**5-355071*y**6+28386*y**7+2129*y**8)-r**28*(
          -1+y)**2*(39120724-297367890*y+979283553*y**2-1820500021*y**3+2095117198*y**4
          -1544754418*y**5+728492380*y**6-209941552*y**7+32595862*y**8-1928972*y**9
          -565*y**10+8981*y**11)+r**26*(-438309788+4077738650*y-16933940673*y**2
          +41178094542*y**3-64754704928*y**4+68678931914*y**5-49661294611*y**6
          +24069153860*y**7-7351161736*y**8+1157385622*y**9+4895629*y**10-28884034*y**11
          +1863668*y**12+278774*y**13-13289*y**14)+(-1+y)**13*(113+904*y+4068*y**2
          +16070*y**3-18177*y**4-182544*y**5+48*y**6+153204*y**7-172921*y**8
          +22192*y**9+53316*y**10-21642*y**11+9113*y**12+1736*y**13+120*y**14)
          +r**24*(-3059920116+26807489830*y-103837119655*y**2+232182367431*y**3
          -326593275712*y**4+291022335388*y**5-148325551231*y**6+17901193061*y**7
          +30169035076*y**8-22632637666*y**9+7557059339*y**10-1298504919*y**11
          +117433424*y**12-10794752*y**13+748283*y**14+7819*y**15)+r**2*(-1+y)**10*(112155
          +541334*y+1575117*y**2+2883766*y**3+1169061*y**4-4925668*y**5-7978489*y**6
          +3560584*y**7+15685381*y**8-18886874*y**9+11059499*y**10-2945666*y**11
          -2736501*y**12+2677928*y**13-648287*y**14+31364*y**15+1296*y**16)+r**6*(
          -1+y)**8*(62162532+148271066*y+249690899*y**2-506275282*y**3-299734805*y**4
          -613230458*y**5+1050114983*y**6+112137066*y**7+10513543*y**8-242570986*y**9
          -418248831*y**10+556597490*y**11-188525015*y**12+13639114*y**13+2562341*y**14
          -107018*y**15+3361*y**16)+r**4*(-1+y)**9*(-2137884-8056226*y-19333975*y**2
          +5511014*y**3+69070163*y**4+113949870*y**5-279892291*y**6+253984538*y**7
          -10043365*y**8-307520158*y**9+285229555*y**10-77405982*y**11-10336263*y**12
          +8922226*y**13-1102905*y**14-11266*y**15+4949*y**16)-r**8*(-1+y)**7*(70260236
          +155537790*y+297343617*y**2-1032505814*y**3+3573944627*y**4-2209540308*y**5
          -10894470065*y**6+21328328340*y**7-13115328243*y**8-71669090*y**9+3553789007*y**10
          -1500042406*y**11+136009693*y**12+41872632*y**13-8573087*y**14-419160*y**15
          +38231*y**16)+r**22*(227682396-2581452578*y+9691614161*y**2-23349831382*y**3
          +51402484217*y**4-98726505846*y**5+139171334405*y**6-135098361274*y**7
          +89857678277*y**8-40750226686*y**9+11872686427*y**10-1594437018*y**11
          -245325837*y**12+144820630*y**13-22164081*y**14+121898*y**15+50291*y**16)
          -r**18*(-1+y)**2*(-71713776938+414557615550*y-943677483351*y**2+1063417687662*y**3
          -507064888451*y**4-146066257436*y**5+345165697395*y**6-217147185840*y**7
          +87340073419*y**8-35222611650*y**9+13492300479*y**10-2605285882*y**11
          -60020309*y**12+98054144*y**13-14296699*y**14+1737820*y**15+120087*y**16)
          -r**10*(-1+y)**6*(-4004617780+1002948218*y+1095292667*y**2+21078159266*y**3
          -22597056641*y**4-133906720*y**5-5753778779*y**6+18224179804*y**7-3978194519*y**8
          -6941797950*y**9+2704298653*y**10+914689922*y**11-666841671*y**12+109582628*y**13
          -6250909*y**14-1574528*y**15+164339*y**16)-r**16*(-1+y)**3*(-91275686294
          +378118719458*y-536039678913*y**2+107906028694*y**3+433963650965*y**4
          -255742217904*y**5-326969810891*y**6+474668030888*y**7-204408564501*y**8
          -6992561518*y**9+38993379457*y**10-14924926170*y**11+2468736875*y**12
          -188923268*y**13+6750603*y**14-581284*y**15+341803*y**16)-r**12*(-1
          +y)**5*(-9994102348+15052316018*y+2329882799*y**2+47197871202*y**3-183337171635*y**4
          +179084314750*y**5+13946233231*y**6-128329307654*y**7+73819934985*y**8
          +872318974*y**9-15924003467*y**10+6126340678*y**11-790092345*y**12-43567662*y**13
          +11189261*y**14-2343010*y**15+346223*y**16)-r**14*(-1+y)**4*(-53406991772
          +152804611862*y-120357853035*y**2+37497778522*y**3-160977617331*y**4
          +304457997150*y**5-209815651523*y**6+44263599154*y**7+5348416605*y**8
          +4982648066*y**9-3448515545*y**10-1326372306*y**11+1137602831*y**12-280496502*y**13
          +24792615*y**14-2232058*y**15+443267*y**16)+r**20*(-37309129596+299212060786*y
          -1038435675577*y**2+2003336813873*y**3-2229073989935*y**4+1157357218159*y**5
          +353785937259*y**6-1021419035999*y**7+701088665829*y**8-174866210805*y**9
          -51859725355*y**10+52123318939*y**11-16027555661*y**12+2174871973*y**13
          -84852935*y**14-1012333*y**15-1732909*y**16+34287*y**17))))/(-31352832000*logy**5*r**20*(
          -1+y)**10+126000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-13063680000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-2177280000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          -181440000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**3-7560000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)
          +6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(-4+8*y
          -4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((rhoLS*(-217728000*logy**5*r**17*(18
          +111*r**2+181*r**4+194*r**6+131*r**8+27*r**10)*(-1+y)**10-518400*logy**4*r**13*(
          -1+y)**6*(-10894*r**18*(-1+y)**4-3*r**16*(-9801+39204*y-58806*y**2
          +45714*y**3-16661*y**4+2030*y**5)+60*(-1+y)**5*(15+15*y+15*y**2
          -202*y**3+190*y**4-62*y**5+8*y**6)-10*r**14*(-12676+45034*y-56211*y**2
          +30362*y**3-4122*y**4-1316*y**5+63*y**6)-35*r**12*(-6661+18784*y-12456*y**2
          -7432*y**3+12333*y**4-4342*y**5+148*y**6+34*y**7)+10*r**2*(-1+y)**4*(
          -1681+6405*y**3-10598*y**4+6384*y**5-1610*y**6+176*y**7)+5*r**4*(-1
          +y)**3*(15387-22947*y+3780*y**2-4284*y**3+22715*y**4-24927*y**5+11088*y**6
          -1632*y**7+64*y**8)+70*r**10*(804+2604*y-15546*y**2+22341*y**3-12629*y**4
          +1371*y**5+1389*y**6-612*y**7+116*y**8)+7*r**8*(-17673+124992*y-296088*y**2
          +301122*y**3-100148*y**4-57892*y**5+65538*y**6-23782*y**7+2923*y**8
          +288*y**9)-14*r**6*(15452-78458*y+150987*y**2-131598*y**3+35017*y**4
          +23623*y**5-16712*y**6-1507*y**7+4598*y**8-1512*y**9+110*y**10))+17280*logy**3*r**9*(
          -1+y)**4*(-1+r**2+y)**2*(25246*r**22*(-1+y)**6-r**20*(-1+y)**2*(-206053
          +874704*y-1438286*y**2+1065209*y**3-387951*y**4+64057*y**5)-r**18*(
          -1+y)**2*(-1204048+3971510*y-4574938*y**2+1391197*y**3+804457*y**4
          -487895*y**5+28137*y**6)+30*(-1+y)**7*(-92-276*y-552*y**2+181*y**3
          -276*y**4+65*y**5+798*y**6-582*y**7+104*y**8)+r**16*(-4262132+21788298*y
          -43526841*y**2+44683246*y**3-25206071*y**4+8500922*y**5-3735643*y**6
          +2744716*y**7-1081221*y**8+138826*y**9)+2*r**14*(-7828471+40624571*y
          -83492697*y**2+86658765*y**3-42862773*y**4+128351*y**5+11759999*y**6
          -6196108*y**7+1376615*y**8-134427*y**9+1875*y**10)+r**2*(-1+y)**5*(47402
          +41882*y+36362*y**2-511153*y**3+489692*y**4-140252*y**5+313838*y**6
          -605967*y**7+453298*y**8-148922*y**9+17520*y**10)-2*r**6*(-1+y)**3*(
          -1581324+2219719*y-513123*y**2+5787337*y**3-17286538*y**4+19684760*y**5
          -10836326*y**6+2643968*y**7-25932*y**8-82997*y**9-5611*y**10+5517*y**11)
          +r**4*(-1+y)**4*(-433563+18716*y-27004*y**2+4234451*y**3-8017104*y**4
          +6004132*y**5-2384556*y**6+1098949*y**7-816981*y**8+410024*y**9-101524*y**10
          +8160*y**11)-r**8*(-1+y)**2*(9249228-24807350*y+21499283*y**2-15956292*y**3
          +37211578*y**4-58142048*y**5+46419348*y**6-19010478*y**7+3051252*y**8
          +355412*y**9-198885*y**10+26552*y**11)-r**12*(28088674-141744938*y
          +283294233*y**2-279895462*y**3+119852818*y**4+23382220*y**5-56834026*y**6
          +32162977*y**7-10232748*y**8+2172202*y**9-319819*y**10+29769*y**11)
          +r**10*(-23949518+120925270*y-243673602*y**2+246683260*y**3-122491370*y**4
          +19238016*y**5-3700230*y**6+17278439*y**7-14198715*y**8+3894690*y**9
          +270172*y**10-313195*y**11+36783*y**12))+288*logy**2*r**5*(-1+y)**2*(
          -1+r**2+y)**3*(7193*r**28*(-1+y)**8-r**26*(-1+y)**4*(-510154+2062195*y
          -3147240*y**2+2101535*y**3-649880*y**4+91584*y**5)+r**24*(-1+y)**2*(12148397
          -69898143*y+166587819*y**2-209361503*y**3+146013785*y**4-53844277*y**5
          +8371373*y**6-113429*y**7+33578*y**8)+r**22*(-1+y)**2*(18925667-109917414*y
          +272396787*y**2-337754510*y**3+205803465*y**4-40240722*y**5-22029711*y**6
          +17051428*y**7-4565700*y**8+375410*y**9)+6*(-1+y)**10*(899+4495*y
          +13485*y**2+20820*y**3+8675*y**4-30523*y**5-14045*y**6-4810*y**7+34430*y**8
          -18750*y**9+2824*y**10)-r**20*(-1+y)**2*(-97030454+418594497*y-661371282*y**2
          +264424069*y**3+488605310*y**4-719144371*y**5+385518768*y**6-88622373*y**7
          +8583356*y**8-1845130*y**9+267410*y**10)+r**2*(-1+y)**8*(12587+53943*y
          +140250*y**2-333545*y**3+767690*y**4+289211*y**5-2364196*y**6+1712055*y**7
          +614495*y**8-1437190*y**9+804502*y**10-188522*y**11+12720*y**12)+r**18*(
          -628357421+4132172473*y-11300441588*y**2+16744460021*y**3-14365026130*y**4
          +6813948347*y**5-1416442736*y**6+133508891*y**7-196092867*y**8+26513680*y**9
          +107334624*y**10-63047112*y**11+12220222*y**12-666404*y**13)-r**4*(-1
          +y)**7*(35172-372513*y-942291*y**2+2065712*y**3+3600970*y**4+162546*y**5
          -19979714*y**6+27143662*y**7-15206474*y**8+5538255*y**9-2857243*y**10
          +1380202*y**11-347396*y**12+38112*y**13)-r**6*(-1+y)**6*(18563641+10368622*y
          +7541533*y**2-178922766*y**3+231131930*y**4-99950852*y**5+62174086*y**6
          -142408746*y**7+148209447*y**8-72443980*y**9+16598661*y**10-1141808*y**11
          -185362*y**12+45594*y**13)+r**8*(-1+y)**5*(75839547-30545436*y-862434*y**2
          -662105502*y**3+1445506515*y**4-1271373594*y**5+583040652*y**6-234369722*y**7
          +174080599*y**8-108731140*y**9+32854822*y**10-2251716*y**11-768669*y**12
          +85078*y**13)-r**10*(-1+y)**4*(374590248-746893683*y+368141550*y**2
          -1105109175*y**3+3886381020*y**4-5533096176*y**5+3930236076*y**6-1285161540*y**7
          -50687010*y**8+210407555*y**9-84821922*y**10+17163607*y**11-1784010*y**12
          +88460*y**13)-r**12*(-1+y)**3*(-769173779+2451741289*y-2706333170*y**2
          +1738694930*y**3-2566699765*y**4+4660723793*y**5-4748805548*y**6+2444640050*y**7
          -377658495*y**8-199954385*y**9+99683886*y**10-13120116*y**11-263105*y**12
          +132415*y**13)+2*r**14*(-1+y)**2*(-913529797+4198982208*y-7464316344*y**2
          +6343951118*y**3-1827330450*y**4-1518628356*y**5+1968733194*y**6-1026877682*y**7
          +262226374*y**8+17923200*y**9-50950922*y**10+22947948*y**11-4754699*y**12
          +349708*y**13)+2*r**16*(-719905394+4845311056*y-13658897189*y**2+20810362826*y**3
          -17467078699*y**4+5212971908*y**5+5128618158*y**6-7191973032*y**7+4094157828*y**8
          -1183135412*y**9+108683661*y**10+25923936*y**11-3986529*y**12-1300554*y**13
          +247436*y**14))+12*logy*r*(-1+y)**2*(-1+r**2+y)**4*(525*r**34*(-1+y)**8
          +r**32*(-1+y)**4*(-2629+8416*y-7374*y**2+10990*y**3-9465*y**4+3038*y**5)
          +2*r**30*(-1+y)**2*(1108550-6474460*y+15656151*y**2-19900279*y**3+14102170*y**4
          -5507202*y**5+1072979*y**6-82603*y**7+6454*y**8)-6*(-1+y)**13*(-23
          -207*y-1035*y**2-3209*y**3-5249*y**4-1129*y**5+4927*y**6+5925*y**7
          -1756*y**8-3996*y**9+1552*y**10)-r**28*(-60756383+470078392*y-1584416830*y**2
          +3028639302*y**3-3595234978*y**4+2737182412*y**5-1335378352*y**6+404084020*y**7
          -69235527*y**8+4891788*y**9+114406*y**10+7750*y**11)+r**26*(422378680
          -3022959244*y+9312504538*y**2-15893513946*y**3+15974451849*y**4-8948488344*y**5
          +1779834824*y**6+887655264*y**7-650126054*y**8+150762556*y**9-13436786*y**10
          +1095330*y**11-84267*y**12)+r**24*(-334519787+2251145788*y-5980672276*y**2
          +9050815378*y**3-9913681241*y**4+9405602522*y**5-7888597404*y**6+5431150218*y**7
          -2881227861*y**8+1068517686*y**9-227390440*y**10+17286436*y**11+714753*y**12
          -17372*y**13)-r**2*(-1+y)**9*(21041+104653*y+312303*y**2+485829*y**3
          -73922*y**4-1307742*y**5+197894*y**6-144266*y**7+903837*y**8-225531*y**9
          +113451*y**10-618747*y**11+522388*y**12-172916*y**13+21728*y**14)+2*r**22*(1239535182
          -7131017240*y+16076452023*y**2-14564143095*y**3-5647672586*y**4+27294980937*y**5
          -28191383249*y**6+12882264795*y**7-794848369*y**8-1867966487*y**9+855207256*y**10
          -166475436*y**11+18150157*y**12-1454786*y**13+92898*y**14)-r**16*(-1
          +y)**2*(11810469125-41132661098*y+52062795255*y**2-38806037514*y**3
          +41127420735*y**4-51610558674*y**5+38897223193*y**6-13469510878*y**7
          +530880095*y**8-1167640138*y**9+2594309325*y**10-1262313970*y**11+169614173*y**12
          +24333094*y**13-5343997*y**14+1274*y**15)+r**8*(-1+y)**6*(-21407937
          -61237074*y-103963729*y**2+447764674*y**3-355367563*y**4+197001322*y**5
          -544780839*y**6+964750936*y**7-911068935*y**8+638640134*y**9-370642135*y**10
          +146350238*y**11-31340557*y**12+3058386*y**13-139121*y**14+2200*y**15)
          +r**4*(-1+y)**8*(639613+2383152*y+5647706*y**2+422898*y**3-7227053*y**4
          -18651568*y**5+8309496*y**6+9793548*y**7+24345639*y**8-45404664*y**9
          +23910822*y**10-3094398*y**11-1540279*y**12+724088*y**13-125208*y**14
          +6208*y**15)+2*r**6*(-1+y)**7*(2313990+6052482*y+10524215*y**2-3336454*y**3
          -58743445*y**4-35531359*y**5+177682028*y**6-125774968*y**7+758800*y**8
          +33271762*y**9-11071565*y**10-2101460*y**11+1705303*y**12-65421*y**13
          -88542*y**14+8634*y**15)+r**20*(-17160323233+102775676632*y-247610000022*y**2
          +302009819142*y**3-170524499191*y**4-11459836080*y**5+76334630724*y**6
          -41779795248*y**7+7799464069*y**8-2374082480*y**9+3408859182*y**10-1669205306*y**11
          +280567395*y**12-5920136*y**13-1026604*y**14+31156*y**15)+r**10*(-1
          +y)**5*(867381904+80380084*y-33884578*y**2-7180446012*y**3+11703928777*y**4
          -6136219171*y**5+1458209701*y**6-4166215645*y**7+6480648578*y**8-4027910010*y**9
          +938444944*y**10+109760290*y**11-101844027*y**12+20624009*y**13-1798867*y**14
          +56023*y**15)+2*r**14*(-1+y)**3*(4147602638-11033703918*y+8394744721*y**2
          -7882304542*y**3+32748489862*y**4-63455329568*y**5+58857792541*y**6-23242468502*y**7
          -3670271606*y**8+7757392206*y**9-3257393413*y**10+585940902*y**11-30333694*y**12
          +866848*y**13-1656393*y**14+215918*y**15)+r**12*(-1+y)**4*(-1291475451
          +957772460*y-300699740*y**2+13774038802*y**3-33569866441*y**4+36630405960*y**5
          -23982215230*y**6+11400978030*y**7-4286479029*y**8+876145492*y**9+144090008*y**10
          -82168930*y**11-34069015*y**12+26370152*y**13-5302926*y**14+327858*y**15)
          -r**18*(23236310246-150913947844*y+406137563690*y**2-580012376874*y**3
          +415791738261*y**4+12974077620*y**5-343058663132*y**6+353565947380*y**7
          -172108020087*y**8+27387985488*y**9+14040203782*y**10-8888628574*y**11
          +2082483555*y**12-271444864*y**13+43468876*y**14-6973548*y**15+276025*y**16))
          -r*(-1+r**2+y)**5*(1019*r**34*(-1+y)**10+r**32*(-1+y)**6*(-62861+240049*y
          -334736*y**2+207020*y**3-54447*y**4+5323*y**5)+r**30*(-1+y)**4*(842428
          -4720110*y+10689081*y**2-13387210*y**3+10475553*y**4-5143990*y**5+1476603*y**6
          -197154*y**7+3319*y**8)-r**28*(-1+y)**2*(75542884-573860190*y+1887706341*y**2
          -3507401317*y**3+4038590302*y**4-2984065978*y**5+1417690756*y**6-420008032*y**7
          +71950606*y**8-6232928*y**9+180263*y**10+32573*y**11)+r**26*(-425826308
          +3876418022*y-15729027609*y**2+37145225838*y**3-55968330524*y**4+55364382554*y**5
          -35293099255*y**6+13059652304*y**7-1497886612*y**8-908801714*y**9+453234769*y**10
          -78867742*y**11+2008340*y**12+1026194*y**13-74657*y**14)+r**24*(-2305085460
          +19729596922*y-74426721331*y**2+160492428447*y**3-212351087032*y**4
          +165570225064*y**5-50846092495*y**6-36372855295*y**7+52073250748*y**8
          -29357893390*y**9+9426264527*y**10-1877728647*y**11+282376256*y**12-39699140*y**13
          +2877827*y**14+8599*y**15)-(-1+y)**11*(-29-1830*y-11373*y**2-182334*y**3
          -679559*y**4-1027496*y**5+1604589*y**6+1989156*y**7+273253*y**8-3960582*y**9
          -118971*y**10+4037642*y**11-2643833*y**12+572756*y**13-17509*y**14-1904*y**15
          +24*y**16)-r**2*(-1+y)**10*(780933+3653974*y+10343547*y**2+10373174*y**3
          -10382505*y**4-41904260*y**5+24960481*y**6+2402636*y**7+22817507*y**8
          -30349450*y**9+13948741*y**10-5660554*y**11+3920217*y**12-1981256*y**13
          +454655*y**14-19064*y**15+1224*y**16)-r**4*(-1+y)**9*(-3083412-8312266*y
          -14998313*y**2+46746478*y**3-18858419*y**4+26155062*y**5+171251275*y**6
          -269223710*y**7-262346027*y**8+649436602*y**9-384541819*y**10+49058202*y**11
          +36613023*y**12-18716326*y**13+3973017*y**14-308906*y**15+11539*y**16)
          -r**6*(-1+y)**8*(-95246412-218807798*y-349987499*y**2+676582822*y**3
          +1085770049*y**4+664410650*y**5-4137682403*y**6+3022312782*y**7-504537295*y**8
          +397226446*y**9-776325945*y**10+441868594*y**11-83966533*y**12-16106002*y**13
          +10786855*y**14-1448518*y**15+62207*y**16)+r**22*(8254898964-70330582574*y
          +259896897113*y**2-552518519986*y**3+749439291989*y**4-671409695094*y**5
          +386727991625*y**6-119359290946*y**7-5271028003*y**8+23478447542*y**9
          -12480601709*y**10+5073902202*y**11-1966329417*y**12+528440014*y**13
          -64229781*y**14+367514*y**15+208547*y**16)-r**8*(-1+y)**7*(80888396
          +314182170*y+563242209*y**2-3365384618*y**3+7167797603*y**4-3905033928*y**5
          -3649931381*y**6+1198429128*y**7+6892237137*y**8-7860272750*y**9+3682798319*y**10
          -795277762*y**11+32196013*y**12-4067844*y**13+14825797*y**14-3481212*y**15
          +236723*y**16)-r**18*(-1+y)**2*(-130131657938+746634543330*y-1700412552447*y**2
          +1892135477394*y**3-788239097039*y**4-499748957876*y**5+811256751963*y**6
          -394989494484*y**7+45780432979*y**8+21289965330*y**9+816555903*y**10
          -4651742014*y**11+582035431*y**12+285208352*y**13-80193691*y**14+4767136*y**15
          +517671*y**16)-r**10*(-1+y)**6*(-7107538876+2744196614*y+2349052739*y**2
          +48735962798*y**3-89874380069*y**4+51322666376*y**5-15530681963*y**6
          +38403055888*y**7-54902982335*y**8+31611676974*y**9-5365867403*y**10
          -2397994330*y**11+1301276373*y**12-246797788*y**13+39645395*y**14-7413572*y**15
          +651179*y**16)-r**12*(-1+y)**5*(-6480564220+10188253478*y+4375413839*y**2
          -21735071466*y**3+47697676893*y**4-119787392798*y**5+163017013519*y**6
          -85045179938*y**7-20850668703*y**8+46586624794*y**9-20278525979*y**10
          +1015916578*y**11+1954742199*y**12-701799906*y**13+120139613*y**14-15344278*y**15
          +1262375*y**16)-r**16*(-1+y)**3*(-24980096654+97456830014*y-104658306513*y**2
          -54839897006*y**3+73881826133*y**4+305991060060*y**5-623428352591*y**6
          +435407852564*y**7-57498663345*y**8-96779253418*y**9+64551724345*y**10
          -17385928662*y**11+2003270099*y**12-120387824*y**13+36434535*y**14-10416976*y**15
          +1361239*y**16)-r**14*(-1+y)**4*(-62195859428+183952890362*y-157156367811*y**2
          +71251696366*y**3-315054182343*y**4+701989699566*y**5-662482112807*y**6
          +240560844730*y**7+62162908821*y**8-87617292346*y**9+29294092375*y**10
          -4722071214*y**11+1517801531*y**12-705238062*y**13+157675539*y**14-20215738*y**15
          +1658459*y**16)+r**20*(-29459954700+235794614878*y-811990939861*y**2
          +1543895694221*y**3-1675397251019*y**4+818169459451*y**5+310966173447*y**6
          -743377885379*y**7+445332419553*y**8-54518415297*y**9-75712669927*y**10
          +46165795927*y**11-10613227049*y**12+693320401*y**13+32288341*y**14+27236351*y**15
          -6797377*y**16+138039*y**17))))/(-41803776000*logy**5*r**20*(-1+y)**10+168000*(r**8*(
          -1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5-17418240000*logy**4*r**16*(
          -1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -2903040000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2-241920000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3-10080000*logy*(
          -1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(
          -4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2
          +y**3))**4))
      resNP += ((mupi*(-217728000*logy**5*r**19*(3+5*r**2+10*r**4+13*r**6
          +27*r**8)*(-1+y)**10-518400*logy**4*r**15*(-1+y)**6*(1522*r**16*(-1+y)**4
          -15*r**14*(-857+3428*y-5142*y**2+3386*y**3-1333*y**4+182*y**5)-14*r**12*(
          -3034+8086*y-4029*y**2-7444*y**3+8226*y**4-2840*y**5+225*y**6)-35*r**10*(883
          -4312*y+8028*y**2-7484*y**3+2637*y**4-38*y**5-124*y**6+2*y**7)+10*(
          -1+y)**4*(-197+2583*y**3-4270*y**4+2520*y**5-658*y**6+64*y**7)+r**2*(
          -1+y)**4*(2769+30660*y**3-60515*y**4+35056*y**5-8120*y**6+640*y**7)
          +70*r**8*(-144+876*y-1914*y**2+1503*y**3+1367*y**4-3147*y**5+2283*y**6
          -750*y**7+88*y**8)+7*r**6*(-1401+7104*y-13656*y**2+6054*y**3+16424*y**4
          -22424*y**5+7386*y**6+3886*y**7-3229*y**8+576*y**9)-70*r**4*(98-482*y
          +903*y**2-252*y**3-713*y**4-527*y**5+2938*y**6-3271*y**7+1676*y**8
          -408*y**9+38*y**10))+17280*logy**3*r**11*(-1+y)**4*(-1+r**2+y)**2*(4982*r**20*(
          -1+y)**6+r**18*(-1+y)**2*(-56551+216240*y-299450*y**2+169175*y**3
          -69405*y**4+11671*y**5)-r**16*(-1+y)**2*(474916-1820162*y+2607862*y**2
          -1647133*y**3+563177*y**4-131869*y**5+24789*y**6)+r**14*(-1271596+6774666*y
          -14672901*y**2+15565508*y**3-8464657*y**4+2137906*y**5+177169*y**6-335494*y**7
          +36537*y**8+8762*y**9)+2*r**12*(-1854233+8558359*y-15063909*y**2+9656913*y**3
          +2368185*y**4-5653877*y**5+2214181*y**6-376856*y**7+187207*y**8-79665*y**9
          +7995*y**10)+(-1+y)**5*(-1118-1118*y-1118*y**2+11437*y**3-47738*y**4
          +36878*y**5+260248*y**6-531027*y**7+393218*y**8-129682*y**9+16320*y**10)
          +r**10*(-1327010+7131154*y-14755653*y**2+7851662*y**3+9953722*y**4
          -9633188*y**5-6334786*y**6+12219163*y**7-6342372*y**8+1177798*y**9+36923*y**10
          -21513*y**11)-r**6*(-1+y)**2*(-304356+1068122*y-1011257*y**2-6513072*y**3
          +28156418*y**4-43121920*y**5+31529844*y**6-10141848*y**7-62538*y**8
          +918742*y**9-215319*y**10+12184*y**11)-2*r**4*(-1+y)**3*(-123582+188981*y
          -57423*y**2+2543597*y**3-7813028*y**4+9040486*y**5-4944400*y**6+1488178*y**7
          -580152*y**8+361913*y**9-126779*y**10+15909*y**11)+r**2*(-1+y)**4*(
          -53919+2236*y+2236*y**2+745051*y**3-1319724*y**4+935924*y**5-1168416*y**6
          +2047529*y**7-1880361*y**8+876064*y**9-196640*y**10+16320*y**11)+r**8*(
          -478834+2791958*y-6615894*y**2+7161920*y**3-14357110*y**4+43341228*y**5
          -67912626*y**6+55095433*y**7-22579815*y**8+2859990*y**9+1054136*y**10
          -399077*y**11+38691*y**12))+288*logy**2*r**7*(-1+y)**2*(-1+r**2+y)**3*(6121*r**26*(
          -1+y)**8-r**24*(-1+y)**4*(-120344+499739*y-795516*y**2+626839*y**3
          -177766*y**4+19008*y**5)-r**22*(-1+y)**2*(-106039+118869*y+1028499*y**2
          -3651629*y**3+6407405*y**4-6680341*y**5+3667661*y**6-924539*y**7+77714*y**8)
          +r**20*(-1+y)**2*(-19470749+106844562*y-238717617*y**2+273306434*y**3
          -179684835*y**4+77729634*y**5-23681547*y**6+4132952*y**7-606564*y**8
          +103030*y**9)+5*r**18*(-1+y)**2*(-9230926+47975043*y-101295558*y**2
          +105457619*y**3-53107718*y**4+9189067*y**5+1960980*y**6-2403243*y**7
          +1458076*y**8-444926*y**9+37546*y**10)-(-1+y)**8*(-19561-58683*y
          -117366*y**2+24745*y**3+260870*y**4+464057*y**5-687244*y**6+518217*y**7
          -510145*y**8-270370*y**9+805654*y**10-444398*y**11+76224*y**12)+r**16*(
          -84385267+547606181*y-1496733976*y**2+2067969877*y**3-1376547350*y**4
          +181698799*y**5+349928228*y**6-300944453*y**7+166205271*y**8-72838000*y**9
          +24903468*y**10-8971884*y**11+2233154*y**12-208048*y**13)-r**4*(-1+y)**6*(536561
          +1017806*y+1281065*y**2-14320062*y**3+2913430*y**4+742328*y**5+104657138*y**6
          -218148990*y**7+180950679*y**8-69813380*y**9+9474861*y**10+1113056*y**11
          -374150*y**12+11658*y**13)-5*r**8*(-1+y)**4*(4532694-8955999*y+4917210*y**2
          -128312787*y**3+467337618*y**4-620738304*y**5+365147496*y**6-65437044*y**7
          -23317332*y**8+8981687*y**9+122370*y**10+116263*y**11-201936*y**12+22064*y**13)
          -r**2*(-1+y)**7*(-112896-167109*y-162639*y**2+18304*y**3+2076710*y**4
          -466038*y**5-10403722*y**6+13854758*y**7-6034078*y**8+2855715*y**9-3789791*y**10
          +2545706*y**11-739144*y**12+76224*y**13)-r**10*(-1+y)**3*(59273213-219204391*y
          +248317118*y**2+429515650*y**3-2586539285*y**4+4509720649*y**5-3611432248*y**6
          +1154938774*y**7+211126305*y**8-287160565*y**9+87372138*y**10-9393936*y**11
          -507217*y**12+113795*y**13)+2*r**12*(-1+y)**2*(-18636809+137586324*y
          -336722736*y**2+72397726*y**3+361416510*y**4+59501988*y**5-769329948*y**6
          +691448222*y**7-201870832*y**8-21607260*y**9+16389296*y**10+2156574*y**11
          -1462561*y**12+144506*y**13)+r**6*(-1+y)**5*(9995829-7614492*y-1816038*y**2
          -174568404*y**3+416533215*y**4-367216878*y**5+279500064*y**6-406196614*y**7
          +429362573*y**8-232159640*y**9+56682074*y**10-1850922*y**11-1408773*y**12
          +170006*y**13)-2*r**14*(138706129-838727015*y+2063711071*y**2-2278816453*y**3
          +397574273*y**4+1526183597*y**5-1251665880*y**6-74718897*y**7+570221751*y**8
          -340369856*y**9+112269099*y**10-30491430*y**11+6945351*y**12-848298*y**13
          +26558*y**14))+12*logy*r**3*(-1+y)**2*(-1+r**2+y)**4*(-387*r**32*(-1
          +y)**8-r**30*(-1+y)**4*(-18145+71032*y-102678*y**2+69034*y**3-18477*y**4
          +2210*y**5)+2*r**28*(-1+y)**2*(656482-3827504*y+9250419*y**2-11929277*y**3
          +8633438*y**4-3313518*y**5+575731*y**6-29717*y**7+2186*y**8)+r**26*(643651
          -4401776*y+14076410*y**2-29472282*y**3+34128182*y**4-4059752*y**5-37213396*y**6
          +42206680*y**7-19851993*y**8+4347168*y**9-448694*y**10+21802*y**11)
          +r**24*(-48350836+390069388*y-1364798254*y**2+2742642954*y**3-3580313703*y**4
          +3268393728*y**5-2148516896*y**6+985403616*y**7-286055194*y**8+43977668*y**9
          -2583562*y**10+80838*y**11-24147*y**12)-r**22*(616890631-4197195140*y
          +12069344744*y**2-18561076838*y**3+16135115323*y**4-7639592530*y**5+1511732436*y**6
          +298442022*y**7-375539835*y**8+182146002*y**9-51008476*y**10+11812504*y**11
          -2051991*y**12+107548*y**13)+2*r**20*(-172175946+1134512756*y-3303765117*y**2
          +5249843583*y**3-4434099022*y**4+1083023295*y**5+1583219711*y**6-2109181263*y**7
          +1587406927*y**8-861310993*y**9+282075176*y**10-40310292*y**11-1588795*y**12
          +618290*y**13+9690*y**14)+(-1+y)**9*(-1573-7865*y-23595*y**2-40077*y**3
          -50114*y**4-10254*y**5+206990*y**6+11230*y**7-183141*y**8+161523*y**9
          -228723*y**10+172575*y**11-5060*y**12-42332*y**13+12416*y**14)-r**6*(
          -1+y)**6*(19625829+28299570*y+31263665*y**2-128769998*y**3-145332835*y**4
          +8531878*y**5+1048898733*y**6-1537030712*y**7+859367079*y**8-267602902*y**9
          +177034115*y**10-137608978*y**11+49746647*y**12-7046706*y**13+85087*y**14
          +7528*y**15)+2*r**4*(-1+y)**7*(-772122-1994418*y-3587537*y**2+5821972*y**3
          +6919585*y**4+14324011*y**5-11925866*y**6+6871522*y**7-18936106*y**8
          -17578252*y**9+49838537*y**10-31540816*y**11+7240715*y**12-141741*y**13
          -112758*y**14+11274*y**15)+r**2*(-1+y)**8*(72185+295032*y+753310*y**2
          +599286*y**3-1178473*y**4-3579524*y**5+3489636*y**6-3575520*y**7+2267223*y**8
          +3814596*y**9-4055202*y**10+575082*y**11+92185*y**12+209416*y**13-99648*y**14
          +12416*y**15)+2*r**12*(-1+y)**3*(159356146-227209518*y+127939085*y**2
          -7187019344*y**3+28509966752*y**4-41896457362*y**5+26920474691*y**6-3545967010*y**7
          -5859486802*y**8+4186206006*y**9-1293853649*y**10+176564952*y**11+4863400*y**12
          -2539054*y**13+26217*y**14+33490*y**15)+r**8*(-1+y)**5*(-23016124+18780176*y
          +39766282*y**2-767735292*y**3+954877853*y**4-632871239*y**5+3938784929*y**6
          -8976895733*y**7+8696573590*y**8-3977194230*y**9+574230476*y**10+213251570*y**11
          -102356199*y**12+16137277*y**13-963623*y**14+42287*y**15)-r**14*(-1
          +y)**2*(-2825235467+9634727582*y-10731229077*y**2+3176971122*y**3+16227718965*y**4
          -43531291194*y**5+46560251339*y**6-19162677578*y**7-3226202921*y**8+5539833298*y**9
          -1259111463*y**10-263331746*y**11+118722655*y**12-6103126*y**13-1876463*y**14
          +134074*y**15)+r**10*(-1+y)**4*(-370551951+530067988*y+23739728*y**2
          +4918817702*y**3-16080997121*y**4+16980195492*y**5-8599244006*y**6+6264905334*y**7
          -7958213529*y**8+5481308132*y**9-1547706956*y**10+24072418*y**11+50079913*y**12
          +2617252*y**13-2153886*y**14+179490*y**15)+r**18*(-1278887213+7072222832*y
          -15260032506*y**2+11124519186*y**3+5663230381*y**4-9016161708*y**5-6256878192*y**6
          +16123530084*y**7-12183938275*y**8+5236365980*y**9-1409481138*y**10+156474710*y**11
          +1340547*y**12+6690464*y**13-2556836*y**14+209684*y**15)+r**16*(-5116233322
          +29570752172*y-68868771130*y**2+65185861614*y**3+12752208831*y**4-77726979324*y**5
          +53700331900*y**6+1661815780*y**7-18965219493*y**8+10551157968*y**9-3879600566*y**10
          +1517924954*y**11-424361175*y**12+33588704*y**13+8932276*y**14-1450188*y**15
          +40999*y**16))+r*(-1+r**2+y)**5*(101*r**34*(-1+y)**10+r**32*(-1+y)**6*(
          -24719+93727*y-130040*y**2+78236*y**3-17361*y**4+505*y**5)-r**30*(
          -1+y)**4*(-1356664+7803798*y-18464127*y**2+23282818*y**3-16640511*y**4
          +6568498*y**5-1350753*y**6+117822*y**7+599*y**8)-r**28*(-1+y)**2*(-13194464
          +96247278*y-303314685*y**2+537085769*y**3-571096958*y**4+349440698*y**5
          -93492608*y**6-13756924*y**7+14993902*y**8-2852816*y**9+55757*y**10
          +10331*y**11)+r**26*(-96948416+920544086*y-3884519619*y**2+9573770730*y**3
          -15379406660*y**4+17175027062*y**5-14005083397*y**6+8652068612*y**7-4079989108*y**8
          +1409989834*y**9-331370561*y**10+52248146*y**11-7102408*y**12+836138*y**13
          -30839*y**14)+(-1+y)**13*(179+1432*y+6444*y**2+21194*y**3+17229*y**4
          -67464*y**5-46560*y**6-6564*y**7-34939*y**8+43936*y**9-4980*y**10-4662*y**11
          +6155*y**12+1280*y**13+120*y**14)-r**24*(191413848-1769730454*y+7304493133*y**2
          -18043162341*y**3+30453901816*y**4-38031013492*y**5+36387919537*y**6
          -26185775939*y**7+13159214792*y**8-3903367574*y**9+274082791*y**10+239476437*y**11
          -91565624*y**12+15460544*y**13-1243397*y**14+30323*y**15)+r**2*(-1+y)**10*(116121
          +560834*y+1632627*y**2+2632570*y**3+1104411*y**4-3894940*y**5-4635379*y**6
          -1705256*y**7+7480783*y**8-3006614*y**9+5782085*y**10-6687926*y**11
          +650229*y**12+1649072*y**13-530597*y**14+26084*y**15+1896*y**16)+r**4*(
          -1+y)**9*(-1105224-4115510*y-9870793*y**2+5370506*y**3+27781637*y**4
          +58174098*y**5-79518937*y**6+93195254*y**7-39522559*y**8-135618586*y**9
          +153114469*y**10-52164978*y**11+5382039*y**12-1117922*y**13+1045149*y**14
          -209518*y**15+12875*y**16)+r**6*(-1+y)**8*(9847344+16231838*y+18401453*y**2
          -119898286*y**3+4275841*y**4-116954918*y**5-371051311*y**6+676948878*y**7
          +41587501*y**8+160377122*y**9-987602817*y**10+834573662*y**11-248008181*y**12
          +13187110*y**13+5828387*y**14-795134*y**15+51511*y**16)+r**22*(-3813895296
          +31548926602*y-113555674129*y**2+226854219158*y**3-263753278405*y**4
          +159074149782*y**5-4006781005*y**6-74630913934*y**7+67042572887*y**8
          -34889637082*y**9+13248695077*y**10-3799938678*y**11+800965113*y**12
          -134329670*y**13+16054137*y**14-1021138*y**15+54581*y**16)+r**8*(-1
          +y)**7*(271101136+270765798*y+209833905*y**2-2452501366*y**3-492009233*y**4
          +191419572*y**5+10950011039*y**6-17766090564*y**7+11659254993*y**8-3818434858*y**9
          +863280799*y**10-316432406*y**11+131229809*y**12-32042352*y**13+6753041*y**14
          -854832*y**15+139519*y**16)+r**10*(-1+y)**6*(1136111512-224151182*y
          -592069829*y**2+723644914*y**3-8039704921*y**4+10283138848*y**5-17322684223*y**6
          +42052978580*y**7-53387891971*y**8+31197630594*y**9-5665606195*y**10
          -2311281686*y**11+1314437649*y**12-231970868*y**13+23825527*y**14-1981840*y**15
          +279091*y**16)+r**12*(-1+y)**5*(5952524656-8766918278*y-274754609*y**2
          -31512056526*y**3+114593749149*y**4-125850493714*y**5+47987130539*y**6
          +1603967954*y**7-3765149067*y**8+837288518*y**9-1231630579*y**10+3283142*y**11
          +647765055*y**12-305995182*y**13+67015033*y**14-6324938*y**15+438847*y**16)
          +r**18*(-1+y)**2*(-14568881878+84153234246*y-193455800535*y**2+178477380798*y**3
          +4619454989*y**4-110968301596*y**5+24532562943*y**6+73927454592*y**7
          -70129873129*y**8+26911791054*y**9-2289104817*y**10-2686800002*y**11
          +1130057243*y**12-163113944*y**13+10706857*y**14-2705884*y**15+459063*y**16)
          +r**14*(-1+y)**4*(11018181848-28189339346*y+15082076949*y**2+47286659642*y**3
          -185643913551*y**4+320499868158*y**5-266006981491*y**6+63232924418*y**7
          +65355615777*y**8-61066149062*y**9+19271736551*y**10-1513212114*y**11
          -165996917*y**12-118512294*y**13+62731863*y**14-8411882*y**15+561451*y**16)
          +r**16*(-1+y)**3*(4993027478-14002981094*y+4584396471*y**2+55769857718*y**3
          -115349532623*y**4+90183696744*y**5-34857053467*y**6+21820637896*y**7
          -11573854953*y**8-10210222166*y**9+14130965321*y**10-5998767786*y**11
          +936692383*y**12-13464940*y**13+8229339*y**14-4894868*y**15+580547*y**16)
          +r**20*(5079680328-42449575862*y+152071921169*y**2-296981343649*y**3
          +324903242791*y**4-155568958007*y**5-65705947623*y**6+153817665499*y**7
          -106440935577*y**8+35580189873*y**9-4160006725*y**10+1057311517*y**11
          -2189472515*y**12+1295375851*y**13-351578789*y**14+45501929*y**15-3314707*y**16
          +244497*y**17))))/(-41803776000*logy**5*r**20*(-1+y)**10+168000*(r**8*(-1
          +y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5-17418240000*logy**4*r**16*(
          -1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -2903040000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2-241920000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3-10080000*logy*(
          -1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(
          -4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2
          +y**3))**4))
      resNP += ((api*muWC**3*(217728000*logy**5*r**20*(144+426*r**2+569*r**4
          +623*r**6+522*r**8+393*r**10+81*r**12)*(-1+y)**11+518400*logy**4*r**16*(
          -1+y)**6*(30318*r**20*(-1+y)**5+96*(-1+y)**7*(-118-236*y-354*y**2
          +543*y**3-170*y**4+20*y**5)+3*r**18*(-22207+111035*y-222070*y**2+208000*y**3
          -100745*y**4+18637*y**5+630*y**6)+4*r**2*(-1+y)**6*(10103+10103*y
          +10103*y**2-51322*y**3+43598*y**4-11170*y**5+1080*y**6)+2*r**4*(-1
          +y)**5*(-220599+151200*y+75600*y**2+6055*y**3-132230*y**4+104664*y**5
          -25550*y**6+2640*y**7)-6*r**16*(30456-123930*y+176985*y**2-55325*y**3
          -72000*y**4+74544*y**5-26005*y**6+2835*y**7)+r**14*(-684973+2599565*y
          -3135880*y**2-23360*y**3+2890045*y**4-2394047*y**5+776370*y**6-87990*y**7
          +3150*y**8)+r**6*(-1+y)**3*(-662341+2219282*y-2004241*y**2-112000*y**3
          +858655*y**4-138194*y**5-269017*y**6+149136*y**7-22080*y**8+960*y**9)
          +14*r**12*(-23648+39940*y+115870*y**2-398345*y**3+433010*y**4-197842*y**5
          +12040*y**6+24015*y**7-9900*y**8+1620*y**9)+7*r**10*(-16785-102975*y
          +673200*y**2-1269430*y**3+931570*y**4+35596*y**5-514010*y**6+351860*y**7
          -102535*y**8+9765*y**9+864*y**10)-14*r**8*(-18424+177470*y-568315*y**2
          +812035*y**3-449645*y**4-162482*y**5+371145*y**6-200595*y**7+33345*y**8
          +9330*y**9-4194*y**10+330*y**11))-17280*logy**3*r**12*(-1+y)**4*(-20922*r**28*(
          -1+y)**7+r**26*(-1+y)**2*(702713-3513565*y+7027130*y**2-6927995*y**3
          +3754240*y**4-1056668*y**5+127425*y**6)+24*(-1+y)**11*(-433-1732*y
          -4330*y**2-3440*y**3+1855*y**4+9868*y**5-7268*y**6+1280*y**7)+r**24*(
          -1+y)**2*(4955204-21137860*y+33180320*y**2-19902815*y**3-1449800*y**4
          +7167646*y**5-2811240*y**6+284865*y**7)+2*r**2*(-1+y)**9*(-38038-76076*y
          -114114*y**2+425203*y**3-150605*y**4+84523*y**5-362359*y**6+407184*y**7
          -175778*y**8+23160*y**9)+r**22*(-611999+12278513*y-64816359*y**2+174372100*y**3
          -263843890*y**4+235359744*y**5-125853008*y**6+39257714*y**7-6600525*y**8
          +786105*y**9-151995*y**10)+r**4*(-1+y)**8*(2623074+1263714*y+584034*y**2
          -19404191*y**3+23330564*y**4-6768964*y**5-3577934*y**6+2393931*y**7
          +10366*y**8-307654*y**9+52560*y**10)+r**20*(1894782+8664846*y-92537658*y**2
          +279290905*y**3-401497640*y**4+287318188*y**5-64284196*y**6-55741012*y**7
          +55795490*y**8-23288070*y**9+5222670*y**10-552705*y**11)+r**6*(-1+y)**7*(
          -1539873+4849440*y+2424720*y**2+11525225*y**3-48631770*y**4+45533106*y**5
          -10553330*y**6-7016455*y**7+4659965*y**8-746740*y**9-106668*y**10+24480*y**11)
          +r**18*(46501946-243316862*y+491779926*y**2-433236050*y**3+88737110*y**4
          +63224088*y**5+86220614*y**6-204266017*y**7+147280485*y**8-48768710*y**9
          +5501656*y**10+701103*y**11-182889*y**12)+r**8*(-1+y)**5*(-32221332
          +117386424*y-129780972*y**2-32040365*y**3+176864925*y**4-114093636*y**5
          -19662458*y**6+51341309*y**7-18326875*y**8-1433300*y**9+2399158*y**10
          -511736*y**11+15858*y**12)+r**14*(-1+y)**2*(-25342978+140814290*y-238379080*y**2
          -35423770*y**3+570000750*y**4-726886764*y**5+369680030*y**6+9580405*y**7
          -105272015*y**8+48475890*y**9-7406718*y**10-264255*y**11+96615*y**12)
          -r**10*(-1+y)**4*(-10893601+112161723*y-285059103*y**2+224979926*y**3
          +132910985*y**4-359049354*y**5+231747292*y**6-23064107*y**7-42670576*y**8
          +21807195*y**9-3494785*y**10-252975*y**11+121380*y**12)-r**12*(-1+y)**3*(
          -44180602+145770088*y-85056492*y**2-189337322*y**3+245897408*y**4+35013732*y**5
          -230978278*y**6+154012787*y**7-24296763*y**8-14137868*y**9+7243810*y**10
          -1410045*y**11+149145*y**12)+r**16*(-31304336+258858992*y-849855216*y**2
          +1382562850*y**3-1008785940*y**4-128812138*y**5+834958166*y**6-633773763*y**7
          +159782420*y**8+56557865*y**9-55889726*y**10+18615017*y**11-3128496*y**12
          +214305*y**13))-288*logy**2*r**8*(-1+y)**2*(-1+r**2+y)**2*(4119*r**32*(
          -1+y)**9+r**30*(-1+y)**4*(125317-618347*y+1211980*y**2-792055*y**3
          +395240*y**4-143002*y**5+28707*y**6)-48*(-1+y)**13*(-31-186*y-651*y**2
          -1521*y**3-2251*y**4-1044*y**5+4811*y**6+3251*y**7-5804*y**8+1676*y**9)
          -r**28*(-1+y)**2*(-23390871+160212533*y-468413966*y**2+758483677*y**3
          -744078498*y**4+455042741*y**5-170563678*y**6+37014451*y**7-4367067*y**8
          +310278*y**9)-r**26*(-1+y)**2*(-160300938+1035110444*y-2817176291*y**2
          +4089802821*y**3-3399902025*y**4+1574128817*y**5-286747319*y**6-77667299*y**7
          +51492009*y**8-9399415*y**9+480396*y**10)+2*r**2*(-1+y)**11*(14537+59636*y
          +152810*y**2-6595*y**3-622875*y**4-1187814*y**5+2077278*y**6-812935*y**7
          -230480*y**8+391200*y**9-130898*y**10+2136*y**11)+r**24*(-1+y)**2*(622014395
          -3565515499*y+8243060477*y**2-9165722337*y**3+3682897379*y**4+2357231135*y**5
          -3602509821*y**6+1840722533*y**7-458599978*y**8+62333956*y**9-8772420*y**10
          +940980*y**11)+r**4*(-1+y)**9*(4982845+8156254*y+10459971*y**2-48421385*y**3
          -23239125*y**4-6761385*y**5+233878337*y**6-295163147*y**7+126425150*y**8
          +7100275*y**9-25275460*y**10+9039884*y**11-1304374*y**12+38160*y**13)
          +r**14*(-1+y)**4*(-3440999425+19039779563*y-38233831438*y**2+25245013525*y**3
          +22471768180*y**4-50265028970*y**5+31310404789*y**6-1781647094*y**7-7115574825*y**8
          +3097482265*y**9-126939630*y**10-202055927*y**11+47052782*y**12-3245250*y**13
          +73455*y**14)-r**6*(-1+y)**8*(21059777+13651791*y+11316235*y**2-307738694*y**3
          +460411151*y**4-265433129*y**5+238976443*y**6-413693855*y**7+364059208*y**8
          -138438362*y**9+12062202*y**10+4096341*y**11+608920*y**12-716364*y**13
          +114336*y**14)+r**10*(-1+y)**6*(-64699322+405969976*y-360598413*y**2
          +2410929087*y**3-9911013743*y**4+14893101129*y**5-9134959872*y**6+159014646*y**7
          +2782474936*y**8-1399155484*y**9+187755393*y**10+37310371*y**11-7513183*y**12
          -959973*y**13+118452*y**14)-r**8*(-1+y)**7*(-438315019+453005992*y
          +101561761*y**2+3009078648*y**3-8260835242*y**4+7258697938*y**5-928612154*y**6
          -2515119572*y**7+1555888209*y**8-86260826*y**9-219187469*y**10+78188612*y**11
          -6544764*y**12-1293232*y**13+251118*y**14)+r**12*(-1+y)**5*(3292703911
          -13362014292*y+17889076913*y**2+7305209*y**3-23783769366*y**4+22877912623*y**5
          -3317647346*y**6-7719997526*y**7+5214804727*y**8-779250628*y**9-430544709*y**10
          +186857213*y**11-12842712*y**12-4172311*y**13+546294*y**14)-2*r**18*(
          -1+y)**2*(-2616148449+12660305927*y-22133680949*y**2+10547546988*y**3
          +15921633493*y**4-24396142342*y**5+8911982696*y**6+5573636948*y**7-6540036106*y**8
          +2168515134*y**9+24970141*y**10-207437648*y**11+62849026*y**12-10113507*y**13
          +891648*y**14)-r**16*(-1+y)**3*(1210838839-2435498638*y-4729712835*y**2
          +18353695832*y**3-20026977743*y**4+7173574122*y**5+3283395831*y**6-3404372730*y**7
          -667784069*y**8+2234479286*y**9-1271844361*y**10+295344082*y**11-6115035*y**12
          -8930538*y**13+1083957*y**14)+r**22*(50599229+1194615*y-1844888535*y**2
          +10438883208*y**3-27951793307*y**4+43847124057*y**5-44174395105*y**6
          +29877803965*y**7-13373041656*y**8+3235247544*y**9+254891914*y**10-518043885*y**11
          +185565470*y**12-30493152*y**13+1681638*y**14)-r**20*(36771507-1939424741*y
          +13429243323*y**2-45208676180*y**3+87667090810*y**4-100670655298*y**5
          +61768799292*y**6-4519733446*y**7-26093770745*y**8+24665025725*y**9-12159739425*y**10
          +3534846474*y**11-529013052*y**12+16074050*y**13+2839890*y**14+321816*y**15))
          +12*logy*r**6*(-1+y)**2*(-1+r**2+y)**3*(2385*r**36*(-1+y)**9+r**34*(
          -1+y)**4*(4138-13535*y+5605*y**2-4288*y**3-4030*y**4-3289*y**5+3495*y**6)
          -r**32*(-1+y)**2*(-2499047+17300876*y-51217362*y**2+85909374*y**3-88315640*y**4
          +56026478*y**5-21819070*y**6+5106042*y**7-680081*y**8+42510*y**9)+r**30*(
          -92832427+822171939*y-3225593916*y**2+7334476494*y**3-10731178692*y**4
          +10659360582*y**5-7391888696*y**6+3604750816*y**7-1217390879*y**8+273006087*y**9
          -37729180*y**10+2875682*y**11-123810*y**12)+6*(-1+y)**12*(-433-2598*y
          -9093*y**2-20350*y**3-25180*y**4-9574*y**5-16164*y**6+59526*y**7+98465*y**8
          -128620*y**9-20543*y**10+80512*y**11-41708*y**12+7760*y**13)+r**28*(
          -1248626161+10380051018*y-37855094229*y**2+79184457362*y**3-104367389395*y**4
          +89333090247*y**5-48657685870*y**6+14975071536*y**7-1164691403*y**8-836199260*y**9
          +288257659*y**10-32574058*y**11+960023*y**12+74931*y**13)+r**2*(-1+y)**11*(
          -117079-506177*y-1316589*y**2-2475225*y**3+850474*y**4+12510458*y**5
          +24113154*y**6-17435122*y**7-44452215*y**8+47859267*y**9-12672229*y**10
          -3209477*y**11+2736436*y**12-658860*y**13+65184*y**14)+r**26*(-3422687737
          +25998038661*y-84804172674*y**2+148830595416*y**3-143094329830*y**4
          +55708698813*y**5+31664926091*y**6-57106748822*y**7+38108392293*y**8
          -15209772027*y**9+3959655154*y**10-721775202*y**11+102998666*y**12-10910119*y**13
          +585717*y**14)+r**24*(-12131337947+84787262802*y-246260020413*y**2+363690421282*y**3
          -225299883555*y**4-122332061436*y**5+361010923015*y**6-321546655940*y**7
          +149982888295*y**8-31459117006*y**9-3413199423*y**10+3897921258*y**11
          -1107957497*y**12+182502248*y**13-15802939*y**14+341256*y**15)+r**22*(10010797805
          -80526708117*y+281786680740*y**2-605955087166*y**3+861976404051*y**4
          -790418718231*y**5+410501527102*y**6-31383510752*y**7-138138455045*y**8
          +136195893301*y**9-75923791440*y**10+26791363290*y**11-5544724563*y**12
          +543513911*y**13-16970002*y**14+6605316*y**15-916200*y**16)-r**4*(-1
          +y)**9*(3027784+7959819*y+14176200*y**2-57181526*y**3-91112172*y**4
          -25077771*y**5+646246916*y**6-816905860*y**7+179487992*y**8+397152509*y**9
          -366540360*y**10+114103266*y**11-123540*y**12-9258941*y**13+2710588*y**14
          -363528*y**15+18624*y**16)+3*r**18*(-1+y)**2*(-46675011911+226807103191*y
          -417030158651*y**2+303058194899*y**3+58419339424*y**4-240445232763*y**5
          +134626283577*y**6-8294114053*y**7-3129466348*y**8-19954565643*y**9+17578369979*y**10
          -5885112627*y**11+798852904*y**12+32413999*y**13-32547481*y**14+4595045*y**15
          +40459*y**16)-r**8*(-1+y)**7*(143959519-164178449*y-90252281*y**2-6752535711*y**3
          +20651561389*y**4-18609350483*y**5-1547159323*y**6+10053780027*y**7-985623963*y**8
          -5792036023*y**9+4282804169*y**10-1401576457*y**11+237160779*y**12-18200101*y**13
          +1734059*y**14-401555*y**15+58404*y**16)+r**10*(-1+y)**6*(13713155149
          -20915380323*y+242112141*y**2-77438571441*y**3+263116799548*y**4-274950446805*y**5
          +46038707877*y**6+125895470639*y**7-99020015512*y**8+18127322215*y**9
          +9069899099*y**10-4277047039*y**11+158741420*y**12+187898353*y**13-31303213*y**14
          +441857*y**15+64035*y**16)-r**6*(-1+y)**8*(-311316023-391415305*y-401569152*y**2
          +3114020950*y**3-46677229*y**4-346280739*y**5-11191067030*y**6+17273032716*y**7
          -8594649093*y**8-581663735*y**9+2179932244*y**10-789091818*y**11+70885261*y**12
          +13666243*y**13-589086*y**14-648632*y**15+70428*y**16)+r**12*(-1+y)**5*(16534924931
          -33653442599*y+10929988758*y**2+15930079396*y**3-43576956958*y**4+108948778431*y**5
          -157585598378*y**6+119108653158*y**7-36247388088*y**8-10953797465*y**9
          +13720865714*y**10-4598750808*y**11+446775134*y**12+82775617*y**13-20734302*y**14
          -632626*y**15+212085*y**16)+r**14*(-1+y)**4*(76169616775-342875278403*y
          +531676157350*y**2-38104886696*y**3-915827674021*y**4+1186138175927*y**5
          -516168296312*y**6-128737471830*y**7+203491309707*y**8-50492414293*y**9
          -11790758674*y**10+5788959428*y**11+491656205*y**12-497426111*y**13+72548164*y**14
          -6475078*y**15+593862*y**16)+r**16*(-1+y)**3*(-63132023099+316591236225*y
          -619471546281*y**2+560070807325*y**3-161374711407*y**4-89761236417*y**5
          +58977472585*y**6+14081991843*y**7-28838894079*y**8+15575450975*y**9
          +130405377*y**10-5389377789*y**11+3149746463*y**12-780321471*y**13+79203807*y**14
          -5912611*y**15+940554*y**16)+r**20*(9968933501-108417290460*y+477823839147*y**2
          -1185300095330*y**3+1751840432146*y**4-1396650827277*y**5+167551515129*y**6
          +885115535536*y**7-1044668322550*y**8+614463857813*y**9-194539157779*y**10
          +12330639702*y**11+16325261842*y**12-7167799795*y**13+1528038991*y**14
          -231132420*y**15+27765429*y**16-1193625*y**17))-r**6*(-1+r**2+y)**4*(2619*r**36*(
          -1+y)**11+2*r**34*(-1+y)**6*(136892-664912*y+1278335*y**2-1224332*y**3
          +596800*y**4-132932*y**5+9453*y**6)+r**32*(-1+y)**4*(-6476325+44228579*y
          -128414141*y**2+208697773*y**3-207111615*y**4+128368679*y**5-49603771*y**6
          +11467843*y**7-1350612*y**8+39510*y**9)-2*r**30*(-1+y)**2*(-24753128
          +225372632*y-907694954*y**2+2118449090*y**3-3198855651*y**4+3319509958*y**5
          -2438594490*y**6+1269006802*y**7-455447740*y**8+106228626*y**9-14252820*y**10
          +757148*y**11+23967*y**12)-2*r**28*(-647365004+6665627474*y-30913987169*y**2
          +84930272481*y**3-153523354815*y**4+192196947728*y**5-170872688984*y**6
          +108641184775*y**7-48841387820*y**8+14957554884*y**9-2877457051*y**10
          +307199025*y**11-32073281*y**12+12081874*y**13-2667124*y**14+180207*y**15)
          +3*(-1+y)**13*(-63397-369990*y-1263789*y**2-2660222*y**3-3321999*y**4
          -1179168*y**5+1995765*y**6+6916764*y**7+4019765*y**8-10575566*y**9-864547*y**10
          +7456626*y**11-4304825*y**12+878932*y**13-23685*y**14-688*y**15+24*y**16)
          -2*r**26*(-3832815008+36803280568*y-157368633790*y**2+392882285418*y**3
          -628761450251*y**4+659469885738*y**5-428533699730*y**6+118607174442*y**7
          +63573315489*y**8-87933529840*y**9+47712625034*y**10-15450828230*y**11
          +3297766803*y**12-534420802*y**13+75942246*y**14-7451134*y**15+284247*y**16)
          -2*r**8*(-1+y)**8*(-4588551004-1051753878*y+961898879*y**2+11102103533*y**3
          +50182701944*y**4-94406649701*y**5-50240854495*y**6+190752639301*y**7
          -122275517994*y**8-1982471081*y**9+32065197621*y**10-12233378429*y**11
          +956952088*y**12+298150261*y**13-51851413*y**14-3631541*y**15-240298*y**16
          +207*y**17)+2*r**2*(-1+y)**11*(817172+2201420*y+3455447*y**2+9169897*y**3
          -32535196*y**4-89967214*y**5-53582147*y**6+300235885*y**7+137859048*y**8
          -607129036*y**9+433891149*y**10-95329889*y**11-22682904*y**12+15669630*y**13
          -3424193*y**14+509643*y**15-584*y**16+1872*y**17)+r**4*(-1+y)**10*(
          -46425159-107344909*y-171640378*y**2+1057711458*y**3+523931832*y**4
          -863008990*y**5-8012415814*y**6+14526196982*y**7-4216986942*y**8-8775823640*y**9
          +8912546706*y**10-3008234186*y**11+30988984*y**12+233259734*y**13-60194642*y**14
          +8002418*y**15-352491*y**16+29037*y**17)+2*r**24*(2639288624-18469623954*y
          +45763457207*y**2+5045655333*y**3-304889699148*y**4+840383692427*y**5
          -1242497679663*y**6+1169733113245*y**7-736926182814*y**8+311874327863*y**9
          -83949798379*y**10+10418301235*y**11+1892534836*y**12-1331887219*y**13
          +369590035*y**14-59244197*y**15+3778582*y**16+39987*y**17)+2*r**6*(-1
          +y)**9*(1547891336+1304771568*y+868731626*y**2-14528510172*y**3+5559233481*y**4
          +1459554827*y**5+41660086236*y**6-71886362450*y**7+41268685047*y**8-3588040459*y**9
          -5038931794*y**10+1438194412*y**11+107256115*y**12-43332175*y**13-17749172*y**14
          +8573506*y**15-644891*y**16+40959*y**17)+6*r**18*(-1+y)**3*(-14127426664
          +74711399632*y-153541669836*y**2+188697533558*y**3-244419661841*y**4
          +370350747229*y**5-408644663750*y**6+257541193626*y**7-60577556509*y**8
          -39078211081*y**9+47208477156*y**10-24231563994*y**11+7472466473*y**12
          -1559297249*y**13+223740222*y**14-12116646*y**15-2094563*y**16+72237*y**17)
          -2*r**10*(-1+y)**7*(-58378748288+97096337784*y-14108117078*y**2+254128468176*y**3
          -876411506105*y**4+928776124217*y**5-245956960644*y**6-248605407644*y**7
          +211491515043*y**8-47195130685*y**9-5250644190*y**10+1570163936*y**11
          +1489007877*y**12-637251169*y**13+63901240*y**14+4665036*y**15-4366351*y**16
          +316845*y**17)-2*r**12*(-1+y)**6*(-159840368344+395468573298*y-232496717395*y**2
          +231542747327*y**3-1059759265350*y**4+1395712511341*y**5-352658620181*y**6
          -635398057163*y**7+542008458882*y**8-93936815879*y**9-55647973989*y**10
          +25027274809*y**11-771984818*y**12-1210111209*y**13+190978829*y**14+3809267*y**15
          -8641426*y**16+962001*y**17)-2*r**16*(-1+y)**4*(-312659042575+1403068162555*y
          -2292364270110*y**2+1014304842674*y**3+1705627020553*y**4-2824479661680*y**5
          +1709369876360*y**6-409820719166*y**7+46772641461*y**8-88471506542*y**9
          +46614251714*y**10+13668149574*y**11-18376128209*y**12+6650006240*y**13
          -1176562236*y**14+88736566*y**15-3351214*y**16+970035*y**17)+2*r**20*(
          -1+y)**2*(-74473849123+547106887661*y-1713403532827*y**2+3138611425447*y**3
          -3600218315074*y**4+2352236427833*y**5-295125545861*y**6-983373623699*y**7
          +1032842526696*y**8-547177231537*y**9+165502401303*y**10-16840579931*y**11
          -7450415226*y**12+3356594607*y**13-631887239*y**14+85629687*y**15-13877369*y**16
          +1004652*y**17)-2*r**14*(-1+y)**5*(-426158535624+1713068040320*y-2443600284570*y**2
          +819784606420*y**3+1597442113915*y**4-2012347618551*y**5+839099139212*y**6
          -51133249734*y**7-11883669579*y**8-53718493389*y**9+31418645470*y**10
          +553006632*y**11-5435812531*y**12+2119322759*y**13-390480576*y**14+34836730*y**15
          -8490789*y**16+1419885*y**17)+2*r**22*(33971597928-300894153112*y+1167672836610*y**2
          -2598840448046*y**3+3580153846497*y**4-2920591432822*y**5+876545313357*y**6
          +886958741082*y**7-1232282171771*y**8+606021896446*y**9-16607587915*y**10
          -152886198218*y**11+96490257051*y**12-31000671290*y**13+5959959407*y**14
          -737278466*y**15+74153623*y**16-9404118*y**17+743757*y**18))))/(-141087744000*logy**5*r**25*(
          -1+y)**11-58786560000*logy**4*r**21*(-1+y)**9*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-9797760000*logy**3*r**17*(-1+y)**7*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-816480000*logy**2*r**13*(
          -1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +567000*(-1+y)*(r**9*(-1+y)**2-6*r**5*y*(2-3*y+y**2)-2*r**3*(-1
          +y)**2*(-4+y**3)+2*r**7*(-4+8*y-4*y**2+y**3)-r*(-1+y)**3*(-1-y
          -y**2+y**3))**5-34020000*logy*r**5*(-1+y)**3*(-(r**9*(-1+y)**2)+6*r**5*y*(2
          -3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)
          +r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((rhoD*(-217728000*logy**5*r**20*(144
          +426*r**2+569*r**4+623*r**6+522*r**8+393*r**10+81*r**12)*(-1+y)**11
          -518400*logy**4*r**16*(-1+y)**6*(30318*r**20*(-1+y)**5+96*(-1+y)**7*(
          -118-236*y-354*y**2+543*y**3-170*y**4+20*y**5)+3*r**18*(-22207+111035*y
          -222070*y**2+208000*y**3-100745*y**4+18637*y**5+630*y**6)+4*r**2*(-1
          +y)**6*(10103+10103*y+10103*y**2-51322*y**3+43598*y**4-11170*y**5
          +1080*y**6)+2*r**4*(-1+y)**5*(-220599+151200*y+75600*y**2+6055*y**3
          -132230*y**4+104664*y**5-25550*y**6+2640*y**7)-6*r**16*(30456-123930*y
          +176985*y**2-55325*y**3-72000*y**4+74544*y**5-26005*y**6+2835*y**7)
          +r**14*(-684973+2599565*y-3135880*y**2-23360*y**3+2890045*y**4-2394047*y**5
          +776370*y**6-87990*y**7+3150*y**8)+r**6*(-1+y)**3*(-662341+2219282*y
          -2004241*y**2-112000*y**3+858655*y**4-138194*y**5-269017*y**6+149136*y**7
          -22080*y**8+960*y**9)+14*r**12*(-23648+39940*y+115870*y**2-398345*y**3
          +433010*y**4-197842*y**5+12040*y**6+24015*y**7-9900*y**8+1620*y**9)
          +7*r**10*(-16785-102975*y+673200*y**2-1269430*y**3+931570*y**4+35596*y**5
          -514010*y**6+351860*y**7-102535*y**8+9765*y**9+864*y**10)-14*r**8*(
          -18424+177470*y-568315*y**2+812035*y**3-449645*y**4-162482*y**5+371145*y**6
          -200595*y**7+33345*y**8+9330*y**9-4194*y**10+330*y**11))+17280*logy**3*r**12*(
          -1+y)**4*(-20922*r**28*(-1+y)**7+r**26*(-1+y)**2*(702713-3513565*y
          +7027130*y**2-6927995*y**3+3754240*y**4-1056668*y**5+127425*y**6)+24*(
          -1+y)**11*(-433-1732*y-4330*y**2-3440*y**3+1855*y**4+9868*y**5-7268*y**6
          +1280*y**7)+r**24*(-1+y)**2*(4955204-21137860*y+33180320*y**2-19902815*y**3
          -1449800*y**4+7167646*y**5-2811240*y**6+284865*y**7)+2*r**2*(-1+y)**9*(
          -38038-76076*y-114114*y**2+425203*y**3-150605*y**4+84523*y**5-362359*y**6
          +407184*y**7-175778*y**8+23160*y**9)+r**22*(-611999+12278513*y-64816359*y**2
          +174372100*y**3-263843890*y**4+235359744*y**5-125853008*y**6+39257714*y**7
          -6600525*y**8+786105*y**9-151995*y**10)+r**4*(-1+y)**8*(2623074+1263714*y
          +584034*y**2-19404191*y**3+23330564*y**4-6768964*y**5-3577934*y**6+2393931*y**7
          +10366*y**8-307654*y**9+52560*y**10)+r**20*(1894782+8664846*y-92537658*y**2
          +279290905*y**3-401497640*y**4+287318188*y**5-64284196*y**6-55741012*y**7
          +55795490*y**8-23288070*y**9+5222670*y**10-552705*y**11)+r**6*(-1+y)**7*(
          -1539873+4849440*y+2424720*y**2+11525225*y**3-48631770*y**4+45533106*y**5
          -10553330*y**6-7016455*y**7+4659965*y**8-746740*y**9-106668*y**10+24480*y**11)
          +r**18*(46501946-243316862*y+491779926*y**2-433236050*y**3+88737110*y**4
          +63224088*y**5+86220614*y**6-204266017*y**7+147280485*y**8-48768710*y**9
          +5501656*y**10+701103*y**11-182889*y**12)+r**8*(-1+y)**5*(-32221332
          +117386424*y-129780972*y**2-32040365*y**3+176864925*y**4-114093636*y**5
          -19662458*y**6+51341309*y**7-18326875*y**8-1433300*y**9+2399158*y**10
          -511736*y**11+15858*y**12)+r**14*(-1+y)**2*(-25342978+140814290*y-238379080*y**2
          -35423770*y**3+570000750*y**4-726886764*y**5+369680030*y**6+9580405*y**7
          -105272015*y**8+48475890*y**9-7406718*y**10-264255*y**11+96615*y**12)
          -r**10*(-1+y)**4*(-10893601+112161723*y-285059103*y**2+224979926*y**3
          +132910985*y**4-359049354*y**5+231747292*y**6-23064107*y**7-42670576*y**8
          +21807195*y**9-3494785*y**10-252975*y**11+121380*y**12)-r**12*(-1+y)**3*(
          -44180602+145770088*y-85056492*y**2-189337322*y**3+245897408*y**4+35013732*y**5
          -230978278*y**6+154012787*y**7-24296763*y**8-14137868*y**9+7243810*y**10
          -1410045*y**11+149145*y**12)+r**16*(-31304336+258858992*y-849855216*y**2
          +1382562850*y**3-1008785940*y**4-128812138*y**5+834958166*y**6-633773763*y**7
          +159782420*y**8+56557865*y**9-55889726*y**10+18615017*y**11-3128496*y**12
          +214305*y**13))+288*logy**2*r**8*(-1+y)**2*(-1+r**2+y)**2*(4119*r**32*(
          -1+y)**9+r**30*(-1+y)**4*(125317-618347*y+1211980*y**2-792055*y**3
          +395240*y**4-143002*y**5+28707*y**6)-48*(-1+y)**13*(-31-186*y-651*y**2
          -1521*y**3-2251*y**4-1044*y**5+4811*y**6+3251*y**7-5804*y**8+1676*y**9)
          -r**28*(-1+y)**2*(-23390871+160212533*y-468413966*y**2+758483677*y**3
          -744078498*y**4+455042741*y**5-170563678*y**6+37014451*y**7-4367067*y**8
          +310278*y**9)-r**26*(-1+y)**2*(-160300938+1035110444*y-2817176291*y**2
          +4089802821*y**3-3399902025*y**4+1574128817*y**5-286747319*y**6-77667299*y**7
          +51492009*y**8-9399415*y**9+480396*y**10)+2*r**2*(-1+y)**11*(14537+59636*y
          +152810*y**2-6595*y**3-622875*y**4-1187814*y**5+2077278*y**6-812935*y**7
          -230480*y**8+391200*y**9-130898*y**10+2136*y**11)+r**24*(-1+y)**2*(622014395
          -3565515499*y+8243060477*y**2-9165722337*y**3+3682897379*y**4+2357231135*y**5
          -3602509821*y**6+1840722533*y**7-458599978*y**8+62333956*y**9-8772420*y**10
          +940980*y**11)+r**4*(-1+y)**9*(4982845+8156254*y+10459971*y**2-48421385*y**3
          -23239125*y**4-6761385*y**5+233878337*y**6-295163147*y**7+126425150*y**8
          +7100275*y**9-25275460*y**10+9039884*y**11-1304374*y**12+38160*y**13)
          +r**14*(-1+y)**4*(-3440999425+19039779563*y-38233831438*y**2+25245013525*y**3
          +22471768180*y**4-50265028970*y**5+31310404789*y**6-1781647094*y**7-7115574825*y**8
          +3097482265*y**9-126939630*y**10-202055927*y**11+47052782*y**12-3245250*y**13
          +73455*y**14)-r**6*(-1+y)**8*(21059777+13651791*y+11316235*y**2-307738694*y**3
          +460411151*y**4-265433129*y**5+238976443*y**6-413693855*y**7+364059208*y**8
          -138438362*y**9+12062202*y**10+4096341*y**11+608920*y**12-716364*y**13
          +114336*y**14)+r**10*(-1+y)**6*(-64699322+405969976*y-360598413*y**2
          +2410929087*y**3-9911013743*y**4+14893101129*y**5-9134959872*y**6+159014646*y**7
          +2782474936*y**8-1399155484*y**9+187755393*y**10+37310371*y**11-7513183*y**12
          -959973*y**13+118452*y**14)-r**8*(-1+y)**7*(-438315019+453005992*y
          +101561761*y**2+3009078648*y**3-8260835242*y**4+7258697938*y**5-928612154*y**6
          -2515119572*y**7+1555888209*y**8-86260826*y**9-219187469*y**10+78188612*y**11
          -6544764*y**12-1293232*y**13+251118*y**14)+r**12*(-1+y)**5*(3292703911
          -13362014292*y+17889076913*y**2+7305209*y**3-23783769366*y**4+22877912623*y**5
          -3317647346*y**6-7719997526*y**7+5214804727*y**8-779250628*y**9-430544709*y**10
          +186857213*y**11-12842712*y**12-4172311*y**13+546294*y**14)-2*r**18*(
          -1+y)**2*(-2616148449+12660305927*y-22133680949*y**2+10547546988*y**3
          +15921633493*y**4-24396142342*y**5+8911982696*y**6+5573636948*y**7-6540036106*y**8
          +2168515134*y**9+24970141*y**10-207437648*y**11+62849026*y**12-10113507*y**13
          +891648*y**14)-r**16*(-1+y)**3*(1210838839-2435498638*y-4729712835*y**2
          +18353695832*y**3-20026977743*y**4+7173574122*y**5+3283395831*y**6-3404372730*y**7
          -667784069*y**8+2234479286*y**9-1271844361*y**10+295344082*y**11-6115035*y**12
          -8930538*y**13+1083957*y**14)+r**22*(50599229+1194615*y-1844888535*y**2
          +10438883208*y**3-27951793307*y**4+43847124057*y**5-44174395105*y**6
          +29877803965*y**7-13373041656*y**8+3235247544*y**9+254891914*y**10-518043885*y**11
          +185565470*y**12-30493152*y**13+1681638*y**14)-r**20*(36771507-1939424741*y
          +13429243323*y**2-45208676180*y**3+87667090810*y**4-100670655298*y**5
          +61768799292*y**6-4519733446*y**7-26093770745*y**8+24665025725*y**9-12159739425*y**10
          +3534846474*y**11-529013052*y**12+16074050*y**13+2839890*y**14+321816*y**15))
          -12*logy*r**6*(-1+y)**2*(-1+r**2+y)**3*(2385*r**36*(-1+y)**9+r**34*(
          -1+y)**4*(4138-13535*y+5605*y**2-4288*y**3-4030*y**4-3289*y**5+3495*y**6)
          -r**32*(-1+y)**2*(-2499047+17300876*y-51217362*y**2+85909374*y**3-88315640*y**4
          +56026478*y**5-21819070*y**6+5106042*y**7-680081*y**8+42510*y**9)+r**30*(
          -92832427+822171939*y-3225593916*y**2+7334476494*y**3-10731178692*y**4
          +10659360582*y**5-7391888696*y**6+3604750816*y**7-1217390879*y**8+273006087*y**9
          -37729180*y**10+2875682*y**11-123810*y**12)+6*(-1+y)**12*(-433-2598*y
          -9093*y**2-20350*y**3-25180*y**4-9574*y**5-16164*y**6+59526*y**7+98465*y**8
          -128620*y**9-20543*y**10+80512*y**11-41708*y**12+7760*y**13)+r**28*(
          -1248626161+10380051018*y-37855094229*y**2+79184457362*y**3-104367389395*y**4
          +89333090247*y**5-48657685870*y**6+14975071536*y**7-1164691403*y**8-836199260*y**9
          +288257659*y**10-32574058*y**11+960023*y**12+74931*y**13)+r**2*(-1+y)**11*(
          -117079-506177*y-1316589*y**2-2475225*y**3+850474*y**4+12510458*y**5
          +24113154*y**6-17435122*y**7-44452215*y**8+47859267*y**9-12672229*y**10
          -3209477*y**11+2736436*y**12-658860*y**13+65184*y**14)+r**26*(-3422687737
          +25998038661*y-84804172674*y**2+148830595416*y**3-143094329830*y**4
          +55708698813*y**5+31664926091*y**6-57106748822*y**7+38108392293*y**8
          -15209772027*y**9+3959655154*y**10-721775202*y**11+102998666*y**12-10910119*y**13
          +585717*y**14)+r**24*(-12131337947+84787262802*y-246260020413*y**2+363690421282*y**3
          -225299883555*y**4-122332061436*y**5+361010923015*y**6-321546655940*y**7
          +149982888295*y**8-31459117006*y**9-3413199423*y**10+3897921258*y**11
          -1107957497*y**12+182502248*y**13-15802939*y**14+341256*y**15)+r**22*(10010797805
          -80526708117*y+281786680740*y**2-605955087166*y**3+861976404051*y**4
          -790418718231*y**5+410501527102*y**6-31383510752*y**7-138138455045*y**8
          +136195893301*y**9-75923791440*y**10+26791363290*y**11-5544724563*y**12
          +543513911*y**13-16970002*y**14+6605316*y**15-916200*y**16)-r**4*(-1
          +y)**9*(3027784+7959819*y+14176200*y**2-57181526*y**3-91112172*y**4
          -25077771*y**5+646246916*y**6-816905860*y**7+179487992*y**8+397152509*y**9
          -366540360*y**10+114103266*y**11-123540*y**12-9258941*y**13+2710588*y**14
          -363528*y**15+18624*y**16)+3*r**18*(-1+y)**2*(-46675011911+226807103191*y
          -417030158651*y**2+303058194899*y**3+58419339424*y**4-240445232763*y**5
          +134626283577*y**6-8294114053*y**7-3129466348*y**8-19954565643*y**9+17578369979*y**10
          -5885112627*y**11+798852904*y**12+32413999*y**13-32547481*y**14+4595045*y**15
          +40459*y**16)-r**8*(-1+y)**7*(143959519-164178449*y-90252281*y**2-6752535711*y**3
          +20651561389*y**4-18609350483*y**5-1547159323*y**6+10053780027*y**7-985623963*y**8
          -5792036023*y**9+4282804169*y**10-1401576457*y**11+237160779*y**12-18200101*y**13
          +1734059*y**14-401555*y**15+58404*y**16)+r**10*(-1+y)**6*(13713155149
          -20915380323*y+242112141*y**2-77438571441*y**3+263116799548*y**4-274950446805*y**5
          +46038707877*y**6+125895470639*y**7-99020015512*y**8+18127322215*y**9
          +9069899099*y**10-4277047039*y**11+158741420*y**12+187898353*y**13-31303213*y**14
          +441857*y**15+64035*y**16)-r**6*(-1+y)**8*(-311316023-391415305*y-401569152*y**2
          +3114020950*y**3-46677229*y**4-346280739*y**5-11191067030*y**6+17273032716*y**7
          -8594649093*y**8-581663735*y**9+2179932244*y**10-789091818*y**11+70885261*y**12
          +13666243*y**13-589086*y**14-648632*y**15+70428*y**16)+r**12*(-1+y)**5*(16534924931
          -33653442599*y+10929988758*y**2+15930079396*y**3-43576956958*y**4+108948778431*y**5
          -157585598378*y**6+119108653158*y**7-36247388088*y**8-10953797465*y**9
          +13720865714*y**10-4598750808*y**11+446775134*y**12+82775617*y**13-20734302*y**14
          -632626*y**15+212085*y**16)+r**14*(-1+y)**4*(76169616775-342875278403*y
          +531676157350*y**2-38104886696*y**3-915827674021*y**4+1186138175927*y**5
          -516168296312*y**6-128737471830*y**7+203491309707*y**8-50492414293*y**9
          -11790758674*y**10+5788959428*y**11+491656205*y**12-497426111*y**13+72548164*y**14
          -6475078*y**15+593862*y**16)+r**16*(-1+y)**3*(-63132023099+316591236225*y
          -619471546281*y**2+560070807325*y**3-161374711407*y**4-89761236417*y**5
          +58977472585*y**6+14081991843*y**7-28838894079*y**8+15575450975*y**9
          +130405377*y**10-5389377789*y**11+3149746463*y**12-780321471*y**13+79203807*y**14
          -5912611*y**15+940554*y**16)+r**20*(9968933501-108417290460*y+477823839147*y**2
          -1185300095330*y**3+1751840432146*y**4-1396650827277*y**5+167551515129*y**6
          +885115535536*y**7-1044668322550*y**8+614463857813*y**9-194539157779*y**10
          +12330639702*y**11+16325261842*y**12-7167799795*y**13+1528038991*y**14
          -231132420*y**15+27765429*y**16-1193625*y**17))+r**6*(-1+r**2+y)**4*(2619*r**36*(
          -1+y)**11+2*r**34*(-1+y)**6*(136892-664912*y+1278335*y**2-1224332*y**3
          +596800*y**4-132932*y**5+9453*y**6)+r**32*(-1+y)**4*(-6476325+44228579*y
          -128414141*y**2+208697773*y**3-207111615*y**4+128368679*y**5-49603771*y**6
          +11467843*y**7-1350612*y**8+39510*y**9)-2*r**30*(-1+y)**2*(-24753128
          +225372632*y-907694954*y**2+2118449090*y**3-3198855651*y**4+3319509958*y**5
          -2438594490*y**6+1269006802*y**7-455447740*y**8+106228626*y**9-14252820*y**10
          +757148*y**11+23967*y**12)-2*r**28*(-647365004+6665627474*y-30913987169*y**2
          +84930272481*y**3-153523354815*y**4+192196947728*y**5-170872688984*y**6
          +108641184775*y**7-48841387820*y**8+14957554884*y**9-2877457051*y**10
          +307199025*y**11-32073281*y**12+12081874*y**13-2667124*y**14+180207*y**15)
          +3*(-1+y)**13*(-63397-369990*y-1263789*y**2-2660222*y**3-3321999*y**4
          -1179168*y**5+1995765*y**6+6916764*y**7+4019765*y**8-10575566*y**9-864547*y**10
          +7456626*y**11-4304825*y**12+878932*y**13-23685*y**14-688*y**15+24*y**16)
          -2*r**26*(-3832815008+36803280568*y-157368633790*y**2+392882285418*y**3
          -628761450251*y**4+659469885738*y**5-428533699730*y**6+118607174442*y**7
          +63573315489*y**8-87933529840*y**9+47712625034*y**10-15450828230*y**11
          +3297766803*y**12-534420802*y**13+75942246*y**14-7451134*y**15+284247*y**16)
          -2*r**8*(-1+y)**8*(-4588551004-1051753878*y+961898879*y**2+11102103533*y**3
          +50182701944*y**4-94406649701*y**5-50240854495*y**6+190752639301*y**7
          -122275517994*y**8-1982471081*y**9+32065197621*y**10-12233378429*y**11
          +956952088*y**12+298150261*y**13-51851413*y**14-3631541*y**15-240298*y**16
          +207*y**17)+2*r**2*(-1+y)**11*(817172+2201420*y+3455447*y**2+9169897*y**3
          -32535196*y**4-89967214*y**5-53582147*y**6+300235885*y**7+137859048*y**8
          -607129036*y**9+433891149*y**10-95329889*y**11-22682904*y**12+15669630*y**13
          -3424193*y**14+509643*y**15-584*y**16+1872*y**17)+r**4*(-1+y)**10*(
          -46425159-107344909*y-171640378*y**2+1057711458*y**3+523931832*y**4
          -863008990*y**5-8012415814*y**6+14526196982*y**7-4216986942*y**8-8775823640*y**9
          +8912546706*y**10-3008234186*y**11+30988984*y**12+233259734*y**13-60194642*y**14
          +8002418*y**15-352491*y**16+29037*y**17)+2*r**24*(2639288624-18469623954*y
          +45763457207*y**2+5045655333*y**3-304889699148*y**4+840383692427*y**5
          -1242497679663*y**6+1169733113245*y**7-736926182814*y**8+311874327863*y**9
          -83949798379*y**10+10418301235*y**11+1892534836*y**12-1331887219*y**13
          +369590035*y**14-59244197*y**15+3778582*y**16+39987*y**17)+2*r**6*(-1
          +y)**9*(1547891336+1304771568*y+868731626*y**2-14528510172*y**3+5559233481*y**4
          +1459554827*y**5+41660086236*y**6-71886362450*y**7+41268685047*y**8-3588040459*y**9
          -5038931794*y**10+1438194412*y**11+107256115*y**12-43332175*y**13-17749172*y**14
          +8573506*y**15-644891*y**16+40959*y**17)+6*r**18*(-1+y)**3*(-14127426664
          +74711399632*y-153541669836*y**2+188697533558*y**3-244419661841*y**4
          +370350747229*y**5-408644663750*y**6+257541193626*y**7-60577556509*y**8
          -39078211081*y**9+47208477156*y**10-24231563994*y**11+7472466473*y**12
          -1559297249*y**13+223740222*y**14-12116646*y**15-2094563*y**16+72237*y**17)
          -2*r**10*(-1+y)**7*(-58378748288+97096337784*y-14108117078*y**2+254128468176*y**3
          -876411506105*y**4+928776124217*y**5-245956960644*y**6-248605407644*y**7
          +211491515043*y**8-47195130685*y**9-5250644190*y**10+1570163936*y**11
          +1489007877*y**12-637251169*y**13+63901240*y**14+4665036*y**15-4366351*y**16
          +316845*y**17)-2*r**12*(-1+y)**6*(-159840368344+395468573298*y-232496717395*y**2
          +231542747327*y**3-1059759265350*y**4+1395712511341*y**5-352658620181*y**6
          -635398057163*y**7+542008458882*y**8-93936815879*y**9-55647973989*y**10
          +25027274809*y**11-771984818*y**12-1210111209*y**13+190978829*y**14+3809267*y**15
          -8641426*y**16+962001*y**17)-2*r**16*(-1+y)**4*(-312659042575+1403068162555*y
          -2292364270110*y**2+1014304842674*y**3+1705627020553*y**4-2824479661680*y**5
          +1709369876360*y**6-409820719166*y**7+46772641461*y**8-88471506542*y**9
          +46614251714*y**10+13668149574*y**11-18376128209*y**12+6650006240*y**13
          -1176562236*y**14+88736566*y**15-3351214*y**16+970035*y**17)+2*r**20*(
          -1+y)**2*(-74473849123+547106887661*y-1713403532827*y**2+3138611425447*y**3
          -3600218315074*y**4+2352236427833*y**5-295125545861*y**6-983373623699*y**7
          +1032842526696*y**8-547177231537*y**9+165502401303*y**10-16840579931*y**11
          -7450415226*y**12+3356594607*y**13-631887239*y**14+85629687*y**15-13877369*y**16
          +1004652*y**17)-2*r**14*(-1+y)**5*(-426158535624+1713068040320*y-2443600284570*y**2
          +819784606420*y**3+1597442113915*y**4-2012347618551*y**5+839099139212*y**6
          -51133249734*y**7-11883669579*y**8-53718493389*y**9+31418645470*y**10
          +553006632*y**11-5435812531*y**12+2119322759*y**13-390480576*y**14+34836730*y**15
          -8490789*y**16+1419885*y**17)+2*r**22*(33971597928-300894153112*y+1167672836610*y**2
          -2598840448046*y**3+3580153846497*y**4-2920591432822*y**5+876545313357*y**6
          +886958741082*y**7-1232282171771*y**8+606021896446*y**9-16607587915*y**10
          -152886198218*y**11+96490257051*y**12-31000671290*y**13+5959959407*y**14
          -737278466*y**15+74153623*y**16-9404118*y**17+743757*y**18))))/(-125411328000*logy**5*r**25*(
          -1+y)**11-52254720000*logy**4*r**21*(-1+y)**9*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-8709120000*logy**3*r**17*(-1+y)**7*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-725760000*logy**2*r**13*(
          -1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +504000*(-1+y)*(r**9*(-1+y)**2-6*r**5*y*(2-3*y+y**2)-2*r**3*(-1
          +y)**2*(-4+y**3)+2*r**7*(-4+8*y-4*y**2+y**3)-r*(-1+y)**3*(-1-y
          -y**2+y**3))**5-30240000*logy*r**5*(-1+y)**3*(-(r**9*(-1+y)**2)+6*r**5*y*(2
          -3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)
          +r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(-217728000*logy**5*r**19*(
          -3+5*r**2+18*r**4+25*r**6+21*r**8)*(-1+y)**10-518400*logy**4*r**15*(
          -1+y)**8*(3750*r**16*(-1+y)**2+r**14*(6971-13942*y+6971*y**2+210*y**3)
          -14*r**12*(-2912+2674*y+1813*y**2-2210*y**3+315*y**4)+175*r**10*(-7
          +314*y-457*y**2+212*y**3-56*y**4+26*y**5)-50*(-1+y)**3*(57+57*y
          +57*y**2-244*y**3+190*y**4-62*y**5+8*y**6)+70*r**8*(-340+1220*y-1150*y**2
          +175*y**3+317*y**4-238*y**5+72*y**6)+35*r**6*(-737+1774*y-1187*y**2
          -50*y**3+583*y**4-476*y**5+147*y**6)-r**2*(-1+y)**2*(943+14560*y**3
          -18725*y**4+9912*y**5-2520*y**6+240*y**7)+14*r**4*(-184-82*y+491*y**2
          -210*y**3+440*y**4-801*y**5+412*y**6-76*y**7+10*y**8))-17280*logy**3*r**11*(
          -1+y)**6*(-1+r**2+y)**2*(5850*r**20*(-1+y)**4-r**18*(-1+y)**2*(-72583
          +156866*y-95983*y**2+20465*y**3)-r**16*(-1+y)**2*(-741876+1190618*y
          -398158*y**2-62129*y**3+2965*y**4)+r**14*(1013744-3959074*y+5919965*y**2
          -3711320*y**3+171300*y**4+896226*y**5-384461*y**6+56070*y**7)+35*(
          -1+y)**5*(246+738*y+1476*y**2-253*y**3-1162*y**4-2295*y**5+3626*y**6
          -1634*y**7+248*y**8)-2*r**12*(-1693211+4649297*y-4137246*y**2+451020*y**3
          +1421455*y**4-928399*y**5+309408*y**6-90279*y**7+10255*y**8)+r**6*(
          -1+y)**2*(51064-456902*y-234653*y**2+3729116*y**3-4954405*y**4+2425366*y**5
          -298943*y**6-113792*y**7+23489*y**8+3960*y**9)-2*r**4*(-1+y)**3*(-231852
          -111019*y-88601*y**2+1109682*y**3-1155315*y**4+545202*y**5-227381*y**6
          +127776*y**7-46257*y**8+6015*y**9)-5*r**10*(-533790+1433974*y-1083583*y**2
          -624082*y**3+1646249*y**4-1052972*y**5+105213*y**6+170339*y**7-70343*y**8
          +6545*y**9)+r**2*(-1+y)**4*(-41557-100334*y-176331*y**2+197747*y**3
          +13145*y**4+245127*y**5-481611*y**6+303096*y**7-80672*y**8+7640*y**9)
          +r**8*(889382-2213818*y+808892*y**2+4744922*y**3-9789178*y**4+8058358*y**5
          -2013732*y**6-1347567*y**7+1172603*y**8-353997*y**9+44135*y**10))-288*logy**2*r**7*(
          -1+y)**4*(-1+r**2+y)**3*(669*r**26*(-1+y)**6-r**24*(-1+y)**4*(-118314
          +238635*y-122328*y**2+25912*y**3)+r**22*(-1+y)**2*(3167785-11975089*y
          +16753020*y**2-10415430*y**3+2633185*y**4-163425*y**5+26454*y**6)+r**20*(
          -1+y)**2*(15589697-58101152*y+81125520*y**2-51480280*y**3+12295665*y**4
          +1624808*y**5-1143358*y**6+120650*y**7)-5*r**18*(-1+y)**2*(-18466988
          +55662707*y-55831650*y**2+13544638*y**3+10603714*y**4-6287825*y**5
          +1049118*y**6-236132*y**7+31298*y**8)-(-1+y)**8*(6063+30315*y+90945*y**2
          +143090*y**3+80475*y**4-173951*y**5-202665*y**6-19220*y**7+334410*y**8
          -202250*y**9+35288*y**10)+r**16*(46245657-280978617*y+721782105*y**2
          -919197130*y**3+436678695*y**4+278084151*y**5-480834901*y**6+240888970*y**7
          -37438720*y**8-8517570*y**9+3532192*y**10-237832*y**11)+r**4*(-1+y)**6*(
          -3345211-8987232*y-16688940*y**2+10693540*y**3+12777260*y**4+23309612*y**5
          -50514186*y**6+28623440*y**7-5548365*y**8-154310*y**9+101674*y**10+6218*y**11)
          -5*r**8*(-1+y)**4*(11502308-1898611*y-1819120*y**2-50284312*y**3+78291632*y**4
          -44334412*y**5+9881548*y**6+226730*y**7-1220008*y**8+798633*y**9-221456*y**10
          +11568*y**11)-r**2*(-1+y)**7*(-161070-662469*y-1701645*y**2-1099015*y**3
          +358515*y**4+3185615*y**5-1525767*y**6+586395*y**7-1596885*y**8+1288110*y**9
          -392720*y**10+40936*y**11)+2*r**12*(-1+y)**2*(69275405-133172846*y
          +1040115*y**2+265979180*y**3-323162495*y**4+80477520*y**5+113588437*y**6
          -89772815*y**7+17157020*y**8+3425245*y**9-1409850*y**10+136334*y**11)
          +r**6*(-1+y)**5*(4985051+11477074*y+20380875*y**2-44879090*y**3+7535340*y**4
          -51188752*y**5+115984152*y**6-82748400*y**7+20834365*y**8+1283010*y**9
          -1375099*y**10+175474*y**11)-r**10*(-1+y)**3*(49005141-114721545*y
          -2397465*y**2+445650725*y**3-660713610*y**4+298317888*y**5+85588070*y**6
          -122963360*y**7+31831025*y**8+3928485*y**9-2839229*y**10+261875*y**11)
          +2*r**14*(109977961-426210609*y+598273968*y**2-264236790*y**3-199371795*y**4
          +288817653*y**5-122776787*y**6+8618729*y**7+13624740*y**8-11120080*y**9
          +5710061*y**10-1474379*y**11+167328*y**12))-12*logy*r**3*(-1+y)**4*(
          -1+r**2+y)**4*(69*r**32*(-1+y)**6+r**30*(-1+y)**4*(-5181+10086*y-4629*y**2
          +910*y**3)+2*r**28*(-1+y)**2*(217572-844008*y+1208685*y**2-796093*y**3
          +250841*y**4-33535*y**5+3158*y**6)+r**26*(14514773-83097582*y+196451973*y**2
          -248020986*y**3+180551617*y**4-76011548*y**5+17132107*y**6-1463878*y**7
          -70654*y**8+178*y**9)+r**24*(146352860-780131516*y+1692810174*y**2
          -1890025322*y**3+1102554407*y**4-264630208*y**5-27308279*y**6+22744626*y**7
          -2863463*y**8+443668*y**9-40947*y**10)+3*(-1+y)**11*(-23-207*y-1035*y**2
          -3209*y**3-5249*y**4-1129*y**5+4927*y**6+5925*y**7-1756*y**8-3996*y**9
          +1552*y**10)+r**22*(323369043-1679334598*y+3602060705*y**2-4025291722*y**3
          +2260869658*y**4-208832576*y**5-525519870*y**6+324158270*y**7-77665293*y**8
          +6100662*y**9+527413*y**10-27292*y**11)+2*r**20*(1070224308-4721605544*y
          +7887558711*y**2-5283712565*y**3-631020121*y**4+3063105392*y**5-1688443900*y**6
          +282976679*y**7+30043735*y**8-11606384*y**9+2686245*y**10-481386*y**11
          +43830*y**12)-r**6*(-1+y)**6*(12879047+48451484*y+116459156*y**2+25032582*y**3
          -50846705*y**4-206117534*y**5+190894492*y**6-82901202*y**7+95345261*y**8
          -79385670*y**9+27739112*y**10-3332276*y**11-67979*y**12+232*y**13)+r**2*(
          -1+y)**8*(-14649-87618*y-305697*y**2-681498*y**3-741218*y**4+168370*y**5
          +1141658*y**6+854386*y**7-1291837*y**8+299568*y**9-186321*y**10+208360*y**11
          -71264*y**12+7760*y**13)+2*r**4*(-1+y)**7*(612420+2945748*y+8560599*y**2
          +10999556*y**3+3835642*y**4-17059173*y**5-8250144*y**6+439669*y**7+20416300*y**8
          -14771417*y**9+3249753*y**10+52171*y**11-85418*y**12+9294*y**13)+r**8*(
          -1+y)**5*(136852196+298437944*y+473415734*y**2-776373268*y**3-415559709*y**4
          -642407881*y**5+2321167888*y**6-1642070332*y**7+296905542*y**8+120680834*y**9
          -59792190*y**10+8109968*y**11-207477*y**12+22751*y**13)-r**14*(-1+y)**2*(
          -2484294705+6091052608*y-1651177246*y**2-12337836914*y**3+16585630377*y**4
          -3636030298*y**5-6435083324*y**6+4144917944*y**7+65151105*y**8-708026952*y**9
          +194307578*y**10-10814734*y**11-1977673*y**12+40234*y**13)+r**18*(-950862723
          +2762654018*y-15453047*y**2-6245243566*y**3+3408697062*y**4+6985428478*y**5
          -9409889794*y**6+3434791906*y**7+628322649*y**8-768620412*y**9+181062145*y**10
          -7446524*y**11-882884*y**12+60692*y**13)+2*r**12*(-1+y)**3*(827108244
          -611921812*y-359771423*y**2-2570705756*y**3+6146942587*y**4-3924736436*y**5
          -488771374*y**6+1636171258*y**7-678495906*y**8+70611438*y**9+12083317*y**10
          -416714*y**11-576685*y**12+96262*y**13)+r**10*(-1+y)**4*(78378471-39250750*y
          -256842083*y**2+417379774*y**3-253724376*y**4+1697948302*y**5-3239842886*y**6
          +2138906180*y**7-347185449*y**8-165329074*y**9+57483977*y**10+872086*y**11
          -1674422*y**12+170250*y**13)+r**16*(3555781374-9915875416*y+5266988984*y**2
          +9321952402*y**3-9851297549*y**4-5690391848*y**5+13651916377*y**6-7907840578*y**7
          +1413193406*y**8+205825878*y**9-31100576*y**10-20382336*y**11-807231*y**12
          +2152042*y**13-114929*y**14))-r*(-1+y)**2*(-1+r**2+y)**5*(55*r**34*(
          -1+y)**8+r**32*(-1+y)**6*(-1169+2891*y-1861*y**2+515*y**3)+r**30*(
          -1+y)**4*(-71688+230978*y-241019*y**2+81710*y**3+5480*y**4-9660*y**5
          +1739*y**6)+r**28*(-1+y)**2*(13989368-78411814*y+179753715*y**2-217874419*y**3
          +151044829*y**4-60283689*y**5+12996773*y**6-1364661*y**7+89763*y**8
          +1175*y**9)+r**26*(147065776-1066771378*y+3337324439*y**2-5883029418*y**3
          +6391698101*y**4-4372256826*y**5+1811257308*y**6-377185494*y**7-5007352*y**8
          +20570364*y**9-3835275*y**10+217680*y**11-8725*y**12)+(-1+y)**12*(11
          +99*y+495*y**2+2417*y**3+4974*y**4+2078*y**5-2482*y**6-4358*y**7
          +2199*y**8+1991*y**9-2349*y**10+373*y**11+128*y**12+24*y**13)-r**24*(
          -914987072+6189236306*y-17808643741*y**2+27926204153*y**3-24813074145*y**4
          +10531144441*y**5+1064266542*y**6-3550943102*y**7+1707773462*y**8-369468700*y**9
          +44192911*y**10-5943643*y**11+328523*y**12+26065*y**13)+r**2*(-1+y)**10*(1475
          +9552*y+35530*y**2-32010*y**3-385125*y**4-953460*y**5+340516*y**6
          +1311040*y**7+511145*y**8-802420*y**9-970190*y**10+1006282*y**11-249495*y**12
          +8440*y**13+720*y**14)+r**4*(-1+y)**9*(760128+4378378*y+14777413*y**2
          +27866194*y**3+23237302*y**4-20033664*y**5-32522809*y**6-17969404*y**7
          +43973404*y**8-17544502*y**9+4056011*y**10-2462694*y**11+1053566*y**12
          -176548*y**13+7225*y**14)-r**22*(-268400208+1711048238*y-5373777709*y**2
          +10796926442*y**3-13841834620*y**4+9274618956*y**5+471788059*y**6-6237063452*y**7
          +4942948616*y**8-1645542530*y**9+105268177*y**10+84572178*y**11-21436364*y**12
          +790792*y**13+9425*y**14)+r**6*(-1+y)**8*(-20887424-93357290*y-255121929*y**2
          -242414574*y**3-8186684*y**4+520893844*y**5+45438071*y**6-69001676*y**7
          -480696536*y**8+436760934*y**9-116014195*y**10-2660006*y**11+5432580*y**12
          -784240*y**13+39125*y**14)+r**8*(-1+y)**7*(80508472+260842614*y+569840915*y**2
          -450974846*y**3-445144694*y**4-1045230298*y**5+2128136423*y**6-1423625124*y**7
          +572765588*y**8-194339206*y**9+66130001*y**10-18628062*y**11+4923434*y**12
          -1180342*y**13+135125*y**14)+r**10*(-1+y)**6*(-997350440-1691176054*y
          -2161565359*y**2+6458255650*y**3+1869540616*y**4+2512289854*y**5-16959642473*y**6
          +13895644552*y**7-2294697416*y**8-1630468478*y**9+768549711*y**10-105849498*y**11
          +6637832*y**12-1702234*y**13+321737*y**14)+r**18*(-1+y)**2*(-21464732546
          +80084335418*y-94166632275*y**2+11006026918*y**3+49762915502*y**4-16290011486*y**5
          -20044465389*y**6+9592091992*y**7+5410988386*y**8-4937597702*y**9+1210156907*y**10
          -49186654*y**11-10484542*y**12+485546*y**13+353925*y**14)+r**12*(-1
          +y)**5*(-2962785336-1299152086*y+822920757*y**2+10415132474*y**3-3496526810*y**4
          -12294826868*y**5+9029674107*y**6+2033454036*y**7-3873416148*y**8+966167730*y**9
          +277409179*y**10-174440046*y**11+36926182*y**12-4405576*y**13+548405*y**14)
          +r**16*(-1+y)**3*(-36057039998+78996220630*y-25665244733*y**2-53907218698*y**3
          +16916999192*y**4+57885030698*y**5-49074055893*y**6+3290362788*y**7+11342421858*y**8
          -5353479742*y**9+1037638625*y**10-122180362*y**11+26619220*y**12-3790610*y**13
          +597025*y**14)+r**14*(-1+y)**4*(-15844558024+14193547926*y+7326717511*y**2
          +38252996058*y**3-97714128676*y**4+53843946232*y**5+20577360027*y**6
          -28618156188*y**7+6467116728*y**8+1429901446*y**9-381702483*y**10-155945278*y**11
          +61356852*y**12-6717236*y**13+677105*y**14)+r**20*(12414648592-74537652958*y
          +182652788711*y**2-219150562991*y**3+94072277508*y**4+76732714698*y**5
          -124636788589*y**6+62473124073*y**7-5095455208*y**8-7606391946*y**9+3016296133*y**10
          -313264053*y**11-27675884*y**12+5452574*y**13+376513*y**14+112827*y**15)))*math.log(mu0**2/r**2))/(
          -6967296000*logy**5*r**20*(-1+y)**10+28000*(r**8*(-1+y)**2-6*r**4*y*(2
          -3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)
          -(-1+y)**3*(-1-y-y**2+y**3))**5-2903040000*logy**4*r**16*(-1+y)**8*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-483840000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          -40320000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**3-1680000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2
          -3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)
          +r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(-1512000*logy**3*r**12*(19
          +19*r**2+11*r**4+3*r**6)*(-1+y)**8-3600*logy**2*r**8*(-1+y)**6*(175*r**12*(
          -1+y)**2+255*r**14*(-1+y)**2-7*r**10*(-897+1254*y-87*y**2-340*y**3
          +90*y**4)+35*r**8*(405-414*y-189*y**2+204*y**3-38*y**4+8*y**5)-35*r**2*(
          -1+y)**2*(213-5*y**4-32*y**5+4*y**6)+35*r**6*(275+134*y-751*y**2
          +196*y**3+143*y**4-82*y**5+25*y**6)+35*r**4*(-669+2022*y-1695*y**2
          +52*y**3+495*y**4-282*y**5+77*y**6)+(-1+y)**3*(-361-361*y-361*y**2
          -4001*y**3+3804*y**4-900*y**5+80*y**6))-60*logy*r**4*(-1+y)**4*(-1
          +r**2+y)**2*(355*r**18*(-1+y)**4-r**16*(-1+y)**2*(-1153+3016*y-2573*y**2
          +1470*y**3)-r**14*(-1+y)**2*(-64706+101828*y-25903*y**2-10734*y**3
          +1755*y**4)+r**12*(-1+y)**2*(8214-66656*y+94159*y**2-16866*y**3-12551*y**4
          +5180*y**5)+r**10*(692212-2030424*y+1848647*y**2-169180*y**3-586485*y**4
          +241888*y**5+27709*y**6-25452*y**7+2485*y**8)+r**2*(-1+y)**3*(19399
          +17793*y+16187*y**2+142341*y**3-189095*y**4+52111*y**5-17483*y**6
          +7323*y**7+1544*y**8+280*y**9)-5*r**8*(-436732+1374912*y-1414175*y**2
          +301728*y**3+420651*y**4-337498*y**5+90783*y**6+5140*y**7-8743*y**8
          +1414*y**9)-(-1+y)**4*(-803-1606*y-2409*y**2-13492*y**3+4295*y**4
          -1662*y**5-7059*y**6+18944*y**7-10248*y**8+1440*y**9)+r**4*(-1+y)**2*(115834
          +6128*y-13123*y**2-627214*y**3+1390935*y**4-1107204*y**5+299327*y**6
          +34778*y**7-29781*y**8+5920*y**9)+r**6*(883662-2380808*y+1934387*y**2
          -460068*y**3+323372*y**4-509292*y**5+263858*y**6-41212*y**7-26282*y**8
          +12628*y**9-245*y**10))+(-1+y)**2*(-1+r**2+y)**3*(23*r**24*(-1+y)**6
          +r**22*(-1+y)**4*(-1636+3203*y-1498*y**2+611*y**3)-r**20*(-1+y)**2*(53282
          -196667*y+264360*y**2-147190*y**3+20590*y**4+6593*y**5+32*y**6)-5*r**18*(
          -1+y)**2*(-10084+25495*y-2964*y**2-59086*y**3+67984*y**4-18137*y**5
          -3136*y**6+768*y**7)-5*r**16*(-1+y)**2*(981683-3134849*y+3304164*y**2
          -878638*y**3-577695*y**4+335767*y**5-23846*y**6-7224*y**7+78*y**8)
          +2*r**14*(-1+y)**2*(5042852-15034913*y+12846762*y**2+344847*y**3-4593008*y**4
          +1133298*y**5+522238*y**6-184337*y**7-20172*y**8+5433*y**9)+r**4*(-1
          +y)**4*(239598+215739*y+172968*y**2+711145*y**3-1068910*y**4-13636*y**5
          -698198*y**6+2381464*y**7-2629420*y**8+1381385*y**9-259362*y**10-13441*y**11
          +668*y**12)+5*r**6*(-1+y)**3*(61652+93801*y-18903*y**2-1950935*y**3
          +5284025*y**4-5051584*y**5+1856368*y**6+72856*y**7-504180*y**8+374135*y**9
          -110233*y**10+4191*y**11+807*y**12)-(-1+y)**6*(-863-2589*y-5178*y**2
          -18310*y**3-7640*y**4-6544*y**5-7722*y**6+26426*y**7-4265*y**8+1565*y**9
          -668*y**10-3764*y**11+1552*y**12)-5*r**8*(-1+y)**2*(1495819-2607070*y
          +733134*y**2-3703654*y**3+14693541*y**4-21082902*y**5+14135366*y**6
          -3338562*y**7-900021*y**8+514084*y**9-5492*y**10-19896*y**11+1653*y**12)
          +2*r**12*(-24565894+116636943*y-212534784*y**2+167628370*y**3-16908815*y**4
          -61310837*y**5+33962579*y**6+2466173*y**7-7236645*y**8+1921290*y**9
          +4081*y**10-50547*y**11+2086*y**12)-r**2*(-1+y)**5*(-24876-47163*y
          -66861*y**2-298290*y**3+176270*y**4-4768*y**5-46084*y**6+399422*y**7
          -301510*y**8+50555*y**9-6031*y**10-2428*y**11+3764*y**12)-2*r**10*(13546628
          -58709229*y+95512344*y**2-62747978*y**3-12826120*y**4+65626674*y**5
          -74365612*y**6+48658242*y**7-16017164*y**8+210745*y**9+1369948*y**10
          -237784*y**11-27336*y**12+6642*y**13)))*nlo.X1El(0,'SLSR',y/2,r))/(580608000*logy**4*r**16*(
          -1+y)**8+193536000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+24192000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+1344000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +28000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(18144000*logy**4*r**15*(46+83*r**2+80*r**4+45*r**6+12*r**8)*(-1
          +y)**10+86400*logy**3*r**11*(-1+y)**8*(1312*r**14*(-1+y)**2+472*r**16*(
          -1+y)**2-7*r**12*(-2429+3418*y-269*y**2-915*y**3+180*y**4)+7*r**10*(5216
          -5032*y-2884*y**2+2905*y**3-285*y**4+60*y**5)+35*r**8*(681+558*y
          -2199*y**2+682*y**3+382*y**4-191*y**5+52*y**6)+(-1+y)**3*(87+87*y
          +87*y**2-6283*y**3+5092*y**4-1040*y**5+80*y**6)+7*r**6*(-2936+15832*y
          -17876*y**2+1180*y**3+5670*y**4-2799*y**5+623*y**6+36*y**7)+r**2*(
          -1+y)**2*(-9208+10605*y**3-13965*y**4+8148*y**5-1330*y**6+80*y**7)
          -7*r**4*(7041-19602*y+15321*y**2+195*y**3-4015*y**4+719*y**5+777*y**6
          -476*y**7+40*y**8))+1440*logy**2*r**7*(-1+y)**6*(-1+r**2+y)**2*(866*r**20*(
          -1+y)**4-r**18*(-1+y)**2*(-7971+17674*y-11435*y**2+2772*y**3)-r**16*(
          -1+y)**2*(-170979+274672*y-81485*y**2-21775*y**3+3722*y**4)+r**14*(
          -1+y)**2*(378732-711016*y+348065*y**2+39601*y**3-47388*y**4+10416*y**5)
          +r**12*(2867580-8799676*y+8910451*y**2-2043295*y**3-1903700*y**4+1043875*y**5
          -41719*y**6-40026*y**7+5110*y**8)-(-1+y)**4*(177+354*y+531*y**2
          -9712*y**3+5415*y**4-1802*y**5-33379*y**6+48344*y**7-20888*y**8+2560*y**9)
          -r**10*(-7035366+21252160*y-20428801*y**2+2528581*y**3+7278746*y**4
          -4340659*y**5+592290*y**6+273526*y**7-134981*y**8+15204*y**9)+r**8*(7375734
          -22440244*y+22051981*y**2-4522609*y**3-4385409*y**4+1517943*y**5+968569*y**6
          -674081*y**7+95859*y**8+21959*y**9-1302*y**10)+r**4*(-1+y)**2*(274698
          -22864*y-15565*y**2-2227211*y**3+4252003*y**4-2935604*y**5+673869*y**6
          +104695*y**7-63509*y**8+8152*y**9+1736*y**10)-r**2*(-1+y)**3*(-3425
          -3779*y-4133*y**2-244042*y**3+251339*y**4-61155*y**5+142909*y**6-187762*y**7
          +102322*y**8-28434*y**9+2560*y**10)+r**6*(2001276-5149120*y+3949567*y**2
          -3385243*y**3+10069747*y**4-14621355*y**5+10004337*y**6-2962467*y**7
          -223457*y**8+413953*y**9-110046*y**10+12808*y**11))+24*logy*r**3*(-1
          +y)**4*(-1+r**2+y)**3*(124*r**26*(-1+y)**6-4*r**24*(-1+y)**4*(-2024
          +4141*y-2210*y**2+473*y**3)-r**22*(-1+y)**2*(-279741+1039704*y-1414110*y**2
          +821525*y**3-158995*y**4-10219*y**5+836*y**6)+r**20*(-1+y)**2*(1216919
          -4671119*y+6783810*y**2-4611640*y**3+1315345*y**4+66951*y**5-103246*y**6
          +11680*y**7)+5*r**18*(-1+y)**2*(3952987-12399292*y+12901560*y**2-3536353*y**3
          -1971707*y**4+1145121*y**5-79870*y**6-14022*y**7+456*y**8)-r**16*(-1
          +y)**2*(-16243217+61756553*y-90149592*y**2+52232158*y**3+2938233*y**4
          -15611383*y**5+5658772*y**6-216308*y**7-306908*y**8+31992*y**9)-2*r**14*(
          -99397639+447087702*y-760883973*y**2+525679005*y**3+35335160*y**4-260518422*y**5
          +116802196*y**6+13873056*y**7-22950255*y**8+5024990*y**9+58611*y**10
          -117823*y**11+3892*y**12)+(-1+y)**6*(89+267*y+534*y**2-6200*y**3
          +620*y**4-1938*y**5-39474*y**6+42512*y**7-13925*y**8-14745*y**9+41724*y**10
          -30168*y**11+6704*y**12)-r**6*(-1+y)**3*(3291509-291267*y-428253*y**2
          -50003974*y**3+110194635*y**4-89557158*y**5+42837394*y**6-37227984*y**7
          +35101883*y**8-17433835*y**9+4115699*y**10-219202*y**11-101963*y**12
          +2516*y**13)-10*r**8*(-1+y)**2*(-3378079+5716129*y-1713420*y**2+18827756*y**3
          -64928536*y**4+83530232*y**5-48091744*y**6+5561134*y**7+8279937*y**8
          -4716339*y**9+975972*y**10-12410*y**11-32314*y**12+2682*y**13)+r**2*(
          -1+y)**5*(-2391-5049*y-7974*y**2-318101*y**3+195315*y**4-48283*y**5
          -522397*y**6+1220773*y**7-684678*y**8+225860*y**9-268901*y**10+171496*y**11
          -46374*y**12+6704*y**13)+r**4*(-1+y)**4*(-243649-214969*y-196375*y**2
          -1583377*y**3+1295300*y**4+1045358*y**5+9828958*y**6-23915370*y**7+21064319*y**8
          -8489725*y**9+897241*y**10+416211*y**11-130930*y**12+17008*y**13)+2*r**12*(196237109
          -904195479*y+1589045601*y**2-1157042431*y**3-66406220*y**4+702358182*y**5
          -470010022*y**6+91351038*y**7+42602047*y**8-30238155*y**9+6282709*y**10
          +208501*y**11-221264*y**12+21384*y**13)+2*r**10*(69385171-289251138*y
          +449968683*y**2-348654421*y**3+309773170*y**4-531778662*y**5+614392506*y**6
          -358809186*y**7+70005447*y**8+33530690*y**9-22644759*y**10+3930507*y**11
          +245128*y**12-99526*y**13+6390*y**14))-r*(-1+y)**3*(-1+r**2+y)**4*(29*r**28*(
          -1+y)**7+2*r**26*(-1+y)**5*(-9679+17812*y-7331*y**2+803*y**3)+r**24*(
          -1+y)**3*(-416467+1545904*y-2105392*y**2+1321998*y**3-395457*y**4
          +34010*y**5+4964*y**6)+2*r**22*(3729334-23521398*y+62275708*y**2-88696836*y**3
          +71352580*y**4-29491797*y**5+2675613*y**6+2411082*y**7-787624*y**8+53085*y**9
          +253*y**10)+r**20*(9712151-63445793*y+180316883*y**2-291967077*y**3
          +291693498*y**4-175201964*y**5+48861214*y**6+7787392*y**7-10333673*y**8
          +2819277*y**9-232537*y**10-9371*y**11)+2*r**18*(170110489-970748873*y
          +2251511909*y**2-2607457140*y**3+1328041785*y**4+179521477*y**5-578525259*y**6
          +262463037*y**7-25598860*y**8-12427060*y**9+3343934*y**10-238593*y**11
          +3154*y**12)+r**16*(-332810921+1798678843*y-3699927499*y**2+3185081187*y**3
          +6873470*y**4-2151467458*y**5+1564284754*y**6-312374462*y**7-99702549*y**8
          +34289955*y**9+12628729*y**10-5920197*y**11+337536*y**12+28612*y**13)
          -4*r**14*(-763803634+3953792250*y-8007121780*y**2+7155626336*y**3-727122542*y**4
          -3991872507*y**5+3100911685*y**6-434505120*y**7-504310742*y**8+243271074*y**9
          -13497184*y**10-14529260*y**11+3372450*y**12-172669*y**13+3643*y**14)
          -(-1+y)**7*(-1219-4876*y-12190*y**2-53726*y**3-57599*y**4-60452*y**5
          -100308*y**6+64600*y**7+28027*y**8+27928*y**9+40246*y**10-31866*y**11
          -6585*y**12-3976*y**13+3996*y**14)-2*r**2*(-1+y)**6*(-28999-83491*y
          -160504*y**2-509763*y**3-291798*y**4-141107*y**5+856942*y**6-335092*y**7
          +514091*y**8+656701*y**9-1729794*y**10+1115399*y**11-309054*y**12+15897*y**13
          +10572*y**14)-2*r**6*(-1+y)**4*(-1747494-2692674*y-2217888*y**2+52654704*y**3
          -70516058*y**4+25629523*y**5-96509077*y**6+252384516*y**7-254549278*y**8
          +116511436*y**9-13147154*y**10-9611124*y**11+3714622*y**12-348301*y**13
          +24247*y**14)-r**4*(-1+y)**5*(-1031203-1894810*y-2581795*y**2+3056192*y**3
          -7588199*y**4+5658616*y**5+39989175*y**6-72121960*y**7+47385311*y**8
          -15138362*y**9+4687187*y**10-2631640*y**11+745355*y**12-89028*y**13
          +43161*y**14)-2*r**10*(-1+y)**2*(-207985809+481541039*y-286500000*y**2
          +903503009*y**3-3590310564*y**4+5467058788*y**5-3683170003*y**6+499750230*y**7
          +846157067*y**8-533705057*y**9+100893146*y**10+6724089*y**11-3308230*y**12
          +60174*y**13+48121*y**14)-r**8*(-1+y)**3*(81688601-63125904*y-18246624*y**2
          -824402394*y**3+2199417281*y**4-2172958442*y**5+946134068*y**6-139090092*y**7
          -20820877*y**8+21920348*y**9-4309184*y**10-10996314*y**11+6408691*y**12
          -838754*y**13+59596*y**14)+r**12*(1245892009-5951388223*y+10981863373*y**2
          -8856690651*y**3+612412525*y**4+5215282129*y**5-5578071319*y**6+3153249589*y**7
          -512278213*y**8-784685165*y**9+649390375*y**10-190326833*y**11+12655663*y**12
          +2907739*y**13-123485*y**14-89513*y**15)))*nlo.X1El(0,'SM',y/2,r))/(-6967296000*logy**5*r**20*(
          -1+y)**10+28000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-2903040000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-483840000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-40320000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -1680000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6
          +120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(
          -67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3
          -2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)
          +2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y
          -421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(
          -1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1
          +y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(
          -4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y
          +45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)
          +2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5
          -56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(1,'SLSR',y/2,r))/(345600*logy**3*r**12*(
          -1+y)**6-200*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +86400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+7200*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(21600*logy**3*r**11*(27+41*r**2
          +29*r**4+9*r**6)*(-1+y)**8+720*logy**2*r**7*(-1+y)**6*(74*r**12*(-1+y)**2
          +31*r**14*(-1+y)**2+r**10*(1389-1968*y+174*y**2+485*y**3-90*y**4)
          +5*r**8*(443-364*y-340*y**2+242*y**3+y**4+4*y**5)-(-1+y)**3*(11
          +11*y+11*y**2+251*y**3-184*y**4+20*y**5)-r**2*(-1+y)**2*(599-455*y**3
          +430*y**4-234*y**5+20*y**6)+5*r**6*(-17+772*y-1124*y**2+168*y**3
          +255*y**4-105*y**5+27*y**6)+r**4*(-3036+8502*y-6681*y**2-50*y**3
          +1860*y**4-744*y**5+113*y**6+36*y**7))+6*logy*r**3*(-1+y)**4*(-1+r**2
          +y)**2*(41*r**18*(-1+y)**4-r**16*(-1+y)**2*(-643+1368*y-807*y**2+162*y**3)
          -r**14*(-1+y)**2*(-15790+25508*y-7489*y**2-1926*y**3+257*y**4)+r**12*(
          -1+y)**2*(22492-45292*y+26723*y**2+338*y**3-2257*y**4+556*y**5)+(
          -1+y)**4*(11+22*y+33*y**2+604*y**3-95*y**4+94*y**5+683*y**6-1128*y**7
          +376*y**8)+r**10*(325264-987788*y+962749*y**2-168480*y**3-240815*y**4
          +115216*y**5-2237*y**6-4404*y**7+495*y**8)+r**2*(-1+y)**3*(1217+1195*y
          +1173*y**2+10851*y**3-12281*y**4+853*y**5-4525*y**6+5397*y**7-1856*y**8
          +376*y**9)+r**4*(-1+y)**2*(18460+228*y-1059*y**2-127026*y**3+222587*y**4
          -138000*y**5+21407*y**6+9694*y**7-3339*y**8+648*y**9)-r**8*(-592234
          +1816036*y-1796019*y**2+337456*y**3+482771*y**4-315066*y**5+67539*y**6
          +5044*y**7-6881*y**8+754*y**9)+r**6*(171082-446136*y+345989*y**2-173976*y**3
          +407904*y**4-548040*y**5+323186*y**6-83264*y**7-1874*y**8+5496*y**9
          -367*y**10))+r*(-1+y)**3*(-1+r**2+y)**3*(11*r**20*(-1+y)**5-r**18*(
          -1+y)**3*(-887+1561*y-584*y**2+20*y**3)-r**14*(-1+y)**2*(98866-215370*y
          +117060*y**2+18665*y**3-23400*y**4+2019*y**5+60*y**6)-6*r**16*(829
          -3910*y+7345*y**2-6960*y**3+3400*y**4-689*y**5-40*y**6+25*y**7)+r**12*(56552
          -202342*y+195188*y**2+67937*y**3-212345*y**4+111118*y**5-11938*y**6
          -5343*y**7+783*y**8+390*y**9)+(-1+y)**5*(56+168*y+336*y**2+869*y**3
          +572*y**4+363*y**5+82*y**6-561*y**7-144*y**8-47*y**9+106*y**10)+3*r**10*(
          -502676+1833106*y-2306948*y**2+790633*y**3+694954*y**4-671513*y**5
          +142444*y**6+32823*y**7-14458*y**8+871*y**9+164*y**10)+3*r**4*(-1+y)**3*(2543
          +3408*y+3113*y**2-42897*y**3+52608*y**4-18023*y**5+5142*y**6-7563*y**7
          +2797*y**8-133*y**9+205*y**10)+r**6*(-1+y)**2*(-128446+85278*y+28872*y**2
          +551901*y**3-1196170*y**4+902511*y**5-195488*y**6-103457*y**7+56364*y**8
          -5265*y**9+300*y**10)+r**2*(-1+y)**4*(1603+3104*y+4470*y**2+2351*y**3
          +1462*y**4-2943*y**5-16354*y**6+18205*y**7-7701*y**8+763*y**9+440*y**10)
          +r**8*(-598858+1924148*y-2036302*y**2+663653*y**3-36127*y**4+208109*y**5
          -130003*y**6+28427*y**7-47803*y**8+28227*y**9-3651*y**10+180*y**11)))*nlo.X1El(1,'SM',y/2,r))/(2073600*logy**4*r**16*(
          -1+y)**8+691200*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+86400*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+4800*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +100*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-180*logy*r**4*(3+r**2)*(-1+y)**4-3*(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(2,'SLSR',y/2,r))/(2880*logy**2*r**8*(
          -1+y)**4+480*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(2160*logy**2*r**7*(4+5*r**2+2*r**4)*(
          -1+y)**6+72*logy*r**3*(-1+y)**4*(8*r**10*(-1+y)**2+3*r**12*(-1+y)**2
          -5*r**8*(-44+64*y-8*y**2-13*y**3+2*y**4)+2*(-1+y)**3*(-1-y-y**2
          -6*y**3+4*y**4)+5*r**6*(26+8*y-64*y**2+21*y**3+7*y**4)+r**2*(-1
          +y)**2*(-58+35*y**3-15*y**4+8*y**5)+5*r**4*(-61+170*y-133*y**2+y**3
          +31*y**4-11*y**5+3*y**6))+3*r*(-1+y)**3*(-1+r**2+y)**2*(7*r**12*(-1
          +y)**3+2*r**10*(-81+214*y-174*y**2+35*y**3+6*y**4)+r**8*(-169+509*y
          -558*y**2+220*y**3+3*y**4-5*y**5)-4*r**6*(1431-2992*y+1413*y**2+518*y**3
          -447*y**4+47*y**5)+(-1+y)**3*(-13-26*y-39*y**2-54*y**3-9*y**4+4*y**5
          +17*y**6)+2*r**2*(-1+y)**2*(-61-72*y-71*y**2+319*y**3-256*y**4+55*y**5
          +26*y**6)+r**4*(-1749+2827*y-705*y**2+335*y**3-1195*y**4+489*y**5
          -47*y**6+45*y**7)))*nlo.X1El(2,'SM',y/2,r))/(-34560*logy**3*r**12*(-1+y)**6
          +20*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)
          +2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3-8640*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -720*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(
          -1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y
          -y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(3,'SLSR',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          )
      resNP += ((api*(12*logy*r**3*(1+r**2)*(-1+y)**4+2*r*(-1+y)**3*(r**6*(-1+y)
          +3*r**2*(-1+y)**2*(3+y)+3*r**4*(-3+y+y**2)+(-1+y)**2*(1+y+y**2)))*nlo.X1El(3,'SM',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      res += resNP*wc.SLSR

    if wc.VR2 != 0:
      resNP = 0
      resNP +=((217728000*logy**5*r**18*(24+57*r**2+83*r**4+83*r**6+57*r**8+24*r**10)*(
          -1+y)**10+518400*logy**4*r**14*(-1+y)**8*(9025*r**16*(-1+y)**2+1888*r**18*(
          -1+y)**2+r**14*(67667-84934*y-7933*y**2+34650*y**3-5040*y**4)+16*(
          -1+y)**4*(-118-236*y-354*y**2+543*y**3-170*y**4+20*y**5)+35*r**12*(2225
          -1030*y-2905*y**2+2032*y**3-120*y**4+48*y**5)+5*r**2*(-1+y)**3*(1805
          +1805*y+1805*y**2-6637*y**3+5424*y**4-1464*y**5+160*y**6)+7*r**10*(5239
          +14422*y-32111*y**2+8510*y**3+8820*y**4-4670*y**5+1040*y**6)+7*r**8*(
          -5239+35378*y-42589*y**2+1860*y**3+18665*y**4-9166*y**5+1577*y**6
          +144*y**7)+r**4*(-1+y)**2*(-67667+50400*y+25200*y**2+6580*y**3-36715*y**4
          +24752*y**5-4760*y**6+320*y**7)-35*r**6*(2225-7870*y+7355*y**2+394*y**3
          -2911*y**4+470*y**5+633*y**6-328*y**7+32*y**8))-17280*logy**3*r**10*(
          -1+y)**6*(-1+r**2+y)**2*(-1732*r**22*(-1+y)**4+r**20*(-1+y)**2*(-32871
          +69206*y-39799*y**2+5544*y**3)+r**18*(-1+y)**2*(-475747+794140*y
          -279515*y**2-44722*y**3+7444*y**4)-r**16*(-1+y)**2*(1463160-2410900*y
          +856265*y**2+362482*y**3-150279*y**4+20832*y**5)+4*(-1+y)**6*(-433
          -1732*y-4330*y**2-3440*y**3+1855*y**4+9868*y**5-7268*y**6+1280*y**7)
          +r**14*(-6933348+20714692*y-20146843*y**2+3009000*y**3+6347350*y**4
          -3305072*y**5+254973*y**6+58268*y**7-10220*y**8)+r**2*(-1+y)**5*(32871
          +102077*y+211082*y**2-37650*y**3-51685*y**4-204711*y**5+233288*y**6
          -90752*y**7+11280*y**8)-r**6*(-1+y)**3*(-1463160-947740*y-856265*y**2
          +7530017*y**3-6926122*y**4+1796790*y**5+438015*y**6-258575*y**7+26968*y**8
          +3472*y**9)+r**4*(-1+y)**4*(-475747-794140*y-1073655*y**2+2496192*y**3
          -1213565*y**4+226732*y**5-256865*y**6+197040*y**7-58912*y**8+5120*y**9)
          -r**8*(-1+y)**2*(6933348-7018700*y-397145*y**2-2803562*y**3+8615809*y**4
          -5093728*y**5+244365*y**6+715230*y**7-225833*y**8+25616*y**9)+r**12*(
          -11757142+35101964*y-33040381*y**2+835372*y**3+17050307*y**4-9267108*y**5
          +259481*y**6+1150756*y**7-374857*y**8+30408*y**9)+r**10*(-11757142+35440888*y
          -33887691*y**2+3267392*y**3+11196327*y**4-1806642*y**5-4554233*y**6
          +2481556*y**7-346617*y**8-36442*y**9+2604*y**10))+288*logy**2*r**6*(-1
          +y)**5*(-1+r**2+y)**3*(248*r**28*(-1+y)**5-r**26*(-1+y)**3*(-27777+56298*y
          -29265*y**2+3784*y**3)-r**24*(1109070-5317665*y+10109643*y**2-9525280*y**3
          +4454910*y**4-834975*y**5+2625*y**6+1672*y**7)+r**22*(-9337202+43868755*y
          -81634373*y**2+74859060*y**3-32903250*y**4+4123677*y**5+1343065*y**6
          -343092*y**7+23360*y**8)+8*(-1+y)**8*(-31-186*y-651*y**2-1521*y**3
          -2251*y**4-1044*y**5+4811*y**6+3251*y**7-5804*y**8+1676*y**9)+r**20*(
          -70438398+291751881*y-455876643*y**2+302273160*y**3-30099150*y**4-61186437*y**5
          +25695739*y**6-2066732*y**7-57980*y**8+4560*y**9)+r**18*(-134121279
          +558112680*y-889629405*y**2+582973280*y**3+25011475*y**4-244110812*y**5
          +117933795*y**6-14619370*y**7-2524730*y**8+1038350*y**9-63984*y**10)
          +r**2*(-1+y)**7*(27777+139629*y+421119*y**2+606369*y**3+260379*y**4
          -826245*y**5-57379*y**6-182569*y**7+418456*y**8-163704*y**9+21168*y**10)
          +2*r**16*(-300957598+1025721731*y-1185035725*y**2+243155655*y**3+565363725*y**4
          -419162574*y**5+24432878*y**6+64654975*y**7-20119605*y**8+1564625*y**9
          +193697*y**10-7784*y**11)-r**8*(-1+y)**4*(70438398+80436687*y+83688075*y**2
          -458234720*y**3+321258880*y**4-35686136*y**5-13334344*y**6-14228300*y**7
          +8333270*y**8-679555*y**9-235287*y**10+5032*y**11)+2*r**12*(-1+y)**2*(
          -300957598+479066259*y-91724781*y**2-131815226*y**3-123644796*y**4
          +202388475*y**5-33715989*y**6-34122294*y**7+13857626*y**8-823754*y**9
          -73702*y**10+12780*y**11)+r**4*(-1+y)**6*(-1109070-4208595*y-10109643*y**2
          -5228363*y**3+4201177*y**4+17726587*y**5-15906813*y**6+4289843*y**7
          -494387*y**8+350648*y**9-122792*y**10+13408*y**11)+r**6*(-1+y)**5*(9337202
          +25194351*y+47102820*y**2-35379880*y**3-7788670*y**4-43295784*y**5
          +72084608*y**6-33142620*y**7+3204480*y**8+1568845*y**9-391368*y**10
          +34016*y**11)-r**10*(-1+y)**3*(-134121279-21627564*y-20019039*y**2
          +792860916*y**3-1015509654*y**4+291688254*y**5+176901424*y**6-130627636*y**7
          +22071909*y**8+2176454*y**9-1052425*y**10+53640*y**11)+2*r**14*(-422890830
          +1480117905*y-1735654167*y**2+245150625*y**3+1148205300*y**4-887105055*y**5
          +24874690*y**6+241222049*y**7-109180850*y**8+13402050*y**9+2430385*y**10
          -614870*y**11+42768*y**12))+12*logy*r**4*(-1+y)**4*(-1+r**2+y)**4*(
          -9*r**30*(-1+y)**6-r**28*(-1+y)**4*(-85313+158686*y-67385*y**2+2572*y**3)
          -r**26*(-1+y)**2*(-4043551+15170220*y-20870264*y**2+12784804*y**3-3293443*y**4
          +196696*y**5+12978*y**6)-r**24*(-63749321+344430786*y-758046029*y**2
          +858573656*y**3-508303937*y**4+125366326*y**5+10278749*y**6-9112476*y**7
          +572954*y**8+19692*y**9)+r**22*(273760923-1411311986*y+2945633705*y**2
          -3086381836*y**3+1510544106*y**4-41454720*y**5-292089474*y**6+115325740*y**7
          -15018789*y**8+1134674*y**9+3257*y**10)+(-1+y)**10*(-9-72*y-324*y**2
          +7368*y**3+35690*y**4+79720*y**5-2292*y**6-97336*y**7+18247*y**8+4400*y**9
          -896*y**10+3104*y**11)+r**20*(1783135709-8181561290*y+14433209311*y**2
          -10873484752*y**3+515312930*y**4+4597279044*y**5-2755061906*y**6+401016904*y**7
          +107604017*y**8-30352490*y**9+2571587*y**10+28536*y**11)+r**18*(1531289539
          -7365205714*y+14449472871*y**2-12803080960*y**3+1341809010*y**4+6822179892*y**5
          -5082834082*y**6+827613448*y**7+461151335*y**8-218361810*y**9+37161019*y**10
          -807704*y**11+5156*y**12)+r**2*(-1+y)**8*(85313+499938*y+1713945*y**2
          +3491848*y**3+3793658*y**4-745268*y**5-5925198*y**6-3760152*y**7+6668277*y**8
          -2115358*y**9+259205*y**10-67040*y**11+20832*y**12)+r**4*(-1+y)**7*(
          -4043551-19213771*y-55254255*y**2-64985343*y**3-17202478*y**4+97777194*y**5
          -19985686*y**6+16398922*y**7-35638707*y**8+18299153*y**9-2651243*y**10
          -140443*y**11+64208*y**12)+r**6*(-1+y)**6*(63749321+216932144*y+477364564*y**2
          +41705592*y**3-305422083*y**4-781151920*y**5+1022054704*y**6-329871136*y**7
          -10623517*y**8+13817408*y**9+2446524*y**10-993048*y**11+135447*y**12)
          +r**14*(-1+y)**2*(11222015653-24589302772*y+10710832470*y**2+17603181404*y**3
          -19740516481*y**4+1838403128*y**5+5672631268*y**6-2488172136*y**7+95714371*y**8
          +161548156*y**9-32118906*y**10+3152204*y**11+151641*y**12)+r**8*(-1
          +y)**5*(-273760923-590029217*y-944292502*y**2+2019393190*y**3-328395070*y**4
          +913907786*y**5-2079652696*y**6+1195013224*y**7-96832515*y**8-108816305*y**9
          +33659062*y**10-3242262*y**11+240228*y**12)+r**12*(-1+y)**3*(-1531289539
          +291241981*y-301545405*y**2+11511116791*y**3-18443500634*y**4+6675896914*y**5
          +4714581974*y**6-3889966434*y**7+639878009*y**8+143875409*y**9-45701625*y**10
          +3027595*y**11+320964*y**12)+r**10*(-1+y)**4*(1783135709+1049018454*y
          +587339695*y**2-12237331284*y**3+12918172976*y**4-1333216972*y**5-3616423322*y**6
          +1614485856*y**7-18574091*y**8-117352026*y**9+26680763*y**10-2365532*y**11
          +341774*y**12)+r**16*(11222015653-42742791146*y+56094553405*y**2-13317622096*y**3
          -36709649850*y**4+32386725804*y**5+243718922*y**6-12019266760*y**7+5416643377*y**8
          -366958650*y**9-266488807*y**10+60952424*y**11-1842620*y**12+10344*y**13))
          -(-1+y)**2*(-1+r**2+y)**5*(11*r**36*(-1+y)**8+5*r**34*(-1+y)**6*(-88
          +165*y-66*y**2+27*y**3)+r**32*(-1+y)**4*(4267-14815*y+16809*y**2
          -10820*y**3+8561*y**4-3425*y**5+719*y**6)+r**30*(-1+y)**2*(-2870496
          +16180138*y-37390470*y**2+45376027*y**3-30644300*y**4+11118695*y**5
          -1851230*y**6+92617*y**7-14336*y**8+2075*y**9)+r**28*(-54099404+397582262*y
          -1260826306*y**2+2249427791*y**3-2461003817*y**4+1677157358*y**5-678659492*y**6
          +134074076*y**7+7974*y**8-4002028*y**9+358486*y**10-26275*y**11+2975*y**12)
          +r**26*(-466552288+3202710502*y-9358796258*y**2+14944198101*y**3-13665969780*y**4
          +6330926943*y**5-151042400*y**6-1382768778*y**7+649433996*y**8-102665240*y**9
          +253570*y**10+290693*y**11+3976*y**12-637*y**13)+(-1+y)**12*(11+99*y
          +495*y**2+2417*y**3+4974*y**4+2078*y**5-2482*y**6-4358*y**7+2199*y**8
          +1991*y**9-2349*y**10+373*y**11+128*y**12+24*y**13)+r**24*(-996454668
          +6489559906*y-18018069254*y**2+27156928995*y**3-22567414375*y**4+7458526331*y**5
          +3627460443*y**6-4775233602*y**7+1916690710*y**8-306558120*y**9+18343432*y**10
          -2750929*y**11-1117699*y**12+78715*y**13-12285*y**14)+r**2*(-1+y)**11*(440
          +3465*y+15345*y**2+68767*y**3+115979*y**4+15946*y**5-91798*y**6-98362*y**7
          +120390*y**8+16597*y**9-59411*y**10+17883*y**11-1833*y**12-232*y**13
          +24*y**14)+r**4*(-1+y)**10*(4267+27616*y+101671*y**2+208895*y**3-415300*y**4
          -1644349*y**5+2465158*y**6+3053158*y**7-2648245*y**8+304150*y**9-573773*y**10
          +136971*y**11+54766*y**12-5705*y**13+320*y**14)+r**6*(-1+y)**9*(2870496
          +16180138*y+53570608*y**2+97091889*y**3+83337809*y**4-54052129*y**5
          -96337863*y**6-54930918*y**7+115876570*y**8-46200120*y**9+4810738*y**10
          -575995*y**11+478565*y**12-41729*y**13+1941*y**14)+r**8*(-1+y)**8*(
          -54099404-235284050*y-627959994*y**2-508723535*y**3+75585675*y**4+1124762073*y**5
          -704480695*y**6+173562778*y**7-229958870*y**8+144287920*y**9-26931024*y**10
          -2453035*y**11+1701511*y**12-172375*y**13+7025*y**14)+r**16*(-1+y)**4*(5745432098
          -5580978748*y-6668075908*y**2+7103858259*y**3-1312046121*y**4+933441345*y**5
          +1733882697*y**6-2406567738*y**7+180016488*y**8+189871438*y**9-42742658*y**10
          -23842889*y**11+5432031*y**12-1159587*y**13+7293*y**14)+r**10*(-1+y)**7*(466552288
          +1336501350*y+2549978480*y**2-1816777773*y**3-2715950317*y**4-4501139425*y**5
          +8763438229*y**6-3601213858*y**7-428506914*y**8+500805892*y**9-60494838*y**10
          -10680529*y**11+3694703*y**12-468713*y**13+16625*y**14)-r**18*(-1+y)**3*(
          -60825974992+152064937480*y-86542891922*y**2-99685117905*y**3+139166126855*y**4
          -22582219431*y**5-43641767405*y**6+22695207854*y**7-297170610*y**8-1856875470*y**9
          +403413308*y**10-9837965*y**11-957397*y**12+725725*y**13+17875*y**14)
          +r**14*(-1+y)**5*(9519863584+1142294562*y-1802649288*y**2-58792536095*y**3
          +81541675665*y**4-13356432413*y**5-33022685379*y**6+18514456866*y**7
          -1185944190*y**8-1481120800*y**9+408470394*y**10-56088243*y**11+7005437*y**12
          -1211925*y**13+25025*y**14)+r**12*(-1+y)**6*(-996454668-1507286566*y
          -2024376310*y**2+11625117475*y**3-8895278299*y**4+1944020733*y**5-3209467043*y**6
          +2728827478*y**7-467592314*y**8-368448948*y**9+181784980*y**10-37550921*y**11
          +5844577*y**12-891891*y**13+26117*y**14)-r**20*(-1+y)**2*(-5745432098
          +23146181742*y-28462330080*y**2+3043436807*y**3+20721242971*y**4-19599206071*y**5
          +10133904451*y**6-3975287978*y**7+528299940*y**8+317287424*y**9-80569186*y**10
          +5776227*y**11+2982003*y**12+216073*y**13+32175*y**14)-r**22*(9519863584
          -58261476066*y+146706777282*y**2-184878491381*y**3+94650291456*y**4
          +43344455058*y**5-93045967810*y**6+52126497939*y**7-7334343680*y**8-4833007654*y**9
          +2356817070*y**10-368562799*y**11+13933504*y**12+3275286*y**13-89102*y**14
          +27313*y**15)))/(6967296000*logy**5*r**20*(-1+y)**10-28000*(r**8*(-1+y)**2
          -6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y
          -4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5+2903040000*logy**4*r**16*(
          -1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +483840000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2+40320000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3+1680000*logy*(
          -1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(
          -4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2
          +y**3))**4))
      resNP += ((api*(2612736000*logy**6*r**22*(-24+83*r**4+166*r**6+171*r**8
          +96*r**10)*(-1+y)**12+12441600*logy**5*r**18*(-1+y)**10*(8184*r**18*(-1
          +y)**2+5*r**16*(5237-10474*y+5237*y**2+168*y**3)-2*r**14*(-65497+70514*y
          +25223*y**2-41685*y**3+5040*y**4)+105*r**12*(617+818*y-2461*y**2+1342*y**3
          -204*y**4+96*y**5)-12*(-1+y)**3*(551+551*y+551*y**2-2109*y**3+1426*y**4
          -380*y**5+40*y**6)+210*r**6*(-345+690*y-345*y**2-59*y**3+249*y**4
          -249*y**5+83*y**6)+14*r**10*(-4128+23196*y-26538*y**2+6630*y**3+4230*y**4
          -2875*y**5+940*y**6)-40*r**2*(-1+y)**2*(-139+1470*y**3-1757*y**4+861*y**5
          -203*y**6+20*y**7)+7*r**8*(-17427+49794*y-39837*y**2+2800*y**3+12785*y**4
          -9088*y**5+2641*y**6+72*y**7)+r**4*(9911-50062*y+55271*y**2-27790*y**3
          +72275*y**4-106316*y**5+61467*y**6-17296*y**7+2700*y**8-160*y**9))
          +103680*logy**4*r**14*(-1+y)**8*(-1+r**2+y)**2*(65472*r**22*(-1+y)**4
          -r**20*(-1+y)**2*(-843787+1818518*y-1105675*y**2+178944*y**3)-2*r**18*(
          -1+y)**2*(-4479118+7412295*y-2713044*y**2-306875*y**3+30192*y**4)
          +r**16*(20830280-77524310*y+107663733*y**2-60869020*y**3+2073490*y**4
          +11267210*y**5-3917075*y**6+519792*y**7)+120*(-1+y)**5*(695+2085*y
          +4170*y**2-628*y**3-2955*y**4-6157*y**5+8946*y**6-3736*y**7+520*y**8)
          -2*r**14*(-30243002+89294983*y-89902451*y**2+21727710*y**3+21247040*y**4
          -15806343*y**5+4489317*y**6-1013474*y**7+73920*y**8)+r**12*(67117074
          -187997454*y+163688679*y**2+18649408*y**3-124661507*y**4+78911766*y**5
          -9710431*y**6-9357304*y**7+4038237*y**8-348768*y**9)+16*r**2*(-1+y)**4*(
          -38251-86927*y-146028*y**2+144826*y**3+54205*y**4+184161*y**5-408248*y**6
          +264568*y**7-73596*y**8+7640*y**9)+r**4*(-1+y)**3*(5938349+3361981*y
          +3019413*y**2-27297695*y**3+23184427*y**4-11080629*y**5+10325959*y**6
          -8839373*y**7+3728760*y**8-697912*y**9+45120*y**10)-2*r**6*(-1+y)**2*(2514850
          +998565*y+1017189*y**2-30008617*y**3+41688237*y**4-21895829*y**5+6235015*y**6
          -2891559*y**7+1791197*y**8-548032*y**9+53184*y**10)+2*r**10*(18303234
          -48387789*y+33581286*y**2+33374156*y**3-79112974*y**4+56616998*y**5
          -9062126*y**6-10582496*y**7+6852964*y**8-1694301*y**9+199248*y**10)
          +r**8*(2732144-4271018*y-11555769*y**2+83063796*y**3-182168344*y**4
          +181941368*y**5-79901458*y**6+3950644*y**7+8316304*y**8-2010406*y**9
          -209437*y**10+112176*y**11))+6912*logy**3*r**10*(-1+y)**6*(-1+r**2+y)**3*(9900*r**28*(
          -1+y)**6-9*r**26*(-1+y)**4*(-52869+109038*y-59469*y**2+9440*y**3)
          +r**24*(-1+y)**2*(11467665-43399503*y+60944922*y**2-37850248*y**3+9125477*y**4
          -288373*y**5+28860*y**6)+r**22*(-1+y)**2*(68843047-256676806*y+356743290*y**2
          -217723760*y**3+42998135*y**4+9416518*y**5-3886044*y**6+385320*y**7)
          -3*r**20*(-1+y)**2*(-131128949+407962329*y-434752930*y**2+137680320*y**3
          +56771775*y**4-42341701*y**5+7090856*y**6-1224940*y**7+113440*y**8)
          -6*(-1+y)**8*(3753+18765*y+56295*y**2+79635*y**3+38265*y**4-110741*y**5
          -93115*y**6-9595*y**7+174390*y**8-106140*y**9+18488*y**10)-6*r**2*(
          -1+y)**7*(-98293-404431*y-1039225*y**2-746305*y**3+101445*y**4+1871611*y**5
          -369603*y**6+95825*y**7-1294220*y**8+1130680*y**9-357268*y**10+38784*y**11)
          -10*r**18*(-56723600+298409934*y-643471125*y**2+683186508*y**3-275785204*y**4
          -137204154*y**5+206455128*y**6-87412320*y**7+10527482*y**8+3052184*y**9
          -1112301*y**10+71868*y**11)+r**6*(-1+y)**5*(39121489+73021361*y+111358860*y**2
          -244369690*y**3-20623820*y**4-196052388*y**5+606126458*y**6-481094830*y**7
          +144196015*y**8-3408505*y**9-6053826*y**10+760556*y**11+34320*y**12)
          +15*r**8*(-1+y)**4*(-15878885+398321*y-301641*y**2+75445067*y**3-95008968*y**4
          +53058880*y**5-41962012*y**6+38157288*y**7-16416427*y**8+982603*y**9
          +1377465*y**10-399719*y**11+38428*y**12)-r**10*(-1+y)**3*(-16984079
          -168609735*y-25928175*y**2+2135852665*y**3-3688217360*y**4+2237584208*y**5
          -317644040*y**6-139199620*y**7+11270035*y**8+12807235*y**9+3435171*y**10
          -2489625*y**11+109320*y**12)-r**4*(-1+y)**6*(11555505+31499343*y+59301450*y**2
          -29902700*y**3-43481800*y**4-85804270*y**5+159655694*y**6-83802820*y**7
          +25257475*y**8-12798925*y**9+6501140*y**10-1549212*y**11+123120*y**12)
          -2*r**12*(-1+y)**2*(-220209043+411954349*y+74185845*y**2-1387709685*y**3
          +2225641975*y**4-1291579609*y**5-192141573*y**6+586088115*y**7-244661840*y**8
          +9427950*y**9+20020802*y**10-5694876*y**11+376590*y**12)+2*r**16*(672276584
          -2860275054*y+4703161815*y**2-3208606645*y**3-315086620*y**4+2019016462*y**5
          -1328054242*y**6+295476880*y**7+75421370*y**8-76228930*y**9+27139629*y**10
          -4606929*y**11+421680*y**12)+6*r**14*(199931015-809563784*y+1167621254*y**2
          -316116510*y**3-1144926480*y**4+1570452140*y**5-697753082*y**6-197067598*y**7
          +351506045*y**8-141006520*y**9+12363020*y**10+5920716*y**11-1482756*y**12
          +122540*y**13))+144*logy**2*r**6*(-1+y)**5*(-1+r**2+y)**4*(-23*r**32*(
          -1+y)**5*(-3209+6418*y-3209*y**2+480*y**3)+2*r**30*(-1+y)**3*(3813069
          -14687090*y+20974070*y**2-13451484*y**3+3657293*y**4-299378*y**5+21840*y**6)
          +r**28*(-156696765+1057733311*y-3046631339*y**2+4868560501*y**3-4688262617*y**4
          +2751366175*y**5-934031441*y**6+151803679*y**7-2082686*y**8-1856018*y**9
          +97200*y**10)-4*r**26*(414551093-2635932465*y+7078032315*y**2-10329043568*y**3
          +8694283262*y**4-3997545800*y**5+687352960*y**6+161157200*y**7-82147187*y**8
          +10329433*y**9-1111803*y**10+74560*y**11)+r**24*(-5491998351+34099706433*y
          -89501248887*y**2+126815795453*y**3-100005267806*y**4+35510585498*y**5
          +6101489418*y**6-11157717398*y**7+4276140677*y**8-679436979*y**9+24715653*y**10
          +7626609*y**11-390320*y**12)+48*(-1+y)**10*(31+217*y+868*y**2+2327*y**3
          +4237*y**4+4165*y**5-3037*y**6-9269*y**7-3302*y**8+5688*y**9+7379*y**10
          -7480*y**11+1676*y**12)+32*r**2*(-1+y)**9*(-7190-43326*y-152292*y**2
          -298927*y**3-309853*y**4+84177*y**5+380444*y**6+365411*y**7-348189*y**8
          +3753*y**9-123262*y**10+149532*y**11-47794*y**12+4516*y**13)+2*r**22*(
          -13036123443+71740866807*y-160783588485*y**2+178791026785*y**3-81950110742*y**4
          -25544771638*y**5+50727703130*y**6-24161409178*y**7+4080963485*y**8+305709647*y**9
          -219329589*y**10+54677193*y**11-6002932*y**12+388960*y**13)-r**8*(-1
          +y)**6*(-1451010035-3264559141*y-5356025172*y**2+7635207792*y**3+4694199929*y**4
          +7877242459*y**5-24027345344*y**6+16328861848*y**7-4459376825*y**8+1070244121*y**9
          -643091724*y**10+206541160*y**11-15320701*y**12-2404767*y**13+4400*y**14)
          -4*r**10*(-1+y)**5*(532880619+836279928*y+1279041687*y**2-5067306179*y**3
          +873734652*y**4-3829426511*y**5+15014097086*y**6-14177258842*y**7+4348245515*y**8
          +736625918*y**9-765614133*y**10+154922861*y**11-3662770*y**12-2093911*y**13
          +66080*y**14)+r**4*(-1+y)**8*(12847569+61921525*y+180451791*y**2+222389195*y**3
          +83426306*y**4-335962822*y**5-172867954*y**6-7442746*y**7+417121421*y**8
          -291841711*y**9+73333203*y**10-14094721*y**11+6399280*y**12-1622416*y**13
          +134080*y**14)+2*r**6*(-1+y)**7*(-76421619-287760878*y-691310232*y**2
          -271014742*y**3+269568917*y**4+1320015980*y**5-704853112*y**6+124753796*y**7
          -874445569*y**8+941333378*y**9-352254336*y**10+32817890*y**11+9575311*y**12
          -2310064*y**13+177280*y**14)+r**20*(-18118394101+110411767663*y-286257098343*y**2
          +375478034189*y**3-190165703694*y**4-126146405342*y**5+245432717970*y**6
          -133484521638*y**7+10232112263*y**8+20574837659*y**9-9439532907*y**10
          +1488323417*y**11+4034556*y**12-12447052*y**13+707360*y**14)-r**16*(
          -1+y)**2*(38804295141-88717211593*y+17906259258*y**2+177659041838*y**3
          -266745370013*y**4+105671297585*y**5+95401088668*y**6-114164491724*y**7
          +31418058091*y**8+9899800633*y**9-7507045526*y**10+1321155550*y**11-480659*y**12
          -24652929*y**13+743680*y**14)+2*r**14*(-1+y)**3*(5945843059-17029728270*y
          +4837008906*y**2+70321106040*y**3-134660239359*y**4+84095487058*y**5
          +10761135356*y**6-37168497616*y**7+14572412981*y**8+540814054*y**9-1609181142*y**10
          +302071064*y**11+19350135*y**12-7019146*y**13+748880*y**14)+r**12*(-1
          +y)**4*(15798847713-10891379223*y-3672465939*y**2-62126431271*y**3+123969656628*y**4
          -86939814728*y**5+36686644034*y**6-19594025494*y**7+6196236065*y**8+3095766737*y**9
          -2701875135*y**10+532383389*y**11+21835658*y**12-11217394*y**13+1070960*y**14)
          -8*r**18*(6406100115-27647816951*y+44841724289*y**2-25981719926*y**3
          -14027554373*y**4+29034862625*y**5-12793771253*y**6-4265641668*y**7+7136176437*y**8
          -3543052149*y**9+996403035*y**10-150073446*y**11-16702371*y**12+14397739*y**13
          -3488503*y**14+156400*y**15))+24*logy*r**4*(-1+y)**4*(-1+r**2+y)**5*(
          -67*r**36*(-1+y)**8-r**34*(-1+y)**6*(-8371+16407*y-7701*y**2+751*y**3)
          -r**32*(-1+y)**4*(-4165414+15817492*y-22057665*y**2+13919660*y**3-3983564*y**4
          +410072*y**5+2467*y**6)-r**30*(-1+y)**2*(-164041554+912718574*y-2081887215*y**2
          +2495745669*y**3-1667377239*y**4+597247379*y**5-94784781*y**6+2708731*y**7
          -144395*y**8+9071*y**9)+r**28*(1631286194-11918605392*y+37633441161*y**2
          -66932210774*y**3+72970659621*y**4-49242570404*y**5+19125198962*y**6
          -2910899736*y**7-655010876*y**8+346176164*y**9-50597355*y**10+3296830*y**11
          -44395*y**12)+r**26*(10787675558-73427698810*y+213012549617*y**2-338085998555*y**3
          +307455037991*y**4-140839364147*y**5+713355030*y**6+34200850710*y**7
          -16919012264*y**8+3343162044*y**9-263391591*y**10+22423285*y**11+147963*y**12
          -117631*y**13)+r**24*(18823928814-125752122436*y+362699386697*y**2-576721863724*y**3
          +516256850280*y**4-192734319032*y**5-92572584409*y**6+150478281208*y**7
          -76456384282*y**8+16260934348*y**9+544528023*y**10-1024573100*y**11+204870500*y**12
          -6447664*y**13-104423*y**14)+8*(-1+y)**12*(8+72*y+360*y**2+638*y**3
          -2242*y**4-14089*y**5-14770*y**6+4226*y**7+21512*y**8+10294*y**9-16354*y**10
          +1688*y**11+354*y**12-485*y**13+388*y**14)+r**2*(-1+y)**10*(-135775
          -932249*y-3665220*y**2-9197950*y**3-14073063*y**4-8045031*y**5+11599404*y**6
          +24205056*y**7+1713291*y**8-10693663*y**9-13974092*y**10+14150370*y**11
          -3721061*y**12+440959*y**13-128124*y**14+25148*y**15)+r**4*(-1+y)**9*(9341449
          +53948433*y+182767770*y**2+321781336*y**3+290769105*y**4-157510247*y**5
          -348505714*y**6-282939948*y**7+378539635*y**8-63584613*y**9+97595094*y**10
          -128793344*y**11+49495603*y**12-5439621*y**13-423742*y**14+110804*y**15)
          +r**22*(116192095402-685950136578*y+1655089027281*y**2-1963702578689*y**3
          +856773795840*y**4+615797052802*y**5-1016709108937*y**6+490987792695*y**7
          -17215588190*y**8-79270228278*y**9+33212850207*y**10-5626300835*y**11
          +423533524*y**12-11697546*y**13+9299513*y**14+191789*y**15)+r**6*(-1
          +y)**8*(-212006706-950469686*y-2608699245*y**2-2519301459*y**3-135161512*y**4
          +5444457278*y**5+845904125*y**6-739647827*y**7-5590165594*y**8+5064681022*y**9
          -1446102275*y**10+95353511*y**11-20785228*y**12+19550778*y**13-3854285*y**14
          +375103*y**15)+r**8*(-1+y)**7*(1249081286+4112675974*y+8962023801*y**2
          -2009492113*y**3-7319228788*y**4-19538550920*y**5+20457788619*y**6-6342665675*y**7
          +13686250198*y**8-17011198802*y**9+7408666879*y**10-632033543*y**11-413515976*y**12
          +124234740*y**13-13433635*y**14+997955*y**15)+r**18*(-1+y)**2*(161153711292
          -341005153052*y-18634624743*y**2+563835150039*y**3-302447617056*y**4
          -458701161870*y**5+648924116533*y**6-260157196095*y**7-40241496324*y**8
          +68913638776*y**9-22905448757*y**10+3448461969*y**11-282413112*y**12
          +57100210*y**13+3093255*y**14+1406935*y**15)+r**10*(-1+y)**6*(-9224758454
          -15623912202*y-20622493359*y**2+66994401163*y**3+12734076858*y**4+24351309500*y**5
          -173789164351*y**6+157442434413*y**7-39232661826*y**8-11193091986*y**9
          +6783891867*y**10-352754547*y**11-369206754*y**12+106999488*y**13-15961997*y**14
          +1948187*y**15)+r**16*(-1+y)**3*(-131960754290+374003671518*y-197069448735*y**2
          -718369311473*y**3+1333850517576*y**4-632532145380*y**5-409385473745*y**6
          +528415767321*y**7-112646658618*y**8-75317533186*y**9+40574652831*y**10
          -3036321423*y**11-1755379036*y**12+419089416*y**13-21112815*y**14+2120039*y**15)
          +r**12*(-1+y)**5*(-1875609534+4743940330*y+15479641683*y**2-41495611047*y**3
          +5500386538*y**4-85984757078*y**5+302931096975*y**6-297335576571*y**7
          +82155856134*y**8+37111337854*y**9-28115516167*y**10+5239024395*y**11
          +82831438*y**12-72209362*y**13-5539867*y**14+2704279*y**15)+r**14*(-1
          +y)**4*(-84354499786+106114561042*y+20542703691*y**2+212625513677*y**3
          -704491797812*y**4+602914779698*y**5-31856573975*y**6-232500635103*y**7
          +135997306470*y**8-22673097842*y**9-5643510019*y**10+3289241583*y**11
          -690564488*y**12+109145678*y**13-10250321*y**14+2717507*y**15)+r**20*(
          -26176924964+89462278552*y+53526870373*y**2-587302101674*y**3+788304245177*y**4
          +84931975944*y**5-1118453882127*y**6+1031211100494*y**7-229027131027*y**8
          -215065610504*y**9+170456659999*y**10-43928149262*y**11+375258683*y**12
          +2009687976*y**13-350891573*y**14+25861546*y**15+752387*y**16))+r**2*(
          -1+y)**2*(-1+r**2+y)**6*(33*r**40*(-1+y)**10+2*r**38*(-1+y)**8*(-748
          +1397*y-550*y**2+179*y**3)+r**36*(-1+y)**6*(24058-89062*y+115557*y**2
          -75204*y**3+37260*y**4-10174*y**5+1521*y**6)+6*r**34*(-1+y)**4*(151348
          -897467*y+2219705*y**2-2899613*y**3+2065385*y**4-724461*y**5+68119*y**6
          +24749*y**7-5589*y**8+416*y**9)-r**32*(-1+y)**2*(-196381925+1476470266*y
          -4801983989*y**2+8839748060*y**3-10113387970*y**4+7423301792*y**5-3472905218*y**6
          +987423604*y**7-151420597*y**8+9247382*y**9-129921*y**10+22112*y**11
          +2804*y**12)-8*r**30*(-410179876+3745137400*y-15210954675*y**2+36121209185*y**3
          -55362732039*y**4+56884439085*y**5-39175462566*y**6+17281851241*y**7
          -4168607270*y**8+148268880*y**9+182124601*y**10-35970899*y**11+808009*y**12
          +91075*y**13-18136*y**14+2385*y**15)-12*r**28*(-1468519418+12825567056*y
          -49630845654*y**2+111505553068*y**3-159486220146*y**4+148397079340*y**5
          -85555058159*y**6+23122001640*y**7+5110081123*y**8-7144111572*y**9+2864917632*y**10
          -615018720*y**11+81755904*y**12-7269976*y**13+101333*y**14-26564*y**15
          +1913*y**16)-(-1+y)**13*(-55-495*y-2475*y**2-5567*y**3-37591*y**4
          -152047*y**5-105575*y**6+114813*y**7+186491*y**8-37533*y**9-257313*y**10
          +149171*y**11+64363*y**12-65149*y**13+17299*y**14-2385*y**15-376*y**16
          +24*y**17)-2*r**2*(-1+y)**12*(1124+9925*y+48477*y**2+522139*y**3+1690277*y**4
          +2536773*y**5-1740807*y**6-6694277*y**7-3598055*y**8+2836247*y**9+6475991*y**10
          -3490919*y**11+862863*y**12-649649*y**13+14611*y**14+82897*y**15-5489*y**16
          +272*y**17)-3*r**4*(-1+y)**11*(-3199970-21318708*y-81568229*y**2-186870369*y**3
          -255305365*y**4-97573209*y**5+209239455*y**6+363211467*y**7-37006085*y**8
          -131498517*y**9-168159503*y**10+192205869*y**11-57658511*y**12+5943749*y**13
          -1458923*y**14+551977*y**15-39221*y**16+1693*y**17)+8*r**26*(12494731252
          -103011519922*y+371849624403*y**2-760886407139*y**3+940602429358*y**4
          -655714496408*y**5+124667388236*y**6+209072475427*y**7-215238699105*y**8
          +93605593806*y**9-17188875733*y**10-1154259709*y**11+1076707604*y**12
          -192681556*y**13+17606886*y**14+344589*y**15+20795*y**16+6016*y**17)
          -24*r**10*(-1+y)**8*(403605124+1092057352*y+2126330719*y**2-3178701191*y**3
          -2007133996*y**4-4821731798*y**5+11239923666*y**6-7206860353*y**7+5453513527*y**8
          -5227964452*y**9+2426202411*y**10-247268865*y**11-190688622*y**12+81521114*y**13
          -16807452*y**14+2747513*y**15-305153*y**16+9256*y**17)-2*r**6*(-1+y)**10*(149245324
          +810552663*y+2603618004*y**2+3952457782*y**3+2742872364*y**4-3507745438*y**5
          -3576332684*y**6-1912226334*y**7+5591212908*y**8-2148544196*y**9+970211516*y**10
          -1165139094*y**11+539501748*y**12-74397290*y**13-9590468*y**14+4012798*y**15
          -350360*y**16+13557*y**17)-6*r**16*(-1+y)**5*(-203078871421+285481476067*y
          +43097835455*y**2+399848869027*y**3-1529086008445*y**4+1236362575163*y**5
          +239224717429*y**6-787335730795*y**7+324688644959*y**8+26311586203*y**9
          -46118221015*y**10+8038063789*y**11+28578893*y**12+127441789*y**13-128138333*y**14
          +24005723*y**15-3761810*y**16+28522*y**17)+12*r**22*(-1+y)**2*(92689083396
          -511525635389*y+1118928172854*y**2-1092598396844*y**3+107976020408*y**4
          +815263909174*y**5-772250993462*y**6+203012826790*y**7+112823420808*y**8
          -97725417550*y**9+24161398426*y**10+106021184*y**11-1007022728*y**12
          +139268406*y**13+4862662*y**14+1300774*y**15+227812*y**16+34879*y**17)
          +4*r**18*(-1+y)**4*(704420497044-1886633847297*y+1099785272289*y**2
          +1326541982655*y**3-1451341663061*y**4-771071488297*y**5+1608872295567*y**6
          -498384531185*y**7-368093598743*y**8+317828441989*y**9-74312162961*y**10
          -6733737491*y**11+7170986605*y**12-1506713987*y**13+209138497*y**14-19499611*y**15
          +4375371*y**16+44616*y**17)-8*r**14*(-1+y)**6*(-28412426996+292946726*y
          +22176468807*y**2+98642337261*y**3-107920402392*y**4-117211854132*y**5
          +244436746363*y**6-126249498694*y**7-18834496658*y**8+43489594311*y**9
          -14517981963*y**10+258427449*y**11+344573108*y**12+154938282*y**13-102276359*y**14
          +20031776*y**15-2623078*y**16+47389*y**17)-4*r**12*(-1+y)**7*(-24489148226
          -29514499554*y-28191418872*y**2+187357077624*y**3-14661817328*y**4+6870500380*y**5
          -452756321571*y**6+519518029811*y**7-128492704577*y**8-88528351391*y**9
          +56603930218*y**10-7344703994*y**11-2286746322*y**12+946500318*y**13
          -190601791*y**14+30346143*y**15-3602891*y**16+90423*y**17)-r**8*(-1
          +y)**9*(-3484715171-13956520237*y-34860607824*y**2-18616951712*y**3
          +20696662900*y**4+90799182556*y**5-18227549668*y**6-23605169084*y**7
          -80157922470*y**8+99795450006*y**9-33712152568*y**10-1147207672*y**11
          +2258849036*y**12-93407068*y**13-106620756*y**14+26605908*y**15-2708023*y**16
          +93847*y**17)+2*r**20*(-1+y)**3*(836156940930-3582090675360*y+5187567773595*y**2
          -1633361084289*y**3-3017952228725*y**4+2726156759471*y**5+61774532037*y**6
          -738597945419*y**7-21922253379*y**8+268569124361*y**9-85876332843*y**10
          -13221077767*y**11+12798573053*y**12-2602763407*y**13+280563339*y**14
          -6172333*y**15+4583865*y**16+214071*y**17)+2*r**24*(4689953377-33142767658*y
          +144137141985*y**2-452332159568*y**3+922965581708*y**4-1096767104632*y**5
          +554313915062*y**6+285789838100*y**7-620376061698*y**8+369761592376*y**9
          -53830973600*y**10-49962067688*y**11+32270767692*y**12-8468166128*y**13
          +955950666*y**14-11734620*y**15+6163209*y**16+17498*y**17+113919*y**18))))/(31352832000*logy**6*r**24*(
          -1+y)**12+15676416000*logy**5*r**20*(-1+y)**10*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+3265920000*logy**4*r**16*(-1+y)**8*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+362880000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +22680000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**4+756000*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**5+10500*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**6))
      resNP += ((api*muWC*(-2612736000*logy**6*r**22*(
          -120-171*r**2-83*r**4+83*r**6+171*r**8+120*r**10)*(-1+y)**12-12441600*logy**5*r**18*(
          -1+y)**9*(14796*r**18*(-1+y)**3+35*r**16*(-907+2721*y-2721*y**2+427*y**3
          +240*y**4)-5*r**14*(28181-54303*y+8943*y**2+48637*y**3-30114*y**4
          +3528*y**5)+105*r**12*(73-2271*y+5349*y**2-5163*y**3+1768*y**4-164*y**5
          +48*y**6)+35*r**2*(-1+y)**3*(907-2766*y**3+2499*y**4-984*y**5+116*y**6)
          -4*(-1+y)**3*(-3699+12180*y**3-15575*y**4+7224*y**5-1260*y**6+80*y**7)
          +7*r**10*(25683-91989*y+114399*y**2-56703*y**3-17490*y**4+33450*y**5
          -15650*y**6+2900*y**7)+7*r**8*(25683-62109*y+39699*y**2+10747*y**3
          -42585*y**4+40767*y**5-18331*y**6+2361*y**7+288*y**8)-35*r**6*(-219
          -5499*y+14733*y**2-12369*y**3+4979*y**4-2127*y**5+171*y**6+931*y**7
          -408*y**8+48*y**9)+5*r**4*(-28181+114783*y-160143*y**2+90453*y**3
          -26397*y**4+23079*y**5-16499*y**6+1889*y**7+1620*y**8-668*y**9+64*y**10))
          +103680*logy**4*r**14*(-1+y)**7*(-1+r**2+y)**2*(-148872*r**22*(-1+y)**5
          +r**20*(-1+y)**2*(1455803-4665153*y+5260641*y**2-2105195*y**3+234384*y**4)
          +r**18*(-1+y)**2*(14896585-39021505*y+32570421*y**2-5247943*y**3-2722862*y**4
          +377304*y**5)+r**16*(25859980-125500220*y+245507941*y**2-217916633*y**3
          +57940570*y**4+36910750*y**5-28850535*y**6+7187859*y**7-786912*y**8)
          +r**14*(57753860-224221980*y+338201721*y**2-171236081*y**3-104461970*y**4
          +159447590*y**5-60245995*y**6+3985099*y**7+1952916*y**8-385560*y**9)
          -24*(-1+y)**5*(-6203-12406*y-18609*y**2+36808*y**3+3655*y**4+11718*y**5
          -46439*y**6+33704*y**7-9248*y**8+720*y**9)+r**2*(-1+y)**4*(-1455803
          -1753547*y-2051291*y**2+7218785*y**3-2427389*y**4+2237923*y**5-7663513*y**6
          +6670051*y**7-2244680*y**8+285064*y**9)+r**12*(30510606-95644830*y
          +96441201*y**2+104026331*y**3-354104895*y**4+322648651*y**5-91008285*y**6
          -38430151*y**7+34372489*y**8-8697885*y**9+676368*y**10)+r**4*(-1+y)**3*(14896585
          -5668250*y-782834*y**2-46823938*y**3+69841168*y**4-43836406*y**5+25670990*y**6
          -17383046*y**7+7593483*y**8-1325648*y**9-6984*y**10+17280*y**11)+r**6*(
          -1+y)**2*(-25859980+29659660*y-5906541*y**2+95955931*y**3-196496317*y**4
          +150303755*y**5-67093943*y**6+34400281*y**7-19326491*y**8+6653357*y**9
          -986560*y**10+32448*y**11)-r**10*(30510606-148440018*y+281224359*y**2
          -369521243*y**3+423513545*y**4-311779559*y**5+66430707*y**6+66764971*y**7
          -50739067*y**8+12900605*y**9-1296162*y**10+78456*y**11)+r**8*(-57753860
          +237808900*y-385755941*y**2+398748705*y**3-419991720*y**4+389741320*y**5
          -206659250*y**6+51615322*y**7-23967580*y**8+27793420*y**9-14842385*y**10
          +3607325*y**11-344256*y**12))-6912*logy**3*r**10*(-1+y)**5*(-1+r**2+y)**3*(32418*r**28*(
          -1+y)**7-3*r**26*(-1+y)**4*(355193-1097997*y+1162833*y**2-437327*y**3
          +48618*y**4)-r**24*(-1+y)**2*(23023170-109477521*y+206700723*y**2-191259380*y**3
          +84166190*y**4-11963755*y**5-1429619*y**6+160992*y**7)+r**22*(-1+y)**2*(
          -107964536+515905681*y-988186145*y**2+905774920*y**3-353950820*y**4
          -701169*y**5+36563289*y**6-8111700*y**7+682080*y**8)+r**20*(-1+y)**2*(
          -631570122+2564032119*y-3943845597*y**2+2439654000*y**3+83357070*y**4
          -793539743*y**5+302596381*y**6-24546648*y**7-1461600*y**8+226140*y**9)
          +6*(-1+y)**8*(5403+21612*y+54030*y**2+30600*y**3-62330*y**4-186836*y**5
          +182206*y**6-25480*y**7-8225*y**8+10280*y**9-9292*y**10+2032*y**11)
          +r**2*(-1+y)**7*(-1065579-3293991*y-6782490*y**2+2074560*y**3+4073440*y**4
          +10452518*y**5-8723238*y**6+495040*y**7-3348185*y**8+4970085*y**9-2087564*y**10
          +253404*y**11)+r**18*(-584220079+3838833628*y-10813062834*y**2+15458733300*y**3
          -9587937100*y**4-2211967772*y**5+7523311944*y**6-4736901342*y**7+1098130575*y**8
          +106313200*y**9-113536774*y**10+23329578*y**11-1362324*y**12)-2*r**16*(452067541
          -2182833643*y+4355449953*y**2-3289896476*y**3-2540631520*y**4+7359171103*y**5
          -5676707019*y**6+963781049*y**7+1188057512*y**8-812085730*y**9+199500656*y**10
          -14470563*y**11-1240827*y**12+5964*y**13)-r**4*(-1+y)**6*(-23023170
          -40408011*y-56815191*y**2+134017852*y**3-14840500*y**4+41779990*y**5
          -143578658*y**6+107445052*y**7-49349794*y**8+32150625*y**9-17006795*y**10
          +4619244*y**11-496836*y**12+12192*y**13)+2*r**12*(-1+y)**2*(452067541
          -1885774226*y+3167212285*y**2-4301518515*y**3+5232604300*y**4-3446346902*y**5
          +115666867*y**6+1043788065*y**7-368166750*y**8-89515075*y**9+72505286*y**10
          -14013916*y**11+875775*y**12+56265*y**13)+r**8*(-1+y)**4*(631570122
          -593818491*y+3418341*y**2-1691277957*y**3+3320906945*y**4-2750538844*y**5
          +2124249372*y**6-1717790552*y**7+822123874*y**8-131520045*y**9-36055053*y**10
          +15582969*y**11-1937889*y**12+131208*y**13)+r**6*(-1+y)**5*(-107964536
          -84047537*y-88256318*y**2+573025511*y**3-290220730*y**4+187177832*y**5
          -713011786*y**6+747126256*y**7-331783862*y**8+83482605*y**9-27945396*y**10
          +10795773*y**11-2231788*y**12+173976*y**13)-r**10*(-1+y)**3*(584220079
          -834927004*y+299389650*y**2-3324747590*y**3+7789805765*y**4-6982783268*y**5
          +3615072138*y**6-2044608010*y**7+1223993855*y**8-333135490*y**9-55857136*y**10
          +54852516*y**11-10990815*y**12+605310*y**13)+2*r**14*y*(-540754701+2703773505*y
          -7382694732*y**2+13501654783*y**3-15199549080*y**4+8029717172*y**5+1685813690*y**6
          -5088499326*y**7+2902516309*y**8-566510445*y**9-103127046*y**10+68736555*y**11
          -11863992*y**12+787308*y**13))-144*logy**2*r**6*(-1+y)**4*(-1+r**2+y)**4*(1488*r**34*(
          -1+y)**8-r**32*(-1+y)**5*(303887-917613*y+929517*y**2-325967*y**3
          +32256*y**4)+r**30*(-1+y)**3*(-20473707+98921843*y-189852586*y**2+180068318*y**3
          -84488999*y**4+16393711*y**5-464756*y**6+9456*y**7)+r**28*(309540003
          -2401324784*y+8130609810*y**2-15652031688*y**3+18685036194*y**4-14113551624*y**5
          +6538954680*y**6-1649988120*y**7+129943923*y**8+27961656*y**9-5398594*y**10
          +248544*y**11)+r**26*(3109214407-22721543548*y+71780221206*y**2-126772115452*y**3
          +134230217354*y**4-82993149856*y**5+23962304176*y**6+2294228048*y**7
          -3755606713*y**8+929993596*y**9-64864286*y**10+1199052*y**11-97984*y**12)
          +r**24*(7623520827-55725959352*y+177415557768*y**2-313132381432*y**3
          +319176681795*y**4-165466999344*y**5+3151274384*y**6+49356015424*y**7
          -28734332271*y**8+6938904680*y**9-556862088*y**10-64117192*y**11+19573793*y**12
          -876992*y**13)-16*(-1+y)**10*(93+558*y+1953*y**2+4662*y**3+5360*y**4
          -7026*y**5-50676*y**6+434*y**7+104811*y**8-70560*y**9-13717*y**10+34668*y**11
          -17412*y**12+3352*y**13)-r**2*(-1+y)**9*(-303887-1525387*y-4594017*y**2
          -5790037*y**3+1347890*y**4+17911434*y**5-5775106*y**6+2655254*y**7-2893251*y**8
          -5254815*y**9+3574003*y**10+176943*y**11-412912*y**12+99888*y**13)+r**22*(41871094599
          -269254535268*y+727803971280*y**2-1025974721704*y**3+695087122835*y**4
          +17726928904*y**5-409053118512*y**6+303245376552*y**7-81208723395*y**8
          -7954849308*y**9+9550607312*y**10-1990733280*y**11+149702233*y**12+1744664*y**13
          +133088*y**14)+r**4*(-1+y)**8*(-20473707-78448136*y-189852586*y**2
          -72136000*y**3+150044447*y**4+455743056*y**5-407652548*y**6+104733152*y**7
          -36399045*y**8-9172424*y**9+14902494*y**10+16565984*y**11-18317391*y**12
          +5505920*y**13-776848*y**14+53632*y**15)+r**6*(-1+y)**7*(309540003+853624769*y
          +1620710704*y**2-1020068084*y**3-743074701*y**4-2227255875*y**5+1991088152*y**6
          +255116032*y**7+887031393*y**8-1915652893*y**9+1038526056*y**10-233363996*y**11
          +22532889*y**12-2569009*y**13+48544*y**14+70016*y**15)-r**8*(-1+y)**6*(3109214407
          +4066257106*y+4810719571*y**2-20223167016*y**3+7193468935*y**4-4143104358*y**5
          +18180581123*y**6-17150969792*y**7+10274437797*y**8-7659620170*y**9+4524007545*y**10
          -1306798904*y**11+107367021*y**12+24052094*y**13-4575215*y**14+97856*y**15)
          +r**10*(-1+y)**5*(7623520827+2361313563*y+3153739023*y**2-41963000497*y**3
          +24927663816*y**4-16025255908*y**5+81474328674*y**6-104565652106*y**7
          +53723183139*y**8-11524332277*y**9+749704275*y**10-94784837*y**11-12768742*y**12
          +22791358*y**13-4038564*y**14+372256*y**15)+r**14*(-1+y)**3*(6226707983
          +11415757513*y-23043714822*y**2-215452758510*y**3+577775831969*y**4
          -551843653249*y**5+224220837384*y**6-35242382516*y**7+7957836225*y**8
          +2106474807*y**9-9380964286*y**10+4947660178*y**11-927791537*y**12+27275585*y**13
          +7172124*y**14+479152*y**15)-r**16*(-1+y)**2*(12444505779-112535165938*y
          +327606871717*y**2-628742180812*y**3+790185486427*y**4-423553131830*y**5
          -224567189019*y**6+443434746616*y**7-204842411391*y**8-8150768254*y**9
          +38908405783*y**10-12857641068*y**11+1222857617*y**12+161559078*y**13
          -42292673*y**14+1331968*y**15)+r**12*(-1+y)**4*(-41871094599+65714221524*y
          -15412873176*y**2+77453828020*y**3-223671735837*y**4+255587805112*y**5
          -227859376098*y**6+178429119752*y**7-76770356385*y**8-3077751356*y**9
          +16433951868*y**10-5692357276*y**11+456846949*y**12+100376240*y**13-19922082*y**14
          +1413344*y**15)+r**20*(6226707983-67456129360*y+292443832670*y**2-571773255928*y**3
          +415349884077*y**4+270994128176*y**5-746981830640*y**6+544447470480*y**7
          -109968571839*y**8-76465886384*y**9+56566767454*y**10-14688610200*y**11
          +1167896675*y**12+173480592*y**13-29527468*y**14+1483712*y**15)+r**18*(12444505779
          -11909891852*y-125206861670*y**2+509215400396*y**3-996155141763*y**4
          +1073934555904*y**5-418261660448*y**6-414736150640*y**7+644849648693*y**8
          -340022209244*y**9+51664860810*y**10+25264068812*y**11-13127282165*y**12
          +2158976136*y**13-119352068*y**14+6640632*y**15-107312*y**16))-24*logy*r**4*(
          -1+y)**3*(-1+r**2+y)**5*(-131*r**36*(-1+y)**9-r**34*(-1+y)**6*(144146
          -413927*y+385833*y**2-111779*y**3+4007*y**4)-r**32*(-1+y)**4*(13506863
          -64589890*y+122087510*y**2-113318647*y**3+52240529*y**4-10706362*y**5
          +602202*y**6+21603*y**7)-r**30*(-1+y)**2*(376048260-2451243226*y+6765781426*y**2
          -10183391247*y**3+8936660913*y**4-4481771893*y**5+1112287895*y**6-53202945*y**7
          -22000125*y**8+1131807*y**9+49535*y**10)+r**28*(-2880367480+23907973990*y
          -87455587110*y**2+183786242785*y**3-241905263686*y**4+202562586739*y**5
          -102318065910*y**6+24075749512*y**7+2873493250*y**8-3379354374*y**9+805314916*y**10
          -76898945*y**11+4332468*y**12-60155*y**13)+r**26*(-20012434012+155187837294*y
          -523553679606*y**2+991694264777*y**3-1120843426123*y**4+706237529461*y**5
          -130448499179*y**6-148096500642*y**7+124804431514*y**8-39379715804*y**9
          +4052709936*y**10+449357065*y**11-99213827*y**12+6896329*y**13-49983*y**14)
          -(-1+y)**12*(131+1048*y+4716*y**2+4970*y**3-26491*y**4-70864*y**5
          +386180*y**6+489452*y**7-722563*y**8-82688*y**9+361548*y**10-228838*y**11
          +31947*y**12+16808*y**13+2644*y**14)+r**24*(-16948319280+136190724842*y
          -493006992582*y**2+999373024185*y**3-1145533296546*y**4+573853087182*y**5
          +236184896174*y**6-547231180513*y**7+343274523148*y**8-89086047770*y**9
          -2959753786*y**10+7682415679*y**11-2039789610*y**12+252629362*y**13-4807614*y**14
          +7129*y**15)+r**18*(-1+y)**2*y*(-446065672940+1784262691760*y-3072429864675*y**2
          +2373752333447*y**3+567641670846*y**4-3073048286270*y**5+2788757062055*y**6
          -876200537295*y**7-281111698064*y**8+316220429988*y**9-92700685405*y**10
          +6168452385*y**11+1826499870*y**12-325818358*y**13+17805241*y**14+1953415*y**15)
          +r**2*(-1+y)**10*(144146+846365*y+2906417*y**2+5900546*y**3+2984628*y**4
          -14878957*y**5-25750905*y**6+1599984*y**7+50852846*y**8-31851253*y**9
          -3790441*y**10+14034898*y**11-7677176*y**12+1547333*y**13-92175*y**14
          -25348*y**15+1092*y**16)+r**4*(-1+y)**9*(-13506863-64589890*y-186677400*y**2
          -190613111*y**3+43794407*y**4+520877242*y**5-236618982*y**6+175625545*y**7
          -4881773*y**8-260482214*y**9+125055540*y**10+48563179*y**11-48873295*y**12
          +11279534*y**13-1080118*y**14-107069*y**15+27268*y**16)+r**6*(-1+y)**8*(376048260
          +1323098446*y+2991439754*y**2+393059043*y**3-2150474463*y**4-5817193182*y**5
          +5735499562*y**6-1314771153*y**7+971046409*y**8-825213414*y**9+325831094*y**10
          -502634687*y**11+405690499*y**12-138458602*y**13+21278902*y**14-2212147*y**15
          +189679*y**16)+r**22*(-200546595188+1370863669226*y-3939620526882*y**2
          +5875576120033*y**3-4033298875717*y**4-782381103938*y**5+3851988301158*y**6
          -2985565224467*y**7+698537773483*y**8+391749732478*y**9-328337288526*y**10
          +88142788555*y**11-5743308751*y**12-1656391366*y**13+289993514*y**14
          -943673*y**15+312061*y**16)+r**8*(-1+y)**7*(-2880367480-6625769110*y
          -11121229360*y**2+15209040515*y**3+2432479561*y**4+15603981008*y**5-13568048840*y**6
          -9074040475*y**7-8037856375*y**8+27464599658*y**9-18345405136*y**10+4530855605*y**11
          -21559165*y**12-214324740*y**13+49004456*y**14-7248317*y**15+672195*y**16)
          +r**10*(-1+y)**6*(20012434012+15100799210*y+12687770094*y**2-141329428439*y**3
          +90045401543*y**4-19631736340*y**5+119619833824*y**6-171764681789*y**7
          +118215902097*y**8-66806032062*y**9+30739451838*y**10-6988027449*y**11
          -424482255*y**12+416308392*y**13-31247756*y**14-8563635*y**15+1482715*y**16)
          +r**12*(-1+y)**5*(-16948319280-604170602*y-14224858528*y**2+93155839473*y**3
          +25310971051*y**4+15960040638*y**5-551441878466*y**6+799442410885*y**7
          -416042004447*y**8+28552241482*y**9+52309758388*y**10-18918662213*y**11
          +1718579293*y**12+128195074*y**13-3534258*y**14-10703121*y**15+2286631*y**16)
          +r**16*(-1+y)**3*(158137679254-652094471932*y+744217320168*y**2+968380540591*y**3
          -3278003685601*y**4+2881040507994*y**5-258002299964*y**6-1078050191791*y**7
          +550803468423*y**8+46358766872*y**9-102621741200*y**10+19860424569*y**11
          +4308222173*y**12-2275516214*y**13+332974404*y**14-18390073*y**15+2584327*y**16)
          +r**14*(-1+y)**4*(200546595188-434055687466*y+192388599842*y**2-210674589205*y**3
          +1067343050081*y**4-1656890111266*y**5+1359525884766*y**6-663773908029*y**7
          +38095654845*y**8+223389076618*y**9-154572151322*y**10+37202161921*y**11
          +1452444187*y**12-2287091390*y**13+367193626*y**14-24080175*y**15+2701779*y**16)
          +r**20*(158137679254-929282320608*y+1991562639210*y**2-1711481222931*y**3
          +200709149426*y**4-165380047205*y**5+1848383278568*y**6-2274050624685*y**7
          +770125151992*y**8+476850641253*y**9-523033879062*y**10+174046687483*y**11
          -9691228230*y**12-9393638611*y**13+2823469796*y**14-351196187*y**15+24418982*y**16
          +1041555*y**17))-(-1+y)*(-1+r**2+y)**6*(33*r**42*(-1+y)**11+r**40*(
          -1+y)**8*(1441-4125*y+3729*y**2-1563*y**3+358*y**4)+r**38*(-1+y)**6*(
          -26306+126226*y-235661*y**2+234633*y**3-147648*y**4+58312*y**5-13221*y**6
          +1521*y**7)+r**36*(-1+y)**4*(-10507998+70249014*y-199451595*y**2+310211085*y**3
          -283785135*y**4+151691129*y**5-43504397*y**6+4971451*y**7+192917*y**8
          -45735*y**9+2496*y**10)-r**34*(-1+y)**2*(494872573-4189429461*y+15623372859*y**2
          -33603811523*y**3+45824433402*y**4-40981849170*y**5+23972516222*y**6
          -8811852198*y**7+1829314869*y**8-154447269*y**9-3235057*y**10+17793*y**11
          +53196*y**12+2804*y**13)+r**32*(-6766154179+68107349471*y-308562673174*y**2
          +827504860514*y**3-1451576007433*y**4+1732823570985*y**5-1411460372724*y**6
          +753169980444*y**7-226066089785*y**8+9139621845*y**9+19835650446*y**10
          -6985077002*y**11+845206045*y**12-8929229*y**13-1046292*y**14+103548*y**15
          -19080*y**16)+(-1+y)**14*(33+297*y+1485*y**2+5049*y**3+18913*y**4
          +52265*y**5+26097*y**6-54123*y**7-58141*y**8+24555*y**9+90951*y**10
          -60901*y**11-23661*y**12+30667*y**13-9893*y**14+951*y**15+232*y**16
          +24*y**17)-4*r**30*(6827188998-66386018742*y+290295532740*y**2-747200052558*y**3
          +1240760596970*y**4-1360079830050*y**5+944292514227*y**6-330763112279*y**7
          -48047284879*y**8+115306902329*y**9-57578734730*y**10+14250834032*y**11
          -1824011440*y**12+165205172*y**13-19624589*y**14-46283*y**15-87057*y**16
          +5739*y**17)-r**2*(-1+y)**13*(-1441-11330*y-50094*y**2-155186*y**3
          -506530*y**4-1156610*y**5-216234*y**6+1432694*y**7+1429792*y**8-1492774*y**9
          -1972026*y**10+2260234*y**11-236070*y**12-489190*y**13+257594*y**14
          -34958*y**15+1545*y**16-240*y**17+24*y**18)-r**4*(-1+y)**12*(-26306
          -178838*y-693257*y**2-3254113*y**3-8992861*y**4-8863645*y**5+40244115*y**6
          +19877203*y**7-78227765*y**8+22853499*y**9+13954517*y**10-12864355*y**11
          +10019753*y**12-3290951*y**13+1574977*y**14-575951*y**15+72043*y**16
          -6209*y**17+544*y**18)-r**6*(-1+y)**11*(10507998+59741016*y+199451595*y**2
          +324463272*y**3+53984292*y**4-896953048*y**5-587492496*y**6+43682232*y**7
          +1242428472*y**8-851825544*y**9+14335510*y**10+369400920*y**11-210646740*y**12
          +44029112*y**13+5130712*y**14-4102200*y**15+706970*y**16-79152*y**17
          +5079*y**18)+4*r**28*(-49478610730+456440187710*y-1870211354728*y**2
          +4428054819878*y**3-6539401152920*y**4+5885113090546*y**5-2467701677559*y**6
          -901998907043*y**7+1977304803871*y**8-1262016251625*y**9+379531915178*y**10
          -18328412752*y**11-23924214610*y**12+7525445144*y**13-964470955*y**14
          +52554381*y**15+2084501*y**16+117281*y**17+12032*y**18)-r**8*(-1+y)**10*(
          -494872573-2209939169*y-6024319914*y**2-4929610180*y**3+1053764032*y**4
          +12124840952*y**5-7790744640*y**6+6568756480*y**7+988815234*y**8-9942033574*y**9
          +5214294520*y**10+2357140092*y**11-2485255488*y**12+692851032*y**13-52815608*y**14
          -14151224*y**15+4447867*y**16-529353*y**17+27114*y**18)-4*r**12*(-1
          +y)**8*(-6827188998-11768506758*y-16754693490*y**2+50543081436*y**3
          -16840476050*y**4+31717831568*y**5-2158943133*y**6-54544539457*y**7-22364859319*y**8
          +109505820417*y**9-76694435540*y**10+17785278482*y**11+2204793696*y**12
          -1901124798*y**13+432278563*y**14-76936125*y**15+14195839*y**16-1582269*y**17
          +55536*y**18)-2*r**18*(-1+y)**5*(1165371114639-2845603233138*y+1528409283150*y**2
          -1291316743758*y**3+7646535458374*y**4-11905937320202*y**5+6608599947024*y**6
          +586303464478*y**7-2614536393148*y**8+1489202639862*y**9-424011418188*y**10
          +43556999246*y**11+20099768874*y**12-10375241510*y**13+2638277264*y**14
          -498346974*y**15+81249693*y**16-11117652*y**17+85566*y**18)+2*r**20*(
          -1+y)**4*(-2244997935018+8289273540762*y-9498165631287*y**2-1658416202163*y**3
          +11173784800581*y**4-3725110315423*y**5-8969184126029*y**6+9410855943987*y**7
          -1751338045049*y**8-2211471751193*y**9+1477202696815*y**10-274097473757*y**11
          -47253033221*y**12+28015724455*y**13-4849504763*y**14+503356701*y**15
          -53809501*y**16+9137271*y**17+89232*y**18)-4*r**14*(-1+y)**7*(49478610730
          +11132691140*y-80160672*y**2-345493164162*y**3+313618061544*y**4-27435198388*y**5
          +358016248993*y**6-740410563618*y**7+530944074632*y**8-155689125544*y**9
          +125858789*y**10+16256302106*y**11-5740831232*y**12+386790012*y**13+390612355*y**14
          -147290326*y**15+28839366*y**16-3258948*y**17+90423*y**18)-r**10*(-1
          +y)**9*(6766154179+20744270218*y+42007814107*y**2-14826168872*y**3-37943912308*y**4
          -78657683416*y**5+96589296432*y**6-5381031280*y**7+19615205570*y**8-51083378172*y**9
          +35938218790*y**10-14438717960*y**11+5539701580*y**12-1706910920*y**13
          +358250680*y**14-83740128*y**15+19251235*y**16-2211182*y**17+93847*y**18)
          -2*r**16*(-1+y)**6*(108959754607-105754682153*y-135367410617*y**2-491327785113*y**3
          +1844241120339*y**4-781457306169*y**5-2713560416435*y**6+3767058350317*y**7
          -1406330579525*y**8-501894334493*y**9+551932135269*y**10-125271517887*y**11
          -11053169947*y**12+6812904297*y**13+253131219*y**14-390784917*y**15+81892990*y**16
          -9891338*y**17+189556*y**18)+2*r**24*(-1+y)**2*(-1165371114639+7642736798613*y
          -20716943545050*y**2+28274570985876*y**3-15801889159140*y**4-8063593640248*y**5
          +19267505716698*y**6-11867831408226*y**7+991791886872*y**8+2614063724592*y**9
          -1420789923188*y**10+219675742416*y**11+43712682000*y**12-19941020932*y**13
          +2163413338*y**14-14946210*y**15+4208363*y**16+2042391*y**17+209274*y**18)
          +2*r**22*(-1+y)**3*(-2244997935018+11915707874400*y-24003902965839*y**2
          +20953587330228*y**3-1715574292060*y**4-12221876923624*y**5+10655120330942*y**6
          -3757400457892*y**7+108811550216*y**8+595584318776*y**9-385247873592*y**10
          +128908130412*y**11-25890572948*y**12+4628060200*y**13-1196188526*y**14
          +228061124*y**15-18546414*y**16+5299944*y**17+214071*y**18)+2*r**26*(108959754607
          -983842863917*y+3816029407321*y**2-8394149960135*y**3+11626547765464*y**4
          -10686782911636*y**5+6738609772370*y**6-2829184494658*y**7+252337820566*y**8
          +1034499380818*y**9-1164991685012*y**10+658021566088*y**11-207941595840*y**12
          +33891948540*y**13-1784839426*y**14-257481534*y**15+29405859*y**16+8469427*y**17
          +427179*y**18+113919*y**19))))/(47029248000*logy**6*r**24*(-1+y)**12+23514624000*logy**5*r**20*(
          -1+y)**10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +4898880000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2+544320000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3+34020000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4
          +1134000*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**5+15750*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**6))
      resNP += ((muG*(-2612736000*logy**6*r**20*(-384-300*r**2
          +37*r**4+511*r**6+759*r**8+609*r**10+216*r**12)*(-1+y)**12+12441600*logy**5*r**16*(
          -1+y)**9*(41028*r**20*(-1+y)**3+r**18*(67007-201021*y+201021*y**2-145967*y**3
          +36960*y**4)-3*r**16*(-175557+435951*y-299871*y**2+74827*y**3+4410*y**4
          +840*y**5)+32*(-1+y)**4*(118+118*y+118*y**2-2052*y**3+1553*y**4
          -295*y**5+20*y**6)+3*r**14*(175937-272031*y-111639*y**2+207453*y**3
          -53900*y**4-11620*y**5+2800*y**6)-2*r**2*(-1+y)**3*(25229-2520*y**3
          -48965*y**4+33096*y**5-11060*y**6+1280*y**7)-7*r**12*(17289-188487*y
          +393417*y**2-223069*y**3-4330*y**4+51790*y**5-22750*y**6+3140*y**7)
          -7*r**10*(100039-392097*y+530067*y**2-230069*y**3-42215*y**4+80589*y**5
          -25697*y**6-5953*y**7+2736*y**8)-r**4*(-1+y)**2*(-517339+1001179*y
          -241920*y**2-711550*y**3+1017975*y**4-836801*y**5+340676*y**6-67420*y**7
          +5120*y**8)+7*r**8*(-91681+281703*y-291693*y**2+111681*y**3-44735*y**4
          +78351*y**5-99083*y**6+65033*y**7-16776*y**8+1200*y**9)+r**6*(-188971
          +188913*y+378087*y**2+391*y**3-1613255*y**4+2621941*y**5-2312793*y**6
          +1219903*y**7-332476*y**8+39540*y**9-1280*y**10))+103680*logy**4*r**12*(
          -1+y)**7*(-1+r**2+y)**2*(558168*r**24*(-1+y)**5-r**22*(-1+y)**2*(3757559
          -12389013*y+14621685*y**2-5898887*y**3+811056*y**4)-r**20*(-1+y)**2*(29044355
          -71147719*y+53159931*y**2+2439671*y**3-10391574*y**4+1155336*y**5)
          -960*(-1+y)**6*(-83-249*y-498*y**2-55*y**3-74*y**4+194*y**5+385*y**6
          -286*y**7+36*y**8)+r**18*(44522468-164921576*y+186868075*y**2-88939603*y**3
          +63463790*y**4-77637698*y**5+49498351*y**6-17080015*y**7+2462208*y**8)
          +16*r**2*(-1+y)**5*(15731+21502*y+17313*y**2-291316*y**3+325*y**4
          -118836*y**5+6128*y**6+205402*y**7-110784*y**8+17760*y**9)+r**16*(296191836
          -1180723352*y+1656257989*y**2-982382033*y**3+175144030*y**4+68836114*y**5
          -53110343*y**6+21481131*y**7-6470772*y**8+827400*y**9)+r**14*(405425090
          -1670996694*y+2493480147*y**2-1715468835*y**3+526231075*y**4+30464717*y**5
          -130197471*y**6+84258583*y**7-36764565*y**8+10811745*y**9-1191792*y**10)
          +r**4*(-1+y)**4*(-5479087-3557519*y-2529711*y**2+55462157*y**3-57196745*y**4
          +18861127*y**5+21810299*y**6-33448009*y**7+20577848*y**8-5727000*y**9
          +592640*y**10)+r**6*(-1+y)**3*(24278251-23503794*y-10354986*y**2+29699342*y**3
          -116697940*y**4+158425986*y**5-117721186*y**6+82000346*y**7-48779307*y**8
          +18862000*y**9-3555352*y**10+215040*y**11)-r**8*(-1+y)**2*(222647908
          -540539000*y+277114017*y**2+550221681*y**3-1149353975*y**4+1081556113*y**5
          -568766477*y**6+164697163*y**7-38391001*y**8+14310355*y**9-4703616*y**10
          +589632*y**11)+r**12*(193772690-847922074*y+1419864713*y**2-1521892681*y**3
          +1559227795*y**4-1411013829*y**5+888922425*y**6-330978823*y**7+27211231*y**8
          +30149915*y**9-10071866*y**10+966504*y**11)-r**10*(106630740-422048696*y
          +508940251*y**2+565451685*y**3-2565001960*y**4+3693305520*y**5-3028149698*y**6
          +1502356178*y**7-387161860*y**8+12871760*y**9+15530815*y**10-2792031*y**11
          +67296*y**12))-6912*logy**3*r**8*(-1+y)**5*(-1+r**2+y)**3*(-125814*r**30*(
          -1+y)**7+3*r**28*(-1+y)**4*(1319341-4083837*y+4335465*y**2-1612263*y**3
          +197894*y**4)+r**26*(-1+y)**2*(76855654-363039701*y+679863619*y**2
          -618656180*y**3+260403090*y**4-29733999*y**5-6618619*y**6+530136*y**7)
          -r**24*(-1+y)**2*(-184195698+904853343*y-1815590721*y**2+1675651680*y**3
          -559750610*y**4-114374407*y**5+118979737*y**6-28178604*y**7+2663280*y**8)
          -r**22*(-1+y)**2*(-969043280+3639017047*y-5032336247*y**2+1887410300*y**3
          +2090483340*y**4-2251339055*y**5+630351403*y**6-12890328*y**7-7511760*y**8
          +368580*y**9)+48*(-1+y)**9*(648+3240*y+9720*y**2+13760*y**3+7215*y**4
          -16531*y**5-10840*y**6-4920*y**7+18315*y**8-7115*y**9+508*y**10)+12*r**2*(
          -1+y)**8*(-44935-187516*y-488230*y**2-415790*y**3-307445*y**4+179570*y**5
          +155747*y**6+50580*y**7+98115*y**8+70670*y**9-144960*y**10+34944*y**11)
          +r**4*(-1+y)**7*(6766237+17228883*y+30895134*y**2+4638380*y**3+20811160*y**4
          +20131126*y**5-13428726*y**6+17109352*y**7-27935305*y**8+518015*y**9
          +12284212*y**10-6093132*y**11+857664*y**12)+r**20*(-2577949867+13673370502*y
          -27636892692*y**2+27618827406*y**3-16560988734*y**4+11056444110*y**5
          -10089291678*y**6+5965013880*y**7-1263478031*y**8-469257016*y**9+360389982*y**10
          -79469874*y**11+4962012*y**12)+r**8*(-1+y)**5*(-181276018+79644593*y
          +167312528*y**2+1968688997*y**3-3074542550*y**4+845080456*y**5+2275493794*y**6
          -3655573496*y**7+2616186696*y**8-965734825*y**9+146937962*y**10-30237*y**11
          -1524532*y**12+4632*y**13)+2*r**14*(-1+y)**2*(547551007-1042721192*y
          -1871390741*y**2+14939283825*y**3-30605257740*y**4+30759481596*y**5-16884553101*y**6
          +3981379107*y**7+1136219240*y**8-1110881485*y**9+283482272*y**10-22267032*y**11
          -2799441*y**12+329685*y**13)+r**6*(-1+y)**6*(33385084+34439525*y+19057635*y**2
          -351870844*y**3+148684060*y**4-132741538*y**5-169406310*y**6+525602640*y**7
          -388835152*y**8+125696365*y**9-40779121*y**10+18213260*y**11-4907700*y**12
          +468096*y**13)-2*r**18*(4874335408-26915378293*y+58553340747*y**2-63082778122*y**3
          +31589115750*y**4+722646269*y**5-11607744739*y**6+8967417511*y**7-3978739421*y**8
          +919981700*y**9-6742552*y**10-41307093*y**11+4464567*y**12+548268*y**13)
          +r**12*(-1+y)**3*(-6492569665+19467672616*y-14953467570*y**2-21569479370*y**3
          +57671467845*y**4-58885386080*y**5+33267824398*y**6-8935384210*y**7-504633925*y**8
          +1089174430*y**9-386146880*y**10+89385636*y**11-16750995*y**12+1192770*y**13)
          -r**10*(-1+y)**4*(-519186382+1173787617*y+88914813*y**2-4575139261*y**3
          +10526704925*y**4-13494136036*y**5+10858141256*y**6-6508179856*y**7+3425894062*y**8
          -1326776725*y**9+249768143*y**10+21023277*y**11-13375857*y**12+1287024*y**13)
          -2*r**16*(4084310194-23845455319*y+56197954485*y**2-71045121314*y**3
          +53685807939*y**4-23685476658*y**5+1054101078*y**6+8318152140*y**7-7072207982*y**8
          +2677249727*y**9-164383761*y**10-349975084*y**11+177693075*y**12-35303604*y**13
          +2655084*y**14))+144*logy**2*r**4*(-1+y)**4*(-1+r**2+y)**4*(4464*r**36*(
          -1+y)**8-r**34*(-1+y)**5*(1146115-3456201*y+3491913*y**2-1190275*y**3
          +118848*y**4)+r**32*(-1+y)**3*(-78823393+380602065*y-729762678*y**2
          +689849882*y**3-321096501*y**4+61530069*y**5-1848772*y**6+115728*y**7)
          +r**30*(1058675791-8201229688*y+27730626858*y**2-53252072088*y**3+63269994282*y**4
          -47394650664*y**5+21658809336*y**6-5331268008*y**7+376372383*y**8+104088608*y**9
          -20286842*y**10+940032*y**11)+r**28*(8980616217-64744242084*y+201277213146*y**2
          -347134457580*y**3+352054914614*y**4-196876337232*y**5+36011469184*y**6
          +22550657456*y**7-15087362055*y**8+3151998036*y**9-190538210*y**10+6958940*y**11
          -890432*y**12)+64*(-1+y)**11*(31+217*y+868*y**2+2327*y**3+4237*y**4
          +4165*y**5-3037*y**6-9269*y**7-3302*y**8+5688*y**9+7379*y**10-7480*y**11
          +1676*y**12)+4*r**2*(-1+y)**10*(-78141-470830*y-1654849*y**2-3230280*y**3
          -3372362*y**4+655220*y**5+2991018*y**6+3326176*y**7-2618977*y**8+582762*y**9
          -358929*y**10-115688*y**11+7248*y**12+53632*y**13)-r**26*(-3925877227
          +33704614520*y-131602177984*y**2+271599808992*y**3-289744458927*y**4
          +103780123552*y**5+99098729536*y**6-137200563200*y**7+69992094967*y**8
          -17597660088*y**9+1772540720*y**10+194217824*y**11-74804301*y**12+3411616*y**13)
          +r**4*(-1+y)**9*(15350057+73529501*y+213185479*y**2+264072771*y**3
          +140725474*y**4-256061926*y**5-87875394*y**6-21018890*y**7+225379061*y**8
          -191438455*y**9+7343019*y**10+38989143*y**11-5454064*y**12-1686032*y**13
          +256256*y**14)+r**24*(62622712253-379440571316*y+946765232752*y**2-1120596260048*y**3
          +296661020257*y**4+881123501304*y**5-1201743493616*y**6+630952728040*y**7
          -72269442593*y**8-73086045596*y**9+34440487408*y**10-5791972728*y**11
          +359116723*y**12+1032056*y**13+1955104*y**14)-r**10*(-1+y)**6*(-3104386329
          +579414066*y+5405983915*y**2+32518925936*y**3-31407581701*y**4+4214197210*y**5
          +37433378847*y**6-91740053616*y**7+84190794717*y**8-37415636554*y**9
          +10106599001*y**10-3007194688*y**11+786823201*y**12-96289378*y**13-2948995*y**14
          +302368*y**15)+r**6*(-1+y)**8*(-88479215-334448624*y-813763714*y**2
          -569353880*y**3-723145245*y**4-370115232*y**5-371214420*y**6-94234320*y**7
          +1083992847*y**8-25430448*y**9-507217434*y**10+191171944*y**11-14101891*y**12
          +11705408*y**13-4826832*y**14+429056*y**15)+r**12*(-1+y)**5*(-7079616011
          +13394771989*y+13356052241*y**2+87801804409*y**3-232281687952*y**4+53708143644*y**5
          +288542471126*y**6-439101998358*y**7+337064681901*y**8-139582828987*y**9
          +20345296589*y**10+5983750685*y**11-2684008658*y**12+393247690*y**13
          -18924436*y**14+588128*y**15)+r**8*(-1+y)**7*(655156033+1325578595*y
          +2057217016*y**2-516806468*y**3+1983514009*y**4+3771246255*y**5-188174472*y**6
          -1026765264*y**7-2958989781*y**8+239367145*y**9+3533199744*y**10-2330005948*y**11
          +513530123*y**12-682251*y**13-10367904*y**14+919168*y**15)+r**16*(-1
          +y)**3*(-388122310499+1333740930067*y-1325596786618*y**2-1202021507930*y**3
          +4253823645635*y**4-4570878712347*y**5+2450598626720*y**6-399298822140*y**7
          -380921570541*y**8+304066090829*y**9-95994171730*y**10+11780380838*y**11
          +1329899533*y**12-434653829*y**13+16433036*y**14+4432976*y**15)-r**18*(
          -1+y)**2*(116755421459-682686775330*y+1533076609533*y**2-2283797348844*y**3
          +2435861431367*y**4-1367537477790*y**5-125022896151*y**6+647484728408*y**7
          -331753078183*y**8+14460323490*y**9+61223259367*y**10-29135313644*y**11
          +3675352909*y**12+556395102*y**13-164042957*y**14+5483264*y**15)+r**22*(
          -224980316365+1299668027768*y-2936663793690*y**2+3260537885488*y**3
          -1789897488695*y**4+537949147888*y**5-433089185744*y**6+428688705952*y**7
          -83428229779*y**8-140560595848*y**9+113370769446*y**10-35471110224*y**11
          +3490837463*y**12+526314016*y**13-107185532*y**14+5865856*y**15)+r**14*(
          -1+y)**4*(14057543789-66918762964*y+24302502712*y**2+490663216244*y**3
          -1271634805409*y**4+1609140866160*y**5-1245449452346*y**6+567678441192*y**7
          -120709806357*y**8-14099244596*y**9+23109225724*y**10-9603690140*y**11
          +1620310121*y**12+204457688*y**13-77511770*y**14+6381952*y**15)-r**20*(540624354411
          -3320933000092*y+8232581860570*y**2-10370087561140*y**3+6117685057109*y**4
          +686836075232*y**5-4336529275600*y**6+3900314483840*y**7-1787718842675*y**8
          +197226589012*y**9+264723189018*y**10-158795317844*y**11+37484714915*y**12
          -3489477560*y**13+121434204*y**14-47107736*y**15+2824336*y**16))+24*logy*r**2*(
          -1+y)**3*(-1+r**2+y)**5*(-515*r**38*(-1+y)**9-r**36*(-1+y)**6*(473170
          -1363367*y+1277865*y**2-353867*y**3+7599*y**4)-r**34*(-1+y)**4*(52026581
          -248689232*y+469675354*y**2-433620583*y**3+197216027*y**4-39843596*y**5
          +2386822*y**6+67667*y**7)-r**32*(-1+y)**2*(1400990750-9109743766*y
          +25066792010*y**2-37533275999*y**3+32631957893*y**4-16090673373*y**5
          +3857854735*y**6-149328473*y**7-74709971*y**8+1650955*y**9+237239*y**10)
          -2*(-1+y)**14*(23+230*y+1265*y**2+3716*y**3-202*y**4-34408*y**5
          -62494*y**6-31948*y**7+36719*y**8+50962*y**9-15155*y**10-9176*y**11
          +1668*y**12)+r**30*(-8346266044+68720047170*y-249294319332*y**2+517744349459*y**3
          -667844246218*y**4+537953844263*y**5-248280581430*y**6+38817903728*y**7
          +20870910746*y**8-12918045862*y**9+2862261906*y**10-306471595*y**11+21442484*y**12
          -349275*y**13)+r**28*(-52743594696+402259940654*y-1330572352884*y**2
          +2444702797701*y**3-2600106459965*y**4+1372001765973*y**5+106338898225*y**6
          -654983685106*y**7+416710915378*y**8-112944481980*y**9+7560942698*y**10
          +2058494701*y**11-303908525*y**12+18405561*y**13-141735*y**14)+r**26*(73478814436
          -517134294778*y+1471494906756*y**2-2217976672381*y**3+1997619606844*y**4
          -1330207797896*y**5+998155710190*y**6-795908964117*y**7+416728116308*y**8
          -89563304026*y**9-21592146448*y**10+20753931593*y**11-6866184884*y**12
          +1053886428*y**13-30277538*y**14+269513*y**15)+r**2*(-1+y)**11*(-176539
          -1211735*y-4762692*y**2-11921118*y**3-18317787*y**4-10894013*y**5+13799532*y**6
          +30375160*y**7+2889607*y**8-11453905*y**9-14877436*y**10+14191162*y**11
          -4712593*y**12+608261*y**13+79892*y**14+19788*y**15+12416*y**16)+r**4*(
          -1+y)**10*(12050302+69409701*y+234579123*y**2+410364538*y**3+392072060*y**4
          -98992221*y**5-257462163*y**6-245126760*y**7+297704370*y**8-179116229*y**9
          -23139843*y**10+65929074*y**11-9612688*y**12+1927517*y**13-1625181*y**14
          +274012*y**15+76388*y**16)+r**6*(-1+y)**9*(-200946611-877891770*y-2357667726*y**2
          -2293702011*y**3-791534129*y**4+2648223710*y**5-1438355680*y**6-1340690439*y**7
          -1326797329*y**8+3086271802*y**9-150098038*y**10-934275961*y**11+222489265*y**12
          +68869890*y**13-18627548*y**14+336539*y**15+348036*y**16)+r**24*(-421030873016
          +2814586273074*y-7798562407776*y**2+10674702329973*y**3-5011890690761*y**4
          -6062973429298*y**5+11266575618032*y**6-6869011131327*y**7+433187552255*y**8
          +1807825639798*y**9-1046785026160*y**10+217569017015*y**11+2860123453*y**12
          -7991685078*y**13+905051488*y**14+24554099*y**15+1244229*y**16)+r**8*(
          -1+y)**8*(335354984+1157561126*y+2805932912*y**2+1304665903*y**3+6468012469*y**4
          +8756349714*y**5+1879427544*y**6-2355001733*y**7-15120270155*y**8+7427773218*y**9
          +6732875376*y**10-5300927115*y**11+1248893671*y**12-221223098*y**13+95666888*y**14
          -16073599*y**15+1453895*y**16)+r**10*(-1+y)**7*(-6055983108-11798993038*y
          -18450447418*y**2+8553843827*y**3-5456330483*y**4-12613322324*y**5-4365954298*y**6
          +40515402897*y**7-14408397563*y**8+17982329922*y**9-41434511502*y**10
          +29783565861*y**11-7484256929*y**12-115084864*y**13+396819586*y**14-59922441*y**15
          +4273875*y**16)+r**12*(-1+y)**6*(-22809967208+15543660786*y+44188950720*y**2
          +153565687233*y**3-289216999361*y**4-11527531220*y**5+398228691230*y**6
          -787098011781*y**7+852797968173*y**8-454760470334*y**9+99217718948*y**10
          +6222809991*y**11-6236292039*y**12+696274944*y**13+258818270*y**14-73400995*y**15
          +8372643*y**16)+r**20*(-1+y)**2*(1716122889732-8802613826772*y+17205621713862*y**2
          -15480491683475*y**3+2153154067415*y**4+11364198677374*y**5-14810072026076*y**6
          +8389222969911*y**7-676953673355*y**8-2008701477440*y**9+1170692193126*y**10
          -241880770277*y**11-2953732223*y**12+8907521430*y**13-1132145200*y**14
          +43316993*y**15+8712975*y**16)+r**14*(-1+y)**5*(-6087944420-38157095714*y
          -17521075286*y**2-199011948939*y**3+876320736587*y**4-179808533918*y**5
          -1880850618676*y**6+2729960881309*y**7-1917426831555*y**8+709987743738*y**9
          -21366129542*y**10-92177058769*y**11+32920812277*y**12-3492844506*y**13
          +166329200*y**14-54646945*y**15+11785159*y**16)+r**18*(-1+y)**3*(1758843637678
          -6583758836268*y+7751202942174*y**2+2906764670751*y**3-16740886767857*y**4
          +17522094571398*y**5-6861432198422*y**6-1561932611691*y**7+2909351148735*y**8
          -1254501433224*y**9+103035331682*y**10+84778366665*y**11-14375492083*y**12
          -4325141586*y**13+1462390806*y**14-127063933*y**15+12269175*y**16)+r**16*(
          -1+y)**4*(-12750385252+231199398862*y-211156159496*y**2-2844753430993*y**3
          +8683728284129*y**4-11394948318290*y**5+8080693934452*y**6-2255928324505*y**7
          -1340680122411*y**8+1553888970850*y**9-582266733616*y**10+54672934013*y**11
          +29920622851*y**12-10194859646*y**13+1405878596*y**14-110430067*y**15
          +13212523*y**16)+r**22*(1421494485794-8963223794756*y+22563090725556*y**2
          -27692455831369*y**3+13503431460206*y**4+5200729039895*y**5-9126356592030*y**6
          +2111986890021*y**7+2291502558468*y**8-1562159617447*y**9+93033681688*y**10
          +245596009353*y**11-90565321490*y**12-2282238399*y**13+7690869266*y**14
          -1650575077*y**15+134104958*y**16+4145363*y**17))+(-1+y)*(-1+r**2
          +y)**6*(165*r**42*(-1+y)**11+r**40*(-1+y)**8*(7963-22899*y+20919*y**2
          -8573*y**3+1790*y**4)+r**38*(-1+y)**6*(-158282+756982*y-1407965*y**2
          +1382093*y**3-844304*y**4+326796*y**5-73645*y**6+7605*y**7)+r**36*(
          -1+y)**4*(-35203338+235982550*y-672412929*y**2+1047189423*y**3-952350853*y**4
          +497581299*y**5-133247527*y**6+11006889*y**7+1816199*y**8-258033*y**9
          +12480*y**10)-r**34*(-1+y)**2*(1944804017-16455377421*y+61313544759*y**2
          -131661857923*y**3+179050865834*y**4-159517133946*y**5+92948339086*y**6
          -34178472014*y**7+7259485121*y**8-723674357*y**9+22228195*y**10-3278135*y**11
          +307964*y**12+14020*y**13)-r**32*(22927994449-229205126309*y+1030250765746*y**2
          -2735448624278*y**3+4732545970531*y**4-5533187282131*y**5+4352956448428*y**6
          -2166629823876*y**7+524317745779*y**8+71201827881*y**9-94030123002*y**10
          +27201099886*y**11-2912825855*y**12+9857439*y**13+2718668*y**14-590756*y**15
          +95400*y**16)-(-1+y)**14*(-1083-9747*y-48735*y**2-166499*y**3-374363*y**4
          -484115*y**5-140267*y**6+551913*y**7+473071*y**8-88265*y**9-467901*y**10
          +265351*y**11+229151*y**12-281897*y**13+35303*y**14+10899*y**15+3688*y**16
          +696*y**17)-4*r**30*(15039347070-143996510022*y+621025584876*y**2-1570972833086*y**3
          +2533777501442*y**4-2620059650706*y**5+1572209546511*y**6-244271882631*y**7
          -423144176687*y**8+391623300453*y**9-165552441594*y**10+39925885696*y**11
          -6564277000*y**12+1096093788*y**13-137356705*y**14+2274245*y**15-546345*y**16
          +28695*y**17)-r**2*(-1+y)**13*(-50149-393590*y-1737498*y**2-4522814*y**3
          -7042030*y**4-4517206*y**5-2209526*y**6+1687946*y**7+1982796*y**8+2566590*y**9
          +2793666*y**10+261126*y**11+2243638*y**12-3947362*y**13+711830*y**14
          -64146*y**15-495*y**16+6704*y**17+120*y**18)-r**4*(-1+y)**12*(-13874518
          -92591398*y-354677659*y**2-812894523*y**3-1129576687*y**4-511281079*y**5
          +747737129*y**6+1446556401*y**7-36568519*y**8-331724455*y**9-438670561*y**10
          +505300399*y**11-211597741*y**12-15391733*y**13+16518387*y**14-1320997*y**15
          +579065*y**16-2631*y**17+2720*y**18)-r**6*(-1+y)**11*(317426262+1694067204*y
          +5358405063*y**2+7954728672*y**3+6113348468*y**4-3814990528*y**5-306186784*y**6
          +1733301184*y**7+7139779128*y**8-8332777864*y**9-2508556578*y**10+4082930208*y**11
          -1285219940*y**12+89990080*y**13-28933304*y**14+2250944*y**15+4852322*y**16
          -372732*y**17+25395*y**18)+4*r**28*(-134609304622+1233040557338*y-5009393848720*y**2
          +11698605804402*y**3-16808284762916*y**4+14107281431590*y**5-4142277268481*y**6
          -4836416960837*y**7+6804397255669*y**8-3875117664415*y**9+996364800574*y**10
          +47598229496*y**11-107901284498*y**12+30524915344*y**13-4065728269*y**14
          +249280283*y**15+3570447*y**16+805455*y**17+60160*y**18)-r**8*(-1+y)**10*(
          -2592760783-9835152455*y-23482127586*y**2-11228566644*y**3+6773326408*y**4
          +30746466192*y**5-48885328408*y**6-24523155480*y**7+10254009006*y**8
          +37757156222*y**9-12070693032*y**10-14298302756*y**11+3138754936*y**12
          +2565901568*y**13-944112880*y**14+21753648*y**15+25132769*y**16-2820295*y**17
          +135570*y**18)-4*r**12*(-1+y)**8*(-24340549026-38259730458*y-47763142782*y**2
          +95331817412*y**3+41480064302*y**4+16925167328*y**5-121769444019*y**6
          +198694146081*y**7-204424740541*y**8+191045345983*y**9-175858827372*y**10
          +87716379662*y**11-16295439772*y**12-3133176946*y**13+1872485245*y**14
          -476347875*y**15+74210045*y**16-8298147*y**17+277680*y**18)-2*r**18*(
          -1+y)**5*(-576179233269+1940228034042*y-1346317389102*y**2-12512534948650*y**3
          +42774912345082*y**4-60987663728846*y**5+41551740225300*y**6-4124571227918*y**7
          -15588923048872*y**8+11884821546074*y**9-2981692274088*y**10-308405992678*y**11
          +306814980790*y**12-66850326258*y**13+9237163244*y**14-2192901922*y**15
          +407389261*y**16-54880020*y**17+427830*y**18)+2*r**20*(-1+y)**4*(-6224938334478
          +25814214621042*y-35998300321605*y**2+4325453247839*y**3+35294681642751*y**4
          -21340961446141*y**5-22537383581423*y**6+31051092850969*y**7-7602496866547*y**8
          -6654822290635*y**9+4862998716829*y**10-954118448031*y**11-156924766863*y**12
          +106137385573*y**13-19834902841*y**14+2407680615*y**15-276633263*y**16
          +44350449*y**17+446160*y**18)-4*r**14*(-1+y)**7*(-100466728142+47207724500*y
          +110203477632*y**2+441039151398*y**3-907641496992*y**4-9445316060*y**5
          +1308727745629*y**6-2327510595150*y**7+2757937362392*y**8-1650983971916*y**9
          +239788046713*y**10+180037919386*y**11-79651937080*y**12+4576402460*y**13
          +2771648823*y**14-933424146*y**15+148671150*y**16-16727912*y**17+452115*y**18)
          -r**10*(-1+y)**9*(319422415+5657083282*y+23734102279*y**2+42247369080*y**3
          +131433582332*y**4+137251189544*y**5-127060667296*y**6-107356733584*y**7
          -176570348134*y**8+190820638420*y**9+95347615454*y**10-151920790184*y**11
          +47252748764*y**12-2817918856*y**13-185076152*y**14-355978688*y**15+101929023*y**16
          -11814534*y**17+469235*y**18)-2*r**16*(-1+y)**6*(-428266186699+354107522477*y
          +221019967997*y**2+230613432573*y**3+764384639465*y**4+371548065485*y**5
          -8153739721169*y**6+11610132932455*y**7-5447397683799*y**8-433217525063*y**9
          +1383086663279*y**10-472666748341*y**11+19187061231*y**12+8092864371*y**13
          +2432907873*y**14-2078733615*y**15+414161258*y**16-49748358*y**17+947780*y**18)
          +2*r**24*(-1+y)**2*(-3850119218229+25666668720723*y-70745824848714*y**2
          +98452506635556*y**3-57220131459580*y**4-25906393200736*y**5+67162091753270*y**6
          -42961484320646*y**7+4937704209696*y**8+8338124407304*y**9-4686656282916*y**10
          +732996682392*y**11+136374098416*y**12-63195821252*y**13+6545161846*y**14
          +38350826*y**15+3769985*y**16+9950889*y**17+1046370*y**18)+2*r**22*(
          -1+y)**3*(-11588012215442+61529852827972*y-125024952916139*y**2+108992745310716*y**3
          -476472978348*y**4-83125704365376*y**5+69854516707222*y**6-15989679665940*y**7
          -11146419960472*y**8+9343672103168*y**9-2346380493528*y**10-101453579404*y**11
          +110703101660*y**12+7981448016*y**13-8407419430*y**14+1417521636*y**15
          -108271750*y**16+25426284*y**17+1070355*y**18)+2*r**26*(988961268139
          -8876840107841*y+34753029494989*y**2-77663784578979*y**3+107781760915640*y**4
          -92162373346196*y**5+39634259687026*y**6+7452947483006*y**7-23489642476554*y**8
          +17134602520450*y**9-6999521410900*y**10+1555782084536*y**11-69505471344*y**12
          -48186857140*y**13+9164246190*y**14-703027918*y**15+21563479*y**16+24953799*y**17
          +2490023*y**18+569595*y**19))))/(501645312000*logy**6*r**24*(-1+y)**12+250822656000*logy**5*r**20*(
          -1+y)**10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +52254720000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2+5806080000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3+362880000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4
          +12096000*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**5+168000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**6))
      resNP += ((api*muWC**2*(-2612736000*logy**6*r**22*(-144-172*r**2
          +13*r**4+298*r**6+417*r**8+288*r**10)*(-1+y)**12-12441600*logy**5*r**18*(
          -1+y)**8*(24780*r**18*(-1+y)**4+r**16*(80357-321428*y+482142*y**2-293708*y**3
          +58517*y**4+6720*y**5)+r**14*(355676-1059824*y+863976*y**2+373846*y**3
          -801424*y**4+337050*y**5-32760*y**6)+8*(-1+y)**4*(2353-3255*y**3+2485*y**4
          -693*y**5-70*y**6+20*y**7)+21*r**12*(1933+17288*y-75972*y**2+114438*y**3
          -71487*y**4+16930*y**5-710*y**6+280*y**7)+2*r**2*(-1+y)**4*(20711-19740*y**3
          -23030*y**4+20244*y**5-6860*y**6+800*y**7)+14*r**10*(-20571+109104*y
          -217296*y**2+199514*y**3-40266*y**4-69585*y**5+61325*y**6-21105*y**7
          +2930*y**8)+35*r**8*(-9783+39600*y-60336*y**2+34844*y**3+18432*y**4
          -41174*y**5+25096*y**6-5094*y**7-901*y**8+360*y**9)-14*r**6*(6178-9232*y
          -17112*y**2+56403*y**3-66002*y**4+27602*y**5+26237*y**6-44673*y**7
          +25147*y**8-5928*y**9+480*y**10)+7*r**4*(22177-114628*y+223782*y**2
          -211258*y**3+76152*y**4+75288*y**5-167922*y**6+159078*y**7-82417*y**8
          +22728*y**9-3140*y**10+160*y**11))-103680*logy**4*r**14*(-1+y)**6*(-1
          +r**2+y)**2*(192264*r**22*(-1+y)**6-3*r**20*(-1+y)**2*(-861271+3573260*y
          -5680330*y**2+4085100*y**3-1356535*y**4+149536*y**5)-2*r**18*(-1+y)**2*(
          -13684816+50081341*y-67482600*y**2+36891460*y**3-4958200*y**4-1668789*y**5
          +182604*y**6)+r**16*(60244188-343806346*y+815854251*y**2-983302684*y**3
          +583824881*y**4-83590498*y**5-94298639*y**6+56686064*y**7-12176801*y**8
          +1094784*y**9)-48*(-1+y)**5*(-4886-4886*y-4886*y**2+41409*y**3-28956*y**4
          +10181*y**5+3181*y**6-32344*y**7+32861*y**8-12324*y**9+1700*y**10)
          +2*r**14*(77739792-379609649*y+745016637*y**2-655011585*y**3+115488815*y**4
          +234679263*y**5-184948181*y**6+50525913*y**7-2326635*y**8-1183630*y**9
          +221460*y**10)-4*r**2*(-1+y)**4*(431514+117264*y+117264*y**2-1852596*y**3
          +1089909*y**4-347804*y**5+517536*y**6+1474556*y**7-3051659*y**8+2029536*y**9
          -574040*y**10+61120*y**11)-r**12*(-121524362+565603534*y-1020603843*y**2
          +572208196*y**3+628999760*y**4-1117554972*y**5+538967690*y**6+68575428*y**7
          -179157666*y**8+76030670*y**9-13534131*y**10+805296*y**11)+2*r**6*(-1
          +y)**2*(-16692284+35941945*y-23108429*y**2+21941714*y**3-290926*y**4
          -69755848*y**5+75931924*y**6-8556178*y**7-24048714*y**8+11884511*y**9
          -749723*y**10-693264*y**11+123072*y**12)-2*r**10*(-5449980+8429323*y
          +39275100*y**2-242361749*y**3+461996166*y**4-302060594*y**5-143555480*y**6
          +351482766*y**7-224388346*y**8+60828679*y**9-3372616*y**10-1217193*y**11
          +129324*y**12)-r**4*(-1+y)**3*(-19203039+26576271*y-6350784*y**2+15529356*y**3
          -18273414*y**4+343314*y**5-9414636*y**6+10875624*y**7+11086169*y**8
          -18393741*y**9+9195240*y**10-1902200*y**11+133440*y**12)+r**8*(-59145612
          +304219066*y-653185431*y**2+841205532*y**3-625552115*y**4-151361636*y**5
          +998348178*y**6-1068470568*y**7+463910606*y**8+16649610*y**9-102114107*y**10
          +42714876*y**11-7768431*y**12+550032*y**13))-6912*logy**3*r**10*(-1+y)**4*(
          -1+r**2+y)**3*(31530*r**28*(-1+y)**8-r**26*(-1+y)**4*(-1351753+5501602*y
          -8488878*y**2+5846092*y**3-1849033*y**4+201030*y**5)-r**24*(-1+y)**2*(
          -34568205+200023239*y-480164229*y**2+608898385*y**3-429556695*y**4
          +160417905*y**5-24842719*y**6-148281*y**7+59400*y**8)+r**22*(-1+y)**2*(214246521
          -1226768970*y+2918600547*y**2-3617726248*y**3+2423230545*y**4-778404766*y**5
          +23757385*y**6+54035308*y**7-11819502*y**8+831780*y**9)-r**20*(-1+y)**2*(
          -1176194571+5999018913*y-12334335183*y**2+12287489911*y**3-5000429625*y**4
          -916708619*y**5+1597763687*y**6-512817067*y**7+50717724*y**8-2213970*y**9
          +61800*y**10)+12*(-1+y)**8*(-6807-20421*y-40842*y**2+24785*y**3+104805*y**4
          +158779*y**5-358343*y**6+239589*y**7-79210*y**8-171430*y**9+270453*y**10
          -131886*y**11+21028*y**12)-10*r**18*(-152097279+1102356624*y-3469460925*y**2
          +5901401826*y**3-5436178684*y**4+1841021141*y**5+1386921490*y**6-1924784579*y**7
          +934463367*y**8-174192801*y**9-23987747*y**10+17360321*y**11-3025206*y**12
          +152052*y**13)+2*r**2*(-1+y)**7*(761632+1645790*y+2652474*y**2-6380266*y**3
          -294055*y**4-5416724*y**5+2735635*y**6+7319122*y**7-2402613*y**8+1507230*y**9
          -6928383*y**10+6015200*y**11-2019996*y**12+232704*y**13)+2*r**16*(1549729557
          -9442800081*y+24175537251*y**2-30098936907*y**3+11454000005*y**4+16083879721*y**5
          -22971177468*y**6+9549421043*y**7+2336902159*y**8-4112379080*y**9+1826596647*y**10
          -382241026*y**11+31019931*y**12+699198*y**13+1050*y**14)-5*r**8*(-1
          +y)**4*(164550279-322007895*y+158648304*y**2-12623326*y**3-235587799*y**4
          +385818573*y**5+129236440*y**6-569382534*y**7+274363221*y**8+104431229*y**9
          -126968932*y**10+34750920*y**11-297565*y**12-992855*y**13+89340*y**14)
          +r**4*(-1+y)**6*(-32478585-23221749*y-21490857*y**2+237047581*y**3
          -211549450*y**4+93480460*y**5+66284138*y**6-329664856*y**7+324249463*y**8
          -98418035*y**9-8960225*y**10+845511*y**11+6114988*y**12-2233644*y**13
          +215760*y**14)+r**6*(-1+y)**5*(126759567-15384441*y+11337831*y**2-415792057*y**3
          +96530300*y**4+171302496*y**5+199696082*y**6+268969188*y**7-1029790861*y**8
          +773658045*y**9-156999113*y**10-59035391*y**11+32573006*y**12-5221932*y**13
          +263280*y**14)+2*r**12*(-1+y)**2*(-280067166+1646362215*y-4218970917*y**2
          +8405242968*y**3-9592310335*y**4+930212532*y**5+9904361285*y**6-10259034171*y**7
          +3433115804*y**8+728122770*y**9-881231591*y**10+238652425*y**11-20042087*y**12
          -1668297*y**13+313815*y**14)-r**10*(-1+y)**3*(-752841087+1827790149*y
          -1448594082*y**2+1931677560*y**3-43782125*y**4-6776025781*y**5+7389316602*y**6
          +838014214*y**7-5654426365*y**8+3382603625*y**9-472976682*y**10-251594426*y**11
          +113593893*y**12-15924645*y**13+673650*y**14)+2*r**14*(770872715-4215403156*y
          +8761140413*y**2-2841362878*y**3-21453050204*y**4+42414048540*y**5-30268959598*y**6
          -3594794381*y**7+22502297886*y**8-17303071447*y**9+5934253840*y**10-486130521*y**11
          -316335057*y**12+110145717*y**13-14456499*y**14+804630*y**15))-144*logy**2*r**6*(
          -1+y)**3*(-1+r**2+y)**4*(2040*r**34*(-1+y)**9-r**32*(-1+y)**5*(-242381
          +977684*y-1486926*y**2+983204*y**3-292781*y**4+28080*y**5)+2*r**30*(
          -1+y)**3*(11071967-64650484*y+156536877*y**2-200189470*y**3+143303561*y**4
          -55884840*y**5+10208987*y**6-500518*y**7+18960*y**8)+r**28*(-458592115
          +4017689703*y-15606461858*y**2+35203016670*y**3-50795968698*y**4+48708046146*y**5
          -31177961616*y**6+12951754008*y**7-3206352315*y**8+357149743*y**9+12840714*y**10
          -5379982*y**11+219600*y**12)-16*(-1+y)**11*(869+5214*y+18249*y**2
          +38581*y**3+48335*y**4+2502*y**5-127253*y**6-57928*y**7+186558*y**8
          -140610*y**9+42854*y**10+66489*y**11-70796*y**12+18436*y**13)-4*r**26*(1281978734
          -10724535508*y+39539402414*y**2-83868706185*y**3+111933676969*y**4-96105505526*y**5
          +51248512800*y**6-14378738058*y**7+205203520*y**8+1146636116*y**9-301225838*y**10
          +24158363*y**11-905791*y**12+47990*y**13)-r**24*(16842209973-137986958085*y
          +498333827232*y**2-1025236805148*y**3+1295368686269*y**4-992889789705*y**5
          +385819045568*y**6+26299831656*y**7-110418568337*y**8+55568768281*y**9
          -12929967088*y**10+1213346452*y**11+33394527*y**12-17720395*y**13+698800*y**14)
          -4*r**2*(-1+y)**9*(219855+893324*y+2268070*y**2+1120284*y**3-3978649*y**4
          -11086504*y**5+10215992*y**6-7900120*y**7+5352257*y**8+11133788*y**9
          -10864082*y**10+1701684*y**11-1811875*y**12+2293584*y**13-742864*y**14
          +72256*y**15)+2*r**22*(-37926039509+283536300579*y-915775440366*y**2
          +1628154839722*y**3-1636588947111*y**4+728468507413*y**5+256687084652*y**6
          -547053622448*y**7+311592339721*y**8-70900034623*y**9-5411408474*y**10
          +6397018094*y**11-1291767461*y**12+113272207*y**13-2210716*y**14+108320*y**15)
          +r**8*(-1+y)**6*(4389353105+1171619573*y+856971735*y**2-28056877865*y**3
          +32350711657*y**4-14666073187*y**5-12904658081*y**6+54804178895*y**7
          -57241085885*y**8+15497576191*y**9+9455382789*y**10-6510161467*y**11
          +687256595*y**12+325054575*y**13-88056123*y**14+4683093*y**15+4400*y**16)
          -2*r**14*(-1+y)**3*(3946349863+4801372284*y-26815640755*y**2-70794351122*y**3
          +174474233167*y**4-627397896*y**5-191387903643*y**6+68369104530*y**7
          +120303016349*y**8-113713066164*y**9+24922352623*y**10+10349377874*y**11
          -6529479075*y**12+1204048048*y**13-35721953*y**14-8247090*y**15+62960*y**16)
          -r**4*(-1+y)**8*(-38940487-108632261*y-206906410*y**2+230348978*y**3
          +412686587*y**4+610342769*y**5-1356656228*y**6+951594820*y**7-426534121*y**8
          -758366139*y**9+1327096238*y**10-694793366*y**11+109131365*y**12+9333343*y**13
          +1987152*y**14-1626320*y**15+134080*y**16)-2*r**6*(-1+y)**7*(191369997
          +346851360*y+505233365*y**2-1564732260*y**3+566553857*y**4-1138515716*y**5
          -653869475*y**6+4092338080*y**7-2354227345*y**8-23477344*y**9-730958889*y**10
          +1215683860*y**11-514101245*y**12+44982580*y**13+18676087*y**14-3734192*y**15
          +177280*y**16)+4*r**10*(-1+y)**5*(-2030271592+978424690*y-294855420*y**2
          +3616024431*y**3+12352044840*y**4-19682903050*y**5-7528815390*y**6+16900985055*y**7
          +6476174198*y**8-15761593690*y**9+4980548376*y**10+1882628845*y**11-1431299060*y**12
          +260200346*y**13-4040950*y**14-3248859*y**15+210230*y**16)-r**16*(-1
          +y)**2*(27961573983-60184321065*y-147267417805*y**2+1059385826595*y**3
          -2099340202157*y**4+1492780474251*y**5+627509950295*y**6-1820946930345*y**7
          +1204927410605*y**8-213533497691*y**9-140168559431*y**10+88487825225*y**11
          -18701408975*y**12+1008715225*y**13+236658973*y**14-40407203*y**15+829520*y**16)
          +r**12*(-1+y)**4*(55925703679-145831257847*y+111231715740*y**2+28976186688*y**3
          -235954419543*y**4+296351630095*y**5+71187077034*y**6-457913372430*y**7
          +366647963809*y**8-57366505529*y**9-68379191592*y**10+39776995868*y**11
          -7111095385*y**12-187546847*y**13+167647522*y**14-16259982*y**15+880720*y**16)
          +r**20*(-40134743763+330004818175*y-1208124243990*y**2+2365380757782*y**3
          -2384111906337*y**4+539884240789*y**5+1535374450880*y**6-1899212185880*y**7
          +871432094771*y**8+26187964689*y**9-226562021894*y**10+112200116230*y**11
          -24136856655*y**12+1622271947*y**13+210498348*y**14-27918932*y**15+1015840*y**16)
          +4*r**18*(-25215978635+147696054451*y-348248190166*y**2+306296484340*y**3
          +262803842309*y**4-880818972263*y**5+719784091372*y**6+91590541922*y**7
          -625758610565*y**8+521546271347*y**9-197286375254*y**10+19390698768*y**11
          +12814992319*y**12-5344111325*y**13+789755044*y**14-42267898*y**15+1772984*y**16
          +1250*y**17))-24*logy*r**4*(-1+y)**2*(-1+r**2+y)**5*(909*r**36*(-1+y)**10
          +r**34*(-1+y)**6*(121093-464437*y+659058*y**2-391372*y**3+87997*y**4
          +81*y**5)-r**32*(-1+y)**4*(-11574072+67121390*y-161030589*y**2+201908792*y**3
          -140888773*y**4+54589310*y**5-10517747*y**6+600596*y**7+25381*y**8)
          -r**30*(-1+y)**2*(-477295662+3608185406*y-11831467471*y**2+21888679205*y**3
          -24936520352*y**4+17918002960*y**5-7941780594*y**6+1978083794*y**7-200711722*y**8
          -6159950*y**9+388345*y**10+70441*y**11)+r**28*(4948542702-46158620060*y
          +192343829057*y**2-469452810538*y**3+739892880248*y**4-782185321216*y**5
          +555457754755*y**6-254087364108*y**7+64119385682*y**8-2023192236*y**9
          -3800661021*y**10+1040976870*y**11-99092184*y**12+3574296*y**13-26247*y**14)
          +r**26*(33498248874-294863416058*y+1149463572665*y**2-2587111110359*y**3
          +3658903872914*y**4-3272177049638*y**5+1674547139721*y**6-218988998341*y**7
          -308219462034*y**8+223738956994*y**9-67046583885*y**10+8272968647*y**11
          +23077526*y**12-41435842*y**13+900747*y**14+57269*y**15)+r**24*(55207744242
          -477343094432*y+1842491742989*y**2-4067154161736*y**3+5456837719129*y**4
          -4206118510958*y**5+1091663118093*y**6+1226427749760*y**7-1523199105045*y**8
          +783568837820*y**9-196507446577*y**10+6719487848*y**11+9831279311*y**12
          -2749571934*y**13+329594711*y**14-6924272*y**15-138949*y**16)+r**22*(332115514166
          -2612234566666*y+8885965209677*y**2-16595746286977*y**3+17148111092837*y**4
          -6485319823537*y**5-6448047282047*y**6+10353642307539*y**7-5696270152027*y**8
          +583300223775*y**9+1004896644935*y**10-604531354499*y**11+147036636095*y**12
          -11833738571*y**13-1348110837*y**14+260441761*y**15+5866337*y**16-269961*y**17)
          -2*(-1+y)**11*(-1869-11214*y-39249*y**2-90228*y**3-123126*y**4+5972*y**5
          +665694*y**6-176708*y**7-1444869*y**8+1894842*y**9-581897*y**10-776316*y**11
          +983028*y**12-436928*y**13+94484*y**14-49356*y**15+14636*y**16+3104*y**17)
          -r**2*(-1+y)**10*(901305+4358367*y+12714051*y**2+16990059*y**3-1512591*y**4
          -56541699*y**5-51475173*y**6+25116429*y**7+120597599*y**8-124571331*y**9
          +85790145*y**10-7907323*y**11-65327829*y**12+47361867*y**13-10714303*y**14
          +850899*y**15-198996*y**16+68524*y**17)-r**8*(-1+y)**7*(-3237183978
          -4517742886*y-5841568377*y**2+24827154929*y**3-20353099157*y**4+21909107939*y**5
          +40612189665*y**6-137848767759*y**7+94401084217*y**8+11149688739*y**9
          -25193484439*y**10-2921238117*y**11+7611257789*y**12-1627762671*y**13
          -246970657*y**14+108839603*y**15-6074087*y**16+165247*y**17)-r**4*(-1
          +y)**9*(-28296917-106992995*y-256577579*y**2-1406405*y**3+499941463*y**4
          +1089932851*y**5-1292668537*y**6+1140582789*y**7-537823985*y**8-1663866321*y**9
          +1730786179*y**10-390732091*y**11+76798129*y**12-165291235*y**13+79584033*y**14
          -8073013*y**15-1094402*y**16+258036*y**17)+r**10*(-1+y)**6*(-29946239322
          +8496703118*y+5167109293*y**2+169993780351*y**3-243731149909*y**4+110338405053*y**5
          +76646372701*y**6-306040003783*y**7+358193420163*y**8-110345029157*y**9
          -95221977345*y**10+84481774049*y**11-19680903903*y**12-1916725989*y**13
          +1488849591*y**14-210988761*y**15+3037707*y**16+394143*y**17)-r**6*(
          -1+y)**8*(593650158+1448954542*y+2502693097*y**2-4365358253*y**3-3515051447*y**4
          -5526272661*y**5+14134968941*y**6-8714655345*y**7+3939037401*y**8+7848499859*y**9
          -17189191317*y**10+10767259257*y**11-1665932901*y**12-662893223*y**13
          +223047263*y**14-993355*y**15-3395915*y**16+413899*y**17)+r**12*(-1
          +y)**5*(4039140558+13835217754*y+12487637467*y**2+96427314133*y**3-852082992735*y**4
          +1129295703045*y**5+208285038121*y**6-1347213470009*y**7+816804888643*y**8
          +96697901859*y**9-249379955395*y**10+56766467075*y**11+17442095471*y**12
          -8760920301*y**13+953729151*y**14-18665983*y**15-6054625*y**16+881771*y**17)
          +r**14*(-1+y)**4*(-287403372918+924480896522*y-915145620057*y**2-93665247475*y**3
          +1212874506683*y**4-1121402370823*y**5-803850561005*y**6+2557888695533*y**7
          -2009014385885*y**8+332530024749*y**9+459622604005*y**10-319834571121*y**11
          +75642756865*y**12-919152365*y**13-2613391007*y**14+323196311*y**15-11897321*y**16
          +1565309*y**17)+r**18*(-1+y)**2*(281935986276-844386129648*y-146089877241*y**2
          +4787452292937*y**3-9080716541211*y**4+5065648249967*y**5+5256756625575*y**6
          -10361184823997*y**7+6616138254921*y**8-1164850062303*y**9-874894201427*y**10
          +605194404399*y**11-147083758593*y**12+9498961417*y**13+1882440389*y**14
          -330098091*y**15+15521999*y**16+2074631*y**17)+r**16*(-1+y)**3*(-208437532250
          +1122102008774*y-2014724093043*y**2-224522437889*y**3+4947188913689*y**4
          -5314160640831*y**5+115481325079*y**6+3305925936467*y**7-1941625174617*y**8
          -187289815003*y**9+566207292667*y**10-173505455955*y**11-11515400185*y**12
          +15508068331*y**13-3131700111*y**14+206253089*y**15-5214173*y**16+2369961*y**17)
          +r**20*(-134154971352+871509642840*y-2005306190145*y**2+1782542858898*y**3
          -84181914552*y**4+240298749468*y**5-3079701223968*y**6+4195045659090*y**7
          -1375084100656*y**8-1855115389436*y**9+2399013396990*y**10-1221783207274*y**11
          +273297976360*y**12+8082959148*y**13-17849325712*y**14+3708252694*y**15
          -347853048*y**16+24044620*y**17+636035*y**18))+(-1+r**2+y)**6*(r**42*(
          -1+y)**12-2*r**40*(-1+y)**8*(-34+139*y-216*y**2+468*y**3-354*y**4
          +117*y**5)-r**38*(-1+y)**6*(102874-595014*y+1420617*y**2-1813780*y**3
          +1320855*y**4-533438*y**5+114051*y**6-15328*y**7+2379*y**8)-2*r**36*(
          -1+y)**4*(3108342-23711127*y+78601413*y**2-146291018*y**3+165766414*y**4
          -116135124*y**5+48275480*y**6-9970026*y**7+20764*y**8+362027*y**9-49325*y**10
          +4756*y**11)-r**34*(-1+y)**2*(514072375-4897934908*y+20865669978*y**2
          -52192400736*y**3+84784941041*y**4-93536849624*y**5+71216642076*y**6
          -37217143200*y**7+12953669717*y**8-2798086996*y**9+320663934*y**10-14419440*y**11
          +1368323*y**12-270312*y**13+16332*y**14)-4*(-1+y)**15*(-10-90*y-450*y**2
          -1718*y**3+1663*y**4+24035*y**5+24535*y**6-3069*y**7-19228*y**8+3084*y**9
          +32784*y**10-31492*y**11-2945*y**12+10531*y**13-5237*y**14+951*y**15
          +232*y**16+24*y**17)+4*r**32*(-2525439946+28151916732*y-142728746796*y**2
          +434234266426*y**3-880789833077*y**4+1250932224722*y**5-1269472135593*y**6
          +919413191354*y**7-462645908806*y**8+149592143660*y**9-23520306950*y**10
          -1989862834*y**11+1561790551*y**12-215363670*y**13+1763467*y**14+245934*y**15
          +44350*y**16+876*y**17)-r**2*(-1+y)**14*(-2045-16120*y-71460*y**2
          -233452*y**3+260292*y**4+2666864*y**5+2017024*y**6-876956*y**7-3268658*y**8
          +1979480*y**9+3323556*y**10-4236644*y**11+1319116*y**12+352896*y**13
          -463512*y**14+89260*y**15-16225*y**16-1040*y**17+24*y**18)+4*r**30*(
          -13263655442+142471886148*y-694276850916*y**2+2017545003340*y**3-3863950222436*y**4
          +5076404764160*y**5-4584465231853*y**6+2711196943766*y**7-846829293874*y**8
          -81408912898*y**9+219494386117*y**10-106155657856*y**11+26620261004*y**12
          -3675276588*y**13+324626809*y**14-34331650*y**15+1768156*y**16-189174*y**17
          +16787*y**18)-2*r**4*(-1+y)**12*(-217762-1267731*y-4323123*y**2-9353050*y**3
          -15311750*y**4-6065970*y**5+62302974*y**6+2366966*y**7-90938318*y**8
          +88626800*y**9-43380724*y**10-6071774*y**11+31185454*y**12-15891966*y**13
          +7188754*y**14-7219294*y**15+2086856*y**16-21997*y**17-11241*y**18+96*y**19)
          +r**6*(-1+y)**11*(-45814230-209975292*y-585003987*y**2-569692903*y**3
          +594533140*y**4+2958848164*y**5+343642888*y**6-238146104*y**7-3331799616*y**8
          +2316790868*y**9-2152664190*y**10+534904666*y**11+2056077228*y**12-1704998132*y**13
          +432840544*y**14+8958176*y**15-10651242*y**16-1102792*y**17+135721*y**18
          +293*y**19)+2*r**8*(-1+y)**10*(359628202+1226844565*y+2717655436*y**2
          -1675213933*y**3-5070995596*y**4-8873810424*y**5+15586199156*y**6-16340743528*y**7
          +5353509052*y**8+26110449210*y**9-31379294728*y**10+9706984718*y**11
          +1341603468*y**12-293276800*y**13-420777812*y**14+117757920*y**15+328506*y**16
          -2800631*y**17+193276*y**18+4743*y**19)+8*r**28*(-39175425376+401055334638*y
          -1847785525947*y**2+5017749587255*y**3-8795707589109*y**4+10126301757525*y**5
          -7147624203056*y**6+1934040206174*y**7+1667193330612*y**8-2229743094041*y**9
          +1223966178403*y**10-348671831422*y**11+30234806693*y**12+11644135451*y**13
          -3928989436*y**14+484655878*y**15-34137180*y**16+1052235*y**17-279588*y**18
          +13491*y**19)+8*r**12*(-1+y)**8*(2765892436+2379546056*y+3349374201*y**2
          -19886912339*y**3+35374030125*y**4-43403320253*y**5-112927938864*y**6
          +318929441874*y**7-236430628296*y**8-21269926347*y**9+105296044133*y**10
          -40051942370*y**11-3321309741*y**12+5266560589*y**13-998655236*y**14
          +19573114*y**15+7541708*y**16+2096771*y**17-131074*y**18+19513*y**19)
          +2*r**18*(-1+y)**5*(-2031813042989+6878493639581*y-7213581199260*y**2
          +2328442640248*y**3-4341386951432*y**4+12278071520004*y**5-12759664391598*y**6
          +5786485377366*y**7-336193474078*y**8-1335902961542*y**9+1376263665934*y**10
          -859449954542*y**11+273633441248*y**12-21773535868*y**13-7491052570*y**14
          +1848466466*y**15-73911501*y**16+28038561*y**17-5702762*y**18+22334*y**19)
          +8*r**16*(-1+y)**6*(-86943020698+172198093794*y-13821279453*y**2+412731920153*y**3
          -2092904157416*y**4+2588050067271*y**5-12527152153*y**6-2364232597013*y**7
          +1739965463077*y**8-49113583285*y**9-503707300860*y**10+232196082435*y**11
          -17401869556*y**12-13737266491*y**13+4066042773*y**14-280757863*y**15
          -10768351*y**16+10216847*y**17-1175139*y**18+34728*y**19)+r**10*(-1
          +y)**9*(-10471651133-21059551545*y-31393804023*y**2+81076835245*y**3
          +21068546364*y**4+53981153100*y**5-163310449768*y**6+27455573704*y**7
          +5926816074*y**8-25948727854*y**9+154192265522*y**10-146637983846*y**11
          +35865447964*y**12+13023001420*y**13-7237759616*y**14+814674896*y**15
          +42005019*y**16-6311985*y**17+379821*y**18+52641*y**19)-4*r**24*(-1
          +y)**2*(821839175134-6180558813349*y+19818285883002*y**2-34145998809437*y**3
          +30767156250422*y**4-5823969675118*y**5-17946621183670*y**6+20096907382262*y**7
          -7512685633428*y**8-1939685549224*y**9+3093280923164*y**10-1220548497304*y**11
          +150357261378*y**12+33194273054*y**13-11735472442*y**14+833767690*y**15
          +55847118*y**16+896653*y**17+891306*y**18+64389*y**19)+4*r**14*(-1+y)**7*(
          -86903705878+65887498454*y+26560002530*y**2+442752283426*y**3-729526945336*y**4
          +242855790124*y**5-42196101033*y**6+174969336727*y**7+7793423560*y**8
          -121431897288*y**9-79016391049*y**10+156087824795*y**11-60606443132*y**12
          +1237884720*y**13+3856361393*y**14-578541407*y**15-2483326*y**16+15235990*y**17
          -1198241*y**18+69771*y**19)-4*r**20*(-1+y)**4*(1863552442942-8649828910055*y
          +14402170341091*y**2-5653148254888*y**3-11463701422440*y**4+11953867817872*y**5
          +5395370203554*y**6-15162035536290*y**7+8432117127658*y**8+504702883126*y**9
          -2599710742362*y**10+1143058655610*y**11-129072823360*y**12-46070156784*y**13
          +16893757446*y**14-2094038382*y**15+79814336*y**16-4750671*y**17+2319759*y**18
          +71838*y**19)-2*r**22*(-1+y)**3*(2755035552250-17399056088400*y+44077200998715*y**2
          -56468423335793*y**3+31817076675484*y**4+9826716115908*y**5-31224637866502*y**6
          +25226898447434*y**7-10522497290144*y**8+1330045679244*y**9+1266686752544*y**10
          -996967301456*y**11+368836421612*y**12-75247428588*y**13+10159211710*y**14
          -1584316242*y**15+192545918*y**16-349876*y**17+2804685*y**18+211497*y**19)
          -2*r**26*(-15299650769+182077610604*y-815384033646*y**2+2186859774292*y**3
          -4684150876989*y**4+9043706290720*y**5-14405086969738*y**6+16698273007728*y**7
          -12758516451952*y**8+5240486431568*y**9+344213270762*y**10-1900354867824*y**11
          +1237120719784*y**12-432615254320*y**13+87389309618*y**14-8812280416*y**15
          -6906567*y**16+101252884*y**17-1901220*y**18+1524428*y**19+1053*y**20))))/(188116992000*logy**6*r**24*(
          -1+y)**12+94058496000*logy**5*r**20*(-1+y)**10*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+19595520000*logy**4*r**16*(-1+y)**8*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+2177280000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +136080000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**4+4536000*logy*r**4*(-1+y)**2*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**5+63000*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**6))
      resNP += ((mupi*(2612736000*logy**6*r**22*(72
          +169*r**2+275*r**4+347*r**6+321*r**8+216*r**10)*(-1+y)**12+12441600*logy**5*r**18*(
          -1+y)**8*(5172*r**18*(-1+y)**4+r**16*(65479-261916*y+392874*y**2-256876*y**3
          +97399*y**4-11760*y**5)+r**14*(288637-882388*y+779262*y**2+152282*y**3
          -421583*y**4+169470*y**5-12600*y**6)+20*(-1+y)**4*(-337+4704*y**3
          -7357*y**4+3780*y**5-812*y**6+64*y**7)-21*r**12*(-4961+584*y+37644*y**2
          -71196*y**3+39009*y**4-4880*y**5-1760*y**6+160*y**7)+r**2*(-1+y)**4*(
          -12391+211470*y**3-354515*y**4+184296*y**5-39620*y**6+3200*y**7)+35*r**10*(
          -1047+16680*y-50004*y**2+56950*y**3-8685*y**4-25104*y**5+19600*y**6
          -5754*y**7+604*y**8)+7*r**8*(-20781+132624*y-297936*y**2+261584*y**3
          +24324*y**4-161684*y**5+73666*y**6+11136*y**7-15229*y**8+2736*y**9)
          -7*r**6*(21427-116128*y+235032*y**2-180918*y**3-3788*y**4+3818*y**5
          +139418*y**6-167292*y**7+80503*y**8-16872*y**9+1200*y**10)+r**4*(-112237
          +539668*y-990942*y**2+801328*y**3-686622*y**4+1796172*y**5-2944578*y**6
          +2502912*y**7-1157873*y**8+283872*y**9-32980*y**10+1280*y**11))-103680*logy**4*r**14*(
          -1+y)**6*(-1+r**2+y)**2*(62088*r**22*(-1+y)**6+3*r**20*(-1+y)**2*(-266739
          +1025564*y-1434866*y**2+804364*y**3-373491*y**4+64688*y**5)-r**18*(
          -1+y)**2*(10049509-38571094*y+55154622*y**2-34110748*y**3+12257557*y**4
          -2625342*y**5+401496*y**6)+r**16*(-42908436+233532092*y-518684019*y**2
          +576331646*y**3-340078153*y**4+104091536*y**5-8686577*y**6-5256946*y**7
          +429289*y**8+171168*y**9)+120*(-1+y)**5*(-187-187*y-187*y**2-123*y**3
          -3273*y**4+3307*y**5+37439*y**6-73961*y**7+52060*y**8-15840*y**9+1792*y**10)
          +r**14*(-137697588+672511076*y-1292795445*y**2+1091732934*y**3-261632927*y**4
          -146988372*y**5+80711969*y**6-9410370*y**7+3209991*y**8-2280908*y**9
          +270840*y**10)-r**12*(151516906-752740760*y+1464949593*y**2-1167171782*y**3
          +116394158*y**4+204849306*y**5+163035428*y**6-294885258*y**7+139907412*y**8
          -22850218*y**9-1054497*y**10+418512*y**11)+r**2*(-1+y)**4*(-915297+44880*y
          +44880*y**2+12989460*y**3-20219250*y**4+11213504*y**5-25564020*y**6
          +54797140*y**7-51157465*y**8+23825520*y**9-5447512*y**10+488960*y**11)
          +r**4*(-1+y)**3*(6283677-8541963*y+1954680*y**2-107064600*y**3+313448490*y**4
          -340346094*y**5+189692916*y**6-107410860*y**7+97101925*y**8-63544875*y**9
          +22346472*y**10-3731608*y**11+215040*y**12)-r**6*(-1+y)**2*(10810804
          -22791140*y+14264887*y**2-217820560*y**3+876193040*y**4-1319423608*y**5
          +955920790*y**6-338707384*y**7+64985460*y**8-30401500*y**9+19920859*y**10
          -5830080*y**11+589632*y**12)+r**10*(-113331738+570569164*y-1131892731*y**2
          +982789810*y**3-531119700*y**4+997636936*y**5-1708852718*y**6+1404928272*y**7
          -545041270*y**8+52395700*y**9+29099837*y**10-8992626*y**11+752664*y**12)
          +r**8*(-54970356+278250148*y-564323661*y**2+671102874*y**3-1205117045*y**4
          +2731922392*y**5-3785898066*y**6+2911764852*y**7-1154569918*y**8+121983780*y**9
          +76320799*y**10-30080622*y**11+3682119*y**12-67296*y**13))+6912*logy**3*r**10*(
          -1+y)**4*(-1+r**2+y)**3*(-34194*r**28*(-1+y)**8+r**26*(-1+y)**4*(-493231
          +2075506*y-3369714*y**2+2709256*y**3-675439*y**4+35502*y**5)+r**24*(
          -1+y)**2*(66900-2544405*y+11793726*y**2-23916461*y**3+32836680*y**4
          -32445975*y**5+18083030*y**6-4475271*y**7+364176*y**8)-r**22*(-1+y)**2*(
          -104599434+581927289*y-1324925616*y**2+1553569301*y**3-1067283870*y**4
          +497060579*y**5-159308144*y**6+25954351*y**7-2742336*y**8+382680*y**9)
          -r**20*(-1+y)**2*(-457678776+2411231103*y-5145037218*y**2+5424481031*y**3
          -2931968460*y**4+797273201*y**5-92880998*y**6-44205047*y**7+32180304*y**8
          -9491160*y**9+802020*y**10)+6*(-1+y)**8*(-11019-33057*y-66114*y**2
          +28850*y**3+140430*y**4+261598*y**5-326246*y**6+335298*y**7-265075*y**8
          -630205*y**9+1023096*y**10-493572*y**11+78016*y**12)+r**2*(-1+y)**7*(
          -150209-102076*y+144399*y**2+1050086*y**3+4820420*y**4-2529662*y**5
          -46584728*y**6+56931322*y**7-21140127*y**8+30983730*y**9-48886479*y**10
          +31083704*y**11-8840196*y**12+930816*y**13)+r**18*(1289285343-8777971359*y
          +25433529114*y**2-39212648118*y**3+33583562480*y**4-14692514836*y**5
          +1467409348*y**6+1715051722*y**7-1184171589*y**8+508403895*y**9-179794982*y**10
          +63392636*y**11-13571586*y**12+1045932*y**13)+r**6*(-1+y)**5*(-70374474
          +40982115*y+10049319*y**2+1152261373*y**3-2396678123*y**4+1774800678*y**5
          -2301176690*y**6+4918352502*y**7-5296312076*y**8+2793115491*y**9-648282229*y**10
          -1847275*y**11+26063329*y**12-3226572*y**13+4632*y**14)+2*r**16*(1743256491
          -10980896610*y+28736223714*y**2-37261834527*y**3+20660205142*y**4+2468351573*y**5
          -6834720570*y**6-822622118*y**7+4000974929*y**8-2224328434*y**9+618434136*y**10
          -122568395*y**11+22350654*y**12-2341977*y**13+19992*y**14)+2*r**12*(
          -1+y)**2*(796068291-3720800871*y+6721017699*y**2-5595706464*y**3+9417747775*y**4
          -24176428542*y**5+30494763877*y**6-17733704748*y**7+2630367163*y**8+2292200565*y**9
          -1276402099*y**10+217747244*y**11+4584899*y**12-5795124*y**13+458835*y**14)
          +r**4*(-1+y)**6*(4112340+5711025*y+6239826*y**2-98403967*y**3+23476156*y**4
          +17099450*y**5+688644220*y**6-1412400842*y**7+1118883464*y**8-441337327*y**9
          +129551810*y**10-63187095*y**11+27578216*y**12-5994372*y**13+468096*y**14)
          +r**10*(-1+y)**3*(-246978063+601860951*y-505761798*y**2+7009056600*y**3
          -33256095815*y**4+57869818661*y**5-46572199422*y**6+15303012016*y**7
          +1503047135*y**8-2093819215*y**9+114118302*y**10+171059896*y**11-29657793*y**12
          -2939085*y**13+468630*y**14)-r**8*(-1+y)**4*(-249207576+456086889*y
          -205227456*y**2+4957855634*y**3-17392432696*y**4+22072523097*y**5-13332000248*y**6
          +5832294432*y**7-4876111068*y**8+3905244047*y**9-1556084296*y**10+192595134*y**11
          +49586924*y**12-16135841*y**13+1287024*y**14)-2*r**14*(-1541745430+10053070415*y
          -27255865444*y**2+35942130467*y**3-19746948137*y**4+1275514509*y**5-9149879560*y**6
          +26221299208*y**7-24681656724*y**8+10633095989*y**9-1461427418*y**10
          -417889155*y**11+117079311*y**12+21510207*y**13-9040902*y**14+752664*y**15))
          -144*logy**2*r**6*(-1+y)**3*(-1+r**2+y)**4*(384*r**34*(-1+y)**9-r**32*(
          -1+y)**5*(-426899+1709132*y-2567538*y**2+1800044*y**3-489107*y**4
          +40608*y**5)-r**30*(-1+y)**3*(-17133253+99584714*y-240175779*y**2+309004832*y**3
          -220457707*y**4+79108770*y**5-9739453*y**6-579436*y**7+47472*y**8)+r**28*(
          -11435779+97214955*y-382880066*y**2+941891154*y**3-1419266250*y**4
          +979671162*y**5+398404320*y**6-1336679616*y**7+1072908501*y**8-408352685*y**9
          +74399322*y**10-6181450*y**11+306432*y**12)+16*(-1+y)**11*(1459+8754*y
          +30639*y**2+63176*y**3+80590*y**4+26082*y**5-102478*y**6-117158*y**7
          +58683*y**8-69540*y**9+126859*y**10+28974*y**11-89356*y**12+26816*y**13)
          +r**26*(928186651-8304010199*y+32809925050*y**2-75292639506*y**3+112462417334*y**4
          -117173942578*y**5+89121740304*y**6-50025676080*y**7+19791132443*y**8
          -4883711999*y**9+574766942*y**10-4923110*y**11-3355220*y**12+89968*y**13)
          +r**24*(10813857465-85925475633*y+297243103104*y**2-578829792696*y**3
          +693810182857*y**4-531848535993*y**5+265783269952*y**6-86014559808*y**7
          +13433906411*y**8+4117825709*y**9-3372633872*y**10+948458216*y**11-184283901*y**12
          +25911565*y**13-1233376*y**14)+r**22*(26090874239-200768312715*y+671926241820*y**2
          -1251283279936*y**3+1383170254827*y**4-881793447859*y**5+253591803640*y**6
          +51319004600*y**7-93007059043*y**8+63838516231*y**9-30870735964*y**10
          +9035949400*y**11-1254236695*y**12-9216121*y**13+13677592*y**14-34016*y**15)
          +r**2*(-1+y)**9*(847179+3482092*y+8938670*y**2+5374212*y**3-10415411*y**4
          -39001400*y**5+10668316*y**6-37909880*y**7+26172541*y**8+81985612*y**9
          -60426202*y**10+3422292*y**11-16264565*y**12+19887072*y**13-6242576*y**14
          +578048*y**15)-r**8*(-1+y)**6*(-548937011-527888951*y-519443925*y**2
          +18987904031*y**3-17548484539*y**4+4677573505*y**5-92780372605*y**6+215603010535*y**7
          -196758394537*y**8+84797326283*y**9-17640117567*y**10+4472096413*y**11
          -2867984585*y**12+900053931*y**13-90230319*y**14-4653027*y**15+302368*y**16)
          +r**4*(-1+y)**8*(-16459853-43341235*y-79599470*y**2+107548198*y**3
          +158831833*y**4+303589711*y**5-123125644*y**6+366032540*y**7-429671651*y**8
          -1598412141*y**9+2581967722*y**10-1394577202*y**11+322912855*y**12-52803247*y**13
          +22822608*y**14-5744080*y**15+429056*y**16)-r**10*(-1+y)**5*(6628389745
          -7959224272*y+18433020*y**2-106422023112*y**3+299488351659*y**4-280321983572*y**5
          +232268230626*y**6-422912061900*y**7+526675899319*y**8-321835295768*y**9
          +76666496664*y**10+12527563424*y**11-11204344195*y**12+2188283068*y**13
          -112817366*y**14-12758412*y**15+565072*y**16)+r**6*(-1+y)**7*(-163140021
          -244848858*y-280324345*y**2+1663407324*y**3+1435235279*y**4-101519342*y**5
          -15270509981*y**6+21577268680*y**7-11312655463*y**8+8314143482*y**9-11786372403*y**10
          +8678405596*y**11-2824095635*y**12+255236014*y**13+66851689*y**14-15001184*y**15
          +919168*y**16)+r**14*(-1+y)**3*(-2894724497+3638340546*y-3884146015*y**2
          +294049726576*y**3-1681788838769*y**4+3386348864070*y**5-3093745086471*y**6
          +1051866077820*y**7+351611409173*y**8-437298180402*y**9+134151727771*y**10
          -1588361896*y**11-8491561155*y**12+1950990826*y**13-82577429*y**14-12909444*y**15
          +1689296*y**16)-r**16*(-1+y)**2*(-93256665303+495307657281*y-1025891277355*y**2
          +750275504397*y**3-58102597403*y**4+655654906269*y**5-1851977729023*y**6
          +1637888053785*y**7-465023347189*y**8-163007934029*y**9+139159596751*y**10
          -21677509897*y**11-4838678105*y**12+1166465167*y**13+138237307*y**14
          -50059517*y**15+2336864*y**16)+r**20*(61589363577-438961124321*y+1336548601890*y**2
          -2138110249770*y**3+1806854392659*y**4-646701213875*y**5-16821025312*y**6
          -75863531600*y**7+220383937415*y**8-152883985743*y**9+54026082274*y**10
          -10634099498*y**11+704192685*y**12-261295645*y**13+188027484*y**14-37195676*y**15
          +2419456*y**16)+r**12*(-1+y)**4*(13761876439-31093432675*y+20917852620*y**2
          -336552476964*y**3+1375285530657*y**4-2030481883037*y**5+1307967389562*y**6
          -303038742690*y**7+32302500793*y**8-106344804029*y**9+78223273512*y**10
          -13175064304*y**11-4225421905*y**12+1444505821*y**13+25599922*y**14-31486314*y**15
          +2478592*y**16)+r**18*(164394311743-1108505242715*y+3125876430782*y**2
          -4353638660918*y**3+2413680888005*y**4+836282685103*y**5-1281684081920*y**6
          -743300864800*y**7+1827311486521*y**8-1217754596965*y**9+403229791870*y**10
          -75923214150*y**11+12654114379*y**12-3105884303*y**13+516944260*y**14
          -39834916*y**15+6059960*y**16-331936*y**17))+24*logy*r**4*(-1+y)**2*(
          -1+r**2+y)**5*(2211*r**36*(-1+y)**10+r**34*(-1+y)**6*(-190252+745345*y
          -1081164*y**2+710092*y**3-171364*y**4+12183*y**5)+r**32*(-1+y)**4*(
          -17372445+100047479*y-237971022*y**2+302400887*y**3-214899982*y**4
          +79662053*y**5-12890198*y**6+540605*y**7+14047*y**8)+r**30*(-1+y)**2*(
          -173553456+1265503646*y-3988139014*y**2+7070159609*y**3-7487115776*y**4
          +4419292498*y**5-898618176*y**6-459695068*y**7+307814984*y**8-57075896*y**9
          +2470126*y**10+7723*y**11)+r**28*(1255982964-11952215710*y+50596974814*y**2
          -125180131391*y**3+202711241083*y**4-230967091157*y**5+196273551563*y**6
          -128993281950*y**7+64632002578*y**8-22804927344*y**9+4952685828*y**10
          -564687843*y**11+45509871*y**12-6029277*y**13+127971*y**14)+r**26*(6959195712
          -64126018198*y+262702594630*y**2-628478387569*y**3+980194673128*y**4
          -1063111232524*y**5+839036193522*y**6-490922001071*y**7+202263872400*y**8
          -45074527966*y**9-3795890550*y**10+5735878681*y**11-1599557624*y**12
          +235458784*y**13-19037442*y**14+264487*y**15)+r**24*(59570530644-495269056498*y
          +1797390333706*y**2-3657168273171*y**3+4478956476065*y**4-3254077870732*y**5
          +1170321663162*y**6+102607269459*y**7-374881099107*y**8+270055962886*y**9
          -134636011202*y**10+45365484091*y**11-9504057245*y**12+1378113048*y**13
          -113121506*y**14+595685*y**15-299285*y**16)+r**22*(62591242768-510238340090*y
          +1840477831030*y**2-3745902633209*y**3+4569597198424*y**4-3217886331737*y**5
          +1007013651194*y**6+194624038203*y**7-340231310204*y**8+246236324535*y**9
          -150467773142*y**10+40377522245*y**11+12414980272*y**12-11406724987*y**13
          +3142932966*y**14-351928039*y**15+15499876*y**16-1476105*y**17)-(-1
          +y)**11*(-7869-47214*y-165249*y**2-350670*y**3-397359*y**4+62624*y**5
          +1158525*y**6+354484*y**7-1833615*y**8+2023698*y**9-1740671*y**10-1398*y**11
          +1378599*y**12-919940*y**13+375011*y**14-231984*y**15+50612*y**16+12416*y**17)
          -r**2*(-1+y)**10*(1370172+6610077*y+19247946*y**2+24997731*y**3+5722572*y**4
          -59492643*y**5-70334502*y**6-31819809*y**7+93436612*y**8-1030365*y**9
          +87397854*y**10-69290663*y**11-65519436*y**12+67050207*y**13-16510082*y**14
          +1501317*y**15-477312*y**16+140324*y**17)-r**4*(-1+y)**9*(-16073245
          -60736909*y-146892628*y**2+8994323*y**3+296660372*y**4+748617197*y**5
          -312848402*y**6+1044431997*y**7-534126016*y**8-2560931319*y**9+2304959096*y**10
          -551987099*y**11+445905680*y**12-511040957*y**13+196247022*y**14-19065173*y**15
          -2591815*y**16+597876*y**17)-r**6*(-1+y)**8*(59155536+56758526*y+362270*y**2
          -935574373*y**3+600497624*y**4-52389165*y**5-6388140350*y**6+3721501455*y**7
          +1020622116*y**8+21085779187*y**9-37831516158*y**10+24019915857*y**11
          -6056841360*y**12+306660857*y**13-33117986*y**14+68486437*y**15-13997308*y**16
          +1396835*y**17)-r**18*(-1+y)**2*(-563871972552+3026969278116*y-6398805339618*y**2
          +4995173083431*y**3+1822886488056*y**4-4712964512131*y**5+408556620198*y**6
          +3136953603019*y**7-2237403711792*y**8+544433606913*y**9-42207981302*y**10
          +16374537381*y**11-2439896184*y**12-5972065289*y**13+2692073906*y**14
          -370674615*y**15+16511480*y**16+1710983*y**17)-r**8*(-1+y)**7*(2166734484
          +2200719118*y+1803243996*y**2-29336499767*y**3-2376515452*y**4+4303711537*y**5
          +168740468874*y**6-289179560613*y**7+185693616134*y**8-84207990621*y**9
          +87043045504*y**10-74471258457*y**11+28879759888*y**12-2677228617*y**13
          -1283928902*y**14+386437525*y**15-35909710*y**16+2347079*y**17)-r**16*(
          -1+y)**3*(-57537973262+186492436010*y-159487190214*y**2-223444785491*y**3
          +2844774851198*y**4-7848811299123*y**5+9186165773716*y**6-4151708197453*y**7
          -1003310631408*y**8+1887913734659*y**9-685473061118*y**10-20435585397*y**11
          +69687407558*y**12-11264921501*y**13-1562071632*y**14+641587253*y**15
          -52494854*y**16+3013059*y**17)-r**10*(-1+y)**6*(-144823392-2258501830*y
          -3095131238*y**2+122064034897*y**3-206662190128*y**4+108354603543*y**5
          -571047455894*y**6+1486233554405*y**7-1586328591984*y**8+775755860791*y**9
          -102192497010*y**10-55781110237*y**11+19671172224*y**12+1311080037*y**13
          -1635030738*y**14+353925159*y**15-36214464*y**16+3659859*y**17)-r**14*(
          -1+y)**4*(-26833039728+54845054918*y-49041621810*y**2+1396520062091*y**3
          -6259801931224*y**4+10415504225687*y**5-7441546866086*y**6+954121987319*y**7
          +1912420083148*y**8-1220940314817*y**9+214638475810*y**10+64346202513*y**11
          -44036360528*y**12+13056911461*y**13-2736073034*y**14+527428781*y**15
          -56551220*y**16+4974719*y**17)-r**12*(-1+y)**5*(42766676724-76702881542*y
          +15886788844*y**2-514996722269*y**3+1907700590736*y**4-2230538614851*y**5
          +1285635681070*y**6-1358225928035*y**7+2012843468710*y**8-1527178541505*y**9
          +427487360072*y**10+100152327653*y**11-96795915460*y**12+22292993259*y**13
          -1512270306*y**14+58838555*y**15-26860006*y**16+5096351*y**17)-r**20*(
          -206103095058+1519240713906*y-4751922499164*y**2+7544045868627*y**3
          -5568207287967*y**4+617670090957*y**5+118112470617*y**6+3977210391579*y**7
          -6382359128719*y**8+4590054311089*y**9-1798373233035*y**10+352324714913*y**11
          +4617794419*y**12-17058687153*y**13-952673797*y**14+2107492561*y**15
          -431139411*y**16+22043041*y**17+1852595*y**18))-(-1+r**2+y)**6*(101*r**42*(
          -1+y)**12+r**40*(-1+y)**8*(-4187+16142*y-22698*y**2+14004*y**3-4347*y**4
          +606*y**5)-r**38*(-1+y)**6*(126830-732432*y+1755573*y**2-2216678*y**3
          +1494867*y**4-448996*y**5+13503*y**6+13570*y**7+195*y**8)-r**36*(-1
          +y)**4*(-19090626+147426528*y-494696175*y**2+943823968*y**3-1118923004*y**4
          +841888296*y**5-392484658*y**6+105547440*y**7-14252546*y**8+732152*y**9
          -52607*y**10+11536*y**11)-r**34*(-1+y)**2*(-456472969+4257036286*y
          -17707067004*y**2+43296751674*y**3-68714852693*y**4+73345148468*y**5
          -52429812024*y**6+23918818860*y**7-6016161767*y**8+355112422*y**9+187691232*y**10
          -38597430*y**11+2630437*y**12-389448*y**13+41076*y**14)+r**32*(94942969
          +594822906*y-11819906433*y**2+65671530344*y**3-209076060775*y**4+454259062522*y**5
          -722925253617*y**6+861414471328*y**7-763459059761*y**8+491120014390*y**9
          -220250541403*y**10+64543279672*y**11-10996524733*y**12+839496462*y**13
          -9541075*y**14-1482048*y**15+722684*y**16-50232*y**17)-(-1+y)**15*(
          -179-1611*y-8055*y**2-28891*y**3-43435*y**4+35485*y**5+117989*y**6
          +137817*y**7+20599*y**8-48993*y**9-10581*y**10-69233*y**11+47423*y**12
          -7753*y**13-12217*y**14+4755*y**15+1160*y**16+120*y**17)-r**2*(-1+y)**14*(
          -8413-66230*y-293202*y**2-932462*y**3-999006*y**4+1863898*y**5+3385346*y**6
          +2544170*y**7-2247940*y**8-519362*y**9+731034*y**10-1692586*y**11+1930022*y**12
          -761778*y**13-154242*y**14+73646*y**15-27815*y**16-2800*y**17+120*y**18)
          +4*r**30*(-6045743890+65304149076*y-318509047386*y**2+922603250786*y**3
          -1764018496288*y**4+2350288247260*y**5-2255813430875*y**6+1597227008014*y**7
          -845511105548*y**8+327244735828*y**9-79668138943*y**10+3177390574*y**11
          +5015985592*y**12-1382903340*y**13+94764335*y**14-9928382*y**15+3413990*y**16
          -99960*y**17+16357*y**18)-r**4*(-1+y)**12*(-792130-4613328*y-15749235*y**2
          -29729632*y**3-44030756*y**4-24651528*y**5+101888616*y**6+70568600*y**7
          -69438368*y**8+51263408*y**9-146825950*y**10+56169520*y**11+56089492*y**12
          -23635752*y**13+14157232*y**14-22424392*y**15+6403442*y**16+146768*y**17
          -65223*y**18+2016*y**19)-r**6*(-1+y)**11*(60104466+272251530*y+750876237*y**2
          +764350775*y**3-377629340*y**4-3064884308*y**5-1615667432*y**6-1417231976*y**7
          +3067360512*y**8+1649180312*y**9+1706845218*y**10-2135005562*y**11-2372011476*y**12
          +2645968708*y**13-748985888*y**14+9782384*y**15+6874974*y**16+4563950*y**17
          -524135*y**18+14651*y**19)-2*r**20*(-1+y)**4*(719215966714-2996501212880*y
          +4246363848217*y**2+906655267820*y**3-7358202681528*y**4+3118785923476*y**5
          +5849259382398*y**6-5508021935112*y**7+241886543524*y**8+638410414072*y**9
          +667180374576*y**10-681665889276*y**11+164242028168*y**12+41525645892*y**13
          -31020657870*y**14+7682430864*y**15-1352241262*y**16+169837632*y**17
          -17865081*y**18+19656*y**19)-r**8*(-1+y)**10*(46104911+237821528*y
          +572520491*y**2+3416726530*y**3+2333859748*y**4+2282010936*y**5-2598039848*y**6
          +22284470752*y**7-4674212470*y**8-71649250416*y**9+80048194630*y**10
          -30256475588*y**11+9160772868*y**12-8361212360*y**13+3920111168*y**14
          -587024832*y**15-57111297*y**16+26134184*y**17-2442505*y**18+62370*y**19)
          -4*r**12*(-1+y)**8*(9417997250+5305769056*y+1561063392*y**2-122345675422*y**3
          +60654551958*y**4+27938358158*y**5+553342079559*y**6-1118560978524*y**7
          +849183472770*y**8-310532333820*y**9+137416591339*y**10-123231372586*y**11
          +60026693322*y**12-8748486874*y**13-3005589139*y**14+1449351608*y**15
          -303562724*y**16+38947240*y**17-4389119*y**18+88556*y**19)+4*r**28*(
          -8265869314+86464943232*y-411187476474*y**2+1176199825202*y**3-2280462438042*y**4
          +3231664299702*y**5-3532052507909*y**6+3039052513148*y**7-1969137810294*y**8
          +798990790324*y**9-28779786797*y**10-201106341898*y**11+137726632346*y**12
          -47772437458*y**13+9753790553*y**14-1112452496*y**15+14860920*y**16+10110600*y**17
          -802605*y**18+90060*y**19)-4*r**14*(-1+y)**7*(25371579566-16737238138*y
          -19481449624*y**2+150734443618*y**3-518279786446*y**4+537448199548*y**5
          -1071962140077*y**6+2945341764379*y**7-3829650761870*y**8+2302763395104*y**9
          -309412170901*y**10-360566979541*y**11+187204286278*y**12-20858633172*y**13
          -7724189815*y**14+2770790857*y**15-523422424*y**16+65822962*y**17-7651631*y**18
          +131727*y**19)-r**10*(-1+y)**9*(644839729+184754973*y-1003023621*y**2
          +8348278447*y**3+27216137580*y**4+14179007124*y**5-199120040008*y**6
          +250999835728*y**7-86842342698*y**8+263993206934*y**9-569449321930*y**10
          +444406777942*y**11-131666154548*y**12-4306165340*y**13+8280034432*y**14
          -303377368*y**15-392984127*y**16+77011221*y**17-7674729*y**18+176259*y**19)
          -2*r**18*(-1+y)**5*(567512742061-1724064235831*y+1305124849656*y**2
          +3802292800228*y**3-18130782703532*y**4+34101275295720*y**5-30024283018482*y**6
          +6493918692906*y**7+10274906521034*y**8-9639411175946*y**9+2987114842282*y**10
          +316194656782*y**11-476895191380*y**12+134972102888*y**13-24058451182*y**14
          +5712939782*y**15-1590966999*y**16+221024913*y**17-22204130*y**18+212030*y**19)
          +2*r**22*(-1+y)**3*(1224922700554-7684005251454*y+19604430523287*y**2
          -21935624216615*y**3+4373331515896*y**4+11865475662876*y**5-6181716030694*y**6
          -7216234528366*y**7+9446358555964*y**8-4120409664168*y**9+409123072016*y**10
          +451466590900*y**11-273276733144*y**12+58938957732*y**13-2845677242*y**14
          -1104116466*y**15+354730778*y**16-70839322*y**17+9648249*y**18+219219*y**19)
          -2*r**16*(-1+y)**6*(368664901763-733441440072*y+199408421016*y**2-2233974237736*y**3
          +9736526542972*y**4-12827305258644*y**5+5896526548022*y**6-527995524152*y**7
          +1600443084910*y**8-2320400068816*y**9+868178997594*y**10+174042299988*y**11
          -203440087372*y**12+56299909196*y**13-12849022950*y**14+4177811312*y**15
          -1331886913*y**16+193618208*y**17-20841570*y**18+290844*y**19)+2*r**24*(
          -1+y)**2*(208756643381-1702088486360*y+5805897498981*y**2-10390548355030*y**3
          +9160755433360*y**4+80992143796*y**5-10206813336158*y**6+13018381845724*y**7
          -8528127351582*y**8+2891926683736*y**9-268562749316*y**10-39203007596*y**11
          -73539864264*y**12+58184016580*y**13-19371413042*y**14+3200007884*y**15
          -280852191*y**16+2911304*y**17+1934127*y**18+370266*y**19)+2*r**26*(
          -296279962283+2914252634364*y-12768848746422*y**2+32256818553784*y**3
          -50693791422819*y**4+48852579449860*y**5-23466004112542*y**6-4693163214372*y**7
          +16272465958232*y**8-12827457543892*y**9+5910046655966*y**10-1668330017652*y**11
          +123648046216*y**12+139729875500*y**13-67748255338*y**14+13042487156*y**15
          -846849045*y**16-139696472*y**17+27929184*y**18-2109076*y**19+339651*y**20))))/(501645312000*logy**6*r**24*(
          -1+y)**12+250822656000*logy**5*r**20*(-1+y)**10*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+52254720000*logy**4*r**16*(-1+y)**8*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+5806080000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +362880000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**4+12096000*logy*r**4*(-1+y)**2*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**5+168000*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**6))
      resNP += ((rhoLS*(2612736000*logy**6*r**20*(
          -96+528*r**2+1497*r**4+2131*r**6+1891*r**8+993*r**10+216*r**12)*(-1
          +y)**12+12441600*logy**5*r**16*(-1+y)**8*(-46092*r**20*(-1+y)**4+r**18*(69649
          -278596*y+417894*y**2-374356*y**3+168769*y**4-28560*y**5)+r**16*(665303
          -2389052*y+3039258*y**2-1723982*y**3+274283*y**4+63630*y**5-2520*y**6)
          -16*(-1+y)**5*(131+131*y+131*y**2-1689*y**3+1426*y**4-380*y**5+40*y**6)
          +8*r**2*(-1+y)**4*(-3306+18760*y**3-29295*y**4+14406*y**5-2800*y**6
          +240*y**7)-15*r**14*(-84865+256048*y-217248*y**2-9420*y**3+99977*y**4
          -36064*y**5-1316*y**6+448*y**7)+5*r**4*(-1+y)**3*(8537+15655*y-12096*y**2
          -102550*y**3+204771*y**4-166901*y**5+64148*y**6-10252*y**7+704*y**8)
          +7*r**12*(121479-145536*y-462456*y**2+979894*y**3-620211*y**4+51000*y**5
          +83860*y**6-28530*y**7+4300*y**8)+7*r**10*(-61327+628888*y-1710492*y**2
          +1888088*y**3-763852*y**4-181276*y**5+262994*y**6-82296*y**7+7249*y**8
          +1584*y**9)-7*r**8*(181977-997368*y+2034972*y**2-1878238*y**3+625072*y**4
          +177738*y**5-147062*y**6-24052*y**7+42393*y**8-12552*y**9+720*y**10)
          +r**6*(-1042023+4833372*y-8580618*y**2+7285192*y**3-3383418*y**4+2336068*y**5
          -3176502*y**6+2702248*y**7-1236947*y**8+287648*y**9-25660*y**10+640*y**11))
          -103680*logy**4*r**12*(-1+y)**6*(-1+r**2+y)**2*(533928*r**24*(-1+y)**6
          -r**22*(-1+y)**2*(-4481155+18992476*y-31158354*y**2+22912396*y**3-7899139*y**4
          +1092336*y**5)-r**20*(-1+y)**2*(-33414487+116032914*y-145416170*y**2
          +61190100*y**3+7467545*y**4-9122198*y**5+706296*y**6)-96*(-1+y)**7*(
          -249-747*y-1494*y**2-60*y**3-915*y**4-181*y**5+3402*y**6-2216*y**7
          +360*y**8)+r**18*(-57590108+282202508*y-515725647*y**2+482274470*y**3
          -270078213*y**4+122193888*y**5-77525973*y**6+51655942*y**7-18790035*y**8
          +2441568*y**9)+8*r**2*(-1+y)**5*(12805+18781*y+24757*y**2-44827*y**3
          -114601*y**4+124715*y**5+333819*y**6-825957*y**7+635652*y**8-199824*y**9
          +22080*y**10)+r**16*(-409756812+2097066948*y-4209470793*y**2+4220654446*y**3
          -1980602099*y**4-222388*y**5+444895557*y**6-186492442*y**7+29173699*y**8
          -3145756*y**9+268440*y**10)+r**4*(-1+y)**4*(-1471501-1510288*y-953200*y**2
          +589988*y**3+19374926*y**4-22408864*y**5-14560212*y**6+47936260*y**7
          -41571053*y**8+18187184*y**9-4062200*y**10+348160*y**11)-r**14*(811929082
          -4152513192*y+8399974701*y**2-8459437086*y**3+3829178270*y**4+402605570*y**5
          -1384143820*y**6+697506014*y**7-171341804*y**8+27482670*y**9-4136197*y**10
          +526992*y**11)+r**6*(-1+y)**3*(40330793-50488703*y+9642744*y**2-160201560*y**3
          +450953386*y**4-500624654*y**5+292795284*y**6-117100044*y**7+53910265*y**8
          -27985271*y**9+9892936*y**10-1837496*y**11+107520*y**12)-r**8*(-1+y)**2*(90558172
          -150834868*y+31828875*y**2-439306272*y**3+1566091048*y**4-2165991576*y**5
          +1553412454*y**6-582640712*y**7+82222532*y**8+10345972*y**9-2370841*y**10
          -864896*y**11+242112*y**12)+r**12*(-851131370+4324272284*y-8755697655*y**2
          +9004557194*y**3-4698418908*y**4+840799960*y**5+123736250*y**6+141836096*y**7
          -169371854*y**8+30935188*y**9+16028705*y**10-7177274*y**11+689784*y**12)
          +r**10*(-482015388+2382099732*y-4740407361*y**2+5191615938*y**3-4315851001*y**4
          +4289636440*y**5-4507306890*y**6+3376334596*y**7-1500183182*y**8+297036916*y**9
          +33533163*y**10-29542502*y**11+5435555*y**12-386016*y**13))+6912*logy**3*r**8*(
          -1+y)**4*(-1+r**2+y)**3*(-93282*r**30*(-1+y)**8+r**28*(-1+y)**4*(-3887405
          +15829466*y-24443814*y**2+16810496*y**3-5203949*y**4+613326*y**5)+r**26*(
          -1+y)**2*(-79536364+457124565*y-1089061278*y**2+1364053657*y**3-938468880*y**4
          +330901839*y**5-42582870*y**6-2274717*y**7+81648*y**8)-r**24*(-1+y)**2*(245510330
          -1422708153*y+3459321252*y**2-4298457529*y**3+2752865590*y**4-718218515*y**5
          -115975912*y**6+125506333*y**7-30373356*y**8+2495160*y**9)+24*(-1+y)**10*(701
          +3505*y+10515*y**2+14535*y**3+6485*y**4-20217*y**5-9255*y**6-4415*y**7
          +20390*y**8-9260*y**9+1016*y**10)+r**22*(-1+y)**2*(-1040618708+4925020191*y
          -9206395518*y**2+7174848055*y**3+129228200*y**4-3912166087*y**5+2426579494*y**6
          -544632667*y**7+37619160*y**8-5687940*y**9+911820*y**10)+6*r**2*(-1
          +y)**8*(19307+66333*y+149490*y**2-83370*y**3-53290*y**4-355114*y**5
          +71034*y**6+150930*y**7-23805*y**8-172735*y**9+305432*y**10-175092*y**11
          +30880*y**12)+r**4*(-1+y)**7*(-3886355-6736468*y-9368403*y**2+25065846*y**3
          -3619900*y**4+10539770*y**5-13117244*y**6-12770814*y**7+22931523*y**8
          +2693050*y**9-19743865*y**10+12739912*y**11-3523308*y**12+392256*y**13)
          +r**20*(3617112973-23678333237*y+63966563182*y**2-94232552674*y**3+83260992080*y**4
          -45918782356*y**5+17428034584*y**6-6852389574*y**7+3182420893*y**8-444628955*y**9
          -642082342*y**10+383510128*y**11-75070458*y**12+4197756*y**13)+r**8*(
          -1+y)**5*(-258365750-8390931*y-16564707*y**2+1104137927*y**3-764036169*y**4
          -80625930*y**5-1629780818*y**6+4222300714*y**7-4278971584*y**8+2276088553*y**9
          -617300395*y**10+46117399*y**11+14827543*y**12-3192468*y**13+224616*y**14)
          +r**6*(-1+y)**6*(30734856+35211279*y+40072242*y**2-240910325*y**3+66904708*y**4
          +78114378*y**5+420919452*y**6-1001538494*y**7+866028900*y**8-373800781*y**9
          +95789466*y**10-28317181*y**11+11058152*y**12-2516700*y**13+234048*y**14)
          +r**12*(-1+y)**3*(-3121753741+6957397121*y-3910842190*y**2+16549206860*y**3
          -61529702565*y**4+96720752447*y**5-80791599742*y**6+34898176620*y**7
          -3120692515*y**8-4259703905*y**9+2155210694*y**10-465901904*y**11+56130645*y**12
          -4685895*y**13+308070*y**14)+2*r**14*(-1+y)**2*(6479737175-29573987373*y
          +53073276507*y**2-51714488374*y**3+36112876755*y**4-27761600700*y**5
          +23881556761*y**6-14776172534*y**7+3985234643*y**8+1055104875*y**9-1086107875*y**10
          +274243012*y**11-14678273*y**12-2948394*y**13+333795*y**14)-r**10*(-1
          +y)**4*(-2118653360+3755012759*y-1539616728*y**2+7667221622*y**3-24781450328*y**4
          +33256863455*y**5-23784617568*y**6+9807729276*y**7-2821585084*y**8+1098603641*y**9
          -482257520*y**10+85563734*y**11+18306652*y**12-8516263*y**13+695712*y**14)
          -2*r**18*(-7041236765+46833573946*y-129871940678*y**2+193823579083*y**3
          -159905286786*y**4+52215510475*y**5+30530375878*y**6-44020825764*y**7
          +22572801529*y**8-5645985718*y**9+420802240*y**10+114357401*y**11-22270458*y**12
          -4030287*y**13+1079904*y**14)-2*r**16*(-9653329254+64496151693*y-181109448432*y**2
          +276410874483*y**3-237580982937*y**4+87400648945*y**5+38977324394*y**6
          -67741745526*y**7+38067721234*y**8-9814829401*y**9-200396718*y**10+1163799163*y**11
          -551613667*y**12+161825283*y**13-27950412*y**14+1951152*y**15))-144*logy**2*r**4*(
          -1+y)**3*(-1+r**2+y)**4*(2592*r**36*(-1+y)**9-r**34*(-1+y)**5*(-732203
          +2939180*y-4434690*y**2+2872076*y**3-778667*y**4+68064*y**5)+r**32*(
          -1+y)**3*(67864149-396691466*y+961743891*y**2-1231450080*y**3+880942939*y**4
          -342265890*y**5+63218445*y**6-3942932*y**7+241104*y**8)+64*(-1+y)**12*(31
          +217*y+868*y**2+2327*y**3+4237*y**4+4165*y**5-3037*y**6-9269*y**7
          -3302*y**8+5688*y**9+7379*y**10-7480*y**11+1676*y**12)+r**30*(-1131778059
          +9887179379*y-38294854658*y**2+86041471410*y**3-123373067658*y**4+117071261370*y**5
          -73670751648*y**6+29777516352*y**7-7034387715*y**8+688407723*y**9+54066874*y**10
          -15642826*y**11+579456*y**12)+r**28*(-9596222845+79141058273*y-287106050230*y**2
          +595877961182*y**3-768670717706*y**4+620925417838*y**5-289433960496*y**6
          +47701907280*y**7+22811747539*y**8-14427693399*y**9+3021192622*y**10
          -265185142*y**11+22023980*y**12-1478896*y**13)+8*r**2*(-1+y)**10*(12197
          +61977*y+188907*y**2+215335*y**3-143710*y**4-983154*y**5-156914*y**6
          +144446*y**7+1349325*y**8-1284615*y**9+505607*y**10+36987*y**11-167228*y**12
          +52840*y**13)-r**26*(8772222247-74756456751*y+287964514416*y**2-623896724216*y**3
          +794839101327*y**4-550388026623*y**5+91382341360*y**6+182217864528*y**7
          -180980552251*y**8+83951353635*y**9-21732949264*y**10+2566999736*y**11
          +115511061*y**12-57281093*y**13+2081888*y**14)-r**4*(-1+y)**9*(6571709
          +24262420*y+56826178*y**2+11216156*y**3-77495173*y**4-202147400*y**5
          +136748820*y**6+31218584*y**7+145135243*y**8-251375884*y**9+111710298*y**10
          +8596460*y**11-15013187*y**12+898976*y**13+382032*y**14+32768*y**15)
          +r**24*(-55826562625+383485315189*y-1108465439748*y**2+1600572128256*y**3
          -810607868501*y**4-998590942515*y**5+2087712223880*y**6-1606937928056*y**7
          +553291939261*y**8+11239620935*y**9-80787048332*y**10+29603266056*y**11
          -5212902071*y**12+567938183*y**13-47151784*y**14+3411872*y**15)+r**10*(
          -1+y)**6*(5531008243+4144048567*y+3958384069*y**2-43374863215*y**3
          +31645260739*y**4-122133241*y**5+50921705077*y**6-143791216303*y**7+153557756585*y**8
          -82891341003*y**9+23589499183*y**10-4195474925*y**11+1130663809*y**12
          -326889395*y**13+38009239*y**14-762485*y**15+89056*y**16)+r**6*(-1+y)**8*(31656619
          +102551029*y+221141170*y**2-204201946*y**3-153020095*y**4-588197785*y**5
          +760996260*y**6-137368660*y**7-232390603*y**8-167671525*y**9+535717818*y**10
          -399343842*y**11+172439615*y**12-65560151*y**13+22155920*y**14-4062352*y**15
          +214528*y**16)+r**12*(-1+y)**5*(-26921637129+16467594704*y+735511748*y**2
          +111807807240*y**3-150478678787*y**4+100572544884*y**5-217625086834*y**6
          +433779364844*y**7-468469544255*y**8+284879065944*y**9-86227074136*y**10
          +915822176*y**11+7789761883*y**12-2253554460*y**13+250655718*y**14-10661844*y**15
          +252304*y**16)+r**8*(-1+y)**7*(-866071765-1306716058*y-1696189561*y**2
          +6474525564*y**3-1464570385*y**4+1098981778*y**5-7393173645*y**6+6068297032*y**7
          -142245143*y**8+1459909210*y**9-5143890531*y**10+4170516924*y**11-1395614371*y**12
          +126434254*y**13+40537225*y**14-10425632*y**15+639104*y**16)-r**18*(
          -1+y)**2*(-616933868855+3276345328641*y-6998328902523*y**2+7866733282397*y**3
          -4543820186755*y**4+173347565429*y**5+1889072726585*y**6-1448300307119*y**7
          +411944248891*y**8+65689274435*y**9-122667565713*y**10+69817614007*y**11
          -20102541633*y**12+918952487*y**13+864602995*y**14-148213061*y**15+3301792*y**16)
          +r**22*(316201651969-2220598097545*y+6523449202658*y**2-10445605326090*y**3
          +9696921791371*y**4-4773517813611*y**5+423853189328*y**6+902190479744*y**7
          -610755305585*y**8+327250910473*y**9-235907229550*y**10+128844625734*y**11
          -35475709627*y**12+2638296075*y**13+570060956*y**14-88743708*y**15+3377408*y**16)
          +r**14*(-1+y)**4*(157602663519-371469793547*y+244924014844*y**2-543054897396*y**3
          +1967302784873*y**4-3187198882053*y**5+2713169331610*y**6-1136914210658*y**7
          +24051374897*y**8+202525246059*y**9-94932737096*y**10+21686577376*y**11
          -2772092761*y**12-378832251*y**13+345230418*y**14-70969770*y**15+4631936*y**16)
          +r**16*(-1+y)**3*(-118402399745+269793814146*y-137813927535*y**2+925472528048*y**3
          -3735305588385*y**4+6242624561414*y**5-5592466615159*y**6+2564435552060*y**7
          -52232092571*y**8-640040265010*y**9+355662467467*y**10-80859905960*y**11
          +3339502925*y**12+1968245098*y**13-297748805*y**14-19404036*y**15+5260048*y**16)
          +r**20*(781563355607-5645783849843*y+17227210583406*y**2-28628690463558*y**3
          +26451004997405*y**4-9044389863241*y**5-8731691048176*y**6+13914359095920*y**7
          -8645595320719*y**8+2349228255235*y**9+310760408446*y**10-479415273734*y**11
          +167179253987*y**12-27905546023*y**13+2556065060*y**14-489876612*y**15
          +104114328*y**16-4887488*y**17))-24*logy*r**2*(-1+y)**2*(-1+r**2+y)**5*(923*r**38*(
          -1+y)**10+r**36*(-1+y)**6*(173504-667527*y+950620*y**2-510528*y**3
          +62864*y**4+15907*y**5)+r**34*(-1+y)**4*(40095491-232627541*y+558027030*y**2
          -699791825*y**3+486118938*y**4-185621919*y**5+36215646*y**6-2936155*y**7
          +51759*y**8)-r**32*(-1+y)**2*(-1334429812+10053600758*y-32839909174*y**2
          +60427169027*y**3-68219271624*y**4+48234161438*y**5-20779092008*y**6
          +4920864164*y**7-445991516*y**8-19185084*y**9+1016182*y**10+16449*y**11)
          +4*(-1+y)**14*(29+261*y+1305*y**2+2993*y**3-1434*y**4-26658*y**5
          -36898*y**6-7722*y**7+37641*y**8+32689*y**9-17991*y**10-3783*y**11
          -6828*y**12+3996*y**13)+r**30*(9785182676-90320801374*y+372191636954*y**2
          -895316033399*y**3+1380833636287*y**4-1409273404821*y**5+940316363171*y**6
          -377368791438*y**7+59832878674*y**8+19626822976*y**9-12971576120*y**10
          +2974048453*y**11-328085621*y**12+18250995*y**13-415413*y**14)+r**28*(54563744832
          -471877662174*y+1803273271278*y**2-3948277576733*y**3+5333386263988*y**4
          -4343282050848*y**5+1662549658494*y**6+423661031101*y**7-872498083512*y**8
          +465467934570*y**9-119403664966*y**10+12299550685*y**11+189398116*y**12
          -57577420*y**13+8083642*y**14-842653*y**15)-r**26*(50455174124-410759470190*y
          +1390542273906*y**2-2660934814129*y**3+3352380225803*y**4-3195244446668*y**5
          +2638247080130*y**6-1959543904363*y**7+1196307645923*y**8-523115434430*y**9
          +123030680766*y**10+16059971513*y**11-24611566383*y**12+8268886616*y**13
          -1106994738*y**14+27848963*y**15+203157*y**16)+r**2*(-1+y)**11*(86621
          +495338*y+1660229*y**2+3153714*y**3+1880079*y**4-6775008*y**5-16933865*y**6
          -7271260*y**7+23433647*y**8+9017562*y**9-1384037*y**10-25106054*y**11
          +19252473*y**12-4169636*y**13-454391*y**14+191024*y**15+5356*y**16+6208*y**17)
          +r**4*(-1+y)**10*(-2796928-13222445*y-37857330*y**2-29330099*y**3+43541040*y**4
          +184364479*y**5-30020970*y**6-35322283*y**7-205808352*y**8+313348805*y**9
          -152627334*y**10-50879265*y**11+84124896*y**12-30907299*y**13+2421730*y**14
          +1534783*y**15-567920*y**16+100492*y**17)+r**6*(-1+y)**9*(105027301
          +354471141*y+771849440*y**2-117590695*y**3-1253893588*y**4-2658896597*y**5
          +3008279598*y**6+73695175*y**7+1180302056*y**8-3240732433*y**9+1597584572*y**10
          +207482927*y**11-171150544*y**12-99274411*y**13+49984246*y**14+1916849*y**15
          -3038441*y**16+447404*y**17)+r**8*(-1+y)**8*(-356481232-1149062710*y
          -2454668686*y**2+3516344957*y**3+1031760012*y**4+5312638505*y**5-11553804626*y**6
          +6103497897*y**7+3175346400*y**8-1721993335*y**9-5589275650*y**10+7039768631*y**11
          -3869201012*y**12+1415963243*y**13-444812702*y**14+110553827*y**15-15383720*y**16
          +1194201*y**17)+r**24*(326062289200-2432220540930*y+7660856033990*y**2
          -12349946476609*y**3+8157559650404*y**4+5747563441195*y**5-16774086703350*y**6
          +14539191948547*y**7-4553835588880*y**8-1983749670901*y**9+2511070023242*y**10
          -1025588059603*y**11+181596577028*y**12-452530111*y**13-4378066778*y**14
          +331884113*y**15+28852408*y**16+1641035*y**17)+r**10*(-1+y)**7*(9998601516
          +11466367026*y+12388454232*y**2-73551478169*y**3+36719377100*y**4-4603014253*y**5
          +62184416818*y**6-90341562551*y**7+45279538114*y**8-31884433259*y**9
          +58210782524*y**10-51315019503*y**11+18775374832*y**12-776999795*y**13
          -1473949766*y**14+453512063*y**15-54647466*y**16+3080537*y**17)+r**20*(
          -1+y)**2*(-2410182086976+14479520100516*y-35161358210070*y**2+43211156385589*y**3
          -21035769724460*y**4-15930094785557*y**5+34974143987738*y**6-25733076660339*y**7
          +6935786869644*y**8+2807575497707*y**9-3020618235426*y**10+1025929248903*y**11
          -120271767940*y**12-18093267783*y**13+6593734878*y**14-730106441*y**15
          +40175268*y**16+4396749*y**17)+r**12*(-1+y)**6*(-35388750656-10478823314*y
          -9469353170*y**2+298971849907*y**3-317909923436*y**4+100828347185*y**5
          -332402662954*y**6+1034707904731*y**7-1358573862220*y**8+898584862261*y**9
          -270099556198*y**10-4895646831*y**11+25965207372*y**12-5373475637*y**13
          -658694750*y**14+519996769*y**15-99062676*y**16+7291617*y**17)+r**18*(
          -1+y)**3*(-140221580402+1135783649486*y-2383584810750*y**2-1708190375421*y**3
          +12889956702034*y**4-20422291410001*y**5+15943622585600*y**6-5532211954767*y**7
          -1265068204040*y**8+2262814357805*y**9-851120596814*y**10+5821069245*y**11
          +53022647642*y**12+5960985961*y**13-7478105364*y**14+1187600367*y**15
          -67002706*y**16+8090125*y**17)+r**14*(-1+y)**5*(131010316588-171025819610*y
          +38480246560*y**2-398132413423*y**3+718835369872*y**4-851184668989*y**5
          +1663701263230*y**6-2506586205481*y**7+2357915085202*y**8-1360390899543*y**9
          +357688667820*y**10+71082626631*y**11-78928640572*y**12+19678356021*y**13
          -1549431754*y**14+211224081*y**15-100091026*y**16+12006393*y**17)+r**16*(
          -1+y)**4*(-736675096904+2143881295802*y-1925247368622*y**2+2683948183925*y**3
          -9895020549996*y**4+18605739023349*y**5-17919612506634*y**6+7672903557841*y**7
          +1660570369632*y**8-3816548669131*y**9+1929807564046*y**10-369635936241*y**11
          -48532638284*y**12+40772897343*y**13-8394565398*y**14+803695659*y**15
          -89352352*y**16+12367965*y**17)+r**22*(-1834630518110+13749976262542*y
          -43456725184760*y**2+74443864581341*y**3-70706869676909*y**4+26748766696187*y**5
          +16743247818667*y**6-26611917425555*y**7+13217857121363*y**8-1647209746817*y**9
          -823713284569*y**10+6632063535*y**11+227421537945*y**12-41002514439*y**13
          -25490622799*y**14+11474917767*y**15-1791750369*y**16+106640895*y**17
          +3084085*y**18))-(-1+r**2+y)**6*(97*r**42*(-1+y)**12+r**40*(-1+y)**8*(
          -3647+14006*y-19554*y**2+14500*y**3-6367*y**4+1542*y**5)+r**38*(-1
          +y)**6*(91602-506160*y+1126431*y**2-1379010*y**3+1082033*y**4-584764*y**5
          +229533*y**6-62554*y**7+9321*y**8)+r**36*(-1+y)**4*(16839810-131060544*y
          +444512139*y**2-846319648*y**3+977001268*y**4-690734904*y**5+285187362*y**6
          -57653808*y**7+613450*y**8+1779864*y**9-261197*y**10+26512*y**11)+r**34*(
          -1+y)**2*(1737281005-16507899190*y+70094485548*y**2-174654065362*y**3
          +282338730097*y**4-309415329108*y**5+233433435208*y**6-120632581004*y**7
          +41639323235*y**8-9122752430*y**9+1166887088*y**10-82362002*y**11+5104223*y**12
          -404440*y**13+24252*y**14)+r**32*(23384471357-258146115966*y+1294778597259*y**2
          -3888625242376*y**3+7756154989173*y**4-10760321677102*y**5+10544120254835*y**6
          -7214905764624*y**7+3266779582715*y**8-810571186706*y**9-9962871239*y**10
          +79091000360*y**11-24810338297*y**12+3153813686*y**13-120281687*y**14
          +385264*y**15+524396*y**16-64248*y**17)-(-1+y)**15*(-31-279*y-1395*y**2
          -20807*y**3-110687*y**4-326455*y**5-352079*y**6-13611*y**7+306083*y**8
          +261867*y**9-133305*y**10+66011*y**11-53933*y**12-53141*y**13+27355*y**14
          +951*y**15+232*y**16+24*y**17)-4*r**30*(-20721824950+219410625300*y
          -1054168176786*y**2+3010276845098*y**3-5619409609000*y**4+7079987335660*y**5
          -5922544093689*y**6+2938485861830*y**7-358355239352*y**8-625301420300*y**9
          +516579351887*y**10-208007999018*y**11+51448148864*y**12-8760105292*y**13
          +1196342165*y**14-120652262*y**15+5247062*y**16-620808*y**17+50791*y**18)
          -r**2*(-1+y)**13*(18065+123485*y+483452*y**2+1357756*y**3+2413528*y**4
          +3135600*y**5+4491368*y**6-1427160*y**7-8299218*y**8-6379042*y**9+713060*y**10
          +7314884*y**11-688056*y**12+2167728*y**13-4351360*y**14+1819200*y**15
          -177887*y**16-24411*y**17-3016*y**18+24*y**19)-r**4*(-1+y)**12*(3421598
          +18345264*y+57904401*y**2+94620048*y**3+9019236*y**4-329389512*y**5
          -579379744*y**6-112775576*y**7+959916056*y**8-15309616*y**9-103155566*y**10
          -667132864*y**11+667642220*y**12-175246184*y**13-31794568*y**14+17573480*y**15
          -1465606*y**16+188080*y**17-67195*y**18+1248*y**19)-r**6*(-1+y)**11*(
          -84581070-374124342*y-1012435455*y**2-523923997*y**3+1265305212*y**4
          +4168254084*y**5-3433332304*y**6-334171024*y**7-2428855032*y**8+8025904096*y**9
          -5262058830*y**10-2025627322*y**11+3982063348*y**12-1765380084*y**13
          +173037384*y**14+95714456*y**15-39824042*y**16+6895046*y**17-645547*y**18
          +15823*y**19)-4*r**28*(-123067959014+1244512714776*y-5654985927090*y**2
          +15065801917658*y**3-25593774094194*y**4+27705970434198*y**5-16551249339919*y**6
          +1365785784*y**7+9595680419910*y**8-9009386607848*y**9+4257804819157*y**10
          -969276945994*y**11-34721379662*y**12+86608430182*y**13-24509871781*y**14
          +3490039404*y**15-267372768*y**16+5416788*y**17-564655*y**18+17868*y**19)
          -r**8*(-1+y)**10*(2184361635+6675496728*y+13447523583*y**2-8726747926*y**3
          -26343452892*y**4-44769349496*y**5+73438419672*y**6-6922601936*y**7+9383864226*y**8
          -48565503648*y**9+23412313726*y**10+5115997276*y**11+2540109092*y**12
          -8441921880*y**13+3418228256*y**14-83121360*y**15-216711821*y**16+44038616*y**17
          -3662965*y**18+100314*y**19)-4*r**12*(-1+y)**8*(39118238986+25021479464*y
          +14980415268*y**2-279546161018*y**3+199791359202*y**4-19095462446*y**5
          +167319474139*y**6-341751210368*y**7+282732769762*y**8-229156911288*y**9
          +250618680035*y**10-175047470054*y**11+49167495038*y**12+6973444866*y**13
          -8211591879*y**14+2470844620*y**15-560425804*y**16+94112732*y**17-9085915*y**18
          +244660*y**19)-2*r**18*(-1+y)**5*(-2578034427199+8934298706557*y-10339958247264*y**2
          +12936205032756*y**3-43950650599788*y**4+90163579643056*y**5-93053287212490*y**6
          +39698122007642*y**7+13679900853882*y**8-25350116643634*y**9+11702764034474*y**10
          -1406338604122*y**11-605966367348*y**12+235842219552*y**13-37289749014*y**14
          +8339352374*y**15-2414993915*y**16+446563525*y**17-46555210*y**18+301366*y**19)
          -r**10*(-1+y)**9*(-4102961987-14797556391*y-32591632209*y**2+49845870083*y**3
          -37582501812*y**4+40094630148*y**5-80127153160*y**6+119418150048*y**7
          +15502307550*y**8-97295316914*y**9-64862354066*y**10+174801628382*y**11
          -103304295860*y**12+22195918420*y**13-1418361952*y**14+1191598200*y**15
          -766479411*y**16+152829441*y**17-13777333*y**18+386823*y**19)-4*r**14*(
          -1+y)**7*(-35590272506-4752203978*y-25828368500*y**2+509455880626*y**3
          -704672327234*y**4+470762900732*y**5-950058857545*y**6+2672566318739*y**7
          -4133303809654*y**8+3218167103724*y**9-968527425709*y**10-234166261297*y**11
          +243669787418*y**12-45092586932*y**13-9039552571*y**14+5102594513*y**15
          -1138913800*y**16+177279798*y**17-17271035*y**18+410811*y**19)+2*r**20*(
          -1+y)**4*(3606376262870-18007353774400*y+32281316656523*y**2-15842920368260*y**3
          -17750819501544*y**4+9365163340612*y**5+36038929072290*y**6-48828255292640*y**7
          +16898328636164*y**8+10217698755136*y**9-11546312222704*y**10+3956599335620*y**11
          -148898528904*y**12-300166201628*y**13+94046132590*y**14-13162826248*y**15
          +1306173270*y**16-213722024*y**17+30350229*y**18+555048*y**19)-2*r**16*(
          -1+y)**6*(615092258255-1206716666040*y+493462137552*y**2-632240541216*y**3
          +1558935438588*y**4-3428737582188*y**5+8626787301806*y**6-10920737829584*y**7
          +5473591344350*y**8+674753541496*y**9-2076012785910*y**10+860173452876*y**11
          -16839712876*y**12-64912849596*y**13+218935074*y**14+8915997768*y**15
          -2915732317*y**16+489221608*y**17-47569738*y**18+846492*y**19)+2*r**24*(
          -1+y)**2*(2976729939121-22568354561992*y+72700702928889*y**2-125289766241302*y**3
          +112084315570680*y**4-19440825718596*y**5-67640183108566*y**6+74425206119060*y**7
          -28039207094070*y**8-5847207630400*y**9+9781306783172*y**10-3493742796628*y**11
          +206277203728*y**12+195572459292*y**13-55160042778*y**14+5138061908*y**15
          -409278659*y**16+81159728*y**17-71565*y**18+885378*y**19)+2*r**22*(-1
          +y)**3*(12073807065850-75987262569822*y+193608804726795*y**2-246202876009475*y**3
          +125248102775688*y**4+70644037004772*y**5-151076575303686*y**6+90906587957290*y**7
          -10842007648732*y**8-15490389987208*y**9+8370516511312*y**10-1093152910036*y**11
          -202474222664*y**12-5382983300*y**13+33642889958*y**14-6719619914*y**15
          +142785314*y**16+15760774*y**17+10679877*y**18+1065207*y**19)+2*r**26*(
          -817311561615+8190066728508*y-36381834855174*y**2+94661250009952*y**3
          -159404979378943*y**4+178840172042300*y**5-128031981159350*y**6+43551887075540*y**7
          +16528822807360*y**8-31173396908220*y**9+20077341414182*y**10-7627885281900*y**11
          +1900170925616*y**12-385143446572*y**13+87287920558*y**14-15047364580*y**15
          +506347367*y**16+43037168*y**17+32544360*y**18-1240420*y**19+343863*y**20))))/(501645312000*logy**6*r**24*(
          -1+y)**12+250822656000*logy**5*r**20*(-1+y)**10*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+52254720000*logy**4*r**16*(-1+y)**8*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+5806080000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +362880000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**4+12096000*logy*r**4*(-1+y)**2*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**5+168000*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**6))
      resNP += ((rhoD*(2612736000*logy**6*r**18*(1440
          +5220*r**2+8460*r**4+9763*r**6+8577*r**8+5817*r**10+2979*r**12+648*r**14)*(
          -1+y)**13+12441600*logy**5*r**14*(-1+y)**8*(120444*r**22*(-1+y)**5+288*(
          -1+y)**7*(-188-376*y-564*y**2+788*y**3-205*y**4+20*y**5)+30*r**2*(
          -1+y)**6*(10009+10009*y+10009*y**2-42071*y**3+32052*y**4-7092*y**5
          +608*y**6)+3*r**20*(-142477+712385*y-1424770*y**2+1352530*y**3-655265*y**4
          +118957*y**5+5040*y**6)+2*r**4*(-1+y)**5*(-1455289+907200*y+453600*y**2
          +511140*y**3-1181775*y**4+711984*y**5-132860*y**6+9600*y**7)-3*r**18*(312083
          -1288255*y+1896110*y**2-676640*y**3-641435*y**4+720487*y**5-247590*y**6
          +22680*y**7)-9*r**16*(369431-1430095*y+1817540*y**2-186120*y**3-1340225*y**4
          +1150829*y**5-364350*y**6+33390*y**7)+r**6*(-1+y)**3*(-5720789+18018778*y
          -15586589*y**2-264670*y**3+4107845*y**4+1413104*y**5-2985003*y**6+1292064*y**7
          -184500*y**8+10560*y**9)+r**14*(-4249433+13917745*y-9511940*y**2-17242690*y**3
          +30733085*y**4-17096647*y**5+1914990*y**6+1617420*y**7-623070*y**8+86940*y**9)
          +7*r**12*(-508493+998605*y+1862440*y**2-7074880*y**3+7077170*y**4-1785454*y**5
          -1614300*y**6+1331160*y**7-356805*y**8+24045*y**9+4752*y**10)-7*r**10*(20579
          +1654445*y-7702240*y**2+13241490*y**3-9429060*y**4+217284*y**5+3836170*y**6
          -2258240*y**7+391255*y**8+75525*y**9-34968*y**10+2160*y**11)+r**8*(3776159
          -29540395*y+85729790*y**2-117413890*y**3+69090500*y**4+6778112*y**5
          -30700810*y**6+12699230*y**7+1562165*y**8-2680845*y**9+766884*y**10
          -68820*y**11+1920*y**12))+103680*logy**4*r**10*(-1+y)**6*(712296*r**30*(
          -1+y)**7-3*r**28*(-1+y)**2*(4422733-22113665*y+44227330*y**2-43246690*y**3
          +22600865*y**4-5631853*y**5+463200*y**6)-288*(-1+y)**11*(-783-3132*y
          -7830*y**2-5680*y**3+2905*y**4+16448*y**5-11468*y**6+1840*y**7)-r**26*(
          -1+y)**2*(116384117-509654185*y+838642370*y**2-566422550*y**3+57803365*y**4
          +121679503*y**5-53233500*y**6+5024880*y**7)-24*r**2*(-1+y)**9*(-117653
          -235306*y-352959*y**2+965508*y**3-17735*y**4+361558*y**5-1495999*y**6
          +1369544*y**7-509408*y**8+60800*y**9)-16*r**4*(-1+y)**8*(4007878+1977478*y
          +962278*y**2-28958142*y**3+32416698*y**4-8238948*y**5-2986753*y**6+7907*y**7
          +1668662*y**8-775968*y**9+92160*y**10)+3*r**24*(-28725171+115589997*y
          -47568291*y**2-612298235*y**3+1544181955*y**4-1735253709*y**5+1072456283*y**6
          -364419309*y**7+56410120*y**8-2224520*y**9+439680*y**10)-r**6*(-1+y)**7*(
          -145214707+180162000*y+90081000*y**2+663233260*y**3-1866491250*y**4
          +1411744224*y**5-152675780*y**6-289774020*y**7+127779825*y**8-6406960*y**9
          -7207272*y**10+1044480*y**11)+3*r**22*(3454271-211429697*y+1208015391*y**2
          -3128956685*y**3+4226254845*y**4-2951648211*y**5+732891237*y**6+400377469*y**7
          -409045580*y**8+154286740*y**9-30489700*y**10+3131520*y**11)+2*r**20*(
          -524499881+2674035467*y-5094014451*y**2+3614935945*y**3+699573410*y**4
          -1712577210*y**5-1021800830*y**6+2789218490*y**7-2021636595*y**8+682459365*y**9
          -86136189*y**10-6544977*y**11+2249856*y**12)+r**10*(-1+y)**4*(-775239013
          +5758190439*y-12880060539*y**2+9006360853*y**3+5978150130*y**4-13071565866*y**5
          +6565252618*y**6+635999862*y**7-1756276929*y**8+521226095*y**9+37853589*y**10
          -45312087*y**11+7044432*y**12+81216*y**13)-r**8*(-1+y)**5*(-1054550489
          +3855447778*y-4218390689*y**2-402779080*y**3+3176201090*y**4-171233932*y**5
          -2567838586*y**6+1574609648*y**7+69629615*y**8-389604590*y**9+143601451*y**10
          -14934032*y**11-2194344*y**12+322560*y**13)+2*r**14*(-1+y)**2*(841299343
          -4249712615*y+6762257980*y**2-379407560*y**3-9885290990*y**4+10050998914*y**5
          -1761524030*y**6-3007764260*y**7+1937935195*y**8-151029105*y**9-230985252*y**10
          +90466950*y**11-13446390*y**12+914220*y**13)-2*r**18*(183974231-12989717*y
          -3323522499*y**2+9626946565*y**3-10219945150*y**4+1211157258*y**5+6908263834*y**6
          -6145667392*y**7+1422340215*y**8+903779225*y**9-743324549*y**10+220457613*y**11
          -31013514*y**12+1660680*y**13)+r**12*(-1+y)**3*(-1273821209+2829589436*y
          +3484886646*y**2-14398334884*y**3+10551342361*y**4+5940325824*y**5-12545875156*y**6
          +5742580984*y**7+711494709*y**8-1539302876*y**9+518081270*y**10-44320020*y**11
          -10536045*y**12+2288160*y**13)+r**16*(708885074-7097866118*y+25526339454*y**2
          -41768966330*y**3+23311324100*y**4+24564831732*y**5-50678590424*y**6
          +33409790072*y**7-4732768950*y**8-6800375470*y**9+4684966594*y**10-1236914358*y**11
          +94406424*y**12+17662680*y**13-2724480*y**14))+6912*logy**3*r**6*(-1+y)**4*(
          -1+r**2+y)**2*(38394*r**34*(-1+y)**9-27*r**32*(-1+y)**4*(163073-818209*y
          +1644950*y**2-1600570*y**3+866365*y**4-241613*y**5+27764*y**6)+720*(
          -1+y)**13*(-23-138*y-483*y**2-986*y**3-1132*y**4+88*y**5+2113*y**6
          +1388*y**7-2649*y**8+772*y**9)+r**30*(-1+y)**2*(-165926615+1127631275*y
          -3268957767*y**2+5218311559*y**3-4978648387*y**4+2876715795*y**5-955405985*y**6
          +154329377*y**7-7373694*y**8+274842*y**9)+r**28*(-1+y)**2*(-1172228844
          +7664770408*y-21199732711*y**2+31449167685*y**3-26840971199*y**4+12785476985*y**5
          -2437960893*y**6-559259849*y**7+368705015*y**8-61686381*y**9+3858984*y**10)
          +30*r**2*(-1+y)**11*(-21457-86932*y-220090*y**2-93508*y**3+315540*y**4
          +900516*y**5-704700*y**6+111440*y**7-415097*y**8+430560*y**9-168044*y**10
          +29472*y**11)-r**26*(-1+y)**2*(5190297368-30313831044*y+72064137871*y**2
          -83798773009*y**3+40052065191*y**4+11640821935*y**5-25141348711*y**6
          +13065185229*y**7-2906907671*y**8+215974869*y**9-7360608*y**10+914580*y**11)
          +12*r**4*(-1+y)**9*(-3123551-5229627*y-6886128*y**2+31721196*y**3+10799995*y**4
          +7119202*y**5-138837616*y**6+170220266*y**7-73357652*y**8+1565305*y**9
          +7776024*y**10-1700082*y**11-114588*y**12+68256*y**13)+r**24*(-4466710695
          +31570332959*y-91305518085*y**2+114239311473*y**3+6337183848*y**4-218540601660*y**5
          +326692536102*y**6-256022151450*y**7+117723933189*y**8-26440229481*y**9
          -2418792845*y**10+3567469389*y**11-1098345690*y**12+166353738*y**13-8802792*y**14)
          +r**6*(-1+y)**8*(296883727+176688691*y+129704065*y**2-3328633121*y**3
          +3663417268*y**4-1581776084*y**5+4478918188*y**6-8106580880*y**7+5888037577*y**8
          -1545635611*y**9-275015593*y**10+243763421*y**11-36337260*y**12-3603156*y**13
          +1176768*y**14)+r**16*(-1+y)**3*(3330114609+59734738582*y-309800907315*y**2
          +511310002608*y**3-220018103079*y**4-321033182898*y**5+447418038861*y**6
          -151189308540*y**7-82759388721*y**8+85653984258*y**9-21723247981*y**10
          -2946573768*y**11+2589077355*y**12-457218462*y**13+18959271*y**14+401220*y**15)
          +r**8*(-1+y)**7*(-3547814851+3556941022*y+772414846*y**2+24730560590*y**3
          -64747602941*y**4+54236596936*y**5-9187819364*y**6-9782080472*y**7+2445315415*y**8
          +2939647522*y**9-1586047954*y**10+101690642*y**11+78666701*y**12-5438280*y**13
          -4219956*y**14+702144*y**15)+r**10*(-1+y)**6*(6230835960-15435543140*y
          +8086767453*y**2-33545221659*y**3+138605495419*y**4-194051613753*y**5
          +98529014670*y**6+22461080394*y**7-48144310542*y**8+18641946882*y**9
          +141753101*y**10-1881335655*y**11+380455503*y**12+26049551*y**13-15061176*y**14
          +1375992*y**15)-r**12*(-1+y)**5*(36198348204-145156156868*y+191530388897*y**2
          -33866013028*y**3-116798228598*y**4+39054778120*y**5+89590837231*y**6
          -70629897104*y**7-6381886364*y**8+26331093516*y**9-10382278837*y**10
          +478202812*y**11+545097482*y**12-83417408*y**13-7346343*y**14+1413288*y**15)
          -r**22*(-363514557+15338911639*y-104411016381*y**2+357518167089*y**3
          -709962347886*y**4+839862084990*y**5-553172279748*y**6+105239356512*y**7
          +151120495797*y**8-164413331043*y**9+84636059501*y**10-24810395241*y**11
          +3408453594*y**12+80097114*y**13-69108096*y**14+2398716*y**15)+2*r**18*(
          -1+y)**2*(-21099886066+93068931072*y-126317652044*y**2-35390882710*y**3
          +271330750034*y**4-290469161644*y**5+109468894991*y**6+25177151843*y**7
          -30165565030*y**8-3368349518*y**9+11997829296*y**10-5360504788*y**11
          +871299126*y**12+57276690*y**13-40075041*y**14+3914289*y**15)-r**14*(
          -1+y)**4*(-47969913227+266803269713*y-539646222628*y**2+377492748976*y**3
          +248748054775*y**4-611043365225*y**5+365922808834*y**6+9580557646*y**7
          -114022614377*y**8+49387407215*y**9-1980737084*y**10-3906904772*y**11
          +803336457*y**12+98836701*y**13-45404490*y**14+4059486*y**15)+2*r**20*(
          -19057980890+127469360920*y-342797224923*y**2+414488185487*y**3-54248473248*y**4
          -472854093738*y**5+571798693287*y**6-195658580199*y**7-156065397054*y**8
          +202362603676*y**9-90377197819*y**10+11591682651*y**11+5648882222*y**12
          -2775645408*y**13+529001397*y**14-57890553*y**15+4074192*y**16))+144*logy**2*r**4*(
          -1+y)**3*(-1+r**2+y)**3*(17664*r**38*(-1+y)**10+3*r**36*(-1+y)**5*(86827
          -416471*y+779950*y**2-904846*y**3+477623*y**4-130315*y**5+18912*y**6)
          +3*r**34*(-1+y)**3*(-13200678+90319017*y-263570919*y**2+417571109*y**3
          -393741655*y**4+229700699*y**5-80302325*y**6+14748487*y**7-1161575*y**8
          +90960*y**9)-3*r**32*(-710399962+6930173317*y-30330348978*y**2+78209082033*y**3
          -131778286642*y**4+152414703226*y**5-123690443748*y**6+70557404122*y**7
          -27732591998*y**8+7133249937*y**9-1073242874*y**10+70575061*y**11+120346*y**12
          +6160*y**13)+12*(-1+y)**13*(-1267-7602*y-26607*y**2-48344*y**3-72670*y**4
          -136236*y**5-428546*y**6+196904*y**7+1054713*y**8-1028130*y**9+46553*y**10
          +597648*y**11-471872*y**12+115456*y**13)+r**30*(26734318634-249321874529*y
          +1036474382196*y**2-2517544845279*y**3+3939048744264*y**4-4120314878880*y**5
          +2873480487648*y**6-1260829501662*y**7+273371156946*y**8+22514256751*y**9
          -30002165524*y**10+6972713181*y**11-607380564*y**12+26112498*y**13-1525680*y**14)
          +r**28*(87786022982-771240920375*y+2985118822662*y**2-6558925703529*y**3
          +8797885673775*y**4-7020664910478*y**5+2469360466917*y**6+1067318073606*y**7
          -1864241838324*y**8+1119279024181*y**9-378173585296*y**10+74073987363*y**11
          -8047843473*y**12+470755488*y**13+2247669*y**14-273168*y**15)+4*r**2*(
          -1+y)**11*(1826036+6696581*y+15520625*y**2+3283915*y**3-42264029*y**4
          -105864590*y**5+28724218*y**6+177550930*y**7+163992310*y**8-518488407*y**9
          +341531037*y**10-56546949*y**11-29118005*y**12+15705400*y**13-3038864*y**14
          +321792*y**15)+r**4*(-1+y)**10*(-222248243-593532669*y-1080935514*y**2
          +2016822234*y**3+3208684383*y**4+3419358561*y**5-16068074148*y**6+12478246788*y**7
          -4858526013*y**8+4002824269*y**9-3380558178*y**10+1106177538*y**11+82514401*y**12
          -113546721*y**13+13228848*y**14+1730160*y**15+98304*y**16)+r**26*(307003365098
          -2479369589489*y+8603228527332*y**2-16149762291349*y**3+16152004607374*y**4
          -4198381351617*y**5-10305607351272*y**6+15109603938003*y**7-10073521547370*y**8
          +3514982357869*y**9-338648708188*y**10-225484202607*y**11+100721949010*y**12
          -18571336411*y**13+1893404352*y**14-95599023*y**15+3828288*y**16)+3*r**18*(
          -1+y)**3*(-559028146818+2293140400191*y-2800396302945*y**2-973699126477*y**3
          +5742124931475*y**4-6242889767705*y**5+3578254895671*y**6-1603837405661*y**7
          +1045385025359*y**8-701846577275*y**9+187441245909*y**10+106430452945*y**11
          -106266150943*y**12+37029841893*y**13-5507510475*y**14+10627289*y**15
          +51846143*y**16+249424*y**17)-r**6*(-1+y)**9*(-6504798074-8205632689*y
          -8574220485*y**2+70648876890*y**3-9778891116*y**4-2937333219*y**5-241475070603*y**6
          +377069910084*y**7-192074876610*y**8-9448911503*y**9+45373003325*y**10
          -14797019262*y**11-69253208*y**12+945695795*y**13-252511581*y**14+61926768*y**15
          -11778096*y**16+643584*y**17)+r**24*(50946199874-196601692463*y-379666751238*y**2
          +5128674734529*y**3-17071333909038*y**4+29960218257489*y**5-31254508862610*y**6
          +18789141255441*y**7-3774522377478*y**8-4004829672589*y**9+4472479342270*y**10
          -2308778982381*y**11+697740055862*y**12-116346020501*y**13+6833428602*y**14
          +717361467*y**15-68040996*y**16+1097760*y**17)+3*r**16*(-1+y)**4*(-645690685806
          +3976961803149*y-9148085079246*y**2+7998781577691*y**3+3383092916460*y**4
          -13209864022207*y**5+10428053509594*y**6-1380766231697*y**7-2894855308952*y**8
          +1782653441255*y**9-177332189658*y**10-155798375135*y**11+40462252612*y**12
          +5701772411*y**13-2653604690*y**14+90128021*y**15+6019542*y**16+1828656*y**17)
          -r**10*(-1+y)**7*(-284775727634+457239908919*y-22114322745*y**2+1724066990009*y**3
          -5967402629691*y**4+6333476785491*y**5-1169690010981*y**6-2663094975315*y**7
          +1979294684877*y**8-187348275763*y**9-314268547155*y**10+122111961315*y**11
          -2556699545*y**12-5903152311*y**13+709570929*y**14+109489623*y**15-21874503*y**16
          +2184480*y**17)-r**8*(-1+y)**8*(27228751850-812074075*y-4959439342*y**2
          -323142469567*y**3+565449202190*y**4-329650643299*y**5+321510871374*y**6
          -679487188695*y**7+642312131694*y**8-208391905505*y**9-52616891162*y**10
          +52062570787*y**11-8111293334*y**12-1792946177*y**13+282481690*y**14
          +173074611*y**15-42849936*y**16+2560896*y**17)+3*r**14*(-1+y)**5*(666964077430
          -3072154297985*y+4912153398955*y**2-1198278123484*y**3-5881321525614*y**4
          +7477211075937*y**5-2397805544559*y**6-1897296801590*y**7+1851006177568*y**8
          -367541541967*y**9-174729786659*y**10+82419297728*y**11+3070992050*y**12
          -7413816609*y**13+1222209031*y**14+49301842*y**15-40955034*y**16+2598960*y**17)
          +r**12*(-1+y)**6*(-166012272086+666165376343*y-676233519906*y**2+1462084098320*y**3
          -6708831249311*y**4+11714317498857*y**5-7684599666264*y**6-1278666313578*y**7
          +4779975063555*y**8-2503619773063*y**9+209646184294*y**10+236015419524*y**11
          -64502236961*y**12-5325159625*y**13+3018011124*y**14+58234710*y**15-91852653*y**16
          +3588720*y**17)-r**20*(-1+y)**2*(-2613432265796+14283758633383*y-29732368648250*y**2
          +23109866501390*y**3+10582320253739*y**4-32700925937947*y**5+19536726573548*y**6
          +3320556133400*y**7-8974530293275*y**8+2527458038457*y**9+1763943471822*y**10
          -1503027005490*y**11+435702692765*y**12-52484942965*y**13+479519504*y**14
          +979758396*y**15-193646841*y**16+4796160*y**17)-r**22*(342441795406-3532093564507*y
          +15813329036124*y**2-41714823332073*y**3+69478084453146*y**4-69825719799567*y**5
          +29984618071752*y**6+20611589624583*y**7-43390914005814*y**8+34127045981203*y**9
          -14989954866244*y**10+2835487260957*y**11+757583793382*y**12-656300537773*y**13
          +181432296576*y**14-23037413595*y**15+1335838248*y**16-110361564*y**17
          +5729760*y**18))+24*logy*(-1+y)**2*(-1+r**2+y)**4*(19875*r**42*(-1+y)**11
          +r**40*(-1+y)**6*(-395413+1844597*y-3397774*y**2+2834728*y**3-1044755*y**4
          -28829*y**5+88086*y**6)-r**38*(-1+y)**4*(-15836183+106278325*y-302641175*y**2
          +510183817*y**3-534155777*y**4+333304027*y**5-123057569*y**6+27187159*y**7
          -3210176*y**8+73248*y**9)-r**36*(-1+y)**2*(1637070235-14199637931*y
          +54413067496*y**2-120395661462*y**3+170251143936*y**4-161482869114*y**5
          +104689997760*y**6-46068090264*y**7+13308465411*y**8-2394383155*y**9
          +265657232*y**10-21271354*y**11+716010*y**12)-6*(-1+y)**16*(-17-153*y
          -765*y**2-3333*y**3-11150*y**4-25190*y**5-16278*y**6+18706*y**7+28147*y**8
          +2731*y**9-28733*y**10+15091*y**11+5644*y**12-10204*y**13+3104*y**14)
          -2*r**2*(-1+y)**14*(2405+16631*y+65708*y**2+257608*y**3+619897*y**4
          +771655*y**5-1114952*y**6-2521496*y**7-743981*y**8+2933721*y**9+1737720*y**10
          -3569604*y**11+1441663*y**12+118873*y**13-213068*y**14+29220*y**15)
          -2*r**34*(13797929395-141997167407*y+658738288408*y**2-1811109612994*y**3
          +3273247873745*y**4-4081343093311*y**5+3580000561548*y**6-2199829813890*y**7
          +912050449239*y**8-226041896691*y**9+17051288262*y**10+7629310104*y**11
          -2448822963*y**12+263198745*y**13-9162354*y**14+94164*y**15)+2*r**32*(
          -84650979743+816166527011*y-3508116672574*y**2+8782871991052*y**3-14008585684993*y**4
          +14467376930645*y**5-8999210928178*y**6+2022450755931*y**7+1749529401390*y**8
          -1947978835859*y**9+917203266130*y**10-236996764730*y**11+31906703383*y**12
          -2231142677*y**13+303351742*y**14-42040317*y**15+1164987*y**16)-r**4*(
          -1+y)**13*(-1965155-11627314*y-40213147*y**2-74023650*y**3-96374243*y**4
          -82554452*y**5-111644819*y**6+166098412*y**7+351561499*y**8-423108250*y**9
          +39436743*y**10+244502934*y**11-205161289*y**12+64216576*y**13-6945257*y**14
          -761536*y**15+300324*y**16+18624*y**17)+2*r**30*(-133808190210+1168783623228*y
          -4438259212015*y**2+9096624962407*y**3-9704672783610*y**4+1804314331832*y**5
          +9867372625887*y**6-15655889110379*y**7+12779401079940*y**8-6527960138446*y**9
          +2077772564335*y**10-330370306079*y**11-22383309998*y**12+24806196328*y**13
          -6751667519*y**14+1092741443*y**15-66952986*y**16+265842*y**17)-r**6*(
          -1+y)**11*(144516671+482719952*y+1027158262*y**2-359618260*y**3-3518772394*y**4
          -6579581984*y**5+6683789490*y**6+8655569292*y**7+6172082676*y**8-30990817840*y**9
          +24071149862*y**10-4256904284*y**11-2861288798*y**12+1519542880*y**13
          -255888466*y**14+11930276*y**15+2943317*y**16-1362656*y**17+416004*y**18)
          +2*r**14*(-1+y)**7*(-785267213270+1635502118934*y-483709420879*y**2
          +3879386872718*y**3-16537396330285*y**4+21085321112330*y**5-5320977258837*y**6
          -11607848173706*y**7+11496806281691*y**8-2832016942370*y**9-1291228920535*y**10
          +836019379242*y**11-54128433411*y**12-53648696946*y**13+7351194405*y**14
          +2311576850*y**15-515444789*y**16-10934604*y**17+789462*y**18)-r**8*(
          -1+y)**10*(-2989591499-6784515533*y-10793633338*y**2+33341674320*y**3
          +24042389842*y**4+15702900986*y**5-195754356904*y**6+224627084634*y**7
          -81819957942*y**8-11735056690*y**9+16060379374*y**10-4959538204*y**11
          +800917290*y**12+879895538*y**13-980796452*y**14+304662514*y**15+213541*y**16
          -12673261*y**17+2297784*y**18)-2*r**12*(-1+y)**8*(-40216290402+47496624336*y
          +22762622075*y**2+626121042569*y**3-1866116974192*y**4+1734235990196*y**5
          -367921566995*y**6+31851866356*y**7-629973188845*y**8+628286689769*y**9
          -165861354196*y**10-38618955063*y**11+20362956378*y**12-786465462*y**13
          +1579448073*y**14-1276974398*y**15+279519997*y**16-14606559*y**17+2436363*y**18)
          +2*r**16*(-1+y)**6*(-583987371416+1093480473046*y+28952371507*y**2-951496202531*y**3
          +2551777745500*y**4-7756629213656*y**5+10581313890745*y**6-5418880281884*y**7
          -1635936632975*y**8+3319667472717*y**9-1395357544758*y**10+77358944109*y**11
          +102866807214*y**12-29967137910*y**13+2797897233*y**14+270556530*y**15
          -146813475*y**16-36126837*y**17+3554841*y**18)-2*r**28*(643652725606
          -5470286082836*y+20040283038629*y**2-39931620469609*y**3+42484978550564*y**4
          -10837419158032*y**5-34238481200093*y**6+52984685563192*y**7-35924974911171*y**8
          +8925599228103*y**9+5015350682352*y**10-5629098149665*y**11+2438254465930*y**12
          -559943442710*y**13+59326174783*y**14+142487674*y**15-399401081*y**16
          -44656501*y**17+3962865*y**18)+2*r**24*(-1+y)**2*(1056463228265-8710485928891*y
          +30495326343289*y**2-59905179262927*y**3+65141315747132*y**4-22932604382564*y**5
          -36210440759331*y**6+59797491714654*y**7-40487639978151*y**8+11251473508241*y**9
          +3898274476148*y**10-5336531687435*y**11+2428516336090*y**12-565560193382*y**13
          +62551785977*y**14-1431999124*y**15-390228568*y**16+51737092*y**17+4711485*y**18)
          +2*r**18*(-1+y)**5*(-4705244244140+23242298266054*y-41486451132491*y**2
          +14808416254342*y**3+56969300757709*y**4-94576279516406*y**5+53287792476637*y**6
          +7561625727916*y**7-25134160761383*y**8+10893558393596*y**9+9344852711*y**10
          -943306932562*y**11-41185908265*y**12+122966853674*y**13-12916130905*y**14
          -4255983040*y**15+560469071*y**16-36487510*y**17+4720992*y**18)-r**10*(
          -1+y)**9*(54900665645+41517861434*y+23836629355*y**2-612694879532*y**3
          +364455367318*y**4+73351207468*y**5+1691679017510*y**6-3411503555776*y**7
          +2110062165552*y**8+100193700924*y**9-680091756636*y**10+258932669908*y**11
          +3185826362*y**12-20585864308*y**13+3113238458*y**14+75996248*y**15+76004723*y**16
          -32019566*y**17+5348913*y**18)+2*r**20*(-1+y)**4*(1872256983043-12250036094851*y
          +31423397790548*y**2-38905284734288*y**3+19570120335611*y**4+4449124260695*y**5
          -7827646128268*y**6-835789410853*y**7+4437878159516*y**8-1914585220842*y**9
          -872389019039*y**10+1303784486374*y**11-559026484693*y**12+77506655467*y**13
          +19990892206*y**14-8944608249*y**15+869111395*y**16-49455677*y**17+8245905*y**18)
          +2*r**22*(-1+y)**3*(7506758202879-40945302240690*y+87382927456759*y**2
          -80659379911758*y**3+130176717657*y**4+71157147337354*y**5-67993079697659*y**6
          +27307682740870*y**7-4492179420845*y**8+2253640259146*y**9-2073019738865*y**10
          -69600246562*y**11+829383389703*y**12-402327939546*y**13+85062673547*y**14
          -9509058518*y**15+559767886*y**16-50508232*y**17+10772874*y**18)-2*r**26*(
          -479001862823+4609980686703*y-19680763818608*y**2+51461199970306*y**3
          -90344107428809*y**4+105272589973873*y**5-71179027768257*y**6+6945888658735*y**7
          +39676978275039*y**8-45973847975815*y**9+28331892992153*y**10-10653934094855*y**11
          +1969141636249*y**12+218272353359*y**13-222308924263*y**14+53043562497*y**15
          -6760905816*y**16+901411624*y**17-140481329*y**18+3740037*y**19))-(
          -1+r**2+y)**5*(2211*r**44*(-1+y)**13+r**42*(-1+y)**8*(83104-404465*y
          +775765*y**2-745342*y**3+388646*y**4-113425*y**5+17637*y**6)+r**40*(
          -1+y)**6*(755649-5217008*y+15566219*y**2-25544133*y**3+23667481*y**4
          -10750105*y**5+512853*y**6+1463485*y**7-469546*y**8+40833*y**9)-r**38*(
          -1+y)**4*(25002928-230810554*y+945840924*y**2-2285663439*y**3+3588921933*y**4
          -3786721464*y**5+2700260148*y**6-1290076710*y**7+402805866*y**8-75685534*y**9
          +6471040*y**10-123387*y**11+57033*y**12)-r**36*(-1+y)**2*(-411275143
          +4773296123*y-25106133943*y**2+77600334466*y**3-157150411343*y**4+222322612405*y**5
          -229060813335*y**6+175863502980*y**7-100918607025*y**8+42612347201*y**9
          -12888132241*y**10+2734766798*y**11-416703113*y**12+50890111*y**13-5661713*y**14
          +479292*y**15)+r**34*(49760989200-609908819225*y+3427109250431*y**2
          -11672996908665*y**3+26879797635127*y**4-44212393914829*y**5+53500848959259*y**6
          -48293669172365*y**7+32558091847187*y**8-16191717844647*y**9+5754265395001*y**10
          -1363766824075*y**11+179986648581*y**12-3002487431*y**13-2905956895*y**14
          +598925553*y**15-110846399*y**16+14310068*y**17-878676*y**18)-3*(-1
          +y)**15*(-6787-46693*y-183916*y**2-560432*y**3-982832*y**4-442292*y**5
          +3223944*y**6+3141860*y**7-3439450*y**8-3366258*y**9-394100*y**10+7803136*y**11
          -7309232*y**12+782036*y**13+3523232*y**14-2521996*y**15+578813*y**16
          -22537*y**17-904*y**18+408*y**19)+r**32*(313363717235-3623248618720*y
          +19067597919548*y**2-60070621919716*y**3+125470981963796*y**4-181530463031488*y**5
          +183419431961048*y**6-124827723723376*y**7+48327103643222*y**8+935679446816*y**9
          -14260816604236*y**10+9640622117456*y**11-3567494373076*y**12+807652984784*y**13
          -111342201856*y**14+10045159184*y**15-792319369*y**16+20407664*y**17
          +2368440*y**18+27444*y**19)-r**2*(-1+y)**14*(-1676432-9843795*y-33770229*y**2
          -80241024*y**3-86592600*y**4+60398844*y**5+378029732*y**6+229757340*y**7
          -402282972*y**8-453208166*y**9+164700174*y**10+715144080*y**11-755711384*y**12
          +284695140*y**13+15686796*y**14-48337108*y**15+13693908*y**16-1073127*y**17
          -117769*y**18-3480*y**19+72*y**20)-r**4*(-1+y)**13*(109107579+506541538*y
          +1427605140*y**2+1316424243*y**3+620740128*y**4-1267801152*y**5+64712232*y**6
          -8978982892*y**7-2913112074*y**8+22882507164*y**9-16290830096*y**10-4981914102*y**11
          +14102130048*y**12-9162928304*y**13+3006148008*y**14-462440460*y**15
          -34913593*y**16+20778354*y**17-1347540*y**18-192325*y**19+1704*y**20)
          -r**6*(-1+y)**12*(4512741680+14076025078*y+28223088900*y**2-19609020867*y**3
          -85256742951*y**4-128160243432*y**5+226652364256*y**6+92432736860*y**7
          +60738842844*y**8-578768231716*y**9+526004804368*y**10-111941378922*y**11
          -56469034834*y**12+25627643416*y**13+1550254560*y**14-1949613188*y**15
          +22260908*y**16+50180094*y**17+2859052*y**18-1495723*y**19+7617*y**20)
          +r**8*(-1+y)**11*(39775037467+66163683183*y+79136268870*y**2-572562238665*y**3
          +40575814749*y**4+177128178636*y**5+2574398626228*y**6-4663059683064*y**7
          +2136847513758*y**8+1447842353586*y**9-1984677641712*y**10+715696904670*y**11
          +26606616074*y**12-95236356564*y**13+30647634204*y**14-3637617248*y**15
          -249817881*y**16+248830695*y**17-47001254*y**18+5635011*y**19+24057*y**20)
          +r**10*(-1+y)**10*(-673210732704-174519248045*y+124217354679*y**2+7223875138461*y**3
          -7164618571767*y**4+124136725140*y**5-16702678582020*y**6+40858015431976*y**7
          -30084607888296*y**8+1242047494818*y**9+8739579428130*y**10-3496341943590*y**11
          -263409031854*y**12+334197073604*y**13+7160893500*y**14-21900905904*y**15
          +372404800*y**16+1071341619*y**17-119218449*y**18+11140369*y**19+338733*y**20)
          +2*r**18*(-1+y)**6*(-67824685315472+314720435689187*y-541710697589475*y**2
          +293503892676108*y**3+321055474350036*y**4-600297416574168*y**5+334082501381340*y**6
          -1319299745682*y**7-86832692916762*y**8+40873961955834*y**9-6492212947974*y**10
          +1678140169434*y**11-1977832068822*y**12+656326276848*y**13-17392077684*y**14
          -23555676054*y**15+3405032274*y**16+362624139*y**17+290501441*y**18-34529726*y**19
          +477978*y**20)+4*r**30*(361250446544-3959528768366*y+19580460989826*y**2
          -57241644022158*y**3+108426610229802*y**4-135341123363706*y**5+102976655890040*y**6
          -25747437478685*y**7-40972442355453*y**8+59908720261482*y**9-41893162236144*y**10
          +17949178003383*y**11-4590999644813*y**12+511678425950*y**13+52976392140*y**14
          -24709446595*y**15+4172811973*y**16-752877648*y**17+107305466*y**18-10970969*y**19
          +676731*y**20)+2*r**26*(-1+y)**2*(6725584361792-57055728981441*y+210333340856187*y**2
          -435764782822443*y**3+533835157616865*y**4-333908145555816*y**5-31576494036916*y**6
          +244897443486618*y**7-190357887999318*y**8+34462472369982*y**9+47687339059410*y**10
          -42762413042436*y**11+16199854125724*y**12-2824716654792*y**13+100078926756*y**14
          -3244605298*y**15+18495673518*y**16-4899151629*y**17+404292803*y**18
          -31528953*y**19+777387*y**20)+4*r**14*(-1+y)**8*(-4609128299120+10394748918186*y
          -4559307047826*y**2+18815215792788*y**3-81998066659452*y**4+110807264290866*y**5
          -38345993674680*y**6-46303689532167*y**7+52729477500921*y**8-15627443758266*y**9
          -3972257166672*y**10+3007971931785*y**11-90077251731*y**12-210329381670*y**13
          +7854288708*y**14+14069697495*y**15-1139537361*y**16-251369196*y**17
          +127892966*y**18-5445885*y**19+797511*y**20)+r**12*(-1+y)**9*(-829987788529
          -566218281668*y+624002595762*y**2+243940432548*y**3+24107218222587*y**4
          -45026853070296*y**5-4706386020376*y**6+72242435594188*y**7-58388822558742*y**8
          +1594202457456*y**9+18193000216428*y**10-7523457793596*y**11-317794574774*y**12
          +754503624488*y**13-97834312680*y**14-10540371724*y**15-130065305*y**16
          +1073278404*y**17+5354786*y**18+6669592*y**19+1415451*y**20)+2*r**16*(
          -1+y)**7*(-21092537053539+60410019122351*y-45582147253644*y**2+37176774272820*y**3
          -181527861748248*y**4+297084183036216*y**5-127820755543800*y**6-124905807341766*y**7
          +154775493705588*y**8-39408055906182*y**9-19067895507636*y**10+10397739162126*y**11
          +646848271830*y**12-1121518450848*y**13+90960212568*y**14+43050513582*y**15
          -3213716817*y**16-1041598785*y**17+465247200*y**18-31003178*y**19+1932162*y**20)
          -2*r**24*(-1+y)**3*(-13476569237419+106567424855749*y-362287647561726*y**2
          +709705692254721*y**3-841511668461969*y**4+504642096317496*y**5+98837277145052*y**6
          -470509285959974*y**7+410906783232492*y**8-162814328381662*y**9-1170472986416*y**10
          +36984599376588*y**11-21007123146968*y**12+6227475541016*y**13-1206216656964*y**14
          +234177117662*y**15-49312303409*y**16+6088073673*y**17-142972074*y**18
          +831675*y**19+2311257*y**20)-2*r**20*(-1+y)**5*(56853026389495-285677273094570*y
          +541127449434444*y**2-348444357499233*y**3-320940181373412*y**4+764897838221892*y**5
          -574669077572192*y**6+157671383556078*y**7+37086794683560*y**8-38188261401344*y**9
          +21438261957744*y**10-20150889061476*y**11+11604391444082*y**12-2487574333836*y**13
          -222693677976*y**14+184184500186*y**15-24798212007*y**16-560071374*y**17
          +83738364*y**18+11711037*y**19+2353338*y**20)-2*r**22*(-1+y)**4*(-4968944007600
          +30891034878106*y-78937172808888*y**2+123497772747057*y**3-161903204687331*y**4
          +193615164848772*y**5-166776748031376*y**6+68221645899058*y**7+23579650966098*y**8
          -54401146405920*y**9+43325901545872*y**10-20995196220420*y**11+4440169730124*y**12
          +1145800980404*y**13-1038924452616*y**14+320368252566*y**15-51583454090*y**16
          +3071811726*y**17+147745536*y**18-10111413*y**19+3910335*y**20)+2*r**28*(
          -81137482143+2127133440871*y-17485854891898*y**2+79436712361074*y**3
          -233000709560115*y**4+467657915953791*y**5-655445718152028*y**6+636817631558326*y**7
          -405805695569662*y**8+131672524869420*y**9+28595613702144*y**10-61221639646998*y**11
          +38063034294738*y**12-14430207895972*y**13+3651549212476*y**14-605140275678*y**15
          +50455873597*y**16+6180554309*y**17-3055898790*y**18+449290444*y**19
          -43955839*y**20+2217933*y**21))))/(1504935936000*logy**6*r**24*(-1+y)**13
          +752467968000*logy**5*r**20*(-1+y)**11*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+156764160000*logy**4*r**16*(-1+y)**9*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+17418240000*logy**3*r**12*(
          -1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +1088640000*logy**2*r**8*(-1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**4+36288000*logy*r**4*(-1+y)**3*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**5+504000*(-1
          +y)*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**6)
          )
      resNP += ((api*muWC**3*(-2612736000*logy**6*r**18*(1440+5220*r**2+8460*r**4+9763*r**6
          +8577*r**8+5817*r**10+2979*r**12+648*r**14)*(-1+y)**13-12441600*logy**5*r**14*(
          -1+y)**8*(120444*r**22*(-1+y)**5+288*(-1+y)**7*(-188-376*y-564*y**2
          +788*y**3-205*y**4+20*y**5)+30*r**2*(-1+y)**6*(10009+10009*y+10009*y**2
          -42071*y**3+32052*y**4-7092*y**5+608*y**6)+3*r**20*(-142477+712385*y
          -1424770*y**2+1352530*y**3-655265*y**4+118957*y**5+5040*y**6)+2*r**4*(
          -1+y)**5*(-1455289+907200*y+453600*y**2+511140*y**3-1181775*y**4+711984*y**5
          -132860*y**6+9600*y**7)-3*r**18*(312083-1288255*y+1896110*y**2-676640*y**3
          -641435*y**4+720487*y**5-247590*y**6+22680*y**7)-9*r**16*(369431-1430095*y
          +1817540*y**2-186120*y**3-1340225*y**4+1150829*y**5-364350*y**6+33390*y**7)
          +r**6*(-1+y)**3*(-5720789+18018778*y-15586589*y**2-264670*y**3+4107845*y**4
          +1413104*y**5-2985003*y**6+1292064*y**7-184500*y**8+10560*y**9)+r**14*(
          -4249433+13917745*y-9511940*y**2-17242690*y**3+30733085*y**4-17096647*y**5
          +1914990*y**6+1617420*y**7-623070*y**8+86940*y**9)+7*r**12*(-508493
          +998605*y+1862440*y**2-7074880*y**3+7077170*y**4-1785454*y**5-1614300*y**6
          +1331160*y**7-356805*y**8+24045*y**9+4752*y**10)-7*r**10*(20579+1654445*y
          -7702240*y**2+13241490*y**3-9429060*y**4+217284*y**5+3836170*y**6-2258240*y**7
          +391255*y**8+75525*y**9-34968*y**10+2160*y**11)+r**8*(3776159-29540395*y
          +85729790*y**2-117413890*y**3+69090500*y**4+6778112*y**5-30700810*y**6
          +12699230*y**7+1562165*y**8-2680845*y**9+766884*y**10-68820*y**11+1920*y**12))
          -103680*logy**4*r**10*(-1+y)**6*(712296*r**30*(-1+y)**7-3*r**28*(-1+y)**2*(4422733
          -22113665*y+44227330*y**2-43246690*y**3+22600865*y**4-5631853*y**5
          +463200*y**6)-288*(-1+y)**11*(-783-3132*y-7830*y**2-5680*y**3+2905*y**4
          +16448*y**5-11468*y**6+1840*y**7)-r**26*(-1+y)**2*(116384117-509654185*y
          +838642370*y**2-566422550*y**3+57803365*y**4+121679503*y**5-53233500*y**6
          +5024880*y**7)-24*r**2*(-1+y)**9*(-117653-235306*y-352959*y**2+965508*y**3
          -17735*y**4+361558*y**5-1495999*y**6+1369544*y**7-509408*y**8+60800*y**9)
          -16*r**4*(-1+y)**8*(4007878+1977478*y+962278*y**2-28958142*y**3+32416698*y**4
          -8238948*y**5-2986753*y**6+7907*y**7+1668662*y**8-775968*y**9+92160*y**10)
          +3*r**24*(-28725171+115589997*y-47568291*y**2-612298235*y**3+1544181955*y**4
          -1735253709*y**5+1072456283*y**6-364419309*y**7+56410120*y**8-2224520*y**9
          +439680*y**10)-r**6*(-1+y)**7*(-145214707+180162000*y+90081000*y**2
          +663233260*y**3-1866491250*y**4+1411744224*y**5-152675780*y**6-289774020*y**7
          +127779825*y**8-6406960*y**9-7207272*y**10+1044480*y**11)+3*r**22*(3454271
          -211429697*y+1208015391*y**2-3128956685*y**3+4226254845*y**4-2951648211*y**5
          +732891237*y**6+400377469*y**7-409045580*y**8+154286740*y**9-30489700*y**10
          +3131520*y**11)+2*r**20*(-524499881+2674035467*y-5094014451*y**2+3614935945*y**3
          +699573410*y**4-1712577210*y**5-1021800830*y**6+2789218490*y**7-2021636595*y**8
          +682459365*y**9-86136189*y**10-6544977*y**11+2249856*y**12)+r**10*(-1
          +y)**4*(-775239013+5758190439*y-12880060539*y**2+9006360853*y**3+5978150130*y**4
          -13071565866*y**5+6565252618*y**6+635999862*y**7-1756276929*y**8+521226095*y**9
          +37853589*y**10-45312087*y**11+7044432*y**12+81216*y**13)-r**8*(-1+y)**5*(
          -1054550489+3855447778*y-4218390689*y**2-402779080*y**3+3176201090*y**4
          -171233932*y**5-2567838586*y**6+1574609648*y**7+69629615*y**8-389604590*y**9
          +143601451*y**10-14934032*y**11-2194344*y**12+322560*y**13)+2*r**14*(
          -1+y)**2*(841299343-4249712615*y+6762257980*y**2-379407560*y**3-9885290990*y**4
          +10050998914*y**5-1761524030*y**6-3007764260*y**7+1937935195*y**8-151029105*y**9
          -230985252*y**10+90466950*y**11-13446390*y**12+914220*y**13)-2*r**18*(183974231
          -12989717*y-3323522499*y**2+9626946565*y**3-10219945150*y**4+1211157258*y**5
          +6908263834*y**6-6145667392*y**7+1422340215*y**8+903779225*y**9-743324549*y**10
          +220457613*y**11-31013514*y**12+1660680*y**13)+r**12*(-1+y)**3*(-1273821209
          +2829589436*y+3484886646*y**2-14398334884*y**3+10551342361*y**4+5940325824*y**5
          -12545875156*y**6+5742580984*y**7+711494709*y**8-1539302876*y**9+518081270*y**10
          -44320020*y**11-10536045*y**12+2288160*y**13)+r**16*(708885074-7097866118*y
          +25526339454*y**2-41768966330*y**3+23311324100*y**4+24564831732*y**5
          -50678590424*y**6+33409790072*y**7-4732768950*y**8-6800375470*y**9+4684966594*y**10
          -1236914358*y**11+94406424*y**12+17662680*y**13-2724480*y**14))-6912*logy**3*r**6*(
          -1+y)**4*(-1+r**2+y)**2*(38394*r**34*(-1+y)**9-27*r**32*(-1+y)**4*(163073
          -818209*y+1644950*y**2-1600570*y**3+866365*y**4-241613*y**5+27764*y**6)
          +720*(-1+y)**13*(-23-138*y-483*y**2-986*y**3-1132*y**4+88*y**5+2113*y**6
          +1388*y**7-2649*y**8+772*y**9)+r**30*(-1+y)**2*(-165926615+1127631275*y
          -3268957767*y**2+5218311559*y**3-4978648387*y**4+2876715795*y**5-955405985*y**6
          +154329377*y**7-7373694*y**8+274842*y**9)+r**28*(-1+y)**2*(-1172228844
          +7664770408*y-21199732711*y**2+31449167685*y**3-26840971199*y**4+12785476985*y**5
          -2437960893*y**6-559259849*y**7+368705015*y**8-61686381*y**9+3858984*y**10)
          +30*r**2*(-1+y)**11*(-21457-86932*y-220090*y**2-93508*y**3+315540*y**4
          +900516*y**5-704700*y**6+111440*y**7-415097*y**8+430560*y**9-168044*y**10
          +29472*y**11)-r**26*(-1+y)**2*(5190297368-30313831044*y+72064137871*y**2
          -83798773009*y**3+40052065191*y**4+11640821935*y**5-25141348711*y**6
          +13065185229*y**7-2906907671*y**8+215974869*y**9-7360608*y**10+914580*y**11)
          +12*r**4*(-1+y)**9*(-3123551-5229627*y-6886128*y**2+31721196*y**3+10799995*y**4
          +7119202*y**5-138837616*y**6+170220266*y**7-73357652*y**8+1565305*y**9
          +7776024*y**10-1700082*y**11-114588*y**12+68256*y**13)+r**24*(-4466710695
          +31570332959*y-91305518085*y**2+114239311473*y**3+6337183848*y**4-218540601660*y**5
          +326692536102*y**6-256022151450*y**7+117723933189*y**8-26440229481*y**9
          -2418792845*y**10+3567469389*y**11-1098345690*y**12+166353738*y**13-8802792*y**14)
          +r**6*(-1+y)**8*(296883727+176688691*y+129704065*y**2-3328633121*y**3
          +3663417268*y**4-1581776084*y**5+4478918188*y**6-8106580880*y**7+5888037577*y**8
          -1545635611*y**9-275015593*y**10+243763421*y**11-36337260*y**12-3603156*y**13
          +1176768*y**14)+r**16*(-1+y)**3*(3330114609+59734738582*y-309800907315*y**2
          +511310002608*y**3-220018103079*y**4-321033182898*y**5+447418038861*y**6
          -151189308540*y**7-82759388721*y**8+85653984258*y**9-21723247981*y**10
          -2946573768*y**11+2589077355*y**12-457218462*y**13+18959271*y**14+401220*y**15)
          +r**8*(-1+y)**7*(-3547814851+3556941022*y+772414846*y**2+24730560590*y**3
          -64747602941*y**4+54236596936*y**5-9187819364*y**6-9782080472*y**7+2445315415*y**8
          +2939647522*y**9-1586047954*y**10+101690642*y**11+78666701*y**12-5438280*y**13
          -4219956*y**14+702144*y**15)+r**10*(-1+y)**6*(6230835960-15435543140*y
          +8086767453*y**2-33545221659*y**3+138605495419*y**4-194051613753*y**5
          +98529014670*y**6+22461080394*y**7-48144310542*y**8+18641946882*y**9
          +141753101*y**10-1881335655*y**11+380455503*y**12+26049551*y**13-15061176*y**14
          +1375992*y**15)-r**12*(-1+y)**5*(36198348204-145156156868*y+191530388897*y**2
          -33866013028*y**3-116798228598*y**4+39054778120*y**5+89590837231*y**6
          -70629897104*y**7-6381886364*y**8+26331093516*y**9-10382278837*y**10
          +478202812*y**11+545097482*y**12-83417408*y**13-7346343*y**14+1413288*y**15)
          -r**22*(-363514557+15338911639*y-104411016381*y**2+357518167089*y**3
          -709962347886*y**4+839862084990*y**5-553172279748*y**6+105239356512*y**7
          +151120495797*y**8-164413331043*y**9+84636059501*y**10-24810395241*y**11
          +3408453594*y**12+80097114*y**13-69108096*y**14+2398716*y**15)+2*r**18*(
          -1+y)**2*(-21099886066+93068931072*y-126317652044*y**2-35390882710*y**3
          +271330750034*y**4-290469161644*y**5+109468894991*y**6+25177151843*y**7
          -30165565030*y**8-3368349518*y**9+11997829296*y**10-5360504788*y**11
          +871299126*y**12+57276690*y**13-40075041*y**14+3914289*y**15)-r**14*(
          -1+y)**4*(-47969913227+266803269713*y-539646222628*y**2+377492748976*y**3
          +248748054775*y**4-611043365225*y**5+365922808834*y**6+9580557646*y**7
          -114022614377*y**8+49387407215*y**9-1980737084*y**10-3906904772*y**11
          +803336457*y**12+98836701*y**13-45404490*y**14+4059486*y**15)+2*r**20*(
          -19057980890+127469360920*y-342797224923*y**2+414488185487*y**3-54248473248*y**4
          -472854093738*y**5+571798693287*y**6-195658580199*y**7-156065397054*y**8
          +202362603676*y**9-90377197819*y**10+11591682651*y**11+5648882222*y**12
          -2775645408*y**13+529001397*y**14-57890553*y**15+4074192*y**16))-144*logy**2*r**4*(
          -1+y)**3*(-1+r**2+y)**3*(17664*r**38*(-1+y)**10+3*r**36*(-1+y)**5*(86827
          -416471*y+779950*y**2-904846*y**3+477623*y**4-130315*y**5+18912*y**6)
          +3*r**34*(-1+y)**3*(-13200678+90319017*y-263570919*y**2+417571109*y**3
          -393741655*y**4+229700699*y**5-80302325*y**6+14748487*y**7-1161575*y**8
          +90960*y**9)-3*r**32*(-710399962+6930173317*y-30330348978*y**2+78209082033*y**3
          -131778286642*y**4+152414703226*y**5-123690443748*y**6+70557404122*y**7
          -27732591998*y**8+7133249937*y**9-1073242874*y**10+70575061*y**11+120346*y**12
          +6160*y**13)+12*(-1+y)**13*(-1267-7602*y-26607*y**2-48344*y**3-72670*y**4
          -136236*y**5-428546*y**6+196904*y**7+1054713*y**8-1028130*y**9+46553*y**10
          +597648*y**11-471872*y**12+115456*y**13)+r**30*(26734318634-249321874529*y
          +1036474382196*y**2-2517544845279*y**3+3939048744264*y**4-4120314878880*y**5
          +2873480487648*y**6-1260829501662*y**7+273371156946*y**8+22514256751*y**9
          -30002165524*y**10+6972713181*y**11-607380564*y**12+26112498*y**13-1525680*y**14)
          +r**28*(87786022982-771240920375*y+2985118822662*y**2-6558925703529*y**3
          +8797885673775*y**4-7020664910478*y**5+2469360466917*y**6+1067318073606*y**7
          -1864241838324*y**8+1119279024181*y**9-378173585296*y**10+74073987363*y**11
          -8047843473*y**12+470755488*y**13+2247669*y**14-273168*y**15)+4*r**2*(
          -1+y)**11*(1826036+6696581*y+15520625*y**2+3283915*y**3-42264029*y**4
          -105864590*y**5+28724218*y**6+177550930*y**7+163992310*y**8-518488407*y**9
          +341531037*y**10-56546949*y**11-29118005*y**12+15705400*y**13-3038864*y**14
          +321792*y**15)+r**4*(-1+y)**10*(-222248243-593532669*y-1080935514*y**2
          +2016822234*y**3+3208684383*y**4+3419358561*y**5-16068074148*y**6+12478246788*y**7
          -4858526013*y**8+4002824269*y**9-3380558178*y**10+1106177538*y**11+82514401*y**12
          -113546721*y**13+13228848*y**14+1730160*y**15+98304*y**16)+r**26*(307003365098
          -2479369589489*y+8603228527332*y**2-16149762291349*y**3+16152004607374*y**4
          -4198381351617*y**5-10305607351272*y**6+15109603938003*y**7-10073521547370*y**8
          +3514982357869*y**9-338648708188*y**10-225484202607*y**11+100721949010*y**12
          -18571336411*y**13+1893404352*y**14-95599023*y**15+3828288*y**16)+3*r**18*(
          -1+y)**3*(-559028146818+2293140400191*y-2800396302945*y**2-973699126477*y**3
          +5742124931475*y**4-6242889767705*y**5+3578254895671*y**6-1603837405661*y**7
          +1045385025359*y**8-701846577275*y**9+187441245909*y**10+106430452945*y**11
          -106266150943*y**12+37029841893*y**13-5507510475*y**14+10627289*y**15
          +51846143*y**16+249424*y**17)-r**6*(-1+y)**9*(-6504798074-8205632689*y
          -8574220485*y**2+70648876890*y**3-9778891116*y**4-2937333219*y**5-241475070603*y**6
          +377069910084*y**7-192074876610*y**8-9448911503*y**9+45373003325*y**10
          -14797019262*y**11-69253208*y**12+945695795*y**13-252511581*y**14+61926768*y**15
          -11778096*y**16+643584*y**17)+r**24*(50946199874-196601692463*y-379666751238*y**2
          +5128674734529*y**3-17071333909038*y**4+29960218257489*y**5-31254508862610*y**6
          +18789141255441*y**7-3774522377478*y**8-4004829672589*y**9+4472479342270*y**10
          -2308778982381*y**11+697740055862*y**12-116346020501*y**13+6833428602*y**14
          +717361467*y**15-68040996*y**16+1097760*y**17)+3*r**16*(-1+y)**4*(-645690685806
          +3976961803149*y-9148085079246*y**2+7998781577691*y**3+3383092916460*y**4
          -13209864022207*y**5+10428053509594*y**6-1380766231697*y**7-2894855308952*y**8
          +1782653441255*y**9-177332189658*y**10-155798375135*y**11+40462252612*y**12
          +5701772411*y**13-2653604690*y**14+90128021*y**15+6019542*y**16+1828656*y**17)
          -r**10*(-1+y)**7*(-284775727634+457239908919*y-22114322745*y**2+1724066990009*y**3
          -5967402629691*y**4+6333476785491*y**5-1169690010981*y**6-2663094975315*y**7
          +1979294684877*y**8-187348275763*y**9-314268547155*y**10+122111961315*y**11
          -2556699545*y**12-5903152311*y**13+709570929*y**14+109489623*y**15-21874503*y**16
          +2184480*y**17)-r**8*(-1+y)**8*(27228751850-812074075*y-4959439342*y**2
          -323142469567*y**3+565449202190*y**4-329650643299*y**5+321510871374*y**6
          -679487188695*y**7+642312131694*y**8-208391905505*y**9-52616891162*y**10
          +52062570787*y**11-8111293334*y**12-1792946177*y**13+282481690*y**14
          +173074611*y**15-42849936*y**16+2560896*y**17)+3*r**14*(-1+y)**5*(666964077430
          -3072154297985*y+4912153398955*y**2-1198278123484*y**3-5881321525614*y**4
          +7477211075937*y**5-2397805544559*y**6-1897296801590*y**7+1851006177568*y**8
          -367541541967*y**9-174729786659*y**10+82419297728*y**11+3070992050*y**12
          -7413816609*y**13+1222209031*y**14+49301842*y**15-40955034*y**16+2598960*y**17)
          +r**12*(-1+y)**6*(-166012272086+666165376343*y-676233519906*y**2+1462084098320*y**3
          -6708831249311*y**4+11714317498857*y**5-7684599666264*y**6-1278666313578*y**7
          +4779975063555*y**8-2503619773063*y**9+209646184294*y**10+236015419524*y**11
          -64502236961*y**12-5325159625*y**13+3018011124*y**14+58234710*y**15-91852653*y**16
          +3588720*y**17)-r**20*(-1+y)**2*(-2613432265796+14283758633383*y-29732368648250*y**2
          +23109866501390*y**3+10582320253739*y**4-32700925937947*y**5+19536726573548*y**6
          +3320556133400*y**7-8974530293275*y**8+2527458038457*y**9+1763943471822*y**10
          -1503027005490*y**11+435702692765*y**12-52484942965*y**13+479519504*y**14
          +979758396*y**15-193646841*y**16+4796160*y**17)-r**22*(342441795406-3532093564507*y
          +15813329036124*y**2-41714823332073*y**3+69478084453146*y**4-69825719799567*y**5
          +29984618071752*y**6+20611589624583*y**7-43390914005814*y**8+34127045981203*y**9
          -14989954866244*y**10+2835487260957*y**11+757583793382*y**12-656300537773*y**13
          +181432296576*y**14-23037413595*y**15+1335838248*y**16-110361564*y**17
          +5729760*y**18))-24*logy*(-1+y)**2*(-1+r**2+y)**4*(19875*r**42*(-1+y)**11
          +r**40*(-1+y)**6*(-395413+1844597*y-3397774*y**2+2834728*y**3-1044755*y**4
          -28829*y**5+88086*y**6)-r**38*(-1+y)**4*(-15836183+106278325*y-302641175*y**2
          +510183817*y**3-534155777*y**4+333304027*y**5-123057569*y**6+27187159*y**7
          -3210176*y**8+73248*y**9)-r**36*(-1+y)**2*(1637070235-14199637931*y
          +54413067496*y**2-120395661462*y**3+170251143936*y**4-161482869114*y**5
          +104689997760*y**6-46068090264*y**7+13308465411*y**8-2394383155*y**9
          +265657232*y**10-21271354*y**11+716010*y**12)-6*(-1+y)**16*(-17-153*y
          -765*y**2-3333*y**3-11150*y**4-25190*y**5-16278*y**6+18706*y**7+28147*y**8
          +2731*y**9-28733*y**10+15091*y**11+5644*y**12-10204*y**13+3104*y**14)
          -2*r**2*(-1+y)**14*(2405+16631*y+65708*y**2+257608*y**3+619897*y**4
          +771655*y**5-1114952*y**6-2521496*y**7-743981*y**8+2933721*y**9+1737720*y**10
          -3569604*y**11+1441663*y**12+118873*y**13-213068*y**14+29220*y**15)
          -2*r**34*(13797929395-141997167407*y+658738288408*y**2-1811109612994*y**3
          +3273247873745*y**4-4081343093311*y**5+3580000561548*y**6-2199829813890*y**7
          +912050449239*y**8-226041896691*y**9+17051288262*y**10+7629310104*y**11
          -2448822963*y**12+263198745*y**13-9162354*y**14+94164*y**15)+2*r**32*(
          -84650979743+816166527011*y-3508116672574*y**2+8782871991052*y**3-14008585684993*y**4
          +14467376930645*y**5-8999210928178*y**6+2022450755931*y**7+1749529401390*y**8
          -1947978835859*y**9+917203266130*y**10-236996764730*y**11+31906703383*y**12
          -2231142677*y**13+303351742*y**14-42040317*y**15+1164987*y**16)-r**4*(
          -1+y)**13*(-1965155-11627314*y-40213147*y**2-74023650*y**3-96374243*y**4
          -82554452*y**5-111644819*y**6+166098412*y**7+351561499*y**8-423108250*y**9
          +39436743*y**10+244502934*y**11-205161289*y**12+64216576*y**13-6945257*y**14
          -761536*y**15+300324*y**16+18624*y**17)+2*r**30*(-133808190210+1168783623228*y
          -4438259212015*y**2+9096624962407*y**3-9704672783610*y**4+1804314331832*y**5
          +9867372625887*y**6-15655889110379*y**7+12779401079940*y**8-6527960138446*y**9
          +2077772564335*y**10-330370306079*y**11-22383309998*y**12+24806196328*y**13
          -6751667519*y**14+1092741443*y**15-66952986*y**16+265842*y**17)-r**6*(
          -1+y)**11*(144516671+482719952*y+1027158262*y**2-359618260*y**3-3518772394*y**4
          -6579581984*y**5+6683789490*y**6+8655569292*y**7+6172082676*y**8-30990817840*y**9
          +24071149862*y**10-4256904284*y**11-2861288798*y**12+1519542880*y**13
          -255888466*y**14+11930276*y**15+2943317*y**16-1362656*y**17+416004*y**18)
          +2*r**14*(-1+y)**7*(-785267213270+1635502118934*y-483709420879*y**2
          +3879386872718*y**3-16537396330285*y**4+21085321112330*y**5-5320977258837*y**6
          -11607848173706*y**7+11496806281691*y**8-2832016942370*y**9-1291228920535*y**10
          +836019379242*y**11-54128433411*y**12-53648696946*y**13+7351194405*y**14
          +2311576850*y**15-515444789*y**16-10934604*y**17+789462*y**18)-r**8*(
          -1+y)**10*(-2989591499-6784515533*y-10793633338*y**2+33341674320*y**3
          +24042389842*y**4+15702900986*y**5-195754356904*y**6+224627084634*y**7
          -81819957942*y**8-11735056690*y**9+16060379374*y**10-4959538204*y**11
          +800917290*y**12+879895538*y**13-980796452*y**14+304662514*y**15+213541*y**16
          -12673261*y**17+2297784*y**18)-2*r**12*(-1+y)**8*(-40216290402+47496624336*y
          +22762622075*y**2+626121042569*y**3-1866116974192*y**4+1734235990196*y**5
          -367921566995*y**6+31851866356*y**7-629973188845*y**8+628286689769*y**9
          -165861354196*y**10-38618955063*y**11+20362956378*y**12-786465462*y**13
          +1579448073*y**14-1276974398*y**15+279519997*y**16-14606559*y**17+2436363*y**18)
          +2*r**16*(-1+y)**6*(-583987371416+1093480473046*y+28952371507*y**2-951496202531*y**3
          +2551777745500*y**4-7756629213656*y**5+10581313890745*y**6-5418880281884*y**7
          -1635936632975*y**8+3319667472717*y**9-1395357544758*y**10+77358944109*y**11
          +102866807214*y**12-29967137910*y**13+2797897233*y**14+270556530*y**15
          -146813475*y**16-36126837*y**17+3554841*y**18)-2*r**28*(643652725606
          -5470286082836*y+20040283038629*y**2-39931620469609*y**3+42484978550564*y**4
          -10837419158032*y**5-34238481200093*y**6+52984685563192*y**7-35924974911171*y**8
          +8925599228103*y**9+5015350682352*y**10-5629098149665*y**11+2438254465930*y**12
          -559943442710*y**13+59326174783*y**14+142487674*y**15-399401081*y**16
          -44656501*y**17+3962865*y**18)+2*r**24*(-1+y)**2*(1056463228265-8710485928891*y
          +30495326343289*y**2-59905179262927*y**3+65141315747132*y**4-22932604382564*y**5
          -36210440759331*y**6+59797491714654*y**7-40487639978151*y**8+11251473508241*y**9
          +3898274476148*y**10-5336531687435*y**11+2428516336090*y**12-565560193382*y**13
          +62551785977*y**14-1431999124*y**15-390228568*y**16+51737092*y**17+4711485*y**18)
          +2*r**18*(-1+y)**5*(-4705244244140+23242298266054*y-41486451132491*y**2
          +14808416254342*y**3+56969300757709*y**4-94576279516406*y**5+53287792476637*y**6
          +7561625727916*y**7-25134160761383*y**8+10893558393596*y**9+9344852711*y**10
          -943306932562*y**11-41185908265*y**12+122966853674*y**13-12916130905*y**14
          -4255983040*y**15+560469071*y**16-36487510*y**17+4720992*y**18)-r**10*(
          -1+y)**9*(54900665645+41517861434*y+23836629355*y**2-612694879532*y**3
          +364455367318*y**4+73351207468*y**5+1691679017510*y**6-3411503555776*y**7
          +2110062165552*y**8+100193700924*y**9-680091756636*y**10+258932669908*y**11
          +3185826362*y**12-20585864308*y**13+3113238458*y**14+75996248*y**15+76004723*y**16
          -32019566*y**17+5348913*y**18)+2*r**20*(-1+y)**4*(1872256983043-12250036094851*y
          +31423397790548*y**2-38905284734288*y**3+19570120335611*y**4+4449124260695*y**5
          -7827646128268*y**6-835789410853*y**7+4437878159516*y**8-1914585220842*y**9
          -872389019039*y**10+1303784486374*y**11-559026484693*y**12+77506655467*y**13
          +19990892206*y**14-8944608249*y**15+869111395*y**16-49455677*y**17+8245905*y**18)
          +2*r**22*(-1+y)**3*(7506758202879-40945302240690*y+87382927456759*y**2
          -80659379911758*y**3+130176717657*y**4+71157147337354*y**5-67993079697659*y**6
          +27307682740870*y**7-4492179420845*y**8+2253640259146*y**9-2073019738865*y**10
          -69600246562*y**11+829383389703*y**12-402327939546*y**13+85062673547*y**14
          -9509058518*y**15+559767886*y**16-50508232*y**17+10772874*y**18)-2*r**26*(
          -479001862823+4609980686703*y-19680763818608*y**2+51461199970306*y**3
          -90344107428809*y**4+105272589973873*y**5-71179027768257*y**6+6945888658735*y**7
          +39676978275039*y**8-45973847975815*y**9+28331892992153*y**10-10653934094855*y**11
          +1969141636249*y**12+218272353359*y**13-222308924263*y**14+53043562497*y**15
          -6760905816*y**16+901411624*y**17-140481329*y**18+3740037*y**19))+(
          -1+r**2+y)**5*(2211*r**44*(-1+y)**13+r**42*(-1+y)**8*(83104-404465*y
          +775765*y**2-745342*y**3+388646*y**4-113425*y**5+17637*y**6)+r**40*(
          -1+y)**6*(755649-5217008*y+15566219*y**2-25544133*y**3+23667481*y**4
          -10750105*y**5+512853*y**6+1463485*y**7-469546*y**8+40833*y**9)-r**38*(
          -1+y)**4*(25002928-230810554*y+945840924*y**2-2285663439*y**3+3588921933*y**4
          -3786721464*y**5+2700260148*y**6-1290076710*y**7+402805866*y**8-75685534*y**9
          +6471040*y**10-123387*y**11+57033*y**12)-r**36*(-1+y)**2*(-411275143
          +4773296123*y-25106133943*y**2+77600334466*y**3-157150411343*y**4+222322612405*y**5
          -229060813335*y**6+175863502980*y**7-100918607025*y**8+42612347201*y**9
          -12888132241*y**10+2734766798*y**11-416703113*y**12+50890111*y**13-5661713*y**14
          +479292*y**15)+r**34*(49760989200-609908819225*y+3427109250431*y**2
          -11672996908665*y**3+26879797635127*y**4-44212393914829*y**5+53500848959259*y**6
          -48293669172365*y**7+32558091847187*y**8-16191717844647*y**9+5754265395001*y**10
          -1363766824075*y**11+179986648581*y**12-3002487431*y**13-2905956895*y**14
          +598925553*y**15-110846399*y**16+14310068*y**17-878676*y**18)-3*(-1
          +y)**15*(-6787-46693*y-183916*y**2-560432*y**3-982832*y**4-442292*y**5
          +3223944*y**6+3141860*y**7-3439450*y**8-3366258*y**9-394100*y**10+7803136*y**11
          -7309232*y**12+782036*y**13+3523232*y**14-2521996*y**15+578813*y**16
          -22537*y**17-904*y**18+408*y**19)+r**32*(313363717235-3623248618720*y
          +19067597919548*y**2-60070621919716*y**3+125470981963796*y**4-181530463031488*y**5
          +183419431961048*y**6-124827723723376*y**7+48327103643222*y**8+935679446816*y**9
          -14260816604236*y**10+9640622117456*y**11-3567494373076*y**12+807652984784*y**13
          -111342201856*y**14+10045159184*y**15-792319369*y**16+20407664*y**17
          +2368440*y**18+27444*y**19)-r**2*(-1+y)**14*(-1676432-9843795*y-33770229*y**2
          -80241024*y**3-86592600*y**4+60398844*y**5+378029732*y**6+229757340*y**7
          -402282972*y**8-453208166*y**9+164700174*y**10+715144080*y**11-755711384*y**12
          +284695140*y**13+15686796*y**14-48337108*y**15+13693908*y**16-1073127*y**17
          -117769*y**18-3480*y**19+72*y**20)-r**4*(-1+y)**13*(109107579+506541538*y
          +1427605140*y**2+1316424243*y**3+620740128*y**4-1267801152*y**5+64712232*y**6
          -8978982892*y**7-2913112074*y**8+22882507164*y**9-16290830096*y**10-4981914102*y**11
          +14102130048*y**12-9162928304*y**13+3006148008*y**14-462440460*y**15
          -34913593*y**16+20778354*y**17-1347540*y**18-192325*y**19+1704*y**20)
          -r**6*(-1+y)**12*(4512741680+14076025078*y+28223088900*y**2-19609020867*y**3
          -85256742951*y**4-128160243432*y**5+226652364256*y**6+92432736860*y**7
          +60738842844*y**8-578768231716*y**9+526004804368*y**10-111941378922*y**11
          -56469034834*y**12+25627643416*y**13+1550254560*y**14-1949613188*y**15
          +22260908*y**16+50180094*y**17+2859052*y**18-1495723*y**19+7617*y**20)
          +r**8*(-1+y)**11*(39775037467+66163683183*y+79136268870*y**2-572562238665*y**3
          +40575814749*y**4+177128178636*y**5+2574398626228*y**6-4663059683064*y**7
          +2136847513758*y**8+1447842353586*y**9-1984677641712*y**10+715696904670*y**11
          +26606616074*y**12-95236356564*y**13+30647634204*y**14-3637617248*y**15
          -249817881*y**16+248830695*y**17-47001254*y**18+5635011*y**19+24057*y**20)
          +r**10*(-1+y)**10*(-673210732704-174519248045*y+124217354679*y**2+7223875138461*y**3
          -7164618571767*y**4+124136725140*y**5-16702678582020*y**6+40858015431976*y**7
          -30084607888296*y**8+1242047494818*y**9+8739579428130*y**10-3496341943590*y**11
          -263409031854*y**12+334197073604*y**13+7160893500*y**14-21900905904*y**15
          +372404800*y**16+1071341619*y**17-119218449*y**18+11140369*y**19+338733*y**20)
          +2*r**18*(-1+y)**6*(-67824685315472+314720435689187*y-541710697589475*y**2
          +293503892676108*y**3+321055474350036*y**4-600297416574168*y**5+334082501381340*y**6
          -1319299745682*y**7-86832692916762*y**8+40873961955834*y**9-6492212947974*y**10
          +1678140169434*y**11-1977832068822*y**12+656326276848*y**13-17392077684*y**14
          -23555676054*y**15+3405032274*y**16+362624139*y**17+290501441*y**18-34529726*y**19
          +477978*y**20)+4*r**30*(361250446544-3959528768366*y+19580460989826*y**2
          -57241644022158*y**3+108426610229802*y**4-135341123363706*y**5+102976655890040*y**6
          -25747437478685*y**7-40972442355453*y**8+59908720261482*y**9-41893162236144*y**10
          +17949178003383*y**11-4590999644813*y**12+511678425950*y**13+52976392140*y**14
          -24709446595*y**15+4172811973*y**16-752877648*y**17+107305466*y**18-10970969*y**19
          +676731*y**20)+2*r**26*(-1+y)**2*(6725584361792-57055728981441*y+210333340856187*y**2
          -435764782822443*y**3+533835157616865*y**4-333908145555816*y**5-31576494036916*y**6
          +244897443486618*y**7-190357887999318*y**8+34462472369982*y**9+47687339059410*y**10
          -42762413042436*y**11+16199854125724*y**12-2824716654792*y**13+100078926756*y**14
          -3244605298*y**15+18495673518*y**16-4899151629*y**17+404292803*y**18
          -31528953*y**19+777387*y**20)+4*r**14*(-1+y)**8*(-4609128299120+10394748918186*y
          -4559307047826*y**2+18815215792788*y**3-81998066659452*y**4+110807264290866*y**5
          -38345993674680*y**6-46303689532167*y**7+52729477500921*y**8-15627443758266*y**9
          -3972257166672*y**10+3007971931785*y**11-90077251731*y**12-210329381670*y**13
          +7854288708*y**14+14069697495*y**15-1139537361*y**16-251369196*y**17
          +127892966*y**18-5445885*y**19+797511*y**20)+r**12*(-1+y)**9*(-829987788529
          -566218281668*y+624002595762*y**2+243940432548*y**3+24107218222587*y**4
          -45026853070296*y**5-4706386020376*y**6+72242435594188*y**7-58388822558742*y**8
          +1594202457456*y**9+18193000216428*y**10-7523457793596*y**11-317794574774*y**12
          +754503624488*y**13-97834312680*y**14-10540371724*y**15-130065305*y**16
          +1073278404*y**17+5354786*y**18+6669592*y**19+1415451*y**20)+2*r**16*(
          -1+y)**7*(-21092537053539+60410019122351*y-45582147253644*y**2+37176774272820*y**3
          -181527861748248*y**4+297084183036216*y**5-127820755543800*y**6-124905807341766*y**7
          +154775493705588*y**8-39408055906182*y**9-19067895507636*y**10+10397739162126*y**11
          +646848271830*y**12-1121518450848*y**13+90960212568*y**14+43050513582*y**15
          -3213716817*y**16-1041598785*y**17+465247200*y**18-31003178*y**19+1932162*y**20)
          -2*r**24*(-1+y)**3*(-13476569237419+106567424855749*y-362287647561726*y**2
          +709705692254721*y**3-841511668461969*y**4+504642096317496*y**5+98837277145052*y**6
          -470509285959974*y**7+410906783232492*y**8-162814328381662*y**9-1170472986416*y**10
          +36984599376588*y**11-21007123146968*y**12+6227475541016*y**13-1206216656964*y**14
          +234177117662*y**15-49312303409*y**16+6088073673*y**17-142972074*y**18
          +831675*y**19+2311257*y**20)-2*r**20*(-1+y)**5*(56853026389495-285677273094570*y
          +541127449434444*y**2-348444357499233*y**3-320940181373412*y**4+764897838221892*y**5
          -574669077572192*y**6+157671383556078*y**7+37086794683560*y**8-38188261401344*y**9
          +21438261957744*y**10-20150889061476*y**11+11604391444082*y**12-2487574333836*y**13
          -222693677976*y**14+184184500186*y**15-24798212007*y**16-560071374*y**17
          +83738364*y**18+11711037*y**19+2353338*y**20)-2*r**22*(-1+y)**4*(-4968944007600
          +30891034878106*y-78937172808888*y**2+123497772747057*y**3-161903204687331*y**4
          +193615164848772*y**5-166776748031376*y**6+68221645899058*y**7+23579650966098*y**8
          -54401146405920*y**9+43325901545872*y**10-20995196220420*y**11+4440169730124*y**12
          +1145800980404*y**13-1038924452616*y**14+320368252566*y**15-51583454090*y**16
          +3071811726*y**17+147745536*y**18-10111413*y**19+3910335*y**20)+2*r**28*(
          -81137482143+2127133440871*y-17485854891898*y**2+79436712361074*y**3
          -233000709560115*y**4+467657915953791*y**5-655445718152028*y**6+636817631558326*y**7
          -405805695569662*y**8+131672524869420*y**9+28595613702144*y**10-61221639646998*y**11
          +38063034294738*y**12-14430207895972*y**13+3651549212476*y**14-605140275678*y**15
          +50455873597*y**16+6180554309*y**17-3055898790*y**18+449290444*y**19
          -43955839*y**20+2217933*y**21))))/(1693052928000*logy**6*r**24*(-1+y)**13
          +846526464000*logy**5*r**20*(-1+y)**11*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+176359680000*logy**4*r**16*(-1+y)**9*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+19595520000*logy**3*r**12*(
          -1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +1224720000*logy**2*r**8*(-1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**4+40824000*logy*r**4*(-1+y)**3*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**5+567000*(-1
          +y)*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**6)
          )
      resNP += ((api*(2612736000*logy**6*r**22*(-24+83*r**4+166*r**6+171*r**8+96*r**10)*(
          -1+y)**12+12441600*logy**5*r**18*(-1+y)**10*(8184*r**18*(-1+y)**2+5*r**16*(5237
          -10474*y+5237*y**2+168*y**3)-2*r**14*(-65497+70514*y+25223*y**2-41685*y**3
          +5040*y**4)+105*r**12*(617+818*y-2461*y**2+1342*y**3-204*y**4+96*y**5)
          -12*(-1+y)**3*(551+551*y+551*y**2-2109*y**3+1426*y**4-380*y**5+40*y**6)
          +210*r**6*(-345+690*y-345*y**2-59*y**3+249*y**4-249*y**5+83*y**6)
          +14*r**10*(-4128+23196*y-26538*y**2+6630*y**3+4230*y**4-2875*y**5
          +940*y**6)-40*r**2*(-1+y)**2*(-139+1470*y**3-1757*y**4+861*y**5-203*y**6
          +20*y**7)+7*r**8*(-17427+49794*y-39837*y**2+2800*y**3+12785*y**4-9088*y**5
          +2641*y**6+72*y**7)+r**4*(9911-50062*y+55271*y**2-27790*y**3+72275*y**4
          -106316*y**5+61467*y**6-17296*y**7+2700*y**8-160*y**9))+103680*logy**4*r**14*(
          -1+y)**8*(-1+r**2+y)**2*(65472*r**22*(-1+y)**4-r**20*(-1+y)**2*(-843787
          +1818518*y-1105675*y**2+178944*y**3)-2*r**18*(-1+y)**2*(-4479118+7412295*y
          -2713044*y**2-306875*y**3+30192*y**4)+r**16*(20830280-77524310*y+107663733*y**2
          -60869020*y**3+2073490*y**4+11267210*y**5-3917075*y**6+519792*y**7)
          +120*(-1+y)**5*(695+2085*y+4170*y**2-628*y**3-2955*y**4-6157*y**5
          +8946*y**6-3736*y**7+520*y**8)-2*r**14*(-30243002+89294983*y-89902451*y**2
          +21727710*y**3+21247040*y**4-15806343*y**5+4489317*y**6-1013474*y**7
          +73920*y**8)+r**12*(67117074-187997454*y+163688679*y**2+18649408*y**3
          -124661507*y**4+78911766*y**5-9710431*y**6-9357304*y**7+4038237*y**8
          -348768*y**9)+16*r**2*(-1+y)**4*(-38251-86927*y-146028*y**2+144826*y**3
          +54205*y**4+184161*y**5-408248*y**6+264568*y**7-73596*y**8+7640*y**9)
          +r**4*(-1+y)**3*(5938349+3361981*y+3019413*y**2-27297695*y**3+23184427*y**4
          -11080629*y**5+10325959*y**6-8839373*y**7+3728760*y**8-697912*y**9+45120*y**10)
          -2*r**6*(-1+y)**2*(2514850+998565*y+1017189*y**2-30008617*y**3+41688237*y**4
          -21895829*y**5+6235015*y**6-2891559*y**7+1791197*y**8-548032*y**9+53184*y**10)
          +2*r**10*(18303234-48387789*y+33581286*y**2+33374156*y**3-79112974*y**4
          +56616998*y**5-9062126*y**6-10582496*y**7+6852964*y**8-1694301*y**9
          +199248*y**10)+r**8*(2732144-4271018*y-11555769*y**2+83063796*y**3
          -182168344*y**4+181941368*y**5-79901458*y**6+3950644*y**7+8316304*y**8
          -2010406*y**9-209437*y**10+112176*y**11))+6912*logy**3*r**10*(-1+y)**6*(
          -1+r**2+y)**3*(9900*r**28*(-1+y)**6-9*r**26*(-1+y)**4*(-52869+109038*y
          -59469*y**2+9440*y**3)+r**24*(-1+y)**2*(11467665-43399503*y+60944922*y**2
          -37850248*y**3+9125477*y**4-288373*y**5+28860*y**6)+r**22*(-1+y)**2*(68843047
          -256676806*y+356743290*y**2-217723760*y**3+42998135*y**4+9416518*y**5
          -3886044*y**6+385320*y**7)-3*r**20*(-1+y)**2*(-131128949+407962329*y
          -434752930*y**2+137680320*y**3+56771775*y**4-42341701*y**5+7090856*y**6
          -1224940*y**7+113440*y**8)-6*(-1+y)**8*(3753+18765*y+56295*y**2+79635*y**3
          +38265*y**4-110741*y**5-93115*y**6-9595*y**7+174390*y**8-106140*y**9
          +18488*y**10)-6*r**2*(-1+y)**7*(-98293-404431*y-1039225*y**2-746305*y**3
          +101445*y**4+1871611*y**5-369603*y**6+95825*y**7-1294220*y**8+1130680*y**9
          -357268*y**10+38784*y**11)-10*r**18*(-56723600+298409934*y-643471125*y**2
          +683186508*y**3-275785204*y**4-137204154*y**5+206455128*y**6-87412320*y**7
          +10527482*y**8+3052184*y**9-1112301*y**10+71868*y**11)+r**6*(-1+y)**5*(39121489
          +73021361*y+111358860*y**2-244369690*y**3-20623820*y**4-196052388*y**5
          +606126458*y**6-481094830*y**7+144196015*y**8-3408505*y**9-6053826*y**10
          +760556*y**11+34320*y**12)+15*r**8*(-1+y)**4*(-15878885+398321*y-301641*y**2
          +75445067*y**3-95008968*y**4+53058880*y**5-41962012*y**6+38157288*y**7
          -16416427*y**8+982603*y**9+1377465*y**10-399719*y**11+38428*y**12)-r**10*(
          -1+y)**3*(-16984079-168609735*y-25928175*y**2+2135852665*y**3-3688217360*y**4
          +2237584208*y**5-317644040*y**6-139199620*y**7+11270035*y**8+12807235*y**9
          +3435171*y**10-2489625*y**11+109320*y**12)-r**4*(-1+y)**6*(11555505
          +31499343*y+59301450*y**2-29902700*y**3-43481800*y**4-85804270*y**5
          +159655694*y**6-83802820*y**7+25257475*y**8-12798925*y**9+6501140*y**10
          -1549212*y**11+123120*y**12)-2*r**12*(-1+y)**2*(-220209043+411954349*y
          +74185845*y**2-1387709685*y**3+2225641975*y**4-1291579609*y**5-192141573*y**6
          +586088115*y**7-244661840*y**8+9427950*y**9+20020802*y**10-5694876*y**11
          +376590*y**12)+2*r**16*(672276584-2860275054*y+4703161815*y**2-3208606645*y**3
          -315086620*y**4+2019016462*y**5-1328054242*y**6+295476880*y**7+75421370*y**8
          -76228930*y**9+27139629*y**10-4606929*y**11+421680*y**12)+6*r**14*(199931015
          -809563784*y+1167621254*y**2-316116510*y**3-1144926480*y**4+1570452140*y**5
          -697753082*y**6-197067598*y**7+351506045*y**8-141006520*y**9+12363020*y**10
          +5920716*y**11-1482756*y**12+122540*y**13))+144*logy**2*r**6*(-1+y)**5*(
          -1+r**2+y)**4*(-23*r**32*(-1+y)**5*(-3209+6418*y-3209*y**2+480*y**3)
          +2*r**30*(-1+y)**3*(3813069-14687090*y+20974070*y**2-13451484*y**3
          +3657293*y**4-299378*y**5+21840*y**6)+r**28*(-156696765+1057733311*y
          -3046631339*y**2+4868560501*y**3-4688262617*y**4+2751366175*y**5-934031441*y**6
          +151803679*y**7-2082686*y**8-1856018*y**9+97200*y**10)-4*r**26*(414551093
          -2635932465*y+7078032315*y**2-10329043568*y**3+8694283262*y**4-3997545800*y**5
          +687352960*y**6+161157200*y**7-82147187*y**8+10329433*y**9-1111803*y**10
          +74560*y**11)+r**24*(-5491998351+34099706433*y-89501248887*y**2+126815795453*y**3
          -100005267806*y**4+35510585498*y**5+6101489418*y**6-11157717398*y**7
          +4276140677*y**8-679436979*y**9+24715653*y**10+7626609*y**11-390320*y**12)
          +48*(-1+y)**10*(31+217*y+868*y**2+2327*y**3+4237*y**4+4165*y**5
          -3037*y**6-9269*y**7-3302*y**8+5688*y**9+7379*y**10-7480*y**11+1676*y**12)
          +32*r**2*(-1+y)**9*(-7190-43326*y-152292*y**2-298927*y**3-309853*y**4
          +84177*y**5+380444*y**6+365411*y**7-348189*y**8+3753*y**9-123262*y**10
          +149532*y**11-47794*y**12+4516*y**13)+2*r**22*(-13036123443+71740866807*y
          -160783588485*y**2+178791026785*y**3-81950110742*y**4-25544771638*y**5
          +50727703130*y**6-24161409178*y**7+4080963485*y**8+305709647*y**9-219329589*y**10
          +54677193*y**11-6002932*y**12+388960*y**13)-r**8*(-1+y)**6*(-1451010035
          -3264559141*y-5356025172*y**2+7635207792*y**3+4694199929*y**4+7877242459*y**5
          -24027345344*y**6+16328861848*y**7-4459376825*y**8+1070244121*y**9-643091724*y**10
          +206541160*y**11-15320701*y**12-2404767*y**13+4400*y**14)-4*r**10*(-1
          +y)**5*(532880619+836279928*y+1279041687*y**2-5067306179*y**3+873734652*y**4
          -3829426511*y**5+15014097086*y**6-14177258842*y**7+4348245515*y**8+736625918*y**9
          -765614133*y**10+154922861*y**11-3662770*y**12-2093911*y**13+66080*y**14)
          +r**4*(-1+y)**8*(12847569+61921525*y+180451791*y**2+222389195*y**3
          +83426306*y**4-335962822*y**5-172867954*y**6-7442746*y**7+417121421*y**8
          -291841711*y**9+73333203*y**10-14094721*y**11+6399280*y**12-1622416*y**13
          +134080*y**14)+2*r**6*(-1+y)**7*(-76421619-287760878*y-691310232*y**2
          -271014742*y**3+269568917*y**4+1320015980*y**5-704853112*y**6+124753796*y**7
          -874445569*y**8+941333378*y**9-352254336*y**10+32817890*y**11+9575311*y**12
          -2310064*y**13+177280*y**14)+r**20*(-18118394101+110411767663*y-286257098343*y**2
          +375478034189*y**3-190165703694*y**4-126146405342*y**5+245432717970*y**6
          -133484521638*y**7+10232112263*y**8+20574837659*y**9-9439532907*y**10
          +1488323417*y**11+4034556*y**12-12447052*y**13+707360*y**14)-r**16*(
          -1+y)**2*(38804295141-88717211593*y+17906259258*y**2+177659041838*y**3
          -266745370013*y**4+105671297585*y**5+95401088668*y**6-114164491724*y**7
          +31418058091*y**8+9899800633*y**9-7507045526*y**10+1321155550*y**11-480659*y**12
          -24652929*y**13+743680*y**14)+2*r**14*(-1+y)**3*(5945843059-17029728270*y
          +4837008906*y**2+70321106040*y**3-134660239359*y**4+84095487058*y**5
          +10761135356*y**6-37168497616*y**7+14572412981*y**8+540814054*y**9-1609181142*y**10
          +302071064*y**11+19350135*y**12-7019146*y**13+748880*y**14)+r**12*(-1
          +y)**4*(15798847713-10891379223*y-3672465939*y**2-62126431271*y**3+123969656628*y**4
          -86939814728*y**5+36686644034*y**6-19594025494*y**7+6196236065*y**8+3095766737*y**9
          -2701875135*y**10+532383389*y**11+21835658*y**12-11217394*y**13+1070960*y**14)
          -8*r**18*(6406100115-27647816951*y+44841724289*y**2-25981719926*y**3
          -14027554373*y**4+29034862625*y**5-12793771253*y**6-4265641668*y**7+7136176437*y**8
          -3543052149*y**9+996403035*y**10-150073446*y**11-16702371*y**12+14397739*y**13
          -3488503*y**14+156400*y**15))+24*logy*r**4*(-1+y)**4*(-1+r**2+y)**5*(
          -67*r**36*(-1+y)**8-r**34*(-1+y)**6*(-8371+16407*y-7701*y**2+751*y**3)
          -r**32*(-1+y)**4*(-4165414+15817492*y-22057665*y**2+13919660*y**3-3983564*y**4
          +410072*y**5+2467*y**6)-r**30*(-1+y)**2*(-164041554+912718574*y-2081887215*y**2
          +2495745669*y**3-1667377239*y**4+597247379*y**5-94784781*y**6+2708731*y**7
          -144395*y**8+9071*y**9)+r**28*(1631286194-11918605392*y+37633441161*y**2
          -66932210774*y**3+72970659621*y**4-49242570404*y**5+19125198962*y**6
          -2910899736*y**7-655010876*y**8+346176164*y**9-50597355*y**10+3296830*y**11
          -44395*y**12)+r**26*(10787675558-73427698810*y+213012549617*y**2-338085998555*y**3
          +307455037991*y**4-140839364147*y**5+713355030*y**6+34200850710*y**7
          -16919012264*y**8+3343162044*y**9-263391591*y**10+22423285*y**11+147963*y**12
          -117631*y**13)+r**24*(18823928814-125752122436*y+362699386697*y**2-576721863724*y**3
          +516256850280*y**4-192734319032*y**5-92572584409*y**6+150478281208*y**7
          -76456384282*y**8+16260934348*y**9+544528023*y**10-1024573100*y**11+204870500*y**12
          -6447664*y**13-104423*y**14)+8*(-1+y)**12*(8+72*y+360*y**2+638*y**3
          -2242*y**4-14089*y**5-14770*y**6+4226*y**7+21512*y**8+10294*y**9-16354*y**10
          +1688*y**11+354*y**12-485*y**13+388*y**14)+r**2*(-1+y)**10*(-135775
          -932249*y-3665220*y**2-9197950*y**3-14073063*y**4-8045031*y**5+11599404*y**6
          +24205056*y**7+1713291*y**8-10693663*y**9-13974092*y**10+14150370*y**11
          -3721061*y**12+440959*y**13-128124*y**14+25148*y**15)+r**4*(-1+y)**9*(9341449
          +53948433*y+182767770*y**2+321781336*y**3+290769105*y**4-157510247*y**5
          -348505714*y**6-282939948*y**7+378539635*y**8-63584613*y**9+97595094*y**10
          -128793344*y**11+49495603*y**12-5439621*y**13-423742*y**14+110804*y**15)
          +r**22*(116192095402-685950136578*y+1655089027281*y**2-1963702578689*y**3
          +856773795840*y**4+615797052802*y**5-1016709108937*y**6+490987792695*y**7
          -17215588190*y**8-79270228278*y**9+33212850207*y**10-5626300835*y**11
          +423533524*y**12-11697546*y**13+9299513*y**14+191789*y**15)+r**6*(-1
          +y)**8*(-212006706-950469686*y-2608699245*y**2-2519301459*y**3-135161512*y**4
          +5444457278*y**5+845904125*y**6-739647827*y**7-5590165594*y**8+5064681022*y**9
          -1446102275*y**10+95353511*y**11-20785228*y**12+19550778*y**13-3854285*y**14
          +375103*y**15)+r**8*(-1+y)**7*(1249081286+4112675974*y+8962023801*y**2
          -2009492113*y**3-7319228788*y**4-19538550920*y**5+20457788619*y**6-6342665675*y**7
          +13686250198*y**8-17011198802*y**9+7408666879*y**10-632033543*y**11-413515976*y**12
          +124234740*y**13-13433635*y**14+997955*y**15)+r**18*(-1+y)**2*(161153711292
          -341005153052*y-18634624743*y**2+563835150039*y**3-302447617056*y**4
          -458701161870*y**5+648924116533*y**6-260157196095*y**7-40241496324*y**8
          +68913638776*y**9-22905448757*y**10+3448461969*y**11-282413112*y**12
          +57100210*y**13+3093255*y**14+1406935*y**15)+r**10*(-1+y)**6*(-9224758454
          -15623912202*y-20622493359*y**2+66994401163*y**3+12734076858*y**4+24351309500*y**5
          -173789164351*y**6+157442434413*y**7-39232661826*y**8-11193091986*y**9
          +6783891867*y**10-352754547*y**11-369206754*y**12+106999488*y**13-15961997*y**14
          +1948187*y**15)+r**16*(-1+y)**3*(-131960754290+374003671518*y-197069448735*y**2
          -718369311473*y**3+1333850517576*y**4-632532145380*y**5-409385473745*y**6
          +528415767321*y**7-112646658618*y**8-75317533186*y**9+40574652831*y**10
          -3036321423*y**11-1755379036*y**12+419089416*y**13-21112815*y**14+2120039*y**15)
          +r**12*(-1+y)**5*(-1875609534+4743940330*y+15479641683*y**2-41495611047*y**3
          +5500386538*y**4-85984757078*y**5+302931096975*y**6-297335576571*y**7
          +82155856134*y**8+37111337854*y**9-28115516167*y**10+5239024395*y**11
          +82831438*y**12-72209362*y**13-5539867*y**14+2704279*y**15)+r**14*(-1
          +y)**4*(-84354499786+106114561042*y+20542703691*y**2+212625513677*y**3
          -704491797812*y**4+602914779698*y**5-31856573975*y**6-232500635103*y**7
          +135997306470*y**8-22673097842*y**9-5643510019*y**10+3289241583*y**11
          -690564488*y**12+109145678*y**13-10250321*y**14+2717507*y**15)+r**20*(
          -26176924964+89462278552*y+53526870373*y**2-587302101674*y**3+788304245177*y**4
          +84931975944*y**5-1118453882127*y**6+1031211100494*y**7-229027131027*y**8
          -215065610504*y**9+170456659999*y**10-43928149262*y**11+375258683*y**12
          +2009687976*y**13-350891573*y**14+25861546*y**15+752387*y**16))+r**2*(
          -1+y)**2*(-1+r**2+y)**6*(33*r**40*(-1+y)**10+2*r**38*(-1+y)**8*(-748
          +1397*y-550*y**2+179*y**3)+r**36*(-1+y)**6*(24058-89062*y+115557*y**2
          -75204*y**3+37260*y**4-10174*y**5+1521*y**6)+6*r**34*(-1+y)**4*(151348
          -897467*y+2219705*y**2-2899613*y**3+2065385*y**4-724461*y**5+68119*y**6
          +24749*y**7-5589*y**8+416*y**9)-r**32*(-1+y)**2*(-196381925+1476470266*y
          -4801983989*y**2+8839748060*y**3-10113387970*y**4+7423301792*y**5-3472905218*y**6
          +987423604*y**7-151420597*y**8+9247382*y**9-129921*y**10+22112*y**11
          +2804*y**12)-8*r**30*(-410179876+3745137400*y-15210954675*y**2+36121209185*y**3
          -55362732039*y**4+56884439085*y**5-39175462566*y**6+17281851241*y**7
          -4168607270*y**8+148268880*y**9+182124601*y**10-35970899*y**11+808009*y**12
          +91075*y**13-18136*y**14+2385*y**15)-12*r**28*(-1468519418+12825567056*y
          -49630845654*y**2+111505553068*y**3-159486220146*y**4+148397079340*y**5
          -85555058159*y**6+23122001640*y**7+5110081123*y**8-7144111572*y**9+2864917632*y**10
          -615018720*y**11+81755904*y**12-7269976*y**13+101333*y**14-26564*y**15
          +1913*y**16)-(-1+y)**13*(-55-495*y-2475*y**2-5567*y**3-37591*y**4
          -152047*y**5-105575*y**6+114813*y**7+186491*y**8-37533*y**9-257313*y**10
          +149171*y**11+64363*y**12-65149*y**13+17299*y**14-2385*y**15-376*y**16
          +24*y**17)-2*r**2*(-1+y)**12*(1124+9925*y+48477*y**2+522139*y**3+1690277*y**4
          +2536773*y**5-1740807*y**6-6694277*y**7-3598055*y**8+2836247*y**9+6475991*y**10
          -3490919*y**11+862863*y**12-649649*y**13+14611*y**14+82897*y**15-5489*y**16
          +272*y**17)-3*r**4*(-1+y)**11*(-3199970-21318708*y-81568229*y**2-186870369*y**3
          -255305365*y**4-97573209*y**5+209239455*y**6+363211467*y**7-37006085*y**8
          -131498517*y**9-168159503*y**10+192205869*y**11-57658511*y**12+5943749*y**13
          -1458923*y**14+551977*y**15-39221*y**16+1693*y**17)+8*r**26*(12494731252
          -103011519922*y+371849624403*y**2-760886407139*y**3+940602429358*y**4
          -655714496408*y**5+124667388236*y**6+209072475427*y**7-215238699105*y**8
          +93605593806*y**9-17188875733*y**10-1154259709*y**11+1076707604*y**12
          -192681556*y**13+17606886*y**14+344589*y**15+20795*y**16+6016*y**17)
          -24*r**10*(-1+y)**8*(403605124+1092057352*y+2126330719*y**2-3178701191*y**3
          -2007133996*y**4-4821731798*y**5+11239923666*y**6-7206860353*y**7+5453513527*y**8
          -5227964452*y**9+2426202411*y**10-247268865*y**11-190688622*y**12+81521114*y**13
          -16807452*y**14+2747513*y**15-305153*y**16+9256*y**17)-2*r**6*(-1+y)**10*(149245324
          +810552663*y+2603618004*y**2+3952457782*y**3+2742872364*y**4-3507745438*y**5
          -3576332684*y**6-1912226334*y**7+5591212908*y**8-2148544196*y**9+970211516*y**10
          -1165139094*y**11+539501748*y**12-74397290*y**13-9590468*y**14+4012798*y**15
          -350360*y**16+13557*y**17)-6*r**16*(-1+y)**5*(-203078871421+285481476067*y
          +43097835455*y**2+399848869027*y**3-1529086008445*y**4+1236362575163*y**5
          +239224717429*y**6-787335730795*y**7+324688644959*y**8+26311586203*y**9
          -46118221015*y**10+8038063789*y**11+28578893*y**12+127441789*y**13-128138333*y**14
          +24005723*y**15-3761810*y**16+28522*y**17)+12*r**22*(-1+y)**2*(92689083396
          -511525635389*y+1118928172854*y**2-1092598396844*y**3+107976020408*y**4
          +815263909174*y**5-772250993462*y**6+203012826790*y**7+112823420808*y**8
          -97725417550*y**9+24161398426*y**10+106021184*y**11-1007022728*y**12
          +139268406*y**13+4862662*y**14+1300774*y**15+227812*y**16+34879*y**17)
          +4*r**18*(-1+y)**4*(704420497044-1886633847297*y+1099785272289*y**2
          +1326541982655*y**3-1451341663061*y**4-771071488297*y**5+1608872295567*y**6
          -498384531185*y**7-368093598743*y**8+317828441989*y**9-74312162961*y**10
          -6733737491*y**11+7170986605*y**12-1506713987*y**13+209138497*y**14-19499611*y**15
          +4375371*y**16+44616*y**17)-8*r**14*(-1+y)**6*(-28412426996+292946726*y
          +22176468807*y**2+98642337261*y**3-107920402392*y**4-117211854132*y**5
          +244436746363*y**6-126249498694*y**7-18834496658*y**8+43489594311*y**9
          -14517981963*y**10+258427449*y**11+344573108*y**12+154938282*y**13-102276359*y**14
          +20031776*y**15-2623078*y**16+47389*y**17)-4*r**12*(-1+y)**7*(-24489148226
          -29514499554*y-28191418872*y**2+187357077624*y**3-14661817328*y**4+6870500380*y**5
          -452756321571*y**6+519518029811*y**7-128492704577*y**8-88528351391*y**9
          +56603930218*y**10-7344703994*y**11-2286746322*y**12+946500318*y**13
          -190601791*y**14+30346143*y**15-3602891*y**16+90423*y**17)-r**8*(-1
          +y)**9*(-3484715171-13956520237*y-34860607824*y**2-18616951712*y**3
          +20696662900*y**4+90799182556*y**5-18227549668*y**6-23605169084*y**7
          -80157922470*y**8+99795450006*y**9-33712152568*y**10-1147207672*y**11
          +2258849036*y**12-93407068*y**13-106620756*y**14+26605908*y**15-2708023*y**16
          +93847*y**17)+2*r**20*(-1+y)**3*(836156940930-3582090675360*y+5187567773595*y**2
          -1633361084289*y**3-3017952228725*y**4+2726156759471*y**5+61774532037*y**6
          -738597945419*y**7-21922253379*y**8+268569124361*y**9-85876332843*y**10
          -13221077767*y**11+12798573053*y**12-2602763407*y**13+280563339*y**14
          -6172333*y**15+4583865*y**16+214071*y**17)+2*r**24*(4689953377-33142767658*y
          +144137141985*y**2-452332159568*y**3+922965581708*y**4-1096767104632*y**5
          +554313915062*y**6+285789838100*y**7-620376061698*y**8+369761592376*y**9
          -53830973600*y**10-49962067688*y**11+32270767692*y**12-8468166128*y**13
          +955950666*y**14-11734620*y**15+6163209*y**16+17498*y**17+113919*y**18)))*math.log(mu0**2/r**2))/(41803776000*logy**6*r**24*(
          -1+y)**12+20901888000*logy**5*r**20*(-1+y)**10*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+4354560000*logy**4*r**16*(-1+y)**8*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+483840000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +30240000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**4+1008000*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**5+14000*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**6))
      resNP += ((api*(-217728000*logy**5*r**18*(176
          +449*r**2+594*r**4+489*r**6+246*r**8+60*r**10)*(-1+y)**12-518400*logy**4*r**14*(
          -1+y)**10*(22140*r**16*(-1+y)**2+4512*r**18*(-1+y)**2-9*r**14*(-24593
          +35186*y-3593*y**2-8820*y**3+1400*y**4)+420*r**12*(1247-1264*y-598*y**2
          +667*y**3-38*y**4+8*y**5)+12*(-1+y)**3*(229+229*y+229*y**2-4391*y**3
          +3274*y**4-590*y**5+40*y**6)+21*r**10*(23193+2514*y-50157*y**2+19340*y**3
          +7890*y**4-3420*y**5+880*y**6)+28*r**8*(-1874+48298*y-68699*y**2+9740*y**3
          +18355*y**4-7781*y**5+1522*y**6+144*y**7)+5*r**2*(-1+y)**2*(-16601
          +33544*y**3-42511*y**4+21672*y**5-3360*y**6+200*y**7)-105*r**6*(5537
          -20054*y+19007*y**2-656*y**3-4971*y**4+1062*y**5+515*y**6-352*y**7
          +24*y**8)+12*r**4*(-44931+120662*y-91131*y**2+6615*y**3-5810*y**4
          +32851*y**5-26537*y**6+9266*y**7-1025*y**8+40*y**9))-17280*logy**3*r**10*(
          -1+y)**8*(-1+r**2+y)**2*(4698*r**22*(-1+y)**4-4*r**20*(-1+y)**2*(-16975
          +36299*y-21673*y**2+3339*y**3)-r**18*(-1+y)**2*(-1157975+1919706*y
          -650301*y**2-111516*y**3+19146*y**4)+2*r**16*(-1+y)**2*(2213883-3788499*y
          +1444773*y**2+341343*y**3-170654*y**4+26124*y**5)+r**14*(25721072-80702606*y
          +85270251*y**2-23876720*y**3-14644660*y**4+9023758*y**5-652859*y**6
          -172256*y**7+26670*y**8)-12*(-1+y)**4*(67+134*y+201*y**2-1042*y**3
          +2045*y**4+148*y**5-16869*y**6+20864*y**7-8218*y**8+920*y**9)-2*r**12*(
          -32647671+98917175*y-96446282*y**2+15007604*y**3+29025249*y**4-15593439*y**5
          +969770*y**6+1182302*y**7-441714*y**8+39606*y**9)+r**10*(84744114-255166282*y
          +245356045*y**2-39692124*y**3-59462959*y**4+19111082*y**5+10860287*y**6
          -7016460*y**7+1114789*y**8+144704*y**9-11046*y**10)-r**2*(-1+y)**3*(34895
          +33287*y+31679*y**2-1251989*y**3+1035753*y**4-249615*y**5+1324503*y**6
          -1796489*y**7+995704*y**8-265488*y**9+23760*y**10)-2*r**4*(-1+y)**2*(
          -926919+130789*y+49555*y**2+7333441*y**3-13075633*y**4+8430051*y**5
          -2418339*y**6+936915*y**7-812596*y**8+366728*y**9-82512*y**10+5520*y**11)
          +2*r**8*(28475555-84362647*y+80309816*y**2-25121514*y**3+18821176*y**4
          -41133344*y**5+32055450*y**6-8895666*y**7-1276011*y**8+1420399*y**9
          -315786*y**10+33072*y**11)+r**6*(13506094-33856450*y+25100757*y**2
          -35513416*y**3+115405524*y**4-164689084*y**5+111843844*y**6-33280240*y**7
          -1318634*y**8+3519926*y**9-758785*y**10+26856*y**11+13608*y**12))-1440*logy**2*r**6*(
          -1+y)**6*(-1+r**2+y)**3*(276*r**28*(-1+y)**6-12*r**26*(-1+y)**4*(-1314
          +2697*y-1452*y**2+187*y**3)-3*r**24*(-1+y)**2*(-168133+632200*y-876210*y**2
          +527508*y**3-113829*y**4-2228*y**5+492*y**6)+3*r**22*(-1+y)**2*(1286377
          -4794775*y+6614430*y**2-3968430*y**3+762957*y**4+156529*y**5-58768*y**6
          +4660*y**7)+r**20*(-1+y)**2*(38832791-124169258*y+135117966*y**2-45118484*y**3
          -14020321*y**4+10260174*y**5-882858*y**6-45180*y**7+2880*y**8)-r**18*(
          -1+y)**2*(-99238517+322890959*y-366337098*y**2+126300938*y**3+56761903*y**4
          -48855117*y**5+8246562*y**6+741954*y**7-535332*y**8+38448*y**9)-6*r**16*(
          -83469054+383763299*y-679943291*y**2+521812353*y**3-49152540*y**4-183271415*y**5
          +101611706*y**6-2081447*y**7-12200003*y**8+3142950*y**9-182956*y**10
          -31310*y**11+1008*y**12)+2*(-1+y)**6*(19+57*y+114*y**2-194*y**3
          +1530*y**4+1086*y**5-15716*y**6+17844*y**7-6141*y**8-23215*y**9+41010*y**10
          -23826*y**11+4632*y**12)+r**2*(-1+y)**5*(3391+6668*y+9831*y**2-173948*y**3
          +151886*y**4-37296*y**5-895160*y**6+1490144*y**7-729753*y**8+599324*y**9
          -856535*y**10+527052*y**11-148140*y**12+18936*y**13)+2*r**14*(526822559
          -2385687609*y+4096967898*y**2-2864532896*y**3-208628817*y**4+1532190843*y**5
          -772207973*y**6-36542439*y**7+164981907*y**8-60841283*y**9+6183168*y**10
          +1681872*y**11-406674*y**12+27144*y**13)+3*r**4*(-1+y)**4*(-23359-17064*y
          -15517*y**2-1311718*y**3+828946*y**4+343976*y**5+6996916*y**6-15161968*y**7
          +12401889*y**8-4960064*y**9+1049153*y**10-246282*y**11+109580*y**12
          -25576*y**13+3088*y**14)-r**8*(-1+y)**2*(-69782647+116967112*y-35862936*y**2
          +430371148*y**3-1414050277*y**4+1731563868*y**5-977526440*y**6+214359836*y**7
          -1961487*y**8+21192028*y**9-19888096*y**10+4910328*y**11-30225*y**12
          -181536*y**13+3324*y**14)+2*r**12*(483983225-2183725230*y+3751312740*y**2
          -2797487834*y**3+517262790*y**4+172216560*y**5+422113120*y**6-555548430*y**7
          +188448828*y**8+30087400*y**9-36624930*y**10+8159940*y**11-155055*y**12
          -50514*y**13+4590*y**14)+r**6*(-1+y)**3*(-7000423+1447566*y+766986*y**2
          +86193298*y**3-169899219*y**4+123757236*y**5-100290032*y**6+167485428*y**7
          -169389951*y**8+84908518*y**9-17963418*y**10-1409214*y**11+1526781*y**12
          -269352*y**13+23796*y**14)-6*r**10*(-50596931+205800111*y-311109498*y**2
          +297069250*y**3-535578084*y**4+1055641858*y**5-1179207066*y**6+670724022*y**7
          -106429694*y**8-98036106*y**9+66951078*y**10-16128470*y**11+412001*y**12
          +617269*y**13-136510*y**14+6770*y**15))-12*logy*r**4*(-1+y)**4*(-1+r**2
          +y)**4*(2070*r**30*(-1+y)**8-3*r**28*(-1+y)**6*(-123305+227290*y-95705*y**2
          +4736*y**3)-6*r**26*(-1+y)**4*(-1493535+5580370*y-7666300*y**2+4682968*y**3
          -1167399*y**4+38774*y**5+10522*y**6)+3*r**24*(-1+y)**2*(45598135-244397630*y
          +532432235*y**2-593937556*y**3+341310151*y**4-75504990*y**5-12760375*y**6
          +7922440*y**7-673034*y**8+2624*y**9)+2*r**22*(-1+y)**3*(-316652035+1349966495*y
          -2220675760*y**2+1679333354*y**3-434161914*y**4-150250380*y**5+108245440*y**6
          -17282630*y**7+706981*y**8+103249*y**9)-r**20*(-1+y)**2*(-5549848235
          +26045848490*y-47402420865*y**2+38768293248*y**3-7748546734*y**4-9357381956*y**5
          +6337575302*y**6-891568760*y**7-272866323*y**8+77090634*y**9-6366209*y**10
          +6608*y**11)-2*r**18*(-1+y)**2*(-3849299605+18660251600*y-36294835735*y**2
          +33331194012*y**3-9535575218*y**4-7694508488*y**5+7116590162*y**6-1555730948*y**7
          -385549337*y**8+255210468*y**9-47784007*y**10-87412*y**11+250508*y**12)
          +r**16*(49871660365-300701149940*y+742763388790*y**2-912926826404*y**3
          +453780988323*y**4+186241867056*y**5-361364951180*y**6+137507593600*y**7
          +43029747103*y**8-51957695236*y**9+14053354618*y**10+465903220*y**11
          -914738415*y**12+154770776*y**13-3856612*y**14-84064*y**15)+(-1+y)**8*(
          -3145-12580*y-31450*y**2-164508*y**3-144959*y**4-146168*y**5-714760*y**6
          +398320*y**7+35701*y**8-507332*y**9+983586*y**10-359460*y**11-26045*y**12
          +11632*y**13-38384*y**14+19552*y**15)+2*r**2*(-1+y)**7*(-87535-251755*y
          -484090*y**2-3438186*y**3-1906913*y**4-1502501*y**5+4088720*y**6-3057980*y**7
          +4647067*y**8+18122251*y**9-32198238*y**10+18689310*y**11-5274155*y**12
          +1127269*y**13-349688*y**14+84424*y**15)+2*r**10*(-1+y)**3*(-4591507295
          +10339467745*y-5923547570*y**2+24473386252*y**3-92954889849*y**4+134535429027*y**5
          -85988105600*y**6+11130345370*y**7+17606192791*y**8-10546916617*y**9
          +1613330206*y**10+552037480*y**11-294356175*y**12+52817957*y**13-1556284*y**14
          +112562*y**15)+r**8*(-1+y)**4*(1629772375-1267175120*y-288195620*y**2
          -15566308148*y**3+37973718621*y**4-33979868868*y**5+20315597410*y**6
          -22930058360*y**7+25026658201*y**8-14056794232*y**9+2774044576*y**10
          +826730860*y**11-561481245*y**12+109556972*y**13-5117614*y**14+320192*y**15)
          +2*r**6*(-1+y)**5*(-52984025-47511125*y-38330885*y**2+951961489*y**3
          -999919773*y**4+284051499*y**5-2566542425*y**6+6064277605*y**7-5614671083*y**8
          +2421029801*y**9-352157183*y**10-78996125*y**11+25971105*y**12+2407169*y**13
          -1391203*y**14+341159*y**15)+r**4*(-1+y)**6*(-7314175-13135930*y-17935555*y**2
          -24752628*y**3-59759219*y**4+41320642*y**5+634781585*y**6-962656160*y**7
          +566054191*y**8-362270822*y**9+379213611*y**10-249463980*y**11+76910515*y**12
          -6569138*y**13-1774409*y**14+519472*y**15)+r**12*(-1+y)**2*(28889088985
          -105401621150*y+134936324335*y**2-93846175244*y**3+153691900473*y**4
          -296789118354*y**5+276750501415*y**6-91898843960*y**7-37405077557*y**8
          +43719621854*y**9-13421551427*y**10+131986660*y**11+769638675*y**12-130285774*y**13
          +5314973*y**14+872096*y**15)+2*r**14*(39504919385-240209195160*y+599171714880*y**2
          -746458654092*y**3+379774858216*y**4+158791786944*y**5-333566712088*y**6
          +156707298660*y**7+19112084754*y**8-51775146712*y**9+22438361152*y**10
          -2877681924*y**11-1016965040*y**12+462087088*y**13-60630504*y**14+1417644*y**15
          +456797*y**16))-(-1+y)**4*(-1+r**2+y)**5*(20*r**36*(-1+y)**8+r**34*(
          -1+y)**6*(-875+1650*y-675*y**2+168*y**3)-r**32*(-1+y)**4*(-157905
          +602505*y-843690*y**2+513738*y**3-118285*y**4+5021*y**5+1520*y**6)
          -r**30*(-1+y)**2*(-8232440+45716070*y-103907805*y**2+123584604*y**3
          -81072615*y**4+27787834*y**5-3849895*y**6+1296*y**7-30757*y**8+8828*y**9)
          +r**28*(101378480-740976950*y+2337590215*y**2-4145344161*y**3+4491991612*y**4
          -2998802956*y**5+1144622070*y**6-171001070*y**7-33861124*y**8+16085058*y**9
          -1780029*y**10+110095*y**11-8040*y**12)+r**26*(1084620480-7472272490*y
          +21927297535*y**2-35248016096*y**3+32723013593*y**4-15963555808*y**5
          +1465773746*y**6+2580713480*y**7-1306527814*y**8+207545942*y**9+3128983*y**10
          -1623656*y**11-116795*y**12+24500*y**13)+r**24*(2691377480-18149782050*y
          +52489396545*y**2-83724590555*y**3+77360783013*y**4-36758667921*y**5
          +1072062014*y**6+8653703094*y**7-4409265366*y**8+772975428*y**9+23339361*y**10
          -27281619*y**11+6481281*y**12-595609*y**13+42504*y**14)-r**22*(-31790359840
          +197800349510*y-508805392825*y**2+670248070492*y**3-411651170134*y**4
          -25228685642*y**5+211800286993*y**6-127114212892*y**7+18036689164*y**8
          +11197147026*y**9-5174576783*y**10+679512372*y**11+13886842*y**12-11740206*y**13
          +228583*y**14+23340*y**15)-r**20*(4006321920-22004495890*y+31102267025*y**2
          +34216458089*y**3-153901065022*y**4+197414016616*y**5-128159597021*y**6
          +44613127235*y**7-7918499348*y**8+614753254*y**9+22620943*y**10-46185273*y**11
          +73098690*y**12-34211916*y**13+2438893*y**14-1225379*y**15+65184*y**16)
          -(-1+y)**9*(685+4110*y+14385*y**2+34248*y**3+63325*y**4+92190*y**5
          +61229*y**6+15808*y**7-54561*y**8-57870*y**9-46325*y**10-15288*y**11
          +68079*y**12-11062*y**13+4695*y**14-2000*y**15-5976*y**16+2328*y**17)
          -r**6*(-1+y)**6*(10760240+30673170*y+57338145*y**2-10092244*y**3+50660883*y**4
          -24574854*y**5-303728195*y**6+119821080*y**7-10002777*y**8+680208154*y**9
          -1090958277*y**10+705165660*y**11-205136415*y**12+25719446*y**13-6550137*y**14
          +2822016*y**15-549035*y**16+7140*y**17)-r**8*(-1+y)**5*(29979600+95535650*y
          +149444325*y**2-1122848916*y**3-89881263*y**4+247670874*y**5+7700501625*y**6
          -13743536420*y**7+9494236137*y**8-4315250034*y**9+2910346447*y**10-1860132780*y**11
          +585605355*y**12-18974546*y**13-39810253*y**14+10596804*y**15-1572245*y**16
          +9640*y**17)-r**2*(-1+y)**8*(33495+164050*y+481875*y**2+1091028*y**3
          +1684071*y**4+1988410*y**5+800931*y**6-394120*y**7-1489631*y**8-618702*y**9
          -683655*y**10+131668*y**11+1108245*y**12-540522*y**13+164081*y**14-33600*y**15
          -35924*y**16+12300*y**17)-r**4*(-1+y)**7*(766940+2941450*y+7029255*y**2
          +13488776*y**3+16827869*y**4+13760446*y**5-25517153*y**6-302768*y**7
          -18983867*y**8-21412758*y**9+35393333*y**10-10715864*y**11+9320231*y**12
          -7262534*y**13+1416389*y**14+170656*y**15-140933*y**16+20532*y**17)
          +r**14*(-1+y)**2*(40081779480-114070796610*y+97490017935*y**2-197171067924*y**3
          +794758546745*y**4-1359217703114*y**5+1015831480659*y**6-128123300576*y**7
          -328921814587*y**8+231446774310*y**9-45511353267*y**10-13478523588*y**11
          +8164641387*y**12-1406923814*y**13+105253745*y**14-2012424*y**15+1431839*y**16
          +49804*y**17)+r**18*(257676630570-1452967590050*y+3267089129335*y**2
          -3369862740248*y**3+683781089271*y**4+1983803183182*y**5-1948097422105*y**6
          +387426194940*y**7+432526309231*y**8-300495225202*y**9+49338879781*y**10
          +16676926640*y**11-7802804995*y**12+842495442*y**13+78469181*y**14-17870708*y**15
          +1772915*y**16+52820*y**17)-r**10*(-1+y)**4*(-1364159320-278017170*y
          +47136355*y**2+17869845240*y**3-26748741457*y**4+13092689966*y**5-33988883933*y**6
          +87411793564*y**7-93425734125*y**8+44661398094*y**9-3761002207*y**10
          -5489930864*y**11+2217799597*y**12-154760590*y**13-79205287*y**14+16926236*y**15
          -2701783*y**16+75684*y**17)-r**12*(-1+y)**3*(10005954400-13822614050*y
          +1061633095*y**2-81031576592*y**3+249781464025*y**4-276086620066*y**5
          +143618905423*y**6-59016839000*y**7+50266020009*y**8-32309638190*y**9
          +5622508957*y**10+3585959824*y**11-2069777165*y**12+511428058*y**13-99996435*y**14
          +10557784*y**15-2598197*y**16+92120*y**17)+r**16*(97685910890-513306920220*y
          +1068154267305*y**2-1057488130723*y**3+427248614379*y**4-28663079289*y**5
          +138392959613*y**6-218941417695*y**7+84099857271*y**8+16581607687*y**9
          -15029998437*y**10+1490413599*y**11-1065025775*y**12+1203274437*y**13
          -457151241*y**14+104809411*y**15-11137917*y**16+989865*y**17+156840*y**18)))*nlo.X1El(0,'SM',y/2,r))/(41803776000*logy**6*r**24*(
          -1+y)**12+20901888000*logy**5*r**20*(-1+y)**10*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+4354560000*logy**4*r**16*(-1+y)**8*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+483840000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +30240000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**4+1008000*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**5+14000*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**6))
      resNP += ((api*(-18144000*logy**4*r**15*(46
          +83*r**2+80*r**4+45*r**6+12*r**8)*(-1+y)**10-86400*logy**3*r**11*(-1
          +y)**8*(1312*r**14*(-1+y)**2+472*r**16*(-1+y)**2-7*r**12*(-2429+3418*y
          -269*y**2-915*y**3+180*y**4)+7*r**10*(5216-5032*y-2884*y**2+2905*y**3
          -285*y**4+60*y**5)+35*r**8*(681+558*y-2199*y**2+682*y**3+382*y**4
          -191*y**5+52*y**6)+(-1+y)**3*(87+87*y+87*y**2-6283*y**3+5092*y**4
          -1040*y**5+80*y**6)+7*r**6*(-2936+15832*y-17876*y**2+1180*y**3+5670*y**4
          -2799*y**5+623*y**6+36*y**7)+r**2*(-1+y)**2*(-9208+10605*y**3-13965*y**4
          +8148*y**5-1330*y**6+80*y**7)-7*r**4*(7041-19602*y+15321*y**2+195*y**3
          -4015*y**4+719*y**5+777*y**6-476*y**7+40*y**8))-1440*logy**2*r**7*(-1
          +y)**6*(-1+r**2+y)**2*(866*r**20*(-1+y)**4-r**18*(-1+y)**2*(-7971+17674*y
          -11435*y**2+2772*y**3)-r**16*(-1+y)**2*(-170979+274672*y-81485*y**2
          -21775*y**3+3722*y**4)+r**14*(-1+y)**2*(378732-711016*y+348065*y**2
          +39601*y**3-47388*y**4+10416*y**5)+r**12*(2867580-8799676*y+8910451*y**2
          -2043295*y**3-1903700*y**4+1043875*y**5-41719*y**6-40026*y**7+5110*y**8)
          -(-1+y)**4*(177+354*y+531*y**2-9712*y**3+5415*y**4-1802*y**5-33379*y**6
          +48344*y**7-20888*y**8+2560*y**9)-r**10*(-7035366+21252160*y-20428801*y**2
          +2528581*y**3+7278746*y**4-4340659*y**5+592290*y**6+273526*y**7-134981*y**8
          +15204*y**9)+r**8*(7375734-22440244*y+22051981*y**2-4522609*y**3-4385409*y**4
          +1517943*y**5+968569*y**6-674081*y**7+95859*y**8+21959*y**9-1302*y**10)
          +r**4*(-1+y)**2*(274698-22864*y-15565*y**2-2227211*y**3+4252003*y**4
          -2935604*y**5+673869*y**6+104695*y**7-63509*y**8+8152*y**9+1736*y**10)
          -r**2*(-1+y)**3*(-3425-3779*y-4133*y**2-244042*y**3+251339*y**4-61155*y**5
          +142909*y**6-187762*y**7+102322*y**8-28434*y**9+2560*y**10)+r**6*(2001276
          -5149120*y+3949567*y**2-3385243*y**3+10069747*y**4-14621355*y**5+10004337*y**6
          -2962467*y**7-223457*y**8+413953*y**9-110046*y**10+12808*y**11))-24*logy*r**3*(
          -1+y)**4*(-1+r**2+y)**3*(124*r**26*(-1+y)**6-4*r**24*(-1+y)**4*(-2024
          +4141*y-2210*y**2+473*y**3)-r**22*(-1+y)**2*(-279741+1039704*y-1414110*y**2
          +821525*y**3-158995*y**4-10219*y**5+836*y**6)+r**20*(-1+y)**2*(1216919
          -4671119*y+6783810*y**2-4611640*y**3+1315345*y**4+66951*y**5-103246*y**6
          +11680*y**7)+5*r**18*(-1+y)**2*(3952987-12399292*y+12901560*y**2-3536353*y**3
          -1971707*y**4+1145121*y**5-79870*y**6-14022*y**7+456*y**8)-r**16*(-1
          +y)**2*(-16243217+61756553*y-90149592*y**2+52232158*y**3+2938233*y**4
          -15611383*y**5+5658772*y**6-216308*y**7-306908*y**8+31992*y**9)-2*r**14*(
          -99397639+447087702*y-760883973*y**2+525679005*y**3+35335160*y**4-260518422*y**5
          +116802196*y**6+13873056*y**7-22950255*y**8+5024990*y**9+58611*y**10
          -117823*y**11+3892*y**12)+(-1+y)**6*(89+267*y+534*y**2-6200*y**3
          +620*y**4-1938*y**5-39474*y**6+42512*y**7-13925*y**8-14745*y**9+41724*y**10
          -30168*y**11+6704*y**12)-r**6*(-1+y)**3*(3291509-291267*y-428253*y**2
          -50003974*y**3+110194635*y**4-89557158*y**5+42837394*y**6-37227984*y**7
          +35101883*y**8-17433835*y**9+4115699*y**10-219202*y**11-101963*y**12
          +2516*y**13)-10*r**8*(-1+y)**2*(-3378079+5716129*y-1713420*y**2+18827756*y**3
          -64928536*y**4+83530232*y**5-48091744*y**6+5561134*y**7+8279937*y**8
          -4716339*y**9+975972*y**10-12410*y**11-32314*y**12+2682*y**13)+r**2*(
          -1+y)**5*(-2391-5049*y-7974*y**2-318101*y**3+195315*y**4-48283*y**5
          -522397*y**6+1220773*y**7-684678*y**8+225860*y**9-268901*y**10+171496*y**11
          -46374*y**12+6704*y**13)+r**4*(-1+y)**4*(-243649-214969*y-196375*y**2
          -1583377*y**3+1295300*y**4+1045358*y**5+9828958*y**6-23915370*y**7+21064319*y**8
          -8489725*y**9+897241*y**10+416211*y**11-130930*y**12+17008*y**13)+2*r**12*(196237109
          -904195479*y+1589045601*y**2-1157042431*y**3-66406220*y**4+702358182*y**5
          -470010022*y**6+91351038*y**7+42602047*y**8-30238155*y**9+6282709*y**10
          +208501*y**11-221264*y**12+21384*y**13)+2*r**10*(69385171-289251138*y
          +449968683*y**2-348654421*y**3+309773170*y**4-531778662*y**5+614392506*y**6
          -358809186*y**7+70005447*y**8+33530690*y**9-22644759*y**10+3930507*y**11
          +245128*y**12-99526*y**13+6390*y**14))+r*(-1+y)**3*(-1+r**2+y)**4*(29*r**28*(
          -1+y)**7+2*r**26*(-1+y)**5*(-9679+17812*y-7331*y**2+803*y**3)+r**24*(
          -1+y)**3*(-416467+1545904*y-2105392*y**2+1321998*y**3-395457*y**4
          +34010*y**5+4964*y**6)+2*r**22*(3729334-23521398*y+62275708*y**2-88696836*y**3
          +71352580*y**4-29491797*y**5+2675613*y**6+2411082*y**7-787624*y**8+53085*y**9
          +253*y**10)+r**20*(9712151-63445793*y+180316883*y**2-291967077*y**3
          +291693498*y**4-175201964*y**5+48861214*y**6+7787392*y**7-10333673*y**8
          +2819277*y**9-232537*y**10-9371*y**11)+2*r**18*(170110489-970748873*y
          +2251511909*y**2-2607457140*y**3+1328041785*y**4+179521477*y**5-578525259*y**6
          +262463037*y**7-25598860*y**8-12427060*y**9+3343934*y**10-238593*y**11
          +3154*y**12)+r**16*(-332810921+1798678843*y-3699927499*y**2+3185081187*y**3
          +6873470*y**4-2151467458*y**5+1564284754*y**6-312374462*y**7-99702549*y**8
          +34289955*y**9+12628729*y**10-5920197*y**11+337536*y**12+28612*y**13)
          -4*r**14*(-763803634+3953792250*y-8007121780*y**2+7155626336*y**3-727122542*y**4
          -3991872507*y**5+3100911685*y**6-434505120*y**7-504310742*y**8+243271074*y**9
          -13497184*y**10-14529260*y**11+3372450*y**12-172669*y**13+3643*y**14)
          -(-1+y)**7*(-1219-4876*y-12190*y**2-53726*y**3-57599*y**4-60452*y**5
          -100308*y**6+64600*y**7+28027*y**8+27928*y**9+40246*y**10-31866*y**11
          -6585*y**12-3976*y**13+3996*y**14)-2*r**2*(-1+y)**6*(-28999-83491*y
          -160504*y**2-509763*y**3-291798*y**4-141107*y**5+856942*y**6-335092*y**7
          +514091*y**8+656701*y**9-1729794*y**10+1115399*y**11-309054*y**12+15897*y**13
          +10572*y**14)-2*r**6*(-1+y)**4*(-1747494-2692674*y-2217888*y**2+52654704*y**3
          -70516058*y**4+25629523*y**5-96509077*y**6+252384516*y**7-254549278*y**8
          +116511436*y**9-13147154*y**10-9611124*y**11+3714622*y**12-348301*y**13
          +24247*y**14)-r**4*(-1+y)**5*(-1031203-1894810*y-2581795*y**2+3056192*y**3
          -7588199*y**4+5658616*y**5+39989175*y**6-72121960*y**7+47385311*y**8
          -15138362*y**9+4687187*y**10-2631640*y**11+745355*y**12-89028*y**13
          +43161*y**14)-2*r**10*(-1+y)**2*(-207985809+481541039*y-286500000*y**2
          +903503009*y**3-3590310564*y**4+5467058788*y**5-3683170003*y**6+499750230*y**7
          +846157067*y**8-533705057*y**9+100893146*y**10+6724089*y**11-3308230*y**12
          +60174*y**13+48121*y**14)-r**8*(-1+y)**3*(81688601-63125904*y-18246624*y**2
          -824402394*y**3+2199417281*y**4-2172958442*y**5+946134068*y**6-139090092*y**7
          -20820877*y**8+21920348*y**9-4309184*y**10-10996314*y**11+6408691*y**12
          -838754*y**13+59596*y**14)+r**12*(1245892009-5951388223*y+10981863373*y**2
          -8856690651*y**3+612412525*y**4+5215282129*y**5-5578071319*y**6+3153249589*y**7
          -512278213*y**8-784685165*y**9+649390375*y**10-190326833*y**11+12655663*y**12
          +2907739*y**13-123485*y**14-89513*y**15)))*nlo.X1El(0,'VR',y/2,r))/(-3483648000*logy**5*r**20*(
          -1+y)**10+14000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-1451520000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-241920000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-20160000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -840000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*(-1512000*logy**3*r**12*(19+19*r**2+11*r**4
          +3*r**6)*(-1+y)**8-3600*logy**2*r**8*(-1+y)**6*(175*r**12*(-1+y)**2+255*r**14*(
          -1+y)**2-7*r**10*(-897+1254*y-87*y**2-340*y**3+90*y**4)+35*r**8*(405
          -414*y-189*y**2+204*y**3-38*y**4+8*y**5)-35*r**2*(-1+y)**2*(213-5*y**4
          -32*y**5+4*y**6)+35*r**6*(275+134*y-751*y**2+196*y**3+143*y**4-82*y**5
          +25*y**6)+35*r**4*(-669+2022*y-1695*y**2+52*y**3+495*y**4-282*y**5
          +77*y**6)+(-1+y)**3*(-361-361*y-361*y**2-4001*y**3+3804*y**4-900*y**5
          +80*y**6))-60*logy*r**4*(-1+y)**4*(-1+r**2+y)**2*(355*r**18*(-1+y)**4
          -r**16*(-1+y)**2*(-1153+3016*y-2573*y**2+1470*y**3)-r**14*(-1+y)**2*(
          -64706+101828*y-25903*y**2-10734*y**3+1755*y**4)+r**12*(-1+y)**2*(8214
          -66656*y+94159*y**2-16866*y**3-12551*y**4+5180*y**5)+r**10*(692212
          -2030424*y+1848647*y**2-169180*y**3-586485*y**4+241888*y**5+27709*y**6
          -25452*y**7+2485*y**8)+r**2*(-1+y)**3*(19399+17793*y+16187*y**2+142341*y**3
          -189095*y**4+52111*y**5-17483*y**6+7323*y**7+1544*y**8+280*y**9)-5*r**8*(
          -436732+1374912*y-1414175*y**2+301728*y**3+420651*y**4-337498*y**5
          +90783*y**6+5140*y**7-8743*y**8+1414*y**9)-(-1+y)**4*(-803-1606*y
          -2409*y**2-13492*y**3+4295*y**4-1662*y**5-7059*y**6+18944*y**7-10248*y**8
          +1440*y**9)+r**4*(-1+y)**2*(115834+6128*y-13123*y**2-627214*y**3+1390935*y**4
          -1107204*y**5+299327*y**6+34778*y**7-29781*y**8+5920*y**9)+r**6*(883662
          -2380808*y+1934387*y**2-460068*y**3+323372*y**4-509292*y**5+263858*y**6
          -41212*y**7-26282*y**8+12628*y**9-245*y**10))+(-1+y)**2*(-1+r**2
          +y)**3*(23*r**24*(-1+y)**6+r**22*(-1+y)**4*(-1636+3203*y-1498*y**2
          +611*y**3)-r**20*(-1+y)**2*(53282-196667*y+264360*y**2-147190*y**3
          +20590*y**4+6593*y**5+32*y**6)-5*r**18*(-1+y)**2*(-10084+25495*y-2964*y**2
          -59086*y**3+67984*y**4-18137*y**5-3136*y**6+768*y**7)-5*r**16*(-1+y)**2*(981683
          -3134849*y+3304164*y**2-878638*y**3-577695*y**4+335767*y**5-23846*y**6
          -7224*y**7+78*y**8)+2*r**14*(-1+y)**2*(5042852-15034913*y+12846762*y**2
          +344847*y**3-4593008*y**4+1133298*y**5+522238*y**6-184337*y**7-20172*y**8
          +5433*y**9)+r**4*(-1+y)**4*(239598+215739*y+172968*y**2+711145*y**3
          -1068910*y**4-13636*y**5-698198*y**6+2381464*y**7-2629420*y**8+1381385*y**9
          -259362*y**10-13441*y**11+668*y**12)+5*r**6*(-1+y)**3*(61652+93801*y
          -18903*y**2-1950935*y**3+5284025*y**4-5051584*y**5+1856368*y**6+72856*y**7
          -504180*y**8+374135*y**9-110233*y**10+4191*y**11+807*y**12)-(-1+y)**6*(
          -863-2589*y-5178*y**2-18310*y**3-7640*y**4-6544*y**5-7722*y**6+26426*y**7
          -4265*y**8+1565*y**9-668*y**10-3764*y**11+1552*y**12)-5*r**8*(-1+y)**2*(1495819
          -2607070*y+733134*y**2-3703654*y**3+14693541*y**4-21082902*y**5+14135366*y**6
          -3338562*y**7-900021*y**8+514084*y**9-5492*y**10-19896*y**11+1653*y**12)
          +2*r**12*(-24565894+116636943*y-212534784*y**2+167628370*y**3-16908815*y**4
          -61310837*y**5+33962579*y**6+2466173*y**7-7236645*y**8+1921290*y**9
          +4081*y**10-50547*y**11+2086*y**12)-r**2*(-1+y)**5*(-24876-47163*y
          -66861*y**2-298290*y**3+176270*y**4-4768*y**5-46084*y**6+399422*y**7
          -301510*y**8+50555*y**9-6031*y**10-2428*y**11+3764*y**12)-2*r**10*(13546628
          -58709229*y+95512344*y**2-62747978*y**3-12826120*y**4+65626674*y**5
          -74365612*y**6+48658242*y**7-16017164*y**8+210745*y**9+1369948*y**10
          -237784*y**11-27336*y**12+6642*y**13)))*nlo.X1El(0,'VR2',y/2,r))/(580608000*logy**4*r**16*(
          -1+y)**8+193536000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+24192000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+1344000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +28000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(518400*logy**4*r**14*(168+381*r**2+418*r**4+255*r**6+72*r**8)*(
          -1+y)**10+17280*logy**3*r**10*(-1+y)**8*(1313*r**14*(-1+y)**2+240*r**16*(
          -1+y)**2-15*r**12*(-988+1400*y-124*y**2-347*y**3+48*y**4)-24*(-1
          +y)**3*(-2-2*y-2*y**2+78*y**3-52*y**4+5*y**5)+r**10*(27453-24306*y
          -18447*y**2+14915*y**3+435*y**4+120*y**5)-5*r**2*(-1+y)**2*(901-1365*y**3
          +1374*y**4-600*y**5+50*y**6)+5*r**8*(2280+5472*y-12768*y**2+3068*y**3
          +2552*y**4-889*y**5+216*y**6)+15*r**6*(-1451+5950*y-6023*y**2+348*y**3
          +1551*y**4-501*y**5+62*y**6+24*y**7)+r**4*(-28908+77976*y-59148*y**2
          +2335*y**3+4680*y**4+7503*y**5-6466*y**6+2148*y**7-120*y**8))+288*logy**2*r**6*(
          -1+y)**6*(-1+r**2+y)**2*(204*r**20*(-1+y)**4-12*r**18*(-1+y)**2*(-427
          +888*y-495*y**2+54*y**3)-r**16*(-1+y)**2*(-98058+163572*y-55182*y**2
          -8795*y**3+1068*y**4)+r**14*(-1+y)**2*(371022-626076*y+230652*y**2
          +55595*y**3-19327*y**4+2424*y**5)+12*(-1+y)**4*(-3-6*y-9*y**2+88*y**3
          -45*y**4+8*y**5+411*y**6-486*y**7+142*y**8)+r**12*(2533086-7811280*y
          +7921674*y**2-1820325*y**3-1592930*y**4+804169*y**5-19560*y**6-17814*y**7
          +1980*y**8)-r**10*(-5267442+15926196*y-15397182*y**2+2453929*y**3+4173609*y**4
          -2082363*y**5+114159*y**6+127722*y**7-50704*y**8+3576*y**9)+r**2*(-1
          +y)**3*(1326+1398*y+1470*y**2+54757*y**3-48276*y**4+4044*y**5-46278*y**6
          +53775*y**7-21162*y**8+3746*y**9)-r**8*(-4499586+13448976*y-12888564*y**2
          +3089191*y**3+465406*y**4+1523593*y**5-1552776*y**6+425939*y**7+16784*y**8
          -31831*y**9+1668*y**10)+r**4*(-1+y)**2*(127038-11364*y-7152*y**2-855115*y**3
          +1384382*y**4-790452*y**5+169204*y**6-33333*y**7+32180*y**8-9892*y**9
          +1704*y**10)+r**6*(1075002-2726832*y+2044446*y**2-2057439*y**3+6031091*y**4
          -7979923*y**5+4769055*y**6-1120271*y**7-154811*y**8+143409*y**9-26679*y**10
          +2952*y**11))+24*logy*r**4*(-1+y)**4*(-1+r**2+y)**3*(315*r**22*(-1+y)**6
          -r**20*(-1+y)**4*(-19813+35675*y-14359*y**2+130*y**3)-r**18*(-1+y)**2*(
          -210069+772788*y-1041600*y**2+598782*y**3-107061*y**4-16470*y**5+2810*y**6)
          -r**16*(-1+y)**2*(-2260995+7253307*y-7886664*y**2+2641771*y**3+736351*y**4
          -511934*y**5+28634*y**6+1050*y**7)+2*r**14*(-1+y)**2*(2493553-8018104*y
          +9009846*y**2-3120440*y**3-1180790*y**4+916612*y**5-108206*y**6+1024*y**7
          +3855*y**8)+5*(-1+y)**6*(63+189*y+378*y**2+1351*y**3+824*y**4+621*y**5
          +1304*y**6-1465*y**7-223*y**8-266*y**9+174*y**10+50*y**11)+2*r**8*(
          -1+y)**2*(8020993-16913941*y+8458620*y**2-7999269*y**3+27062342*y**4
          -28843343*y**5+10494516*y**6+1232625*y**7-2038261*y**8+519128*y**9-10630*y**10
          +120*y**11)+r**2*(-1+y)**5*(17507+33205*y+47526*y**2+82532*y**3+25408*y**4
          -26700*y**5-428290*y**6+424634*y**7-157247*y**8+33627*y**9-8872*y**10
          +3470*y**11)+2*r**12*(17179311-78203385*y+135540423*y**2-98296904*y**3
          +1873844*y**4+40002240*y**5-19838840*y**6-22118*y**7+2229259*y**8-497389*y**9
          +30379*y**10+3480*y**11)+r**4*(-1+y)**4*(269949+251061*y+220311*y**2
          -2838154*y**3+2733486*y**4-929382*y**5+1587834*y**6-2137756*y**7+1036809*y**8
          -146531*y**9-20837*y**10+11010*y**11)+r**6*(-1+y)**3*(-3424035+2257953*y
          +646767*y**2+17755891*y**3-35928490*y**4+24721974*y**5-5272118*y**6
          -1471982*y**7+682969*y**8+27125*y**9-24629*y**10+11775*y**11)-2*r**10*(
          -25122951+114193854*y-197387919*y**2+143714186*y**3-6400124*y**4-53257692*y**5
          +26485248*y**6+936704*y**7-4577711*y**8+1659574*y**9-224157*y**10-20602*y**11
          +1590*y**12))+(-1+y)**4*(-1+r**2+y)**4*(r**28*(-1+y)**6+2*r**26*(-1
          +y)**4*(35-72*y+39*y**2+51*y**3)+r**24*(-1+y)**2*(30289-113880*y
          +156420*y**2-93710*y**3+22367*y**4-1618*y**5+220*y**6)-2*r**22*(-309546
          +1676460*y-3693678*y**2+4185664*y**3-2488454*y**4+639011*y**5+22098*y**6
          -32406*y**7+740*y**8+231*y**9)+r**20*(3593445-18633750*y+39037527*y**2
          -41239972*y**3+21309074*y**4-2814686*y**5-1885532*y**6+660216*y**7-34795*y**8
          +9744*y**9-1271*y**10)+2*r**18*(16754577-79118952*y+144867639*y**2
          -119944249*y**3+26830010*y**4+25099249*y**5-17591524*y**6+2801631*y**7
          +381489*y**8-87765*y**9+8609*y**10+486*y**11)+r**16*(21553093-100847610*y
          +196220109*y**2-189940934*y**3+75613988*y**4+9974110*y**5-12205540*y**6
          -2172438*y**7+1793419*y**8-34148*y**9+40167*y**10+1500*y**11+4284*y**12)
          -(-1+y)**7*(-89-445*y-1335*y**2-2397*y**3-3190*y**4-2906*y**5-510*y**6
          +1402*y**7+2691*y**8+195*y**9+85*y**10-445*y**11-532*y**12+276*y**13)
          +2*r**6*(-1+y)**4*(115866+314316*y+489954*y**2-1998752*y**3+266684*y**4
          -263591*y**5+5800956*y**6-7181948*y**7+3041546*y**8-416874*y**9+29410*y**10
          -19812*y**11+12704*y**12+341*y**13)+4*r**14*(101510398-417346012*y
          +617811474*y**2-292117772*y**3-193554056*y**4+272304755*y**5-77910692*y**6
          -27246140*y**7+19851382*y**8-3314724*y**9-33838*y**10+70764*y**11+996*y**12
          +465*y**13)-2*r**2*(-1+y)**6*(-1895-7402*y-18060*y**2-28771*y**3-30145*y**4
          -19970*y**5+4772*y**6+15204*y**7+16575*y**8-4100*y**9+880*y**10-1945*y**11
          -1359*y**12+616*y**13)-2*r**10*(-1+y)**2*(-22997157+28859130*y-333534*y**2
          +95892305*y**3-257671977*y**4+222046289*y**5-52107140*y**6-32877074*y**7
          +22866529*y**8-3066668*y**9-911342*y**10+200385*y**11-41107*y**12+961*y**13)
          -r**4*(-1+y)**5*(-65561-189439*y-361500*y**2-240972*y**3-206513*y**4
          +81211*y**5+875152*y**6-283928*y**7+147477*y**8-253737*y**9+110060*y**10
          -15868*y**11-8267*y**12+1485*y**13)+r**8*(-1+y)**3*(-7461315-2074635*y
          -356127*y**2+60469211*y**3-76635676*y**4+32492758*y**5-20570998*y**6
          +26802710*y**7-15049987*y**8+1765721*y**9+1026677*y**10-275697*y**11
          +60162*y**12+1596*y**13)+r**12*(151837363-562423394*y+730610293*y**2
          -381031244*y**3+205018899*y**4-403635626*y**5+376014785*y**6-100491192*y**7
          -37900671*y**8+27965810*y**9-7177897*y**10+1253524*y**11-93111*y**12
          +55530*y**13-3069*y**14)))*nlo.X1El(1,'SM',y/2,r))/(49766400*logy**5*r**20*(
          -1+y)**10-200*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5
          +20736000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+3456000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+288000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +12000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*(-21600*logy**3*r**11*(27+41*r**2+29*r**4+9*r**6)*(
          -1+y)**8-720*logy**2*r**7*(-1+y)**6*(74*r**12*(-1+y)**2+31*r**14*(-1
          +y)**2+r**10*(1389-1968*y+174*y**2+485*y**3-90*y**4)+5*r**8*(443
          -364*y-340*y**2+242*y**3+y**4+4*y**5)-(-1+y)**3*(11+11*y+11*y**2
          +251*y**3-184*y**4+20*y**5)-r**2*(-1+y)**2*(599-455*y**3+430*y**4
          -234*y**5+20*y**6)+5*r**6*(-17+772*y-1124*y**2+168*y**3+255*y**4
          -105*y**5+27*y**6)+r**4*(-3036+8502*y-6681*y**2-50*y**3+1860*y**4
          -744*y**5+113*y**6+36*y**7))-6*logy*r**3*(-1+y)**4*(-1+r**2+y)**2*(41*r**18*(
          -1+y)**4-r**16*(-1+y)**2*(-643+1368*y-807*y**2+162*y**3)-r**14*(
          -1+y)**2*(-15790+25508*y-7489*y**2-1926*y**3+257*y**4)+r**12*(-1
          +y)**2*(22492-45292*y+26723*y**2+338*y**3-2257*y**4+556*y**5)+(-1
          +y)**4*(11+22*y+33*y**2+604*y**3-95*y**4+94*y**5+683*y**6-1128*y**7
          +376*y**8)+r**10*(325264-987788*y+962749*y**2-168480*y**3-240815*y**4
          +115216*y**5-2237*y**6-4404*y**7+495*y**8)+r**2*(-1+y)**3*(1217+1195*y
          +1173*y**2+10851*y**3-12281*y**4+853*y**5-4525*y**6+5397*y**7-1856*y**8
          +376*y**9)+r**4*(-1+y)**2*(18460+228*y-1059*y**2-127026*y**3+222587*y**4
          -138000*y**5+21407*y**6+9694*y**7-3339*y**8+648*y**9)-r**8*(-592234
          +1816036*y-1796019*y**2+337456*y**3+482771*y**4-315066*y**5+67539*y**6
          +5044*y**7-6881*y**8+754*y**9)+r**6*(171082-446136*y+345989*y**2-173976*y**3
          +407904*y**4-548040*y**5+323186*y**6-83264*y**7-1874*y**8+5496*y**9
          -367*y**10))-r*(-1+y)**3*(-1+r**2+y)**3*(11*r**20*(-1+y)**5-r**18*(
          -1+y)**3*(-887+1561*y-584*y**2+20*y**3)-r**14*(-1+y)**2*(98866-215370*y
          +117060*y**2+18665*y**3-23400*y**4+2019*y**5+60*y**6)-6*r**16*(829
          -3910*y+7345*y**2-6960*y**3+3400*y**4-689*y**5-40*y**6+25*y**7)+r**12*(56552
          -202342*y+195188*y**2+67937*y**3-212345*y**4+111118*y**5-11938*y**6
          -5343*y**7+783*y**8+390*y**9)+(-1+y)**5*(56+168*y+336*y**2+869*y**3
          +572*y**4+363*y**5+82*y**6-561*y**7-144*y**8-47*y**9+106*y**10)+3*r**10*(
          -502676+1833106*y-2306948*y**2+790633*y**3+694954*y**4-671513*y**5
          +142444*y**6+32823*y**7-14458*y**8+871*y**9+164*y**10)+3*r**4*(-1+y)**3*(2543
          +3408*y+3113*y**2-42897*y**3+52608*y**4-18023*y**5+5142*y**6-7563*y**7
          +2797*y**8-133*y**9+205*y**10)+r**6*(-1+y)**2*(-128446+85278*y+28872*y**2
          +551901*y**3-1196170*y**4+902511*y**5-195488*y**6-103457*y**7+56364*y**8
          -5265*y**9+300*y**10)+r**2*(-1+y)**4*(1603+3104*y+4470*y**2+2351*y**3
          +1462*y**4-2943*y**5-16354*y**6+18205*y**7-7701*y**8+763*y**9+440*y**10)
          +r**8*(-598858+1924148*y-2036302*y**2+663653*y**3-36127*y**4+208109*y**5
          -130003*y**6+28427*y**7-47803*y**8+28227*y**9-3651*y**10+180*y**11)))*nlo.X1El(1,'VR',y/2,r))/(1036800*logy**4*r**16*(
          -1+y)**8+345600*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+43200*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+2400*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +50*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6+120*logy*r**4*(
          -1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(-67+98*y
          -13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3-2*y**4
          +y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)+2*r**2*(
          -1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y-421*y**2
          +40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(
          -1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1
          +y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(
          -4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y
          +45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)
          +2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5
          -56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(1,'VR2',y/2,r))/(345600*logy**3*r**12*(
          -1+y)**6-200*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +86400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+7200*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-25920*logy**3*r**10*(10+20*r**2
          +17*r**4+6*r**6)*(-1+y)**8-432*logy**2*r**6*(-1+y)**6*(155*r**12*(-1+y)**2
          +18*r**14*(-1+y)**2+r**10*(1818-2556*y+198*y**2+610*y**3-60*y**4)
          +2*(-1+y)**3*(-1-y-y**2-41*y**3+24*y**4)+10*r**8*(201-96*y-258*y**2
          +124*y**3+28*y**4)+10*r**2*(-1+y)**2*(-39+47*y**3-30*y**4+10*y**5)
          +10*r**6*(-103+566*y-643*y**2+64*y**3+140*y**4-37*y**5+9*y**6)+r**4*(
          -2583+6966*y-5283*y**2+140*y**3+705*y**4+138*y**5-131*y**6+48*y**7))
          -36*logy*r**4*(-1+y)**4*(-1+r**2+y)**2*(49*r**14*(-1+y)**4+2*r**12*(
          -1+y)**2*(586-1005*y+360*y**2+33*y**3)-r**10*(-1+y)**2*(-5415+8688*y
          -2706*y**2-920*y**3+93*y**4)-2*(-1+y)**4*(23+46*y+69*y**2+138*y**3
          +23*y**4-53*y**6+4*y**7)-2*r**8*(-20597+62840*y-61851*y**2+12064*y**3
          +13199*y**4-5694*y**5+19*y**6+30*y**7)+r**2*(-1+y)**3*(-1237-1193*y
          -1125*y**2+5351*y**3-3239*y**4+813*y**5-31*y**6+101*y**7)+2*r**4*(
          -1+y)**2*(6180-3441*y-1146*y**2-7549*y**3+7956*y**4-1959*y**5-38*y**6
          +177*y**7)+r**6*(53099-159664*y+153452*y**2-30640*y**3-24930*y**4
          +7216*y**5+1844*y**6-672*y**7+295*y**8))+3*(-1+y)**4*(-1+r**2+y)**3*(r**20*(
          -1+y)**4-r**18*(-1+y)**2*(45-87*y+39*y**2+5*y**3)-2*r**16*(655-2392*y
          +3162*y**2-1745*y**3+305*y**4+7*y**5+12*y**6)-2*r**14*(7067-22973*y
          +25428*y**2-9172*y**3-1545*y**4+1191*y**5-12*y**6+6*y**7)+2*r**12*(
          -17402+53024*y-54363*y**2+13768*y**3+9043*y**4-3576*y**5-335*y**6
          -138*y**7+19*y**8)+2*(-1+y)**5*(2+8*y+20*y**2+25*y**3+21*y**4+4*y**5
          -8*y**6-11*y**7-7*y**8+6*y**9)+2*r**10*(-147658+379090*y-263769*y**2
          -56529*y**3+119577*y**4-24007*y**5-7121*y**6+1697*y**7-389*y**8+9*y**9)
          -2*r**6*(-1+y)**2*(8957+3227*y+1343*y**2-35887*y**3+28653*y**4-6461*y**5
          -625*y**6+655*y**7+236*y**8+22*y**9)+r**4*(-1+y)**3*(1085+2299*y
          +3390*y**2-4446*y**3+468*y**4-1540*y**5+2110*y**6-1042*y**7-197*y**8
          +33*y**9)+r**2*(-1+y)**4*(145+423*y+822*y**2+816*y**3+488*y**4-10*y**5
          -234*y**6-144*y**7-69*y**8+43*y**9)-2*r**8*(46727-99746*y+50112*y**2
          -20880*y**3+74828*y**4-65172*y**5+10516*y**6+4518*y**7-1305*y**8+372*y**9
          +30*y**10)))*nlo.X1El(2,'SM',y/2,r))/(207360*logy**4*r**16*(-1+y)**8+69120*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +8640*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+480*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+10*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(-2160*logy**2*r**7*(4+5*r**2
          +2*r**4)*(-1+y)**6-72*logy*r**3*(-1+y)**4*(8*r**10*(-1+y)**2+3*r**12*(
          -1+y)**2-5*r**8*(-44+64*y-8*y**2-13*y**3+2*y**4)+2*(-1+y)**3*(
          -1-y-y**2-6*y**3+4*y**4)+5*r**6*(26+8*y-64*y**2+21*y**3+7*y**4)
          +r**2*(-1+y)**2*(-58+35*y**3-15*y**4+8*y**5)+5*r**4*(-61+170*y-133*y**2
          +y**3+31*y**4-11*y**5+3*y**6))-3*r*(-1+y)**3*(-1+r**2+y)**2*(7*r**12*(
          -1+y)**3+2*r**10*(-81+214*y-174*y**2+35*y**3+6*y**4)+r**8*(-169
          +509*y-558*y**2+220*y**3+3*y**4-5*y**5)-4*r**6*(1431-2992*y+1413*y**2
          +518*y**3-447*y**4+47*y**5)+(-1+y)**3*(-13-26*y-39*y**2-54*y**3
          -9*y**4+4*y**5+17*y**6)+2*r**2*(-1+y)**2*(-61-72*y-71*y**2+319*y**3
          -256*y**4+55*y**5+26*y**6)+r**4*(-1749+2827*y-705*y**2+335*y**3-1195*y**4
          +489*y**5-47*y**6+45*y**7)))*nlo.X1El(2,'VR',y/2,r))/(-17280*logy**3*r**12*(
          -1+y)**6+10*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -4320*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-360*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-180*logy*r**4*(3+r**2)*(-1
          +y)**4-3*(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(
          -1+y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(2,'VR2',y/2,r))/(2880*logy**2*r**8*(-1+y)**4+480*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(144*logy**2*r**6*(4+7*r**2+4*r**4)*(-1+y)**6+24*logy*r**4*(-1
          +y)**4*(9*r**8*(-1+y)**2+21*r**4*y*(4-6*y+y**2+y**3)+3*r**2*(-1+y)**2*(
          -24+16*y+8*y**2+y**3)-(-1+y)**3*(-9-9*y-9*y**2+2*y**3)+r**6*(72
          -96*y+25*y**3))-(-1+y)**4*(-1+r**2+y)**2*(1+r**12*(-1+y)**2-6*y**3
          +4*y**4+8*y**6-10*y**7+3*y**8+r**10*(-30+58*y-26*y**2)-r**8*(285
          -412*y+74*y**2+62*y**3+7*y**4)-4*r**6*(383-383*y-56*y**2+84*y**3
          +15*y**4+2*y**5)+r**4*(-285+158*y+53*y**2+324*y**3-215*y**4-38*y**5
          +3*y**6)+2*r**2*(-15+y+y**2+40*y**3-17*y**4-y**5-13*y**6+4*y**7)))*nlo.X1El(3,'SM',y/2,r))/(1728*logy**3*r**12*(
          -1+y)**6-(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +432*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+36*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-24*logy*r**3*(1+r**2)*(-1
          +y)**4-4*r*(-1+y)**3*(r**6*(-1+y)+3*r**2*(-1+y)**2*(3+y)+3*r**4*(
          -3+y+y**2)+(-1+y)**2*(1+y+y**2)))*nlo.X1El(3,'VR',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(3,'VR2',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.VR2

    if wc.VLVR != 0:
      resNP = 0
      resNP +=((18144000*logy**4*r**15*(3+5*r**2+6*r**4+5*r**6+3*r**8)*(-1+y)**8+43200*logy**3*r**11*(
          -1+y)**6*(654*r**14*(-1+y)**2+255*r**16*(-1+y)**2-14*r**12*(-431+502*y
          +109*y**2-260*y**3+45*y**4)+70*r**10*(49+22*y-131*y**2+76*y**3-10*y**4
          +4*y**5)+5*(-1+y)**4*(-51-102*y-153*y**2+272*y**3-108*y**4+16*y**5)
          +35*r**8*y*(288-432*y+60*y**2+183*y**3-110*y**4+25*y**5)-14*r**4*(
          -1+y)**2*(431-360*y-180*y**2+180*y**3+5*y**4-56*y**5+10*y**6)+70*r**6*(
          -49+218*y-229*y**2-28*y**3+161*y**4-94*y**5+21*y**6)+2*r**2*(-1
          +y)**3*(327+327*y+327*y**2-1353*y**3+1272*y**4-380*y**5+40*y**6))
          +720*logy**2*r**7*(-1+y)**4*(-1+r**2+y)**2*(355*r**20*(-1+y)**4-2*r**18*(
          -1+y)**2*(-2981+6317*y-3691*y**2+735*y**3)-r**16*(-1+y)**2*(-86699
          +140132*y-44182*y**2-11156*y**3+1755*y**4)+4*r**14*(-1+y)**2*(33314
          -60756*y+29814*y**2+9734*y**3-6926*y**4+1295*y**5)-5*(-1+y)**6*(
          -71-284*y-710*y**2-732*y**3+385*y**4+1920*y**5-1496*y**6+288*y**7)
          -r**8*(-1+y)**2*(-875618+1006716*y+35262*y**2-399460*y**3-55425*y**4
          +155008*y**5-28036*y**6-7392*y**7+245*y**8)+r**4*(-1+y)**4*(86699+140132*y
          +184314*y**2-519020*y**3+307265*y**4-30004*y**5-20682*y**6+5016*y**7
          +280*y**8)-2*r**2*(-1+y)**5*(2981+9298*y+19306*y**2-8980*y**3-535*y**4
          -15286*y**5+16032*y**6-6036*y**7+720*y**8)+4*r**6*(-1+y)**3*(-33314
          -27442*y-29814*y**2+225880*y**3-210320*y**4+50239*y**5+18562*y**6
          -10321*y**7+1480*y**8)+r**12*(875618-2495756*y+2198298*y**2+15580*y**3
          -1030835*y**4+469812*y**5-15434*y**6-18368*y**7+2485*y**8)-10*r**10*(
          -112262+336786*y-312016*y**2-35502*y**3+253087*y**4-159185*y**5+17376*y**6
          +18282*y**7-7273*y**8+707*y**9))+12*logy*r**3*(-1+y)**4*(-1+r**2+y)**3*(
          -23*r**26*(-1+y)**4-r**24*(-1+y)**2*(-3133+6197*y-2995*y**2+611*y**3)
          +2*r**22*(76629-289881*y+403815*y**2-246210*y**3+56870*y**4-739*y**5
          +16*y**6)+(-1+y)**9*(23+184*y+828*y**2+2220*y**3+2385*y**4-2648*y**5
          -2444*y**6+1552*y**7)+r**20*(959802-3550272*y+4872810*y**2-3009270*y**3
          +714220*y**4+56318*y**5-42248*y**6+3840*y**7)+5*r**18*(1663455-5091138*y
          +5107956*y**2-1048588*y**3-1239885*y**4+659370*y**5-56672*y**6-3536*y**7
          +78*y**8)+r**16*(2486271-11092779*y+20175996*y**2-11574184*y**3-6344209*y**4
          +9127829*y**5-2831696*y**6+93304*y**7+124334*y**8-10866*y**9)+4*r**14*(13652071
          -30491371*y+14420529*y**2+16436514*y**3-17888981*y**4+1278122*y**5
          +4169546*y**6-1441654*y**7+85336*y**8+24181*y**9-1043*y**10)-2*r**6*(
          -1+y)**4*(-479901-1295235*y-2436405*y**2+2960540*y**3-1005865*y**4
          +1537992*y**5-1954765*y**6+849680*y**7-110290*y**8-8585*y**9+334*y**10)
          -5*r**8*(-1+y)**3*(1663455+1764228*y+1680273*y**2-11498712*y**3+9055028*y**4
          -480332*y**5-2095868*y**6+837952*y**7-79063*y**8-10568*y**9+807*y**10)
          +r**2*(-1+y)**6*(3133+15596*y+46581*y**2+86106*y**3+18831*y**4-147960*y**5
          +46579*y**6-16206*y**7+26244*y**8-10456*y**9+1552*y**10)+2*r**4*(-1
          +y)**5*(-76629-289881*y-693696*y**2-342781*y**3+343274*y**4+1274397*y**5
          -1218794*y**6+316221*y**7+18631*y**8-15124*y**9+1882*y**10)+r**10*(
          -1+y)**2*(2486271+3633966*y+5449251*y**2-44281684*y**3+50060916*y**4
          -10065636*y**5-8464816*y**6+3767124*y**7-172391*y**8-69266*y**9+8265*y**10)
          +4*r**12*(13652071-37768984*y+28975755*y**2+17441955*y**3-42235475*y**4
          +22634753*y**5+358338*y**6-4335980*y**7+1343470*y**8-41275*y**9-27949*y**10
          +3321*y**11))-r*(-1+y)**2*(-1+r**2+y)**4*(11*r**28*(-1+y)**6+2*r**26*(
          -1+y)**4*(64-12*y-99*y**2+62*y**3)+r**24*(-1+y)**2*(-137663+512776*y
          -694128*y**2+425652*y**3-123903*y**4+13540*y**5+606*y**6)+2*r**22*(
          -1056216+5674136*y-12386346*y**2+13861178*y**3-8030117*y**4+1837506*y**5
          +255284*y**6-163254*y**7+8427*y**8+802*y**9)-(-1+y)**10*(-11-88*y
          -396*y**2-1944*y**3-2722*y**4+2192*y**5+1068*y**6-1624*y**7+549*y**8
          +152*y**9+24*y**10)+r**20*(-4657909+23553238*y-48724099*y**2+52324784*y**3
          -29055878*y**4+4884028*y**5+3360382*y**6-2134256*y**7+508811*y**8-72402*y**9
          +2101*y**10)-2*r**2*(-1+y)**8*(-64-268*y-601*y**2+23704*y**3+44379*y**4
          +22382*y**5-95355*y**6-55424*y**7+106221*y**8-32854*y**9+1732*y**10
          +148*y**11)-2*r**18*(30490976-140160916*y+246164665*y**2-178347140*y**3
          -10616045*y**4+102405998*y**5-62794823*y**6+12157560*y**7+1251665*y**8
          -619030*y**9+59826*y**10+264*y**11)-r**4*(-1+y)**7*(-137663-650439*y
          -1857343*y**2-2202523*y**3-2698*y**4+4178318*y**5-2324730*y**6+506118*y**7
          -105927*y**8+69673*y**9-22455*y**10+1669*y**11)-2*r**6*(-1+y)**6*(1056216
          +3561704*y+7768426*y**2+40786*y**3-4540589*y**4-12024726*y**5+15713133*y**6
          -4801476*y**7-353311*y**8+364114*y**9-53115*y**10+2838*y**11)-4*r**14*(
          -1+y)**2*(106429256-212858512*y+65363586*y**2+158063546*y**3-137939579*y**4
          +489454*y**5+34665615*y**6-9039436*y**7-1038571*y**8+647154*y**9-54935*y**10
          +4422*y**11)-2*r**10*(-1+y)**4*(30490976+18197012*y+8627773*y**2-191623022*y**3
          +189615758*y**4-7585204*y**5-55763136*y**6+22682452*y**7-1742978*y**8
          -282208*y**9+7303*y**10+10274*y**11)-r**8*(-1+y)**5*(-4657909-9579511*y
          -15591350*y**2+64989010*y**3-46308370*y**4+7352978*y**5+6239772*y**6
          -883100*y**7-1204385*y**8+545645*y**9-103694*y**10+12914*y**11)-r**12*(
          -1+y)**3*(81164329-47358347*y-61007109*y**2-57512129*y**3+145233746*y**4
          -53090422*y**5-17764770*y**6+20070934*y**7-4805771*y**8+618129*y**9
          -55657*y**10+23067*y**11)+r**16*(81164329-358463298*y+561202793*y**2
          -288346520*y**3-159003650*y**4+260614332*y**5-116557094*y**6+22459984*y**7
          -5222355*y**8+3116150*y**9-1047811*y**10+91192*y**11-8052*y**12)))/(290304000*logy**4*r**16*(
          -1+y)**8+96768000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+12096000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+672000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +14000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-217728000*logy**5*r**19*(-3+5*r**2+18*r**4+25*r**6+21*r**8)*(
          -1+y)**10-518400*logy**4*r**15*(-1+y)**8*(3750*r**16*(-1+y)**2+r**14*(6971
          -13942*y+6971*y**2+210*y**3)-14*r**12*(-2912+2674*y+1813*y**2-2210*y**3
          +315*y**4)+175*r**10*(-7+314*y-457*y**2+212*y**3-56*y**4+26*y**5)
          -50*(-1+y)**3*(57+57*y+57*y**2-244*y**3+190*y**4-62*y**5+8*y**6)
          +70*r**8*(-340+1220*y-1150*y**2+175*y**3+317*y**4-238*y**5+72*y**6)
          +35*r**6*(-737+1774*y-1187*y**2-50*y**3+583*y**4-476*y**5+147*y**6)
          -r**2*(-1+y)**2*(943+14560*y**3-18725*y**4+9912*y**5-2520*y**6+240*y**7)
          +14*r**4*(-184-82*y+491*y**2-210*y**3+440*y**4-801*y**5+412*y**6
          -76*y**7+10*y**8))-17280*logy**3*r**11*(-1+y)**6*(-1+r**2+y)**2*(5850*r**20*(
          -1+y)**4-r**18*(-1+y)**2*(-72583+156866*y-95983*y**2+20465*y**3)
          -r**16*(-1+y)**2*(-741876+1190618*y-398158*y**2-62129*y**3+2965*y**4)
          +r**14*(1013744-3959074*y+5919965*y**2-3711320*y**3+171300*y**4+896226*y**5
          -384461*y**6+56070*y**7)+35*(-1+y)**5*(246+738*y+1476*y**2-253*y**3
          -1162*y**4-2295*y**5+3626*y**6-1634*y**7+248*y**8)-2*r**12*(-1693211
          +4649297*y-4137246*y**2+451020*y**3+1421455*y**4-928399*y**5+309408*y**6
          -90279*y**7+10255*y**8)+r**6*(-1+y)**2*(51064-456902*y-234653*y**2
          +3729116*y**3-4954405*y**4+2425366*y**5-298943*y**6-113792*y**7+23489*y**8
          +3960*y**9)-2*r**4*(-1+y)**3*(-231852-111019*y-88601*y**2+1109682*y**3
          -1155315*y**4+545202*y**5-227381*y**6+127776*y**7-46257*y**8+6015*y**9)
          -5*r**10*(-533790+1433974*y-1083583*y**2-624082*y**3+1646249*y**4-1052972*y**5
          +105213*y**6+170339*y**7-70343*y**8+6545*y**9)+r**2*(-1+y)**4*(-41557
          -100334*y-176331*y**2+197747*y**3+13145*y**4+245127*y**5-481611*y**6
          +303096*y**7-80672*y**8+7640*y**9)+r**8*(889382-2213818*y+808892*y**2
          +4744922*y**3-9789178*y**4+8058358*y**5-2013732*y**6-1347567*y**7+1172603*y**8
          -353997*y**9+44135*y**10))-288*logy**2*r**7*(-1+y)**4*(-1+r**2+y)**3*(669*r**26*(
          -1+y)**6-r**24*(-1+y)**4*(-118314+238635*y-122328*y**2+25912*y**3)
          +r**22*(-1+y)**2*(3167785-11975089*y+16753020*y**2-10415430*y**3+2633185*y**4
          -163425*y**5+26454*y**6)+r**20*(-1+y)**2*(15589697-58101152*y+81125520*y**2
          -51480280*y**3+12295665*y**4+1624808*y**5-1143358*y**6+120650*y**7)
          -5*r**18*(-1+y)**2*(-18466988+55662707*y-55831650*y**2+13544638*y**3
          +10603714*y**4-6287825*y**5+1049118*y**6-236132*y**7+31298*y**8)-(
          -1+y)**8*(6063+30315*y+90945*y**2+143090*y**3+80475*y**4-173951*y**5
          -202665*y**6-19220*y**7+334410*y**8-202250*y**9+35288*y**10)+r**16*(46245657
          -280978617*y+721782105*y**2-919197130*y**3+436678695*y**4+278084151*y**5
          -480834901*y**6+240888970*y**7-37438720*y**8-8517570*y**9+3532192*y**10
          -237832*y**11)+r**4*(-1+y)**6*(-3345211-8987232*y-16688940*y**2+10693540*y**3
          +12777260*y**4+23309612*y**5-50514186*y**6+28623440*y**7-5548365*y**8
          -154310*y**9+101674*y**10+6218*y**11)-5*r**8*(-1+y)**4*(11502308-1898611*y
          -1819120*y**2-50284312*y**3+78291632*y**4-44334412*y**5+9881548*y**6
          +226730*y**7-1220008*y**8+798633*y**9-221456*y**10+11568*y**11)-r**2*(
          -1+y)**7*(-161070-662469*y-1701645*y**2-1099015*y**3+358515*y**4+3185615*y**5
          -1525767*y**6+586395*y**7-1596885*y**8+1288110*y**9-392720*y**10+40936*y**11)
          +2*r**12*(-1+y)**2*(69275405-133172846*y+1040115*y**2+265979180*y**3
          -323162495*y**4+80477520*y**5+113588437*y**6-89772815*y**7+17157020*y**8
          +3425245*y**9-1409850*y**10+136334*y**11)+r**6*(-1+y)**5*(4985051+11477074*y
          +20380875*y**2-44879090*y**3+7535340*y**4-51188752*y**5+115984152*y**6
          -82748400*y**7+20834365*y**8+1283010*y**9-1375099*y**10+175474*y**11)
          -r**10*(-1+y)**3*(49005141-114721545*y-2397465*y**2+445650725*y**3
          -660713610*y**4+298317888*y**5+85588070*y**6-122963360*y**7+31831025*y**8
          +3928485*y**9-2839229*y**10+261875*y**11)+2*r**14*(109977961-426210609*y
          +598273968*y**2-264236790*y**3-199371795*y**4+288817653*y**5-122776787*y**6
          +8618729*y**7+13624740*y**8-11120080*y**9+5710061*y**10-1474379*y**11
          +167328*y**12))-12*logy*r**3*(-1+y)**4*(-1+r**2+y)**4*(69*r**32*(-1+y)**6
          +r**30*(-1+y)**4*(-5181+10086*y-4629*y**2+910*y**3)+2*r**28*(-1+y)**2*(217572
          -844008*y+1208685*y**2-796093*y**3+250841*y**4-33535*y**5+3158*y**6)
          +r**26*(14514773-83097582*y+196451973*y**2-248020986*y**3+180551617*y**4
          -76011548*y**5+17132107*y**6-1463878*y**7-70654*y**8+178*y**9)+r**24*(146352860
          -780131516*y+1692810174*y**2-1890025322*y**3+1102554407*y**4-264630208*y**5
          -27308279*y**6+22744626*y**7-2863463*y**8+443668*y**9-40947*y**10)+3*(
          -1+y)**11*(-23-207*y-1035*y**2-3209*y**3-5249*y**4-1129*y**5+4927*y**6
          +5925*y**7-1756*y**8-3996*y**9+1552*y**10)+r**22*(323369043-1679334598*y
          +3602060705*y**2-4025291722*y**3+2260869658*y**4-208832576*y**5-525519870*y**6
          +324158270*y**7-77665293*y**8+6100662*y**9+527413*y**10-27292*y**11)
          +2*r**20*(1070224308-4721605544*y+7887558711*y**2-5283712565*y**3-631020121*y**4
          +3063105392*y**5-1688443900*y**6+282976679*y**7+30043735*y**8-11606384*y**9
          +2686245*y**10-481386*y**11+43830*y**12)-r**6*(-1+y)**6*(12879047+48451484*y
          +116459156*y**2+25032582*y**3-50846705*y**4-206117534*y**5+190894492*y**6
          -82901202*y**7+95345261*y**8-79385670*y**9+27739112*y**10-3332276*y**11
          -67979*y**12+232*y**13)+r**2*(-1+y)**8*(-14649-87618*y-305697*y**2
          -681498*y**3-741218*y**4+168370*y**5+1141658*y**6+854386*y**7-1291837*y**8
          +299568*y**9-186321*y**10+208360*y**11-71264*y**12+7760*y**13)+2*r**4*(
          -1+y)**7*(612420+2945748*y+8560599*y**2+10999556*y**3+3835642*y**4
          -17059173*y**5-8250144*y**6+439669*y**7+20416300*y**8-14771417*y**9
          +3249753*y**10+52171*y**11-85418*y**12+9294*y**13)+r**8*(-1+y)**5*(136852196
          +298437944*y+473415734*y**2-776373268*y**3-415559709*y**4-642407881*y**5
          +2321167888*y**6-1642070332*y**7+296905542*y**8+120680834*y**9-59792190*y**10
          +8109968*y**11-207477*y**12+22751*y**13)-r**14*(-1+y)**2*(-2484294705
          +6091052608*y-1651177246*y**2-12337836914*y**3+16585630377*y**4-3636030298*y**5
          -6435083324*y**6+4144917944*y**7+65151105*y**8-708026952*y**9+194307578*y**10
          -10814734*y**11-1977673*y**12+40234*y**13)+r**18*(-950862723+2762654018*y
          -15453047*y**2-6245243566*y**3+3408697062*y**4+6985428478*y**5-9409889794*y**6
          +3434791906*y**7+628322649*y**8-768620412*y**9+181062145*y**10-7446524*y**11
          -882884*y**12+60692*y**13)+2*r**12*(-1+y)**3*(827108244-611921812*y
          -359771423*y**2-2570705756*y**3+6146942587*y**4-3924736436*y**5-488771374*y**6
          +1636171258*y**7-678495906*y**8+70611438*y**9+12083317*y**10-416714*y**11
          -576685*y**12+96262*y**13)+r**10*(-1+y)**4*(78378471-39250750*y-256842083*y**2
          +417379774*y**3-253724376*y**4+1697948302*y**5-3239842886*y**6+2138906180*y**7
          -347185449*y**8-165329074*y**9+57483977*y**10+872086*y**11-1674422*y**12
          +170250*y**13)+r**16*(3555781374-9915875416*y+5266988984*y**2+9321952402*y**3
          -9851297549*y**4-5690391848*y**5+13651916377*y**6-7907840578*y**7+1413193406*y**8
          +205825878*y**9-31100576*y**10-20382336*y**11-807231*y**12+2152042*y**13
          -114929*y**14))-r*(-1+y)**2*(-1+r**2+y)**5*(55*r**34*(-1+y)**8+r**32*(
          -1+y)**6*(-1169+2891*y-1861*y**2+515*y**3)+r**30*(-1+y)**4*(-71688
          +230978*y-241019*y**2+81710*y**3+5480*y**4-9660*y**5+1739*y**6)+r**28*(
          -1+y)**2*(13989368-78411814*y+179753715*y**2-217874419*y**3+151044829*y**4
          -60283689*y**5+12996773*y**6-1364661*y**7+89763*y**8+1175*y**9)+r**26*(147065776
          -1066771378*y+3337324439*y**2-5883029418*y**3+6391698101*y**4-4372256826*y**5
          +1811257308*y**6-377185494*y**7-5007352*y**8+20570364*y**9-3835275*y**10
          +217680*y**11-8725*y**12)+(-1+y)**12*(11+99*y+495*y**2+2417*y**3
          +4974*y**4+2078*y**5-2482*y**6-4358*y**7+2199*y**8+1991*y**9-2349*y**10
          +373*y**11+128*y**12+24*y**13)-r**24*(-914987072+6189236306*y-17808643741*y**2
          +27926204153*y**3-24813074145*y**4+10531144441*y**5+1064266542*y**6-3550943102*y**7
          +1707773462*y**8-369468700*y**9+44192911*y**10-5943643*y**11+328523*y**12
          +26065*y**13)+r**2*(-1+y)**10*(1475+9552*y+35530*y**2-32010*y**3-385125*y**4
          -953460*y**5+340516*y**6+1311040*y**7+511145*y**8-802420*y**9-970190*y**10
          +1006282*y**11-249495*y**12+8440*y**13+720*y**14)+r**4*(-1+y)**9*(760128
          +4378378*y+14777413*y**2+27866194*y**3+23237302*y**4-20033664*y**5
          -32522809*y**6-17969404*y**7+43973404*y**8-17544502*y**9+4056011*y**10
          -2462694*y**11+1053566*y**12-176548*y**13+7225*y**14)-r**22*(-268400208
          +1711048238*y-5373777709*y**2+10796926442*y**3-13841834620*y**4+9274618956*y**5
          +471788059*y**6-6237063452*y**7+4942948616*y**8-1645542530*y**9+105268177*y**10
          +84572178*y**11-21436364*y**12+790792*y**13+9425*y**14)+r**6*(-1+y)**8*(
          -20887424-93357290*y-255121929*y**2-242414574*y**3-8186684*y**4+520893844*y**5
          +45438071*y**6-69001676*y**7-480696536*y**8+436760934*y**9-116014195*y**10
          -2660006*y**11+5432580*y**12-784240*y**13+39125*y**14)+r**8*(-1+y)**7*(80508472
          +260842614*y+569840915*y**2-450974846*y**3-445144694*y**4-1045230298*y**5
          +2128136423*y**6-1423625124*y**7+572765588*y**8-194339206*y**9+66130001*y**10
          -18628062*y**11+4923434*y**12-1180342*y**13+135125*y**14)+r**10*(-1
          +y)**6*(-997350440-1691176054*y-2161565359*y**2+6458255650*y**3+1869540616*y**4
          +2512289854*y**5-16959642473*y**6+13895644552*y**7-2294697416*y**8-1630468478*y**9
          +768549711*y**10-105849498*y**11+6637832*y**12-1702234*y**13+321737*y**14)
          +r**18*(-1+y)**2*(-21464732546+80084335418*y-94166632275*y**2+11006026918*y**3
          +49762915502*y**4-16290011486*y**5-20044465389*y**6+9592091992*y**7+5410988386*y**8
          -4937597702*y**9+1210156907*y**10-49186654*y**11-10484542*y**12+485546*y**13
          +353925*y**14)+r**12*(-1+y)**5*(-2962785336-1299152086*y+822920757*y**2
          +10415132474*y**3-3496526810*y**4-12294826868*y**5+9029674107*y**6+2033454036*y**7
          -3873416148*y**8+966167730*y**9+277409179*y**10-174440046*y**11+36926182*y**12
          -4405576*y**13+548405*y**14)+r**16*(-1+y)**3*(-36057039998+78996220630*y
          -25665244733*y**2-53907218698*y**3+16916999192*y**4+57885030698*y**5
          -49074055893*y**6+3290362788*y**7+11342421858*y**8-5353479742*y**9+1037638625*y**10
          -122180362*y**11+26619220*y**12-3790610*y**13+597025*y**14)+r**14*(-1
          +y)**4*(-15844558024+14193547926*y+7326717511*y**2+38252996058*y**3
          -97714128676*y**4+53843946232*y**5+20577360027*y**6-28618156188*y**7
          +6467116728*y**8+1429901446*y**9-381702483*y**10-155945278*y**11+61356852*y**12
          -6717236*y**13+677105*y**14)+r**20*(12414648592-74537652958*y+182652788711*y**2
          -219150562991*y**3+94072277508*y**4+76732714698*y**5-124636788589*y**6
          +62473124073*y**7-5095455208*y**8-7606391946*y**9+3016296133*y**10-313264053*y**11
          -27675884*y**12+5452574*y**13+376513*y**14+112827*y**15))))/(-2612736000*logy**5*r**20*(
          -1+y)**10+10500*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-1088640000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-181440000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-15120000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -630000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*muWC*(435456000*logy**5*r**19*(-6-5*r**2+5*r**6
          +6*r**8)*(-1+y)**10+1036800*logy**4*r**15*(-1+y)**7*(1650*r**16*(-1+y)**3
          +r**14*(-1507+4521*y-4521*y**2-173*y**3+840*y**4)-14*r**12*(682-1146*y
          -204*y**2+1623*y**3-955*y**4+135*y**5)+35*r**10*(193-879*y+1329*y**2
          -993*y**3+330*y**4-68*y**5+20*y**6)-10*(-1+y)**3*(-165+595*y**3-784*y**4
          +378*y**5-70*y**6+4*y**7)+70*r**8*(170-510*y+510*y**2-145*y**3-223*y**4
          +289*y**5-146*y**6+28*y**7)+r**2*(-1+y)**3*(1507-6230*y**3+5075*y**4
          -1652*y**5+40*y**7)+35*r**6*(193-279*y-171*y**2+477*y**3-503*y**4
          +459*y**5-247*y**6+47*y**7)-14*r**4*(682-2946*y+4296*y**2-2437*y**3
          +315*y**4+73*y**5-49*y**6+114*y**7-58*y**8+10*y**9))+172800*logy**3*r**11*(
          -1+y)**5*(-1+r**2+y)**2*(723*r**20*(-1+y)**5-r**18*(-1+y)**2*(5707
          -18567*y+21459*y**2-9009*y**3+1354*y**4)-r**16*(-1+y)**2*(60279-154097*y
          +122586*y**2-15539*y**3-12603*y**4+1760*y**5)+r**14*(-48134+258720*y
          -571533*y**2+560707*y**3-154096*y**4-131510*y**5+114907*y**6-34885*y**7
          +4354*y**8)+r**10*y*(-83698+292943*y-714609*y**2+1163617*y**3-988421*y**4
          +283353*y**5+152425*y**6-143235*y**7+39767*y**8-3612*y**9)+(-1+y)**5*(
          -723-1446*y-2169*y**2+4691*y**3+222*y**4+1395*y**5-5664*y**6+4002*y**7
          -990*y**8+52*y**9)+r**12*(-124852+433658*y-568504*y**2+127758*y**3
          +453503*y**4-477945*y**5+164298*y**6-2176*y**7-9723*y**8+1603*y**9)
          -r**2*(-1+y)**4*(-5707-7153*y-8599*y**2+29867*y**3-11485*y**4+9817*y**5
          -28619*y**6+23373*y**7-6932*y**8+556*y**9+52*y**10)-r**4*(-1+y)**3*(60279
          -26740*y-4771*y**2-189298*y**3+306473*y**4-200264*y**5+97971*y**6
          -54288*y**7+23694*y**8-5002*y**9+346*y**10)+r**6*(-1+y)**2*(48134-30084*y
          -57*y**2-317809*y**3+591227*y**4-404089*y**5+144529*y**6-64003*y**7
          +38519*y**8-13047*y**9+1640*y**10)+r**8*(124852-565158*y+1028754*y**2
          -1222326*y**3+1303981*y**4-1053479*y**5+384867*y**6+101486*y**7-148079*y**8
          +53299*y**9-8953*y**10+756*y**11))+576*logy**2*r**7*(-1+y)**3*(-1+r**2
          +y)**3*(1683*r**26*(-1+y)**7-r**24*(-1+y)**4*(69846-214587*y+224685*y**2
          -83633*y**3+12349*y**4)-r**22*(-1+y)**2*(1628249-7705132*y+14437373*y**2
          -13232895*y**3+5772655*y**4-829354*y**5-90293*y**6+8997*y**7)+r**20*(
          -1+y)**2*(-5143687+25030769*y-49379212*y**2+46947335*y**3-19598590*y**4
          +683547*y**5+1969306*y**6-573183*y**7+56265*y**8)+5*r**18*(-1+y)**2*(
          -7492324+29560079*y-43248313*y**2+23811101*y**3+4382982*y**4-10596656*y**5
          +3849833*y**6-312923*y**7-22950*y**8+1831*y**9)+(-1+y)**9*(-1683-8415*y
          -25245*y**2-37660*y**3-3015*y**4+83121*y**5-36785*y**6-11380*y**7+15960*y**8
          -7810*y**9+1412*y**10)+r**16*(689871+24727458*y-166094874*y**2+358927835*y**3
          -272062175*y**4-123323652*y**5+371389724*y**6-270789792*y**7+81771565*y**8
          +63150*y**9-6901444*y**10+1700493*y**11-112159*y**12)-r**2*(-1+y)**7*(69846
          +214587*y+439272*y**2-225085*y**3-187005*y**4-610102*y**5+372016*y**6
          +171591*y**7+113985*y**8-316795*y**9+158806*y**10-27528*y**11+1412*y**12)
          +r**10*(-1+y)**3*(689871-30246426*y+26313720*y**2+183591460*y**3-394989985*y**4
          +295242648*y**5-78305318*y**6-4649085*y**7+1763090*y**8+1567560*y**9
          -411344*y**10+7719*y**11+7090*y**12)+r**6*(-1+y)**5*(-5143687-4456021*y
          -5149027*y**2+27367720*y**3-11265135*y**4+10328034*y**5-41948368*y**6
          +42744519*y**7-17562020*y**8+2518535*y**9+161103*y**10-83011*y**11+9358*y**12)
          -5*r**8*(-1+y)**4*(-7492324+7901541*y+68763*y**2+18273051*y**3-41444589*y**4
          +37205514*y**5-23877004*y**6+14013353*y**7-5024851*y**8+75079*y**9+559805*y**10
          -148122*y**11+10184*y**12)+r**4*(-1+y)**6*(1628249+2820385*y+3911856*y**2
          -10341605*y**3+1955835*y**4-2239578*y**5+9411320*y**6-7768677*y**7+3274580*y**8
          -1481035*y**9+629354*y**10-147430*y**11+12746*y**12)+r**12*(-1+y)**2*(20351278
          -125582414*y+279984826*y**2-442509860*y**3+489004930*y**4-222594116*y**5
          -132391042*y**6+209846683*y**7-89802315*y**8+6939770*y**9+5451238*y**10
          -1563619*y**11+134641*y**12)+r**14*(-20351278+57579088*y-7971522*y**2
          -240186858*y**3+576297420*y**4-634782114*y**5+276440174*y**6+115697349*y**7
          -202217364*y**8+98833055*y**9-20271908*y**10+743413*y**11+179198*y**12
          +11347*y**13))-24*logy*r**3*(-1+y)**3*(-1+r**2+y)**4*(r**30*(-1+y)**4*(2367
          -7101*y+7101*y**2-2119*y**3+248*y**4)-2*r**28*(-1+y)**2*(-207498+1001832*y
          -1916886*y**2+1810091*y**3-852186*y**4+176532*y**5-9426*y**6+581*y**7)
          +2*(-1+y)**11*y**3*(267+3113*y+10358*y**2-1168*y**3-14895*y**4+4573*y**5
          +3562*y**6-1998*y**7+388*y**8)+r**26*(6848455-46175245*y+132887205*y**2
          -210976287*y**3+199478003*y**4-112918861*y**5+36115435*y**6-5319365*y**7
          -14418*y**8+82502*y**9-3424*y**10)+2*r**24*(35400632-221541388*y+582848054*y**2
          -821722949*y**3+643898580*y**4-242394826*y**5-1561452*y**6+34460576*y**7
          -10166566*y**8+808760*y**9-26536*y**10+3315*y**11)+r**22*(61247643-412515509*y
          +1227863919*y**2-1936952829*y**3+1560720230*y**4-355324274*y**5-408531590*y**6
          +374767462*y**7-131997781*y**8+21529935*y**9-636829*y**10-333561*y**11
          +17584*y**12)-2*r**20*(-474333138+2535639376*y-5399101858*y**2+5318711155*y**3
          -1234312358*y**4-2453641283*y**5+2542151378*y**6-887048555*y**7-24484402*y**8
          +97664793*y**9-23290194*y**10+1732606*y**11+21748*y**12+3732*y**13)
          +r**18*(-858789357+3753131767*y-5013289367*y**2+889533185*y**3+1973068214*y**4
          +1872648182*y**5-5439805286*y**6+3538972422*y**7-395290117*y**8-544624025*y**9
          +273772925*y**10-46150231*y**11+503220*y**12+408332*y**13-29864*y**14)
          -2*r**4*(-1+y)**7*(-207498-794334*y-1916886*y**2-647347*y**3+2090887*y**4
          +5429883*y**5-6115155*y**6+1211249*y**7+697271*y**8-432267*y**9+51615*y**10
          +88414*y**11-57388*y**12+6226*y**13+330*y**14)+2*r**16*y*(1076812520
          -4845656340*y+9301785407*y**2-8806175888*y**3+1555363036*y**4+6264822350*y**5
          -7860118680*y**6+4249700576*y**7-842301634*y**8-216396682*y**9+146826855*y**10
          -26058780*y**11+1479442*y**12-82828*y**13+646*y**14)-r**2*(-1+y)**8*(2367
          +11835*y+35505*y**2+64281*y**3-155302*y**4-482862*y**5+670722*y**6
          -115538*y**7-390145*y**8+451051*y**9-163555*y**10-18807*y**11+28208*y**12
          -8536*y**13+776*y**14)+r**6*(-1+y)**6*(-6848455-18781425*y-35452200*y**2
          +29920348*y**3+2025161*y**4+37113315*y**5-6085620*y**6-33014040*y**7
          -11481061*y**8+42201173*y**9-23615660*y**10+4984220*y**11-169285*y**12
          -47687*y**13+1216*y**14)-2*r**8*(-1+y)**5*(-35400632-44538228*y-50688822*y**2
          +241965915*y**3-93308961*y**4+23399867*y**5-214154291*y**6+255139872*y**7
          -139396842*y**8+48942360*y**9-11784460*y**10+725569*y**11+396975*y**12
          -85923*y**13+6601*y**14)+r**14*(-1+y)**2*(858789357-3117183089*y+2787468994*y**2
          +4641057758*y**3-11499880853*y**4+7364978793*y**5+1239511180*y**6-3449614796*y**7
          +1110657731*y**8+284283633*y**9-248626550*y**10+50815534*y**11-1136123*y**12
          -653289*y**13+13720*y**14)-2*r**12*(-1+y)**3*(-474333138+784692590*y
          -146261500*y**2+753342291*y**3-2817613867*y**4+3331325413*y**5-2004053833*y**6
          +606165272*y**7+83974450*y**8-196398954*y**9+88997900*y**10-16769407*y**11
          +894903*y**12+10659*y**13+14221*y**14)-r**10*(-1+y)**4*(61247643+45029651*y
          +84001019*y**2-331660149*y**3-168573084*y**4-198755472*y**5+1732904842*y**6
          -1942887634*y**7+770380967*y**8-6234253*y**9-75370021*y**10+15272007*y**11
          +706490*y**12-453718*y**13+41712*y**14))+2*r*(-1+y)*(-1+r**2+y)**5*(11*r**34*(
          -1+y)**9+r**32*(-1+y)**6*(661-1928*y+1818*y**2-588*y**3+95*y**4)
          +r**30*(-1+y)**4*(-172110+828896*y-1577197*y**2+1460761*y**3-670830*y**4
          +151296*y**5-14651*y**6+255*y**7)-r**28*(-1+y)**2*(8719198-56883330*y
          +156883043*y**2-236047922*y**3+208321104*y**4-107378082*y**5+29619416*y**6
          -3078022*y**7-144362*y**8+9612*y**9+225*y**10)-(-1+y)**12*(-11-88*y
          -396*y**2-854*y**3-5901*y**4-19180*y**5+7768*y**6+26628*y**7-22997*y**8
          -3624*y**9+9716*y**10-2830*y**11+493*y**12+76*y**13)-r**26*(56893562
          -469305532*y+1705597977*y**2-3561789325*y**3+4667427053*y**4-3916557089*y**5
          +2026144780*y**6-543369428*y**7+1826010*y**8+43926712*y**9-12117653*y**10
          +1404377*y**11-89969*y**12+2925*y**13)-r**24*(478084378-3694875518*y
          +12393895569*y**2-23295971946*y**3+26060590370*y**4-16104629946*y**5
          +2551642003*y**6+3932405816*y**7-3288969162*y**8+1133698378*y**9-171491977*y**10
          +5012770*y**11+701470*y**12-76162*y**13+6357*y**14)+r**2*(-1+y)**10*(
          -661-3911*y-13496*y**2+28370*y**3+39145*y**4-132643*y**5-689828*y**6
          +187812*y**7+1555245*y**8-1091465*y**9-211896*y**10+411814*y**11-152641*y**12
          +18835*y**13-780*y**14+100*y**15)+r**22*(673596282-5014800248*y+15526414467*y**2
          -26174260623*y**3+26351699814*y**4-16615076124*y**5+7247943111*y**6-2829964779*y**7
          +972552786*y**8-4212148*y**9-233546923*y**10+134036687*y**11-40345138*y**12
          +6179912*y**13-189791*y**14+715*y**15)+r**4*(-1+y)**9*(-172110-828896*y
          -2406093*y**2-2382675*y**3+4498746*y**4+13794708*y**5-19600851*y**6
          +7197363*y**7+12110562*y**8-16539700*y**9+5479481*y**10+1272647*y**11
          -1347070*y**12+326288*y**13-31721*y**14+1321*y**15)+r**6*(-1+y)**8*(8719198
          +30725736*y+69273977*y**2+4877811*y**3-45790630*y**4-128503220*y**5
          +108357829*y**6+14222527*y**7+9043534*y**8-58114484*y**9+36777847*y**10
          -9551515*y**11+362346*y**12+437680*y**13-106661*y**14+8025*y**15)+r**8*(
          -1+y)**7*(-56893562-127944160*y-212473747*y**2+368360783*y**3-145295116*y**4
          +191058340*y**5+181801511*y**6-411904785*y**7-169225910*y**8+479124748*y**9
          -257053553*y**10+45692249*y**11+1152332*y**12-486048*y**13-182707*y**14
          +29625*y**15)+r**10*(-1+y)**6*(478084378+348284872*y+264414399*y**2
          -3369219631*y**3+1736907296*y**4+45368608*y**5+3891445775*y**6-6154747289*y**7
          +3406267126*y**8-636371648*y**9-142820391*y**10+89944903*y**11-17987760*y**12
          +2410280*y**13-518823*y**14+73905*y**15)+r**18*(-1+y)**2*(14380443136
          -68738031830*y+120784182151*y**2-86198329259*y**3-2457423682*y**4+40381669490*y**5
          -21234707233*y**6+2635247975*y**7-233118740*y**8+1152018026*y**9-715181251*y**10
          +166833063*y**11-11506426*y**12-663126*y**13-64819*y**14+96525*y**15)
          +r**12*(-1+y)**5*(673596282-373970008*y-716491373*y**2-3330793819*y**3
          +8126443262*y**4-745860244*y**5-11068087539*y**6+10052802411*y**7-1622995242*y**8
          -1907929824*y**9+951342517*y**10-70261453*y**11-46540238*y**12+11720236*y**13
          -1313813*y**14+130845*y**15)+r**16*(-1+y)**3*(14380443136-46305513258*y
          +42270367149*y**2+14991052747*y**3-38111300310*y**4-10518213450*y**5
          +49786263943*y**6-32961847521*y**7+3035222388*y**8+5902353002*y**9-2951704461*y**10
          +535577865*y**11-31993678*y**12+1737690*y**13-758967*y**14+153725*y**15)
          +r**14*(-1+y)**4*(7064801654-13704410432*y+3841552249*y**2-10289187445*y**3
          +47481067702*y**4-56678576516*y**5+22625195653*y**6+4709108391*y**7-7074897006*y**8
          +2272353160*y**9-364850341*y**10+108413729*y**11-53520590*y**12+12980876*y**13
          -1606537*y**14+167453*y**15)+r**20*(-7064801654+49878804454*y-148539128337*y**2
          +234847231250*y**3-190815640871*y**4+28005388490*y**5+97920702637*y**6
          -97952080946*y**7+36636185955*y**8+1561785842*y**9-6388167263*y**10+2122833974*y**11
          -183513217*y**12-36930530*y**13+7523779*y**14-228598*y**15+35035*y**16))))/(
          -1959552000*logy**5*r**20*(-1+y)**10+7875*(r**8*(-1+y)**2-6*r**4*y*(2
          -3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)
          -(-1+y)**3*(-1-y-y**2+y**3))**5-816480000*logy**4*r**16*(-1+y)**8*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-136080000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          -11340000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**3-472500*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2
          -3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)
          +r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((muG*(217728000*logy**5*r**17*(-42
          -21*r**2-11*r**4+14*r**6+31*r**8+27*r**10)*(-1+y)**10-518400*logy**4*r**13*(
          -1+y)**7*(9398*r**18*(-1+y)**3+35*r**16*(637-1911*y+1911*y**2-1099*y**3
          +222*y**4)-2*r**14*(-39428+89934*y-47409*y**2+1593*y**3+4445*y**4
          +315*y**5)+4*(-1+y)**4*(194+194*y+194*y**2-3621*y**3+2854*y**4-590*y**5
          +40*y**6)+35*r**12*(-483+3309*y-6099*y**2+2717*y**3+44*y**4-218*y**5
          +50*y**6)-70*r**2*(-1+y)**3*(97+239*y**3-648*y**4+424*y**5-134*y**6
          +16*y**7)-14*r**10*(5544-18732*y+21882*y**2-5759*y**3-4960*y**4+5975*y**5
          -3070*y**6+470*y**7)-7*r**8*(8081-20943*y+15993*y**2+679*y**3-5185*y**4
          +4639*y**5-707*y**6-1933*y**7+576*y**8)-r**4*(-1+y)**2*(-96289+184489*y
          -44100*y**2-123060*y**3+164675*y**4-130431*y**5+52976*y**6-10160*y**7
          +640*y**8)+70*r**6*(-636+1278*y-333*y**2+133*y**3-1646*y**4+2515*y**5
          -2319*y**6+1340*y**7-370*y**8+38*y**9))-17280*logy**3*r**9*(-1+y)**5*(
          -1+r**2+y)**2*(27842*r**22*(-1+y)**5-r**20*(-1+y)**2*(139939-475501*y
          +586869*y**2-251836*y**3+47729*y**4)-r**18*(-1+y)**2*(1202104-2814114*y
          +1877124*y**2+310807*y**3-510840*y**4+54219*y**5)-2*(-1+y)**6*(-2343
          -7029*y-14058*y**2+415*y**3-155*y**4+7948*y**5+3094*y**6-4142*y**7
          +520*y**8)+r**16*(2488762-9284160*y+10967961*y**2-4552277*y**3+991750*y**4
          -1962892*y**5+2040355*y**6-903041*y**7+140042*y**8)+2*r**14*(4313579
          -16971652*y+23072753*y**2-12355200*y**3+329405*y**4+2996986*y**5-2140233*y**6
          +875007*y**7-196000*y**8+15855*y**9)+r**2*(-1+y)**5*(16526+23680*y
          +21462*y**2-229013*y**3+34325*y**4-85461*y**5-44765*y**6+211728*y**7
          -114922*y**8+19440*y**9)+r**12*(3551678-16838460*y+29048517*y**2-28420153*y**3
          +18855775*y**4-5439685*y**5-3154745*y**6+3638828*y**7-1821502*y**8+573720*y**9
          -67473*y**10)-r**8*(-1+y)**2*(8949136-21148746*y+10440651*y**2+20113543*y**3
          -39132605*y**4+33931015*y**5-16157919*y**6+3516659*y**7-35383*y**8-127335*y**9
          +12184*y**10)-2*r**6*(-1+y)**3*(-218726+305957*y+138086*y**2-1724133*y**3
          +4626545*y**4-4911123*y**5+2626743*y**6-944471*y**7+323413*y**8-106950*y**9
          +15909*y**10)+r**4*(-1+y)**4*(-182723-113283*y-76345*y**2+2181956*y**3
          -2281830*y**4+649398*y**5+802088*y**6-1081765*y**7+636244*y**8-172060*y**9
          +16320*y**10)+r**10*(-3968562+13327224*y-11656278*y**2-20554674*y**3
          +62492920*y**4-71438192*y**5+46526410*y**6-17503077*y**7+1978444*y**8
          +1224850*y**9-484526*y**10+55461*y**11))+288*logy**2*r**5*(-1+y)**3*(
          -1+r**2+y)**3*(-13141*r**28*(-1+y)**7+r**26*(-1+y)**4*(548348-1684467*y
          +1763313*y**2-641502*y**3+100908*y**4)+r**24*(-1+y)**2*(11143043-52388122*y
          +97379591*y**2-87809250*y**3+36620695*y**4-4172368*y**5-933973*y**6
          +56384*y**7)-r**22*(-1+y)**2*(-9487371+52349871*y-122952180*y**2+127052430*y**3
          -45148765*y**4-11310629*y**5+13112374*y**6-4131150*y**7+440920*y**8)
          +r**20*(-1+y)**2*(140326162-518627219*y+681070267*y**2-219623830*y**3
          -304349810*y**4+307657113*y**5-84484501*y**6+6868*y**7+1384170*y**8
          +7780*y**9)+2*(-1+y)**9*(2334+11670*y+35010*y**2+54175*y**3+30060*y**4
          -62058*y**5-47470*y**6-19685*y**7+77550*y**8-31910*y**9+2824*y**10)
          +r**2*(-1+y)**8*(-80519-336080*y-875210*y**2-568875*y**3-417575*y**4
          +392258*y**5-106450*y**6+125585*y**7+534700*y**8-173700*y**9-177414*y**10
          +59280*y**11)+r**6*(-1+y)**6*(5927663+5882269*y+2920728*y**2-50723190*y**3
          +25259030*y**4-17699856*y**5-26954018*y**6+81069264*y**7-63055085*y**8
          +19369045*y**9-2179732*y**10-57776*y**11+11658*y**12)+r**4*(-1+y)**7*(1195432
          +2998377*y+5270664*y**2-697840*y**3+1460380*y**4+1228816*y**5+1769386*y**6
          -399088*y**7-2795060*y**8+461195*y**9+1026102*y**10-548588*y**11+76224*y**12)
          +r**12*(-1+y)**3*(-909586273+2566982290*y-1838422020*y**2-2265951710*y**3
          +5447471795*y**4-4753693494*y**5+2140225450*y**6-285565560*y**7-208164515*y**8
          +114910880*y**9-22538558*y**10+757410*y**11+120305*y**12)-r**8*(-1+y)**5*(11431671
          -9648537*y-16923279*y**2-222312505*y**3+337384400*y**4-54373972*y**5
          -248970156*y**6+320062398*y**7-203860945*y**8+67467125*y**9-7305649*y**10
          -763557*y**11+170006*y**12)+r**10*(-1+y)**4*(6325006-65526555*y+561435*y**2
          +777597650*y**3-1906854780*y**4+2168609748*y**5-1323220300*y**6+391283560*y**7
          -9199650*y**8-36042195*y**9+14398871*y**10-3272220*y**11+249430*y**12)
          -2*r**14*(-1+y)**2*(-39199507-100111807*y+634941821*y**2-1363290245*y**3
          +1369992805*y**4-423905561*y**5-345131221*y**6+385338833*y**7-154498880*y**8
          +10192295*y**9+16330643*y**10-5230797*y**11+473621*y**12)+r**18*(-375769187
          +1944432254*y-3771026202*y**2+3285179875*y**3-1058288645*y**4+115570044*y**5
          -589331928*y**6+704064599*y**7-268394650*y**8-22063230*y**9+47088118*y**10
          -12142926*y**11+821878*y**12)-2*r**16*(390508943-2177796134*y+4767023289*y**2
          -5089430153*y**3+2208067520*y**4+986643894*y**5-2187897922*y**6+1682190032*y**7
          -711184414*y**8+118705655*y**9+24187413*y**10-11908619*y**11+749579*y**12
          +140917*y**13))-12*logy*r*(-1+y)**3*(-1+r**2+y)**4*(69*r**34*(-1+y)**7
          -r**32*(-1+y)**4*(14403-43485*y+44037*y**2-10573*y**3+578*y**4)+2*r**30*(
          -1+y)**2*(-1688448+8155800*y-15610317*y**2+14725170*y**3-6918972*y**4
          +1446294*y**5-85771*y**6+6644*y**7)+2*(-1+y)**12*(-23-207*y-1035*y**2
          -3209*y**3-5249*y**4-1129*y**5+4927*y**6+5925*y**7-1756*y**8-3996*y**9
          +1552*y**10)+r**28*(-48930895+329130265*y-944944869*y**2+1493340593*y**3
          -1399225705*y**4+779819483*y**5-243653285*y**6+34722439*y**7+318752*y**8
          -637500*y**9+20722*y**10)+r**26*(-409831092+2516289160*y-6463669882*y**2
          +8759171824*y**3-6281600469*y**4+1666614539*y**5+700737587*y**6-631190453*y**7
          +153453581*y**8-10593191*y**9+575123*y**10-80727*y**11)+r**24*(522908059
          -2828954337*y+5607875059*y**2-5127033983*y**3+2419346594*y**4-1451764592*y**5
          +1791165692*y**6-1420825998*y**7+622393783*y**8-141941559*y**9+5636953*y**10
          +2783125*y**11-132796*y**12)+r**2*(-1+y)**9*(-12835-76826*y-268247*y**2
          -579710*y**3-604564*y**4+189946*y**5+775668*y**6+674790*y**7-922069*y**8
          +241064*y**9+26139*y**10-98192*y**11+35732*y**12+3104*y**13)+2*r**22*(
          -2287883112+12017238816*y-24755844031*y**2+22138363376*y**3-640969014*y**4
          -16152305043*y**5+13330810808*y**6-3084221371*y**7-1279357678*y**8+865260709*y**9
          -162751425*y**10+8599971*y**11+121772*y**12+66222*y**13)-r**8*(-1+y)**6*(
          -47062225-96369475*y-145305796*y**2+110987966*y**3-16556229*y**4-118855987*y**5
          -110957362*y**6+138017790*y**7-6052489*y**8+45114101*y**9-93696138*y**10
          +46163612*y**11-8535769*y**12+196473*y**13+7528*y**14)+2*r**6*(-1+y)**7*(
          -1664184-6281768*y-15404831*y**2-5753601*y**3-16119164*y**4-15797985*y**5
          -21188367*y**6+6969679*y**7+43716319*y**8-19165735*y**9-8613856*y**10
          +6086910*y**11-635023*y**12-45668*y**13+11274*y**14)+r**4*(-1+y)**8*(821971
          +3936947*y+11403689*y**2+14028119*y**3+6538956*y**4-15984932*y**5-4600604*y**6
          -1145888*y**7+10801417*y**8-7865647*y**9+817611*y**10+932657*y**11-52576*y**12
          -72136*y**13+12416*y**14)+r**10*(-1+y)**5*(237745924+47532324*y-215181766*y**2
          -1800066902*y**3+1561396109*y**4-134096652*y**5-1567728317*y**6+4123524668*y**7
          -3963036450*y**8+1615159628*y**9-168306672*y**10-67339582*y**11+23444873*y**12
          -2269148*y**13+101963*y**14)-r**16*(-1+y)**2*(21738576251-68048226203*y
          +60884286174*y**2+35516813944*y**3-111363591119*y**4+85091138195*y**5
          -19051539902*y**6-11946761536*y**7+9203657249*y**8-969063285*y**9-1090103746*y**10
          +338565280*y**11-9929013*y**12-5320843*y**13+122554*y**14)+2*r**14*(
          -1+y)**3*(-208722032-489866296*y+373155051*y**2+12843399061*y**3-34522093597*y**4
          +39946039559*y**5-24079960108*y**6+4557858448*y**7+3824358328*y**8-2992779816*y**9
          +839425273*y**10-71527921*y**11-3053999*y**12-243539*y**13+181588*y**14)
          +r**20*(12331522641-57976558551*y+96632501647*y**2-56833420023*y**3
          -19091543336*y**4+34656298136*y**5-1460600620*y**6-15180424196*y**7+7647105879*y**8
          +96438935*y**9-1149377927*y**10+298213371*y**11-7851376*y**12-3144456*y**13
          +239876*y**14)+r**12*(-1+y)**4*(162609067+188305103*y+148155819*y**2
          +3325811273*y**3-7729842406*y**4+50487418*y**5+10541916856*y**6-11414956526*y**7
          +6197327951*y**8-1583092741*y**9-30655685*y**10+82652541*y**11+5901332*y**12
          -4596524*y**13+420522*y**14)+r**18*(13347092570-76922780090*y+175381064248*y**2
          -198885819826*y**3+84799408315*y**4+82050583519*y**5-168003761285*y**6
          +131859586999*y**7-48278680188*y**8-207281660*y**9+6945014042*y**10-2353780300*y**11
          +275010103*y**12-7493961*y**13+1960195*y**14-122681*y**15))-r*(-1+y)*(
          -1+r**2+y)**5*(213*r**34*(-1+y)**9+r**32*(-1+y)**6*(8683-25812*y+24924*y**2
          -8784*y**3+1569*y**4)+r**30*(-1+y)**4*(-1353172+6549846*y-12537537*y**2
          +11591589*y**3-5215438*y**4+1133324*y**5-107745*y**6+3333*y**7)-r**28*(
          -1+y)**2*(69861412-455056978*y+1252415811*y**2-1877978130*y**3+1648618656*y**4
          -844069602*y**5+231883558*y**6-24855326*y**7-560220*y**8-55436*y**9
          +5055*y**10)+r**26*(-306504612+2486704922*y-8882755911*y**2+18118228327*y**3
          -22833669713*y**4+17790914209*y**5-7744973558*y**6+933462802*y**7+781186158*y**8
          -426906532*y**9+95394533*y**10-11900209*y**11+914239*y**12-38655*y**13)
          +r**24*(-2706526532+20701452158*y-68573142333*y**2+126346224034*y**3
          -135624273306*y**4+73958982950*y**5+2569997351*y**6-33545229876*y**7
          +23347645416*y**8-7506421198*y**9+1060288297*y**10-27167694*y**11-2308426*y**12
          +322890*y**13-67731*y**14)-(-1+y)**11*(-629-3851*y-13472*y**2+60874*y**3
          +309343*y**4+602455*y**5-319568*y**6-1011116*y**7-162103*y**8+516739*y**9
          +554552*y**10-520006*y**11+114413*y**12-13871*y**13-1832*y**14+72*y**15)
          +r**2*(-1+y)**10*(630763+3627965*y+12229226*y**2+21635516*y**3+18699065*y**4
          -11510323*y**5-19383536*y**6-12920428*y**7+23907457*y**8-12291141*y**9
          -2284034*y**10+6096696*y**11-1577173*y**12-373*y**13+19576*y**14+744*y**15)
          +r**4*(-1+y)**9*(-10391692-45092010*y-120255609*y**2-112951367*y**3
          -27388760*y**4+156168646*y**5-103536521*y**6-46872563*y**7-512532*y**8
          +73298874*y**9-14078347*y**10-4841869*y**11-2384328*y**12+2392874*y**13
          -329139*y**14+14343*y**15)+r**22*(10321187492-76740444690*y+241254518919*y**2
          -416737095083*y**3+422938262134*y**4-236069613728*y**5+33967010569*y**6
          +49368355951*y**7-41103343800*y**8+16101175326*y**9-4086441871*y**10
          +1058737571*y**11-326031570*y**12+56036708*y**13-2063985*y**14+30057*y**15)
          +r**6*(-1+y)**8*(-4212292-11697574*y-6915547*y**2-98028769*y**3+398903362*y**4
          +730711432*y**5+67292571*y**6-301795963*y**7-911044344*y**8+671776714*y**9
          +219344515*y**10-237553847*y**11+38822410*y**12+6352388*y**13-1428051*y**14
          +88995*y**15)+r**8*(-1+y)**7*(-534135228-1021749118*y-1458365839*y**2
          +1409562915*y**3+695100716*y**4-19820064*y**5-1725217059*y**6+2195326953*y**7
          -2171769100*y**8+2200870698*y**9-1130949653*y**10+235166277*y**11-2573764*y**12
          +7212660*y**13-2481689*y**14+317295*y**15)+3*r**16*(-1+y)**3*(30544946682
          -109886124776*y+124308837987*y**2+2605689109*y**3-86155274422*y**4-8255344902*y**5
          +109597159319*y**6-77642418337*y**7+5705678134*y**8+15383465556*y**9
          -7226707935*y**10+1198653107*y**11-49810650*y**12+6566682*y**13-2982459*y**14
          +498905*y**15)+r**10*(-1+y)**6*(-2731381604-519792546*y+1474745523*y**2
          +13914983197*y**3-14766173898*y**4-2059541346*y**5+13636560149*y**6-31555905739*y**7
          +35670508148*y**8-15771149282*y**9+848772161*y**10+1298530547*y**11-312171734*y**12
          +38231030*y**13-5291545*y**14+756939*y**15)+r**18*(-1+y)**2*(136379381234
          -653074539256*y+1159210816607*y**2-823666339195*y**3-114521166928*y**4
          +578489700692*y**5-345477710923*y**6+29395513721*y**7+49488570070*y**8
          -15554963644*y**9-3617981891*y**10+2334437179*y**11-268528328*y**12-6655600*y**13
          -680353*y**14+978615*y**15)+r**12*(-1+y)**5*(-7151044612+3514201550*y
          +3689079191*y**2+1851825905*y**3+12529149232*y**4+6451154754*y**5-68836006377*y**6
          +63376767321*y**7-8668696572*y**8-13547951366*y**9+6113980501*y**10+111693427*y**11
          -477479312*y**12+114094742*y**13-12859491*y**14+1291107*y**15)+r**14*(
          -1+y)**4*(-8584005772+20080648130*y-4798453003*y**2-142517315049*y**3
          +421507702050*y**4-530784880524*y**5+306363421443*y**6-14009248191*y**7
          -85074008544*y**8+43540017298*y**9-6753037253*y**10+211162777*y**11-253698006*y**12
          +119264568*y**13-16870323*y**14+1620399*y**15)+r**20*(-48793549420+348777055370*y
          -1052120461755*y**2+1690270919754*y**3-1414715455317*y**4+270602712990*y**5
          +647494086589*y**6-678657193690*y**7+259726523347*y**8+6000907414*y**9
          -39642139465*y**10+11601619222*y**11-159593255*y**12-445780926*y**13
          +61639303*y**14-1682630*y**15+392469*y**16))))/(-20901888000*logy**5*r**20*(
          -1+y)**10+84000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-8709120000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-1451520000*logy**3*r**12*(-1+y)**6*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-120960000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -5040000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*muWC**2*(217728000*logy**5*r**19*(-33-25*r**2
          +10*r**4+43*r**6+63*r**8)*(-1+y)**10+518400*logy**4*r**15*(-1+y)**6*(11422*r**16*(
          -1+y)**4+3*r**14*(7299-29196*y+43794*y**2-25626*y**3+4639*y**4+770*y**5)
          -14*r**12*(-7126+19054*y-9681*y**2-18406*y**3+23694*y**4-9380*y**5
          +1035*y**6)+10*(-1+y)**4*(793-987*y**3+434*y**4+252*y**5-238*y**6
          +40*y**7)+35*r**10*(-2041+10744*y-21276*y**2+21416*y**3-10575*y**4
          +2426*y**5-404*y**6+118*y**7)+r**2*(-1+y)**4*(11811-6720*y**3-30065*y**4
          +25144*y**5-8120*y**6+880*y**7)+70*r**8*(-1164+4956*y-8034*y**2+5433*y**3
          +1835*y**4-6219*y**5+4893*y**6-1794*y**7+256*y**8)+7*r**6*(-7191+21264*y
          -16896*y**2-13386*y**3+45824*y**4-51284*y**5+28566*y**6-4934*y**7-1819*y**8
          +576*y**9)-14*r**4*(-3602+19358*y-38937*y**2+39138*y**3-20077*y**4
          -1183*y**5+15422*y**6-17333*y**7+9412*y**8-2448*y**9+250*y**10))+17280*logy**3*r**11*(
          -1+y)**4*(-1+r**2+y)**2*(16708*r**20*(-1+y)**6-r**18*(-1+y)**2*(-227761
          +944460*y-1500230*y**2+1083215*y**3-380295*y**4+52291*y**5)-r**16*(
          -1+y)**2*(-2283286+8251442*y-10908352*y**2+5790883*y**3-651257*y**4
          -299021*y**5+28011*y**6)+r**14*(2715616-15980286*y+39580491*y**2-49532708*y**3
          +29908747*y**4-2815486*y**5-7569679*y**6+4829254*y**7-1213707*y**8+121858*y**9)
          -(-1+y)**5*(-22808-22808*y-22808*y**2+217237*y**3-181808*y**4+72068*y**5
          +48478*y**6-241047*y**7+243458*y**8-98422*y**9+14760*y**10)+2*r**12*(3727013
          -16936009*y+30096339*y**2-20100843*y**3-7254360*y**4+19625597*y**5
          -11847826*y**6+2873966*y**7-74002*y**8-90225*y**9+16050*y**10)+r**10*(1327010
          -4620214*y+3456423*y**2+22374898*y**3-66300502*y**4+74194328*y**5-31818434*y**6
          -8291323*y**7+15212172*y**8-6667858*y**9+1264447*y**10-86847*y**11)
          +2*r**4*(-1+y)**3*(780603-1116304*y+272112*y**2-224308*y**3-376463*y**4
          +1439431*y**5-470875*y**6-795707*y**7+589578*y**8-68527*y**9-46559*y**10
          +10719*y**11)-r**2*(-1+y)**4*(117291+45616*y+45616*y**2-408929*y**3
          -79164*y**4+296864*y**5-15336*y**6+487769*y**7-971211*y**8+651424*y**9
          -181520*y**10+17880*y**11)+r**6*(-1+y)**2*(-1748376+3414662*y-1912067*y**2
          +3019488*y**3+885338*y**4-13262440*y**5+15071304*y**6-3885888*y**7-3138198*y**8
          +2465722*y**9-655929*y**10+61384*y**11)+r**8*(-3266726+17908342*y-41201466*y**2
          +60370480*y**3-61432100*y**4+27382572*y**5+24762246*y**6-46594003*y**7
          +30066765*y**8-8901330*y**9+813424*y**10+107807*y**11-16011*y**12))
          +288*logy**2*r**7*(-1+y)**2*(-1+r**2+y)**3*(3977*r**26*(-1+y)**8-r**24*(
          -1+y)**4*(-298732+1206859*y-1840116*y**2+1223069*y**3-398126*y**4
          +55086*y**5)+r**22*(-1+y)**2*(9663455-55881417*y+133883529*y**2-169673237*y**3
          +120440705*y**4-46292395*y**5+8102027*y**6-328799*y**7+23732*y**8)+r**20*(
          -1+y)**2*(50332871-287891298*y+685177503*y**2-851265716*y**3+578960385*y**4
          -199422456*y**5+15966993*y**6+11121982*y**7-3170124*y**8+234560*y**9)
          -5*r**18*(-1+y)**2*(-54184870+270289461*y-538145910*y**2+507814103*y**3
          -169676432*y**4-80688761*y**5+88639914*y**6-27379779*y**7+3197914*y**8
          -296240*y**9+26560*y**10)+(-1+y)**8*(-29659-88977*y-177954*y**2+51235*y**3
          +543230*y**4+773003*y**5-1923496*y**6+1390083*y**7-498535*y**8-577030*y**9
          +1003606*y**10-508202*y**11+84696*y**12)+r**16*(80246041-691831703*y
          +2641667968*y**2-5218106131*y**3+5162487410*y**4-1074129937*y**5-3318208484*y**6
          +4154021549*y**7-2281573413*y**8+563088490*y**9+16884096*y**10-42639738*y**11
          +8642758*y**12-464906*y**13)-5*r**8*(-1+y)**4*(40421250-83407191*y
          +42079458*y**2+19087059*y**3-109031778*y**4+148837686*y**5+1347612*y**6
          -161905098*y**7+137546556*y**8-39581267*y**9-3030726*y**10+4131299*y**11
          -747900*y**12+39040*y**13)+r**2*(-1+y)**7*(306180+701337*y+1185471*y**2
          -3967838*y**3+2305190*y**4-3004620*y**5-4511014*y**6+12652208*y**7-6379714*y**8
          +271035*y**9-936185*y**10+1427702*y**11-565504*y**12+67752*y**13)+r**4*(
          -1+y)**6*(-9232933-6135010*y-5267761*y**2+71200704*y**3-70871210*y**4
          +25914806*y**5+34751750*y**6-115069008*y**7+114691137*y**8-41279690*y**9
          -3187473*y**10+5773760*y**11-1335206*y**12+88134*y**13)-r**6*(-1+y)**5*(
          -20866293-3488496*y-5974074*y**2+20532078*y**3+184736085*y**4-237657864*y**5
          -34158348*y**6+101960708*y**7+67523339*y**8-111676310*y**9+42537482*y**10
          -3315606*y**11-854559*y**12+113858*y**13)+r**10*(-1+y)**3*(55133987
          -33586609*y-91043758*y**2-514150790*y**3+884949385*y**4+368324851*y**5
          -1370144452*y**6+713001376*y**7+172653255*y**8-285987385*y**9+99245562*y**10
          -11908314*y**11-503443*y**12+156335*y**13)+2*r**12*(-1+y)**2*(-42417025
          +300214752*y-879978984*y**2+2095086332*y**3-3155960880*y**4+2075295150*y**5
          +498720726*y**6-1718161397*y**7+1100817826*y**8-268618995*y**9-11923700*y**10
          +18887997*y**11-3632219*y**12+259417*y**13)+2*r**14*(199759963-1072518113*y
          +2260362901*y**2-1582170445*y**3-2051878561*y**4+5159422199*y**5-3985332744*y**6
          +407509578*y**7+1523965890*y**8-1243521113*y**9+469583988*y**10-93537393*y**11
          +8637996*y**12-344745*y**13+60599*y**14))+12*logy*r**3*(-1+y)**2*(-1
          +r**2+y)**4*(387*r**32*(-1+y)**8+r**30*(-1+y)**4*(-3943+14224*y-17466*y**2
          +13714*y**3-4275*y**4+722*y**5)+2*r**28*(-1+y)**2*(588506-3428476*y
          +8261889*y**2-10432585*y**3+7340224*y**4-2858790*y**5+540017*y**6-30325*y**7
          +1300*y**8)-r**26*(-40447079+313740424*y-1060298290*y**2+2033708670*y**3
          -2428597558*y**4+1870321432*y**5-931419172*y**6+290815480*y**7-51681675*y**8
          +3765648*y**9+66862*y**10+1258*y**11)+r**24*(473158420-3473373628*y
          +11017471558*y**2-19597494990*y**3+21167772051*y**4-13903914600*y**5
          +5038517384*y**6-553139280*y**7-249470510*y**8+87726244*y**9-7439990*y**10
          +277374*y**11-15633*y**12)+r**22*(984376489-7039774052*y+21911621312*y**2
          -37549977326*y**3+37121153677*y**4-19135859554*y**5+1192488540*y**6+4998236334*y**7
          -3416131293*y**8+1103312298*y**9-184009060*y**10+13632112*y**11+54879*y**12
          +2044*y**13)+2*r**20*(3018174774-19194347840*y+50912212521*y**2-69556721661*y**3
          +43752240100*y**4+6232950255*y**5-31557975677*y**6+22684380861*y**7-6762791845*y**8
          +128415823*y**9+443654746*y**10-109826508*y**11+11853943*y**12-510194*y**13
          +12702*y**14)-(-1+y)**9*(-1573-7865*y-23595*y**2-43281*y**3-77858*y**4
          -32094*y**5+485030*y**6-187610*y**7-607893*y**8+805611*y**9-419883*y**10
          +22635*y**11+123580*y**12-80276*y**13+17072*y**14)+r**6*(-1+y)**6*(
          -21464901-43298250*y-68760985*y**2+263465290*y**3-312703957*y**4+219060802*y**5
          +789705123*y**6-1698601232*y**7+988564953*y**8+54490502*y**9-217866883*y**10
          +33990302*y**11+18825617*y**12-6317118*y**13+378505*y**14+232*y**15)
          -r**2*(-1+y)**8*(86387+351840*y+895330*y**2+771942*y**3-2495971*y**4
          -5544884*y**5+10411140*y**6-8293080*y**7+619581*y**8+8861772*y**9-7742838*y**10
          +1443570*y**11+374275*y**12-11048*y**13-43776*y**14+7760*y**15)-2*r**4*(
          -1+y)**7*(-2017110-5515434*y-10322849*y**2+13439206*y**3+23348989*y**4
          +34357987*y**5-81196094*y**6+50829946*y**7-22019974*y**8-24355480*y**9
          +52741829*y**10-31320022*y**11+6365903*y**12+239943*y**13-148134*y**14
          +9294*y**15)-r**18*(3873848929-20599303912*y+37338494298*y**2-24292416126*y**3
          -837979793*y**4-8413641516*y**5+37617842616*y**6-37749136164*y**7+11421636959*y**8
          +6132369428*y**9-6319862838*y**10+2076013646*y**11-278580159*y**12+7259792*y**13
          +72340*y**14+30500*y**15)+r**8*(-1+y)**5*(447823708+90870976*y+34040846*y**2
          -2744121552*y**3+3068420659*y**4-767634697*y**5-1088135033*y**6+3345365777*y**7
          -3962133022*y**8+1717123806*y**9+154491364*y**10-363371918*y**11+106299327*y**12
          -10342501*y**13-146665*y**14+36925*y**15)+r**14*(-1+y)**2*(2327500675
          -14221107094*y+24696683421*y**2+14298503706*y**3-80617912701*y**4+69657866682*y**5
          +9807445661*y**6-47297433434*y**7+24135432241*y**8+581588710*y**9-4456572561*y**10
          +1533320758*y**11-192987287*y**12-3206122*y**13+2125591*y**14+51754*y**15)
          +2*r**12*(-1+y)**3*(2686642682-7326944850*y+5457785455*y**2+1789396598*y**3
          -7084229804*y**4+5002821682*y**5+5091800785*y**6-12115347620*y**7+8992631734*y**8
          -2503965582*y**9-418527475*y**10+458038890*y**11-110849260*y**12+7844518*y**13
          -47589*y**14+51836*y**15)+r**10*(-1+y)**4*(3066093-432760036*y-257567936*y**2
          -2424850694*y**3+15102474731*y**4-16799101164*y**5-2990717878*y**6+15789849522*y**7
          -8321398077*y**8-821616812*y**9+1962521564*y**10-567924586*y**11+37313189*y**12
          +4343996*y**13-818694*y**14+70782*y**15)+r**16*(5116233322-16649001932*y
          -2200855190*y**2+104583439350*y**3-230047744371*y**4+202065446412*y**5
          +2813179868*y**6-171161108140*y**7+164283050565*y**8-71655184488*y**9
          +11390459990*y**10+2840757490*y**11-1650266445*y**12+296869960*y**13
          -27679516*y**14+2451876*y**15-48751*y**16))-r*(-1+r**2+y)**5*(35*r**34*(
          -1+y)**10-r**32*(-1+y)**6*(20753-78193*y+107564*y**2-63800*y**3+13263*y**4
          +65*y**5)-r**30*(-1+y)**4*(-324004+1797762*y-4027569*y**2+5055070*y**3
          -3850965*y**4+1635742*y**5-355071*y**6+28386*y**7+2129*y**8)-r**28*(
          -1+y)**2*(39120724-297367890*y+979283553*y**2-1820500021*y**3+2095117198*y**4
          -1544754418*y**5+728492380*y**6-209941552*y**7+32595862*y**8-1928972*y**9
          -565*y**10+8981*y**11)+r**26*(-438309788+4077738650*y-16933940673*y**2
          +41178094542*y**3-64754704928*y**4+68678931914*y**5-49661294611*y**6
          +24069153860*y**7-7351161736*y**8+1157385622*y**9+4895629*y**10-28884034*y**11
          +1863668*y**12+278774*y**13-13289*y**14)+(-1+y)**13*(113+904*y+4068*y**2
          +16070*y**3-18177*y**4-182544*y**5+48*y**6+153204*y**7-172921*y**8
          +22192*y**9+53316*y**10-21642*y**11+9113*y**12+1736*y**13+120*y**14)
          +r**24*(-3059920116+26807489830*y-103837119655*y**2+232182367431*y**3
          -326593275712*y**4+291022335388*y**5-148325551231*y**6+17901193061*y**7
          +30169035076*y**8-22632637666*y**9+7557059339*y**10-1298504919*y**11
          +117433424*y**12-10794752*y**13+748283*y**14+7819*y**15)+r**2*(-1+y)**10*(112155
          +541334*y+1575117*y**2+2883766*y**3+1169061*y**4-4925668*y**5-7978489*y**6
          +3560584*y**7+15685381*y**8-18886874*y**9+11059499*y**10-2945666*y**11
          -2736501*y**12+2677928*y**13-648287*y**14+31364*y**15+1296*y**16)+r**6*(
          -1+y)**8*(62162532+148271066*y+249690899*y**2-506275282*y**3-299734805*y**4
          -613230458*y**5+1050114983*y**6+112137066*y**7+10513543*y**8-242570986*y**9
          -418248831*y**10+556597490*y**11-188525015*y**12+13639114*y**13+2562341*y**14
          -107018*y**15+3361*y**16)+r**4*(-1+y)**9*(-2137884-8056226*y-19333975*y**2
          +5511014*y**3+69070163*y**4+113949870*y**5-279892291*y**6+253984538*y**7
          -10043365*y**8-307520158*y**9+285229555*y**10-77405982*y**11-10336263*y**12
          +8922226*y**13-1102905*y**14-11266*y**15+4949*y**16)-r**8*(-1+y)**7*(70260236
          +155537790*y+297343617*y**2-1032505814*y**3+3573944627*y**4-2209540308*y**5
          -10894470065*y**6+21328328340*y**7-13115328243*y**8-71669090*y**9+3553789007*y**10
          -1500042406*y**11+136009693*y**12+41872632*y**13-8573087*y**14-419160*y**15
          +38231*y**16)+r**22*(227682396-2581452578*y+9691614161*y**2-23349831382*y**3
          +51402484217*y**4-98726505846*y**5+139171334405*y**6-135098361274*y**7
          +89857678277*y**8-40750226686*y**9+11872686427*y**10-1594437018*y**11
          -245325837*y**12+144820630*y**13-22164081*y**14+121898*y**15+50291*y**16)
          -r**18*(-1+y)**2*(-71713776938+414557615550*y-943677483351*y**2+1063417687662*y**3
          -507064888451*y**4-146066257436*y**5+345165697395*y**6-217147185840*y**7
          +87340073419*y**8-35222611650*y**9+13492300479*y**10-2605285882*y**11
          -60020309*y**12+98054144*y**13-14296699*y**14+1737820*y**15+120087*y**16)
          -r**10*(-1+y)**6*(-4004617780+1002948218*y+1095292667*y**2+21078159266*y**3
          -22597056641*y**4-133906720*y**5-5753778779*y**6+18224179804*y**7-3978194519*y**8
          -6941797950*y**9+2704298653*y**10+914689922*y**11-666841671*y**12+109582628*y**13
          -6250909*y**14-1574528*y**15+164339*y**16)-r**16*(-1+y)**3*(-91275686294
          +378118719458*y-536039678913*y**2+107906028694*y**3+433963650965*y**4
          -255742217904*y**5-326969810891*y**6+474668030888*y**7-204408564501*y**8
          -6992561518*y**9+38993379457*y**10-14924926170*y**11+2468736875*y**12
          -188923268*y**13+6750603*y**14-581284*y**15+341803*y**16)-r**12*(-1
          +y)**5*(-9994102348+15052316018*y+2329882799*y**2+47197871202*y**3-183337171635*y**4
          +179084314750*y**5+13946233231*y**6-128329307654*y**7+73819934985*y**8
          +872318974*y**9-15924003467*y**10+6126340678*y**11-790092345*y**12-43567662*y**13
          +11189261*y**14-2343010*y**15+346223*y**16)-r**14*(-1+y)**4*(-53406991772
          +152804611862*y-120357853035*y**2+37497778522*y**3-160977617331*y**4
          +304457997150*y**5-209815651523*y**6+44263599154*y**7+5348416605*y**8
          +4982648066*y**9-3448515545*y**10-1326372306*y**11+1137602831*y**12-280496502*y**13
          +24792615*y**14-2232058*y**15+443267*y**16)+r**20*(-37309129596+299212060786*y
          -1038435675577*y**2+2003336813873*y**3-2229073989935*y**4+1157357218159*y**5
          +353785937259*y**6-1021419035999*y**7+701088665829*y**8-174866210805*y**9
          -51859725355*y**10+52123318939*y**11-16027555661*y**12+2174871973*y**13
          -84852935*y**14-1012333*y**15-1732909*y**16+34287*y**17))))/(-15676416000*logy**5*r**20*(
          -1+y)**10+63000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-6531840000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-1088640000*logy**3*r**12*(-1+y)**6*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-90720000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -3780000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((rhoLS*(-217728000*logy**5*r**17*(-6+71*r**2+129*r**4
          +146*r**6+95*r**8+27*r**10)*(-1+y)**10-518400*logy**4*r**13*(-1+y)**6*(
          -10894*r**18*(-1+y)**4-5*r**16*(-4787+19148*y-28722*y**2+23054*y**3
          -8903*y**4+1218*y**5)+r**14*(118448-417092*y+512238*y**2-267852*y**3
          +27868*y**4+15680*y**5-630*y**6)-20*(-1+y)**5*(15+15*y+15*y**2-202*y**3
          +190*y**4-62*y**5+8*y**6)-7*r**12*(-21781+58624*y-30936*y**2-33216*y**3
          +42229*y**4-12710*y**5-340*y**6+170*y**7)+2*r**2*(-1+y)**4*(-4201+21805*y**3
          -34510*y**4+18536*y**5-4130*y**6+400*y**7)+70*r**10*(472+2492*y-12498*y**2
          +17017*y**3-8801*y**4-49*y**5+1797*y**6-708*y**7+116*y**8)+r**4*(-1
          +y)**3*(16763-4163*y-6300*y**2-63700*y**3+132195*y**4-110383*y**5
          +42448*y**6-5920*y**7+320*y**8)+7*r**8*(-16293+103872*y-233208*y**2
          +229842*y**3-77948*y**4-36572*y**5+42578*y**6-14702*y**7+1423*y**8
          +288*y**9)-70*r**6*(2544-12306*y+22719*y**2-19506*y**3+6393*y**4+955*y**5
          -168*y**6-1411*y**7+1046*y**8-288*y**9+22*y**10))+17280*logy**3*r**9*(
          -1+y)**4*(-1+r**2+y)**2*(25246*r**22*(-1+y)**6-r**20*(-1+y)**2*(-190205
          +811312*y-1343198*y**2+1001817*y**3-372103*y**4+64057*y**5)-r**18*(
          -1+y)**2*(-1428628+4838134*y-5795634*y**2+2162321*y**3+580701*y**4
          -456611*y**5+28137*y**6)-10*(-1+y)**7*(-92-276*y-552*y**2+181*y**3
          -276*y**4+65*y**5+798*y**6-582*y**7+104*y**8)+r**16*(-3450924+17159746*y
          -32510361*y**2+30649630*y**3-15016611*y**4+4321314*y**5-2758851*y**6
          +2551516*y**7-1040185*y**8+138826*y**9)+2*r**14*(-7151703+36698903*y
          -73940211*y**2+74119845*y**3-33652849*y**4-2941477*y**5+11261157*y**6
          -5357904*y**7+1106975*y**8-108911*y**9+1875*y**10)+r**2*(-1+y)**5*(7686
          +9526*y+11366*y**2-61809*y**3-11504*y**4+54464*y**5+159954*y**6-393711*y**7
          +305114*y**8-98666*y**9+11280*y**10)-2*r**6*(-1+y)**3*(-1027468+1378203*y
          -284349*y**2+3755511*y**3-11121974*y**4+12745632*y**5-7284960*y**6+2068594*y**7
          -215656*y**8+7639*y**9-17239*y**10+5517*y**11)+r**4*(-1+y)**4*(-108779
          -53212*y-37972*y**2+533883*y**3-270092*y**4-152564*y**5-444828*y**6
          +1196517*y**7-1023513*y**8+445912*y**9-99812*y**10+8160*y**11)-r**8*(
          -1+y)**2*(3291188-6157774*y+2650859*y**2-13450756*y**3+43596054*y**4
          -58663912*y**5+41572072*y**6-15400854*y**7+1879416*y**8+588036*y**9
          -233281*y**10+26552*y**11)-r**12*(20728170-106478482*y+217201689*y**2
          -222973326*y**3+105472214*y**4+11165204*y**5-45963642*y**6+28267761*y**7
          -9005544*y**8+1782946*y**9-270859*y**10+29769*y**11)+r**10*(-15910070
          +80986702*y-166327542*y**2+181921460*y**3-121249950*y**4+62036520*y**5
          -37584934*y**6+25359179*y**7-11417015*y**8+1779170*y**9+707320*y**10
          -337623*y**11+36783*y**12))-288*logy**2*r**5*(-1+y)**2*(-1+r**2+y)**3*(
          -7193*r**28*(-1+y)**8+r**26*(-1+y)**4*(-509106+2058003*y-3140952*y**2
          +2097343*y**3-648832*y**4+91584*y**5)-r**24*(-1+y)**2*(11457121-65747343*y
          +156199815*y**2-195321563*y**3+134912725*y**4-48645901*y**5+6992193*y**6
          +56975*y**7+33578*y**8)-r**22*(-1+y)**2*(22311583-131008578*y+326406927*y**2
          -413557342*y**3+271974525*y**4-78519998*y**5-7799427*y**6+14248588*y**7
          -4386988*y**8+375410*y**9)+2*(-1+y)**10*(899+4495*y+13485*y**2+20820*y**3
          +8675*y**4-30523*y**5-14045*y**6-4810*y**7+34430*y**8-18750*y**9+2824*y**10)
          +r**20*(-1+y)**2*(-139899962+646320561*y-1150651566*y**2+806435137*y**3
          +162411410*y**4-612884203*y**5+361621164*y**6-79812729*y**7+5498348*y**8
          -1325770*y**9+267410*y**10)+r**2*(-1+y)**8*(12057+41565*y+93918*y**2
          -111555*y**3-55130*y**4-299639*y**5+405780*y**6-210411*y**7-154595*y**8
          +260030*y**9-8718*y**10-78470*y**11+21168*y**12)+r**4*(-1+y)**7*(-480424
          -836813*y-1162755*y**2+4054772*y**3-951770*y**4+1107518*y**5-4443694*y**6
          +3242770*y**7+434366*y**8+154295*y**9-1828919*y**10+1287082*y**11-355540*y**12
          +38112*y**13)+r**6*(-1+y)**6*(5248269+5182026*y+5487441*y**2-48681566*y**3
          +33244250*y**4+7489132*y**5+42200438*y**6-130310282*y**7+124879347*y**8
          -55108800*y**9+9847449*y**10+447736*y**11-391034*y**12+45594*y**13)
          -r**8*(-1+y)**5*(37560487-3901656*y+1338546*y**2-173980342*y**3+222492375*y**4
          -138390714*y**5+187970252*y**6-294758522*y**7+265300939*y**8-137009000*y**9
          +37398002*y**10-3077596*y**11-628849*y**12+85078*y**13)+r**10*(-1+y)**4*(284081864
          -545190539*y+245513430*y**2-914444375*y**3+3159962300*y**4-4466917248*y**5
          +3215258428*y**6-1075159180*y**7-47494610*y**8+181698475*y**9-69762266*y**10
          +13291311*y**11-1471050*y**12+88460*y**13)+r**12*(-1+y)**3*(-230547851
          +462372625*y-213113594*y**2+1370934770*y**3-4634231605*y**4+6602408897*y**5
          -5118613980*y**6+2081316298*y**7-150181935*y**8-247810145*y**9+105794254*y**10
          -14817620*y**11-34529*y**12+132415*y**13)-2*r**14*(-1+y)**2*(-601800761
          +2892125268*y-5464757880*y**2+5300072178*y**3-2358788790*y**4-629286888*y**5
          +1656848474*y**6-1087480970*y**7+343817914*y**8-22490660*y**9-34772926*y**10
          +19344308*y**11-4453475*y**12+349708*y**13)+r**18*(558959281-3623887253*y
          +9673799908*y**2-13796939081*y**3+11123345370*y**4-4734792527*y**5+884177936*y**6
          -408248991*y**7+527190927*y**8-188767920*y**9-58286304*y**10+54334192*y**11
          -11635942*y**12+666404*y**13)-2*r**16*(-673205706+4512884532*y-12625173465*y**2
          +18984502458*y**3-15517549479*y**4+4067111052*y**5+5227816726*y**6-6783648560*y**7
          +3751923284*y**8-1048942432*y**9+78949529*y**10+31773592*y**11-5630525*y**12
          -1058442*y**13+247436*y**14))+12*logy*r*(-1+y)**2*(-1+r**2+y)**4*(525*r**34*(
          -1+y)**8+r**32*(-1+y)**4*(-12257+46928*y-65142*y**2+49502*y**3-19093*y**4
          +3038*y**5)+2*r**30*(-1+y)**2*(1276242-7461356*y+18055995*y**2-23012203*y**3
          +16420126*y**4-6506058*y**5+1312831*y**6-110271*y**7+6454*y**8)+2*(
          -1+y)**13*(-23-207*y-1035*y**2-3209*y**3-5249*y**4-1129*y**5+4927*y**6
          +5925*y**7-1756*y**8-3996*y**9+1552*y**10)-r**28*(-52678747+406810632*y
          -1368948214*y**2+2609896230*y**3-3082743250*y**4+2325767548*y**5-1116573512*y**6
          +328119284*y**7-52768635*y**8+2842860*y**9+244054*y**10+7750*y**11)
          +r**26*(442597960-3186937516*y+9883183354*y**2-17022569330*y**3+17397902033*y**4
          -10167759704*y**5+2517301632*y**6+569005008*y**7-554229950*y**8+132325852*y**9
          -11803466*y**10+1142794*y**11-84267*y**12)+r**24*(-182680591+1115855036*y
          -2309604564*y**2+2225436050*y**3-1682771141*y**4+2471779098*y**5-3599011364*y**6
          +3448243018*y**7-2208286393*y**8+899771126*y**9-191731072*y**10+10809188*y**11
          +1335381*y**12-17372*y**13)-r**2*(-1+y)**9*(81+589*y+2319*y**2+5389*y**3
          +123294*y**4+292738*y**5+11142*y**6-276618*y**7-606483*y**8+936677*y**9
          -269269*y**10-236131*y**11+207524*y**12-54356*y**13+3104*y**14)+2*r**22*(1840655330
          -11175077216*y+27585130263*y**2-32324226507*y**3+9845385538*y**4+20743462565*y**5
          -28599421693*y**6+14860783079*y**7-1932528161*y**8-1430925611*y**9+703210580*y**10
          -125647716*y**11+12034733*y**12-1206082*y**13+92898*y**14)-r**16*(-1
          +y)**2*(-1323430095+9847859438*y-17332453701*y**2-16789640970*y**3+81079799347*y**4
          -97627403754*y**5+53950993941*y**6-9283766446*y**7-5281584573*y**8+1754220398*y**9
          +1790889625*y**10-1249557154*y**11+214910297*y**12+17628718*y**13-5486345*y**14
          +1274*y**15)+r**8*(-1+y)**6*(-39914893-59275930*y-74008141*y**2+366518274*y**3
          -178229551*y**4+1973394*y**5-227758787*y**6+318163080*y**7-129371115*y**8
          +99860670*y**9-163742651*y**10+114189742*y**11-35271289*y**12+4673466*y**13
          -188469*y**14+2200*y**15)+r**4*(-1+y)**8*(-309631-1151712*y-2704942*y**2
          -1206366*y**3+3517815*y**4+9728800*y**5-7200936*y**6+417004*y**7-5645293*y**8
          +7566280*y**9-3242802*y**10+390098*y**11-201387*y**12+253784*y**13-76920*y**14
          +6208*y**15)+2*r**6*(-1+y)**7*(241690+1011558*y+2588879*y**2-6065290*y**3
          -2747173*y**4-11547759*y**5+32747116*y**6-22764256*y**7-11183788*y**8
          +16551998*y**9+1348835*y**10-7066424*y**11+2710527*y**12-157597*y**13
          -72950*y**14+8634*y**15)+r**20*(-16760084757+99625720776*y-236259243870*y**2
          +278797607510*y**3-143316304843*y**4-26006894752*y**5+71566466436*y**6
          -27960430352*y**7-2784664887*y**8+2013576464*y**9+2421297078*y**10-1594186762*y**11
          +286258247*y**12-2943848*y**13-1843596*y**14+31156*y**15)+r**10*(-1
          +y)**5*(297638848+184827652*y+164105134*y**2-2378080964*y**3+2322158841*y**4
          -316590819*y**5+1456577725*y**6-5473932189*y**7+6626000482*y**8-3731453818*y**9
          +818321248*y**10+128989098*y**11-107902395*y**12+22308857*y**13-1907723*y**14
          +56023*y**15)+2*r**14*(-1+y)**3*(3605844314-8895573522*y+6038413553*y**2
          -10608711026*y**3+40580574830*y**4-67967031360*y**5+57366869369*y**6
          -21118553726*y**7-3952758618*y**8+7500103130*y**9-3180097197*y**10+573130178*y**11
          -18597102*y**12-2980456*y**13-1264285*y**14+215918*y**15)+r**12*(-1
          +y)**4*(-945407559+725159180*y-79992940*y**2+3662773154*y**3-5947559701*y**4
          +7058758216*y**5-10003697550*y**6+10349002830*y**7-6681771673*y**8+2600659092*y**9
          -469067640*y**10-12984530*y**11-14847515*y**12+21566344*y**13-5065566*y**14
          +327858*y**15)-r**18*(21976990054-143773554404*y+389702336458*y**2-560905622850*y**3
          +405174382445*y**4+14980794900*y**5-346589899052*y**6+363527940004*y**7
          -183443694535*y**8+34556440000*y**9+11148666598*y**10-7972429094*y**11
          +1768281563*y**12-169702640*y**13+24596380*y**14-5801852*y**15+276025*y**16))
          +r*(-1+r**2+y)**5*(985*r**34*(-1+y)**10+r**32*(-1+y)**6*(-16991+69339*y
          -104296*y**2+74316*y**3-29421*y**4+6705*y**5)+r**30*(-1+y)**4*(494100
          -3025354*y+7688907*y**2-9845710*y**3+6724627*y**4-2641618*y**5+672481*y**6
          -122214*y**7+16261*y**8)+r**28*(-1+y)**2*(62985860-475788326*y+1556578849*y**2
          -2870721361*y**3+3264079414*y**4-2357146562*y**5+1073052596*y**6-292551760*y**7
          +41916950*y**8-2353360*y**9+63931*y**10+9049*y**11)+r**26*(411083540
          -3765521182*y+15382873205*y**2-36618002038*y**3+55772611220*y**4-56142066274*y**5
          +37028156131*y**6-14933570768*y**7+2720571892*y**8+433054234*y**9-367594941*y**10
          +87700966*y**11-9729532*y**12+434566*y**13-34619*y**14)+r**24*(2644397876
          -22842906722*y+87067162215*y**2-190464012339*y**3+258533320208*y**4
          -214414825696*y**5+87677728627*y**6+15586633539*y**7-42435839372*y**8
          +25182572790*y**9-7690493139*y**10+1272065115*y**11-129785384*y**12+14807356*y**13
          -609303*y**14-81371*y**15)+r**22*(-7960660004+67793515606*y-249991715477*y**2
          +528584048026*y**3-708017031937*y**4+616284408718*y**5-330384772341*y**6
          +78104216954*y**7+23416916423*y**8-24774620526*y**9+8622554761*y**10
          -2483048946*y**11+1140423573*y**12-387508374*y**13+54158113*y**14-1000450*y**15
          -52119*y**16)+(-1+y)**11*(-3361-19614*y-66993*y**2-96566*y**3+19301*y**4
          +243848*y**5-563287*y**6-244764*y**7+501897*y**8+484178*y**9-82423*y**10
          -774494*y**11+556507*y**12-130556*y**13+7071*y**14+1136*y**15+120*y**16)
          +r**2*(-1+y)**10*(-44071-205074*y-571377*y**2-83890*y**3+3724099*y**4
          +8206444*y**5-4562931*y**6-5328836*y**7-9543265*y**8+24125662*y**9-11087775*y**10
          -6937666*y**11+7744413*y**12-2288120*y**13+208739*y**14+2552*y**15+1096*y**16)
          +r**4*(-1+y)**9*(6055084+20709838*y+45333163*y**2+13126054*y**3-63575287*y**4
          -155107826*y**5+171014127*y**6-46363942*y**7+46383041*y**8-36464622*y**9
          -6448751*y**10-1161774*y**11+19481379*y**12-13231470*y**13+3388309*y**14
          -292882*y**15+11559*y**16)+r**6*(-1+y)**8*(13974340+20958658*y+8722849*y**2
          +228784350*y**3-155651939*y**4-17363262*y**5-463002311*y**6+589361686*y**7
          +306143069*y**8-499139258*y**9-144366597*y**10+345233322*y**11-120684385*y**12
          -7973994*y**13+11524747*y**14-1689406*y**15+80131*y**16)+r**8*(-1+y)**7*(626920460
          +725954866*y+714074541*y**2-4242178194*y**3+2557569951*y**4-39176568*y**5
          +1274396183*y**6-2551880696*y**7+2722357389*y**8-2826251766*y**9+2091059507*y**10
          -803702698*y**11+120951105*y**12-20835620*y**13+18069865*y**14-4263724*y**15
          +319399*y**16)+r**18*(-1+y)**2*(-141945549850+819502852842*y-1879534868163*y**2
          +2102898082522*y**3-876046141243*y**4-560473771396*y**5+895641248831*y**6
          -418359128292*y**7+31994796303*y**8+30824611178*y**9+1658897459*y**10
          -7347429446*y**11+1720421155*y**12+41635600*y**13-45114735*y**14+1484912*y**15
          +532323*y**16)+r**10*(-1+y)**6*(-1110308012-145358082*y-476421577*y**2
          +12434343430*y**3-16392609721*y**4+7372165800*y**5-10934043279*y**6+39613422800*y**7
          -56285474939*y**8+35930684038*y**9-7970661663*y**10-2220776290*y**11
          +1515943177*y**12-290549516*y**13+41293783*y**14-7911700*y**15+789751*y**16)
          +r**16*(-1+y)**3*(-50259739670+221875855046*y-336374935917*y**2+118381062970*y**3
          +96614739737*y**4+195493959036*y**5-598972063787*y**6+497895104132*y**7
          -114828520797*y**8-77106584626*y**9+62906283061*y**10-18013197246*y**11
          +2103110735*y**12-113084048*y**13+34813539*y**14-8815552*y**15+1069387*y**16)
          +r**12*(-1+y)**5*(4759126884-6758300578*y+1666263491*y**2-5765432882*y**3
          +9062699945*y**4-33476945270*y**5+78714334163*y**6-61740023962*y**7-4716267651*y**8
          +33712790850*y**9-18170767967*y**10+1609291018*y**11+1735562171*y**12
          -667529642*y**13+109985705*y**14-13575422*y**15+1285147*y**16)+r**14*(
          -1+y)**4*(-34995628852+104498558546*y-94896544599*y**2+120122385958*y**3
          -448999262459*y**4+828280366758*y**5-740618315451*y**6+272685810546*y**7
          +63476586177*y**8-97964450834*y**9+32882284123*y**10-3933679398*y**11
          +835271903*y**12-559052710*y**13+136589943*y**14-16410354*y**15+1418703*y**16)
          +r**20*(37421294476-302047001254*y+1052535059073*y**2-2036410516313*y**3
          +2278384878463*y**4-1220361350511*y**5-271469389547*y**6+927683228231*y**7
          -626887820509*y**8+143437191709*y**9+49381607659*y**10-40312316219*y**11
          +8909898629*y**12-62533453*y**13-212616097*y**14+8115501*y**15+2137645*y**16
          +132517*y**17))))/(-20901888000*logy**5*r**20*(-1+y)**10+84000*(r**8*(-1
          +y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5-8709120000*logy**4*r**16*(
          -1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -1451520000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2-120960000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3-5040000*logy*(
          -1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(
          -4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2
          +y**3))**4))
      resNP += ((mupi*(-217728000*logy**5*r**19*(3+5*r**2+10*r**4+13*r**6
          +27*r**8)*(-1+y)**10-518400*logy**4*r**15*(-1+y)**6*(1522*r**16*(-1+y)**4
          -15*r**14*(-857+3428*y-5142*y**2+3386*y**3-1333*y**4+182*y**5)-14*r**12*(
          -3034+8086*y-4029*y**2-7444*y**3+8226*y**4-2840*y**5+225*y**6)-35*r**10*(883
          -4312*y+8028*y**2-7484*y**3+2637*y**4-38*y**5-124*y**6+2*y**7)+10*(
          -1+y)**4*(-197+2583*y**3-4270*y**4+2520*y**5-658*y**6+64*y**7)+r**2*(
          -1+y)**4*(2769+30660*y**3-60515*y**4+35056*y**5-8120*y**6+640*y**7)
          +70*r**8*(-144+876*y-1914*y**2+1503*y**3+1367*y**4-3147*y**5+2283*y**6
          -750*y**7+88*y**8)+7*r**6*(-1401+7104*y-13656*y**2+6054*y**3+16424*y**4
          -22424*y**5+7386*y**6+3886*y**7-3229*y**8+576*y**9)-70*r**4*(98-482*y
          +903*y**2-252*y**3-713*y**4-527*y**5+2938*y**6-3271*y**7+1676*y**8
          -408*y**9+38*y**10))+17280*logy**3*r**11*(-1+y)**4*(-1+r**2+y)**2*(4982*r**20*(
          -1+y)**6+r**18*(-1+y)**2*(-56551+216240*y-299450*y**2+169175*y**3
          -69405*y**4+11671*y**5)-r**16*(-1+y)**2*(474916-1820162*y+2607862*y**2
          -1647133*y**3+563177*y**4-131869*y**5+24789*y**6)+r**14*(-1271596+6774666*y
          -14672901*y**2+15565508*y**3-8464657*y**4+2137906*y**5+177169*y**6-335494*y**7
          +36537*y**8+8762*y**9)+2*r**12*(-1854233+8558359*y-15063909*y**2+9656913*y**3
          +2368185*y**4-5653877*y**5+2214181*y**6-376856*y**7+187207*y**8-79665*y**9
          +7995*y**10)+(-1+y)**5*(-1118-1118*y-1118*y**2+11437*y**3-47738*y**4
          +36878*y**5+260248*y**6-531027*y**7+393218*y**8-129682*y**9+16320*y**10)
          +r**10*(-1327010+7131154*y-14755653*y**2+7851662*y**3+9953722*y**4
          -9633188*y**5-6334786*y**6+12219163*y**7-6342372*y**8+1177798*y**9+36923*y**10
          -21513*y**11)-r**6*(-1+y)**2*(-304356+1068122*y-1011257*y**2-6513072*y**3
          +28156418*y**4-43121920*y**5+31529844*y**6-10141848*y**7-62538*y**8
          +918742*y**9-215319*y**10+12184*y**11)-2*r**4*(-1+y)**3*(-123582+188981*y
          -57423*y**2+2543597*y**3-7813028*y**4+9040486*y**5-4944400*y**6+1488178*y**7
          -580152*y**8+361913*y**9-126779*y**10+15909*y**11)+r**2*(-1+y)**4*(
          -53919+2236*y+2236*y**2+745051*y**3-1319724*y**4+935924*y**5-1168416*y**6
          +2047529*y**7-1880361*y**8+876064*y**9-196640*y**10+16320*y**11)+r**8*(
          -478834+2791958*y-6615894*y**2+7161920*y**3-14357110*y**4+43341228*y**5
          -67912626*y**6+55095433*y**7-22579815*y**8+2859990*y**9+1054136*y**10
          -399077*y**11+38691*y**12))+288*logy**2*r**7*(-1+y)**2*(-1+r**2+y)**3*(6121*r**26*(
          -1+y)**8-r**24*(-1+y)**4*(-120344+499739*y-795516*y**2+626839*y**3
          -177766*y**4+19008*y**5)-r**22*(-1+y)**2*(-106039+118869*y+1028499*y**2
          -3651629*y**3+6407405*y**4-6680341*y**5+3667661*y**6-924539*y**7+77714*y**8)
          +r**20*(-1+y)**2*(-19470749+106844562*y-238717617*y**2+273306434*y**3
          -179684835*y**4+77729634*y**5-23681547*y**6+4132952*y**7-606564*y**8
          +103030*y**9)+5*r**18*(-1+y)**2*(-9230926+47975043*y-101295558*y**2
          +105457619*y**3-53107718*y**4+9189067*y**5+1960980*y**6-2403243*y**7
          +1458076*y**8-444926*y**9+37546*y**10)-(-1+y)**8*(-19561-58683*y
          -117366*y**2+24745*y**3+260870*y**4+464057*y**5-687244*y**6+518217*y**7
          -510145*y**8-270370*y**9+805654*y**10-444398*y**11+76224*y**12)+r**16*(
          -84385267+547606181*y-1496733976*y**2+2067969877*y**3-1376547350*y**4
          +181698799*y**5+349928228*y**6-300944453*y**7+166205271*y**8-72838000*y**9
          +24903468*y**10-8971884*y**11+2233154*y**12-208048*y**13)-r**4*(-1+y)**6*(536561
          +1017806*y+1281065*y**2-14320062*y**3+2913430*y**4+742328*y**5+104657138*y**6
          -218148990*y**7+180950679*y**8-69813380*y**9+9474861*y**10+1113056*y**11
          -374150*y**12+11658*y**13)-5*r**8*(-1+y)**4*(4532694-8955999*y+4917210*y**2
          -128312787*y**3+467337618*y**4-620738304*y**5+365147496*y**6-65437044*y**7
          -23317332*y**8+8981687*y**9+122370*y**10+116263*y**11-201936*y**12+22064*y**13)
          -r**2*(-1+y)**7*(-112896-167109*y-162639*y**2+18304*y**3+2076710*y**4
          -466038*y**5-10403722*y**6+13854758*y**7-6034078*y**8+2855715*y**9-3789791*y**10
          +2545706*y**11-739144*y**12+76224*y**13)-r**10*(-1+y)**3*(59273213-219204391*y
          +248317118*y**2+429515650*y**3-2586539285*y**4+4509720649*y**5-3611432248*y**6
          +1154938774*y**7+211126305*y**8-287160565*y**9+87372138*y**10-9393936*y**11
          -507217*y**12+113795*y**13)+2*r**12*(-1+y)**2*(-18636809+137586324*y
          -336722736*y**2+72397726*y**3+361416510*y**4+59501988*y**5-769329948*y**6
          +691448222*y**7-201870832*y**8-21607260*y**9+16389296*y**10+2156574*y**11
          -1462561*y**12+144506*y**13)+r**6*(-1+y)**5*(9995829-7614492*y-1816038*y**2
          -174568404*y**3+416533215*y**4-367216878*y**5+279500064*y**6-406196614*y**7
          +429362573*y**8-232159640*y**9+56682074*y**10-1850922*y**11-1408773*y**12
          +170006*y**13)-2*r**14*(138706129-838727015*y+2063711071*y**2-2278816453*y**3
          +397574273*y**4+1526183597*y**5-1251665880*y**6-74718897*y**7+570221751*y**8
          -340369856*y**9+112269099*y**10-30491430*y**11+6945351*y**12-848298*y**13
          +26558*y**14))+12*logy*r**3*(-1+y)**2*(-1+r**2+y)**4*(-387*r**32*(-1
          +y)**8-r**30*(-1+y)**4*(-18145+71032*y-102678*y**2+69034*y**3-18477*y**4
          +2210*y**5)+2*r**28*(-1+y)**2*(656482-3827504*y+9250419*y**2-11929277*y**3
          +8633438*y**4-3313518*y**5+575731*y**6-29717*y**7+2186*y**8)+r**26*(643651
          -4401776*y+14076410*y**2-29472282*y**3+34128182*y**4-4059752*y**5-37213396*y**6
          +42206680*y**7-19851993*y**8+4347168*y**9-448694*y**10+21802*y**11)
          +r**24*(-48350836+390069388*y-1364798254*y**2+2742642954*y**3-3580313703*y**4
          +3268393728*y**5-2148516896*y**6+985403616*y**7-286055194*y**8+43977668*y**9
          -2583562*y**10+80838*y**11-24147*y**12)-r**22*(616890631-4197195140*y
          +12069344744*y**2-18561076838*y**3+16135115323*y**4-7639592530*y**5+1511732436*y**6
          +298442022*y**7-375539835*y**8+182146002*y**9-51008476*y**10+11812504*y**11
          -2051991*y**12+107548*y**13)+2*r**20*(-172175946+1134512756*y-3303765117*y**2
          +5249843583*y**3-4434099022*y**4+1083023295*y**5+1583219711*y**6-2109181263*y**7
          +1587406927*y**8-861310993*y**9+282075176*y**10-40310292*y**11-1588795*y**12
          +618290*y**13+9690*y**14)+(-1+y)**9*(-1573-7865*y-23595*y**2-40077*y**3
          -50114*y**4-10254*y**5+206990*y**6+11230*y**7-183141*y**8+161523*y**9
          -228723*y**10+172575*y**11-5060*y**12-42332*y**13+12416*y**14)-r**6*(
          -1+y)**6*(19625829+28299570*y+31263665*y**2-128769998*y**3-145332835*y**4
          +8531878*y**5+1048898733*y**6-1537030712*y**7+859367079*y**8-267602902*y**9
          +177034115*y**10-137608978*y**11+49746647*y**12-7046706*y**13+85087*y**14
          +7528*y**15)+2*r**4*(-1+y)**7*(-772122-1994418*y-3587537*y**2+5821972*y**3
          +6919585*y**4+14324011*y**5-11925866*y**6+6871522*y**7-18936106*y**8
          -17578252*y**9+49838537*y**10-31540816*y**11+7240715*y**12-141741*y**13
          -112758*y**14+11274*y**15)+r**2*(-1+y)**8*(72185+295032*y+753310*y**2
          +599286*y**3-1178473*y**4-3579524*y**5+3489636*y**6-3575520*y**7+2267223*y**8
          +3814596*y**9-4055202*y**10+575082*y**11+92185*y**12+209416*y**13-99648*y**14
          +12416*y**15)+2*r**12*(-1+y)**3*(159356146-227209518*y+127939085*y**2
          -7187019344*y**3+28509966752*y**4-41896457362*y**5+26920474691*y**6-3545967010*y**7
          -5859486802*y**8+4186206006*y**9-1293853649*y**10+176564952*y**11+4863400*y**12
          -2539054*y**13+26217*y**14+33490*y**15)+r**8*(-1+y)**5*(-23016124+18780176*y
          +39766282*y**2-767735292*y**3+954877853*y**4-632871239*y**5+3938784929*y**6
          -8976895733*y**7+8696573590*y**8-3977194230*y**9+574230476*y**10+213251570*y**11
          -102356199*y**12+16137277*y**13-963623*y**14+42287*y**15)-r**14*(-1
          +y)**2*(-2825235467+9634727582*y-10731229077*y**2+3176971122*y**3+16227718965*y**4
          -43531291194*y**5+46560251339*y**6-19162677578*y**7-3226202921*y**8+5539833298*y**9
          -1259111463*y**10-263331746*y**11+118722655*y**12-6103126*y**13-1876463*y**14
          +134074*y**15)+r**10*(-1+y)**4*(-370551951+530067988*y+23739728*y**2
          +4918817702*y**3-16080997121*y**4+16980195492*y**5-8599244006*y**6+6264905334*y**7
          -7958213529*y**8+5481308132*y**9-1547706956*y**10+24072418*y**11+50079913*y**12
          +2617252*y**13-2153886*y**14+179490*y**15)+r**18*(-1278887213+7072222832*y
          -15260032506*y**2+11124519186*y**3+5663230381*y**4-9016161708*y**5-6256878192*y**6
          +16123530084*y**7-12183938275*y**8+5236365980*y**9-1409481138*y**10+156474710*y**11
          +1340547*y**12+6690464*y**13-2556836*y**14+209684*y**15)+r**16*(-5116233322
          +29570752172*y-68868771130*y**2+65185861614*y**3+12752208831*y**4-77726979324*y**5
          +53700331900*y**6+1661815780*y**7-18965219493*y**8+10551157968*y**9-3879600566*y**10
          +1517924954*y**11-424361175*y**12+33588704*y**13+8932276*y**14-1450188*y**15
          +40999*y**16))+r*(-1+r**2+y)**5*(101*r**34*(-1+y)**10+r**32*(-1+y)**6*(
          -24719+93727*y-130040*y**2+78236*y**3-17361*y**4+505*y**5)-r**30*(
          -1+y)**4*(-1356664+7803798*y-18464127*y**2+23282818*y**3-16640511*y**4
          +6568498*y**5-1350753*y**6+117822*y**7+599*y**8)-r**28*(-1+y)**2*(-13194464
          +96247278*y-303314685*y**2+537085769*y**3-571096958*y**4+349440698*y**5
          -93492608*y**6-13756924*y**7+14993902*y**8-2852816*y**9+55757*y**10
          +10331*y**11)+r**26*(-96948416+920544086*y-3884519619*y**2+9573770730*y**3
          -15379406660*y**4+17175027062*y**5-14005083397*y**6+8652068612*y**7-4079989108*y**8
          +1409989834*y**9-331370561*y**10+52248146*y**11-7102408*y**12+836138*y**13
          -30839*y**14)+(-1+y)**13*(179+1432*y+6444*y**2+21194*y**3+17229*y**4
          -67464*y**5-46560*y**6-6564*y**7-34939*y**8+43936*y**9-4980*y**10-4662*y**11
          +6155*y**12+1280*y**13+120*y**14)-r**24*(191413848-1769730454*y+7304493133*y**2
          -18043162341*y**3+30453901816*y**4-38031013492*y**5+36387919537*y**6
          -26185775939*y**7+13159214792*y**8-3903367574*y**9+274082791*y**10+239476437*y**11
          -91565624*y**12+15460544*y**13-1243397*y**14+30323*y**15)+r**2*(-1+y)**10*(116121
          +560834*y+1632627*y**2+2632570*y**3+1104411*y**4-3894940*y**5-4635379*y**6
          -1705256*y**7+7480783*y**8-3006614*y**9+5782085*y**10-6687926*y**11
          +650229*y**12+1649072*y**13-530597*y**14+26084*y**15+1896*y**16)+r**4*(
          -1+y)**9*(-1105224-4115510*y-9870793*y**2+5370506*y**3+27781637*y**4
          +58174098*y**5-79518937*y**6+93195254*y**7-39522559*y**8-135618586*y**9
          +153114469*y**10-52164978*y**11+5382039*y**12-1117922*y**13+1045149*y**14
          -209518*y**15+12875*y**16)+r**6*(-1+y)**8*(9847344+16231838*y+18401453*y**2
          -119898286*y**3+4275841*y**4-116954918*y**5-371051311*y**6+676948878*y**7
          +41587501*y**8+160377122*y**9-987602817*y**10+834573662*y**11-248008181*y**12
          +13187110*y**13+5828387*y**14-795134*y**15+51511*y**16)+r**22*(-3813895296
          +31548926602*y-113555674129*y**2+226854219158*y**3-263753278405*y**4
          +159074149782*y**5-4006781005*y**6-74630913934*y**7+67042572887*y**8
          -34889637082*y**9+13248695077*y**10-3799938678*y**11+800965113*y**12
          -134329670*y**13+16054137*y**14-1021138*y**15+54581*y**16)+r**8*(-1
          +y)**7*(271101136+270765798*y+209833905*y**2-2452501366*y**3-492009233*y**4
          +191419572*y**5+10950011039*y**6-17766090564*y**7+11659254993*y**8-3818434858*y**9
          +863280799*y**10-316432406*y**11+131229809*y**12-32042352*y**13+6753041*y**14
          -854832*y**15+139519*y**16)+r**10*(-1+y)**6*(1136111512-224151182*y
          -592069829*y**2+723644914*y**3-8039704921*y**4+10283138848*y**5-17322684223*y**6
          +42052978580*y**7-53387891971*y**8+31197630594*y**9-5665606195*y**10
          -2311281686*y**11+1314437649*y**12-231970868*y**13+23825527*y**14-1981840*y**15
          +279091*y**16)+r**12*(-1+y)**5*(5952524656-8766918278*y-274754609*y**2
          -31512056526*y**3+114593749149*y**4-125850493714*y**5+47987130539*y**6
          +1603967954*y**7-3765149067*y**8+837288518*y**9-1231630579*y**10+3283142*y**11
          +647765055*y**12-305995182*y**13+67015033*y**14-6324938*y**15+438847*y**16)
          +r**18*(-1+y)**2*(-14568881878+84153234246*y-193455800535*y**2+178477380798*y**3
          +4619454989*y**4-110968301596*y**5+24532562943*y**6+73927454592*y**7
          -70129873129*y**8+26911791054*y**9-2289104817*y**10-2686800002*y**11
          +1130057243*y**12-163113944*y**13+10706857*y**14-2705884*y**15+459063*y**16)
          +r**14*(-1+y)**4*(11018181848-28189339346*y+15082076949*y**2+47286659642*y**3
          -185643913551*y**4+320499868158*y**5-266006981491*y**6+63232924418*y**7
          +65355615777*y**8-61066149062*y**9+19271736551*y**10-1513212114*y**11
          -165996917*y**12-118512294*y**13+62731863*y**14-8411882*y**15+561451*y**16)
          +r**16*(-1+y)**3*(4993027478-14002981094*y+4584396471*y**2+55769857718*y**3
          -115349532623*y**4+90183696744*y**5-34857053467*y**6+21820637896*y**7
          -11573854953*y**8-10210222166*y**9+14130965321*y**10-5998767786*y**11
          +936692383*y**12-13464940*y**13+8229339*y**14-4894868*y**15+580547*y**16)
          +r**20*(5079680328-42449575862*y+152071921169*y**2-296981343649*y**3
          +324903242791*y**4-155568958007*y**5-65705947623*y**6+153817665499*y**7
          -106440935577*y**8+35580189873*y**9-4160006725*y**10+1057311517*y**11
          -2189472515*y**12+1295375851*y**13-351578789*y**14+45501929*y**15-3314707*y**16
          +244497*y**17))))/(-20901888000*logy**5*r**20*(-1+y)**10+84000*(r**8*(-1
          +y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5-8709120000*logy**4*r**16*(
          -1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -1451520000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2-120960000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3-5040000*logy*(
          -1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(
          -4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2
          +y**3))**4))
      resNP += ((api*muWC**3*(217728000*logy**5*r**22*(144+390*r**2+473*r**4
          +479*r**6+378*r**8+285*r**10+81*r**12)*(-1+y)**11+518400*logy**4*r**18*(
          -1+y)**6*(30318*r**20*(-1+y)**5+96*(-1+y)**7*(-118-236*y-354*y**2
          +543*y**3-170*y**4+20*y**5)+45*r**18*(-1521+7605*y-15210*y**2+14272*y**3
          -6919*y**4+1283*y**5+42*y**6)+28*r**2*(-1+y)**6*(1379+1379*y+1379*y**2
          -6466*y**3+5414*y**4-1330*y**5+120*y**6)+10*r**4*(-1+y)**5*(-42555
          +30240*y+15120*y**2-5257*y**3-14854*y**4+12936*y**5-2758*y**6+240*y**7)
          -42*r**16*(2704-9470*y+8815*y**2+8745*y**3-19060*y**4+12836*y**5-3895*y**6
          +405*y**7)+5*r**14*(-91601+338305*y-377360*y**2-91696*y**3+472337*y**4
          -366955*y**5+119490*y**6-14574*y**7+630*y**8)+r**6*(-1+y)**3*(-556333
          +1931666*y-1784833*y**2-122920*y**3+893935*y**4-305522*y**5-109081*y**6
          +85968*y**7-13680*y**8+960*y**9)+14*r**12*(-20528+45940*y+49870*y**2
          -256085*y**3+294350*y**4-130042*y**5-5360*y**6+27795*y**7-10800*y**8
          +1620*y**9)+7*r**10*(-26745-9975*y+379200*y**2-841390*y**3+663730*y**4
          +4516*y**5-353210*y**6+242300*y**7-66895*y**8+4725*y**9+864*y**10)
          -70*r**8*(-1616+22270*y-80015*y**2+120827*y**3-69757*y**4-22822*y**5
          +54561*y**6-28023*y**7+3069*y**8+2250*y**9-810*y**10+66*y**11))-17280*logy**3*r**14*(
          -1+y)**4*(-20922*r**28*(-1+y)**7+r**26*(-1+y)**2*(709121-3545605*y
          +7091210*y**2-6992075*y**3+3786280*y**4-1063076*y**5+127425*y**6)+24*(
          -1+y)**11*(-433-1732*y-4330*y**2-3440*y**3+1855*y**4+9868*y**5-7268*y**6
          +1280*y**7)+r**24*(-1+y)**2*(5007812-21400900*y+33706400*y**2-20443235*y**3
          -1143740*y**4+7072018*y**5-2796900*y**6+284865*y**7)+2*r**2*(-1+y)**9*(
          -40798-81596*y-122394*y**2+447193*y**3-164315*y**4+94753*y**5-340369*y**6
          +365784*y**7-155198*y**8+20040*y**9)+r**22*(-1929959+21723113*y-93916239*y**2
          +224921680*y**3-318473530*y**4+273701004*y**5-143606408*y**6+44618294*y**7
          -7571805*y**8+862245*y**9-151995*y**10)+r**4*(-1+y)**8*(2557842+1198482*y
          +518802*y**2-18695603*y**3+22606712*y**4-6498592*y**5-3809882*y**6+2796483*y**7
          -337202*y**8-171382*y**9+33840*y**10)+r**20*(-3893778+40884606*y-160146378*y**2
          +331980085*y**3-371881700*y**4+189678328*y**5+24677744*y**6-97298992*y**7
          +66002510*y**8-24419010*y**9+5254890*y**10-552705*y**11)+r**6*(-1+y)**7*(
          -1072281+4633440*y+2316720*y**2+6136805*y**3-36104790*y**4+34983942*y**5
          -7374710*y**6-6316135*y**7+3821405*y**8-500500*y**9-126276*y**10+24480*y**11)
          +r**18*(39397946-220825022*y+506022966*y**2-596953070*y**3+401255150*y**4
          -221922312*y**5+215142134*y**6-223249057*y**7+143738205*y**8-49227350*y**9
          +6396856*y**10+582843*y**11-182889*y**12)+r**8*(-1+y)**5*(-30910932
          +112887864*y-125653932*y**2-33079385*y**3+188472765*y**4-148143036*y**5
          +19677262*y**6+29725169*y**7-13791355*y**8-679940*y**9+1833358*y**10
          -416696*y**11+15858*y**12)+r**14*(-1+y)**2*(-17880754+111869570*y-219549640*y**2
          +46641710*y**3+364474590*y**4-510501252*y**5+253256030*y**6+29510665*y**7
          -91867295*y**8+39558450*y**9-5643054*y**10-293235*y**11+96615*y**12)
          -r**10*(-1+y)**4*(-3953161+78619443*y-227899383*y**2+201695126*y**3
          +78581945*y**4-270341154*y**5+178860892*y**6-16387727*y**7-34019176*y**8
          +16441035*y**9-2017225*y**10-457995*y**11+121380*y**12)-r**12*(-1+y)**3*(
          -44731162+165350248*y-161278572*y**2-82253522*y**3+222772688*y**4-76043508*y**5
          -78940798*y**6+61168367*y**7+4695237*y**8-18361748*y**9+7705210*y**10
          -1541985*y**11+149145*y**12)+r**16*(-15286352+141491504*y-497551152*y**2
          +844751290*y**3-634615980*y**4-59945746*y**5+462603302*y**6-283137711*y**7
          -27557320*y**8+124216505*y**9-73259702*y**10+21352469*y**11-3275412*y**12
          +214305*y**13))+288*logy**2*r**10*(-1+y)**2*(-1+r**2+y)**2*(-4119*r**32*(
          -1+y)**9-r**30*(-1+y)**4*(117601-579767*y+1134820*y**2-714895*y**3
          +356660*y**4-135286*y**5+28707*y**6)+48*(-1+y)**13*(-31-186*y-651*y**2
          -1521*y**3-2251*y**4-1044*y**5+4811*y**6+3251*y**7-5804*y**8+1676*y**9)
          +r**28*(-1+y)**2*(-23532207+161186453*y-471273998*y**2+763012465*y**3
          -748015638*y**4+456531677*y**5-170289958*y**6+36578263*y**7-4257735*y**8
          +310278*y**9)+r**26*(-1+y)**2*(-165187086+1068427280*y-2914135571*y**2
          +4247492985*y**3-3557856657*y**4+1675600445*y**5-329021975*y**6-66304439*y**7
          +49491525*y**8-9165703*y**9+480396*y**10)+2*r**2*(-1+y)**11*(-19931
          -81212*y-206750*y**2-37415*y**3+695745*y**4+1423002*y**5-2176146*y**6
          +757525*y**7-4960*y**8-72120*y**9+1454*y**10+14808*y**11)-r**24*(-1
          +y)**2*(587595515-3322846555*y+7512065501*y**2-7929694473*y**3+2382368483*y**4
          +3252732719*y**5-4015308165*y**6+1966034909*y**7-480787642*y**8+63564052*y**9
          -8584524*y**10+940980*y**11)+r**4*(-1+y)**9*(-5035285-8282710*y-10682019*y**2
          +49640549*y**3+21607365*y**4+7726845*y**5-231977705*y**6+291103103*y**7
          -125234678*y**8-3473215*y**9+20207740*y**10-5985260*y**11+405766*y**12
          +63504*y**13)+r**22*(111135799-1300774491*y+6361171263*y**2-19247563608*y**3
          +38322673547*y**4-51014615073*y**5+46390001497*y**6-29329849381*y**7
          +12577022196*y**8-2926154484*y**9-304475626*y**10+515445669*y**11-182761982*y**12
          +30090312*y**13-1681638*y**14)-r**14*(-1+y)**4*(-2678474605+15196488935*y
          -31069669942*y**2+21140965357*y**3+16984505800*y**4-38970872270*y**5
          +23521962805*y**6-184814606*y**7-6158317389*y**8+2322292645*y**9+167117850*y**10
          -288405815*y**11+63628298*y**12-4228518*y**13+73455*y**14)+r**6*(-1
          +y)**8*(21766589+13491459*y+10817923*y**2-311087462*y**3+473269991*y**4
          -277578953*y**5+211969267*y**6-338214911*y**7+289177324*y**8-100025702*y**9
          +612714*y**10+6503349*y**11+220288*y**12-700212*y**13+114336*y**14)
          -r**10*(-1+y)**6*(328402+276743644*y-308877861*y**2+1627495323*y**3
          -6939501683*y**4+10586010441*y**5-6214254048*y**6-506633298*y**7+2438936524*y**8
          -1090937944*y**9+77810457*y**10+63944479*y**11-13293691*y**12-115197*y**13
          +118452*y**14)+r**8*(-1+y)**7*(-417309643+441711352*y+96909553*y**2
          +2789942400*y**3-7724984962*y**4+6765275386*y**5-722960954*y**6-2589738716*y**7
          +1667341665*y**8-210644306*y**9-143146493*y**10+49922852*y**11+17388*y**12
          -2082640*y**13+251118*y**14)-r**12*(-1+y)**5*(3148064095-12807804780*y
          +17222587457*y**2+339160469*y**3-25139883846*y**4+26994608275*y**5-8623132850*y**6
          -4308763694*y**7+4234788127*y**8-853218148*y**9-263985045*y**10+121325705*y**11
          -410088*y**12-4913971*y**13+546294*y**14)+2*r**18*(-1+y)**2*(-2182068843
          +10846502057*y-20002733057*y**2+12180229110*y**3+9044587273*y**4-16718067004*y**5
          +4869785456*y**6+6265496654*y**7-6152960440*y**8+1837717854*y**9+166527697*y**10
          -243525788*y**11+66562678*y**12-10172295*y**13+891648*y**14)+r**16*(
          -1+y)**3*(1877144503-6810554542*y+6558361341*y**2+4593740456*y**3-15082836863*y**4
          +15454400394*y**5-10281149241*y**6+6060214158*y**7-4210643957*y**8+2823911006*y**9
          -1243056697*y**10+274881658*y**11-5129499*y**12-9190674*y**13+1083957*y**14)
          +r**20*(636211515-6233268773*y+26217300051*y**2-64554162872*y**3+99732703918*y**4
          -92956445614*y**5+39197248656*y**6+17129842598*y**7-38082809861*y**8
          +28950245609*y**9-13269855117*y**10+3784266642*y**11-574191324*y**12
          +19607858*y**13+2984898*y**14+321816*y**15))+12*logy*r**8*(-1+y)**2*(
          -1+r**2+y)**3*(2385*r**36*(-1+y)**9+r**34*(-1+y)**4*(4438-15035*y
          +8605*y**2-7288*y**3-2530*y**4-3589*y**5+3495*y**6)-r**32*(-1+y)**2*(
          -2491451+17248604*y-51064146*y**2+85681398*y**3-88176200*y**4+56088302*y**5
          -21974638*y**6+5199666*y**7-699965*y**8+42510*y**9)+r**30*(-91045171
          +806478891*y-3164596020*y**2+7196033430*y**3-10527368964*y**4+10455102822*y**5
          -7250043512*y**6+3537076000*y**7-1196071895*y**8+268877919*y**9-37243876*y**10
          +2828186*y**11-123810*y**12)+6*(-1+y)**12*(-479-2874*y-10059*y**2
          -21754*y**3-22220*y**4+2478*y**5-24612*y**6+45538*y**7+91223*y**8-100380*y**9
          -15849*y**10+50736*y**11-24404*y**12+4656*y**13)+r**28*(-1297093657
          +10804504842*y-39498501285*y**2+82881916850*y**3-109708797067*y**4+94495028487*y**5
          -52025855470*y**6+16441778256*y**7-1587747491*y**8-745672988*y**9+267874315*y**10
          -28431082*y**11+623759*y**12+74931*y**13)+r**2*(-1+y)**11*(-149851-669209*y
          -1803201*y**2-3241737*y**3+1105042*y**4+14973482*y**5+24084858*y**6
          -17621938*y**7-46988811*y**8+49404171*y**9-13003081*y**10-2352149*y**11
          +1841764*y**12-296652*y**13+9312*y**14)+r**26*(-3320893729+24981006333*y
          -80351001114*y**2+137547871200*y**3-124709737570*y**4+35464740297*y**5
          +47062492187*y**6-65228593382*y**7+41051574885*y**8-15933772587*y**9
          +4085707162*y**10-741101370*y**11+105447566*y**12-10831195*y**13+585717*y**14)
          +r**24*(-10894629155+74902721634*y-212084291757*y**2+296903853586*y**3
          -144590861919*y**4-184053250740*y**5+389954689171*y**6-328658786732*y**7
          +149995275007*y**8-30871281718*y**9-3546044511*y**10+3822227970*y**11
          -1044982061*y**12+165401432*y**13-14157463*y**14+341256*y**15)+r**22*(12487598309
          -97518919725*y+329262130092*y**2-670269823606*y**3+889144509747*y**4
          -745114329063*y**5+324531334798*y**6+39153372784*y**7-173715808205*y**8
          +149739353149*y**9-81060692808*y**10+28788685602*y**11-6188098851*y**12
          +696852311*y**13-39034546*y**14+7690212*y**15-916200*y**16)-r**4*(-1
          +y)**9*(4542736+12084339*y+21841824*y**2-67970558*y**3-112231740*y**4
          -53018331*y**5+722874116*y**6-833237908*y**7+213841856*y**8+259840085*y**9
          -229885776*y**10+60477546*y**11+3216684*y**12-5256173*y**13+1391980*y**14
          -209304*y**15+18624*y**16)+3*r**18*(-1+y)**2*(-43950324567+219623486423*y
          -422183591507*y**2+342543770843*y**3+5493835476*y**4-224230426807*y**5
          +164303042813*y**6-47415575361*y**7+19282659724*y**8-27772234307*y**9
          +19749007755*y**10-6541370595*y**11+1039413068*y**12-48735517*y**13-17574869*y**14
          +3560969*y**15+40459*y**16)-r**8*(-1+y)**7*(161114983-195484457*y-128872697*y**2
          -6427999167*y**3+20066946361*y**4-18126859127*y**5-2457298207*y**6+12395901039*y**7
          -4222140891*y**8-3107194327*y**9+2768809985*y**10-817666465*y**11+107793783*y**12
          -9884617*y**13+2815991*y**14-296591*y**15+58404*y**16)+r**10*(-1+y)**6*(12810803317
          -19904117355*y+422398845*y**2-69674645025*y**3+239301546688*y**4-249137114817*y**5
          +35854208361*y**6+123719667731*y**7-96765483784*y**8+19435568935*y**9
          +6987541139*y**10-3161729191*y**11-184287376*y**12+247327909*y**13-33627673*y**14
          -273739*y**15+64035*y**16)-r**6*(-1+y)**8*(-305935391-382261441*y-390406776*y**2
          +3121060894*y**3-258201181*y**4-256107267*y**5-10672992758*y**6+16517899884*y**7
          -8217510861*y**8-525821231*y**9+1955581564*y**10-619197954*y**11+8414317*y**12
          +23629267*y**13-977838*y**14-603656*y**15+70428*y**16)+r**12*(-1+y)**5*(17188599611
          -35732655503*y+12839871054*y**2+529725916*y**3+20252464970*y**4+1275377991*y**5
          -68338822370*y**6+86580119406*y**7-41206078128*y**8+1430506159*y**9+6012472634*y**10
          -1618649712*y**11-332260810*y**12+220370137*y**13-34964454*y**14-536986*y**15
          +212085*y**16)+r**14*(-1+y)**4*(74778589231-333685997963*y+514989425902*y**2
          -46359761312*y**3-862154272285*y**4+1145020889327*y**5-542642251472*y**6
          -72419864334*y**7+171651198339*y**8-44406894445*y**9-10466692282*y**10
          +4676072348*y**11+790198757*y**12-488671127*y**13+49961980*y**14-4188526*y**15
          +593862*y**16)+r**16*(-1+y)**3*(-43241153723+218083294017*y-430416458433*y**2
          +417798877717*y**3-230658283203*y**4+164792768859*y**5-192455352299*y**6
          +135931978407*y**7-44744278503*y**8-1544975833*y**9+13525407777*y**10
          -10888004397*y**11+4659026651*y**12-1024045539*y**13+88489611*y**14-4999663*y**15
          +940554*y**16)+r**20*(20850856853-179712888828*y+666014600475*y**2-1412007391970*y**3
          +1775170124842*y**4-1074274961997*y**5-335602832247*y**6+1286041276000*y**7
          -1232356178110*y**8+659199218021*y**9-191248568755*y**10+4903307238*y**11
          +19439442250*y**12-7746647395*y**13+1514930287*y**14-208263876*y**15
          +25170837*y**16-1193625*y**17))-r**8*(-1+r**2+y)**4*(2067*r**36*(-1+y)**11
          +2*r**34*(-1+y)**6*(125444-608776*y+1169375*y**2-1118060*y**3+542104*y**4
          -118508*y**5+7725*y**6)+r**32*(-1+y)**4*(-5982045+40854395*y-118630973*y**2
          +192958045*y**3-191689167*y**4+118855079*y**5-45926587*y**6+10625875*y**7
          -1254924*y**8+36222*y**9)-2*r**30*(-1+y)**2*(-20776472+190482824*y
          -772556330*y**2+1813221794*y**3-2751171915*y**4+2869975006*y**5-2121739986*y**6
          +1111936426*y**7-402331444*y**8+95136330*y**9-13273404*y**10+837092*y**11
          +9519*y**12)-2*r**28*(-681920348+7041453266*y-32763050009*y**2+90380144265*y**3
          -164268176595*y**4+207188128556*y**5-186147240428*y**6+120201584995*y**7
          -55376712068*y**8+17693105724*y**9-3693903355*y**10+461020977*y**11-41624261*y**12
          +9047038*y**13-1918984*y**14+128427*y**15)+3*(-1+y)**13*(-65405-380934*y
          -1298781*y**2-2633070*y**3-2949463*y**4-434656*y**5+838405*y**6+5689788*y**7
          +4056141*y**8-8092558*y**9-833907*y**10+4804738*y**11-2540657*y**12
          +490004*y**13-11029*y**14+1168*y**15+216*y**16)-2*r**26*(-3861325232
          +36960026440*y-157376751358*y**2+390510445482*y**3-618769062035*y**4
          +636757670658*y**5-394488509186*y**6+82788088218*y**7+90375385761*y**8
          -101855341072*y**9+52324234826*y**10-16154229734*y**11+3197238795*y**12
          -464598538*y**13+62440662*y**14-6219022*y**15+236535*y**16)+2*r**2*(
          -1+y)**11*(1507964+4757564*y+9432359*y**2+9604249*y**3-53905684*y**4
          -122594302*y**5+13619701*y**6+285924397*y**7+161329464*y**8-686984380*y**9
          +499514349*y**10-112672337*y**11-22264944*y**12+12684462*y**13-611561*y**14
          -222261*y**15+37072*y**16+3888*y**17)-2*r**8*(-1+y)**8*(-4224143788
          -1066477398*y+872207111*y**2+11126784149*y**3+45160254356*y**4-87332047649*y**5
          -49138390375*y**6+186918968437*y**7-126919211646*y**8+7954862275*y**9
          +24746128749*y**10-9034860629*y**11+64365100*y**12+400590097*y**13-38866381*y**14
          -4195637*y**15-1241398*y**16+18627*y**17)+r**4*(-1+y)**10*(-61393503
          -139182805*y-219966730*y**2+1237717458*y**3+515911584*y**4-685523110*y**5
          -8314891558*y**6+14258608790*y**7-4389878262*y**8-7139651264*y**9+7070978178*y**10
          -2195502170*y**11-45902576*y**12+165098654*y**13-27834770*y**14+1517810*y**15
          +96933*y**16+37341*y**17)+2*r**6*(-1+y)**9*(1464920120+1194516048*y
          +754973114*y**2-13925170620*y**3+6280146273*y**4+1032211787*y**5+38223106908*y**6
          -67011672722*y**7+38340491103*y**8-2084158843*y**9-5776198306*y**10+1446357868*y**11
          +298386235*y**12-120712783*y**13-2336180*y**14+4511074*y**15+38701*y**16
          +38223*y**17)+6*r**18*(-1+y)**3*(-5688777288+29453191312*y-60131707324*y**2
          +111887846934*y**3-266747706249*y**4+467968825821*y**5-482123798830*y**6
          +266699282602*y**7-39805523581*y**8-57687485385*y**9+58491539524*y**10
          -30438694394*y**11+10120510865*y**12-2318519553*y**13+360826934*y**14
          -27484982*y**15-1007763*y**16+49357*y**17)-2*r**24*(-1965996608+11631350130*y
          -14750416223*y**2-87349632429*y**3+444913916736*y**4-995712164255*y**5
          +1347136909815*y**6-1196071387309*y**7+714899954466*y**8-286127018579*y**9
          +73261128787*y**10-9941054587*y**11-346255960*y**12+598724263*y**13-222100507*y**14
          +48487301*y**15-4164058*y**16+55017*y**17)-2*r**10*(-1+y)**7*(-53655411728
          +90603728664*y-14216217446*y**2+226511127504*y**3-788077545569*y**4
          +830741959193*y**5-199589808972*y**6-250752971612*y**7+200467786707*y**8
          -38221508317*y**9-8300562942*y**10+1196571392*y**11+2088527037*y**12
          -821148961*y**13+105580336*y**14-3708948*y**15-4333759*y**16+305421*y**17)
          +2*r**20*(-1+y)**2*(-76459574539+555574094789*y-1716597672307*y**2+3082512391279*y**3
          -3414711621718*y**4+2031223095293*y**5+66761920171*y**6-1261123992035*y**7
          +1173814463772*y**8-588687107029*y**9+169674834591*y**10-17339857619*y**11
          -5286835494*y**12+1847759499*y**13-176118503*y**14+15243255*y**15-7643141*y**16
          +659736*y**17)-2*r**16*(-1+y)**4*(-324900788359+1503293922787*y-2581126151622*y**2
          +1383088010810*y**3+1594329362989*y**4-3115980525732*y**5+2147348315840*y**6
          -691567553774*y**7+128293008969*y**8-75340910714*y**9+17929303850*y**10
          +31060534638*y**11-23938590437*y**12+7411090196*y**13-1157003700*y**14
          +71811766*y**15-1139290*y**16+717783*y**17)-2*r**12*(-1+y)**6*(-150594725608
          +377744241522*y-228887342059*y**2+238362972935*y**3-1098324676314*y**4
          +1536391866865*y**5-550651245077*y**6-517925408843*y**7+533380181046*y**8
          -124878748091*y**9-30575711325*y**10+12391723489*y**11+3636814114*y**12
          -2134741581*y**13+316575005*y**14-19970557*y**15-5855734*y**16+810213*y**17)
          -2*r**14*(-1+y)**5*(-402984850488+1629870622880*y-2342594446314*y**2
          +830160455092*y**3+1402981379395*y**4-1729095834615*y**5+647859218396*y**6
          -19414080822*y**7+35662214397*y**8-95315778429*y**9+49230889390*y**10
          -5635895256*y**11-2893708123*y**12+1188759911*y**13-166073616*y**14-5638262*y**15
          -3846045*y**16+1108509*y**17)+2*r**22*(31283721816-276622538920*y+1071827807538*y**2
          -2381937226142*y**3+3269255411193*y**4-2620706335726*y**5+660474769005*y**6
          +1033797854106*y**7-1339033870451*y**8+667119064294*y**9-30528464491*y**10
          -161504744570*y**11+104570525379*y**12-33532095842*y**13+6129539663*y**14
          -629079074*y**15+40163935*y**16-4931598*y**17+429885*y**18))))/(-70543872000*logy**5*r**27*(
          -1+y)**11+283500*r**7*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)
          -2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(
          -1-y-y**2+y**3))**5-29393280000*logy**4*r**23*(-1+y)**9*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-4898880000*logy**3*r**19*(
          -1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          -408240000*logy**2*r**15*(-1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**3-17010000*logy*r**7*(-1+y)**3*(-(r**9*(
          -1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(
          -4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((rhoD*(
          -217728000*logy**5*r**22*(144+390*r**2+473*r**4+479*r**6+378*r**8+285*r**10
          +81*r**12)*(-1+y)**11-518400*logy**4*r**18*(-1+y)**6*(30318*r**20*(-1+y)**5
          +96*(-1+y)**7*(-118-236*y-354*y**2+543*y**3-170*y**4+20*y**5)+45*r**18*(
          -1521+7605*y-15210*y**2+14272*y**3-6919*y**4+1283*y**5+42*y**6)+28*r**2*(
          -1+y)**6*(1379+1379*y+1379*y**2-6466*y**3+5414*y**4-1330*y**5+120*y**6)
          +10*r**4*(-1+y)**5*(-42555+30240*y+15120*y**2-5257*y**3-14854*y**4
          +12936*y**5-2758*y**6+240*y**7)-42*r**16*(2704-9470*y+8815*y**2+8745*y**3
          -19060*y**4+12836*y**5-3895*y**6+405*y**7)+5*r**14*(-91601+338305*y
          -377360*y**2-91696*y**3+472337*y**4-366955*y**5+119490*y**6-14574*y**7
          +630*y**8)+r**6*(-1+y)**3*(-556333+1931666*y-1784833*y**2-122920*y**3
          +893935*y**4-305522*y**5-109081*y**6+85968*y**7-13680*y**8+960*y**9)
          +14*r**12*(-20528+45940*y+49870*y**2-256085*y**3+294350*y**4-130042*y**5
          -5360*y**6+27795*y**7-10800*y**8+1620*y**9)+7*r**10*(-26745-9975*y
          +379200*y**2-841390*y**3+663730*y**4+4516*y**5-353210*y**6+242300*y**7
          -66895*y**8+4725*y**9+864*y**10)-70*r**8*(-1616+22270*y-80015*y**2
          +120827*y**3-69757*y**4-22822*y**5+54561*y**6-28023*y**7+3069*y**8
          +2250*y**9-810*y**10+66*y**11))+17280*logy**3*r**14*(-1+y)**4*(-20922*r**28*(
          -1+y)**7+r**26*(-1+y)**2*(709121-3545605*y+7091210*y**2-6992075*y**3
          +3786280*y**4-1063076*y**5+127425*y**6)+24*(-1+y)**11*(-433-1732*y
          -4330*y**2-3440*y**3+1855*y**4+9868*y**5-7268*y**6+1280*y**7)+r**24*(
          -1+y)**2*(5007812-21400900*y+33706400*y**2-20443235*y**3-1143740*y**4
          +7072018*y**5-2796900*y**6+284865*y**7)+2*r**2*(-1+y)**9*(-40798-81596*y
          -122394*y**2+447193*y**3-164315*y**4+94753*y**5-340369*y**6+365784*y**7
          -155198*y**8+20040*y**9)+r**22*(-1929959+21723113*y-93916239*y**2+224921680*y**3
          -318473530*y**4+273701004*y**5-143606408*y**6+44618294*y**7-7571805*y**8
          +862245*y**9-151995*y**10)+r**4*(-1+y)**8*(2557842+1198482*y+518802*y**2
          -18695603*y**3+22606712*y**4-6498592*y**5-3809882*y**6+2796483*y**7
          -337202*y**8-171382*y**9+33840*y**10)+r**20*(-3893778+40884606*y-160146378*y**2
          +331980085*y**3-371881700*y**4+189678328*y**5+24677744*y**6-97298992*y**7
          +66002510*y**8-24419010*y**9+5254890*y**10-552705*y**11)+r**6*(-1+y)**7*(
          -1072281+4633440*y+2316720*y**2+6136805*y**3-36104790*y**4+34983942*y**5
          -7374710*y**6-6316135*y**7+3821405*y**8-500500*y**9-126276*y**10+24480*y**11)
          +r**18*(39397946-220825022*y+506022966*y**2-596953070*y**3+401255150*y**4
          -221922312*y**5+215142134*y**6-223249057*y**7+143738205*y**8-49227350*y**9
          +6396856*y**10+582843*y**11-182889*y**12)+r**8*(-1+y)**5*(-30910932
          +112887864*y-125653932*y**2-33079385*y**3+188472765*y**4-148143036*y**5
          +19677262*y**6+29725169*y**7-13791355*y**8-679940*y**9+1833358*y**10
          -416696*y**11+15858*y**12)+r**14*(-1+y)**2*(-17880754+111869570*y-219549640*y**2
          +46641710*y**3+364474590*y**4-510501252*y**5+253256030*y**6+29510665*y**7
          -91867295*y**8+39558450*y**9-5643054*y**10-293235*y**11+96615*y**12)
          -r**10*(-1+y)**4*(-3953161+78619443*y-227899383*y**2+201695126*y**3
          +78581945*y**4-270341154*y**5+178860892*y**6-16387727*y**7-34019176*y**8
          +16441035*y**9-2017225*y**10-457995*y**11+121380*y**12)-r**12*(-1+y)**3*(
          -44731162+165350248*y-161278572*y**2-82253522*y**3+222772688*y**4-76043508*y**5
          -78940798*y**6+61168367*y**7+4695237*y**8-18361748*y**9+7705210*y**10
          -1541985*y**11+149145*y**12)+r**16*(-15286352+141491504*y-497551152*y**2
          +844751290*y**3-634615980*y**4-59945746*y**5+462603302*y**6-283137711*y**7
          -27557320*y**8+124216505*y**9-73259702*y**10+21352469*y**11-3275412*y**12
          +214305*y**13))-288*logy**2*r**10*(-1+y)**2*(-1+r**2+y)**2*(-4119*r**32*(
          -1+y)**9-r**30*(-1+y)**4*(117601-579767*y+1134820*y**2-714895*y**3
          +356660*y**4-135286*y**5+28707*y**6)+48*(-1+y)**13*(-31-186*y-651*y**2
          -1521*y**3-2251*y**4-1044*y**5+4811*y**6+3251*y**7-5804*y**8+1676*y**9)
          +r**28*(-1+y)**2*(-23532207+161186453*y-471273998*y**2+763012465*y**3
          -748015638*y**4+456531677*y**5-170289958*y**6+36578263*y**7-4257735*y**8
          +310278*y**9)+r**26*(-1+y)**2*(-165187086+1068427280*y-2914135571*y**2
          +4247492985*y**3-3557856657*y**4+1675600445*y**5-329021975*y**6-66304439*y**7
          +49491525*y**8-9165703*y**9+480396*y**10)+2*r**2*(-1+y)**11*(-19931
          -81212*y-206750*y**2-37415*y**3+695745*y**4+1423002*y**5-2176146*y**6
          +757525*y**7-4960*y**8-72120*y**9+1454*y**10+14808*y**11)-r**24*(-1
          +y)**2*(587595515-3322846555*y+7512065501*y**2-7929694473*y**3+2382368483*y**4
          +3252732719*y**5-4015308165*y**6+1966034909*y**7-480787642*y**8+63564052*y**9
          -8584524*y**10+940980*y**11)+r**4*(-1+y)**9*(-5035285-8282710*y-10682019*y**2
          +49640549*y**3+21607365*y**4+7726845*y**5-231977705*y**6+291103103*y**7
          -125234678*y**8-3473215*y**9+20207740*y**10-5985260*y**11+405766*y**12
          +63504*y**13)+r**22*(111135799-1300774491*y+6361171263*y**2-19247563608*y**3
          +38322673547*y**4-51014615073*y**5+46390001497*y**6-29329849381*y**7
          +12577022196*y**8-2926154484*y**9-304475626*y**10+515445669*y**11-182761982*y**12
          +30090312*y**13-1681638*y**14)-r**14*(-1+y)**4*(-2678474605+15196488935*y
          -31069669942*y**2+21140965357*y**3+16984505800*y**4-38970872270*y**5
          +23521962805*y**6-184814606*y**7-6158317389*y**8+2322292645*y**9+167117850*y**10
          -288405815*y**11+63628298*y**12-4228518*y**13+73455*y**14)+r**6*(-1
          +y)**8*(21766589+13491459*y+10817923*y**2-311087462*y**3+473269991*y**4
          -277578953*y**5+211969267*y**6-338214911*y**7+289177324*y**8-100025702*y**9
          +612714*y**10+6503349*y**11+220288*y**12-700212*y**13+114336*y**14)
          -r**10*(-1+y)**6*(328402+276743644*y-308877861*y**2+1627495323*y**3
          -6939501683*y**4+10586010441*y**5-6214254048*y**6-506633298*y**7+2438936524*y**8
          -1090937944*y**9+77810457*y**10+63944479*y**11-13293691*y**12-115197*y**13
          +118452*y**14)+r**8*(-1+y)**7*(-417309643+441711352*y+96909553*y**2
          +2789942400*y**3-7724984962*y**4+6765275386*y**5-722960954*y**6-2589738716*y**7
          +1667341665*y**8-210644306*y**9-143146493*y**10+49922852*y**11+17388*y**12
          -2082640*y**13+251118*y**14)-r**12*(-1+y)**5*(3148064095-12807804780*y
          +17222587457*y**2+339160469*y**3-25139883846*y**4+26994608275*y**5-8623132850*y**6
          -4308763694*y**7+4234788127*y**8-853218148*y**9-263985045*y**10+121325705*y**11
          -410088*y**12-4913971*y**13+546294*y**14)+2*r**18*(-1+y)**2*(-2182068843
          +10846502057*y-20002733057*y**2+12180229110*y**3+9044587273*y**4-16718067004*y**5
          +4869785456*y**6+6265496654*y**7-6152960440*y**8+1837717854*y**9+166527697*y**10
          -243525788*y**11+66562678*y**12-10172295*y**13+891648*y**14)+r**16*(
          -1+y)**3*(1877144503-6810554542*y+6558361341*y**2+4593740456*y**3-15082836863*y**4
          +15454400394*y**5-10281149241*y**6+6060214158*y**7-4210643957*y**8+2823911006*y**9
          -1243056697*y**10+274881658*y**11-5129499*y**12-9190674*y**13+1083957*y**14)
          +r**20*(636211515-6233268773*y+26217300051*y**2-64554162872*y**3+99732703918*y**4
          -92956445614*y**5+39197248656*y**6+17129842598*y**7-38082809861*y**8
          +28950245609*y**9-13269855117*y**10+3784266642*y**11-574191324*y**12
          +19607858*y**13+2984898*y**14+321816*y**15))-12*logy*r**8*(-1+y)**2*(
          -1+r**2+y)**3*(2385*r**36*(-1+y)**9+r**34*(-1+y)**4*(4438-15035*y
          +8605*y**2-7288*y**3-2530*y**4-3589*y**5+3495*y**6)-r**32*(-1+y)**2*(
          -2491451+17248604*y-51064146*y**2+85681398*y**3-88176200*y**4+56088302*y**5
          -21974638*y**6+5199666*y**7-699965*y**8+42510*y**9)+r**30*(-91045171
          +806478891*y-3164596020*y**2+7196033430*y**3-10527368964*y**4+10455102822*y**5
          -7250043512*y**6+3537076000*y**7-1196071895*y**8+268877919*y**9-37243876*y**10
          +2828186*y**11-123810*y**12)+6*(-1+y)**12*(-479-2874*y-10059*y**2
          -21754*y**3-22220*y**4+2478*y**5-24612*y**6+45538*y**7+91223*y**8-100380*y**9
          -15849*y**10+50736*y**11-24404*y**12+4656*y**13)+r**28*(-1297093657
          +10804504842*y-39498501285*y**2+82881916850*y**3-109708797067*y**4+94495028487*y**5
          -52025855470*y**6+16441778256*y**7-1587747491*y**8-745672988*y**9+267874315*y**10
          -28431082*y**11+623759*y**12+74931*y**13)+r**2*(-1+y)**11*(-149851-669209*y
          -1803201*y**2-3241737*y**3+1105042*y**4+14973482*y**5+24084858*y**6
          -17621938*y**7-46988811*y**8+49404171*y**9-13003081*y**10-2352149*y**11
          +1841764*y**12-296652*y**13+9312*y**14)+r**26*(-3320893729+24981006333*y
          -80351001114*y**2+137547871200*y**3-124709737570*y**4+35464740297*y**5
          +47062492187*y**6-65228593382*y**7+41051574885*y**8-15933772587*y**9
          +4085707162*y**10-741101370*y**11+105447566*y**12-10831195*y**13+585717*y**14)
          +r**24*(-10894629155+74902721634*y-212084291757*y**2+296903853586*y**3
          -144590861919*y**4-184053250740*y**5+389954689171*y**6-328658786732*y**7
          +149995275007*y**8-30871281718*y**9-3546044511*y**10+3822227970*y**11
          -1044982061*y**12+165401432*y**13-14157463*y**14+341256*y**15)+r**22*(12487598309
          -97518919725*y+329262130092*y**2-670269823606*y**3+889144509747*y**4
          -745114329063*y**5+324531334798*y**6+39153372784*y**7-173715808205*y**8
          +149739353149*y**9-81060692808*y**10+28788685602*y**11-6188098851*y**12
          +696852311*y**13-39034546*y**14+7690212*y**15-916200*y**16)-r**4*(-1
          +y)**9*(4542736+12084339*y+21841824*y**2-67970558*y**3-112231740*y**4
          -53018331*y**5+722874116*y**6-833237908*y**7+213841856*y**8+259840085*y**9
          -229885776*y**10+60477546*y**11+3216684*y**12-5256173*y**13+1391980*y**14
          -209304*y**15+18624*y**16)+3*r**18*(-1+y)**2*(-43950324567+219623486423*y
          -422183591507*y**2+342543770843*y**3+5493835476*y**4-224230426807*y**5
          +164303042813*y**6-47415575361*y**7+19282659724*y**8-27772234307*y**9
          +19749007755*y**10-6541370595*y**11+1039413068*y**12-48735517*y**13-17574869*y**14
          +3560969*y**15+40459*y**16)-r**8*(-1+y)**7*(161114983-195484457*y-128872697*y**2
          -6427999167*y**3+20066946361*y**4-18126859127*y**5-2457298207*y**6+12395901039*y**7
          -4222140891*y**8-3107194327*y**9+2768809985*y**10-817666465*y**11+107793783*y**12
          -9884617*y**13+2815991*y**14-296591*y**15+58404*y**16)+r**10*(-1+y)**6*(12810803317
          -19904117355*y+422398845*y**2-69674645025*y**3+239301546688*y**4-249137114817*y**5
          +35854208361*y**6+123719667731*y**7-96765483784*y**8+19435568935*y**9
          +6987541139*y**10-3161729191*y**11-184287376*y**12+247327909*y**13-33627673*y**14
          -273739*y**15+64035*y**16)-r**6*(-1+y)**8*(-305935391-382261441*y-390406776*y**2
          +3121060894*y**3-258201181*y**4-256107267*y**5-10672992758*y**6+16517899884*y**7
          -8217510861*y**8-525821231*y**9+1955581564*y**10-619197954*y**11+8414317*y**12
          +23629267*y**13-977838*y**14-603656*y**15+70428*y**16)+r**12*(-1+y)**5*(17188599611
          -35732655503*y+12839871054*y**2+529725916*y**3+20252464970*y**4+1275377991*y**5
          -68338822370*y**6+86580119406*y**7-41206078128*y**8+1430506159*y**9+6012472634*y**10
          -1618649712*y**11-332260810*y**12+220370137*y**13-34964454*y**14-536986*y**15
          +212085*y**16)+r**14*(-1+y)**4*(74778589231-333685997963*y+514989425902*y**2
          -46359761312*y**3-862154272285*y**4+1145020889327*y**5-542642251472*y**6
          -72419864334*y**7+171651198339*y**8-44406894445*y**9-10466692282*y**10
          +4676072348*y**11+790198757*y**12-488671127*y**13+49961980*y**14-4188526*y**15
          +593862*y**16)+r**16*(-1+y)**3*(-43241153723+218083294017*y-430416458433*y**2
          +417798877717*y**3-230658283203*y**4+164792768859*y**5-192455352299*y**6
          +135931978407*y**7-44744278503*y**8-1544975833*y**9+13525407777*y**10
          -10888004397*y**11+4659026651*y**12-1024045539*y**13+88489611*y**14-4999663*y**15
          +940554*y**16)+r**20*(20850856853-179712888828*y+666014600475*y**2-1412007391970*y**3
          +1775170124842*y**4-1074274961997*y**5-335602832247*y**6+1286041276000*y**7
          -1232356178110*y**8+659199218021*y**9-191248568755*y**10+4903307238*y**11
          +19439442250*y**12-7746647395*y**13+1514930287*y**14-208263876*y**15
          +25170837*y**16-1193625*y**17))+r**8*(-1+r**2+y)**4*(2067*r**36*(-1+y)**11
          +2*r**34*(-1+y)**6*(125444-608776*y+1169375*y**2-1118060*y**3+542104*y**4
          -118508*y**5+7725*y**6)+r**32*(-1+y)**4*(-5982045+40854395*y-118630973*y**2
          +192958045*y**3-191689167*y**4+118855079*y**5-45926587*y**6+10625875*y**7
          -1254924*y**8+36222*y**9)-2*r**30*(-1+y)**2*(-20776472+190482824*y
          -772556330*y**2+1813221794*y**3-2751171915*y**4+2869975006*y**5-2121739986*y**6
          +1111936426*y**7-402331444*y**8+95136330*y**9-13273404*y**10+837092*y**11
          +9519*y**12)-2*r**28*(-681920348+7041453266*y-32763050009*y**2+90380144265*y**3
          -164268176595*y**4+207188128556*y**5-186147240428*y**6+120201584995*y**7
          -55376712068*y**8+17693105724*y**9-3693903355*y**10+461020977*y**11-41624261*y**12
          +9047038*y**13-1918984*y**14+128427*y**15)+3*(-1+y)**13*(-65405-380934*y
          -1298781*y**2-2633070*y**3-2949463*y**4-434656*y**5+838405*y**6+5689788*y**7
          +4056141*y**8-8092558*y**9-833907*y**10+4804738*y**11-2540657*y**12
          +490004*y**13-11029*y**14+1168*y**15+216*y**16)-2*r**26*(-3861325232
          +36960026440*y-157376751358*y**2+390510445482*y**3-618769062035*y**4
          +636757670658*y**5-394488509186*y**6+82788088218*y**7+90375385761*y**8
          -101855341072*y**9+52324234826*y**10-16154229734*y**11+3197238795*y**12
          -464598538*y**13+62440662*y**14-6219022*y**15+236535*y**16)+2*r**2*(
          -1+y)**11*(1507964+4757564*y+9432359*y**2+9604249*y**3-53905684*y**4
          -122594302*y**5+13619701*y**6+285924397*y**7+161329464*y**8-686984380*y**9
          +499514349*y**10-112672337*y**11-22264944*y**12+12684462*y**13-611561*y**14
          -222261*y**15+37072*y**16+3888*y**17)-2*r**8*(-1+y)**8*(-4224143788
          -1066477398*y+872207111*y**2+11126784149*y**3+45160254356*y**4-87332047649*y**5
          -49138390375*y**6+186918968437*y**7-126919211646*y**8+7954862275*y**9
          +24746128749*y**10-9034860629*y**11+64365100*y**12+400590097*y**13-38866381*y**14
          -4195637*y**15-1241398*y**16+18627*y**17)+r**4*(-1+y)**10*(-61393503
          -139182805*y-219966730*y**2+1237717458*y**3+515911584*y**4-685523110*y**5
          -8314891558*y**6+14258608790*y**7-4389878262*y**8-7139651264*y**9+7070978178*y**10
          -2195502170*y**11-45902576*y**12+165098654*y**13-27834770*y**14+1517810*y**15
          +96933*y**16+37341*y**17)+2*r**6*(-1+y)**9*(1464920120+1194516048*y
          +754973114*y**2-13925170620*y**3+6280146273*y**4+1032211787*y**5+38223106908*y**6
          -67011672722*y**7+38340491103*y**8-2084158843*y**9-5776198306*y**10+1446357868*y**11
          +298386235*y**12-120712783*y**13-2336180*y**14+4511074*y**15+38701*y**16
          +38223*y**17)+6*r**18*(-1+y)**3*(-5688777288+29453191312*y-60131707324*y**2
          +111887846934*y**3-266747706249*y**4+467968825821*y**5-482123798830*y**6
          +266699282602*y**7-39805523581*y**8-57687485385*y**9+58491539524*y**10
          -30438694394*y**11+10120510865*y**12-2318519553*y**13+360826934*y**14
          -27484982*y**15-1007763*y**16+49357*y**17)-2*r**24*(-1965996608+11631350130*y
          -14750416223*y**2-87349632429*y**3+444913916736*y**4-995712164255*y**5
          +1347136909815*y**6-1196071387309*y**7+714899954466*y**8-286127018579*y**9
          +73261128787*y**10-9941054587*y**11-346255960*y**12+598724263*y**13-222100507*y**14
          +48487301*y**15-4164058*y**16+55017*y**17)-2*r**10*(-1+y)**7*(-53655411728
          +90603728664*y-14216217446*y**2+226511127504*y**3-788077545569*y**4
          +830741959193*y**5-199589808972*y**6-250752971612*y**7+200467786707*y**8
          -38221508317*y**9-8300562942*y**10+1196571392*y**11+2088527037*y**12
          -821148961*y**13+105580336*y**14-3708948*y**15-4333759*y**16+305421*y**17)
          +2*r**20*(-1+y)**2*(-76459574539+555574094789*y-1716597672307*y**2+3082512391279*y**3
          -3414711621718*y**4+2031223095293*y**5+66761920171*y**6-1261123992035*y**7
          +1173814463772*y**8-588687107029*y**9+169674834591*y**10-17339857619*y**11
          -5286835494*y**12+1847759499*y**13-176118503*y**14+15243255*y**15-7643141*y**16
          +659736*y**17)-2*r**16*(-1+y)**4*(-324900788359+1503293922787*y-2581126151622*y**2
          +1383088010810*y**3+1594329362989*y**4-3115980525732*y**5+2147348315840*y**6
          -691567553774*y**7+128293008969*y**8-75340910714*y**9+17929303850*y**10
          +31060534638*y**11-23938590437*y**12+7411090196*y**13-1157003700*y**14
          +71811766*y**15-1139290*y**16+717783*y**17)-2*r**12*(-1+y)**6*(-150594725608
          +377744241522*y-228887342059*y**2+238362972935*y**3-1098324676314*y**4
          +1536391866865*y**5-550651245077*y**6-517925408843*y**7+533380181046*y**8
          -124878748091*y**9-30575711325*y**10+12391723489*y**11+3636814114*y**12
          -2134741581*y**13+316575005*y**14-19970557*y**15-5855734*y**16+810213*y**17)
          -2*r**14*(-1+y)**5*(-402984850488+1629870622880*y-2342594446314*y**2
          +830160455092*y**3+1402981379395*y**4-1729095834615*y**5+647859218396*y**6
          -19414080822*y**7+35662214397*y**8-95315778429*y**9+49230889390*y**10
          -5635895256*y**11-2893708123*y**12+1188759911*y**13-166073616*y**14-5638262*y**15
          -3846045*y**16+1108509*y**17)+2*r**22*(31283721816-276622538920*y+1071827807538*y**2
          -2381937226142*y**3+3269255411193*y**4-2620706335726*y**5+660474769005*y**6
          +1033797854106*y**7-1339033870451*y**8+667119064294*y**9-30528464491*y**10
          -161504744570*y**11+104570525379*y**12-33532095842*y**13+6129539663*y**14
          -629079074*y**15+40163935*y**16-4931598*y**17+429885*y**18))))/(-62705664000*logy**5*r**27*(
          -1+y)**11+252000*r**7*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)
          -2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(
          -1-y-y**2+y**3))**5-26127360000*logy**4*r**23*(-1+y)**9*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-4354560000*logy**3*r**19*(
          -1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          -362880000*logy**2*r**15*(-1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**3-15120000*logy*r**7*(-1+y)**3*(-(r**9*(
          -1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(
          -4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(
          -217728000*logy**5*r**19*(-3+5*r**2+18*r**4+25*r**6+21*r**8)*(-1+y)**10
          -518400*logy**4*r**15*(-1+y)**8*(3750*r**16*(-1+y)**2+r**14*(6971-13942*y
          +6971*y**2+210*y**3)-14*r**12*(-2912+2674*y+1813*y**2-2210*y**3+315*y**4)
          +175*r**10*(-7+314*y-457*y**2+212*y**3-56*y**4+26*y**5)-50*(-1+y)**3*(57
          +57*y+57*y**2-244*y**3+190*y**4-62*y**5+8*y**6)+70*r**8*(-340+1220*y
          -1150*y**2+175*y**3+317*y**4-238*y**5+72*y**6)+35*r**6*(-737+1774*y
          -1187*y**2-50*y**3+583*y**4-476*y**5+147*y**6)-r**2*(-1+y)**2*(943
          +14560*y**3-18725*y**4+9912*y**5-2520*y**6+240*y**7)+14*r**4*(-184
          -82*y+491*y**2-210*y**3+440*y**4-801*y**5+412*y**6-76*y**7+10*y**8))
          -17280*logy**3*r**11*(-1+y)**6*(-1+r**2+y)**2*(5850*r**20*(-1+y)**4-r**18*(
          -1+y)**2*(-72583+156866*y-95983*y**2+20465*y**3)-r**16*(-1+y)**2*(
          -741876+1190618*y-398158*y**2-62129*y**3+2965*y**4)+r**14*(1013744
          -3959074*y+5919965*y**2-3711320*y**3+171300*y**4+896226*y**5-384461*y**6
          +56070*y**7)+35*(-1+y)**5*(246+738*y+1476*y**2-253*y**3-1162*y**4
          -2295*y**5+3626*y**6-1634*y**7+248*y**8)-2*r**12*(-1693211+4649297*y
          -4137246*y**2+451020*y**3+1421455*y**4-928399*y**5+309408*y**6-90279*y**7
          +10255*y**8)+r**6*(-1+y)**2*(51064-456902*y-234653*y**2+3729116*y**3
          -4954405*y**4+2425366*y**5-298943*y**6-113792*y**7+23489*y**8+3960*y**9)
          -2*r**4*(-1+y)**3*(-231852-111019*y-88601*y**2+1109682*y**3-1155315*y**4
          +545202*y**5-227381*y**6+127776*y**7-46257*y**8+6015*y**9)-5*r**10*(
          -533790+1433974*y-1083583*y**2-624082*y**3+1646249*y**4-1052972*y**5
          +105213*y**6+170339*y**7-70343*y**8+6545*y**9)+r**2*(-1+y)**4*(-41557
          -100334*y-176331*y**2+197747*y**3+13145*y**4+245127*y**5-481611*y**6
          +303096*y**7-80672*y**8+7640*y**9)+r**8*(889382-2213818*y+808892*y**2
          +4744922*y**3-9789178*y**4+8058358*y**5-2013732*y**6-1347567*y**7+1172603*y**8
          -353997*y**9+44135*y**10))-288*logy**2*r**7*(-1+y)**4*(-1+r**2+y)**3*(669*r**26*(
          -1+y)**6-r**24*(-1+y)**4*(-118314+238635*y-122328*y**2+25912*y**3)
          +r**22*(-1+y)**2*(3167785-11975089*y+16753020*y**2-10415430*y**3+2633185*y**4
          -163425*y**5+26454*y**6)+r**20*(-1+y)**2*(15589697-58101152*y+81125520*y**2
          -51480280*y**3+12295665*y**4+1624808*y**5-1143358*y**6+120650*y**7)
          -5*r**18*(-1+y)**2*(-18466988+55662707*y-55831650*y**2+13544638*y**3
          +10603714*y**4-6287825*y**5+1049118*y**6-236132*y**7+31298*y**8)-(
          -1+y)**8*(6063+30315*y+90945*y**2+143090*y**3+80475*y**4-173951*y**5
          -202665*y**6-19220*y**7+334410*y**8-202250*y**9+35288*y**10)+r**16*(46245657
          -280978617*y+721782105*y**2-919197130*y**3+436678695*y**4+278084151*y**5
          -480834901*y**6+240888970*y**7-37438720*y**8-8517570*y**9+3532192*y**10
          -237832*y**11)+r**4*(-1+y)**6*(-3345211-8987232*y-16688940*y**2+10693540*y**3
          +12777260*y**4+23309612*y**5-50514186*y**6+28623440*y**7-5548365*y**8
          -154310*y**9+101674*y**10+6218*y**11)-5*r**8*(-1+y)**4*(11502308-1898611*y
          -1819120*y**2-50284312*y**3+78291632*y**4-44334412*y**5+9881548*y**6
          +226730*y**7-1220008*y**8+798633*y**9-221456*y**10+11568*y**11)-r**2*(
          -1+y)**7*(-161070-662469*y-1701645*y**2-1099015*y**3+358515*y**4+3185615*y**5
          -1525767*y**6+586395*y**7-1596885*y**8+1288110*y**9-392720*y**10+40936*y**11)
          +2*r**12*(-1+y)**2*(69275405-133172846*y+1040115*y**2+265979180*y**3
          -323162495*y**4+80477520*y**5+113588437*y**6-89772815*y**7+17157020*y**8
          +3425245*y**9-1409850*y**10+136334*y**11)+r**6*(-1+y)**5*(4985051+11477074*y
          +20380875*y**2-44879090*y**3+7535340*y**4-51188752*y**5+115984152*y**6
          -82748400*y**7+20834365*y**8+1283010*y**9-1375099*y**10+175474*y**11)
          -r**10*(-1+y)**3*(49005141-114721545*y-2397465*y**2+445650725*y**3
          -660713610*y**4+298317888*y**5+85588070*y**6-122963360*y**7+31831025*y**8
          +3928485*y**9-2839229*y**10+261875*y**11)+2*r**14*(109977961-426210609*y
          +598273968*y**2-264236790*y**3-199371795*y**4+288817653*y**5-122776787*y**6
          +8618729*y**7+13624740*y**8-11120080*y**9+5710061*y**10-1474379*y**11
          +167328*y**12))-12*logy*r**3*(-1+y)**4*(-1+r**2+y)**4*(69*r**32*(-1+y)**6
          +r**30*(-1+y)**4*(-5181+10086*y-4629*y**2+910*y**3)+2*r**28*(-1+y)**2*(217572
          -844008*y+1208685*y**2-796093*y**3+250841*y**4-33535*y**5+3158*y**6)
          +r**26*(14514773-83097582*y+196451973*y**2-248020986*y**3+180551617*y**4
          -76011548*y**5+17132107*y**6-1463878*y**7-70654*y**8+178*y**9)+r**24*(146352860
          -780131516*y+1692810174*y**2-1890025322*y**3+1102554407*y**4-264630208*y**5
          -27308279*y**6+22744626*y**7-2863463*y**8+443668*y**9-40947*y**10)+3*(
          -1+y)**11*(-23-207*y-1035*y**2-3209*y**3-5249*y**4-1129*y**5+4927*y**6
          +5925*y**7-1756*y**8-3996*y**9+1552*y**10)+r**22*(323369043-1679334598*y
          +3602060705*y**2-4025291722*y**3+2260869658*y**4-208832576*y**5-525519870*y**6
          +324158270*y**7-77665293*y**8+6100662*y**9+527413*y**10-27292*y**11)
          +2*r**20*(1070224308-4721605544*y+7887558711*y**2-5283712565*y**3-631020121*y**4
          +3063105392*y**5-1688443900*y**6+282976679*y**7+30043735*y**8-11606384*y**9
          +2686245*y**10-481386*y**11+43830*y**12)-r**6*(-1+y)**6*(12879047+48451484*y
          +116459156*y**2+25032582*y**3-50846705*y**4-206117534*y**5+190894492*y**6
          -82901202*y**7+95345261*y**8-79385670*y**9+27739112*y**10-3332276*y**11
          -67979*y**12+232*y**13)+r**2*(-1+y)**8*(-14649-87618*y-305697*y**2
          -681498*y**3-741218*y**4+168370*y**5+1141658*y**6+854386*y**7-1291837*y**8
          +299568*y**9-186321*y**10+208360*y**11-71264*y**12+7760*y**13)+2*r**4*(
          -1+y)**7*(612420+2945748*y+8560599*y**2+10999556*y**3+3835642*y**4
          -17059173*y**5-8250144*y**6+439669*y**7+20416300*y**8-14771417*y**9
          +3249753*y**10+52171*y**11-85418*y**12+9294*y**13)+r**8*(-1+y)**5*(136852196
          +298437944*y+473415734*y**2-776373268*y**3-415559709*y**4-642407881*y**5
          +2321167888*y**6-1642070332*y**7+296905542*y**8+120680834*y**9-59792190*y**10
          +8109968*y**11-207477*y**12+22751*y**13)-r**14*(-1+y)**2*(-2484294705
          +6091052608*y-1651177246*y**2-12337836914*y**3+16585630377*y**4-3636030298*y**5
          -6435083324*y**6+4144917944*y**7+65151105*y**8-708026952*y**9+194307578*y**10
          -10814734*y**11-1977673*y**12+40234*y**13)+r**18*(-950862723+2762654018*y
          -15453047*y**2-6245243566*y**3+3408697062*y**4+6985428478*y**5-9409889794*y**6
          +3434791906*y**7+628322649*y**8-768620412*y**9+181062145*y**10-7446524*y**11
          -882884*y**12+60692*y**13)+2*r**12*(-1+y)**3*(827108244-611921812*y
          -359771423*y**2-2570705756*y**3+6146942587*y**4-3924736436*y**5-488771374*y**6
          +1636171258*y**7-678495906*y**8+70611438*y**9+12083317*y**10-416714*y**11
          -576685*y**12+96262*y**13)+r**10*(-1+y)**4*(78378471-39250750*y-256842083*y**2
          +417379774*y**3-253724376*y**4+1697948302*y**5-3239842886*y**6+2138906180*y**7
          -347185449*y**8-165329074*y**9+57483977*y**10+872086*y**11-1674422*y**12
          +170250*y**13)+r**16*(3555781374-9915875416*y+5266988984*y**2+9321952402*y**3
          -9851297549*y**4-5690391848*y**5+13651916377*y**6-7907840578*y**7+1413193406*y**8
          +205825878*y**9-31100576*y**10-20382336*y**11-807231*y**12+2152042*y**13
          -114929*y**14))-r*(-1+y)**2*(-1+r**2+y)**5*(55*r**34*(-1+y)**8+r**32*(
          -1+y)**6*(-1169+2891*y-1861*y**2+515*y**3)+r**30*(-1+y)**4*(-71688
          +230978*y-241019*y**2+81710*y**3+5480*y**4-9660*y**5+1739*y**6)+r**28*(
          -1+y)**2*(13989368-78411814*y+179753715*y**2-217874419*y**3+151044829*y**4
          -60283689*y**5+12996773*y**6-1364661*y**7+89763*y**8+1175*y**9)+r**26*(147065776
          -1066771378*y+3337324439*y**2-5883029418*y**3+6391698101*y**4-4372256826*y**5
          +1811257308*y**6-377185494*y**7-5007352*y**8+20570364*y**9-3835275*y**10
          +217680*y**11-8725*y**12)+(-1+y)**12*(11+99*y+495*y**2+2417*y**3
          +4974*y**4+2078*y**5-2482*y**6-4358*y**7+2199*y**8+1991*y**9-2349*y**10
          +373*y**11+128*y**12+24*y**13)-r**24*(-914987072+6189236306*y-17808643741*y**2
          +27926204153*y**3-24813074145*y**4+10531144441*y**5+1064266542*y**6-3550943102*y**7
          +1707773462*y**8-369468700*y**9+44192911*y**10-5943643*y**11+328523*y**12
          +26065*y**13)+r**2*(-1+y)**10*(1475+9552*y+35530*y**2-32010*y**3-385125*y**4
          -953460*y**5+340516*y**6+1311040*y**7+511145*y**8-802420*y**9-970190*y**10
          +1006282*y**11-249495*y**12+8440*y**13+720*y**14)+r**4*(-1+y)**9*(760128
          +4378378*y+14777413*y**2+27866194*y**3+23237302*y**4-20033664*y**5
          -32522809*y**6-17969404*y**7+43973404*y**8-17544502*y**9+4056011*y**10
          -2462694*y**11+1053566*y**12-176548*y**13+7225*y**14)-r**22*(-268400208
          +1711048238*y-5373777709*y**2+10796926442*y**3-13841834620*y**4+9274618956*y**5
          +471788059*y**6-6237063452*y**7+4942948616*y**8-1645542530*y**9+105268177*y**10
          +84572178*y**11-21436364*y**12+790792*y**13+9425*y**14)+r**6*(-1+y)**8*(
          -20887424-93357290*y-255121929*y**2-242414574*y**3-8186684*y**4+520893844*y**5
          +45438071*y**6-69001676*y**7-480696536*y**8+436760934*y**9-116014195*y**10
          -2660006*y**11+5432580*y**12-784240*y**13+39125*y**14)+r**8*(-1+y)**7*(80508472
          +260842614*y+569840915*y**2-450974846*y**3-445144694*y**4-1045230298*y**5
          +2128136423*y**6-1423625124*y**7+572765588*y**8-194339206*y**9+66130001*y**10
          -18628062*y**11+4923434*y**12-1180342*y**13+135125*y**14)+r**10*(-1
          +y)**6*(-997350440-1691176054*y-2161565359*y**2+6458255650*y**3+1869540616*y**4
          +2512289854*y**5-16959642473*y**6+13895644552*y**7-2294697416*y**8-1630468478*y**9
          +768549711*y**10-105849498*y**11+6637832*y**12-1702234*y**13+321737*y**14)
          +r**18*(-1+y)**2*(-21464732546+80084335418*y-94166632275*y**2+11006026918*y**3
          +49762915502*y**4-16290011486*y**5-20044465389*y**6+9592091992*y**7+5410988386*y**8
          -4937597702*y**9+1210156907*y**10-49186654*y**11-10484542*y**12+485546*y**13
          +353925*y**14)+r**12*(-1+y)**5*(-2962785336-1299152086*y+822920757*y**2
          +10415132474*y**3-3496526810*y**4-12294826868*y**5+9029674107*y**6+2033454036*y**7
          -3873416148*y**8+966167730*y**9+277409179*y**10-174440046*y**11+36926182*y**12
          -4405576*y**13+548405*y**14)+r**16*(-1+y)**3*(-36057039998+78996220630*y
          -25665244733*y**2-53907218698*y**3+16916999192*y**4+57885030698*y**5
          -49074055893*y**6+3290362788*y**7+11342421858*y**8-5353479742*y**9+1037638625*y**10
          -122180362*y**11+26619220*y**12-3790610*y**13+597025*y**14)+r**14*(-1
          +y)**4*(-15844558024+14193547926*y+7326717511*y**2+38252996058*y**3
          -97714128676*y**4+53843946232*y**5+20577360027*y**6-28618156188*y**7
          +6467116728*y**8+1429901446*y**9-381702483*y**10-155945278*y**11+61356852*y**12
          -6717236*y**13+677105*y**14)+r**20*(12414648592-74537652958*y+182652788711*y**2
          -219150562991*y**3+94072277508*y**4+76732714698*y**5-124636788589*y**6
          +62473124073*y**7-5095455208*y**8-7606391946*y**9+3016296133*y**10-313264053*y**11
          -27675884*y**12+5452574*y**13+376513*y**14+112827*y**15)))*math.log(mu0**2/r**2))/(
          -3483648000*logy**5*r**20*(-1+y)**10+14000*(r**8*(-1+y)**2-6*r**4*y*(2
          -3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)
          -(-1+y)**3*(-1-y-y**2+y**3))**5-1451520000*logy**4*r**16*(-1+y)**8*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-241920000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          -20160000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**3-840000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2
          -3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)
          +r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(54432000*logy**4*r**15*(46
          +83*r**2+80*r**4+45*r**6+12*r**8)*(-1+y)**10+259200*logy**3*r**11*(-1
          +y)**8*(1312*r**14*(-1+y)**2+472*r**16*(-1+y)**2-7*r**12*(-2429+3418*y
          -269*y**2-915*y**3+180*y**4)+7*r**10*(5216-5032*y-2884*y**2+2905*y**3
          -285*y**4+60*y**5)+35*r**8*(681+558*y-2199*y**2+682*y**3+382*y**4
          -191*y**5+52*y**6)+(-1+y)**3*(87+87*y+87*y**2-6283*y**3+5092*y**4
          -1040*y**5+80*y**6)+7*r**6*(-2936+15832*y-17876*y**2+1180*y**3+5670*y**4
          -2799*y**5+623*y**6+36*y**7)+r**2*(-1+y)**2*(-9208+10605*y**3-13965*y**4
          +8148*y**5-1330*y**6+80*y**7)-7*r**4*(7041-19602*y+15321*y**2+195*y**3
          -4015*y**4+719*y**5+777*y**6-476*y**7+40*y**8))+4320*logy**2*r**7*(-1
          +y)**6*(-1+r**2+y)**2*(866*r**20*(-1+y)**4-r**18*(-1+y)**2*(-7971+17674*y
          -11435*y**2+2772*y**3)-r**16*(-1+y)**2*(-170979+274672*y-81485*y**2
          -21775*y**3+3722*y**4)+r**14*(-1+y)**2*(378732-711016*y+348065*y**2
          +39601*y**3-47388*y**4+10416*y**5)+r**12*(2867580-8799676*y+8910451*y**2
          -2043295*y**3-1903700*y**4+1043875*y**5-41719*y**6-40026*y**7+5110*y**8)
          -(-1+y)**4*(177+354*y+531*y**2-9712*y**3+5415*y**4-1802*y**5-33379*y**6
          +48344*y**7-20888*y**8+2560*y**9)-r**10*(-7035366+21252160*y-20428801*y**2
          +2528581*y**3+7278746*y**4-4340659*y**5+592290*y**6+273526*y**7-134981*y**8
          +15204*y**9)+r**8*(7375734-22440244*y+22051981*y**2-4522609*y**3-4385409*y**4
          +1517943*y**5+968569*y**6-674081*y**7+95859*y**8+21959*y**9-1302*y**10)
          +r**4*(-1+y)**2*(274698-22864*y-15565*y**2-2227211*y**3+4252003*y**4
          -2935604*y**5+673869*y**6+104695*y**7-63509*y**8+8152*y**9+1736*y**10)
          -r**2*(-1+y)**3*(-3425-3779*y-4133*y**2-244042*y**3+251339*y**4-61155*y**5
          +142909*y**6-187762*y**7+102322*y**8-28434*y**9+2560*y**10)+r**6*(2001276
          -5149120*y+3949567*y**2-3385243*y**3+10069747*y**4-14621355*y**5+10004337*y**6
          -2962467*y**7-223457*y**8+413953*y**9-110046*y**10+12808*y**11))+72*logy*r**3*(
          -1+y)**4*(-1+r**2+y)**3*(124*r**26*(-1+y)**6-4*r**24*(-1+y)**4*(-2024
          +4141*y-2210*y**2+473*y**3)-r**22*(-1+y)**2*(-279741+1039704*y-1414110*y**2
          +821525*y**3-158995*y**4-10219*y**5+836*y**6)+r**20*(-1+y)**2*(1216919
          -4671119*y+6783810*y**2-4611640*y**3+1315345*y**4+66951*y**5-103246*y**6
          +11680*y**7)+5*r**18*(-1+y)**2*(3952987-12399292*y+12901560*y**2-3536353*y**3
          -1971707*y**4+1145121*y**5-79870*y**6-14022*y**7+456*y**8)-r**16*(-1
          +y)**2*(-16243217+61756553*y-90149592*y**2+52232158*y**3+2938233*y**4
          -15611383*y**5+5658772*y**6-216308*y**7-306908*y**8+31992*y**9)-2*r**14*(
          -99397639+447087702*y-760883973*y**2+525679005*y**3+35335160*y**4-260518422*y**5
          +116802196*y**6+13873056*y**7-22950255*y**8+5024990*y**9+58611*y**10
          -117823*y**11+3892*y**12)+(-1+y)**6*(89+267*y+534*y**2-6200*y**3
          +620*y**4-1938*y**5-39474*y**6+42512*y**7-13925*y**8-14745*y**9+41724*y**10
          -30168*y**11+6704*y**12)-r**6*(-1+y)**3*(3291509-291267*y-428253*y**2
          -50003974*y**3+110194635*y**4-89557158*y**5+42837394*y**6-37227984*y**7
          +35101883*y**8-17433835*y**9+4115699*y**10-219202*y**11-101963*y**12
          +2516*y**13)-10*r**8*(-1+y)**2*(-3378079+5716129*y-1713420*y**2+18827756*y**3
          -64928536*y**4+83530232*y**5-48091744*y**6+5561134*y**7+8279937*y**8
          -4716339*y**9+975972*y**10-12410*y**11-32314*y**12+2682*y**13)+r**2*(
          -1+y)**5*(-2391-5049*y-7974*y**2-318101*y**3+195315*y**4-48283*y**5
          -522397*y**6+1220773*y**7-684678*y**8+225860*y**9-268901*y**10+171496*y**11
          -46374*y**12+6704*y**13)+r**4*(-1+y)**4*(-243649-214969*y-196375*y**2
          -1583377*y**3+1295300*y**4+1045358*y**5+9828958*y**6-23915370*y**7+21064319*y**8
          -8489725*y**9+897241*y**10+416211*y**11-130930*y**12+17008*y**13)+2*r**12*(196237109
          -904195479*y+1589045601*y**2-1157042431*y**3-66406220*y**4+702358182*y**5
          -470010022*y**6+91351038*y**7+42602047*y**8-30238155*y**9+6282709*y**10
          +208501*y**11-221264*y**12+21384*y**13)+2*r**10*(69385171-289251138*y
          +449968683*y**2-348654421*y**3+309773170*y**4-531778662*y**5+614392506*y**6
          -358809186*y**7+70005447*y**8+33530690*y**9-22644759*y**10+3930507*y**11
          +245128*y**12-99526*y**13+6390*y**14))-3*r*(-1+y)**3*(-1+r**2+y)**4*(29*r**28*(
          -1+y)**7+2*r**26*(-1+y)**5*(-9679+17812*y-7331*y**2+803*y**3)+r**24*(
          -1+y)**3*(-416467+1545904*y-2105392*y**2+1321998*y**3-395457*y**4
          +34010*y**5+4964*y**6)+2*r**22*(3729334-23521398*y+62275708*y**2-88696836*y**3
          +71352580*y**4-29491797*y**5+2675613*y**6+2411082*y**7-787624*y**8+53085*y**9
          +253*y**10)+r**20*(9712151-63445793*y+180316883*y**2-291967077*y**3
          +291693498*y**4-175201964*y**5+48861214*y**6+7787392*y**7-10333673*y**8
          +2819277*y**9-232537*y**10-9371*y**11)+2*r**18*(170110489-970748873*y
          +2251511909*y**2-2607457140*y**3+1328041785*y**4+179521477*y**5-578525259*y**6
          +262463037*y**7-25598860*y**8-12427060*y**9+3343934*y**10-238593*y**11
          +3154*y**12)+r**16*(-332810921+1798678843*y-3699927499*y**2+3185081187*y**3
          +6873470*y**4-2151467458*y**5+1564284754*y**6-312374462*y**7-99702549*y**8
          +34289955*y**9+12628729*y**10-5920197*y**11+337536*y**12+28612*y**13)
          -4*r**14*(-763803634+3953792250*y-8007121780*y**2+7155626336*y**3-727122542*y**4
          -3991872507*y**5+3100911685*y**6-434505120*y**7-504310742*y**8+243271074*y**9
          -13497184*y**10-14529260*y**11+3372450*y**12-172669*y**13+3643*y**14)
          -(-1+y)**7*(-1219-4876*y-12190*y**2-53726*y**3-57599*y**4-60452*y**5
          -100308*y**6+64600*y**7+28027*y**8+27928*y**9+40246*y**10-31866*y**11
          -6585*y**12-3976*y**13+3996*y**14)-2*r**2*(-1+y)**6*(-28999-83491*y
          -160504*y**2-509763*y**3-291798*y**4-141107*y**5+856942*y**6-335092*y**7
          +514091*y**8+656701*y**9-1729794*y**10+1115399*y**11-309054*y**12+15897*y**13
          +10572*y**14)-2*r**6*(-1+y)**4*(-1747494-2692674*y-2217888*y**2+52654704*y**3
          -70516058*y**4+25629523*y**5-96509077*y**6+252384516*y**7-254549278*y**8
          +116511436*y**9-13147154*y**10-9611124*y**11+3714622*y**12-348301*y**13
          +24247*y**14)-r**4*(-1+y)**5*(-1031203-1894810*y-2581795*y**2+3056192*y**3
          -7588199*y**4+5658616*y**5+39989175*y**6-72121960*y**7+47385311*y**8
          -15138362*y**9+4687187*y**10-2631640*y**11+745355*y**12-89028*y**13
          +43161*y**14)-2*r**10*(-1+y)**2*(-207985809+481541039*y-286500000*y**2
          +903503009*y**3-3590310564*y**4+5467058788*y**5-3683170003*y**6+499750230*y**7
          +846157067*y**8-533705057*y**9+100893146*y**10+6724089*y**11-3308230*y**12
          +60174*y**13+48121*y**14)-r**8*(-1+y)**3*(81688601-63125904*y-18246624*y**2
          -824402394*y**3+2199417281*y**4-2172958442*y**5+946134068*y**6-139090092*y**7
          -20820877*y**8+21920348*y**9-4309184*y**10-10996314*y**11+6408691*y**12
          -838754*y**13+59596*y**14)+r**12*(1245892009-5951388223*y+10981863373*y**2
          -8856690651*y**3+612412525*y**4+5215282129*y**5-5578071319*y**6+3153249589*y**7
          -512278213*y**8-784685165*y**9+649390375*y**10-190326833*y**11+12655663*y**12
          +2907739*y**13-123485*y**14-89513*y**15)))*nlo.X1El(0,'SM',y/2,r))/(-3483648000*logy**5*r**20*(
          -1+y)**10+14000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-1451520000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-241920000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-20160000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -840000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*(-18144000*logy**4*r**15*(46+83*r**2+80*r**4
          +45*r**6+12*r**8)*(-1+y)**10-86400*logy**3*r**11*(-1+y)**8*(1312*r**14*(
          -1+y)**2+472*r**16*(-1+y)**2-7*r**12*(-2429+3418*y-269*y**2-915*y**3
          +180*y**4)+7*r**10*(5216-5032*y-2884*y**2+2905*y**3-285*y**4+60*y**5)
          +35*r**8*(681+558*y-2199*y**2+682*y**3+382*y**4-191*y**5+52*y**6)
          +(-1+y)**3*(87+87*y+87*y**2-6283*y**3+5092*y**4-1040*y**5+80*y**6)
          +7*r**6*(-2936+15832*y-17876*y**2+1180*y**3+5670*y**4-2799*y**5+623*y**6
          +36*y**7)+r**2*(-1+y)**2*(-9208+10605*y**3-13965*y**4+8148*y**5-1330*y**6
          +80*y**7)-7*r**4*(7041-19602*y+15321*y**2+195*y**3-4015*y**4+719*y**5
          +777*y**6-476*y**7+40*y**8))-1440*logy**2*r**7*(-1+y)**6*(-1+r**2+y)**2*(866*r**20*(
          -1+y)**4-r**18*(-1+y)**2*(-7971+17674*y-11435*y**2+2772*y**3)-r**16*(
          -1+y)**2*(-170979+274672*y-81485*y**2-21775*y**3+3722*y**4)+r**14*(
          -1+y)**2*(378732-711016*y+348065*y**2+39601*y**3-47388*y**4+10416*y**5)
          +r**12*(2867580-8799676*y+8910451*y**2-2043295*y**3-1903700*y**4+1043875*y**5
          -41719*y**6-40026*y**7+5110*y**8)-(-1+y)**4*(177+354*y+531*y**2
          -9712*y**3+5415*y**4-1802*y**5-33379*y**6+48344*y**7-20888*y**8+2560*y**9)
          -r**10*(-7035366+21252160*y-20428801*y**2+2528581*y**3+7278746*y**4
          -4340659*y**5+592290*y**6+273526*y**7-134981*y**8+15204*y**9)+r**8*(7375734
          -22440244*y+22051981*y**2-4522609*y**3-4385409*y**4+1517943*y**5+968569*y**6
          -674081*y**7+95859*y**8+21959*y**9-1302*y**10)+r**4*(-1+y)**2*(274698
          -22864*y-15565*y**2-2227211*y**3+4252003*y**4-2935604*y**5+673869*y**6
          +104695*y**7-63509*y**8+8152*y**9+1736*y**10)-r**2*(-1+y)**3*(-3425
          -3779*y-4133*y**2-244042*y**3+251339*y**4-61155*y**5+142909*y**6-187762*y**7
          +102322*y**8-28434*y**9+2560*y**10)+r**6*(2001276-5149120*y+3949567*y**2
          -3385243*y**3+10069747*y**4-14621355*y**5+10004337*y**6-2962467*y**7
          -223457*y**8+413953*y**9-110046*y**10+12808*y**11))-24*logy*r**3*(-1
          +y)**4*(-1+r**2+y)**3*(124*r**26*(-1+y)**6-4*r**24*(-1+y)**4*(-2024
          +4141*y-2210*y**2+473*y**3)-r**22*(-1+y)**2*(-279741+1039704*y-1414110*y**2
          +821525*y**3-158995*y**4-10219*y**5+836*y**6)+r**20*(-1+y)**2*(1216919
          -4671119*y+6783810*y**2-4611640*y**3+1315345*y**4+66951*y**5-103246*y**6
          +11680*y**7)+5*r**18*(-1+y)**2*(3952987-12399292*y+12901560*y**2-3536353*y**3
          -1971707*y**4+1145121*y**5-79870*y**6-14022*y**7+456*y**8)-r**16*(-1
          +y)**2*(-16243217+61756553*y-90149592*y**2+52232158*y**3+2938233*y**4
          -15611383*y**5+5658772*y**6-216308*y**7-306908*y**8+31992*y**9)-2*r**14*(
          -99397639+447087702*y-760883973*y**2+525679005*y**3+35335160*y**4-260518422*y**5
          +116802196*y**6+13873056*y**7-22950255*y**8+5024990*y**9+58611*y**10
          -117823*y**11+3892*y**12)+(-1+y)**6*(89+267*y+534*y**2-6200*y**3
          +620*y**4-1938*y**5-39474*y**6+42512*y**7-13925*y**8-14745*y**9+41724*y**10
          -30168*y**11+6704*y**12)-r**6*(-1+y)**3*(3291509-291267*y-428253*y**2
          -50003974*y**3+110194635*y**4-89557158*y**5+42837394*y**6-37227984*y**7
          +35101883*y**8-17433835*y**9+4115699*y**10-219202*y**11-101963*y**12
          +2516*y**13)-10*r**8*(-1+y)**2*(-3378079+5716129*y-1713420*y**2+18827756*y**3
          -64928536*y**4+83530232*y**5-48091744*y**6+5561134*y**7+8279937*y**8
          -4716339*y**9+975972*y**10-12410*y**11-32314*y**12+2682*y**13)+r**2*(
          -1+y)**5*(-2391-5049*y-7974*y**2-318101*y**3+195315*y**4-48283*y**5
          -522397*y**6+1220773*y**7-684678*y**8+225860*y**9-268901*y**10+171496*y**11
          -46374*y**12+6704*y**13)+r**4*(-1+y)**4*(-243649-214969*y-196375*y**2
          -1583377*y**3+1295300*y**4+1045358*y**5+9828958*y**6-23915370*y**7+21064319*y**8
          -8489725*y**9+897241*y**10+416211*y**11-130930*y**12+17008*y**13)+2*r**12*(196237109
          -904195479*y+1589045601*y**2-1157042431*y**3-66406220*y**4+702358182*y**5
          -470010022*y**6+91351038*y**7+42602047*y**8-30238155*y**9+6282709*y**10
          +208501*y**11-221264*y**12+21384*y**13)+2*r**10*(69385171-289251138*y
          +449968683*y**2-348654421*y**3+309773170*y**4-531778662*y**5+614392506*y**6
          -358809186*y**7+70005447*y**8+33530690*y**9-22644759*y**10+3930507*y**11
          +245128*y**12-99526*y**13+6390*y**14))+r*(-1+y)**3*(-1+r**2+y)**4*(29*r**28*(
          -1+y)**7+2*r**26*(-1+y)**5*(-9679+17812*y-7331*y**2+803*y**3)+r**24*(
          -1+y)**3*(-416467+1545904*y-2105392*y**2+1321998*y**3-395457*y**4
          +34010*y**5+4964*y**6)+2*r**22*(3729334-23521398*y+62275708*y**2-88696836*y**3
          +71352580*y**4-29491797*y**5+2675613*y**6+2411082*y**7-787624*y**8+53085*y**9
          +253*y**10)+r**20*(9712151-63445793*y+180316883*y**2-291967077*y**3
          +291693498*y**4-175201964*y**5+48861214*y**6+7787392*y**7-10333673*y**8
          +2819277*y**9-232537*y**10-9371*y**11)+2*r**18*(170110489-970748873*y
          +2251511909*y**2-2607457140*y**3+1328041785*y**4+179521477*y**5-578525259*y**6
          +262463037*y**7-25598860*y**8-12427060*y**9+3343934*y**10-238593*y**11
          +3154*y**12)+r**16*(-332810921+1798678843*y-3699927499*y**2+3185081187*y**3
          +6873470*y**4-2151467458*y**5+1564284754*y**6-312374462*y**7-99702549*y**8
          +34289955*y**9+12628729*y**10-5920197*y**11+337536*y**12+28612*y**13)
          -4*r**14*(-763803634+3953792250*y-8007121780*y**2+7155626336*y**3-727122542*y**4
          -3991872507*y**5+3100911685*y**6-434505120*y**7-504310742*y**8+243271074*y**9
          -13497184*y**10-14529260*y**11+3372450*y**12-172669*y**13+3643*y**14)
          -(-1+y)**7*(-1219-4876*y-12190*y**2-53726*y**3-57599*y**4-60452*y**5
          -100308*y**6+64600*y**7+28027*y**8+27928*y**9+40246*y**10-31866*y**11
          -6585*y**12-3976*y**13+3996*y**14)-2*r**2*(-1+y)**6*(-28999-83491*y
          -160504*y**2-509763*y**3-291798*y**4-141107*y**5+856942*y**6-335092*y**7
          +514091*y**8+656701*y**9-1729794*y**10+1115399*y**11-309054*y**12+15897*y**13
          +10572*y**14)-2*r**6*(-1+y)**4*(-1747494-2692674*y-2217888*y**2+52654704*y**3
          -70516058*y**4+25629523*y**5-96509077*y**6+252384516*y**7-254549278*y**8
          +116511436*y**9-13147154*y**10-9611124*y**11+3714622*y**12-348301*y**13
          +24247*y**14)-r**4*(-1+y)**5*(-1031203-1894810*y-2581795*y**2+3056192*y**3
          -7588199*y**4+5658616*y**5+39989175*y**6-72121960*y**7+47385311*y**8
          -15138362*y**9+4687187*y**10-2631640*y**11+745355*y**12-89028*y**13
          +43161*y**14)-2*r**10*(-1+y)**2*(-207985809+481541039*y-286500000*y**2
          +903503009*y**3-3590310564*y**4+5467058788*y**5-3683170003*y**6+499750230*y**7
          +846157067*y**8-533705057*y**9+100893146*y**10+6724089*y**11-3308230*y**12
          +60174*y**13+48121*y**14)-r**8*(-1+y)**3*(81688601-63125904*y-18246624*y**2
          -824402394*y**3+2199417281*y**4-2172958442*y**5+946134068*y**6-139090092*y**7
          -20820877*y**8+21920348*y**9-4309184*y**10-10996314*y**11+6408691*y**12
          -838754*y**13+59596*y**14)+r**12*(1245892009-5951388223*y+10981863373*y**2
          -8856690651*y**3+612412525*y**4+5215282129*y**5-5578071319*y**6+3153249589*y**7
          -512278213*y**8-784685165*y**9+649390375*y**10-190326833*y**11+12655663*y**12
          +2907739*y**13-123485*y**14-89513*y**15)))*nlo.X1El(0,'VL',y/2,r))/(-3483648000*logy**5*r**20*(
          -1+y)**10+14000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-1451520000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-241920000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-20160000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -840000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*(-1512000*logy**3*r**12*(19+19*r**2+11*r**4
          +3*r**6)*(-1+y)**8-3600*logy**2*r**8*(-1+y)**6*(175*r**12*(-1+y)**2+255*r**14*(
          -1+y)**2-7*r**10*(-897+1254*y-87*y**2-340*y**3+90*y**4)+35*r**8*(405
          -414*y-189*y**2+204*y**3-38*y**4+8*y**5)-35*r**2*(-1+y)**2*(213-5*y**4
          -32*y**5+4*y**6)+35*r**6*(275+134*y-751*y**2+196*y**3+143*y**4-82*y**5
          +25*y**6)+35*r**4*(-669+2022*y-1695*y**2+52*y**3+495*y**4-282*y**5
          +77*y**6)+(-1+y)**3*(-361-361*y-361*y**2-4001*y**3+3804*y**4-900*y**5
          +80*y**6))-60*logy*r**4*(-1+y)**4*(-1+r**2+y)**2*(355*r**18*(-1+y)**4
          -r**16*(-1+y)**2*(-1153+3016*y-2573*y**2+1470*y**3)-r**14*(-1+y)**2*(
          -64706+101828*y-25903*y**2-10734*y**3+1755*y**4)+r**12*(-1+y)**2*(8214
          -66656*y+94159*y**2-16866*y**3-12551*y**4+5180*y**5)+r**10*(692212
          -2030424*y+1848647*y**2-169180*y**3-586485*y**4+241888*y**5+27709*y**6
          -25452*y**7+2485*y**8)+r**2*(-1+y)**3*(19399+17793*y+16187*y**2+142341*y**3
          -189095*y**4+52111*y**5-17483*y**6+7323*y**7+1544*y**8+280*y**9)-5*r**8*(
          -436732+1374912*y-1414175*y**2+301728*y**3+420651*y**4-337498*y**5
          +90783*y**6+5140*y**7-8743*y**8+1414*y**9)-(-1+y)**4*(-803-1606*y
          -2409*y**2-13492*y**3+4295*y**4-1662*y**5-7059*y**6+18944*y**7-10248*y**8
          +1440*y**9)+r**4*(-1+y)**2*(115834+6128*y-13123*y**2-627214*y**3+1390935*y**4
          -1107204*y**5+299327*y**6+34778*y**7-29781*y**8+5920*y**9)+r**6*(883662
          -2380808*y+1934387*y**2-460068*y**3+323372*y**4-509292*y**5+263858*y**6
          -41212*y**7-26282*y**8+12628*y**9-245*y**10))+(-1+y)**2*(-1+r**2
          +y)**3*(23*r**24*(-1+y)**6+r**22*(-1+y)**4*(-1636+3203*y-1498*y**2
          +611*y**3)-r**20*(-1+y)**2*(53282-196667*y+264360*y**2-147190*y**3
          +20590*y**4+6593*y**5+32*y**6)-5*r**18*(-1+y)**2*(-10084+25495*y-2964*y**2
          -59086*y**3+67984*y**4-18137*y**5-3136*y**6+768*y**7)-5*r**16*(-1+y)**2*(981683
          -3134849*y+3304164*y**2-878638*y**3-577695*y**4+335767*y**5-23846*y**6
          -7224*y**7+78*y**8)+2*r**14*(-1+y)**2*(5042852-15034913*y+12846762*y**2
          +344847*y**3-4593008*y**4+1133298*y**5+522238*y**6-184337*y**7-20172*y**8
          +5433*y**9)+r**4*(-1+y)**4*(239598+215739*y+172968*y**2+711145*y**3
          -1068910*y**4-13636*y**5-698198*y**6+2381464*y**7-2629420*y**8+1381385*y**9
          -259362*y**10-13441*y**11+668*y**12)+5*r**6*(-1+y)**3*(61652+93801*y
          -18903*y**2-1950935*y**3+5284025*y**4-5051584*y**5+1856368*y**6+72856*y**7
          -504180*y**8+374135*y**9-110233*y**10+4191*y**11+807*y**12)-(-1+y)**6*(
          -863-2589*y-5178*y**2-18310*y**3-7640*y**4-6544*y**5-7722*y**6+26426*y**7
          -4265*y**8+1565*y**9-668*y**10-3764*y**11+1552*y**12)-5*r**8*(-1+y)**2*(1495819
          -2607070*y+733134*y**2-3703654*y**3+14693541*y**4-21082902*y**5+14135366*y**6
          -3338562*y**7-900021*y**8+514084*y**9-5492*y**10-19896*y**11+1653*y**12)
          +2*r**12*(-24565894+116636943*y-212534784*y**2+167628370*y**3-16908815*y**4
          -61310837*y**5+33962579*y**6+2466173*y**7-7236645*y**8+1921290*y**9
          +4081*y**10-50547*y**11+2086*y**12)-r**2*(-1+y)**5*(-24876-47163*y
          -66861*y**2-298290*y**3+176270*y**4-4768*y**5-46084*y**6+399422*y**7
          -301510*y**8+50555*y**9-6031*y**10-2428*y**11+3764*y**12)-2*r**10*(13546628
          -58709229*y+95512344*y**2-62747978*y**3-12826120*y**4+65626674*y**5
          -74365612*y**6+48658242*y**7-16017164*y**8+210745*y**9+1369948*y**10
          -237784*y**11-27336*y**12+6642*y**13)))*nlo.X1El(0,'VLVR',y/2,r))/(580608000*logy**4*r**16*(
          -1+y)**8+193536000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+24192000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+1344000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +28000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(1512000*logy**3*r**12*(19+19*r**2+11*r**4+3*r**6)*(-1+y)**8+3600*logy**2*r**8*(
          -1+y)**6*(175*r**12*(-1+y)**2+255*r**14*(-1+y)**2-7*r**10*(-897+1254*y
          -87*y**2-340*y**3+90*y**4)+35*r**8*(405-414*y-189*y**2+204*y**3-38*y**4
          +8*y**5)-35*r**2*(-1+y)**2*(213-5*y**4-32*y**5+4*y**6)+35*r**6*(275
          +134*y-751*y**2+196*y**3+143*y**4-82*y**5+25*y**6)+35*r**4*(-669
          +2022*y-1695*y**2+52*y**3+495*y**4-282*y**5+77*y**6)+(-1+y)**3*(
          -361-361*y-361*y**2-4001*y**3+3804*y**4-900*y**5+80*y**6))+60*logy*r**4*(
          -1+y)**4*(-1+r**2+y)**2*(355*r**18*(-1+y)**4-r**16*(-1+y)**2*(-1153
          +3016*y-2573*y**2+1470*y**3)-r**14*(-1+y)**2*(-64706+101828*y-25903*y**2
          -10734*y**3+1755*y**4)+r**12*(-1+y)**2*(8214-66656*y+94159*y**2-16866*y**3
          -12551*y**4+5180*y**5)+r**10*(692212-2030424*y+1848647*y**2-169180*y**3
          -586485*y**4+241888*y**5+27709*y**6-25452*y**7+2485*y**8)+r**2*(-1
          +y)**3*(19399+17793*y+16187*y**2+142341*y**3-189095*y**4+52111*y**5
          -17483*y**6+7323*y**7+1544*y**8+280*y**9)-5*r**8*(-436732+1374912*y
          -1414175*y**2+301728*y**3+420651*y**4-337498*y**5+90783*y**6+5140*y**7
          -8743*y**8+1414*y**9)-(-1+y)**4*(-803-1606*y-2409*y**2-13492*y**3
          +4295*y**4-1662*y**5-7059*y**6+18944*y**7-10248*y**8+1440*y**9)+r**4*(
          -1+y)**2*(115834+6128*y-13123*y**2-627214*y**3+1390935*y**4-1107204*y**5
          +299327*y**6+34778*y**7-29781*y**8+5920*y**9)+r**6*(883662-2380808*y
          +1934387*y**2-460068*y**3+323372*y**4-509292*y**5+263858*y**6-41212*y**7
          -26282*y**8+12628*y**9-245*y**10))-(-1+y)**2*(-1+r**2+y)**3*(23*r**24*(
          -1+y)**6+r**22*(-1+y)**4*(-1636+3203*y-1498*y**2+611*y**3)-r**20*(
          -1+y)**2*(53282-196667*y+264360*y**2-147190*y**3+20590*y**4+6593*y**5
          +32*y**6)-5*r**18*(-1+y)**2*(-10084+25495*y-2964*y**2-59086*y**3+67984*y**4
          -18137*y**5-3136*y**6+768*y**7)-5*r**16*(-1+y)**2*(981683-3134849*y
          +3304164*y**2-878638*y**3-577695*y**4+335767*y**5-23846*y**6-7224*y**7
          +78*y**8)+2*r**14*(-1+y)**2*(5042852-15034913*y+12846762*y**2+344847*y**3
          -4593008*y**4+1133298*y**5+522238*y**6-184337*y**7-20172*y**8+5433*y**9)
          +r**4*(-1+y)**4*(239598+215739*y+172968*y**2+711145*y**3-1068910*y**4
          -13636*y**5-698198*y**6+2381464*y**7-2629420*y**8+1381385*y**9-259362*y**10
          -13441*y**11+668*y**12)+5*r**6*(-1+y)**3*(61652+93801*y-18903*y**2
          -1950935*y**3+5284025*y**4-5051584*y**5+1856368*y**6+72856*y**7-504180*y**8
          +374135*y**9-110233*y**10+4191*y**11+807*y**12)-(-1+y)**6*(-863-2589*y
          -5178*y**2-18310*y**3-7640*y**4-6544*y**5-7722*y**6+26426*y**7-4265*y**8
          +1565*y**9-668*y**10-3764*y**11+1552*y**12)-5*r**8*(-1+y)**2*(1495819
          -2607070*y+733134*y**2-3703654*y**3+14693541*y**4-21082902*y**5+14135366*y**6
          -3338562*y**7-900021*y**8+514084*y**9-5492*y**10-19896*y**11+1653*y**12)
          +2*r**12*(-24565894+116636943*y-212534784*y**2+167628370*y**3-16908815*y**4
          -61310837*y**5+33962579*y**6+2466173*y**7-7236645*y**8+1921290*y**9
          +4081*y**10-50547*y**11+2086*y**12)-r**2*(-1+y)**5*(-24876-47163*y
          -66861*y**2-298290*y**3+176270*y**4-4768*y**5-46084*y**6+399422*y**7
          -301510*y**8+50555*y**9-6031*y**10-2428*y**11+3764*y**12)-2*r**10*(13546628
          -58709229*y+95512344*y**2-62747978*y**3-12826120*y**4+65626674*y**5
          -74365612*y**6+48658242*y**7-16017164*y**8+210745*y**9+1369948*y**10
          -237784*y**11-27336*y**12+6642*y**13)))*nlo.X1El(0,'VR',y/2,r))/(290304000*logy**4*r**16*(
          -1+y)**8+96768000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+12096000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+672000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +14000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(64800*logy**3*r**11*(27+41*r**2+29*r**4+9*r**6)*(-1+y)**8+2160*logy**2*r**7*(
          -1+y)**6*(74*r**12*(-1+y)**2+31*r**14*(-1+y)**2+r**10*(1389-1968*y
          +174*y**2+485*y**3-90*y**4)+5*r**8*(443-364*y-340*y**2+242*y**3+y**4
          +4*y**5)-(-1+y)**3*(11+11*y+11*y**2+251*y**3-184*y**4+20*y**5)
          -r**2*(-1+y)**2*(599-455*y**3+430*y**4-234*y**5+20*y**6)+5*r**6*(-17
          +772*y-1124*y**2+168*y**3+255*y**4-105*y**5+27*y**6)+r**4*(-3036
          +8502*y-6681*y**2-50*y**3+1860*y**4-744*y**5+113*y**6+36*y**7))+18*logy*r**3*(
          -1+y)**4*(-1+r**2+y)**2*(41*r**18*(-1+y)**4-r**16*(-1+y)**2*(-643+1368*y
          -807*y**2+162*y**3)-r**14*(-1+y)**2*(-15790+25508*y-7489*y**2-1926*y**3
          +257*y**4)+r**12*(-1+y)**2*(22492-45292*y+26723*y**2+338*y**3-2257*y**4
          +556*y**5)+(-1+y)**4*(11+22*y+33*y**2+604*y**3-95*y**4+94*y**5
          +683*y**6-1128*y**7+376*y**8)+r**10*(325264-987788*y+962749*y**2-168480*y**3
          -240815*y**4+115216*y**5-2237*y**6-4404*y**7+495*y**8)+r**2*(-1+y)**3*(1217
          +1195*y+1173*y**2+10851*y**3-12281*y**4+853*y**5-4525*y**6+5397*y**7
          -1856*y**8+376*y**9)+r**4*(-1+y)**2*(18460+228*y-1059*y**2-127026*y**3
          +222587*y**4-138000*y**5+21407*y**6+9694*y**7-3339*y**8+648*y**9)-r**8*(
          -592234+1816036*y-1796019*y**2+337456*y**3+482771*y**4-315066*y**5
          +67539*y**6+5044*y**7-6881*y**8+754*y**9)+r**6*(171082-446136*y+345989*y**2
          -173976*y**3+407904*y**4-548040*y**5+323186*y**6-83264*y**7-1874*y**8
          +5496*y**9-367*y**10))+3*r*(-1+y)**3*(-1+r**2+y)**3*(11*r**20*(-1+y)**5
          -r**18*(-1+y)**3*(-887+1561*y-584*y**2+20*y**3)-r**14*(-1+y)**2*(98866
          -215370*y+117060*y**2+18665*y**3-23400*y**4+2019*y**5+60*y**6)-6*r**16*(829
          -3910*y+7345*y**2-6960*y**3+3400*y**4-689*y**5-40*y**6+25*y**7)+r**12*(56552
          -202342*y+195188*y**2+67937*y**3-212345*y**4+111118*y**5-11938*y**6
          -5343*y**7+783*y**8+390*y**9)+(-1+y)**5*(56+168*y+336*y**2+869*y**3
          +572*y**4+363*y**5+82*y**6-561*y**7-144*y**8-47*y**9+106*y**10)+3*r**10*(
          -502676+1833106*y-2306948*y**2+790633*y**3+694954*y**4-671513*y**5
          +142444*y**6+32823*y**7-14458*y**8+871*y**9+164*y**10)+3*r**4*(-1+y)**3*(2543
          +3408*y+3113*y**2-42897*y**3+52608*y**4-18023*y**5+5142*y**6-7563*y**7
          +2797*y**8-133*y**9+205*y**10)+r**6*(-1+y)**2*(-128446+85278*y+28872*y**2
          +551901*y**3-1196170*y**4+902511*y**5-195488*y**6-103457*y**7+56364*y**8
          -5265*y**9+300*y**10)+r**2*(-1+y)**4*(1603+3104*y+4470*y**2+2351*y**3
          +1462*y**4-2943*y**5-16354*y**6+18205*y**7-7701*y**8+763*y**9+440*y**10)
          +r**8*(-598858+1924148*y-2036302*y**2+663653*y**3-36127*y**4+208109*y**5
          -130003*y**6+28427*y**7-47803*y**8+28227*y**9-3651*y**10+180*y**11)))*nlo.X1El(1,'SM',y/2,r))/(1036800*logy**4*r**16*(
          -1+y)**8+345600*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+43200*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+2400*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +50*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-21600*logy**3*r**11*(27+41*r**2+29*r**4+9*r**6)*(-1+y)**8-720*logy**2*r**7*(
          -1+y)**6*(74*r**12*(-1+y)**2+31*r**14*(-1+y)**2+r**10*(1389-1968*y
          +174*y**2+485*y**3-90*y**4)+5*r**8*(443-364*y-340*y**2+242*y**3+y**4
          +4*y**5)-(-1+y)**3*(11+11*y+11*y**2+251*y**3-184*y**4+20*y**5)
          -r**2*(-1+y)**2*(599-455*y**3+430*y**4-234*y**5+20*y**6)+5*r**6*(-17
          +772*y-1124*y**2+168*y**3+255*y**4-105*y**5+27*y**6)+r**4*(-3036
          +8502*y-6681*y**2-50*y**3+1860*y**4-744*y**5+113*y**6+36*y**7))-6*logy*r**3*(
          -1+y)**4*(-1+r**2+y)**2*(41*r**18*(-1+y)**4-r**16*(-1+y)**2*(-643+1368*y
          -807*y**2+162*y**3)-r**14*(-1+y)**2*(-15790+25508*y-7489*y**2-1926*y**3
          +257*y**4)+r**12*(-1+y)**2*(22492-45292*y+26723*y**2+338*y**3-2257*y**4
          +556*y**5)+(-1+y)**4*(11+22*y+33*y**2+604*y**3-95*y**4+94*y**5
          +683*y**6-1128*y**7+376*y**8)+r**10*(325264-987788*y+962749*y**2-168480*y**3
          -240815*y**4+115216*y**5-2237*y**6-4404*y**7+495*y**8)+r**2*(-1+y)**3*(1217
          +1195*y+1173*y**2+10851*y**3-12281*y**4+853*y**5-4525*y**6+5397*y**7
          -1856*y**8+376*y**9)+r**4*(-1+y)**2*(18460+228*y-1059*y**2-127026*y**3
          +222587*y**4-138000*y**5+21407*y**6+9694*y**7-3339*y**8+648*y**9)-r**8*(
          -592234+1816036*y-1796019*y**2+337456*y**3+482771*y**4-315066*y**5
          +67539*y**6+5044*y**7-6881*y**8+754*y**9)+r**6*(171082-446136*y+345989*y**2
          -173976*y**3+407904*y**4-548040*y**5+323186*y**6-83264*y**7-1874*y**8
          +5496*y**9-367*y**10))-r*(-1+y)**3*(-1+r**2+y)**3*(11*r**20*(-1+y)**5
          -r**18*(-1+y)**3*(-887+1561*y-584*y**2+20*y**3)-r**14*(-1+y)**2*(98866
          -215370*y+117060*y**2+18665*y**3-23400*y**4+2019*y**5+60*y**6)-6*r**16*(829
          -3910*y+7345*y**2-6960*y**3+3400*y**4-689*y**5-40*y**6+25*y**7)+r**12*(56552
          -202342*y+195188*y**2+67937*y**3-212345*y**4+111118*y**5-11938*y**6
          -5343*y**7+783*y**8+390*y**9)+(-1+y)**5*(56+168*y+336*y**2+869*y**3
          +572*y**4+363*y**5+82*y**6-561*y**7-144*y**8-47*y**9+106*y**10)+3*r**10*(
          -502676+1833106*y-2306948*y**2+790633*y**3+694954*y**4-671513*y**5
          +142444*y**6+32823*y**7-14458*y**8+871*y**9+164*y**10)+3*r**4*(-1+y)**3*(2543
          +3408*y+3113*y**2-42897*y**3+52608*y**4-18023*y**5+5142*y**6-7563*y**7
          +2797*y**8-133*y**9+205*y**10)+r**6*(-1+y)**2*(-128446+85278*y+28872*y**2
          +551901*y**3-1196170*y**4+902511*y**5-195488*y**6-103457*y**7+56364*y**8
          -5265*y**9+300*y**10)+r**2*(-1+y)**4*(1603+3104*y+4470*y**2+2351*y**3
          +1462*y**4-2943*y**5-16354*y**6+18205*y**7-7701*y**8+763*y**9+440*y**10)
          +r**8*(-598858+1924148*y-2036302*y**2+663653*y**3-36127*y**4+208109*y**5
          -130003*y**6+28427*y**7-47803*y**8+28227*y**9-3651*y**10+180*y**11)))*nlo.X1El(1,'VL',y/2,r))/(1036800*logy**4*r**16*(
          -1+y)**8+345600*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+43200*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+2400*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +50*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6+120*logy*r**4*(
          -1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(-67+98*y
          -13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3-2*y**4
          +y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)+2*r**2*(
          -1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y-421*y**2
          +40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(
          -1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1
          +y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(
          -4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y
          +45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)
          +2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5
          -56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(1,'VLVR',y/2,r))/(345600*logy**3*r**12*(
          -1+y)**6-200*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +86400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+7200*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-3600*logy**2*r**8*(15+10*r**2
          +3*r**4)*(-1+y)**6-120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(
          -1+y)**2-5*r**8*(-67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y
          -18*y**2+22*y**3-2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3
          -16*y**4+2*y**5)+2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(
          -151+482*y-421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))-(-1+y)**2*(
          -1+r**2+y)**2*(7*r**16*(-1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2
          +27*y**3)-r**12*(-1+y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)
          +2*r**10*(-1+y)**2*(-4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)
          +5*r**8*(13422-43158*y+45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6
          -284*y**7+33*y**8)+2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3
          -2300*y**4+277*y**5-56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436
          -542*y+757*y**2+11016*y**3-25545*y**4+20466*y**5-4753*y**6-652*y**7
          +89*y**8)+(-1+y)**4*(67+134*y+201*y**2+428*y**3-55*y**4-22*y**5
          -89*y**6-156*y**7+92*y**8)-2*r**6*(-17964+49281*y-40854*y**2+5986*y**3
          +8446*y**4-11636*y**5+9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(1,'VR',y/2,r))/(172800*logy**3*r**12*(
          -1+y)**6-100*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +43200*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+3600*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(6480*logy**2*r**7*(4+5*r**2
          +2*r**4)*(-1+y)**6+216*logy*r**3*(-1+y)**4*(8*r**10*(-1+y)**2+3*r**12*(
          -1+y)**2-5*r**8*(-44+64*y-8*y**2-13*y**3+2*y**4)+2*(-1+y)**3*(
          -1-y-y**2-6*y**3+4*y**4)+5*r**6*(26+8*y-64*y**2+21*y**3+7*y**4)
          +r**2*(-1+y)**2*(-58+35*y**3-15*y**4+8*y**5)+5*r**4*(-61+170*y-133*y**2
          +y**3+31*y**4-11*y**5+3*y**6))+9*r*(-1+y)**3*(-1+r**2+y)**2*(7*r**12*(
          -1+y)**3+2*r**10*(-81+214*y-174*y**2+35*y**3+6*y**4)+r**8*(-169
          +509*y-558*y**2+220*y**3+3*y**4-5*y**5)-4*r**6*(1431-2992*y+1413*y**2
          +518*y**3-447*y**4+47*y**5)+(-1+y)**3*(-13-26*y-39*y**2-54*y**3
          -9*y**4+4*y**5+17*y**6)+2*r**2*(-1+y)**2*(-61-72*y-71*y**2+319*y**3
          -256*y**4+55*y**5+26*y**6)+r**4*(-1749+2827*y-705*y**2+335*y**3-1195*y**4
          +489*y**5-47*y**6+45*y**7)))*nlo.X1El(2,'SM',y/2,r))/(-17280*logy**3*r**12*(
          -1+y)**6+10*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -4320*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-360*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-2160*logy**2*r**7*(4+5*r**2
          +2*r**4)*(-1+y)**6-72*logy*r**3*(-1+y)**4*(8*r**10*(-1+y)**2+3*r**12*(
          -1+y)**2-5*r**8*(-44+64*y-8*y**2-13*y**3+2*y**4)+2*(-1+y)**3*(
          -1-y-y**2-6*y**3+4*y**4)+5*r**6*(26+8*y-64*y**2+21*y**3+7*y**4)
          +r**2*(-1+y)**2*(-58+35*y**3-15*y**4+8*y**5)+5*r**4*(-61+170*y-133*y**2
          +y**3+31*y**4-11*y**5+3*y**6))-3*r*(-1+y)**3*(-1+r**2+y)**2*(7*r**12*(
          -1+y)**3+2*r**10*(-81+214*y-174*y**2+35*y**3+6*y**4)+r**8*(-169
          +509*y-558*y**2+220*y**3+3*y**4-5*y**5)-4*r**6*(1431-2992*y+1413*y**2
          +518*y**3-447*y**4+47*y**5)+(-1+y)**3*(-13-26*y-39*y**2-54*y**3
          -9*y**4+4*y**5+17*y**6)+2*r**2*(-1+y)**2*(-61-72*y-71*y**2+319*y**3
          -256*y**4+55*y**5+26*y**6)+r**4*(-1749+2827*y-705*y**2+335*y**3-1195*y**4
          +489*y**5-47*y**6+45*y**7)))*nlo.X1El(2,'VL',y/2,r))/(-17280*logy**3*r**12*(
          -1+y)**6+10*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          -4320*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))-360*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-180*logy*r**4*(3+r**2)*(-1
          +y)**4-3*(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(
          -1+y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(2,'VLVR',y/2,r))/(2880*logy**2*r**8*(-1+y)**4+480*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(180*logy*r**4*(3+r**2)*(-1+y)**4+3*(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(2,'VR',y/2,r))/(1440*logy**2*r**8*(
          -1+y)**4+240*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+10*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(72*logy*r**3*(1+r**2)*(-1+y)**4
          +12*r*(-1+y)**3*(r**6*(-1+y)+3*r**2*(-1+y)**2*(3+y)+3*r**4*(-3+y
          +y**2)+(-1+y)**2*(1+y+y**2)))*nlo.X1El(3,'SM',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-24*logy*r**3*(1+r**2)*(-1+y)**4
          -4*r*(-1+y)**3*(r**6*(-1+y)+3*r**2*(-1+y)**2*(3+y)+3*r**4*(-3+y
          +y**2)+(-1+y)**2*(1+y+y**2)))*nlo.X1El(3,'VL',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(3,'VLVR',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -(2*api*(-1+y)**2*nlo.X1El(3,'VR',y/2,r))/(12*logy*r**4*(-1+y)**2-r**8*(
          -1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.VLVR

    if wc.SLT != 0:
      resNP = 0
      resNP +=((18144000*logy**4*r**16*(3+5*r**2+5*r**4+3*r**6)*(-1+y)**8+345600*logy**3*r**12*(
          -1+y)**6*(154*r**12*(-1+y)**2+r**14*(-1+y)**2+7*r**10*(108-126*y-27*y**2
          +50*y**3)-(-1+y)**5*(-1-3*y-6*y**2-45*y**3+20*y**4)+35*r**8*(9
          +12*y-36*y**2+13*y**3+2*y**4+y**5)+7*r**4*(-1+y)**2*(-108+90*y
          +45*y**2-20*y**3+5*y**4+3*y**5)-7*r**2*(-1+y)**3*(-22-22*y-22*y**2
          +38*y**3-27*y**4+5*y**5)+35*r**6*(-9+48*y-54*y**2+2*y**3+19*y**4
          -8*y**5+2*y**6))-1440*logy**2*r**8*(-1+y)**5*(-1+r**2+y)**2*(291*r**18*(
          -1+y)**3+r**16*(1137-2829*y+1665*y**2+1309*y**3-1282*y**4)+r**14*(16740
          -51192*y+52623*y**2-24557*y**3+8393*y**4-2007*y**5)+r**12*(122268
          -289656*y+191745*y**2+8285*y**3-27385*y**4-8393*y**5+3136*y**6)-r**2*(
          -1+y)**4*(-1137-2829*y-4494*y**2-15070*y**3+14275*y**4+6247*y**5
          -5036*y**6+1044*y**7)-r**6*(-1+y)**2*(-122268-45120*y-24357*y**2+245305*y**3
          -174190*y**4+49538*y**5-3045*y**6+1337*y**7)-(-1+y)**5*(-291-1164*y
          -2910*y**2-3340*y**3+1445*y**4+7476*y**5-6156*y**6+1440*y**7)+r**10*(464946
          -906306*y+368505*y**2+231325*y**3-171540*y**4+32544*y**5-15379*y**6
          +1505*y**7)+r**4*(-1+y)**3*(-16740-34452*y-52623*y**2+6920*y**3+45050*y**4
          -16920*y**5-10283*y**6+2748*y**7)+r**8*(464946-953478*y+439263*y**2
          +199219*y**3-161610*y**4+22644*y**5-24557*y**6+19327*y**7-5754*y**8))
          +96*logy*r**4*(-1+y)**4*(-1+r**2+y)**3*(12*r**24*(-1+y)**4+r**22*(-1
          +y)**2*(-1199+2362*y-1127*y**2+454*y**3)+r**20*(-12518+44903*y-58725*y**2
          +31610*y**3-2725*y**4-3887*y**5+342*y**6)-(-1+y)**9*(12+96*y+432*y**2
          +1575*y**3+2305*y**4-677*y**5-1331*y**6+388*y**7)-5*r**18*(-27933+98433*y
          -120768*y**2+49174*y**3+6679*y**4-4478*y**5-2404*y**6+457*y**7)-5*r**16*(
          -65572+232348*y-300744*y**2+215938*y**3-134185*y**4+64217*y**5-6143*y**6
          -4751*y**7+292*y**8)-r**2*(-1+y)**6*(1199+5959*y+17769*y**2+36624*y**3
          +5779*y**4-60724*y**5+31991*y**6-744*y**7-3074*y**8+221*y**9)+5*r**6*(
          -1+y)**4*(27933+70500*y+120768*y**2+60797*y**3-134898*y**4-52028*y**5
          +109820*y**6-36523*y**7+3433*y**8+298*y**9)-5*r**8*(-1+y)**3*(65572
          +101204*y+133968*y**2-273817*y**3-43562*y**4+27058*y**5+36736*y**6
          -853*y**7-10378*y**8+1172*y**9)+r**4*(-1+y)**5*(12518+44903*y+103628*y**2
          -34697*y**3-81267*y**4-192293*y**5+280422*y**6-81803*y**7-1253*y**8
          +2342*y**9)-r**10*(-1+y)**2*(-2197406+636754*y+643714*y**2+3042869*y**3
          -4429546*y**4+1404906*y**5+198646*y**6-155139*y**7-21144*y**8+4846*y**9)
          +r**14*(2197406-5955464*y+4674996*y**2+946261*y**3-2733904*y**4+607694*y**5
          +355064*y**6-67571*y**7-23786*y**8+6304*y**9)+r**12*(6793548-16983870*y
          +11461050*y**2+3732595*y**3-8292565*y**4+4882394*y**5-2389780*y**6+816375*y**7
          +22855*y**8-48510*y**9+5908*y**10))-(-1+y)**2*(-1+r**2+y)**4*(11*r**30*(
          -1+y)**6+r**28*(-1+y)**4*(-479+914*y-391*y**2+124*y**3)+r**26*(-1
          +y)**2*(9223-36172*y+51992*y**2-36980*y**3+16203*y**4-3912*y**5+606*y**6)
          +r**24*(183773-1023706*y+2340017*y**2-2880520*y**3+2118901*y**4-958558*y**5
          +231551*y**6+28*y**7-16290*y**8+1604*y**9)-(-1+y)**10*(-11-88*y
          -396*y**2-1944*y**3-2722*y**4+2192*y**5+1068*y**6-1624*y**7+549*y**8
          +152*y**9+24*y**10)+r**22*(25671+391542*y-2179683*y**2+5043220*y**3
          -7266094*y**4+7054128*y**5-4176802*y**6+1185388*y**7-39625*y**8-28646*y**9
          +2101*y**10)-r**2*(-1+y)**9*(-479-3309*y-13060*y**2-55452*y**3-50994*y**4
          +89722*y**5-1900*y**6-45300*y**7+24617*y**8+59*y**9+72*y**10+24*y**11)
          -r**4*(-1+y)**8*(-9223-54618*y-188177*y**2-668880*y**3-632998*y**4
          +405180*y**5+366102*y**6+269032*y**7-346115*y**8+104478*y**9-1077*y**10
          +296*y**11)-r**20*(12852411-64149510*y+125547369*y**2-111520024*y**3
          +24464638*y**4+33275028*y**5-26384838*y**6+5596136*y**7+559079*y**8
          -245358*y**9+15741*y**10+528*y**11)-r**6*(-1+y)**7*(183773+839933*y
          +2340017*y**2+1666345*y**3-1567782*y**4-5654230*y**5+6374658*y**6-270382*y**7
          -1045335*y**8+333017*y**9-9683*y**10+1669*y**11)-r**8*(-1+y)**6*(-25671
          +442884*y+1762470*y**2+11781252*y**3+3575374*y**4+6460528*y**5-12276520*y**6
          +5679920*y**7-663487*y**8+306316*y**9-38742*y**10+5676*y**11)-r**10*(
          -1+y)**5*(-12852411-25592277*y-35805582*y**2+26724622*y**3+53217086*y**4
          +17819602*y**5-56414152*y**6+24386392*y**7-2091387*y**8+408699*y**9
          -95106*y**10+12914*y**11)-r**16*(-1+y)**2*(138714671-326090304*y+177216424*y**2
          +236673680*y**3-376425974*y**4+178712240*y**5-22302164*y**6-1607704*y**7
          -1299585*y**8+1054144*y**9-127116*y**10+17688*y**11)-r**12*(-1+y)**4*(
          -6196883-5423638*y+3381165*y**2-25732324*y**3+50863642*y**4-9236356*y**5
          -26330030*y**6+28810640*y**7-8350071*y**8+1541738*y**9-156431*y**10
          +20548*y**11)-r**14*(-1+y)**3*(-138714671+90053709*y+58820171*y**2
          +97353655*y**3-213918406*y**4+57558610*y**5+23487734*y**6+9454414*y**7
          -9736395*y**8+2273441*y**9-175329*y**10+23067*y**11)+r**18*(6196883
          -30211170*y+50071047*y**2+15276224*y**3-176117406*y**4+269399828*y**5
          -188779066*y**6+55829080*y**7+1953951*y**8-3883394*y**9+219539*y**10
          +52536*y**11-8052*y**12)))/(580608000*logy**4*r**16*(-1+y)**8+193536000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +24192000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+1344000*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3+28000*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(-217728000*logy**5*r**22*(5
          +10*r**2+9*r**4)*(-1+y)**10-518400*logy**4*r**16*(-1+y)**8*(565*r**14*(
          -1+y)**2+14*r**12*(367-734*y+367*y**2+15*y**3)+7*r**10*(2367-2034*y
          -1683*y**2+1570*y**3)+1750*r**4*(-1+y)**2*(-3-y**3+y**4)+70*r**8*(
          -60+420*y-510*y**2+170*y**3-26*y**4+29*y**5)+7*r**2*(-1+y)**2*(-79
          -810*y**3+745*y**4-256*y**5+40*y**6)+8*(-1+y)**3*(-107-107*y-107*y**2
          +33*y**3+208*y**4-170*y**5+40*y**6)+35*r**6*(-375+1050*y-825*y**2
          +64*y**3+197*y**4-136*y**5+49*y**6))+17280*logy**3*r**12*(-1+y)**6*(
          -1+r**2+y)**2*(1977*r**18*(-1+y)**4-2*r**16*(-1+y)**2*(9420-16863*y
          +5466*y**2+4057*y**3)-r**14*(-1+y)**2*(198972-363870*y+158793*y**2
          -17144*y**3+7149*y**4)+4*(-1+y)**6*(-261-1044*y-2610*y**2-1750*y**3
          +2285*y**4+8046*y**5-8106*y**6+2040*y**7)+2*r**12*(-305682+1062483*y
          -1335681*y**2+631880*y**3+6620*y**4-46173*y**5-18753*y**6+4606*y**7)
          +r**10*(-1427886+3941142*y-3384351*y**2+168940*y**3+1208755*y**4-632994*y**5
          +161443*y**6-31024*y**7-6825*y**8)+r**2*(-1+y)**4*(24309+46530*y+66663*y**2
          +13108*y**3-74285*y**4-9414*y**5+48345*y**6-19208*y**7+1952*y**8)+r**6*(
          -1+y)**2*(-129540+183234*y+113997*y**2-913176*y**3+869955*y**4-272550*y**5
          +58431*y**6-31052*y**7+3101*y**8)-2*r**4*(-1+y)**3*(68946+40851*y
          +36870*y**2-123997*y**3-81010*y**4+111049*y**5-8826*y**6-17915*y**7
          +4832*y**8)-2*r**8*(400266-1059429*y+739536*y**2+547806*y**3-1279544*y**4
          +881384*y**5-220696*y**6-24086*y**7+11494*y**8+3269*y**9))+288*logy**2*r**8*(
          -1+y)**5*(-1+r**2+y)**3*(1023*r**24*(-1+y)**5-r**22*(-1+y)**3*(-60319
          +123707*y-66457*y**2+34479*y**3)+r**20*(-107843+367381*y-403328*y**2
          +47050*y**3+263205*y**4-284647*y**5+116734*y**6+1448*y**7)+5*r**18*(1449693
          -6539886*y+11396247*y**2-9155242*y**3+2918837*y**4-74496*y**5+177063*y**6
          -197600*y**7+25384*y**8)-10*r**16*(-2466553+10571519*y-17469241*y**2
          +13696479*y**3-4874910*y**4+477948*y**5+112841*y**6-69259*y**7+9391*y**8
          +11785*y**9)-4*(-1+y)**7*(1383+6915*y+20745*y**2+32285*y**3+25525*y**4
          -22661*y**5-66765*y**6-6845*y**7+87840*y**8-52950*y**9+9528*y**10)
          -r**2*(-1+y)**6*(1679-9880*y-66190*y**2+89730*y**3+627350*y**4+1126732*y**5
          -2484670*y**6+968890*y**7+126895*y**8-112000*y**9+11464*y**10)-5*r**6*(
          -1+y)**4*(1105011+1492956*y+1684095*y**2-2037270*y**3-3139662*y**4
          +613374*y**5+3579274*y**6-3108090*y**7+1159315*y**8-229538*y**9+28535*y**10)
          -5*r**8*(-1+y)**3*(-2625323-259178*y-472637*y**2+7696452*y**3-799128*y**4
          -4824828*y**5+494948*y**6+1256612*y**7-69837*y**8-209682*y**9+59001*y**10)
          +2*r**10*(-1+y)**2*(18450143-25433160*y-5976615*y**2+59665120*y**3
          -68478045*y**4+31383864*y**5-7604365*y**6+1287240*y**7+1187030*y**8
          -905280*y**9+78068*y**10)+r**4*(-1+y)**5*(204643+790290*y+1806150*y**2
          +4024000*y**3+1798320*y**4+650304*y**5-13425190*y**6+12031800*y**7-2983675*y**8
          -202970*y**9+94328*y**10)-2*r**14*(-21950383+82921220*y-117721030*y**2
          +61663680*y**3+14778825*y**4-25538154*y**5+5028955*y**6-930620*y**7
          +2689170*y**8-1129650*y**9+159987*y**10)+2*r**12*(43873299-129877209*y
          +113918805*y**2+26010075*y**3-110884515*y**4+74812437*y**5-12740707*y**6
          -12165455*y**7+9287600*y**8-2029860*y**9-268786*y**10+64316*y**11))
          +12*logy*r**4*(-1+y)**4*(-1+r**2+y)**4*(217*r**30*(-1+y)**6+2*r**28*(
          -1+y)**4*(-4101+7768*y-3233*y**2+886*y**3)+r**26*(-1+y)**2*(520359
          -2000392*y+2824700*y**2-1914940*y**3+727115*y**4-128404*y**5+19562*y**6)
          +4*r**24*(401441-2184916*y+4978763*y**2-6671107*y**3+6247129*y**4-4053211*y**5
          +1401281*y**6-40213*y**7-104558*y**8+6991*y**9)+r**22*(-18952287+113362050*y
          -276501213*y**2+363933464*y**3-296764694*y**4+171780012*y**5-75668530*y**6
          +21400808*y**7-2602619*y**8+301714*y**9-75905*y**10)+8*(-1+y)**10*(13
          +104*y+468*y**2+1158*y**3+1528*y**4-698*y**5-7030*y**6-6918*y**7
          +7867*y**8+4122*y**9-4190*y**10+776*y**11)-2*r**20*(124544235-611030988*y
          +1176977193*y**2-1049788412*y**3+309865958*y**4+139205688*y**5-81791246*y**6
          -25456168*y**7+18269487*y**8-12508*y**9-771323*y**10+77684*y**11)-r**2*(
          -1+y)**8*(24027+143746*y+501655*y**2+1035160*y**3+1395190*y**4+553836*y**5
          -2359722*y**6-1444920*y**7+2815615*y**8-1012990*y**9-6813*y**10+31376*y**11
          +3840*y**12)+r**6*(-1+y)**6*(4602259+16123464*y+35326212*y**2+47453820*y**3
          +29850475*y**4-7757888*y**5-146395688*y**6+105406536*y**7+14651905*y**8
          -33036200*y**9+10531204*y**10-1165476*y**11+9377*y**12)-2*r**4*(-1+y)**7*(
          -296853-1399343*y-4009127*y**2-4870165*y**3-11130*y**4+11750546*y**5
          +1661906*y**6-2208186*y**7-11348785*y**8+9642205*y**9-2322443*y**10
          +22287*y**11+29088*y**12)+r**18*(-372110441+1772602242*y-3407234241*y**2
          +3411673560*y**3-1887540470*y**4+416109292*y**5+329492486*y**6-440140888*y**7
          +211670515*y**8-30227230*y**9-4069701*y**10-264528*y**11+39404*y**12)
          +4*r**8*(-1+y)**5*(-1377117-5706501*y-13487382*y**2-22708615*y**3+8967445*y**4
          +8965554*y**5+79828992*y**6-92173326*y**7+27103765*y**8+135355*y**9
          +670638*y**10-695091*y**11+60283*y**12)+r**10*(-1+y)**4*(184424349+131980530*y
          +72765603*y**2-566729240*y**3-208481460*y**4+319585132*y**5+688823230*y**6
          -943395176*y**7+424503165*y**8-73103790*y**9+3613519*y**10-1529360*y**11
          +135498*y**12)-2*r**12*(-1+y)**3*(66426757+1802611*y+55629865*y**2
          -442838515*y**3+221939100*y**4+139769486*y**5-32505262*y**6+65099450*y**7
          -160960035*y**8+84749375*y**9-11028443*y**10-328199*y**11+147810*y**12)
          -r**14*(-1+y)**2*(1415582733-2173379492*y+19236982*y**2+2503226580*y**3
          -3148276065*y**4+2118443864*y**5-520303756*y**6-283352344*y**7+175632795*y**8
          +10624140*y**9-12339722*y**10+1162948*y**11+253337*y**12)+8*r**16*(-56304396
          +202969450*y-257584482*y**2+20669663*y**3+270476730*y**4-184740013*y**5
          -120099900*y**6+177038334*y**7-36278096*y**8-27745680*y**9+12636334*y**10
          -673725*y**11-377102*y**12+12883*y**13))-r**2*(-1+y)**2*(-1+r**2+y)**5*(33*r**34*(
          -1+y)**8+r**32*(-1+y)**6*(-1497+2829*y-1167*y**2+325*y**3)+r**30*(
          -1+y)**4*(29118-111756*y+155037*y**2-104508*y**3+43592*y**4-9736*y**5
          +1229*y**6)+r**28*(-1+y)**2*(-388662+2289522*y-5535765*y**2+7264495*y**3
          -5849705*y**4+3089957*y**5-1069567*y**6+234865*y**7-27165*y**8+1625*y**9)
          -r**26*(6705390-49299672*y+156444939*y**2-281748970*y**3+318382031*y**4
          -234158108*y**5+110231882*y**6-29682144*y**7+2662120*y**8+574644*y**9
          -90037*y**10+650*y**11+2875*y**12)+r**24*(27853734-212915538*y+695174517*y**2
          -1248420207*y**3+1320118179*y**4-808824359*y**5+259162170*y**6-45448070*y**7
          +31990548*y**8-26146704*y**9+8415985*y**10-1012187*y**11+132483*y**12
          -13351*y**13)+r**22*(119834358-860601756*y+2651442549*y**2-4732388556*y**3
          +5762343100*y**4-5517066176*y**5+4435344847*y**6-2755491128*y**7+1111528822*y**8
          -222396380*y**9+4534083*y**10+2913924*y**11-253256*y**12+221624*y**13
          -10855*y**14)+(-1+y)**11*(171+1368*y+6156*y**2+18890*y**3+49693*y**4
          +85288*y**5-52480*y**6-141140*y**7+121133*y**8+23008*y**9-65684*y**10
          +21562*y**11-741*y**12-48*y**13+24*y**14)+r**2*(-1+y)**10*(8379+59046*y
          +237132*y**2+728948*y**3+1963095*y**4+3435322*y**5-1038632*y**6-4321224*y**7
          -312791*y**8+1048250*y**9+1465364*y**10-1210924*y**11+247557*y**12-2842*y**13
          +520*y**14)+r**4*(-1+y)**9*(-756390-4292304*y-14309151*y**2-25315392*y**3
          -18986732*y**4+24253090*y**5+32185573*y**6-361688*y**7-53446526*y**8
          +31259164*y**9-60285*y**10-3684504*y**11+839104*y**12-32542*y**13+4583*y**14)
          +r**6*(-1+y)**8*(2728050+10051692*y+23379807*y**2-17503380*y**3-105132180*y**4
          -214240720*y**5+122124181*y**6+16623416*y**7+146304610*y**8-162437940*y**9
          +55190825*y**10-7415268*y**11+1464832*y**12-185000*y**13+23075*y**14)
          +r**8*(-1+y)**7*(70781622+217847688*y+429524475*y**2+276777580*y**3
          -202746070*y**4-645663554*y**5-770313371*y**6+1146353280*y**7+140474010*y**8
          -548384980*y**9+223610157*y**10-35033692*y**11+5458870*y**12-649890*y**13
          +75875*y**14)+3*r**16*(-1+y)**3*(-977199580+2451404248*y-1460610047*y**2
          -4001733720*y**3+7987787520*y**4-4758368710*y**5+467828659*y**6-386817256*y**7
          +1122124340*y**8-660479900*y**9+165592335*y**10-23473712*y**11+5693848*y**12
          -836550*y**13+96525*y**14)+r**18*(-1+y)**2*(-510650316+2409209256*y
          -3286672755*y**2-3057156280*y**3+14282307640*y**4-17194395608*y**5+9134522153*y**6
          -1695564080*y**7+195020060*y**8-549575240*y**9+332770399*y**10-73328984*y**11
          +11245560*y**12-1252680*y**13+160875*y**14)+r**10*(-1+y)**6*(168669150
          +283479756*y+274391061*y**2-642791080*y**3-257261546*y**4-431894260*y**5
          +1871321141*y**6-1208302896*y**7+367040914*y**8-402566236*y**9+327195855*y**10
          -98312552*y**11+16983930*y**12-1544764*y**13+173927*y**14)+r**12*(-1
          +y)**5*(1797897090+761883936*y-65188215*y**2-5883097896*y**3+533851040*y**4
          +2847124210*y**5+5773940793*y**6-8417237640*y**7+3522163602*y**8-723166500*y**9
          +331329555*y**10-130921824*y**11+27487260*y**12-2585726*y**13+286715*y**14)
          +r**14*(-1+y)**4*(2838822618-1722510420*y-2397574809*y**2-946163356*y**3
          +2289411824*y**4+1859630744*y**5+1537241145*y**6-7639135992*y**7+6227315682*y**8
          -2111423268*y**9+442620393*y**10-95843820*y**11+25425556*y**12-3070496*y**13
          +342199*y**14)+r**20*(1521596178-9684806466*y+25616779269*y**2-34466969381*y**3
          +19854484076*y**4+7427884718*y**5-20945403561*y**6+15234005959*y**7-5467630366*y**8
          +1131377090*y**9-357981453*y**10+178129977*y**11-46685728*y**12+5396722*y**13
          -219791*y**14+42757*y**15))))/(-2612736000*logy**5*r**20*(-1+y)**10+10500*(r**8*(
          -1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5-1088640000*logy**4*r**16*(
          -1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          -181440000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2-15120000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3-630000*logy*(
          -1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(
          -4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2
          +y**3))**4))
      resNP += ((api*muWC*(-217728000*logy**5*r**20*(-9-5*r**2+5*r**4+9*r**6)*(
          -1+y)**10-3628800*logy**4*r**16*(-1+y)**7*(203*r**14*(-1+y)**3+5*r**12*(
          -131+393*y-393*y**2+29*y**3+54*y**4)+r**10*(-1617+2151*y+1899*y**2
          -4973*y**3+2060*y**4)-5*r**2*(-1+y)**3*(-131+264*y**3-99*y**4+8*y**6)
          +5*r**8*(495-1785*y+2235*y**2-1235*y**3+150*y**4+18*y**5+26*y**6)
          -(-1+y)**3*(-203-130*y**3+525*y**4-432*y**5+120*y**6)+5*r**6*(495
          -1185*y+735*y**2+247*y**3-741*y**4+651*y**5-307*y**6+57*y**7)+r**4*(
          -1617+7551*y-11601*y**2+7517*y**3-2555*y**4+1287*y**5-551*y**6-79*y**7
          +48*y**8))-17280*logy**3*r**12*(-1+y)**5*(-1+r**2+y)**2*(-3021*r**18*(
          -1+y)**5+r**16*(-1+y)**2*(-43149+123405*y-111321*y**2+16103*y**3
          +13242*y**4)+r**14*(-1+y)**2*(-336864+920328*y-815997*y**2+180583*y**3
          -3147*y**4+15057*y**5)+(-1+y)**6*(-3021-9063*y-18126*y**2-1850*y**3
          +15195*y**4+38721*y**5-47472*y**6+13016*y**7)-7*r**12*(68832-324552*y
          +621123*y**2-489083*y**3+43230*y**4+113238*y**5-22053*y**6-12043*y**7
          +2508*y**8)-21*r**6*(-1+y)**2*(-22944+29480*y-10281*y**2+61923*y**3
          -85713*y**4+37699*y**5-13375*y**6+12261*y**7-4743*y**8+493*y**9)+7*r**10*(
          -89622+269166*y-249771*y**2-208273*y**3+639925*y**4-495193*y**5+141339*y**6
          -6079*y**7-4007*y**8+1315*y**9)-r**4*(-1+y)**3*(336864-90264*y-14067*y**2
          -104230*y**3-477393*y**4+673316*y**5-197281*y**6+17322*y**7-16115*y**8
          +6248*y**9)+r**2*(-1+y)**4*(43149+37107*y+31065*y**2-25177*y**3-73689*y**4
          +27081*y**5-17357*y**6+47005*y**7-33608*y**8+6424*y**9)+7*r**8*(89622
          -447810*y+875025*y**2-1083765*y**3+1076935*y**4-742129*y**5+254385*y**6
          -20675*y**7+9715*y**8-15285*y**9+3982*y**10))+1440*logy**2*r**8*(-1+y)**4*(
          -1+r**2+y)**3*(1311*r**24*(-1+y)**6-r**22*(-1+y)**3*(11728-39117*y
          +46983*y**2-27361*y**3+13039*y**4)+r**20*(-19360+185799*y-645990*y**2
          +1106367*y**3-1075388*y**4+690709*y**5-350918*y**6+124453*y**7-15672*y**8)
          +(-1+y)**8*(-1311-6555*y-19665*y**2-28823*y**3-11937*y**4+39391*y**5
          -6135*y**6+3075*y**7-7592*y**8+3152*y**9)+r**18*(-2554704+13902579*y
          -30729162*y**2+34003931*y**3-17879764*y**4+2213017*y**5+1108134*y**6
          +217065*y**7-325928*y**8+44832*y**9)+r**16*(-7558429+39461937*y-83844099*y**2
          +88695907*y**3-44401875*y**4+5637411*y**5+2507033*y**6-948731*y**7+769268*y**8
          -333580*y**9+15158*y**10)-14*r**12*y*(1353105-5412420*y+10765668*y**2
          -13332591*y**3+9520203*y**4-2592925*y**5-1091425*y**6+1175587*y**7-511944*y**8
          +155697*y**9-32495*y**10+3540*y**11)+r**8*(-1+y)**3*(-7558429+5888637*y
          +89151*y**2+3086869*y**3+9763542*y**4-17363724*y**5+3746386*y**6+4159264*y**7
          -1954609*y**8+495223*y**9-115817*y**10+4307*y**11)-r**4*(-1+y)**5*(19360
          +108359*y+204753*y**2+1108312*y**3+225646*y**4+132442*y**5-4565416*y**6
          +5037712*y**7-2071462*y**8+313879*y**9-31337*y**10+4952*y**11)+r**2*(
          -1+y)**6*(-11728-39117*y-86100*y**2-464*y**3+35804*y**4+232502*y**5
          -146252*y**6-117400*y**7-556*y**8+131871*y**9-63264*y**10+8704*y**11)
          +2*r**10*(-1+y)**2*(700048-979555*y+2582826*y**2-19971073*y**3+32077996*y**4
          -21619521*y**5+11473126*y**6-7453991*y**7+2776448*y**8+193584*y**9-314052*y**10
          +38564*y**11)-r**6*(-1+y)**4*(-2554704-1129059*y-665886*y**2+3637341*y**3
          +2168448*y**4-3096864*y**5-92528*y**6-22264*y**7-388136*y**8+717547*y**9
          -355562*y**10+51267*y**11)-2*r**14*(700048-3920781*y+11406504*y**2
          -7247584*y**3-15979872*y**4+24440355*y**5-8188942*y**6-2543059*y**7
          +984484*y**8+701522*y**9-382558*y**10+57883*y**11))-12*logy*r**4*(-1
          +y)**3*(-1+r**2+y)**4*(-113*r**30*(-1+y)**7+r**28*(-1+y)**4*(15825-47927*y
          +48831*y**2-14781*y**3+4692*y**4)-r**26*(-1+y)**2*(-1114065+5319437*y
          -10044660*y**2+9489876*y**3-4740209*y**4+1232501*y**5-79546*y**6+11866*y**7)
          +r**24*(-2996495+19584813*y-52725201*y**2+72459603*y**3-47042375*y**4
          +1969785*y**5+15127857*y**6-6436959*y**7-714718*y**8+897830*y**9-79340*y**10)
          +r**22*(-24460755+177174213*y-545341611*y**2+922486621*y**3-960320822*y**4
          +692263130*y**5-403754934*y**6+192631706*y**7-56139351*y**8+4480417*y**9
          +793345*y**10-13559*y**11)-(-1+y)**10*(113+791*y+3164*y**2+13044*y**3
          +70934*y**4+173418*y**5-156388*y**6-283964*y**7+217681*y**8+18791*y**9
          -45856*y**10+10672*y**11)+r**20*(-433512819+2525252721*y-6020947575*y**2
          +7173403721*y**3-3709164494*y**4-559685006*y**5+1606972674*y**6-609836334*y**7
          -9485671*y**8+38951469*y**9+230725*y**10-2066795*y**11+268184*y**12)
          +r**2*(-1+y)**8*(-15825-79577*y-240087*y**2-253719*y**3+952230*y**4
          +2420310*y**5-4421086*y**6+1099394*y**7+3398043*y**8-3002605*y**9+567765*y**10
          +253813*y**11-132432*y**12+13776*y**13)+r**4*(-1+y)**7*(1114065+4205372*y
          +10044660*y**2+5758520*y**3-3785175*y**4-24613160*y**5+2920376*y**6
          +14861120*y**7+12250155*y**8-23115300*y**9+9629620*y**10-1421848*y**11
          -28805*y**12+20400*y**13)-r**6*(-1+y)**6*(-2996495-7598833*y-11949732*y**2
          -19485564*y**3-575275*y**4-11263125*y**5+62191736*y**6-37603896*y**7
          +31308483*y**8-29963875*y**9+10737420*y**10+1466772*y**11-1022697*y**12
          +67081*y**13)+r**14*(-1+y)**2*(-965147565+2059671649*y-415335690*y**2
          -5227470070*y**3+9618250325*y**4-8251428705*y**5+4430367652*y**6-1472930980*y**7
          -157077715*y**8+404564175*y**9-139468730*y**10+6815674*y**11+2830795*y**12
          +71185*y**13)-r**8*(-1+y)**5*(24460755+54870438*y+81252309*y**2+167169788*y**3
          -66182380*y**4-36166960*y**5-801764286*y**6+1210132752*y**7-579997181*y**8
          +75514430*y**9+13928505*y**10-24252*y**11-1269786*y**12+91868*y**13)
          +r**10*(-1+y)**4*(433512819-75824193*y-102623745*y**2-780305173*y**3
          +82990460*y**4+610220052*y**5+208587406*y**6-961966810*y**7+902394251*y**8
          -496979385*y**9+140193779*y**10-13346513*y**11-925370*y**12+200422*y**13)
          +r**18*(-504963955+2945438989*y-7301925033*y**2+9577490319*y**3-6888657050*y**4
          +2542025110*y**5-202188738*y**6-635768594*y**7+892430057*y**8-552219575*y**9
          +130305595*y**10-37101*y**11-2658348*y**12+280324*y**13)+r**12*(-1+y)**3*(
          -504963955+589308696*y-233534154*y**2+378577412*y**3+1103462655*y**4
          -2039223420*y**5-140724652*y**6+1277594248*y**7-328708229*y**8-273370880*y**9
          +143646550*y**10-18893644*y**11-807719*y**12+373092*y**13)+r**16*(965147565
          -5661508871*y+13021765967*y**2-17673285109*y**3+17495627118*y**4-10899160130*y**5
          -635998298*y**6+7359758086*y**7-5307914727*y**8+1316917429*y**9+123568915*y**10
          -119353281*y**11+12491772*y**12+1965636*y**13-22072*y**14))-(-1+y)*(
          -1+r**2+y)**5*(33*r**36*(-1+y)**9+r**34*(-1+y)**6*(1326-3813*y+3483*y**2
          -1481*y**3+325*y**4)+r**32*(-1+y)**4*(-20739+98586*y-181662*y**2+178851*y**3
          -112969*y**4+45790*y**5-10910*y**6+1229*y**7)+r**30*(-1+y)**2*(1145052
          -7726878*y+22134438*y**2-35089973*y**3+33960091*y**4-21171867*y**5
          +8800361*y**6-2416747*y**7+419777*y**8-28999*y**9+1625*y**10)-r**28*(
          -9433440+76968954*y-275647794*y**2+568109819*y**3-739873078*y**4+622565585*y**5
          -319204430*y**6+67505084*y**7+27510706*y**8-25045342*y**9+7275960*y**10
          -722399*y**11+300*y**12+2875*y**13)+r**26*(-98635356+812525070*y-2916821502*y**2
          +5936379429*y**3-7422246151*y**4+5703224337*y**5-2430762895*y**6+294459234*y**7
          +194082302*y**8-73205408*y**9-3846716*y**10+5646665*y**11-877867*y**12
          +137009*y**13-13351*y**14)-(-1+y)**12*(-33-264*y-1188*y**2-3630*y**3
          -14359*y**4-35464*y**5+20096*y**6+55132*y**7-52551*y**8-7040*y**9+23772*y**10
          -8382*y**11+1231*y**12+256*y**13+24*y**14)+r**18*(-1+y)**3*y*(-50431788
          +151295364*y+26593086723*y**2-74740175600*y**3+77017111330*y**4-32368104344*y**5
          +4017426977*y**6-2454556656*y**7+3829578560*y**8-2242688220*y**9+678748917*y**10
          -130089856*y**11+21851018*y**12-2574000*y**13+289575*y**14)+r**2*(-1
          +y)**11*(1326+9117*y+35808*y**2+94334*y**3+379546*y**4+808091*y**5
          -993984*y**6-1009700*y**7+1706194*y**8-362749*y**9-419136*y**10+229422*y**11
          -51578*y**12-923*y**13-192*y**14+24*y**15)+r**4*(-1+y)**10*(20739+119325*y
          +399573*y**2+708632*y**3+2930009*y**4+5766347*y**5-4926455*y**6-1277096*y**7
          +3055781*y**8-2339253*y**9+212439*y**10+268600*y**11-318257*y**12+40957*y**13
          -2661*y**14+520*y**15)+r**6*(-1+y)**9*(1145052+5436774*y+15552612*y**2
          +17774229*y**3+4677520*y**4-29087686*y**5+27144292*y**6-13210139*y**7
          -26571028*y**8+27309330*y**9-7906724*y**10-3599041*y**11+1081352*y**12
          -11026*y**13-28100*y**14+4583*y**15)-r**24*(-48834792+315058542*y-709782786*y**2
          +260462595*y**3+2373615998*y**4-7212817826*y**5+11728971866*y**6-12274049863*y**7
          +8278811020*y**8-3346748166*y**9+645397418*y**10+7759597*y**11-19245746*y**12
          +1656490*y**13-220402*y**14+10855*y**15)+r**8*(-1+y)**8*(-9433440-29801754*y
          -62106378*y**2+15573159*y**3+81652990*y**4+211109390*y**5-58322222*y**6
          -250530019*y**7-171508748*y**8+393866290*y**9-202989870*y**10+31719881*y**11
          -1703298*y**12+536394*y**13-165450*y**14+23075*y**15)+r**10*(-1+y)**7*(
          -98635356-220712934*y-333726492*y**2+11846743*y**3+271620932*y**4+238019352*y**5
          +208811824*y**6-1110033899*y**7+569108732*y**8+139376530*y**9-305905356*y**10
          +137348625*y**11-35509444*y**12+5363740*y**13-604072*y**14+75875*y**15)
          +r**20*(-1+y)**2*(3349472934-18230284860*y+37268094372*y**2-29926537099*y**3
          -15221885828*y**4+60118586762*y**5-63083274684*y**6+33483535393*y**7
          -8162597114*y**8+535480280*y**9-499315116*y**10+440971599*y**11-124487960*y**12
          +16795018*y**13-1316172*y**14+160875*y**15)+r**12*(-1+y)**6*(-48834792
          +26785002*y+155037834*y**2+1658248997*y**3-749322302*y**4-463689272*y**5
          -5951970374*y**6+8780400685*y**7-4061183548*y**8+438354858*y**9-211745258*y**10
          +242186327*y**11-91912814*y**12+15259956*y**13-1482026*y**14+173927*y**15)
          +r**14*(-1+y)**5*(-3319493268+2002379934*y+1365611940*y**2+7580002413*y**3
          -6227082808*y**4-3914115954*y**5-5066548148*y**6+17049738105*y**7-13990357716*y**8
          +5664861426*y**9-1618854228*y**10+407351679*y**11-107911680*y**12+22250818*y**13
          -2544828*y**14+286715*y**15)+r**16*(-1+y)**4*(-3349472934+5216025678*y
          +1774683174*y**2+2126963483*y**3-18412758380*y**4+14349812602*y**5+1762304114*y**6
          +1222303977*y**7-11084368566*y**8+9269491650*y**9-3435282942*y**10+650272533*y**11
          -100627976*y**12+22806758*y**13-3087370*y**14+342199*y**15)+r**22*(-3319493268
          +24553566210*y-77563540026*y**2+132351767557*y**3-120220786041*y**4
          +28362519210*y**5+62636429914*y**6-82996577571*y**7+51230394683*y**8
          -18860498146*y**9+4573652466*y**10-911976481*y**11+202981197*y**12-44055690*y**13
          +5822062*y**14-248833*y**15+42757*y**16))))/(3919104000*logy**5*r**20*(-1
          +y)**10-15750*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5
          +1632960000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+272160000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+22680000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +945000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((rhoLS*(-217728000*logy**5*r**20*(75+109*r**2+77*r**4
          +27*r**6)*(-1+y)**10+518400*logy**4*r**16*(-1+y)**6*(7381*r**14*(-1+y)**4
          +105*r**12*(-229+916*y-1374*y**2+1102*y**3-425*y**4+58*y**5)+35*r**2*(
          -1+y)**4*(1311-1356*y**3+727*y**4-256*y**5+8*y**6)-7*r**10*(13947
          -47688*y+55332*y**2-26548*y**3+2837*y**4-40*y**5+720*y**6)-35*r**8*(3065
          -7640*y+2220*y**2+6878*y**3-6073*y**4+1048*y**5+104*y**6+110*y**7)
          +(-1+y)**4*(1579+12810*y**3-19285*y**4+13776*y**5-5320*y**6+640*y**7)
          -35*r**6*(-313+7792*y-24768*y**2+29856*y**3-15044*y**4+1892*y**5+466*y**6
          -104*y**7+79*y**8)-7*r**4*(-23307+115728*y-218592*y**2+197518*y**3
          -87752*y**4+24142*y**5-14218*y**6+8492*y**7-2443*y**8+432*y**9))-17280*logy**3*r**12*(
          -1+y)**4*(-1+r**2+y)**2*(10549*r**18*(-1+y)**6-r**16*(-1+y)**2*(237427
          -928610*y+1340170*y**2-795380*y**3+116475*y**4+35078*y**5)-r**14*(
          -1+y)**2*(713608-2422468*y+2965005*y**2-1116220*y**3-110410*y**4+73392*y**5
          +17213*y**6)+r**12*(3483736-17907484*y+35965881*y**2-37807094*y**3
          +22325391*y**4-6661876*y**5+609239*y**6-165766*y**7+142409*y**8-9636*y**9)
          +r**2*(-1+y)**5*(-38029-22679*y-7329*y**2-324019*y**3+399901*y**4
          -280561*y**5-156191*y**6+209579*y**7-39136*y**8+864*y**9)+5*(-1+y)**6*(
          -1535-3070*y-4605*y**2+5584*y**3+9275*y**4+7702*y**5-58495*y**6+57128*y**7
          -21968*y**8+3264*y**9)-5*r**10*(-2328198+12020664*y-24609753*y**2+26340526*y**3
          -15983562*y**4+5288398*y**5-547016*y**6-396942*y**7+332136*y**8-127574*y**9
          +16361*y**10)-r**4*(-1+y)**3*(1221448-1350220*y+71715*y**2+407635*y**3
          -2385705*y**4+4546919*y**5-3506435*y**6+985845*y**7+272265*y**8-249555*y**9
          +36488*y**10)+r**6*(-1+y)**2*(5988392-15358340*y+12001605*y**2-8868660*y**3
          +16700600*y**4-18581004*y**5+10620790*y**6-3808140*y**7+1136240*y**8
          -328480*y**9+68597*y**10)+r**8*(14863566-76132596*y+155919915*y**2
          -169267290*y**3+113094880*y**4-57697032*y**5+28416562*y**6-11554800*y**7
          +2295930*y**8+235860*y**9-220869*y**10+45874*y**11))+288*logy**2*r**8*(
          -1+y)**3*(-1+r**2+y)**3*(-27231*r**24*(-1+y)**7+r**22*(-1+y)**3*(-248278
          +1074805*y-1816440*y**2+1442780*y**3-784030*y**4+252083*y**5)+r**20*(
          -3393634+24827731*y-77659569*y**2+134493641*y**3-141870539*y**4+96529869*y**5
          -45172191*y**6+15197439*y**7-3147091*y**8+194344*y**9)-5*r**18*(8128914
          -50605665*y+131489871*y**2-177860327*y**3+122030265*y**4-23114071*y**5
          -21109687*y**6+12118647*y**7-138195*y**8-1087672*y**9+147920*y**10)
          +5*r**16*(-5623667+31765790*y-77784492*y**2+92492150*y**3-42097106*y**4
          -14155194*y**5+28017894*y**6-23652748*y**7+17165145*y**8-7321704*y**9
          +1169266*y**10+24666*y**11)+5*r**6*(-1+y)**4*(6889182-2561427*y-1315443*y**2
          -505677*y**3-14657499*y**4+30725088*y**5-12107688*y**6-26998568*y**7
          +36436922*y**8-18893901*y**9+5000075*y**10-700155*y**11+16291*y**12)
          +5*r**8*(-1+y)**3*(-38458829+64324838*y-20427090*y**2+14823194*y**3
          +642865*y**4-55613022*y**5+62972730*y**6-16486590*y**7-18968789*y**8
          +16565160*y**9-3966664*y**10-60108*y**11+50705*y**12)+(-1+y)**7*(16929
          +50787*y+101574*y**2-159020*y**3-390620*y**4-530058*y**5+1351666*y**6
          -532348*y**7-411005*y**8-150505*y**9+767904*y**10-443528*y**11+76224*y**12)
          +r**2*(-1+y)**6*(-73882-198551*y-374007*y**2-566860*y**3+1387000*y**4
          +1465014*y**5-7926658*y**6+9140284*y**7-5104990*y**8+1274825*y**9+830993*y**10
          -654616*y**11+101448*y**12)-r**4*(-1+y)**5*(-2356994-1247927*y-931184*y**2
          +26772905*y**3-23227170*y**4+4087068*y**5-57298786*y**6+141227568*y**7
          -138947780*y**8+65476395*y**9-14182774*y**10+811063*y**11+153616*y**12)
          -2*r**10*(-1+y)**2*(-256379194+827937473*y-914943619*y**2+798557185*y**3
          -1192127315*y**4+1431231643*y**5-1053551361*y**6+480402403*y**7-119538835*y**8
          +1769940*y**9+9323876*y**10-2737412*y**11+303216*y**12)+2*r**14*(257922794
          -1468745513*y+3356703219*y**2-4080955880*y**3+2822609150*y**4-940206933*y**5
          -133930329*y**6+297650667*y**7-140140495*y**8+25711650*y**9+7841314*y**10
          -5658783*y**11+807139*y**12)+2*r**12*(498132402-2876292051*y+6772494321*y**2
          -8696081832*y**3+6866296455*y**4-3516245634*y**5+1046687412*y**6+93602008*y**7
          -375109346*y**8+278653945*y**9-116176993*y**10+27236164*y**11-3315179*y**12
          +118328*y**13))-12*logy*r**4*(-1+y)**2*(-1+r**2+y)**4*(1045*r**30*(-1
          +y)**8-r**28*(-1+y)**4*(-29911+123824*y-196186*y**2+101964*y**3-34151*y**4
          +14540*y**5)+r**26*(-1+y)**2*(5680033-32896934*y+78764905*y**2-100125248*y**3
          +72796501*y**4-30652542*y**5+6672935*y**6-526364*y**7+61114*y**8)+r**24*(
          -34625197+267382052*y-890845450*y**2+1675427916*y**3-1939031334*y**4
          +1403648944*y**5-614281296*y**6+150728240*y**7-25269221*y**8+10646284*y**9
          -3930542*y**10+284004*y**11)+r**22*(-99664679+763304264*y-2548465168*y**2
          +4734096480*y**3-5396872991*y**4+4176658256*y**5-2642983256*y**6+1556723312*y**7
          -689338565*y**8+147966056*y**9+665288*y**10-2685968*y**11-7829*y**12)
          -r**20*(1100887373-7220805172*y+19810500168*y**2-27863557552*y**3+17397519049*y**4
          +4456124248*y**5-16087214472*y**6+11893848168*y**7-3910452897*y**8+343141876*y**9
          +75429504*y**10+11690344*y**11-9079861*y**12+826824*y**13)+r**18*(872647093
          -5513601144*y+13396418594*y**2-15779089168*y**3+5512849615*y**4+10901418224*y**5
          -17581586632*y**6+8980396032*y**7+2090163331*y**8-4453007160*y**9+1736834458*y**10
          -108821424*y**11-65984551*y**12+10762112*y**13-743380*y**14)+(-1+y)**9*(
          -5477-27385*y-82155*y**2-32135*y**3+106446*y**4+111734*y**5-1582630*y**6
          -40190*y**7+2140135*y**8-1282237*y**9+311793*y**10-52635*y**11-880*y**12
          -24800*y**13+12416*y**14)+r**2*(-1+y)**8*(-165769-641168*y-1548150*y**2
          +1100760*y**3+4350501*y**4+5464608*y**5-20483524*y**6+9446960*y**7+14733345*y**8
          -12180112*y**9+1377786*y**10+369592*y**11+8515*y**12-86080*y**13+44736*y**14)
          +r**10*(-1+y)**4*(1553984051-1505647500*y-269264360*y**2-1746368900*y**3
          +1633657577*y**4+2231250848*y**5-1824670710*y**6-6637228360*y**7+12148786485*y**8
          -8452242124*y**9+2916760676*y**10-487626740*y**11+25771695*y**12+1269240*y**13
          +80122*y**14)+r**4*(-1+y)**7*(953887+2690237*y+5389152*y**2-225204*y**3
          -27517441*y**4-49057479*y**5+102180016*y**6-15287544*y**7-25728827*y**8
          -41351753*y**9+84157792*y**10-54953428*y**11+14919517*y**12-1428269*y**13
          +107344*y**14)+r**6*(-1+y)**6*(-9637757-19373302*y-29683881*y**2+44018592*y**3
          -43874181*y**4+7534954*y**5-186768201*y**6+625065312*y**7-743571519*y**8
          +300696462*y**9+107290253*y**10-142868672*y**11+47107969*y**12-5948098*y**13
          +396069*y**14)+r**8*(-1+y)**5*(-18317321-92804217*y-83383933*y**2-901802069*y**3
          +1341659440*y**4-646884188*y**5+1825233274*y**6-4679065754*y**7+5303718743*y**8
          -3042502225*y**9+943994959*y**10-186954257*y**11+37704962*y**12-7406874*y**13
          +729460*y**14)-r**14*(-1+y)**2*(-7569942159+30154378106*y-43910902649*y**2
          +46685788748*y**3-63568046743*y**4+76977192798*y**5-62339147337*y**6
          +30363606088*y**7-4491795621*y**8-3658161034*y**9+1986452861*y**10-241225044*y**11
          -51195189*y**12+6042098*y**13+907077*y**14)-r**12*(-1+y)**3*(3529434773
          -8049265029*y+5191244950*y**2-3662078890*y**3+2204910443*y**4+2596814749*y**5
          -2026440192*y**6-115096540*y**7-371530725*y**8+1454697989*y**9-1423772722*y**10
          +580001446*y**11-81647035*y**12-4653885*y**13+1092668*y**14)-r**16*(
          -13823252799+87848446940*y-230727008818*y**2+332336732596*y**3-285195963561*y**4
          +131534000320*y**5+8586429720*y**6-68235976544*y**7+58772577023*y**8
          -26695443268*y**9+5323289862*y**10+793627540*y**11-578345463*y**12+56180456*y**13
          +4431604*y**14+274392*y**15))+(-1+r**2+y)**5*(97*r**36*(-1+y)**10+r**34*(
          -1+y)**6*(-9076+35819*y-52516*y**2+36604*y**3-11796*y**4+1445*y**5)
          +r**32*(-1+y)**4*(241289-1415379*y+3420390*y**2-4483139*y**3+3516006*y**4
          -1706513*y**5+521430*y**6-96585*y**7+7973*y**8)+r**30*(-1+y)**2*(-7451808
          +58081442*y-196642714*y**2+378321075*y**3-457195592*y**4+365015398*y**5
          -198426304*y**6+74546500*y**7-19322112*y**8+3290832*y**9-317438*y**10
          +20081*y**11)+(-1+y)**13*(31+248*y+1116*y**2+19474*y**3+90345*y**4
          +217752*y**5+63456*y**6-177252*y**7+25465*y**8-46624*y**9-22788*y**10
          +28866*y**11+1231*y**12+256*y**13+24*y**14)+r**28*(-15646220+124027822*y
          -416573102*y**2+738247771*y**3-619157555*y**4-168976135*y**5+1145323421*y**6
          -1590473978*y**7+1314545574*y**8-716907304*y**9+253479020*y**10-53201793*y**11
          +5684265*y**12-346975*y**13+13589*y**14)+r**26*(502082560-4559526514*y
          +18306658818*y**2-42617803043*y**3+63101419216*y**4-60824076832*y**5
          +36639960550*y**6-11022737761*y**7-1245519904*y**8+2518616870*y**9-912296930*y**10
          +101504699*y**11+14977648*y**12-3923028*y**13+579034*y**14-49783*y**15)
          +r**2*(-1+y)**11*(6020+36275*y+127505*y**2-267374*y**3-1334490*y**4
          -1976655*y**5+5912575*y**6+3176196*y**7-7349856*y**8+3159701*y**9-847889*y**10
          -387374*y**11+470174*y**12-52345*y**13-511*y**14+24*y**15+24*y**16)
          +r**4*(-1+y)**10*(25225+161594*y+557862*y**2-4180657*y**3-11334009*y**4
          -13796110*y**5+25975852*y**6-331141*y**7-11415681*y**8+4661030*y**9
          -1392506*y**10-1119195*y**11+2638729*y**12-1520562*y**13+477704*y**14
          -26959*y**15+1224*y**16)+r**6*(-1+y)**9*(-2925504-9874382*y-21316012*y**2
          -6875819*y**3+43190221*y**4+96267310*y**5-239281964*y**6+101753081*y**7
          +193747213*y**8-157838474*y**9-12017372*y**10+34541303*y**11-1039289*y**12
          -6985814*y**13+3040308*y**14-287429*y**15+14623*y**16)+r**8*(-1+y)**8*(10497140
          +32844662*y+70863914*y**2-27605323*y**3-131117259*y**4-231096664*y**5
          +678177646*y**6-174845785*y**7+273310461*y**8-883613730*y**9+1044136702*y**10
          -673603597*y**11+237858271*y**12-50916188*y**13+11259914*y**14-1437103*y**15
          +86939*y**16)-r**24*(812999388-7276856314*y+28309492498*y**2-63709377703*y**3
          +90200861729*y**4-75921186184*y**5+18878109038*y**6+39677624971*y**7
          -57390511039*y**8+37305945230*y**9-12561959770*y**10+1433380015*y**11
          +347793731*y**12-119336908*y**13+14676666*y**14-1909459*y**15+119711*y**16)
          +r**10*(-1+y)**7*(-7675424+46463294*y+98648508*y**2+545779599*y**3
          -984376665*y**4+488620720*y**5+353074478*y**6+4608182957*y**7-8529552987*y**8
          +4104813174*y**9+1749641584*y**10-2707237943*y**11+1146694145*y**12-233799652*y**13
          +35170726*y**14-4458245*y**15+315731*y**16)+r**20*(-1+y)**2*(-25727739010
          +161649919454*y-411883006870*y**2+527797006837*y**3-250280302527*y**4
          -261496833714*y**5+553560923908*y**6-449092558335*y**7+194391754047*y**8
          -43496853454*y**9+7409594506*y**10-4409300729*y**11+2087413175*y**12
          -461932414*y**13+54951176*y**14-4758237*y**15+506187*y**16)+r**12*(-1
          +y)**6*(-679911516-483540686*y-71827186*y**2-4287474553*y**3+9262847027*y**4
          -4442299882*y**5+14321363472*y**6-29728830097*y**7+28646661509*y**8-16619177274*y**9
          +8332350534*y**10-4772720667*y**11+2104498573*y**12-536113966*y**13+81159612*y**14
          -9541371*y**15+764471*y**16)+r**18*(-1+y)**3*(32220327720-144129962876*y
          +238471811198*y**2-271672562301*y**3+388291630467*y**4-509565319218*y**5
          +414951818032*y**6-190922490415*y**7+53939628137*y**8-28109158760*y**9
          +26216102454*y**10-13583104059*y**11+3625884517*y**12-634715786*y**13
          +99279868*y**14-12101881*y**15+1156903*y**16)+r**14*(-1+y)**5*(9662267936
          -15444621862*y+2108712284*y**2-17483558739*y**3+37479470277*y**4-11947803158*y**5
          +4714628584*y**6-65738206427*y**7+117615622353*y**8-89746505930*y**9
          +36007588756*y**10-9447538265*y**11+2515586343*y**12-699822714*y**13
          +123522728*y**14-14690809*y**15+1281443*y**16)+r**16*(-1+y)**4*(-4127299586
          +13613799044*y-19515058734*y**2+14406770137*y**3+28105637247*y**4-56214652146*y**5
          +16334383378*y**6-16925512253*y**7+81381164991*y**8-95150732968*y**9
          +52384171102*y**10-16157860305*y**11+3265934597*y**12-669807018*y**13
          +127834206*y**14-16231435*y**15+1491743*y**16)+r**22*(10024547072-83822962870*y
          +305306143850*y**2-622655842043*y**3+736168433432*y**4-396103213907*y**5
          -195573088658*y**6+565286303561*y**7-523133532268*y**8+280566864037*y**9
          -91339577306*y**10+16587938287*y**11-1479555856*y**12+245525911*y**13
          -85074494*y**14+6357891*y**15+721316*y**16+12045*y**17))))/(-41803776000*logy**5*r**20*(
          -1+y)**10+168000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-17418240000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-2903040000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          -241920000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**3-10080000*logy*(-1+y)**2*(-(r**9*(-1
          +y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(
          -4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*muWC**2*(217728000*logy**5*r**20*(
          -12-5*r**2+14*r**4+27*r**6)*(-1+y)**10+518400*logy**4*r**16*(-1+y)**6*(1691*r**14*(
          -1+y)**4+42*r**12*(409-1636*y+2454*y**2-1501*y**3+299*y**4+35*y**5)
          -7*r**2*(-1+y)**4*(-1131-210*y**3+1745*y**4-704*y**5+40*y**6)+7*r**10*(5013
          -11952*y+1728*y**2+18818*y**3-17617*y**4+4550*y**5+180*y**6)+70*r**8*(
          -632+2948*y-5262*y**2+4546*y**3-1670*y**4+161*y**5-74*y**6+55*y**7)
          -4*(-1+y)**4*(-356-1050*y**3+665*y**4+756*y**5-700*y**6+160*y**7)
          +35*r**6*(-937+3448*y-4572*y**2+1716*y**3+2548*y**4-3910*y**5+2494*y**6
          -830*y**7+115*y**8)+14*r**4*(981-5724*y+12186*y**2-13579*y**3+9326*y**4
          -3826*y**5-236*y**6+1609*y**7-881*y**8+144*y**9))-17280*logy**3*r**12*(
          -1+y)**4*(-1+r**2+y)**2*(5891*r**18*(-1+y)**6-2*r**16*(-1+y)**2*(25648
          -96701*y+130324*y**2-58136*y**3-12696*y**4+12851*y**5)-r**14*(-1+y)**2*(680648
          -2610482*y+3719235*y**2-2296520*y**3+649210*y**4-110718*y**5+28687*y**6)
          +2*r**12*(-860120+4653173*y-10329669*y**2+11156299*y**3-5319903*y**4
          +163355*y**5+601907*y**6+28679*y**7-117499*y**8+17478*y**9)-r**2*(-1
          +y)**4*(-27275+1696*y+1696*y**2-8624*y**3-126074*y**4+348176*y**5
          -99656*y**6-238456*y**7+184689*y**8-43336*y**9+864*y**10)-4*(-1+y)**5*(
          -212-212*y-212*y**2+3043*y**3-7052*y**4+8852*y**5+1432*y**6-31368*y**7
          +41852*y**8-21778*y**9+4080*y**10)+r**10*(-2571342+11378238*y-19100907*y**2
          +10084088*y**3+8916528*y**4-14892268*y**5+8151182*y**6-2575128*y**7
          +766422*y**8-179698*y**9+10285*y**10)+2*r**4*(-1+y)**3*(-222904+281917*y
          -41448*y**2-515608*y**3+1193802*y**4-850070*y**5-21772*y**6+121908*y**7
          +103008*y**8-78087*y**9+13504*y**10)-r**6*(-1+y)**2*(-880456+2108242*y
          -1608663*y**2+390432*y**3+2476532*y**4-4736796*y**5+3107758*y**6-485832*y**7
          -140272*y**8-32542*y**9+22097*y**10)-2*r**8*(-320472+1959597*y-5011200*y**2
          +8766135*y**3-11057290*y**4+8390244*y**5-2762464*y**6-309960*y**7+276030*y**8
          +193305*y**9-151632*y**10+27707*y**11))-288*logy**2*r**8*(-1+y)**3*(-1
          +r**2+y)**3*(3369*r**24*(-1+y)**7-r**22*(-1+y)**3*(-164597+668495*y
          -1028010*y**2+727720*y**3-327845*y**4+84697*y**5)-r**20*(683629-4228921*y
          +11011239*y**2-16121801*y**3+14612069*y**4-7958139*y**5+1849401*y**6
          +366081*y**7-216314*y**8+2756*y**9)+5*r**18*(4795863-31425504*y+86942280*y**2
          -130009774*y**3+111445692*y**4-53161640*y**5+12812368*y**6-2513166*y**7
          +1732233*y**8-689708*y**9+71356*y**10)-10*r**16*(-7997999+49855355*y
          -130656756*y**2+183026174*y**3-145209563*y**4+64031853*y**5-14984823*y**6
          +2388221*y**7-320814*y**8-235512*y**9+97171*y**10+6693*y**11)+4*(-1
          +y)**7*(-4389-13167*y-26334*y**2+13165*y**3+100435*y**4+116448*y**5
          -397346*y**6+308678*y**7-116540*y**8-80710*y**9+174516*y**10-99062*y**11
          +19056*y**12)+5*r**8*(-1+y)**3*(12151693-22130380*y+8709276*y**2+28153412*y**3
          -87501605*y**4+89053992*y**5-27695580*y**6-7362552*y**7+2758723*y**8
          +975720*y**9+518240*y**10-361200*y**11+35261*y**12)-5*r**6*(-1+y)**4*(2373153
          -1049058*y-390678*y**2+3582240*y**3-2772801*y**4-7861992*y**5+3399732*y**6
          +14537852*y**7-15447065*y**8+4587006*y**9+342094*y**10-453624*y**11
          +68741*y**12)+r**2*(-1+y)**6*(-111037-169406*y-175107*y**2+247250*y**3
          +2993800*y**4-1087206*y**5-9035128*y**6+15909634*y**7-10345375*y**8
          +938600*y**9+2006543*y**10-840016*y**11+101448*y**12)-r**4*(-1+y)**5*(256291
          -176792*y-428219*y**2-1473010*y**3-4597470*y**4+5726028*y**5+12235874*y**6
          -5976432*y**7-17087165*y**8+15888120*y**9-3610519*y**10-610682*y**11
          +189976*y**12)+2*r**10*(-1+y)**2*(-18777851+50605762*y-58958036*y**2
          +138181250*y**3-124029700*y**4-56978698*y**5+95408646*y**6+15506702*y**7
          -51422225*y**8+11829450*y**9+6516424*y**10-2762758*y**11+257034*y**12)
          -2*r**14*(-45832589+255323318*y-593800599*y**2+603625460*y**3-55500875*y**4
          -426847512*y**5+367844784*y**6-113892492*y**7+15431815*y**8-16147200*y**9
          +12861401*y**10-3677202*y**11+415691*y**12)+r**12*(96684234-357934002*y
          +311964012*y**2+863689176*y**3-2581799280*y**4+2874926172*y**5-1565703336*y**6
          +359416256*y**7+40633598*y**8-69788170*y**9+38617144*y**10-13033612*y**11
          +2611532*y**12-283724*y**13))+12*logy*r**4*(-1+y)**2*(-1+r**2+y)**4*(
          -251*r**30*(-1+y)**8-2*r**28*(-1+y)**4*(-4943+19270*y-27650*y**2+26460*y**3
          -9055*y**4+898*y**5)-r**26*(-1+y)**2*(1259537-7356970*y+17774909*y**2
          -22915828*y**3+17271257*y**4-7979850*y**5+2107627*y**6-309352*y**7+35870*y**8)
          -4*r**24*(1987048-15130694*y+50334448*y**2-96297573*y**3+118942878*y**4
          -101542300*y**5+61876344*y**6-25993808*y**7+6230978*y**8-170458*y**9
          -240088*y**10+20025*y**11)+r**22*(63854821-514922752*y+1795212200*y**2
          -3512489244*y**3+4286056633*y**4-3518026432*y**5+2124220096*y**6-1022915176*y**7
          +378326239*y**8-88057888*y**9+9147656*y**10-126524*y**11+22771*y**12)
          +2*r**20*(405122165-2795225494*y+8186297112*y**2-12990106354*y**3+11611501069*y**4
          -5101344896*y**5+95750712*y**6+765859920*y**7-70947153*y**8-162481694*y**9
          +58930656*y**10-2894918*y**11-819457*y**12+72732*y**13)+4*(-1+y)**9*(
          -617-3085*y-9255*y**2-17009*y**3-53346*y**4-51406*y**5+318650*y**6
          -71300*y**7-342437*y**8+338267*y**9-160227*y**10+45585*y**11+10280*y**12
          -14204*y**13+3104*y**14)+r**18*(1106445223-7361995932*y+21043835378*y**2
          -32827418212*y**3+30090453553*y**4-16706984176*y**5+5667596264*y**6-171780456*y**7
          -2359414751*y**8+2419475124*y**9-1127717222*y**10+248360268*y**11-21390697*y**12
          +1196888*y**13+10748*y**14)+4*r**8*(-1+y)**5*(-1737254+10065876*y+13151996*y**2
          +72416851*y**3+11919391*y**4-138624977*y**5-205990517*y**6+519611518*y**7
          -266641792*y**8-41105302*y**9+63170806*y**10-13227209*y**11-570889*y**12
          +131091*y**13+19411*y**14)+2*r**4*(-1+y)**7*(-575059-1423211*y-2465502*y**2
          +6385326*y**3-2869865*y**4+6297963*y**5+2852492*y**6-28895616*y**7+6155903*y**8
          +18853955*y**9-2551654*y**10-8960006*y**11+3902693*y**12-489979*y**13
          +30560*y**14)+r**6*(-1+y)**6*(-11059217-12792118*y-10191429*y**2+98003292*y**3
          +56722995*y**4-62975906*y**5-419287449*y**6+829361928*y**7-614850099*y**8
          +98404230*y**9+123010673*y**10-75721508*y**11+13616401*y**12-579118*y**13
          +41325*y**14)+r**2*(-1+y)**8*(57221+238756*y+621570*y**2+278004*y**3
          -4776549*y**4-6707832*y**5+23039948*y**6-16896760*y**7-4382973*y**8
          +18369188*y**9-13642014*y**10+3292996*y**11+553165*y**12-397456*y**13
          +44736*y**14)+2*r**12*(-1+y)**3*(692437271-1499735469*y+887061760*y**2
          +732120854*y**3-4442490139*y**4+6728776513*y**5-3027570042*y**6-1485078580*y**7
          +1846070457*y**8-414893227*y**9-74983084*y**10+8424286*y**11+8816795*y**12
          -2584761*y**13+311366*y**14)+r**10*(-1+y)**4*(-462987547+550140264*y
          +56311684*y**2-890907068*y**3+1580343071*y**4-230368996*y**5-146459238*y**6
          -1281867448*y**7+1435052451*y**8-297422752*y**9-206528032*y**10+93622324*y**11
          -11779911*y**12-1644708*y**13+331906*y**14)+r**14*(-1+y)**2*(1979036199
          -6080300474*y+4835892017*y**2+7989336364*y**3-17140162265*y**4+11819635722*y**5
          -5298918087*y**6+2950569896*y**7-207898083*y**8-1404566630*y**9+1010376379*y**10
          -309108564*y**11+40634037*y**12-2075306*y**13+444795*y**14)+4*r**16*(19415001
          +210608368*y-1483762922*y**2+5538801812*y**3-12308012979*y**4+15577945868*y**5
          -10335007596*y**6+2019361904*y**7+1731165361*y**8-1135026452*y**9+60622386*y**10
          +145673978*y**11-44336307*y**12+1779652*y**13+766256*y**14+5670*y**15))
          -(-1+r**2+y)**5*(r**36*(-1+y)**10-r**34*(-1+y)**6*(-251+1009*y-1526*y**2
          +1664*y**3-891*y**4+235*y**5)-r**32*(-1+y)**4*(7594-47316*y+122901*y**2
          -194266*y**3+203607*y**4-135112*y**5+59403*y**6-16218*y**7+2143*y**8)
          -r**30*(-1+y)**2*(-241506+2010958*y-7324373*y**2+14792181*y**3-18449380*y**4
          +15762830*y**5-10307774*y**6+5411216*y**7-2203242*y**8+592620*y**9-91453*y**10
          +7603*y**11)+r**28*(25859890-244770896*y+1034341399*y**2-2577836096*y**3
          +4218221866*y**4-4772504812*y**5+3818106071*y**6-2153719448*y**7+823981182*y**8
          -189310384*y**9+14209877*y**10+4760760*y**11-1564986*y**12+217484*y**13
          -11107*y**14)+4*(-1+y)**13*(10+80*y+360*y**2+1288*y**3-3231*y**4
          -21732*y**5+1716*y**6+19854*y**7-24074*y**8+2852*y**9+8292*y**10-3726*y**11
          +1231*y**12+256*y**13+24*y**14)+r**2*(-1+y)**12*(1873+12911*y+50844*y**2
          +157562*y**3-543271*y**4-2532835*y**5+1424296*y**6+1807756*y**7-3054029*y**8
          +1270673*y**9+308548*y**10-350622*y**11+168835*y**12+227*y**13+408*y**14
          +24*y**15)+r**26*(-90955922+889466078*y-3858576981*y**2+9796716877*y**3
          -16128690242*y**4+18010076900*y**5-13862553689*y**6+7339423919*y**7-2656978318*y**8
          +697236998*y**9-175431863*y**10+46716131*y**11-5654078*y**12-844584*y**13
          +111109*y**14+4865*y**15)+r**4*(-1+y)**10*(-198917-955804*y-2766477*y**2
          -4959634*y**3+5750883*y**4+21350120*y**5-24610853*y**6+11890274*y**7
          +1768257*y**8-18593788*y**9+6468913*y**10+7840914*y**11-4258247*y**12
          +225552*y**13+311105*y**14-1666*y**15+168*y**16)-r**6*(-1+y)**9*(703950
          +2546648*y+5510581*y**2+30267038*y**3+16799651*y**4-9731194*y**5-158621113*y**6
          +153235048*y**7+52456973*y**8-202724524*y**9+192365435*y**10-86916482*y**11
          +9132461*y**12+3457454*y**13-1435287*y**14+8924*y**15+437*y**16)-r**8*(
          -1+y)**8*(23879470+54586396*y+86583679*y**2-36724670*y**3+53843373*y**4
          -244265060*y**5-391972561*y**6+1552274422*y**7-588826059*y**8-961560084*y**9
          +777423413*y**10-112772042*y**11-53070601*y**12+12549404*y**13-2423939*y**14
          -21998*y**15+8857*y**16)-r**20*(-1+y)**2*(-2702890388+18391639684*y
          -49036631129*y**2+66367474310*y**3-30483902541*y**4-49642202136*y**5
          +101700141071*y**6-80287307286*y**7+27480744699*y**8+877860004*y**9-3277802659*y**10
          +600430874*y**11+80377825*y**12-19011824*y**13-1101203*y**14+720918*y**15
          +11781*y**16)+r**24*(-393284394+3601272556*y-14646920197*y**2+34354596346*y**3
          -51583793687*y**4+53714749276*y**5-43816035173*y**6+32957376734*y**7
          -23442018863*y**8+13303690972*y**9-5033275943*y**10+1081506494*y**11
          -97576037*y**12-803108*y**13+857265*y**14-453014*y**15+43573*y**16)
          -r**10*(-1+y)**7*(259191746+283327552*y+234361743*y**2-1394660442*y**3
          +198950883*y**4+210012626*y**5+3157968481*y**6-4083983720*y**7+3038897769*y**8
          -1883146932*y**9+512654993*y**10+134959694*y**11-104301443*y**12-29822*y**13
          -186721*y**14-252460*y**15+44053*y**16)-r**12*(-1+y)**6*(877263810-267027172*y
          -543135443*y**2-6416378630*y**3+5237976973*y**4+4670421616*y**5+9315773421*y**6
          -26175704426*y**7+17686737169*y**8-2666371476*y**9-1044081201*y**10+84160326*y**11
          +118710239*y**12-57770744*y**13+6860823*y**14-828630*y**15+121345*y**16)
          -r**18*(-1+y)**3*(-3870077820+15875656172*y-22502537927*y**2-36941169030*y**3
          +156310715541*y**4-200779888470*y**5+121099660103*y**6-27547351376*y**7
          -4959388733*y**8+2183368712*y**9+1056826311*y**10-303661614*y**11-72801397*y**12
          +25155938*y**13+1744697*y**14-427196*y**15+144089*y**16)-r**14*(-1+y)**5*(6007539910
          -8797878632*y-154421531*y**2-3251443002*y**3+6093424239*y**4+5177228582*y**5
          +1729798151*y**6-22282156648*y**7+23650331361*y**8-10059543004*y**9+2864273627*y**10
          -1173957418*y**11+362379729*y**12-84108834*y**13+12659065*y**14-1465844*y**15
          +210649*y**16)-r**16*(-1+y)**4*(4046852054-8668178468*y-246646833*y**2
          -3731063014*y**3+58458307977*y**4-89943865620*y**5+39738959831*y**6+5565673166*y**7
          +1431271881*y**8-12283759748*y**9+7974800357*y**10-2008689906*y**11+177706747*y**12
          -17340612*y**13+9319701*y**14-1428086*y**15+232573*y**16)+r**22*(-4919381494
          +41105733566*y-149971963537*y**2+309571052131*y**3-384939849121*y**4
          +266466188329*y**5-38845340645*y**6-111893721061*y**7+120914934815*y**8
          -64975087931*y**9+21847484941*y**10-5408883791*y**11+1309094285*y**12
          -293403821*y**13+32001577*y**14+2141649*y**15-1058005*y**16+58113*y**17))))/(
          -15676416000*logy**5*r**20*(-1+y)**10+63000*(r**8*(-1+y)**2-6*r**4*y*(2
          -3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)
          -(-1+y)**3*(-1-y-y**2+y**3))**5-6531840000*logy**4*r**16*(-1+y)**8*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-1088640000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          -90720000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**3-3780000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2
          -3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)
          +r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((mupi*(-217728000*logy**5*r**20*(3
          +5*r**2+13*r**4+27*r**6)*(-1+y)**10+518400*logy**4*r**16*(-1+y)**6*(881*r**14*(
          -1+y)**4+21*r**12*(-981+3924*y-5886*y**2+3894*y**3-1321*y**4+130*y**5)
          -7*r**2*(-1+y)**4*(297+4380*y**3-4975*y**4+1408*y**5+40*y**6)-35*r**10*(1035
          -2520*y+540*y**2+3404*y**3-2827*y**4+584*y**5+72*y**6)-35*r**8*(-1043
          +4952*y-8988*y**2+7774*y**3-2525*y**4+248*y**5-272*y**6+142*y**7)
          +5*(-1+y)**4*(283-1134*y**3-1141*y**4+3024*y**5-1624*y**6+256*y**7)
          -35*r**6*(-389+1856*y-3384*y**2+1968*y**3+2132*y**4-3644*y**5+2114*y**6
          -568*y**7+59*y**8)-7*r**4*(-927+4608*y-8712*y**2+3038*y**3+7088*y**4
          -3778*y**5-6458*y**6+7852*y**7-3143*y**8+432*y**9))-17280*logy**3*r**12*(
          -1+y)**4*(-1+r**2+y)**2*(-2719*r**18*(-1+y)**6+r**16*(-1+y)**2*(-26855
          +112858*y-182882*y**2+149728*y**3-59367*y**4+11678*y**5)+r**14*(-1
          +y)**2*(350704-1449388*y+2229495*y**2-1603300*y**3+747230*y**4-166824*y**5
          +12203*y**6)+r**12*(1995008-10351628*y+21459501*y**2-21310870*y**3
          +10101039*y**4-2123588*y**5+433483*y**6-324926*y**7+164425*y**8-17244*y**9)
          +r**10*(3260622-15221928*y+27304137*y**2-19296718*y**3-20898*y**4+5947058*y**5
          -2935192*y**6+2054478*y**7-1489332*y**8+471158*y**9-48185*y**10)-r**2*(
          -1+y)**4*(-74897+14734*y+14734*y**2+185974*y**3+397684*y**4-998662*y**5
          +332626*y**6+283826*y**7-127539*y**8-33424*y**9+17544*y**10)+(-1+y)**5*(7367
          +7367*y+7367*y**2-51673*y**3-58723*y**4+51373*y**5+340613*y**6-690987*y**7
          +555328*y**8-213272*y**9+32640*y**10)-r**4*(-1+y)**3*(118976-153716*y
          +62799*y**2-2332921*y**3+3655719*y**4+51847*y**5-2698879*y**6+1131441*y**7
          +311721*y**8-245259*y**9+35272*y**10)+r**6*(-1+y)**2*(-315440+913772*y
          -712383*y**2-3767988*y**3+14254132*y**4-17248548*y**5+9433178*y**6-2586732*y**7
          +790708*y**8-394952*y**9+75253*y**10)+r**8*(600174-3447684*y+7734735*y**2
          -6070050*y**3+1145540*y**4-4639368*y**5+9876938*y**6-7016100*y**7+1742310*y**8
          +248220*y**9-201921*y**10+27206*y**11))+288*logy**2*r**8*(-1+y)**3*(-1
          +r**2+y)**3*(-12927*r**24*(-1+y)**7+r**22*(-1+y)**3*(153274-574315*y
          +764520*y**2-340280*y**3+49690*y**4+26191*y**5)+r**20*(-1657658+11535227*y
          -34499313*y**2+58528957*y**3-61950463*y**4+42407733*y**5-19323207*y**6
          +6398403*y**7-1669247*y**8+229568*y**9)+5*r**18*(1927614-13479159*y
          +39989337*y**2-65820269*y**3+67240299*y**4-46044937*y**5+22310087*y**6
          -7699539*y**7+1835487*y**8-267136*y**9+8216*y**10)-5*r**16*(-9316709
          +58360322*y-152708916*y**2+214484678*y**3-181544906*y**4+106009554*y**5
          -50548158*y**6+19920176*y**7-6437253*y**8+2366496*y**9-657530*y**10
          +72246*y**11)+5*r**6*(-1+y)**4*(2917806-2178819*y-608163*y**2-20074161*y**3
          +9952281*y**4+31519920*y**5-15812472*y**6-29286496*y**7+31991746*y**8
          -12491061*y**9+2535139*y**10-313239*y**11+16319*y**12)+2*r**14*(81164458
          -441334201*y+957691923*y**2-927439600*y**3+241986070*y**4+247391619*y**5
          -246250113*y**6+143096739*y**7-83776775*y**8+36538830*y**9-9461602*y**10
          +747789*y**11+36863*y**12)+5*r**8*(-1+y)**3*(1628099-3919562*y+20094*y**2
          +65299978*y**3-154973191*y**4+96726186*y**5+7939170*y**6-13486470*y**7
          -12824173*y**8+9300936*y**9-796640*y**10-362028*y**11+57601*y**12)-2*r**10*(
          -1+y)**2*(27054982-76017479*y+64480357*y**2+61945985*y**3-532676635*y**4
          +919420151*y**5-687206997*y**6+252893351*y**7-50612135*y**8+15084060*y**9
          -5418308*y**10+236276*y**11+64392*y**12)+r**2*(-1+y)**6*(-397994-749647*y
          -1054959*y**2+1779040*y**3+6531620*y**4+776058*y**5-23751566*y**6+32252048*y**7
          -18938090*y**8+3863605*y**9+1086061*y**10-600512*y**11+72336*y**12)
          +(-1+y)**7*(-15447-46341*y-92682*y**2+46040*y**3+412820*y**4+414954*y**5
          -1725958*y**6+1648384*y**7-634165*y**8-966845*y**9+1604568*y**10-839776*y**11
          +152448*y**12)-r**4*(-1+y)**5*(802982+981401*y+589472*y**2+10607365*y**3
          -22434930*y**4+10053996*y**5-45996122*y**6+132094056*y**7-140811940*y**8
          +67556355*y**9-12399278*y**10-677029*y**11+305672*y**12)+2*r**12*(96684234
          -500010027*y+1022344137*y**2-835010064*y**3-51482085*y**4+475382802*y**5
          -293824896*y**6+201758756*y**7-197402662*y**8+107402585*y**9-31485161*y**10
          +6726548*y**11-1172143*y**12+87976*y**13))-12*logy*r**4*(-1+y)**2*(-1
          +r**2+y)**4*(-163*r**30*(-1+y)**8-r**28*(-1+y)**4*(-67247+268336*y
          -400874*y**2+296676*y**3-94639*y**4+17668*y**5)-r**26*(-1+y)**2*(-823121
          +4586566*y-10542473*y**2+12771952*y**3-8147741*y**4+1958430*y**5+279113*y**6
          -344468*y**7+36142*y**8)+r**24*(-24885869+188789476*y-619605626*y**2
          +1145934996*y**3-1310048958*y**4+959374880*y**5-455536536*y**6+143256016*y**7
          -32681101*y**8+6201308*y**9-1010806*y**10+77820*y**11)+r**22*(54327377
          -424940600*y+1422876928*y**2-2621493792*y**3+2923690937*y**4-2078301008*y**5
          +960386000*y**6-256670432*y**7+10339307*y**8+5743528*y**9+7234096*y**10
          -2673760*y**11+86219*y**12)+r**20*(319950203-2304605356*y+7106587560*y**2
          -12377371528*y**3+13798299631*y**4-10956941120*y**5+6882975888*y**6-3586987344*y**7
          +1517263377*y**8-504615356*y**9+119560392*y**10-18472232*y**11+3727109*y**12
          -513624*y**13)+r**18*(697998581-4372783032*y+11345578690*y**2-15016590368*y**3
          +10782464999*y**4-5121921872*y**5+3102550984*y**6-1644300480*y**7-134233549*y**8
          +505001352*y**9-207858934*y**10+105692448*y**11-50645135*y**12+11209792*y**13
          -819476*y**14)+(-1+y)**9*(-4597-22985*y-68955*y**2-113551*y**3-282738*y**4
          -277466*y**5+1252330*y**6+36290*y**7-851833*y**8+604531*y**9-879087*y**10
          +728205*y**11-119360*y**12-81616*y**13+24832*y**14)+r**2*(-1+y)**8*(66967
          +286256*y+761610*y**2+515112*y**3-5935251*y**4-9011424*y**5+25555708*y**6
          -17232080*y**7-1869999*y**8+17536432*y**9-16572918*y**10+5644136*y**11
          -52405*y**12-356288*y**13+48144*y**14)+r**4*(-1+y)**7*(1041959+3581077*y
          +7655856*y**2+12682884*y**3-40110545*y**4-37292103*y**5+94010576*y**6
          -79760232*y**7+16790717*y**8-30680545*y**9+88028144*y**10-68994428*y**11
          +19789901*y**12-1812301*y**13+61040*y**14)+r**10*(-1+y)**4*(374563363
          -427730508*y+32224712*y**2-3814858420*y**3+5750573041*y**4+1120950784*y**5
          -1497816414*y**6-6075397544*y**7+8463188085*y**8-4792966412*y**9+1498463428*y**10
          -273376228*y**11+13703607*y**12+87960*y**13+62546*y**14)+r**12*(-1+y)**3*(1254857219
          -2716123923*y+1079718490*y**2+4764818114*y**3-15595304827*y**4+17487047827*y**5
          -6414783864*y**6-1685357620*y**7+2565374397*y**8-1493560861*y**9+951119954*y**10
          -453923438*y**11+89524955*y**12-6796611*y**13+126188*y**14)+r**6*(-1
          +y)**6*(-13128949-11777222*y-7330161*y**2+218614080*y**3+56715123*y**4
          -93888262*y**5-1058939481*y**6+1958110752*y**7-1436437335*y**8+380625534*y**9
          +123917461*y**10-123631072*y**11+34701209*y**12-4427570*y**13+283893*y**14)
          +r**8*(-1+y)**5*(-87280297-10702041*y+26070355*y**2+321582371*y**3
          +795411632*y**4-1199046076*y**5+648867842*y**6-1878798970*y**7+3237255463*y**8
          -2295377249*y**9+690124223*y**10-63959401*y**11-830510*y**12-3036234*y**13
          +430892*y**14)+r**14*(-1+y)**2*(1062629703-3086143306*y+2246762017*y**2
          +1542269588*y**3+10256836655*y**4-29969765646*y**5+27447552897*y**6-11808756104*y**7
          +3531763629*y**8-1124207590*y**9+388654043*y**10-179363916*y**11+69313437*y**12
          -12429442*y**13+676035*y**14)+r**16*(3050762703-18195102364*y+44179721138*y**2
          -47774738732*y**3+7042632849*y**4+39439205200*y**5-51890575272*y**6+40142164384*y**7
          -24153695551*y**8+10794284852*y**9-3095066454*y**10+436625236*y**11+40844703*y**12
          -17341192*y**13+166924*y**14+111576*y**15))+(-1+r**2+y)**5*(101*r**36*(
          -1+y)**10+r**34*(-1+y)**6*(-3476+13399*y-18836*y**2+11564*y**3-3636*y**4
          +505*y**5)-r**32*(-1+y)**4*(-47029+263343*y-594942*y**2+693007*y**3
          -468246*y**4+206053*y**5-51294*y**6+3981*y**7+599*y**8)-r**30*(-1+y)**2*(2952144
          -22593874*y+74935202*y**2-142088871*y**3+170251432*y**4-133870214*y**5
          +69301136*y**6-22828892*y**7+4103088*y**8-161088*y**9-91034*y**10+10331*y**11)
          +r**28*(23419460-230334610*y+1010832554*y**2-2624399353*y**3+4512495041*y**4
          -5457693635*y**5+4810902097*y**6-3147310354*y**7+1527979230*y**8-536288912*y**9
          +125383660*y**10-14473557*y**11-961875*y**12+442693*y**13-30839*y**14)
          +(-1+y)**13*(179+1432*y+6444*y**2+21194*y**3+17229*y**4-67464*y**5
          -46560*y**6-6564*y**7-34939*y**8+43936*y**9-4980*y**10-4662*y**11+6155*y**12
          +1280*y**13+120*y**14)+r**26*(113994224-954549122*y+3470885754*y**2
          -6966169039*y**3+7818496256*y**4-3356257664*y**5-3323145682*y**6+6503181451*y**7
          -5012825840*y**8+2196337126*y**9-558939802*y**10+64952119*y**11+8265440*y**12
          -4733796*y**13+673298*y**14-30323*y**15)+r**2*(-1+y)**12*(7724+53173*y
          +209112*y**2+598126*y**3+52096*y**4-2641397*y**5-133360*y**6+586412*y**7
          -989476*y**8+1453099*y**9-640312*y**10-12978*y**11+182936*y**12-2315*y**13
          +240*y**14+120*y**15)+r**4*(-1+y)**10*(-460051-2207366*y-6373698*y**2
          -10846445*y**3+4837635*y**4+34191226*y**5-17143300*y**6+12832471*y**7
          -9462117*y**8-21002474*y**9+5282750*y**10+15513345*y**11-6755923*y**12
          -626538*y**13+753064*y**14-12875*y**15+1896*y**16)+r**6*(-1+y)**9*(
          -4843056-17968462*y-41368676*y**2-67198927*y**3+5690825*y**4+120758006*y**5
          +148546292*y**6-185406803*y**7-64831279*y**8+243807974*y**9-279082708*y**10
          +160909915*y**11-32306101*y**12-3637774*y**13+2921796*y**14-115897*y**15
          +12875*y**16)+r**8*(-1+y)**8*(-19458620-48067850*y-76253486*y**2-159589271*y**3
          -305926239*y**4+100160920*y**5+1592239958*y**6-2527925453*y**7+940588305*y**8
          +226995054*y**9+235721654*y**10-478585169*y**11+206410739*y**12-31817884*y**13
          +6953410*y**14-521579*y**15+51511*y**16)+r**24*(-933073164+8294225114*y
          -32368364378*y**2+71619928835*y**3-96828127165*y**4+78670197080*y**5
          -30806701270*y**6-6094311719*y**7+14774544923*y**8-8269295614*y**9+1909884866*y**10
          +250099525*y**11-276168103*y**12+61100492*y**13-3916146*y**14-212257*y**15
          +54581*y**16)+r**10*(-1+y)**7*(-222477424-200422370*y-129682812*y**2
          +1752601179*y**3-1177224333*y**4-319220512*y**5-6228314378*y**6+12124504609*y**7
          -11115223431*y**8+5055490470*y**9+310535672*y**10-1599681331*y**11+727177093*y**12
          -122559908*y**13+18276878*y**14-1534921*y**15+139519*y**16)+r**12*(-1
          +y)**6*(-1608023244+307194962*y+701512390*y**2+8323123771*y**3-3253240049*y**4
          -10197742322*y**5-2166703536*y**6+8154295675*y**7+3151278361*y**8-8165872266*y**9
          +4038462750*y**10-1530115407*y**11+764876945*y**12-205976822*y**13+36504300*y**14
          -3310599*y**15+279091*y**16)+r**14*(-1+y)**5*(-2056600016+1630137658*y
          +2219147044*y**2-12140285415*y**3+29234407185*y**4-17293357726*y**5-2299720*y**6
          -21784545463*y**7+45819624741*y**8-38846571418*y**9+16122599708*y**10
          -3730702885*y**11+821030619*y**12-222269826*y**13+49068808*y**14-5562941*y**15
          +438847*y**16)+r**20*(-1+y)**2*(-4642638026+27955994014*y-68421875438*y**2
          +68848945793*y**3+16853851269*y**4-126737013498*y**5+166205302196*y**6
          -129125815659*y**7+69976908123*y**8-27849952190*y**9+9659991506*y**10
          -4021721893*y**11+1535623027*y**12-385825286*y**13+56535976*y**14-5872977*y**15
          +459063*y**16)+r**16*(-1+y)**4*(1954714694-8360138900*y+10817321178*y**2
          +6405285101*y**3-55297450365*y**4+81600018294*y**5-41715394198*y**6-9511345921*y**7
          +34057473867*y**8-36494061152*y**9+22164723062*y**10-8239286613*y**11
          +1897288033*y**12-335622978*y**13+59042982*y**14-7432535*y**15+561451*y**16)
          +r**18*(-1+y)**3*(7740155640-31600016980*y+44399894398*y**2-5443036017*y**3
          -8621644113*y**4-53712083850*y**5+85956326816*y**6-54061891211*y**7+29334728365*y**8
          -23219143072*y**9+16103147718*y**10-8156988183*y**11+2572119113*y**12
          -506134498*y**13+69785660*y**14-7736333*y**15+580547*y**16)+r**22*(119716816
          -1407711302*y+6407391634*y**2-10603818487*y**3-12162037448*y**4+87182460905*y**5
          -180512413402*y**6+213111580333*y**7-160851047132*y**8+80322502625*y**9
          -26607481954*y**10+5639119259*y**11-726684464*y**12+154303019*y**13-85630102*y**14
          +22495983*y**15-2990780*y**16+244497*y**17))))/(-41803776000*logy**5*r**20*(
          -1+y)**10+168000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-17418240000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-2903040000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          -241920000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**3-10080000*logy*(-1+y)**2*(-(r**9*(-1
          +y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(
          -4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((muG*(
          -217728000*logy**5*r**18*(-12+27*r**2+49*r**4+61*r**6+27*r**8)*(-1+y)**10
          +518400*logy**4*r**14*(-1+y)**7*(6929*r**16*(-1+y)**3+35*r**14*(695-2085*y
          +2085*y**2-1157*y**3+222*y**4)+168*(-1+y)**4*(-7-7*y-7*y**2+58*y**3
          -42*y**4+10*y**5)-7*r**12*(-12799+30297*y-18147*y**2+2529*y**3-200*y**4
          +720*y**5)-7*r**10*(-4773-3981*y+31431*y**2-28007*y**3+9350*y**4-2330*y**5
          +710*y**6)-35*r**4*(-1+y)**2*(-301+1021*y-360*y**2-996*y**3+983*y**4
          -787*y**5+216*y**6+8*y**7)-35*r**8*(1821-8403*y+12813*y**2-7643*y**3
          +2049*y**4-411*y**5-21*y**6+35*y**7)+r**2*(-1+y)**3*(-4157+15890*y**3
          -6405*y**4+9072*y**5-6440*y**6+1280*y**7)-7*r**6*(12883-46749*y+58899*y**2
          -29563*y**3+845*y**4+6327*y**5-1911*y**6-1259*y**7+528*y**8))-17280*logy**3*r**10*(
          -1+y)**5*(-1+r**2+y)**2*(8241*r**20*(-1+y)**5-r**18*(-1+y)**2*(-215851
          +631071*y-598107*y**2+145445*y**3+28842*y**4)-r**16*(-1+y)**2*(-648128
          +1528124*y-1086621*y**2-152781*y**3+140809*y**4+18397*y**5)+r**14*(
          -3540720+14736084*y-22262493*y**2+16411009*y**3-7107430*y**4+2146990*y**5
          -415689*y**6+74613*y**7-364*y**8)+140*(-1+y)**5*(-18-36*y-54*y**2
          +187*y**3-77*y**4+31*y**5+169*y**6-188*y**7+46*y**8)+r**12*(-9506358
          +38807034*y-57874719*y**2+41150823*y**3-16521715*y**4+4321443*y**5
          +642691*y**6-1536891*y**7+655557*y**8-95865*y**9)-r**4*(-1+y)**3*(-202265
          +93606*y+30606*y**2+1534926*y**3-3221824*y**4+1704146*y**5+548194*y**6
          -786006*y**7+382649*y**8-114176*y**9+17544*y**10)+r**10*(-7564614+31263030*y
          -48658365*y**2+38287165*y**3-18099235*y**4+5253213*y**5-523285*y**6
          +157935*y**7-23395*y**8-113295*y**9+20846*y**10)+r**2*(-1+y)**4*(-26277
          -21237*y-16197*y**2+280563*y**3-348227*y**4+113997*y**5+399597*y**6
          -718843*y**7+526072*y**8-201088*y**9+32640*y**10)-r**6*(-1+y)**2*(-160112
          +828756*y-326829*y**2+117651*y**3-1449609*y**4+2160095*y**5-2044931*y**6
          +721029*y**7+385849*y**8-269291*y**9+41592*y**10)+r**8*(669864-3979932*y
          +7488795*y**2-2266075*y**3-9900660*y**4+17159772*y**5-17360546*y**6
          +13291230*y**7-7217100*y**8+2791160*y**9-782761*y**10+106253*y**11))
          +288*logy**2*r**6*(-1+y)**4*(-1+r**2+y)**3*(-33327*r**26*(-1+y)**6+r**24*(
          -1+y)**3*(107486-422439*y+622401*y**2-426359*y**3+250711*y**4)+r**22*(3075478
          -19513809*y+51556164*y**2-73091313*y**3+61114030*y**4-32705523*y**5
          +12698864*y**6-3494859*y**7+360968*y**8)-5*r**20*(-7376430+38545419*y
          -80785524*y**2+80747523*y**3-29477390*y**4-11059167*y**5+11485264*y**6
          -1408463*y**7-809200*y**8+137968*y**9)-140*(-1+y)**7*(-15-60*y-150*y**2
          -59*y**3-687*y**4-1554*y**5+230*y**6+625*y**7+1764*y**8-1628*y**9
          +334*y**10)-5*r**18*(-3617791+14790267*y-24918693*y**2+8904029*y**3
          +28175447*y**4-39883887*y**5+23205243*y**6-11267477*y**7+6141076*y**8
          -1575092*y**9+46878*y**10)+2*r**16*(-240433268+1114092573*y-1932533070*y**2
          +1628907380*y**3-715918800*y**4+115879161*y**5+111876694*y**6-120920355*y**7
          +42841120*y**8+762550*y**9-4734068*y**10+852083*y**11)+5*r**10*(-1+y)**2*(10103995
          -32916346*y+18749574*y**2-17652646*y**3+97056721*y**4-109931742*y**5
          +18770122*y**6+47177474*y**7-53654789*y**8+27813264*y**9-5794848*y**10
          +202924*y**11+67897*y**12)+r**4*(-1+y)**5*(-135574-114647*y-151419*y**2
          +645820*y**3+1238640*y**4+1653278*y**5-5454066*y**6+5244308*y**7-7597970*y**8
          +5861585*y**9-891979*y**10-286312*y**11+72336*y**12)+5*r**8*(-1+y)**3*(6974286
          -3874539*y+42573*y**2-39071577*y**3+83268969*y**4-49431048*y**5-13462704*y**6
          +14047560*y**7+9109322*y**8-11410269*y**9+5073667*y**10-1008847*y**11
          +73007*y**12)+r**2*(-1+y)**6*(101133+297099*y+581598*y**2-722220*y**3
          +421940*y**4+444414*y**5-658798*y**6-298596*y**7-1810905*y**8+1788735*y**9
          +331928*y**10-642776*y**11+152448*y**12)+2*r**14*(-358022094+1685353113*y
          -3054117024*y**2+2865999360*y**3-1646178135*y**4+555067443*y**5+155507079*y**6
          -376923537*y**7+252303265*y**8-103654740*y**9+28800401*y**10-4382567*y**11
          +261436*y**12)-r**6*(-1+y)**4*(7338362+2358281*y+295532*y**2-61285135*y**3
          +107693350*y**4-33514844*y**5-130894282*y**6+228488936*y**7-190489440*y**8
          +87706475*y**9-20303418*y**10+728751*y**11+281432*y**12)-2*r**12*(9329918
          +13548921*y-106708956*y**2-83347348*y**3+780882900*y**4-1402995846*y**5
          +1535820188*y**6-1272706368*y**7+733378106*y**8-238806375*y**9+26557328*y**10
          +8798916*y**11-4189276*y**12+437892*y**13))-12*logy*r**2*(-1+y)**3*(
          -1+r**2+y)**4*(701*r**32*(-1+y)**7-r**30*(-1+y)**4*(93127-282185*y
          +287793*y**2-91699*y**3+26164*y**4)+r**28*(-1+y)**2*(-5031741+23934321*y
          -45002348*y**2+42099708*y**3-20453685*y**4+4941633*y**5-140402*y**6
          +28514*y**7)+r**26*(37557389-249158471*y+694576387*y**2-1050021809*y**3
          +918715285*y**4-454693915*y**5+114526181*y**6-16392667*y**7+8368394*y**8
          -4021330*y**9+320556*y**10)+r**24*(78547363-538694901*y+1587602883*y**2
          -2567720933*y**3+2546685922*y**4-1798319758*y**5+1116582282*y**6-576826278*y**7
          +157410443*y**8+517043*y**9-4841885*y**10+65819*y**11)+r**22*(965930429
          -5294222615*y+11572480353*y**2-11209136903*y**3+606615810*y**4+9382516930*y**5
          -9185238614*y**6+3665521098*y**7-439574087*y**8-69903275*y**9-4819499*y**10
          +9088189*y**11-1161816*y**12)-140*(-1+y)**9*(-15-90*y-315*y**2-682*y**3
          -740*y**4+150*y**5+644*y**6+698*y**7-433*y**8+140*y**9-65*y**10-184*y**11
          +92*y**12)+r**20*(-881004561+4638870439*y-8649104875*y**2+6435165197*y**3
          +994470730*y**4-6040567518*y**5+4606094082*y**6+458808890*y**7-3084772469*y**8
          +1841724395*y**9-268630871*y**10-64086471*y**11+16595260*y**12-1322228*y**13)
          +r**18*(-12294067583+64972736109*y-134909130773*y**2+143413652135*y**3
          -81187959762*y**4+10050462686*y**5+33827872022*y**6-43158106794*y**7
          +26362362725*y**8-7600217791*y**9+92367447*y**10+512327219*y**11-77814308*y**12
          -4396860*y**13-86472*y**14)+r**2*(-1+y)**8*(10267+42935*y+103605*y**2
          +452049*y**3-333738*y**4-2518674*y**5-2249070*y**6+632810*y**7+5324767*y**8
          -3731269*y**9-355143*y**10+1746085*y**11-821840*y**12+48384*y**13+24832*y**14)
          +r**4*(-1+y)**7*(-187253-882480*y-2468470*y**2+3231968*y**3+6042449*y**4
          +8827656*y**5-18391660*y**6+5052760*y**7+17571509*y**8-8894968*y**9
          -4704878*y**10+4592040*y**11-1507665*y**12+14848*y**13+48144*y**14)
          +r**6*(-1+y)**6*(5660079+13008333*y+20913520*y**2-28593324*y**3+49593031*y**4
          +42132657*y**5-84589016*y**6-1646800*y**7-63158307*y**8+92995663*y**9
          +28714264*y**10-71257092*y**11+25097005*y**12-2529869*y**13+91856*y**14)
          -r**12*(-1+y)**3*(-504557095+563638524*y-237406176*y**2+3274340636*y**3
          -7529284205*y**4+5964327640*y**5-2111037138*y**6+4795029352*y**7-9508090017*y**8
          +7823423420*y**9-3162817420*y**10+621404764*y**11-19337451*y**12-3620144*y**13
          +105310*y**14)+r**8*(-1+y)**5*(14487151+16813442*y+7058171*y**2-109530920*y**3
          +418353419*y**4+168487058*y**5-953160609*y**6+901374128*y**7-932122195*y**8
          +705206742*y**9-143567359*y**10-105522408*y**11+53220601*y**12-8577610*y**13
          +520389*y**14)+r**10*(-1+y)**4*(-354160937-47707305*y-6573453*y**2
          +2208826339*y**3-3721336024*y**4+1572563164*y**5+4272035970*y**6-8643397674*y**7
          +7768718887*y**8-3904239537*y**9+1005313423*y**10-108685465*y**11+8473402*y**12
          -7296226*y**13+865436*y**14)-r**14*(-1+y)**2*(-1573549659+5453098315*y
          -4558013130*y**2+4466673134*y**3-18457538253*y**4+23095856613*y**5-2835420360*y**6
          -12124131580*y**7+8637816747*y**8-1768554859*y**9-926370354*y**10+711613070*y**11
          -122931715*y**12+546619*y**13+1017412*y**14)+r**16*(-2397477443+10502754437*y
          -17407914719*y**2+27352762913*y**3-65236775635*y**4+111650861493*y**5
          -114769264679*y**6+75039736513*y**7-29367395041*y**8+1095265095*y**9
          +5953183163*y**10-2767060133*y**11+285803831*y**12+81365503*y**13-15620085*y**14
          -225213*y**15))+(-1+y)*(-1+r**2+y)**5*(165*r**36*(-1+y)**9+r**34*(
          -1+y)**6*(7384-21327*y+19677*y**2-8159*y**3+1625*y**4)+r**32*(-1
          +y)**4*(-122161+583122*y-1081464*y**2+1063203*y**3-657695*y**4+260258*y**5
          -60528*y**6+6145*y**7)+r**30*(-1+y)**2*(6679200-45053754*y+128985396*y**2
          -204364563*y**3+197507325*y**4-122489345*y**5+50213231*y**6-13463157*y**7
          +2274339*y**8-162397*y**9+8125*y**10)+r**28*(14140460-98578602*y+283948248*y**2
          -404786251*y**3+185203744*y**4+350223663*y**5-794267130*y**6+823017472*y**7
          -526424854*y**8+210708906*y**9-47499718*y**10+4278467*y**11-14030*y**12
          -14375*y**13)+r**26*(-529992992+4277231498*y-15006197772*y**2+29771736795*y**3
          -36116145765*y**4+26532430499*y**5-10057120511*y**6-117886266*y**7+1955118950*y**8
          -840152600*y**9+128385278*y**10+5601103*y**11-3459217*y**12+741755*y**13
          -66755*y**14)+(-1+y)**12*(663+5304*y+23868*y**2+90818*y**3+205833*y**4
          +243192*y**5-52352*y**6-362452*y**7+107201*y**8+40064*y**9-124100*y**10
          +51778*y**11+13039*y**12+3136*y**13+408*y**14)-r**24*(-1111187580+8785997046*y
          -29649745656*y**2+55495620839*y**3-60185907534*y**4+29801580554*y**5
          +13742547952*y**6-35929052659*y**7+28630366416*y**8-11489102358*y**9
          +1737093616*y**10+275067417*y**11-112384470*y**12+10568710*y**13-1292568*y**14
          +54275*y**15)+r**2*(-1+y)**10*(85528+491283*y+1655493*y**2+2514058*y**3
          +2271898*y**4+408321*y**5+5153579*y**6+36404*y**7-12395876*y**8+4890389*y**9
          +3054299*y**10-3215382*y**11+990778*y**12+96343*y**13+9013*y**14+1752*y**15
          +120*y**16)+r**4*(-1+y)**9*(1326397+6103026*y+16887258*y**2+18557175*y**3
          -9826813*y**4-62813118*y**5+14229768*y**6+11174219*y**7+5519435*y**8
          -35814914*y**9+5157010*y**10+29708781*y**11-16563027*y**12+2111790*y**13
          +819052*y**14-18639*y**15+2600*y**16)+r**6*(-1+y)**8*(4853088+15556362*y
          +30350040*y**2+76535357*y**3-63960647*y**4-181058026*y**5-76762024*y**6
          +146757265*y**7+269090521*y**8-305926146*y**9-22131632*y**10+164138447*y**11
          -71945205*y**12+8580322*y**13+3440768*y**14-229405*y**15+22915*y**16)
          +r**8*(-1+y)**7*(96058900+199846302*y+291292566*y**2-182974819*y**3
          -109678983*y**4-367819240*y**5-258700854*y**6+106388223*y**7+242130633*y**8
          +55435926*y**9+502579970*y**10-701885573*y**11+293730011*y**12-37377964*y**13
          +10835582*y**14-1208055*y**15+115375*y**16)+r**22*(-9721791200+71563708926*y
          -224256961416*y**2+374268492543*y**3-310652966317*y**4-4127170374*y**5
          +306387090528*y**6-357837734413*y**7+218371120379*y**8-78183698006*y**9
          +15529092688*y**10-1468574139*y**11+222382329*y**12-110799522*y**13+18562648*y**14
          -968439*y**15+213785*y**16)+r**10*(-1+y)**6*(600725344+635640774*y
          +461364792*y**2-2267282409*y**3+4003297643*y**4+343940472*y**5-10193212222*y**6
          +11394758637*y**7-10408525031*y**8+8411370030*y**9-1739126860*y**10-2033126127*y**11
          +1321381421*y**12-253233260*y**13+37448402*y**14-3992981*y**15+379375*y**16)
          +r**12*(-1+y)**5*(-1073506908+738607530*y-72154206*y**2+10309467471*y**3
          -18411888129*y**4+11450488102*y**5+14634875900*y**6-45139710033*y**7
          +45103427353*y**8-21162588002*y**9+4993523410*y**10-2305727315*y**11
          +1782149089*y**12-530568974*y**13+88699056*y**14-9147979*y**15+869635*y**16)
          +r**14*(-1+y)**4*(1916855008-2499265038*y+1096441536*y**2-6347463435*y**3
          +18377776529*y**4-22293281678*y**5+31235459196*y**6-74363505427*y**7
          +115316298045*y**8-92991950818*y**9+37473124032*y**10-8000853633*y**11
          +1856070891*y**12-595838210*y**13+129410564*y**14-15031137*y**15+1433575*y**16)
          +r**18*(-1+y)**2*(24269906640-102615889716*y+153874919682*y**2-175424284133*y**3
          +344860289999*y**4-531824675370*y**5+422572176332*y**6-143921792959*y**7
          +2263673781*y**8-4432206288*y**9+20785204690*y**10-13953098691*y**11
          +4174464777*y**12-740237298*y**13+115843264*y**14-14478585*y**15+1447875*y**16)
          +r**16*(-1+y)**3*(10254790606-36222396516*y+36620678430*y**2-26775576831*y**3
          +102089478851*y**4-163265505282*y**5+63188735582*y**6+32880493195*y**7
          +16370511867*y**8-72780654112*y**9+52038800226*y**10-17076293961*y**11
          +3242973825*y**12-603132986*y**13+133417986*y**14-17727875*y**15+1710995*y**16)
          +r**20*(24700790618-179058516704*y+544579119360*y**2-871701732391*y**3
          +662145804936*y**4+147237062695*y**5-920056186298*y**6+1053963658215*y**7
          -655027819898*y**8+230714184593*y**9-41307843444*y**10+7995328463*y**11
          -6670112500*y**12+3083138289*y**13-672939954*y**14+83281681*y**15-8022036*y**16
          +804375*y**17))))/(41803776000*logy**5*r**20*(-1+y)**10-168000*(r**8*(-1
          +y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(
          -4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5+17418240000*logy**4*r**16*(
          -1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +2903040000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2+241920000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3+10080000*logy*(
          -1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(
          -4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2
          +y**3))**4))
      resNP += ((rhoD*(217728000*logy**5*r**16*(108+276*r**2+329*r**4+303*r**6
          +231*r**8+81*r**10)*(-1+y)**11+518400*logy**4*r**12*(-1+y)**6*(10281*r**18*(
          -1+y)**5+56*r**2*(-1+y)**5*(-751+1680*y**3-1200*y**4+396*y**5+10*y**6)
          +105*r**16*(-647+3235*y-6470*y**2+6068*y**3-2941*y**4+545*y**5+18*y**6)
          -24*(-1+y)**6*(-11-11*y-11*y**2-256*y**3+514*y**4-410*y**5+80*y**6)
          +3*r**14*(-50537+195985*y-250220*y**2+21600*y**3+157865*y**4-113053*y**5
          +23660*y**6+1260*y**7)-105*r**6*(-1+y)**3*(3411-12342*y+11691*y**2
          -1388*y**3-1297*y**4-858*y**5+799*y**6-240*y**7+8*y**8)+21*r**12*(
          -16041+57105*y-56460*y**2-26690*y**3+77275*y**4-46589*y**5+10220*y**6
          -1370*y**7+630*y**8)-r**4*(-1+y)**4*(-333261+560061*y-113400*y**2
          -138950*y**3+49525*y**4-58079*y**5+42504*y**6-17880*y**7+1920*y**8)
          +7*r**10*(-26457+41385*y+144480*y**2-444320*y**3+429420*y**4-150648*y**5
          -12910*y**6+20610*y**7-5925*y**8+1485*y**9)+7*r**8*(2593-111665*y
          +470080*y**2-769410*y**3+545370*y**4-79146*y**5-100540*y**6+44330*y**7
          +1745*y**8-4365*y**9+1008*y**10))-17280*logy**3*r**8*(-1+y)**4*(33933*r**26*(
          -1+y)**7-r**24*(-1+y)**2*(-321629+1608145*y-3216290*y**2+3105590*y**3
          -1374085*y**4+108209*y**5+69420*y**6)-3*r**22*(-1+y)**2*(-1095571+5066615*y
          -9105130*y**2+7668290*y**3-3355755*y**4+930191*y**5-386320*y**6+117520*y**7)
          -12*(-1+y)**10*(858+2574*y+5148*y**2-2735*y**3-13250*y**4-20153*y**5
          +42986*y**6-22658*y**7+4080*y**8)-4*r**2*(-1+y)**9*(12192+24384*y
          +36576*y**2-5552*y**3-178265*y**4-95702*y**5+273511*y**6-120176*y**7
          +20482*y**8)-r**4*(-1+y)**8*(-609039-577359*y-561519*y**2+1784761*y**3
          +741531*y**4-1564641*y**5-381341*y**6+868939*y**7+180504*y**8-243696*y**9
          +48960*y**10)-3*r**20*(-96373-2042789*y+15639267*y**2-48528085*y**3
          +78743065*y**4-73337307*y**5+41101469*y**6-14067987*y**7+2986260*y**8
          -514800*y**9+83680*y**10)-r**6*(-1+y)**7*(5159177-5046720*y-2523360*y**2
          -7449720*y**3+15319450*y**4-4848504*y**5-3229420*y**6+1730720*y**7+964605*y**8
          -611440*y**9+100512*y**10)+5*r**8*(-1+y)**5*(-4387353+16772970*y-19106349*y**2
          +472180*y**3+13387758*y**4-8980836*y**5+2167110*y**6-624480*y**7+478275*y**8
          -116314*y**9-37473*y**10+7272*y**11)+10*r**18*(389761-908995*y-2620077*y**2
          +13429215*y**3-20642456*y**4+13781672*y**5-3064780*y**6-463560*y**7
          -232535*y**8+506373*y**9-179529*y**10+14991*y**11)+r**10*(-1+y)**4*(
          -7171773-21463281*y+120707181*y**2-144204727*y**3+51835270*y**4-2995602*y**5
          +22252946*y**6-23908446*y**7+5391247*y**8+2341035*y**9-1202535*y**10
          +81885*y**11)-2*r**12*(-1+y)**3*(-15716503+61776952*y-69760308*y**2
          -1707168*y**3+38355662*y**4-1864772*y**5-25544582*y**6+16631508*y**7
          -3547207*y**8+198438*y**9-246000*y**10+126180*y**11)-2*r**14*(-1+y)**2*(8811009
          -55166985*y+119024820*y**2-85766780*y**3-25570770*y**4+61643742*y**5
          -23685390*y**6-1313730*y**7+1274145*y**8+1165235*y**9-768936*y**10+177240*y**11)
          +2*r**16*(10361103-52316061*y+100760373*y**2-94556945*y**3+69061090*y**4
          -94843406*y**5+124418602*y**6-98820796*y**7+48740195*y**8-16041515*y**9
          +3829203*y**10-613641*y**11+21798*y**12))-288*logy**2*r**4*(-1+y)**3*(
          -1+r**2+y)**2*(-4473*r**30*(-1+y)**8-3*r**28*(-1+y)**3*(339613-1695083*y
          +3381220*y**2-3245800*y**3+1807555*y**4-569453*y**5+87388*y**6)+12*(
          -1+y)**11*(-69-345*y-1035*y**2+1430*y**3+6075*y**4-1887*y**5-91005*y**6
          +15360*y**7+132070*y**8-97150*y**9+19056*y**10)+4*r**2*(-1+y)**10*(
          -31731-126510*y-315240*y**2-37000*y**3+877125*y**4+1678062*y**5-3398240*y**6
          +1399640*y**7+1047300*y**8-1010800*y**9+200894*y**10)+r**26*(5388288
          -39027096*y+121278951*y**2-217011692*y**3+248483610*y**4-188420784*y**5
          +94142956*y**6-30938796*y**7+7679742*y**8-2013440*y**9+438261*y**10)
          +r**24*(-141619288+1074471656*y-3529503751*y**2+6524772724*y**3-7416790506*y**4
          +5336772080*y**5-2439042428*y**6+747295176*y**7-219859774*y**8+83654456*y**9
          -22333517*y**10+2183172*y**11)+r**22*(-343227329+2327180940*y-6615457515*y**2
          +9846783740*y**3-7817682270*y**4+2655926688*y**5+358038620*y**6-469712340*y**7
          +21305685*y**8+28649020*y**9+15143991*y**10-6633360*y**11-315870*y**12)
          +r**20*(91472319-1159396626*y+5408017383*y**2-14760315866*y**3+24096864170*y**4
          -23693279598*y**5+14628418812*y**6-6535177026*y**7+2885710797*y**8-1445156620*y**9
          +655944229*y**10-217104636*y**11+46017618*y**12-5206956*y**13)+r**4*(
          -1+y)**8*(-3506483-5411878*y-6640341*y**2+37401062*y**3+9769660*y**4
          +4844106*y**5-187298664*y**6+257111862*y**7-117397709*y**8-3626960*y**9
          +20003377*y**10-5328408*y**11-358296*y**12+228672*y**13)-r**8*(-1+y)**6*(
          -95793744+69979032*y+24026343*y**2+317967634*y**3-401496855*y**4-156733392*y**5
          +132273386*y**6+378104864*y**7-290814058*y**8-57165220*y**9+113850611*y**10
          -36528718*y**11+3360893*y**12+229224*y**13)+r**6*(-1+y)**7*(-29454893
          -17118055*y-10647813*y**2+169588641*y**3+36248120*y**4-142532124*y**5
          -336060480*y**6+568611356*y**7-255238207*y**8-20072945*y**9+45915417*y**10
          -8717465*y**11-1894568*y**12+533016*y**13)-r**12*(-1+y)**4*(-2463780253
          +9723290278*y-12703719000*y**2+3067775590*y**3+6806813915*y**4-6355429644*y**5
          +1856016024*y**6-118627240*y**7+111104465*y**8+75480210*y**9-144679028*y**10
          +49171198*y**11-5747235*y**12+648720*y**13)+2*r**16*(-1+y)**2*(-1407610778
          +5620837640*y-7516564833*y**2+2918940506*y**3+634746655*y**4+965630496*y**5
          -2368679180*y**6+1473571766*y**7-408809332*y**8+156039520*y**9-141280893*y**10
          +60965190*y**11-11388783*y**12+796026*y**13)-r**10*(-1+y)**5*(560843576
          -1484438960*y+859830231*y**2-311210957*y**3+1951258715*y**4-2606900097*y**5
          +442140890*y**6+1230459538*y**7-666486326*y**8-146536990*y**9+199224171*y**10
          -46225305*y**11-1467369*y**12+1448883*y**13)+r**14*(-1+y)**3*(-798411021
          +5966304729*y-14483466192*y**2+14084835444*y**3-4662562245*y**4+167702697*y**5
          -1310529208*y**6+1779052424*y**7-744033463*y**8-45074005*y**9+85779524*y**10
          +12209504*y**11-14292507*y**12+1880319*y**13)-2*r**18*(371228854-1966047056*y
          +3574690729*y**2-299906026*y**3-7818349096*y**4+11923628192*y**5-8400490593*y**6
          +3107901712*y**7-270915948*y**8-456805948*y**9+347121779*y**10-158197926*y**11
          +59350834*y**12-14922276*y**13+1712769*y**14))+12*logy*(-1+y)**2*(-1
          +r**2+y)**3*(4695*r**36*(-1+y)**9+3*r**34*(-1+y)**4*(12766-59135*y
          +104185*y**2-37870*y**3+14520*y**4-13491*y**5+5585*y**6)-r**32*(-1
          +y)**2*(-1992546+14263335*y-43916535*y**2+73996525*y**3-75529679*y**4
          +49175023*y**5-18710773*y**6+4131647*y**7-535843*y**8+21246*y**9)+12*(
          -1+y)**14*(17+136*y+612*y**2+2602*y**3+8072*y**4+15128*y**5-4320*y**6
          -21442*y**7+12743*y**8+1648*y**9-7100*y**10+3104*y**11)+r**30*(95032074
          -812677545*y+3062816919*y**2-6676855198*y**3+9377640922*y**4-8994918582*y**5
          +6109659474*y**6-2990355352*y**7+1037136298*y**8-232837337*y**9+25757103*y**10
          +186926*y**11-48102*y**12)+4*r**2*(-1+y)**12*(6370+38373*y+134841*y**2
          +203790*y**3+51170*y**4-262440*y**5+1512984*y**6+161998*y**7-2496440*y**8
          +1232155*y**9+249095*y**10-335732*y**11+91836*y**12)-3*r**28*(169503730
          -1530917811*y+6094872447*y**2-13907061004*y**3+20231921689*y**4-19983622177*y**5
          +14079711454*y**6-7393215728*y**7+2972291188*y**8-899569549*y**9+188502387*y**10
          -22734628*y**11+1035121*y**12+89281*y**13)+r**26*(-4243432678+32934854571*y
          -110126812533*y**2+205222187032*y**3-228599763914*y**4+147776205231*y**5
          -42871373117*y**6-6121186144*y**7+5781040566*y**8+2169977513*y**9-2631723103*y**10
          +808660296*y**11-103862598*y**12+11625277*y**13-1826799*y**14)+r**4*(
          -1+y)**11*(409269+2009037*y+5894091*y**2+9455371*y**3-5264582*y**4
          -47231558*y**5-54403474*y**6+34521558*y**7+115200273*y**8-117812791*y**9
          +34251239*y**10+1261487*y**11-1898624*y**12+303456*y**13+37248*y**14)
          +r**24*(-2812538370+16312192041*y-32685775065*y**2+1363159954*y**3+100166595032*y**4
          -180119589357*y**5+153623441493*y**6-77198391040*y**7+36499772782*y**8
          -28573859329*y**9+20527739569*y**10-9133675134*y**11+2356416780*y**12
          -376488011*y**13+48849347*y**14-3226692*y**15)-r**14*(-1+y)**5*(11914395966
          -40090961061*y+35140782816*y**2+1762964668*y**3+19006149142*y**4-58528233623*y**5
          +17719595712*y**6+53045836398*y**7-47602843206*y**8+2978617581*y**9+9177458208*y**10
          -2496451776*y**11-348996814*y**12+208559663*y**13-17770048*y**14+64374*y**15)
          +r**12*(-1+y)**6*(-11243034-1222344345*y+736592121*y**2+73159753*y**3
          +2134482824*y**4-3376292073*y**5-4961211385*y**6+11639898833*y**7-8329978186*y**8
          +3009302597*y**9+186613583*y**10-618770245*y**11+160479196*y**12-24293667*y**13
          +3093329*y**14+78699*y**15)+3*r**10*(-1+y)**7*(-552018282-21215225*y
          +121185104*y**2+3122830175*y**3-1678467646*y**4-2062299305*y**5-4848171700*y**6
          +12128648567*y**7-7269096070*y**8-154865883*y**9+1742235576*y**10-561215475*y**11
          -14880146*y**12+27604445*y**13-2658196*y**14+152061*y**15)+r**6*(-1
          +y)**9*(11408538+29323761*y+51834024*y**2-149527190*y**3-141689734*y**4
          +12228255*y**5+1436600448*y**6-2063671468*y**7+257257150*y**8+1291489223*y**9
          -947356424*y**10+210561666*y**11+13559694*y**12-9314135*y**13+484736*y**14
          +171456*y**15)+r**8*(-1+y)**8*(-105853910-72720397*y-16367667*y**2
          +1156202402*y**3-356056872*y**4+75255337*y**5-5236126681*y**6+8509455044*y**7
          -5068539814*y**8+929081269*y**9+354220731*y**10-157844422*y**11-28878252*y**12
          +22632287*y**13-2974847*y**14+363792*y**15)+3*r**16*(-1+y)**4*(17276037262
          -71450350971*y+105179611451*y**2-45603023660*y**3-41556345296*y**4+61471989075*y**5
          -27226887943*y**6-10528135322*y**7+19704862030*y**8-9337516333*y**9+1714307509*y**10
          +19577664*y**11-33917004*y**12+5516405*y**13-6570121*y**14+965254*y**15)
          +3*r**18*(-1+y)**3*(12463111550-39544593653*y+29535246312*y**2+20657907593*y**3
          -36861158718*y**4+20809617063*y**5-14069473524*y**6+9410435061*y**7+317817314*y**8
          -5945091199*y**9+3369461904*y**10+117560427*y**11-551625698*y**12+166704493*y**13
          -26634308*y**14+2595383*y**15)+r**20*(-1+y)**2*(-29366181124+146893132243*y
          -282161191623*y**2+249868394271*y**3-108552664166*y**4+42152130239*y**5
          -46270582461*y**6+55556435531*y**7-46849527552*y**8+25493814297*y**9
          -12837181921*y**10+7032399493*y**11-2492521958*y**12+460610181*y**13
          -53720331*y**14+7102881*y**15)+r**22*(8953266258-76751763189*y+285362422203*y**2
          -643014891266*y**3+944749043756*y**4-900554244951*y**5+550397378101*y**6
          -227989784496*y**7+85214168822*y**8-37826075227*y**9+15561986173*y**10
          -5226300690*y**11+1144224368*y**12+92746119*y**13-142033229*y**14+29381220*y**15
          +476028*y**16))-(-1+r**2+y)**4*(2211*r**38*(-1+y)**11+r**36*(-1+y)**6*(78895
          -385631*y+744730*y**2-720940*y**3+376445*y**4-107005*y**5+15426*y**6)
          +r**34*(-1+y)**4*(-1200851+8155561*y-23459039*y**2+37364873*y**3-36587959*y**4
          +23279669*y**5-9780873*y**6+2610135*y**7-387246*y**8+27618*y**9)-r**32*(
          -1+y)**2*(-13180231+114528647*y-437965180*y**2+980336130*y**3-1432118918*y**4
          +1435224128*y**5-1008221374*y**6+496386342*y**7-165405641*y**8+33952025*y**9
          -2990262*y**10-290120*y**11+67014*y**12)-2*r**30*(99054938-1053335296*y
          +5059051361*y**2-14539664941*y**3+27939557847*y**4-37993814761*y**5+37698876221*y**6
          -27656561673*y**7+14960146444*y**8-5829458262*y**9+1532449591*y**10-215021035*y**11
          -11272533*y**12+12159927*y**13-2429245*y**14+184617*y**15)+3*(-1+y)**13*(6787
          +39906*y+137223*y**2+390090*y**3+495425*y**4-306000*y**5-3023279*y**6
          +682844*y**7+5473885*y**8-5813750*y**9+1416809*y**10+2067690*y**11-1989017*y**12
          +556100*y**13-22625*y**14-496*y**15+408*y**16)-2*r**28*(-152135482+1883732016*y
          -10347864321*y**2+33743612001*y**3-73030070297*y**4+110758752821*y**5
          -120980911525*y**6+96173462224*y**7-55434674057*y**8+22673440526*y**9
          -6142573703*y**10+763042045*y**11+201982537*y**12-143097219*y**13+38282381*y**14
          -4985566*y**15+274419*y**16)+r**2*(-1+y)**12*(-666931-3107891*y-8787693*y**2
          +1672975*y**3+12411399*y**4-4166089*y**5-176595831*y**6+205378741*y**7
          +277257283*y**8-502968765*y**9+195517269*y**10+70640713*y**11-84904895*y**12
          +24377617*y**13-1337809*y**14-27949*y**15+11784*y**16+72*y**17)+r**4*(
          -1+y)**11*(-17765183-63708544*y-143992950*y**2+51829042*y**3+352097772*y**4
          +526090582*y**5-1130033532*y**6+321417292*y**7-113563228*y**8+979861868*y**9
          -1157544542*y**10+557515610*y**11-164490424*y**12+30913086*y**13-313040*y**14
          +938568*y**15+45191*y**16+1632*y**17)+r**6*(-1+y)**10*(13195229-33608225*y
          -131020338*y**2-961551206*y**3+667230640*y**4+2199342860*y**5+9280961108*y**6
          -21891631680*y**7+5978095276*y**8+15927217516*y**9-15028472074*y**10
          +4406668954*y**11-103773124*y**12-119973280*y**13+9802184*y**14+5641900*y**15
          +133803*y**16+6057*y**17)-2*r**8*(-1+y)**9*(450917066+256504174*y+101084901*y**2
          -4111311582*y**3+444390028*y**4-2777382830*y**5+14776474900*y**6-14833363651*y**7
          +11149498881*y**8-13803353433*y**9+11197400961*y**10-3790149912*y**11
          +431948810*y**12-30345684*y**13+6624470*y**14-6190007*y**15-361297*y**16
          +14205*y**17)+2*r**26*(1996019062-19723926184*y+86896363575*y**2-220613325663*y**3
          +353107577600*y**4-369163734850*y**5+256737804416*y**6-128813658122*y**7
          +67486987983*y**8-51154268907*y**9+36852857283*y**10-18847026135*y**11
          +6638376850*y**12-1678783500*y**13+316969702*y**14-40040800*y**15+2006473*y**16
          +70017*y**17)-2*r**10*(-1+y)**8*(8095229482-2999437900*y-3419711913*y**2
          -44265937239*y**3+40160440340*y**4+13697363114*y**5+59229287292*y**6
          -163782860198*y**7+114504850191*y**8-13930797763*y**9-14070777413*y**10
          +4682060121*y**11+514968054*y**12-407681792*y**13+15714658*y**14-1045548*y**15
          -1862803*y**16+151317*y**17)+2*r**20*(-1+y)**3*(10436066587-66047221162*y
          +172097809875*y**2-241417762312*y**3+42249544470*y**4+353072666632*y**5
          -430800208026*y**6+115095276983*y**7+133788691733*y**8-136282250139*y**9
          +53150631303*y**10-2688924202*y**11-6837007444*y**12+3263971034*y**13
          -760681376*y**14+104738683*y**15-11913330*y**16+482691*y**17)-2*r**12*(
          -1+y)**7*(20464742954-21353708750*y-7924737597*y**2-64040861070*y**3
          +118837903150*y**4-15815532818*y**5+28732312894*y**6-206309522807*y**7
          +201643462995*y**8-47816601869*y**9-23186889169*y**10+15475795980*y**11
          -3038584836*y**12+441442220*y**13-194404336*y**14+32170553*y**15-5931079*y**16
          +567585*y**17)-2*r**18*(-1+y)**4*(-89807245495+428150676907*y-770745655860*y**2
          +556944733586*y**3+194045529961*y**4-768122738889*y**5+604317430703*y**6
          +6259227289*y**7-338866725468*y**8+254885977714*y**9-97223140474*y**10
          +21482476608*y**11-1179223991*y**12-628662613*y**13+93782655*y**14+11716213*y**15
          -1979263*y**16+780417*y**17)+2*r**22*(-1+y)**2*(-9886426729+85710419659*y
          -315748865919*y**2+704023907675*y**3-1028486878446*y**4+976358305592*y**5
          -555537469374*y**6+126349570700*y**7+57718811743*y**8-57476018987*y**9
          +19732167077*y**10-1987114157*y**11-1265692268*y**12+1074704742*y**13
          -471461032*y**14+112748070*y**15-16601468*y**16+1189122*y**17)-2*r**14*(
          -1+y)**6*(73728216026-205719854888*y+160228183905*y**2-63871966189*y**3
          +224341166246*y**4-291803406972*y**5+64635754114*y**6+52102290508*y**7
          +11730517257*y**8-46442611373*y**9+12797607485*y**10+12295311315*y**11
          -9193681352*y**12+2981670802*y**13-662377728*y**14+90549806*y**15-11301121*y**16
          +1192959*y**17)-2*r**16*(-1+y)**5*(-20610094499+189267634472*y-486475450104*y**2
          +350153638316*y**3+415009936405*y**4-866164997670*y**5+436216880421*y**6
          +179303844021*y**7-307321137846*y**8+126056466149*y**9-24939560186*y**10
          +15612784962*y**11-9859211687*y**12+3243148640*y**13-702452019*y**14
          +104112765*y**15-11713845*y**16+1458105*y**17)+2*r**24*(9962863610-89882696392*y
          +355748803577*y**2-812981014925*y**3+1177685507610*y**4-1096812630146*y**5
          +588911469546*y**6-35365974521*y**7-255111894512*y**8+276757457574*y**9
          -182909677574*y**10+91184489513*y**11-35968669190*y**12+10585022778*y**13
          -1939994934*y**14+109937885*y**15+35453858*y**16-9278166*y**17+824409*y**18))))/(125411328000*logy**5*r**20*(
          -1+y)**11-504000*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(
          -1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5+52254720000*logy**4*r**16*(-1+y)**9*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))+8709120000*logy**3*r**12*(
          -1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          +725760000*logy**2*r**8*(-1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**3+30240000*logy*(-1+y)**3*(-(r**9*(-1
          +y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(
          -4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*muWC**3*(
          -217728000*logy**5*r**16*(108+276*r**2+329*r**4+303*r**6+231*r**8+81*r**10)*(
          -1+y)**11-518400*logy**4*r**12*(-1+y)**6*(10281*r**18*(-1+y)**5+56*r**2*(
          -1+y)**5*(-751+1680*y**3-1200*y**4+396*y**5+10*y**6)+105*r**16*(-647
          +3235*y-6470*y**2+6068*y**3-2941*y**4+545*y**5+18*y**6)-24*(-1+y)**6*(
          -11-11*y-11*y**2-256*y**3+514*y**4-410*y**5+80*y**6)+3*r**14*(-50537
          +195985*y-250220*y**2+21600*y**3+157865*y**4-113053*y**5+23660*y**6
          +1260*y**7)-105*r**6*(-1+y)**3*(3411-12342*y+11691*y**2-1388*y**3
          -1297*y**4-858*y**5+799*y**6-240*y**7+8*y**8)+21*r**12*(-16041+57105*y
          -56460*y**2-26690*y**3+77275*y**4-46589*y**5+10220*y**6-1370*y**7+630*y**8)
          -r**4*(-1+y)**4*(-333261+560061*y-113400*y**2-138950*y**3+49525*y**4
          -58079*y**5+42504*y**6-17880*y**7+1920*y**8)+7*r**10*(-26457+41385*y
          +144480*y**2-444320*y**3+429420*y**4-150648*y**5-12910*y**6+20610*y**7
          -5925*y**8+1485*y**9)+7*r**8*(2593-111665*y+470080*y**2-769410*y**3
          +545370*y**4-79146*y**5-100540*y**6+44330*y**7+1745*y**8-4365*y**9
          +1008*y**10))+17280*logy**3*r**8*(-1+y)**4*(33933*r**26*(-1+y)**7-r**24*(
          -1+y)**2*(-321629+1608145*y-3216290*y**2+3105590*y**3-1374085*y**4
          +108209*y**5+69420*y**6)-3*r**22*(-1+y)**2*(-1095571+5066615*y-9105130*y**2
          +7668290*y**3-3355755*y**4+930191*y**5-386320*y**6+117520*y**7)-12*(
          -1+y)**10*(858+2574*y+5148*y**2-2735*y**3-13250*y**4-20153*y**5+42986*y**6
          -22658*y**7+4080*y**8)-4*r**2*(-1+y)**9*(12192+24384*y+36576*y**2
          -5552*y**3-178265*y**4-95702*y**5+273511*y**6-120176*y**7+20482*y**8)
          -r**4*(-1+y)**8*(-609039-577359*y-561519*y**2+1784761*y**3+741531*y**4
          -1564641*y**5-381341*y**6+868939*y**7+180504*y**8-243696*y**9+48960*y**10)
          -3*r**20*(-96373-2042789*y+15639267*y**2-48528085*y**3+78743065*y**4
          -73337307*y**5+41101469*y**6-14067987*y**7+2986260*y**8-514800*y**9
          +83680*y**10)-r**6*(-1+y)**7*(5159177-5046720*y-2523360*y**2-7449720*y**3
          +15319450*y**4-4848504*y**5-3229420*y**6+1730720*y**7+964605*y**8-611440*y**9
          +100512*y**10)+5*r**8*(-1+y)**5*(-4387353+16772970*y-19106349*y**2
          +472180*y**3+13387758*y**4-8980836*y**5+2167110*y**6-624480*y**7+478275*y**8
          -116314*y**9-37473*y**10+7272*y**11)+10*r**18*(389761-908995*y-2620077*y**2
          +13429215*y**3-20642456*y**4+13781672*y**5-3064780*y**6-463560*y**7
          -232535*y**8+506373*y**9-179529*y**10+14991*y**11)+r**10*(-1+y)**4*(
          -7171773-21463281*y+120707181*y**2-144204727*y**3+51835270*y**4-2995602*y**5
          +22252946*y**6-23908446*y**7+5391247*y**8+2341035*y**9-1202535*y**10
          +81885*y**11)-2*r**12*(-1+y)**3*(-15716503+61776952*y-69760308*y**2
          -1707168*y**3+38355662*y**4-1864772*y**5-25544582*y**6+16631508*y**7
          -3547207*y**8+198438*y**9-246000*y**10+126180*y**11)-2*r**14*(-1+y)**2*(8811009
          -55166985*y+119024820*y**2-85766780*y**3-25570770*y**4+61643742*y**5
          -23685390*y**6-1313730*y**7+1274145*y**8+1165235*y**9-768936*y**10+177240*y**11)
          +2*r**16*(10361103-52316061*y+100760373*y**2-94556945*y**3+69061090*y**4
          -94843406*y**5+124418602*y**6-98820796*y**7+48740195*y**8-16041515*y**9
          +3829203*y**10-613641*y**11+21798*y**12))+288*logy**2*r**4*(-1+y)**3*(
          -1+r**2+y)**2*(-4473*r**30*(-1+y)**8-3*r**28*(-1+y)**3*(339613-1695083*y
          +3381220*y**2-3245800*y**3+1807555*y**4-569453*y**5+87388*y**6)+12*(
          -1+y)**11*(-69-345*y-1035*y**2+1430*y**3+6075*y**4-1887*y**5-91005*y**6
          +15360*y**7+132070*y**8-97150*y**9+19056*y**10)+4*r**2*(-1+y)**10*(
          -31731-126510*y-315240*y**2-37000*y**3+877125*y**4+1678062*y**5-3398240*y**6
          +1399640*y**7+1047300*y**8-1010800*y**9+200894*y**10)+r**26*(5388288
          -39027096*y+121278951*y**2-217011692*y**3+248483610*y**4-188420784*y**5
          +94142956*y**6-30938796*y**7+7679742*y**8-2013440*y**9+438261*y**10)
          +r**24*(-141619288+1074471656*y-3529503751*y**2+6524772724*y**3-7416790506*y**4
          +5336772080*y**5-2439042428*y**6+747295176*y**7-219859774*y**8+83654456*y**9
          -22333517*y**10+2183172*y**11)+r**22*(-343227329+2327180940*y-6615457515*y**2
          +9846783740*y**3-7817682270*y**4+2655926688*y**5+358038620*y**6-469712340*y**7
          +21305685*y**8+28649020*y**9+15143991*y**10-6633360*y**11-315870*y**12)
          +r**20*(91472319-1159396626*y+5408017383*y**2-14760315866*y**3+24096864170*y**4
          -23693279598*y**5+14628418812*y**6-6535177026*y**7+2885710797*y**8-1445156620*y**9
          +655944229*y**10-217104636*y**11+46017618*y**12-5206956*y**13)+r**4*(
          -1+y)**8*(-3506483-5411878*y-6640341*y**2+37401062*y**3+9769660*y**4
          +4844106*y**5-187298664*y**6+257111862*y**7-117397709*y**8-3626960*y**9
          +20003377*y**10-5328408*y**11-358296*y**12+228672*y**13)-r**8*(-1+y)**6*(
          -95793744+69979032*y+24026343*y**2+317967634*y**3-401496855*y**4-156733392*y**5
          +132273386*y**6+378104864*y**7-290814058*y**8-57165220*y**9+113850611*y**10
          -36528718*y**11+3360893*y**12+229224*y**13)+r**6*(-1+y)**7*(-29454893
          -17118055*y-10647813*y**2+169588641*y**3+36248120*y**4-142532124*y**5
          -336060480*y**6+568611356*y**7-255238207*y**8-20072945*y**9+45915417*y**10
          -8717465*y**11-1894568*y**12+533016*y**13)-r**12*(-1+y)**4*(-2463780253
          +9723290278*y-12703719000*y**2+3067775590*y**3+6806813915*y**4-6355429644*y**5
          +1856016024*y**6-118627240*y**7+111104465*y**8+75480210*y**9-144679028*y**10
          +49171198*y**11-5747235*y**12+648720*y**13)+2*r**16*(-1+y)**2*(-1407610778
          +5620837640*y-7516564833*y**2+2918940506*y**3+634746655*y**4+965630496*y**5
          -2368679180*y**6+1473571766*y**7-408809332*y**8+156039520*y**9-141280893*y**10
          +60965190*y**11-11388783*y**12+796026*y**13)-r**10*(-1+y)**5*(560843576
          -1484438960*y+859830231*y**2-311210957*y**3+1951258715*y**4-2606900097*y**5
          +442140890*y**6+1230459538*y**7-666486326*y**8-146536990*y**9+199224171*y**10
          -46225305*y**11-1467369*y**12+1448883*y**13)+r**14*(-1+y)**3*(-798411021
          +5966304729*y-14483466192*y**2+14084835444*y**3-4662562245*y**4+167702697*y**5
          -1310529208*y**6+1779052424*y**7-744033463*y**8-45074005*y**9+85779524*y**10
          +12209504*y**11-14292507*y**12+1880319*y**13)-2*r**18*(371228854-1966047056*y
          +3574690729*y**2-299906026*y**3-7818349096*y**4+11923628192*y**5-8400490593*y**6
          +3107901712*y**7-270915948*y**8-456805948*y**9+347121779*y**10-158197926*y**11
          +59350834*y**12-14922276*y**13+1712769*y**14))-12*logy*(-1+y)**2*(-1
          +r**2+y)**3*(4695*r**36*(-1+y)**9+3*r**34*(-1+y)**4*(12766-59135*y
          +104185*y**2-37870*y**3+14520*y**4-13491*y**5+5585*y**6)-r**32*(-1
          +y)**2*(-1992546+14263335*y-43916535*y**2+73996525*y**3-75529679*y**4
          +49175023*y**5-18710773*y**6+4131647*y**7-535843*y**8+21246*y**9)+12*(
          -1+y)**14*(17+136*y+612*y**2+2602*y**3+8072*y**4+15128*y**5-4320*y**6
          -21442*y**7+12743*y**8+1648*y**9-7100*y**10+3104*y**11)+r**30*(95032074
          -812677545*y+3062816919*y**2-6676855198*y**3+9377640922*y**4-8994918582*y**5
          +6109659474*y**6-2990355352*y**7+1037136298*y**8-232837337*y**9+25757103*y**10
          +186926*y**11-48102*y**12)+4*r**2*(-1+y)**12*(6370+38373*y+134841*y**2
          +203790*y**3+51170*y**4-262440*y**5+1512984*y**6+161998*y**7-2496440*y**8
          +1232155*y**9+249095*y**10-335732*y**11+91836*y**12)-3*r**28*(169503730
          -1530917811*y+6094872447*y**2-13907061004*y**3+20231921689*y**4-19983622177*y**5
          +14079711454*y**6-7393215728*y**7+2972291188*y**8-899569549*y**9+188502387*y**10
          -22734628*y**11+1035121*y**12+89281*y**13)+r**26*(-4243432678+32934854571*y
          -110126812533*y**2+205222187032*y**3-228599763914*y**4+147776205231*y**5
          -42871373117*y**6-6121186144*y**7+5781040566*y**8+2169977513*y**9-2631723103*y**10
          +808660296*y**11-103862598*y**12+11625277*y**13-1826799*y**14)+r**4*(
          -1+y)**11*(409269+2009037*y+5894091*y**2+9455371*y**3-5264582*y**4
          -47231558*y**5-54403474*y**6+34521558*y**7+115200273*y**8-117812791*y**9
          +34251239*y**10+1261487*y**11-1898624*y**12+303456*y**13+37248*y**14)
          +r**24*(-2812538370+16312192041*y-32685775065*y**2+1363159954*y**3+100166595032*y**4
          -180119589357*y**5+153623441493*y**6-77198391040*y**7+36499772782*y**8
          -28573859329*y**9+20527739569*y**10-9133675134*y**11+2356416780*y**12
          -376488011*y**13+48849347*y**14-3226692*y**15)-r**14*(-1+y)**5*(11914395966
          -40090961061*y+35140782816*y**2+1762964668*y**3+19006149142*y**4-58528233623*y**5
          +17719595712*y**6+53045836398*y**7-47602843206*y**8+2978617581*y**9+9177458208*y**10
          -2496451776*y**11-348996814*y**12+208559663*y**13-17770048*y**14+64374*y**15)
          +r**12*(-1+y)**6*(-11243034-1222344345*y+736592121*y**2+73159753*y**3
          +2134482824*y**4-3376292073*y**5-4961211385*y**6+11639898833*y**7-8329978186*y**8
          +3009302597*y**9+186613583*y**10-618770245*y**11+160479196*y**12-24293667*y**13
          +3093329*y**14+78699*y**15)+3*r**10*(-1+y)**7*(-552018282-21215225*y
          +121185104*y**2+3122830175*y**3-1678467646*y**4-2062299305*y**5-4848171700*y**6
          +12128648567*y**7-7269096070*y**8-154865883*y**9+1742235576*y**10-561215475*y**11
          -14880146*y**12+27604445*y**13-2658196*y**14+152061*y**15)+r**6*(-1
          +y)**9*(11408538+29323761*y+51834024*y**2-149527190*y**3-141689734*y**4
          +12228255*y**5+1436600448*y**6-2063671468*y**7+257257150*y**8+1291489223*y**9
          -947356424*y**10+210561666*y**11+13559694*y**12-9314135*y**13+484736*y**14
          +171456*y**15)+r**8*(-1+y)**8*(-105853910-72720397*y-16367667*y**2
          +1156202402*y**3-356056872*y**4+75255337*y**5-5236126681*y**6+8509455044*y**7
          -5068539814*y**8+929081269*y**9+354220731*y**10-157844422*y**11-28878252*y**12
          +22632287*y**13-2974847*y**14+363792*y**15)+3*r**16*(-1+y)**4*(17276037262
          -71450350971*y+105179611451*y**2-45603023660*y**3-41556345296*y**4+61471989075*y**5
          -27226887943*y**6-10528135322*y**7+19704862030*y**8-9337516333*y**9+1714307509*y**10
          +19577664*y**11-33917004*y**12+5516405*y**13-6570121*y**14+965254*y**15)
          +3*r**18*(-1+y)**3*(12463111550-39544593653*y+29535246312*y**2+20657907593*y**3
          -36861158718*y**4+20809617063*y**5-14069473524*y**6+9410435061*y**7+317817314*y**8
          -5945091199*y**9+3369461904*y**10+117560427*y**11-551625698*y**12+166704493*y**13
          -26634308*y**14+2595383*y**15)+r**20*(-1+y)**2*(-29366181124+146893132243*y
          -282161191623*y**2+249868394271*y**3-108552664166*y**4+42152130239*y**5
          -46270582461*y**6+55556435531*y**7-46849527552*y**8+25493814297*y**9
          -12837181921*y**10+7032399493*y**11-2492521958*y**12+460610181*y**13
          -53720331*y**14+7102881*y**15)+r**22*(8953266258-76751763189*y+285362422203*y**2
          -643014891266*y**3+944749043756*y**4-900554244951*y**5+550397378101*y**6
          -227989784496*y**7+85214168822*y**8-37826075227*y**9+15561986173*y**10
          -5226300690*y**11+1144224368*y**12+92746119*y**13-142033229*y**14+29381220*y**15
          +476028*y**16))+(-1+r**2+y)**4*(2211*r**38*(-1+y)**11+r**36*(-1+y)**6*(78895
          -385631*y+744730*y**2-720940*y**3+376445*y**4-107005*y**5+15426*y**6)
          +r**34*(-1+y)**4*(-1200851+8155561*y-23459039*y**2+37364873*y**3-36587959*y**4
          +23279669*y**5-9780873*y**6+2610135*y**7-387246*y**8+27618*y**9)-r**32*(
          -1+y)**2*(-13180231+114528647*y-437965180*y**2+980336130*y**3-1432118918*y**4
          +1435224128*y**5-1008221374*y**6+496386342*y**7-165405641*y**8+33952025*y**9
          -2990262*y**10-290120*y**11+67014*y**12)-2*r**30*(99054938-1053335296*y
          +5059051361*y**2-14539664941*y**3+27939557847*y**4-37993814761*y**5+37698876221*y**6
          -27656561673*y**7+14960146444*y**8-5829458262*y**9+1532449591*y**10-215021035*y**11
          -11272533*y**12+12159927*y**13-2429245*y**14+184617*y**15)+3*(-1+y)**13*(6787
          +39906*y+137223*y**2+390090*y**3+495425*y**4-306000*y**5-3023279*y**6
          +682844*y**7+5473885*y**8-5813750*y**9+1416809*y**10+2067690*y**11-1989017*y**12
          +556100*y**13-22625*y**14-496*y**15+408*y**16)-2*r**28*(-152135482+1883732016*y
          -10347864321*y**2+33743612001*y**3-73030070297*y**4+110758752821*y**5
          -120980911525*y**6+96173462224*y**7-55434674057*y**8+22673440526*y**9
          -6142573703*y**10+763042045*y**11+201982537*y**12-143097219*y**13+38282381*y**14
          -4985566*y**15+274419*y**16)+r**2*(-1+y)**12*(-666931-3107891*y-8787693*y**2
          +1672975*y**3+12411399*y**4-4166089*y**5-176595831*y**6+205378741*y**7
          +277257283*y**8-502968765*y**9+195517269*y**10+70640713*y**11-84904895*y**12
          +24377617*y**13-1337809*y**14-27949*y**15+11784*y**16+72*y**17)+r**4*(
          -1+y)**11*(-17765183-63708544*y-143992950*y**2+51829042*y**3+352097772*y**4
          +526090582*y**5-1130033532*y**6+321417292*y**7-113563228*y**8+979861868*y**9
          -1157544542*y**10+557515610*y**11-164490424*y**12+30913086*y**13-313040*y**14
          +938568*y**15+45191*y**16+1632*y**17)+r**6*(-1+y)**10*(13195229-33608225*y
          -131020338*y**2-961551206*y**3+667230640*y**4+2199342860*y**5+9280961108*y**6
          -21891631680*y**7+5978095276*y**8+15927217516*y**9-15028472074*y**10
          +4406668954*y**11-103773124*y**12-119973280*y**13+9802184*y**14+5641900*y**15
          +133803*y**16+6057*y**17)-2*r**8*(-1+y)**9*(450917066+256504174*y+101084901*y**2
          -4111311582*y**3+444390028*y**4-2777382830*y**5+14776474900*y**6-14833363651*y**7
          +11149498881*y**8-13803353433*y**9+11197400961*y**10-3790149912*y**11
          +431948810*y**12-30345684*y**13+6624470*y**14-6190007*y**15-361297*y**16
          +14205*y**17)+2*r**26*(1996019062-19723926184*y+86896363575*y**2-220613325663*y**3
          +353107577600*y**4-369163734850*y**5+256737804416*y**6-128813658122*y**7
          +67486987983*y**8-51154268907*y**9+36852857283*y**10-18847026135*y**11
          +6638376850*y**12-1678783500*y**13+316969702*y**14-40040800*y**15+2006473*y**16
          +70017*y**17)-2*r**10*(-1+y)**8*(8095229482-2999437900*y-3419711913*y**2
          -44265937239*y**3+40160440340*y**4+13697363114*y**5+59229287292*y**6
          -163782860198*y**7+114504850191*y**8-13930797763*y**9-14070777413*y**10
          +4682060121*y**11+514968054*y**12-407681792*y**13+15714658*y**14-1045548*y**15
          -1862803*y**16+151317*y**17)+2*r**20*(-1+y)**3*(10436066587-66047221162*y
          +172097809875*y**2-241417762312*y**3+42249544470*y**4+353072666632*y**5
          -430800208026*y**6+115095276983*y**7+133788691733*y**8-136282250139*y**9
          +53150631303*y**10-2688924202*y**11-6837007444*y**12+3263971034*y**13
          -760681376*y**14+104738683*y**15-11913330*y**16+482691*y**17)-2*r**12*(
          -1+y)**7*(20464742954-21353708750*y-7924737597*y**2-64040861070*y**3
          +118837903150*y**4-15815532818*y**5+28732312894*y**6-206309522807*y**7
          +201643462995*y**8-47816601869*y**9-23186889169*y**10+15475795980*y**11
          -3038584836*y**12+441442220*y**13-194404336*y**14+32170553*y**15-5931079*y**16
          +567585*y**17)-2*r**18*(-1+y)**4*(-89807245495+428150676907*y-770745655860*y**2
          +556944733586*y**3+194045529961*y**4-768122738889*y**5+604317430703*y**6
          +6259227289*y**7-338866725468*y**8+254885977714*y**9-97223140474*y**10
          +21482476608*y**11-1179223991*y**12-628662613*y**13+93782655*y**14+11716213*y**15
          -1979263*y**16+780417*y**17)+2*r**22*(-1+y)**2*(-9886426729+85710419659*y
          -315748865919*y**2+704023907675*y**3-1028486878446*y**4+976358305592*y**5
          -555537469374*y**6+126349570700*y**7+57718811743*y**8-57476018987*y**9
          +19732167077*y**10-1987114157*y**11-1265692268*y**12+1074704742*y**13
          -471461032*y**14+112748070*y**15-16601468*y**16+1189122*y**17)-2*r**14*(
          -1+y)**6*(73728216026-205719854888*y+160228183905*y**2-63871966189*y**3
          +224341166246*y**4-291803406972*y**5+64635754114*y**6+52102290508*y**7
          +11730517257*y**8-46442611373*y**9+12797607485*y**10+12295311315*y**11
          -9193681352*y**12+2981670802*y**13-662377728*y**14+90549806*y**15-11301121*y**16
          +1192959*y**17)-2*r**16*(-1+y)**5*(-20610094499+189267634472*y-486475450104*y**2
          +350153638316*y**3+415009936405*y**4-866164997670*y**5+436216880421*y**6
          +179303844021*y**7-307321137846*y**8+126056466149*y**9-24939560186*y**10
          +15612784962*y**11-9859211687*y**12+3243148640*y**13-702452019*y**14
          +104112765*y**15-11713845*y**16+1458105*y**17)+2*r**24*(9962863610-89882696392*y
          +355748803577*y**2-812981014925*y**3+1177685507610*y**4-1096812630146*y**5
          +588911469546*y**6-35365974521*y**7-255111894512*y**8+276757457574*y**9
          -182909677574*y**10+91184489513*y**11-35968669190*y**12+10585022778*y**13
          -1939994934*y**14+109937885*y**15+35453858*y**16-9278166*y**17+824409*y**18))))/(141087744000*logy**5*r**20*(
          -1+y)**11-567000*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(
          -1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5+58786560000*logy**4*r**16*(-1+y)**9*(-(r**8*(-1+y)**2)
          +6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y
          -4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))+9797760000*logy**3*r**12*(
          -1+y)**7*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          +816480000*logy**2*r**8*(-1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**3+34020000*logy*(-1+y)**3*(-(r**9*(-1
          +y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(
          -4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(
          -217728000*logy**5*r**22*(5+10*r**2+9*r**4)*(-1+y)**10-518400*logy**4*r**16*(
          -1+y)**8*(565*r**14*(-1+y)**2+14*r**12*(367-734*y+367*y**2+15*y**3)
          +7*r**10*(2367-2034*y-1683*y**2+1570*y**3)+1750*r**4*(-1+y)**2*(-3
          -y**3+y**4)+70*r**8*(-60+420*y-510*y**2+170*y**3-26*y**4+29*y**5)
          +7*r**2*(-1+y)**2*(-79-810*y**3+745*y**4-256*y**5+40*y**6)+8*(-1
          +y)**3*(-107-107*y-107*y**2+33*y**3+208*y**4-170*y**5+40*y**6)+35*r**6*(
          -375+1050*y-825*y**2+64*y**3+197*y**4-136*y**5+49*y**6))+17280*logy**3*r**12*(
          -1+y)**6*(-1+r**2+y)**2*(1977*r**18*(-1+y)**4-2*r**16*(-1+y)**2*(9420
          -16863*y+5466*y**2+4057*y**3)-r**14*(-1+y)**2*(198972-363870*y+158793*y**2
          -17144*y**3+7149*y**4)+4*(-1+y)**6*(-261-1044*y-2610*y**2-1750*y**3
          +2285*y**4+8046*y**5-8106*y**6+2040*y**7)+2*r**12*(-305682+1062483*y
          -1335681*y**2+631880*y**3+6620*y**4-46173*y**5-18753*y**6+4606*y**7)
          +r**10*(-1427886+3941142*y-3384351*y**2+168940*y**3+1208755*y**4-632994*y**5
          +161443*y**6-31024*y**7-6825*y**8)+r**2*(-1+y)**4*(24309+46530*y+66663*y**2
          +13108*y**3-74285*y**4-9414*y**5+48345*y**6-19208*y**7+1952*y**8)+r**6*(
          -1+y)**2*(-129540+183234*y+113997*y**2-913176*y**3+869955*y**4-272550*y**5
          +58431*y**6-31052*y**7+3101*y**8)-2*r**4*(-1+y)**3*(68946+40851*y
          +36870*y**2-123997*y**3-81010*y**4+111049*y**5-8826*y**6-17915*y**7
          +4832*y**8)-2*r**8*(400266-1059429*y+739536*y**2+547806*y**3-1279544*y**4
          +881384*y**5-220696*y**6-24086*y**7+11494*y**8+3269*y**9))+288*logy**2*r**8*(
          -1+y)**5*(-1+r**2+y)**3*(1023*r**24*(-1+y)**5-r**22*(-1+y)**3*(-60319
          +123707*y-66457*y**2+34479*y**3)+r**20*(-107843+367381*y-403328*y**2
          +47050*y**3+263205*y**4-284647*y**5+116734*y**6+1448*y**7)+5*r**18*(1449693
          -6539886*y+11396247*y**2-9155242*y**3+2918837*y**4-74496*y**5+177063*y**6
          -197600*y**7+25384*y**8)-10*r**16*(-2466553+10571519*y-17469241*y**2
          +13696479*y**3-4874910*y**4+477948*y**5+112841*y**6-69259*y**7+9391*y**8
          +11785*y**9)-4*(-1+y)**7*(1383+6915*y+20745*y**2+32285*y**3+25525*y**4
          -22661*y**5-66765*y**6-6845*y**7+87840*y**8-52950*y**9+9528*y**10)
          -r**2*(-1+y)**6*(1679-9880*y-66190*y**2+89730*y**3+627350*y**4+1126732*y**5
          -2484670*y**6+968890*y**7+126895*y**8-112000*y**9+11464*y**10)-5*r**6*(
          -1+y)**4*(1105011+1492956*y+1684095*y**2-2037270*y**3-3139662*y**4
          +613374*y**5+3579274*y**6-3108090*y**7+1159315*y**8-229538*y**9+28535*y**10)
          -5*r**8*(-1+y)**3*(-2625323-259178*y-472637*y**2+7696452*y**3-799128*y**4
          -4824828*y**5+494948*y**6+1256612*y**7-69837*y**8-209682*y**9+59001*y**10)
          +2*r**10*(-1+y)**2*(18450143-25433160*y-5976615*y**2+59665120*y**3
          -68478045*y**4+31383864*y**5-7604365*y**6+1287240*y**7+1187030*y**8
          -905280*y**9+78068*y**10)+r**4*(-1+y)**5*(204643+790290*y+1806150*y**2
          +4024000*y**3+1798320*y**4+650304*y**5-13425190*y**6+12031800*y**7-2983675*y**8
          -202970*y**9+94328*y**10)-2*r**14*(-21950383+82921220*y-117721030*y**2
          +61663680*y**3+14778825*y**4-25538154*y**5+5028955*y**6-930620*y**7
          +2689170*y**8-1129650*y**9+159987*y**10)+2*r**12*(43873299-129877209*y
          +113918805*y**2+26010075*y**3-110884515*y**4+74812437*y**5-12740707*y**6
          -12165455*y**7+9287600*y**8-2029860*y**9-268786*y**10+64316*y**11))
          +12*logy*r**4*(-1+y)**4*(-1+r**2+y)**4*(217*r**30*(-1+y)**6+2*r**28*(
          -1+y)**4*(-4101+7768*y-3233*y**2+886*y**3)+r**26*(-1+y)**2*(520359
          -2000392*y+2824700*y**2-1914940*y**3+727115*y**4-128404*y**5+19562*y**6)
          +4*r**24*(401441-2184916*y+4978763*y**2-6671107*y**3+6247129*y**4-4053211*y**5
          +1401281*y**6-40213*y**7-104558*y**8+6991*y**9)+r**22*(-18952287+113362050*y
          -276501213*y**2+363933464*y**3-296764694*y**4+171780012*y**5-75668530*y**6
          +21400808*y**7-2602619*y**8+301714*y**9-75905*y**10)+8*(-1+y)**10*(13
          +104*y+468*y**2+1158*y**3+1528*y**4-698*y**5-7030*y**6-6918*y**7
          +7867*y**8+4122*y**9-4190*y**10+776*y**11)-2*r**20*(124544235-611030988*y
          +1176977193*y**2-1049788412*y**3+309865958*y**4+139205688*y**5-81791246*y**6
          -25456168*y**7+18269487*y**8-12508*y**9-771323*y**10+77684*y**11)-r**2*(
          -1+y)**8*(24027+143746*y+501655*y**2+1035160*y**3+1395190*y**4+553836*y**5
          -2359722*y**6-1444920*y**7+2815615*y**8-1012990*y**9-6813*y**10+31376*y**11
          +3840*y**12)+r**6*(-1+y)**6*(4602259+16123464*y+35326212*y**2+47453820*y**3
          +29850475*y**4-7757888*y**5-146395688*y**6+105406536*y**7+14651905*y**8
          -33036200*y**9+10531204*y**10-1165476*y**11+9377*y**12)-2*r**4*(-1+y)**7*(
          -296853-1399343*y-4009127*y**2-4870165*y**3-11130*y**4+11750546*y**5
          +1661906*y**6-2208186*y**7-11348785*y**8+9642205*y**9-2322443*y**10
          +22287*y**11+29088*y**12)+r**18*(-372110441+1772602242*y-3407234241*y**2
          +3411673560*y**3-1887540470*y**4+416109292*y**5+329492486*y**6-440140888*y**7
          +211670515*y**8-30227230*y**9-4069701*y**10-264528*y**11+39404*y**12)
          +4*r**8*(-1+y)**5*(-1377117-5706501*y-13487382*y**2-22708615*y**3+8967445*y**4
          +8965554*y**5+79828992*y**6-92173326*y**7+27103765*y**8+135355*y**9
          +670638*y**10-695091*y**11+60283*y**12)+r**10*(-1+y)**4*(184424349+131980530*y
          +72765603*y**2-566729240*y**3-208481460*y**4+319585132*y**5+688823230*y**6
          -943395176*y**7+424503165*y**8-73103790*y**9+3613519*y**10-1529360*y**11
          +135498*y**12)-2*r**12*(-1+y)**3*(66426757+1802611*y+55629865*y**2
          -442838515*y**3+221939100*y**4+139769486*y**5-32505262*y**6+65099450*y**7
          -160960035*y**8+84749375*y**9-11028443*y**10-328199*y**11+147810*y**12)
          -r**14*(-1+y)**2*(1415582733-2173379492*y+19236982*y**2+2503226580*y**3
          -3148276065*y**4+2118443864*y**5-520303756*y**6-283352344*y**7+175632795*y**8
          +10624140*y**9-12339722*y**10+1162948*y**11+253337*y**12)+8*r**16*(-56304396
          +202969450*y-257584482*y**2+20669663*y**3+270476730*y**4-184740013*y**5
          -120099900*y**6+177038334*y**7-36278096*y**8-27745680*y**9+12636334*y**10
          -673725*y**11-377102*y**12+12883*y**13))-r**2*(-1+y)**2*(-1+r**2+y)**5*(33*r**34*(
          -1+y)**8+r**32*(-1+y)**6*(-1497+2829*y-1167*y**2+325*y**3)+r**30*(
          -1+y)**4*(29118-111756*y+155037*y**2-104508*y**3+43592*y**4-9736*y**5
          +1229*y**6)+r**28*(-1+y)**2*(-388662+2289522*y-5535765*y**2+7264495*y**3
          -5849705*y**4+3089957*y**5-1069567*y**6+234865*y**7-27165*y**8+1625*y**9)
          -r**26*(6705390-49299672*y+156444939*y**2-281748970*y**3+318382031*y**4
          -234158108*y**5+110231882*y**6-29682144*y**7+2662120*y**8+574644*y**9
          -90037*y**10+650*y**11+2875*y**12)+r**24*(27853734-212915538*y+695174517*y**2
          -1248420207*y**3+1320118179*y**4-808824359*y**5+259162170*y**6-45448070*y**7
          +31990548*y**8-26146704*y**9+8415985*y**10-1012187*y**11+132483*y**12
          -13351*y**13)+r**22*(119834358-860601756*y+2651442549*y**2-4732388556*y**3
          +5762343100*y**4-5517066176*y**5+4435344847*y**6-2755491128*y**7+1111528822*y**8
          -222396380*y**9+4534083*y**10+2913924*y**11-253256*y**12+221624*y**13
          -10855*y**14)+(-1+y)**11*(171+1368*y+6156*y**2+18890*y**3+49693*y**4
          +85288*y**5-52480*y**6-141140*y**7+121133*y**8+23008*y**9-65684*y**10
          +21562*y**11-741*y**12-48*y**13+24*y**14)+r**2*(-1+y)**10*(8379+59046*y
          +237132*y**2+728948*y**3+1963095*y**4+3435322*y**5-1038632*y**6-4321224*y**7
          -312791*y**8+1048250*y**9+1465364*y**10-1210924*y**11+247557*y**12-2842*y**13
          +520*y**14)+r**4*(-1+y)**9*(-756390-4292304*y-14309151*y**2-25315392*y**3
          -18986732*y**4+24253090*y**5+32185573*y**6-361688*y**7-53446526*y**8
          +31259164*y**9-60285*y**10-3684504*y**11+839104*y**12-32542*y**13+4583*y**14)
          +r**6*(-1+y)**8*(2728050+10051692*y+23379807*y**2-17503380*y**3-105132180*y**4
          -214240720*y**5+122124181*y**6+16623416*y**7+146304610*y**8-162437940*y**9
          +55190825*y**10-7415268*y**11+1464832*y**12-185000*y**13+23075*y**14)
          +r**8*(-1+y)**7*(70781622+217847688*y+429524475*y**2+276777580*y**3
          -202746070*y**4-645663554*y**5-770313371*y**6+1146353280*y**7+140474010*y**8
          -548384980*y**9+223610157*y**10-35033692*y**11+5458870*y**12-649890*y**13
          +75875*y**14)+3*r**16*(-1+y)**3*(-977199580+2451404248*y-1460610047*y**2
          -4001733720*y**3+7987787520*y**4-4758368710*y**5+467828659*y**6-386817256*y**7
          +1122124340*y**8-660479900*y**9+165592335*y**10-23473712*y**11+5693848*y**12
          -836550*y**13+96525*y**14)+r**18*(-1+y)**2*(-510650316+2409209256*y
          -3286672755*y**2-3057156280*y**3+14282307640*y**4-17194395608*y**5+9134522153*y**6
          -1695564080*y**7+195020060*y**8-549575240*y**9+332770399*y**10-73328984*y**11
          +11245560*y**12-1252680*y**13+160875*y**14)+r**10*(-1+y)**6*(168669150
          +283479756*y+274391061*y**2-642791080*y**3-257261546*y**4-431894260*y**5
          +1871321141*y**6-1208302896*y**7+367040914*y**8-402566236*y**9+327195855*y**10
          -98312552*y**11+16983930*y**12-1544764*y**13+173927*y**14)+r**12*(-1
          +y)**5*(1797897090+761883936*y-65188215*y**2-5883097896*y**3+533851040*y**4
          +2847124210*y**5+5773940793*y**6-8417237640*y**7+3522163602*y**8-723166500*y**9
          +331329555*y**10-130921824*y**11+27487260*y**12-2585726*y**13+286715*y**14)
          +r**14*(-1+y)**4*(2838822618-1722510420*y-2397574809*y**2-946163356*y**3
          +2289411824*y**4+1859630744*y**5+1537241145*y**6-7639135992*y**7+6227315682*y**8
          -2111423268*y**9+442620393*y**10-95843820*y**11+25425556*y**12-3070496*y**13
          +342199*y**14)+r**20*(1521596178-9684806466*y+25616779269*y**2-34466969381*y**3
          +19854484076*y**4+7427884718*y**5-20945403561*y**6+15234005959*y**7-5467630366*y**8
          +1131377090*y**9-357981453*y**10+178129977*y**11-46685728*y**12+5396722*y**13
          -219791*y**14+42757*y**15)))*math.log(mu0**2/r**2))/(-3483648000*logy**5*r**20*(
          -1+y)**10+14000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-1451520000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-241920000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-20160000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -840000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*(-1512000*logy**3*r**12*(19+19*r**2+11*r**4
          +3*r**6)*(-1+y)**8-3600*logy**2*r**8*(-1+y)**6*(175*r**12*(-1+y)**2+255*r**14*(
          -1+y)**2-7*r**10*(-897+1254*y-87*y**2-340*y**3+90*y**4)+35*r**8*(405
          -414*y-189*y**2+204*y**3-38*y**4+8*y**5)-35*r**2*(-1+y)**2*(213-5*y**4
          -32*y**5+4*y**6)+35*r**6*(275+134*y-751*y**2+196*y**3+143*y**4-82*y**5
          +25*y**6)+35*r**4*(-669+2022*y-1695*y**2+52*y**3+495*y**4-282*y**5
          +77*y**6)+(-1+y)**3*(-361-361*y-361*y**2-4001*y**3+3804*y**4-900*y**5
          +80*y**6))-60*logy*r**4*(-1+y)**4*(-1+r**2+y)**2*(355*r**18*(-1+y)**4
          -r**16*(-1+y)**2*(-1153+3016*y-2573*y**2+1470*y**3)-r**14*(-1+y)**2*(
          -64706+101828*y-25903*y**2-10734*y**3+1755*y**4)+r**12*(-1+y)**2*(8214
          -66656*y+94159*y**2-16866*y**3-12551*y**4+5180*y**5)+r**10*(692212
          -2030424*y+1848647*y**2-169180*y**3-586485*y**4+241888*y**5+27709*y**6
          -25452*y**7+2485*y**8)+r**2*(-1+y)**3*(19399+17793*y+16187*y**2+142341*y**3
          -189095*y**4+52111*y**5-17483*y**6+7323*y**7+1544*y**8+280*y**9)-5*r**8*(
          -436732+1374912*y-1414175*y**2+301728*y**3+420651*y**4-337498*y**5
          +90783*y**6+5140*y**7-8743*y**8+1414*y**9)-(-1+y)**4*(-803-1606*y
          -2409*y**2-13492*y**3+4295*y**4-1662*y**5-7059*y**6+18944*y**7-10248*y**8
          +1440*y**9)+r**4*(-1+y)**2*(115834+6128*y-13123*y**2-627214*y**3+1390935*y**4
          -1107204*y**5+299327*y**6+34778*y**7-29781*y**8+5920*y**9)+r**6*(883662
          -2380808*y+1934387*y**2-460068*y**3+323372*y**4-509292*y**5+263858*y**6
          -41212*y**7-26282*y**8+12628*y**9-245*y**10))+(-1+y)**2*(-1+r**2
          +y)**3*(23*r**24*(-1+y)**6+r**22*(-1+y)**4*(-1636+3203*y-1498*y**2
          +611*y**3)-r**20*(-1+y)**2*(53282-196667*y+264360*y**2-147190*y**3
          +20590*y**4+6593*y**5+32*y**6)-5*r**18*(-1+y)**2*(-10084+25495*y-2964*y**2
          -59086*y**3+67984*y**4-18137*y**5-3136*y**6+768*y**7)-5*r**16*(-1+y)**2*(981683
          -3134849*y+3304164*y**2-878638*y**3-577695*y**4+335767*y**5-23846*y**6
          -7224*y**7+78*y**8)+2*r**14*(-1+y)**2*(5042852-15034913*y+12846762*y**2
          +344847*y**3-4593008*y**4+1133298*y**5+522238*y**6-184337*y**7-20172*y**8
          +5433*y**9)+r**4*(-1+y)**4*(239598+215739*y+172968*y**2+711145*y**3
          -1068910*y**4-13636*y**5-698198*y**6+2381464*y**7-2629420*y**8+1381385*y**9
          -259362*y**10-13441*y**11+668*y**12)+5*r**6*(-1+y)**3*(61652+93801*y
          -18903*y**2-1950935*y**3+5284025*y**4-5051584*y**5+1856368*y**6+72856*y**7
          -504180*y**8+374135*y**9-110233*y**10+4191*y**11+807*y**12)-(-1+y)**6*(
          -863-2589*y-5178*y**2-18310*y**3-7640*y**4-6544*y**5-7722*y**6+26426*y**7
          -4265*y**8+1565*y**9-668*y**10-3764*y**11+1552*y**12)-5*r**8*(-1+y)**2*(1495819
          -2607070*y+733134*y**2-3703654*y**3+14693541*y**4-21082902*y**5+14135366*y**6
          -3338562*y**7-900021*y**8+514084*y**9-5492*y**10-19896*y**11+1653*y**12)
          +2*r**12*(-24565894+116636943*y-212534784*y**2+167628370*y**3-16908815*y**4
          -61310837*y**5+33962579*y**6+2466173*y**7-7236645*y**8+1921290*y**9
          +4081*y**10-50547*y**11+2086*y**12)-r**2*(-1+y)**5*(-24876-47163*y
          -66861*y**2-298290*y**3+176270*y**4-4768*y**5-46084*y**6+399422*y**7
          -301510*y**8+50555*y**9-6031*y**10-2428*y**11+3764*y**12)-2*r**10*(13546628
          -58709229*y+95512344*y**2-62747978*y**3-12826120*y**4+65626674*y**5
          -74365612*y**6+48658242*y**7-16017164*y**8+210745*y**9+1369948*y**10
          -237784*y**11-27336*y**12+6642*y**13)))*nlo.X1El(0,'SLT',y/2,r))/(580608000*logy**4*r**16*(
          -1+y)**8+193536000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+24192000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+1344000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +28000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-18144000*logy**4*r**16*(27+45*r**2+31*r**4+9*r**6)*(-1+y)**10
          -86400*logy**3*r**12*(-1+y)**8*(11*r**14*(-1+y)**2+21*r**12*(61-122*y
          +61*y**2+5*y**3)+35*r**10*(393-570*y+69*y**2+106*y**3+9*y**4)+35*r**8*(627
          -510*y-489*y**2+275*y**3+79*y**4+17*y**5)-7*r**2*(-1+y)**2*(1073
          -1350*y**3+550*y**4-208*y**5+10*y**6)-5*(-1+y)**3*(135+135*y+135*y**2
          -614*y**3+366*y**4-138*y**5+16*y**6)+35*r**6*(-69+1218*y-1689*y**2
          +248*y**3+285*y**4-18*y**5+20*y**6)+7*r**4*(-3963+11166*y-8823*y**2
          +505*y**3+735*y**4+378*y**5-46*y**6+48*y**7))-1440*logy**2*r**8*(-1
          +y)**6*(-1+r**2+y)**2*(-858*r**18*(-1+y)**4+3*r**16*(-1+y)**2*(1590
          -2608*y+446*y**2+1557*y**3)+r**14*(-1+y)**2*(19848-45540*y+29952*y**2
          -15256*y**3+7111*y**4)+r**12*(359736-1251924*y+1532808*y**2-655400*y**3
          -48305*y**4+34364*y**5+39039*y**6-11018*y**7)+r**10*(2485944-7767768*y
          +7970934*y**2-2029980*y**3-1169505*y**4+520106*y**5-54377*y**6+47376*y**7
          -6230*y**8)+r**2*(-1+y)**3*(37566+34914*y+32262*y**2-224510*y**3+155163*y**4
          -88381*y**5-40179*y**6+75373*y**7-17630*y**8+1822*y**9)+(-1+y)**4*(1326
          +2652*y+3978*y**2-6341*y**3+9815*y**4-181*y**5-76607*y**6+83592*y**7
          -30714*y**8+4080*y**9)-r**4*(-1+y)**2*(-64872-49020*y+7752*y**2-233016*y**3
          +970011*y**4-707938*y**5+87710*y**6+110288*y**7-79619*y**8+9104*y**9)
          +r**8*(3974928-12037032*y+11775918*y**2-3055402*y**3-666477*y**4-157528*y**5
          +10507*y**6+203407*y**7-76748*y**8+20027*y**9)+r**6*(1594200-4240116*y
          +3338664*y**2-1732136*y**3+3861529*y**4-4576586*y**5+2195291*y**6-496964*y**7
          +42461*y**8+6846*y**9+6811*y**10))-24*logy*r**4*(-1+y)**4*(-1+r**2
          +y)**3*(69*r**24*(-1+y)**6+r**22*(-1+y)**4*(-13378+26549*y-12964*y**2
          +9408*y**3)+r**20*(-1+y)**2*(-117216+405831*y-502230*y**2+203065*y**3
          +77070*y**4-80274*y**5+3854*y**6)-5*r**18*(-1+y)**2*(-281370+953277*y
          -1092240*y**2+230149*y**3+345304*y**4-125186*y**5-38328*y**6+10774*y**7)
          -5*r**16*(-1+y)**2*(-160949+839351*y-1664388*y**2+2294421*y**3-2273185*y**4
          +1094084*y**5-71966*y**6-81842*y**7+3614*y**8)+2*r**14*(18834426-93118401*y
          +180359100*y**2-159292710*y**3+39232720*y**4+33962588*y**5-20667448*y**6
          -2653250*y**7+3664510*y**8+10655*y**9-403064*y**10+74374*y**11)-5*r**8*(
          -1+y)**2*(-3796035+5912958*y-764790*y**2+1397586*y**3+2533181*y**4
          -15622054*y**5+11514300*y**6+634786*y**7-2795361*y**8+738344*y**9+234814*y**10
          -187908*y**11+11179*y**12)-(-1+y)**6*(1821+5463*y+10926*y**2-12245*y**3
          +14640*y**4+2933*y**5-224516*y**6+180643*y**7-53005*y**8-101140*y**9
          +207246*y**10-114822*y**11+19056*y**12)+5*r**6*(-1+y)**3*(358794-516387*y
          -58179*y**2-3311220*y**3+9559820*y**4-8638718*y**5+626634*y**6+7443848*y**7
          -8059270*y**8+3270165*y**9-411491*y**10-34912*y**11+22916*y**12)-r**2*(
          -1+y)**5*(63762+122061*y+174897*y**2-541315*y**3+428765*y**4-240979*y**5
          -3214947*y**6+4457761*y**7-2046285*y**8+328010*y**9+276742*y**10-222714*y**11
          +36242*y**12)+2*r**12*(83422008-387990531*y+693334908*y**2-545331780*y**3
          +87201940*y**4+152049044*y**5-119260008*y**6+53204734*y**7-20604320*y**8
          +2937585*y**9+1575098*y**10-551936*y**11+44758*y**12)+r**4*(-1+y)**4*(
          -650896-624193*y-528856*y**2+5379650*y**3-2740490*y**4+1087862*y**5
          -8497684*y**6+21086452*y**7-20641400*y**8+7846615*y**9-655216*y**10
          -167498*y**11+50654*y**12)-2*r**10*(-57748406+245719263*y-388898148*y**2
          +302262166*y**3-245956960*y**4+374190652*y**5-378818136*y**6+177794486*y**7
          -17022942*y**8-19135415*y**9+8736004*y**10-770752*y**11-417588*y**12
          +65776*y**13))-(-1+y)**2*(-1+r**2+y)**4*(17*r**30*(-1+y)**8-r**28*(
          -1+y)**6*(-227+522*y-363*y**2+338*y**3)-r**26*(-1+y)**4*(21949-88476*y
          +133416*y**2-112584*y**3+65851*y**4-16928*y**5+3852*y**6)-r**24*(-1
          +y)**2*(430719-2351718*y+5228931*y**2-6325094*y**3+4802997*y**4-2470764*y**5
          +715713*y**6+51754*y**7-97256*y**8+9518*y**9)-r**22*(-1+y)**2*(447183
          -1360194*y+515541*y**2+5804716*y**3-16862174*y**4+22039960*y**5-14162216*y**6
          +3518124*y**7+159499*y**8-114686*y**9+247*y**10)+r**20*(-1+y)**2*(32382243
          -160063230*y+309128697*y**2-246000838*y**3-26131778*y**4+183468776*y**5
          -113203208*y**6+15174678*y**7+6941363*y**8-1634222*y**9-112869*y**10
          +22388*y**11)+r**18*(-1+y)**2*(-50057749+224361630*y-353832561*y**2
          -18276340*y**3+863222480*y**4-1271520652*y**5+804186060*y**6-181034988*y**7
          -37398135*y**8+21054870*y**9-754499*y**10-296040*y**11+9924*y**12)+r**16*(699666713
          -4569035124*y+12424707918*y**2-17115397390*y**3+9533226357*y**4+5930873660*y**5
          -14530125412*y**6+11190586604*y**7-4128500505*y**8+459803976*y**9+115779106*y**10
          +9332286*y**11-26161397*y**12+5161520*y**13+50292*y**14-24604*y**15)
          +(-1+y)**8*(507+2028*y+5070*y**2-3298*y**3-521*y**4-5820*y**5-93116*y**6
          +25000*y**7-13939*y**8-34968*y**9+99834*y**10-34662*y**11+2305*y**12
          -888*y**13-6636*y**14+3104*y**15)+r**2*(-1+y)**7*(20143+58401*y+112746*y**2
          -227094*y**3+65111*y**4-140443*y**5-2139212*y**6+2195548*y**7-685247*y**8
          -447057*y**9+1848422*y**10-1390314*y**11+301081*y**12-13909*y**13-20804*y**14
          +14628*y**15)+r**6*(-1+y)**5*(1123789+1530993*y+1211379*y**2-11716185*y**3
          -5347059*y**4+11003665*y**5+70011309*y**6-209692563*y**7+230063015*y**8
          -104828637*y**9-2796827*y**10+31138073*y**11-19449441*y**12+4764795*y**13
          -175429*y**14+23123*y**15)+r**4*(-1+y)**6*(289481+544122*y+747141*y**2
          -3456150*y**3+1450829*y**4-1563490*y**5-8441729*y**6+12332108*y**7-3717685*y**8
          +3555182*y**9-8640973*y**10+9664482*y**11-5529249*y**12+1205210*y**13
          -31511*y**14+24232*y**15)+r**8*(-1+y)**4*(-10415253+10719144*y+2296764*y**2
          +95423954*y**3-247832381*y**4+219005868*y**5-132303988*y**6+231250022*y**7
          -422695383*y**8+394057112*y**9-171233252*y**10+34988094*y**11-12333911*y**12
          +5746804*y**13-644356*y**14+50762*y**15)+r**12*(-1+y)**2*(294570801
          -965957058*y+1022311887*y**2-500901378*y**3+550491897*y**4-387715666*y**5
          -429944829*y**6+806037506*y**7-936288789*y**8+1062594986*y**9-722414891*y**10
          +233292762*y**11-28825893*y**12+1646042*y**13-571383*y**14+106006*y**15)
          +r**10*(-1+y)**3*(-16648833+4535421*y+34135380*y**2-54455736*y**3+413968203*y**4
          -988618379*y**5+655733388*y**6+752377420*y**7-1845868323*y**8+1598447599*y**9
          -657273388*y**10+93831816*y**11+5964825*y**12+1626559*y**13-1004052*y**14
          +112100*y**15)+r**14*(1051085963-6174799592*y+14752108812*y**2-18556072888*y**3
          +15271756072*y**4-14701937512*y**5+18372747648*y**6-15847758624*y**7
          +6753587626*y**8-638445144*y**9-118363340*y**10-388188520*y**11+292363312*y**12
          -74538488*y**13+6343072*y**14+95264*y**15+16339*y**16)))*nlo.X1El(0,'SM',y/2,r))/(6967296000*logy**5*r**20*(
          -1+y)**10-28000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5+2903040000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+483840000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+40320000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +1680000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6
          +120*logy*r**4*(-1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(
          -67+98*y-13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3
          -2*y**4+y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)
          +2*r**2*(-1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y
          -421*y**2+40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(
          -1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1
          +y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(
          -4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y
          +45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)
          +2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5
          -56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(1,'SLT',y/2,r))/(345600*logy**3*r**12*(
          -1+y)**6-200*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +86400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+7200*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(43200*logy**3*r**12*(6+8*r**2
          +3*r**4)*(-1+y)**8+720*logy**2*r**8*(-1+y)**6*(-10*r**12*(-1+y)**2+r**10*(112
          -224*y+112*y**2+15*y**3)+5*r**8*(197-286*y+35*y**2+45*y**3+15*y**4)
          +5*r**2*(-1+y)**2*(-80+131*y**3-30*y**4+6*y**5)+5*r**6*(96+96*y-336*y**2
          +74*y**3+68*y**4+11*y**5)+(-1+y)**3*(-43-43*y-43*y**2+272*y**3
          -118*y**4+20*y**5)+5*r**4*(-242+700*y-566*y**2+14*y**3+56*y**4+35*y**5
          +3*y**6))-12*logy*r**4*(-1+y)**4*(-1+r**2+y)**2*(29*r**16*(-1+y)**4
          -2*r**14*(-1+y)**2*(31-33*y-27*y**2+164*y**3)-r**12*(-1+y)**2*(-1667
          +2068*y+178*y**2-1662*y**3+543*y**4)+2*r**10*(-12542+43014*y-50602*y**2
          +17365*y**3+7030*y**4-3863*y**5-604*y**6+302*y**7)+5*r**8*(-20857+64512*y
          -65192*y**2+16974*y**3+6060*y**4-918*y**5+558*y**6-1088*y**7+131*y**8)
          +2*(-1+y)**4*(-38-76*y-114*y**2+393*y**3-15*y**4+123*y**5+911*y**6
          -926*y**7+192*y**8)+2*r**2*(-1+y)**3*(-824-748*y-672*y**2+6839*y**3
          -3535*y**4+1139*y**5+863*y**6-1488*y**7+226*y**8)-r**4*(-1+y)**2*(1423
          +2016*y-336*y**2+19362*y**3-59740*y**4+33812*y**5-1556*y**6-1354*y**7
          +973*y**8)-2*r**6*(28007-75003*y+59332*y**2-34883*y**3+79412*y**4
          -85107*y**5+30828*y**6-2207*y**7-967*y**8+588*y**9))+(-1+y)**2*(-1
          +r**2+y)**3*(4*r**22*(-1+y)**6+r**20*(-1+y)**4*(-100+188*y-76*y**2
          +27*y**3)-r**18*(-1+y)**2*(47-128*y+192*y**2-98*y**3-193*y**4+270*y**5
          +10*y**6)-5*r**16*(-1+y)**2*(-103+247*y-96*y**2-1823*y**3+3011*y**4
          -1146*y**5-102*y**6+36*y**7)-2*r**14*(-1+y)**2*(6199-14434*y+5025*y**2
          +36260*y**3-64175*y**4+36546*y**5-5871*y**6-780*y**7+30*y**8)+10*r**6*(
          -1+y)**3*(1111-1227*y-198*y**2-11894*y**3+29778*y**4-20526*y**5+378*y**6
          +11606*y**7-11533*y**8+3765*y**9-72*y**10+12*y**11)+(-1+y)**6*(-11
          -33*y-66*y**2+173*y**3+132*y**4+213*y**5+676*y**6-349*y**7-13*y**8
          -72*y**9-142*y**10+92*y**11)+2*r**8*(-1+y)**2*(34076-53144*y+5346*y**2
          +8891*y**3-118364*y**4+284559*y**5-183226*y**6+34579*y**7-23016*y**8
          +16839*y**9-2160*y**10+120*y**11)+2*r**12*(150583-744759*y+1435932*y**2
          -1179323*y**3-24558*y**4+823686*y**5-648750*y**6+211988*y**7-24157*y**8
          +453*y**9-1074*y**10+279*y**11)+r**2*(-1+y)**5*(-335-637*y-906*y**2
          +4904*y**3-236*y**4+1704*y**5+7298*y**6-10754*y**7+2811*y**8-299*y**9
          -304*y**10+354*y**11)+r**4*(-1+y)**4*(-2522-2462*y-2012*y**2+27083*y**3
          -8452*y**4+2072*y**5-17188*y**6+41702*y**7-41818*y**8+12142*y**9+40*y**10
          +415*y**11)+4*r**10*(97604-419274*y+670329*y**2-550167*y**3+542478*y**4
          -847980*y**5+799206*y**6-331290*y**7+27942*y**8+9922*y**9+2751*y**10
          -1707*y**11+186*y**12)))*nlo.X1El(1,'SM',y/2,r))/(2073600*logy**4*r**16*(-1
          +y)**8+691200*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+86400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1
          +y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+4800*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +100*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-180*logy*r**4*(3+r**2)*(-1+y)**4-3*(-1+y)**2*(-15*r**8*(-1+y)**2
          +3*r**10*(-1+y)**2+15*r**2*(-1+y)**2*(-5+y**4)-10*r**6*(-20+34*y
          -11*y**2-2*y**3+y**4)+30*r**4*(-4+14*y-13*y**2+2*y**3+y**4)+(-1
          +y)**3*(-7-7*y-7*y**2-7*y**3+8*y**4)))*nlo.X1El(2,'SLT',y/2,r))/(2880*logy**2*r**8*(
          -1+y)**4+480*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-2160*logy**2*r**8*(1+r**2)*(-1
          +y)**6+72*logy*r**4*(-1+y)**4*(3*r**10*(-1+y)**2-5*r**8*(5-10*y+5*y**2
          +y**3)+5*r**2*(-1+y)**2*(5-16*y**3+2*y**4)-5*r**6*(12-12*y-6*y**2
          +4*y**3+5*y**4)+(-1+y)**3*(3+3*y+3*y**2-32*y**3+8*y**4)-15*r**4*(
          -4+12*y-10*y**2-2*y**3+3*y**4+y**5))-3*(-1+y)**2*(-1+r**2+y)**2*(r**14*(
          -1+y)**4+r**12*(-1+y)**2*(-21+40*y-17*y**2+12*y**3)+r**10*(-1+y)**2*(
          -3-26*y+28*y**2-90*y**3+21*y**4)+r**8*(743-2470*y+2765*y**2-330*y**3
          -1465*y**4+832*y**5-115*y**6)+(-1+y)**4*(1+2*y+3*y**2-26*y**3-11*y**4
          -12*y**5-13*y**6+16*y**7)+r**4*(-1+y)**2*(-3+32*y-y**2+360*y**3
          -1265*y**4+568*y**5+33*y**6+36*y**7)+r**2*(-1+y)**3*(21+19*y+17*y**2
          -341*y**3+109*y**4-17*y**5-15*y**6+47*y**7)+r**6*(743-1988*y+1560*y**2
          -1500*y**3+3930*y**4-3948*y**5+1188*y**6+20*y**7-5*y**8)))*nlo.X1El(2,'SM',y/2,r))/(34560*logy**3*r**12*(
          -1+y)**6-20*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +8640*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+720*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(3,'SLT',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +(2*api*(-1+y)**2*y**3*(-1+r**2+y)**3*nlo.X1El(3,'SM',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      res += resNP*wc.SLT

    if wc.T2 != 0:
      resNP = 0
      resNP +=((-18144000*logy**4*r**16*(3+5*r**2+5*r**4+3*r**6)*(-1+y)**8-345600*logy**3*r**12*(
          -1+y)**6*(154*r**12*(-1+y)**2+r**14*(-1+y)**2+7*r**10*(108-126*y-27*y**2
          +50*y**3)-(-1+y)**5*(-1-3*y-6*y**2-45*y**3+20*y**4)+35*r**8*(9
          +12*y-36*y**2+13*y**3+2*y**4+y**5)+7*r**4*(-1+y)**2*(-108+90*y
          +45*y**2-20*y**3+5*y**4+3*y**5)-7*r**2*(-1+y)**3*(-22-22*y-22*y**2
          +38*y**3-27*y**4+5*y**5)+35*r**6*(-9+48*y-54*y**2+2*y**3+19*y**4
          -8*y**5+2*y**6))+1440*logy**2*r**8*(-1+y)**5*(-1+r**2+y)**2*(291*r**18*(
          -1+y)**3+r**16*(1137-2829*y+1665*y**2+1309*y**3-1282*y**4)+r**14*(16740
          -51192*y+52623*y**2-24557*y**3+8393*y**4-2007*y**5)+r**12*(122268
          -289656*y+191745*y**2+8285*y**3-27385*y**4-8393*y**5+3136*y**6)-r**2*(
          -1+y)**4*(-1137-2829*y-4494*y**2-15070*y**3+14275*y**4+6247*y**5
          -5036*y**6+1044*y**7)-r**6*(-1+y)**2*(-122268-45120*y-24357*y**2+245305*y**3
          -174190*y**4+49538*y**5-3045*y**6+1337*y**7)-(-1+y)**5*(-291-1164*y
          -2910*y**2-3340*y**3+1445*y**4+7476*y**5-6156*y**6+1440*y**7)+r**10*(464946
          -906306*y+368505*y**2+231325*y**3-171540*y**4+32544*y**5-15379*y**6
          +1505*y**7)+r**4*(-1+y)**3*(-16740-34452*y-52623*y**2+6920*y**3+45050*y**4
          -16920*y**5-10283*y**6+2748*y**7)+r**8*(464946-953478*y+439263*y**2
          +199219*y**3-161610*y**4+22644*y**5-24557*y**6+19327*y**7-5754*y**8))
          -96*logy*r**4*(-1+y)**4*(-1+r**2+y)**3*(12*r**24*(-1+y)**4+r**22*(-1
          +y)**2*(-1199+2362*y-1127*y**2+454*y**3)+r**20*(-12518+44903*y-58725*y**2
          +31610*y**3-2725*y**4-3887*y**5+342*y**6)-(-1+y)**9*(12+96*y+432*y**2
          +1575*y**3+2305*y**4-677*y**5-1331*y**6+388*y**7)-5*r**18*(-27933+98433*y
          -120768*y**2+49174*y**3+6679*y**4-4478*y**5-2404*y**6+457*y**7)-5*r**16*(
          -65572+232348*y-300744*y**2+215938*y**3-134185*y**4+64217*y**5-6143*y**6
          -4751*y**7+292*y**8)-r**2*(-1+y)**6*(1199+5959*y+17769*y**2+36624*y**3
          +5779*y**4-60724*y**5+31991*y**6-744*y**7-3074*y**8+221*y**9)+5*r**6*(
          -1+y)**4*(27933+70500*y+120768*y**2+60797*y**3-134898*y**4-52028*y**5
          +109820*y**6-36523*y**7+3433*y**8+298*y**9)-5*r**8*(-1+y)**3*(65572
          +101204*y+133968*y**2-273817*y**3-43562*y**4+27058*y**5+36736*y**6
          -853*y**7-10378*y**8+1172*y**9)+r**4*(-1+y)**5*(12518+44903*y+103628*y**2
          -34697*y**3-81267*y**4-192293*y**5+280422*y**6-81803*y**7-1253*y**8
          +2342*y**9)-r**10*(-1+y)**2*(-2197406+636754*y+643714*y**2+3042869*y**3
          -4429546*y**4+1404906*y**5+198646*y**6-155139*y**7-21144*y**8+4846*y**9)
          +r**14*(2197406-5955464*y+4674996*y**2+946261*y**3-2733904*y**4+607694*y**5
          +355064*y**6-67571*y**7-23786*y**8+6304*y**9)+r**12*(6793548-16983870*y
          +11461050*y**2+3732595*y**3-8292565*y**4+4882394*y**5-2389780*y**6+816375*y**7
          +22855*y**8-48510*y**9+5908*y**10))+(-1+y)**2*(-1+r**2+y)**4*(11*r**30*(
          -1+y)**6+r**28*(-1+y)**4*(-479+914*y-391*y**2+124*y**3)+r**26*(-1
          +y)**2*(9223-36172*y+51992*y**2-36980*y**3+16203*y**4-3912*y**5+606*y**6)
          +r**24*(183773-1023706*y+2340017*y**2-2880520*y**3+2118901*y**4-958558*y**5
          +231551*y**6+28*y**7-16290*y**8+1604*y**9)-(-1+y)**10*(-11-88*y
          -396*y**2-1944*y**3-2722*y**4+2192*y**5+1068*y**6-1624*y**7+549*y**8
          +152*y**9+24*y**10)+r**22*(25671+391542*y-2179683*y**2+5043220*y**3
          -7266094*y**4+7054128*y**5-4176802*y**6+1185388*y**7-39625*y**8-28646*y**9
          +2101*y**10)-r**2*(-1+y)**9*(-479-3309*y-13060*y**2-55452*y**3-50994*y**4
          +89722*y**5-1900*y**6-45300*y**7+24617*y**8+59*y**9+72*y**10+24*y**11)
          -r**4*(-1+y)**8*(-9223-54618*y-188177*y**2-668880*y**3-632998*y**4
          +405180*y**5+366102*y**6+269032*y**7-346115*y**8+104478*y**9-1077*y**10
          +296*y**11)-r**20*(12852411-64149510*y+125547369*y**2-111520024*y**3
          +24464638*y**4+33275028*y**5-26384838*y**6+5596136*y**7+559079*y**8
          -245358*y**9+15741*y**10+528*y**11)-r**6*(-1+y)**7*(183773+839933*y
          +2340017*y**2+1666345*y**3-1567782*y**4-5654230*y**5+6374658*y**6-270382*y**7
          -1045335*y**8+333017*y**9-9683*y**10+1669*y**11)-r**8*(-1+y)**6*(-25671
          +442884*y+1762470*y**2+11781252*y**3+3575374*y**4+6460528*y**5-12276520*y**6
          +5679920*y**7-663487*y**8+306316*y**9-38742*y**10+5676*y**11)-r**10*(
          -1+y)**5*(-12852411-25592277*y-35805582*y**2+26724622*y**3+53217086*y**4
          +17819602*y**5-56414152*y**6+24386392*y**7-2091387*y**8+408699*y**9
          -95106*y**10+12914*y**11)-r**16*(-1+y)**2*(138714671-326090304*y+177216424*y**2
          +236673680*y**3-376425974*y**4+178712240*y**5-22302164*y**6-1607704*y**7
          -1299585*y**8+1054144*y**9-127116*y**10+17688*y**11)-r**12*(-1+y)**4*(
          -6196883-5423638*y+3381165*y**2-25732324*y**3+50863642*y**4-9236356*y**5
          -26330030*y**6+28810640*y**7-8350071*y**8+1541738*y**9-156431*y**10
          +20548*y**11)-r**14*(-1+y)**3*(-138714671+90053709*y+58820171*y**2
          +97353655*y**3-213918406*y**4+57558610*y**5+23487734*y**6+9454414*y**7
          -9736395*y**8+2273441*y**9-175329*y**10+23067*y**11)+r**18*(6196883
          -30211170*y+50071047*y**2+15276224*y**3-176117406*y**4+269399828*y**5
          -188779066*y**6+55829080*y**7+1953951*y**8-3883394*y**9+219539*y**10
          +52536*y**11-8052*y**12)))/(72576000*logy**4*r**16*(-1+y)**8+24192000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +3024000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**2+168000*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**3+3500*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((api*(435456000*logy**5*r**22*(5+10*r**2
          +9*r**4)*(-1+y)**10+1036800*logy**4*r**16*(-1+y)**8*(565*r**14*(-1+y)**2
          +14*r**12*(367-734*y+367*y**2+15*y**3)+7*r**10*(2367-2034*y-1683*y**2
          +1570*y**3)+1750*r**4*(-1+y)**2*(-3-y**3+y**4)+70*r**8*(-60+420*y
          -510*y**2+170*y**3-26*y**4+29*y**5)+7*r**2*(-1+y)**2*(-79-810*y**3
          +745*y**4-256*y**5+40*y**6)+8*(-1+y)**3*(-107-107*y-107*y**2+33*y**3
          +208*y**4-170*y**5+40*y**6)+35*r**6*(-375+1050*y-825*y**2+64*y**3
          +197*y**4-136*y**5+49*y**6))-34560*logy**3*r**12*(-1+y)**6*(-1+r**2
          +y)**2*(1977*r**18*(-1+y)**4-2*r**16*(-1+y)**2*(9420-16863*y+5466*y**2
          +4057*y**3)-r**14*(-1+y)**2*(198972-363870*y+158793*y**2-17144*y**3
          +7149*y**4)+4*(-1+y)**6*(-261-1044*y-2610*y**2-1750*y**3+2285*y**4
          +8046*y**5-8106*y**6+2040*y**7)+2*r**12*(-305682+1062483*y-1335681*y**2
          +631880*y**3+6620*y**4-46173*y**5-18753*y**6+4606*y**7)+r**10*(-1427886
          +3941142*y-3384351*y**2+168940*y**3+1208755*y**4-632994*y**5+161443*y**6
          -31024*y**7-6825*y**8)+r**2*(-1+y)**4*(24309+46530*y+66663*y**2+13108*y**3
          -74285*y**4-9414*y**5+48345*y**6-19208*y**7+1952*y**8)+r**6*(-1+y)**2*(
          -129540+183234*y+113997*y**2-913176*y**3+869955*y**4-272550*y**5+58431*y**6
          -31052*y**7+3101*y**8)-2*r**4*(-1+y)**3*(68946+40851*y+36870*y**2
          -123997*y**3-81010*y**4+111049*y**5-8826*y**6-17915*y**7+4832*y**8)
          -2*r**8*(400266-1059429*y+739536*y**2+547806*y**3-1279544*y**4+881384*y**5
          -220696*y**6-24086*y**7+11494*y**8+3269*y**9))-576*logy**2*r**8*(-1+y)**5*(
          -1+r**2+y)**3*(1023*r**24*(-1+y)**5-r**22*(-1+y)**3*(-60319+123707*y
          -66457*y**2+34479*y**3)+r**20*(-107843+367381*y-403328*y**2+47050*y**3
          +263205*y**4-284647*y**5+116734*y**6+1448*y**7)+5*r**18*(1449693-6539886*y
          +11396247*y**2-9155242*y**3+2918837*y**4-74496*y**5+177063*y**6-197600*y**7
          +25384*y**8)-10*r**16*(-2466553+10571519*y-17469241*y**2+13696479*y**3
          -4874910*y**4+477948*y**5+112841*y**6-69259*y**7+9391*y**8+11785*y**9)
          -4*(-1+y)**7*(1383+6915*y+20745*y**2+32285*y**3+25525*y**4-22661*y**5
          -66765*y**6-6845*y**7+87840*y**8-52950*y**9+9528*y**10)-r**2*(-1+y)**6*(1679
          -9880*y-66190*y**2+89730*y**3+627350*y**4+1126732*y**5-2484670*y**6
          +968890*y**7+126895*y**8-112000*y**9+11464*y**10)-5*r**6*(-1+y)**4*(1105011
          +1492956*y+1684095*y**2-2037270*y**3-3139662*y**4+613374*y**5+3579274*y**6
          -3108090*y**7+1159315*y**8-229538*y**9+28535*y**10)-5*r**8*(-1+y)**3*(
          -2625323-259178*y-472637*y**2+7696452*y**3-799128*y**4-4824828*y**5
          +494948*y**6+1256612*y**7-69837*y**8-209682*y**9+59001*y**10)+2*r**10*(
          -1+y)**2*(18450143-25433160*y-5976615*y**2+59665120*y**3-68478045*y**4
          +31383864*y**5-7604365*y**6+1287240*y**7+1187030*y**8-905280*y**9+78068*y**10)
          +r**4*(-1+y)**5*(204643+790290*y+1806150*y**2+4024000*y**3+1798320*y**4
          +650304*y**5-13425190*y**6+12031800*y**7-2983675*y**8-202970*y**9+94328*y**10)
          -2*r**14*(-21950383+82921220*y-117721030*y**2+61663680*y**3+14778825*y**4
          -25538154*y**5+5028955*y**6-930620*y**7+2689170*y**8-1129650*y**9+159987*y**10)
          +2*r**12*(43873299-129877209*y+113918805*y**2+26010075*y**3-110884515*y**4
          +74812437*y**5-12740707*y**6-12165455*y**7+9287600*y**8-2029860*y**9
          -268786*y**10+64316*y**11))-24*logy*r**4*(-1+y)**4*(-1+r**2+y)**4*(217*r**30*(
          -1+y)**6+2*r**28*(-1+y)**4*(-4101+7768*y-3233*y**2+886*y**3)+r**26*(
          -1+y)**2*(520359-2000392*y+2824700*y**2-1914940*y**3+727115*y**4-128404*y**5
          +19562*y**6)+4*r**24*(401441-2184916*y+4978763*y**2-6671107*y**3+6247129*y**4
          -4053211*y**5+1401281*y**6-40213*y**7-104558*y**8+6991*y**9)+r**22*(
          -18952287+113362050*y-276501213*y**2+363933464*y**3-296764694*y**4
          +171780012*y**5-75668530*y**6+21400808*y**7-2602619*y**8+301714*y**9
          -75905*y**10)+8*(-1+y)**10*(13+104*y+468*y**2+1158*y**3+1528*y**4
          -698*y**5-7030*y**6-6918*y**7+7867*y**8+4122*y**9-4190*y**10+776*y**11)
          -2*r**20*(124544235-611030988*y+1176977193*y**2-1049788412*y**3+309865958*y**4
          +139205688*y**5-81791246*y**6-25456168*y**7+18269487*y**8-12508*y**9
          -771323*y**10+77684*y**11)-r**2*(-1+y)**8*(24027+143746*y+501655*y**2
          +1035160*y**3+1395190*y**4+553836*y**5-2359722*y**6-1444920*y**7+2815615*y**8
          -1012990*y**9-6813*y**10+31376*y**11+3840*y**12)+r**6*(-1+y)**6*(4602259
          +16123464*y+35326212*y**2+47453820*y**3+29850475*y**4-7757888*y**5
          -146395688*y**6+105406536*y**7+14651905*y**8-33036200*y**9+10531204*y**10
          -1165476*y**11+9377*y**12)-2*r**4*(-1+y)**7*(-296853-1399343*y-4009127*y**2
          -4870165*y**3-11130*y**4+11750546*y**5+1661906*y**6-2208186*y**7-11348785*y**8
          +9642205*y**9-2322443*y**10+22287*y**11+29088*y**12)+r**18*(-372110441
          +1772602242*y-3407234241*y**2+3411673560*y**3-1887540470*y**4+416109292*y**5
          +329492486*y**6-440140888*y**7+211670515*y**8-30227230*y**9-4069701*y**10
          -264528*y**11+39404*y**12)+4*r**8*(-1+y)**5*(-1377117-5706501*y-13487382*y**2
          -22708615*y**3+8967445*y**4+8965554*y**5+79828992*y**6-92173326*y**7
          +27103765*y**8+135355*y**9+670638*y**10-695091*y**11+60283*y**12)+r**10*(
          -1+y)**4*(184424349+131980530*y+72765603*y**2-566729240*y**3-208481460*y**4
          +319585132*y**5+688823230*y**6-943395176*y**7+424503165*y**8-73103790*y**9
          +3613519*y**10-1529360*y**11+135498*y**12)-2*r**12*(-1+y)**3*(66426757
          +1802611*y+55629865*y**2-442838515*y**3+221939100*y**4+139769486*y**5
          -32505262*y**6+65099450*y**7-160960035*y**8+84749375*y**9-11028443*y**10
          -328199*y**11+147810*y**12)-r**14*(-1+y)**2*(1415582733-2173379492*y
          +19236982*y**2+2503226580*y**3-3148276065*y**4+2118443864*y**5-520303756*y**6
          -283352344*y**7+175632795*y**8+10624140*y**9-12339722*y**10+1162948*y**11
          +253337*y**12)+8*r**16*(-56304396+202969450*y-257584482*y**2+20669663*y**3
          +270476730*y**4-184740013*y**5-120099900*y**6+177038334*y**7-36278096*y**8
          -27745680*y**9+12636334*y**10-673725*y**11-377102*y**12+12883*y**13))
          +2*r**2*(-1+y)**2*(-1+r**2+y)**5*(33*r**34*(-1+y)**8+r**32*(-1+y)**6*(
          -1497+2829*y-1167*y**2+325*y**3)+r**30*(-1+y)**4*(29118-111756*y
          +155037*y**2-104508*y**3+43592*y**4-9736*y**5+1229*y**6)+r**28*(-1
          +y)**2*(-388662+2289522*y-5535765*y**2+7264495*y**3-5849705*y**4+3089957*y**5
          -1069567*y**6+234865*y**7-27165*y**8+1625*y**9)-r**26*(6705390-49299672*y
          +156444939*y**2-281748970*y**3+318382031*y**4-234158108*y**5+110231882*y**6
          -29682144*y**7+2662120*y**8+574644*y**9-90037*y**10+650*y**11+2875*y**12)
          +r**24*(27853734-212915538*y+695174517*y**2-1248420207*y**3+1320118179*y**4
          -808824359*y**5+259162170*y**6-45448070*y**7+31990548*y**8-26146704*y**9
          +8415985*y**10-1012187*y**11+132483*y**12-13351*y**13)+r**22*(119834358
          -860601756*y+2651442549*y**2-4732388556*y**3+5762343100*y**4-5517066176*y**5
          +4435344847*y**6-2755491128*y**7+1111528822*y**8-222396380*y**9+4534083*y**10
          +2913924*y**11-253256*y**12+221624*y**13-10855*y**14)+(-1+y)**11*(171
          +1368*y+6156*y**2+18890*y**3+49693*y**4+85288*y**5-52480*y**6-141140*y**7
          +121133*y**8+23008*y**9-65684*y**10+21562*y**11-741*y**12-48*y**13
          +24*y**14)+r**2*(-1+y)**10*(8379+59046*y+237132*y**2+728948*y**3+1963095*y**4
          +3435322*y**5-1038632*y**6-4321224*y**7-312791*y**8+1048250*y**9+1465364*y**10
          -1210924*y**11+247557*y**12-2842*y**13+520*y**14)+r**4*(-1+y)**9*(-756390
          -4292304*y-14309151*y**2-25315392*y**3-18986732*y**4+24253090*y**5
          +32185573*y**6-361688*y**7-53446526*y**8+31259164*y**9-60285*y**10-3684504*y**11
          +839104*y**12-32542*y**13+4583*y**14)+r**6*(-1+y)**8*(2728050+10051692*y
          +23379807*y**2-17503380*y**3-105132180*y**4-214240720*y**5+122124181*y**6
          +16623416*y**7+146304610*y**8-162437940*y**9+55190825*y**10-7415268*y**11
          +1464832*y**12-185000*y**13+23075*y**14)+r**8*(-1+y)**7*(70781622+217847688*y
          +429524475*y**2+276777580*y**3-202746070*y**4-645663554*y**5-770313371*y**6
          +1146353280*y**7+140474010*y**8-548384980*y**9+223610157*y**10-35033692*y**11
          +5458870*y**12-649890*y**13+75875*y**14)+3*r**16*(-1+y)**3*(-977199580
          +2451404248*y-1460610047*y**2-4001733720*y**3+7987787520*y**4-4758368710*y**5
          +467828659*y**6-386817256*y**7+1122124340*y**8-660479900*y**9+165592335*y**10
          -23473712*y**11+5693848*y**12-836550*y**13+96525*y**14)+r**18*(-1+y)**2*(
          -510650316+2409209256*y-3286672755*y**2-3057156280*y**3+14282307640*y**4
          -17194395608*y**5+9134522153*y**6-1695564080*y**7+195020060*y**8-549575240*y**9
          +332770399*y**10-73328984*y**11+11245560*y**12-1252680*y**13+160875*y**14)
          +r**10*(-1+y)**6*(168669150+283479756*y+274391061*y**2-642791080*y**3
          -257261546*y**4-431894260*y**5+1871321141*y**6-1208302896*y**7+367040914*y**8
          -402566236*y**9+327195855*y**10-98312552*y**11+16983930*y**12-1544764*y**13
          +173927*y**14)+r**12*(-1+y)**5*(1797897090+761883936*y-65188215*y**2
          -5883097896*y**3+533851040*y**4+2847124210*y**5+5773940793*y**6-8417237640*y**7
          +3522163602*y**8-723166500*y**9+331329555*y**10-130921824*y**11+27487260*y**12
          -2585726*y**13+286715*y**14)+r**14*(-1+y)**4*(2838822618-1722510420*y
          -2397574809*y**2-946163356*y**3+2289411824*y**4+1859630744*y**5+1537241145*y**6
          -7639135992*y**7+6227315682*y**8-2111423268*y**9+442620393*y**10-95843820*y**11
          +25425556*y**12-3070496*y**13+342199*y**14)+r**20*(1521596178-9684806466*y
          +25616779269*y**2-34466969381*y**3+19854484076*y**4+7427884718*y**5-20945403561*y**6
          +15234005959*y**7-5467630366*y**8+1131377090*y**9-357981453*y**10+178129977*y**11
          -46685728*y**12+5396722*y**13-219791*y**14+42757*y**15))))/(-653184000*logy**5*r**20*(
          -1+y)**10+2625*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-272160000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-45360000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-3780000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -157500*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*muWC*(870912000*logy**5*r**20*(-9-5*r**2+5*r**4
          +9*r**6)*(-1+y)**10+14515200*logy**4*r**16*(-1+y)**7*(203*r**14*(-1+y)**3
          +5*r**12*(-131+393*y-393*y**2+29*y**3+54*y**4)+r**10*(-1617+2151*y
          +1899*y**2-4973*y**3+2060*y**4)-5*r**2*(-1+y)**3*(-131+264*y**3-99*y**4
          +8*y**6)+5*r**8*(495-1785*y+2235*y**2-1235*y**3+150*y**4+18*y**5
          +26*y**6)-(-1+y)**3*(-203-130*y**3+525*y**4-432*y**5+120*y**6)+5*r**6*(495
          -1185*y+735*y**2+247*y**3-741*y**4+651*y**5-307*y**6+57*y**7)+r**4*(
          -1617+7551*y-11601*y**2+7517*y**3-2555*y**4+1287*y**5-551*y**6-79*y**7
          +48*y**8))+69120*logy**3*r**12*(-1+y)**5*(-1+r**2+y)**2*(-3021*r**18*(
          -1+y)**5+r**16*(-1+y)**2*(-43149+123405*y-111321*y**2+16103*y**3
          +13242*y**4)+r**14*(-1+y)**2*(-336864+920328*y-815997*y**2+180583*y**3
          -3147*y**4+15057*y**5)+(-1+y)**6*(-3021-9063*y-18126*y**2-1850*y**3
          +15195*y**4+38721*y**5-47472*y**6+13016*y**7)-7*r**12*(68832-324552*y
          +621123*y**2-489083*y**3+43230*y**4+113238*y**5-22053*y**6-12043*y**7
          +2508*y**8)-21*r**6*(-1+y)**2*(-22944+29480*y-10281*y**2+61923*y**3
          -85713*y**4+37699*y**5-13375*y**6+12261*y**7-4743*y**8+493*y**9)+7*r**10*(
          -89622+269166*y-249771*y**2-208273*y**3+639925*y**4-495193*y**5+141339*y**6
          -6079*y**7-4007*y**8+1315*y**9)-r**4*(-1+y)**3*(336864-90264*y-14067*y**2
          -104230*y**3-477393*y**4+673316*y**5-197281*y**6+17322*y**7-16115*y**8
          +6248*y**9)+r**2*(-1+y)**4*(43149+37107*y+31065*y**2-25177*y**3-73689*y**4
          +27081*y**5-17357*y**6+47005*y**7-33608*y**8+6424*y**9)+7*r**8*(89622
          -447810*y+875025*y**2-1083765*y**3+1076935*y**4-742129*y**5+254385*y**6
          -20675*y**7+9715*y**8-15285*y**9+3982*y**10))-5760*logy**2*r**8*(-1+y)**4*(
          -1+r**2+y)**3*(1311*r**24*(-1+y)**6-r**22*(-1+y)**3*(11728-39117*y
          +46983*y**2-27361*y**3+13039*y**4)+r**20*(-19360+185799*y-645990*y**2
          +1106367*y**3-1075388*y**4+690709*y**5-350918*y**6+124453*y**7-15672*y**8)
          +(-1+y)**8*(-1311-6555*y-19665*y**2-28823*y**3-11937*y**4+39391*y**5
          -6135*y**6+3075*y**7-7592*y**8+3152*y**9)+r**18*(-2554704+13902579*y
          -30729162*y**2+34003931*y**3-17879764*y**4+2213017*y**5+1108134*y**6
          +217065*y**7-325928*y**8+44832*y**9)+r**16*(-7558429+39461937*y-83844099*y**2
          +88695907*y**3-44401875*y**4+5637411*y**5+2507033*y**6-948731*y**7+769268*y**8
          -333580*y**9+15158*y**10)-14*r**12*y*(1353105-5412420*y+10765668*y**2
          -13332591*y**3+9520203*y**4-2592925*y**5-1091425*y**6+1175587*y**7-511944*y**8
          +155697*y**9-32495*y**10+3540*y**11)+r**8*(-1+y)**3*(-7558429+5888637*y
          +89151*y**2+3086869*y**3+9763542*y**4-17363724*y**5+3746386*y**6+4159264*y**7
          -1954609*y**8+495223*y**9-115817*y**10+4307*y**11)-r**4*(-1+y)**5*(19360
          +108359*y+204753*y**2+1108312*y**3+225646*y**4+132442*y**5-4565416*y**6
          +5037712*y**7-2071462*y**8+313879*y**9-31337*y**10+4952*y**11)+r**2*(
          -1+y)**6*(-11728-39117*y-86100*y**2-464*y**3+35804*y**4+232502*y**5
          -146252*y**6-117400*y**7-556*y**8+131871*y**9-63264*y**10+8704*y**11)
          +2*r**10*(-1+y)**2*(700048-979555*y+2582826*y**2-19971073*y**3+32077996*y**4
          -21619521*y**5+11473126*y**6-7453991*y**7+2776448*y**8+193584*y**9-314052*y**10
          +38564*y**11)-r**6*(-1+y)**4*(-2554704-1129059*y-665886*y**2+3637341*y**3
          +2168448*y**4-3096864*y**5-92528*y**6-22264*y**7-388136*y**8+717547*y**9
          -355562*y**10+51267*y**11)-2*r**14*(700048-3920781*y+11406504*y**2
          -7247584*y**3-15979872*y**4+24440355*y**5-8188942*y**6-2543059*y**7
          +984484*y**8+701522*y**9-382558*y**10+57883*y**11))+48*logy*r**4*(-1
          +y)**3*(-1+r**2+y)**4*(-113*r**30*(-1+y)**7+r**28*(-1+y)**4*(15825-47927*y
          +48831*y**2-14781*y**3+4692*y**4)-r**26*(-1+y)**2*(-1114065+5319437*y
          -10044660*y**2+9489876*y**3-4740209*y**4+1232501*y**5-79546*y**6+11866*y**7)
          +r**24*(-2996495+19584813*y-52725201*y**2+72459603*y**3-47042375*y**4
          +1969785*y**5+15127857*y**6-6436959*y**7-714718*y**8+897830*y**9-79340*y**10)
          +r**22*(-24460755+177174213*y-545341611*y**2+922486621*y**3-960320822*y**4
          +692263130*y**5-403754934*y**6+192631706*y**7-56139351*y**8+4480417*y**9
          +793345*y**10-13559*y**11)-(-1+y)**10*(113+791*y+3164*y**2+13044*y**3
          +70934*y**4+173418*y**5-156388*y**6-283964*y**7+217681*y**8+18791*y**9
          -45856*y**10+10672*y**11)+r**20*(-433512819+2525252721*y-6020947575*y**2
          +7173403721*y**3-3709164494*y**4-559685006*y**5+1606972674*y**6-609836334*y**7
          -9485671*y**8+38951469*y**9+230725*y**10-2066795*y**11+268184*y**12)
          +r**2*(-1+y)**8*(-15825-79577*y-240087*y**2-253719*y**3+952230*y**4
          +2420310*y**5-4421086*y**6+1099394*y**7+3398043*y**8-3002605*y**9+567765*y**10
          +253813*y**11-132432*y**12+13776*y**13)+r**4*(-1+y)**7*(1114065+4205372*y
          +10044660*y**2+5758520*y**3-3785175*y**4-24613160*y**5+2920376*y**6
          +14861120*y**7+12250155*y**8-23115300*y**9+9629620*y**10-1421848*y**11
          -28805*y**12+20400*y**13)-r**6*(-1+y)**6*(-2996495-7598833*y-11949732*y**2
          -19485564*y**3-575275*y**4-11263125*y**5+62191736*y**6-37603896*y**7
          +31308483*y**8-29963875*y**9+10737420*y**10+1466772*y**11-1022697*y**12
          +67081*y**13)+r**14*(-1+y)**2*(-965147565+2059671649*y-415335690*y**2
          -5227470070*y**3+9618250325*y**4-8251428705*y**5+4430367652*y**6-1472930980*y**7
          -157077715*y**8+404564175*y**9-139468730*y**10+6815674*y**11+2830795*y**12
          +71185*y**13)-r**8*(-1+y)**5*(24460755+54870438*y+81252309*y**2+167169788*y**3
          -66182380*y**4-36166960*y**5-801764286*y**6+1210132752*y**7-579997181*y**8
          +75514430*y**9+13928505*y**10-24252*y**11-1269786*y**12+91868*y**13)
          +r**10*(-1+y)**4*(433512819-75824193*y-102623745*y**2-780305173*y**3
          +82990460*y**4+610220052*y**5+208587406*y**6-961966810*y**7+902394251*y**8
          -496979385*y**9+140193779*y**10-13346513*y**11-925370*y**12+200422*y**13)
          +r**18*(-504963955+2945438989*y-7301925033*y**2+9577490319*y**3-6888657050*y**4
          +2542025110*y**5-202188738*y**6-635768594*y**7+892430057*y**8-552219575*y**9
          +130305595*y**10-37101*y**11-2658348*y**12+280324*y**13)+r**12*(-1+y)**3*(
          -504963955+589308696*y-233534154*y**2+378577412*y**3+1103462655*y**4
          -2039223420*y**5-140724652*y**6+1277594248*y**7-328708229*y**8-273370880*y**9
          +143646550*y**10-18893644*y**11-807719*y**12+373092*y**13)+r**16*(965147565
          -5661508871*y+13021765967*y**2-17673285109*y**3+17495627118*y**4-10899160130*y**5
          -635998298*y**6+7359758086*y**7-5307914727*y**8+1316917429*y**9+123568915*y**10
          -119353281*y**11+12491772*y**12+1965636*y**13-22072*y**14))+4*(-1+y)*(
          -1+r**2+y)**5*(33*r**36*(-1+y)**9+r**34*(-1+y)**6*(1326-3813*y+3483*y**2
          -1481*y**3+325*y**4)+r**32*(-1+y)**4*(-20739+98586*y-181662*y**2+178851*y**3
          -112969*y**4+45790*y**5-10910*y**6+1229*y**7)+r**30*(-1+y)**2*(1145052
          -7726878*y+22134438*y**2-35089973*y**3+33960091*y**4-21171867*y**5
          +8800361*y**6-2416747*y**7+419777*y**8-28999*y**9+1625*y**10)-r**28*(
          -9433440+76968954*y-275647794*y**2+568109819*y**3-739873078*y**4+622565585*y**5
          -319204430*y**6+67505084*y**7+27510706*y**8-25045342*y**9+7275960*y**10
          -722399*y**11+300*y**12+2875*y**13)+r**26*(-98635356+812525070*y-2916821502*y**2
          +5936379429*y**3-7422246151*y**4+5703224337*y**5-2430762895*y**6+294459234*y**7
          +194082302*y**8-73205408*y**9-3846716*y**10+5646665*y**11-877867*y**12
          +137009*y**13-13351*y**14)-(-1+y)**12*(-33-264*y-1188*y**2-3630*y**3
          -14359*y**4-35464*y**5+20096*y**6+55132*y**7-52551*y**8-7040*y**9+23772*y**10
          -8382*y**11+1231*y**12+256*y**13+24*y**14)+r**18*(-1+y)**3*y*(-50431788
          +151295364*y+26593086723*y**2-74740175600*y**3+77017111330*y**4-32368104344*y**5
          +4017426977*y**6-2454556656*y**7+3829578560*y**8-2242688220*y**9+678748917*y**10
          -130089856*y**11+21851018*y**12-2574000*y**13+289575*y**14)+r**2*(-1
          +y)**11*(1326+9117*y+35808*y**2+94334*y**3+379546*y**4+808091*y**5
          -993984*y**6-1009700*y**7+1706194*y**8-362749*y**9-419136*y**10+229422*y**11
          -51578*y**12-923*y**13-192*y**14+24*y**15)+r**4*(-1+y)**10*(20739+119325*y
          +399573*y**2+708632*y**3+2930009*y**4+5766347*y**5-4926455*y**6-1277096*y**7
          +3055781*y**8-2339253*y**9+212439*y**10+268600*y**11-318257*y**12+40957*y**13
          -2661*y**14+520*y**15)+r**6*(-1+y)**9*(1145052+5436774*y+15552612*y**2
          +17774229*y**3+4677520*y**4-29087686*y**5+27144292*y**6-13210139*y**7
          -26571028*y**8+27309330*y**9-7906724*y**10-3599041*y**11+1081352*y**12
          -11026*y**13-28100*y**14+4583*y**15)-r**24*(-48834792+315058542*y-709782786*y**2
          +260462595*y**3+2373615998*y**4-7212817826*y**5+11728971866*y**6-12274049863*y**7
          +8278811020*y**8-3346748166*y**9+645397418*y**10+7759597*y**11-19245746*y**12
          +1656490*y**13-220402*y**14+10855*y**15)+r**8*(-1+y)**8*(-9433440-29801754*y
          -62106378*y**2+15573159*y**3+81652990*y**4+211109390*y**5-58322222*y**6
          -250530019*y**7-171508748*y**8+393866290*y**9-202989870*y**10+31719881*y**11
          -1703298*y**12+536394*y**13-165450*y**14+23075*y**15)+r**10*(-1+y)**7*(
          -98635356-220712934*y-333726492*y**2+11846743*y**3+271620932*y**4+238019352*y**5
          +208811824*y**6-1110033899*y**7+569108732*y**8+139376530*y**9-305905356*y**10
          +137348625*y**11-35509444*y**12+5363740*y**13-604072*y**14+75875*y**15)
          +r**20*(-1+y)**2*(3349472934-18230284860*y+37268094372*y**2-29926537099*y**3
          -15221885828*y**4+60118586762*y**5-63083274684*y**6+33483535393*y**7
          -8162597114*y**8+535480280*y**9-499315116*y**10+440971599*y**11-124487960*y**12
          +16795018*y**13-1316172*y**14+160875*y**15)+r**12*(-1+y)**6*(-48834792
          +26785002*y+155037834*y**2+1658248997*y**3-749322302*y**4-463689272*y**5
          -5951970374*y**6+8780400685*y**7-4061183548*y**8+438354858*y**9-211745258*y**10
          +242186327*y**11-91912814*y**12+15259956*y**13-1482026*y**14+173927*y**15)
          +r**14*(-1+y)**5*(-3319493268+2002379934*y+1365611940*y**2+7580002413*y**3
          -6227082808*y**4-3914115954*y**5-5066548148*y**6+17049738105*y**7-13990357716*y**8
          +5664861426*y**9-1618854228*y**10+407351679*y**11-107911680*y**12+22250818*y**13
          -2544828*y**14+286715*y**15)+r**16*(-1+y)**4*(-3349472934+5216025678*y
          +1774683174*y**2+2126963483*y**3-18412758380*y**4+14349812602*y**5+1762304114*y**6
          +1222303977*y**7-11084368566*y**8+9269491650*y**9-3435282942*y**10+650272533*y**11
          -100627976*y**12+22806758*y**13-3087370*y**14+342199*y**15)+r**22*(-3319493268
          +24553566210*y-77563540026*y**2+132351767557*y**3-120220786041*y**4
          +28362519210*y**5+62636429914*y**6-82996577571*y**7+51230394683*y**8
          -18860498146*y**9+4573652466*y**10-911976481*y**11+202981197*y**12-44055690*y**13
          +5822062*y**14-248833*y**15+42757*y**16))))/(1959552000*logy**5*r**20*(-1
          +y)**10-7875*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5
          +816480000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+136080000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+11340000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +472500*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((muG*(217728000*logy**5*r**18*(-54-47*r**2-29*r**4
          +7*r**6+27*r**8)*(-1+y)**10-518400*logy**4*r**14*(-1+y)**7*(6929*r**16*(
          -1+y)**3+r**14*(28633-85899*y+85899*y**2-44803*y**3+7770*y**4)-7*r**12*(
          -6883+12549*y-399*y**2-3927*y**3+340*y**4+720*y**5)+4*(-1+y)**4*(
          -181-181*y-181*y**2-2386*y**3+2654*y**4-790*y**5+120*y**6)-7*r**10*(12183
          -38649*y+41799*y**2-12143*y**3+470*y**4-1970*y**5+710*y**6)-35*r**8*(2553
          -5919*y+3309*y**2+697*y**3+165*y**4-447*y**5-153*y**6+35*y**7)-7*r**4*(
          -1+y)**2*(-16301+32501*y-8100*y**2-14700*y**3+11335*y**4-5339*y**5
          +744*y**6+40*y**7)+r**2*(-1+y)**3*(-27089+59570*y**3-66885*y**4+43344*y**5
          -12320*y**6+1280*y**7)-7*r**6*(5103-1209*y-19941*y**2+12437*y**3+16865*y**4
          -20013*y**5+9829*y**6-3599*y**7+528*y**8))+17280*logy**3*r**10*(-1+y)**5*(
          -1+r**2+y)**2*(8241*r**20*(-1+y)**5-r**18*(-1+y)**2*(-216627+633399*y
          -600435*y**2+146221*y**3+28842*y**4)-r**16*(-1+y)**2*(-505896+1102980*y
          -664581*y**2-331427*y**3+180327*y**4+18397*y**5)+r**14*(-3298920+13293036*y
          -18930405*y**2+12383989*y**3-4205140*y**4+849280*y**5-113811*y**6+64335*y**7
          -364*y**8)+2*(-1+y)**6*(-2052-6156*y-12312*y**2+4745*y**3+6220*y**4
          +18237*y**5-9394*y**6-3998*y**7+1560*y**8)+r**12*(-4542486+17722506*y
          -24330519*y**2+18098119*y**3-12214905*y**4+5974021*y**5+726009*y**6
          -2038861*y**7+743981*y**8-95865*y**9)-r**4*(-1+y)**4*(-273495-366189*y
          -403131*y**2+3211199*y**3-3345879*y**4+1997575*y**5-641491*y**6+244991*y**7
          -83424*y**8+17544*y**9)+r**2*(-1+y)**5*(-7011-5814*y+3591*y**2+352224*y**3
          -13555*y**4+76226*y**5-505741*y**6+443784*y**7-188044*y**8+32640*y**9)
          -r**6*(-1+y)**3*(3247704-2524116*y-815487*y**2-7035094*y**3+12431633*y**4
          -8085024*y**5+2392051*y**6+176602*y**7-226761*y**8+41592*y**9)+r**8*(
          -1+y)**2*(11095248-23980596*y+11616315*y**2+7880051*y**3-9001163*y**4
          +5389017*y**5-3555639*y**6+1660275*y**7-632961*y**8+106253*y**9)+r**10*(4603770
          -17076282*y+21673827*y**2-86079*y**3-25490185*y**4+24219279*y**5-10019723*y**6
          +2700093*y**7-439951*y**8-105595*y**9+20846*y**10))+288*logy**2*r**6*(
          -1+y)**4*(-1+r**2+y)**3*(33327*r**26*(-1+y)**6-r**24*(-1+y)**3*(80660
          -341961*y+541923*y**2-399533*y**3+250711*y**4)+r**22*(-3010126+19202175*y
          -51058752*y**2+73060773*y**3-62020630*y**4+33936561*y**5-13393700*y**6
          +3644667*y**7-360968*y**8)+r**20*(-32788846+167912013*y-341227308*y**2
          +316666151*y**3-73207210*y**4-96003549*y**5+71630992*y**6-9932887*y**7
          -3739196*y**8+689840*y**9)+2*(-1+y)**8*(-2973-14865*y-44595*y**2
          -63820*y**3-63925*y**4-4699*y**5+42915*y**6+43670*y**7+16070*y**8-38750*y**9
          +8472*y**10)+5*r**18*(-2897071+13079265*y-27143745*y**2+21336569*y**3
          +9138191*y**4-24855057*y**5+16860255*y**6-10198205*y**7+6290116*y**8
          -1657196*y**9+46878*y**10)-r**4*(-1+y)**6*(-634850-1685649*y-3267180*y**2
          -776530*y**3-4116040*y**4-3157140*y**5+6191688*y**6-6994670*y**7+7425930*y**8
          -2134835*y**9+46940*y**10+72336*y**11)-5*r**8*(-1+y)**4*(6345064+2646181*y
          +1317430*y**2-88055151*y**3+122321712*y**4-80553168*y**5+26502392*y**6
          +6087560*y**7-9604104*y**8+4848083*y**9-971606*y**10+73007*y**11)-r**2*(
          -1+y)**7*(179219+699038*y+1703000*y**2+1023910*y**3-26530*y**4-2880658*y**5
          -1853836*y**6-20950*y**7+2787215*y**8-818220*y**9-356636*y**10+152448*y**11)
          +r**6*(-1+y)**5*(11227438+19507247*y+26313255*y**2-123889850*y**3+47639880*y**4
          -41804476*y**5+126479646*y**6-144743630*y**7+78095050*y**8-21699955*y**9
          +1187963*y**10+281432*y**11)-r**10*(-1+y)**3*(-363687383+507905175*y
          +13579545*y**2+324404435*y**3-1177858530*y**4+854941476*y**5-118155110*y**6
          -157292520*y**7+115007665*y**8-26372195*y**9+1609957*y**10+339485*y**11)
          +2*r**12*(-1+y)**2*(-431832634+1138826467*y-818384460*y**2-457902695*y**3
          +1010643230*y**4-776881257*y**5+491227116*y**6-202984365*y**7+35517020*y**8
          +493570*y**9-3110884*y**10+437892*y**11)-2*r**16*(-203848343+915217128*y
          -1500758535*y**2+1137788660*y**3-377585385*y**4-63934224*y**5+207913789*y**6
          -164947965*y**7+56726140*y**8-2342090*y**9-4409258*y**10+852083*y**11)
          -2*r**14*(-93105470+453481179*y-869155764*y**2+1213326020*y**3-1530711315*y**4
          +1179756885*y**5-219811333*y**6-302002347*y**7+242969305*y**8-99011860*y**9
          +28607285*y**10-4604021*y**11+261436*y**12))+12*logy*r**2*(-1+y)**3*(
          -1+r**2+y)**4*(701*r**32*(-1+y)**7-r**30*(-1+y)**4*(93673-283823*y
          +289431*y**2-92245*y**3+26164*y**4)+r**28*(-1+y)**2*(-4942095+23488275*y
          -44116808*y**2+41180532*y**3-19893627*y**4+4729239*y**5-98030*y**6+28514*y**7)
          +r**26*(41280227-274287089*y+766875613*y**2-1165262327*y**3+1029119407*y**4
          -518653993*y**5+135379979*y**6-19331653*y**7+8376602*y**8-4041322*y**9
          +320556*y**10)-2*(-1+y)**11*(-1-8*y-36*y**2+2462*y**3+10040*y**4
          +23480*y**5+29432*y**6+9466*y**7-14407*y**8-22960*y**9+2676*y**10+4656*y**11)
          +r**24*(29507041-212509647*y+672245445*y**2-1161179183*y**3+1262407360*y**4
          -1092581008*y**5+889053348*y**6-529624140*y**7+144545423*y**8+4286015*y**9
          -5208473*y**10+65819*y**11)+r**22*(980332515-5412451521*y+11942264007*y**2
          -11710534641*y**3+746626630*y**4+9779989246*y**5-9677658366*y**6+3895212274*y**7
          -475589369*y**8-75886165*y**9-2210721*y**10+9163927*y**11-1161816*y**12)
          +r**2*(-1+y)**9*(-40613-243670*y-852817*y**2-1556664*y**3-1963566*y**4
          -709740*y**5+1611274*y**6+1393688*y**7-1907093*y**8+531266*y**9+1366103*y**10
          -996704*y**11+95704*y**12+24832*y**13)+r**4*(-1+y)**8*(-356649-1906209*y
          -5944835*y**2-7939655*y**3-4412374*y**4+14470574*y**5+27014414*y**6
          +9895306*y**7-35750689*y**8+14566899*y**9+23525*y**10-1583155*y**11
          +50704*y**12+48144*y**13)+r**6*(-1+y)**7*(12865903+44410660*y+98288364*y**2
          +31461120*y**3+971399*y**4-101004112*y**5-63503116*y**6+41985216*y**7
          +117241449*y**8-57666324*y**9-41265616*y**10+23386256*y**11-2879055*y**12
          +91856*y**13)-r**12*(-1+y)**4*(-356355523+257537297*y+169310117*y**2
          +6315319077*y**3-14310963028*y**4+11036162368*y**5-2061267502*y**6-5028697382*y**7
          +6017856013*y**8-2944691247*y**9+700817305*y**10-23898495*y**11-4698310*y**12
          +105310*y**13)-r**16*(-1+y)**2*(-8948875251+30590229495*y-33135616978*y**2
          -14871391330*y**3+61835396517*y**4-56487470621*y**5+29029582172*y**6
          -9069020192*y**7-1133643833*y**8+2097732233*y**9-399493578*y**10-65858142*y**11
          +18560295*y**12+225213*y**13)+r**8*(-1+y)**6*(58137835+160475645*y
          +285323832*y**2-269290180*y**3-268148499*y**4-558411209*y**5+632954556*y**6
          -607575908*y**7+688651241*y**8-331629401*y**9-20734276*y**10+40504424*y**11
          -8318449*y**12+520389*y**13)+r**10*(-1+y)**5*(-307306521-294309498*y
          -258614151*y**2+4856395268*y**3-3562194768*y**4+1648694624*y**5-4198872222*y**6
          +5332146144*y**7-3399328729*y**8+1020075918*y**9-104155003*y**10-11179380*y**11
          -5053118*y**12+865436*y**13)-r**14*(-1+y)**3*(9115010933-16645465112*y
          +3440144230*y**2+556367300*y**3+16182646103*y**4-13354410988*y**5-3657411188*y**6
          +6371069288*y**7-2058691237*y**8-442078528*y**9+693507230*y**10-148553100*y**11
          +3575657*y**12+1017412*y**13)-r**20*(805157771-3859947461*y+5731463229*y**2
          -468553663*y**3-8937054666*y**4+13419384202*y**5-9277553594*y**6+1367538986*y**7
          +2699988435*y**8-1773829209*y**9+229577677*y**10+78387605*y**11-18121540*y**12
          +1322228*y**13)+r**18*(-10304309665+54005200875*y-110894212859*y**2
          +117102510849*y**3-65971283562*y**4+3456355910*y**5+40258332470*y**6
          -49396632282*y**7+29473897367*y**8-8249759741*y**9+31471005*y**10+585356105*y**11
          -93052284*y**12-3787716*y**13-86472*y**14))-(-1+y)*(-1+r**2+y)**5*(165*r**36*(
          -1+y)**9+25*r**34*(-1+y)**6*(312-903*y+837*y**2-343*y**3+65*y**4)
          +r**32*(-1+y)**4*(-138105+660762*y-1230504*y**2+1205803*y**3-728495*y**4
          +277682*y**5-62408*y**6+6145*y**7)+r**30*(-1+y)**2*(7012536-47302914*y
          +135405624*y**2-214464831*y**3+207070953*y**4-128070581*y**5+52170827*y**6
          -13829193*y**7+2293695*y**8-159841*y**9+8125*y**10)+r**28*(5423316-22782546*y
          -6738816*y**2+243705289*y**3-749809748*y**4+1265809791*y**5-1415958906*y**6
          +1114622056*y**7-617003974*y**8+226786818*y**9-48087982*y**10+3966407*y**11
          +18670*y**12-14375*y**13)+r**26*(-496905432+3975696882*y-13802070264*y**2
          +26968645651*y**3-31837111921*y**4+21956873771*y**5-6495837479*y**6-2154750474*y**7
          +2782154294*y**8-1051682384*y**9+149747666*y**10+9272167*y**11-4557277*y**12
          +815555*y**13-66755*y**14)+(-1+y)**12*(951+7608*y+34236*y**2+96866*y**3
          +193425*y**4+213816*y**5-88256*y**6-341380*y**7+134177*y**8+98816*y**9
          -153092*y**10+23698*y**11+18919*y**12+5632*y**13+984*y**14)+r**2*(-1
          +y)**11*(58224+402837*y+1592412*y**2+3961026*y**3+6620384*y**4+5167319*y**5
          -5068152*y**6-10247612*y**7+3938640*y**8+226739*y**9-1511508*y**10+1559970*y**11
          -120320*y**12+44289*y**13+6032*y**14+120*y**15)+r**4*(-1+y)**10*(10683
          +265065*y+1401591*y**2+8741260*y**3+12960473*y**4-4108633*y**5-51637057*y**6
          -59080464*y**7+22070413*y**8+17187967*y**9+26555205*y**10-20358228*y**11
          +3812303*y**12+965057*y**13-4235*y**14+2600*y**15)+r**6*(-1+y)**9*(
          -11263848-52293834*y-146580774*y**2-125012615*y**3-62839368*y**4+157576858*y**5
          +200569310*y**6-23609015*y**7-427248168*y**8+317172018*y**9+55799510*y**10
          -75331941*y**11+16744824*y**12+3553118*y**13-186990*y**14+22915*y**15)
          -r**24*(-1456625748+11475641070*y-38699144136*y**2+72467397815*y**3
          -78909274638*y**4+40674458738*y**5+13267764592*y**6-39985003411*y**7
          +31417335912*y**8-12119626302*y**9+1621458880*y**10+364381833*y**11-128954358*y**12
          +11667118*y**13-1307640*y**14+54275*y**15)+r**8*(-1+y)**8*(47628276
          +88416102*y+75010152*y**2-281105125*y**3-177341422*y**4-185479134*y**5
          -290749616*y**6+891412129*y**7+361065808*y**8-55695398*y**9-481946992*y**10
          +281876389*y**11-22746406*y**12+9644142*y**13-1048280*y**14+115375*y**15)
          +r**10*(-1+y)**7*(762235656+1453008570*y+1868153118*y**2-5836200017*y**3
          -2192523268*y**4-5047775236*y**5+7760306182*y**6-4755475343*y**7+7493847168*y**8
          -4407354294*y**9-465125030*y**10+1096906513*y**11-213202660*y**12+32076064*y**13
          -3467998*y**14+379375*y**15)+r**20*(-1+y)**2*(27608200194-145283150244*y
          +293163028878*y**2-244555477707*y**3-65874545536*y**4+358923890450*y**5
          -370843058118*y**6+186912856909*y**7-40425394470*y**8+667363664*y**9
          -2042295414*y**10+2081532567*y**11-571207532*y**12+75224082*y**13-6869698*y**14
          +804375*y**15)+r**12*(-1+y)**6*(158007828+1026214026*y+710520624*y**2
          +19401835653*y**3-32412338730*y**4+10527481808*y**5-15653023308*y**6
          +30544429401*y**7-19777847752*y**8+3644840794*y**9-242083536*y**10+1158421967*y**11
          -422382290*y**12+76905084*y**13-7966404*y**14+869635*y**15)+r**14*(-1
          +y)**5*(3857682456-1918821330*y-2110332198*y**2-12416425655*y**3+37186606736*y**4
          -38655226346*y**5+1017345926*y**6+53213456397*y**7-70108347624*y**8+35208960594*y**9
          -7163721450*y**10+1258986339*y**11-449906464*y**12+113474314*y**13-13261270*y**14
          +1433575*y**15)+r**18*(-1+y)**3*(-5792750808+1171538724*y+38755046694*y**2
          +53941947275*y**3-312482272764*y**4+386255541942*y**5-187572338402*y**6
          +17063719613*y**7+7340222816*y**8+11109068024*y**9-11832689534*y**10
          +4069260853*y**11-718327532*y**12+109236334*y**13-13387110*y**14+1447875*y**15)
          +r**16*(-1+y)**4*(-39726702726+95868222702*y-46950115128*y**2-20516197505*y**3
          -38079172996*y**4+56478307046*y**5+28444550560*y**6-28535062995*y**7
          -36721865286*y**8+42348667146*y**9-16290816720*y**10+3110672433*y**11
          -517832032*y**12+119817586*y**13-15975080*y**14+1710995*y**15)+r**22*(
          -11145097224+82892746758*y-263022036156*y**2+447078267419*y**3-387817590805*y**4
          +31738765074*y**5+321051011724*y**6-389944337713*y**7+237785390147*y**8
          -82446885150*y**9+14484664564*y**10-607465767*y**11+36115969*y**12-102934266*y**13
          +20365180*y**14-1193539*y**15+213785*y**16))))/(5225472000*logy**5*r**20*(
          -1+y)**10-21000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5+2177280000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+362880000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+30240000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +1260000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*muWC**2*(-217728000*logy**5*r**20*(-12-5*r**2
          +14*r**4+27*r**6)*(-1+y)**10-518400*logy**4*r**16*(-1+y)**6*(1691*r**14*(
          -1+y)**4+42*r**12*(409-1636*y+2454*y**2-1501*y**3+299*y**4+35*y**5)
          -7*r**2*(-1+y)**4*(-1131-210*y**3+1745*y**4-704*y**5+40*y**6)+7*r**10*(5013
          -11952*y+1728*y**2+18818*y**3-17617*y**4+4550*y**5+180*y**6)+70*r**8*(
          -632+2948*y-5262*y**2+4546*y**3-1670*y**4+161*y**5-74*y**6+55*y**7)
          -4*(-1+y)**4*(-356-1050*y**3+665*y**4+756*y**5-700*y**6+160*y**7)
          +35*r**6*(-937+3448*y-4572*y**2+1716*y**3+2548*y**4-3910*y**5+2494*y**6
          -830*y**7+115*y**8)+14*r**4*(981-5724*y+12186*y**2-13579*y**3+9326*y**4
          -3826*y**5-236*y**6+1609*y**7-881*y**8+144*y**9))+17280*logy**3*r**12*(
          -1+y)**4*(-1+r**2+y)**2*(5891*r**18*(-1+y)**6-2*r**16*(-1+y)**2*(25648
          -96701*y+130324*y**2-58136*y**3-12696*y**4+12851*y**5)-r**14*(-1+y)**2*(680648
          -2610482*y+3719235*y**2-2296520*y**3+649210*y**4-110718*y**5+28687*y**6)
          +2*r**12*(-860120+4653173*y-10329669*y**2+11156299*y**3-5319903*y**4
          +163355*y**5+601907*y**6+28679*y**7-117499*y**8+17478*y**9)-r**2*(-1
          +y)**4*(-27275+1696*y+1696*y**2-8624*y**3-126074*y**4+348176*y**5
          -99656*y**6-238456*y**7+184689*y**8-43336*y**9+864*y**10)-4*(-1+y)**5*(
          -212-212*y-212*y**2+3043*y**3-7052*y**4+8852*y**5+1432*y**6-31368*y**7
          +41852*y**8-21778*y**9+4080*y**10)+r**10*(-2571342+11378238*y-19100907*y**2
          +10084088*y**3+8916528*y**4-14892268*y**5+8151182*y**6-2575128*y**7
          +766422*y**8-179698*y**9+10285*y**10)+2*r**4*(-1+y)**3*(-222904+281917*y
          -41448*y**2-515608*y**3+1193802*y**4-850070*y**5-21772*y**6+121908*y**7
          +103008*y**8-78087*y**9+13504*y**10)-r**6*(-1+y)**2*(-880456+2108242*y
          -1608663*y**2+390432*y**3+2476532*y**4-4736796*y**5+3107758*y**6-485832*y**7
          -140272*y**8-32542*y**9+22097*y**10)-2*r**8*(-320472+1959597*y-5011200*y**2
          +8766135*y**3-11057290*y**4+8390244*y**5-2762464*y**6-309960*y**7+276030*y**8
          +193305*y**9-151632*y**10+27707*y**11))+288*logy**2*r**8*(-1+y)**3*(-1
          +r**2+y)**3*(3369*r**24*(-1+y)**7-r**22*(-1+y)**3*(-164597+668495*y
          -1028010*y**2+727720*y**3-327845*y**4+84697*y**5)-r**20*(683629-4228921*y
          +11011239*y**2-16121801*y**3+14612069*y**4-7958139*y**5+1849401*y**6
          +366081*y**7-216314*y**8+2756*y**9)+5*r**18*(4795863-31425504*y+86942280*y**2
          -130009774*y**3+111445692*y**4-53161640*y**5+12812368*y**6-2513166*y**7
          +1732233*y**8-689708*y**9+71356*y**10)-10*r**16*(-7997999+49855355*y
          -130656756*y**2+183026174*y**3-145209563*y**4+64031853*y**5-14984823*y**6
          +2388221*y**7-320814*y**8-235512*y**9+97171*y**10+6693*y**11)+4*(-1
          +y)**7*(-4389-13167*y-26334*y**2+13165*y**3+100435*y**4+116448*y**5
          -397346*y**6+308678*y**7-116540*y**8-80710*y**9+174516*y**10-99062*y**11
          +19056*y**12)+5*r**8*(-1+y)**3*(12151693-22130380*y+8709276*y**2+28153412*y**3
          -87501605*y**4+89053992*y**5-27695580*y**6-7362552*y**7+2758723*y**8
          +975720*y**9+518240*y**10-361200*y**11+35261*y**12)-5*r**6*(-1+y)**4*(2373153
          -1049058*y-390678*y**2+3582240*y**3-2772801*y**4-7861992*y**5+3399732*y**6
          +14537852*y**7-15447065*y**8+4587006*y**9+342094*y**10-453624*y**11
          +68741*y**12)+r**2*(-1+y)**6*(-111037-169406*y-175107*y**2+247250*y**3
          +2993800*y**4-1087206*y**5-9035128*y**6+15909634*y**7-10345375*y**8
          +938600*y**9+2006543*y**10-840016*y**11+101448*y**12)-r**4*(-1+y)**5*(256291
          -176792*y-428219*y**2-1473010*y**3-4597470*y**4+5726028*y**5+12235874*y**6
          -5976432*y**7-17087165*y**8+15888120*y**9-3610519*y**10-610682*y**11
          +189976*y**12)+2*r**10*(-1+y)**2*(-18777851+50605762*y-58958036*y**2
          +138181250*y**3-124029700*y**4-56978698*y**5+95408646*y**6+15506702*y**7
          -51422225*y**8+11829450*y**9+6516424*y**10-2762758*y**11+257034*y**12)
          -2*r**14*(-45832589+255323318*y-593800599*y**2+603625460*y**3-55500875*y**4
          -426847512*y**5+367844784*y**6-113892492*y**7+15431815*y**8-16147200*y**9
          +12861401*y**10-3677202*y**11+415691*y**12)+r**12*(96684234-357934002*y
          +311964012*y**2+863689176*y**3-2581799280*y**4+2874926172*y**5-1565703336*y**6
          +359416256*y**7+40633598*y**8-69788170*y**9+38617144*y**10-13033612*y**11
          +2611532*y**12-283724*y**13))-12*logy*r**4*(-1+y)**2*(-1+r**2+y)**4*(
          -251*r**30*(-1+y)**8-2*r**28*(-1+y)**4*(-4943+19270*y-27650*y**2+26460*y**3
          -9055*y**4+898*y**5)-r**26*(-1+y)**2*(1259537-7356970*y+17774909*y**2
          -22915828*y**3+17271257*y**4-7979850*y**5+2107627*y**6-309352*y**7+35870*y**8)
          -4*r**24*(1987048-15130694*y+50334448*y**2-96297573*y**3+118942878*y**4
          -101542300*y**5+61876344*y**6-25993808*y**7+6230978*y**8-170458*y**9
          -240088*y**10+20025*y**11)+r**22*(63854821-514922752*y+1795212200*y**2
          -3512489244*y**3+4286056633*y**4-3518026432*y**5+2124220096*y**6-1022915176*y**7
          +378326239*y**8-88057888*y**9+9147656*y**10-126524*y**11+22771*y**12)
          +2*r**20*(405122165-2795225494*y+8186297112*y**2-12990106354*y**3+11611501069*y**4
          -5101344896*y**5+95750712*y**6+765859920*y**7-70947153*y**8-162481694*y**9
          +58930656*y**10-2894918*y**11-819457*y**12+72732*y**13)+4*(-1+y)**9*(
          -617-3085*y-9255*y**2-17009*y**3-53346*y**4-51406*y**5+318650*y**6
          -71300*y**7-342437*y**8+338267*y**9-160227*y**10+45585*y**11+10280*y**12
          -14204*y**13+3104*y**14)+r**18*(1106445223-7361995932*y+21043835378*y**2
          -32827418212*y**3+30090453553*y**4-16706984176*y**5+5667596264*y**6-171780456*y**7
          -2359414751*y**8+2419475124*y**9-1127717222*y**10+248360268*y**11-21390697*y**12
          +1196888*y**13+10748*y**14)+4*r**8*(-1+y)**5*(-1737254+10065876*y+13151996*y**2
          +72416851*y**3+11919391*y**4-138624977*y**5-205990517*y**6+519611518*y**7
          -266641792*y**8-41105302*y**9+63170806*y**10-13227209*y**11-570889*y**12
          +131091*y**13+19411*y**14)+2*r**4*(-1+y)**7*(-575059-1423211*y-2465502*y**2
          +6385326*y**3-2869865*y**4+6297963*y**5+2852492*y**6-28895616*y**7+6155903*y**8
          +18853955*y**9-2551654*y**10-8960006*y**11+3902693*y**12-489979*y**13
          +30560*y**14)+r**6*(-1+y)**6*(-11059217-12792118*y-10191429*y**2+98003292*y**3
          +56722995*y**4-62975906*y**5-419287449*y**6+829361928*y**7-614850099*y**8
          +98404230*y**9+123010673*y**10-75721508*y**11+13616401*y**12-579118*y**13
          +41325*y**14)+r**2*(-1+y)**8*(57221+238756*y+621570*y**2+278004*y**3
          -4776549*y**4-6707832*y**5+23039948*y**6-16896760*y**7-4382973*y**8
          +18369188*y**9-13642014*y**10+3292996*y**11+553165*y**12-397456*y**13
          +44736*y**14)+2*r**12*(-1+y)**3*(692437271-1499735469*y+887061760*y**2
          +732120854*y**3-4442490139*y**4+6728776513*y**5-3027570042*y**6-1485078580*y**7
          +1846070457*y**8-414893227*y**9-74983084*y**10+8424286*y**11+8816795*y**12
          -2584761*y**13+311366*y**14)+r**10*(-1+y)**4*(-462987547+550140264*y
          +56311684*y**2-890907068*y**3+1580343071*y**4-230368996*y**5-146459238*y**6
          -1281867448*y**7+1435052451*y**8-297422752*y**9-206528032*y**10+93622324*y**11
          -11779911*y**12-1644708*y**13+331906*y**14)+r**14*(-1+y)**2*(1979036199
          -6080300474*y+4835892017*y**2+7989336364*y**3-17140162265*y**4+11819635722*y**5
          -5298918087*y**6+2950569896*y**7-207898083*y**8-1404566630*y**9+1010376379*y**10
          -309108564*y**11+40634037*y**12-2075306*y**13+444795*y**14)+4*r**16*(19415001
          +210608368*y-1483762922*y**2+5538801812*y**3-12308012979*y**4+15577945868*y**5
          -10335007596*y**6+2019361904*y**7+1731165361*y**8-1135026452*y**9+60622386*y**10
          +145673978*y**11-44336307*y**12+1779652*y**13+766256*y**14+5670*y**15))
          +(-1+r**2+y)**5*(r**36*(-1+y)**10-r**34*(-1+y)**6*(-251+1009*y-1526*y**2
          +1664*y**3-891*y**4+235*y**5)-r**32*(-1+y)**4*(7594-47316*y+122901*y**2
          -194266*y**3+203607*y**4-135112*y**5+59403*y**6-16218*y**7+2143*y**8)
          -r**30*(-1+y)**2*(-241506+2010958*y-7324373*y**2+14792181*y**3-18449380*y**4
          +15762830*y**5-10307774*y**6+5411216*y**7-2203242*y**8+592620*y**9-91453*y**10
          +7603*y**11)+r**28*(25859890-244770896*y+1034341399*y**2-2577836096*y**3
          +4218221866*y**4-4772504812*y**5+3818106071*y**6-2153719448*y**7+823981182*y**8
          -189310384*y**9+14209877*y**10+4760760*y**11-1564986*y**12+217484*y**13
          -11107*y**14)+4*(-1+y)**13*(10+80*y+360*y**2+1288*y**3-3231*y**4
          -21732*y**5+1716*y**6+19854*y**7-24074*y**8+2852*y**9+8292*y**10-3726*y**11
          +1231*y**12+256*y**13+24*y**14)+r**2*(-1+y)**12*(1873+12911*y+50844*y**2
          +157562*y**3-543271*y**4-2532835*y**5+1424296*y**6+1807756*y**7-3054029*y**8
          +1270673*y**9+308548*y**10-350622*y**11+168835*y**12+227*y**13+408*y**14
          +24*y**15)+r**26*(-90955922+889466078*y-3858576981*y**2+9796716877*y**3
          -16128690242*y**4+18010076900*y**5-13862553689*y**6+7339423919*y**7-2656978318*y**8
          +697236998*y**9-175431863*y**10+46716131*y**11-5654078*y**12-844584*y**13
          +111109*y**14+4865*y**15)+r**4*(-1+y)**10*(-198917-955804*y-2766477*y**2
          -4959634*y**3+5750883*y**4+21350120*y**5-24610853*y**6+11890274*y**7
          +1768257*y**8-18593788*y**9+6468913*y**10+7840914*y**11-4258247*y**12
          +225552*y**13+311105*y**14-1666*y**15+168*y**16)-r**6*(-1+y)**9*(703950
          +2546648*y+5510581*y**2+30267038*y**3+16799651*y**4-9731194*y**5-158621113*y**6
          +153235048*y**7+52456973*y**8-202724524*y**9+192365435*y**10-86916482*y**11
          +9132461*y**12+3457454*y**13-1435287*y**14+8924*y**15+437*y**16)-r**8*(
          -1+y)**8*(23879470+54586396*y+86583679*y**2-36724670*y**3+53843373*y**4
          -244265060*y**5-391972561*y**6+1552274422*y**7-588826059*y**8-961560084*y**9
          +777423413*y**10-112772042*y**11-53070601*y**12+12549404*y**13-2423939*y**14
          -21998*y**15+8857*y**16)-r**20*(-1+y)**2*(-2702890388+18391639684*y
          -49036631129*y**2+66367474310*y**3-30483902541*y**4-49642202136*y**5
          +101700141071*y**6-80287307286*y**7+27480744699*y**8+877860004*y**9-3277802659*y**10
          +600430874*y**11+80377825*y**12-19011824*y**13-1101203*y**14+720918*y**15
          +11781*y**16)+r**24*(-393284394+3601272556*y-14646920197*y**2+34354596346*y**3
          -51583793687*y**4+53714749276*y**5-43816035173*y**6+32957376734*y**7
          -23442018863*y**8+13303690972*y**9-5033275943*y**10+1081506494*y**11
          -97576037*y**12-803108*y**13+857265*y**14-453014*y**15+43573*y**16)
          -r**10*(-1+y)**7*(259191746+283327552*y+234361743*y**2-1394660442*y**3
          +198950883*y**4+210012626*y**5+3157968481*y**6-4083983720*y**7+3038897769*y**8
          -1883146932*y**9+512654993*y**10+134959694*y**11-104301443*y**12-29822*y**13
          -186721*y**14-252460*y**15+44053*y**16)-r**12*(-1+y)**6*(877263810-267027172*y
          -543135443*y**2-6416378630*y**3+5237976973*y**4+4670421616*y**5+9315773421*y**6
          -26175704426*y**7+17686737169*y**8-2666371476*y**9-1044081201*y**10+84160326*y**11
          +118710239*y**12-57770744*y**13+6860823*y**14-828630*y**15+121345*y**16)
          -r**18*(-1+y)**3*(-3870077820+15875656172*y-22502537927*y**2-36941169030*y**3
          +156310715541*y**4-200779888470*y**5+121099660103*y**6-27547351376*y**7
          -4959388733*y**8+2183368712*y**9+1056826311*y**10-303661614*y**11-72801397*y**12
          +25155938*y**13+1744697*y**14-427196*y**15+144089*y**16)-r**14*(-1+y)**5*(6007539910
          -8797878632*y-154421531*y**2-3251443002*y**3+6093424239*y**4+5177228582*y**5
          +1729798151*y**6-22282156648*y**7+23650331361*y**8-10059543004*y**9+2864273627*y**10
          -1173957418*y**11+362379729*y**12-84108834*y**13+12659065*y**14-1465844*y**15
          +210649*y**16)-r**16*(-1+y)**4*(4046852054-8668178468*y-246646833*y**2
          -3731063014*y**3+58458307977*y**4-89943865620*y**5+39738959831*y**6+5565673166*y**7
          +1431271881*y**8-12283759748*y**9+7974800357*y**10-2008689906*y**11+177706747*y**12
          -17340612*y**13+9319701*y**14-1428086*y**15+232573*y**16)+r**22*(-4919381494
          +41105733566*y-149971963537*y**2+309571052131*y**3-384939849121*y**4
          +266466188329*y**5-38845340645*y**6-111893721061*y**7+120914934815*y**8
          -64975087931*y**9+21847484941*y**10-5408883791*y**11+1309094285*y**12
          -293403821*y**13+32001577*y**14+2141649*y**15-1058005*y**16+58113*y**17))))/(
          -1959552000*logy**5*r**20*(-1+y)**10+7875*(r**8*(-1+y)**2-6*r**4*y*(2
          -3*y+y**2)-2*r**2*(-1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)
          -(-1+y)**3*(-1-y-y**2+y**3))**5-816480000*logy**4*r**16*(-1+y)**8*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))-136080000*logy**3*r**12*(
          -1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2
          -11340000*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))**3-472500*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2
          -3*y+y**2)+2*r**3*(-1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)
          +r*(-1+y)**3*(-1-y-y**2+y**3))**4))
      resNP += ((mupi*(217728000*logy**5*r**20*(3
          +5*r**2+13*r**4+27*r**6)*(-1+y)**10-518400*logy**4*r**16*(-1+y)**6*(881*r**14*(
          -1+y)**4+21*r**12*(-981+3924*y-5886*y**2+3894*y**3-1321*y**4+130*y**5)
          -7*r**2*(-1+y)**4*(297+4380*y**3-4975*y**4+1408*y**5+40*y**6)-35*r**10*(1035
          -2520*y+540*y**2+3404*y**3-2827*y**4+584*y**5+72*y**6)-35*r**8*(-1043
          +4952*y-8988*y**2+7774*y**3-2525*y**4+248*y**5-272*y**6+142*y**7)
          +5*(-1+y)**4*(283-1134*y**3-1141*y**4+3024*y**5-1624*y**6+256*y**7)
          -35*r**6*(-389+1856*y-3384*y**2+1968*y**3+2132*y**4-3644*y**5+2114*y**6
          -568*y**7+59*y**8)-7*r**4*(-927+4608*y-8712*y**2+3038*y**3+7088*y**4
          -3778*y**5-6458*y**6+7852*y**7-3143*y**8+432*y**9))+17280*logy**3*r**12*(
          -1+y)**4*(-1+r**2+y)**2*(-2719*r**18*(-1+y)**6+r**16*(-1+y)**2*(-26855
          +112858*y-182882*y**2+149728*y**3-59367*y**4+11678*y**5)+r**14*(-1
          +y)**2*(350704-1449388*y+2229495*y**2-1603300*y**3+747230*y**4-166824*y**5
          +12203*y**6)+r**12*(1995008-10351628*y+21459501*y**2-21310870*y**3
          +10101039*y**4-2123588*y**5+433483*y**6-324926*y**7+164425*y**8-17244*y**9)
          +r**10*(3260622-15221928*y+27304137*y**2-19296718*y**3-20898*y**4+5947058*y**5
          -2935192*y**6+2054478*y**7-1489332*y**8+471158*y**9-48185*y**10)-r**2*(
          -1+y)**4*(-74897+14734*y+14734*y**2+185974*y**3+397684*y**4-998662*y**5
          +332626*y**6+283826*y**7-127539*y**8-33424*y**9+17544*y**10)+(-1+y)**5*(7367
          +7367*y+7367*y**2-51673*y**3-58723*y**4+51373*y**5+340613*y**6-690987*y**7
          +555328*y**8-213272*y**9+32640*y**10)-r**4*(-1+y)**3*(118976-153716*y
          +62799*y**2-2332921*y**3+3655719*y**4+51847*y**5-2698879*y**6+1131441*y**7
          +311721*y**8-245259*y**9+35272*y**10)+r**6*(-1+y)**2*(-315440+913772*y
          -712383*y**2-3767988*y**3+14254132*y**4-17248548*y**5+9433178*y**6-2586732*y**7
          +790708*y**8-394952*y**9+75253*y**10)+r**8*(600174-3447684*y+7734735*y**2
          -6070050*y**3+1145540*y**4-4639368*y**5+9876938*y**6-7016100*y**7+1742310*y**8
          +248220*y**9-201921*y**10+27206*y**11))-288*logy**2*r**8*(-1+y)**3*(-1
          +r**2+y)**3*(-12927*r**24*(-1+y)**7+r**22*(-1+y)**3*(153274-574315*y
          +764520*y**2-340280*y**3+49690*y**4+26191*y**5)+r**20*(-1657658+11535227*y
          -34499313*y**2+58528957*y**3-61950463*y**4+42407733*y**5-19323207*y**6
          +6398403*y**7-1669247*y**8+229568*y**9)+5*r**18*(1927614-13479159*y
          +39989337*y**2-65820269*y**3+67240299*y**4-46044937*y**5+22310087*y**6
          -7699539*y**7+1835487*y**8-267136*y**9+8216*y**10)-5*r**16*(-9316709
          +58360322*y-152708916*y**2+214484678*y**3-181544906*y**4+106009554*y**5
          -50548158*y**6+19920176*y**7-6437253*y**8+2366496*y**9-657530*y**10
          +72246*y**11)+5*r**6*(-1+y)**4*(2917806-2178819*y-608163*y**2-20074161*y**3
          +9952281*y**4+31519920*y**5-15812472*y**6-29286496*y**7+31991746*y**8
          -12491061*y**9+2535139*y**10-313239*y**11+16319*y**12)+2*r**14*(81164458
          -441334201*y+957691923*y**2-927439600*y**3+241986070*y**4+247391619*y**5
          -246250113*y**6+143096739*y**7-83776775*y**8+36538830*y**9-9461602*y**10
          +747789*y**11+36863*y**12)+5*r**8*(-1+y)**3*(1628099-3919562*y+20094*y**2
          +65299978*y**3-154973191*y**4+96726186*y**5+7939170*y**6-13486470*y**7
          -12824173*y**8+9300936*y**9-796640*y**10-362028*y**11+57601*y**12)-2*r**10*(
          -1+y)**2*(27054982-76017479*y+64480357*y**2+61945985*y**3-532676635*y**4
          +919420151*y**5-687206997*y**6+252893351*y**7-50612135*y**8+15084060*y**9
          -5418308*y**10+236276*y**11+64392*y**12)+r**2*(-1+y)**6*(-397994-749647*y
          -1054959*y**2+1779040*y**3+6531620*y**4+776058*y**5-23751566*y**6+32252048*y**7
          -18938090*y**8+3863605*y**9+1086061*y**10-600512*y**11+72336*y**12)
          +(-1+y)**7*(-15447-46341*y-92682*y**2+46040*y**3+412820*y**4+414954*y**5
          -1725958*y**6+1648384*y**7-634165*y**8-966845*y**9+1604568*y**10-839776*y**11
          +152448*y**12)-r**4*(-1+y)**5*(802982+981401*y+589472*y**2+10607365*y**3
          -22434930*y**4+10053996*y**5-45996122*y**6+132094056*y**7-140811940*y**8
          +67556355*y**9-12399278*y**10-677029*y**11+305672*y**12)+2*r**12*(96684234
          -500010027*y+1022344137*y**2-835010064*y**3-51482085*y**4+475382802*y**5
          -293824896*y**6+201758756*y**7-197402662*y**8+107402585*y**9-31485161*y**10
          +6726548*y**11-1172143*y**12+87976*y**13))+12*logy*r**4*(-1+y)**2*(-1
          +r**2+y)**4*(-163*r**30*(-1+y)**8-r**28*(-1+y)**4*(-67247+268336*y
          -400874*y**2+296676*y**3-94639*y**4+17668*y**5)-r**26*(-1+y)**2*(-823121
          +4586566*y-10542473*y**2+12771952*y**3-8147741*y**4+1958430*y**5+279113*y**6
          -344468*y**7+36142*y**8)+r**24*(-24885869+188789476*y-619605626*y**2
          +1145934996*y**3-1310048958*y**4+959374880*y**5-455536536*y**6+143256016*y**7
          -32681101*y**8+6201308*y**9-1010806*y**10+77820*y**11)+r**22*(54327377
          -424940600*y+1422876928*y**2-2621493792*y**3+2923690937*y**4-2078301008*y**5
          +960386000*y**6-256670432*y**7+10339307*y**8+5743528*y**9+7234096*y**10
          -2673760*y**11+86219*y**12)+r**20*(319950203-2304605356*y+7106587560*y**2
          -12377371528*y**3+13798299631*y**4-10956941120*y**5+6882975888*y**6-3586987344*y**7
          +1517263377*y**8-504615356*y**9+119560392*y**10-18472232*y**11+3727109*y**12
          -513624*y**13)+r**18*(697998581-4372783032*y+11345578690*y**2-15016590368*y**3
          +10782464999*y**4-5121921872*y**5+3102550984*y**6-1644300480*y**7-134233549*y**8
          +505001352*y**9-207858934*y**10+105692448*y**11-50645135*y**12+11209792*y**13
          -819476*y**14)+(-1+y)**9*(-4597-22985*y-68955*y**2-113551*y**3-282738*y**4
          -277466*y**5+1252330*y**6+36290*y**7-851833*y**8+604531*y**9-879087*y**10
          +728205*y**11-119360*y**12-81616*y**13+24832*y**14)+r**2*(-1+y)**8*(66967
          +286256*y+761610*y**2+515112*y**3-5935251*y**4-9011424*y**5+25555708*y**6
          -17232080*y**7-1869999*y**8+17536432*y**9-16572918*y**10+5644136*y**11
          -52405*y**12-356288*y**13+48144*y**14)+r**4*(-1+y)**7*(1041959+3581077*y
          +7655856*y**2+12682884*y**3-40110545*y**4-37292103*y**5+94010576*y**6
          -79760232*y**7+16790717*y**8-30680545*y**9+88028144*y**10-68994428*y**11
          +19789901*y**12-1812301*y**13+61040*y**14)+r**10*(-1+y)**4*(374563363
          -427730508*y+32224712*y**2-3814858420*y**3+5750573041*y**4+1120950784*y**5
          -1497816414*y**6-6075397544*y**7+8463188085*y**8-4792966412*y**9+1498463428*y**10
          -273376228*y**11+13703607*y**12+87960*y**13+62546*y**14)+r**12*(-1+y)**3*(1254857219
          -2716123923*y+1079718490*y**2+4764818114*y**3-15595304827*y**4+17487047827*y**5
          -6414783864*y**6-1685357620*y**7+2565374397*y**8-1493560861*y**9+951119954*y**10
          -453923438*y**11+89524955*y**12-6796611*y**13+126188*y**14)+r**6*(-1
          +y)**6*(-13128949-11777222*y-7330161*y**2+218614080*y**3+56715123*y**4
          -93888262*y**5-1058939481*y**6+1958110752*y**7-1436437335*y**8+380625534*y**9
          +123917461*y**10-123631072*y**11+34701209*y**12-4427570*y**13+283893*y**14)
          +r**8*(-1+y)**5*(-87280297-10702041*y+26070355*y**2+321582371*y**3
          +795411632*y**4-1199046076*y**5+648867842*y**6-1878798970*y**7+3237255463*y**8
          -2295377249*y**9+690124223*y**10-63959401*y**11-830510*y**12-3036234*y**13
          +430892*y**14)+r**14*(-1+y)**2*(1062629703-3086143306*y+2246762017*y**2
          +1542269588*y**3+10256836655*y**4-29969765646*y**5+27447552897*y**6-11808756104*y**7
          +3531763629*y**8-1124207590*y**9+388654043*y**10-179363916*y**11+69313437*y**12
          -12429442*y**13+676035*y**14)+r**16*(3050762703-18195102364*y+44179721138*y**2
          -47774738732*y**3+7042632849*y**4+39439205200*y**5-51890575272*y**6+40142164384*y**7
          -24153695551*y**8+10794284852*y**9-3095066454*y**10+436625236*y**11+40844703*y**12
          -17341192*y**13+166924*y**14+111576*y**15))-(-1+r**2+y)**5*(101*r**36*(
          -1+y)**10+r**34*(-1+y)**6*(-3476+13399*y-18836*y**2+11564*y**3-3636*y**4
          +505*y**5)-r**32*(-1+y)**4*(-47029+263343*y-594942*y**2+693007*y**3
          -468246*y**4+206053*y**5-51294*y**6+3981*y**7+599*y**8)-r**30*(-1+y)**2*(2952144
          -22593874*y+74935202*y**2-142088871*y**3+170251432*y**4-133870214*y**5
          +69301136*y**6-22828892*y**7+4103088*y**8-161088*y**9-91034*y**10+10331*y**11)
          +r**28*(23419460-230334610*y+1010832554*y**2-2624399353*y**3+4512495041*y**4
          -5457693635*y**5+4810902097*y**6-3147310354*y**7+1527979230*y**8-536288912*y**9
          +125383660*y**10-14473557*y**11-961875*y**12+442693*y**13-30839*y**14)
          +(-1+y)**13*(179+1432*y+6444*y**2+21194*y**3+17229*y**4-67464*y**5
          -46560*y**6-6564*y**7-34939*y**8+43936*y**9-4980*y**10-4662*y**11+6155*y**12
          +1280*y**13+120*y**14)+r**26*(113994224-954549122*y+3470885754*y**2
          -6966169039*y**3+7818496256*y**4-3356257664*y**5-3323145682*y**6+6503181451*y**7
          -5012825840*y**8+2196337126*y**9-558939802*y**10+64952119*y**11+8265440*y**12
          -4733796*y**13+673298*y**14-30323*y**15)+r**2*(-1+y)**12*(7724+53173*y
          +209112*y**2+598126*y**3+52096*y**4-2641397*y**5-133360*y**6+586412*y**7
          -989476*y**8+1453099*y**9-640312*y**10-12978*y**11+182936*y**12-2315*y**13
          +240*y**14+120*y**15)+r**4*(-1+y)**10*(-460051-2207366*y-6373698*y**2
          -10846445*y**3+4837635*y**4+34191226*y**5-17143300*y**6+12832471*y**7
          -9462117*y**8-21002474*y**9+5282750*y**10+15513345*y**11-6755923*y**12
          -626538*y**13+753064*y**14-12875*y**15+1896*y**16)+r**6*(-1+y)**9*(
          -4843056-17968462*y-41368676*y**2-67198927*y**3+5690825*y**4+120758006*y**5
          +148546292*y**6-185406803*y**7-64831279*y**8+243807974*y**9-279082708*y**10
          +160909915*y**11-32306101*y**12-3637774*y**13+2921796*y**14-115897*y**15
          +12875*y**16)+r**8*(-1+y)**8*(-19458620-48067850*y-76253486*y**2-159589271*y**3
          -305926239*y**4+100160920*y**5+1592239958*y**6-2527925453*y**7+940588305*y**8
          +226995054*y**9+235721654*y**10-478585169*y**11+206410739*y**12-31817884*y**13
          +6953410*y**14-521579*y**15+51511*y**16)+r**24*(-933073164+8294225114*y
          -32368364378*y**2+71619928835*y**3-96828127165*y**4+78670197080*y**5
          -30806701270*y**6-6094311719*y**7+14774544923*y**8-8269295614*y**9+1909884866*y**10
          +250099525*y**11-276168103*y**12+61100492*y**13-3916146*y**14-212257*y**15
          +54581*y**16)+r**10*(-1+y)**7*(-222477424-200422370*y-129682812*y**2
          +1752601179*y**3-1177224333*y**4-319220512*y**5-6228314378*y**6+12124504609*y**7
          -11115223431*y**8+5055490470*y**9+310535672*y**10-1599681331*y**11+727177093*y**12
          -122559908*y**13+18276878*y**14-1534921*y**15+139519*y**16)+r**12*(-1
          +y)**6*(-1608023244+307194962*y+701512390*y**2+8323123771*y**3-3253240049*y**4
          -10197742322*y**5-2166703536*y**6+8154295675*y**7+3151278361*y**8-8165872266*y**9
          +4038462750*y**10-1530115407*y**11+764876945*y**12-205976822*y**13+36504300*y**14
          -3310599*y**15+279091*y**16)+r**14*(-1+y)**5*(-2056600016+1630137658*y
          +2219147044*y**2-12140285415*y**3+29234407185*y**4-17293357726*y**5-2299720*y**6
          -21784545463*y**7+45819624741*y**8-38846571418*y**9+16122599708*y**10
          -3730702885*y**11+821030619*y**12-222269826*y**13+49068808*y**14-5562941*y**15
          +438847*y**16)+r**20*(-1+y)**2*(-4642638026+27955994014*y-68421875438*y**2
          +68848945793*y**3+16853851269*y**4-126737013498*y**5+166205302196*y**6
          -129125815659*y**7+69976908123*y**8-27849952190*y**9+9659991506*y**10
          -4021721893*y**11+1535623027*y**12-385825286*y**13+56535976*y**14-5872977*y**15
          +459063*y**16)+r**16*(-1+y)**4*(1954714694-8360138900*y+10817321178*y**2
          +6405285101*y**3-55297450365*y**4+81600018294*y**5-41715394198*y**6-9511345921*y**7
          +34057473867*y**8-36494061152*y**9+22164723062*y**10-8239286613*y**11
          +1897288033*y**12-335622978*y**13+59042982*y**14-7432535*y**15+561451*y**16)
          +r**18*(-1+y)**3*(7740155640-31600016980*y+44399894398*y**2-5443036017*y**3
          -8621644113*y**4-53712083850*y**5+85956326816*y**6-54061891211*y**7+29334728365*y**8
          -23219143072*y**9+16103147718*y**10-8156988183*y**11+2572119113*y**12
          -506134498*y**13+69785660*y**14-7736333*y**15+580547*y**16)+r**22*(119716816
          -1407711302*y+6407391634*y**2-10603818487*y**3-12162037448*y**4+87182460905*y**5
          -180512413402*y**6+213111580333*y**7-160851047132*y**8+80322502625*y**9
          -26607481954*y**10+5639119259*y**11-726684464*y**12+154303019*y**13-85630102*y**14
          +22495983*y**15-2990780*y**16+244497*y**17))))/(-5225472000*logy**5*r**20*(
          -1+y)**10+21000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-2177280000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-362880000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-30240000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -1260000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((rhoLS*(217728000*logy**5*r**18*(-6+69*r**2+103*r**4
          +59*r**6+27*r**8)*(-1+y)**10-518400*logy**4*r**14*(-1+y)**6*(7381*r**16*(
          -1+y)**4+15*r**14*(-1795+7180*y-10770*y**2+8482*y**3-3167*y**4+406*y**5)
          +12*(-1+y)**5*(159+159*y+159*y**2-996*y**3+894*y**4-310*y**5+40*y**6)
          -7*r**12*(11163-36552*y+38628*y**2-14872*y**3-847*y**4+320*y**5+720*y**6)
          -7*r**10*(12661-32944*y+14016*y**2+20686*y**3-18749*y**4+1460*y**5
          +880*y**6+550*y**7)+r**2*(-1+y)**4*(1411+16170*y**3-26005*y**4+18144*y**5
          -6160*y**6+640*y**7)+35*r**4*(-1+y)**2*(1023-1686*y+483*y**2-1320*y**3
          +3811*y**4-3306*y**5+1295*y**6-272*y**7+8*y**8)-35*r**8*(395+4600*y
          -19260*y**2+25476*y**3-13436*y**4+1496*y**5+670*y**6-164*y**7+79*y**8)
          -7*r**6*(-23547+114888*y-213732*y**2+193078*y**3-93932*y**4+40042*y**5
          -28018*y**6+14132*y**7-3343*y**8+432*y**9))+17280*logy**3*r**10*(-1+y)**4*(
          -1+r**2+y)**2*(10549*r**20*(-1+y)**6-r**18*(-1+y)**2*(241087-943250*y
          +1362130*y**2-810020*y**3+120135*y**4+35078*y**5)-r**16*(-1+y)**2*(598648
          -1969948*y+2304525*y**2-679330*y**3-242530*y**4+91542*y**5+17213*y**6)
          +30*(-1+y)**6*(134+268*y+402*y**2-439*y**3+541*y**4-299*y**5-1153*y**6
          +1548*y**7-686*y**8+104*y**9)-r**14*(-3378016+17150164*y-33803901*y**2
          +34457474*y**3-19132281*y**4+4709656*y**5+111421*y**6+46666*y**7-145619*y**8
          +9636*y**9)+5*r**2*(-1+y)**5*(14963+13355*y+11747*y**2-104053*y**3
          +94091*y**4-42101*y**5+76871*y**6-116361*y**7+78244*y**8-24980*y**9
          +3264*y**10)-5*r**12*(-1979922+10262712*y-21137445*y**2+23059150*y**3
          -14689308*y**4+5380678*y**5-704948*y**6-448014*y**7+379338*y**8-133562*y**9
          +16361*y**10)+r**4*(-1+y)**3*(241871-329241*y+102420*y**2-2465340*y**3
          +7414860*y**4-8918272*y**5+5185552*y**6-885520*y**7-672535*y**8+389065*y**9
          -57424*y**10+864*y**11)-r**6*(-1+y)**2*(-1183168+2703068*y-1633195*y**2
          -2556460*y**3+9371290*y**4-14689484*y**5+12760204*y**6-5995820*y**7
          +978570*y**8+473220*y**9-277313*y**10+36488*y**11)+r**10*(12902526-66772836*y
          +138679335*y**2-155537910*y**3+113480950*y**4-69038832*y**5+40095802*y**6
          -17679720*y**7+4033500*y**8+540*y**9-209229*y**10+45874*y**11)+r**8*(5530532
          -24329484*y+40920237*y**2-38094350*y**3+40781795*y**4-62890804*y**5
          +69694338*y**6-46542734*y**7+19701000*y**8-6158720*y**9+1779897*y**10
          -460304*y**11+68597*y**12))-288*logy**2*r**6*(-1+y)**3*(-1+r**2+y)**3*(
          -27231*r**26*(-1+y)**7+r**24*(-1+y)**3*(-241192+1046461*y-1773924*y**2
          +1414436*y**3-776944*y**4+252083*y**5)+r**22*(-3588682+26214325*y-81904383*y**2
          +141789929*y**3-149584799*y**4+101712207*y**5-47381445*y**6+15767643*y**7
          -3219139*y**8+194344*y**9)+r**20*(-37283466+229448199*y-586871301*y**2
          +771278779*y**3-488436621*y**4+34568501*y**5+140878961*y**6-70372539*y**7
          +2173731*y**8+5355356*y**9-739600*y**10)+5*r**18*(-4599623+26708900*y
          -68911878*y**2+89168114*y**3-53099846*y**4+5052540*y**5+14135664*y**6
          -19010572*y**7+16828761*y**8-7509864*y**9+1213138*y**10+24666*y**11)
          -6*(-1+y)**7*(1599+4797*y+9594*y**2-6205*y**3-29980*y**4-44903*y**5
          +66876*y**6+107*y**7+42605*y**8-108870*y**9+78954*y**10-24398*y**11
          +2824*y**12)+2*r**16*(243130409-1377115403*y+3125068779*y**2-3767725355*y**3
          +2567447585*y**4-792469473*y**5-219605259*y**6+352722432*y**7-168177145*y**8
          +34968990*y**9+6059764*y**10-5546463*y**11+807139*y**12)+5*r**8*(-1
          +y)**3*(-1766748+804981*y+3109764*y**2-52757970*y**3+175205688*y**4
          -251477379*y**5+179071068*y**6-30528880*y**7-60941356*y**8+59590487*y**9
          -25710188*y**10+6021446*y**11-742204*y**12+16291*y**13)+r**2*(-1+y)**6*(58323
          +145428*y+261315*y**2-216136*y**3+1628130*y**4-577676*y**5-5280346*y**6
          +6181820*y**7-1549313*y**8-475480*y**9-746497*y**10+1209068*y**11-525860*y**12
          +76224*y**13)+r**4*(-1+y)**5*(622258+1142107*y+1242592*y**2-8612087*y**3
          +7447420*y**4-3743366*y**5+16898116*y**6-33869774*y**7+31463414*y**8
          -16593345*y**9+4419108*y**10+503577*y**11-643468*y**12+101448*y**13)
          +2*r**14*(422512158-2471213973*y+5920741827*y**2-7866960012*y**3+6659948955*y**4
          -3878742816*y**5+1481576916*y**6-146341514*y**7-284769116*y**8+248521645*y**9
          -108772717*y**10+26718082*y**11-3379763*y**12+118328*y**13)-r**6*(-1
          +y)**4*(16602674-11080077*y-3002793*y**2-122986909*y**3+280755995*y**4
          -241255038*y**5+146716474*y**6-193394614*y**7+259496768*y**8-195473045*y**9
          +77585539*y**10-14506997*y**11+577407*y**12+153616*y**13)+r**10*(-1
          +y)**2*(241472497-664605179*y+553992532*y**2-64475440*y**3-274984135*y**4
          +628622291*y**5-788358972*y**6+465878256*y**7-15063485*y**8-157067965*y**9
          +92873912*y**10-17622224*y**11-663613*y**12+253525*y**13)-2*r**12*(-202143742
          +1034944195*y-2123944833*y**2+2665399844*y**3-3464948384*y**4+5190320124*y**5
          -6045997510*y**6+4683335936*y**7-2365225728*y**8+744440343*y**9-108488207*y**10
          -19136010*y**11+14418072*y**12-3277316*y**13+303216*y**14))+12*logy*r**2*(
          -1+y)**2*(-1+r**2+y)**4*(1045*r**32*(-1+y)**8-r**30*(-1+y)**4*(-23317
          +97448*y-156622*y**2+75588*y**3-27557*y**4+14540*y**5)+r**28*(-1+y)**2*(5838187
          -33819482*y+80978959*y**2-102965516*y**3+74911027*y**4-31578066*y**5
          +6899417*y**6-551240*y**7+61114*y**8)+r**26*(-39058255+301900148*y
          -1007636134*y**2+1900665852*y**3-2212012326*y**4+1619750704*y**5-726655092*y**6
          +188217944*y**7-32819627*y**8+11477956*y**9-3980774*y**10+284004*y**11)
          +r**24*(-68342057+520146848*y-1732861276*y**2+3178642020*y**3-3527109479*y**4
          +2690610200*y**5-1846723316*y**6+1270174280*y**7-621847475*y**8+137913344*y**9
          +1466792*y**10-2666852*y**11-7829*y**12)-r**22*(1078400999-7084380244*y
          +19469801208*y**2-27441229648*y**3+17190177883*y**4+4373905480*y**5-15952292844*y**6
          +11870710512*y**7-3948708351*y**8+373238092*y**9+63312396*y**10+14462488*y**11
          -9367195*y**12+826824*y**13)+r**20*(893794543-5483489616*y+12720617450*y**2
          -13311872908*y**3+647859745*y**4+17119011764*y**5-23017562908*y**6+12285667020*y**7
          +634395061*y**8-3928192740*y**9+1566489118*y**10-66113976*y**11-72209245*y**12
          +11006072*y**13-743380*y**14)-6*(-1+y)**9*(-1073-5365*y-16095*y**2
          -23669*y**3-16718*y**4+15046*y**5+15650*y**6+20330*y**7-10277*y**8
          +6891*y**9-19123*y**10-5685*y**11+20740*y**12-10204*y**13+1552*y**14)
          +r**2*(-1+y)**8*(135431+515972*y+1225550*y**2+824828*y**3-1499507*y**4
          -4128536*y**5+3576276*y**6-996440*y**7+1302249*y**8-1502956*y**9+894614*y**10
          +53052*y**11-394685*y**12+218848*y**13-69112*y**14+12416*y**15)+r**4*(
          -1+y)**7*(-777413-2387699*y-5052194*y**2+6179046*y**3-2266095*y**4
          +10336407*y**5+19590388*y**6-41815092*y**7-19641907*y**8+76333675*y**9
          -55053730*y**10+16593086*y**11-2312889*y**12+285761*y**13-140080*y**14
          +44736*y**15)+r**12*(-1+y)**3*(-1902165473+3741268589*y-1158767320*y**2
          -3279545364*y**3+11216114381*y**4-21635765337*y**5+20739035522*y**6-2762389070*y**7
          -16902270007*y**8+20535575563*y**9-11572756812*y**10+3490528264*y**11
          -515368085*y**12+19704321*y**13+1756706*y**14+80122*y**15)+r**6*(-1
          +y)**6*(-7124605-13883602*y-19263481*y**2+81002436*y**3+63704455*y**4
          -4838206*y**5-395419441*y**6+430103272*y**7-138892087*y**8+71986650*y**9
          -165610683*y**10+158950868*y**11-74081891*y**12+16626726*y**13-1519755*y**14
          +107344*y**15)-r**18*(-13178504421+83995827548*y-221663136190*y**2+322286853508*y**3
          -281544152319*y**4+134774786704*y**5+4401990624*y**6-66415299200*y**7
          +58157409749*y**8-26112543412*y**9+4887764850*y**10+951796228*y**11-602003985*y**12
          +55042568*y**13+4901356*y**14+274392*y**15)+r**8*(-1+y)**5*(27391283
          +25655711*y+24450425*y**2-401234679*y**3+854772237*y**4-696615007*y**5
          +307564603*y**6-850616925*y**7+1715875413*y**8-1467407919*y**9+437676055*y**10
          +169379311*y**11-175953525*y**12+52544591*y**13-6405643*y**14+396069*y**15)
          +r**10*(-1+y)**4*(-526045597+689098792*y+28521412*y**2+3716649280*y**3
          -10079011827*y**4+9928826604*y**5-6168911814*y**6+6594758076*y**7-8950234795*y**8
          +7601802744*y**9-3665123192*y**10+1012444272*y**11-191295013*y**12+40828340*y**13
          -8004742*y**14+729460*y**15)-r**14*(-1+y)**2*(-4130544719+14082210518*y
          -16667859697*y**2+10690113128*y**3-9421238895*y**4+9300774466*y**5-6478896161*y**6
          +4059812524*y**7-1092496981*y**8-1995180950*y**9+3207176085*y**10-2197599632*y**11
          +715835123*y**12-81542722*y**13-5934755*y**14+1092668*y**15)+r**16*(4496024685
          -26688840176*y+65822386128*y**2-107681257844*y**3+172212200662*y**4
          -267215361328*y**5+318119645620*y**6-261888838336*y**7+140327836448*y**8
          -38525823384*y**9-4677682864*y**10+7894710308*y**11-2346730142*y**12
          +84455896*y**13+73070572*y**14-4889168*y**15-907077*y**16))-(-1+r**2
          +y)**5*(97*r**36*(-1+y)**10+r**34*(-1+y)**6*(-10192+40283*y-59212*y**2
          +41068*y**3-12912*y**4+1445*y**5)+r**32*(-1+y)**4*(286913-1683543*y
          +4071270*y**2-5324543*y**3+4138986*y**4-1971473*y**5+583242*y**6-103353*y**7
          +7973*y**8)+r**30*(-1+y)**2*(-8160204+63605198*y-215307682*y**2+414263211*y**3
          -500880872*y**4+400131514*y**5-217451884*y**6+81460012*y**7-20934276*y**8
          +3502992*y**9-328730*y**10+20081*y**11)+r**28*(-7913696+48203302*y
          -84270842*y**2-121673501*y**3+844085653*y**4-1895171023*y**5+2595748121*y**6
          -2467639382*y**7+1694735694*y**8-832291972*y**9+276612284*y**10-55816653*y**11
          +5751309*y**12-334483*y**13+13589*y**14)+r**26*(489725500-4419921118*y
          +17617363434*y**2-40630387751*y**3+59338006480*y**4-55846582516*y**5
          +31888819702*y**6-7715617813*y**7-2899814824*y**8+3081985598*y**9-1023474086*y**10
          +105196691*y**11+18709564*y**12-4733580*y**13+640102*y**14-49783*y**15)
          +(-1+y)**11*(-3461-20766*y-72681*y**2-143838*y**3-95927*y**4+160840*y**5
          -187359*y**6+33012*y**7+309901*y**8-79566*y**9+14913*y**10-163174*y**11
          +89719*y**12-10588*y**13+743*y**14+208*y**15+24*y**16)-r**24*(1064848536
          -9497296426*y+36915651682*y**2-82962404947*y**3+117580615925*y**4-101520328216*y**5
          +34510359002*y**6+33704211835*y**7-55940460427*y**8+36771345374*y**9
          -12114699802*y**10+1178364763*y**11+429311183*y**12-133826476*y**13+16004526*y**14
          -1950643*y**15+119711*y**16)+r**2*(-1+y)**10*(156772+723909*y+2030502*y**2
          +2408263*y**3+3732676*y**4+2809005*y**5-11352070*y**6-887597*y**7+7822092*y**8
          -5459609*y**9+5063722*y**10-1505139*y**11-2636404*y**12+2014095*y**13
          -396042*y**14+11801*y**15+24*y**17)+r**4*(-1+y)**9*(5400275+19252019*y
          +43365668*y**2+16424311*y**3-15629788*y**4-74371943*y**5-26649110*y**6
          +39479753*y**7+80811308*y**8-106482539*y**9+59979136*y**10-16511567*y**11
          -8962720*y**12+10911031*y**13-3929198*y**14+631407*y**15-31267*y**16
          +1224*y**17)+r**22*(10737606356-90262197826*y+330725211062*y**2-680514230231*y**3
          +820392227540*y**4-478243858523*y**5-140576353634*y**6+538626939065*y**7
          -511274586364*y**8+273528986089*y**9-86827689158*y**10+14471094355*y**11
          -851424172*y**12+138141895*y**13-77180654*y**14+6669675*y**15+632480*y**16
          +12045*y**17)+r**6*(-1+y)**8*(29453244+73036394*y+117033314*y**2-30929477*y**3
          -224954964*y**4-136622649*y**5+546668778*y**6-524465845*y**7-68015876*y**8
          +678107043*y**9-549200994*y**10+140479337*y**11-4293092*y**12+15983853*y**13
          -13906154*y**14+3851249*y**15-326784*y**16+14623*y**17)+r**8*(-1+y)**7*(49606816
          +52766010*y+8899116*y**2+612390513*y**3-591021328*y**4+67917313*y**5
          -2221191410*y**6+3467684387*y**7-2107364986*y**8+2073682131*y**9-2857233664*y**10
          +2283823775*y**11-1046305292*y**12+298242423*y**13-65298778*y**14+13727085*y**15
          -1603050*y**16+86939*y**17)+r**10*(-1+y)**6*(575667284+45385430*y-170213962*y**2
          -2999194083*y**3+6912347208*y**4-7419702865*y**5+1116718442*y**6-67924695*y**7
          +10888055576*y**8-14190909141*y**9+3926815298*y**10+4146403071*y**11
          -3883312624*y**12+1380519357*y**13-267085442*y**14+40234683*y**15-4887268*y**16
          +315731*y**17)+r**12*(-1+y)**5*(-1246725384+3964492598*y-2050210636*y**2
          +18393533919*y**3-58239905016*y**4+64344539601*y**5-45265824742*y**6
          +50784342817*y**7-58026819054*y**8+41394219371*y**9-20788488696*y**10
          +11185414329*y**11-6466616452*y**12+2586155735*y**13-605507830*y**14
          +89295879*y**15-10324910*y**16+764471*y**17)+r**18*(-1+y)**2*(-24760849188
          +131456546720*y-274060957198*y**2+380601401411*y**3-595563964056*y**4
          +916093385181*y**5-961334402410*y**6+614138347079*y**7-234430169112*y**8
          +74505716677*y**9-53317368578*y**10+40691662065*y**11-17728011784*y**12
          +4393169751*y**13-754427046*y**14+113090885*y**15-13247300*y**16+1156903*y**17)
          +r**14*(-1+y)**4*(-14497317572+39592437570*y-28326386094*y**2+10707403427*y**3
          -27226262796*y**4+5490901475*y**5+35730321234*y**6+31565312931*y**7-168717034844*y**8
          +205393531847*y**9-125085889434*y**10+44490378657*y**11-11517725780*y**12
          +3118640817*y**13-805189226*y**14+135169881*y**15-15805536*y**16+1281443*y**17)
          +r**16*(-1+y)**3*(-209326834-1756415098*y+14716762826*y**2-36494749699*y**3
          +26285744962*y**4+4962883413*y**5+23178694064*y**6-39450436509*y**7-66246297152*y**8
          +171176427931*y**9-149570789894*y**10+69837010651*y**11-19659837110*y**12
          +3944591051*y**13-794376468*y**14+142508965*y**15-17518842*y**16+1491743*y**17)
          +r**20*(-27762301366+230323313098*y-824340538296*y**2+1644966959231*y**3
          -1882407897939*y**4+883011918457*y**5+801258425929*y**6-1846523302853*y**7
          +1669956007705*y**8-881940847327*y**9+280327917129*y**10-57375075947*y**11
          +16881110119*y**12-8969506573*y**13+3127148091*y**14-595544495*y**15
          +67629545*y**16-5920695*y**17+506187*y**18))))/(-5225472000*logy**5*r**20*(
          -1+y)**10+21000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5-2177280000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))-362880000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-30240000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -1260000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*muWC**3*(653184000*logy**5*r**16*(42+106*r**2
          +129*r**4+119*r**6+89*r**8+27*r**10)*(-1+y)**11+518400*logy**4*r**12*(
          -1+y)**6*(10281*r**18*(-1+y)**5-12*(-1+y)**6*(-97-97*y-97*y**2+498*y**3
          +78*y**4-510*y**5+120*y**6)+15*r**16*(-4733+23665*y-47330*y**2+44516*y**3
          -21607*y**4+4019*y**5+126*y**6)+12*r**2*(-1+y)**5*(-4063+9730*y**3
          -9030*y**4+4228*y**5-630*y**6+80*y**7)+3*r**14*(-54813+217365*y-292980*y**2
          +65200*y**3+133965*y**4-106257*y**5+22820*y**6+1260*y**7)-105*r**6*(
          -1+y)**3*(3951-14262*y+13491*y**2-1260*y**3-2237*y**4-362*y**5+723*y**6
          -256*y**7+8*y**8)+21*r**12*(-20121+73905*y-81060*y**2-14990*y**3+83215*y**4
          -54929*y**5+13040*y**6-1610*y**7+630*y**8)-r**4*(-1+y)**4*(-384669
          +649269*y-132300*y**2-157430*y**3+32725*y**4-20111*y**5+21336*y**6
          -14520*y**7+1920*y**8)+7*r**10*(-30957+47685*y+172380*y**2-529460*y**3
          +522900*y**4-199968*y**5+770*y**6+17490*y**7-5205*y**8+1485*y**9)+21*r**8*(1691
          -47155*y+191060*y**2-309230*y**3+217330*y**4-26422*y**5-49580*y**6
          +25890*y**7-2965*y**8-955*y**9+336*y**10))+17280*logy**3*r**8*(-1+y)**4*(
          -33933*r**26*(-1+y)**7+15*r**24*(-1+y)**2*(-20611+103055*y-206110*y**2
          +198730*y**3-87451*y**4+6383*y**5+4628*y**6)+3*r**22*(-1+y)**2*(-1151559
          +5346555*y-9665010*y**2+8240950*y**3-3674035*y**4+1024519*y**5-399100*y**6
          +117520*y**7)+6*(-1+y)**10*(2176+6528*y+13056*y**2-6375*y**3-25120*y**4
          -40631*y**5+81982*y**6-42406*y**7+7640*y**8)-2*r**2*(-1+y)**9*(-41106
          -82212*y-123318*y**2+140746*y**3+295465*y**4+206836*y**5-565763*y**6
          +270688*y**7-59306*y**8+3120*y**9)+5*r**4*(-1+y)**8*(-162099-134163*y
          -120195*y**2+822623*y**3-503943*y**4-23829*y**5-79411*y**6+137573*y**7
          +47832*y**8-49200*y**9+9792*y**10)+3*r**20*(-183613-1554509*y+14602827*y**2
          -47679135*y**3+79063535*y**4-74585867*y**5+42171889*y**6-14492797*y**7
          +3056810*y**8-516420*y**9+83680*y**10)+r**6*(-1+y)**7*(5669277-5850720*y
          -2925360*y**2-6875260*y**3+17829610*y**4-8585784*y**5-1625570*y**6+1668200*y**7
          +854955*y**8-581160*y**9+100512*y**10)-5*r**8*(-1+y)**5*(-5100369+19432794*y
          -22123653*y**2+58456*y**3+17145330*y**4-12162168*y**5+2899716*y**6-224406*y**7
          +190569*y**8-41656*y**9-49125*y**10+7272*y**11)-10*r**18*(483903-1414053*y
          -1643679*y**2+12897683*y**3-21586465*y**4+15781961*y**5-4803002*y**6
          +417262*y**7-519698*y**8+567372*y**9-186195*y**10+14991*y**11)+10*r**14*(
          -1+y)**2*(2333781-14269293*y+30541356*y**2-22967464*y**3-4725198*y**4
          +15295992*y**5-6975411*y**6+538863*y**7+22548*y**8+292732*y**9-158634*y**10
          +35448*y**11)-r**10*(-1+y)**4*(-7999533-25784001*y+140525901*y**2-165617647*y**3
          +48030490*y**4+21840678*y**5+1195196*y**6-15882936*y**7+4032097*y**8
          +2498145*y**9-1257075*y**10+81885*y**11)+2*r**12*(-1+y)**3*(-17744907
          +68848968*y-74631132*y**2-12606602*y**3+61414558*y**4-19845098*y**5
          -19569193*y**6+17105387*y**7-4624318*y**8+476247*y**9-247890*y**10+126180*y**11)
          -2*r**16*(12828303-64445661*y+121424373*y**2-101381450*y**3+45639820*y**4
          -60546836*y**5+106866067*y**6-98679271*y**7+52360175*y**8-17508995*y**9
          +4047108*y**10-625431*y**11+21798*y**12))+288*logy**2*r**4*(-1+y)**3*(
          -1+r**2+y)**2*(4473*r**30*(-1+y)**8+3*r**28*(-1+y)**3*(335509-1674563*y
          +3340180*y**2-3204760*y**3+1787035*y**4-565349*y**5+87388*y**6)+r**26*(
          -6036258+44186232*y-139225119*y**2+252747080*y**3-293293806*y**4+225061524*y**5
          -113677972*y**6+37511184*y**7-8961960*y**8+2127356*y**9-438261*y**10)
          -6*(-1+y)**11*(761+3805*y+11415*y**2+23680*y**3+20825*y**4-34297*y**5
          -196055*y**6+25910*y**7+298570*y**8-213050*y**9+40936*y**10)+r**24*(144355806
          -1097336004*y+3612819063*y**2-6700131662*y**3+7654809638*y**4-5556701334*y**5
          +2580380776*y**6-809610238*y**7+237462612*y**8-86332838*y**9+22467353*y**10
          -2183172*y**11)-2*r**2*(-1+y)**10*(-70515-286626*y-727980*y**2+17170*y**3
          +1566795*y**4+3085590*y**5-6359968*y**6+2710930*y**7+1911330*y**8-1785920*y**9
          +289750*y**10+16944*y**11)+r**22*(370464705-2523535188*y+7221236205*y**2
          -10883364800*y**3+8876885400*y**4-3293213400*y**5-163330874*y**6+461415600*y**7
          -30099375*y**8-29407700*y**9-13727355*y**10+6360912*y**11+315870*y**12)
          -r**4*(-1+y)**8*(-3933531-5808174*y-6812667*y**2+39314662*y**3+6403430*y**4
          +6096762*y**5-177048202*y**6+239034214*y**7-104819759*y**8-7802680*y**9
          +20668569*y**10-5358024*y**11-373272*y**12+228672*y**13)+r**8*(-1+y)**6*(
          -121011102+96963168*y+28358085*y**2+656250904*y**3-1330939155*y**4
          +752461704*y**5-214939726*y**6+360232820*y**7-233871628*y**8-76463020*y**9
          +118009973*y**10-37603192*y**11+3581945*y**12+229224*y**13)-r**6*(-1
          +y)**7*(-39815133-21558879*y-12601299*y**2+270675971*y**3-116647170*y**4
          -60863814*y**5-346081642*y**6+572364018*y**7-272023237*y**8-4867255*y**9
          +39115097*y**10-6911129*y**11-2158544*y**12+533016*y**13)+r**12*(-1
          +y)**4*(-2860360485+11291645046*y-14752654476*y**2+3228683430*y**3+9024612975*y**4
          -8566337460*y**5+2499770408*y**6+78575772*y**7-53884675*y**8+118582850*y**9
          -158313280*y**10+53381746*y**11-6032571*y**12+648720*y**13)-2*r**16*(
          -1+y)**2*(-1656470133+6558630876*y-8596321569*y**2+2739979431*y**3
          +2034702510*y**4-167366394*y**5-2110981492*y**6+1567403023*y**7-474137182*y**8
          +181757240*y**9-153023323*y**10+63876966*y**11-11651979*y**12+796026*y**13)
          +r**10*(-1+y)**5*(615981534-1649729538*y+967482261*y**2-223704147*y**3
          +2105856615*y**4-3313509273*y**5+1184304826*y**6+905343098*y**7-633386636*y**8
          -116391140*y**9+182162389*y**10-42206163*y**11-1712709*y**12+1448883*y**13)
          -r**14*(-1+y)**3*(-992991837+7158401817*y-17083228044*y**2+16489039704*y**3
          -4956013545*y**4-1266965691*y**5+183901016*y**6+1042739288*y**7-576953323*y**8
          -27607105*y**9+66068528*y**10+15681692*y**11-14556819*y**12+1880319*y**13)
          +r**20*(-65979255+997621722*y-4990670793*y**2+14242508666*y**3-23912831900*y**4
          +24055219110*y**5-15265636494*y**6+7071238926*y**7-3191510547*y**8+1576999300*y**9
          -697120705*y**10+224696472*y**11-46549458*y**12+5206956*y**13)+2*r**18*(435668877
          -2363697900*y+4546600758*y**2-1363915674*y**3-7712188851*y**4+13044196266*y**5
          -9820694060*y**6+3935836124*y**7-477452582*y**8-488466918*y**9+386738457*y**10
          -170145590*y**11+60730168*y**12-14921844*y**13+1712769*y**14))+12*logy*(
          -1+y)**2*(-1+r**2+y)**3*(4695*r**36*(-1+y)**9+3*r**34*(-1+y)**4*(16034
          -75475*y+136865*y**2-70550*y**3+30860*y**4-16759*y**5+5585*y**6)-r**32*(
          -1+y)**2*(-1610256+11616717*y-36094329*y**2+61125139*y**3-62634509*y**4
          +41087473*y**5-15563515*y**6+3410801*y**7-456367*y**8+21246*y**9)+6*(
          -1+y)**14*(57+456*y+2052*y**2+7378*y**3+18184*y**4+26136*y**5-14696*y**6
          -43882*y**7+33167*y**8+5536*y**9-19748*y**10+7760*y**11)+r**30*(101273598
          -868324779*y+3282536781*y**2-7183413898*y**3+10134851374*y**4-9765881502*y**5
          +6656496330*y**6-3261839044*y**7+1130230498*y**8-253991759*y**9+28644609*y**10
          +3494*y**11-48102*y**12)+2*r**2*(-1+y)**12*(4968+30321*y+107919*y**2
          +67322*y**3-161150*y**4-182916*y**5+3290768*y**6+518522*y**7-5366734*y**8
          +2546075*y**9+460873*y**10-596764*y**11+139484*y**12+9312*y**13)-3*r**28*(172756934
          -1564498137*y+6245750325*y**2-14302457908*y**3+20912837885*y**4-20802759769*y**5
          +14788033502*y**6-7834190188*y**7+3164841892*y**8-955047695*y**9+197772925*y**10
          -23332000*y**11+1009353*y**12+89281*y**13)+r**26*(-4366638834+33954540417*y
          -113813007975*y**2+212885708576*y**3-238752392054*y**4+156754915323*y**5
          -48279259229*y**6-3881973820*y**7+5114486358*y**8+2358622603*y**9-2711338189*y**10
          +842425212*y**11-112070830*y**12+12378841*y**13-1826799*y**14)+r**4*(
          -1+y)**11*(1108473+5292363*y+15234615*y**2+19787185*y**3-3177182*y**4
          -65875946*y**5-60730066*y**6+35167290*y**7+138142605*y**8-135396241*y**9
          +37732523*y**10+1815653*y**11-2161880*y**12+339360*y**13+37248*y**14)
          +r**24*(-3499233942+21465507051*y-49210041411*y**2+30338351806*y**3
          +71520859178*y**4-167663688123*y**5+158628136593*y**6-88291187308*y**7
          +44702362858*y**8-32584791151*y**9+22095819307*y**10-9629596494*y**11
          +2465850594*y**12-389802689*y**13+49304423*y**14-3226692*y**15)-r**14*(
          -1+y)**5*(12621118938-43708238943*y+39054498696*y**2+11953828012*y**3
          -5988395222*y**4-43690250537*y**5+21367133496*y**6+46890510318*y**7-46492290594*y**8
          +3599536479*y**9+8794181400*y**10-2327674128*y**11-399271714*y**12+212073257*y**13
          -17655832*y**14+64374*y**15)+r**12*(-1+y)**6*(15116274-1565355195*y
          +1026344979*y**2-5775514805*y**3+21451677326*y**4-27116121129*y**5+8215047635*y**6
          +9201785717*y**7-9549717010*y**8+4164426803*y**9-268727119*y**10-530338315*y**11
          +149021554*y**12-21018735*y**13+2861321*y**14+78699*y**15)+3*r**10*(
          -1+y)**7*(-706525118-1342331*y+173368984*y**2+4409323597*y**3-4123696010*y**4
          -558965753*y**5-4885026488*y**6+11797404467*y**7-7189476674*y**8-93616285*y**9
          +1689237160*y**10-537179581*y**11-21581526*y**12+28287377*y**13-2595880*y**14
          +152061*y**15)+r**6*(-1+y)**9*(8017134+20357379*y+36099792*y**2-159209546*y**3
          -52892410*y**4+61540053*y**5+1221289872*y**6-1913424604*y**7+223109482*y**8
          +1277457005*y**9-923657168*y**10+196858374*y**11+16579362*y**12-9433061*y**13
          +496880*y**14+171456*y**15)+r**8*(-1+y)**8*(-124291362-80130615*y-6720849*y**2
          +1106202430*y**3-175292258*y**4-16511129*y**5-5137309285*y**6+8044358288*y**7
          -4431554530*y**8+509952731*y**9+505004249*y**10-182986750*y**11-29366714*y**12
          +22986325*y**13-2856323*y**14+363792*y**15)+3*r**16*(-1+y)**4*(20721115846
          -84949253849*y+123971834053*y**2-52844245524*y**3-51056930710*y**4+75486623097*y**5
          -34939741067*y**6-9197929846*y**7+20681238318*y**8-10218030755*y**9+2051214403*y**10
          -55732684*y**11-17039982*y**12+2269331*y**13-6235885*y**14+965254*y**15)
          +3*r**18*(-1+y)**3*(15030248362-47859201075*y+36518660184*y**2+25648632255*y**3
          -47953319562*y**4+24554730379*y**5-10459830320*y**6+5974794457*y**7+1457726070*y**8
          -6157612781*y**9+3350816376*y**10+171757745*y**11-569513366*y**12+167803925*y**13
          -26408032*y**14+2595383*y**15)+r**20*(-1+y)**2*(-32670014544+162734323653*y
          -309527740017*y**2+263603095337*y**3-89812283500*y**4+8935788539*y**5
          -26629356841*y**6+53163544239*y**7-50131048104*y**8+27732979515*y**9
          -13676428651*y**10+7303784263*y**11-2575778172*y**12+477319717*y**13
          -54840315*y**14+7102881*y**15)+r**22*(9256224534-79668913167*y+297367903737*y**2
          -671167876742*y**3+986831206148*y**4-942927602541*y**5+579973697167*y**6
          -242406039744*y**7+89774460674*y**8-38050644361*y**9+14601355495*y**10
          -4480040478*y**11+880533032*y**12+124305093*y**13-137341487*y**14+28296612*y**15
          +476028*y**16))-(-1+r**2+y)**4*(2211*r**38*(-1+y)**11+3*r**36*(-1+y)**6*(26905
          -131577*y+254310*y**2-246380*y**3+128515*y**4-36275*y**5+5142*y**6)
          +r**34*(-1+y)**4*(-1275483+8670705*y-24975351*y**2+39844273*y**3-39046079*y**4
          +24793741*y**5-10352017*y**6+2734607*y**7-400126*y**8+27618*y**9)-r**32*(
          -1+y)**2*(-14442411+125714667*y-481800636*y**2+1080473634*y**3-1580194670*y**4
          +1584145544*y**5-1112434126*y**6+547377558*y**7-182604605*y**8+37773997*y**9
          -3493798*y**10-259608*y**11+67014*y**12)-2*r**30*(103962330-1107172788*y
          +5326378107*y**2-15335532863*y**3+29526275825*y**4-40235122235*y**5+40013154581*y**6
          -29432056053*y**7+15977170216*y**8-6261638214*y**9+1665959593*y**10-243796333*y**11
          -7293579*y**12+11876397*y**13-2426401*y**14+184617*y**15)+3*(-1+y)**13*(7607
          +44274*y+150855*y**2+370898*y**3+320997*y**4-630048*y**5-2478391*y**6
          +1240380*y**7+5426729*y**8-6942294*y**9+1420265*y**10+3274530*y**11
          -2801885*y**12+738148*y**13-28953*y**14-1424*y**15+312*y**16)-2*r**28*(
          -148292562+1859423292*y-10315154403*y**2+33916024483*y**3-73949306807*y**4
          +112954253831*y**5-124284511077*y**6+99588290128*y**7-57924173261*y**8
          +23947333406*y**9-6583455593*y**10+855633871*y**11+194948515*y**12-144782097*y**13
          +38797361*y**14-5034706*y**15+274419*y**16)+r**2*(-1+y)**12*(-66459
          -300243*y-849825*y**2+9402803*y**3+1327439*y**4-42257257*y**5-152689539*y**6
          +212759905*y**7+301735867*y**8-547144685*y**9+213974489*y**10+73833685*y**11
          -88206327*y**12+24239105*y**13-1009429*y**14-56073*y**15+10472*y**16
          +72*y**17)+r**4*(-1+y)**11*(-24559803-84703752*y-186106458*y**2+85574442*y**3
          +385784956*y**4+647967814*y**5-1130736936*y**6+153690268*y**7-345141148*y**8
          +1498999540*y**9-1449670666*y**10+609235682*y**11-161135592*y**12+29016206*y**13
          +181804*y**14+858680*y**15+42531*y**16+1632*y**17)+r**6*(-1+y)**10*(
          -71882787-227150217*y-432690126*y**2-651499450*y**3+1654140480*y**4
          +2818095692*y**5+6553524752*y**6-20165736684*y**7+5139538084*y**8+16860170996*y**9
          -15492194270*y**10+4408228222*y**11-71238932*y**12-116151744*y**13+7272764*y**14
          +5715080*y**15+117683*y**16+6057*y**17)-2*r**8*(-1+y)**9*(688651266
          +482037858*y+266319879*y**2-4496009666*y**3-1718775540*y**4-1603203530*y**5
          +17533200242*y**6-16398558587*y**7+9432583689*y**8-12110679837*y**9+10741774191*y**10
          -3749885148*y**11+427203818*y**12-35224008*y**13+9893192*y**14-6624887*y**15
          -317137*y**16+14205*y**17)+2*r**26*(2081578614-20609115300*y+91003040661*y**2
          -231949676365*y**3+373978016880*y**4-396474576694*y**5+283323150898*y**6
          -148871629444*y**7+79712265087*y**8-57399030447*y**9+39582187365*y**10
          -19866857721*y**11+6957387586*y**12-1758361752*y**13+331373812*y**14
          -41635990*y**15+2081593*y**16+70017*y**17)-2*r**10*(-1+y)**8*(10642078794
          -3934713720*y-4454133507*y**2-59424481549*y**3+68452336452*y**4-3331934314*y**5
          +63895314134*y**6-165378922600*y**7+113262072351*y**8-11788289287*y**9
          -14511967163*y**10+4342390767*y**11+653618550*y**12-417988892*y**13+18092920*y**14
          -1923882*y**15-1748371*y**16+151317*y**17)-6*r**18*(-1+y)**4*(-34948046405
          +167496882245*y-303623150758*y**2+222026930896*y**3+65997342795*y**4
          -275337659703*y**5+207034470119*y**6+10379809049*y**7-120366408684*y**8
          +87278294242*y**9-32702006908*y**10+7260958302*y**11-466608045*y**12
          -192836027*y**13+30760923*y**14+4041401*y**15-713581*y**16+260139*y**17)
          +2*r**20*(-1+y)**3*(14580942903-93722012118*y+248982535149*y**2-355386312308*y**3
          +137323088182*y**4+310316977984*y**5-419868682236*y**6+108665926655*y**7
          +138789108665*y**8-136294723423*y**9+50971595941*y**10-1456619854*y**11
          -7112735940*y**12+3299649298*y**13-769899254*y**14+106530627*y**15-11940962*y**16
          +482691*y**17)-2*r**12*(-1+y)**7*(26527942242-27900825018*y-10257630867*y**2
          -68153143610*y**3+117724939566*y**4+18427240942*y**5-10190216572*y**6
          -196073315367*y**7+206725022655*y**8-50727536921*y**9-22629604843*y**10
          +15042098496*y**11-2820879756*y**12+415362500*y**13-194486950*y**14+31889729*y**15
          -5799811*y**16+567585*y**17)+2*r**22*(-1+y)**2*(-8081119593+73017414063*y
          -278228386761*y**2+645213165693*y**3-980266260598*y**4+964900371944*y**5
          -569365662900*y**6+138460147994*y**7+55956618547*y**8-59491359823*y**9
          +20837162455*y**10-2194444967*y**11-1253471220*y**12+1077034870*y**13
          -474339994*y**14+113947504*y**15-16710336*y**16+1189122*y**17)-2*r**14*(
          -1+y)**6*(88061943642-241999601220*y+183233585223*y**2-39655971579*y**3
          +161373625102*y**4-222795870612*y**5+21240566228*y**6+62136262002*y**7
          +17039677197*y**8-49521256185*y**9+11802383127*y**10+13272019233*y**11
          -9356775864*y**12+2980618802*y**13-665913522*y**14+92082088*y**15-11305821*y**16
          +1192959*y**17)-2*r**16*(-1+y)**5*(-23020931703+220711831644*y-574133583246*y**2
          +442599346240*y**3+397863142505*y**4-904779388362*y**5+456177078587*y**6
          +189631244245*y**7-318796609554*y**8+130984215849*y**9-28190798700*y**10
          +17565069294*y**11-10423459219*y**12+3311919724*y**13-709782369*y**14
          +106428925*y**15-11895565*y**16+1458105*y**17)+2*r**24*(10217458482-92230275300*y
          +365282649507*y**2-835179453919*y**3+1209447258838*y**4-1122754824886*y**5
          +592913802360*y**6-15644575451*y**7-285750460784*y**8+303593419138*y**9
          -199281063280*y**10+98478572979*y**11-38366570730*y**12+11173033694*y**13
          -2049545476*y**14+124535559*y**15+34503186*y**16-9288326*y**17+824409*y**18))))/(17635968000*logy**5*r**20*(
          -1+y)**11-70875*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(
          -1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5+7348320000*logy**4*r**16*(-1+y)**9*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+1224720000*logy**3*r**12*(-1+y)**7*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+102060000*logy**2*r**8*(
          -1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +4252500*logy*(-1+y)**3*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((rhoD*(-653184000*logy**5*r**16*(42+106*r**2+129*r**4
          +119*r**6+89*r**8+27*r**10)*(-1+y)**11-518400*logy**4*r**12*(-1+y)**6*(10281*r**18*(
          -1+y)**5-12*(-1+y)**6*(-97-97*y-97*y**2+498*y**3+78*y**4-510*y**5
          +120*y**6)+15*r**16*(-4733+23665*y-47330*y**2+44516*y**3-21607*y**4
          +4019*y**5+126*y**6)+12*r**2*(-1+y)**5*(-4063+9730*y**3-9030*y**4+4228*y**5
          -630*y**6+80*y**7)+3*r**14*(-54813+217365*y-292980*y**2+65200*y**3
          +133965*y**4-106257*y**5+22820*y**6+1260*y**7)-105*r**6*(-1+y)**3*(3951
          -14262*y+13491*y**2-1260*y**3-2237*y**4-362*y**5+723*y**6-256*y**7
          +8*y**8)+21*r**12*(-20121+73905*y-81060*y**2-14990*y**3+83215*y**4
          -54929*y**5+13040*y**6-1610*y**7+630*y**8)-r**4*(-1+y)**4*(-384669
          +649269*y-132300*y**2-157430*y**3+32725*y**4-20111*y**5+21336*y**6
          -14520*y**7+1920*y**8)+7*r**10*(-30957+47685*y+172380*y**2-529460*y**3
          +522900*y**4-199968*y**5+770*y**6+17490*y**7-5205*y**8+1485*y**9)+21*r**8*(1691
          -47155*y+191060*y**2-309230*y**3+217330*y**4-26422*y**5-49580*y**6
          +25890*y**7-2965*y**8-955*y**9+336*y**10))-17280*logy**3*r**8*(-1+y)**4*(
          -33933*r**26*(-1+y)**7+15*r**24*(-1+y)**2*(-20611+103055*y-206110*y**2
          +198730*y**3-87451*y**4+6383*y**5+4628*y**6)+3*r**22*(-1+y)**2*(-1151559
          +5346555*y-9665010*y**2+8240950*y**3-3674035*y**4+1024519*y**5-399100*y**6
          +117520*y**7)+6*(-1+y)**10*(2176+6528*y+13056*y**2-6375*y**3-25120*y**4
          -40631*y**5+81982*y**6-42406*y**7+7640*y**8)-2*r**2*(-1+y)**9*(-41106
          -82212*y-123318*y**2+140746*y**3+295465*y**4+206836*y**5-565763*y**6
          +270688*y**7-59306*y**8+3120*y**9)+5*r**4*(-1+y)**8*(-162099-134163*y
          -120195*y**2+822623*y**3-503943*y**4-23829*y**5-79411*y**6+137573*y**7
          +47832*y**8-49200*y**9+9792*y**10)+3*r**20*(-183613-1554509*y+14602827*y**2
          -47679135*y**3+79063535*y**4-74585867*y**5+42171889*y**6-14492797*y**7
          +3056810*y**8-516420*y**9+83680*y**10)+r**6*(-1+y)**7*(5669277-5850720*y
          -2925360*y**2-6875260*y**3+17829610*y**4-8585784*y**5-1625570*y**6+1668200*y**7
          +854955*y**8-581160*y**9+100512*y**10)-5*r**8*(-1+y)**5*(-5100369+19432794*y
          -22123653*y**2+58456*y**3+17145330*y**4-12162168*y**5+2899716*y**6-224406*y**7
          +190569*y**8-41656*y**9-49125*y**10+7272*y**11)-10*r**18*(483903-1414053*y
          -1643679*y**2+12897683*y**3-21586465*y**4+15781961*y**5-4803002*y**6
          +417262*y**7-519698*y**8+567372*y**9-186195*y**10+14991*y**11)+10*r**14*(
          -1+y)**2*(2333781-14269293*y+30541356*y**2-22967464*y**3-4725198*y**4
          +15295992*y**5-6975411*y**6+538863*y**7+22548*y**8+292732*y**9-158634*y**10
          +35448*y**11)-r**10*(-1+y)**4*(-7999533-25784001*y+140525901*y**2-165617647*y**3
          +48030490*y**4+21840678*y**5+1195196*y**6-15882936*y**7+4032097*y**8
          +2498145*y**9-1257075*y**10+81885*y**11)+2*r**12*(-1+y)**3*(-17744907
          +68848968*y-74631132*y**2-12606602*y**3+61414558*y**4-19845098*y**5
          -19569193*y**6+17105387*y**7-4624318*y**8+476247*y**9-247890*y**10+126180*y**11)
          -2*r**16*(12828303-64445661*y+121424373*y**2-101381450*y**3+45639820*y**4
          -60546836*y**5+106866067*y**6-98679271*y**7+52360175*y**8-17508995*y**9
          +4047108*y**10-625431*y**11+21798*y**12))-288*logy**2*r**4*(-1+y)**3*(
          -1+r**2+y)**2*(4473*r**30*(-1+y)**8+3*r**28*(-1+y)**3*(335509-1674563*y
          +3340180*y**2-3204760*y**3+1787035*y**4-565349*y**5+87388*y**6)+r**26*(
          -6036258+44186232*y-139225119*y**2+252747080*y**3-293293806*y**4+225061524*y**5
          -113677972*y**6+37511184*y**7-8961960*y**8+2127356*y**9-438261*y**10)
          -6*(-1+y)**11*(761+3805*y+11415*y**2+23680*y**3+20825*y**4-34297*y**5
          -196055*y**6+25910*y**7+298570*y**8-213050*y**9+40936*y**10)+r**24*(144355806
          -1097336004*y+3612819063*y**2-6700131662*y**3+7654809638*y**4-5556701334*y**5
          +2580380776*y**6-809610238*y**7+237462612*y**8-86332838*y**9+22467353*y**10
          -2183172*y**11)-2*r**2*(-1+y)**10*(-70515-286626*y-727980*y**2+17170*y**3
          +1566795*y**4+3085590*y**5-6359968*y**6+2710930*y**7+1911330*y**8-1785920*y**9
          +289750*y**10+16944*y**11)+r**22*(370464705-2523535188*y+7221236205*y**2
          -10883364800*y**3+8876885400*y**4-3293213400*y**5-163330874*y**6+461415600*y**7
          -30099375*y**8-29407700*y**9-13727355*y**10+6360912*y**11+315870*y**12)
          -r**4*(-1+y)**8*(-3933531-5808174*y-6812667*y**2+39314662*y**3+6403430*y**4
          +6096762*y**5-177048202*y**6+239034214*y**7-104819759*y**8-7802680*y**9
          +20668569*y**10-5358024*y**11-373272*y**12+228672*y**13)+r**8*(-1+y)**6*(
          -121011102+96963168*y+28358085*y**2+656250904*y**3-1330939155*y**4
          +752461704*y**5-214939726*y**6+360232820*y**7-233871628*y**8-76463020*y**9
          +118009973*y**10-37603192*y**11+3581945*y**12+229224*y**13)-r**6*(-1
          +y)**7*(-39815133-21558879*y-12601299*y**2+270675971*y**3-116647170*y**4
          -60863814*y**5-346081642*y**6+572364018*y**7-272023237*y**8-4867255*y**9
          +39115097*y**10-6911129*y**11-2158544*y**12+533016*y**13)+r**12*(-1
          +y)**4*(-2860360485+11291645046*y-14752654476*y**2+3228683430*y**3+9024612975*y**4
          -8566337460*y**5+2499770408*y**6+78575772*y**7-53884675*y**8+118582850*y**9
          -158313280*y**10+53381746*y**11-6032571*y**12+648720*y**13)-2*r**16*(
          -1+y)**2*(-1656470133+6558630876*y-8596321569*y**2+2739979431*y**3
          +2034702510*y**4-167366394*y**5-2110981492*y**6+1567403023*y**7-474137182*y**8
          +181757240*y**9-153023323*y**10+63876966*y**11-11651979*y**12+796026*y**13)
          +r**10*(-1+y)**5*(615981534-1649729538*y+967482261*y**2-223704147*y**3
          +2105856615*y**4-3313509273*y**5+1184304826*y**6+905343098*y**7-633386636*y**8
          -116391140*y**9+182162389*y**10-42206163*y**11-1712709*y**12+1448883*y**13)
          -r**14*(-1+y)**3*(-992991837+7158401817*y-17083228044*y**2+16489039704*y**3
          -4956013545*y**4-1266965691*y**5+183901016*y**6+1042739288*y**7-576953323*y**8
          -27607105*y**9+66068528*y**10+15681692*y**11-14556819*y**12+1880319*y**13)
          +r**20*(-65979255+997621722*y-4990670793*y**2+14242508666*y**3-23912831900*y**4
          +24055219110*y**5-15265636494*y**6+7071238926*y**7-3191510547*y**8+1576999300*y**9
          -697120705*y**10+224696472*y**11-46549458*y**12+5206956*y**13)+2*r**18*(435668877
          -2363697900*y+4546600758*y**2-1363915674*y**3-7712188851*y**4+13044196266*y**5
          -9820694060*y**6+3935836124*y**7-477452582*y**8-488466918*y**9+386738457*y**10
          -170145590*y**11+60730168*y**12-14921844*y**13+1712769*y**14))-12*logy*(
          -1+y)**2*(-1+r**2+y)**3*(4695*r**36*(-1+y)**9+3*r**34*(-1+y)**4*(16034
          -75475*y+136865*y**2-70550*y**3+30860*y**4-16759*y**5+5585*y**6)-r**32*(
          -1+y)**2*(-1610256+11616717*y-36094329*y**2+61125139*y**3-62634509*y**4
          +41087473*y**5-15563515*y**6+3410801*y**7-456367*y**8+21246*y**9)+6*(
          -1+y)**14*(57+456*y+2052*y**2+7378*y**3+18184*y**4+26136*y**5-14696*y**6
          -43882*y**7+33167*y**8+5536*y**9-19748*y**10+7760*y**11)+r**30*(101273598
          -868324779*y+3282536781*y**2-7183413898*y**3+10134851374*y**4-9765881502*y**5
          +6656496330*y**6-3261839044*y**7+1130230498*y**8-253991759*y**9+28644609*y**10
          +3494*y**11-48102*y**12)+2*r**2*(-1+y)**12*(4968+30321*y+107919*y**2
          +67322*y**3-161150*y**4-182916*y**5+3290768*y**6+518522*y**7-5366734*y**8
          +2546075*y**9+460873*y**10-596764*y**11+139484*y**12+9312*y**13)-3*r**28*(172756934
          -1564498137*y+6245750325*y**2-14302457908*y**3+20912837885*y**4-20802759769*y**5
          +14788033502*y**6-7834190188*y**7+3164841892*y**8-955047695*y**9+197772925*y**10
          -23332000*y**11+1009353*y**12+89281*y**13)+r**26*(-4366638834+33954540417*y
          -113813007975*y**2+212885708576*y**3-238752392054*y**4+156754915323*y**5
          -48279259229*y**6-3881973820*y**7+5114486358*y**8+2358622603*y**9-2711338189*y**10
          +842425212*y**11-112070830*y**12+12378841*y**13-1826799*y**14)+r**4*(
          -1+y)**11*(1108473+5292363*y+15234615*y**2+19787185*y**3-3177182*y**4
          -65875946*y**5-60730066*y**6+35167290*y**7+138142605*y**8-135396241*y**9
          +37732523*y**10+1815653*y**11-2161880*y**12+339360*y**13+37248*y**14)
          +r**24*(-3499233942+21465507051*y-49210041411*y**2+30338351806*y**3
          +71520859178*y**4-167663688123*y**5+158628136593*y**6-88291187308*y**7
          +44702362858*y**8-32584791151*y**9+22095819307*y**10-9629596494*y**11
          +2465850594*y**12-389802689*y**13+49304423*y**14-3226692*y**15)-r**14*(
          -1+y)**5*(12621118938-43708238943*y+39054498696*y**2+11953828012*y**3
          -5988395222*y**4-43690250537*y**5+21367133496*y**6+46890510318*y**7-46492290594*y**8
          +3599536479*y**9+8794181400*y**10-2327674128*y**11-399271714*y**12+212073257*y**13
          -17655832*y**14+64374*y**15)+r**12*(-1+y)**6*(15116274-1565355195*y
          +1026344979*y**2-5775514805*y**3+21451677326*y**4-27116121129*y**5+8215047635*y**6
          +9201785717*y**7-9549717010*y**8+4164426803*y**9-268727119*y**10-530338315*y**11
          +149021554*y**12-21018735*y**13+2861321*y**14+78699*y**15)+3*r**10*(
          -1+y)**7*(-706525118-1342331*y+173368984*y**2+4409323597*y**3-4123696010*y**4
          -558965753*y**5-4885026488*y**6+11797404467*y**7-7189476674*y**8-93616285*y**9
          +1689237160*y**10-537179581*y**11-21581526*y**12+28287377*y**13-2595880*y**14
          +152061*y**15)+r**6*(-1+y)**9*(8017134+20357379*y+36099792*y**2-159209546*y**3
          -52892410*y**4+61540053*y**5+1221289872*y**6-1913424604*y**7+223109482*y**8
          +1277457005*y**9-923657168*y**10+196858374*y**11+16579362*y**12-9433061*y**13
          +496880*y**14+171456*y**15)+r**8*(-1+y)**8*(-124291362-80130615*y-6720849*y**2
          +1106202430*y**3-175292258*y**4-16511129*y**5-5137309285*y**6+8044358288*y**7
          -4431554530*y**8+509952731*y**9+505004249*y**10-182986750*y**11-29366714*y**12
          +22986325*y**13-2856323*y**14+363792*y**15)+3*r**16*(-1+y)**4*(20721115846
          -84949253849*y+123971834053*y**2-52844245524*y**3-51056930710*y**4+75486623097*y**5
          -34939741067*y**6-9197929846*y**7+20681238318*y**8-10218030755*y**9+2051214403*y**10
          -55732684*y**11-17039982*y**12+2269331*y**13-6235885*y**14+965254*y**15)
          +3*r**18*(-1+y)**3*(15030248362-47859201075*y+36518660184*y**2+25648632255*y**3
          -47953319562*y**4+24554730379*y**5-10459830320*y**6+5974794457*y**7+1457726070*y**8
          -6157612781*y**9+3350816376*y**10+171757745*y**11-569513366*y**12+167803925*y**13
          -26408032*y**14+2595383*y**15)+r**20*(-1+y)**2*(-32670014544+162734323653*y
          -309527740017*y**2+263603095337*y**3-89812283500*y**4+8935788539*y**5
          -26629356841*y**6+53163544239*y**7-50131048104*y**8+27732979515*y**9
          -13676428651*y**10+7303784263*y**11-2575778172*y**12+477319717*y**13
          -54840315*y**14+7102881*y**15)+r**22*(9256224534-79668913167*y+297367903737*y**2
          -671167876742*y**3+986831206148*y**4-942927602541*y**5+579973697167*y**6
          -242406039744*y**7+89774460674*y**8-38050644361*y**9+14601355495*y**10
          -4480040478*y**11+880533032*y**12+124305093*y**13-137341487*y**14+28296612*y**15
          +476028*y**16))+(-1+r**2+y)**4*(2211*r**38*(-1+y)**11+3*r**36*(-1+y)**6*(26905
          -131577*y+254310*y**2-246380*y**3+128515*y**4-36275*y**5+5142*y**6)
          +r**34*(-1+y)**4*(-1275483+8670705*y-24975351*y**2+39844273*y**3-39046079*y**4
          +24793741*y**5-10352017*y**6+2734607*y**7-400126*y**8+27618*y**9)-r**32*(
          -1+y)**2*(-14442411+125714667*y-481800636*y**2+1080473634*y**3-1580194670*y**4
          +1584145544*y**5-1112434126*y**6+547377558*y**7-182604605*y**8+37773997*y**9
          -3493798*y**10-259608*y**11+67014*y**12)-2*r**30*(103962330-1107172788*y
          +5326378107*y**2-15335532863*y**3+29526275825*y**4-40235122235*y**5+40013154581*y**6
          -29432056053*y**7+15977170216*y**8-6261638214*y**9+1665959593*y**10-243796333*y**11
          -7293579*y**12+11876397*y**13-2426401*y**14+184617*y**15)+3*(-1+y)**13*(7607
          +44274*y+150855*y**2+370898*y**3+320997*y**4-630048*y**5-2478391*y**6
          +1240380*y**7+5426729*y**8-6942294*y**9+1420265*y**10+3274530*y**11
          -2801885*y**12+738148*y**13-28953*y**14-1424*y**15+312*y**16)-2*r**28*(
          -148292562+1859423292*y-10315154403*y**2+33916024483*y**3-73949306807*y**4
          +112954253831*y**5-124284511077*y**6+99588290128*y**7-57924173261*y**8
          +23947333406*y**9-6583455593*y**10+855633871*y**11+194948515*y**12-144782097*y**13
          +38797361*y**14-5034706*y**15+274419*y**16)+r**2*(-1+y)**12*(-66459
          -300243*y-849825*y**2+9402803*y**3+1327439*y**4-42257257*y**5-152689539*y**6
          +212759905*y**7+301735867*y**8-547144685*y**9+213974489*y**10+73833685*y**11
          -88206327*y**12+24239105*y**13-1009429*y**14-56073*y**15+10472*y**16
          +72*y**17)+r**4*(-1+y)**11*(-24559803-84703752*y-186106458*y**2+85574442*y**3
          +385784956*y**4+647967814*y**5-1130736936*y**6+153690268*y**7-345141148*y**8
          +1498999540*y**9-1449670666*y**10+609235682*y**11-161135592*y**12+29016206*y**13
          +181804*y**14+858680*y**15+42531*y**16+1632*y**17)+r**6*(-1+y)**10*(
          -71882787-227150217*y-432690126*y**2-651499450*y**3+1654140480*y**4
          +2818095692*y**5+6553524752*y**6-20165736684*y**7+5139538084*y**8+16860170996*y**9
          -15492194270*y**10+4408228222*y**11-71238932*y**12-116151744*y**13+7272764*y**14
          +5715080*y**15+117683*y**16+6057*y**17)-2*r**8*(-1+y)**9*(688651266
          +482037858*y+266319879*y**2-4496009666*y**3-1718775540*y**4-1603203530*y**5
          +17533200242*y**6-16398558587*y**7+9432583689*y**8-12110679837*y**9+10741774191*y**10
          -3749885148*y**11+427203818*y**12-35224008*y**13+9893192*y**14-6624887*y**15
          -317137*y**16+14205*y**17)+2*r**26*(2081578614-20609115300*y+91003040661*y**2
          -231949676365*y**3+373978016880*y**4-396474576694*y**5+283323150898*y**6
          -148871629444*y**7+79712265087*y**8-57399030447*y**9+39582187365*y**10
          -19866857721*y**11+6957387586*y**12-1758361752*y**13+331373812*y**14
          -41635990*y**15+2081593*y**16+70017*y**17)-2*r**10*(-1+y)**8*(10642078794
          -3934713720*y-4454133507*y**2-59424481549*y**3+68452336452*y**4-3331934314*y**5
          +63895314134*y**6-165378922600*y**7+113262072351*y**8-11788289287*y**9
          -14511967163*y**10+4342390767*y**11+653618550*y**12-417988892*y**13+18092920*y**14
          -1923882*y**15-1748371*y**16+151317*y**17)-6*r**18*(-1+y)**4*(-34948046405
          +167496882245*y-303623150758*y**2+222026930896*y**3+65997342795*y**4
          -275337659703*y**5+207034470119*y**6+10379809049*y**7-120366408684*y**8
          +87278294242*y**9-32702006908*y**10+7260958302*y**11-466608045*y**12
          -192836027*y**13+30760923*y**14+4041401*y**15-713581*y**16+260139*y**17)
          +2*r**20*(-1+y)**3*(14580942903-93722012118*y+248982535149*y**2-355386312308*y**3
          +137323088182*y**4+310316977984*y**5-419868682236*y**6+108665926655*y**7
          +138789108665*y**8-136294723423*y**9+50971595941*y**10-1456619854*y**11
          -7112735940*y**12+3299649298*y**13-769899254*y**14+106530627*y**15-11940962*y**16
          +482691*y**17)-2*r**12*(-1+y)**7*(26527942242-27900825018*y-10257630867*y**2
          -68153143610*y**3+117724939566*y**4+18427240942*y**5-10190216572*y**6
          -196073315367*y**7+206725022655*y**8-50727536921*y**9-22629604843*y**10
          +15042098496*y**11-2820879756*y**12+415362500*y**13-194486950*y**14+31889729*y**15
          -5799811*y**16+567585*y**17)+2*r**22*(-1+y)**2*(-8081119593+73017414063*y
          -278228386761*y**2+645213165693*y**3-980266260598*y**4+964900371944*y**5
          -569365662900*y**6+138460147994*y**7+55956618547*y**8-59491359823*y**9
          +20837162455*y**10-2194444967*y**11-1253471220*y**12+1077034870*y**13
          -474339994*y**14+113947504*y**15-16710336*y**16+1189122*y**17)-2*r**14*(
          -1+y)**6*(88061943642-241999601220*y+183233585223*y**2-39655971579*y**3
          +161373625102*y**4-222795870612*y**5+21240566228*y**6+62136262002*y**7
          +17039677197*y**8-49521256185*y**9+11802383127*y**10+13272019233*y**11
          -9356775864*y**12+2980618802*y**13-665913522*y**14+92082088*y**15-11305821*y**16
          +1192959*y**17)-2*r**16*(-1+y)**5*(-23020931703+220711831644*y-574133583246*y**2
          +442599346240*y**3+397863142505*y**4-904779388362*y**5+456177078587*y**6
          +189631244245*y**7-318796609554*y**8+130984215849*y**9-28190798700*y**10
          +17565069294*y**11-10423459219*y**12+3311919724*y**13-709782369*y**14
          +106428925*y**15-11895565*y**16+1458105*y**17)+2*r**24*(10217458482-92230275300*y
          +365282649507*y**2-835179453919*y**3+1209447258838*y**4-1122754824886*y**5
          +592913802360*y**6-15644575451*y**7-285750460784*y**8+303593419138*y**9
          -199281063280*y**10+98478572979*y**11-38366570730*y**12+11173033694*y**13
          -2049545476*y**14+124535559*y**15+34503186*y**16-9288326*y**17+824409*y**18))))/(15676416000*logy**5*r**20*(
          -1+y)**11-63000*(-1+y)*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(
          -1+y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5+6531840000*logy**4*r**16*(-1+y)**9*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+1088640000*logy**3*r**12*(-1+y)**7*(
          -(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)
          -2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+90720000*logy**2*r**8*(
          -1+y)**5*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +3780000*logy*(-1+y)**3*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*(217728000*logy**5*r**22*(5+10*r**2+9*r**4)*(
          -1+y)**10+518400*logy**4*r**16*(-1+y)**8*(565*r**14*(-1+y)**2+14*r**12*(367
          -734*y+367*y**2+15*y**3)+7*r**10*(2367-2034*y-1683*y**2+1570*y**3)
          +1750*r**4*(-1+y)**2*(-3-y**3+y**4)+70*r**8*(-60+420*y-510*y**2+170*y**3
          -26*y**4+29*y**5)+7*r**2*(-1+y)**2*(-79-810*y**3+745*y**4-256*y**5
          +40*y**6)+8*(-1+y)**3*(-107-107*y-107*y**2+33*y**3+208*y**4-170*y**5
          +40*y**6)+35*r**6*(-375+1050*y-825*y**2+64*y**3+197*y**4-136*y**5
          +49*y**6))-17280*logy**3*r**12*(-1+y)**6*(-1+r**2+y)**2*(1977*r**18*(-1
          +y)**4-2*r**16*(-1+y)**2*(9420-16863*y+5466*y**2+4057*y**3)-r**14*(
          -1+y)**2*(198972-363870*y+158793*y**2-17144*y**3+7149*y**4)+4*(-1
          +y)**6*(-261-1044*y-2610*y**2-1750*y**3+2285*y**4+8046*y**5-8106*y**6
          +2040*y**7)+2*r**12*(-305682+1062483*y-1335681*y**2+631880*y**3+6620*y**4
          -46173*y**5-18753*y**6+4606*y**7)+r**10*(-1427886+3941142*y-3384351*y**2
          +168940*y**3+1208755*y**4-632994*y**5+161443*y**6-31024*y**7-6825*y**8)
          +r**2*(-1+y)**4*(24309+46530*y+66663*y**2+13108*y**3-74285*y**4-9414*y**5
          +48345*y**6-19208*y**7+1952*y**8)+r**6*(-1+y)**2*(-129540+183234*y
          +113997*y**2-913176*y**3+869955*y**4-272550*y**5+58431*y**6-31052*y**7
          +3101*y**8)-2*r**4*(-1+y)**3*(68946+40851*y+36870*y**2-123997*y**3
          -81010*y**4+111049*y**5-8826*y**6-17915*y**7+4832*y**8)-2*r**8*(400266
          -1059429*y+739536*y**2+547806*y**3-1279544*y**4+881384*y**5-220696*y**6
          -24086*y**7+11494*y**8+3269*y**9))-288*logy**2*r**8*(-1+y)**5*(-1+r**2
          +y)**3*(1023*r**24*(-1+y)**5-r**22*(-1+y)**3*(-60319+123707*y-66457*y**2
          +34479*y**3)+r**20*(-107843+367381*y-403328*y**2+47050*y**3+263205*y**4
          -284647*y**5+116734*y**6+1448*y**7)+5*r**18*(1449693-6539886*y+11396247*y**2
          -9155242*y**3+2918837*y**4-74496*y**5+177063*y**6-197600*y**7+25384*y**8)
          -10*r**16*(-2466553+10571519*y-17469241*y**2+13696479*y**3-4874910*y**4
          +477948*y**5+112841*y**6-69259*y**7+9391*y**8+11785*y**9)-4*(-1+y)**7*(1383
          +6915*y+20745*y**2+32285*y**3+25525*y**4-22661*y**5-66765*y**6-6845*y**7
          +87840*y**8-52950*y**9+9528*y**10)-r**2*(-1+y)**6*(1679-9880*y-66190*y**2
          +89730*y**3+627350*y**4+1126732*y**5-2484670*y**6+968890*y**7+126895*y**8
          -112000*y**9+11464*y**10)-5*r**6*(-1+y)**4*(1105011+1492956*y+1684095*y**2
          -2037270*y**3-3139662*y**4+613374*y**5+3579274*y**6-3108090*y**7+1159315*y**8
          -229538*y**9+28535*y**10)-5*r**8*(-1+y)**3*(-2625323-259178*y-472637*y**2
          +7696452*y**3-799128*y**4-4824828*y**5+494948*y**6+1256612*y**7-69837*y**8
          -209682*y**9+59001*y**10)+2*r**10*(-1+y)**2*(18450143-25433160*y-5976615*y**2
          +59665120*y**3-68478045*y**4+31383864*y**5-7604365*y**6+1287240*y**7
          +1187030*y**8-905280*y**9+78068*y**10)+r**4*(-1+y)**5*(204643+790290*y
          +1806150*y**2+4024000*y**3+1798320*y**4+650304*y**5-13425190*y**6+12031800*y**7
          -2983675*y**8-202970*y**9+94328*y**10)-2*r**14*(-21950383+82921220*y
          -117721030*y**2+61663680*y**3+14778825*y**4-25538154*y**5+5028955*y**6
          -930620*y**7+2689170*y**8-1129650*y**9+159987*y**10)+2*r**12*(43873299
          -129877209*y+113918805*y**2+26010075*y**3-110884515*y**4+74812437*y**5
          -12740707*y**6-12165455*y**7+9287600*y**8-2029860*y**9-268786*y**10
          +64316*y**11))-12*logy*r**4*(-1+y)**4*(-1+r**2+y)**4*(217*r**30*(-1+y)**6
          +2*r**28*(-1+y)**4*(-4101+7768*y-3233*y**2+886*y**3)+r**26*(-1+y)**2*(520359
          -2000392*y+2824700*y**2-1914940*y**3+727115*y**4-128404*y**5+19562*y**6)
          +4*r**24*(401441-2184916*y+4978763*y**2-6671107*y**3+6247129*y**4-4053211*y**5
          +1401281*y**6-40213*y**7-104558*y**8+6991*y**9)+r**22*(-18952287+113362050*y
          -276501213*y**2+363933464*y**3-296764694*y**4+171780012*y**5-75668530*y**6
          +21400808*y**7-2602619*y**8+301714*y**9-75905*y**10)+8*(-1+y)**10*(13
          +104*y+468*y**2+1158*y**3+1528*y**4-698*y**5-7030*y**6-6918*y**7
          +7867*y**8+4122*y**9-4190*y**10+776*y**11)-2*r**20*(124544235-611030988*y
          +1176977193*y**2-1049788412*y**3+309865958*y**4+139205688*y**5-81791246*y**6
          -25456168*y**7+18269487*y**8-12508*y**9-771323*y**10+77684*y**11)-r**2*(
          -1+y)**8*(24027+143746*y+501655*y**2+1035160*y**3+1395190*y**4+553836*y**5
          -2359722*y**6-1444920*y**7+2815615*y**8-1012990*y**9-6813*y**10+31376*y**11
          +3840*y**12)+r**6*(-1+y)**6*(4602259+16123464*y+35326212*y**2+47453820*y**3
          +29850475*y**4-7757888*y**5-146395688*y**6+105406536*y**7+14651905*y**8
          -33036200*y**9+10531204*y**10-1165476*y**11+9377*y**12)-2*r**4*(-1+y)**7*(
          -296853-1399343*y-4009127*y**2-4870165*y**3-11130*y**4+11750546*y**5
          +1661906*y**6-2208186*y**7-11348785*y**8+9642205*y**9-2322443*y**10
          +22287*y**11+29088*y**12)+r**18*(-372110441+1772602242*y-3407234241*y**2
          +3411673560*y**3-1887540470*y**4+416109292*y**5+329492486*y**6-440140888*y**7
          +211670515*y**8-30227230*y**9-4069701*y**10-264528*y**11+39404*y**12)
          +4*r**8*(-1+y)**5*(-1377117-5706501*y-13487382*y**2-22708615*y**3+8967445*y**4
          +8965554*y**5+79828992*y**6-92173326*y**7+27103765*y**8+135355*y**9
          +670638*y**10-695091*y**11+60283*y**12)+r**10*(-1+y)**4*(184424349+131980530*y
          +72765603*y**2-566729240*y**3-208481460*y**4+319585132*y**5+688823230*y**6
          -943395176*y**7+424503165*y**8-73103790*y**9+3613519*y**10-1529360*y**11
          +135498*y**12)-2*r**12*(-1+y)**3*(66426757+1802611*y+55629865*y**2
          -442838515*y**3+221939100*y**4+139769486*y**5-32505262*y**6+65099450*y**7
          -160960035*y**8+84749375*y**9-11028443*y**10-328199*y**11+147810*y**12)
          -r**14*(-1+y)**2*(1415582733-2173379492*y+19236982*y**2+2503226580*y**3
          -3148276065*y**4+2118443864*y**5-520303756*y**6-283352344*y**7+175632795*y**8
          +10624140*y**9-12339722*y**10+1162948*y**11+253337*y**12)+8*r**16*(-56304396
          +202969450*y-257584482*y**2+20669663*y**3+270476730*y**4-184740013*y**5
          -120099900*y**6+177038334*y**7-36278096*y**8-27745680*y**9+12636334*y**10
          -673725*y**11-377102*y**12+12883*y**13))+r**2*(-1+y)**2*(-1+r**2+y)**5*(33*r**34*(
          -1+y)**8+r**32*(-1+y)**6*(-1497+2829*y-1167*y**2+325*y**3)+r**30*(
          -1+y)**4*(29118-111756*y+155037*y**2-104508*y**3+43592*y**4-9736*y**5
          +1229*y**6)+r**28*(-1+y)**2*(-388662+2289522*y-5535765*y**2+7264495*y**3
          -5849705*y**4+3089957*y**5-1069567*y**6+234865*y**7-27165*y**8+1625*y**9)
          -r**26*(6705390-49299672*y+156444939*y**2-281748970*y**3+318382031*y**4
          -234158108*y**5+110231882*y**6-29682144*y**7+2662120*y**8+574644*y**9
          -90037*y**10+650*y**11+2875*y**12)+r**24*(27853734-212915538*y+695174517*y**2
          -1248420207*y**3+1320118179*y**4-808824359*y**5+259162170*y**6-45448070*y**7
          +31990548*y**8-26146704*y**9+8415985*y**10-1012187*y**11+132483*y**12
          -13351*y**13)+r**22*(119834358-860601756*y+2651442549*y**2-4732388556*y**3
          +5762343100*y**4-5517066176*y**5+4435344847*y**6-2755491128*y**7+1111528822*y**8
          -222396380*y**9+4534083*y**10+2913924*y**11-253256*y**12+221624*y**13
          -10855*y**14)+(-1+y)**11*(171+1368*y+6156*y**2+18890*y**3+49693*y**4
          +85288*y**5-52480*y**6-141140*y**7+121133*y**8+23008*y**9-65684*y**10
          +21562*y**11-741*y**12-48*y**13+24*y**14)+r**2*(-1+y)**10*(8379+59046*y
          +237132*y**2+728948*y**3+1963095*y**4+3435322*y**5-1038632*y**6-4321224*y**7
          -312791*y**8+1048250*y**9+1465364*y**10-1210924*y**11+247557*y**12-2842*y**13
          +520*y**14)+r**4*(-1+y)**9*(-756390-4292304*y-14309151*y**2-25315392*y**3
          -18986732*y**4+24253090*y**5+32185573*y**6-361688*y**7-53446526*y**8
          +31259164*y**9-60285*y**10-3684504*y**11+839104*y**12-32542*y**13+4583*y**14)
          +r**6*(-1+y)**8*(2728050+10051692*y+23379807*y**2-17503380*y**3-105132180*y**4
          -214240720*y**5+122124181*y**6+16623416*y**7+146304610*y**8-162437940*y**9
          +55190825*y**10-7415268*y**11+1464832*y**12-185000*y**13+23075*y**14)
          +r**8*(-1+y)**7*(70781622+217847688*y+429524475*y**2+276777580*y**3
          -202746070*y**4-645663554*y**5-770313371*y**6+1146353280*y**7+140474010*y**8
          -548384980*y**9+223610157*y**10-35033692*y**11+5458870*y**12-649890*y**13
          +75875*y**14)+3*r**16*(-1+y)**3*(-977199580+2451404248*y-1460610047*y**2
          -4001733720*y**3+7987787520*y**4-4758368710*y**5+467828659*y**6-386817256*y**7
          +1122124340*y**8-660479900*y**9+165592335*y**10-23473712*y**11+5693848*y**12
          -836550*y**13+96525*y**14)+r**18*(-1+y)**2*(-510650316+2409209256*y
          -3286672755*y**2-3057156280*y**3+14282307640*y**4-17194395608*y**5+9134522153*y**6
          -1695564080*y**7+195020060*y**8-549575240*y**9+332770399*y**10-73328984*y**11
          +11245560*y**12-1252680*y**13+160875*y**14)+r**10*(-1+y)**6*(168669150
          +283479756*y+274391061*y**2-642791080*y**3-257261546*y**4-431894260*y**5
          +1871321141*y**6-1208302896*y**7+367040914*y**8-402566236*y**9+327195855*y**10
          -98312552*y**11+16983930*y**12-1544764*y**13+173927*y**14)+r**12*(-1
          +y)**5*(1797897090+761883936*y-65188215*y**2-5883097896*y**3+533851040*y**4
          +2847124210*y**5+5773940793*y**6-8417237640*y**7+3522163602*y**8-723166500*y**9
          +331329555*y**10-130921824*y**11+27487260*y**12-2585726*y**13+286715*y**14)
          +r**14*(-1+y)**4*(2838822618-1722510420*y-2397574809*y**2-946163356*y**3
          +2289411824*y**4+1859630744*y**5+1537241145*y**6-7639135992*y**7+6227315682*y**8
          -2111423268*y**9+442620393*y**10-95843820*y**11+25425556*y**12-3070496*y**13
          +342199*y**14)+r**20*(1521596178-9684806466*y+25616779269*y**2-34466969381*y**3
          +19854484076*y**4+7427884718*y**5-20945403561*y**6+15234005959*y**7-5467630366*y**8
          +1131377090*y**9-357981453*y**10+178129977*y**11-46685728*y**12+5396722*y**13
          -219791*y**14+42757*y**15)))*math.log(mu0**2/r**2))/(-435456000*logy**5*r**20*(-1
          +y)**10+1750*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**5
          -181440000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))-30240000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2-2520000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          -105000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*(18144000*logy**4*r**16*(111+147*r**2+95*r**4
          +27*r**6)*(-1+y)**10+86400*logy**3*r**12*(-1+y)**8*(247*r**14*(-1+y)**2
          -21*r**12*(-167+334*y-167*y**2+5*y**3)-7*r**10*(-5793+8346*y-933*y**2
          -1540*y**3+45*y**4)+35*r**8*(2025-1770*y-1395*y**2+907*y**3+83*y**4
          +55*y**5)-(-1+y)**3*(2889+2889*y+2889*y**2-1136*y**3-2046*y**4-30*y**5
          +40*y**6)-7*r**2*(-1+y)**2*(4741-2700*y**3+920*y**4-656*y**5+50*y**6)
          +35*r**6*(375+2778*y-4917*y**2+928*y**3+741*y**4-144*y**5+82*y**6)
          +7*r**4*(-14001+41322*y-33981*y**2+2375*y**3+5025*y**4-1404*y**5+568*y**6
          +96*y**7))+1440*logy**2*r**8*(-1+y)**6*(-1+r**2+y)**2*(-3096*r**18*(-1
          +y)**4+3*r**16*(-1+y)**2*(7144-12224*y+3016*y**2+2379*y**3)+r**14*(
          -1+y)**2*(122400-237012*y+119766*y**2-36086*y**3+18227*y**4)+r**12*(948048
          -3353484*y+4250346*y**2-2128030*y**3+182435*y**4+68002*y**5+49749*y**6
          -16366*y**7)+r**10*(7226796-22389672*y+22618116*y**2-5572830*y**3-3484065*y**4
          +1766824*y**5-260173*y**6+122724*y**7-20020*y**8)+r**2*(-1+y)**3*(176388
          +163260*y+150132*y**2-122206*y**3-211239*y**4-70763*y**5-75285*y**6
          +143393*y**7-22294*y**8+3014*y**9)+(-1+y)**4*(6564+13128*y+19692*y**2
          +40271*y**3+14665*y**4+7651*y**5-195013*y**6+173448*y**7-53406*y**8
          +6600*y**9)-r**4*(-1+y)**2*(-428160-180372*y+59946*y**2+464814*y**3
          -486843*y**4+848470*y**5-633668*y**6+285514*y**7-141229*y**8+9928*y**9)
          +r**8*(13819956-42483504*y+42527436*y**2-11091164*y**3-5220999*y**4
          +3216094*y**5-1163071*y**6+506489*y**7-109186*y**8+31549*y**9)+r**6*(6334128
          -17085204*y+13768146*y**2-4708774*y**3+7674191*y**4-9976120*y**5+5220229*y**6
          -1457746*y**7+224899*y**8-14616*y**9+20867*y**10))-24*logy*r**4*(-1
          +y)**4*(-1+r**2+y)**3*(2559*r**24*(-1+y)**6-r**22*(-1+y)**4*(-14312
          +36301*y-29666*y**2+26262*y**3)-r**20*(-1+y)**2*(-560634+1921629*y
          -2281290*y**2+786005*y**3+430020*y**4-337236*y**5+34606*y**6)+5*r**18*(
          -1+y)**2*(-1226280+4118553*y-4631040*y**2+1439051*y**3+626726*y**4
          -279184*y**5-78252*y**6+27206*y**7)+5*r**16*(-1+y)**2*(-1520035+6034813*y
          -9347652*y**2+8367069*y**3-5496215*y**4+2124610*y**5+84902*y**6-275278*y**7
          +23446*y**8)-2*r**14*(40059384-194760369*y+369713070*y**2-320851920*y**3
          +80510000*y**4+61908112*y**5-36319592*y**6-7554970*y**7+8104820*y**8
          -135425*y**9-847246*y**10+170636*y**11)+5*r**8*(-1+y)**2*(-17084115
          +28000722*y-5213550*y**2+9347994*y**3-32103311*y**4+32039554*y**5-32472300*y**6
          +26572874*y**7-10232769*y**8+977836*y**9+970286*y**10-528372*y**11+40151*y**12)
          +(-1+y)**6*(10959+32877*y+65754*y**2+128255*y**3+115740*y**4+79057*y**5
          -505444*y**6+277187*y**7-124355*y**8-333590*y**9+623634*y**10-311658*y**11
          +46584*y**12)-5*r**6*(-1+y)**3*(939240-2176953*y-63141*y**2+1402080*y**3
          -5769530*y**4+7855790*y**5-7802754*y**6+15673432*y**7-16017140*y**8
          +6203295*y**9-604165*y**10-115028*y**11+54874*y**12)+r**2*(-1+y)**5*(352488
          +672099*y+958833*y**2+1213915*y**3-126365*y**4-555821*y**5-8297673*y**6
          +9021479*y**7-3481065*y**8+716590*y**9+597308*y**10-517326*y**11+75538*y**12)
          -2*r**12*(275839962-1296014229*y+2346981462*y**2-1896274170*y**3+354652760*y**4
          +513597616*y**5-427907172*y**6+170302826*y**7-47559730*y**8+2749215*y**9
          +5049772*y**10-1613374*y**11+142562*y**12)-r**4*(-1+y)**4*(-3506234
          -3269327*y-2704334*y**2+8773000*y**3+326090*y**4+2702698*y**5-24120776*y**6
          +51699728*y**7-45054250*y**8+13866785*y**9+253786*y**10-699772*y**11
          +157606*y**12)+2*r**10*(-213303784+919119687*y-1479311142*y**2+1088193104*y**3
          -510904760*y**4+538235108*y**5-562343784*y**6+242898874*y**7+8024832*y**8
          -45955615*y**9+17304926*y**10-1134278*y**11-983232*y**12+160064*y**13))
          +(-1+y)**2*(-1+r**2+y)**4*(103*r**30*(-1+y)**8+r**28*(-1+y)**6*(-4937
          +9462*y-4113*y**2+1226*y**3)-r**26*(-1+y)**4*(169871-637404*y+880584*y**2
          -543084*y**3+137633*y**4-556*y**5+6036*y**6)-r**24*(-1+y)**2*(-443169
          +2365098*y-4879941*y**2+3818546*y**3+1399101*y**4-4374576*y**5+2408937*y**6
          -77014*y**7-253936*y**8+32554*y**9)-r**22*(-1+y)**2*(15564417-78452526*y
          +155179779*y**2-134778364*y**3+11433830*y**4+73631252*y**5-57100624*y**6
          +14703756*y**7+278909*y**8-478150*y**9+14921*y**10)+r**20*(-1+y)**2*(196879647
          -986800590*y+1933119333*y**2-1725005114*y**3+410546774*y**4+457246228*y**5
          -364586560*y**6+69327762*y**7+14039359*y**8-4568554*y**9-325305*y**10
          +87820*y**11)+r**18*(-1+y)**2*(-356082671+1725858930*y-3122900619*y**2
          +1949868544*y**3+1428000544*y**4-3192563744*y**5+2023754964*y**6-366834408*y**7
          -152883069*y**8+67268406*y**9-2027185*y**10-1369344*y**11+77652*y**12)
          +r**16*(2123296177-14049825396*y+38796778062*y**2-55275236966*y**3+35968342365*y**4
          +7327452964*y**5-32796770108*y**6+25774657636*y**7-8444724273*y**8-96072600*y**9
          +813884306*y**10-100801146*y**11-54978973*y**12+14111464*y**13+50460*y**14
          -107972*y**15)+(-1+y)**8*(3603+14412*y+36030*y**2+69046*y**3+84575*y**4
          +70308*y**5-175444*y**6-9400*y**7-90827*y**8-164280*y**9+289050*y**10
          -73518*y**11+17945*y**12+2856*y**13-29220*y**14+10864*y**15)+r**6*(
          -1+y)**5*(7678931+9185247*y+6799461*y**2-43766943*y**3+26441595*y**4
          -14567053*y**5+189849831*y**6-480430317*y**7+474162121*y**8-187258875*y**9
          -27090517*y**10+79968847*y**11-49441719*y**12+11863497*y**13-274295*y**14
          +16189*y**15)+r**2*(-1+y)**7*(133037+384699*y+740574*y**2+1066746*y**3
          +637585*y**4-57065*y**5-5484868*y**6+3253532*y**7-1414237*y**8-1467315*y**9
          +5751274*y**10-3742506*y**11+726719*y**12-58559*y**13-66820*y**14+45204*y**15)
          +r**4*(-1+y)**6*(1802029+3349338*y+4546449*y**2+1297038*y**3-2754815*y**4
          -5325182*y**5-23738341*y**6+25649092*y**7-4071881*y**8+12317830*y**9
          -28594793*y**10+29806278*y**11-15807141*y**12+3021118*y**13+17885*y**14
          +53096*y**15)+r**8*(-1+y)**4*(-41900517+51927576*y+7136196*y**2+78704074*y**3
          -76665325*y**4-35359320*y**5-180973412*y**6+734311018*y**7-1162562343*y**8
          +911146000*y**9-295868764*y**10+16154286*y**11-13213639*y**12+12675344*y**13
          -1696100*y**14+104926*y**15)+r**12*(-1+y)**2*(1166840829-3921656562*y
          +4325500803*y**2-1781847918*y**3+1208445045*y**4-2309888690*y**5+2656398759*y**6
          -2225405546*y**7+272547471*y**8+1744508170*y**9-1630181647*y**10+556791078*y**11
          -58051857*y**12-2196278*y**13-462315*y**14+226658*y**15)+r**10*(-1+y)**3*(
          -116271147+119236839*y+101944020*y**2+343006332*y**3-1374943395*y**4
          +1818270275*y**5-1954282368*y**6+3045602780*y**7-4229774409*y**8+3402160805*y**9
          -1303601684*y**10+106647804*y**11+48357975*y**12-1031023*y**13-2489760*y**14
          +302956*y**15)+r**14*(3710717677-22002063928*y+53162924388*y**2-66448785608*y**3
          +47012949176*y**4-26464082336*y**5+23764771488*y**6-18619892136*y**7
          +4250060006*y**8+3446739288*y**9-1556497444*y**10-827419352*y**11+744363248*y**12
          -186943648*y**13+11697536*y**14+1538728*y**15-77083*y**16)))*nlo.X1El(0,'SM',y/2,r))/(1741824000*logy**5*r**20*(
          -1+y)**10-7000*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1
          +y)**2*(-4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y
          -y**2+y**3))**5+725760000*logy**4*r**16*(-1+y)**8*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+120960000*logy**3*r**12*(-1+y)**6*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+10080000*logy**2*r**8*(
          -1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +420000*logy*(-1+y)**2*(-(r**9*(-1+y)**2)+6*r**5*y*(2-3*y+y**2)+2*r**3*(
          -1+y)**2*(-4+y**3)-2*r**7*(-4+8*y-4*y**2+y**3)+r*(-1+y)**3*(-1
          -y-y**2+y**3))**4))
      resNP += ((api*(-1512000*logy**3*r**12*(19+19*r**2+11*r**4
          +3*r**6)*(-1+y)**8-3600*logy**2*r**8*(-1+y)**6*(175*r**12*(-1+y)**2+255*r**14*(
          -1+y)**2-7*r**10*(-897+1254*y-87*y**2-340*y**3+90*y**4)+35*r**8*(405
          -414*y-189*y**2+204*y**3-38*y**4+8*y**5)-35*r**2*(-1+y)**2*(213-5*y**4
          -32*y**5+4*y**6)+35*r**6*(275+134*y-751*y**2+196*y**3+143*y**4-82*y**5
          +25*y**6)+35*r**4*(-669+2022*y-1695*y**2+52*y**3+495*y**4-282*y**5
          +77*y**6)+(-1+y)**3*(-361-361*y-361*y**2-4001*y**3+3804*y**4-900*y**5
          +80*y**6))-60*logy*r**4*(-1+y)**4*(-1+r**2+y)**2*(355*r**18*(-1+y)**4
          -r**16*(-1+y)**2*(-1153+3016*y-2573*y**2+1470*y**3)-r**14*(-1+y)**2*(
          -64706+101828*y-25903*y**2-10734*y**3+1755*y**4)+r**12*(-1+y)**2*(8214
          -66656*y+94159*y**2-16866*y**3-12551*y**4+5180*y**5)+r**10*(692212
          -2030424*y+1848647*y**2-169180*y**3-586485*y**4+241888*y**5+27709*y**6
          -25452*y**7+2485*y**8)+r**2*(-1+y)**3*(19399+17793*y+16187*y**2+142341*y**3
          -189095*y**4+52111*y**5-17483*y**6+7323*y**7+1544*y**8+280*y**9)-5*r**8*(
          -436732+1374912*y-1414175*y**2+301728*y**3+420651*y**4-337498*y**5
          +90783*y**6+5140*y**7-8743*y**8+1414*y**9)-(-1+y)**4*(-803-1606*y
          -2409*y**2-13492*y**3+4295*y**4-1662*y**5-7059*y**6+18944*y**7-10248*y**8
          +1440*y**9)+r**4*(-1+y)**2*(115834+6128*y-13123*y**2-627214*y**3+1390935*y**4
          -1107204*y**5+299327*y**6+34778*y**7-29781*y**8+5920*y**9)+r**6*(883662
          -2380808*y+1934387*y**2-460068*y**3+323372*y**4-509292*y**5+263858*y**6
          -41212*y**7-26282*y**8+12628*y**9-245*y**10))+(-1+y)**2*(-1+r**2
          +y)**3*(23*r**24*(-1+y)**6+r**22*(-1+y)**4*(-1636+3203*y-1498*y**2
          +611*y**3)-r**20*(-1+y)**2*(53282-196667*y+264360*y**2-147190*y**3
          +20590*y**4+6593*y**5+32*y**6)-5*r**18*(-1+y)**2*(-10084+25495*y-2964*y**2
          -59086*y**3+67984*y**4-18137*y**5-3136*y**6+768*y**7)-5*r**16*(-1+y)**2*(981683
          -3134849*y+3304164*y**2-878638*y**3-577695*y**4+335767*y**5-23846*y**6
          -7224*y**7+78*y**8)+2*r**14*(-1+y)**2*(5042852-15034913*y+12846762*y**2
          +344847*y**3-4593008*y**4+1133298*y**5+522238*y**6-184337*y**7-20172*y**8
          +5433*y**9)+r**4*(-1+y)**4*(239598+215739*y+172968*y**2+711145*y**3
          -1068910*y**4-13636*y**5-698198*y**6+2381464*y**7-2629420*y**8+1381385*y**9
          -259362*y**10-13441*y**11+668*y**12)+5*r**6*(-1+y)**3*(61652+93801*y
          -18903*y**2-1950935*y**3+5284025*y**4-5051584*y**5+1856368*y**6+72856*y**7
          -504180*y**8+374135*y**9-110233*y**10+4191*y**11+807*y**12)-(-1+y)**6*(
          -863-2589*y-5178*y**2-18310*y**3-7640*y**4-6544*y**5-7722*y**6+26426*y**7
          -4265*y**8+1565*y**9-668*y**10-3764*y**11+1552*y**12)-5*r**8*(-1+y)**2*(1495819
          -2607070*y+733134*y**2-3703654*y**3+14693541*y**4-21082902*y**5+14135366*y**6
          -3338562*y**7-900021*y**8+514084*y**9-5492*y**10-19896*y**11+1653*y**12)
          +2*r**12*(-24565894+116636943*y-212534784*y**2+167628370*y**3-16908815*y**4
          -61310837*y**5+33962579*y**6+2466173*y**7-7236645*y**8+1921290*y**9
          +4081*y**10-50547*y**11+2086*y**12)-r**2*(-1+y)**5*(-24876-47163*y
          -66861*y**2-298290*y**3+176270*y**4-4768*y**5-46084*y**6+399422*y**7
          -301510*y**8+50555*y**9-6031*y**10-2428*y**11+3764*y**12)-2*r**10*(13546628
          -58709229*y+95512344*y**2-62747978*y**3-12826120*y**4+65626674*y**5
          -74365612*y**6+48658242*y**7-16017164*y**8+210745*y**9+1369948*y**10
          -237784*y**11-27336*y**12+6642*y**13)))*nlo.X1El(0,'T2',y/2,r))/(580608000*logy**4*r**16*(
          -1+y)**8+193536000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+24192000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+1344000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +28000*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(-43200*logy**3*r**12*(69+62*r**2+21*r**4)*(-1+y)**8-720*logy**2*r**8*(
          -1+y)**6*(-19*r**12*(-1+y)**2+r**10*(598-1196*y+598*y**2-30*y**3)
          +5*r**8*(1385-2014*y+251*y**2+294*y**3+24*y**4)+(-1+y)**3*(-547
          -547*y-547*y**2+803*y**3+8*y**4+20*y**5)+10*r**6*(768-420*y-906*y**2
          +334*y**3+106*y**4+37*y**5)+2*r**2*(-1+y)**2*(-2603+1325*y**3-15*y**4
          +78*y**5)+5*r**4*(-2105+6694*y-5831*y**2+608*y**3+587*y**4-28*y**5
          +75*y**6))+60*logy*r**4*(-1+y)**4*(-1+r**2+y)**2*(85*r**16*(-1+y)**4
          -10*r**14*(-1+y)**2*(52-87*y+18*y**2+23*y**3)-r**12*(-1+y)**2*(-832
          +338*y+1337*y**2-1740*y**3+633*y**4)+r**10*(-22520+75846*y-86866*y**2
          +31372*y**3+7828*y**4-5486*y**5-706*y**6+452*y**7)+2*r**2*(-1+y)**3*(
          -2476-2225*y-1974*y**2+4291*y**3+802*y**4+763*y**5+592*y**6-1329*y**7
          +116*y**8)+(-1+y)**4*(-251-502*y-753*y**2-288*y**3-21*y**4+270*y**5
          +2441*y**6-1928*y**7+312*y**8)+r**8*(-180346+572094*y-600935*y**2
          +187440*y**3+46515*y**4-30654*y**5+10371*y**6-6080*y**7+875*y**8)-r**4*(
          -1+y)**2*(9056+3726*y-2085*y**2+15180*y**3-35075*y**4+7414*y**5+7289*y**6
          -2240*y**7+1055*y**8)-2*r**6*(60748-166485*y+136862*y**2-42220*y**3
          +52270*y**4-58698*y**5+17490*y**6+368*y**7-770*y**8+435*y**9))+(-1
          +y)**2*(-1+r**2+y)**3*(5*r**22*(-1+y)**6-r**20*(-1+y)**4*(-325+665*y
          -355*y**2+249*y**3)-5*r**18*(-1+y)**2*(-1921+6862*y-8754*y**2+3988*y**3
          +551*y**4-834*y**5+76*y**6)+5*r**16*(-1+y)**2*(-19903+68431*y-79962*y**2
          +27112*y**3+11417*y**4-7419*y**5+60*y**6+216*y**7)+10*r**14*(-1+y)**2*(36599
          -117140*y+117591*y**2-3488*y**3-68260*y**4+41904*y**5-5793*y**6-1452*y**7
          +159*y**8)-10*r**8*(-1+y)**2*(92281-157201*y+31779*y**2+39421*y**3
          -115243*y**4+190311*y**5-50717*y**6-43039*y**7-1926*y**8+14958*y**9
          -2502*y**10+78*y**11)+5*r**6*(-1+y)**3*(-17297+30723*y+855*y**2+82843*y**3
          -131580*y**4+27948*y**5+46788*y**6-111988*y**7+112349*y**8-35583*y**9
          -459*y**10+201*y**11)-10*r**12*(231065-1170729*y+2325762*y**2-2118118*y**3
          +496677*y**4+698205*y**5-659037*y**6+215455*y**7-14450*y**8-5160*y**9
          -33*y**10+243*y**11)-5*r**4*(-1+y)**4*(-9841-9019*y-6985*y**2+21595*y**3
          +4624*y**4+3532*y**5-27104*y**6+55144*y**7-47951*y**8+11135*y**9+953*y**10
          +317*y**11)-5*r**2*(-1+y)**5*(-1327-2507*y-3540*y**2+94*y**3+1604*y**4
          +3108*y**5+10654*y**6-11086*y**7+1995*y**8-505*y**9-362*y**10+432*y**11)
          -(-1+y)**6*(-245-735*y-1470*y**2-1396*y**3-792*y**4+402*y**5+4486*y**6
          -760*y**7+341*y**8-363*y**9-1312*y**10+644*y**11)-2*r**10*(1869325
          -8193240*y+13460310*y**2-10374114*y**3+5643726*y**4-5982624*y**5+5456766*y**6
          -1801944*y**7-329361*y**8+259424*y**9+8724*y**10-19326*y**11+2334*y**12)))*nlo.X1El(1,'SM',y/2,r))/(1036800*logy**4*r**16*(
          -1+y)**8+345600*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+43200*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+2400*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +50*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4)
          )
      resNP += ((api*(3600*logy**2*r**8*(15+10*r**2+3*r**4)*(-1+y)**6+120*logy*r**4*(
          -1+y)**4*(-10*r**10*(-1+y)**2+11*r**12*(-1+y)**2-5*r**8*(-67+98*y
          -13*y**2-20*y**3+6*y**4)+10*r**6*(72-84*y-18*y**2+22*y**3-2*y**4
          +y**5)-5*(-1+y)**3*(5+5*y+5*y**2+17*y**3-16*y**4+2*y**5)+2*r**2*(
          -1+y)**2*(-163-10*y**3+35*y**4+3*y**5)+5*r**4*(-151+482*y-421*y**2
          +40*y**3+73*y**4-32*y**5+9*y**6))+(-1+y)**2*(-1+r**2+y)**2*(7*r**16*(
          -1+y)**4-2*r**14*(-1+y)**2*(-12+31*y-26*y**2+27*y**3)-r**12*(-1
          +y)**2*(-3356+5454*y-1521*y**2-536*y**3+79*y**4)+2*r**10*(-1+y)**2*(
          -4416+6165*y+15*y**2-1175*y**3+85*y**4+76*y**5)+5*r**8*(13422-43158*y
          +45699*y**2-12588*y**3-7715*y**4+4958*y**5-247*y**6-284*y**7+33*y**8)
          +2*r**2*(-1+y)**3*(648+581*y+514*y**2+1447*y**3-2300*y**4+277*y**5
          -56*y**6+11*y**7+78*y**8)-r**4*(-1+y)**2*(-4436-542*y+757*y**2+11016*y**3
          -25545*y**4+20466*y**5-4753*y**6-652*y**7+89*y**8)+(-1+y)**4*(67
          +134*y+201*y**2+428*y**3-55*y**4-22*y**5-89*y**6-156*y**7+92*y**8)
          -2*r**6*(-17964+49281*y-40854*y**2+5986*y**3+8446*y**4-11636*y**5
          +9694*y**6-3046*y**7+14*y**8+79*y**9)))*nlo.X1El(1,'T2',y/2,r))/(345600*logy**3*r**12*(
          -1+y)**6-200*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +86400*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+7200*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(2160*logy**2*r**8*(11+5*r**2)*(
          -1+y)**6-72*logy*r**4*(-1+y)**4*(9*r**10*(-1+y)**2+5*r**8*(-13+26*y
          -13*y**2+y**3)-5*r**2*(-1+y)**2*(-67+38*y**3+2*y**4)+(-1+y)**3*(39
          +39*y+39*y**2-76*y**3+4*y**4)-5*r**6*(120-180*y+30*y**2+14*y**3
          +7*y**4)-15*r**4*(-24+92*y-90*y**2+12*y**3+7*y**4+3*y**5))-3*(-1
          +y)**2*(-1+r**2+y)**2*(7*r**14*(-1+y)**4-r**12*(-1+y)**2*(57-100*y
          +29*y**2+24*y**3)-r**10*(-1+y)**2*(-759+1202*y-256*y**2-258*y**3
          +81*y**4)+r**8*(-4969+17330*y-20755*y**2+8250*y**3+1835*y**4-2156*y**5
          +425*y**6)-r**4*(-1+y)**2*(711+196*y-203*y**2+1620*y**3-3475*y**4
          +1004*y**5+339*y**6+48*y**7)-(-1+y)**4*(23+46*y+69*y**2-10*y**3
          -25*y**4-48*y**5-71*y**6+56*y**7)-r**2*(-1+y)**3*(393+347*y+301*y**2
          -865*y**3-55*y**4-73*y**5-27*y**6+139*y**7)+r**6*(-6919+19324*y-16320*y**2
          +5940*y**3-8130*y**4+8604*y**5-2244*y**6-340*y**7+85*y**8)))*nlo.X1El(2,'SM',y/2,r))/(8640*logy**3*r**12*(
          -1+y)**6-5*(r**8*(-1+y)**2-6*r**4*y*(2-3*y+y**2)-2*r**2*(-1+y)**2*(
          -4+y**3)+2*r**6*(-4+8*y-4*y**2+y**3)-(-1+y)**3*(-1-y-y**2+y**3))**3
          +2160*logy**2*r**8*(-1+y)**4*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)
          +2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(
          -1-y-y**2+y**3))+180*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-180*logy*r**4*(3+r**2)*(-1
          +y)**4-3*(-1+y)**2*(-15*r**8*(-1+y)**2+3*r**10*(-1+y)**2+15*r**2*(
          -1+y)**2*(-5+y**4)-10*r**6*(-20+34*y-11*y**2-2*y**3+y**4)+30*r**4*(
          -4+14*y-13*y**2+2*y**3+y**4)+(-1+y)**3*(-7-7*y-7*y**2-7*y**3
          +8*y**4)))*nlo.X1El(2,'T2',y/2,r))/(2880*logy**2*r**8*(-1+y)**4+480*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))
          +20*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4
          +y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2)
          )
      resNP += ((api*(-144*logy*r**4*(-1+y)**4-4*(-1+y)**2*(-3*r**8*(-1+y)**2-2*r**6*(
          -12+24*y-12*y**2+y**3)+6*r**4*y*(6-9*y+y**2+2*y**3)+6*r**2*(-1
          +y)**2*(-4+3*y**3)+(-1+y)**3*(-3-3*y-3*y**2+7*y**3)))*nlo.X1El(3,'SM',y/2,r))/(144*logy**2*r**8*(
          -1+y)**4+24*logy*r**4*(-1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))+(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y
          +y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(
          -1+y)**3*(-1-y-y**2+y**3))**2))
      resNP += ((api*(-1+y)**2*nlo.X1El(3,'T2',y/2,r))/(12*logy*r**4*(
          -1+y)**2-r**8*(-1+y)**2+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3)))
      res += resNP*wc.T2

    if wc.SRT != 0:
      resNP = 0
      resNP +=((rhoLS*(-9072000*logy**4*r**13*(3+7*r**2+9*r**4+9*r**6)*(-1+y)**8+151200*logy**3*r**9*(
          -1+y)**6*(-795*r**12*(-1+y)**2+57*r**14*(-1+y)**2+r**10*(-1847+1534*y
          +1393*y**2-1440*y**3+180*y**4)+r**4*(-1+y)**2*(983-720*y-360*y**2
          +640*y**3-315*y**4+12*y**5)-5*r**8*(-89+610*y-737*y**2+242*y**3-12*y**4
          +18*y**5)+(-1+y)**3*(-7-7*y-7*y**2+143*y**3-112*y**4+20*y**5)+5*r**2*(
          -1+y)**2*(31-80*y**3+127*y**4-72*y**5+12*y**6)-5*r**6*(-199+734*y
          -703*y**2-64*y**3+479*y**4-310*y**5+75*y**6))-360*logy**2*r**5*(-1+y)**4*(
          -1+r**2+y)**2*(707*r**18*(-1+y)**4+r**16*(-1+y)**2*(-26747+52080*y
          -23919*y**2+10856*y**3)-r**14*(-1+y)**2*(-114814+249368*y-120505*y**2
          +36282*y**3+7419*y**4)-r**12*(-1+y)**2*(-902650+1124788*y-38297*y**2
          -321852*y**3-29857*y**4+11138*y**5)-7*(-1+y)**5*(-103-309*y-618*y**2
          +70*y**3+125*y**4+483*y**5-256*y**6+8*y**7)-7*r**2*(-1+y)**4*(-535
          -864*y-987*y**2+4096*y**3-1245*y**4-1000*y**5+1239*y**6-528*y**7
          +24*y**8)-r**6*(-1+y)**2*(-225442+122080*y+26341*y**2+507746*y**3
          -1031175*y**4+676672*y**5-143195*y**6-7926*y**7+1399*y**8)+r**4*(-1
          +y)**3*(-42406-39634*y-39109*y**2+438859*y**3-468620*y**4+104646*y**5
          +92159*y**6-61931*y**7+12536*y**8)+r**10*(1901116-5472152*y+4913671*y**2
          +333360*y**3-3441405*y**4+2296844*y**5-546473*y**6+4944*y**7+12895*y**8)
          +r**8*(1070188-3254272*y+3165183*y**2+486618*y**3-3560187*y**4+2936912*y**5
          -818553*y**6-107108*y**7+88857*y**8-7638*y**9))-30*logy*r*(-1+y)**4*(
          -1+r**2+y)**3*(-385*r**24*(-1+y)**4-r**22*(-1+y)**2*(-11984+22813*y
          -9674*y**2+1769*y**3)-3*r**20*(49658-192689*y+272118*y**2-185538*y**3
          +73582*y**4-13525*y**5+1274*y**6)+r**18*(188944-968611*y+1688904*y**2
          -1111486*y**3+177064*y**4+69885*y**5+17280*y**6+3540*y**7)+r**16*(2684913
          -8763783*y+9476460*y**2-4030442*y**3+661425*y**4-187903*y**5+134158*y**6
          -108640*y**7+16212*y**8)+7*(-1+y)**6*(-7-35*y-105*y**2-211*y**3
          -157*y**4+167*y**5+245*y**6+115*y**7-304*y**8+92*y**9)+2*r**14*(5642336
          -14776979*y+10842888*y**2+4024498*y**3-8686868*y**4+2919544*y**5+18794*y**6
          +136992*y**7-55958*y**8+1953*y**9)+r**12*(16469628-38521014*y+22936116*y**2
          +23829180*y**3-46007072*y**4+26575064*y**5-3435486*y**6-2106756*y**7
          +567920*y**8+70742*y**9-14322*y**10)+7*r**2*(-1+y)**5*(176+725*y+1865*y**2
          +805*y**3+345*y**4-1377*y**5-725*y**6-125*y**7+1615*y**8-1180*y**9
          +276*y**10)-r**6*(-1+y)**3*(295792+426419*y+472101*y**2-1908660*y**3
          +1212676*y**4+440090*y**5-929334*y**6+354084*y**7+18020*y**8-26141*y**9
          +553*y**10)+r**8*(-1+y)**2*(711361+415828*y+412321*y**2-8401930*y**3
          +11411100*y**4-3948786*y**5-1978198*y**6+2004134*y**7-595165*y**8+60130*y**9
          +1605*y**10)+r**4*(-1+y)**4*(-29582-75285*y-132594*y**2+77100*y**3
          +26552*y**4+88626*y**5-105370*y**6+27804*y**7+4770*y**8-5877*y**9+2056*y**10)
          -2*r**10*(-1200864+2986893*y-1935612*y**2-1479914*y**3+481416*y**4
          +4976606*y**5-6155424*y**6+2949182*y**7-802496*y**8+236969*y**9-59612*y**10
          +2856*y**11))-r*(-1+y)**2*(-1+r**2+y)**4*(245*r**26*(-1+y)**6+r**24*(
          -1+y)**4*(-8085+15190*y-6125*y**2+1191*y**3)+r**22*(-1+y)**2*(108500
          -414190*y+568435*y**2-363222*y**3+128781*y**4-21686*y**5+1142*y**6)
          +r**20*(-638120+3774050*y-9099545*y**2+11790836*y**3-9213266*y**4+4551450*y**5
          -1338585*y**6+186300*y**7+6164*y**8-3684*y**9)-5*r**18*(142079-458192*y
          +209720*y**2+782318*y**3-1225773*y**4+713540*y**5-111688*y**6-104790*y**7
          +83972*y**8-19572*y**9+1826*y**10)-5*r**16*(-1865675+9886352*y-20608742*y**2
          +20347857*y**3-7936399*y**4-1262200*y**5+1033320*y**6+1098087*y**7-889232*y**8
          +197874*y**9-22680*y**10+438*y**11)+(-1+y)**7*(7315+35105*y+101640*y**2
          +171219*y**3+100094*y**4-169841*y**5-173106*y**6-50441*y**7+232731*y**8
          -92544*y**9+4726*y**10+926*y**11+176*y**12)-5*r**8*(-1+y)**3*(-3153731
          -168175*y+1912813*y**2-9431434*y**3+27330451*y**4-20281416*y**5-2225656*y**6
          +7350006*y**7-2833561*y**8+603059*y**9-155073*y**10+6696*y**11+221*y**12)
          -5*r**6*(-1+y)**4*(-2370116-2513490*y-2071727*y**2+12907466*y**3-8615854*y**4
          -1323012*y**5+4327396*y**6-2439780*y**7+206224*y**8+240974*y**9-44297*y**10
          -9326*y**11+342*y**12)+r**4*(-1+y)**5*(757960+1501990*y+2096255*y**2
          -618381*y**3-3574521*y**4-5323381*y**5+7137339*y**6-1089211*y**7-543419*y**8
          +278271*y**9-154254*y**10+34696*y**11+656*y**12)+r**2*(-1+y)**6*(-31185
          -115570*y-279335*y**2+501418*y**3-128337*y**4-564692*y**5+64683*y**6
          +201418*y**7-142318*y**8+204962*y**9-99348*y**10+9512*y**11+792*y**12)
          +2*r**14*(16454060-73838170*y+125451025*y**2-102247826*y**3+45293284*y**4
          -17916816*y**5+6926069*y**6+2513364*y**7-3467374*y**8+806566*y**9+20556*y**10
          -33774*y**11+7536*y**12)+r**10*(-1+y)**2*(82882135-120198680*y+2204720*y**2
          +148665128*y**3-157701247*y**4+24112008*y**5+73294888*y**6-62917212*y**7
          +23889547*y**8-5260528*y**9+1354032*y**10-191508*y**11+9717*y**12)+2*r**12*(67429880
          -276239250*y+408670325*y**2-120664248*y**3-385265970*y**4+528041810*y**5
          -271370965*y**6+46849105*y**7-350194*y**8+5394020*y**9-3190390*y**10
          +814065*y**11-128730*y**12+10542*y**13))))/(217728000*logy**4*r**16*(-1
          +y)**8+72576000*logy**3*r**12*(-1+y)**6*(-(r**8*(-1+y)**2)+6*r**4*y*(2
          -3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)
          +(-1+y)**3*(-1-y-y**2+y**3))+9072000*logy**2*r**8*(-1+y)**4*(-(r**8*(
          -1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(-4+y**3)-2*r**6*(
          -4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**2+504000*logy*r**4*(
          -1+y)**2*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**3
          +10500*(-(r**8*(-1+y)**2)+6*r**4*y*(2-3*y+y**2)+2*r**2*(-1+y)**2*(
          -4+y**3)-2*r**6*(-4+8*y-4*y**2+y**3)+(-1+y)**3*(-1-y-y**2+y**3))**4))
      res += resNP*wc.SRT

    return res*par.mbkin**3


