from kolya import parameters
from kolya import NLOpartonic as nlo
from kolya import NNLOpartonic as nnlo
from kolya import NLOpw as nlopw
import math

def moment_1_KIN_MS(q2cut, par, hqe, wc, **kwargs):
    """ Central moment of the q2 spectrum. SM Part. Moment n. 1 """
    Q2=q2cut/par.mbkin**2
    r=par.mcMS/par.mbkin
    mus=par.scale_alphas/par.mbkin
    mu0=par.scale_mcMS/par.mbkin
    mumuG=par.scale_muG/par.mbkin
    murhoD=par.scale_rhoD/par.mbkin
    murhoLS=par.scale_rhoLS/par.mbkin
    muWC=par.scale_mbkin/par.mbkin
    api=par.alphas/math.pi

    rhoD=hqe.rhoD/par.mbkin**3
    rhoLS=hqe.rhoLS/par.mbkin**3
    muG=hqe.muG/par.mbkin**2

    pi2=math.pi**2
    z3=1.202056903159594
    flagPERP=kwargs.get('flag_basisPERP', 1)
    flagDEBUG=kwargs.get('flag_DEBUG', 0)
    FLAGcf=1
    FLAGcD=1
    FLAGcs=1

    sqrtq2=math.sqrt(1-2*Q2+Q2**2-2*r**2-2*Q2*r**2+r**4)
    logq2 =math.log((1-Q2+r**2-sqrtq2)/(1-Q2+r**2+sqrtq2))

    res = 0
    res +=((flagPERP*rhoLS*(720*logq2**2*r**6*(-1+3*r**2)+2*(Q2-(-1+r)**2)*(Q2
        -(1+r)**2)*(6+r**2+4*Q2**5*r**2+69*r**4-316*r**6+1454*r**8-477*r**10
        -17*r**12+3*Q2**4*(-3+13*r**2+4*r**4)-Q2**3*(-21+85*r**2+541*r**4
        +43*r**6)+Q2**2*(-9+8*r**2+650*r**4+578*r**6+17*r**8)+Q2*(-9+33*r**2
        +416*r**4-628*r**6+401*r**8+27*r**10))-12*logq2*r**2*(-5+26*r**2-24*Q2**4*r**2
        +16*r**4-294*r**6-19*r**8+36*r**10+Q2**3*(-5+81*r**2+66*r**4)-Q2**2*(
        -5+34*r**2+151*r**4+24*r**6)+Q2*(5-39*r**2-11*r**4+59*r**6-54*r**8))*sqrtq2))/(2160*logq2**2*r**8
        +15*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
        -Q2**2*(1+r**2)-Q2*(1+r**4))**2-360*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))
    res += ((muG*(-720*logq2**2*r**6*(
        -1+3*r**2)-2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(6+r**2+4*Q2**5*r**2
        +69*r**4-316*r**6+1454*r**8-477*r**10-17*r**12+3*Q2**4*(-3+13*r**2
        +4*r**4)-Q2**3*(-21+85*r**2+541*r**4+43*r**6)+Q2**2*(-9+8*r**2+650*r**4
        +578*r**6+17*r**8)+Q2*(-9+33*r**2+416*r**4-628*r**6+401*r**8+27*r**10))
        +12*logq2*r**2*(-5+26*r**2-24*Q2**4*r**2+16*r**4-294*r**6-19*r**8+36*r**10
        +Q2**3*(-5+81*r**2+66*r**4)-Q2**2*(-5+34*r**2+151*r**4+24*r**6)+Q2*(5
        -39*r**2-11*r**4+59*r**6-54*r**8))*sqrtq2))/(2160*logq2**2*r**8+15*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2-360*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6
        -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(-180*logq2*r**4*(1+r**2)+(8*Q2**4
        -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
        +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)/(-120*logq2*r**4
        +10*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)
        +(flagPERP*rhoD*(-48*logq2*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-5
        +26*r**2-24*Q2**4*r**2+16*r**4-294*r**6-19*r**8+36*r**10+Q2**3*(-5
        +81*r**2+66*r**4)-Q2**2*(-5+34*r**2+151*r**4+24*r**6)+Q2*(5-39*r**2
        -11*r**4+59*r**6-54*r**8))+2880*logq2**2*r**6*(-1+3*r**2)*sqrtq2+8*(4*Q2**7*r**2
        +Q2**6*(-9+31*r**2+4*r**4)-3*Q2**5*(-13+47*r**2+217*r**4+21*r**6)
        +Q2**4*(-60+193*r**2+1827*r**4+1761*r**6+115*r**8)-2*Q2**3*(-15+46*r**2
        +625*r**4+1065*r**6+622*r**8+25*r**10)-(-1+r**2)**2*(-6-r**2-69*r**4
        +316*r**6-1454*r**8+477*r**10+17*r**12)-3*Q2**2*(-5+7*r**2+68*r**4
        +202*r**6-473*r**8+263*r**10+18*r**12)+Q2*(-21+37*r**2+201*r**4-933*r**6
        -203*r**8-3357*r**10+1335*r**12+61*r**14))*sqrtq2))/(-1440*logq2*r**4*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))+8640*logq2**2*r**8*sqrtq2+60*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))**2*sqrtq2))
    res += ((rhoD*(-12*logq2*(24*Q2**6*(1+5*r**4)-Q2**5*(99+64*r**2
        +315*r**4+570*r**6)+Q2**4*(135+117*r**2+285*r**4+835*r**6+900*r**8)
        -2*Q2**3*(15+49*r**2+64*r**4+315*r**6+275*r**8+150*r**10)-(-1+r**2)**2*(21
        -89*r**2+506*r**4+2986*r**6-99*r**8-145*r**10+180*r**12)-2*Q2**2*(45
        -116*r**2+232*r**4+544*r**6-265*r**8-180*r**10+300*r**12)+Q2*(81
        -318*r**2+1207*r**4+6102*r**6+6587*r**8-14*r**10-835*r**12+630*r**14))
        +720*logq2**2*r**4*(3+10*r**2+15*r**4)*sqrtq2-2*(6*Q2**8+4*Q2**7*(3+r**2)
        +2*Q2**6*(15+62*r**2+29*r**4)-3*Q2**5*(213+125*r**2+943*r**4+151*r**6)
        +Q2**4*(1455+256*r**2+2430*r**4+7200*r**6+835*r**8)-2*Q2**3*(393-302*r**2
        +1597*r**4+627*r**6+2110*r**8+223*r**10)-6*Q2**2*(142-373*r**2+436*r**4
        -746*r**6-790*r**8+727*r**10+44*r**12)-(-1+r**2)**2*(351-2656*r**2
        +9501*r**4+5656*r**6-4919*r**8+2040*r**10+107*r**12)+Q2*(1125-6209*r**2
        +15555*r**4+24657*r**6+13387*r**8-14463*r**10+5901*r**12+367*r**14))*sqrtq2))/(
        -1080*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+6480*logq2**2*r**8*sqrtq2
        +45*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
        -Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2))

    if( flagDEBUG == 1):
        print("Q2moment n. 1 LO = ",res*par.mbkin**2)
    resNLO = 0
    resNLO +=((muWC*(-138240*logq2**2*r**10+64*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(
        -Q2**6-2*Q2**5*(1+r**2)+Q2**4*(15-46*r**2-21*r**4)+4*Q2**3*(-5+32*r**2
        +173*r**4+16*r**6)-Q2**2*(-5+68*r**2+426*r**4+692*r**6+31*r**8)-6*Q2*(
        -1+9*r**2+38*r**4-34*r**6+103*r**8+5*r**10)+3*(-1+14*r**2-219*r**4
        -84*r**6-659*r**8+222*r**10+7*r**12))-1536*logq2*r**6*(8*Q2**4-22*Q2**3*(1
        +r**2)+8*Q2**2*(1+4*r**2+r**4)+3*Q2*(1+4*r**2-r**4+6*r**6)+3*(1
        +21*r**2+41*r**4+r**6-4*r**8))*sqrtq2))/(-25920*logq2**2*r**10-180*r**2*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2+4320*logq2*r**6*(1+Q2**3-7*r**2-7*r**4+r**6
        -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(muWC**2*(-17280*logq2**2*r**10
        +8*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-Q2**6-2*Q2**5*(1+r**2)+Q2**4*(15
        -46*r**2-21*r**4)+4*Q2**3*(-5+32*r**2+173*r**4+16*r**6)-Q2**2*(-5
        +68*r**2+426*r**4+692*r**6+31*r**8)-6*Q2*(-1+9*r**2+38*r**4-34*r**6
        +103*r**8+5*r**10)+3*(-1+14*r**2-219*r**4-84*r**6-659*r**8+222*r**10
        +7*r**12))-192*logq2*r**6*(8*Q2**4-22*Q2**3*(1+r**2)+8*Q2**2*(1+4*r**2
        +r**4)+3*Q2*(1+4*r**2-r**4+6*r**6)+3*(1+21*r**2+41*r**4+r**6-4*r**8))*sqrtq2))/(
        -8640*logq2**2*r**10-60*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
        -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+1440*logq2*r**6*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(
        -34560*logq2**2*r**12-16*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(Q2**6
        +2*Q2**5*(1+r**2)+Q2**4*(21+46*r**2-15*r**4)+4*Q2**3*(-16-173*r**2
        -32*r**4+5*r**6)+Q2**2*(31+692*r**2+426*r**4+68*r**6-5*r**8)-6*Q2*(
        -5-103*r**2+34*r**4-38*r**6-9*r**8+r**10)+3*(-7-222*r**2+659*r**4
        +84*r**6+219*r**8-14*r**10+r**12))-384*logq2*r**6*(8*Q2**4-22*Q2**3*(1
        +r**2)+8*Q2**2*(1+4*r**2+r**4)+3*Q2*(6-r**2+4*r**4+r**6)+3*(-4
        +r**2+41*r**4+21*r**6+r**8))*sqrtq2)/(-8640*logq2**2*r**10-60*r**2*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2+1440*logq2*r**6*(1+Q2**3-7*r**2-7*r**4+r**6
        -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(flagPERP*muWC**3*(96*logq2*(-Q2
        +(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-5+26*r**2-24*Q2**4*r**2+16*r**4
        -294*r**6-19*r**8+36*r**10+Q2**3*(-5+81*r**2+66*r**4)-Q2**2*(-5+34*r**2
        +151*r**4+24*r**6)+Q2*(5-39*r**2-11*r**4+59*r**6-54*r**8))-5760*logq2**2*r**6*(
        -1+3*r**2)*sqrtq2+16*(-4*Q2**7*r**2+Q2**6*(9-31*r**2-4*r**4)+3*Q2**5*(
        -13+47*r**2+217*r**4+21*r**6)-Q2**4*(-60+193*r**2+1827*r**4+1761*r**6
        +115*r**8)+2*Q2**3*(-15+46*r**2+625*r**4+1065*r**6+622*r**8+25*r**10)
        +(-1+r**2)**2*(-6-r**2-69*r**4+316*r**6-1454*r**8+477*r**10+17*r**12)
        +3*Q2**2*(-5+7*r**2+68*r**4+202*r**6-473*r**8+263*r**10+18*r**12)
        +Q2*(21-37*r**2-201*r**4+933*r**6+203*r**8+3357*r**10-1335*r**12
        -61*r**14))*sqrtq2))/(-3240*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+19440*logq2**2*r**8*sqrtq2
        +135*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
        -Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(muWC**3*(96*logq2*(24*Q2**6*(1
        +5*r**4)-Q2**5*(99+64*r**2+315*r**4+570*r**6)+Q2**4*(135+117*r**2
        +285*r**4+835*r**6+900*r**8)-2*Q2**3*(15+49*r**2+64*r**4+315*r**6
        +275*r**8+150*r**10)-(-1+r**2)**2*(21-89*r**2+506*r**4+2986*r**6-99*r**8
        -145*r**10+180*r**12)-2*Q2**2*(45-116*r**2+232*r**4+544*r**6-265*r**8
        -180*r**10+300*r**12)+Q2*(81-318*r**2+1207*r**4+6102*r**6+6587*r**8
        -14*r**10-835*r**12+630*r**14))-5760*logq2**2*r**4*(3+10*r**2+15*r**4)*sqrtq2
        +16*(6*Q2**8+4*Q2**7*(3+r**2)+2*Q2**6*(15+62*r**2+29*r**4)-3*Q2**5*(213
        +125*r**2+943*r**4+151*r**6)+Q2**4*(1455+256*r**2+2430*r**4+7200*r**6
        +835*r**8)-2*Q2**3*(393-302*r**2+1597*r**4+627*r**6+2110*r**8+223*r**10)
        -6*Q2**2*(142-373*r**2+436*r**4-746*r**6-790*r**8+727*r**10+44*r**12)
        -(-1+r**2)**2*(351-2656*r**2+9501*r**4+5656*r**6-4919*r**8+2040*r**10
        +107*r**12)+Q2*(1125-6209*r**2+15555*r**4+24657*r**6+13387*r**8-14463*r**10
        +5901*r**12+367*r**14))*sqrtq2))/(-9720*logq2*r**4*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))+58320*logq2**2*r**8*sqrtq2+405*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)
        +((-17280*logq2**2*r**12-8*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(Q2**6
        +2*Q2**5*(1+r**2)+Q2**4*(21+46*r**2-15*r**4)+4*Q2**3*(-16-173*r**2
        -32*r**4+5*r**6)+Q2**2*(31+692*r**2+426*r**4+68*r**6-5*r**8)-6*Q2*(
        -5-103*r**2+34*r**4-38*r**6-9*r**8+r**10)+3*(-7-222*r**2+659*r**4
        +84*r**6+219*r**8-14*r**10+r**12))-192*logq2*r**6*(8*Q2**4-22*Q2**3*(1
        +r**2)+8*Q2**2*(1+4*r**2+r**4)+3*Q2*(6-r**2+4*r**4+r**6)+3*(-4
        +r**2+41*r**4+21*r**6+r**8))*sqrtq2)*math.log(mu0))/(-2880*logq2**2*r**10-20*r**2*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2+480*logq2*r**6*(1+Q2**3-7*r**2-7*r**4+r**6
        -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((17280*logq2**2*r**12+8*(-Q2
        +(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(Q2**6+2*Q2**5*(1+r**2)+Q2**4*(21
        +46*r**2-15*r**4)+4*Q2**3*(-16-173*r**2-32*r**4+5*r**6)+Q2**2*(31
        +692*r**2+426*r**4+68*r**6-5*r**8)-6*Q2*(-5-103*r**2+34*r**4-38*r**6
        -9*r**8+r**10)+3*(-7-222*r**2+659*r**4+84*r**6+219*r**8-14*r**10
        +r**12))+192*logq2*r**6*(8*Q2**4-22*Q2**3*(1+r**2)+8*Q2**2*(1+4*r**2
        +r**4)+3*Q2*(6-r**2+4*r**4+r**6)+3*(-4+r**2+41*r**4+21*r**6+r**8))*sqrtq2)*math.log(r))/(
        -2880*logq2**2*r**10-20*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
        -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+480*logq2*r**6*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((180*logq2*r**4*(1
        +r**2)+(-3-8*Q2**4+42*r**2+282*r**4+42*r**6-3*r**8+7*Q2**3*(1+r**2)
        +Q2**2*(7-2*r**2+7*r**4)-3*Q2*(1-11*r**2-11*r**4+r**6))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(1440*logq2**2*r**8
        +10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
        -Q2**2*(1+r**2)-Q2*(1+r**4))**2-240*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+nlo.X1Q2(1,'SM',Q2,r)/(-12*logq2*r**4
        +(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))

    if( flagDEBUG == 1):
        print("Q2moment n. 1 NLO = api*",resNLO*par.mbkin**2)
    res += api*resNLO

    if(kwargs.get('flag_includeNLOpw', 1) == 1):
        resNLO = 0
        resNLO +=(muG*((muWC**2*(138240*logq2**3*(-Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)-192*logq2*(
            -Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(-24*Q2**9*r**2+3*Q2**8*(-5+54*r**2
            +46*r**4)-2*Q2**7*(-25+150*r**2+386*r**4+135*r**6)+2*Q2**6*(-20+208*r**2
            +111*r**4+472*r**6+51*r**8)+6*Q2**5*(-5-136*r**2+319*r**4+953*r**6
            +146*r**8+59*r**10)-2*Q2**4*(-25-492*r**2+1283*r**4+6086*r**6+7161*r**8
            +1430*r**10+243*r**12)+6*Q2**2*r**2*(10+33*r**2-212*r**4+237*r**6-1318*r**8
            +1223*r**10+112*r**12+35*r**14)+2*Q2**3*(-5-236*r**2+636*r**4+2831*r**6
            +6871*r**8+3954*r**10+874*r**12+51*r**14)+(-1+r**2)**2*(5+36*r**2
            -29*r**4+2106*r**6-4733*r**8-2968*r**10+3001*r**12+386*r**14+36*r**16)
            -2*Q2*(5+18*r**2+155*r**4+125*r**6-3039*r**8-103*r**10-6511*r**12
            +4407*r**14+542*r**16+81*r**18))-4608*logq2**2*r**8*(-36*Q2**6*r**2+Q2**5*(10
            +111*r**2+171*r**4)-Q2**4*(25+135*r**2+328*r**4+270*r**6)+r**2*(-1
            +r**2)**2*(19-96*r**2-36*r**4-31*r**6+54*r**8)+Q2**3*(15+45*r**2+192*r**4
            +277*r**6+90*r**8)+Q2**2*(5-5*r**2-73*r**4+16*r**6-153*r**8+180*r**10)
            +Q2*(-5+r**2+197*r**4+197*r**6-73*r**8+232*r**10-189*r**12))*sqrtq2
            +32*r**2*(Q2**11*(-18+47*r**2)-3*Q2**10*(-45+71*r**2+296*r**4)+Q2**9*(
            -435+370*r**2+4573*r**4+4528*r**6)-Q2**8*(-780+747*r**2+8501*r**4
            +16589*r**6+9567*r**8)+2*Q2**7*(-420+1233*r**2+4982*r**4+2078*r**6
            +9086*r**8+2919*r**10)+2*Q2**6*(273-2475*r**2-7612*r**4+18472*r**6
            +37897*r**8+4361*r**10+5712*r**12)-r**2*(-1+r**2)**4*(115+121*r**2-345*r**4
            +14821*r**6-38699*r**8+18831*r**10-95*r**12+931*r**14)-2*Q2**5*(105
            -2544*r**2-10697*r**4+31444*r**6+70825*r**8+87784*r**10+14443*r**12
            +11928*r**14)+2*Q2**4*(30-1305*r**2-8119*r**4+30329*r**6+36899*r**8
            +48071*r**10+59585*r**12+6641*r**14+6861*r**16)+Q2**3*(-30+807*r**2
            +5236*r**4-27460*r**6+5680*r**8-10034*r**10-41636*r**12+63716*r**14
            -1346*r**16+5067*r**18)+Q2*(-1+r**2)**2*(-3+432*r**2-44*r**4+5112*r**6
            +12162*r**8-7016*r**10-140436*r**12+92040*r**14-2111*r**16+5304*r**18)
            +Q2**2*(15-581*r**2+256*r**4-5120*r**6-7654*r**8+64642*r**10-76640*r**12
            +249728*r**14-156041*r**16+11203*r**18-10688*r**20))*sqrtq2))/(311040*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+6480*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-180*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-77760*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC*(1105920*logq2**3*(-Q2+(-1+r)**2)*r**12*(-Q2
            +(1+r)**2)-1536*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(-24*Q2**9*r**2
            +3*Q2**8*(-5+54*r**2+46*r**4)-2*Q2**7*(-25+150*r**2+386*r**4+135*r**6)
            +2*Q2**6*(-20+208*r**2+111*r**4+472*r**6+51*r**8)+6*Q2**5*(-5-136*r**2
            +319*r**4+953*r**6+146*r**8+59*r**10)-2*Q2**4*(-25-492*r**2+1283*r**4
            +6086*r**6+7161*r**8+1430*r**10+243*r**12)+6*Q2**2*r**2*(10+33*r**2
            -212*r**4+237*r**6-1318*r**8+1223*r**10+112*r**12+35*r**14)+2*Q2**3*(
            -5-236*r**2+636*r**4+2831*r**6+6871*r**8+3954*r**10+874*r**12+51*r**14)
            +(-1+r**2)**2*(5+36*r**2-29*r**4+2106*r**6-4733*r**8-2968*r**10+3001*r**12
            +386*r**14+36*r**16)-2*Q2*(5+18*r**2+155*r**4+125*r**6-3039*r**8
            -103*r**10-6511*r**12+4407*r**14+542*r**16+81*r**18))-36864*logq2**2*r**8*(
            -36*Q2**6*r**2+Q2**5*(10+111*r**2+171*r**4)-Q2**4*(25+135*r**2+328*r**4
            +270*r**6)+r**2*(-1+r**2)**2*(19-96*r**2-36*r**4-31*r**6+54*r**8)+Q2**3*(15
            +45*r**2+192*r**4+277*r**6+90*r**8)+Q2**2*(5-5*r**2-73*r**4+16*r**6
            -153*r**8+180*r**10)+Q2*(-5+r**2+197*r**4+197*r**6-73*r**8+232*r**10
            -189*r**12))*sqrtq2+256*r**2*(Q2**11*(-18+47*r**2)-3*Q2**10*(-45+71*r**2
            +296*r**4)+Q2**9*(-435+370*r**2+4573*r**4+4528*r**6)-Q2**8*(-780+747*r**2
            +8501*r**4+16589*r**6+9567*r**8)+2*Q2**7*(-420+1233*r**2+4982*r**4
            +2078*r**6+9086*r**8+2919*r**10)+2*Q2**6*(273-2475*r**2-7612*r**4+18472*r**6
            +37897*r**8+4361*r**10+5712*r**12)-r**2*(-1+r**2)**4*(115+121*r**2-345*r**4
            +14821*r**6-38699*r**8+18831*r**10-95*r**12+931*r**14)-2*Q2**5*(105
            -2544*r**2-10697*r**4+31444*r**6+70825*r**8+87784*r**10+14443*r**12
            +11928*r**14)+2*Q2**4*(30-1305*r**2-8119*r**4+30329*r**6+36899*r**8
            +48071*r**10+59585*r**12+6641*r**14+6861*r**16)+Q2**3*(-30+807*r**2
            +5236*r**4-27460*r**6+5680*r**8-10034*r**10-41636*r**12+63716*r**14
            -1346*r**16+5067*r**18)+Q2*(-1+r**2)**2*(-3+432*r**2-44*r**4+5112*r**6
            +12162*r**8-7016*r**10-140436*r**12+92040*r**14-2111*r**16+5304*r**18)
            +Q2**2*(15-581*r**2+256*r**4-5120*r**6-7654*r**8+64642*r**10-76640*r**12
            +249728*r**14-156041*r**16+11203*r**18-10688*r**20))*sqrtq2))/(933120*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+19440*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-540*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-233280*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(-276480*logq2**3*(-Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)
            +384*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(48*Q2**9*r**2+Q2**8*(5
            -306*r**2-270*r**4)+2*Q2**7*(-10+325*r**2+657*r**4+270*r**6)-2*Q2**6*(
            -10+218*r**2+747*r**4+758*r**6+201*r**8)-2*Q2**5*(-10+123*r**2+513*r**4
            +1079*r**6-3*r**8+18*r**10)+2*Q2**4*(-25+196*r**2+1389*r**4+3506*r**6
            +2077*r**8+210*r**10+81*r**12)-2*Q2**3*(-10+17*r**2+771*r**4+1348*r**6
            +2084*r**8+597*r**10-133*r**12+30*r**14)+(-1+r**2)**2*(5+36*r**2-29*r**4
            +2106*r**6-4733*r**8-2968*r**10+3001*r**12+386*r**14+36*r**16)+2*Q2**2*(10
            -30*r**2+117*r**4-116*r**6-1839*r**8-534*r**10+2539*r**12+168*r**14
            +45*r**16)-2*Q2*(10+17*r**2-51*r**4+1495*r**6-4687*r**8-1203*r**10
            -4025*r**12+3653*r**14+417*r**16+54*r**18))+9216*logq2**2*r**10*(24*Q2**6
            -3*Q2**5*(33+23*r**2)+Q2**4*(130+167*r**2+45*r**4)-Q2**3*(55+78*r**2
            +53*r**4+15*r**6)+(-1+r**2)**2*(19-96*r**2-36*r**4-31*r**6+54*r**8)
            +Q2**2*(15-98*r**2-49*r**4-3*r**6+105*r**8)+Q2*(-34+242*r**2+177*r**4
            -8*r**6+127*r**8-144*r**10))*sqrtq2+64*r**4*(4*Q2**12+Q2**11*(19+12*r**2)
            -Q2**10*(262+1447*r**2+205*r**4)+Q2**9*(848+8503*r**2+7822*r**4+735*r**6)
            -Q2**8*(1257+18491*r**2+29603*r**4+16573*r**6+1260*r**8)+2*Q2**7*(555
            +7280*r**2+15150*r**4+16578*r**6+7621*r**8+546*r**10)-2*Q2**6*(630
            -3491*r**2-7137*r**4-9300*r**6+3214*r**8+1493*r**10+147*r**12)-2*Q2**5*(
            -936+10597*r**2+19708*r**4+33991*r**6+26068*r**8+2377*r**10+1892*r**12
            +135*r**14)+(-1+r**2)**4*(115+121*r**2-345*r**4+14821*r**6-38699*r**8
            +18831*r**10-95*r**12+931*r**14)+2*Q2**4*(-699+7271*r**2+9159*r**4
            +11213*r**6+8885*r**8+20879*r**10-849*r**12+1189*r**14+120*r**16)+Q2*(
            -1+r**2)**2*(-584+283*r**2-1624*r**4-36772*r**6+59512*r**8+94238*r**10
            -75304*r**12-1052*r**14-4144*r**16+7*r**18)-Q2**3*(193+2564*r**2+5532*r**4
            -10980*r**6-45574*r**8-34012*r**10+75748*r**12+2612*r**14+3877*r**16
            +40*r**18)+Q2**2*(986-2015*r**2+6955*r**4+15432*r**6-47852*r**8-19874*r**10
            -136854*r**12+107416*r**14+274*r**16+6433*r**18-21*r**20))*sqrtq2)/(311040*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+6480*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-180*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-77760*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+((-138240*logq2**3*(-Q2+(-1+r)**2)*r**12*(-Q2+(1
            +r)**2)+192*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(48*Q2**9*r**2
            +Q2**8*(5-306*r**2-270*r**4)+2*Q2**7*(-10+325*r**2+657*r**4+270*r**6)
            -2*Q2**6*(-10+218*r**2+747*r**4+758*r**6+201*r**8)-2*Q2**5*(-10+123*r**2
            +513*r**4+1079*r**6-3*r**8+18*r**10)+2*Q2**4*(-25+196*r**2+1389*r**4
            +3506*r**6+2077*r**8+210*r**10+81*r**12)-2*Q2**3*(-10+17*r**2+771*r**4
            +1348*r**6+2084*r**8+597*r**10-133*r**12+30*r**14)+(-1+r**2)**2*(5
            +36*r**2-29*r**4+2106*r**6-4733*r**8-2968*r**10+3001*r**12+386*r**14
            +36*r**16)+2*Q2**2*(10-30*r**2+117*r**4-116*r**6-1839*r**8-534*r**10
            +2539*r**12+168*r**14+45*r**16)-2*Q2*(10+17*r**2-51*r**4+1495*r**6
            -4687*r**8-1203*r**10-4025*r**12+3653*r**14+417*r**16+54*r**18))+4608*logq2**2*r**10*(24*Q2**6
            -3*Q2**5*(33+23*r**2)+Q2**4*(130+167*r**2+45*r**4)-Q2**3*(55+78*r**2
            +53*r**4+15*r**6)+(-1+r**2)**2*(19-96*r**2-36*r**4-31*r**6+54*r**8)
            +Q2**2*(15-98*r**2-49*r**4-3*r**6+105*r**8)+Q2*(-34+242*r**2+177*r**4
            -8*r**6+127*r**8-144*r**10))*sqrtq2+32*r**4*(4*Q2**12+Q2**11*(19+12*r**2)
            -Q2**10*(262+1447*r**2+205*r**4)+Q2**9*(848+8503*r**2+7822*r**4+735*r**6)
            -Q2**8*(1257+18491*r**2+29603*r**4+16573*r**6+1260*r**8)+2*Q2**7*(555
            +7280*r**2+15150*r**4+16578*r**6+7621*r**8+546*r**10)-2*Q2**6*(630
            -3491*r**2-7137*r**4-9300*r**6+3214*r**8+1493*r**10+147*r**12)-2*Q2**5*(
            -936+10597*r**2+19708*r**4+33991*r**6+26068*r**8+2377*r**10+1892*r**12
            +135*r**14)+(-1+r**2)**4*(115+121*r**2-345*r**4+14821*r**6-38699*r**8
            +18831*r**10-95*r**12+931*r**14)+2*Q2**4*(-699+7271*r**2+9159*r**4
            +11213*r**6+8885*r**8+20879*r**10-849*r**12+1189*r**14+120*r**16)+Q2*(
            -1+r**2)**2*(-584+283*r**2-1624*r**4-36772*r**6+59512*r**8+94238*r**10
            -75304*r**12-1052*r**14-4144*r**16+7*r**18)-Q2**3*(193+2564*r**2+5532*r**4
            -10980*r**6-45574*r**8-34012*r**10+75748*r**12+2612*r**14+3877*r**16
            +40*r**18)+Q2**2*(986-2015*r**2+6955*r**4+15432*r**6-47852*r**8-19874*r**10
            -136854*r**12+107416*r**14+274*r**16+6433*r**18-21*r**20))*sqrtq2)*math.log(mu0))/(103680*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+2160*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-60*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-25920*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+FLAGcf*((-4680*logq2**2*r**6*(-1+3*r**2)-13*(Q2-(
            -1+r)**2)*(Q2-(1+r)**2)*(6+r**2+4*Q2**5*r**2+69*r**4-316*r**6+1454*r**8
            -477*r**10-17*r**12+3*Q2**4*(-3+13*r**2+4*r**4)-Q2**3*(-21+85*r**2
            +541*r**4+43*r**6)+Q2**2*(-9+8*r**2+650*r**4+578*r**6+17*r**8)+Q2*(
            -9+33*r**2+416*r**4-628*r**6+401*r**8+27*r**10))+78*logq2*r**2*(-5
            +26*r**2-24*Q2**4*r**2+16*r**4-294*r**6-19*r**8+36*r**10+Q2**3*(-5
            +81*r**2+66*r**4)-Q2**2*(-5+34*r**2+151*r**4+24*r**6)+Q2*(5-39*r**2
            -11*r**4+59*r**6-54*r**8))*sqrtq2)/(6480*logq2**2*r**8+45*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2-1080*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2)+((-360*logq2**2*r**6*(-1+3*r**2)-(Q2-(
            -1+r)**2)*(Q2-(1+r)**2)*(6+r**2+4*Q2**5*r**2+69*r**4-316*r**6+1454*r**8
            -477*r**10-17*r**12+3*Q2**4*(-3+13*r**2+4*r**4)-Q2**3*(-21+85*r**2
            +541*r**4+43*r**6)+Q2**2*(-9+8*r**2+650*r**4+578*r**6+17*r**8)+Q2*(
            -9+33*r**2+416*r**4-628*r**6+401*r**8+27*r**10))+6*logq2*r**2*(-5
            +26*r**2-24*Q2**4*r**2+16*r**4-294*r**6-19*r**8+36*r**10+Q2**3*(-5
            +81*r**2+66*r**4)-Q2**2*(-5+34*r**2+151*r**4+24*r**6)+Q2*(5-39*r**2
            -11*r**4+59*r**6-54*r**8))*sqrtq2)*math.log(mumuG))/(720*logq2**2*r**8+5*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+((138240*logq2**3*(-Q2+(-1
            +r)**2)*r**12*(-Q2+(1+r)**2)-192*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1
            +r)**2)*(48*Q2**9*r**2+Q2**8*(5-306*r**2-270*r**4)+2*Q2**7*(-10+325*r**2
            +657*r**4+270*r**6)-2*Q2**6*(-10+218*r**2+747*r**4+758*r**6+201*r**8)
            -2*Q2**5*(-10+123*r**2+513*r**4+1079*r**6-3*r**8+18*r**10)+2*Q2**4*(
            -25+196*r**2+1389*r**4+3506*r**6+2077*r**8+210*r**10+81*r**12)-2*Q2**3*(
            -10+17*r**2+771*r**4+1348*r**6+2084*r**8+597*r**10-133*r**12+30*r**14)
            +(-1+r**2)**2*(5+36*r**2-29*r**4+2106*r**6-4733*r**8-2968*r**10+3001*r**12
            +386*r**14+36*r**16)+2*Q2**2*(10-30*r**2+117*r**4-116*r**6-1839*r**8
            -534*r**10+2539*r**12+168*r**14+45*r**16)-2*Q2*(10+17*r**2-51*r**4
            +1495*r**6-4687*r**8-1203*r**10-4025*r**12+3653*r**14+417*r**16+54*r**18))
            -4608*logq2**2*r**10*(24*Q2**6-3*Q2**5*(33+23*r**2)+Q2**4*(130+167*r**2
            +45*r**4)-Q2**3*(55+78*r**2+53*r**4+15*r**6)+(-1+r**2)**2*(19-96*r**2
            -36*r**4-31*r**6+54*r**8)+Q2**2*(15-98*r**2-49*r**4-3*r**6+105*r**8)
            +Q2*(-34+242*r**2+177*r**4-8*r**6+127*r**8-144*r**10))*sqrtq2-32*r**4*(4*Q2**12
            +Q2**11*(19+12*r**2)-Q2**10*(262+1447*r**2+205*r**4)+Q2**9*(848+8503*r**2
            +7822*r**4+735*r**6)-Q2**8*(1257+18491*r**2+29603*r**4+16573*r**6+1260*r**8)
            +2*Q2**7*(555+7280*r**2+15150*r**4+16578*r**6+7621*r**8+546*r**10)
            -2*Q2**6*(630-3491*r**2-7137*r**4-9300*r**6+3214*r**8+1493*r**10+147*r**12)
            -2*Q2**5*(-936+10597*r**2+19708*r**4+33991*r**6+26068*r**8+2377*r**10
            +1892*r**12+135*r**14)+(-1+r**2)**4*(115+121*r**2-345*r**4+14821*r**6
            -38699*r**8+18831*r**10-95*r**12+931*r**14)+2*Q2**4*(-699+7271*r**2
            +9159*r**4+11213*r**6+8885*r**8+20879*r**10-849*r**12+1189*r**14+120*r**16)
            +Q2*(-1+r**2)**2*(-584+283*r**2-1624*r**4-36772*r**6+59512*r**8+94238*r**10
            -75304*r**12-1052*r**14-4144*r**16+7*r**18)-Q2**3*(193+2564*r**2+5532*r**4
            -10980*r**6-45574*r**8-34012*r**10+75748*r**12+2612*r**14+3877*r**16
            +40*r**18)+Q2**2*(986-2015*r**2+6955*r**4+15432*r**6-47852*r**8-19874*r**10
            -136854*r**12+107416*r**14+274*r**16+6433*r**18-21*r**20))*sqrtq2)*math.log(r))/(103680*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+2160*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-60*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-25920*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+((720*logq2**2*r**6*(-4+21*r**2+9*r**4)+(Q2-(-1
            +r)**2)*(Q2-(1+r)**2)*(21+120*Q2**7+431*r**2+2289*r**4-3941*r**6
            +26419*r**8-5607*r**10-937*r**12+45*r**14-225*Q2**6*(1+r**2)-8*Q2**5*(15
            -58*r**2+15*r**4)-4*Q2**3*(-84+275*r**2+1754*r**4+107*r**6)+3*Q2**4*(37
            -17*r**2-281*r**4+125*r**6)+Q2**2*(-99+1093*r**2+10210*r**4+8818*r**6
            +1717*r**8-195*r**10)+4*Q2*(-36+327*r**2+1534*r**4-2282*r**6+1954*r**8
            +63*r**10))-24*logq2*r**2*(-10-11*r**2-36*Q2**4*r**2+14*r**4-1326*r**6
            -416*r**8+189*r**10+2*Q2**3*(-5+132*r**2+117*r**4)-Q2**2*(-10+191*r**2
            +524*r**4+171*r**6)-2*Q2*(-5+93*r**2+2*r**4-68*r**6+108*r**8))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(
            -103680*logq2**3*r**12-2160*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+25920*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+60*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((12*logq2*r**4+(3-5*Q2**3-5*r**2
            +19*r**4-5*r**6+5*Q2**2*(1+r**2)+Q2*(5-8*r**2+5*r**4))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(288*logq2**2*r**8
            +2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-48*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((180*logq2*r**4*(1+r**2)
            +(-3-8*Q2**4+42*r**2+282*r**4+42*r**6-3*r**8+7*Q2**3*(1+r**2)+Q2**2*(7
            -2*r**2+7*r**4)-3*Q2*(1-11*r**2-11*r**4+r**6))*sqrtq2)*nlopw.X1Q2MuG(0,Q2,r))/(1440*logq2**2*r**8
            +10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-240*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+nlopw.X1Q2MuG(1,Q2,r)/(-12*logq2*r**4
            +(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))
            +rhoLS*((flagPERP*(276480*logq2**3*(-Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)
            -384*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(48*Q2**9*r**2+Q2**8*(5
            -306*r**2-270*r**4)+2*Q2**7*(-10+325*r**2+657*r**4+270*r**6)-2*Q2**6*(
            -10+218*r**2+747*r**4+758*r**6+201*r**8)-2*Q2**5*(-10+123*r**2+513*r**4
            +1079*r**6-3*r**8+18*r**10)+2*Q2**4*(-25+196*r**2+1389*r**4+3506*r**6
            +2077*r**8+210*r**10+81*r**12)-2*Q2**3*(-10+17*r**2+771*r**4+1348*r**6
            +2084*r**8+597*r**10-133*r**12+30*r**14)+(-1+r**2)**2*(5+36*r**2-29*r**4
            +2106*r**6-4733*r**8-2968*r**10+3001*r**12+386*r**14+36*r**16)+2*Q2**2*(10
            -30*r**2+117*r**4-116*r**6-1839*r**8-534*r**10+2539*r**12+168*r**14
            +45*r**16)-2*Q2*(10+17*r**2-51*r**4+1495*r**6-4687*r**8-1203*r**10
            -4025*r**12+3653*r**14+417*r**16+54*r**18))-9216*logq2**2*r**10*(24*Q2**6
            -3*Q2**5*(33+23*r**2)+Q2**4*(130+167*r**2+45*r**4)-Q2**3*(55+78*r**2
            +53*r**4+15*r**6)+(-1+r**2)**2*(19-96*r**2-36*r**4-31*r**6+54*r**8)
            +Q2**2*(15-98*r**2-49*r**4-3*r**6+105*r**8)+Q2*(-34+242*r**2+177*r**4
            -8*r**6+127*r**8-144*r**10))*sqrtq2-64*r**4*(4*Q2**12+Q2**11*(19+12*r**2)
            -Q2**10*(262+1447*r**2+205*r**4)+Q2**9*(848+8503*r**2+7822*r**4+735*r**6)
            -Q2**8*(1257+18491*r**2+29603*r**4+16573*r**6+1260*r**8)+2*Q2**7*(555
            +7280*r**2+15150*r**4+16578*r**6+7621*r**8+546*r**10)-2*Q2**6*(630
            -3491*r**2-7137*r**4-9300*r**6+3214*r**8+1493*r**10+147*r**12)-2*Q2**5*(
            -936+10597*r**2+19708*r**4+33991*r**6+26068*r**8+2377*r**10+1892*r**12
            +135*r**14)+(-1+r**2)**4*(115+121*r**2-345*r**4+14821*r**6-38699*r**8
            +18831*r**10-95*r**12+931*r**14)+2*Q2**4*(-699+7271*r**2+9159*r**4
            +11213*r**6+8885*r**8+20879*r**10-849*r**12+1189*r**14+120*r**16)+Q2*(
            -1+r**2)**2*(-584+283*r**2-1624*r**4-36772*r**6+59512*r**8+94238*r**10
            -75304*r**12-1052*r**14-4144*r**16+7*r**18)-Q2**3*(193+2564*r**2+5532*r**4
            -10980*r**6-45574*r**8-34012*r**10+75748*r**12+2612*r**14+3877*r**16
            +40*r**18)+Q2**2*(986-2015*r**2+6955*r**4+15432*r**6-47852*r**8-19874*r**10
            -136854*r**12+107416*r**14+274*r**16+6433*r**18-21*r**20))*sqrtq2))/(311040*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+6480*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-180*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-77760*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(flagPERP*muWC*(-552960*logq2**3*(-Q2+(-1+r)**2)*r**12*(1
            +3*r**2)*(-Q2+(1+r)**2)+768*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1
            +r)**2)*(-24*Q2**9*r**2+Q2**8*(-25+171*r**2+138*r**4)-2*Q2**7*(-40+145*r**2
            +456*r**4+135*r**6)+2*Q2**6*(-30+349*r**2-271*r**4+453*r**6+51*r**8)
            +2*Q2**5*(-20-1017*r**2+2406*r**4+7408*r**6+1350*r**8+177*r**10)+2*Q2**3*r**2*(
            -623+1568*r**2+8421*r**4+18124*r**6+10871*r**8+1812*r**10+51*r**12)
            -2*Q2**4*(-25-1322*r**2+3069*r**4+16160*r**6+18199*r**8+3300*r**10
            +243*r**12)+(-1+r**2)**2*(15-r**2+71*r**4+4667*r**6-10787*r**8-11087*r**10
            +7369*r**12+1077*r**14+36*r**16)+2*Q2**2*(10-45*r**2+339*r**4-599*r**6
            +2049*r**8-9831*r**10+8161*r**12+1251*r**14+105*r**16)-2*Q2*(20-101*r**2
            +630*r**4+1250*r**6-9158*r**8-3732*r**10-18406*r**12+10438*r**14+1698*r**16
            +81*r**18))+18432*logq2**2*r**8*(-84*Q2**6*r**2+3*Q2**5*(5+98*r**2+133*r**4)
            -Q2**4*(35+390*r**2+877*r**4+630*r**6)+Q2**3*(20+155*r**2+523*r**4
            +748*r**6+210*r**8)+Q2**2*r**2*(40-147*r**2-76*r**4-357*r**6+420*r**8)
            +(-1+r**2)**2*(-5+76*r**2-219*r**4-274*r**6-64*r**8+126*r**10)+Q2*(5
            -101*r**2+428*r**4+853*r**6+188*r**8+508*r**10-441*r**12))*sqrtq2-128*r**2*(
            -4*Q2**12*r**2+Q2**11*(-27+75*r**2+8*r**4)+Q2**10*(204-227*r**2-1028*r**4
            +67*r**6)+Q2**9*(-675+189*r**2+4907*r**4+5099*r**6-320*r**8)+Q2**8*(1290
            -885*r**2-8162*r**4-18520*r**6-10936*r**8+525*r**10)-2*Q2**7*(795-2577*r**2
            -6464*r**4+6336*r**6-7113*r**8-2977*r**10+96*r**12)-2*Q2**6*(-672+5769*r**2
            +16234*r**4-47959*r**6-98376*r**8-21987*r**10-8722*r**12+273*r**14)
            +2*Q2**5*(-399+6231*r**2+24755*r**4-78239*r**6-184751*r**8-218525*r**10
            -47837*r**12-17675*r**14+408*r**16)+Q2**4*(300-6594*r**2-35192*r**4
            +148548*r**6+207536*r**8+265868*r**10+303056*r**12+55548*r**14+20876*r**16
            -330*r**18)+(-1+r**2)**4*(-6-189*r**2-262*r**4+1490*r**6-32826*r**8
            +85772*r**10-30490*r**12-4722*r**14-1504*r**16+17*r**18)+Q2**3*(-15
            +1555*r**2+9472*r**4-58528*r**6+16678*r**8-2950*r**10-102760*r**12
            +115152*r**14+13785*r**16+7811*r**18-200*r**20)-Q2*(-1+r**2)**2*(-33
            -599*r**2+140*r**4-10820*r**6-26362*r**8+33362*r**10+332740*r**12-161404*r**14
            -20389*r**16-8507*r**18+112*r**20)+Q2**2*(-60-555*r**2+872*r**4-16561*r**6
            -19408*r**8+177510*r**10-108760*r**12+548834*r**14-265908*r**16-22651*r**18
            -17104*r**20+271*r**22))*sqrtq2))/(933120*logq2**3*r**14*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))+19440*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-540*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2-233280*logq2**2*r**10*(Q2**5-3*Q2**4*(1
            +r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)
            +2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)
            +(flagPERP*muWC**2*(-138240*logq2**3*(-Q2+(-1+r)**2)*r**12*(1+3*r**2)*(
            -Q2+(1+r)**2)+192*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(-24*Q2**9*r**2
            +Q2**8*(-25+171*r**2+138*r**4)-2*Q2**7*(-40+145*r**2+456*r**4+135*r**6)
            +2*Q2**6*(-30+349*r**2-271*r**4+453*r**6+51*r**8)+2*Q2**5*(-20-1017*r**2
            +2406*r**4+7408*r**6+1350*r**8+177*r**10)+2*Q2**3*r**2*(-623+1568*r**2
            +8421*r**4+18124*r**6+10871*r**8+1812*r**10+51*r**12)-2*Q2**4*(-25
            -1322*r**2+3069*r**4+16160*r**6+18199*r**8+3300*r**10+243*r**12)+(
            -1+r**2)**2*(15-r**2+71*r**4+4667*r**6-10787*r**8-11087*r**10+7369*r**12
            +1077*r**14+36*r**16)+2*Q2**2*(10-45*r**2+339*r**4-599*r**6+2049*r**8
            -9831*r**10+8161*r**12+1251*r**14+105*r**16)-2*Q2*(20-101*r**2+630*r**4
            +1250*r**6-9158*r**8-3732*r**10-18406*r**12+10438*r**14+1698*r**16
            +81*r**18))+4608*logq2**2*r**8*(-84*Q2**6*r**2+3*Q2**5*(5+98*r**2+133*r**4)
            -Q2**4*(35+390*r**2+877*r**4+630*r**6)+Q2**3*(20+155*r**2+523*r**4
            +748*r**6+210*r**8)+Q2**2*r**2*(40-147*r**2-76*r**4-357*r**6+420*r**8)
            +(-1+r**2)**2*(-5+76*r**2-219*r**4-274*r**6-64*r**8+126*r**10)+Q2*(5
            -101*r**2+428*r**4+853*r**6+188*r**8+508*r**10-441*r**12))*sqrtq2-32*r**2*(
            -4*Q2**12*r**2+Q2**11*(-27+75*r**2+8*r**4)+Q2**10*(204-227*r**2-1028*r**4
            +67*r**6)+Q2**9*(-675+189*r**2+4907*r**4+5099*r**6-320*r**8)+Q2**8*(1290
            -885*r**2-8162*r**4-18520*r**6-10936*r**8+525*r**10)-2*Q2**7*(795-2577*r**2
            -6464*r**4+6336*r**6-7113*r**8-2977*r**10+96*r**12)-2*Q2**6*(-672+5769*r**2
            +16234*r**4-47959*r**6-98376*r**8-21987*r**10-8722*r**12+273*r**14)
            +2*Q2**5*(-399+6231*r**2+24755*r**4-78239*r**6-184751*r**8-218525*r**10
            -47837*r**12-17675*r**14+408*r**16)+Q2**4*(300-6594*r**2-35192*r**4
            +148548*r**6+207536*r**8+265868*r**10+303056*r**12+55548*r**14+20876*r**16
            -330*r**18)+(-1+r**2)**4*(-6-189*r**2-262*r**4+1490*r**6-32826*r**8
            +85772*r**10-30490*r**12-4722*r**14-1504*r**16+17*r**18)+Q2**3*(-15
            +1555*r**2+9472*r**4-58528*r**6+16678*r**8-2950*r**10-102760*r**12
            +115152*r**14+13785*r**16+7811*r**18-200*r**20)-Q2*(-1+r**2)**2*(-33
            -599*r**2+140*r**4-10820*r**6-26362*r**8+33362*r**10+332740*r**12-161404*r**14
            -20389*r**16-8507*r**18+112*r**20)+Q2**2*(-60-555*r**2+872*r**4-16561*r**6
            -19408*r**8+177510*r**10-108760*r**12+548834*r**14-265908*r**16-22651*r**18
            -17104*r**20+271*r**22))*sqrtq2))/(622080*logq2**3*r**14*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))+12960*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-360*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2-155520*logq2**2*r**10*(Q2**5-3*Q2**4*(1
            +r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)
            +2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)
            +(flagPERP*(138240*logq2**3*(-Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)-192*logq2*(
            -Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(48*Q2**9*r**2+Q2**8*(5-306*r**2
            -270*r**4)+2*Q2**7*(-10+325*r**2+657*r**4+270*r**6)-2*Q2**6*(-10+218*r**2
            +747*r**4+758*r**6+201*r**8)-2*Q2**5*(-10+123*r**2+513*r**4+1079*r**6
            -3*r**8+18*r**10)+2*Q2**4*(-25+196*r**2+1389*r**4+3506*r**6+2077*r**8
            +210*r**10+81*r**12)-2*Q2**3*(-10+17*r**2+771*r**4+1348*r**6+2084*r**8
            +597*r**10-133*r**12+30*r**14)+(-1+r**2)**2*(5+36*r**2-29*r**4+2106*r**6
            -4733*r**8-2968*r**10+3001*r**12+386*r**14+36*r**16)+2*Q2**2*(10-30*r**2
            +117*r**4-116*r**6-1839*r**8-534*r**10+2539*r**12+168*r**14+45*r**16)
            -2*Q2*(10+17*r**2-51*r**4+1495*r**6-4687*r**8-1203*r**10-4025*r**12
            +3653*r**14+417*r**16+54*r**18))-4608*logq2**2*r**10*(24*Q2**6-3*Q2**5*(33
            +23*r**2)+Q2**4*(130+167*r**2+45*r**4)-Q2**3*(55+78*r**2+53*r**4+15*r**6)
            +(-1+r**2)**2*(19-96*r**2-36*r**4-31*r**6+54*r**8)+Q2**2*(15-98*r**2
            -49*r**4-3*r**6+105*r**8)+Q2*(-34+242*r**2+177*r**4-8*r**6+127*r**8
            -144*r**10))*sqrtq2-32*r**4*(4*Q2**12+Q2**11*(19+12*r**2)-Q2**10*(262
            +1447*r**2+205*r**4)+Q2**9*(848+8503*r**2+7822*r**4+735*r**6)-Q2**8*(1257
            +18491*r**2+29603*r**4+16573*r**6+1260*r**8)+2*Q2**7*(555+7280*r**2
            +15150*r**4+16578*r**6+7621*r**8+546*r**10)-2*Q2**6*(630-3491*r**2
            -7137*r**4-9300*r**6+3214*r**8+1493*r**10+147*r**12)-2*Q2**5*(-936
            +10597*r**2+19708*r**4+33991*r**6+26068*r**8+2377*r**10+1892*r**12
            +135*r**14)+(-1+r**2)**4*(115+121*r**2-345*r**4+14821*r**6-38699*r**8
            +18831*r**10-95*r**12+931*r**14)+2*Q2**4*(-699+7271*r**2+9159*r**4
            +11213*r**6+8885*r**8+20879*r**10-849*r**12+1189*r**14+120*r**16)+Q2*(
            -1+r**2)**2*(-584+283*r**2-1624*r**4-36772*r**6+59512*r**8+94238*r**10
            -75304*r**12-1052*r**14-4144*r**16+7*r**18)-Q2**3*(193+2564*r**2+5532*r**4
            -10980*r**6-45574*r**8-34012*r**10+75748*r**12+2612*r**14+3877*r**16
            +40*r**18)+Q2**2*(986-2015*r**2+6955*r**4+15432*r**6-47852*r**8-19874*r**10
            -136854*r**12+107416*r**14+274*r**16+6433*r**18-21*r**20))*sqrtq2)*math.log(mu0))/(103680*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+2160*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-60*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-25920*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+FLAGcs*flagPERP*((9360*logq2**2*r**6*(-1+3*r**2)+26*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(6+r**2+4*Q2**5*r**2+69*r**4-316*r**6
            +1454*r**8-477*r**10-17*r**12+3*Q2**4*(-3+13*r**2+4*r**4)-Q2**3*(-21
            +85*r**2+541*r**4+43*r**6)+Q2**2*(-9+8*r**2+650*r**4+578*r**6+17*r**8)
            +Q2*(-9+33*r**2+416*r**4-628*r**6+401*r**8+27*r**10))-156*logq2*r**2*(
            -5+26*r**2-24*Q2**4*r**2+16*r**4-294*r**6-19*r**8+36*r**10+Q2**3*(
            -5+81*r**2+66*r**4)-Q2**2*(-5+34*r**2+151*r**4+24*r**6)+Q2*(5-39*r**2
            -11*r**4+59*r**6-54*r**8))*sqrtq2)/(6480*logq2**2*r**8+45*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2-1080*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2)+((720*logq2**2*r**6*(-1+3*r**2)+2*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(6+r**2+4*Q2**5*r**2+69*r**4-316*r**6
            +1454*r**8-477*r**10-17*r**12+3*Q2**4*(-3+13*r**2+4*r**4)-Q2**3*(-21
            +85*r**2+541*r**4+43*r**6)+Q2**2*(-9+8*r**2+650*r**4+578*r**6+17*r**8)
            +Q2*(-9+33*r**2+416*r**4-628*r**6+401*r**8+27*r**10))-12*logq2*r**2*(
            -5+26*r**2-24*Q2**4*r**2+16*r**4-294*r**6-19*r**8+36*r**10+Q2**3*(
            -5+81*r**2+66*r**4)-Q2**2*(-5+34*r**2+151*r**4+24*r**6)+Q2*(5-39*r**2
            -11*r**4+59*r**6-54*r**8))*sqrtq2)*math.log(murhoLS))/(720*logq2**2*r**8+5*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+(flagPERP*(-138240*logq2**3*(
            -Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)+192*logq2*(-Q2+(-1+r)**2)*r**4*(
            -Q2+(1+r)**2)*(48*Q2**9*r**2+Q2**8*(5-306*r**2-270*r**4)+2*Q2**7*(-10
            +325*r**2+657*r**4+270*r**6)-2*Q2**6*(-10+218*r**2+747*r**4+758*r**6
            +201*r**8)-2*Q2**5*(-10+123*r**2+513*r**4+1079*r**6-3*r**8+18*r**10)
            +2*Q2**4*(-25+196*r**2+1389*r**4+3506*r**6+2077*r**8+210*r**10+81*r**12)
            -2*Q2**3*(-10+17*r**2+771*r**4+1348*r**6+2084*r**8+597*r**10-133*r**12
            +30*r**14)+(-1+r**2)**2*(5+36*r**2-29*r**4+2106*r**6-4733*r**8-2968*r**10
            +3001*r**12+386*r**14+36*r**16)+2*Q2**2*(10-30*r**2+117*r**4-116*r**6
            -1839*r**8-534*r**10+2539*r**12+168*r**14+45*r**16)-2*Q2*(10+17*r**2
            -51*r**4+1495*r**6-4687*r**8-1203*r**10-4025*r**12+3653*r**14+417*r**16
            +54*r**18))+4608*logq2**2*r**10*(24*Q2**6-3*Q2**5*(33+23*r**2)+Q2**4*(130
            +167*r**2+45*r**4)-Q2**3*(55+78*r**2+53*r**4+15*r**6)+(-1+r**2)**2*(19
            -96*r**2-36*r**4-31*r**6+54*r**8)+Q2**2*(15-98*r**2-49*r**4-3*r**6
            +105*r**8)+Q2*(-34+242*r**2+177*r**4-8*r**6+127*r**8-144*r**10))*sqrtq2
            +32*r**4*(4*Q2**12+Q2**11*(19+12*r**2)-Q2**10*(262+1447*r**2+205*r**4)
            +Q2**9*(848+8503*r**2+7822*r**4+735*r**6)-Q2**8*(1257+18491*r**2+29603*r**4
            +16573*r**6+1260*r**8)+2*Q2**7*(555+7280*r**2+15150*r**4+16578*r**6
            +7621*r**8+546*r**10)-2*Q2**6*(630-3491*r**2-7137*r**4-9300*r**6+3214*r**8
            +1493*r**10+147*r**12)-2*Q2**5*(-936+10597*r**2+19708*r**4+33991*r**6
            +26068*r**8+2377*r**10+1892*r**12+135*r**14)+(-1+r**2)**4*(115+121*r**2
            -345*r**4+14821*r**6-38699*r**8+18831*r**10-95*r**12+931*r**14)+2*Q2**4*(
            -699+7271*r**2+9159*r**4+11213*r**6+8885*r**8+20879*r**10-849*r**12
            +1189*r**14+120*r**16)+Q2*(-1+r**2)**2*(-584+283*r**2-1624*r**4-36772*r**6
            +59512*r**8+94238*r**10-75304*r**12-1052*r**14-4144*r**16+7*r**18)
            -Q2**3*(193+2564*r**2+5532*r**4-10980*r**6-45574*r**8-34012*r**10+75748*r**12
            +2612*r**14+3877*r**16+40*r**18)+Q2**2*(986-2015*r**2+6955*r**4+15432*r**6
            -47852*r**8-19874*r**10-136854*r**12+107416*r**14+274*r**16+6433*r**18
            -21*r**20))*sqrtq2)*math.log(r))/(103680*logq2**3*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))+2160*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2-60*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2-25920*logq2**2*r**10*(Q2**5-3*Q2**4*(1+r**2)
            +2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1
            -2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)
            +(flagPERP*(-720*logq2**2*r**6*(-4+21*r**2+9*r**4)-(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(21+120*Q2**7+431*r**2+2289*r**4-3941*r**6+26419*r**8
            -5607*r**10-937*r**12+45*r**14-225*Q2**6*(1+r**2)-8*Q2**5*(15-58*r**2
            +15*r**4)-4*Q2**3*(-84+275*r**2+1754*r**4+107*r**6)+3*Q2**4*(37-17*r**2
            -281*r**4+125*r**6)+Q2**2*(-99+1093*r**2+10210*r**4+8818*r**6+1717*r**8
            -195*r**10)+4*Q2*(-36+327*r**2+1534*r**4-2282*r**6+1954*r**8+63*r**10))
            +24*logq2*r**2*(-10-11*r**2-36*Q2**4*r**2+14*r**4-1326*r**6-416*r**8
            +189*r**10+2*Q2**3*(-5+132*r**2+117*r**4)-Q2**2*(-10+191*r**2+524*r**4
            +171*r**6)-2*Q2*(-5+93*r**2+2*r**4-68*r**6+108*r**8))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(
            -103680*logq2**3*r**12-2160*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+25920*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+60*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(flagPERP*(-12*logq2*r**4+(-3+5*Q2**3
            +5*r**2-19*r**4+5*r**6-5*Q2**2*(1+r**2)+Q2*(-5+8*r**2-5*r**4))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(288*logq2**2*r**8
            +2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-48*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(flagPERP*(-180*logq2*r**4*(1
            +r**2)+(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*nlopw.X1Q2MuG(0,Q2,r))/(1440*logq2**2*r**8
            +10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-240*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)-(flagPERP*nlopw.X1Q2MuG(1,Q2,r))/(
            -12*logq2*r**4+(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2))+rhoD*((flagPERP*muWC*(18432*logq2**2*(-Q2+(-1+r)**2)*r**8*(
            -Q2+(1+r)**2)*(-84*Q2**6*r**2+3*Q2**5*(5+98*r**2+133*r**4)-Q2**4*(35
            +390*r**2+877*r**4+630*r**6)+Q2**3*(20+155*r**2+523*r**4+748*r**6
            +210*r**8)+Q2**2*r**2*(40-147*r**2-76*r**4-357*r**6+420*r**8)+(-1
            +r**2)**2*(-5+76*r**2-219*r**4-274*r**6-64*r**8+126*r**10)+Q2*(5-101*r**2
            +428*r**4+853*r**6+188*r**8+508*r**10-441*r**12))-128*(Q2-(-1+r)**2)**2*r**2*(Q2
            -(1+r)**2)**2*(-4*Q2**10*r**2+Q2**9*(-27+67*r**2)+Q2**8*(150-143*r**2
            -902*r**4+71*r**6)+Q2**7*(-348+82*r**2+2978*r**4+3370*r**6-178*r**8)
            +2*Q2**6*(222-487*r**2-788*r**4-3778*r**6-1754*r**8+49*r**10)+2*Q2**5*(
            -177+1658*r**2+2681*r**4-14216*r**6-1981*r**8-2296*r**10+91*r**12)
            -4*Q2**4*(-48+938*r**2+3982*r**4-13789*r**6-30484*r**8-6827*r**10-3082*r**12
            +70*r**14)+2*Q2**3*(-30+659*r**2+5887*r**4-21091*r**6-36791*r**8-56731*r**10
            -10903*r**12-3149*r**14+37*r**16)+(-1+r**2)**2*(-6-189*r**2-262*r**4
            +1490*r**6-32826*r**8+85772*r**10-30490*r**12-4722*r**14-1504*r**16
            +17*r**18)+2*Q2**2*(-6+29*r**2-388*r**4+2236*r**6-9844*r**8+26594*r**10
            -23564*r**12-1516*r**14-2230*r**16+49*r**18)+Q2*(21+209*r**2-1042*r**4
            +13276*r**6-36310*r**8+72530*r**10-222176*r**12+90980*r**14+7937*r**16
            +5533*r**18-78*r**20))-552960*logq2**3*r**12*(1+3*r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2-768*logq2*r**4*(24*Q2**11*r**2+Q2**10*(25-219*r**2
            -186*r**4)+2*Q2**9*(-65+303*r**2+741*r**4+285*r**6)-Q2**8*(-245+1339*r**2
            +1633*r**4+3165*r**6+780*r**8)+8*Q2**7*(-20+470*r**2-531*r**4-1919*r**6
            -39*r**8+15*r**10)+2*Q2**6*(-35-3805*r**2+6846*r**4+34444*r**6+36841*r**8
            +6003*r**10+546*r**12)-4*Q2**5*(-35-2147*r**2+4741*r**4+24229*r**6
            +37891*r**8+29377*r**10+4947*r**12+357*r**14)-(-1+r**2)**4*(15-r**2
            +71*r**4+4667*r**6-10787*r**8-11087*r**10+7369*r**12+1077*r**14+36*r**16)
            +2*Q2**4*(-35-2473*r**2+7239*r**4+29277*r**6+39989*r**8+50883*r**10
            +29047*r**12+5289*r**14+240*r**16)+8*Q2**3*(10+113*r**2-399*r**4-983*r**6
            -2277*r**8-585*r**10-4985*r**12+5491*r**14+675*r**16+60*r**18)+2*Q2*(
            -1+r**2)**2*(35-87*r**2+700*r**4+5988*r**6-15278*r**8-25606*r**10-22124*r**12
            +18884*r**14+2811*r**16+117*r**18)+Q2**2*(-115+485*r**2-3082*r**4-9400*r**6
            +44510*r**8+65462*r**10+10052*r**12+106424*r**14-65323*r**16-10203*r**18
            -570*r**20))*sqrtq2))/(-233280*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-540*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+933120*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+19440*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(flagPERP*muWC**2*(2304*logq2**2*(
            -Q2+(-1+r)**2)*r**8*(-Q2+(1+r)**2)*(-84*Q2**6*r**2+3*Q2**5*(5+98*r**2
            +133*r**4)-Q2**4*(35+390*r**2+877*r**4+630*r**6)+Q2**3*(20+155*r**2
            +523*r**4+748*r**6+210*r**8)+Q2**2*r**2*(40-147*r**2-76*r**4-357*r**6
            +420*r**8)+(-1+r**2)**2*(-5+76*r**2-219*r**4-274*r**6-64*r**8+126*r**10)
            +Q2*(5-101*r**2+428*r**4+853*r**6+188*r**8+508*r**10-441*r**12))
            -16*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(-4*Q2**10*r**2+Q2**9*(-27
            +67*r**2)+Q2**8*(150-143*r**2-902*r**4+71*r**6)+Q2**7*(-348+82*r**2
            +2978*r**4+3370*r**6-178*r**8)+2*Q2**6*(222-487*r**2-788*r**4-3778*r**6
            -1754*r**8+49*r**10)+2*Q2**5*(-177+1658*r**2+2681*r**4-14216*r**6-1981*r**8
            -2296*r**10+91*r**12)-4*Q2**4*(-48+938*r**2+3982*r**4-13789*r**6-30484*r**8
            -6827*r**10-3082*r**12+70*r**14)+2*Q2**3*(-30+659*r**2+5887*r**4-21091*r**6
            -36791*r**8-56731*r**10-10903*r**12-3149*r**14+37*r**16)+(-1+r**2)**2*(
            -6-189*r**2-262*r**4+1490*r**6-32826*r**8+85772*r**10-30490*r**12
            -4722*r**14-1504*r**16+17*r**18)+2*Q2**2*(-6+29*r**2-388*r**4+2236*r**6
            -9844*r**8+26594*r**10-23564*r**12-1516*r**14-2230*r**16+49*r**18)
            +Q2*(21+209*r**2-1042*r**4+13276*r**6-36310*r**8+72530*r**10-222176*r**12
            +90980*r**14+7937*r**16+5533*r**18-78*r**20))-69120*logq2**3*r**12*(1
            +3*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-96*logq2*r**4*(24*Q2**11*r**2
            +Q2**10*(25-219*r**2-186*r**4)+2*Q2**9*(-65+303*r**2+741*r**4+285*r**6)
            -Q2**8*(-245+1339*r**2+1633*r**4+3165*r**6+780*r**8)+8*Q2**7*(-20+470*r**2
            -531*r**4-1919*r**6-39*r**8+15*r**10)+2*Q2**6*(-35-3805*r**2+6846*r**4
            +34444*r**6+36841*r**8+6003*r**10+546*r**12)-4*Q2**5*(-35-2147*r**2
            +4741*r**4+24229*r**6+37891*r**8+29377*r**10+4947*r**12+357*r**14)
            -(-1+r**2)**4*(15-r**2+71*r**4+4667*r**6-10787*r**8-11087*r**10+7369*r**12
            +1077*r**14+36*r**16)+2*Q2**4*(-35-2473*r**2+7239*r**4+29277*r**6+39989*r**8
            +50883*r**10+29047*r**12+5289*r**14+240*r**16)+8*Q2**3*(10+113*r**2
            -399*r**4-983*r**6-2277*r**8-585*r**10-4985*r**12+5491*r**14+675*r**16
            +60*r**18)+2*Q2*(-1+r**2)**2*(35-87*r**2+700*r**4+5988*r**6-15278*r**8
            -25606*r**10-22124*r**12+18884*r**14+2811*r**16+117*r**18)+Q2**2*(-115
            +485*r**2-3082*r**4-9400*r**6+44510*r**8+65462*r**10+10052*r**12+106424*r**14
            -65323*r**16-10203*r**18-570*r**20))*sqrtq2))/(-77760*logq2**2*(-Q2+(
            -1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-180*(-Q2
            +(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+311040*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+6480*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(flagPERP*(-9216*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(24*Q2**6-3*Q2**5*(33+23*r**2)
            +Q2**4*(130+167*r**2+45*r**4)-Q2**3*(55+78*r**2+53*r**4+15*r**6)+(
            -1+r**2)**2*(19-96*r**2-36*r**4-31*r**6+54*r**8)+Q2**2*(15-98*r**2
            -49*r**4-3*r**6+105*r**8)+Q2*(-34+242*r**2+177*r**4-8*r**6+127*r**8
            -144*r**10))-64*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(4*Q2**10
            +Q2**9*(27+20*r**2)-Q2**8*(212+1345*r**2+169*r**4)+Q2**7*(397+5423*r**2
            +4807*r**4+377*r**6)-Q2**6*(251+5930*r**2+11452*r**4+5198*r**6+337*r**8)
            +Q2**5*(211-2431*r**2+1178*r**4+3670*r**6+119*r**8+41*r**10)+Q2**4*(
            -587+7970*r**2+11611*r**4+16520*r**6+2543*r**8+1858*r**10+125*r**12)
            -Q2**3*(-487+3575*r**2+6505*r**4+10603*r**6+7967*r**8-575*r**10-145*r**12
            +61*r**14)+(-1+r**2)**2*(115+121*r**2-345*r**4+14821*r**6-38699*r**8
            +18831*r**10-95*r**12+931*r**14)+Q2**2*(163-778*r**2+3074*r**4-13058*r**6
            -484*r**8+13682*r**10+790*r**12+938*r**14-7*r**16)+Q2*(-354+755*r**2
            -2072*r**4-7820*r**6+11756*r**8+54502*r**10-37832*r**12+620*r**14-2282*r**16
            +7*r**18))+276480*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            -384*logq2*r**4*(48*Q2**11*r**2+Q2**10*(5-402*r**2-366*r**4)+2*Q2**9*(
            -15+650*r**2+1185*r**4+564*r**6)-Q2**8*(-65+2012*r**2+5075*r**4+4990*r**6
            +1752*r**8)+4*Q2**7*(-10+319*r**2+707*r**4+606*r**6+1019*r**8+327*r**10)
            +Q2**6*(-70+368*r**2+4720*r**4+14416*r**6+9594*r**8-232*r**10-168*r**12)
            -4*Q2**5*(-35+251*r**2+2099*r**4+5657*r**6+5801*r**8+3137*r**10+205*r**12
            +105*r**14)+(-1+r**2)**4*(5+36*r**2-29*r**4+2106*r**6-4733*r**8-2968*r**10
            +3001*r**12+386*r**14+36*r**16)+2*Q2**4*(-35+230*r**2+2665*r**4+5046*r**6
            +1479*r**8+4390*r**10+5205*r**12+10*r**14+186*r**16)-4*Q2**3*(10+7*r**2
            +425*r**4+660*r**6-4219*r**8-4086*r**10+371*r**12+4980*r**14+325*r**16
            +87*r**18)-2*Q2*(-1+r**2)**2*(15+58*r**2-44*r**4+3572*r**6-7314*r**8
            -8904*r**10-3992*r**12+7040*r**14+839*r**16+90*r**18)+Q2**2*(65+34*r**2
            +142*r**4+7216*r**6-24722*r**8-8900*r**10-13172*r**12-20960*r**14+23041*r**16
            +2354*r**18+342*r**20))*sqrtq2))/(-77760*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-180*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+311040*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+6480*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(9216*logq2**2*r**6*(24*Q2**8*(2
            +5*r**4)-3*Q2**7*(103+93*r**2+235*r**4+195*r**6)+Q2**6*(789+1125*r**2
            +2344*r**4+2075*r**6+1035*r**8)-3*Q2**5*(311+507*r**2+1147*r**4+1071*r**6
            +590*r**8+290*r**10)+(-1+r**2)**4*(-57+33*r**2-512*r**4-912*r**6-357*r**8
            +95*r**10+270*r**12)+3*Q2**4*(95+225*r**2+376*r**4+315*r**6+315*r**8
            +310*r**10+300*r**12)+Q2**3*(537-225*r**2+2863*r**4+5558*r**6+1860*r**8
            -428*r**10-1360*r**12-1845*r**14)-3*Q2*(-1+r**2)**2*(-107+71*r**2-864*r**4
            -1879*r**6-1484*r**8-192*r**10+195*r**12+420*r**14)+3*Q2**2*(-227+273*r**2
            -1554*r**4-2514*r**6-2774*r**8-1327*r**10-262*r**12-40*r**14+745*r**16))
            +64*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(28*Q2**12*r**2+8*Q2**11*r**2*(17
            +12*r**2)-Q2**10*(144+595*r**2+6562*r**4+1555*r**6)+Q2**9*(882-679*r**2
            +24181*r**4+34003*r**6+5685*r**8)-2*Q2**8*(999-3174*r**2+16810*r**4
            +43744*r**6+34091*r**8+5130*r**10)+4*Q2**7*(378-3579*r**2-2408*r**4
            +16929*r**6+20829*r**8+13010*r**10+2541*r**12)+2*Q2**6*(756+8955*r**2
            +85778*r**4+67443*r**6+46848*r**8+26603*r**10+6286*r**12-2541*r**14)
            +2*Q2**5*(-1890-5913*r**2-183595*r**4-182377*r**6-184963*r**8-58429*r**10
            -70627*r**12-21833*r**14+315*r**16)+2*(-1+r**2)**4*(-63-484*r**2-11632*r**4
            +45552*r**6-58534*r**8-63676*r**10+50640*r**12+1328*r**14+2309*r**16)
            +4*Q2**4*(567-264*r**2+71986*r**4+27402*r**6+52234*r**8+56296*r**10
            -30962*r**12+27186*r**14+7463*r**16+60*r**18)+Q2*(-1+r**2)**2*(738
            +4645*r**2+126385*r**4-335668*r**6+291944*r**8+682954*r**10+249938*r**12
            -436492*r**14-10634*r**16-20911*r**18+61*r**20)+4*Q2**3*(162+2423*r**2
            +12310*r**4+17547*r**6+70191*r**8+30919*r**10-109883*r**12-26719*r**14
            -15773*r**16-7162*r**18+65*r**20)-Q2**2*(1512+8347*r**2+213698*r**4
            -442333*r**6+522312*r**8+338306*r**10+919124*r**12+125490*r**14-538384*r**16
            -7549*r**18-34870*r**20+267*r**22))-552960*logq2**3*r**10*(3+5*r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+768*logq2*r**4*(120*Q2**11*r**2+Q2**10*(28
            -651*r**2-915*r**4)+Q2**9*(-141+1334*r**2+3939*r**4+2820*r**6)-Q2**8*(
            -367+655*r**2+6247*r**4+7829*r**6+4380*r**8)+2*Q2**7*(-430-3086*r**2
            -691*r**4-213*r**6+1721*r**8+1635*r**10)+Q2**6*(1708+22810*r**2+32366*r**4
            +38654*r**6+23526*r**8+8092*r**10-420*r**12)-2*Q2**5*(1015+16730*r**2
            +29291*r**4+39173*r**6+25007*r**8+11312*r**10+6211*r**12+525*r**14)
            +(-1+r**2)**4*(-113-2091*r**2+4289*r**4-5523*r**6-23113*r**8-365*r**10
            +8543*r**12+1003*r**14+90*r**16)+2*Q2**4*(413+8023*r**2+16382*r**4
            +12591*r**6+17544*r**8+7547*r**10+5748*r**12+4343*r**14+465*r**16)
            -2*Q2**3*(-434-6590*r**2+3935*r**4-28737*r**6-27061*r**8+4707*r**10
            +15833*r**12+19929*r**14+3583*r**16+435*r**18)-Q2*(-1+r**2)**2*(-627
            -11084*r**2+15172*r**4-24730*r**6-102258*r**8-71406*r**10+13036*r**12
            +38930*r**14+4277*r**16+450*r**18)+Q2**2*(-1280-20743*r**2+30665*r**4
            -68914*r**6-102646*r**8-117028*r**10-61000*r**12-1558*r**14+58526*r**16
            +6643*r**18+855*r**20))*sqrtq2)/(-233280*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-540*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+933120*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+19440*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(muWC**2*(-2304*logq2**2*r**6*(
            -12*Q2**8*(3+35*r**4)+3*Q2**7*(76+131*r**2+670*r**4+945*r**6)-Q2**6*(543
            +1655*r**2+5223*r**4+8575*r**6+7560*r**8)+3*Q2**5*(222+749*r**2+2174*r**4
            +3952*r**6+3780*r**8+3115*r**10)+(-1+r**2)**4*(-111+49*r**2-581*r**4
            +99*r**6-526*r**8+80*r**10+630*r**12)-3*Q2**4*(215+415*r**2+1107*r**4
            +1915*r**6+2380*r**8+750*r**10+1050*r**12)+Q2**3*(816+415*r**2+4254*r**4
            +4139*r**6-2180*r**8+1641*r**10-3250*r**12-5355*r**14)-3*Q2*(-1+r**2)**2*(
            -166-7*r**2-1122*r**4-747*r**6+358*r**8-441*r**10+10*r**12+1155*r**14)
            +3*Q2**2*(-291+109*r**2-2067*r**4-1787*r**6+263*r**8+1499*r**10-781*r**12
            -1245*r**14+2380*r**16))+16*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(
            -6*Q2**13+2*Q2**12*(39+7*r**2)+Q2**11*(90+72*r**2-58*r**4)+Q2**10*(
            -3741-671*r**2-3851*r**4+607*r**6)-4*Q2**9*(-3945-2778*r**2+502*r**4
            -4952*r**6+575*r**8)+Q2**8*(-28509-35121*r**2-14642*r**4+15302*r**6
            -40441*r**8+3747*r**10)+Q2**7*(21972+49380*r**2+40252*r**4-78480*r**6
            -89676*r**8+9164*r**10-1668*r**12)+Q2**6*(1182-58986*r**2+48622*r**4
            +490982*r**6+793086*r**8+269310*r**10+107702*r**12-3354*r**14)+2*Q2**5*(
            -6591+38010*r**2-71608*r**4-440822*r**6-771002*r**8-921626*r**10-168968*r**12
            -97178*r**14+2793*r**16)+4*Q2**4*(2025-13758*r**2+30244*r**4+129972*r**6
            +197573*r**8+144563*r**10+320642*r**12+20442*r**14+29228*r**16-675*r**18)
            +(-1+r**2)**4*(603-3177*r**2+72164*r**4-224116*r**6+120462*r**8+261086*r**10
            -176644*r**12-25260*r**14-7945*r**16+107*r**18)-4*Q2*(-1+r**2)**2*(648
            -1925*r**2+65336*r**4-111692*r**6-68524*r**8+178406*r**10+237916*r**12
            -227380*r**14-27292*r**16-11105*r**18+172*r**20)-2*Q2**3*(1815-5138*r**2
            +88585*r**4+94676*r**6+33850*r**8+389696*r**10-242554*r**12-356436*r**14
            -91089*r**16-17518*r**18+433*r**20)+Q2**2*(3855-4359*r**2+321941*r**4
            -340021*r**6+320498*r**8-776754*r**10+673574*r**12+1780298*r**14-1471425*r**16
            -145159*r**18-87547*r**20+1579*r**22))-69120*logq2**3*r**10*(-9-10*r**2
            +15*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+96*logq2*r**2*(120*Q2**11*(1
            +r**4)-Q2**10*(813+680*r**2-3*r**4+930*r**6)+2*Q2**9*(1128+1633*r**2
            +531*r**4+243*r**6+1425*r**8)-Q2**8*(3159+5992*r**2+6970*r**4-3740*r**6
            -1593*r**8+3900*r**10)+4*Q2**7*(504+1331*r**2+1657*r**4-6009*r**6-21043*r**8
            -5670*r**10+150*r**12)+2*Q2**6*(63-1598*r**2+5777*r**4+57906*r**6+144223*r**8
            +167494*r**10+35061*r**12+2730*r**14)-4*Q2**5*(252-692*r**2+5986*r**4
            +44389*r**6+110029*r**8+142318*r**10+127252*r**12+23913*r**14+1785*r**16)
            -(-1+r**2)**4*(-21-216*r**2-8644*r**4+11756*r**6+21542*r**8-61292*r**10
            -16172*r**12+38596*r**14+5631*r**16+180*r**18)+2*Q2**4*(297-758*r**2
            +12704*r**4+50046*r**6+101880*r**8+163742*r**10+112332*r**12+102394*r**14
            +23427*r**16+1200*r**18)+2*Q2*(-1+r**2)**2*(-48-553*r**2-18585*r**4
            +7162*r**6+15762*r**8-19976*r**10-102976*r**12-29834*r**14+99374*r**16
            +14529*r**18+585*r**20)+4*Q2**3*(-54-307*r**2-11075*r**4-7917*r**6
            -28339*r**8-14223*r**10-29073*r**12+24305*r**14+70085*r**16+7518*r**18
            +600*r**20)+Q2**2*(159+2036*r**2+57587*r**4-28378*r**6+133346*r**8
            +34784*r**10-154198*r**12+226076*r**14+278111*r**16-355828*r**18-52605*r**20
            -2850*r**22))*sqrtq2))/(-233280*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-540*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+933120*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+19440*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(muWC*(-18432*logq2**2*r**6*(
            -12*Q2**8*(3+35*r**4)+3*Q2**7*(76+131*r**2+670*r**4+945*r**6)-Q2**6*(543
            +1655*r**2+5223*r**4+8575*r**6+7560*r**8)+3*Q2**5*(222+749*r**2+2174*r**4
            +3952*r**6+3780*r**8+3115*r**10)+(-1+r**2)**4*(-111+49*r**2-581*r**4
            +99*r**6-526*r**8+80*r**10+630*r**12)-3*Q2**4*(215+415*r**2+1107*r**4
            +1915*r**6+2380*r**8+750*r**10+1050*r**12)+Q2**3*(816+415*r**2+4254*r**4
            +4139*r**6-2180*r**8+1641*r**10-3250*r**12-5355*r**14)-3*Q2*(-1+r**2)**2*(
            -166-7*r**2-1122*r**4-747*r**6+358*r**8-441*r**10+10*r**12+1155*r**14)
            +3*Q2**2*(-291+109*r**2-2067*r**4-1787*r**6+263*r**8+1499*r**10-781*r**12
            -1245*r**14+2380*r**16))+128*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(
            -6*Q2**13+2*Q2**12*(39+7*r**2)+Q2**11*(90+72*r**2-58*r**4)+Q2**10*(
            -3741-671*r**2-3851*r**4+607*r**6)-4*Q2**9*(-3945-2778*r**2+502*r**4
            -4952*r**6+575*r**8)+Q2**8*(-28509-35121*r**2-14642*r**4+15302*r**6
            -40441*r**8+3747*r**10)+Q2**7*(21972+49380*r**2+40252*r**4-78480*r**6
            -89676*r**8+9164*r**10-1668*r**12)+Q2**6*(1182-58986*r**2+48622*r**4
            +490982*r**6+793086*r**8+269310*r**10+107702*r**12-3354*r**14)+2*Q2**5*(
            -6591+38010*r**2-71608*r**4-440822*r**6-771002*r**8-921626*r**10-168968*r**12
            -97178*r**14+2793*r**16)+4*Q2**4*(2025-13758*r**2+30244*r**4+129972*r**6
            +197573*r**8+144563*r**10+320642*r**12+20442*r**14+29228*r**16-675*r**18)
            +(-1+r**2)**4*(603-3177*r**2+72164*r**4-224116*r**6+120462*r**8+261086*r**10
            -176644*r**12-25260*r**14-7945*r**16+107*r**18)-4*Q2*(-1+r**2)**2*(648
            -1925*r**2+65336*r**4-111692*r**6-68524*r**8+178406*r**10+237916*r**12
            -227380*r**14-27292*r**16-11105*r**18+172*r**20)-2*Q2**3*(1815-5138*r**2
            +88585*r**4+94676*r**6+33850*r**8+389696*r**10-242554*r**12-356436*r**14
            -91089*r**16-17518*r**18+433*r**20)+Q2**2*(3855-4359*r**2+321941*r**4
            -340021*r**6+320498*r**8-776754*r**10+673574*r**12+1780298*r**14-1471425*r**16
            -145159*r**18-87547*r**20+1579*r**22))-552960*logq2**3*r**10*(-9-10*r**2
            +15*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+768*logq2*r**2*(120*Q2**11*(1
            +r**4)-Q2**10*(813+680*r**2-3*r**4+930*r**6)+2*Q2**9*(1128+1633*r**2
            +531*r**4+243*r**6+1425*r**8)-Q2**8*(3159+5992*r**2+6970*r**4-3740*r**6
            -1593*r**8+3900*r**10)+4*Q2**7*(504+1331*r**2+1657*r**4-6009*r**6-21043*r**8
            -5670*r**10+150*r**12)+2*Q2**6*(63-1598*r**2+5777*r**4+57906*r**6+144223*r**8
            +167494*r**10+35061*r**12+2730*r**14)-4*Q2**5*(252-692*r**2+5986*r**4
            +44389*r**6+110029*r**8+142318*r**10+127252*r**12+23913*r**14+1785*r**16)
            -(-1+r**2)**4*(-21-216*r**2-8644*r**4+11756*r**6+21542*r**8-61292*r**10
            -16172*r**12+38596*r**14+5631*r**16+180*r**18)+2*Q2**4*(297-758*r**2
            +12704*r**4+50046*r**6+101880*r**8+163742*r**10+112332*r**12+102394*r**14
            +23427*r**16+1200*r**18)+2*Q2*(-1+r**2)**2*(-48-553*r**2-18585*r**4
            +7162*r**6+15762*r**8-19976*r**10-102976*r**12-29834*r**14+99374*r**16
            +14529*r**18+585*r**20)+4*Q2**3*(-54-307*r**2-11075*r**4-7917*r**6
            -28339*r**8-14223*r**10-29073*r**12+24305*r**14+70085*r**16+7518*r**18
            +600*r**20)+Q2**2*(159+2036*r**2+57587*r**4-28378*r**6+133346*r**8
            +34784*r**10-154198*r**12+226076*r**14+278111*r**16-355828*r**18-52605*r**20
            -2850*r**22))*sqrtq2))/(-699840*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-1620*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+2799360*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+58320*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(flagPERP*(-4608*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(24*Q2**6-3*Q2**5*(33+23*r**2)
            +Q2**4*(130+167*r**2+45*r**4)-Q2**3*(55+78*r**2+53*r**4+15*r**6)+(
            -1+r**2)**2*(19-96*r**2-36*r**4-31*r**6+54*r**8)+Q2**2*(15-98*r**2
            -49*r**4-3*r**6+105*r**8)+Q2*(-34+242*r**2+177*r**4-8*r**6+127*r**8
            -144*r**10))-32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(4*Q2**10
            +Q2**9*(27+20*r**2)-Q2**8*(212+1345*r**2+169*r**4)+Q2**7*(397+5423*r**2
            +4807*r**4+377*r**6)-Q2**6*(251+5930*r**2+11452*r**4+5198*r**6+337*r**8)
            +Q2**5*(211-2431*r**2+1178*r**4+3670*r**6+119*r**8+41*r**10)+Q2**4*(
            -587+7970*r**2+11611*r**4+16520*r**6+2543*r**8+1858*r**10+125*r**12)
            -Q2**3*(-487+3575*r**2+6505*r**4+10603*r**6+7967*r**8-575*r**10-145*r**12
            +61*r**14)+(-1+r**2)**2*(115+121*r**2-345*r**4+14821*r**6-38699*r**8
            +18831*r**10-95*r**12+931*r**14)+Q2**2*(163-778*r**2+3074*r**4-13058*r**6
            -484*r**8+13682*r**10+790*r**12+938*r**14-7*r**16)+Q2*(-354+755*r**2
            -2072*r**4-7820*r**6+11756*r**8+54502*r**10-37832*r**12+620*r**14-2282*r**16
            +7*r**18))+138240*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            -192*logq2*r**4*(48*Q2**11*r**2+Q2**10*(5-402*r**2-366*r**4)+2*Q2**9*(
            -15+650*r**2+1185*r**4+564*r**6)-Q2**8*(-65+2012*r**2+5075*r**4+4990*r**6
            +1752*r**8)+4*Q2**7*(-10+319*r**2+707*r**4+606*r**6+1019*r**8+327*r**10)
            +Q2**6*(-70+368*r**2+4720*r**4+14416*r**6+9594*r**8-232*r**10-168*r**12)
            -4*Q2**5*(-35+251*r**2+2099*r**4+5657*r**6+5801*r**8+3137*r**10+205*r**12
            +105*r**14)+(-1+r**2)**4*(5+36*r**2-29*r**4+2106*r**6-4733*r**8-2968*r**10
            +3001*r**12+386*r**14+36*r**16)+2*Q2**4*(-35+230*r**2+2665*r**4+5046*r**6
            +1479*r**8+4390*r**10+5205*r**12+10*r**14+186*r**16)-4*Q2**3*(10+7*r**2
            +425*r**4+660*r**6-4219*r**8-4086*r**10+371*r**12+4980*r**14+325*r**16
            +87*r**18)-2*Q2*(-1+r**2)**2*(15+58*r**2-44*r**4+3572*r**6-7314*r**8
            -8904*r**10-3992*r**12+7040*r**14+839*r**16+90*r**18)+Q2**2*(65+34*r**2
            +142*r**4+7216*r**6-24722*r**8-8900*r**10-13172*r**12-20960*r**14+23041*r**16
            +2354*r**18+342*r**20))*sqrtq2)*math.log(mu0))/(-25920*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-60*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+103680*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+2160*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((4608*logq2**2*r**6*(24*Q2**8*(2
            +5*r**4)-3*Q2**7*(103+93*r**2+235*r**4+195*r**6)+Q2**6*(789+1125*r**2
            +2344*r**4+2075*r**6+1035*r**8)-3*Q2**5*(311+507*r**2+1147*r**4+1071*r**6
            +590*r**8+290*r**10)+(-1+r**2)**4*(-57+33*r**2-512*r**4-912*r**6-357*r**8
            +95*r**10+270*r**12)+3*Q2**4*(95+225*r**2+376*r**4+315*r**6+315*r**8
            +310*r**10+300*r**12)+Q2**3*(537-225*r**2+2863*r**4+5558*r**6+1860*r**8
            -428*r**10-1360*r**12-1845*r**14)-3*Q2*(-1+r**2)**2*(-107+71*r**2-864*r**4
            -1879*r**6-1484*r**8-192*r**10+195*r**12+420*r**14)+3*Q2**2*(-227+273*r**2
            -1554*r**4-2514*r**6-2774*r**8-1327*r**10-262*r**12-40*r**14+745*r**16))
            +32*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(28*Q2**12*r**2+8*Q2**11*r**2*(17
            +12*r**2)-Q2**10*(144+595*r**2+6562*r**4+1555*r**6)+Q2**9*(882-679*r**2
            +24181*r**4+34003*r**6+5685*r**8)-2*Q2**8*(999-3174*r**2+16810*r**4
            +43744*r**6+34091*r**8+5130*r**10)+4*Q2**7*(378-3579*r**2-2408*r**4
            +16929*r**6+20829*r**8+13010*r**10+2541*r**12)+2*Q2**6*(756+8955*r**2
            +85778*r**4+67443*r**6+46848*r**8+26603*r**10+6286*r**12-2541*r**14)
            +2*Q2**5*(-1890-5913*r**2-183595*r**4-182377*r**6-184963*r**8-58429*r**10
            -70627*r**12-21833*r**14+315*r**16)+2*(-1+r**2)**4*(-63-484*r**2-11632*r**4
            +45552*r**6-58534*r**8-63676*r**10+50640*r**12+1328*r**14+2309*r**16)
            +4*Q2**4*(567-264*r**2+71986*r**4+27402*r**6+52234*r**8+56296*r**10
            -30962*r**12+27186*r**14+7463*r**16+60*r**18)+Q2*(-1+r**2)**2*(738
            +4645*r**2+126385*r**4-335668*r**6+291944*r**8+682954*r**10+249938*r**12
            -436492*r**14-10634*r**16-20911*r**18+61*r**20)+4*Q2**3*(162+2423*r**2
            +12310*r**4+17547*r**6+70191*r**8+30919*r**10-109883*r**12-26719*r**14
            -15773*r**16-7162*r**18+65*r**20)-Q2**2*(1512+8347*r**2+213698*r**4
            -442333*r**6+522312*r**8+338306*r**10+919124*r**12+125490*r**14-538384*r**16
            -7549*r**18-34870*r**20+267*r**22))-276480*logq2**3*r**10*(3+5*r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+384*logq2*r**4*(120*Q2**11*r**2+Q2**10*(28
            -651*r**2-915*r**4)+Q2**9*(-141+1334*r**2+3939*r**4+2820*r**6)-Q2**8*(
            -367+655*r**2+6247*r**4+7829*r**6+4380*r**8)+2*Q2**7*(-430-3086*r**2
            -691*r**4-213*r**6+1721*r**8+1635*r**10)+Q2**6*(1708+22810*r**2+32366*r**4
            +38654*r**6+23526*r**8+8092*r**10-420*r**12)-2*Q2**5*(1015+16730*r**2
            +29291*r**4+39173*r**6+25007*r**8+11312*r**10+6211*r**12+525*r**14)
            +(-1+r**2)**4*(-113-2091*r**2+4289*r**4-5523*r**6-23113*r**8-365*r**10
            +8543*r**12+1003*r**14+90*r**16)+2*Q2**4*(413+8023*r**2+16382*r**4
            +12591*r**6+17544*r**8+7547*r**10+5748*r**12+4343*r**14+465*r**16)
            -2*Q2**3*(-434-6590*r**2+3935*r**4-28737*r**6-27061*r**8+4707*r**10
            +15833*r**12+19929*r**14+3583*r**16+435*r**18)-Q2*(-1+r**2)**2*(-627
            -11084*r**2+15172*r**4-24730*r**6-102258*r**8-71406*r**10+13036*r**12
            +38930*r**14+4277*r**16+450*r**18)+Q2**2*(-1280-20743*r**2+30665*r**4
            -68914*r**6-102646*r**8-117028*r**10-61000*r**12-1558*r**14+58526*r**16
            +6643*r**18+855*r**20))*sqrtq2)*math.log(mu0))/(-77760*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-180*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+311040*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+6480*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+FLAGcD*((-6*logq2*(24*Q2**6*(1
            +5*r**4)-Q2**5*(99+64*r**2+315*r**4+570*r**6)+Q2**4*(135+117*r**2
            +285*r**4+835*r**6+900*r**8)-2*Q2**3*(15+49*r**2+64*r**4+315*r**6
            +275*r**8+150*r**10)-(-1+r**2)**2*(21-89*r**2+506*r**4+2986*r**6-99*r**8
            -145*r**10+180*r**12)-2*Q2**2*(45-116*r**2+232*r**4+544*r**6-265*r**8
            -180*r**10+300*r**12)+Q2*(81-318*r**2+1207*r**4+6102*r**6+6587*r**8
            -14*r**10-835*r**12+630*r**14))+360*logq2**2*r**4*(3+10*r**2+15*r**4)*sqrtq2
            +(-6*Q2**8-4*Q2**7*(3+r**2)-2*Q2**6*(15+62*r**2+29*r**4)+3*Q2**5*(213
            +125*r**2+943*r**4+151*r**6)-Q2**4*(1455+256*r**2+2430*r**4+7200*r**6
            +835*r**8)+2*Q2**3*(393-302*r**2+1597*r**4+627*r**6+2110*r**8+223*r**10)
            +6*Q2**2*(142-373*r**2+436*r**4-746*r**6-790*r**8+727*r**10+44*r**12)
            +(-1+r**2)**2*(351-2656*r**2+9501*r**4+5656*r**6-4919*r**8+2040*r**10
            +107*r**12)-Q2*(1125-6209*r**2+15555*r**4+24657*r**6+13387*r**8-14463*r**10
            +5901*r**12+367*r**14))*sqrtq2)/(-360*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +2160*logq2**2*r**8*sqrtq2+15*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)
            +((120*logq2*(24*Q2**6*(1+5*r**4)-Q2**5*(99+64*r**2+315*r**4+570*r**6)
            +Q2**4*(135+117*r**2+285*r**4+835*r**6+900*r**8)-2*Q2**3*(15+49*r**2
            +64*r**4+315*r**6+275*r**8+150*r**10)-(-1+r**2)**2*(21-89*r**2+506*r**4
            +2986*r**6-99*r**8-145*r**10+180*r**12)-2*Q2**2*(45-116*r**2+232*r**4
            +544*r**6-265*r**8-180*r**10+300*r**12)+Q2*(81-318*r**2+1207*r**4
            +6102*r**6+6587*r**8-14*r**10-835*r**12+630*r**14))-7200*logq2**2*r**4*(3
            +10*r**2+15*r**4)*sqrtq2+20*(6*Q2**8+4*Q2**7*(3+r**2)+2*Q2**6*(15+62*r**2
            +29*r**4)-3*Q2**5*(213+125*r**2+943*r**4+151*r**6)+Q2**4*(1455+256*r**2
            +2430*r**4+7200*r**6+835*r**8)-2*Q2**3*(393-302*r**2+1597*r**4+627*r**6
            +2110*r**8+223*r**10)-6*Q2**2*(142-373*r**2+436*r**4-746*r**6-790*r**8
            +727*r**10+44*r**12)-(-1+r**2)**2*(351-2656*r**2+9501*r**4+5656*r**6
            -4919*r**8+2040*r**10+107*r**12)+Q2*(1125-6209*r**2+15555*r**4+24657*r**6
            +13387*r**8-14463*r**10+5901*r**12+367*r**14))*sqrtq2)*math.log(murhoD))/(
            -1944*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+11664*logq2**2*r**8*sqrtq2
            +81*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2))+FLAGcD*flagPERP*((-48*logq2*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-5+26*r**2-24*Q2**4*r**2+16*r**4
            -294*r**6-19*r**8+36*r**10+Q2**3*(-5+81*r**2+66*r**4)-Q2**2*(-5+34*r**2
            +151*r**4+24*r**6)+Q2*(5-39*r**2-11*r**4+59*r**6-54*r**8))+2880*logq2**2*r**6*(
            -1+3*r**2)*sqrtq2+8*(4*Q2**7*r**2+Q2**6*(-9+31*r**2+4*r**4)-3*Q2**5*(
            -13+47*r**2+217*r**4+21*r**6)+Q2**4*(-60+193*r**2+1827*r**4+1761*r**6
            +115*r**8)-2*Q2**3*(-15+46*r**2+625*r**4+1065*r**6+622*r**8+25*r**10)
            -(-1+r**2)**2*(-6-r**2-69*r**4+316*r**6-1454*r**8+477*r**10+17*r**12)
            -3*Q2**2*(-5+7*r**2+68*r**4+202*r**6-473*r**8+263*r**10+18*r**12)
            +Q2*(-21+37*r**2+201*r**4-933*r**6-203*r**8-3357*r**10+1335*r**12
            +61*r**14))*sqrtq2)/(-960*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+5760*logq2**2*r**8*sqrtq2
            +40*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((240*logq2*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(-5+26*r**2-24*Q2**4*r**2+16*r**4-294*r**6-19*r**8
            +36*r**10+Q2**3*(-5+81*r**2+66*r**4)-Q2**2*(-5+34*r**2+151*r**4+24*r**6)
            +Q2*(5-39*r**2-11*r**4+59*r**6-54*r**8))-14400*logq2**2*r**6*(-1+3*r**2)*sqrtq2
            +(25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*(-15+24*Q2**4-22*r**2-22*r**4-70*r**6
            +9*r**8-21*Q2**3*(1+r**2)+Q2**2*(-21+38*r**2-21*r**4)+Q2*(-15+29*r**2
            -43*r**4+9*r**6))-15*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(-3+5*Q2**3
            +5*r**2-19*r**4+5*r**6-5*Q2**2*(1+r**2)+Q2*(-5+8*r**2-5*r**4))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8)))*sqrtq2)*math.log(murhoD))/(
            -1296*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+7776*logq2**2*r**8*sqrtq2
            +54*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2))+(flagPERP*(4608*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(24*Q2**6-3*Q2**5*(33+23*r**2)+Q2**4*(130
            +167*r**2+45*r**4)-Q2**3*(55+78*r**2+53*r**4+15*r**6)+(-1+r**2)**2*(19
            -96*r**2-36*r**4-31*r**6+54*r**8)+Q2**2*(15-98*r**2-49*r**4-3*r**6
            +105*r**8)+Q2*(-34+242*r**2+177*r**4-8*r**6+127*r**8-144*r**10))
            +32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(4*Q2**10+Q2**9*(27+20*r**2)
            -Q2**8*(212+1345*r**2+169*r**4)+Q2**7*(397+5423*r**2+4807*r**4+377*r**6)
            -Q2**6*(251+5930*r**2+11452*r**4+5198*r**6+337*r**8)+Q2**5*(211-2431*r**2
            +1178*r**4+3670*r**6+119*r**8+41*r**10)+Q2**4*(-587+7970*r**2+11611*r**4
            +16520*r**6+2543*r**8+1858*r**10+125*r**12)-Q2**3*(-487+3575*r**2+6505*r**4
            +10603*r**6+7967*r**8-575*r**10-145*r**12+61*r**14)+(-1+r**2)**2*(115
            +121*r**2-345*r**4+14821*r**6-38699*r**8+18831*r**10-95*r**12+931*r**14)
            +Q2**2*(163-778*r**2+3074*r**4-13058*r**6-484*r**8+13682*r**10+790*r**12
            +938*r**14-7*r**16)+Q2*(-354+755*r**2-2072*r**4-7820*r**6+11756*r**8
            +54502*r**10-37832*r**12+620*r**14-2282*r**16+7*r**18))-138240*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+192*logq2*r**4*(48*Q2**11*r**2+Q2**10*(5
            -402*r**2-366*r**4)+2*Q2**9*(-15+650*r**2+1185*r**4+564*r**6)-Q2**8*(
            -65+2012*r**2+5075*r**4+4990*r**6+1752*r**8)+4*Q2**7*(-10+319*r**2
            +707*r**4+606*r**6+1019*r**8+327*r**10)+Q2**6*(-70+368*r**2+4720*r**4
            +14416*r**6+9594*r**8-232*r**10-168*r**12)-4*Q2**5*(-35+251*r**2+2099*r**4
            +5657*r**6+5801*r**8+3137*r**10+205*r**12+105*r**14)+(-1+r**2)**4*(5
            +36*r**2-29*r**4+2106*r**6-4733*r**8-2968*r**10+3001*r**12+386*r**14
            +36*r**16)+2*Q2**4*(-35+230*r**2+2665*r**4+5046*r**6+1479*r**8+4390*r**10
            +5205*r**12+10*r**14+186*r**16)-4*Q2**3*(10+7*r**2+425*r**4+660*r**6
            -4219*r**8-4086*r**10+371*r**12+4980*r**14+325*r**16+87*r**18)-2*Q2*(
            -1+r**2)**2*(15+58*r**2-44*r**4+3572*r**6-7314*r**8-8904*r**10-3992*r**12
            +7040*r**14+839*r**16+90*r**18)+Q2**2*(65+34*r**2+142*r**4+7216*r**6
            -24722*r**8-8900*r**10-13172*r**12-20960*r**14+23041*r**16+2354*r**18
            +342*r**20))*sqrtq2)*math.log(r))/(-25920*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-60*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+103680*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+2160*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((-4608*logq2**2*r**6*(24*Q2**8*(2
            +5*r**4)-3*Q2**7*(103+93*r**2+235*r**4+195*r**6)+Q2**6*(789+1125*r**2
            +2344*r**4+2075*r**6+1035*r**8)-3*Q2**5*(311+507*r**2+1147*r**4+1071*r**6
            +590*r**8+290*r**10)+(-1+r**2)**4*(-57+33*r**2-512*r**4-912*r**6-357*r**8
            +95*r**10+270*r**12)+3*Q2**4*(95+225*r**2+376*r**4+315*r**6+315*r**8
            +310*r**10+300*r**12)+Q2**3*(537-225*r**2+2863*r**4+5558*r**6+1860*r**8
            -428*r**10-1360*r**12-1845*r**14)-3*Q2*(-1+r**2)**2*(-107+71*r**2-864*r**4
            -1879*r**6-1484*r**8-192*r**10+195*r**12+420*r**14)+3*Q2**2*(-227+273*r**2
            -1554*r**4-2514*r**6-2774*r**8-1327*r**10-262*r**12-40*r**14+745*r**16))
            -32*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(28*Q2**12*r**2+8*Q2**11*r**2*(17
            +12*r**2)-Q2**10*(144+595*r**2+6562*r**4+1555*r**6)+Q2**9*(882-679*r**2
            +24181*r**4+34003*r**6+5685*r**8)-2*Q2**8*(999-3174*r**2+16810*r**4
            +43744*r**6+34091*r**8+5130*r**10)+4*Q2**7*(378-3579*r**2-2408*r**4
            +16929*r**6+20829*r**8+13010*r**10+2541*r**12)+2*Q2**6*(756+8955*r**2
            +85778*r**4+67443*r**6+46848*r**8+26603*r**10+6286*r**12-2541*r**14)
            +2*Q2**5*(-1890-5913*r**2-183595*r**4-182377*r**6-184963*r**8-58429*r**10
            -70627*r**12-21833*r**14+315*r**16)+2*(-1+r**2)**4*(-63-484*r**2-11632*r**4
            +45552*r**6-58534*r**8-63676*r**10+50640*r**12+1328*r**14+2309*r**16)
            +4*Q2**4*(567-264*r**2+71986*r**4+27402*r**6+52234*r**8+56296*r**10
            -30962*r**12+27186*r**14+7463*r**16+60*r**18)+Q2*(-1+r**2)**2*(738
            +4645*r**2+126385*r**4-335668*r**6+291944*r**8+682954*r**10+249938*r**12
            -436492*r**14-10634*r**16-20911*r**18+61*r**20)+4*Q2**3*(162+2423*r**2
            +12310*r**4+17547*r**6+70191*r**8+30919*r**10-109883*r**12-26719*r**14
            -15773*r**16-7162*r**18+65*r**20)-Q2**2*(1512+8347*r**2+213698*r**4
            -442333*r**6+522312*r**8+338306*r**10+919124*r**12+125490*r**14-538384*r**16
            -7549*r**18-34870*r**20+267*r**22))+276480*logq2**3*r**10*(3+5*r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-384*logq2*r**4*(120*Q2**11*r**2+Q2**10*(28
            -651*r**2-915*r**4)+Q2**9*(-141+1334*r**2+3939*r**4+2820*r**6)-Q2**8*(
            -367+655*r**2+6247*r**4+7829*r**6+4380*r**8)+2*Q2**7*(-430-3086*r**2
            -691*r**4-213*r**6+1721*r**8+1635*r**10)+Q2**6*(1708+22810*r**2+32366*r**4
            +38654*r**6+23526*r**8+8092*r**10-420*r**12)-2*Q2**5*(1015+16730*r**2
            +29291*r**4+39173*r**6+25007*r**8+11312*r**10+6211*r**12+525*r**14)
            +(-1+r**2)**4*(-113-2091*r**2+4289*r**4-5523*r**6-23113*r**8-365*r**10
            +8543*r**12+1003*r**14+90*r**16)+2*Q2**4*(413+8023*r**2+16382*r**4
            +12591*r**6+17544*r**8+7547*r**10+5748*r**12+4343*r**14+465*r**16)
            -2*Q2**3*(-434-6590*r**2+3935*r**4-28737*r**6-27061*r**8+4707*r**10
            +15833*r**12+19929*r**14+3583*r**16+435*r**18)-Q2*(-1+r**2)**2*(-627
            -11084*r**2+15172*r**4-24730*r**6-102258*r**8-71406*r**10+13036*r**12
            +38930*r**14+4277*r**16+450*r**18)+Q2**2*(-1280-20743*r**2+30665*r**4
            -68914*r**6-102646*r**8-117028*r**10-61000*r**12-1558*r**14+58526*r**16
            +6643*r**18+855*r**20))*sqrtq2)*math.log(r))/(-77760*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-180*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+311040*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+6480*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((12*logq2*(24*Q2**6*(2
            +5*r**4)-Q2**5*(168+133*r**2+540*r**4+795*r**6)-2*Q2**3*r**2*(73+268*r**2
            +570*r**4+590*r**6+375*r**8)+Q2**4*(180+159*r**2+645*r**4+1825*r**6
            +1575*r**8)-(-1+r**2)**2*(12+37*r**2+2117*r**4+3922*r**6-558*r**8
            -415*r**10+405*r**12)-2*Q2**2*(60-167*r**2+799*r**4+538*r**6-700*r**8
            -135*r**10+525*r**12)+Q2*(72-201*r**2+4924*r**4+10719*r**6+7964*r**8
            -1103*r**10-1600*r**12+1305*r**14))-720*logq2**2*r**4*(12+19*r**2+15*r**4)*sqrtq2
            +(120*Q2**9-3*Q2**8*(87+155*r**2)+Q2**7*(258+596*r**2+450*r**4)+Q2**6*(420
            -514*r**2-808*r**4+390*r**6)-6*Q2**5*(441+230*r**2+1306*r**4-98*r**6
            +145*r**8)+2*Q2**4*(1905+622*r**2+6030*r**4+13410*r**6+955*r**8+90*r**10)
            +2*Q2**3*(-477-362*r**2-6203*r**4-3468*r**6-8555*r**8-1802*r**10+195*r**12)
            -6*Q2**2*(378-1147*r**2+1784*r**4-3549*r**6-2410*r**8+3143*r**10-64*r**12
            +25*r**14)+(-1+r**2)**2*(-549+3179*r**2-33609*r**4-12869*r**6+18541*r**8
            -6915*r**10-943*r**12+45*r**14)+Q2*(2070-9916*r**2+66480*r**4+75468*r**6
            +27908*r**8-53892*r**10+22224*r**12+2228*r**14-90*r**16))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(19440*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+45*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-77760*logq2**3*r**12*sqrtq2
            -1620*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(flagPERP*(24*logq2*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-10-11*r**2-36*Q2**4*r**2+14*r**4
            -1326*r**6-416*r**8+189*r**10+2*Q2**3*(-5+132*r**2+117*r**4)-Q2**2*(
            -10+191*r**2+524*r**4+171*r**6)-2*Q2*(-5+93*r**2+2*r**4-68*r**6
            +108*r**8))-720*logq2**2*r**6*(-4+21*r**2+9*r**4)*sqrtq2+(5*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(-15+24*Q2**4-22*r**2-22*r**4-70*r**6+9*r**8
            -21*Q2**3*(1+r**2)+Q2**2*(-21+38*r**2-21*r**4)+Q2*(-15+29*r**2-43*r**4
            +9*r**6))-6*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(-3+5*Q2**3+5*r**2-19*r**4
            +5*r**6-5*Q2**2*(1+r**2)+Q2*(-5+8*r**2-5*r**4))*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(25920*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+60*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-103680*logq2**3*r**12*sqrtq2
            -2160*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(flagPERP*((Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(-3+5*Q2**3+5*r**2-19*r**4+5*r**6-5*Q2**2*(1
            +r**2)+Q2*(-5+8*r**2-5*r**4))-12*logq2*r**4*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(
            -48*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+288*logq2**2*r**8*sqrtq2+2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2)+((-2*(5*Q2**5-Q2**4*(7+15*r**2)+2*Q2**3*(4
            +2*r**2+5*r**4)+(-1+r**2)**2*(17+r**2-11*r**4+5*r**6)+2*Q2**2*(7
            -6*r**2-4*r**4+5*r**6)-Q2*(37+20*r**2+8*r**4-32*r**6+15*r**8))-24*logq2*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(
            -72*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+432*logq2**2*r**8*sqrtq2+3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2)+((180*logq2*r**4*(1+r**2)+(-3-8*Q2**4
            +42*r**2+282*r**4+42*r**6-3*r**8+7*Q2**3*(1+r**2)+Q2**2*(7-2*r**2
            +7*r**4)-3*Q2*(1-11*r**2-11*r**4+r**6))*sqrtq2)*nlopw.X1Q2RhoD(0,Q2,r))/(1440*logq2**2*r**8
            +10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-240*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+nlopw.X1Q2RhoD(1,Q2,r)/(
            -12*logq2*r**4+(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)))
        if( flagDEBUG == 1):
            print("Q2moment n. 1 NLO pw = api*",resNLO*par.mbkin**2)
        res += api*resNLO

    if(kwargs.get('flag_includeNNLO', 1) == 1):
        resNNLO = 0
        resNNLO +=((flagPERP*muWC**5*(-18432*logq2**2*(-Q2+(-1+r)**2)*r**8*(-Q2+(1+r)**2)*(
            -84*Q2**6*r**2+3*Q2**5*(5+98*r**2+133*r**4)-Q2**4*(35+390*r**2+877*r**4
            +630*r**6)+Q2**3*(20+155*r**2+523*r**4+748*r**6+210*r**8)+Q2**2*r**2*(40
            -147*r**2-76*r**4-357*r**6+420*r**8)+(-1+r**2)**2*(-5+76*r**2-219*r**4
            -274*r**6-64*r**8+126*r**10)+Q2*(5-101*r**2+428*r**4+853*r**6+188*r**8
            +508*r**10-441*r**12))+128*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(
            -4*Q2**10*r**2+Q2**9*(-27+67*r**2)+Q2**8*(150-143*r**2-902*r**4+71*r**6)
            +Q2**7*(-348+82*r**2+2978*r**4+3370*r**6-178*r**8)+2*Q2**6*(222-487*r**2
            -788*r**4-3778*r**6-1754*r**8+49*r**10)+2*Q2**5*(-177+1658*r**2+2681*r**4
            -14216*r**6-1981*r**8-2296*r**10+91*r**12)-4*Q2**4*(-48+938*r**2+3982*r**4
            -13789*r**6-30484*r**8-6827*r**10-3082*r**12+70*r**14)+2*Q2**3*(-30
            +659*r**2+5887*r**4-21091*r**6-36791*r**8-56731*r**10-10903*r**12-3149*r**14
            +37*r**16)+(-1+r**2)**2*(-6-189*r**2-262*r**4+1490*r**6-32826*r**8
            +85772*r**10-30490*r**12-4722*r**14-1504*r**16+17*r**18)+2*Q2**2*(-6
            +29*r**2-388*r**4+2236*r**6-9844*r**8+26594*r**10-23564*r**12-1516*r**14
            -2230*r**16+49*r**18)+Q2*(21+209*r**2-1042*r**4+13276*r**6-36310*r**8
            +72530*r**10-222176*r**12+90980*r**14+7937*r**16+5533*r**18-78*r**20))
            +552960*logq2**3*r**12*(1+3*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            +768*logq2*r**4*(24*Q2**11*r**2+Q2**10*(25-219*r**2-186*r**4)+2*Q2**9*(
            -65+303*r**2+741*r**4+285*r**6)-Q2**8*(-245+1339*r**2+1633*r**4+3165*r**6
            +780*r**8)+8*Q2**7*(-20+470*r**2-531*r**4-1919*r**6-39*r**8+15*r**10)
            +2*Q2**6*(-35-3805*r**2+6846*r**4+34444*r**6+36841*r**8+6003*r**10
            +546*r**12)-4*Q2**5*(-35-2147*r**2+4741*r**4+24229*r**6+37891*r**8
            +29377*r**10+4947*r**12+357*r**14)-(-1+r**2)**4*(15-r**2+71*r**4+4667*r**6
            -10787*r**8-11087*r**10+7369*r**12+1077*r**14+36*r**16)+2*Q2**4*(-35
            -2473*r**2+7239*r**4+29277*r**6+39989*r**8+50883*r**10+29047*r**12
            +5289*r**14+240*r**16)+8*Q2**3*(10+113*r**2-399*r**4-983*r**6-2277*r**8
            -585*r**10-4985*r**12+5491*r**14+675*r**16+60*r**18)+2*Q2*(-1+r**2)**2*(35
            -87*r**2+700*r**4+5988*r**6-15278*r**8-25606*r**10-22124*r**12+18884*r**14
            +2811*r**16+117*r**18)+Q2**2*(-115+485*r**2-3082*r**4-9400*r**6+44510*r**8
            +65462*r**10+10052*r**12+106424*r**14-65323*r**16-10203*r**18-570*r**20))*sqrtq2))/(
            -699840*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))-1620*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3+2799360*logq2**3*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            +58320*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)+(flagPERP*muWC**4*(-147456*logq2**2*(-Q2+(-1+r)**2)*r**8*(
            -Q2+(1+r)**2)*(-84*Q2**6*r**2+3*Q2**5*(5+98*r**2+133*r**4)-Q2**4*(35
            +390*r**2+877*r**4+630*r**6)+Q2**3*(20+155*r**2+523*r**4+748*r**6
            +210*r**8)+Q2**2*r**2*(40-147*r**2-76*r**4-357*r**6+420*r**8)+(-1
            +r**2)**2*(-5+76*r**2-219*r**4-274*r**6-64*r**8+126*r**10)+Q2*(5-101*r**2
            +428*r**4+853*r**6+188*r**8+508*r**10-441*r**12))+1024*(Q2-(-1+r)**2)**2*r**2*(Q2
            -(1+r)**2)**2*(-4*Q2**10*r**2+Q2**9*(-27+67*r**2)+Q2**8*(150-143*r**2
            -902*r**4+71*r**6)+Q2**7*(-348+82*r**2+2978*r**4+3370*r**6-178*r**8)
            +2*Q2**6*(222-487*r**2-788*r**4-3778*r**6-1754*r**8+49*r**10)+2*Q2**5*(
            -177+1658*r**2+2681*r**4-14216*r**6-1981*r**8-2296*r**10+91*r**12)
            -4*Q2**4*(-48+938*r**2+3982*r**4-13789*r**6-30484*r**8-6827*r**10-3082*r**12
            +70*r**14)+2*Q2**3*(-30+659*r**2+5887*r**4-21091*r**6-36791*r**8-56731*r**10
            -10903*r**12-3149*r**14+37*r**16)+(-1+r**2)**2*(-6-189*r**2-262*r**4
            +1490*r**6-32826*r**8+85772*r**10-30490*r**12-4722*r**14-1504*r**16
            +17*r**18)+2*Q2**2*(-6+29*r**2-388*r**4+2236*r**6-9844*r**8+26594*r**10
            -23564*r**12-1516*r**14-2230*r**16+49*r**18)+Q2*(21+209*r**2-1042*r**4
            +13276*r**6-36310*r**8+72530*r**10-222176*r**12+90980*r**14+7937*r**16
            +5533*r**18-78*r**20))+4423680*logq2**3*r**12*(1+3*r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2+6144*logq2*r**4*(24*Q2**11*r**2+Q2**10*(25-219*r**2
            -186*r**4)+2*Q2**9*(-65+303*r**2+741*r**4+285*r**6)-Q2**8*(-245+1339*r**2
            +1633*r**4+3165*r**6+780*r**8)+8*Q2**7*(-20+470*r**2-531*r**4-1919*r**6
            -39*r**8+15*r**10)+2*Q2**6*(-35-3805*r**2+6846*r**4+34444*r**6+36841*r**8
            +6003*r**10+546*r**12)-4*Q2**5*(-35-2147*r**2+4741*r**4+24229*r**6
            +37891*r**8+29377*r**10+4947*r**12+357*r**14)-(-1+r**2)**4*(15-r**2
            +71*r**4+4667*r**6-10787*r**8-11087*r**10+7369*r**12+1077*r**14+36*r**16)
            +2*Q2**4*(-35-2473*r**2+7239*r**4+29277*r**6+39989*r**8+50883*r**10
            +29047*r**12+5289*r**14+240*r**16)+8*Q2**3*(10+113*r**2-399*r**4-983*r**6
            -2277*r**8-585*r**10-4985*r**12+5491*r**14+675*r**16+60*r**18)+2*Q2*(
            -1+r**2)**2*(35-87*r**2+700*r**4+5988*r**6-15278*r**8-25606*r**10-22124*r**12
            +18884*r**14+2811*r**16+117*r**18)+Q2**2*(-115+485*r**2-3082*r**4-9400*r**6
            +44510*r**8+65462*r**10+10052*r**12+106424*r**14-65323*r**16-10203*r**18
            -570*r**20))*sqrtq2))/(-2099520*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-4860*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+8398080*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+174960*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(muWC**5*(18432*logq2**2*r**6*(
            -12*Q2**8*(3+35*r**4)+3*Q2**7*(76+131*r**2+670*r**4+945*r**6)-Q2**6*(543
            +1655*r**2+5223*r**4+8575*r**6+7560*r**8)+3*Q2**5*(222+749*r**2+2174*r**4
            +3952*r**6+3780*r**8+3115*r**10)+(-1+r**2)**4*(-111+49*r**2-581*r**4
            +99*r**6-526*r**8+80*r**10+630*r**12)-3*Q2**4*(215+415*r**2+1107*r**4
            +1915*r**6+2380*r**8+750*r**10+1050*r**12)+Q2**3*(816+415*r**2+4254*r**4
            +4139*r**6-2180*r**8+1641*r**10-3250*r**12-5355*r**14)-3*Q2*(-1+r**2)**2*(
            -166-7*r**2-1122*r**4-747*r**6+358*r**8-441*r**10+10*r**12+1155*r**14)
            +3*Q2**2*(-291+109*r**2-2067*r**4-1787*r**6+263*r**8+1499*r**10-781*r**12
            -1245*r**14+2380*r**16))-128*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(
            -6*Q2**13+2*Q2**12*(39+7*r**2)+Q2**11*(90+72*r**2-58*r**4)+Q2**10*(
            -3741-671*r**2-3851*r**4+607*r**6)-4*Q2**9*(-3945-2778*r**2+502*r**4
            -4952*r**6+575*r**8)+Q2**8*(-28509-35121*r**2-14642*r**4+15302*r**6
            -40441*r**8+3747*r**10)+Q2**7*(21972+49380*r**2+40252*r**4-78480*r**6
            -89676*r**8+9164*r**10-1668*r**12)+Q2**6*(1182-58986*r**2+48622*r**4
            +490982*r**6+793086*r**8+269310*r**10+107702*r**12-3354*r**14)+2*Q2**5*(
            -6591+38010*r**2-71608*r**4-440822*r**6-771002*r**8-921626*r**10-168968*r**12
            -97178*r**14+2793*r**16)+4*Q2**4*(2025-13758*r**2+30244*r**4+129972*r**6
            +197573*r**8+144563*r**10+320642*r**12+20442*r**14+29228*r**16-675*r**18)
            +(-1+r**2)**4*(603-3177*r**2+72164*r**4-224116*r**6+120462*r**8+261086*r**10
            -176644*r**12-25260*r**14-7945*r**16+107*r**18)-4*Q2*(-1+r**2)**2*(648
            -1925*r**2+65336*r**4-111692*r**6-68524*r**8+178406*r**10+237916*r**12
            -227380*r**14-27292*r**16-11105*r**18+172*r**20)-2*Q2**3*(1815-5138*r**2
            +88585*r**4+94676*r**6+33850*r**8+389696*r**10-242554*r**12-356436*r**14
            -91089*r**16-17518*r**18+433*r**20)+Q2**2*(3855-4359*r**2+321941*r**4
            -340021*r**6+320498*r**8-776754*r**10+673574*r**12+1780298*r**14-1471425*r**16
            -145159*r**18-87547*r**20+1579*r**22))+552960*logq2**3*r**10*(-9-10*r**2
            +15*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-768*logq2*r**2*(120*Q2**11*(1
            +r**4)-Q2**10*(813+680*r**2-3*r**4+930*r**6)+2*Q2**9*(1128+1633*r**2
            +531*r**4+243*r**6+1425*r**8)-Q2**8*(3159+5992*r**2+6970*r**4-3740*r**6
            -1593*r**8+3900*r**10)+4*Q2**7*(504+1331*r**2+1657*r**4-6009*r**6-21043*r**8
            -5670*r**10+150*r**12)+2*Q2**6*(63-1598*r**2+5777*r**4+57906*r**6+144223*r**8
            +167494*r**10+35061*r**12+2730*r**14)-4*Q2**5*(252-692*r**2+5986*r**4
            +44389*r**6+110029*r**8+142318*r**10+127252*r**12+23913*r**14+1785*r**16)
            -(-1+r**2)**4*(-21-216*r**2-8644*r**4+11756*r**6+21542*r**8-61292*r**10
            -16172*r**12+38596*r**14+5631*r**16+180*r**18)+2*Q2**4*(297-758*r**2
            +12704*r**4+50046*r**6+101880*r**8+163742*r**10+112332*r**12+102394*r**14
            +23427*r**16+1200*r**18)+2*Q2*(-1+r**2)**2*(-48-553*r**2-18585*r**4
            +7162*r**6+15762*r**8-19976*r**10-102976*r**12-29834*r**14+99374*r**16
            +14529*r**18+585*r**20)+4*Q2**3*(-54-307*r**2-11075*r**4-7917*r**6
            -28339*r**8-14223*r**10-29073*r**12+24305*r**14+70085*r**16+7518*r**18
            +600*r**20)+Q2**2*(159+2036*r**2+57587*r**4-28378*r**6+133346*r**8
            +34784*r**10-154198*r**12+226076*r**14+278111*r**16-355828*r**18-52605*r**20
            -2850*r**22))*sqrtq2))/(-2099520*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-4860*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+8398080*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+174960*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(16*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(2593*Q2**11-Q2**10*(2593+545*r**2)
            +Q2**9*(44081+113828*r**2-65651*r**4)+Q2**8*(-313753-2800793*r**2-665081*r**4
            +241447*r**6)+Q2**7*(689738+9875488*r**2+9130680*r**4+1498064*r**6-358430*r**8)
            +2*Q2**6*(-199661-4812305*r**2-8199376*r**4-4423568*r**6-562685*r**8
            +89831*r**10)+2*Q2**5*(-308567-4002484*r**2+7968605*r**4+6153928*r**6
            +1659821*r**8-514300*r**10+69713*r**12)-2*Q2**4*(-516007-10289771*r**2
            +18552189*r**4+25270073*r**6+16413493*r**8+3525609*r**10-1174591*r**12
            +108757*r**14)+Q2**3*(-360427-8070112*r**2+37010992*r**4+30497072*r**6
            +59047838*r**8+22721344*r**10+8222336*r**12-1041424*r**14+58813*r**16)
            +3*(-1+r**2)**2*(-18151-661581*r**2+5865366*r**4-11713638*r**6-5105364*r**8
            -7808580*r**10-3500550*r**12+590838*r**14-54453*r**16+2593*r**18)+Q2**2*(
            -261893-7884413*r**2+27443896*r**4+11608264*r**6+10857562*r**8+4327258*r**10
            +1754392*r**12+2241928*r**14-622469*r**16+51315*r**18)+3*Q2*(80383
            +2564140*r**2-18933349*r**4+25184144*r**6+20035202*r**8+38525624*r**10
            +18361802*r**12+5696816*r**14-2122177*r**16+234460*r**18-12965*r**20))
            -16*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(2593*Q2**12-2*Q2**11*(2593
            +1569*r**2)+Q2**10*(46674+116966*r**2-65106*r**4)+Q2**9*(-357834-2958702*r**2
            -713258*r**4+307098*r**6)+Q2**8*(1003491+12990034*r**2+12596554*r**4
            +1921698*r**6-599877*r**8)+4*Q2**7*(-272265-5047459*r**2-8851230*r**4
            -4868970*r**6-566251*r**8+134523*r**10)-4*Q2**6*(54453-504741*r**2-10490143*r**4
            -9388436*r**6-3323037*r**8+20723*r**10+10059*r**12)-4*Q2**5*(-412287
            -7300411*r**2+11259155*r**4+19696303*r**6+12113621*r**8+2335565*r**10
            -809589*r**12+89235*r**14)+Q2**4*(-1392441-29681668*r**2+53535828*r**4
            +118141596*r**6+142414970*r**8+62599548*r**10+12924372*r**12-3173092*r**14
            +276327*r**16)-2*Q2**3*(-49267-273063*r**2+748492*r**4+27949900*r**6
            +39343674*r**8+38720962*r**10+14594644*r**12+2469492*r**14-180071*r**16
            +3749*r**18)+2*Q2**2*(251521+7919363*r**2-38179765*r**4+18250136*r**6
            +18819890*r**8+50196026*r**10+24501878*r**12+6547064*r**14-3992995*r**16
            +637267*r**18-45105*r**20)-3*(-1+r**2)**2*(-18151-679732*r**2+5203785*r**4
            -5848272*r**6-16819002*r**8-12913944*r**10-11309130*r**12-2909712*r**14
            +536385*r**16-51860*r**18+2593*r**20)+6*Q2*(-49267-1634901*r**2+11769793*r**4
            -15178373*r**6-10516034*r**8-33936158*r**10-24938090*r**12-12137630*r**14
            -4155659*r**16+1295027*r**18-140567*r**20+7779*r**22))*sqrtq2+logq2**3*(
            -1075368960*r**18*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3
            -1075368960*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**2*(
            -2304*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(16912*Q2**6-Q2**5*(80332
            +180667*r**2)+Q2**4*(126840+520861*r**2+397125*r**4)-2*Q2**3*(21140
            +172492*r**2+133597*r**4+129650*r**6)+3*(-1+r**2)**2*(-8456-15971*r**2
            +295189*r**4+191469*r**6+4509*r**8)-2*Q2**2*(42280+73562*r**2-222519*r**4
            -198703*r**6+10570*r**8)+3*Q2*(29596+49697*r**2-558998*r**4-1005258*r**6
            -393178*r**8+11181*r**10))+2304*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(16912*Q2**7
            -Q2**6*(97244+197579*r**2)+4*Q2**5*(51793+195465*r**2+144448*r**4)-5*Q2**4*(33824
            +198537*r**2+237036*r**4+131285*r**6)+4*Q2**3*(-10570+60035*r**2+264304*r**4
            +230975*r**6+59540*r**8)-3*(-1+r**2)**2*(-8456-24427*r**2+279218*r**4
            +486658*r**6+195978*r**8+4509*r**10)+Q2**2*(173348+380775*r**2-1974908*r**4
            -3858218*r**6-1555800*r**8+54683*r**10)-12*Q2*(9513+19588*r**2-206994*r**4
            -287344*r**6-328799*r**8-141112*r**10+1668*r**12))*sqrtq2)+logq2*(-576*r**8*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-16560*Q2**9-186300*Q2**7*(1
            +r**2)**2+Q2**8*(95220+94719*r**2)+4*Q2**6*(17595+119658*r**2+104777*r**4
            +32476*r**6)+4*Q2**5*(61065-64329*r**2-266053*r**4-126341*r**6+7118*r**8)
            +Q2**4*(-335340+206610*r**2+2665784*r**4+3560824*r**6+1058340*r**8-73230*r**10)
            +4*Q2**3*(17595-22296*r**2-502049*r**4-627912*r**6-611683*r**8-200140*r**10
            +4349*r**12)+(-1+r**2)**2*(24840-123489*r**2-565402*r**4+2764381*r**6
            +2077236*r**8+1485661*r**10-63850*r**12+1503*r**14)+4*Q2**2*(36225-101490*r**2
            -248859*r**4-87926*r**6+141839*r**8+73116*r**10-36445*r**12+2560*r**14)
            -12*Q2*(9315-43189*r**2-121903*r**4+382689*r**6+809561*r**8+655401*r**10
            +201115*r**12-26541*r**14+512*r**16))+576*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(16560*Q2**9+186300*Q2**7*(1+r**2)**2-3*Q2**8*(31740+31573*r**2)
            -4*Q2**6*(17595+119658*r**2+104777*r**4+32476*r**6)-4*Q2**5*(61065-64329*r**2
            -266053*r**4-126341*r**6+7118*r**8)+2*Q2**4*(167670-103305*r**2-1332892*r**4
            -1780412*r**6-529170*r**8+36615*r**10)+4*Q2**3*(-17595+22296*r**2+502049*r**4
            +627912*r**6+611683*r**8+200140*r**10-4349*r**12)-(-1+r**2)**2*(24840
            -123489*r**2-565402*r**4+2764381*r**6+2077236*r**8+1485661*r**10-63850*r**12
            +1503*r**14)-4*Q2**2*(36225-101490*r**2-248859*r**4-87926*r**6+141839*r**8
            +73116*r**10-36445*r**12+2560*r**14)+12*Q2*(9315-43189*r**2-121903*r**4
            +382689*r**6+809561*r**8+655401*r**10+201115*r**12-26541*r**14+512*r**16))*sqrtq2))/(23040*(
            -Q2+(-1+r)**2)**3*r**4*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +23040*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(-39813120*r**16*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3-39813120*r**16*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*sqrtq2)+logq2**2*(9953280*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+9953280*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(
            -829440*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-829440*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2))+(muWC**4*(32*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-687*Q2**13+Q2**12*(10389+1549*r**2)+Q2**11*(3744
            +17478*r**2-5804*r**4)+2*Q2**10*(-220470-71213*r**2-371285*r**4+32530*r**6)
            +Q2**9*(1921425+1628238*r**2+947122*r**4+3848758*r**6-251875*r**8)+Q2**8*(
            -3490959-4985781*r**2-4275664*r**4-1738832*r**6-7883549*r**8+414249*r**10)
            -4*Q2**7*(-661794-1779987*r**2-2093042*r**4+2043180*r**6+2205432*r**8
            -658639*r**10+46572*r**12)-4*Q2**6*(-66012+2108115*r**2-386183*r**4
            -16173610*r**6-27795954*r**8-9369843*r**10-4316809*r**12+92748*r**14)
            +Q2**5*(-1737597+10374348*r**2-12254380*r**4-115512740*r**6-206198870*r**8
            -256636292*r**10-45783980*r**12-31569140*r**14+619995*r**16)+Q2**4*(1054215
            -7361373*r**2+10856912*r**4+70862640*r**6+102090334*r**8+71058622*r**10
            +178046272*r**12+6544608*r**14+18562027*r**16-299025*r**18)+(-1+r**2)**4*(77427
            -411759*r**2+9110146*r**4-29014898*r**6+11281332*r**8+40117060*r**10
            -27114194*r**12-2683614*r**14-1261175*r**16+11995*r**18)-2*Q2**3*(236532
            -725623*r**2+10516406*r**4+13305664*r**6+1386020*r**8+52670566*r**10
            -36090296*r**12-50249232*r**14-12562056*r**16-3005567*r**18+49106*r**20)
            -Q2*(-1+r**2)**2*(333477-1013788*r**2+33141721*r**4-59421904*r**6-47509850*r**8
            +89265736*r**10+140267870*r**12-135986864*r**14-11160779*r**16-7094188*r**18
            +77129*r**20)+2*Q2**2*(249150-315021*r**2+20435663*r**4-22959334*r**6
            +14329952*r**8-54632034*r**10+38262830*r**12+128254688*r**14-109297950*r**16
            -6470161*r**18-7047805*r**20+88582*r**22))+32*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(687*Q2**14-52*Q2**13*(213+43*r**2)+Q2**12*(6645-5540*r**2
            +7353*r**4)+Q2**11*(444684+163648*r**2+754244*r**4-70864*r**6)+Q2**10*(
            -2362365-2211604*r**2-1832118*r**4-4526268*r**6+316935*r**8)+Q2**9*(5412384
            +8535444*r**2+6851024*r**4+6534712*r**6+11480432*r**8-666124*r**10)
            +Q2**8*(-6138135-15596688*r**2-17633613*r**4+2158224*r**6-800653*r**8
            -10103856*r**10+600537*r**12)+8*Q2**7*(297891+2274948*r**2+1743423*r**4
            -8061874*r**6-16022283*r**8-5458318*r**10-1852371*r**12+23088*r**14)
            +Q2**6*(2001645-18542760*r**2+5366652*r**4+181751912*r**6+382077126*r**8
            +405299480*r**10+100530588*r**12+48465384*r**14-990987*r**16)+4*Q2**5*(
            -697953+3999531*r**2-3184236*r**4-49657440*r**6-105950486*r**8-133473446*r**10
            -120116636*r**12-20974432*r**14-12377793*r**16+229755*r**18)+Q2**4*(1527279
            -7758404*r**2+24528351*r**4+108330880*r**6+175725014*r**8+278490088*r**10
            +176924302*r**12+84092416*r**14-17477*r**16+12251868*r**18-200813*r**20)
            +(-1+r**2)**4*(77427-334332*r**2+8698387*r**4-19904752*r**6-17733566*r**8
            +51398392*r**10+13002866*r**12-29797808*r**14-3944789*r**16-1249180*r**18
            +11995*r**20)-4*Q2*(-1+r**2)**2*(102726-311731*r**2+10534756*r**4-18481783*r**6
            -7127620*r**8+7573846*r**10+33366656*r**12+23985710*r**14-42538946*r**16
            -4601059*r**18-2075556*r**20+22281*r**22)-4*Q2**3*(242841-402056*r**2
            +15113223*r**4+431368*r**6+14510818*r**8-287724*r**10+27421550*r**12
            +20957580*r**14-86054619*r**16-11018892*r**18-5002133*r**20+68844*r**22)
            +Q2**2*(831777-1812484*r**2+75744058*r**4-131766476*r**6+87216915*r**8
            +44259368*r**10-118511860*r**12+5778168*r**14+438994295*r**16-352295716*r**18
            -23931206*r**20-21166892*r**22+254293*r**24))*sqrtq2+logq2**3*(-276480*r**12*(1
            -Q2+r**2)*(-576-640*r**2+1203*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3
            -276480*r**12*(-576-640*r**2+1203*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*sqrtq2)+logq2**2*(-4608*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -48*Q2**8*(96+1255*r**4)+3*Q2**7*(9728+16768*r**2+93455*r**4+135540*r**6)
            -Q2**6*(69504+211840*r**2+691629*r**4+1188725*r**6+1084320*r**8)+3*Q2**5*(28416
            +95872*r**2+276517*r**4+523676*r**6+515025*r**8+446780*r**10)+(-1
            +r**2)**4*(-14208+6272*r**2-63433*r**4+23607*r**6-46673*r**8+1735*r**10
            +90360*r**12)-3*Q2**4*(27520+53120*r**2+132381*r**4+250385*r**6+306665*r**8
            +86685*r**10+150600*r**12)+Q2**3*(104448+53120*r**2+501987*r**4+486052*r**6
            -417550*r**8+161448*r**10-448805*r**12-768060*r**14)-3*Q2*(-1+r**2)**2*(
            -21248-896*r**2-130251*r**4-70506*r**6+93614*r**8-29718*r**10-12895*r**12
            +165660*r**14)+3*Q2**2*(-37248+13952*r**2-246081*r**4-201601*r**6+112234*r**8
            +261802*r**10-56633*r**12-200265*r**14+341360*r**16))-4608*r**8*(48*Q2**11*(96
            +1255*r**4)-3*Q2**10*(14336+21376*r**2+153695*r**4+195780*r**6)+20*Q2**9*(8544
            +22976*r**2+93909*r**4+168508*r**6+124245*r**8)-15*Q2**8*(25728+89088*r**2
            +308323*r**4+605864*r**6+663887*r**8+391560*r**10)+20*Q2**7*(28800+103680*r**2
            +332830*r**4+682149*r**6+866846*r**8+726243*r**10+406620*r**12)+(-1
            +r**2)**6*(-14208-7936*r**2-57161*r**4-39826*r**6-23066*r**8-44938*r**10
            +92095*r**12+90360*r**14)-2*Q2**6*(338688+977280*r**2+2950705*r**4+5760370*r**6
            +7138820*r**8+6972218*r**10+4553535*r**12+2846340*r**14)-12*Q2**5*(-63168
            -106368*r**2-384840*r**4-636155*r**6-396220*r**8-197808*r**10-219078*r**12
            +96775*r**14+52710*r**16)-4*Q2*(-1+r**2)**4*(-26592-19008*r**2-153455*r**4
            -159875*r**6-53445*r**8+43592*r**10+1673*r**12+161055*r**14+192015*r**16)
            +15*Q2**2*(-1+r**2)**2*(-23040-9600*r**2-148783*r**4-171166*r**6-68173*r**8
            +44392*r**10+109359*r**12-2726*r**14+69021*r**16+185740*r**18)+10*Q2**4*(
            -79488-52992*r**2-461905*r**4-636054*r**6-164765*r**8+241052*r**10
            +452025*r**12+68242*r**14+331149*r**16+542160*r**18)-20*Q2**3*(-32256
            +9984*r**2-197870*r**4-123719*r**6+50926*r**8-21867*r**10+4886*r**12
            +184427*r**14-58558*r**16-102009*r**18+271080*r**20))*sqrtq2)+logq2*(
            -384*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-48*Q2**11*(160
            +241*r**4)+Q2**10*(52032+43520*r**2+28725*r**4+89652*r**6)-2*Q2**9*(72192
            +104512*r**2+78939*r**4+98901*r**6+137370*r**8)+Q2**8*(202176+383488*r**2
            +618853*r**4+37174*r**6+218565*r**8+375960*r**10)-4*Q2**7*(32256+85184*r**2
            +173359*r**4-344967*r**6-1424269*r**8-343683*r**10+14460*r**12)-2*Q2**6*(4032
            -102272*r**2+188693*r**4+3657384*r**6+9829996*r**8+11850052*r**10+2531373*r**12
            +263172*r**14)+8*Q2**5*(8064-22144*r**2+147083*r**4+1394690*r**6+3608165*r**8
            +4802522*r**10+4470584*r**12+868977*r**14+86037*r**16)+(-1+r**2)**4*(
            -1344-13824*r**2-549571*r**4+784946*r**6+1801751*r**8-4053908*r**10
            -1101833*r**12+2700994*r**14+387357*r**16+17352*r**18)-2*Q2**4*(19008
            -48512*r**2+704921*r**4+3120810*r**6+6563817*r**8+10712768*r**10+7108329*r**12
            +6968746*r**14+1671129*r**16+115680*r**18)-2*Q2*(-1+r**2)**2*(-3072
            -35392*r**2-1182879*r**4+516445*r**6+1824519*r**8-781043*r**10-6343819*r**12
            -2134637*r**14+6974969*r**16+996195*r**18+56394*r**20)-4*Q2**3*(-3456
            -19648*r**2-689603*r**4-483117*r**6-1630717*r**8-759855*r**10-1707825*r**12
            +1719545*r**14+5016881*r**16+520275*r**18+57840*r**20)+Q2**2*(-10176
            -130304*r**2-3660539*r**4+1945468*r**6-6654296*r**8-820664*r**10+12641302*r**12
            -12711488*r**14-20032760*r**16+25150504*r**18+3558933*r**20+274740*r**22))
            +384*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(48*Q2**11*(160+241*r**4)
            -Q2**10*(52032+43520*r**2+28725*r**4+89652*r**6)+2*Q2**9*(72192+104512*r**2
            +78939*r**4+98901*r**6+137370*r**8)-Q2**8*(202176+383488*r**2+618853*r**4
            +37174*r**6+218565*r**8+375960*r**10)+4*Q2**7*(32256+85184*r**2+173359*r**4
            -344967*r**6-1424269*r**8-343683*r**10+14460*r**12)+2*Q2**6*(4032-102272*r**2
            +188693*r**4+3657384*r**6+9829996*r**8+11850052*r**10+2531373*r**12
            +263172*r**14)-8*Q2**5*(8064-22144*r**2+147083*r**4+1394690*r**6+3608165*r**8
            +4802522*r**10+4470584*r**12+868977*r**14+86037*r**16)-(-1+r**2)**4*(
            -1344-13824*r**2-549571*r**4+784946*r**6+1801751*r**8-4053908*r**10
            -1101833*r**12+2700994*r**14+387357*r**16+17352*r**18)+2*Q2**4*(19008
            -48512*r**2+704921*r**4+3120810*r**6+6563817*r**8+10712768*r**10+7108329*r**12
            +6968746*r**14+1671129*r**16+115680*r**18)+2*Q2*(-1+r**2)**2*(-3072
            -35392*r**2-1182879*r**4+516445*r**6+1824519*r**8-781043*r**10-6343819*r**12
            -2134637*r**14+6974969*r**16+996195*r**18+56394*r**20)+4*Q2**3*(-3456
            -19648*r**2-689603*r**4-483117*r**6-1630717*r**8-759855*r**10-1707825*r**12
            +1719545*r**14+5016881*r**16+520275*r**18+57840*r**20)+Q2**2*(10176
            +130304*r**2+3660539*r**4-1945468*r**6+6654296*r**8+820664*r**10-12641302*r**12
            +12711488*r**14+20032760*r**16-25150504*r**18-3558933*r**20-274740*r**22))*sqrtq2)))/(58320*(
            -Q2+(-1+r)**2)**3*r**4*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +58320*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(-100776960*r**16*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3-100776960*r**16*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*sqrtq2)+logq2**2*(25194240*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+25194240*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(
            -2099520*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-2099520*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2))+((4*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(Q2**6+2*Q2**5*(1+r**2)+Q2**4*(21+46*r**2-15*r**4)
            +4*Q2**3*(-16-173*r**2-32*r**4+5*r**6)+Q2**2*(31+692*r**2+426*r**4
            +68*r**6-5*r**8)-6*Q2*(-5-103*r**2+34*r**4-38*r**6-9*r**8+r**10)
            +3*(-7-222*r**2+659*r**4+84*r**6+219*r**8-14*r**10+r**12))+4*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(Q2**6+2*Q2**5*(1+r**2)+Q2**4*(21+46*r**2
            -15*r**4)+4*Q2**3*(-16-173*r**2-32*r**4+5*r**6)+Q2**2*(31+692*r**2
            +426*r**4+68*r**6-5*r**8)-6*Q2*(-5-103*r**2+34*r**4-38*r**6-9*r**8
            +r**10)+3*(-7-222*r**2+659*r**4+84*r**6+219*r**8-14*r**10+r**12))*sqrtq2
            +logq2**2*(8640*(-Q2+(-1+r)**2)*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)
            +8640*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2*(96*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(8*Q2**4-22*Q2**3*(1+r**2)+8*Q2**2*(1
            +4*r**2+r**4)+3*Q2*(6-r**2+4*r**4+r**6)+3*(-4+r**2+41*r**4+21*r**6
            +r**8))+96*(-Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(8*Q2**4
            -22*Q2**3*(1+r**2)+8*Q2**2*(1+4*r**2+r**4)+3*Q2*(6-r**2+4*r**4+r**6)
            +3*(-4+r**2+41*r**4+21*r**6+r**8))*sqrtq2))*z3)/(-120*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*(-Q2
            +(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+logq2**2*(17280*r**10*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -17280*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2*(2880*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+2880*(-Q2
            +(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+((muWC**2*(-360*logq2*Q2*r**4*(1
            +r**2)+2*Q2*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(2160*logq2**2*r**8
            +15*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-360*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(muWC*(-2880*logq2*Q2*r**4*(1
            +r**2)+16*Q2*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(6480*logq2**2*r**8
            +45*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-1080*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))*nlo.X1Q2_DerivativeQ2(0,Q2,r)+((
            -4*muWC**2*Q2)/(-36*logq2*r**4+3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2)-(32*muWC*Q2)/(-108*logq2*r**4+9*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))*nlo.X1Q2_DerivativeQ2(1,Q2,r)
            +(pi2*(-4*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(Q2**6
            +2*Q2**5*(1+r**2)+Q2**4*(21+46*r**2-15*r**4)+4*Q2**3*(-16-173*r**2
            -32*r**4+5*r**6)+Q2**2*(31+692*r**2+426*r**4+68*r**6-5*r**8)-6*Q2*(
            -5-103*r**2+34*r**4-38*r**6-9*r**8+r**10)+3*(-7-222*r**2+659*r**4
            +84*r**6+219*r**8-14*r**10+r**12))*(3+math.log(4))-4*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(Q2**6+2*Q2**5*(1+r**2)+Q2**4*(21+46*r**2-15*r**4)
            +4*Q2**3*(-16-173*r**2-32*r**4+5*r**6)+Q2**2*(31+692*r**2+426*r**4
            +68*r**6-5*r**8)-6*Q2*(-5-103*r**2+34*r**4-38*r**6-9*r**8+r**10)
            +3*(-7-222*r**2+659*r**4+84*r**6+219*r**8-14*r**10+r**12))*sqrtq2*(3
            +math.log(4))+logq2**2*(-8640*(-Q2+(-1+r)**2)*r**12*(1-Q2+r**2)*(-Q2+(1
            +r)**2)*(3+math.log(4))-8640*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2*(3
            +math.log(4)))+logq2*(-96*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(8*Q2**4
            -22*Q2**3*(1+r**2)+8*Q2**2*(1+4*r**2+r**4)+3*Q2*(6-r**2+4*r**4+r**6)
            +3*(-4+r**2+41*r**4+21*r**6+r**8))*(3+math.log(4))-96*(-Q2+(-1+r)**2)*r**6*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(8*Q2**4-22*Q2**3*(1+r**2)+8*Q2**2*(1+4*r**2
            +r**4)+3*Q2*(6-r**2+4*r**4+r**6)+3*(-4+r**2+41*r**4+21*r**6+r**8))*sqrtq2*(3
            +math.log(4)))))/(-360*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-360*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2+logq2**2*(51840*r**10*(-1+Q2**3+r**2+r**4
            -r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))-51840*r**10*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2*(8640*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+8640*(-Q2+(-1+r)**2)*r**6*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2))+((-16*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(Q2**11-Q2**10*(1+97*r**2)+Q2**9*(17-924*r**2+749*r**4)+Q2**8*(
            -121+22343*r**2+4583*r**4-2617*r**6)+2*Q2**7*(133-41264*r**2-30180*r**4
            -6680*r**6+2641*r**8)+Q2**6*(-154+78366*r**2+90272*r**4+65696*r**6
            +29958*r**8-6706*r**10)+2*Q2**5*(-119+55756*r**2+57469*r**4+143880*r**6
            -76211*r**8-22460*r**10+2737*r**12)-2*Q2**4*(-199+135893*r**2+129981*r**4
            +638105*r**6+190037*r**8-140631*r**10-19327*r**12+1397*r**14)+Q2**3*(
            -139+131232*r**2+27824*r**4+1180208*r**6-11298*r**8+291776*r**10-181504*r**12
            -15888*r**14+797*r**16)+Q2**2*(-101+91523*r**2+85112*r**4+703880*r**6
            +153050*r**8-199654*r**10-16552*r**12+37064*r**14+1115*r**16-77*r**18)
            +3*(-1+r**2)**2*(-7+9811*r**2+2262*r**4+183642*r**6-398420*r**8+185148*r**10
            -1350*r**12+10294*r**14-21*r**16+r**18)-3*Q2*(-31+36372*r**2-16315*r**4
            +504048*r**6-888514*r**8+183368*r**10+90870*r**12+41552*r**14+14369*r**16
            -284*r**18+5*r**20))+16*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(Q2**12
            -2*Q2**11*(1+49*r**2)+2*Q2**10*(9-413*r**2+423*r**4)-6*Q2**9*(23-3875*r**2
            -793*r**4+561*r**6)+Q2**8*(387-104750*r**2-87286*r**4-15326*r**6+7899*r**8)
            -4*Q2**7*(105-40157*r**2-58290*r**4-34854*r**6-9509*r**8+2997*r**10)
            +4*Q2**6*(-21+8325*r**2-13425*r**4+32948*r**6-62019*r**8-17043*r**10
            +3045*r**12)-4*Q2**5*(-159+95765*r**2+121603*r**4+419727*r**6+128853*r**8
            -119651*r**10-19525*r**12+2067*r**14)+Q2**4*(-537+402620*r**2+559572*r**4
            +2716380*r**6+1644986*r**8+390588*r**10-501420*r**12-51748*r**14+3591*r**16)
            -2*Q2**3*(-19+19785*r**2+36972*r**4+252076*r**6+507930*r**8+240066*r**10
            +63412*r**12-117228*r**14-8103*r**16+437*r**18)-3*(-1+r**2)**2*(-7
            +9804*r**2+12073*r**4+185904*r**6-214778*r**8-213272*r**10+183798*r**12
            +8944*r**14+10273*r**16-20*r**18+r**20)+2*Q2**2*(97-100269*r**2-63845*r**4
            -1150568*r**6+904306*r**8-251750*r**10-28202*r**12-72584*r**14-40643*r**16
            -93*r**18+31*r**20)+6*Q2*(-19+23083*r**2+1345*r**4+338331*r**6-573954*r**8
            +230242*r**10-247914*r**12+165282*r**14+16981*r**16+12211*r**18-151*r**20
            +3*r**22))*sqrtq2+logq2**3*(414720*r**18*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3+414720*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**2*(-2304*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-1168*Q2**6
            +Q2**5*(5548+2683*r**2)-Q2**4*(8760+6589*r**2+1605*r**4)+2*Q2**3*(1460
            +1228*r**2+1213*r**4+50*r**6)+3*(-1+r**2)**2*(584-381*r**2-501*r**4
            -461*r**6+579*r**8)+2*Q2**2*(2920-262*r**2-231*r**4-367*r**6+730*r**8)
            +Q2*(-6132+6621*r**2+66*r**4+3486*r**6+1326*r**8-3207*r**10))-2304*(
            -Q2+(-1+r)**2)*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(-1168*Q2**6+Q2**5*(5548+2683*r**2)-Q2**4*(8760+6589*r**2
            +1605*r**4)+2*Q2**3*(1460+1228*r**2+1213*r**4+50*r**6)+3*(-1+r**2)**2*(584
            -381*r**2-501*r**4-461*r**6+579*r**8)+2*Q2**2*(2920-262*r**2-231*r**4
            -367*r**6+730*r**8)+Q2*(-6132+6621*r**2+66*r**4+3486*r**6+1326*r**8
            -3207*r**10))*sqrtq2)+logq2*(-192*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-368*Q2**9-4140*Q2**7*(1+r**2)**2+Q2**8*(2116+1923*r**2)
            +4*Q2**6*(391+1386*r**2-339*r**4+2116*r**6)+4*Q2**5*(1357+6027*r**2
            +23247*r**4+3679*r**6-4146*r**8)+6*Q2**4*(-1242-8025*r**2-35068*r**4
            -18012*r**6-930*r**8+3063*r**10)+4*Q2**3*(391+5688*r**2+23883*r**4
            +16600*r**6+9201*r**8-204*r**10-2207*r**12)+3*(-1+r**2)**2*(184+2177*r**2
            +15898*r**4-19069*r**6-18804*r**8+15107*r**10+2154*r**12+193*r**14)
            +4*Q2**2*(805+4110*r**2+33753*r**4-8198*r**6+2667*r**8-12*r**10+1615*r**12
            +360*r**14)-36*Q2*(69+549*r**2+3967*r**4-5713*r**6-409*r**8-1753*r**10
            +2197*r**12+349*r**14+24*r**16))+192*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(368*Q2**9+4140*Q2**7*(1+r**2)**2-Q2**8*(2116+1923*r**2)-4*Q2**6*(391
            +1386*r**2-339*r**4+2116*r**6)+4*Q2**5*(-1357-6027*r**2-23247*r**4
            -3679*r**6+4146*r**8)+6*Q2**4*(1242+8025*r**2+35068*r**4+18012*r**6
            +930*r**8-3063*r**10)+4*Q2**3*(-391-5688*r**2-23883*r**4-16600*r**6
            -9201*r**8+204*r**10+2207*r**12)-3*(-1+r**2)**2*(184+2177*r**2+15898*r**4
            -19069*r**6-18804*r**8+15107*r**10+2154*r**12+193*r**14)-4*Q2**2*(805
            +4110*r**2+33753*r**4-8198*r**6+2667*r**8-12*r**10+1615*r**12+360*r**14)
            +36*Q2*(69+549*r**2+3967*r**4-5713*r**6-409*r**8-1753*r**10+2197*r**12
            +349*r**14+24*r**16))*sqrtq2))*math.log(mu0)**2)/(480*(-Q2+(-1+r)**2)**3*r**4*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+480*(-Q2+(-1+r)**2)**3*r**4*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(
            -829440*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-829440*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**2*(207360*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+207360*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)+logq2*(-17280*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2-17280*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2))+((-40*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(Q2**6+2*Q2**5*(1+r**2)
            +Q2**4*(21+46*r**2-15*r**4)+4*Q2**3*(-16-173*r**2-32*r**4+5*r**6)
            +Q2**2*(31+692*r**2+426*r**4+68*r**6-5*r**8)-6*Q2*(-5-103*r**2+34*r**4
            -38*r**6-9*r**8+r**10)+3*(-7-222*r**2+659*r**4+84*r**6+219*r**8
            -14*r**10+r**12))-40*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(Q2**6
            +2*Q2**5*(1+r**2)+Q2**4*(21+46*r**2-15*r**4)+4*Q2**3*(-16-173*r**2
            -32*r**4+5*r**6)+Q2**2*(31+692*r**2+426*r**4+68*r**6-5*r**8)-6*Q2*(
            -5-103*r**2+34*r**4-38*r**6-9*r**8+r**10)+3*(-7-222*r**2+659*r**4
            +84*r**6+219*r**8-14*r**10+r**12))*sqrtq2+logq2**2*(-86400*(-Q2+(-1
            +r)**2)*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)-86400*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2)+logq2*(-960*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(8*Q2**4-22*Q2**3*(1+r**2)+8*Q2**2*(1+4*r**2+r**4)+3*Q2*(6
            -r**2+4*r**4+r**6)+3*(-4+r**2+41*r**4+21*r**6+r**8))-960*(-Q2
            +(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(8*Q2**4-22*Q2**3*(1
            +r**2)+8*Q2**2*(1+4*r**2+r**4)+3*Q2*(6-r**2+4*r**4+r**6)+3*(-4
            +r**2+41*r**4+21*r**6+r**8))*sqrtq2))*math.log(mus))/(-36*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-36*(-Q2
            +(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+logq2**2*(5184*r**10*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -5184*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2*(864*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+864*(-Q2
            +(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+math.log(mu0)*((16*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(311*Q2**11+Q2**10*(-311+457*r**2)+Q2**9*(5287
            +18876*r**2-12053*r**4)+Q2**8*(-37631-462335*r**2-105887*r**4+43585*r**6)
            +Q2**7*(82726+1650400*r**2+1439880*r**4+254896*r**6-72242*r**8)+2*Q2**6*(
            -23947-798663*r**2-1244080*r**4-717040*r**6-149499*r**8+29057*r**10)
            -2*Q2**5*(37009+789292*r**2-662171*r**4+25608*r**6-613835*r**8-58460*r**10
            +6265*r**12)-2*Q2**4*(-61889-1988957*r**2+1562235*r**4-360353*r**6+977155*r**8
            +1189167*r**10-39017*r**12+5731*r**14)+Q2**3*(-43229-1692960*r**2+4365904*r**4
            -2648240*r**6+7265970*r**8+1197760*r**10+1982848*r**12-41328*r**14+2875*r**16)
            +3*(-1+r**2)**2*(-2177-133675*r**2+703482*r**4-2420394*r**6+1527284*r**8
            -1952028*r**10-419850*r**12+16538*r**14-6531*r**16+311*r**18)+Q2**2*(
            -31411-1455995*r**2+2889352*r**4-2382344*r**6+498838*r**8+1605526*r**10
            +303400*r**12+73528*r**14-81971*r**16+6677*r**18)-3*Q2*(-9641-509172*r**2
            +2398291*r**4-5793264*r**6+2350546*r**8-5690504*r**10-2730918*r**12
            -919376*r**14+181399*r**16-27076*r**18+1555*r**20))-16*r**6*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*(311*Q2**12+2*Q2**11*(-311+73*r**2)+Q2**10*(5598
            +18730*r**2-12510*r**4)+6*Q2**9*(-7153-81083*r**2-18785*r**4+9273*r**6)
            +Q2**8*(120357+2150366*r**2+2008102*r**4+317198*r**6-115827*r**8)+4*Q2**7*(
            -32655-832613*r**2-1394610*r**4-782214*r**6-120413*r**8+32589*r**10)
            +4*Q2**6*(-6531+16659*r**2+1352457*r**4+967756*r**6+740187*r**8+89451*r**10
            -17661*r**12)+4*Q2**5*(49449+1407629*r**2-717557*r**4-138105*r**6-782691*r**8
            -930731*r**10-6589*r**12+267*r**14)+Q2**4*(-167007-5794652*r**2+3512460*r**4
            -244476*r**6+8499574*r**8+5530404*r**10+4283148*r**12-107900*r**14+14337*r**16)
            +2*Q2**3*(5909+140097*r**2+108204*r**4-2050004*r**6-2059446*r**8-3429102*r**10
            -1438604*r**12-933996*r**14-21759*r**16+1901*r**18)+2*Q2**2*(30167+1507461*r**2
            -4314115*r**4+8436392*r**6-2584066*r**8+7483574*r**10+3141914*r**12
            +1190600*r**14-267877*r**16+78261*r**18-5671*r**20)-3*(-1+r**2)**2*(
            -2177-135852*r**2+569807*r**4-1716912*r**6-893110*r**8-424744*r**10
            -2371878*r**12-403312*r**14+10007*r**16-6220*r**18+311*r**20)+6*Q2*(
            -5909-324067*r**2+1428887*r**4-3678003*r**6+1814418*r**8-5383474*r**10
            -1704966*r**12-2373042*r**14-598717*r**16+92117*r**18-16337*r**20+933*r**22))*sqrtq2
            +logq2**3*(-128977920*r**18*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3-128977920*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**2*(-11520*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-848*Q2**6
            +Q2**5*(4028-1513*r**2)+Q2**4*(-6360+5599*r**2+7959*r**4)-2*Q2**3*(
            -1060+2884*r**2+1951*r**4+3110*r**6)+2*Q2**2*(2120-2078*r**2+5181*r**4
            +4453*r**6+530*r**8)+3*(-1+r**2)**2*(424-801*r**2+6663*r**4+4175*r**6
            +735*r**8)-3*Q2*(1484-3595*r**2+13618*r**4+23278*r**6+9118*r**8+881*r**10))
            -11520*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(848*Q2**7+Q2**6*(
            -4876+665*r**2)-4*Q2**5*(-2597+771*r**2+2368*r**4)+Q2**4*(-8480+5007*r**2
            +17460*r**4+14179*r**6)-4*Q2**3*(530-127*r**2+5008*r**4+4757*r**6+1820*r**8)
            +3*(-1+r**2)**2*(424-377*r**2+5862*r**4+10838*r**6+4910*r**8+735*r**10)
            +Q2**2*(8692-10701*r**2+47060*r**4+89102*r**6+37320*r**8+3703*r**10)
            -12*Q2*(477-940*r**2+4678*r**4+6736*r**6+7861*r**8+3176*r**10+404*r**12))*sqrtq2)
            +logq2*(-192*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(
            -8048*Q2**9-90540*Q2**7*(1+r**2)**2+Q2**8*(46276+45051*r**2)+4*Q2**6*(8551
            +51282*r**2+36525*r**4+23308*r**6)-4*Q2**5*(-29677-8979*r**2-28071*r**4
            +26393*r**6+19770*r**8)+6*Q2**4*(-27162-30705*r**2-26620*r**4+120036*r**6
            +59550*r**8+12063*r**10)-4*Q2**3*(-8551-22536*r**2+54885*r**4+140264*r**6
            +174255*r**8+74364*r**10+10319*r**12)+20*Q2**2*(3521-2994*r**2+18213*r**4
            -15286*r**6+13263*r**8+5340*r**10-925*r**12+576*r**14)+3*(-1+r**2)**2*(4024
            -3319*r**2+16810*r**4+234395*r**6+151980*r**8+262811*r**10+3834*r**12
            +1225*r**14)-36*Q2*(1509-2307*r**2+6535*r**4+15863*r**6+96575*r**8
            +70511*r**10+36397*r**12-1355*r**14+192*r**16))+192*r**8*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3*(8048*Q2**9+90540*Q2**7*(1+r**2)**2-Q2**8*(46276
            +45051*r**2)-4*Q2**6*(8551+51282*r**2+36525*r**4+23308*r**6)+4*Q2**5*(
            -29677-8979*r**2-28071*r**4+26393*r**6+19770*r**8)-6*Q2**4*(-27162
            -30705*r**2-26620*r**4+120036*r**6+59550*r**8+12063*r**10)+4*Q2**3*(
            -8551-22536*r**2+54885*r**4+140264*r**6+174255*r**8+74364*r**10+10319*r**12)
            -20*Q2**2*(3521-2994*r**2+18213*r**4-15286*r**6+13263*r**8+5340*r**10
            -925*r**12+576*r**14)-3*(-1+r**2)**2*(4024-3319*r**2+16810*r**4+234395*r**6
            +151980*r**8+262811*r**10+3834*r**12+1225*r**14)+36*Q2*(1509-2307*r**2
            +6535*r**4+15863*r**6+96575*r**8+70511*r**10+36397*r**12-1355*r**14
            +192*r**16))*sqrtq2))/(2880*(-Q2+(-1+r)**2)**3*r**4*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+2880*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(-4976640*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-4976640*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**2*(1244160*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+1244160*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)+logq2*(-103680*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2-103680*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2))+((-20*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(Q2**6+2*Q2**5*(1+r**2)
            +Q2**4*(21+46*r**2-15*r**4)+4*Q2**3*(-16-173*r**2-32*r**4+5*r**6)
            +Q2**2*(31+692*r**2+426*r**4+68*r**6-5*r**8)-6*Q2*(-5-103*r**2+34*r**4
            -38*r**6-9*r**8+r**10)+3*(-7-222*r**2+659*r**4+84*r**6+219*r**8
            -14*r**10+r**12))-20*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(Q2**6
            +2*Q2**5*(1+r**2)+Q2**4*(21+46*r**2-15*r**4)+4*Q2**3*(-16-173*r**2
            -32*r**4+5*r**6)+Q2**2*(31+692*r**2+426*r**4+68*r**6-5*r**8)-6*Q2*(
            -5-103*r**2+34*r**4-38*r**6-9*r**8+r**10)+3*(-7-222*r**2+659*r**4
            +84*r**6+219*r**8-14*r**10+r**12))*sqrtq2+logq2**2*(-43200*(-Q2+(-1
            +r)**2)*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)-43200*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2)+logq2*(-480*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(8*Q2**4-22*Q2**3*(1+r**2)+8*Q2**2*(1+4*r**2+r**4)+3*Q2*(6
            -r**2+4*r**4+r**6)+3*(-4+r**2+41*r**4+21*r**6+r**8))-480*(-Q2
            +(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(8*Q2**4-22*Q2**3*(1
            +r**2)+8*Q2**2*(1+4*r**2+r**4)+3*Q2*(6-r**2+4*r**4+r**6)+3*(-4
            +r**2+41*r**4+21*r**6+r**8))*sqrtq2))*math.log(mus))/(-12*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-12*(-Q2
            +(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+logq2**2*(1728*r**10*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -1728*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2*(288*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+288*(-Q2
            +(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)))+((-16*r**6*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**4*(511*Q2**11+Q2**10*(-511+257*r**2)+Q2**9*(8687
            +26076*r**2-15853*r**4)+Q2**8*(-61831-640135*r**2-149287*r**4+57785*r**6)
            +Q2**7*(135926+2271200*r**2+2039880*r**4+347696*r**6-91042*r**8)+Q2**6*(
            -78694-2205726*r**2-3595360*r**4-2003680*r**6-336198*r**8+60914*r**10)
            +2*Q2**5*(-60809-1004492*r**2+1365571*r**4+679992*r**6+616435*r**8-17540*r**10
            +3535*r**12)-2*Q2**4*(-101689-2554357*r**2+3193635*r**4+2614247*r**6
            +2542955*r**8+1229367*r**10-160417*r**12+16331*r**14)+Q2**3*(-71029
            -2096160*r**2+7242704*r**4+1610960*r**6+11764770*r**8+3412160*r**10
            +2315648*r**12-146928*r**14+8675*r**16)+3*(-1+r**2)**2*(-3577-168275*r**2
            +1155882*r**4-3016794*r**6+486484*r**8-2247228*r**10-689850*r**12+78538*r**14
            -10731*r**16+511*r**18)+Q2**2*(-51611-1909795*r**2+5127752*r**4-345544*r**6
            +1579238*r**8+1610726*r**10+410600*r**12+305528*r**14-127771*r**16+10477*r**18)
            -3*Q2*(-15841-645972*r**2+3820091*r**4-6897264*r**6-632254*r**8-8338504*r**10
            -3987318*r**12-1287376*r**14+367199*r**16-45476*r**18+2555*r**20))+16*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(511*Q2**12-2*Q2**11*(511+127*r**2)
            +Q2**10*(9198+26330*r**2-16110*r**4)+6*Q2**9*(-11753-112483*r**2-26585*r**4
            +12273*r**6)+Q2**8*(197757+2973166*r**2+2829302*r**4+439198*r**6-148827*r**8)
            +4*Q2**7*(-53655-1153213*r**2-1976610*r**4-1097814*r**6-148213*r**8
            +37989*r**10)+4*Q2**6*(-10731+68859*r**2+2133057*r**4+1739756*r**6+893187*r**8
            +60051*r**10-13461*r**12)-4*Q2**5*(-81249-1809829*r**2+1777357*r**4
            +2329905*r**6+1919691*r**8+914131*r**10-87211*r**12+9933*r**14)+Q2**4*(
            -274407-7408252*r**2+8521260*r**4+13226724*r**6+22079174*r**8+10956804*r**10
            +4453548*r**12-435100*r**14+41337*r**16)+2*Q2**3*(9709+128697*r**2-9396*r**4
            -4599604*r**6-5898246*r**8-6783102*r**10-2658604*r**12-931596*r**14
            +5241*r**16+901*r**18)+2*Q2**2*(49567+1949661*r**2-7339115*r**4+7954792*r**6
            +331534*r**8+10912774*r**10+4970314*r**12+1573000*r**14-639677*r**16
            +126861*r**18-9071*r**20)-3*(-1+r**2)**2*(-3577-171852*r**2+987607*r**4
            -1860912*r**6-2530310*r**8-1760744*r**10-2937078*r**12-611312*r**14
            +67807*r**16-10220*r**18+511*r**20)+6*Q2*(-9709-411467*r**2+2331487*r**4
            -4287003*r**6+73218*r**8-7603874*r**10-4017366*r**12-3031842*r**14-888917*r**16
            +211117*r**18-27337*r**20+1533*r**22))*sqrtq2+logq2**3*(211921920*r**18*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+211921920*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**2*(11520*r**12*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*(-208*Q2**6+Q2**5*(988-5153*r**2)+Q2**4*(
            -1560+15719*r**2+14559*r**4)-2*Q2**3*(-260+5924*r**2+4391*r**4+5110*r**6)
            +2*Q2**2*(520-3118*r**2+8661*r**4+7613*r**6+130*r**8)+3*(-1+r**2)**2*(104
            -921*r**2+11343*r**4+7255*r**6+615*r**8)-3*Q2*(364-3635*r**2+22178*r**4
            +39038*r**6+15278*r**8+361*r**10))+11520*(-Q2+(-1+r)**2)*r**12*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(-208*Q2**6
            +Q2**5*(988-5153*r**2)+Q2**4*(-1560+15719*r**2+14559*r**4)-2*Q2**3*(
            -260+5924*r**2+4391*r**4+5110*r**6)+2*Q2**2*(520-3118*r**2+8661*r**4
            +7613*r**6+130*r**8)+3*(-1+r**2)**2*(104-921*r**2+11343*r**4+7255*r**6
            +615*r**8)-3*Q2*(364-3635*r**2+22178*r**4+39038*r**6+15278*r**8+361*r**10))*sqrtq2)
            +logq2*(192*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(
            -11248*Q2**9-126540*Q2**7*(1+r**2)**2+Q2**8*(64676+63651*r**2)+4*Q2**6*(11951
            +76482*r**2+61125*r**4+27308*r**6)-4*Q2**5*(-41477+15621*r**2+70929*r**4
            +61393*r**6+11370*r**8)+6*Q2**4*(-37962-9705*r**2+132580*r**4+285636*r**6
            +101550*r**8+4263*r**10)-4*Q2**3*(-11951-8136*r**2+209085*r**4+311464*r**6
            +329655*r**8+119964*r**10+5719*r**12)+20*Q2**2*(4921-8994*r**2-4227*r**4
            -16646*r**6+18903*r**8+8700*r**10-3125*r**12+576*r**14)+3*(-1+r**2)**2*(5624
            -16319*r**2-52390*r**4+476995*r**6+341580*r**8+351811*r**10-4566*r**12
            +1025*r**14)-36*Q2*(2109-6507*r**2-9265*r**4+54463*r**6+159175*r**8
            +123511*r**10+48197*r**12-3955*r**14+192*r**16))-192*r**8*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3*(11248*Q2**9+126540*Q2**7*(1+r**2)**2-Q2**8*(64676
            +63651*r**2)-4*Q2**6*(11951+76482*r**2+61125*r**4+27308*r**6)+4*Q2**5*(
            -41477+15621*r**2+70929*r**4+61393*r**6+11370*r**8)-6*Q2**4*(-37962
            -9705*r**2+132580*r**4+285636*r**6+101550*r**8+4263*r**10)+4*Q2**3*(
            -11951-8136*r**2+209085*r**4+311464*r**6+329655*r**8+119964*r**10+5719*r**12)
            -20*Q2**2*(4921-8994*r**2-4227*r**4-16646*r**6+18903*r**8+8700*r**10
            -3125*r**12+576*r**14)-3*(-1+r**2)**2*(5624-16319*r**2-52390*r**4+476995*r**6
            +341580*r**8+351811*r**10-4566*r**12+1025*r**14)+36*Q2*(2109-6507*r**2
            -9265*r**4+54463*r**6+159175*r**8+123511*r**10+48197*r**12-3955*r**14
            +192*r**16))*sqrtq2))/(2880*(-Q2+(-1+r)**2)**3*r**4*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+2880*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(-4976640*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-4976640*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**2*(1244160*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+1244160*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)+logq2*(-103680*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2-103680*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2))+((-128*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(Q2**11+Q2**10*(-1+3*r**2)+Q2**9*(17
            +76*r**2-51*r**4)+Q2**8*(-121-1857*r**2-417*r**4+183*r**6)+Q2**7*(266
            +6672*r**2+5640*r**4+1040*r**6-318*r**8)+2*Q2**6*(-77-3217*r**2-4764*r**4
            -2852*r**6-721*r**8+147*r**10)-2*Q2**5*(119+3444*r**2-1269*r**4+2320*r**6
            -3189*r**8-540*r**10+63*r**12)+2*Q2**4*(199+8607*r**2-3081*r**4+11095*r**6
            -237*r**8-6069*r**10-173*r**12+3*r**14)+Q2**3*(-139-7568*r**2+13824*r**4
            -26992*r**6+23902*r**8-624*r**10+9296*r**12+112*r**14-3*r**16)+3*(
            -1+r**2)**2*(-7-589*r**2+2262*r**4-10758*r**6+11180*r**8-9252*r**10
            -1350*r**12-106*r**14-21*r**16+r**18)+Q2**2*(-101-6177*r**2+8112*r**4
            -18720*r**6-750*r**8+8346*r**10+1248*r**12-336*r**14-285*r**16+23*r**18)
            -3*Q2*(-31-2228*r**2+8085*r**4-26752*r**6+21486*r**8-21432*r**10-10330*r**12
            -3648*r**14+369*r**16-84*r**18+5*r**20))+128*r**6*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(Q2**12+2*Q2**11*(-1+r**2)+Q2**10*(18+74*r**2-54*r**4)
            +2*Q2**9*(-69-975*r**2-221*r**4+117*r**6)+Q2**8*(387+8650*r**2+7914*r**4
            +1274*r**6-501*r**8)+4*Q2**7*(-105-3343*r**2-5460*r**4-3096*r**6-541*r**8
            +153*r**10)-4*Q2**6*(21+75*r**2-4625*r**4-2648*r**6-3381*r**8-557*r**10
            +105*r**12)+4*Q2**5*(159+6085*r**2-453*r**4+6073*r**6-553*r**8-4899*r**10
            -325*r**12+33*r**14)+Q2**4*(-537-25180*r**2+2772*r**4-43020*r**6+2186*r**8
            +11988*r**10+21780*r**12+452*r**14-9*r**16)+2*Q2**3*(19+765*r**2+928*r**4
            -2776*r**6+1170*r**8-7466*r**10-3712*r**12-4872*r**14-197*r**16+13*r**18)
            +2*Q2**2*(97+6481*r**2-13095*r**4+45432*r**6-22494*r**8+28350*r**10
            +10698*r**12+5016*r**14-243*r**16+257*r**18-19*r**20)-3*(-1+r**2)**2*(
            -7-596*r**2+1673*r**4-8496*r**6+422*r**8+1928*r**10-10602*r**12-1456*r**14
            -127*r**16-20*r**18+r**20)+6*Q2*(-19-1417*r**2+4645*r**4-17269*r**6
            +14846*r**8-21158*r**10-1714*r**12-10318*r**14-2219*r**16+111*r**18
            -51*r**20+3*r**22))*sqrtq2+logq2**3*(3317760*r**18*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3+3317760*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*sqrtq2)+logq2**2*(18432*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(
            -32*Q2**6+Q2**5*(152+17*r**2)+Q2**4*(-240-11*r**2+105*r**4)-2*Q2**3*(
            -40+28*r**2+13*r**4+50*r**6)+2*Q2**2*(80-38*r**2+81*r**4+67*r**6
            +20*r**8)+3*(-1+r**2)**2*(16-19*r**2+101*r**4+61*r**6+21*r**8)-3*Q2*(56
            -93*r**2+222*r**4+362*r**6+142*r**8+31*r**10))+18432*(-Q2+(-1+r)**2)*r**12*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(-32*Q2**6
            +Q2**5*(152+17*r**2)+Q2**4*(-240-11*r**2+105*r**4)-2*Q2**3*(-40+28*r**2
            +13*r**4+50*r**6)+2*Q2**2*(80-38*r**2+81*r**4+67*r**6+20*r**8)+3*(
            -1+r**2)**2*(16-19*r**2+101*r**4+61*r**6+21*r**8)-3*Q2*(56-93*r**2
            +222*r**4+362*r**6+142*r**8+31*r**10))*sqrtq2)+logq2*(1536*r**8*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-32*Q2**9-360*Q2**7*(1
            +r**2)**2+Q2**8*(184+177*r**2)+4*Q2**6*(34+189*r**2+114*r**4+109*r**6)
            +Q2**5*(472+492*r**2+1812*r**4-116*r**6-516*r**8)+6*Q2**4*(-108-225*r**2
            -632*r**4+112*r**6+180*r**8+87*r**10)-8*Q2**3*(-17-81*r**2-96*r**4
            +100*r**6+213*r**8+123*r**10+34*r**12)+3*(-1+r**2)**2*(16+23*r**2
            +302*r**4+469*r**6+204*r**8+1093*r**10+46*r**12+7*r**14)+4*Q2**2*(70
            +15*r**2+822*r**4-377*r**6+258*r**8+87*r**10+10*r**12+15*r**14)-36*Q2*(6
            +r**2+83*r**4-37*r**6+309*r**8+203*r**10+153*r**12+r**14+r**16))
            -1536*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(32*Q2**9+360*Q2**7*(1
            +r**2)**2-Q2**8*(184+177*r**2)-4*Q2**6*(34+189*r**2+114*r**4+109*r**6)
            +4*Q2**5*(-118-123*r**2-453*r**4+29*r**6+129*r**8)-6*Q2**4*(-108-225*r**2
            -632*r**4+112*r**6+180*r**8+87*r**10)+8*Q2**3*(-17-81*r**2-96*r**4
            +100*r**6+213*r**8+123*r**10+34*r**12)-3*(-1+r**2)**2*(16+23*r**2
            +302*r**4+469*r**6+204*r**8+1093*r**10+46*r**12+7*r**14)-4*Q2**2*(70
            +15*r**2+822*r**4-377*r**6+258*r**8+87*r**10+10*r**12+15*r**14)+36*Q2*(6
            +r**2+83*r**4-37*r**6+309*r**8+203*r**10+153*r**12+r**14+r**16))*sqrtq2))*math.log(mu0))/(80*(
            -Q2+(-1+r)**2)**3*r**4*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +80*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(-138240*r**16*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3-138240*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*sqrtq2)+logq2**2*(34560*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+34560*r**12*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(-2880*r**8*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-2880*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2))+((20*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(Q2**6+2*Q2**5*(1+r**2)+Q2**4*(21+46*r**2-15*r**4)+4*Q2**3*(
            -16-173*r**2-32*r**4+5*r**6)+Q2**2*(31+692*r**2+426*r**4+68*r**6
            -5*r**8)-6*Q2*(-5-103*r**2+34*r**4-38*r**6-9*r**8+r**10)+3*(-7
            -222*r**2+659*r**4+84*r**6+219*r**8-14*r**10+r**12))+20*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(Q2**6+2*Q2**5*(1+r**2)+Q2**4*(21+46*r**2
            -15*r**4)+4*Q2**3*(-16-173*r**2-32*r**4+5*r**6)+Q2**2*(31+692*r**2
            +426*r**4+68*r**6-5*r**8)-6*Q2*(-5-103*r**2+34*r**4-38*r**6-9*r**8
            +r**10)+3*(-7-222*r**2+659*r**4+84*r**6+219*r**8-14*r**10+r**12))*sqrtq2
            +logq2**2*(43200*(-Q2+(-1+r)**2)*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)
            +43200*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2*(480*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(8*Q2**4-22*Q2**3*(1+r**2)+8*Q2**2*(1
            +4*r**2+r**4)+3*Q2*(6-r**2+4*r**4+r**6)+3*(-4+r**2+41*r**4+21*r**6
            +r**8))+480*(-Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(8*Q2**4
            -22*Q2**3*(1+r**2)+8*Q2**2*(1+4*r**2+r**4)+3*Q2*(6-r**2+4*r**4+r**6)
            +3*(-4+r**2+41*r**4+21*r**6+r**8))*sqrtq2))*math.log(mus))/(-12*(-Q2+(
            -1+r)**2)*r**2*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -12*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2
            +logq2**2*(1728*r**10*(-1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3
            +2*r**2+3*r**4))-1728*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2*(288*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+288*(-Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)))*math.log(r)
            +((16*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(49*Q2**11+Q2**10*(-49
            +47*r**2)+Q2**9*(833+2724*r**2-1699*r**4)+Q2**8*(-5929-66793*r**2-15433*r**4
            +6167*r**6)+Q2**7*(13034+237728*r**2+210360*r**4+36560*r**6-9982*r**8)
            +Q2**6*(-7546-230466*r**2-367072*r**4-208096*r**6-39258*r**8+7406*r**10)
            +Q2**5*(-11662-219112*r**2+236762*r**4+65040*r**6+153722*r**8+6920*r**10
            -574*r**12)-2*Q2**4*(-9751-277243*r**2+277869*r**4+105545*r**6+201413*r**8
            +150681*r**10-11023*r**12+1253*r**14)+Q2**3*(-6811-232032*r**2+691376*r**4
            -115408*r**6+1135998*r**8+261824*r**10+264704*r**12-10512*r**14+653*r**16)
            +3*(-1+r**2)**2*(-343-18461*r**2+110838*r**4-332742*r**6+138220*r**8
            -258948*r**10-66150*r**12+5206*r**14-1029*r**16+49*r**18)+Q2**2*(-4949
            -204973*r**2+474488*r**4-194680*r**6+117050*r**8+200954*r**10+43352*r**12
            +20936*r**14-12565*r**16+1027*r**18)-3*Q2*(-1519-70572*r**2+371765*r**4
            -780048*r**6+142814*r**8-845368*r**10-404970*r**12-133552*r**14+32081*r**16
            -4316*r**18+245*r**20))-16*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(49*Q2**12
            -2*Q2**11*(49+r**2)+Q2**10*(882+2726*r**2-1746*r**4)+6*Q2**9*(-1127
            -11725*r**2-2743*r**4+1311*r**6)+Q2**8*(18963+310450*r**2+292586*r**4
            +45826*r**6-16149*r**8)+4*Q2**7*(-5145-120307*r**2-203790*r**4-113754*r**6
            -16459*r**8+4347*r**10)+Q2**6*(-4116+18900*r**2+834300*r**4+640208*r**6
            +401076*r**8+38772*r**10-7980*r**12)-4*Q2**5*(-7791-196315*r**2+143347*r**4
            +128223*r**6+155397*r**8+115501*r**10-3925*r**12+483*r**14)+Q2**4*(
            -26313-806020*r**2+692628*r**4+651420*r**6+1749914*r**8+966012*r**10
            +544020*r**12-30052*r**14+3159*r**16)+2*Q2**3*(931+16935*r**2+7572*r**4
            -385324*r**6-451770*r**8-598434*r**10-241588*r**12-116628*r**14-1353*r**16
            +187*r**18)+2*Q2**2*(4753+210819*r**2-692405*r**4+1030168*r**6-175406*r**8
            +1109050*r**10+485302*r**12+168184*r**14-52307*r**16+12243*r**18-881*r**20)
            -3*(-1+r**2)**2*(-343-18804*r**2+92377*r**4-221904*r**6-194522*r**8
            -120728*r**10-325098*r**12-60944*r**14+4177*r**16-980*r**18+49*r**20)
            +6*Q2*(-931-44933*r**2+224305*r**4-490581*r**6+138654*r**8-785342*r**10
            -330186*r**12-329982*r**14-89531*r**16+17539*r**18-2599*r**20+147*r**22))*sqrtq2
            +logq2**3*(-20321280*r**18*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3-20321280*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**2*(-2304*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-368*Q2**6
            +Q2**5*(1748-1867*r**2)+Q2**4*(-2760+6061*r**2+6645*r**4)-2*Q2**3*(
            -460+2572*r**2+1837*r**4+2450*r**6)+2*Q2**2*(920-1562*r**2+4119*r**4
            +3583*r**6+230*r**8)+3*(-1+r**2)**2*(184-531*r**2+5349*r**4+3389*r**6
            +429*r**8)-3*Q2*(644-2257*r**2+10678*r**4+18538*r**6+7258*r**8+419*r**10))
            -2304*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(368*Q2**7+Q2**6*(-2116
            +1499*r**2)+Q2**5*(4508-6180*r**2-8512*r**4)+5*Q2**4*(-736+1689*r**2
            +3276*r**4+2309*r**6)-4*Q2**3*(230+275*r**2+4264*r**4+3935*r**6+1340*r**8)
            +3*(-1+r**2)**2*(184-347*r**2+4818*r**4+8738*r**6+3818*r**8+429*r**10)
            +Q2**2*(3772-8055*r**2+37148*r**4+71018*r**6+29400*r**8+1717*r**10)
            -12*Q2*(207-628*r**2+3754*r**4+5344*r**6+6199*r**8+2552*r**10+212*r**12))*sqrtq2)
            +logq2*(-192*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(
            -1168*Q2**9-13140*Q2**7*(1+r**2)**2+Q2**8*(6716+6573*r**2)+4*Q2**6*(1241
            +7686*r**2+5811*r**4+3116*r**6)-4*Q2**5*(-4307+123*r**2+1503*r**4+5071*r**6
            +2046*r**8)+6*Q2**4*(-3942-2775*r**2+4732*r**4+23388*r**6+9570*r**8
            +1113*r**10)-4*Q2**3*(-1241-2088*r**2+14667*r**4+26200*r**6+29649*r**8
            +11604*r**10+1057*r**12)+3*(-1+r**2)**2*(584-1073*r**2-1402*r**4+41581*r**6
            +28596*r**8+37357*r**10+54*r**12+143*r**14)+4*Q2**2*(2555-3390*r**2
            +5703*r**4-9898*r**6+9717*r**8+4188*r**10-1135*r**12+360*r**14)-36*Q2*(219
            -501*r**2+17*r**4+3937*r**6+15241*r**8+11497*r**10+5147*r**12-301*r**14
            +24*r**16))+192*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1168*Q2**9
            +13140*Q2**7*(1+r**2)**2-Q2**8*(6716+6573*r**2)-4*Q2**6*(1241+7686*r**2
            +5811*r**4+3116*r**6)+4*Q2**5*(-4307+123*r**2+1503*r**4+5071*r**6+2046*r**8)
            -6*Q2**4*(-3942-2775*r**2+4732*r**4+23388*r**6+9570*r**8+1113*r**10)
            +4*Q2**3*(-1241-2088*r**2+14667*r**4+26200*r**6+29649*r**8+11604*r**10
            +1057*r**12)-3*(-1+r**2)**2*(584-1073*r**2-1402*r**4+41581*r**6+28596*r**8
            +37357*r**10+54*r**12+143*r**14)-4*Q2**2*(2555-3390*r**2+5703*r**4
            -9898*r**6+9717*r**8+4188*r**10-1135*r**12+360*r**14)+36*Q2*(219-501*r**2
            +17*r**4+3937*r**6+15241*r**8+11497*r**10+5147*r**12-301*r**14+24*r**16))*sqrtq2))*math.log(r)**2)/(480*(
            -Q2+(-1+r)**2)**3*r**4*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +480*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(-829440*r**16*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3-829440*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*sqrtq2)+logq2**2*(207360*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +207360*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(
            -17280*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-17280*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2))+nlo.X1Q2_Derivativer(1,Q2,r)*((4*r)/(-36*logq2*r**4
            +3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)
            -(2*muWC**2*r)/(-36*logq2*r**4+3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2)-(16*muWC*r)/(-108*logq2*r**4+9*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(2*r*math.log(mu0))/(
            -12*logq2*r**4+(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)-(2*r*math.log(r))/(-12*logq2*r**4+(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+nlo.X1Q2_Derivativer(0,Q2,r)*((360*logq2*r**5*(1
            +r**2)-2*r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)/(2160*logq2**2*r**8
            +15*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-360*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(muWC**2*(-180*logq2*r**5*(1
            +r**2)+r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(2160*logq2**2*r**8
            +15*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-360*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(muWC*(-1440*logq2*r**5*(1
            +r**2)+8*r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(6480*logq2**2*r**8
            +45*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-1080*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((180*logq2*r**5*(1+r**2)
            +r*(-3-8*Q2**4+42*r**2+282*r**4+42*r**6-3*r**8+7*Q2**3*(1+r**2)
            +Q2**2*(7-2*r**2+7*r**4)-3*Q2*(1-11*r**2-11*r**4+r**6))*sqrtq2)*math.log(mu0))/(720*logq2**2*r**8
            +5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((-180*logq2*r**5*(1+r**2)
            +r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2
            -11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*math.log(r))/(720*logq2**2*r**8
            +5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+flagPERP*muWC**3*((pi2*(
            -48*logq2*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-5+26*r**2-24*Q2**4*r**2
            +16*r**4-294*r**6-19*r**8+36*r**10+Q2**3*(-5+81*r**2+66*r**4)-Q2**2*(
            -5+34*r**2+151*r**4+24*r**6)+Q2*(5-39*r**2-11*r**4+59*r**6-54*r**8))
            +2880*logq2**2*r**6*(-1+3*r**2)*sqrtq2+8*(4*Q2**7*r**2+Q2**6*(-9+31*r**2
            +4*r**4)-3*Q2**5*(-13+47*r**2+217*r**4+21*r**6)+Q2**4*(-60+193*r**2
            +1827*r**4+1761*r**6+115*r**8)-2*Q2**3*(-15+46*r**2+625*r**4+1065*r**6
            +622*r**8+25*r**10)-(-1+r**2)**2*(-6-r**2-69*r**4+316*r**6-1454*r**8
            +477*r**10+17*r**12)-3*Q2**2*(-5+7*r**2+68*r**4+202*r**6-473*r**8
            +263*r**10+18*r**12)+Q2*(-21+37*r**2+201*r**4-933*r**6-203*r**8-3357*r**10
            +1335*r**12+61*r**14))*sqrtq2))/(-3240*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +19440*logq2**2*r**8*sqrtq2+135*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)
            +(2304*logq2**2*(-Q2+(-1+r)**2)*r**8*(-Q2+(1+r)**2)*(-996*Q2**6*r**2
            +Q2**5*(-735+7416*r**2+6171*r**4)-Q2**4*(-2205+13480*r**2+27143*r**4
            +11790*r**6)+Q2**3*(-1470+7795*r**2+17937*r**4+26822*r**6+3930*r**8)
            +(-1+r**2)**2*(-735+6194*r**2-7041*r**4-30846*r**6-1286*r**8+4374*r**10)
            +Q2**2*(-1470+7830*r**2-3283*r**4-17444*r**6-7593*r**8+12180*r**10)
            +Q2*(2205-16229*r**2+12742*r**4+73137*r**6+48842*r**8+10532*r**10
            -13869*r**12))-16*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(-716*Q2**10*r**2
            +Q2**9*(1323-4833*r**2-640*r**4)+Q2**8*(-7056+31333*r**2+143882*r**4
            +15845*r**6)-2*Q2**7*(-6615+26050*r**2+277574*r**4+254488*r**6+19115*r**8)
            +2*Q2**6*(-3087+3281*r**2+301268*r**4+607180*r**6+264419*r**8+12595*r**10)
            +2*Q2**5*(-6174+38225*r**2+80497*r**4-484838*r**6-625258*r**8+105847*r**10
            +12721*r**12)-2*Q2**4*(-9261+45586*r**2+314357*r**4-574214*r**6-1450435*r**8
            -923044*r**10+351511*r**12+22580*r**14)+2*Q2**3*(-3087+14846*r**2+115412*r**4
            -498620*r**6-1623752*r**8-1605070*r**10-742436*r**12+140564*r**14+6415*r**16)
            +(-1+r**2)**2*(-882+2347*r**2-6812*r**4+128640*r**6-942320*r**8+2469346*r**10
            +451692*r**12-719024*r**14+22834*r**16+2499*r**18)+2*Q2**2*(-2205+9005*r**2
            +42142*r**4-215294*r**6-185620*r**8+70072*r**10+140650*r**12-649738*r**14
            +79513*r**16+7315*r**18)-Q2*(-3969+17337*r**2+25630*r**4-383236*r**6
            +151070*r**8+1691842*r**10+4798136*r**12+1458308*r**14-2259101*r**16
            +125573*r**18+11690*r**20))-69120*logq2**3*r**12*(-115+441*r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+96*logq2*r**4*(5064*Q2**11*r**2+Q2**10*(895
            -42411*r**2-39054*r**4)+2*Q2**9*(-2685+67105*r**2+123621*r**4+59943*r**6)
            -Q2**8*(-11635+193303*r**2+558859*r**4+551141*r**6+170724*r**8)+8*Q2**7*(
            -895+8338*r**2+70406*r**4+131559*r**6+75251*r**8+7437*r**10)+2*Q2**6*(
            -6265+98939*r**2-135278*r**4-934172*r**6-988245*r**8-212893*r**10+77574*r**12)
            -4*Q2**5*(-6265+81385*r**2-45287*r**4-719057*r**6-1115171*r**8-793523*r**10
            -87961*r**12+55839*r**14)-(-1+r**2)**4*(-895+9579*r**2-18035*r**4-134277*r**6
            +345643*r**8+852173*r**10-296981*r**12-57187*r**14+4140*r**16)+2*Q2**4*(
            -6265+90415*r**2-113611*r**4-1026435*r**6-1431345*r**8-1812709*r**10
            -1007235*r**12-54511*r**14+41232*r**16)+8*Q2**3*(-895+5621*r**2+1138*r**4
            -33051*r**6+54274*r**8+178419*r**10+218386*r**12-140097*r**14-56503*r**16
            +7428*r**18)+2*Q2*(-1+r**2)**2*(-2685+28279*r**2-53864*r**4-347152*r**6
            +814110*r**8+1754634*r**10+1475440*r**12-709792*r**14-156649*r**16+14319*r**18)
            +Q2**2*(11635-122539*r**2+259442*r**4+1109384*r**6-2493070*r**8-5207242*r**10
            -2582404*r**12-4874920*r**14+2029883*r**16+676117*r**18-72846*r**20))*sqrtq2)/(
            -699840*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))-1620*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3+2799360*logq2**3*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            +58320*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)+((36864*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(24*Q2**6
            -3*Q2**5*(33+23*r**2)+Q2**4*(130+167*r**2+45*r**4)-Q2**3*(55+78*r**2
            +53*r**4+15*r**6)+(-1+r**2)**2*(19-96*r**2-36*r**4-31*r**6+54*r**8)
            +Q2**2*(15-98*r**2-49*r**4-3*r**6+105*r**8)+Q2*(-34+242*r**2+177*r**4
            -8*r**6+127*r**8-144*r**10))+256*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(4*Q2**10+Q2**9*(27+20*r**2)-Q2**8*(212+1345*r**2+169*r**4)
            +Q2**7*(397+5423*r**2+4807*r**4+377*r**6)-Q2**6*(251+5930*r**2+11452*r**4
            +5198*r**6+337*r**8)+Q2**5*(211-2431*r**2+1178*r**4+3670*r**6+119*r**8
            +41*r**10)+Q2**4*(-587+7970*r**2+11611*r**4+16520*r**6+2543*r**8+1858*r**10
            +125*r**12)-Q2**3*(-487+3575*r**2+6505*r**4+10603*r**6+7967*r**8-575*r**10
            -145*r**12+61*r**14)+(-1+r**2)**2*(115+121*r**2-345*r**4+14821*r**6
            -38699*r**8+18831*r**10-95*r**12+931*r**14)+Q2**2*(163-778*r**2+3074*r**4
            -13058*r**6-484*r**8+13682*r**10+790*r**12+938*r**14-7*r**16)+Q2*(
            -354+755*r**2-2072*r**4-7820*r**6+11756*r**8+54502*r**10-37832*r**12
            +620*r**14-2282*r**16+7*r**18))-1105920*logq2**3*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2+1536*logq2*r**4*(48*Q2**11*r**2+Q2**10*(5-402*r**2
            -366*r**4)+2*Q2**9*(-15+650*r**2+1185*r**4+564*r**6)-Q2**8*(-65+2012*r**2
            +5075*r**4+4990*r**6+1752*r**8)+4*Q2**7*(-10+319*r**2+707*r**4+606*r**6
            +1019*r**8+327*r**10)+Q2**6*(-70+368*r**2+4720*r**4+14416*r**6+9594*r**8
            -232*r**10-168*r**12)-4*Q2**5*(-35+251*r**2+2099*r**4+5657*r**6+5801*r**8
            +3137*r**10+205*r**12+105*r**14)+(-1+r**2)**4*(5+36*r**2-29*r**4+2106*r**6
            -4733*r**8-2968*r**10+3001*r**12+386*r**14+36*r**16)+2*Q2**4*(-35+230*r**2
            +2665*r**4+5046*r**6+1479*r**8+4390*r**10+5205*r**12+10*r**14+186*r**16)
            -4*Q2**3*(10+7*r**2+425*r**4+660*r**6-4219*r**8-4086*r**10+371*r**12
            +4980*r**14+325*r**16+87*r**18)-2*Q2*(-1+r**2)**2*(15+58*r**2-44*r**4
            +3572*r**6-7314*r**8-8904*r**10-3992*r**12+7040*r**14+839*r**16+90*r**18)
            +Q2**2*(65+34*r**2+142*r**4+7216*r**6-24722*r**8-8900*r**10-13172*r**12
            -20960*r**14+23041*r**16+2354*r**18+342*r**20))*sqrtq2)*math.log(mu0))/(-233280*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -540*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +933120*logq2**3*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+19440*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)
            +((240*logq2*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-5+26*r**2-24*Q2**4*r**2
            +16*r**4-294*r**6-19*r**8+36*r**10+Q2**3*(-5+81*r**2+66*r**4)-Q2**2*(
            -5+34*r**2+151*r**4+24*r**6)+Q2*(5-39*r**2-11*r**4+59*r**6-54*r**8))
            -14400*logq2**2*r**6*(-1+3*r**2)*sqrtq2+(25*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(
            -15+24*Q2**4-22*r**2-22*r**4-70*r**6+9*r**8-21*Q2**3*(1+r**2)+Q2**2*(
            -21+38*r**2-21*r**4)+Q2*(-15+29*r**2-43*r**4+9*r**6))-15*(Q2-(
            -1+r)**2)*(Q2-(1+r)**2)*(-3+5*Q2**3+5*r**2-19*r**4+5*r**6-5*Q2**2*(1
            +r**2)+Q2*(-5+8*r**2-5*r**4))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7
            +2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8)))*sqrtq2)*math.log(mus))/(-1944*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+11664*logq2**2*r**8*sqrtq2+81*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)
            +((-48*logq2*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-5+26*r**2-24*Q2**4*r**2
            +16*r**4-294*r**6-19*r**8+36*r**10+Q2**3*(-5+81*r**2+66*r**4)-Q2**2*(
            -5+34*r**2+151*r**4+24*r**6)+Q2*(5-39*r**2-11*r**4+59*r**6-54*r**8))
            +2880*logq2**2*r**6*(-1+3*r**2)*sqrtq2+8*(4*Q2**7*r**2+Q2**6*(-9+31*r**2
            +4*r**4)-3*Q2**5*(-13+47*r**2+217*r**4+21*r**6)+Q2**4*(-60+193*r**2
            +1827*r**4+1761*r**6+115*r**8)-2*Q2**3*(-15+46*r**2+625*r**4+1065*r**6
            +622*r**8+25*r**10)-(-1+r**2)**2*(-6-r**2-69*r**4+316*r**6-1454*r**8
            +477*r**10+17*r**12)-3*Q2**2*(-5+7*r**2+68*r**4+202*r**6-473*r**8
            +263*r**10+18*r**12)+Q2*(-21+37*r**2+201*r**4-933*r**6-203*r**8-3357*r**10
            +1335*r**12+61*r**14))*sqrtq2)*math.log(2*muWC))/(-360*logq2*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))+2160*logq2**2*r**8*sqrtq2+15*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)
            +((-46080*logq2**2*(-Q2+(-1+r)**2)*r**8*(-Q2+(1+r)**2)*(60*Q2**6*r**2
            +Q2**5*(1-252*r**2-177*r**4)+Q2**4*(-3+336*r**2+445*r**4+126*r**6)
            -Q2**3*(-2+145*r**2+215*r**4+166*r**6+42*r**8)+(-1+r**2)**2*(1+38*r**2
            -225*r**4-46*r**6-74*r**8+126*r**10)+Q2**2*(2+26*r**2-235*r**4-96*r**6
            +3*r**8+240*r**10)+Q2*(-3-61*r**2+574*r**4+333*r**6-86*r**8+296*r**10
            -333*r**12))-64*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(44*Q2**10*r**2
            +3*Q2**9*(3+99*r**2+80*r**4)-Q2**8*(48+2377*r**2+15454*r**4+1957*r**6)
            +Q2**7*(90+4496*r**2+62480*r**4+55268*r**6+4346*r**8)-2*Q2**6*(21+1511*r**2
            +34176*r**4+65828*r**6+29955*r**8+1973*r**10)+Q2**5*(-84+3098*r**2
            -28606*r**4+7796*r**6+36332*r**8+2894*r**10+674*r**12)+2*Q2**4*(63
            -3896*r**2+46549*r**4+74836*r**6+110785*r**8+21814*r**10+8959*r**12
            +610*r**14)-2*Q2**3*(21-3076*r**2+21054*r**4+43130*r**6+75818*r**8
            +59588*r**10+1538*r**12-1842*r**14+329*r**16)+2*Q2**2*(-15+1057*r**2
            -4466*r**4+17314*r**6-81032*r**8-2480*r**10+84538*r**12+406*r**14+6271*r**16
            +7*r**18)+(-1+r**2)**2*(-6+1421*r**2+1432*r**4-3340*r**6+174668*r**8
            -456014*r**10+233144*r**12-6052*r**14+11530*r**16+17*r**18)+Q2*(27
            -4443*r**2+9050*r**4-22708*r**6-96570*r**8+132122*r**10+633248*r**12
            -472140*r**14+22943*r**16-28735*r**18+6*r**20))-276480*logq2**3*r**12*(
            -13+3*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-384*logq2*r**4*(552*Q2**11*r**2
            +Q2**10*(55-4623*r**2-4206*r**4)+2*Q2**9*(-165+7485*r**2+13637*r**4
            +6483*r**6)-Q2**8*(-715+23267*r**2+58203*r**4+57217*r**6+20244*r**8)
            +8*Q2**7*(-55+1892*r**2+3840*r**4+2807*r**6+5713*r**8+1947*r**10)+Q2**6*(
            -770+3150*r**2+59508*r**4+188840*r**6+130662*r**8+62*r**10-3108*r**12)
            -4*Q2**5*(-385+2513*r**2+25953*r**4+74007*r**6+78461*r**8+43725*r**10
            +3103*r**12+903*r**14)+(-1+r**2)**4*(55+505*r**2-477*r**4+24817*r**6
            -55475*r**8-30465*r**10+34645*r**12+4327*r**14+468*r**16)+2*Q2**4*(
            -385+2195*r**2+33333*r**4+68633*r**6+27807*r**8+65967*r**10+70445*r**12
            +493*r**14+1992*r**16)-8*Q2**3*(55+81*r**2+2604*r**4+3807*r**6-25404*r**8
            -23747*r**10+3752*r**12+29469*r**14+1601*r**16+582*r**18)-2*Q2*(-1
            +r**2)**2*(165+901*r**2-904*r**4+41280*r**6-83822*r**8-96850*r**10-38736*r**12
            +81184*r**14+9185*r**16+1197*r**18)+Q2**2*(715+1249*r**2-30*r**4+80616*r**6
            -285086*r**8-73314*r**10-143364*r**12-222920*r**14+267699*r**16+24161*r**18
            +4674*r**20))*sqrtq2)*math.log(r))/(-699840*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-1620*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+2799360*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+58320*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2))+muWC**3*((pi2*(
            -48*logq2*(24*Q2**6*(1+5*r**4)-Q2**5*(99+64*r**2+315*r**4+570*r**6)
            +Q2**4*(135+117*r**2+285*r**4+835*r**6+900*r**8)-2*Q2**3*(15+49*r**2
            +64*r**4+315*r**6+275*r**8+150*r**10)-(-1+r**2)**2*(21-89*r**2+506*r**4
            +2986*r**6-99*r**8-145*r**10+180*r**12)-2*Q2**2*(45-116*r**2+232*r**4
            +544*r**6-265*r**8-180*r**10+300*r**12)+Q2*(81-318*r**2+1207*r**4
            +6102*r**6+6587*r**8-14*r**10-835*r**12+630*r**14))+2880*logq2**2*r**4*(3
            +10*r**2+15*r**4)*sqrtq2-8*(6*Q2**8+4*Q2**7*(3+r**2)+2*Q2**6*(15+62*r**2
            +29*r**4)-3*Q2**5*(213+125*r**2+943*r**4+151*r**6)+Q2**4*(1455+256*r**2
            +2430*r**4+7200*r**6+835*r**8)-2*Q2**3*(393-302*r**2+1597*r**4+627*r**6
            +2110*r**8+223*r**10)-6*Q2**2*(142-373*r**2+436*r**4-746*r**6-790*r**8
            +727*r**10+44*r**12)-(-1+r**2)**2*(351-2656*r**2+9501*r**4+5656*r**6
            -4919*r**8+2040*r**10+107*r**12)+Q2*(1125-6209*r**2+15555*r**4+24657*r**6
            +13387*r**8-14463*r**10+5901*r**12+367*r**14))*sqrtq2))/(-9720*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+58320*logq2**2*r**8*sqrtq2+405*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)+(-64*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-954*Q2**13
            +2*Q2**12*(261+689*r**2)-2*Q2**11*(-3015+12316*r**2+6519*r**4)+Q2**10*(72783
            +191159*r**2+926837*r**4+150221*r**6)-2*Q2**9*(223065+348923*r**2+1845085*r**4
            +2414149*r**6+278910*r**8)+Q2**8*(863973+1162749*r**2+6006730*r**4+11643754*r**6
            +9719465*r**8+937233*r**10)-4*Q2**7*(87831+355479*r**2+1161653*r**4
            +2898582*r**6+3371817*r**8+1559755*r**10+148659*r**12)-2*Q2**6*(586305
            -1869993*r**2+206605*r**4+166407*r**6-5226999*r**8-5573405*r**10+3457601*r**12
            +191127*r**14)+2*Q2**5*(965277-3824244*r**2+4773686*r**4+9504788*r**6
            +5338136*r**8-5000296*r**10-10408138*r**12+6994888*r**14+442719*r**16)
            +(-1+r**2)**4*(55413-716099*r**2+4625692*r**4-8784204*r**6-9285854*r**8
            -940406*r**10+4572036*r**12-3505940*r**14+259081*r**16+17241*r**18)
            -4*Q2**4*(220905-1437234*r**2+3294590*r**4+3196530*r**6-1325053*r**8
            -305347*r**10+667808*r**12-4860180*r**14+1654438*r**16+111495*r**18)
            -2*Q2*(-1+r**2)**2*(171135-1895153*r**2+10076320*r**4-11105572*r**6
            -32218570*r**8-23301818*r**10+2196044*r**12+9429476*r**14-9096437*r**16
            +876011*r**18+56404*r**20)-2*Q2**3*(250497-1391818*r**2+3668215*r**4
            +3361752*r**6-1974486*r**8+132556*r**10+11021830*r**12-1464040*r**14
            -6754043*r**16+1370510*r**18+73427*r**20)+Q2**2*(768627-7372057*r**2
            +33049837*r**4-29039999*r**6-61244166*r**8-112555358*r**10-58687034*r**12
            +4173390*r**14+42417811*r**16-35088137*r**18+4065613*r**20+262833*r**22))
            -64*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(954*Q2**14-4*Q2**13*(369
            +583*r**2)+4*Q2**12*(-1377+6633*r**2+3604*r**4)-Q2**11*(66753+209761*r**2
            +964507*r**4+163259*r**6)+Q2**10*(518913+961788*r**2+4808166*r**4+5905356*r**6
            +708041*r**8)-Q2**9*(1310103+2306725*r**2+10394746*r**4+20162222*r**6
            +15105583*r**8+1495053*r**10)+Q2**8*(1215297+3448638*r**2+11816091*r**4
            +29244812*r**6+34850487*r**8+16895718*r**10+1531869*r**12)-2*Q2**7*(
            -410643+2756613*r**2+2827659*r**4+7954063*r**6+17767797*r**8+15436549*r**10
            -40773*r**12+106191*r**14)-4*Q2**6*(775791-2553966*r**2+1555149*r**4
            +4938900*r**6+138772*r**8-7900350*r**10-6261971*r**12+5321808*r**14
            +316923*r**16)+2*Q2**5*(1407087-5733435*r**2+7538622*r**4+20671534*r**6
            +12192818*r**8-272854*r**10-14072818*r**12-13133610*r**14+10746483*r**16
            +665709*r**18)+(-1+r**2)**4*(55413-660686*r**2+3909593*r**4-4158512*r**6
            -18070058*r**8-10226260*r**10+3631630*r**12+1066096*r**14-3246859*r**16
            +276322*r**18+17241*r**20)-2*Q2**4*(191313-1040840*r**2+46497*r**4+9620488*r**6
            +5717440*r**8-3393356*r**10-10296908*r**12-6920704*r**14+342559*r**16
            +2161356*r**18+149563*r**20)+Q2**3*(-1269621+9654699*r**2-37602631*r**4
            +14980065*r**6+58469634*r**8+116239218*r**10+36378262*r**12-23288970*r**14
            -25981645*r**16+45855203*r**18-6953487*r**20-409687*r**22)-Q2*(-1+r**2)**2*(397683
            -4274961*r**2+22475637*r**4-20810191*r**6-73740038*r**8-102193678*r**10
            -45044554*r**12+9660622*r**14+12509075*r**16-20447713*r**18+2089429*r**20
            +130049*r**22)+Q2**2*(1110897-11078276*r**2+53753302*r**4-62296892*r**6
            -90146377*r**8-113740024*r**10-138080172*r**12-91042504*r**14-4927489*r**16
            +64326396*r**18-52606634*r**20+5854852*r**22+375641*r**24))*sqrtq2+logq2**3*(276480*r**12*(1
            -Q2+r**2)*(249+1150*r**2+1773*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3
            +276480*r**12*(249+1150*r**2+1773*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*sqrtq2)+logq2**2*(9216*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(12*Q2**8*(
            -19+65*r**4)+3*Q2**7*(-62-1457*r**2-2600*r**4+645*r**6)+Q2**6*(4521
            +30855*r**2+54221*r**4+1135*r**6-21960*r**8)+3*Q2**5*(-3484-20193*r**2
            -39848*r**4-12774*r**6+15140*r**8+13415*r**10)+3*Q2**4*(2305+8425*r**2
            +23009*r**4+24315*r**6-24380*r**8-16000*r**10+1950*r**12)+(-1+r**2)**4*(
            -1383-1443*r**2+39017*r**4+243777*r**6-2148*r**8-5570*r**10+13230*r**12)
            +Q2**3*(5718+40575*r**2-73738*r**4-685403*r**6-711120*r**8+79043*r**10
            +35620*r**12-98055*r**14)-3*Q2*(-1+r**2)**2*(-2248-5421*r**2+52984*r**4
            +361639*r**6+342114*r**8-553*r**10-9090*r**12+21855*r**14)+3*Q2**2*(
            -3883-12873*r**2+75099*r**4+474759*r**6+488339*r**8+501457*r**10+577*r**12
            -42095*r**14+41180*r**16))-9216*r**8*(12*Q2**11*(-19+65*r**4)-3*Q2**10*(
            -166+1229*r**2+3380*r**4+135*r**6)+5*Q2**9*(879+8814*r**2+18478*r**4
            +4058*r**6-5085*r**8)+15*Q2**8*(-1623-12028*r**2-27232*r**4-15086*r**6
            +5943*r**8+7410*r**10)+5*Q2**7*(10404+68832*r**2+170115*r**4+147407*r**6
            +625*r**8-67155*r**10-36540*r**12)-(-1+r**2)**6*(-1383-2826*r**2+37574*r**4
            +282794*r**6+241629*r**8-7718*r**10+7660*r**12+13230*r**14)+Q2**6*(
            -50904-284970*r**2-886635*r**4-1567690*r**6-963090*r**8+464026*r**10
            +355725*r**12+27090*r**14)+Q2*(-1+r**2)**4*(-10893-30102*r**2+252705*r**4
            +2048905*r**6+2709420*r**8+1735008*r**10-6823*r**12+48045*r**14+105255*r**16)
            +3*Q2**5*(798-12572*r**2+217225*r**4+1334355*r**6+1881810*r**8+1138518*r**10
            -172047*r**12-25485*r**14+131670*r**16)-15*Q2**2*(-1+r**2)**2*(-2402
            -7515*r**2+49087*r**4+385860*r**6+517057*r**8+509820*r**10+352945*r**12
            -1120*r**14-655*r**16+23995*r**18)-5*Q2**4*(-10386-53676*r**2+180903*r**4
            +1553398*r**6+2243777*r**8+2240256*r**10+1517809*r**12-60082*r**14-26247*r**16
            +147240*r**18)+5*Q2**3*(-12456-39696*r**2+253221*r**4+1629025*r**6+1278153*r**8
            +1152085*r**10+1322423*r**12+1718019*r**14-7717*r**16-120489*r**18+135720*r**20))*sqrtq2)
            +logq2*(-384*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -24*Q2**11*(147+1343*r**4)+Q2**10*(25137+18200*r**2+194061*r**4+248838*r**6)
            -2*Q2**9*(35280+43557*r**2+248293*r**4+549555*r**6+381795*r**8)-4*Q2**7*r**2*(49597
            +129251*r**2+315109*r**4+625215*r**6+487570*r**8+83010*r**10)+Q2**8*(85995
            +164084*r**2+668062*r**4+1843984*r**6+2264063*r**8+1078260*r**10)-2*Q2**6*(64827
            -144970*r**2-90691*r**4+805546*r**6+84727*r**8-1471986*r**10-366163*r**12
            +545118*r**14)+4*Q2**5*(37044-93058*r**2+58552*r**4+1421233*r**6+1182247*r**8
            +87400*r**10-1226030*r**12-196279*r**14+382011*r**16)+(-1+r**2)**4*(3087
            -27460*r**2+181464*r**4+577192*r**6-5308614*r**8-3334568*r**10+2067224*r**12
            -786680*r**14-254233*r**16+31068*r**18)-2*Q2**4*(19845-62062*r**2+53692*r**4
            +2213966*r**6+605028*r**8-1172850*r**10-384088*r**12-1352718*r**14-225565*r**16
            +275280*r**18)-2*Q2*(-1+r**2)**2*(10584-86217*r**2+471457*r**4+1491406*r**6
            -9322318*r**8-16541628*r**10-5038716*r**12+3974290*r**14-1763194*r**16
            -707035*r**18+105291*r**20)-4*Q2**3*(13230-78869*r**2+278083*r**4+597329*r**6
            -768285*r**8-3649285*r**10+471993*r**12+1231571*r**14-912309*r**16-477578*r**18
            +108840*r**20)+Q2**2*(55125-429052*r**2+1986949*r**4+4260454*r**6-22673906*r**8
            -39810056*r**10-44799074*r**12-16064300*r**14+14655325*r**16-4160060*r**18
            -3174115*r**20+528390*r**22))+384*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(24*Q2**11*(147+1343*r**4)-Q2**10*(25137+18200*r**2+194061*r**4
            +248838*r**6)+2*Q2**9*(35280+43557*r**2+248293*r**4+549555*r**6+381795*r**8)
            +4*Q2**7*r**2*(49597+129251*r**2+315109*r**4+625215*r**6+487570*r**8
            +83010*r**10)-Q2**8*(85995+164084*r**2+668062*r**4+1843984*r**6+2264063*r**8
            +1078260*r**10)+2*Q2**6*(64827-144970*r**2-90691*r**4+805546*r**6+84727*r**8
            -1471986*r**10-366163*r**12+545118*r**14)-4*Q2**5*(37044-93058*r**2
            +58552*r**4+1421233*r**6+1182247*r**8+87400*r**10-1226030*r**12-196279*r**14
            +382011*r**16)-(-1+r**2)**4*(3087-27460*r**2+181464*r**4+577192*r**6
            -5308614*r**8-3334568*r**10+2067224*r**12-786680*r**14-254233*r**16
            +31068*r**18)+2*Q2**4*(19845-62062*r**2+53692*r**4+2213966*r**6+605028*r**8
            -1172850*r**10-384088*r**12-1352718*r**14-225565*r**16+275280*r**18)
            +2*Q2*(-1+r**2)**2*(10584-86217*r**2+471457*r**4+1491406*r**6-9322318*r**8
            -16541628*r**10-5038716*r**12+3974290*r**14-1763194*r**16-707035*r**18
            +105291*r**20)+4*Q2**3*(13230-78869*r**2+278083*r**4+597329*r**6-768285*r**8
            -3649285*r**10+471993*r**12+1231571*r**14-912309*r**16-477578*r**18
            +108840*r**20)+Q2**2*(-55125+429052*r**2-1986949*r**4-4260454*r**6+22673906*r**8
            +39810056*r**10+44799074*r**12+16064300*r**14-14655325*r**16+4160060*r**18
            +3174115*r**20-528390*r**22))*sqrtq2))/(19440*(-Q2+(-1+r)**2)**3*r**4*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+19440*(-Q2+(-1+r)**2)**3*r**4*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(
            -33592320*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-33592320*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**2*(8398080*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+8398080*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)+logq2*(-699840*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2-699840*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2))+((-36864*logq2**2*r**6*(24*Q2**8*(2
            +5*r**4)-3*Q2**7*(103+93*r**2+235*r**4+195*r**6)+Q2**6*(789+1125*r**2
            +2344*r**4+2075*r**6+1035*r**8)-3*Q2**5*(311+507*r**2+1147*r**4+1071*r**6
            +590*r**8+290*r**10)+(-1+r**2)**4*(-57+33*r**2-512*r**4-912*r**6-357*r**8
            +95*r**10+270*r**12)+3*Q2**4*(95+225*r**2+376*r**4+315*r**6+315*r**8
            +310*r**10+300*r**12)+Q2**3*(537-225*r**2+2863*r**4+5558*r**6+1860*r**8
            -428*r**10-1360*r**12-1845*r**14)-3*Q2*(-1+r**2)**2*(-107+71*r**2-864*r**4
            -1879*r**6-1484*r**8-192*r**10+195*r**12+420*r**14)+3*Q2**2*(-227+273*r**2
            -1554*r**4-2514*r**6-2774*r**8-1327*r**10-262*r**12-40*r**14+745*r**16))
            -256*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(28*Q2**12*r**2+8*Q2**11*r**2*(17
            +12*r**2)-Q2**10*(144+595*r**2+6562*r**4+1555*r**6)+Q2**9*(882-679*r**2
            +24181*r**4+34003*r**6+5685*r**8)-2*Q2**8*(999-3174*r**2+16810*r**4
            +43744*r**6+34091*r**8+5130*r**10)+4*Q2**7*(378-3579*r**2-2408*r**4
            +16929*r**6+20829*r**8+13010*r**10+2541*r**12)+2*Q2**6*(756+8955*r**2
            +85778*r**4+67443*r**6+46848*r**8+26603*r**10+6286*r**12-2541*r**14)
            +2*Q2**5*(-1890-5913*r**2-183595*r**4-182377*r**6-184963*r**8-58429*r**10
            -70627*r**12-21833*r**14+315*r**16)+2*(-1+r**2)**4*(-63-484*r**2-11632*r**4
            +45552*r**6-58534*r**8-63676*r**10+50640*r**12+1328*r**14+2309*r**16)
            +4*Q2**4*(567-264*r**2+71986*r**4+27402*r**6+52234*r**8+56296*r**10
            -30962*r**12+27186*r**14+7463*r**16+60*r**18)+Q2*(-1+r**2)**2*(738
            +4645*r**2+126385*r**4-335668*r**6+291944*r**8+682954*r**10+249938*r**12
            -436492*r**14-10634*r**16-20911*r**18+61*r**20)+4*Q2**3*(162+2423*r**2
            +12310*r**4+17547*r**6+70191*r**8+30919*r**10-109883*r**12-26719*r**14
            -15773*r**16-7162*r**18+65*r**20)-Q2**2*(1512+8347*r**2+213698*r**4
            -442333*r**6+522312*r**8+338306*r**10+919124*r**12+125490*r**14-538384*r**16
            -7549*r**18-34870*r**20+267*r**22))+2211840*logq2**3*r**10*(3+5*r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-3072*logq2*r**4*(120*Q2**11*r**2
            +Q2**10*(28-651*r**2-915*r**4)+Q2**9*(-141+1334*r**2+3939*r**4+2820*r**6)
            -Q2**8*(-367+655*r**2+6247*r**4+7829*r**6+4380*r**8)+2*Q2**7*(-430
            -3086*r**2-691*r**4-213*r**6+1721*r**8+1635*r**10)+Q2**6*(1708+22810*r**2
            +32366*r**4+38654*r**6+23526*r**8+8092*r**10-420*r**12)-2*Q2**5*(1015
            +16730*r**2+29291*r**4+39173*r**6+25007*r**8+11312*r**10+6211*r**12
            +525*r**14)+(-1+r**2)**4*(-113-2091*r**2+4289*r**4-5523*r**6-23113*r**8
            -365*r**10+8543*r**12+1003*r**14+90*r**16)+2*Q2**4*(413+8023*r**2+16382*r**4
            +12591*r**6+17544*r**8+7547*r**10+5748*r**12+4343*r**14+465*r**16)
            -2*Q2**3*(-434-6590*r**2+3935*r**4-28737*r**6-27061*r**8+4707*r**10
            +15833*r**12+19929*r**14+3583*r**16+435*r**18)-Q2*(-1+r**2)**2*(-627
            -11084*r**2+15172*r**4-24730*r**6-102258*r**8-71406*r**10+13036*r**12
            +38930*r**14+4277*r**16+450*r**18)+Q2**2*(-1280-20743*r**2+30665*r**4
            -68914*r**6-102646*r**8-117028*r**10-61000*r**12-1558*r**14+58526*r**16
            +6643*r**18+855*r**20))*sqrtq2)*math.log(mu0))/(-699840*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-1620*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+2799360*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+58320*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((240*logq2*(24*Q2**6*(1
            +5*r**4)-Q2**5*(99+64*r**2+315*r**4+570*r**6)+Q2**4*(135+117*r**2
            +285*r**4+835*r**6+900*r**8)-2*Q2**3*(15+49*r**2+64*r**4+315*r**6
            +275*r**8+150*r**10)-(-1+r**2)**2*(21-89*r**2+506*r**4+2986*r**6-99*r**8
            -145*r**10+180*r**12)-2*Q2**2*(45-116*r**2+232*r**4+544*r**6-265*r**8
            -180*r**10+300*r**12)+Q2*(81-318*r**2+1207*r**4+6102*r**6+6587*r**8
            -14*r**10-835*r**12+630*r**14))-14400*logq2**2*r**4*(3+10*r**2+15*r**4)*sqrtq2
            +40*(6*Q2**8+4*Q2**7*(3+r**2)+2*Q2**6*(15+62*r**2+29*r**4)-3*Q2**5*(213
            +125*r**2+943*r**4+151*r**6)+Q2**4*(1455+256*r**2+2430*r**4+7200*r**6
            +835*r**8)-2*Q2**3*(393-302*r**2+1597*r**4+627*r**6+2110*r**8+223*r**10)
            -6*Q2**2*(142-373*r**2+436*r**4-746*r**6-790*r**8+727*r**10+44*r**12)
            -(-1+r**2)**2*(351-2656*r**2+9501*r**4+5656*r**6-4919*r**8+2040*r**10
            +107*r**12)+Q2*(1125-6209*r**2+15555*r**4+24657*r**6+13387*r**8-14463*r**10
            +5901*r**12+367*r**14))*sqrtq2)*math.log(mus))/(-5832*logq2*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))+34992*logq2**2*r**8*sqrtq2+243*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)
            +((-48*logq2*(24*Q2**6*(1+5*r**4)-Q2**5*(99+64*r**2+315*r**4+570*r**6)
            +Q2**4*(135+117*r**2+285*r**4+835*r**6+900*r**8)-2*Q2**3*(15+49*r**2
            +64*r**4+315*r**6+275*r**8+150*r**10)-(-1+r**2)**2*(21-89*r**2+506*r**4
            +2986*r**6-99*r**8-145*r**10+180*r**12)-2*Q2**2*(45-116*r**2+232*r**4
            +544*r**6-265*r**8-180*r**10+300*r**12)+Q2*(81-318*r**2+1207*r**4
            +6102*r**6+6587*r**8-14*r**10-835*r**12+630*r**14))+2880*logq2**2*r**4*(3
            +10*r**2+15*r**4)*sqrtq2-8*(6*Q2**8+4*Q2**7*(3+r**2)+2*Q2**6*(15+62*r**2
            +29*r**4)-3*Q2**5*(213+125*r**2+943*r**4+151*r**6)+Q2**4*(1455+256*r**2
            +2430*r**4+7200*r**6+835*r**8)-2*Q2**3*(393-302*r**2+1597*r**4+627*r**6
            +2110*r**8+223*r**10)-6*Q2**2*(142-373*r**2+436*r**4-746*r**6-790*r**8
            +727*r**10+44*r**12)-(-1+r**2)**2*(351-2656*r**2+9501*r**4+5656*r**6
            -4919*r**8+2040*r**10+107*r**12)+Q2*(1125-6209*r**2+15555*r**4+24657*r**6
            +13387*r**8-14463*r**10+5901*r**12+367*r**14))*sqrtq2)*math.log(2*muWC))/(
            -1080*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+6480*logq2**2*r**8*sqrtq2
            +45*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((9216*logq2**2*r**6*(12*Q2**8*(49
            +125*r**4)-Q2**7*(3774+3379*r**2+8700*r**4+7425*r**6)+Q2**6*(9609+13535*r**2
            +28409*r**4+25895*r**6+13500*r**8)-3*Q2**5*(3776+6057*r**2+13732*r**4
            +13106*r**6+7500*r**8+3925*r**10)+(-1+r**2)**4*(-687+413*r**2-6587*r**4
            -12867*r**6-4472*r**8+1250*r**10+3150*r**12)+Q2**4*(3435+8075*r**2
            +13143*r**4+11145*r**6+12080*r**8+11520*r**10+11250*r**12)+Q2**3*(6522
            -3025*r**2+35738*r**4+72833*r**6+28400*r**8-5473*r**10-16660*r**12
            -21375*r**14)-Q2*(-1+r**2)**2*(-3876+2713*r**2-32992*r**4-76707*r**6
            -62242*r**8-7511*r**10+7590*r**12+14625*r**14)+3*Q2**2*(-2747+3423*r**2
            -19609*r**4-34109*r**6-37689*r**8-20047*r**10-3467*r**12+45*r**14+8600*r**16))
            +64*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-6*Q2**13+Q2**12*(6+350*r**2)
            +2*Q2**11*(-3+772*r**2+547*r**4)-Q2**10*(1035+6311*r**2+75377*r**4
            +18053*r**6)+2*Q2**9*(3573-5899*r**2+138807*r**4+195267*r**6+32960*r**8)
            -Q2**8*(17577-82503*r**2+384418*r**4+1012050*r**6+783277*r**8+119373*r**10)
            +4*Q2**7*(3771-44937*r**2-32455*r**4+189946*r**6+235561*r**8+150551*r**10
            +30075*r**12)+2*Q2**6*(5589+119463*r**2+1032457*r**4+828455*r**6+637165*r**8
            +372035*r**10+63805*r**12-32169*r**14)+2*Q2**5*(-16677-96312*r**2-2192258*r**4
            -2171616*r**6-2250180*r**8-810468*r**10-941346*r**12-239396*r**14+6573*r**16)
            +4*Q2**4*(5451+6072*r**2+850094*r**4+319570*r**6+648603*r**8+685413*r**10
            -361848*r**12+359284*r**14+85364*r**16+45*r**18)+(-1+r**2)**4*(-1161
            -16729*r**2-253532*r**4+1051340*r**6-1518490*r**8-1521842*r**10+1241276*r**12
            +11924*r**14+56707*r**16+107*r**18)+2*Q2*(-1+r**2)**2*(3339+41353*r**2
            +704458*r**4-1968236*r**6+2040182*r**8+4336858*r**10+1456096*r**12-2671444*r**14
            -11585*r**16-129443*r**18+22*r**20)+2*Q2**3*(2229+69086*r**2+280819*r**4
            +398720*r**6+1746394*r**8+737748*r**10-2729514*r**12-614960*r**14-334015*r**16
            -179714*r**18+1127*r**20)-Q2**2*(13215+152567*r**2+2388105*r**4-5192247*r**6
            +6872834*r**8+4958498*r**10+11687406*r**12+1331678*r**14-6683425*r**16
            +112359*r**18-436215*r**20+1625*r**22))-1382400*logq2**3*r**10*(15+26*r**2
            +3*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+384*logq2*r**2*(24*Q2**11*(
            -1+115*r**4)+Q2**10*(171+808*r**2-14937*r**4-21030*r**6)+Q2**9*(-480
            -4038*r**2+30306*r**4+90790*r**6+64830*r**8)+4*Q2**7*r**2*(-5591-37769*r**2
            -10107*r**4-7793*r**6+17942*r**8+19470*r**10)-Q2**8*(-585-10084*r**2
            +13550*r**4+143448*r**6+179779*r**8+101220*r**10)+Q2**6*(-882+43708*r**2
            +554226*r**4+778740*r**6+957878*r**8+622236*r**10+209666*r**12-15540*r**14)
            -4*Q2**5*(-252+13034*r**2+202928*r**4+347577*r**6+472671*r**8+310940*r**10
            +156186*r**12+79729*r**14+4515*r**16)+(-1+r**2)**4*(21-2948*r**2-49904*r**4
            +108336*r**6-176186*r**8-585872*r**10+5952*r**12+200608*r**14+22453*r**16
            +2340*r**18)+2*Q2**4*(-135+10514*r**2+194372*r**4+384246*r**6+304076*r**8
            +439494*r**10+186048*r**12+154682*r**14+109735*r**16+9960*r**18)-4*Q2**3*(90
            -5839*r**2-78855*r**4+51855*r**6-358539*r**8-357267*r**10+58871*r**12
            +199837*r**14+230853*r**16+40054*r**18+5820*r**20)-2*Q2*(-1+r**2)**2*(72
            -8247*r**2-132293*r**4+194810*r**6-375426*r**8-1367900*r**10-909676*r**12
            +189030*r**14+456202*r**16+46643*r**18+5985*r**20)+Q2**2*(375-34196*r**2
            -493649*r**4+776730*r**6-1860918*r**8-2796008*r**10-3197910*r**12-1621092*r**14
            +88639*r**16+1373052*r**18+138407*r**20+23370*r**22))*sqrtq2)*math.log(r))/(
            -2099520*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))-4860*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3+8398080*logq2**3*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            +174960*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2))+muWC*((pi2*(-32*(Q2-(-1+r)**2)**2*r**2*(1-Q2+r**2)*(Q2
            -(1+r)**2)**2*(-Q2**6-2*Q2**5*(1+r**2)+Q2**4*(15-46*r**2-21*r**4)+4*Q2**3*(
            -5+32*r**2+173*r**4+16*r**6)-Q2**2*(-5+68*r**2+426*r**4+692*r**6
            +31*r**8)-6*Q2*(-1+9*r**2+38*r**4-34*r**6+103*r**8+5*r**10)+3*(
            -1+14*r**2-219*r**4-84*r**6-659*r**8+222*r**10+7*r**12))+32*r**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(Q2**6+2*Q2**5*(1+r**2)+Q2**4*(-15
            +46*r**2+21*r**4)-4*Q2**3*(-5+32*r**2+173*r**4+16*r**6)+Q2**2*(-5
            +68*r**2+426*r**4+692*r**6+31*r**8)+6*Q2*(-1+9*r**2+38*r**4-34*r**6
            +103*r**8+5*r**10)+3*(1-14*r**2+219*r**4+84*r**6+659*r**8-222*r**10
            -7*r**12))*sqrtq2+logq2**2*(69120*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(
            -Q2+(1+r)**2)+69120*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2*(-768*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-8*Q2**4+22*Q2**3*(1
            +r**2)-8*Q2**2*(1+4*r**2+r**4)-3*Q2*(1+4*r**2-r**4+6*r**6)+3*(
            -1-21*r**2-41*r**4-r**6+4*r**8))-768*(-Q2+(-1+r)**2)*r**6*(1-Q2
            +r**2)*(-Q2+(1+r)**2)*(-8*Q2**4+22*Q2**3*(1+r**2)-8*Q2**2*(1+4*r**2
            +r**4)-3*Q2*(1+4*r**2-r**4+6*r**6)+3*(-1-21*r**2-41*r**4-r**6
            +4*r**8))*sqrtq2)))/(-180*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-180*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+logq2**2*(25920*r**10*(-1
            +Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))-25920*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2*(4320*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+4320*(-Q2+(-1+r)**2)*r**6*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2))+(-64*(Q2-(-1+r)**2)**4*r**4*(Q2-(1
            +r)**2)**4*(-183*Q2**11+Q2**10*(183+55*r**2)+Q2**9*(3477-7868*r**2-4391*r**4)
            +Q2**8*(-12993+48799*r**2+218239*r**4+31231*r**6)-2*Q2**7*(-8601+52888*r**2
            +370308*r**4+379824*r**6+34771*r**8)+2*Q2**6*(-1281+28091*r**2+352496*r**4
            +673584*r**6+370247*r**8+25163*r**10)+2*Q2**5*(-8967+64484*r**2+25589*r**4
            -616312*r**6-614299*r**8+224876*r**10+16721*r**12)-2*Q2**4*(-9699+110761*r**2
            +34257*r**4-1292355*r**6-2511071*r**8-1352379*r**10+588381*r**12+36097*r**14)
            +Q2**3*(-5307+96496*r**2-268544*r**4-1873728*r**6-4378418*r**8-4159184*r**10
            -2479824*r**12+404896*r**14+25309*r**16)+3*(-1+r**2)**2*(-183+3843*r**2
            -70042*r**4+247050*r**6+21276*r**8+1476620*r**10+296874*r**12-413946*r**14
            +18347*r**16+1281*r**18)+Q2**2*(-3477+42931*r**2-269624*r**4-299816*r**6
            +30058*r**8-1648022*r**10-1828856*r**12-2249864*r**14+357883*r**16+19507*r**18)
            -3*Q2*(-915+16964*r**2-203671*r**4+323408*r**6+745126*r**8+2874248*r**10
            +3180590*r**12+605680*r**14-1314259*r**16+91508*r**18+5801*r**20))-64*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(183*Q2**12-2*Q2**11*(183+119*r**2)
            +6*Q2**10*(-549+1351*r**2+741*r**4)-2*Q2**9*(-8235+26595*r**2+115249*r**4
            +17811*r**6)+Q2**8*(-30195+141582*r**2+1007654*r**4+1009118*r**6+100773*r**8)
            -12*Q2**7*(-1647+12063*r**2+129282*r**4+237286*r**6+130807*r**8+9989*r**10)
            +4*Q2**6*(3843-18837*r**2+177499*r**4+821196*r**6+829065*r**8+85267*r**10
            +4221*r**12)+4*Q2**5*(-9333+83139*r**2+62165*r**4-941539*r**6-1870841*r**8
            -870901*r**10+414989*r**12+26409*r**14)-3*Q2**4*(-8235+99540*r**2+7164*r**4
            -1463308*r**6-3995090*r**8-3962028*r**10-1335940*r**12+551284*r**14
            +32501*r**16)+2*Q2**3*(-915+24129*r**2+48788*r**4-921228*r**6-3141102*r**8
            -3444790*r**10-2405076*r**12+87468*r**14+36161*r**16+2901*r**18)+3*(
            -1+r**2)**2*(-183+3660*r**2-66199*r**4+177008*r**6+268326*r**8+1497896*r**10
            +1773494*r**12-117072*r**14-395599*r**16+19628*r**18+1281*r**20)+2*Q2**2*(
            -3111+45173*r**2-418853*r**4+200392*r**6+982810*r**8+3502390*r**10
            +3032446*r**12-1130840*r**14-2917379*r**16+325957*r**18+18455*r**20)
            -6*Q2*(-549+10129*r**2-132309*r**4+255357*r**6+262834*r**8+2650246*r**10
            +1709874*r**12+2127598*r**14+217267*r**16-836055*r**18+56547*r**20+3541*r**22))*sqrtq2
            +logq2**3*(-303575040*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3-303575040*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**2*(9216*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-1904*Q2**6
            +Q2**5*(13709+10964*r**2)-Q2**4*(28275+42587*r**2+20040*r**4)+2*Q2**3*(8830
            +11099*r**2+13844*r**4+3340*r**6)+3*(-1+r**2)**2*(1317-14603*r**2-21923*r**4
            +37*r**6+2232*r**8)+2*Q2**2*(4070-14201*r**2-17073*r**4+5014*r**6+9560*r**8)
            -3*Q2*(4427-29846*r**2-72486*r**4-39546*r**6-1481*r**8+7172*r**10))
            +9216*(-Q2+(-1+r)**2)*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(-1904*Q2**6+Q2**5*(13709+10964*r**2)-Q2**4*(28275
            +42587*r**2+20040*r**4)+2*Q2**3*(8830+11099*r**2+13844*r**4+3340*r**6)
            +3*(-1+r**2)**2*(1317-14603*r**2-21923*r**4+37*r**6+2232*r**8)+2*Q2**2*(4070
            -14201*r**2-17073*r**4+5014*r**6+9560*r**8)-3*Q2*(4427-29846*r**2
            -72486*r**4-39546*r**6-1481*r**8+7172*r**10))*sqrtq2)+logq2*(-768*r**8*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-3952*Q2**9-44460*Q2**7*(1
            +r**2)**2+3*Q2**8*(7593+7532*r**2)+4*Q2**6*(5804+27405*r**2+27954*r**4
            +5255*r**6)+12*Q2**5*(2626-9139*r**2-25843*r**4-5967*r**6+3663*r**8)
            -18*Q2**4*(2571-11210*r**2-46924*r**4-44972*r**6-4805*r**8+3486*r**10)
            +4*Q2**3*(4529-38844*r**2-144303*r**4-157288*r**6-143205*r**8-10296*r**10
            +3431*r**12)+3*(-1+r**2)**2*(-439-10502*r**2+60699*r**4+197292*r**6
            +245787*r**8-84054*r**10-14711*r**12+1208*r**14)+12*Q2**2*(-160-4795*r**2
            -2268*r**4+9913*r**6-762*r**8-41613*r**10-10590*r**12+1975*r**14)-36*Q2*(
            -64-2955*r**2+6701*r**4+53167*r**6+57407*r**8+39991*r**10-18553*r**12
            -4419*r**14+485*r**16))+768*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(3952*Q2**9
            +44460*Q2**7*(1+r**2)**2-3*Q2**8*(7593+7532*r**2)-4*Q2**6*(5804+27405*r**2
            +27954*r**4+5255*r**6)-12*Q2**5*(2626-9139*r**2-25843*r**4-5967*r**6
            +3663*r**8)+18*Q2**4*(2571-11210*r**2-46924*r**4-44972*r**6-4805*r**8
            +3486*r**10)+4*Q2**3*(-4529+38844*r**2+144303*r**4+157288*r**6+143205*r**8
            +10296*r**10-3431*r**12)-3*(-1+r**2)**2*(-439-10502*r**2+60699*r**4
            +197292*r**6+245787*r**8-84054*r**10-14711*r**12+1208*r**14)-12*Q2**2*(
            -160-4795*r**2-2268*r**4+9913*r**6-762*r**8-41613*r**10-10590*r**12
            +1975*r**14)+36*Q2*(-64-2955*r**2+6701*r**4+53167*r**6+57407*r**8
            +39991*r**10-18553*r**12-4419*r**14+485*r**16))*sqrtq2))/(2160*(-Q2+(
            -1+r)**2)**3*r**4*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+2160*(
            -Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*sqrtq2+logq2**3*(-3732480*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3-3732480*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**2*(933120*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+933120*r**12*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(-77760*r**8*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-77760*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2))+((4096*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(Q2**10
            +10*Q2**9*(1+r**2)-Q2**8*(71+434*r**2+71*r**4)+Q2**7*(163+1497*r**2
            +1497*r**4+163*r**6)+24*r**2*(-1+r**2)**4*(13+26*r**2+282*r**4+26*r**6
            +13*r**8)-Q2**6*(173+1436*r**2+2610*r**4+1436*r**6+173*r**8)+Q2**5*(79
            -437*r**2-458*r**4-458*r**6-437*r**8+79*r**10)+Q2**4*(-5+1110*r**2
            +2193*r**4+3292*r**6+2193*r**8+1110*r**10-5*r**12)+Q2**3*(1-281*r**2
            -1191*r**4+2047*r**6+2047*r**8-1191*r**10-281*r**12+r**14)+3*Q2*(
            -1+r**2)**2*(1-261*r**2-627*r**4-4153*r**6-4153*r**8-627*r**10-261*r**12
            +r**14)-8*Q2**2*(1-56*r**2-197*r**4+34*r**6-644*r**8+34*r**10-197*r**12
            -56*r**14+r**16))-4096*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(Q2**11
            +9*Q2**10*(1+r**2)-Q2**9*(81+454*r**2+81*r**4)+26*Q2**8*(9+77*r**2
            +77*r**4+9*r**6)-12*Q2**7*(28+258*r**2+467*r**4+258*r**6+28*r**8)
            -24*r**2*(-1+r**2)**4*(13+39*r**2+308*r**4+308*r**6+39*r**8+13*r**10)
            +4*Q2**6*(63+293*r**2+897*r**4+897*r**6+293*r**8+63*r**10)+4*Q2**5*(
            -21+367*r**2+772*r**4+1052*r**6+772*r**8+367*r**10-21*r**12)+6*Q2**4*(1
            -231*r**2-749*r**4-573*r**6-573*r**8-749*r**10-231*r**12+r**14)+Q2**3*(
            -9+728*r**2+3048*r**4-1128*r**6+1058*r**8-1128*r**10+3048*r**12+728*r**14
            -9*r**16)-3*Q2*(-1+r**2)**2*(1-364*r**2-888*r**4-6724*r**6-4210*r**8
            -6724*r**10-888*r**12-364*r**14+r**16)+Q2**2*(11-1229*r**2-2336*r**4
            -10784*r**6+5698*r**8+5698*r**10-10784*r**12-2336*r**14-1229*r**16
            +11*r**18))*sqrtq2+logq2**2*(589824*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(8*Q2**6-23*Q2**5*(1+r**2)+6*(-1+r**2)**4*(3+4*r**2+3*r**4)
            +Q2**4*(15+29*r**2+15*r**4)-Q2**3*(5+r**2+r**4+5*r**6)-3*Q2*(-1
            +r**2)**2*(16+19*r**2+19*r**4+16*r**6)+Q2**2*(35+4*r**2-18*r**4+4*r**6
            +35*r**8))+589824*(-Q2+(-1+r)**2)*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(8*Q2**6-23*Q2**5*(1+r**2)+6*(-1+r**2)**4*(3
            +4*r**2+3*r**4)+Q2**4*(15+29*r**2+15*r**4)-Q2**3*(5+r**2+r**4+5*r**6)
            -3*Q2*(-1+r**2)**2*(16+19*r**2+19*r**4+16*r**6)+Q2**2*(35+4*r**2-18*r**4
            +4*r**6+35*r**8))*sqrtq2)+logq2*(49152*r**8*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3*(8*Q2**9-45*Q2**8*(1+r**2)+90*Q2**7*(1+r**2)**2
            -Q2**6*(67+153*r**2+153*r**4+67*r**6)-6*Q2**5*(1+24*r**2+68*r**4+24*r**6
            +r**8)+6*(-1+r**2)**4*(1+13*r**2+106*r**4+106*r**6+13*r**8+r**10)
            +9*Q2**4*(3+25*r**2+56*r**4+56*r**6+25*r**8+3*r**10)-18*Q2*(-1+r**2)**2*(1
            +11*r**2+85*r**4+86*r**6+85*r**8+11*r**10+r**12)-2*Q2**3*(5+45*r**2
            -33*r**4-10*r**6-33*r**8+45*r**10+5*r**12)+3*Q2**2*(5+45*r**2+231*r**4
            -41*r**6-41*r**8+231*r**10+45*r**12+5*r**14))+49152*r**8*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3*(8*Q2**9-45*Q2**8*(1+r**2)+90*Q2**7*(1+r**2)**2
            -Q2**6*(67+153*r**2+153*r**4+67*r**6)-6*Q2**5*(1+24*r**2+68*r**4+24*r**6
            +r**8)+6*(-1+r**2)**4*(1+13*r**2+106*r**4+106*r**6+13*r**8+r**10)
            +9*Q2**4*(3+25*r**2+56*r**4+56*r**6+25*r**8+3*r**10)-18*Q2*(-1+r**2)**2*(1
            +11*r**2+85*r**4+86*r**6+85*r**8+11*r**10+r**12)-2*Q2**3*(5+45*r**2
            -33*r**4-10*r**6-33*r**8+45*r**10+5*r**12)+3*Q2**2*(5+45*r**2+231*r**4
            -41*r**6-41*r**8+231*r**10+45*r**12+5*r**14))*sqrtq2))*math.log(mu0))/(720*(
            -Q2+(-1+r)**2)**3*r**4*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +720*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(-1244160*r**16*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3-1244160*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*sqrtq2)+logq2**2*(311040*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +311040*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(
            -25920*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-25920*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2))+((160*(Q2-(-1+r)**2)**2*r**2*(1-Q2
            +r**2)*(Q2-(1+r)**2)**2*(-Q2**6-2*Q2**5*(1+r**2)+Q2**4*(15-46*r**2
            -21*r**4)+4*Q2**3*(-5+32*r**2+173*r**4+16*r**6)-Q2**2*(-5+68*r**2
            +426*r**4+692*r**6+31*r**8)-6*Q2*(-1+9*r**2+38*r**4-34*r**6+103*r**8
            +5*r**10)+3*(-1+14*r**2-219*r**4-84*r**6-659*r**8+222*r**10+7*r**12))
            -160*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(Q2**6+2*Q2**5*(1+r**2)
            +Q2**4*(-15+46*r**2+21*r**4)-4*Q2**3*(-5+32*r**2+173*r**4+16*r**6)
            +Q2**2*(-5+68*r**2+426*r**4+692*r**6+31*r**8)+6*Q2*(-1+9*r**2+38*r**4
            -34*r**6+103*r**8+5*r**10)+3*(1-14*r**2+219*r**4+84*r**6+659*r**8
            -222*r**10-7*r**12))*sqrtq2+logq2**2*(-345600*(-Q2+(-1+r)**2)*r**10*(1
            -Q2+r**2)*(-Q2+(1+r)**2)-345600*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2*(3840*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -8*Q2**4+22*Q2**3*(1+r**2)-8*Q2**2*(1+4*r**2+r**4)-3*Q2*(1+4*r**2
            -r**4+6*r**6)+3*(-1-21*r**2-41*r**4-r**6+4*r**8))+3840*(-Q2+(
            -1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(-8*Q2**4+22*Q2**3*(1+r**2)
            -8*Q2**2*(1+4*r**2+r**4)-3*Q2*(1+4*r**2-r**4+6*r**6)+3*(-1-21*r**2
            -41*r**4-r**6+4*r**8))*sqrtq2))*math.log(mus))/(-108*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-108*(-Q2
            +(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+logq2**2*(15552*r**10*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -15552*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2*(2592*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+2592*(-Q2
            +(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+((-32*(Q2-(-1+r)**2)**2*r**2*(1
            -Q2+r**2)*(Q2-(1+r)**2)**2*(-Q2**6-2*Q2**5*(1+r**2)+Q2**4*(15-46*r**2
            -21*r**4)+4*Q2**3*(-5+32*r**2+173*r**4+16*r**6)-Q2**2*(-5+68*r**2
            +426*r**4+692*r**6+31*r**8)-6*Q2*(-1+9*r**2+38*r**4-34*r**6+103*r**8
            +5*r**10)+3*(-1+14*r**2-219*r**4-84*r**6-659*r**8+222*r**10+7*r**12))
            +32*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(Q2**6+2*Q2**5*(1+r**2)
            +Q2**4*(-15+46*r**2+21*r**4)-4*Q2**3*(-5+32*r**2+173*r**4+16*r**6)
            +Q2**2*(-5+68*r**2+426*r**4+692*r**6+31*r**8)+6*Q2*(-1+9*r**2+38*r**4
            -34*r**6+103*r**8+5*r**10)+3*(1-14*r**2+219*r**4+84*r**6+659*r**8
            -222*r**10-7*r**12))*sqrtq2+logq2**2*(69120*(-Q2+(-1+r)**2)*r**10*(1
            -Q2+r**2)*(-Q2+(1+r)**2)+69120*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2*(-768*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -8*Q2**4+22*Q2**3*(1+r**2)-8*Q2**2*(1+4*r**2+r**4)-3*Q2*(1+4*r**2
            -r**4+6*r**6)+3*(-1-21*r**2-41*r**4-r**6+4*r**8))-768*(-Q2+(-1
            +r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(-8*Q2**4+22*Q2**3*(1+r**2)
            -8*Q2**2*(1+4*r**2+r**4)-3*Q2*(1+4*r**2-r**4+6*r**6)+3*(-1-21*r**2
            -41*r**4-r**6+4*r**8))*sqrtq2))*math.log(2*muWC))/(-20*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-20*(-Q2
            +(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+logq2**2*(2880*r**10*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -2880*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2*(480*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+480*(-Q2
            +(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+((-256*(Q2-(-1+r)**2)**4*r**4*(Q2
            -(1+r)**2)**4*(-Q2**11+Q2**10*(1+49*r**2)+Q2**9*(19+444*r**2+463*r**4)
            -Q2**8*(71+3191*r**2+19943*r**4+3287*r**6)+Q2**7*(94+7360*r**2+68856*r**4
            +68752*r**6+7558*r**8)-2*Q2**6*(7+4059*r**2+33040*r**4+59872*r**6+32943*r**8
            +4075*r**10)+2*Q2**5*(-49+2276*r**2-10501*r**4-14520*r**6-14509*r**8
            -9412*r**10+2015*r**12)+2*Q2**4*(53-727*r**2+26841*r**4+60461*r**6
            +93881*r**8+60789*r**10+23813*r**12-319*r**14)+Q2**3*(-29+576*r**2
            -15152*r**4-68240*r**6+75762*r**8+76960*r**10-71552*r**12-11472*r**14
            +187*r**16)+Q2**2*(-19-155*r**2+20344*r**4+75112*r**6-13082*r**8+241894*r**10
            -23240*r**12+64456*r**14+23773*r**16-283*r**18)+3*(-1+r**2)**2*(-1
            +21*r**2+4682*r**4+1350*r**6+94788*r**8-191404*r**10+96294*r**12-2262*r**14
            +5165*r**16+7*r**18)+3*Q2*(5-44*r**2-11695*r**4-6832*r**6-157962*r**8
            +156008*r**10+154334*r**12-157200*r**14+2117*r**16-13308*r**18+17*r**20))
            -256*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(Q2**12-2*Q2**11*(1+25*r**2)
            -2*Q2**10*(9+197*r**2+207*r**4)+6*Q2**9*(15+609*r**2+3475*r**4+625*r**6)
            -Q2**8*(165+10622*r**2+91990*r**4+91982*r**6+10845*r**8)+4*Q2**7*(27
            +3893*r**2+35574*r**4+64338*r**6+35549*r**8+3927*r**10)-4*Q2**6*(-21
            +3171*r**2+13299*r**4+39196*r**6+39153*r**8+13803*r**10+3045*r**12)
            +4*Q2**5*(-51+1477*r**2-17533*r**4-42741*r**6-61455*r**8-42355*r**10
            -15605*r**12+1167*r**14)+Q2**4*(135-1924*r**2+67380*r**4+242844*r**6
            +232922*r**8+232380*r**10+240756*r**12+58460*r**14-825*r**16)+2*Q2**3*(
            -5+351*r**2-17460*r**4-79252*r**6+10302*r**8-44586*r**10+14324*r**12
            -73740*r**14-17529*r**16+235*r**18)+Q2**2*(-34-42*r**2+55274*r**4+115952*r**6
            +535916*r**8-239212*r**10-244348*r**12+512816*r**14+81878*r**16+63414*r**18
            -334*r**20)+3*(-1+r**2)**2*(-1+20*r**2+4703*r**4+6032*r**6+96138*r**8
            -96616*r**10-95110*r**12+94032*r**14+2903*r**16+5172*r**18+7*r**20)
            +6*Q2*(3-31*r**2-8189*r**4-5267*r**6-130782*r**8+188838*r**10-131774*r**12
            +191694*r**14-130533*r**16+697*r**18-9221*r**20+5*r**22))*sqrtq2+logq2**3*(
            -6635520*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-6635520*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**2*(-184320*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(80*Q2**6-Q2**5*(239+236*r**2)+Q2**4*(177
            +329*r**2+168*r**4)-2*Q2**3*(34+17*r**2+20*r**4+28*r**6)+3*(-1+r**2)**2*(57
            -23*r**2-15*r**4-39*r**6+56*r**8)+2*Q2**2*(166+35*r**2-69*r**4+14*r**6
            +160*r**8)-3*Q2*(151-94*r**2+50*r**4+14*r**6-125*r**8+148*r**10))
            +184320*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(80*Q2**7-Q2**6*(319
            +316*r**2)+Q2**5*(416+804*r**2+404*r**4)-Q2**4*(245+540*r**2+537*r**4
            +224*r**6)+4*Q2**3*(100+43*r**2-16*r**4+31*r**6+94*r**8)-3*(-1+r**2)**2*(57
            +34*r**2-38*r**4-54*r**6+17*r**8+56*r**10)-Q2**2*(785+120*r**2+82*r**4
            -68*r**6-27*r**8+764*r**10)+12*Q2*(52-20*r**2+11*r**4+8*r**6+2*r**8
            -32*r**10+51*r**12))*sqrtq2)+logq2*(-3072*r**8*(1-Q2+r**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*(368*Q2**9+4140*Q2**7*(1+r**2)**2-Q2**8*(2067
            +2068*r**2)-4*Q2**6*(784+1713*r**2+1710*r**4+787*r**6)-4*Q2**5*(30
            +1903*r**2+5391*r**4+1851*r**6+13*r**8)+6*Q2**4*(177+2010*r**2+4860*r**4
            +4828*r**6+1905*r**8+162*r**10)-4*Q2**3*(97+1308*r**2-15*r**4+616*r**6
            -21*r**8+1152*r**10+103*r**12)+20*Q2**2*(36+313*r**2+1680*r**4-267*r**6
            -302*r**8+1551*r**10+294*r**12+43*r**14)+3*(-1+r**2)**2*(95+1014*r**2
            +8221*r**4-7980*r**6-7715*r**8+7430*r**10+991*r**12+104*r**14)-36*Q2*(24
            +203*r**2+1595*r**4-1487*r**6+265*r**8-1559*r**10+1457*r**12+195*r**14
            +27*r**16))-3072*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(368*Q2**9
            +4140*Q2**7*(1+r**2)**2-Q2**8*(2067+2068*r**2)-4*Q2**6*(784+1713*r**2
            +1710*r**4+787*r**6)-4*Q2**5*(30+1903*r**2+5391*r**4+1851*r**6+13*r**8)
            +6*Q2**4*(177+2010*r**2+4860*r**4+4828*r**6+1905*r**8+162*r**10)-4*Q2**3*(97
            +1308*r**2-15*r**4+616*r**6-21*r**8+1152*r**10+103*r**12)+20*Q2**2*(36
            +313*r**2+1680*r**4-267*r**6-302*r**8+1551*r**10+294*r**12+43*r**14)
            +3*(-1+r**2)**2*(95+1014*r**2+8221*r**4-7980*r**6-7715*r**8+7430*r**10
            +991*r**12+104*r**14)-36*Q2*(24+203*r**2+1595*r**4-1487*r**6+265*r**8
            -1559*r**10+1457*r**12+195*r**14+27*r**16))*sqrtq2))*math.log(r))/(2160*(-Q2
            +(-1+r)**2)**3*r**4*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+2160*(
            -Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*sqrtq2+logq2**3*(-3732480*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3-3732480*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**2*(933120*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+933120*r**12*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(-77760*r**8*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-77760*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)))+muWC**2*((pi2*(-4*(Q2-(-1+r)**2)**2*r**2*(1-Q2+r**2)*(Q2
            -(1+r)**2)**2*(-Q2**6-2*Q2**5*(1+r**2)+Q2**4*(15-46*r**2-21*r**4)+4*Q2**3*(
            -5+32*r**2+173*r**4+16*r**6)-Q2**2*(-5+68*r**2+426*r**4+692*r**6
            +31*r**8)-6*Q2*(-1+9*r**2+38*r**4-34*r**6+103*r**8+5*r**10)+3*(
            -1+14*r**2-219*r**4-84*r**6-659*r**8+222*r**10+7*r**12))+4*r**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(Q2**6+2*Q2**5*(1+r**2)+Q2**4*(-15
            +46*r**2+21*r**4)-4*Q2**3*(-5+32*r**2+173*r**4+16*r**6)+Q2**2*(-5
            +68*r**2+426*r**4+692*r**6+31*r**8)+6*Q2*(-1+9*r**2+38*r**4-34*r**6
            +103*r**8+5*r**10)+3*(1-14*r**2+219*r**4+84*r**6+659*r**8-222*r**10
            -7*r**12))*sqrtq2+logq2**2*(8640*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(
            -Q2+(1+r)**2)+8640*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2*(-96*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-8*Q2**4+22*Q2**3*(1
            +r**2)-8*Q2**2*(1+4*r**2+r**4)-3*Q2*(1+4*r**2-r**4+6*r**6)+3*(
            -1-21*r**2-41*r**4-r**6+4*r**8))-96*(-Q2+(-1+r)**2)*r**6*(1-Q2
            +r**2)*(-Q2+(1+r)**2)*(-8*Q2**4+22*Q2**3*(1+r**2)-8*Q2**2*(1+4*r**2
            +r**4)-3*Q2*(1+4*r**2-r**4+6*r**6)+3*(-1-21*r**2-41*r**4-r**6
            +4*r**8))*sqrtq2)))/(-60*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-60*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+logq2**2*(8640*r**10*(-1
            +Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))-8640*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2*(1440*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+1440*(-Q2+(-1+r)**2)*r**6*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2))+(-32*(Q2-(-1+r)**2)**4*r**4*(Q2-(1
            +r)**2)**4*(-415*Q2**11+Q2**10*(-97+127*r**2)+Q2**9*(11981-22940*r**2
            -9935*r**4)+Q2**8*(-43801+136103*r**2+617831*r**4+70663*r**6)-2*Q2**7*(
            -33841+156616*r**2+1007028*r**4+1088000*r**6+78667*r**8)+2*Q2**6*(-20825
            +143891*r**2+980528*r**4+1780048*r**6+1055087*r**8+56867*r**10)+2*Q2**5*(
            -5999+28564*r**2-348995*r**4-649624*r**6-1105859*r**8+812572*r**10
            +38009*r**12)+Q2**4*(29654-302690*r**2+1349358*r**4+3922934*r**6+4748686*r**8
            +4839270*r**10-4145770*r**12-163730*r**14)+Q2**3*(-7939+136912*r**2
            -1586528*r**4-2754784*r**6-10104770*r**8-3246512*r**10-5554672*r**12
            +1628224*r**14+57397*r**16)+3*(-1+r**2)**2*(-415+8715*r**2-105354*r**4
            +560250*r**6+1047996*r**8+1242156*r**10+1672986*r**12-938730*r**14+95091*r**16
            +2905*r**18)+Q2**2*(-8397+104507*r**2-418936*r**4-767464*r**6-997414*r**8
            -2938150*r**10-448312*r**12-4704328*r**14+1312835*r**16+44219*r**18)
            -3*Q2*(-2075+37444*r**2-389599*r**4+965072*r**6+2215094*r**8+7558664*r**10
            +2545598*r**12+4098416*r**14-3105115*r**16+405748*r**18+13153*r**20))
            -32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(415*Q2**12-2*Q2**11*(159
            +271*r**2)+2*Q2**10*(-6039+11485*r**2+5031*r**4)-2*Q2**9*(-27891+73531*r**2
            +325353*r**4+40299*r**6)+Q2**8*(-111483+405534*r**2+2767990*r**4+2864494*r**6
            +227997*r**8)-4*Q2**7*(-27333+133333*r**2+1072086*r**4+1937538*r**6
            +1110877*r**8+67767*r**10)+4*Q2**6*(-7413+47251*r**2+736707*r**4+1705100*r**6
            +1970497*r**8+149691*r**10+9429*r**12)+4*Q2**5*(-10413+86955*r**2-497555*r**4
            -1480043*r**6-2064913*r**8-1356461*r**10+1461733*r**12+59937*r**14)
            +Q2**4*(37593-409948*r**2+2633196*r**4+8027076*r**6+18776390*r**8+12834468*r**10
            +6248172*r**12-5937724*r**14-221127*r**16)+2*Q2**3*(229+12233*r**2-515340*r**4
            -1786924*r**6-5931070*r**8-5206566*r**10-4176436*r**12+388940*r**14
            +186393*r**16+6589*r**18)+3*(-1+r**2)**2*(-415+8300*r**2-96639*r**4
            +454896*r**6+1608246*r**8+2290152*r**10+2915142*r**12+734256*r**14-843639*r**16
            +97996*r**18+2905*r**20)+2*Q2**2*(-7311+104221*r**2-741613*r**4+854408*r**6
            +2440202*r**8+9370214*r**10+2125166*r**12+3571304*r**14-6353419*r**16
            +1287149*r**18+41839*r**20)-6*Q2*(-1245+22457*r**2-237677*r**4+677573*r**6
            +1501154*r**8+4740086*r**10+5170466*r**12+1800734*r**14+2319419*r**16
            -1912687*r**18+254091*r**20+8029*r**22))*sqrtq2+logq2**3*(-344217600*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-344217600*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**2*(4608*r**12*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*(1808*Q2**6+Q2**5*(17317-4268*r**2)+Q2**4*(
            -56475-62851*r**2+600*r**4)+Q2**3*(40060+38054*r**2+50504*r**4-200*r**6)
            +3*(-1+r**2)**2*(-99-31059*r**2-47659*r**4+2141*r**6+1976*r**8)+2*Q2**2*(5350
            -30673*r**2-37929*r**4+12902*r**6+6280*r**8)-3*Q2*(4371-66118*r**2
            -160278*r**4-90698*r**6+8447*r**8+5476*r**10))+4608*(-Q2+(-1+r)**2)*r**12*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1808*Q2**6
            +Q2**5*(17317-4268*r**2)+Q2**4*(-56475-62851*r**2+600*r**4)+Q2**3*(40060
            +38054*r**2+50504*r**4-200*r**6)+3*(-1+r**2)**2*(-99-31059*r**2-47659*r**4
            +2141*r**6+1976*r**8)+2*Q2**2*(5350-30673*r**2-37929*r**4+12902*r**6
            +6280*r**8)-3*Q2*(4371-66118*r**2-160278*r**4-90698*r**6+8447*r**8
            +5476*r**10))*sqrtq2)+logq2*(-1152*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-3664*Q2**9-41220*Q2**7*(1+r**2)**2+7*Q2**8*(2967
            +2996*r**2)+4*Q2**6*(8172+20303*r**2+23790*r**4+4685*r**6)+4*Q2**5*(
            -1342-14523*r**2-18235*r**4-3063*r**6+10823*r**8)-2*Q2**4*(1353-72510*r**2
            -227780*r**4-123364*r**6+9465*r**8+30618*r**10)+4*Q2**3*(-461-30148*r**2
            -94093*r**4-90904*r**6-67151*r**8+2184*r**10+3317*r**12)+(-1+r**2)**2*(33
            -12502*r**2+220963*r**4+351756*r**6+461731*r**8-107302*r**10-22047*r**12
            +3768*r**14)+4*Q2**2*(280-8075*r**2-4884*r**4+27449*r**6-16386*r**8
            -35229*r**10-16950*r**12+5975*r**14)-12*Q2*(-16-4899*r**2+27301*r**4
            +112551*r**6+129671*r**8+61167*r**10-21265*r**12-7195*r**14+1485*r**16))
            +1152*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(3664*Q2**9+41220*Q2**7*(1
            +r**2)**2-7*Q2**8*(2967+2996*r**2)-4*Q2**6*(8172+20303*r**2+23790*r**4
            +4685*r**6)+Q2**5*(5368+58092*r**2+72940*r**4+12252*r**6-43292*r**8)
            +2*Q2**4*(1353-72510*r**2-227780*r**4-123364*r**6+9465*r**8+30618*r**10)
            -4*Q2**3*(-461-30148*r**2-94093*r**4-90904*r**6-67151*r**8+2184*r**10
            +3317*r**12)-(-1+r**2)**2*(33-12502*r**2+220963*r**4+351756*r**6+461731*r**8
            -107302*r**10-22047*r**12+3768*r**14)-4*Q2**2*(280-8075*r**2-4884*r**4
            +27449*r**6-16386*r**8-35229*r**10-16950*r**12+5975*r**14)+12*Q2*(
            -16-4899*r**2+27301*r**4+112551*r**6+129671*r**8+61167*r**10-21265*r**12
            -7195*r**14+1485*r**16))*sqrtq2))/(6480*(-Q2+(-1+r)**2)**3*r**4*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+6480*(-Q2+(-1+r)**2)**3*r**4*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(
            -11197440*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-11197440*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**2*(2799360*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+2799360*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)+logq2*(-233280*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2-233280*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2))+((512*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(Q2**10+10*Q2**9*(1+r**2)-Q2**8*(71
            +434*r**2+71*r**4)+Q2**7*(163+1497*r**2+1497*r**4+163*r**6)+24*r**2*(
            -1+r**2)**4*(13+26*r**2+282*r**4+26*r**6+13*r**8)-Q2**6*(173+1436*r**2
            +2610*r**4+1436*r**6+173*r**8)+Q2**5*(79-437*r**2-458*r**4-458*r**6
            -437*r**8+79*r**10)+Q2**4*(-5+1110*r**2+2193*r**4+3292*r**6+2193*r**8
            +1110*r**10-5*r**12)+Q2**3*(1-281*r**2-1191*r**4+2047*r**6+2047*r**8
            -1191*r**10-281*r**12+r**14)+3*Q2*(-1+r**2)**2*(1-261*r**2-627*r**4
            -4153*r**6-4153*r**8-627*r**10-261*r**12+r**14)-8*Q2**2*(1-56*r**2
            -197*r**4+34*r**6-644*r**8+34*r**10-197*r**12-56*r**14+r**16))-512*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(Q2**11+9*Q2**10*(1+r**2)-Q2**9*(81
            +454*r**2+81*r**4)+26*Q2**8*(9+77*r**2+77*r**4+9*r**6)-12*Q2**7*(28
            +258*r**2+467*r**4+258*r**6+28*r**8)-24*r**2*(-1+r**2)**4*(13+39*r**2
            +308*r**4+308*r**6+39*r**8+13*r**10)+4*Q2**6*(63+293*r**2+897*r**4
            +897*r**6+293*r**8+63*r**10)+4*Q2**5*(-21+367*r**2+772*r**4+1052*r**6
            +772*r**8+367*r**10-21*r**12)+6*Q2**4*(1-231*r**2-749*r**4-573*r**6
            -573*r**8-749*r**10-231*r**12+r**14)+Q2**3*(-9+728*r**2+3048*r**4
            -1128*r**6+1058*r**8-1128*r**10+3048*r**12+728*r**14-9*r**16)-3*Q2*(
            -1+r**2)**2*(1-364*r**2-888*r**4-6724*r**6-4210*r**8-6724*r**10-888*r**12
            -364*r**14+r**16)+Q2**2*(11-1229*r**2-2336*r**4-10784*r**6+5698*r**8
            +5698*r**10-10784*r**12-2336*r**14-1229*r**16+11*r**18))*sqrtq2+logq2**2*(73728*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(8*Q2**6-23*Q2**5*(1+r**2)+6*(-1+r**2)**4*(3
            +4*r**2+3*r**4)+Q2**4*(15+29*r**2+15*r**4)-Q2**3*(5+r**2+r**4+5*r**6)
            -3*Q2*(-1+r**2)**2*(16+19*r**2+19*r**4+16*r**6)+Q2**2*(35+4*r**2-18*r**4
            +4*r**6+35*r**8))+73728*(-Q2+(-1+r)**2)*r**12*(1-Q2+r**2)*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(8*Q2**6-23*Q2**5*(1+r**2)
            +6*(-1+r**2)**4*(3+4*r**2+3*r**4)+Q2**4*(15+29*r**2+15*r**4)-Q2**3*(5
            +r**2+r**4+5*r**6)-3*Q2*(-1+r**2)**2*(16+19*r**2+19*r**4+16*r**6)
            +Q2**2*(35+4*r**2-18*r**4+4*r**6+35*r**8))*sqrtq2)+logq2*(6144*r**8*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(8*Q2**9-45*Q2**8*(1
            +r**2)+90*Q2**7*(1+r**2)**2-Q2**6*(67+153*r**2+153*r**4+67*r**6)-6*Q2**5*(1
            +24*r**2+68*r**4+24*r**6+r**8)+6*(-1+r**2)**4*(1+13*r**2+106*r**4
            +106*r**6+13*r**8+r**10)+9*Q2**4*(3+25*r**2+56*r**4+56*r**6+25*r**8
            +3*r**10)-18*Q2*(-1+r**2)**2*(1+11*r**2+85*r**4+86*r**6+85*r**8+11*r**10
            +r**12)-2*Q2**3*(5+45*r**2-33*r**4-10*r**6-33*r**8+45*r**10+5*r**12)
            +3*Q2**2*(5+45*r**2+231*r**4-41*r**6-41*r**8+231*r**10+45*r**12+5*r**14))
            +6144*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(8*Q2**9-45*Q2**8*(1
            +r**2)+90*Q2**7*(1+r**2)**2-Q2**6*(67+153*r**2+153*r**4+67*r**6)-6*Q2**5*(1
            +24*r**2+68*r**4+24*r**6+r**8)+6*(-1+r**2)**4*(1+13*r**2+106*r**4
            +106*r**6+13*r**8+r**10)+9*Q2**4*(3+25*r**2+56*r**4+56*r**6+25*r**8
            +3*r**10)-18*Q2*(-1+r**2)**2*(1+11*r**2+85*r**4+86*r**6+85*r**8+11*r**10
            +r**12)-2*Q2**3*(5+45*r**2-33*r**4-10*r**6-33*r**8+45*r**10+5*r**12)
            +3*Q2**2*(5+45*r**2+231*r**4-41*r**6-41*r**8+231*r**10+45*r**12+5*r**14))*sqrtq2))*math.log(mu0))/(240*(
            -Q2+(-1+r)**2)**3*r**4*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +240*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(-414720*r**16*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3-414720*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*sqrtq2)+logq2**2*(103680*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +103680*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(
            -8640*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-8640*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2))+((20*(Q2-(-1+r)**2)**2*r**2*(1-Q2
            +r**2)*(Q2-(1+r)**2)**2*(-Q2**6-2*Q2**5*(1+r**2)+Q2**4*(15-46*r**2
            -21*r**4)+4*Q2**3*(-5+32*r**2+173*r**4+16*r**6)-Q2**2*(-5+68*r**2
            +426*r**4+692*r**6+31*r**8)-6*Q2*(-1+9*r**2+38*r**4-34*r**6+103*r**8
            +5*r**10)+3*(-1+14*r**2-219*r**4-84*r**6-659*r**8+222*r**10+7*r**12))
            -20*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(Q2**6+2*Q2**5*(1+r**2)
            +Q2**4*(-15+46*r**2+21*r**4)-4*Q2**3*(-5+32*r**2+173*r**4+16*r**6)
            +Q2**2*(-5+68*r**2+426*r**4+692*r**6+31*r**8)+6*Q2*(-1+9*r**2+38*r**4
            -34*r**6+103*r**8+5*r**10)+3*(1-14*r**2+219*r**4+84*r**6+659*r**8
            -222*r**10-7*r**12))*sqrtq2+logq2**2*(-43200*(-Q2+(-1+r)**2)*r**10*(1
            -Q2+r**2)*(-Q2+(1+r)**2)-43200*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2*(480*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -8*Q2**4+22*Q2**3*(1+r**2)-8*Q2**2*(1+4*r**2+r**4)-3*Q2*(1+4*r**2
            -r**4+6*r**6)+3*(-1-21*r**2-41*r**4-r**6+4*r**8))+480*(-Q2+(-1
            +r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(-8*Q2**4+22*Q2**3*(1+r**2)
            -8*Q2**2*(1+4*r**2+r**4)-3*Q2*(1+4*r**2-r**4+6*r**6)+3*(-1-21*r**2
            -41*r**4-r**6+4*r**8))*sqrtq2))*math.log(mus))/(-36*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-36*(-Q2
            +(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+logq2**2*(5184*r**10*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -5184*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2*(864*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+864*(-Q2
            +(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+((-12*(Q2-(-1+r)**2)**2*r**2*(1
            -Q2+r**2)*(Q2-(1+r)**2)**2*(-Q2**6-2*Q2**5*(1+r**2)+Q2**4*(15-46*r**2
            -21*r**4)+4*Q2**3*(-5+32*r**2+173*r**4+16*r**6)-Q2**2*(-5+68*r**2
            +426*r**4+692*r**6+31*r**8)-6*Q2*(-1+9*r**2+38*r**4-34*r**6+103*r**8
            +5*r**10)+3*(-1+14*r**2-219*r**4-84*r**6-659*r**8+222*r**10+7*r**12))
            +12*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(Q2**6+2*Q2**5*(1+r**2)
            +Q2**4*(-15+46*r**2+21*r**4)-4*Q2**3*(-5+32*r**2+173*r**4+16*r**6)
            +Q2**2*(-5+68*r**2+426*r**4+692*r**6+31*r**8)+6*Q2*(-1+9*r**2+38*r**4
            -34*r**6+103*r**8+5*r**10)+3*(1-14*r**2+219*r**4+84*r**6+659*r**8
            -222*r**10-7*r**12))*sqrtq2+logq2**2*(25920*(-Q2+(-1+r)**2)*r**10*(1
            -Q2+r**2)*(-Q2+(1+r)**2)+25920*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2*(-288*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -8*Q2**4+22*Q2**3*(1+r**2)-8*Q2**2*(1+4*r**2+r**4)-3*Q2*(1+4*r**2
            -r**4+6*r**6)+3*(-1-21*r**2-41*r**4-r**6+4*r**8))-288*(-Q2+(-1
            +r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(-8*Q2**4+22*Q2**3*(1+r**2)
            -8*Q2**2*(1+4*r**2+r**4)-3*Q2*(1+4*r**2-r**4+6*r**6)+3*(-1-21*r**2
            -41*r**4-r**6+4*r**8))*sqrtq2))*math.log(2*muWC))/(-20*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-20*(-Q2
            +(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+logq2**2*(2880*r**10*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -2880*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2*(480*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+480*(-Q2
            +(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+((-32*(Q2-(-1+r)**2)**4*r**4*(Q2
            -(1+r)**2)**4*(-Q2**11+Q2**10*(1+49*r**2)+Q2**9*(19+444*r**2+463*r**4)
            -Q2**8*(71+3191*r**2+19943*r**4+3287*r**6)+Q2**7*(94+7360*r**2+68856*r**4
            +68752*r**6+7558*r**8)-2*Q2**6*(7+4059*r**2+33040*r**4+59872*r**6+32943*r**8
            +4075*r**10)+2*Q2**5*(-49+2276*r**2-10501*r**4-14520*r**6-14509*r**8
            -9412*r**10+2015*r**12)+2*Q2**4*(53-727*r**2+26841*r**4+60461*r**6
            +93881*r**8+60789*r**10+23813*r**12-319*r**14)+Q2**3*(-29+576*r**2
            -15152*r**4-68240*r**6+75762*r**8+76960*r**10-71552*r**12-11472*r**14
            +187*r**16)+Q2**2*(-19-155*r**2+20344*r**4+75112*r**6-13082*r**8+241894*r**10
            -23240*r**12+64456*r**14+23773*r**16-283*r**18)+3*(-1+r**2)**2*(-1
            +21*r**2+4682*r**4+1350*r**6+94788*r**8-191404*r**10+96294*r**12-2262*r**14
            +5165*r**16+7*r**18)+3*Q2*(5-44*r**2-11695*r**4-6832*r**6-157962*r**8
            +156008*r**10+154334*r**12-157200*r**14+2117*r**16-13308*r**18+17*r**20))
            -32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(Q2**12-2*Q2**11*(1+25*r**2)
            -2*Q2**10*(9+197*r**2+207*r**4)+6*Q2**9*(15+609*r**2+3475*r**4+625*r**6)
            -Q2**8*(165+10622*r**2+91990*r**4+91982*r**6+10845*r**8)+4*Q2**7*(27
            +3893*r**2+35574*r**4+64338*r**6+35549*r**8+3927*r**10)-4*Q2**6*(-21
            +3171*r**2+13299*r**4+39196*r**6+39153*r**8+13803*r**10+3045*r**12)
            +4*Q2**5*(-51+1477*r**2-17533*r**4-42741*r**6-61455*r**8-42355*r**10
            -15605*r**12+1167*r**14)+Q2**4*(135-1924*r**2+67380*r**4+242844*r**6
            +232922*r**8+232380*r**10+240756*r**12+58460*r**14-825*r**16)+2*Q2**3*(
            -5+351*r**2-17460*r**4-79252*r**6+10302*r**8-44586*r**10+14324*r**12
            -73740*r**14-17529*r**16+235*r**18)+Q2**2*(-34-42*r**2+55274*r**4+115952*r**6
            +535916*r**8-239212*r**10-244348*r**12+512816*r**14+81878*r**16+63414*r**18
            -334*r**20)+3*(-1+r**2)**2*(-1+20*r**2+4703*r**4+6032*r**6+96138*r**8
            -96616*r**10-95110*r**12+94032*r**14+2903*r**16+5172*r**18+7*r**20)
            +6*Q2*(3-31*r**2-8189*r**4-5267*r**6-130782*r**8+188838*r**10-131774*r**12
            +191694*r**14-130533*r**16+697*r**18-9221*r**20+5*r**22))*sqrtq2+logq2**3*(
            -829440*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-829440*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**2*(-23040*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(80*Q2**6-Q2**5*(239+236*r**2)+Q2**4*(177
            +329*r**2+168*r**4)-2*Q2**3*(34+17*r**2+20*r**4+28*r**6)+3*(-1+r**2)**2*(57
            -23*r**2-15*r**4-39*r**6+56*r**8)+2*Q2**2*(166+35*r**2-69*r**4+14*r**6
            +160*r**8)-3*Q2*(151-94*r**2+50*r**4+14*r**6-125*r**8+148*r**10))
            +23040*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(80*Q2**7-Q2**6*(319
            +316*r**2)+Q2**5*(416+804*r**2+404*r**4)-Q2**4*(245+540*r**2+537*r**4
            +224*r**6)+4*Q2**3*(100+43*r**2-16*r**4+31*r**6+94*r**8)-3*(-1+r**2)**2*(57
            +34*r**2-38*r**4-54*r**6+17*r**8+56*r**10)-Q2**2*(785+120*r**2+82*r**4
            -68*r**6-27*r**8+764*r**10)+12*Q2*(52-20*r**2+11*r**4+8*r**6+2*r**8
            -32*r**10+51*r**12))*sqrtq2)+logq2*(-384*r**8*(1-Q2+r**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*(368*Q2**9+4140*Q2**7*(1+r**2)**2-Q2**8*(2067
            +2068*r**2)-4*Q2**6*(784+1713*r**2+1710*r**4+787*r**6)-4*Q2**5*(30
            +1903*r**2+5391*r**4+1851*r**6+13*r**8)+6*Q2**4*(177+2010*r**2+4860*r**4
            +4828*r**6+1905*r**8+162*r**10)-4*Q2**3*(97+1308*r**2-15*r**4+616*r**6
            -21*r**8+1152*r**10+103*r**12)+20*Q2**2*(36+313*r**2+1680*r**4-267*r**6
            -302*r**8+1551*r**10+294*r**12+43*r**14)+3*(-1+r**2)**2*(95+1014*r**2
            +8221*r**4-7980*r**6-7715*r**8+7430*r**10+991*r**12+104*r**14)-36*Q2*(24
            +203*r**2+1595*r**4-1487*r**6+265*r**8-1559*r**10+1457*r**12+195*r**14
            +27*r**16))-384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(368*Q2**9
            +4140*Q2**7*(1+r**2)**2-Q2**8*(2067+2068*r**2)-4*Q2**6*(784+1713*r**2
            +1710*r**4+787*r**6)-4*Q2**5*(30+1903*r**2+5391*r**4+1851*r**6+13*r**8)
            +6*Q2**4*(177+2010*r**2+4860*r**4+4828*r**6+1905*r**8+162*r**10)-4*Q2**3*(97
            +1308*r**2-15*r**4+616*r**6-21*r**8+1152*r**10+103*r**12)+20*Q2**2*(36
            +313*r**2+1680*r**4-267*r**6-302*r**8+1551*r**10+294*r**12+43*r**14)
            +3*(-1+r**2)**2*(95+1014*r**2+8221*r**4-7980*r**6-7715*r**8+7430*r**10
            +991*r**12+104*r**14)-36*Q2*(24+203*r**2+1595*r**4-1487*r**6+265*r**8
            -1559*r**10+1457*r**12+195*r**14+27*r**16))*sqrtq2))*math.log(r))/(720*(-Q2
            +(-1+r)**2)**3*r**4*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+720*(-Q2
            +(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*sqrtq2+logq2**3*(-1244160*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3-1244160*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**2*(311040*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+311040*r**12*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(-25920*r**8*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-25920*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)))+((-34560*logq2**2*(-Q2+(-1+r)**2)*r**10*(2+r**2)*(
            -Q2+(1+r)**2)-16*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-17*Q2**6
            -4*Q2**5*(1+r**2)+Q2**4*(-57-182*r**2+75*r**4)+Q2**3*(128+964*r**2
            +316*r**4-40*r**6)+Q2**2*(13-424*r**2+258*r**4+224*r**6-35*r**8)+12*Q2*(
            -5-28*r**2+149*r**4+77*r**6-14*r**8+r**10)+3*(-1+314*r**2+377*r**4
            +1852*r**6-323*r**8-62*r**10+3*r**12))+384*logq2*r**6*(16*Q2**6-61*Q2**5*(1
            +r**2)+Q2**4*(75+103*r**2+60*r**4)-2*Q2**3*(5+31*r**2+16*r**4+5*r**6)
            +9*(-1+r**2)**2*(-1-11*r**2-41*r**4-11*r**6+4*r**8)+Q2**2*(-50-22*r**2
            -216*r**4+68*r**6+40*r**8)+Q2*(39+123*r**2+1008*r**4+978*r**6+93*r**8
            -81*r**10))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(103680*logq2**3*r**14*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))+2160*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-60*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-25920*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC*(138240*logq2**2*(-Q2+(-1+r)**2)*r**10*(3+2*r**2)*(
            -Q2+(1+r)**2)+64*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(32*Q2**7
            -Q2**6*(43+60*r**2)-4*Q2**5*(7-17*r**2+8*r**4)-4*Q2**3*(-10+51*r**2
            +345*r**4+4*r**6)+Q2**4*(25-126*r**2-251*r**4+100*r**6)+Q2**2*(-17
            +268*r**2+1270*r**4+1952*r**6+479*r**8-52*r**10)+12*Q2*(-1+10*r**2
            +75*r**4+35*r**6+180*r**8+r**10)+3*(1-22*r**2+311*r**4+1120*r**6
            +2595*r**8-326*r**10-83*r**12+4*r**14))-23040*logq2*r**6*(3*Q2**5*(1
            +r**2)-Q2**4*(8+17*r**2+9*r**4)+r**2*(-1+r**2)**2*(-11-41*r**2-11*r**4
            +3*r**6)+2*Q2**2*r**2*(-2-12*r**2+r**4+3*r**6)+2*Q2**3*(3+4*r**2+5*r**4
            +3*r**6)+Q2*(-1+21*r**2+106*r**4+104*r**6+19*r**8-9*r**10))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(311040*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+6480*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-180*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-77760*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC**2*(17280*logq2**2*(-Q2+(-1+r)**2)*r**10*(3+2*r**2)*(
            -Q2+(1+r)**2)+8*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(32*Q2**7
            -Q2**6*(43+60*r**2)-4*Q2**5*(7-17*r**2+8*r**4)-4*Q2**3*(-10+51*r**2
            +345*r**4+4*r**6)+Q2**4*(25-126*r**2-251*r**4+100*r**6)+Q2**2*(-17
            +268*r**2+1270*r**4+1952*r**6+479*r**8-52*r**10)+12*Q2*(-1+10*r**2
            +75*r**4+35*r**6+180*r**8+r**10)+3*(1-22*r**2+311*r**4+1120*r**6
            +2595*r**8-326*r**10-83*r**12+4*r**14))-2880*logq2*r**6*(3*Q2**5*(1+r**2)
            -Q2**4*(8+17*r**2+9*r**4)+r**2*(-1+r**2)**2*(-11-41*r**2-11*r**4+3*r**6)
            +2*Q2**2*r**2*(-2-12*r**2+r**4+3*r**6)+2*Q2**3*(3+4*r**2+5*r**4+3*r**6)
            +Q2*(-1+21*r**2+106*r**4+104*r**6+19*r**8-9*r**10))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(103680*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+2160*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-60*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-25920*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC**3*(-96*logq2*(24*Q2**6*(2+5*r**4)-Q2**5*(168
            +133*r**2+540*r**4+795*r**6)-2*Q2**3*r**2*(73+268*r**2+570*r**4+590*r**6
            +375*r**8)+Q2**4*(180+159*r**2+645*r**4+1825*r**6+1575*r**8)-(-1
            +r**2)**2*(12+37*r**2+2117*r**4+3922*r**6-558*r**8-415*r**10+405*r**12)
            -2*Q2**2*(60-167*r**2+799*r**4+538*r**6-700*r**8-135*r**10+525*r**12)
            +Q2*(72-201*r**2+4924*r**4+10719*r**6+7964*r**8-1103*r**10-1600*r**12
            +1305*r**14))+5760*logq2**2*r**4*(12+19*r**2+15*r**4)*sqrtq2-8*(120*Q2**9
            -3*Q2**8*(87+155*r**2)+Q2**7*(258+596*r**2+450*r**4)+Q2**6*(420-514*r**2
            -808*r**4+390*r**6)-6*Q2**5*(441+230*r**2+1306*r**4-98*r**6+145*r**8)
            +2*Q2**4*(1905+622*r**2+6030*r**4+13410*r**6+955*r**8+90*r**10)+2*Q2**3*(
            -477-362*r**2-6203*r**4-3468*r**6-8555*r**8-1802*r**10+195*r**12)
            -6*Q2**2*(378-1147*r**2+1784*r**4-3549*r**6-2410*r**8+3143*r**10-64*r**12
            +25*r**14)+(-1+r**2)**2*(-549+3179*r**2-33609*r**4-12869*r**6+18541*r**8
            -6915*r**10-943*r**12+45*r**14)+Q2*(2070-9916*r**2+66480*r**4+75468*r**6
            +27908*r**8-53892*r**10+22224*r**12+2228*r**14-90*r**16))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(174960*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+405*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-699840*logq2**3*r**12*sqrtq2
            -14580*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(flagPERP*muWC**3*(
            -48*logq2*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-10-11*r**2-36*Q2**4*r**2
            +14*r**4-1326*r**6-416*r**8+189*r**10+2*Q2**3*(-5+132*r**2+117*r**4)
            -Q2**2*(-10+191*r**2+524*r**4+171*r**6)-2*Q2*(-5+93*r**2+2*r**4-68*r**6
            +108*r**8))+1440*logq2**2*r**6*(-4+21*r**2+9*r**4)*sqrtq2+(-10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(-15+24*Q2**4-22*r**2-22*r**4-70*r**6+9*r**8
            -21*Q2**3*(1+r**2)+Q2**2*(-21+38*r**2-21*r**4)+Q2*(-15+29*r**2-43*r**4
            +9*r**6))+12*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(-3+5*Q2**3+5*r**2-19*r**4
            +5*r**6-5*Q2**2*(1+r**2)+Q2*(-5+8*r**2-5*r**4))*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(58320*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+135*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-233280*logq2**3*r**12*sqrtq2
            -4860*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((-17280*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(2+r**2)*(-Q2+(1+r)**2)-8*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(-17*Q2**6-4*Q2**5*(1+r**2)+Q2**4*(-57-182*r**2+75*r**4)
            +Q2**3*(128+964*r**2+316*r**4-40*r**6)+Q2**2*(13-424*r**2+258*r**4
            +224*r**6-35*r**8)+12*Q2*(-5-28*r**2+149*r**4+77*r**6-14*r**8+r**10)
            +3*(-1+314*r**2+377*r**4+1852*r**6-323*r**8-62*r**10+3*r**12))+192*logq2*r**6*(16*Q2**6
            -61*Q2**5*(1+r**2)+Q2**4*(75+103*r**2+60*r**4)-2*Q2**3*(5+31*r**2
            +16*r**4+5*r**6)+9*(-1+r**2)**2*(-1-11*r**2-41*r**4-11*r**6+4*r**8)
            +Q2**2*(-50-22*r**2-216*r**4+68*r**6+40*r**8)+Q2*(39+123*r**2+1008*r**4
            +978*r**6+93*r**8-81*r**10))*sqrtq2)*math.log(mu0)*nlo.X1Q2(0,'SM',Q2,r))/(34560*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+720*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-20*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-8640*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+((900*logq2*r**4*(1+r**2)-5*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2)*math.log(mus)*nlo.X1Q2(0,'SM',Q2,r))/(1728*logq2**2*r**8
            +12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-288*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((17280*logq2**2*(-Q2+(
            -1+r)**2)*r**10*(2+r**2)*(-Q2+(1+r)**2)+8*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(-17*Q2**6-4*Q2**5*(1+r**2)+Q2**4*(-57-182*r**2+75*r**4)
            +Q2**3*(128+964*r**2+316*r**4-40*r**6)+Q2**2*(13-424*r**2+258*r**4
            +224*r**6-35*r**8)+12*Q2*(-5-28*r**2+149*r**4+77*r**6-14*r**8+r**10)
            +3*(-1+314*r**2+377*r**4+1852*r**6-323*r**8-62*r**10+3*r**12))-192*logq2*r**6*(16*Q2**6
            -61*Q2**5*(1+r**2)+Q2**4*(75+103*r**2+60*r**4)-2*Q2**3*(5+31*r**2
            +16*r**4+5*r**6)+9*(-1+r**2)**2*(-1-11*r**2-41*r**4-11*r**6+4*r**8)
            +Q2**2*(-50-22*r**2-216*r**4+68*r**6+40*r**8)+Q2*(39+123*r**2+1008*r**4
            +978*r**6+93*r**8-81*r**10))*sqrtq2)*math.log(r)*nlo.X1Q2(0,'SM',Q2,r))/(34560*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+720*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-20*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-8640*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+((-180*logq2*r**4*(1+r**2)+(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r)**2)/(-17280*logq2**3*r**12
            -360*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+4320*logq2**2*r**8*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(flagPERP*muWC**3*(-4*(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(-3+5*Q2**3+5*r**2-19*r**4+5*r**6-5*Q2**2*(1+r**2)+Q2*(
            -5+8*r**2-5*r**4))+48*logq2*r**4*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(-216*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+1296*logq2**2*r**8*sqrtq2+9*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)+((muWC**3*(16*(5*Q2**5-Q2**4*(7+15*r**2)+2*Q2**3*(4
            +2*r**2+5*r**4)+(-1+r**2)**2*(17+r**2-11*r**4+5*r**6)+2*Q2**2*(7
            -6*r**2-4*r**4+5*r**6)-Q2*(37+20*r**2+8*r**4-32*r**6+15*r**8))+192*logq2*sqrtq2))/(
            -648*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+3888*logq2**2*r**8*sqrtq2
            +27*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(-768*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)+64*r**4*(-Q2**4+Q2**3*(1+r**2)+2*(-1+r**2)**2*(-2-5*r**2
            +r**4)+Q2**2*(-3-4*r**2+3*r**4)+Q2*(7+29*r**2+17*r**4-5*r**6))*sqrtq2)/(
            -1728*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-12*(-Q2+(-1
            +r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+288*logq2*r**6*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC**2*(576*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)-16*r**2*(5*Q2**5-Q2**4*(13+15*r**2)+2*Q2**3*(4+4*r**2+5*r**4)
            +(-1+r**2)**2*(1-15*r**2-27*r**4+5*r**6)+2*Q2**2*(2-6*r**2-7*r**4
            +5*r**6)+Q2*(-5+36*r**2+72*r**4+56*r**6-15*r**8))*sqrtq2))/(-1728*logq2**2*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-12*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+288*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC*(4608*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)-128*r**2*(5*Q2**5-Q2**4*(13+15*r**2)
            +2*Q2**3*(4+4*r**2+5*r**4)+(-1+r**2)**2*(1-15*r**2-27*r**4+5*r**6)
            +2*Q2**2*(2-6*r**2-7*r**4+5*r**6)+Q2*(-5+36*r**2+72*r**4+56*r**6
            -15*r**8))*sqrtq2))/(-5184*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))
            -36*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            +864*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1
            +r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(
            -3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((-384*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)+32*r**4*(-Q2**4+Q2**3*(1+r**2)+2*(-1+r**2)**2*(
            -2-5*r**2+r**4)+Q2**2*(-3-4*r**2+3*r**4)+Q2*(7+29*r**2+17*r**4
            -5*r**6))*sqrtq2)*math.log(mu0))/(-576*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))-4*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+96*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(25*math.log(mus))/(-72*logq2*r**4
            +6*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)
            +((384*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)-32*r**4*(-Q2**4+Q2**3*(1
            +r**2)+2*(-1+r**2)**2*(-2-5*r**2+r**4)+Q2**2*(-3-4*r**2+3*r**4)+Q2*(7
            +29*r**2+17*r**4-5*r**6))*sqrtq2)*math.log(r))/(-576*logq2**2*r**10*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))-4*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+96*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2))*nlo.X1Q2(1,'SM',Q2,r)
            -(nlo.X1Q2(0,'SM',Q2,r)*nlo.X1Q2(1,'SM',Q2,r))/(144*logq2**2*r**8+(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-24*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((180*logq2*r**4*(1+r**2)+(
            -3-8*Q2**4+42*r**2+282*r**4+42*r**6-3*r**8+7*Q2**3*(1+r**2)+Q2**2*(7
            -2*r**2+7*r**4)-3*Q2*(1-11*r**2-11*r**4+r**6))*sqrtq2)*nnlo.X2Q2(0,Q2,r))/(1440*logq2**2*r**8
            +10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-240*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+nnlo.X2Q2(1,Q2,r)/(-12*logq2*r**4
            +(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))
        if( flagDEBUG == 1):
            print("Q2moment n. 1 NNLO = api^2*",resNNLO*par.mbkin**2)
        res += api**2*resNNLO

    if((kwargs.get('flag_includeNNLO', 1) == 1) and (kwargs.get('flag_includeNLOpw', 1) == 1)):
        resNNLO = 0
        resNNLO +=(FLAGcD*muWC**3*((48*logq2*(24*Q2**6*(1+5*r**4)-Q2**5*(99+64*r**2+315*r**4
            +570*r**6)+Q2**4*(135+117*r**2+285*r**4+835*r**6+900*r**8)-2*Q2**3*(15
            +49*r**2+64*r**4+315*r**6+275*r**8+150*r**10)-(-1+r**2)**2*(21-89*r**2
            +506*r**4+2986*r**6-99*r**8-145*r**10+180*r**12)-2*Q2**2*(45-116*r**2
            +232*r**4+544*r**6-265*r**8-180*r**10+300*r**12)+Q2*(81-318*r**2
            +1207*r**4+6102*r**6+6587*r**8-14*r**10-835*r**12+630*r**14))-2880*logq2**2*r**4*(3
            +10*r**2+15*r**4)*sqrtq2+8*(6*Q2**8+4*Q2**7*(3+r**2)+2*Q2**6*(15+62*r**2
            +29*r**4)-3*Q2**5*(213+125*r**2+943*r**4+151*r**6)+Q2**4*(1455+256*r**2
            +2430*r**4+7200*r**6+835*r**8)-2*Q2**3*(393-302*r**2+1597*r**4+627*r**6
            +2110*r**8+223*r**10)-6*Q2**2*(142-373*r**2+436*r**4-746*r**6-790*r**8
            +727*r**10+44*r**12)-(-1+r**2)**2*(351-2656*r**2+9501*r**4+5656*r**6
            -4919*r**8+2040*r**10+107*r**12)+Q2*(1125-6209*r**2+15555*r**4+24657*r**6
            +13387*r**8-14463*r**10+5901*r**12+367*r**14))*sqrtq2)/(-3240*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+19440*logq2**2*r**8*sqrtq2+135*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)+((-960*logq2*(24*Q2**6*(1+5*r**4)-Q2**5*(99+64*r**2
            +315*r**4+570*r**6)+Q2**4*(135+117*r**2+285*r**4+835*r**6+900*r**8)
            -2*Q2**3*(15+49*r**2+64*r**4+315*r**6+275*r**8+150*r**10)-(-1+r**2)**2*(21
            -89*r**2+506*r**4+2986*r**6-99*r**8-145*r**10+180*r**12)-2*Q2**2*(45
            -116*r**2+232*r**4+544*r**6-265*r**8-180*r**10+300*r**12)+Q2*(81
            -318*r**2+1207*r**4+6102*r**6+6587*r**8-14*r**10-835*r**12+630*r**14))
            +57600*logq2**2*r**4*(3+10*r**2+15*r**4)*sqrtq2-160*(6*Q2**8+4*Q2**7*(3
            +r**2)+2*Q2**6*(15+62*r**2+29*r**4)-3*Q2**5*(213+125*r**2+943*r**4
            +151*r**6)+Q2**4*(1455+256*r**2+2430*r**4+7200*r**6+835*r**8)-2*Q2**3*(393
            -302*r**2+1597*r**4+627*r**6+2110*r**8+223*r**10)-6*Q2**2*(142-373*r**2
            +436*r**4-746*r**6-790*r**8+727*r**10+44*r**12)-(-1+r**2)**2*(351
            -2656*r**2+9501*r**4+5656*r**6-4919*r**8+2040*r**10+107*r**12)+Q2*(1125
            -6209*r**2+15555*r**4+24657*r**6+13387*r**8-14463*r**10+5901*r**12
            +367*r**14))*sqrtq2)*math.log(murhoD))/(-17496*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+104976*logq2**2*r**8*sqrtq2+729*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2))
            +FLAGcD*flagPERP*muWC**3*((48*logq2*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(
            -5+26*r**2-24*Q2**4*r**2+16*r**4-294*r**6-19*r**8+36*r**10+Q2**3*(
            -5+81*r**2+66*r**4)-Q2**2*(-5+34*r**2+151*r**4+24*r**6)+Q2*(5-39*r**2
            -11*r**4+59*r**6-54*r**8))-2880*logq2**2*r**6*(-1+3*r**2)*sqrtq2+8*(
            -4*Q2**7*r**2+Q2**6*(9-31*r**2-4*r**4)+3*Q2**5*(-13+47*r**2+217*r**4
            +21*r**6)-Q2**4*(-60+193*r**2+1827*r**4+1761*r**6+115*r**8)+2*Q2**3*(
            -15+46*r**2+625*r**4+1065*r**6+622*r**8+25*r**10)+(-1+r**2)**2*(-6
            -r**2-69*r**4+316*r**6-1454*r**8+477*r**10+17*r**12)+3*Q2**2*(-5+7*r**2
            +68*r**4+202*r**6-473*r**8+263*r**10+18*r**12)+Q2*(21-37*r**2-201*r**4
            +933*r**6+203*r**8+3357*r**10-1335*r**12-61*r**14))*sqrtq2)/(-1080*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+6480*logq2**2*r**8*sqrtq2+45*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)+((-960*logq2*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(
            -5+26*r**2-24*Q2**4*r**2+16*r**4-294*r**6-19*r**8+36*r**10+Q2**3*(
            -5+81*r**2+66*r**4)-Q2**2*(-5+34*r**2+151*r**4+24*r**6)+Q2*(5-39*r**2
            -11*r**4+59*r**6-54*r**8))+57600*logq2**2*r**6*(-1+3*r**2)*sqrtq2+(
            -100*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*(-15+24*Q2**4-22*r**2-22*r**4-70*r**6
            +9*r**8-21*Q2**3*(1+r**2)+Q2**2*(-21+38*r**2-21*r**4)+Q2*(-15+29*r**2
            -43*r**4+9*r**6))+60*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(-3+5*Q2**3
            +5*r**2-19*r**4+5*r**6-5*Q2**2*(1+r**2)+Q2*(-5+8*r**2-5*r**4))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8)))*sqrtq2)*math.log(murhoD))/(
            -5832*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+34992*logq2**2*r**8*sqrtq2
            +243*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2))+(muWC**3*(-720*logq2*r**4*(1
            +r**2)+4*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*nlopw.X1Q2RhoD(0,Q2,r))/(6480*logq2**2*r**8
            +45*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-1080*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)-(8*muWC**3*nlopw.X1Q2RhoD(1,Q2,r))/(
            -108*logq2*r**4+9*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2))
        if( flagDEBUG == 1):
            print("Q2moment n. 1 NNLO pw = api^2*",resNNLO*par.mbkin**2)
        res += api**2*resNNLO

    return res*par.mbkin**2


def moment_2_KIN_MS(q2cut, par, hqe, wc, **kwargs):
    """ Central moment of the q2 spectrum. SM Part. Moment n. 2 """
    Q2=q2cut/par.mbkin**2
    r=par.mcMS/par.mbkin
    mus=par.scale_alphas/par.mbkin
    mu0=par.scale_mcMS/par.mbkin
    mumuG=par.scale_muG/par.mbkin
    murhoD=par.scale_rhoD/par.mbkin
    murhoLS=par.scale_rhoLS/par.mbkin
    muWC=par.scale_mbkin/par.mbkin
    api=par.alphas/math.pi

    rhoD=hqe.rhoD/par.mbkin**3
    rhoLS=hqe.rhoLS/par.mbkin**3
    muG=hqe.muG/par.mbkin**2

    pi2=math.pi**2
    z3=1.202056903159594
    flagPERP=kwargs.get('flag_basisPERP', 1)
    flagDEBUG=kwargs.get('flag_DEBUG', 0)
    FLAGcf=1
    FLAGcD=1
    FLAGcs=1

    sqrtq2=math.sqrt(1-2*Q2+Q2**2-2*r**2-2*Q2*r**2+r**4)
    logq2 =math.log((1-Q2+r**2-sqrtq2)/(1-Q2+r**2+sqrtq2))

    res = 0
    res +=((flagPERP*rhoD*(-1440*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(1
        -11*r**2+10*Q2**5*r**2+50*r**4+30*r**6+125*r**8-41*r**10+26*r**12-4*Q2**4*(1
        +8*r**2+11*r**4)+Q2**3*(6+49*r**2+89*r**4+61*r**6)-Q2**2*(-1+23*r**2
        +56*r**4+108*r**6+4*r**8)+Q2*(-4+12*r**2-33*r**4+27*r**6+77*r**8
        -49*r**10))-2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**9*r**2+Q2**8*(
        -22+89*r**2+23*r**4)-Q2**7*(-101+398*r**2+2817*r**4+196*r**6)+Q2**6*(
        -156+3*r**2+11687*r**4+9911*r**6+335*r**8)-Q2**5*(-47-904*r**2+10040*r**4
        +31544*r**6+7963*r**8+64*r**10)+Q2**4*(110+333*r**2-8167*r**4+8892*r**6
        +20686*r**8-10725*r**10-337*r**12)+Q2**3*(-93-2074*r**2+14295*r**4
        +18820*r**6+48901*r**8+4158*r**10+17921*r**12+272*r**14)+Q2**2*(-16
        +753*r**2-1695*r**4-6029*r**6-69053*r**8-42197*r**10-13221*r**12-1783*r**14
        +41*r**16)+Q2*(41+857*r**2-7214*r**4+9536*r**6-43980*r**8+110834*r**10
        -62202*r**12+21784*r**14-7941*r**16-115*r**18)+2*(-6-237*r**2+1964*r**4
        -9815*r**6-8509*r**8+86159*r**10-86693*r**12+43631*r**14-6565*r**16
        +1654*r**18+17*r**20))-43200*logq2**3*r**10*(1-2*r**2+3*r**4)*sqrtq2
        +12*logq2*r**2*(-5*(-1+Q2)**7*(7+15*Q2+8*Q2**2)-2*(-1+Q2)**5*(-121
        -75*Q2+30*Q2**2-150*Q2**3-180*Q2**4+46*Q2**5)*r**2+5*(-1+Q2)**3*(
        -77-113*Q2-324*Q2**2+602*Q2**3+33*Q2**4-621*Q2**5+140*Q2**6)*r**4
        -10*(-1166+2308*Q2-1238*Q2**2+2368*Q2**3-5001*Q2**4+2788*Q2**5+900*Q2**6
        -1160*Q2**7+201*Q2**8)*r**6+10*(-5855+4862*Q2-2830*Q2**2-5510*Q2**3
        +8466*Q2**4-2557*Q2**5-893*Q2**6+237*Q2**7)*r**8+10*(8718+2928*Q2
        +108*Q2**2-8184*Q2**3+4717*Q2**4-456*Q2**5+21*Q2**6)*r**10-2*(21593
        -20570*Q2-23820*Q2**2+7000*Q2**3-5890*Q2**4+1743*Q2**5)*r**12+10*(
        -656-3356*Q2-2430*Q2**2-632*Q2**3+315*Q2**4)*r**14-5*(-3063-4486*Q2
        -90*Q2**2+18*Q2**3)*r**16-10*(585-38*Q2+147*Q2**2)*r**18+5*(-3+178*Q2)*r**20
        -172*r**22)*sqrtq2))/(32400*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+75*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**3-129600*logq2**3*r**12*sqrtq2-2700*logq2*r**4*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2*sqrtq2)+(-3600*logq2**2*r**8*(-3+r**2)*(-1+3*r**2)
        +(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6
        -28170*r**8+31692*r**10-9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)
        +Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)
        +Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2
        -6138*r**4-6138*r**6-355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4
        +35188*r**6+10313*r**8-406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4
        +6605*r**6+6605*r**8-7237*r**10-595*r**12+27*r**14))-120*logq2*r**4*(37
        +20*Q2**5-r**2-156*r**4-156*r**6-r**8+37*r**10-88*Q2**4*(1+r**2)
        +Q2**3*(107+294*r**2+107*r**4)+Q2**2*(7-235*r**2-235*r**4+7*r**6)
        +Q2*(-83+30*r**2+66*r**4+30*r**6-83*r**8))*sqrtq2)/(43200*logq2**2*r**8
        +300*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
        -Q2**2*(1+r**2)-Q2*(1+r**4))**2-7200*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(flagPERP*rhoLS*(-43200*logq2**3*r**10*(1
        -2*r**2+3*r**4)-12*logq2*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-35
        +172*r**2+92*Q2**8*r**2-6*r**4-11844*r**6+34868*r**8-5600*r**10-2882*r**12
        +6396*r**14+359*r**16+172*r**18+Q2**7*(40-636*r**2-516*r**4)+Q2**6*(
        -125+1136*r**2+3085*r**4+886*r**6)-2*Q2**5*(-30+111*r**2+1967*r**4
        +2027*r**6+41*r**8)-Q2**4*(-175+1100*r**2+1500*r**4+2828*r**6+655*r**8
        +1260*r**10)+4*Q2**3*(-50+177*r**2+1320*r**4+3908*r**6+3628*r**8+1155*r**10
        +262*r**12)+Q2**2*(-15+436*r**2-2059*r**4-7258*r**6-27873*r**8-6128*r**10
        -2309*r**12+206*r**14)-2*Q2*(-50+293*r**2+175*r**4+367*r**6+1845*r**8
        -11305*r**10+4597*r**12+205*r**14+273*r**16))-1440*logq2**2*r**6*(1-11*r**2
        +10*Q2**5*r**2+50*r**4+30*r**6+125*r**8-41*r**10+26*r**12-4*Q2**4*(1
        +8*r**2+11*r**4)+Q2**3*(6+49*r**2+89*r**4+61*r**6)-Q2**2*(-1+23*r**2
        +56*r**4+108*r**6+4*r**8)+Q2*(-4+12*r**2-33*r**4+27*r**6+77*r**8
        -49*r**10))*sqrtq2-2*(7*Q2**11*r**2+Q2**10*(-22+75*r**2+9*r**4)-5*Q2**9*(
        -29+105*r**2+611*r**4+47*r**6)+10*Q2**8*(-38+73*r**2+1794*r**4+1598*r**6
        +75*r**8)-10*Q2**7*(-46-61*r**2+3534*r**4+6970*r**6+3088*r**8+93*r**10)
        +2*Q2**6*(-70-627*r**2+10815*r**4+39300*r**6+45950*r**8+7285*r**10
        +63*r**12)+2*Q2**5*(-133-1075*r**2+9081*r**4+3405*r**6+17415*r**8-15723*r**10
        +16105*r**12+441*r**14)-20*Q2**4*(-14-260*r**2+1743*r**4+2335*r**6
        +10488*r**8+9576*r**10+779*r**12+2411*r**14+42*r**16)+5*Q2**3*(-4-501*r**2
        +2604*r**4+2628*r**6+26348*r**8+51702*r**10+21428*r**12+4076*r**14
        +2584*r**16+15*r**18)+2*(-1+r**2)**2*(-6-237*r**2+1964*r**4-9815*r**6
        -8509*r**8+86159*r**10-86693*r**12+43631*r**14-6565*r**16+1654*r**18
        +17*r**20)+5*Q2**2*(-22-297*r**2+2685*r**4-5232*r**6-1364*r**8+25698*r**10
        -53706*r**12+30112*r**14-10086*r**16+3511*r**18+61*r**20)+Q2*(65+1747*r**2
        -15795*r**4+56225*r**6+3030*r**8-102270*r**10-325714*r**12+429270*r**14
        -261975*r**16+57195*r**18-14395*r**20-183*r**22))*sqrtq2))/(-129600*logq2**3*r**12
        -2700*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+32400*logq2**2*r**8*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+75*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**3*sqrtq2))
    res += ((muG*(43200*logq2**3*r**10*(1-2*r**2+3*r**4)
        +12*logq2*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-35+172*r**2+92*Q2**8*r**2
        -6*r**4-11844*r**6+34868*r**8-5600*r**10-2882*r**12+6396*r**14+359*r**16
        +172*r**18+Q2**7*(40-636*r**2-516*r**4)+Q2**6*(-125+1136*r**2+3085*r**4
        +886*r**6)-2*Q2**5*(-30+111*r**2+1967*r**4+2027*r**6+41*r**8)-Q2**4*(
        -175+1100*r**2+1500*r**4+2828*r**6+655*r**8+1260*r**10)+4*Q2**3*(-50
        +177*r**2+1320*r**4+3908*r**6+3628*r**8+1155*r**10+262*r**12)+Q2**2*(
        -15+436*r**2-2059*r**4-7258*r**6-27873*r**8-6128*r**10-2309*r**12
        +206*r**14)-2*Q2*(-50+293*r**2+175*r**4+367*r**6+1845*r**8-11305*r**10
        +4597*r**12+205*r**14+273*r**16))+1440*logq2**2*r**6*(1-11*r**2+10*Q2**5*r**2
        +50*r**4+30*r**6+125*r**8-41*r**10+26*r**12-4*Q2**4*(1+8*r**2+11*r**4)
        +Q2**3*(6+49*r**2+89*r**4+61*r**6)-Q2**2*(-1+23*r**2+56*r**4+108*r**6
        +4*r**8)+Q2*(-4+12*r**2-33*r**4+27*r**6+77*r**8-49*r**10))*sqrtq2
        +2*(7*Q2**11*r**2+Q2**10*(-22+75*r**2+9*r**4)-5*Q2**9*(-29+105*r**2
        +611*r**4+47*r**6)+10*Q2**8*(-38+73*r**2+1794*r**4+1598*r**6+75*r**8)
        -10*Q2**7*(-46-61*r**2+3534*r**4+6970*r**6+3088*r**8+93*r**10)+2*Q2**6*(
        -70-627*r**2+10815*r**4+39300*r**6+45950*r**8+7285*r**10+63*r**12)
        +2*Q2**5*(-133-1075*r**2+9081*r**4+3405*r**6+17415*r**8-15723*r**10
        +16105*r**12+441*r**14)-20*Q2**4*(-14-260*r**2+1743*r**4+2335*r**6
        +10488*r**8+9576*r**10+779*r**12+2411*r**14+42*r**16)+5*Q2**3*(-4-501*r**2
        +2604*r**4+2628*r**6+26348*r**8+51702*r**10+21428*r**12+4076*r**14
        +2584*r**16+15*r**18)+2*(-1+r**2)**2*(-6-237*r**2+1964*r**4-9815*r**6
        -8509*r**8+86159*r**10-86693*r**12+43631*r**14-6565*r**16+1654*r**18
        +17*r**20)+5*Q2**2*(-22-297*r**2+2685*r**4-5232*r**6-1364*r**8+25698*r**10
        -53706*r**12+30112*r**14-10086*r**16+3511*r**18+61*r**20)+Q2*(65+1747*r**2
        -15795*r**4+56225*r**6+3030*r**8-102270*r**10-325714*r**12+429270*r**14
        -261975*r**16+57195*r**18-14395*r**20-183*r**22))*sqrtq2))/(-129600*logq2**3*r**12
        -2700*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+32400*logq2**2*r**8*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+75*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**3*sqrtq2))
    res += ((rhoD*(1440*logq2**2*r**4*(10*Q2**7*(1+5*r**4)
        -4*Q2**6*(19+26*r**2+77*r**4+80*r**6)+Q2**5*(201+500*r**2+1457*r**4
        +1343*r**6+795*r**8)-Q2**4*(215+758*r**2+2837*r**4+3624*r**6+1980*r**8
        +850*r**10)+2*Q2**3*(10+191*r**2+810*r**4+1147*r**6+1353*r**8+415*r**10
        +50*r**12)+(-1+r**2)**2*(29-10*r**2+507*r**4-2218*r**6-3483*r**8-102*r**10
        +107*r**12+130*r**14)+Q2**2*(150-38*r**2+969*r**4-1368*r**6-2014*r**8
        -274*r**10+295*r**12+600*r**14)+Q2*(-119+86*r**2-1507*r**4+3971*r**6
        +11956*r**8+6170*r**10+135*r**12-27*r**14-505*r**16))+2*(Q2-(-1
        +r)**2)*(Q2-(1+r)**2)*(8*Q2**12+Q2**11*(19+5*r**2)+Q2**10*(69+312*r**2
        +139*r**4)-Q2**9*(2973+1415*r**2+13845*r**4+1655*r**6)+2*Q2**8*(6266
        +521*r**2+16200*r**4+35467*r**6+2610*r**8)-2*Q2**7*(9712-3611*r**2
        -9936*r**4+62186*r**6+66386*r**8+3423*r**10)+2*Q2**6*(2072+1935*r**2
        -61245*r**4-10798*r**6+86420*r**8+26287*r**10+945*r**12)+2*Q2**5*(11672
        -41479*r**2+147396*r**4+209881*r**6+240442*r**8-62343*r**10+78766*r**12
        +2481*r**14)-2*Q2**4*(13201-71075*r**2+299355*r**4+744945*r**6+919905*r**8
        +713699*r**10-54415*r**12+110975*r**14+2610*r**16)+Q2**3*(3893-46947*r**2
        +402420*r**4+1147164*r**6+2150370*r**8+1441802*r**10+967372*r**12+3940*r**14
        +58121*r**16+505*r**18)+2*(-1+r**2)**2*(731-9790*r**2+106706*r**4-300958*r**6
        +144348*r**8-301378*r**10-524770*r**12+302334*r**14-29527*r**16+7392*r**18
        +112*r**20)+Q2**2*(10491-84742*r**2+442083*r**4-100472*r**6+770418*r**8
        -528204*r**10-289358*r**12+1166712*r**14-258093*r**16+78802*r**18+1963*r**20)
        +Q2*(-7163+83965*r**2-710695*r**4+1148445*r**6+456510*r**8+1378846*r**10
        +1630950*r**12+2565390*r**14-1921475*r**16+278885*r**18-64063*r**20
        -1195*r**22))+43200*logq2**3*r**8*(3+5*r**2-65*r**4+r**6)*sqrtq2+12*logq2*(92*Q2**10*(1
        +5*r**4)-20*Q2**9*(29+15*r**2+105*r**4+175*r**6)+5*Q2**8*(279+271*r**2
        +205*r**4+2715*r**6+2010*r**8)-10*Q2**7*(132+259*r**2-766*r**4+668*r**6
        +3002*r**8+1185*r**10)-10*Q2**6*(42-335*r**2+2345*r**4+3050*r**6+2732*r**8
        -2147*r**10+105*r**12)+2*Q2**5*(1008-1895*r**2+25330*r**4+86925*r**6
        +128000*r**8+85343*r**10+7950*r**12+8715*r**14)-10*Q2**4*(147-230*r**2
        +6386*r**4+37548*r**6+74256*r**8+63236*r**10+26280*r**12+3650*r**14
        +1575*r**16)+10*Q2**3*(-12+167*r**2+1354*r**4+25306*r**6+51738*r**8
        +66076*r**10+43574*r**12+6870*r**14+2450*r**16+45*r**18)+10*Q2**2*(72
        -391*r**2+5303*r**4+3264*r**6+11020*r**8-2606*r**10-21870*r**12+6408*r**14
        +19188*r**16-963*r**18+735*r**20)+(-1+r**2)**2*(67-401*r**2+13526*r**4
        +9618*r**6-128500*r**8-158132*r**10-447154*r**12+51694*r**14+52977*r**16
        +645*r**18+860*r**20)-10*Q2*(38-245*r**2+5136*r**4+3913*r**6-15952*r**8
        -85914*r**10-97164*r**12-75350*r**14+4778*r**16+18783*r**18-388*r**20
        +445*r**22))*sqrtq2))/(97200*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
        +225*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-388800*logq2**3*r**12*sqrtq2-8100*logq2*r**4*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2*sqrtq2))

    if( flagDEBUG == 1):
        print("Q2moment n. 2 LO = ",res*par.mbkin**4)
    resNLO = 0
    resNLO +=((muWC**2*(345600*logq2**3*(-Q2+(-1+r)**2)*r**14*(-3+5*r**2)*(-Q2+(1+r)**2)
        +96*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(39+184*Q2**8-3867*r**2
        -25973*r**4+50081*r**6-3175*r**8-8589*r**10+11917*r**12+823*r**14+344*r**16
        -8*Q2**7*(149+129*r**2)+Q2**6*(2367+5475*r**2+1772*r**4)-2*Q2**5*(667
        +3104*r**2+3119*r**4+82*r**6)-Q2**4*(895-535*r**2+7961*r**4+3335*r**6
        +2520*r**8)+4*Q2**3*(249-390*r**2+1196*r**4+6626*r**6+2435*r**8+524*r**10)
        +Q2**2*(97+1297*r**2+15474*r**4-10226*r**6-7811*r**8-3923*r**10+412*r**12)
        -2*Q2*(131-2680*r**2-9071*r**4+10450*r**6-13055*r**8+9404*r**10+675*r**12
        +546*r**14))+5760*logq2**2*r**10*(40*Q2**7-4*Q2**6*(37+64*r**2)+3*Q2**5*(51
        +183*r**2+212*r**4)-Q2**4*(5+154*r**2+653*r**4+680*r**6)+2*Q2**3*(70
        -117*r**2+9*r**4+116*r**6+40*r**8)+(-1+r**2)**2*(-163+26*r**2+106*r**4
        +466*r**6-179*r**8+104*r**10)+Q2**2*(-540+6*r**2+20*r**4+502*r**6
        -348*r**8+480*r**10)+Q2*(523-263*r**2+208*r**4-1052*r**6-1207*r**8
        +755*r**10-404*r**12))*sqrtq2+8*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
        -13+4*Q2**10+404*r**2-6453*r**4-53600*r**6-142382*r**8+644712*r**10
        -641774*r**12+323008*r**14-51045*r**16+13412*r**18+131*r**20+7*Q2**9*(1
        +r**2)+3*Q2**8*(-41+102*r**2+47*r**4)-6*Q2**7*(-57+312*r**2+1834*r**4
        +145*r**6)+6*Q2**6*(-63+623*r**2+7092*r**4+6423*r**6+249*r**8)-6*Q2**5*(
        -14+369*r**2+6937*r**4+16621*r**6+4867*r**8+80*r**10)-2*Q2**4*(-84
        +891*r**2+4110*r**4-10306*r**6-20622*r**8+23091*r**10+576*r**12)+2*Q2**3*(
        -51+1152*r**2+8712*r**4-14165*r**6+78457*r**8+13926*r**10+36702*r**12
        +507*r**14)+6*Q2**2*(-7+57*r**2+354*r**4+10083*r**6+11218*r**8-19285*r**10
        -5374*r**12-1151*r**14+25*r**16)+Q2*(53-1233*r**2+5058*r**4+62878*r**6
        -3216*r**8+163512*r**10-224402*r**12+73362*r**14-32373*r**16-439*r**18))*sqrtq2))/(1555200*logq2**3*r**14*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))+32400*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
        +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-900*(-Q2+(-1+r)**2)*r**2*(-Q2
        +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-388800*logq2**2*r**10*(Q2**5
        -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
        +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
        -3*r**8))*sqrtq2)+(muWC*(2764800*logq2**3*(-Q2+(-1+r)**2)*r**14*(-3+5*r**2)*(
        -Q2+(1+r)**2)+768*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(39
        +184*Q2**8-3867*r**2-25973*r**4+50081*r**6-3175*r**8-8589*r**10+11917*r**12
        +823*r**14+344*r**16-8*Q2**7*(149+129*r**2)+Q2**6*(2367+5475*r**2+1772*r**4)
        -2*Q2**5*(667+3104*r**2+3119*r**4+82*r**6)-Q2**4*(895-535*r**2+7961*r**4
        +3335*r**6+2520*r**8)+4*Q2**3*(249-390*r**2+1196*r**4+6626*r**6+2435*r**8
        +524*r**10)+Q2**2*(97+1297*r**2+15474*r**4-10226*r**6-7811*r**8-3923*r**10
        +412*r**12)-2*Q2*(131-2680*r**2-9071*r**4+10450*r**6-13055*r**8+9404*r**10
        +675*r**12+546*r**14))+46080*logq2**2*r**10*(40*Q2**7-4*Q2**6*(37+64*r**2)
        +3*Q2**5*(51+183*r**2+212*r**4)-Q2**4*(5+154*r**2+653*r**4+680*r**6)
        +2*Q2**3*(70-117*r**2+9*r**4+116*r**6+40*r**8)+(-1+r**2)**2*(-163
        +26*r**2+106*r**4+466*r**6-179*r**8+104*r**10)+Q2**2*(-540+6*r**2
        +20*r**4+502*r**6-348*r**8+480*r**10)+Q2*(523-263*r**2+208*r**4-1052*r**6
        -1207*r**8+755*r**10-404*r**12))*sqrtq2+64*r**2*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))**2*(-13+4*Q2**10+404*r**2-6453*r**4-53600*r**6-142382*r**8
        +644712*r**10-641774*r**12+323008*r**14-51045*r**16+13412*r**18+131*r**20
        +7*Q2**9*(1+r**2)+3*Q2**8*(-41+102*r**2+47*r**4)-6*Q2**7*(-57+312*r**2
        +1834*r**4+145*r**6)+6*Q2**6*(-63+623*r**2+7092*r**4+6423*r**6+249*r**8)
        -6*Q2**5*(-14+369*r**2+6937*r**4+16621*r**6+4867*r**8+80*r**10)-2*Q2**4*(
        -84+891*r**2+4110*r**4-10306*r**6-20622*r**8+23091*r**10+576*r**12)
        +2*Q2**3*(-51+1152*r**2+8712*r**4-14165*r**6+78457*r**8+13926*r**10
        +36702*r**12+507*r**14)+6*Q2**2*(-7+57*r**2+354*r**4+10083*r**6+11218*r**8
        -19285*r**10-5374*r**12-1151*r**14+25*r**16)+Q2*(53-1233*r**2+5058*r**4
        +62878*r**6-3216*r**8+163512*r**10-224402*r**12+73362*r**14-32373*r**16
        -439*r**18))*sqrtq2))/(4665600*logq2**3*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))+97200*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(
        -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2-2700*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**3*sqrtq2-1166400*logq2**2*r**10*(Q2**5-3*Q2**4*(1
        +r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)
        +2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)
        +(-691200*logq2**3*(-Q2+(-1+r)**2)*r**16*(-5+3*r**2)*(-Q2+(1+r)**2)
        +192*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(344+184*Q2**8
        +823*r**2+11917*r**4-8589*r**6-3175*r**8+50081*r**10-25973*r**12-3867*r**14
        +39*r**16-8*Q2**7*(129+149*r**2)+Q2**6*(1772+5475*r**2+2367*r**4)-2*Q2**5*(82
        +3119*r**2+3104*r**4+667*r**6)-Q2**4*(2520+3335*r**2+7961*r**4-535*r**6
        +895*r**8)+4*Q2**3*(524+2435*r**2+6626*r**4+1196*r**6-390*r**8+249*r**10)
        +Q2**2*(412-3923*r**2-7811*r**4-10226*r**6+15474*r**8+1297*r**10+97*r**12)
        -2*Q2*(546+675*r**2+9404*r**4-13055*r**6+10450*r**8-9071*r**10-2680*r**12
        +131*r**14))+11520*logq2**2*r**10*(40*Q2**7-4*Q2**6*(64+37*r**2)+3*Q2**5*(212
        +183*r**2+51*r**4)-Q2**4*(680+653*r**2+154*r**4+5*r**6)+2*Q2**3*(40
        +116*r**2+9*r**4-117*r**6+70*r**8)+Q2**2*(480-348*r**2+502*r**4+20*r**6
        +6*r**8-540*r**10)-(-1+r**2)**2*(-104+179*r**2-466*r**4-106*r**6-26*r**8
        +163*r**10)+Q2*(-404+755*r**2-1207*r**4-1052*r**6+208*r**8-263*r**10
        +523*r**12))*sqrtq2+16*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(131
        +4*Q2**10+13412*r**2-51045*r**4+323008*r**6-641774*r**8+644712*r**10
        -142382*r**12-53600*r**14-6453*r**16+404*r**18-13*r**20+7*Q2**9*(1
        +r**2)+Q2**8*(141+306*r**2-123*r**4)+6*Q2**7*(-145-1834*r**2-312*r**4
        +57*r**6)-6*Q2**6*(-249-6423*r**2-7092*r**4-623*r**6+63*r**8)+6*Q2**5*(
        -80-4867*r**2-16621*r**4-6937*r**6-369*r**8+14*r**10)+2*Q2**4*(-576
        -23091*r**2+20622*r**4+10306*r**6-4110*r**8-891*r**10+84*r**12)+2*Q2**3*(507
        +36702*r**2+13926*r**4+78457*r**6-14165*r**8+8712*r**10+1152*r**12
        -51*r**14)-6*Q2**2*(-25+1151*r**2+5374*r**4+19285*r**6-11218*r**8-10083*r**10
        -354*r**12-57*r**14+7*r**16)+Q2*(-439-32373*r**2+73362*r**4-224402*r**6
        +163512*r**8-3216*r**10+62878*r**12+5058*r**14-1233*r**16+53*r**18))*sqrtq2)/(1555200*logq2**3*r**14*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))+32400*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
        +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-900*(-Q2+(-1+r)**2)*r**2*(-Q2
        +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-388800*logq2**2*r**10*(Q2**5
        -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
        +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
        -3*r**8))*sqrtq2)+(flagPERP*muWC**3*(11520*logq2**2*(-Q2+(-1+r)**2)*r**6*(
        -Q2+(1+r)**2)*(1-11*r**2+10*Q2**5*r**2+50*r**4+30*r**6+125*r**8-41*r**10
        +26*r**12-4*Q2**4*(1+8*r**2+11*r**4)+Q2**3*(6+49*r**2+89*r**4+61*r**6)
        -Q2**2*(-1+23*r**2+56*r**4+108*r**6+4*r**8)+Q2*(-4+12*r**2-33*r**4
        +27*r**6+77*r**8-49*r**10))+16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**9*r**2
        +Q2**8*(-22+89*r**2+23*r**4)-Q2**7*(-101+398*r**2+2817*r**4+196*r**6)
        +Q2**6*(-156+3*r**2+11687*r**4+9911*r**6+335*r**8)-Q2**5*(-47-904*r**2
        +10040*r**4+31544*r**6+7963*r**8+64*r**10)+Q2**4*(110+333*r**2-8167*r**4
        +8892*r**6+20686*r**8-10725*r**10-337*r**12)+Q2**3*(-93-2074*r**2+14295*r**4
        +18820*r**6+48901*r**8+4158*r**10+17921*r**12+272*r**14)+Q2**2*(-16
        +753*r**2-1695*r**4-6029*r**6-69053*r**8-42197*r**10-13221*r**12-1783*r**14
        +41*r**16)+Q2*(41+857*r**2-7214*r**4+9536*r**6-43980*r**8+110834*r**10
        -62202*r**12+21784*r**14-7941*r**16-115*r**18)+2*(-6-237*r**2+1964*r**4
        -9815*r**6-8509*r**8+86159*r**10-86693*r**12+43631*r**14-6565*r**16
        +1654*r**18+17*r**20))+345600*logq2**3*r**10*(1-2*r**2+3*r**4)*sqrtq2
        +96*logq2*r**2*(92*Q2**10*r**2-20*Q2**9*(-2+41*r**2+35*r**4)+5*Q2**8*(
        -41+484*r**2+1041*r**4+402*r**6)-10*Q2**7*(-35+296*r**2+1158*r**4
        +1160*r**6+237*r**8)-10*Q2**6*(7-61*r**2-750*r**4-900*r**6-893*r**8
        +21*r**10)+Q2**5*(-490+2216*r**2+7050*r**4+27880*r**6+25570*r**8+4560*r**10
        +3486*r**12)-10*Q2**4*(-56+203*r**2+1316*r**4+5001*r**6+8466*r**8+4717*r**10
        +1178*r**12+315*r**14)+10*Q2**3*(-7-32*r**2+656*r**4+2368*r**6+5510*r**8
        +8184*r**10+1400*r**12+632*r**14+9*r**16)+10*Q2**2*(-25+161*r**2-108*r**4
        -1238*r**6+2830*r**8-108*r**10-4764*r**12+2430*r**14-45*r**16+147*r**18)
        +(-1+r**2)**2*(-35+172*r**2-6*r**4-11844*r**6+34868*r**8-5600*r**10
        -2882*r**12+6396*r**14+359*r**16+172*r**18)-10*Q2*(-17+106*r**2-59*r**4
        -2308*r**6+4862*r**8+2928*r**10+4114*r**12-3356*r**14+2243*r**16+38*r**18
        +89*r**20))*sqrtq2))/(291600*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
        +675*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-1166400*logq2**3*r**12*sqrtq2-24300*logq2*r**4*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2*sqrtq2)+(muWC**3*(-11520*logq2**2*r**4*(10*Q2**7*(1
        +5*r**4)-4*Q2**6*(19+26*r**2+77*r**4+80*r**6)+Q2**5*(201+500*r**2
        +1457*r**4+1343*r**6+795*r**8)-Q2**4*(215+758*r**2+2837*r**4+3624*r**6
        +1980*r**8+850*r**10)+2*Q2**3*(10+191*r**2+810*r**4+1147*r**6+1353*r**8
        +415*r**10+50*r**12)+(-1+r**2)**2*(29-10*r**2+507*r**4-2218*r**6-3483*r**8
        -102*r**10+107*r**12+130*r**14)+Q2**2*(150-38*r**2+969*r**4-1368*r**6
        -2014*r**8-274*r**10+295*r**12+600*r**14)+Q2*(-119+86*r**2-1507*r**4
        +3971*r**6+11956*r**8+6170*r**10+135*r**12-27*r**14-505*r**16))-16*(Q2
        -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**12+Q2**11*(19+5*r**2)+Q2**10*(69
        +312*r**2+139*r**4)-Q2**9*(2973+1415*r**2+13845*r**4+1655*r**6)+2*Q2**8*(6266
        +521*r**2+16200*r**4+35467*r**6+2610*r**8)-2*Q2**7*(9712-3611*r**2
        -9936*r**4+62186*r**6+66386*r**8+3423*r**10)+2*Q2**6*(2072+1935*r**2
        -61245*r**4-10798*r**6+86420*r**8+26287*r**10+945*r**12)+2*Q2**5*(11672
        -41479*r**2+147396*r**4+209881*r**6+240442*r**8-62343*r**10+78766*r**12
        +2481*r**14)-2*Q2**4*(13201-71075*r**2+299355*r**4+744945*r**6+919905*r**8
        +713699*r**10-54415*r**12+110975*r**14+2610*r**16)+Q2**3*(3893-46947*r**2
        +402420*r**4+1147164*r**6+2150370*r**8+1441802*r**10+967372*r**12+3940*r**14
        +58121*r**16+505*r**18)+2*(-1+r**2)**2*(731-9790*r**2+106706*r**4-300958*r**6
        +144348*r**8-301378*r**10-524770*r**12+302334*r**14-29527*r**16+7392*r**18
        +112*r**20)+Q2**2*(10491-84742*r**2+442083*r**4-100472*r**6+770418*r**8
        -528204*r**10-289358*r**12+1166712*r**14-258093*r**16+78802*r**18+1963*r**20)
        +Q2*(-7163+83965*r**2-710695*r**4+1148445*r**6+456510*r**8+1378846*r**10
        +1630950*r**12+2565390*r**14-1921475*r**16+278885*r**18-64063*r**20
        -1195*r**22))-345600*logq2**3*r**8*(3+5*r**2-65*r**4+r**6)*sqrtq2-96*logq2*(92*Q2**10*(1
        +5*r**4)-20*Q2**9*(29+15*r**2+105*r**4+175*r**6)+5*Q2**8*(279+271*r**2
        +205*r**4+2715*r**6+2010*r**8)-10*Q2**7*(132+259*r**2-766*r**4+668*r**6
        +3002*r**8+1185*r**10)-10*Q2**6*(42-335*r**2+2345*r**4+3050*r**6+2732*r**8
        -2147*r**10+105*r**12)+2*Q2**5*(1008-1895*r**2+25330*r**4+86925*r**6
        +128000*r**8+85343*r**10+7950*r**12+8715*r**14)-10*Q2**4*(147-230*r**2
        +6386*r**4+37548*r**6+74256*r**8+63236*r**10+26280*r**12+3650*r**14
        +1575*r**16)+10*Q2**3*(-12+167*r**2+1354*r**4+25306*r**6+51738*r**8
        +66076*r**10+43574*r**12+6870*r**14+2450*r**16+45*r**18)+10*Q2**2*(72
        -391*r**2+5303*r**4+3264*r**6+11020*r**8-2606*r**10-21870*r**12+6408*r**14
        +19188*r**16-963*r**18+735*r**20)+(-1+r**2)**2*(67-401*r**2+13526*r**4
        +9618*r**6-128500*r**8-158132*r**10-447154*r**12+51694*r**14+52977*r**16
        +645*r**18+860*r**20)-10*Q2*(38-245*r**2+5136*r**4+3913*r**6-15952*r**8
        -85914*r**10-97164*r**12-75350*r**14+4778*r**16+18783*r**18-388*r**20
        +445*r**22))*sqrtq2))/(874800*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
        +2025*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-3499200*logq2**3*r**12*sqrtq2-72900*logq2*r**4*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2*sqrtq2)+((-345600*logq2**3*(-Q2+(-1+r)**2)*r**16*(
        -5+3*r**2)*(-Q2+(1+r)**2)+96*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**2*(344+184*Q2**8+823*r**2+11917*r**4-8589*r**6-3175*r**8+50081*r**10
        -25973*r**12-3867*r**14+39*r**16-8*Q2**7*(129+149*r**2)+Q2**6*(1772
        +5475*r**2+2367*r**4)-2*Q2**5*(82+3119*r**2+3104*r**4+667*r**6)-Q2**4*(2520
        +3335*r**2+7961*r**4-535*r**6+895*r**8)+4*Q2**3*(524+2435*r**2+6626*r**4
        +1196*r**6-390*r**8+249*r**10)+Q2**2*(412-3923*r**2-7811*r**4-10226*r**6
        +15474*r**8+1297*r**10+97*r**12)-2*Q2*(546+675*r**2+9404*r**4-13055*r**6
        +10450*r**8-9071*r**10-2680*r**12+131*r**14))+5760*logq2**2*r**10*(40*Q2**7
        -4*Q2**6*(64+37*r**2)+3*Q2**5*(212+183*r**2+51*r**4)-Q2**4*(680+653*r**2
        +154*r**4+5*r**6)+2*Q2**3*(40+116*r**2+9*r**4-117*r**6+70*r**8)+Q2**2*(480
        -348*r**2+502*r**4+20*r**6+6*r**8-540*r**10)-(-1+r**2)**2*(-104+179*r**2
        -466*r**4-106*r**6-26*r**8+163*r**10)+Q2*(-404+755*r**2-1207*r**4
        -1052*r**6+208*r**8-263*r**10+523*r**12))*sqrtq2+8*r**4*(Q2**2+(-1
        +r**2)**2-2*Q2*(1+r**2))**2*(131+4*Q2**10+13412*r**2-51045*r**4+323008*r**6
        -641774*r**8+644712*r**10-142382*r**12-53600*r**14-6453*r**16+404*r**18
        -13*r**20+7*Q2**9*(1+r**2)+Q2**8*(141+306*r**2-123*r**4)+6*Q2**7*(
        -145-1834*r**2-312*r**4+57*r**6)-6*Q2**6*(-249-6423*r**2-7092*r**4
        -623*r**6+63*r**8)+6*Q2**5*(-80-4867*r**2-16621*r**4-6937*r**6-369*r**8
        +14*r**10)+2*Q2**4*(-576-23091*r**2+20622*r**4+10306*r**6-4110*r**8
        -891*r**10+84*r**12)+2*Q2**3*(507+36702*r**2+13926*r**4+78457*r**6
        -14165*r**8+8712*r**10+1152*r**12-51*r**14)-6*Q2**2*(-25+1151*r**2
        +5374*r**4+19285*r**6-11218*r**8-10083*r**10-354*r**12-57*r**14+7*r**16)
        +Q2*(-439-32373*r**2+73362*r**4-224402*r**6+163512*r**8-3216*r**10
        +62878*r**12+5058*r**14-1233*r**16+53*r**18))*sqrtq2)*math.log(mu0))/(518400*logq2**3*r**14*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))+10800*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
        +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-300*(-Q2+(-1+r)**2)*r**2*(-Q2
        +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-129600*logq2**2*r**10*(Q2**5
        -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
        +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
        -3*r**8))*sqrtq2)+((345600*logq2**3*(-Q2+(-1+r)**2)*r**16*(-5+3*r**2)*(
        -Q2+(1+r)**2)-96*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(344
        +184*Q2**8+823*r**2+11917*r**4-8589*r**6-3175*r**8+50081*r**10-25973*r**12
        -3867*r**14+39*r**16-8*Q2**7*(129+149*r**2)+Q2**6*(1772+5475*r**2+2367*r**4)
        -2*Q2**5*(82+3119*r**2+3104*r**4+667*r**6)-Q2**4*(2520+3335*r**2+7961*r**4
        -535*r**6+895*r**8)+4*Q2**3*(524+2435*r**2+6626*r**4+1196*r**6-390*r**8
        +249*r**10)+Q2**2*(412-3923*r**2-7811*r**4-10226*r**6+15474*r**8+1297*r**10
        +97*r**12)-2*Q2*(546+675*r**2+9404*r**4-13055*r**6+10450*r**8-9071*r**10
        -2680*r**12+131*r**14))-5760*logq2**2*r**10*(40*Q2**7-4*Q2**6*(64+37*r**2)
        +3*Q2**5*(212+183*r**2+51*r**4)-Q2**4*(680+653*r**2+154*r**4+5*r**6)
        +2*Q2**3*(40+116*r**2+9*r**4-117*r**6+70*r**8)+Q2**2*(480-348*r**2
        +502*r**4+20*r**6+6*r**8-540*r**10)-(-1+r**2)**2*(-104+179*r**2-466*r**4
        -106*r**6-26*r**8+163*r**10)+Q2*(-404+755*r**2-1207*r**4-1052*r**6
        +208*r**8-263*r**10+523*r**12))*sqrtq2-8*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**2*(131+4*Q2**10+13412*r**2-51045*r**4+323008*r**6-641774*r**8
        +644712*r**10-142382*r**12-53600*r**14-6453*r**16+404*r**18-13*r**20
        +7*Q2**9*(1+r**2)+Q2**8*(141+306*r**2-123*r**4)+6*Q2**7*(-145-1834*r**2
        -312*r**4+57*r**6)-6*Q2**6*(-249-6423*r**2-7092*r**4-623*r**6+63*r**8)
        +6*Q2**5*(-80-4867*r**2-16621*r**4-6937*r**6-369*r**8+14*r**10)+2*Q2**4*(
        -576-23091*r**2+20622*r**4+10306*r**6-4110*r**8-891*r**10+84*r**12)
        +2*Q2**3*(507+36702*r**2+13926*r**4+78457*r**6-14165*r**8+8712*r**10
        +1152*r**12-51*r**14)-6*Q2**2*(-25+1151*r**2+5374*r**4+19285*r**6-11218*r**8
        -10083*r**10-354*r**12-57*r**14+7*r**16)+Q2*(-439-32373*r**2+73362*r**4
        -224402*r**6+163512*r**8-3216*r**10+62878*r**12+5058*r**14-1233*r**16
        +53*r**18))*sqrtq2)*math.log(r))/(518400*logq2**3*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))+10800*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(
        -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2-300*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**3*sqrtq2-129600*logq2**2*r**10*(Q2**5-3*Q2**4*(1
        +r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)
        +2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)
        +((3600*logq2**2*r**8*(15+22*r**2+15*r**4)+(Q2-(-1+r)**2)*(Q2-(1
        +r)**2)*(7+92*Q2**8-156*r**2+5096*r**4+19308*r**6+138690*r**8+19308*r**10
        +5096*r**12-156*r**14+7*r**16-156*Q2**7*(1+r**2)+Q2**6*(-89+190*r**2
        -89*r**4)+2*Q2**5*(79-247*r**2-247*r**4+79*r**6)+Q2**4*(165-1160*r**2
        -10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4-2439*r**6
        -280*r**8+19*r**10)+Q2**2*(-79+806*r**2+1787*r**4-14228*r**6+1787*r**8
        +806*r**10-79*r**12)+2*Q2*(27-635*r**2-2957*r**4+19165*r**6+19165*r**8
        -2957*r**10-635*r**12+27*r**14))+600*logq2*r**4*(1+2*Q2**5+35*r**2
        +276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17+42*r**2
        +17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2+66*r**4
        +30*r**6-11*r**8))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(-259200*logq2**3*r**12
        -5400*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+64800*logq2**2*r**8*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+150*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**3*sqrtq2)+((180*logq2*r**4*(1+r**2)+(-3-8*Q2**4
        +42*r**2+282*r**4+42*r**6-3*r**8+7*Q2**3*(1+r**2)+Q2**2*(7-2*r**2
        +7*r**4)-3*Q2*(1-11*r**2-11*r**4+r**6))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(720*logq2**2*r**8
        +5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
        -Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+nlo.X1Q2(2,'SM',Q2,r)/(-12*logq2*r**4
        +(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))

    if( flagDEBUG == 1):
        print("Q2moment n. 2 NLO = api*",resNLO*par.mbkin**4)
    res += api*resNLO

    if(kwargs.get('flag_includeNLOpw', 1) == 1):
        resNLO = 0
        resNLO +=(muG*((16588800*logq2**4*(-Q2+(-1+r)**2)*r**16*(-1+3*r**4)*(-Q2+(1+r)**2)
            +4608*logq2**2*(-Q2+(-1+r)**2)*r**8*(-Q2+(1+r)**2)*(-768*Q2**10*r**2
            +40*Q2**9*(-2+144*r**2+125*r**4)-5*Q2**8*(-97+3288*r**2+5821*r**4+2496*r**6)
            +20*Q2**7*(-50+1032*r**2+2952*r**4+2590*r**6+711*r**8)-20*Q2**6*(-22
            +274*r**2+1805*r**4+2571*r**6+1792*r**8+336*r**10)+4*Q2**5*(320-3486*r**2
            -9190*r**4-13940*r**6-3205*r**8+2620*r**10+579*r**12)-10*Q2**4*(187
            -1464*r**2-6594*r**4-12680*r**6-10875*r**8-420*r**10+1606*r**12+360*r**14)
            -20*Q2**3*(-22+148*r**2+1339*r**4+3012*r**6+2641*r**8-208*r**10+223*r**12
            -824*r**14+51*r**16)+20*Q2**2*(40-162*r**2-555*r**4+2009*r**6-3473*r**8
            -662*r**10-3243*r**12+4967*r**14-25*r**16+384*r**18)+(-1+r**2)**2*(145
            -198*r**2-4416*r**4+36566*r**6-21762*r**8+870*r**10-10912*r**12+38106*r**14
            +3249*r**16+1552*r**18)-20*Q2*(32-114*r**2-687*r**4+4204*r**6-5118*r**8
            +3864*r**10+5794*r**12-5328*r**14+5526*r**16+158*r**18+309*r**20))
            -64*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**14+Q2**13*(68+46*r**2)
            -Q2**12*(717+6352*r**2+643*r**4)+4*Q2**11*(396+11268*r**2+10829*r**4
            +624*r**6)-2*Q2**10*(58+56589*r**2+119149*r**4+56161*r**6+2343*r**8)
            +8*Q2**9*(-108+11073*r**2+47052*r**4+49657*r**6+13950*r**8+517*r**10)
            -2*Q2**8*(4593-51766*r**2-53644*r**4-172420*r**6+38069*r**8-18162*r**10
            +66*r**12)-4*Q2**7*(-5736+59893*r**2+194922*r**4+677168*r**6+543520*r**8
            +90437*r**10+41634*r**12+726*r**14)+Q2**6*(-13473+107480*r**2+561048*r**4
            +2817388*r**6+4727966*r**8+2103752*r**10+254520*r**12+102468*r**14+1683*r**16)
            +2*Q2**5*(-6974+47965*r**2-13292*r**4+433982*r**6-711268*r**8-1106496*r**10
            -194620*r**12-70622*r**14+11562*r**16+451*r**18)+Q2**4*(21607-110684*r**2
            +105489*r**4-2865356*r**6-2478042*r**8-1628916*r**10+362842*r**12+188764*r**14
            +348739*r**16-39200*r**18-1243*r**20)+4*Q2**3*(-1308+2193*r**2-31247*r**4
            +295690*r**6+368708*r**8+221166*r**10+196538*r**12-111708*r**14-70520*r**16
            -50223*r**18+1477*r**20+34*r**22)+2*(-1+r**2)**2*(-468+1288*r**2-34435*r**4
            +43936*r**6+292209*r**8-2571552*r**10+4429614*r**12-2779872*r**14+519474*r**16
            -130824*r**18-27595*r**20-992*r**22+17*r**24)+2*Q2**2*(-3201+19537*r**2
            -102987*r**4+272991*r**6-245380*r**8+997286*r**10+471654*r**12-1300294*r**14
            +658859*r**16-247575*r**18-87995*r**20-1081*r**22+186*r**24)-4*Q2*(
            -1166+5788*r**2-64394*r**4+175131*r**6+1990*r**8-1021853*r**10-167156*r**12
            +2846098*r**14-2779082*r**16+685710*r**18-147906*r**20-50157*r**22-1454*r**24
            +51*r**26))-276480*logq2**3*r**12*(40*Q2**7*r**2-4*Q2**6*(6+52*r**2+37*r**4)
            +Q2**5*(109+472*r**2+591*r**4+108*r**6)+Q2**4*(-165-497*r**2-869*r**4
            -379*r**6+130*r**8)+2*Q2**3*(25+129*r**2+187*r**4+46*r**6-72*r**8
            +25*r**10)-(-1+r**2)**2*(-31+157*r**2-310*r**4+330*r**6+245*r**8-119*r**10
            +208*r**12)-2*Q2**2*(-55+166*r**2-240*r**4+29*r**6+48*r**8-183*r**10
            +315*r**12)+Q2*(-111+486*r**2-1063*r**4+490*r**6+1375*r**8+846*r**10
            -761*r**12+658*r**14))*sqrtq2+384*logq2*r**4*(-184*Q2**15*r**2+4*Q2**14*(
            -10+548*r**2+525*r**4)-Q2**13*(-325+10248*r**2+21801*r**4+9956*r**6)
            +Q2**12*(-1045+24391*r**2+82775*r**4+83077*r**6+25198*r**8)-2*Q2**11*(
            -725+14763*r**2+67423*r**4+82320*r**6+74306*r**8+17349*r**10)+2*Q2**10*(55
            +5094*r**2+15142*r**4-144617*r**6-98052*r**8+47247*r**10+9139*r**12)
            +Q2**9*(-3245+16486*r**2+224355*r**4+1639870*r**6+2460865*r**8+1206750*r**10
            +91561*r**12+17310*r**14)-Q2**8*(-4125+17949*r**2+345323*r**4+2513833*r**6
            +5164385*r**8+4770875*r**10+1834589*r**12+206703*r**14+35028*r**16)
            +4*Q2**7*(-165+27*r**2+50905*r**4+311204*r**6+843301*r**8+1155440*r**10
            +991477*r**12+324160*r**14+37674*r**16+4641*r**18)+4*Q2**6*(-825+1288*r**2
            -10697*r**4+228075*r**6+486761*r**8+579599*r**10-24237*r**12-444637*r**14
            -162770*r**16-19629*r**18+1264*r**20)+Q2**5*(3355+4036*r**2+13237*r**4
            -1506472*r**6-4012402*r**8-5544248*r**10-4512182*r**12-1020288*r**14
            +1100503*r**16+556868*r**18+63937*r**20-10344*r**22)+(-1+r**2)**4*(35
            +325*r**2+5069*r**4+15147*r**6-173030*r**8+1062838*r**10-899034*r**12
            -567734*r**14+919363*r**16-96635*r**18+74637*r**20+4619*r**22)+Q2**4*(
            -715-7203*r**2+4345*r**4+689755*r**6+1965760*r**8+1718050*r**10+469586*r**12
            +670310*r**14+1363925*r**16-748815*r**18-123035*r**20-15153*r**22+3590*r**24)
            +Q2*(-1+r**2)**2*(-275-1576*r**2-27868*r**4-31570*r**6+729921*r**8
            -3719826*r**10+1431784*r**12+1268116*r**14+1677063*r**16-4186836*r**18
            +520436*r**20-396098*r**22-28213*r**24+142*r**26)+2*Q2**3*(-475+961*r**2
            -26363*r**4-19568*r**6+111180*r**8-505435*r**10+1147318*r**12+1187816*r**14
            +595001*r**16-2500085*r**18+354725*r**20-317144*r**22-28298*r**24+367*r**26)
            +2*Q2**2*(415+738*r**2+28890*r**4-32909*r**6-516826*r**8+2393295*r**10
            -1938201*r**12+1287730*r**14+1194783*r**16-3107068*r**18+3772540*r**20
            -728037*r**22+377180*r**24+32651*r**26-381*r**28))*sqrtq2)/(-18662400*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-777600*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-900*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+43200*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+6220800*logq2**3*r**14*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC*(-132710400*logq2**4*(-Q2+(-1+r)**2)*(-1+r)*r**16*(1
            +r)*(-Q2+(1+r)**2)-184320*logq2**2*(-Q2+(-1+r)**2)*r**8*(-Q2+(1
            +r)**2)*(76*Q2**10*r**2-4*Q2**9*(2+124*r**2+143*r**4)+Q2**8*(35+1275*r**2
            +2998*r**4+1644*r**6)-2*Q2**7*(30+796*r**2+2592*r**4+3280*r**6+975*r**8)
            +Q2**6*(32+1247*r**2+2652*r**4+3865*r**6+5296*r**8-204*r**10)+2*Q2**5*(28
            -624*r**2+490*r**4+4028*r**6+5431*r**8+806*r**10+1515*r**12)-2*Q2**4*(51
            -638*r**2+425*r**4+4230*r**6+11850*r**8+10226*r**10+2812*r**12+1404*r**14)
            +2*Q2**3*(10-230*r**2+85*r**4+422*r**6+5091*r**8+9788*r**10+2655*r**12
            +1916*r**14+63*r**16)+(-1+r**2)**3*(-19+36*r**2+357*r**4-4242*r**6
            +1867*r**8+2296*r**10+3631*r**12+230*r**14+164*r**16)+Q2**2*(80-333*r**2
            -468*r**4+1405*r**6-2956*r**8-367*r**10-10680*r**12+13639*r**14-1640*r**16
            +1320*r**18)+Q2*(-72+348*r**2+466*r**4-5660*r**6+9236*r**8+88*r**10
            -5408*r**12+13724*r**14-12740*r**16+844*r**18-826*r**20))-256*(Q2
            -(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(22*Q2**13*(-2+5*r**2)+Q2**12*(369
            -664*r**2-3609*r**4)+2*Q2**11*(-659+75*r**2+14651*r**4+11091*r**6)
            +Q2**10*(2553+3020*r**2-74204*r**4-148524*r**6-52221*r**8)+4*Q2**9*(
            -690+585*r**2+22976*r**4+42526*r**6+58792*r**8+7345*r**10)+2*Q2**8*(699
            -13635*r**2-50874*r**4+131650*r**6+344537*r**8+45153*r**10+45990*r**12)
            -4*Q2**7*(-3-11187*r**2-33242*r**4+151813*r**6+719959*r**8+704613*r**10
            +165846*r**12+44373*r**14)+Q2**6*(-54-24960*r**2-99116*r**4+355956*r**6
            +2424648*r**8+5652296*r**10+2640980*r**12+594564*r**14+63366*r**16)
            +2*Q2**5*(-258-1845*r**2+6282*r**4-67692*r**6-364510*r**8+234082*r**10
            -2134970*r**12+972212*r**14+74208*r**16+61371*r**18)+Q2**4*(485+7060*r**2
            +12131*r**4+158356*r**6+1657330*r**8-3431228*r**10-6769058*r**12+2534796*r**14
            -4922199*r**16-514168*r**18-138305*r**20)+2*(-1+r**2)**3*(6-267*r**2
            -2644*r**4-15169*r**6-17444*r**8+58374*r**10-1873120*r**12+2517634*r**14
            -643266*r**16+220709*r**18+11860*r**20+2527*r**22)+2*Q2**3*(-27-145*r**2
            -2071*r**4-36585*r**6-759298*r**8+1150898*r**10+1016630*r**12+2717106*r**14
            -458755*r**16+996223*r**18+117569*r**20+10455*r**22)+Q2**2*(-131+516*r**2
            +14576*r**4+3592*r**6-138611*r**8-968072*r**10+2592736*r**12-7374992*r**14
            +9030703*r**16-4809084*r**18+1573168*r**20+32648*r**22+42951*r**24)
            -4*Q2*(-18+410*r**2+3569*r**4+6312*r**6-88215*r**8+420006*r**10-717330*r**12
            +2801952*r**14-6141324*r**16+5019990*r**18-1719263*r**20+395320*r**22
            +11829*r**24+6762*r**26))-2211840*logq2**3*r**12*(30*Q2**7*r**2-2*Q2**6*(2
            +57*r**2+96*r**4)+Q2**5*(24+138*r**2+521*r**4+477*r**6)-2*Q2**4*(20
            +31*r**2+201*r**4+428*r**6+255*r**8)+Q2**3*(30-42*r**2+141*r**4+342*r**6
            +569*r**8+60*r**10)+(-1+r**2)**3*(14-53*r**2+127*r**4+7*r**6+67*r**8
            +78*r**10)+Q2**2*(-30+68*r**2-143*r**4+11*r**6-15*r**8-251*r**10+360*r**12)
            -Q2*(-34+113*r**2-468*r**4+95*r**6+280*r**8+9*r**10-298*r**12+303*r**14))*sqrtq2
            -3072*logq2*r**4*(46*Q2**15*r**2+Q2**14*(60-682*r**2-488*r**4)+Q2**13*(
            -470+3266*r**2+6473*r**4+2147*r**6)-2*Q2**12*(-745+4162*r**2+12351*r**4
            +11913*r**6+2404*r**8)+Q2**11*(-2230+15386*r**2+36653*r**4+29008*r**6
            +37261*r**8+4622*r**10)+Q2**10*(850-26164*r**2-4191*r**4+209849*r**6
            +209759*r**8+3799*r**10+2794*r**12)-Q2**9*(-2280-38509*r**2+59294*r**4
            +760345*r**6+1404530*r**8+842555*r**10+107556*r**12+12749*r**14)+Q2**8*(
            -3660-39417*r**2+94314*r**4+1090671*r**6+2527110*r**8+2928365*r**10
            +1209438*r**12+160149*r**14+12606*r**16)+2*Q2**7*(810+12039*r**2-42283*r**4
            -453294*r**6-789297*r**8-1069640*r**10-1207091*r**12-161418*r**14-29019*r**16
            +33*r**18)+r**2*(-1+r**2)**5*(-383-2909*r**2-34*r**4+7856*r**6-457194*r**8
            +274442*r**10+334604*r**12-22896*r**14+37289*r**16+1939*r**18+86*r**20)
            -2*Q2**6*(-480+4391*r**2-26767*r**4-365887*r**6+46701*r**8+987017*r**10
            +1016151*r**12+10853*r**14+620433*r**16+49986*r**18+5522*r**20)+Q2**5*(
            -1350+3760*r**2-23203*r**4-721943*r**6+567032*r**8+2792072*r**10+5441690*r**12
            +4346502*r**14+1177862*r**16+1637712*r**18+135217*r**20+9449*r**22)
            -2*Q2**4*(-205+301*r**2-7141*r**4-223810*r**6+308360*r**8+596620*r**10
            +976038*r**12+1828622*r**14+570815*r**16+394735*r**18+282415*r**20+24556*r**22
            +694*r**24)-Q2*(-1+r**2)**3*(20-2219*r**2-13829*r**4+31883*r**6-26217*r**8
            -1260802*r**10-356934*r**12+1127346*r**14+1843862*r**16-209363*r**18
            +234827*r**20+13123*r**22+703*r**24)-Q2**3*(-130+4174*r**2+20887*r**4
            +25068*r**6-375965*r**8+176010*r**10-973798*r**12+417376*r**14-2164456*r**16
            +3448010*r**18-1037905*r**20+434004*r**22+23847*r**24+2878*r**26)+Q2**2*(
            -110+4996*r**2+18193*r**4-129311*r**6+124827*r**8+1199295*r**10-1378752*r**12
            -394306*r**14+1129972*r**16-4675594*r**18+4995565*r**20-1436319*r**22
            +509663*r**24+29639*r**26+2242*r**28))*sqrtq2))/(-55987200*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-2332800*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-2700*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+129600*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+18662400*logq2**3*r**14*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC**2*(-16588800*logq2**4*(-Q2+(-1+r)**2)*(-1+r)*r**16*(1
            +r)*(-Q2+(1+r)**2)-23040*logq2**2*(-Q2+(-1+r)**2)*r**8*(-Q2+(1
            +r)**2)*(76*Q2**10*r**2-4*Q2**9*(2+124*r**2+143*r**4)+Q2**8*(35+1275*r**2
            +2998*r**4+1644*r**6)-2*Q2**7*(30+796*r**2+2592*r**4+3280*r**6+975*r**8)
            +Q2**6*(32+1247*r**2+2652*r**4+3865*r**6+5296*r**8-204*r**10)+2*Q2**5*(28
            -624*r**2+490*r**4+4028*r**6+5431*r**8+806*r**10+1515*r**12)-2*Q2**4*(51
            -638*r**2+425*r**4+4230*r**6+11850*r**8+10226*r**10+2812*r**12+1404*r**14)
            +2*Q2**3*(10-230*r**2+85*r**4+422*r**6+5091*r**8+9788*r**10+2655*r**12
            +1916*r**14+63*r**16)+(-1+r**2)**3*(-19+36*r**2+357*r**4-4242*r**6
            +1867*r**8+2296*r**10+3631*r**12+230*r**14+164*r**16)+Q2**2*(80-333*r**2
            -468*r**4+1405*r**6-2956*r**8-367*r**10-10680*r**12+13639*r**14-1640*r**16
            +1320*r**18)+Q2*(-72+348*r**2+466*r**4-5660*r**6+9236*r**8+88*r**10
            -5408*r**12+13724*r**14-12740*r**16+844*r**18-826*r**20))-32*(Q2-(
            -1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(22*Q2**13*(-2+5*r**2)+Q2**12*(369
            -664*r**2-3609*r**4)+2*Q2**11*(-659+75*r**2+14651*r**4+11091*r**6)
            +Q2**10*(2553+3020*r**2-74204*r**4-148524*r**6-52221*r**8)+4*Q2**9*(
            -690+585*r**2+22976*r**4+42526*r**6+58792*r**8+7345*r**10)+2*Q2**8*(699
            -13635*r**2-50874*r**4+131650*r**6+344537*r**8+45153*r**10+45990*r**12)
            -4*Q2**7*(-3-11187*r**2-33242*r**4+151813*r**6+719959*r**8+704613*r**10
            +165846*r**12+44373*r**14)+Q2**6*(-54-24960*r**2-99116*r**4+355956*r**6
            +2424648*r**8+5652296*r**10+2640980*r**12+594564*r**14+63366*r**16)
            +2*Q2**5*(-258-1845*r**2+6282*r**4-67692*r**6-364510*r**8+234082*r**10
            -2134970*r**12+972212*r**14+74208*r**16+61371*r**18)+Q2**4*(485+7060*r**2
            +12131*r**4+158356*r**6+1657330*r**8-3431228*r**10-6769058*r**12+2534796*r**14
            -4922199*r**16-514168*r**18-138305*r**20)+2*(-1+r**2)**3*(6-267*r**2
            -2644*r**4-15169*r**6-17444*r**8+58374*r**10-1873120*r**12+2517634*r**14
            -643266*r**16+220709*r**18+11860*r**20+2527*r**22)+2*Q2**3*(-27-145*r**2
            -2071*r**4-36585*r**6-759298*r**8+1150898*r**10+1016630*r**12+2717106*r**14
            -458755*r**16+996223*r**18+117569*r**20+10455*r**22)+Q2**2*(-131+516*r**2
            +14576*r**4+3592*r**6-138611*r**8-968072*r**10+2592736*r**12-7374992*r**14
            +9030703*r**16-4809084*r**18+1573168*r**20+32648*r**22+42951*r**24)
            -4*Q2*(-18+410*r**2+3569*r**4+6312*r**6-88215*r**8+420006*r**10-717330*r**12
            +2801952*r**14-6141324*r**16+5019990*r**18-1719263*r**20+395320*r**22
            +11829*r**24+6762*r**26))-276480*logq2**3*r**12*(30*Q2**7*r**2-2*Q2**6*(2
            +57*r**2+96*r**4)+Q2**5*(24+138*r**2+521*r**4+477*r**6)-2*Q2**4*(20
            +31*r**2+201*r**4+428*r**6+255*r**8)+Q2**3*(30-42*r**2+141*r**4+342*r**6
            +569*r**8+60*r**10)+(-1+r**2)**3*(14-53*r**2+127*r**4+7*r**6+67*r**8
            +78*r**10)+Q2**2*(-30+68*r**2-143*r**4+11*r**6-15*r**8-251*r**10+360*r**12)
            -Q2*(-34+113*r**2-468*r**4+95*r**6+280*r**8+9*r**10-298*r**12+303*r**14))*sqrtq2
            -384*logq2*r**4*(46*Q2**15*r**2+Q2**14*(60-682*r**2-488*r**4)+Q2**13*(
            -470+3266*r**2+6473*r**4+2147*r**6)-2*Q2**12*(-745+4162*r**2+12351*r**4
            +11913*r**6+2404*r**8)+Q2**11*(-2230+15386*r**2+36653*r**4+29008*r**6
            +37261*r**8+4622*r**10)+Q2**10*(850-26164*r**2-4191*r**4+209849*r**6
            +209759*r**8+3799*r**10+2794*r**12)-Q2**9*(-2280-38509*r**2+59294*r**4
            +760345*r**6+1404530*r**8+842555*r**10+107556*r**12+12749*r**14)+Q2**8*(
            -3660-39417*r**2+94314*r**4+1090671*r**6+2527110*r**8+2928365*r**10
            +1209438*r**12+160149*r**14+12606*r**16)+2*Q2**7*(810+12039*r**2-42283*r**4
            -453294*r**6-789297*r**8-1069640*r**10-1207091*r**12-161418*r**14-29019*r**16
            +33*r**18)+r**2*(-1+r**2)**5*(-383-2909*r**2-34*r**4+7856*r**6-457194*r**8
            +274442*r**10+334604*r**12-22896*r**14+37289*r**16+1939*r**18+86*r**20)
            -2*Q2**6*(-480+4391*r**2-26767*r**4-365887*r**6+46701*r**8+987017*r**10
            +1016151*r**12+10853*r**14+620433*r**16+49986*r**18+5522*r**20)+Q2**5*(
            -1350+3760*r**2-23203*r**4-721943*r**6+567032*r**8+2792072*r**10+5441690*r**12
            +4346502*r**14+1177862*r**16+1637712*r**18+135217*r**20+9449*r**22)
            -2*Q2**4*(-205+301*r**2-7141*r**4-223810*r**6+308360*r**8+596620*r**10
            +976038*r**12+1828622*r**14+570815*r**16+394735*r**18+282415*r**20+24556*r**22
            +694*r**24)-Q2*(-1+r**2)**3*(20-2219*r**2-13829*r**4+31883*r**6-26217*r**8
            -1260802*r**10-356934*r**12+1127346*r**14+1843862*r**16-209363*r**18
            +234827*r**20+13123*r**22+703*r**24)-Q2**3*(-130+4174*r**2+20887*r**4
            +25068*r**6-375965*r**8+176010*r**10-973798*r**12+417376*r**14-2164456*r**16
            +3448010*r**18-1037905*r**20+434004*r**22+23847*r**24+2878*r**26)+Q2**2*(
            -110+4996*r**2+18193*r**4-129311*r**6+124827*r**8+1199295*r**10-1378752*r**12
            -394306*r**14+1129972*r**16-4675594*r**18+4995565*r**20-1436319*r**22
            +509663*r**24+29639*r**26+2242*r**28))*sqrtq2))/(-18662400*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-777600*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-900*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+43200*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+6220800*logq2**3*r**14*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+((8294400*logq2**4*(-Q2+(-1+r)**2)*r**16*(-1+3*r**4)*(
            -Q2+(1+r)**2)+2304*logq2**2*(-Q2+(-1+r)**2)*r**8*(-Q2+(1+r)**2)*(
            -768*Q2**10*r**2+40*Q2**9*(-2+144*r**2+125*r**4)-5*Q2**8*(-97+3288*r**2
            +5821*r**4+2496*r**6)+20*Q2**7*(-50+1032*r**2+2952*r**4+2590*r**6+711*r**8)
            -20*Q2**6*(-22+274*r**2+1805*r**4+2571*r**6+1792*r**8+336*r**10)+4*Q2**5*(320
            -3486*r**2-9190*r**4-13940*r**6-3205*r**8+2620*r**10+579*r**12)-10*Q2**4*(187
            -1464*r**2-6594*r**4-12680*r**6-10875*r**8-420*r**10+1606*r**12+360*r**14)
            -20*Q2**3*(-22+148*r**2+1339*r**4+3012*r**6+2641*r**8-208*r**10+223*r**12
            -824*r**14+51*r**16)+20*Q2**2*(40-162*r**2-555*r**4+2009*r**6-3473*r**8
            -662*r**10-3243*r**12+4967*r**14-25*r**16+384*r**18)+(-1+r**2)**2*(145
            -198*r**2-4416*r**4+36566*r**6-21762*r**8+870*r**10-10912*r**12+38106*r**14
            +3249*r**16+1552*r**18)-20*Q2*(32-114*r**2-687*r**4+4204*r**6-5118*r**8
            +3864*r**10+5794*r**12-5328*r**14+5526*r**16+158*r**18+309*r**20))
            -32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**14+Q2**13*(68+46*r**2)
            -Q2**12*(717+6352*r**2+643*r**4)+4*Q2**11*(396+11268*r**2+10829*r**4
            +624*r**6)-2*Q2**10*(58+56589*r**2+119149*r**4+56161*r**6+2343*r**8)
            +8*Q2**9*(-108+11073*r**2+47052*r**4+49657*r**6+13950*r**8+517*r**10)
            -2*Q2**8*(4593-51766*r**2-53644*r**4-172420*r**6+38069*r**8-18162*r**10
            +66*r**12)-4*Q2**7*(-5736+59893*r**2+194922*r**4+677168*r**6+543520*r**8
            +90437*r**10+41634*r**12+726*r**14)+Q2**6*(-13473+107480*r**2+561048*r**4
            +2817388*r**6+4727966*r**8+2103752*r**10+254520*r**12+102468*r**14+1683*r**16)
            +2*Q2**5*(-6974+47965*r**2-13292*r**4+433982*r**6-711268*r**8-1106496*r**10
            -194620*r**12-70622*r**14+11562*r**16+451*r**18)+Q2**4*(21607-110684*r**2
            +105489*r**4-2865356*r**6-2478042*r**8-1628916*r**10+362842*r**12+188764*r**14
            +348739*r**16-39200*r**18-1243*r**20)+4*Q2**3*(-1308+2193*r**2-31247*r**4
            +295690*r**6+368708*r**8+221166*r**10+196538*r**12-111708*r**14-70520*r**16
            -50223*r**18+1477*r**20+34*r**22)+2*(-1+r**2)**2*(-468+1288*r**2-34435*r**4
            +43936*r**6+292209*r**8-2571552*r**10+4429614*r**12-2779872*r**14+519474*r**16
            -130824*r**18-27595*r**20-992*r**22+17*r**24)+2*Q2**2*(-3201+19537*r**2
            -102987*r**4+272991*r**6-245380*r**8+997286*r**10+471654*r**12-1300294*r**14
            +658859*r**16-247575*r**18-87995*r**20-1081*r**22+186*r**24)-4*Q2*(
            -1166+5788*r**2-64394*r**4+175131*r**6+1990*r**8-1021853*r**10-167156*r**12
            +2846098*r**14-2779082*r**16+685710*r**18-147906*r**20-50157*r**22-1454*r**24
            +51*r**26))-138240*logq2**3*r**12*(40*Q2**7*r**2-4*Q2**6*(6+52*r**2+37*r**4)
            +Q2**5*(109+472*r**2+591*r**4+108*r**6)+Q2**4*(-165-497*r**2-869*r**4
            -379*r**6+130*r**8)+2*Q2**3*(25+129*r**2+187*r**4+46*r**6-72*r**8
            +25*r**10)-(-1+r**2)**2*(-31+157*r**2-310*r**4+330*r**6+245*r**8-119*r**10
            +208*r**12)-2*Q2**2*(-55+166*r**2-240*r**4+29*r**6+48*r**8-183*r**10
            +315*r**12)+Q2*(-111+486*r**2-1063*r**4+490*r**6+1375*r**8+846*r**10
            -761*r**12+658*r**14))*sqrtq2+192*logq2*r**4*(-184*Q2**15*r**2+4*Q2**14*(
            -10+548*r**2+525*r**4)-Q2**13*(-325+10248*r**2+21801*r**4+9956*r**6)
            +Q2**12*(-1045+24391*r**2+82775*r**4+83077*r**6+25198*r**8)-2*Q2**11*(
            -725+14763*r**2+67423*r**4+82320*r**6+74306*r**8+17349*r**10)+2*Q2**10*(55
            +5094*r**2+15142*r**4-144617*r**6-98052*r**8+47247*r**10+9139*r**12)
            +Q2**9*(-3245+16486*r**2+224355*r**4+1639870*r**6+2460865*r**8+1206750*r**10
            +91561*r**12+17310*r**14)-Q2**8*(-4125+17949*r**2+345323*r**4+2513833*r**6
            +5164385*r**8+4770875*r**10+1834589*r**12+206703*r**14+35028*r**16)
            +4*Q2**7*(-165+27*r**2+50905*r**4+311204*r**6+843301*r**8+1155440*r**10
            +991477*r**12+324160*r**14+37674*r**16+4641*r**18)+4*Q2**6*(-825+1288*r**2
            -10697*r**4+228075*r**6+486761*r**8+579599*r**10-24237*r**12-444637*r**14
            -162770*r**16-19629*r**18+1264*r**20)+Q2**5*(3355+4036*r**2+13237*r**4
            -1506472*r**6-4012402*r**8-5544248*r**10-4512182*r**12-1020288*r**14
            +1100503*r**16+556868*r**18+63937*r**20-10344*r**22)+(-1+r**2)**4*(35
            +325*r**2+5069*r**4+15147*r**6-173030*r**8+1062838*r**10-899034*r**12
            -567734*r**14+919363*r**16-96635*r**18+74637*r**20+4619*r**22)+Q2**4*(
            -715-7203*r**2+4345*r**4+689755*r**6+1965760*r**8+1718050*r**10+469586*r**12
            +670310*r**14+1363925*r**16-748815*r**18-123035*r**20-15153*r**22+3590*r**24)
            +Q2*(-1+r**2)**2*(-275-1576*r**2-27868*r**4-31570*r**6+729921*r**8
            -3719826*r**10+1431784*r**12+1268116*r**14+1677063*r**16-4186836*r**18
            +520436*r**20-396098*r**22-28213*r**24+142*r**26)+2*Q2**3*(-475+961*r**2
            -26363*r**4-19568*r**6+111180*r**8-505435*r**10+1147318*r**12+1187816*r**14
            +595001*r**16-2500085*r**18+354725*r**20-317144*r**22-28298*r**24+367*r**26)
            +2*Q2**2*(415+738*r**2+28890*r**4-32909*r**6-516826*r**8+2393295*r**10
            -1938201*r**12+1287730*r**14+1194783*r**16-3107068*r**18+3772540*r**20
            -728037*r**22+377180*r**24+32651*r**26-381*r**28))*sqrtq2)*math.log(mu0))/(
            -6220800*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-259200*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -300*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4
            +14400*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*sqrtq2+2073600*logq2**3*r**14*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+FLAGcf*((561600*logq2**3*r**10*(1
            -2*r**2+3*r**4)+156*logq2*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-35
            +172*r**2+92*Q2**8*r**2-6*r**4-11844*r**6+34868*r**8-5600*r**10-2882*r**12
            +6396*r**14+359*r**16+172*r**18+Q2**7*(40-636*r**2-516*r**4)+Q2**6*(
            -125+1136*r**2+3085*r**4+886*r**6)-2*Q2**5*(-30+111*r**2+1967*r**4
            +2027*r**6+41*r**8)-Q2**4*(-175+1100*r**2+1500*r**4+2828*r**6+655*r**8
            +1260*r**10)+4*Q2**3*(-50+177*r**2+1320*r**4+3908*r**6+3628*r**8+1155*r**10
            +262*r**12)+Q2**2*(-15+436*r**2-2059*r**4-7258*r**6-27873*r**8-6128*r**10
            -2309*r**12+206*r**14)-2*Q2*(-50+293*r**2+175*r**4+367*r**6+1845*r**8
            -11305*r**10+4597*r**12+205*r**14+273*r**16))+18720*logq2**2*r**6*(1
            -11*r**2+10*Q2**5*r**2+50*r**4+30*r**6+125*r**8-41*r**10+26*r**12-4*Q2**4*(1
            +8*r**2+11*r**4)+Q2**3*(6+49*r**2+89*r**4+61*r**6)-Q2**2*(-1+23*r**2
            +56*r**4+108*r**6+4*r**8)+Q2*(-4+12*r**2-33*r**4+27*r**6+77*r**8
            -49*r**10))*sqrtq2+26*(7*Q2**11*r**2+Q2**10*(-22+75*r**2+9*r**4)-5*Q2**9*(
            -29+105*r**2+611*r**4+47*r**6)+10*Q2**8*(-38+73*r**2+1794*r**4+1598*r**6
            +75*r**8)-10*Q2**7*(-46-61*r**2+3534*r**4+6970*r**6+3088*r**8+93*r**10)
            +2*Q2**6*(-70-627*r**2+10815*r**4+39300*r**6+45950*r**8+7285*r**10
            +63*r**12)+2*Q2**5*(-133-1075*r**2+9081*r**4+3405*r**6+17415*r**8-15723*r**10
            +16105*r**12+441*r**14)-20*Q2**4*(-14-260*r**2+1743*r**4+2335*r**6
            +10488*r**8+9576*r**10+779*r**12+2411*r**14+42*r**16)+5*Q2**3*(-4-501*r**2
            +2604*r**4+2628*r**6+26348*r**8+51702*r**10+21428*r**12+4076*r**14
            +2584*r**16+15*r**18)+2*(-1+r**2)**2*(-6-237*r**2+1964*r**4-9815*r**6
            -8509*r**8+86159*r**10-86693*r**12+43631*r**14-6565*r**16+1654*r**18
            +17*r**20)+5*Q2**2*(-22-297*r**2+2685*r**4-5232*r**6-1364*r**8+25698*r**10
            -53706*r**12+30112*r**14-10086*r**16+3511*r**18+61*r**20)+Q2*(65+1747*r**2
            -15795*r**4+56225*r**6+3030*r**8-102270*r**10-325714*r**12+429270*r**14
            -261975*r**16+57195*r**18-14395*r**20-183*r**22))*sqrtq2)/(-777600*logq2**3*r**12
            -16200*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+194400*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+450*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((43200*logq2**3*r**10*(1-2*r**2+3*r**4)
            +12*logq2*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-35+172*r**2+92*Q2**8*r**2
            -6*r**4-11844*r**6+34868*r**8-5600*r**10-2882*r**12+6396*r**14+359*r**16
            +172*r**18+Q2**7*(40-636*r**2-516*r**4)+Q2**6*(-125+1136*r**2+3085*r**4
            +886*r**6)-2*Q2**5*(-30+111*r**2+1967*r**4+2027*r**6+41*r**8)-Q2**4*(
            -175+1100*r**2+1500*r**4+2828*r**6+655*r**8+1260*r**10)+4*Q2**3*(-50
            +177*r**2+1320*r**4+3908*r**6+3628*r**8+1155*r**10+262*r**12)+Q2**2*(
            -15+436*r**2-2059*r**4-7258*r**6-27873*r**8-6128*r**10-2309*r**12
            +206*r**14)-2*Q2*(-50+293*r**2+175*r**4+367*r**6+1845*r**8-11305*r**10
            +4597*r**12+205*r**14+273*r**16))+1440*logq2**2*r**6*(1-11*r**2+10*Q2**5*r**2
            +50*r**4+30*r**6+125*r**8-41*r**10+26*r**12-4*Q2**4*(1+8*r**2+11*r**4)
            +Q2**3*(6+49*r**2+89*r**4+61*r**6)-Q2**2*(-1+23*r**2+56*r**4+108*r**6
            +4*r**8)+Q2*(-4+12*r**2-33*r**4+27*r**6+77*r**8-49*r**10))*sqrtq2
            +2*(7*Q2**11*r**2+Q2**10*(-22+75*r**2+9*r**4)-5*Q2**9*(-29+105*r**2
            +611*r**4+47*r**6)+10*Q2**8*(-38+73*r**2+1794*r**4+1598*r**6+75*r**8)
            -10*Q2**7*(-46-61*r**2+3534*r**4+6970*r**6+3088*r**8+93*r**10)+2*Q2**6*(
            -70-627*r**2+10815*r**4+39300*r**6+45950*r**8+7285*r**10+63*r**12)
            +2*Q2**5*(-133-1075*r**2+9081*r**4+3405*r**6+17415*r**8-15723*r**10
            +16105*r**12+441*r**14)-20*Q2**4*(-14-260*r**2+1743*r**4+2335*r**6
            +10488*r**8+9576*r**10+779*r**12+2411*r**14+42*r**16)+5*Q2**3*(-4-501*r**2
            +2604*r**4+2628*r**6+26348*r**8+51702*r**10+21428*r**12+4076*r**14
            +2584*r**16+15*r**18)+2*(-1+r**2)**2*(-6-237*r**2+1964*r**4-9815*r**6
            -8509*r**8+86159*r**10-86693*r**12+43631*r**14-6565*r**16+1654*r**18
            +17*r**20)+5*Q2**2*(-22-297*r**2+2685*r**4-5232*r**6-1364*r**8+25698*r**10
            -53706*r**12+30112*r**14-10086*r**16+3511*r**18+61*r**20)+Q2*(65+1747*r**2
            -15795*r**4+56225*r**6+3030*r**8-102270*r**10-325714*r**12+429270*r**14
            -261975*r**16+57195*r**18-14395*r**20-183*r**22))*sqrtq2)*math.log(mumuG))/(
            -86400*logq2**3*r**12-1800*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+21600*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+50*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2))+((-8294400*logq2**4*(-Q2+(-1+r)**2)*r**16*(
            -1+3*r**4)*(-Q2+(1+r)**2)-2304*logq2**2*(-Q2+(-1+r)**2)*r**8*(-Q2
            +(1+r)**2)*(-768*Q2**10*r**2+40*Q2**9*(-2+144*r**2+125*r**4)-5*Q2**8*(
            -97+3288*r**2+5821*r**4+2496*r**6)+20*Q2**7*(-50+1032*r**2+2952*r**4
            +2590*r**6+711*r**8)-20*Q2**6*(-22+274*r**2+1805*r**4+2571*r**6+1792*r**8
            +336*r**10)+4*Q2**5*(320-3486*r**2-9190*r**4-13940*r**6-3205*r**8+2620*r**10
            +579*r**12)-10*Q2**4*(187-1464*r**2-6594*r**4-12680*r**6-10875*r**8
            -420*r**10+1606*r**12+360*r**14)-20*Q2**3*(-22+148*r**2+1339*r**4+3012*r**6
            +2641*r**8-208*r**10+223*r**12-824*r**14+51*r**16)+20*Q2**2*(40-162*r**2
            -555*r**4+2009*r**6-3473*r**8-662*r**10-3243*r**12+4967*r**14-25*r**16
            +384*r**18)+(-1+r**2)**2*(145-198*r**2-4416*r**4+36566*r**6-21762*r**8
            +870*r**10-10912*r**12+38106*r**14+3249*r**16+1552*r**18)-20*Q2*(32
            -114*r**2-687*r**4+4204*r**6-5118*r**8+3864*r**10+5794*r**12-5328*r**14
            +5526*r**16+158*r**18+309*r**20))+32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(7*Q2**14+Q2**13*(68+46*r**2)-Q2**12*(717+6352*r**2+643*r**4)
            +4*Q2**11*(396+11268*r**2+10829*r**4+624*r**6)-2*Q2**10*(58+56589*r**2
            +119149*r**4+56161*r**6+2343*r**8)+8*Q2**9*(-108+11073*r**2+47052*r**4
            +49657*r**6+13950*r**8+517*r**10)-2*Q2**8*(4593-51766*r**2-53644*r**4
            -172420*r**6+38069*r**8-18162*r**10+66*r**12)-4*Q2**7*(-5736+59893*r**2
            +194922*r**4+677168*r**6+543520*r**8+90437*r**10+41634*r**12+726*r**14)
            +Q2**6*(-13473+107480*r**2+561048*r**4+2817388*r**6+4727966*r**8+2103752*r**10
            +254520*r**12+102468*r**14+1683*r**16)+2*Q2**5*(-6974+47965*r**2-13292*r**4
            +433982*r**6-711268*r**8-1106496*r**10-194620*r**12-70622*r**14+11562*r**16
            +451*r**18)+Q2**4*(21607-110684*r**2+105489*r**4-2865356*r**6-2478042*r**8
            -1628916*r**10+362842*r**12+188764*r**14+348739*r**16-39200*r**18-1243*r**20)
            +4*Q2**3*(-1308+2193*r**2-31247*r**4+295690*r**6+368708*r**8+221166*r**10
            +196538*r**12-111708*r**14-70520*r**16-50223*r**18+1477*r**20+34*r**22)
            +2*(-1+r**2)**2*(-468+1288*r**2-34435*r**4+43936*r**6+292209*r**8-2571552*r**10
            +4429614*r**12-2779872*r**14+519474*r**16-130824*r**18-27595*r**20-992*r**22
            +17*r**24)+2*Q2**2*(-3201+19537*r**2-102987*r**4+272991*r**6-245380*r**8
            +997286*r**10+471654*r**12-1300294*r**14+658859*r**16-247575*r**18-87995*r**20
            -1081*r**22+186*r**24)-4*Q2*(-1166+5788*r**2-64394*r**4+175131*r**6
            +1990*r**8-1021853*r**10-167156*r**12+2846098*r**14-2779082*r**16+685710*r**18
            -147906*r**20-50157*r**22-1454*r**24+51*r**26))+138240*logq2**3*r**12*(40*Q2**7*r**2
            -4*Q2**6*(6+52*r**2+37*r**4)+Q2**5*(109+472*r**2+591*r**4+108*r**6)
            +Q2**4*(-165-497*r**2-869*r**4-379*r**6+130*r**8)+2*Q2**3*(25+129*r**2
            +187*r**4+46*r**6-72*r**8+25*r**10)-(-1+r**2)**2*(-31+157*r**2-310*r**4
            +330*r**6+245*r**8-119*r**10+208*r**12)-2*Q2**2*(-55+166*r**2-240*r**4
            +29*r**6+48*r**8-183*r**10+315*r**12)+Q2*(-111+486*r**2-1063*r**4
            +490*r**6+1375*r**8+846*r**10-761*r**12+658*r**14))*sqrtq2-192*logq2*r**4*(
            -184*Q2**15*r**2+4*Q2**14*(-10+548*r**2+525*r**4)-Q2**13*(-325+10248*r**2
            +21801*r**4+9956*r**6)+Q2**12*(-1045+24391*r**2+82775*r**4+83077*r**6
            +25198*r**8)-2*Q2**11*(-725+14763*r**2+67423*r**4+82320*r**6+74306*r**8
            +17349*r**10)+2*Q2**10*(55+5094*r**2+15142*r**4-144617*r**6-98052*r**8
            +47247*r**10+9139*r**12)+Q2**9*(-3245+16486*r**2+224355*r**4+1639870*r**6
            +2460865*r**8+1206750*r**10+91561*r**12+17310*r**14)-Q2**8*(-4125+17949*r**2
            +345323*r**4+2513833*r**6+5164385*r**8+4770875*r**10+1834589*r**12+206703*r**14
            +35028*r**16)+4*Q2**7*(-165+27*r**2+50905*r**4+311204*r**6+843301*r**8
            +1155440*r**10+991477*r**12+324160*r**14+37674*r**16+4641*r**18)+4*Q2**6*(
            -825+1288*r**2-10697*r**4+228075*r**6+486761*r**8+579599*r**10-24237*r**12
            -444637*r**14-162770*r**16-19629*r**18+1264*r**20)+Q2**5*(3355+4036*r**2
            +13237*r**4-1506472*r**6-4012402*r**8-5544248*r**10-4512182*r**12-1020288*r**14
            +1100503*r**16+556868*r**18+63937*r**20-10344*r**22)+(-1+r**2)**4*(35
            +325*r**2+5069*r**4+15147*r**6-173030*r**8+1062838*r**10-899034*r**12
            -567734*r**14+919363*r**16-96635*r**18+74637*r**20+4619*r**22)+Q2**4*(
            -715-7203*r**2+4345*r**4+689755*r**6+1965760*r**8+1718050*r**10+469586*r**12
            +670310*r**14+1363925*r**16-748815*r**18-123035*r**20-15153*r**22+3590*r**24)
            +Q2*(-1+r**2)**2*(-275-1576*r**2-27868*r**4-31570*r**6+729921*r**8
            -3719826*r**10+1431784*r**12+1268116*r**14+1677063*r**16-4186836*r**18
            +520436*r**20-396098*r**22-28213*r**24+142*r**26)+2*Q2**3*(-475+961*r**2
            -26363*r**4-19568*r**6+111180*r**8-505435*r**10+1147318*r**12+1187816*r**14
            +595001*r**16-2500085*r**18+354725*r**20-317144*r**22-28298*r**24+367*r**26)
            +2*Q2**2*(415+738*r**2+28890*r**4-32909*r**6-516826*r**8+2393295*r**10
            -1938201*r**12+1287730*r**14+1194783*r**16-3107068*r**18+3772540*r**20
            -728037*r**22+377180*r**24+32651*r**26-381*r**28))*sqrtq2)*math.log(r))/(-6220800*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-259200*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-300*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+14400*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+2073600*logq2**3*r**14*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+((43200*logq2**3*r**10*(-16+47*r**2+46*r**4+15*r**6)
            -12*logq2*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-80-1341*r**2+1544*Q2**8*r**2
            -7172*r**4-59768*r**6+117716*r**8-820230*r**10-397644*r**12+156712*r**14
            +17708*r**16+499*r**18-8*Q2**7*(-40+1269*r**2+1149*r**4)+Q2**6*(-800
            +14927*r**2+40590*r**4+13327*r**6)+Q2**5*(80+3186*r**2-44058*r**4-48218*r**6
            +4706*r**8)+Q2**4*(1200-13955*r**2-3760*r**4+41094*r**6+15520*r**8
            -21795*r**10)+4*Q2**3*(-200-531*r**2+10635*r**4+55156*r**6+42996*r**8
            +9655*r**10+2209*r**12)+Q2**2*(-320+7497*r**2-27738*r**4-275421*r**6
            -527636*r**8-220461*r**10-55258*r**12+7097*r**14)-2*Q2*(-200-209*r**2
            +8405*r**4+67339*r**6+29745*r**8-40055*r**10+98659*r**12-595*r**14
            +2511*r**16))-720*logq2**2*r**6*(-64+133*r**2+60*Q2**5*r**2+1223*r**4
            -10172*r**6-7372*r**8-1313*r**10+1005*r**12-32*Q2**4*(2+9*r**2+15*r**4)
            +Q2**3*(16+1453*r**2+2522*r**4+1485*r**6)-Q2**2*(-96+1069*r**2+3351*r**4
            +3783*r**6+765*r**8)-Q2*(-16+409*r**2+1378*r**4+146*r**6-462*r**8
            +1305*r**10))*sqrtq2+(-100*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(5*Q2**5-4*Q2**3*(
            -1+r**2)**2+Q2**2*(-3+r**2)*(-1+r**2)**2-4*Q2**4*(1+r**2)+Q2*(-1+r**2)**2*(
            -3-8*r**2+r**4)+(-1+r**2)**2*(-3-47*r**2-11*r**4+r**6))+(Q2-(
            -1+r)**2)*(Q2-(1+r)**2)*(-327+40*Q2**11+5381*r**2+51893*r**4-66375*r**6
            +459862*r**8-1267442*r**10+6907134*r**12-1962938*r**14-121295*r**16
            -29907*r**18-1651*r**20+65*r**22-160*Q2**10*(1+r**2)+Q2**9*(25-158*r**2
            +25*r**4)+Q2**8*(1913-6501*r**2-3237*r**4+825*r**6)-2*Q2**7*(2502-11611*r**2
            -64954*r**4-8107*r**6+750*r**8)+2*Q2**6*(1502-7291*r**2-167219*r**4
            -158107*r**6-8175*r**8+210*r**10)+2*Q2**5*(1711-11743*r**2+61595*r**4
            +379858*r**6+56331*r**8-7647*r**10+735*r**12)+Q2**4*(-3690+20928*r**2
            +204288*r**4-432758*r**6-916254*r**8+338360*r**10+34328*r**12-1650*r**14)
            +2*Q2**3*(-514+8473*r**2-16750*r**4-239765*r**6-565632*r**8+77979*r**10
            -155902*r**12-5559*r**14+150*r**16)+2*Q2**2*(782-7781*r**2-54965*r**4
            +345293*r**6+1595771*r**8+1042739*r**10+455677*r**12-12549*r**14-5697*r**16
            +250*r**18)+Q2*(241-6028*r**2-28199*r**4+357456*r**6+1406870*r**8
            -1995336*r**10+2615318*r**12-480176*r**14+108569*r**16+8820*r**18-335*r**20)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(6220800*logq2**4*r**16
            +259200*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+300*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-2073600*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-14400*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((720*logq2**2*r**6*(-4+21*r**2+9*r**4)+(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(21
            +120*Q2**7+431*r**2+2289*r**4-3941*r**6+26419*r**8-5607*r**10-937*r**12
            +45*r**14-225*Q2**6*(1+r**2)-8*Q2**5*(15-58*r**2+15*r**4)-4*Q2**3*(
            -84+275*r**2+1754*r**4+107*r**6)+3*Q2**4*(37-17*r**2-281*r**4+125*r**6)
            +Q2**2*(-99+1093*r**2+10210*r**4+8818*r**6+1717*r**8-195*r**10)+4*Q2*(
            -36+327*r**2+1534*r**4-2282*r**6+1954*r**8+63*r**10))-24*logq2*r**2*(
            -10-11*r**2-36*Q2**4*r**2+14*r**4-1326*r**6-416*r**8+189*r**10+2*Q2**3*(
            -5+132*r**2+117*r**4)-Q2**2*(-10+191*r**2+524*r**4+171*r**6)-2*Q2*(
            -5+93*r**2+2*r**4-68*r**6+108*r**8))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(
            -51840*logq2**3*r**12-1080*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+12960*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+30*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((12*logq2*r**4+(3-5*Q2**3-5*r**2
            +19*r**4-5*r**6+5*Q2**2*(1+r**2)+Q2*(5-8*r**2+5*r**4))*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(288*logq2**2*r**8
            +2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-48*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((3600*logq2**2*r**8*(15
            +22*r**2+15*r**4)+(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(7+92*Q2**8-156*r**2
            +5096*r**4+19308*r**6+138690*r**8+19308*r**10+5096*r**12-156*r**14
            +7*r**16-156*Q2**7*(1+r**2)+Q2**6*(-89+190*r**2-89*r**4)+2*Q2**5*(79
            -247*r**2-247*r**4+79*r**6)+Q2**4*(165-1160*r**2-10298*r**4-1160*r**6
            +165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4-2439*r**6-280*r**8+19*r**10)
            +Q2**2*(-79+806*r**2+1787*r**4-14228*r**6+1787*r**8+806*r**10-79*r**12)
            +2*Q2*(27-635*r**2-2957*r**4+19165*r**6+19165*r**8-2957*r**10-635*r**12
            +27*r**14))+600*logq2*r**4*(1+2*Q2**5+35*r**2+276*r**4+276*r**6+35*r**8
            +r**10-16*Q2**4*(1+r**2)+Q2**3*(17+42*r**2+17*r**4)+Q2**2*(7-19*r**2
            -19*r**4+7*r**6)+Q2*(-11+30*r**2+66*r**4+30*r**6-11*r**8))*sqrtq2)*nlopw.X1Q2MuG(0,Q2,r))/(
            -259200*logq2**3*r**12-5400*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+64800*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+150*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((180*logq2*r**4*(1+r**2)+(-3-8*Q2**4
            +42*r**2+282*r**4+42*r**6-3*r**8+7*Q2**3*(1+r**2)+Q2**2*(7-2*r**2
            +7*r**4)-3*Q2*(1-11*r**2-11*r**4+r**6))*sqrtq2)*nlopw.X1Q2MuG(1,Q2,r))/(720*logq2**2*r**8
            +5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+nlopw.X1Q2MuG(2,Q2,r)/(-12*logq2*r**4
            +(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))
            +rhoLS*((flagPERP*(-16588800*logq2**4*(-Q2+(-1+r)**2)*r**16*(-1+3*r**4)*(
            -Q2+(1+r)**2)-4608*logq2**2*(-Q2+(-1+r)**2)*r**8*(-Q2+(1+r)**2)*(
            -768*Q2**10*r**2+40*Q2**9*(-2+144*r**2+125*r**4)-5*Q2**8*(-97+3288*r**2
            +5821*r**4+2496*r**6)+20*Q2**7*(-50+1032*r**2+2952*r**4+2590*r**6+711*r**8)
            -20*Q2**6*(-22+274*r**2+1805*r**4+2571*r**6+1792*r**8+336*r**10)+4*Q2**5*(320
            -3486*r**2-9190*r**4-13940*r**6-3205*r**8+2620*r**10+579*r**12)-10*Q2**4*(187
            -1464*r**2-6594*r**4-12680*r**6-10875*r**8-420*r**10+1606*r**12+360*r**14)
            -20*Q2**3*(-22+148*r**2+1339*r**4+3012*r**6+2641*r**8-208*r**10+223*r**12
            -824*r**14+51*r**16)+20*Q2**2*(40-162*r**2-555*r**4+2009*r**6-3473*r**8
            -662*r**10-3243*r**12+4967*r**14-25*r**16+384*r**18)+(-1+r**2)**2*(145
            -198*r**2-4416*r**4+36566*r**6-21762*r**8+870*r**10-10912*r**12+38106*r**14
            +3249*r**16+1552*r**18)-20*Q2*(32-114*r**2-687*r**4+4204*r**6-5118*r**8
            +3864*r**10+5794*r**12-5328*r**14+5526*r**16+158*r**18+309*r**20))
            +64*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**14+Q2**13*(68+46*r**2)
            -Q2**12*(717+6352*r**2+643*r**4)+4*Q2**11*(396+11268*r**2+10829*r**4
            +624*r**6)-2*Q2**10*(58+56589*r**2+119149*r**4+56161*r**6+2343*r**8)
            +8*Q2**9*(-108+11073*r**2+47052*r**4+49657*r**6+13950*r**8+517*r**10)
            -2*Q2**8*(4593-51766*r**2-53644*r**4-172420*r**6+38069*r**8-18162*r**10
            +66*r**12)-4*Q2**7*(-5736+59893*r**2+194922*r**4+677168*r**6+543520*r**8
            +90437*r**10+41634*r**12+726*r**14)+Q2**6*(-13473+107480*r**2+561048*r**4
            +2817388*r**6+4727966*r**8+2103752*r**10+254520*r**12+102468*r**14+1683*r**16)
            +2*Q2**5*(-6974+47965*r**2-13292*r**4+433982*r**6-711268*r**8-1106496*r**10
            -194620*r**12-70622*r**14+11562*r**16+451*r**18)+Q2**4*(21607-110684*r**2
            +105489*r**4-2865356*r**6-2478042*r**8-1628916*r**10+362842*r**12+188764*r**14
            +348739*r**16-39200*r**18-1243*r**20)+4*Q2**3*(-1308+2193*r**2-31247*r**4
            +295690*r**6+368708*r**8+221166*r**10+196538*r**12-111708*r**14-70520*r**16
            -50223*r**18+1477*r**20+34*r**22)+2*(-1+r**2)**2*(-468+1288*r**2-34435*r**4
            +43936*r**6+292209*r**8-2571552*r**10+4429614*r**12-2779872*r**14+519474*r**16
            -130824*r**18-27595*r**20-992*r**22+17*r**24)+2*Q2**2*(-3201+19537*r**2
            -102987*r**4+272991*r**6-245380*r**8+997286*r**10+471654*r**12-1300294*r**14
            +658859*r**16-247575*r**18-87995*r**20-1081*r**22+186*r**24)-4*Q2*(
            -1166+5788*r**2-64394*r**4+175131*r**6+1990*r**8-1021853*r**10-167156*r**12
            +2846098*r**14-2779082*r**16+685710*r**18-147906*r**20-50157*r**22-1454*r**24
            +51*r**26))+276480*logq2**3*r**12*(40*Q2**7*r**2-4*Q2**6*(6+52*r**2+37*r**4)
            +Q2**5*(109+472*r**2+591*r**4+108*r**6)+Q2**4*(-165-497*r**2-869*r**4
            -379*r**6+130*r**8)+2*Q2**3*(25+129*r**2+187*r**4+46*r**6-72*r**8
            +25*r**10)-(-1+r**2)**2*(-31+157*r**2-310*r**4+330*r**6+245*r**8-119*r**10
            +208*r**12)-2*Q2**2*(-55+166*r**2-240*r**4+29*r**6+48*r**8-183*r**10
            +315*r**12)+Q2*(-111+486*r**2-1063*r**4+490*r**6+1375*r**8+846*r**10
            -761*r**12+658*r**14))*sqrtq2-384*logq2*r**4*(-184*Q2**15*r**2+4*Q2**14*(
            -10+548*r**2+525*r**4)-Q2**13*(-325+10248*r**2+21801*r**4+9956*r**6)
            +Q2**12*(-1045+24391*r**2+82775*r**4+83077*r**6+25198*r**8)-2*Q2**11*(
            -725+14763*r**2+67423*r**4+82320*r**6+74306*r**8+17349*r**10)+2*Q2**10*(55
            +5094*r**2+15142*r**4-144617*r**6-98052*r**8+47247*r**10+9139*r**12)
            +Q2**9*(-3245+16486*r**2+224355*r**4+1639870*r**6+2460865*r**8+1206750*r**10
            +91561*r**12+17310*r**14)-Q2**8*(-4125+17949*r**2+345323*r**4+2513833*r**6
            +5164385*r**8+4770875*r**10+1834589*r**12+206703*r**14+35028*r**16)
            +4*Q2**7*(-165+27*r**2+50905*r**4+311204*r**6+843301*r**8+1155440*r**10
            +991477*r**12+324160*r**14+37674*r**16+4641*r**18)+4*Q2**6*(-825+1288*r**2
            -10697*r**4+228075*r**6+486761*r**8+579599*r**10-24237*r**12-444637*r**14
            -162770*r**16-19629*r**18+1264*r**20)+Q2**5*(3355+4036*r**2+13237*r**4
            -1506472*r**6-4012402*r**8-5544248*r**10-4512182*r**12-1020288*r**14
            +1100503*r**16+556868*r**18+63937*r**20-10344*r**22)+(-1+r**2)**4*(35
            +325*r**2+5069*r**4+15147*r**6-173030*r**8+1062838*r**10-899034*r**12
            -567734*r**14+919363*r**16-96635*r**18+74637*r**20+4619*r**22)+Q2**4*(
            -715-7203*r**2+4345*r**4+689755*r**6+1965760*r**8+1718050*r**10+469586*r**12
            +670310*r**14+1363925*r**16-748815*r**18-123035*r**20-15153*r**22+3590*r**24)
            +Q2*(-1+r**2)**2*(-275-1576*r**2-27868*r**4-31570*r**6+729921*r**8
            -3719826*r**10+1431784*r**12+1268116*r**14+1677063*r**16-4186836*r**18
            +520436*r**20-396098*r**22-28213*r**24+142*r**26)+2*Q2**3*(-475+961*r**2
            -26363*r**4-19568*r**6+111180*r**8-505435*r**10+1147318*r**12+1187816*r**14
            +595001*r**16-2500085*r**18+354725*r**20-317144*r**22-28298*r**24+367*r**26)
            +2*Q2**2*(415+738*r**2+28890*r**4-32909*r**6-516826*r**8+2393295*r**10
            -1938201*r**12+1287730*r**14+1194783*r**16-3107068*r**18+3772540*r**20
            -728037*r**22+377180*r**24+32651*r**26-381*r**28))*sqrtq2))/(-18662400*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-777600*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-900*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+43200*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+6220800*logq2**3*r**14*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(flagPERP*muWC**2*(4147200*logq2**4*(-Q2+(-1+r)**2)*r**16*(
            -3+2*r**2+3*r**4)*(-Q2+(1+r)**2)+1152*logq2**2*(-Q2+(-1+r)**2)*r**8*(
            -Q2+(1+r)**2)*(1512*Q2**10*r**2-40*Q2**9*(2+253*r**2+285*r**4)+5*Q2**8*(63
            +5230*r**2+12359*r**4+6552*r**6)-20*Q2**7*(30+1620*r**2+5428*r**4+6765*r**6
            +1941*r**8)+10*Q2**6*(60+2445*r**2+5366*r**4+7157*r**6+10520*r**8-396*r**10)
            +Q2**5*(240-23194*r**2+32600*r**4+210680*r**6+268060*r**8+47050*r**10
            +59796*r**12)-30*Q2**4*(39-804*r**2+1204*r**4+8108*r**6+19803*r**8
            +16144*r**10+4426*r**12+1840*r**14)+20*Q2**3*(18-525*r**2+723*r**4
            +2566*r**6+14021*r**8+25251*r**10+6785*r**12+4084*r**14+117*r**16)
            +10*Q2**2*(120-355*r**2-1506*r**4+1733*r**6-2786*r**8-601*r**10-27278*r**12
            +28791*r**14-2150*r**16+2592*r**18)+(-1+r**2)**2*(335-748*r**2-7626*r**4
            +82556*r**6-82852*r**8-3420*r**10-24262*r**12+72116*r**14+3909*r**16
            +3192*r**18)-10*Q2*(120-495*r**2-1442*r**4+9738*r**6-12720*r**8+5236*r**10
            +19380*r**12-29898*r**14+26392*r**16-645*r**18+1614*r**20))-16*(Q2
            -(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(7*Q2**14*r**2+2*Q2**13*(33-76*r**2
            +r**4)+Q2**12*(-571+743*r**2+4079*r**4-251*r**6)+Q2**11*(2133+742*r**2
            -37120*r**4-25218*r**6+983*r**8)+Q2**10*(-4433-5026*r**2+96946*r**4
            +193578*r**6+59899*r**8-1436*r**10)+Q2**9*(5445-9274*r**2-145403*r**4
            -148308*r**6-274041*r**8-29770*r**10+71*r**12)+2*Q2**8*(-1881+28282*r**2
            +125826*r**4-333010*r**6-841779*r**8-173534*r**10-62418*r**12+1218*r**14)
            +2*Q2**7*(561-41618*r**2-190564*r**4+619678*r**6+3049876*r**8+3008310*r**10
            +685684*r**12+117366*r**14-1389*r**16)+Q2**6*(-66+43811*r**2+254404*r**4
            -686044*r**6-5125052*r**8-11777466*r**10-5701324*r**12-1085356*r**14
            -83274*r**16+159*r**18)+4*Q2**5*(99+733*r**2+11859*r**4+38602*r**6
            +352209*r**8-316158*r**10+2036593*r**12-898926*r**14-156808*r**16-41667*r**18
            +488*r**20)-Q2**4*(495+5033*r**2+138217*r**4+97187*r**6+3057050*r**8
            -7935706*r**10-15860242*r**12+3609522*r**14-9616473*r**16-1425791*r**18
            -189095*r**20+1403*r**22)-Q2**3*(-121+2562*r**2-44576*r**4-45110*r**6
            -2943617*r**8+5162588*r**10+6509696*r**12+13052108*r**14-1004435*r**16
            +3957282*r**18+553248*r**20+29162*r**22+13*r**24)+2*(-1+r**2)**2*(6
            -741*r**2-1089*r**4-46960*r**6+41661*r**8+368027*r**10-4503046*r**12
            +8820368*r**14-5940772*r**16+1383449*r**18-339673*r**20-36928*r**22
            -3519*r**24+17*r**26)+Q2**2*(99-3032*r**2+6754*r**4-151910*r**6+372617*r**8
            +2142070*r**10-5660852*r**12+15475692*r**14-16815179*r**16+8424028*r**18
            -2586094*r**20-281286*r**22-59361*r**24+454*r**26)+Q2*(-67+5022*r**2
            -4779*r**4+233532*r**6-1014987*r**8+2668434*r**10-4804579*r**12+25050728*r**14
            -49323649*r**16+37997154*r**18-11525017*r**20+2480732*r**22+273551*r**24
            +37742*r**26-217*r**28))+69120*logq2**3*r**12*(140*Q2**7*r**2-8*Q2**6*(3
            +70*r**2+112*r**4)+Q2**5*(119+824*r**2+2511*r**4+2226*r**6)-Q2**4*(175
            +577*r**2+2225*r**4+4083*r**6+2380*r**8)+2*Q2**3*(55+14*r**2+394*r**4
            +966*r**6+1391*r**8+140*r**10)+(-1+r**2)**2*(-59+291*r**2-670*r**4
            +570*r**6+125*r**8-141*r**10+364*r**12)+2*Q2**2*(-55+104*r**2-228*r**4
            +50*r**6+83*r**8-714*r**10+840*r**12)-Q2*(-139+472*r**2-1649*r**4
            +510*r**6+1995*r**8+964*r**10-1647*r**12+1414*r**14))*sqrtq2+96*logq2*r**4*(92*Q2**15*r**2
            -8*Q2**14*(-25+204*r**2+122*r**4)+Q2**13*(-1555+8120*r**2+15957*r**4
            +4294*r**6)-Q2**12*(-4915+22359*r**2+60903*r**4+58661*r**6+9616*r**8)
            +Q2**11*(-7470+51128*r**2+76396*r**4+3196*r**6+80834*r**8+9244*r**10)
            +2*Q2**10*(1755-55094*r**2+19866*r**4+509942*r**6+508337*r**8+36496*r**10
            +2794*r**12)-Q2**9*(-5875-181524*r**2+221323*r**4+3232490*r**6+5955855*r**8
            +3554360*r**10+421361*r**12+25498*r**14)+Q2**8*(-10515-187635*r**2+306741*r**4
            +4530657*r**6+10568375*r**8+12189115*r**10+4999515*r**12+571431*r**14
            +25212*r**16)+4*Q2**7*(1455+24987*r**2-74456*r**4-923142*r**6-1599042*r**8
            -2095660*r**10-2451328*r**12-342066*r**14-39597*r**16+33*r**18)-4*Q2**6*(
            -135+2324*r**2-60692*r**4-686132*r**6+293792*r**8+2601242*r**10+2670874*r**12
            +200328*r**14+1270143*r**16+112302*r**18+5522*r**20)+Q2**5*(-2045-12480*r**2
            -148049*r**4-2513678*r**6+3369102*r**8+14987176*r**10+27117150*r**12
            +21419916*r**14+5725807*r**16+6799432*r**18+563571*r**20+18898*r**22)
            +(-1+r**2)**4*(35+1091*r**2+10121*r**4+9397*r**6-188810*r**8+1992938*r**10
            -2362306*r**12-688058*r**14+1634363*r**16-217005*r**18+145337*r**20
            +8325*r**22+172*r**24)-Q2**4*(-925-3283*r**2-97699*r**4-1563165*r**6
            +3061870*r**8+7039410*r**10+10714706*r**12+18880758*r**14+6950535*r**16
            +3430545*r**18+2431265*r**20+186807*r**22+2776*r**24)-Q2*(-1+r**2)**2*(195
            +5522*r**2+49338*r**4-71472*r**6-426291*r**8+5132186*r**10-1591476*r**12
            -4493536*r**14-4237219*r**16+9061206*r**18-1628166*r**20+905744*r**22
            +57363*r**24+1406*r**26)-2*Q2**3*(215+2880*r**2+55574*r**4+95138*r**6
            -1053975*r**8+90790*r**10-1186940*r**12+1464212*r**14-5440551*r**16
            +6931100*r**18-1874970*r**20+849930*r**22+63719*r**24+2878*r**26)+2*Q2**2*(195
            +4718*r**2+46726*r**4-158998*r**6-304133*r**8+2726280*r**10-1780866*r**12
            -449772*r**14+4513561*r**16-10697634*r**18+10454650*r**20-2688702*r**22
            +1023721*r**24+72812*r**26+2242*r**28))*sqrtq2))/(-18662400*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-777600*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-900*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+43200*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+6220800*logq2**3*r**14*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(flagPERP*muWC*(33177600*logq2**4*(-Q2+(-1+r)**2)*r**16*(
            -3+2*r**2+3*r**4)*(-Q2+(1+r)**2)+9216*logq2**2*(-Q2+(-1+r)**2)*r**8*(
            -Q2+(1+r)**2)*(1512*Q2**10*r**2-40*Q2**9*(2+253*r**2+285*r**4)+5*Q2**8*(63
            +5230*r**2+12359*r**4+6552*r**6)-20*Q2**7*(30+1620*r**2+5428*r**4+6765*r**6
            +1941*r**8)+10*Q2**6*(60+2445*r**2+5366*r**4+7157*r**6+10520*r**8-396*r**10)
            +Q2**5*(240-23194*r**2+32600*r**4+210680*r**6+268060*r**8+47050*r**10
            +59796*r**12)-30*Q2**4*(39-804*r**2+1204*r**4+8108*r**6+19803*r**8
            +16144*r**10+4426*r**12+1840*r**14)+20*Q2**3*(18-525*r**2+723*r**4
            +2566*r**6+14021*r**8+25251*r**10+6785*r**12+4084*r**14+117*r**16)
            +10*Q2**2*(120-355*r**2-1506*r**4+1733*r**6-2786*r**8-601*r**10-27278*r**12
            +28791*r**14-2150*r**16+2592*r**18)+(-1+r**2)**2*(335-748*r**2-7626*r**4
            +82556*r**6-82852*r**8-3420*r**10-24262*r**12+72116*r**14+3909*r**16
            +3192*r**18)-10*Q2*(120-495*r**2-1442*r**4+9738*r**6-12720*r**8+5236*r**10
            +19380*r**12-29898*r**14+26392*r**16-645*r**18+1614*r**20))-128*(Q2
            -(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(7*Q2**14*r**2+2*Q2**13*(33-76*r**2
            +r**4)+Q2**12*(-571+743*r**2+4079*r**4-251*r**6)+Q2**11*(2133+742*r**2
            -37120*r**4-25218*r**6+983*r**8)+Q2**10*(-4433-5026*r**2+96946*r**4
            +193578*r**6+59899*r**8-1436*r**10)+Q2**9*(5445-9274*r**2-145403*r**4
            -148308*r**6-274041*r**8-29770*r**10+71*r**12)+2*Q2**8*(-1881+28282*r**2
            +125826*r**4-333010*r**6-841779*r**8-173534*r**10-62418*r**12+1218*r**14)
            +2*Q2**7*(561-41618*r**2-190564*r**4+619678*r**6+3049876*r**8+3008310*r**10
            +685684*r**12+117366*r**14-1389*r**16)+Q2**6*(-66+43811*r**2+254404*r**4
            -686044*r**6-5125052*r**8-11777466*r**10-5701324*r**12-1085356*r**14
            -83274*r**16+159*r**18)+4*Q2**5*(99+733*r**2+11859*r**4+38602*r**6
            +352209*r**8-316158*r**10+2036593*r**12-898926*r**14-156808*r**16-41667*r**18
            +488*r**20)-Q2**4*(495+5033*r**2+138217*r**4+97187*r**6+3057050*r**8
            -7935706*r**10-15860242*r**12+3609522*r**14-9616473*r**16-1425791*r**18
            -189095*r**20+1403*r**22)-Q2**3*(-121+2562*r**2-44576*r**4-45110*r**6
            -2943617*r**8+5162588*r**10+6509696*r**12+13052108*r**14-1004435*r**16
            +3957282*r**18+553248*r**20+29162*r**22+13*r**24)+2*(-1+r**2)**2*(6
            -741*r**2-1089*r**4-46960*r**6+41661*r**8+368027*r**10-4503046*r**12
            +8820368*r**14-5940772*r**16+1383449*r**18-339673*r**20-36928*r**22
            -3519*r**24+17*r**26)+Q2**2*(99-3032*r**2+6754*r**4-151910*r**6+372617*r**8
            +2142070*r**10-5660852*r**12+15475692*r**14-16815179*r**16+8424028*r**18
            -2586094*r**20-281286*r**22-59361*r**24+454*r**26)+Q2*(-67+5022*r**2
            -4779*r**4+233532*r**6-1014987*r**8+2668434*r**10-4804579*r**12+25050728*r**14
            -49323649*r**16+37997154*r**18-11525017*r**20+2480732*r**22+273551*r**24
            +37742*r**26-217*r**28))+552960*logq2**3*r**12*(140*Q2**7*r**2-8*Q2**6*(3
            +70*r**2+112*r**4)+Q2**5*(119+824*r**2+2511*r**4+2226*r**6)-Q2**4*(175
            +577*r**2+2225*r**4+4083*r**6+2380*r**8)+2*Q2**3*(55+14*r**2+394*r**4
            +966*r**6+1391*r**8+140*r**10)+(-1+r**2)**2*(-59+291*r**2-670*r**4
            +570*r**6+125*r**8-141*r**10+364*r**12)+2*Q2**2*(-55+104*r**2-228*r**4
            +50*r**6+83*r**8-714*r**10+840*r**12)-Q2*(-139+472*r**2-1649*r**4
            +510*r**6+1995*r**8+964*r**10-1647*r**12+1414*r**14))*sqrtq2+768*logq2*r**4*(92*Q2**15*r**2
            -8*Q2**14*(-25+204*r**2+122*r**4)+Q2**13*(-1555+8120*r**2+15957*r**4
            +4294*r**6)-Q2**12*(-4915+22359*r**2+60903*r**4+58661*r**6+9616*r**8)
            +Q2**11*(-7470+51128*r**2+76396*r**4+3196*r**6+80834*r**8+9244*r**10)
            +2*Q2**10*(1755-55094*r**2+19866*r**4+509942*r**6+508337*r**8+36496*r**10
            +2794*r**12)-Q2**9*(-5875-181524*r**2+221323*r**4+3232490*r**6+5955855*r**8
            +3554360*r**10+421361*r**12+25498*r**14)+Q2**8*(-10515-187635*r**2+306741*r**4
            +4530657*r**6+10568375*r**8+12189115*r**10+4999515*r**12+571431*r**14
            +25212*r**16)+4*Q2**7*(1455+24987*r**2-74456*r**4-923142*r**6-1599042*r**8
            -2095660*r**10-2451328*r**12-342066*r**14-39597*r**16+33*r**18)-4*Q2**6*(
            -135+2324*r**2-60692*r**4-686132*r**6+293792*r**8+2601242*r**10+2670874*r**12
            +200328*r**14+1270143*r**16+112302*r**18+5522*r**20)+Q2**5*(-2045-12480*r**2
            -148049*r**4-2513678*r**6+3369102*r**8+14987176*r**10+27117150*r**12
            +21419916*r**14+5725807*r**16+6799432*r**18+563571*r**20+18898*r**22)
            +(-1+r**2)**4*(35+1091*r**2+10121*r**4+9397*r**6-188810*r**8+1992938*r**10
            -2362306*r**12-688058*r**14+1634363*r**16-217005*r**18+145337*r**20
            +8325*r**22+172*r**24)-Q2**4*(-925-3283*r**2-97699*r**4-1563165*r**6
            +3061870*r**8+7039410*r**10+10714706*r**12+18880758*r**14+6950535*r**16
            +3430545*r**18+2431265*r**20+186807*r**22+2776*r**24)-Q2*(-1+r**2)**2*(195
            +5522*r**2+49338*r**4-71472*r**6-426291*r**8+5132186*r**10-1591476*r**12
            -4493536*r**14-4237219*r**16+9061206*r**18-1628166*r**20+905744*r**22
            +57363*r**24+1406*r**26)-2*Q2**3*(215+2880*r**2+55574*r**4+95138*r**6
            -1053975*r**8+90790*r**10-1186940*r**12+1464212*r**14-5440551*r**16
            +6931100*r**18-1874970*r**20+849930*r**22+63719*r**24+2878*r**26)+2*Q2**2*(195
            +4718*r**2+46726*r**4-158998*r**6-304133*r**8+2726280*r**10-1780866*r**12
            -449772*r**14+4513561*r**16-10697634*r**18+10454650*r**20-2688702*r**22
            +1023721*r**24+72812*r**26+2242*r**28))*sqrtq2))/(-55987200*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-2332800*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-2700*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+129600*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+18662400*logq2**3*r**14*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(flagPERP*(-8294400*logq2**4*(-Q2+(-1+r)**2)*r**16*(
            -1+3*r**4)*(-Q2+(1+r)**2)-2304*logq2**2*(-Q2+(-1+r)**2)*r**8*(-Q2
            +(1+r)**2)*(-768*Q2**10*r**2+40*Q2**9*(-2+144*r**2+125*r**4)-5*Q2**8*(
            -97+3288*r**2+5821*r**4+2496*r**6)+20*Q2**7*(-50+1032*r**2+2952*r**4
            +2590*r**6+711*r**8)-20*Q2**6*(-22+274*r**2+1805*r**4+2571*r**6+1792*r**8
            +336*r**10)+4*Q2**5*(320-3486*r**2-9190*r**4-13940*r**6-3205*r**8+2620*r**10
            +579*r**12)-10*Q2**4*(187-1464*r**2-6594*r**4-12680*r**6-10875*r**8
            -420*r**10+1606*r**12+360*r**14)-20*Q2**3*(-22+148*r**2+1339*r**4+3012*r**6
            +2641*r**8-208*r**10+223*r**12-824*r**14+51*r**16)+20*Q2**2*(40-162*r**2
            -555*r**4+2009*r**6-3473*r**8-662*r**10-3243*r**12+4967*r**14-25*r**16
            +384*r**18)+(-1+r**2)**2*(145-198*r**2-4416*r**4+36566*r**6-21762*r**8
            +870*r**10-10912*r**12+38106*r**14+3249*r**16+1552*r**18)-20*Q2*(32
            -114*r**2-687*r**4+4204*r**6-5118*r**8+3864*r**10+5794*r**12-5328*r**14
            +5526*r**16+158*r**18+309*r**20))+32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(7*Q2**14+Q2**13*(68+46*r**2)-Q2**12*(717+6352*r**2+643*r**4)
            +4*Q2**11*(396+11268*r**2+10829*r**4+624*r**6)-2*Q2**10*(58+56589*r**2
            +119149*r**4+56161*r**6+2343*r**8)+8*Q2**9*(-108+11073*r**2+47052*r**4
            +49657*r**6+13950*r**8+517*r**10)-2*Q2**8*(4593-51766*r**2-53644*r**4
            -172420*r**6+38069*r**8-18162*r**10+66*r**12)-4*Q2**7*(-5736+59893*r**2
            +194922*r**4+677168*r**6+543520*r**8+90437*r**10+41634*r**12+726*r**14)
            +Q2**6*(-13473+107480*r**2+561048*r**4+2817388*r**6+4727966*r**8+2103752*r**10
            +254520*r**12+102468*r**14+1683*r**16)+2*Q2**5*(-6974+47965*r**2-13292*r**4
            +433982*r**6-711268*r**8-1106496*r**10-194620*r**12-70622*r**14+11562*r**16
            +451*r**18)+Q2**4*(21607-110684*r**2+105489*r**4-2865356*r**6-2478042*r**8
            -1628916*r**10+362842*r**12+188764*r**14+348739*r**16-39200*r**18-1243*r**20)
            +4*Q2**3*(-1308+2193*r**2-31247*r**4+295690*r**6+368708*r**8+221166*r**10
            +196538*r**12-111708*r**14-70520*r**16-50223*r**18+1477*r**20+34*r**22)
            +2*(-1+r**2)**2*(-468+1288*r**2-34435*r**4+43936*r**6+292209*r**8-2571552*r**10
            +4429614*r**12-2779872*r**14+519474*r**16-130824*r**18-27595*r**20-992*r**22
            +17*r**24)+2*Q2**2*(-3201+19537*r**2-102987*r**4+272991*r**6-245380*r**8
            +997286*r**10+471654*r**12-1300294*r**14+658859*r**16-247575*r**18-87995*r**20
            -1081*r**22+186*r**24)-4*Q2*(-1166+5788*r**2-64394*r**4+175131*r**6
            +1990*r**8-1021853*r**10-167156*r**12+2846098*r**14-2779082*r**16+685710*r**18
            -147906*r**20-50157*r**22-1454*r**24+51*r**26))+138240*logq2**3*r**12*(40*Q2**7*r**2
            -4*Q2**6*(6+52*r**2+37*r**4)+Q2**5*(109+472*r**2+591*r**4+108*r**6)
            +Q2**4*(-165-497*r**2-869*r**4-379*r**6+130*r**8)+2*Q2**3*(25+129*r**2
            +187*r**4+46*r**6-72*r**8+25*r**10)-(-1+r**2)**2*(-31+157*r**2-310*r**4
            +330*r**6+245*r**8-119*r**10+208*r**12)-2*Q2**2*(-55+166*r**2-240*r**4
            +29*r**6+48*r**8-183*r**10+315*r**12)+Q2*(-111+486*r**2-1063*r**4
            +490*r**6+1375*r**8+846*r**10-761*r**12+658*r**14))*sqrtq2-192*logq2*r**4*(
            -184*Q2**15*r**2+4*Q2**14*(-10+548*r**2+525*r**4)-Q2**13*(-325+10248*r**2
            +21801*r**4+9956*r**6)+Q2**12*(-1045+24391*r**2+82775*r**4+83077*r**6
            +25198*r**8)-2*Q2**11*(-725+14763*r**2+67423*r**4+82320*r**6+74306*r**8
            +17349*r**10)+2*Q2**10*(55+5094*r**2+15142*r**4-144617*r**6-98052*r**8
            +47247*r**10+9139*r**12)+Q2**9*(-3245+16486*r**2+224355*r**4+1639870*r**6
            +2460865*r**8+1206750*r**10+91561*r**12+17310*r**14)-Q2**8*(-4125+17949*r**2
            +345323*r**4+2513833*r**6+5164385*r**8+4770875*r**10+1834589*r**12+206703*r**14
            +35028*r**16)+4*Q2**7*(-165+27*r**2+50905*r**4+311204*r**6+843301*r**8
            +1155440*r**10+991477*r**12+324160*r**14+37674*r**16+4641*r**18)+4*Q2**6*(
            -825+1288*r**2-10697*r**4+228075*r**6+486761*r**8+579599*r**10-24237*r**12
            -444637*r**14-162770*r**16-19629*r**18+1264*r**20)+Q2**5*(3355+4036*r**2
            +13237*r**4-1506472*r**6-4012402*r**8-5544248*r**10-4512182*r**12-1020288*r**14
            +1100503*r**16+556868*r**18+63937*r**20-10344*r**22)+(-1+r**2)**4*(35
            +325*r**2+5069*r**4+15147*r**6-173030*r**8+1062838*r**10-899034*r**12
            -567734*r**14+919363*r**16-96635*r**18+74637*r**20+4619*r**22)+Q2**4*(
            -715-7203*r**2+4345*r**4+689755*r**6+1965760*r**8+1718050*r**10+469586*r**12
            +670310*r**14+1363925*r**16-748815*r**18-123035*r**20-15153*r**22+3590*r**24)
            +Q2*(-1+r**2)**2*(-275-1576*r**2-27868*r**4-31570*r**6+729921*r**8
            -3719826*r**10+1431784*r**12+1268116*r**14+1677063*r**16-4186836*r**18
            +520436*r**20-396098*r**22-28213*r**24+142*r**26)+2*Q2**3*(-475+961*r**2
            -26363*r**4-19568*r**6+111180*r**8-505435*r**10+1147318*r**12+1187816*r**14
            +595001*r**16-2500085*r**18+354725*r**20-317144*r**22-28298*r**24+367*r**26)
            +2*Q2**2*(415+738*r**2+28890*r**4-32909*r**6-516826*r**8+2393295*r**10
            -1938201*r**12+1287730*r**14+1194783*r**16-3107068*r**18+3772540*r**20
            -728037*r**22+377180*r**24+32651*r**26-381*r**28))*sqrtq2)*math.log(mu0))/(
            -6220800*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-259200*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -300*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4
            +14400*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*sqrtq2+2073600*logq2**3*r**14*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+FLAGcs*flagPERP*((
            -561600*logq2**3*r**10*(1-2*r**2+3*r**4)-156*logq2*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(-35+172*r**2+92*Q2**8*r**2-6*r**4-11844*r**6+34868*r**8
            -5600*r**10-2882*r**12+6396*r**14+359*r**16+172*r**18+Q2**7*(40-636*r**2
            -516*r**4)+Q2**6*(-125+1136*r**2+3085*r**4+886*r**6)-2*Q2**5*(-30+111*r**2
            +1967*r**4+2027*r**6+41*r**8)-Q2**4*(-175+1100*r**2+1500*r**4+2828*r**6
            +655*r**8+1260*r**10)+4*Q2**3*(-50+177*r**2+1320*r**4+3908*r**6+3628*r**8
            +1155*r**10+262*r**12)+Q2**2*(-15+436*r**2-2059*r**4-7258*r**6-27873*r**8
            -6128*r**10-2309*r**12+206*r**14)-2*Q2*(-50+293*r**2+175*r**4+367*r**6
            +1845*r**8-11305*r**10+4597*r**12+205*r**14+273*r**16))-18720*logq2**2*r**6*(1
            -11*r**2+10*Q2**5*r**2+50*r**4+30*r**6+125*r**8-41*r**10+26*r**12-4*Q2**4*(1
            +8*r**2+11*r**4)+Q2**3*(6+49*r**2+89*r**4+61*r**6)-Q2**2*(-1+23*r**2
            +56*r**4+108*r**6+4*r**8)+Q2*(-4+12*r**2-33*r**4+27*r**6+77*r**8
            -49*r**10))*sqrtq2-26*(7*Q2**11*r**2+Q2**10*(-22+75*r**2+9*r**4)-5*Q2**9*(
            -29+105*r**2+611*r**4+47*r**6)+10*Q2**8*(-38+73*r**2+1794*r**4+1598*r**6
            +75*r**8)-10*Q2**7*(-46-61*r**2+3534*r**4+6970*r**6+3088*r**8+93*r**10)
            +2*Q2**6*(-70-627*r**2+10815*r**4+39300*r**6+45950*r**8+7285*r**10
            +63*r**12)+2*Q2**5*(-133-1075*r**2+9081*r**4+3405*r**6+17415*r**8-15723*r**10
            +16105*r**12+441*r**14)-20*Q2**4*(-14-260*r**2+1743*r**4+2335*r**6
            +10488*r**8+9576*r**10+779*r**12+2411*r**14+42*r**16)+5*Q2**3*(-4-501*r**2
            +2604*r**4+2628*r**6+26348*r**8+51702*r**10+21428*r**12+4076*r**14
            +2584*r**16+15*r**18)+2*(-1+r**2)**2*(-6-237*r**2+1964*r**4-9815*r**6
            -8509*r**8+86159*r**10-86693*r**12+43631*r**14-6565*r**16+1654*r**18
            +17*r**20)+5*Q2**2*(-22-297*r**2+2685*r**4-5232*r**6-1364*r**8+25698*r**10
            -53706*r**12+30112*r**14-10086*r**16+3511*r**18+61*r**20)+Q2*(65+1747*r**2
            -15795*r**4+56225*r**6+3030*r**8-102270*r**10-325714*r**12+429270*r**14
            -261975*r**16+57195*r**18-14395*r**20-183*r**22))*sqrtq2)/(-388800*logq2**3*r**12
            -8100*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+97200*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+225*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((-43200*logq2**3*r**10*(1-2*r**2+3*r**4)
            -12*logq2*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-35+172*r**2+92*Q2**8*r**2
            -6*r**4-11844*r**6+34868*r**8-5600*r**10-2882*r**12+6396*r**14+359*r**16
            +172*r**18+Q2**7*(40-636*r**2-516*r**4)+Q2**6*(-125+1136*r**2+3085*r**4
            +886*r**6)-2*Q2**5*(-30+111*r**2+1967*r**4+2027*r**6+41*r**8)-Q2**4*(
            -175+1100*r**2+1500*r**4+2828*r**6+655*r**8+1260*r**10)+4*Q2**3*(-50
            +177*r**2+1320*r**4+3908*r**6+3628*r**8+1155*r**10+262*r**12)+Q2**2*(
            -15+436*r**2-2059*r**4-7258*r**6-27873*r**8-6128*r**10-2309*r**12
            +206*r**14)-2*Q2*(-50+293*r**2+175*r**4+367*r**6+1845*r**8-11305*r**10
            +4597*r**12+205*r**14+273*r**16))-1440*logq2**2*r**6*(1-11*r**2+10*Q2**5*r**2
            +50*r**4+30*r**6+125*r**8-41*r**10+26*r**12-4*Q2**4*(1+8*r**2+11*r**4)
            +Q2**3*(6+49*r**2+89*r**4+61*r**6)-Q2**2*(-1+23*r**2+56*r**4+108*r**6
            +4*r**8)+Q2*(-4+12*r**2-33*r**4+27*r**6+77*r**8-49*r**10))*sqrtq2
            -2*(7*Q2**11*r**2+Q2**10*(-22+75*r**2+9*r**4)-5*Q2**9*(-29+105*r**2
            +611*r**4+47*r**6)+10*Q2**8*(-38+73*r**2+1794*r**4+1598*r**6+75*r**8)
            -10*Q2**7*(-46-61*r**2+3534*r**4+6970*r**6+3088*r**8+93*r**10)+2*Q2**6*(
            -70-627*r**2+10815*r**4+39300*r**6+45950*r**8+7285*r**10+63*r**12)
            +2*Q2**5*(-133-1075*r**2+9081*r**4+3405*r**6+17415*r**8-15723*r**10
            +16105*r**12+441*r**14)-20*Q2**4*(-14-260*r**2+1743*r**4+2335*r**6
            +10488*r**8+9576*r**10+779*r**12+2411*r**14+42*r**16)+5*Q2**3*(-4-501*r**2
            +2604*r**4+2628*r**6+26348*r**8+51702*r**10+21428*r**12+4076*r**14
            +2584*r**16+15*r**18)+2*(-1+r**2)**2*(-6-237*r**2+1964*r**4-9815*r**6
            -8509*r**8+86159*r**10-86693*r**12+43631*r**14-6565*r**16+1654*r**18
            +17*r**20)+5*Q2**2*(-22-297*r**2+2685*r**4-5232*r**6-1364*r**8+25698*r**10
            -53706*r**12+30112*r**14-10086*r**16+3511*r**18+61*r**20)+Q2*(65+1747*r**2
            -15795*r**4+56225*r**6+3030*r**8-102270*r**10-325714*r**12+429270*r**14
            -261975*r**16+57195*r**18-14395*r**20-183*r**22))*sqrtq2)*math.log(murhoLS))/(
            -43200*logq2**3*r**12-900*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+10800*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+25*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2))+(flagPERP*(8294400*logq2**4*(-Q2+(-1
            +r)**2)*r**16*(-1+3*r**4)*(-Q2+(1+r)**2)+2304*logq2**2*(-Q2+(-1+r)**2)*r**8*(
            -Q2+(1+r)**2)*(-768*Q2**10*r**2+40*Q2**9*(-2+144*r**2+125*r**4)-5*Q2**8*(
            -97+3288*r**2+5821*r**4+2496*r**6)+20*Q2**7*(-50+1032*r**2+2952*r**4
            +2590*r**6+711*r**8)-20*Q2**6*(-22+274*r**2+1805*r**4+2571*r**6+1792*r**8
            +336*r**10)+4*Q2**5*(320-3486*r**2-9190*r**4-13940*r**6-3205*r**8+2620*r**10
            +579*r**12)-10*Q2**4*(187-1464*r**2-6594*r**4-12680*r**6-10875*r**8
            -420*r**10+1606*r**12+360*r**14)-20*Q2**3*(-22+148*r**2+1339*r**4+3012*r**6
            +2641*r**8-208*r**10+223*r**12-824*r**14+51*r**16)+20*Q2**2*(40-162*r**2
            -555*r**4+2009*r**6-3473*r**8-662*r**10-3243*r**12+4967*r**14-25*r**16
            +384*r**18)+(-1+r**2)**2*(145-198*r**2-4416*r**4+36566*r**6-21762*r**8
            +870*r**10-10912*r**12+38106*r**14+3249*r**16+1552*r**18)-20*Q2*(32
            -114*r**2-687*r**4+4204*r**6-5118*r**8+3864*r**10+5794*r**12-5328*r**14
            +5526*r**16+158*r**18+309*r**20))-32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(7*Q2**14+Q2**13*(68+46*r**2)-Q2**12*(717+6352*r**2+643*r**4)
            +4*Q2**11*(396+11268*r**2+10829*r**4+624*r**6)-2*Q2**10*(58+56589*r**2
            +119149*r**4+56161*r**6+2343*r**8)+8*Q2**9*(-108+11073*r**2+47052*r**4
            +49657*r**6+13950*r**8+517*r**10)-2*Q2**8*(4593-51766*r**2-53644*r**4
            -172420*r**6+38069*r**8-18162*r**10+66*r**12)-4*Q2**7*(-5736+59893*r**2
            +194922*r**4+677168*r**6+543520*r**8+90437*r**10+41634*r**12+726*r**14)
            +Q2**6*(-13473+107480*r**2+561048*r**4+2817388*r**6+4727966*r**8+2103752*r**10
            +254520*r**12+102468*r**14+1683*r**16)+2*Q2**5*(-6974+47965*r**2-13292*r**4
            +433982*r**6-711268*r**8-1106496*r**10-194620*r**12-70622*r**14+11562*r**16
            +451*r**18)+Q2**4*(21607-110684*r**2+105489*r**4-2865356*r**6-2478042*r**8
            -1628916*r**10+362842*r**12+188764*r**14+348739*r**16-39200*r**18-1243*r**20)
            +4*Q2**3*(-1308+2193*r**2-31247*r**4+295690*r**6+368708*r**8+221166*r**10
            +196538*r**12-111708*r**14-70520*r**16-50223*r**18+1477*r**20+34*r**22)
            +2*(-1+r**2)**2*(-468+1288*r**2-34435*r**4+43936*r**6+292209*r**8-2571552*r**10
            +4429614*r**12-2779872*r**14+519474*r**16-130824*r**18-27595*r**20-992*r**22
            +17*r**24)+2*Q2**2*(-3201+19537*r**2-102987*r**4+272991*r**6-245380*r**8
            +997286*r**10+471654*r**12-1300294*r**14+658859*r**16-247575*r**18-87995*r**20
            -1081*r**22+186*r**24)-4*Q2*(-1166+5788*r**2-64394*r**4+175131*r**6
            +1990*r**8-1021853*r**10-167156*r**12+2846098*r**14-2779082*r**16+685710*r**18
            -147906*r**20-50157*r**22-1454*r**24+51*r**26))-138240*logq2**3*r**12*(40*Q2**7*r**2
            -4*Q2**6*(6+52*r**2+37*r**4)+Q2**5*(109+472*r**2+591*r**4+108*r**6)
            +Q2**4*(-165-497*r**2-869*r**4-379*r**6+130*r**8)+2*Q2**3*(25+129*r**2
            +187*r**4+46*r**6-72*r**8+25*r**10)-(-1+r**2)**2*(-31+157*r**2-310*r**4
            +330*r**6+245*r**8-119*r**10+208*r**12)-2*Q2**2*(-55+166*r**2-240*r**4
            +29*r**6+48*r**8-183*r**10+315*r**12)+Q2*(-111+486*r**2-1063*r**4
            +490*r**6+1375*r**8+846*r**10-761*r**12+658*r**14))*sqrtq2+192*logq2*r**4*(
            -184*Q2**15*r**2+4*Q2**14*(-10+548*r**2+525*r**4)-Q2**13*(-325+10248*r**2
            +21801*r**4+9956*r**6)+Q2**12*(-1045+24391*r**2+82775*r**4+83077*r**6
            +25198*r**8)-2*Q2**11*(-725+14763*r**2+67423*r**4+82320*r**6+74306*r**8
            +17349*r**10)+2*Q2**10*(55+5094*r**2+15142*r**4-144617*r**6-98052*r**8
            +47247*r**10+9139*r**12)+Q2**9*(-3245+16486*r**2+224355*r**4+1639870*r**6
            +2460865*r**8+1206750*r**10+91561*r**12+17310*r**14)-Q2**8*(-4125+17949*r**2
            +345323*r**4+2513833*r**6+5164385*r**8+4770875*r**10+1834589*r**12+206703*r**14
            +35028*r**16)+4*Q2**7*(-165+27*r**2+50905*r**4+311204*r**6+843301*r**8
            +1155440*r**10+991477*r**12+324160*r**14+37674*r**16+4641*r**18)+4*Q2**6*(
            -825+1288*r**2-10697*r**4+228075*r**6+486761*r**8+579599*r**10-24237*r**12
            -444637*r**14-162770*r**16-19629*r**18+1264*r**20)+Q2**5*(3355+4036*r**2
            +13237*r**4-1506472*r**6-4012402*r**8-5544248*r**10-4512182*r**12-1020288*r**14
            +1100503*r**16+556868*r**18+63937*r**20-10344*r**22)+(-1+r**2)**4*(35
            +325*r**2+5069*r**4+15147*r**6-173030*r**8+1062838*r**10-899034*r**12
            -567734*r**14+919363*r**16-96635*r**18+74637*r**20+4619*r**22)+Q2**4*(
            -715-7203*r**2+4345*r**4+689755*r**6+1965760*r**8+1718050*r**10+469586*r**12
            +670310*r**14+1363925*r**16-748815*r**18-123035*r**20-15153*r**22+3590*r**24)
            +Q2*(-1+r**2)**2*(-275-1576*r**2-27868*r**4-31570*r**6+729921*r**8
            -3719826*r**10+1431784*r**12+1268116*r**14+1677063*r**16-4186836*r**18
            +520436*r**20-396098*r**22-28213*r**24+142*r**26)+2*Q2**3*(-475+961*r**2
            -26363*r**4-19568*r**6+111180*r**8-505435*r**10+1147318*r**12+1187816*r**14
            +595001*r**16-2500085*r**18+354725*r**20-317144*r**22-28298*r**24+367*r**26)
            +2*Q2**2*(415+738*r**2+28890*r**4-32909*r**6-516826*r**8+2393295*r**10
            -1938201*r**12+1287730*r**14+1194783*r**16-3107068*r**18+3772540*r**20
            -728037*r**22+377180*r**24+32651*r**26-381*r**28))*sqrtq2)*math.log(r))/(-6220800*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-259200*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-300*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+14400*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+2073600*logq2**3*r**14*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(flagPERP*(-43200*logq2**3*r**10*(-16+47*r**2+46*r**4
            +15*r**6)+12*logq2*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-80-1341*r**2
            +1544*Q2**8*r**2-7172*r**4-59768*r**6+117716*r**8-820230*r**10-397644*r**12
            +156712*r**14+17708*r**16+499*r**18-8*Q2**7*(-40+1269*r**2+1149*r**4)
            +Q2**6*(-800+14927*r**2+40590*r**4+13327*r**6)+Q2**5*(80+3186*r**2
            -44058*r**4-48218*r**6+4706*r**8)+Q2**4*(1200-13955*r**2-3760*r**4
            +41094*r**6+15520*r**8-21795*r**10)+4*Q2**3*(-200-531*r**2+10635*r**4
            +55156*r**6+42996*r**8+9655*r**10+2209*r**12)+Q2**2*(-320+7497*r**2
            -27738*r**4-275421*r**6-527636*r**8-220461*r**10-55258*r**12+7097*r**14)
            -2*Q2*(-200-209*r**2+8405*r**4+67339*r**6+29745*r**8-40055*r**10+98659*r**12
            -595*r**14+2511*r**16))+720*logq2**2*r**6*(-64+133*r**2+60*Q2**5*r**2
            +1223*r**4-10172*r**6-7372*r**8-1313*r**10+1005*r**12-32*Q2**4*(2+9*r**2
            +15*r**4)+Q2**3*(16+1453*r**2+2522*r**4+1485*r**6)-Q2**2*(-96+1069*r**2
            +3351*r**4+3783*r**6+765*r**8)-Q2*(-16+409*r**2+1378*r**4+146*r**6
            -462*r**8+1305*r**10))*sqrtq2+(100*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(5*Q2**5
            -4*Q2**3*(-1+r**2)**2+Q2**2*(-3+r**2)*(-1+r**2)**2-4*Q2**4*(1+r**2)
            +Q2*(-1+r**2)**2*(-3-8*r**2+r**4)+(-1+r**2)**2*(-3-47*r**2-11*r**4
            +r**6))+(Q2-(-1+r)**2)*(-Q2+(1+r)**2)*(-327+40*Q2**11+5381*r**2
            +51893*r**4-66375*r**6+459862*r**8-1267442*r**10+6907134*r**12-1962938*r**14
            -121295*r**16-29907*r**18-1651*r**20+65*r**22-160*Q2**10*(1+r**2)+Q2**9*(25
            -158*r**2+25*r**4)+Q2**8*(1913-6501*r**2-3237*r**4+825*r**6)-2*Q2**7*(2502
            -11611*r**2-64954*r**4-8107*r**6+750*r**8)+2*Q2**6*(1502-7291*r**2
            -167219*r**4-158107*r**6-8175*r**8+210*r**10)+2*Q2**5*(1711-11743*r**2
            +61595*r**4+379858*r**6+56331*r**8-7647*r**10+735*r**12)+Q2**4*(-3690
            +20928*r**2+204288*r**4-432758*r**6-916254*r**8+338360*r**10+34328*r**12
            -1650*r**14)+2*Q2**3*(-514+8473*r**2-16750*r**4-239765*r**6-565632*r**8
            +77979*r**10-155902*r**12-5559*r**14+150*r**16)+2*Q2**2*(782-7781*r**2
            -54965*r**4+345293*r**6+1595771*r**8+1042739*r**10+455677*r**12-12549*r**14
            -5697*r**16+250*r**18)+Q2*(241-6028*r**2-28199*r**4+357456*r**6+1406870*r**8
            -1995336*r**10+2615318*r**12-480176*r**14+108569*r**16+8820*r**18-335*r**20)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(6220800*logq2**4*r**16
            +259200*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+300*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-2073600*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-14400*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +(flagPERP*(-720*logq2**2*r**6*(-4+21*r**2+9*r**4)-(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(21+120*Q2**7+431*r**2+2289*r**4-3941*r**6+26419*r**8
            -5607*r**10-937*r**12+45*r**14-225*Q2**6*(1+r**2)-8*Q2**5*(15-58*r**2
            +15*r**4)-4*Q2**3*(-84+275*r**2+1754*r**4+107*r**6)+3*Q2**4*(37-17*r**2
            -281*r**4+125*r**6)+Q2**2*(-99+1093*r**2+10210*r**4+8818*r**6+1717*r**8
            -195*r**10)+4*Q2*(-36+327*r**2+1534*r**4-2282*r**6+1954*r**8+63*r**10))
            +24*logq2*r**2*(-10-11*r**2-36*Q2**4*r**2+14*r**4-1326*r**6-416*r**8
            +189*r**10+2*Q2**3*(-5+132*r**2+117*r**4)-Q2**2*(-10+191*r**2+524*r**4
            +171*r**6)-2*Q2*(-5+93*r**2+2*r**4-68*r**6+108*r**8))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(
            -51840*logq2**3*r**12-1080*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+12960*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+30*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(flagPERP*(-12*logq2*r**4+(-3+5*Q2**3
            +5*r**2-19*r**4+5*r**6-5*Q2**2*(1+r**2)+Q2*(-5+8*r**2-5*r**4))*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(288*logq2**2*r**8
            +2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-48*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(flagPERP*(-3600*logq2**2*r**8*(15
            +22*r**2+15*r**4)-(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(7+92*Q2**8-156*r**2
            +5096*r**4+19308*r**6+138690*r**8+19308*r**10+5096*r**12-156*r**14
            +7*r**16-156*Q2**7*(1+r**2)+Q2**6*(-89+190*r**2-89*r**4)+2*Q2**5*(79
            -247*r**2-247*r**4+79*r**6)+Q2**4*(165-1160*r**2-10298*r**4-1160*r**6
            +165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4-2439*r**6-280*r**8+19*r**10)
            +Q2**2*(-79+806*r**2+1787*r**4-14228*r**6+1787*r**8+806*r**10-79*r**12)
            +2*Q2*(27-635*r**2-2957*r**4+19165*r**6+19165*r**8-2957*r**10-635*r**12
            +27*r**14))-600*logq2*r**4*(1+2*Q2**5+35*r**2+276*r**4+276*r**6+35*r**8
            +r**10-16*Q2**4*(1+r**2)+Q2**3*(17+42*r**2+17*r**4)+Q2**2*(7-19*r**2
            -19*r**4+7*r**6)+Q2*(-11+30*r**2+66*r**4+30*r**6-11*r**8))*sqrtq2)*nlopw.X1Q2MuG(0,Q2,r))/(
            -259200*logq2**3*r**12-5400*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+64800*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+150*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(flagPERP*(-180*logq2*r**4*(1+r**2)+(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*nlopw.X1Q2MuG(1,Q2,r))/(720*logq2**2*r**8
            +5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)-(flagPERP*nlopw.X1Q2MuG(2,Q2,r))/(
            -12*logq2*r**4+(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2))+rhoD*((flagPERP*(-276480*logq2**3*(-Q2+(-1+r)**2)*r**12*(
            -Q2+(1+r)**2)*(-40*Q2**7*r**2+4*Q2**6*(6+52*r**2+37*r**4)-Q2**5*(109
            +472*r**2+591*r**4+108*r**6)+Q2**4*(165+497*r**2+869*r**4+379*r**6
            -130*r**8)-2*Q2**3*(25+129*r**2+187*r**4+46*r**6-72*r**8+25*r**10)
            +(-1+r**2)**2*(-31+157*r**2-310*r**4+330*r**6+245*r**8-119*r**10+208*r**12)
            +2*Q2**2*(-55+166*r**2-240*r**4+29*r**6+48*r**8-183*r**10+315*r**12)
            -Q2*(-111+486*r**2-1063*r**4+490*r**6+1375*r**8+846*r**10-761*r**12
            +658*r**14))-384*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-184*Q2**13*r**2
            +4*Q2**12*(-10+456*r**2+433*r**4)-Q2**11*(-245+6496*r**2+15057*r**4
            +6308*r**6)+Q2**10*(-515+9985*r**2+41625*r**4+41987*r**6+10850*r**8)
            -Q2**9*(-175+3600*r**2+29806*r**4+14726*r**6+40497*r**8+6690*r**10)
            -Q2**8*(-975+7677*r**2+57668*r**4+347020*r**6+275051*r**8+20167*r**10
            +5952*r**12)+2*Q2**7*(-735+3516*r**2+58048*r**4+394604*r**6+628787*r**8
            +278368*r**10+33220*r**12+6048*r**14)-2*Q2**6*(-105-1401*r**2+28864*r**4
            +231932*r**6+716071*r**8+662585*r**10+173784*r**12+20684*r**14+2442*r**16)
            -2*Q2**5*(-615+1920*r**2+3397*r**4+181208*r**6+107031*r**8-138170*r**10
            -204945*r**12-41408*r**14-7972*r**16+1650*r**18)+2*Q2**4*(-525-1225*r**2
            -467*r**4+259743*r**6+678115*r**8+683851*r**10+202441*r**12-60867*r**14
            -91922*r**16-10814*r**18+1670*r**20)+Q2**3*(25+3336*r**2+4353*r**4
            -116700*r**6-764946*r**8-438432*r**10-610162*r**12+6632*r**14+229145*r**16
            +98296*r**18+4817*r**20-364*r**22)+(-1+r**2)**2*(35+325*r**2+5069*r**4
            +15147*r**6-173030*r**8+1062838*r**10-899034*r**12-567734*r**14+919363*r**16
            -96635*r**18+74637*r**20+4619*r**22)+Q2**2*(385-131*r**2+16807*r**4
            -53843*r**6-113856*r**8+136566*r**10-653310*r**12-972954*r**14+1370973*r**16
            -318259*r**18+220439*r**20+22061*r**22-478*r**24)+Q2*(-205-856*r**2
            -17080*r**4+8862*r**6+414155*r**8-1940210*r**10+1759392*r**12-1665420*r**14
            +2380321*r**16-2541380*r**18+476440*r**20-237586*r**22-18975*r**24+142*r**26))
            -16588800*logq2**4*r**16*(-1+3*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            -4608*logq2**2*r**8*(-768*Q2**12*r**2+8*Q2**11*(-10+912*r**2+817*r**4)-Q2**10*(
            -645+28568*r**2+49089*r**4+23248*r**6)+10*Q2**9*(-205+5847*r**2+14353*r**4
            +13073*r**6+4418*r**8)-5*Q2**8*(-585+12434*r**2+38240*r**4+48762*r**6
            +34405*r**8+9528*r**10)+8*Q2**7*(-75+2347*r**2+7895*r**4+9205*r**6
            +16420*r**8+14870*r**10+3747*r**12)+Q2**6*(-3990+33608*r**2+142648*r**4
            +327140*r**6+276810*r**8+22420*r**10-64052*r**12-14952*r**14)+4*Q2**5*(1365
            -11251*r**2-48883*r**4-110476*r**6-115495*r**8-60345*r**10-3051*r**12
            +15412*r**14+2124*r**16)+10*Q2**4*(-195+2018*r**2+8317*r**4+22378*r**6
            +7775*r**8-242*r**10+2003*r**12+10802*r**14-4028*r**16+612*r**18)+(
            -1+r**2)**4*(145-198*r**2-4416*r**4+36566*r**6-21762*r**8+870*r**10
            -10912*r**12+38106*r**14+3249*r**16+1552*r**18)-40*Q2**3*(45-83*r**2
            -550*r**4+3797*r**6-5045*r**8-3442*r**10+632*r**12-1679*r**14+8666*r**16
            -25*r**18+564*r**20)-2*Q2*(-1+r**2)**2*(465-1193*r**2-11484*r**4+74190*r**6
            -36376*r**8+17748*r**10+47898*r**12-26086*r**14+96615*r**16+6381*r**18
            +4642*r**20)+Q2**2*(2225-8608*r**2-39735*r**4+245020*r**6-296790*r**8
            +196660*r**10+244066*r**12+295260*r**14-339995*r**16+368540*r**18+2965*r**20
            +21592*r**22))*sqrtq2+64*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**14
            +Q2**13*(68+46*r**2)-Q2**12*(717+6352*r**2+643*r**4)+4*Q2**11*(396
            +11268*r**2+10829*r**4+624*r**6)-2*Q2**10*(58+56589*r**2+119149*r**4
            +56161*r**6+2343*r**8)+8*Q2**9*(-108+11073*r**2+47052*r**4+49657*r**6
            +13950*r**8+517*r**10)-2*Q2**8*(4593-51766*r**2-53644*r**4-172420*r**6
            +38069*r**8-18162*r**10+66*r**12)-4*Q2**7*(-5736+59893*r**2+194922*r**4
            +677168*r**6+543520*r**8+90437*r**10+41634*r**12+726*r**14)+Q2**6*(
            -13473+107480*r**2+561048*r**4+2817388*r**6+4727966*r**8+2103752*r**10
            +254520*r**12+102468*r**14+1683*r**16)+2*Q2**5*(-6974+47965*r**2-13292*r**4
            +433982*r**6-711268*r**8-1106496*r**10-194620*r**12-70622*r**14+11562*r**16
            +451*r**18)+Q2**4*(21607-110684*r**2+105489*r**4-2865356*r**6-2478042*r**8
            -1628916*r**10+362842*r**12+188764*r**14+348739*r**16-39200*r**18-1243*r**20)
            +4*Q2**3*(-1308+2193*r**2-31247*r**4+295690*r**6+368708*r**8+221166*r**10
            +196538*r**12-111708*r**14-70520*r**16-50223*r**18+1477*r**20+34*r**22)
            +2*(-1+r**2)**2*(-468+1288*r**2-34435*r**4+43936*r**6+292209*r**8-2571552*r**10
            +4429614*r**12-2779872*r**14+519474*r**16-130824*r**18-27595*r**20-992*r**22
            +17*r**24)+2*Q2**2*(-3201+19537*r**2-102987*r**4+272991*r**6-245380*r**8
            +997286*r**10+471654*r**12-1300294*r**14+658859*r**16-247575*r**18-87995*r**20
            -1081*r**22+186*r**24)-4*Q2*(-1166+5788*r**2-64394*r**4+175131*r**6
            +1990*r**8-1021853*r**10-167156*r**12+2846098*r**14-2779082*r**16+685710*r**18
            -147906*r**20-50157*r**22-1454*r**24+51*r**26))*sqrtq2))/(6220800*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +43200*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3-18662400*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            -777600*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2-900*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+(flagPERP*muWC*(552960*logq2**3*(-Q2+(
            -1+r)**2)*r**12*(-Q2+(1+r)**2)*(140*Q2**7*r**2-8*Q2**6*(3+70*r**2+112*r**4)
            +Q2**5*(119+824*r**2+2511*r**4+2226*r**6)-Q2**4*(175+577*r**2+2225*r**4
            +4083*r**6+2380*r**8)+2*Q2**3*(55+14*r**2+394*r**4+966*r**6+1391*r**8
            +140*r**10)+(-1+r**2)**2*(-59+291*r**2-670*r**4+570*r**6+125*r**8
            -141*r**10+364*r**12)+2*Q2**2*(-55+104*r**2-228*r**4+50*r**6+83*r**8
            -714*r**10+840*r**12)-Q2*(-139+472*r**2-1649*r**4+510*r**6+1995*r**8
            +964*r**10-1647*r**12+1414*r**14))+768*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(92*Q2**13*r**2-8*Q2**12*(-25+181*r**2+99*r**4)+Q2**11*(
            -1155+5532*r**2+11661*r**4+2618*r**6)-Q2**10*(-2405+11757*r**2+28821*r**4
            +30239*r**6+3588*r**8)-Q2**9*(1505-24582*r**2+4202*r**4+99752*r**6
            -6755*r**8+550*r**10)+Q2**8*(-1905-47467*r**2+83394*r**4+796330*r**6
            +802611*r**8+108465*r**10+8076*r**12)-2*Q2**7*(-1785-27594*r**2+47299*r**4
            +703138*r**6+1480015*r**8+809198*r**10+98067*r**12+4398*r**14)+Q2**6*(
            -1470-26462*r**2+51498*r**4+946834*r**6+2542418*r**8+3732690*r**10
            +776698*r**12+69258*r**14-456*r**16)+2*Q2**5*(-345-1982*r**2-23174*r**4
            -267006*r**6+412206*r**8+636094*r**10-433582*r**12+779286*r**14+78879*r**16
            +4008*r**18)-2*Q2**4*(-315-2459*r**2-19596*r**4-383216*r**6+647308*r**8
            +2903228*r**10+2863592*r**12+833524*r**14+1142819*r**16+93915*r**18
            +2800*r**20)+Q2**3*(-95+1200*r**2-20719*r**4-457150*r**6+466646*r**8
            +1695680*r**10+6636998*r**12+2066364*r**14+1646985*r**16+601424*r**18
            +34985*r**20-318*r**22)+(-1+r**2)**2*(35+1091*r**2+10121*r**4+9397*r**6
            -188810*r**8+1992938*r**10-2362306*r**12-688058*r**14+1634363*r**16
            -217005*r**18+145337*r**20+8325*r**22+172*r**24)+Q2**2*(105+1835*r**2
            +28675*r**4-85539*r**6-254590*r**8-263966*r**10+1359538*r**12-5454898*r**14
            +5154889*r**16-1650125*r**18+757131*r**20+59157*r**22+2188*r**24)-Q2*(125
            +3270*r**2+26914*r**4-110508*r**6-67465*r**8+1523930*r**10-852740*r**12
            +1607192*r**14-6129829*r**16+6226490*r**18-1484830*r**20+598420*r**22
            +40369*r**24+1062*r**26))+33177600*logq2**4*r**16*(-3+2*r**2+3*r**4)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+9216*logq2**2*r**8*(1512*Q2**12*r**2
            -8*Q2**11*(10+1643*r**2+1803*r**4)+Q2**10*(475+48062*r**2+101811*r**4
            +57072*r**6)-10*Q2**9*(131+9529*r**2+27569*r**4+31173*r**6+11574*r**8)
            +5*Q2**8*(423+23194*r**2+69078*r**4+98922*r**6+89943*r**8+21288*r**10)
            +2*Q2**7*(-780-52247*r**2-83990*r**4+4820*r**6+18870*r**8-106545*r**10
            +14448*r**12)-2*Q2**6*(525-46639*r**2+24786*r**4+370550*r**6+767925*r**8
            +628665*r**10+116676*r**12+89376*r**14)+2*Q2**5*(1470-40037*r**2+58844*r**4
            +366163*r**6+917190*r**8+1191725*r**10+801828*r**12+192549*r**14+86268*r**16)
            +(-1+r**2)**4*(335-748*r**2-7626*r**4+82556*r**6-82852*r**8-3420*r**10
            -24262*r**12+72116*r**14+3909*r**16+3192*r**18)-10*Q2**4*(69-4319*r**2
            +10851*r**4+26111*r**6+83507*r**8+111627*r**10+131245*r**12+42081*r**14
            +21192*r**16+3396*r**18)-10*Q2**3*(324+157*r**2-8746*r**4+9002*r**6
            -34050*r**8-1088*r**10+23014*r**12-58402*r**14+82206*r**16-7461*r**18
            +6564*r**20)-2*Q2*(-1+r**2)**2*(935-2888*r**2-15584*r**4+123620*r**6
            -63896*r**8-60092*r**10+69218*r**12-101636*r**14+207985*r**16+3876*r**18
            +11262*r**20)+Q2**2*(3935-14868*r**2-51295*r**4+306880*r**6-392810*r**8
            +162200*r**10+103426*r**12+734320*r**14-1104805*r**16+939260*r**18-56435*r**20
            +61392*r**22))*sqrtq2-128*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**14*r**2
            +2*Q2**13*(33-76*r**2+r**4)+Q2**12*(-571+743*r**2+4079*r**4-251*r**6)
            +Q2**11*(2133+742*r**2-37120*r**4-25218*r**6+983*r**8)+Q2**10*(-4433
            -5026*r**2+96946*r**4+193578*r**6+59899*r**8-1436*r**10)+Q2**9*(5445
            -9274*r**2-145403*r**4-148308*r**6-274041*r**8-29770*r**10+71*r**12)
            +2*Q2**8*(-1881+28282*r**2+125826*r**4-333010*r**6-841779*r**8-173534*r**10
            -62418*r**12+1218*r**14)+2*Q2**7*(561-41618*r**2-190564*r**4+619678*r**6
            +3049876*r**8+3008310*r**10+685684*r**12+117366*r**14-1389*r**16)+Q2**6*(
            -66+43811*r**2+254404*r**4-686044*r**6-5125052*r**8-11777466*r**10
            -5701324*r**12-1085356*r**14-83274*r**16+159*r**18)+4*Q2**5*(99+733*r**2
            +11859*r**4+38602*r**6+352209*r**8-316158*r**10+2036593*r**12-898926*r**14
            -156808*r**16-41667*r**18+488*r**20)-Q2**4*(495+5033*r**2+138217*r**4
            +97187*r**6+3057050*r**8-7935706*r**10-15860242*r**12+3609522*r**14
            -9616473*r**16-1425791*r**18-189095*r**20+1403*r**22)-Q2**3*(-121+2562*r**2
            -44576*r**4-45110*r**6-2943617*r**8+5162588*r**10+6509696*r**12+13052108*r**14
            -1004435*r**16+3957282*r**18+553248*r**20+29162*r**22+13*r**24)+2*(
            -1+r**2)**2*(6-741*r**2-1089*r**4-46960*r**6+41661*r**8+368027*r**10
            -4503046*r**12+8820368*r**14-5940772*r**16+1383449*r**18-339673*r**20
            -36928*r**22-3519*r**24+17*r**26)+Q2**2*(99-3032*r**2+6754*r**4-151910*r**6
            +372617*r**8+2142070*r**10-5660852*r**12+15475692*r**14-16815179*r**16
            +8424028*r**18-2586094*r**20-281286*r**22-59361*r**24+454*r**26)+Q2*(
            -67+5022*r**2-4779*r**4+233532*r**6-1014987*r**8+2668434*r**10-4804579*r**12
            +25050728*r**14-49323649*r**16+37997154*r**18-11525017*r**20+2480732*r**22
            +273551*r**24+37742*r**26-217*r**28))*sqrtq2))/(18662400*logq2**3*(-Q2
            +(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+129600*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-55987200*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-2332800*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-2700*(-Q2+(-1
            +r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(flagPERP*muWC**2*(69120*logq2**3*(-Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)*(140*Q2**7*r**2
            -8*Q2**6*(3+70*r**2+112*r**4)+Q2**5*(119+824*r**2+2511*r**4+2226*r**6)
            -Q2**4*(175+577*r**2+2225*r**4+4083*r**6+2380*r**8)+2*Q2**3*(55+14*r**2
            +394*r**4+966*r**6+1391*r**8+140*r**10)+(-1+r**2)**2*(-59+291*r**2
            -670*r**4+570*r**6+125*r**8-141*r**10+364*r**12)+2*Q2**2*(-55+104*r**2
            -228*r**4+50*r**6+83*r**8-714*r**10+840*r**12)-Q2*(-139+472*r**2
            -1649*r**4+510*r**6+1995*r**8+964*r**10-1647*r**12+1414*r**14))+96*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(92*Q2**13*r**2-8*Q2**12*(-25+181*r**2
            +99*r**4)+Q2**11*(-1155+5532*r**2+11661*r**4+2618*r**6)-Q2**10*(-2405
            +11757*r**2+28821*r**4+30239*r**6+3588*r**8)-Q2**9*(1505-24582*r**2
            +4202*r**4+99752*r**6-6755*r**8+550*r**10)+Q2**8*(-1905-47467*r**2
            +83394*r**4+796330*r**6+802611*r**8+108465*r**10+8076*r**12)-2*Q2**7*(
            -1785-27594*r**2+47299*r**4+703138*r**6+1480015*r**8+809198*r**10+98067*r**12
            +4398*r**14)+Q2**6*(-1470-26462*r**2+51498*r**4+946834*r**6+2542418*r**8
            +3732690*r**10+776698*r**12+69258*r**14-456*r**16)+2*Q2**5*(-345-1982*r**2
            -23174*r**4-267006*r**6+412206*r**8+636094*r**10-433582*r**12+779286*r**14
            +78879*r**16+4008*r**18)-2*Q2**4*(-315-2459*r**2-19596*r**4-383216*r**6
            +647308*r**8+2903228*r**10+2863592*r**12+833524*r**14+1142819*r**16
            +93915*r**18+2800*r**20)+Q2**3*(-95+1200*r**2-20719*r**4-457150*r**6
            +466646*r**8+1695680*r**10+6636998*r**12+2066364*r**14+1646985*r**16
            +601424*r**18+34985*r**20-318*r**22)+(-1+r**2)**2*(35+1091*r**2+10121*r**4
            +9397*r**6-188810*r**8+1992938*r**10-2362306*r**12-688058*r**14+1634363*r**16
            -217005*r**18+145337*r**20+8325*r**22+172*r**24)+Q2**2*(105+1835*r**2
            +28675*r**4-85539*r**6-254590*r**8-263966*r**10+1359538*r**12-5454898*r**14
            +5154889*r**16-1650125*r**18+757131*r**20+59157*r**22+2188*r**24)-Q2*(125
            +3270*r**2+26914*r**4-110508*r**6-67465*r**8+1523930*r**10-852740*r**12
            +1607192*r**14-6129829*r**16+6226490*r**18-1484830*r**20+598420*r**22
            +40369*r**24+1062*r**26))+4147200*logq2**4*r**16*(-3+2*r**2+3*r**4)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+1152*logq2**2*r**8*(1512*Q2**12*r**2
            -8*Q2**11*(10+1643*r**2+1803*r**4)+Q2**10*(475+48062*r**2+101811*r**4
            +57072*r**6)-10*Q2**9*(131+9529*r**2+27569*r**4+31173*r**6+11574*r**8)
            +5*Q2**8*(423+23194*r**2+69078*r**4+98922*r**6+89943*r**8+21288*r**10)
            +2*Q2**7*(-780-52247*r**2-83990*r**4+4820*r**6+18870*r**8-106545*r**10
            +14448*r**12)-2*Q2**6*(525-46639*r**2+24786*r**4+370550*r**6+767925*r**8
            +628665*r**10+116676*r**12+89376*r**14)+2*Q2**5*(1470-40037*r**2+58844*r**4
            +366163*r**6+917190*r**8+1191725*r**10+801828*r**12+192549*r**14+86268*r**16)
            +(-1+r**2)**4*(335-748*r**2-7626*r**4+82556*r**6-82852*r**8-3420*r**10
            -24262*r**12+72116*r**14+3909*r**16+3192*r**18)-10*Q2**4*(69-4319*r**2
            +10851*r**4+26111*r**6+83507*r**8+111627*r**10+131245*r**12+42081*r**14
            +21192*r**16+3396*r**18)-10*Q2**3*(324+157*r**2-8746*r**4+9002*r**6
            -34050*r**8-1088*r**10+23014*r**12-58402*r**14+82206*r**16-7461*r**18
            +6564*r**20)-2*Q2*(-1+r**2)**2*(935-2888*r**2-15584*r**4+123620*r**6
            -63896*r**8-60092*r**10+69218*r**12-101636*r**14+207985*r**16+3876*r**18
            +11262*r**20)+Q2**2*(3935-14868*r**2-51295*r**4+306880*r**6-392810*r**8
            +162200*r**10+103426*r**12+734320*r**14-1104805*r**16+939260*r**18-56435*r**20
            +61392*r**22))*sqrtq2-16*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**14*r**2
            +2*Q2**13*(33-76*r**2+r**4)+Q2**12*(-571+743*r**2+4079*r**4-251*r**6)
            +Q2**11*(2133+742*r**2-37120*r**4-25218*r**6+983*r**8)+Q2**10*(-4433
            -5026*r**2+96946*r**4+193578*r**6+59899*r**8-1436*r**10)+Q2**9*(5445
            -9274*r**2-145403*r**4-148308*r**6-274041*r**8-29770*r**10+71*r**12)
            +2*Q2**8*(-1881+28282*r**2+125826*r**4-333010*r**6-841779*r**8-173534*r**10
            -62418*r**12+1218*r**14)+2*Q2**7*(561-41618*r**2-190564*r**4+619678*r**6
            +3049876*r**8+3008310*r**10+685684*r**12+117366*r**14-1389*r**16)+Q2**6*(
            -66+43811*r**2+254404*r**4-686044*r**6-5125052*r**8-11777466*r**10
            -5701324*r**12-1085356*r**14-83274*r**16+159*r**18)+4*Q2**5*(99+733*r**2
            +11859*r**4+38602*r**6+352209*r**8-316158*r**10+2036593*r**12-898926*r**14
            -156808*r**16-41667*r**18+488*r**20)-Q2**4*(495+5033*r**2+138217*r**4
            +97187*r**6+3057050*r**8-7935706*r**10-15860242*r**12+3609522*r**14
            -9616473*r**16-1425791*r**18-189095*r**20+1403*r**22)-Q2**3*(-121+2562*r**2
            -44576*r**4-45110*r**6-2943617*r**8+5162588*r**10+6509696*r**12+13052108*r**14
            -1004435*r**16+3957282*r**18+553248*r**20+29162*r**22+13*r**24)+2*(
            -1+r**2)**2*(6-741*r**2-1089*r**4-46960*r**6+41661*r**8+368027*r**10
            -4503046*r**12+8820368*r**14-5940772*r**16+1383449*r**18-339673*r**20
            -36928*r**22-3519*r**24+17*r**26)+Q2**2*(99-3032*r**2+6754*r**4-151910*r**6
            +372617*r**8+2142070*r**10-5660852*r**12+15475692*r**14-16815179*r**16
            +8424028*r**18-2586094*r**20-281286*r**22-59361*r**24+454*r**26)+Q2*(
            -67+5022*r**2-4779*r**4+233532*r**6-1014987*r**8+2668434*r**10-4804579*r**12
            +25050728*r**14-49323649*r**16+37997154*r**18-11525017*r**20+2480732*r**22
            +273551*r**24+37742*r**26-217*r**28))*sqrtq2))/(6220800*logq2**3*(-Q2+(
            -1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+43200*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-18662400*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-777600*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-900*(-Q2+(-1
            +r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(muWC**2*(-69120*logq2**3*r**10*(20*Q2**9*(3+35*r**4)-24*Q2**8*(13+31*r**2
            +195*r**4+245*r**6)+Q2**7*(561+3183*r**2+14117*r**4+28285*r**6+20790*r**8)
            -Q2**6*(261+4962*r**2+18436*r**4+49542*r**6+65215*r**8+38640*r**10)
            +3*Q2**5*(79+1041*r**2+2054*r**4+11700*r**6+20173*r**8+21195*r**10
            +12110*r**12)+(-1+r**2)**4*(-627-186*r**2-1181*r**4+3424*r**6+7779*r**8
            -4034*r**10+1645*r**12+1820*r**14)-Q2**4*(2625+2490*r**2-1373*r**4
            +9664*r**6+19295*r**8+22570*r**10+9725*r**12+6300*r**14)+Q2**3*(6147
            +3909*r**2+15113*r**4+8709*r**6-44529*r**8-17033*r**10+16299*r**12
            -20545*r**14-22470*r**16)-Q2*(-1+r**2)**2*(-3171-1599*r**2-9791*r**4
            +6599*r**6+47789*r**8+29055*r**10-17377*r**12+6905*r**14+10710*r**16)
            +3*Q2**2*(-2117+134*r**2-6638*r**4+918*r**6+17288*r**8+22490*r**10
            +19054*r**12-12974*r**14-195*r**16+8120*r**18))-96*logq2*(-Q2+(-1
            +r)**2)*r**2*(-Q2+(1+r)**2)*(460*Q2**15*(1+r**4)-16*Q2**14*(271+180*r**2
            +122*r**4+305*r**6)+Q2**13*(17591+22381*r**2-321*r**4+23239*r**6+21470*r**8)
            -Q2**12*(38997+71154*r**2-13660*r**4-63114*r**6+81103*r**8+48080*r**10)
            +2*Q2**11*(23765+57106*r**2-87123*r**4-259071*r**6-496416*r**8+981*r**10
            +23110*r**12)+Q2**10*(-21098-85754*r**2+994664*r**4+2585400*r**6+5438766*r**8
            +5928510*r**10+693684*r**12+27940*r**14)-Q2**9*(23023-3905*r**2+2624031*r**4
            +8486141*r**6+17216595*r**8+22887189*r**10+16387405*r**12+1976671*r**14
            +127490*r**16)+Q2**8*(38973+44328*r**2+3555492*r**4+14690164*r**6+32124314*r**8
            +44264612*r**10+41459860*r**12+20832372*r**14+2349777*r**16+126060*r**18)
            +4*Q2**7*(-3894-15588*r**2-587010*r**4-3211417*r**6-6820541*r**8-8121137*r**10
            -6493533*r**12-6089925*r**14-598707*r**16-118221*r**18+165*r**20)-4*Q2**6*(2695
            -24699*r**2-102968*r**4-1439568*r**6-2418516*r**8+4240474*r**10+14185204*r**12
            +16406922*r**14+5039017*r**16+6929869*r**18+525096*r**20+27610*r**22)
            +Q2**5*(13321-98337*r**2+325217*r**4-2538339*r**6-10704756*r**8+19868014*r**10
            +76736378*r**12+124345850*r**14+112154161*r**16+31357139*r**18+34323525*r**20
            +2523977*r**22+94490*r**24)+(-1+r**2)**4*(67-3016*r**2-86182*r**4+187460*r**6
            -4240939*r**8+8589228*r**10+11184140*r**12-21309512*r**14+4377165*r**16
            +7013824*r**18-299110*r**20+767236*r**22+39579*r**24+860*r**26)-Q2**4*(2891
            -17150*r**2+463692*r**4-1938706*r**6-6680745*r**8+7665124*r**10+16301560*r**12
            +46186676*r**14+46009841*r**16+33899490*r**18+9837340*r**20+11568990*r**22
            +824077*r**24+13880*r**26)-Q2*(-1+r**2)**2*(625-20817*r**2-451058*r**4
            +754596*r**6-20346823*r**8+25302751*r**10+43934394*r**12+5449240*r**14
            -59204389*r**16+12569813*r**18+40659394*r**20-3942332*r**22+4784763*r**24
            +269213*r**26+7030*r**28)-2*Q2**3*(1407-28758*r**2-418177*r**4+630759*r**6
            -10776718*r**8-5102761*r**10-3226520*r**12-4555646*r**14-12056017*r**16
            +9171908*r**18+33983459*r**20-3637097*r**22+4689888*r**24+295483*r**26
            +14390*r**28)+2*Q2**2*(1099-28297*r**2-430260*r**4+858932*r**6-18013339*r**8
            +19754877*r**10+7416014*r**12+17072930*r**14+33297381*r**16-33482847*r**18
            -19832016*r**20+46290528*r**22-8955925*r**24+5468907*r**26+337206*r**28
            +11210*r**30))-4147200*logq2**4*r**14*(-15-15*r**2+65*r**4+r**6)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-1152*logq2**2*r**6*(8*Q2**12*(193
            +945*r**4)-8*Q2**11*(1731+1931*r**2+6385*r**4+9015*r**6)+Q2**10*(51399
            +109687*r**2+234449*r**4+387745*r**6+285360*r**8)-10*Q2**9*(10145+30640*r**2
            +70388*r**4+111170*r**6+113683*r**8+57870*r**10)+5*Q2**8*(22347+85581*r**2
            +224830*r**4+349498*r**6+340743*r**8+292273*r**10+106440*r**12)+2*Q2**7*(
            -31284-157260*r**2-426345*r**4-385710*r**6+302560*r**8+603306*r**10
            -124595*r**12+72240*r**14)-2*Q2**6*(-4263-68103*r**2-167270*r**4+449000*r**6
            +2280375*r**8+4211027*r**10+3566302*r**12+773780*r**14+446880*r**16)
            +2*Q2**5*(5346-36372*r**2-116849*r**4+198270*r**6+1720655*r**8+4465656*r**10
            +5477193*r**12+4269906*r**14+904855*r**16+431340*r**18)+(-1+r**2)**4*(
            -1741-2607*r**2-178458*r**4+135506*r**6+623940*r**8-23244*r**10-347518*r**12
            +96558*r**14+428169*r**16+31035*r**18+15960*r**20)-10*Q2**4*(1845-4545*r**2
            +27477*r**4-15049*r**6+57223*r**8+295849*r**10+476539*r**12+217797*r**14
            +203520*r**16+73852*r**18+16980*r**20)-10*Q2**3*(-2824+888*r**2-139405*r**4
            -59682*r**6-129706*r**8+5026*r**10+188268*r**12-275562*r**14+267234*r**16
            +478654*r**18-8591*r**20+32820*r**22)-2*Q2*(-1+r**2)**2*(-5211-4618*r**2
            -446170*r**4+55818*r**6+976656*r**8+976256*r**10+855378*r**12-778560*r**14
            +152027*r**16+1219914*r**18+52600*r**20+56310*r**22)+Q2**2*(-24501+5995*r**2
            -1684445*r**4+620575*r**6+582290*r**8+1930802*r**10+5367610*r**12+6460130*r**14
            -3949405*r**16-2403245*r**18+5337619*r**20-108785*r**22+306960*r**24))*sqrtq2
            +16*r**2*(8*Q2**19-Q2**18*(139+35*r**2)+6*Q2**17*(-1+10*r**2+31*r**4)
            +Q2**16*(16715+3669*r**2+18225*r**4-2345*r**6)+Q2**15*(-142133-88278*r**2
            -73236*r**4-174890*r**6+14681*r**8)+Q2**14*(569185+539307*r**2+24522*r**4
            +531726*r**6+765861*r**8-48489*r**10)+Q2**13*(-1311069-1538650*r**2
            +612251*r**4+1607560*r**6-1342427*r**8-1760622*r**10+90685*r**12)-Q2**12*(
            -1748057-2475511*r**2+3954197*r**4+12772979*r**6+16541441*r**8+1374287*r**10
            -1593901*r**12+82693*r**14)+Q2**11*(-1003081-2848542*r**2+15955794*r**4
            +50292290*r**6+87397284*r**8+83128158*r**10+15784590*r**12+2227326*r**14
            -20475*r**16)+Q2**10*(-694617+3810841*r**2-40218036*r**4-133919964*r**6
            -255246234*r**8-298404454*r**10-218606172*r**12-38889268*r**14-8622669*r**16
            +151437*r**18)+Q2**9*(1770131-5507754*r**2+62442081*r**4+212605108*r**6
            +428295358*r**8+556569048*r**10+480581186*r**12+288617036*r**14+43121903*r**16
            +10786578*r**18-171171*r**20)+Q2**8*(-1242645+4338885*r**2-56430357*r**4
            -188549475*r**6-350031086*r**8-383702898*r**10-362374190*r**12-262980802*r**14
            -78738765*r**16-7135491*r**18-4023789*r**20+51285*r**22)+Q2**7*(20929
            +1145598*r**2+20384376*r**4+106707578*r**6+131404097*r**8-158113380*r**10
            -473696344*r**12-452423900*r**14-132429277*r**16-324916538*r**18-40933728*r**20
            -5821182*r**22+75803*r**24)+Q2**6*(536267-5337303*r**2+14149482*r**4
            -89332690*r**6-72740463*r**8+275064171*r**10+637447324*r**12+922524340*r**14
            +954541565*r**16+22426927*r**18+497413914*r**20+52267518*r**22+8876423*r**24
            -94115*r**26)+2*(-1+r**2)**6*(-329+21211*r**2+186987*r**4-1086705*r**6
            +10674994*r**8-32731582*r**10+16666274*r**12+24787658*r**14-27616177*r**16
            +6837811*r**18-2226509*r**20-161305*r**22-18040*r**24+112*r**26)-Q2*(
            -1+r**2)**4*(-8599+374478*r**2+2286957*r**4-8419456*r**6+112534141*r**8
            -238203290*r**10-169825743*r**12+331002240*r**14+148593867*r**16-348405686*r**18
            +96751959*r**20-35792640*r**22-2528177*r**24-336766*r**26+2315*r**28)
            +Q2**5*(-312967+3606642*r**2-23368875*r**4+96648768*r**6-28452695*r**8
            -200421918*r**10-168970163*r**12-297470352*r**14-8219709*r**16-706256586*r**18
            +315891047*r**20-259179312*r**22-24592101*r**24-4197642*r**26+33783*r**28)
            +2*Q2**2*(-1+r**2)**2*(-20740+676723*r**2+2626266*r**4-6237503*r**6+135107650*r**8
            -215656259*r**10-160688156*r**12-95517521*r**14+350483848*r**16+149546093*r**18
            -473731158*r**20+151318303*r**22-57380550*r**24-3834525*r**26-646248*r**28
            +4977*r**30)+Q2**4*(-5949+624397*r**2+15323797*r**4-57108109*r**6+272124331*r**8
            +53550565*r**10-23990779*r**12+40043811*r**14+487390513*r**16-725444417*r**18
            -121085593*r**20-62545743*r**22-68122783*r**24-3262129*r**26-1042689*r**28
            +14777*r**30)+Q2**3*(84853-2298250*r**2-6742294*r**4+23575790*r**6-376779662*r**8
            +545105734*r**10+70427890*r**12-24453682*r**14+913696380*r**16-975697006*r**18
            -546780962*r**20+1266182170*r**22-472839074*r**24+171454130*r**26+9902918*r**28
            +2379050*r**30-21185*r**32))*sqrtq2))/(18662400*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+129600*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-55987200*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-2332800*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-2700*(-Q2+(-1
            +r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(muWC*(-552960*logq2**3*r**10*(20*Q2**9*(3+35*r**4)-24*Q2**8*(13+31*r**2
            +195*r**4+245*r**6)+Q2**7*(561+3183*r**2+14117*r**4+28285*r**6+20790*r**8)
            -Q2**6*(261+4962*r**2+18436*r**4+49542*r**6+65215*r**8+38640*r**10)
            +3*Q2**5*(79+1041*r**2+2054*r**4+11700*r**6+20173*r**8+21195*r**10
            +12110*r**12)+(-1+r**2)**4*(-627-186*r**2-1181*r**4+3424*r**6+7779*r**8
            -4034*r**10+1645*r**12+1820*r**14)-Q2**4*(2625+2490*r**2-1373*r**4
            +9664*r**6+19295*r**8+22570*r**10+9725*r**12+6300*r**14)+Q2**3*(6147
            +3909*r**2+15113*r**4+8709*r**6-44529*r**8-17033*r**10+16299*r**12
            -20545*r**14-22470*r**16)-Q2*(-1+r**2)**2*(-3171-1599*r**2-9791*r**4
            +6599*r**6+47789*r**8+29055*r**10-17377*r**12+6905*r**14+10710*r**16)
            +3*Q2**2*(-2117+134*r**2-6638*r**4+918*r**6+17288*r**8+22490*r**10
            +19054*r**12-12974*r**14-195*r**16+8120*r**18))-768*logq2*(-Q2+(-1
            +r)**2)*r**2*(-Q2+(1+r)**2)*(460*Q2**15*(1+r**4)-16*Q2**14*(271+180*r**2
            +122*r**4+305*r**6)+Q2**13*(17591+22381*r**2-321*r**4+23239*r**6+21470*r**8)
            -Q2**12*(38997+71154*r**2-13660*r**4-63114*r**6+81103*r**8+48080*r**10)
            +2*Q2**11*(23765+57106*r**2-87123*r**4-259071*r**6-496416*r**8+981*r**10
            +23110*r**12)+Q2**10*(-21098-85754*r**2+994664*r**4+2585400*r**6+5438766*r**8
            +5928510*r**10+693684*r**12+27940*r**14)-Q2**9*(23023-3905*r**2+2624031*r**4
            +8486141*r**6+17216595*r**8+22887189*r**10+16387405*r**12+1976671*r**14
            +127490*r**16)+Q2**8*(38973+44328*r**2+3555492*r**4+14690164*r**6+32124314*r**8
            +44264612*r**10+41459860*r**12+20832372*r**14+2349777*r**16+126060*r**18)
            +4*Q2**7*(-3894-15588*r**2-587010*r**4-3211417*r**6-6820541*r**8-8121137*r**10
            -6493533*r**12-6089925*r**14-598707*r**16-118221*r**18+165*r**20)-4*Q2**6*(2695
            -24699*r**2-102968*r**4-1439568*r**6-2418516*r**8+4240474*r**10+14185204*r**12
            +16406922*r**14+5039017*r**16+6929869*r**18+525096*r**20+27610*r**22)
            +Q2**5*(13321-98337*r**2+325217*r**4-2538339*r**6-10704756*r**8+19868014*r**10
            +76736378*r**12+124345850*r**14+112154161*r**16+31357139*r**18+34323525*r**20
            +2523977*r**22+94490*r**24)+(-1+r**2)**4*(67-3016*r**2-86182*r**4+187460*r**6
            -4240939*r**8+8589228*r**10+11184140*r**12-21309512*r**14+4377165*r**16
            +7013824*r**18-299110*r**20+767236*r**22+39579*r**24+860*r**26)-Q2**4*(2891
            -17150*r**2+463692*r**4-1938706*r**6-6680745*r**8+7665124*r**10+16301560*r**12
            +46186676*r**14+46009841*r**16+33899490*r**18+9837340*r**20+11568990*r**22
            +824077*r**24+13880*r**26)-Q2*(-1+r**2)**2*(625-20817*r**2-451058*r**4
            +754596*r**6-20346823*r**8+25302751*r**10+43934394*r**12+5449240*r**14
            -59204389*r**16+12569813*r**18+40659394*r**20-3942332*r**22+4784763*r**24
            +269213*r**26+7030*r**28)-2*Q2**3*(1407-28758*r**2-418177*r**4+630759*r**6
            -10776718*r**8-5102761*r**10-3226520*r**12-4555646*r**14-12056017*r**16
            +9171908*r**18+33983459*r**20-3637097*r**22+4689888*r**24+295483*r**26
            +14390*r**28)+2*Q2**2*(1099-28297*r**2-430260*r**4+858932*r**6-18013339*r**8
            +19754877*r**10+7416014*r**12+17072930*r**14+33297381*r**16-33482847*r**18
            -19832016*r**20+46290528*r**22-8955925*r**24+5468907*r**26+337206*r**28
            +11210*r**30))-33177600*logq2**4*r**14*(-15-15*r**2+65*r**4+r**6)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-9216*logq2**2*r**6*(8*Q2**12*(193
            +945*r**4)-8*Q2**11*(1731+1931*r**2+6385*r**4+9015*r**6)+Q2**10*(51399
            +109687*r**2+234449*r**4+387745*r**6+285360*r**8)-10*Q2**9*(10145+30640*r**2
            +70388*r**4+111170*r**6+113683*r**8+57870*r**10)+5*Q2**8*(22347+85581*r**2
            +224830*r**4+349498*r**6+340743*r**8+292273*r**10+106440*r**12)+2*Q2**7*(
            -31284-157260*r**2-426345*r**4-385710*r**6+302560*r**8+603306*r**10
            -124595*r**12+72240*r**14)-2*Q2**6*(-4263-68103*r**2-167270*r**4+449000*r**6
            +2280375*r**8+4211027*r**10+3566302*r**12+773780*r**14+446880*r**16)
            +2*Q2**5*(5346-36372*r**2-116849*r**4+198270*r**6+1720655*r**8+4465656*r**10
            +5477193*r**12+4269906*r**14+904855*r**16+431340*r**18)+(-1+r**2)**4*(
            -1741-2607*r**2-178458*r**4+135506*r**6+623940*r**8-23244*r**10-347518*r**12
            +96558*r**14+428169*r**16+31035*r**18+15960*r**20)-10*Q2**4*(1845-4545*r**2
            +27477*r**4-15049*r**6+57223*r**8+295849*r**10+476539*r**12+217797*r**14
            +203520*r**16+73852*r**18+16980*r**20)-10*Q2**3*(-2824+888*r**2-139405*r**4
            -59682*r**6-129706*r**8+5026*r**10+188268*r**12-275562*r**14+267234*r**16
            +478654*r**18-8591*r**20+32820*r**22)-2*Q2*(-1+r**2)**2*(-5211-4618*r**2
            -446170*r**4+55818*r**6+976656*r**8+976256*r**10+855378*r**12-778560*r**14
            +152027*r**16+1219914*r**18+52600*r**20+56310*r**22)+Q2**2*(-24501+5995*r**2
            -1684445*r**4+620575*r**6+582290*r**8+1930802*r**10+5367610*r**12+6460130*r**14
            -3949405*r**16-2403245*r**18+5337619*r**20-108785*r**22+306960*r**24))*sqrtq2
            +128*r**2*(8*Q2**19-Q2**18*(139+35*r**2)+6*Q2**17*(-1+10*r**2+31*r**4)
            +Q2**16*(16715+3669*r**2+18225*r**4-2345*r**6)+Q2**15*(-142133-88278*r**2
            -73236*r**4-174890*r**6+14681*r**8)+Q2**14*(569185+539307*r**2+24522*r**4
            +531726*r**6+765861*r**8-48489*r**10)+Q2**13*(-1311069-1538650*r**2
            +612251*r**4+1607560*r**6-1342427*r**8-1760622*r**10+90685*r**12)-Q2**12*(
            -1748057-2475511*r**2+3954197*r**4+12772979*r**6+16541441*r**8+1374287*r**10
            -1593901*r**12+82693*r**14)+Q2**11*(-1003081-2848542*r**2+15955794*r**4
            +50292290*r**6+87397284*r**8+83128158*r**10+15784590*r**12+2227326*r**14
            -20475*r**16)+Q2**10*(-694617+3810841*r**2-40218036*r**4-133919964*r**6
            -255246234*r**8-298404454*r**10-218606172*r**12-38889268*r**14-8622669*r**16
            +151437*r**18)+Q2**9*(1770131-5507754*r**2+62442081*r**4+212605108*r**6
            +428295358*r**8+556569048*r**10+480581186*r**12+288617036*r**14+43121903*r**16
            +10786578*r**18-171171*r**20)+Q2**8*(-1242645+4338885*r**2-56430357*r**4
            -188549475*r**6-350031086*r**8-383702898*r**10-362374190*r**12-262980802*r**14
            -78738765*r**16-7135491*r**18-4023789*r**20+51285*r**22)+Q2**7*(20929
            +1145598*r**2+20384376*r**4+106707578*r**6+131404097*r**8-158113380*r**10
            -473696344*r**12-452423900*r**14-132429277*r**16-324916538*r**18-40933728*r**20
            -5821182*r**22+75803*r**24)+Q2**6*(536267-5337303*r**2+14149482*r**4
            -89332690*r**6-72740463*r**8+275064171*r**10+637447324*r**12+922524340*r**14
            +954541565*r**16+22426927*r**18+497413914*r**20+52267518*r**22+8876423*r**24
            -94115*r**26)+2*(-1+r**2)**6*(-329+21211*r**2+186987*r**4-1086705*r**6
            +10674994*r**8-32731582*r**10+16666274*r**12+24787658*r**14-27616177*r**16
            +6837811*r**18-2226509*r**20-161305*r**22-18040*r**24+112*r**26)-Q2*(
            -1+r**2)**4*(-8599+374478*r**2+2286957*r**4-8419456*r**6+112534141*r**8
            -238203290*r**10-169825743*r**12+331002240*r**14+148593867*r**16-348405686*r**18
            +96751959*r**20-35792640*r**22-2528177*r**24-336766*r**26+2315*r**28)
            +Q2**5*(-312967+3606642*r**2-23368875*r**4+96648768*r**6-28452695*r**8
            -200421918*r**10-168970163*r**12-297470352*r**14-8219709*r**16-706256586*r**18
            +315891047*r**20-259179312*r**22-24592101*r**24-4197642*r**26+33783*r**28)
            +2*Q2**2*(-1+r**2)**2*(-20740+676723*r**2+2626266*r**4-6237503*r**6+135107650*r**8
            -215656259*r**10-160688156*r**12-95517521*r**14+350483848*r**16+149546093*r**18
            -473731158*r**20+151318303*r**22-57380550*r**24-3834525*r**26-646248*r**28
            +4977*r**30)+Q2**4*(-5949+624397*r**2+15323797*r**4-57108109*r**6+272124331*r**8
            +53550565*r**10-23990779*r**12+40043811*r**14+487390513*r**16-725444417*r**18
            -121085593*r**20-62545743*r**22-68122783*r**24-3262129*r**26-1042689*r**28
            +14777*r**30)+Q2**3*(84853-2298250*r**2-6742294*r**4+23575790*r**6-376779662*r**8
            +545105734*r**10+70427890*r**12-24453682*r**14+913696380*r**16-975697006*r**18
            -546780962*r**20+1266182170*r**22-472839074*r**24+171454130*r**26+9902918*r**28
            +2379050*r**30-21185*r**32))*sqrtq2))/(55987200*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+388800*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-167961600*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-6998400*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-8100*(-Q2+(-1
            +r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(276480*logq2**3*r**10*(-40*Q2**9*(2+5*r**4)+12*Q2**8*(64+67*r**2+136*r**4
            +95*r**6)-Q2**7*(2964+5561*r**2+8098*r**4+6581*r**6+2220*r**8)+Q2**6*(5844
            +14257*r**2+21265*r**4+17957*r**6+8131*r**8+1170*r**10)+3*Q2**5*(-1916
            -5405*r**2-8132*r**4-7670*r**6-3686*r**8-969*r**10+170*r**12)+(-1
            +r**2)**4*(-292-63*r**2+219*r**4-1566*r**6-726*r**8-1939*r**10+927*r**12
            +1040*r**14)+Q2**4*(1140+6475*r**2+7793*r**4+7904*r**6+3952*r**8+765*r**10
            +4555*r**12+3000*r**14)+Q2**3*(3492+721*r**2+2986*r**4+9717*r**6+7496*r**8
            +2139*r**10+1786*r**12-9857*r**14-9840*r**16)-Q2*(-1+r**2)**2*(-1716
            -295*r**2+218*r**4-9511*r**6-6446*r**8-5565*r**10-5586*r**12+4331*r**14
            +5370*r**16)+3*Q2**2*(-1292+517*r**2-203*r**4-5559*r**6-5197*r**8-1035*r**10
            -389*r**12-3849*r**14+617*r**16+3590*r**18))+384*logq2*(-Q2+(-1+r)**2)*r**4*(
            -Q2+(1+r)**2)*(-920*Q2**15*r**2+12*Q2**14*(-21+572*r**2+875*r**4)-Q2**13*(
            -1777+15074*r**2+71179*r**4+49780*r**6)+Q2**12*(-6251-14031*r**2+152445*r**4
            +268743*r**6+125990*r**8)-2*Q2**11*(-8682-97004*r**2-16530*r**4+60605*r**6
            +213422*r**8+86745*r**10)+2*Q2**10*(-20834-359512*r**2-565088*r**4-1099907*r**6
            -902725*r**8+20323*r**10+45695*r**12)+Q2**9*(70829+1518062*r**2+3608013*r**4
            +8193770*r**6+10788755*r**8+6288442*r**10+887307*r**12+86550*r**14)
            -Q2**8*(63459+1638207*r**2+5613479*r**4+13214831*r**6+22101185*r**8
            +19188625*r**10+8760689*r**12+1407777*r**14+175140*r**16)+4*Q2**7*(-1452
            +14538*r**2+905932*r**4+839501*r**6+3378670*r**8+4764103*r**10+3308128*r**12
            +1411297*r**14+260406*r**16+23205*r**18)+4*Q2**6*(19833+533126*r**2
            +225187*r**4+5699857*r**6+6882087*r**8+3697281*r**10-485709*r**12-159383*r**14
            -474518*r**16-132273*r**18+6320*r**20)+(-1+r**2)**4*(-1073-49561*r**2
            +115245*r**4-1761603*r**6+3348914*r**8+5096322*r**10-13337610*r**12
            -192490*r**14+4701183*r**16-47209*r**18+377181*r**20+22701*r**22)-Q2**5*(78309
            +2456262*r**2+2377025*r**4+35941784*r**6+52714602*r**8+45469332*r**10
            +19261698*r**12-6198560*r**14+3017089*r**16-1235098*r**18-315603*r**20
            +51720*r**22)+Q2**4*(18623+737699*r**2+1226687*r**4+15703665*r**6+25181300*r**8
            +11722222*r**10+16169542*r**12+8552418*r**14-7153185*r**16+2546655*r**18
            +332235*r**20-37571*r**22+17950*r**24)+Q2*(-1+r**2)**2*(7879+327496*r**2
            -760920*r**4+10198826*r**6-14172357*r**8-19970218*r**10+27758320*r**12
            +36551564*r**14-1568011*r**16-23072868*r**18+642664*r**20-1981366*r**22
            -137719*r**24+710*r**26)+2*Q2**3*(11566+369228*r**2-768346*r**4+6964643*r**6
            -4278730*r**8+7141235*r**10+5662748*r**12+2859738*r**14-9404478*r**16
            -10703210*r**18-497026*r**20-1705981*r**22-146022*r**24+1835*r**26)
            -2*Q2**2*(11058+404348*r**2-1137176*r**4+11128991*r**6-16256715*r**8
            -681471*r**10+7933849*r**12+9227002*r**14+16663368*r**16+6465490*r**18
            -19687282*r**20+1799783*r**22-1889071*r**24-160079*r**26+1905*r**28))
            +16588800*logq2**4*r**14*(-6-5*r**2+r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2+4608*logq2**2*r**6*(-16*Q2**12*(47+240*r**4)+8*Q2**11*(838
            +703*r**2+3800*r**4+4085*r**6)-Q2**10*(24862+39031*r**2+127212*r**4
            +206395*r**6+116240*r**8)+10*Q2**9*(4714+10743*r**2+31431*r**4+59787*r**6
            +54723*r**8+22090*r**10)-5*Q2**8*(7878+27663*r**2+68260*r**4+169030*r**6
            +196662*r**8+137147*r**10+47640*r**12)+4*Q2**7*(-3804+13560*r**2-77510*r**4
            -50645*r**6+31470*r**8+108321*r**10+89030*r**12+37470*r**14)+2*Q2**6*(34146
            +33621*r**2+742550*r**4+1383580*r**6+1430620*r**8+697981*r**10+72556*r**12
            +5110*r**14-37380*r**16)+4*Q2**5*(-15114-23877*r**2-457679*r**4-955300*r**6
            -1105430*r**8-759479*r**10-192147*r**12+54936*r**14-16330*r**16+10620*r**18)
            +10*Q2**4*(906+5697*r**2+59974*r**4+168425*r**6+146418*r**8+121827*r**10
            +61098*r**12+42967*r**14+22608*r**16+7052*r**18+3060*r**20)+(-1+r**2)**4*(
            -982-439*r**2-84336*r**4+100902*r**6+205300*r**8-292248*r**10-512256*r**12
            +91066*r**14+249378*r**16+19855*r**18+7760*r**20)-20*Q2**3*(-1192+1938*r**2
            -43130*r**4+11529*r**6-15186*r**8-67233*r**10-38514*r**12-19193*r**14
            +74042*r**16+94327*r**18+5612*r**20+5640*r**22)-2*Q2*(-1+r**2)**2*(
            -3602+1629*r**2-246615*r**4+201076*r**6+424162*r**8-533248*r**10-867284*r**12
            -809030*r**14+277304*r**16+629643*r**18+38755*r**20+23210*r**22)+Q2**2*(
            -20582+34285*r**2-1097520*r**4+1176275*r**6+473360*r**8-2040566*r**10
            -1463420*r**12-362770*r**14-2411330*r**16-207015*r**18+2304268*r**20
            +51055*r**22+107960*r**24))*sqrtq2-64*r**2*(45*Q2**18*r**2+2*Q2**17*r**2*(127
            +83*r**2)-Q2**16*(552+2593*r**2+31854*r**4+5725*r**6)+Q2**15*(5688
            -2166*r**2+225980*r**4+332122*r**6+38416*r**8)-Q2**14*(25050-76423*r**2
            +551570*r**4+1933616*r**6+1530900*r**8+136535*r**10)+2*Q2**13*(29400
            -173165*r**2-7985*r**4+2029954*r**6+3344428*r**8+1937487*r**10+151585*r**12)
            -Q2**12*(68250-850975*r**2-3812790*r**4+374495*r**6+6242434*r**8+10343875*r**10
            +5399514*r**12+438893*r**14)+2*Q2**11*(-1092-659031*r**2-6582074*r**4
            -9858925*r**6-13728846*r**8-9261317*r**10+979626*r**12+1332977*r**14
            +200330*r**16)+Q2**10*(126126+1245629*r**2+26156762*r**4+58325846*r**6
            +111491258*r**8+130117416*r**10+81426414*r**12+18297522*r**14+4015440*r**16
            -190333*r**18)-2*Q2**9*(85800+204083*r**2+15228995*r**4+42178764*r**6
            +87496680*r**8+128568510*r**10+112897898*r**12+61975780*r**14+15142584*r**16
            +4334495*r**18+715*r**20)+Q2**8*(64350-737495*r**2+10483310*r**4+53860449*r**6
            +59996108*r**8+152135022*r**10+213132940*r**12+165054430*r**14+91800774*r**16
            +23401353*r**18+6985462*r**20+25025*r**22)+2*Q2**7*(42900+677759*r**2
            +12820866*r**4+762275*r**6+109972604*r**8+111349430*r**10+62461164*r**12
            -21646202*r**14-15480580*r**16-16565781*r**18-6637870*r**20-1072137*r**22
            +25844*r**24)+2*(-1+r**2)**6*(201+3152*r**2+178553*r**4-1032672*r**6
            +6084658*r**8-15914992*r**10+8469878*r**12+15508688*r**14-13195015*r**16
            +2205392*r**18-884559*r**20-121680*r**22-5716*r**24+112*r**26)-Q2**6*(126126
            +1060467*r**2+42883502*r**4+2057740*r**6+383093536*r**8+361246199*r**10
            +342567500*r**12+198140992*r**14-60588210*r**16+20859281*r**18-4173114*r**20
            -10039660*r**22+640036*r**24+81445*r**26)-8*Q2*(-1+r**2)**4*(486+6460*r**2
            +368861*r**4-1757202*r**6+9733164*r**8-18776379*r**10-4175798*r**12
            +27017944*r**14+8602354*r**16-18223514*r**18+2883873*r**20-1550182*r**22
            -232100*r**24-10247*r**26+280*r**28)+2*Q2**5*(28392+150385*r**2+12179173*r**4
            -12515054*r**6+129769228*r**8+27943763*r**10+33558637*r**12+34518796*r**14
            +102309184*r**16-45560025*r**18+14190327*r**20+8921410*r**22-2271572*r**24
            +402357*r**26+19159*r**28)+2*Q2**2*(-1+r**2)**2*(7725+86139*r**2+4905884*r**4
            -20393536*r**6+106261857*r**8-165586435*r**10-40123448*r**12+86230214*r**14
            +228390551*r**16+21873077*r**18-167694532*r**20+28165524*r**22-16925733*r**24
            -2874925*r**26-118944*r**28+4582*r**30)+Q2**4*(13650+219493*r**2+4449610*r**4
            -4899281*r**6+35404310*r**8+46425585*r**10+48516934*r**12+95951835*r**14
            +196351422*r**16-332723425*r**18-98192650*r**20-2227*r**22-44188070*r**24
            -4932341*r**26-463110*r**28+7465*r**30)-2*Q2**3*(14700+141485*r**2+7532070*r**4
            -29533309*r**6+140946982*r**8-209180207*r**10+50756270*r**12+31131375*r**14
            -20047882*r**16+260197751*r**18+20959314*r**20-186135175*r**22+43096530*r**24
            -22443509*r**26-4312358*r**28-188907*r**30+8870*r**32))*sqrtq2)/(18662400*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +129600*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3-55987200*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            -2332800*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2*sqrtq2-2700*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+(flagPERP*(-138240*logq2**3*(-Q2+(-1
            +r)**2)*r**12*(-Q2+(1+r)**2)*(-40*Q2**7*r**2+4*Q2**6*(6+52*r**2+37*r**4)
            -Q2**5*(109+472*r**2+591*r**4+108*r**6)+Q2**4*(165+497*r**2+869*r**4
            +379*r**6-130*r**8)-2*Q2**3*(25+129*r**2+187*r**4+46*r**6-72*r**8
            +25*r**10)+(-1+r**2)**2*(-31+157*r**2-310*r**4+330*r**6+245*r**8-119*r**10
            +208*r**12)+2*Q2**2*(-55+166*r**2-240*r**4+29*r**6+48*r**8-183*r**10
            +315*r**12)-Q2*(-111+486*r**2-1063*r**4+490*r**6+1375*r**8+846*r**10
            -761*r**12+658*r**14))-192*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -184*Q2**13*r**2+4*Q2**12*(-10+456*r**2+433*r**4)-Q2**11*(-245+6496*r**2
            +15057*r**4+6308*r**6)+Q2**10*(-515+9985*r**2+41625*r**4+41987*r**6
            +10850*r**8)-Q2**9*(-175+3600*r**2+29806*r**4+14726*r**6+40497*r**8
            +6690*r**10)-Q2**8*(-975+7677*r**2+57668*r**4+347020*r**6+275051*r**8
            +20167*r**10+5952*r**12)+2*Q2**7*(-735+3516*r**2+58048*r**4+394604*r**6
            +628787*r**8+278368*r**10+33220*r**12+6048*r**14)-2*Q2**6*(-105-1401*r**2
            +28864*r**4+231932*r**6+716071*r**8+662585*r**10+173784*r**12+20684*r**14
            +2442*r**16)-2*Q2**5*(-615+1920*r**2+3397*r**4+181208*r**6+107031*r**8
            -138170*r**10-204945*r**12-41408*r**14-7972*r**16+1650*r**18)+2*Q2**4*(
            -525-1225*r**2-467*r**4+259743*r**6+678115*r**8+683851*r**10+202441*r**12
            -60867*r**14-91922*r**16-10814*r**18+1670*r**20)+Q2**3*(25+3336*r**2
            +4353*r**4-116700*r**6-764946*r**8-438432*r**10-610162*r**12+6632*r**14
            +229145*r**16+98296*r**18+4817*r**20-364*r**22)+(-1+r**2)**2*(35+325*r**2
            +5069*r**4+15147*r**6-173030*r**8+1062838*r**10-899034*r**12-567734*r**14
            +919363*r**16-96635*r**18+74637*r**20+4619*r**22)+Q2**2*(385-131*r**2
            +16807*r**4-53843*r**6-113856*r**8+136566*r**10-653310*r**12-972954*r**14
            +1370973*r**16-318259*r**18+220439*r**20+22061*r**22-478*r**24)+Q2*(
            -205-856*r**2-17080*r**4+8862*r**6+414155*r**8-1940210*r**10+1759392*r**12
            -1665420*r**14+2380321*r**16-2541380*r**18+476440*r**20-237586*r**22
            -18975*r**24+142*r**26))-8294400*logq2**4*r**16*(-1+3*r**4)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*sqrtq2-2304*logq2**2*r**8*(-768*Q2**12*r**2+8*Q2**11*(
            -10+912*r**2+817*r**4)-Q2**10*(-645+28568*r**2+49089*r**4+23248*r**6)
            +10*Q2**9*(-205+5847*r**2+14353*r**4+13073*r**6+4418*r**8)-5*Q2**8*(
            -585+12434*r**2+38240*r**4+48762*r**6+34405*r**8+9528*r**10)+8*Q2**7*(
            -75+2347*r**2+7895*r**4+9205*r**6+16420*r**8+14870*r**10+3747*r**12)
            +Q2**6*(-3990+33608*r**2+142648*r**4+327140*r**6+276810*r**8+22420*r**10
            -64052*r**12-14952*r**14)+4*Q2**5*(1365-11251*r**2-48883*r**4-110476*r**6
            -115495*r**8-60345*r**10-3051*r**12+15412*r**14+2124*r**16)+10*Q2**4*(
            -195+2018*r**2+8317*r**4+22378*r**6+7775*r**8-242*r**10+2003*r**12
            +10802*r**14-4028*r**16+612*r**18)+(-1+r**2)**4*(145-198*r**2-4416*r**4
            +36566*r**6-21762*r**8+870*r**10-10912*r**12+38106*r**14+3249*r**16
            +1552*r**18)-40*Q2**3*(45-83*r**2-550*r**4+3797*r**6-5045*r**8-3442*r**10
            +632*r**12-1679*r**14+8666*r**16-25*r**18+564*r**20)-2*Q2*(-1+r**2)**2*(465
            -1193*r**2-11484*r**4+74190*r**6-36376*r**8+17748*r**10+47898*r**12
            -26086*r**14+96615*r**16+6381*r**18+4642*r**20)+Q2**2*(2225-8608*r**2
            -39735*r**4+245020*r**6-296790*r**8+196660*r**10+244066*r**12+295260*r**14
            -339995*r**16+368540*r**18+2965*r**20+21592*r**22))*sqrtq2+32*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**14+Q2**13*(68+46*r**2)-Q2**12*(717
            +6352*r**2+643*r**4)+4*Q2**11*(396+11268*r**2+10829*r**4+624*r**6)
            -2*Q2**10*(58+56589*r**2+119149*r**4+56161*r**6+2343*r**8)+8*Q2**9*(
            -108+11073*r**2+47052*r**4+49657*r**6+13950*r**8+517*r**10)-2*Q2**8*(4593
            -51766*r**2-53644*r**4-172420*r**6+38069*r**8-18162*r**10+66*r**12)
            -4*Q2**7*(-5736+59893*r**2+194922*r**4+677168*r**6+543520*r**8+90437*r**10
            +41634*r**12+726*r**14)+Q2**6*(-13473+107480*r**2+561048*r**4+2817388*r**6
            +4727966*r**8+2103752*r**10+254520*r**12+102468*r**14+1683*r**16)+2*Q2**5*(
            -6974+47965*r**2-13292*r**4+433982*r**6-711268*r**8-1106496*r**10-194620*r**12
            -70622*r**14+11562*r**16+451*r**18)+Q2**4*(21607-110684*r**2+105489*r**4
            -2865356*r**6-2478042*r**8-1628916*r**10+362842*r**12+188764*r**14+348739*r**16
            -39200*r**18-1243*r**20)+4*Q2**3*(-1308+2193*r**2-31247*r**4+295690*r**6
            +368708*r**8+221166*r**10+196538*r**12-111708*r**14-70520*r**16-50223*r**18
            +1477*r**20+34*r**22)+2*(-1+r**2)**2*(-468+1288*r**2-34435*r**4+43936*r**6
            +292209*r**8-2571552*r**10+4429614*r**12-2779872*r**14+519474*r**16
            -130824*r**18-27595*r**20-992*r**22+17*r**24)+2*Q2**2*(-3201+19537*r**2
            -102987*r**4+272991*r**6-245380*r**8+997286*r**10+471654*r**12-1300294*r**14
            +658859*r**16-247575*r**18-87995*r**20-1081*r**22+186*r**24)-4*Q2*(
            -1166+5788*r**2-64394*r**4+175131*r**6+1990*r**8-1021853*r**10-167156*r**12
            +2846098*r**14-2779082*r**16+685710*r**18-147906*r**20-50157*r**22-1454*r**24
            +51*r**26))*sqrtq2)*math.log(mu0))/(2073600*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+14400*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-6220800*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-259200*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-300*(-Q2+(-1
            +r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +((138240*logq2**3*r**10*(-40*Q2**9*(2+5*r**4)+12*Q2**8*(64+67*r**2+136*r**4
            +95*r**6)-Q2**7*(2964+5561*r**2+8098*r**4+6581*r**6+2220*r**8)+Q2**6*(5844
            +14257*r**2+21265*r**4+17957*r**6+8131*r**8+1170*r**10)+3*Q2**5*(-1916
            -5405*r**2-8132*r**4-7670*r**6-3686*r**8-969*r**10+170*r**12)+(-1
            +r**2)**4*(-292-63*r**2+219*r**4-1566*r**6-726*r**8-1939*r**10+927*r**12
            +1040*r**14)+Q2**4*(1140+6475*r**2+7793*r**4+7904*r**6+3952*r**8+765*r**10
            +4555*r**12+3000*r**14)+Q2**3*(3492+721*r**2+2986*r**4+9717*r**6+7496*r**8
            +2139*r**10+1786*r**12-9857*r**14-9840*r**16)-Q2*(-1+r**2)**2*(-1716
            -295*r**2+218*r**4-9511*r**6-6446*r**8-5565*r**10-5586*r**12+4331*r**14
            +5370*r**16)+3*Q2**2*(-1292+517*r**2-203*r**4-5559*r**6-5197*r**8-1035*r**10
            -389*r**12-3849*r**14+617*r**16+3590*r**18))+192*logq2*(-Q2+(-1+r)**2)*r**4*(
            -Q2+(1+r)**2)*(-920*Q2**15*r**2+12*Q2**14*(-21+572*r**2+875*r**4)-Q2**13*(
            -1777+15074*r**2+71179*r**4+49780*r**6)+Q2**12*(-6251-14031*r**2+152445*r**4
            +268743*r**6+125990*r**8)-2*Q2**11*(-8682-97004*r**2-16530*r**4+60605*r**6
            +213422*r**8+86745*r**10)+2*Q2**10*(-20834-359512*r**2-565088*r**4-1099907*r**6
            -902725*r**8+20323*r**10+45695*r**12)+Q2**9*(70829+1518062*r**2+3608013*r**4
            +8193770*r**6+10788755*r**8+6288442*r**10+887307*r**12+86550*r**14)
            -Q2**8*(63459+1638207*r**2+5613479*r**4+13214831*r**6+22101185*r**8
            +19188625*r**10+8760689*r**12+1407777*r**14+175140*r**16)+4*Q2**7*(-1452
            +14538*r**2+905932*r**4+839501*r**6+3378670*r**8+4764103*r**10+3308128*r**12
            +1411297*r**14+260406*r**16+23205*r**18)+4*Q2**6*(19833+533126*r**2
            +225187*r**4+5699857*r**6+6882087*r**8+3697281*r**10-485709*r**12-159383*r**14
            -474518*r**16-132273*r**18+6320*r**20)+(-1+r**2)**4*(-1073-49561*r**2
            +115245*r**4-1761603*r**6+3348914*r**8+5096322*r**10-13337610*r**12
            -192490*r**14+4701183*r**16-47209*r**18+377181*r**20+22701*r**22)-Q2**5*(78309
            +2456262*r**2+2377025*r**4+35941784*r**6+52714602*r**8+45469332*r**10
            +19261698*r**12-6198560*r**14+3017089*r**16-1235098*r**18-315603*r**20
            +51720*r**22)+Q2**4*(18623+737699*r**2+1226687*r**4+15703665*r**6+25181300*r**8
            +11722222*r**10+16169542*r**12+8552418*r**14-7153185*r**16+2546655*r**18
            +332235*r**20-37571*r**22+17950*r**24)+Q2*(-1+r**2)**2*(7879+327496*r**2
            -760920*r**4+10198826*r**6-14172357*r**8-19970218*r**10+27758320*r**12
            +36551564*r**14-1568011*r**16-23072868*r**18+642664*r**20-1981366*r**22
            -137719*r**24+710*r**26)+2*Q2**3*(11566+369228*r**2-768346*r**4+6964643*r**6
            -4278730*r**8+7141235*r**10+5662748*r**12+2859738*r**14-9404478*r**16
            -10703210*r**18-497026*r**20-1705981*r**22-146022*r**24+1835*r**26)
            -2*Q2**2*(11058+404348*r**2-1137176*r**4+11128991*r**6-16256715*r**8
            -681471*r**10+7933849*r**12+9227002*r**14+16663368*r**16+6465490*r**18
            -19687282*r**20+1799783*r**22-1889071*r**24-160079*r**26+1905*r**28))
            +8294400*logq2**4*r**14*(-6-5*r**2+r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2+2304*logq2**2*r**6*(-16*Q2**12*(47+240*r**4)+8*Q2**11*(838
            +703*r**2+3800*r**4+4085*r**6)-Q2**10*(24862+39031*r**2+127212*r**4
            +206395*r**6+116240*r**8)+10*Q2**9*(4714+10743*r**2+31431*r**4+59787*r**6
            +54723*r**8+22090*r**10)-5*Q2**8*(7878+27663*r**2+68260*r**4+169030*r**6
            +196662*r**8+137147*r**10+47640*r**12)+4*Q2**7*(-3804+13560*r**2-77510*r**4
            -50645*r**6+31470*r**8+108321*r**10+89030*r**12+37470*r**14)+2*Q2**6*(34146
            +33621*r**2+742550*r**4+1383580*r**6+1430620*r**8+697981*r**10+72556*r**12
            +5110*r**14-37380*r**16)+4*Q2**5*(-15114-23877*r**2-457679*r**4-955300*r**6
            -1105430*r**8-759479*r**10-192147*r**12+54936*r**14-16330*r**16+10620*r**18)
            +10*Q2**4*(906+5697*r**2+59974*r**4+168425*r**6+146418*r**8+121827*r**10
            +61098*r**12+42967*r**14+22608*r**16+7052*r**18+3060*r**20)+(-1+r**2)**4*(
            -982-439*r**2-84336*r**4+100902*r**6+205300*r**8-292248*r**10-512256*r**12
            +91066*r**14+249378*r**16+19855*r**18+7760*r**20)-20*Q2**3*(-1192+1938*r**2
            -43130*r**4+11529*r**6-15186*r**8-67233*r**10-38514*r**12-19193*r**14
            +74042*r**16+94327*r**18+5612*r**20+5640*r**22)-2*Q2*(-1+r**2)**2*(
            -3602+1629*r**2-246615*r**4+201076*r**6+424162*r**8-533248*r**10-867284*r**12
            -809030*r**14+277304*r**16+629643*r**18+38755*r**20+23210*r**22)+Q2**2*(
            -20582+34285*r**2-1097520*r**4+1176275*r**6+473360*r**8-2040566*r**10
            -1463420*r**12-362770*r**14-2411330*r**16-207015*r**18+2304268*r**20
            +51055*r**22+107960*r**24))*sqrtq2-32*r**2*(45*Q2**18*r**2+2*Q2**17*r**2*(127
            +83*r**2)-Q2**16*(552+2593*r**2+31854*r**4+5725*r**6)+Q2**15*(5688
            -2166*r**2+225980*r**4+332122*r**6+38416*r**8)-Q2**14*(25050-76423*r**2
            +551570*r**4+1933616*r**6+1530900*r**8+136535*r**10)+2*Q2**13*(29400
            -173165*r**2-7985*r**4+2029954*r**6+3344428*r**8+1937487*r**10+151585*r**12)
            -Q2**12*(68250-850975*r**2-3812790*r**4+374495*r**6+6242434*r**8+10343875*r**10
            +5399514*r**12+438893*r**14)+2*Q2**11*(-1092-659031*r**2-6582074*r**4
            -9858925*r**6-13728846*r**8-9261317*r**10+979626*r**12+1332977*r**14
            +200330*r**16)+Q2**10*(126126+1245629*r**2+26156762*r**4+58325846*r**6
            +111491258*r**8+130117416*r**10+81426414*r**12+18297522*r**14+4015440*r**16
            -190333*r**18)-2*Q2**9*(85800+204083*r**2+15228995*r**4+42178764*r**6
            +87496680*r**8+128568510*r**10+112897898*r**12+61975780*r**14+15142584*r**16
            +4334495*r**18+715*r**20)+Q2**8*(64350-737495*r**2+10483310*r**4+53860449*r**6
            +59996108*r**8+152135022*r**10+213132940*r**12+165054430*r**14+91800774*r**16
            +23401353*r**18+6985462*r**20+25025*r**22)+2*Q2**7*(42900+677759*r**2
            +12820866*r**4+762275*r**6+109972604*r**8+111349430*r**10+62461164*r**12
            -21646202*r**14-15480580*r**16-16565781*r**18-6637870*r**20-1072137*r**22
            +25844*r**24)+2*(-1+r**2)**6*(201+3152*r**2+178553*r**4-1032672*r**6
            +6084658*r**8-15914992*r**10+8469878*r**12+15508688*r**14-13195015*r**16
            +2205392*r**18-884559*r**20-121680*r**22-5716*r**24+112*r**26)-Q2**6*(126126
            +1060467*r**2+42883502*r**4+2057740*r**6+383093536*r**8+361246199*r**10
            +342567500*r**12+198140992*r**14-60588210*r**16+20859281*r**18-4173114*r**20
            -10039660*r**22+640036*r**24+81445*r**26)-8*Q2*(-1+r**2)**4*(486+6460*r**2
            +368861*r**4-1757202*r**6+9733164*r**8-18776379*r**10-4175798*r**12
            +27017944*r**14+8602354*r**16-18223514*r**18+2883873*r**20-1550182*r**22
            -232100*r**24-10247*r**26+280*r**28)+2*Q2**5*(28392+150385*r**2+12179173*r**4
            -12515054*r**6+129769228*r**8+27943763*r**10+33558637*r**12+34518796*r**14
            +102309184*r**16-45560025*r**18+14190327*r**20+8921410*r**22-2271572*r**24
            +402357*r**26+19159*r**28)+2*Q2**2*(-1+r**2)**2*(7725+86139*r**2+4905884*r**4
            -20393536*r**6+106261857*r**8-165586435*r**10-40123448*r**12+86230214*r**14
            +228390551*r**16+21873077*r**18-167694532*r**20+28165524*r**22-16925733*r**24
            -2874925*r**26-118944*r**28+4582*r**30)+Q2**4*(13650+219493*r**2+4449610*r**4
            -4899281*r**6+35404310*r**8+46425585*r**10+48516934*r**12+95951835*r**14
            +196351422*r**16-332723425*r**18-98192650*r**20-2227*r**22-44188070*r**24
            -4932341*r**26-463110*r**28+7465*r**30)-2*Q2**3*(14700+141485*r**2+7532070*r**4
            -29533309*r**6+140946982*r**8-209180207*r**10+50756270*r**12+31131375*r**14
            -20047882*r**16+260197751*r**18+20959314*r**20-186135175*r**22+43096530*r**24
            -22443509*r**26-4312358*r**28-188907*r**30+8870*r**32))*sqrtq2)*math.log(mu0))/(6220800*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +43200*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3-18662400*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            -777600*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2-900*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+FLAGcD*flagPERP*((-720*logq2**2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(1-11*r**2+10*Q2**5*r**2+50*r**4+30*r**6
            +125*r**8-41*r**10+26*r**12-4*Q2**4*(1+8*r**2+11*r**4)+Q2**3*(6+49*r**2
            +89*r**4+61*r**6)-Q2**2*(-1+23*r**2+56*r**4+108*r**6+4*r**8)+Q2*(
            -4+12*r**2-33*r**4+27*r**6+77*r**8-49*r**10))-(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(7*Q2**9*r**2+Q2**8*(-22+89*r**2+23*r**4)-Q2**7*(-101
            +398*r**2+2817*r**4+196*r**6)+Q2**6*(-156+3*r**2+11687*r**4+9911*r**6
            +335*r**8)-Q2**5*(-47-904*r**2+10040*r**4+31544*r**6+7963*r**8+64*r**10)
            +Q2**4*(110+333*r**2-8167*r**4+8892*r**6+20686*r**8-10725*r**10-337*r**12)
            +Q2**3*(-93-2074*r**2+14295*r**4+18820*r**6+48901*r**8+4158*r**10+17921*r**12
            +272*r**14)+Q2**2*(-16+753*r**2-1695*r**4-6029*r**6-69053*r**8-42197*r**10
            -13221*r**12-1783*r**14+41*r**16)+Q2*(41+857*r**2-7214*r**4+9536*r**6
            -43980*r**8+110834*r**10-62202*r**12+21784*r**14-7941*r**16-115*r**18)
            +2*(-6-237*r**2+1964*r**4-9815*r**6-8509*r**8+86159*r**10-86693*r**12
            +43631*r**14-6565*r**16+1654*r**18+17*r**20))-21600*logq2**3*r**10*(1
            -2*r**2+3*r**4)*sqrtq2+6*logq2*r**2*(-5*(-1+Q2)**7*(7+15*Q2+8*Q2**2)
            -2*(-1+Q2)**5*(-121-75*Q2+30*Q2**2-150*Q2**3-180*Q2**4+46*Q2**5)*r**2
            +5*(-1+Q2)**3*(-77-113*Q2-324*Q2**2+602*Q2**3+33*Q2**4-621*Q2**5
            +140*Q2**6)*r**4-10*(-1166+2308*Q2-1238*Q2**2+2368*Q2**3-5001*Q2**4
            +2788*Q2**5+900*Q2**6-1160*Q2**7+201*Q2**8)*r**6+10*(-5855+4862*Q2
            -2830*Q2**2-5510*Q2**3+8466*Q2**4-2557*Q2**5-893*Q2**6+237*Q2**7)*r**8
            +10*(8718+2928*Q2+108*Q2**2-8184*Q2**3+4717*Q2**4-456*Q2**5+21*Q2**6)*r**10
            -2*(21593-20570*Q2-23820*Q2**2+7000*Q2**3-5890*Q2**4+1743*Q2**5)*r**12
            +10*(-656-3356*Q2-2430*Q2**2-632*Q2**3+315*Q2**4)*r**14-5*(-3063
            -4486*Q2-90*Q2**2+18*Q2**3)*r**16-10*(585-38*Q2+147*Q2**2)*r**18+5*(
            -3+178*Q2)*r**20-172*r**22)*sqrtq2)/(10800*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-43200*logq2**3*r**12*sqrtq2
            -900*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((2880*logq2**2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(1-11*r**2+10*Q2**5*r**2+50*r**4
            +30*r**6+125*r**8-41*r**10+26*r**12-4*Q2**4*(1+8*r**2+11*r**4)+Q2**3*(6
            +49*r**2+89*r**4+61*r**6)-Q2**2*(-1+23*r**2+56*r**4+108*r**6+4*r**8)
            +Q2*(-4+12*r**2-33*r**4+27*r**6+77*r**8-49*r**10))+4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**9*r**2+Q2**8*(-22+89*r**2+23*r**4)
            -Q2**7*(-101+398*r**2+2817*r**4+196*r**6)+Q2**6*(-156+3*r**2+11687*r**4
            +9911*r**6+335*r**8)-Q2**5*(-47-904*r**2+10040*r**4+31544*r**6+7963*r**8
            +64*r**10)+Q2**4*(110+333*r**2-8167*r**4+8892*r**6+20686*r**8-10725*r**10
            -337*r**12)+Q2**3*(-93-2074*r**2+14295*r**4+18820*r**6+48901*r**8+4158*r**10
            +17921*r**12+272*r**14)+Q2**2*(-16+753*r**2-1695*r**4-6029*r**6-69053*r**8
            -42197*r**10-13221*r**12-1783*r**14+41*r**16)+Q2*(41+857*r**2-7214*r**4
            +9536*r**6-43980*r**8+110834*r**10-62202*r**12+21784*r**14-7941*r**16
            -115*r**18)+2*(-6-237*r**2+1964*r**4-9815*r**6-8509*r**8+86159*r**10
            -86693*r**12+43631*r**14-6565*r**16+1654*r**18+17*r**20))+86400*logq2**3*r**10*(1
            -2*r**2+3*r**4)*sqrtq2+24*logq2*r**2*(5*(-1+Q2)**7*(7+15*Q2+8*Q2**2)
            +2*(-1+Q2)**5*(-121-75*Q2+30*Q2**2-150*Q2**3-180*Q2**4+46*Q2**5)*r**2
            -5*(-1+Q2)**3*(-77-113*Q2-324*Q2**2+602*Q2**3+33*Q2**4-621*Q2**5
            +140*Q2**6)*r**4+10*(-1166+2308*Q2-1238*Q2**2+2368*Q2**3-5001*Q2**4
            +2788*Q2**5+900*Q2**6-1160*Q2**7+201*Q2**8)*r**6-10*(-5855+4862*Q2
            -2830*Q2**2-5510*Q2**3+8466*Q2**4-2557*Q2**5-893*Q2**6+237*Q2**7)*r**8
            -10*(8718+2928*Q2+108*Q2**2-8184*Q2**3+4717*Q2**4-456*Q2**5+21*Q2**6)*r**10
            +2*(21593-20570*Q2-23820*Q2**2+7000*Q2**3-5890*Q2**4+1743*Q2**5)*r**12
            -10*(-656-3356*Q2-2430*Q2**2-632*Q2**3+315*Q2**4)*r**14+5*(-3063
            -4486*Q2-90*Q2**2+18*Q2**3)*r**16+10*(585-38*Q2+147*Q2**2)*r**18-5*(
            -3+178*Q2)*r**20+172*r**22)*sqrtq2)*math.log(murhoD))/(11664*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+27*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-46656*logq2**3*r**12*sqrtq2
            -972*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2))+FLAGcD*((720*logq2**2*r**4*(10*Q2**7*(1
            +5*r**4)-4*Q2**6*(19+26*r**2+77*r**4+80*r**6)+Q2**5*(201+500*r**2
            +1457*r**4+1343*r**6+795*r**8)-Q2**4*(215+758*r**2+2837*r**4+3624*r**6
            +1980*r**8+850*r**10)+2*Q2**3*(10+191*r**2+810*r**4+1147*r**6+1353*r**8
            +415*r**10+50*r**12)+(-1+r**2)**2*(29-10*r**2+507*r**4-2218*r**6-3483*r**8
            -102*r**10+107*r**12+130*r**14)+Q2**2*(150-38*r**2+969*r**4-1368*r**6
            -2014*r**8-274*r**10+295*r**12+600*r**14)+Q2*(-119+86*r**2-1507*r**4
            +3971*r**6+11956*r**8+6170*r**10+135*r**12-27*r**14-505*r**16))+(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**12+Q2**11*(19+5*r**2)+Q2**10*(69
            +312*r**2+139*r**4)-Q2**9*(2973+1415*r**2+13845*r**4+1655*r**6)+2*Q2**8*(6266
            +521*r**2+16200*r**4+35467*r**6+2610*r**8)-2*Q2**7*(9712-3611*r**2
            -9936*r**4+62186*r**6+66386*r**8+3423*r**10)+2*Q2**6*(2072+1935*r**2
            -61245*r**4-10798*r**6+86420*r**8+26287*r**10+945*r**12)+2*Q2**5*(11672
            -41479*r**2+147396*r**4+209881*r**6+240442*r**8-62343*r**10+78766*r**12
            +2481*r**14)-2*Q2**4*(13201-71075*r**2+299355*r**4+744945*r**6+919905*r**8
            +713699*r**10-54415*r**12+110975*r**14+2610*r**16)+Q2**3*(3893-46947*r**2
            +402420*r**4+1147164*r**6+2150370*r**8+1441802*r**10+967372*r**12+3940*r**14
            +58121*r**16+505*r**18)+2*(-1+r**2)**2*(731-9790*r**2+106706*r**4-300958*r**6
            +144348*r**8-301378*r**10-524770*r**12+302334*r**14-29527*r**16+7392*r**18
            +112*r**20)+Q2**2*(10491-84742*r**2+442083*r**4-100472*r**6+770418*r**8
            -528204*r**10-289358*r**12+1166712*r**14-258093*r**16+78802*r**18+1963*r**20)
            +Q2*(-7163+83965*r**2-710695*r**4+1148445*r**6+456510*r**8+1378846*r**10
            +1630950*r**12+2565390*r**14-1921475*r**16+278885*r**18-64063*r**20
            -1195*r**22))+21600*logq2**3*r**8*(3+5*r**2-65*r**4+r**6)*sqrtq2+6*logq2*(92*Q2**10*(1
            +5*r**4)-20*Q2**9*(29+15*r**2+105*r**4+175*r**6)+5*Q2**8*(279+271*r**2
            +205*r**4+2715*r**6+2010*r**8)-10*Q2**7*(132+259*r**2-766*r**4+668*r**6
            +3002*r**8+1185*r**10)-10*Q2**6*(42-335*r**2+2345*r**4+3050*r**6+2732*r**8
            -2147*r**10+105*r**12)+2*Q2**5*(1008-1895*r**2+25330*r**4+86925*r**6
            +128000*r**8+85343*r**10+7950*r**12+8715*r**14)-10*Q2**4*(147-230*r**2
            +6386*r**4+37548*r**6+74256*r**8+63236*r**10+26280*r**12+3650*r**14
            +1575*r**16)+10*Q2**3*(-12+167*r**2+1354*r**4+25306*r**6+51738*r**8
            +66076*r**10+43574*r**12+6870*r**14+2450*r**16+45*r**18)+10*Q2**2*(72
            -391*r**2+5303*r**4+3264*r**6+11020*r**8-2606*r**10-21870*r**12+6408*r**14
            +19188*r**16-963*r**18+735*r**20)+(-1+r**2)**2*(67-401*r**2+13526*r**4
            +9618*r**6-128500*r**8-158132*r**10-447154*r**12+51694*r**14+52977*r**16
            +645*r**18+860*r**20)-10*Q2*(38-245*r**2+5136*r**4+3913*r**6-15952*r**8
            -85914*r**10-97164*r**12-75350*r**14+4778*r**16+18783*r**18-388*r**20
            +445*r**22))*sqrtq2)/(32400*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+75*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3-129600*logq2**3*r**12*sqrtq2-2700*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2)+((-2880*logq2**2*r**4*(10*Q2**7*(1+5*r**4)
            -4*Q2**6*(19+26*r**2+77*r**4+80*r**6)+Q2**5*(201+500*r**2+1457*r**4
            +1343*r**6+795*r**8)-Q2**4*(215+758*r**2+2837*r**4+3624*r**6+1980*r**8
            +850*r**10)+2*Q2**3*(10+191*r**2+810*r**4+1147*r**6+1353*r**8+415*r**10
            +50*r**12)+(-1+r**2)**2*(29-10*r**2+507*r**4-2218*r**6-3483*r**8-102*r**10
            +107*r**12+130*r**14)+Q2**2*(150-38*r**2+969*r**4-1368*r**6-2014*r**8
            -274*r**10+295*r**12+600*r**14)+Q2*(-119+86*r**2-1507*r**4+3971*r**6
            +11956*r**8+6170*r**10+135*r**12-27*r**14-505*r**16))-4*(Q2-(-1
            +r)**2)*(Q2-(1+r)**2)*(8*Q2**12+Q2**11*(19+5*r**2)+Q2**10*(69+312*r**2
            +139*r**4)-Q2**9*(2973+1415*r**2+13845*r**4+1655*r**6)+2*Q2**8*(6266
            +521*r**2+16200*r**4+35467*r**6+2610*r**8)-2*Q2**7*(9712-3611*r**2
            -9936*r**4+62186*r**6+66386*r**8+3423*r**10)+2*Q2**6*(2072+1935*r**2
            -61245*r**4-10798*r**6+86420*r**8+26287*r**10+945*r**12)+2*Q2**5*(11672
            -41479*r**2+147396*r**4+209881*r**6+240442*r**8-62343*r**10+78766*r**12
            +2481*r**14)-2*Q2**4*(13201-71075*r**2+299355*r**4+744945*r**6+919905*r**8
            +713699*r**10-54415*r**12+110975*r**14+2610*r**16)+Q2**3*(3893-46947*r**2
            +402420*r**4+1147164*r**6+2150370*r**8+1441802*r**10+967372*r**12+3940*r**14
            +58121*r**16+505*r**18)+2*(-1+r**2)**2*(731-9790*r**2+106706*r**4-300958*r**6
            +144348*r**8-301378*r**10-524770*r**12+302334*r**14-29527*r**16+7392*r**18
            +112*r**20)+Q2**2*(10491-84742*r**2+442083*r**4-100472*r**6+770418*r**8
            -528204*r**10-289358*r**12+1166712*r**14-258093*r**16+78802*r**18+1963*r**20)
            +Q2*(-7163+83965*r**2-710695*r**4+1148445*r**6+456510*r**8+1378846*r**10
            +1630950*r**12+2565390*r**14-1921475*r**16+278885*r**18-64063*r**20
            -1195*r**22))-86400*logq2**3*r**8*(3+5*r**2-65*r**4+r**6)*sqrtq2-24*logq2*(92*Q2**10*(1
            +5*r**4)-20*Q2**9*(29+15*r**2+105*r**4+175*r**6)+5*Q2**8*(279+271*r**2
            +205*r**4+2715*r**6+2010*r**8)-10*Q2**7*(132+259*r**2-766*r**4+668*r**6
            +3002*r**8+1185*r**10)-10*Q2**6*(42-335*r**2+2345*r**4+3050*r**6+2732*r**8
            -2147*r**10+105*r**12)+2*Q2**5*(1008-1895*r**2+25330*r**4+86925*r**6
            +128000*r**8+85343*r**10+7950*r**12+8715*r**14)-10*Q2**4*(147-230*r**2
            +6386*r**4+37548*r**6+74256*r**8+63236*r**10+26280*r**12+3650*r**14
            +1575*r**16)+10*Q2**3*(-12+167*r**2+1354*r**4+25306*r**6+51738*r**8
            +66076*r**10+43574*r**12+6870*r**14+2450*r**16+45*r**18)+10*Q2**2*(72
            -391*r**2+5303*r**4+3264*r**6+11020*r**8-2606*r**10-21870*r**12+6408*r**14
            +19188*r**16-963*r**18+735*r**20)+(-1+r**2)**2*(67-401*r**2+13526*r**4
            +9618*r**6-128500*r**8-158132*r**10-447154*r**12+51694*r**14+52977*r**16
            +645*r**18+860*r**20)-10*Q2*(38-245*r**2+5136*r**4+3913*r**6-15952*r**8
            -85914*r**10-97164*r**12-75350*r**14+4778*r**16+18783*r**18-388*r**20
            +445*r**22))*sqrtq2)*math.log(murhoD))/(34992*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+81*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-139968*logq2**3*r**12*sqrtq2
            -2916*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2))+(flagPERP*(138240*logq2**3*(
            -Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)*(-40*Q2**7*r**2+4*Q2**6*(6+52*r**2
            +37*r**4)-Q2**5*(109+472*r**2+591*r**4+108*r**6)+Q2**4*(165+497*r**2
            +869*r**4+379*r**6-130*r**8)-2*Q2**3*(25+129*r**2+187*r**4+46*r**6
            -72*r**8+25*r**10)+(-1+r**2)**2*(-31+157*r**2-310*r**4+330*r**6+245*r**8
            -119*r**10+208*r**12)+2*Q2**2*(-55+166*r**2-240*r**4+29*r**6+48*r**8
            -183*r**10+315*r**12)-Q2*(-111+486*r**2-1063*r**4+490*r**6+1375*r**8
            +846*r**10-761*r**12+658*r**14))+192*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(-184*Q2**13*r**2+4*Q2**12*(-10+456*r**2+433*r**4)
            -Q2**11*(-245+6496*r**2+15057*r**4+6308*r**6)+Q2**10*(-515+9985*r**2
            +41625*r**4+41987*r**6+10850*r**8)-Q2**9*(-175+3600*r**2+29806*r**4
            +14726*r**6+40497*r**8+6690*r**10)-Q2**8*(-975+7677*r**2+57668*r**4
            +347020*r**6+275051*r**8+20167*r**10+5952*r**12)+2*Q2**7*(-735+3516*r**2
            +58048*r**4+394604*r**6+628787*r**8+278368*r**10+33220*r**12+6048*r**14)
            -2*Q2**6*(-105-1401*r**2+28864*r**4+231932*r**6+716071*r**8+662585*r**10
            +173784*r**12+20684*r**14+2442*r**16)-2*Q2**5*(-615+1920*r**2+3397*r**4
            +181208*r**6+107031*r**8-138170*r**10-204945*r**12-41408*r**14-7972*r**16
            +1650*r**18)+2*Q2**4*(-525-1225*r**2-467*r**4+259743*r**6+678115*r**8
            +683851*r**10+202441*r**12-60867*r**14-91922*r**16-10814*r**18+1670*r**20)
            +Q2**3*(25+3336*r**2+4353*r**4-116700*r**6-764946*r**8-438432*r**10
            -610162*r**12+6632*r**14+229145*r**16+98296*r**18+4817*r**20-364*r**22)
            +(-1+r**2)**2*(35+325*r**2+5069*r**4+15147*r**6-173030*r**8+1062838*r**10
            -899034*r**12-567734*r**14+919363*r**16-96635*r**18+74637*r**20+4619*r**22)
            +Q2**2*(385-131*r**2+16807*r**4-53843*r**6-113856*r**8+136566*r**10
            -653310*r**12-972954*r**14+1370973*r**16-318259*r**18+220439*r**20+22061*r**22
            -478*r**24)+Q2*(-205-856*r**2-17080*r**4+8862*r**6+414155*r**8-1940210*r**10
            +1759392*r**12-1665420*r**14+2380321*r**16-2541380*r**18+476440*r**20
            -237586*r**22-18975*r**24+142*r**26))+8294400*logq2**4*r**16*(-1+3*r**4)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+2304*logq2**2*r**8*(-768*Q2**12*r**2
            +8*Q2**11*(-10+912*r**2+817*r**4)-Q2**10*(-645+28568*r**2+49089*r**4
            +23248*r**6)+10*Q2**9*(-205+5847*r**2+14353*r**4+13073*r**6+4418*r**8)
            -5*Q2**8*(-585+12434*r**2+38240*r**4+48762*r**6+34405*r**8+9528*r**10)
            +8*Q2**7*(-75+2347*r**2+7895*r**4+9205*r**6+16420*r**8+14870*r**10
            +3747*r**12)+Q2**6*(-3990+33608*r**2+142648*r**4+327140*r**6+276810*r**8
            +22420*r**10-64052*r**12-14952*r**14)+4*Q2**5*(1365-11251*r**2-48883*r**4
            -110476*r**6-115495*r**8-60345*r**10-3051*r**12+15412*r**14+2124*r**16)
            +10*Q2**4*(-195+2018*r**2+8317*r**4+22378*r**6+7775*r**8-242*r**10
            +2003*r**12+10802*r**14-4028*r**16+612*r**18)+(-1+r**2)**4*(145-198*r**2
            -4416*r**4+36566*r**6-21762*r**8+870*r**10-10912*r**12+38106*r**14
            +3249*r**16+1552*r**18)-40*Q2**3*(45-83*r**2-550*r**4+3797*r**6-5045*r**8
            -3442*r**10+632*r**12-1679*r**14+8666*r**16-25*r**18+564*r**20)-2*Q2*(
            -1+r**2)**2*(465-1193*r**2-11484*r**4+74190*r**6-36376*r**8+17748*r**10
            +47898*r**12-26086*r**14+96615*r**16+6381*r**18+4642*r**20)+Q2**2*(2225
            -8608*r**2-39735*r**4+245020*r**6-296790*r**8+196660*r**10+244066*r**12
            +295260*r**14-339995*r**16+368540*r**18+2965*r**20+21592*r**22))*sqrtq2
            -32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**14+Q2**13*(68+46*r**2)
            -Q2**12*(717+6352*r**2+643*r**4)+4*Q2**11*(396+11268*r**2+10829*r**4
            +624*r**6)-2*Q2**10*(58+56589*r**2+119149*r**4+56161*r**6+2343*r**8)
            +8*Q2**9*(-108+11073*r**2+47052*r**4+49657*r**6+13950*r**8+517*r**10)
            -2*Q2**8*(4593-51766*r**2-53644*r**4-172420*r**6+38069*r**8-18162*r**10
            +66*r**12)-4*Q2**7*(-5736+59893*r**2+194922*r**4+677168*r**6+543520*r**8
            +90437*r**10+41634*r**12+726*r**14)+Q2**6*(-13473+107480*r**2+561048*r**4
            +2817388*r**6+4727966*r**8+2103752*r**10+254520*r**12+102468*r**14+1683*r**16)
            +2*Q2**5*(-6974+47965*r**2-13292*r**4+433982*r**6-711268*r**8-1106496*r**10
            -194620*r**12-70622*r**14+11562*r**16+451*r**18)+Q2**4*(21607-110684*r**2
            +105489*r**4-2865356*r**6-2478042*r**8-1628916*r**10+362842*r**12+188764*r**14
            +348739*r**16-39200*r**18-1243*r**20)+4*Q2**3*(-1308+2193*r**2-31247*r**4
            +295690*r**6+368708*r**8+221166*r**10+196538*r**12-111708*r**14-70520*r**16
            -50223*r**18+1477*r**20+34*r**22)+2*(-1+r**2)**2*(-468+1288*r**2-34435*r**4
            +43936*r**6+292209*r**8-2571552*r**10+4429614*r**12-2779872*r**14+519474*r**16
            -130824*r**18-27595*r**20-992*r**22+17*r**24)+2*Q2**2*(-3201+19537*r**2
            -102987*r**4+272991*r**6-245380*r**8+997286*r**10+471654*r**12-1300294*r**14
            +658859*r**16-247575*r**18-87995*r**20-1081*r**22+186*r**24)-4*Q2*(
            -1166+5788*r**2-64394*r**4+175131*r**6+1990*r**8-1021853*r**10-167156*r**12
            +2846098*r**14-2779082*r**16+685710*r**18-147906*r**20-50157*r**22-1454*r**24
            +51*r**26))*sqrtq2)*math.log(r))/(2073600*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+14400*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-6220800*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-259200*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-300*(-Q2+(-1
            +r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +((-138240*logq2**3*r**10*(-40*Q2**9*(2+5*r**4)+12*Q2**8*(64+67*r**2+136*r**4
            +95*r**6)-Q2**7*(2964+5561*r**2+8098*r**4+6581*r**6+2220*r**8)+Q2**6*(5844
            +14257*r**2+21265*r**4+17957*r**6+8131*r**8+1170*r**10)+3*Q2**5*(-1916
            -5405*r**2-8132*r**4-7670*r**6-3686*r**8-969*r**10+170*r**12)+(-1
            +r**2)**4*(-292-63*r**2+219*r**4-1566*r**6-726*r**8-1939*r**10+927*r**12
            +1040*r**14)+Q2**4*(1140+6475*r**2+7793*r**4+7904*r**6+3952*r**8+765*r**10
            +4555*r**12+3000*r**14)+Q2**3*(3492+721*r**2+2986*r**4+9717*r**6+7496*r**8
            +2139*r**10+1786*r**12-9857*r**14-9840*r**16)-Q2*(-1+r**2)**2*(-1716
            -295*r**2+218*r**4-9511*r**6-6446*r**8-5565*r**10-5586*r**12+4331*r**14
            +5370*r**16)+3*Q2**2*(-1292+517*r**2-203*r**4-5559*r**6-5197*r**8-1035*r**10
            -389*r**12-3849*r**14+617*r**16+3590*r**18))-192*logq2*(-Q2+(-1+r)**2)*r**4*(
            -Q2+(1+r)**2)*(-920*Q2**15*r**2+12*Q2**14*(-21+572*r**2+875*r**4)-Q2**13*(
            -1777+15074*r**2+71179*r**4+49780*r**6)+Q2**12*(-6251-14031*r**2+152445*r**4
            +268743*r**6+125990*r**8)-2*Q2**11*(-8682-97004*r**2-16530*r**4+60605*r**6
            +213422*r**8+86745*r**10)+2*Q2**10*(-20834-359512*r**2-565088*r**4-1099907*r**6
            -902725*r**8+20323*r**10+45695*r**12)+Q2**9*(70829+1518062*r**2+3608013*r**4
            +8193770*r**6+10788755*r**8+6288442*r**10+887307*r**12+86550*r**14)
            -Q2**8*(63459+1638207*r**2+5613479*r**4+13214831*r**6+22101185*r**8
            +19188625*r**10+8760689*r**12+1407777*r**14+175140*r**16)+4*Q2**7*(-1452
            +14538*r**2+905932*r**4+839501*r**6+3378670*r**8+4764103*r**10+3308128*r**12
            +1411297*r**14+260406*r**16+23205*r**18)+4*Q2**6*(19833+533126*r**2
            +225187*r**4+5699857*r**6+6882087*r**8+3697281*r**10-485709*r**12-159383*r**14
            -474518*r**16-132273*r**18+6320*r**20)+(-1+r**2)**4*(-1073-49561*r**2
            +115245*r**4-1761603*r**6+3348914*r**8+5096322*r**10-13337610*r**12
            -192490*r**14+4701183*r**16-47209*r**18+377181*r**20+22701*r**22)-Q2**5*(78309
            +2456262*r**2+2377025*r**4+35941784*r**6+52714602*r**8+45469332*r**10
            +19261698*r**12-6198560*r**14+3017089*r**16-1235098*r**18-315603*r**20
            +51720*r**22)+Q2**4*(18623+737699*r**2+1226687*r**4+15703665*r**6+25181300*r**8
            +11722222*r**10+16169542*r**12+8552418*r**14-7153185*r**16+2546655*r**18
            +332235*r**20-37571*r**22+17950*r**24)+Q2*(-1+r**2)**2*(7879+327496*r**2
            -760920*r**4+10198826*r**6-14172357*r**8-19970218*r**10+27758320*r**12
            +36551564*r**14-1568011*r**16-23072868*r**18+642664*r**20-1981366*r**22
            -137719*r**24+710*r**26)+2*Q2**3*(11566+369228*r**2-768346*r**4+6964643*r**6
            -4278730*r**8+7141235*r**10+5662748*r**12+2859738*r**14-9404478*r**16
            -10703210*r**18-497026*r**20-1705981*r**22-146022*r**24+1835*r**26)
            -2*Q2**2*(11058+404348*r**2-1137176*r**4+11128991*r**6-16256715*r**8
            -681471*r**10+7933849*r**12+9227002*r**14+16663368*r**16+6465490*r**18
            -19687282*r**20+1799783*r**22-1889071*r**24-160079*r**26+1905*r**28))
            -8294400*logq2**4*r**14*(-6-5*r**2+r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2-2304*logq2**2*r**6*(-16*Q2**12*(47+240*r**4)+8*Q2**11*(838
            +703*r**2+3800*r**4+4085*r**6)-Q2**10*(24862+39031*r**2+127212*r**4
            +206395*r**6+116240*r**8)+10*Q2**9*(4714+10743*r**2+31431*r**4+59787*r**6
            +54723*r**8+22090*r**10)-5*Q2**8*(7878+27663*r**2+68260*r**4+169030*r**6
            +196662*r**8+137147*r**10+47640*r**12)+4*Q2**7*(-3804+13560*r**2-77510*r**4
            -50645*r**6+31470*r**8+108321*r**10+89030*r**12+37470*r**14)+2*Q2**6*(34146
            +33621*r**2+742550*r**4+1383580*r**6+1430620*r**8+697981*r**10+72556*r**12
            +5110*r**14-37380*r**16)+4*Q2**5*(-15114-23877*r**2-457679*r**4-955300*r**6
            -1105430*r**8-759479*r**10-192147*r**12+54936*r**14-16330*r**16+10620*r**18)
            +10*Q2**4*(906+5697*r**2+59974*r**4+168425*r**6+146418*r**8+121827*r**10
            +61098*r**12+42967*r**14+22608*r**16+7052*r**18+3060*r**20)+(-1+r**2)**4*(
            -982-439*r**2-84336*r**4+100902*r**6+205300*r**8-292248*r**10-512256*r**12
            +91066*r**14+249378*r**16+19855*r**18+7760*r**20)-20*Q2**3*(-1192+1938*r**2
            -43130*r**4+11529*r**6-15186*r**8-67233*r**10-38514*r**12-19193*r**14
            +74042*r**16+94327*r**18+5612*r**20+5640*r**22)-2*Q2*(-1+r**2)**2*(
            -3602+1629*r**2-246615*r**4+201076*r**6+424162*r**8-533248*r**10-867284*r**12
            -809030*r**14+277304*r**16+629643*r**18+38755*r**20+23210*r**22)+Q2**2*(
            -20582+34285*r**2-1097520*r**4+1176275*r**6+473360*r**8-2040566*r**10
            -1463420*r**12-362770*r**14-2411330*r**16-207015*r**18+2304268*r**20
            +51055*r**22+107960*r**24))*sqrtq2+32*r**2*(45*Q2**18*r**2+2*Q2**17*r**2*(127
            +83*r**2)-Q2**16*(552+2593*r**2+31854*r**4+5725*r**6)+Q2**15*(5688
            -2166*r**2+225980*r**4+332122*r**6+38416*r**8)-Q2**14*(25050-76423*r**2
            +551570*r**4+1933616*r**6+1530900*r**8+136535*r**10)+2*Q2**13*(29400
            -173165*r**2-7985*r**4+2029954*r**6+3344428*r**8+1937487*r**10+151585*r**12)
            -Q2**12*(68250-850975*r**2-3812790*r**4+374495*r**6+6242434*r**8+10343875*r**10
            +5399514*r**12+438893*r**14)+2*Q2**11*(-1092-659031*r**2-6582074*r**4
            -9858925*r**6-13728846*r**8-9261317*r**10+979626*r**12+1332977*r**14
            +200330*r**16)+Q2**10*(126126+1245629*r**2+26156762*r**4+58325846*r**6
            +111491258*r**8+130117416*r**10+81426414*r**12+18297522*r**14+4015440*r**16
            -190333*r**18)-2*Q2**9*(85800+204083*r**2+15228995*r**4+42178764*r**6
            +87496680*r**8+128568510*r**10+112897898*r**12+61975780*r**14+15142584*r**16
            +4334495*r**18+715*r**20)+Q2**8*(64350-737495*r**2+10483310*r**4+53860449*r**6
            +59996108*r**8+152135022*r**10+213132940*r**12+165054430*r**14+91800774*r**16
            +23401353*r**18+6985462*r**20+25025*r**22)+2*Q2**7*(42900+677759*r**2
            +12820866*r**4+762275*r**6+109972604*r**8+111349430*r**10+62461164*r**12
            -21646202*r**14-15480580*r**16-16565781*r**18-6637870*r**20-1072137*r**22
            +25844*r**24)+2*(-1+r**2)**6*(201+3152*r**2+178553*r**4-1032672*r**6
            +6084658*r**8-15914992*r**10+8469878*r**12+15508688*r**14-13195015*r**16
            +2205392*r**18-884559*r**20-121680*r**22-5716*r**24+112*r**26)-Q2**6*(126126
            +1060467*r**2+42883502*r**4+2057740*r**6+383093536*r**8+361246199*r**10
            +342567500*r**12+198140992*r**14-60588210*r**16+20859281*r**18-4173114*r**20
            -10039660*r**22+640036*r**24+81445*r**26)-8*Q2*(-1+r**2)**4*(486+6460*r**2
            +368861*r**4-1757202*r**6+9733164*r**8-18776379*r**10-4175798*r**12
            +27017944*r**14+8602354*r**16-18223514*r**18+2883873*r**20-1550182*r**22
            -232100*r**24-10247*r**26+280*r**28)+2*Q2**5*(28392+150385*r**2+12179173*r**4
            -12515054*r**6+129769228*r**8+27943763*r**10+33558637*r**12+34518796*r**14
            +102309184*r**16-45560025*r**18+14190327*r**20+8921410*r**22-2271572*r**24
            +402357*r**26+19159*r**28)+2*Q2**2*(-1+r**2)**2*(7725+86139*r**2+4905884*r**4
            -20393536*r**6+106261857*r**8-165586435*r**10-40123448*r**12+86230214*r**14
            +228390551*r**16+21873077*r**18-167694532*r**20+28165524*r**22-16925733*r**24
            -2874925*r**26-118944*r**28+4582*r**30)+Q2**4*(13650+219493*r**2+4449610*r**4
            -4899281*r**6+35404310*r**8+46425585*r**10+48516934*r**12+95951835*r**14
            +196351422*r**16-332723425*r**18-98192650*r**20-2227*r**22-44188070*r**24
            -4932341*r**26-463110*r**28+7465*r**30)-2*Q2**3*(14700+141485*r**2+7532070*r**4
            -29533309*r**6+140946982*r**8-209180207*r**10+50756270*r**12+31131375*r**14
            -20047882*r**16+260197751*r**18+20959314*r**20-186135175*r**22+43096530*r**24
            -22443509*r**26-4312358*r**28-188907*r**30+8870*r**32))*sqrtq2)*math.log(r))/(6220800*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +43200*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3-18662400*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            -777600*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2-900*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+(flagPERP*(720*logq2**2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(-64+133*r**2+60*Q2**5*r**2+1223*r**4-10172*r**6-7372*r**8
            -1313*r**10+1005*r**12-32*Q2**4*(2+9*r**2+15*r**4)+Q2**3*(16+1453*r**2
            +2522*r**4+1485*r**6)-Q2**2*(-96+1069*r**2+3351*r**4+3783*r**6+765*r**8)
            -Q2*(-16+409*r**2+1378*r**4+146*r**6-462*r**8+1305*r**10))+(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(27+460*Q2**11-5281*r**2+3007*r**4
            -221525*r**6-568062*r**8+1862442*r**10-6856934*r**12+1636338*r**14+127395*r**16
            +49207*r**18-1049*r**20+35*r**22-1240*Q2**10*(1+r**2)+Q2**9*(-125+3558*r**2
            -125*r**4)+Q2**8*(987+r**2-4463*r**4+2475*r**6)-2*Q2**7*(-1802+8311*r**2
            +50954*r**4+4407*r**6+150*r**8)+Q2**6*(-4604+20782*r**2+325038*r**4
            +294014*r**6+28150*r**8-2820*r**10)+2*Q2**5*(-1011+10443*r**2-67095*r**4
            -357658*r**6-48031*r**8-853*r**10+165*r**12)+Q2**4*(3490-20928*r**2
            -209888*r**4+392158*r**6+839654*r**8-327160*r**10-38328*r**12+2250*r**14)
            +Q2**3*(328-32346*r**2+87100*r**4+421330*r**6+1121864*r**8-91758*r**10
            +273404*r**12+15718*r**14-600*r**16)-2*Q2**2*(482-8581*r**2-6865*r**4
            +350793*r**6+1495671*r**8+1043439*r**10+497177*r**12-5249*r**14-7697*r**16
            +350*r**18)+Q2*(59+14028*r**2-55101*r**4-351056*r**6-1362670*r**8
            +2088136*r**10-2583118*r**12+371376*r**14-101869*r**16-7220*r**18+235*r**20))
            -43200*logq2**3*r**10*(-16+47*r**2+46*r**4+15*r**6)*sqrtq2+12*logq2*r**2*(80*(
            -1+Q2)**6*(-1+Q2+6*Q2**2+4*Q2**3)+(-1+Q2)**5*(1181+3445*Q2+255*Q2**2
            -6905*Q2**3-5520*Q2**4+1544*Q2**5)*r**2-10*(-1+Q2)**2*(457+936*Q2
            +3159*Q2**2-1584*Q2**3+1995*Q2**4+2812*Q2**5-5163*Q2**6+1228*Q2**7)*r**4
            +5*(-9353+6648*Q2+6152*Q2**2+121012*Q2**3-153418*Q2**4+37808*Q2**5
            +34544*Q2**6-29564*Q2**7+6651*Q2**8)*r**6-20*(-11504-3858*Q2-25076*Q2**2
            -65995*Q2**3+69164*Q2**4-5792*Q2**5-5824*Q2**6+1557*Q2**7)*r**8-10*(111543
            -146944*Q2+30208*Q2**2-149158*Q2**3+65341*Q2**4+646*Q2**5+1788*Q2**6)*r**10
            +4*(340133+504680*Q2-76300*Q2**2+114425*Q2**3-22765*Q2**4+14283*Q2**5)*r**12
            -10*(-13177-95780*Q2-44612*Q2**2-11846*Q2**3+3237*Q2**4)*r**14-20*(34668
            +27678*Q2+2204*Q2**2+519*Q2**3)*r**16+5*(24359-5036*Q2+3528*Q2**2)*r**18
            -10*(-1671+602*Q2)*r**20+499*r**22)*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(-2073600*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-14400*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +6220800*logq2**4*r**16*sqrtq2+259200*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2+300*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)+((-720*logq2**2*r**4*(20*Q2**7*(2
            +5*r**4)-8*Q2**6*(56+70*r**2+137*r**4+125*r**6)+Q2**5*(1278+2808*r**2
            +5511*r**4+6236*r**6+3675*r**8)-Q2**4*(1310+3674*r**2+9025*r**4+13293*r**6
            +11565*r**8+5525*r**10)+2*Q2**3*(10+858*r**2+2748*r**4+4516*r**6+5401*r**8
            +2730*r**10+925*r**12)+(-1+r**2)**2*(122+222*r**2+7521*r**4+14321*r**6
            +7246*r**8-1086*r**10-r**12+1175*r**14)+2*Q2**2*(450-432*r**2+2549*r**4
            +2364*r**6-687*r**8-2179*r**10+980*r**12+1875*r**14)-Q2*(602-596*r**2
            +17123*r**4+40792*r**6+43217*r**8+18200*r**10-3927*r**12-1356*r**14
            +4025*r**16))-(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(460*Q2**13-16*Q2**12*(82
            +135*r**2)+Q2**11*(1529+4740*r**2+2815*r**4)+Q2**10*(1819-3033*r**2
            -6551*r**4+1485*r**6)-Q2**9*(23303+17090*r**2+115130*r**4+6710*r**6
            +5375*r**8)+Q2**8*(62417+40597*r**2+327980*r**4+552804*r**6+50555*r**8
            +255*r**10)+Q2**7*(-57754-28928*r**2-262978*r**4-974832*r**6-812682*r**8
            -74656*r**10+5670*r**12)-2*Q2**6*(11903-48025*r**2+142215*r**4-388557*r**6
            -706385*r**8-20297*r**10+995*r**12+615*r**14)+2*Q2**5*(42997-133354*r**2
            +970036*r**4+850926*r**6+851232*r**8-683938*r**10+495816*r**12+47086*r**14
            -2385*r**16)+Q2**4*(-50522+207550*r**2-3318940*r**4-4644060*r**6-7089020*r**8
            -8579388*r**10-8740*r**12-892740*r**14-60490*r**16+2750*r**18)+Q2**3*(
            -11727+89948*r**2+1125795*r**4+3085184*r**6+6539270*r**8+4213752*r**10
            +5518802*r**12+1736640*r**14+112201*r**16-21780*r**18+1035*r**20)+Q2**2*(24291
            -184457*r**2+2140933*r**4-3316247*r**6+66738*r**8-8819574*r**10-3668978*r**12
            +7653702*r**14-1290453*r**16+279487*r**18+30893*r**20-1135*r**22)+(
            -1+r**2)**2*(937+3615*r**2+431077*r**4-1573101*r**6+8535566*r**8+2653074*r**10
            -5607690*r**12+2405258*r**14+183561*r**16+53519*r**18-1051*r**20+35*r**22)
            +Q2*(-9023+61750*r**2-1974350*r**4+5447050*r**6-15554525*r**8-20228524*r**10
            -3778340*r**12+16573420*r**14-8765065*r**16+104310*r**18-210318*r**20
            -5750*r**22+165*r**24))-43200*logq2**3*r**8*(27+66*r**2+25*r**4+46*r**6)*sqrtq2
            -12*logq2*(8*Q2**10*(47+240*r**4)-40*Q2**9*(47+33*r**2+254*r**4+360*r**6)
            +5*Q2**8*(663+822*r**2+3147*r**4+11002*r**6+7530*r**8)-20*Q2**7*(78
            +311*r**2+197*r**4+3147*r**6+5189*r**8+1710*r**10)-20*Q2**6*(117-375*r**2
            +2667*r**4+739*r**6-2220*r**8-4132*r**10+1020*r**12)+4*Q2**5*(822-855*r**2
            +49350*r**4+99260*r**6+128770*r**8+87217*r**10+1010*r**12+15690*r**14)
            -10*Q2**4*(87+628*r**2+24775*r**4+70724*r**6+117149*r**8+150572*r**10
            +90983*r**12+10444*r**14+3510*r**16)-20*Q2**3*(42-387*r**2-1779*r**4
            -19931*r**6-42087*r**8-57495*r**10-46105*r**12-22757*r**14-6487*r**16
            +570*r**18)+(-1+r**2)**2*(11+592*r**2+30668*r**4-22346*r**6+715940*r**8
            +1405134*r**10-430102*r**12-161478*r**14+212161*r**16+20050*r**18+570*r**20)
            +20*Q2**2*(33-39*r**2+7809*r**4-8255*r**6+4379*r**8-15091*r**10-55217*r**12
            +5335*r**14+32452*r**16-1886*r**18+960*r**20)-20*Q2*(8+95*r**2+6056*r**4
            -7924*r**6+74172*r**8+189052*r**10+137992*r**12-51814*r**14-31044*r**16
            +35605*r**18+1712*r**20+330*r**22))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(-1555200*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-10800*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +4665600*logq2**4*r**16*sqrtq2+194400*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2+225*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)+((24*logq2*(24*Q2**6*(2
            +5*r**4)-Q2**5*(168+133*r**2+540*r**4+795*r**6)-2*Q2**3*r**2*(73+268*r**2
            +570*r**4+590*r**6+375*r**8)+Q2**4*(180+159*r**2+645*r**4+1825*r**6
            +1575*r**8)-(-1+r**2)**2*(12+37*r**2+2117*r**4+3922*r**6-558*r**8
            -415*r**10+405*r**12)-2*Q2**2*(60-167*r**2+799*r**4+538*r**6-700*r**8
            -135*r**10+525*r**12)+Q2*(72-201*r**2+4924*r**4+10719*r**6+7964*r**8
            -1103*r**10-1600*r**12+1305*r**14))-1440*logq2**2*r**4*(12+19*r**2+15*r**4)*sqrtq2
            +2*(120*Q2**9-3*Q2**8*(87+155*r**2)+Q2**7*(258+596*r**2+450*r**4)+Q2**6*(420
            -514*r**2-808*r**4+390*r**6)-6*Q2**5*(441+230*r**2+1306*r**4-98*r**6
            +145*r**8)+2*Q2**4*(1905+622*r**2+6030*r**4+13410*r**6+955*r**8+90*r**10)
            +2*Q2**3*(-477-362*r**2-6203*r**4-3468*r**6-8555*r**8-1802*r**10+195*r**12)
            -6*Q2**2*(378-1147*r**2+1784*r**4-3549*r**6-2410*r**8+3143*r**10-64*r**12
            +25*r**14)+(-1+r**2)**2*(-549+3179*r**2-33609*r**4-12869*r**6+18541*r**8
            -6915*r**10-943*r**12+45*r**14)+Q2*(2070-9916*r**2+66480*r**4+75468*r**6
            +27908*r**8-53892*r**10+22224*r**12+2228*r**14-90*r**16))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(19440*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+45*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-77760*logq2**3*r**12*sqrtq2
            -1620*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(flagPERP*(24*logq2*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-10-11*r**2-36*Q2**4*r**2+14*r**4
            -1326*r**6-416*r**8+189*r**10+2*Q2**3*(-5+132*r**2+117*r**4)-Q2**2*(
            -10+191*r**2+524*r**4+171*r**6)-2*Q2*(-5+93*r**2+2*r**4-68*r**6
            +108*r**8))-720*logq2**2*r**6*(-4+21*r**2+9*r**4)*sqrtq2+(5*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(-15+24*Q2**4-22*r**2-22*r**4-70*r**6+9*r**8
            -21*Q2**3*(1+r**2)+Q2**2*(-21+38*r**2-21*r**4)+Q2*(-15+29*r**2-43*r**4
            +9*r**6))-6*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(-3+5*Q2**3+5*r**2-19*r**4
            +5*r**6-5*Q2**2*(1+r**2)+Q2*(-5+8*r**2-5*r**4))*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8)))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(12960*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+30*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-51840*logq2**3*r**12*sqrtq2
            -1080*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(flagPERP*((Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(-3+5*Q2**3+5*r**2-19*r**4+5*r**6-5*Q2**2*(1
            +r**2)+Q2*(-5+8*r**2-5*r**4))-12*logq2*r**4*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(
            -48*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+288*logq2**2*r**8*sqrtq2+2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2)+((-2*(5*Q2**5-Q2**4*(7+15*r**2)+2*Q2**3*(4
            +2*r**2+5*r**4)+(-1+r**2)**2*(17+r**2-11*r**4+5*r**6)+2*Q2**2*(7
            -6*r**2-4*r**4+5*r**6)-Q2*(37+20*r**2+8*r**4-32*r**6+15*r**8))-24*logq2*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(
            -72*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+432*logq2**2*r**8*sqrtq2+3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2)+((3600*logq2**2*r**8*(15+22*r**2+15*r**4)
            +(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4+19308*r**6
            +138690*r**8+19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1
            +r**2)+Q2**6*(-89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4
            +79*r**6)+Q2**4*(165-1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19
            -280*r**2-2439*r**4-2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2
            +1787*r**4-14228*r**6+1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2
            -2957*r**4+19165*r**6+19165*r**8-2957*r**10-635*r**12+27*r**14))+600*logq2*r**4*(1
            +2*Q2**5+35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)
            +Q2**3*(17+42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(
            -11+30*r**2+66*r**4+30*r**6-11*r**8))*sqrtq2)*nlopw.X1Q2RhoD(0,Q2,r))/(
            -259200*logq2**3*r**12-5400*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+64800*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+150*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((180*logq2*r**4*(1+r**2)+(-3-8*Q2**4
            +42*r**2+282*r**4+42*r**6-3*r**8+7*Q2**3*(1+r**2)+Q2**2*(7-2*r**2
            +7*r**4)-3*Q2*(1-11*r**2-11*r**4+r**6))*sqrtq2)*nlopw.X1Q2RhoD(1,Q2,r))/(720*logq2**2*r**8
            +5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+nlopw.X1Q2RhoD(2,Q2,r)/(
            -12*logq2*r**4+(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)))
        if( flagDEBUG == 1):
            print("Q2moment n. 2 NLO pw = api*",resNLO*par.mbkin**4)
        res += api*resNLO

    if(kwargs.get('flag_includeNNLO', 1) == 1):
        resNNLO = 0
        resNNLO +=((flagPERP*muWC**5*(-552960*logq2**3*(-Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)*(140*Q2**7*r**2
            -8*Q2**6*(3+70*r**2+112*r**4)+Q2**5*(119+824*r**2+2511*r**4+2226*r**6)
            -Q2**4*(175+577*r**2+2225*r**4+4083*r**6+2380*r**8)+2*Q2**3*(55+14*r**2
            +394*r**4+966*r**6+1391*r**8+140*r**10)+(-1+r**2)**2*(-59+291*r**2
            -670*r**4+570*r**6+125*r**8-141*r**10+364*r**12)+2*Q2**2*(-55+104*r**2
            -228*r**4+50*r**6+83*r**8-714*r**10+840*r**12)-Q2*(-139+472*r**2
            -1649*r**4+510*r**6+1995*r**8+964*r**10-1647*r**12+1414*r**14))-768*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(92*Q2**13*r**2-8*Q2**12*(-25+181*r**2
            +99*r**4)+Q2**11*(-1155+5532*r**2+11661*r**4+2618*r**6)-Q2**10*(-2405
            +11757*r**2+28821*r**4+30239*r**6+3588*r**8)-Q2**9*(1505-24582*r**2
            +4202*r**4+99752*r**6-6755*r**8+550*r**10)+Q2**8*(-1905-47467*r**2
            +83394*r**4+796330*r**6+802611*r**8+108465*r**10+8076*r**12)-2*Q2**7*(
            -1785-27594*r**2+47299*r**4+703138*r**6+1480015*r**8+809198*r**10+98067*r**12
            +4398*r**14)+Q2**6*(-1470-26462*r**2+51498*r**4+946834*r**6+2542418*r**8
            +3732690*r**10+776698*r**12+69258*r**14-456*r**16)+2*Q2**5*(-345-1982*r**2
            -23174*r**4-267006*r**6+412206*r**8+636094*r**10-433582*r**12+779286*r**14
            +78879*r**16+4008*r**18)-2*Q2**4*(-315-2459*r**2-19596*r**4-383216*r**6
            +647308*r**8+2903228*r**10+2863592*r**12+833524*r**14+1142819*r**16
            +93915*r**18+2800*r**20)+Q2**3*(-95+1200*r**2-20719*r**4-457150*r**6
            +466646*r**8+1695680*r**10+6636998*r**12+2066364*r**14+1646985*r**16
            +601424*r**18+34985*r**20-318*r**22)+(-1+r**2)**2*(35+1091*r**2+10121*r**4
            +9397*r**6-188810*r**8+1992938*r**10-2362306*r**12-688058*r**14+1634363*r**16
            -217005*r**18+145337*r**20+8325*r**22+172*r**24)+Q2**2*(105+1835*r**2
            +28675*r**4-85539*r**6-254590*r**8-263966*r**10+1359538*r**12-5454898*r**14
            +5154889*r**16-1650125*r**18+757131*r**20+59157*r**22+2188*r**24)-Q2*(125
            +3270*r**2+26914*r**4-110508*r**6-67465*r**8+1523930*r**10-852740*r**12
            +1607192*r**14-6129829*r**16+6226490*r**18-1484830*r**20+598420*r**22
            +40369*r**24+1062*r**26))-33177600*logq2**4*r**16*(-3+2*r**2+3*r**4)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-9216*logq2**2*r**8*(1512*Q2**12*r**2
            -8*Q2**11*(10+1643*r**2+1803*r**4)+Q2**10*(475+48062*r**2+101811*r**4
            +57072*r**6)-10*Q2**9*(131+9529*r**2+27569*r**4+31173*r**6+11574*r**8)
            +5*Q2**8*(423+23194*r**2+69078*r**4+98922*r**6+89943*r**8+21288*r**10)
            +2*Q2**7*(-780-52247*r**2-83990*r**4+4820*r**6+18870*r**8-106545*r**10
            +14448*r**12)-2*Q2**6*(525-46639*r**2+24786*r**4+370550*r**6+767925*r**8
            +628665*r**10+116676*r**12+89376*r**14)+2*Q2**5*(1470-40037*r**2+58844*r**4
            +366163*r**6+917190*r**8+1191725*r**10+801828*r**12+192549*r**14+86268*r**16)
            +(-1+r**2)**4*(335-748*r**2-7626*r**4+82556*r**6-82852*r**8-3420*r**10
            -24262*r**12+72116*r**14+3909*r**16+3192*r**18)-10*Q2**4*(69-4319*r**2
            +10851*r**4+26111*r**6+83507*r**8+111627*r**10+131245*r**12+42081*r**14
            +21192*r**16+3396*r**18)-10*Q2**3*(324+157*r**2-8746*r**4+9002*r**6
            -34050*r**8-1088*r**10+23014*r**12-58402*r**14+82206*r**16-7461*r**18
            +6564*r**20)-2*Q2*(-1+r**2)**2*(935-2888*r**2-15584*r**4+123620*r**6
            -63896*r**8-60092*r**10+69218*r**12-101636*r**14+207985*r**16+3876*r**18
            +11262*r**20)+Q2**2*(3935-14868*r**2-51295*r**4+306880*r**6-392810*r**8
            +162200*r**10+103426*r**12+734320*r**14-1104805*r**16+939260*r**18-56435*r**20
            +61392*r**22))*sqrtq2+128*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**14*r**2
            +2*Q2**13*(33-76*r**2+r**4)+Q2**12*(-571+743*r**2+4079*r**4-251*r**6)
            +Q2**11*(2133+742*r**2-37120*r**4-25218*r**6+983*r**8)+Q2**10*(-4433
            -5026*r**2+96946*r**4+193578*r**6+59899*r**8-1436*r**10)+Q2**9*(5445
            -9274*r**2-145403*r**4-148308*r**6-274041*r**8-29770*r**10+71*r**12)
            +2*Q2**8*(-1881+28282*r**2+125826*r**4-333010*r**6-841779*r**8-173534*r**10
            -62418*r**12+1218*r**14)+2*Q2**7*(561-41618*r**2-190564*r**4+619678*r**6
            +3049876*r**8+3008310*r**10+685684*r**12+117366*r**14-1389*r**16)+Q2**6*(
            -66+43811*r**2+254404*r**4-686044*r**6-5125052*r**8-11777466*r**10
            -5701324*r**12-1085356*r**14-83274*r**16+159*r**18)+4*Q2**5*(99+733*r**2
            +11859*r**4+38602*r**6+352209*r**8-316158*r**10+2036593*r**12-898926*r**14
            -156808*r**16-41667*r**18+488*r**20)-Q2**4*(495+5033*r**2+138217*r**4
            +97187*r**6+3057050*r**8-7935706*r**10-15860242*r**12+3609522*r**14
            -9616473*r**16-1425791*r**18-189095*r**20+1403*r**22)-Q2**3*(-121+2562*r**2
            -44576*r**4-45110*r**6-2943617*r**8+5162588*r**10+6509696*r**12+13052108*r**14
            -1004435*r**16+3957282*r**18+553248*r**20+29162*r**22+13*r**24)+2*(
            -1+r**2)**2*(6-741*r**2-1089*r**4-46960*r**6+41661*r**8+368027*r**10
            -4503046*r**12+8820368*r**14-5940772*r**16+1383449*r**18-339673*r**20
            -36928*r**22-3519*r**24+17*r**26)+Q2**2*(99-3032*r**2+6754*r**4-151910*r**6
            +372617*r**8+2142070*r**10-5660852*r**12+15475692*r**14-16815179*r**16
            +8424028*r**18-2586094*r**20-281286*r**22-59361*r**24+454*r**26)+Q2*(
            -67+5022*r**2-4779*r**4+233532*r**6-1014987*r**8+2668434*r**10-4804579*r**12
            +25050728*r**14-49323649*r**16+37997154*r**18-11525017*r**20+2480732*r**22
            +273551*r**24+37742*r**26-217*r**28))*sqrtq2))/(55987200*logq2**3*(-Q2
            +(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+388800*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-167961600*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-6998400*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-8100*(-Q2+(-1
            +r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(flagPERP*muWC**4*(-4423680*logq2**3*(-Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)*(140*Q2**7*r**2
            -8*Q2**6*(3+70*r**2+112*r**4)+Q2**5*(119+824*r**2+2511*r**4+2226*r**6)
            -Q2**4*(175+577*r**2+2225*r**4+4083*r**6+2380*r**8)+2*Q2**3*(55+14*r**2
            +394*r**4+966*r**6+1391*r**8+140*r**10)+(-1+r**2)**2*(-59+291*r**2
            -670*r**4+570*r**6+125*r**8-141*r**10+364*r**12)+2*Q2**2*(-55+104*r**2
            -228*r**4+50*r**6+83*r**8-714*r**10+840*r**12)-Q2*(-139+472*r**2
            -1649*r**4+510*r**6+1995*r**8+964*r**10-1647*r**12+1414*r**14))-6144*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(92*Q2**13*r**2-8*Q2**12*(-25+181*r**2
            +99*r**4)+Q2**11*(-1155+5532*r**2+11661*r**4+2618*r**6)-Q2**10*(-2405
            +11757*r**2+28821*r**4+30239*r**6+3588*r**8)-Q2**9*(1505-24582*r**2
            +4202*r**4+99752*r**6-6755*r**8+550*r**10)+Q2**8*(-1905-47467*r**2
            +83394*r**4+796330*r**6+802611*r**8+108465*r**10+8076*r**12)-2*Q2**7*(
            -1785-27594*r**2+47299*r**4+703138*r**6+1480015*r**8+809198*r**10+98067*r**12
            +4398*r**14)+Q2**6*(-1470-26462*r**2+51498*r**4+946834*r**6+2542418*r**8
            +3732690*r**10+776698*r**12+69258*r**14-456*r**16)+2*Q2**5*(-345-1982*r**2
            -23174*r**4-267006*r**6+412206*r**8+636094*r**10-433582*r**12+779286*r**14
            +78879*r**16+4008*r**18)-2*Q2**4*(-315-2459*r**2-19596*r**4-383216*r**6
            +647308*r**8+2903228*r**10+2863592*r**12+833524*r**14+1142819*r**16
            +93915*r**18+2800*r**20)+Q2**3*(-95+1200*r**2-20719*r**4-457150*r**6
            +466646*r**8+1695680*r**10+6636998*r**12+2066364*r**14+1646985*r**16
            +601424*r**18+34985*r**20-318*r**22)+(-1+r**2)**2*(35+1091*r**2+10121*r**4
            +9397*r**6-188810*r**8+1992938*r**10-2362306*r**12-688058*r**14+1634363*r**16
            -217005*r**18+145337*r**20+8325*r**22+172*r**24)+Q2**2*(105+1835*r**2
            +28675*r**4-85539*r**6-254590*r**8-263966*r**10+1359538*r**12-5454898*r**14
            +5154889*r**16-1650125*r**18+757131*r**20+59157*r**22+2188*r**24)-Q2*(125
            +3270*r**2+26914*r**4-110508*r**6-67465*r**8+1523930*r**10-852740*r**12
            +1607192*r**14-6129829*r**16+6226490*r**18-1484830*r**20+598420*r**22
            +40369*r**24+1062*r**26))-265420800*logq2**4*r**16*(-3+2*r**2+3*r**4)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-73728*logq2**2*r**8*(1512*Q2**12*r**2
            -8*Q2**11*(10+1643*r**2+1803*r**4)+Q2**10*(475+48062*r**2+101811*r**4
            +57072*r**6)-10*Q2**9*(131+9529*r**2+27569*r**4+31173*r**6+11574*r**8)
            +5*Q2**8*(423+23194*r**2+69078*r**4+98922*r**6+89943*r**8+21288*r**10)
            +2*Q2**7*(-780-52247*r**2-83990*r**4+4820*r**6+18870*r**8-106545*r**10
            +14448*r**12)-2*Q2**6*(525-46639*r**2+24786*r**4+370550*r**6+767925*r**8
            +628665*r**10+116676*r**12+89376*r**14)+2*Q2**5*(1470-40037*r**2+58844*r**4
            +366163*r**6+917190*r**8+1191725*r**10+801828*r**12+192549*r**14+86268*r**16)
            +(-1+r**2)**4*(335-748*r**2-7626*r**4+82556*r**6-82852*r**8-3420*r**10
            -24262*r**12+72116*r**14+3909*r**16+3192*r**18)-10*Q2**4*(69-4319*r**2
            +10851*r**4+26111*r**6+83507*r**8+111627*r**10+131245*r**12+42081*r**14
            +21192*r**16+3396*r**18)-10*Q2**3*(324+157*r**2-8746*r**4+9002*r**6
            -34050*r**8-1088*r**10+23014*r**12-58402*r**14+82206*r**16-7461*r**18
            +6564*r**20)-2*Q2*(-1+r**2)**2*(935-2888*r**2-15584*r**4+123620*r**6
            -63896*r**8-60092*r**10+69218*r**12-101636*r**14+207985*r**16+3876*r**18
            +11262*r**20)+Q2**2*(3935-14868*r**2-51295*r**4+306880*r**6-392810*r**8
            +162200*r**10+103426*r**12+734320*r**14-1104805*r**16+939260*r**18-56435*r**20
            +61392*r**22))*sqrtq2+1024*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**14*r**2
            +2*Q2**13*(33-76*r**2+r**4)+Q2**12*(-571+743*r**2+4079*r**4-251*r**6)
            +Q2**11*(2133+742*r**2-37120*r**4-25218*r**6+983*r**8)+Q2**10*(-4433
            -5026*r**2+96946*r**4+193578*r**6+59899*r**8-1436*r**10)+Q2**9*(5445
            -9274*r**2-145403*r**4-148308*r**6-274041*r**8-29770*r**10+71*r**12)
            +2*Q2**8*(-1881+28282*r**2+125826*r**4-333010*r**6-841779*r**8-173534*r**10
            -62418*r**12+1218*r**14)+2*Q2**7*(561-41618*r**2-190564*r**4+619678*r**6
            +3049876*r**8+3008310*r**10+685684*r**12+117366*r**14-1389*r**16)+Q2**6*(
            -66+43811*r**2+254404*r**4-686044*r**6-5125052*r**8-11777466*r**10
            -5701324*r**12-1085356*r**14-83274*r**16+159*r**18)+4*Q2**5*(99+733*r**2
            +11859*r**4+38602*r**6+352209*r**8-316158*r**10+2036593*r**12-898926*r**14
            -156808*r**16-41667*r**18+488*r**20)-Q2**4*(495+5033*r**2+138217*r**4
            +97187*r**6+3057050*r**8-7935706*r**10-15860242*r**12+3609522*r**14
            -9616473*r**16-1425791*r**18-189095*r**20+1403*r**22)-Q2**3*(-121+2562*r**2
            -44576*r**4-45110*r**6-2943617*r**8+5162588*r**10+6509696*r**12+13052108*r**14
            -1004435*r**16+3957282*r**18+553248*r**20+29162*r**22+13*r**24)+2*(
            -1+r**2)**2*(6-741*r**2-1089*r**4-46960*r**6+41661*r**8+368027*r**10
            -4503046*r**12+8820368*r**14-5940772*r**16+1383449*r**18-339673*r**20
            -36928*r**22-3519*r**24+17*r**26)+Q2**2*(99-3032*r**2+6754*r**4-151910*r**6
            +372617*r**8+2142070*r**10-5660852*r**12+15475692*r**14-16815179*r**16
            +8424028*r**18-2586094*r**20-281286*r**22-59361*r**24+454*r**26)+Q2*(
            -67+5022*r**2-4779*r**4+233532*r**6-1014987*r**8+2668434*r**10-4804579*r**12
            +25050728*r**14-49323649*r**16+37997154*r**18-11525017*r**20+2480732*r**22
            +273551*r**24+37742*r**26-217*r**28))*sqrtq2))/(167961600*logq2**3*(-Q2
            +(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+1166400*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-503884800*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-20995200*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-24300*(-Q2+(
            -1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(muWC**5*(552960*logq2**3*r**10*(20*Q2**9*(3+35*r**4)-24*Q2**8*(13+31*r**2
            +195*r**4+245*r**6)+Q2**7*(561+3183*r**2+14117*r**4+28285*r**6+20790*r**8)
            -Q2**6*(261+4962*r**2+18436*r**4+49542*r**6+65215*r**8+38640*r**10)
            +3*Q2**5*(79+1041*r**2+2054*r**4+11700*r**6+20173*r**8+21195*r**10
            +12110*r**12)+(-1+r**2)**4*(-627-186*r**2-1181*r**4+3424*r**6+7779*r**8
            -4034*r**10+1645*r**12+1820*r**14)-Q2**4*(2625+2490*r**2-1373*r**4
            +9664*r**6+19295*r**8+22570*r**10+9725*r**12+6300*r**14)+Q2**3*(6147
            +3909*r**2+15113*r**4+8709*r**6-44529*r**8-17033*r**10+16299*r**12
            -20545*r**14-22470*r**16)-Q2*(-1+r**2)**2*(-3171-1599*r**2-9791*r**4
            +6599*r**6+47789*r**8+29055*r**10-17377*r**12+6905*r**14+10710*r**16)
            +3*Q2**2*(-2117+134*r**2-6638*r**4+918*r**6+17288*r**8+22490*r**10
            +19054*r**12-12974*r**14-195*r**16+8120*r**18))+768*logq2*(-Q2+(-1
            +r)**2)*r**2*(-Q2+(1+r)**2)*(460*Q2**15*(1+r**4)-16*Q2**14*(271+180*r**2
            +122*r**4+305*r**6)+Q2**13*(17591+22381*r**2-321*r**4+23239*r**6+21470*r**8)
            -Q2**12*(38997+71154*r**2-13660*r**4-63114*r**6+81103*r**8+48080*r**10)
            +2*Q2**11*(23765+57106*r**2-87123*r**4-259071*r**6-496416*r**8+981*r**10
            +23110*r**12)+Q2**10*(-21098-85754*r**2+994664*r**4+2585400*r**6+5438766*r**8
            +5928510*r**10+693684*r**12+27940*r**14)-Q2**9*(23023-3905*r**2+2624031*r**4
            +8486141*r**6+17216595*r**8+22887189*r**10+16387405*r**12+1976671*r**14
            +127490*r**16)+Q2**8*(38973+44328*r**2+3555492*r**4+14690164*r**6+32124314*r**8
            +44264612*r**10+41459860*r**12+20832372*r**14+2349777*r**16+126060*r**18)
            +4*Q2**7*(-3894-15588*r**2-587010*r**4-3211417*r**6-6820541*r**8-8121137*r**10
            -6493533*r**12-6089925*r**14-598707*r**16-118221*r**18+165*r**20)-4*Q2**6*(2695
            -24699*r**2-102968*r**4-1439568*r**6-2418516*r**8+4240474*r**10+14185204*r**12
            +16406922*r**14+5039017*r**16+6929869*r**18+525096*r**20+27610*r**22)
            +Q2**5*(13321-98337*r**2+325217*r**4-2538339*r**6-10704756*r**8+19868014*r**10
            +76736378*r**12+124345850*r**14+112154161*r**16+31357139*r**18+34323525*r**20
            +2523977*r**22+94490*r**24)+(-1+r**2)**4*(67-3016*r**2-86182*r**4+187460*r**6
            -4240939*r**8+8589228*r**10+11184140*r**12-21309512*r**14+4377165*r**16
            +7013824*r**18-299110*r**20+767236*r**22+39579*r**24+860*r**26)-Q2**4*(2891
            -17150*r**2+463692*r**4-1938706*r**6-6680745*r**8+7665124*r**10+16301560*r**12
            +46186676*r**14+46009841*r**16+33899490*r**18+9837340*r**20+11568990*r**22
            +824077*r**24+13880*r**26)-Q2*(-1+r**2)**2*(625-20817*r**2-451058*r**4
            +754596*r**6-20346823*r**8+25302751*r**10+43934394*r**12+5449240*r**14
            -59204389*r**16+12569813*r**18+40659394*r**20-3942332*r**22+4784763*r**24
            +269213*r**26+7030*r**28)-2*Q2**3*(1407-28758*r**2-418177*r**4+630759*r**6
            -10776718*r**8-5102761*r**10-3226520*r**12-4555646*r**14-12056017*r**16
            +9171908*r**18+33983459*r**20-3637097*r**22+4689888*r**24+295483*r**26
            +14390*r**28)+2*Q2**2*(1099-28297*r**2-430260*r**4+858932*r**6-18013339*r**8
            +19754877*r**10+7416014*r**12+17072930*r**14+33297381*r**16-33482847*r**18
            -19832016*r**20+46290528*r**22-8955925*r**24+5468907*r**26+337206*r**28
            +11210*r**30))+33177600*logq2**4*r**14*(-15-15*r**2+65*r**4+r**6)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+9216*logq2**2*r**6*(8*Q2**12*(193
            +945*r**4)-8*Q2**11*(1731+1931*r**2+6385*r**4+9015*r**6)+Q2**10*(51399
            +109687*r**2+234449*r**4+387745*r**6+285360*r**8)-10*Q2**9*(10145+30640*r**2
            +70388*r**4+111170*r**6+113683*r**8+57870*r**10)+5*Q2**8*(22347+85581*r**2
            +224830*r**4+349498*r**6+340743*r**8+292273*r**10+106440*r**12)+2*Q2**7*(
            -31284-157260*r**2-426345*r**4-385710*r**6+302560*r**8+603306*r**10
            -124595*r**12+72240*r**14)-2*Q2**6*(-4263-68103*r**2-167270*r**4+449000*r**6
            +2280375*r**8+4211027*r**10+3566302*r**12+773780*r**14+446880*r**16)
            +2*Q2**5*(5346-36372*r**2-116849*r**4+198270*r**6+1720655*r**8+4465656*r**10
            +5477193*r**12+4269906*r**14+904855*r**16+431340*r**18)+(-1+r**2)**4*(
            -1741-2607*r**2-178458*r**4+135506*r**6+623940*r**8-23244*r**10-347518*r**12
            +96558*r**14+428169*r**16+31035*r**18+15960*r**20)-10*Q2**4*(1845-4545*r**2
            +27477*r**4-15049*r**6+57223*r**8+295849*r**10+476539*r**12+217797*r**14
            +203520*r**16+73852*r**18+16980*r**20)-10*Q2**3*(-2824+888*r**2-139405*r**4
            -59682*r**6-129706*r**8+5026*r**10+188268*r**12-275562*r**14+267234*r**16
            +478654*r**18-8591*r**20+32820*r**22)-2*Q2*(-1+r**2)**2*(-5211-4618*r**2
            -446170*r**4+55818*r**6+976656*r**8+976256*r**10+855378*r**12-778560*r**14
            +152027*r**16+1219914*r**18+52600*r**20+56310*r**22)+Q2**2*(-24501+5995*r**2
            -1684445*r**4+620575*r**6+582290*r**8+1930802*r**10+5367610*r**12+6460130*r**14
            -3949405*r**16-2403245*r**18+5337619*r**20-108785*r**22+306960*r**24))*sqrtq2
            -128*r**2*(8*Q2**19-Q2**18*(139+35*r**2)+6*Q2**17*(-1+10*r**2+31*r**4)
            +Q2**16*(16715+3669*r**2+18225*r**4-2345*r**6)+Q2**15*(-142133-88278*r**2
            -73236*r**4-174890*r**6+14681*r**8)+Q2**14*(569185+539307*r**2+24522*r**4
            +531726*r**6+765861*r**8-48489*r**10)+Q2**13*(-1311069-1538650*r**2
            +612251*r**4+1607560*r**6-1342427*r**8-1760622*r**10+90685*r**12)-Q2**12*(
            -1748057-2475511*r**2+3954197*r**4+12772979*r**6+16541441*r**8+1374287*r**10
            -1593901*r**12+82693*r**14)+Q2**11*(-1003081-2848542*r**2+15955794*r**4
            +50292290*r**6+87397284*r**8+83128158*r**10+15784590*r**12+2227326*r**14
            -20475*r**16)+Q2**10*(-694617+3810841*r**2-40218036*r**4-133919964*r**6
            -255246234*r**8-298404454*r**10-218606172*r**12-38889268*r**14-8622669*r**16
            +151437*r**18)+Q2**9*(1770131-5507754*r**2+62442081*r**4+212605108*r**6
            +428295358*r**8+556569048*r**10+480581186*r**12+288617036*r**14+43121903*r**16
            +10786578*r**18-171171*r**20)+Q2**8*(-1242645+4338885*r**2-56430357*r**4
            -188549475*r**6-350031086*r**8-383702898*r**10-362374190*r**12-262980802*r**14
            -78738765*r**16-7135491*r**18-4023789*r**20+51285*r**22)+Q2**7*(20929
            +1145598*r**2+20384376*r**4+106707578*r**6+131404097*r**8-158113380*r**10
            -473696344*r**12-452423900*r**14-132429277*r**16-324916538*r**18-40933728*r**20
            -5821182*r**22+75803*r**24)+Q2**6*(536267-5337303*r**2+14149482*r**4
            -89332690*r**6-72740463*r**8+275064171*r**10+637447324*r**12+922524340*r**14
            +954541565*r**16+22426927*r**18+497413914*r**20+52267518*r**22+8876423*r**24
            -94115*r**26)+2*(-1+r**2)**6*(-329+21211*r**2+186987*r**4-1086705*r**6
            +10674994*r**8-32731582*r**10+16666274*r**12+24787658*r**14-27616177*r**16
            +6837811*r**18-2226509*r**20-161305*r**22-18040*r**24+112*r**26)-Q2*(
            -1+r**2)**4*(-8599+374478*r**2+2286957*r**4-8419456*r**6+112534141*r**8
            -238203290*r**10-169825743*r**12+331002240*r**14+148593867*r**16-348405686*r**18
            +96751959*r**20-35792640*r**22-2528177*r**24-336766*r**26+2315*r**28)
            +Q2**5*(-312967+3606642*r**2-23368875*r**4+96648768*r**6-28452695*r**8
            -200421918*r**10-168970163*r**12-297470352*r**14-8219709*r**16-706256586*r**18
            +315891047*r**20-259179312*r**22-24592101*r**24-4197642*r**26+33783*r**28)
            +2*Q2**2*(-1+r**2)**2*(-20740+676723*r**2+2626266*r**4-6237503*r**6+135107650*r**8
            -215656259*r**10-160688156*r**12-95517521*r**14+350483848*r**16+149546093*r**18
            -473731158*r**20+151318303*r**22-57380550*r**24-3834525*r**26-646248*r**28
            +4977*r**30)+Q2**4*(-5949+624397*r**2+15323797*r**4-57108109*r**6+272124331*r**8
            +53550565*r**10-23990779*r**12+40043811*r**14+487390513*r**16-725444417*r**18
            -121085593*r**20-62545743*r**22-68122783*r**24-3262129*r**26-1042689*r**28
            +14777*r**30)+Q2**3*(84853-2298250*r**2-6742294*r**4+23575790*r**6-376779662*r**8
            +545105734*r**10+70427890*r**12-24453682*r**14+913696380*r**16-975697006*r**18
            -546780962*r**20+1266182170*r**22-472839074*r**24+171454130*r**26+9902918*r**28
            +2379050*r**30-21185*r**32))*sqrtq2))/(167961600*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+1166400*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-503884800*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-20995200*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-24300*(-Q2+(
            -1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(16*r**6*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-10372*Q2**15
            +Q2**14*(12965+3237*r**2)+8*Q2**13*(-41488-106210*r**2+59825*r**4)+Q2**12*(3295703
            +38962637*r**2+7750793*r**4-2585213*r**6)+4*Q2**11*(-2844521-59627542*r**2
            -66977941*r**4-7495048*r**6+1589532*r**8)+Q2**10*(16691141+550564669*r**2
            +1223534642*r**4+700613570*r**6+57907617*r**8-8195911*r**10)+4*Q2**9*(
            -726040-80946606*r**2-500578691*r**4-511584526*r**6-199272306*r**8-11831920*r**10
            +1060329*r**12)+Q2**8*(-23982657-841204035*r**2+809526351*r**4+1160966245*r**6
            +1484761725*r**8+241301559*r**10-17043435*r**12+2298375*r**14)-4*Q2**7*(
            -7460061-403767924*r**2-270987870*r**4-456981896*r**6+269886400*r**8
            +383561572*r**10-48560238*r**12-14905056*r**14+975441*r**16)+Q2**6*(
            -4587017-533758569*r**2-1563711396*r**4-908058996*r**6+998438674*r**8
            +4079176498*r**10+1753366156*r**12-69673956*r**14-16966881*r**16+23839*r**18)
            +16*Q2**5*(-1094246-70711788*r**2+141711927*r**4-333722369*r**6+381566551*r**8
            -139734341*r**10+8543892*r**12+57336987*r**14+3044121*r**16-2838749*r**18
            +174423*r**20)-Q2**4*(-13392845-1224734687*r**2+2905003561*r**4-9958892669*r**6
            +19237821486*r**8+2005507882*r**10-3916398494*r**12+3923825606*r**14
            +2721220831*r**16+221882101*r**18-41987915*r**20+1683703*r**22)-4*Q2**3*(
            -33709+43859390*r**2-170556631*r**4+984034000*r**6-3686258180*r**8+2749295804*r**10
            -631566410*r**12+2460918136*r**14-165341865*r**16-223243130*r**18-23269855*r**20
            +58040*r**22+60250*r**24)+(-1+r**2)**2*(-339683-42788527*r**2+336704630*r**4
            -2338937994*r**6+9941225959*r**8-19453497317*r**10+16656801604*r**12
            +2395496548*r**14-4162416821*r**16-1382048409*r**18-81153850*r**20+24543398*r**22
            -1469903*r**24+40365*r**26)+Q2**2*(-4483297-371216633*r**2+1945922002*r**4
            -7861922446*r**6+15642658445*r**8-5582372923*r**10-1009176948*r**12-5467596820*r**14
            -7930178311*r**16-2161420175*r**18+329496610*r**20+131703586*r**22-16929317*r**24
            +661827*r**26)-4*Q2*(-539344-57230978*r**2+425945435*r**4-2382828642*r**6
            +8220393098*r**8-12392225412*r**10+7046314721*r**12+2615057540*r**14
            +2536158524*r**16-3183482226*r**18-946226099*r**20-16801698*r**22+29810570*r**24
            -2255112*r**26+69623*r**28))-16*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(10372*Q2**15
            -Q2**14*(12965+3237*r**2)+Q2**13*(331904+849680*r**2-478600*r**4)+Q2**12*(
            -3295703-38962637*r**2-7750793*r**4+2585213*r**6)+4*Q2**11*(2844521
            +59627542*r**2+66977941*r**4+7495048*r**6-1589532*r**8)+Q2**10*(-16691141
            -550564669*r**2-1223534642*r**4-700613570*r**6-57907617*r**8+8195911*r**10)
            +4*Q2**9*(726040+80946606*r**2+500578691*r**4+511584526*r**6+199272306*r**8
            +11831920*r**10-1060329*r**12)-Q2**8*(-23982657-841204035*r**2+809526351*r**4
            +1160966245*r**6+1484761725*r**8+241301559*r**10-17043435*r**12+2298375*r**14)
            +4*Q2**7*(-7460061-403767924*r**2-270987870*r**4-456981896*r**6+269886400*r**8
            +383561572*r**10-48560238*r**12-14905056*r**14+975441*r**16)+Q2**6*(4587017
            +533758569*r**2+1563711396*r**4+908058996*r**6-998438674*r**8-4079176498*r**10
            -1753366156*r**12+69673956*r**14+16966881*r**16-23839*r**18)-16*Q2**5*(
            -1094246-70711788*r**2+141711927*r**4-333722369*r**6+381566551*r**8
            -139734341*r**10+8543892*r**12+57336987*r**14+3044121*r**16-2838749*r**18
            +174423*r**20)+Q2**4*(-13392845-1224734687*r**2+2905003561*r**4-9958892669*r**6
            +19237821486*r**8+2005507882*r**10-3916398494*r**12+3923825606*r**14
            +2721220831*r**16+221882101*r**18-41987915*r**20+1683703*r**22)+4*Q2**3*(
            -33709+43859390*r**2-170556631*r**4+984034000*r**6-3686258180*r**8+2749295804*r**10
            -631566410*r**12+2460918136*r**14-165341865*r**16-223243130*r**18-23269855*r**20
            +58040*r**22+60250*r**24)+Q2**2*(4483297+371216633*r**2-1945922002*r**4
            +7861922446*r**6-15642658445*r**8+5582372923*r**10+1009176948*r**12+5467596820*r**14
            +7930178311*r**16+2161420175*r**18-329496610*r**20-131703586*r**22+16929317*r**24
            -661827*r**26)-(-1+r**2)**2*(-339683-42788527*r**2+336704630*r**4-2338937994*r**6
            +9941225959*r**8-19453497317*r**10+16656801604*r**12+2395496548*r**14
            -4162416821*r**16-1382048409*r**18-81153850*r**20+24543398*r**22-1469903*r**24
            +40365*r**26)+4*Q2*(-539344-57230978*r**2+425945435*r**4-2382828642*r**6
            +8220393098*r**8-12392225412*r**10+7046314721*r**12+2615057540*r**14
            +2536158524*r**16-3183482226*r**18-946226099*r**20-16801698*r**22+29810570*r**24
            -2255112*r**26+69623*r**28))*sqrtq2+logq2**4*(-41472000*r**22*(1-Q2+r**2)*(
            -2593+1863*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-41472000*r**22*(
            -2593+1863*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**3*(
            -276480*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-21140*Q2**7+2*Q2**6*(67648
            +52933*r**2)-6*Q2**5*(56021+54177*r**2+29646*r**4)+Q2**4*(359380+282433*r**2
            +61438*r**4+110905*r**6)+Q2**3*(-42280-98747*r**2+60961*r**4+347743*r**6
            -297205*r**8)+2*(-1+r**2)**2*(-27482+118931*r**2-446244*r**4-73644*r**6
            +41306*r**8+168133*r**10)+Q2**2*(-253680+468903*r**2-798908*r**4-110558*r**6
            +173748*r**8+906975*r**10)+Q2*(213514-781183*r**2+2058561*r**4+1772586*r**6
            -652284*r**8+104597*r**10-963791*r**12))-276480*r**16*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(21140*Q2**8-2*Q2**7*(78218+63503*r**2)+Q2**6*(471422
            +566224*r**2+283742*r**4)-Q2**5*(695506+943621*r**2+564376*r**4+288781*r**6)
            +10*Q2**4*(40166+74056*r**2+28291*r**4-17540*r**6+40811*r**8)-2*Q2**3*(
            -105700+304965*r**2-380561*r**4-259631*r**6+61605*r**8+602090*r**10)
            +2*(-1+r**2)**2*(-27482+91449*r**2-327313*r**4-519888*r**6-32338*r**8
            +209439*r**10+168133*r**12)+2*Q2**2*(-233597+498203*r**2-1194283*r**4
            -1341026*r**6+357737*r**8+488063*r**10+935383*r**12)+Q2*(268478-915459*r**2
            +2700554*r**4+1955597*r**6+1635602*r**8-571441*r**10-269274*r**12-1300057*r**14))*sqrtq2)
            +logq2**2*(4608*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(
            -409864*Q2**10+10*Q2**9*(303236+134657*r**2)+15*Q2**8*(-581896-416107*r**2
            +23449*r**4)-5*Q2**7*(-2090148-2383095*r**2+1019918*r**4+1070469*r**6)
            +10*Q2**6*(135564-1681983*r**2-656146*r**4+1492587*r**6+217014*r**8)
            +3*Q2**5*(-5866124+9897955*r**2+17895400*r**4+9013620*r**6-272720*r**8
            +4120901*r**10)-10*Q2**4*(-1686624+3712467*r**2+6648535*r**4+4367864*r**6
            +30054*r**8+203731*r**10+1686417*r**12)+5*Q2**3*(-222372+1466601*r**2
            +3052438*r**4+2345027*r**6-9830308*r**8-2209637*r**10+1563666*r**12
            +826713*r**14)+30*Q2**2*(-266768+1072375*r**2-224712*r**4-363129*r**6
            +1269658*r**8+604633*r**10-4271824*r**12-1623887*r**14+170774*r**16)
            +(-1+r**2)**2*(-1067864+6578007*r**2-7647047*r**4+9286699*r**6+24359685*r**8
            +91227649*r**10-67045697*r**12-16802643*r**14+531211*r**16)-5*Q2*(-1042892
            +6197559*r**2-7491712*r**4+2495882*r**6+34207008*r**8+6668768*r**10
            +31309712*r**12-30486522*r**14-11000356*r**16+678553*r**18))-4608*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(409864*Q2**10-10*Q2**9*(303236+134657*r**2)
            +Q2**8*(8728440+6241605*r**2-351735*r**4)+5*Q2**7*(-2090148-2383095*r**2
            +1019918*r**4+1070469*r**6)-10*Q2**6*(135564-1681983*r**2-656146*r**4
            +1492587*r**6+217014*r**8)-3*Q2**5*(-5866124+9897955*r**2+17895400*r**4
            +9013620*r**6-272720*r**8+4120901*r**10)+10*Q2**4*(-1686624+3712467*r**2
            +6648535*r**4+4367864*r**6+30054*r**8+203731*r**10+1686417*r**12)-5*Q2**3*(
            -222372+1466601*r**2+3052438*r**4+2345027*r**6-9830308*r**8-2209637*r**10
            +1563666*r**12+826713*r**14)-30*Q2**2*(-266768+1072375*r**2-224712*r**4
            -363129*r**6+1269658*r**8+604633*r**10-4271824*r**12-1623887*r**14+170774*r**16)
            -(-1+r**2)**2*(-1067864+6578007*r**2-7647047*r**4+9286699*r**6+24359685*r**8
            +91227649*r**10-67045697*r**12-16802643*r**14+531211*r**16)+5*Q2*(-1042892
            +6197559*r**2-7491712*r**4+2495882*r**6+34207008*r**8+6668768*r**10
            +31309712*r**12-30486522*r**14-11000356*r**16+678553*r**18))*sqrtq2)
            +logq2*(-384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(285660*Q2**13
            -2*Q2**12*(1229580+1411669*r**2)+2*Q2**11*(4064445+10203481*r**2+5305706*r**4)
            -Q2**10*(11140740+53430247*r**2+56744954*r**4+19272455*r**6)+Q2**9*(
            -1707750+49023835*r**2+76576711*r**4+69246641*r**6+15377355*r**8)+2*Q2**8*(12537990
            +17615175*r**2+35422912*r**4-19666360*r**6-23572498*r**8+788625*r**10)
            -4*Q2**7*(6827895+27717396*r**2+59274187*r**4+15110054*r**6-43304291*r**8
            -11267368*r**10+2691351*r**12)+2*Q2**6*(-707940+36367443*r**2+35102758*r**4
            +84792955*r**6-156243156*r**8-123262025*r**10-13013242*r**12+1405983*r**14)
            +2*Q2**5*(12444840+7219317*r**2+131191273*r**4-271043905*r**6-178354241*r**8
            +82549289*r**10-95720563*r**12-31170757*r**14+2977275*r**16)-2*Q2**4*(8694000
            +21151005*r**2+129904088*r**4-396751232*r**6-475493784*r**8-94432354*r**10
            +147403776*r**12-228169192*r**14-49586672*r**16+2181165*r**18)-2*Q2**3*(493695
            -12636475*r**2+15807632*r**4+83365460*r**6+238671598*r**8-262601610*r**10
            -172754360*r**12-201138292*r**14+86509715*r**16+11758597*r**18+161480*r**20)
            +2*(-1+r**2)**2*(267030-140621*r**2+11719312*r**4-61228715*r**6-48490492*r**8
            +448181746*r**10-944205824*r**12+196214558*r**14+217429510*r**16+24868987*r**18
            -2335856*r**20+40365*r**22)+Q2**2*(6793740-12144503*r**2+185268958*r**4
            -638790479*r**6+280698024*r**8-242654418*r**10+23084356*r**12+879626622*r**14
            +961142604*r**16+57566281*r**18-36509602*r**20+1435217*r**22)-Q2*(3297510
            -5811427*r**2+115160993*r**4-603935505*r**6+397969625*r**8+456548870*r**10
            -1247032226*r**12-2386576606*r**14+606565820*r**16+1300223965*r**18+127241985*r**20
            -25680657*r**22+587653*r**24))+384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(285660*Q2**14-2*Q2**13*(1372410+1554499*r**2)+10*Q2**12*(1058805
            +2568946*r**2+1343475*r**4)-Q2**11*(19269630+81966099*r**2+87763328*r**4
            +29883867*r**6)+2*Q2**10*(4716495+56797411*r**2+93375956*r**4+72632025*r**6
            +17324905*r**8)-Q2**9*(-26783730+12085735*r**2+54754722*r**4+185156072*r**6
            +131768992*r**8+13800105*r**10)-2*Q2**8*(26193780+85587957*r**2+171586461*r**4
            +45976660*r**6-129847440*r**8-45318609*r**10+6171327*r**12)+2*Q2**7*(12947850
            +105458025*r**2+209085924*r**4+233561437*r**6-212631630*r**8-232405343*r**10
            -30165276*r**12+6788685*r**14)+4*Q2**6*(6576390-14220093*r**2+29860536*r**4
            -195469809*r**6-53452020*r**8+181027235*r**10+20277352*r**12-9781749*r**14
            +785646*r**16)-4*Q2**5*(10569420+20407581*r**2+134157339*r**4-268301932*r**6
            -462445965*r**8-95118653*r**10+67116251*r**12-177530256*r**14-38890077*r**16
            +2579220*r**18)+2*Q2**4*(8200305+42481480*r**2+135247461*r**4-350212604*r**6
            -1110916614*r**8-307324528*r**10+225725782*r**12+120372876*r**14-364265579*r**16
            -59164104*r**18+2019685*r**20)+Q2**3*(7781130-36430063*r**2+191611272*r**4
            -440444295*r**6+924772140*r**8-290514442*r**10-847627584*r**12+131841318*r**14
            +731885450*r**16+254102905*r**18-12669448*r**20+1758177*r**22)-2*(-1
            +r**2)**2*(267030+126409*r**2+11578691*r**4-49509403*r**6-109719207*r**8
            +399691254*r**10-496024078*r**12-747991266*r**14+413644068*r**16+242298497*r**18
            +22533131*r**20-2295491*r**22+40365*r**24)-2*Q2**2*(5045625-5581095*r**2
            +144142724*r**4-528728513*r**6+19938585*r**8+247296238*r**10-733301144*r**12
            -741932814*r**14+1223667523*r**16+1159466425*r**18+74149332*r**20-30377521*r**22
            +1011435*r**24)+Q2*(3831570-3863279*r**2+133884734*r**4-658390432*r**6
            -34593380*r**8+1822386525*r**10-4568602972*r**12+1432007072*r**14-4018421646*r**16
            +1479238835*r**18+1758177310*r**20+160723456*r**22-29926176*r**24+668383*r**26))*sqrtq2))/(345600*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+345600*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*sqrtq2+logq2**4*(7166361600*r**20*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3+7166361600*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**3*(-2388787200*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-2388787200*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2**2*(298598400*r**12*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+298598400*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)+logq2*(-16588800*(-Q2+(-1+r)**2)**3*r**8*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-16588800*(-Q2+(-1+r)**2)**3*r**8*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2))
            +(muWC**4*(32*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(916*Q2**17
            -Q2**16*(16419+2081*r**2)+2*Q2**15*(-7325-23734*r**2+7043*r**4)+4*Q2**14*(490478
            +139403*r**2+861666*r**4-55131*r**6)+2*Q2**13*(-6758509-3924596*r**2
            -7360620*r**4-13531824*r**6+573453*r**8)+4*Q2**12*(10430279+9095915*r**2
            +4994754*r**4+23223172*r**6+22857933*r**8-706173*r**10)+2*Q2**11*(-33271545
            -39486738*r**2+5588893*r**4+36032824*r**6-89483983*r**8-66949182*r**10
            +1617187*r**12)+4*Q2**10*(10672646+27723985*r**2-65745472*r**4-226312079*r**6
            -410432222*r**8-52149237*r**10-7266912*r**12+32747*r**14)+2*Q2**9*(15063643
            -82980312*r**2+564945362*r**4+1769928504*r**6+3354322780*r**8+3665581864*r**10
            +703794558*r**12+207901576*r**14-2639351*r**16)+2*Q2**8*(-38233337+123684717*r**2
            -1117216704*r**4-3666029104*r**6-7213310406*r**8-8599774834*r**10-6709572912*r**12
            -1097194800*r**14-301154697*r**16+3100669*r**18)+2*Q2**7*(23294745-90872570*r**2
            +1029254685*r**4+3550426512*r**6+6982090418*r**8+8703414476*r**10+7764380530*r**12
            +3374109360*r**14+422079237*r**16+107883438*r**18-693407*r**20)-4*Q2**6*(
            -2218378+21348115*r**2+97988590*r**4+914503801*r**6+1067682492*r**8
            -1381896914*r**10-2454086716*r**12+217683170*r**14-3346142994*r**16-403122913*r**18
            -92277170*r**20+830245*r**22)+2*Q2**5*(-12534919+124335212*r**2-413649360*r**4
            +1793950112*r**6+1769119829*r**8-6845952008*r**10-14117763384*r**12-20076039504*r**14
            +1828760387*r**16-11751178276*r**18-1160087992*r**20-245254800*r**22
            +1649583*r**24)+(-1+r**2)**4*(-83171+5396995*r**2+48192078*r**4-289533510*r**6
            +2655653983*r**8-8322831367*r**10+3481118324*r**12+8141864156*r**14-8425162885*r**16
            +2174854357*r**18-672093122*r**20-41730454*r**22-6051319*r**24+25135*r**26)
            -4*Q2**4*(-2245463+30108797*r**2-179087778*r**4+941322996*r**6+572301585*r**8
            -1733698997*r**10-1805132604*r**12-541459576*r**14-8820113197*r**16+3472712915*r**18
            -2727303490*r**20-247355868*r**22-40392621*r**24+165381*r**26)-2*Q2*(
            -1+r**2)**2*(-461711+18495682*r**2+94560713*r**4-334006024*r**6+4585745877*r**8
            -9715747934*r**10-7597514179*r**12+11174210000*r**14+12610538435*r**16
            -19825226186*r**18+6103826155*r**20-1978951368*r**22-114860553*r**24
            -22236826*r**26+104719*r**28)-2*Q2**3*(-1586621+32331646*r**2+158159901*r**4
            -591466808*r**6+3945786867*r**8+1870767294*r**10-2258202483*r**12+12209138544*r**14
            -10561296111*r**16-6902526454*r**18+2404152527*r**20-2707006008*r**22
            -117972295*r**24-54719046*r**26+410247*r**28)+4*Q2**2*(-833118+23575095*r**2
            +49112716*r**4-112070173*r**6+3252637738*r**8-5514865989*r**10-299437900*r**12
            -6982397937*r**14+5355589446*r**16+12681462309*r**18-17999248908*r**20
            +6750594425*r**22-2077865234*r**24-97345303*r**26-30598452*r**28+168085*r**30))
            +32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(916*Q2**17-Q2**16*(16419
            +2081*r**2)+2*Q2**15*(-7325-23734*r**2+7043*r**4)+4*Q2**14*(490478+139403*r**2
            +861666*r**4-55131*r**6)+2*Q2**13*(-6758509-3924596*r**2-7360620*r**4
            -13531824*r**6+573453*r**8)+4*Q2**12*(10430279+9095915*r**2+4994754*r**4
            +23223172*r**6+22857933*r**8-706173*r**10)+2*Q2**11*(-33271545-39486738*r**2
            +5588893*r**4+36032824*r**6-89483983*r**8-66949182*r**10+1617187*r**12)
            +4*Q2**10*(10672646+27723985*r**2-65745472*r**4-226312079*r**6-410432222*r**8
            -52149237*r**10-7266912*r**12+32747*r**14)+2*Q2**9*(15063643-82980312*r**2
            +564945362*r**4+1769928504*r**6+3354322780*r**8+3665581864*r**10+703794558*r**12
            +207901576*r**14-2639351*r**16)+2*Q2**8*(-38233337+123684717*r**2-1117216704*r**4
            -3666029104*r**6-7213310406*r**8-8599774834*r**10-6709572912*r**12-1097194800*r**14
            -301154697*r**16+3100669*r**18)+2*Q2**7*(23294745-90872570*r**2+1029254685*r**4
            +3550426512*r**6+6982090418*r**8+8703414476*r**10+7764380530*r**12+3374109360*r**14
            +422079237*r**16+107883438*r**18-693407*r**20)-4*Q2**6*(-2218378+21348115*r**2
            +97988590*r**4+914503801*r**6+1067682492*r**8-1381896914*r**10-2454086716*r**12
            +217683170*r**14-3346142994*r**16-403122913*r**18-92277170*r**20+830245*r**22)
            +2*Q2**5*(-12534919+124335212*r**2-413649360*r**4+1793950112*r**6+1769119829*r**8
            -6845952008*r**10-14117763384*r**12-20076039504*r**14+1828760387*r**16
            -11751178276*r**18-1160087992*r**20-245254800*r**22+1649583*r**24)+(
            -1+r**2)**4*(-83171+5396995*r**2+48192078*r**4-289533510*r**6+2655653983*r**8
            -8322831367*r**10+3481118324*r**12+8141864156*r**14-8425162885*r**16
            +2174854357*r**18-672093122*r**20-41730454*r**22-6051319*r**24+25135*r**26)
            -4*Q2**4*(-2245463+30108797*r**2-179087778*r**4+941322996*r**6+572301585*r**8
            -1733698997*r**10-1805132604*r**12-541459576*r**14-8820113197*r**16+3472712915*r**18
            -2727303490*r**20-247355868*r**22-40392621*r**24+165381*r**26)-2*Q2*(
            -1+r**2)**2*(-461711+18495682*r**2+94560713*r**4-334006024*r**6+4585745877*r**8
            -9715747934*r**10-7597514179*r**12+11174210000*r**14+12610538435*r**16
            -19825226186*r**18+6103826155*r**20-1978951368*r**22-114860553*r**24
            -22236826*r**26+104719*r**28)-2*Q2**3*(-1586621+32331646*r**2+158159901*r**4
            -591466808*r**6+3945786867*r**8+1870767294*r**10-2258202483*r**12+12209138544*r**14
            -10561296111*r**16-6902526454*r**18+2404152527*r**20-2707006008*r**22
            -117972295*r**24-54719046*r**26+410247*r**28)+4*Q2**2*(-833118+23575095*r**2
            +49112716*r**4-112070173*r**6+3252637738*r**8-5514865989*r**10-299437900*r**12
            -6982397937*r**14+5355589446*r**16+12681462309*r**18-17999248908*r**20
            +6750594425*r**22-2077865234*r**24-97345303*r**26-30598452*r**28+168085*r**30))*sqrtq2
            +logq2**4*(16588800*r**16*(1-Q2+r**2)*(960+960*r**2-4403*r**4+71*r**6)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3+16588800*r**16*(960+960*r**2-4403*r**4
            +71*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**3*(-552960*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(20*Q2**9*(96+1255*r**4)-6*Q2**8*(1664
            +3968*r**2+27039*r**4+35140*r**6)+2*Q2**7*(8976+50928*r**2+235268*r**4
            +489361*r**6+372735*r**8)-Q2**6*(8352+158784*r**2+595379*r**4+1661754*r**6
            +2247287*r**8+1385520*r**10)+3*Q2**5*(2528+33312*r**2+59221*r**4+387171*r**6
            +675857*r**8+721953*r**10+434230*r**12)+2*(-1+r**2)**4*(-10032-2976*r**2
            -10283*r**4+52732*r**6+127542*r**8-71186*r**10+26293*r**12+32630*r**14)
            -2*Q2**4*(42000+39840*r**2-51533*r**4+156784*r**6+331562*r**8+368410*r**10
            +147635*r**12+112950*r**14)-Q2*(-1+r**2)**2*(-101472-51168*r**2-236119*r**4
            +223669*r**6+1571584*r**8+912426*r**10-602423*r**12+214993*r**14+384030*r**16)
            -2*Q2**3*(-98352-62544*r**2-182435*r**4-120984*r**6+740301*r**8+257840*r**10
            -270369*r**12+350968*r**14+402855*r**16)+3*Q2**2*(-67744+4288*r**2-167245*r**4
            +15822*r**6+585913*r**8+735772*r**10+608405*r**12-435202*r**14-27489*r**16
            +291160*r**18))+552960*r**12*(20*Q2**12*(96+1255*r**4)-6*Q2**11*(2624
            +4928*r**2+39589*r**4+47690*r**6)+2*Q2**10*(26832+103536*r**2+554861*r**4
            +1074072*r**6+726645*r**8)-5*Q2**9*(18816+121536*r**2+580001*r**4+1402952*r**6
            +1660629*r**8+855910*r**10)+10*Q2**8*(9648+95664*r**2+423777*r**4+1215050*r**6
            +1901089*r**8+1744278*r**10+790650*r**12)-10*Q2**7*(14976+97920*r**2
            +320922*r**4+1140775*r**6+2147995*r**8+2569985*r**10+2044707*r**12+903600*r**14)
            -2*(-1+r**2)**6*(-10032-13008*r**2-13259*r**4+42449*r**6+180274*r**8
            +56356*r**10-44893*r**12+58923*r**14+32630*r**16)+2*Q2**6*(239904+540768*r**2
            +739284*r**4+2964545*r**6+5268570*r**8+7896634*r**10+7994228*r**12+5413149*r**14
            +2582790*r**16)+Q2*(-1+r**2)**4*(-161664-210624*r**2-421081*r**4+244954*r**6
            +2709735*r**8+2883454*r**10+948269*r**12-513594*r**14+887301*r**16+579810*r**18)
            +2*Q2**5*(-526464-725952*r**2-1071957*r**4-1819079*r**6+1189000*r**8
            +2282156*r**10-434777*r**12-1429867*r**14+1119846*r**16+655110*r**18)
            -10*Q2**2*(-1+r**2)**2*(-56784-50448*r**2-158763*r**4-7325*r**6+675164*r**8
            +894605*r**10+890088*r**12+392741*r**14-239392*r**16+216603*r**18+222135*r**20)
            -10*Q2**4*(-138528-118368*r**2-337002*r**4-296993*r**6+863470*r**8+1401337*r**10
            +1588396*r**12+660553*r**14-282946*r**16+546783*r**18+519570*r**20)
            +10*Q2**3*(-113088-7104*r**2-249983*r**4+68953*r**6+1013747*r**8+538155*r**10
            +550637*r**12+1107869*r**14+970793*r**16-707519*r**18+68022*r**20+464350*r**22))*sqrtq2)
            +logq2**2*(-9216*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(8*Q2**12*(6176
            +35397*r**4)-2*Q2**11*(221568+247168*r**2+967751*r**4+1350156*r**6)
            +Q2**10*(1644768+3509984*r**2+8390749*r**4+14630723*r**6+10683696*r**8)
            -5*Q2**9*(649280+1960960*r**2+4782365*r**4+8043302*r**6+8549329*r**8
            +4333644*r**10)+5*Q2**8*(715104+2738592*r**2+7491587*r**4+12058709*r**6
            +12276105*r**8+10973303*r**10+3984744*r**12)+2*Q2**7*(-1001088-5032320*r**2
            -14596491*r**4-13587150*r**6+10318445*r**8+21571632*r**10-5004400*r**12
            +2725104*r**14)-2*Q2**6*(-136416-2179296*r**2-6779212*r**4+13199683*r**6
            +75192480*r**8+144142384*r**10+126366974*r**12+27751723*r**14+16785888*r**16)
            +2*Q2**5*(171072-1163904*r**2-5192794*r**4+5447052*r**6+55718059*r**8
            +149301342*r**10+185392206*r**12+149762826*r**14+32008817*r**16+16210524*r**18)
            +(-1+r**2)**4*(-55712-83424*r**2-5661435*r**4+4912669*r**6+23180133*r**8
            -3810819*r**10-11519501*r**12+2160435*r**14+15365931*r**16+959667*r**18
            +601656*r**20)-10*Q2**4*(59040-145440*r**2+709650*r**4-603419*r**6+1335848*r**8
            +10139711*r**10+15923384*r**12+6788469*r**14+6833994*r**16+2554343*r**18
            +639588*r**20)-10*Q2**3*(-90368+28416*r**2-4394594*r**4-1556610*r**6
            -2314997*r**8+257276*r**10+6015585*r**12-9173790*r**14+8946741*r**16
            +17254880*r**18-423871*r**20+1233732*r**22)-Q2*(-1+r**2)**2*(-333504
            -295552*r**2-28349653*r**4+6321168*r**6+77100834*r**8+58114268*r**10
            +48673080*r**12-52500732*r**14+4927022*r**16+87653556*r**18+2844301*r**20
            +4242012*r**22)+Q2**2*(-784032+191840*r**2-53543869*r**4+24516035*r**6
            +39943300*r**8+49378624*r**10+177782630*r**12+204923098*r**14-127054340*r**16
            -96816880*r**18+192913703*r**20-6208525*r**22+11552016*r**24))-9216*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(8*Q2**12*(6176+35397*r**4)-2*Q2**11*(221568
            +247168*r**2+967751*r**4+1350156*r**6)+Q2**10*(1644768+3509984*r**2
            +8390749*r**4+14630723*r**6+10683696*r**8)-5*Q2**9*(649280+1960960*r**2
            +4782365*r**4+8043302*r**6+8549329*r**8+4333644*r**10)+5*Q2**8*(715104
            +2738592*r**2+7491587*r**4+12058709*r**6+12276105*r**8+10973303*r**10
            +3984744*r**12)+2*Q2**7*(-1001088-5032320*r**2-14596491*r**4-13587150*r**6
            +10318445*r**8+21571632*r**10-5004400*r**12+2725104*r**14)-2*Q2**6*(
            -136416-2179296*r**2-6779212*r**4+13199683*r**6+75192480*r**8+144142384*r**10
            +126366974*r**12+27751723*r**14+16785888*r**16)+2*Q2**5*(171072-1163904*r**2
            -5192794*r**4+5447052*r**6+55718059*r**8+149301342*r**10+185392206*r**12
            +149762826*r**14+32008817*r**16+16210524*r**18)+(-1+r**2)**4*(-55712
            -83424*r**2-5661435*r**4+4912669*r**6+23180133*r**8-3810819*r**10-11519501*r**12
            +2160435*r**14+15365931*r**16+959667*r**18+601656*r**20)-10*Q2**4*(59040
            -145440*r**2+709650*r**4-603419*r**6+1335848*r**8+10139711*r**10+15923384*r**12
            +6788469*r**14+6833994*r**16+2554343*r**18+639588*r**20)-10*Q2**3*(-90368
            +28416*r**2-4394594*r**4-1556610*r**6-2314997*r**8+257276*r**10+6015585*r**12
            -9173790*r**14+8946741*r**16+17254880*r**18-423871*r**20+1233732*r**22)
            -Q2*(-1+r**2)**2*(-333504-295552*r**2-28349653*r**4+6321168*r**6+77100834*r**8
            +58114268*r**10+48673080*r**12-52500732*r**14+4927022*r**16+87653556*r**18
            +2844301*r**20+4242012*r**22)+Q2**2*(-784032+191840*r**2-53543869*r**4
            +24516035*r**6+39943300*r**8+49378624*r**10+177782630*r**12+204923098*r**14
            -127054340*r**16-96816880*r**18+192913703*r**20-6208525*r**22+11552016*r**24))*sqrtq2)
            +logq2*(-768*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(92*Q2**15*(160
            +241*r**4)-2*Q2**14*(69376+46080*r**2+79859*r**4+117608*r**6)+2*Q2**13*(281456
            +358096*r**2+251580*r**4+815785*r**6+517427*r**8)-Q2**12*(1247904+2276928*r**2
            +1088839*r**4+1430250*r**6+5725163*r**8+2317456*r**10)+Q2**11*(1520960
            +3654784*r**2-2621829*r**4-10245993*r**6-27143067*r**8+4648653*r**10
            +2227804*r**12)+Q2**10*(-675136-2744128*r**2+27735535*r**4+76796040*r**6
            +187105218*r**8+210449076*r**10+23239143*r**12+1346708*r**14)-Q2**9*(736736
            -124960*r**2+79637679*r**4+268267075*r**6+595703520*r**8+841153878*r**10
            +609843455*r**12+77042399*r**14+6145018*r**16)+4*Q2**8*(311784+354624*r**2
            +27564195*r**4+117050216*r**6+270271330*r**8+390092911*r**10+382746680*r**12
            +195636240*r**14+23587665*r**16+1519023*r**18)+2*Q2**7*(-249216-997632*r**2
            -36584571*r**4-206264305*r**6-463184387*r**8-553731647*r**10-446928657*r**12
            -447005001*r**14-46374075*r**16-10662207*r**18+15906*r**20)-4*Q2**6*(86240
            -790368*r**2-3177202*r**4-48144798*r**6-97442631*r**8+129181580*r**10
            +482156810*r**12+580952868*r**14+177925337*r**16+257042324*r**18+19743534*r**20
            +1330802*r**22)+2*Q2**5*(213136-1573392*r**2+5081837*r**4-45955374*r**6
            -214743477*r**8+317565898*r**10+1274575478*r**12+2098685960*r**14+1947853576*r**16
            +533204378*r**18+633452769*r**20+47837522*r**22+2277209*r**24)+2*(-1
            +r**2)**4*(1072-48256*r**2-1377859*r**4+3033002*r**6-65680471*r**8+141097218*r**10
            +201699842*r**12-378446984*r**14+68863002*r**16+128591176*r**18-8385535*r**20
            +14107294*r**22+724173*r**24+20726*r**26)-Q2**4*(92512-548800*r**2+14587503*r**4
            -67819886*r**6-266072445*r**8+267962888*r**10+543526130*r**12+1552943884*r**14
            +1520558890*r**16+1137297600*r**18+294984575*r**20+420395010*r**22+31627283*r**24
            +669016*r**26)+Q2**3*(-90048+1840512*r**2+26669935*r**4-41359989*r**6
            +657442441*r**8+280320169*r**10+33866030*r**12+315849410*r**14+772682854*r**16
            -567918890*r**18-2450880161*r**20+285079283*r**22-351254895*r**24-21160255*r**26
            -1387196*r**28)-Q2*(-1+r**2)**2*(20000-666144*r**2-14424109*r**4+24286905*r**6
            -632182109*r**8+855720899*r**10+1590065016*r**12+33634670*r**14-2038669094*r**16
            +350827258*r**18+1486549271*r**20-174527527*r**22+176386659*r**24+9813859*r**26
            +338846*r**28)+Q2**2*(70336-1811008*r**2-27510369*r**4+54918080*r**6
            -1121492278*r**8+1334113932*r**10+699573641*r**12+932534948*r**14+2095748460*r**16
            -2136608184*r**18-1609523247*r**20+3397199832*r**22-713354614*r**24+405086700*r**26
            +24321927*r**28+1080644*r**30))+768*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(92*Q2**16*(160+241*r**4)-2*Q2**15*(76736+53440*r**2+90945*r**4
            +128694*r**6)+2*Q2**14*(350832+473552*r**2+377519*r**4+1013252*r**6
            +635035*r**8)-Q2**13*(1810816+3556032*r**2+2308191*r**4+3564980*r**6
            +8391587*r**8+3352310*r**10)+2*Q2**12*(1384432+3589808*r**2+371969*r**4
            -3863452*r**6-9993827*r**8+6345636*r**10+2272630*r**12)+Q2**11*(-2196096
            -7919872*r**2+26702580*r**4+89663862*r**6+224494278*r**8+232943490*r**10
            +16362686*r**12-881096*r**14)-2*Q2**10*(30800-1772112*r**2+52314543*r**4
            +186399325*r**6+429802389*r**8+619354086*r**10+421765837*r**12+50814125*r**14
            +3745863*r**16)+Q2**9*(1983872+2030272*r**2+189769499*r**4+816105618*r**6
            +1945055915*r**8+2997229042*r**10+2981984053*r**12+1469430814*r**14+177538077*r**16
            +12221110*r**18)-2*Q2**8*(872784+2330448*r**2+92422209*r**4+495493127*r**6
            +1237827479*r**8+1874460129*r**10+1992607839*r**12+1603770841*r**14+484821885*r**16
            +60875583*r**18+3022140*r**20)+2*Q2**7*(76736+2827584*r**2+43936607*r**4
            +339138472*r**6+864333954*r**8+758552874*r**10+36346684*r**12-267972078*r**14
            +137528402*r**16-457048366*r**18-28840767*r**20-2677510*r**22)+2*Q2**6*(385616
            -2981648*r**2-2853303*r**4-148599374*r**6-505918335*r**8+381043796*r**10
            +2497252258*r**12+4224905316*r**14+3465609986*r**16+1403139700*r**18
            +1187024485*r**20+89986194*r**22+4938813*r**24)-Q2**5*(518784-3269312*r**2
            +21604393*r**4-149566960*r**6-787470147*r**8+473607730*r**10+3727808882*r**12
            +8299466760*r**14+9613637962*r**16+6099413508*r**18+2628298869*r**20
            +1782975592*r**22+131856745*r**24+5223434*r**26)+2*Q2**4*(1232+692112*r**2
            +20354319*r**4-47296186*r**6+161775055*r**8+141105306*r**10+422677524*r**12
            +1206159712*r**14+1923092814*r**16+1044968800*r**18-509298993*r**20+500229434*r**22
            +50383699*r**24+5568022*r**26-359090*r**28)-2*(-1+r**2)**4*(1072-47184*r**2
            -1426115*r**4+1655143*r**6-62647469*r**8+75416747*r**10+342797060*r**12
            -176747142*r**14-309583982*r**16+197454178*r**18+120205641*r**20+5721759*r**22
            +14831467*r**24+744899*r**26+20726*r**28)+Q2*(-1+r**2)**2*(22144-746944*r**2
            -17650803*r**4+21343724*r**6-754143872*r**8+774521114*r**10+2153435785*r**12
            +342200786*r**14+49879200*r**16-2463005460*r**18+1443966759*r**20+1630960824*r**22
            -69892768*r**24+211559866*r**26+11518147*r**28+380298*r**30)+2*Q2**3*(80192
            -1780736*r**2-28010408*r**4+34804067*r**6-868787365*r**8+198175661*r**10
            +192693721*r**12+291409754*r**14+503608098*r**16-1170686074*r**18+704637902*r**20
            +2781500355*r**22-323589501*r**24+388750925*r**26+23434689*r**28+1233920*r**30)
            -2*Q2**2*(45168-1223408*r**2-21196599*r**4+39938345*r**6-880877113*r**8
            +1178496838*r**10+640064341*r**12-329332937*r**14+1256204995*r**16+2210470196*r**18
            -2499952885*r**20-504561113*r**22+2347918101*r**24-412877450*r**26+293253207*r**28
            +17269369*r**30+709745*r**32))*sqrtq2)))/(291600*r**4*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4+291600*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2+logq2**4*(6046617600*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+6046617600*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**3*(-2015539200*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-2015539200*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)+logq2**2*(251942400*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+251942400*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+logq2*(
            -13996800*(-Q2+(-1+r)**2)**3*r**8*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3-13996800*(-Q2+(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2))+((4*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(-131-4*Q2**10-13412*r**2+51045*r**4-323008*r**6+641774*r**8
            -644712*r**10+142382*r**12+53600*r**14+6453*r**16-404*r**18+13*r**20
            -7*Q2**9*(1+r**2)+3*Q2**8*(-47-102*r**2+41*r**4)+6*Q2**7*(145+1834*r**2
            +312*r**4-57*r**6)+6*Q2**6*(-249-6423*r**2-7092*r**4-623*r**6+63*r**8)
            +6*Q2**5*(80+4867*r**2+16621*r**4+6937*r**6+369*r**8-14*r**10)-2*Q2**4*(
            -576-23091*r**2+20622*r**4+10306*r**6-4110*r**8-891*r**10+84*r**12)
            +2*Q2**3*(-507-36702*r**2-13926*r**4-78457*r**6+14165*r**8-8712*r**10
            -1152*r**12+51*r**14)+6*Q2**2*(-25+1151*r**2+5374*r**4+19285*r**6-11218*r**8
            -10083*r**10-354*r**12-57*r**14+7*r**16)+Q2*(439+32373*r**2-73362*r**4
            +224402*r**6-163512*r**8+3216*r**10-62878*r**12-5058*r**14+1233*r**16
            -53*r**18))+4*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-131+4*Q2**11
            -13543*r**2+37633*r**4-271963*r**6+318766*r**8-2938*r**10-502330*r**12
            +195982*r**14+60053*r**16+6049*r**18-391*r**20+13*r**22+3*Q2**10*(1
            +r**2)+Q2**9*(134+292*r**2-130*r**4)+3*Q2**8*(-337-3817*r**2-685*r**4
            +155*r**6)+12*Q2**7*(197+4201*r**2+4619*r**4+439*r**6-60*r**8)+6*Q2**6*(
            -329-11539*r**2-30136*r**4-14652*r**6-929*r**8+77*r**10)+4*Q2**5*(
            -168-4125*r**2+42543*r**4+40490*r**6+8904*r**8+87*r**10+21*r**12)
            -6*Q2**4*(-361-20123*r**2-5465*r**4-15843*r**6+6787*r**8-4571*r**10
            -653*r**12+45*r**14)+4*Q2**3*(-216-20331*r**2-33375*r**4-75119*r**6
            -15319*r**8+17851*r**10-4401*r**12-465*r**14+15*r**16)+Q2**2*(-589
            -25617*r**2+112512*r**4-76448*r**6+211914*r**8-131022*r**10+256*r**12
            +2592*r**14-1533*r**16+95*r**18)-6*Q2*(-95-7704*r**2+15339*r**4-79008*r**6
            +96814*r**8-80736*r**10+33674*r**12+20256*r**14+1713*r**16-264*r**18
            +11*r**20))*sqrtq2+logq2**3*(172800*(-Q2+(-1+r)**2)*r**16*(1-Q2+r**2)*(
            -5+3*r**2)*(-Q2+(1+r)**2)+172800*r**16*(-5+3*r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2)+logq2**2*(2880*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-104-40*Q2**5+179*r**2-466*r**4-106*r**6-26*r**8+163*r**10
            +4*Q2**4*(44+17*r**2)+Q2**3*(-244-141*r**2+23*r**4)+Q2**2*(16+167*r**2
            -122*r**4-17*r**6)+Q2*(196-213*r**2+11*r**4+143*r**6-197*r**8))+2880*(
            -Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(-104-40*Q2**5
            +179*r**2-466*r**4-106*r**6-26*r**8+163*r**10+4*Q2**4*(44+17*r**2)
            +Q2**3*(-244-141*r**2+23*r**4)+Q2**2*(16+167*r**2-122*r**4-17*r**6)
            +Q2*(196-213*r**2+11*r**4+143*r**6-197*r**8))*sqrtq2)+logq2*(-48*r**6*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(344+184*Q2**8+823*r**2
            +11917*r**4-8589*r**6-3175*r**8+50081*r**10-25973*r**12-3867*r**14
            +39*r**16-8*Q2**7*(129+149*r**2)+Q2**6*(1772+5475*r**2+2367*r**4)-2*Q2**5*(82
            +3119*r**2+3104*r**4+667*r**6)-Q2**4*(2520+3335*r**2+7961*r**4-535*r**6
            +895*r**8)+4*Q2**3*(524+2435*r**2+6626*r**4+1196*r**6-390*r**8+249*r**10)
            +Q2**2*(412-3923*r**2-7811*r**4-10226*r**6+15474*r**8+1297*r**10+97*r**12)
            -2*Q2*(546+675*r**2+9404*r**4-13055*r**6+10450*r**8-9071*r**10-2680*r**12
            +131*r**14))-48*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(344+184*Q2**8
            +823*r**2+11917*r**4-8589*r**6-3175*r**8+50081*r**10-25973*r**12-3867*r**14
            +39*r**16-8*Q2**7*(129+149*r**2)+Q2**6*(1772+5475*r**2+2367*r**4)-2*Q2**5*(82
            +3119*r**2+3104*r**4+667*r**6)-Q2**4*(2520+3335*r**2+7961*r**4-535*r**6
            +895*r**8)+4*Q2**3*(524+2435*r**2+6626*r**4+1196*r**6-390*r**8+249*r**10)
            +Q2**2*(412-3923*r**2-7811*r**4-10226*r**6+15474*r**8+1297*r**10+97*r**12)
            -2*Q2*(546+675*r**2+9404*r**4-13055*r**6+10450*r**8-9071*r**10-2680*r**12
            +131*r**14))*sqrtq2))*z3)/(-1800*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3-1800*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(-3110400*r**14*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            +3110400*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**2*(
            -777600*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -777600*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(64800*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+64800*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2))+((muWC*(-57600*logq2**2*Q2*r**8*(15+22*r**2+15*r**4)
            -16*Q2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4
            +19308*r**6+138690*r**8+19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1
            +r**2)+Q2**6*(-89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4
            +79*r**6)+Q2**4*(165-1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19
            -280*r**2-2439*r**4-2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2
            +1787*r**4-14228*r**6+1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2
            -2957*r**4+19165*r**6+19165*r**8-2957*r**10-635*r**12+27*r**14))-9600*logq2*Q2*r**4*(1
            +2*Q2**5+35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)
            +Q2**3*(17+42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(
            -11+30*r**2+66*r**4+30*r**6-11*r**8))*sqrtq2))/(-1166400*logq2**3*r**12
            -24300*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+291600*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+675*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(muWC**2*(-7200*logq2**2*Q2*r**8*(15+22*r**2
            +15*r**4)-2*Q2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(7+92*Q2**8-156*r**2
            +5096*r**4+19308*r**6+138690*r**8+19308*r**10+5096*r**12-156*r**14
            +7*r**16-156*Q2**7*(1+r**2)+Q2**6*(-89+190*r**2-89*r**4)+2*Q2**5*(79
            -247*r**2-247*r**4+79*r**6)+Q2**4*(165-1160*r**2-10298*r**4-1160*r**6
            +165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4-2439*r**6-280*r**8+19*r**10)
            +Q2**2*(-79+806*r**2+1787*r**4-14228*r**6+1787*r**8+806*r**10-79*r**12)
            +2*Q2*(27-635*r**2-2957*r**4+19165*r**6+19165*r**8-2957*r**10-635*r**12
            +27*r**14))-1200*logq2*Q2*r**4*(1+2*Q2**5+35*r**2+276*r**4+276*r**6
            +35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17+42*r**2+17*r**4)+Q2**2*(7
            -19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2+66*r**4+30*r**6-11*r**8))*sqrtq2))/(
            -388800*logq2**3*r**12-8100*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+97200*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+225*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2))*nlo.X1Q2_DerivativeQ2(0,Q2,r)+((muWC**2*(-720*logq2*Q2*r**4*(1
            +r**2)+4*Q2*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(2160*logq2**2*r**8
            +15*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-360*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(muWC*(-5760*logq2*Q2*r**4*(1
            +r**2)+32*Q2*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(6480*logq2**2*r**8
            +45*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-1080*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))*nlo.X1Q2_DerivativeQ2(1,Q2,r)+((
            -4*muWC**2*Q2)/(-36*logq2*r**4+3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2)-(32*muWC*Q2)/(-108*logq2*r**4+9*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))*nlo.X1Q2_DerivativeQ2(2,Q2,r)
            +(pi2*(-4*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-131-4*Q2**10
            -13412*r**2+51045*r**4-323008*r**6+641774*r**8-644712*r**10+142382*r**12
            +53600*r**14+6453*r**16-404*r**18+13*r**20-7*Q2**9*(1+r**2)+3*Q2**8*(
            -47-102*r**2+41*r**4)+6*Q2**7*(145+1834*r**2+312*r**4-57*r**6)+6*Q2**6*(
            -249-6423*r**2-7092*r**4-623*r**6+63*r**8)+6*Q2**5*(80+4867*r**2+16621*r**4
            +6937*r**6+369*r**8-14*r**10)-2*Q2**4*(-576-23091*r**2+20622*r**4+10306*r**6
            -4110*r**8-891*r**10+84*r**12)+2*Q2**3*(-507-36702*r**2-13926*r**4
            -78457*r**6+14165*r**8-8712*r**10-1152*r**12+51*r**14)+6*Q2**2*(-25
            +1151*r**2+5374*r**4+19285*r**6-11218*r**8-10083*r**10-354*r**12-57*r**14
            +7*r**16)+Q2*(439+32373*r**2-73362*r**4+224402*r**6-163512*r**8+3216*r**10
            -62878*r**12-5058*r**14+1233*r**16-53*r**18))*(3+math.log(4))-4*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-131+4*Q2**11-13543*r**2+37633*r**4
            -271963*r**6+318766*r**8-2938*r**10-502330*r**12+195982*r**14+60053*r**16
            +6049*r**18-391*r**20+13*r**22+3*Q2**10*(1+r**2)+Q2**9*(134+292*r**2
            -130*r**4)+3*Q2**8*(-337-3817*r**2-685*r**4+155*r**6)+12*Q2**7*(197
            +4201*r**2+4619*r**4+439*r**6-60*r**8)+6*Q2**6*(-329-11539*r**2-30136*r**4
            -14652*r**6-929*r**8+77*r**10)+4*Q2**5*(-168-4125*r**2+42543*r**4+40490*r**6
            +8904*r**8+87*r**10+21*r**12)-6*Q2**4*(-361-20123*r**2-5465*r**4-15843*r**6
            +6787*r**8-4571*r**10-653*r**12+45*r**14)+4*Q2**3*(-216-20331*r**2
            -33375*r**4-75119*r**6-15319*r**8+17851*r**10-4401*r**12-465*r**14
            +15*r**16)+Q2**2*(-589-25617*r**2+112512*r**4-76448*r**6+211914*r**8
            -131022*r**10+256*r**12+2592*r**14-1533*r**16+95*r**18)-6*Q2*(-95
            -7704*r**2+15339*r**4-79008*r**6+96814*r**8-80736*r**10+33674*r**12
            +20256*r**14+1713*r**16-264*r**18+11*r**20))*sqrtq2*(3+math.log(4))+logq2**3*(
            -172800*(-Q2+(-1+r)**2)*r**16*(1-Q2+r**2)*(-5+3*r**2)*(-Q2+(1+r)**2)*(3
            +math.log(4))-172800*(-Q2+(-1+r)**2)*r**16*(-5+3*r**2)*(-Q2+(1+r)**2)*sqrtq2*(3
            +math.log(4)))+logq2**2*(-2880*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -104-40*Q2**5+179*r**2-466*r**4-106*r**6-26*r**8+163*r**10+4*Q2**4*(44
            +17*r**2)+Q2**3*(-244-141*r**2+23*r**4)+Q2**2*(16+167*r**2-122*r**4
            -17*r**6)+Q2*(196-213*r**2+11*r**4+143*r**6-197*r**8))*(3+math.log(4))
            -2880*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(-104-40*Q2**5
            +179*r**2-466*r**4-106*r**6-26*r**8+163*r**10+4*Q2**4*(44+17*r**2)
            +Q2**3*(-244-141*r**2+23*r**4)+Q2**2*(16+167*r**2-122*r**4-17*r**6)
            +Q2*(196-213*r**2+11*r**4+143*r**6-197*r**8))*sqrtq2*(3+math.log(4)))
            +logq2*(48*r**6*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(344
            +184*Q2**8+823*r**2+11917*r**4-8589*r**6-3175*r**8+50081*r**10-25973*r**12
            -3867*r**14+39*r**16-8*Q2**7*(129+149*r**2)+Q2**6*(1772+5475*r**2+2367*r**4)
            -2*Q2**5*(82+3119*r**2+3104*r**4+667*r**6)-Q2**4*(2520+3335*r**2+7961*r**4
            -535*r**6+895*r**8)+4*Q2**3*(524+2435*r**2+6626*r**4+1196*r**6-390*r**8
            +249*r**10)+Q2**2*(412-3923*r**2-7811*r**4-10226*r**6+15474*r**8+1297*r**10
            +97*r**12)-2*Q2*(546+675*r**2+9404*r**4-13055*r**6+10450*r**8-9071*r**10
            -2680*r**12+131*r**14))*(3+math.log(4))+48*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(344+184*Q2**8+823*r**2+11917*r**4-8589*r**6-3175*r**8+50081*r**10
            -25973*r**12-3867*r**14+39*r**16-8*Q2**7*(129+149*r**2)+Q2**6*(1772
            +5475*r**2+2367*r**4)-2*Q2**5*(82+3119*r**2+3104*r**4+667*r**6)-Q2**4*(2520
            +3335*r**2+7961*r**4-535*r**6+895*r**8)+4*Q2**3*(524+2435*r**2+6626*r**4
            +1196*r**6-390*r**8+249*r**10)+Q2**2*(412-3923*r**2-7811*r**4-10226*r**6
            +15474*r**8+1297*r**10+97*r**12)-2*Q2*(546+675*r**2+9404*r**4-13055*r**6
            +10450*r**8-9071*r**10-2680*r**12+131*r**14))*sqrtq2*(3+math.log(4)))))/(
            -5400*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            -5400*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(-9331200*r**14*(-1+Q2**3+r**2
            +r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))+9331200*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**2*(-2332800*(-Q2+(-1
            +r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-2332800*(
            -Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(194400*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+194400*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2*sqrtq2))+((16*r**6*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(4*Q2**15-Q2**14*(5+461*r**2)+8*Q2**13*(16-812*r**2
            +721*r**4)+Q2**12*(-1271+315003*r**2+68103*r**4-31355*r**6)+4*Q2**11*(1097
            -494346*r**2-631179*r**4-83688*r**6+24020*r**8)+Q2**10*(-6437+4612379*r**2
            +11740014*r**4+7633614*r**6+973151*r**8-183329*r**10)+4*Q2**9*(280-565262*r**2
            -3695977*r**4-3359562*r**6-3217222*r**8-446780*r**10+56443*r**12)-Q2**8*(
            -9249+9161013*r**2+18913119*r**4+68676205*r**6+10866685*r**8-16664961*r**10
            -2104347*r**12+179391*r**14)+4*Q2**7*(-2877+4245996*r**2+16134114*r**4
            +61936984*r**6+45191200*r**8+4950052*r**10-4709646*r**12-395424*r**14
            +23025*r**16)-Q2**6*(-1769+6030927*r**2+42330396*r**4+202093356*r**6
            +285265170*r**8+110114946*r**10+5810892*r**12-12526404*r**14-796929*r**16
            +37975*r**18)+16*Q2**5*(422-721033*r**2-2050116*r**4-13388251*r**6+8836213*r**8
            -6106305*r**10+6092062*r**12+923609*r**14+112179*r**16-23632*r**18+1436*r**20)
            +Q2**4*(-5165+12986809*r**2+56798233*r**4+449102203*r**6-227575122*r**8
            +505884506*r**10+123853058*r**12-184587402*r**14-18037697*r**16-8507987*r**18
            +213925*r**20-13361*r**22)+4*Q2**3*(-13-487554*r**2-4803831*r**4-40705120*r**6
            +72606380*r**8-145775396*r**10+45571798*r**12-41993096*r**14+25835255*r**16
            +669350*r**18+965409*r**20-11544*r**22+362*r**24)+(-1+r**2)**2*(131
            -474489*r**2-2089942*r**4-37755398*r**6+155693657*r**8-565684211*r**10
            +800402428*r**12-403839812*r**14+51222229*r**16-30667327*r**18-5185190*r**20
            +24266*r**22-8241*r**24+299*r**26)+Q2**2*(1729-4041087*r**2-8032434*r**4
            -151659106*r**6+276506995*r**8-459666957*r**10-3291724*r**12+32503796*r**14
            -2787609*r**16-39649145*r**18-7640962*r**20+436206*r**22-55707*r**24
            +3205*r**26)-4*Q2*(208-635434*r**2-1648503*r**4-35707942*r**6+145671150*r**8
            -407241056*r**10+441988043*r**12-116097844*r**14-42047596*r**16-6288770*r**18
            -12972177*r**20-3504934*r**22+133422*r**24-10612*r**26+445*r**28))+16*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**15-Q2**14*(5+461*r**2)+8*Q2**13*(16
            -812*r**2+721*r**4)+Q2**12*(-1271+315003*r**2+68103*r**4-31355*r**6)
            +4*Q2**11*(1097-494346*r**2-631179*r**4-83688*r**6+24020*r**8)+Q2**10*(
            -6437+4612379*r**2+11740014*r**4+7633614*r**6+973151*r**8-183329*r**10)
            +4*Q2**9*(280-565262*r**2-3695977*r**4-3359562*r**6-3217222*r**8-446780*r**10
            +56443*r**12)-Q2**8*(-9249+9161013*r**2+18913119*r**4+68676205*r**6
            +10866685*r**8-16664961*r**10-2104347*r**12+179391*r**14)+4*Q2**7*(-2877
            +4245996*r**2+16134114*r**4+61936984*r**6+45191200*r**8+4950052*r**10
            -4709646*r**12-395424*r**14+23025*r**16)-Q2**6*(-1769+6030927*r**2+42330396*r**4
            +202093356*r**6+285265170*r**8+110114946*r**10+5810892*r**12-12526404*r**14
            -796929*r**16+37975*r**18)+16*Q2**5*(422-721033*r**2-2050116*r**4-13388251*r**6
            +8836213*r**8-6106305*r**10+6092062*r**12+923609*r**14+112179*r**16
            -23632*r**18+1436*r**20)+Q2**4*(-5165+12986809*r**2+56798233*r**4+449102203*r**6
            -227575122*r**8+505884506*r**10+123853058*r**12-184587402*r**14-18037697*r**16
            -8507987*r**18+213925*r**20-13361*r**22)+4*Q2**3*(-13-487554*r**2-4803831*r**4
            -40705120*r**6+72606380*r**8-145775396*r**10+45571798*r**12-41993096*r**14
            +25835255*r**16+669350*r**18+965409*r**20-11544*r**22+362*r**24)+(
            -1+r**2)**2*(131-474489*r**2-2089942*r**4-37755398*r**6+155693657*r**8
            -565684211*r**10+800402428*r**12-403839812*r**14+51222229*r**16-30667327*r**18
            -5185190*r**20+24266*r**22-8241*r**24+299*r**26)+Q2**2*(1729-4041087*r**2
            -8032434*r**4-151659106*r**6+276506995*r**8-459666957*r**10-3291724*r**12
            +32503796*r**14-2787609*r**16-39649145*r**18-7640962*r**20+436206*r**22
            -55707*r**24+3205*r**26)-4*Q2*(208-635434*r**2-1648503*r**4-35707942*r**6
            +145671150*r**8-407241056*r**10+441988043*r**12-116097844*r**14-42047596*r**16
            -6288770*r**18-12972177*r**20-3504934*r**22+133422*r**24-10612*r**26
            +445*r**28))*sqrtq2+logq2**4*(-8294400*r**22*(1-Q2+r**2)*(5+69*r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3-8294400*r**22*(5+69*r**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**3*(-276480*r**16*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*(1460*Q2**7-2*Q2**6*(4672+2053*r**2)+2*Q2**5*(11607
            +8435*r**2+978*r**4)+Q2**4*(-24820-22177*r**2-4718*r**4+2135*r**6)
            +Q2**3*(2920+6523*r**2+2735*r**4+737*r**6-3515*r**8)+2*(-1+r**2)**2*(1898
            -675*r**2-820*r**4+1940*r**6-1250*r**8+3347*r**10)+Q2**2*(17520-2407*r**2
            +1276*r**4-1506*r**6+1772*r**8+11265*r**10)-Q2*(14746-14239*r**2+1665*r**4
            +8330*r**6+15380*r**8-6251*r**10+15889*r**12))+276480*r**16*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1460*Q2**8-2*Q2**7*(5402+2783*r**2)+Q2**6*(32558
            +30320*r**2+6062*r**4)+Q2**5*(-48034-62261*r**2-23544*r**4+179*r**6)
            +10*Q2**4*(2774+5352*r**2+2963*r**4+332*r**6-565*r**8)+2*Q2**3*(7300
            -5925*r**2-3991*r**4-2489*r**6+2275*r**8+7390*r**10)-2*(-1+r**2)**2*(1898
            +1223*r**2-1495*r**4+1120*r**6+690*r**8+2097*r**10+3347*r**12)-2*Q2**2*(16133
            +437*r**2+267*r**4+4050*r**6+7823*r**8+3393*r**10+13577*r**12)+Q2*(18542
            -8435*r**2-7718*r**4+15805*r**6+11810*r**8+24703*r**10-6250*r**12+22583*r**14))*sqrtq2)
            +logq2**2*(-4608*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(18232*Q2**10
            -10*Q2**9*(13724+10111*r**2)+5*Q2**8*(78888+117215*r**2+41187*r**4)
            -5*Q2**7*(93564+234377*r**2+149982*r**4+40629*r**6)+10*Q2**6*(-4884
            +67201*r**2+5022*r**4+25499*r**6+19974*r**8)+Q2**5*(726396+758185*r**2
            +3027480*r**4+1269180*r**6-147920*r**8-330609*r**10)+10*Q2**4*(-67296
            -122419*r**2-440175*r**4-264856*r**6-18934*r**8+26829*r**10+33831*r**12)
            -5*Q2**3*(-6012-112745*r**2-134118*r**4-200243*r**6-111292*r**8+46053*r**10
            +16190*r**12+31767*r**14)+10*Q2**2*(31632-16859*r**2+334536*r**4-75771*r**6
            -19970*r**8-17013*r**10+147792*r**12+30691*r**14+7602*r**16)+(-1+r**2)**2*(39272
            +19959*r**2+785041*r**4-410437*r**6-62835*r**8-1017407*r**10+1225031*r**12
            +193149*r**14+27427*r**16)-5*Q2*(39572-28873*r**2+586464*r**4-609878*r**6
            +188672*r**8+122688*r**10-289232*r**12+527846*r**14+87708*r**16+14393*r**18))
            -4608*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(18232*Q2**10-10*Q2**9*(13724
            +10111*r**2)+5*Q2**8*(78888+117215*r**2+41187*r**4)-5*Q2**7*(93564+234377*r**2
            +149982*r**4+40629*r**6)+10*Q2**6*(-4884+67201*r**2+5022*r**4+25499*r**6
            +19974*r**8)+Q2**5*(726396+758185*r**2+3027480*r**4+1269180*r**6-147920*r**8
            -330609*r**10)+10*Q2**4*(-67296-122419*r**2-440175*r**4-264856*r**6
            -18934*r**8+26829*r**10+33831*r**12)-5*Q2**3*(-6012-112745*r**2-134118*r**4
            -200243*r**6-111292*r**8+46053*r**10+16190*r**12+31767*r**14)+10*Q2**2*(31632
            -16859*r**2+334536*r**4-75771*r**6-19970*r**8-17013*r**10+147792*r**12
            +30691*r**14+7602*r**16)+(-1+r**2)**2*(39272+19959*r**2+785041*r**4
            -410437*r**6-62835*r**8-1017407*r**10+1225031*r**12+193149*r**14+27427*r**16)
            -5*Q2*(39572-28873*r**2+586464*r**4-609878*r**6+188672*r**8+122688*r**10
            -289232*r**12+527846*r**14+87708*r**16+14393*r**18))*sqrtq2)+logq2*(
            -384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(2116*Q2**13-2*Q2**12*(9108
            +12619*r**2)+2*Q2**11*(30107+94839*r**2+55326*r**4)-Q2**10*(82524+464505*r**2
            +503830*r**4+271177*r**6)+Q2**9*(-12650+102565*r**2-956343*r**4+404687*r**6
            +456725*r**8)+Q2**8*(185748+1500690*r**2+9046288*r**4+6734560*r**6+37588*r**8
            -581202*r**10)+4*Q2**7*(-50577-653676*r**2-4396709*r**4-6013338*r**6
            -2268443*r**8+21304*r**10+131559*r**12)+2*Q2**6*(-5244+451437*r**2+3295658*r**4
            +12347685*r**6+6050868*r**8+2917161*r**10-53878*r**12-130047*r**14)
            +2*Q2**5*(92184+971115*r**2+9952343*r**4+569217*r**6+10529633*r**8+1390007*r**10
            -4359085*r**12-389947*r**14-4923*r**16)+2*Q2**4*(-64400-1132995*r**2
            -13152856*r**4-5794016*r**6-24097672*r**8-10510722*r**10+619728*r**12
            +5396504*r**14+569504*r**16+40525*r**18)+2*Q2**3*(-3657+220405*r**2
            +2915816*r**4+2486740*r**6+5413694*r**8+8096534*r**10+985240*r**12+582924*r**14
            -2354805*r**16-256459*r**18-14432*r**20)+Q2**2*(50324+641367*r**2+9465106*r**4
            -13020193*r**6+53073688*r**8-26728814*r**10+11975516*r**12+4660834*r**14
            +4213588*r**16+3038487*r**18+151570*r**20-1473*r**22)+2*(-1+r**2)**2*(1978
            +45981*r**2+845416*r**4-1449165*r**6+8408684*r**8-3075618*r**10-13389600*r**12
            +10221314*r**14+614970*r**16+942821*r**18+29720*r**20+299*r**22)+Q2*(
            -24426-433827*r**2-7107823*r**4+17174255*r**6-64592135*r**8+58324102*r**10
            -12175746*r**12+27382306*r**14-35640980*r**16-4031715*r**18-4305551*r**20
            -143377*r**22+517*r**24))+384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(2116*Q2**14
            -2*Q2**13*(10166+13677*r**2)+2*Q2**12*(39215+116566*r**2+67945*r**4)
            -Q2**11*(142738+714397*r**2+804160*r**4+381829*r**6)+2*Q2**10*(34937
            +324797*r**2+5996*r**4+589847*r**6+363951*r**8)+Q2**9*(198398+1410775*r**2
            +9900066*r**4+7286216*r**6-823824*r**8-1037927*r**10)+2*Q2**8*(-194028
            -2150571*r**2-14066907*r**4-19917100*r**6-7922960*r**8+314415*r**10
            +553719*r**12)+Q2**7*(191820+3719886*r**2+26792856*r**4+66335558*r**6
            +45228860*r**8+14822878*r**10-719208*r**12-786330*r**14)+4*Q2**6*(48714
            +262461*r**2+3102624*r**4-7537063*r**6-3934460*r**8-3789011*r**10-3611184*r**12
            -103011*r**14+62562*r**16)+4*Q2**5*(-78292-1098147*r**2-12038157*r**4
            -8157788*r**6-17598261*r**8-11215181*r**10+1794403*r**12+5072768*r**14
            +482187*r**16+22724*r**18)-2*Q2**4*(-60743-1417800*r**2-17201667*r**4
            -21433612*r**6-35305382*r**8-42704928*r**10-10876234*r**12+5433308*r**14
            +8320813*r**16+866488*r**18+54957*r**20)+Q2**3*(57638+207871*r**2+3192664*r**4
            -23825305*r**6+37272820*r**8-53749270*r**10-6188032*r**12+1524506*r**14
            +7757350*r**16+8261015*r**18+693352*r**20+27391*r**22)-2*(-1+r**2)**2*(1978
            +47959*r**2+891397*r**4-603749*r**6+6959519*r**8+5333066*r**10-16465218*r**12
            -3168286*r**14+10836284*r**16+1557791*r**18+972541*r**20+30019*r**22
            +299*r**24)+2*Q2**2*(-37375-562759*r**2-8607148*r**4+10364671*r**6-52322815*r**8
            +15989614*r**10+1288776*r**12+5372978*r**14-22257701*r**16-5641895*r**18
            -3747804*r**20-146737*r**22+995*r**24)+Q2*(28382+542303*r**2+9052514*r**4
            -16254464*r**6+71722740*r**8-36416269*r**10-43807716*r**12+52643232*r**14
            -58175842*r**16+59541085*r**18+5855362*r**20+6216288*r**22+201104*r**24
            +81*r**26))*sqrtq2))*math.log(mu0)**2)/(7200*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4+7200*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2+logq2**4*(149299200*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+149299200*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**3*(-49766400*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-49766400*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)+logq2**2*(6220800*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+6220800*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+logq2*(
            -345600*(-Q2+(-1+r)**2)**3*r**8*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3-345600*(-Q2+(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2))+((-8*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(-131-4*Q2**10-13412*r**2+51045*r**4-323008*r**6+641774*r**8
            -644712*r**10+142382*r**12+53600*r**14+6453*r**16-404*r**18+13*r**20
            -7*Q2**9*(1+r**2)+3*Q2**8*(-47-102*r**2+41*r**4)+6*Q2**7*(145+1834*r**2
            +312*r**4-57*r**6)+6*Q2**6*(-249-6423*r**2-7092*r**4-623*r**6+63*r**8)
            +6*Q2**5*(80+4867*r**2+16621*r**4+6937*r**6+369*r**8-14*r**10)-2*Q2**4*(
            -576-23091*r**2+20622*r**4+10306*r**6-4110*r**8-891*r**10+84*r**12)
            +2*Q2**3*(-507-36702*r**2-13926*r**4-78457*r**6+14165*r**8-8712*r**10
            -1152*r**12+51*r**14)+6*Q2**2*(-25+1151*r**2+5374*r**4+19285*r**6-11218*r**8
            -10083*r**10-354*r**12-57*r**14+7*r**16)+Q2*(439+32373*r**2-73362*r**4
            +224402*r**6-163512*r**8+3216*r**10-62878*r**12-5058*r**14+1233*r**16
            -53*r**18))-8*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-131+4*Q2**11
            -13543*r**2+37633*r**4-271963*r**6+318766*r**8-2938*r**10-502330*r**12
            +195982*r**14+60053*r**16+6049*r**18-391*r**20+13*r**22+3*Q2**10*(1
            +r**2)+Q2**9*(134+292*r**2-130*r**4)+3*Q2**8*(-337-3817*r**2-685*r**4
            +155*r**6)+12*Q2**7*(197+4201*r**2+4619*r**4+439*r**6-60*r**8)+6*Q2**6*(
            -329-11539*r**2-30136*r**4-14652*r**6-929*r**8+77*r**10)+4*Q2**5*(
            -168-4125*r**2+42543*r**4+40490*r**6+8904*r**8+87*r**10+21*r**12)
            -6*Q2**4*(-361-20123*r**2-5465*r**4-15843*r**6+6787*r**8-4571*r**10
            -653*r**12+45*r**14)+4*Q2**3*(-216-20331*r**2-33375*r**4-75119*r**6
            -15319*r**8+17851*r**10-4401*r**12-465*r**14+15*r**16)+Q2**2*(-589
            -25617*r**2+112512*r**4-76448*r**6+211914*r**8-131022*r**10+256*r**12
            +2592*r**14-1533*r**16+95*r**18)-6*Q2*(-95-7704*r**2+15339*r**4-79008*r**6
            +96814*r**8-80736*r**10+33674*r**12+20256*r**14+1713*r**16-264*r**18
            +11*r**20))*sqrtq2+logq2**3*(-345600*(-Q2+(-1+r)**2)*r**16*(1-Q2+r**2)*(
            -5+3*r**2)*(-Q2+(1+r)**2)-345600*r**16*(-5+3*r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2)+logq2**2*(-5760*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-104-40*Q2**5+179*r**2-466*r**4-106*r**6-26*r**8+163*r**10
            +4*Q2**4*(44+17*r**2)+Q2**3*(-244-141*r**2+23*r**4)+Q2**2*(16+167*r**2
            -122*r**4-17*r**6)+Q2*(196-213*r**2+11*r**4+143*r**6-197*r**8))-5760*(
            -Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(-104-40*Q2**5
            +179*r**2-466*r**4-106*r**6-26*r**8+163*r**10+4*Q2**4*(44+17*r**2)
            +Q2**3*(-244-141*r**2+23*r**4)+Q2**2*(16+167*r**2-122*r**4-17*r**6)
            +Q2*(196-213*r**2+11*r**4+143*r**6-197*r**8))*sqrtq2)+logq2*(96*r**6*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(344+184*Q2**8+823*r**2
            +11917*r**4-8589*r**6-3175*r**8+50081*r**10-25973*r**12-3867*r**14
            +39*r**16-8*Q2**7*(129+149*r**2)+Q2**6*(1772+5475*r**2+2367*r**4)-2*Q2**5*(82
            +3119*r**2+3104*r**4+667*r**6)-Q2**4*(2520+3335*r**2+7961*r**4-535*r**6
            +895*r**8)+4*Q2**3*(524+2435*r**2+6626*r**4+1196*r**6-390*r**8+249*r**10)
            +Q2**2*(412-3923*r**2-7811*r**4-10226*r**6+15474*r**8+1297*r**10+97*r**12)
            -2*Q2*(546+675*r**2+9404*r**4-13055*r**6+10450*r**8-9071*r**10-2680*r**12
            +131*r**14))+96*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(344+184*Q2**8
            +823*r**2+11917*r**4-8589*r**6-3175*r**8+50081*r**10-25973*r**12-3867*r**14
            +39*r**16-8*Q2**7*(129+149*r**2)+Q2**6*(1772+5475*r**2+2367*r**4)-2*Q2**5*(82
            +3119*r**2+3104*r**4+667*r**6)-Q2**4*(2520+3335*r**2+7961*r**4-535*r**6
            +895*r**8)+4*Q2**3*(524+2435*r**2+6626*r**4+1196*r**6-390*r**8+249*r**10)
            +Q2**2*(412-3923*r**2-7811*r**4-10226*r**6+15474*r**8+1297*r**10+97*r**12)
            -2*Q2*(546+675*r**2+9404*r**4-13055*r**6+10450*r**8-9071*r**10-2680*r**12
            +131*r**14))*sqrtq2))*math.log(mus))/(-108*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3-108*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(-186624*r**14*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            +186624*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**2*(
            -46656*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -46656*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(3888*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+3888*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2))+math.log(mu0)*((16*r**6*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(-1244*Q2**15+Q2**14*(1555-2093*r**2)+8*Q2**13*(-4976
            -17342*r**2+11191*r**4)+Q2**12*(395281+6454251*r**2+1313295*r**4-484667*r**6)
            +4*Q2**11*(-341167-9943674*r**2-11579043*r**4-1366200*r**6+323588*r**8)
            +Q2**10*(2001907+92072315*r**2+212655102*r**4+126686574*r**6+12317879*r**8
            -1989473*r**10)+4*Q2**9*(-87080-12927746*r**2-81027301*r**4-80554626*r**6
            -41678206*r**8-3854960*r**10+433999*r**12)-Q2**8*(2876439+152084613*r**2
            +3294375*r**4+228978925*r**6-122523515*r**8-119382897*r**10-9277347*r**12
            +687711*r**14)+4*Q2**7*(894747+72182892*r**2+120140274*r**4+390029368*r**6
            +210961600*r**8-20087036*r**10-19492254*r**12-315360*r**14+5241*r**16)
            -Q2**6*(550159+97677423*r**2+419257020*r**4+1201481580*r**6+1417722594*r**8
            +96541314*r**10-182584212*r**12-59102340*r**14-2230665*r**16+202039*r**18)
            +16*Q2**5*(-131242-12519580*r**2+6227337*r**4-112975927*r**6+94246897*r**8
            -50005539*r**10+33920860*r**12+11980877*r**14+976863*r**16-473923*r**18
            +29033*r**20)+Q2**4*(1606315+219530377*r**2-47932271*r**4+3638946619*r**6
            -3575595426*r**8+2485504058*r**10+1146301874*r**12-1474986186*r**14-429390281*r**16
            -72990851*r**18+6277885*r**20-277553*r**22)-4*Q2**3*(-4043+7982994*r**2
            +5114607*r**4+339753520*r**6-841646300*r**8+1122205412*r**10-323010598*r**12
            +526913480*r**14-159605615*r**16-30852470*r**18-8049609*r**20+69384*r**22
            +5398*r**24)+(-1+r**2)**2*(-40741-7781817*r**2+29805338*r**4-489159014*r**6
            +2053290113*r**8-5426657939*r**10+6352160284*r**12-1887191300*r**14-231454595*r**16
            -334145983*r**18-37886390*r**20+3125738*r**22-223833*r**24+6539*r**26)
            +Q2**2*(-537719-67105119*r**2+194090334*r**4-1777800130*r**6+3400996075*r**8
            -3161942349*r**10-140904556*r**12-491733964*r**14-982681953*r**16-477718745*r**18
            -1032562*r**20+18424590*r**22-2366355*r**24+98053*r**26)-4*Q2*(-64688
            -10412686*r**2+43076877*r**4-483464590*r**6+1789224102*r**8-3709939964*r**10
            +3245160407*r**12-307481764*r**14+82533860*r**16-422387294*r**18-185467893*r**20
            -20965966*r**22+4357542*r**24-332440*r**26+10897*r**28))-16*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1244*Q2**15+Q2**14*(-1555+2093*r**2)
            +Q2**13*(39808+138736*r**2-89528*r**4)+Q2**12*(-395281-6454251*r**2
            -1313295*r**4+484667*r**6)+4*Q2**11*(341167+9943674*r**2+11579043*r**4
            +1366200*r**6-323588*r**8)+Q2**10*(-2001907-92072315*r**2-212655102*r**4
            -126686574*r**6-12317879*r**8+1989473*r**10)+4*Q2**9*(87080+12927746*r**2
            +81027301*r**4+80554626*r**6+41678206*r**8+3854960*r**10-433999*r**12)
            +Q2**8*(2876439+152084613*r**2+3294375*r**4+228978925*r**6-122523515*r**8
            -119382897*r**10-9277347*r**12+687711*r**14)-4*Q2**7*(894747+72182892*r**2
            +120140274*r**4+390029368*r**6+210961600*r**8-20087036*r**10-19492254*r**12
            -315360*r**14+5241*r**16)+Q2**6*(550159+97677423*r**2+419257020*r**4
            +1201481580*r**6+1417722594*r**8+96541314*r**10-182584212*r**12-59102340*r**14
            -2230665*r**16+202039*r**18)-16*Q2**5*(-131242-12519580*r**2+6227337*r**4
            -112975927*r**6+94246897*r**8-50005539*r**10+33920860*r**12+11980877*r**14
            +976863*r**16-473923*r**18+29033*r**20)+Q2**4*(-1606315-219530377*r**2
            +47932271*r**4-3638946619*r**6+3575595426*r**8-2485504058*r**10-1146301874*r**12
            +1474986186*r**14+429390281*r**16+72990851*r**18-6277885*r**20+277553*r**22)
            +4*Q2**3*(-4043+7982994*r**2+5114607*r**4+339753520*r**6-841646300*r**8
            +1122205412*r**10-323010598*r**12+526913480*r**14-159605615*r**16-30852470*r**18
            -8049609*r**20+69384*r**22+5398*r**24)+Q2**2*(537719+67105119*r**2-194090334*r**4
            +1777800130*r**6-3400996075*r**8+3161942349*r**10+140904556*r**12+491733964*r**14
            +982681953*r**16+477718745*r**18+1032562*r**20-18424590*r**22+2366355*r**24
            -98053*r**26)-(-1+r**2)**2*(-40741-7781817*r**2+29805338*r**4-489159014*r**6
            +2053290113*r**8-5426657939*r**10+6352160284*r**12-1887191300*r**14-231454595*r**16
            -334145983*r**18-37886390*r**20+3125738*r**22-223833*r**24+6539*r**26)
            +4*Q2*(-64688-10412686*r**2+43076877*r**4-483464590*r**6+1789224102*r**8
            -3709939964*r**10+3245160407*r**12-307481764*r**14+82533860*r**16-422387294*r**18
            -185467893*r**20-20965966*r**22+4357542*r**24-332440*r**26+10897*r**28))*sqrtq2
            +logq2**4*(-8294400*r**22*(1-Q2+r**2)*(-1555+1509*r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3-8294400*r**22*(-1555+1509*r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*sqrtq2)+logq2**3*(-276480*r**16*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(5300*Q2**7-2*Q2**6*(16960+4621*r**2)+Q2**5*(84270
            +51382*r**2-11148*r**4)+Q2**4*(-90100-85225*r**2-17966*r**4+25055*r**6)
            +Q2**3*(10600+23155*r**2+22199*r**4+46409*r**6-55235*r**8)+2*(-1+r**2)**2*(6890
            +10869*r**2-58876*r**4+1484*r**6-1706*r**8+38579*r**10)+Q2**2*(63600
            +44225*r**2-90596*r**4-21618*r**6+30764*r**8+171465*r**10)+Q2*(-53530
            -18473*r**2+242199*r**4+171334*r**6-162596*r**8+46499*r**10-203353*r**12))
            +276480*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(5300*Q2**8-2*Q2**7*(19610
            +7271*r**2)+Q2**6*(118190+94544*r**2-1906*r**4)+Q2**5*(-174370-220877*r**2
            -58200*r**4+36203*r**6)+10*Q2**4*(10070+19848*r**2+12539*r**4+3932*r**6
            -8029*r**8)+2*Q2**3*(26500+5235*r**2-67975*r**4-45113*r**6+19795*r**8
            +113350*r**10)-2*(-1+r**2)**2*(6890+17759*r**2-48007*r**4-57392*r**6
            -222*r**8+36873*r**10+38579*r**12)-2*Q2**2*(58565+63149*r**2-144285*r**4
            -141774*r**6+85871*r**8+77865*r**10+187409*r**12)+Q2*(67310+66181*r**2
            -371174*r**4-153323*r**6-135838*r**8+203047*r**10-874*r**12+280511*r**14))*sqrtq2)
            +logq2**2*(-4608*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(148408*Q2**10
            -10*Q2**9*(111068+70999*r**2)+5*Q2**8*(638760+784919*r**2+213699*r**4)
            -5*Q2**7*(759996+1555697*r**2+684990*r**4+88653*r**6)+10*Q2**6*(-42900
            +567913*r**2+107166*r**4-44509*r**6+81318*r**8)+Q2**5*(6067644+468625*r**2
            +9788280*r**4+3550140*r**6-698480*r**8-3292761*r**10)+10*Q2**4*(-568992
            -207691*r**2-1564335*r**4-896440*r**6-98518*r**8+169653*r**10+388359*r**12)
            -5*Q2**3*(-59580-429521*r**2-351366*r**4-794555*r**6-1800124*r**8-21075*r**10
            +278174*r**12+272319*r**14)-10*Q2**2*(-268368+483539*r**2-1887720*r**4
            +276003*r**6+572546*r**8+313149*r**10-2361360*r**12-760075*r**14+21486*r**16)
            +(-1+r**2)**2*(342248-694929*r**2+5169889*r**4-3348253*r**6-3311475*r**8
            -16622423*r**10+14792279*r**12+3092661*r**14+83203*r**16)+5*Q2*(-340820
            +912049*r**2-4079232*r**4+3596006*r**6+3155680*r**8+151584*r**10+5381360*r**12
            -6568694*r**14-1815612*r**16+5119*r**18))-4608*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(148408*Q2**10-10*Q2**9*(111068+70999*r**2)+5*Q2**8*(638760
            +784919*r**2+213699*r**4)-5*Q2**7*(759996+1555697*r**2+684990*r**4+88653*r**6)
            +10*Q2**6*(-42900+567913*r**2+107166*r**4-44509*r**6+81318*r**8)+Q2**5*(6067644
            +468625*r**2+9788280*r**4+3550140*r**6-698480*r**8-3292761*r**10)+10*Q2**4*(
            -568992-207691*r**2-1564335*r**4-896440*r**6-98518*r**8+169653*r**10
            +388359*r**12)-5*Q2**3*(-59580-429521*r**2-351366*r**4-794555*r**6-1800124*r**8
            -21075*r**10+278174*r**12+272319*r**14)-10*Q2**2*(-268368+483539*r**2
            -1887720*r**4+276003*r**6+572546*r**8+313149*r**10-2361360*r**12-760075*r**14
            +21486*r**16)+(-1+r**2)**2*(342248-694929*r**2+5169889*r**4-3348253*r**6
            -3311475*r**8-16622423*r**10+14792279*r**12+3092661*r**14+83203*r**16)
            +5*Q2*(-340820+912049*r**2-4079232*r**4+3596006*r**6+3155680*r**8+151584*r**10
            +5381360*r**12-6568694*r**14-1815612*r**16+5119*r**18))*sqrtq2)+logq2*(
            -384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(46276*Q2**13-2*Q2**12*(199188
            +240355*r**2)+2*Q2**11*(658427+1756863*r**2+945990*r**4)-Q2**10*(1804764
            +9026433*r**2+9643126*r**4+3815137*r**6)+Q2**9*(-276650+6535405*r**2
            +4182561*r**4+10633511*r**6+4341245*r**8)+Q2**8*(4062228+12397890*r**2
            +57466624*r**4+31546480*r**6-5549756*r**8-2944242*r**10)+4*Q2**7*(-1106097
            -6909900*r**2-30961277*r**4-34297194*r**6-6958619*r**8+1489816*r**10
            +381615*r**12)-2*Q2**6*(114684-6873909*r**2-22069610*r**4-76985805*r**6
            -13591284*r**8-703281*r**10+1878646*r**12+530295*r**14)+2*Q2**5*(2016024
            +6121923*r**2+69719855*r**4-30000663*r**6+35064809*r**8+17574383*r**10
            -35205397*r**12-5907955*r**14+336717*r**16)-2*Q2**4*(1408400+8695515*r**2
            +86835688*r**4-17141632*r**6+72033496*r**8+45202866*r**10+14641536*r**12
            -56965592*r**14-9124112*r**16+47435*r**18)+2*Q2**3*(-79977+2731405*r**2
            +13807568*r**4+3248500*r**6+94622*r**8+75738854*r**10+26396680*r**12
            +27688812*r**14-23264565*r**16-2818867*r**18-97592*r**20)+2*(-1+r**2)**2*(43258
            +230997*r**2+5992624*r**4-15292125*r**6+39464156*r**8+38088126*r**10
            -187474176*r**12+79105586*r**14+29849610*r**16+8122829*r**18-124624*r**20
            +6539*r**22)+Q2**2*(1100564+1979535*r**2+73688818*r**4-148213849*r**6
            +320684824*r**8-173861726*r**10+67447580*r**12+132485842*r**14+140018644*r**16
            +23422671*r**18-3636878*r**20+167175*r**22)-Q2*(534186+1632219*r**2
            +52412215*r**4-166379975*r**6+397158335*r**8-259062262*r**10-86450958*r**12
            -438989170*r**14+266364260*r**16+180411675*r**18+38762711*r**20-2359751*r**22
            +68915*r**24))+384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(46276*Q2**14
            -2*Q2**13*(222326+263493*r**2)+2*Q2**12*(857615+2196406*r**2+1186345*r**4)
            -Q2**11*(3121618+13857013*r**2+15048832*r**4+5707117*r**6)+2*Q2**10*(764057
            +8683301*r**2+11426060*r**4+12045887*r**6+4078191*r**8)+Q2**9*(4338878
            +6139135*r**2+46748658*r**4+16730408*r**6-20524512*r**8-7285487*r**10)
            +2*Q2**8*(-4243308-22049859*r**2-96854811*r**4-113100940*r**6-26915600*r**8
            +7226631*r**10+2235351*r**12)+2*Q2**7*(2097510+22905903*r**2+97811964*r**4
            +207502747*r**6+96102910*r**8+11640887*r**10-5621508*r**12-1293525*r**14)
            +4*Q2**6*(1065354-318651*r**2+20388168*r**4-64528039*r**6-27756140*r**8
            +1639909*r**10-17015016*r**12-1749507*r**14+433506*r**16)-4*Q2**5*(1712212
            +8416731*r**2+81338733*r**4+11288780*r**6+38548821*r**8+48921029*r**10
            -1494739*r**12-49039472*r**14-7347675*r**16+192076*r**18)-2*Q2**4*(-1328423
            -12835320*r**2-109338771*r**4-72942556*r**6-54986486*r**8-192975216*r**10
            -86241082*r**12+14635244*r**14+89354269*r**16+11895544*r**18+50157*r**20)
            +Q2**3*(1260518-3323321*r**2+40610872*r**4-182325985*r**6+313998580*r**8
            -325528678*r**10-136823488*r**12+24314858*r**14+131170150*r**16+75589535*r**18
            +2196040*r**20+362359*r**22)-2*(-1+r**2)**2*(43258+274255*r**2+6223621*r**4
            -9299501*r**6+24172031*r**8+77552282*r**10-149386050*r**12-108368590*r**14
            +108955196*r**16+37972439*r**18+7998205*r**20-118085*r**22+6539*r**24)
            -2*Q2**2*(817375+2356159*r**2+64040284*r**4-120452503*r**6+284814655*r**8
            -56119582*r**10-96432552*r**12-119527874*r**14+269434373*r**16+171926495*r**18
            +29274252*r**20-2914727*r**22+118045*r**24)+Q2*(620702+2455367*r**2
            +65192210*r**4-168060512*r**6+382860420*r**8+25831451*r**10-793885764*r**12
            +458844000*r**14-804296386*r**16+501834325*r**18+246133042*r**20+53160192*r**22
            -2566240*r**24+81993*r**26))*sqrtq2))/(43200*r**4*(1-Q2+r**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4+43200*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2+logq2**4*(895795200*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+895795200*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**3*(-298598400*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-298598400*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)+logq2**2*(37324800*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+37324800*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+logq2*(
            -2073600*(-Q2+(-1+r)**2)**3*r**8*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3-2073600*(-Q2+(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2))+((-4*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(-131-4*Q2**10-13412*r**2+51045*r**4-323008*r**6+641774*r**8
            -644712*r**10+142382*r**12+53600*r**14+6453*r**16-404*r**18+13*r**20
            -7*Q2**9*(1+r**2)+3*Q2**8*(-47-102*r**2+41*r**4)+6*Q2**7*(145+1834*r**2
            +312*r**4-57*r**6)+6*Q2**6*(-249-6423*r**2-7092*r**4-623*r**6+63*r**8)
            +6*Q2**5*(80+4867*r**2+16621*r**4+6937*r**6+369*r**8-14*r**10)-2*Q2**4*(
            -576-23091*r**2+20622*r**4+10306*r**6-4110*r**8-891*r**10+84*r**12)
            +2*Q2**3*(-507-36702*r**2-13926*r**4-78457*r**6+14165*r**8-8712*r**10
            -1152*r**12+51*r**14)+6*Q2**2*(-25+1151*r**2+5374*r**4+19285*r**6-11218*r**8
            -10083*r**10-354*r**12-57*r**14+7*r**16)+Q2*(439+32373*r**2-73362*r**4
            +224402*r**6-163512*r**8+3216*r**10-62878*r**12-5058*r**14+1233*r**16
            -53*r**18))-4*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-131+4*Q2**11
            -13543*r**2+37633*r**4-271963*r**6+318766*r**8-2938*r**10-502330*r**12
            +195982*r**14+60053*r**16+6049*r**18-391*r**20+13*r**22+3*Q2**10*(1
            +r**2)+Q2**9*(134+292*r**2-130*r**4)+3*Q2**8*(-337-3817*r**2-685*r**4
            +155*r**6)+12*Q2**7*(197+4201*r**2+4619*r**4+439*r**6-60*r**8)+6*Q2**6*(
            -329-11539*r**2-30136*r**4-14652*r**6-929*r**8+77*r**10)+4*Q2**5*(
            -168-4125*r**2+42543*r**4+40490*r**6+8904*r**8+87*r**10+21*r**12)
            -6*Q2**4*(-361-20123*r**2-5465*r**4-15843*r**6+6787*r**8-4571*r**10
            -653*r**12+45*r**14)+4*Q2**3*(-216-20331*r**2-33375*r**4-75119*r**6
            -15319*r**8+17851*r**10-4401*r**12-465*r**14+15*r**16)+Q2**2*(-589
            -25617*r**2+112512*r**4-76448*r**6+211914*r**8-131022*r**10+256*r**12
            +2592*r**14-1533*r**16+95*r**18)-6*Q2*(-95-7704*r**2+15339*r**4-79008*r**6
            +96814*r**8-80736*r**10+33674*r**12+20256*r**14+1713*r**16-264*r**18
            +11*r**20))*sqrtq2+logq2**3*(-172800*(-Q2+(-1+r)**2)*r**16*(1-Q2+r**2)*(
            -5+3*r**2)*(-Q2+(1+r)**2)-172800*r**16*(-5+3*r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2)+logq2**2*(-2880*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-104-40*Q2**5+179*r**2-466*r**4-106*r**6-26*r**8+163*r**10
            +4*Q2**4*(44+17*r**2)+Q2**3*(-244-141*r**2+23*r**4)+Q2**2*(16+167*r**2
            -122*r**4-17*r**6)+Q2*(196-213*r**2+11*r**4+143*r**6-197*r**8))-2880*(
            -Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(-104-40*Q2**5
            +179*r**2-466*r**4-106*r**6-26*r**8+163*r**10+4*Q2**4*(44+17*r**2)
            +Q2**3*(-244-141*r**2+23*r**4)+Q2**2*(16+167*r**2-122*r**4-17*r**6)
            +Q2*(196-213*r**2+11*r**4+143*r**6-197*r**8))*sqrtq2)+logq2*(48*r**6*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(344+184*Q2**8+823*r**2
            +11917*r**4-8589*r**6-3175*r**8+50081*r**10-25973*r**12-3867*r**14
            +39*r**16-8*Q2**7*(129+149*r**2)+Q2**6*(1772+5475*r**2+2367*r**4)-2*Q2**5*(82
            +3119*r**2+3104*r**4+667*r**6)-Q2**4*(2520+3335*r**2+7961*r**4-535*r**6
            +895*r**8)+4*Q2**3*(524+2435*r**2+6626*r**4+1196*r**6-390*r**8+249*r**10)
            +Q2**2*(412-3923*r**2-7811*r**4-10226*r**6+15474*r**8+1297*r**10+97*r**12)
            -2*Q2*(546+675*r**2+9404*r**4-13055*r**6+10450*r**8-9071*r**10-2680*r**12
            +131*r**14))+48*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(344+184*Q2**8
            +823*r**2+11917*r**4-8589*r**6-3175*r**8+50081*r**10-25973*r**12-3867*r**14
            +39*r**16-8*Q2**7*(129+149*r**2)+Q2**6*(1772+5475*r**2+2367*r**4)-2*Q2**5*(82
            +3119*r**2+3104*r**4+667*r**6)-Q2**4*(2520+3335*r**2+7961*r**4-535*r**6
            +895*r**8)+4*Q2**3*(524+2435*r**2+6626*r**4+1196*r**6-390*r**8+249*r**10)
            +Q2**2*(412-3923*r**2-7811*r**4-10226*r**6+15474*r**8+1297*r**10+97*r**12)
            -2*Q2*(546+675*r**2+9404*r**4-13055*r**6+10450*r**8-9071*r**10-2680*r**12
            +131*r**14))*sqrtq2))*math.log(mus))/(-36*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3-36*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(-62208*r**14*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            +62208*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**2*(-15552*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -15552*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(1296*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+1296*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)))+((-16*r**6*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(-2044*Q2**15+Q2**14*(2555-1093*r**2)+8*Q2**13*(-8176-24142*r**2
            +14591*r**4)+Q2**12*(649481+8920851*r**2+1795095*r**4-631267*r**6)+4*Q2**11*(
            -560567-13698474*r**2-15672843*r**4-1803000*r**6+405988*r**8)+Q2**10*(3289307
            +126663715*r**2+287097102*r**4+167826174*r**6+15159679*r**8-2317273*r**10)
            +4*Q2**9*(-143080-18197746*r**2-113290301*r**4-114208626*r**6-51672206*r**8
            -4030960*r**10+422999*r**12)+Q2**8*(-4726239-201486813*r**2+89502225*r**4
            -28081925*r**6+253844515*r**8+110645097*r**10+4539147*r**12-219111*r**14)
            +4*Q2**7*(1470147+96142092*r**2+114539874*r**4+323906168*r**6+116561600*r**8
            -57508636*r**10-8091054*r**12+1470240*r**14-106959*r**16)-Q2**6*(903959
            +128668023*r**2+469798620*r**4+941127180*r**6+875779794*r**8-395231886*r**10
            -326202612*r**12-33328740*r**14+367935*r**16+138239*r**18)+16*Q2**5*(
            -215642-16752380*r**2+20414337*r**4-116656127*r**6+109016297*r**8-50729739*r**10
            +24632060*r**12+14859877*r**14+1026663*r**16-652523*r**18+40033*r**20)
            +Q2**4*(2639315+292029377*r**2-362865271*r**4+3667867619*r**6-4675905426*r**8
            +1506462058*r**10+1243779874*r**12-1473912186*r**14-608129281*r**16-76079851*r**18
            +9140885*r**20-384553*r**22)-4*Q2**3*(-6643+10542594*r**2-15773193*r**4
            +348601520*r**6-1005154300*r**8+1094620612*r**10-296951798*r**12+646643080*r**14
            -130090615*r**16-46838470*r**18-8254209*r**20+54984*r**22+10598*r**24)
            +(-1+r**2)**2*(-66941-10280817*r**2+58974538*r**4-606473014*r**6+2559710713*r**8
            -5991663739*r**10+6320148284*r**12-1044854500*r**14-633481195*r**16-389824583*r**18
            -35632390*r**20+4963738*r**22-322833*r**24+9139*r**26)+Q2**2*(-883519
            -88908519*r**2+356065134*r**4-2131735730*r**6+4146413075*r**8-2838811749*r**10
            -212735756*r**12-963059564*r**14-1584801753*r**16-578361745*r**18+36644638*r**20
            +27788190*r**22-3570555*r**24+143453*r**26)-4*Q2*(-106288-13753886*r**2
            +78352677*r**4-607477790*r**6+2180355702*r**8-3993332764*r**10+3062875807*r**12
            +82048636*r**14+345176260*r**16-655664494*r**18-236684493*r**20-16531166*r**22
            +6420342*r**24-487640*r**26+15497*r**28))+16*r**6*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(2044*Q2**15+Q2**14*(-2555+1093*r**2)-8*Q2**13*(-8176
            -24142*r**2+14591*r**4)+Q2**12*(-649481-8920851*r**2-1795095*r**4+631267*r**6)
            +Q2**11*(2242268+54793896*r**2+62691372*r**4+7212000*r**6-1623952*r**8)
            +Q2**10*(-3289307-126663715*r**2-287097102*r**4-167826174*r**6-15159679*r**8
            +2317273*r**10)+4*Q2**9*(143080+18197746*r**2+113290301*r**4+114208626*r**6
            +51672206*r**8+4030960*r**10-422999*r**12)+Q2**8*(4726239+201486813*r**2
            -89502225*r**4+28081925*r**6-253844515*r**8-110645097*r**10-4539147*r**12
            +219111*r**14)+4*Q2**7*(-1470147-96142092*r**2-114539874*r**4-323906168*r**6
            -116561600*r**8+57508636*r**10+8091054*r**12-1470240*r**14+106959*r**16)
            +Q2**6*(903959+128668023*r**2+469798620*r**4+941127180*r**6+875779794*r**8
            -395231886*r**10-326202612*r**12-33328740*r**14+367935*r**16+138239*r**18)
            -16*Q2**5*(-215642-16752380*r**2+20414337*r**4-116656127*r**6+109016297*r**8
            -50729739*r**10+24632060*r**12+14859877*r**14+1026663*r**16-652523*r**18
            +40033*r**20)+Q2**4*(-2639315-292029377*r**2+362865271*r**4-3667867619*r**6
            +4675905426*r**8-1506462058*r**10-1243779874*r**12+1473912186*r**14+608129281*r**16
            +76079851*r**18-9140885*r**20+384553*r**22)+4*Q2**3*(-6643+10542594*r**2
            -15773193*r**4+348601520*r**6-1005154300*r**8+1094620612*r**10-296951798*r**12
            +646643080*r**14-130090615*r**16-46838470*r**18-8254209*r**20+54984*r**22
            +10598*r**24)+Q2**2*(883519+88908519*r**2-356065134*r**4+2131735730*r**6
            -4146413075*r**8+2838811749*r**10+212735756*r**12+963059564*r**14+1584801753*r**16
            +578361745*r**18-36644638*r**20-27788190*r**22+3570555*r**24-143453*r**26)
            -(-1+r**2)**2*(-66941-10280817*r**2+58974538*r**4-606473014*r**6+2559710713*r**8
            -5991663739*r**10+6320148284*r**12-1044854500*r**14-633481195*r**16-389824583*r**18
            -35632390*r**20+4963738*r**22-322833*r**24+9139*r**26)+4*Q2*(-106288
            -13753886*r**2+78352677*r**4-607477790*r**6+2180355702*r**8-3993332764*r**10
            +3062875807*r**12+82048636*r**14+345176260*r**16-655664494*r**18-236684493*r**20
            -16531166*r**22+6420342*r**24-487640*r**26+15497*r**28))*sqrtq2+logq2**4*(8294400*r**22*(1
            -Q2+r**2)*(-2555+2109*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3
            +8294400*r**22*(-2555+2109*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**3*(276480*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1300*Q2**7
            +Q2**6*(-8320+5558*r**2)-2*Q2**5*(-10335+509*r**2+13974*r**4)+Q2**4*(
            -22100-27425*r**2-5566*r**4+30055*r**6)+Q2**3*(2600+4955*r**2+22399*r**4
            +71809*r**6-72235*r**8)+2*(-1+r**2)**2*(1690+21069*r**2-91676*r**4
            -7316*r**6+3494*r**8+45979*r**10)+Q2**2*(15600+84025*r**2-153796*r**4
            -27618*r**6+41164*r**8+222465*r**10)+Q2*(-13130-101473*r**2+402399*r**4
            +320534*r**6-187396*r**8+44299*r**10-251153*r**12))-276480*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1300*Q2**8+Q2**7*(-9620+4258*r**2)
            +Q2**6*(28990+1744*r**2-33506*r**4)+Q2**5*(-42770-47077*r**2+23400*r**4
            +58003*r**6)+10*Q2**4*(2470+5448*r**2+5539*r**4+4732*r**6-10229*r**8)
            +2*Q2**3*(6500+38235*r**2-90575*r**4-60913*r**6+20795*r**8+147350*r**10)
            -2*(-1+r**2)**2*(1690+22759*r**2-70607*r**4-98992*r**6-3822*r**8+49473*r**10
            +45979*r**12)-2*Q2**2*(14365+100549*r**2-236085*r**4-250974*r**6+100471*r**8
            +109665*r**10+236809*r**12)+Q2*(16510+149981*r**2-565174*r**4-328723*r**6
            -280238*r**8+206447*r**10+29926*r**12+343111*r**14))*sqrtq2)+logq2**2*(
            -4608*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-150008*Q2**10
            +10*Q2**9*(111868+64799*r**2)-5*Q2**8*(643560+689119*r**2+141099*r**4)
            +5*Q2**7*(767196+1355497*r**2+362190*r**4-59547*r**6)-10*Q2**6*(-45300
            +586913*r**2+149166*r**4-200309*r**6+32118*r**8)+Q2**5*(-6228444+3040375*r**2
            -740280*r**4+589860*r**6+394480*r**8+3698961*r**10)-10*Q2**4*(-588192
            +276109*r**2-337335*r**4-130040*r**6-65318*r**8+141453*r**10+462159*r**12)
            +5*Q2**3*(-66780-133321*r**2+101034*r**4-288355*r**6-2370524*r**8-265275*r**10
            +371374*r**12+283719*r**14)+(-1+r**2)**2*(-359848+1230729*r**2-4473689*r**4
            +3388853*r**6+5072475*r**8+21941023*r**10-17922079*r**12-4062861*r**14
            +2197*r**16)+10*Q2**2*(-277968+702139*r**2-1393320*r**4+69003*r**6+831346*r**8
            +424149*r**10-3100560*r**12-1082675*r**14+73086*r**16)-5*Q2*(-356020
            +1339049*r**2-3695232*r**4+2791606*r**6+6080480*r**8+861984*r**10+7304560*r**12
            -8039494*r**14-2514012*r**16+80519*r**18))+4608*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(150008*Q2**10-10*Q2**9*(111868+64799*r**2)+5*Q2**8*(643560
            +689119*r**2+141099*r**4)+5*Q2**7*(-767196-1355497*r**2-362190*r**4
            +59547*r**6)+10*Q2**6*(-45300+586913*r**2+149166*r**4-200309*r**6+32118*r**8)
            -Q2**5*(-6228444+3040375*r**2-740280*r**4+589860*r**6+394480*r**8+3698961*r**10)
            +10*Q2**4*(-588192+276109*r**2-337335*r**4-130040*r**6-65318*r**8+141453*r**10
            +462159*r**12)-5*Q2**3*(-66780-133321*r**2+101034*r**4-288355*r**6-2370524*r**8
            -265275*r**10+371374*r**12+283719*r**14)-(-1+r**2)**2*(-359848+1230729*r**2
            -4473689*r**4+3388853*r**6+5072475*r**8+21941023*r**10-17922079*r**12
            -4062861*r**14+2197*r**16)-10*Q2**2*(-277968+702139*r**2-1393320*r**4
            +69003*r**6+831346*r**8+424149*r**10-3100560*r**12-1082675*r**14+73086*r**16)
            +5*Q2*(-356020+1339049*r**2-3695232*r**4+2791606*r**6+6080480*r**8
            +861984*r**10+7304560*r**12-8039494*r**14-2514012*r**16+80519*r**18))*sqrtq2)
            +logq2*(384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(64676*Q2**13-2*Q2**12*(278388
            +327755*r**2)+2*Q2**11*(920227+2382663*r**2+1261590*r**4)-Q2**10*(2522364
            +12355833*r**2+13161926*r**4+4846937*r**6)+Q2**9*(-386650+10118405*r**2
            +11601561*r**4+15270511*r**6+4772245*r**8)+2*Q2**8*(2838714+6321945*r**2
            +24061312*r**4+8773240*r**6-4608878*r**8-937521*r**10)-4*Q2**7*(1545897
            +7963500*r**2+28320277*r**4+25639194*r**6-56381*r**8-2317016*r**10+38985*r**12)
            -2*Q2**6*(160284-8919309*r**2-19376410*r**4-63320805*r**6+8236716*r**8
            +13487319*r**10+2786246*r**12+210495*r**14)+2*Q2**5*(2817624+5089323*r**2
            +63513655*r**4-51664863*r**6+4235809*r**8+21620983*r**10-35413997*r**12
            -7656155*r**14+572517*r**16)-2*Q2**4*(1968400+8464515*r**2+75307688*r**4
            -56949632*r**6-3670504*r**8+20824866*r**10+26929536*r**12-65613592*r**14
            -11988112*r**16+280435*r**18)-2*Q2**3*(111777-3338405*r**2-7839568*r**4
            +7187500*r**6+26999378*r**8-82614454*r**10-38004680*r**12-42124812*r**14
            +26039565*r**16+3299867*r**18+86392*r**20)+2*(-1+r**2)**2*(60458+145197*r**2
            +5509424*r**4-17611125*r**6+22031356*r**8+77394126*r**10-237854976*r**12
            +77434786*r**14+45479610*r**16+8486629*r**18-351824*r**20+9139*r**22)
            +Q2**2*(1538164+3735*r**2+72414818*r**4-175832849*r**6+255540824*r**8
            -148802926*r**10+49669180*r**12+192171842*r**14+206670644*r**16+22867671*r**18
            -6677278*r**20+279375*r**22)-Q2*(746586+479619*r**2+49622015*r**4-184552975*r**6
            +322187335*r**8-128949062*r**10-201721758*r**12-576876770*r**14+254600260*r**16
            +273300675*r**18+41470111*r**20-4558351*r**22+114715*r**24))-384*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(64676*Q2**14-2*Q2**13*(310726+360093*r**2)
            +Q2**12*(2397230+5977612*r**2+3178690*r**4)-Q2**11*(4362818+18961613*r**2
            +20450432*r**4+7370117*r**6)+Q2**10*(2135714+24996602*r**2+37119320*r**4
            +33279374*r**6+9619182*r**8)+Q2**9*(6064078+2912135*r**2+26402658*r**4
            -9325592*r**6-29260512*r**8-6647287*r**10)+2*Q2**8*(-5930508-25087659*r**2
            -87023811*r**4-84112940*r**6-4051600*r**8+10180431*r**10+859551*r**12)
            +Q2**7*(5863020+55876206*r**2+183887928*r**4+342479494*r**6+85857820*r**8
            -36468226*r**10-14684616*r**12-265050*r**14)+4*Q2**6*(1488954-1834851*r**2
            +17608968*r**4-67181039*r**6-25424140*r**8+21672509*r**10-9570216*r**12
            -2329707*r**14+391506*r**16)-4*Q2**5*(2393012+8185731*r**2+71955333*r**4
            -22550420*r**6-25549779*r**8+23340829*r**10+6568261*r**12-54341872*r**14
            -9535875*r**16+426476*r**18)+2*Q2**4*(1856623+13771320*r**2+91611771*r**4
            +11170556*r**6-87619514*r**8+99768816*r**10+85759082*r**12+3440756*r**14
            -103641269*r**16-15007544*r**18+194043*r**20)+Q2**3*(1761718-6449521*r**2
            +50058872*r**4-177136985*r**6+323914580*r**8-260033078*r**10-191569088*r**12
            +31912858*r**14+174500150*r**16+81546535*r**18+95240*r**20+452159*r**22)
            -2*(-1+r**2)**2*(60458+205655*r**2+5654621*r**4-12101701*r**6+4420231*r**8
            +99425482*r**10-160460850*r**12-160420190*r**14+122914396*r**16+53966239*r**18
            +8134805*r**20-342685*r**22+9139*r**24)-2*Q2**2*(1142375+1010759*r**2
            +61020284*r**4-143985503*r**6+200947655*r**8-11105582*r**10-150427752*r**12
            -167517874*r**14+326721373*r**16+251419495*r**18+28830252*r**20-5478127*r**22
            +197045*r**24)+Q2*(867502+1274767*r**2+60660610*r**4-191900512*r**6
            +263160420*r**8+224678851*r**10-1071894564*r**12+482479200*r**14-1016766386*r**16
            +517825325*r**18+371079842*r**20+55310592*r**22-5183840*r**24+132993*r**26))*sqrtq2))/(43200*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+43200*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*sqrtq2+logq2**4*(895795200*r**20*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3+895795200*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**3*(-298598400*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-298598400*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2**2*(37324800*r**12*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+37324800*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)+logq2*(-2073600*(-Q2+(-1+r)**2)**3*r**8*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3-2073600*(-Q2+(-1+r)**2)**3*r**8*(1-Q2+r**2)*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2))+((-128*r**6*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-4*Q2**15+Q2**14*(5
            -14*r**2)+2*Q2**13*(-64-277*r**2+191*r**4)+Q2**12*(1271+25972*r**2
            +5347*r**4-2070*r**6)+4*Q2**11*(-1097-40154*r**2-47621*r**4-5762*r**6
            +1430*r**8)+Q2**10*(6437+372346*r**2+876886*r**4+532336*r**6+55349*r**8
            -9346*r**10)+2*Q2**9*(-560-102001*r**2-644071*r**4-630526*r**6-372206*r**8
            -39065*r**10+4589*r**12)-Q2**8*(9249+639012*r**2+304731*r**4+1815170*r**6
            -231185*r**8-648864*r**10-63003*r**12+5034*r**14)+4*Q2**7*(2877+301704*r**2
            +643086*r**4+2236316*r**6+1391300*r**8+11348*r**10-136854*r**12-7176*r**14
            +375*r**16)-Q2**6*(1769+412698*r**2+2027004*r**4+7064544*r**6+9063430*r**8
            +2026804*r**10-505892*r**12-387696*r**14-19671*r**16+1250*r**18)+2*Q2**5*(
            -3376-416711*r**2-92247*r**4-4616092*r**6+3560796*r**8-2065610*r**10
            +1643654*r**12+427828*r**14+39468*r**16-15319*r**18+937*r**20)+Q2**4*(5165
            +918716*r**2+726317*r**4+18863222*r**6-15213078*r**8+15979344*r**10
            +5668242*r**12-7685548*r**14-1682503*r**16-370588*r**18+23825*r**20
            -1114*r**22)-4*Q2**3*(-13+33646*r**2+91369*r**4+1742130*r**6-3876870*r**8
            +5930304*r**10-1763102*r**12+2373304*r**14-922745*r**16-111150*r**18
            -41291*r**20+406*r**22+12*r**24)+(-1+r**2)**2*(-131-32786*r**2+64842*r**4
            -2184152*r**6+9124843*r**8-26512914*r**10+33183372*r**12-12439488*r**14
            +40371*r**16-1567798*r**18-204310*r**20+10584*r**22-859*r**24+26*r**26)
            +Q2**2*(-1729-281938*r**2+508934*r**4-8162544*r**6+15403505*r**8-17469818*r**10
            -511276*r**12-1100496*r**14-3252191*r**16-2176230*r**18-122138*r**20
            +66944*r**22-8593*r**24+370*r**26)+2*Q2*(416+87757*r**2-230081*r**4
            +4267466*r**6-16213550*r**8+36888763*r**10-34933539*r**12+5617212*r**14
            +768108*r**16+2954035*r**18+1614521*r**20+245882*r**22-32606*r**24+2501*r**26
            -85*r**28))+128*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**15
            +Q2**14*(-5+14*r**2)+Q2**13*(128+554*r**2-382*r**4)+Q2**12*(-1271-25972*r**2
            -5347*r**4+2070*r**6)+4*Q2**11*(1097+40154*r**2+47621*r**4+5762*r**6
            -1430*r**8)+Q2**10*(-6437-372346*r**2-876886*r**4-532336*r**6-55349*r**8
            +9346*r**10)+2*Q2**9*(560+102001*r**2+644071*r**4+630526*r**6+372206*r**8
            +39065*r**10-4589*r**12)+Q2**8*(9249+639012*r**2+304731*r**4+1815170*r**6
            -231185*r**8-648864*r**10-63003*r**12+5034*r**14)-4*Q2**7*(2877+301704*r**2
            +643086*r**4+2236316*r**6+1391300*r**8+11348*r**10-136854*r**12-7176*r**14
            +375*r**16)+Q2**6*(1769+412698*r**2+2027004*r**4+7064544*r**6+9063430*r**8
            +2026804*r**10-505892*r**12-387696*r**14-19671*r**16+1250*r**18)+Q2**5*(6752
            +833422*r**2+184494*r**4+9232184*r**6-7121592*r**8+4131220*r**10-3287308*r**12
            -855656*r**14-78936*r**16+30638*r**18-1874*r**20)+Q2**4*(-5165-918716*r**2
            -726317*r**4-18863222*r**6+15213078*r**8-15979344*r**10-5668242*r**12
            +7685548*r**14+1682503*r**16+370588*r**18-23825*r**20+1114*r**22)+4*Q2**3*(
            -13+33646*r**2+91369*r**4+1742130*r**6-3876870*r**8+5930304*r**10-1763102*r**12
            +2373304*r**14-922745*r**16-111150*r**18-41291*r**20+406*r**22+12*r**24)
            +Q2**2*(1729+281938*r**2-508934*r**4+8162544*r**6-15403505*r**8+17469818*r**10
            +511276*r**12+1100496*r**14+3252191*r**16+2176230*r**18+122138*r**20
            -66944*r**22+8593*r**24-370*r**26)-(-1+r**2)**2*(-131-32786*r**2+64842*r**4
            -2184152*r**6+9124843*r**8-26512914*r**10+33183372*r**12-12439488*r**14
            +40371*r**16-1567798*r**18-204310*r**20+10584*r**22-859*r**24+26*r**26)
            +2*Q2*(-416-87757*r**2+230081*r**4-4267466*r**6+16213550*r**8-36888763*r**10
            +34933539*r**12-5617212*r**14-768108*r**16-2954035*r**18-1614521*r**20
            -245882*r**22+32606*r**24-2501*r**26+85*r**28))*sqrtq2+logq2**4*(66355200*r**22*(1
            -Q2+r**2)*(-5+6*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+66355200*r**22*(
            -5+6*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**3*(2211840*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(40*Q2**7-2*Q2**6*(128+47*r**2)+Q2**5*(636
            +430*r**2-6*r**4)+Q2**4*(-680-623*r**2-132*r**4+115*r**6)+Q2**3*(80
            +177*r**2+115*r**4+163*r**6-235*r**8)+2*(-1+r**2)**2*(52+25*r**2-205*r**4
            +35*r**6-25*r**8+178*r**10)+Q2**2*(480+107*r**2-276*r**4-94*r**6+128*r**8
            +735*r**10)+Q2*(-404+161*r**2+765*r**4+430*r**6-770*r**8+249*r**10
            -911*r**12))-2211840*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(40*Q2**8
            -2*Q2**7*(148+67*r**2)+Q2**6*(892+780*r**2+88*r**4)+Q2**5*(-1316-1689*r**2
            -556*r**4+121*r**6)+10*Q2**4*(76+148*r**2+87*r**4+18*r**6-35*r**8)
            +2*Q2**3*(200-75*r**2-284*r**4-186*r**6+100*r**8+485*r**10)-2*(-1
            +r**2)**2*(52+77*r**2-180*r**4-170*r**6+10*r**8+153*r**10+178*r**12)
            -2*Q2**2*(442+213*r**2-467*r**4-400*r**6+402*r**8+307*r**10+823*r**12)
            +Q2*(508+85*r**2-1332*r**4-255*r**6-260*r**8+1047*r**10-100*r**12
            +1267*r**14))*sqrtq2)+logq2**2*(36864*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(768*Q2**10-10*Q2**9*(576+389*r**2)+5*Q2**8*(3312
            +4385*r**2+1338*r**4)-5*Q2**7*(3936+8723*r**2+4568*r**4+921*r**6)+10*Q2**6*(
            -216+2899*r**2+428*r**4+251*r**6+576*r**8)+Q2**5*(31104+13315*r**2
            +79020*r**4+31320*r**6-4580*r**8-15891*r**10)+10*Q2**4*(-2904-2581*r**2
            -11950*r**4-7044*r**6-616*r**8+971*r**10+1794*r**12)-5*Q2**3*(-288
            -3155*r**2-3232*r**4-5707*r**6-7608*r**8+647*r**10+1160*r**12+1383*r**14)
            +10*Q2**2*(1368-1841*r**2+11364*r**4-2079*r**6-2180*r**8-1287*r**10
            +10008*r**12+2959*r**14+48*r**16)+(-1+r**2)**2*(1728-1959*r**2+29084*r**4
            -17313*r**6-11790*r**8-70093*r**10+67344*r**12+13101*r**14+698*r**16)
            -5*Q2*(1728-3427*r**2+22436*r**4-21222*r**6-7372*r**8+1412*r**10-22068*r**12
            +29654*r**14+7292*r**16+207*r**18))+36864*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(768*Q2**10-10*Q2**9*(576+389*r**2)+5*Q2**8*(3312
            +4385*r**2+1338*r**4)-5*Q2**7*(3936+8723*r**2+4568*r**4+921*r**6)+10*Q2**6*(
            -216+2899*r**2+428*r**4+251*r**6+576*r**8)+Q2**5*(31104+13315*r**2
            +79020*r**4+31320*r**6-4580*r**8-15891*r**10)+10*Q2**4*(-2904-2581*r**2
            -11950*r**4-7044*r**6-616*r**8+971*r**10+1794*r**12)-5*Q2**3*(-288
            -3155*r**2-3232*r**4-5707*r**6-7608*r**8+647*r**10+1160*r**12+1383*r**14)
            +10*Q2**2*(1368-1841*r**2+11364*r**4-2079*r**6-2180*r**8-1287*r**10
            +10008*r**12+2959*r**14+48*r**16)+(-1+r**2)**2*(1728-1959*r**2+29084*r**4
            -17313*r**6-11790*r**8-70093*r**10+67344*r**12+13101*r**14+698*r**16)
            -5*Q2*(1728-3427*r**2+22436*r**4-21222*r**6-7372*r**8+1412*r**10-22068*r**12
            +29654*r**14+7292*r**16+207*r**18))*sqrtq2)+logq2*(3072*r**8*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**4*(184*Q2**13-18*Q2**12*(88+109*r**2)+2*Q2**11*(2618
            +7211*r**2+3949*r**4)-Q2**10*(7176+36695*r**2+39320*r**4+16673*r**6)
            +Q2**9*(-1100+22935*r**2-1207*r**4+41013*r**6+21275*r**8)+2*Q2**8*(8076
            +31905*r**2+164131*r**4+103845*r**6-8769*r**8-9324*r**10)+4*Q2**7*(
            -4398-32724*r**2-169441*r**4-205462*r**6-57982*r**8+5196*r**10+3291*r**12)
            +Q2**6*(-912+58926*r**2+246584*r**4+886630*r**6+276864*r**8+95278*r**10
            -13944*r**12-7506*r**14)+2*Q2**5*(8016+35085*r**2+382357*r**4-89117*r**6
            +278167*r**8+78993*r**10-182715*r**12-25353*r**14+1023*r**16)+2*Q2**4*(
            -5600-46005*r**2-487994*r**4-34084*r**6-609778*r**8-310978*r**10-38178*r**12
            +269896*r**14+38646*r**16+475*r**18)+2*Q2**3*(-318+12345*r**2+90409*r**4
            +49260*r**6+84456*r**8+373166*r**10+101510*r**12+99476*r**14-112570*r**16
            -13191*r**18-543*r**20)+2*(-1+r**2)**2*(172+1469*r**2+32709*r**4-72460*r**6
            +259566*r**8+76568*r**10-820300*r**12+417186*r**14+107030*r**16+41179*r**18
            +55*r**20+26*r**22)+Q2**2*(4376+16433*r**2+387744*r**4-686357*r**6
            +1872112*r**8-983186*r**10+406384*r**12+505066*r**14+522712*r**16+123713*r**18
            -9520*r**20+523*r**22)-Q2*(2124+12073*r**2+281627*r**4-810245*r**6
            +2300865*r**8-1752498*r**10-93046*r**12-1859094*r**14+1423770*r**16
            +651785*r**18+193499*r**20-5477*r**22+217*r**24))-3072*r**8*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*(184*Q2**14-2*Q2**13*(884+1073*r**2)+4*Q2**12*(1705
            +4492*r**2+2465*r**4)-Q2**11*(12412+56353*r**2+61640*r**4+24571*r**6)
            +Q2**10*(6076+66806*r**2+74808*r**4+97006*r**6+37948*r**8)+Q2**9*(17252
            +41975*r**2+306534*r**4+167884*r**6-79826*r**8-39923*r**10)+2*Q2**8*(
            -16872-105429*r**2-534918*r**4-678900*r**6-211040*r**8+28485*r**10
            +15906*r**12)+2*Q2**7*(8340+103707*r**2+527622*r**4+1193121*r**6+665320*r**8
            +153211*r**10-23946*r**12-10335*r**14)+4*Q2**6*(4236+3039*r**2+114801*r**4
            -327862*r**6-151790*r**8-53539*r**10-111691*r**12-7314*r**14+2388*r**16)
            -4*Q2**5*(6808+44553*r**2+452718*r**4+163662*r**6+399414*r**8+334069*r**10
            -32772*r**12-238982*r**14-31488*r**16+274*r**18)-4*Q2**4*(-2641-31975*r**2
            -312204*r**4-285669*r**6-364159*r**8-646961*r**10-225333*r**12+66121*r**14
            +210556*r**16+26156*r**18+509*r**20)+Q2**3*(5012-7621*r**2+182236*r**4
            -965695*r**6+1604680*r**8-1898430*r**10-542968*r**12+103094*r**14+548900*r**16
            +375235*r**18+17948*r**20+1609*r**22)-2*(-1+r**2)**2*(172+1641*r**2
            +34178*r**4-39751*r**6+187106*r**8+336134*r**10-743732*r**12-403114*r**14
            +524216*r**16+148209*r**18+41234*r**20+81*r**22+26*r**24)-2*Q2**2*(3250
            +16441*r**2+342902*r**4-554429*r**6+1743310*r**8-431786*r**10-334924*r**12
            -473822*r**14+1225774*r**16+649105*r**18+153846*r**20-7237*r**22+370*r**24)
            +Q2*(2468+16447*r**2+353586*r**4-801436*r**6+2365010*r**8-481681*r**10
            -3273284*r**12+2316568*r**14-3530608*r**16+2564165*r**18+894738*r**20
            +270212*r**22-5254*r**24+269*r**26))*sqrtq2))*math.log(mu0))/(1200*r**4*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+1200*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*sqrtq2+logq2**4*(24883200*r**20*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3+24883200*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**3*(-8294400*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-8294400*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2**2*(1036800*r**12*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+1036800*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)+logq2*(-57600*(-Q2+(-1+r)**2)**3*r**8*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3-57600*(-Q2+(-1+r)**2)**3*r**8*(1-Q2+r**2)*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2))+((4*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-131-4*Q2**10-13412*r**2+51045*r**4
            -323008*r**6+641774*r**8-644712*r**10+142382*r**12+53600*r**14+6453*r**16
            -404*r**18+13*r**20-7*Q2**9*(1+r**2)+3*Q2**8*(-47-102*r**2+41*r**4)
            +6*Q2**7*(145+1834*r**2+312*r**4-57*r**6)+6*Q2**6*(-249-6423*r**2-7092*r**4
            -623*r**6+63*r**8)+6*Q2**5*(80+4867*r**2+16621*r**4+6937*r**6+369*r**8
            -14*r**10)-2*Q2**4*(-576-23091*r**2+20622*r**4+10306*r**6-4110*r**8
            -891*r**10+84*r**12)+2*Q2**3*(-507-36702*r**2-13926*r**4-78457*r**6
            +14165*r**8-8712*r**10-1152*r**12+51*r**14)+6*Q2**2*(-25+1151*r**2
            +5374*r**4+19285*r**6-11218*r**8-10083*r**10-354*r**12-57*r**14+7*r**16)
            +Q2*(439+32373*r**2-73362*r**4+224402*r**6-163512*r**8+3216*r**10
            -62878*r**12-5058*r**14+1233*r**16-53*r**18))+4*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(-131+4*Q2**11-13543*r**2+37633*r**4-271963*r**6
            +318766*r**8-2938*r**10-502330*r**12+195982*r**14+60053*r**16+6049*r**18
            -391*r**20+13*r**22+3*Q2**10*(1+r**2)+Q2**9*(134+292*r**2-130*r**4)
            +3*Q2**8*(-337-3817*r**2-685*r**4+155*r**6)+12*Q2**7*(197+4201*r**2
            +4619*r**4+439*r**6-60*r**8)+6*Q2**6*(-329-11539*r**2-30136*r**4-14652*r**6
            -929*r**8+77*r**10)+4*Q2**5*(-168-4125*r**2+42543*r**4+40490*r**6+8904*r**8
            +87*r**10+21*r**12)-6*Q2**4*(-361-20123*r**2-5465*r**4-15843*r**6+6787*r**8
            -4571*r**10-653*r**12+45*r**14)+4*Q2**3*(-216-20331*r**2-33375*r**4
            -75119*r**6-15319*r**8+17851*r**10-4401*r**12-465*r**14+15*r**16)+Q2**2*(
            -589-25617*r**2+112512*r**4-76448*r**6+211914*r**8-131022*r**10+256*r**12
            +2592*r**14-1533*r**16+95*r**18)-6*Q2*(-95-7704*r**2+15339*r**4-79008*r**6
            +96814*r**8-80736*r**10+33674*r**12+20256*r**14+1713*r**16-264*r**18
            +11*r**20))*sqrtq2+logq2**3*(172800*(-Q2+(-1+r)**2)*r**16*(1-Q2+r**2)*(
            -5+3*r**2)*(-Q2+(1+r)**2)+172800*r**16*(-5+3*r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2)+logq2**2*(2880*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-104-40*Q2**5+179*r**2-466*r**4-106*r**6-26*r**8+163*r**10
            +4*Q2**4*(44+17*r**2)+Q2**3*(-244-141*r**2+23*r**4)+Q2**2*(16+167*r**2
            -122*r**4-17*r**6)+Q2*(196-213*r**2+11*r**4+143*r**6-197*r**8))+2880*(
            -Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(-104-40*Q2**5
            +179*r**2-466*r**4-106*r**6-26*r**8+163*r**10+4*Q2**4*(44+17*r**2)
            +Q2**3*(-244-141*r**2+23*r**4)+Q2**2*(16+167*r**2-122*r**4-17*r**6)
            +Q2*(196-213*r**2+11*r**4+143*r**6-197*r**8))*sqrtq2)+logq2*(-48*r**6*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(344+184*Q2**8+823*r**2
            +11917*r**4-8589*r**6-3175*r**8+50081*r**10-25973*r**12-3867*r**14
            +39*r**16-8*Q2**7*(129+149*r**2)+Q2**6*(1772+5475*r**2+2367*r**4)-2*Q2**5*(82
            +3119*r**2+3104*r**4+667*r**6)-Q2**4*(2520+3335*r**2+7961*r**4-535*r**6
            +895*r**8)+4*Q2**3*(524+2435*r**2+6626*r**4+1196*r**6-390*r**8+249*r**10)
            +Q2**2*(412-3923*r**2-7811*r**4-10226*r**6+15474*r**8+1297*r**10+97*r**12)
            -2*Q2*(546+675*r**2+9404*r**4-13055*r**6+10450*r**8-9071*r**10-2680*r**12
            +131*r**14))-48*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(344+184*Q2**8
            +823*r**2+11917*r**4-8589*r**6-3175*r**8+50081*r**10-25973*r**12-3867*r**14
            +39*r**16-8*Q2**7*(129+149*r**2)+Q2**6*(1772+5475*r**2+2367*r**4)-2*Q2**5*(82
            +3119*r**2+3104*r**4+667*r**6)-Q2**4*(2520+3335*r**2+7961*r**4-535*r**6
            +895*r**8)+4*Q2**3*(524+2435*r**2+6626*r**4+1196*r**6-390*r**8+249*r**10)
            +Q2**2*(412-3923*r**2-7811*r**4-10226*r**6+15474*r**8+1297*r**10+97*r**12)
            -2*Q2*(546+675*r**2+9404*r**4-13055*r**6+10450*r**8-9071*r**10-2680*r**12
            +131*r**14))*sqrtq2))*math.log(mus))/(-36*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3-36*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(-62208*r**14*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            +62208*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**2*(-15552*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -15552*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(1296*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+1296*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)))*math.log(r)+((16*r**6*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(-196*Q2**15+Q2**14*(245-211*r**2)+8*Q2**13*(-784
            -2512*r**2+1571*r**4)+Q2**12*(62279+931653*r**2+188553*r**4-68005*r**6)
            +4*Q2**11*(-53753-1433046*r**2-1654629*r**4-192888*r**6+44620*r**8)
            +Q2**10*(315413+13260229*r**2+30350514*r**4+17918514*r**6+1683601*r**8
            -265279*r**10)+4*Q2**9*(-13720-1882762*r**2-11761727*r**4-11773062*r**6
            -5715722*r**8-490780*r**10+53693*r**12)+Q2**8*(-453201-21511563*r**2
            +4286031*r**4-18451955*r**6+21963565*r**8+14480511*r**10+919797*r**12
            -62241*r**14)+4*Q2**7*(140973+10235796*r**2+14734014*r**4+45406184*r**6
            +21591200*r**8-4405348*r**10-1859346*r**12+50976*r**14-5025*r**16)-Q2**6*(86681
            +13778577*r**2+54965796*r**4+137004756*r**6+149779470*r**8-12828354*r**10
            -30093708*r**12-6083004*r**14-147279*r**16+22025*r**18)+16*Q2**5*(-20678
            -1779233*r**2+1496634*r**4-14308301*r**6+12528563*r**8-6287355*r**10
            +3769862*r**12+1643359*r**14+124629*r**16-68282*r**18+4186*r**20)+Q2**4*(253085
            +31111559*r**2-21935017*r**4+456332453*r**6-502652622*r**8+261124006*r**10
            +148222558*r**12-184318902*r**14-62722447*r**16-9280237*r**18+929675*r**20
            -40111*r**22)-4*Q2**3*(-637+1127454*r**2-418119*r**4+42917120*r**6-113483380*r**8
            +138879196*r**10-39057098*r**12+71925496*r**14-18456505*r**16-4665850*r**18
            -1016559*r**20+7944*r**22+938*r**24)+(-1+r**2)**2*(-6419-1099239*r**2
            +5202358*r**4-67083898*r**6+282298807*r**8-706935661*r**10+792399428*r**12
            -193255612*r**14-49284421*r**16-44586977*r**18-4621690*r**20+483766*r**22
            -32991*r**24+949*r**26)+Q2**2*(-84721-9491937*r**2+32461266*r**4-240143006*r**6
            +462861245*r**8-378884307*r**10-21249524*r**12-85327604*r**14-153317559*r**16
            -64809895*r**18+1778338*r**20+2777106*r**22-356757*r**24+14555*r**26)
            -4*Q2*(-10192-1470734*r**2+7170447*r**4-66711242*r**6+243454050*r**8
            -478089256*r**10+396416893*r**12-18715244*r**14+23613004*r**16-64608070*r**18
            -25776327*r**20-2396234*r**22+649122*r**24-49412*r**26+1595*r**28))
            -16*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(196*Q2**15+Q2**14*(-245
            +211*r**2)-8*Q2**13*(-784-2512*r**2+1571*r**4)+Q2**12*(-62279-931653*r**2
            -188553*r**4+68005*r**6)+Q2**11*(215012+5732184*r**2+6618516*r**4+771552*r**6
            -178480*r**8)+Q2**10*(-315413-13260229*r**2-30350514*r**4-17918514*r**6
            -1683601*r**8+265279*r**10)+4*Q2**9*(13720+1882762*r**2+11761727*r**4
            +11773062*r**6+5715722*r**8+490780*r**10-53693*r**12)+Q2**8*(453201
            +21511563*r**2-4286031*r**4+18451955*r**6-21963565*r**8-14480511*r**10
            -919797*r**12+62241*r**14)+4*Q2**7*(-140973-10235796*r**2-14734014*r**4
            -45406184*r**6-21591200*r**8+4405348*r**10+1859346*r**12-50976*r**14
            +5025*r**16)+Q2**6*(86681+13778577*r**2+54965796*r**4+137004756*r**6
            +149779470*r**8-12828354*r**10-30093708*r**12-6083004*r**14-147279*r**16
            +22025*r**18)-16*Q2**5*(-20678-1779233*r**2+1496634*r**4-14308301*r**6
            +12528563*r**8-6287355*r**10+3769862*r**12+1643359*r**14+124629*r**16
            -68282*r**18+4186*r**20)+Q2**4*(-253085-31111559*r**2+21935017*r**4
            -456332453*r**6+502652622*r**8-261124006*r**10-148222558*r**12+184318902*r**14
            +62722447*r**16+9280237*r**18-929675*r**20+40111*r**22)+4*Q2**3*(-637
            +1127454*r**2-418119*r**4+42917120*r**6-113483380*r**8+138879196*r**10
            -39057098*r**12+71925496*r**14-18456505*r**16-4665850*r**18-1016559*r**20
            +7944*r**22+938*r**24)+Q2**2*(84721+9491937*r**2-32461266*r**4+240143006*r**6
            -462861245*r**8+378884307*r**10+21249524*r**12+85327604*r**14+153317559*r**16
            +64809895*r**18-1778338*r**20-2777106*r**22+356757*r**24-14555*r**26)
            -(-1+r**2)**2*(-6419-1099239*r**2+5202358*r**4-67083898*r**6+282298807*r**8
            -706935661*r**10+792399428*r**12-193255612*r**14-49284421*r**16-44586977*r**18
            -4621690*r**20+483766*r**22-32991*r**24+949*r**26)+4*Q2*(-10192-1470734*r**2
            +7170447*r**4-66711242*r**6+243454050*r**8-478089256*r**10+396416893*r**12
            -18715244*r**14+23613004*r**16-64608070*r**18-25776327*r**20-2396234*r**22
            +649122*r**24-49412*r**26+1595*r**28))*sqrtq2+logq2**4*(-8294400*r**22*(1
            -Q2+r**2)*(-245+219*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-8294400*r**22*(
            -245+219*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**3*(
            -276480*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(460*Q2**7-2*Q2**6*(1472
            +203*r**2)+Q2**5*(7314+3770*r**2-2244*r**4)+Q2**4*(-7820-7727*r**2
            -1618*r**4+3385*r**6)+Q2**3*(920+1973*r**2+2785*r**4+7087*r**6-7765*r**8)
            +2*(-1+r**2)**2*(598+1875*r**2-9020*r**4-260*r**6+50*r**8+5197*r**10)
            +Q2**2*(5520+7543*r**2-14524*r**4-3006*r**6+4372*r**8+24015*r**10)
            +Q2*(-4646-6511*r**2+38385*r**4+28970*r**6-21580*r**8+5701*r**10-27839*r**12))
            +276480*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(460*Q2**8-2*Q2**7*(1702
            +433*r**2)+Q2**6*(10258+7120*r**2-1838*r**4)+Q2**5*(-15134-18811*r**2
            -3144*r**4+5629*r**6)+10*Q2**4*(874+1752*r**2+1213*r**4+532*r**6-1115*r**8)
            +2*Q2**3*(2300+2325*r**2-9641*r**4-6439*r**6+2525*r**8+15890*r**10)
            -2*(-1+r**2)**2*(598+2473*r**2-7145*r**4-9280*r**6-210*r**8+5247*r**10
            +5197*r**12)-2*Q2**2*(5083+9787*r**2-22683*r**4-23250*r**6+11473*r**8
            +11343*r**10+25927*r**12)+Q2*(5842+12515*r**2-56218*r**4-28045*r**6
            -24290*r**8+25553*r**10+1450*r**12+38233*r**14))*sqrtq2)+logq2**2*(-4608*r**12*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(18632*Q2**10-10*Q2**9*(13924
            +8561*r**2)+5*Q2**8*(80088+93265*r**2+23037*r**4)-5*Q2**7*(95364+184327*r**2
            +69282*r**4+3579*r**6)+10*Q2**6*(-5484+71951*r**2+15522*r**4-13451*r**6
            +7674*r**8)+Q2**5*(766596-119065*r**2+765480*r**4+234180*r**6-71920*r**8
            -432159*r**10)+10*Q2**4*(-72096-1469*r**2-133425*r**4-73256*r**6-10634*r**8
            +19779*r**10+52281*r**12)-5*Q2**3*(-7812-38695*r**2-21018*r**4-73693*r**6
            -253892*r**8-14997*r**10+39490*r**12+34617*r**14)-10*Q2**2*(-34032+71509*r**2
            -210936*r**4+24021*r**6+84670*r**8+44763*r**10-332592*r**12-111341*r**14
            +5298*r**16)+(-1+r**2)**2*(43672-113991*r**2+610991*r**4-420587*r**6
            -503085*r**8-2347057*r**10+2007481*r**12+435699*r**14+6077*r**16)+5*Q2*(
            -43372+135623*r**2-490464*r**4+408778*r**6+542528*r**8+54912*r**10
            +770032*r**12-895546*r**14-262308*r**16+4457*r**18))-4608*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(18632*Q2**10-10*Q2**9*(13924+8561*r**2)
            +5*Q2**8*(80088+93265*r**2+23037*r**4)-5*Q2**7*(95364+184327*r**2+69282*r**4
            +3579*r**6)+10*Q2**6*(-5484+71951*r**2+15522*r**4-13451*r**6+7674*r**8)
            +Q2**5*(766596-119065*r**2+765480*r**4+234180*r**6-71920*r**8-432159*r**10)
            +10*Q2**4*(-72096-1469*r**2-133425*r**4-73256*r**6-10634*r**8+19779*r**10
            +52281*r**12)-5*Q2**3*(-7812-38695*r**2-21018*r**4-73693*r**6-253892*r**8
            -14997*r**10+39490*r**12+34617*r**14)-10*Q2**2*(-34032+71509*r**2-210936*r**4
            +24021*r**6+84670*r**8+44763*r**10-332592*r**12-111341*r**14+5298*r**16)
            +(-1+r**2)**2*(43672-113991*r**2+610991*r**4-420587*r**6-503085*r**8
            -2347057*r**10+2007481*r**12+435699*r**14+6077*r**16)+5*Q2*(-43372
            +135623*r**2-490464*r**4+408778*r**6+542528*r**8+54912*r**10+770032*r**12
            -895546*r**14-262308*r**16+4457*r**18))*sqrtq2)+logq2*(-384*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(6716*Q2**13-2*Q2**12*(28908+34469*r**2)
            +2*Q2**11*(95557+251289*r**2+134226*r**4)-Q2**10*(261924+1296855*r**2
            +1383530*r**4+529127*r**6)+Q2**9*(-40150+998315*r**2+898407*r**4+1563937*r**6
            +564475*r**8)+Q2**8*(589548+1562190*r**2+6710288*r**4+3234560*r**6-879412*r**8
            -313902*r**10)+4*Q2**7*(-160527-917076*r**2-3736459*r**4-3848838*r**6
            -514693*r**8+228104*r**10+26409*r**12)-2*Q2**6*(16644-962787*r**2-2622358*r**4
            -8931435*r**6-593868*r**8+630489*r**10+280778*r**12+50097*r**14)+2*Q2**5*(292584
            +712965*r**2+8400793*r**4-4846833*r**6+2822383*r**8+2401657*r**10-4411235*r**12
            -826997*r**14+54027*r**16)-2*Q2**4*(204400+1075245*r**2+10270856*r**4
            -4157984*r**6+5171672*r**8+4416222*r**10+2452272*r**12-7558504*r**14
            -1285504*r**16+17725*r**18)-2*Q2**3*(11607-372155*r**2-1423816*r**4
            +122260*r**6+1359806*r**8-9815434*r**10-3887240*r**12-4191924*r**14
            +3048555*r**16+376709*r**18+11632*r**20)+2*(-1+r**2)**2*(6278+24531*r**2
            +724616*r**4-2028915*r**6+4050484*r**8+6750882*r**10-25984800*r**12
            +9803614*r**14+4522470*r**16+1033771*r**18-27080*r**20+949*r**22)+Q2**2*(159724
            +147417*r**2+9146606*r**4-19924943*r**6+36787688*r**8-20464114*r**10
            +7530916*r**12+19582334*r**14+20876588*r**16+2899737*r**18-608530*r**20
            +26577*r**22)-Q2*(77526+145677*r**2+6410273*r**4-21717505*r**6+45849385*r**8
            -25795802*r**10-16641954*r**12-61854206*r**14+32699980*r**16+27253965*r**18
            +4982401*r**20-406273*r**22+10933*r**24))+384*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(6716*Q2**14-2*Q2**13*(32266+37827*r**2)+Q2**12*(248930
            +629332*r**2+337390*r**4)-Q2**11*(453038+1990547*r**2+2154560*r**4+797579*r**6)
            +2*Q2**10*(110887+1278547*r**2+1789396*r**4+1738297*r**6+546801*r**8)
            +Q2**9*(629698+604025*r**2+4813566*r**4+772216*r**6-3007824*r**8-878377*r**10)
            +2*Q2**8*(-615828-2910021*r**2-11609157*r**4-12670100*r**6-2206960*r**8
            +1052865*r**10+209769*r**12)+2*Q2**7*(304410+3117993*r**2+11929428*r**4
            +24102029*r**6+9320930*r**8-57311*r**10-789804*r**12-102915*r**14)+4*Q2**6*(154614
            -116589*r**2+2407824*r**4-8200313*r**6-3351460*r**8+1219139*r**10-1749984*r**12
            -248061*r**14+52062*r**16)-4*Q2**5*(248492+1040397*r**2+9692307*r**4
            -302012*r**6+1573611*r**8+4820131*r**10+221347*r**12-6398368*r**14-1029237*r**16
            +35876*r**18)+2*Q2**4*(192793+1651800*r**2+12769917*r**4+5990612*r**6
            -346118*r**8+19403328*r**10+10755734*r**12-914308*r**14-11892563*r**16
            -1644488*r**18+6093*r**20)+Q2**3*(182938-573679*r**2+5554664*r**4-22528055*r**6
            +39751820*r**8-37375370*r**10-19874432*r**12+3424006*r**14+18589850*r**16
            +9750265*r**18+168152*r**20+49841*r**22)-2*(-1+r**2)**2*(6278+30809*r**2
            +749147*r**4-1304299*r**6+2021569*r**8+10801366*r**10-19233918*r**12
            -16181186*r**14+14326084*r**16+5556241*r**18+1006691*r**20-26131*r**22
            +949*r**24)-2*Q2**2*(118625+226409*r**2+7852148*r**4-16247921*r**6+31356065*r**8
            -4736114*r**10-14787576*r**12-17370478*r**14+36579451*r**16+25515145*r**18
            +3636804*r**20-494113*r**22+18755*r**24)+Q2*(90082+247153*r**2+7919614*r**4
            -22214464*r**6+41797740*r**8+13295581*r**10-113309916*r**12+58552032*r**14
            -111293342*r**16+63538835*r**18+37092062*r**20+6753888*r**22-453296*r**24
            +12831*r**26))*sqrtq2))*math.log(r)**2)/(7200*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4+7200*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2+logq2**4*(149299200*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+149299200*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**3*(-49766400*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-49766400*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)+logq2**2*(6220800*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+6220800*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+logq2*(
            -345600*(-Q2+(-1+r)**2)**3*r**8*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3-345600*(-Q2+(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2))+nlo.X1Q2_Derivativer(2,Q2,r)*((4*r)/(-36*logq2*r**4
            +3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)
            -(2*muWC**2*r)/(-36*logq2*r**4+3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2)-(16*muWC*r)/(-108*logq2*r**4+9*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(2*r*math.log(mu0))/(
            -12*logq2*r**4+(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)-(2*r*math.log(r))/(-12*logq2*r**4+(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+nlo.X1Q2_Derivativer(0,Q2,r)*((muWC*(
            -28800*logq2**2*r**9*(15+22*r**2+15*r**4)-8*(-Q2+(-1+r)**2)*r*(-Q2
            +(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4+19308*r**6+138690*r**8
            +19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1+r**2)+Q2**6*(
            -89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4+79*r**6)+Q2**4*(165
            -1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4
            -2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2+1787*r**4-14228*r**6
            +1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2-2957*r**4+19165*r**6
            +19165*r**8-2957*r**10-635*r**12+27*r**14))-4800*logq2*r**5*(1+2*Q2**5
            +35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17
            +42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2
            +66*r**4+30*r**6-11*r**8))*sqrtq2))/(-1166400*logq2**3*r**12-24300*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+291600*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+675*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*sqrtq2)+(muWC**2*(-3600*logq2**2*r**9*(15+22*r**2+15*r**4)-(
            -Q2+(-1+r)**2)*r*(-Q2+(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4
            +19308*r**6+138690*r**8+19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1
            +r**2)+Q2**6*(-89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4
            +79*r**6)+Q2**4*(165-1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19
            -280*r**2-2439*r**4-2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2
            +1787*r**4-14228*r**6+1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2
            -2957*r**4+19165*r**6+19165*r**8-2957*r**10-635*r**12+27*r**14))-600*logq2*r**5*(1
            +2*Q2**5+35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)
            +Q2**3*(17+42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(
            -11+30*r**2+66*r**4+30*r**6-11*r**8))*sqrtq2))/(-388800*logq2**3*r**12
            -8100*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+97200*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+225*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(7200*logq2**2*r**9*(15+22*r**2+15*r**4)
            +2*(-Q2+(-1+r)**2)*r*(-Q2+(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4
            +19308*r**6+138690*r**8+19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1
            +r**2)+Q2**6*(-89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4
            +79*r**6)+Q2**4*(165-1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19
            -280*r**2-2439*r**4-2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2
            +1787*r**4-14228*r**6+1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2
            -2957*r**4+19165*r**6+19165*r**8-2957*r**10-635*r**12+27*r**14))+1200*logq2*r**5*(1
            +2*Q2**5+35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)
            +Q2**3*(17+42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(
            -11+30*r**2+66*r**4+30*r**6-11*r**8))*sqrtq2)/(-388800*logq2**3*r**12
            -8100*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+97200*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+225*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((3600*logq2**2*r**9*(15+22*r**2+15*r**4)
            +(-Q2+(-1+r)**2)*r*(-Q2+(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4
            +19308*r**6+138690*r**8+19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1
            +r**2)+Q2**6*(-89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4
            +79*r**6)+Q2**4*(165-1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19
            -280*r**2-2439*r**4-2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2
            +1787*r**4-14228*r**6+1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2
            -2957*r**4+19165*r**6+19165*r**8-2957*r**10-635*r**12+27*r**14))+600*logq2*r**5*(1
            +2*Q2**5+35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)
            +Q2**3*(17+42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(
            -11+30*r**2+66*r**4+30*r**6-11*r**8))*sqrtq2)*math.log(mu0))/(-129600*logq2**3*r**12
            -2700*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+32400*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+75*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((-3600*logq2**2*r**9*(15+22*r**2+15*r**4)
            -(-Q2+(-1+r)**2)*r*(-Q2+(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4
            +19308*r**6+138690*r**8+19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1
            +r**2)+Q2**6*(-89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4
            +79*r**6)+Q2**4*(165-1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19
            -280*r**2-2439*r**4-2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2
            +1787*r**4-14228*r**6+1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2
            -2957*r**4+19165*r**6+19165*r**8-2957*r**10-635*r**12+27*r**14))-600*logq2*r**5*(1
            +2*Q2**5+35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)
            +Q2**3*(17+42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(
            -11+30*r**2+66*r**4+30*r**6-11*r**8))*sqrtq2)*math.log(r))/(-129600*logq2**3*r**12
            -2700*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+32400*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+75*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2))+nlo.X1Q2_Derivativer(1,Q2,r)*((720*logq2*r**5*(1
            +r**2)-4*r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)/(2160*logq2**2*r**8
            +15*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-360*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(muWC**2*(-360*logq2*r**5*(1
            +r**2)+2*r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(2160*logq2**2*r**8
            +15*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-360*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(muWC*(-2880*logq2*r**5*(1
            +r**2)+16*r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(6480*logq2**2*r**8
            +45*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-1080*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((360*logq2*r**5*(1+r**2)
            -2*r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2
            -11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*math.log(mu0))/(720*logq2**2*r**8
            +5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((-360*logq2*r**5*(1+r**2)
            +2*r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2
            -11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*math.log(r))/(720*logq2**2*r**8
            +5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+flagPERP*muWC**3*((pi2*(
            -5760*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(1-11*r**2+10*Q2**5*r**2
            +50*r**4+30*r**6+125*r**8-41*r**10+26*r**12-4*Q2**4*(1+8*r**2+11*r**4)
            +Q2**3*(6+49*r**2+89*r**4+61*r**6)-Q2**2*(-1+23*r**2+56*r**4+108*r**6
            +4*r**8)+Q2*(-4+12*r**2-33*r**4+27*r**6+77*r**8-49*r**10))-8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**9*r**2+Q2**8*(-22+89*r**2+23*r**4)
            -Q2**7*(-101+398*r**2+2817*r**4+196*r**6)+Q2**6*(-156+3*r**2+11687*r**4
            +9911*r**6+335*r**8)-Q2**5*(-47-904*r**2+10040*r**4+31544*r**6+7963*r**8
            +64*r**10)+Q2**4*(110+333*r**2-8167*r**4+8892*r**6+20686*r**8-10725*r**10
            -337*r**12)+Q2**3*(-93-2074*r**2+14295*r**4+18820*r**6+48901*r**8+4158*r**10
            +17921*r**12+272*r**14)+Q2**2*(-16+753*r**2-1695*r**4-6029*r**6-69053*r**8
            -42197*r**10-13221*r**12-1783*r**14+41*r**16)+Q2*(41+857*r**2-7214*r**4
            +9536*r**6-43980*r**8+110834*r**10-62202*r**12+21784*r**14-7941*r**16
            -115*r**18)+2*(-6-237*r**2+1964*r**4-9815*r**6-8509*r**8+86159*r**10
            -86693*r**12+43631*r**14-6565*r**16+1654*r**18+17*r**20))-172800*logq2**3*r**10*(1
            -2*r**2+3*r**4)*sqrtq2+48*logq2*r**2*(-5*(-1+Q2)**7*(7+15*Q2+8*Q2**2)
            -2*(-1+Q2)**5*(-121-75*Q2+30*Q2**2-150*Q2**3-180*Q2**4+46*Q2**5)*r**2
            +5*(-1+Q2)**3*(-77-113*Q2-324*Q2**2+602*Q2**3+33*Q2**4-621*Q2**5
            +140*Q2**6)*r**4-10*(-1166+2308*Q2-1238*Q2**2+2368*Q2**3-5001*Q2**4
            +2788*Q2**5+900*Q2**6-1160*Q2**7+201*Q2**8)*r**6+10*(-5855+4862*Q2
            -2830*Q2**2-5510*Q2**3+8466*Q2**4-2557*Q2**5-893*Q2**6+237*Q2**7)*r**8
            +10*(8718+2928*Q2+108*Q2**2-8184*Q2**3+4717*Q2**4-456*Q2**5+21*Q2**6)*r**10
            -2*(21593-20570*Q2-23820*Q2**2+7000*Q2**3-5890*Q2**4+1743*Q2**5)*r**12
            +10*(-656-3356*Q2-2430*Q2**2-632*Q2**3+315*Q2**4)*r**14-5*(-3063
            -4486*Q2-90*Q2**2+18*Q2**3)*r**16-10*(585-38*Q2+147*Q2**2)*r**18+5*(
            -3+178*Q2)*r**20-172*r**22)*sqrtq2))/(291600*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+675*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-1166400*logq2**3*r**12*sqrtq2
            -24300*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(69120*logq2**3*(
            -Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)*(1660*Q2**7*r**2-8*Q2**6*(51+1079*r**2
            +1760*r**4)+Q2**5*(-107+24880*r**2+43857*r**4+43290*r**6)-Q2**4*(-3075
            +32459*r**2+62891*r**4+84745*r**6+54140*r**8)+Q2**3*(-3070+20556*r**2
            +20960*r**4+79964*r**6+78990*r**8+4280*r**10)+(-1+r**2)**2*(-1433+8405*r**2
            -2570*r**4+23790*r**6+61495*r**8-18067*r**10+14300*r**12)+2*Q2**2*(
            -1025+608*r**2+846*r**4+5044*r**6+18147*r**8-37020*r**10+27720*r**12)
            -Q2*(-3993+18492*r**2-1235*r**4+34790*r**6+172625*r**8+163488*r**10
            -91237*r**12+50750*r**14))-96*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(19412*Q2**13*r**2-8*Q2**12*(-895+24054*r**2+21481*r**4)+Q2**11*(
            -43855+664748*r**2+1468341*r**4+586702*r**6)-Q2**10*(-92185+939713*r**2
            +4174833*r**4+4086163*r**6+874636*r**8)+Q2**9*(-31325+28470*r**2+4312742*r**4
            +7018612*r**6+4565919*r**8+133230*r**10)+Q2**8*(-174525+1605561*r**2
            +1611646*r**4+2062670*r**6+208747*r**8+215369*r**10+1377636*r**12)-2*Q2**7*(
            -131565+898668*r**2+3649907*r**4+7727818*r**6+9699619*r**8+4359596*r**10
            +2673131*r**12+840042*r**14)+Q2**6*(-37590-43506*r**2+4995742*r**4+9794786*r**6
            +30245074*r**8+24649310*r**10+5641134*r**12+5268962*r**14+89256*r**16)
            +2*Q2**5*(-110085+811728*r**2+442982*r**4+1067020*r**6-10025802*r**8
            -39189880*r**10-18589602*r**12-4329148*r**14-1481525*r**16+641976*r**18)
            +2*Q2**4*(93975-593635*r**2-1433006*r**4+1962054*r**6+2018770*r**8+61896478*r**10
            +80438578*r**12+25816134*r**14+9807139*r**16+656953*r**18-465040*r**20)
            -Q2**3*(4475+146148*r**2-2170809*r**4+6654090*r**6-5910702*r**8+92157096*r**10
            +172305994*r**12+122636764*r**14+19008115*r**16+11057012*r**18-915281*r**20
            +35098*r**22)+(-1+r**2)**2*(-6265+54427*r**2-164707*r**4-3556563*r**6
            +28652710*r**8-53523302*r**10-54173898*r**12+83936758*r**14-59460977*r**16
            -396725*r**18-2967123*r**20-282019*r**22+25284*r**24)+Q2**2*(-68915
            +655843*r**2-1750133*r**4-6092279*r**6+29749122*r**8-13944222*r**10
            -34040622*r**12+160005606*r**14-53712051*r**16-9804037*r**18-7126813*r**20
            -2346031*r**22+336932*r**24)+Q2*(36695-358042*r**2+1097222*r**4+9939972*r**6
            -69992755*r**8+97788610*r**10+36315924*r**12+231152856*r**14-206274239*r**16
            +138964330*r**18-1538330*r**20+8959268*r**22+1518747*r**24-160658*r**26))
            +4147200*logq2**4*r**16*(115-294*r**2+537*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2+1152*logq2**2*r**8*(-25752*Q2**12*r**2+8*Q2**11*(1150+25803*r**2
            +27173*r**4)-Q2**10*(59475+784522*r**2+1251711*r**4+774512*r**6)+10*Q2**9*(14755
            +165789*r**2+322145*r**4+303529*r**6+148138*r**8)-5*Q2**8*(29055+372898*r**2
            +881170*r**4+1293138*r**6+830627*r**8+315480*r**10)+2*Q2**7*(-24300
            +378767*r**2+1714690*r**4+5946920*r**6+7042430*r**8+2752285*r**10+416112*r**12)
            -2*Q2**6*(-126525-274451*r**2+1178894*r**4+9952330*r**6+18318555*r**8
            +15128465*r**10+4646324*r**12+41664*r**14)+Q2**5*(-216300-957086*r**2
            +2664112*r**4+22033714*r**6+48388420*r**8+60920430*r**10+35044704*r**12
            +10813022*r**14-155016*r**16)+10*Q2**4*(1845+103531*r**2-331705*r**4
            -1326763*r**6-2431157*r**8-4246783*r**10-4860551*r**12-943085*r**14
            -432304*r**16+31932*r**18)+(-1+r**2)**4*(-1975+45408*r**2-318594*r**4
            -215216*r**6+5084832*r**8+786360*r**10+9202*r**12+1821504*r**14+484551*r**16
            +36728*r**18)-10*Q2**3*(-8940+116531*r**2-421730*r**4-392750*r**6+523478*r**8
            +1395748*r**10+1413598*r**12-2745370*r**14+1737526*r**16+388849*r**18
            +55140*r**20)-2*Q2*(-1+r**2)**2*(-9375+154688*r**2-867876*r**4-351300*r**6
            +7459576*r**8+11085492*r**10+8944182*r**12-1675004*r**14+4744695*r**16
            +1338444*r**18+107678*r**20)+Q2**2*(-64775+884668*r**2-4278405*r**4
            +1260920*r**6+18060810*r**8+16347920*r**10+49026854*r**12+47885880*r**14
            -27353395*r**16+16200340*r**18+5258255*r**20+495728*r**22))*sqrtq2-16*r**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1253*Q2**14*r**2+2*Q2**13*(-1617+6086*r**2
            +883*r**4)-Q2**12*(-24549+108939*r**2+664697*r**4+57473*r**6)+Q2**11*(
            -73941+203862*r**2+4600452*r**4+4200574*r**6+224373*r**8)-Q2**10*(-98931
            -145346*r**2+11186610*r**4+22835626*r**6+10142125*r**8+361044*r**10)
            +Q2**9*(-11025-702966*r**2+8480223*r**4+40254612*r**6+41567557*r**8
            +7832730*r**10+142789*r**12)+2*Q2**8*(-71001+1788*r**2+5195978*r**4
            -8530762*r**6-16930195*r**8-13452724*r**10+4926798*r**12+176934*r**14)
            -2*Q2**7*(-84231-827214*r**2+12299764*r**4+10648386*r**6+18342872*r**8
            +6876154*r**10+2509868*r**12+11503098*r**14+250647*r**16)+Q2**6*(-25578
            -1329159*r**2+11696644*r**4+21756132*r**6+49620284*r**8+81782434*r**10
            +5673556*r**12+23399124*r**14+9667302*r**16+77229*r**18)+4*Q2**5*(-23373
            -275048*r**2+3434167*r**4-4488902*r**6+5135465*r**8-23445460*r**10-32165355*r**12
            +7659122*r**14-13272152*r**16+3081480*r**18+78952*r**20)+Q2**4*(69825
            +2027213*r**2-20293273*r**4+35645823*r**6-53822722*r**8+78470406*r**10
            +289227210*r**12+226241234*r**14-27464527*r**16+69585533*r**18-14119105*r**20
            -246017*r**22)+Q2**3*(1911-629298*r**2+5615628*r**4-18880426*r**6+24092795*r**8
            -34977788*r**10-330837624*r**12-295844684*r**14-136394619*r**16-4967890*r**18
            -18625428*r**20+2049782*r**22+2441*r**24)+2*(-1+r**2)**2*(-882-43641*r**2
            +579971*r**4-4322690*r**6+8198969*r**8+41160165*r**10-176378190*r**12
            +147460068*r**14-32944788*r**16-34018479*r**18+7283307*r**20-3567554*r**22
            +193901*r**24+3043*r**26)+Q2**2*(-23961-498864*r**2+6528550*r**4-27865890*r**6
            +31494489*r**8+14566802*r**10-6054556*r**12+136864932*r**14+99976553*r**16
            -133371604*r**18+66510774*r**20-37382210*r**22+3832343*r**24+78642*r**26)
            +Q2*(11319+405322*r**2-5640521*r**4+35148724*r**6-67879017*r**8-101921978*r**10
            +268104151*r**12+408757432*r**14-392679923*r**16+37795894*r**18+239904909*r**20
            -81296748*r**22+32721189*r**24-2217926*r**26-38427*r**28))*sqrtq2)/(55987200*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +388800*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3-167961600*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            -6998400*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2*sqrtq2-8100*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+((1105920*logq2**3*(-Q2+(-1+r)**2)*r**12*(
            -Q2+(1+r)**2)*(-40*Q2**7*r**2+4*Q2**6*(6+52*r**2+37*r**4)-Q2**5*(109
            +472*r**2+591*r**4+108*r**6)+Q2**4*(165+497*r**2+869*r**4+379*r**6
            -130*r**8)-2*Q2**3*(25+129*r**2+187*r**4+46*r**6-72*r**8+25*r**10)
            +(-1+r**2)**2*(-31+157*r**2-310*r**4+330*r**6+245*r**8-119*r**10+208*r**12)
            +2*Q2**2*(-55+166*r**2-240*r**4+29*r**6+48*r**8-183*r**10+315*r**12)
            -Q2*(-111+486*r**2-1063*r**4+490*r**6+1375*r**8+846*r**10-761*r**12
            +658*r**14))+1536*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -184*Q2**13*r**2+4*Q2**12*(-10+456*r**2+433*r**4)-Q2**11*(-245+6496*r**2
            +15057*r**4+6308*r**6)+Q2**10*(-515+9985*r**2+41625*r**4+41987*r**6
            +10850*r**8)-Q2**9*(-175+3600*r**2+29806*r**4+14726*r**6+40497*r**8
            +6690*r**10)-Q2**8*(-975+7677*r**2+57668*r**4+347020*r**6+275051*r**8
            +20167*r**10+5952*r**12)+2*Q2**7*(-735+3516*r**2+58048*r**4+394604*r**6
            +628787*r**8+278368*r**10+33220*r**12+6048*r**14)-2*Q2**6*(-105-1401*r**2
            +28864*r**4+231932*r**6+716071*r**8+662585*r**10+173784*r**12+20684*r**14
            +2442*r**16)-2*Q2**5*(-615+1920*r**2+3397*r**4+181208*r**6+107031*r**8
            -138170*r**10-204945*r**12-41408*r**14-7972*r**16+1650*r**18)+2*Q2**4*(
            -525-1225*r**2-467*r**4+259743*r**6+678115*r**8+683851*r**10+202441*r**12
            -60867*r**14-91922*r**16-10814*r**18+1670*r**20)+Q2**3*(25+3336*r**2
            +4353*r**4-116700*r**6-764946*r**8-438432*r**10-610162*r**12+6632*r**14
            +229145*r**16+98296*r**18+4817*r**20-364*r**22)+(-1+r**2)**2*(35+325*r**2
            +5069*r**4+15147*r**6-173030*r**8+1062838*r**10-899034*r**12-567734*r**14
            +919363*r**16-96635*r**18+74637*r**20+4619*r**22)+Q2**2*(385-131*r**2
            +16807*r**4-53843*r**6-113856*r**8+136566*r**10-653310*r**12-972954*r**14
            +1370973*r**16-318259*r**18+220439*r**20+22061*r**22-478*r**24)+Q2*(
            -205-856*r**2-17080*r**4+8862*r**6+414155*r**8-1940210*r**10+1759392*r**12
            -1665420*r**14+2380321*r**16-2541380*r**18+476440*r**20-237586*r**22
            -18975*r**24+142*r**26))+66355200*logq2**4*r**16*(-1+3*r**4)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+18432*logq2**2*r**8*(-768*Q2**12*r**2
            +8*Q2**11*(-10+912*r**2+817*r**4)-Q2**10*(-645+28568*r**2+49089*r**4
            +23248*r**6)+10*Q2**9*(-205+5847*r**2+14353*r**4+13073*r**6+4418*r**8)
            -5*Q2**8*(-585+12434*r**2+38240*r**4+48762*r**6+34405*r**8+9528*r**10)
            +8*Q2**7*(-75+2347*r**2+7895*r**4+9205*r**6+16420*r**8+14870*r**10
            +3747*r**12)+Q2**6*(-3990+33608*r**2+142648*r**4+327140*r**6+276810*r**8
            +22420*r**10-64052*r**12-14952*r**14)+4*Q2**5*(1365-11251*r**2-48883*r**4
            -110476*r**6-115495*r**8-60345*r**10-3051*r**12+15412*r**14+2124*r**16)
            +10*Q2**4*(-195+2018*r**2+8317*r**4+22378*r**6+7775*r**8-242*r**10
            +2003*r**12+10802*r**14-4028*r**16+612*r**18)+(-1+r**2)**4*(145-198*r**2
            -4416*r**4+36566*r**6-21762*r**8+870*r**10-10912*r**12+38106*r**14
            +3249*r**16+1552*r**18)-40*Q2**3*(45-83*r**2-550*r**4+3797*r**6-5045*r**8
            -3442*r**10+632*r**12-1679*r**14+8666*r**16-25*r**18+564*r**20)-2*Q2*(
            -1+r**2)**2*(465-1193*r**2-11484*r**4+74190*r**6-36376*r**8+17748*r**10
            +47898*r**12-26086*r**14+96615*r**16+6381*r**18+4642*r**20)+Q2**2*(2225
            -8608*r**2-39735*r**4+245020*r**6-296790*r**8+196660*r**10+244066*r**12
            +295260*r**14-339995*r**16+368540*r**18+2965*r**20+21592*r**22))*sqrtq2
            -256*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**14+Q2**13*(68
            +46*r**2)-Q2**12*(717+6352*r**2+643*r**4)+4*Q2**11*(396+11268*r**2
            +10829*r**4+624*r**6)-2*Q2**10*(58+56589*r**2+119149*r**4+56161*r**6
            +2343*r**8)+8*Q2**9*(-108+11073*r**2+47052*r**4+49657*r**6+13950*r**8
            +517*r**10)-2*Q2**8*(4593-51766*r**2-53644*r**4-172420*r**6+38069*r**8
            -18162*r**10+66*r**12)-4*Q2**7*(-5736+59893*r**2+194922*r**4+677168*r**6
            +543520*r**8+90437*r**10+41634*r**12+726*r**14)+Q2**6*(-13473+107480*r**2
            +561048*r**4+2817388*r**6+4727966*r**8+2103752*r**10+254520*r**12+102468*r**14
            +1683*r**16)+2*Q2**5*(-6974+47965*r**2-13292*r**4+433982*r**6-711268*r**8
            -1106496*r**10-194620*r**12-70622*r**14+11562*r**16+451*r**18)+Q2**4*(21607
            -110684*r**2+105489*r**4-2865356*r**6-2478042*r**8-1628916*r**10+362842*r**12
            +188764*r**14+348739*r**16-39200*r**18-1243*r**20)+4*Q2**3*(-1308+2193*r**2
            -31247*r**4+295690*r**6+368708*r**8+221166*r**10+196538*r**12-111708*r**14
            -70520*r**16-50223*r**18+1477*r**20+34*r**22)+2*(-1+r**2)**2*(-468
            +1288*r**2-34435*r**4+43936*r**6+292209*r**8-2571552*r**10+4429614*r**12
            -2779872*r**14+519474*r**16-130824*r**18-27595*r**20-992*r**22+17*r**24)
            +2*Q2**2*(-3201+19537*r**2-102987*r**4+272991*r**6-245380*r**8+997286*r**10
            +471654*r**12-1300294*r**14+658859*r**16-247575*r**18-87995*r**20-1081*r**22
            +186*r**24)-4*Q2*(-1166+5788*r**2-64394*r**4+175131*r**6+1990*r**8
            -1021853*r**10-167156*r**12+2846098*r**14-2779082*r**16+685710*r**18
            -147906*r**20-50157*r**22-1454*r**24+51*r**26))*sqrtq2)*math.log(mu0))/(18662400*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +129600*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3-55987200*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            -2332800*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2*sqrtq2-2700*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+((5760*logq2**2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(1-11*r**2+10*Q2**5*r**2+50*r**4+30*r**6+125*r**8-41*r**10
            +26*r**12-4*Q2**4*(1+8*r**2+11*r**4)+Q2**3*(6+49*r**2+89*r**4+61*r**6)
            -Q2**2*(-1+23*r**2+56*r**4+108*r**6+4*r**8)+Q2*(-4+12*r**2-33*r**4
            +27*r**6+77*r**8-49*r**10))+8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**9*r**2
            +Q2**8*(-22+89*r**2+23*r**4)-Q2**7*(-101+398*r**2+2817*r**4+196*r**6)
            +Q2**6*(-156+3*r**2+11687*r**4+9911*r**6+335*r**8)-Q2**5*(-47-904*r**2
            +10040*r**4+31544*r**6+7963*r**8+64*r**10)+Q2**4*(110+333*r**2-8167*r**4
            +8892*r**6+20686*r**8-10725*r**10-337*r**12)+Q2**3*(-93-2074*r**2+14295*r**4
            +18820*r**6+48901*r**8+4158*r**10+17921*r**12+272*r**14)+Q2**2*(-16
            +753*r**2-1695*r**4-6029*r**6-69053*r**8-42197*r**10-13221*r**12-1783*r**14
            +41*r**16)+Q2*(41+857*r**2-7214*r**4+9536*r**6-43980*r**8+110834*r**10
            -62202*r**12+21784*r**14-7941*r**16-115*r**18)+2*(-6-237*r**2+1964*r**4
            -9815*r**6-8509*r**8+86159*r**10-86693*r**12+43631*r**14-6565*r**16
            +1654*r**18+17*r**20))+172800*logq2**3*r**10*(1-2*r**2+3*r**4)*sqrtq2
            +48*logq2*r**2*(92*Q2**10*r**2-20*Q2**9*(-2+41*r**2+35*r**4)+5*Q2**8*(
            -41+484*r**2+1041*r**4+402*r**6)-10*Q2**7*(-35+296*r**2+1158*r**4
            +1160*r**6+237*r**8)-10*Q2**6*(7-61*r**2-750*r**4-900*r**6-893*r**8
            +21*r**10)+Q2**5*(-490+2216*r**2+7050*r**4+27880*r**6+25570*r**8+4560*r**10
            +3486*r**12)-10*Q2**4*(-56+203*r**2+1316*r**4+5001*r**6+8466*r**8+4717*r**10
            +1178*r**12+315*r**14)+10*Q2**3*(-7-32*r**2+656*r**4+2368*r**6+5510*r**8
            +8184*r**10+1400*r**12+632*r**14+9*r**16)+10*Q2**2*(-25+161*r**2-108*r**4
            -1238*r**6+2830*r**8-108*r**10-4764*r**12+2430*r**14-45*r**16+147*r**18)
            +(-1+r**2)**2*(-35+172*r**2-6*r**4-11844*r**6+34868*r**8-5600*r**10
            -2882*r**12+6396*r**14+359*r**16+172*r**18)-10*Q2*(-17+106*r**2-59*r**4
            -2308*r**6+4862*r**8+2928*r**10+4114*r**12-3356*r**14+2243*r**16+38*r**18
            +89*r**20))*sqrtq2)*math.log(mus))/(34992*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +81*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-139968*logq2**3*r**12*sqrtq2-2916*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2)+((-5760*logq2**2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(1-11*r**2+10*Q2**5*r**2+50*r**4+30*r**6+125*r**8-41*r**10
            +26*r**12-4*Q2**4*(1+8*r**2+11*r**4)+Q2**3*(6+49*r**2+89*r**4+61*r**6)
            -Q2**2*(-1+23*r**2+56*r**4+108*r**6+4*r**8)+Q2*(-4+12*r**2-33*r**4
            +27*r**6+77*r**8-49*r**10))-8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**9*r**2
            +Q2**8*(-22+89*r**2+23*r**4)-Q2**7*(-101+398*r**2+2817*r**4+196*r**6)
            +Q2**6*(-156+3*r**2+11687*r**4+9911*r**6+335*r**8)-Q2**5*(-47-904*r**2
            +10040*r**4+31544*r**6+7963*r**8+64*r**10)+Q2**4*(110+333*r**2-8167*r**4
            +8892*r**6+20686*r**8-10725*r**10-337*r**12)+Q2**3*(-93-2074*r**2+14295*r**4
            +18820*r**6+48901*r**8+4158*r**10+17921*r**12+272*r**14)+Q2**2*(-16
            +753*r**2-1695*r**4-6029*r**6-69053*r**8-42197*r**10-13221*r**12-1783*r**14
            +41*r**16)+Q2*(41+857*r**2-7214*r**4+9536*r**6-43980*r**8+110834*r**10
            -62202*r**12+21784*r**14-7941*r**16-115*r**18)+2*(-6-237*r**2+1964*r**4
            -9815*r**6-8509*r**8+86159*r**10-86693*r**12+43631*r**14-6565*r**16
            +1654*r**18+17*r**20))-172800*logq2**3*r**10*(1-2*r**2+3*r**4)*sqrtq2
            +48*logq2*r**2*(-5*(-1+Q2)**7*(7+15*Q2+8*Q2**2)-2*(-1+Q2)**5*(-121
            -75*Q2+30*Q2**2-150*Q2**3-180*Q2**4+46*Q2**5)*r**2+5*(-1+Q2)**3*(
            -77-113*Q2-324*Q2**2+602*Q2**3+33*Q2**4-621*Q2**5+140*Q2**6)*r**4
            -10*(-1166+2308*Q2-1238*Q2**2+2368*Q2**3-5001*Q2**4+2788*Q2**5+900*Q2**6
            -1160*Q2**7+201*Q2**8)*r**6+10*(-5855+4862*Q2-2830*Q2**2-5510*Q2**3
            +8466*Q2**4-2557*Q2**5-893*Q2**6+237*Q2**7)*r**8+10*(8718+2928*Q2
            +108*Q2**2-8184*Q2**3+4717*Q2**4-456*Q2**5+21*Q2**6)*r**10-2*(21593
            -20570*Q2-23820*Q2**2+7000*Q2**3-5890*Q2**4+1743*Q2**5)*r**12+10*(
            -656-3356*Q2-2430*Q2**2-632*Q2**3+315*Q2**4)*r**14-5*(-3063-4486*Q2
            -90*Q2**2+18*Q2**3)*r**16-10*(585-38*Q2+147*Q2**2)*r**18+5*(-3+178*Q2)*r**20
            -172*r**22)*sqrtq2)*math.log(2*muWC))/(32400*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+75*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-129600*logq2**3*r**12*sqrtq2
            -2700*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((-276480*logq2**3*(
            -Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)*(-500*Q2**7*r**2+8*Q2**6*(37+325*r**2
            +238*r**4)-Q2**5*(1331+5936*r**2+7519*r**4+1614*r**6)+Q2**4*(1995+6293*r**2
            +11045*r**4+5207*r**6-1220*r**8)-2*Q2**3*(295+1646*r**2+2356*r**4+834*r**6
            -611*r**8+320*r**10)+(-1+r**2)**2*(-369+1861*r**2-3770*r**4+3870*r**6
            +2575*r**8-1331*r**10+2444*r**12)+2*Q2**2*(-665+2024*r**2-2938*r**4
            +320*r**6+463*r**8-1984*r**10+3660*r**12)-Q2*(-1329+5812*r**2-12979*r**4
            +5750*r**6+15625*r**8+9224*r**10-8677*r**12+7694*r**14))-384*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-2116*Q2**13*r**2+8*Q2**12*(-55+2622*r**2
            +2499*r**4)-Q2**11*(-2695+74844*r**2+173973*r**4+73078*r**6)+Q2**10*(
            -5665+115601*r**2+480161*r**4+485187*r**6+126612*r**8)-Q2**9*(-1925
            +43790*r**2+334822*r**4+132172*r**6+463719*r**8+80830*r**10)-Q2**8*(
            -10725+82873*r**2+693606*r**4+4225750*r**6+3359067*r**8+244929*r**10
            +63348*r**12)+2*Q2**7*(-8085+36844*r**2+684383*r**4+4768578*r**6+7616339*r**8
            +3371356*r**10+387687*r**12+68178*r**14)-2*Q2**6*(-1155-16969*r**2+335659*r**4
            +2800357*r**6+8645857*r**8+8011415*r**10+2104051*r**12+234789*r**14
            +29532*r**16)-2*Q2**5*(-6765+17936*r**2+38490*r**4+2206684*r**6+1375874*r**8
            -1421520*r**10-2377494*r**12-476460*r**14-87321*r**16+15792*r**18)+2*Q2**4*(
            -5775-19005*r**2-15454*r**4+3186806*r**6+8298730*r**8+8776142*r**10
            +3020562*r**12-568034*r**14-1056359*r**16-127653*r**18+17240*r**20)
            +Q2**3*(275+39764*r**2+67951*r**4-1471070*r**6-9305662*r**8-5983544*r**10
            -8626918*r**12-753236*r**14+2670315*r**16+1125732*r**18+65079*r**20
            -4686*r**22)+Q2**2*(4235+2861*r**2+193437*r**4-699281*r**6-1188682*r**8
            +1573662*r**10-8213506*r**12-10798774*r**14+16384731*r**16-3955083*r**18
            +2644773*r**20+253575*r**22-3548*r**24)+(-1+r**2)**2*(385+4341*r**2
            +60811*r**4+160867*r**6-1919110*r**8+12621318*r**10-11352646*r**12-6365398*r**14
            +10827993*r**16-1183355*r**18+891707*r**20+54515*r**22+172*r**24)+Q2*(
            -2255-12894*r**2-201214*r**4+175892*r**6+4583875*r**8-23039650*r**10
            +21742748*r**12-18775112*r**14+27678791*r**16-30104450*r**18+5810530*r**20
            -2841804*r**22-221499*r**24+642*r**26))-16588800*logq2**4*r**16*(-13+2*r**2
            +33*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-4608*logq2**2*r**8*(
            -9208*Q2**12*r**2+8*Q2**11*(-130+10967*r**2+9797*r**4)-Q2**10*(-8285+343698*r**2
            +591239*r**4+278768*r**6)+10*Q2**9*(-2605+70309*r**2+173169*r**4+157657*r**6
            +52970*r**8)-5*Q2**8*(-7345+149378*r**2+461210*r**4+586962*r**6+414699*r**8
            +114264*r**10)+2*Q2**7*(-3500+112123*r**2+374170*r**4+409400*r**6+754550*r**8
            +707985*r**10+180288*r**12)+Q2**6*(-50470+406878*r**2+1758868*r**4+4132300*r**6
            +3631210*r**8+479750*r**10-719352*r**12-182112*r**14)+2*Q2**5*(34090
            -271667*r**2-1203536*r**4-2774467*r**6-2986750*r**8-1681765*r**10-193752*r**12
            +339819*r**14+52428*r**16)+10*Q2**4*(-2395+23951*r**2+103871*r**4+282433*r**6
            +111531*r**8+25933*r**10+57537*r**12+138391*r**14-46272*r**16+7260*r**18)
            +(-1+r**2)**4*(1785-2728*r**2-51786*r**4+448216*r**6-300472*r**8+5280*r**10
            -133382*r**12+453176*r**14+36399*r**16+18712*r**18)-10*Q2**3*(2260-4849*r**2
            -24010*r**4+188234*r**6-250114*r**8-177708*r**10+21270*r**12-63378*r**14
            +411694*r**16-3867*r**18+27188*r**20)-2*Q2*(-1+r**2)**2*(5745-15628*r**2
            -134404*r**4+908820*r**6-495176*r**8+141428*r**10+524358*r**12-307316*r**14
            +1148135*r**16+68856*r**18+55982*r**20)+Q2**2*(27625-111188*r**2-456365*r**4
            +2985000*r**6-3748950*r**8+2291520*r**10+2648406*r**12+3281640*r**14
            -3967875*r**16+4392500*r**18+455*r**20+260432*r**22))*sqrtq2+64*r**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(77*Q2**14*r**2+22*Q2**13*(1+34*r**2
            +25*r**4)-Q2**12*(167+8019*r**2+73085*r**4+7465*r**6)+Q2**11*(503+17966*r**2
            +519380*r**4+500646*r**6+28969*r**8)-Q2**10*(673+2406*r**2+1306674*r**4
            +2756106*r**6+1303321*r**8+54796*r**10)+Q2**9*(75-5774*r**2+1024603*r**4
            +4325092*r**6+4570777*r**8+1310210*r**10+49561*r**12)+2*Q2**8*(483-56128*r**2
            +597114*r**4+713438*r**6+2221745*r**8-373600*r**10+188382*r**12-2010*r**14)
            -2*Q2**7*(573-134534*r**2+1379836*r**4+4690554*r**6+16422072*r**8+13234338*r**10
            +2192788*r**12+939090*r**14+16035*r**16)+Q2**6*(174-155567*r**2+1233588*r**4
            +6706708*r**6+34084412*r**8+57208466*r**10+25664388*r**12+2950468*r**14
            +1186158*r**16+20037*r**18)+4*Q2**5*(159-40732*r**2+269649*r**4-50662*r**6
            +2616193*r**8-4185532*r**10-6540599*r**12-1241006*r**14-341132*r**16
            +49668*r**18+2218*r**20)-Q2**4*(475-250197*r**2+1214253*r**4-1046343*r**6
            +34641882*r**8+30809754*r**10+21869118*r**12-2894034*r**14-2493093*r**16
            -3787413*r**18+382885*r**20+13513*r**22)+Q2**3*(-13-59642*r**2+68972*r**4
            -1398626*r**6+14286695*r**8+18256980*r**10+13059144*r**12+11617508*r**14
            -4531399*r**16-3412570*r**18-2327732*r**20+58238*r**22+1645*r**24)+2*(
            -1+r**2)**2*(6-5421*r**2+11791*r**4-391310*r**6+481021*r**8+3290117*r**10
            -30218566*r**12+53116508*r**14-33739492*r**16+6578189*r**18-1647913*r**20
            -312878*r**22-13439*r**24+187*r**26)+Q2**2*(163-74824*r**2+432982*r**4
            -2326962*r**6+6456389*r**8-6095046*r**10+24410244*r**12+10593988*r**14
            -32453283*r**16+17006756*r**18-6502042*r**20-1895890*r**22-52485*r**24
            +4010*r**26)+Q2*(-77+54226*r**2-244493*r**4+2907876*r**6-8097021*r**8
            +596094*r**10+48114883*r**12+5388376*r**14-136419647*r**16+135558702*r**18
            -35143167*r**20+7781316*r**22+2228617*r**24+86146*r**26-2231*r**28))*sqrtq2)*math.log(r))/(55987200*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +388800*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3-167961600*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            -6998400*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2*sqrtq2-8100*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2))+muWC**3*((pi2*(5760*logq2**2*r**4*(10*Q2**7*(1
            +5*r**4)-4*Q2**6*(19+26*r**2+77*r**4+80*r**6)+Q2**5*(201+500*r**2
            +1457*r**4+1343*r**6+795*r**8)-Q2**4*(215+758*r**2+2837*r**4+3624*r**6
            +1980*r**8+850*r**10)+2*Q2**3*(10+191*r**2+810*r**4+1147*r**6+1353*r**8
            +415*r**10+50*r**12)+(-1+r**2)**2*(29-10*r**2+507*r**4-2218*r**6-3483*r**8
            -102*r**10+107*r**12+130*r**14)+Q2**2*(150-38*r**2+969*r**4-1368*r**6
            -2014*r**8-274*r**10+295*r**12+600*r**14)+Q2*(-119+86*r**2-1507*r**4
            +3971*r**6+11956*r**8+6170*r**10+135*r**12-27*r**14-505*r**16))+8*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**12+Q2**11*(19+5*r**2)+Q2**10*(69
            +312*r**2+139*r**4)-Q2**9*(2973+1415*r**2+13845*r**4+1655*r**6)+2*Q2**8*(6266
            +521*r**2+16200*r**4+35467*r**6+2610*r**8)-2*Q2**7*(9712-3611*r**2
            -9936*r**4+62186*r**6+66386*r**8+3423*r**10)+2*Q2**6*(2072+1935*r**2
            -61245*r**4-10798*r**6+86420*r**8+26287*r**10+945*r**12)+2*Q2**5*(11672
            -41479*r**2+147396*r**4+209881*r**6+240442*r**8-62343*r**10+78766*r**12
            +2481*r**14)-2*Q2**4*(13201-71075*r**2+299355*r**4+744945*r**6+919905*r**8
            +713699*r**10-54415*r**12+110975*r**14+2610*r**16)+Q2**3*(3893-46947*r**2
            +402420*r**4+1147164*r**6+2150370*r**8+1441802*r**10+967372*r**12+3940*r**14
            +58121*r**16+505*r**18)+2*(-1+r**2)**2*(731-9790*r**2+106706*r**4-300958*r**6
            +144348*r**8-301378*r**10-524770*r**12+302334*r**14-29527*r**16+7392*r**18
            +112*r**20)+Q2**2*(10491-84742*r**2+442083*r**4-100472*r**6+770418*r**8
            -528204*r**10-289358*r**12+1166712*r**14-258093*r**16+78802*r**18+1963*r**20)
            +Q2*(-7163+83965*r**2-710695*r**4+1148445*r**6+456510*r**8+1378846*r**10
            +1630950*r**12+2565390*r**14-1921475*r**16+278885*r**18-64063*r**20
            -1195*r**22))+172800*logq2**3*r**8*(3+5*r**2-65*r**4+r**6)*sqrtq2+48*logq2*(92*Q2**10*(1
            +5*r**4)-20*Q2**9*(29+15*r**2+105*r**4+175*r**6)+5*Q2**8*(279+271*r**2
            +205*r**4+2715*r**6+2010*r**8)-10*Q2**7*(132+259*r**2-766*r**4+668*r**6
            +3002*r**8+1185*r**10)-10*Q2**6*(42-335*r**2+2345*r**4+3050*r**6+2732*r**8
            -2147*r**10+105*r**12)+2*Q2**5*(1008-1895*r**2+25330*r**4+86925*r**6
            +128000*r**8+85343*r**10+7950*r**12+8715*r**14)-10*Q2**4*(147-230*r**2
            +6386*r**4+37548*r**6+74256*r**8+63236*r**10+26280*r**12+3650*r**14
            +1575*r**16)+10*Q2**3*(-12+167*r**2+1354*r**4+25306*r**6+51738*r**8
            +66076*r**10+43574*r**12+6870*r**14+2450*r**16+45*r**18)+10*Q2**2*(72
            -391*r**2+5303*r**4+3264*r**6+11020*r**8-2606*r**10-21870*r**12+6408*r**14
            +19188*r**16-963*r**18+735*r**20)+(-1+r**2)**2*(67-401*r**2+13526*r**4
            +9618*r**6-128500*r**8-158132*r**10-447154*r**12+51694*r**14+52977*r**16
            +645*r**18+860*r**20)-10*Q2*(38-245*r**2+5136*r**4+3913*r**6-15952*r**8
            -85914*r**10-97164*r**12-75350*r**14+4778*r**16+18783*r**18-388*r**20
            +445*r**22))*sqrtq2))/(874800*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +2025*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-3499200*logq2**3*r**12*sqrtq2-72900*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2)+(-64*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1272*Q2**17-45*Q2**16*(3+37*r**2)+4*Q2**15*(-3111
            +16792*r**2+8045*r**4)-2*Q2**14*(182241+323301*r**2+2102853*r**4+252893*r**6)
            +Q2**13*(2908713+3147602*r**2+26251180*r**4+33638694*r**6+2590003*r**8)
            -Q2**12*(8772423+7853391*r**2+61446022*r**4+163250950*r**6+114190227*r**8
            +6582379*r**10)+2*Q2**11*(5606139+6569257*r**2+24641299*r**4+136163436*r**6
            +203908155*r**8+91109475*r**10+4339583*r**12)-2*Q2**10*(-1155990+16766181*r**2
            -31442625*r**4+5120150*r**6+91455384*r**8+207594369*r**10+29555655*r**12
            +1761980*r**14)-Q2**9*(26994561-94549144*r**2+262937658*r**4+921972592*r**6
            +1592695360*r**8+1154723360*r**10+35335126*r**12+268388008*r**14+6195343*r**16)
            +Q2**8*(33153549-142427769*r**2+435100170*r**4+2193225510*r**6+4487270800*r**8
            +4842820000*r**10+2743966974*r**12+434714850*r**14+439783947*r**16+9520929*r**18)
            -4*Q2**7*(1680030-12096753*r**2+35487204*r**4+554660760*r**6+1227185534*r**8
            +1616782996*r**10+1224130502*r**12+399584784*r**14+115934280*r**16+44309349*r**18
            +624162*r**20)+Q2**6*(-22775826+153094442*r**2-879088886*r**4+838369038*r**6
            +2391943460*r**8+4906978756*r**10+5272778052*r**12+2325295764*r**14-2232942402*r**16
            +621675330*r**18-218064670*r**20-5365202*r**22)+Q2**5*(23828247-222782910*r**2
            +1607518200*r**4-837909386*r**6-2278255585*r**8-8601449572*r**10-11530836344*r**12
            -8267357708*r**14-4248690011*r**16+4457783010*r**18-825601152*r**20+294624726*r**22
            +5584165*r**24)+Q2**4*(-5630457+82278283*r**2-866902786*r**4+1455719718*r**6
            +2133549985*r**8+7202378485*r**10+12086337644*r**12+9646845292*r**14
            +5147536513*r**16+5392338685*r**18-2361968618*r**20+369975278*r**22-94741161*r**24
            -1210621*r**26)+2*(-1+r**2)**4*(113421-2075789*r**2+30577453*r**4-171866757*r**6
            +448660826*r**8-401835338*r**10+660325870*r**12+613724914*r**14+360412717*r**16
            -474811421*r**18+84311397*r**20-15761901*r**22+1425388*r**24+21620*r**26)
            -Q2*(-1+r**2)**2*(1788567-29910150*r**2+380837895*r**4-1740697840*r**6
            +3095078995*r**8-794057214*r**10+3866863379*r**12+9300254048*r**14+6187767317*r**16
            +1894931726*r**18-4942269883*r**20+1099312016*r**22-210413823*r**24+21715318*r**26
            +358049*r**28)-2*Q2**3*(2986881-33201621*r**2+243883525*r**4-419980268*r**6
            +485039019*r**8-338548925*r**10-187984357*r**12+223136280*r**14+603074855*r**16
            -1405927495*r**18-1310879301*r**20+714342868*r**22-189438035*r**24+28591833*r**26
            +674341*r**28)+2*Q2**2*(2694948-41124523*r**2+443275919*r**4-1699416060*r**6
            +2462497914*r**8-1593600741*r**10+5288795261*r**12+4476625002*r**14+7311767520*r**16
            +2793186507*r**18+2544277273*r**20-5002547168*r**22+1387180674*r**24
            -273177915*r**26+30555099*r**28+568690*r**30))-64*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1272*Q2**17-45*Q2**16*(3+37*r**2)+4*Q2**15*(-3111
            +16792*r**2+8045*r**4)-2*Q2**14*(182241+323301*r**2+2102853*r**4+252893*r**6)
            +Q2**13*(2908713+3147602*r**2+26251180*r**4+33638694*r**6+2590003*r**8)
            -Q2**12*(8772423+7853391*r**2+61446022*r**4+163250950*r**6+114190227*r**8
            +6582379*r**10)+2*Q2**11*(5606139+6569257*r**2+24641299*r**4+136163436*r**6
            +203908155*r**8+91109475*r**10+4339583*r**12)-2*Q2**10*(-1155990+16766181*r**2
            -31442625*r**4+5120150*r**6+91455384*r**8+207594369*r**10+29555655*r**12
            +1761980*r**14)-Q2**9*(26994561-94549144*r**2+262937658*r**4+921972592*r**6
            +1592695360*r**8+1154723360*r**10+35335126*r**12+268388008*r**14+6195343*r**16)
            +Q2**8*(33153549-142427769*r**2+435100170*r**4+2193225510*r**6+4487270800*r**8
            +4842820000*r**10+2743966974*r**12+434714850*r**14+439783947*r**16+9520929*r**18)
            -4*Q2**7*(1680030-12096753*r**2+35487204*r**4+554660760*r**6+1227185534*r**8
            +1616782996*r**10+1224130502*r**12+399584784*r**14+115934280*r**16+44309349*r**18
            +624162*r**20)+Q2**6*(-22775826+153094442*r**2-879088886*r**4+838369038*r**6
            +2391943460*r**8+4906978756*r**10+5272778052*r**12+2325295764*r**14-2232942402*r**16
            +621675330*r**18-218064670*r**20-5365202*r**22)+Q2**5*(23828247-222782910*r**2
            +1607518200*r**4-837909386*r**6-2278255585*r**8-8601449572*r**10-11530836344*r**12
            -8267357708*r**14-4248690011*r**16+4457783010*r**18-825601152*r**20+294624726*r**22
            +5584165*r**24)+Q2**4*(-5630457+82278283*r**2-866902786*r**4+1455719718*r**6
            +2133549985*r**8+7202378485*r**10+12086337644*r**12+9646845292*r**14
            +5147536513*r**16+5392338685*r**18-2361968618*r**20+369975278*r**22-94741161*r**24
            -1210621*r**26)+2*(-1+r**2)**4*(113421-2075789*r**2+30577453*r**4-171866757*r**6
            +448660826*r**8-401835338*r**10+660325870*r**12+613724914*r**14+360412717*r**16
            -474811421*r**18+84311397*r**20-15761901*r**22+1425388*r**24+21620*r**26)
            -Q2*(-1+r**2)**2*(1788567-29910150*r**2+380837895*r**4-1740697840*r**6
            +3095078995*r**8-794057214*r**10+3866863379*r**12+9300254048*r**14+6187767317*r**16
            +1894931726*r**18-4942269883*r**20+1099312016*r**22-210413823*r**24+21715318*r**26
            +358049*r**28)-2*Q2**3*(2986881-33201621*r**2+243883525*r**4-419980268*r**6
            +485039019*r**8-338548925*r**10-187984357*r**12+223136280*r**14+603074855*r**16
            -1405927495*r**18-1310879301*r**20+714342868*r**22-189438035*r**24+28591833*r**26
            +674341*r**28)+2*Q2**2*(2694948-41124523*r**2+443275919*r**4-1699416060*r**6
            +2462497914*r**8-1593600741*r**10+5288795261*r**12+4476625002*r**14+7311767520*r**16
            +2793186507*r**18+2544277273*r**20-5002547168*r**22+1387180674*r**24
            -273177915*r**26+30555099*r**28+568690*r**30))*sqrtq2+logq2**4*(16588800*r**16*(1
            -Q2+r**2)*(249+575*r**2-9987*r**4+419*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3+16588800*r**16*(249+575*r**2-9987*r**4+419*r**6)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**3*(276480*r**12*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(-20*Q2**9*(-19+65*r**4)-24*Q2**8*(152
            +447*r**2+974*r**4+265*r**6)+Q2**7*(9669+65333*r**2+410077*r**4+261683*r**6
            +80430*r**8)-Q2**6*(5709+135304*r**2+1557262*r**4+2044304*r**6+907453*r**8
            +244080*r**10)+3*Q2**5*(-4129+44943*r**2+812786*r**4+1273232*r**6+1235665*r**8
            +423177*r**10+93670*r**12)+(-1+r**2)**4*(-3023+6804*r**2+183753*r**4
            -999252*r**6-1402077*r**8+8116*r**10+60579*r**12+46540*r**14)+Q2**4*(16635
            -98560*r**2-1490693*r**4-2437688*r**6-2933491*r**8-2466780*r**10-449635*r**12
            +50100*r**14)+Q2**3*(5463+66143*r**2-605467*r**4+2256219*r**6+7811491*r**8
            +3202557*r**10+102623*r**12-502519*r**14-478590*r**16)-Q2*(-1+r**2)**2*(
            -13899+15403*r**2+921301*r**4-3512387*r**6-9700267*r**8-5259243*r**10
            +207315*r**12+303427*r**14+249870*r**16)+3*Q2**2*(-7093+864*r**2+522620*r**4
            -1751988*r**6-4027434*r**8-3947616*r**10-2285068*r**12+35676*r**14+93679*r**16
            +174040*r**18))+276480*r**12*(20*Q2**12*(-19+65*r**4)+12*Q2**11*(399+989*r**2
            +1623*r**4+205*r**6)-Q2**10*(21753+109221*r**2+509629*r**4+348291*r**6
            +95610*r**8)+10*Q2**9*(4604+39941*r**2+308434*r**4+415928*r**6+201794*r**8
            +50315*r**10)-5*Q2**8*(7479+156057*r**2+1782992*r**4+3280300*r**6+2907629*r**8
            +1137411*r**10+252180*r**12)+10*Q2**7*(-2700+93888*r**2+1450485*r**4
            +3066114*r**6+3647032*r**8+2614438*r**10+849303*r**12+160560*r**14)
            +(-1+r**2)**6*(-3023+3781*r**2+190557*r**4-815499*r**6-2401329*r**8
            -1393961*r**10+68695*r**12+107119*r**14+46540*r**16)-2*Q2**6*(-37947
            +410613*r**2+6563056*r**4+15569550*r**6+23720835*r**8+20467313*r**10
            +12123858*r**12+2865036*r**14+229110*r**16)+Q2**5*(-24624+621852*r**2
            +3749378*r**4+22032472*r**6+58017130*r**8+61646576*r**10+30977862*r**12
            +8999048*r**14-987138*r**16-1827180*r**18)-2*Q2*(-1+r**2)**4*(-11484
            +7935*r**2+746251*r**4-2600462*r**6-9433065*r**8-10368536*r**10-4530095*r**12
            +397934*r**14+414057*r**16+194745*r**18)+5*Q2**2*(-1+r**2)**2*(-14409
            +5841*r**2+972676*r**4-3182990*r**6-10487852*r**8-12372196*r**10-11265906*r**12
            -5094738*r**14+413893*r**16+451059*r**18+282270*r**20)+10*Q2**4*(-7749
            -33741*r**2+584691*r**4-2299185*r**6-7900317*r**8-9173215*r**10-8270313*r**12
            -3388731*r**14+108022*r**16+417816*r**18+330210*r**20)-10*Q2**3*(-11402
            +1134*r**2+821979*r**4-3049572*r**6-6589626*r**8-4247358*r**10-4108328*r**12
            -6149442*r**14-4044988*r**16+37288*r**18+194637*r**20+284110*r**22))*sqrtq2)
            +logq2**2*(-4608*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(8*Q2**12*(3155
            +34431*r**4)-8*Q2**11*(32255+38225*r**2+284017*r**4+310297*r**6)+Q2**10*(1066505
            +2376335*r**2+10427163*r**4+15892229*r**6+9391408*r**8)-10*Q2**9*(221555
            +716862*r**2+2925966*r**4+5051352*r**6+4399455*r**8+1860626*r**10)+5*Q2**8*(406005
            +2051073*r**2+9215378*r**4+17906978*r**6+19193337*r**8+11647621*r**10
            +3634872*r**12)-2*Q2**7*(-351060+2981700*r**2+16924213*r**4+49321450*r**6
            +67500240*r**8+45716010*r**10+16319015*r**12+610608*r**14)-2*Q2**6*(1861335
            +496545*r**2+568654*r**4-58466476*r**6-149094715*r**8-124009345*r**10
            -40393930*r**12-1124356*r**14+8629824*r**16)+2*Q2**5*(1767270+1289400*r**2
            +9272627*r**4-83658794*r**6-263427793*r**8-327263500*r**10-210581475*r**12
            -47365638*r**14-1536149*r**16+8948052*r**18)+(-1+r**2)**4*(64205-240115*r**2
            +1435218*r**4-10924974*r**6+36219124*r**8+80951052*r**10+114491910*r**12
            -18798098*r**14-12438081*r**16-2029529*r**18+139688*r**20)-10*Q2**4*(65595
            +202443*r**2+588299*r**4-12938693*r**6-34635471*r**8-40715139*r**10
            -47225091*r**12-27146551*r**14-2485152*r**16-304460*r**18+501804*r**20)
            -10*Q2**3*(137440-405096*r**2+1392959*r**4-1815462*r**6+2954694*r**8
            +26774910*r**10+36009492*r**12+16336418*r**14-7922390*r**16-9698974*r**18
            -1794467*r**20+376716*r**22)-2*Q2*(-1+r**2)**2*(228895-818880*r**2+4156698*r**4
            -28183166*r**6+51021280*r**8+265862816*r**10+359379742*r**12+190407652*r**14
            -49931359*r**16-31453680*r**18-5784536*r**20+596138*r**22)+Q2**2*(1261765
            -4862525*r**2+20271153*r**4-107212765*r**6+119028950*r**8+723422890*r**10
            +1221259030*r**12+778623314*r**14+509155525*r**16-108773565*r**18-107160695*r**20
            -26756645*r**22+3669968*r**24))-4608*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(8*Q2**12*(3155+34431*r**4)-8*Q2**11*(32255+38225*r**2+284017*r**4
            +310297*r**6)+Q2**10*(1066505+2376335*r**2+10427163*r**4+15892229*r**6
            +9391408*r**8)-10*Q2**9*(221555+716862*r**2+2925966*r**4+5051352*r**6
            +4399455*r**8+1860626*r**10)+5*Q2**8*(406005+2051073*r**2+9215378*r**4
            +17906978*r**6+19193337*r**8+11647621*r**10+3634872*r**12)-2*Q2**7*(
            -351060+2981700*r**2+16924213*r**4+49321450*r**6+67500240*r**8+45716010*r**10
            +16319015*r**12+610608*r**14)-2*Q2**6*(1861335+496545*r**2+568654*r**4
            -58466476*r**6-149094715*r**8-124009345*r**10-40393930*r**12-1124356*r**14
            +8629824*r**16)+2*Q2**5*(1767270+1289400*r**2+9272627*r**4-83658794*r**6
            -263427793*r**8-327263500*r**10-210581475*r**12-47365638*r**14-1536149*r**16
            +8948052*r**18)+(-1+r**2)**4*(64205-240115*r**2+1435218*r**4-10924974*r**6
            +36219124*r**8+80951052*r**10+114491910*r**12-18798098*r**14-12438081*r**16
            -2029529*r**18+139688*r**20)-10*Q2**4*(65595+202443*r**2+588299*r**4
            -12938693*r**6-34635471*r**8-40715139*r**10-47225091*r**12-27146551*r**14
            -2485152*r**16-304460*r**18+501804*r**20)-10*Q2**3*(137440-405096*r**2
            +1392959*r**4-1815462*r**6+2954694*r**8+26774910*r**10+36009492*r**12
            +16336418*r**14-7922390*r**16-9698974*r**18-1794467*r**20+376716*r**22)
            -2*Q2*(-1+r**2)**2*(228895-818880*r**2+4156698*r**4-28183166*r**6+51021280*r**8
            +265862816*r**10+359379742*r**12+190407652*r**14-49931359*r**16-31453680*r**18
            -5784536*r**20+596138*r**22)+Q2**2*(1261765-4862525*r**2+20271153*r**4
            -107212765*r**6+119028950*r**8+723422890*r**10+1221259030*r**12+778623314*r**14
            +509155525*r**16-108773565*r**18-107160695*r**20-26756645*r**22+3669968*r**24))*sqrtq2)
            +logq2*(-384*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(92*Q2**15*(147
            +1343*r**4)-24*Q2**14*(5243+3192*r**2+44973*r**4+55602*r**6)+Q2**13*(487893
            +557449*r**2+3678385*r**4+10038383*r**6+5985722*r**8)-Q2**12*(952707
            +1706264*r**2+5706642*r**4+26616048*r**6+36516915*r**8+13868848*r**10)
            +2*Q2**11*(359709+1455894*r**2+339845*r**4+11618727*r**6+24501568*r**8
            +30742471*r**10+7504146*r**12)+2*Q2**10*(386463-1635185*r**2+8683124*r**4
            +29188438*r**6+66329857*r**8+42160661*r**10-13964324*r**12+1396022*r**14)
            -Q2**9*(2317161-2726621*r**2+43688701*r**4+268247025*r**6+704063125*r**8
            +845528641*r**10+453903455*r**12+68752971*r**14+28854054*r**16)+Q2**8*(1887039
            -600318*r**2+44725590*r**4+480218038*r**6+1394593048*r**8+2012241394*r**10
            +1622447474*r**12+649041394*r**14+127972929*r**16+31396356*r**18)-4*Q2**7*(
            -77616+1026048*r**2-5886516*r**4+90330155*r**6+324862405*r**8+562857275*r**10
            +566891213*r**12+304815839*r**14+53783945*r**16+21850515*r**18+708801*r**20)
            -4*Q2**6*(447909-2023251*r**2+31123030*r**4+16713566*r**6-141985258*r**8
            -539776020*r**10-776844594*r**12-491536740*r**14-40455499*r**16+107809727*r**18
            -4963284*r**20+5851246*r**22)+Q2**5*(1298451-6125805*r**2+137720391*r**4
            +281173117*r**6-531319244*r**8-3321296682*r**10-6712532202*r**12-5970430902*r**14
            -3060178933*r**16+39635831*r**18+520965283*r**20+7551321*r**22+20987694*r**24)
            +Q2**4*(-92757-54388*r**2-36037222*r**4-167188852*r**6+763059105*r**8
            +2458940024*r**10+4875870340*r**12+5539088224*r**14+4078974405*r**16
            +2311368900*r**18+23596578*r**20-122942412*r**22-17866577*r**24-3414248*r**26)
            +(-1+r**2)**4*(9849-93554*r**2+3495620*r**4-9774018*r**6-33671967*r**8
            +196965272*r**10+144471000*r**12+948932964*r**14+697863347*r**16-385144698*r**18
            -54177436*r**20+2846814*r**22-935949*r**24+175956*r**26)-Q2*(-1+r**2)**2*(85407
            -813769*r**2+23763050*r**4-55233816*r**6-173525129*r**8+411321267*r**10
            +1850808142*r**12+4543675472*r**14+5658907477*r**16+1938009301*r**18
            -1825478394*r**20-315475768*r**22+37462933*r**24-7261631*r**26+1461058*r**28)
            -2*Q2**3*(213591-1838122*r**2+29048175*r**4-55879127*r**6+127957210*r**8
            -118736507*r**10+354862948*r**12+267903358*r**14+1155438951*r**16-214214364*r**18
            -643393909*r**20-251434151*r**22+80306152*r**24-14389119*r**26+3002914*r**28)
            +2*Q2**2*(146559-1439397*r**2+31403764*r**4-76228666*r**6-76027385*r**8
            -68618397*r**10+1353718464*r**12+4059555362*r**14+3862344437*r**16+3208353945*r**18
            +1416921572*r**20-1306102982*r**22-380989691*r**24+74651689*r**26-12338200*r**28
            +2354526*r**30))+384*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(92*Q2**16*(147
            +1343*r**4)-4*Q2**15*(34839+22533*r**2+300727*r**4+364501*r**6)+Q2**14*(613725
            +759889*r**2+4834345*r**4+12452183*r**6+7320170*r**8)-2*Q2**13*(720300
            +1375803*r**2+4971238*r**4+20166408*r**6+26270510*r**8+9927285*r**10)
            +Q2**12*(1672125+5570759*r**2+8092596*r**4+55560144*r**6+112136099*r**8
            +111870705*r**10+28877140*r**12)-2*Q2**11*(-26754+3450788*r**2-6887385*r**4
            -17229866*r**6-30209562*r**8+13083378*r**10+52210941*r**12+6108124*r**14)
            -Q2**10*(3090087-5224065*r**2+57784579*r**4+343990149*r**6+895099715*r**8
            +1062509677*r**10+510296129*r**12+43616367*r**14+31646098*r**16)+2*Q2**9*(2102100
            -504889*r**2+42843835*r**4+396076882*r**6+1183451599*r**8+1780916580*r**10
            +1460939785*r**12+585848910*r**14+112789977*r**16+30125205*r**18)-Q2**8*(1576575
            +5390913*r**2+20579208*r**4+886264248*r**6+3174260706*r**8+5658263542*r**10
            +5902253720*r**12+3490752224*r**14+992150103*r**16+246771345*r**18+34231560*r**20)
            -4*Q2**7*(525525-2971683*r**2+35983498*r**4-67730073*r**6-557177818*r**8
            -1427495700*r**10-1906593082*r**12-1363243792*r**14-399055283*r**16+32175267*r**18
            -27522600*r**20+5142445*r**22)+Q2**6*(3090087-12427173*r**2+254119507*r**4
            +472519501*r**6-1032406012*r**8-6048341794*r**10-11979014658*r**12-11043956238*r**14
            -5188147889*r**16+309052743*r**18+932351055*r**20+11103169*r**22+44392678*r**24)
            -2*Q2**5*(695604-2386483*r**2+83815904*r**4+293041180*r**6-506602616*r**8
            -3155777975*r**10-7454849612*r**12-9111025664*r**14-6554792120*r**16
            -2665956001*r**18+268502268*r**20+325729508*r**22+23202796*r**24+12200971*r**26)
            -(-1+r**2)**4*(9849-83705*r**2+3402066*r**4-6278398*r**6-43445985*r**8
            +163293305*r**10+341436272*r**12+1093403964*r**14+1646796311*r**16+312718649*r**18
            -439322134*r**20-51330622*r**22+1910865*r**24-759993*r**26+175956*r**28)
            -Q2**4*(334425-3823389*r**2+22004740*r**4-314984328*r**6+851784673*r**8
            +2984526115*r**10+8044536260*r**12+10950765280*r**14+11928940531*r**16
            +5961914577*r**18+1048177660*r**20-602214136*r**22+19803315*r**24-50059063*r**26
            +2591580*r**28)+2*Q2*(-1+r**2)**2*(47628-420807*r**2+13320929*r**4-24164789*r**6
            -119693628*r**8+246165663*r**10+989498949*r**12+3625719925*r**14+4573525684*r**16
            +3382489175*r**18+763253107*r**20-1207448587*r**22-169409924*r**24+17547985*r**26
            -3544217*r**28+818507*r**30)+2*Q2**3*(360150-3063928*r**2+58613817*r**4
            -103059618*r**6-3949302*r**8-59397694*r**10+1589844905*r**12+4682321668*r**14
            +5285686746*r**16+4149578532*r**18+559313299*r**20-2200931042*r**22-552117690*r**24
            +140568722*r**26-23724405*r**28+5357440*r**30)-Q2**2*(378525-3570259*r**2
            +85404729*r**4-193223489*r**6-343806549*r**8+413846145*r**10+3424840613*r**12
            +12079928107*r**14+14266164273*r**16+9305266583*r**18+9207961515*r**20
            +5495127501*r**22-4531249271*r**24-1010339269*r**26+178074231*r**28-30151095*r**30
            +6170110*r**32))*sqrtq2))/(97200*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4+97200*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2+logq2**4*(2015539200*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+2015539200*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**3*(-671846400*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-671846400*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)+logq2**2*(83980800*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+83980800*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+logq2*(
            -4665600*(-Q2+(-1+r)**2)**3*r**8*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3-4665600*(-Q2+(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2))+((-1105920*logq2**3*r**10*(-40*Q2**9*(2
            +5*r**4)+12*Q2**8*(64+67*r**2+136*r**4+95*r**6)-Q2**7*(2964+5561*r**2
            +8098*r**4+6581*r**6+2220*r**8)+Q2**6*(5844+14257*r**2+21265*r**4+17957*r**6
            +8131*r**8+1170*r**10)+3*Q2**5*(-1916-5405*r**2-8132*r**4-7670*r**6
            -3686*r**8-969*r**10+170*r**12)+(-1+r**2)**4*(-292-63*r**2+219*r**4
            -1566*r**6-726*r**8-1939*r**10+927*r**12+1040*r**14)+Q2**4*(1140+6475*r**2
            +7793*r**4+7904*r**6+3952*r**8+765*r**10+4555*r**12+3000*r**14)+Q2**3*(3492
            +721*r**2+2986*r**4+9717*r**6+7496*r**8+2139*r**10+1786*r**12-9857*r**14
            -9840*r**16)-Q2*(-1+r**2)**2*(-1716-295*r**2+218*r**4-9511*r**6-6446*r**8
            -5565*r**10-5586*r**12+4331*r**14+5370*r**16)+3*Q2**2*(-1292+517*r**2
            -203*r**4-5559*r**6-5197*r**8-1035*r**10-389*r**12-3849*r**14+617*r**16
            +3590*r**18))-1536*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(-920*Q2**15*r**2
            +12*Q2**14*(-21+572*r**2+875*r**4)-Q2**13*(-1777+15074*r**2+71179*r**4
            +49780*r**6)+Q2**12*(-6251-14031*r**2+152445*r**4+268743*r**6+125990*r**8)
            -2*Q2**11*(-8682-97004*r**2-16530*r**4+60605*r**6+213422*r**8+86745*r**10)
            +2*Q2**10*(-20834-359512*r**2-565088*r**4-1099907*r**6-902725*r**8+20323*r**10
            +45695*r**12)+Q2**9*(70829+1518062*r**2+3608013*r**4+8193770*r**6+10788755*r**8
            +6288442*r**10+887307*r**12+86550*r**14)-Q2**8*(63459+1638207*r**2+5613479*r**4
            +13214831*r**6+22101185*r**8+19188625*r**10+8760689*r**12+1407777*r**14
            +175140*r**16)+4*Q2**7*(-1452+14538*r**2+905932*r**4+839501*r**6+3378670*r**8
            +4764103*r**10+3308128*r**12+1411297*r**14+260406*r**16+23205*r**18)
            +4*Q2**6*(19833+533126*r**2+225187*r**4+5699857*r**6+6882087*r**8+3697281*r**10
            -485709*r**12-159383*r**14-474518*r**16-132273*r**18+6320*r**20)+(
            -1+r**2)**4*(-1073-49561*r**2+115245*r**4-1761603*r**6+3348914*r**8
            +5096322*r**10-13337610*r**12-192490*r**14+4701183*r**16-47209*r**18
            +377181*r**20+22701*r**22)-Q2**5*(78309+2456262*r**2+2377025*r**4+35941784*r**6
            +52714602*r**8+45469332*r**10+19261698*r**12-6198560*r**14+3017089*r**16
            -1235098*r**18-315603*r**20+51720*r**22)+Q2**4*(18623+737699*r**2+1226687*r**4
            +15703665*r**6+25181300*r**8+11722222*r**10+16169542*r**12+8552418*r**14
            -7153185*r**16+2546655*r**18+332235*r**20-37571*r**22+17950*r**24)+Q2*(
            -1+r**2)**2*(7879+327496*r**2-760920*r**4+10198826*r**6-14172357*r**8
            -19970218*r**10+27758320*r**12+36551564*r**14-1568011*r**16-23072868*r**18
            +642664*r**20-1981366*r**22-137719*r**24+710*r**26)+2*Q2**3*(11566+369228*r**2
            -768346*r**4+6964643*r**6-4278730*r**8+7141235*r**10+5662748*r**12+2859738*r**14
            -9404478*r**16-10703210*r**18-497026*r**20-1705981*r**22-146022*r**24
            +1835*r**26)-2*Q2**2*(11058+404348*r**2-1137176*r**4+11128991*r**6-16256715*r**8
            -681471*r**10+7933849*r**12+9227002*r**14+16663368*r**16+6465490*r**18
            -19687282*r**20+1799783*r**22-1889071*r**24-160079*r**26+1905*r**28))
            -66355200*logq2**4*r**14*(-6-5*r**2+r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2-18432*logq2**2*r**6*(-16*Q2**12*(47+240*r**4)+8*Q2**11*(838
            +703*r**2+3800*r**4+4085*r**6)-Q2**10*(24862+39031*r**2+127212*r**4
            +206395*r**6+116240*r**8)+10*Q2**9*(4714+10743*r**2+31431*r**4+59787*r**6
            +54723*r**8+22090*r**10)-5*Q2**8*(7878+27663*r**2+68260*r**4+169030*r**6
            +196662*r**8+137147*r**10+47640*r**12)+4*Q2**7*(-3804+13560*r**2-77510*r**4
            -50645*r**6+31470*r**8+108321*r**10+89030*r**12+37470*r**14)+2*Q2**6*(34146
            +33621*r**2+742550*r**4+1383580*r**6+1430620*r**8+697981*r**10+72556*r**12
            +5110*r**14-37380*r**16)+4*Q2**5*(-15114-23877*r**2-457679*r**4-955300*r**6
            -1105430*r**8-759479*r**10-192147*r**12+54936*r**14-16330*r**16+10620*r**18)
            +10*Q2**4*(906+5697*r**2+59974*r**4+168425*r**6+146418*r**8+121827*r**10
            +61098*r**12+42967*r**14+22608*r**16+7052*r**18+3060*r**20)+(-1+r**2)**4*(
            -982-439*r**2-84336*r**4+100902*r**6+205300*r**8-292248*r**10-512256*r**12
            +91066*r**14+249378*r**16+19855*r**18+7760*r**20)-20*Q2**3*(-1192+1938*r**2
            -43130*r**4+11529*r**6-15186*r**8-67233*r**10-38514*r**12-19193*r**14
            +74042*r**16+94327*r**18+5612*r**20+5640*r**22)-2*Q2*(-1+r**2)**2*(
            -3602+1629*r**2-246615*r**4+201076*r**6+424162*r**8-533248*r**10-867284*r**12
            -809030*r**14+277304*r**16+629643*r**18+38755*r**20+23210*r**22)+Q2**2*(
            -20582+34285*r**2-1097520*r**4+1176275*r**6+473360*r**8-2040566*r**10
            -1463420*r**12-362770*r**14-2411330*r**16-207015*r**18+2304268*r**20
            +51055*r**22+107960*r**24))*sqrtq2+256*r**2*(45*Q2**18*r**2+2*Q2**17*r**2*(127
            +83*r**2)-Q2**16*(552+2593*r**2+31854*r**4+5725*r**6)+Q2**15*(5688
            -2166*r**2+225980*r**4+332122*r**6+38416*r**8)-Q2**14*(25050-76423*r**2
            +551570*r**4+1933616*r**6+1530900*r**8+136535*r**10)+2*Q2**13*(29400
            -173165*r**2-7985*r**4+2029954*r**6+3344428*r**8+1937487*r**10+151585*r**12)
            -Q2**12*(68250-850975*r**2-3812790*r**4+374495*r**6+6242434*r**8+10343875*r**10
            +5399514*r**12+438893*r**14)+2*Q2**11*(-1092-659031*r**2-6582074*r**4
            -9858925*r**6-13728846*r**8-9261317*r**10+979626*r**12+1332977*r**14
            +200330*r**16)+Q2**10*(126126+1245629*r**2+26156762*r**4+58325846*r**6
            +111491258*r**8+130117416*r**10+81426414*r**12+18297522*r**14+4015440*r**16
            -190333*r**18)-2*Q2**9*(85800+204083*r**2+15228995*r**4+42178764*r**6
            +87496680*r**8+128568510*r**10+112897898*r**12+61975780*r**14+15142584*r**16
            +4334495*r**18+715*r**20)+Q2**8*(64350-737495*r**2+10483310*r**4+53860449*r**6
            +59996108*r**8+152135022*r**10+213132940*r**12+165054430*r**14+91800774*r**16
            +23401353*r**18+6985462*r**20+25025*r**22)+2*Q2**7*(42900+677759*r**2
            +12820866*r**4+762275*r**6+109972604*r**8+111349430*r**10+62461164*r**12
            -21646202*r**14-15480580*r**16-16565781*r**18-6637870*r**20-1072137*r**22
            +25844*r**24)+2*(-1+r**2)**6*(201+3152*r**2+178553*r**4-1032672*r**6
            +6084658*r**8-15914992*r**10+8469878*r**12+15508688*r**14-13195015*r**16
            +2205392*r**18-884559*r**20-121680*r**22-5716*r**24+112*r**26)-Q2**6*(126126
            +1060467*r**2+42883502*r**4+2057740*r**6+383093536*r**8+361246199*r**10
            +342567500*r**12+198140992*r**14-60588210*r**16+20859281*r**18-4173114*r**20
            -10039660*r**22+640036*r**24+81445*r**26)-8*Q2*(-1+r**2)**4*(486+6460*r**2
            +368861*r**4-1757202*r**6+9733164*r**8-18776379*r**10-4175798*r**12
            +27017944*r**14+8602354*r**16-18223514*r**18+2883873*r**20-1550182*r**22
            -232100*r**24-10247*r**26+280*r**28)+2*Q2**5*(28392+150385*r**2+12179173*r**4
            -12515054*r**6+129769228*r**8+27943763*r**10+33558637*r**12+34518796*r**14
            +102309184*r**16-45560025*r**18+14190327*r**20+8921410*r**22-2271572*r**24
            +402357*r**26+19159*r**28)+2*Q2**2*(-1+r**2)**2*(7725+86139*r**2+4905884*r**4
            -20393536*r**6+106261857*r**8-165586435*r**10-40123448*r**12+86230214*r**14
            +228390551*r**16+21873077*r**18-167694532*r**20+28165524*r**22-16925733*r**24
            -2874925*r**26-118944*r**28+4582*r**30)+Q2**4*(13650+219493*r**2+4449610*r**4
            -4899281*r**6+35404310*r**8+46425585*r**10+48516934*r**12+95951835*r**14
            +196351422*r**16-332723425*r**18-98192650*r**20-2227*r**22-44188070*r**24
            -4932341*r**26-463110*r**28+7465*r**30)-2*Q2**3*(14700+141485*r**2+7532070*r**4
            -29533309*r**6+140946982*r**8-209180207*r**10+50756270*r**12+31131375*r**14
            -20047882*r**16+260197751*r**18+20959314*r**20-186135175*r**22+43096530*r**24
            -22443509*r**26-4312358*r**28-188907*r**30+8870*r**32))*sqrtq2)*math.log(mu0))/(55987200*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +388800*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3-167961600*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            -6998400*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2*sqrtq2-8100*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+((-5760*logq2**2*r**4*(10*Q2**7*(1+5*r**4)
            -4*Q2**6*(19+26*r**2+77*r**4+80*r**6)+Q2**5*(201+500*r**2+1457*r**4
            +1343*r**6+795*r**8)-Q2**4*(215+758*r**2+2837*r**4+3624*r**6+1980*r**8
            +850*r**10)+2*Q2**3*(10+191*r**2+810*r**4+1147*r**6+1353*r**8+415*r**10
            +50*r**12)+(-1+r**2)**2*(29-10*r**2+507*r**4-2218*r**6-3483*r**8-102*r**10
            +107*r**12+130*r**14)+Q2**2*(150-38*r**2+969*r**4-1368*r**6-2014*r**8
            -274*r**10+295*r**12+600*r**14)+Q2*(-119+86*r**2-1507*r**4+3971*r**6
            +11956*r**8+6170*r**10+135*r**12-27*r**14-505*r**16))-8*(Q2-(-1
            +r)**2)*(Q2-(1+r)**2)*(8*Q2**12+Q2**11*(19+5*r**2)+Q2**10*(69+312*r**2
            +139*r**4)-Q2**9*(2973+1415*r**2+13845*r**4+1655*r**6)+2*Q2**8*(6266
            +521*r**2+16200*r**4+35467*r**6+2610*r**8)-2*Q2**7*(9712-3611*r**2
            -9936*r**4+62186*r**6+66386*r**8+3423*r**10)+2*Q2**6*(2072+1935*r**2
            -61245*r**4-10798*r**6+86420*r**8+26287*r**10+945*r**12)+2*Q2**5*(11672
            -41479*r**2+147396*r**4+209881*r**6+240442*r**8-62343*r**10+78766*r**12
            +2481*r**14)-2*Q2**4*(13201-71075*r**2+299355*r**4+744945*r**6+919905*r**8
            +713699*r**10-54415*r**12+110975*r**14+2610*r**16)+Q2**3*(3893-46947*r**2
            +402420*r**4+1147164*r**6+2150370*r**8+1441802*r**10+967372*r**12+3940*r**14
            +58121*r**16+505*r**18)+2*(-1+r**2)**2*(731-9790*r**2+106706*r**4-300958*r**6
            +144348*r**8-301378*r**10-524770*r**12+302334*r**14-29527*r**16+7392*r**18
            +112*r**20)+Q2**2*(10491-84742*r**2+442083*r**4-100472*r**6+770418*r**8
            -528204*r**10-289358*r**12+1166712*r**14-258093*r**16+78802*r**18+1963*r**20)
            +Q2*(-7163+83965*r**2-710695*r**4+1148445*r**6+456510*r**8+1378846*r**10
            +1630950*r**12+2565390*r**14-1921475*r**16+278885*r**18-64063*r**20
            -1195*r**22))-172800*logq2**3*r**8*(3+5*r**2-65*r**4+r**6)*sqrtq2-48*logq2*(92*Q2**10*(1
            +5*r**4)-20*Q2**9*(29+15*r**2+105*r**4+175*r**6)+5*Q2**8*(279+271*r**2
            +205*r**4+2715*r**6+2010*r**8)-10*Q2**7*(132+259*r**2-766*r**4+668*r**6
            +3002*r**8+1185*r**10)-10*Q2**6*(42-335*r**2+2345*r**4+3050*r**6+2732*r**8
            -2147*r**10+105*r**12)+2*Q2**5*(1008-1895*r**2+25330*r**4+86925*r**6
            +128000*r**8+85343*r**10+7950*r**12+8715*r**14)-10*Q2**4*(147-230*r**2
            +6386*r**4+37548*r**6+74256*r**8+63236*r**10+26280*r**12+3650*r**14
            +1575*r**16)+10*Q2**3*(-12+167*r**2+1354*r**4+25306*r**6+51738*r**8
            +66076*r**10+43574*r**12+6870*r**14+2450*r**16+45*r**18)+10*Q2**2*(72
            -391*r**2+5303*r**4+3264*r**6+11020*r**8-2606*r**10-21870*r**12+6408*r**14
            +19188*r**16-963*r**18+735*r**20)+(-1+r**2)**2*(67-401*r**2+13526*r**4
            +9618*r**6-128500*r**8-158132*r**10-447154*r**12+51694*r**14+52977*r**16
            +645*r**18+860*r**20)-10*Q2*(38-245*r**2+5136*r**4+3913*r**6-15952*r**8
            -85914*r**10-97164*r**12-75350*r**14+4778*r**16+18783*r**18-388*r**20
            +445*r**22))*sqrtq2)*math.log(mus))/(104976*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+243*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-419904*logq2**3*r**12*sqrtq2
            -8748*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((5760*logq2**2*r**4*(10*Q2**7*(1
            +5*r**4)-4*Q2**6*(19+26*r**2+77*r**4+80*r**6)+Q2**5*(201+500*r**2
            +1457*r**4+1343*r**6+795*r**8)-Q2**4*(215+758*r**2+2837*r**4+3624*r**6
            +1980*r**8+850*r**10)+2*Q2**3*(10+191*r**2+810*r**4+1147*r**6+1353*r**8
            +415*r**10+50*r**12)+(-1+r**2)**2*(29-10*r**2+507*r**4-2218*r**6-3483*r**8
            -102*r**10+107*r**12+130*r**14)+Q2**2*(150-38*r**2+969*r**4-1368*r**6
            -2014*r**8-274*r**10+295*r**12+600*r**14)+Q2*(-119+86*r**2-1507*r**4
            +3971*r**6+11956*r**8+6170*r**10+135*r**12-27*r**14-505*r**16))+8*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**12+Q2**11*(19+5*r**2)+Q2**10*(69
            +312*r**2+139*r**4)-Q2**9*(2973+1415*r**2+13845*r**4+1655*r**6)+2*Q2**8*(6266
            +521*r**2+16200*r**4+35467*r**6+2610*r**8)-2*Q2**7*(9712-3611*r**2
            -9936*r**4+62186*r**6+66386*r**8+3423*r**10)+2*Q2**6*(2072+1935*r**2
            -61245*r**4-10798*r**6+86420*r**8+26287*r**10+945*r**12)+2*Q2**5*(11672
            -41479*r**2+147396*r**4+209881*r**6+240442*r**8-62343*r**10+78766*r**12
            +2481*r**14)-2*Q2**4*(13201-71075*r**2+299355*r**4+744945*r**6+919905*r**8
            +713699*r**10-54415*r**12+110975*r**14+2610*r**16)+Q2**3*(3893-46947*r**2
            +402420*r**4+1147164*r**6+2150370*r**8+1441802*r**10+967372*r**12+3940*r**14
            +58121*r**16+505*r**18)+2*(-1+r**2)**2*(731-9790*r**2+106706*r**4-300958*r**6
            +144348*r**8-301378*r**10-524770*r**12+302334*r**14-29527*r**16+7392*r**18
            +112*r**20)+Q2**2*(10491-84742*r**2+442083*r**4-100472*r**6+770418*r**8
            -528204*r**10-289358*r**12+1166712*r**14-258093*r**16+78802*r**18+1963*r**20)
            +Q2*(-7163+83965*r**2-710695*r**4+1148445*r**6+456510*r**8+1378846*r**10
            +1630950*r**12+2565390*r**14-1921475*r**16+278885*r**18-64063*r**20
            -1195*r**22))+172800*logq2**3*r**8*(3+5*r**2-65*r**4+r**6)*sqrtq2+48*logq2*(92*Q2**10*(1
            +5*r**4)-20*Q2**9*(29+15*r**2+105*r**4+175*r**6)+5*Q2**8*(279+271*r**2
            +205*r**4+2715*r**6+2010*r**8)-10*Q2**7*(132+259*r**2-766*r**4+668*r**6
            +3002*r**8+1185*r**10)-10*Q2**6*(42-335*r**2+2345*r**4+3050*r**6+2732*r**8
            -2147*r**10+105*r**12)+2*Q2**5*(1008-1895*r**2+25330*r**4+86925*r**6
            +128000*r**8+85343*r**10+7950*r**12+8715*r**14)-10*Q2**4*(147-230*r**2
            +6386*r**4+37548*r**6+74256*r**8+63236*r**10+26280*r**12+3650*r**14
            +1575*r**16)+10*Q2**3*(-12+167*r**2+1354*r**4+25306*r**6+51738*r**8
            +66076*r**10+43574*r**12+6870*r**14+2450*r**16+45*r**18)+10*Q2**2*(72
            -391*r**2+5303*r**4+3264*r**6+11020*r**8-2606*r**10-21870*r**12+6408*r**14
            +19188*r**16-963*r**18+735*r**20)+(-1+r**2)**2*(67-401*r**2+13526*r**4
            +9618*r**6-128500*r**8-158132*r**10-447154*r**12+51694*r**14+52977*r**16
            +645*r**18+860*r**20)-10*Q2*(38-245*r**2+5136*r**4+3913*r**6-15952*r**8
            -85914*r**10-97164*r**12-75350*r**14+4778*r**16+18783*r**18-388*r**20
            +445*r**22))*sqrtq2)*math.log(2*muWC))/(97200*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+225*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-388800*logq2**3*r**12*sqrtq2
            -8100*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((276480*logq2**3*r**10*(
            -20*Q2**9*(49+125*r**4)+8*Q2**8*(1176+1237*r**2+2550*r**4+1815*r**6)
            -Q2**7*(36279+68387*r**2+102183*r**4+83965*r**6+29610*r**8)+Q2**6*(71439
            +175108*r**2+270534*r**4+235148*r**6+109395*r**8+19560*r**10)+Q2**5*(
            -70143-199027*r**2-314178*r**4-308040*r**6-162521*r**8-47325*r**10
            +930*r**12)+(-1+r**2)**4*(-3547-816*r**2+1009*r**4-12236*r**6+519*r**8
            -23424*r**10+10915*r**12+12220*r**14)+Q2**4*(13815+79780*r**2+103923*r**4
            +113256*r**6+69345*r**8+26480*r**10+58325*r**12+36900*r**14)+Q2**3*(42627
            +8359*r**2+43473*r**4+104259*r**6+39791*r**8+3637*r**10+20659*r**12
            -115935*r**14-114870*r**16)-Q2*(-1+r**2)**2*(-20871-3709*r**2-5471*r**4
            -92611*r**6-13791*r**8-31795*r**10-68537*r**12+50995*r**14+62910*r**16)
            +Q2**2*(-47211+18932*r**2-21384*r**4-167016*r**6-110666*r**8+41460*r**10
            +32472*r**12-140352*r**14+22245*r**16+125760*r**18))+384*logq2*(-Q2
            +(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-92*Q2**15*(-1+115*r**4)+8*Q2**14*(
            -107-450*r**2+9859*r**4+15140*r**6)+Q2**13*(3319+25503*r**2-171565*r**4
            -822831*r**6-575890*r**8)+Q2**12*(-6481-87980*r**2-173338*r**4+1764908*r**6
            +3110707*r**8+1463800*r**10)+Q2**11*(4894+231956*r**2+2303502*r**4+408778*r**6
            -1259480*r**8-4907702*r**10-2035660*r**12)+2*Q2**10*(2629-265667*r**2
            -4283828*r**4-6633710*r**6-13145097*r**8-10993189*r**10+140712*r**12
            +562310*r**14)+Q2**9*(-15763+883915*r**2+18145241*r**4+42177201*r**6
            +96402305*r**8+128692457*r**10+75809171*r**12+10706651*r**14+911110*r**16)
            -Q2**8*(-12837+779406*r**2+19625730*r**4+65271362*r**6+153252172*r**8
            +259817318*r**10+228344358*r**12+105423654*r**14+16792593*r**16+1975620*r**18)
            +4*Q2**7*(528-24720*r**2+205764*r**4+10462775*r**6+8369349*r**8+37861503*r**10
            +54728965*r**12+39036459*r**14+16974345*r**16+3070359*r**18+278625*r**20)
            +4*Q2**6*(-3047+256077*r**2+6304694*r**4+2587290*r**6+70119994*r**8
            +87597584*r**10+51139698*r**12-1237616*r**14-1268715*r**16-5677421*r**18
            -1511184*r**20+48230*r**22)-Q2**5*(-8833+998427*r**2+29067083*r**4+26870589*r**6
            +440637156*r**8+666628774*r**10+603457182*r**12+281228810*r**14-47494441*r**16
            +38115551*r**18-14557161*r**20-3546727*r**22+526150*r**24)+(-1+r**2)**4*(67
            -13746*r**2-581792*r**4+1339910*r**6-21856969*r**8+42078368*r**10+62147360*r**12
            -154685612*r**14+2452265*r**16+54025654*r**18-771200*r**20+4539046*r**22
            +266589*r**24+860*r**26)+Q2**4*(-631+227160*r**2+8761762*r**4+13710104*r**6
            +195788615*r**8+324933272*r**10+176916756*r**12+237048616*r**14+133405791*r**16
            -70401600*r**18+30795594*r**20+4436704*r**22-453423*r**24+201520*r**26)
            +Q2*(-1+r**2)**2*(-581+101799*r**2+3839826*r**4-8917560*r**6+126244043*r**8
            -174838109*r**10-252125938*r**12+304828944*r**14+404593497*r**16-33584603*r**18
            -264993330*r**20+8827944*r**22-23899615*r**24-1604207*r**26+1490*r**28)
            +2*Q2**3*(-1453+153814*r**2+4314635*r**4-8995291*r**6+84611606*r**8
            -50909039*r**10+86923096*r**12+67069478*r**14+27065979*r**16-113674516*r**18
            -123054513*r**20-4994635*r**22-20771428*r**24-1658963*r**26+7630*r**28)
            -2*Q2**2*(-997+144895*r**2+4726884*r**4-13375746*r**6+136866999*r**8
            -197308501*r**10-14814500*r**12+67380662*r**14+86031457*r**16+181838397*r**18
            +65239228*r**20-226391990*r**22+22885709*r**24-22921831*r**26-1838716*r**28
            +11650*r**30))+16588800*logq2**4*r**14*(-75-65*r**2+65*r**4+11*r**6)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+4608*logq2**2*r**6*(-8*Q2**12*(1127
            +5755*r**4)+8*Q2**11*(10019+8329*r**2+45405*r**4+48985*r**6)-Q2**10*(296501
            +460703*r**2+1504791*r**4+2467325*r**6+1393840*r**8)+10*Q2**9*(56087
            +126378*r**2+367466*r**4+707324*r**6+654063*r**8+264850*r**10)-5*Q2**8*(93489
            +324025*r**2+778474*r**4+1964498*r**6+2305381*r**8+1635581*r**10+571320*r**12)
            +2*Q2**7*(-90564+311060*r**2-1986055*r**4-1542950*r**6+294400*r**8+2281066*r**10
            +2089075*r**12+901440*r**14)+Q2**6*(809046+814786*r**2+18067740*r**4
            +34547240*r**6+37093650*r**8+19196846*r**10+2914876*r**12+284840*r**14
            -910560*r**16)+2*Q2**5*(-357294-574672*r**2-11085319*r**4-23890510*r**6
            -28819515*r**8-20939244*r**10-6372537*r**12+702686*r**14-483335*r**16
            +262140*r**18)+10*Q2**4*(10623+68227*r**2+724639*r**4+2142835*r**6+2012525*r**8
            +1781685*r**10+1084041*r**12+705249*r**14+300896*r**16+92852*r**18+36300*r**20)
            +(-1+r**2)**4*(-11561-6997*r**2-1021818*r**4+1144526*r**6+2676940*r**8
            -2945724*r**10-5470078*r**12+1007218*r**14+2921949*r**16+229585*r**18
            +93560*r**20)-10*Q2**3*(-28192+44600*r**2-1046027*r**4+260822*r**6-395374*r**8
            -1463054*r**10-695924*r**12-349250*r**14+1745790*r**16+2192062*r**18
            +128527*r**20+135940*r**22)-2*Q2*(-1+r**2)**2*(-42451+14332*r**2-2987270*r**4
            +2231718*r**6+5352856*r**8-4653664*r**10-8078022*r**12-8556860*r**14
            +3106427*r**16+7362964*r**18+440460*r**20+279910*r**22)+Q2**2*(-242881
            +385805*r**2-13279925*r**4+13529365*r**6+6077650*r**8-19709658*r**10
            -9717310*r**12+908110*r**14-25980945*r**16-2787555*r**18+26889059*r**20
            +507725*r**22+1302160*r**24))*sqrtq2-64*r**2*(-8*Q2**19+Q2**18*(21+575*r**2)
            +2*Q2**17*(-23+1380*r**2+903*r**4)-Q2**16*(3437+27997*r**2+366307*r**4
            +66355*r**6)+Q2**15*(40373-52542*r**2+2597324*r**4+3832566*r**6+446311*r**8)
            -Q2**14*(191391-1028349*r**2+6299386*r**4+22364162*r**6+17709655*r**8
            +1589931*r**10)+Q2**13*(476897-4413570*r**2-465011*r**4+47006528*r**6
            +77461959*r**8+44962930*r**10+3547355*r**12)-Q2**12*(599547-10660621*r**2
            -45152471*r**4+3747913*r**6+70515317*r**8+118949341*r**10+63040759*r**12
            +5184023*r**14)+Q2**11*(72241-16779462*r**2-155822282*r**4-231619950*r**6
            -328504316*r**8-228286826*r**10+17645514*r**12+32132350*r**14+4828395*r**16)
            +Q2**10*(963391+17023039*r**2+310137864*r**4+681498824*r**6+1312291546*r**8
            +1549528154*r**10+981189656*r**12+224637592*r**14+44796279*r**16-2435433*r**18)
            +Q2**9*(-1434719-7542458*r**2-361089913*r**4-978563476*r**6-2034322230*r**8
            -3019782096*r**10-2679448578*r**12-1487144748*r**14-367332811*r**16-99598070*r**18
            +154011*r**20)+Q2**8*(634543-8245545*r**2+126021327*r**4+614969599*r**6
            +637855962*r**8+1706620586*r**10+2449063130*r**12+1939946042*r**14+1101173319*r**16
            +279414607*r**18+82485447*r**20+249015*r**22)+Q2**7*(615407+19549318*r**2
            +294219280*r**4+31577786*r**6+2724254719*r**8+2867282636*r**10+1743752456*r**12
            -338526716*r**14-324067699*r**16-411168946*r**18-146505560*r**20-28507742*r**22
            +544453*r**24)+2*(-1+r**2)**6*(1681+52731*r**2+1972517*r**4-11413425*r**6
            +71521574*r**8-191881502*r**10+101365054*r**12+179874538*r**14-159566327*r**16
            +28891731*r**18-11072099*r**20-1378105*r**22-75200*r**24+1232*r**26)
            -Q2**6*(1019621+17649345*r**2+490075970*r**4+38371370*r**6+4708634163*r**8
            +4631936775*r**10+4550912124*r**12+2768841516*r**14-479200965*r**16+320377023*r**18
            -84677598*r**20-100974838*r**22+3951309*r**24+883225*r**26)-Q2*(-1
            +r**2)**4*(32183+890178*r**2+32665155*r**4-155624016*r**6+925774531*r**8
            -1829435894*r**10-422495953*r**12+2523331424*r**14+738135317*r**16-1745286426*r**18
            +309014681*r**20-155998480*r**22-20854159*r**24-1107506*r**26+24565*r**28)
            +Q2**5*(494499+6133338*r**2+275310595*r**4-276850776*r**6+3199028995*r**8
            +866015090*r**10+1053657515*r**12+1115119808*r**14+2686124369*r**16-963190786*r**18
            +410506913*r**20+184631704*r**22-43215991*r**24+8028214*r**26+426033*r**28)
            +2*Q2**2*(-1+r**2)**2*(62968+1542899*r**2+54257464*r**4-226177345*r**6
            +1270602070*r**8-2013972895*r**10-540358998*r**12+929905113*r**14+2619749292*r**16
            +164708453*r**18-1997292860*r**20+383857169*r**22-215237882*r**24-31899577*r**26
            -1664678*r**28+50007*r**30)+Q2**4*(86743+3433359*r**2+49877849*r**4
            -53052487*r**6+423266935*r**8+542338447*r**10+588486737*r**12+1151751217*r**14
            +2268050589*r**16-4061787835*r**18-1102815293*r**20+18513379*r**22-540403691*r**24
            -55984227*r**26-5980525*r**28+74803*r**30)-Q2**3*(232461+5278210*r**2
            +165734066*r**4-655959998*r**6+3365737146*r**8-5052220894*r**10+1121301050*r**12
            +431064978*r**14-720600524*r**16+6096256438*r**18+261896310*r**20-4445437930*r**22
            +1167831606*r**24-579989978*r**26-94228834*r**28-5402602*r**30+191695*r**32))*sqrtq2)*math.log(r))/(167961600*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +1166400*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3-503884800*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            -20995200*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2*sqrtq2-24300*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2))+muWC*((pi2*(-32*r**2*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-13+4*Q2**10+404*r**2-6453*r**4-53600*r**6-142382*r**8
            +644712*r**10-641774*r**12+323008*r**14-51045*r**16+13412*r**18+131*r**20
            +7*Q2**9*(1+r**2)+3*Q2**8*(-41+102*r**2+47*r**4)-6*Q2**7*(-57+312*r**2
            +1834*r**4+145*r**6)+6*Q2**6*(-63+623*r**2+7092*r**4+6423*r**6+249*r**8)
            -6*Q2**5*(-14+369*r**2+6937*r**4+16621*r**6+4867*r**8+80*r**10)-2*Q2**4*(
            -84+891*r**2+4110*r**4-10306*r**6-20622*r**8+23091*r**10+576*r**12)
            +2*Q2**3*(-51+1152*r**2+8712*r**4-14165*r**6+78457*r**8+13926*r**10
            +36702*r**12+507*r**14)+6*Q2**2*(-7+57*r**2+354*r**4+10083*r**6+11218*r**8
            -19285*r**10-5374*r**12-1151*r**14+25*r**16)+Q2*(53-1233*r**2+5058*r**4
            +62878*r**6-3216*r**8+163512*r**10-224402*r**12+73362*r**14-32373*r**16
            -439*r**18))+32*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(13+4*Q2**11
            -391*r**2+6049*r**4+60053*r**6+195982*r**8-502330*r**10-2938*r**12
            +318766*r**14-271963*r**16+37633*r**18-13543*r**20-131*r**22+3*Q2**10*(1
            +r**2)+2*Q2**9*(-65+146*r**2+67*r**4)-3*Q2**8*(-155+685*r**2+3817*r**4
            +337*r**6)+12*Q2**7*(-60+439*r**2+4619*r**4+4201*r**6+197*r**8)-6*Q2**6*(
            -77+929*r**2+14652*r**4+30136*r**6+11539*r**8+329*r**10)-4*Q2**5*(
            -21-87*r**2-8904*r**4-40490*r**6-42543*r**8+4125*r**10+168*r**12)
            +6*Q2**4*(-45+653*r**2+4571*r**4-6787*r**6+15843*r**8+5465*r**10+20123*r**12
            +361*r**14)-4*Q2**3*(-15+465*r**2+4401*r**4-17851*r**6+15319*r**8+75119*r**10
            +33375*r**12+20331*r**14+216*r**16)+Q2**2*(95-1533*r**2+2592*r**4+256*r**6
            -131022*r**8+211914*r**10-76448*r**12+112512*r**14-25617*r**16-589*r**18)
            +6*Q2*(-11+264*r**2-1713*r**4-20256*r**6-33674*r**8+80736*r**10-96814*r**12
            +79008*r**14-15339*r**16+7704*r**18+95*r**20))*sqrtq2+logq2**3*(-1382400*(
            -Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(-3+5*r**2)*(-Q2+(1+r)**2)-1382400*r**14*(
            -3+5*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**2*(-23040*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-163+40*Q2**5+26*r**2+106*r**4+466*r**6
            -179*r**8+104*r**10-4*Q2**4*(17+44*r**2)+Q2**3*(-23+141*r**2+244*r**4)
            +Q2**2*(17+122*r**2-167*r**4-16*r**6)+Q2*(197-143*r**2-11*r**4+213*r**6
            -196*r**8))-23040*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(
            -163+40*Q2**5+26*r**2+106*r**4+466*r**6-179*r**8+104*r**10-4*Q2**4*(17
            +44*r**2)+Q2**3*(-23+141*r**2+244*r**4)+Q2**2*(17+122*r**2-167*r**4
            -16*r**6)+Q2*(197-143*r**2-11*r**4+213*r**6-196*r**8))*sqrtq2)+logq2*(
            -384*r**6*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(39+184*Q2**8
            -3867*r**2-25973*r**4+50081*r**6-3175*r**8-8589*r**10+11917*r**12+823*r**14
            +344*r**16-8*Q2**7*(149+129*r**2)+Q2**6*(2367+5475*r**2+1772*r**4)
            -2*Q2**5*(667+3104*r**2+3119*r**4+82*r**6)-Q2**4*(895-535*r**2+7961*r**4
            +3335*r**6+2520*r**8)+4*Q2**3*(249-390*r**2+1196*r**4+6626*r**6+2435*r**8
            +524*r**10)+Q2**2*(97+1297*r**2+15474*r**4-10226*r**6-7811*r**8-3923*r**10
            +412*r**12)-2*Q2*(131-2680*r**2-9071*r**4+10450*r**6-13055*r**8+9404*r**10
            +675*r**12+546*r**14))-384*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(39
            +184*Q2**8-3867*r**2-25973*r**4+50081*r**6-3175*r**8-8589*r**10+11917*r**12
            +823*r**14+344*r**16-8*Q2**7*(149+129*r**2)+Q2**6*(2367+5475*r**2+1772*r**4)
            -2*Q2**5*(667+3104*r**2+3119*r**4+82*r**6)-Q2**4*(895-535*r**2+7961*r**4
            +3335*r**6+2520*r**8)+4*Q2**3*(249-390*r**2+1196*r**4+6626*r**6+2435*r**8
            +524*r**10)+Q2**2*(97+1297*r**2+15474*r**4-10226*r**6-7811*r**8-3923*r**10
            +412*r**12)-2*Q2*(131-2680*r**2-9071*r**4+10450*r**6-13055*r**8+9404*r**10
            +675*r**12+546*r**14))*sqrtq2)))/(-2700*(-Q2+(-1+r)**2)*r**2*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-2700*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(
            -4665600*r**14*(-1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2
            +3*r**4))+4665600*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**2*(-1166400*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))-1166400*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1
            +r)**2)*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)
            +logq2*(97200*(-Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+97200*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2))+(-64*(Q2-(-1+r)**2)**4*r**4*(1-Q2
            +r**2)*(Q2-(1+r)**2)**4*(732*Q2**15-Q2**14*(915+307*r**2)+24*Q2**13*(
            -1037+2450*r**2+1352*r**4)-Q2**12*(-134139+539759*r**2+3056747*r**4
            +331505*r**6)+4*Q2**11*(-75396+493624*r**2+5096803*r**4+4786618*r**6
            +294703*r**8)-Q2**10*(-299937+3333975*r**2+51386990*r**4+95071166*r**6
            +45395387*r**8+1911699*r**10)+4*Q2**9*(10065+350816*r**2+12294990*r**4
            +40424674*r**6+39151909*r**8+7972530*r**10+241016*r**12)+Q2**8*(-428769
            +4034685*r**2+15565839*r**4-108278811*r**6-127375955*r**8-73028985*r**10
            +52773765*r**12+1391799*r**14)-12*Q2**7*(-34221+554976*r**2+5537398*r**4
            -5776596*r**6-8028352*r**8+596072*r**10+3928870*r**12+9367588*r**14
            +185865*r**16)+Q2**6*(-58377+2448663*r**2+39310716*r**4-86370324*r**6
            -261474814*r**8-164102494*r**10-49726612*r**12+91286076*r**14+44084271*r**16
            +394671*r**18)+16*Q2**5*(-10065+173815*r**2+63165*r**4-4007325*r**6
            +9888004*r**8-1167493*r**10-15344137*r**12+4756135*r**14-14354145*r**16
            +3981744*r**18+87622*r**20)-Q2**4*(-97905+2787357*r**2+1913085*r**4
            -206155689*r**6+11079606*r**8+179145202*r**10-871280582*r**12-916830818*r**14
            +36559611*r**16-330773199*r**18+71076105*r**20+1112907*r**22)+4*Q2**3*(4758
            -8440*r**2-2953*r**4-19747126*r**6+22349585*r**8+139188040*r**10-22193190*r**12
            -71277084*r**14-119974364*r**16+3439280*r**18-24232273*r**20+2526290*r**22
            +2357*r**24)+(-1+r**2)**2*(-2379+94777*r**2-1931242*r**4-9321610*r**6
            +18593535*r**8+497794723*r**10-1438349564*r**12+1101402724*r**14-150631085*r**16
            -333434465*r**18+74989926*r**20-33949018*r**22+2037113*r**24+28165*r**26)
            +Q2**2*(-41541+1147571*r**2-8818702*r**4-61264462*r**6+21789081*r**8
            +546964801*r**10+502310860*r**12-310670356*r**14-224616563*r**16-686031371*r**18
            +253551810*r**20-174996766*r**22+19699103*r**24+362135*r**26)-4*Q2*(
            -4209+148296*r**2-2068118*r**4-10866578*r**6+28375477*r**8+285717998*r**10
            -513307252*r**12-171701404*r**14+351509321*r**16-13685044*r**18-285616054*r**20
            +94984366*r**22-39086093*r**24+2876542*r**26+44352*r**28))-64*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(732*Q2**15-Q2**14*(915+307*r**2)+24*Q2**13*(
            -1037+2450*r**2+1352*r**4)-Q2**12*(-134139+539759*r**2+3056747*r**4
            +331505*r**6)+4*Q2**11*(-75396+493624*r**2+5096803*r**4+4786618*r**6
            +294703*r**8)-Q2**10*(-299937+3333975*r**2+51386990*r**4+95071166*r**6
            +45395387*r**8+1911699*r**10)+4*Q2**9*(10065+350816*r**2+12294990*r**4
            +40424674*r**6+39151909*r**8+7972530*r**10+241016*r**12)+Q2**8*(-428769
            +4034685*r**2+15565839*r**4-108278811*r**6-127375955*r**8-73028985*r**10
            +52773765*r**12+1391799*r**14)-12*Q2**7*(-34221+554976*r**2+5537398*r**4
            -5776596*r**6-8028352*r**8+596072*r**10+3928870*r**12+9367588*r**14
            +185865*r**16)+Q2**6*(-58377+2448663*r**2+39310716*r**4-86370324*r**6
            -261474814*r**8-164102494*r**10-49726612*r**12+91286076*r**14+44084271*r**16
            +394671*r**18)+16*Q2**5*(-10065+173815*r**2+63165*r**4-4007325*r**6
            +9888004*r**8-1167493*r**10-15344137*r**12+4756135*r**14-14354145*r**16
            +3981744*r**18+87622*r**20)-Q2**4*(-97905+2787357*r**2+1913085*r**4
            -206155689*r**6+11079606*r**8+179145202*r**10-871280582*r**12-916830818*r**14
            +36559611*r**16-330773199*r**18+71076105*r**20+1112907*r**22)+4*Q2**3*(4758
            -8440*r**2-2953*r**4-19747126*r**6+22349585*r**8+139188040*r**10-22193190*r**12
            -71277084*r**14-119974364*r**16+3439280*r**18-24232273*r**20+2526290*r**22
            +2357*r**24)+(-1+r**2)**2*(-2379+94777*r**2-1931242*r**4-9321610*r**6
            +18593535*r**8+497794723*r**10-1438349564*r**12+1101402724*r**14-150631085*r**16
            -333434465*r**18+74989926*r**20-33949018*r**22+2037113*r**24+28165*r**26)
            +Q2**2*(-41541+1147571*r**2-8818702*r**4-61264462*r**6+21789081*r**8
            +546964801*r**10+502310860*r**12-310670356*r**14-224616563*r**16-686031371*r**18
            +253551810*r**20-174996766*r**22+19699103*r**24+362135*r**26)-4*Q2*(
            -4209+148296*r**2-2068118*r**4-10866578*r**6+28375477*r**8+285717998*r**10
            -513307252*r**12-171701404*r**14+351509321*r**16-13685044*r**18-285616054*r**20
            +94984366*r**22-39086093*r**24+2876542*r**26+44352*r**28))*sqrtq2+logq2**4*(33177600*r**20*(1
            -Q2+r**2)*(-549+1075*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+33177600*r**20*(
            -549+1075*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**3*(1105920*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(2380*Q2**7-2*Q2**6*(4403+9344*r**2)
            +2*Q2**5*(5958+17957*r**2+27369*r**4)-Q2**4*(8735+4818*r**2+46359*r**4
            +66380*r**6)+Q2**3*(13955-23753*r**2+2633*r**4+16141*r**6+5720*r**8)
            +2*(-1+r**2)**2*(-3443-7222*r**2+11988*r**4+33948*r**6-11797*r**8+8086*r**10)
            +Q2**2*(-26505-13228*r**2+8882*r**4+61220*r**6-40129*r**8+64080*r**10)
            +Q2*(22681+25245*r**2-412*r**4-171462*r**6-169687*r**8+99177*r**10
            -58022*r**12))-1105920*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(2380*Q2**8
            -2*Q2**7*(5593+10534*r**2)+Q2**6*(20722+63408*r**2+73426*r**4)-Q2**5*(20651
            +52648*r**2+137011*r**4+121118*r**6)+10*Q2**4*(2269-1020*r**2+5381*r**4
            +12888*r**6+7210*r**8)+Q2**3*(-40460-3430*r**2+30002*r**4+42446*r**6
            -61990*r**8+58360*r**10)+Q2**2*(49186+64978*r**2+3934*r**4-241564*r**6
            -190778*r**8+75226*r**10-122102*r**12)-2*(-1+r**2)**2*(-3443-10665*r**2
            +4766*r**4+45936*r**6+22151*r**8-3711*r**10+8086*r**12)+Q2*(-29567
            -48598*r**2+21145*r**4+177374*r**6+205739*r**8+201766*r**10-97093*r**12
            +74194*r**14))*sqrtq2)+logq2**2*(92160*r**12*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3*(-5208*Q2**10+Q2**9*(20654+33464*r**2)-Q2**8*(13443
            +66487*r**2+84264*r**4)+Q2**7*(-44595-48898*r**2+63281*r**4+97596*r**6)
            -2*Q2**6*(-23514-86205*r**2+94622*r**4+73737*r**6+19308*r**8)+Q2**5*(89157
            -87760*r**2+561396*r**4+1459560*r**6+610019*r**8-14604*r**10)+2*Q2**4*(
            -79047+14443*r**2-19754*r**4-582600*r**6-1112081*r**8-454037*r**10
            +6048*r**12)+Q2**3*(3903+115422*r**2-254611*r**4-459068*r**6+526021*r**8
            +382778*r**10+301167*r**12-13116*r**14)+(-1+r**2)**2*(25561-155793*r**2
            -342059*r**4+865099*r**6+359511*r**8-100775*r**10+358099*r**12+119805*r**14
            +6712*r**16)+2*Q2**2*(71790-272171*r**2-364944*r**4+28509*r**6+206338*r**8
            -262461*r**10+763800*r**12+223027*r**14+15792*r**16)-Q2*(108543-604220*r**2
            -677750*r**4+1132656*r**6+1225888*r**8+3252064*r**10-1363098*r**12+1019392*r**14
            +425521*r**16+25644*r**18))-92160*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(5208*Q2**10-2*Q2**9*(10327+16732*r**2)+Q2**8*(13443+66487*r**2
            +84264*r**4)+Q2**7*(44595+48898*r**2-63281*r**4-97596*r**6)+2*Q2**6*(
            -23514-86205*r**2+94622*r**4+73737*r**6+19308*r**8)+Q2**5*(-89157+87760*r**2
            -561396*r**4-1459560*r**6-610019*r**8+14604*r**10)+2*Q2**4*(79047-14443*r**2
            +19754*r**4+582600*r**6+1112081*r**8+454037*r**10-6048*r**12)+Q2**3*(
            -3903-115422*r**2+254611*r**4+459068*r**6-526021*r**8-382778*r**10
            -301167*r**12+13116*r**14)-(-1+r**2)**2*(25561-155793*r**2-342059*r**4
            +865099*r**6+359511*r**8-100775*r**10+358099*r**12+119805*r**14+6712*r**16)
            -2*Q2**2*(71790-272171*r**2-364944*r**4+28509*r**6+206338*r**8-262461*r**10
            +763800*r**12+223027*r**14+15792*r**16)+Q2*(108543-604220*r**2-677750*r**4
            +1132656*r**6+1225888*r**8+3252064*r**10-1363098*r**12+1019392*r**14
            +425521*r**16+25644*r**18))*sqrtq2)+logq2*(-1536*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(22724*Q2**13-2*Q2**12*(107683+100180*r**2)+2*Q2**11*(389702
            +794431*r**2+340475*r**4)-Q2**10*(1291297+4379766*r**2+4206465*r**4
            +1003804*r**6)+Q2**9*(608445+5066279*r**2+6683169*r**4+4101869*r**6
            +113430*r**8)+2*Q2**8*(584391-979038*r**2-1796360*r**4+333760*r**6+811617*r**8
            +834186*r**10)-4*Q2**7*(481617-25896*r**2-2221733*r**4-581110*r**6+1780477*r**8
            +1695036*r**10+499185*r**12)+2*Q2**6*(370761+117930*r**2-8581295*r**4
            -8677900*r**6-1208755*r**8+1938826*r**10+2819925*r**12+36420*r**14)
            +2*Q2**5*(268557-1978707*r**2-514133*r**4+5562959*r**6-25718167*r**8
            -17962423*r**10-6001937*r**12-1323933*r**14+786264*r**16)+2*Q2**4*(-266635
            +2971248*r**2+10257208*r**4-14952672*r**6+19847086*r**8+66810376*r**10
            +32715168*r**12+12892408*r**14+562053*r**16-565840*r**18)-2*Q2**3*(-16072
            +482387*r**2+3670325*r**4-15413100*r**6-5675912*r**8-5952806*r**10+29736418*r**12
            +7344780*r**14+6591920*r**16-513133*r**18+23273*r**20)+2*(-1+r**2)**2*(2379
            -282352*r**2-868435*r**4+15878090*r**6-15413390*r**8-35970688*r**10
            +46092734*r**12-29835620*r**14-545245*r**16-1643440*r**18-152971*r**20
            +15738*r**22)+Q2**2*(117959-3533774*r**2-8127857*r**4+62604180*r**6
            +21621842*r**8-5567844*r**10+33628194*r**12-92597608*r**14-23653785*r**16
            -8785742*r**18-2559665*r**20+415700*r**22)+Q2*(-46451+2631303*r**2
            +5295785*r**4-98050395*r**6+82647260*r**8+61136882*r**10+156400654*r**12
            -184083850*r**14+140481665*r**16+3571335*r**18+10326089*r**20+1674213*r**22
            -198890*r**24))+1536*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(22724*Q2**14
            -2*Q2**13*(119045+111542*r**2)+6*Q2**12*(165795+334098*r**2+146885*r**4)
            -Q2**11*(2070701+6748032*r**2+6476277*r**4+1684754*r**6)+2*Q2**10*(949871
            +5368671*r**2+7634700*r**4+4656069*r**6+558617*r**8)+Q2**9*(560337-7632800*r**2
            -15342168*r**4-10117518*r**6-2592065*r**8+1554942*r**10)-6*Q2**8*(515875
            -148813*r**2-2406288*r**4-874940*r**6+1568777*r**8+1678625*r**10+610852*r**12)
            +2*Q2**7*(1333995+1029372*r**2-13076553*r**4-14283586*r**6+1189979*r**8
            +8889852*r**10+7208367*r**12+1034790*r**14)+4*Q2**6*(-51102-1233699*r**2
            +3974616*r**4+11411077*r**6-7915756*r**8-9346247*r**10-5380344*r**12
            -2090139*r**14+374922*r**16)-4*Q2**5*(267596-2340699*r**2-6375024*r**4
            +10000749*r**6-20001147*r**8-55245483*r**10-28339764*r**12-10109139*r**14
            -549861*r**16+676052*r**18)+2*Q2**4*(282707-3187000*r**2-16898781*r**4
            +20108564*r**6+781498*r**8-80704656*r**10-129261962*r**12-52952356*r**14
            -20046381*r**16+516920*r**18+542567*r**20)+Q2**3*(85815-2601144*r**2
            +177567*r**4+39118630*r**6-20556182*r**8-28825280*r**10+81195418*r**12
            -18435212*r**14+4219615*r**16+3371832*r**18-3539385*r**20+462246*r**22)
            -2*(-1+r**2)**2*(2379-279973*r**2-1150787*r**4+15009655*r**6+464700*r**8
            -51384078*r**10+10122046*r**12+16257114*r**14-30380865*r**16-2188685*r**18
            -1796411*r**20-137233*r**22+15738*r**24)-2*Q2**2*(82205-3023559*r**2
            -8478708*r**4+76263359*r**6+789381*r**8-22541442*r**10-64170152*r**12
            +62557218*r**14-128366529*r**16-18005431*r**18-10835748*r**20-1909089*r**22
            +307295*r**24)+Q2*(51209-3159072*r**2-8529792*r**4+127419826*r**6-80672875*r**8
            -122315778*r**10-12296096*r**12-288300356*r**14+254039643*r**16-204830140*r**18
            -8720096*r**20-14643822*r**22-1844217*r**24+230366*r**26))*sqrtq2))/(32400*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+32400*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*sqrtq2+logq2**4*(671846400*r**20*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3+671846400*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**3*(-223948800*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-223948800*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2**2*(27993600*r**12*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+27993600*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)+logq2*(-1555200*(-Q2+(-1+r)**2)**3*r**8*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3-1555200*(-Q2+(-1+r)**2)**3*r**8*(1-Q2+r**2)*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2))+((-1024*r**6*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(19*Q2**14+282*Q2**13*(1
            +r**2)-Q2**12*(3091+24994*r**2+3091*r**4)+8*Q2**11*(1468+21109*r**2
            +21109*r**4+1468*r**6)-Q2**10*(22929+429508*r**2+842398*r**4+429508*r**6
            +22929*r**8)+2*Q2**9*(11861+196905*r**2+601954*r**4+601954*r**6+196905*r**8
            +11861*r**10)+Q2**8*(-9399+236586*r**2+371247*r**4+1763900*r**6+371247*r**8
            +236586*r**10-9399*r**12)-48*Q2**7*(81+16094*r**2+44039*r**4+162216*r**6
            +162216*r**8+44039*r**10+16094*r**12+81*r**14)+Q2**6*(2217+491496*r**2
            +1407516*r**4+5890552*r**6+10367974*r**8+5890552*r**10+1407516*r**12
            +491496*r**14+2217*r**16)+Q2**5*(5198+54366*r**2-686520*r**4+694376*r**6
            -915068*r**8-915068*r**10+694376*r**12-686520*r**14+54366*r**16+5198*r**18)
            -Q2**4*(5241+148110*r**2-1331547*r**4+315528*r**6+2811026*r**8+766964*r**10
            +2811026*r**12+315528*r**14-1331547*r**16+148110*r**18+5241*r**20)+8*Q2**3*(74
            +2879*r**2-79999*r**4-72760*r**6+463054*r**8-719328*r**10-719328*r**12
            +463054*r**14-72760*r**16-79999*r**18+2879*r**20+74*r**22)+(-1+r**2)**2*(131
            -7796*r**2-226850*r**4-1011012*r**6+4060637*r**8-20862856*r**10+33503492*r**12
            -20862856*r**14+4060637*r**16-1011012*r**18-226850*r**20-7796*r**22
            +131*r**24)+Q2**2*(1429-7844*r**2-837182*r**4-2196852*r**6-124213*r**8
            +2220248*r**10-11762372*r**12+2220248*r**14-124213*r**16-2196852*r**18
            -837182*r**20-7844*r**22+1429*r**24)+Q2*(-786+22582*r**2+851092*r**4
            +2310964*r**6-9033670*r**8+34123682*r**10-23089864*r**12-23089864*r**14
            +34123682*r**16-9033670*r**18+2310964*r**20+851092*r**22+22582*r**24
            -786*r**26))-1024*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(19*Q2**14
            +282*Q2**13*(1+r**2)-Q2**12*(3091+24994*r**2+3091*r**4)+8*Q2**11*(1468
            +21109*r**2+21109*r**4+1468*r**6)-Q2**10*(22929+429508*r**2+842398*r**4
            +429508*r**6+22929*r**8)+2*Q2**9*(11861+196905*r**2+601954*r**4+601954*r**6
            +196905*r**8+11861*r**10)+Q2**8*(-9399+236586*r**2+371247*r**4+1763900*r**6
            +371247*r**8+236586*r**10-9399*r**12)-48*Q2**7*(81+16094*r**2+44039*r**4
            +162216*r**6+162216*r**8+44039*r**10+16094*r**12+81*r**14)+Q2**6*(2217
            +491496*r**2+1407516*r**4+5890552*r**6+10367974*r**8+5890552*r**10+1407516*r**12
            +491496*r**14+2217*r**16)+Q2**5*(5198+54366*r**2-686520*r**4+694376*r**6
            -915068*r**8-915068*r**10+694376*r**12-686520*r**14+54366*r**16+5198*r**18)
            -Q2**4*(5241+148110*r**2-1331547*r**4+315528*r**6+2811026*r**8+766964*r**10
            +2811026*r**12+315528*r**14-1331547*r**16+148110*r**18+5241*r**20)+8*Q2**3*(74
            +2879*r**2-79999*r**4-72760*r**6+463054*r**8-719328*r**10-719328*r**12
            +463054*r**14-72760*r**16-79999*r**18+2879*r**20+74*r**22)+(-1+r**2)**2*(131
            -7796*r**2-226850*r**4-1011012*r**6+4060637*r**8-20862856*r**10+33503492*r**12
            -20862856*r**14+4060637*r**16-1011012*r**18-226850*r**20-7796*r**22
            +131*r**24)+Q2**2*(1429-7844*r**2-837182*r**4-2196852*r**6-124213*r**8
            +2220248*r**10-11762372*r**12+2220248*r**14-124213*r**16-2196852*r**18
            -837182*r**20-7844*r**22+1429*r**24)+Q2*(-786+22582*r**2+851092*r**4
            +2310964*r**6-9033670*r**8+34123682*r**10-23089864*r**12-23089864*r**14
            +34123682*r**16-9033670*r**18+2310964*r**20+851092*r**22+22582*r**24
            -786*r**26))*sqrtq2+logq2**4*(2654208000*r**22*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3+2654208000*r**22*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*sqrtq2)+logq2**3*(35389440*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(-20*Q2**7+74*Q2**6*(1+r**2)-2*Q2**5*(27+94*r**2+27*r**4)
            +Q2**4*(-65+102*r**2+102*r**4-65*r**6)-Q2**3*(25+8*r**2-44*r**4+8*r**6
            +25*r**8)+(-1+r**2)**2*(104-77*r**2+123*r**4+123*r**6-77*r**8+104*r**10)
            +Q2**2*(315-58*r**2+53*r**4+53*r**6-58*r**8+315*r**10)-Q2*(329-363*r**2
            +361*r**4+546*r**6+361*r**8-363*r**10+329*r**12))+35389440*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(20*Q2**8-94*Q2**7*(1+r**2)+16*Q2**6*(8
            +21*r**2+8*r**4)+Q2**5*(11-344*r**2-344*r**4+11*r**6)-5*Q2**4*(8-9*r**2
            -32*r**4-9*r**6+8*r**8)+(-1+r**4)**2*(104-181*r**2+304*r**4-181*r**6
            +104*r**8)-Q2**3*(340-25*r**2+17*r**4+17*r**6-25*r**8+340*r**10)+2*Q2**2*(322
            -53*r**2+178*r**4+326*r**6+178*r**8-53*r**10+322*r**12)-Q2*(433-319*r**2
            +379*r**4+707*r**6+707*r**8+379*r**10-319*r**12+433*r**14))*sqrtq2)
            +logq2**2*(294912*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(
            -768*Q2**10+5000*Q2**9*(1+r**2)-5*Q2**8*(2496+4817*r**2+2496*r**4)+10*Q2**7*(1422
            +3851*r**2+3851*r**4+1422*r**6)-10*Q2**6*(672+1761*r**2+1756*r**4+1761*r**6
            +672*r**8)+4*Q2**5*(579-1255*r**2-7665*r**4-7665*r**6-1255*r**8+579*r**10)
            -10*Q2**4*(360+355*r**2-332*r**4-3708*r**6-332*r**8+355*r**10+360*r**12)
            -10*Q2**3*(102-471*r**2+487*r**4-982*r**6-982*r**8+487*r**10-471*r**12
            +102*r**14)+10*Q2**2*(768+719*r**2+9732*r**4-2283*r**6-952*r**8-2283*r**10
            +9732*r**12+719*r**14+768*r**16)+(-1+r**2)**2*(1552+3399*r**2+36046*r**4
            -16907*r**6+5820*r**8-16907*r**10+36046*r**12+3399*r**14+1552*r**16)
            -20*Q2*(309+272*r**2+5219*r**4-4899*r**6+4499*r**8+4499*r**10-4899*r**12
            +5219*r**14+272*r**16+309*r**18))-294912*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(768*Q2**10-5000*Q2**9*(1+r**2)+5*Q2**8*(2496+4817*r**2+2496*r**4)
            -10*Q2**7*(1422+3851*r**2+3851*r**4+1422*r**6)+10*Q2**6*(672+1761*r**2
            +1756*r**4+1761*r**6+672*r**8)-4*Q2**5*(579-1255*r**2-7665*r**4-7665*r**6
            -1255*r**8+579*r**10)+10*Q2**4*(360+355*r**2-332*r**4-3708*r**6-332*r**8
            +355*r**10+360*r**12)+10*Q2**3*(102-471*r**2+487*r**4-982*r**6-982*r**8
            +487*r**10-471*r**12+102*r**14)-10*Q2**2*(768+719*r**2+9732*r**4-2283*r**6
            -952*r**8-2283*r**10+9732*r**12+719*r**14+768*r**16)-(-1+r**2)**2*(1552
            +3399*r**2+36046*r**4-16907*r**6+5820*r**8-16907*r**10+36046*r**12
            +3399*r**14+1552*r**16)+20*Q2*(309+272*r**2+5219*r**4-4899*r**6+4499*r**8
            +4499*r**10-4899*r**12+5219*r**14+272*r**16+309*r**18))*sqrtq2)+logq2*(49152*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(-92*Q2**13+866*Q2**12*(1+r**2)-2*Q2**11*(1577
            +3466*r**2+1577*r**4)+Q2**10*(5425+18126*r**2+18126*r**4+5425*r**6)
            -Q2**9*(3345+12866*r**2-1644*r**4+12866*r**6+3345*r**8)-2*Q2**8*(1488
            +10923*r**2+72010*r**4+72010*r**6+10923*r**8+1488*r**10)+Q2**7*(6048
            +45687*r**2+262312*r**4+458810*r**6+262312*r**8+45687*r**10+6048*r**12)
            -Q2**6*(2442+29637*r**2+137597*r**4+352960*r**6+352960*r**8+137597*r**10
            +29637*r**12+2442*r**14)+Q2**5*(-1650+11847*r**2+10102*r**4-58135*r**6
            -77824*r**8-58135*r**10+10102*r**12+11847*r**14-1650*r**16)+Q2**4*(1670
            -10959*r**2-73259*r**4+115911*r**6+76837*r**8+76837*r**10+115911*r**12
            -73259*r**14-10959*r**16+1670*r**18)+r**2*(-1+r**2)**2*(2327+37541*r**2
            -49270*r**4+433894*r**6-316492*r**8-316492*r**10+433894*r**12-49270*r**14
            +37541*r**16+2327*r**18)+Q2**3*(-182+1321*r**2+35350*r**4-68880*r**6
            +154544*r**8+10574*r**10+154544*r**12-68880*r**14+35350*r**16+1321*r**18
            -182*r**20)+Q2**2*(-239+11747*r**2+119063*r**4-25275*r**6+515482*r**8
            -167178*r**10-167178*r**12+515482*r**14-25275*r**16+119063*r**18+11747*r**20
            -239*r**22)+Q2*(71-9681*r**2-121454*r**4+204015*r**6-1123175*r**8
            +1016098*r**10-795748*r**12+1016098*r**14-1123175*r**16+204015*r**18
            -121454*r**20-9681*r**22+71*r**24))+49152*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(92*Q2**14-958*Q2**13*(1+r**2)+12*Q2**12*(335+722*r**2+335*r**4)
            -Q2**11*(8579+28212*r**2+28212*r**4+8579*r**6)+Q2**10*(8770+36417*r**2
            +34608*r**4+36417*r**6+8770*r**8)+Q2**9*(-369+5635*r**2+132798*r**4
            +132798*r**6+5635*r**8-369*r**10)-3*Q2**8*(3008+23503*r**2+142726*r**4
            +248950*r**6+142726*r**8+23503*r**10+3008*r**12)+2*Q2**7*(4245+40686*r**2
            +222798*r**4+537041*r**6+537041*r**8+222798*r**10+40686*r**12+4245*r**14)
            -2*Q2**6*(396+21963*r**2+88668*r**4+216211*r**6+314048*r**8+216211*r**10
            +88668*r**12+21963*r**14+396*r**16)+r**2*(-1+r**4)**2*(2327+35214*r**2
            -84484*r**4+518378*r**6-834870*r**8+518378*r**10-84484*r**12+35214*r**14
            +2327*r**16)-4*Q2**5*(830-5289*r**2-23802*r**4+40986*r**6+53199*r**8
            +53199*r**10+40986*r**12-23802*r**14-5289*r**16+830*r**18)+2*Q2**4*(926
            -5305*r**2-59784*r**4+55766*r**6+19102*r**8+71550*r**10+19102*r**12
            +55766*r**14-59784*r**16-5305*r**18+926*r**20)+Q2**3*(57-10608*r**2
            -82392*r**4-8255*r**6-429818*r**8+332296*r**10+332296*r**12-429818*r**14
            -8255*r**16-82392*r**18-10608*r**20+57*r**22)+Q2**2*(-310+21189*r**2
            +252264*r**4-110227*r**6+1613382*r**8-667794*r**10+461392*r**12-667794*r**14
            +1613382*r**16-110227*r**18+252264*r**20+21189*r**22-310*r**24)+Q2*(71
            -11937*r**2-164022*r**4+204586*r**6-1489135*r**8+1126473*r**10-530036*r**12
            -530036*r**14+1126473*r**16-1489135*r**18+204586*r**20-164022*r**22
            -11937*r**24+71*r**26))*sqrtq2))*math.log(mu0))/(10800*r**4*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4+10800*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2+logq2**4*(223948800*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+223948800*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**3*(-74649600*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-74649600*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)+logq2**2*(9331200*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+9331200*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+logq2*(
            -518400*(-Q2+(-1+r)**2)**3*r**8*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3-518400*(-Q2+(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2))+((32*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(-13+4*Q2**10+404*r**2-6453*r**4-53600*r**6-142382*r**8+644712*r**10
            -641774*r**12+323008*r**14-51045*r**16+13412*r**18+131*r**20+7*Q2**9*(1
            +r**2)+3*Q2**8*(-41+102*r**2+47*r**4)-6*Q2**7*(-57+312*r**2+1834*r**4
            +145*r**6)+6*Q2**6*(-63+623*r**2+7092*r**4+6423*r**6+249*r**8)-6*Q2**5*(
            -14+369*r**2+6937*r**4+16621*r**6+4867*r**8+80*r**10)-2*Q2**4*(-84
            +891*r**2+4110*r**4-10306*r**6-20622*r**8+23091*r**10+576*r**12)+2*Q2**3*(
            -51+1152*r**2+8712*r**4-14165*r**6+78457*r**8+13926*r**10+36702*r**12
            +507*r**14)+6*Q2**2*(-7+57*r**2+354*r**4+10083*r**6+11218*r**8-19285*r**10
            -5374*r**12-1151*r**14+25*r**16)+Q2*(53-1233*r**2+5058*r**4+62878*r**6
            -3216*r**8+163512*r**10-224402*r**12+73362*r**14-32373*r**16-439*r**18))
            -32*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(13+4*Q2**11-391*r**2
            +6049*r**4+60053*r**6+195982*r**8-502330*r**10-2938*r**12+318766*r**14
            -271963*r**16+37633*r**18-13543*r**20-131*r**22+3*Q2**10*(1+r**2)+2*Q2**9*(
            -65+146*r**2+67*r**4)-3*Q2**8*(-155+685*r**2+3817*r**4+337*r**6)+12*Q2**7*(
            -60+439*r**2+4619*r**4+4201*r**6+197*r**8)-6*Q2**6*(-77+929*r**2+14652*r**4
            +30136*r**6+11539*r**8+329*r**10)-4*Q2**5*(-21-87*r**2-8904*r**4-40490*r**6
            -42543*r**8+4125*r**10+168*r**12)+6*Q2**4*(-45+653*r**2+4571*r**4-6787*r**6
            +15843*r**8+5465*r**10+20123*r**12+361*r**14)-4*Q2**3*(-15+465*r**2
            +4401*r**4-17851*r**6+15319*r**8+75119*r**10+33375*r**12+20331*r**14
            +216*r**16)+Q2**2*(95-1533*r**2+2592*r**4+256*r**6-131022*r**8+211914*r**10
            -76448*r**12+112512*r**14-25617*r**16-589*r**18)+6*Q2*(-11+264*r**2
            -1713*r**4-20256*r**6-33674*r**8+80736*r**10-96814*r**12+79008*r**14
            -15339*r**16+7704*r**18+95*r**20))*sqrtq2+logq2**3*(1382400*(-Q2+(-1
            +r)**2)*r**14*(1-Q2+r**2)*(-3+5*r**2)*(-Q2+(1+r)**2)+1382400*r**14*(
            -3+5*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**2*(23040*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-163+40*Q2**5+26*r**2+106*r**4+466*r**6
            -179*r**8+104*r**10-4*Q2**4*(17+44*r**2)+Q2**3*(-23+141*r**2+244*r**4)
            +Q2**2*(17+122*r**2-167*r**4-16*r**6)+Q2*(197-143*r**2-11*r**4+213*r**6
            -196*r**8))+23040*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(
            -163+40*Q2**5+26*r**2+106*r**4+466*r**6-179*r**8+104*r**10-4*Q2**4*(17
            +44*r**2)+Q2**3*(-23+141*r**2+244*r**4)+Q2**2*(17+122*r**2-167*r**4
            -16*r**6)+Q2*(197-143*r**2-11*r**4+213*r**6-196*r**8))*sqrtq2)+logq2*(384*r**6*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(39+184*Q2**8-3867*r**2
            -25973*r**4+50081*r**6-3175*r**8-8589*r**10+11917*r**12+823*r**14+344*r**16
            -8*Q2**7*(149+129*r**2)+Q2**6*(2367+5475*r**2+1772*r**4)-2*Q2**5*(667
            +3104*r**2+3119*r**4+82*r**6)-Q2**4*(895-535*r**2+7961*r**4+3335*r**6
            +2520*r**8)+4*Q2**3*(249-390*r**2+1196*r**4+6626*r**6+2435*r**8+524*r**10)
            +Q2**2*(97+1297*r**2+15474*r**4-10226*r**6-7811*r**8-3923*r**10+412*r**12)
            -2*Q2*(131-2680*r**2-9071*r**4+10450*r**6-13055*r**8+9404*r**10+675*r**12
            +546*r**14))+384*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(39+184*Q2**8
            -3867*r**2-25973*r**4+50081*r**6-3175*r**8-8589*r**10+11917*r**12+823*r**14
            +344*r**16-8*Q2**7*(149+129*r**2)+Q2**6*(2367+5475*r**2+1772*r**4)
            -2*Q2**5*(667+3104*r**2+3119*r**4+82*r**6)-Q2**4*(895-535*r**2+7961*r**4
            +3335*r**6+2520*r**8)+4*Q2**3*(249-390*r**2+1196*r**4+6626*r**6+2435*r**8
            +524*r**10)+Q2**2*(97+1297*r**2+15474*r**4-10226*r**6-7811*r**8-3923*r**10
            +412*r**12)-2*Q2*(131-2680*r**2-9071*r**4+10450*r**6-13055*r**8+9404*r**10
            +675*r**12+546*r**14))*sqrtq2))*math.log(mus))/(-324*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-324*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(
            -559872*r**14*(-1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2
            +3*r**4))+559872*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**2*(
            -139968*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -139968*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(11664*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+11664*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2))+((-32*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(
            -13+4*Q2**10+404*r**2-6453*r**4-53600*r**6-142382*r**8+644712*r**10
            -641774*r**12+323008*r**14-51045*r**16+13412*r**18+131*r**20+7*Q2**9*(1
            +r**2)+3*Q2**8*(-41+102*r**2+47*r**4)-6*Q2**7*(-57+312*r**2+1834*r**4
            +145*r**6)+6*Q2**6*(-63+623*r**2+7092*r**4+6423*r**6+249*r**8)-6*Q2**5*(
            -14+369*r**2+6937*r**4+16621*r**6+4867*r**8+80*r**10)-2*Q2**4*(-84
            +891*r**2+4110*r**4-10306*r**6-20622*r**8+23091*r**10+576*r**12)+2*Q2**3*(
            -51+1152*r**2+8712*r**4-14165*r**6+78457*r**8+13926*r**10+36702*r**12
            +507*r**14)+6*Q2**2*(-7+57*r**2+354*r**4+10083*r**6+11218*r**8-19285*r**10
            -5374*r**12-1151*r**14+25*r**16)+Q2*(53-1233*r**2+5058*r**4+62878*r**6
            -3216*r**8+163512*r**10-224402*r**12+73362*r**14-32373*r**16-439*r**18))
            +32*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(13+4*Q2**11-391*r**2
            +6049*r**4+60053*r**6+195982*r**8-502330*r**10-2938*r**12+318766*r**14
            -271963*r**16+37633*r**18-13543*r**20-131*r**22+3*Q2**10*(1+r**2)+2*Q2**9*(
            -65+146*r**2+67*r**4)-3*Q2**8*(-155+685*r**2+3817*r**4+337*r**6)+12*Q2**7*(
            -60+439*r**2+4619*r**4+4201*r**6+197*r**8)-6*Q2**6*(-77+929*r**2+14652*r**4
            +30136*r**6+11539*r**8+329*r**10)-4*Q2**5*(-21-87*r**2-8904*r**4-40490*r**6
            -42543*r**8+4125*r**10+168*r**12)+6*Q2**4*(-45+653*r**2+4571*r**4-6787*r**6
            +15843*r**8+5465*r**10+20123*r**12+361*r**14)-4*Q2**3*(-15+465*r**2
            +4401*r**4-17851*r**6+15319*r**8+75119*r**10+33375*r**12+20331*r**14
            +216*r**16)+Q2**2*(95-1533*r**2+2592*r**4+256*r**6-131022*r**8+211914*r**10
            -76448*r**12+112512*r**14-25617*r**16-589*r**18)+6*Q2*(-11+264*r**2
            -1713*r**4-20256*r**6-33674*r**8+80736*r**10-96814*r**12+79008*r**14
            -15339*r**16+7704*r**18+95*r**20))*sqrtq2+logq2**3*(-1382400*(-Q2+(
            -1+r)**2)*r**14*(1-Q2+r**2)*(-3+5*r**2)*(-Q2+(1+r)**2)-1382400*r**14*(
            -3+5*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**2*(-23040*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-163+40*Q2**5+26*r**2+106*r**4+466*r**6
            -179*r**8+104*r**10-4*Q2**4*(17+44*r**2)+Q2**3*(-23+141*r**2+244*r**4)
            +Q2**2*(17+122*r**2-167*r**4-16*r**6)+Q2*(197-143*r**2-11*r**4+213*r**6
            -196*r**8))-23040*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(
            -163+40*Q2**5+26*r**2+106*r**4+466*r**6-179*r**8+104*r**10-4*Q2**4*(17
            +44*r**2)+Q2**3*(-23+141*r**2+244*r**4)+Q2**2*(17+122*r**2-167*r**4
            -16*r**6)+Q2*(197-143*r**2-11*r**4+213*r**6-196*r**8))*sqrtq2)+logq2*(
            -384*r**6*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(39+184*Q2**8
            -3867*r**2-25973*r**4+50081*r**6-3175*r**8-8589*r**10+11917*r**12+823*r**14
            +344*r**16-8*Q2**7*(149+129*r**2)+Q2**6*(2367+5475*r**2+1772*r**4)
            -2*Q2**5*(667+3104*r**2+3119*r**4+82*r**6)-Q2**4*(895-535*r**2+7961*r**4
            +3335*r**6+2520*r**8)+4*Q2**3*(249-390*r**2+1196*r**4+6626*r**6+2435*r**8
            +524*r**10)+Q2**2*(97+1297*r**2+15474*r**4-10226*r**6-7811*r**8-3923*r**10
            +412*r**12)-2*Q2*(131-2680*r**2-9071*r**4+10450*r**6-13055*r**8+9404*r**10
            +675*r**12+546*r**14))-384*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(39
            +184*Q2**8-3867*r**2-25973*r**4+50081*r**6-3175*r**8-8589*r**10+11917*r**12
            +823*r**14+344*r**16-8*Q2**7*(149+129*r**2)+Q2**6*(2367+5475*r**2+1772*r**4)
            -2*Q2**5*(667+3104*r**2+3119*r**4+82*r**6)-Q2**4*(895-535*r**2+7961*r**4
            +3335*r**6+2520*r**8)+4*Q2**3*(249-390*r**2+1196*r**4+6626*r**6+2435*r**8
            +524*r**10)+Q2**2*(97+1297*r**2+15474*r**4-10226*r**6-7811*r**8-3923*r**10
            +412*r**12)-2*Q2*(131-2680*r**2-9071*r**4+10450*r**6-13055*r**8+9404*r**10
            +675*r**12+546*r**14))*sqrtq2))*math.log(2*muWC))/(-300*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-300*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(
            -518400*r**14*(-1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2
            +3*r**4))+518400*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**2*(
            -129600*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -129600*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(10800*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+10800*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2))+((256*(Q2-(-1+r)**2)**4*r**4*(1-Q2+r**2)*(Q2-(1
            +r)**2)**4*(-4*Q2**15+Q2**14*(5+233*r**2)+8*Q2**13*(17+389*r**2+407*r**4)
            -Q2**12*(733+34683*r**2+287595*r**4+35821*r**6)+4*Q2**11*(412+33048*r**2
            +486147*r**4+487842*r**6+34135*r**8)-Q2**10*(1639+260939*r**2+4948398*r**4
            +9736566*r**6+4981139*r**8+268711*r**10)+4*Q2**9*(-55+70286*r**2+1131460*r**4
            +3443454*r**6+3450409*r**8+1155080*r**10+70886*r**12)+Q2**8*(2343-136479*r**2
            +2795343*r**4+5111569*r**6+22171285*r**8+4918947*r**10+2592021*r**12
            -122037*r**14)-4*Q2**7*(561+2736*r**2+2260530*r**4+6528724*r**6+23831104*r**8
            +23689720*r**10+6369618*r**12+2197740*r**14+8787*r**16)+Q2**6*(319+13611*r**2
            +5769084*r**4+17608284*r**6+73145490*r**8+127125402*r**10+71988396*r**12
            +16637484*r**14+5742999*r**16+24835*r**18)+8*Q2**5*(110+6011*r**2+82047*r**4
            -1000990*r**6+948676*r**8-1379844*r**10-1224908*r**12+1004762*r**14
            -887910*r**16+39221*r**18+6953*r**20)-Q2**4*(535+48577*r**2+1792765*r**4
            -15084869*r**6+3780966*r**8+33244922*r**10+14098778*r**12+39233862*r**14
            +3641731*r**16-14403899*r**18+1414825*r**20+57727*r**22)+4*Q2**3*(-26
            +1848*r**2+70119*r**4-1840046*r**6-1893815*r**8+10514648*r**10-17394166*r**12
            -17125948*r**14+11930836*r**16-1790480*r**18-1815537*r**20+56298*r**22
            +1789*r**24)+(-1+r**2)**2*(13+1077*r**2-84362*r**4-2710930*r**6-12410537*r**8
            +46717511*r**10-246142588*r**12+401881844*r**14-253179301*r**16+51259747*r**18
            -12718714*r**20-2576354*r**22-106047*r**24+1441*r**26)+Q2**2*(227+11127*r**2
            -47310*r**4-9857798*r**6-26865439*r**8-4501155*r**10+24286348*r**12
            -141507620*r**14+28258629*r**16+2236529*r**18-28131902*r**20-9236310*r**22
            -203145*r**24+15419*r**26)-4*Q2*(23+1582*r**2-57432*r**4-2531102*r**6
            -7188975*r**8+25934624*r**10-101057834*r**12+71217244*r**14+68358169*r**16
            -103788010*r**18+29056668*r**20-7552958*r**22-2376897*r**24-84452*r**26
            +2150*r**28))-256*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**15
            -Q2**14*(5+233*r**2)-8*Q2**13*(17+389*r**2+407*r**4)+Q2**12*(733+34683*r**2
            +287595*r**4+35821*r**6)-4*Q2**11*(412+33048*r**2+486147*r**4+487842*r**6
            +34135*r**8)+Q2**10*(1639+260939*r**2+4948398*r**4+9736566*r**6+4981139*r**8
            +268711*r**10)-4*Q2**9*(-55+70286*r**2+1131460*r**4+3443454*r**6+3450409*r**8
            +1155080*r**10+70886*r**12)+Q2**8*(-2343+136479*r**2-2795343*r**4-5111569*r**6
            -22171285*r**8-4918947*r**10-2592021*r**12+122037*r**14)+4*Q2**7*(561
            +2736*r**2+2260530*r**4+6528724*r**6+23831104*r**8+23689720*r**10+6369618*r**12
            +2197740*r**14+8787*r**16)-Q2**6*(319+13611*r**2+5769084*r**4+17608284*r**6
            +73145490*r**8+127125402*r**10+71988396*r**12+16637484*r**14+5742999*r**16
            +24835*r**18)-8*Q2**5*(110+6011*r**2+82047*r**4-1000990*r**6+948676*r**8
            -1379844*r**10-1224908*r**12+1004762*r**14-887910*r**16+39221*r**18
            +6953*r**20)+Q2**4*(535+48577*r**2+1792765*r**4-15084869*r**6+3780966*r**8
            +33244922*r**10+14098778*r**12+39233862*r**14+3641731*r**16-14403899*r**18
            +1414825*r**20+57727*r**22)-4*Q2**3*(-26+1848*r**2+70119*r**4-1840046*r**6
            -1893815*r**8+10514648*r**10-17394166*r**12-17125948*r**14+11930836*r**16
            -1790480*r**18-1815537*r**20+56298*r**22+1789*r**24)+Q2**2*(-227-11127*r**2
            +47310*r**4+9857798*r**6+26865439*r**8+4501155*r**10-24286348*r**12
            +141507620*r**14-28258629*r**16-2236529*r**18+28131902*r**20+9236310*r**22
            +203145*r**24-15419*r**26)-(-1+r**2)**2*(13+1077*r**2-84362*r**4-2710930*r**6
            -12410537*r**8+46717511*r**10-246142588*r**12+401881844*r**14-253179301*r**16
            +51259747*r**18-12718714*r**20-2576354*r**22-106047*r**24+1441*r**26)
            +4*Q2*(23+1582*r**2-57432*r**4-2531102*r**6-7188975*r**8+25934624*r**10
            -101057834*r**12+71217244*r**14+68358169*r**16-103788010*r**18+29056668*r**20
            -7552958*r**22-2376897*r**24-84452*r**26+2150*r**28))*sqrtq2+logq2**4*(
            -132710400*r**20*(1-Q2+r**2)*(3+55*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3-132710400*r**20*(3+55*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**3*(-4423680*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-500*Q2**7
            +2*Q2**6*(925+952*r**2)-2*Q2**5*(690+2387*r**2+807*r**4)+Q2**4*(-1535
            +2510*r**2+2737*r**4-1220*r**6)-Q2**3*(685+65*r**2-1057*r**4+283*r**6
            +640*r**8)+2*(-1+r**2)**2*(1285-898*r**2+1432*r**4+1312*r**6-873*r**8
            +1222*r**10)+Q2**2*(7815-1340*r**2+1242*r**4+956*r**6-1193*r**8+7320*r**10)
            -Q2*(8135-8701*r**2+8788*r**4+12358*r**6+7863*r**8-8297*r**10+7694*r**12))
            -4423680*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(500*Q2**8-2*Q2**7*(1175
            +1202*r**2)+Q2**6*(3230+8528*r**2+3518*r**4)-Q2**5*(-155+8664*r**2
            +9125*r**4+394*r**6)-10*Q2**4*(85-104*r**2-419*r**4-180*r**6+58*r**8)
            -2*Q2**3*(4250-295*r**2+125*r**4+91*r**6-135*r**8+3980*r**10)+2*(
            -1+r**2)**2*(1285+387*r**2+534*r**4+2744*r**6+439*r**8+349*r**10+1222*r**12)
            +2*Q2**2*(7975-1113*r**2+4345*r**4+7278*r**6+3813*r**8-1085*r**10+7507*r**12)
            -Q2*(10705-7502*r**2+9113*r**4+16246*r**6+16091*r**8+8126*r**10-7237*r**12
            +10138*r**14))*sqrtq2)+logq2**2*(-73728*r**12*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3*(-9208*Q2**10+10*Q2**9*(6031+5996*r**2)-5*Q2**8*(30315
            +58283*r**2+29928*r**4)+5*Q2**7*(34869+94038*r**2+93425*r**4+34092*r**6)
            -10*Q2**6*(8310+21911*r**2+20862*r**4+21037*r**6+8076*r**8)+Q2**5*(25761
            -58720*r**2-388620*r**4-413160*r**6-77785*r**8+28596*r**10)-10*Q2**4*(3951
            +4401*r**2-4150*r**4-48328*r**6-10119*r**8+1841*r**10+4416*r**12)-5*Q2**3*(2505
            -10838*r**2+10467*r**4-26420*r**6-21037*r**8+13950*r**10-9823*r**12
            +2412*r**14)+10*Q2**2*(8958+10241*r**2+120480*r**4-27951*r**6-12718*r**8
            -26361*r**10+114312*r**12+7535*r**14+9264*r**16)+(-1+r**2)**2*(18197
            +45639*r**2+448201*r**4-229477*r**6+61035*r**8-203087*r**10+429071*r**12
            +38109*r**14+18712*r**16)-5*Q2*(14455+16548*r**2+257866*r**4-244768*r**6
            +212400*r**8+201328*r**10-231130*r**12+248592*r**14+10921*r**16+14908*r**18))
            +73728*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(9208*Q2**10-10*Q2**9*(6031
            +5996*r**2)+5*Q2**8*(30315+58283*r**2+29928*r**4)-5*Q2**7*(34869+94038*r**2
            +93425*r**4+34092*r**6)+10*Q2**6*(8310+21911*r**2+20862*r**4+21037*r**6
            +8076*r**8)+Q2**5*(-25761+58720*r**2+388620*r**4+413160*r**6+77785*r**8
            -28596*r**10)+10*Q2**4*(3951+4401*r**2-4150*r**4-48328*r**6-10119*r**8
            +1841*r**10+4416*r**12)+5*Q2**3*(2505-10838*r**2+10467*r**4-26420*r**6
            -21037*r**8+13950*r**10-9823*r**12+2412*r**14)-10*Q2**2*(8958+10241*r**2
            +120480*r**4-27951*r**6-12718*r**8-26361*r**10+114312*r**12+7535*r**14
            +9264*r**16)-(-1+r**2)**2*(18197+45639*r**2+448201*r**4-229477*r**6
            +61035*r**8-203087*r**10+429071*r**12+38109*r**14+18712*r**16)+5*Q2*(14455
            +16548*r**2+257866*r**4-244768*r**6+212400*r**8+201328*r**10-231130*r**12
            +248592*r**14+10921*r**16+14908*r**18))*sqrtq2)+logq2*(-6144*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(-2116*Q2**13+2*Q2**12*(9955+9996*r**2)
            -2*Q2**11*(36270+80055*r**2+36539*r**4)+Q2**10*(125041+417430*r**2+418377*r**4
            +126612*r**6)-Q2**9*(78125+285599*r**2-76551*r**4+290869*r**6+80830*r**8)
            -2*Q2**8*(33039+271322*r**2+1763240*r**4+1751600*r**6+261537*r**8+31674*r**10)
            +4*Q2**7*(34185+278258*r**2+1608947*r**4+2796150*r**6+1587077*r**8+268854*r**10
            +34089*r**12)-2*Q2**6*(27705+360182*r**2+1722117*r**4+4344660*r**6+4303845*r**8
            +1664630*r**10+345417*r**12+29532*r**14)-2*Q2**5*(18621-133423*r**2
            -120181*r**4+677387*r**6+1088033*r**8+805941*r**10-90193*r**12-137001*r**14
            +15792*r**16)+2*Q2**4*(18875-117188*r**2-835868*r**4+1329492*r**6+1043934*r**8
            +1300564*r**10+1589972*r**12-821468*r**14-130353*r**16+17240*r**18)
            +Q2**3*(-4256+26894*r**2+820650*r**4-1508760*r**6+3825136*r**8+322532*r**10
            +3438116*r**12-1757480*r**14+788720*r**16+37774*r**18-4686*r**20)+Q2**2*(
            -5175+266726*r**2+2854737*r**4-273340*r**6+12669998*r**8-4101164*r**10
            -3886978*r**12+12045848*r**14-744695*r**16+2851142*r**18+272049*r**20
            -3548*r**22)+2*(-1+r**2)**2*(13+26788*r**2+452311*r**4-513090*r**6
            +5198374*r**8-4049808*r**10-3601374*r**12+5119564*r**14-602835*r**16
            +448076*r**18+27495*r**20+86*r**22)+Q2*(1475-221351*r**2-2928433*r**4
            +4431915*r**6-26897380*r**8+25075790*r**10-18521598*r**12+23735786*r**14
            -26581345*r**16+4987225*r**18-2900945*r**20-226581*r**22+642*r**24))
            -6144*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(2116*Q2**14-2*Q2**13*(11013
            +11054*r**2)+Q2**12*(92450+200012*r**2+93070*r**4)-Q2**11*(197581+650080*r**2
            +651565*r**4+199690*r**6)+Q2**10*(203166+828070*r**2+759256*r**4+835858*r**6
            +207442*r**8)+Q2**9*(-12047+178920*r**2+3317432*r**4+3288882*r**6+151375*r**8
            -17482*r**10)-2*Q2**8*(101409+860877*r**2+5252456*r**4+9107140*r**6
            +5187291*r**8+830919*r**10+99852*r**12)+2*Q2**7*(96075+985068*r**2+5496527*r**4
            +13154854*r**6+13070299*r**8+5376492*r**10+951303*r**12+97710*r**14)
            -4*Q2**6*(4542+260655*r**2+1101240*r**4+2694695*r**6+3780236*r**8+2581267*r**10
            +1050120*r**12+255975*r**14+6870*r**16)-4*Q2**5*(18748-115995*r**2-544736*r**4
            +943349*r**6+1404677*r**8+1597269*r**10+1152860*r**12-524331*r**14-125781*r**16
            +16516*r**18)+Q2**4*(42006-223520*r**2-2726762*r**4+2496008*r**6+921716*r**8
            +4366464*r**10+2342956*r**12+3294488*r**14-2692362*r**16-264000*r**18
            +39166*r**20)-Q2**3*(-919+244088*r**2+2007193*r**4+414770*r**6+10353622*r**8
            -8248832*r**10-7647626*r**12+10365212*r**14+224065*r**16+2024648*r**18
            +238961*r**20+1138*r**22)+2*(-1+r**2)**2*(13+26801*r**2+479099*r**4
            -60779*r**6+4685284*r**8+1148566*r**10-7651182*r**12+1518190*r**14+4516729*r**16
            -154759*r**18+475571*r**20+27581*r**22+86*r**24)-2*Q2**2*(3325-241451*r**2
            -3024948*r**4+925259*r**6-19647019*r**8+8253478*r**10-5266728*r**12
            +7788458*r**14-18941249*r**16+1440389*r**18-3012068*r**20-247541*r**22
            +2095*r**24)+Q2*(1449-273400*r**2-3947280*r**4+4285330*r**6-35819195*r**8
            +28097702*r**10-12839040*r**12-11330820*r**14+26041115*r**16-35140740*r**18
            +5029264*r**20-3913870*r**22-280585*r**24+470*r**26))*sqrtq2))*math.log(r))/(32400*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+32400*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*sqrtq2+logq2**4*(671846400*r**20*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3+671846400*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**3*(-223948800*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-223948800*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2**2*(27993600*r**12*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+27993600*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)+logq2*(-1555200*(-Q2+(-1+r)**2)**3*r**8*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3-1555200*(-Q2+(-1+r)**2)**3*r**8*(1-Q2+r**2)*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)))+muWC**2*((pi2*(
            -4*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-13+4*Q2**10+404*r**2
            -6453*r**4-53600*r**6-142382*r**8+644712*r**10-641774*r**12+323008*r**14
            -51045*r**16+13412*r**18+131*r**20+7*Q2**9*(1+r**2)+3*Q2**8*(-41+102*r**2
            +47*r**4)-6*Q2**7*(-57+312*r**2+1834*r**4+145*r**6)+6*Q2**6*(-63+623*r**2
            +7092*r**4+6423*r**6+249*r**8)-6*Q2**5*(-14+369*r**2+6937*r**4+16621*r**6
            +4867*r**8+80*r**10)-2*Q2**4*(-84+891*r**2+4110*r**4-10306*r**6-20622*r**8
            +23091*r**10+576*r**12)+2*Q2**3*(-51+1152*r**2+8712*r**4-14165*r**6
            +78457*r**8+13926*r**10+36702*r**12+507*r**14)+6*Q2**2*(-7+57*r**2
            +354*r**4+10083*r**6+11218*r**8-19285*r**10-5374*r**12-1151*r**14+25*r**16)
            +Q2*(53-1233*r**2+5058*r**4+62878*r**6-3216*r**8+163512*r**10-224402*r**12
            +73362*r**14-32373*r**16-439*r**18))+4*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(13+4*Q2**11-391*r**2+6049*r**4+60053*r**6+195982*r**8-502330*r**10
            -2938*r**12+318766*r**14-271963*r**16+37633*r**18-13543*r**20-131*r**22
            +3*Q2**10*(1+r**2)+2*Q2**9*(-65+146*r**2+67*r**4)-3*Q2**8*(-155+685*r**2
            +3817*r**4+337*r**6)+12*Q2**7*(-60+439*r**2+4619*r**4+4201*r**6+197*r**8)
            -6*Q2**6*(-77+929*r**2+14652*r**4+30136*r**6+11539*r**8+329*r**10)
            -4*Q2**5*(-21-87*r**2-8904*r**4-40490*r**6-42543*r**8+4125*r**10+168*r**12)
            +6*Q2**4*(-45+653*r**2+4571*r**4-6787*r**6+15843*r**8+5465*r**10+20123*r**12
            +361*r**14)-4*Q2**3*(-15+465*r**2+4401*r**4-17851*r**6+15319*r**8+75119*r**10
            +33375*r**12+20331*r**14+216*r**16)+Q2**2*(95-1533*r**2+2592*r**4+256*r**6
            -131022*r**8+211914*r**10-76448*r**12+112512*r**14-25617*r**16-589*r**18)
            +6*Q2*(-11+264*r**2-1713*r**4-20256*r**6-33674*r**8+80736*r**10-96814*r**12
            +79008*r**14-15339*r**16+7704*r**18+95*r**20))*sqrtq2+logq2**3*(-172800*(
            -Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(-3+5*r**2)*(-Q2+(1+r)**2)-172800*r**14*(
            -3+5*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**2*(-2880*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-163+40*Q2**5+26*r**2+106*r**4+466*r**6
            -179*r**8+104*r**10-4*Q2**4*(17+44*r**2)+Q2**3*(-23+141*r**2+244*r**4)
            +Q2**2*(17+122*r**2-167*r**4-16*r**6)+Q2*(197-143*r**2-11*r**4+213*r**6
            -196*r**8))-2880*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(
            -163+40*Q2**5+26*r**2+106*r**4+466*r**6-179*r**8+104*r**10-4*Q2**4*(17
            +44*r**2)+Q2**3*(-23+141*r**2+244*r**4)+Q2**2*(17+122*r**2-167*r**4
            -16*r**6)+Q2*(197-143*r**2-11*r**4+213*r**6-196*r**8))*sqrtq2)+logq2*(
            -48*r**6*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(39+184*Q2**8
            -3867*r**2-25973*r**4+50081*r**6-3175*r**8-8589*r**10+11917*r**12+823*r**14
            +344*r**16-8*Q2**7*(149+129*r**2)+Q2**6*(2367+5475*r**2+1772*r**4)
            -2*Q2**5*(667+3104*r**2+3119*r**4+82*r**6)-Q2**4*(895-535*r**2+7961*r**4
            +3335*r**6+2520*r**8)+4*Q2**3*(249-390*r**2+1196*r**4+6626*r**6+2435*r**8
            +524*r**10)+Q2**2*(97+1297*r**2+15474*r**4-10226*r**6-7811*r**8-3923*r**10
            +412*r**12)-2*Q2*(131-2680*r**2-9071*r**4+10450*r**6-13055*r**8+9404*r**10
            +675*r**12+546*r**14))-48*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(39
            +184*Q2**8-3867*r**2-25973*r**4+50081*r**6-3175*r**8-8589*r**10+11917*r**12
            +823*r**14+344*r**16-8*Q2**7*(149+129*r**2)+Q2**6*(2367+5475*r**2+1772*r**4)
            -2*Q2**5*(667+3104*r**2+3119*r**4+82*r**6)-Q2**4*(895-535*r**2+7961*r**4
            +3335*r**6+2520*r**8)+4*Q2**3*(249-390*r**2+1196*r**4+6626*r**6+2435*r**8
            +524*r**10)+Q2**2*(97+1297*r**2+15474*r**4-10226*r**6-7811*r**8-3923*r**10
            +412*r**12)-2*Q2*(131-2680*r**2-9071*r**4+10450*r**6-13055*r**8+9404*r**10
            +675*r**12+546*r**14))*sqrtq2)))/(-900*(-Q2+(-1+r)**2)*r**2*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-900*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(
            -1555200*r**14*(-1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2
            +3*r**4))+1555200*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**2*(-388800*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))-388800*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1
            +r)**2)*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)
            +logq2*(32400*(-Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+32400*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2))+(-32*(Q2-(-1+r)**2)**4*r**4*(1-Q2
            +r**2)*(Q2-(1+r)**2)**4*(1660*Q2**15+Q2**14*(357-707*r**2)+8*Q2**13*(
            -10991+21160*r**2+9178*r**4)-Q2**12*(-475331+1598351*r**2+8663555*r**4
            +750017*r**6)+4*Q2**11*(-301284+1575736*r**2+15009787*r**4+13567546*r**6
            +666647*r**8)-Q2**10*(-1666681+12813543*r**2+158098910*r**4+279718334*r**6
            +128223523*r**8+4322243*r**10)+4*Q2**9*(-277911+3179716*r**2+45251154*r**4
            +110317498*r**6+109188293*r**8+21179094*r**10+543196*r**12)+Q2**8*(-28089
            -1941795*r**2-53481657*r**4-191307531*r**6+71055365*r**8-67427769*r**10
            +169719885*r**12+3161607*r**14)-4*Q2**7*(-113007+1713792*r**2+12748626*r**4
            -14197756*r**6+182777024*r**8+331516280*r**10+112328130*r**12+86904780*r**14
            +1263939*r**16)+Q2**6*(68447+1370727*r**2+22747740*r**4-169505428*r**6
            -22143886*r**8+1128925250*r**10+954772812*r**12+433324860*r**14+132684567*r**16
            +893759*r**18)+16*Q2**5*(-30777+524786*r**2-458304*r**4-14065953*r**6
            -9844344*r**8+29971181*r**10-82284631*r**12+82263251*r**14-21971733*r**16
            +12986091*r**18+198521*r**20)+Q2**4*(296137-7535357*r**2+41204059*r**4
            +567722233*r**6+959490938*r**8-1067809778*r**10-695652170*r**12+3323824962*r**14
            -2478712067*r**16+454831663*r**18-232295633*r**20-2520827*r**22)+4*Q2**3*(8998
            +41960*r**2-5164273*r**4-48686966*r**6-86234775*r**8+542274664*r**10
            -291865910*r**12+615911492*r**14-664193564*r**16+225212080*r**18-29798617*r**20
            +8394290*r**22+5261*r**24)+(-1+r**2)**2*(-7059+261449*r**2-4553594*r**4
            +6583990*r**6+207784071*r**8+864106547*r**10-1118624476*r**12-1789282972*r**14
            +2702310683*r**16-1602327601*r**18+375124182*r**20-66490778*r**22+7221361*r**24
            +63797*r**26)+Q2**2*(-112509+2930819*r**2-22570366*r**4-98710222*r**6
            +264806801*r**8+1271379025*r**10+977073580*r**12-678369684*r**14+1932302149*r**16
            -3050265371*r**18+1394529874*r**20-357854494*r**22+66811175*r**24+820423*r**26)
            -4*Q2*(-12041+396924*r**2-5453378*r**4-5947146*r**6+135227813*r**8
            +686417082*r**10-941959208*r**12+216142996*r**14-1558550543*r**16+2153323224*r**18
            -1436334986*r**20+409479414*r**22-80665613*r**24+10004594*r**26+100468*r**28))
            -32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1660*Q2**15+Q2**14*(357
            -707*r**2)+8*Q2**13*(-10991+21160*r**2+9178*r**4)-Q2**12*(-475331+1598351*r**2
            +8663555*r**4+750017*r**6)+4*Q2**11*(-301284+1575736*r**2+15009787*r**4
            +13567546*r**6+666647*r**8)-Q2**10*(-1666681+12813543*r**2+158098910*r**4
            +279718334*r**6+128223523*r**8+4322243*r**10)+4*Q2**9*(-277911+3179716*r**2
            +45251154*r**4+110317498*r**6+109188293*r**8+21179094*r**10+543196*r**12)
            +Q2**8*(-28089-1941795*r**2-53481657*r**4-191307531*r**6+71055365*r**8
            -67427769*r**10+169719885*r**12+3161607*r**14)-4*Q2**7*(-113007+1713792*r**2
            +12748626*r**4-14197756*r**6+182777024*r**8+331516280*r**10+112328130*r**12
            +86904780*r**14+1263939*r**16)+Q2**6*(68447+1370727*r**2+22747740*r**4
            -169505428*r**6-22143886*r**8+1128925250*r**10+954772812*r**12+433324860*r**14
            +132684567*r**16+893759*r**18)+16*Q2**5*(-30777+524786*r**2-458304*r**4
            -14065953*r**6-9844344*r**8+29971181*r**10-82284631*r**12+82263251*r**14
            -21971733*r**16+12986091*r**18+198521*r**20)+Q2**4*(296137-7535357*r**2
            +41204059*r**4+567722233*r**6+959490938*r**8-1067809778*r**10-695652170*r**12
            +3323824962*r**14-2478712067*r**16+454831663*r**18-232295633*r**20-2520827*r**22)
            +4*Q2**3*(8998+41960*r**2-5164273*r**4-48686966*r**6-86234775*r**8+542274664*r**10
            -291865910*r**12+615911492*r**14-664193564*r**16+225212080*r**18-29798617*r**20
            +8394290*r**22+5261*r**24)+(-1+r**2)**2*(-7059+261449*r**2-4553594*r**4
            +6583990*r**6+207784071*r**8+864106547*r**10-1118624476*r**12-1789282972*r**14
            +2702310683*r**16-1602327601*r**18+375124182*r**20-66490778*r**22+7221361*r**24
            +63797*r**26)+Q2**2*(-112509+2930819*r**2-22570366*r**4-98710222*r**6
            +264806801*r**8+1271379025*r**10+977073580*r**12-678369684*r**14+1932302149*r**16
            -3050265371*r**18+1394529874*r**20-357854494*r**22+66811175*r**24+820423*r**26)
            -4*Q2*(-12041+396924*r**2-5453378*r**4-5947146*r**6+135227813*r**8
            +686417082*r**10-941959208*r**12+216142996*r**14-1558550543*r**16+2153323224*r**18
            -1436334986*r**20+409479414*r**22-80665613*r**24+10004594*r**26+100468*r**28))*sqrtq2
            +logq2**4*(16588800*r**20*(1-Q2+r**2)*(-1629+2435*r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3+16588800*r**20*(-1629+2435*r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*sqrtq2)+logq2**3*(552960*r**16*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-2260*Q2**7+2*Q2**6*(725+3344*r**2)+6*Q2**5*(2850
            -1153*r**2+347*r**4)+Q2**4*(-31255+13790*r**2+11489*r**4-19900*r**6)
            +Q2**3*(50875-58465*r**2-8671*r**4+2309*r**6-2360*r**8)+2*(-1+r**2)**2*(
            -25915-9806*r**2+17004*r**4+82164*r**6-23381*r**8+8294*r**10)+Q2**2*(
            -121905-39660*r**2+28274*r**4+133652*r**6-79161*r**8+52800*r**10)+Q2*(137825
            +23557*r**2+82164*r**4-347766*r**6-379791*r**8+150769*r**10-53638*r**12))
            +552960*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(2260*Q2**8-2*Q2**7*(1855
            +4474*r**2)+2*Q2**6*(-7825+7528*r**2+2303*r**4)+Q2**5*(48355-3608*r**2
            -16325*r**4+21982*r**6)-10*Q2**4*(8213-4100*r**2-3395*r**4+1072*r**6
            +1754*r**8)-2*Q2**3*(-86390-16035*r**2+47705*r**4+70007*r**6-39555*r**8
            +27580*r**10)+2*(-1+r**2)**2*(-25915-35721*r**2+7198*r**4+99168*r**6
            +58783*r**8-15087*r**10+8294*r**12)+2*Q2**2*(-129865-92561*r**2-46775*r**4
            +254846*r**6+217141*r**8-88565*r**10+53219*r**12)+Q2*(189655+77334*r**2
            +84319*r**4-342302*r**6-386147*r**8-503462*r**10+177069*r**12-70226*r**14))*sqrtq2)
            +logq2**2*(-9216*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(155896*Q2**10
            -10*Q2**9*(76895+110876*r**2)+15*Q2**8*(82265+256877*r**2+203512*r**4)
            -5*Q2**7*(109989+676030*r**2+1383801*r**4+718908*r**6)+10*Q2**6*(51510
            -64653*r**2+241486*r**4+525129*r**6+17292*r**8)+3*Q2**5*(-927899+70480*r**2
            +91860*r**4-220600*r**6-989885*r**8+1348436*r**10)-10*Q2**4*(-361455
            -109381*r**2+55110*r**4+68824*r**6-207241*r**8-389445*r**10+373344*r**12)
            +5*Q2**3*(-178695-350046*r**2+337739*r**4+1650940*r**6-137309*r**8-165370*r**10
            -89031*r**12+61884*r**14)+30*Q2**2*(-41066+263305*r**2+547024*r**4-53215*r**6
            -193958*r**8+65103*r**10+14808*r**12-200369*r**14+44528*r**16)+(-1
            +r**2)**2*(-144949+2824437*r**2+10515983*r**4-15386791*r**6-4455195*r**8
            -1057021*r**10+128393*r**12-1264353*r**14+134696*r**16)-5*Q2*(-170695
            +1857244*r**2+4403238*r**4-4173584*r**6-2134400*r**8-6436416*r**10-151190*r**12
            +817696*r**14-1129737*r**16+154004*r**18))-9216*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(155896*Q2**10-10*Q2**9*(76895+110876*r**2)+15*Q2**8*(82265
            +256877*r**2+203512*r**4)-5*Q2**7*(109989+676030*r**2+1383801*r**4+718908*r**6)
            +10*Q2**6*(51510-64653*r**2+241486*r**4+525129*r**6+17292*r**8)+3*Q2**5*(
            -927899+70480*r**2+91860*r**4-220600*r**6-989885*r**8+1348436*r**10)
            -10*Q2**4*(-361455-109381*r**2+55110*r**4+68824*r**6-207241*r**8-389445*r**10
            +373344*r**12)+5*Q2**3*(-178695-350046*r**2+337739*r**4+1650940*r**6
            -137309*r**8-165370*r**10-89031*r**12+61884*r**14)+30*Q2**2*(-41066
            +263305*r**2+547024*r**4-53215*r**6-193958*r**8+65103*r**10+14808*r**12
            -200369*r**14+44528*r**16)+(-1+r**2)**2*(-144949+2824437*r**2+10515983*r**4
            -15386791*r**6-4455195*r**8-1057021*r**10+128393*r**12-1264353*r**14
            +134696*r**16)-5*Q2*(-170695+1857244*r**2+4403238*r**4-4173584*r**6
            -2134400*r**8-6436416*r**10-151190*r**12+817696*r**14-1129737*r**16
            +154004*r**18))*sqrtq2)+logq2*(-768*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(63204*Q2**13-2*Q2**12*(313339+277380*r**2)+2*Q2**11*(1185446
            +2320135*r**2+937875*r**4)-Q2**10*(4395977+12692582*r**2+12084793*r**4
            +2729484*r**6)+Q2**9*(3823365+13756463*r**2+10255033*r**4+9929989*r**6
            +183030*r**8)+2*Q2**8*(-212049-2181310*r**2+13616600*r**4+24673888*r**6
            +5833257*r**8+2406906*r**10)-4*Q2**7*(400041-207388*r**2+6798403*r**4
            +30392066*r**6+27341845*r**8+7345320*r**10+1411785*r**12)+2*Q2**6*(154353
            -60958*r**2-4358735*r**4+11809236*r**6+62548165*r**8+21823618*r**10
            +8840277*r**12+52020*r**14)+2*Q2**5*(588117-6606835*r**2-24414205*r**4
            +20103695*r**6-3030911*r**8-38309383*r**10+39308455*r**12+2156115*r**14
            +2295144*r**16)-2*Q2**4*(393795-9845576*r**2-52231216*r**4+30865656*r**6
            +10355018*r**8-25051392*r**10-44416136*r**12+40645904*r**14+4768107*r**16
            +1640640*r**18)-2*Q2**3*(40328+2473795*r**2+20936285*r**4-38407948*r**6
            -18523592*r**8-56870406*r**10+39196690*r**12+3711020*r**14-463072*r**16
            -2356093*r**18+73233*r**20)+2*(-1+r**2)**2*(7059-486536*r**2+3090013*r**4
            +39676330*r**6+19761842*r**8-154507424*r**10+88992238*r**12-23031988*r**14
            -9055205*r**16+790408*r**18-102635*r**20+46698*r**22)+Q2**2*(262367
            -7273102*r**2-2106233*r**4+166192356*r**6+76068450*r**8+50578780*r**10
            -65814798*r**12+71919288*r**14-123847361*r**16+30657970*r**18-2423417*r**20
            +1222500*r**22)-Q2*(103723-5250111*r**2+11163615*r**4+246102355*r**6
            +3624020*r**8-289514626*r**10-291911198*r**12+108710810*r**14+25190135*r**16
            -100411455*r**18+14554943*r**20-1502701*r**22+586890*r**24))+768*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(63204*Q2**14-2*Q2**13*(344941+308982*r**2)
            +Q2**12*(2997570+5821708*r**2+2430510*r**4)-Q2**11*(6766869+19703744*r**2
            +18600813*r**4+4605234*r**6)+Q2**10*(8219342+30845022*r**2+35032408*r**4
            +24744266*r**6+2912514*r**8)+Q2**9*(-4247463-21942448*r**2+3221704*r**4
            +29162754*r**6+1553495*r**8+4630782*r**10)-2*Q2**8*(588033-2808135*r**2
            +25032096*r**4+99074620*r**6+85190835*r**8+22930803*r**10+5230476*r**12)
            +2*Q2**7*(954435+324348*r**2+8823295*r**4+86190174*r**6+178015987*r**8
            +91197948*r**10+26354487*r**12+2875590*r**14)+4*Q2**6*(216882-3350115*r**2
            -9997256*r**4+6326597*r**6-38694156*r**8-61340583*r**10+4322280*r**12
            -3368091*r**14+1121562*r**16)-4*Q2**5*(490956-7932147*r**2-41626128*r**4
            +13277573*r**6+13713901*r**8-33195843*r**10-21708532*r**12+41055237*r**14
            +4609683*r**16+1967892*r**18)+2*Q2**4*(353467-11925576*r**2-83013077*r**4
            +17042388*r**6+59744266*r**8+42174032*r**10-108664218*r**12-7481252*r**14
            +45877083*r**16+8764840*r**18+1567407*r**20)+Q2**3*(343023-2244856*r**2
            +44713927*r**4+131249030*r**6-37794630*r**8-100209216*r**10-101162230*r**12
            +157734708*r**14-117351465*r**16+25019640*r**18-6989137*r**20+1368966*r**22)
            -2*(-1+r**2)**2*(7059-479477*r**2+2603477*r**4+42766343*r**6+59438172*r**8
            -134745582*r**10-65515186*r**12+65960250*r**14-32087193*r**16-8264797*r**18
            +687773*r**20-55937*r**22+46698*r**24)-2*Q2**2*(183045-6130423*r**2
            +892140*r**4+205094239*r**6+122942413*r**8-81433698*r**10-153573608*r**12
            +57407650*r**14-13368969*r**16-96800423*r**18+21394748*r**20-1351809*r**22
            +904695*r**24)+Q2*(117841-6147696*r**2+14053792*r**4+323285506*r**6
            +136724765*r**8-594600162*r**10+254112032*r**12-894248164*r**14+385902963*r**16
            -83483660*r**18-107333824*r**20+15136994*r**22-1307873*r**24+680286*r**26))*sqrtq2))/(97200*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+97200*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*sqrtq2+logq2**4*(2015539200*r**20*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3+2015539200*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**3*(-671846400*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-671846400*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2**2*(83980800*r**12*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+83980800*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)+logq2*(-4665600*(-Q2+(-1+r)**2)**3*r**8*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3-4665600*(-Q2+(-1+r)**2)**3*r**8*(1-Q2+r**2)*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2))+((-128*r**6*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(19*Q2**14+282*Q2**13*(1
            +r**2)-Q2**12*(3091+24994*r**2+3091*r**4)+8*Q2**11*(1468+21109*r**2
            +21109*r**4+1468*r**6)-Q2**10*(22929+429508*r**2+842398*r**4+429508*r**6
            +22929*r**8)+2*Q2**9*(11861+196905*r**2+601954*r**4+601954*r**6+196905*r**8
            +11861*r**10)+Q2**8*(-9399+236586*r**2+371247*r**4+1763900*r**6+371247*r**8
            +236586*r**10-9399*r**12)-48*Q2**7*(81+16094*r**2+44039*r**4+162216*r**6
            +162216*r**8+44039*r**10+16094*r**12+81*r**14)+Q2**6*(2217+491496*r**2
            +1407516*r**4+5890552*r**6+10367974*r**8+5890552*r**10+1407516*r**12
            +491496*r**14+2217*r**16)+Q2**5*(5198+54366*r**2-686520*r**4+694376*r**6
            -915068*r**8-915068*r**10+694376*r**12-686520*r**14+54366*r**16+5198*r**18)
            -Q2**4*(5241+148110*r**2-1331547*r**4+315528*r**6+2811026*r**8+766964*r**10
            +2811026*r**12+315528*r**14-1331547*r**16+148110*r**18+5241*r**20)+8*Q2**3*(74
            +2879*r**2-79999*r**4-72760*r**6+463054*r**8-719328*r**10-719328*r**12
            +463054*r**14-72760*r**16-79999*r**18+2879*r**20+74*r**22)+(-1+r**2)**2*(131
            -7796*r**2-226850*r**4-1011012*r**6+4060637*r**8-20862856*r**10+33503492*r**12
            -20862856*r**14+4060637*r**16-1011012*r**18-226850*r**20-7796*r**22
            +131*r**24)+Q2**2*(1429-7844*r**2-837182*r**4-2196852*r**6-124213*r**8
            +2220248*r**10-11762372*r**12+2220248*r**14-124213*r**16-2196852*r**18
            -837182*r**20-7844*r**22+1429*r**24)+Q2*(-786+22582*r**2+851092*r**4
            +2310964*r**6-9033670*r**8+34123682*r**10-23089864*r**12-23089864*r**14
            +34123682*r**16-9033670*r**18+2310964*r**20+851092*r**22+22582*r**24
            -786*r**26))-128*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(19*Q2**14
            +282*Q2**13*(1+r**2)-Q2**12*(3091+24994*r**2+3091*r**4)+8*Q2**11*(1468
            +21109*r**2+21109*r**4+1468*r**6)-Q2**10*(22929+429508*r**2+842398*r**4
            +429508*r**6+22929*r**8)+2*Q2**9*(11861+196905*r**2+601954*r**4+601954*r**6
            +196905*r**8+11861*r**10)+Q2**8*(-9399+236586*r**2+371247*r**4+1763900*r**6
            +371247*r**8+236586*r**10-9399*r**12)-48*Q2**7*(81+16094*r**2+44039*r**4
            +162216*r**6+162216*r**8+44039*r**10+16094*r**12+81*r**14)+Q2**6*(2217
            +491496*r**2+1407516*r**4+5890552*r**6+10367974*r**8+5890552*r**10+1407516*r**12
            +491496*r**14+2217*r**16)+Q2**5*(5198+54366*r**2-686520*r**4+694376*r**6
            -915068*r**8-915068*r**10+694376*r**12-686520*r**14+54366*r**16+5198*r**18)
            -Q2**4*(5241+148110*r**2-1331547*r**4+315528*r**6+2811026*r**8+766964*r**10
            +2811026*r**12+315528*r**14-1331547*r**16+148110*r**18+5241*r**20)+8*Q2**3*(74
            +2879*r**2-79999*r**4-72760*r**6+463054*r**8-719328*r**10-719328*r**12
            +463054*r**14-72760*r**16-79999*r**18+2879*r**20+74*r**22)+(-1+r**2)**2*(131
            -7796*r**2-226850*r**4-1011012*r**6+4060637*r**8-20862856*r**10+33503492*r**12
            -20862856*r**14+4060637*r**16-1011012*r**18-226850*r**20-7796*r**22
            +131*r**24)+Q2**2*(1429-7844*r**2-837182*r**4-2196852*r**6-124213*r**8
            +2220248*r**10-11762372*r**12+2220248*r**14-124213*r**16-2196852*r**18
            -837182*r**20-7844*r**22+1429*r**24)+Q2*(-786+22582*r**2+851092*r**4
            +2310964*r**6-9033670*r**8+34123682*r**10-23089864*r**12-23089864*r**14
            +34123682*r**16-9033670*r**18+2310964*r**20+851092*r**22+22582*r**24
            -786*r**26))*sqrtq2+logq2**4*(331776000*r**22*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3+331776000*r**22*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*sqrtq2)+logq2**3*(4423680*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(-20*Q2**7+74*Q2**6*(1+r**2)-2*Q2**5*(27+94*r**2+27*r**4)
            +Q2**4*(-65+102*r**2+102*r**4-65*r**6)-Q2**3*(25+8*r**2-44*r**4+8*r**6
            +25*r**8)+(-1+r**2)**2*(104-77*r**2+123*r**4+123*r**6-77*r**8+104*r**10)
            +Q2**2*(315-58*r**2+53*r**4+53*r**6-58*r**8+315*r**10)-Q2*(329-363*r**2
            +361*r**4+546*r**6+361*r**8-363*r**10+329*r**12))+4423680*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(20*Q2**8-94*Q2**7*(1+r**2)+16*Q2**6*(8
            +21*r**2+8*r**4)+Q2**5*(11-344*r**2-344*r**4+11*r**6)-5*Q2**4*(8-9*r**2
            -32*r**4-9*r**6+8*r**8)+(-1+r**4)**2*(104-181*r**2+304*r**4-181*r**6
            +104*r**8)-Q2**3*(340-25*r**2+17*r**4+17*r**6-25*r**8+340*r**10)+2*Q2**2*(322
            -53*r**2+178*r**4+326*r**6+178*r**8-53*r**10+322*r**12)-Q2*(433-319*r**2
            +379*r**4+707*r**6+707*r**8+379*r**10-319*r**12+433*r**14))*sqrtq2)
            +logq2**2*(36864*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(
            -768*Q2**10+5000*Q2**9*(1+r**2)-5*Q2**8*(2496+4817*r**2+2496*r**4)+10*Q2**7*(1422
            +3851*r**2+3851*r**4+1422*r**6)-10*Q2**6*(672+1761*r**2+1756*r**4+1761*r**6
            +672*r**8)+4*Q2**5*(579-1255*r**2-7665*r**4-7665*r**6-1255*r**8+579*r**10)
            -10*Q2**4*(360+355*r**2-332*r**4-3708*r**6-332*r**8+355*r**10+360*r**12)
            -10*Q2**3*(102-471*r**2+487*r**4-982*r**6-982*r**8+487*r**10-471*r**12
            +102*r**14)+10*Q2**2*(768+719*r**2+9732*r**4-2283*r**6-952*r**8-2283*r**10
            +9732*r**12+719*r**14+768*r**16)+(-1+r**2)**2*(1552+3399*r**2+36046*r**4
            -16907*r**6+5820*r**8-16907*r**10+36046*r**12+3399*r**14+1552*r**16)
            -20*Q2*(309+272*r**2+5219*r**4-4899*r**6+4499*r**8+4499*r**10-4899*r**12
            +5219*r**14+272*r**16+309*r**18))-36864*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(768*Q2**10-5000*Q2**9*(1+r**2)+5*Q2**8*(2496+4817*r**2+2496*r**4)
            -10*Q2**7*(1422+3851*r**2+3851*r**4+1422*r**6)+10*Q2**6*(672+1761*r**2
            +1756*r**4+1761*r**6+672*r**8)-4*Q2**5*(579-1255*r**2-7665*r**4-7665*r**6
            -1255*r**8+579*r**10)+10*Q2**4*(360+355*r**2-332*r**4-3708*r**6-332*r**8
            +355*r**10+360*r**12)+10*Q2**3*(102-471*r**2+487*r**4-982*r**6-982*r**8
            +487*r**10-471*r**12+102*r**14)-10*Q2**2*(768+719*r**2+9732*r**4-2283*r**6
            -952*r**8-2283*r**10+9732*r**12+719*r**14+768*r**16)-(-1+r**2)**2*(1552
            +3399*r**2+36046*r**4-16907*r**6+5820*r**8-16907*r**10+36046*r**12
            +3399*r**14+1552*r**16)+20*Q2*(309+272*r**2+5219*r**4-4899*r**6+4499*r**8
            +4499*r**10-4899*r**12+5219*r**14+272*r**16+309*r**18))*sqrtq2)+logq2*(6144*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(-92*Q2**13+866*Q2**12*(1+r**2)-2*Q2**11*(1577
            +3466*r**2+1577*r**4)+Q2**10*(5425+18126*r**2+18126*r**4+5425*r**6)
            -Q2**9*(3345+12866*r**2-1644*r**4+12866*r**6+3345*r**8)-2*Q2**8*(1488
            +10923*r**2+72010*r**4+72010*r**6+10923*r**8+1488*r**10)+Q2**7*(6048
            +45687*r**2+262312*r**4+458810*r**6+262312*r**8+45687*r**10+6048*r**12)
            -Q2**6*(2442+29637*r**2+137597*r**4+352960*r**6+352960*r**8+137597*r**10
            +29637*r**12+2442*r**14)+Q2**5*(-1650+11847*r**2+10102*r**4-58135*r**6
            -77824*r**8-58135*r**10+10102*r**12+11847*r**14-1650*r**16)+Q2**4*(1670
            -10959*r**2-73259*r**4+115911*r**6+76837*r**8+76837*r**10+115911*r**12
            -73259*r**14-10959*r**16+1670*r**18)+r**2*(-1+r**2)**2*(2327+37541*r**2
            -49270*r**4+433894*r**6-316492*r**8-316492*r**10+433894*r**12-49270*r**14
            +37541*r**16+2327*r**18)+Q2**3*(-182+1321*r**2+35350*r**4-68880*r**6
            +154544*r**8+10574*r**10+154544*r**12-68880*r**14+35350*r**16+1321*r**18
            -182*r**20)+Q2**2*(-239+11747*r**2+119063*r**4-25275*r**6+515482*r**8
            -167178*r**10-167178*r**12+515482*r**14-25275*r**16+119063*r**18+11747*r**20
            -239*r**22)+Q2*(71-9681*r**2-121454*r**4+204015*r**6-1123175*r**8
            +1016098*r**10-795748*r**12+1016098*r**14-1123175*r**16+204015*r**18
            -121454*r**20-9681*r**22+71*r**24))+6144*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(92*Q2**14-958*Q2**13*(1+r**2)+12*Q2**12*(335+722*r**2+335*r**4)
            -Q2**11*(8579+28212*r**2+28212*r**4+8579*r**6)+Q2**10*(8770+36417*r**2
            +34608*r**4+36417*r**6+8770*r**8)+Q2**9*(-369+5635*r**2+132798*r**4
            +132798*r**6+5635*r**8-369*r**10)-3*Q2**8*(3008+23503*r**2+142726*r**4
            +248950*r**6+142726*r**8+23503*r**10+3008*r**12)+2*Q2**7*(4245+40686*r**2
            +222798*r**4+537041*r**6+537041*r**8+222798*r**10+40686*r**12+4245*r**14)
            -2*Q2**6*(396+21963*r**2+88668*r**4+216211*r**6+314048*r**8+216211*r**10
            +88668*r**12+21963*r**14+396*r**16)+r**2*(-1+r**4)**2*(2327+35214*r**2
            -84484*r**4+518378*r**6-834870*r**8+518378*r**10-84484*r**12+35214*r**14
            +2327*r**16)-4*Q2**5*(830-5289*r**2-23802*r**4+40986*r**6+53199*r**8
            +53199*r**10+40986*r**12-23802*r**14-5289*r**16+830*r**18)+2*Q2**4*(926
            -5305*r**2-59784*r**4+55766*r**6+19102*r**8+71550*r**10+19102*r**12
            +55766*r**14-59784*r**16-5305*r**18+926*r**20)+Q2**3*(57-10608*r**2
            -82392*r**4-8255*r**6-429818*r**8+332296*r**10+332296*r**12-429818*r**14
            -8255*r**16-82392*r**18-10608*r**20+57*r**22)+Q2**2*(-310+21189*r**2
            +252264*r**4-110227*r**6+1613382*r**8-667794*r**10+461392*r**12-667794*r**14
            +1613382*r**16-110227*r**18+252264*r**20+21189*r**22-310*r**24)+Q2*(71
            -11937*r**2-164022*r**4+204586*r**6-1489135*r**8+1126473*r**10-530036*r**12
            -530036*r**14+1126473*r**16-1489135*r**18+204586*r**20-164022*r**22
            -11937*r**24+71*r**26))*sqrtq2))*math.log(mu0))/(3600*r**4*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4+3600*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2+logq2**4*(74649600*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+74649600*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**3*(-24883200*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-24883200*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)+logq2**2*(3110400*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+3110400*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+logq2*(
            -172800*(-Q2+(-1+r)**2)**3*r**8*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3-172800*(-Q2+(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2))+((4*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(-13+4*Q2**10+404*r**2-6453*r**4-53600*r**6-142382*r**8+644712*r**10
            -641774*r**12+323008*r**14-51045*r**16+13412*r**18+131*r**20+7*Q2**9*(1
            +r**2)+3*Q2**8*(-41+102*r**2+47*r**4)-6*Q2**7*(-57+312*r**2+1834*r**4
            +145*r**6)+6*Q2**6*(-63+623*r**2+7092*r**4+6423*r**6+249*r**8)-6*Q2**5*(
            -14+369*r**2+6937*r**4+16621*r**6+4867*r**8+80*r**10)-2*Q2**4*(-84
            +891*r**2+4110*r**4-10306*r**6-20622*r**8+23091*r**10+576*r**12)+2*Q2**3*(
            -51+1152*r**2+8712*r**4-14165*r**6+78457*r**8+13926*r**10+36702*r**12
            +507*r**14)+6*Q2**2*(-7+57*r**2+354*r**4+10083*r**6+11218*r**8-19285*r**10
            -5374*r**12-1151*r**14+25*r**16)+Q2*(53-1233*r**2+5058*r**4+62878*r**6
            -3216*r**8+163512*r**10-224402*r**12+73362*r**14-32373*r**16-439*r**18))
            -4*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(13+4*Q2**11-391*r**2
            +6049*r**4+60053*r**6+195982*r**8-502330*r**10-2938*r**12+318766*r**14
            -271963*r**16+37633*r**18-13543*r**20-131*r**22+3*Q2**10*(1+r**2)+2*Q2**9*(
            -65+146*r**2+67*r**4)-3*Q2**8*(-155+685*r**2+3817*r**4+337*r**6)+12*Q2**7*(
            -60+439*r**2+4619*r**4+4201*r**6+197*r**8)-6*Q2**6*(-77+929*r**2+14652*r**4
            +30136*r**6+11539*r**8+329*r**10)-4*Q2**5*(-21-87*r**2-8904*r**4-40490*r**6
            -42543*r**8+4125*r**10+168*r**12)+6*Q2**4*(-45+653*r**2+4571*r**4-6787*r**6
            +15843*r**8+5465*r**10+20123*r**12+361*r**14)-4*Q2**3*(-15+465*r**2
            +4401*r**4-17851*r**6+15319*r**8+75119*r**10+33375*r**12+20331*r**14
            +216*r**16)+Q2**2*(95-1533*r**2+2592*r**4+256*r**6-131022*r**8+211914*r**10
            -76448*r**12+112512*r**14-25617*r**16-589*r**18)+6*Q2*(-11+264*r**2
            -1713*r**4-20256*r**6-33674*r**8+80736*r**10-96814*r**12+79008*r**14
            -15339*r**16+7704*r**18+95*r**20))*sqrtq2+logq2**3*(172800*(-Q2+(-1
            +r)**2)*r**14*(1-Q2+r**2)*(-3+5*r**2)*(-Q2+(1+r)**2)+172800*r**14*(
            -3+5*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**2*(2880*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-163+40*Q2**5+26*r**2+106*r**4+466*r**6
            -179*r**8+104*r**10-4*Q2**4*(17+44*r**2)+Q2**3*(-23+141*r**2+244*r**4)
            +Q2**2*(17+122*r**2-167*r**4-16*r**6)+Q2*(197-143*r**2-11*r**4+213*r**6
            -196*r**8))+2880*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(
            -163+40*Q2**5+26*r**2+106*r**4+466*r**6-179*r**8+104*r**10-4*Q2**4*(17
            +44*r**2)+Q2**3*(-23+141*r**2+244*r**4)+Q2**2*(17+122*r**2-167*r**4
            -16*r**6)+Q2*(197-143*r**2-11*r**4+213*r**6-196*r**8))*sqrtq2)+logq2*(48*r**6*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(39+184*Q2**8-3867*r**2
            -25973*r**4+50081*r**6-3175*r**8-8589*r**10+11917*r**12+823*r**14+344*r**16
            -8*Q2**7*(149+129*r**2)+Q2**6*(2367+5475*r**2+1772*r**4)-2*Q2**5*(667
            +3104*r**2+3119*r**4+82*r**6)-Q2**4*(895-535*r**2+7961*r**4+3335*r**6
            +2520*r**8)+4*Q2**3*(249-390*r**2+1196*r**4+6626*r**6+2435*r**8+524*r**10)
            +Q2**2*(97+1297*r**2+15474*r**4-10226*r**6-7811*r**8-3923*r**10+412*r**12)
            -2*Q2*(131-2680*r**2-9071*r**4+10450*r**6-13055*r**8+9404*r**10+675*r**12
            +546*r**14))+48*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(39+184*Q2**8
            -3867*r**2-25973*r**4+50081*r**6-3175*r**8-8589*r**10+11917*r**12+823*r**14
            +344*r**16-8*Q2**7*(149+129*r**2)+Q2**6*(2367+5475*r**2+1772*r**4)
            -2*Q2**5*(667+3104*r**2+3119*r**4+82*r**6)-Q2**4*(895-535*r**2+7961*r**4
            +3335*r**6+2520*r**8)+4*Q2**3*(249-390*r**2+1196*r**4+6626*r**6+2435*r**8
            +524*r**10)+Q2**2*(97+1297*r**2+15474*r**4-10226*r**6-7811*r**8-3923*r**10
            +412*r**12)-2*Q2*(131-2680*r**2-9071*r**4+10450*r**6-13055*r**8+9404*r**10
            +675*r**12+546*r**14))*sqrtq2))*math.log(mus))/(-108*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-108*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(
            -186624*r**14*(-1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2
            +3*r**4))+186624*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**2*(
            -46656*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -46656*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(3888*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+3888*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2))+((-4*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(
            -13+4*Q2**10+404*r**2-6453*r**4-53600*r**6-142382*r**8+644712*r**10
            -641774*r**12+323008*r**14-51045*r**16+13412*r**18+131*r**20+7*Q2**9*(1
            +r**2)+3*Q2**8*(-41+102*r**2+47*r**4)-6*Q2**7*(-57+312*r**2+1834*r**4
            +145*r**6)+6*Q2**6*(-63+623*r**2+7092*r**4+6423*r**6+249*r**8)-6*Q2**5*(
            -14+369*r**2+6937*r**4+16621*r**6+4867*r**8+80*r**10)-2*Q2**4*(-84
            +891*r**2+4110*r**4-10306*r**6-20622*r**8+23091*r**10+576*r**12)+2*Q2**3*(
            -51+1152*r**2+8712*r**4-14165*r**6+78457*r**8+13926*r**10+36702*r**12
            +507*r**14)+6*Q2**2*(-7+57*r**2+354*r**4+10083*r**6+11218*r**8-19285*r**10
            -5374*r**12-1151*r**14+25*r**16)+Q2*(53-1233*r**2+5058*r**4+62878*r**6
            -3216*r**8+163512*r**10-224402*r**12+73362*r**14-32373*r**16-439*r**18))
            +4*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(13+4*Q2**11-391*r**2
            +6049*r**4+60053*r**6+195982*r**8-502330*r**10-2938*r**12+318766*r**14
            -271963*r**16+37633*r**18-13543*r**20-131*r**22+3*Q2**10*(1+r**2)+2*Q2**9*(
            -65+146*r**2+67*r**4)-3*Q2**8*(-155+685*r**2+3817*r**4+337*r**6)+12*Q2**7*(
            -60+439*r**2+4619*r**4+4201*r**6+197*r**8)-6*Q2**6*(-77+929*r**2+14652*r**4
            +30136*r**6+11539*r**8+329*r**10)-4*Q2**5*(-21-87*r**2-8904*r**4-40490*r**6
            -42543*r**8+4125*r**10+168*r**12)+6*Q2**4*(-45+653*r**2+4571*r**4-6787*r**6
            +15843*r**8+5465*r**10+20123*r**12+361*r**14)-4*Q2**3*(-15+465*r**2
            +4401*r**4-17851*r**6+15319*r**8+75119*r**10+33375*r**12+20331*r**14
            +216*r**16)+Q2**2*(95-1533*r**2+2592*r**4+256*r**6-131022*r**8+211914*r**10
            -76448*r**12+112512*r**14-25617*r**16-589*r**18)+6*Q2*(-11+264*r**2
            -1713*r**4-20256*r**6-33674*r**8+80736*r**10-96814*r**12+79008*r**14
            -15339*r**16+7704*r**18+95*r**20))*sqrtq2+logq2**3*(-172800*(-Q2+(-1
            +r)**2)*r**14*(1-Q2+r**2)*(-3+5*r**2)*(-Q2+(1+r)**2)-172800*r**14*(
            -3+5*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**2*(-2880*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-163+40*Q2**5+26*r**2+106*r**4+466*r**6
            -179*r**8+104*r**10-4*Q2**4*(17+44*r**2)+Q2**3*(-23+141*r**2+244*r**4)
            +Q2**2*(17+122*r**2-167*r**4-16*r**6)+Q2*(197-143*r**2-11*r**4+213*r**6
            -196*r**8))-2880*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(
            -163+40*Q2**5+26*r**2+106*r**4+466*r**6-179*r**8+104*r**10-4*Q2**4*(17
            +44*r**2)+Q2**3*(-23+141*r**2+244*r**4)+Q2**2*(17+122*r**2-167*r**4
            -16*r**6)+Q2*(197-143*r**2-11*r**4+213*r**6-196*r**8))*sqrtq2)+logq2*(
            -48*r**6*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(39+184*Q2**8
            -3867*r**2-25973*r**4+50081*r**6-3175*r**8-8589*r**10+11917*r**12+823*r**14
            +344*r**16-8*Q2**7*(149+129*r**2)+Q2**6*(2367+5475*r**2+1772*r**4)
            -2*Q2**5*(667+3104*r**2+3119*r**4+82*r**6)-Q2**4*(895-535*r**2+7961*r**4
            +3335*r**6+2520*r**8)+4*Q2**3*(249-390*r**2+1196*r**4+6626*r**6+2435*r**8
            +524*r**10)+Q2**2*(97+1297*r**2+15474*r**4-10226*r**6-7811*r**8-3923*r**10
            +412*r**12)-2*Q2*(131-2680*r**2-9071*r**4+10450*r**6-13055*r**8+9404*r**10
            +675*r**12+546*r**14))-48*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(39
            +184*Q2**8-3867*r**2-25973*r**4+50081*r**6-3175*r**8-8589*r**10+11917*r**12
            +823*r**14+344*r**16-8*Q2**7*(149+129*r**2)+Q2**6*(2367+5475*r**2+1772*r**4)
            -2*Q2**5*(667+3104*r**2+3119*r**4+82*r**6)-Q2**4*(895-535*r**2+7961*r**4
            +3335*r**6+2520*r**8)+4*Q2**3*(249-390*r**2+1196*r**4+6626*r**6+2435*r**8
            +524*r**10)+Q2**2*(97+1297*r**2+15474*r**4-10226*r**6-7811*r**8-3923*r**10
            +412*r**12)-2*Q2*(131-2680*r**2-9071*r**4+10450*r**6-13055*r**8+9404*r**10
            +675*r**12+546*r**14))*sqrtq2))*math.log(2*muWC))/(-100*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-100*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+logq2**3*(
            -172800*r**14*(-1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2
            +3*r**4))+172800*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**2*(
            -43200*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -43200*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2*(3600*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+3600*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2))+((32*(Q2-(-1+r)**2)**4*r**4*(1-Q2+r**2)*(Q2-(1
            +r)**2)**4*(-4*Q2**15+Q2**14*(5+233*r**2)+8*Q2**13*(17+389*r**2+407*r**4)
            -Q2**12*(733+34683*r**2+287595*r**4+35821*r**6)+4*Q2**11*(412+33048*r**2
            +486147*r**4+487842*r**6+34135*r**8)-Q2**10*(1639+260939*r**2+4948398*r**4
            +9736566*r**6+4981139*r**8+268711*r**10)+4*Q2**9*(-55+70286*r**2+1131460*r**4
            +3443454*r**6+3450409*r**8+1155080*r**10+70886*r**12)+Q2**8*(2343-136479*r**2
            +2795343*r**4+5111569*r**6+22171285*r**8+4918947*r**10+2592021*r**12
            -122037*r**14)-4*Q2**7*(561+2736*r**2+2260530*r**4+6528724*r**6+23831104*r**8
            +23689720*r**10+6369618*r**12+2197740*r**14+8787*r**16)+Q2**6*(319+13611*r**2
            +5769084*r**4+17608284*r**6+73145490*r**8+127125402*r**10+71988396*r**12
            +16637484*r**14+5742999*r**16+24835*r**18)+8*Q2**5*(110+6011*r**2+82047*r**4
            -1000990*r**6+948676*r**8-1379844*r**10-1224908*r**12+1004762*r**14
            -887910*r**16+39221*r**18+6953*r**20)-Q2**4*(535+48577*r**2+1792765*r**4
            -15084869*r**6+3780966*r**8+33244922*r**10+14098778*r**12+39233862*r**14
            +3641731*r**16-14403899*r**18+1414825*r**20+57727*r**22)+4*Q2**3*(-26
            +1848*r**2+70119*r**4-1840046*r**6-1893815*r**8+10514648*r**10-17394166*r**12
            -17125948*r**14+11930836*r**16-1790480*r**18-1815537*r**20+56298*r**22
            +1789*r**24)+(-1+r**2)**2*(13+1077*r**2-84362*r**4-2710930*r**6-12410537*r**8
            +46717511*r**10-246142588*r**12+401881844*r**14-253179301*r**16+51259747*r**18
            -12718714*r**20-2576354*r**22-106047*r**24+1441*r**26)+Q2**2*(227+11127*r**2
            -47310*r**4-9857798*r**6-26865439*r**8-4501155*r**10+24286348*r**12
            -141507620*r**14+28258629*r**16+2236529*r**18-28131902*r**20-9236310*r**22
            -203145*r**24+15419*r**26)-4*Q2*(23+1582*r**2-57432*r**4-2531102*r**6
            -7188975*r**8+25934624*r**10-101057834*r**12+71217244*r**14+68358169*r**16
            -103788010*r**18+29056668*r**20-7552958*r**22-2376897*r**24-84452*r**26
            +2150*r**28))-32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**15
            -Q2**14*(5+233*r**2)-8*Q2**13*(17+389*r**2+407*r**4)+Q2**12*(733+34683*r**2
            +287595*r**4+35821*r**6)-4*Q2**11*(412+33048*r**2+486147*r**4+487842*r**6
            +34135*r**8)+Q2**10*(1639+260939*r**2+4948398*r**4+9736566*r**6+4981139*r**8
            +268711*r**10)-4*Q2**9*(-55+70286*r**2+1131460*r**4+3443454*r**6+3450409*r**8
            +1155080*r**10+70886*r**12)+Q2**8*(-2343+136479*r**2-2795343*r**4-5111569*r**6
            -22171285*r**8-4918947*r**10-2592021*r**12+122037*r**14)+4*Q2**7*(561
            +2736*r**2+2260530*r**4+6528724*r**6+23831104*r**8+23689720*r**10+6369618*r**12
            +2197740*r**14+8787*r**16)-Q2**6*(319+13611*r**2+5769084*r**4+17608284*r**6
            +73145490*r**8+127125402*r**10+71988396*r**12+16637484*r**14+5742999*r**16
            +24835*r**18)-8*Q2**5*(110+6011*r**2+82047*r**4-1000990*r**6+948676*r**8
            -1379844*r**10-1224908*r**12+1004762*r**14-887910*r**16+39221*r**18
            +6953*r**20)+Q2**4*(535+48577*r**2+1792765*r**4-15084869*r**6+3780966*r**8
            +33244922*r**10+14098778*r**12+39233862*r**14+3641731*r**16-14403899*r**18
            +1414825*r**20+57727*r**22)-4*Q2**3*(-26+1848*r**2+70119*r**4-1840046*r**6
            -1893815*r**8+10514648*r**10-17394166*r**12-17125948*r**14+11930836*r**16
            -1790480*r**18-1815537*r**20+56298*r**22+1789*r**24)+Q2**2*(-227-11127*r**2
            +47310*r**4+9857798*r**6+26865439*r**8+4501155*r**10-24286348*r**12
            +141507620*r**14-28258629*r**16-2236529*r**18+28131902*r**20+9236310*r**22
            +203145*r**24-15419*r**26)-(-1+r**2)**2*(13+1077*r**2-84362*r**4-2710930*r**6
            -12410537*r**8+46717511*r**10-246142588*r**12+401881844*r**14-253179301*r**16
            +51259747*r**18-12718714*r**20-2576354*r**22-106047*r**24+1441*r**26)
            +4*Q2*(23+1582*r**2-57432*r**4-2531102*r**6-7188975*r**8+25934624*r**10
            -101057834*r**12+71217244*r**14+68358169*r**16-103788010*r**18+29056668*r**20
            -7552958*r**22-2376897*r**24-84452*r**26+2150*r**28))*sqrtq2+logq2**4*(
            -16588800*r**20*(1-Q2+r**2)*(3+55*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3-16588800*r**20*(3+55*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**3*(-552960*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-500*Q2**7
            +2*Q2**6*(925+952*r**2)-2*Q2**5*(690+2387*r**2+807*r**4)+Q2**4*(-1535
            +2510*r**2+2737*r**4-1220*r**6)-Q2**3*(685+65*r**2-1057*r**4+283*r**6
            +640*r**8)+2*(-1+r**2)**2*(1285-898*r**2+1432*r**4+1312*r**6-873*r**8
            +1222*r**10)+Q2**2*(7815-1340*r**2+1242*r**4+956*r**6-1193*r**8+7320*r**10)
            -Q2*(8135-8701*r**2+8788*r**4+12358*r**6+7863*r**8-8297*r**10+7694*r**12))
            -552960*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(500*Q2**8-2*Q2**7*(1175
            +1202*r**2)+Q2**6*(3230+8528*r**2+3518*r**4)-Q2**5*(-155+8664*r**2
            +9125*r**4+394*r**6)-10*Q2**4*(85-104*r**2-419*r**4-180*r**6+58*r**8)
            -2*Q2**3*(4250-295*r**2+125*r**4+91*r**6-135*r**8+3980*r**10)+2*(
            -1+r**2)**2*(1285+387*r**2+534*r**4+2744*r**6+439*r**8+349*r**10+1222*r**12)
            +2*Q2**2*(7975-1113*r**2+4345*r**4+7278*r**6+3813*r**8-1085*r**10+7507*r**12)
            -Q2*(10705-7502*r**2+9113*r**4+16246*r**6+16091*r**8+8126*r**10-7237*r**12
            +10138*r**14))*sqrtq2)+logq2**2*(-9216*r**12*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3*(-9208*Q2**10+10*Q2**9*(6031+5996*r**2)-5*Q2**8*(30315
            +58283*r**2+29928*r**4)+5*Q2**7*(34869+94038*r**2+93425*r**4+34092*r**6)
            -10*Q2**6*(8310+21911*r**2+20862*r**4+21037*r**6+8076*r**8)+Q2**5*(25761
            -58720*r**2-388620*r**4-413160*r**6-77785*r**8+28596*r**10)-10*Q2**4*(3951
            +4401*r**2-4150*r**4-48328*r**6-10119*r**8+1841*r**10+4416*r**12)-5*Q2**3*(2505
            -10838*r**2+10467*r**4-26420*r**6-21037*r**8+13950*r**10-9823*r**12
            +2412*r**14)+10*Q2**2*(8958+10241*r**2+120480*r**4-27951*r**6-12718*r**8
            -26361*r**10+114312*r**12+7535*r**14+9264*r**16)+(-1+r**2)**2*(18197
            +45639*r**2+448201*r**4-229477*r**6+61035*r**8-203087*r**10+429071*r**12
            +38109*r**14+18712*r**16)-5*Q2*(14455+16548*r**2+257866*r**4-244768*r**6
            +212400*r**8+201328*r**10-231130*r**12+248592*r**14+10921*r**16+14908*r**18))
            +9216*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(9208*Q2**10-10*Q2**9*(6031
            +5996*r**2)+5*Q2**8*(30315+58283*r**2+29928*r**4)-5*Q2**7*(34869+94038*r**2
            +93425*r**4+34092*r**6)+10*Q2**6*(8310+21911*r**2+20862*r**4+21037*r**6
            +8076*r**8)+Q2**5*(-25761+58720*r**2+388620*r**4+413160*r**6+77785*r**8
            -28596*r**10)+10*Q2**4*(3951+4401*r**2-4150*r**4-48328*r**6-10119*r**8
            +1841*r**10+4416*r**12)+5*Q2**3*(2505-10838*r**2+10467*r**4-26420*r**6
            -21037*r**8+13950*r**10-9823*r**12+2412*r**14)-10*Q2**2*(8958+10241*r**2
            +120480*r**4-27951*r**6-12718*r**8-26361*r**10+114312*r**12+7535*r**14
            +9264*r**16)-(-1+r**2)**2*(18197+45639*r**2+448201*r**4-229477*r**6
            +61035*r**8-203087*r**10+429071*r**12+38109*r**14+18712*r**16)+5*Q2*(14455
            +16548*r**2+257866*r**4-244768*r**6+212400*r**8+201328*r**10-231130*r**12
            +248592*r**14+10921*r**16+14908*r**18))*sqrtq2)+logq2*(-768*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(-2116*Q2**13+2*Q2**12*(9955+9996*r**2)
            -2*Q2**11*(36270+80055*r**2+36539*r**4)+Q2**10*(125041+417430*r**2+418377*r**4
            +126612*r**6)-Q2**9*(78125+285599*r**2-76551*r**4+290869*r**6+80830*r**8)
            -2*Q2**8*(33039+271322*r**2+1763240*r**4+1751600*r**6+261537*r**8+31674*r**10)
            +4*Q2**7*(34185+278258*r**2+1608947*r**4+2796150*r**6+1587077*r**8+268854*r**10
            +34089*r**12)-2*Q2**6*(27705+360182*r**2+1722117*r**4+4344660*r**6+4303845*r**8
            +1664630*r**10+345417*r**12+29532*r**14)-2*Q2**5*(18621-133423*r**2
            -120181*r**4+677387*r**6+1088033*r**8+805941*r**10-90193*r**12-137001*r**14
            +15792*r**16)+2*Q2**4*(18875-117188*r**2-835868*r**4+1329492*r**6+1043934*r**8
            +1300564*r**10+1589972*r**12-821468*r**14-130353*r**16+17240*r**18)
            +Q2**3*(-4256+26894*r**2+820650*r**4-1508760*r**6+3825136*r**8+322532*r**10
            +3438116*r**12-1757480*r**14+788720*r**16+37774*r**18-4686*r**20)+Q2**2*(
            -5175+266726*r**2+2854737*r**4-273340*r**6+12669998*r**8-4101164*r**10
            -3886978*r**12+12045848*r**14-744695*r**16+2851142*r**18+272049*r**20
            -3548*r**22)+2*(-1+r**2)**2*(13+26788*r**2+452311*r**4-513090*r**6
            +5198374*r**8-4049808*r**10-3601374*r**12+5119564*r**14-602835*r**16
            +448076*r**18+27495*r**20+86*r**22)+Q2*(1475-221351*r**2-2928433*r**4
            +4431915*r**6-26897380*r**8+25075790*r**10-18521598*r**12+23735786*r**14
            -26581345*r**16+4987225*r**18-2900945*r**20-226581*r**22+642*r**24))
            -768*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(2116*Q2**14-2*Q2**13*(11013
            +11054*r**2)+Q2**12*(92450+200012*r**2+93070*r**4)-Q2**11*(197581+650080*r**2
            +651565*r**4+199690*r**6)+Q2**10*(203166+828070*r**2+759256*r**4+835858*r**6
            +207442*r**8)+Q2**9*(-12047+178920*r**2+3317432*r**4+3288882*r**6+151375*r**8
            -17482*r**10)-2*Q2**8*(101409+860877*r**2+5252456*r**4+9107140*r**6
            +5187291*r**8+830919*r**10+99852*r**12)+2*Q2**7*(96075+985068*r**2+5496527*r**4
            +13154854*r**6+13070299*r**8+5376492*r**10+951303*r**12+97710*r**14)
            -4*Q2**6*(4542+260655*r**2+1101240*r**4+2694695*r**6+3780236*r**8+2581267*r**10
            +1050120*r**12+255975*r**14+6870*r**16)-4*Q2**5*(18748-115995*r**2-544736*r**4
            +943349*r**6+1404677*r**8+1597269*r**10+1152860*r**12-524331*r**14-125781*r**16
            +16516*r**18)+Q2**4*(42006-223520*r**2-2726762*r**4+2496008*r**6+921716*r**8
            +4366464*r**10+2342956*r**12+3294488*r**14-2692362*r**16-264000*r**18
            +39166*r**20)-Q2**3*(-919+244088*r**2+2007193*r**4+414770*r**6+10353622*r**8
            -8248832*r**10-7647626*r**12+10365212*r**14+224065*r**16+2024648*r**18
            +238961*r**20+1138*r**22)+2*(-1+r**2)**2*(13+26801*r**2+479099*r**4
            -60779*r**6+4685284*r**8+1148566*r**10-7651182*r**12+1518190*r**14+4516729*r**16
            -154759*r**18+475571*r**20+27581*r**22+86*r**24)-2*Q2**2*(3325-241451*r**2
            -3024948*r**4+925259*r**6-19647019*r**8+8253478*r**10-5266728*r**12
            +7788458*r**14-18941249*r**16+1440389*r**18-3012068*r**20-247541*r**22
            +2095*r**24)+Q2*(1449-273400*r**2-3947280*r**4+4285330*r**6-35819195*r**8
            +28097702*r**10-12839040*r**12-11330820*r**14+26041115*r**16-35140740*r**18
            +5029264*r**20-3913870*r**22-280585*r**24+470*r**26))*sqrtq2))*math.log(r))/(10800*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+10800*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*sqrtq2+logq2**4*(223948800*r**20*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3+223948800*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)
            +logq2**3*(-74649600*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-74649600*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+logq2**2*(9331200*r**12*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+9331200*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2)+logq2*(-518400*(-Q2+(-1+r)**2)**3*r**8*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3-518400*(-Q2+(-1+r)**2)**3*r**8*(1-Q2+r**2)*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)))+(flagPERP*muWC**3*(
            -1440*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(-64+133*r**2+60*Q2**5*r**2
            +1223*r**4-10172*r**6-7372*r**8-1313*r**10+1005*r**12-32*Q2**4*(2+9*r**2
            +15*r**4)+Q2**3*(16+1453*r**2+2522*r**4+1485*r**6)-Q2**2*(-96+1069*r**2
            +3351*r**4+3783*r**6+765*r**8)-Q2*(-16+409*r**2+1378*r**4+146*r**6
            -462*r**8+1305*r**10))-2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(27
            +460*Q2**11-5281*r**2+3007*r**4-221525*r**6-568062*r**8+1862442*r**10
            -6856934*r**12+1636338*r**14+127395*r**16+49207*r**18-1049*r**20+35*r**22
            -1240*Q2**10*(1+r**2)+Q2**9*(-125+3558*r**2-125*r**4)+Q2**8*(987+r**2
            -4463*r**4+2475*r**6)-2*Q2**7*(-1802+8311*r**2+50954*r**4+4407*r**6
            +150*r**8)+Q2**6*(-4604+20782*r**2+325038*r**4+294014*r**6+28150*r**8
            -2820*r**10)+2*Q2**5*(-1011+10443*r**2-67095*r**4-357658*r**6-48031*r**8
            -853*r**10+165*r**12)+Q2**4*(3490-20928*r**2-209888*r**4+392158*r**6
            +839654*r**8-327160*r**10-38328*r**12+2250*r**14)+Q2**3*(328-32346*r**2
            +87100*r**4+421330*r**6+1121864*r**8-91758*r**10+273404*r**12+15718*r**14
            -600*r**16)-2*Q2**2*(482-8581*r**2-6865*r**4+350793*r**6+1495671*r**8
            +1043439*r**10+497177*r**12-5249*r**14-7697*r**16+350*r**18)+Q2*(59
            +14028*r**2-55101*r**4-351056*r**6-1362670*r**8+2088136*r**10-2583118*r**12
            +371376*r**14-101869*r**16-7220*r**18+235*r**20))+86400*logq2**3*r**10*(
            -16+47*r**2+46*r**4+15*r**6)*sqrtq2+24*logq2*r**2*(-80*(-1+Q2)**6*(
            -1+Q2+6*Q2**2+4*Q2**3)-(-1+Q2)**5*(1181+3445*Q2+255*Q2**2-6905*Q2**3
            -5520*Q2**4+1544*Q2**5)*r**2+10*(-1+Q2)**2*(457+936*Q2+3159*Q2**2
            -1584*Q2**3+1995*Q2**4+2812*Q2**5-5163*Q2**6+1228*Q2**7)*r**4-5*(-9353
            +6648*Q2+6152*Q2**2+121012*Q2**3-153418*Q2**4+37808*Q2**5+34544*Q2**6
            -29564*Q2**7+6651*Q2**8)*r**6+20*(-11504-3858*Q2-25076*Q2**2-65995*Q2**3
            +69164*Q2**4-5792*Q2**5-5824*Q2**6+1557*Q2**7)*r**8+10*(111543-146944*Q2
            +30208*Q2**2-149158*Q2**3+65341*Q2**4+646*Q2**5+1788*Q2**6)*r**10-4*(340133
            +504680*Q2-76300*Q2**2+114425*Q2**3-22765*Q2**4+14283*Q2**5)*r**12+10*(
            -13177-95780*Q2-44612*Q2**2-11846*Q2**3+3237*Q2**4)*r**14+20*(34668
            +27678*Q2+2204*Q2**2+519*Q2**3)*r**16-5*(24359-5036*Q2+3528*Q2**2)*r**18
            +10*(-1671+602*Q2)*r**20-499*r**22)*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(-4665600*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-32400*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +13996800*logq2**4*r**16*sqrtq2+583200*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2+675*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)+((-1382400*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(15+11*r**2)*(-Q2+(1+r)**2)+384*logq2*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-71-376*Q2**8-2467*r**2-44893*r**4
            -42159*r**6-164195*r**8-72149*r**10+40997*r**12+4023*r**14+114*r**16
            +4*Q2**7*(342+337*r**2)-Q2**6*(1283+3945*r**2+858*r**4)+Q2**5*(-874
            +4582*r**2+3202*r**4+266*r**6)+Q2**4*(2055+5195*r**2+24779*r**4+4445*r**6
            -2570*r**8)+4*Q2**3*(-161-3545*r**2-20444*r**4-19529*r**6-2385*r**8
            +564*r**10)+Q2**2*(-613+3617*r**2+30404*r**4+70334*r**6+3699*r**8-5923*r**10
            +1082*r**12)+Q2*(438+5850*r**2+40342*r**4-73690*r**6-62590*r**8-9058*r**10
            +6370*r**12-1262*r**14))-115200*logq2**2*r**10*(8*Q2**7-2*Q2**6*(40+31*r**2)
            +3*Q2**5*(78+125*r**2+55*r**4)-2*Q2**4*(131+287*r**2+259*r**4+83*r**6)
            +Q2**3*(28+287*r**2+327*r**4+195*r**6+55*r**8)+Q2**2*(180+21*r**2
            +344*r**4-32*r**6-144*r**8-57*r**10)-(-1+r**2)**2*(-34-131*r**2-572*r**4
            -224*r**6-22*r**8+47*r**10)+2*Q2*(-71-55*r**2-751*r**4-869*r**6-206*r**8
            +28*r**10+52*r**12))*sqrtq2-32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -1+106*Q2**10+4478*r**2+53025*r**4+449632*r**6-390566*r**8+1472148*r**10
            -417338*r**12-37760*r**14-10617*r**16+206*r**18-7*r**20-47*Q2**9*(1
            +r**2)+Q2**8*(414+1464*r**2-702*r**4)+3*Q2**7*(-665-5717*r**2-1501*r**4
            +311*r**6)+3*Q2**6*(517+11104*r**2+8296*r**4+124*r**6+71*r**8)-3*Q2**5*(
            -405+2601*r**2+22548*r**4+4756*r**6-1643*r**8+183*r**10)+Q2**4*(-1233
            -46218*r**2+32691*r**4-53572*r**6+35565*r**8+3822*r**10-303*r**12)
            +Q2**3*(-369+46911*r**2+137493*r**4+590141*r**6+244325*r**8-25179*r**10
            -6849*r**12+327*r**14)+3*Q2**2*(105+2332*r**2-37722*r**4-125680*r**6
            -47576*r**8+21404*r**10-1838*r**12-664*r**14+39*r**16)-2*Q2*(-22+10971*r**2
            +2241*r**4+152179*r**6-355599*r**8-159423*r**10+76039*r**12-5931*r**14
            -1299*r**16+44*r**18))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(-18662400*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-777600*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-900*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+43200*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+6220800*logq2**3*r**14*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC*(16588800*logq2**3*(-Q2+(-1+r)**2)*r**14*(10
            +11*r**2+5*r**4)*(-Q2+(1+r)**2)-1536*logq2*r**6*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(-28+392*Q2**8-911*r**2-48789*r**4-156467*r**6-492585*r**8
            -186457*r**10+37101*r**12+5579*r**14+157*r**16-4*Q2**7*(709+714*r**2)
            +Q2**6*(4136+10965*r**2+4561*r**4)+2*Q2**5*(109-4907*r**2-5597*r**4
            +679*r**6)+Q2**4*(-2860+7475*r**2+25217*r**4+6725*r**6-7485*r**8)+4*Q2**3*(62
            +215*r**2+4673*r**4+5588*r**6+1375*r**8+787*r**10)+Q2**2*(776-9089*r**2
            -37373*r**4-75078*r**6-64078*r**8-18629*r**10+2471*r**12)-2*Q2*(23
            -1685*r**2+6757*r**4+55235*r**6+49685*r**8+31457*r**10-1945*r**12+873*r**14))
            -460800*logq2**2*r**10*(18*Q2**6+Q2**5*(-9+11*r**2+60*r**4)-4*Q2**4*(21
            +64*r**2+78*r**4+45*r**6)+Q2**3*(147+95*r**2+167*r**4+187*r**6+120*r**8)
            +(-1+r**2)**2*(-21-284*r**2-1368*r**4-1020*r**6-175*r**8+60*r**10)
            +Q2**2*(-117-32*r**2-708*r**4-332*r**6+133*r**8+120*r**10)+Q2*(66
            +424*r**2+3402*r**4+4950*r**6+2312*r**8+258*r**10-180*r**12))*sqrtq2
            -128*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7+184*Q2**11-204*r**2
            +1661*r**4-68290*r**6-481926*r**8-691016*r**10-2553730*r**12+385044*r**14
            +22495*r**16+16756*r**18-411*r**20+14*r**22-2*Q2**10*(195+248*r**2)
            +Q2**9*(-97+957*r**2-50*r**4)+6*Q2**8*(48-117*r**2-292*r**4+165*r**6)
            -3*Q2**7*(-271+1553*r**2+10349*r**4+717*r**6+40*r**8)+Q2**6*(-915+9456*r**2
            +85908*r**4+94332*r**6+10635*r**8-1128*r**10)+Q2**5*(-417+1485*r**2
            -30216*r**4-155044*r**6-23751*r**8-2229*r**10+132*r**12)+Q2**4*(597
            -9282*r**2-26835*r**4+162888*r**6+249151*r**8-108618*r**10-14337*r**12
            +900*r**14)+Q2**3*(87+267*r**2+5757*r**4-20855*r**6+169677*r**8-127687*r**10
            +77847*r**12+6747*r**14-240*r**16)-Q2**2*(163-3564*r**2+10278*r**4
            +123632*r**6+344196*r**8+578508*r**10+301010*r**12-2232*r**14-5871*r**16
            +280*r**18)+2*Q2*(3-193*r**2+3426*r**4-6519*r**6-174215*r**8-231465*r**10
            -485817*r**12+67279*r**14-13476*r**16-1470*r**18+47*r**20))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(
            -55987200*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-2332800*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -2700*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4
            +129600*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*sqrtq2+18662400*logq2**3*r**14*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC**2*(2073600*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(10+11*r**2+5*r**4)*(-Q2+(1+r)**2)-192*logq2*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-28+392*Q2**8-911*r**2-48789*r**4
            -156467*r**6-492585*r**8-186457*r**10+37101*r**12+5579*r**14+157*r**16
            -4*Q2**7*(709+714*r**2)+Q2**6*(4136+10965*r**2+4561*r**4)+2*Q2**5*(109
            -4907*r**2-5597*r**4+679*r**6)+Q2**4*(-2860+7475*r**2+25217*r**4+6725*r**6
            -7485*r**8)+4*Q2**3*(62+215*r**2+4673*r**4+5588*r**6+1375*r**8+787*r**10)
            +Q2**2*(776-9089*r**2-37373*r**4-75078*r**6-64078*r**8-18629*r**10
            +2471*r**12)-2*Q2*(23-1685*r**2+6757*r**4+55235*r**6+49685*r**8+31457*r**10
            -1945*r**12+873*r**14))-57600*logq2**2*r**10*(18*Q2**6+Q2**5*(-9+11*r**2
            +60*r**4)-4*Q2**4*(21+64*r**2+78*r**4+45*r**6)+Q2**3*(147+95*r**2
            +167*r**4+187*r**6+120*r**8)+(-1+r**2)**2*(-21-284*r**2-1368*r**4
            -1020*r**6-175*r**8+60*r**10)+Q2**2*(-117-32*r**2-708*r**4-332*r**6
            +133*r**8+120*r**10)+Q2*(66+424*r**2+3402*r**4+4950*r**6+2312*r**8
            +258*r**10-180*r**12))*sqrtq2-16*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7
            +184*Q2**11-204*r**2+1661*r**4-68290*r**6-481926*r**8-691016*r**10
            -2553730*r**12+385044*r**14+22495*r**16+16756*r**18-411*r**20+14*r**22
            -2*Q2**10*(195+248*r**2)+Q2**9*(-97+957*r**2-50*r**4)+6*Q2**8*(48-117*r**2
            -292*r**4+165*r**6)-3*Q2**7*(-271+1553*r**2+10349*r**4+717*r**6+40*r**8)
            +Q2**6*(-915+9456*r**2+85908*r**4+94332*r**6+10635*r**8-1128*r**10)
            +Q2**5*(-417+1485*r**2-30216*r**4-155044*r**6-23751*r**8-2229*r**10
            +132*r**12)+Q2**4*(597-9282*r**2-26835*r**4+162888*r**6+249151*r**8
            -108618*r**10-14337*r**12+900*r**14)+Q2**3*(87+267*r**2+5757*r**4-20855*r**6
            +169677*r**8-127687*r**10+77847*r**12+6747*r**14-240*r**16)-Q2**2*(163
            -3564*r**2+10278*r**4+123632*r**6+344196*r**8+578508*r**10+301010*r**12
            -2232*r**14-5871*r**16+280*r**18)+2*Q2*(3-193*r**2+3426*r**4-6519*r**6
            -174215*r**8-231465*r**10-485817*r**12+67279*r**14-13476*r**16-1470*r**18
            +47*r**20))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(-18662400*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-777600*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-900*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+43200*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+6220800*logq2**3*r**14*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC**3*(5760*logq2**2*r**4*(20*Q2**7*(2+5*r**4)-8*Q2**6*(56
            +70*r**2+137*r**4+125*r**6)+Q2**5*(1278+2808*r**2+5511*r**4+6236*r**6
            +3675*r**8)-Q2**4*(1310+3674*r**2+9025*r**4+13293*r**6+11565*r**8+5525*r**10)
            +2*Q2**3*(10+858*r**2+2748*r**4+4516*r**6+5401*r**8+2730*r**10+925*r**12)
            +(-1+r**2)**2*(122+222*r**2+7521*r**4+14321*r**6+7246*r**8-1086*r**10
            -r**12+1175*r**14)+2*Q2**2*(450-432*r**2+2549*r**4+2364*r**6-687*r**8
            -2179*r**10+980*r**12+1875*r**14)-Q2*(602-596*r**2+17123*r**4+40792*r**6
            +43217*r**8+18200*r**10-3927*r**12-1356*r**14+4025*r**16))+8*(Q2-(
            -1+r)**2)*(Q2-(1+r)**2)*(460*Q2**13-16*Q2**12*(82+135*r**2)+Q2**11*(1529
            +4740*r**2+2815*r**4)+Q2**10*(1819-3033*r**2-6551*r**4+1485*r**6)-Q2**9*(23303
            +17090*r**2+115130*r**4+6710*r**6+5375*r**8)+Q2**8*(62417+40597*r**2
            +327980*r**4+552804*r**6+50555*r**8+255*r**10)+Q2**7*(-57754-28928*r**2
            -262978*r**4-974832*r**6-812682*r**8-74656*r**10+5670*r**12)-2*Q2**6*(11903
            -48025*r**2+142215*r**4-388557*r**6-706385*r**8-20297*r**10+995*r**12
            +615*r**14)+2*Q2**5*(42997-133354*r**2+970036*r**4+850926*r**6+851232*r**8
            -683938*r**10+495816*r**12+47086*r**14-2385*r**16)+Q2**4*(-50522+207550*r**2
            -3318940*r**4-4644060*r**6-7089020*r**8-8579388*r**10-8740*r**12-892740*r**14
            -60490*r**16+2750*r**18)+Q2**3*(-11727+89948*r**2+1125795*r**4+3085184*r**6
            +6539270*r**8+4213752*r**10+5518802*r**12+1736640*r**14+112201*r**16
            -21780*r**18+1035*r**20)+Q2**2*(24291-184457*r**2+2140933*r**4-3316247*r**6
            +66738*r**8-8819574*r**10-3668978*r**12+7653702*r**14-1290453*r**16
            +279487*r**18+30893*r**20-1135*r**22)+(-1+r**2)**2*(937+3615*r**2+431077*r**4
            -1573101*r**6+8535566*r**8+2653074*r**10-5607690*r**12+2405258*r**14
            +183561*r**16+53519*r**18-1051*r**20+35*r**22)+Q2*(-9023+61750*r**2
            -1974350*r**4+5447050*r**6-15554525*r**8-20228524*r**10-3778340*r**12
            +16573420*r**14-8765065*r**16+104310*r**18-210318*r**20-5750*r**22+165*r**24))
            +345600*logq2**3*r**8*(27+66*r**2+25*r**4+46*r**6)*sqrtq2+96*logq2*(8*Q2**10*(47
            +240*r**4)-40*Q2**9*(47+33*r**2+254*r**4+360*r**6)+5*Q2**8*(663+822*r**2
            +3147*r**4+11002*r**6+7530*r**8)-20*Q2**7*(78+311*r**2+197*r**4+3147*r**6
            +5189*r**8+1710*r**10)-20*Q2**6*(117-375*r**2+2667*r**4+739*r**6-2220*r**8
            -4132*r**10+1020*r**12)+4*Q2**5*(822-855*r**2+49350*r**4+99260*r**6
            +128770*r**8+87217*r**10+1010*r**12+15690*r**14)-10*Q2**4*(87+628*r**2
            +24775*r**4+70724*r**6+117149*r**8+150572*r**10+90983*r**12+10444*r**14
            +3510*r**16)-20*Q2**3*(42-387*r**2-1779*r**4-19931*r**6-42087*r**8
            -57495*r**10-46105*r**12-22757*r**14-6487*r**16+570*r**18)+(-1+r**2)**2*(11
            +592*r**2+30668*r**4-22346*r**6+715940*r**8+1405134*r**10-430102*r**12
            -161478*r**14+212161*r**16+20050*r**18+570*r**20)+20*Q2**2*(33-39*r**2
            +7809*r**4-8255*r**6+4379*r**8-15091*r**10-55217*r**12+5335*r**14+32452*r**16
            -1886*r**18+960*r**20)-20*Q2*(8+95*r**2+6056*r**4-7924*r**6+74172*r**8
            +189052*r**10+137992*r**12-51814*r**14-31044*r**16+35605*r**18+1712*r**20
            +330*r**22))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(-13996800*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-97200*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +41990400*logq2**4*r**16*sqrtq2+1749600*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2+2025*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)+((-691200*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(15+11*r**2)*(-Q2+(1+r)**2)+192*logq2*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-71-376*Q2**8-2467*r**2-44893*r**4
            -42159*r**6-164195*r**8-72149*r**10+40997*r**12+4023*r**14+114*r**16
            +4*Q2**7*(342+337*r**2)-Q2**6*(1283+3945*r**2+858*r**4)+Q2**5*(-874
            +4582*r**2+3202*r**4+266*r**6)+Q2**4*(2055+5195*r**2+24779*r**4+4445*r**6
            -2570*r**8)+4*Q2**3*(-161-3545*r**2-20444*r**4-19529*r**6-2385*r**8
            +564*r**10)+Q2**2*(-613+3617*r**2+30404*r**4+70334*r**6+3699*r**8-5923*r**10
            +1082*r**12)+Q2*(438+5850*r**2+40342*r**4-73690*r**6-62590*r**8-9058*r**10
            +6370*r**12-1262*r**14))-57600*logq2**2*r**10*(8*Q2**7-2*Q2**6*(40+31*r**2)
            +3*Q2**5*(78+125*r**2+55*r**4)-2*Q2**4*(131+287*r**2+259*r**4+83*r**6)
            +Q2**3*(28+287*r**2+327*r**4+195*r**6+55*r**8)+Q2**2*(180+21*r**2
            +344*r**4-32*r**6-144*r**8-57*r**10)-(-1+r**2)**2*(-34-131*r**2-572*r**4
            -224*r**6-22*r**8+47*r**10)+2*Q2*(-71-55*r**2-751*r**4-869*r**6-206*r**8
            +28*r**10+52*r**12))*sqrtq2-16*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -1+106*Q2**10+4478*r**2+53025*r**4+449632*r**6-390566*r**8+1472148*r**10
            -417338*r**12-37760*r**14-10617*r**16+206*r**18-7*r**20-47*Q2**9*(1
            +r**2)+Q2**8*(414+1464*r**2-702*r**4)+3*Q2**7*(-665-5717*r**2-1501*r**4
            +311*r**6)+3*Q2**6*(517+11104*r**2+8296*r**4+124*r**6+71*r**8)-3*Q2**5*(
            -405+2601*r**2+22548*r**4+4756*r**6-1643*r**8+183*r**10)+Q2**4*(-1233
            -46218*r**2+32691*r**4-53572*r**6+35565*r**8+3822*r**10-303*r**12)
            +Q2**3*(-369+46911*r**2+137493*r**4+590141*r**6+244325*r**8-25179*r**10
            -6849*r**12+327*r**14)+3*Q2**2*(105+2332*r**2-37722*r**4-125680*r**6
            -47576*r**8+21404*r**10-1838*r**12-664*r**14+39*r**16)-2*Q2*(-22+10971*r**2
            +2241*r**4+152179*r**6-355599*r**8-159423*r**10+76039*r**12-5931*r**14
            -1299*r**16+44*r**18))*sqrtq2)*math.log(mu0)*nlo.X1Q2(0,'SM',Q2,r))/(-6220800*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-259200*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-300*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+14400*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+2073600*logq2**3*r**14*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+((3600*logq2**2*r**8*(15+22*r**2+15*r**4)+(Q2-(-1
            +r)**2)*(Q2-(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4+19308*r**6+138690*r**8
            +19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1+r**2)+Q2**6*(
            -89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4+79*r**6)+Q2**4*(165
            -1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4
            -2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2+1787*r**4-14228*r**6
            +1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2-2957*r**4+19165*r**6
            +19165*r**8-2957*r**10-635*r**12+27*r**14))+600*logq2*r**4*(1+2*Q2**5
            +35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17
            +42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2
            +66*r**4+30*r**6-11*r**8))*sqrtq2)*math.log(mus)*nlo.X1Q2(0,'SM',Q2,r))/(-62208*logq2**3*r**12
            -1296*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+15552*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+36*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((691200*logq2**3*(-Q2+(-1+r)**2)*r**14*(15
            +11*r**2)*(-Q2+(1+r)**2)-192*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-71-376*Q2**8-2467*r**2-44893*r**4-42159*r**6-164195*r**8
            -72149*r**10+40997*r**12+4023*r**14+114*r**16+4*Q2**7*(342+337*r**2)
            -Q2**6*(1283+3945*r**2+858*r**4)+Q2**5*(-874+4582*r**2+3202*r**4+266*r**6)
            +Q2**4*(2055+5195*r**2+24779*r**4+4445*r**6-2570*r**8)+4*Q2**3*(-161
            -3545*r**2-20444*r**4-19529*r**6-2385*r**8+564*r**10)+Q2**2*(-613+3617*r**2
            +30404*r**4+70334*r**6+3699*r**8-5923*r**10+1082*r**12)+Q2*(438+5850*r**2
            +40342*r**4-73690*r**6-62590*r**8-9058*r**10+6370*r**12-1262*r**14))
            +57600*logq2**2*r**10*(8*Q2**7-2*Q2**6*(40+31*r**2)+3*Q2**5*(78+125*r**2
            +55*r**4)-2*Q2**4*(131+287*r**2+259*r**4+83*r**6)+Q2**3*(28+287*r**2
            +327*r**4+195*r**6+55*r**8)+Q2**2*(180+21*r**2+344*r**4-32*r**6-144*r**8
            -57*r**10)-(-1+r**2)**2*(-34-131*r**2-572*r**4-224*r**6-22*r**8+47*r**10)
            +2*Q2*(-71-55*r**2-751*r**4-869*r**6-206*r**8+28*r**10+52*r**12))*sqrtq2
            +16*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-1+106*Q2**10+4478*r**2
            +53025*r**4+449632*r**6-390566*r**8+1472148*r**10-417338*r**12-37760*r**14
            -10617*r**16+206*r**18-7*r**20-47*Q2**9*(1+r**2)+Q2**8*(414+1464*r**2
            -702*r**4)+3*Q2**7*(-665-5717*r**2-1501*r**4+311*r**6)+3*Q2**6*(517
            +11104*r**2+8296*r**4+124*r**6+71*r**8)-3*Q2**5*(-405+2601*r**2+22548*r**4
            +4756*r**6-1643*r**8+183*r**10)+Q2**4*(-1233-46218*r**2+32691*r**4
            -53572*r**6+35565*r**8+3822*r**10-303*r**12)+Q2**3*(-369+46911*r**2
            +137493*r**4+590141*r**6+244325*r**8-25179*r**10-6849*r**12+327*r**14)
            +3*Q2**2*(105+2332*r**2-37722*r**4-125680*r**6-47576*r**8+21404*r**10
            -1838*r**12-664*r**14+39*r**16)-2*Q2*(-22+10971*r**2+2241*r**4+152179*r**6
            -355599*r**8-159423*r**10+76039*r**12-5931*r**14-1299*r**16+44*r**18))*sqrtq2)*math.log(r)*nlo.X1Q2(0,'SM',Q2,r))/(
            -6220800*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-259200*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -300*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4
            +14400*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*sqrtq2+2073600*logq2**3*r**14*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((
            -3600*logq2**2*r**8*(57+98*r**2+57*r**4)-(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(41
            +376*Q2**8-1068*r**2+10408*r**4+108924*r**6+526590*r**8+108924*r**10
            +10408*r**12-1068*r**14+41*r**16-648*Q2**7*(1+r**2)+Q2**6*(-367+770*r**2
            -367*r**4)+Q2**5*(754-2362*r**2-2362*r**4+754*r**6)+Q2**4*(495-3160*r**2
            -31054*r**4-3160*r**6+495*r**8)+Q2**3*(-556+7540*r**2+53496*r**4+53496*r**6
            +7540*r**8-556*r**10)+Q2**2*(-257+2818*r**2+17461*r**4-21724*r**6+17461*r**8
            +2818*r**10-257*r**12)+2*Q2*(81-1945*r**2-4591*r**4+70055*r**6+70055*r**8
            -4591*r**10-1945*r**12+81*r**14))+120*logq2*r**4*(17-20*Q2**5-701*r**2
            -5676*r**4-5676*r**6-701*r**8+17*r**10+232*Q2**4*(1+r**2)-Q2**3*(233
            +546*r**2+233*r**4)+Q2**2*(-133+145*r**2+145*r**4-133*r**6)+Q2*(137
            -570*r**2-1254*r**4-570*r**6+137*r**8))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r)**2)/(6220800*logq2**4*r**16
            +259200*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+300*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-2073600*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-14400*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +(flagPERP*muWC**3*(-96*logq2*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(
            -10-11*r**2-36*Q2**4*r**2+14*r**4-1326*r**6-416*r**8+189*r**10+2*Q2**3*(
            -5+132*r**2+117*r**4)-Q2**2*(-10+191*r**2+524*r**4+171*r**6)-2*Q2*(
            -5+93*r**2+2*r**4-68*r**6+108*r**8))+2880*logq2**2*r**6*(-4+21*r**2
            +9*r**4)*sqrtq2+(-20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(-15+24*Q2**4-22*r**2
            -22*r**4-70*r**6+9*r**8-21*Q2**3*(1+r**2)+Q2**2*(-21+38*r**2-21*r**4)
            +Q2*(-15+29*r**2-43*r**4+9*r**6))+24*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(
            -3+5*Q2**3+5*r**2-19*r**4+5*r**6-5*Q2**2*(1+r**2)+Q2*(-5+8*r**2
            -5*r**4))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8)))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(58320*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+135*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-233280*logq2**3*r**12*sqrtq2
            -4860*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((-69120*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(2+r**2)*(-Q2+(1+r)**2)-32*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(-17*Q2**6-4*Q2**5*(1+r**2)+Q2**4*(-57-182*r**2
            +75*r**4)+Q2**3*(128+964*r**2+316*r**4-40*r**6)+Q2**2*(13-424*r**2
            +258*r**4+224*r**6-35*r**8)+12*Q2*(-5-28*r**2+149*r**4+77*r**6-14*r**8
            +r**10)+3*(-1+314*r**2+377*r**4+1852*r**6-323*r**8-62*r**10+3*r**12))
            +768*logq2*r**6*(16*Q2**6-61*Q2**5*(1+r**2)+Q2**4*(75+103*r**2+60*r**4)
            -2*Q2**3*(5+31*r**2+16*r**4+5*r**6)+9*(-1+r**2)**2*(-1-11*r**2-41*r**4
            -11*r**6+4*r**8)+Q2**2*(-50-22*r**2-216*r**4+68*r**6+40*r**8)+Q2*(39
            +123*r**2+1008*r**4+978*r**6+93*r**8-81*r**10))*sqrtq2)/(103680*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+2160*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-60*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-25920*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC*(276480*logq2**2*(-Q2+(-1+r)**2)*r**10*(4+3*r**2)*(
            -Q2+(1+r)**2)+128*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(40*Q2**7
            -Q2**6*(58+75*r**2)-4*Q2**5*(9-21*r**2+10*r**4)+4*Q2**3*(10-44*r**2
            -371*r**4+3*r**6)+Q2**4*(50-203*r**2-328*r**4+125*r**6)+12*Q2*(-1
            +9*r**2+113*r**4+81*r**6+218*r**8)+Q2**2*(-30+391*r**2+1652*r**4+2334*r**6
            +602*r**8-65*r**10)+3*(2-43*r**2+308*r**4+1863*r**6+3338*r**8-329*r**10
            -104*r**12+5*r**14))-3072*logq2*r**6*(4*Q2**6+41*Q2**5*(1+r**2)-Q2**4*(135
            +293*r**2+150*r**4)+2*Q2**3*(55+71*r**2+86*r**4+55*r**6)+3*(-1+r**2)**2*(3
            -77*r**2-287*r**4-77*r**6+18*r**8)+2*Q2**2*(5-29*r**2-252*r**4+16*r**6
            +50*r**8)+3*Q2*(-13+139*r**2+744*r**4+734*r**6+129*r**8-53*r**10))*sqrtq2))/(311040*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+6480*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-180*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-77760*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC**2*(34560*logq2**2*(-Q2+(-1+r)**2)*r**10*(4+3*r**2)*(
            -Q2+(1+r)**2)+16*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(40*Q2**7
            -Q2**6*(58+75*r**2)-4*Q2**5*(9-21*r**2+10*r**4)+4*Q2**3*(10-44*r**2
            -371*r**4+3*r**6)+Q2**4*(50-203*r**2-328*r**4+125*r**6)+12*Q2*(-1
            +9*r**2+113*r**4+81*r**6+218*r**8)+Q2**2*(-30+391*r**2+1652*r**4+2334*r**6
            +602*r**8-65*r**10)+3*(2-43*r**2+308*r**4+1863*r**6+3338*r**8-329*r**10
            -104*r**12+5*r**14))-384*logq2*r**6*(4*Q2**6+41*Q2**5*(1+r**2)-Q2**4*(135
            +293*r**2+150*r**4)+2*Q2**3*(55+71*r**2+86*r**4+55*r**6)+3*(-1+r**2)**2*(3
            -77*r**2-287*r**4-77*r**6+18*r**8)+2*Q2**2*(5-29*r**2-252*r**4+16*r**6
            +50*r**8)+3*Q2*(-13+139*r**2+744*r**4+734*r**6+129*r**8-53*r**10))*sqrtq2))/(103680*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+2160*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-60*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-25920*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC**3*(-192*logq2*(24*Q2**6*(2+5*r**4)-Q2**5*(168
            +133*r**2+540*r**4+795*r**6)-2*Q2**3*r**2*(73+268*r**2+570*r**4+590*r**6
            +375*r**8)+Q2**4*(180+159*r**2+645*r**4+1825*r**6+1575*r**8)-(-1
            +r**2)**2*(12+37*r**2+2117*r**4+3922*r**6-558*r**8-415*r**10+405*r**12)
            -2*Q2**2*(60-167*r**2+799*r**4+538*r**6-700*r**8-135*r**10+525*r**12)
            +Q2*(72-201*r**2+4924*r**4+10719*r**6+7964*r**8-1103*r**10-1600*r**12
            +1305*r**14))+11520*logq2**2*r**4*(12+19*r**2+15*r**4)*sqrtq2-16*(120*Q2**9
            -3*Q2**8*(87+155*r**2)+Q2**7*(258+596*r**2+450*r**4)+Q2**6*(420-514*r**2
            -808*r**4+390*r**6)-6*Q2**5*(441+230*r**2+1306*r**4-98*r**6+145*r**8)
            +2*Q2**4*(1905+622*r**2+6030*r**4+13410*r**6+955*r**8+90*r**10)+2*Q2**3*(
            -477-362*r**2-6203*r**4-3468*r**6-8555*r**8-1802*r**10+195*r**12)
            -6*Q2**2*(378-1147*r**2+1784*r**4-3549*r**6-2410*r**8+3143*r**10-64*r**12
            +25*r**14)+(-1+r**2)**2*(-549+3179*r**2-33609*r**4-12869*r**6+18541*r**8
            -6915*r**10-943*r**12+45*r**14)+Q2*(2070-9916*r**2+66480*r**4+75468*r**6
            +27908*r**8-53892*r**10+22224*r**12+2228*r**14-90*r**16))*sqrtq2))/(174960*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+405*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-699840*logq2**3*r**12*sqrtq2
            -14580*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((-34560*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(2+r**2)*(-Q2+(1+r)**2)-16*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(-17*Q2**6-4*Q2**5*(1+r**2)+Q2**4*(-57-182*r**2
            +75*r**4)+Q2**3*(128+964*r**2+316*r**4-40*r**6)+Q2**2*(13-424*r**2
            +258*r**4+224*r**6-35*r**8)+12*Q2*(-5-28*r**2+149*r**4+77*r**6-14*r**8
            +r**10)+3*(-1+314*r**2+377*r**4+1852*r**6-323*r**8-62*r**10+3*r**12))
            +384*logq2*r**6*(16*Q2**6-61*Q2**5*(1+r**2)+Q2**4*(75+103*r**2+60*r**4)
            -2*Q2**3*(5+31*r**2+16*r**4+5*r**6)+9*(-1+r**2)**2*(-1-11*r**2-41*r**4
            -11*r**6+4*r**8)+Q2**2*(-50-22*r**2-216*r**4+68*r**6+40*r**8)+Q2*(39
            +123*r**2+1008*r**4+978*r**6+93*r**8-81*r**10))*sqrtq2)*math.log(mu0))/(34560*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+720*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-20*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-8640*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+((900*logq2*r**4*(1+r**2)-5*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2)*math.log(mus))/(864*logq2**2*r**8+6*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-144*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((34560*logq2**2*(-Q2+(-1+r)**2)*r**10*(2
            +r**2)*(-Q2+(1+r)**2)+16*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -17*Q2**6-4*Q2**5*(1+r**2)+Q2**4*(-57-182*r**2+75*r**4)+Q2**3*(128
            +964*r**2+316*r**4-40*r**6)+Q2**2*(13-424*r**2+258*r**4+224*r**6-35*r**8)
            +12*Q2*(-5-28*r**2+149*r**4+77*r**6-14*r**8+r**10)+3*(-1+314*r**2
            +377*r**4+1852*r**6-323*r**8-62*r**10+3*r**12))-384*logq2*r**6*(16*Q2**6
            -61*Q2**5*(1+r**2)+Q2**4*(75+103*r**2+60*r**4)-2*Q2**3*(5+31*r**2
            +16*r**4+5*r**6)+9*(-1+r**2)**2*(-1-11*r**2-41*r**4-11*r**6+4*r**8)
            +Q2**2*(-50-22*r**2-216*r**4+68*r**6+40*r**8)+Q2*(39+123*r**2+1008*r**4
            +978*r**6+93*r**8-81*r**10))*sqrtq2)*math.log(r))/(34560*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+720*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-20*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-8640*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2))*nlo.X1Q2(1,'SM',Q2,r)+((-360*logq2*r**4*(1+r**2)+2*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r)*nlo.X1Q2(1,'SM',Q2,r))/(
            -8640*logq2**3*r**12-180*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+2160*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+5*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)-nlo.X1Q2(1,'SM',Q2,r)**2/(144*logq2**2*r**8
            +(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-24*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(flagPERP*muWC**3*(-4*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(-3+5*Q2**3+5*r**2-19*r**4+5*r**6-5*Q2**2*(1
            +r**2)+Q2*(-5+8*r**2-5*r**4))+48*logq2*r**4*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(
            -216*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+1296*logq2**2*r**8*sqrtq2
            +9*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((muWC**3*(16*(5*Q2**5-Q2**4*(7
            +15*r**2)+2*Q2**3*(4+2*r**2+5*r**4)+(-1+r**2)**2*(17+r**2-11*r**4
            +5*r**6)+2*Q2**2*(7-6*r**2-4*r**4+5*r**6)-Q2*(37+20*r**2+8*r**4
            -32*r**6+15*r**8))+192*logq2*sqrtq2))/(-648*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+3888*logq2**2*r**8*sqrtq2+27*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)
            +(-768*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)+64*r**4*(-Q2**4+Q2**3*(1
            +r**2)+2*(-1+r**2)**2*(-2-5*r**2+r**4)+Q2**2*(-3-4*r**2+3*r**4)+Q2*(7
            +29*r**2+17*r**4-5*r**6))*sqrtq2)/(-1728*logq2**2*r**10*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))-12*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+288*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC**2*(768*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)-32*r**2*(3*Q2**5-Q2**4*(8+9*r**2)
            +Q2**3*(5+5*r**2+6*r**4)+(-1+r**2)**2*(1-11*r**2-17*r**4+3*r**6)
            +Q2**2*(3-8*r**2-9*r**4+6*r**6)+Q2*(-4+25*r**2+49*r**4+35*r**6-9*r**8))*sqrtq2))/(
            -1728*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-12*(-Q2+(-1
            +r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+288*logq2*r**6*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC*(6144*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)
            -256*r**2*(3*Q2**5-Q2**4*(8+9*r**2)+Q2**3*(5+5*r**2+6*r**4)+(-1+r**2)**2*(1
            -11*r**2-17*r**4+3*r**6)+Q2**2*(3-8*r**2-9*r**4+6*r**6)+Q2*(-4+25*r**2
            +49*r**4+35*r**6-9*r**8))*sqrtq2))/(-5184*logq2**2*r**10*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))-36*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+864*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((
            -384*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)+32*r**4*(-Q2**4+Q2**3*(1
            +r**2)+2*(-1+r**2)**2*(-2-5*r**2+r**4)+Q2**2*(-3-4*r**2+3*r**4)+Q2*(7
            +29*r**2+17*r**4-5*r**6))*sqrtq2)*math.log(mu0))/(-576*logq2**2*r**10*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))-4*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+96*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(25*math.log(mus))/(
            -72*logq2*r**4+6*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)+((384*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)-32*r**4*(
            -Q2**4+Q2**3*(1+r**2)+2*(-1+r**2)**2*(-2-5*r**2+r**4)+Q2**2*(-3-4*r**2
            +3*r**4)+Q2*(7+29*r**2+17*r**4-5*r**6))*sqrtq2)*math.log(r))/(-576*logq2**2*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-4*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+96*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2))*nlo.X1Q2(2,'SM',Q2,r)
            -(nlo.X1Q2(0,'SM',Q2,r)*nlo.X1Q2(2,'SM',Q2,r))/(144*logq2**2*r**8+(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-24*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((3600*logq2**2*r**8*(15+22*r**2
            +15*r**4)+(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4
            +19308*r**6+138690*r**8+19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1
            +r**2)+Q2**6*(-89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4
            +79*r**6)+Q2**4*(165-1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19
            -280*r**2-2439*r**4-2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2
            +1787*r**4-14228*r**6+1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2
            -2957*r**4+19165*r**6+19165*r**8-2957*r**10-635*r**12+27*r**14))+600*logq2*r**4*(1
            +2*Q2**5+35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)
            +Q2**3*(17+42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(
            -11+30*r**2+66*r**4+30*r**6-11*r**8))*sqrtq2)*nnlo.X2Q2(0,Q2,r))/(-259200*logq2**3*r**12
            -5400*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+64800*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+150*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((180*logq2*r**4*(1+r**2)+(-3-8*Q2**4
            +42*r**2+282*r**4+42*r**6-3*r**8+7*Q2**3*(1+r**2)+Q2**2*(7-2*r**2
            +7*r**4)-3*Q2*(1-11*r**2-11*r**4+r**6))*sqrtq2)*nnlo.X2Q2(1,Q2,r))/(720*logq2**2*r**8
            +5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+nnlo.X2Q2(2,Q2,r)/(-12*logq2*r**4
            +(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))
        if( flagDEBUG == 1):
            print("Q2moment n. 2 NNLO = api^2*",resNNLO*par.mbkin**4)
        res += api**2*resNNLO

    if((kwargs.get('flag_includeNNLO', 1) == 1) and (kwargs.get('flag_includeNLOpw', 1) == 1)):
        resNNLO = 0
        resNNLO +=(FLAGcD*flagPERP*muWC**3*((5760*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(1
            -11*r**2+10*Q2**5*r**2+50*r**4+30*r**6+125*r**8-41*r**10+26*r**12-4*Q2**4*(1
            +8*r**2+11*r**4)+Q2**3*(6+49*r**2+89*r**4+61*r**6)-Q2**2*(-1+23*r**2
            +56*r**4+108*r**6+4*r**8)+Q2*(-4+12*r**2-33*r**4+27*r**6+77*r**8
            -49*r**10))+8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**9*r**2+Q2**8*(
            -22+89*r**2+23*r**4)-Q2**7*(-101+398*r**2+2817*r**4+196*r**6)+Q2**6*(
            -156+3*r**2+11687*r**4+9911*r**6+335*r**8)-Q2**5*(-47-904*r**2+10040*r**4
            +31544*r**6+7963*r**8+64*r**10)+Q2**4*(110+333*r**2-8167*r**4+8892*r**6
            +20686*r**8-10725*r**10-337*r**12)+Q2**3*(-93-2074*r**2+14295*r**4
            +18820*r**6+48901*r**8+4158*r**10+17921*r**12+272*r**14)+Q2**2*(-16
            +753*r**2-1695*r**4-6029*r**6-69053*r**8-42197*r**10-13221*r**12-1783*r**14
            +41*r**16)+Q2*(41+857*r**2-7214*r**4+9536*r**6-43980*r**8+110834*r**10
            -62202*r**12+21784*r**14-7941*r**16-115*r**18)+2*(-6-237*r**2+1964*r**4
            -9815*r**6-8509*r**8+86159*r**10-86693*r**12+43631*r**14-6565*r**16
            +1654*r**18+17*r**20))+172800*logq2**3*r**10*(1-2*r**2+3*r**4)*sqrtq2
            +48*logq2*r**2*(92*Q2**10*r**2-20*Q2**9*(-2+41*r**2+35*r**4)+5*Q2**8*(
            -41+484*r**2+1041*r**4+402*r**6)-10*Q2**7*(-35+296*r**2+1158*r**4
            +1160*r**6+237*r**8)-10*Q2**6*(7-61*r**2-750*r**4-900*r**6-893*r**8
            +21*r**10)+Q2**5*(-490+2216*r**2+7050*r**4+27880*r**6+25570*r**8+4560*r**10
            +3486*r**12)-10*Q2**4*(-56+203*r**2+1316*r**4+5001*r**6+8466*r**8+4717*r**10
            +1178*r**12+315*r**14)+10*Q2**3*(-7-32*r**2+656*r**4+2368*r**6+5510*r**8
            +8184*r**10+1400*r**12+632*r**14+9*r**16)+10*Q2**2*(-25+161*r**2-108*r**4
            -1238*r**6+2830*r**8-108*r**10-4764*r**12+2430*r**14-45*r**16+147*r**18)
            +(-1+r**2)**2*(-35+172*r**2-6*r**4-11844*r**6+34868*r**8-5600*r**10
            -2882*r**12+6396*r**14+359*r**16+172*r**18)-10*Q2*(-17+106*r**2-59*r**4
            -2308*r**6+4862*r**8+2928*r**10+4114*r**12-3356*r**14+2243*r**16+38*r**18
            +89*r**20))*sqrtq2)/(97200*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+225*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3-388800*logq2**3*r**12*sqrtq2-8100*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2)+((-23040*logq2**2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(1-11*r**2+10*Q2**5*r**2+50*r**4+30*r**6+125*r**8-41*r**10
            +26*r**12-4*Q2**4*(1+8*r**2+11*r**4)+Q2**3*(6+49*r**2+89*r**4+61*r**6)
            -Q2**2*(-1+23*r**2+56*r**4+108*r**6+4*r**8)+Q2*(-4+12*r**2-33*r**4
            +27*r**6+77*r**8-49*r**10))-32*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7*Q2**9*r**2
            +Q2**8*(-22+89*r**2+23*r**4)-Q2**7*(-101+398*r**2+2817*r**4+196*r**6)
            +Q2**6*(-156+3*r**2+11687*r**4+9911*r**6+335*r**8)-Q2**5*(-47-904*r**2
            +10040*r**4+31544*r**6+7963*r**8+64*r**10)+Q2**4*(110+333*r**2-8167*r**4
            +8892*r**6+20686*r**8-10725*r**10-337*r**12)+Q2**3*(-93-2074*r**2+14295*r**4
            +18820*r**6+48901*r**8+4158*r**10+17921*r**12+272*r**14)+Q2**2*(-16
            +753*r**2-1695*r**4-6029*r**6-69053*r**8-42197*r**10-13221*r**12-1783*r**14
            +41*r**16)+Q2*(41+857*r**2-7214*r**4+9536*r**6-43980*r**8+110834*r**10
            -62202*r**12+21784*r**14-7941*r**16-115*r**18)+2*(-6-237*r**2+1964*r**4
            -9815*r**6-8509*r**8+86159*r**10-86693*r**12+43631*r**14-6565*r**16
            +1654*r**18+17*r**20))-691200*logq2**3*r**10*(1-2*r**2+3*r**4)*sqrtq2
            +192*logq2*r**2*(-5*(-1+Q2)**7*(7+15*Q2+8*Q2**2)-2*(-1+Q2)**5*(-121
            -75*Q2+30*Q2**2-150*Q2**3-180*Q2**4+46*Q2**5)*r**2+5*(-1+Q2)**3*(
            -77-113*Q2-324*Q2**2+602*Q2**3+33*Q2**4-621*Q2**5+140*Q2**6)*r**4
            -10*(-1166+2308*Q2-1238*Q2**2+2368*Q2**3-5001*Q2**4+2788*Q2**5+900*Q2**6
            -1160*Q2**7+201*Q2**8)*r**6+10*(-5855+4862*Q2-2830*Q2**2-5510*Q2**3
            +8466*Q2**4-2557*Q2**5-893*Q2**6+237*Q2**7)*r**8+10*(8718+2928*Q2
            +108*Q2**2-8184*Q2**3+4717*Q2**4-456*Q2**5+21*Q2**6)*r**10-2*(21593
            -20570*Q2-23820*Q2**2+7000*Q2**3-5890*Q2**4+1743*Q2**5)*r**12+10*(
            -656-3356*Q2-2430*Q2**2-632*Q2**3+315*Q2**4)*r**14-5*(-3063-4486*Q2
            -90*Q2**2+18*Q2**3)*r**16-10*(585-38*Q2+147*Q2**2)*r**18+5*(-3+178*Q2)*r**20
            -172*r**22)*sqrtq2)*math.log(murhoD))/(104976*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+243*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-419904*logq2**3*r**12*sqrtq2
            -8748*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2))+FLAGcD*muWC**3*((
            -5760*logq2**2*r**4*(10*Q2**7*(1+5*r**4)-4*Q2**6*(19+26*r**2+77*r**4+80*r**6)
            +Q2**5*(201+500*r**2+1457*r**4+1343*r**6+795*r**8)-Q2**4*(215+758*r**2
            +2837*r**4+3624*r**6+1980*r**8+850*r**10)+2*Q2**3*(10+191*r**2+810*r**4
            +1147*r**6+1353*r**8+415*r**10+50*r**12)+(-1+r**2)**2*(29-10*r**2
            +507*r**4-2218*r**6-3483*r**8-102*r**10+107*r**12+130*r**14)+Q2**2*(150
            -38*r**2+969*r**4-1368*r**6-2014*r**8-274*r**10+295*r**12+600*r**14)
            +Q2*(-119+86*r**2-1507*r**4+3971*r**6+11956*r**8+6170*r**10+135*r**12
            -27*r**14-505*r**16))-8*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**12+Q2**11*(19
            +5*r**2)+Q2**10*(69+312*r**2+139*r**4)-Q2**9*(2973+1415*r**2+13845*r**4
            +1655*r**6)+2*Q2**8*(6266+521*r**2+16200*r**4+35467*r**6+2610*r**8)
            -2*Q2**7*(9712-3611*r**2-9936*r**4+62186*r**6+66386*r**8+3423*r**10)
            +2*Q2**6*(2072+1935*r**2-61245*r**4-10798*r**6+86420*r**8+26287*r**10
            +945*r**12)+2*Q2**5*(11672-41479*r**2+147396*r**4+209881*r**6+240442*r**8
            -62343*r**10+78766*r**12+2481*r**14)-2*Q2**4*(13201-71075*r**2+299355*r**4
            +744945*r**6+919905*r**8+713699*r**10-54415*r**12+110975*r**14+2610*r**16)
            +Q2**3*(3893-46947*r**2+402420*r**4+1147164*r**6+2150370*r**8+1441802*r**10
            +967372*r**12+3940*r**14+58121*r**16+505*r**18)+2*(-1+r**2)**2*(731
            -9790*r**2+106706*r**4-300958*r**6+144348*r**8-301378*r**10-524770*r**12
            +302334*r**14-29527*r**16+7392*r**18+112*r**20)+Q2**2*(10491-84742*r**2
            +442083*r**4-100472*r**6+770418*r**8-528204*r**10-289358*r**12+1166712*r**14
            -258093*r**16+78802*r**18+1963*r**20)+Q2*(-7163+83965*r**2-710695*r**4
            +1148445*r**6+456510*r**8+1378846*r**10+1630950*r**12+2565390*r**14
            -1921475*r**16+278885*r**18-64063*r**20-1195*r**22))-172800*logq2**3*r**8*(3
            +5*r**2-65*r**4+r**6)*sqrtq2-48*logq2*(92*Q2**10*(1+5*r**4)-20*Q2**9*(29
            +15*r**2+105*r**4+175*r**6)+5*Q2**8*(279+271*r**2+205*r**4+2715*r**6
            +2010*r**8)-10*Q2**7*(132+259*r**2-766*r**4+668*r**6+3002*r**8+1185*r**10)
            -10*Q2**6*(42-335*r**2+2345*r**4+3050*r**6+2732*r**8-2147*r**10+105*r**12)
            +2*Q2**5*(1008-1895*r**2+25330*r**4+86925*r**6+128000*r**8+85343*r**10
            +7950*r**12+8715*r**14)-10*Q2**4*(147-230*r**2+6386*r**4+37548*r**6
            +74256*r**8+63236*r**10+26280*r**12+3650*r**14+1575*r**16)+10*Q2**3*(
            -12+167*r**2+1354*r**4+25306*r**6+51738*r**8+66076*r**10+43574*r**12
            +6870*r**14+2450*r**16+45*r**18)+10*Q2**2*(72-391*r**2+5303*r**4+3264*r**6
            +11020*r**8-2606*r**10-21870*r**12+6408*r**14+19188*r**16-963*r**18
            +735*r**20)+(-1+r**2)**2*(67-401*r**2+13526*r**4+9618*r**6-128500*r**8
            -158132*r**10-447154*r**12+51694*r**14+52977*r**16+645*r**18+860*r**20)
            -10*Q2*(38-245*r**2+5136*r**4+3913*r**6-15952*r**8-85914*r**10-97164*r**12
            -75350*r**14+4778*r**16+18783*r**18-388*r**20+445*r**22))*sqrtq2)/(291600*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+675*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-1166400*logq2**3*r**12*sqrtq2
            -24300*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((23040*logq2**2*r**4*(10*Q2**7*(1
            +5*r**4)-4*Q2**6*(19+26*r**2+77*r**4+80*r**6)+Q2**5*(201+500*r**2
            +1457*r**4+1343*r**6+795*r**8)-Q2**4*(215+758*r**2+2837*r**4+3624*r**6
            +1980*r**8+850*r**10)+2*Q2**3*(10+191*r**2+810*r**4+1147*r**6+1353*r**8
            +415*r**10+50*r**12)+(-1+r**2)**2*(29-10*r**2+507*r**4-2218*r**6-3483*r**8
            -102*r**10+107*r**12+130*r**14)+Q2**2*(150-38*r**2+969*r**4-1368*r**6
            -2014*r**8-274*r**10+295*r**12+600*r**14)+Q2*(-119+86*r**2-1507*r**4
            +3971*r**6+11956*r**8+6170*r**10+135*r**12-27*r**14-505*r**16))+32*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**12+Q2**11*(19+5*r**2)+Q2**10*(69
            +312*r**2+139*r**4)-Q2**9*(2973+1415*r**2+13845*r**4+1655*r**6)+2*Q2**8*(6266
            +521*r**2+16200*r**4+35467*r**6+2610*r**8)-2*Q2**7*(9712-3611*r**2
            -9936*r**4+62186*r**6+66386*r**8+3423*r**10)+2*Q2**6*(2072+1935*r**2
            -61245*r**4-10798*r**6+86420*r**8+26287*r**10+945*r**12)+2*Q2**5*(11672
            -41479*r**2+147396*r**4+209881*r**6+240442*r**8-62343*r**10+78766*r**12
            +2481*r**14)-2*Q2**4*(13201-71075*r**2+299355*r**4+744945*r**6+919905*r**8
            +713699*r**10-54415*r**12+110975*r**14+2610*r**16)+Q2**3*(3893-46947*r**2
            +402420*r**4+1147164*r**6+2150370*r**8+1441802*r**10+967372*r**12+3940*r**14
            +58121*r**16+505*r**18)+2*(-1+r**2)**2*(731-9790*r**2+106706*r**4-300958*r**6
            +144348*r**8-301378*r**10-524770*r**12+302334*r**14-29527*r**16+7392*r**18
            +112*r**20)+Q2**2*(10491-84742*r**2+442083*r**4-100472*r**6+770418*r**8
            -528204*r**10-289358*r**12+1166712*r**14-258093*r**16+78802*r**18+1963*r**20)
            +Q2*(-7163+83965*r**2-710695*r**4+1148445*r**6+456510*r**8+1378846*r**10
            +1630950*r**12+2565390*r**14-1921475*r**16+278885*r**18-64063*r**20
            -1195*r**22))+691200*logq2**3*r**8*(3+5*r**2-65*r**4+r**6)*sqrtq2+192*logq2*(92*Q2**10*(1
            +5*r**4)-20*Q2**9*(29+15*r**2+105*r**4+175*r**6)+5*Q2**8*(279+271*r**2
            +205*r**4+2715*r**6+2010*r**8)-10*Q2**7*(132+259*r**2-766*r**4+668*r**6
            +3002*r**8+1185*r**10)-10*Q2**6*(42-335*r**2+2345*r**4+3050*r**6+2732*r**8
            -2147*r**10+105*r**12)+2*Q2**5*(1008-1895*r**2+25330*r**4+86925*r**6
            +128000*r**8+85343*r**10+7950*r**12+8715*r**14)-10*Q2**4*(147-230*r**2
            +6386*r**4+37548*r**6+74256*r**8+63236*r**10+26280*r**12+3650*r**14
            +1575*r**16)+10*Q2**3*(-12+167*r**2+1354*r**4+25306*r**6+51738*r**8
            +66076*r**10+43574*r**12+6870*r**14+2450*r**16+45*r**18)+10*Q2**2*(72
            -391*r**2+5303*r**4+3264*r**6+11020*r**8-2606*r**10-21870*r**12+6408*r**14
            +19188*r**16-963*r**18+735*r**20)+(-1+r**2)**2*(67-401*r**2+13526*r**4
            +9618*r**6-128500*r**8-158132*r**10-447154*r**12+51694*r**14+52977*r**16
            +645*r**18+860*r**20)-10*Q2*(38-245*r**2+5136*r**4+3913*r**6-15952*r**8
            -85914*r**10-97164*r**12-75350*r**14+4778*r**16+18783*r**18-388*r**20
            +445*r**22))*sqrtq2)*math.log(murhoD))/(314928*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+729*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-1259712*logq2**3*r**12*sqrtq2
            -26244*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2))+(muWC**3*(-14400*logq2**2*r**8*(15
            +22*r**2+15*r**4)-4*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(7+92*Q2**8-156*r**2
            +5096*r**4+19308*r**6+138690*r**8+19308*r**10+5096*r**12-156*r**14
            +7*r**16-156*Q2**7*(1+r**2)+Q2**6*(-89+190*r**2-89*r**4)+2*Q2**5*(79
            -247*r**2-247*r**4+79*r**6)+Q2**4*(165-1160*r**2-10298*r**4-1160*r**6
            +165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4-2439*r**6-280*r**8+19*r**10)
            +Q2**2*(-79+806*r**2+1787*r**4-14228*r**6+1787*r**8+806*r**10-79*r**12)
            +2*Q2*(27-635*r**2-2957*r**4+19165*r**6+19165*r**8-2957*r**10-635*r**12
            +27*r**14))-2400*logq2*r**4*(1+2*Q2**5+35*r**2+276*r**4+276*r**6+35*r**8
            +r**10-16*Q2**4*(1+r**2)+Q2**3*(17+42*r**2+17*r**4)+Q2**2*(7-19*r**2
            -19*r**4+7*r**6)+Q2*(-11+30*r**2+66*r**4+30*r**6-11*r**8))*sqrtq2)*nlopw.X1Q2RhoD(0,Q2,r))/(
            -1166400*logq2**3*r**12-24300*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+291600*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+675*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(muWC**3*(-1440*logq2*r**4*(1+r**2)+8*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*nlopw.X1Q2RhoD(1,Q2,r))/(6480*logq2**2*r**8
            +45*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-1080*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)-(8*muWC**3*nlopw.X1Q2RhoD(2,Q2,r))/(
            -108*logq2*r**4+9*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2))
        if( flagDEBUG == 1):
            print("Q2moment n. 2 NNLO pw = api^2*",resNNLO*par.mbkin**4)
        res += api**2*resNNLO

    return res*par.mbkin**4


def moment_3_KIN_MS(q2cut, par, hqe, wc, **kwargs):
    """ Central moment of the q2 spectrum. SM Part. Moment n. 3 """
    Q2=q2cut/par.mbkin**2
    r=par.mcMS/par.mbkin
    mus=par.scale_alphas/par.mbkin
    mu0=par.scale_mcMS/par.mbkin
    mumuG=par.scale_muG/par.mbkin
    murhoD=par.scale_rhoD/par.mbkin
    murhoLS=par.scale_rhoLS/par.mbkin
    muWC=par.scale_mbkin/par.mbkin
    api=par.alphas/math.pi

    rhoD=hqe.rhoD/par.mbkin**3
    rhoLS=hqe.rhoLS/par.mbkin**3
    muG=hqe.muG/par.mbkin**2

    pi2=math.pi**2
    z3=1.202056903159594
    flagPERP=kwargs.get('flag_basisPERP', 1)
    flagDEBUG=kwargs.get('flag_DEBUG', 0)
    FLAGcf=1
    FLAGcD=1
    FLAGcs=1

    sqrtq2=math.sqrt(1-2*Q2+Q2**2-2*r**2-2*Q2*r**2+r**4)
    logq2 =math.log((1-Q2+r**2-sqrtq2)/(1-Q2+r**2+sqrtq2))

    res = 0
    res +=((flagPERP*rhoD*(-172800*logq2**3*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(301
        -1584*r**2-240*Q2**6*r**2+5717*r**4-6176*r**6+8279*r**8-72*r**10-1017*r**12
        +1272*r**14+20*Q2**5*(7+51*r**2+72*r**4)-4*Q2**4*(196+445*r**2+1206*r**4
        +837*r**6)+Q2**3*(1001+2581*r**2+5141*r**4+8403*r**6+3162*r**8)+Q2**2*(91
        -2396*r**2-1418*r**4-5364*r**6-6801*r**8+432*r**10)+Q2*(-749+2609*r**2
        -3480*r**4-158*r**6+3027*r**8+2589*r**10-2718*r**12))-48*logq2*(Q2
        -(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(-2345-4786*r**2-4656*Q2**12*r**2
        -227548*r**4+481994*r**6+1802615*r**8-49508100*r**10+129325752*r**12
        -64400404*r**14-24624243*r**16+36020510*r**18-7593180*r**20+2793034*r**22
        +119077*r**24+9624*r**26+4*Q2**11*(-805+12483*r**2+10068*r**4)-4*Q2**10*(
        -4270+40169*r**2+101692*r**4+31629*r**6)+5*Q2**9*(-5705+35759*r**2
        +230039*r**4+218089*r**6+30234*r**8)+5*Q2**8*(-525+8796*r**2-146250*r**4
        -109268*r**6-153705*r**8+11736*r**10)-4*Q2**7*(-15225+43362*r**2+391830*r**4
        +2489570*r**6+2227745*r**8+377580*r**10+82962*r**12)+2*Q2**6*(-27930
        -43407*r**2+1131663*r**4+11081830*r**6+22772900*r**8+9808525*r**10+1462503*r**12
        +123228*r**14)+2*Q2**5*(-9555+140781*r**2-32367*r**4-4813089*r**6-29472945*r**8
        -31808175*r**10-3300179*r**12-377517*r**14+60246*r**16)-10*Q2**4*(-5565
        +7257*r**2+73677*r**4+1239897*r**6+13677*r**8-4040437*r**10-1987573*r**12
        +2016227*r**14+189432*r**16+25632*r**18)+20*Q2**3*(-1050-6669*r**2-15750*r**4
        +487512*r**6+1874250*r**8+2580692*r**10+822492*r**12+1358960*r**14+999352*r**16
        +75105*r**18+4146*r**20)+2*Q2**2*(-5950+43977*r**2+67185*r**4+926990*r**6
        -6384960*r**8-19560330*r**10-42812974*r**12+391620*r**14-15779010*r**16
        +594465*r**18+36285*r**20+28302*r**22)-Q2*(-10955+5893*r**2-461227*r**4
        +2684035*r**6+5334100*r**8-7411850*r**10+19731094*r**12-69809126*r**14
        +49679065*r**16-20660475*r**18+8352405*r**20+424163*r**22+46878*r**24))
        -72576000*logq2**4*r**14*(3-5*r**2+3*r**4+3*r**6)*sqrtq2+2880*logq2**2*r**6*(4320*Q2**11*r**2
        -8*Q2**10*(-7+5007*r**2+4986*r**4)+40*Q2**9*(-49+3857*r**2+7613*r**4
        +3759*r**6)-5*Q2**8*(-1785+59477*r**2+182793*r**4+184359*r**6+55980*r**8)
        +20*Q2**7*(-693+13253*r**2+62918*r**4+96754*r**6+66735*r**8+10305*r**10)
        +10*Q2**6*r**2*(203-53651*r**2-117893*r**4-127639*r**6-74214*r**8+14490*r**10)
        -2*Q2**5*(-12054+112469*r**2+304767*r**4+680760*r**6+961880*r**8+607101*r**10
        +176799*r**12+206262*r**14)+10*Q2**4*(-2499+18097*r**2+84256*r**4+244614*r**6
        +424315*r**8+462877*r**10+217370*r**12+75348*r**14+27414*r**16)+20*Q2**3*(105
        -212*r**2-14014*r**4-73778*r**6-81299*r**8-182225*r**10-173800*r**12
        -14564*r**14-25104*r**16+1755*r**18)-(-1+r**2)**2*(-1561+9259*r**2
        +17902*r**4-417650*r**6+974908*r**8-198572*r**10+237346*r**12-321422*r**14
        +301405*r**16-10303*r**18+13488*r**20)-10*Q2**2*(-1176+8281*r**2+7383*r**4
        -111243*r**6+173905*r**8-7005*r**10-34557*r**12-191033*r**14+148275*r**16
        -27480*r**18+14490*r**20)+10*Q2*(-770+5515*r**2+4639*r**4-115040*r**6
        +228502*r**8-24740*r**10+66736*r**12+144310*r**14-185396*r**16+125097*r**18
        -14511*r**20+7578*r**22))*sqrtq2+8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(279
        +51832*r**2+176*Q2**13*r**2-369279*r**4+4247926*r**6-14274463*r**8+27526342*r**10
        +129617771*r**12-553885372*r**14+660388553*r**16-367966084*r**18+98308279*r**20
        -19691578*r**22-449*r**24-240954*r**26-803*r**28+Q2**12*(-771+3063*r**2
        +750*r**4)-164*Q2**11*(-33+128*r**2+1019*r**4+62*r**6)+Q2**10*(-15111
        -9033*r**2+1230491*r**4+1032041*r**6+31932*r**8)-5*Q2**9*(-3879-36553*r**2
        +548994*r**4+1328318*r**6+448293*r**8+7979*r**10)+3*Q2**8*(-1965-51364*r**2
        +421575*r**4+3601030*r**6+3697755*r**8+297990*r**10+691*r**12)+2*Q2**7*(
        -6534-250623*r**2+1616565*r**4+1573020*r**6+4328420*r**8+225321*r**10
        +1865997*r**12+23610*r**14)-6*Q2**6*(-2121-155674*r**2+639433*r**4+3196174*r**6
        +14532525*r**8+12173384*r**10+3212001*r**12+870548*r**14+6754*r**16)
        +2*Q2**5*(1341-77562*r**2-628581*r**4+4567029*r**6+42074003*r**8+109470491*r**10
        +33108893*r**12+7934379*r**14+18744*r**16-3777*r**18)+5*Q2**4*(-1809
        -150223*r**2+876924*r**4+169908*r**6+7909498*r**8-20693230*r**10-36952648*r**12
        +12121444*r**14+636303*r**16+858453*r**18+5444*r**20)-2*Q2**3*(-1560
        -259383*r**2+945675*r**4-2691330*r**6+34366420*r**8+42739050*r**10+22169566*r**12
        -21456000*r**14+54405220*r**16+4550445*r**18+1210935*r**20+4962*r**22)
        +Q2**2*(1689+97333*r**2-1232405*r**4-268865*r**6-2372290*r**8+41581502*r**10
        +204873794*r**12-9518230*r**14+80995985*r**16+10862285*r**18+3461779*r**20
        -676457*r**22-4520*r**24)+Q2*(-1413-196377*r**2+1385164*r**4-8497688*r**6
        +31338675*r**8-29081629*r**10+114936104*r**12-332908368*r**14+324732521*r**16
        -173777275*r**18+47143692*r**20-249752*r**22+980329*r**24+4017*r**26))*sqrtq2))/(
        -145152000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
        -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-1008000*logq2*r**4*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**3+435456000*logq2**4*r**16*sqrtq2+18144000*logq2**2*r**8*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2*sqrtq2+21000*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
        +(-1512000*logq2**3*r**12*(-1+r**2)**2*(1+r**2)-60*logq2*(-Q2+(-1+r)**2)*r**4*(
        -Q2+(1+r)**2)*(-320*Q2**9+2408*Q2**8*(1+r**2)-8*Q2**7*(793+2026*r**2
        +793*r**4)+Q2**6*(6069+34299*r**2+34299*r**4+6069*r**6)+2*Q2**5*(1141
        -9272*r**2-8986*r**4-9272*r**6+1141*r**8)-Q2**4*(8645+25705*r**2+122002*r**4
        +122002*r**6+25705*r**8+8645*r**10)+4*Q2**3*(1113+8678*r**2+46887*r**4
        +94004*r**6+46887*r**8+8678*r**10+1113*r**12)-2*Q2*(-1+r**2)**2*(1267
        +6626*r**2+62833*r**4+75268*r**6+62833*r**8+6626*r**10+1267*r**12)
        +(-1+r**2)**2*(653+4535*r**2+56817*r**4+13595*r**6+13595*r**8+56817*r**10
        +4535*r**12+653*r**14)+Q2**2*(1979-6007*r**2-22233*r**4-296299*r**6
        -296299*r**8-22233*r**10-6007*r**12+1979*r**14))-3600*logq2**2*r**8*(
        -80*Q2**6+480*Q2**5*(1+r**2)-36*Q2**4*(31+54*r**2+31*r**4)-3*Q2*(-1
        +r**2)**2*(267+335*r**2+335*r**4+267*r**6)+Q2**3*(949+2955*r**2+2955*r**4
        +949*r**6)+3*Q2**2*(83-576*r**2-806*r**4-576*r**6+83*r**8)+(-1+r**2)**2*(319
        +278*r**2+1326*r**4+278*r**6+319*r**8))*sqrtq2+(250*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4-2708*r**6-1133*r**8-34*r**10
        +r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1-19*r**2
        -19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4-26*r**6+r**8)+Q2*(1-31*r**2
        -390*r**4-390*r**6-31*r**8+r**10))-7*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4
        -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
        +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(11+36*Q2**8-348*r**2
        -4952*r**4+27564*r**6+27450*r**8+27564*r**10-4952*r**12-348*r**14+11*r**16
        -68*Q2**7*(1+r**2)+Q2**6*(-37+70*r**2-37*r**4)+2*Q2**5*(67-211*r**2
        -211*r**4+67*r**6)+Q2**4*(-55+600*r**2+3326*r**4+600*r**6-55*r**8)
        -8*Q2**3*(2+25*r**2+1233*r**4+1233*r**6+25*r**8+2*r**10)+Q2**2*(13
        -2*r**2+7471*r**4+18716*r**6+7471*r**8-2*r**10+13*r**12)+Q2*(-18
        +370*r**2+7678*r**4+3970*r**6+3970*r**8+7678*r**10+370*r**12-18*r**14)))*sqrtq2)/(
        -6048000*logq2**3*r**12-126000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
        +1512000*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))*sqrtq2+3500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)+(flagPERP*rhoLS*(
        -9072000*logq2**4*r**14*(3-5*r**2+3*r**4+3*r**6)-360*logq2**2*(-Q2+(
        -1+r)**2)*r**6*(-Q2+(1+r)**2)*(-1561+9259*r**2-4320*Q2**9*r**2+17902*r**4
        -417650*r**6+974908*r**8-198572*r**10+237346*r**12-321422*r**14+301405*r**16
        -10303*r**18+13488*r**20+56*Q2**8*(-1+561*r**2+558*r**4)-8*Q2**7*(-231
        +10905*r**2+23479*r**4+10443*r**6)+Q2**6*(-5173+95073*r**2+395461*r**4
        +410123*r**6+81564*r**8)+2*Q2**5*(833+2838*r**2-132894*r**4-264396*r**6
        -165291*r**8+20286*r**10)-Q2**4*(-8505+92765*r**2+183856*r**4+124504*r**6
        +99137*r**8+84875*r**10+145320*r**12)+2*Q2**3*(-4382+27037*r**2+165883*r**4
        +368170*r**6+507632*r**8+336617*r**10+152467*r**12+40656*r**14)+Q2**2*(
        -1043+19425*r**2-81059*r**4-460371*r**6-705957*r**8-1240669*r**10-142657*r**12
        -186753*r**14+33804*r**16)+Q2*(4578-30598*r**2-57842*r**4+265818*r**6
        -581026*r**8+372202*r**10+735618*r**12-512218*r**14+53872*r**16-48804*r**18))
        +(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(279+51832*r**2+176*Q2**13*r**2
        -369279*r**4+4247926*r**6-14274463*r**8+27526342*r**10+129617771*r**12
        -553885372*r**14+660388553*r**16-367966084*r**18+98308279*r**20-19691578*r**22
        -449*r**24-240954*r**26-803*r**28+Q2**12*(-771+3063*r**2+750*r**4)
        -164*Q2**11*(-33+128*r**2+1019*r**4+62*r**6)+Q2**10*(-15111-9033*r**2
        +1230491*r**4+1032041*r**6+31932*r**8)-5*Q2**9*(-3879-36553*r**2+548994*r**4
        +1328318*r**6+448293*r**8+7979*r**10)+3*Q2**8*(-1965-51364*r**2+421575*r**4
        +3601030*r**6+3697755*r**8+297990*r**10+691*r**12)+2*Q2**7*(-6534-250623*r**2
        +1616565*r**4+1573020*r**6+4328420*r**8+225321*r**10+1865997*r**12+23610*r**14)
        -6*Q2**6*(-2121-155674*r**2+639433*r**4+3196174*r**6+14532525*r**8+12173384*r**10
        +3212001*r**12+870548*r**14+6754*r**16)+2*Q2**5*(1341-77562*r**2-628581*r**4
        +4567029*r**6+42074003*r**8+109470491*r**10+33108893*r**12+7934379*r**14
        +18744*r**16-3777*r**18)+5*Q2**4*(-1809-150223*r**2+876924*r**4+169908*r**6
        +7909498*r**8-20693230*r**10-36952648*r**12+12121444*r**14+636303*r**16
        +858453*r**18+5444*r**20)-2*Q2**3*(-1560-259383*r**2+945675*r**4-2691330*r**6
        +34366420*r**8+42739050*r**10+22169566*r**12-21456000*r**14+54405220*r**16
        +4550445*r**18+1210935*r**20+4962*r**22)+Q2**2*(1689+97333*r**2-1232405*r**4
        -268865*r**6-2372290*r**8+41581502*r**10+204873794*r**12-9518230*r**14
        +80995985*r**16+10862285*r**18+3461779*r**20-676457*r**22-4520*r**24)
        +Q2*(-1413-196377*r**2+1385164*r**4-8497688*r**6+31338675*r**8-29081629*r**10
        +114936104*r**12-332908368*r**14+324732521*r**16-173777275*r**18+47143692*r**20
        -249752*r**22+980329*r**24+4017*r**26))-21600*logq2**3*r**10*(301-1584*r**2
        -240*Q2**6*r**2+5717*r**4-6176*r**6+8279*r**8-72*r**10-1017*r**12+1272*r**14
        +20*Q2**5*(7+51*r**2+72*r**4)-4*Q2**4*(196+445*r**2+1206*r**4+837*r**6)
        +Q2**3*(1001+2581*r**2+5141*r**4+8403*r**6+3162*r**8)+Q2**2*(91-2396*r**2
        -1418*r**4-5364*r**6-6801*r**8+432*r**10)+Q2*(-749+2609*r**2-3480*r**4
        -158*r**6+3027*r**8+2589*r**10-2718*r**12))*sqrtq2+6*logq2*r**2*(175*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2*(8+581*r**2+120*Q2**6*r**2+3050*r**4+5739*r**6
        +17844*r**8+12711*r**10+978*r**12-351*r**14-20*Q2**5*(1+15*r**2+18*r**4)
        -2*Q2**4*(16+121*r**2+138*r**4+153*r**6)+Q2**3*(88+271*r**2-53*r**4
        -177*r**6+459*r**8)+Q2**2*(8+525*r**2+1434*r**4+2118*r**6+1530*r**8
        +489*r**10)+Q2*(-52+725*r**2+1053*r**4+930*r**6+2430*r**8+1725*r**10
        -51*r**12))-(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(-945+77289*r**2+16344*Q2**12*r**2
        -1068248*r**4-2287556*r**6+19762515*r**8+1063925*r**10+325341152*r**12
        +351047496*r**14+300436157*r**16+86127035*r**18-35764680*r**20+471484*r**22
        +1150177*r**24-51801*r**26-24*Q2**11*(280+1857*r**2+2697*r**4)-2*Q2**10*(
        -9240+56013*r**2+91034*r**4+37533*r**6)+5*Q2**9*(315+90324*r**2+206344*r**4
        +187534*r**6+97119*r**8)-15*Q2**8*(2695+9843*r**2-5640*r**4-127074*r**6
        -9315*r**8+15723*r**10)-6*Q2**7*(-2450+63908*r**2+329295*r**4+2057255*r**6
        +1851205*r**8+280595*r**10+130908*r**12)+6*Q2**6*(6090-42119*r**2-42954*r**4
        +3218410*r**6+7796650*r**8+2824075*r**10-56574*r**12+106526*r**14)+6*Q2**5*(
        -2485+70202*r**2-57689*r**4-2695313*r**6-13862440*r**8-15042650*r**10
        -2436943*r**12-13139*r**14+93057*r**16)-10*Q2**4*(1995-52698*r**2-36468*r**4
        +1087647*r**6-377658*r**8-4864267*r**10-2008608*r**12+1907937*r**14
        -177333*r**16+53037*r**18)-10*Q2**3*(-630+31188*r**2-231525*r**4-1908369*r**6
        -5477115*r**8-3551839*r**10+1392701*r**12-4061955*r**14-3776739*r**16
        -202185*r**18+24468*r**20)+6*Q2**2*(1050-50966*r**2+195820*r**4+2367055*r**6
        +5253880*r**8+13578290*r**10+18742992*r**12+25988540*r**14+3090630*r**16
        +343580*r**18-415780*r**20+36909*r**22)+Q2*(-945+64632*r**2-1076498*r**4
        +5130240*r**6+27091125*r**8+89598500*r**10+99449856*r**12+205945476*r**14
        +62581685*r**16+50756100*r**18-15255630*r**20-1199588*r**22+67047*r**24)))*sqrtq2))/(54432000*logq2**4*r**16
        +2268000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+2625*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))**4-18144000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))*sqrtq2-126000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
        )
    res += ((muG*(9072000*logq2**4*r**14*(3-5*r**2+3*r**4+3*r**6)+360*logq2**2*(
        -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(-1561+9259*r**2-4320*Q2**9*r**2
        +17902*r**4-417650*r**6+974908*r**8-198572*r**10+237346*r**12-321422*r**14
        +301405*r**16-10303*r**18+13488*r**20+56*Q2**8*(-1+561*r**2+558*r**4)
        -8*Q2**7*(-231+10905*r**2+23479*r**4+10443*r**6)+Q2**6*(-5173+95073*r**2
        +395461*r**4+410123*r**6+81564*r**8)+2*Q2**5*(833+2838*r**2-132894*r**4
        -264396*r**6-165291*r**8+20286*r**10)-Q2**4*(-8505+92765*r**2+183856*r**4
        +124504*r**6+99137*r**8+84875*r**10+145320*r**12)+2*Q2**3*(-4382+27037*r**2
        +165883*r**4+368170*r**6+507632*r**8+336617*r**10+152467*r**12+40656*r**14)
        +Q2**2*(-1043+19425*r**2-81059*r**4-460371*r**6-705957*r**8-1240669*r**10
        -142657*r**12-186753*r**14+33804*r**16)+Q2*(4578-30598*r**2-57842*r**4
        +265818*r**6-581026*r**8+372202*r**10+735618*r**12-512218*r**14+53872*r**16
        -48804*r**18))-(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(279+51832*r**2
        +176*Q2**13*r**2-369279*r**4+4247926*r**6-14274463*r**8+27526342*r**10
        +129617771*r**12-553885372*r**14+660388553*r**16-367966084*r**18+98308279*r**20
        -19691578*r**22-449*r**24-240954*r**26-803*r**28+Q2**12*(-771+3063*r**2
        +750*r**4)-164*Q2**11*(-33+128*r**2+1019*r**4+62*r**6)+Q2**10*(-15111
        -9033*r**2+1230491*r**4+1032041*r**6+31932*r**8)-5*Q2**9*(-3879-36553*r**2
        +548994*r**4+1328318*r**6+448293*r**8+7979*r**10)+3*Q2**8*(-1965-51364*r**2
        +421575*r**4+3601030*r**6+3697755*r**8+297990*r**10+691*r**12)+2*Q2**7*(
        -6534-250623*r**2+1616565*r**4+1573020*r**6+4328420*r**8+225321*r**10
        +1865997*r**12+23610*r**14)-6*Q2**6*(-2121-155674*r**2+639433*r**4+3196174*r**6
        +14532525*r**8+12173384*r**10+3212001*r**12+870548*r**14+6754*r**16)
        +2*Q2**5*(1341-77562*r**2-628581*r**4+4567029*r**6+42074003*r**8+109470491*r**10
        +33108893*r**12+7934379*r**14+18744*r**16-3777*r**18)+5*Q2**4*(-1809
        -150223*r**2+876924*r**4+169908*r**6+7909498*r**8-20693230*r**10-36952648*r**12
        +12121444*r**14+636303*r**16+858453*r**18+5444*r**20)-2*Q2**3*(-1560
        -259383*r**2+945675*r**4-2691330*r**6+34366420*r**8+42739050*r**10+22169566*r**12
        -21456000*r**14+54405220*r**16+4550445*r**18+1210935*r**20+4962*r**22)
        +Q2**2*(1689+97333*r**2-1232405*r**4-268865*r**6-2372290*r**8+41581502*r**10
        +204873794*r**12-9518230*r**14+80995985*r**16+10862285*r**18+3461779*r**20
        -676457*r**22-4520*r**24)+Q2*(-1413-196377*r**2+1385164*r**4-8497688*r**6
        +31338675*r**8-29081629*r**10+114936104*r**12-332908368*r**14+324732521*r**16
        -173777275*r**18+47143692*r**20-249752*r**22+980329*r**24+4017*r**26))
        +21600*logq2**3*r**10*(301-1584*r**2-240*Q2**6*r**2+5717*r**4-6176*r**6
        +8279*r**8-72*r**10-1017*r**12+1272*r**14+20*Q2**5*(7+51*r**2+72*r**4)
        -4*Q2**4*(196+445*r**2+1206*r**4+837*r**6)+Q2**3*(1001+2581*r**2+5141*r**4
        +8403*r**6+3162*r**8)+Q2**2*(91-2396*r**2-1418*r**4-5364*r**6-6801*r**8
        +432*r**10)+Q2*(-749+2609*r**2-3480*r**4-158*r**6+3027*r**8+2589*r**10
        -2718*r**12))*sqrtq2+6*logq2*r**2*(-175*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(8
        +581*r**2+120*Q2**6*r**2+3050*r**4+5739*r**6+17844*r**8+12711*r**10
        +978*r**12-351*r**14-20*Q2**5*(1+15*r**2+18*r**4)-2*Q2**4*(16+121*r**2
        +138*r**4+153*r**6)+Q2**3*(88+271*r**2-53*r**4-177*r**6+459*r**8)
        +Q2**2*(8+525*r**2+1434*r**4+2118*r**6+1530*r**8+489*r**10)+Q2*(-52
        +725*r**2+1053*r**4+930*r**6+2430*r**8+1725*r**10-51*r**12))+(Q2
        -(-1+r)**2)*(Q2-(1+r)**2)*(-945+77289*r**2+16344*Q2**12*r**2-1068248*r**4
        -2287556*r**6+19762515*r**8+1063925*r**10+325341152*r**12+351047496*r**14
        +300436157*r**16+86127035*r**18-35764680*r**20+471484*r**22+1150177*r**24
        -51801*r**26-24*Q2**11*(280+1857*r**2+2697*r**4)-2*Q2**10*(-9240+56013*r**2
        +91034*r**4+37533*r**6)+5*Q2**9*(315+90324*r**2+206344*r**4+187534*r**6
        +97119*r**8)-15*Q2**8*(2695+9843*r**2-5640*r**4-127074*r**6-9315*r**8
        +15723*r**10)-6*Q2**7*(-2450+63908*r**2+329295*r**4+2057255*r**6+1851205*r**8
        +280595*r**10+130908*r**12)+6*Q2**6*(6090-42119*r**2-42954*r**4+3218410*r**6
        +7796650*r**8+2824075*r**10-56574*r**12+106526*r**14)+6*Q2**5*(-2485
        +70202*r**2-57689*r**4-2695313*r**6-13862440*r**8-15042650*r**10-2436943*r**12
        -13139*r**14+93057*r**16)-10*Q2**4*(1995-52698*r**2-36468*r**4+1087647*r**6
        -377658*r**8-4864267*r**10-2008608*r**12+1907937*r**14-177333*r**16
        +53037*r**18)-10*Q2**3*(-630+31188*r**2-231525*r**4-1908369*r**6-5477115*r**8
        -3551839*r**10+1392701*r**12-4061955*r**14-3776739*r**16-202185*r**18
        +24468*r**20)+6*Q2**2*(1050-50966*r**2+195820*r**4+2367055*r**6+5253880*r**8
        +13578290*r**10+18742992*r**12+25988540*r**14+3090630*r**16+343580*r**18
        -415780*r**20+36909*r**22)+Q2*(-945+64632*r**2-1076498*r**4+5130240*r**6
        +27091125*r**8+89598500*r**10+99449856*r**12+205945476*r**14+62581685*r**16
        +50756100*r**18-15255630*r**20-1199588*r**22+67047*r**24)))*sqrtq2))/(54432000*logq2**4*r**16
        +2268000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+2625*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))**4-18144000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))*sqrtq2-126000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
        )
    res += ((rhoD*(43200*logq2**3*r**8*(-240*Q2**8*(1+5*r**4)+20*Q2**7*(117+166*r**2
        +501*r**4+480*r**6)-4*Q2**6*(2415+5900*r**2+10136*r**4+14688*r**6+8085*r**8)
        +Q2**5*(19425+64530*r**2+93454*r**4+122436*r**6+133377*r**8+56490*r**10)
        -Q2**4*(17325+75505*r**2+111190*r**4+115462*r**6+146261*r**8+133785*r**10
        +46200*r**12)+Q2**3*(-210+29530*r**2+62170*r**4+36808*r**6+70082*r**8
        +98834*r**10+33270*r**12-2100*r**14)+(-1+r**2)**2*(2175+355*r**2-4569*r**4
        +39419*r**6+18349*r**8+115649*r**10-35691*r**12+5793*r**14+6360*r**16)
        +2*Q2**2*(6405+1710*r**2-17795*r**4+18194*r**6+29*r**8+40550*r**10
        -56313*r**12+14010*r**14+17850*r**16)-Q2*(9315-2300*r**2-25984*r**4
        +128230*r**6+56718*r**8+228638*r**10+286248*r**12-121038*r**14+5223*r**16
        +26310*r**18))-12*logq2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(4656*Q2**14*(1
        +5*r**4)-4*Q2**13*(9981+4346*r**2+38205*r**4+61980*r**6)+4*Q2**12*(35289
        +31746*r**2-3186*r**4+392890*r**6+264645*r**8)-Q2**11*(246759+384626*r**2
        -2256934*r**4+587244*r**6+5876815*r**8+2222370*r**10)+Q2**10*(155661
        +594681*r**2-8831714*r**4-13613034*r**6-7003739*r**8+8957825*r**10+1850880*r**12)
        +Q2**9*(185163-401150*r**2+21101265*r**4+55561850*r**6+91934525*r**8
        +68897718*r**10+939175*r**12+1490190*r**14)-Q2**8*(427977+170877*r**2
        +34467885*r**4+141383925*r**6+309486275*r**8+391317767*r**10+205760327*r**12
        +22704135*r**14+4844160*r**16)+Q2**7*(243738+632892*r**2+27746208*r**4
        +216896700*r**6+571666860*r**8+909856288*r**10+774178672*r**12+248138668*r**14
        +29796330*r**16+3521340*r**18)+2*Q2**6*(68409-318579*r**2+7216116*r**4
        -73107126*r**6-189303760*r**8-437701626*r**10-485681424*r**12-303122814*r**14
        +1309859*r**16-3843135*r**18+627120*r**20)-2*Q2**5*(130911-142854*r**2
        +27383571*r**4+15435336*r**6+182291046*r**8+165362706*r**10+80090386*r**12
        +79355246*r**14+52021411*r**16+162885196*r**18+8394675*r**20+1790130*r**22)
        +2*Q2**4*(54153+49975*r**2+21185265*r**4+52066275*r**6+329756050*r**8
        +567660684*r**10+603473600*r**12+564545620*r**14+392790475*r**16+229278725*r**18
        +152733063*r**20+8436225*r**22+913890*r**24)+Q2**3*(35901-262314*r**2
        +1570530*r**4-68997280*r**6-109705125*r**8-634573542*r**10-618767172*r**12
        -988466560*r**14-589938125*r**16-4908950*r**18-329195934*r**20-22813664*r**22
        -3502795*r**24+385830*r**26)-(-1+r**2)**2*(2589-4733*r**2+2241614*r**4
        -5780470*r**6+73049315*r**8-233520403*r**10-35002404*r**12+1228727532*r**14
        -742870045*r**16+129396765*r**18+122562014*r**20-23266038*r**22+16198429*r**24
        +441715*r**26+48120*r**28)-Q2**2*(51519-191549*r**2+21023614*r**4-48309390*r**6
        +383527965*r**8-515789363*r**10+29328068*r**12+329218412*r**14-1181695175*r**16
        -132837235*r**18+696010894*r**20-243046494*r**22+126648299*r**24+3036515*r**26
        +799920*r**28)+Q2*(19191-68166*r**2+12008609*r**4-34826154*r**6+321469335*r**8
        -789979722*r**10+85768417*r**12+1505869722*r**14+1701505453*r**16-981466970*r**18
        -175522149*r**20+583848074*r**22-180867131*r**24+78850026*r**26+1956835*r**28
        +330630*r**30))+18144000*logq2**4*r**12*(9+12*r**2-26*r**4+84*r**6+9*r**8)*sqrtq2
        +720*logq2**2*r**4*(-4320*Q2**11*(1+5*r**4)+8*Q2**10*(4965+4916*r**2+20601*r**4
        +24930*r**6)-40*Q2**9*(3612+7217*r**2+19493*r**4+31427*r**6+18795*r**8)
        +5*Q2**8*(50625+163440*r**2+459434*r**4+829380*r**6+751365*r**8+279900*r**10)
        -20*Q2**7*(8226+54837*r**2+165173*r**4+369290*r**6+407620*r**8+259473*r**10
        +51525*r**12)-20*Q2**6*(7245-29757*r**2-13760*r**4-167221*r**6-237535*r**8
        -163463*r**10-111678*r**12+36225*r**14)+2*Q2**5*(170100+80262*r**2+2890847*r**4
        +5149485*r**6+5819760*r**8+6516920*r**10+5177967*r**12+1268757*r**14
        +1031310*r**16)-10*Q2**4*(19917+43302*r**2+696535*r**4+1674070*r**6
        +2004837*r**8+2248840*r**10+2048341*r**12+1426478*r**14+375522*r**16
        +137070*r**18)-20*Q2**3*(2070-18825*r**2-40178*r**4-413134*r**6-493868*r**8
        -490217*r**10-921311*r**12-312148*r**14-100640*r**16-102060*r**18+8775*r**20)
        +20*Q2**2*(5481-14553*r**2+216497*r**4-202152*r**6-195594*r**8+245543*r**10
        +79464*r**12-737049*r**14-42235*r**16+428850*r**18-42237*r**20+36225*r**22)
        +(-1+r**2)**2*(8805-17242*r**2+789439*r**4-1773860*r**6-986474*r**8
        +9561352*r**10+5375842*r**12-326924*r**14-1127675*r**16+1722514*r**18
        +12383*r**20+67440*r**22)-10*Q2*(5268-15566*r**2+341497*r**4-654419*r**6
        -274184*r**8+2240122*r**10+1166944*r**12+2977672*r**14-436142*r**16
        -719852*r**18+696519*r**20-43509*r**22+37890*r**24))*sqrtq2+(-63*(Q2
        -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
        -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
        +r**8))**3*(5*Q2**5-Q2**4*(7+15*r**2)+2*Q2**3*(4+2*r**2+5*r**4)+(-1
        +r**2)**2*(17+r**2-11*r**4+5*r**6)+2*Q2**2*(7-6*r**2-4*r**4+5*r**6)
        -Q2*(37+20*r**2+8*r**4-32*r**6+15*r**8))+5*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32256*Q2**14
        -288*Q2**13*(339+518*r**2)+8*Q2**12*(11745+40478*r**2+23877*r**4)+Q2**11*(95499
        -358507*r**2-508135*r**4+99351*r**6)-Q2**10*(383589+356080*r**2+1976274*r**4
        -329264*r**6+354249*r**8)+Q2**9*(21459+1400491*r**2+7390760*r**4+10034036*r**6
        +1055725*r**8+34713*r**10)+3*Q2**8*(374345-756146*r**2-3663623*r**4
        -3769244*r**6-2403589*r**8-751922*r**10+107331*r**12)-6*Q2**7*(199739
        -371663*r**2-1833699*r**4-4168441*r**6-937469*r**8+2363425*r**10-467*r**12
        +14847*r**14)+Q2**6*(-288642+2265816*r**2+231180*r**4-8496168*r**6+23003492*r**8
        -6870072*r**10+13567596*r**12+2449800*r**14-179802*r**16)+2*Q2**5*(556707
        -2541849*r**2+17102856*r**4+26213580*r**6-16538884*r**8-58976872*r**10
        -14698344*r**12+5756076*r**14-244239*r**16+26649*r**18)+2*Q2**4*(-280545
        +498702*r**2-36732645*r**4-57585012*r**6-82444840*r**8-153525108*r**10
        -68689312*r**12+19803180*r**14-6641823*r**16-733650*r**18+33453*r**20)
        +Q2**3*(-80553+1343297*r**2+18298989*r**4+65629323*r**6+235764138*r**8
        +98850070*r**10+231769822*r**12+308404866*r**14+33807807*r**16-440343*r**18
        +313973*r**20-15309*r**22)+Q2**2*(240999-890072*r**2+38735950*r**4-99122616*r**6
        -171385291*r**8-436767904*r**10-226505772*r**12+241352384*r**14+125268401*r**16
        -35938824*r**18+3304030*r**20+469624*r**22-15309*r**24)+(-1+r**2)**2*(33375
        -463432*r**2+9716288*r**4+34210932*r**6+429107767*r**8+185694112*r**10
        -23101104*r**12-160832984*r**14+74725573*r**16+11512488*r**18+710768*r**20
        -61084*r**22+1701*r**24)+Q2*(-144057+1075351*r**2-33791760*r**4+4965436*r**6
        -891123325*r**8-1407498441*r**10-371766112*r**12+416999240*r**14+306799653*r**16
        -255890035*r**18-12685712*r**20-1896324*r**22-63215*r**24+1701*r**26)))*sqrtq2))/(
        -108864000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
        -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-756000*logq2*r**4*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**3+326592000*logq2**4*r**16*sqrtq2+13608000*logq2**2*r**8*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2*sqrtq2+15750*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2))

    if( flagDEBUG == 1):
        print("Q2moment n. 3 LO = ",res*par.mbkin**6)
    resNLO = 0
    resNLO +=((muWC*(580608000*logq2**4*(-Q2+(-1+r)**2)*(-1+r)*r**18*(1+r)*(3+r**2)*(
        -Q2+(1+r)**2)+46080*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
        -3083-1440*Q2**9-21300*r**2-156012*r**4+219036*r**6-102726*r**8+96228*r**10
        -127380*r**12+93732*r**14-2991*r**16+4496*r**18+4*Q2**8*(2273+2604*r**2)
        -4*Q2**7*(5349+13191*r**2+6962*r**4)+4*Q2**6*(5194+21897*r**2+27244*r**4
        +6797*r**6)+4*Q2**5*(-1288-11575*r**2-22049*r**4-18501*r**6+3381*r**8)
        +Q2**4*(105+16540*r**2+192*r**4-91464*r**6-43925*r**8-48440*r**10)
        +2*Q2**3*(-1876-25263*r**2-52654*r**4+31644*r**6+102858*r**8+44779*r**10
        +13552*r**12)+2*Q2**2*(-1457+10532*r**2+37610*r**4+92844*r**6-52061*r**8
        -9494*r**10-23128*r**12+5634*r**14)-2*Q2*(-3882-17641*r**2-96488*r**4
        +111141*r**6+740*r**8-79343*r**10+83496*r**12-6157*r**14+8134*r**16))
        +32*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-57-24*Q2**14+3714*r**2
        +43777*r**4-3791308*r**6-10159121*r**8+15296334*r**10-236289183*r**12
        +694656216*r**14-815729139*r**16+457228062*r**18-127046277*r**20+25369844*r**22
        +93757*r**24+322322*r**26+1059*r**28-56*Q2**13*(1+r**2)+Q2**12*(1457
        -3446*r**2-1627*r**4)+4*Q2**11*(-1615+8387*r**2+54679*r**4+3797*r**6)
        -4*Q2**10*(-3472+30654*r**2+403567*r**4+338572*r**6+11639*r**8)+4*Q2**9*(
        -4008+54495*r**2+1044380*r**4+2055110*r**6+727340*r**8+15387*r**10)
        -Q2**8*(-8157+170178*r**2+3813345*r**4+13564420*r**6+12323485*r**8+1013978*r**10
        +15423*r**12)-8*Q2**7*(-207+2181*r**2+203412*r**4-98905*r**6+1778395*r**8
        +542973*r**10+651616*r**12+6327*r**14)+8*Q2**6*(-420+13398*r**2+622461*r**4
        +1572643*r**6+10153075*r**8+11587780*r**10+3383193*r**12+891191*r**14
        +5943*r**16)+8*Q2**5*(-57-1356*r**2-185973*r**4-797988*r**6-6859881*r**8
        -23311392*r**10-9155691*r**12-2312708*r**14-8398*r**16+1284*r**18)-Q2**4*(
        -1931+71530*r**2+2109045*r**4-6455760*r**6+15777210*r**8-44549788*r**10
        -138504270*r**12+88484320*r**14+7369665*r**16+5785410*r**18+34249*r**20)
        +4*Q2**3*(-119+8471*r**2+323305*r**4-3050295*r**6-3025010*r**8-6052382*r**10
        +19084558*r**12-13941570*r**14+34632105*r**16+3167815*r**18+818121*r**20
        +3001*r**22)+4*Q2**2*(-122+4186*r**2+58337*r**4+87590*r**6+5884315*r**8
        +13803764*r**10+13722438*r**12-4033124*r**14-12132160*r**16-2175310*r**18
        -930087*r**20+223806*r**22+1567*r**24)-4*Q2*(-80+4233*r**2+73226*r**4
        -2220242*r**6-2960350*r**8-2058365*r**10-5455156*r**12-38454012*r**14
        +85305484*r**16-50223425*r**18+15606570*r**20+53198*r**22+327586*r**24
        +1333*r**26))-2764800*logq2**3*r**14*(80*Q2**8-40*Q2**7*(9+16*r**2)+4*Q2**6*(70
        +513*r**2+539*r**4)-Q2**5*(-875+832*r**2+4493*r**4+3766*r**6)+Q2**4*(
        -1365-2575*r**2+381*r**4+4383*r**6+3080*r**8)+Q2**3*(-1085+2710*r**2
        +2036*r**4+454*r**6-1567*r**8+140*r**10)-2*(-1+r**2)**3*(425+136*r**2
        +960*r**4-36*r**6-17*r**8+212*r**10)+Q2**2*(3815-1805*r**2+1326*r**4
        -1534*r**6-585*r**8+1163*r**10-2380*r**12)+2*Q2*(-1545+1684*r**2-2740*r**4
        +417*r**6+2167*r**8+382*r**10-1242*r**12+877*r**14))*sqrtq2-768*logq2*r**6*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1552*Q2**12-16*Q2**11*(1019+839*r**2)
        +4*Q2**10*(15178+32249*r**2+10543*r**4)-5*Q2**9*(20243+74180*r**2+65923*r**4
        +10078*r**6)+5*Q2**8*(11133+66119*r**2+14571*r**4+35385*r**6-3912*r**8)
        +Q2**7*(53091+217390*r**2+2593880*r**4+3079970*r**6+593565*r**8+110616*r**10)
        -Q2**6*(79317+518637*r**2+4583390*r**4+11581510*r**6+6306325*r**8+1004157*r**10
        +82152*r**12)+Q2**5*(681+236908*r**2+1727601*r**4+10473500*r**6+14406375*r**8
        +1663476*r**10+209223*r**12-40164*r**14)+5*Q2**4*(9453-16225*r**2-6707*r**4
        -197281*r**6-743501*r**8-450367*r**10+1400275*r**12+135873*r**14+17088*r**16)
        -5*Q2**3*(3923-19446*r**2-374714*r**4-697606*r**6-133704*r**8+1291134*r**10
        +1473114*r**12+1304486*r**14+102165*r**16+5528*r**18)-Q2**2*(9343-69585*r**2
        +487680*r**4+4315940*r**6+9186670*r**8-1775226*r**10+1697420*r**12-7227620*r**14
        +579795*r**16+34315*r**18+18868*r**20)+2*Q2*(4273-74882*r**2-922030*r**4
        -366555*r**6-5796450*r**8+7857684*r**10-6759156*r**12+7452630*r**14
        -2892495*r**16+1415150*r**18+74018*r**20+7813*r**22)+2*(-859+26573*r**2
        +484101*r**4+224465*r**6+7062050*r**8-15428522*r**10+7750374*r**12+4644878*r**14
        -5539715*r**16+1263325*r**18-464619*r**20-20447*r**22-1604*r**24))*sqrtq2))/(
        -653184000*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-27216000*logq2**2*(
        -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
        -31500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4
        +1512000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))**3*sqrtq2+217728000*logq2**3*r**14*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
        +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
        -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC**2*(72576000*logq2**4*(
        -Q2+(-1+r)**2)*(-1+r)*r**18*(1+r)*(3+r**2)*(-Q2+(1+r)**2)+5760*logq2**2*r**10*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-3083-1440*Q2**9-21300*r**2-156012*r**4
        +219036*r**6-102726*r**8+96228*r**10-127380*r**12+93732*r**14-2991*r**16
        +4496*r**18+4*Q2**8*(2273+2604*r**2)-4*Q2**7*(5349+13191*r**2+6962*r**4)
        +4*Q2**6*(5194+21897*r**2+27244*r**4+6797*r**6)+4*Q2**5*(-1288-11575*r**2
        -22049*r**4-18501*r**6+3381*r**8)+Q2**4*(105+16540*r**2+192*r**4-91464*r**6
        -43925*r**8-48440*r**10)+2*Q2**3*(-1876-25263*r**2-52654*r**4+31644*r**6
        +102858*r**8+44779*r**10+13552*r**12)+2*Q2**2*(-1457+10532*r**2+37610*r**4
        +92844*r**6-52061*r**8-9494*r**10-23128*r**12+5634*r**14)-2*Q2*(-3882
        -17641*r**2-96488*r**4+111141*r**6+740*r**8-79343*r**10+83496*r**12
        -6157*r**14+8134*r**16))+4*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(
        -57-24*Q2**14+3714*r**2+43777*r**4-3791308*r**6-10159121*r**8+15296334*r**10
        -236289183*r**12+694656216*r**14-815729139*r**16+457228062*r**18-127046277*r**20
        +25369844*r**22+93757*r**24+322322*r**26+1059*r**28-56*Q2**13*(1+r**2)
        +Q2**12*(1457-3446*r**2-1627*r**4)+4*Q2**11*(-1615+8387*r**2+54679*r**4
        +3797*r**6)-4*Q2**10*(-3472+30654*r**2+403567*r**4+338572*r**6+11639*r**8)
        +4*Q2**9*(-4008+54495*r**2+1044380*r**4+2055110*r**6+727340*r**8+15387*r**10)
        -Q2**8*(-8157+170178*r**2+3813345*r**4+13564420*r**6+12323485*r**8+1013978*r**10
        +15423*r**12)-8*Q2**7*(-207+2181*r**2+203412*r**4-98905*r**6+1778395*r**8
        +542973*r**10+651616*r**12+6327*r**14)+8*Q2**6*(-420+13398*r**2+622461*r**4
        +1572643*r**6+10153075*r**8+11587780*r**10+3383193*r**12+891191*r**14
        +5943*r**16)+8*Q2**5*(-57-1356*r**2-185973*r**4-797988*r**6-6859881*r**8
        -23311392*r**10-9155691*r**12-2312708*r**14-8398*r**16+1284*r**18)-Q2**4*(
        -1931+71530*r**2+2109045*r**4-6455760*r**6+15777210*r**8-44549788*r**10
        -138504270*r**12+88484320*r**14+7369665*r**16+5785410*r**18+34249*r**20)
        +4*Q2**3*(-119+8471*r**2+323305*r**4-3050295*r**6-3025010*r**8-6052382*r**10
        +19084558*r**12-13941570*r**14+34632105*r**16+3167815*r**18+818121*r**20
        +3001*r**22)+4*Q2**2*(-122+4186*r**2+58337*r**4+87590*r**6+5884315*r**8
        +13803764*r**10+13722438*r**12-4033124*r**14-12132160*r**16-2175310*r**18
        -930087*r**20+223806*r**22+1567*r**24)-4*Q2*(-80+4233*r**2+73226*r**4
        -2220242*r**6-2960350*r**8-2058365*r**10-5455156*r**12-38454012*r**14
        +85305484*r**16-50223425*r**18+15606570*r**20+53198*r**22+327586*r**24
        +1333*r**26))-345600*logq2**3*r**14*(80*Q2**8-40*Q2**7*(9+16*r**2)+4*Q2**6*(70
        +513*r**2+539*r**4)-Q2**5*(-875+832*r**2+4493*r**4+3766*r**6)+Q2**4*(
        -1365-2575*r**2+381*r**4+4383*r**6+3080*r**8)+Q2**3*(-1085+2710*r**2
        +2036*r**4+454*r**6-1567*r**8+140*r**10)-2*(-1+r**2)**3*(425+136*r**2
        +960*r**4-36*r**6-17*r**8+212*r**10)+Q2**2*(3815-1805*r**2+1326*r**4
        -1534*r**6-585*r**8+1163*r**10-2380*r**12)+2*Q2*(-1545+1684*r**2-2740*r**4
        +417*r**6+2167*r**8+382*r**10-1242*r**12+877*r**14))*sqrtq2-96*logq2*r**6*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1552*Q2**12-16*Q2**11*(1019+839*r**2)
        +4*Q2**10*(15178+32249*r**2+10543*r**4)-5*Q2**9*(20243+74180*r**2+65923*r**4
        +10078*r**6)+5*Q2**8*(11133+66119*r**2+14571*r**4+35385*r**6-3912*r**8)
        +Q2**7*(53091+217390*r**2+2593880*r**4+3079970*r**6+593565*r**8+110616*r**10)
        -Q2**6*(79317+518637*r**2+4583390*r**4+11581510*r**6+6306325*r**8+1004157*r**10
        +82152*r**12)+Q2**5*(681+236908*r**2+1727601*r**4+10473500*r**6+14406375*r**8
        +1663476*r**10+209223*r**12-40164*r**14)+5*Q2**4*(9453-16225*r**2-6707*r**4
        -197281*r**6-743501*r**8-450367*r**10+1400275*r**12+135873*r**14+17088*r**16)
        -5*Q2**3*(3923-19446*r**2-374714*r**4-697606*r**6-133704*r**8+1291134*r**10
        +1473114*r**12+1304486*r**14+102165*r**16+5528*r**18)-Q2**2*(9343-69585*r**2
        +487680*r**4+4315940*r**6+9186670*r**8-1775226*r**10+1697420*r**12-7227620*r**14
        +579795*r**16+34315*r**18+18868*r**20)+2*Q2*(4273-74882*r**2-922030*r**4
        -366555*r**6-5796450*r**8+7857684*r**10-6759156*r**12+7452630*r**14
        -2892495*r**16+1415150*r**18+74018*r**20+7813*r**22)+2*(-859+26573*r**2
        +484101*r**4+224465*r**6+7062050*r**8-15428522*r**10+7750374*r**12+4644878*r**14
        -5539715*r**16+1263325*r**18-464619*r**20-20447*r**22-1604*r**24))*sqrtq2))/(
        -217728000*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-9072000*logq2**2*(
        -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
        -10500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4
        +504000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))**3*sqrtq2+72576000*logq2**3*r**14*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
        +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
        -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(
        -145152000*logq2**4*(-Q2+(-1+r)**2)*(-1+r)*r**20*(1+r)*(1+3*r**2)*(
        -Q2+(1+r)**2)-11520*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
        -4496+1440*Q2**9+2991*r**2-93732*r**4+127380*r**6-96228*r**8+102726*r**10
        -219036*r**12+156012*r**14+21300*r**16+3083*r**18-4*Q2**8*(2604+2273*r**2)
        +4*Q2**7*(6962+13191*r**2+5349*r**4)-4*Q2**6*(6797+27244*r**2+21897*r**4
        +5194*r**6)+4*Q2**5*(-3381+18501*r**2+22049*r**4+11575*r**6+1288*r**8)
        +Q2**4*(48440+43925*r**2+91464*r**4-192*r**6-16540*r**8-105*r**10)
        +2*Q2**3*(-13552-44779*r**2-102858*r**4-31644*r**6+52654*r**8+25263*r**10
        +1876*r**12)+2*Q2**2*(-5634+23128*r**2+9494*r**4+52061*r**6-92844*r**8
        -37610*r**10-10532*r**12+1457*r**14)-2*Q2*(-8134+6157*r**2-83496*r**4
        +79343*r**6-740*r**8-111141*r**10+96488*r**12+17641*r**14+3882*r**16))
        -8*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-1059+24*Q2**14-322322*r**2
        -93757*r**4-25369844*r**6+127046277*r**8-457228062*r**10+815729139*r**12
        -694656216*r**14+236289183*r**16-15296334*r**18+10159121*r**20+3791308*r**22
        -43777*r**24-3714*r**26+57*r**28+56*Q2**13*(1+r**2)+Q2**12*(1627+3446*r**2
        -1457*r**4)+4*Q2**11*(-3797-54679*r**2-8387*r**4+1615*r**6)+4*Q2**10*(11639
        +338572*r**2+403567*r**4+30654*r**6-3472*r**8)+4*Q2**9*(-15387-727340*r**2
        -2055110*r**4-1044380*r**6-54495*r**8+4008*r**10)+Q2**8*(15423+1013978*r**2
        +12323485*r**4+13564420*r**6+3813345*r**8+170178*r**10-8157*r**12)-8*Q2**7*(
        -6327-651616*r**2-542973*r**4-1778395*r**6+98905*r**8-203412*r**10
        -2181*r**12+207*r**14)+8*Q2**6*(-5943-891191*r**2-3383193*r**4-11587780*r**6
        -10153075*r**8-1572643*r**10-622461*r**12-13398*r**14+420*r**16)+8*Q2**5*(
        -1284+8398*r**2+2312708*r**4+9155691*r**6+23311392*r**8+6859881*r**10
        +797988*r**12+185973*r**14+1356*r**16+57*r**18)+Q2**4*(34249+5785410*r**2
        +7369665*r**4+88484320*r**6-138504270*r**8-44549788*r**10+15777210*r**12
        -6455760*r**14+2109045*r**16+71530*r**18-1931*r**20)+4*Q2**3*(-3001
        -818121*r**2-3167815*r**4-34632105*r**6+13941570*r**8-19084558*r**10
        +6052382*r**12+3025010*r**14+3050295*r**16-323305*r**18-8471*r**20+119*r**22)
        +4*Q2**2*(-1567-223806*r**2+930087*r**4+2175310*r**6+12132160*r**8+4033124*r**10
        -13722438*r**12-13803764*r**14-5884315*r**16-87590*r**18-58337*r**20
        -4186*r**22+122*r**24)-4*Q2*(-1333-327586*r**2-53198*r**4-15606570*r**6
        +50223425*r**8-85305484*r**10+38454012*r**12+5455156*r**14+2058365*r**16
        +2960350*r**18+2220242*r**20-73226*r**22-4233*r**24+80*r**26))-691200*logq2**3*r**14*(80*Q2**8
        -40*Q2**7*(16+9*r**2)+4*Q2**6*(539+513*r**2+70*r**4)+Q2**5*(-3766-4493*r**2
        -832*r**4+875*r**6)+Q2**4*(3080+4383*r**2+381*r**4-2575*r**6-1365*r**8)
        +Q2**3*(140-1567*r**2+454*r**4+2036*r**6+2710*r**8-1085*r**10)+2*(
        -1+r**2)**3*(212-17*r**2-36*r**4+960*r**6+136*r**8+425*r**10)+Q2**2*(
        -2380+1163*r**2-585*r**4-1534*r**6+1326*r**8-1805*r**10+3815*r**12)
        +Q2*(1754-2484*r**2+764*r**4+4334*r**6+834*r**8-5480*r**10+3368*r**12
        -3090*r**14))*sqrtq2-192*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1552*Q2**12
        -16*Q2**11*(839+1019*r**2)+4*Q2**10*(10543+32249*r**2+15178*r**4)-5*Q2**9*(10078
        +65923*r**2+74180*r**4+20243*r**6)+5*Q2**8*(-3912+35385*r**2+14571*r**4
        +66119*r**6+11133*r**8)+Q2**7*(110616+593565*r**2+3079970*r**4+2593880*r**6
        +217390*r**8+53091*r**10)-Q2**6*(82152+1004157*r**2+6306325*r**4+11581510*r**6
        +4583390*r**8+518637*r**10+79317*r**12)+Q2**5*(-40164+209223*r**2+1663476*r**4
        +14406375*r**6+10473500*r**8+1727601*r**10+236908*r**12+681*r**14)+5*Q2**4*(17088
        +135873*r**2+1400275*r**4-450367*r**6-743501*r**8-197281*r**10-6707*r**12
        -16225*r**14+9453*r**16)-5*Q2**3*(5528+102165*r**2+1304486*r**4+1473114*r**6
        +1291134*r**8-133704*r**10-697606*r**12-374714*r**14-19446*r**16+3923*r**18)
        -Q2**2*(18868+34315*r**2+579795*r**4-7227620*r**6+1697420*r**8-1775226*r**10
        +9186670*r**12+4315940*r**14+487680*r**16-69585*r**18+9343*r**20)+2*Q2*(7813
        +74018*r**2+1415150*r**4-2892495*r**6+7452630*r**8-6759156*r**10+7857684*r**12
        -5796450*r**14-366555*r**16-922030*r**18-74882*r**20+4273*r**22)+2*(
        -1604-20447*r**2-464619*r**4+1263325*r**6-5539715*r**8+4644878*r**10
        +7750374*r**12-15428522*r**14+7062050*r**16+224465*r**18+484101*r**20
        +26573*r**22-859*r**24))*sqrtq2)/(-217728000*logq2**4*r**18*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))-9072000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2-10500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**4+504000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
        +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+72576000*logq2**3*r**14*(Q2**5
        -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
        +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
        -3*r**8))*sqrtq2)+(flagPERP*muWC**3*(172800*logq2**3*(-Q2+(-1+r)**2)*r**10*(
        -Q2+(1+r)**2)*(301-1584*r**2-240*Q2**6*r**2+5717*r**4-6176*r**6+8279*r**8
        -72*r**10-1017*r**12+1272*r**14+20*Q2**5*(7+51*r**2+72*r**4)-4*Q2**4*(196
        +445*r**2+1206*r**4+837*r**6)+Q2**3*(1001+2581*r**2+5141*r**4+8403*r**6
        +3162*r**8)+Q2**2*(91-2396*r**2-1418*r**4-5364*r**6-6801*r**8+432*r**10)
        +Q2*(-749+2609*r**2-3480*r**4-158*r**6+3027*r**8+2589*r**10-2718*r**12))
        +48*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(-2345-4786*r**2
        -4656*Q2**12*r**2-227548*r**4+481994*r**6+1802615*r**8-49508100*r**10
        +129325752*r**12-64400404*r**14-24624243*r**16+36020510*r**18-7593180*r**20
        +2793034*r**22+119077*r**24+9624*r**26+4*Q2**11*(-805+12483*r**2+10068*r**4)
        -4*Q2**10*(-4270+40169*r**2+101692*r**4+31629*r**6)+5*Q2**9*(-5705+35759*r**2
        +230039*r**4+218089*r**6+30234*r**8)+5*Q2**8*(-525+8796*r**2-146250*r**4
        -109268*r**6-153705*r**8+11736*r**10)-4*Q2**7*(-15225+43362*r**2+391830*r**4
        +2489570*r**6+2227745*r**8+377580*r**10+82962*r**12)+2*Q2**6*(-27930
        -43407*r**2+1131663*r**4+11081830*r**6+22772900*r**8+9808525*r**10+1462503*r**12
        +123228*r**14)+2*Q2**5*(-9555+140781*r**2-32367*r**4-4813089*r**6-29472945*r**8
        -31808175*r**10-3300179*r**12-377517*r**14+60246*r**16)-10*Q2**4*(-5565
        +7257*r**2+73677*r**4+1239897*r**6+13677*r**8-4040437*r**10-1987573*r**12
        +2016227*r**14+189432*r**16+25632*r**18)+20*Q2**3*(-1050-6669*r**2-15750*r**4
        +487512*r**6+1874250*r**8+2580692*r**10+822492*r**12+1358960*r**14+999352*r**16
        +75105*r**18+4146*r**20)+2*Q2**2*(-5950+43977*r**2+67185*r**4+926990*r**6
        -6384960*r**8-19560330*r**10-42812974*r**12+391620*r**14-15779010*r**16
        +594465*r**18+36285*r**20+28302*r**22)-Q2*(-10955+5893*r**2-461227*r**4
        +2684035*r**6+5334100*r**8-7411850*r**10+19731094*r**12-69809126*r**14
        +49679065*r**16-20660475*r**18+8352405*r**20+424163*r**22+46878*r**24))
        +72576000*logq2**4*r**14*(3-5*r**2+3*r**4+3*r**6)*sqrtq2+2880*logq2**2*r**6*(
        -4320*Q2**11*r**2+8*Q2**10*(-7+5007*r**2+4986*r**4)-40*Q2**9*(-49+3857*r**2
        +7613*r**4+3759*r**6)+5*Q2**8*(-1785+59477*r**2+182793*r**4+184359*r**6
        +55980*r**8)-20*Q2**7*(-693+13253*r**2+62918*r**4+96754*r**6+66735*r**8
        +10305*r**10)-10*Q2**6*r**2*(203-53651*r**2-117893*r**4-127639*r**6-74214*r**8
        +14490*r**10)+2*Q2**5*(-12054+112469*r**2+304767*r**4+680760*r**6+961880*r**8
        +607101*r**10+176799*r**12+206262*r**14)-10*Q2**4*(-2499+18097*r**2
        +84256*r**4+244614*r**6+424315*r**8+462877*r**10+217370*r**12+75348*r**14
        +27414*r**16)-20*Q2**3*(105-212*r**2-14014*r**4-73778*r**6-81299*r**8
        -182225*r**10-173800*r**12-14564*r**14-25104*r**16+1755*r**18)+(-1
        +r**2)**2*(-1561+9259*r**2+17902*r**4-417650*r**6+974908*r**8-198572*r**10
        +237346*r**12-321422*r**14+301405*r**16-10303*r**18+13488*r**20)+10*Q2**2*(
        -1176+8281*r**2+7383*r**4-111243*r**6+173905*r**8-7005*r**10-34557*r**12
        -191033*r**14+148275*r**16-27480*r**18+14490*r**20)-10*Q2*(-770+5515*r**2
        +4639*r**4-115040*r**6+228502*r**8-24740*r**10+66736*r**12+144310*r**14
        -185396*r**16+125097*r**18-14511*r**20+7578*r**22))*sqrtq2-8*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(279+51832*r**2+176*Q2**13*r**2-369279*r**4
        +4247926*r**6-14274463*r**8+27526342*r**10+129617771*r**12-553885372*r**14
        +660388553*r**16-367966084*r**18+98308279*r**20-19691578*r**22-449*r**24
        -240954*r**26-803*r**28+Q2**12*(-771+3063*r**2+750*r**4)-164*Q2**11*(
        -33+128*r**2+1019*r**4+62*r**6)+Q2**10*(-15111-9033*r**2+1230491*r**4
        +1032041*r**6+31932*r**8)-5*Q2**9*(-3879-36553*r**2+548994*r**4+1328318*r**6
        +448293*r**8+7979*r**10)+3*Q2**8*(-1965-51364*r**2+421575*r**4+3601030*r**6
        +3697755*r**8+297990*r**10+691*r**12)+2*Q2**7*(-6534-250623*r**2+1616565*r**4
        +1573020*r**6+4328420*r**8+225321*r**10+1865997*r**12+23610*r**14)-6*Q2**6*(
        -2121-155674*r**2+639433*r**4+3196174*r**6+14532525*r**8+12173384*r**10
        +3212001*r**12+870548*r**14+6754*r**16)+2*Q2**5*(1341-77562*r**2-628581*r**4
        +4567029*r**6+42074003*r**8+109470491*r**10+33108893*r**12+7934379*r**14
        +18744*r**16-3777*r**18)+5*Q2**4*(-1809-150223*r**2+876924*r**4+169908*r**6
        +7909498*r**8-20693230*r**10-36952648*r**12+12121444*r**14+636303*r**16
        +858453*r**18+5444*r**20)-2*Q2**3*(-1560-259383*r**2+945675*r**4-2691330*r**6
        +34366420*r**8+42739050*r**10+22169566*r**12-21456000*r**14+54405220*r**16
        +4550445*r**18+1210935*r**20+4962*r**22)+Q2**2*(1689+97333*r**2-1232405*r**4
        -268865*r**6-2372290*r**8+41581502*r**10+204873794*r**12-9518230*r**14
        +80995985*r**16+10862285*r**18+3461779*r**20-676457*r**22-4520*r**24)
        +Q2*(-1413-196377*r**2+1385164*r**4-8497688*r**6+31338675*r**8-29081629*r**10
        +114936104*r**12-332908368*r**14+324732521*r**16-173777275*r**18+47143692*r**20
        -249752*r**22+980329*r**24+4017*r**26))*sqrtq2))/(-163296000*logq2**3*r**12*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))-1134000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
        +489888000*logq2**4*r**16*sqrtq2+20412000*logq2**2*r**8*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))**2*sqrtq2+23625*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
        -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)+(muWC**3*(
        -172800*logq2**3*r**8*(-240*Q2**8*(1+5*r**4)+20*Q2**7*(117+166*r**2+501*r**4
        +480*r**6)-4*Q2**6*(2415+5900*r**2+10136*r**4+14688*r**6+8085*r**8)
        +Q2**5*(19425+64530*r**2+93454*r**4+122436*r**6+133377*r**8+56490*r**10)
        -Q2**4*(17325+75505*r**2+111190*r**4+115462*r**6+146261*r**8+133785*r**10
        +46200*r**12)+Q2**3*(-210+29530*r**2+62170*r**4+36808*r**6+70082*r**8
        +98834*r**10+33270*r**12-2100*r**14)+(-1+r**2)**2*(2175+355*r**2-4569*r**4
        +39419*r**6+18349*r**8+115649*r**10-35691*r**12+5793*r**14+6360*r**16)
        +2*Q2**2*(6405+1710*r**2-17795*r**4+18194*r**6+29*r**8+40550*r**10
        -56313*r**12+14010*r**14+17850*r**16)-Q2*(9315-2300*r**2-25984*r**4
        +128230*r**6+56718*r**8+228638*r**10+286248*r**12-121038*r**14+5223*r**16
        +26310*r**18))+48*logq2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(4656*Q2**14*(1
        +5*r**4)-4*Q2**13*(9981+4346*r**2+38205*r**4+61980*r**6)+4*Q2**12*(35289
        +31746*r**2-3186*r**4+392890*r**6+264645*r**8)-Q2**11*(246759+384626*r**2
        -2256934*r**4+587244*r**6+5876815*r**8+2222370*r**10)+Q2**10*(155661
        +594681*r**2-8831714*r**4-13613034*r**6-7003739*r**8+8957825*r**10+1850880*r**12)
        +Q2**9*(185163-401150*r**2+21101265*r**4+55561850*r**6+91934525*r**8
        +68897718*r**10+939175*r**12+1490190*r**14)-Q2**8*(427977+170877*r**2
        +34467885*r**4+141383925*r**6+309486275*r**8+391317767*r**10+205760327*r**12
        +22704135*r**14+4844160*r**16)+Q2**7*(243738+632892*r**2+27746208*r**4
        +216896700*r**6+571666860*r**8+909856288*r**10+774178672*r**12+248138668*r**14
        +29796330*r**16+3521340*r**18)+2*Q2**6*(68409-318579*r**2+7216116*r**4
        -73107126*r**6-189303760*r**8-437701626*r**10-485681424*r**12-303122814*r**14
        +1309859*r**16-3843135*r**18+627120*r**20)-2*Q2**5*(130911-142854*r**2
        +27383571*r**4+15435336*r**6+182291046*r**8+165362706*r**10+80090386*r**12
        +79355246*r**14+52021411*r**16+162885196*r**18+8394675*r**20+1790130*r**22)
        +2*Q2**4*(54153+49975*r**2+21185265*r**4+52066275*r**6+329756050*r**8
        +567660684*r**10+603473600*r**12+564545620*r**14+392790475*r**16+229278725*r**18
        +152733063*r**20+8436225*r**22+913890*r**24)+Q2**3*(35901-262314*r**2
        +1570530*r**4-68997280*r**6-109705125*r**8-634573542*r**10-618767172*r**12
        -988466560*r**14-589938125*r**16-4908950*r**18-329195934*r**20-22813664*r**22
        -3502795*r**24+385830*r**26)-(-1+r**2)**2*(2589-4733*r**2+2241614*r**4
        -5780470*r**6+73049315*r**8-233520403*r**10-35002404*r**12+1228727532*r**14
        -742870045*r**16+129396765*r**18+122562014*r**20-23266038*r**22+16198429*r**24
        +441715*r**26+48120*r**28)-Q2**2*(51519-191549*r**2+21023614*r**4-48309390*r**6
        +383527965*r**8-515789363*r**10+29328068*r**12+329218412*r**14-1181695175*r**16
        -132837235*r**18+696010894*r**20-243046494*r**22+126648299*r**24+3036515*r**26
        +799920*r**28)+Q2*(19191-68166*r**2+12008609*r**4-34826154*r**6+321469335*r**8
        -789979722*r**10+85768417*r**12+1505869722*r**14+1701505453*r**16-981466970*r**18
        -175522149*r**20+583848074*r**22-180867131*r**24+78850026*r**26+1956835*r**28
        +330630*r**30))-72576000*logq2**4*r**12*(9+12*r**2-26*r**4+84*r**6+9*r**8)*sqrtq2
        -2880*logq2**2*r**4*(-4320*Q2**11*(1+5*r**4)+8*Q2**10*(4965+4916*r**2+20601*r**4
        +24930*r**6)-40*Q2**9*(3612+7217*r**2+19493*r**4+31427*r**6+18795*r**8)
        +5*Q2**8*(50625+163440*r**2+459434*r**4+829380*r**6+751365*r**8+279900*r**10)
        -20*Q2**7*(8226+54837*r**2+165173*r**4+369290*r**6+407620*r**8+259473*r**10
        +51525*r**12)-20*Q2**6*(7245-29757*r**2-13760*r**4-167221*r**6-237535*r**8
        -163463*r**10-111678*r**12+36225*r**14)+2*Q2**5*(170100+80262*r**2+2890847*r**4
        +5149485*r**6+5819760*r**8+6516920*r**10+5177967*r**12+1268757*r**14
        +1031310*r**16)-10*Q2**4*(19917+43302*r**2+696535*r**4+1674070*r**6
        +2004837*r**8+2248840*r**10+2048341*r**12+1426478*r**14+375522*r**16
        +137070*r**18)-20*Q2**3*(2070-18825*r**2-40178*r**4-413134*r**6-493868*r**8
        -490217*r**10-921311*r**12-312148*r**14-100640*r**16-102060*r**18+8775*r**20)
        +20*Q2**2*(5481-14553*r**2+216497*r**4-202152*r**6-195594*r**8+245543*r**10
        +79464*r**12-737049*r**14-42235*r**16+428850*r**18-42237*r**20+36225*r**22)
        +(-1+r**2)**2*(8805-17242*r**2+789439*r**4-1773860*r**6-986474*r**8
        +9561352*r**10+5375842*r**12-326924*r**14-1127675*r**16+1722514*r**18
        +12383*r**20+67440*r**22)-10*Q2*(5268-15566*r**2+341497*r**4-654419*r**6
        -274184*r**8+2240122*r**10+1166944*r**12+2977672*r**14-436142*r**16
        -719852*r**18+696519*r**20-43509*r**22+37890*r**24))*sqrtq2+(252*(Q2
        -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
        -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
        +r**8))**3*(5*Q2**5-Q2**4*(7+15*r**2)+2*Q2**3*(4+2*r**2+5*r**4)+(-1
        +r**2)**2*(17+r**2-11*r**4+5*r**6)+2*Q2**2*(7-6*r**2-4*r**4+5*r**6)
        -Q2*(37+20*r**2+8*r**4-32*r**6+15*r**8))-20*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))*(32256*Q2**14-288*Q2**13*(339+518*r**2)+8*Q2**12*(11745+40478*r**2
        +23877*r**4)+Q2**11*(95499-358507*r**2-508135*r**4+99351*r**6)-Q2**10*(383589
        +356080*r**2+1976274*r**4-329264*r**6+354249*r**8)+Q2**9*(21459+1400491*r**2
        +7390760*r**4+10034036*r**6+1055725*r**8+34713*r**10)+3*Q2**8*(374345
        -756146*r**2-3663623*r**4-3769244*r**6-2403589*r**8-751922*r**10+107331*r**12)
        -6*Q2**7*(199739-371663*r**2-1833699*r**4-4168441*r**6-937469*r**8+2363425*r**10
        -467*r**12+14847*r**14)+Q2**6*(-288642+2265816*r**2+231180*r**4-8496168*r**6
        +23003492*r**8-6870072*r**10+13567596*r**12+2449800*r**14-179802*r**16)
        +2*Q2**5*(556707-2541849*r**2+17102856*r**4+26213580*r**6-16538884*r**8
        -58976872*r**10-14698344*r**12+5756076*r**14-244239*r**16+26649*r**18)
        +2*Q2**4*(-280545+498702*r**2-36732645*r**4-57585012*r**6-82444840*r**8
        -153525108*r**10-68689312*r**12+19803180*r**14-6641823*r**16-733650*r**18
        +33453*r**20)+Q2**3*(-80553+1343297*r**2+18298989*r**4+65629323*r**6
        +235764138*r**8+98850070*r**10+231769822*r**12+308404866*r**14+33807807*r**16
        -440343*r**18+313973*r**20-15309*r**22)+Q2**2*(240999-890072*r**2+38735950*r**4
        -99122616*r**6-171385291*r**8-436767904*r**10-226505772*r**12+241352384*r**14
        +125268401*r**16-35938824*r**18+3304030*r**20+469624*r**22-15309*r**24)
        +(-1+r**2)**2*(33375-463432*r**2+9716288*r**4+34210932*r**6+429107767*r**8
        +185694112*r**10-23101104*r**12-160832984*r**14+74725573*r**16+11512488*r**18
        +710768*r**20-61084*r**22+1701*r**24)+Q2*(-144057+1075351*r**2-33791760*r**4
        +4965436*r**6-891123325*r**8-1407498441*r**10-371766112*r**12+416999240*r**14
        +306799653*r**16-255890035*r**18-12685712*r**20-1896324*r**22-63215*r**24
        +1701*r**26)))*sqrtq2))/(-489888000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
        -3402000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+1469664000*logq2**4*r**16*sqrtq2
        +61236000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
        -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+70875*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**4*sqrtq2)+((-72576000*logq2**4*(-Q2+(-1+r)**2)*(
        -1+r)*r**20*(1+r)*(1+3*r**2)*(-Q2+(1+r)**2)-5760*logq2**2*r**10*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-4496+1440*Q2**9+2991*r**2-93732*r**4
        +127380*r**6-96228*r**8+102726*r**10-219036*r**12+156012*r**14+21300*r**16
        +3083*r**18-4*Q2**8*(2604+2273*r**2)+4*Q2**7*(6962+13191*r**2+5349*r**4)
        -4*Q2**6*(6797+27244*r**2+21897*r**4+5194*r**6)+4*Q2**5*(-3381+18501*r**2
        +22049*r**4+11575*r**6+1288*r**8)+Q2**4*(48440+43925*r**2+91464*r**4
        -192*r**6-16540*r**8-105*r**10)+2*Q2**3*(-13552-44779*r**2-102858*r**4
        -31644*r**6+52654*r**8+25263*r**10+1876*r**12)+2*Q2**2*(-5634+23128*r**2
        +9494*r**4+52061*r**6-92844*r**8-37610*r**10-10532*r**12+1457*r**14)
        -2*Q2*(-8134+6157*r**2-83496*r**4+79343*r**6-740*r**8-111141*r**10
        +96488*r**12+17641*r**14+3882*r**16))-4*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**3*(-1059+24*Q2**14-322322*r**2-93757*r**4-25369844*r**6+127046277*r**8
        -457228062*r**10+815729139*r**12-694656216*r**14+236289183*r**16-15296334*r**18
        +10159121*r**20+3791308*r**22-43777*r**24-3714*r**26+57*r**28+56*Q2**13*(1
        +r**2)+Q2**12*(1627+3446*r**2-1457*r**4)+4*Q2**11*(-3797-54679*r**2
        -8387*r**4+1615*r**6)+4*Q2**10*(11639+338572*r**2+403567*r**4+30654*r**6
        -3472*r**8)+4*Q2**9*(-15387-727340*r**2-2055110*r**4-1044380*r**6-54495*r**8
        +4008*r**10)+Q2**8*(15423+1013978*r**2+12323485*r**4+13564420*r**6+3813345*r**8
        +170178*r**10-8157*r**12)-8*Q2**7*(-6327-651616*r**2-542973*r**4-1778395*r**6
        +98905*r**8-203412*r**10-2181*r**12+207*r**14)+8*Q2**6*(-5943-891191*r**2
        -3383193*r**4-11587780*r**6-10153075*r**8-1572643*r**10-622461*r**12
        -13398*r**14+420*r**16)+8*Q2**5*(-1284+8398*r**2+2312708*r**4+9155691*r**6
        +23311392*r**8+6859881*r**10+797988*r**12+185973*r**14+1356*r**16+57*r**18)
        +Q2**4*(34249+5785410*r**2+7369665*r**4+88484320*r**6-138504270*r**8
        -44549788*r**10+15777210*r**12-6455760*r**14+2109045*r**16+71530*r**18
        -1931*r**20)+4*Q2**3*(-3001-818121*r**2-3167815*r**4-34632105*r**6+13941570*r**8
        -19084558*r**10+6052382*r**12+3025010*r**14+3050295*r**16-323305*r**18
        -8471*r**20+119*r**22)+4*Q2**2*(-1567-223806*r**2+930087*r**4+2175310*r**6
        +12132160*r**8+4033124*r**10-13722438*r**12-13803764*r**14-5884315*r**16
        -87590*r**18-58337*r**20-4186*r**22+122*r**24)-4*Q2*(-1333-327586*r**2
        -53198*r**4-15606570*r**6+50223425*r**8-85305484*r**10+38454012*r**12
        +5455156*r**14+2058365*r**16+2960350*r**18+2220242*r**20-73226*r**22
        -4233*r**24+80*r**26))-345600*logq2**3*r**14*(80*Q2**8-40*Q2**7*(16+9*r**2)
        +4*Q2**6*(539+513*r**2+70*r**4)+Q2**5*(-3766-4493*r**2-832*r**4+875*r**6)
        +Q2**4*(3080+4383*r**2+381*r**4-2575*r**6-1365*r**8)+Q2**3*(140-1567*r**2
        +454*r**4+2036*r**6+2710*r**8-1085*r**10)+2*(-1+r**2)**3*(212-17*r**2
        -36*r**4+960*r**6+136*r**8+425*r**10)+Q2**2*(-2380+1163*r**2-585*r**4
        -1534*r**6+1326*r**8-1805*r**10+3815*r**12)+Q2*(1754-2484*r**2+764*r**4
        +4334*r**6+834*r**8-5480*r**10+3368*r**12-3090*r**14))*sqrtq2-96*logq2*r**6*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1552*Q2**12-16*Q2**11*(839+1019*r**2)
        +4*Q2**10*(10543+32249*r**2+15178*r**4)-5*Q2**9*(10078+65923*r**2+74180*r**4
        +20243*r**6)+5*Q2**8*(-3912+35385*r**2+14571*r**4+66119*r**6+11133*r**8)
        +Q2**7*(110616+593565*r**2+3079970*r**4+2593880*r**6+217390*r**8+53091*r**10)
        -Q2**6*(82152+1004157*r**2+6306325*r**4+11581510*r**6+4583390*r**8+518637*r**10
        +79317*r**12)+Q2**5*(-40164+209223*r**2+1663476*r**4+14406375*r**6+10473500*r**8
        +1727601*r**10+236908*r**12+681*r**14)+5*Q2**4*(17088+135873*r**2+1400275*r**4
        -450367*r**6-743501*r**8-197281*r**10-6707*r**12-16225*r**14+9453*r**16)
        -5*Q2**3*(5528+102165*r**2+1304486*r**4+1473114*r**6+1291134*r**8-133704*r**10
        -697606*r**12-374714*r**14-19446*r**16+3923*r**18)-Q2**2*(18868+34315*r**2
        +579795*r**4-7227620*r**6+1697420*r**8-1775226*r**10+9186670*r**12+4315940*r**14
        +487680*r**16-69585*r**18+9343*r**20)+2*Q2*(7813+74018*r**2+1415150*r**4
        -2892495*r**6+7452630*r**8-6759156*r**10+7857684*r**12-5796450*r**14
        -366555*r**16-922030*r**18-74882*r**20+4273*r**22)+2*(-1604-20447*r**2
        -464619*r**4+1263325*r**6-5539715*r**8+4644878*r**10+7750374*r**12-15428522*r**14
        +7062050*r**16+224465*r**18+484101*r**20+26573*r**22-859*r**24))*sqrtq2)*math.log(mu0))/(
        -72576000*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-3024000*logq2**2*(
        -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
        -3500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4
        +168000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))**3*sqrtq2+24192000*logq2**3*r**14*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
        +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
        -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((72576000*logq2**4*(
        -Q2+(-1+r)**2)*(-1+r)*r**20*(1+r)*(1+3*r**2)*(-Q2+(1+r)**2)+5760*logq2**2*r**10*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-4496+1440*Q2**9+2991*r**2-93732*r**4
        +127380*r**6-96228*r**8+102726*r**10-219036*r**12+156012*r**14+21300*r**16
        +3083*r**18-4*Q2**8*(2604+2273*r**2)+4*Q2**7*(6962+13191*r**2+5349*r**4)
        -4*Q2**6*(6797+27244*r**2+21897*r**4+5194*r**6)+4*Q2**5*(-3381+18501*r**2
        +22049*r**4+11575*r**6+1288*r**8)+Q2**4*(48440+43925*r**2+91464*r**4
        -192*r**6-16540*r**8-105*r**10)+2*Q2**3*(-13552-44779*r**2-102858*r**4
        -31644*r**6+52654*r**8+25263*r**10+1876*r**12)+2*Q2**2*(-5634+23128*r**2
        +9494*r**4+52061*r**6-92844*r**8-37610*r**10-10532*r**12+1457*r**14)
        -2*Q2*(-8134+6157*r**2-83496*r**4+79343*r**6-740*r**8-111141*r**10
        +96488*r**12+17641*r**14+3882*r**16))+4*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**3*(-1059+24*Q2**14-322322*r**2-93757*r**4-25369844*r**6+127046277*r**8
        -457228062*r**10+815729139*r**12-694656216*r**14+236289183*r**16-15296334*r**18
        +10159121*r**20+3791308*r**22-43777*r**24-3714*r**26+57*r**28+56*Q2**13*(1
        +r**2)+Q2**12*(1627+3446*r**2-1457*r**4)+4*Q2**11*(-3797-54679*r**2
        -8387*r**4+1615*r**6)+4*Q2**10*(11639+338572*r**2+403567*r**4+30654*r**6
        -3472*r**8)+4*Q2**9*(-15387-727340*r**2-2055110*r**4-1044380*r**6-54495*r**8
        +4008*r**10)+Q2**8*(15423+1013978*r**2+12323485*r**4+13564420*r**6+3813345*r**8
        +170178*r**10-8157*r**12)-8*Q2**7*(-6327-651616*r**2-542973*r**4-1778395*r**6
        +98905*r**8-203412*r**10-2181*r**12+207*r**14)+8*Q2**6*(-5943-891191*r**2
        -3383193*r**4-11587780*r**6-10153075*r**8-1572643*r**10-622461*r**12
        -13398*r**14+420*r**16)+8*Q2**5*(-1284+8398*r**2+2312708*r**4+9155691*r**6
        +23311392*r**8+6859881*r**10+797988*r**12+185973*r**14+1356*r**16+57*r**18)
        +Q2**4*(34249+5785410*r**2+7369665*r**4+88484320*r**6-138504270*r**8
        -44549788*r**10+15777210*r**12-6455760*r**14+2109045*r**16+71530*r**18
        -1931*r**20)+4*Q2**3*(-3001-818121*r**2-3167815*r**4-34632105*r**6+13941570*r**8
        -19084558*r**10+6052382*r**12+3025010*r**14+3050295*r**16-323305*r**18
        -8471*r**20+119*r**22)+4*Q2**2*(-1567-223806*r**2+930087*r**4+2175310*r**6
        +12132160*r**8+4033124*r**10-13722438*r**12-13803764*r**14-5884315*r**16
        -87590*r**18-58337*r**20-4186*r**22+122*r**24)-4*Q2*(-1333-327586*r**2
        -53198*r**4-15606570*r**6+50223425*r**8-85305484*r**10+38454012*r**12
        +5455156*r**14+2058365*r**16+2960350*r**18+2220242*r**20-73226*r**22
        -4233*r**24+80*r**26))+345600*logq2**3*r**14*(80*Q2**8-40*Q2**7*(16+9*r**2)
        +4*Q2**6*(539+513*r**2+70*r**4)+Q2**5*(-3766-4493*r**2-832*r**4+875*r**6)
        +Q2**4*(3080+4383*r**2+381*r**4-2575*r**6-1365*r**8)+Q2**3*(140-1567*r**2
        +454*r**4+2036*r**6+2710*r**8-1085*r**10)+2*(-1+r**2)**3*(212-17*r**2
        -36*r**4+960*r**6+136*r**8+425*r**10)+Q2**2*(-2380+1163*r**2-585*r**4
        -1534*r**6+1326*r**8-1805*r**10+3815*r**12)+Q2*(1754-2484*r**2+764*r**4
        +4334*r**6+834*r**8-5480*r**10+3368*r**12-3090*r**14))*sqrtq2+96*logq2*r**6*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1552*Q2**12-16*Q2**11*(839+1019*r**2)
        +4*Q2**10*(10543+32249*r**2+15178*r**4)-5*Q2**9*(10078+65923*r**2+74180*r**4
        +20243*r**6)+5*Q2**8*(-3912+35385*r**2+14571*r**4+66119*r**6+11133*r**8)
        +Q2**7*(110616+593565*r**2+3079970*r**4+2593880*r**6+217390*r**8+53091*r**10)
        -Q2**6*(82152+1004157*r**2+6306325*r**4+11581510*r**6+4583390*r**8+518637*r**10
        +79317*r**12)+Q2**5*(-40164+209223*r**2+1663476*r**4+14406375*r**6+10473500*r**8
        +1727601*r**10+236908*r**12+681*r**14)+5*Q2**4*(17088+135873*r**2+1400275*r**4
        -450367*r**6-743501*r**8-197281*r**10-6707*r**12-16225*r**14+9453*r**16)
        -5*Q2**3*(5528+102165*r**2+1304486*r**4+1473114*r**6+1291134*r**8-133704*r**10
        -697606*r**12-374714*r**14-19446*r**16+3923*r**18)-Q2**2*(18868+34315*r**2
        +579795*r**4-7227620*r**6+1697420*r**8-1775226*r**10+9186670*r**12+4315940*r**14
        +487680*r**16-69585*r**18+9343*r**20)+2*Q2*(7813+74018*r**2+1415150*r**4
        -2892495*r**6+7452630*r**8-6759156*r**10+7857684*r**12-5796450*r**14
        -366555*r**16-922030*r**18-74882*r**20+4273*r**22)+2*(-1604-20447*r**2
        -464619*r**4+1263325*r**6-5539715*r**8+4644878*r**10+7750374*r**12-15428522*r**14
        +7062050*r**16+224465*r**18+484101*r**20+26573*r**22-859*r**24))*sqrtq2)*math.log(r))/(
        -72576000*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-3024000*logq2**2*(
        -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
        -3500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4
        +168000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))**3*sqrtq2+24192000*logq2**3*r**14*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
        +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
        -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((1512000*logq2**3*r**12*(1
        +r**2)*(19+10*r**2+19*r**4)+60*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1
        +r)**2)*(23-1440*Q2**9+10999*r**2+228160*r**4+383296*r**6+3006322*r**8
        +3006322*r**10+383296*r**12+228160*r**14+10999*r**16+23*r**18+10248*Q2**8*(1
        +r**2)-512*Q2**7*(37+94*r**2+37*r**4)+Q2**6*(4319+70769*r**2+70769*r**4
        +4319*r**6)+2*Q2**5*(8631-19072*r**2-30126*r**4-19072*r**6+8631*r**8)
        -Q2**4*(11375+66235*r**2+466262*r**4+466262*r**6+66235*r**8+11375*r**10)
        -4*Q2**3*(847-28698*r**2-220767*r**4-429164*r**6-220767*r**8-28698*r**10
        +847*r**12)+Q2**2*(3729-4117*r**2-37563*r**4-1070849*r**6-1070849*r**8
        -37563*r**10-4117*r**12+3729*r**14)-2*Q2*(217+25092*r**2+198688*r**4
        -394052*r**6-869490*r**8-394052*r**10+198688*r**12+25092*r**14+217*r**16))
        +3600*logq2**2*r**8*(781-80*Q2**6+4344*r**2+33555*r**4+43600*r**6+33555*r**8
        +4344*r**10+781*r**12+900*Q2**5*(1+r**2)-4*Q2**4*(951+1718*r**2+951*r**4)
        +Q2**3*(3931+13189*r**2+13189*r**4+3931*r**6)+Q2**2*(1131-5648*r**2
        -11126*r**4-5648*r**6+1131*r**8)-3*Q2*(953-829*r**2-3484*r**4-3484*r**6
        -829*r**8+953*r**10))*sqrtq2+(-250*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1+8*Q2**6
        -34*r**2-1133*r**4-2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1+r**2)
        +Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1
        -26*r**2-118*r**4-26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6
        -31*r**8+r**10))+7*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1
        +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
        -14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6
        -28170*r**8+31692*r**10-9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)
        +Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)
        +Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2
        -6138*r**4-6138*r**6-355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4
        +35188*r**6+10313*r**8-406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4
        +6605*r**6+6605*r**8-7237*r**10-595*r**12+27*r**14)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(72576000*logq2**4*r**16
        +3024000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+3500*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))**4-24192000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))*sqrtq2-168000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
        +((3600*logq2**2*r**8*(15+22*r**2+15*r**4)+(Q2-(-1+r)**2)*(Q2-(1
        +r)**2)*(7+92*Q2**8-156*r**2+5096*r**4+19308*r**6+138690*r**8+19308*r**10
        +5096*r**12-156*r**14+7*r**16-156*Q2**7*(1+r**2)+Q2**6*(-89+190*r**2
        -89*r**4)+2*Q2**5*(79-247*r**2-247*r**4+79*r**6)+Q2**4*(165-1160*r**2
        -10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4-2439*r**6
        -280*r**8+19*r**10)+Q2**2*(-79+806*r**2+1787*r**4-14228*r**6+1787*r**8
        +806*r**10-79*r**12)+2*Q2*(27-635*r**2-2957*r**4+19165*r**6+19165*r**8
        -2957*r**10-635*r**12+27*r**14))+600*logq2*r**4*(1+2*Q2**5+35*r**2
        +276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17+42*r**2
        +17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2+66*r**4
        +30*r**6-11*r**8))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(-86400*logq2**3*r**12-1800*logq2*r**4*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2+21600*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
        -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+50*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
        +((540*logq2*r**4*(1+r**2)-3*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
        -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
        +r**8))*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(1440*logq2**2*r**8+10*(Q2**2+(-1
        +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
        -Q2*(1+r**4))**2-240*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))*sqrtq2)+nlo.X1Q2(3,'SM',Q2,r)/(-12*logq2*r**4+(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))

    if( flagDEBUG == 1):
        print("Q2moment n. 3 NLO = api*",resNLO*par.mbkin**6)
    res += api*resNLO

    if(kwargs.get('flag_includeNLOpw', 1) == 1):
        resNLO = 0
        resNLO +=(muG*((10450944000*logq2**5*(-Q2+(-1+r)**2)*r**20*(-1+r**4+2*r**6)*(-Q2
            +(1+r)**2)+276480*logq2**3*(-Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)*(12240*Q2**11*r**2
            -2*Q2**10*(805+53106*r**2+45816*r**4)+10*Q2**9*(1015+39116*r**2+64725*r**4
            +27132*r**6)-5*Q2**8*(4620+150673*r**2+364785*r**4+298335*r**6+77877*r**8)
            +5*Q2**7*(3570+143209*r**2+480963*r**4+586151*r**6+308835*r**8+55800*r**10)
            -5*Q2**6*(-2520+22750*r**2+177459*r**4+380766*r**6+352988*r**8+139020*r**10
            +40257*r**12)+Q2**5*(-30030-407771*r**2-1498101*r**4-1336650*r**6-303620*r**8
            +778485*r**10+466599*r**12+375984*r**14)-5*Q2**4*(-2520-74608*r**2-394287*r**4
            -513900*r**6-387451*r**8+134208*r**10+299623*r**12+180180*r**14+70299*r**16)
            -5*Q2**3*(-1470+28837*r**2+81273*r**4+304061*r**6+153637*r**8-187209*r**10
            -459837*r**12-4249*r**14-165315*r**16+20448*r**18)+(-1+r**2)**2*(140
            +9813*r**2-202046*r**4+926700*r**6-769394*r**8+310202*r**10-49598*r**12
            -371164*r**14+840390*r**16+4209*r**18+56748*r**20)+5*Q2**2*(-1470+12026*r**2
            -181791*r**4+424860*r**6-318268*r**8-74112*r**10-111870*r**12-397228*r**14
            +616338*r**16-99210*r**18+80325*r**20)-5*Q2*(-280+7373*r**2-162861*r**4
            +598484*r**6-681340*r**8+216198*r**10+315794*r**12+314324*r**14-592836*r**16
            +600693*r**18-62925*r**20+52176*r**22))-192*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(-9312*Q2**17*r**2+4*Q2**16*(-805+31950*r**2+31368*r**4)
            -4*Q2**15*(-6685+161502*r**2+404131*r**4+169116*r**6)+Q2**14*(-86205
            +1568566*r**2+7173691*r**4+7409140*r**6+1895670*r**8)-2*Q2**13*(-55335
            +877182*r**2+6391588*r**4+7546174*r**6+7529917*r**8+1386990*r**10)+Q2**12*(55545
            +325312*r**2+892928*r**4-68024936*r**6-55484733*r**8+7582332*r**10+1205856*r**12)
            +4*Q2**11*(-88830+138939*r**2+7316008*r**4+90026929*r**6+162887050*r**8
            +76015549*r**10+6217412*r**12+641391*r**14)-Q2**10*(-367675-1123030*r**2
            +36823099*r**4+594075420*r**6+1792409349*r**8+1705822874*r**10+526212217*r**12
            +49659184*r**14+4273698*r**16)+2*Q2**9*(51205-825816*r**2+4872884*r**4
            +96431950*r**6+833807240*r**8+1312272220*r**10+895413124*r**12+152528314*r**14
            +14089355*r**16+642180*r**18)+Q2**8*(-523215-2287872*r**2-5690958*r**4
            +626144376*r**6+913254048*r**8+1261991140*r**10+202088558*r**12-313915968*r**14
            +199085991*r**16+14213508*r**18+2551560*r**20)-4*Q2**7*(-88165-1312728*r**2
            -7969281*r**4+197575162*r**6+740554886*r**8+1732027876*r**10+2057652454*r**12
            +790695704*r**14+170255247*r**16+87188276*r**18+6605931*r**20+630894*r**22)
            +Q2**6*(117425-1964862*r**2-15376235*r**4+107758348*r**6+1798025460*r**8
            +5044647308*r**10+10384226762*r**12+8058157568*r**14+1879903593*r**16
            +424735010*r**18+152762433*r**20+12860644*r**22-69294*r**24)+2*Q2**5*(
            -143535-1355918*r**2-18809060*r**4+209996206*r**6+78374599*r**8+662949094*r**10
            -177607368*r**12-2139634132*r**14-1113700217*r**16-581191826*r**18-260611316*r**20
            -44953946*r**22-2255135*r**24+650394*r**26)+Q2**4*(123795+2844816*r**2
            +44458316*r**4-296284040*r**6-471841525*r**8-2272449820*r**10-6261334512*r**12
            -1755882032*r**14+1136786505*r**16+924153720*r**18+2563155940*r**20+818410136*r**22
            +118116281*r**24+2390900*r**26-629280*r**28)-4*Q2**3*(-7980+107941*r**2
            +1499054*r**4+2511507*r**6-55651184*r**8-21011415*r**10-810178302*r**12
            +57571407*r**14+221197076*r**16+46474703*r**18+579675250*r**20+243457961*r**22
            +84712264*r**24+3269667*r**26-455394*r**28+30645*r**30)+(-1+r**2)**2*(
            -2345-65626*r**2-1854889*r**4+5984320*r**6-47439045*r**8-275719454*r**10
            +1938692851*r**12-6012321852*r**14+4658322525*r**16+2971961450*r**18
            -4803909227*r**20+1599597976*r**22-516519559*r**24-47590770*r**26-13103455*r**28
            -362524*r**30+9624*r**32)+Q2**2*(-49455-643662*r**2-15312277*r**4+103829084*r**6
            -285839973*r**8-52386658*r**10+2229257831*r**12-3134616736*r**14+1959850417*r**16
            +6026543886*r**18-9059347279*r**20+5204165324*r**22-1817549687*r**24
            -163304926*r**26-83714563*r**28-3897608*r**30+216282*r**32)+2*Q2*(8995
            +183028*r**2+4702628*r**4-26616782*r**6+116212870*r**8+241815308*r**10
            -2486307572*r**12+6566587018*r**14-5601093876*r**16+4012394060*r**18
            -7740793636*r**20+8223996790*r**22-3180020950*r**24+857273108*r**26+69788020*r**28
            +29502158*r**30+1047329*r**32-38496*r**34))+16588800*logq2**4*r**16*(240*Q2**8*r**2
            -30*Q2**7*(7+50*r**2+36*r**4)+6*Q2**6*(266+735*r**2+837*r**4+140*r**6)
            +Q2**5*(-4431-8071*r**2-9867*r**4-2727*r**6+3255*r**8)+Q2**4*(5145
            +8463*r**2+10265*r**4+3621*r**6-7935*r**8-5985*r**10)-Q2**3*(840+6167*r**2
            +3532*r**4+304*r**6-7221*r**8-10755*r**10+1995*r**12)+(-1+r**2)**2*(
            -819+3026*r**2-3897*r**4-222*r**6+6253*r**8-138*r**10-1083*r**12+3180*r**14)
            +Q2**2*(-3570+9163*r**2-7256*r**4-1146*r**6+823*r**8-1104*r**10-7515*r**12
            +12705*r**14)+Q2*(3129-11202*r**2+16166*r**4+1809*r**6-13731*r**8
            -16370*r**10-5184*r**12+11343*r**14-11160*r**16))*sqrtq2+4608*logq2**2*r**8*(57168*Q2**16*r**2
            -2*Q2**15*(-5845+367914*r**2+345684*r**4)+2*Q2**14*(-60410+1977755*r**2
            +3847837*r**4+1805820*r**6)-Q2**13*(-518455+11477745*r**2+34954556*r**4
            +33573901*r**6+10536375*r**8)+Q2**12*(-1127245+18705305*r**2+81383504*r**4
            +115278232*r**6+77963459*r**8+18219765*r**10)-Q2**11*(-1014580+13797569*r**2
            +91024971*r**4+147290736*r**6+158596776*r**8+99085571*r**10+17166369*r**12)
            +Q2**10*(795410-6200271*r**2+558208*r**4-111856145*r**6-149321880*r**8
            +4964085*r**10+55689058*r**12+3326439*r**14)+Q2**9*(-3084235+22994780*r**2
            +131965177*r**4+604029700*r**6+1079140925*r**8+848095140*r**10+253919035*r**12
            +13668052*r**14+11837370*r**16)-Q2**8*(-2890965+17705610*r**2+160097138*r**4
            +762087708*r**6+1647095240*r**8+1876140160*r**10+1144132650*r**12+322631448*r**14
            +40802073*r**16+14798250*r**18)+2*Q2**7*(91245-993555*r**2+31303271*r**4
            +158436418*r**6+400757286*r**8+628835220*r**10+646730610*r**12+378414966*r**14
            +125102193*r**16+19586391*r**18+4069035*r**20)-2*Q2**6*(1350580-6684492*r**2
            -14780171*r**4-90271141*r**6-248522356*r**8-243999466*r**10+403562*r**12
            +272798404*r**14+244216284*r**16+141574594*r**18+24874029*r**20+1273533*r**22)
            +Q2**5*(2217985-9060649*r**2-41186662*r**4-249628665*r**6-756356125*r**8
            -947143370*r**10-614776364*r**12+124696566*r**14+472413935*r**16+492953875*r**18
            +271044530*r**20+47995843*r**22+401901*r**24)+(-1+r**2)**4*(19915-39592*r**2
            +357464*r**4+6433228*r**6-38999325*r**8+134836920*r**10-60268716*r**12
            -61967028*r**14-45600531*r**16+115400300*r**18-20550860*r**20+14446408*r**22
            +1214789*r**24+77028*r**26)+Q2**4*(-286195-21915*r**2+19524024*r**4
            +110953260*r**6+200345175*r**8+409387415*r**10-70845440*r**12-314499048*r**14
            -472823125*r**16+121791875*r**18-394822920*r**20-25896820*r**22-12836351*r**24
            +1226865*r**26)+Q2**3*(-696920+3897355*r**2-10185931*r**4-58507916*r**6
            +299251940*r**8-595755285*r**10+456783225*r**12+316067952*r**14+80680992*r**16
            +491937185*r**18-1168768945*r**20+404633020*r**22-199420396*r**24-17716151*r**26
            -2200125*r**28)-Q2*(-1+r**2)**2*(164045-570452*r**2+2279922*r**4+31431742*r**6
            -204063877*r**8+587490210*r**10-180960636*r**12-133773324*r**14-82820229*r**16
            -242011256*r**18+635536970*r**20-142928562*r**22+84802877*r**24+7745962*r**26
            +556608*r**28)+Q2**2*(529130-2771695*r**2+7796704*r**4+53272407*r**6
            -435592656*r**8+1190874175*r**10-952364130*r**12+292056957*r**14+118660386*r**16
            +508424047*r**18-1312177820*r**20+1534052225*r**22-481728636*r**24+185089857*r**26
            +18039134*r**28+1599915*r**30))*sqrtq2+32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(176*Q2**18+Q2**17*(2535+1676*r**2)-Q2**16*(32913+364661*r**2
            +31652*r**4)+Q2**15*(68917+3787700*r**2+3771553*r**4+177696*r**6)-Q2**14*(
            -186186+14930971*r**2+33942285*r**4+15925827*r**6+525835*r**8)+Q2**13*(
            -732732+26050717*r**2+105692368*r**4+111027624*r**6+32799280*r**8+907327*r**10)
            -Q2**12*(324509+9485791*r**2+95086832*r**4+107830116*r**6+132834703*r**8
            +25415813*r**10+849708*r**12)+Q2**11*(4735695-35935918*r**2-174035451*r**4
            -860194842*r**6-730239207*r**8-78154746*r**10-25696893*r**12+186626*r**14)
            +Q2**10*(-7878420+51117673*r**2+455427703*r**4+2689270611*r**6+4581253617*r**8
            +2298868719*r**10+369632889*r**12+71295877*r**14+445027*r**16)-Q2**9*(
            -2284128+6347953*r**2+273545720*r**4+2278224806*r**6+7588991340*r**8
            +7470882852*r**10+2238303088*r**12+320261170*r**14+42657116*r**16+366355*r**18)
            +Q2**8*(7905711-29243549*r**2-120166776*r**4-1776146298*r**6+1548013800*r**8
            +4035751620*r**10+3769240026*r**12-219460086*r**14+2011977*r**16-29382855*r**18
            -121682*r**20)+Q2**7*(-9312237+5292944*r**2+126690299*r**4+4437162732*r**6
            +7584211446*r**8+12328513824*r**10+7299356238*r**12+1118301864*r**14
            +1733839047*r**16+122705136*r**18+50863751*r**20+262988*r**22)-Q2**6*(
            -631274-24250639*r**2-17896433*r**4+1874113581*r**6+6883024941*r**8
            +15156693138*r**10+20234085838*r**12+7332891090*r**14+985613736*r**16
            +858975661*r**18+78073619*r**20+12183601*r**22+6021*r**24)+Q2**5*(5624664
            -13151621*r**2+112252680*r**4-1821627060*r**6+1866941356*r**8-2250779013*r**10
            +7611706416*r**12+8755730960*r**14+1615778544*r**16+1282968081*r**18
            +175004776*r**20+126163332*r**22-18061908*r**24-163367*r**26)+Q2**4*(
            -3753939-7632901*r**2-209951320*r**4+2113533408*r**6-1413307675*r**8
            +10066028003*r**10+6957706272*r**12-699243080*r**14-1370609321*r**16
            -3452772735*r**18-2930899984*r**20-412158616*r**22-139818345*r**24+12844193*r**26
            +90440*r**28)+Q2**3*(-105655+8863882*r**2+44640383*r**4-316660626*r**6
            +585467545*r**8-2566777246*r**10-5087246889*r**12+3816175574*r**14-720240173*r**16
            +2043625630*r**18+2367671797*r**20+1524887882*r**22+224304843*r**24+13040374*r**26
            +118325*r**28+13554*r**30)+Q2**2*(1128336-2016029*r**2+92595333*r**4
            -654708291*r**6+2153606607*r**8-3252444525*r**10+1274435037*r**12-2290651051*r**14
            -7064801553*r**16+16654038801*r**18-12936995113*r**20+3971069823*r**22
            +275119893*r**24+186126969*r**26+72474567*r**28-3043473*r**30-31331*r**32)
            -2*(-1+r**2)**2*(-36857-161613*r**2-6810851*r**4+35146072*r**6-233476106*r**8
            -16624739*r**10+3287333199*r**12-13455588938*r**14+20748902706*r**16
            -14279266723*r**18+4617951579*r**20-955820164*r**22-34667986*r**24-29099053*r**26
            -4448071*r**28+74742*r**30+803*r**32)+Q2*(-500931-431635*r**2-65255680*r**4
            +451471698*r**6-2224528152*r**8+3042024930*r**10+6513831000*r**12-23634794558*r**14
            -2182533326*r**16+57386238084*r**18-60936658352*r**20+24714711430*r**22
            -5251155984*r**24-197165922*r**26-182264232*r**28-46919322*r**30+1182905*r**32
            +12047*r**34))*sqrtq2)/(7838208000*logq2**5*r**22*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))+544320000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+1890000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-45360000*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-31500*(-Q2+(
            -1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2-3265920000*logq2**4*r**18*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC**2*(3483648000*logq2**5*(-Q2+(-1+r)**2)*r**20*(9
            -10*r**2+3*r**4)*(-Q2+(1+r)**2)-276480*logq2**3*(-Q2+(-1+r)**2)*r**12*(
            -Q2+(1+r)**2)*(-13800*Q2**11*r**2+2*Q2**10*(1183+50106*r**2+63360*r**4)
            -10*Q2**9*(1862+30037*r**2+75730*r**4+47775*r**6)+5*Q2**8*(10836+96829*r**2
            +341865*r**4+457575*r**6+178965*r**8)-5*Q2**7*(14175+91596*r**2+349567*r**4
            +710459*r**6+666090*r**8+133425*r**10)+5*Q2**6*(5166+71750*r**2+136503*r**4
            +302646*r**6+475234*r**8+381276*r**10-94815*r**12)+Q2**5*(39753-427924*r**2
            -192780*r**4+684375*r**6+2480045*r**8+1957878*r**10+792246*r**12+1382535*r**14)
            -5*Q2**4*(9786-82854*r**2-86027*r**4-15030*r**6+508353*r**8+1152958*r**10
            +695411*r**12+368550*r**14+190125*r**16)-5*Q2**3*(-1659+22414*r**2+18399*r**4
            +223919*r**6-104783*r**8-380981*r**10-767571*r**12-8635*r**14-270690*r**16
            +20115*r**18)+(-1+r**2)**2*(3206-17901*r**2-146458*r**4+1170320*r**6
            -1694762*r**8+463394*r**10-610154*r**12+36128*r**14+529700*r**16-35093*r**18
            +49620*r**20)+5*Q2**2*(3780-25424*r**2-85653*r**4+329592*r**6-297428*r**8
            -97656*r**10-49734*r**12-285416*r**14+602424*r**16-177960*r**18+100275*r**20)
            -5*Q2*(2821-21240*r**2-75386*r**4+493297*r**6-795330*r**8+116332*r**10
            +97264*r**12-119610*r**14-335243*r**16+484164*r**18-102894*r**20+54225*r**22))
            -192*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-4656*Q2**17*r**2
            +12*Q2**16*(-805+7546*r**2+4520*r**4)-4*Q2**15*(-20300+125745*r**2+251866*r**4
            +64161*r**6)+Q2**14*(-275065+1370912*r**2+4915363*r**4+4199138*r**6
            +601950*r**8)-2*Q2**13*(-214970+1260163*r**2+4511450*r**4+3212968*r**6
            +3509566*r**8+276675*r**10)-Q2**12*(121555-4616214*r**2-3023244*r**4
            +70427968*r**6+64771265*r**8+2686282*r**10+584052*r**12)+4*Q2**11*(-160055
            -2115147*r**2+2393678*r**4+77520954*r**6+151402081*r**8+73309069*r**10
            +7399168*r**12+520380*r**14)-Q2**10*(-955955-10703980*r**2+11335747*r**4
            +511505094*r**6+1522681473*r**8+1609029128*r**10+460965593*r**12+42222190*r**14
            +1745238*r**16)+2*Q2**9*(-113960-3256097*r**2+7273912*r**4+200456682*r**6
            +642716370*r**8+1019230350*r**10+784038848*r**12+28314782*r**14+1917262*r**16
            -406725*r**18)+Q2**8*(-671055-828018*r**2-35072310*r**4-215322668*r**6
            +308248824*r**8+2203025540*r**10+1859786862*r**12+765039060*r**14+785865087*r**16
            +52984614*r**18+2640000*r**20)-4*Q2**7*(-159390-939705*r**2-9439218*r**4
            -53682899*r**6+214629860*r**8+1513266814*r**10+2933086536*r**12+1765694942*r**14
            +765085506*r**16+243568995*r**18+13529634*r**20+383757*r**22)+Q2**6*(14245
            -2601000*r**2-10313459*r**4-123020682*r**6+115313612*r**8+3546757368*r**10
            +10923209002*r**12+15423453156*r**14+3846091133*r**16+2325452512*r**18
            +95933193*r**20+318550*r**22-678510*r**24)+2*Q2**5*(-163030+873155*r**2
            -449162*r**4-59157020*r**6+63575378*r**8-822995267*r**10+9161508*r**12
            -2453250528*r**14-3537729018*r**16+2869320653*r**18-9100762*r**20+354852508*r**22
            +17493086*r**24+659379*r**26)-Q2**4*(-161735+1050718*r**2+8348312*r**4
            -170558248*r**6+8830865*r**8-2785712110*r**10+1203553164*r**12+6784711776*r**14
            +1117779451*r**16+1067976450*r**18+7966875960*r**20+933866408*r**22+558750427*r**24
            +22439662*r**26+514500*r**28)-4*Q2**3*(-6685+84789*r**2-978690*r**4
            +8974724*r**6+1719973*r**8+355459575*r**10-21401448*r**12+103434950*r**14
            -2194764243*r**16+1284336819*r**18-1364735290*r**20-272891816*r**22-164138485*r**24
            -4518431*r**26+174308*r**28+40350*r**30)+(-1+r**2)**2*(-2345+90000*r**2
            +1706955*r**4-3249462*r**6+64464163*r**8+87165780*r**10-901095201*r**12
            +5288150230*r**14-7931083571*r**16+1246630344*r**18+3028509985*r**20
            -1648009898*r**22+577234465*r**24-8347692*r**26+15923893*r**28+462730*r**30
            +9624*r**32)+Q2**2*(-52255+957372*r**2+7167859*r**4-42997778*r**6+174602455*r**8
            -492810992*r**10-412533913*r**12+455422842*r**14+2160167061*r**16-10848483700*r**18
            +15873197529*r**20-10198915870*r**22+3796670349*r**24-354338008*r**26
            +177399245*r**28+6731318*r**30+216486*r**32)-2*Q2*(-9380+259607*r**2
            +3240484*r**4-15128458*r**6+110463318*r**8-201897928*r**10-102586012*r**12
            +2276253942*r**14-2145554354*r**16-169137186*r**18-5484409684*r**20+8541201618*r**22
            -4505777326*r**24+1369522912*r**26-86388532*r**28+45531842*r**30+1497262*r**32
            +37875*r**34))+16588800*logq2**4*r**16*(360*Q2**8*r**2-10*Q2**7*(7+162*r**2
            +288*r**4)+Q2**6*(70+2800*r**2+9864*r**4+9702*r**6)-Q2**5*(-315+455*r**2
            +12039*r**4+24261*r**6+16947*r**8)+Q2**4*(-490-3290*r**2+2465*r**4
            +19687*r**6+29226*r**8+13860*r**10)+Q2**3*(-1085+6125*r**2-55*r**4
            -3508*r**6-11572*r**8-16449*r**10+630*r**12)+Q2**2*(3465-8995*r**2
            +9360*r**4-1943*r**6+4612*r**8-1530*r**10+6441*r**12-10710*r**14)-(
            -1+r**2)**2*(-1015+3700*r**2-9019*r**4+6654*r**6-3671*r**8-696*r**10
            +39*r**12+1908*r**14)+Q2*(-3220+10805*r**2-26354*r**4+6770*r**6+8093*r**8
            -7377*r**10+1968*r**12-6978*r**14+7893*r**16))*sqrtq2-4608*logq2**2*r**8*(
            -48696*Q2**16*r**2+Q2**15*(-8750+619356*r**2+602496*r**4)-2*Q2**14*(-45955
            +1637980*r**2+3353044*r**4+1597185*r**6)+Q2**13*(-393085+9544235*r**2
            +29680992*r**4+30279507*r**6+9227085*r**8)-2*Q2**12*(-430185+8601300*r**2
            +33690399*r**4+49321377*r**6+35555819*r**8+7275660*r**10)+Q2**11*(-904925
            +20888253*r**2+80487362*r**4+108916432*r**6+110165837*r**8+80182727*r**10
            +7667478*r**12)+Q2**10*(23905-19147608*r**2-36842691*r**4+105370860*r**6
            +292293505*r**8+170417230*r**10+5213229*r**12+15325002*r**14)-Q2**9*(
            -1096130-14793420*r**2+24541599*r**4+420289120*r**6+1168638925*r**8
            +1396571620*r**10+676232765*r**12+139301024*r**14+34318185*r**16)+Q2**8*(
            -1310505-8515320*r**2+44594566*r**4+491699956*r**6+1488182760*r**8+2431219720*r**10
            +2176788310*r**12+755763936*r**14+172325661*r**16+24098580*r**18)+2*Q2**7*(385980
            +660975*r**2-13783702*r**4-177281646*r**6-420480552*r**8-707588780*r**10
            -896325280*r**12-690316642*r**14-10866696*r**16-29567187*r**18+3731970*r**20)
            -2*Q2**6*(194600-1118316*r**2-4980263*r**4-150811833*r**6-134778178*r**8
            +34462052*r**10+288135656*r**12+186283262*r**14+53070742*r**16+397557572*r**18
            +31532427*r**20+13002759*r**22)+Q2**5*(211015-1190677*r**2-4257006*r**4
            -283011785*r**6-121726915*r**8+129496190*r**10+1071798188*r**12+1699419558*r**14
            +1124927665*r**16+630736535*r**18+778254050*r**20+80103299*r**22+17510283*r**24)
            +(-1+r**2)**4*(14455+66124*r**2+405092*r**4+2904544*r**6-21889925*r**8
            +163937640*r**10-217667748*r**12+4343716*r**14-17519463*r**16+81215600*r**18
            -24685920*r**20+13048924*r**22+572117*r**24+134844*r**26)-2*Q2**4*(-53480
            +143980*r**2-2733281*r**4-71210145*r**6+32240950*r**8-78792240*r**10
            +169118570*r**12+313156762*r**14+443317660*r**16-40129300*r**18+266623295*r**20
            +73466175*r**22+16499694*r**24+356160*r**26)+Q2**3*(-348285+252585*r**2
            -6848558*r**4-4729788*r**6+170699355*r**8-463203255*r**10+580112610*r**12
            +197835936*r**14-69405119*r**16+581246235*r**18-1407937210*r**20+696723580*r**22
            -269425503*r**24+1106707*r**26-6079290*r**28)-Q2*(-1+r**2)**2*(101500
            +264314*r**2+2099891*r**4+2722766*r**6-78130466*r**8+561515200*r**10
            -453769023*r**12-425833772*r**14+26678008*r**16-194483998*r**18+546273725*r**20
            -202328866*r**22+89573806*r**24+3186276*r**26+1170639*r**28)+Q2**2*(279545
            +65400*r**2+4797077*r**4-18715404*r**6-123352933*r**8+842656050*r**10
            -1032108585*r**12+153752766*r**14-385405217*r**16+485386996*r**18-1402620525*r**20
            +1721530760*r**22-735422643*r**24+239886946*r**26+3299137*r**28+4050630*r**30))*sqrtq2
            +32*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(Q2**17*(-1542+3767*r**2)
            +Q2**16*(17778-34295*r**2-202649*r**4)+Q2**15*(-90588-48157*r**2+2703580*r**4
            +1795979*r**6)+Q2**14*(265755+884987*r**2-11670975*r**4-21685077*r**6
            -6684838*r**8)+Q2**13*(-487065-2036822*r**2+24842008*r**4+70452960*r**6
            +64811533*r**8+10930882*r**10)+Q2**12*(558966-968167*r**2-33973991*r**4
            -55260148*r**6-17601730*r**8-52942397*r**10+124571*r**12)-Q2**11*(369234
            -11276885*r**2-43439958*r**4+117227325*r**6+866976798*r**8+771141141*r**10
            +147201030*r**12+30009811*r**14)+Q2**10*(108009-19197293*r**2-53738693*r**4
            +252514953*r**6+2341893339*r**8+4291308117*r**10+2157827685*r**12+394790047*r**14
            +43404460*r**16)-Q2**9*(36135-11109566*r**2-39161350*r**4+187190956*r**6
            +2257069404*r**8+6141189660*r**10+7119901134*r**12+1613906380*r**14+240030101*r**16
            +5591674*r**18)+Q2**8*(107580+5913859*r**2-4036131*r**4+178950750*r**6
            +801485394*r**8+297238956*r**10+1191701244*r**12+2488651314*r**14-2272787550*r**16
            -321456111*r**18-47004089*r**20)+Q2**7*(-100056-11288227*r**2-9993928*r**4
            -273757839*r**6-595963920*r**8+4491699882*r**10+16256563392*r**12+13540316202*r**14
            +6394062696*r**16+4980998985*r**18+576025160*r**20+46264757*r**22)+Q2**6*(
            -5091+2933305*r**2+11695871*r**4+139192525*r**6+835777836*r**8-1621498590*r**10
            -13948361850*r**12-31901420814*r**14-11909001555*r**16-8718131499*r**18
            -2024095637*r**20-183139855*r**22+947194*r**24)+Q2**5*(61521+3808522*r**2
            -28370844*r**4+117110832*r**6+109585057*r**8-756150402*r**10+3713849136*r**12
            +3331421552*r**14+29118644979*r**16-15091024218*r**18+5141891980*r**20
            -2633603904*r**22-260618949*r**24-28978382*r**26)+Q2**4*(-32370-2786053*r**2
            +30512375*r**4-140374992*r**6-670038658*r**8+759434435*r**10-8018552049*r**12
            +9880515640*r**14+14628460834*r**16-24932164959*r**18+30037804805*r**20
            -2070573928*r**22+3029598930*r**24+254165153*r**26+17179637*r**28)+Q2**3*(
            -4890+37963*r**2-3897802*r**4+15461665*r**6+231666598*r**8-660501613*r**10
            +6858453334*r**12-6795019951*r**14-2193154430*r**16-7795136551*r**18
            +7261628146*r**20-9057687397*r**22-993268622*r**24-509178935*r**26-36397822*r**28
            +1262707*r**30)+Q2**2*(11007+584377*r**2-13883931*r**4+34969887*r**6
            +34122375*r**8-433765335*r**10+1164825381*r**12+3569280167*r**14-14597705739*r**16
            +38052829155*r**18-55086960601*r**20+40972182837*r**22-16700674011*r**24
            +3328519227*r**26-772998705*r**28-53989371*r**30-5378720*r**32)-2*(
            -1+r**2)**2*(-279-13022*r**2+895669*r**4+340517*r**6+6227088*r**8+136133284*r**10
            -24477805*r**12-1619164573*r**14+9797800836*r**16-19765032126*r**18+16781801099*r**20
            -7146253189*r**22+1874103604*r**24-201243528*r**26+47101613*r**28+2756221*r**30
            +160591*r**32)+Q2*(-4203-219145*r**2+9256670*r**4-17880900*r**6+7876662*r**8
            +834616116*r**10-2690363250*r**12+5997073876*r**14-12254053880*r**16
            +51938805666*r**18-117247904438*r**20+115192751140*r**22-57301510662*r**24
            +16588218180*r**26-2431338678*r**28+471636300*r**30+29871155*r**32+2257391*r**34))*sqrtq2))/(15676416000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+1088640000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+3780000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-90720000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            -63000*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
            -6531840000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC*(13934592000*logq2**5*(
            -Q2+(-1+r)**2)*r**20*(9-10*r**2+3*r**4)*(-Q2+(1+r)**2)-1105920*logq2**3*(
            -Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)*(-13800*Q2**11*r**2+2*Q2**10*(1183
            +50106*r**2+63360*r**4)-10*Q2**9*(1862+30037*r**2+75730*r**4+47775*r**6)
            +5*Q2**8*(10836+96829*r**2+341865*r**4+457575*r**6+178965*r**8)-5*Q2**7*(14175
            +91596*r**2+349567*r**4+710459*r**6+666090*r**8+133425*r**10)+5*Q2**6*(5166
            +71750*r**2+136503*r**4+302646*r**6+475234*r**8+381276*r**10-94815*r**12)
            +Q2**5*(39753-427924*r**2-192780*r**4+684375*r**6+2480045*r**8+1957878*r**10
            +792246*r**12+1382535*r**14)-5*Q2**4*(9786-82854*r**2-86027*r**4-15030*r**6
            +508353*r**8+1152958*r**10+695411*r**12+368550*r**14+190125*r**16)-5*Q2**3*(
            -1659+22414*r**2+18399*r**4+223919*r**6-104783*r**8-380981*r**10-767571*r**12
            -8635*r**14-270690*r**16+20115*r**18)+(-1+r**2)**2*(3206-17901*r**2
            -146458*r**4+1170320*r**6-1694762*r**8+463394*r**10-610154*r**12+36128*r**14
            +529700*r**16-35093*r**18+49620*r**20)+5*Q2**2*(3780-25424*r**2-85653*r**4
            +329592*r**6-297428*r**8-97656*r**10-49734*r**12-285416*r**14+602424*r**16
            -177960*r**18+100275*r**20)-5*Q2*(2821-21240*r**2-75386*r**4+493297*r**6
            -795330*r**8+116332*r**10+97264*r**12-119610*r**14-335243*r**16+484164*r**18
            -102894*r**20+54225*r**22))-768*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-4656*Q2**17*r**2+12*Q2**16*(-805+7546*r**2+4520*r**4)-4*Q2**15*(
            -20300+125745*r**2+251866*r**4+64161*r**6)+Q2**14*(-275065+1370912*r**2
            +4915363*r**4+4199138*r**6+601950*r**8)-2*Q2**13*(-214970+1260163*r**2
            +4511450*r**4+3212968*r**6+3509566*r**8+276675*r**10)-Q2**12*(121555
            -4616214*r**2-3023244*r**4+70427968*r**6+64771265*r**8+2686282*r**10
            +584052*r**12)+4*Q2**11*(-160055-2115147*r**2+2393678*r**4+77520954*r**6
            +151402081*r**8+73309069*r**10+7399168*r**12+520380*r**14)-Q2**10*(-955955
            -10703980*r**2+11335747*r**4+511505094*r**6+1522681473*r**8+1609029128*r**10
            +460965593*r**12+42222190*r**14+1745238*r**16)+2*Q2**9*(-113960-3256097*r**2
            +7273912*r**4+200456682*r**6+642716370*r**8+1019230350*r**10+784038848*r**12
            +28314782*r**14+1917262*r**16-406725*r**18)+Q2**8*(-671055-828018*r**2
            -35072310*r**4-215322668*r**6+308248824*r**8+2203025540*r**10+1859786862*r**12
            +765039060*r**14+785865087*r**16+52984614*r**18+2640000*r**20)-4*Q2**7*(
            -159390-939705*r**2-9439218*r**4-53682899*r**6+214629860*r**8+1513266814*r**10
            +2933086536*r**12+1765694942*r**14+765085506*r**16+243568995*r**18+13529634*r**20
            +383757*r**22)+Q2**6*(14245-2601000*r**2-10313459*r**4-123020682*r**6
            +115313612*r**8+3546757368*r**10+10923209002*r**12+15423453156*r**14
            +3846091133*r**16+2325452512*r**18+95933193*r**20+318550*r**22-678510*r**24)
            +2*Q2**5*(-163030+873155*r**2-449162*r**4-59157020*r**6+63575378*r**8
            -822995267*r**10+9161508*r**12-2453250528*r**14-3537729018*r**16+2869320653*r**18
            -9100762*r**20+354852508*r**22+17493086*r**24+659379*r**26)-Q2**4*(-161735
            +1050718*r**2+8348312*r**4-170558248*r**6+8830865*r**8-2785712110*r**10
            +1203553164*r**12+6784711776*r**14+1117779451*r**16+1067976450*r**18
            +7966875960*r**20+933866408*r**22+558750427*r**24+22439662*r**26+514500*r**28)
            -4*Q2**3*(-6685+84789*r**2-978690*r**4+8974724*r**6+1719973*r**8+355459575*r**10
            -21401448*r**12+103434950*r**14-2194764243*r**16+1284336819*r**18-1364735290*r**20
            -272891816*r**22-164138485*r**24-4518431*r**26+174308*r**28+40350*r**30)
            +(-1+r**2)**2*(-2345+90000*r**2+1706955*r**4-3249462*r**6+64464163*r**8
            +87165780*r**10-901095201*r**12+5288150230*r**14-7931083571*r**16+1246630344*r**18
            +3028509985*r**20-1648009898*r**22+577234465*r**24-8347692*r**26+15923893*r**28
            +462730*r**30+9624*r**32)+Q2**2*(-52255+957372*r**2+7167859*r**4-42997778*r**6
            +174602455*r**8-492810992*r**10-412533913*r**12+455422842*r**14+2160167061*r**16
            -10848483700*r**18+15873197529*r**20-10198915870*r**22+3796670349*r**24
            -354338008*r**26+177399245*r**28+6731318*r**30+216486*r**32)-2*Q2*(
            -9380+259607*r**2+3240484*r**4-15128458*r**6+110463318*r**8-201897928*r**10
            -102586012*r**12+2276253942*r**14-2145554354*r**16-169137186*r**18-5484409684*r**20
            +8541201618*r**22-4505777326*r**24+1369522912*r**26-86388532*r**28+45531842*r**30
            +1497262*r**32+37875*r**34))+66355200*logq2**4*r**16*(360*Q2**8*r**2-10*Q2**7*(7
            +162*r**2+288*r**4)+Q2**6*(70+2800*r**2+9864*r**4+9702*r**6)-Q2**5*(
            -315+455*r**2+12039*r**4+24261*r**6+16947*r**8)+Q2**4*(-490-3290*r**2
            +2465*r**4+19687*r**6+29226*r**8+13860*r**10)+Q2**3*(-1085+6125*r**2
            -55*r**4-3508*r**6-11572*r**8-16449*r**10+630*r**12)+Q2**2*(3465-8995*r**2
            +9360*r**4-1943*r**6+4612*r**8-1530*r**10+6441*r**12-10710*r**14)-(
            -1+r**2)**2*(-1015+3700*r**2-9019*r**4+6654*r**6-3671*r**8-696*r**10
            +39*r**12+1908*r**14)+Q2*(-3220+10805*r**2-26354*r**4+6770*r**6+8093*r**8
            -7377*r**10+1968*r**12-6978*r**14+7893*r**16))*sqrtq2-18432*logq2**2*r**8*(
            -48696*Q2**16*r**2+Q2**15*(-8750+619356*r**2+602496*r**4)-2*Q2**14*(-45955
            +1637980*r**2+3353044*r**4+1597185*r**6)+Q2**13*(-393085+9544235*r**2
            +29680992*r**4+30279507*r**6+9227085*r**8)-2*Q2**12*(-430185+8601300*r**2
            +33690399*r**4+49321377*r**6+35555819*r**8+7275660*r**10)+Q2**11*(-904925
            +20888253*r**2+80487362*r**4+108916432*r**6+110165837*r**8+80182727*r**10
            +7667478*r**12)+Q2**10*(23905-19147608*r**2-36842691*r**4+105370860*r**6
            +292293505*r**8+170417230*r**10+5213229*r**12+15325002*r**14)-Q2**9*(
            -1096130-14793420*r**2+24541599*r**4+420289120*r**6+1168638925*r**8
            +1396571620*r**10+676232765*r**12+139301024*r**14+34318185*r**16)+Q2**8*(
            -1310505-8515320*r**2+44594566*r**4+491699956*r**6+1488182760*r**8+2431219720*r**10
            +2176788310*r**12+755763936*r**14+172325661*r**16+24098580*r**18)+2*Q2**7*(385980
            +660975*r**2-13783702*r**4-177281646*r**6-420480552*r**8-707588780*r**10
            -896325280*r**12-690316642*r**14-10866696*r**16-29567187*r**18+3731970*r**20)
            -2*Q2**6*(194600-1118316*r**2-4980263*r**4-150811833*r**6-134778178*r**8
            +34462052*r**10+288135656*r**12+186283262*r**14+53070742*r**16+397557572*r**18
            +31532427*r**20+13002759*r**22)+Q2**5*(211015-1190677*r**2-4257006*r**4
            -283011785*r**6-121726915*r**8+129496190*r**10+1071798188*r**12+1699419558*r**14
            +1124927665*r**16+630736535*r**18+778254050*r**20+80103299*r**22+17510283*r**24)
            +(-1+r**2)**4*(14455+66124*r**2+405092*r**4+2904544*r**6-21889925*r**8
            +163937640*r**10-217667748*r**12+4343716*r**14-17519463*r**16+81215600*r**18
            -24685920*r**20+13048924*r**22+572117*r**24+134844*r**26)-2*Q2**4*(-53480
            +143980*r**2-2733281*r**4-71210145*r**6+32240950*r**8-78792240*r**10
            +169118570*r**12+313156762*r**14+443317660*r**16-40129300*r**18+266623295*r**20
            +73466175*r**22+16499694*r**24+356160*r**26)+Q2**3*(-348285+252585*r**2
            -6848558*r**4-4729788*r**6+170699355*r**8-463203255*r**10+580112610*r**12
            +197835936*r**14-69405119*r**16+581246235*r**18-1407937210*r**20+696723580*r**22
            -269425503*r**24+1106707*r**26-6079290*r**28)-Q2*(-1+r**2)**2*(101500
            +264314*r**2+2099891*r**4+2722766*r**6-78130466*r**8+561515200*r**10
            -453769023*r**12-425833772*r**14+26678008*r**16-194483998*r**18+546273725*r**20
            -202328866*r**22+89573806*r**24+3186276*r**26+1170639*r**28)+Q2**2*(279545
            +65400*r**2+4797077*r**4-18715404*r**6-123352933*r**8+842656050*r**10
            -1032108585*r**12+153752766*r**14-385405217*r**16+485386996*r**18-1402620525*r**20
            +1721530760*r**22-735422643*r**24+239886946*r**26+3299137*r**28+4050630*r**30))*sqrtq2
            +128*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(Q2**17*(-1542+3767*r**2)
            +Q2**16*(17778-34295*r**2-202649*r**4)+Q2**15*(-90588-48157*r**2+2703580*r**4
            +1795979*r**6)+Q2**14*(265755+884987*r**2-11670975*r**4-21685077*r**6
            -6684838*r**8)+Q2**13*(-487065-2036822*r**2+24842008*r**4+70452960*r**6
            +64811533*r**8+10930882*r**10)+Q2**12*(558966-968167*r**2-33973991*r**4
            -55260148*r**6-17601730*r**8-52942397*r**10+124571*r**12)-Q2**11*(369234
            -11276885*r**2-43439958*r**4+117227325*r**6+866976798*r**8+771141141*r**10
            +147201030*r**12+30009811*r**14)+Q2**10*(108009-19197293*r**2-53738693*r**4
            +252514953*r**6+2341893339*r**8+4291308117*r**10+2157827685*r**12+394790047*r**14
            +43404460*r**16)-Q2**9*(36135-11109566*r**2-39161350*r**4+187190956*r**6
            +2257069404*r**8+6141189660*r**10+7119901134*r**12+1613906380*r**14+240030101*r**16
            +5591674*r**18)+Q2**8*(107580+5913859*r**2-4036131*r**4+178950750*r**6
            +801485394*r**8+297238956*r**10+1191701244*r**12+2488651314*r**14-2272787550*r**16
            -321456111*r**18-47004089*r**20)+Q2**7*(-100056-11288227*r**2-9993928*r**4
            -273757839*r**6-595963920*r**8+4491699882*r**10+16256563392*r**12+13540316202*r**14
            +6394062696*r**16+4980998985*r**18+576025160*r**20+46264757*r**22)+Q2**6*(
            -5091+2933305*r**2+11695871*r**4+139192525*r**6+835777836*r**8-1621498590*r**10
            -13948361850*r**12-31901420814*r**14-11909001555*r**16-8718131499*r**18
            -2024095637*r**20-183139855*r**22+947194*r**24)+Q2**5*(61521+3808522*r**2
            -28370844*r**4+117110832*r**6+109585057*r**8-756150402*r**10+3713849136*r**12
            +3331421552*r**14+29118644979*r**16-15091024218*r**18+5141891980*r**20
            -2633603904*r**22-260618949*r**24-28978382*r**26)+Q2**4*(-32370-2786053*r**2
            +30512375*r**4-140374992*r**6-670038658*r**8+759434435*r**10-8018552049*r**12
            +9880515640*r**14+14628460834*r**16-24932164959*r**18+30037804805*r**20
            -2070573928*r**22+3029598930*r**24+254165153*r**26+17179637*r**28)+Q2**3*(
            -4890+37963*r**2-3897802*r**4+15461665*r**6+231666598*r**8-660501613*r**10
            +6858453334*r**12-6795019951*r**14-2193154430*r**16-7795136551*r**18
            +7261628146*r**20-9057687397*r**22-993268622*r**24-509178935*r**26-36397822*r**28
            +1262707*r**30)+Q2**2*(11007+584377*r**2-13883931*r**4+34969887*r**6
            +34122375*r**8-433765335*r**10+1164825381*r**12+3569280167*r**14-14597705739*r**16
            +38052829155*r**18-55086960601*r**20+40972182837*r**22-16700674011*r**24
            +3328519227*r**26-772998705*r**28-53989371*r**30-5378720*r**32)-2*(
            -1+r**2)**2*(-279-13022*r**2+895669*r**4+340517*r**6+6227088*r**8+136133284*r**10
            -24477805*r**12-1619164573*r**14+9797800836*r**16-19765032126*r**18+16781801099*r**20
            -7146253189*r**22+1874103604*r**24-201243528*r**26+47101613*r**28+2756221*r**30
            +160591*r**32)+Q2*(-4203-219145*r**2+9256670*r**4-17880900*r**6+7876662*r**8
            +834616116*r**10-2690363250*r**12+5997073876*r**14-12254053880*r**16
            +51938805666*r**18-117247904438*r**20+115192751140*r**22-57301510662*r**24
            +16588218180*r**26-2431338678*r**28+471636300*r**30+29871155*r**32+2257391*r**34))*sqrtq2))/(23514624000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+1632960000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+5670000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-136080000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            -94500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
            -9797760000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((10450944000*logq2**5*(
            -Q2+(-1+r)**2)*r**20*(-1+r**4+2*r**6)*(-Q2+(1+r)**2)+276480*logq2**3*(
            -Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)*(12240*Q2**11*r**2-2*Q2**10*(805
            +53106*r**2+45816*r**4)+10*Q2**9*(1015+39116*r**2+64725*r**4+27132*r**6)
            -5*Q2**8*(4620+150673*r**2+364785*r**4+298335*r**6+77877*r**8)+5*Q2**7*(3570
            +143209*r**2+480963*r**4+586151*r**6+308835*r**8+55800*r**10)-5*Q2**6*(
            -2520+22750*r**2+177459*r**4+380766*r**6+352988*r**8+139020*r**10+40257*r**12)
            +Q2**5*(-30030-407771*r**2-1498101*r**4-1336650*r**6-303620*r**8+778485*r**10
            +466599*r**12+375984*r**14)-5*Q2**4*(-2520-74608*r**2-394287*r**4-513900*r**6
            -387451*r**8+134208*r**10+299623*r**12+180180*r**14+70299*r**16)-5*Q2**3*(
            -1470+28837*r**2+81273*r**4+304061*r**6+153637*r**8-187209*r**10-459837*r**12
            -4249*r**14-165315*r**16+20448*r**18)+(-1+r**2)**2*(140+9813*r**2-202046*r**4
            +926700*r**6-769394*r**8+310202*r**10-49598*r**12-371164*r**14+840390*r**16
            +4209*r**18+56748*r**20)+5*Q2**2*(-1470+12026*r**2-181791*r**4+424860*r**6
            -318268*r**8-74112*r**10-111870*r**12-397228*r**14+616338*r**16-99210*r**18
            +80325*r**20)-5*Q2*(-280+7373*r**2-162861*r**4+598484*r**6-681340*r**8
            +216198*r**10+315794*r**12+314324*r**14-592836*r**16+600693*r**18-62925*r**20
            +52176*r**22))-192*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -9312*Q2**17*r**2+4*Q2**16*(-805+31950*r**2+31368*r**4)-4*Q2**15*(-6685
            +161502*r**2+404131*r**4+169116*r**6)+Q2**14*(-86205+1568566*r**2+7173691*r**4
            +7409140*r**6+1895670*r**8)-2*Q2**13*(-55335+877182*r**2+6391588*r**4
            +7546174*r**6+7529917*r**8+1386990*r**10)+Q2**12*(55545+325312*r**2
            +892928*r**4-68024936*r**6-55484733*r**8+7582332*r**10+1205856*r**12)
            +4*Q2**11*(-88830+138939*r**2+7316008*r**4+90026929*r**6+162887050*r**8
            +76015549*r**10+6217412*r**12+641391*r**14)-Q2**10*(-367675-1123030*r**2
            +36823099*r**4+594075420*r**6+1792409349*r**8+1705822874*r**10+526212217*r**12
            +49659184*r**14+4273698*r**16)+2*Q2**9*(51205-825816*r**2+4872884*r**4
            +96431950*r**6+833807240*r**8+1312272220*r**10+895413124*r**12+152528314*r**14
            +14089355*r**16+642180*r**18)+Q2**8*(-523215-2287872*r**2-5690958*r**4
            +626144376*r**6+913254048*r**8+1261991140*r**10+202088558*r**12-313915968*r**14
            +199085991*r**16+14213508*r**18+2551560*r**20)-4*Q2**7*(-88165-1312728*r**2
            -7969281*r**4+197575162*r**6+740554886*r**8+1732027876*r**10+2057652454*r**12
            +790695704*r**14+170255247*r**16+87188276*r**18+6605931*r**20+630894*r**22)
            +Q2**6*(117425-1964862*r**2-15376235*r**4+107758348*r**6+1798025460*r**8
            +5044647308*r**10+10384226762*r**12+8058157568*r**14+1879903593*r**16
            +424735010*r**18+152762433*r**20+12860644*r**22-69294*r**24)+2*Q2**5*(
            -143535-1355918*r**2-18809060*r**4+209996206*r**6+78374599*r**8+662949094*r**10
            -177607368*r**12-2139634132*r**14-1113700217*r**16-581191826*r**18-260611316*r**20
            -44953946*r**22-2255135*r**24+650394*r**26)+Q2**4*(123795+2844816*r**2
            +44458316*r**4-296284040*r**6-471841525*r**8-2272449820*r**10-6261334512*r**12
            -1755882032*r**14+1136786505*r**16+924153720*r**18+2563155940*r**20+818410136*r**22
            +118116281*r**24+2390900*r**26-629280*r**28)-4*Q2**3*(-7980+107941*r**2
            +1499054*r**4+2511507*r**6-55651184*r**8-21011415*r**10-810178302*r**12
            +57571407*r**14+221197076*r**16+46474703*r**18+579675250*r**20+243457961*r**22
            +84712264*r**24+3269667*r**26-455394*r**28+30645*r**30)+(-1+r**2)**2*(
            -2345-65626*r**2-1854889*r**4+5984320*r**6-47439045*r**8-275719454*r**10
            +1938692851*r**12-6012321852*r**14+4658322525*r**16+2971961450*r**18
            -4803909227*r**20+1599597976*r**22-516519559*r**24-47590770*r**26-13103455*r**28
            -362524*r**30+9624*r**32)+Q2**2*(-49455-643662*r**2-15312277*r**4+103829084*r**6
            -285839973*r**8-52386658*r**10+2229257831*r**12-3134616736*r**14+1959850417*r**16
            +6026543886*r**18-9059347279*r**20+5204165324*r**22-1817549687*r**24
            -163304926*r**26-83714563*r**28-3897608*r**30+216282*r**32)+2*Q2*(8995
            +183028*r**2+4702628*r**4-26616782*r**6+116212870*r**8+241815308*r**10
            -2486307572*r**12+6566587018*r**14-5601093876*r**16+4012394060*r**18
            -7740793636*r**20+8223996790*r**22-3180020950*r**24+857273108*r**26+69788020*r**28
            +29502158*r**30+1047329*r**32-38496*r**34))+16588800*logq2**4*r**16*(240*Q2**8*r**2
            -30*Q2**7*(7+50*r**2+36*r**4)+6*Q2**6*(266+735*r**2+837*r**4+140*r**6)
            +Q2**5*(-4431-8071*r**2-9867*r**4-2727*r**6+3255*r**8)+Q2**4*(5145
            +8463*r**2+10265*r**4+3621*r**6-7935*r**8-5985*r**10)-Q2**3*(840+6167*r**2
            +3532*r**4+304*r**6-7221*r**8-10755*r**10+1995*r**12)+(-1+r**2)**2*(
            -819+3026*r**2-3897*r**4-222*r**6+6253*r**8-138*r**10-1083*r**12+3180*r**14)
            +Q2**2*(-3570+9163*r**2-7256*r**4-1146*r**6+823*r**8-1104*r**10-7515*r**12
            +12705*r**14)+Q2*(3129-11202*r**2+16166*r**4+1809*r**6-13731*r**8
            -16370*r**10-5184*r**12+11343*r**14-11160*r**16))*sqrtq2+4608*logq2**2*r**8*(57168*Q2**16*r**2
            -2*Q2**15*(-5845+367914*r**2+345684*r**4)+2*Q2**14*(-60410+1977755*r**2
            +3847837*r**4+1805820*r**6)-Q2**13*(-518455+11477745*r**2+34954556*r**4
            +33573901*r**6+10536375*r**8)+Q2**12*(-1127245+18705305*r**2+81383504*r**4
            +115278232*r**6+77963459*r**8+18219765*r**10)-Q2**11*(-1014580+13797569*r**2
            +91024971*r**4+147290736*r**6+158596776*r**8+99085571*r**10+17166369*r**12)
            +Q2**10*(795410-6200271*r**2+558208*r**4-111856145*r**6-149321880*r**8
            +4964085*r**10+55689058*r**12+3326439*r**14)+Q2**9*(-3084235+22994780*r**2
            +131965177*r**4+604029700*r**6+1079140925*r**8+848095140*r**10+253919035*r**12
            +13668052*r**14+11837370*r**16)-Q2**8*(-2890965+17705610*r**2+160097138*r**4
            +762087708*r**6+1647095240*r**8+1876140160*r**10+1144132650*r**12+322631448*r**14
            +40802073*r**16+14798250*r**18)+2*Q2**7*(91245-993555*r**2+31303271*r**4
            +158436418*r**6+400757286*r**8+628835220*r**10+646730610*r**12+378414966*r**14
            +125102193*r**16+19586391*r**18+4069035*r**20)-2*Q2**6*(1350580-6684492*r**2
            -14780171*r**4-90271141*r**6-248522356*r**8-243999466*r**10+403562*r**12
            +272798404*r**14+244216284*r**16+141574594*r**18+24874029*r**20+1273533*r**22)
            +Q2**5*(2217985-9060649*r**2-41186662*r**4-249628665*r**6-756356125*r**8
            -947143370*r**10-614776364*r**12+124696566*r**14+472413935*r**16+492953875*r**18
            +271044530*r**20+47995843*r**22+401901*r**24)+(-1+r**2)**4*(19915-39592*r**2
            +357464*r**4+6433228*r**6-38999325*r**8+134836920*r**10-60268716*r**12
            -61967028*r**14-45600531*r**16+115400300*r**18-20550860*r**20+14446408*r**22
            +1214789*r**24+77028*r**26)+Q2**4*(-286195-21915*r**2+19524024*r**4
            +110953260*r**6+200345175*r**8+409387415*r**10-70845440*r**12-314499048*r**14
            -472823125*r**16+121791875*r**18-394822920*r**20-25896820*r**22-12836351*r**24
            +1226865*r**26)+Q2**3*(-696920+3897355*r**2-10185931*r**4-58507916*r**6
            +299251940*r**8-595755285*r**10+456783225*r**12+316067952*r**14+80680992*r**16
            +491937185*r**18-1168768945*r**20+404633020*r**22-199420396*r**24-17716151*r**26
            -2200125*r**28)-Q2*(-1+r**2)**2*(164045-570452*r**2+2279922*r**4+31431742*r**6
            -204063877*r**8+587490210*r**10-180960636*r**12-133773324*r**14-82820229*r**16
            -242011256*r**18+635536970*r**20-142928562*r**22+84802877*r**24+7745962*r**26
            +556608*r**28)+Q2**2*(529130-2771695*r**2+7796704*r**4+53272407*r**6
            -435592656*r**8+1190874175*r**10-952364130*r**12+292056957*r**14+118660386*r**16
            +508424047*r**18-1312177820*r**20+1534052225*r**22-481728636*r**24+185089857*r**26
            +18039134*r**28+1599915*r**30))*sqrtq2+32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(176*Q2**18+Q2**17*(2535+1676*r**2)-Q2**16*(32913+364661*r**2
            +31652*r**4)+Q2**15*(68917+3787700*r**2+3771553*r**4+177696*r**6)-Q2**14*(
            -186186+14930971*r**2+33942285*r**4+15925827*r**6+525835*r**8)+Q2**13*(
            -732732+26050717*r**2+105692368*r**4+111027624*r**6+32799280*r**8+907327*r**10)
            -Q2**12*(324509+9485791*r**2+95086832*r**4+107830116*r**6+132834703*r**8
            +25415813*r**10+849708*r**12)+Q2**11*(4735695-35935918*r**2-174035451*r**4
            -860194842*r**6-730239207*r**8-78154746*r**10-25696893*r**12+186626*r**14)
            +Q2**10*(-7878420+51117673*r**2+455427703*r**4+2689270611*r**6+4581253617*r**8
            +2298868719*r**10+369632889*r**12+71295877*r**14+445027*r**16)-Q2**9*(
            -2284128+6347953*r**2+273545720*r**4+2278224806*r**6+7588991340*r**8
            +7470882852*r**10+2238303088*r**12+320261170*r**14+42657116*r**16+366355*r**18)
            +Q2**8*(7905711-29243549*r**2-120166776*r**4-1776146298*r**6+1548013800*r**8
            +4035751620*r**10+3769240026*r**12-219460086*r**14+2011977*r**16-29382855*r**18
            -121682*r**20)+Q2**7*(-9312237+5292944*r**2+126690299*r**4+4437162732*r**6
            +7584211446*r**8+12328513824*r**10+7299356238*r**12+1118301864*r**14
            +1733839047*r**16+122705136*r**18+50863751*r**20+262988*r**22)-Q2**6*(
            -631274-24250639*r**2-17896433*r**4+1874113581*r**6+6883024941*r**8
            +15156693138*r**10+20234085838*r**12+7332891090*r**14+985613736*r**16
            +858975661*r**18+78073619*r**20+12183601*r**22+6021*r**24)+Q2**5*(5624664
            -13151621*r**2+112252680*r**4-1821627060*r**6+1866941356*r**8-2250779013*r**10
            +7611706416*r**12+8755730960*r**14+1615778544*r**16+1282968081*r**18
            +175004776*r**20+126163332*r**22-18061908*r**24-163367*r**26)+Q2**4*(
            -3753939-7632901*r**2-209951320*r**4+2113533408*r**6-1413307675*r**8
            +10066028003*r**10+6957706272*r**12-699243080*r**14-1370609321*r**16
            -3452772735*r**18-2930899984*r**20-412158616*r**22-139818345*r**24+12844193*r**26
            +90440*r**28)+Q2**3*(-105655+8863882*r**2+44640383*r**4-316660626*r**6
            +585467545*r**8-2566777246*r**10-5087246889*r**12+3816175574*r**14-720240173*r**16
            +2043625630*r**18+2367671797*r**20+1524887882*r**22+224304843*r**24+13040374*r**26
            +118325*r**28+13554*r**30)+Q2**2*(1128336-2016029*r**2+92595333*r**4
            -654708291*r**6+2153606607*r**8-3252444525*r**10+1274435037*r**12-2290651051*r**14
            -7064801553*r**16+16654038801*r**18-12936995113*r**20+3971069823*r**22
            +275119893*r**24+186126969*r**26+72474567*r**28-3043473*r**30-31331*r**32)
            -2*(-1+r**2)**2*(-36857-161613*r**2-6810851*r**4+35146072*r**6-233476106*r**8
            -16624739*r**10+3287333199*r**12-13455588938*r**14+20748902706*r**16
            -14279266723*r**18+4617951579*r**20-955820164*r**22-34667986*r**24-29099053*r**26
            -4448071*r**28+74742*r**30+803*r**32)+Q2*(-500931-431635*r**2-65255680*r**4
            +451471698*r**6-2224528152*r**8+3042024930*r**10+6513831000*r**12-23634794558*r**14
            -2182533326*r**16+57386238084*r**18-60936658352*r**20+24714711430*r**22
            -5251155984*r**24-197165922*r**26-182264232*r**28-46919322*r**30+1182905*r**32
            +12047*r**34))*sqrtq2)*math.log(mu0))/(5225472000*logq2**5*r**22*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))+362880000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+1260000*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-30240000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-21000*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2-2177280000*logq2**4*r**18*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+FLAGcf*((117936000*logq2**4*r**14*(3-5*r**2+3*r**4+3*r**6)
            +4680*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(-1561+9259*r**2
            -4320*Q2**9*r**2+17902*r**4-417650*r**6+974908*r**8-198572*r**10+237346*r**12
            -321422*r**14+301405*r**16-10303*r**18+13488*r**20+56*Q2**8*(-1+561*r**2
            +558*r**4)-8*Q2**7*(-231+10905*r**2+23479*r**4+10443*r**6)+Q2**6*(-5173
            +95073*r**2+395461*r**4+410123*r**6+81564*r**8)+2*Q2**5*(833+2838*r**2
            -132894*r**4-264396*r**6-165291*r**8+20286*r**10)-Q2**4*(-8505+92765*r**2
            +183856*r**4+124504*r**6+99137*r**8+84875*r**10+145320*r**12)+2*Q2**3*(
            -4382+27037*r**2+165883*r**4+368170*r**6+507632*r**8+336617*r**10+152467*r**12
            +40656*r**14)+Q2**2*(-1043+19425*r**2-81059*r**4-460371*r**6-705957*r**8
            -1240669*r**10-142657*r**12-186753*r**14+33804*r**16)+Q2*(4578-30598*r**2
            -57842*r**4+265818*r**6-581026*r**8+372202*r**10+735618*r**12-512218*r**14
            +53872*r**16-48804*r**18))-13*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(279
            +51832*r**2+176*Q2**13*r**2-369279*r**4+4247926*r**6-14274463*r**8+27526342*r**10
            +129617771*r**12-553885372*r**14+660388553*r**16-367966084*r**18+98308279*r**20
            -19691578*r**22-449*r**24-240954*r**26-803*r**28+Q2**12*(-771+3063*r**2
            +750*r**4)-164*Q2**11*(-33+128*r**2+1019*r**4+62*r**6)+Q2**10*(-15111
            -9033*r**2+1230491*r**4+1032041*r**6+31932*r**8)-5*Q2**9*(-3879-36553*r**2
            +548994*r**4+1328318*r**6+448293*r**8+7979*r**10)+3*Q2**8*(-1965-51364*r**2
            +421575*r**4+3601030*r**6+3697755*r**8+297990*r**10+691*r**12)+2*Q2**7*(
            -6534-250623*r**2+1616565*r**4+1573020*r**6+4328420*r**8+225321*r**10
            +1865997*r**12+23610*r**14)-6*Q2**6*(-2121-155674*r**2+639433*r**4+3196174*r**6
            +14532525*r**8+12173384*r**10+3212001*r**12+870548*r**14+6754*r**16)
            +2*Q2**5*(1341-77562*r**2-628581*r**4+4567029*r**6+42074003*r**8+109470491*r**10
            +33108893*r**12+7934379*r**14+18744*r**16-3777*r**18)+5*Q2**4*(-1809
            -150223*r**2+876924*r**4+169908*r**6+7909498*r**8-20693230*r**10-36952648*r**12
            +12121444*r**14+636303*r**16+858453*r**18+5444*r**20)-2*Q2**3*(-1560
            -259383*r**2+945675*r**4-2691330*r**6+34366420*r**8+42739050*r**10+22169566*r**12
            -21456000*r**14+54405220*r**16+4550445*r**18+1210935*r**20+4962*r**22)
            +Q2**2*(1689+97333*r**2-1232405*r**4-268865*r**6-2372290*r**8+41581502*r**10
            +204873794*r**12-9518230*r**14+80995985*r**16+10862285*r**18+3461779*r**20
            -676457*r**22-4520*r**24)+Q2*(-1413-196377*r**2+1385164*r**4-8497688*r**6
            +31338675*r**8-29081629*r**10+114936104*r**12-332908368*r**14+324732521*r**16
            -173777275*r**18+47143692*r**20-249752*r**22+980329*r**24+4017*r**26))
            +280800*logq2**3*r**10*(301-1584*r**2-240*Q2**6*r**2+5717*r**4-6176*r**6
            +8279*r**8-72*r**10-1017*r**12+1272*r**14+20*Q2**5*(7+51*r**2+72*r**4)
            -4*Q2**4*(196+445*r**2+1206*r**4+837*r**6)+Q2**3*(1001+2581*r**2+5141*r**4
            +8403*r**6+3162*r**8)+Q2**2*(91-2396*r**2-1418*r**4-5364*r**6-6801*r**8
            +432*r**10)+Q2*(-749+2609*r**2-3480*r**4-158*r**6+3027*r**8+2589*r**10
            -2718*r**12))*sqrtq2+78*logq2*r**2*(-175*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(8
            +581*r**2+120*Q2**6*r**2+3050*r**4+5739*r**6+17844*r**8+12711*r**10
            +978*r**12-351*r**14-20*Q2**5*(1+15*r**2+18*r**4)-2*Q2**4*(16+121*r**2
            +138*r**4+153*r**6)+Q2**3*(88+271*r**2-53*r**4-177*r**6+459*r**8)
            +Q2**2*(8+525*r**2+1434*r**4+2118*r**6+1530*r**8+489*r**10)+Q2*(-52
            +725*r**2+1053*r**4+930*r**6+2430*r**8+1725*r**10-51*r**12))+(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(-945+77289*r**2+16344*Q2**12*r**2-1068248*r**4
            -2287556*r**6+19762515*r**8+1063925*r**10+325341152*r**12+351047496*r**14
            +300436157*r**16+86127035*r**18-35764680*r**20+471484*r**22+1150177*r**24
            -51801*r**26-24*Q2**11*(280+1857*r**2+2697*r**4)-2*Q2**10*(-9240+56013*r**2
            +91034*r**4+37533*r**6)+5*Q2**9*(315+90324*r**2+206344*r**4+187534*r**6
            +97119*r**8)-15*Q2**8*(2695+9843*r**2-5640*r**4-127074*r**6-9315*r**8
            +15723*r**10)-6*Q2**7*(-2450+63908*r**2+329295*r**4+2057255*r**6+1851205*r**8
            +280595*r**10+130908*r**12)+6*Q2**6*(6090-42119*r**2-42954*r**4+3218410*r**6
            +7796650*r**8+2824075*r**10-56574*r**12+106526*r**14)+6*Q2**5*(-2485
            +70202*r**2-57689*r**4-2695313*r**6-13862440*r**8-15042650*r**10-2436943*r**12
            -13139*r**14+93057*r**16)-10*Q2**4*(1995-52698*r**2-36468*r**4+1087647*r**6
            -377658*r**8-4864267*r**10-2008608*r**12+1907937*r**14-177333*r**16
            +53037*r**18)-10*Q2**3*(-630+31188*r**2-231525*r**4-1908369*r**6-5477115*r**8
            -3551839*r**10+1392701*r**12-4061955*r**14-3776739*r**16-202185*r**18
            +24468*r**20)+6*Q2**2*(1050-50966*r**2+195820*r**4+2367055*r**6+5253880*r**8
            +13578290*r**10+18742992*r**12+25988540*r**14+3090630*r**16+343580*r**18
            -415780*r**20+36909*r**22)+Q2*(-945+64632*r**2-1076498*r**4+5130240*r**6
            +27091125*r**8+89598500*r**10+99449856*r**12+205945476*r**14+62581685*r**16
            +50756100*r**18-15255630*r**20-1199588*r**22+67047*r**24)))*sqrtq2)/(326592000*logq2**4*r**16
            +13608000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+15750*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4-108864000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2-756000*logq2*r**4*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((9072000*logq2**4*r**14*(3-5*r**2+3*r**4
            +3*r**6)+360*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(-1561+9259*r**2
            -4320*Q2**9*r**2+17902*r**4-417650*r**6+974908*r**8-198572*r**10+237346*r**12
            -321422*r**14+301405*r**16-10303*r**18+13488*r**20+56*Q2**8*(-1+561*r**2
            +558*r**4)-8*Q2**7*(-231+10905*r**2+23479*r**4+10443*r**6)+Q2**6*(-5173
            +95073*r**2+395461*r**4+410123*r**6+81564*r**8)+2*Q2**5*(833+2838*r**2
            -132894*r**4-264396*r**6-165291*r**8+20286*r**10)-Q2**4*(-8505+92765*r**2
            +183856*r**4+124504*r**6+99137*r**8+84875*r**10+145320*r**12)+2*Q2**3*(
            -4382+27037*r**2+165883*r**4+368170*r**6+507632*r**8+336617*r**10+152467*r**12
            +40656*r**14)+Q2**2*(-1043+19425*r**2-81059*r**4-460371*r**6-705957*r**8
            -1240669*r**10-142657*r**12-186753*r**14+33804*r**16)+Q2*(4578-30598*r**2
            -57842*r**4+265818*r**6-581026*r**8+372202*r**10+735618*r**12-512218*r**14
            +53872*r**16-48804*r**18))-(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(279
            +51832*r**2+176*Q2**13*r**2-369279*r**4+4247926*r**6-14274463*r**8+27526342*r**10
            +129617771*r**12-553885372*r**14+660388553*r**16-367966084*r**18+98308279*r**20
            -19691578*r**22-449*r**24-240954*r**26-803*r**28+Q2**12*(-771+3063*r**2
            +750*r**4)-164*Q2**11*(-33+128*r**2+1019*r**4+62*r**6)+Q2**10*(-15111
            -9033*r**2+1230491*r**4+1032041*r**6+31932*r**8)-5*Q2**9*(-3879-36553*r**2
            +548994*r**4+1328318*r**6+448293*r**8+7979*r**10)+3*Q2**8*(-1965-51364*r**2
            +421575*r**4+3601030*r**6+3697755*r**8+297990*r**10+691*r**12)+2*Q2**7*(
            -6534-250623*r**2+1616565*r**4+1573020*r**6+4328420*r**8+225321*r**10
            +1865997*r**12+23610*r**14)-6*Q2**6*(-2121-155674*r**2+639433*r**4+3196174*r**6
            +14532525*r**8+12173384*r**10+3212001*r**12+870548*r**14+6754*r**16)
            +2*Q2**5*(1341-77562*r**2-628581*r**4+4567029*r**6+42074003*r**8+109470491*r**10
            +33108893*r**12+7934379*r**14+18744*r**16-3777*r**18)+5*Q2**4*(-1809
            -150223*r**2+876924*r**4+169908*r**6+7909498*r**8-20693230*r**10-36952648*r**12
            +12121444*r**14+636303*r**16+858453*r**18+5444*r**20)-2*Q2**3*(-1560
            -259383*r**2+945675*r**4-2691330*r**6+34366420*r**8+42739050*r**10+22169566*r**12
            -21456000*r**14+54405220*r**16+4550445*r**18+1210935*r**20+4962*r**22)
            +Q2**2*(1689+97333*r**2-1232405*r**4-268865*r**6-2372290*r**8+41581502*r**10
            +204873794*r**12-9518230*r**14+80995985*r**16+10862285*r**18+3461779*r**20
            -676457*r**22-4520*r**24)+Q2*(-1413-196377*r**2+1385164*r**4-8497688*r**6
            +31338675*r**8-29081629*r**10+114936104*r**12-332908368*r**14+324732521*r**16
            -173777275*r**18+47143692*r**20-249752*r**22+980329*r**24+4017*r**26))
            +21600*logq2**3*r**10*(301-1584*r**2-240*Q2**6*r**2+5717*r**4-6176*r**6
            +8279*r**8-72*r**10-1017*r**12+1272*r**14+20*Q2**5*(7+51*r**2+72*r**4)
            -4*Q2**4*(196+445*r**2+1206*r**4+837*r**6)+Q2**3*(1001+2581*r**2+5141*r**4
            +8403*r**6+3162*r**8)+Q2**2*(91-2396*r**2-1418*r**4-5364*r**6-6801*r**8
            +432*r**10)+Q2*(-749+2609*r**2-3480*r**4-158*r**6+3027*r**8+2589*r**10
            -2718*r**12))*sqrtq2+6*logq2*r**2*(-175*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(8
            +581*r**2+120*Q2**6*r**2+3050*r**4+5739*r**6+17844*r**8+12711*r**10
            +978*r**12-351*r**14-20*Q2**5*(1+15*r**2+18*r**4)-2*Q2**4*(16+121*r**2
            +138*r**4+153*r**6)+Q2**3*(88+271*r**2-53*r**4-177*r**6+459*r**8)
            +Q2**2*(8+525*r**2+1434*r**4+2118*r**6+1530*r**8+489*r**10)+Q2*(-52
            +725*r**2+1053*r**4+930*r**6+2430*r**8+1725*r**10-51*r**12))+(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(-945+77289*r**2+16344*Q2**12*r**2-1068248*r**4
            -2287556*r**6+19762515*r**8+1063925*r**10+325341152*r**12+351047496*r**14
            +300436157*r**16+86127035*r**18-35764680*r**20+471484*r**22+1150177*r**24
            -51801*r**26-24*Q2**11*(280+1857*r**2+2697*r**4)-2*Q2**10*(-9240+56013*r**2
            +91034*r**4+37533*r**6)+5*Q2**9*(315+90324*r**2+206344*r**4+187534*r**6
            +97119*r**8)-15*Q2**8*(2695+9843*r**2-5640*r**4-127074*r**6-9315*r**8
            +15723*r**10)-6*Q2**7*(-2450+63908*r**2+329295*r**4+2057255*r**6+1851205*r**8
            +280595*r**10+130908*r**12)+6*Q2**6*(6090-42119*r**2-42954*r**4+3218410*r**6
            +7796650*r**8+2824075*r**10-56574*r**12+106526*r**14)+6*Q2**5*(-2485
            +70202*r**2-57689*r**4-2695313*r**6-13862440*r**8-15042650*r**10-2436943*r**12
            -13139*r**14+93057*r**16)-10*Q2**4*(1995-52698*r**2-36468*r**4+1087647*r**6
            -377658*r**8-4864267*r**10-2008608*r**12+1907937*r**14-177333*r**16
            +53037*r**18)-10*Q2**3*(-630+31188*r**2-231525*r**4-1908369*r**6-5477115*r**8
            -3551839*r**10+1392701*r**12-4061955*r**14-3776739*r**16-202185*r**18
            +24468*r**20)+6*Q2**2*(1050-50966*r**2+195820*r**4+2367055*r**6+5253880*r**8
            +13578290*r**10+18742992*r**12+25988540*r**14+3090630*r**16+343580*r**18
            -415780*r**20+36909*r**22)+Q2*(-945+64632*r**2-1076498*r**4+5130240*r**6
            +27091125*r**8+89598500*r**10+99449856*r**12+205945476*r**14+62581685*r**16
            +50756100*r**18-15255630*r**20-1199588*r**22+67047*r**24)))*sqrtq2)*math.log(mumuG))/(36288000*logq2**4*r**16
            +1512000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+1750*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-12096000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-84000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2))
            +((-10450944000*logq2**5*(-Q2+(-1+r)**2)*r**20*(-1+r**4+2*r**6)*(-Q2
            +(1+r)**2)-276480*logq2**3*(-Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)*(12240*Q2**11*r**2
            -2*Q2**10*(805+53106*r**2+45816*r**4)+10*Q2**9*(1015+39116*r**2+64725*r**4
            +27132*r**6)-5*Q2**8*(4620+150673*r**2+364785*r**4+298335*r**6+77877*r**8)
            +5*Q2**7*(3570+143209*r**2+480963*r**4+586151*r**6+308835*r**8+55800*r**10)
            -5*Q2**6*(-2520+22750*r**2+177459*r**4+380766*r**6+352988*r**8+139020*r**10
            +40257*r**12)+Q2**5*(-30030-407771*r**2-1498101*r**4-1336650*r**6-303620*r**8
            +778485*r**10+466599*r**12+375984*r**14)-5*Q2**4*(-2520-74608*r**2-394287*r**4
            -513900*r**6-387451*r**8+134208*r**10+299623*r**12+180180*r**14+70299*r**16)
            -5*Q2**3*(-1470+28837*r**2+81273*r**4+304061*r**6+153637*r**8-187209*r**10
            -459837*r**12-4249*r**14-165315*r**16+20448*r**18)+(-1+r**2)**2*(140
            +9813*r**2-202046*r**4+926700*r**6-769394*r**8+310202*r**10-49598*r**12
            -371164*r**14+840390*r**16+4209*r**18+56748*r**20)+5*Q2**2*(-1470+12026*r**2
            -181791*r**4+424860*r**6-318268*r**8-74112*r**10-111870*r**12-397228*r**14
            +616338*r**16-99210*r**18+80325*r**20)-5*Q2*(-280+7373*r**2-162861*r**4
            +598484*r**6-681340*r**8+216198*r**10+315794*r**12+314324*r**14-592836*r**16
            +600693*r**18-62925*r**20+52176*r**22))+192*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(-9312*Q2**17*r**2+4*Q2**16*(-805+31950*r**2+31368*r**4)
            -4*Q2**15*(-6685+161502*r**2+404131*r**4+169116*r**6)+Q2**14*(-86205
            +1568566*r**2+7173691*r**4+7409140*r**6+1895670*r**8)-2*Q2**13*(-55335
            +877182*r**2+6391588*r**4+7546174*r**6+7529917*r**8+1386990*r**10)+Q2**12*(55545
            +325312*r**2+892928*r**4-68024936*r**6-55484733*r**8+7582332*r**10+1205856*r**12)
            +4*Q2**11*(-88830+138939*r**2+7316008*r**4+90026929*r**6+162887050*r**8
            +76015549*r**10+6217412*r**12+641391*r**14)-Q2**10*(-367675-1123030*r**2
            +36823099*r**4+594075420*r**6+1792409349*r**8+1705822874*r**10+526212217*r**12
            +49659184*r**14+4273698*r**16)+2*Q2**9*(51205-825816*r**2+4872884*r**4
            +96431950*r**6+833807240*r**8+1312272220*r**10+895413124*r**12+152528314*r**14
            +14089355*r**16+642180*r**18)+Q2**8*(-523215-2287872*r**2-5690958*r**4
            +626144376*r**6+913254048*r**8+1261991140*r**10+202088558*r**12-313915968*r**14
            +199085991*r**16+14213508*r**18+2551560*r**20)-4*Q2**7*(-88165-1312728*r**2
            -7969281*r**4+197575162*r**6+740554886*r**8+1732027876*r**10+2057652454*r**12
            +790695704*r**14+170255247*r**16+87188276*r**18+6605931*r**20+630894*r**22)
            +Q2**6*(117425-1964862*r**2-15376235*r**4+107758348*r**6+1798025460*r**8
            +5044647308*r**10+10384226762*r**12+8058157568*r**14+1879903593*r**16
            +424735010*r**18+152762433*r**20+12860644*r**22-69294*r**24)+2*Q2**5*(
            -143535-1355918*r**2-18809060*r**4+209996206*r**6+78374599*r**8+662949094*r**10
            -177607368*r**12-2139634132*r**14-1113700217*r**16-581191826*r**18-260611316*r**20
            -44953946*r**22-2255135*r**24+650394*r**26)+Q2**4*(123795+2844816*r**2
            +44458316*r**4-296284040*r**6-471841525*r**8-2272449820*r**10-6261334512*r**12
            -1755882032*r**14+1136786505*r**16+924153720*r**18+2563155940*r**20+818410136*r**22
            +118116281*r**24+2390900*r**26-629280*r**28)-4*Q2**3*(-7980+107941*r**2
            +1499054*r**4+2511507*r**6-55651184*r**8-21011415*r**10-810178302*r**12
            +57571407*r**14+221197076*r**16+46474703*r**18+579675250*r**20+243457961*r**22
            +84712264*r**24+3269667*r**26-455394*r**28+30645*r**30)+(-1+r**2)**2*(
            -2345-65626*r**2-1854889*r**4+5984320*r**6-47439045*r**8-275719454*r**10
            +1938692851*r**12-6012321852*r**14+4658322525*r**16+2971961450*r**18
            -4803909227*r**20+1599597976*r**22-516519559*r**24-47590770*r**26-13103455*r**28
            -362524*r**30+9624*r**32)+Q2**2*(-49455-643662*r**2-15312277*r**4+103829084*r**6
            -285839973*r**8-52386658*r**10+2229257831*r**12-3134616736*r**14+1959850417*r**16
            +6026543886*r**18-9059347279*r**20+5204165324*r**22-1817549687*r**24
            -163304926*r**26-83714563*r**28-3897608*r**30+216282*r**32)+2*Q2*(8995
            +183028*r**2+4702628*r**4-26616782*r**6+116212870*r**8+241815308*r**10
            -2486307572*r**12+6566587018*r**14-5601093876*r**16+4012394060*r**18
            -7740793636*r**20+8223996790*r**22-3180020950*r**24+857273108*r**26+69788020*r**28
            +29502158*r**30+1047329*r**32-38496*r**34))-16588800*logq2**4*r**16*(240*Q2**8*r**2
            -30*Q2**7*(7+50*r**2+36*r**4)+6*Q2**6*(266+735*r**2+837*r**4+140*r**6)
            +Q2**5*(-4431-8071*r**2-9867*r**4-2727*r**6+3255*r**8)+Q2**4*(5145
            +8463*r**2+10265*r**4+3621*r**6-7935*r**8-5985*r**10)-Q2**3*(840+6167*r**2
            +3532*r**4+304*r**6-7221*r**8-10755*r**10+1995*r**12)+(-1+r**2)**2*(
            -819+3026*r**2-3897*r**4-222*r**6+6253*r**8-138*r**10-1083*r**12+3180*r**14)
            +Q2**2*(-3570+9163*r**2-7256*r**4-1146*r**6+823*r**8-1104*r**10-7515*r**12
            +12705*r**14)+Q2*(3129-11202*r**2+16166*r**4+1809*r**6-13731*r**8
            -16370*r**10-5184*r**12+11343*r**14-11160*r**16))*sqrtq2-4608*logq2**2*r**8*(57168*Q2**16*r**2
            -2*Q2**15*(-5845+367914*r**2+345684*r**4)+2*Q2**14*(-60410+1977755*r**2
            +3847837*r**4+1805820*r**6)-Q2**13*(-518455+11477745*r**2+34954556*r**4
            +33573901*r**6+10536375*r**8)+Q2**12*(-1127245+18705305*r**2+81383504*r**4
            +115278232*r**6+77963459*r**8+18219765*r**10)-Q2**11*(-1014580+13797569*r**2
            +91024971*r**4+147290736*r**6+158596776*r**8+99085571*r**10+17166369*r**12)
            +Q2**10*(795410-6200271*r**2+558208*r**4-111856145*r**6-149321880*r**8
            +4964085*r**10+55689058*r**12+3326439*r**14)+Q2**9*(-3084235+22994780*r**2
            +131965177*r**4+604029700*r**6+1079140925*r**8+848095140*r**10+253919035*r**12
            +13668052*r**14+11837370*r**16)-Q2**8*(-2890965+17705610*r**2+160097138*r**4
            +762087708*r**6+1647095240*r**8+1876140160*r**10+1144132650*r**12+322631448*r**14
            +40802073*r**16+14798250*r**18)+2*Q2**7*(91245-993555*r**2+31303271*r**4
            +158436418*r**6+400757286*r**8+628835220*r**10+646730610*r**12+378414966*r**14
            +125102193*r**16+19586391*r**18+4069035*r**20)-2*Q2**6*(1350580-6684492*r**2
            -14780171*r**4-90271141*r**6-248522356*r**8-243999466*r**10+403562*r**12
            +272798404*r**14+244216284*r**16+141574594*r**18+24874029*r**20+1273533*r**22)
            +Q2**5*(2217985-9060649*r**2-41186662*r**4-249628665*r**6-756356125*r**8
            -947143370*r**10-614776364*r**12+124696566*r**14+472413935*r**16+492953875*r**18
            +271044530*r**20+47995843*r**22+401901*r**24)+(-1+r**2)**4*(19915-39592*r**2
            +357464*r**4+6433228*r**6-38999325*r**8+134836920*r**10-60268716*r**12
            -61967028*r**14-45600531*r**16+115400300*r**18-20550860*r**20+14446408*r**22
            +1214789*r**24+77028*r**26)+Q2**4*(-286195-21915*r**2+19524024*r**4
            +110953260*r**6+200345175*r**8+409387415*r**10-70845440*r**12-314499048*r**14
            -472823125*r**16+121791875*r**18-394822920*r**20-25896820*r**22-12836351*r**24
            +1226865*r**26)+Q2**3*(-696920+3897355*r**2-10185931*r**4-58507916*r**6
            +299251940*r**8-595755285*r**10+456783225*r**12+316067952*r**14+80680992*r**16
            +491937185*r**18-1168768945*r**20+404633020*r**22-199420396*r**24-17716151*r**26
            -2200125*r**28)-Q2*(-1+r**2)**2*(164045-570452*r**2+2279922*r**4+31431742*r**6
            -204063877*r**8+587490210*r**10-180960636*r**12-133773324*r**14-82820229*r**16
            -242011256*r**18+635536970*r**20-142928562*r**22+84802877*r**24+7745962*r**26
            +556608*r**28)+Q2**2*(529130-2771695*r**2+7796704*r**4+53272407*r**6
            -435592656*r**8+1190874175*r**10-952364130*r**12+292056957*r**14+118660386*r**16
            +508424047*r**18-1312177820*r**20+1534052225*r**22-481728636*r**24+185089857*r**26
            +18039134*r**28+1599915*r**30))*sqrtq2-32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(176*Q2**18+Q2**17*(2535+1676*r**2)-Q2**16*(32913+364661*r**2
            +31652*r**4)+Q2**15*(68917+3787700*r**2+3771553*r**4+177696*r**6)-Q2**14*(
            -186186+14930971*r**2+33942285*r**4+15925827*r**6+525835*r**8)+Q2**13*(
            -732732+26050717*r**2+105692368*r**4+111027624*r**6+32799280*r**8+907327*r**10)
            -Q2**12*(324509+9485791*r**2+95086832*r**4+107830116*r**6+132834703*r**8
            +25415813*r**10+849708*r**12)+Q2**11*(4735695-35935918*r**2-174035451*r**4
            -860194842*r**6-730239207*r**8-78154746*r**10-25696893*r**12+186626*r**14)
            +Q2**10*(-7878420+51117673*r**2+455427703*r**4+2689270611*r**6+4581253617*r**8
            +2298868719*r**10+369632889*r**12+71295877*r**14+445027*r**16)-Q2**9*(
            -2284128+6347953*r**2+273545720*r**4+2278224806*r**6+7588991340*r**8
            +7470882852*r**10+2238303088*r**12+320261170*r**14+42657116*r**16+366355*r**18)
            +Q2**8*(7905711-29243549*r**2-120166776*r**4-1776146298*r**6+1548013800*r**8
            +4035751620*r**10+3769240026*r**12-219460086*r**14+2011977*r**16-29382855*r**18
            -121682*r**20)+Q2**7*(-9312237+5292944*r**2+126690299*r**4+4437162732*r**6
            +7584211446*r**8+12328513824*r**10+7299356238*r**12+1118301864*r**14
            +1733839047*r**16+122705136*r**18+50863751*r**20+262988*r**22)-Q2**6*(
            -631274-24250639*r**2-17896433*r**4+1874113581*r**6+6883024941*r**8
            +15156693138*r**10+20234085838*r**12+7332891090*r**14+985613736*r**16
            +858975661*r**18+78073619*r**20+12183601*r**22+6021*r**24)+Q2**5*(5624664
            -13151621*r**2+112252680*r**4-1821627060*r**6+1866941356*r**8-2250779013*r**10
            +7611706416*r**12+8755730960*r**14+1615778544*r**16+1282968081*r**18
            +175004776*r**20+126163332*r**22-18061908*r**24-163367*r**26)+Q2**4*(
            -3753939-7632901*r**2-209951320*r**4+2113533408*r**6-1413307675*r**8
            +10066028003*r**10+6957706272*r**12-699243080*r**14-1370609321*r**16
            -3452772735*r**18-2930899984*r**20-412158616*r**22-139818345*r**24+12844193*r**26
            +90440*r**28)+Q2**3*(-105655+8863882*r**2+44640383*r**4-316660626*r**6
            +585467545*r**8-2566777246*r**10-5087246889*r**12+3816175574*r**14-720240173*r**16
            +2043625630*r**18+2367671797*r**20+1524887882*r**22+224304843*r**24+13040374*r**26
            +118325*r**28+13554*r**30)+Q2**2*(1128336-2016029*r**2+92595333*r**4
            -654708291*r**6+2153606607*r**8-3252444525*r**10+1274435037*r**12-2290651051*r**14
            -7064801553*r**16+16654038801*r**18-12936995113*r**20+3971069823*r**22
            +275119893*r**24+186126969*r**26+72474567*r**28-3043473*r**30-31331*r**32)
            -2*(-1+r**2)**2*(-36857-161613*r**2-6810851*r**4+35146072*r**6-233476106*r**8
            -16624739*r**10+3287333199*r**12-13455588938*r**14+20748902706*r**16
            -14279266723*r**18+4617951579*r**20-955820164*r**22-34667986*r**24-29099053*r**26
            -4448071*r**28+74742*r**30+803*r**32)+Q2*(-500931-431635*r**2-65255680*r**4
            +451471698*r**6-2224528152*r**8+3042024930*r**10+6513831000*r**12-23634794558*r**14
            -2182533326*r**16+57386238084*r**18-60936658352*r**20+24714711430*r**22
            -5251155984*r**24-197165922*r**26-182264232*r**28-46919322*r**30+1182905*r**32
            +12047*r**34))*sqrtq2)*math.log(r))/(5225472000*logq2**5*r**22*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))+362880000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+1260000*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-30240000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-21000*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2-2177280000*logq2**4*r**18*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+((18144000*logq2**4*r**14*(-108+205*r**2+243*r**4+147*r**6
            +57*r**8)-1440*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(-8386
            -11465*r**2-22920*Q2**9*r**2-62195*r**4-2717840*r**6+6917980*r**8-22099358*r**10
            -21383090*r**12-6768560*r**14+4537510*r**16+392615*r**18+76389*r**20
            +14*Q2**8*(176+13983*r**2+14511*r**4)-8*Q2**7*(-1596+84411*r**2+173866*r**4
            +81219*r**6)+Q2**6*(-48538+796596*r**2+3339844*r**4+3375056*r**6+703962*r**8)
            +Q2**5*(15316+131715*r**2-2502696*r**4-5462046*r**6-2927100*r**8+366891*r**10)
            +Q2**4*(74130-810275*r**2-1204411*r**4+2238572*r**6+2423914*r**8-339305*r**10
            -1262625*r**12)+Q2**3*(-63784+236918*r**2+2698370*r**4+7422746*r**6
            +7895716*r**8+6043210*r**10+2727458*r**12+592326*r**14)+2*Q2**2*(-7819
            +150219*r**2-381124*r**4-4440276*r**6-8601465*r**8-9106871*r**10-3127304*r**12
            -1118016*r**14+176016*r**16)-Q2*(-31668+141481*r**2+554090*r**4+314664*r**6
            +7132318*r**8+2108438*r**10-2336106*r**12+5668600*r**14-202474*r**16
            +359457*r**18))+(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-1257+23280*Q2**15
            +197749*r**2+5145507*r**4+37228177*r**6-11952781*r**8+1204100569*r**10
            +3078214607*r**12-14343705979*r**14+29332802261*r**16-10064178193*r**18
            +1119578233*r**20-435150781*r**22-50596703*r**24-1367613*r**26+22549*r**28
            -345*r**30-79740*Q2**14*(1+r**2)+8*Q2**13*(2895+37654*r**2+2895*r**4)
            +3*Q2**12*(10311+27177*r**2-92175*r**4+50095*r**6)+2*Q2**11*(249537
            -1289432*r**2-7773146*r**4-807368*r**6+8505*r**8)+Q2**10*(-986172+3822624*r**2
            +74286932*r**4+68106212*r**6+4895544*r**8-393780*r**10)+10*Q2**9*(9627
            +394004*r**2-9538059*r**4-27851224*r**6-8402667*r**8-170236*r**10+7323*r**12)
            +3*Q2**8*(292055-2580963*r**2-6067745*r**4+114291165*r**6+135603965*r**8
            -12702065*r**10-2710163*r**12+182935*r**14)-4*Q2**7*(58359+2614968*r**2
            -26319450*r**4-35403360*r**6-74039890*r**8+7955784*r**10-41387322*r**12
            -1812960*r**14+73455*r**16)-12*Q2**6*(42929-1640069*r**2+2028028*r**4
            +56921404*r**6+256968360*r**8+210037384*r**10+59041116*r**12+8400908*r**14
            -371921*r**16+24085*r**18)+4*Q2**5*(41181+617088*r**2-19508241*r**4
            +62799384*r**6+692754868*r**8+1863290056*r**10+479147908*r**12+167334024*r**14
            -15204081*r**16-1492392*r**18+53805*r**20)+5*Q2**4*(37059-3096475*r**2
            +10222233*r**4+62664543*r**6+276752950*r**8-942013894*r**10-1554884278*r**12
            +473069638*r**14+47446023*r**16+20863329*r**18-232675*r**20+14427*r**22)
            -2*Q2**3*(34875-2048616*r**2-16758750*r**4+5883960*r**6+866331085*r**8
            +1008596400*r**10-74882948*r**12-1204117200*r**14+1515261685*r**16+268895160*r**18
            +13545570*r**20-1127016*r**22+33795*r**24)-4*Q2**2*(6543-880504*r**2
            +8241125*r**4+16841225*r**6-25041740*r**8-1022570411*r**10-2949907082*r**12
            -1066261010*r**14-1527284885*r**16-36676610*r**18-26658907*r**20+6455561*r**22
            -34990*r**24+2085*r**26)+2*Q2*(6387-883932*r**2-2310811*r**4-34583608*r**6
            +341356575*r**8+506580796*r**10+1887785929*r**12-4580216208*r**14+7260612841*r**16
            -2701290980*r**18+547759167*r**20+57731528*r**22+7755269*r**24-195708*r**26
            +4755*r**28))-86400*logq2**3*r**10*(-360*Q2**6*r**2+10*Q2**5*(56+237*r**2
            +405*r**4)-2*Q2**4*(2576+3407*r**2+10086*r**4+8559*r**6)+Q2**3*(5138
            +32029*r**2+55679*r**4+73515*r**6+34647*r**8)-2*Q2**2*(-1379+14446*r**2
            +30670*r**4+50580*r**6+43557*r**8+5934*r**10)+Q2*(-3122+10343*r**2
            -34011*r**4-39374*r**6+10956*r**8+8871*r**10-29823*r**12)+2*(-91+282*r**2
            +28681*r**4-101848*r**6-99713*r**8-57342*r**10-8685*r**12+10236*r**14))*sqrtq2
            +24*logq2*r**2*(50*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(-98+9859*r**2+780*Q2**6*r**2
            +66412*r**4+45153*r**6+156558*r**8+186021*r**10+18504*r**12-5289*r**14
            -5*Q2**5*(56+705*r**2+873*r**4)-Q2**4*(448+2713*r**2+5322*r**4+3609*r**6)
            +Q2**3*(1022+4049*r**2-295*r**4-1191*r**6+6051*r**8)+2*Q2**2*(161+4170*r**2
            +9264*r**4+11520*r**6+11091*r**8+3498*r**10)+Q2*(-518+10930*r**2+18114*r**4
            -3102*r**6+29448*r**8+25212*r**10-564*r**12))+(-Q2+(-1+r)**2)*(-Q2
            +(1+r)**2)*(83808*Q2**12*r**2-36*Q2**11*(-1120+18771*r**2+15411*r**4)
            +4*Q2**10*(-27720+466737*r**2+1208506*r**4+411297*r**6)-5*Q2**9*(1890
            +349557*r**2+2224963*r**4+2231623*r**6+350487*r**8)-30*Q2**8*(-8085
            +43811*r**2-64894*r**4-80998*r**6-116253*r**8+57363*r**10)+12*Q2**7*(
            -7350+135257*r**2+1332200*r**4+7164795*r**6+6069565*r**8+1225560*r**10
            +407997*r**12)-12*Q2**6*(18270-275016*r**2+681929*r**4+14980320*r**6
            +31376620*r**8+12914780*r**10+1208389*r**12+86884*r**14)-6*Q2**5*(-14910
            +321681*r**2+90873*r**4-16510339*r**6-99120415*r**8-104263215*r**10
            -14286299*r**12-731927*r**14+671751*r**16)+20*Q2**4*(5985-194247*r**2
            +276357*r**4+5627400*r**6-4667217*r**8-31184234*r**10-11835201*r**12
            +8650872*r**14+280332*r**16+90513*r**18)+20*Q2**3*(-1890+73674*r**2
            -428211*r**4-4638909*r**6-16685739*r**8-18117443*r**10+2611585*r**12
            -11175315*r**14-11488227*r**16-883527*r**18+90642*r**20)-12*Q2**2*(3150
            -162209*r**2+748325*r**4+7819815*r**6-163040*r**8-46435610*r**10-56614022*r**12
            +4561950*r**14-14164590*r**16+1623515*r**18-650015*r**20+79131*r**22)
            -Q2*(-5670+283161*r**2-3775469*r**4+27596175*r**6+69206535*r**8+67130510*r**10
            +160962138*r**12+526134498*r**14-158523100*r**16+303525465*r**18-89190765*r**20
            -8699249*r**22+459771*r**24)+2*(2835-228981*r**2+2941132*r**4+12759694*r**6
            -44988705*r**8-10434715*r**10-650410648*r**12+246921636*r**14-123584503*r**16
            -375975595*r**18+55397580*r**20-4874546*r**22-2760443*r**24+131259*r**26)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(
            -5225472000*logq2**5*r**20-362880000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -1260000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+2177280000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+30240000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+21000*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +((43200*logq2**3*r**10*(-16+47*r**2+46*r**4+15*r**6)-12*logq2*(-Q2
            +(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-80-1341*r**2+1544*Q2**8*r**2-7172*r**4
            -59768*r**6+117716*r**8-820230*r**10-397644*r**12+156712*r**14+17708*r**16
            +499*r**18-8*Q2**7*(-40+1269*r**2+1149*r**4)+Q2**6*(-800+14927*r**2
            +40590*r**4+13327*r**6)+Q2**5*(80+3186*r**2-44058*r**4-48218*r**6+4706*r**8)
            +Q2**4*(1200-13955*r**2-3760*r**4+41094*r**6+15520*r**8-21795*r**10)
            +4*Q2**3*(-200-531*r**2+10635*r**4+55156*r**6+42996*r**8+9655*r**10
            +2209*r**12)+Q2**2*(-320+7497*r**2-27738*r**4-275421*r**6-527636*r**8
            -220461*r**10-55258*r**12+7097*r**14)-2*Q2*(-200-209*r**2+8405*r**4
            +67339*r**6+29745*r**8-40055*r**10+98659*r**12-595*r**14+2511*r**16))
            -720*logq2**2*r**6*(-64+133*r**2+60*Q2**5*r**2+1223*r**4-10172*r**6-7372*r**8
            -1313*r**10+1005*r**12-32*Q2**4*(2+9*r**2+15*r**4)+Q2**3*(16+1453*r**2
            +2522*r**4+1485*r**6)-Q2**2*(-96+1069*r**2+3351*r**4+3783*r**6+765*r**8)
            -Q2*(-16+409*r**2+1378*r**4+146*r**6-462*r**8+1305*r**10))*sqrtq2
            +(-100*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(5*Q2**5-4*Q2**3*(-1+r**2)**2+Q2**2*(
            -3+r**2)*(-1+r**2)**2-4*Q2**4*(1+r**2)+Q2*(-1+r**2)**2*(-3-8*r**2
            +r**4)+(-1+r**2)**2*(-3-47*r**2-11*r**4+r**6))+(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(-327+40*Q2**11+5381*r**2+51893*r**4-66375*r**6+459862*r**8
            -1267442*r**10+6907134*r**12-1962938*r**14-121295*r**16-29907*r**18
            -1651*r**20+65*r**22-160*Q2**10*(1+r**2)+Q2**9*(25-158*r**2+25*r**4)
            +Q2**8*(1913-6501*r**2-3237*r**4+825*r**6)-2*Q2**7*(2502-11611*r**2
            -64954*r**4-8107*r**6+750*r**8)+2*Q2**6*(1502-7291*r**2-167219*r**4
            -158107*r**6-8175*r**8+210*r**10)+2*Q2**5*(1711-11743*r**2+61595*r**4
            +379858*r**6+56331*r**8-7647*r**10+735*r**12)+Q2**4*(-3690+20928*r**2
            +204288*r**4-432758*r**6-916254*r**8+338360*r**10+34328*r**12-1650*r**14)
            +2*Q2**3*(-514+8473*r**2-16750*r**4-239765*r**6-565632*r**8+77979*r**10
            -155902*r**12-5559*r**14+150*r**16)+2*Q2**2*(782-7781*r**2-54965*r**4
            +345293*r**6+1595771*r**8+1042739*r**10+455677*r**12-12549*r**14-5697*r**16
            +250*r**18)+Q2*(241-6028*r**2-28199*r**4+357456*r**6+1406870*r**8
            -1995336*r**10+2615318*r**12-480176*r**14+108569*r**16+8820*r**18-335*r**20)))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(2073600*logq2**4*r**16
            +86400*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+100*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-691200*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-4800*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((720*logq2**2*r**6*(-4+21*r**2+9*r**4)+(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(21
            +120*Q2**7+431*r**2+2289*r**4-3941*r**6+26419*r**8-5607*r**10-937*r**12
            +45*r**14-225*Q2**6*(1+r**2)-8*Q2**5*(15-58*r**2+15*r**4)-4*Q2**3*(
            -84+275*r**2+1754*r**4+107*r**6)+3*Q2**4*(37-17*r**2-281*r**4+125*r**6)
            +Q2**2*(-99+1093*r**2+10210*r**4+8818*r**6+1717*r**8-195*r**10)+4*Q2*(
            -36+327*r**2+1534*r**4-2282*r**6+1954*r**8+63*r**10))-24*logq2*r**2*(
            -10-11*r**2-36*Q2**4*r**2+14*r**4-1326*r**6-416*r**8+189*r**10+2*Q2**3*(
            -5+132*r**2+117*r**4)-Q2**2*(-10+191*r**2+524*r**4+171*r**6)-2*Q2*(
            -5+93*r**2+2*r**4-68*r**6+108*r**8))*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(
            -34560*logq2**3*r**12-720*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+8640*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((12*logq2*r**4+(3-5*Q2**3-5*r**2
            +19*r**4-5*r**6+5*Q2**2*(1+r**2)+Q2*(5-8*r**2+5*r**4))*sqrtq2)*nlo.X1Q2(3,'SM',Q2,r))/(288*logq2**2*r**8
            +2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-48*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((1512000*logq2**3*r**12*(1
            +r**2)*(19+10*r**2+19*r**4)+60*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1
            +r)**2)*(23-1440*Q2**9+10999*r**2+228160*r**4+383296*r**6+3006322*r**8
            +3006322*r**10+383296*r**12+228160*r**14+10999*r**16+23*r**18+10248*Q2**8*(1
            +r**2)-512*Q2**7*(37+94*r**2+37*r**4)+Q2**6*(4319+70769*r**2+70769*r**4
            +4319*r**6)+2*Q2**5*(8631-19072*r**2-30126*r**4-19072*r**6+8631*r**8)
            -Q2**4*(11375+66235*r**2+466262*r**4+466262*r**6+66235*r**8+11375*r**10)
            -4*Q2**3*(847-28698*r**2-220767*r**4-429164*r**6-220767*r**8-28698*r**10
            +847*r**12)+Q2**2*(3729-4117*r**2-37563*r**4-1070849*r**6-1070849*r**8
            -37563*r**10-4117*r**12+3729*r**14)-2*Q2*(217+25092*r**2+198688*r**4
            -394052*r**6-869490*r**8-394052*r**10+198688*r**12+25092*r**14+217*r**16))
            +3600*logq2**2*r**8*(781-80*Q2**6+4344*r**2+33555*r**4+43600*r**6+33555*r**8
            +4344*r**10+781*r**12+900*Q2**5*(1+r**2)-4*Q2**4*(951+1718*r**2+951*r**4)
            +Q2**3*(3931+13189*r**2+13189*r**4+3931*r**6)+Q2**2*(1131-5648*r**2
            -11126*r**4-5648*r**6+1131*r**8)-3*Q2*(953-829*r**2-3484*r**4-3484*r**6
            -829*r**8+953*r**10))*sqrtq2+(-250*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1+8*Q2**6
            -34*r**2-1133*r**4-2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1+r**2)
            +Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1
            -26*r**2-118*r**4-26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6
            -31*r**8+r**10))+7*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6
            -28170*r**8+31692*r**10-9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)
            +Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)
            +Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2
            -6138*r**4-6138*r**6-355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4
            +35188*r**6+10313*r**8-406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4
            +6605*r**6+6605*r**8-7237*r**10-595*r**12+27*r**14)))*sqrtq2)*nlopw.X1Q2MuG(0,Q2,r))/(72576000*logq2**4*r**16
            +3024000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+3500*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-24192000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-168000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((3600*logq2**2*r**8*(15+22*r**2+15*r**4)+(Q2-(-1+r)**2)*(Q2-(1
            +r)**2)*(7+92*Q2**8-156*r**2+5096*r**4+19308*r**6+138690*r**8+19308*r**10
            +5096*r**12-156*r**14+7*r**16-156*Q2**7*(1+r**2)+Q2**6*(-89+190*r**2
            -89*r**4)+2*Q2**5*(79-247*r**2-247*r**4+79*r**6)+Q2**4*(165-1160*r**2
            -10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4-2439*r**6
            -280*r**8+19*r**10)+Q2**2*(-79+806*r**2+1787*r**4-14228*r**6+1787*r**8
            +806*r**10-79*r**12)+2*Q2*(27-635*r**2-2957*r**4+19165*r**6+19165*r**8
            -2957*r**10-635*r**12+27*r**14))+600*logq2*r**4*(1+2*Q2**5+35*r**2
            +276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17+42*r**2
            +17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2+66*r**4
            +30*r**6-11*r**8))*sqrtq2)*nlopw.X1Q2MuG(1,Q2,r))/(-86400*logq2**3*r**12-1800*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+21600*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+50*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((540*logq2*r**4*(1+r**2)-3*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*sqrtq2)*nlopw.X1Q2MuG(2,Q2,r))/(1440*logq2**2*r**8+10*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2-240*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2)+nlopw.X1Q2MuG(3,Q2,r)/(-12*logq2*r**4+(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+rhoLS*((flagPERP*(
            -10450944000*logq2**5*(-Q2+(-1+r)**2)*r**20*(-1+r**4+2*r**6)*(-Q2+(1
            +r)**2)-276480*logq2**3*(-Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)*(12240*Q2**11*r**2
            -2*Q2**10*(805+53106*r**2+45816*r**4)+10*Q2**9*(1015+39116*r**2+64725*r**4
            +27132*r**6)-5*Q2**8*(4620+150673*r**2+364785*r**4+298335*r**6+77877*r**8)
            +5*Q2**7*(3570+143209*r**2+480963*r**4+586151*r**6+308835*r**8+55800*r**10)
            -5*Q2**6*(-2520+22750*r**2+177459*r**4+380766*r**6+352988*r**8+139020*r**10
            +40257*r**12)+Q2**5*(-30030-407771*r**2-1498101*r**4-1336650*r**6-303620*r**8
            +778485*r**10+466599*r**12+375984*r**14)-5*Q2**4*(-2520-74608*r**2-394287*r**4
            -513900*r**6-387451*r**8+134208*r**10+299623*r**12+180180*r**14+70299*r**16)
            -5*Q2**3*(-1470+28837*r**2+81273*r**4+304061*r**6+153637*r**8-187209*r**10
            -459837*r**12-4249*r**14-165315*r**16+20448*r**18)+(-1+r**2)**2*(140
            +9813*r**2-202046*r**4+926700*r**6-769394*r**8+310202*r**10-49598*r**12
            -371164*r**14+840390*r**16+4209*r**18+56748*r**20)+5*Q2**2*(-1470+12026*r**2
            -181791*r**4+424860*r**6-318268*r**8-74112*r**10-111870*r**12-397228*r**14
            +616338*r**16-99210*r**18+80325*r**20)-5*Q2*(-280+7373*r**2-162861*r**4
            +598484*r**6-681340*r**8+216198*r**10+315794*r**12+314324*r**14-592836*r**16
            +600693*r**18-62925*r**20+52176*r**22))+192*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(-9312*Q2**17*r**2+4*Q2**16*(-805+31950*r**2+31368*r**4)
            -4*Q2**15*(-6685+161502*r**2+404131*r**4+169116*r**6)+Q2**14*(-86205
            +1568566*r**2+7173691*r**4+7409140*r**6+1895670*r**8)-2*Q2**13*(-55335
            +877182*r**2+6391588*r**4+7546174*r**6+7529917*r**8+1386990*r**10)+Q2**12*(55545
            +325312*r**2+892928*r**4-68024936*r**6-55484733*r**8+7582332*r**10+1205856*r**12)
            +4*Q2**11*(-88830+138939*r**2+7316008*r**4+90026929*r**6+162887050*r**8
            +76015549*r**10+6217412*r**12+641391*r**14)-Q2**10*(-367675-1123030*r**2
            +36823099*r**4+594075420*r**6+1792409349*r**8+1705822874*r**10+526212217*r**12
            +49659184*r**14+4273698*r**16)+2*Q2**9*(51205-825816*r**2+4872884*r**4
            +96431950*r**6+833807240*r**8+1312272220*r**10+895413124*r**12+152528314*r**14
            +14089355*r**16+642180*r**18)+Q2**8*(-523215-2287872*r**2-5690958*r**4
            +626144376*r**6+913254048*r**8+1261991140*r**10+202088558*r**12-313915968*r**14
            +199085991*r**16+14213508*r**18+2551560*r**20)-4*Q2**7*(-88165-1312728*r**2
            -7969281*r**4+197575162*r**6+740554886*r**8+1732027876*r**10+2057652454*r**12
            +790695704*r**14+170255247*r**16+87188276*r**18+6605931*r**20+630894*r**22)
            +Q2**6*(117425-1964862*r**2-15376235*r**4+107758348*r**6+1798025460*r**8
            +5044647308*r**10+10384226762*r**12+8058157568*r**14+1879903593*r**16
            +424735010*r**18+152762433*r**20+12860644*r**22-69294*r**24)+2*Q2**5*(
            -143535-1355918*r**2-18809060*r**4+209996206*r**6+78374599*r**8+662949094*r**10
            -177607368*r**12-2139634132*r**14-1113700217*r**16-581191826*r**18-260611316*r**20
            -44953946*r**22-2255135*r**24+650394*r**26)+Q2**4*(123795+2844816*r**2
            +44458316*r**4-296284040*r**6-471841525*r**8-2272449820*r**10-6261334512*r**12
            -1755882032*r**14+1136786505*r**16+924153720*r**18+2563155940*r**20+818410136*r**22
            +118116281*r**24+2390900*r**26-629280*r**28)-4*Q2**3*(-7980+107941*r**2
            +1499054*r**4+2511507*r**6-55651184*r**8-21011415*r**10-810178302*r**12
            +57571407*r**14+221197076*r**16+46474703*r**18+579675250*r**20+243457961*r**22
            +84712264*r**24+3269667*r**26-455394*r**28+30645*r**30)+(-1+r**2)**2*(
            -2345-65626*r**2-1854889*r**4+5984320*r**6-47439045*r**8-275719454*r**10
            +1938692851*r**12-6012321852*r**14+4658322525*r**16+2971961450*r**18
            -4803909227*r**20+1599597976*r**22-516519559*r**24-47590770*r**26-13103455*r**28
            -362524*r**30+9624*r**32)+Q2**2*(-49455-643662*r**2-15312277*r**4+103829084*r**6
            -285839973*r**8-52386658*r**10+2229257831*r**12-3134616736*r**14+1959850417*r**16
            +6026543886*r**18-9059347279*r**20+5204165324*r**22-1817549687*r**24
            -163304926*r**26-83714563*r**28-3897608*r**30+216282*r**32)+2*Q2*(8995
            +183028*r**2+4702628*r**4-26616782*r**6+116212870*r**8+241815308*r**10
            -2486307572*r**12+6566587018*r**14-5601093876*r**16+4012394060*r**18
            -7740793636*r**20+8223996790*r**22-3180020950*r**24+857273108*r**26+69788020*r**28
            +29502158*r**30+1047329*r**32-38496*r**34))-16588800*logq2**4*r**16*(240*Q2**8*r**2
            -30*Q2**7*(7+50*r**2+36*r**4)+6*Q2**6*(266+735*r**2+837*r**4+140*r**6)
            +Q2**5*(-4431-8071*r**2-9867*r**4-2727*r**6+3255*r**8)+Q2**4*(5145
            +8463*r**2+10265*r**4+3621*r**6-7935*r**8-5985*r**10)-Q2**3*(840+6167*r**2
            +3532*r**4+304*r**6-7221*r**8-10755*r**10+1995*r**12)+(-1+r**2)**2*(
            -819+3026*r**2-3897*r**4-222*r**6+6253*r**8-138*r**10-1083*r**12+3180*r**14)
            +Q2**2*(-3570+9163*r**2-7256*r**4-1146*r**6+823*r**8-1104*r**10-7515*r**12
            +12705*r**14)+Q2*(3129-11202*r**2+16166*r**4+1809*r**6-13731*r**8
            -16370*r**10-5184*r**12+11343*r**14-11160*r**16))*sqrtq2-4608*logq2**2*r**8*(57168*Q2**16*r**2
            -2*Q2**15*(-5845+367914*r**2+345684*r**4)+2*Q2**14*(-60410+1977755*r**2
            +3847837*r**4+1805820*r**6)-Q2**13*(-518455+11477745*r**2+34954556*r**4
            +33573901*r**6+10536375*r**8)+Q2**12*(-1127245+18705305*r**2+81383504*r**4
            +115278232*r**6+77963459*r**8+18219765*r**10)-Q2**11*(-1014580+13797569*r**2
            +91024971*r**4+147290736*r**6+158596776*r**8+99085571*r**10+17166369*r**12)
            +Q2**10*(795410-6200271*r**2+558208*r**4-111856145*r**6-149321880*r**8
            +4964085*r**10+55689058*r**12+3326439*r**14)+Q2**9*(-3084235+22994780*r**2
            +131965177*r**4+604029700*r**6+1079140925*r**8+848095140*r**10+253919035*r**12
            +13668052*r**14+11837370*r**16)-Q2**8*(-2890965+17705610*r**2+160097138*r**4
            +762087708*r**6+1647095240*r**8+1876140160*r**10+1144132650*r**12+322631448*r**14
            +40802073*r**16+14798250*r**18)+2*Q2**7*(91245-993555*r**2+31303271*r**4
            +158436418*r**6+400757286*r**8+628835220*r**10+646730610*r**12+378414966*r**14
            +125102193*r**16+19586391*r**18+4069035*r**20)-2*Q2**6*(1350580-6684492*r**2
            -14780171*r**4-90271141*r**6-248522356*r**8-243999466*r**10+403562*r**12
            +272798404*r**14+244216284*r**16+141574594*r**18+24874029*r**20+1273533*r**22)
            +Q2**5*(2217985-9060649*r**2-41186662*r**4-249628665*r**6-756356125*r**8
            -947143370*r**10-614776364*r**12+124696566*r**14+472413935*r**16+492953875*r**18
            +271044530*r**20+47995843*r**22+401901*r**24)+(-1+r**2)**4*(19915-39592*r**2
            +357464*r**4+6433228*r**6-38999325*r**8+134836920*r**10-60268716*r**12
            -61967028*r**14-45600531*r**16+115400300*r**18-20550860*r**20+14446408*r**22
            +1214789*r**24+77028*r**26)+Q2**4*(-286195-21915*r**2+19524024*r**4
            +110953260*r**6+200345175*r**8+409387415*r**10-70845440*r**12-314499048*r**14
            -472823125*r**16+121791875*r**18-394822920*r**20-25896820*r**22-12836351*r**24
            +1226865*r**26)+Q2**3*(-696920+3897355*r**2-10185931*r**4-58507916*r**6
            +299251940*r**8-595755285*r**10+456783225*r**12+316067952*r**14+80680992*r**16
            +491937185*r**18-1168768945*r**20+404633020*r**22-199420396*r**24-17716151*r**26
            -2200125*r**28)-Q2*(-1+r**2)**2*(164045-570452*r**2+2279922*r**4+31431742*r**6
            -204063877*r**8+587490210*r**10-180960636*r**12-133773324*r**14-82820229*r**16
            -242011256*r**18+635536970*r**20-142928562*r**22+84802877*r**24+7745962*r**26
            +556608*r**28)+Q2**2*(529130-2771695*r**2+7796704*r**4+53272407*r**6
            -435592656*r**8+1190874175*r**10-952364130*r**12+292056957*r**14+118660386*r**16
            +508424047*r**18-1312177820*r**20+1534052225*r**22-481728636*r**24+185089857*r**26
            +18039134*r**28+1599915*r**30))*sqrtq2-32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(176*Q2**18+Q2**17*(2535+1676*r**2)-Q2**16*(32913+364661*r**2
            +31652*r**4)+Q2**15*(68917+3787700*r**2+3771553*r**4+177696*r**6)-Q2**14*(
            -186186+14930971*r**2+33942285*r**4+15925827*r**6+525835*r**8)+Q2**13*(
            -732732+26050717*r**2+105692368*r**4+111027624*r**6+32799280*r**8+907327*r**10)
            -Q2**12*(324509+9485791*r**2+95086832*r**4+107830116*r**6+132834703*r**8
            +25415813*r**10+849708*r**12)+Q2**11*(4735695-35935918*r**2-174035451*r**4
            -860194842*r**6-730239207*r**8-78154746*r**10-25696893*r**12+186626*r**14)
            +Q2**10*(-7878420+51117673*r**2+455427703*r**4+2689270611*r**6+4581253617*r**8
            +2298868719*r**10+369632889*r**12+71295877*r**14+445027*r**16)-Q2**9*(
            -2284128+6347953*r**2+273545720*r**4+2278224806*r**6+7588991340*r**8
            +7470882852*r**10+2238303088*r**12+320261170*r**14+42657116*r**16+366355*r**18)
            +Q2**8*(7905711-29243549*r**2-120166776*r**4-1776146298*r**6+1548013800*r**8
            +4035751620*r**10+3769240026*r**12-219460086*r**14+2011977*r**16-29382855*r**18
            -121682*r**20)+Q2**7*(-9312237+5292944*r**2+126690299*r**4+4437162732*r**6
            +7584211446*r**8+12328513824*r**10+7299356238*r**12+1118301864*r**14
            +1733839047*r**16+122705136*r**18+50863751*r**20+262988*r**22)-Q2**6*(
            -631274-24250639*r**2-17896433*r**4+1874113581*r**6+6883024941*r**8
            +15156693138*r**10+20234085838*r**12+7332891090*r**14+985613736*r**16
            +858975661*r**18+78073619*r**20+12183601*r**22+6021*r**24)+Q2**5*(5624664
            -13151621*r**2+112252680*r**4-1821627060*r**6+1866941356*r**8-2250779013*r**10
            +7611706416*r**12+8755730960*r**14+1615778544*r**16+1282968081*r**18
            +175004776*r**20+126163332*r**22-18061908*r**24-163367*r**26)+Q2**4*(
            -3753939-7632901*r**2-209951320*r**4+2113533408*r**6-1413307675*r**8
            +10066028003*r**10+6957706272*r**12-699243080*r**14-1370609321*r**16
            -3452772735*r**18-2930899984*r**20-412158616*r**22-139818345*r**24+12844193*r**26
            +90440*r**28)+Q2**3*(-105655+8863882*r**2+44640383*r**4-316660626*r**6
            +585467545*r**8-2566777246*r**10-5087246889*r**12+3816175574*r**14-720240173*r**16
            +2043625630*r**18+2367671797*r**20+1524887882*r**22+224304843*r**24+13040374*r**26
            +118325*r**28+13554*r**30)+Q2**2*(1128336-2016029*r**2+92595333*r**4
            -654708291*r**6+2153606607*r**8-3252444525*r**10+1274435037*r**12-2290651051*r**14
            -7064801553*r**16+16654038801*r**18-12936995113*r**20+3971069823*r**22
            +275119893*r**24+186126969*r**26+72474567*r**28-3043473*r**30-31331*r**32)
            -2*(-1+r**2)**2*(-36857-161613*r**2-6810851*r**4+35146072*r**6-233476106*r**8
            -16624739*r**10+3287333199*r**12-13455588938*r**14+20748902706*r**16
            -14279266723*r**18+4617951579*r**20-955820164*r**22-34667986*r**24-29099053*r**26
            -4448071*r**28+74742*r**30+803*r**32)+Q2*(-500931-431635*r**2-65255680*r**4
            +451471698*r**6-2224528152*r**8+3042024930*r**10+6513831000*r**12-23634794558*r**14
            -2182533326*r**16+57386238084*r**18-60936658352*r**20+24714711430*r**22
            -5251155984*r**24-197165922*r**26-182264232*r**28-46919322*r**30+1182905*r**32
            +12047*r**34))*sqrtq2))/(7838208000*logq2**5*r**22*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))+544320000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+1890000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-45360000*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-31500*(-Q2+(
            -1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2-3265920000*logq2**4*r**18*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(flagPERP*muWC**2*(10450944000*logq2**5*(-Q2+(-1+r)**2)*(
            -1+r)*r**20*(1+r)*(5+r**4)*(-Q2+(1+r)**2)+276480*logq2**3*(-Q2+(
            -1+r)**2)*r**12*(-Q2+(1+r)**2)*(-29160*Q2**11*r**2+Q2**10*(4354+216102*r**2
            +267984*r**4)-10*Q2**9*(3325+66353*r**2+163515*r**4+101031*r**6)+5*Q2**8*(18963
            +217340*r**2+759570*r**4+987930*r**6+378117*r**8)-5*Q2**7*(24864+201663*r**2
            +802730*r**4+1573576*r**6+1433190*r**8+281385*r**10)+5*Q2**6*(10836
            +135835*r**2+305769*r**4+664530*r**6+1002386*r**8+802851*r**10-199647*r**12)
            +Q2**5*(49392-702149*r**2+20742*r**4+2409825*r**6+6538540*r**8+5080677*r**10
            +1895166*r**12+2901087*r**14)-5*Q2**4*(14070-140631*r**2-66595*r**4
            +290289*r**6+1571277*r**8+2923703*r**10+1719739*r**12+826455*r**14+397053*r**16)
            -5*Q2**3*(-3192+48245*r**2-12498*r**4+262078*r**6-423970*r**8-1226496*r**10
            -1986054*r**12-99470*r**14-580110*r**16+43227*r**18)+(-1+r**2)**3*(
            -4879+17066*r**2+337776*r**4-1881054*r**6+1045786*r**8+195594*r**10
            +1135624*r**12+1267014*r**14+52269*r**16+102804*r**18)+5*Q2**2*(4914
            -29617*r**2-196389*r**4+563052*r**6-402136*r**8-205254*r**10-130662*r**12
            -807604*r**14+1345806*r**16-351585*r**18+209475*r**20)-5*Q2*(4046-27807*r**2
            -178360*r**4+925373*r**6-1352916*r**8+189098*r**10+333536*r**12-3990*r**14
            -887338*r**16+1081941*r**18-196344*r**20+112761*r**22))+192*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-4656*Q2**17*r**2+4*Q2**16*(-4025+29301*r**2
            +13560*r**4)-4*Q2**15*(-33915+173959*r**2+332147*r**4+64161*r**6)+Q2**14*(
            -463925+2049671*r**2+6780185*r**4+5508151*r**6+601950*r**8)-2*Q2**13*(
            -374605+2243625*r**2+6002282*r**4+1678596*r**6+4164467*r**8+276675*r**10)
            -Q2**12*(298655-9872017*r**2-2600340*r**4+146601032*r**6+135666425*r**8
            +8729489*r**10+584052*r**12)+4*Q2**11*(-231280-4659131*r**2+2991439*r**4
            +147236034*r**6+289270594*r**8+139608749*r**10+12919151*r**12+520380*r**14)
            -Q2**10*(-1544235-22194735*r**2+9501973*r**4+953067611*r**6+2846105125*r**8
            +3021455135*r**10+859028971*r**12+68523365*r**14+1745238*r**16)+Q2**9*(
            -558250-11591682*r**2+26946580*r**4+769013688*r**6+2263830160*r**8+3499116540*r**10
            +2824648828*r**12+91724120*r**14+146698*r**16-813450*r**18)+Q2**8*(-818895
            -3654615*r**2-84100182*r**4-491668006*r**6+890470948*r**8+5610996100*r**10
            +4947223110*r**12+1819512278*r**14+1493478459*r**16+96097443*r**18+2640000*r**20)
            -4*Q2**7*(-230615-1918911*r**2-22686315*r**4-129886211*r**6+464456190*r**8
            +3445614778*r**10+6608535690*r**12+3972723470*r**14+1558621729*r**16
            +462231085*r**18+23413593*r**20+383757*r**22)+Q2**6*(-88935-3591779*r**2
            -25238257*r**4-273258847*r**6+199821868*r**8+8083222218*r**10+24872273910*r**12
            +34287250778*r**14+8836672153*r**16+4414465193*r**18+186773803*r**20
            -3620395*r**22-678510*r**24)+2*Q2**5*(-182525+1022549*r**2-2129110*r**4
            -133904188*r**6+182074025*r**8-1405616455*r**10-52111404*r**12-5142992712*r**14
            -7680651411*r**16+5954564575*r**18+260346690*r**20+673786340*r**22+32699047*r**24
            +659379*r**26)-Q2**4*(-199675+1861989*r**2+13825040*r**4-372087236*r**6
            +49064585*r**8-4574003935*r**10+3856760092*r**12+17237300160*r**14+5350472567*r**16
            +2665715495*r**18+17066338640*r**20+2302742724*r**22+1067888955*r**24
            +40622099*r**26+514500*r**28)+(-1+r**2)**3*(2345-165468*r**2-3653345*r**4
            +4213008*r**6-116202759*r**8-384811156*r**10+1936178071*r**12-9002208200*r**14
            +5223578419*r**16+4839613628*r**18-2105105963*r**20+1166707872*r**22
            +42596395*r**24+31322548*r**26+884981*r**28+9624*r**30)-4*Q2**3*(-5390
            +57565*r**2-1481049*r**4+19094588*r**6+9956016*r**8+621706335*r**10
            -206534955*r**12-375594042*r**14-5438779686*r**16+2053206763*r**18-2788047695*r**20
            -722150560*r**22-323084284*r**24-9797927*r**26+581971*r**28+40350*r**30)
            +Q2**2*(-55055+1539245*r**2+15613325*r**4-95302237*r**6+342362235*r**8
            -681654379*r**10-1576967699*r**12+1220656435*r**14+5906222589*r**16-25051915025*r**18
            +33063160223*r**20-20249429807*r**22+7212583665*r**24-456732977*r**26
            +336592615*r**28+13110361*r**30+216486*r**32)-2*Q2*(-9765+455763*r**2
            +6761482*r**4-33637268*r**6+210570022*r**8-223612708*r**10-922698382*r**12
            +4957142836*r**14-3481924164*r**16+868319106*r**18-13335320514*r**20
            +18273598100*r**22-8917783318*r**24+2604291932*r**26-95912378*r**28+86833612*r**30
            +2887769*r**32+37875*r**34))+116121600*logq2**4*r**16*(-120*Q2**8*r**2+30*Q2**7*(1
            +19*r**2+32*r**4)-6*Q2**6*(16+185*r**2+580*r**4+539*r**6)+Q2**5*(96
            +746*r**2+4710*r**4+8559*r**6+5649*r**8)-Q2**4*(30-227*r**2+2070*r**4
            +7575*r**6+10332*r**8+4620*r**10)+Q2**3*(300-1183*r**2+377*r**4+2005*r**6
            +4623*r**8+5928*r**10-210*r**12)+(-1+r**2)**3*(276-733*r**2+1478*r**4
            +68*r**6+408*r**8+567*r**10+636*r**12)+Q2**2*(-870+2062*r**2-1929*r**4
            +232*r**6-872*r**8+264*r**10-2457*r**12+3570*r**14)+Q2*(846-2753*r**2
            +6267*r**4-1059*r**6-2725*r**8+339*r**10-837*r**12+2553*r**14-2631*r**16))*sqrtq2
            -23040*logq2**2*r**8*(17784*Q2**16*r**2+Q2**15*(3794-228090*r**2-220464*r**4)
            +2*Q2**14*(-19348+603235*r**2+1242280*r**4+584985*r**6)-Q2**13*(-161392
            +3510693*r**2+11021025*r**4+11246565*r**6+3381525*r**8)+Q2**12*(-344610
            +6377158*r**2+24877288*r**4+36161994*r**6+26320090*r**8+5340720*r**10)
            -2*Q2**11*(-175714+4025628*r**2+14574915*r**4+17535548*r**6+17788630*r**8
            +14451490*r**10+1425711*r**12)-2*Q2**10*(623-4074082*r**2-6087799*r**4
            +29656463*r**6+72327853*r**8+42533018*r**10+2482155*r**12+2753289*r**14)
            +Q2**9*(-416738-7214585*r**2+10581615*r**4+194006545*r**6+530302165*r**8
            +621627557*r**10+295609325*r**12+56973755*r**14+12419385*r**16)-2*Q2**8*(
            -240618-2305983*r**2+8567535*r**4+110385905*r**6+337631775*r**8+542333997*r**10
            +477253097*r**12+162263775*r**14+33934035*r**16+4370850*r**18)+2*Q2**7*(
            -148155-345333*r**2+5152572*r**4+74179196*r**6+187569380*r**8+312695290*r**10
            +392796282*r**12+300471352*r**14+5384571*r**16+9966735*r**18-1329570*r**20)
            +2*Q2**6*(96782-853725*r**2-1989900*r**4-53921619*r**6-40865050*r**8
            +51623672*r**10+168720038*r**12+103662220*r**14+29028316*r**16+168571925*r**18
            +15228630*r**20+4675671*r**22)-2*(-1+r**2)**5*(-3164-11103*r**2-89740*r**4
            -847083*r**6+4386372*r**8-26946120*r**10+8717478*r**12+11164272*r**14
            +16072218*r**16-1880137*r**18+2850294*r**20+170635*r**22+24078*r**24)
            -Q2**5*(129220-1332817*r**2-1933321*r**4-97176197*r**6-2724337*r**8
            +177045446*r**10+633799238*r**12+900712830*r**14+557339898*r**16+292463243*r**18
            +331898435*r**20+35561735*r**22+6293427*r**24)+2*Q2**4*(-15533-63555*r**2
            -1122900*r**4-26013895*r**6+26380585*r**8+2686686*r**10+109147700*r**12
            +191309650*r**14+255788865*r**16+596185*r**18+117308032*r**20+33460965*r**22
            +6493155*r**24+127260*r**26)+Q2*(-1+r**2)**3*(-44758-71071*r**2-930244*r**4
            -4278036*r**6+35229978*r**8-174630171*r**10-44389080*r**12+105023856*r**14
            +103091310*r**16+197800267*r**18-40475876*r**20+38757796*r**22+2225358*r**24
            +418671*r**26)+2*Q2**3*(75936-157274*r**2+1432735*r**4+3316800*r**6
            -42815890*r**8+79571928*r**10-91851297*r**12-25981860*r**14+16607160*r**16
            -156749430*r**18+301644281*r**20-140885644*r**22+53762250*r**24+939880*r**26
            +1090425*r**28)-2*Q2**2*(61915-101904*r**2+1095291*r**4-1033257*r**6
            -34349315*r**8+161828710*r**10-165813027*r**12+16132113*r**14-50458611*r**16
            +120902060*r**18-318215715*r**20+366132081*r**22-146528229*r**24+48056318*r**26
            +1566155*r**28+725415*r**30))*sqrtq2+32*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(176*Q2**18*r**2+Q2**17*(2313-4999*r**2+222*r**4)+Q2**16*(-27831
            +41074*r**2+227095*r**4-12066*r**6)+Q2**15*(148287+138957*r**2-3606965*r**4
            -2021143*r**6+64288*r**8)+Q2**14*(-457500-1537255*r**2+16562010*r**4
            +29532198*r**6+7587314*r**8-155055*r**10)+Q2**13*(892965+3181345*r**2
            -38572892*r**4-96612480*r**6-86558453*r**8-12289601*r**10+163212*r**12)
            +Q2**12*(-1121754+2510493*r**2+65636338*r**4+53435771*r**6-58849194*r**8
            +48169567*r**10-1476334*r**12+56329*r**14)+Q2**11*(868143-20362963*r**2
            -107146983*r**4+232025547*r**6+1735903161*r**8+1560772827*r**10+295392063*r**12
            +38202749*r**14-363792*r**16)+Q2**10*(-362736+33936121*r**2+136023706*r**4
            -421664136*r**6-4431318318*r**8-8166770862*r**10-4119315954*r**12-693458816*r**14
            -54731402*r**16+364221*r**18)+Q2**9*(91575-21181645*r**2-77296790*r**4
            +303668354*r**6+4229784392*r**8+11266065120*r**10+13220439390*r**12+3032713870*r**14
            +364737889*r**16+7597997*r**18+17160*r**20)-Q2**8*(120780+6296423*r**2
            +33451296*r**4+358745175*r**6+1671351804*r**8-655367502*r**10-149730396*r**12
            +3599958426*r**14-4357629480*r**16-680886441*r**18-58743652*r**20+327327*r**22)
            +Q2**7*(128469+16259231*r**2+60774653*r**4+567877023*r**6+1514356458*r**8
            -10121742546*r**10-36902108478*r**12-31783864314*r**14-14018557167*r**16
            -9544669437*r**18-1116523663*r**20-58756885*r**22+233376*r**24)+Q2**6*(
            -3468-5459901*r**2-20002114*r**4-313283426*r**6-1803490402*r**8+3699693165*r**10
            +31771634460*r**12+70840959188*r**14+28834374240*r**16+17278746573*r**18
            +3985745574*r**20+303829262*r**22-335858*r**24+34307*r**26)-Q2**5*(79089
            +3801293*r**2-20924808*r**4+136772724*r**6+472726253*r**8-2165410791*r**10
            +7542644244*r**12+8767664080*r**14+61524304779*r**16-27783802209*r**18
            +7766490152*r**20-4860917892*r**22-582858537*r**24-36206533*r**26+130956*r**28)
            +Q2**4*(46050+3025775*r**2-36468370*r**4+184713573*r**6+1720749494*r**8
            -2484523765*r**10+14312128170*r**12-22733394815*r**14-34318487426*r**16
            +47977225677*r**18-59434307470*r**20+1161609215*r**22-5691358230*r**24
            -538582087*r**26-21826186*r**28+58395*r**30)-(-1+r**2)**3*(-837-3046*r**2
            +2845574*r**4+10677976*r**6-5786832*r**8+636089126*r**10+579280450*r**12
            -7565546468*r**14+35283444978*r**16-44760554106*r**18+19864115914*r**20
            -6192595232*r**22+385535744*r**24-183526854*r**26-13122962*r**28-406228*r**30
            +803*r**32)+Q2**3*(5565-136473*r**2+9291263*r**4-32128595*r**6-548907843*r**8
            +1583135399*r**10-13085842265*r**12+14953442869*r**14+10951896895*r**16
            +20239085981*r**18-13551566763*r**20+18835537199*r**22+2530346743*r**24
            +1021735125*r**26+60517637*r**28-1430801*r**30+10064*r**32)-Q2**2*(15528
            +414725*r**2-17784462*r**4+8798844*r**6+300967314*r**8-1337026464*r**10
            +2354495562*r**12+8126035036*r**14-31279960998*r**16+78431910642*r**18
            -107631524906*r**20+76903236756*r**22-29545361226*r**24+5188014504*r**26
            -1362453906*r**28-133036908*r**30-6758218*r**32+18177*r**34)+2*Q2*(3078
            +51520*r**2-6765674*r**4-1673415*r**6+97502733*r**8-1106398491*r**10
            +2806710273*r**12-4643078395*r**14+11143999493*r**16-55372148991*r**18
            +119279219273*r**20-111857961781*r**22+52742661687*r**24-14476213041*r**26
            +1848212883*r**28-416606985*r**30-36087887*r**32-1429493*r**34+3213*r**36))*sqrtq2))/(31352832000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+2177280000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+7560000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-181440000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            -126000*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
            -13063680000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(flagPERP*muWC*(20901888000*logq2**5*(
            -Q2+(-1+r)**2)*(-1+r)*r**20*(1+r)*(5+r**4)*(-Q2+(1+r)**2)+552960*logq2**3*(
            -Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)*(-29160*Q2**11*r**2+Q2**10*(4354
            +216102*r**2+267984*r**4)-10*Q2**9*(3325+66353*r**2+163515*r**4+101031*r**6)
            +5*Q2**8*(18963+217340*r**2+759570*r**4+987930*r**6+378117*r**8)-5*Q2**7*(24864
            +201663*r**2+802730*r**4+1573576*r**6+1433190*r**8+281385*r**10)+5*Q2**6*(10836
            +135835*r**2+305769*r**4+664530*r**6+1002386*r**8+802851*r**10-199647*r**12)
            +Q2**5*(49392-702149*r**2+20742*r**4+2409825*r**6+6538540*r**8+5080677*r**10
            +1895166*r**12+2901087*r**14)-5*Q2**4*(14070-140631*r**2-66595*r**4
            +290289*r**6+1571277*r**8+2923703*r**10+1719739*r**12+826455*r**14+397053*r**16)
            -5*Q2**3*(-3192+48245*r**2-12498*r**4+262078*r**6-423970*r**8-1226496*r**10
            -1986054*r**12-99470*r**14-580110*r**16+43227*r**18)+(-1+r**2)**3*(
            -4879+17066*r**2+337776*r**4-1881054*r**6+1045786*r**8+195594*r**10
            +1135624*r**12+1267014*r**14+52269*r**16+102804*r**18)+5*Q2**2*(4914
            -29617*r**2-196389*r**4+563052*r**6-402136*r**8-205254*r**10-130662*r**12
            -807604*r**14+1345806*r**16-351585*r**18+209475*r**20)-5*Q2*(4046-27807*r**2
            -178360*r**4+925373*r**6-1352916*r**8+189098*r**10+333536*r**12-3990*r**14
            -887338*r**16+1081941*r**18-196344*r**20+112761*r**22))+384*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-4656*Q2**17*r**2+4*Q2**16*(-4025+29301*r**2
            +13560*r**4)-4*Q2**15*(-33915+173959*r**2+332147*r**4+64161*r**6)+Q2**14*(
            -463925+2049671*r**2+6780185*r**4+5508151*r**6+601950*r**8)-2*Q2**13*(
            -374605+2243625*r**2+6002282*r**4+1678596*r**6+4164467*r**8+276675*r**10)
            -Q2**12*(298655-9872017*r**2-2600340*r**4+146601032*r**6+135666425*r**8
            +8729489*r**10+584052*r**12)+4*Q2**11*(-231280-4659131*r**2+2991439*r**4
            +147236034*r**6+289270594*r**8+139608749*r**10+12919151*r**12+520380*r**14)
            -Q2**10*(-1544235-22194735*r**2+9501973*r**4+953067611*r**6+2846105125*r**8
            +3021455135*r**10+859028971*r**12+68523365*r**14+1745238*r**16)+Q2**9*(
            -558250-11591682*r**2+26946580*r**4+769013688*r**6+2263830160*r**8+3499116540*r**10
            +2824648828*r**12+91724120*r**14+146698*r**16-813450*r**18)+Q2**8*(-818895
            -3654615*r**2-84100182*r**4-491668006*r**6+890470948*r**8+5610996100*r**10
            +4947223110*r**12+1819512278*r**14+1493478459*r**16+96097443*r**18+2640000*r**20)
            -4*Q2**7*(-230615-1918911*r**2-22686315*r**4-129886211*r**6+464456190*r**8
            +3445614778*r**10+6608535690*r**12+3972723470*r**14+1558621729*r**16
            +462231085*r**18+23413593*r**20+383757*r**22)+Q2**6*(-88935-3591779*r**2
            -25238257*r**4-273258847*r**6+199821868*r**8+8083222218*r**10+24872273910*r**12
            +34287250778*r**14+8836672153*r**16+4414465193*r**18+186773803*r**20
            -3620395*r**22-678510*r**24)+2*Q2**5*(-182525+1022549*r**2-2129110*r**4
            -133904188*r**6+182074025*r**8-1405616455*r**10-52111404*r**12-5142992712*r**14
            -7680651411*r**16+5954564575*r**18+260346690*r**20+673786340*r**22+32699047*r**24
            +659379*r**26)-Q2**4*(-199675+1861989*r**2+13825040*r**4-372087236*r**6
            +49064585*r**8-4574003935*r**10+3856760092*r**12+17237300160*r**14+5350472567*r**16
            +2665715495*r**18+17066338640*r**20+2302742724*r**22+1067888955*r**24
            +40622099*r**26+514500*r**28)+(-1+r**2)**3*(2345-165468*r**2-3653345*r**4
            +4213008*r**6-116202759*r**8-384811156*r**10+1936178071*r**12-9002208200*r**14
            +5223578419*r**16+4839613628*r**18-2105105963*r**20+1166707872*r**22
            +42596395*r**24+31322548*r**26+884981*r**28+9624*r**30)-4*Q2**3*(-5390
            +57565*r**2-1481049*r**4+19094588*r**6+9956016*r**8+621706335*r**10
            -206534955*r**12-375594042*r**14-5438779686*r**16+2053206763*r**18-2788047695*r**20
            -722150560*r**22-323084284*r**24-9797927*r**26+581971*r**28+40350*r**30)
            +Q2**2*(-55055+1539245*r**2+15613325*r**4-95302237*r**6+342362235*r**8
            -681654379*r**10-1576967699*r**12+1220656435*r**14+5906222589*r**16-25051915025*r**18
            +33063160223*r**20-20249429807*r**22+7212583665*r**24-456732977*r**26
            +336592615*r**28+13110361*r**30+216486*r**32)-2*Q2*(-9765+455763*r**2
            +6761482*r**4-33637268*r**6+210570022*r**8-223612708*r**10-922698382*r**12
            +4957142836*r**14-3481924164*r**16+868319106*r**18-13335320514*r**20
            +18273598100*r**22-8917783318*r**24+2604291932*r**26-95912378*r**28+86833612*r**30
            +2887769*r**32+37875*r**34))+232243200*logq2**4*r**16*(-120*Q2**8*r**2+30*Q2**7*(1
            +19*r**2+32*r**4)-6*Q2**6*(16+185*r**2+580*r**4+539*r**6)+Q2**5*(96
            +746*r**2+4710*r**4+8559*r**6+5649*r**8)-Q2**4*(30-227*r**2+2070*r**4
            +7575*r**6+10332*r**8+4620*r**10)+Q2**3*(300-1183*r**2+377*r**4+2005*r**6
            +4623*r**8+5928*r**10-210*r**12)+(-1+r**2)**3*(276-733*r**2+1478*r**4
            +68*r**6+408*r**8+567*r**10+636*r**12)+Q2**2*(-870+2062*r**2-1929*r**4
            +232*r**6-872*r**8+264*r**10-2457*r**12+3570*r**14)+Q2*(846-2753*r**2
            +6267*r**4-1059*r**6-2725*r**8+339*r**10-837*r**12+2553*r**14-2631*r**16))*sqrtq2
            -46080*logq2**2*r**8*(17784*Q2**16*r**2+Q2**15*(3794-228090*r**2-220464*r**4)
            +2*Q2**14*(-19348+603235*r**2+1242280*r**4+584985*r**6)-Q2**13*(-161392
            +3510693*r**2+11021025*r**4+11246565*r**6+3381525*r**8)+Q2**12*(-344610
            +6377158*r**2+24877288*r**4+36161994*r**6+26320090*r**8+5340720*r**10)
            -2*Q2**11*(-175714+4025628*r**2+14574915*r**4+17535548*r**6+17788630*r**8
            +14451490*r**10+1425711*r**12)-2*Q2**10*(623-4074082*r**2-6087799*r**4
            +29656463*r**6+72327853*r**8+42533018*r**10+2482155*r**12+2753289*r**14)
            +Q2**9*(-416738-7214585*r**2+10581615*r**4+194006545*r**6+530302165*r**8
            +621627557*r**10+295609325*r**12+56973755*r**14+12419385*r**16)-2*Q2**8*(
            -240618-2305983*r**2+8567535*r**4+110385905*r**6+337631775*r**8+542333997*r**10
            +477253097*r**12+162263775*r**14+33934035*r**16+4370850*r**18)+2*Q2**7*(
            -148155-345333*r**2+5152572*r**4+74179196*r**6+187569380*r**8+312695290*r**10
            +392796282*r**12+300471352*r**14+5384571*r**16+9966735*r**18-1329570*r**20)
            +2*Q2**6*(96782-853725*r**2-1989900*r**4-53921619*r**6-40865050*r**8
            +51623672*r**10+168720038*r**12+103662220*r**14+29028316*r**16+168571925*r**18
            +15228630*r**20+4675671*r**22)-2*(-1+r**2)**5*(-3164-11103*r**2-89740*r**4
            -847083*r**6+4386372*r**8-26946120*r**10+8717478*r**12+11164272*r**14
            +16072218*r**16-1880137*r**18+2850294*r**20+170635*r**22+24078*r**24)
            -Q2**5*(129220-1332817*r**2-1933321*r**4-97176197*r**6-2724337*r**8
            +177045446*r**10+633799238*r**12+900712830*r**14+557339898*r**16+292463243*r**18
            +331898435*r**20+35561735*r**22+6293427*r**24)+2*Q2**4*(-15533-63555*r**2
            -1122900*r**4-26013895*r**6+26380585*r**8+2686686*r**10+109147700*r**12
            +191309650*r**14+255788865*r**16+596185*r**18+117308032*r**20+33460965*r**22
            +6493155*r**24+127260*r**26)+Q2*(-1+r**2)**3*(-44758-71071*r**2-930244*r**4
            -4278036*r**6+35229978*r**8-174630171*r**10-44389080*r**12+105023856*r**14
            +103091310*r**16+197800267*r**18-40475876*r**20+38757796*r**22+2225358*r**24
            +418671*r**26)+2*Q2**3*(75936-157274*r**2+1432735*r**4+3316800*r**6
            -42815890*r**8+79571928*r**10-91851297*r**12-25981860*r**14+16607160*r**16
            -156749430*r**18+301644281*r**20-140885644*r**22+53762250*r**24+939880*r**26
            +1090425*r**28)-2*Q2**2*(61915-101904*r**2+1095291*r**4-1033257*r**6
            -34349315*r**8+161828710*r**10-165813027*r**12+16132113*r**14-50458611*r**16
            +120902060*r**18-318215715*r**20+366132081*r**22-146528229*r**24+48056318*r**26
            +1566155*r**28+725415*r**30))*sqrtq2+64*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(176*Q2**18*r**2+Q2**17*(2313-4999*r**2+222*r**4)+Q2**16*(-27831
            +41074*r**2+227095*r**4-12066*r**6)+Q2**15*(148287+138957*r**2-3606965*r**4
            -2021143*r**6+64288*r**8)+Q2**14*(-457500-1537255*r**2+16562010*r**4
            +29532198*r**6+7587314*r**8-155055*r**10)+Q2**13*(892965+3181345*r**2
            -38572892*r**4-96612480*r**6-86558453*r**8-12289601*r**10+163212*r**12)
            +Q2**12*(-1121754+2510493*r**2+65636338*r**4+53435771*r**6-58849194*r**8
            +48169567*r**10-1476334*r**12+56329*r**14)+Q2**11*(868143-20362963*r**2
            -107146983*r**4+232025547*r**6+1735903161*r**8+1560772827*r**10+295392063*r**12
            +38202749*r**14-363792*r**16)+Q2**10*(-362736+33936121*r**2+136023706*r**4
            -421664136*r**6-4431318318*r**8-8166770862*r**10-4119315954*r**12-693458816*r**14
            -54731402*r**16+364221*r**18)+Q2**9*(91575-21181645*r**2-77296790*r**4
            +303668354*r**6+4229784392*r**8+11266065120*r**10+13220439390*r**12+3032713870*r**14
            +364737889*r**16+7597997*r**18+17160*r**20)-Q2**8*(120780+6296423*r**2
            +33451296*r**4+358745175*r**6+1671351804*r**8-655367502*r**10-149730396*r**12
            +3599958426*r**14-4357629480*r**16-680886441*r**18-58743652*r**20+327327*r**22)
            +Q2**7*(128469+16259231*r**2+60774653*r**4+567877023*r**6+1514356458*r**8
            -10121742546*r**10-36902108478*r**12-31783864314*r**14-14018557167*r**16
            -9544669437*r**18-1116523663*r**20-58756885*r**22+233376*r**24)+Q2**6*(
            -3468-5459901*r**2-20002114*r**4-313283426*r**6-1803490402*r**8+3699693165*r**10
            +31771634460*r**12+70840959188*r**14+28834374240*r**16+17278746573*r**18
            +3985745574*r**20+303829262*r**22-335858*r**24+34307*r**26)-Q2**5*(79089
            +3801293*r**2-20924808*r**4+136772724*r**6+472726253*r**8-2165410791*r**10
            +7542644244*r**12+8767664080*r**14+61524304779*r**16-27783802209*r**18
            +7766490152*r**20-4860917892*r**22-582858537*r**24-36206533*r**26+130956*r**28)
            +Q2**4*(46050+3025775*r**2-36468370*r**4+184713573*r**6+1720749494*r**8
            -2484523765*r**10+14312128170*r**12-22733394815*r**14-34318487426*r**16
            +47977225677*r**18-59434307470*r**20+1161609215*r**22-5691358230*r**24
            -538582087*r**26-21826186*r**28+58395*r**30)-(-1+r**2)**3*(-837-3046*r**2
            +2845574*r**4+10677976*r**6-5786832*r**8+636089126*r**10+579280450*r**12
            -7565546468*r**14+35283444978*r**16-44760554106*r**18+19864115914*r**20
            -6192595232*r**22+385535744*r**24-183526854*r**26-13122962*r**28-406228*r**30
            +803*r**32)+Q2**3*(5565-136473*r**2+9291263*r**4-32128595*r**6-548907843*r**8
            +1583135399*r**10-13085842265*r**12+14953442869*r**14+10951896895*r**16
            +20239085981*r**18-13551566763*r**20+18835537199*r**22+2530346743*r**24
            +1021735125*r**26+60517637*r**28-1430801*r**30+10064*r**32)-Q2**2*(15528
            +414725*r**2-17784462*r**4+8798844*r**6+300967314*r**8-1337026464*r**10
            +2354495562*r**12+8126035036*r**14-31279960998*r**16+78431910642*r**18
            -107631524906*r**20+76903236756*r**22-29545361226*r**24+5188014504*r**26
            -1362453906*r**28-133036908*r**30-6758218*r**32+18177*r**34)+2*Q2*(3078
            +51520*r**2-6765674*r**4-1673415*r**6+97502733*r**8-1106398491*r**10
            +2806710273*r**12-4643078395*r**14+11143999493*r**16-55372148991*r**18
            +119279219273*r**20-111857961781*r**22+52742661687*r**24-14476213041*r**26
            +1848212883*r**28-416606985*r**30-36087887*r**32-1429493*r**34+3213*r**36))*sqrtq2))/(23514624000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+1632960000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+5670000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-136080000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            -94500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
            -9797760000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(flagPERP*(-10450944000*logq2**5*(
            -Q2+(-1+r)**2)*r**20*(-1+r**4+2*r**6)*(-Q2+(1+r)**2)-276480*logq2**3*(
            -Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)*(12240*Q2**11*r**2-2*Q2**10*(805
            +53106*r**2+45816*r**4)+10*Q2**9*(1015+39116*r**2+64725*r**4+27132*r**6)
            -5*Q2**8*(4620+150673*r**2+364785*r**4+298335*r**6+77877*r**8)+5*Q2**7*(3570
            +143209*r**2+480963*r**4+586151*r**6+308835*r**8+55800*r**10)-5*Q2**6*(
            -2520+22750*r**2+177459*r**4+380766*r**6+352988*r**8+139020*r**10+40257*r**12)
            +Q2**5*(-30030-407771*r**2-1498101*r**4-1336650*r**6-303620*r**8+778485*r**10
            +466599*r**12+375984*r**14)-5*Q2**4*(-2520-74608*r**2-394287*r**4-513900*r**6
            -387451*r**8+134208*r**10+299623*r**12+180180*r**14+70299*r**16)-5*Q2**3*(
            -1470+28837*r**2+81273*r**4+304061*r**6+153637*r**8-187209*r**10-459837*r**12
            -4249*r**14-165315*r**16+20448*r**18)+(-1+r**2)**2*(140+9813*r**2-202046*r**4
            +926700*r**6-769394*r**8+310202*r**10-49598*r**12-371164*r**14+840390*r**16
            +4209*r**18+56748*r**20)+5*Q2**2*(-1470+12026*r**2-181791*r**4+424860*r**6
            -318268*r**8-74112*r**10-111870*r**12-397228*r**14+616338*r**16-99210*r**18
            +80325*r**20)-5*Q2*(-280+7373*r**2-162861*r**4+598484*r**6-681340*r**8
            +216198*r**10+315794*r**12+314324*r**14-592836*r**16+600693*r**18-62925*r**20
            +52176*r**22))+192*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -9312*Q2**17*r**2+4*Q2**16*(-805+31950*r**2+31368*r**4)-4*Q2**15*(-6685
            +161502*r**2+404131*r**4+169116*r**6)+Q2**14*(-86205+1568566*r**2+7173691*r**4
            +7409140*r**6+1895670*r**8)-2*Q2**13*(-55335+877182*r**2+6391588*r**4
            +7546174*r**6+7529917*r**8+1386990*r**10)+Q2**12*(55545+325312*r**2
            +892928*r**4-68024936*r**6-55484733*r**8+7582332*r**10+1205856*r**12)
            +4*Q2**11*(-88830+138939*r**2+7316008*r**4+90026929*r**6+162887050*r**8
            +76015549*r**10+6217412*r**12+641391*r**14)-Q2**10*(-367675-1123030*r**2
            +36823099*r**4+594075420*r**6+1792409349*r**8+1705822874*r**10+526212217*r**12
            +49659184*r**14+4273698*r**16)+2*Q2**9*(51205-825816*r**2+4872884*r**4
            +96431950*r**6+833807240*r**8+1312272220*r**10+895413124*r**12+152528314*r**14
            +14089355*r**16+642180*r**18)+Q2**8*(-523215-2287872*r**2-5690958*r**4
            +626144376*r**6+913254048*r**8+1261991140*r**10+202088558*r**12-313915968*r**14
            +199085991*r**16+14213508*r**18+2551560*r**20)-4*Q2**7*(-88165-1312728*r**2
            -7969281*r**4+197575162*r**6+740554886*r**8+1732027876*r**10+2057652454*r**12
            +790695704*r**14+170255247*r**16+87188276*r**18+6605931*r**20+630894*r**22)
            +Q2**6*(117425-1964862*r**2-15376235*r**4+107758348*r**6+1798025460*r**8
            +5044647308*r**10+10384226762*r**12+8058157568*r**14+1879903593*r**16
            +424735010*r**18+152762433*r**20+12860644*r**22-69294*r**24)+2*Q2**5*(
            -143535-1355918*r**2-18809060*r**4+209996206*r**6+78374599*r**8+662949094*r**10
            -177607368*r**12-2139634132*r**14-1113700217*r**16-581191826*r**18-260611316*r**20
            -44953946*r**22-2255135*r**24+650394*r**26)+Q2**4*(123795+2844816*r**2
            +44458316*r**4-296284040*r**6-471841525*r**8-2272449820*r**10-6261334512*r**12
            -1755882032*r**14+1136786505*r**16+924153720*r**18+2563155940*r**20+818410136*r**22
            +118116281*r**24+2390900*r**26-629280*r**28)-4*Q2**3*(-7980+107941*r**2
            +1499054*r**4+2511507*r**6-55651184*r**8-21011415*r**10-810178302*r**12
            +57571407*r**14+221197076*r**16+46474703*r**18+579675250*r**20+243457961*r**22
            +84712264*r**24+3269667*r**26-455394*r**28+30645*r**30)+(-1+r**2)**2*(
            -2345-65626*r**2-1854889*r**4+5984320*r**6-47439045*r**8-275719454*r**10
            +1938692851*r**12-6012321852*r**14+4658322525*r**16+2971961450*r**18
            -4803909227*r**20+1599597976*r**22-516519559*r**24-47590770*r**26-13103455*r**28
            -362524*r**30+9624*r**32)+Q2**2*(-49455-643662*r**2-15312277*r**4+103829084*r**6
            -285839973*r**8-52386658*r**10+2229257831*r**12-3134616736*r**14+1959850417*r**16
            +6026543886*r**18-9059347279*r**20+5204165324*r**22-1817549687*r**24
            -163304926*r**26-83714563*r**28-3897608*r**30+216282*r**32)+2*Q2*(8995
            +183028*r**2+4702628*r**4-26616782*r**6+116212870*r**8+241815308*r**10
            -2486307572*r**12+6566587018*r**14-5601093876*r**16+4012394060*r**18
            -7740793636*r**20+8223996790*r**22-3180020950*r**24+857273108*r**26+69788020*r**28
            +29502158*r**30+1047329*r**32-38496*r**34))-16588800*logq2**4*r**16*(240*Q2**8*r**2
            -30*Q2**7*(7+50*r**2+36*r**4)+6*Q2**6*(266+735*r**2+837*r**4+140*r**6)
            +Q2**5*(-4431-8071*r**2-9867*r**4-2727*r**6+3255*r**8)+Q2**4*(5145
            +8463*r**2+10265*r**4+3621*r**6-7935*r**8-5985*r**10)-Q2**3*(840+6167*r**2
            +3532*r**4+304*r**6-7221*r**8-10755*r**10+1995*r**12)+(-1+r**2)**2*(
            -819+3026*r**2-3897*r**4-222*r**6+6253*r**8-138*r**10-1083*r**12+3180*r**14)
            +Q2**2*(-3570+9163*r**2-7256*r**4-1146*r**6+823*r**8-1104*r**10-7515*r**12
            +12705*r**14)+Q2*(3129-11202*r**2+16166*r**4+1809*r**6-13731*r**8
            -16370*r**10-5184*r**12+11343*r**14-11160*r**16))*sqrtq2-4608*logq2**2*r**8*(57168*Q2**16*r**2
            -2*Q2**15*(-5845+367914*r**2+345684*r**4)+2*Q2**14*(-60410+1977755*r**2
            +3847837*r**4+1805820*r**6)-Q2**13*(-518455+11477745*r**2+34954556*r**4
            +33573901*r**6+10536375*r**8)+Q2**12*(-1127245+18705305*r**2+81383504*r**4
            +115278232*r**6+77963459*r**8+18219765*r**10)-Q2**11*(-1014580+13797569*r**2
            +91024971*r**4+147290736*r**6+158596776*r**8+99085571*r**10+17166369*r**12)
            +Q2**10*(795410-6200271*r**2+558208*r**4-111856145*r**6-149321880*r**8
            +4964085*r**10+55689058*r**12+3326439*r**14)+Q2**9*(-3084235+22994780*r**2
            +131965177*r**4+604029700*r**6+1079140925*r**8+848095140*r**10+253919035*r**12
            +13668052*r**14+11837370*r**16)-Q2**8*(-2890965+17705610*r**2+160097138*r**4
            +762087708*r**6+1647095240*r**8+1876140160*r**10+1144132650*r**12+322631448*r**14
            +40802073*r**16+14798250*r**18)+2*Q2**7*(91245-993555*r**2+31303271*r**4
            +158436418*r**6+400757286*r**8+628835220*r**10+646730610*r**12+378414966*r**14
            +125102193*r**16+19586391*r**18+4069035*r**20)-2*Q2**6*(1350580-6684492*r**2
            -14780171*r**4-90271141*r**6-248522356*r**8-243999466*r**10+403562*r**12
            +272798404*r**14+244216284*r**16+141574594*r**18+24874029*r**20+1273533*r**22)
            +Q2**5*(2217985-9060649*r**2-41186662*r**4-249628665*r**6-756356125*r**8
            -947143370*r**10-614776364*r**12+124696566*r**14+472413935*r**16+492953875*r**18
            +271044530*r**20+47995843*r**22+401901*r**24)+(-1+r**2)**4*(19915-39592*r**2
            +357464*r**4+6433228*r**6-38999325*r**8+134836920*r**10-60268716*r**12
            -61967028*r**14-45600531*r**16+115400300*r**18-20550860*r**20+14446408*r**22
            +1214789*r**24+77028*r**26)+Q2**4*(-286195-21915*r**2+19524024*r**4
            +110953260*r**6+200345175*r**8+409387415*r**10-70845440*r**12-314499048*r**14
            -472823125*r**16+121791875*r**18-394822920*r**20-25896820*r**22-12836351*r**24
            +1226865*r**26)+Q2**3*(-696920+3897355*r**2-10185931*r**4-58507916*r**6
            +299251940*r**8-595755285*r**10+456783225*r**12+316067952*r**14+80680992*r**16
            +491937185*r**18-1168768945*r**20+404633020*r**22-199420396*r**24-17716151*r**26
            -2200125*r**28)-Q2*(-1+r**2)**2*(164045-570452*r**2+2279922*r**4+31431742*r**6
            -204063877*r**8+587490210*r**10-180960636*r**12-133773324*r**14-82820229*r**16
            -242011256*r**18+635536970*r**20-142928562*r**22+84802877*r**24+7745962*r**26
            +556608*r**28)+Q2**2*(529130-2771695*r**2+7796704*r**4+53272407*r**6
            -435592656*r**8+1190874175*r**10-952364130*r**12+292056957*r**14+118660386*r**16
            +508424047*r**18-1312177820*r**20+1534052225*r**22-481728636*r**24+185089857*r**26
            +18039134*r**28+1599915*r**30))*sqrtq2-32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(176*Q2**18+Q2**17*(2535+1676*r**2)-Q2**16*(32913+364661*r**2
            +31652*r**4)+Q2**15*(68917+3787700*r**2+3771553*r**4+177696*r**6)-Q2**14*(
            -186186+14930971*r**2+33942285*r**4+15925827*r**6+525835*r**8)+Q2**13*(
            -732732+26050717*r**2+105692368*r**4+111027624*r**6+32799280*r**8+907327*r**10)
            -Q2**12*(324509+9485791*r**2+95086832*r**4+107830116*r**6+132834703*r**8
            +25415813*r**10+849708*r**12)+Q2**11*(4735695-35935918*r**2-174035451*r**4
            -860194842*r**6-730239207*r**8-78154746*r**10-25696893*r**12+186626*r**14)
            +Q2**10*(-7878420+51117673*r**2+455427703*r**4+2689270611*r**6+4581253617*r**8
            +2298868719*r**10+369632889*r**12+71295877*r**14+445027*r**16)-Q2**9*(
            -2284128+6347953*r**2+273545720*r**4+2278224806*r**6+7588991340*r**8
            +7470882852*r**10+2238303088*r**12+320261170*r**14+42657116*r**16+366355*r**18)
            +Q2**8*(7905711-29243549*r**2-120166776*r**4-1776146298*r**6+1548013800*r**8
            +4035751620*r**10+3769240026*r**12-219460086*r**14+2011977*r**16-29382855*r**18
            -121682*r**20)+Q2**7*(-9312237+5292944*r**2+126690299*r**4+4437162732*r**6
            +7584211446*r**8+12328513824*r**10+7299356238*r**12+1118301864*r**14
            +1733839047*r**16+122705136*r**18+50863751*r**20+262988*r**22)-Q2**6*(
            -631274-24250639*r**2-17896433*r**4+1874113581*r**6+6883024941*r**8
            +15156693138*r**10+20234085838*r**12+7332891090*r**14+985613736*r**16
            +858975661*r**18+78073619*r**20+12183601*r**22+6021*r**24)+Q2**5*(5624664
            -13151621*r**2+112252680*r**4-1821627060*r**6+1866941356*r**8-2250779013*r**10
            +7611706416*r**12+8755730960*r**14+1615778544*r**16+1282968081*r**18
            +175004776*r**20+126163332*r**22-18061908*r**24-163367*r**26)+Q2**4*(
            -3753939-7632901*r**2-209951320*r**4+2113533408*r**6-1413307675*r**8
            +10066028003*r**10+6957706272*r**12-699243080*r**14-1370609321*r**16
            -3452772735*r**18-2930899984*r**20-412158616*r**22-139818345*r**24+12844193*r**26
            +90440*r**28)+Q2**3*(-105655+8863882*r**2+44640383*r**4-316660626*r**6
            +585467545*r**8-2566777246*r**10-5087246889*r**12+3816175574*r**14-720240173*r**16
            +2043625630*r**18+2367671797*r**20+1524887882*r**22+224304843*r**24+13040374*r**26
            +118325*r**28+13554*r**30)+Q2**2*(1128336-2016029*r**2+92595333*r**4
            -654708291*r**6+2153606607*r**8-3252444525*r**10+1274435037*r**12-2290651051*r**14
            -7064801553*r**16+16654038801*r**18-12936995113*r**20+3971069823*r**22
            +275119893*r**24+186126969*r**26+72474567*r**28-3043473*r**30-31331*r**32)
            -2*(-1+r**2)**2*(-36857-161613*r**2-6810851*r**4+35146072*r**6-233476106*r**8
            -16624739*r**10+3287333199*r**12-13455588938*r**14+20748902706*r**16
            -14279266723*r**18+4617951579*r**20-955820164*r**22-34667986*r**24-29099053*r**26
            -4448071*r**28+74742*r**30+803*r**32)+Q2*(-500931-431635*r**2-65255680*r**4
            +451471698*r**6-2224528152*r**8+3042024930*r**10+6513831000*r**12-23634794558*r**14
            -2182533326*r**16+57386238084*r**18-60936658352*r**20+24714711430*r**22
            -5251155984*r**24-197165922*r**26-182264232*r**28-46919322*r**30+1182905*r**32
            +12047*r**34))*sqrtq2)*math.log(mu0))/(5225472000*logq2**5*r**22*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))+362880000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+1260000*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-30240000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-21000*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2-2177280000*logq2**4*r**18*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+FLAGcs*flagPERP*((-117936000*logq2**4*r**14*(3-5*r**2
            +3*r**4+3*r**6)-4680*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(
            -1561+9259*r**2-4320*Q2**9*r**2+17902*r**4-417650*r**6+974908*r**8-198572*r**10
            +237346*r**12-321422*r**14+301405*r**16-10303*r**18+13488*r**20+56*Q2**8*(
            -1+561*r**2+558*r**4)-8*Q2**7*(-231+10905*r**2+23479*r**4+10443*r**6)
            +Q2**6*(-5173+95073*r**2+395461*r**4+410123*r**6+81564*r**8)+2*Q2**5*(833
            +2838*r**2-132894*r**4-264396*r**6-165291*r**8+20286*r**10)-Q2**4*(
            -8505+92765*r**2+183856*r**4+124504*r**6+99137*r**8+84875*r**10+145320*r**12)
            +2*Q2**3*(-4382+27037*r**2+165883*r**4+368170*r**6+507632*r**8+336617*r**10
            +152467*r**12+40656*r**14)+Q2**2*(-1043+19425*r**2-81059*r**4-460371*r**6
            -705957*r**8-1240669*r**10-142657*r**12-186753*r**14+33804*r**16)+Q2*(4578
            -30598*r**2-57842*r**4+265818*r**6-581026*r**8+372202*r**10+735618*r**12
            -512218*r**14+53872*r**16-48804*r**18))+13*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(279+51832*r**2+176*Q2**13*r**2-369279*r**4+4247926*r**6-14274463*r**8
            +27526342*r**10+129617771*r**12-553885372*r**14+660388553*r**16-367966084*r**18
            +98308279*r**20-19691578*r**22-449*r**24-240954*r**26-803*r**28+Q2**12*(
            -771+3063*r**2+750*r**4)-164*Q2**11*(-33+128*r**2+1019*r**4+62*r**6)
            +Q2**10*(-15111-9033*r**2+1230491*r**4+1032041*r**6+31932*r**8)-5*Q2**9*(
            -3879-36553*r**2+548994*r**4+1328318*r**6+448293*r**8+7979*r**10)+3*Q2**8*(
            -1965-51364*r**2+421575*r**4+3601030*r**6+3697755*r**8+297990*r**10
            +691*r**12)+2*Q2**7*(-6534-250623*r**2+1616565*r**4+1573020*r**6+4328420*r**8
            +225321*r**10+1865997*r**12+23610*r**14)-6*Q2**6*(-2121-155674*r**2
            +639433*r**4+3196174*r**6+14532525*r**8+12173384*r**10+3212001*r**12
            +870548*r**14+6754*r**16)+2*Q2**5*(1341-77562*r**2-628581*r**4+4567029*r**6
            +42074003*r**8+109470491*r**10+33108893*r**12+7934379*r**14+18744*r**16
            -3777*r**18)+5*Q2**4*(-1809-150223*r**2+876924*r**4+169908*r**6+7909498*r**8
            -20693230*r**10-36952648*r**12+12121444*r**14+636303*r**16+858453*r**18
            +5444*r**20)-2*Q2**3*(-1560-259383*r**2+945675*r**4-2691330*r**6+34366420*r**8
            +42739050*r**10+22169566*r**12-21456000*r**14+54405220*r**16+4550445*r**18
            +1210935*r**20+4962*r**22)+Q2**2*(1689+97333*r**2-1232405*r**4-268865*r**6
            -2372290*r**8+41581502*r**10+204873794*r**12-9518230*r**14+80995985*r**16
            +10862285*r**18+3461779*r**20-676457*r**22-4520*r**24)+Q2*(-1413-196377*r**2
            +1385164*r**4-8497688*r**6+31338675*r**8-29081629*r**10+114936104*r**12
            -332908368*r**14+324732521*r**16-173777275*r**18+47143692*r**20-249752*r**22
            +980329*r**24+4017*r**26))-280800*logq2**3*r**10*(301-1584*r**2-240*Q2**6*r**2
            +5717*r**4-6176*r**6+8279*r**8-72*r**10-1017*r**12+1272*r**14+20*Q2**5*(7
            +51*r**2+72*r**4)-4*Q2**4*(196+445*r**2+1206*r**4+837*r**6)+Q2**3*(1001
            +2581*r**2+5141*r**4+8403*r**6+3162*r**8)+Q2**2*(91-2396*r**2-1418*r**4
            -5364*r**6-6801*r**8+432*r**10)+Q2*(-749+2609*r**2-3480*r**4-158*r**6
            +3027*r**8+2589*r**10-2718*r**12))*sqrtq2+78*logq2*r**2*(175*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(8+581*r**2+120*Q2**6*r**2+3050*r**4+5739*r**6
            +17844*r**8+12711*r**10+978*r**12-351*r**14-20*Q2**5*(1+15*r**2+18*r**4)
            -2*Q2**4*(16+121*r**2+138*r**4+153*r**6)+Q2**3*(88+271*r**2-53*r**4
            -177*r**6+459*r**8)+Q2**2*(8+525*r**2+1434*r**4+2118*r**6+1530*r**8
            +489*r**10)+Q2*(-52+725*r**2+1053*r**4+930*r**6+2430*r**8+1725*r**10
            -51*r**12))-(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(-945+77289*r**2+16344*Q2**12*r**2
            -1068248*r**4-2287556*r**6+19762515*r**8+1063925*r**10+325341152*r**12
            +351047496*r**14+300436157*r**16+86127035*r**18-35764680*r**20+471484*r**22
            +1150177*r**24-51801*r**26-24*Q2**11*(280+1857*r**2+2697*r**4)-2*Q2**10*(
            -9240+56013*r**2+91034*r**4+37533*r**6)+5*Q2**9*(315+90324*r**2+206344*r**4
            +187534*r**6+97119*r**8)-15*Q2**8*(2695+9843*r**2-5640*r**4-127074*r**6
            -9315*r**8+15723*r**10)-6*Q2**7*(-2450+63908*r**2+329295*r**4+2057255*r**6
            +1851205*r**8+280595*r**10+130908*r**12)+6*Q2**6*(6090-42119*r**2-42954*r**4
            +3218410*r**6+7796650*r**8+2824075*r**10-56574*r**12+106526*r**14)+6*Q2**5*(
            -2485+70202*r**2-57689*r**4-2695313*r**6-13862440*r**8-15042650*r**10
            -2436943*r**12-13139*r**14+93057*r**16)-10*Q2**4*(1995-52698*r**2-36468*r**4
            +1087647*r**6-377658*r**8-4864267*r**10-2008608*r**12+1907937*r**14
            -177333*r**16+53037*r**18)-10*Q2**3*(-630+31188*r**2-231525*r**4-1908369*r**6
            -5477115*r**8-3551839*r**10+1392701*r**12-4061955*r**14-3776739*r**16
            -202185*r**18+24468*r**20)+6*Q2**2*(1050-50966*r**2+195820*r**4+2367055*r**6
            +5253880*r**8+13578290*r**10+18742992*r**12+25988540*r**14+3090630*r**16
            +343580*r**18-415780*r**20+36909*r**22)+Q2*(-945+64632*r**2-1076498*r**4
            +5130240*r**6+27091125*r**8+89598500*r**10+99449856*r**12+205945476*r**14
            +62581685*r**16+50756100*r**18-15255630*r**20-1199588*r**22+67047*r**24)))*sqrtq2)/(163296000*logq2**4*r**16
            +6804000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+7875*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-54432000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-378000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((-9072000*logq2**4*r**14*(3-5*r**2+3*r**4+3*r**6)-360*logq2**2*(-Q2
            +(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(-1561+9259*r**2-4320*Q2**9*r**2+17902*r**4
            -417650*r**6+974908*r**8-198572*r**10+237346*r**12-321422*r**14+301405*r**16
            -10303*r**18+13488*r**20+56*Q2**8*(-1+561*r**2+558*r**4)-8*Q2**7*(-231
            +10905*r**2+23479*r**4+10443*r**6)+Q2**6*(-5173+95073*r**2+395461*r**4
            +410123*r**6+81564*r**8)+2*Q2**5*(833+2838*r**2-132894*r**4-264396*r**6
            -165291*r**8+20286*r**10)-Q2**4*(-8505+92765*r**2+183856*r**4+124504*r**6
            +99137*r**8+84875*r**10+145320*r**12)+2*Q2**3*(-4382+27037*r**2+165883*r**4
            +368170*r**6+507632*r**8+336617*r**10+152467*r**12+40656*r**14)+Q2**2*(
            -1043+19425*r**2-81059*r**4-460371*r**6-705957*r**8-1240669*r**10-142657*r**12
            -186753*r**14+33804*r**16)+Q2*(4578-30598*r**2-57842*r**4+265818*r**6
            -581026*r**8+372202*r**10+735618*r**12-512218*r**14+53872*r**16-48804*r**18))
            +(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(279+51832*r**2+176*Q2**13*r**2
            -369279*r**4+4247926*r**6-14274463*r**8+27526342*r**10+129617771*r**12
            -553885372*r**14+660388553*r**16-367966084*r**18+98308279*r**20-19691578*r**22
            -449*r**24-240954*r**26-803*r**28+Q2**12*(-771+3063*r**2+750*r**4)
            -164*Q2**11*(-33+128*r**2+1019*r**4+62*r**6)+Q2**10*(-15111-9033*r**2
            +1230491*r**4+1032041*r**6+31932*r**8)-5*Q2**9*(-3879-36553*r**2+548994*r**4
            +1328318*r**6+448293*r**8+7979*r**10)+3*Q2**8*(-1965-51364*r**2+421575*r**4
            +3601030*r**6+3697755*r**8+297990*r**10+691*r**12)+2*Q2**7*(-6534-250623*r**2
            +1616565*r**4+1573020*r**6+4328420*r**8+225321*r**10+1865997*r**12+23610*r**14)
            -6*Q2**6*(-2121-155674*r**2+639433*r**4+3196174*r**6+14532525*r**8+12173384*r**10
            +3212001*r**12+870548*r**14+6754*r**16)+2*Q2**5*(1341-77562*r**2-628581*r**4
            +4567029*r**6+42074003*r**8+109470491*r**10+33108893*r**12+7934379*r**14
            +18744*r**16-3777*r**18)+5*Q2**4*(-1809-150223*r**2+876924*r**4+169908*r**6
            +7909498*r**8-20693230*r**10-36952648*r**12+12121444*r**14+636303*r**16
            +858453*r**18+5444*r**20)-2*Q2**3*(-1560-259383*r**2+945675*r**4-2691330*r**6
            +34366420*r**8+42739050*r**10+22169566*r**12-21456000*r**14+54405220*r**16
            +4550445*r**18+1210935*r**20+4962*r**22)+Q2**2*(1689+97333*r**2-1232405*r**4
            -268865*r**6-2372290*r**8+41581502*r**10+204873794*r**12-9518230*r**14
            +80995985*r**16+10862285*r**18+3461779*r**20-676457*r**22-4520*r**24)
            +Q2*(-1413-196377*r**2+1385164*r**4-8497688*r**6+31338675*r**8-29081629*r**10
            +114936104*r**12-332908368*r**14+324732521*r**16-173777275*r**18+47143692*r**20
            -249752*r**22+980329*r**24+4017*r**26))-21600*logq2**3*r**10*(301-1584*r**2
            -240*Q2**6*r**2+5717*r**4-6176*r**6+8279*r**8-72*r**10-1017*r**12+1272*r**14
            +20*Q2**5*(7+51*r**2+72*r**4)-4*Q2**4*(196+445*r**2+1206*r**4+837*r**6)
            +Q2**3*(1001+2581*r**2+5141*r**4+8403*r**6+3162*r**8)+Q2**2*(91-2396*r**2
            -1418*r**4-5364*r**6-6801*r**8+432*r**10)+Q2*(-749+2609*r**2-3480*r**4
            -158*r**6+3027*r**8+2589*r**10-2718*r**12))*sqrtq2+6*logq2*r**2*(175*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(8+581*r**2+120*Q2**6*r**2+3050*r**4+5739*r**6
            +17844*r**8+12711*r**10+978*r**12-351*r**14-20*Q2**5*(1+15*r**2+18*r**4)
            -2*Q2**4*(16+121*r**2+138*r**4+153*r**6)+Q2**3*(88+271*r**2-53*r**4
            -177*r**6+459*r**8)+Q2**2*(8+525*r**2+1434*r**4+2118*r**6+1530*r**8
            +489*r**10)+Q2*(-52+725*r**2+1053*r**4+930*r**6+2430*r**8+1725*r**10
            -51*r**12))-(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(-945+77289*r**2+16344*Q2**12*r**2
            -1068248*r**4-2287556*r**6+19762515*r**8+1063925*r**10+325341152*r**12
            +351047496*r**14+300436157*r**16+86127035*r**18-35764680*r**20+471484*r**22
            +1150177*r**24-51801*r**26-24*Q2**11*(280+1857*r**2+2697*r**4)-2*Q2**10*(
            -9240+56013*r**2+91034*r**4+37533*r**6)+5*Q2**9*(315+90324*r**2+206344*r**4
            +187534*r**6+97119*r**8)-15*Q2**8*(2695+9843*r**2-5640*r**4-127074*r**6
            -9315*r**8+15723*r**10)-6*Q2**7*(-2450+63908*r**2+329295*r**4+2057255*r**6
            +1851205*r**8+280595*r**10+130908*r**12)+6*Q2**6*(6090-42119*r**2-42954*r**4
            +3218410*r**6+7796650*r**8+2824075*r**10-56574*r**12+106526*r**14)+6*Q2**5*(
            -2485+70202*r**2-57689*r**4-2695313*r**6-13862440*r**8-15042650*r**10
            -2436943*r**12-13139*r**14+93057*r**16)-10*Q2**4*(1995-52698*r**2-36468*r**4
            +1087647*r**6-377658*r**8-4864267*r**10-2008608*r**12+1907937*r**14
            -177333*r**16+53037*r**18)-10*Q2**3*(-630+31188*r**2-231525*r**4-1908369*r**6
            -5477115*r**8-3551839*r**10+1392701*r**12-4061955*r**14-3776739*r**16
            -202185*r**18+24468*r**20)+6*Q2**2*(1050-50966*r**2+195820*r**4+2367055*r**6
            +5253880*r**8+13578290*r**10+18742992*r**12+25988540*r**14+3090630*r**16
            +343580*r**18-415780*r**20+36909*r**22)+Q2*(-945+64632*r**2-1076498*r**4
            +5130240*r**6+27091125*r**8+89598500*r**10+99449856*r**12+205945476*r**14
            +62581685*r**16+50756100*r**18-15255630*r**20-1199588*r**22+67047*r**24)))*sqrtq2)*math.log(murhoLS))/(18144000*logq2**4*r**16
            +756000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+875*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-6048000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-42000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2))
            +(flagPERP*(10450944000*logq2**5*(-Q2+(-1+r)**2)*r**20*(-1+r**4+2*r**6)*(
            -Q2+(1+r)**2)+276480*logq2**3*(-Q2+(-1+r)**2)*r**12*(-Q2+(1+r)**2)*(12240*Q2**11*r**2
            -2*Q2**10*(805+53106*r**2+45816*r**4)+10*Q2**9*(1015+39116*r**2+64725*r**4
            +27132*r**6)-5*Q2**8*(4620+150673*r**2+364785*r**4+298335*r**6+77877*r**8)
            +5*Q2**7*(3570+143209*r**2+480963*r**4+586151*r**6+308835*r**8+55800*r**10)
            -5*Q2**6*(-2520+22750*r**2+177459*r**4+380766*r**6+352988*r**8+139020*r**10
            +40257*r**12)+Q2**5*(-30030-407771*r**2-1498101*r**4-1336650*r**6-303620*r**8
            +778485*r**10+466599*r**12+375984*r**14)-5*Q2**4*(-2520-74608*r**2-394287*r**4
            -513900*r**6-387451*r**8+134208*r**10+299623*r**12+180180*r**14+70299*r**16)
            -5*Q2**3*(-1470+28837*r**2+81273*r**4+304061*r**6+153637*r**8-187209*r**10
            -459837*r**12-4249*r**14-165315*r**16+20448*r**18)+(-1+r**2)**2*(140
            +9813*r**2-202046*r**4+926700*r**6-769394*r**8+310202*r**10-49598*r**12
            -371164*r**14+840390*r**16+4209*r**18+56748*r**20)+5*Q2**2*(-1470+12026*r**2
            -181791*r**4+424860*r**6-318268*r**8-74112*r**10-111870*r**12-397228*r**14
            +616338*r**16-99210*r**18+80325*r**20)-5*Q2*(-280+7373*r**2-162861*r**4
            +598484*r**6-681340*r**8+216198*r**10+315794*r**12+314324*r**14-592836*r**16
            +600693*r**18-62925*r**20+52176*r**22))-192*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(-9312*Q2**17*r**2+4*Q2**16*(-805+31950*r**2+31368*r**4)
            -4*Q2**15*(-6685+161502*r**2+404131*r**4+169116*r**6)+Q2**14*(-86205
            +1568566*r**2+7173691*r**4+7409140*r**6+1895670*r**8)-2*Q2**13*(-55335
            +877182*r**2+6391588*r**4+7546174*r**6+7529917*r**8+1386990*r**10)+Q2**12*(55545
            +325312*r**2+892928*r**4-68024936*r**6-55484733*r**8+7582332*r**10+1205856*r**12)
            +4*Q2**11*(-88830+138939*r**2+7316008*r**4+90026929*r**6+162887050*r**8
            +76015549*r**10+6217412*r**12+641391*r**14)-Q2**10*(-367675-1123030*r**2
            +36823099*r**4+594075420*r**6+1792409349*r**8+1705822874*r**10+526212217*r**12
            +49659184*r**14+4273698*r**16)+2*Q2**9*(51205-825816*r**2+4872884*r**4
            +96431950*r**6+833807240*r**8+1312272220*r**10+895413124*r**12+152528314*r**14
            +14089355*r**16+642180*r**18)+Q2**8*(-523215-2287872*r**2-5690958*r**4
            +626144376*r**6+913254048*r**8+1261991140*r**10+202088558*r**12-313915968*r**14
            +199085991*r**16+14213508*r**18+2551560*r**20)-4*Q2**7*(-88165-1312728*r**2
            -7969281*r**4+197575162*r**6+740554886*r**8+1732027876*r**10+2057652454*r**12
            +790695704*r**14+170255247*r**16+87188276*r**18+6605931*r**20+630894*r**22)
            +Q2**6*(117425-1964862*r**2-15376235*r**4+107758348*r**6+1798025460*r**8
            +5044647308*r**10+10384226762*r**12+8058157568*r**14+1879903593*r**16
            +424735010*r**18+152762433*r**20+12860644*r**22-69294*r**24)+2*Q2**5*(
            -143535-1355918*r**2-18809060*r**4+209996206*r**6+78374599*r**8+662949094*r**10
            -177607368*r**12-2139634132*r**14-1113700217*r**16-581191826*r**18-260611316*r**20
            -44953946*r**22-2255135*r**24+650394*r**26)+Q2**4*(123795+2844816*r**2
            +44458316*r**4-296284040*r**6-471841525*r**8-2272449820*r**10-6261334512*r**12
            -1755882032*r**14+1136786505*r**16+924153720*r**18+2563155940*r**20+818410136*r**22
            +118116281*r**24+2390900*r**26-629280*r**28)-4*Q2**3*(-7980+107941*r**2
            +1499054*r**4+2511507*r**6-55651184*r**8-21011415*r**10-810178302*r**12
            +57571407*r**14+221197076*r**16+46474703*r**18+579675250*r**20+243457961*r**22
            +84712264*r**24+3269667*r**26-455394*r**28+30645*r**30)+(-1+r**2)**2*(
            -2345-65626*r**2-1854889*r**4+5984320*r**6-47439045*r**8-275719454*r**10
            +1938692851*r**12-6012321852*r**14+4658322525*r**16+2971961450*r**18
            -4803909227*r**20+1599597976*r**22-516519559*r**24-47590770*r**26-13103455*r**28
            -362524*r**30+9624*r**32)+Q2**2*(-49455-643662*r**2-15312277*r**4+103829084*r**6
            -285839973*r**8-52386658*r**10+2229257831*r**12-3134616736*r**14+1959850417*r**16
            +6026543886*r**18-9059347279*r**20+5204165324*r**22-1817549687*r**24
            -163304926*r**26-83714563*r**28-3897608*r**30+216282*r**32)+2*Q2*(8995
            +183028*r**2+4702628*r**4-26616782*r**6+116212870*r**8+241815308*r**10
            -2486307572*r**12+6566587018*r**14-5601093876*r**16+4012394060*r**18
            -7740793636*r**20+8223996790*r**22-3180020950*r**24+857273108*r**26+69788020*r**28
            +29502158*r**30+1047329*r**32-38496*r**34))+16588800*logq2**4*r**16*(240*Q2**8*r**2
            -30*Q2**7*(7+50*r**2+36*r**4)+6*Q2**6*(266+735*r**2+837*r**4+140*r**6)
            +Q2**5*(-4431-8071*r**2-9867*r**4-2727*r**6+3255*r**8)+Q2**4*(5145
            +8463*r**2+10265*r**4+3621*r**6-7935*r**8-5985*r**10)-Q2**3*(840+6167*r**2
            +3532*r**4+304*r**6-7221*r**8-10755*r**10+1995*r**12)+(-1+r**2)**2*(
            -819+3026*r**2-3897*r**4-222*r**6+6253*r**8-138*r**10-1083*r**12+3180*r**14)
            +Q2**2*(-3570+9163*r**2-7256*r**4-1146*r**6+823*r**8-1104*r**10-7515*r**12
            +12705*r**14)+Q2*(3129-11202*r**2+16166*r**4+1809*r**6-13731*r**8
            -16370*r**10-5184*r**12+11343*r**14-11160*r**16))*sqrtq2+4608*logq2**2*r**8*(57168*Q2**16*r**2
            -2*Q2**15*(-5845+367914*r**2+345684*r**4)+2*Q2**14*(-60410+1977755*r**2
            +3847837*r**4+1805820*r**6)-Q2**13*(-518455+11477745*r**2+34954556*r**4
            +33573901*r**6+10536375*r**8)+Q2**12*(-1127245+18705305*r**2+81383504*r**4
            +115278232*r**6+77963459*r**8+18219765*r**10)-Q2**11*(-1014580+13797569*r**2
            +91024971*r**4+147290736*r**6+158596776*r**8+99085571*r**10+17166369*r**12)
            +Q2**10*(795410-6200271*r**2+558208*r**4-111856145*r**6-149321880*r**8
            +4964085*r**10+55689058*r**12+3326439*r**14)+Q2**9*(-3084235+22994780*r**2
            +131965177*r**4+604029700*r**6+1079140925*r**8+848095140*r**10+253919035*r**12
            +13668052*r**14+11837370*r**16)-Q2**8*(-2890965+17705610*r**2+160097138*r**4
            +762087708*r**6+1647095240*r**8+1876140160*r**10+1144132650*r**12+322631448*r**14
            +40802073*r**16+14798250*r**18)+2*Q2**7*(91245-993555*r**2+31303271*r**4
            +158436418*r**6+400757286*r**8+628835220*r**10+646730610*r**12+378414966*r**14
            +125102193*r**16+19586391*r**18+4069035*r**20)-2*Q2**6*(1350580-6684492*r**2
            -14780171*r**4-90271141*r**6-248522356*r**8-243999466*r**10+403562*r**12
            +272798404*r**14+244216284*r**16+141574594*r**18+24874029*r**20+1273533*r**22)
            +Q2**5*(2217985-9060649*r**2-41186662*r**4-249628665*r**6-756356125*r**8
            -947143370*r**10-614776364*r**12+124696566*r**14+472413935*r**16+492953875*r**18
            +271044530*r**20+47995843*r**22+401901*r**24)+(-1+r**2)**4*(19915-39592*r**2
            +357464*r**4+6433228*r**6-38999325*r**8+134836920*r**10-60268716*r**12
            -61967028*r**14-45600531*r**16+115400300*r**18-20550860*r**20+14446408*r**22
            +1214789*r**24+77028*r**26)+Q2**4*(-286195-21915*r**2+19524024*r**4
            +110953260*r**6+200345175*r**8+409387415*r**10-70845440*r**12-314499048*r**14
            -472823125*r**16+121791875*r**18-394822920*r**20-25896820*r**22-12836351*r**24
            +1226865*r**26)+Q2**3*(-696920+3897355*r**2-10185931*r**4-58507916*r**6
            +299251940*r**8-595755285*r**10+456783225*r**12+316067952*r**14+80680992*r**16
            +491937185*r**18-1168768945*r**20+404633020*r**22-199420396*r**24-17716151*r**26
            -2200125*r**28)-Q2*(-1+r**2)**2*(164045-570452*r**2+2279922*r**4+31431742*r**6
            -204063877*r**8+587490210*r**10-180960636*r**12-133773324*r**14-82820229*r**16
            -242011256*r**18+635536970*r**20-142928562*r**22+84802877*r**24+7745962*r**26
            +556608*r**28)+Q2**2*(529130-2771695*r**2+7796704*r**4+53272407*r**6
            -435592656*r**8+1190874175*r**10-952364130*r**12+292056957*r**14+118660386*r**16
            +508424047*r**18-1312177820*r**20+1534052225*r**22-481728636*r**24+185089857*r**26
            +18039134*r**28+1599915*r**30))*sqrtq2+32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(176*Q2**18+Q2**17*(2535+1676*r**2)-Q2**16*(32913+364661*r**2
            +31652*r**4)+Q2**15*(68917+3787700*r**2+3771553*r**4+177696*r**6)-Q2**14*(
            -186186+14930971*r**2+33942285*r**4+15925827*r**6+525835*r**8)+Q2**13*(
            -732732+26050717*r**2+105692368*r**4+111027624*r**6+32799280*r**8+907327*r**10)
            -Q2**12*(324509+9485791*r**2+95086832*r**4+107830116*r**6+132834703*r**8
            +25415813*r**10+849708*r**12)+Q2**11*(4735695-35935918*r**2-174035451*r**4
            -860194842*r**6-730239207*r**8-78154746*r**10-25696893*r**12+186626*r**14)
            +Q2**10*(-7878420+51117673*r**2+455427703*r**4+2689270611*r**6+4581253617*r**8
            +2298868719*r**10+369632889*r**12+71295877*r**14+445027*r**16)-Q2**9*(
            -2284128+6347953*r**2+273545720*r**4+2278224806*r**6+7588991340*r**8
            +7470882852*r**10+2238303088*r**12+320261170*r**14+42657116*r**16+366355*r**18)
            +Q2**8*(7905711-29243549*r**2-120166776*r**4-1776146298*r**6+1548013800*r**8
            +4035751620*r**10+3769240026*r**12-219460086*r**14+2011977*r**16-29382855*r**18
            -121682*r**20)+Q2**7*(-9312237+5292944*r**2+126690299*r**4+4437162732*r**6
            +7584211446*r**8+12328513824*r**10+7299356238*r**12+1118301864*r**14
            +1733839047*r**16+122705136*r**18+50863751*r**20+262988*r**22)-Q2**6*(
            -631274-24250639*r**2-17896433*r**4+1874113581*r**6+6883024941*r**8
            +15156693138*r**10+20234085838*r**12+7332891090*r**14+985613736*r**16
            +858975661*r**18+78073619*r**20+12183601*r**22+6021*r**24)+Q2**5*(5624664
            -13151621*r**2+112252680*r**4-1821627060*r**6+1866941356*r**8-2250779013*r**10
            +7611706416*r**12+8755730960*r**14+1615778544*r**16+1282968081*r**18
            +175004776*r**20+126163332*r**22-18061908*r**24-163367*r**26)+Q2**4*(
            -3753939-7632901*r**2-209951320*r**4+2113533408*r**6-1413307675*r**8
            +10066028003*r**10+6957706272*r**12-699243080*r**14-1370609321*r**16
            -3452772735*r**18-2930899984*r**20-412158616*r**22-139818345*r**24+12844193*r**26
            +90440*r**28)+Q2**3*(-105655+8863882*r**2+44640383*r**4-316660626*r**6
            +585467545*r**8-2566777246*r**10-5087246889*r**12+3816175574*r**14-720240173*r**16
            +2043625630*r**18+2367671797*r**20+1524887882*r**22+224304843*r**24+13040374*r**26
            +118325*r**28+13554*r**30)+Q2**2*(1128336-2016029*r**2+92595333*r**4
            -654708291*r**6+2153606607*r**8-3252444525*r**10+1274435037*r**12-2290651051*r**14
            -7064801553*r**16+16654038801*r**18-12936995113*r**20+3971069823*r**22
            +275119893*r**24+186126969*r**26+72474567*r**28-3043473*r**30-31331*r**32)
            -2*(-1+r**2)**2*(-36857-161613*r**2-6810851*r**4+35146072*r**6-233476106*r**8
            -16624739*r**10+3287333199*r**12-13455588938*r**14+20748902706*r**16
            -14279266723*r**18+4617951579*r**20-955820164*r**22-34667986*r**24-29099053*r**26
            -4448071*r**28+74742*r**30+803*r**32)+Q2*(-500931-431635*r**2-65255680*r**4
            +451471698*r**6-2224528152*r**8+3042024930*r**10+6513831000*r**12-23634794558*r**14
            -2182533326*r**16+57386238084*r**18-60936658352*r**20+24714711430*r**22
            -5251155984*r**24-197165922*r**26-182264232*r**28-46919322*r**30+1182905*r**32
            +12047*r**34))*sqrtq2)*math.log(r))/(5225472000*logq2**5*r**22*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))+362880000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+1260000*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-30240000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-21000*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2-2177280000*logq2**4*r**18*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(flagPERP*(-18144000*logq2**4*r**14*(-108+205*r**2+243*r**4
            +147*r**6+57*r**8)+1440*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(
            -8386-11465*r**2-22920*Q2**9*r**2-62195*r**4-2717840*r**6+6917980*r**8
            -22099358*r**10-21383090*r**12-6768560*r**14+4537510*r**16+392615*r**18
            +76389*r**20+14*Q2**8*(176+13983*r**2+14511*r**4)-8*Q2**7*(-1596+84411*r**2
            +173866*r**4+81219*r**6)+Q2**6*(-48538+796596*r**2+3339844*r**4+3375056*r**6
            +703962*r**8)+Q2**5*(15316+131715*r**2-2502696*r**4-5462046*r**6-2927100*r**8
            +366891*r**10)+Q2**4*(74130-810275*r**2-1204411*r**4+2238572*r**6+2423914*r**8
            -339305*r**10-1262625*r**12)+Q2**3*(-63784+236918*r**2+2698370*r**4
            +7422746*r**6+7895716*r**8+6043210*r**10+2727458*r**12+592326*r**14)
            +2*Q2**2*(-7819+150219*r**2-381124*r**4-4440276*r**6-8601465*r**8-9106871*r**10
            -3127304*r**12-1118016*r**14+176016*r**16)-Q2*(-31668+141481*r**2+554090*r**4
            +314664*r**6+7132318*r**8+2108438*r**10-2336106*r**12+5668600*r**14
            -202474*r**16+359457*r**18))-(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -1257+23280*Q2**15+197749*r**2+5145507*r**4+37228177*r**6-11952781*r**8
            +1204100569*r**10+3078214607*r**12-14343705979*r**14+29332802261*r**16
            -10064178193*r**18+1119578233*r**20-435150781*r**22-50596703*r**24-1367613*r**26
            +22549*r**28-345*r**30-79740*Q2**14*(1+r**2)+8*Q2**13*(2895+37654*r**2
            +2895*r**4)+3*Q2**12*(10311+27177*r**2-92175*r**4+50095*r**6)+2*Q2**11*(249537
            -1289432*r**2-7773146*r**4-807368*r**6+8505*r**8)+Q2**10*(-986172+3822624*r**2
            +74286932*r**4+68106212*r**6+4895544*r**8-393780*r**10)+10*Q2**9*(9627
            +394004*r**2-9538059*r**4-27851224*r**6-8402667*r**8-170236*r**10+7323*r**12)
            +3*Q2**8*(292055-2580963*r**2-6067745*r**4+114291165*r**6+135603965*r**8
            -12702065*r**10-2710163*r**12+182935*r**14)-4*Q2**7*(58359+2614968*r**2
            -26319450*r**4-35403360*r**6-74039890*r**8+7955784*r**10-41387322*r**12
            -1812960*r**14+73455*r**16)-12*Q2**6*(42929-1640069*r**2+2028028*r**4
            +56921404*r**6+256968360*r**8+210037384*r**10+59041116*r**12+8400908*r**14
            -371921*r**16+24085*r**18)+4*Q2**5*(41181+617088*r**2-19508241*r**4
            +62799384*r**6+692754868*r**8+1863290056*r**10+479147908*r**12+167334024*r**14
            -15204081*r**16-1492392*r**18+53805*r**20)+5*Q2**4*(37059-3096475*r**2
            +10222233*r**4+62664543*r**6+276752950*r**8-942013894*r**10-1554884278*r**12
            +473069638*r**14+47446023*r**16+20863329*r**18-232675*r**20+14427*r**22)
            -2*Q2**3*(34875-2048616*r**2-16758750*r**4+5883960*r**6+866331085*r**8
            +1008596400*r**10-74882948*r**12-1204117200*r**14+1515261685*r**16+268895160*r**18
            +13545570*r**20-1127016*r**22+33795*r**24)-4*Q2**2*(6543-880504*r**2
            +8241125*r**4+16841225*r**6-25041740*r**8-1022570411*r**10-2949907082*r**12
            -1066261010*r**14-1527284885*r**16-36676610*r**18-26658907*r**20+6455561*r**22
            -34990*r**24+2085*r**26)+2*Q2*(6387-883932*r**2-2310811*r**4-34583608*r**6
            +341356575*r**8+506580796*r**10+1887785929*r**12-4580216208*r**14+7260612841*r**16
            -2701290980*r**18+547759167*r**20+57731528*r**22+7755269*r**24-195708*r**26
            +4755*r**28))+86400*logq2**3*r**10*(-360*Q2**6*r**2+10*Q2**5*(56+237*r**2
            +405*r**4)-2*Q2**4*(2576+3407*r**2+10086*r**4+8559*r**6)+Q2**3*(5138
            +32029*r**2+55679*r**4+73515*r**6+34647*r**8)-2*Q2**2*(-1379+14446*r**2
            +30670*r**4+50580*r**6+43557*r**8+5934*r**10)+Q2*(-3122+10343*r**2
            -34011*r**4-39374*r**6+10956*r**8+8871*r**10-29823*r**12)+2*(-91+282*r**2
            +28681*r**4-101848*r**6-99713*r**8-57342*r**10-8685*r**12+10236*r**14))*sqrtq2
            +24*logq2*r**2*(-50*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(-98+9859*r**2+780*Q2**6*r**2
            +66412*r**4+45153*r**6+156558*r**8+186021*r**10+18504*r**12-5289*r**14
            -5*Q2**5*(56+705*r**2+873*r**4)-Q2**4*(448+2713*r**2+5322*r**4+3609*r**6)
            +Q2**3*(1022+4049*r**2-295*r**4-1191*r**6+6051*r**8)+2*Q2**2*(161+4170*r**2
            +9264*r**4+11520*r**6+11091*r**8+3498*r**10)+Q2*(-518+10930*r**2+18114*r**4
            -3102*r**6+29448*r**8+25212*r**10-564*r**12))-(-Q2+(-1+r)**2)*(-Q2
            +(1+r)**2)*(83808*Q2**12*r**2-36*Q2**11*(-1120+18771*r**2+15411*r**4)
            +4*Q2**10*(-27720+466737*r**2+1208506*r**4+411297*r**6)-5*Q2**9*(1890
            +349557*r**2+2224963*r**4+2231623*r**6+350487*r**8)-30*Q2**8*(-8085
            +43811*r**2-64894*r**4-80998*r**6-116253*r**8+57363*r**10)+12*Q2**7*(
            -7350+135257*r**2+1332200*r**4+7164795*r**6+6069565*r**8+1225560*r**10
            +407997*r**12)-12*Q2**6*(18270-275016*r**2+681929*r**4+14980320*r**6
            +31376620*r**8+12914780*r**10+1208389*r**12+86884*r**14)-6*Q2**5*(-14910
            +321681*r**2+90873*r**4-16510339*r**6-99120415*r**8-104263215*r**10
            -14286299*r**12-731927*r**14+671751*r**16)+20*Q2**4*(5985-194247*r**2
            +276357*r**4+5627400*r**6-4667217*r**8-31184234*r**10-11835201*r**12
            +8650872*r**14+280332*r**16+90513*r**18)+20*Q2**3*(-1890+73674*r**2
            -428211*r**4-4638909*r**6-16685739*r**8-18117443*r**10+2611585*r**12
            -11175315*r**14-11488227*r**16-883527*r**18+90642*r**20)-12*Q2**2*(3150
            -162209*r**2+748325*r**4+7819815*r**6-163040*r**8-46435610*r**10-56614022*r**12
            +4561950*r**14-14164590*r**16+1623515*r**18-650015*r**20+79131*r**22)
            -Q2*(-5670+283161*r**2-3775469*r**4+27596175*r**6+69206535*r**8+67130510*r**10
            +160962138*r**12+526134498*r**14-158523100*r**16+303525465*r**18-89190765*r**20
            -8699249*r**22+459771*r**24)+2*(2835-228981*r**2+2941132*r**4+12759694*r**6
            -44988705*r**8-10434715*r**10-650410648*r**12+246921636*r**14-123584503*r**16
            -375975595*r**18+55397580*r**20-4874546*r**22-2760443*r**24+131259*r**26)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(
            -5225472000*logq2**5*r**20-362880000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -1260000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+2177280000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+30240000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+21000*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +(flagPERP*(-43200*logq2**3*r**10*(-16+47*r**2+46*r**4+15*r**6)+12*logq2*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-80-1341*r**2+1544*Q2**8*r**2
            -7172*r**4-59768*r**6+117716*r**8-820230*r**10-397644*r**12+156712*r**14
            +17708*r**16+499*r**18-8*Q2**7*(-40+1269*r**2+1149*r**4)+Q2**6*(-800
            +14927*r**2+40590*r**4+13327*r**6)+Q2**5*(80+3186*r**2-44058*r**4-48218*r**6
            +4706*r**8)+Q2**4*(1200-13955*r**2-3760*r**4+41094*r**6+15520*r**8
            -21795*r**10)+4*Q2**3*(-200-531*r**2+10635*r**4+55156*r**6+42996*r**8
            +9655*r**10+2209*r**12)+Q2**2*(-320+7497*r**2-27738*r**4-275421*r**6
            -527636*r**8-220461*r**10-55258*r**12+7097*r**14)-2*Q2*(-200-209*r**2
            +8405*r**4+67339*r**6+29745*r**8-40055*r**10+98659*r**12-595*r**14
            +2511*r**16))+720*logq2**2*r**6*(-64+133*r**2+60*Q2**5*r**2+1223*r**4
            -10172*r**6-7372*r**8-1313*r**10+1005*r**12-32*Q2**4*(2+9*r**2+15*r**4)
            +Q2**3*(16+1453*r**2+2522*r**4+1485*r**6)-Q2**2*(-96+1069*r**2+3351*r**4
            +3783*r**6+765*r**8)-Q2*(-16+409*r**2+1378*r**4+146*r**6-462*r**8
            +1305*r**10))*sqrtq2+(100*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(5*Q2**5-4*Q2**3*(
            -1+r**2)**2+Q2**2*(-3+r**2)*(-1+r**2)**2-4*Q2**4*(1+r**2)+Q2*(-1+r**2)**2*(
            -3-8*r**2+r**4)+(-1+r**2)**2*(-3-47*r**2-11*r**4+r**6))+(Q2-(
            -1+r)**2)*(-Q2+(1+r)**2)*(-327+40*Q2**11+5381*r**2+51893*r**4-66375*r**6
            +459862*r**8-1267442*r**10+6907134*r**12-1962938*r**14-121295*r**16
            -29907*r**18-1651*r**20+65*r**22-160*Q2**10*(1+r**2)+Q2**9*(25-158*r**2
            +25*r**4)+Q2**8*(1913-6501*r**2-3237*r**4+825*r**6)-2*Q2**7*(2502-11611*r**2
            -64954*r**4-8107*r**6+750*r**8)+2*Q2**6*(1502-7291*r**2-167219*r**4
            -158107*r**6-8175*r**8+210*r**10)+2*Q2**5*(1711-11743*r**2+61595*r**4
            +379858*r**6+56331*r**8-7647*r**10+735*r**12)+Q2**4*(-3690+20928*r**2
            +204288*r**4-432758*r**6-916254*r**8+338360*r**10+34328*r**12-1650*r**14)
            +2*Q2**3*(-514+8473*r**2-16750*r**4-239765*r**6-565632*r**8+77979*r**10
            -155902*r**12-5559*r**14+150*r**16)+2*Q2**2*(782-7781*r**2-54965*r**4
            +345293*r**6+1595771*r**8+1042739*r**10+455677*r**12-12549*r**14-5697*r**16
            +250*r**18)+Q2*(241-6028*r**2-28199*r**4+357456*r**6+1406870*r**8
            -1995336*r**10+2615318*r**12-480176*r**14+108569*r**16+8820*r**18-335*r**20)))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(2073600*logq2**4*r**16
            +86400*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+100*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-691200*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-4800*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +(flagPERP*(-720*logq2**2*r**6*(-4+21*r**2+9*r**4)-(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(21+120*Q2**7+431*r**2+2289*r**4-3941*r**6+26419*r**8
            -5607*r**10-937*r**12+45*r**14-225*Q2**6*(1+r**2)-8*Q2**5*(15-58*r**2
            +15*r**4)-4*Q2**3*(-84+275*r**2+1754*r**4+107*r**6)+3*Q2**4*(37-17*r**2
            -281*r**4+125*r**6)+Q2**2*(-99+1093*r**2+10210*r**4+8818*r**6+1717*r**8
            -195*r**10)+4*Q2*(-36+327*r**2+1534*r**4-2282*r**6+1954*r**8+63*r**10))
            +24*logq2*r**2*(-10-11*r**2-36*Q2**4*r**2+14*r**4-1326*r**6-416*r**8
            +189*r**10+2*Q2**3*(-5+132*r**2+117*r**4)-Q2**2*(-10+191*r**2+524*r**4
            +171*r**6)-2*Q2*(-5+93*r**2+2*r**4-68*r**6+108*r**8))*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(
            -34560*logq2**3*r**12-720*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+8640*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(flagPERP*(-12*logq2*r**4+(-3+5*Q2**3
            +5*r**2-19*r**4+5*r**6-5*Q2**2*(1+r**2)+Q2*(-5+8*r**2-5*r**4))*sqrtq2)*nlo.X1Q2(3,'SM',Q2,r))/(288*logq2**2*r**8
            +2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-48*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(flagPERP*(-1512000*logq2**3*r**12*(1
            +r**2)*(19+10*r**2+19*r**4)-60*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1
            +r)**2)*(23-1440*Q2**9+10999*r**2+228160*r**4+383296*r**6+3006322*r**8
            +3006322*r**10+383296*r**12+228160*r**14+10999*r**16+23*r**18+10248*Q2**8*(1
            +r**2)-512*Q2**7*(37+94*r**2+37*r**4)+Q2**6*(4319+70769*r**2+70769*r**4
            +4319*r**6)+2*Q2**5*(8631-19072*r**2-30126*r**4-19072*r**6+8631*r**8)
            -Q2**4*(11375+66235*r**2+466262*r**4+466262*r**6+66235*r**8+11375*r**10)
            -4*Q2**3*(847-28698*r**2-220767*r**4-429164*r**6-220767*r**8-28698*r**10
            +847*r**12)+Q2**2*(3729-4117*r**2-37563*r**4-1070849*r**6-1070849*r**8
            -37563*r**10-4117*r**12+3729*r**14)-2*Q2*(217+25092*r**2+198688*r**4
            -394052*r**6-869490*r**8-394052*r**10+198688*r**12+25092*r**14+217*r**16))
            -3600*logq2**2*r**8*(781-80*Q2**6+4344*r**2+33555*r**4+43600*r**6+33555*r**8
            +4344*r**10+781*r**12+900*Q2**5*(1+r**2)-4*Q2**4*(951+1718*r**2+951*r**4)
            +Q2**3*(3931+13189*r**2+13189*r**4+3931*r**6)+Q2**2*(1131-5648*r**2
            -11126*r**4-5648*r**6+1131*r**8)-3*Q2*(953-829*r**2-3484*r**4-3484*r**6
            -829*r**8+953*r**10))*sqrtq2+(250*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1+8*Q2**6
            -34*r**2-1133*r**4-2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1+r**2)
            +Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1
            -26*r**2-118*r**4-26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6
            -31*r**8+r**10))-7*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6
            -28170*r**8+31692*r**10-9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)
            +Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)
            +Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2
            -6138*r**4-6138*r**6-355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4
            +35188*r**6+10313*r**8-406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4
            +6605*r**6+6605*r**8-7237*r**10-595*r**12+27*r**14)))*sqrtq2)*nlopw.X1Q2MuG(0,Q2,r))/(72576000*logq2**4*r**16
            +3024000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+3500*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-24192000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-168000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +(flagPERP*(-3600*logq2**2*r**8*(15+22*r**2+15*r**4)-(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4+19308*r**6+138690*r**8
            +19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1+r**2)+Q2**6*(
            -89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4+79*r**6)+Q2**4*(165
            -1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4
            -2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2+1787*r**4-14228*r**6
            +1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2-2957*r**4+19165*r**6
            +19165*r**8-2957*r**10-635*r**12+27*r**14))-600*logq2*r**4*(1+2*Q2**5
            +35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17
            +42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2
            +66*r**4+30*r**6-11*r**8))*sqrtq2)*nlopw.X1Q2MuG(1,Q2,r))/(-86400*logq2**3*r**12
            -1800*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+21600*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+50*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(flagPERP*(-540*logq2*r**4*(1+r**2)+3*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*nlopw.X1Q2MuG(2,Q2,r))/(1440*logq2**2*r**8
            +10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-240*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)-(flagPERP*nlopw.X1Q2MuG(3,Q2,r))/(
            -12*logq2*r**4+(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2))+rhoD*((flagPERP*muWC*(232243200*logq2**4*(-Q2+(-1+r)**2)*r**16*(
            -Q2+(1+r)**2)*(-120*Q2**8*r**2+30*Q2**7*(1+19*r**2+32*r**4)-6*Q2**6*(16
            +185*r**2+580*r**4+539*r**6)+Q2**5*(96+746*r**2+4710*r**4+8559*r**6
            +5649*r**8)-Q2**4*(30-227*r**2+2070*r**4+7575*r**6+10332*r**8+4620*r**10)
            +Q2**3*(300-1183*r**2+377*r**4+2005*r**6+4623*r**8+5928*r**10-210*r**12)
            +(-1+r**2)**3*(276-733*r**2+1478*r**4+68*r**6+408*r**8+567*r**10+636*r**12)
            +Q2**2*(-870+2062*r**2-1929*r**4+232*r**6-872*r**8+264*r**10-2457*r**12
            +3570*r**14)+Q2*(846-2753*r**2+6267*r**4-1059*r**6-2725*r**8+339*r**10
            -837*r**12+2553*r**14-2631*r**16))+46080*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(-17784*Q2**14*r**2+2*Q2**13*(-1897+96261*r**2+92448*r**4)
            -2*Q2**12*(-15554+405615*r**2+882646*r**4+391197*r**6)+Q2**11*(-95382
            +1750339*r**2+6071923*r**4+6328463*r**6+1631841*r**8)-2*Q2**10*(-61369
            +1096899*r**2+4560520*r**4+6649091*r**6+5099489*r**8+647322*r**10)+Q2**9*(
            -10570+1968033*r**2+4044291*r**4-5702304*r**6-6463898*r**8+2850955*r**10
            -1369707*r**12)+4*Q2**8*(-35658-448491*r**2+1114939*r**4+13311700*r**6
            +28261739*r**8+18008755*r**10+3884124*r**12+1015452*r**14)-2*Q2**7*(
            -71022-676110*r**2+2673843*r**4+33385290*r**6+103349827*r**8+130770026*r**10
            +53465389*r**12+11683758*r**14+1463031*r**16)+2*Q2**6*(-27258-57369*r**2
            +619543*r**4+17000977*r**6+58654985*r**8+124500337*r**10+116525561*r**12
            +9453563*r**14+3934017*r**16-586116*r**18)+2*Q2**5*(22617-357987*r**2
            -73183*r**4-11576662*r**6+2995634*r**8+11071016*r**10-15469322*r**12
            -12990098*r**14+52951493*r**16+5486763*r**18+1620369*r**20)-2*Q2**4*(24290
            -185838*r**2-420537*r**4-14917407*r**6+1569580*r**8+47681716*r**10+103696522*r**12
            +61483838*r**14+50657978*r**16+52694826*r**18+6120615*r**20+848817*r**22)
            +Q2**3*(-13174+119817*r**2-838637*r**4-12247855*r**6-1484579*r**8-6965910*r**10
            +97517726*r**12+181952266*r**14-18152100*r**16+105864669*r**18+9439999*r**20
            +3191957*r**22-342579*r**24)+2*(-1+r**2)**3*(-3164-11103*r**2-89740*r**4
            -847083*r**6+4386372*r**8-26946120*r**10+8717478*r**12+11164272*r**14
            +16072218*r**16-1880137*r**18+2850294*r**20+170635*r**22+24078*r**24)
            +2*Q2**2*(26649-64220*r**2+379509*r**4-1334768*r**6-9129162*r**8+18487974*r**10
            -8693214*r**12-10067148*r**14-60601875*r**16+99979092*r**18-50614423*r**20
            +20473404*r**22+779204*r**24+378978*r**26)-Q2*(32102-18099*r**2+512869*r**4
            +3872*r**6-21603566*r**8+105464001*r**10-112916667*r**12+3028632*r**14
            +31351506*r**16-146886593*r**18+185388447*r**20-71030584*r**22+25227574*r**24
            +1124147*r**26+322359*r**28))-64*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(
            -176*Q2**18*r**2+Q2**17*(-2313+4999*r**2-222*r**4)+Q2**16*(27831-41074*r**2
            -227095*r**4+12066*r**6)+Q2**15*(-148287-138957*r**2+3606965*r**4+2021143*r**6
            -64288*r**8)+Q2**14*(457500+1537255*r**2-16562010*r**4-29532198*r**6
            -7587314*r**8+155055*r**10)+Q2**13*(-892965-3181345*r**2+38572892*r**4
            +96612480*r**6+86558453*r**8+12289601*r**10-163212*r**12)-Q2**12*(-1121754
            +2510493*r**2+65636338*r**4+53435771*r**6-58849194*r**8+48169567*r**10
            -1476334*r**12+56329*r**14)+Q2**11*(-868143+20362963*r**2+107146983*r**4
            -232025547*r**6-1735903161*r**8-1560772827*r**10-295392063*r**12-38202749*r**14
            +363792*r**16)+Q2**10*(362736-33936121*r**2-136023706*r**4+421664136*r**6
            +4431318318*r**8+8166770862*r**10+4119315954*r**12+693458816*r**14+54731402*r**16
            -364221*r**18)-Q2**9*(91575-21181645*r**2-77296790*r**4+303668354*r**6
            +4229784392*r**8+11266065120*r**10+13220439390*r**12+3032713870*r**14
            +364737889*r**16+7597997*r**18+17160*r**20)+Q2**8*(120780+6296423*r**2
            +33451296*r**4+358745175*r**6+1671351804*r**8-655367502*r**10-149730396*r**12
            +3599958426*r**14-4357629480*r**16-680886441*r**18-58743652*r**20+327327*r**22)
            +Q2**7*(-128469-16259231*r**2-60774653*r**4-567877023*r**6-1514356458*r**8
            +10121742546*r**10+36902108478*r**12+31783864314*r**14+14018557167*r**16
            +9544669437*r**18+1116523663*r**20+58756885*r**22-233376*r**24)-Q2**6*(
            -3468-5459901*r**2-20002114*r**4-313283426*r**6-1803490402*r**8+3699693165*r**10
            +31771634460*r**12+70840959188*r**14+28834374240*r**16+17278746573*r**18
            +3985745574*r**20+303829262*r**22-335858*r**24+34307*r**26)+Q2**5*(79089
            +3801293*r**2-20924808*r**4+136772724*r**6+472726253*r**8-2165410791*r**10
            +7542644244*r**12+8767664080*r**14+61524304779*r**16-27783802209*r**18
            +7766490152*r**20-4860917892*r**22-582858537*r**24-36206533*r**26+130956*r**28)
            +Q2**4*(-46050-3025775*r**2+36468370*r**4-184713573*r**6-1720749494*r**8
            +2484523765*r**10-14312128170*r**12+22733394815*r**14+34318487426*r**16
            -47977225677*r**18+59434307470*r**20-1161609215*r**22+5691358230*r**24
            +538582087*r**26+21826186*r**28-58395*r**30)+(-1+r**2)**3*(-837-3046*r**2
            +2845574*r**4+10677976*r**6-5786832*r**8+636089126*r**10+579280450*r**12
            -7565546468*r**14+35283444978*r**16-44760554106*r**18+19864115914*r**20
            -6192595232*r**22+385535744*r**24-183526854*r**26-13122962*r**28-406228*r**30
            +803*r**32)-Q2**3*(5565-136473*r**2+9291263*r**4-32128595*r**6-548907843*r**8
            +1583135399*r**10-13085842265*r**12+14953442869*r**14+10951896895*r**16
            +20239085981*r**18-13551566763*r**20+18835537199*r**22+2530346743*r**24
            +1021735125*r**26+60517637*r**28-1430801*r**30+10064*r**32)+Q2**2*(15528
            +414725*r**2-17784462*r**4+8798844*r**6+300967314*r**8-1337026464*r**10
            +2354495562*r**12+8126035036*r**14-31279960998*r**16+78431910642*r**18
            -107631524906*r**20+76903236756*r**22-29545361226*r**24+5188014504*r**26
            -1362453906*r**28-133036908*r**30-6758218*r**32+18177*r**34)-2*Q2*(3078
            +51520*r**2-6765674*r**4-1673415*r**6+97502733*r**8-1106398491*r**10
            +2806710273*r**12-4643078395*r**14+11143999493*r**16-55372148991*r**18
            +119279219273*r**20-111857961781*r**22+52742661687*r**24-14476213041*r**26
            +1848212883*r**28-416606985*r**30-36087887*r**32-1429493*r**34+3213*r**36))
            +20901888000*logq2**5*r**20*(-5+5*r**2-r**4+r**6)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2-552960*logq2**3*r**12*(29160*Q2**13*r**2-2*Q2**12*(2177
            +137211*r**2+163152*r**4)+2*Q2**11*(20979+566801*r**2+1272501*r**4+787719*r**6)
            -Q2**10*(165669+2687654*r**2+8235344*r**4+9910704*r**6+4179189*r**8)
            +5*Q2**9*(69440+793675*r**2+2824818*r**4+4749284*r**6+4088190*r**8+1239681*r**10)
            -5*Q2**8*(79527+768303*r**2+2658408*r**4+5103272*r**6+6177745*r**8+4463697*r**10
            +741240*r**12)+Q2**7*(183288+2928534*r**2+6516638*r**4+8142060*r**6
            +5574460*r**8+7914598*r**10+8488974*r**12-3490632*r**14)+2*Q2**6*(57477
            -1289742*r**2-960232*r**4+2684222*r**6+12928820*r**8+20271952*r**10
            +13282598*r**12+3857028*r**14+4392837*r**16)-(-1+r**2)**5*(-4879+17066*r**2
            +337776*r**4-1881054*r**6+1045786*r**8+195594*r**10+1135624*r**12+1267014*r**14
            +52269*r**16+102804*r**18)-2*Q2**5*(103026-1153884*r**2-267669*r**4
            +1296371*r**6+11237571*r**8+22747851*r**10+27318521*r**12+15075361*r**14
            +5614311*r**16+3327741*r**18)+20*Q2**4*(3885-57315*r**2+88408*r**4-194841*r**6
            +412506*r**8+894406*r**10+999843*r**12+1322333*r**14+119309*r**16+364425*r**18
            +25281*r**20)+Q2*(-1+r**2)**3*(-29988+143179*r**2+1720289*r**4-6702816*r**6
            +1477784*r**8+4685590*r**10+3197586*r**12+5360376*r**14+7630356*r**16
            -107769*r**18+769413*r**20)+10*Q2**3*(5341-11292*r**2-371276*r**4+997009*r**6
            -995854*r**8-571080*r**10-147664*r**12+382810*r**14-1089079*r**16+2087180*r**18
            -573564*r**20+287469*r**22)+Q2**2*(-69909+466538*r**2+2994816*r**4-14939500*r**6
            +20583785*r**8-3094872*r**10+952364*r**12-2136652*r**14-5775975*r**16
            +19919390*r**18-21566844*r**20+4944648*r**22-2277789*r**24))*sqrtq2-384*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(4656*Q2**17*r**2-4*Q2**16*(-4025+29301*r**2
            +13560*r**4)+4*Q2**15*(-33915+173959*r**2+332147*r**4+64161*r**6)-Q2**14*(
            -463925+2049671*r**2+6780185*r**4+5508151*r**6+601950*r**8)+2*Q2**13*(
            -374605+2243625*r**2+6002282*r**4+1678596*r**6+4164467*r**8+276675*r**10)
            +Q2**12*(298655-9872017*r**2-2600340*r**4+146601032*r**6+135666425*r**8
            +8729489*r**10+584052*r**12)-4*Q2**11*(-231280-4659131*r**2+2991439*r**4
            +147236034*r**6+289270594*r**8+139608749*r**10+12919151*r**12+520380*r**14)
            +Q2**10*(-1544235-22194735*r**2+9501973*r**4+953067611*r**6+2846105125*r**8
            +3021455135*r**10+859028971*r**12+68523365*r**14+1745238*r**16)+2*Q2**9*(279125
            +5795841*r**2-13473290*r**4-384506844*r**6-1131915080*r**8-1749558270*r**10
            -1412324414*r**12-45862060*r**14-73349*r**16+406725*r**18)-Q2**8*(-818895
            -3654615*r**2-84100182*r**4-491668006*r**6+890470948*r**8+5610996100*r**10
            +4947223110*r**12+1819512278*r**14+1493478459*r**16+96097443*r**18+2640000*r**20)
            +4*Q2**7*(-230615-1918911*r**2-22686315*r**4-129886211*r**6+464456190*r**8
            +3445614778*r**10+6608535690*r**12+3972723470*r**14+1558621729*r**16
            +462231085*r**18+23413593*r**20+383757*r**22)+Q2**6*(88935+3591779*r**2
            +25238257*r**4+273258847*r**6-199821868*r**8-8083222218*r**10-24872273910*r**12
            -34287250778*r**14-8836672153*r**16-4414465193*r**18-186773803*r**20
            +3620395*r**22+678510*r**24)-2*Q2**5*(-182525+1022549*r**2-2129110*r**4
            -133904188*r**6+182074025*r**8-1405616455*r**10-52111404*r**12-5142992712*r**14
            -7680651411*r**16+5954564575*r**18+260346690*r**20+673786340*r**22+32699047*r**24
            +659379*r**26)+Q2**4*(-199675+1861989*r**2+13825040*r**4-372087236*r**6
            +49064585*r**8-4574003935*r**10+3856760092*r**12+17237300160*r**14+5350472567*r**16
            +2665715495*r**18+17066338640*r**20+2302742724*r**22+1067888955*r**24
            +40622099*r**26+514500*r**28)-(-1+r**2)**3*(2345-165468*r**2-3653345*r**4
            +4213008*r**6-116202759*r**8-384811156*r**10+1936178071*r**12-9002208200*r**14
            +5223578419*r**16+4839613628*r**18-2105105963*r**20+1166707872*r**22
            +42596395*r**24+31322548*r**26+884981*r**28+9624*r**30)+4*Q2**3*(-5390
            +57565*r**2-1481049*r**4+19094588*r**6+9956016*r**8+621706335*r**10
            -206534955*r**12-375594042*r**14-5438779686*r**16+2053206763*r**18-2788047695*r**20
            -722150560*r**22-323084284*r**24-9797927*r**26+581971*r**28+40350*r**30)
            -Q2**2*(-55055+1539245*r**2+15613325*r**4-95302237*r**6+342362235*r**8
            -681654379*r**10-1576967699*r**12+1220656435*r**14+5906222589*r**16-25051915025*r**18
            +33063160223*r**20-20249429807*r**22+7212583665*r**24-456732977*r**26
            +336592615*r**28+13110361*r**30+216486*r**32)+2*Q2*(-9765+455763*r**2
            +6761482*r**4-33637268*r**6+210570022*r**8-223612708*r**10-922698382*r**12
            +4957142836*r**14-3481924164*r**16+868319106*r**18-13335320514*r**20
            +18273598100*r**22-8917783318*r**24+2604291932*r**26-95912378*r**28+86833612*r**30
            +2887769*r**32+37875*r**34))*sqrtq2))/(-9797760000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-136080000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-94500*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5+23514624000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+1632960000*logq2**3*(-Q2+(-1
            +r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+5670000*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(flagPERP*muWC**2*(29030400*logq2**4*(-Q2+(-1+r)**2)*r**16*(-Q2+(1+r)**2)*(
            -120*Q2**8*r**2+30*Q2**7*(1+19*r**2+32*r**4)-6*Q2**6*(16+185*r**2+580*r**4
            +539*r**6)+Q2**5*(96+746*r**2+4710*r**4+8559*r**6+5649*r**8)-Q2**4*(30
            -227*r**2+2070*r**4+7575*r**6+10332*r**8+4620*r**10)+Q2**3*(300-1183*r**2
            +377*r**4+2005*r**6+4623*r**8+5928*r**10-210*r**12)+(-1+r**2)**3*(276
            -733*r**2+1478*r**4+68*r**6+408*r**8+567*r**10+636*r**12)+Q2**2*(-870
            +2062*r**2-1929*r**4+232*r**6-872*r**8+264*r**10-2457*r**12+3570*r**14)
            +Q2*(846-2753*r**2+6267*r**4-1059*r**6-2725*r**8+339*r**10-837*r**12
            +2553*r**14-2631*r**16))+5760*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-17784*Q2**14*r**2+2*Q2**13*(-1897+96261*r**2+92448*r**4)-2*Q2**12*(
            -15554+405615*r**2+882646*r**4+391197*r**6)+Q2**11*(-95382+1750339*r**2
            +6071923*r**4+6328463*r**6+1631841*r**8)-2*Q2**10*(-61369+1096899*r**2
            +4560520*r**4+6649091*r**6+5099489*r**8+647322*r**10)+Q2**9*(-10570
            +1968033*r**2+4044291*r**4-5702304*r**6-6463898*r**8+2850955*r**10-1369707*r**12)
            +4*Q2**8*(-35658-448491*r**2+1114939*r**4+13311700*r**6+28261739*r**8
            +18008755*r**10+3884124*r**12+1015452*r**14)-2*Q2**7*(-71022-676110*r**2
            +2673843*r**4+33385290*r**6+103349827*r**8+130770026*r**10+53465389*r**12
            +11683758*r**14+1463031*r**16)+2*Q2**6*(-27258-57369*r**2+619543*r**4
            +17000977*r**6+58654985*r**8+124500337*r**10+116525561*r**12+9453563*r**14
            +3934017*r**16-586116*r**18)+2*Q2**5*(22617-357987*r**2-73183*r**4-11576662*r**6
            +2995634*r**8+11071016*r**10-15469322*r**12-12990098*r**14+52951493*r**16
            +5486763*r**18+1620369*r**20)-2*Q2**4*(24290-185838*r**2-420537*r**4
            -14917407*r**6+1569580*r**8+47681716*r**10+103696522*r**12+61483838*r**14
            +50657978*r**16+52694826*r**18+6120615*r**20+848817*r**22)+Q2**3*(-13174
            +119817*r**2-838637*r**4-12247855*r**6-1484579*r**8-6965910*r**10+97517726*r**12
            +181952266*r**14-18152100*r**16+105864669*r**18+9439999*r**20+3191957*r**22
            -342579*r**24)+2*(-1+r**2)**3*(-3164-11103*r**2-89740*r**4-847083*r**6
            +4386372*r**8-26946120*r**10+8717478*r**12+11164272*r**14+16072218*r**16
            -1880137*r**18+2850294*r**20+170635*r**22+24078*r**24)+2*Q2**2*(26649
            -64220*r**2+379509*r**4-1334768*r**6-9129162*r**8+18487974*r**10-8693214*r**12
            -10067148*r**14-60601875*r**16+99979092*r**18-50614423*r**20+20473404*r**22
            +779204*r**24+378978*r**26)-Q2*(32102-18099*r**2+512869*r**4+3872*r**6
            -21603566*r**8+105464001*r**10-112916667*r**12+3028632*r**14+31351506*r**16
            -146886593*r**18+185388447*r**20-71030584*r**22+25227574*r**24+1124147*r**26
            +322359*r**28))-8*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-176*Q2**18*r**2
            +Q2**17*(-2313+4999*r**2-222*r**4)+Q2**16*(27831-41074*r**2-227095*r**4
            +12066*r**6)+Q2**15*(-148287-138957*r**2+3606965*r**4+2021143*r**6-64288*r**8)
            +Q2**14*(457500+1537255*r**2-16562010*r**4-29532198*r**6-7587314*r**8
            +155055*r**10)+Q2**13*(-892965-3181345*r**2+38572892*r**4+96612480*r**6
            +86558453*r**8+12289601*r**10-163212*r**12)-Q2**12*(-1121754+2510493*r**2
            +65636338*r**4+53435771*r**6-58849194*r**8+48169567*r**10-1476334*r**12
            +56329*r**14)+Q2**11*(-868143+20362963*r**2+107146983*r**4-232025547*r**6
            -1735903161*r**8-1560772827*r**10-295392063*r**12-38202749*r**14+363792*r**16)
            +Q2**10*(362736-33936121*r**2-136023706*r**4+421664136*r**6+4431318318*r**8
            +8166770862*r**10+4119315954*r**12+693458816*r**14+54731402*r**16-364221*r**18)
            -Q2**9*(91575-21181645*r**2-77296790*r**4+303668354*r**6+4229784392*r**8
            +11266065120*r**10+13220439390*r**12+3032713870*r**14+364737889*r**16
            +7597997*r**18+17160*r**20)+Q2**8*(120780+6296423*r**2+33451296*r**4
            +358745175*r**6+1671351804*r**8-655367502*r**10-149730396*r**12+3599958426*r**14
            -4357629480*r**16-680886441*r**18-58743652*r**20+327327*r**22)+Q2**7*(
            -128469-16259231*r**2-60774653*r**4-567877023*r**6-1514356458*r**8+10121742546*r**10
            +36902108478*r**12+31783864314*r**14+14018557167*r**16+9544669437*r**18
            +1116523663*r**20+58756885*r**22-233376*r**24)-Q2**6*(-3468-5459901*r**2
            -20002114*r**4-313283426*r**6-1803490402*r**8+3699693165*r**10+31771634460*r**12
            +70840959188*r**14+28834374240*r**16+17278746573*r**18+3985745574*r**20
            +303829262*r**22-335858*r**24+34307*r**26)+Q2**5*(79089+3801293*r**2
            -20924808*r**4+136772724*r**6+472726253*r**8-2165410791*r**10+7542644244*r**12
            +8767664080*r**14+61524304779*r**16-27783802209*r**18+7766490152*r**20
            -4860917892*r**22-582858537*r**24-36206533*r**26+130956*r**28)+Q2**4*(
            -46050-3025775*r**2+36468370*r**4-184713573*r**6-1720749494*r**8+2484523765*r**10
            -14312128170*r**12+22733394815*r**14+34318487426*r**16-47977225677*r**18
            +59434307470*r**20-1161609215*r**22+5691358230*r**24+538582087*r**26
            +21826186*r**28-58395*r**30)+(-1+r**2)**3*(-837-3046*r**2+2845574*r**4
            +10677976*r**6-5786832*r**8+636089126*r**10+579280450*r**12-7565546468*r**14
            +35283444978*r**16-44760554106*r**18+19864115914*r**20-6192595232*r**22
            +385535744*r**24-183526854*r**26-13122962*r**28-406228*r**30+803*r**32)
            -Q2**3*(5565-136473*r**2+9291263*r**4-32128595*r**6-548907843*r**8+1583135399*r**10
            -13085842265*r**12+14953442869*r**14+10951896895*r**16+20239085981*r**18
            -13551566763*r**20+18835537199*r**22+2530346743*r**24+1021735125*r**26
            +60517637*r**28-1430801*r**30+10064*r**32)+Q2**2*(15528+414725*r**2
            -17784462*r**4+8798844*r**6+300967314*r**8-1337026464*r**10+2354495562*r**12
            +8126035036*r**14-31279960998*r**16+78431910642*r**18-107631524906*r**20
            +76903236756*r**22-29545361226*r**24+5188014504*r**26-1362453906*r**28
            -133036908*r**30-6758218*r**32+18177*r**34)-2*Q2*(3078+51520*r**2-6765674*r**4
            -1673415*r**6+97502733*r**8-1106398491*r**10+2806710273*r**12-4643078395*r**14
            +11143999493*r**16-55372148991*r**18+119279219273*r**20-111857961781*r**22
            +52742661687*r**24-14476213041*r**26+1848212883*r**28-416606985*r**30
            -36087887*r**32-1429493*r**34+3213*r**36))+2612736000*logq2**5*r**20*(
            -5+5*r**2-r**4+r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-69120*logq2**3*r**12*(29160*Q2**13*r**2
            -2*Q2**12*(2177+137211*r**2+163152*r**4)+2*Q2**11*(20979+566801*r**2
            +1272501*r**4+787719*r**6)-Q2**10*(165669+2687654*r**2+8235344*r**4
            +9910704*r**6+4179189*r**8)+5*Q2**9*(69440+793675*r**2+2824818*r**4
            +4749284*r**6+4088190*r**8+1239681*r**10)-5*Q2**8*(79527+768303*r**2
            +2658408*r**4+5103272*r**6+6177745*r**8+4463697*r**10+741240*r**12)
            +Q2**7*(183288+2928534*r**2+6516638*r**4+8142060*r**6+5574460*r**8+7914598*r**10
            +8488974*r**12-3490632*r**14)+2*Q2**6*(57477-1289742*r**2-960232*r**4
            +2684222*r**6+12928820*r**8+20271952*r**10+13282598*r**12+3857028*r**14
            +4392837*r**16)-(-1+r**2)**5*(-4879+17066*r**2+337776*r**4-1881054*r**6
            +1045786*r**8+195594*r**10+1135624*r**12+1267014*r**14+52269*r**16+102804*r**18)
            -2*Q2**5*(103026-1153884*r**2-267669*r**4+1296371*r**6+11237571*r**8
            +22747851*r**10+27318521*r**12+15075361*r**14+5614311*r**16+3327741*r**18)
            +20*Q2**4*(3885-57315*r**2+88408*r**4-194841*r**6+412506*r**8+894406*r**10
            +999843*r**12+1322333*r**14+119309*r**16+364425*r**18+25281*r**20)+Q2*(
            -1+r**2)**3*(-29988+143179*r**2+1720289*r**4-6702816*r**6+1477784*r**8
            +4685590*r**10+3197586*r**12+5360376*r**14+7630356*r**16-107769*r**18
            +769413*r**20)+10*Q2**3*(5341-11292*r**2-371276*r**4+997009*r**6-995854*r**8
            -571080*r**10-147664*r**12+382810*r**14-1089079*r**16+2087180*r**18
            -573564*r**20+287469*r**22)+Q2**2*(-69909+466538*r**2+2994816*r**4-14939500*r**6
            +20583785*r**8-3094872*r**10+952364*r**12-2136652*r**14-5775975*r**16
            +19919390*r**18-21566844*r**20+4944648*r**22-2277789*r**24))*sqrtq2-48*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(4656*Q2**17*r**2-4*Q2**16*(-4025+29301*r**2
            +13560*r**4)+4*Q2**15*(-33915+173959*r**2+332147*r**4+64161*r**6)-Q2**14*(
            -463925+2049671*r**2+6780185*r**4+5508151*r**6+601950*r**8)+2*Q2**13*(
            -374605+2243625*r**2+6002282*r**4+1678596*r**6+4164467*r**8+276675*r**10)
            +Q2**12*(298655-9872017*r**2-2600340*r**4+146601032*r**6+135666425*r**8
            +8729489*r**10+584052*r**12)-4*Q2**11*(-231280-4659131*r**2+2991439*r**4
            +147236034*r**6+289270594*r**8+139608749*r**10+12919151*r**12+520380*r**14)
            +Q2**10*(-1544235-22194735*r**2+9501973*r**4+953067611*r**6+2846105125*r**8
            +3021455135*r**10+859028971*r**12+68523365*r**14+1745238*r**16)+2*Q2**9*(279125
            +5795841*r**2-13473290*r**4-384506844*r**6-1131915080*r**8-1749558270*r**10
            -1412324414*r**12-45862060*r**14-73349*r**16+406725*r**18)-Q2**8*(-818895
            -3654615*r**2-84100182*r**4-491668006*r**6+890470948*r**8+5610996100*r**10
            +4947223110*r**12+1819512278*r**14+1493478459*r**16+96097443*r**18+2640000*r**20)
            +4*Q2**7*(-230615-1918911*r**2-22686315*r**4-129886211*r**6+464456190*r**8
            +3445614778*r**10+6608535690*r**12+3972723470*r**14+1558621729*r**16
            +462231085*r**18+23413593*r**20+383757*r**22)+Q2**6*(88935+3591779*r**2
            +25238257*r**4+273258847*r**6-199821868*r**8-8083222218*r**10-24872273910*r**12
            -34287250778*r**14-8836672153*r**16-4414465193*r**18-186773803*r**20
            +3620395*r**22+678510*r**24)-2*Q2**5*(-182525+1022549*r**2-2129110*r**4
            -133904188*r**6+182074025*r**8-1405616455*r**10-52111404*r**12-5142992712*r**14
            -7680651411*r**16+5954564575*r**18+260346690*r**20+673786340*r**22+32699047*r**24
            +659379*r**26)+Q2**4*(-199675+1861989*r**2+13825040*r**4-372087236*r**6
            +49064585*r**8-4574003935*r**10+3856760092*r**12+17237300160*r**14+5350472567*r**16
            +2665715495*r**18+17066338640*r**20+2302742724*r**22+1067888955*r**24
            +40622099*r**26+514500*r**28)-(-1+r**2)**3*(2345-165468*r**2-3653345*r**4
            +4213008*r**6-116202759*r**8-384811156*r**10+1936178071*r**12-9002208200*r**14
            +5223578419*r**16+4839613628*r**18-2105105963*r**20+1166707872*r**22
            +42596395*r**24+31322548*r**26+884981*r**28+9624*r**30)+4*Q2**3*(-5390
            +57565*r**2-1481049*r**4+19094588*r**6+9956016*r**8+621706335*r**10
            -206534955*r**12-375594042*r**14-5438779686*r**16+2053206763*r**18-2788047695*r**20
            -722150560*r**22-323084284*r**24-9797927*r**26+581971*r**28+40350*r**30)
            -Q2**2*(-55055+1539245*r**2+15613325*r**4-95302237*r**6+342362235*r**8
            -681654379*r**10-1576967699*r**12+1220656435*r**14+5906222589*r**16-25051915025*r**18
            +33063160223*r**20-20249429807*r**22+7212583665*r**24-456732977*r**26
            +336592615*r**28+13110361*r**30+216486*r**32)+2*Q2*(-9765+455763*r**2
            +6761482*r**4-33637268*r**6+210570022*r**8-223612708*r**10-922698382*r**12
            +4957142836*r**14-3481924164*r**16+868319106*r**18-13335320514*r**20
            +18273598100*r**22-8917783318*r**24+2604291932*r**26-95912378*r**28+86833612*r**30
            +2887769*r**32+37875*r**34))*sqrtq2))/(-3265920000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-45360000*logq2**2*(-Q2+(
            -1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-31500*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5+7838208000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+544320000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+1890000*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(flagPERP*(-16588800*logq2**4*(-Q2+(-1+r)**2)*r**16*(-Q2+(1+r)**2)*(240*Q2**8*r**2
            -30*Q2**7*(7+50*r**2+36*r**4)+6*Q2**6*(266+735*r**2+837*r**4+140*r**6)
            +Q2**5*(-4431-8071*r**2-9867*r**4-2727*r**6+3255*r**8)+Q2**4*(5145
            +8463*r**2+10265*r**4+3621*r**6-7935*r**8-5985*r**10)-Q2**3*(840+6167*r**2
            +3532*r**4+304*r**6-7221*r**8-10755*r**10+1995*r**12)+(-1+r**2)**2*(
            -819+3026*r**2-3897*r**4-222*r**6+6253*r**8-138*r**10-1083*r**12+3180*r**14)
            +Q2**2*(-3570+9163*r**2-7256*r**4-1146*r**6+823*r**8-1104*r**10-7515*r**12
            +12705*r**14)+Q2*(3129-11202*r**2+16166*r**4+1809*r**6-13731*r**8
            -16370*r**10-5184*r**12+11343*r**14-11160*r**16))-4608*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(57168*Q2**14*r**2-2*Q2**13*(-5845+310746*r**2
            +288516*r**4)+Q2**12*(-97440+2678738*r**2+5412962*r**4+2400408*r**6)
            -Q2**11*(-311885+5670277*r**2+19448798*r**4+18479733*r**6+5158527*r**8)
            +Q2**10*(-406035+5114903*r**2+31187308*r**4+45167948*r**6+30074793*r**8
            +5502303*r**10)-Q2**9*(109375-1914214*r**2+10624190*r**4+9327810*r**6
            +20463435*r**8+19768700*r**10+1003236*r**12)-Q2**8*(-982695+8517566*r**2
            +37413211*r**4+139668380*r**6+179830575*r**8+66020850*r**10+4925001*r**12
            +4182336*r**14)+2*Q2**7*(-504735+2896037*r**2+27332808*r**4+118015867*r**6
            +226287510*r**8+172280965*r**10+46978302*r**12+6607803*r**14+2237967*r**16)
            -2*Q2**6*(55335-1171277*r**2+9893187*r**4+53666742*r**6+165987353*r**8
            +217919090*r**10+107190853*r**12+23966922*r**14+4429332*r**16+832023*r**18)
            +4*Q2**5*(242655-1333589*r**2-3588274*r**4-17464864*r**6-28069744*r**8
            +11650261*r**10+33903421*r**12+15583626*r**14+16154511*r**16+3465906*r**18
            +83511*r**20)-2*Q2**4*(324625-1038809*r**2-7383795*r**4-38767680*r**6
            -134930980*r**8-117932660*r**10-19151192*r**12+47345910*r**14+53577395*r**16
            +47152645*r**18+7911075*r**20+107466*r**22)+Q2**3*(-51135+1071683*r**2
            -4782482*r**4-18535145*r**6-74648325*r**8-136988350*r**10+3426424*r**12
            +174209514*r**14-6842005*r**16+143071675*r**18+13564810*r**20+2726143*r**22
            -362007*r**24)+(-1+r**2)**2*(19915-39592*r**2+357464*r**4+6433228*r**6
            -38999325*r**8+134836920*r**10-60268716*r**12-61967028*r**14-45600531*r**16
            +115400300*r**18-20550860*r**20+14446408*r**22+1214789*r**24+77028*r**26)
            +Q2**2*(260785-1356937*r**2+2139322*r**4+14240208*r**6-115580595*r**8
            +212437305*r**10-174402996*r**12-23795904*r**14-258619341*r**16+368938745*r**18
            -147183590*r**20+69561008*r**22+7284207*r**24+717783*r**26)-Q2*(124215
            -531098*r**2+1644178*r**4+17850358*r**6-138931683*r**8+395815020*r**10
            -330097044*r**12+110698164*r**14+132314889*r**16-381610794*r**18+445838090*r**20
            -130719658*r**22+53480483*r**24+5162328*r**26+402552*r**28))+32*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-176*Q2**18-Q2**17*(2535+1676*r**2)
            +Q2**16*(32913+364661*r**2+31652*r**4)-Q2**15*(68917+3787700*r**2+3771553*r**4
            +177696*r**6)+Q2**14*(-186186+14930971*r**2+33942285*r**4+15925827*r**6
            +525835*r**8)-Q2**13*(-732732+26050717*r**2+105692368*r**4+111027624*r**6
            +32799280*r**8+907327*r**10)+Q2**12*(324509+9485791*r**2+95086832*r**4
            +107830116*r**6+132834703*r**8+25415813*r**10+849708*r**12)+Q2**11*(
            -4735695+35935918*r**2+174035451*r**4+860194842*r**6+730239207*r**8
            +78154746*r**10+25696893*r**12-186626*r**14)-Q2**10*(-7878420+51117673*r**2
            +455427703*r**4+2689270611*r**6+4581253617*r**8+2298868719*r**10+369632889*r**12
            +71295877*r**14+445027*r**16)+Q2**9*(-2284128+6347953*r**2+273545720*r**4
            +2278224806*r**6+7588991340*r**8+7470882852*r**10+2238303088*r**12+320261170*r**14
            +42657116*r**16+366355*r**18)+Q2**8*(-7905711+29243549*r**2+120166776*r**4
            +1776146298*r**6-1548013800*r**8-4035751620*r**10-3769240026*r**12+219460086*r**14
            -2011977*r**16+29382855*r**18+121682*r**20)-Q2**7*(-9312237+5292944*r**2
            +126690299*r**4+4437162732*r**6+7584211446*r**8+12328513824*r**10+7299356238*r**12
            +1118301864*r**14+1733839047*r**16+122705136*r**18+50863751*r**20+262988*r**22)
            +Q2**6*(-631274-24250639*r**2-17896433*r**4+1874113581*r**6+6883024941*r**8
            +15156693138*r**10+20234085838*r**12+7332891090*r**14+985613736*r**16
            +858975661*r**18+78073619*r**20+12183601*r**22+6021*r**24)+Q2**5*(-5624664
            +13151621*r**2-112252680*r**4+1821627060*r**6-1866941356*r**8+2250779013*r**10
            -7611706416*r**12-8755730960*r**14-1615778544*r**16-1282968081*r**18
            -175004776*r**20-126163332*r**22+18061908*r**24+163367*r**26)+Q2**4*(3753939
            +7632901*r**2+209951320*r**4-2113533408*r**6+1413307675*r**8-10066028003*r**10
            -6957706272*r**12+699243080*r**14+1370609321*r**16+3452772735*r**18+2930899984*r**20
            +412158616*r**22+139818345*r**24-12844193*r**26-90440*r**28)-Q2**3*(
            -105655+8863882*r**2+44640383*r**4-316660626*r**6+585467545*r**8-2566777246*r**10
            -5087246889*r**12+3816175574*r**14-720240173*r**16+2043625630*r**18+2367671797*r**20
            +1524887882*r**22+224304843*r**24+13040374*r**26+118325*r**28+13554*r**30)
            +2*(-1+r**2)**2*(-36857-161613*r**2-6810851*r**4+35146072*r**6-233476106*r**8
            -16624739*r**10+3287333199*r**12-13455588938*r**14+20748902706*r**16
            -14279266723*r**18+4617951579*r**20-955820164*r**22-34667986*r**24-29099053*r**26
            -4448071*r**28+74742*r**30+803*r**32)+Q2**2*(-1128336+2016029*r**2-92595333*r**4
            +654708291*r**6-2153606607*r**8+3252444525*r**10-1274435037*r**12+2290651051*r**14
            +7064801553*r**16-16654038801*r**18+12936995113*r**20-3971069823*r**22
            -275119893*r**24-186126969*r**26-72474567*r**28+3043473*r**30+31331*r**32)
            +Q2*(500931+431635*r**2+65255680*r**4-451471698*r**6+2224528152*r**8
            -3042024930*r**10-6513831000*r**12+23634794558*r**14+2182533326*r**16
            -57386238084*r**18+60936658352*r**20-24714711430*r**22+5251155984*r**24
            +197165922*r**26+182264232*r**28+46919322*r**30-1182905*r**32-12047*r**34))
            -10450944000*logq2**5*r**20*(-1+r**4+2*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2-276480*logq2**3*r**12*(12240*Q2**13*r**2-2*Q2**12*(805+65346*r**2
            +58056*r**4)+2*Q2**11*(6685+309522*r**2+509229*r**4+233412*r**6)-Q2**10*(45010
            +1658977*r**2+3781563*r**4+3251763*r**6+1023657*r**8)+5*Q2**9*(14840
            +527967*r**2+1486895*r**4+1785987*r**6+1082181*r**8+265818*r**10)-5*Q2**8*(9240
            +457741*r**2+1493862*r**4+2234432*r**6+1988952*r**8+1010871*r**10+229734*r**12)
            +2*Q2**7*(-18690+237437*r**2+747282*r**4+1541385*r**6+2560700*r**8+2909985*r**10
            +1622772*r**12+528777*r**14)-4*Q2**6*(-21315-277423*r**2-1283996*r**4
            -1999003*r**6-1593305*r**8+172455*r**10+1141077*r**12+719649*r**14+326187*r**16)
            +2*Q2**5*(-23940-631588*r**2-2903952*r**4-4675197*r**6-4455058*r**8
            -773655*r**10+2621752*r**12+2520273*r**14+1522998*r**16+488367*r**18)
            +10*Q2**4*(-945+68164*r**2+143010*r**4+497731*r**6+175533*r**8-268233*r**10
            -524859*r**12-520271*r**14+133824*r**16-214263*r**18+25461*r**20)+(
            -1+r**2)**4*(140+9813*r**2-202046*r**4+926700*r**6-769394*r**8+310202*r**10
            -49598*r**12-371164*r**14+840390*r**16+4209*r**18+56748*r**20)-10*Q2**3*(
            -2345+30131*r**2-240131*r**4+627487*r**6-420684*r**8-379492*r**10+6024*r**12
            +12172*r**14-385635*r**16+990889*r**18-153453*r**20+116637*r**22)-Q2*(
            -1+r**2)**2*(-1120+56771*r**2-1198771*r**4+4441728*r**6-3092088*r**8
            +162606*r**10+2100178*r**12+730096*r**14-2025728*r**16+4692663*r**18
            -192711*r**20+374376*r**22)+Q2**2*(-10010+155293*r**2-2812977*r**4+9699175*r**6
            -10402295*r**8+3060690*r**10+2470954*r**12+5101414*r**14+5242620*r**16
            -10614735*r**18+10741815*r**20-1516077*r**22+980133*r**24))*sqrtq2-192*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(9312*Q2**17*r**2-4*Q2**16*(-805+31950*r**2
            +31368*r**4)+4*Q2**15*(-6685+161502*r**2+404131*r**4+169116*r**6)-Q2**14*(
            -86205+1568566*r**2+7173691*r**4+7409140*r**6+1895670*r**8)+2*Q2**13*(
            -55335+877182*r**2+6391588*r**4+7546174*r**6+7529917*r**8+1386990*r**10)
            -Q2**12*(55545+325312*r**2+892928*r**4-68024936*r**6-55484733*r**8+7582332*r**10
            +1205856*r**12)-4*Q2**11*(-88830+138939*r**2+7316008*r**4+90026929*r**6
            +162887050*r**8+76015549*r**10+6217412*r**12+641391*r**14)+Q2**10*(-367675
            -1123030*r**2+36823099*r**4+594075420*r**6+1792409349*r**8+1705822874*r**10
            +526212217*r**12+49659184*r**14+4273698*r**16)-2*Q2**9*(51205-825816*r**2
            +4872884*r**4+96431950*r**6+833807240*r**8+1312272220*r**10+895413124*r**12
            +152528314*r**14+14089355*r**16+642180*r**18)-Q2**8*(-523215-2287872*r**2
            -5690958*r**4+626144376*r**6+913254048*r**8+1261991140*r**10+202088558*r**12
            -313915968*r**14+199085991*r**16+14213508*r**18+2551560*r**20)+4*Q2**7*(
            -88165-1312728*r**2-7969281*r**4+197575162*r**6+740554886*r**8+1732027876*r**10
            +2057652454*r**12+790695704*r**14+170255247*r**16+87188276*r**18+6605931*r**20
            +630894*r**22)+Q2**6*(-117425+1964862*r**2+15376235*r**4-107758348*r**6
            -1798025460*r**8-5044647308*r**10-10384226762*r**12-8058157568*r**14
            -1879903593*r**16-424735010*r**18-152762433*r**20-12860644*r**22+69294*r**24)
            +2*Q2**5*(143535+1355918*r**2+18809060*r**4-209996206*r**6-78374599*r**8
            -662949094*r**10+177607368*r**12+2139634132*r**14+1113700217*r**16+581191826*r**18
            +260611316*r**20+44953946*r**22+2255135*r**24-650394*r**26)+Q2**4*(-123795
            -2844816*r**2-44458316*r**4+296284040*r**6+471841525*r**8+2272449820*r**10
            +6261334512*r**12+1755882032*r**14-1136786505*r**16-924153720*r**18-2563155940*r**20
            -818410136*r**22-118116281*r**24-2390900*r**26+629280*r**28)+4*Q2**3*(
            -7980+107941*r**2+1499054*r**4+2511507*r**6-55651184*r**8-21011415*r**10
            -810178302*r**12+57571407*r**14+221197076*r**16+46474703*r**18+579675250*r**20
            +243457961*r**22+84712264*r**24+3269667*r**26-455394*r**28+30645*r**30)
            +Q2**2*(49455+643662*r**2+15312277*r**4-103829084*r**6+285839973*r**8
            +52386658*r**10-2229257831*r**12+3134616736*r**14-1959850417*r**16-6026543886*r**18
            +9059347279*r**20-5204165324*r**22+1817549687*r**24+163304926*r**26+83714563*r**28
            +3897608*r**30-216282*r**32)-(-1+r**2)**2*(-2345-65626*r**2-1854889*r**4
            +5984320*r**6-47439045*r**8-275719454*r**10+1938692851*r**12-6012321852*r**14
            +4658322525*r**16+2971961450*r**18-4803909227*r**20+1599597976*r**22
            -516519559*r**24-47590770*r**26-13103455*r**28-362524*r**30+9624*r**32)
            +2*Q2*(-8995-183028*r**2-4702628*r**4+26616782*r**6-116212870*r**8
            -241815308*r**10+2486307572*r**12-6566587018*r**14+5601093876*r**16-4012394060*r**18
            +7740793636*r**20-8223996790*r**22+3180020950*r**24-857273108*r**26-69788020*r**28
            -29502158*r**30-1047329*r**32+38496*r**34))*sqrtq2))/(-3265920000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -45360000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3-31500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5+7838208000*logq2**5*r**22*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2+544320000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+1890000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(16588800*logq2**4*r**14*(240*Q2**10*(2+5*r**4)-60*Q2**9*(94+101*r**2
            +207*r**4+130*r**6)+6*Q2**8*(4860+9135*r**2+12334*r**4+10171*r**6+2700*r**8)
            +Q2**7*(-83115-206985*r**2-257752*r**4-220950*r**6-90333*r**8+2475*r**10)
            +Q2**6*(136395+397005*r**2+493517*r**4+440608*r**6+218607*r**8-7497*r**10
            -58275*r**12)+3*Q2**5*(-38745-126315*r**2-149848*r**4-154328*r**6-81845*r**8
            -5447*r**10+29078*r**12+22050*r**14)+(-1+r**2)**4*(-5295-1515*r**2
            +12089*r**4-30135*r**6+33915*r**8+73675*r**10-38745*r**12+15711*r**14
            +15900*r**16)+Q2**4*(12915+126105*r**2+139415*r**4+167910*r**6+101619*r**8
            -10879*r**10-61995*r**12+75600*r**14+53550*r**16)-Q2*(-1+r**2)**2*(
            -32055-8775*r**2+61087*r**4-181678*r**6+89880*r**8+411845*r**10+258475*r**12
            -156672*r**14+75093*r**16+87600*r**18)-Q2**3*(-75015-29085*r**2+56014*r**4
            -169219*r**6+1941*r**8+304330*r**10+155324*r**12-159411*r**14+206136*r**16
            +192825*r**18)+3*Q2**2*(-25245+6885*r**2+42599*r**4-131085*r**6+33124*r**8
            +167335*r**10+177730*r**12+174821*r**14-120075*r**16+13436*r**18+63675*r**20))
            +4608*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(48*Q2**16*(838+5955*r**4)
            -4*Q2**15*(115086+92281*r**2+723555*r**4+864210*r**6)+2*Q2**14*(1132020
            +1819411*r**2+7153190*r**4+15360775*r**6+9029100*r**8)-Q2**13*(6062805
            +14976983*r**2+43559448*r**4+120434570*r**6+134641855*r**8+52681875*r**10)
            +Q2**12*(8763615+31761437*r**2+69492641*r**4+252228032*r**6+387303175*r**8
            +308413235*r**10+91098825*r**12)-Q2**11*(3704022+30348218*r**2-33218587*r**4
            +125513553*r**6+328176528*r**8+448962072*r**10+365622605*r**12+85831845*r**14)
            +Q2**10*(-9696918-11224756*r**2-431228895*r**4-915897800*r**6-1320104945*r**8
            -1171642776*r**10-347392653*r**12+124808260*r**14+16632195*r**16)+Q2**9*(18851745
            +64970231*r**2+933837305*r**4+2852840125*r**6+5100395095*r**8+6044378435*r**10
            +4203949251*r**12+1544529415*r**14+224658700*r**16+59186850*r**18)-Q2**8*(11581515
            +70765809*r**2+838223784*r**4+3722446430*r**6+7260934980*r**8+10218802340*r**10
            +9198204694*r**12+5047360794*r**14+1782447585*r**16+336651315*r**18+73991250*r**20)
            +2*Q2**7*(-2548590+10700688*r**2-81188991*r**4+914255153*r**6+1352749420*r**8
            +2471321070*r**10+3402726318*r**12+2896150584*r**14+1375226418*r**16
            +669262050*r**18+127026465*r**20+20345175*r**22)-2*Q2**6*(-6607986-12613643*r**2
            -573488343*r**4-406225493*r**6-2402483023*r**8-3611757844*r**10-2348027518*r**12
            +30572132*r**14+1444601632*r**16+735581727*r**18+732147589*r**20+107602545*r**22
            +6367665*r**24)+Q2**5*(-7975107-30764441*r**2-1047937990*r**4-1369733260*r**6
            -6109730745*r**8-10866330877*r**10-10013433212*r**12-5705151680*r**14
            +156001995*r**16+3541298405*r**18+1584877714*r**20+1393134428*r**22+175143265*r**24
            +2009505*r**26)+(-1+r**2)**4*(-54381-210203*r**2-16395496*r**4+37320860*r**6
            -211843025*r**8+198926577*r**10+736984476*r**12-215859408*r**14-899793615*r**16
            +437532135*r**18+419929304*r**20-32371148*r**22+83990029*r**24+5778755*r**26
            +385140*r**28)+Q2**4*(-122535+13857947*r**2+182210865*r**4+759602400*r**6
            +1152709455*r**8+4433877135*r**10+3314220251*r**12+2455541080*r**14+355871775*r**16
            +930412745*r**18-546174625*r**20-844170648*r**22-73416295*r**24-32457875*r**26
            +6134325*r**28)-Q2*(-1+r**2)**2*(-492951-1061959*r**2-118227404*r**4
            +274064934*r**6-1369318985*r**8+945468947*r**10+3247233198*r**12-850025412*r**14
            +474010287*r**16-2528283225*r**18+1619857264*r**20+2474718686*r**22-348999759*r**24
            +496834829*r**26+35998510*r**28+2783040*r**30)-Q2**3*(-2922570+2247458*r**2
            -377729407*r**4+807717625*r**6-3163267960*r**8+1251681580*r**10+504013719*r**12
            -2325064401*r**14-579670770*r**16-2555941470*r**18+3172963615*r**20+4532850823*r**22
            -804813292*r**24+1182172720*r**26+86585705*r**28+11000625*r**30)+Q2**2*(
            -1796310-243688*r**2-332550859*r**4+936445312*r**6-3755572965*r**8+3679851120*r**10
            +2800326121*r**12-3482035632*r**14+2816936931*r**16+6250094040*r**18
            -4955843345*r**20-594358208*r**22+5816223041*r**24-1664897568*r**26+1106087475*r**28
            +82454960*r**30+7999575*r**32))-32*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(
            -1088*Q2**20*r**2-4*Q2**19*r**2*(3254+2527*r**2)+4*Q2**18*(6984+21070*r**2
            +437053*r**4+61039*r**6)-4*Q2**17*(73854-171626*r**2+3014129*r**4+5281142*r**6
            +424263*r**8)+Q2**16*(1326024-7616863*r**2+10708800*r**4+133192066*r**6
            +110588280*r**8+6453933*r**10)-Q2**15*(3118554-31531241*r**2-150313053*r**4
            +168955990*r**6+559106952*r**8+310985011*r**10+15463707*r**12)+Q2**14*(3388050
            -76009897*r**2-739442852*r**4-828150155*r**6-117685638*r**8+976472905*r**10
            +461342488*r**12+24222699*r**14)+Q2**13*(1176462+117929405*r**2+1833019065*r**4
            +4035889717*r**6+6813848013*r**8+5387219375*r**10+114960835*r**12-172718721*r**14
            -23983863*r**16)+Q2**12*(-8597862-111367537*r**2-2873005284*r**4-9065034328*r**6
            -21798363408*r**8-33373604106*r**10-21103165356*r**12-3496517712*r**14
            -615526906*r**16+12576291*r**18)+Q2**11*(9946638+24048549*r**2+2376833185*r**4
            +12146252716*r**6+31815516512*r**8+71668770270*r**10+76615036110*r**12
            +36282863212*r**14+6183276442*r**16+1160980645*r**18-637559*r**20)-Q2**10*(815958
            -115695195*r**2-1128092708*r**4+6620899277*r**6+2012840548*r**8+49048420610*r**10
            +88665167472*r**12+76598873210*r**14+24815634998*r**16+4453422329*r**18
            +720515972*r**20+881881*r**22)-Q2**9*(9459450+204896583*r**2+5985540467*r**4
            +7571950725*r**6+84026083939*r**8+109965770630*r**10+82424373502*r**12
            +25337876474*r**14-6487207040*r**16+11502502019*r**18-201432865*r**20
            +254002353*r**22+4454099*r**24)+Q2**8*(9284418+148767325*r**2+6790054364*r**4
            +16708903958*r**6+146759336214*r**8+294394151871*r**10+359794833240*r**12
            +295372365172*r**14+138383580222*r**16+46805498859*r**18+33170043532*r**20
            +1901361590*r**22+651899306*r**24+5602233*r**26)-Q2**7*(904878-9202987*r**2
            +1263538329*r**4+12129584710*r**6+68122705248*r**8+257617249959*r**10
            +309010861599*r**12+384739997348*r**14+246136316902*r**16+97896992451*r**18
            +37377275975*r**20+23120353110*r**22+1889799628*r**24+267617409*r**26
            +795201*r**28)+Q2**6*(-4702698-113996459*r**2-4785719340*r**4+5289423595*r**6
            -105134994174*r**8+96159586285*r**10-134605463928*r**12+14050429531*r**14
            +150135100474*r**16+68074935271*r**18+64288585396*r**20+33751587849*r**22
            +7012162606*r**24+2151622743*r**26-161640080*r**28-2970831*r**30)+Q2**5*(3603978
            +91016839*r**2+5075059355*r**4-4257705781*r**6+175555714407*r**8-116949353701*r**10
            +405247882799*r**12+228394781439*r**14+159936830335*r**16-142688920811*r**18
            +12865882481*r**20-101359146943*r**22-45176325499*r**24-1821897399*r**26
            -2004503611*r**28+193228277*r**30+2333835*r**32)+2*(-1+r**2)**4*(7767
            +336787*r**2+25802988*r**4-145684328*r**6+2324017000*r**8-13079872076*r**10
            +42016399156*r**12-71280856848*r**14+24865187926*r**16+58748744970*r**18
            -65447245804*r**20+24238088472*r**22-5593858048*r**24-419913148*r**26
            -150164020*r**28-20401312*r**30+301035*r**32+5483*r**34)-Q2**4*(464850
            +16192379*r**2+1317687948*r**4-1304476580*r**6+76708683348*r**8-138390616000*r**10
            +294096844876*r**12+18699514236*r**14+18436502920*r**16+232070889134*r**18
            -227361498620*r**20+80541018676*r**22-42375593876*r**24-23240391240*r**26
            +86028068*r**28-490707980*r**30+41707494*r**32+230367*r**34)-Q2*(-1
            +r**2)**2*(146214+5417905*r**2+391529241*r**4-2086623996*r**6+29902437860*r**8
            -141284837416*r**10+376241404400*r**12-445599218156*r**14-119078627440*r**16
            +392652404210*r**18+160834888250*r**20-464754914100*r**22+213029257884*r**24
            -56006326832*r**26-5088138920*r**28-1576114148*r**30-294597430*r**32
            +6144181*r**34+104293*r**36)-Q2**3*(802566+21028385*r**2+1180633641*r**4
            -4770241744*r**6+46743767352*r**8-104754704844*r**10+154813560420*r**12
            -49355881920*r**14+62641812964*r**16+220115144526*r**18-337889367890*r**20
            +17284569840*r**22+78166419832*r**24-73529655996*r**26-7278006828*r**28
            -2601332832*r**30-820918170*r**32+31766297*r**34+604401*r**36)+Q2**2*(539406
            +16673921*r**2+1123640504*r**4-6095670319*r**6+72517673608*r**8-300943086180*r**10
            +713437302960*r**12-799267034132*r**14+260644081396*r**16-336941934074*r**18
            +574188341952*r**20+87707883382*r**22-647947135928*r**24+366104173340*r**26
            -96457539696*r**28-10124528628*r**30-2576048338*r**32-822259519*r**34
            +23208008*r**36+390337*r**38))+20901888000*logq2**5*r**18*(-3-2*r**2+14*r**6
            +3*r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+276480*logq2**3*r**10*(240*Q2**13*(64
            +255*r**4)-4*Q2**12*(43920+41885*r**2+155079*r**4+145140*r**6)+2*Q2**11*(428160
            +783895*r**2+1807566*r**4+2413191*r**6+1167060*r**8)-Q2**10*(2271465
            +6056755*r**2+13248946*r**4+19439868*r**6+15303561*r**8+5118285*r**10)
            +5*Q2**9*(668190+2436539*r**2+5606946*r**4+8989754*r**6+8713014*r**8
            +4994739*r**10+1329090*r**12)-5*Q2**8*(390429+2513814*r**2+5592871*r**4
            +10181682*r**6+11862563*r**8+9114906*r**10+4408953*r**12+1148670*r**14)
            +2*Q2**7*(-943020+1798410*r**2-2905804*r**4-3376800*r**6+3525405*r**8
            +10477370*r**10+12366390*r**12+6044916*r**14+2643885*r**16)+Q2**6*(4580910
            +5816370*r**2+47913076*r**4+93829676*r**6+93769570*r**8+55259630*r**10
            +1345440*r**12-24375024*r**14-9379524*r**16-6523740*r**18)+2*Q2**5*(
            -1679310-3454065*r**2-24735604*r**4-52216407*r**6-57160479*r**8-46499485*r**10
            -14215635*r**12+7140931*r**14+16229193*r**16+4592226*r**18+2441835*r**20)
            +10*Q2**4*(18255+370188*r**2+977857*r**4+3641739*r**6+3832564*r**8+3781350*r**10
            +929160*r**12-1217124*r**14+1445605*r**16+151038*r**18-382737*r**20
            +127305*r**22)+(-1+r**2)**4*(-48165+13550*r**2-1655781*r**4+1417708*r**6
            +4541262*r**8-4479524*r**10+7586390*r**12-4775864*r**14+1422647*r**16
            +4444518*r**18+321519*r**20+283740*r**22)-10*Q2**3*(-146916+243673*r**2
            -2417218*r**4+287293*r**6+1287721*r**8-2508126*r**10-143152*r**12+1672986*r**14
            -3061934*r**16+3795669*r**18+4878538*r**20-117159*r**22+583185*r**24)
            -Q2*(-1+r**2)**2*(-369270+336545*r**2-10337182*r**4+6100739*r**6+21858300*r**8
            -21620574*r**10+26197332*r**12+35776222*r**14-20172494*r**16+7590445*r**18
            +24581514*r**20+762543*r**22+1871880*r**24)+Q2**2*(-1122405+2141545*r**2
            -25839026*r**4+23762820*r**6+27255595*r**8-55974305*r**10+34948620*r**12
            +64970392*r**14+83670265*r**16-50727345*r**18-12109290*r**20+52512660*r**22
            -3238191*r**24+4900665*r**26))*sqrtq2-384*logq2*r**4*(-23280*Q2**21*r**2
            +4*Q2**20*(-1901+67017*r**2+101700*r**4)-2*Q2**19*(-41999+448466*r**2
            +2233249*r**4+1542780*r**6)+Q2**18*(-459281-1559330*r**2+15642922*r**4
            +29852110*r**6+13479015*r**8)+Q2**17*(1790765+25708162*r**2+1763942*r**4
            -63318368*r**6-104663043*r**8-37316610*r**10)+2*Q2**16*(-2867207-61671801*r**2
            -105688319*r**4-144588394*r**6-50424471*r**8+96399759*r**10+33133905*r**12)
            +Q2**15*(14785748+375739980*r**2+951504816*r**4+2177714094*r**6+3122669772*r**8
            +1618383720*r**10-88767984*r**12-67902210*r**14)+2*Q2**14*(-13987292
            -390441682*r**2-1236100760*r**4-3341185983*r**6-6730888595*r**8-6869872632*r**10
            -3000297082*r**12-216959823*r**14+7113465*r**16)+2*Q2**13*(16969864+506705280*r**2
            +2031835975*r**4+5593514577*r**6+14434495681*r**8+20359789241*r**10+15994937513*r**12
            +5894938467*r**14+583333335*r**16+32718915*r**18)-2*Q2**12*(8093930+228108348*r**2
            +1753935795*r**4+2486972684*r**6+11922502594*r**8+24399961008*r**10+28605474124*r**12
            +20167841132*r**14+6427363428*r**16+707976828*r**18+46605585*r**20)+2*Q2**11*(
            -11419824-505875682*r**2-359138540*r**4-11762023525*r**6-22053851624*r**8
            -22891251572*r**10-10373232704*r**12+6301646226*r**14+9911683256*r**16
            +2546333638*r**18+408310188*r**20+18295875*r**22)+2*Q2**10*(25377495
            +1129233976*r**2+2929278924*r**4+30578647613*r**6+81386925062*r**8+128940233264*r**10
            +138131797516*r**12+91744005734*r**14+35877627579*r**16+7679273944*r**18
            +2924456392*r**20+42971357*r**22+19904040*r**24)-2*Q2**9*(19227663+917275138*r**2
            +3409864633*r**4+31792876459*r**6+107221525520*r**8+184717808607*r**10
            +238473483262*r**12+213961798674*r**14+126209036139*r**16+52933835940*r**18
            +15924577913*r**20+5286211363*r**22+267784582*r**24+28106715*r**26)+2*Q2**8*(
            -309244-23374190*r**2+1585832717*r**4+3774731746*r**6+59527138458*r**8
            +79160255820*r**10+117817470339*r**12+153782240156*r**14+145785056816*r**16
            +82294322258*r**18+42678519187*r**20+13314568514*r**22+4053031858*r**24
            +234271440*r**26+7997085*r**28)+2*Q2**7*(13274150+759597978*r**2+161396852*r**4
            +30272158165*r**6+2766961710*r**8+81700868796*r**10+118924170204*r**12
            +80617398739*r**14-7626953486*r**16-75287733526*r**18-42707036724*r**20
            -40517465125*r**22-10135336454*r**24-2172501792*r**26-136057692*r**28
            +9941085*r**30)+2*(-1+r**2)**6*(17587+1690505*r**2-1956685*r**4+205369507*r**6
            -876454659*r**8+2486920321*r**10-1700432405*r**12-9649384245*r**14+14466855531*r**16
            -2950948477*r**18-4573545263*r**20+1879026145*r**22-832379545*r**24-71840013*r**26
            -15449839*r**28-460495*r**30+12030*r**32)-2*Q2**6*(11208856+699610998*r**2
            +507200388*r**4+36664028793*r**6+10378266609*r**8+114852463440*r**10
            +171898395918*r**12+147713419207*r**14+101353358607*r**16+19253914238*r**18
            -69733046584*r**20-21113445321*r**22-38125271505*r**24-7760402340*r**26
            -1009435962*r**28-61940247*r**30+10426905*r**32)-Q2*(-1+r**2)**4*(391351
            +34643162*r**2-52644702*r**4+3693361850*r**6-13506634574*r**8+34878803658*r**10
            -14371761366*r**12-107430449846*r**14+51028639920*r**16+100282304558*r**18
            -47641227194*r**20-56438082114*r**22+24681311278*r**24-12949489570*r**26
            -1128662034*r**28-262871490*r**30-8961607*r**32+288720*r**34)+2*Q2**5*(2739596
            +197222392*r**2+356755553*r**4+14589850563*r**6-1755938077*r**8+36411578703*r**10
            +68181636305*r**12+16507990519*r**14+19392144531*r**16+20990441923*r**18
            +58414254027*r**20-30589374503*r**22+4090000113*r**24-8780221699*r**26
            -2675848701*r**28-12200531*r**30+2501901*r**32+2675385*r**34)+Q2**2*(
            -1+r**2)**2*(1838795+148782168*r**2-319681765*r**4+13838127558*r**6-47109494458*r**8
            +117465073430*r**10-64301379602*r**12-185374231242*r**14+16369175364*r**16
            +60633904006*r**18+155921352540*r**20-92489899070*r**22-165541722246*r**24
            +78918328018*r**26-40556181998*r**28-3411110590*r**30-921061071*r**32
            -37434822*r**34+1454985*r**36)+2*Q2**4*(2127956+138033786*r**2-461964733*r**4
            +7840297272*r**6-19790272210*r**8+52974872524*r**10-33107466886*r**12
            +22515073360*r**14+10975752926*r**16+33939524200*r**18+42486769024*r**20
            -97182377736*r**22-47804694006*r**24+18809275172*r**26-25292019290*r**28
            -1819800704*r**30-759732714*r**32-43547346*r**34+1845405*r**36)+2*Q2**3*(
            -2213167-161652300*r**2+511472097*r**4-13028240203*r**6+45629624116*r**8
            -114699478476*r**10+108629300948*r**12+24428453500*r**14-29581682274*r**16
            +35062830868*r**18+66581988318*r**20-123225830586*r**22+5632289764*r**24
            +139053641132*r**26-74902667964*r**28+31484497900*r**30+2238971513*r**32
            +817861464*r**34+42133545*r**36-1860195*r**38))*sqrtq2)/(-9797760000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -136080000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3-94500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5+23514624000*logq2**5*r**22*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2+1632960000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+5670000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(muWC*(-33177600*logq2**4*r**14*(-120*Q2**10*(3+35*r**4)+30*Q2**9*(71+190*r**2
            +1155*r**4+1400*r**6)-6*Q2**8*(75+4410*r**2+22776*r**4+44030*r**6+30765*r**8)
            +Q2**7*(-22005+13305*r**2+246818*r**4+670848*r**6+836535*r**8+457695*r**10)
            -2*Q2**6*(-30870-49665*r**2+51109*r**4+377195*r**6+687519*r**8+676620*r**10
            +335160*r**12)+3*Q2**5*(-17745-58275*r**2-63083*r**4+100129*r**6+308189*r**8
            +424347*r**10+341495*r**12+171255*r**14)-Q2**4*(51030-33600*r**2-203885*r**4
            +56475*r**6+266046*r**8+412510*r**10+420735*r**12+56175*r**14+22050*r**16)
            +(-1+r**2)**4*(-13380-6240*r**2+21949*r**4-109371*r**6+20094*r**8-61666*r**10
            -22851*r**12+23205*r**14+22260*r**16)+Q2**3*(161325+104055*r**2-79664*r**4
            +474230*r**6+100374*r**8+177544*r**10+104720*r**12+168066*r**14-350595*r**16
            -349335*r**18)-Q2*(-1+r**2)**2*(-72585-42375*r**2+67462*r**4-533236*r**6
            -191076*r**8-157126*r**10-209486*r**12-110028*r**14+103845*r**16+136605*r**18)
            +6*Q2**2*(-26220+135*r**2+23272*r**4-167898*r**6-59426*r**8-63556*r**10
            -22606*r**12-15118*r**14-63978*r**16+4165*r**18+55230*r**20))-9216*logq2**2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(-24*Q2**16*(5117+18525*r**4)+2*Q2**15*(718659
            +661654*r**2+2074695*r**4+2755800*r**6)-2*Q2**14*(3619845+6688372*r**2
            +12130370*r**4+22587740*r**6+14624625*r**8)+Q2**13*(20323155+56513731*r**2
            +103615716*r**4+178855200*r**6+202098465*r**8+84538125*r**10)-2*Q2**12*(16841640
            +64274037*r**2+133811416*r**4+221896522*r**6+252739380*r**8+228203245*r**10
            +66759000*r**12)+2*Q2**11*(14911452+82436848*r**2+164432808*r**4+241567773*r**6
            +112221178*r**8+45180572*r**10+217778090*r**12+35642775*r**14)+2*Q2**10*(
            -1633797-52189409*r**2+24308080*r**4+362074915*r**6+1255593040*r**8
            +2114707421*r**10+1457991628*r**12+147121065*r**14+68832225*r**16)-Q2**9*(23311695
            +977537*r**2+713488400*r**4+3118376580*r**6+8107826450*r**8+13934114150*r**10
            +14377919152*r**12+7507235620*r**14+1302283615*r**16+310484625*r**18)
            +2*Q2**8*(12788820+27342444*r**2+492825789*r**4+2086270875*r**6+5466731425*r**8
            +9953274465*r**10+12436137489*r**12+9753806389*r**14+3700138875*r**16
            +697008435*r**18+109271250*r**20)+2*Q2**7*(-4912545-29569326*r**2-372255693*r**4
            -1457772996*r**6-3744231730*r**8-5753874670*r**10-7180554446*r**12-7055882718*r**14
            -4188730901*r**16+446773260*r**18-149311485*r**20+33239250*r**22)-2*Q2**6*(963567
            -30437354*r**2-263821554*r**4-978036504*r**6-2617235949*r**8-826344902*r**10
            +2969745706*r**12+5983716946*r**14+5202342671*r**16+3564306176*r**18
            +4797999832*r**20+377595030*r**22+116891775*r**24)+Q2**5*(3343509-47455663*r**2
            -360003860*r**4-1942231940*r**6-5585471095*r**8-2325426671*r**10+6277282144*r**12
            +18838151680*r**14+21236929335*r**16+16332389955*r**18+8939910772*r**20
            +9018094564*r**22+802949995*r**24+157335675*r**26)+2*(-1+r**2)**4*(-23304
            -502442*r**2-14894839*r**4+14767085*r**6-244552895*r**8+485341113*r**10
            +551653164*r**12-1534431642*r**14-443548890*r**16+405286620*r**18+311213741*r**20
            -64438547*r**22+76205281*r**24+3723605*r**26+601950*r**28)-2*Q2**4*(894120
            -4127203*r**2+34763730*r**4-619458330*r**6-378306800*r**8-624439675*r**10
            -393024924*r**12+2566220800*r**14+5638075340*r**16+1353256275*r**18+1190778830*r**20
            +1848439802*r**22+837653820*r**24+137689515*r**26+3181500*r**28)-Q2*(
            -1+r**2)**2*(-318663-6807547*r**2-180486207*r**4+153549237*r**6-2766897815*r**8
            +3956505381*r**10+4765966089*r**12-9055963251*r**14-6863866749*r**16
            -5093264505*r**18+3900872107*r**20+4177086183*r**22-1341697317*r**24
            +1042033487*r**26+45222795*r**28+10466775*r**30)-2*Q2**3*(-622290-9817128*r**2
            -228898678*r**4+263384225*r**6-2832658380*r**8+980439910*r**10+584844336*r**12
            -2179043169*r**14+450956550*r**16-4437161700*r**18+4656122730*r**20+4951238767*r**22
            -2071737128*r**24+1559437350*r**26+28077980*r**28+27260625*r**30)+2*Q2**2*(
            -427815-8817637*r**2-208809816*r**4+298785993*r**6-3141788940*r**8+4696765145*r**10
            +505102454*r**12-5488693593*r**14-3466029516*r**16+1586461845*r**18-7700417660*r**20
            +813227583*r**22+6316331184*r**24-2896877577*r**26+1380523870*r**28+38929105*r**30
            +18135375*r**32))+64*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(-144*Q2**21
            +16*Q2**20*(171+13*r**2)+Q2**19*(11898+10424*r**2-4622*r**4)+2*Q2**18*(
            -454077-60721*r**2-519733*r**4+47183*r**6)+8*Q2**17*(1050123+333051*r**2
            +547796*r**4+1376249*r**6-76802*r**8)+Q2**16*(-36790047-17295855*r**2
            +42654714*r**4-48300182*r**6-52344723*r**8+2045933*r**10)+Q2**15*(91547286
            +47580168*r**2-385339066*r**4-382243992*r**6+178303562*r**8+127341744*r**10
            -3827302*r**12)+2*Q2**14*(-64187697-29149617*r**2+781465571*r**4+1435203659*r**6
            +1284278877*r**8-18393571*r**10-58391551*r**12+1683673*r**14)+2*Q2**13*(33497031
            +18011112*r**2-2194511310*r**4-4999865812*r**6-7517514416*r**8-6275613096*r**10
            -799027786*r**12-94173036*r**14+683041*r**16)+Q2**12*(86945898-105352806*r**2
            +8992101620*r**4+25357534980*r**6+43745600136*r**8+55718829480*r**10
            +35653173708*r**12+5072693468*r**14+699581454*r**16-7149922*r**18)+2*Q2**11*(
            -90435735+154834124*r**2-6013356985*r**4-22494373372*r**6-41768259478*r**8
            -56605560972*r**10-57054822546*r**12-25024736180*r**14-3225320131*r**16
            -400882768*r**18+3633435*r**20)+Q2**10*(95672226-280651294*r**2+7278727414*r**4
            +47935484566*r**6+79776112156*r**8+93026970796*r**10+76204922724*r**12
            +91023731860*r**14+4871010242*r**16+356010226*r**18+77379302*r**20-669162*r**22)
            +Q2**9*(64067094-227739104*r**2+4858739952*r**4-26063188616*r**6+15082461742*r**8
            +131285731232*r**10+269760550192*r**12+288521780624*r**14+69966894994*r**16
            +94738016192*r**18+9904926240*r**20+824250232*r**22-5266326*r**24)+4*Q2**8*(
            -27188853+148210107*r**2-3193587463*r**4+1840904945*r**6-25355831444*r**8
            -91331366700*r**10-186659253366*r**12-223074753254*r**14-170032057929*r**16
            -49537757529*r**18-34051328811*r**20-3125942995*r**22-217196902*r**24
            +1139122*r**26)+2*Q2**7*(13589001-78015156*r**2+4129331253*r**4-974370308*r**6
            +40637617473*r**8+141105617312*r**10+313953357093*r**12+475912252312*r**14
            +428814430691*r**16+174163415436*r**18+69688248279*r**20+22516396140*r**22
            +1797059155*r**24+53584008*r**26-17329*r**28)-2*Q2**6*(-22041141+273711003*r**2
            -576869669*r**4+6815776803*r**6+20558417167*r**8+67753520847*r**10+98991591391*r**12
            +35145916375*r**14+100212145009*r**16+158652002593*r**18-310362726783*r**20
            +20859477913*r**22-38449595979*r**24-3003498635*r**26-236180283*r**28
            +1186669*r**30)+2*Q2**5*(-19386627+301143576*r**2-2225370950*r**4+14608903732*r**6
            +16176658806*r**8+72980206168*r**10+83408696266*r**12-117980553164*r**14
            -220241464408*r**16-306323288632*r**18+270636105534*r**20-546729245636*r**22
            +19830878554*r**24-47247996984*r**26-3380448194*r**28-196095140*r**30
            +770699*r**32)+(-1+r**2)**4*(-175869+6204415*r**2-1512924*r**4+421945900*r**6
            +4606465168*r**8-34327610360*r**10+128783215300*r**12-273902663124*r**14
            +188275551790*r**16+178517770974*r**18-276261854068*r**20+132891298980*r**22
            -37846001560*r**24+2978544560*r**26-1021803892*r**28-53656828*r**30-2043945*r**32
            +5483*r**34)-2*Q2**4*(-2489451+62389293*r**2-936114714*r**4+8669676926*r**6
            -927805502*r**8+50406836130*r**10+19143398606*r**12-69977353738*r**14
            -35241008932*r**16+65585052604*r**18-455268917902*r**20+376026787674*r**22
            -255046415122*r**24+10670031406*r**26-14444337702*r**28-982839502*r**30
            -30493473*r**32+48199*r**34)-2*Q2*(-1+r**2)**2*(-836877+25548002*r**2
            -63285403*r**4+1682324776*r**6+11252451536*r**8-65925942184*r**10+200032733360*r**12
            -271388908872*r**14-126391470834*r**16+444873132508*r**18+243915749314*r**20
            -648306924776*r**22+372822322088*r**24-118482234440*r**26+12053540056*r**28
            -3631649528*r**30-202634361*r**32-9221838*r**34+27473*r**36)-4*Q2**3*(
            -2329251+47623740*r**2-121740772*r**4+1077714618*r**6+10111652448*r**8
            -23766407418*r**10+66554066004*r**12-15484272350*r**14-58668107502*r**16
            +193441289014*r**18-203794553796*r**20-56840812658*r**22+125665415496*r**24
            -85199741550*r**26+13555919388*r**28-4595189610*r**30-278348311*r**32
            -22398474*r**34+92984*r**36)+4*Q2**2*(-1555596+41161990*r**2-171742711*r**4
            +2289929711*r**6+9385125146*r**8-49810095306*r**10+145709950626*r**12
            -202649415562*r**14+114999979450*r**16-166713361958*r**18+274954747620*r**20
            +297147215908*r**22-670504780178*r**24+425666237842*r**26-142489009362*r**28
            +19457731482*r**30-4761019574*r**32-280205224*r**34-16229053*r**36+54749*r**38))
            -20901888000*logq2**5*r**18*(-21-20*r**2+26*r**4-28*r**6+3*r**8)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+552960*logq2**3*r**10*(120*Q2**13*(191
            +1215*r**4)-2*Q2**12*(114945+149594*r**2+640893*r**4+815760*r**6)+2*Q2**11*(501270
            +1246953*r**2+3324119*r**4+5880351*r**6+3938595*r**8)-Q2**10*(2450640
            +8733363*r**2+21901490*r**4+41391116*r**6+44854686*r**8+20895945*r**10)
            +5*Q2**9*(732297+3267986*r**2+8537647*r**4+16782744*r**6+22109939*r**8
            +17718246*r**10+6198405*r**12)-5*Q2**8*(713871+3515400*r**2+9513093*r**4
            +18098760*r**6+25198241*r**8+25494760*r**10+17177787*r**12+3706200*r**14)
            +2*Q2**7*(1361070+5950593*r**2+18095076*r**4+21952315*r**6+11713350*r**8
            -4085485*r**10-1521172*r**12+5075361*r**14-8726580*r**16)+2*Q2**6*(-1064610
            -3738126*r**2-19178868*r**4-12830677*r**6+27693560*r**8+93951845*r**10
            +122498884*r**12+84774437*r**14+31777578*r**16+21964185*r**18)-2*Q2**5*(
            -554895-2996613*r**2-19952325*r**4-22431966*r**6+1151024*r**8+72653040*r**10
            +129281532*r**12+127538990*r**14+83397079*r**16+31049829*r**18+16638705*r**20)
            +10*Q2**4*(82614-368973*r**2+74904*r**4-1753054*r**6-3376638*r**8+3590154*r**10
            +8989058*r**12+10410516*r**14+2630728*r**16+1957603*r**18+2456262*r**20
            +252810*r**22)-(-1+r**2)**4*(-93225-58562*r**2-4662813*r**4+6029396*r**6
            +8872890*r**8-25500796*r**10+102082*r**12-13078072*r**14+7021519*r**16
            +5399550*r**18+334011*r**20+514020*r**22)+10*Q2**3*(-209544+189850*r**2
            -5217531*r**4+495172*r**6+2685001*r**8-6908584*r**10-1630314*r**12-1554724*r**14
            -6374738*r**16+9400238*r**18+8674133*r**20-1147584*r**22+1437345*r**24)
            +Q2*(-1+r**2)**2*(-621195-10194*r**2-25985470*r**4+21639206*r**6+40219967*r**8
            -91098692*r**10-64204148*r**12-15384740*r**14-56170701*r**16+34183638*r**18
            +33054642*r**20-429378*r**22+3847065*r**24)+Q2**2*(1657500-1769073*r**2
            +56554034*r**4-61584150*r**6-29398630*r**8+157709105*r**10+57300756*r**12
            +64902092*r**14-42433840*r**16+144305745*r**18-22617190*r**20-84699318*r**22
            +13381914*r**24-11388945*r**26))*sqrtq2-384*logq2*r**2*(-23280*Q2**21*(1
            +r**4)+4*Q2**20*(82671+50830*r**2+61011*r**4+91080*r**6)-4*Q2**19*(533022
            +637987*r**2+2597*r**4+1004693*r**6+626925*r**8)+Q2**18*(8171397+13945366*r**2
            -10617230*r**4-6014620*r**6+25628289*r**8+9862950*r**10)-2*Q2**17*(10176624
            +21255351*r**2-47437097*r**4-98105078*r**6-68348862*r**8+37701655*r**10
            +11806575*r**12)+Q2**16*(33335487+74518818*r**2-520219167*r**4-1263911876*r**6
            -1888972239*r**8-1368259350*r**10+44738431*r**12+31609320*r**14)+4*Q2**15*(
            -8217936-14604381*r**2+479362718*r**4+1322572389*r**6+2361518996*r**8
            +2996921629*r**10+1741309286*r**12+106190059*r**14-1958520*r**16)-4*Q2**14*(
            -2539341+10563039*r**2+1186070504*r**4+3893451665*r**6+7723344584*r**8
            +11470085907*r**10+11190377632*r**12+5076242719*r**14+399634781*r**16
            +13450350*r**18)+4*Q2**13*(5023296+41123433*r**2+1925989830*r**4+7792219798*r**6
            +16984580144*r**8+26659759000*r**10+29820561388*r**12+23733997122*r**14
            +8435178200*r**16+680482567*r**18+25549350*r**20)-4*Q2**12*(7328139+46990671*r**2
            +1867135753*r**4+10103648292*r**6+22154130252*r**8+32446038174*r**10
            +31427524748*r**12+26776024672*r**14+23710739945*r**16+5606595323*r**18
            +505024715*r**20+16859700*r**22)-4*Q2**11*(-2500836-23344009*r**2-588917704*r**4
            -7694956849*r**6-10374414014*r**8+5704910058*r**10+48883317496*r**12
            +80549919882*r**14+56043233088*r**16+7900859535*r**18+7039125760*r**20
            +265607927*r**22+9891570*r**24)+2*Q2**10*(6532539+7400536*r**2+2036598170*r**4
            -4425707906*r**6+28157453669*r**8+162955157962*r**10+430570955380*r**12
            +679476929708*r**14+664916050389*r**16+383741706748*r**18+106098742018*r**20
            +41002541494*r**22+2008482619*r**24+57025410*r**26)-4*Q2**9*(3866616
            +16494686*r**2+1599077001*r**4+1571010586*r**6+28326943262*r**8+120263926448*r**10
            +300837633723*r**12+502404009044*r**14+581685128788*r**16+452702426662*r**18
            +210935087135*r**20+61751970850*r**22+19215084646*r**24+922015484*r**26
            +20688525*r**28)+2*Q2**8*(912033+42283644*r**2+2000437375*r**4+4960453048*r**6
            +50773713213*r**8+188270966716*r**10+428513409651*r**12+617494280192*r**14
            +720796879163*r**16+678898648676*r**18+413543903557*r**20+28994040184*r**22
            +44235199207*r**24+4049638980*r**26+234348361*r**28-2701200*r**30)+4*Q2**7*(2002464
            -22109919*r**2-208659702*r**4-2635199053*r**6-20126135604*r**8-64203039039*r**10
            -126281051602*r**12-57693777925*r**14+80098584904*r**16+160665906635*r**18
            +128893013574*r**20+103774455425*r**22+220357997036*r**24+17737344723*r**26
            +13617952578*r**28+537062225*r**30+13735200*r**32)+(-1+r**2)**6*(7767
            -209264*r**2-7168048*r**4-41837248*r**6-1514131292*r**8+5810282664*r**10
            -20850323600*r**12+36214505296*r**14+31777403946*r**16-129485375496*r**18
            +56350412336*r**20+17291841952*r**22-13102397468*r**24+6347188952*r**26
            +164204688*r**28+155181008*r**30+3965687*r**32+48120*r**34)-4*Q2**6*(1647351
            -14352831*r**2+117544484*r**4-2396871489*r**6-15528829330*r**8-50224376909*r**10
            -96731471812*r**12+1280532399*r**14+119395271172*r**16+287703612373*r**18
            +324683049868*r**20+228431693765*r**22+96117974722*r**24+249999556697*r**26
            +22135234132*r**28+14069643725*r**30+528913813*r**32+10223070*r**34)
            -2*Q2*(-1+r**2)**4*(47136-1120867*r**2-29305005*r**4-186778536*r**6
            -5949184412*r**8+17475296892*r**10-61504054904*r**12+81529098888*r**14
            +114367967172*r**16-176339299026*r**18-248800387802*r**20+169628489064*r**22
            +69510987084*r**24-53855086276*r**26+27670686288*r**28+381341624*r**30
            +761677932*r**32+20939133*r**34+285615*r**36)+4*Q2**5*(278460-929313*r**2
            +130513082*r**4-1101912826*r**6-2720462752*r**8-28925807046*r**10-10828837304*r**12
            +42112541462*r**14+15725112352*r**16+65890527248*r**18+102479034900*r**20
            +54386760514*r**22+46736809296*r**24-20357624906*r**26+87753763704*r**28
            +8977095586*r**30+4654503028*r**32+163434785*r**34+1833330*r**36)+4*Q2**4*(388422
            -7098663*r**2-106574148*r**4-224987056*r**6-12004037354*r**8+24166375880*r**10
            -98014573870*r**12+10566363668*r**14+41326120490*r**16-86202866542*r**18
            -37669624366*r**20-77500515036*r**22+155705403218*r**24+139051578208*r**26
            -80394636554*r**28+63652848764*r**30-3521821656*r**32+2318473837*r**34
            +80172458*r**36+2178300*r**38)+Q2**2*(-1+r**2)**2*(486573-10381292*r**2
            -194321531*r**4-1317957546*r**6-38150370636*r**8+97563842736*r**10-355932844172*r**12
            +440694522168*r**14+331051253942*r**16-430400593928*r**18-594909461146*r**20
            -1017050328940*r**22+695705559492*r**24+569910692784*r**26-425472619836*r**28
            +201379402712*r**30-1805674971*r**32+6204334996*r**34+184372445*r**36
            +2886150*r**38)-4*Q2**3*(327318-6474966*r**2-83146165*r**4-522777708*r**6
            -15354507471*r**8+42893086308*r**10-153157340564*r**12+205301715028*r**14
            +5598332816*r**16-177698390632*r**18-4561137910*r**20+43442445196*r**22
            -380066562306*r**24+59286238332*r**26+344003481852*r**28-236238546916*r**30
            +94186854434*r**32-4439218082*r**34+3130292035*r**36+101028976*r**38
            +1900425*r**40))*sqrtq2))/(-29393280000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-408240000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-283500*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5+70543872000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+4898880000*logq2**3*(-Q2+(-1
            +r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+17010000*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(muWC**2*(-4147200*logq2**4*r**14*(-120*Q2**10*(3+35*r**4)+30*Q2**9*(71
            +190*r**2+1155*r**4+1400*r**6)-6*Q2**8*(75+4410*r**2+22776*r**4+44030*r**6
            +30765*r**8)+Q2**7*(-22005+13305*r**2+246818*r**4+670848*r**6+836535*r**8
            +457695*r**10)-2*Q2**6*(-30870-49665*r**2+51109*r**4+377195*r**6+687519*r**8
            +676620*r**10+335160*r**12)+3*Q2**5*(-17745-58275*r**2-63083*r**4+100129*r**6
            +308189*r**8+424347*r**10+341495*r**12+171255*r**14)-Q2**4*(51030-33600*r**2
            -203885*r**4+56475*r**6+266046*r**8+412510*r**10+420735*r**12+56175*r**14
            +22050*r**16)+(-1+r**2)**4*(-13380-6240*r**2+21949*r**4-109371*r**6
            +20094*r**8-61666*r**10-22851*r**12+23205*r**14+22260*r**16)+Q2**3*(161325
            +104055*r**2-79664*r**4+474230*r**6+100374*r**8+177544*r**10+104720*r**12
            +168066*r**14-350595*r**16-349335*r**18)-Q2*(-1+r**2)**2*(-72585-42375*r**2
            +67462*r**4-533236*r**6-191076*r**8-157126*r**10-209486*r**12-110028*r**14
            +103845*r**16+136605*r**18)+6*Q2**2*(-26220+135*r**2+23272*r**4-167898*r**6
            -59426*r**8-63556*r**10-22606*r**12-15118*r**14-63978*r**16+4165*r**18
            +55230*r**20))-1152*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(
            -24*Q2**16*(5117+18525*r**4)+2*Q2**15*(718659+661654*r**2+2074695*r**4
            +2755800*r**6)-2*Q2**14*(3619845+6688372*r**2+12130370*r**4+22587740*r**6
            +14624625*r**8)+Q2**13*(20323155+56513731*r**2+103615716*r**4+178855200*r**6
            +202098465*r**8+84538125*r**10)-2*Q2**12*(16841640+64274037*r**2+133811416*r**4
            +221896522*r**6+252739380*r**8+228203245*r**10+66759000*r**12)+2*Q2**11*(14911452
            +82436848*r**2+164432808*r**4+241567773*r**6+112221178*r**8+45180572*r**10
            +217778090*r**12+35642775*r**14)+2*Q2**10*(-1633797-52189409*r**2+24308080*r**4
            +362074915*r**6+1255593040*r**8+2114707421*r**10+1457991628*r**12+147121065*r**14
            +68832225*r**16)-Q2**9*(23311695+977537*r**2+713488400*r**4+3118376580*r**6
            +8107826450*r**8+13934114150*r**10+14377919152*r**12+7507235620*r**14
            +1302283615*r**16+310484625*r**18)+2*Q2**8*(12788820+27342444*r**2+492825789*r**4
            +2086270875*r**6+5466731425*r**8+9953274465*r**10+12436137489*r**12+9753806389*r**14
            +3700138875*r**16+697008435*r**18+109271250*r**20)+2*Q2**7*(-4912545
            -29569326*r**2-372255693*r**4-1457772996*r**6-3744231730*r**8-5753874670*r**10
            -7180554446*r**12-7055882718*r**14-4188730901*r**16+446773260*r**18-149311485*r**20
            +33239250*r**22)-2*Q2**6*(963567-30437354*r**2-263821554*r**4-978036504*r**6
            -2617235949*r**8-826344902*r**10+2969745706*r**12+5983716946*r**14+5202342671*r**16
            +3564306176*r**18+4797999832*r**20+377595030*r**22+116891775*r**24)+Q2**5*(3343509
            -47455663*r**2-360003860*r**4-1942231940*r**6-5585471095*r**8-2325426671*r**10
            +6277282144*r**12+18838151680*r**14+21236929335*r**16+16332389955*r**18
            +8939910772*r**20+9018094564*r**22+802949995*r**24+157335675*r**26)+2*(
            -1+r**2)**4*(-23304-502442*r**2-14894839*r**4+14767085*r**6-244552895*r**8
            +485341113*r**10+551653164*r**12-1534431642*r**14-443548890*r**16+405286620*r**18
            +311213741*r**20-64438547*r**22+76205281*r**24+3723605*r**26+601950*r**28)
            -2*Q2**4*(894120-4127203*r**2+34763730*r**4-619458330*r**6-378306800*r**8
            -624439675*r**10-393024924*r**12+2566220800*r**14+5638075340*r**16+1353256275*r**18
            +1190778830*r**20+1848439802*r**22+837653820*r**24+137689515*r**26+3181500*r**28)
            -Q2*(-1+r**2)**2*(-318663-6807547*r**2-180486207*r**4+153549237*r**6
            -2766897815*r**8+3956505381*r**10+4765966089*r**12-9055963251*r**14-6863866749*r**16
            -5093264505*r**18+3900872107*r**20+4177086183*r**22-1341697317*r**24
            +1042033487*r**26+45222795*r**28+10466775*r**30)-2*Q2**3*(-622290-9817128*r**2
            -228898678*r**4+263384225*r**6-2832658380*r**8+980439910*r**10+584844336*r**12
            -2179043169*r**14+450956550*r**16-4437161700*r**18+4656122730*r**20+4951238767*r**22
            -2071737128*r**24+1559437350*r**26+28077980*r**28+27260625*r**30)+2*Q2**2*(
            -427815-8817637*r**2-208809816*r**4+298785993*r**6-3141788940*r**8+4696765145*r**10
            +505102454*r**12-5488693593*r**14-3466029516*r**16+1586461845*r**18-7700417660*r**20
            +813227583*r**22+6316331184*r**24-2896877577*r**26+1380523870*r**28+38929105*r**30
            +18135375*r**32))+8*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(-144*Q2**21
            +16*Q2**20*(171+13*r**2)+Q2**19*(11898+10424*r**2-4622*r**4)+2*Q2**18*(
            -454077-60721*r**2-519733*r**4+47183*r**6)+8*Q2**17*(1050123+333051*r**2
            +547796*r**4+1376249*r**6-76802*r**8)+Q2**16*(-36790047-17295855*r**2
            +42654714*r**4-48300182*r**6-52344723*r**8+2045933*r**10)+Q2**15*(91547286
            +47580168*r**2-385339066*r**4-382243992*r**6+178303562*r**8+127341744*r**10
            -3827302*r**12)+2*Q2**14*(-64187697-29149617*r**2+781465571*r**4+1435203659*r**6
            +1284278877*r**8-18393571*r**10-58391551*r**12+1683673*r**14)+2*Q2**13*(33497031
            +18011112*r**2-2194511310*r**4-4999865812*r**6-7517514416*r**8-6275613096*r**10
            -799027786*r**12-94173036*r**14+683041*r**16)+Q2**12*(86945898-105352806*r**2
            +8992101620*r**4+25357534980*r**6+43745600136*r**8+55718829480*r**10
            +35653173708*r**12+5072693468*r**14+699581454*r**16-7149922*r**18)+2*Q2**11*(
            -90435735+154834124*r**2-6013356985*r**4-22494373372*r**6-41768259478*r**8
            -56605560972*r**10-57054822546*r**12-25024736180*r**14-3225320131*r**16
            -400882768*r**18+3633435*r**20)+Q2**10*(95672226-280651294*r**2+7278727414*r**4
            +47935484566*r**6+79776112156*r**8+93026970796*r**10+76204922724*r**12
            +91023731860*r**14+4871010242*r**16+356010226*r**18+77379302*r**20-669162*r**22)
            +Q2**9*(64067094-227739104*r**2+4858739952*r**4-26063188616*r**6+15082461742*r**8
            +131285731232*r**10+269760550192*r**12+288521780624*r**14+69966894994*r**16
            +94738016192*r**18+9904926240*r**20+824250232*r**22-5266326*r**24)+4*Q2**8*(
            -27188853+148210107*r**2-3193587463*r**4+1840904945*r**6-25355831444*r**8
            -91331366700*r**10-186659253366*r**12-223074753254*r**14-170032057929*r**16
            -49537757529*r**18-34051328811*r**20-3125942995*r**22-217196902*r**24
            +1139122*r**26)+2*Q2**7*(13589001-78015156*r**2+4129331253*r**4-974370308*r**6
            +40637617473*r**8+141105617312*r**10+313953357093*r**12+475912252312*r**14
            +428814430691*r**16+174163415436*r**18+69688248279*r**20+22516396140*r**22
            +1797059155*r**24+53584008*r**26-17329*r**28)-2*Q2**6*(-22041141+273711003*r**2
            -576869669*r**4+6815776803*r**6+20558417167*r**8+67753520847*r**10+98991591391*r**12
            +35145916375*r**14+100212145009*r**16+158652002593*r**18-310362726783*r**20
            +20859477913*r**22-38449595979*r**24-3003498635*r**26-236180283*r**28
            +1186669*r**30)+2*Q2**5*(-19386627+301143576*r**2-2225370950*r**4+14608903732*r**6
            +16176658806*r**8+72980206168*r**10+83408696266*r**12-117980553164*r**14
            -220241464408*r**16-306323288632*r**18+270636105534*r**20-546729245636*r**22
            +19830878554*r**24-47247996984*r**26-3380448194*r**28-196095140*r**30
            +770699*r**32)+(-1+r**2)**4*(-175869+6204415*r**2-1512924*r**4+421945900*r**6
            +4606465168*r**8-34327610360*r**10+128783215300*r**12-273902663124*r**14
            +188275551790*r**16+178517770974*r**18-276261854068*r**20+132891298980*r**22
            -37846001560*r**24+2978544560*r**26-1021803892*r**28-53656828*r**30-2043945*r**32
            +5483*r**34)-2*Q2**4*(-2489451+62389293*r**2-936114714*r**4+8669676926*r**6
            -927805502*r**8+50406836130*r**10+19143398606*r**12-69977353738*r**14
            -35241008932*r**16+65585052604*r**18-455268917902*r**20+376026787674*r**22
            -255046415122*r**24+10670031406*r**26-14444337702*r**28-982839502*r**30
            -30493473*r**32+48199*r**34)-2*Q2*(-1+r**2)**2*(-836877+25548002*r**2
            -63285403*r**4+1682324776*r**6+11252451536*r**8-65925942184*r**10+200032733360*r**12
            -271388908872*r**14-126391470834*r**16+444873132508*r**18+243915749314*r**20
            -648306924776*r**22+372822322088*r**24-118482234440*r**26+12053540056*r**28
            -3631649528*r**30-202634361*r**32-9221838*r**34+27473*r**36)-4*Q2**3*(
            -2329251+47623740*r**2-121740772*r**4+1077714618*r**6+10111652448*r**8
            -23766407418*r**10+66554066004*r**12-15484272350*r**14-58668107502*r**16
            +193441289014*r**18-203794553796*r**20-56840812658*r**22+125665415496*r**24
            -85199741550*r**26+13555919388*r**28-4595189610*r**30-278348311*r**32
            -22398474*r**34+92984*r**36)+4*Q2**2*(-1555596+41161990*r**2-171742711*r**4
            +2289929711*r**6+9385125146*r**8-49810095306*r**10+145709950626*r**12
            -202649415562*r**14+114999979450*r**16-166713361958*r**18+274954747620*r**20
            +297147215908*r**22-670504780178*r**24+425666237842*r**26-142489009362*r**28
            +19457731482*r**30-4761019574*r**32-280205224*r**34-16229053*r**36+54749*r**38))
            -2612736000*logq2**5*r**18*(-21-20*r**2+26*r**4-28*r**6+3*r**8)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+69120*logq2**3*r**10*(120*Q2**13*(191
            +1215*r**4)-2*Q2**12*(114945+149594*r**2+640893*r**4+815760*r**6)+2*Q2**11*(501270
            +1246953*r**2+3324119*r**4+5880351*r**6+3938595*r**8)-Q2**10*(2450640
            +8733363*r**2+21901490*r**4+41391116*r**6+44854686*r**8+20895945*r**10)
            +5*Q2**9*(732297+3267986*r**2+8537647*r**4+16782744*r**6+22109939*r**8
            +17718246*r**10+6198405*r**12)-5*Q2**8*(713871+3515400*r**2+9513093*r**4
            +18098760*r**6+25198241*r**8+25494760*r**10+17177787*r**12+3706200*r**14)
            +2*Q2**7*(1361070+5950593*r**2+18095076*r**4+21952315*r**6+11713350*r**8
            -4085485*r**10-1521172*r**12+5075361*r**14-8726580*r**16)+2*Q2**6*(-1064610
            -3738126*r**2-19178868*r**4-12830677*r**6+27693560*r**8+93951845*r**10
            +122498884*r**12+84774437*r**14+31777578*r**16+21964185*r**18)-2*Q2**5*(
            -554895-2996613*r**2-19952325*r**4-22431966*r**6+1151024*r**8+72653040*r**10
            +129281532*r**12+127538990*r**14+83397079*r**16+31049829*r**18+16638705*r**20)
            +10*Q2**4*(82614-368973*r**2+74904*r**4-1753054*r**6-3376638*r**8+3590154*r**10
            +8989058*r**12+10410516*r**14+2630728*r**16+1957603*r**18+2456262*r**20
            +252810*r**22)-(-1+r**2)**4*(-93225-58562*r**2-4662813*r**4+6029396*r**6
            +8872890*r**8-25500796*r**10+102082*r**12-13078072*r**14+7021519*r**16
            +5399550*r**18+334011*r**20+514020*r**22)+10*Q2**3*(-209544+189850*r**2
            -5217531*r**4+495172*r**6+2685001*r**8-6908584*r**10-1630314*r**12-1554724*r**14
            -6374738*r**16+9400238*r**18+8674133*r**20-1147584*r**22+1437345*r**24)
            +Q2*(-1+r**2)**2*(-621195-10194*r**2-25985470*r**4+21639206*r**6+40219967*r**8
            -91098692*r**10-64204148*r**12-15384740*r**14-56170701*r**16+34183638*r**18
            +33054642*r**20-429378*r**22+3847065*r**24)+Q2**2*(1657500-1769073*r**2
            +56554034*r**4-61584150*r**6-29398630*r**8+157709105*r**10+57300756*r**12
            +64902092*r**14-42433840*r**16+144305745*r**18-22617190*r**20-84699318*r**22
            +13381914*r**24-11388945*r**26))*sqrtq2-48*logq2*r**2*(-23280*Q2**21*(1
            +r**4)+4*Q2**20*(82671+50830*r**2+61011*r**4+91080*r**6)-4*Q2**19*(533022
            +637987*r**2+2597*r**4+1004693*r**6+626925*r**8)+Q2**18*(8171397+13945366*r**2
            -10617230*r**4-6014620*r**6+25628289*r**8+9862950*r**10)-2*Q2**17*(10176624
            +21255351*r**2-47437097*r**4-98105078*r**6-68348862*r**8+37701655*r**10
            +11806575*r**12)+Q2**16*(33335487+74518818*r**2-520219167*r**4-1263911876*r**6
            -1888972239*r**8-1368259350*r**10+44738431*r**12+31609320*r**14)+4*Q2**15*(
            -8217936-14604381*r**2+479362718*r**4+1322572389*r**6+2361518996*r**8
            +2996921629*r**10+1741309286*r**12+106190059*r**14-1958520*r**16)-4*Q2**14*(
            -2539341+10563039*r**2+1186070504*r**4+3893451665*r**6+7723344584*r**8
            +11470085907*r**10+11190377632*r**12+5076242719*r**14+399634781*r**16
            +13450350*r**18)+4*Q2**13*(5023296+41123433*r**2+1925989830*r**4+7792219798*r**6
            +16984580144*r**8+26659759000*r**10+29820561388*r**12+23733997122*r**14
            +8435178200*r**16+680482567*r**18+25549350*r**20)-4*Q2**12*(7328139+46990671*r**2
            +1867135753*r**4+10103648292*r**6+22154130252*r**8+32446038174*r**10
            +31427524748*r**12+26776024672*r**14+23710739945*r**16+5606595323*r**18
            +505024715*r**20+16859700*r**22)-4*Q2**11*(-2500836-23344009*r**2-588917704*r**4
            -7694956849*r**6-10374414014*r**8+5704910058*r**10+48883317496*r**12
            +80549919882*r**14+56043233088*r**16+7900859535*r**18+7039125760*r**20
            +265607927*r**22+9891570*r**24)+2*Q2**10*(6532539+7400536*r**2+2036598170*r**4
            -4425707906*r**6+28157453669*r**8+162955157962*r**10+430570955380*r**12
            +679476929708*r**14+664916050389*r**16+383741706748*r**18+106098742018*r**20
            +41002541494*r**22+2008482619*r**24+57025410*r**26)-4*Q2**9*(3866616
            +16494686*r**2+1599077001*r**4+1571010586*r**6+28326943262*r**8+120263926448*r**10
            +300837633723*r**12+502404009044*r**14+581685128788*r**16+452702426662*r**18
            +210935087135*r**20+61751970850*r**22+19215084646*r**24+922015484*r**26
            +20688525*r**28)+2*Q2**8*(912033+42283644*r**2+2000437375*r**4+4960453048*r**6
            +50773713213*r**8+188270966716*r**10+428513409651*r**12+617494280192*r**14
            +720796879163*r**16+678898648676*r**18+413543903557*r**20+28994040184*r**22
            +44235199207*r**24+4049638980*r**26+234348361*r**28-2701200*r**30)+4*Q2**7*(2002464
            -22109919*r**2-208659702*r**4-2635199053*r**6-20126135604*r**8-64203039039*r**10
            -126281051602*r**12-57693777925*r**14+80098584904*r**16+160665906635*r**18
            +128893013574*r**20+103774455425*r**22+220357997036*r**24+17737344723*r**26
            +13617952578*r**28+537062225*r**30+13735200*r**32)+(-1+r**2)**6*(7767
            -209264*r**2-7168048*r**4-41837248*r**6-1514131292*r**8+5810282664*r**10
            -20850323600*r**12+36214505296*r**14+31777403946*r**16-129485375496*r**18
            +56350412336*r**20+17291841952*r**22-13102397468*r**24+6347188952*r**26
            +164204688*r**28+155181008*r**30+3965687*r**32+48120*r**34)-4*Q2**6*(1647351
            -14352831*r**2+117544484*r**4-2396871489*r**6-15528829330*r**8-50224376909*r**10
            -96731471812*r**12+1280532399*r**14+119395271172*r**16+287703612373*r**18
            +324683049868*r**20+228431693765*r**22+96117974722*r**24+249999556697*r**26
            +22135234132*r**28+14069643725*r**30+528913813*r**32+10223070*r**34)
            -2*Q2*(-1+r**2)**4*(47136-1120867*r**2-29305005*r**4-186778536*r**6
            -5949184412*r**8+17475296892*r**10-61504054904*r**12+81529098888*r**14
            +114367967172*r**16-176339299026*r**18-248800387802*r**20+169628489064*r**22
            +69510987084*r**24-53855086276*r**26+27670686288*r**28+381341624*r**30
            +761677932*r**32+20939133*r**34+285615*r**36)+4*Q2**5*(278460-929313*r**2
            +130513082*r**4-1101912826*r**6-2720462752*r**8-28925807046*r**10-10828837304*r**12
            +42112541462*r**14+15725112352*r**16+65890527248*r**18+102479034900*r**20
            +54386760514*r**22+46736809296*r**24-20357624906*r**26+87753763704*r**28
            +8977095586*r**30+4654503028*r**32+163434785*r**34+1833330*r**36)+4*Q2**4*(388422
            -7098663*r**2-106574148*r**4-224987056*r**6-12004037354*r**8+24166375880*r**10
            -98014573870*r**12+10566363668*r**14+41326120490*r**16-86202866542*r**18
            -37669624366*r**20-77500515036*r**22+155705403218*r**24+139051578208*r**26
            -80394636554*r**28+63652848764*r**30-3521821656*r**32+2318473837*r**34
            +80172458*r**36+2178300*r**38)+Q2**2*(-1+r**2)**2*(486573-10381292*r**2
            -194321531*r**4-1317957546*r**6-38150370636*r**8+97563842736*r**10-355932844172*r**12
            +440694522168*r**14+331051253942*r**16-430400593928*r**18-594909461146*r**20
            -1017050328940*r**22+695705559492*r**24+569910692784*r**26-425472619836*r**28
            +201379402712*r**30-1805674971*r**32+6204334996*r**34+184372445*r**36
            +2886150*r**38)-4*Q2**3*(327318-6474966*r**2-83146165*r**4-522777708*r**6
            -15354507471*r**8+42893086308*r**10-153157340564*r**12+205301715028*r**14
            +5598332816*r**16-177698390632*r**18-4561137910*r**20+43442445196*r**22
            -380066562306*r**24+59286238332*r**26+344003481852*r**28-236238546916*r**30
            +94186854434*r**32-4439218082*r**34+3130292035*r**36+101028976*r**38
            +1900425*r**40))*sqrtq2))/(-9797760000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-136080000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-94500*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5+23514624000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+1632960000*logq2**3*(-Q2+(-1
            +r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+5670000*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(flagPERP*(-8294400*logq2**4*(-Q2+(-1+r)**2)*r**16*(-Q2+(1+r)**2)*(240*Q2**8*r**2
            -30*Q2**7*(7+50*r**2+36*r**4)+6*Q2**6*(266+735*r**2+837*r**4+140*r**6)
            +Q2**5*(-4431-8071*r**2-9867*r**4-2727*r**6+3255*r**8)+Q2**4*(5145
            +8463*r**2+10265*r**4+3621*r**6-7935*r**8-5985*r**10)-Q2**3*(840+6167*r**2
            +3532*r**4+304*r**6-7221*r**8-10755*r**10+1995*r**12)+(-1+r**2)**2*(
            -819+3026*r**2-3897*r**4-222*r**6+6253*r**8-138*r**10-1083*r**12+3180*r**14)
            +Q2**2*(-3570+9163*r**2-7256*r**4-1146*r**6+823*r**8-1104*r**10-7515*r**12
            +12705*r**14)+Q2*(3129-11202*r**2+16166*r**4+1809*r**6-13731*r**8
            -16370*r**10-5184*r**12+11343*r**14-11160*r**16))-2304*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(57168*Q2**14*r**2-2*Q2**13*(-5845+310746*r**2
            +288516*r**4)+Q2**12*(-97440+2678738*r**2+5412962*r**4+2400408*r**6)
            -Q2**11*(-311885+5670277*r**2+19448798*r**4+18479733*r**6+5158527*r**8)
            +Q2**10*(-406035+5114903*r**2+31187308*r**4+45167948*r**6+30074793*r**8
            +5502303*r**10)-Q2**9*(109375-1914214*r**2+10624190*r**4+9327810*r**6
            +20463435*r**8+19768700*r**10+1003236*r**12)-Q2**8*(-982695+8517566*r**2
            +37413211*r**4+139668380*r**6+179830575*r**8+66020850*r**10+4925001*r**12
            +4182336*r**14)+2*Q2**7*(-504735+2896037*r**2+27332808*r**4+118015867*r**6
            +226287510*r**8+172280965*r**10+46978302*r**12+6607803*r**14+2237967*r**16)
            -2*Q2**6*(55335-1171277*r**2+9893187*r**4+53666742*r**6+165987353*r**8
            +217919090*r**10+107190853*r**12+23966922*r**14+4429332*r**16+832023*r**18)
            +4*Q2**5*(242655-1333589*r**2-3588274*r**4-17464864*r**6-28069744*r**8
            +11650261*r**10+33903421*r**12+15583626*r**14+16154511*r**16+3465906*r**18
            +83511*r**20)-2*Q2**4*(324625-1038809*r**2-7383795*r**4-38767680*r**6
            -134930980*r**8-117932660*r**10-19151192*r**12+47345910*r**14+53577395*r**16
            +47152645*r**18+7911075*r**20+107466*r**22)+Q2**3*(-51135+1071683*r**2
            -4782482*r**4-18535145*r**6-74648325*r**8-136988350*r**10+3426424*r**12
            +174209514*r**14-6842005*r**16+143071675*r**18+13564810*r**20+2726143*r**22
            -362007*r**24)+(-1+r**2)**2*(19915-39592*r**2+357464*r**4+6433228*r**6
            -38999325*r**8+134836920*r**10-60268716*r**12-61967028*r**14-45600531*r**16
            +115400300*r**18-20550860*r**20+14446408*r**22+1214789*r**24+77028*r**26)
            +Q2**2*(260785-1356937*r**2+2139322*r**4+14240208*r**6-115580595*r**8
            +212437305*r**10-174402996*r**12-23795904*r**14-258619341*r**16+368938745*r**18
            -147183590*r**20+69561008*r**22+7284207*r**24+717783*r**26)-Q2*(124215
            -531098*r**2+1644178*r**4+17850358*r**6-138931683*r**8+395815020*r**10
            -330097044*r**12+110698164*r**14+132314889*r**16-381610794*r**18+445838090*r**20
            -130719658*r**22+53480483*r**24+5162328*r**26+402552*r**28))+16*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-176*Q2**18-Q2**17*(2535+1676*r**2)
            +Q2**16*(32913+364661*r**2+31652*r**4)-Q2**15*(68917+3787700*r**2+3771553*r**4
            +177696*r**6)+Q2**14*(-186186+14930971*r**2+33942285*r**4+15925827*r**6
            +525835*r**8)-Q2**13*(-732732+26050717*r**2+105692368*r**4+111027624*r**6
            +32799280*r**8+907327*r**10)+Q2**12*(324509+9485791*r**2+95086832*r**4
            +107830116*r**6+132834703*r**8+25415813*r**10+849708*r**12)+Q2**11*(
            -4735695+35935918*r**2+174035451*r**4+860194842*r**6+730239207*r**8
            +78154746*r**10+25696893*r**12-186626*r**14)-Q2**10*(-7878420+51117673*r**2
            +455427703*r**4+2689270611*r**6+4581253617*r**8+2298868719*r**10+369632889*r**12
            +71295877*r**14+445027*r**16)+Q2**9*(-2284128+6347953*r**2+273545720*r**4
            +2278224806*r**6+7588991340*r**8+7470882852*r**10+2238303088*r**12+320261170*r**14
            +42657116*r**16+366355*r**18)+Q2**8*(-7905711+29243549*r**2+120166776*r**4
            +1776146298*r**6-1548013800*r**8-4035751620*r**10-3769240026*r**12+219460086*r**14
            -2011977*r**16+29382855*r**18+121682*r**20)-Q2**7*(-9312237+5292944*r**2
            +126690299*r**4+4437162732*r**6+7584211446*r**8+12328513824*r**10+7299356238*r**12
            +1118301864*r**14+1733839047*r**16+122705136*r**18+50863751*r**20+262988*r**22)
            +Q2**6*(-631274-24250639*r**2-17896433*r**4+1874113581*r**6+6883024941*r**8
            +15156693138*r**10+20234085838*r**12+7332891090*r**14+985613736*r**16
            +858975661*r**18+78073619*r**20+12183601*r**22+6021*r**24)+Q2**5*(-5624664
            +13151621*r**2-112252680*r**4+1821627060*r**6-1866941356*r**8+2250779013*r**10
            -7611706416*r**12-8755730960*r**14-1615778544*r**16-1282968081*r**18
            -175004776*r**20-126163332*r**22+18061908*r**24+163367*r**26)+Q2**4*(3753939
            +7632901*r**2+209951320*r**4-2113533408*r**6+1413307675*r**8-10066028003*r**10
            -6957706272*r**12+699243080*r**14+1370609321*r**16+3452772735*r**18+2930899984*r**20
            +412158616*r**22+139818345*r**24-12844193*r**26-90440*r**28)-Q2**3*(
            -105655+8863882*r**2+44640383*r**4-316660626*r**6+585467545*r**8-2566777246*r**10
            -5087246889*r**12+3816175574*r**14-720240173*r**16+2043625630*r**18+2367671797*r**20
            +1524887882*r**22+224304843*r**24+13040374*r**26+118325*r**28+13554*r**30)
            +2*(-1+r**2)**2*(-36857-161613*r**2-6810851*r**4+35146072*r**6-233476106*r**8
            -16624739*r**10+3287333199*r**12-13455588938*r**14+20748902706*r**16
            -14279266723*r**18+4617951579*r**20-955820164*r**22-34667986*r**24-29099053*r**26
            -4448071*r**28+74742*r**30+803*r**32)+Q2**2*(-1128336+2016029*r**2-92595333*r**4
            +654708291*r**6-2153606607*r**8+3252444525*r**10-1274435037*r**12+2290651051*r**14
            +7064801553*r**16-16654038801*r**18+12936995113*r**20-3971069823*r**22
            -275119893*r**24-186126969*r**26-72474567*r**28+3043473*r**30+31331*r**32)
            +Q2*(500931+431635*r**2+65255680*r**4-451471698*r**6+2224528152*r**8
            -3042024930*r**10-6513831000*r**12+23634794558*r**14+2182533326*r**16
            -57386238084*r**18+60936658352*r**20-24714711430*r**22+5251155984*r**24
            +197165922*r**26+182264232*r**28+46919322*r**30-1182905*r**32-12047*r**34))
            -5225472000*logq2**5*r**20*(-1+r**4+2*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2-138240*logq2**3*r**12*(12240*Q2**13*r**2-2*Q2**12*(805+65346*r**2
            +58056*r**4)+2*Q2**11*(6685+309522*r**2+509229*r**4+233412*r**6)-Q2**10*(45010
            +1658977*r**2+3781563*r**4+3251763*r**6+1023657*r**8)+5*Q2**9*(14840
            +527967*r**2+1486895*r**4+1785987*r**6+1082181*r**8+265818*r**10)-5*Q2**8*(9240
            +457741*r**2+1493862*r**4+2234432*r**6+1988952*r**8+1010871*r**10+229734*r**12)
            +2*Q2**7*(-18690+237437*r**2+747282*r**4+1541385*r**6+2560700*r**8+2909985*r**10
            +1622772*r**12+528777*r**14)-4*Q2**6*(-21315-277423*r**2-1283996*r**4
            -1999003*r**6-1593305*r**8+172455*r**10+1141077*r**12+719649*r**14+326187*r**16)
            +2*Q2**5*(-23940-631588*r**2-2903952*r**4-4675197*r**6-4455058*r**8
            -773655*r**10+2621752*r**12+2520273*r**14+1522998*r**16+488367*r**18)
            +10*Q2**4*(-945+68164*r**2+143010*r**4+497731*r**6+175533*r**8-268233*r**10
            -524859*r**12-520271*r**14+133824*r**16-214263*r**18+25461*r**20)+(
            -1+r**2)**4*(140+9813*r**2-202046*r**4+926700*r**6-769394*r**8+310202*r**10
            -49598*r**12-371164*r**14+840390*r**16+4209*r**18+56748*r**20)-10*Q2**3*(
            -2345+30131*r**2-240131*r**4+627487*r**6-420684*r**8-379492*r**10+6024*r**12
            +12172*r**14-385635*r**16+990889*r**18-153453*r**20+116637*r**22)-Q2*(
            -1+r**2)**2*(-1120+56771*r**2-1198771*r**4+4441728*r**6-3092088*r**8
            +162606*r**10+2100178*r**12+730096*r**14-2025728*r**16+4692663*r**18
            -192711*r**20+374376*r**22)+Q2**2*(-10010+155293*r**2-2812977*r**4+9699175*r**6
            -10402295*r**8+3060690*r**10+2470954*r**12+5101414*r**14+5242620*r**16
            -10614735*r**18+10741815*r**20-1516077*r**22+980133*r**24))*sqrtq2-96*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(9312*Q2**17*r**2-4*Q2**16*(-805+31950*r**2
            +31368*r**4)+4*Q2**15*(-6685+161502*r**2+404131*r**4+169116*r**6)-Q2**14*(
            -86205+1568566*r**2+7173691*r**4+7409140*r**6+1895670*r**8)+2*Q2**13*(
            -55335+877182*r**2+6391588*r**4+7546174*r**6+7529917*r**8+1386990*r**10)
            -Q2**12*(55545+325312*r**2+892928*r**4-68024936*r**6-55484733*r**8+7582332*r**10
            +1205856*r**12)-4*Q2**11*(-88830+138939*r**2+7316008*r**4+90026929*r**6
            +162887050*r**8+76015549*r**10+6217412*r**12+641391*r**14)+Q2**10*(-367675
            -1123030*r**2+36823099*r**4+594075420*r**6+1792409349*r**8+1705822874*r**10
            +526212217*r**12+49659184*r**14+4273698*r**16)-2*Q2**9*(51205-825816*r**2
            +4872884*r**4+96431950*r**6+833807240*r**8+1312272220*r**10+895413124*r**12
            +152528314*r**14+14089355*r**16+642180*r**18)-Q2**8*(-523215-2287872*r**2
            -5690958*r**4+626144376*r**6+913254048*r**8+1261991140*r**10+202088558*r**12
            -313915968*r**14+199085991*r**16+14213508*r**18+2551560*r**20)+4*Q2**7*(
            -88165-1312728*r**2-7969281*r**4+197575162*r**6+740554886*r**8+1732027876*r**10
            +2057652454*r**12+790695704*r**14+170255247*r**16+87188276*r**18+6605931*r**20
            +630894*r**22)+Q2**6*(-117425+1964862*r**2+15376235*r**4-107758348*r**6
            -1798025460*r**8-5044647308*r**10-10384226762*r**12-8058157568*r**14
            -1879903593*r**16-424735010*r**18-152762433*r**20-12860644*r**22+69294*r**24)
            +2*Q2**5*(143535+1355918*r**2+18809060*r**4-209996206*r**6-78374599*r**8
            -662949094*r**10+177607368*r**12+2139634132*r**14+1113700217*r**16+581191826*r**18
            +260611316*r**20+44953946*r**22+2255135*r**24-650394*r**26)+Q2**4*(-123795
            -2844816*r**2-44458316*r**4+296284040*r**6+471841525*r**8+2272449820*r**10
            +6261334512*r**12+1755882032*r**14-1136786505*r**16-924153720*r**18-2563155940*r**20
            -818410136*r**22-118116281*r**24-2390900*r**26+629280*r**28)+4*Q2**3*(
            -7980+107941*r**2+1499054*r**4+2511507*r**6-55651184*r**8-21011415*r**10
            -810178302*r**12+57571407*r**14+221197076*r**16+46474703*r**18+579675250*r**20
            +243457961*r**22+84712264*r**24+3269667*r**26-455394*r**28+30645*r**30)
            +Q2**2*(49455+643662*r**2+15312277*r**4-103829084*r**6+285839973*r**8
            +52386658*r**10-2229257831*r**12+3134616736*r**14-1959850417*r**16-6026543886*r**18
            +9059347279*r**20-5204165324*r**22+1817549687*r**24+163304926*r**26+83714563*r**28
            +3897608*r**30-216282*r**32)-(-1+r**2)**2*(-2345-65626*r**2-1854889*r**4
            +5984320*r**6-47439045*r**8-275719454*r**10+1938692851*r**12-6012321852*r**14
            +4658322525*r**16+2971961450*r**18-4803909227*r**20+1599597976*r**22
            -516519559*r**24-47590770*r**26-13103455*r**28-362524*r**30+9624*r**32)
            +2*Q2*(-8995-183028*r**2-4702628*r**4+26616782*r**6-116212870*r**8
            -241815308*r**10+2486307572*r**12-6566587018*r**14+5601093876*r**16-4012394060*r**18
            +7740793636*r**20-8223996790*r**22+3180020950*r**24-857273108*r**26-69788020*r**28
            -29502158*r**30-1047329*r**32+38496*r**34))*sqrtq2)*math.log(mu0))/(-1088640000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -15120000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3-10500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5+2612736000*logq2**5*r**22*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2+181440000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+630000*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +((8294400*logq2**4*r**14*(240*Q2**10*(2+5*r**4)-60*Q2**9*(94+101*r**2
            +207*r**4+130*r**6)+6*Q2**8*(4860+9135*r**2+12334*r**4+10171*r**6+2700*r**8)
            +Q2**7*(-83115-206985*r**2-257752*r**4-220950*r**6-90333*r**8+2475*r**10)
            +Q2**6*(136395+397005*r**2+493517*r**4+440608*r**6+218607*r**8-7497*r**10
            -58275*r**12)+3*Q2**5*(-38745-126315*r**2-149848*r**4-154328*r**6-81845*r**8
            -5447*r**10+29078*r**12+22050*r**14)+(-1+r**2)**4*(-5295-1515*r**2
            +12089*r**4-30135*r**6+33915*r**8+73675*r**10-38745*r**12+15711*r**14
            +15900*r**16)+Q2**4*(12915+126105*r**2+139415*r**4+167910*r**6+101619*r**8
            -10879*r**10-61995*r**12+75600*r**14+53550*r**16)-Q2*(-1+r**2)**2*(
            -32055-8775*r**2+61087*r**4-181678*r**6+89880*r**8+411845*r**10+258475*r**12
            -156672*r**14+75093*r**16+87600*r**18)-Q2**3*(-75015-29085*r**2+56014*r**4
            -169219*r**6+1941*r**8+304330*r**10+155324*r**12-159411*r**14+206136*r**16
            +192825*r**18)+3*Q2**2*(-25245+6885*r**2+42599*r**4-131085*r**6+33124*r**8
            +167335*r**10+177730*r**12+174821*r**14-120075*r**16+13436*r**18+63675*r**20))
            +2304*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(48*Q2**16*(838+5955*r**4)
            -4*Q2**15*(115086+92281*r**2+723555*r**4+864210*r**6)+2*Q2**14*(1132020
            +1819411*r**2+7153190*r**4+15360775*r**6+9029100*r**8)-Q2**13*(6062805
            +14976983*r**2+43559448*r**4+120434570*r**6+134641855*r**8+52681875*r**10)
            +Q2**12*(8763615+31761437*r**2+69492641*r**4+252228032*r**6+387303175*r**8
            +308413235*r**10+91098825*r**12)-Q2**11*(3704022+30348218*r**2-33218587*r**4
            +125513553*r**6+328176528*r**8+448962072*r**10+365622605*r**12+85831845*r**14)
            +Q2**10*(-9696918-11224756*r**2-431228895*r**4-915897800*r**6-1320104945*r**8
            -1171642776*r**10-347392653*r**12+124808260*r**14+16632195*r**16)+Q2**9*(18851745
            +64970231*r**2+933837305*r**4+2852840125*r**6+5100395095*r**8+6044378435*r**10
            +4203949251*r**12+1544529415*r**14+224658700*r**16+59186850*r**18)-Q2**8*(11581515
            +70765809*r**2+838223784*r**4+3722446430*r**6+7260934980*r**8+10218802340*r**10
            +9198204694*r**12+5047360794*r**14+1782447585*r**16+336651315*r**18+73991250*r**20)
            +2*Q2**7*(-2548590+10700688*r**2-81188991*r**4+914255153*r**6+1352749420*r**8
            +2471321070*r**10+3402726318*r**12+2896150584*r**14+1375226418*r**16
            +669262050*r**18+127026465*r**20+20345175*r**22)-2*Q2**6*(-6607986-12613643*r**2
            -573488343*r**4-406225493*r**6-2402483023*r**8-3611757844*r**10-2348027518*r**12
            +30572132*r**14+1444601632*r**16+735581727*r**18+732147589*r**20+107602545*r**22
            +6367665*r**24)+Q2**5*(-7975107-30764441*r**2-1047937990*r**4-1369733260*r**6
            -6109730745*r**8-10866330877*r**10-10013433212*r**12-5705151680*r**14
            +156001995*r**16+3541298405*r**18+1584877714*r**20+1393134428*r**22+175143265*r**24
            +2009505*r**26)+(-1+r**2)**4*(-54381-210203*r**2-16395496*r**4+37320860*r**6
            -211843025*r**8+198926577*r**10+736984476*r**12-215859408*r**14-899793615*r**16
            +437532135*r**18+419929304*r**20-32371148*r**22+83990029*r**24+5778755*r**26
            +385140*r**28)+Q2**4*(-122535+13857947*r**2+182210865*r**4+759602400*r**6
            +1152709455*r**8+4433877135*r**10+3314220251*r**12+2455541080*r**14+355871775*r**16
            +930412745*r**18-546174625*r**20-844170648*r**22-73416295*r**24-32457875*r**26
            +6134325*r**28)-Q2*(-1+r**2)**2*(-492951-1061959*r**2-118227404*r**4
            +274064934*r**6-1369318985*r**8+945468947*r**10+3247233198*r**12-850025412*r**14
            +474010287*r**16-2528283225*r**18+1619857264*r**20+2474718686*r**22-348999759*r**24
            +496834829*r**26+35998510*r**28+2783040*r**30)-Q2**3*(-2922570+2247458*r**2
            -377729407*r**4+807717625*r**6-3163267960*r**8+1251681580*r**10+504013719*r**12
            -2325064401*r**14-579670770*r**16-2555941470*r**18+3172963615*r**20+4532850823*r**22
            -804813292*r**24+1182172720*r**26+86585705*r**28+11000625*r**30)+Q2**2*(
            -1796310-243688*r**2-332550859*r**4+936445312*r**6-3755572965*r**8+3679851120*r**10
            +2800326121*r**12-3482035632*r**14+2816936931*r**16+6250094040*r**18
            -4955843345*r**20-594358208*r**22+5816223041*r**24-1664897568*r**26+1106087475*r**28
            +82454960*r**30+7999575*r**32))-16*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(
            -1088*Q2**20*r**2-4*Q2**19*r**2*(3254+2527*r**2)+4*Q2**18*(6984+21070*r**2
            +437053*r**4+61039*r**6)-4*Q2**17*(73854-171626*r**2+3014129*r**4+5281142*r**6
            +424263*r**8)+Q2**16*(1326024-7616863*r**2+10708800*r**4+133192066*r**6
            +110588280*r**8+6453933*r**10)-Q2**15*(3118554-31531241*r**2-150313053*r**4
            +168955990*r**6+559106952*r**8+310985011*r**10+15463707*r**12)+Q2**14*(3388050
            -76009897*r**2-739442852*r**4-828150155*r**6-117685638*r**8+976472905*r**10
            +461342488*r**12+24222699*r**14)+Q2**13*(1176462+117929405*r**2+1833019065*r**4
            +4035889717*r**6+6813848013*r**8+5387219375*r**10+114960835*r**12-172718721*r**14
            -23983863*r**16)+Q2**12*(-8597862-111367537*r**2-2873005284*r**4-9065034328*r**6
            -21798363408*r**8-33373604106*r**10-21103165356*r**12-3496517712*r**14
            -615526906*r**16+12576291*r**18)+Q2**11*(9946638+24048549*r**2+2376833185*r**4
            +12146252716*r**6+31815516512*r**8+71668770270*r**10+76615036110*r**12
            +36282863212*r**14+6183276442*r**16+1160980645*r**18-637559*r**20)-Q2**10*(815958
            -115695195*r**2-1128092708*r**4+6620899277*r**6+2012840548*r**8+49048420610*r**10
            +88665167472*r**12+76598873210*r**14+24815634998*r**16+4453422329*r**18
            +720515972*r**20+881881*r**22)-Q2**9*(9459450+204896583*r**2+5985540467*r**4
            +7571950725*r**6+84026083939*r**8+109965770630*r**10+82424373502*r**12
            +25337876474*r**14-6487207040*r**16+11502502019*r**18-201432865*r**20
            +254002353*r**22+4454099*r**24)+Q2**8*(9284418+148767325*r**2+6790054364*r**4
            +16708903958*r**6+146759336214*r**8+294394151871*r**10+359794833240*r**12
            +295372365172*r**14+138383580222*r**16+46805498859*r**18+33170043532*r**20
            +1901361590*r**22+651899306*r**24+5602233*r**26)-Q2**7*(904878-9202987*r**2
            +1263538329*r**4+12129584710*r**6+68122705248*r**8+257617249959*r**10
            +309010861599*r**12+384739997348*r**14+246136316902*r**16+97896992451*r**18
            +37377275975*r**20+23120353110*r**22+1889799628*r**24+267617409*r**26
            +795201*r**28)+Q2**6*(-4702698-113996459*r**2-4785719340*r**4+5289423595*r**6
            -105134994174*r**8+96159586285*r**10-134605463928*r**12+14050429531*r**14
            +150135100474*r**16+68074935271*r**18+64288585396*r**20+33751587849*r**22
            +7012162606*r**24+2151622743*r**26-161640080*r**28-2970831*r**30)+Q2**5*(3603978
            +91016839*r**2+5075059355*r**4-4257705781*r**6+175555714407*r**8-116949353701*r**10
            +405247882799*r**12+228394781439*r**14+159936830335*r**16-142688920811*r**18
            +12865882481*r**20-101359146943*r**22-45176325499*r**24-1821897399*r**26
            -2004503611*r**28+193228277*r**30+2333835*r**32)+2*(-1+r**2)**4*(7767
            +336787*r**2+25802988*r**4-145684328*r**6+2324017000*r**8-13079872076*r**10
            +42016399156*r**12-71280856848*r**14+24865187926*r**16+58748744970*r**18
            -65447245804*r**20+24238088472*r**22-5593858048*r**24-419913148*r**26
            -150164020*r**28-20401312*r**30+301035*r**32+5483*r**34)-Q2**4*(464850
            +16192379*r**2+1317687948*r**4-1304476580*r**6+76708683348*r**8-138390616000*r**10
            +294096844876*r**12+18699514236*r**14+18436502920*r**16+232070889134*r**18
            -227361498620*r**20+80541018676*r**22-42375593876*r**24-23240391240*r**26
            +86028068*r**28-490707980*r**30+41707494*r**32+230367*r**34)-Q2*(-1
            +r**2)**2*(146214+5417905*r**2+391529241*r**4-2086623996*r**6+29902437860*r**8
            -141284837416*r**10+376241404400*r**12-445599218156*r**14-119078627440*r**16
            +392652404210*r**18+160834888250*r**20-464754914100*r**22+213029257884*r**24
            -56006326832*r**26-5088138920*r**28-1576114148*r**30-294597430*r**32
            +6144181*r**34+104293*r**36)-Q2**3*(802566+21028385*r**2+1180633641*r**4
            -4770241744*r**6+46743767352*r**8-104754704844*r**10+154813560420*r**12
            -49355881920*r**14+62641812964*r**16+220115144526*r**18-337889367890*r**20
            +17284569840*r**22+78166419832*r**24-73529655996*r**26-7278006828*r**28
            -2601332832*r**30-820918170*r**32+31766297*r**34+604401*r**36)+Q2**2*(539406
            +16673921*r**2+1123640504*r**4-6095670319*r**6+72517673608*r**8-300943086180*r**10
            +713437302960*r**12-799267034132*r**14+260644081396*r**16-336941934074*r**18
            +574188341952*r**20+87707883382*r**22-647947135928*r**24+366104173340*r**26
            -96457539696*r**28-10124528628*r**30-2576048338*r**32-822259519*r**34
            +23208008*r**36+390337*r**38))+10450944000*logq2**5*r**18*(-3-2*r**2+14*r**6
            +3*r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+138240*logq2**3*r**10*(240*Q2**13*(64
            +255*r**4)-4*Q2**12*(43920+41885*r**2+155079*r**4+145140*r**6)+2*Q2**11*(428160
            +783895*r**2+1807566*r**4+2413191*r**6+1167060*r**8)-Q2**10*(2271465
            +6056755*r**2+13248946*r**4+19439868*r**6+15303561*r**8+5118285*r**10)
            +5*Q2**9*(668190+2436539*r**2+5606946*r**4+8989754*r**6+8713014*r**8
            +4994739*r**10+1329090*r**12)-5*Q2**8*(390429+2513814*r**2+5592871*r**4
            +10181682*r**6+11862563*r**8+9114906*r**10+4408953*r**12+1148670*r**14)
            +2*Q2**7*(-943020+1798410*r**2-2905804*r**4-3376800*r**6+3525405*r**8
            +10477370*r**10+12366390*r**12+6044916*r**14+2643885*r**16)+Q2**6*(4580910
            +5816370*r**2+47913076*r**4+93829676*r**6+93769570*r**8+55259630*r**10
            +1345440*r**12-24375024*r**14-9379524*r**16-6523740*r**18)+2*Q2**5*(
            -1679310-3454065*r**2-24735604*r**4-52216407*r**6-57160479*r**8-46499485*r**10
            -14215635*r**12+7140931*r**14+16229193*r**16+4592226*r**18+2441835*r**20)
            +10*Q2**4*(18255+370188*r**2+977857*r**4+3641739*r**6+3832564*r**8+3781350*r**10
            +929160*r**12-1217124*r**14+1445605*r**16+151038*r**18-382737*r**20
            +127305*r**22)+(-1+r**2)**4*(-48165+13550*r**2-1655781*r**4+1417708*r**6
            +4541262*r**8-4479524*r**10+7586390*r**12-4775864*r**14+1422647*r**16
            +4444518*r**18+321519*r**20+283740*r**22)-10*Q2**3*(-146916+243673*r**2
            -2417218*r**4+287293*r**6+1287721*r**8-2508126*r**10-143152*r**12+1672986*r**14
            -3061934*r**16+3795669*r**18+4878538*r**20-117159*r**22+583185*r**24)
            -Q2*(-1+r**2)**2*(-369270+336545*r**2-10337182*r**4+6100739*r**6+21858300*r**8
            -21620574*r**10+26197332*r**12+35776222*r**14-20172494*r**16+7590445*r**18
            +24581514*r**20+762543*r**22+1871880*r**24)+Q2**2*(-1122405+2141545*r**2
            -25839026*r**4+23762820*r**6+27255595*r**8-55974305*r**10+34948620*r**12
            +64970392*r**14+83670265*r**16-50727345*r**18-12109290*r**20+52512660*r**22
            -3238191*r**24+4900665*r**26))*sqrtq2-192*logq2*r**4*(-23280*Q2**21*r**2
            +4*Q2**20*(-1901+67017*r**2+101700*r**4)-2*Q2**19*(-41999+448466*r**2
            +2233249*r**4+1542780*r**6)+Q2**18*(-459281-1559330*r**2+15642922*r**4
            +29852110*r**6+13479015*r**8)+Q2**17*(1790765+25708162*r**2+1763942*r**4
            -63318368*r**6-104663043*r**8-37316610*r**10)+2*Q2**16*(-2867207-61671801*r**2
            -105688319*r**4-144588394*r**6-50424471*r**8+96399759*r**10+33133905*r**12)
            +Q2**15*(14785748+375739980*r**2+951504816*r**4+2177714094*r**6+3122669772*r**8
            +1618383720*r**10-88767984*r**12-67902210*r**14)+2*Q2**14*(-13987292
            -390441682*r**2-1236100760*r**4-3341185983*r**6-6730888595*r**8-6869872632*r**10
            -3000297082*r**12-216959823*r**14+7113465*r**16)+2*Q2**13*(16969864+506705280*r**2
            +2031835975*r**4+5593514577*r**6+14434495681*r**8+20359789241*r**10+15994937513*r**12
            +5894938467*r**14+583333335*r**16+32718915*r**18)-2*Q2**12*(8093930+228108348*r**2
            +1753935795*r**4+2486972684*r**6+11922502594*r**8+24399961008*r**10+28605474124*r**12
            +20167841132*r**14+6427363428*r**16+707976828*r**18+46605585*r**20)+2*Q2**11*(
            -11419824-505875682*r**2-359138540*r**4-11762023525*r**6-22053851624*r**8
            -22891251572*r**10-10373232704*r**12+6301646226*r**14+9911683256*r**16
            +2546333638*r**18+408310188*r**20+18295875*r**22)+2*Q2**10*(25377495
            +1129233976*r**2+2929278924*r**4+30578647613*r**6+81386925062*r**8+128940233264*r**10
            +138131797516*r**12+91744005734*r**14+35877627579*r**16+7679273944*r**18
            +2924456392*r**20+42971357*r**22+19904040*r**24)-2*Q2**9*(19227663+917275138*r**2
            +3409864633*r**4+31792876459*r**6+107221525520*r**8+184717808607*r**10
            +238473483262*r**12+213961798674*r**14+126209036139*r**16+52933835940*r**18
            +15924577913*r**20+5286211363*r**22+267784582*r**24+28106715*r**26)+2*Q2**8*(
            -309244-23374190*r**2+1585832717*r**4+3774731746*r**6+59527138458*r**8
            +79160255820*r**10+117817470339*r**12+153782240156*r**14+145785056816*r**16
            +82294322258*r**18+42678519187*r**20+13314568514*r**22+4053031858*r**24
            +234271440*r**26+7997085*r**28)+2*Q2**7*(13274150+759597978*r**2+161396852*r**4
            +30272158165*r**6+2766961710*r**8+81700868796*r**10+118924170204*r**12
            +80617398739*r**14-7626953486*r**16-75287733526*r**18-42707036724*r**20
            -40517465125*r**22-10135336454*r**24-2172501792*r**26-136057692*r**28
            +9941085*r**30)+2*(-1+r**2)**6*(17587+1690505*r**2-1956685*r**4+205369507*r**6
            -876454659*r**8+2486920321*r**10-1700432405*r**12-9649384245*r**14+14466855531*r**16
            -2950948477*r**18-4573545263*r**20+1879026145*r**22-832379545*r**24-71840013*r**26
            -15449839*r**28-460495*r**30+12030*r**32)-2*Q2**6*(11208856+699610998*r**2
            +507200388*r**4+36664028793*r**6+10378266609*r**8+114852463440*r**10
            +171898395918*r**12+147713419207*r**14+101353358607*r**16+19253914238*r**18
            -69733046584*r**20-21113445321*r**22-38125271505*r**24-7760402340*r**26
            -1009435962*r**28-61940247*r**30+10426905*r**32)-Q2*(-1+r**2)**4*(391351
            +34643162*r**2-52644702*r**4+3693361850*r**6-13506634574*r**8+34878803658*r**10
            -14371761366*r**12-107430449846*r**14+51028639920*r**16+100282304558*r**18
            -47641227194*r**20-56438082114*r**22+24681311278*r**24-12949489570*r**26
            -1128662034*r**28-262871490*r**30-8961607*r**32+288720*r**34)+2*Q2**5*(2739596
            +197222392*r**2+356755553*r**4+14589850563*r**6-1755938077*r**8+36411578703*r**10
            +68181636305*r**12+16507990519*r**14+19392144531*r**16+20990441923*r**18
            +58414254027*r**20-30589374503*r**22+4090000113*r**24-8780221699*r**26
            -2675848701*r**28-12200531*r**30+2501901*r**32+2675385*r**34)+Q2**2*(
            -1+r**2)**2*(1838795+148782168*r**2-319681765*r**4+13838127558*r**6-47109494458*r**8
            +117465073430*r**10-64301379602*r**12-185374231242*r**14+16369175364*r**16
            +60633904006*r**18+155921352540*r**20-92489899070*r**22-165541722246*r**24
            +78918328018*r**26-40556181998*r**28-3411110590*r**30-921061071*r**32
            -37434822*r**34+1454985*r**36)+2*Q2**4*(2127956+138033786*r**2-461964733*r**4
            +7840297272*r**6-19790272210*r**8+52974872524*r**10-33107466886*r**12
            +22515073360*r**14+10975752926*r**16+33939524200*r**18+42486769024*r**20
            -97182377736*r**22-47804694006*r**24+18809275172*r**26-25292019290*r**28
            -1819800704*r**30-759732714*r**32-43547346*r**34+1845405*r**36)+2*Q2**3*(
            -2213167-161652300*r**2+511472097*r**4-13028240203*r**6+45629624116*r**8
            -114699478476*r**10+108629300948*r**12+24428453500*r**14-29581682274*r**16
            +35062830868*r**18+66581988318*r**20-123225830586*r**22+5632289764*r**24
            +139053641132*r**26-74902667964*r**28+31484497900*r**30+2238971513*r**32
            +817861464*r**34+42133545*r**36-1860195*r**38))*sqrtq2)*math.log(mu0))/(-3265920000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -45360000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3-31500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5+7838208000*logq2**5*r**22*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2+544320000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+1890000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +FLAGcD*flagPERP*((-172800*logq2**3*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(301
            -1584*r**2-240*Q2**6*r**2+5717*r**4-6176*r**6+8279*r**8-72*r**10-1017*r**12
            +1272*r**14+20*Q2**5*(7+51*r**2+72*r**4)-4*Q2**4*(196+445*r**2+1206*r**4
            +837*r**6)+Q2**3*(1001+2581*r**2+5141*r**4+8403*r**6+3162*r**8)+Q2**2*(91
            -2396*r**2-1418*r**4-5364*r**6-6801*r**8+432*r**10)+Q2*(-749+2609*r**2
            -3480*r**4-158*r**6+3027*r**8+2589*r**10-2718*r**12))-48*logq2*(Q2
            -(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(-2345-4786*r**2-4656*Q2**12*r**2
            -227548*r**4+481994*r**6+1802615*r**8-49508100*r**10+129325752*r**12
            -64400404*r**14-24624243*r**16+36020510*r**18-7593180*r**20+2793034*r**22
            +119077*r**24+9624*r**26+4*Q2**11*(-805+12483*r**2+10068*r**4)-4*Q2**10*(
            -4270+40169*r**2+101692*r**4+31629*r**6)+5*Q2**9*(-5705+35759*r**2
            +230039*r**4+218089*r**6+30234*r**8)+5*Q2**8*(-525+8796*r**2-146250*r**4
            -109268*r**6-153705*r**8+11736*r**10)-4*Q2**7*(-15225+43362*r**2+391830*r**4
            +2489570*r**6+2227745*r**8+377580*r**10+82962*r**12)+2*Q2**6*(-27930
            -43407*r**2+1131663*r**4+11081830*r**6+22772900*r**8+9808525*r**10+1462503*r**12
            +123228*r**14)+2*Q2**5*(-9555+140781*r**2-32367*r**4-4813089*r**6-29472945*r**8
            -31808175*r**10-3300179*r**12-377517*r**14+60246*r**16)-10*Q2**4*(-5565
            +7257*r**2+73677*r**4+1239897*r**6+13677*r**8-4040437*r**10-1987573*r**12
            +2016227*r**14+189432*r**16+25632*r**18)+20*Q2**3*(-1050-6669*r**2-15750*r**4
            +487512*r**6+1874250*r**8+2580692*r**10+822492*r**12+1358960*r**14+999352*r**16
            +75105*r**18+4146*r**20)+2*Q2**2*(-5950+43977*r**2+67185*r**4+926990*r**6
            -6384960*r**8-19560330*r**10-42812974*r**12+391620*r**14-15779010*r**16
            +594465*r**18+36285*r**20+28302*r**22)-Q2*(-10955+5893*r**2-461227*r**4
            +2684035*r**6+5334100*r**8-7411850*r**10+19731094*r**12-69809126*r**14
            +49679065*r**16-20660475*r**18+8352405*r**20+424163*r**22+46878*r**24))
            -72576000*logq2**4*r**14*(3-5*r**2+3*r**4+3*r**6)*sqrtq2+2880*logq2**2*r**6*(4320*Q2**11*r**2
            -8*Q2**10*(-7+5007*r**2+4986*r**4)+40*Q2**9*(-49+3857*r**2+7613*r**4
            +3759*r**6)-5*Q2**8*(-1785+59477*r**2+182793*r**4+184359*r**6+55980*r**8)
            +20*Q2**7*(-693+13253*r**2+62918*r**4+96754*r**6+66735*r**8+10305*r**10)
            +10*Q2**6*r**2*(203-53651*r**2-117893*r**4-127639*r**6-74214*r**8+14490*r**10)
            -2*Q2**5*(-12054+112469*r**2+304767*r**4+680760*r**6+961880*r**8+607101*r**10
            +176799*r**12+206262*r**14)+10*Q2**4*(-2499+18097*r**2+84256*r**4+244614*r**6
            +424315*r**8+462877*r**10+217370*r**12+75348*r**14+27414*r**16)+20*Q2**3*(105
            -212*r**2-14014*r**4-73778*r**6-81299*r**8-182225*r**10-173800*r**12
            -14564*r**14-25104*r**16+1755*r**18)-(-1+r**2)**2*(-1561+9259*r**2
            +17902*r**4-417650*r**6+974908*r**8-198572*r**10+237346*r**12-321422*r**14
            +301405*r**16-10303*r**18+13488*r**20)-10*Q2**2*(-1176+8281*r**2+7383*r**4
            -111243*r**6+173905*r**8-7005*r**10-34557*r**12-191033*r**14+148275*r**16
            -27480*r**18+14490*r**20)+10*Q2*(-770+5515*r**2+4639*r**4-115040*r**6
            +228502*r**8-24740*r**10+66736*r**12+144310*r**14-185396*r**16+125097*r**18
            -14511*r**20+7578*r**22))*sqrtq2+8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(279
            +51832*r**2+176*Q2**13*r**2-369279*r**4+4247926*r**6-14274463*r**8+27526342*r**10
            +129617771*r**12-553885372*r**14+660388553*r**16-367966084*r**18+98308279*r**20
            -19691578*r**22-449*r**24-240954*r**26-803*r**28+Q2**12*(-771+3063*r**2
            +750*r**4)-164*Q2**11*(-33+128*r**2+1019*r**4+62*r**6)+Q2**10*(-15111
            -9033*r**2+1230491*r**4+1032041*r**6+31932*r**8)-5*Q2**9*(-3879-36553*r**2
            +548994*r**4+1328318*r**6+448293*r**8+7979*r**10)+3*Q2**8*(-1965-51364*r**2
            +421575*r**4+3601030*r**6+3697755*r**8+297990*r**10+691*r**12)+2*Q2**7*(
            -6534-250623*r**2+1616565*r**4+1573020*r**6+4328420*r**8+225321*r**10
            +1865997*r**12+23610*r**14)-6*Q2**6*(-2121-155674*r**2+639433*r**4+3196174*r**6
            +14532525*r**8+12173384*r**10+3212001*r**12+870548*r**14+6754*r**16)
            +2*Q2**5*(1341-77562*r**2-628581*r**4+4567029*r**6+42074003*r**8+109470491*r**10
            +33108893*r**12+7934379*r**14+18744*r**16-3777*r**18)+5*Q2**4*(-1809
            -150223*r**2+876924*r**4+169908*r**6+7909498*r**8-20693230*r**10-36952648*r**12
            +12121444*r**14+636303*r**16+858453*r**18+5444*r**20)-2*Q2**3*(-1560
            -259383*r**2+945675*r**4-2691330*r**6+34366420*r**8+42739050*r**10+22169566*r**12
            -21456000*r**14+54405220*r**16+4550445*r**18+1210935*r**20+4962*r**22)
            +Q2**2*(1689+97333*r**2-1232405*r**4-268865*r**6-2372290*r**8+41581502*r**10
            +204873794*r**12-9518230*r**14+80995985*r**16+10862285*r**18+3461779*r**20
            -676457*r**22-4520*r**24)+Q2*(-1413-196377*r**2+1385164*r**4-8497688*r**6
            +31338675*r**8-29081629*r**10+114936104*r**12-332908368*r**14+324732521*r**16
            -173777275*r**18+47143692*r**20-249752*r**22+980329*r**24+4017*r**26))*sqrtq2)/(
            -96768000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-672000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+290304000*logq2**4*r**16*sqrtq2+12096000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2+14000*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +((172800*logq2**3*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(301-1584*r**2
            -240*Q2**6*r**2+5717*r**4-6176*r**6+8279*r**8-72*r**10-1017*r**12+1272*r**14
            +20*Q2**5*(7+51*r**2+72*r**4)-4*Q2**4*(196+445*r**2+1206*r**4+837*r**6)
            +Q2**3*(1001+2581*r**2+5141*r**4+8403*r**6+3162*r**8)+Q2**2*(91-2396*r**2
            -1418*r**4-5364*r**6-6801*r**8+432*r**10)+Q2*(-749+2609*r**2-3480*r**4
            -158*r**6+3027*r**8+2589*r**10-2718*r**12))+48*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2
            -(1+r)**2)**2*(-2345-4786*r**2-4656*Q2**12*r**2-227548*r**4+481994*r**6
            +1802615*r**8-49508100*r**10+129325752*r**12-64400404*r**14-24624243*r**16
            +36020510*r**18-7593180*r**20+2793034*r**22+119077*r**24+9624*r**26
            +4*Q2**11*(-805+12483*r**2+10068*r**4)-4*Q2**10*(-4270+40169*r**2+101692*r**4
            +31629*r**6)+5*Q2**9*(-5705+35759*r**2+230039*r**4+218089*r**6+30234*r**8)
            +5*Q2**8*(-525+8796*r**2-146250*r**4-109268*r**6-153705*r**8+11736*r**10)
            -4*Q2**7*(-15225+43362*r**2+391830*r**4+2489570*r**6+2227745*r**8+377580*r**10
            +82962*r**12)+2*Q2**6*(-27930-43407*r**2+1131663*r**4+11081830*r**6
            +22772900*r**8+9808525*r**10+1462503*r**12+123228*r**14)+2*Q2**5*(-9555
            +140781*r**2-32367*r**4-4813089*r**6-29472945*r**8-31808175*r**10-3300179*r**12
            -377517*r**14+60246*r**16)-10*Q2**4*(-5565+7257*r**2+73677*r**4+1239897*r**6
            +13677*r**8-4040437*r**10-1987573*r**12+2016227*r**14+189432*r**16+25632*r**18)
            +20*Q2**3*(-1050-6669*r**2-15750*r**4+487512*r**6+1874250*r**8+2580692*r**10
            +822492*r**12+1358960*r**14+999352*r**16+75105*r**18+4146*r**20)+2*Q2**2*(
            -5950+43977*r**2+67185*r**4+926990*r**6-6384960*r**8-19560330*r**10
            -42812974*r**12+391620*r**14-15779010*r**16+594465*r**18+36285*r**20
            +28302*r**22)-Q2*(-10955+5893*r**2-461227*r**4+2684035*r**6+5334100*r**8
            -7411850*r**10+19731094*r**12-69809126*r**14+49679065*r**16-20660475*r**18
            +8352405*r**20+424163*r**22+46878*r**24))+72576000*logq2**4*r**14*(3-5*r**2
            +3*r**4+3*r**6)*sqrtq2+2880*logq2**2*r**6*(-4320*Q2**11*r**2+8*Q2**10*(-7
            +5007*r**2+4986*r**4)-40*Q2**9*(-49+3857*r**2+7613*r**4+3759*r**6)
            +5*Q2**8*(-1785+59477*r**2+182793*r**4+184359*r**6+55980*r**8)-20*Q2**7*(
            -693+13253*r**2+62918*r**4+96754*r**6+66735*r**8+10305*r**10)-10*Q2**6*r**2*(203
            -53651*r**2-117893*r**4-127639*r**6-74214*r**8+14490*r**10)+2*Q2**5*(
            -12054+112469*r**2+304767*r**4+680760*r**6+961880*r**8+607101*r**10
            +176799*r**12+206262*r**14)-10*Q2**4*(-2499+18097*r**2+84256*r**4+244614*r**6
            +424315*r**8+462877*r**10+217370*r**12+75348*r**14+27414*r**16)-20*Q2**3*(105
            -212*r**2-14014*r**4-73778*r**6-81299*r**8-182225*r**10-173800*r**12
            -14564*r**14-25104*r**16+1755*r**18)+(-1+r**2)**2*(-1561+9259*r**2
            +17902*r**4-417650*r**6+974908*r**8-198572*r**10+237346*r**12-321422*r**14
            +301405*r**16-10303*r**18+13488*r**20)+10*Q2**2*(-1176+8281*r**2+7383*r**4
            -111243*r**6+173905*r**8-7005*r**10-34557*r**12-191033*r**14+148275*r**16
            -27480*r**18+14490*r**20)-10*Q2*(-770+5515*r**2+4639*r**4-115040*r**6
            +228502*r**8-24740*r**10+66736*r**12+144310*r**14-185396*r**16+125097*r**18
            -14511*r**20+7578*r**22))*sqrtq2-8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(279
            +51832*r**2+176*Q2**13*r**2-369279*r**4+4247926*r**6-14274463*r**8+27526342*r**10
            +129617771*r**12-553885372*r**14+660388553*r**16-367966084*r**18+98308279*r**20
            -19691578*r**22-449*r**24-240954*r**26-803*r**28+Q2**12*(-771+3063*r**2
            +750*r**4)-164*Q2**11*(-33+128*r**2+1019*r**4+62*r**6)+Q2**10*(-15111
            -9033*r**2+1230491*r**4+1032041*r**6+31932*r**8)-5*Q2**9*(-3879-36553*r**2
            +548994*r**4+1328318*r**6+448293*r**8+7979*r**10)+3*Q2**8*(-1965-51364*r**2
            +421575*r**4+3601030*r**6+3697755*r**8+297990*r**10+691*r**12)+2*Q2**7*(
            -6534-250623*r**2+1616565*r**4+1573020*r**6+4328420*r**8+225321*r**10
            +1865997*r**12+23610*r**14)-6*Q2**6*(-2121-155674*r**2+639433*r**4+3196174*r**6
            +14532525*r**8+12173384*r**10+3212001*r**12+870548*r**14+6754*r**16)
            +2*Q2**5*(1341-77562*r**2-628581*r**4+4567029*r**6+42074003*r**8+109470491*r**10
            +33108893*r**12+7934379*r**14+18744*r**16-3777*r**18)+5*Q2**4*(-1809
            -150223*r**2+876924*r**4+169908*r**6+7909498*r**8-20693230*r**10-36952648*r**12
            +12121444*r**14+636303*r**16+858453*r**18+5444*r**20)-2*Q2**3*(-1560
            -259383*r**2+945675*r**4-2691330*r**6+34366420*r**8+42739050*r**10+22169566*r**12
            -21456000*r**14+54405220*r**16+4550445*r**18+1210935*r**20+4962*r**22)
            +Q2**2*(1689+97333*r**2-1232405*r**4-268865*r**6-2372290*r**8+41581502*r**10
            +204873794*r**12-9518230*r**14+80995985*r**16+10862285*r**18+3461779*r**20
            -676457*r**22-4520*r**24)+Q2*(-1413-196377*r**2+1385164*r**4-8497688*r**6
            +31338675*r**8-29081629*r**10+114936104*r**12-332908368*r**14+324732521*r**16
            -173777275*r**18+47143692*r**20-249752*r**22+980329*r**24+4017*r**26))*sqrtq2)*math.log(murhoD))/(
            -26127360*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-181440*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+78382080*logq2**4*r**16*sqrtq2+3265920*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2+3780*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2))
            +FLAGcD*((43200*logq2**3*r**8*(-240*Q2**8*(1+5*r**4)+20*Q2**7*(117+166*r**2
            +501*r**4+480*r**6)-4*Q2**6*(2415+5900*r**2+10136*r**4+14688*r**6+8085*r**8)
            +Q2**5*(19425+64530*r**2+93454*r**4+122436*r**6+133377*r**8+56490*r**10)
            -Q2**4*(17325+75505*r**2+111190*r**4+115462*r**6+146261*r**8+133785*r**10
            +46200*r**12)+Q2**3*(-210+29530*r**2+62170*r**4+36808*r**6+70082*r**8
            +98834*r**10+33270*r**12-2100*r**14)+(-1+r**2)**2*(2175+355*r**2-4569*r**4
            +39419*r**6+18349*r**8+115649*r**10-35691*r**12+5793*r**14+6360*r**16)
            +2*Q2**2*(6405+1710*r**2-17795*r**4+18194*r**6+29*r**8+40550*r**10
            -56313*r**12+14010*r**14+17850*r**16)-Q2*(9315-2300*r**2-25984*r**4
            +128230*r**6+56718*r**8+228638*r**10+286248*r**12-121038*r**14+5223*r**16
            +26310*r**18))-12*logq2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(4656*Q2**14*(1
            +5*r**4)-4*Q2**13*(9981+4346*r**2+38205*r**4+61980*r**6)+4*Q2**12*(35289
            +31746*r**2-3186*r**4+392890*r**6+264645*r**8)-Q2**11*(246759+384626*r**2
            -2256934*r**4+587244*r**6+5876815*r**8+2222370*r**10)+Q2**10*(155661
            +594681*r**2-8831714*r**4-13613034*r**6-7003739*r**8+8957825*r**10+1850880*r**12)
            +Q2**9*(185163-401150*r**2+21101265*r**4+55561850*r**6+91934525*r**8
            +68897718*r**10+939175*r**12+1490190*r**14)-Q2**8*(427977+170877*r**2
            +34467885*r**4+141383925*r**6+309486275*r**8+391317767*r**10+205760327*r**12
            +22704135*r**14+4844160*r**16)+Q2**7*(243738+632892*r**2+27746208*r**4
            +216896700*r**6+571666860*r**8+909856288*r**10+774178672*r**12+248138668*r**14
            +29796330*r**16+3521340*r**18)+2*Q2**6*(68409-318579*r**2+7216116*r**4
            -73107126*r**6-189303760*r**8-437701626*r**10-485681424*r**12-303122814*r**14
            +1309859*r**16-3843135*r**18+627120*r**20)-2*Q2**5*(130911-142854*r**2
            +27383571*r**4+15435336*r**6+182291046*r**8+165362706*r**10+80090386*r**12
            +79355246*r**14+52021411*r**16+162885196*r**18+8394675*r**20+1790130*r**22)
            +2*Q2**4*(54153+49975*r**2+21185265*r**4+52066275*r**6+329756050*r**8
            +567660684*r**10+603473600*r**12+564545620*r**14+392790475*r**16+229278725*r**18
            +152733063*r**20+8436225*r**22+913890*r**24)+Q2**3*(35901-262314*r**2
            +1570530*r**4-68997280*r**6-109705125*r**8-634573542*r**10-618767172*r**12
            -988466560*r**14-589938125*r**16-4908950*r**18-329195934*r**20-22813664*r**22
            -3502795*r**24+385830*r**26)-(-1+r**2)**2*(2589-4733*r**2+2241614*r**4
            -5780470*r**6+73049315*r**8-233520403*r**10-35002404*r**12+1228727532*r**14
            -742870045*r**16+129396765*r**18+122562014*r**20-23266038*r**22+16198429*r**24
            +441715*r**26+48120*r**28)-Q2**2*(51519-191549*r**2+21023614*r**4-48309390*r**6
            +383527965*r**8-515789363*r**10+29328068*r**12+329218412*r**14-1181695175*r**16
            -132837235*r**18+696010894*r**20-243046494*r**22+126648299*r**24+3036515*r**26
            +799920*r**28)+Q2*(19191-68166*r**2+12008609*r**4-34826154*r**6+321469335*r**8
            -789979722*r**10+85768417*r**12+1505869722*r**14+1701505453*r**16-981466970*r**18
            -175522149*r**20+583848074*r**22-180867131*r**24+78850026*r**26+1956835*r**28
            +330630*r**30))+18144000*logq2**4*r**12*(9+12*r**2-26*r**4+84*r**6+9*r**8)*sqrtq2
            +720*logq2**2*r**4*(-4320*Q2**11*(1+5*r**4)+8*Q2**10*(4965+4916*r**2+20601*r**4
            +24930*r**6)-40*Q2**9*(3612+7217*r**2+19493*r**4+31427*r**6+18795*r**8)
            +5*Q2**8*(50625+163440*r**2+459434*r**4+829380*r**6+751365*r**8+279900*r**10)
            -20*Q2**7*(8226+54837*r**2+165173*r**4+369290*r**6+407620*r**8+259473*r**10
            +51525*r**12)-20*Q2**6*(7245-29757*r**2-13760*r**4-167221*r**6-237535*r**8
            -163463*r**10-111678*r**12+36225*r**14)+2*Q2**5*(170100+80262*r**2+2890847*r**4
            +5149485*r**6+5819760*r**8+6516920*r**10+5177967*r**12+1268757*r**14
            +1031310*r**16)-10*Q2**4*(19917+43302*r**2+696535*r**4+1674070*r**6
            +2004837*r**8+2248840*r**10+2048341*r**12+1426478*r**14+375522*r**16
            +137070*r**18)-20*Q2**3*(2070-18825*r**2-40178*r**4-413134*r**6-493868*r**8
            -490217*r**10-921311*r**12-312148*r**14-100640*r**16-102060*r**18+8775*r**20)
            +20*Q2**2*(5481-14553*r**2+216497*r**4-202152*r**6-195594*r**8+245543*r**10
            +79464*r**12-737049*r**14-42235*r**16+428850*r**18-42237*r**20+36225*r**22)
            +(-1+r**2)**2*(8805-17242*r**2+789439*r**4-1773860*r**6-986474*r**8
            +9561352*r**10+5375842*r**12-326924*r**14-1127675*r**16+1722514*r**18
            +12383*r**20+67440*r**22)-10*Q2*(5268-15566*r**2+341497*r**4-654419*r**6
            -274184*r**8+2240122*r**10+1166944*r**12+2977672*r**14-436142*r**16
            -719852*r**18+696519*r**20-43509*r**22+37890*r**24))*sqrtq2+(-63*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**3*(5*Q2**5-Q2**4*(7+15*r**2)+2*Q2**3*(4+2*r**2+5*r**4)+(-1
            +r**2)**2*(17+r**2-11*r**4+5*r**6)+2*Q2**2*(7-6*r**2-4*r**4+5*r**6)
            -Q2*(37+20*r**2+8*r**4-32*r**6+15*r**8))+5*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32256*Q2**14
            -288*Q2**13*(339+518*r**2)+8*Q2**12*(11745+40478*r**2+23877*r**4)+Q2**11*(95499
            -358507*r**2-508135*r**4+99351*r**6)-Q2**10*(383589+356080*r**2+1976274*r**4
            -329264*r**6+354249*r**8)+Q2**9*(21459+1400491*r**2+7390760*r**4+10034036*r**6
            +1055725*r**8+34713*r**10)+3*Q2**8*(374345-756146*r**2-3663623*r**4
            -3769244*r**6-2403589*r**8-751922*r**10+107331*r**12)-6*Q2**7*(199739
            -371663*r**2-1833699*r**4-4168441*r**6-937469*r**8+2363425*r**10-467*r**12
            +14847*r**14)+Q2**6*(-288642+2265816*r**2+231180*r**4-8496168*r**6+23003492*r**8
            -6870072*r**10+13567596*r**12+2449800*r**14-179802*r**16)+2*Q2**5*(556707
            -2541849*r**2+17102856*r**4+26213580*r**6-16538884*r**8-58976872*r**10
            -14698344*r**12+5756076*r**14-244239*r**16+26649*r**18)+2*Q2**4*(-280545
            +498702*r**2-36732645*r**4-57585012*r**6-82444840*r**8-153525108*r**10
            -68689312*r**12+19803180*r**14-6641823*r**16-733650*r**18+33453*r**20)
            +Q2**3*(-80553+1343297*r**2+18298989*r**4+65629323*r**6+235764138*r**8
            +98850070*r**10+231769822*r**12+308404866*r**14+33807807*r**16-440343*r**18
            +313973*r**20-15309*r**22)+Q2**2*(240999-890072*r**2+38735950*r**4-99122616*r**6
            -171385291*r**8-436767904*r**10-226505772*r**12+241352384*r**14+125268401*r**16
            -35938824*r**18+3304030*r**20+469624*r**22-15309*r**24)+(-1+r**2)**2*(33375
            -463432*r**2+9716288*r**4+34210932*r**6+429107767*r**8+185694112*r**10
            -23101104*r**12-160832984*r**14+74725573*r**16+11512488*r**18+710768*r**20
            -61084*r**22+1701*r**24)+Q2*(-144057+1075351*r**2-33791760*r**4+4965436*r**6
            -891123325*r**8-1407498441*r**10-371766112*r**12+416999240*r**14+306799653*r**16
            -255890035*r**18-12685712*r**20-1896324*r**22-63215*r**24+1701*r**26)))*sqrtq2)/(
            -72576000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-504000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+217728000*logq2**4*r**16*sqrtq2+9072000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2+10500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +((-43200*logq2**3*r**8*(-240*Q2**8*(1+5*r**4)+20*Q2**7*(117+166*r**2+501*r**4
            +480*r**6)-4*Q2**6*(2415+5900*r**2+10136*r**4+14688*r**6+8085*r**8)
            +Q2**5*(19425+64530*r**2+93454*r**4+122436*r**6+133377*r**8+56490*r**10)
            -Q2**4*(17325+75505*r**2+111190*r**4+115462*r**6+146261*r**8+133785*r**10
            +46200*r**12)+Q2**3*(-210+29530*r**2+62170*r**4+36808*r**6+70082*r**8
            +98834*r**10+33270*r**12-2100*r**14)+(-1+r**2)**2*(2175+355*r**2-4569*r**4
            +39419*r**6+18349*r**8+115649*r**10-35691*r**12+5793*r**14+6360*r**16)
            +2*Q2**2*(6405+1710*r**2-17795*r**4+18194*r**6+29*r**8+40550*r**10
            -56313*r**12+14010*r**14+17850*r**16)-Q2*(9315-2300*r**2-25984*r**4
            +128230*r**6+56718*r**8+228638*r**10+286248*r**12-121038*r**14+5223*r**16
            +26310*r**18))+12*logq2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(4656*Q2**14*(1
            +5*r**4)-4*Q2**13*(9981+4346*r**2+38205*r**4+61980*r**6)+4*Q2**12*(35289
            +31746*r**2-3186*r**4+392890*r**6+264645*r**8)-Q2**11*(246759+384626*r**2
            -2256934*r**4+587244*r**6+5876815*r**8+2222370*r**10)+Q2**10*(155661
            +594681*r**2-8831714*r**4-13613034*r**6-7003739*r**8+8957825*r**10+1850880*r**12)
            +Q2**9*(185163-401150*r**2+21101265*r**4+55561850*r**6+91934525*r**8
            +68897718*r**10+939175*r**12+1490190*r**14)-Q2**8*(427977+170877*r**2
            +34467885*r**4+141383925*r**6+309486275*r**8+391317767*r**10+205760327*r**12
            +22704135*r**14+4844160*r**16)+Q2**7*(243738+632892*r**2+27746208*r**4
            +216896700*r**6+571666860*r**8+909856288*r**10+774178672*r**12+248138668*r**14
            +29796330*r**16+3521340*r**18)+2*Q2**6*(68409-318579*r**2+7216116*r**4
            -73107126*r**6-189303760*r**8-437701626*r**10-485681424*r**12-303122814*r**14
            +1309859*r**16-3843135*r**18+627120*r**20)-2*Q2**5*(130911-142854*r**2
            +27383571*r**4+15435336*r**6+182291046*r**8+165362706*r**10+80090386*r**12
            +79355246*r**14+52021411*r**16+162885196*r**18+8394675*r**20+1790130*r**22)
            +2*Q2**4*(54153+49975*r**2+21185265*r**4+52066275*r**6+329756050*r**8
            +567660684*r**10+603473600*r**12+564545620*r**14+392790475*r**16+229278725*r**18
            +152733063*r**20+8436225*r**22+913890*r**24)+Q2**3*(35901-262314*r**2
            +1570530*r**4-68997280*r**6-109705125*r**8-634573542*r**10-618767172*r**12
            -988466560*r**14-589938125*r**16-4908950*r**18-329195934*r**20-22813664*r**22
            -3502795*r**24+385830*r**26)-(-1+r**2)**2*(2589-4733*r**2+2241614*r**4
            -5780470*r**6+73049315*r**8-233520403*r**10-35002404*r**12+1228727532*r**14
            -742870045*r**16+129396765*r**18+122562014*r**20-23266038*r**22+16198429*r**24
            +441715*r**26+48120*r**28)-Q2**2*(51519-191549*r**2+21023614*r**4-48309390*r**6
            +383527965*r**8-515789363*r**10+29328068*r**12+329218412*r**14-1181695175*r**16
            -132837235*r**18+696010894*r**20-243046494*r**22+126648299*r**24+3036515*r**26
            +799920*r**28)+Q2*(19191-68166*r**2+12008609*r**4-34826154*r**6+321469335*r**8
            -789979722*r**10+85768417*r**12+1505869722*r**14+1701505453*r**16-981466970*r**18
            -175522149*r**20+583848074*r**22-180867131*r**24+78850026*r**26+1956835*r**28
            +330630*r**30))-18144000*logq2**4*r**12*(9+12*r**2-26*r**4+84*r**6+9*r**8)*sqrtq2
            -720*logq2**2*r**4*(-4320*Q2**11*(1+5*r**4)+8*Q2**10*(4965+4916*r**2+20601*r**4
            +24930*r**6)-40*Q2**9*(3612+7217*r**2+19493*r**4+31427*r**6+18795*r**8)
            +5*Q2**8*(50625+163440*r**2+459434*r**4+829380*r**6+751365*r**8+279900*r**10)
            -20*Q2**7*(8226+54837*r**2+165173*r**4+369290*r**6+407620*r**8+259473*r**10
            +51525*r**12)-20*Q2**6*(7245-29757*r**2-13760*r**4-167221*r**6-237535*r**8
            -163463*r**10-111678*r**12+36225*r**14)+2*Q2**5*(170100+80262*r**2+2890847*r**4
            +5149485*r**6+5819760*r**8+6516920*r**10+5177967*r**12+1268757*r**14
            +1031310*r**16)-10*Q2**4*(19917+43302*r**2+696535*r**4+1674070*r**6
            +2004837*r**8+2248840*r**10+2048341*r**12+1426478*r**14+375522*r**16
            +137070*r**18)-20*Q2**3*(2070-18825*r**2-40178*r**4-413134*r**6-493868*r**8
            -490217*r**10-921311*r**12-312148*r**14-100640*r**16-102060*r**18+8775*r**20)
            +20*Q2**2*(5481-14553*r**2+216497*r**4-202152*r**6-195594*r**8+245543*r**10
            +79464*r**12-737049*r**14-42235*r**16+428850*r**18-42237*r**20+36225*r**22)
            +(-1+r**2)**2*(8805-17242*r**2+789439*r**4-1773860*r**6-986474*r**8
            +9561352*r**10+5375842*r**12-326924*r**14-1127675*r**16+1722514*r**18
            +12383*r**20+67440*r**22)-10*Q2*(5268-15566*r**2+341497*r**4-654419*r**6
            -274184*r**8+2240122*r**10+1166944*r**12+2977672*r**14-436142*r**16
            -719852*r**18+696519*r**20-43509*r**22+37890*r**24))*sqrtq2+(63*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**3*(5*Q2**5-Q2**4*(7+15*r**2)+2*Q2**3*(4+2*r**2+5*r**4)+(-1
            +r**2)**2*(17+r**2-11*r**4+5*r**6)+2*Q2**2*(7-6*r**2-4*r**4+5*r**6)
            -Q2*(37+20*r**2+8*r**4-32*r**6+15*r**8))-5*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32256*Q2**14
            -288*Q2**13*(339+518*r**2)+8*Q2**12*(11745+40478*r**2+23877*r**4)+Q2**11*(95499
            -358507*r**2-508135*r**4+99351*r**6)-Q2**10*(383589+356080*r**2+1976274*r**4
            -329264*r**6+354249*r**8)+Q2**9*(21459+1400491*r**2+7390760*r**4+10034036*r**6
            +1055725*r**8+34713*r**10)+3*Q2**8*(374345-756146*r**2-3663623*r**4
            -3769244*r**6-2403589*r**8-751922*r**10+107331*r**12)-6*Q2**7*(199739
            -371663*r**2-1833699*r**4-4168441*r**6-937469*r**8+2363425*r**10-467*r**12
            +14847*r**14)+Q2**6*(-288642+2265816*r**2+231180*r**4-8496168*r**6+23003492*r**8
            -6870072*r**10+13567596*r**12+2449800*r**14-179802*r**16)+2*Q2**5*(556707
            -2541849*r**2+17102856*r**4+26213580*r**6-16538884*r**8-58976872*r**10
            -14698344*r**12+5756076*r**14-244239*r**16+26649*r**18)+2*Q2**4*(-280545
            +498702*r**2-36732645*r**4-57585012*r**6-82444840*r**8-153525108*r**10
            -68689312*r**12+19803180*r**14-6641823*r**16-733650*r**18+33453*r**20)
            +Q2**3*(-80553+1343297*r**2+18298989*r**4+65629323*r**6+235764138*r**8
            +98850070*r**10+231769822*r**12+308404866*r**14+33807807*r**16-440343*r**18
            +313973*r**20-15309*r**22)+Q2**2*(240999-890072*r**2+38735950*r**4-99122616*r**6
            -171385291*r**8-436767904*r**10-226505772*r**12+241352384*r**14+125268401*r**16
            -35938824*r**18+3304030*r**20+469624*r**22-15309*r**24)+(-1+r**2)**2*(33375
            -463432*r**2+9716288*r**4+34210932*r**6+429107767*r**8+185694112*r**10
            -23101104*r**12-160832984*r**14+74725573*r**16+11512488*r**18+710768*r**20
            -61084*r**22+1701*r**24)+Q2*(-144057+1075351*r**2-33791760*r**4+4965436*r**6
            -891123325*r**8-1407498441*r**10-371766112*r**12+416999240*r**14+306799653*r**16
            -255890035*r**18-12685712*r**20-1896324*r**22-63215*r**24+1701*r**26)))*sqrtq2)*math.log(murhoD))/(
            -19595520*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-136080*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+58786560*logq2**4*r**16*sqrtq2+2449440*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2+2835*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2))
            +(flagPERP*(8294400*logq2**4*(-Q2+(-1+r)**2)*r**16*(-Q2+(1+r)**2)*(240*Q2**8*r**2
            -30*Q2**7*(7+50*r**2+36*r**4)+6*Q2**6*(266+735*r**2+837*r**4+140*r**6)
            +Q2**5*(-4431-8071*r**2-9867*r**4-2727*r**6+3255*r**8)+Q2**4*(5145
            +8463*r**2+10265*r**4+3621*r**6-7935*r**8-5985*r**10)-Q2**3*(840+6167*r**2
            +3532*r**4+304*r**6-7221*r**8-10755*r**10+1995*r**12)+(-1+r**2)**2*(
            -819+3026*r**2-3897*r**4-222*r**6+6253*r**8-138*r**10-1083*r**12+3180*r**14)
            +Q2**2*(-3570+9163*r**2-7256*r**4-1146*r**6+823*r**8-1104*r**10-7515*r**12
            +12705*r**14)+Q2*(3129-11202*r**2+16166*r**4+1809*r**6-13731*r**8
            -16370*r**10-5184*r**12+11343*r**14-11160*r**16))+2304*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(57168*Q2**14*r**2-2*Q2**13*(-5845+310746*r**2
            +288516*r**4)+Q2**12*(-97440+2678738*r**2+5412962*r**4+2400408*r**6)
            -Q2**11*(-311885+5670277*r**2+19448798*r**4+18479733*r**6+5158527*r**8)
            +Q2**10*(-406035+5114903*r**2+31187308*r**4+45167948*r**6+30074793*r**8
            +5502303*r**10)-Q2**9*(109375-1914214*r**2+10624190*r**4+9327810*r**6
            +20463435*r**8+19768700*r**10+1003236*r**12)-Q2**8*(-982695+8517566*r**2
            +37413211*r**4+139668380*r**6+179830575*r**8+66020850*r**10+4925001*r**12
            +4182336*r**14)+2*Q2**7*(-504735+2896037*r**2+27332808*r**4+118015867*r**6
            +226287510*r**8+172280965*r**10+46978302*r**12+6607803*r**14+2237967*r**16)
            -2*Q2**6*(55335-1171277*r**2+9893187*r**4+53666742*r**6+165987353*r**8
            +217919090*r**10+107190853*r**12+23966922*r**14+4429332*r**16+832023*r**18)
            +4*Q2**5*(242655-1333589*r**2-3588274*r**4-17464864*r**6-28069744*r**8
            +11650261*r**10+33903421*r**12+15583626*r**14+16154511*r**16+3465906*r**18
            +83511*r**20)-2*Q2**4*(324625-1038809*r**2-7383795*r**4-38767680*r**6
            -134930980*r**8-117932660*r**10-19151192*r**12+47345910*r**14+53577395*r**16
            +47152645*r**18+7911075*r**20+107466*r**22)+Q2**3*(-51135+1071683*r**2
            -4782482*r**4-18535145*r**6-74648325*r**8-136988350*r**10+3426424*r**12
            +174209514*r**14-6842005*r**16+143071675*r**18+13564810*r**20+2726143*r**22
            -362007*r**24)+(-1+r**2)**2*(19915-39592*r**2+357464*r**4+6433228*r**6
            -38999325*r**8+134836920*r**10-60268716*r**12-61967028*r**14-45600531*r**16
            +115400300*r**18-20550860*r**20+14446408*r**22+1214789*r**24+77028*r**26)
            +Q2**2*(260785-1356937*r**2+2139322*r**4+14240208*r**6-115580595*r**8
            +212437305*r**10-174402996*r**12-23795904*r**14-258619341*r**16+368938745*r**18
            -147183590*r**20+69561008*r**22+7284207*r**24+717783*r**26)-Q2*(124215
            -531098*r**2+1644178*r**4+17850358*r**6-138931683*r**8+395815020*r**10
            -330097044*r**12+110698164*r**14+132314889*r**16-381610794*r**18+445838090*r**20
            -130719658*r**22+53480483*r**24+5162328*r**26+402552*r**28))-16*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-176*Q2**18-Q2**17*(2535+1676*r**2)
            +Q2**16*(32913+364661*r**2+31652*r**4)-Q2**15*(68917+3787700*r**2+3771553*r**4
            +177696*r**6)+Q2**14*(-186186+14930971*r**2+33942285*r**4+15925827*r**6
            +525835*r**8)-Q2**13*(-732732+26050717*r**2+105692368*r**4+111027624*r**6
            +32799280*r**8+907327*r**10)+Q2**12*(324509+9485791*r**2+95086832*r**4
            +107830116*r**6+132834703*r**8+25415813*r**10+849708*r**12)+Q2**11*(
            -4735695+35935918*r**2+174035451*r**4+860194842*r**6+730239207*r**8
            +78154746*r**10+25696893*r**12-186626*r**14)-Q2**10*(-7878420+51117673*r**2
            +455427703*r**4+2689270611*r**6+4581253617*r**8+2298868719*r**10+369632889*r**12
            +71295877*r**14+445027*r**16)+Q2**9*(-2284128+6347953*r**2+273545720*r**4
            +2278224806*r**6+7588991340*r**8+7470882852*r**10+2238303088*r**12+320261170*r**14
            +42657116*r**16+366355*r**18)+Q2**8*(-7905711+29243549*r**2+120166776*r**4
            +1776146298*r**6-1548013800*r**8-4035751620*r**10-3769240026*r**12+219460086*r**14
            -2011977*r**16+29382855*r**18+121682*r**20)-Q2**7*(-9312237+5292944*r**2
            +126690299*r**4+4437162732*r**6+7584211446*r**8+12328513824*r**10+7299356238*r**12
            +1118301864*r**14+1733839047*r**16+122705136*r**18+50863751*r**20+262988*r**22)
            +Q2**6*(-631274-24250639*r**2-17896433*r**4+1874113581*r**6+6883024941*r**8
            +15156693138*r**10+20234085838*r**12+7332891090*r**14+985613736*r**16
            +858975661*r**18+78073619*r**20+12183601*r**22+6021*r**24)+Q2**5*(-5624664
            +13151621*r**2-112252680*r**4+1821627060*r**6-1866941356*r**8+2250779013*r**10
            -7611706416*r**12-8755730960*r**14-1615778544*r**16-1282968081*r**18
            -175004776*r**20-126163332*r**22+18061908*r**24+163367*r**26)+Q2**4*(3753939
            +7632901*r**2+209951320*r**4-2113533408*r**6+1413307675*r**8-10066028003*r**10
            -6957706272*r**12+699243080*r**14+1370609321*r**16+3452772735*r**18+2930899984*r**20
            +412158616*r**22+139818345*r**24-12844193*r**26-90440*r**28)-Q2**3*(
            -105655+8863882*r**2+44640383*r**4-316660626*r**6+585467545*r**8-2566777246*r**10
            -5087246889*r**12+3816175574*r**14-720240173*r**16+2043625630*r**18+2367671797*r**20
            +1524887882*r**22+224304843*r**24+13040374*r**26+118325*r**28+13554*r**30)
            +2*(-1+r**2)**2*(-36857-161613*r**2-6810851*r**4+35146072*r**6-233476106*r**8
            -16624739*r**10+3287333199*r**12-13455588938*r**14+20748902706*r**16
            -14279266723*r**18+4617951579*r**20-955820164*r**22-34667986*r**24-29099053*r**26
            -4448071*r**28+74742*r**30+803*r**32)+Q2**2*(-1128336+2016029*r**2-92595333*r**4
            +654708291*r**6-2153606607*r**8+3252444525*r**10-1274435037*r**12+2290651051*r**14
            +7064801553*r**16-16654038801*r**18+12936995113*r**20-3971069823*r**22
            -275119893*r**24-186126969*r**26-72474567*r**28+3043473*r**30+31331*r**32)
            +Q2*(500931+431635*r**2+65255680*r**4-451471698*r**6+2224528152*r**8
            -3042024930*r**10-6513831000*r**12+23634794558*r**14+2182533326*r**16
            -57386238084*r**18+60936658352*r**20-24714711430*r**22+5251155984*r**24
            +197165922*r**26+182264232*r**28+46919322*r**30-1182905*r**32-12047*r**34))
            +5225472000*logq2**5*r**20*(-1+r**4+2*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2+138240*logq2**3*r**12*(12240*Q2**13*r**2-2*Q2**12*(805+65346*r**2
            +58056*r**4)+2*Q2**11*(6685+309522*r**2+509229*r**4+233412*r**6)-Q2**10*(45010
            +1658977*r**2+3781563*r**4+3251763*r**6+1023657*r**8)+5*Q2**9*(14840
            +527967*r**2+1486895*r**4+1785987*r**6+1082181*r**8+265818*r**10)-5*Q2**8*(9240
            +457741*r**2+1493862*r**4+2234432*r**6+1988952*r**8+1010871*r**10+229734*r**12)
            +2*Q2**7*(-18690+237437*r**2+747282*r**4+1541385*r**6+2560700*r**8+2909985*r**10
            +1622772*r**12+528777*r**14)-4*Q2**6*(-21315-277423*r**2-1283996*r**4
            -1999003*r**6-1593305*r**8+172455*r**10+1141077*r**12+719649*r**14+326187*r**16)
            +2*Q2**5*(-23940-631588*r**2-2903952*r**4-4675197*r**6-4455058*r**8
            -773655*r**10+2621752*r**12+2520273*r**14+1522998*r**16+488367*r**18)
            +10*Q2**4*(-945+68164*r**2+143010*r**4+497731*r**6+175533*r**8-268233*r**10
            -524859*r**12-520271*r**14+133824*r**16-214263*r**18+25461*r**20)+(
            -1+r**2)**4*(140+9813*r**2-202046*r**4+926700*r**6-769394*r**8+310202*r**10
            -49598*r**12-371164*r**14+840390*r**16+4209*r**18+56748*r**20)-10*Q2**3*(
            -2345+30131*r**2-240131*r**4+627487*r**6-420684*r**8-379492*r**10+6024*r**12
            +12172*r**14-385635*r**16+990889*r**18-153453*r**20+116637*r**22)-Q2*(
            -1+r**2)**2*(-1120+56771*r**2-1198771*r**4+4441728*r**6-3092088*r**8
            +162606*r**10+2100178*r**12+730096*r**14-2025728*r**16+4692663*r**18
            -192711*r**20+374376*r**22)+Q2**2*(-10010+155293*r**2-2812977*r**4+9699175*r**6
            -10402295*r**8+3060690*r**10+2470954*r**12+5101414*r**14+5242620*r**16
            -10614735*r**18+10741815*r**20-1516077*r**22+980133*r**24))*sqrtq2+96*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(9312*Q2**17*r**2-4*Q2**16*(-805+31950*r**2
            +31368*r**4)+4*Q2**15*(-6685+161502*r**2+404131*r**4+169116*r**6)-Q2**14*(
            -86205+1568566*r**2+7173691*r**4+7409140*r**6+1895670*r**8)+2*Q2**13*(
            -55335+877182*r**2+6391588*r**4+7546174*r**6+7529917*r**8+1386990*r**10)
            -Q2**12*(55545+325312*r**2+892928*r**4-68024936*r**6-55484733*r**8+7582332*r**10
            +1205856*r**12)-4*Q2**11*(-88830+138939*r**2+7316008*r**4+90026929*r**6
            +162887050*r**8+76015549*r**10+6217412*r**12+641391*r**14)+Q2**10*(-367675
            -1123030*r**2+36823099*r**4+594075420*r**6+1792409349*r**8+1705822874*r**10
            +526212217*r**12+49659184*r**14+4273698*r**16)-2*Q2**9*(51205-825816*r**2
            +4872884*r**4+96431950*r**6+833807240*r**8+1312272220*r**10+895413124*r**12
            +152528314*r**14+14089355*r**16+642180*r**18)-Q2**8*(-523215-2287872*r**2
            -5690958*r**4+626144376*r**6+913254048*r**8+1261991140*r**10+202088558*r**12
            -313915968*r**14+199085991*r**16+14213508*r**18+2551560*r**20)+4*Q2**7*(
            -88165-1312728*r**2-7969281*r**4+197575162*r**6+740554886*r**8+1732027876*r**10
            +2057652454*r**12+790695704*r**14+170255247*r**16+87188276*r**18+6605931*r**20
            +630894*r**22)+Q2**6*(-117425+1964862*r**2+15376235*r**4-107758348*r**6
            -1798025460*r**8-5044647308*r**10-10384226762*r**12-8058157568*r**14
            -1879903593*r**16-424735010*r**18-152762433*r**20-12860644*r**22+69294*r**24)
            +2*Q2**5*(143535+1355918*r**2+18809060*r**4-209996206*r**6-78374599*r**8
            -662949094*r**10+177607368*r**12+2139634132*r**14+1113700217*r**16+581191826*r**18
            +260611316*r**20+44953946*r**22+2255135*r**24-650394*r**26)+Q2**4*(-123795
            -2844816*r**2-44458316*r**4+296284040*r**6+471841525*r**8+2272449820*r**10
            +6261334512*r**12+1755882032*r**14-1136786505*r**16-924153720*r**18-2563155940*r**20
            -818410136*r**22-118116281*r**24-2390900*r**26+629280*r**28)+4*Q2**3*(
            -7980+107941*r**2+1499054*r**4+2511507*r**6-55651184*r**8-21011415*r**10
            -810178302*r**12+57571407*r**14+221197076*r**16+46474703*r**18+579675250*r**20
            +243457961*r**22+84712264*r**24+3269667*r**26-455394*r**28+30645*r**30)
            +Q2**2*(49455+643662*r**2+15312277*r**4-103829084*r**6+285839973*r**8
            +52386658*r**10-2229257831*r**12+3134616736*r**14-1959850417*r**16-6026543886*r**18
            +9059347279*r**20-5204165324*r**22+1817549687*r**24+163304926*r**26+83714563*r**28
            +3897608*r**30-216282*r**32)-(-1+r**2)**2*(-2345-65626*r**2-1854889*r**4
            +5984320*r**6-47439045*r**8-275719454*r**10+1938692851*r**12-6012321852*r**14
            +4658322525*r**16+2971961450*r**18-4803909227*r**20+1599597976*r**22
            -516519559*r**24-47590770*r**26-13103455*r**28-362524*r**30+9624*r**32)
            +2*Q2*(-8995-183028*r**2-4702628*r**4+26616782*r**6-116212870*r**8
            -241815308*r**10+2486307572*r**12-6566587018*r**14+5601093876*r**16-4012394060*r**18
            +7740793636*r**20-8223996790*r**22+3180020950*r**24-857273108*r**26-69788020*r**28
            -29502158*r**30-1047329*r**32+38496*r**34))*sqrtq2)*math.log(r))/(-1088640000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -15120000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3-10500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5+2612736000*logq2**5*r**22*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2+181440000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+630000*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +((-8294400*logq2**4*r**14*(240*Q2**10*(2+5*r**4)-60*Q2**9*(94+101*r**2
            +207*r**4+130*r**6)+6*Q2**8*(4860+9135*r**2+12334*r**4+10171*r**6+2700*r**8)
            +Q2**7*(-83115-206985*r**2-257752*r**4-220950*r**6-90333*r**8+2475*r**10)
            +Q2**6*(136395+397005*r**2+493517*r**4+440608*r**6+218607*r**8-7497*r**10
            -58275*r**12)+3*Q2**5*(-38745-126315*r**2-149848*r**4-154328*r**6-81845*r**8
            -5447*r**10+29078*r**12+22050*r**14)+(-1+r**2)**4*(-5295-1515*r**2
            +12089*r**4-30135*r**6+33915*r**8+73675*r**10-38745*r**12+15711*r**14
            +15900*r**16)+Q2**4*(12915+126105*r**2+139415*r**4+167910*r**6+101619*r**8
            -10879*r**10-61995*r**12+75600*r**14+53550*r**16)-Q2*(-1+r**2)**2*(
            -32055-8775*r**2+61087*r**4-181678*r**6+89880*r**8+411845*r**10+258475*r**12
            -156672*r**14+75093*r**16+87600*r**18)-Q2**3*(-75015-29085*r**2+56014*r**4
            -169219*r**6+1941*r**8+304330*r**10+155324*r**12-159411*r**14+206136*r**16
            +192825*r**18)+3*Q2**2*(-25245+6885*r**2+42599*r**4-131085*r**6+33124*r**8
            +167335*r**10+177730*r**12+174821*r**14-120075*r**16+13436*r**18+63675*r**20))
            -2304*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(48*Q2**16*(838+5955*r**4)
            -4*Q2**15*(115086+92281*r**2+723555*r**4+864210*r**6)+2*Q2**14*(1132020
            +1819411*r**2+7153190*r**4+15360775*r**6+9029100*r**8)-Q2**13*(6062805
            +14976983*r**2+43559448*r**4+120434570*r**6+134641855*r**8+52681875*r**10)
            +Q2**12*(8763615+31761437*r**2+69492641*r**4+252228032*r**6+387303175*r**8
            +308413235*r**10+91098825*r**12)-Q2**11*(3704022+30348218*r**2-33218587*r**4
            +125513553*r**6+328176528*r**8+448962072*r**10+365622605*r**12+85831845*r**14)
            +Q2**10*(-9696918-11224756*r**2-431228895*r**4-915897800*r**6-1320104945*r**8
            -1171642776*r**10-347392653*r**12+124808260*r**14+16632195*r**16)+Q2**9*(18851745
            +64970231*r**2+933837305*r**4+2852840125*r**6+5100395095*r**8+6044378435*r**10
            +4203949251*r**12+1544529415*r**14+224658700*r**16+59186850*r**18)-Q2**8*(11581515
            +70765809*r**2+838223784*r**4+3722446430*r**6+7260934980*r**8+10218802340*r**10
            +9198204694*r**12+5047360794*r**14+1782447585*r**16+336651315*r**18+73991250*r**20)
            +2*Q2**7*(-2548590+10700688*r**2-81188991*r**4+914255153*r**6+1352749420*r**8
            +2471321070*r**10+3402726318*r**12+2896150584*r**14+1375226418*r**16
            +669262050*r**18+127026465*r**20+20345175*r**22)-2*Q2**6*(-6607986-12613643*r**2
            -573488343*r**4-406225493*r**6-2402483023*r**8-3611757844*r**10-2348027518*r**12
            +30572132*r**14+1444601632*r**16+735581727*r**18+732147589*r**20+107602545*r**22
            +6367665*r**24)+Q2**5*(-7975107-30764441*r**2-1047937990*r**4-1369733260*r**6
            -6109730745*r**8-10866330877*r**10-10013433212*r**12-5705151680*r**14
            +156001995*r**16+3541298405*r**18+1584877714*r**20+1393134428*r**22+175143265*r**24
            +2009505*r**26)+(-1+r**2)**4*(-54381-210203*r**2-16395496*r**4+37320860*r**6
            -211843025*r**8+198926577*r**10+736984476*r**12-215859408*r**14-899793615*r**16
            +437532135*r**18+419929304*r**20-32371148*r**22+83990029*r**24+5778755*r**26
            +385140*r**28)+Q2**4*(-122535+13857947*r**2+182210865*r**4+759602400*r**6
            +1152709455*r**8+4433877135*r**10+3314220251*r**12+2455541080*r**14+355871775*r**16
            +930412745*r**18-546174625*r**20-844170648*r**22-73416295*r**24-32457875*r**26
            +6134325*r**28)-Q2*(-1+r**2)**2*(-492951-1061959*r**2-118227404*r**4
            +274064934*r**6-1369318985*r**8+945468947*r**10+3247233198*r**12-850025412*r**14
            +474010287*r**16-2528283225*r**18+1619857264*r**20+2474718686*r**22-348999759*r**24
            +496834829*r**26+35998510*r**28+2783040*r**30)-Q2**3*(-2922570+2247458*r**2
            -377729407*r**4+807717625*r**6-3163267960*r**8+1251681580*r**10+504013719*r**12
            -2325064401*r**14-579670770*r**16-2555941470*r**18+3172963615*r**20+4532850823*r**22
            -804813292*r**24+1182172720*r**26+86585705*r**28+11000625*r**30)+Q2**2*(
            -1796310-243688*r**2-332550859*r**4+936445312*r**6-3755572965*r**8+3679851120*r**10
            +2800326121*r**12-3482035632*r**14+2816936931*r**16+6250094040*r**18
            -4955843345*r**20-594358208*r**22+5816223041*r**24-1664897568*r**26+1106087475*r**28
            +82454960*r**30+7999575*r**32))+16*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(
            -1088*Q2**20*r**2-4*Q2**19*r**2*(3254+2527*r**2)+4*Q2**18*(6984+21070*r**2
            +437053*r**4+61039*r**6)-4*Q2**17*(73854-171626*r**2+3014129*r**4+5281142*r**6
            +424263*r**8)+Q2**16*(1326024-7616863*r**2+10708800*r**4+133192066*r**6
            +110588280*r**8+6453933*r**10)-Q2**15*(3118554-31531241*r**2-150313053*r**4
            +168955990*r**6+559106952*r**8+310985011*r**10+15463707*r**12)+Q2**14*(3388050
            -76009897*r**2-739442852*r**4-828150155*r**6-117685638*r**8+976472905*r**10
            +461342488*r**12+24222699*r**14)+Q2**13*(1176462+117929405*r**2+1833019065*r**4
            +4035889717*r**6+6813848013*r**8+5387219375*r**10+114960835*r**12-172718721*r**14
            -23983863*r**16)+Q2**12*(-8597862-111367537*r**2-2873005284*r**4-9065034328*r**6
            -21798363408*r**8-33373604106*r**10-21103165356*r**12-3496517712*r**14
            -615526906*r**16+12576291*r**18)+Q2**11*(9946638+24048549*r**2+2376833185*r**4
            +12146252716*r**6+31815516512*r**8+71668770270*r**10+76615036110*r**12
            +36282863212*r**14+6183276442*r**16+1160980645*r**18-637559*r**20)-Q2**10*(815958
            -115695195*r**2-1128092708*r**4+6620899277*r**6+2012840548*r**8+49048420610*r**10
            +88665167472*r**12+76598873210*r**14+24815634998*r**16+4453422329*r**18
            +720515972*r**20+881881*r**22)-Q2**9*(9459450+204896583*r**2+5985540467*r**4
            +7571950725*r**6+84026083939*r**8+109965770630*r**10+82424373502*r**12
            +25337876474*r**14-6487207040*r**16+11502502019*r**18-201432865*r**20
            +254002353*r**22+4454099*r**24)+Q2**8*(9284418+148767325*r**2+6790054364*r**4
            +16708903958*r**6+146759336214*r**8+294394151871*r**10+359794833240*r**12
            +295372365172*r**14+138383580222*r**16+46805498859*r**18+33170043532*r**20
            +1901361590*r**22+651899306*r**24+5602233*r**26)-Q2**7*(904878-9202987*r**2
            +1263538329*r**4+12129584710*r**6+68122705248*r**8+257617249959*r**10
            +309010861599*r**12+384739997348*r**14+246136316902*r**16+97896992451*r**18
            +37377275975*r**20+23120353110*r**22+1889799628*r**24+267617409*r**26
            +795201*r**28)+Q2**6*(-4702698-113996459*r**2-4785719340*r**4+5289423595*r**6
            -105134994174*r**8+96159586285*r**10-134605463928*r**12+14050429531*r**14
            +150135100474*r**16+68074935271*r**18+64288585396*r**20+33751587849*r**22
            +7012162606*r**24+2151622743*r**26-161640080*r**28-2970831*r**30)+Q2**5*(3603978
            +91016839*r**2+5075059355*r**4-4257705781*r**6+175555714407*r**8-116949353701*r**10
            +405247882799*r**12+228394781439*r**14+159936830335*r**16-142688920811*r**18
            +12865882481*r**20-101359146943*r**22-45176325499*r**24-1821897399*r**26
            -2004503611*r**28+193228277*r**30+2333835*r**32)+2*(-1+r**2)**4*(7767
            +336787*r**2+25802988*r**4-145684328*r**6+2324017000*r**8-13079872076*r**10
            +42016399156*r**12-71280856848*r**14+24865187926*r**16+58748744970*r**18
            -65447245804*r**20+24238088472*r**22-5593858048*r**24-419913148*r**26
            -150164020*r**28-20401312*r**30+301035*r**32+5483*r**34)-Q2**4*(464850
            +16192379*r**2+1317687948*r**4-1304476580*r**6+76708683348*r**8-138390616000*r**10
            +294096844876*r**12+18699514236*r**14+18436502920*r**16+232070889134*r**18
            -227361498620*r**20+80541018676*r**22-42375593876*r**24-23240391240*r**26
            +86028068*r**28-490707980*r**30+41707494*r**32+230367*r**34)-Q2*(-1
            +r**2)**2*(146214+5417905*r**2+391529241*r**4-2086623996*r**6+29902437860*r**8
            -141284837416*r**10+376241404400*r**12-445599218156*r**14-119078627440*r**16
            +392652404210*r**18+160834888250*r**20-464754914100*r**22+213029257884*r**24
            -56006326832*r**26-5088138920*r**28-1576114148*r**30-294597430*r**32
            +6144181*r**34+104293*r**36)-Q2**3*(802566+21028385*r**2+1180633641*r**4
            -4770241744*r**6+46743767352*r**8-104754704844*r**10+154813560420*r**12
            -49355881920*r**14+62641812964*r**16+220115144526*r**18-337889367890*r**20
            +17284569840*r**22+78166419832*r**24-73529655996*r**26-7278006828*r**28
            -2601332832*r**30-820918170*r**32+31766297*r**34+604401*r**36)+Q2**2*(539406
            +16673921*r**2+1123640504*r**4-6095670319*r**6+72517673608*r**8-300943086180*r**10
            +713437302960*r**12-799267034132*r**14+260644081396*r**16-336941934074*r**18
            +574188341952*r**20+87707883382*r**22-647947135928*r**24+366104173340*r**26
            -96457539696*r**28-10124528628*r**30-2576048338*r**32-822259519*r**34
            +23208008*r**36+390337*r**38))-10450944000*logq2**5*r**18*(-3-2*r**2+14*r**6
            +3*r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-138240*logq2**3*r**10*(240*Q2**13*(64
            +255*r**4)-4*Q2**12*(43920+41885*r**2+155079*r**4+145140*r**6)+2*Q2**11*(428160
            +783895*r**2+1807566*r**4+2413191*r**6+1167060*r**8)-Q2**10*(2271465
            +6056755*r**2+13248946*r**4+19439868*r**6+15303561*r**8+5118285*r**10)
            +5*Q2**9*(668190+2436539*r**2+5606946*r**4+8989754*r**6+8713014*r**8
            +4994739*r**10+1329090*r**12)-5*Q2**8*(390429+2513814*r**2+5592871*r**4
            +10181682*r**6+11862563*r**8+9114906*r**10+4408953*r**12+1148670*r**14)
            +2*Q2**7*(-943020+1798410*r**2-2905804*r**4-3376800*r**6+3525405*r**8
            +10477370*r**10+12366390*r**12+6044916*r**14+2643885*r**16)+Q2**6*(4580910
            +5816370*r**2+47913076*r**4+93829676*r**6+93769570*r**8+55259630*r**10
            +1345440*r**12-24375024*r**14-9379524*r**16-6523740*r**18)+2*Q2**5*(
            -1679310-3454065*r**2-24735604*r**4-52216407*r**6-57160479*r**8-46499485*r**10
            -14215635*r**12+7140931*r**14+16229193*r**16+4592226*r**18+2441835*r**20)
            +10*Q2**4*(18255+370188*r**2+977857*r**4+3641739*r**6+3832564*r**8+3781350*r**10
            +929160*r**12-1217124*r**14+1445605*r**16+151038*r**18-382737*r**20
            +127305*r**22)+(-1+r**2)**4*(-48165+13550*r**2-1655781*r**4+1417708*r**6
            +4541262*r**8-4479524*r**10+7586390*r**12-4775864*r**14+1422647*r**16
            +4444518*r**18+321519*r**20+283740*r**22)-10*Q2**3*(-146916+243673*r**2
            -2417218*r**4+287293*r**6+1287721*r**8-2508126*r**10-143152*r**12+1672986*r**14
            -3061934*r**16+3795669*r**18+4878538*r**20-117159*r**22+583185*r**24)
            -Q2*(-1+r**2)**2*(-369270+336545*r**2-10337182*r**4+6100739*r**6+21858300*r**8
            -21620574*r**10+26197332*r**12+35776222*r**14-20172494*r**16+7590445*r**18
            +24581514*r**20+762543*r**22+1871880*r**24)+Q2**2*(-1122405+2141545*r**2
            -25839026*r**4+23762820*r**6+27255595*r**8-55974305*r**10+34948620*r**12
            +64970392*r**14+83670265*r**16-50727345*r**18-12109290*r**20+52512660*r**22
            -3238191*r**24+4900665*r**26))*sqrtq2+192*logq2*r**4*(-23280*Q2**21*r**2
            +4*Q2**20*(-1901+67017*r**2+101700*r**4)-2*Q2**19*(-41999+448466*r**2
            +2233249*r**4+1542780*r**6)+Q2**18*(-459281-1559330*r**2+15642922*r**4
            +29852110*r**6+13479015*r**8)+Q2**17*(1790765+25708162*r**2+1763942*r**4
            -63318368*r**6-104663043*r**8-37316610*r**10)+2*Q2**16*(-2867207-61671801*r**2
            -105688319*r**4-144588394*r**6-50424471*r**8+96399759*r**10+33133905*r**12)
            +Q2**15*(14785748+375739980*r**2+951504816*r**4+2177714094*r**6+3122669772*r**8
            +1618383720*r**10-88767984*r**12-67902210*r**14)+2*Q2**14*(-13987292
            -390441682*r**2-1236100760*r**4-3341185983*r**6-6730888595*r**8-6869872632*r**10
            -3000297082*r**12-216959823*r**14+7113465*r**16)+2*Q2**13*(16969864+506705280*r**2
            +2031835975*r**4+5593514577*r**6+14434495681*r**8+20359789241*r**10+15994937513*r**12
            +5894938467*r**14+583333335*r**16+32718915*r**18)-2*Q2**12*(8093930+228108348*r**2
            +1753935795*r**4+2486972684*r**6+11922502594*r**8+24399961008*r**10+28605474124*r**12
            +20167841132*r**14+6427363428*r**16+707976828*r**18+46605585*r**20)+2*Q2**11*(
            -11419824-505875682*r**2-359138540*r**4-11762023525*r**6-22053851624*r**8
            -22891251572*r**10-10373232704*r**12+6301646226*r**14+9911683256*r**16
            +2546333638*r**18+408310188*r**20+18295875*r**22)+2*Q2**10*(25377495
            +1129233976*r**2+2929278924*r**4+30578647613*r**6+81386925062*r**8+128940233264*r**10
            +138131797516*r**12+91744005734*r**14+35877627579*r**16+7679273944*r**18
            +2924456392*r**20+42971357*r**22+19904040*r**24)-2*Q2**9*(19227663+917275138*r**2
            +3409864633*r**4+31792876459*r**6+107221525520*r**8+184717808607*r**10
            +238473483262*r**12+213961798674*r**14+126209036139*r**16+52933835940*r**18
            +15924577913*r**20+5286211363*r**22+267784582*r**24+28106715*r**26)+2*Q2**8*(
            -309244-23374190*r**2+1585832717*r**4+3774731746*r**6+59527138458*r**8
            +79160255820*r**10+117817470339*r**12+153782240156*r**14+145785056816*r**16
            +82294322258*r**18+42678519187*r**20+13314568514*r**22+4053031858*r**24
            +234271440*r**26+7997085*r**28)+2*Q2**7*(13274150+759597978*r**2+161396852*r**4
            +30272158165*r**6+2766961710*r**8+81700868796*r**10+118924170204*r**12
            +80617398739*r**14-7626953486*r**16-75287733526*r**18-42707036724*r**20
            -40517465125*r**22-10135336454*r**24-2172501792*r**26-136057692*r**28
            +9941085*r**30)+2*(-1+r**2)**6*(17587+1690505*r**2-1956685*r**4+205369507*r**6
            -876454659*r**8+2486920321*r**10-1700432405*r**12-9649384245*r**14+14466855531*r**16
            -2950948477*r**18-4573545263*r**20+1879026145*r**22-832379545*r**24-71840013*r**26
            -15449839*r**28-460495*r**30+12030*r**32)-2*Q2**6*(11208856+699610998*r**2
            +507200388*r**4+36664028793*r**6+10378266609*r**8+114852463440*r**10
            +171898395918*r**12+147713419207*r**14+101353358607*r**16+19253914238*r**18
            -69733046584*r**20-21113445321*r**22-38125271505*r**24-7760402340*r**26
            -1009435962*r**28-61940247*r**30+10426905*r**32)-Q2*(-1+r**2)**4*(391351
            +34643162*r**2-52644702*r**4+3693361850*r**6-13506634574*r**8+34878803658*r**10
            -14371761366*r**12-107430449846*r**14+51028639920*r**16+100282304558*r**18
            -47641227194*r**20-56438082114*r**22+24681311278*r**24-12949489570*r**26
            -1128662034*r**28-262871490*r**30-8961607*r**32+288720*r**34)+2*Q2**5*(2739596
            +197222392*r**2+356755553*r**4+14589850563*r**6-1755938077*r**8+36411578703*r**10
            +68181636305*r**12+16507990519*r**14+19392144531*r**16+20990441923*r**18
            +58414254027*r**20-30589374503*r**22+4090000113*r**24-8780221699*r**26
            -2675848701*r**28-12200531*r**30+2501901*r**32+2675385*r**34)+Q2**2*(
            -1+r**2)**2*(1838795+148782168*r**2-319681765*r**4+13838127558*r**6-47109494458*r**8
            +117465073430*r**10-64301379602*r**12-185374231242*r**14+16369175364*r**16
            +60633904006*r**18+155921352540*r**20-92489899070*r**22-165541722246*r**24
            +78918328018*r**26-40556181998*r**28-3411110590*r**30-921061071*r**32
            -37434822*r**34+1454985*r**36)+2*Q2**4*(2127956+138033786*r**2-461964733*r**4
            +7840297272*r**6-19790272210*r**8+52974872524*r**10-33107466886*r**12
            +22515073360*r**14+10975752926*r**16+33939524200*r**18+42486769024*r**20
            -97182377736*r**22-47804694006*r**24+18809275172*r**26-25292019290*r**28
            -1819800704*r**30-759732714*r**32-43547346*r**34+1845405*r**36)+2*Q2**3*(
            -2213167-161652300*r**2+511472097*r**4-13028240203*r**6+45629624116*r**8
            -114699478476*r**10+108629300948*r**12+24428453500*r**14-29581682274*r**16
            +35062830868*r**18+66581988318*r**20-123225830586*r**22+5632289764*r**24
            +139053641132*r**26-74902667964*r**28+31484497900*r**30+2238971513*r**32
            +817861464*r**34+42133545*r**36-1860195*r**38))*sqrtq2)*math.log(r))/(-3265920000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -45360000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3-31500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5+7838208000*logq2**5*r**22*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2+544320000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+1890000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(flagPERP*(86400*logq2**3*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(-360*Q2**6*r**2
            +10*Q2**5*(56+237*r**2+405*r**4)-2*Q2**4*(2576+3407*r**2+10086*r**4
            +8559*r**6)+Q2**3*(5138+32029*r**2+55679*r**4+73515*r**6+34647*r**8)
            -2*Q2**2*(-1379+14446*r**2+30670*r**4+50580*r**6+43557*r**8+5934*r**10)
            +Q2*(-3122+10343*r**2-34011*r**4-39374*r**6+10956*r**8+8871*r**10
            -29823*r**12)+2*(-91+282*r**2+28681*r**4-101848*r**6-99713*r**8-57342*r**10
            -8685*r**12+10236*r**14))+24*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(
            -122808*Q2**12*r**2+14*Q2**11*(-1880+66429*r**2+60789*r**4)-2*Q2**10*(
            -52640+1036399*r**2+2717462*r**4+931119*r**6)+5*Q2**9*(-20090+184997*r**2
            +2184863*r**4+2210563*r**6+142947*r**8)+10*Q2**8*(-12285+188958*r**2
            -439302*r**4-936244*r**6-639789*r**8+270774*r**10)-4*Q2**7*(-68250+214896*r**2
            +3408825*r**4+19474085*r**6+16503395*r**8+3229605*r**10+821016*r**12)
            -4*Q2**6*(16590+656523*r**2-3938937*r**4-48083585*r**6-95232460*r**8
            -41391365*r**10-6366717*r**12+66423*r**14)+2*Q2**5*(-84630+820743*r**2
            +2675019*r**4-37336017*r**6-260265345*r**8-268793145*r**10-25507697*r**12
            -3283581*r**14+1117053*r**16)-20*Q2**4*(-5985-81312*r**2+472977*r**4
            +6023430*r**6-3751077*r**8-29989724*r**10-11659661*r**12+8984182*r**14
            +961842*r**16+41328*r**18)-10*Q2**3*(-1260+152523*r**2+685473*r**4-7421658*r**6
            -28403958*r**8-36666196*r**10-3852300*r**12-20030230*r**14-15885134*r**16
            -1401159*r**18+38619*r**20)+2*Q2**2*(-17500-65379*r**2+2675700*r**4
            +8946965*r**6-99187440*r**8-457949610*r**10-634743232*r**12-253335450*r**14
            -196325940*r**16+6690765*r**18+1501260*r**20+139461*r**22)-Q2*(-10430
            -428561*r**2-3675031*r**4+23936125*r**6+81525565*r**8+182986690*r**10
            +176301262*r**12-107945498*r**14+562295200*r**16-160505265*r**18+63205065*r**20
            +4801949*r**22+40929*r**24)+2*(-385-51794*r**2-1065032*r**4+974056*r**6
            -25793945*r**8-153620310*r**10+410527248*r**12-810987536*r**14-482355147*r**16
            +225241570*r**18+2827320*r**20+11328296*r**22+446693*r**24+966*r**26))
            -18144000*logq2**4*r**14*(-108+205*r**2+243*r**4+147*r**6+57*r**8)*sqrtq2
            +1440*logq2**2*r**6*(-22920*Q2**11*r**2+Q2**10*(2464+241602*r**2+248994*r**4)
            -20*Q2**9*(-392+54733*r**2+107146*r**4+53949*r**6)+10*Q2**8*(-7161+231247*r**2
            +728637*r**4+724587*r**6+220662*r**8)-5*Q2**7*(-25032+413045*r**2+2160632*r**4
            +3487006*r**6+2235312*r**8+338157*r**10)-5*Q2**6*(1008+42133*r**2-1047133*r**4
            -3132004*r**6-3299180*r**8-1349649*r**10+258489*r**12)+Q2**5*(-196728
            +1810291*r**2+3976932*r**4+5029485*r**6+4065040*r**8+2633037*r**10+2270436*r**12
            +3484467*r**14)-5*Q2**4*(-37212+200873*r**2+1228511*r**4+5057133*r**6
            +10219499*r**8+9808031*r**10+4391209*r**12+1337931*r**14+419049*r**16)
            -5*Q2**3*(168+69319*r**2-506056*r**4-4246772*r**6-8156648*r**8-13279886*r**10
            -9961912*r**12-2498660*r**14-1102656*r**16+94239*r**18)+(-1+r**2)**2*(
            -8386-11465*r**2-62195*r**4-2717840*r**6+6917980*r**8-22099358*r**10
            -21383090*r**12-6768560*r**14+4537510*r**16+392615*r**18+76389*r**20)
            +5*Q2**2*(-17472+107975*r**2-9963*r**4-1607190*r**6+4321574*r**8+738744*r**10
            -1773696*r**12-1608826*r**14+2807850*r**16-446703*r**18+229467*r**20)
            -5*Q2*(-9688+33023*r**2+18428*r**4-1242421*r**6+3091472*r**8-8440858*r**10
            -17277112*r**12-8770810*r**14-3667576*r**16+3258651*r**18+3324*r**20
            +102447*r**22))*sqrtq2+(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(-252*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(-3+5*Q2**3+5*r**2-19*r**4+5*r**6-5*Q2**2*(1
            +r**2)+Q2*(-5+8*r**2-5*r**4))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7
            +2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**3+150*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(-115+200*Q2**6
            -4126*r**2+5499*r**4+16524*r**6-2201*r**8-486*r**10+25*r**12-150*Q2**5*(1
            +r**2)-6*Q2**4*(25-54*r**2+25*r**4)+Q2**3*(-115+309*r**2-111*r**4
            +25*r**6)+Q2**2*(-115-6*r**2+886*r**4-286*r**6+25*r**8)+Q2*(-115
            -1111*r**2+3466*r**4+666*r**6-411*r**8+25*r**10))+5*(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(
            -381+118368*Q2**12+187378*r**2-3610610*r**4-30687966*r**6-117894619*r**8
            -252076420*r**10-1046392476*r**12-962795428*r**14+114616301*r**16+45159954*r**18
            +1455886*r**20-242942*r**22+6123*r**24-310896*Q2**11*(1+r**2)-16*Q2**10*(2427
            -51158*r**2+2427*r**4)+Q2**9*(422697-731485*r**2-1266589*r**4+601065*r**6)
            -3*Q2**8*(-60785+412516*r**2+2286730*r**4+240036*r**6+25455*r**8)-6*Q2**7*(55198
            -576833*r**2-2491341*r**4-2328181*r**6-702933*r**8+98226*r**10)+6*Q2**6*(
            -47922+236827*r**2+2432442*r**4-1080910*r**6+2727022*r**8+7931*r**10
            +6482*r**12)+6*Q2**5*(12633-478566*r**2-1452790*r**4+290387*r**6+5644527*r**8
            -2761034*r**10-830186*r**12+59589*r**14)+2*Q2**4*(90369-963255*r**2
            -9543264*r**4+22046055*r**6+79006682*r**8+21799407*r**10-10363320*r**12
            -231183*r**14+13005*r**16)-2*Q2**3*(-29790+241731*r**2+7912671*r**4
            +30128553*r**6+17319703*r**8+21228703*r**10+50775033*r**12-3064785*r**14
            -1443489*r**16+63030*r**18)-6*Q2**2*(6970-134257*r**2-204102*r**4+20005912*r**6
            +76500400*r**8+74888866*r**10+83784840*r**12+17577720*r**14-1039834*r**16
            -111137*r**18+4302*r**20)+Q2*(-28887+867889*r**2+983121*r**4-73655271*r**6
            -307238698*r**8+30896982*r**10-515497818*r**12-292032346*r**14+29433921*r**16
            +767673*r**18-653495*r**20+19329*r**22)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(2177280000*logq2**4*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+30240000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +21000*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-5225472000*logq2**5*r**20*sqrtq2
            -362880000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-1260000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+((-43200*logq2**3*r**8*(-240*Q2**8*(2+5*r**4)
            +20*Q2**7*(360+458*r**2+921*r**4+795*r**6)-4*Q2**6*(10878+24988*r**2
            +37177*r**4+44382*r**6+21315*r**8)+Q2**5*(104622+336729*r**2+610940*r**4
            +754746*r**6+592878*r**8+226485*r**10)-Q2**4*(100170+406601*r**2+950681*r**4
            +1445654*r**6+1340944*r**8+821745*r**10+277725*r**12)+2*Q2**3*(-210
            +76507*r**2+268474*r**4+442105*r**6+545546*r**8+427613*r**10+142110*r**12
            +30975*r**14)+(-1+r**2)**2*(10398+20051*r**2+344043*r**4+653275*r**6
            +46655*r**8+236257*r**10-20391*r**12+42417*r**14+51615*r**16)+2*Q2**2*(35490
            +5457*r**2+90893*r**4+164401*r**6-148211*r**8-43133*r**10-92097*r**12
            +120795*r**14+97125*r**16)-Q2*(48618+2519*r**2+743284*r**4+2018828*r**6
            +1239000*r**8+675682*r**10+732396*r**12-186084*r**14+77022*r**16+186015*r**18))
            +12*logq2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(48*Q2**14*(838+5955*r**4)
            -4*Q2**13*(65364+42334*r**2+454635*r**4+623565*r**6)+4*Q2**12*(163146
            +208224*r**2+894561*r**4+3342410*r**6+2065935*r**8)-Q2**11*(656226+1833679*r**2
            +84304*r**4+22306266*r**6+38121590*r**8+11742735*r**10)+Q2**10*(-149166
            +2219769*r**2-19515511*r**4-5678706*r**6+22929104*r**8+48201385*r**10
            +1293765*r**12)+Q2**9*(932202-342925*r**2+76673940*r**4+152248645*r**6
            +257519050*r**8+211707117*r**10+2145800*r**12+17529195*r**14)-Q2**8*(643938
            +3798333*r**2+146675925*r**4+437213085*r**6+882677905*r**8+1358502463*r**10
            +809696023*r**12+100729095*r**14+19767105*r**16)+2*Q2**7*(-95034+2588349*r**2
            +53176656*r**4+284990610*r**6+610277460*r**8+1237277626*r**10+1342363624*r**12
            +507031666*r**14+68458110*r**16+600885*r**18)+2*Q2**6*(217626-214491*r**2
            +35738589*r**4-171511494*r**6-182677310*r**8-838490994*r**10-1530284226*r**12
            -1109220606*r**14+19096696*r**16-15779535*r**18+6071985*r**20)-2*Q2**5*(65934
            +2080929*r**2+91484994*r**4-11418171*r**6+938823504*r**8+1735891344*r**10
            +1264896044*r**12+128316124*r**14-103897846*r**16+641803679*r**18+49148010*r**20
            +3864015*r**22)+2*Q2**4*(-35838+1452875*r**2+51882885*r**4+85761615*r**6
            +1613697575*r**8+4539789096*r**10+6092626300*r**12+5792334320*r**14+2702174210*r**16
            +677749525*r**18+545560167*r**20+46791225*r**22-215955*r**24)+Q2**3*(51894
            +280869*r**2+20582640*r**4-238788530*r**6-955856370*r**8-5773454613*r**10
            -9598500528*r**12-11078392700*r**14-7478849710*r**16-3189519205*r**18
            -1747630656*r**20-49296466*r**22-6995990*r**24+2161365*r**26)-(-1+r**2)**2*(
            -534+48893*r**2+3628921*r**4+4981510*r**6+416786020*r**8-537515837*r**10
            +2356443219*r**12+6031181748*r**14-4075225670*r**16-816998205*r**18+1469546671*r**20
            +74778438*r**22+53899256*r**24+1993085*r**26+4485*r**28)-Q2**2*(5766
            +1036019*r**2+51050531*r**4-168655590*r**6+1958971260*r**8-1187137387*r**10
            -1213972463*r**12-3140772932*r**14-7657593370*r**16+2403993805*r**18
            +4634750021*r**20-1107742806*r**22+412538776*r**24+29160235*r**26+816135*r**28)
            +Q2*(-2526+405111*r**2+22928476*r**4-51338271*r**6+1773922710*r**8
            -1998482013*r**10+3593369168*r**12+15385804533*r**14+9033069422*r**16
            -10589866795*r**18-2504580276*r**20+5323069171*r**22-314544934*r**24
            +245900049*r**26+14449160*r**28+105015*r**30))-18144000*logq2**4*r**12*(138
            +387*r**2+11*r**4+45*r**6+243*r**8)*sqrtq2+720*logq2**2*r**4*(240*Q2**11*(64
            +255*r**4)-4*Q2**10*(39012+41168*r**2+144009*r**4+162585*r**6)+40*Q2**9*(13902
            +28126*r**2+68281*r**4+114094*r**6+68145*r**8)-5*Q2**8*(174834+551055*r**2
            +1289626*r**4+2645436*r**6+2787060*r**8+1078965*r**10)+10*Q2**7*(39204
            +315906*r**2+679997*r**4+1754018*r**6+2666128*r**8+1948404*r**10+396135*r**12)
            +10*Q2**6*(64512-152460*r**2+413806*r**4+113261*r**6-949288*r**8-1613582*r**10
            -957054*r**12+322245*r**14)-2*Q2**5*(494172+330078*r**2+12922009*r**4
            +32645910*r**6+45077655*r**8+36674062*r**10+17152923*r**12+3633294*r**14
            +4126185*r**16)+10*Q2**4*(37062+190281*r**2+3112430*r**4+10882625*r**6
            +20459910*r**8+23905019*r**10+16846118*r**12+7520071*r**14+1493184*r**16
            +484020*r**18)+10*Q2**3*(21132-153210*r**2-390653*r**4-5537254*r**6
            -13279970*r**8-18008558*r**10-18413960*r**12-8400010*r**14-3016082*r**16
            -1144680*r**18+115245*r**20)-(-1+r**2)**2*(11058+89563*r**2+3450374*r**4
            +1692575*r**6+38015816*r**8+76898906*r**10+13179992*r**12-28558654*r**14
            +4508870*r**16+14059979*r**18+1063906*r**20+176415*r**22)-10*Q2**2*(24864
            -36624*r**2+1909688*r**4-490773*r**6+77604*r**8-1242028*r**10-6830988*r**12
            -6346062*r**14+4137692*r**16+4738548*r**18-362316*r**20+267435*r**22)
            +10*Q2*(8772+15110*r**2+1429913*r**4-432166*r**6+8402753*r**8+21283532*r**10
            +17981306*r**12+3226292*r**14-7328794*r**16+151982*r**18+4887981*r**20
            +90354*r**22+118485*r**24))*sqrtq2+(252*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**3*(5*Q2**5-Q2**4*(7+15*r**2)
            +2*Q2**3*(4+2*r**2+5*r**4)+(-1+r**2)**2*(17+r**2-11*r**4+5*r**6)
            +2*Q2**2*(7-6*r**2-4*r**4+5*r**6)-Q2*(37+20*r**2+8*r**4-32*r**6
            +15*r**8))-5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(124368*Q2**14-12*Q2**13*(31607
            +48011*r**2)+4*Q2**12*(90147+312950*r**2+184707*r**4)+Q2**11*(371985
            -1453151*r**2-2008817*r**4+392583*r**6)-Q2**10*(1330575+1047134*r**2
            +5511696*r**4-1664614*r**6+1415577*r**8)+Q2**9*(-137583+4550843*r**2
            +22675900*r**4+30847768*r**6+3085235*r**8+216189*r**10)+3*Q2**8*(1184187
            -2216408*r**2-8366339*r**4-9087572*r**6-6611567*r**8-2629444*r**10+398663*r**12)
            -6*Q2**7*(408713-622003*r**2-460117*r**4-7540753*r**6-1337767*r**8+8012741*r**10
            -76045*r**12+62351*r**14)+Q2**6*(-2194182+12374268*r**2+30175344*r**4
            +33186516*r**6+91383376*r**8-34206132*r**10+36823248*r**12+8414724*r**14
            -642666*r**16)+2*Q2**5*(1194639-5548923*r**2+64485252*r**4+49440888*r**6
            -102815012*r**8-197673968*r**10-42786108*r**12+21745512*r**14-879699*r**16
            +97227*r**18)+2*Q2**4*(161295-6325704*r**2-116360655*r**4-60436236*r**6
            -97257380*r**8-381221244*r**10-207762356*r**12+62111700*r**14-17138499*r**16
            -2530980*r**18+121659*r**20)+Q2**3*(-688827+9820381*r**2+8125467*r**4
            +27128619*r**6+399694734*r**8-38526994*r**10+601434146*r**12+982049778*r**14
            +133134381*r**16-10216779*r**18+945091*r**20-51357*r**22)+Q2**2*(14565
            +5151122*r**2+105308600*r**4-474631098*r**6-628285703*r**8-1402253348*r**10
            -700221072*r**12+701722132*r**14+394628383*r**16-112997742*r**18+7661528*r**20
            +1675430*r**22-57597*r**24)+(-1+r**2)**2*(20997-485606*r**2+12779698*r**4
            +181474206*r**6+1526622767*r**8+690798284*r**10-57575364*r**12-500522236*r**14
            +199723379*r**16+48433818*r**18+1265554*r**20-257570*r**22+6873*r**24)
            +Q2*(25797-2877937*r**2-47186412*r**4-24294112*r**6-3489882275*r**8
            -4940138109*r**10-1319224616*r**12+1185768064*r**14+1038599799*r**16
            -735216755*r**18-72991468*r**20-1601952*r**22-124057*r**24+4833*r**26)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(1632960000*logq2**4*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+22680000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +15750*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-3919104000*logq2**5*r**20*sqrtq2
            -272160000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-945000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+(flagPERP*(720*logq2**2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(-64+133*r**2+60*Q2**5*r**2+1223*r**4-10172*r**6-7372*r**8
            -1313*r**10+1005*r**12-32*Q2**4*(2+9*r**2+15*r**4)+Q2**3*(16+1453*r**2
            +2522*r**4+1485*r**6)-Q2**2*(-96+1069*r**2+3351*r**4+3783*r**6+765*r**8)
            -Q2*(-16+409*r**2+1378*r**4+146*r**6-462*r**8+1305*r**10))+(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(27+460*Q2**11-5281*r**2+3007*r**4
            -221525*r**6-568062*r**8+1862442*r**10-6856934*r**12+1636338*r**14+127395*r**16
            +49207*r**18-1049*r**20+35*r**22-1240*Q2**10*(1+r**2)+Q2**9*(-125+3558*r**2
            -125*r**4)+Q2**8*(987+r**2-4463*r**4+2475*r**6)-2*Q2**7*(-1802+8311*r**2
            +50954*r**4+4407*r**6+150*r**8)+Q2**6*(-4604+20782*r**2+325038*r**4
            +294014*r**6+28150*r**8-2820*r**10)+2*Q2**5*(-1011+10443*r**2-67095*r**4
            -357658*r**6-48031*r**8-853*r**10+165*r**12)+Q2**4*(3490-20928*r**2
            -209888*r**4+392158*r**6+839654*r**8-327160*r**10-38328*r**12+2250*r**14)
            +Q2**3*(328-32346*r**2+87100*r**4+421330*r**6+1121864*r**8-91758*r**10
            +273404*r**12+15718*r**14-600*r**16)-2*Q2**2*(482-8581*r**2-6865*r**4
            +350793*r**6+1495671*r**8+1043439*r**10+497177*r**12-5249*r**14-7697*r**16
            +350*r**18)+Q2*(59+14028*r**2-55101*r**4-351056*r**6-1362670*r**8
            +2088136*r**10-2583118*r**12+371376*r**14-101869*r**16-7220*r**18+235*r**20))
            -43200*logq2**3*r**10*(-16+47*r**2+46*r**4+15*r**6)*sqrtq2+12*logq2*r**2*(80*(
            -1+Q2)**6*(-1+Q2+6*Q2**2+4*Q2**3)+(-1+Q2)**5*(1181+3445*Q2+255*Q2**2
            -6905*Q2**3-5520*Q2**4+1544*Q2**5)*r**2-10*(-1+Q2)**2*(457+936*Q2
            +3159*Q2**2-1584*Q2**3+1995*Q2**4+2812*Q2**5-5163*Q2**6+1228*Q2**7)*r**4
            +5*(-9353+6648*Q2+6152*Q2**2+121012*Q2**3-153418*Q2**4+37808*Q2**5
            +34544*Q2**6-29564*Q2**7+6651*Q2**8)*r**6-20*(-11504-3858*Q2-25076*Q2**2
            -65995*Q2**3+69164*Q2**4-5792*Q2**5-5824*Q2**6+1557*Q2**7)*r**8-10*(111543
            -146944*Q2+30208*Q2**2-149158*Q2**3+65341*Q2**4+646*Q2**5+1788*Q2**6)*r**10
            +4*(340133+504680*Q2-76300*Q2**2+114425*Q2**3-22765*Q2**4+14283*Q2**5)*r**12
            -10*(-13177-95780*Q2-44612*Q2**2-11846*Q2**3+3237*Q2**4)*r**14-20*(34668
            +27678*Q2+2204*Q2**2+519*Q2**3)*r**16+5*(24359-5036*Q2+3528*Q2**2)*r**18
            -10*(-1671+602*Q2)*r**20+499*r**22)*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(-691200*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-4800*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+2073600*logq2**4*r**16*sqrtq2
            +86400*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+100*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**4*sqrtq2)+((-720*logq2**2*r**4*(20*Q2**7*(2+5*r**4)-8*Q2**6*(56
            +70*r**2+137*r**4+125*r**6)+Q2**5*(1278+2808*r**2+5511*r**4+6236*r**6
            +3675*r**8)-Q2**4*(1310+3674*r**2+9025*r**4+13293*r**6+11565*r**8+5525*r**10)
            +2*Q2**3*(10+858*r**2+2748*r**4+4516*r**6+5401*r**8+2730*r**10+925*r**12)
            +(-1+r**2)**2*(122+222*r**2+7521*r**4+14321*r**6+7246*r**8-1086*r**10
            -r**12+1175*r**14)+2*Q2**2*(450-432*r**2+2549*r**4+2364*r**6-687*r**8
            -2179*r**10+980*r**12+1875*r**14)-Q2*(602-596*r**2+17123*r**4+40792*r**6
            +43217*r**8+18200*r**10-3927*r**12-1356*r**14+4025*r**16))-(Q2-(
            -1+r)**2)*(Q2-(1+r)**2)*(460*Q2**13-16*Q2**12*(82+135*r**2)+Q2**11*(1529
            +4740*r**2+2815*r**4)+Q2**10*(1819-3033*r**2-6551*r**4+1485*r**6)-Q2**9*(23303
            +17090*r**2+115130*r**4+6710*r**6+5375*r**8)+Q2**8*(62417+40597*r**2
            +327980*r**4+552804*r**6+50555*r**8+255*r**10)+Q2**7*(-57754-28928*r**2
            -262978*r**4-974832*r**6-812682*r**8-74656*r**10+5670*r**12)-2*Q2**6*(11903
            -48025*r**2+142215*r**4-388557*r**6-706385*r**8-20297*r**10+995*r**12
            +615*r**14)+2*Q2**5*(42997-133354*r**2+970036*r**4+850926*r**6+851232*r**8
            -683938*r**10+495816*r**12+47086*r**14-2385*r**16)+Q2**4*(-50522+207550*r**2
            -3318940*r**4-4644060*r**6-7089020*r**8-8579388*r**10-8740*r**12-892740*r**14
            -60490*r**16+2750*r**18)+Q2**3*(-11727+89948*r**2+1125795*r**4+3085184*r**6
            +6539270*r**8+4213752*r**10+5518802*r**12+1736640*r**14+112201*r**16
            -21780*r**18+1035*r**20)+Q2**2*(24291-184457*r**2+2140933*r**4-3316247*r**6
            +66738*r**8-8819574*r**10-3668978*r**12+7653702*r**14-1290453*r**16
            +279487*r**18+30893*r**20-1135*r**22)+(-1+r**2)**2*(937+3615*r**2+431077*r**4
            -1573101*r**6+8535566*r**8+2653074*r**10-5607690*r**12+2405258*r**14
            +183561*r**16+53519*r**18-1051*r**20+35*r**22)+Q2*(-9023+61750*r**2
            -1974350*r**4+5447050*r**6-15554525*r**8-20228524*r**10-3778340*r**12
            +16573420*r**14-8765065*r**16+104310*r**18-210318*r**20-5750*r**22+165*r**24))
            -43200*logq2**3*r**8*(27+66*r**2+25*r**4+46*r**6)*sqrtq2-12*logq2*(8*Q2**10*(47
            +240*r**4)-40*Q2**9*(47+33*r**2+254*r**4+360*r**6)+5*Q2**8*(663+822*r**2
            +3147*r**4+11002*r**6+7530*r**8)-20*Q2**7*(78+311*r**2+197*r**4+3147*r**6
            +5189*r**8+1710*r**10)-20*Q2**6*(117-375*r**2+2667*r**4+739*r**6-2220*r**8
            -4132*r**10+1020*r**12)+4*Q2**5*(822-855*r**2+49350*r**4+99260*r**6
            +128770*r**8+87217*r**10+1010*r**12+15690*r**14)-10*Q2**4*(87+628*r**2
            +24775*r**4+70724*r**6+117149*r**8+150572*r**10+90983*r**12+10444*r**14
            +3510*r**16)-20*Q2**3*(42-387*r**2-1779*r**4-19931*r**6-42087*r**8
            -57495*r**10-46105*r**12-22757*r**14-6487*r**16+570*r**18)+(-1+r**2)**2*(11
            +592*r**2+30668*r**4-22346*r**6+715940*r**8+1405134*r**10-430102*r**12
            -161478*r**14+212161*r**16+20050*r**18+570*r**20)+20*Q2**2*(33-39*r**2
            +7809*r**4-8255*r**6+4379*r**8-15091*r**10-55217*r**12+5335*r**14+32452*r**16
            -1886*r**18+960*r**20)-20*Q2*(8+95*r**2+6056*r**4-7924*r**6+74172*r**8
            +189052*r**10+137992*r**12-51814*r**14-31044*r**16+35605*r**18+1712*r**20
            +330*r**22))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(-518400*logq2**3*r**12*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-3600*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+1555200*logq2**4*r**16*sqrtq2
            +64800*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+75*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**4*sqrtq2)+((12*logq2*(24*Q2**6*(2+5*r**4)-Q2**5*(168
            +133*r**2+540*r**4+795*r**6)-2*Q2**3*r**2*(73+268*r**2+570*r**4+590*r**6
            +375*r**8)+Q2**4*(180+159*r**2+645*r**4+1825*r**6+1575*r**8)-(-1
            +r**2)**2*(12+37*r**2+2117*r**4+3922*r**6-558*r**8-415*r**10+405*r**12)
            -2*Q2**2*(60-167*r**2+799*r**4+538*r**6-700*r**8-135*r**10+525*r**12)
            +Q2*(72-201*r**2+4924*r**4+10719*r**6+7964*r**8-1103*r**10-1600*r**12
            +1305*r**14))-720*logq2**2*r**4*(12+19*r**2+15*r**4)*sqrtq2+(120*Q2**9
            -3*Q2**8*(87+155*r**2)+Q2**7*(258+596*r**2+450*r**4)+Q2**6*(420-514*r**2
            -808*r**4+390*r**6)-6*Q2**5*(441+230*r**2+1306*r**4-98*r**6+145*r**8)
            +2*Q2**4*(1905+622*r**2+6030*r**4+13410*r**6+955*r**8+90*r**10)+2*Q2**3*(
            -477-362*r**2-6203*r**4-3468*r**6-8555*r**8-1802*r**10+195*r**12)
            -6*Q2**2*(378-1147*r**2+1784*r**4-3549*r**6-2410*r**8+3143*r**10-64*r**12
            +25*r**14)+(-1+r**2)**2*(-549+3179*r**2-33609*r**4-12869*r**6+18541*r**8
            -6915*r**10-943*r**12+45*r**14)+Q2*(2070-9916*r**2+66480*r**4+75468*r**6
            +27908*r**8-53892*r**10+22224*r**12+2228*r**14-90*r**16))*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(6480*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+15*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-25920*logq2**3*r**12*sqrtq2
            -540*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(flagPERP*(24*logq2*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-10-11*r**2-36*Q2**4*r**2+14*r**4
            -1326*r**6-416*r**8+189*r**10+2*Q2**3*(-5+132*r**2+117*r**4)-Q2**2*(
            -10+191*r**2+524*r**4+171*r**6)-2*Q2*(-5+93*r**2+2*r**4-68*r**6
            +108*r**8))-720*logq2**2*r**6*(-4+21*r**2+9*r**4)*sqrtq2+(5*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(-15+24*Q2**4-22*r**2-22*r**4-70*r**6+9*r**8
            -21*Q2**3*(1+r**2)+Q2**2*(-21+38*r**2-21*r**4)+Q2*(-15+29*r**2-43*r**4
            +9*r**6))-6*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(-3+5*Q2**3+5*r**2-19*r**4
            +5*r**6-5*Q2**2*(1+r**2)+Q2*(-5+8*r**2-5*r**4))*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8)))*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(8640*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-34560*logq2**3*r**12*sqrtq2
            -720*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(flagPERP*((Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(-3+5*Q2**3+5*r**2-19*r**4+5*r**6-5*Q2**2*(1
            +r**2)+Q2*(-5+8*r**2-5*r**4))-12*logq2*r**4*sqrtq2)*nlo.X1Q2(3,'SM',Q2,r))/(
            -48*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+288*logq2**2*r**8*sqrtq2+2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2)+((-2*(5*Q2**5-Q2**4*(7+15*r**2)+2*Q2**3*(4
            +2*r**2+5*r**4)+(-1+r**2)**2*(17+r**2-11*r**4+5*r**6)+2*Q2**2*(7
            -6*r**2-4*r**4+5*r**6)-Q2*(37+20*r**2+8*r**4-32*r**6+15*r**8))-24*logq2*sqrtq2)*nlo.X1Q2(3,'SM',Q2,r))/(
            -72*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+432*logq2**2*r**8*sqrtq2+3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2)+((1512000*logq2**3*r**12*(1+r**2)*(19
            +10*r**2+19*r**4)+60*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(23
            -1440*Q2**9+10999*r**2+228160*r**4+383296*r**6+3006322*r**8+3006322*r**10
            +383296*r**12+228160*r**14+10999*r**16+23*r**18+10248*Q2**8*(1+r**2)
            -512*Q2**7*(37+94*r**2+37*r**4)+Q2**6*(4319+70769*r**2+70769*r**4+4319*r**6)
            +2*Q2**5*(8631-19072*r**2-30126*r**4-19072*r**6+8631*r**8)-Q2**4*(11375
            +66235*r**2+466262*r**4+466262*r**6+66235*r**8+11375*r**10)-4*Q2**3*(847
            -28698*r**2-220767*r**4-429164*r**6-220767*r**8-28698*r**10+847*r**12)
            +Q2**2*(3729-4117*r**2-37563*r**4-1070849*r**6-1070849*r**8-37563*r**10
            -4117*r**12+3729*r**14)-2*Q2*(217+25092*r**2+198688*r**4-394052*r**6
            -869490*r**8-394052*r**10+198688*r**12+25092*r**14+217*r**16))+3600*logq2**2*r**8*(781
            -80*Q2**6+4344*r**2+33555*r**4+43600*r**6+33555*r**8+4344*r**10+781*r**12
            +900*Q2**5*(1+r**2)-4*Q2**4*(951+1718*r**2+951*r**4)+Q2**3*(3931+13189*r**2
            +13189*r**4+3931*r**6)+Q2**2*(1131-5648*r**2-11126*r**4-5648*r**6+1131*r**8)
            -3*Q2*(953-829*r**2-3484*r**4-3484*r**6-829*r**8+953*r**10))*sqrtq2
            +(-250*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4
            -2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2
            -6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4
            -26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6-31*r**8+r**10))+7*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6-28170*r**8+31692*r**10
            -9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)+Q2**6*(-11+10*r**2
            -11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)+Q2**4*(-165+1480*r**2
            +10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2-6138*r**4-6138*r**6
            -355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4+35188*r**6+10313*r**8
            -406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4+6605*r**6+6605*r**8
            -7237*r**10-595*r**12+27*r**14)))*sqrtq2)*nlopw.X1Q2RhoD(0,Q2,r))/(72576000*logq2**4*r**16
            +3024000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+3500*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-24192000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-168000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((3600*logq2**2*r**8*(15+22*r**2+15*r**4)+(Q2-(-1+r)**2)*(Q2-(1
            +r)**2)*(7+92*Q2**8-156*r**2+5096*r**4+19308*r**6+138690*r**8+19308*r**10
            +5096*r**12-156*r**14+7*r**16-156*Q2**7*(1+r**2)+Q2**6*(-89+190*r**2
            -89*r**4)+2*Q2**5*(79-247*r**2-247*r**4+79*r**6)+Q2**4*(165-1160*r**2
            -10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4-2439*r**6
            -280*r**8+19*r**10)+Q2**2*(-79+806*r**2+1787*r**4-14228*r**6+1787*r**8
            +806*r**10-79*r**12)+2*Q2*(27-635*r**2-2957*r**4+19165*r**6+19165*r**8
            -2957*r**10-635*r**12+27*r**14))+600*logq2*r**4*(1+2*Q2**5+35*r**2
            +276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17+42*r**2
            +17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2+66*r**4
            +30*r**6-11*r**8))*sqrtq2)*nlopw.X1Q2RhoD(1,Q2,r))/(-86400*logq2**3*r**12
            -1800*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+21600*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+50*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((540*logq2*r**4*(1+r**2)-3*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*nlopw.X1Q2RhoD(2,Q2,r))/(1440*logq2**2*r**8
            +10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-240*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+nlopw.X1Q2RhoD(3,Q2,r)/(
            -12*logq2*r**4+(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)))
        if( flagDEBUG == 1):
            print("Q2moment n. 3 NLO pw = api*",resNLO*par.mbkin**6)
        res += api*resNLO

    if(kwargs.get('flag_includeNNLO', 1) == 1):
        resNNLO = 0
        resNNLO +=((flagPERP*muWC**5*(-232243200*logq2**4*(-Q2+(-1+r)**2)*r**16*(-Q2+(1+r)**2)*(
            -120*Q2**8*r**2+30*Q2**7*(1+19*r**2+32*r**4)-6*Q2**6*(16+185*r**2+580*r**4
            +539*r**6)+Q2**5*(96+746*r**2+4710*r**4+8559*r**6+5649*r**8)-Q2**4*(30
            -227*r**2+2070*r**4+7575*r**6+10332*r**8+4620*r**10)+Q2**3*(300-1183*r**2
            +377*r**4+2005*r**6+4623*r**8+5928*r**10-210*r**12)+(-1+r**2)**3*(276
            -733*r**2+1478*r**4+68*r**6+408*r**8+567*r**10+636*r**12)+Q2**2*(-870
            +2062*r**2-1929*r**4+232*r**6-872*r**8+264*r**10-2457*r**12+3570*r**14)
            +Q2*(846-2753*r**2+6267*r**4-1059*r**6-2725*r**8+339*r**10-837*r**12
            +2553*r**14-2631*r**16))-46080*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-17784*Q2**14*r**2+2*Q2**13*(-1897+96261*r**2+92448*r**4)-2*Q2**12*(
            -15554+405615*r**2+882646*r**4+391197*r**6)+Q2**11*(-95382+1750339*r**2
            +6071923*r**4+6328463*r**6+1631841*r**8)-2*Q2**10*(-61369+1096899*r**2
            +4560520*r**4+6649091*r**6+5099489*r**8+647322*r**10)+Q2**9*(-10570
            +1968033*r**2+4044291*r**4-5702304*r**6-6463898*r**8+2850955*r**10-1369707*r**12)
            +4*Q2**8*(-35658-448491*r**2+1114939*r**4+13311700*r**6+28261739*r**8
            +18008755*r**10+3884124*r**12+1015452*r**14)-2*Q2**7*(-71022-676110*r**2
            +2673843*r**4+33385290*r**6+103349827*r**8+130770026*r**10+53465389*r**12
            +11683758*r**14+1463031*r**16)+2*Q2**6*(-27258-57369*r**2+619543*r**4
            +17000977*r**6+58654985*r**8+124500337*r**10+116525561*r**12+9453563*r**14
            +3934017*r**16-586116*r**18)+2*Q2**5*(22617-357987*r**2-73183*r**4-11576662*r**6
            +2995634*r**8+11071016*r**10-15469322*r**12-12990098*r**14+52951493*r**16
            +5486763*r**18+1620369*r**20)-2*Q2**4*(24290-185838*r**2-420537*r**4
            -14917407*r**6+1569580*r**8+47681716*r**10+103696522*r**12+61483838*r**14
            +50657978*r**16+52694826*r**18+6120615*r**20+848817*r**22)+Q2**3*(-13174
            +119817*r**2-838637*r**4-12247855*r**6-1484579*r**8-6965910*r**10+97517726*r**12
            +181952266*r**14-18152100*r**16+105864669*r**18+9439999*r**20+3191957*r**22
            -342579*r**24)+2*(-1+r**2)**3*(-3164-11103*r**2-89740*r**4-847083*r**6
            +4386372*r**8-26946120*r**10+8717478*r**12+11164272*r**14+16072218*r**16
            -1880137*r**18+2850294*r**20+170635*r**22+24078*r**24)+2*Q2**2*(26649
            -64220*r**2+379509*r**4-1334768*r**6-9129162*r**8+18487974*r**10-8693214*r**12
            -10067148*r**14-60601875*r**16+99979092*r**18-50614423*r**20+20473404*r**22
            +779204*r**24+378978*r**26)-Q2*(32102-18099*r**2+512869*r**4+3872*r**6
            -21603566*r**8+105464001*r**10-112916667*r**12+3028632*r**14+31351506*r**16
            -146886593*r**18+185388447*r**20-71030584*r**22+25227574*r**24+1124147*r**26
            +322359*r**28))+64*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-176*Q2**18*r**2
            +Q2**17*(-2313+4999*r**2-222*r**4)+Q2**16*(27831-41074*r**2-227095*r**4
            +12066*r**6)+Q2**15*(-148287-138957*r**2+3606965*r**4+2021143*r**6-64288*r**8)
            +Q2**14*(457500+1537255*r**2-16562010*r**4-29532198*r**6-7587314*r**8
            +155055*r**10)+Q2**13*(-892965-3181345*r**2+38572892*r**4+96612480*r**6
            +86558453*r**8+12289601*r**10-163212*r**12)-Q2**12*(-1121754+2510493*r**2
            +65636338*r**4+53435771*r**6-58849194*r**8+48169567*r**10-1476334*r**12
            +56329*r**14)+Q2**11*(-868143+20362963*r**2+107146983*r**4-232025547*r**6
            -1735903161*r**8-1560772827*r**10-295392063*r**12-38202749*r**14+363792*r**16)
            +Q2**10*(362736-33936121*r**2-136023706*r**4+421664136*r**6+4431318318*r**8
            +8166770862*r**10+4119315954*r**12+693458816*r**14+54731402*r**16-364221*r**18)
            -Q2**9*(91575-21181645*r**2-77296790*r**4+303668354*r**6+4229784392*r**8
            +11266065120*r**10+13220439390*r**12+3032713870*r**14+364737889*r**16
            +7597997*r**18+17160*r**20)+Q2**8*(120780+6296423*r**2+33451296*r**4
            +358745175*r**6+1671351804*r**8-655367502*r**10-149730396*r**12+3599958426*r**14
            -4357629480*r**16-680886441*r**18-58743652*r**20+327327*r**22)+Q2**7*(
            -128469-16259231*r**2-60774653*r**4-567877023*r**6-1514356458*r**8+10121742546*r**10
            +36902108478*r**12+31783864314*r**14+14018557167*r**16+9544669437*r**18
            +1116523663*r**20+58756885*r**22-233376*r**24)-Q2**6*(-3468-5459901*r**2
            -20002114*r**4-313283426*r**6-1803490402*r**8+3699693165*r**10+31771634460*r**12
            +70840959188*r**14+28834374240*r**16+17278746573*r**18+3985745574*r**20
            +303829262*r**22-335858*r**24+34307*r**26)+Q2**5*(79089+3801293*r**2
            -20924808*r**4+136772724*r**6+472726253*r**8-2165410791*r**10+7542644244*r**12
            +8767664080*r**14+61524304779*r**16-27783802209*r**18+7766490152*r**20
            -4860917892*r**22-582858537*r**24-36206533*r**26+130956*r**28)+Q2**4*(
            -46050-3025775*r**2+36468370*r**4-184713573*r**6-1720749494*r**8+2484523765*r**10
            -14312128170*r**12+22733394815*r**14+34318487426*r**16-47977225677*r**18
            +59434307470*r**20-1161609215*r**22+5691358230*r**24+538582087*r**26
            +21826186*r**28-58395*r**30)+(-1+r**2)**3*(-837-3046*r**2+2845574*r**4
            +10677976*r**6-5786832*r**8+636089126*r**10+579280450*r**12-7565546468*r**14
            +35283444978*r**16-44760554106*r**18+19864115914*r**20-6192595232*r**22
            +385535744*r**24-183526854*r**26-13122962*r**28-406228*r**30+803*r**32)
            -Q2**3*(5565-136473*r**2+9291263*r**4-32128595*r**6-548907843*r**8+1583135399*r**10
            -13085842265*r**12+14953442869*r**14+10951896895*r**16+20239085981*r**18
            -13551566763*r**20+18835537199*r**22+2530346743*r**24+1021735125*r**26
            +60517637*r**28-1430801*r**30+10064*r**32)+Q2**2*(15528+414725*r**2
            -17784462*r**4+8798844*r**6+300967314*r**8-1337026464*r**10+2354495562*r**12
            +8126035036*r**14-31279960998*r**16+78431910642*r**18-107631524906*r**20
            +76903236756*r**22-29545361226*r**24+5188014504*r**26-1362453906*r**28
            -133036908*r**30-6758218*r**32+18177*r**34)-2*Q2*(3078+51520*r**2-6765674*r**4
            -1673415*r**6+97502733*r**8-1106398491*r**10+2806710273*r**12-4643078395*r**14
            +11143999493*r**16-55372148991*r**18+119279219273*r**20-111857961781*r**22
            +52742661687*r**24-14476213041*r**26+1848212883*r**28-416606985*r**30
            -36087887*r**32-1429493*r**34+3213*r**36))-20901888000*logq2**5*r**20*(
            -5+5*r**2-r**4+r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+552960*logq2**3*r**12*(29160*Q2**13*r**2
            -2*Q2**12*(2177+137211*r**2+163152*r**4)+2*Q2**11*(20979+566801*r**2
            +1272501*r**4+787719*r**6)-Q2**10*(165669+2687654*r**2+8235344*r**4
            +9910704*r**6+4179189*r**8)+5*Q2**9*(69440+793675*r**2+2824818*r**4
            +4749284*r**6+4088190*r**8+1239681*r**10)-5*Q2**8*(79527+768303*r**2
            +2658408*r**4+5103272*r**6+6177745*r**8+4463697*r**10+741240*r**12)
            +Q2**7*(183288+2928534*r**2+6516638*r**4+8142060*r**6+5574460*r**8+7914598*r**10
            +8488974*r**12-3490632*r**14)+2*Q2**6*(57477-1289742*r**2-960232*r**4
            +2684222*r**6+12928820*r**8+20271952*r**10+13282598*r**12+3857028*r**14
            +4392837*r**16)-(-1+r**2)**5*(-4879+17066*r**2+337776*r**4-1881054*r**6
            +1045786*r**8+195594*r**10+1135624*r**12+1267014*r**14+52269*r**16+102804*r**18)
            -2*Q2**5*(103026-1153884*r**2-267669*r**4+1296371*r**6+11237571*r**8
            +22747851*r**10+27318521*r**12+15075361*r**14+5614311*r**16+3327741*r**18)
            +20*Q2**4*(3885-57315*r**2+88408*r**4-194841*r**6+412506*r**8+894406*r**10
            +999843*r**12+1322333*r**14+119309*r**16+364425*r**18+25281*r**20)+Q2*(
            -1+r**2)**3*(-29988+143179*r**2+1720289*r**4-6702816*r**6+1477784*r**8
            +4685590*r**10+3197586*r**12+5360376*r**14+7630356*r**16-107769*r**18
            +769413*r**20)+10*Q2**3*(5341-11292*r**2-371276*r**4+997009*r**6-995854*r**8
            -571080*r**10-147664*r**12+382810*r**14-1089079*r**16+2087180*r**18
            -573564*r**20+287469*r**22)+Q2**2*(-69909+466538*r**2+2994816*r**4-14939500*r**6
            +20583785*r**8-3094872*r**10+952364*r**12-2136652*r**14-5775975*r**16
            +19919390*r**18-21566844*r**20+4944648*r**22-2277789*r**24))*sqrtq2+384*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(4656*Q2**17*r**2-4*Q2**16*(-4025+29301*r**2
            +13560*r**4)+4*Q2**15*(-33915+173959*r**2+332147*r**4+64161*r**6)-Q2**14*(
            -463925+2049671*r**2+6780185*r**4+5508151*r**6+601950*r**8)+2*Q2**13*(
            -374605+2243625*r**2+6002282*r**4+1678596*r**6+4164467*r**8+276675*r**10)
            +Q2**12*(298655-9872017*r**2-2600340*r**4+146601032*r**6+135666425*r**8
            +8729489*r**10+584052*r**12)-4*Q2**11*(-231280-4659131*r**2+2991439*r**4
            +147236034*r**6+289270594*r**8+139608749*r**10+12919151*r**12+520380*r**14)
            +Q2**10*(-1544235-22194735*r**2+9501973*r**4+953067611*r**6+2846105125*r**8
            +3021455135*r**10+859028971*r**12+68523365*r**14+1745238*r**16)+2*Q2**9*(279125
            +5795841*r**2-13473290*r**4-384506844*r**6-1131915080*r**8-1749558270*r**10
            -1412324414*r**12-45862060*r**14-73349*r**16+406725*r**18)-Q2**8*(-818895
            -3654615*r**2-84100182*r**4-491668006*r**6+890470948*r**8+5610996100*r**10
            +4947223110*r**12+1819512278*r**14+1493478459*r**16+96097443*r**18+2640000*r**20)
            +4*Q2**7*(-230615-1918911*r**2-22686315*r**4-129886211*r**6+464456190*r**8
            +3445614778*r**10+6608535690*r**12+3972723470*r**14+1558621729*r**16
            +462231085*r**18+23413593*r**20+383757*r**22)+Q2**6*(88935+3591779*r**2
            +25238257*r**4+273258847*r**6-199821868*r**8-8083222218*r**10-24872273910*r**12
            -34287250778*r**14-8836672153*r**16-4414465193*r**18-186773803*r**20
            +3620395*r**22+678510*r**24)-2*Q2**5*(-182525+1022549*r**2-2129110*r**4
            -133904188*r**6+182074025*r**8-1405616455*r**10-52111404*r**12-5142992712*r**14
            -7680651411*r**16+5954564575*r**18+260346690*r**20+673786340*r**22+32699047*r**24
            +659379*r**26)+Q2**4*(-199675+1861989*r**2+13825040*r**4-372087236*r**6
            +49064585*r**8-4574003935*r**10+3856760092*r**12+17237300160*r**14+5350472567*r**16
            +2665715495*r**18+17066338640*r**20+2302742724*r**22+1067888955*r**24
            +40622099*r**26+514500*r**28)-(-1+r**2)**3*(2345-165468*r**2-3653345*r**4
            +4213008*r**6-116202759*r**8-384811156*r**10+1936178071*r**12-9002208200*r**14
            +5223578419*r**16+4839613628*r**18-2105105963*r**20+1166707872*r**22
            +42596395*r**24+31322548*r**26+884981*r**28+9624*r**30)+4*Q2**3*(-5390
            +57565*r**2-1481049*r**4+19094588*r**6+9956016*r**8+621706335*r**10
            -206534955*r**12-375594042*r**14-5438779686*r**16+2053206763*r**18-2788047695*r**20
            -722150560*r**22-323084284*r**24-9797927*r**26+581971*r**28+40350*r**30)
            -Q2**2*(-55055+1539245*r**2+15613325*r**4-95302237*r**6+342362235*r**8
            -681654379*r**10-1576967699*r**12+1220656435*r**14+5906222589*r**16-25051915025*r**18
            +33063160223*r**20-20249429807*r**22+7212583665*r**24-456732977*r**26
            +336592615*r**28+13110361*r**30+216486*r**32)+2*Q2*(-9765+455763*r**2
            +6761482*r**4-33637268*r**6+210570022*r**8-223612708*r**10-922698382*r**12
            +4957142836*r**14-3481924164*r**16+868319106*r**18-13335320514*r**20
            +18273598100*r**22-8917783318*r**24+2604291932*r**26-95912378*r**28+86833612*r**30
            +2887769*r**32+37875*r**34))*sqrtq2))/(-29393280000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-408240000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            -283500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5
            +70543872000*logq2**5*r**22*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            +4898880000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2+17010000*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)+(flagPERP*muWC**4*(
            -1857945600*logq2**4*(-Q2+(-1+r)**2)*r**16*(-Q2+(1+r)**2)*(-120*Q2**8*r**2
            +30*Q2**7*(1+19*r**2+32*r**4)-6*Q2**6*(16+185*r**2+580*r**4+539*r**6)
            +Q2**5*(96+746*r**2+4710*r**4+8559*r**6+5649*r**8)-Q2**4*(30-227*r**2
            +2070*r**4+7575*r**6+10332*r**8+4620*r**10)+Q2**3*(300-1183*r**2+377*r**4
            +2005*r**6+4623*r**8+5928*r**10-210*r**12)+(-1+r**2)**3*(276-733*r**2
            +1478*r**4+68*r**6+408*r**8+567*r**10+636*r**12)+Q2**2*(-870+2062*r**2
            -1929*r**4+232*r**6-872*r**8+264*r**10-2457*r**12+3570*r**14)+Q2*(846
            -2753*r**2+6267*r**4-1059*r**6-2725*r**8+339*r**10-837*r**12+2553*r**14
            -2631*r**16))-368640*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -17784*Q2**14*r**2+2*Q2**13*(-1897+96261*r**2+92448*r**4)-2*Q2**12*(-15554
            +405615*r**2+882646*r**4+391197*r**6)+Q2**11*(-95382+1750339*r**2+6071923*r**4
            +6328463*r**6+1631841*r**8)-2*Q2**10*(-61369+1096899*r**2+4560520*r**4
            +6649091*r**6+5099489*r**8+647322*r**10)+Q2**9*(-10570+1968033*r**2
            +4044291*r**4-5702304*r**6-6463898*r**8+2850955*r**10-1369707*r**12)
            +4*Q2**8*(-35658-448491*r**2+1114939*r**4+13311700*r**6+28261739*r**8
            +18008755*r**10+3884124*r**12+1015452*r**14)-2*Q2**7*(-71022-676110*r**2
            +2673843*r**4+33385290*r**6+103349827*r**8+130770026*r**10+53465389*r**12
            +11683758*r**14+1463031*r**16)+2*Q2**6*(-27258-57369*r**2+619543*r**4
            +17000977*r**6+58654985*r**8+124500337*r**10+116525561*r**12+9453563*r**14
            +3934017*r**16-586116*r**18)+2*Q2**5*(22617-357987*r**2-73183*r**4-11576662*r**6
            +2995634*r**8+11071016*r**10-15469322*r**12-12990098*r**14+52951493*r**16
            +5486763*r**18+1620369*r**20)-2*Q2**4*(24290-185838*r**2-420537*r**4
            -14917407*r**6+1569580*r**8+47681716*r**10+103696522*r**12+61483838*r**14
            +50657978*r**16+52694826*r**18+6120615*r**20+848817*r**22)+Q2**3*(-13174
            +119817*r**2-838637*r**4-12247855*r**6-1484579*r**8-6965910*r**10+97517726*r**12
            +181952266*r**14-18152100*r**16+105864669*r**18+9439999*r**20+3191957*r**22
            -342579*r**24)+2*(-1+r**2)**3*(-3164-11103*r**2-89740*r**4-847083*r**6
            +4386372*r**8-26946120*r**10+8717478*r**12+11164272*r**14+16072218*r**16
            -1880137*r**18+2850294*r**20+170635*r**22+24078*r**24)+2*Q2**2*(26649
            -64220*r**2+379509*r**4-1334768*r**6-9129162*r**8+18487974*r**10-8693214*r**12
            -10067148*r**14-60601875*r**16+99979092*r**18-50614423*r**20+20473404*r**22
            +779204*r**24+378978*r**26)-Q2*(32102-18099*r**2+512869*r**4+3872*r**6
            -21603566*r**8+105464001*r**10-112916667*r**12+3028632*r**14+31351506*r**16
            -146886593*r**18+185388447*r**20-71030584*r**22+25227574*r**24+1124147*r**26
            +322359*r**28))+512*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-176*Q2**18*r**2
            +Q2**17*(-2313+4999*r**2-222*r**4)+Q2**16*(27831-41074*r**2-227095*r**4
            +12066*r**6)+Q2**15*(-148287-138957*r**2+3606965*r**4+2021143*r**6-64288*r**8)
            +Q2**14*(457500+1537255*r**2-16562010*r**4-29532198*r**6-7587314*r**8
            +155055*r**10)+Q2**13*(-892965-3181345*r**2+38572892*r**4+96612480*r**6
            +86558453*r**8+12289601*r**10-163212*r**12)-Q2**12*(-1121754+2510493*r**2
            +65636338*r**4+53435771*r**6-58849194*r**8+48169567*r**10-1476334*r**12
            +56329*r**14)+Q2**11*(-868143+20362963*r**2+107146983*r**4-232025547*r**6
            -1735903161*r**8-1560772827*r**10-295392063*r**12-38202749*r**14+363792*r**16)
            +Q2**10*(362736-33936121*r**2-136023706*r**4+421664136*r**6+4431318318*r**8
            +8166770862*r**10+4119315954*r**12+693458816*r**14+54731402*r**16-364221*r**18)
            -Q2**9*(91575-21181645*r**2-77296790*r**4+303668354*r**6+4229784392*r**8
            +11266065120*r**10+13220439390*r**12+3032713870*r**14+364737889*r**16
            +7597997*r**18+17160*r**20)+Q2**8*(120780+6296423*r**2+33451296*r**4
            +358745175*r**6+1671351804*r**8-655367502*r**10-149730396*r**12+3599958426*r**14
            -4357629480*r**16-680886441*r**18-58743652*r**20+327327*r**22)+Q2**7*(
            -128469-16259231*r**2-60774653*r**4-567877023*r**6-1514356458*r**8+10121742546*r**10
            +36902108478*r**12+31783864314*r**14+14018557167*r**16+9544669437*r**18
            +1116523663*r**20+58756885*r**22-233376*r**24)-Q2**6*(-3468-5459901*r**2
            -20002114*r**4-313283426*r**6-1803490402*r**8+3699693165*r**10+31771634460*r**12
            +70840959188*r**14+28834374240*r**16+17278746573*r**18+3985745574*r**20
            +303829262*r**22-335858*r**24+34307*r**26)+Q2**5*(79089+3801293*r**2
            -20924808*r**4+136772724*r**6+472726253*r**8-2165410791*r**10+7542644244*r**12
            +8767664080*r**14+61524304779*r**16-27783802209*r**18+7766490152*r**20
            -4860917892*r**22-582858537*r**24-36206533*r**26+130956*r**28)+Q2**4*(
            -46050-3025775*r**2+36468370*r**4-184713573*r**6-1720749494*r**8+2484523765*r**10
            -14312128170*r**12+22733394815*r**14+34318487426*r**16-47977225677*r**18
            +59434307470*r**20-1161609215*r**22+5691358230*r**24+538582087*r**26
            +21826186*r**28-58395*r**30)+(-1+r**2)**3*(-837-3046*r**2+2845574*r**4
            +10677976*r**6-5786832*r**8+636089126*r**10+579280450*r**12-7565546468*r**14
            +35283444978*r**16-44760554106*r**18+19864115914*r**20-6192595232*r**22
            +385535744*r**24-183526854*r**26-13122962*r**28-406228*r**30+803*r**32)
            -Q2**3*(5565-136473*r**2+9291263*r**4-32128595*r**6-548907843*r**8+1583135399*r**10
            -13085842265*r**12+14953442869*r**14+10951896895*r**16+20239085981*r**18
            -13551566763*r**20+18835537199*r**22+2530346743*r**24+1021735125*r**26
            +60517637*r**28-1430801*r**30+10064*r**32)+Q2**2*(15528+414725*r**2
            -17784462*r**4+8798844*r**6+300967314*r**8-1337026464*r**10+2354495562*r**12
            +8126035036*r**14-31279960998*r**16+78431910642*r**18-107631524906*r**20
            +76903236756*r**22-29545361226*r**24+5188014504*r**26-1362453906*r**28
            -133036908*r**30-6758218*r**32+18177*r**34)-2*Q2*(3078+51520*r**2-6765674*r**4
            -1673415*r**6+97502733*r**8-1106398491*r**10+2806710273*r**12-4643078395*r**14
            +11143999493*r**16-55372148991*r**18+119279219273*r**20-111857961781*r**22
            +52742661687*r**24-14476213041*r**26+1848212883*r**28-416606985*r**30
            -36087887*r**32-1429493*r**34+3213*r**36))-167215104000*logq2**5*r**20*(
            -5+5*r**2-r**4+r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+4423680*logq2**3*r**12*(29160*Q2**13*r**2
            -2*Q2**12*(2177+137211*r**2+163152*r**4)+2*Q2**11*(20979+566801*r**2
            +1272501*r**4+787719*r**6)-Q2**10*(165669+2687654*r**2+8235344*r**4
            +9910704*r**6+4179189*r**8)+5*Q2**9*(69440+793675*r**2+2824818*r**4
            +4749284*r**6+4088190*r**8+1239681*r**10)-5*Q2**8*(79527+768303*r**2
            +2658408*r**4+5103272*r**6+6177745*r**8+4463697*r**10+741240*r**12)
            +Q2**7*(183288+2928534*r**2+6516638*r**4+8142060*r**6+5574460*r**8+7914598*r**10
            +8488974*r**12-3490632*r**14)+2*Q2**6*(57477-1289742*r**2-960232*r**4
            +2684222*r**6+12928820*r**8+20271952*r**10+13282598*r**12+3857028*r**14
            +4392837*r**16)-(-1+r**2)**5*(-4879+17066*r**2+337776*r**4-1881054*r**6
            +1045786*r**8+195594*r**10+1135624*r**12+1267014*r**14+52269*r**16+102804*r**18)
            -2*Q2**5*(103026-1153884*r**2-267669*r**4+1296371*r**6+11237571*r**8
            +22747851*r**10+27318521*r**12+15075361*r**14+5614311*r**16+3327741*r**18)
            +20*Q2**4*(3885-57315*r**2+88408*r**4-194841*r**6+412506*r**8+894406*r**10
            +999843*r**12+1322333*r**14+119309*r**16+364425*r**18+25281*r**20)+Q2*(
            -1+r**2)**3*(-29988+143179*r**2+1720289*r**4-6702816*r**6+1477784*r**8
            +4685590*r**10+3197586*r**12+5360376*r**14+7630356*r**16-107769*r**18
            +769413*r**20)+10*Q2**3*(5341-11292*r**2-371276*r**4+997009*r**6-995854*r**8
            -571080*r**10-147664*r**12+382810*r**14-1089079*r**16+2087180*r**18
            -573564*r**20+287469*r**22)+Q2**2*(-69909+466538*r**2+2994816*r**4-14939500*r**6
            +20583785*r**8-3094872*r**10+952364*r**12-2136652*r**14-5775975*r**16
            +19919390*r**18-21566844*r**20+4944648*r**22-2277789*r**24))*sqrtq2+3072*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(4656*Q2**17*r**2-4*Q2**16*(-4025+29301*r**2
            +13560*r**4)+4*Q2**15*(-33915+173959*r**2+332147*r**4+64161*r**6)-Q2**14*(
            -463925+2049671*r**2+6780185*r**4+5508151*r**6+601950*r**8)+2*Q2**13*(
            -374605+2243625*r**2+6002282*r**4+1678596*r**6+4164467*r**8+276675*r**10)
            +Q2**12*(298655-9872017*r**2-2600340*r**4+146601032*r**6+135666425*r**8
            +8729489*r**10+584052*r**12)-4*Q2**11*(-231280-4659131*r**2+2991439*r**4
            +147236034*r**6+289270594*r**8+139608749*r**10+12919151*r**12+520380*r**14)
            +Q2**10*(-1544235-22194735*r**2+9501973*r**4+953067611*r**6+2846105125*r**8
            +3021455135*r**10+859028971*r**12+68523365*r**14+1745238*r**16)+2*Q2**9*(279125
            +5795841*r**2-13473290*r**4-384506844*r**6-1131915080*r**8-1749558270*r**10
            -1412324414*r**12-45862060*r**14-73349*r**16+406725*r**18)-Q2**8*(-818895
            -3654615*r**2-84100182*r**4-491668006*r**6+890470948*r**8+5610996100*r**10
            +4947223110*r**12+1819512278*r**14+1493478459*r**16+96097443*r**18+2640000*r**20)
            +4*Q2**7*(-230615-1918911*r**2-22686315*r**4-129886211*r**6+464456190*r**8
            +3445614778*r**10+6608535690*r**12+3972723470*r**14+1558621729*r**16
            +462231085*r**18+23413593*r**20+383757*r**22)+Q2**6*(88935+3591779*r**2
            +25238257*r**4+273258847*r**6-199821868*r**8-8083222218*r**10-24872273910*r**12
            -34287250778*r**14-8836672153*r**16-4414465193*r**18-186773803*r**20
            +3620395*r**22+678510*r**24)-2*Q2**5*(-182525+1022549*r**2-2129110*r**4
            -133904188*r**6+182074025*r**8-1405616455*r**10-52111404*r**12-5142992712*r**14
            -7680651411*r**16+5954564575*r**18+260346690*r**20+673786340*r**22+32699047*r**24
            +659379*r**26)+Q2**4*(-199675+1861989*r**2+13825040*r**4-372087236*r**6
            +49064585*r**8-4574003935*r**10+3856760092*r**12+17237300160*r**14+5350472567*r**16
            +2665715495*r**18+17066338640*r**20+2302742724*r**22+1067888955*r**24
            +40622099*r**26+514500*r**28)-(-1+r**2)**3*(2345-165468*r**2-3653345*r**4
            +4213008*r**6-116202759*r**8-384811156*r**10+1936178071*r**12-9002208200*r**14
            +5223578419*r**16+4839613628*r**18-2105105963*r**20+1166707872*r**22
            +42596395*r**24+31322548*r**26+884981*r**28+9624*r**30)+4*Q2**3*(-5390
            +57565*r**2-1481049*r**4+19094588*r**6+9956016*r**8+621706335*r**10
            -206534955*r**12-375594042*r**14-5438779686*r**16+2053206763*r**18-2788047695*r**20
            -722150560*r**22-323084284*r**24-9797927*r**26+581971*r**28+40350*r**30)
            -Q2**2*(-55055+1539245*r**2+15613325*r**4-95302237*r**6+342362235*r**8
            -681654379*r**10-1576967699*r**12+1220656435*r**14+5906222589*r**16-25051915025*r**18
            +33063160223*r**20-20249429807*r**22+7212583665*r**24-456732977*r**26
            +336592615*r**28+13110361*r**30+216486*r**32)+2*Q2*(-9765+455763*r**2
            +6761482*r**4-33637268*r**6+210570022*r**8-223612708*r**10-922698382*r**12
            +4957142836*r**14-3481924164*r**16+868319106*r**18-13335320514*r**20
            +18273598100*r**22-8917783318*r**24+2604291932*r**26-95912378*r**28+86833612*r**30
            +2887769*r**32+37875*r**34))*sqrtq2))/(-88179840000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-1224720000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            -850500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5
            +211631616000*logq2**5*r**22*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            +14696640000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2+51030000*logq2*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)+(muWC**5*(33177600*logq2**4*r**14*(
            -120*Q2**10*(3+35*r**4)+30*Q2**9*(71+190*r**2+1155*r**4+1400*r**6)-6*Q2**8*(75
            +4410*r**2+22776*r**4+44030*r**6+30765*r**8)+Q2**7*(-22005+13305*r**2
            +246818*r**4+670848*r**6+836535*r**8+457695*r**10)-2*Q2**6*(-30870-49665*r**2
            +51109*r**4+377195*r**6+687519*r**8+676620*r**10+335160*r**12)+3*Q2**5*(
            -17745-58275*r**2-63083*r**4+100129*r**6+308189*r**8+424347*r**10+341495*r**12
            +171255*r**14)-Q2**4*(51030-33600*r**2-203885*r**4+56475*r**6+266046*r**8
            +412510*r**10+420735*r**12+56175*r**14+22050*r**16)+(-1+r**2)**4*(-13380
            -6240*r**2+21949*r**4-109371*r**6+20094*r**8-61666*r**10-22851*r**12
            +23205*r**14+22260*r**16)+Q2**3*(161325+104055*r**2-79664*r**4+474230*r**6
            +100374*r**8+177544*r**10+104720*r**12+168066*r**14-350595*r**16-349335*r**18)
            -Q2*(-1+r**2)**2*(-72585-42375*r**2+67462*r**4-533236*r**6-191076*r**8
            -157126*r**10-209486*r**12-110028*r**14+103845*r**16+136605*r**18)+6*Q2**2*(
            -26220+135*r**2+23272*r**4-167898*r**6-59426*r**8-63556*r**10-22606*r**12
            -15118*r**14-63978*r**16+4165*r**18+55230*r**20))+9216*logq2**2*(-Q2
            +(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(-24*Q2**16*(5117+18525*r**4)+2*Q2**15*(718659
            +661654*r**2+2074695*r**4+2755800*r**6)-2*Q2**14*(3619845+6688372*r**2
            +12130370*r**4+22587740*r**6+14624625*r**8)+Q2**13*(20323155+56513731*r**2
            +103615716*r**4+178855200*r**6+202098465*r**8+84538125*r**10)-2*Q2**12*(16841640
            +64274037*r**2+133811416*r**4+221896522*r**6+252739380*r**8+228203245*r**10
            +66759000*r**12)+2*Q2**11*(14911452+82436848*r**2+164432808*r**4+241567773*r**6
            +112221178*r**8+45180572*r**10+217778090*r**12+35642775*r**14)+2*Q2**10*(
            -1633797-52189409*r**2+24308080*r**4+362074915*r**6+1255593040*r**8
            +2114707421*r**10+1457991628*r**12+147121065*r**14+68832225*r**16)-Q2**9*(23311695
            +977537*r**2+713488400*r**4+3118376580*r**6+8107826450*r**8+13934114150*r**10
            +14377919152*r**12+7507235620*r**14+1302283615*r**16+310484625*r**18)
            +2*Q2**8*(12788820+27342444*r**2+492825789*r**4+2086270875*r**6+5466731425*r**8
            +9953274465*r**10+12436137489*r**12+9753806389*r**14+3700138875*r**16
            +697008435*r**18+109271250*r**20)+2*Q2**7*(-4912545-29569326*r**2-372255693*r**4
            -1457772996*r**6-3744231730*r**8-5753874670*r**10-7180554446*r**12-7055882718*r**14
            -4188730901*r**16+446773260*r**18-149311485*r**20+33239250*r**22)-2*Q2**6*(963567
            -30437354*r**2-263821554*r**4-978036504*r**6-2617235949*r**8-826344902*r**10
            +2969745706*r**12+5983716946*r**14+5202342671*r**16+3564306176*r**18
            +4797999832*r**20+377595030*r**22+116891775*r**24)+Q2**5*(3343509-47455663*r**2
            -360003860*r**4-1942231940*r**6-5585471095*r**8-2325426671*r**10+6277282144*r**12
            +18838151680*r**14+21236929335*r**16+16332389955*r**18+8939910772*r**20
            +9018094564*r**22+802949995*r**24+157335675*r**26)+2*(-1+r**2)**4*(-23304
            -502442*r**2-14894839*r**4+14767085*r**6-244552895*r**8+485341113*r**10
            +551653164*r**12-1534431642*r**14-443548890*r**16+405286620*r**18+311213741*r**20
            -64438547*r**22+76205281*r**24+3723605*r**26+601950*r**28)-2*Q2**4*(894120
            -4127203*r**2+34763730*r**4-619458330*r**6-378306800*r**8-624439675*r**10
            -393024924*r**12+2566220800*r**14+5638075340*r**16+1353256275*r**18+1190778830*r**20
            +1848439802*r**22+837653820*r**24+137689515*r**26+3181500*r**28)-Q2*(
            -1+r**2)**2*(-318663-6807547*r**2-180486207*r**4+153549237*r**6-2766897815*r**8
            +3956505381*r**10+4765966089*r**12-9055963251*r**14-6863866749*r**16
            -5093264505*r**18+3900872107*r**20+4177086183*r**22-1341697317*r**24
            +1042033487*r**26+45222795*r**28+10466775*r**30)-2*Q2**3*(-622290-9817128*r**2
            -228898678*r**4+263384225*r**6-2832658380*r**8+980439910*r**10+584844336*r**12
            -2179043169*r**14+450956550*r**16-4437161700*r**18+4656122730*r**20+4951238767*r**22
            -2071737128*r**24+1559437350*r**26+28077980*r**28+27260625*r**30)+2*Q2**2*(
            -427815-8817637*r**2-208809816*r**4+298785993*r**6-3141788940*r**8+4696765145*r**10
            +505102454*r**12-5488693593*r**14-3466029516*r**16+1586461845*r**18-7700417660*r**20
            +813227583*r**22+6316331184*r**24-2896877577*r**26+1380523870*r**28+38929105*r**30
            +18135375*r**32))-64*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(-144*Q2**21
            +16*Q2**20*(171+13*r**2)+Q2**19*(11898+10424*r**2-4622*r**4)+2*Q2**18*(
            -454077-60721*r**2-519733*r**4+47183*r**6)+8*Q2**17*(1050123+333051*r**2
            +547796*r**4+1376249*r**6-76802*r**8)+Q2**16*(-36790047-17295855*r**2
            +42654714*r**4-48300182*r**6-52344723*r**8+2045933*r**10)+Q2**15*(91547286
            +47580168*r**2-385339066*r**4-382243992*r**6+178303562*r**8+127341744*r**10
            -3827302*r**12)+2*Q2**14*(-64187697-29149617*r**2+781465571*r**4+1435203659*r**6
            +1284278877*r**8-18393571*r**10-58391551*r**12+1683673*r**14)+2*Q2**13*(33497031
            +18011112*r**2-2194511310*r**4-4999865812*r**6-7517514416*r**8-6275613096*r**10
            -799027786*r**12-94173036*r**14+683041*r**16)+Q2**12*(86945898-105352806*r**2
            +8992101620*r**4+25357534980*r**6+43745600136*r**8+55718829480*r**10
            +35653173708*r**12+5072693468*r**14+699581454*r**16-7149922*r**18)+2*Q2**11*(
            -90435735+154834124*r**2-6013356985*r**4-22494373372*r**6-41768259478*r**8
            -56605560972*r**10-57054822546*r**12-25024736180*r**14-3225320131*r**16
            -400882768*r**18+3633435*r**20)+Q2**10*(95672226-280651294*r**2+7278727414*r**4
            +47935484566*r**6+79776112156*r**8+93026970796*r**10+76204922724*r**12
            +91023731860*r**14+4871010242*r**16+356010226*r**18+77379302*r**20-669162*r**22)
            +Q2**9*(64067094-227739104*r**2+4858739952*r**4-26063188616*r**6+15082461742*r**8
            +131285731232*r**10+269760550192*r**12+288521780624*r**14+69966894994*r**16
            +94738016192*r**18+9904926240*r**20+824250232*r**22-5266326*r**24)+4*Q2**8*(
            -27188853+148210107*r**2-3193587463*r**4+1840904945*r**6-25355831444*r**8
            -91331366700*r**10-186659253366*r**12-223074753254*r**14-170032057929*r**16
            -49537757529*r**18-34051328811*r**20-3125942995*r**22-217196902*r**24
            +1139122*r**26)+2*Q2**7*(13589001-78015156*r**2+4129331253*r**4-974370308*r**6
            +40637617473*r**8+141105617312*r**10+313953357093*r**12+475912252312*r**14
            +428814430691*r**16+174163415436*r**18+69688248279*r**20+22516396140*r**22
            +1797059155*r**24+53584008*r**26-17329*r**28)-2*Q2**6*(-22041141+273711003*r**2
            -576869669*r**4+6815776803*r**6+20558417167*r**8+67753520847*r**10+98991591391*r**12
            +35145916375*r**14+100212145009*r**16+158652002593*r**18-310362726783*r**20
            +20859477913*r**22-38449595979*r**24-3003498635*r**26-236180283*r**28
            +1186669*r**30)+2*Q2**5*(-19386627+301143576*r**2-2225370950*r**4+14608903732*r**6
            +16176658806*r**8+72980206168*r**10+83408696266*r**12-117980553164*r**14
            -220241464408*r**16-306323288632*r**18+270636105534*r**20-546729245636*r**22
            +19830878554*r**24-47247996984*r**26-3380448194*r**28-196095140*r**30
            +770699*r**32)+(-1+r**2)**4*(-175869+6204415*r**2-1512924*r**4+421945900*r**6
            +4606465168*r**8-34327610360*r**10+128783215300*r**12-273902663124*r**14
            +188275551790*r**16+178517770974*r**18-276261854068*r**20+132891298980*r**22
            -37846001560*r**24+2978544560*r**26-1021803892*r**28-53656828*r**30-2043945*r**32
            +5483*r**34)-2*Q2**4*(-2489451+62389293*r**2-936114714*r**4+8669676926*r**6
            -927805502*r**8+50406836130*r**10+19143398606*r**12-69977353738*r**14
            -35241008932*r**16+65585052604*r**18-455268917902*r**20+376026787674*r**22
            -255046415122*r**24+10670031406*r**26-14444337702*r**28-982839502*r**30
            -30493473*r**32+48199*r**34)-2*Q2*(-1+r**2)**2*(-836877+25548002*r**2
            -63285403*r**4+1682324776*r**6+11252451536*r**8-65925942184*r**10+200032733360*r**12
            -271388908872*r**14-126391470834*r**16+444873132508*r**18+243915749314*r**20
            -648306924776*r**22+372822322088*r**24-118482234440*r**26+12053540056*r**28
            -3631649528*r**30-202634361*r**32-9221838*r**34+27473*r**36)-4*Q2**3*(
            -2329251+47623740*r**2-121740772*r**4+1077714618*r**6+10111652448*r**8
            -23766407418*r**10+66554066004*r**12-15484272350*r**14-58668107502*r**16
            +193441289014*r**18-203794553796*r**20-56840812658*r**22+125665415496*r**24
            -85199741550*r**26+13555919388*r**28-4595189610*r**30-278348311*r**32
            -22398474*r**34+92984*r**36)+4*Q2**2*(-1555596+41161990*r**2-171742711*r**4
            +2289929711*r**6+9385125146*r**8-49810095306*r**10+145709950626*r**12
            -202649415562*r**14+114999979450*r**16-166713361958*r**18+274954747620*r**20
            +297147215908*r**22-670504780178*r**24+425666237842*r**26-142489009362*r**28
            +19457731482*r**30-4761019574*r**32-280205224*r**34-16229053*r**36+54749*r**38))
            +20901888000*logq2**5*r**18*(-21-20*r**2+26*r**4-28*r**6+3*r**8)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-552960*logq2**3*r**10*(120*Q2**13*(191
            +1215*r**4)-2*Q2**12*(114945+149594*r**2+640893*r**4+815760*r**6)+2*Q2**11*(501270
            +1246953*r**2+3324119*r**4+5880351*r**6+3938595*r**8)-Q2**10*(2450640
            +8733363*r**2+21901490*r**4+41391116*r**6+44854686*r**8+20895945*r**10)
            +5*Q2**9*(732297+3267986*r**2+8537647*r**4+16782744*r**6+22109939*r**8
            +17718246*r**10+6198405*r**12)-5*Q2**8*(713871+3515400*r**2+9513093*r**4
            +18098760*r**6+25198241*r**8+25494760*r**10+17177787*r**12+3706200*r**14)
            +2*Q2**7*(1361070+5950593*r**2+18095076*r**4+21952315*r**6+11713350*r**8
            -4085485*r**10-1521172*r**12+5075361*r**14-8726580*r**16)+2*Q2**6*(-1064610
            -3738126*r**2-19178868*r**4-12830677*r**6+27693560*r**8+93951845*r**10
            +122498884*r**12+84774437*r**14+31777578*r**16+21964185*r**18)-2*Q2**5*(
            -554895-2996613*r**2-19952325*r**4-22431966*r**6+1151024*r**8+72653040*r**10
            +129281532*r**12+127538990*r**14+83397079*r**16+31049829*r**18+16638705*r**20)
            +10*Q2**4*(82614-368973*r**2+74904*r**4-1753054*r**6-3376638*r**8+3590154*r**10
            +8989058*r**12+10410516*r**14+2630728*r**16+1957603*r**18+2456262*r**20
            +252810*r**22)-(-1+r**2)**4*(-93225-58562*r**2-4662813*r**4+6029396*r**6
            +8872890*r**8-25500796*r**10+102082*r**12-13078072*r**14+7021519*r**16
            +5399550*r**18+334011*r**20+514020*r**22)+10*Q2**3*(-209544+189850*r**2
            -5217531*r**4+495172*r**6+2685001*r**8-6908584*r**10-1630314*r**12-1554724*r**14
            -6374738*r**16+9400238*r**18+8674133*r**20-1147584*r**22+1437345*r**24)
            +Q2*(-1+r**2)**2*(-621195-10194*r**2-25985470*r**4+21639206*r**6+40219967*r**8
            -91098692*r**10-64204148*r**12-15384740*r**14-56170701*r**16+34183638*r**18
            +33054642*r**20-429378*r**22+3847065*r**24)+Q2**2*(1657500-1769073*r**2
            +56554034*r**4-61584150*r**6-29398630*r**8+157709105*r**10+57300756*r**12
            +64902092*r**14-42433840*r**16+144305745*r**18-22617190*r**20-84699318*r**22
            +13381914*r**24-11388945*r**26))*sqrtq2+384*logq2*r**2*(-23280*Q2**21*(1
            +r**4)+4*Q2**20*(82671+50830*r**2+61011*r**4+91080*r**6)-4*Q2**19*(533022
            +637987*r**2+2597*r**4+1004693*r**6+626925*r**8)+Q2**18*(8171397+13945366*r**2
            -10617230*r**4-6014620*r**6+25628289*r**8+9862950*r**10)-2*Q2**17*(10176624
            +21255351*r**2-47437097*r**4-98105078*r**6-68348862*r**8+37701655*r**10
            +11806575*r**12)+Q2**16*(33335487+74518818*r**2-520219167*r**4-1263911876*r**6
            -1888972239*r**8-1368259350*r**10+44738431*r**12+31609320*r**14)+4*Q2**15*(
            -8217936-14604381*r**2+479362718*r**4+1322572389*r**6+2361518996*r**8
            +2996921629*r**10+1741309286*r**12+106190059*r**14-1958520*r**16)-4*Q2**14*(
            -2539341+10563039*r**2+1186070504*r**4+3893451665*r**6+7723344584*r**8
            +11470085907*r**10+11190377632*r**12+5076242719*r**14+399634781*r**16
            +13450350*r**18)+4*Q2**13*(5023296+41123433*r**2+1925989830*r**4+7792219798*r**6
            +16984580144*r**8+26659759000*r**10+29820561388*r**12+23733997122*r**14
            +8435178200*r**16+680482567*r**18+25549350*r**20)-4*Q2**12*(7328139+46990671*r**2
            +1867135753*r**4+10103648292*r**6+22154130252*r**8+32446038174*r**10
            +31427524748*r**12+26776024672*r**14+23710739945*r**16+5606595323*r**18
            +505024715*r**20+16859700*r**22)-4*Q2**11*(-2500836-23344009*r**2-588917704*r**4
            -7694956849*r**6-10374414014*r**8+5704910058*r**10+48883317496*r**12
            +80549919882*r**14+56043233088*r**16+7900859535*r**18+7039125760*r**20
            +265607927*r**22+9891570*r**24)+2*Q2**10*(6532539+7400536*r**2+2036598170*r**4
            -4425707906*r**6+28157453669*r**8+162955157962*r**10+430570955380*r**12
            +679476929708*r**14+664916050389*r**16+383741706748*r**18+106098742018*r**20
            +41002541494*r**22+2008482619*r**24+57025410*r**26)-4*Q2**9*(3866616
            +16494686*r**2+1599077001*r**4+1571010586*r**6+28326943262*r**8+120263926448*r**10
            +300837633723*r**12+502404009044*r**14+581685128788*r**16+452702426662*r**18
            +210935087135*r**20+61751970850*r**22+19215084646*r**24+922015484*r**26
            +20688525*r**28)+2*Q2**8*(912033+42283644*r**2+2000437375*r**4+4960453048*r**6
            +50773713213*r**8+188270966716*r**10+428513409651*r**12+617494280192*r**14
            +720796879163*r**16+678898648676*r**18+413543903557*r**20+28994040184*r**22
            +44235199207*r**24+4049638980*r**26+234348361*r**28-2701200*r**30)+4*Q2**7*(2002464
            -22109919*r**2-208659702*r**4-2635199053*r**6-20126135604*r**8-64203039039*r**10
            -126281051602*r**12-57693777925*r**14+80098584904*r**16+160665906635*r**18
            +128893013574*r**20+103774455425*r**22+220357997036*r**24+17737344723*r**26
            +13617952578*r**28+537062225*r**30+13735200*r**32)+(-1+r**2)**6*(7767
            -209264*r**2-7168048*r**4-41837248*r**6-1514131292*r**8+5810282664*r**10
            -20850323600*r**12+36214505296*r**14+31777403946*r**16-129485375496*r**18
            +56350412336*r**20+17291841952*r**22-13102397468*r**24+6347188952*r**26
            +164204688*r**28+155181008*r**30+3965687*r**32+48120*r**34)-4*Q2**6*(1647351
            -14352831*r**2+117544484*r**4-2396871489*r**6-15528829330*r**8-50224376909*r**10
            -96731471812*r**12+1280532399*r**14+119395271172*r**16+287703612373*r**18
            +324683049868*r**20+228431693765*r**22+96117974722*r**24+249999556697*r**26
            +22135234132*r**28+14069643725*r**30+528913813*r**32+10223070*r**34)
            -2*Q2*(-1+r**2)**4*(47136-1120867*r**2-29305005*r**4-186778536*r**6
            -5949184412*r**8+17475296892*r**10-61504054904*r**12+81529098888*r**14
            +114367967172*r**16-176339299026*r**18-248800387802*r**20+169628489064*r**22
            +69510987084*r**24-53855086276*r**26+27670686288*r**28+381341624*r**30
            +761677932*r**32+20939133*r**34+285615*r**36)+4*Q2**5*(278460-929313*r**2
            +130513082*r**4-1101912826*r**6-2720462752*r**8-28925807046*r**10-10828837304*r**12
            +42112541462*r**14+15725112352*r**16+65890527248*r**18+102479034900*r**20
            +54386760514*r**22+46736809296*r**24-20357624906*r**26+87753763704*r**28
            +8977095586*r**30+4654503028*r**32+163434785*r**34+1833330*r**36)+4*Q2**4*(388422
            -7098663*r**2-106574148*r**4-224987056*r**6-12004037354*r**8+24166375880*r**10
            -98014573870*r**12+10566363668*r**14+41326120490*r**16-86202866542*r**18
            -37669624366*r**20-77500515036*r**22+155705403218*r**24+139051578208*r**26
            -80394636554*r**28+63652848764*r**30-3521821656*r**32+2318473837*r**34
            +80172458*r**36+2178300*r**38)+Q2**2*(-1+r**2)**2*(486573-10381292*r**2
            -194321531*r**4-1317957546*r**6-38150370636*r**8+97563842736*r**10-355932844172*r**12
            +440694522168*r**14+331051253942*r**16-430400593928*r**18-594909461146*r**20
            -1017050328940*r**22+695705559492*r**24+569910692784*r**26-425472619836*r**28
            +201379402712*r**30-1805674971*r**32+6204334996*r**34+184372445*r**36
            +2886150*r**38)-4*Q2**3*(327318-6474966*r**2-83146165*r**4-522777708*r**6
            -15354507471*r**8+42893086308*r**10-153157340564*r**12+205301715028*r**14
            +5598332816*r**16-177698390632*r**18-4561137910*r**20+43442445196*r**22
            -380066562306*r**24+59286238332*r**26+344003481852*r**28-236238546916*r**30
            +94186854434*r**32-4439218082*r**34+3130292035*r**36+101028976*r**38
            +1900425*r**40))*sqrtq2))/(-88179840000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-1224720000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-850500*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5+211631616000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+14696640000*logq2**3*(-Q2+(-1
            +r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+51030000*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(16*(Q2-(-1+r)**2)**6*r**6*(Q2-(1+r)**2)**6*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))**2*(62232*Q2**19+16*Q2**18*(-2593+2271*r**2)+Q2**17*(3907651
            +9883414*r**2-5552457*r**4)+Q2**16*(-51624037-739054895*r**2-130022203*r**4
            +39676623*r**6)+Q2**15*(247408502+6556582914*r**2+7997392740*r**4+737829650*r**6
            -141917934*r**8)+Q2**14*(-592453826-24107596196*r**2-59848341690*r**4
            -35100616194*r**6-2325188228*r**8+308553894*r**10)+Q2**13*(668936954
            +39210613366*r**2+175875473402*r**4+199522801692*r**6+78087051014*r**8
            +4355532206*r**10-424388538*r**12)+2*Q2**12*(27944761-761592234*r**2
            -93796604292*r**4-146679883751*r**6-141600566299*r**8-41848043276*r**10
            -2305641050*r**12+174084573*r**14)-2*Q2**11*(578884657+49476466183*r**2
            +80444794176*r**4+267050716009*r**6+184985042040*r**8-46177543167*r**10
            -4873313236*r**12-913345313*r**14+60809307*r**16)+2*Q2**10*(642594667
            +70805641346*r**2+306984257737*r**4+1044262429687*r**6+1634627453695*r**8
            +740706147507*r**10+89052340259*r**12+35015809701*r**14+600193066*r**16
            -17100369*r**18)+2*Q2**9*(-47462272-6861936279*r**2-239089473630*r**4
            -757928003536*r**6-2897509574552*r**8-2273426394598*r**10-695649752764*r**12
            -109091036840*r**14-24167094736*r**16-400261147*r**18+5063058*r**20)
            +2*Q2**8*(-475566572-79280539745*r**2-100786408377*r**4-1161469716852*r**6
            +1982891469576*r**8+2503697638230*r**10+1532616347902*r**12+423981870888*r**14
            +137037896388*r**16-16255347989*r**18-830048549*r**20+31167084*r**22)
            -2*Q2**7*(-351281489-75844733947*r**2-273800179802*r**4-2273794172967*r**6
            +184548640647*r**8+1768881759450*r**10+2741790248572*r**12+1933987263562*r**14
            +687439903413*r**16+212473489297*r**18-25370416018*r**20-980688179*r**22
            +23879973*r**24)+2*Q2**6*(67285757+2679181746*r**2-141581847291*r**4
            -607194228139*r**6-1590488477460*r**8+2632298913585*r**10+3293127485834*r**12
            +4015780085906*r**14+2010469309957*r**16+630338952260*r**18+88382381169*r**20
            -3200607207*r**22+44949266*r**24-6764583*r**26)+2*Q2**5*(-216020237-47887709663*r**2
            -13242095049*r**4-1623224271114*r**6+4682121773611*r**8-6265131450813*r**10
            +2765997833895*r**12-3425311604476*r**14-534601626831*r**16-630842321497*r**18
            -38127470387*r**20+158736047046*r**22-9406252047*r**24-650834507*r**26
            +16407189*r**28)+2*Q2**4*(92785319+27877077502*r**2+41981591300*r**4
            +1579998191583*r**6-5600201884459*r**8+9890948840816*r**10-12353840984394*r**12
            +1275562389685*r**14+4091628115729*r**16-1125250617482*r**18+626455129656*r**20
            -106083220663*r**22-180522868365*r**24+4679092508*r**26+347599886*r**28
            -5958621*r**30)-2*Q2**3*(-19896089-2224955019*r**2+27694358124*r**4+119368295719*r**6
            -1005828111142*r**8+3545387027173*r**10-9473282741024*r**12+8130197745487*r**14
            -1931084071828*r**16+6357837867799*r**18-42950587844*r**20+534851037485*r**22
            -39292661186*r**24-23199197041*r**26-368625032*r**28-65105315*r**30+2339733*r**32)
            +(-1+r**2)**2*(-2745987-1036189629*r**2+1742587638*r**4-121792936366*r**6
            +1056161819402*r**8-5457242276498*r**10+17284869005038*r**12-29454160410342*r**14
            +22849907997252*r**16-3823666128204*r**18-2004877115838*r**20-230323418154*r**22
            -455607732890*r**24-98712714686*r**26+8809815002*r**28+37086398*r**30
            -13792305*r**32+206169*r**34)+2*Q2**2*(-31611263-8756142170*r**2+19798725231*r**4
            -573421073291*r**6+3314172426471*r**8-9949843489479*r**10+14649165408619*r**12
            -5870975365831*r**14+1335230892477*r**16-1700485523767*r**18-3223124797603*r**20
            -249626399313*r**22-641096525491*r**24-199015333461*r**26+51707243721*r**28
            -597690205*r**30-134185586*r**32+2656941*r**34)+Q2*(22063837+7285826144*r**2
            -19559516963*r**4+677677397848*r**6-5417724322700*r**8+23748072928536*r**10
            -61284148676876*r**12+79180474904376*r**14-38090515335754*r**16-2183501452360*r**18
            -6506877972938*r**20+10500546467720*r**22-536260046908*r**24+1352519572424*r**26
            +411601921860*r**28-56110644760*r**30+22000437*r**32+104390920*r**34
            -1728843*r**36))-16*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(62232*Q2**20-8*Q2**19*(12965
            +3237*r**2)+Q2**18*(3949139+9888566*r**2-5588793*r**4)+8*Q2**17*(-6941461
            -94105745*r**2-16794145*r**4+5653635*r**6)+Q2**16*(299032539+7347261846*r**2
            +8866469838*r**4+828175230*r**6-181594557*r**8)+4*Q2**15*(-209965582
            -7727896903*r**2-18600579336*r**4-10958959646*r**6-730274986*r**8+112617957*r**10)
            +4*Q2**14*(315347695+15977665847*r**2+64957852822*r**4+73617939894*r**6
            +28878213859*r**8+1593041635*r**10-183235608*r**12)+4*Q2**13*(-153261858
            -10350683697*r**2-100669823838*r**4-167189510649*r**6-140202746326*r**8
            -41534667443*r**10-2135606442*r**12+193139421*r**14)-4*Q2**12*(303414709
            +24371409355*r**2-7056701175*r**4+13287113983*r**6-51647704005*r**8-114813076371*r**10
            -24513498781*r**12-1522450895*r**14+117446940*r**16)+4*Q2**11*(610739662
            +60430496093*r**2+218452759048*r**4+695878969936*r**6+1043331605872*r**8
            +439756823190*r**10+19000741928*r**12+14614575576*r**14-126171470*r**16
            +21854469*r**18)+2*Q2**10*(-690056939-78310172292*r**2-616879372713*r**4
            -2109174690960*r**6-5576399457934*r**8-4648759995800*r**10-1525408240530*r**12
            -233159186800*r**14-59783097503*r**16-983353844*r**18+22163427*r**20)
            +4*Q2**9*(-214052150-36185570597*r**2+72582500766*r**4-82226119843*r**6
            +2819164523832*r**8+3837316803690*r**10+2250846247632*r**12+614361330246*r**14
            +135148013982*r**16+4156003947*r**18-217425230*r**20+13052013*r**22)
            -2*Q2**8*(-826848061-155600840264*r**2-453867127924*r**4-3536050298196*r**6
            +1005970393371*r**8+6255470867256*r**10+6778104234704*r**12+3890585482352*r**14
            +1248459670689*r**16+333256037696*r**18-42455812556*r**20-1779569644*r**22
            +55047057*r**24)+4*Q2**7*(-141997866-36758416845*r**2-245613380520*r**4
            -1577394290454*r**6-1839867004890*r**8+2292864656841*r**10+3901899746928*r**12
            +4345778799020*r**14+2315948238466*r**16+765126172485*r**18+137742727224*r**20
            -14775855702*r**22-455929470*r**24+8557695*r**26)+4*Q2**6*(-141652997
            -25317088583*r**2+62830285248*r**4-437224097842*r**6+3439902239605*r**8
            -3653470943469*r**10-1579714282762*r**12-5367109588108*r**14-3280425511347*r**16
            -1635825291857*r**18-378424401908*r**20+36777136542*r**22-3125297053*r**24
            -344509595*r**26+11585886*r**28)-4*Q2**5*(-154402778-37990403701*r**2
            -51555698006*r**4-1608232278873*r**6+4329549693478*r**8-5736979259009*r**10
            +4427353683738*r**12-967438080133*r**14-4025770673518*r**16-20096665423*r**18
            -647712460770*r**20+113345898661*r**22+164926331682*r**24-7368089531*r**26
            -491013602*r**28+11182905*r**30)+4*Q2**4*(-36444615-12872453901*r**2
            -48776513463*r**4-870674039301*r**6+2513015902009*r**8-3918066991765*r**10
            +5968087442301*r**12+1474040424611*r**14-1718053216793*r**16-4662107683023*r**18
            +270873037835*r**20-527611473239*r**22+162949375107*r**24+99521486449*r**26
            -2329033681*r**28-138267975*r**30+1809444*r**32)+4*Q2**3*(-25753676-5500496639*r**2
            +22634064168*r**4-213179209724*r**6+1213856305524*r**8-3705142286724*r**10
            +4360634847384*r**12-3607030180684*r**14+3767172283068*r**16+1363134136102*r**18
            +1545881241176*r**20+121137025164*r**22-72769074596*r**24-130753595844*r**26
            +14069710824*r**28-515710276*r**30-98475584*r**32+2498337*r**34)+Q2**2*(85286363
            +24861333010*r**2-41644683085*r**4+1784922093968*r**6-10899227029060*r**8
            +37019415054552*r**10-70682792515156*r**12+61624094818800*r**14-29019026389046*r**16
            -1452992189780*r**18+3340342669802*r**20+17446048861552*r**22+1245185802700*r**24
            +3032743290328*r**26+706218101340*r**28-158329751792*r**30+1485752019*r**32
            +367448210*r**34-7042725*r**36)-(-1+r**2)**2*(-2745987-1038935616*r**2
            +706398009*r**4-120050348728*r**6+934368883036*r**8-4401080457096*r**10
            +11827626728540*r**12-12169291405304*r**14-6604252413090*r**16+19026241869048*r**18
            -5828543244042*r**20-2235200533992*r**22-685931151044*r**24-554320447576*r**26
            -89902899684*r**28+8846901400*r**30+23294093*r**32-13586136*r**34+206169*r**36)
            +4*Q2*(-6202456-2084646909*r**2+4021477932*r**4-196108045539*r**6+1510384301156*r**8
            -6505426864376*r**10+16697897781444*r**12-21844366731104*r**14+14488284563588*r**16
            -9675906436234*r**18+9295685640780*r**20-1009475952366*r**22-2991031108308*r**24
            -58520048144*r**26-503373495700*r**28-117946633848*r**30+16202623556*r**32
            -15378545*r**34-29216680*r**36+483753*r**38))*sqrtq2+logq2**7*(-112870195200000*r**34*(1
            +r**2)**2*(1-Q2+r**2)*(-2593-6210*r**2+10851*r**4)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3-112870195200000*(Q2-(-1+r)**2)**2*r**34*(1+r**2)**2*(
            -2593-6210*r**2+10851*r**4)*(Q2-(1+r)**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2**6*(-627056640000*r**28*(1+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(72480*Q2**8*(1+r**2)-240*Q2**7*(2416+4287*r**2+1871*r**4)
            +8*Q2**6*(244167+572366*r**2+382503*r**4+25368*r**6)+Q2**5*(-3411996
            -9194269*r**2-6839167*r**4+1039917*r**6+2096811*r**8)+Q2**4*(2790480
            +8488983*r**2+4977724*r**4-6402258*r**6-7935948*r**8-2717445*r**10)
            +Q2**3*(126840-2253772*r**2-677498*r**4+6156226*r**6+11604794*r**8+2845962*r**10
            -4305720*r**12)+3*(-1+r**2)**2*(-128048+177923*r**2+178036*r**4-2840071*r**6
            -1194336*r**8+3335677*r**10+1078556*r**12+1112583*r**14)+2*Q2**2*(-1078140
            -54496*r**2+784519*r**4-3166224*r**6-2232254*r**8+2008604*r**10+4053171*r**12
            +6443220*r**14)-3*Q2*(-529708+618845*r**2+679169*r**4-6494225*r**6
            -8858877*r**8+8225011*r**10+8441983*r**12+1091009*r**14+3708073*r**16))
            +627056640000*r**28*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(72480*Q2**9*(1
            +r**2)-240*Q2**8*(2718+4891*r**2+2173*r**4)+8*Q2**7*(316647+773456*r**2
            +567243*r**4+81498*r**6)+Q2**6*(-5365332-15726533*r**2-14478119*r**4
            -2223051*r**6+1893867*r**8)-4*Q2**5*(-1550619-5273812*r**2-5252790*r**4
            +150752*r**6+2768169*r**8+1203564*r**10)-5*Q2**4*(532728+2706647*r**2
            +2828841*r**4-1516152*r**6-5188600*r**8-2699871*r**10+317655*r**12)
            +4*Q2**3*(-570780+504485*r**2+1125077*r**4-2952794*r**6-5556382*r**8
            -2608387*r**10+2391525*r**12+4298040*r**14)+Q2**2*(3745404+408737*r**2
            -3497553*r**4+24246085*r**6+37373587*r**8-24227733*r**10-37449499*r**12
            -24265809*r**14-24010659*r**16)-3*(-1+r**2)**2*(-128048+49875*r**2+355959*r**4
            -2662035*r**6-4034407*r**8+2141341*r**10+4414233*r**12+2191139*r**14
            +1112583*r**16)+12*Q2*(-164439+130789*r**2+248039*r**4-2208319*r**6
            -2672315*r**8+562603*r**10+2469965*r**12+2956035*r**14+913118*r**16
            +1205164*r**18))*sqrtq2)+logq2**5*(-497664000*r**24*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-8117760*Q2**12*(1+r**2)+480*Q2**11*(74581
            +118642*r**2+44061*r**4)-8*Q2**10*(-7190208-7515241*r**2+1009134*r**4
            +523959*r**6)+840*Q2**9*(-852531-1527218*r**2-21788*r**4+1118178*r**6
            +465279*r**8)-15*Q2**8*(-128195868-260392699*r**2+61101532*r**4+543016714*r**6
            +487736864*r**8+138018513*r**10)+20*Q2**7*(-98513109-245555588*r**2+17251035*r**4
            +832827960*r**6+1242569689*r**8+771469452*r**10+197434209*r**12)-60*Q2**6*(12760125
            -26853372*r**2-239368311*r**4-281825058*r**6+136056367*r**8+373698048*r**10
            +197636523*r**12+48546750*r**14)-12*Q2**5*(-325935561-93164337*r**2+3582234173*r**4
            +8064112953*r**6+5561114925*r**8-925088191*r**10-2166437357*r**12-335149577*r**14
            +59734668*r**16)+10*Q2**4*(-336151386+105573467*r**2+4786965564*r**4
            +10811293002*r**6+6483666488*r**8-5481820518*r**10-9643741908*r**12-5102431126*r**14
            -618401862*r**16+287868759*r**18)-60*Q2**3*(-861083+25538826*r**2+143873345*r**4
            +393436184*r**6-16628882*r**8-1497263848*r**10-2234438710*r**12-820849088*r**14
            +156026885*r**16-13062266*r**18+39828253*r**20)+420*Q2**2*(3995407-5798934*r**2
            -57533779*r**4-28423306*r**6+27885794*r**8-53678422*r**10-112458394*r**12
            -6130594*r**14+288002975*r**16+295212268*r**18+39554141*r**20+3080364*r**22)
            +9*(-1+r**2)**2*(23344656-83551371*r**2-447101346*r**4+659634641*r**6
            +37252208*r**8-4054632442*r**10-2113323436*r**12+1722824846*r**14+3796582784*r**16
            +4116246917*r**18+663435086*r**20+14493857*r**22)-180*Q2*(5809421-19634839*r**2
            -91323651*r**4+103237965*r**6+67589778*r**8-718598466*r**10-506139186*r**12
            +568840326*r**14+341791821*r**16+398678713*r**18+612672181*r**20+100996941*r**22
            +3120276*r**24))+497664000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(8117760*Q2**12*(1
            +r**2)-480*Q2**11*(74581+118642*r**2+44061*r**4)+8*Q2**10*(-7190208
            -7515241*r**2+1009134*r**4+523959*r**6)-840*Q2**9*(-852531-1527218*r**2
            -21788*r**4+1118178*r**6+465279*r**8)+15*Q2**8*(-128195868-260392699*r**2
            +61101532*r**4+543016714*r**6+487736864*r**8+138018513*r**10)-20*Q2**7*(
            -98513109-245555588*r**2+17251035*r**4+832827960*r**6+1242569689*r**8
            +771469452*r**10+197434209*r**12)+60*Q2**6*(12760125-26853372*r**2-239368311*r**4
            -281825058*r**6+136056367*r**8+373698048*r**10+197636523*r**12+48546750*r**14)
            +12*Q2**5*(-325935561-93164337*r**2+3582234173*r**4+8064112953*r**6+5561114925*r**8
            -925088191*r**10-2166437357*r**12-335149577*r**14+59734668*r**16)-10*Q2**4*(
            -336151386+105573467*r**2+4786965564*r**4+10811293002*r**6+6483666488*r**8
            -5481820518*r**10-9643741908*r**12-5102431126*r**14-618401862*r**16+287868759*r**18)
            +60*Q2**3*(-861083+25538826*r**2+143873345*r**4+393436184*r**6-16628882*r**8
            -1497263848*r**10-2234438710*r**12-820849088*r**14+156026885*r**16-13062266*r**18
            +39828253*r**20)-420*Q2**2*(3995407-5798934*r**2-57533779*r**4-28423306*r**6
            +27885794*r**8-53678422*r**10-112458394*r**12-6130594*r**14+288002975*r**16
            +295212268*r**18+39554141*r**20+3080364*r**22)-9*(-1+r**2)**2*(23344656
            -83551371*r**2-447101346*r**4+659634641*r**6+37252208*r**8-4054632442*r**10
            -2113323436*r**12+1722824846*r**14+3796582784*r**16+4116246917*r**18
            +663435086*r**20+14493857*r**22)+180*Q2*(5809421-19634839*r**2-91323651*r**4
            +103237965*r**6+67589778*r**8-718598466*r**10-506139186*r**12+568840326*r**14
            +341791821*r**16+398678713*r**18+612672181*r**20+100996941*r**22+3120276*r**24))*sqrtq2)
            +logq2**4*(8294400*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-10823680*Q2**16
            -25600*Q2**15*(3429+4192*r**2)+64*Q2**14*(31845813+45302580*r**2+14726399*r**4)
            -8*Q2**13*(1596518416+3320025681*r**2+2025606898*r**4+294534033*r**6)
            +16*Q2**12*(2510831907+7527891328*r**2+7773190798*r**4+2947557044*r**6
            +218210691*r**8)-Q2**11*(65312085768+297980218007*r**2+475115471676*r**4
            +329707614894*r**6+99140177116*r**8+9474052059*r**10)+Q2**10*(28949383872
            +372358014127*r**2+919431799723*r**4+966413652538*r**6+505836900738*r**8
            +150875200151*r**10+29203632531*r**12)-Q2**9*(-86407768536+68696444915*r**2
            +675273339032*r**4+1194830645725*r**6+1083264898480*r**8+528777117989*r**10
            +171767390800*r**12+53662515147*r**14)+Q2**8*(-165488430144-454086836669*r**2
            -577852468977*r**4+225213502413*r**6+1874561576865*r**8+2268789907981*r**10
            +1082098284801*r**12+233157528803*r**14+56115516303*r**16)-2*Q2**7*(-42933205688
            -306480588437*r**2-713126946812*r**4-322265382326*r**6+1658095831156*r**8
            +3450037664342*r**10+2835378175748*r**12+1134046411458*r**14+183113895164*r**16
            +14002828531*r**18)+Q2**6*(71553970176-249741393706*r**2-490742146538*r**4
            -265768535692*r**6+1120387069332*r**8+5678645966764*r**10+8471798604284*r**12
            +5436843549012*r**14+1973957953108*r**16+334446336182*r**18-8852814842*r**20)
            +2*Q2**5*(-61283289672-74598100807*r**2-518494000768*r**4+239703586167*r**6
            +3961357371072*r**8+4962558211012*r**10+321558730272*r**12-2392508693268*r**14
            -928903694888*r**16-42755305773*r**18-25041176816*r**20+13989096269*r**22)
            -2*Q2**4*(-25138228216-116224332635*r**2-534580164723*r**4+911713049575*r**6
            +5982259406215*r**8+8010690433012*r**10+1454440521580*r**12-5675084848604*r**14
            -5644259469020*r**16-1583727692185*r**18+308954562759*r**20+80819402485*r**22
            +10288655757*r**24)+3*Q2**3*(6217266824-40668887761*r**2+21340578412*r**4
            +423187846542*r**6+955050885100*r**8+997221241997*r**10-1861632880888*r**12
            -6118579962364*r**14-5060431140304*r**16-1557264613575*r**18-700915607796*r**20
            +144914171374*r**22+48309663452*r**24+454126987*r**26)+9*(-1+r**2)**2*(
            -147997792-471119441*r**2-7144965583*r**4+36428470292*r**6+66803706404*r**8
            -130271444041*r**10-48831668063*r**12+303407306776*r**14+459656344856*r**16
            -118279157563*r**18-724825620117*r**20-235801649196*r**22-33295170268*r**24
            -871687723*r**26+124011459*r**28)+3*Q2**2*(-8726247296+9066552201*r**2
            -203664923339*r**4+339471769998*r**6+1616549837382*r**8+222700362847*r**10
            -373055356797*r**12+1869163574148*r**14+1781221297044*r**16-4046137836409*r**18
            -6765298856901*r**20-1738814753554*r**22-297859974234*r**24-24922553967*r**26
            +2730148877*r**28)-9*Q2*(-1092370808-182028257*r**2-37349585896*r**4
            +165204580521*r**6+272041637264*r**8-506937221813*r**10+254189879184*r**12
            +1073661246877*r**14-193893660792*r**16+405685580237*r**18-329749047720*r**20
            -2061900364277*r**22-669192855456*r**24-101104737079*r**26-4058430976*r**28
            +594818991*r**30))+8294400*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(10823680*Q2**17
            +5120*Q2**16*(15031+18846*r**2)-64*Q2**15*(33217413+48350980*r**2+16403199*r**4)
            +40*Q2**14*(370256984+787442565*r**2+501167746*r**4+82469045*r**6)-8*Q2**13*(6618182230
            +19972326753*r**2+20892014175*r**4+8215255019*r**6+730955415*r**8)+Q2**12*(105485396280
            +458599789767*r**2+719932785692*r**4+501239580366*r**6+149792460876*r**8
            +12965423115*r**10)-2*Q2**11*(47130734820+367825158951*r**2+846263744703*r**4
            +885618369554*r**6+467342346374*r**8+129744714663*r**10+19338842295*r**12)
            +2*Q2**10*(-28729192332+235001921457*r**2+983531576441*r**4+1540338048993*r**6
            +1277757725878*r**8+592744609439*r**10+175923111741*r**12+41433073839*r**14)
            -10*Q2**9*(-25189619868-47179816029*r**2+16611731497*r**4+209531748717*r**6
            +415265712107*r**8+388083192445*r**10+178264279359*r**12+45858743475*r**14
            +10977803145*r**16)+Q2**8*(-251354841520-1232536443687*r**2-2458193199270*r**4
            -997169731216*r**6+5415966741590*r**8+11043426813530*r**10+9021644544278*r**12
            +3583348636520*r**14+655500835434*r**16+84121173365*r**18)-4*Q2**7*(-3578110300
            -237142245489*r**2-632489304259*r**4-584138298492*r**6+948011991748*r**8
            +3973728239440*r**10+5260657571116*r**12+3343923180856*r**14+1152069641588*r**16
            +182169945893*r**18+4788210555*r**20)-4*Q2**6*(-48530137380+7247805479*r**2
            -74126115323*r**4+308979463641*r**6+1767024052126*r**8+781520846482*r**10
            -3376831777626*r**12-4673414884958*r**14-2317152222974*r**16-598478725209*r**18
            -93918968743*r**20+9207751845*r**22)+4*Q2**5*(-43210758944-126052861557*r**2
            -563836133149*r**4+316461317487*r**6+5091660181727*r**8+8467303007548*r**10
            +3369278731432*r**12-3873017405800*r**14-4482835928588*r**16-1277693346423*r**18
            +120579040085*r**20+34883660969*r**22+12138876013*r**24)-5*Q2**4*(-6324931192
            -80946356997*r**2-247517451896*r**4+404765861866*r**6+3330619513376*r**8
            +6195512680889*r**10+2669072653304*r**12-5359405708228*r**14-7563996411232*r**16
            -3825553632627*r**18-930458616448*r**20+242858088922*r**22+65429021368*r**24
            +4387938495*r**26)-6*Q2**3*(-7471757060+21759086569*r**2-92168306995*r**4
            -52528327478*r**6+119155552870*r**8-864785882125*r**10+245678141047*r**12
            +4924688208700*r**14+6480116199856*r**16+1285778958735*r**18-2253559317765*r**20
            -591406658566*r**22-245541904530*r**24-36843172203*r**26+1138010945*r**28)
            +9*(-1+r**2)**2*(-147997792-619117233*r**2-7616085024*r**4+29283504709*r**6
            +103232176696*r**8-63467737637*r**10-179103112104*r**12+254575638713*r**14
            +763063651632*r**16+341377187293*r**18-843104777680*r**20-960627269313*r**22
            -269096819464*r**24-34166857991*r**26-747676264*r**28+124011459*r**30)
            +6*Q2**2*(-6001679860-102889933*r**2-153323564413*r**4+315710294111*r**6
            +1386073259586*r**8+159219267395*r**10+306107321801*r**12+2358545978991*r**14
            +1534351944408*r**16-523929899327*r**18-5900341918235*r**20-7344907351643*r**22
            -2022126647078*r**24-313048369719*r**26-17183849009*r**28+2257302925*r**30)
            -18*Q2*(-620184300-724761461*r**2-21941169323*r**4+89051138321*r**6
            +212024009011*r**8-231172985553*r**10+12883791897*r**12+799325162461*r**14
            +341888824663*r**16-261196310527*r**18+23662786191*r**20-648039489261*r**22
            -1508805355863*r**24-470190294459*r**26-68295475709*r**28-2291661313*r**30
            +359415225*r**32))*sqrtq2)+logq2**3*(-138240*r**16*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(-257751040*Q2**19+512*Q2**18*(11271524
            +7716081*r**2)-64*Q2**17*(724795571+1138870610*r**2+420829279*r**4)+16*Q2**16*(11756142744
            +30783773591*r**2+25219791014*r**4+6520365831*r**6)-16*Q2**15*(25441385053
            +105280053088*r**2+140037193770*r**4+76855741272*r**6+15537041457*r**8)
            +Q2**14*(354038474600+3062747592915*r**2+6138125084188*r**4+5384729538022*r**6
            +2222689578940*r**8+377630840455*r**10)-2*Q2**13*(-190427886908+1072862713213*r**2
            +3753994851781*r**4+5091567433070*r**6+3669065184914*r**8+1273486110997*r**10
            +188470478053*r**12)+Q2**12*(-1301339490288-2581879946295*r**2-3581638741534*r**4
            -2728571204845*r**6+3392636885260*r**8+5630293206079*r**10+2198136635010*r**12
            +254906916453*r**14)-4*Q2**11*(-263660931192-1875307795233*r**2-6660494000459*r**4
            -14425226712081*r**6-14177273223555*r**8-5253338803259*r**10+72384967559*r**12
            +419828739693*r**14+18077641407*r**16)-Q2**10*(-510302322424+6672120936141*r**2
            +34333211430352*r**4+122054331835968*r**6+192120395363208*r**8+139457980909362*r**10
            +49197945596672*r**12+8327557567688*r**14-333406210656*r**16+162273716729*r**18)
            +2*Q2**9*(-759718556540-146344821015*r**2-756353073563*r**4+43185374832568*r**6
            +121780574674840*r**8+134991689180970*r**10+76563766024730*r**12+26424613856672*r**14
            +8175637878428*r**16+910897435285*r**18+147468348105*r**20)-Q2**8*(-758308229504
            -6863811909761*r**2-52283842173774*r**4-69000247394865*r**6+43767485704024*r**8
            +221340907734374*r**10+281769383008156*r**12+171358661173646*r**14+59407151148280*r**16
            +19073769636219*r**18+2704629811426*r**20+116692736579*r**22)-8*Q2**7*(
            -60110735526+849210885805*r**2+6303333139383*r**4+21309586724715*r**6
            +22406136544395*r**8-17800917739186*r**10-74948017293190*r**12-85546327258374*r**14
            -48078284487060*r**16-13935459310955*r**18-2262861387553*r**20-204917940725*r**22
            +21305156511*r**24)+Q2**6*(-663743454248+1104637345393*r**2-5279059121044*r**4
            +106836318820334*r**6+109385903706060*r**8-157964203124613*r**10-631443413064712*r**12
            -1053887506281708*r**14-869700632794512*r**16-411438469061465*r**18-116698750984804*r**20
            -10983718354946*r**22-137155345428*r**24+184350896493*r**26)+2*Q2**5*(64093745348
            +1693681572453*r**2+20119454339957*r**4+1148378624146*r**6+42462398166606*r**8
            -33931672937637*r**10-242260978086797*r**12-66269958768260*r**14+205439548831672*r**16
            +141644053532987*r**18+34304600690779*r**20+12577173672434*r**22-1801447873482*r**24
            -436758385403*r**26+2290859197*r**28)+Q2**4*(156003229520-2885541619885*r**2
            -23247716194562*r**4-41833833197483*r**6-85793660034020*r**8+382862913474115*r**10
            +1236364485334210*r**12+1049959330407069*r**14-252908731044264*r**16-954475041328895*r**18
            -450265228122110*r**20+17674450600775*r**22+28630124292668*r**24+11008320987497*r**26
            +1022216060990*r**28-84151725625*r**30)+12*Q2**3*(-7097822384+27142506339*r**2
            -239024459351*r**4+2895586227975*r**6-4616180165779*r**8-18972288744481*r**10
            -26166276296339*r**12-8277937747933*r**14+81278187793265*r**16+129753830552473*r**18
            +81153609415979*r**20+42828414257701*r**22+2617004171159*r**24-1584802769115*r**26
            -419644501569*r**28-25077948239*r**30+2424970299*r**32)+9*(-1+r**2)**2*(
            -262835808+7152098011*r**2+55778651192*r**4-19233651660*r**6+1176940191200*r**8
            -5720418346096*r**10-9045728751128*r**12+24776797644724*r**14+21945262431920*r**16
            -60943707253250*r**18-43046008184184*r**20+58757412548348*r**22+29259429563776*r**24
            +7798980395240*r**26+1045876563800*r**28-30753053412*r**30-6499367856*r**32
            +219755183*r**34)+3*Q2**2*(-1036850792+240911004675*r**2+2662991940568*r**4
            -6746791679420*r**6+37891851859200*r**8-57118511680944*r**10-158576317396440*r**12
            -6210473412764*r**14-72500245329760*r**16-168646677572050*r**18+210150291540264*r**20
            +548284361775980*r**22+190900457865824*r**24+54306446560680*r**26+9191866896600*r**28
            -334536011028*r**30-104223250840*r**32+4552140247*r**34)-18*Q2*(-654577532
            +22489554217*r**2+168968936237*r**4-412128411172*r**6+3411165619860*r**8
            -13196555018584*r**10-11878077822016*r**12+23567410733644*r**14+8034557569996*r**16
            -232428153870*r**18-61330005328686*r**20-33609817779244*r**22+85189883218076*r**24
            +39765204567424*r**26+10925140294760*r**28+1674669058052*r**30-62760872832*r**32
            -15186064707*r**34+601276377*r**36))+138240*r**16*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(257751040*Q2**19-512*Q2**18*(11271524+7716081*r**2)
            +64*Q2**17*(724795571+1138870610*r**2+420829279*r**4)-16*Q2**16*(11756142744
            +30783773591*r**2+25219791014*r**4+6520365831*r**6)+16*Q2**15*(25441385053
            +105280053088*r**2+140037193770*r**4+76855741272*r**6+15537041457*r**8)
            -Q2**14*(354038474600+3062747592915*r**2+6138125084188*r**4+5384729538022*r**6
            +2222689578940*r**8+377630840455*r**10)+2*Q2**13*(-190427886908+1072862713213*r**2
            +3753994851781*r**4+5091567433070*r**6+3669065184914*r**8+1273486110997*r**10
            +188470478053*r**12)+Q2**12*(1301339490288+2581879946295*r**2+3581638741534*r**4
            +2728571204845*r**6-3392636885260*r**8-5630293206079*r**10-2198136635010*r**12
            -254906916453*r**14)+4*Q2**11*(-263660931192-1875307795233*r**2-6660494000459*r**4
            -14425226712081*r**6-14177273223555*r**8-5253338803259*r**10+72384967559*r**12
            +419828739693*r**14+18077641407*r**16)+Q2**10*(-510302322424+6672120936141*r**2
            +34333211430352*r**4+122054331835968*r**6+192120395363208*r**8+139457980909362*r**10
            +49197945596672*r**12+8327557567688*r**14-333406210656*r**16+162273716729*r**18)
            -2*Q2**9*(-759718556540-146344821015*r**2-756353073563*r**4+43185374832568*r**6
            +121780574674840*r**8+134991689180970*r**10+76563766024730*r**12+26424613856672*r**14
            +8175637878428*r**16+910897435285*r**18+147468348105*r**20)+Q2**8*(-758308229504
            -6863811909761*r**2-52283842173774*r**4-69000247394865*r**6+43767485704024*r**8
            +221340907734374*r**10+281769383008156*r**12+171358661173646*r**14+59407151148280*r**16
            +19073769636219*r**18+2704629811426*r**20+116692736579*r**22)+8*Q2**7*(
            -60110735526+849210885805*r**2+6303333139383*r**4+21309586724715*r**6
            +22406136544395*r**8-17800917739186*r**10-74948017293190*r**12-85546327258374*r**14
            -48078284487060*r**16-13935459310955*r**18-2262861387553*r**20-204917940725*r**22
            +21305156511*r**24)+Q2**6*(663743454248-1104637345393*r**2+5279059121044*r**4
            -106836318820334*r**6-109385903706060*r**8+157964203124613*r**10+631443413064712*r**12
            +1053887506281708*r**14+869700632794512*r**16+411438469061465*r**18+116698750984804*r**20
            +10983718354946*r**22+137155345428*r**24-184350896493*r**26)-2*Q2**5*(64093745348
            +1693681572453*r**2+20119454339957*r**4+1148378624146*r**6+42462398166606*r**8
            -33931672937637*r**10-242260978086797*r**12-66269958768260*r**14+205439548831672*r**16
            +141644053532987*r**18+34304600690779*r**20+12577173672434*r**22-1801447873482*r**24
            -436758385403*r**26+2290859197*r**28)+Q2**4*(-156003229520+2885541619885*r**2
            +23247716194562*r**4+41833833197483*r**6+85793660034020*r**8-382862913474115*r**10
            -1236364485334210*r**12-1049959330407069*r**14+252908731044264*r**16+954475041328895*r**18
            +450265228122110*r**20-17674450600775*r**22-28630124292668*r**24-11008320987497*r**26
            -1022216060990*r**28+84151725625*r**30)-12*Q2**3*(-7097822384+27142506339*r**2
            -239024459351*r**4+2895586227975*r**6-4616180165779*r**8-18972288744481*r**10
            -26166276296339*r**12-8277937747933*r**14+81278187793265*r**16+129753830552473*r**18
            +81153609415979*r**20+42828414257701*r**22+2617004171159*r**24-1584802769115*r**26
            -419644501569*r**28-25077948239*r**30+2424970299*r**32)-9*(-1+r**2)**2*(
            -262835808+7152098011*r**2+55778651192*r**4-19233651660*r**6+1176940191200*r**8
            -5720418346096*r**10-9045728751128*r**12+24776797644724*r**14+21945262431920*r**16
            -60943707253250*r**18-43046008184184*r**20+58757412548348*r**22+29259429563776*r**24
            +7798980395240*r**26+1045876563800*r**28-30753053412*r**30-6499367856*r**32
            +219755183*r**34)-3*Q2**2*(-1036850792+240911004675*r**2+2662991940568*r**4
            -6746791679420*r**6+37891851859200*r**8-57118511680944*r**10-158576317396440*r**12
            -6210473412764*r**14-72500245329760*r**16-168646677572050*r**18+210150291540264*r**20
            +548284361775980*r**22+190900457865824*r**24+54306446560680*r**26+9191866896600*r**28
            -334536011028*r**30-104223250840*r**32+4552140247*r**34)+18*Q2*(-654577532
            +22489554217*r**2+168968936237*r**4-412128411172*r**6+3411165619860*r**8
            -13196555018584*r**10-11878077822016*r**12+23567410733644*r**14+8034557569996*r**16
            -232428153870*r**18-61330005328686*r**20-33609817779244*r**22+85189883218076*r**24
            +39765204567424*r**26+10925140294760*r**28+1674669058052*r**30-62760872832*r**32
            -15186064707*r**34+601276377*r**36))*sqrtq2)+logq2**2*(2304*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(4002154496*Q2**22-512*Q2**21*(98348006
            +89834431*r**2)+32*Q2**20*(8424164963+16334743654*r**2+7295516163*r**4)
            -160*Q2**19*(4754064084+16042222051*r**2+15029688010*r**4+4257857355*r**6)
            +40*Q2**18*(25752811481+169663239931*r**2+263110375003*r**4+159621547681*r**6
            +31083687784*r**8)-Q2**17*(-145383909436+8970236528185*r**2+21679345453260*r**4
            +22285287440850*r**6+10470304126800*r**8+1414343007189*r**10)+Q2**16*(
            -2790255821712-330452358517*r**2+3827385477415*r**4+8125479112770*r**6
            +16633635518330*r**8+9716078282803*r**10+803374261743*r**12)+2*Q2**15*(1873150455808
            +11099482772099*r**2+42896153941243*r**4+91491529562435*r**6+72032580034710*r**8
            +17149241097853*r**10-699506667921*r**12+172261716413*r**14)-10*Q2**14*(9911328128
            +3476044608667*r**2+18485555692950*r**4+61166083556876*r**6+80168693007199*r**8
            +45524336033919*r**10+10830509103016*r**12+922279888730*r**14+119882351715*r**16)
            +10*Q2**13*(-477759077032+1153479080393*r**2+9005979270309*r**4+81356037099072*r**6
            +170107297772979*r**8+154251216770300*r**10+67130164839579*r**12+13558301738420*r**14
            +1315414835253*r**16+85196409287*r**18)+2*Q2**12*(2154520357808+17141393639515*r**2
            +117784479857190*r**4-43501567987755*r**6-617215507579125*r**8-977343476266453*r**10
            -766274554125545*r**12-307086456146145*r**14-55110634581495*r**16-4694570870650*r**18
            +300691011583*r**20)-2*Q2**11*(-501832717984+24824876023921*r**2+204371088589485*r**4
            +642664551039435*r**6+953781796483320*r**8+1049322483874314*r**10+389207309569994*r**12
            -249876533789330*r**14-217535011606320*r**16-39937700461435*r**18-1863272925599*r**20
            +735680890311*r**22)+2*Q2**10*(-1939045455672+5780510121269*r**2+57866537057798*r**4
            +943879183852290*r**6+2590755455589105*r**8+5486955270656602*r**10+5904204878753316*r**12
            +2818182257122812*r**14+495156163933570*r**16-69941265283095*r**18-7247886684802*r**20
            +1521675593354*r**22+265442397213*r**24)+10*Q2**9*(160584128788+3233034651332*r**2
            +29586189256505*r**4-82974926362108*r**6-299769093653527*r**8-1328885949724346*r**10
            -2290706334706934*r**12-1748299309027760*r**14-695142990471818*r**16-188774845270032*r**18
            -26354679765475*r**20-8662332471220*r**22-969754170835*r**24+82824762470*r**26)
            -10*Q2**8*(-120478193792+3049899696458*r**2+30774967280079*r**4+103538717663091*r**6
            +437306976243411*r**8+32247431186811*r**10-1415636300957976*r**12-2070229520736522*r**14
            -1334152769001330*r**16-551763001760368*r**18-209613474225713*r**20-44718702861225*r**22
            -9413128002849*r**24-716510712597*r**26+75855127482*r**28)-2*Q2**7*(612483352512
            +282140009815*r**2-12052028919385*r**4-922301723706285*r**6-3606761179172750*r**8
            -7310066062847537*r**10-1561588293198435*r**12+10918297299060515*r**14
            +17200206284030700*r**16+13056979733177325*r**18+5473933810262113*r**20
            +1427607422126545*r**22+216788622067170*r**24-338545002515*r**26-1806488873125*r**28
            +73502762937*r**30)+2*Q2**6*(23799539744+7452846905899*r**2+64379087104910*r**4
            -415951938718160*r**6-529763756545905*r**8-6360282408744839*r**10-1392252566548704*r**12
            +13714968270626210*r**14+27823271526656805*r**16+29766853432019245*r**18
            +18406748605440566*r**20+6985996205283916*r**22+1308679080248105*r**24
            +175204680375855*r**26-22112193152740*r**28-3785697724446*r**30+205547297539*r**32)
            -2*Q2**5*(-171176251288+3229541060941*r**2+38369241629757*r**4+290821745178260*r**6
            +2289584688040615*r**8-2204328887853102*r**10+2131386324107189*r**12+2362298189886088*r**14
            +99615510627495*r**16+9883291811837920*r**18+9873373503009503*r**20+4299615212110644*r**22
            +2096929189455133*r**24-21057473005930*r**26-2520818853585*r**28-6193260254288*r**30
            -792889279699*r**32+39043594347*r**34)-10*Q2**4*(11964382816+207383052599*r**2
            -405990181230*r**4-80550625587039*r**6-297542346758901*r**8+6658799977305*r**10
            -204098027882145*r**12+2514163873767805*r**14+6565598888453823*r**16+3210193018877707*r**18
            -3276154500269033*r**20-2409091633690077*r**22-87945658790175*r**24+82676987148291*r**26
            +142033447209069*r**28+32557359997887*r**30-567264348427*r**32-276700648350*r**34
            +10490248075*r**36)+30*Q2**3*(-946181728+72915069947*r**2+427411486711*r**4
            -6540712518235*r**6+13154741299532*r**8-103235767586028*r**10+223301505277000*r**12
            +534070424165796*r**14+751749385584332*r**16-399327729165166*r**18-2343314172490290*r**20
            -2278460471333146*r**22-1593647372707580*r**24-306029029420364*r**26-13386038251344*r**28
            +13399271503796*r**30+6311824512324*r**32-13915950677*r**34-49137324733*r**36
            +1546509853*r**38)+9*(-1+r**2)**2*(7218704+5948471585*r**2-29305885135*r**4
            -2131875567875*r**6-3381859390715*r**8+20497010599924*r**10-209830203973980*r**12
            +829520231766180*r**14+365857942223700*r**16-3660054790232930*r**18+1232751601905454*r**20
            +5306457473513830*r**22-2303924270110330*r**24-1712702231359900*r**26
            -617142599204620*r**28-172557129933996*r**30-11803887582060*r**32+2017025911785*r**34
            +54557442825*r**36-8398214235*r**38+170001789*r**40)+6*Q2**2*(4109497996
            -39373903015*r**2-1172064695190*r**4-25416444312910*r**6-145313403399575*r**8
            +660534108152616*r**10-2262617685314180*r**12+2353106902088820*r**14+5149452243777080*r**16
            +2152144925919250*r**18+2731797879670576*r**20-3420415420991720*r**22
            -12844216163230070*r**24-4705540027751680*r**26-1829067943947900*r**28
            -595443057894484*r**30-2266583570460*r**32+9251086419565*r**34+33257137510*r**36
            -51835228650*r**38+1545976421*r**40)-9*Q2*(480491908+23070351863*r**2
            -247485769290*r**4-11560829280130*r**6-22189164577430*r**8+197004691838883*r**10
            -1082054446647992*r**12+2992282563689320*r**14+1812984488623440*r**16
            -6488001089881810*r**18-4297270710066972*r**20+8369754404168148*r**22
            +9025597571887980*r**24-7477927158015490*r**26-4609066813470840*r**28
            -1615401296586712*r**30-516516830880772*r**32-31572207654885*r**34+8389699553430*r**36
            +195105548830*r**38-43389698982*r**40+1016777503*r**42))-2304*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(4002154496*Q2**23-512*Q2**22*(106164714
            +97651139*r**2)+32*Q2**21*(9997733059+19345662646*r**2+8732867059*r**4)
            -32*Q2**20*(32194485383+104970018872*r**2+98778699867*r**4+28584802938*r**6)
            +40*Q2**19*(44769067817+252848384471*r**2+387398015247*r**4+236771729141*r**6
            +48115117204*r**8)-Q2**18*(884728549804+16786878584665*r**2+38990290050620*r**4
            +39194564348210*r**6+18098513545400*r**8+2657690518549*r**10)+4*Q2**17*(
            -733909932787+2123600065058*r**2+8619241864715*r**4+13022528001720*r**6
            +12347306771495*r**8+5400181354198*r**10+554429317233*r**12)+Q2**16*(6536556733328
            +25319673724427*r**2+82295374763588*r**4+171030194534685*r**6+119306045438320*r**8
            +7948768394573*r**10-11918465880388*r**12-458850828917*r**14)-4*Q2**15*(961353548224
            +15176428135621*r**2+73211707589046*r**4+220109050644029*r**6+282183787316570*r**8
            +158401750651079*r**10+35301139972506*r**12+2042077246071*r**14+385836737494*r**16)
            +20*Q2**14*(-233923874452+2319717508594*r**2+15483789785963*r**4+80503838174449*r**6
            +155721037168527*r**8+139972122905709*r**10+61742504988257*r**12+12655545365083*r**14
            +1178788537849*r**16+102539380501*r**18)-4*Q2**13*(-2271657871484-6881396811355*r**2
            -33493594051840*r**4+247655824917330*r**6+937266090969690*r**8+1299568024491424*r**10
            +936590731087470*r**12+355264394518070*r**14+64739608724930*r**16+5848813546675*r**18
            +62645517426*r**20)-4*Q2**12*(826343819912+22060395010622*r**2+169648481043095*r**4
            +358473731454435*r**6+146532360458220*r**8-272618249985632*r**10-677205360411002*r**12
            -661618772030510*r**14-289866051166980*r**16-49871452956790*r**18-3128576392333*r**20
            +518185950947*r**22)+4*Q2**11*(-1220439086828+15051776713603*r**2+143531250835602*r**4
            +895457411740605*r**6+2093600901555930*r**8+3745029775507118*r**10+3671367336098812*r**12
            +1478756516451738*r**14+13872309268960*r**16-163706988675425*r**18-24524430035918*r**20
            +197041779033*r**22+500561643762*r**24)+2*Q2**10*(2741966099612+12323708591063*r**2
            +84283899103458*r**4-1416620352720628*r**6-5033480107709030*r**8-14722140474867437*r**10
            -22844691822944588*r**12-17463883681014928*r**14-6789053373415472*r**16
            -1369089125000635*r**18-54584246859478*r**20-37585451264652*r**22-6635888844742*r**24
            +148681415137*r**26)-20*Q2**9*(20052967498+3221759238289*r**2+31797095593958*r**4
            +25074990278744*r**6+27281478113888*r**8-798203806095531*r**10-2517614292694628*r**12
            -3054617582235608*r**14-1888797534250454*r**16-717840418751109*r**18-212371499630610*r**20
            -39867857548960*r**22-9522607322452*r**24-801720060481*r**26+79339944976*r**28)
            +2*Q2**8*(-1214874321472+14364967503515*r**2+181176363802070*r**4+1593870148422135*r**6
            +6310989648705260*r**8+9657838099998647*r**10-5355356055657390*r**12-28347626407533005*r**14
            -34222117732719960*r**16-22486558586985815*r**18-9280816190192518*r**20
            -2699268307561235*r**22-487447776387540*r**24-50309648574715*r**26-1396789052450*r**28
            +305772874473*r**30)+4*Q2**7*(318141446128+4173735134113*r**2+26304599097670*r**4
            -675152845671915*r**6-2529413329712470*r**8-8638554825382563*r**10-5131953461297338*r**12
            +11535838638244145*r**14+27970887554874010*r**16+30012019724613635*r**18
            +18468831074440002*r**20+6943768718836287*r**22+1476537562220910*r**24
            +195827378720255*r**26-12128613514190*r**28-2759341917317*r**30+139525030238*r**32)
            -4*Q2**6*(-73688355772+5353093753292*r**2+55100587820283*r**4-30375553217495*r**6
            +671934496388275*r**8-4547187526571923*r**10-2810574325593177*r**12+7342506946981797*r**14
            +20818927653955255*r**16+33736708385256985*r**18+29023487770234657*r**20
            +14846180011417563*r**22+5195802237493577*r**24+731413143809015*r**26
            +75285834184765*r**28-16045575565737*r**30-2186519853303*r**32+122295445943*r**34)
            -4*Q2**5*(115499082684-1010724773329*r**2-21814366798424*r**4-365972057371606*r**6
            -2034059083506690*r**8-25980900150494*r**10-473773787832406*r**12+4038567427422874*r**14
            +15183040370877766*r**16+3034028885961560*r**18-18068718908096294*r**20
            -13109223441785266*r**22-3418136347758326*r**24-831243390353874*r**26
            +366872763952430*r**28+85750439548654*r**30+2074913895926*r**32-314828778199*r**34
            +6703823014*r**36)+20*Q2**4*(4562918816+219046322628*r**2+541813665751*r**4
            -50289376661487*r**6-169314374223672*r**8-300295424769840*r**10+236232643963080*r**12
            +1956138559191524*r**14+5667505459487312*r**16+4288904359918016*r**18
            -3547951999431098*r**20-6260313773979274*r**22-3638989705301496*r**24
            -461677879951488*r**26+92276159801664*r**28+107394310859172*r**30+25462784593216*r**32
            -442856424404*r**34-206811187237*r**36+7564888817*r**38)-12*Q2**3*(-4420203318
            +199609172055*r**2+1836848739240*r**4-2575030422355*r**6+89191773653030*r**8
            -555469619792548*r**10+1431473186884520*r**12+716876372562580*r**14+639823402486780*r**16
            -195018321911710*r**18-8222503693973928*r**20-9844228899062730*r**22-3258161528486780*r**24
            -2396420991444020*r**26+115996302794680*r**28+297754612078372*r**30+50411031825530*r**32
            +11119228194335*r**34-174261757280*r**36-93059422875*r**38+3093286422*r**40)
            -9*(-1+r**2)**2*(7218704+5955690289*r**2-23357413550*r**4-2161181453010*r**6
            -5513734958590*r**8+17115151209209*r**10-189333193374056*r**12+619690027792200*r**14
            +1195378173989880*r**16-3294196848009230*r**18-2427303188327476*r**20
            +6539209075419284*r**22+3002533203403500*r**24-4016626501470230*r**26
            -2329844830564520*r**28-789699729138616*r**30-184361017516056*r**32-9786861670275*r**34
            +2071583354610*r**36+46159228590*r**38-8228212446*r**40+170001789*r**42)
            -3*Q2**2*(9660471716-1317754449*r**2-3165334504280*r**4-87859505856590*r**6
            -408027189157260*r**8+1621455485022731*r**10-6450330494267104*r**12+9157826124617240*r**14
            +20444071757602120*r**16-4860808930252770*r**18-3123926519021264*r**20
            +23732028129862156*r**22-5452470452779640*r**24-57533293856009970*r**26
            -26896416383811680*r**28-9695225893444904*r**30-2744969775572204*r**32
            -80747617266445*r**34+43737785774440*r**36+548160464210*r**38-230747601404*r**40
            +6142285351*r**42)+36*Q2*(121927653+7371219487*r**2-66402756757*r**4
            -3468907593860*r**6-8224351999415*r**8+49986095268733*r**10-284813959843413*r**12
            +794976441838848*r**14+825563581757530*r**16-2059316761043130*r**18-466638168838442*r**20
            +813345793392792*r**22+1427816090205898*r**24+2437318549061770*r**26-2895664094520370*r**28
            -1718860568235552*r**30-603937588596543*r**32-173755341848437*r**34-9741472516065*r**36
            +2621079478540*r**38+55809930733*r**40-12777784823*r**42+296694823*r**44))*sqrtq2)
            +logq2*(-192*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(-77103360*Q2**21+96*Q2**20*(10059165
            +12275647*r**2)-8*Q2**19*(621062100+1696852163*r**2+900691183*r**4)+8*Q2**18*(1609026525
            +7736408881*r**2+8888138459*r**4+2919149299*r**6)-Q2**17*(13859043300
            +131367164145*r**2+224821857595*r**4+182588877967*r**6+42270131297*r**8)
            +Q2**16*(-11633043960+68480939237*r**2+15876359540*r**4+130458757130*r**6
            +222191484260*r**8+35917111729*r**10)+2*Q2**15*(26547638220+138052115908*r**2
            +814348470231*r**4+1392772696129*r**6+570117659137*r**8-10821702373*r**10
            +3767653756*r**12)-2*Q2**14*(25148823300+304128791034*r**2+2082290203229*r**4
            +6064780048086*r**6+5619234189662*r**8+1786142334794*r**10+150722663489*r**12
            +19842998374*r**14)+Q2**13*(-25406724600+309054158276*r**2+3176509083354*r**4
            +21967349058682*r**6+33916673173920*r**8+21574960357424*r**10+5302697592898*r**12
            +426138221714*r**14+6670465084*r**16)+2*Q2**12*(45046532700+268302583240*r**2
            +2176418517175*r**4-6092034082718*r**6-18218286023043*r**8-20117476305004*r**10
            -11374137783039*r**12-2396741930654*r**14-156235255057*r**16+25556661088*r**18)
            -2*Q2**11*(24899230980+448593360108*r**2+5703711418205*r**4+13001568669991*r**6
            +21539921348265*r**8+25655687454327*r**10+4395828063131*r**12-4656748215595*r**14
            -1057907448001*r**16-56253842335*r**18+23542584796*r**20)+2*Q2**10*(-21568311180
            +134995241150*r**2+3552457644247*r**4+29619283338882*r**6+80061738577152*r**8
            +161383286293028*r**10+129265470202942*r**12+40164666781524*r**14+3687902458692*r**16
            +800563394190*r**18+77603982899*r**20-4947503174*r**22)+2*Q2**9*(32627836800
            +244348887149*r**2+2844309244354*r**4-19833086039878*r**6-53198830578411*r**8
            -227294369387822*r**10-294041427672684*r**12-156459370311084*r**14-44043077897478*r**16
            -5986843075791*r**18-1686821448262*r**20-156468919166*r**22+17594889569*r**24)
            -2*Q2**8*(5467718700+254355821223*r**2+5831861320537*r**4+11645366871820*r**6
            +78959379283325*r**8-54841704613251*r**10-257902447219526*r**12-229419423202952*r**14
            -106590797248794*r**16-37111608728175*r**18-5964383811411*r**20-624849424580*r**22
            -48011597903*r**24+4608145547*r**26)-2*Q2**7*(14036276700-31380254300*r**2
            -2575523614805*r**4-29770148847899*r**6-139048834991519*r**8-155789139514893*r**10
            +117035857664282*r**12+306100659366722*r**14+326400331686350*r**16+171072432757850*r**18
            +55897955065807*r**20+9558267306457*r**22-694198369163*r**24-110788692977*r**26
            +7057938668*r**28)+2*Q2**6*(8677369620+90920035298*r**2+1669242964425*r**4
            -16166414480338*r**6-22569765193030*r**8-190743673812802*r**10+113526150467483*r**12
            +383753961051010*r**14+575009337649440*r**16+433831845655150*r**18+197486695312511*r**20
            +42744479630274*r**22+7505039240210*r**24-543526980622*r**26-96246955235*r**28
            +4608043406*r**30)+2*Q2**5*(1470913020-59890027998*r**2-2351840455237*r**4
            -6341826813501*r**6-97279064705080*r**8+187119671143988*r**10-161493739690775*r**12
            -85317756626247*r**14-80088412605998*r**16-292942008914814*r**18-69263369031059*r**20
            -62890274376043*r**22+11333302545924*r**24+3933071866664*r**26-115416506641*r**28
            -17861249809*r**30+939733606*r**32)-2*Q2**4*(3038615100-5035324412*r**2
            -754914642357*r**4-11635412337214*r**6-71241669582123*r**8+154719879866684*r**10
            -178196779869893*r**12+301802789268542*r**14+710918602589653*r**16-253199195821224*r**18
            -307056413218903*r**20+20189359340862*r**22-24121072680473*r**24+22019318826636*r**26
            +8999136985297*r**28-151898726206*r**30-50456676557*r**32+1672634588*r**34)
            +2*Q2**3*(650124900+10808390936*r**2+296737623149*r**4-3877092457717*r**6
            +5710049914665*r**8-15629604552913*r**10+22874066123145*r**12+218427493505911*r**14
            +230834760001733*r**16-485689854552005*r**18-458941194934289*r**20-514389546716303*r**22
            -93505206579989*r**24-19655389685475*r**26+1552474303315*r**28+2830216523277*r**30
            +15586122947*r**32-12306605471*r**34+278890184*r**36)+3*(-1+r**2)**2*(19921680
            -53131509*r**2-7972879192*r**4-177661618465*r**6-988163050344*r**8+10101849660740*r**10
            -57949705244728*r**12+177194652066756*r**14-135533256157320*r**16-316435005880558*r**18
            +551801994395480*r**20-131796165847142*r**22-82808142770936*r**24-27937963277340*r**26
            -15063839005352*r**28-1819721723900*r**30+201900780504*r**32+4364226747*r**34
            -627956000*r**36+11410879*r**38)+2*Q2**2*(367259400-5983999530*r**2-319238848495*r**4
            -1356454313510*r**6-24643157513340*r**8+137289241092936*r**10-395702153690984*r**12
            +437362188573616*r**14+304689522042196*r**16-14279966725004*r**18+26507975441378*r**20
            -546039262166492*r**22-299993746405972*r**24-87529913580312*r**26-66795596133072*r**28
            -4173239318464*r**30+2142799280756*r**32-2876145274*r**34-9551661499*r**36
            +248731666*r**38)-3*Q2*(136880820-944803461*r**2-67351989965*r**4-822915985801*r**6
            -6205433256685*r**8+59414398126932*r**10-265657458880012*r**12+620278396646180*r**14
            -247905333615252*r**16-800364899433310*r**18+450435424179314*r**20+708893769867082*r**22
            -261461082083390*r**24-269715875821868*r**26-59142860450700*r**28-47388749027804*r**30
            -6222590744984*r**32+1066868127675*r**34+16447837171*r**36-3971991305*r**38
            +82099363*r**40))+192*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(616826880*Q2**25
            -1536*Q2**24*(5380965+6489206*r**2)+32*Q2**23*(1436500305+3867554338*r**2
            +2042304593*r**4)-8*Q2**22*(16345763280+77644987861*r**2+89055608122*r**4
            +28597964565*r**6)+8*Q2**21*(20441578095+189286084454*r**2+340061812432*r**4
            +259257543130*r**6+55986328577*r**8)-Q2**20*(-98164984860+1243149268619*r**2
            +2424770984948*r**4+3739005247318*r**6+3050975225224*r**8+401674250111*r**10)
            -4*Q2**19*(156729492135+657898468559*r**2+3385717155510*r**4+5766817301450*r**6
            +1953385753255*r**8-270439458265*r**10+38299147964*r**12)+2*Q2**18*(347788646730
            +3982401019853*r**2+24220537708348*r**4+69521217293635*r**6+64731709144410*r**8
            +19884564329795*r**10+1858341622048*r**12+339202859693*r**14)-4*Q2**17*(
            -74828366865+1508273097902*r**2+13631113899554*r**4+78929670068180*r**6
            +123389659550070*r**8+77509964750350*r**10+18062061615122*r**12+1668122033584*r**14
            +64839871655*r**16)+Q2**16*(-1375061819040-6234716314343*r**2-33185839866984*r**4
            +266084973909860*r**6+752740414335056*r**8+794089706635570*r**10+394627430597832*r**12
            +68951835993916*r**14+4654219195120*r**16-770372556779*r**18)+16*Q2**15*(52674949485
            +959075829091*r**2+9960603739757*r**4+20122764691652*r**6+18884200544361*r**8
            +16492148423794*r**10-9868997589339*r**12-11509395585228*r**14-1193759482218*r**16
            +13511002931*r**18+54851245954*r**20)+8*Q2**14*(106783539570-908260362087*r**2
            -17543808043310*r**4-136123430728725*r**6-364156283572520*r**8-727741893659440*r**10
            -611088310988498*r**12-197537865821620*r**14-26190971312590*r**16-5567889489705*r**18
            -611748941980*r**20+25800464233*r**22)-16*Q2**13*(85415625090+570831533854*r**2
            +4273887597059*r**4-60467335631640*r**6-227268186413220*r**8-797007351474610*r**10
            -1090984101237554*r**12-644274098421264*r**14-173979273319320*r**16-24900809908320*r**18
            -3947876702245*r**20-376769599076*r**22+53358176654*r**24)+2*Q2**12*(60716523780
            +6572939029501*r**2+111650186248652*r**4+198708841012790*r**6+518876743361560*r**8
            -4603247025793065*r**10-12286072105576176*r**12-11668150522898572*r**14
            -5421475992211940*r**16-1266000283877325*r**18-163331308066940*r**20-6746652036154*r**22
            -206669398168*r**24+119354640265*r**26)+8*Q2**11*(110453416695-310336972661*r**2
            -14805875341748*r**4-199629758839690*r**6-828505273187173*r**8-1161581743228835*r**10
            +243217614066016*r**12+1173355979399868*r**14+1486362358096845*r**16+908051070480613*r**18
            +244376659649980*r**20+36557137939774*r**22-4917326024623*r**24-816646808125*r**26
            +58210245352*r**28)-4*Q2**10*(119562750810+1671345295201*r**2+22960370331912*r**4
            -271475969898353*r**6-1200814556999674*r**8-6846642282545891*r**10-11196197098774416*r**12
            -16479703322678837*r**14-11839572968975082*r**16-2703500834574661*r**18
            +629536552983416*r**20+202562126586021*r**22+39968040904522*r**24-7084446804793*r**26
            -1225409714864*r**28+78234547969*r**30)-8*Q2**9*(32690002005-660997905658*r**2
            -17213924536760*r**4-59014602545000*r**6-309667250539860*r**8+3033247586102030*r**10
            +6362136671144008*r**12+16234413714032740*r**14+19572022835559370*r**16
            +10174984886066450*r**18+2920070652126280*r**20+251778939781968*r**22
            +150472504475620*r**24+35550217711770*r**26-1010403595480*r**28-300835716620*r**30
            +15906841937*r**32)+2*Q2**8*(153858885480+145954491973*r**2-13241305040552*r**4
            -555006487273520*r**6-2666562582888000*r**8-1449642935939920*r**10-11445070919533648*r**12
            +25918422709121272*r**14+79714637875589640*r**16+59657201291821410*r**18
            +24678621876864440*r**20+10198011704039232*r**22+2093636213928752*r**24
            +755670128931000*r**26+228622085038400*r**28-5545111176200*r**30-2107903760992*r**32
            +87213768433*r**34)-16*Q2**7*(12274065+145591684633*r**2+3184362835191*r**4
            -26415066903880*r**6-124951731574225*r**8-1770695655593060*r**10-4726614585477313*r**12
            -5059660241462336*r**14+4244232736533205*r**16+9588487461275590*r**18
            +9110698064688265*r**20+5075105049411032*r**22+1909142810438469*r**24
            +462138904993980*r**26+11302480334485*r**28+1474932872880*r**30+35890991398*r**32
            -15629964599*r**34+1467820*r**36)-16*Q2**6*(6262794315-61163217497*r**2
            -2043176977756*r**4-18725970524050*r**6-69880760534946*r**8+1393801361373175*r**10
            +832549949328537*r**12+6880087888289631*r**14-3447435880263090*r**16-16465576598239679*r**18
            -21694252895134145*r**20-17569254007568153*r**22-8868371789283794*r**24
            -2177844276784755*r**26-568379213640649*r**28-6334348875795*r**30+18582236319963*r**32
            +40981047444*r**34-114454367155*r**36+3548674399*r**38)+8*Q2**5*(3366841545
            +37442955902*r**2+432849695094*r**4-38915027042106*r**6-162944610731353*r**8
            -495926384700212*r**10-6859549858475472*r**12+13187371845455096*r**14
            -9664232461779154*r**16-19626650640863232*r**18-12008654165229308*r**20
            -17242176363322932*r**22-9383604606124854*r**24-7381754592415964*r**26
            -327375676160752*r**28-128438516580888*r**30-52932947792423*r**32+14878030324114*r**34
            +315326703174*r**36-78250708338*r**38+1719312063*r**40)+Q2**4*(16119955260
            -373444975791*r**2-9662176133060*r**4+44522628461850*r**6+524436214051800*r**8
            +14349978137294825*r**10+26115334334031104*r**12-70530681982341320*r**14
            +82933287691957080*r**16-159573838581855630*r**18-436466593088398120*r**20
            +55115184553102844*r**22+107485971329171920*r**24-18860892437341110*r**26
            +7007843095089760*r**28-10467548720251400*r**30-6143577497136436*r**32
            -260817168378915*r**34+80811125943180*r**36+1100529520570*r**38-388406770440*r**40
            +9846762029*r**42)-12*Q2**3*(713370645-5752608683*r**2-189832766698*r**4
            -4528825637690*r**6+3703013592445*r**8+429782633674105*r**10-1326118245455628*r**12
            +3199604354307992*r**14-3165225202669750*r**16-16042107201558470*r**18
            -11873826711072860*r**20+24582684793443092*r**22+32749685891757282*r**24
            +32020403723308970*r**26+9366327965914880*r**28+1555883532228600*r**30
            +273996860499457*r**32-230491365646223*r**34-41390121791530*r**36+4527377029270*r**38
            +152756536385*r**40-20122531363*r**42+387515772*r**44)-9*(-1+r**2)**2*(19921680
            -332035029*r**2-9101675986*r**4-61325851451*r**6+2249314015020*r**8+40747891678445*r**10
            -104008983983434*r**12+52573278469739*r**14+2688599849611824*r**16-14253868990866210*r**18
            +15183343321332060*r**20+23962526703657826*r**22-45812492467915576*r**24
            +5478552697729834*r**26+10556981383600860*r**28+3862760405366950*r**30
            +1750002214530016*r**32+351187378143879*r**34-8628135368586*r**36-5047767170295*r**38
            +199669717740*r**40+12082988121*r**42-787708306*r**44+11410879*r**46)
            -6*Q2**2*(92212290-7104558687*r**2-154987247324*r**4+4336185643695*r**6
            +21168482240490*r**8+367548759200155*r**10+1586183726685328*r**12-12090447579001659*r**14
            +38062655000773220*r**16-34042120044036470*r**18-55458296469758280*r**20
            -3849273905219562*r**22+18291213535536196*r**24+68309663280417270*r**26
            +24878863540440720*r**28+7785877190564810*r**30+6107550291426138*r**32
            +407667330769381*r**34-187387967729980*r**36+1386348574635*r**38+1016869341650*r**40
            -1789773217*r**42-3432145344*r**44+85644545*r**46)+36*Q2*(29239785-637255398*r**2
            -14987107294*r**4+70329943620*r**6+2608743712766*r**8+50966370866810*r**10
            -74883695538838*r**12-550406035272824*r**14+4550640195755655*r**16-13650341292125644*r**18
            +5020062131138660*r**20+22204593216225752*r**22-11990943333039964*r**24
            -20104623896929660*r**26+7134281678943236*r**28+7343260870099360*r**30
            +2319665902864727*r**32+1256461853123826*r**34+256470680112250*r**36-17967055660604*r**38
            -4562351571490*r**40+267762226882*r**42+12918447506*r**44-1086271240*r**46
            +17672121*r**48))*sqrtq2))/(8064000*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2+8064000*(-Q2+(-1
            +r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2+logq2**7*(-65013232435200000*r**32*(1
            +r**2)**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-65013232435200000*r**32*(1
            +r**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**6*(361184624640000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))+361184624640000*r**28*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))*sqrtq2)+logq2*(-483840000*(-Q2
            +(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(9+8*Q2**4-78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)
            -Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-483840000*(-Q2+(-1
            +r)**2)**3*r**8*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(9+8*Q2**4
            -78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)-Q2**2*(13+10*r**2
            +13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2)+logq2**2*(5806080000*(-Q2+(-1+r)**2)**3*r**12*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1
            +r**2)-Q2**6*(531+550*r**2+531*r**4)-2*Q2**5*(19+473*r**2+473*r**4
            +19*r**6)+Q2**4*(815-2120*r**2-11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1
            +225*r**2+494*r**4+494*r**6+225*r**8+r**10)+Q2**2*(-501+4554*r**2
            +26793*r**4+31188*r**6+26793*r**8+4554*r**10-501*r**12)-54*Q2*(1+15*r**2
            -311*r**4-1385*r**6-1385*r**8-311*r**10+15*r**12+r**14)+9*(17-316*r**2
            -184*r**4+13388*r**6+34670*r**8+13388*r**10-184*r**12-316*r**14+17*r**16))
            +5806080000*(-Q2+(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531+550*r**2
            +531*r**4)-2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815-2120*r**2
            -11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4+494*r**6
            +225*r**8+r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6+26793*r**8
            +4554*r**10-501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6-1385*r**8
            -311*r**10+15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6+34670*r**8
            +13388*r**10-184*r**12-316*r**14+17*r**16))*sqrtq2)+logq2**3*(-69672960000*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8+256*Q2**7*(1+r**2)
            -Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2+893*r**4+319*r**6)
            +Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)+12*Q2**3*(61
            +235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(-1071+9654*r**2
            +51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)-18*Q2*(23
            -35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12+23*r**14)
            +9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10-264*r**12
            -756*r**14+47*r**16))-69672960000*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8
            +256*Q2**7*(1+r**2)-Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2
            +893*r**4+319*r**6)+Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)
            +12*Q2**3*(61+235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(
            -1071+9654*r**2+51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)
            -18*Q2*(23-35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12
            +23*r**14)+9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10
            -264*r**12-756*r**14+47*r**16))*sqrtq2)+logq2**4*(836075520000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513+770*r**2
            +513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105-3400*r**2
            -11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4-1178*r**6
            +75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6+19593*r**8
            +3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6-5785*r**8
            -2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4+25204*r**6
            +52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))+836075520000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513
            +770*r**2+513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105
            -3400*r**2-11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4
            -1178*r**6+75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6
            +19593*r**8+3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6
            -5785*r**8-2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4
            +25204*r**6+52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))*sqrtq2)
            +logq2**5*(-2006581248000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(64*Q2**8+1088*Q2**7*(1+r**2)+Q2**6*(-63+130*r**2-63*r**4)
            -2*Q2**5*(2777+6379*r**2+6379*r**4+2777*r**6)+Q2**4*(1555-8080*r**2
            -22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743-315*r**2-6548*r**4-6548*r**6
            -315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2+199629*r**4+305844*r**6
            +199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83-375*r**2-2833*r**4
            -5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)+9*(301-4028*r**2
            +808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12-4028*r**14+301*r**16))
            -2006581248000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(64*Q2**8+1088*Q2**7*(1
            +r**2)+Q2**6*(-63+130*r**2-63*r**4)-2*Q2**5*(2777+6379*r**2+6379*r**4
            +2777*r**6)+Q2**4*(1555-8080*r**2-22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743
            -315*r**2-6548*r**4-6548*r**6-315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2
            +199629*r**4+305844*r**6+199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83
            -375*r**2-2833*r**4-5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)
            +9*(301-4028*r**2+808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12
            -4028*r**14+301*r**16))*sqrtq2))+(muWC**4*(16*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(
            -16488*Q2**21+16*Q2**20*(23103+1340*r**2)+Q2**19*(887499+2078338*r**2
            -465013*r**4)+Q2**18*(-110612187-28010557*r**2-195808909*r**4+10220789*r**6)
            +Q2**17*(1047702927+437784630*r**2+1476518666*r**4+2081546414*r**6-67569389*r**8)
            +Q2**16*(-4620668427-2660527821*r**2-74104944*r**4-14572429216*r**6-9890109717*r**8
            +226302685*r**10)-4*Q2**15*(-2879888907-1863019230*r**2+7674340823*r**4
            +2574784920*r**6-13738647523*r**8-6044848518*r**10+106063955*r**12)+4*Q2**14*(
            -4027226043-2587762335*r**2+40278505607*r**4+70722247547*r**6+62704350405*r**8
            -14649411403*r**10-5837345281*r**12+93116671*r**14)+4*Q2**13*(2046834759
            +2247664470*r**2-127302262164*r**4-300316061770*r**6-503646251504*r**8
            -434856420090*r**10-52271304616*r**12-7595232522*r**14+39024157*r**16)
            +4*Q2**12*(2868746361-4576152399*r**2+276393016900*r**4+817860564732*r**6
            +1580057311056*r**8+2128306613532*r**10+1362614758332*r**12+207154089988*r**14
            +30305169687*r**16-200241197*r**18)+2*Q2**11*(-11691763083+21783074086*r**2
            -758329474583*r**4-2952763672016*r**6-6043789614578*r**8-8809940172972*r**10
            -9032476494138*r**12-3957588208048*r**14-558162477611*r**16-69800626922*r**18
            +405367209*r**20)+2*Q2**10*(6184070139-19217384263*r**2+464627399485*r**4
            +3168865326247*r**6+5868491795674*r**8+7421734493374*r**10+6569970583878*r**12
            +7341350165554*r**14+518381412563*r**16+70627579297*r**18+6003953813*r**20
            -34643505*r**22)+2*Q2**9*(4073300361-13883757542*r**2+306945015234*r**4
            -1785093174398*r**6+226099315615*r**8+7696878152204*r**10+18082491770284*r**12
            +20112350611868*r**14+5119836919567*r**16+7161551075210*r**18+772362713826*r**20
            +73005730642*r**22-297842727*r**24)+2*Q2**8*(-6952029693+37648965993*r**2
            -811919656528*r**4+589758007784*r**6-5737061314769*r**8-22780273766331*r**10
            -49572306436416*r**12-62101786835696*r**14-48378383674623*r**16-14870198677869*r**18
            -10336423786992*r**20-995135306488*r**22-76282466611*r**24+256914751*r**26)
            +4*Q2**7*(870844239-5003980962*r**2+262171964913*r**4-91788260072*r**6
            +2361016343721*r**8+8734982139194*r**10+20590834800579*r**12+31615306540144*r**14
            +29761543014737*r**16+11997900340722*r**18+5187261230007*r**20+1690545842616*r**22
            +147254970487*r**24+4532538678*r**26-1098283*r**28)-4*Q2**6*(-1407917985
            +17430047439*r**2-37382894171*r**4+449278654317*r**6+1308191522473*r**8
            +4177985990949*r**10+7093553191723*r**12+2224693694839*r**14+5922108194353*r**16
            +11484037847305*r**18-22730682840933*r**20+1683288024715*r**22-2914212747321*r**24
            -228574808573*r**26-20803946091*r**28+66698641*r**30)+4*Q2**5*(-1239233883
            +19209180558*r**2-141895926656*r**4+960639512398*r**6+1111692785742*r**8
            +4437503289202*r**10+6286338102460*r**12-8424162694814*r**14-14281453324540*r**16
            -21906027914446*r**18+20753662814376*r**20-39508770125678*r**22+1793522274970*r**24
            -3549878063538*r**26-257978415716*r**28-17161591490*r**30+43363055*r**32)
            +(-1+r**2)**4*(-22488147+792842471*r**2-168478338*r**4+53747245778*r**6
            +570282450338*r**8-4454539473202*r**10+16207259657462*r**12-34043872194054*r**14
            +19925016665084*r**16+30870184069404*r**18-42405649687910*r**20+20185651880598*r**22
            -5706544722578*r**24+489923078338*r**26-152720310542*r**28-7921229666*r**30
            -356625081*r**32+616045*r**34)-4*Q2**4*(-159284769+3984127791*r**2-59554576548*r**4
            +566209785548*r**6-13969806950*r**8+3032464536414*r**10+2022779669900*r**12
            -6088591365556*r**14-2019105251416*r**16+5178640784140*r**18-32972571394636*r**20
            +28242232551972*r**22-18453867351994*r**24+983393639218*r**26-1069631299740*r**28
            -75153697084*r**30-2632137063*r**32+2750773*r**34)+Q2**3*(1190978787
            -24321983934*r**2+62072848571*r**4-550922816352*r**6-4996056648396*r**8
            +12518949175512*r**10-31440542776140*r**12+5005644790432*r**14+38745993846930*r**16
            -107077190028308*r**18+111369529514370*r**20+32525593776352*r**22-73397248157772*r**24
            +50582154225816*r**26-8402612957196*r**28+2796433522656*r**30+162716003747*r**32
            +15711594594*r**34-41725669*r**36)-Q2*(-1+r**2)**2*(-214010391+6528138188*r**2
            -15998547859*r**4+430603288528*r**6+2779193752700*r**8-17231541540448*r**10
            +50169142029932*r**12-67558842034992*r**14-40083035791530*r**16+117441185919640*r**18
            +82029171083374*r**20-194767964277008*r**22+111892945396796*r**24-35560099221824*r**26
            +3868768457260*r**28-1088461212560*r**30-59662480887*r**32-3218753220*r**34
            +6172301*r**36)+Q2**2*(-795547827+21031031939*r**2-87353327093*r**4+1175511746821*r**6
            +4604067966556*r**8-26111101730364*r**10+73263687658020*r**12-101703842666180*r**14
            +50159920035614*r**16-77853987508318*r**18+133202362549074*r**20+188310343086638*r**22
            -397357630703236*r**24+253088388139364*r**26-85382647725372*r**28+12211285859292*r**30
            -2867303892547*r**32-163614084941*r**34-11332743749*r**36+24592309*r**38))
            +16*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))**2*(16488*Q2**22-8*Q2**21*(48267+4741*r**2)+Q2**20*(
            -517851-1687250*r**2+486453*r**4)+2*Q2**19*(55749843+15488197*r**2+98711117*r**4
            -5342901*r**6)+2*Q2**18*(-579157557-288203687*r**2-850169066*r**4-1133567267*r**6
            +38895089*r**8)+2*Q2**17*(2834185677+2073007689*r**2+994204120*r**4+9065247148*r**6
            +5952043371*r**8-146936037*r**10)+Q2**16*(-16140224055-14733273168*r**2
            +27962730527*r**4-4347394480*r**6-79417129025*r**8-33843201104*r**10
            +650558505*r**12)-8*Q2**15*(-3453557475-3665335236*r**2+23044913600*r**4
            +40485686645*r**6+25770243901*r**8-17216453722*r**10-5888064922*r**12
            +99590313*r**14)+8*Q2**14*(-3037030401-4431326424*r**2+82496502718*r**4
            +205658407462*r**6+318536424728*r**8+241455679546*r**10+15892273966*r**12
            +925501956*r**14+27046257*r**16)+8*Q2**13*(-410955801+4435325814*r**2
            -200723807297*r**4-622739444333*r**6-1192009812165*r**8-1533404642563*r**10
            -924871241519*r**12-133510313563*r**14-18930689026*r**16+119632677*r**18)
            +2*Q2**12*(17429255805-25197886162*r**2+1301963203585*r**4+5141270835280*r**6
            +10839625366154*r**8+16226668022148*r**10+16014319237866*r**12+7097125904688*r**14
            +1033080996961*r**16+130010483902*r**18-805849603*r**20)+4*Q2**11*(-8937916611
            +14654347633*r**2-600586899991*r**4-3439979236423*r**6-7432522541134*r**8
            -11137732140462*r**10-12206193625494*r**12-10165707433870*r**14-2517066049111*r**16
            -349295341915*r**18-37699606763*r**20+220005357*r**22)+4*Q2**10*(1055384889
            +425221709*r**2+69232499994*r**4+2709292950065*r**6+4405628903153*r**8
            +2796674068422*r**10-2045393346516*r**12-3100514931218*r**14+1369947329275*r**16
            -3286271041675*r**18-347865590358*r**20-33518210167*r**22+131599611*r**24)
            +4*Q2**9*(5512665027-23729711587*r**2+552490457110*r**4-1033953083474*r**6
            +2089033727993*r**8+15351625617075*r**10+37675838179452*r**12+50148314608924*r**14
            +36805285603029*r**16+13575793336323*r**18+9135168788014*r**20+920251875478*r**22
            +74495177263*r**24-277378739*r**26)+2*Q2**8*(-8693718171+40704898224*r**2
            -1298614620361*r**4-38585128600*r**6-9869335994427*r**8-45987299359488*r**10
            -113534249803905*r**12-174904706352400*r**14-170003256539793*r**16-87244383033936*r**18
            -35581144924875*r**20-14712650778712*r**22-1365927714073*r**24-85090629216*r**26
            +259111317*r**28)+8*Q2**7*(-268536873+6648455358*r**2+109892544890*r**4
            +309831179579*r**6+1788709803061*r**8+7636992236932*r**10+18209685065748*r**12
            +27215417517781*r**14+33649478874617*r**16+26621740601382*r**18-2772760635102*r**20
            +4280547548669*r**22-538205967109*r**24-38393649704*r**26-8136252848*r**28
            +32800179*r**30)-16*Q2**6*(-661787967+8807827503*r**2-40462193347*r**4
            +343133818136*r**6+717290740633*r**8+2480920200656*r**10+4389469321283*r**12
            +223521047937*r**14-1533662858837*r**16-1124970468197*r**18+2376754455187*r**20
            -15139041235474*r**22+140649388091*r**24-1673166404858*r**26-126839292595*r**28
            -9474709735*r**30+27515424*r**32)+8*Q2**5*(-699259326+10977037233*r**2
            -91120661323*r**4+692476685645*r**6+1029181245595*r**8+4290830305679*r**10
            +6373310530781*r**12-4113207978955*r**14-12362360635385*r**16-15504420227423*r**18
            -17062468247353*r**20+4743562620335*r**22-28084557601351*r**24-386481074675*r**26
            -2438743889497*r**28-175146852145*r**30-9875182749*r**32+23056914*r**34)
            +(-1+r**2)**4*(-22488147+770354324*r**2+624364133*r**4+53578767440*r**6
            +624029696116*r**8-3884257022864*r**10+11752720184260*r**12-17836612536592*r**14
            -14118855528970*r**16+50795200734488*r**18-11535465618506*r**20-22219997807312*r**22
            +14479107158020*r**24-5216621644240*r**26+337202767796*r**28-160641540208*r**30
            -8277854747*r**32-356009036*r**34+616045*r**36)+Q2**4*(-553839711+9022611846*r**2
            +160208946457*r**4-1475698019648*r**6+2787096734004*r**8-24592928093368*r**10
            +11219565950884*r**12+11257601992192*r**14-6315207379042*r**16+94439047897412*r**18
            -193807072386*r**20-13604238405696*r**22+34243787357860*r**24+19299740625288*r**26
            +8747563599284*r**28+1782706464640*r**30+148427332841*r**32-5194049434*r**34
            +30722577*r**36)-2*Q2*(-1+r**2)**2*(-118249269+3575973281*r**2-5623530549*r**4
            +234740892797*r**6+1836208260836*r**8-9996852457924*r**10+29312110771844*r**12
            -44151315493620*r**14-1710928557934*r**16+17167214336646*r**18+57624677920690*r**20
            +11564171066094*r**22-85679258525948*r**24+54210755289532*r**26-19265220977180*r**28
            +1783874857228*r**30-642679084869*r**32-35044298783*r**34-1785219045*r**36
            +3394173*r**38)-2*Q2**3*(-993263307+22081018543*r**2-62552095865*r**4
            +832180857301*r**6+5075523715652*r**8-16816997128740*r**10+46092640629324*r**12
            -37634472340236*r**14+3204140699126*r**16-4761395663470*r**18+64455011531506*r**20
            +22207609897958*r**22-178242988160908*r**24+137951741035660*r**26-63781094496996*r**28
            +8908732646916*r**30-2913226709475*r**32-171020841641*r**34-13501306337*r**36
            +33158989*r**38)+2*Q2**2*(-504779109+13595821541*r**2-47795564890*r**4
            +778643471081*r**6+3840784170581*r**8-21933179760564*r**10+67282002395592*r**12
            -106784411321732*r**14+46829933838910*r**16+51177173997502*r**18-68793930753340*r**20
            +40063792555798*r**22+187205378708794*r**24-299191598428148*r**26+177293826355848*r**28
            -58778729607492*r**30+7665005184119*r**32-2001636490747*r**34-114082815418*r**36
            -7269624631*r**38+15382305*r**40))*sqrtq2+logq2**7*(-338610585600000*r**28*(1
            +r**2)**2*(1-Q2+r**2)*(-1344-1280*r**2+2069*r**4-1954*r**6+165*r**8)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3-338610585600000*(Q2-(-1+r)**2)**2*r**28*(1
            +r**2)**2*(-1344-1280*r**2+2069*r**4-1954*r**6+165*r**8)*(Q2-(1+r)**2)**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**6*(-268738560000*r**24*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-480*Q2**10*(96+96*r**2
            +1255*r**4+1255*r**6)+240*Q2**9*(1136+4176*r**2+22897*r**4+44957*r**6
            +25100*r**8)-8*Q2**8*(-11616+412640*r**2+2714152*r**4+6765829*r**6+7843104*r**8
            +3309435*r**10)+Q2**7*(-3550464-2546304*r**2+34162723*r**4+121212049*r**6
            +202568457*r**8+180161511*r**10+65646540*r**12)-Q2**6*(-9201024-23546880*r**2
            -500261*r**4+111446616*r**6+281257514*r**8+365124696*r**10+280382571*r**12
            +96143040*r**14)+Q2**5*(-7623168-30921856*r**2-48564755*r**4+13478911*r**6
            +162579368*r**8+291350404*r**10+305055031*r**12+211227597*r**14+73688580*r**16)
            -Q2**4*(6814080+1935360*r**2-35855203*r**4-22823620*r**6+39837411*r**8
            +97594352*r**10+109556147*r**12+60087180*r**14+8518125*r**16+3162600*r**18)
            +(-1+r**2)**4*(-1656192-3247872*r**2-2802043*r**4-14966560*r**6-4252437*r**8
            -11317040*r**10-12539765*r**12+122016*r**14+6119013*r**16+3192720*r**18)
            +Q2**3*(21157632+33605760*r**2+7018949*r**4+74869335*r**6+52279981*r**8
            +26640299*r**10+67336971*r**12+33623749*r**14-25489233*r**16-96539463*r**18
            -50104620*r**20)-Q2*(-1+r**2)**2*(-9121536-16755072*r**2-17619355*r**4
            -99547599*r**6-77819861*r**8-35604821*r**10-79769865*r**12-45743617*r**14
            -655083*r**16+32258469*r**18+19593060*r**20)+Q2**2*(-20155776-21293056*r**2
            -5635085*r**4-173912096*r**6-185515180*r**8-108730160*r**10-50125166*r**12
            -77484592*r**14-63955436*r**16-48626192*r**18+46332819*r**20+47529360*r**22))
            -268738560000*r**24*(1+r**2)*(480*Q2**13*(96+96*r**2+1255*r**4+1255*r**6)
            -240*Q2**12*(1712+5328*r**2+31003*r**4+60017*r**6+32630*r**8)+8*Q2**11*(107904
            +919520*r**2+5405422*r**4+13266469*r**6+14524734*r**8+5794335*r**10)
            -Q2**10*(-2965248+10630272*r**2+129024211*r**4+395097913*r**6+608161329*r**8
            +492239487*r**10+163747380*r**12)+20*Q2**9*(-992928-1569504*r**2+8501625*r**4
            +39892271*r**6+80248386*r**8+93464610*r**10+63187893*r**12+18926655*r**14)
            -5*Q2**8*(-9194112-28102272*r**2-3091397*r**4+159932005*r**6+456703100*r**8
            +694214372*r**10+674290233*r**12+409770279*r**14+117106560*r**16)+20*Q2**7*(
            -2360448-10086912*r**2-15512658*r**4+11033135*r**6+83891231*r**8+167107818*r**10
            +205903536*r**12+175513191*r**14+100560771*r**16+28915200*r**18)+(-1
            +r**2)**6*(-1656192-4904064*r**2-6049915*r**4-17768603*r**6-19218997*r**8
            -15569477*r**10-23856805*r**12-12417749*r**14+6241029*r**16+9311733*r**18
            +3192720*r**20)-2*Q2**6*(4764672-31251840*r**2-146450209*r**4-62166373*r**6
            +309543647*r**8+825251287*r**10+1209919725*r**12+1196145541*r**14+863805897*r**16
            +451901097*r**18+138295980*r**20)+4*Q2**5*(24111936+45429696*r**2+8559208*r**4
            +92636029*r**6+175001467*r**8+179051347*r**10+210007631*r**12+212481293*r**14
            +102878129*r**16-22633863*r**18-79211619*r**20-28666710*r**22)-4*Q2*(
            -1+r**2)**4*(-3522528-9733152*r**2-13561219*r**4-44353584*r**6-57116005*r**8
            -50195089*r**10-47096343*r**12-46044521*r**14-16354231*r**16+13446405*r**18
            +19148502*r**20+7292805*r**22)+5*Q2**2*(-1+r**2)**2*(-10497792-22946432*r**2
            -26870979*r**4-119082483*r**6-162807048*r**8-168008516*r**10-147728938*r**12
            -94403130*r**14-90508588*r**16-40222292*r**18+18293669*r**20+47720517*r**22
            +23177340*r**24)+10*Q2**4*(-13987584-26111232*r**2-18115179*r**4-97707899*r**6
            -140271290*r**8-131606294*r**10-92437828*r**12-51287816*r**14-54251766*r**16
            -15430770*r**18+31899495*r**20+65913099*r**22+30933240*r**24)-20*Q2**3*(
            -5532288-6808128*r**2-2359510*r**4-44589643*r**6-40367977*r**8-41459178*r**10
            -56053388*r**12-34548270*r**14-7911626*r**16-22697676*r**18-20900726*r**20
            -9724863*r**22+15591819*r**24+12733230*r**26))*sqrtq2)+logq2**5*(-1492992000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7680*Q2**14*(96+96*r**2
            +1255*r**4+1255*r**6)-480*Q2**13*(28768+72768*r**2+354643*r**4+663230*r**6
            +352587*r**8)+8*Q2**12*(11471136+45421184*r**2+163071979*r**4+380660110*r**6
            +404305371*r**8+152536248*r**10)-8*Q2**11*(41644992+217735840*r**2+735756491*r**4
            +1814940948*r**6+2669473862*r**8+2015818188*r**10+601619631*r**12)+Q2**10*(765768768
            +4792251136*r**2+16589815911*r**4+41777585388*r**6+71795637890*r**8+76708465328*r**10
            +45420859335*r**12+11286389844*r**14)-10*Q2**9*(122208384+817107392*r**2
            +2898339661*r**4+7407799727*r**6+13676368232*r**8+17598415002*r**10+14926976977*r**12
            +7318476951*r**14+1517905818*r**16)+5*Q2**8*(302268864+1821592064*r**2
            +6186355995*r**4+14989765130*r**6+26502043701*r**8+35088638732*r**10
            +36051548869*r**12+26750778826*r**14+11124544299*r**16+1538157600*r**18)
            +4*Q2**7*(-399938304-1885071296*r**2-6126661341*r**4-11704004235*r**6
            -8771831859*r**8+8262489359*r**10+25381164789*r**12+22417261379*r**14
            +8241377795*r**16+3658195641*r**18+2424759768*r**20)-2*Q2**6*(-665530176
            -2935364480*r**2-13321513993*r**4-27159451904*r**6-4309011386*r**8+90075520620*r**10
            +219496301662*r**12+280391356972*r**14+216750717366*r**16+102522169844*r**18
            +35650556751*r**20+10411680852*r**22)+8*Q2**5*(-60441792-513935104*r**2
            -3429330429*r**4-9001254112*r**6-9565764165*r**8+7099833646*r**10+40679594211*r**12
            +69353773005*r**14+72332606558*r**16+51256767940*r**18+23922828568*r**20
            +7509541185*r**22+1825233609*r**24)-10*Q2**4*(52761024-122249344*r**2
            -195768501*r**4-1049281002*r**6-5259837603*r**8-4135569380*r**10+7932736296*r**12
            +19473400572*r**14+20032152328*r**16+11057617476*r**18+5039969869*r**20
            +3951360166*r**22+1501909659*r**24+46887912*r**26)+3*(-1+r**2)**4*(-8535744
            -73529344*r**2-1010863755*r**4-842691086*r**6+2442761669*r**8-2202336720*r**10
            -7693018922*r**12-6903632932*r**14-5029056522*r**16+633714976*r**18+3771705909*r**20
            +1698699186*r**22+261703557*r**24+69742128*r**26)-6*Q2*(-1+r**2)**2*(
            -32206464-175034688*r**2-2741922919*r**4-3311176031*r**6+4062593353*r**8
            -5263074041*r**10-22559109932*r**12-20374998914*r**14-16425728834*r**16
            -11685461486*r**18+2863484605*r**20+10345622945*r**22+4793952633*r**24
            +693447015*r**26+268262358*r**28)-20*Q2**3*(-45326976-58288896*r**2-1527320127*r**4
            -2867213011*r**6+403866159*r**8+52453141*r**10-3260433736*r**12-3006304938*r**14
            -3611466518*r**16-1819120210*r**18+5690620989*r**20+8440884973*r**22
            +3154525047*r**24+391226061*r**26+329172282*r**28)+Q2**2*(-594900672
            -1469234688*r**2-33242437193*r**4-30590761100*r**6+53777181978*r**8-84637415352*r**10
            -255538141959*r**12-191489234724*r**14-87456199860*r**16-85802037216*r**18
            -138366933015*r**20-33293002948*r**22+104078056922*r**24+59428626840*r**26
            +5770951143*r**28+4929277044*r**30))-1492992000*r**20*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(7680*Q2**14*(96+96*r**2+1255*r**4+1255*r**6)-480*Q2**13*(28768
            +72768*r**2+354643*r**4+663230*r**6+352587*r**8)+8*Q2**12*(11471136
            +45421184*r**2+163071979*r**4+380660110*r**6+404305371*r**8+152536248*r**10)
            -8*Q2**11*(41644992+217735840*r**2+735756491*r**4+1814940948*r**6+2669473862*r**8
            +2015818188*r**10+601619631*r**12)+Q2**10*(765768768+4792251136*r**2
            +16589815911*r**4+41777585388*r**6+71795637890*r**8+76708465328*r**10
            +45420859335*r**12+11286389844*r**14)-10*Q2**9*(122208384+817107392*r**2
            +2898339661*r**4+7407799727*r**6+13676368232*r**8+17598415002*r**10+14926976977*r**12
            +7318476951*r**14+1517905818*r**16)+5*Q2**8*(302268864+1821592064*r**2
            +6186355995*r**4+14989765130*r**6+26502043701*r**8+35088638732*r**10
            +36051548869*r**12+26750778826*r**14+11124544299*r**16+1538157600*r**18)
            +4*Q2**7*(-399938304-1885071296*r**2-6126661341*r**4-11704004235*r**6
            -8771831859*r**8+8262489359*r**10+25381164789*r**12+22417261379*r**14
            +8241377795*r**16+3658195641*r**18+2424759768*r**20)-2*Q2**6*(-665530176
            -2935364480*r**2-13321513993*r**4-27159451904*r**6-4309011386*r**8+90075520620*r**10
            +219496301662*r**12+280391356972*r**14+216750717366*r**16+102522169844*r**18
            +35650556751*r**20+10411680852*r**22)+8*Q2**5*(-60441792-513935104*r**2
            -3429330429*r**4-9001254112*r**6-9565764165*r**8+7099833646*r**10+40679594211*r**12
            +69353773005*r**14+72332606558*r**16+51256767940*r**18+23922828568*r**20
            +7509541185*r**22+1825233609*r**24)-10*Q2**4*(52761024-122249344*r**2
            -195768501*r**4-1049281002*r**6-5259837603*r**8-4135569380*r**10+7932736296*r**12
            +19473400572*r**14+20032152328*r**16+11057617476*r**18+5039969869*r**20
            +3951360166*r**22+1501909659*r**24+46887912*r**26)+3*(-1+r**2)**4*(-8535744
            -73529344*r**2-1010863755*r**4-842691086*r**6+2442761669*r**8-2202336720*r**10
            -7693018922*r**12-6903632932*r**14-5029056522*r**16+633714976*r**18+3771705909*r**20
            +1698699186*r**22+261703557*r**24+69742128*r**26)-6*Q2*(-1+r**2)**2*(
            -32206464-175034688*r**2-2741922919*r**4-3311176031*r**6+4062593353*r**8
            -5263074041*r**10-22559109932*r**12-20374998914*r**14-16425728834*r**16
            -11685461486*r**18+2863484605*r**20+10345622945*r**22+4793952633*r**24
            +693447015*r**26+268262358*r**28)-20*Q2**3*(-45326976-58288896*r**2-1527320127*r**4
            -2867213011*r**6+403866159*r**8+52453141*r**10-3260433736*r**12-3006304938*r**14
            -3611466518*r**16-1819120210*r**18+5690620989*r**20+8440884973*r**22
            +3154525047*r**24+391226061*r**26+329172282*r**28)+Q2**2*(-594900672
            -1469234688*r**2-33242437193*r**4-30590761100*r**6+53777181978*r**8-84637415352*r**10
            -255538141959*r**12-191489234724*r**14-87456199860*r**16-85802037216*r**18
            -138366933015*r**20-33293002948*r**22+104078056922*r**24+59428626840*r**26
            +5770951143*r**28+4929277044*r**30))*sqrtq2)+logq2**4*(-8294400*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-30720*Q2**18*(96+1255*r**4)+15360*Q2**17*(10640
            +12544*r**2+91358*r**4+96601*r**6)-192*Q2**16*(8898208+21432512*r**2
            +74529763*r**4+141304408*r**6+80107621*r**8)+8*Q2**15*(1091293632+3851969280*r**2
            +10723340225*r**4+23289537234*r**6+25177481601*r**8+9898382544*r**10)
            -16*Q2**14*(1664729760+7618081728*r**2+20765081687*r**4+46055774913*r**6
            +66189526878*r**8+49919966361*r**10+14836064325*r**12)+Q2**13*(52083264000
            +290014708992*r**2+838914905215*r**4+1879618075120*r**6+3091659327794*r**8
            +3250319328456*r**10+1863739896639*r**12+420420738360*r**14)-Q2**12*(66051083520
            +432285950208*r**2+1352913453501*r**4+3057685334517*r**6+5131324355374*r**8
            +6261411921678*r**10+5289020365941*r**12+2457505923741*r**14+356157103680*r**16)
            +2*Q2**11*(25362710784+196298326272*r**2+624410936634*r**4+1212502595805*r**6
            +1315092468720*r**8+472300582942*r**10+211343385210*r**12+873305337357*r**14
            +515693670156*r**16-76533077592*r**18)+2*Q2**10*(-6504505344-87437240064*r**2
            -103386033996*r**4+949164449823*r**6+5066483471999*r**8+13202563641526*r**10
            +19357262739574*r**12+15288314810511*r**14+5820542234703*r**16+1164750254460*r**18
            +381020384232*r**20)-Q2**9*(23360647680+39573736704*r**2+1216228187901*r**4
            +8348208370854*r**6+29815095211144*r**8+71280622741738*r**10+115208468453754*r**12
            +121126437419506*r**14+77056064092224*r**16+26527241671974*r**18+4836114524673*r**20
            +792163426200*r**22)+Q2**8*(41104124160+131382057216*r**2+2159177000715*r**4
            +11354316176625*r**6+37331124553002*r**8+88608750588238*r**10+152196164485548*r**12
            +187174141910940*r**14+157639621150910*r**16+81907973128122*r**18+23229023174913*r**20
            +3844069555947*r**22+149509498080*r**24)+4*Q2**7*(-8635424640-36417835776*r**2
            -600587286222*r**4-2264945505759*r**6-6490756673738*r**8-13186124803646*r**10
            -18400776026858*r**12-19888155228634*r**14-18233921454154*r**16-12097966876318*r**18
            -2815860725616*r**20+839346269853*r**22-58280145252*r**24+114339765720*r**26)
            -4*Q2**6*(-2806224768-36400966656*r**2-521888608958*r**4-1665586079097*r**6
            -5201534533079*r**8-7501749949054*r**10+1745574084972*r**12+22731607437436*r**14
            +40737881552036*r**16+40280831753688*r**18+27359794797250*r**20+16434615528097*r**22
            +6927976790295*r**24+641166962754*r**26+119558136684*r**28)+Q2**5*(7941969408
            -110461150464*r**2-1051802933131*r**4-5938986350988*r**6-24547880808270*r**8
            -41245694597244*r**10-13158641902605*r**12+80299521779640*r**14+193768028993676*r**16
            +245427089105664*r**18+207692012341995*r**20+129345624316684*r**22+66187922318466*r**24
            +24642150594492*r**26+2537407578861*r**28+143574183816*r**30)+9*(-1
            +r**2)**4*(16187136-388662528*r**2-5662052831*r**4-29307646557*r**6-181777742444*r**8
            +105369850900*r**10+743847147553*r**12-499160931333*r**14-1579505159496*r**16
            -1067873435112*r**18-20174803173*r**20+612737752673*r**22+316218511764*r**24
            +73719715028*r**26+40121786531*r**28+3248436737*r**30+37285152*r**32)
            +Q2**4*(-9880124160+22566404352*r**2-394230514807*r**4+3233526027437*r**6
            +7991641325942*r**8+11368422092094*r**10+20057994690051*r**12-3479053508841*r**14
            -65159967643044*r**16-94536379141764*r**18-63071305821033*r**20-34887643332653*r**22
            -33981936104402*r**24-19230217145018*r**26-4198442772003*r**28-836023270551*r**30
            +78611654400*r**32)-9*Q2*(-1+r**2)**2*(88505856-2582440192*r**2-36149492609*r**4
            -139503902708*r**6-1074861376571*r**8-107100191424*r**10+3260236066523*r**12
            -1167884749260*r**14-7522861392039*r**16-6794839518168*r**18-4339665445235*r**20
            +165166331060*r**22+3522612944447*r**24+1699932497072*r**26+330910513689*r**28
            +275078799628*r**30+22506577059*r**32+646192872*r**34)-6*Q2**3*(-487292160
            -8783397632*r**2-189539263370*r**4-73936604755*r**6-2947792292584*r**8
            -4028618102386*r**10+2523686283750*r**12+929274195915*r**14-3042921228600*r**16
            -4028232696852*r**18-4557884522158*r**20+6698343570851*r**22+13991029896040*r**24
            +4935705637630*r**26+726562187986*r**28+1327349302629*r**30+63712480056*r**32
            +14645765640*r**34)+6*Q2**2*(157217280-9625977088*r**2-138330056136*r**4
            -243742378147*r**6-3325939752679*r**8-275216865278*r**10+7589503303490*r**12
            -5905329892089*r**14-16978651976781*r**16-10608785056212*r**18-4954859159684*r**20
            -10833756606021*r**22-5243183322449*r**24+8983184659138*r**26+4840134910466*r**28
            +202221068257*r**30+1090201896069*r**32+81610500624*r**34+5597247240*r**36))
            -8294400*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(30720*Q2**19*(96
            +1255*r**4)-15360*Q2**18*(10832+12736*r**2+93868*r**4+99111*r**6)+192*Q2**17*(9749408
            +23287232*r**2+82841923*r**4+156341128*r**6+87835701*r**8)-8*Q2**16*(1304850624
            +4579906560*r**2+13026434825*r**4+28469557338*r**6+30491370297*r**8+11820965448*r**10)
            +8*Q2**15*(4420753152+20179426368*r**2+56105472879*r**4+126124427285*r**6
            +180846072591*r**8+134915796867*r**10+39570511194*r**12)-5*Q2**14*(15743788032
            +87707938560*r**2+258609103971*r**4+589750356144*r**6+977516831290*r**8
            +1021614244056*r**10+579967277523*r**12+131559553512*r**14)+4*Q2**13*(29533586880
            +193595980800*r**2+620460766927*r**4+1444054578713*r**6+2525650439572*r**8
            +3150847644482*r**10+2600769897759*r**12+1185416639685*r**14+194144460510*r**16)
            -Q2**12*(116776505088+890933686272*r**2+3034021276977*r**4+6835603979628*r**6
            +10819194627331*r**8+12337337442936*r**10+11973119058039*r**12+9493136964396*r**14
            +3845050367733*r**16+203090948496*r**18)-4*Q2**11*(-15933608064-154549138560*r**2
            -462047648451*r**4-443874541308*r**6+1269444203737*r**8+5707585294932*r**10
            +9336809385711*r**12+7101833043972*r**14+2215771613595*r**16+362794830948*r**18
            +228776730912*r**20)+Q2**10*(10351636992-148309754112*r**2+834581639781*r**4
            +10039765202508*r**6+41846391054788*r**8+107818716968788*r**10+180328121215954*r**12
            +190417592519676*r**14+119273778182652*r**16+40497826650300*r**18+7927655802057*r**20
            +1554204194664*r**22)-20*Q2**9*(3223238592+9715822080*r**2+170748946266*r**4
            +1045937636769*r**6+3774721406750*r**8+9485223427056*r**10+16934262784052*r**12
            +21175452389210*r**14+17791106133132*r**16+9274563944616*r**18+2729618968578*r**20
            +473617375341*r**22+47083646214*r**24)+Q2**8*(75645822720+318157524480*r**2
            +4692908202819*r**4+22573275200376*r**6+74648467424579*r**8+178684374355824*r**10
            +314408019181218*r**12+418922927311024*r**14+417749448878466*r**16+287939461784304*r**18
            +116400439205499*r**20+23715707651448*r**22+4226699635035*r**24-307849564800*r**26)
            +8*Q2**7*(-5720824704-40727113536*r**2-579446865478*r**4-2265559435539*r**6
            -6978618356288*r**8-13589315713219*r**10-14920663372766*r**12-7778661909028*r**14
            +1307902434624*r**16+4974471711608*r**18+6222983597658*r**20+7229050536167*r**22
            +3854521457448*r**24+348613291611*r**26+116948951202*r**28)-Q2**6*(-3282929664
            -267289916160*r**2-3284961235587*r**4-14688885103208*r**6-52016363256974*r**8
            -92058832525776*r**10-36183345358933*r**12+178208247869272*r**14+447645984951564*r**16
            +569501942328560*r**18+478254518545747*r**20+304523265618072*r**22+159638291592034*r**24
            +54918725606688*r**26+5580307976613*r**28+621806730552*r**30)+4*Q2**5*(4455523392
            -31271396352*r**2-192008392197*r**4-2556078827889*r**6-9619627121300*r**8
            -19290499374402*r**10-18615582797475*r**12+17654983346469*r**14+84806879604090*r**16
            +133432874310276*r**18+129047601817173*r**20+92981319997833*r**22+57378870684888*r**24
            +27515072514494*r**26+7844500236339*r**28+879251258307*r**30+16240632354*r**32)
            +9*(-1+r**2)**4*(16187136-372475392*r**2-6050715359*r**4-34969699388*r**6
            -211085389001*r**8-76407891544*r**10+849216998453*r**12+244686216220*r**14
            -2078666090829*r**16-2647378594608*r**18-1088048238285*r**20+592562949500*r**22
            +928956264437*r**24+389938226792*r**26+113841501559*r**28+43370223268*r**30
            +3285721889*r**32+37285152*r**34)+5*Q2**4*(-2560775424-8002821120*r**2
            -301779938135*r**4+479135176820*r**6-1292317280425*r**8-962329039256*r**10
            +9313706896929*r**12+4430917271340*r**14-17379309704697*r**16-36773148593184*r**18
            -36990998419149*r**20-11553777545716*r**22+3015319987837*r**24-4719583884728*r**26
            -3813857357821*r**28+585925954644*r**30-75027347163*r**32+33297249648*r**34)
            -36*Q2*(-1+r**2)**2*(26173248-728742784*r**2-10900118360*r**4-48506399685*r**6
            -335797445360*r**8-185585969691*r**10+876116394602*r**12+52716485431*r**14
            -2132020572644*r**16-3181431239415*r**18-2649609513962*r**20-1147321297567*r**22
            +689586869688*r**24+1319141471423*r**26+559935969750*r**28+150678473005*r**30
            +82811893724*r**32+6581659091*r**34+170869506*r**36)-12*Q2**3*(-165037440
            -9448333440*r**2-168326358569*r**4-253609123136*r**6-3173834325009*r**8
            -3625813630124*r**10+3042285742427*r**12-1226184706212*r**14-9546149504733*r**16
            -8839969490832*r**18-6770488189347*r**20-4346648778664*r**22+7723095072221*r**24
            +13954960096404*r**26+5251201368041*r**28+1128066279436*r**30+1240631839377*r**32
            +79984373160*r**34+10121506440*r**36)+3*Q2**2*(579952128-27215875328*r**2
            -388600385555*r**4-973506941612*r**6-9635373452944*r**8-1492957258884*r**10
            +21827298094824*r**12-20018024398388*r**14-51548531218728*r**16-33925878516036*r**18
            -25945831834606*r**20-25428258421324*r**22-35596035345664*r**24-8060378508908*r**26
            +29007614531184*r**28+14024282765412*r**30+1994624403128*r**32+3035760308532*r**34
            +238058069673*r**36+13133073096*r**38))*sqrtq2)+logq2**3*(138240*r**12*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(30720*Q2**21*(6112
            +44739*r**4)-512*Q2**20*(5793696+6902464*r**2+34430505*r**4+41137164*r**6)
            +320*Q2**19*(65255712+146287936*r**2+395225177*r**4+745243014*r**6+448149261*r**8)
            -80*Q2**18*(1056645408+3440963712*r**2+7855254379*r**4+16366758510*r**6
            +17866269147*r**8+6978617496*r**10)+80*Q2**17*(2664010368+11546008160*r**2
            +27231219237*r**4+56516080882*r**6+80805942484*r**8+60628732374*r**10
            +16410679983*r**12)-5*Q2**16*(66639701568+380030197376*r**2+994402026039*r**4
            +2052392675472*r**6+3185050031762*r**8+3341685882824*r**10+1932930274887*r**12
            +337866733176*r**14)+8*Q2**15*(34470437856+292043791104*r**2+797109400975*r**4
            +1518333108294*r**6+1942024926105*r**8+1841151774796*r**10+1938252431769*r**12
            +1159855821870*r**14+37983711519*r**16)+40*Q2**14*(384632352-32433241184*r**2
            -17140107654*r**4+221150527663*r**6+962842235924*r**8+2202036823875*r**10
            +2341486169314*r**12+945388648893*r**14+108729843744*r**16+70896249441*r**18)
            -40*Q2**13*(7714714272+17882695168*r**2+343331249416*r**4+1685138899533*r**6
            +4786085239617*r**8+9994061471067*r**10+13601071883271*r**12+10382044214035*r**14
            +3797280491679*r**16+649554453573*r**18+116296965489*r**20)+20*Q2**12*(15876355584
            +100902390720*r**2+1350934158243*r**4+6708371137602*r**6+19555396530726*r**8
            +41797825841768*r**10+64541372903070*r**12+65991176277612*r**14+38980035581382*r**16
            +10936181313144*r**18+1667837745267*r**20+103881128274*r**22)+40*Q2**11*(
            -2001611808-46528497664*r**2-650525443011*r**4-3659781326664*r**6-11478871706613*r**8
            -24261635683104*r**10-36964664873602*r**12-42037033543628*r**14-34907741123418*r**16
            -16076260586184*r**18-2100893151811*r**20-298765585668*r**22+70212192759*r**24)
            -8*Q2**10*(14483783904-124897410464*r**2-1372022746510*r**4-11093606057679*r**6
            -33126353869890*r**8-37418908537429*r**10+27073783245894*r**12+148344547850130*r**14
            +178043169268114*r**16+84336717153510*r**18+34592826870904*r**20+25754870628701*r**22
            +2602097631840*r**24+560302125231*r**26)+40*Q2**9*(3072247008-3543655296*r**2
            +138454795250*r**4-368484004767*r**6+2442351984093*r**8+26350671026281*r**10
            +95106889641255*r**12+203339848201002*r**14+271843507384426*r**16+220673236850610*r**18
            +104682087456792*r**20+32915282850773*r**22+8993777647641*r**24+819353207301*r**26
            +39218888079*r**28)+10*Q2**8*(-3500327232-59287629568*r**2-1401967593141*r**4
            -2936961657596*r**6-37356625968566*r**8-189212476446624*r**10-598270281303043*r**12
            -1299271188451852*r**14-1953561665075364*r**16-1983523652854720*r**18
            -1286250182952195*r**20-517435433029044*r**22-141843250925174*r**24-19820361900128*r**26
            -1618970450613*r**28+162682021116*r**30)-40*Q2**7*(592596192-22762366720*r**2
            -328281803325*r**4-1119340061766*r**6-10649709896995*r**8-36413440119444*r**10
            -103675964364957*r**12-214461665353130*r**14-324281425485331*r**16-373637660120520*r**18
            -296904107065327*r**20-126568572122266*r**22-26517449087841*r**24-11062425834436*r**26
            +2142174685673*r**28+158506806186*r**30+45139844247*r**32)+40*Q2**6*(701708640
            -13826938656*r**2-155898225722*r**4-1195150046595*r**6-9109433957712*r**8
            -23521971437275*r**10-60702106394586*r**12-67064622586527*r**14+20049873502344*r**16
            +137943949911369*r**18+184404657955290*r**20+173985031605671*r**22+174151516079016*r**24
            +104052625842303*r**26+15217865244730*r**28+4970080321467*r**30+339610331328*r**32
            +7739120115*r**34)+8*Q2**5*(-1274527584-3480659456*r**2-48779552340*r**4
            +4896987262969*r**6+30568564836005*r**8+129620723492259*r**10+380201580554951*r**12
            +397289017898865*r**14-259364544840339*r**16-1370742053664285*r**18-2135438231230321*r**20
            -2066032377223149*r**22-1528004748188425*r**24-1088632657095119*r**26
            -575314924711395*r**28-102691162245629*r**30-14210644958121*r**32-889097918775*r**34
            +58387889889*r**36)+9*(-1+r**2)**4*(-2484288-366767744*r**2-93318523*r**4
            +168359170268*r**6+1292183575272*r**8+2434434405524*r**10+15188930778572*r**12
            -30068290816516*r**14-86884917244744*r**16+93388822250484*r**18+182238056595566*r**20
            +25584773264788*r**22-72732039395624*r**24-27931753399716*r**26-4551887974484*r**28
            -7501718503052*r**30-1225152130616*r**32-85351386212*r**34-2234392683*r**36
            +273373728*r**38)-20*Q2**4*(117866112-11979281984*r**2-122903898851*r**4
            +677168297466*r**6+577490517210*r**8+35636615424752*r**10+64794645328008*r**12
            +52280477733992*r**14+26502919739622*r**16-125316818363424*r**18-351525557678890*r**20
            -323066350036324*r**22-174946775755866*r**24-177822604660752*r**26-135415643162552*r**28
            -54227273496024*r**30-17709339160550*r**32-111153705600*r**34+7062864189*r**36
            +14170613466*r**38)+120*Q2**3*(34609632-996124672*r**2-12081009399*r**4
            -108311336116*r**6-1482581215945*r**8+418660523600*r**10-15156356497944*r**12
            -15646611071684*r**14+13183022916364*r**16+4558888181368*r**18-8846020584502*r**20
            -19546550234436*r**22+15502568083450*r**24+63011798480800*r**26+20082206763664*r**28
            -286283884764*r**30+10675198708652*r**32+543637069208*r**34+282836049077*r**36
            +17798075288*r**38+3298359*r**40)-360*Q2*(-1+r**2)**2*(-979872-40645632*r**2
            +141564912*r**4+24447349429*r**6+196008021175*r**8+332904490098*r**10
            +2442984544278*r**12-2074277932458*r**14-9890194512326*r**16+4199029406746*r**18
            +20309920373246*r**20+16544388677040*r**22+947342953160*r**24-9699196199050*r**26
            -3853029979902*r**28-192138753078*r**30-1218100411386*r**32-189395213314*r**34
            -17725871878*r**36-717262469*r**38+55501281*r**40)+120*Q2**2*(-15230112
            +24615200*r**2+3462608464*r**4+153435574223*r**6+1314861429608*r**8+796086668733*r**10
            +16492917708874*r**12-9107534060380*r**14-40189876767578*r**16+30132958555620*r**18
            +62521019957794*r**20+36031659652170*r**22+50171347814398*r**24+34484378801302*r**26
            -48123039183714*r**28-23727722172604*r**30+6531636327058*r**32-8995300033132*r**34
            -1131700453722*r**36-174691724289*r**38-9924377086*r**40+445009173*r**42))
            +138240*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(30720*Q2**21*(6112
            +44739*r**4)-512*Q2**20*(5793696+6902464*r**2+34430505*r**4+41137164*r**6)
            +320*Q2**19*(65255712+146287936*r**2+395225177*r**4+745243014*r**6+448149261*r**8)
            -80*Q2**18*(1056645408+3440963712*r**2+7855254379*r**4+16366758510*r**6
            +17866269147*r**8+6978617496*r**10)+80*Q2**17*(2664010368+11546008160*r**2
            +27231219237*r**4+56516080882*r**6+80805942484*r**8+60628732374*r**10
            +16410679983*r**12)-5*Q2**16*(66639701568+380030197376*r**2+994402026039*r**4
            +2052392675472*r**6+3185050031762*r**8+3341685882824*r**10+1932930274887*r**12
            +337866733176*r**14)+8*Q2**15*(34470437856+292043791104*r**2+797109400975*r**4
            +1518333108294*r**6+1942024926105*r**8+1841151774796*r**10+1938252431769*r**12
            +1159855821870*r**14+37983711519*r**16)+40*Q2**14*(384632352-32433241184*r**2
            -17140107654*r**4+221150527663*r**6+962842235924*r**8+2202036823875*r**10
            +2341486169314*r**12+945388648893*r**14+108729843744*r**16+70896249441*r**18)
            -40*Q2**13*(7714714272+17882695168*r**2+343331249416*r**4+1685138899533*r**6
            +4786085239617*r**8+9994061471067*r**10+13601071883271*r**12+10382044214035*r**14
            +3797280491679*r**16+649554453573*r**18+116296965489*r**20)+20*Q2**12*(15876355584
            +100902390720*r**2+1350934158243*r**4+6708371137602*r**6+19555396530726*r**8
            +41797825841768*r**10+64541372903070*r**12+65991176277612*r**14+38980035581382*r**16
            +10936181313144*r**18+1667837745267*r**20+103881128274*r**22)+40*Q2**11*(
            -2001611808-46528497664*r**2-650525443011*r**4-3659781326664*r**6-11478871706613*r**8
            -24261635683104*r**10-36964664873602*r**12-42037033543628*r**14-34907741123418*r**16
            -16076260586184*r**18-2100893151811*r**20-298765585668*r**22+70212192759*r**24)
            -8*Q2**10*(14483783904-124897410464*r**2-1372022746510*r**4-11093606057679*r**6
            -33126353869890*r**8-37418908537429*r**10+27073783245894*r**12+148344547850130*r**14
            +178043169268114*r**16+84336717153510*r**18+34592826870904*r**20+25754870628701*r**22
            +2602097631840*r**24+560302125231*r**26)+40*Q2**9*(3072247008-3543655296*r**2
            +138454795250*r**4-368484004767*r**6+2442351984093*r**8+26350671026281*r**10
            +95106889641255*r**12+203339848201002*r**14+271843507384426*r**16+220673236850610*r**18
            +104682087456792*r**20+32915282850773*r**22+8993777647641*r**24+819353207301*r**26
            +39218888079*r**28)+10*Q2**8*(-3500327232-59287629568*r**2-1401967593141*r**4
            -2936961657596*r**6-37356625968566*r**8-189212476446624*r**10-598270281303043*r**12
            -1299271188451852*r**14-1953561665075364*r**16-1983523652854720*r**18
            -1286250182952195*r**20-517435433029044*r**22-141843250925174*r**24-19820361900128*r**26
            -1618970450613*r**28+162682021116*r**30)-40*Q2**7*(592596192-22762366720*r**2
            -328281803325*r**4-1119340061766*r**6-10649709896995*r**8-36413440119444*r**10
            -103675964364957*r**12-214461665353130*r**14-324281425485331*r**16-373637660120520*r**18
            -296904107065327*r**20-126568572122266*r**22-26517449087841*r**24-11062425834436*r**26
            +2142174685673*r**28+158506806186*r**30+45139844247*r**32)+40*Q2**6*(701708640
            -13826938656*r**2-155898225722*r**4-1195150046595*r**6-9109433957712*r**8
            -23521971437275*r**10-60702106394586*r**12-67064622586527*r**14+20049873502344*r**16
            +137943949911369*r**18+184404657955290*r**20+173985031605671*r**22+174151516079016*r**24
            +104052625842303*r**26+15217865244730*r**28+4970080321467*r**30+339610331328*r**32
            +7739120115*r**34)+8*Q2**5*(-1274527584-3480659456*r**2-48779552340*r**4
            +4896987262969*r**6+30568564836005*r**8+129620723492259*r**10+380201580554951*r**12
            +397289017898865*r**14-259364544840339*r**16-1370742053664285*r**18-2135438231230321*r**20
            -2066032377223149*r**22-1528004748188425*r**24-1088632657095119*r**26
            -575314924711395*r**28-102691162245629*r**30-14210644958121*r**32-889097918775*r**34
            +58387889889*r**36)+9*(-1+r**2)**4*(-2484288-366767744*r**2-93318523*r**4
            +168359170268*r**6+1292183575272*r**8+2434434405524*r**10+15188930778572*r**12
            -30068290816516*r**14-86884917244744*r**16+93388822250484*r**18+182238056595566*r**20
            +25584773264788*r**22-72732039395624*r**24-27931753399716*r**26-4551887974484*r**28
            -7501718503052*r**30-1225152130616*r**32-85351386212*r**34-2234392683*r**36
            +273373728*r**38)-20*Q2**4*(117866112-11979281984*r**2-122903898851*r**4
            +677168297466*r**6+577490517210*r**8+35636615424752*r**10+64794645328008*r**12
            +52280477733992*r**14+26502919739622*r**16-125316818363424*r**18-351525557678890*r**20
            -323066350036324*r**22-174946775755866*r**24-177822604660752*r**26-135415643162552*r**28
            -54227273496024*r**30-17709339160550*r**32-111153705600*r**34+7062864189*r**36
            +14170613466*r**38)+120*Q2**3*(34609632-996124672*r**2-12081009399*r**4
            -108311336116*r**6-1482581215945*r**8+418660523600*r**10-15156356497944*r**12
            -15646611071684*r**14+13183022916364*r**16+4558888181368*r**18-8846020584502*r**20
            -19546550234436*r**22+15502568083450*r**24+63011798480800*r**26+20082206763664*r**28
            -286283884764*r**30+10675198708652*r**32+543637069208*r**34+282836049077*r**36
            +17798075288*r**38+3298359*r**40)-360*Q2*(-1+r**2)**2*(-979872-40645632*r**2
            +141564912*r**4+24447349429*r**6+196008021175*r**8+332904490098*r**10
            +2442984544278*r**12-2074277932458*r**14-9890194512326*r**16+4199029406746*r**18
            +20309920373246*r**20+16544388677040*r**22+947342953160*r**24-9699196199050*r**26
            -3853029979902*r**28-192138753078*r**30-1218100411386*r**32-189395213314*r**34
            -17725871878*r**36-717262469*r**38+55501281*r**40)+120*Q2**2*(-15230112
            +24615200*r**2+3462608464*r**4+153435574223*r**6+1314861429608*r**8+796086668733*r**10
            +16492917708874*r**12-9107534060380*r**14-40189876767578*r**16+30132958555620*r**18
            +62521019957794*r**20+36031659652170*r**22+50171347814398*r**24+34484378801302*r**26
            -48123039183714*r**28-23727722172604*r**30+6531636327058*r**32-8995300033132*r**34
            -1131700453722*r**36-174691724289*r**38-9924377086*r**40+445009173*r**42))*sqrtq2)
            +logq2**2*(-2304*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-6144*Q2**24*(163744
            +711897*r**4)+512*Q2**23*(27134112+25309952*r**2+99107931*r**4+121840866*r**6)
            -32*Q2**22*(2612488608+4956246592*r**2+10615459377*r**4+20433495586*r**6
            +12057589329*r**8)+32*Q2**21*(8861208072+26203616928*r**2+50236538969*r**4
            +101280585716*r**6+112986880549*r**8+41228496546*r**10)-8*Q2**20*(71685525792
            +309699620352*r**2+622671759528*r**4+1202915276113*r**6+1716316349013*r**8
            +1355603360351*r**10+316075394451*r**12)+Q2**19*(623155609344+4312174761600*r**2
            +8331815564817*r**4+14532151960180*r**6+19553300625310*r**8+22733074387264*r**10
            +17136889025825*r**12+1882597430172*r**14)+Q2**18*(-76187112576-3850955389056*r**2
            +119558164387*r**4+14151765757307*r**6+47887566058770*r**8+79682978324274*r**10
            +35564383982219*r**12-4902934111693*r**14+2808698416032*r**16)-Q2**17*(753420754176
            +444152194944*r**2+35711644350579*r**4+142236078781592*r**6+342129111078433*r**8
            +623555674426116*r**10+631384482244149*r**12+263625001765904*r**14+37197684451927*r**16
            +8498026195188*r**18)+Q2**16*(925508717184+5853876567936*r**2+87315815058303*r**4
            +391996483952607*r**6+980889173923553*r**8+1889432599833521*r**10+2505893394468481*r**12
            +1860836084863793*r**14+581157076268207*r**16+79345879428863*r**18+6885792324912*r**20)
            +4*Q2**15*(-35952593664-1852938294144*r**2-25294261299131*r**4-150966075477636*r**6
            -411250285111766*r**8-802314180083696*r**10-1166890624083866*r**12-1188543063004696*r**14
            -688278411360286*r**16-130371238451616*r**18-15149491562647*r**20+983018517708*r**22)
            -4*Q2**14*(158803634304-895871881600*r**2-8888847886383*r**4-123768299328415*r**6
            -325455366097030*r**8-482334667591654*r**10-400448734320370*r**12-224202080708322*r**14
            -373940732371550*r**16-234761917726430*r**18+81587535578469*r**20+8078033285125*r**22
            +3020480614752*r**24)+4*Q2**13*(135056908416+532417315456*r**2+15757393379133*r**4
            -6861813869712*r**6+200141351658735*r**8+1222179533432244*r**10+3560545346437004*r**12
            +6501979699862992*r**14+6600991470169492*r**16+3333412842209520*r**18
            +1033034804181991*r**20+347799089894256*r**22+29056871703693*r**24+1654842977388*r**26)
            +4*Q2**12*(9768834816-1256862312576*r**2-24274276411201*r**4-106358421777253*r**6
            -847879172053427*r**8-3663609389524131*r**10-9935321011625864*r**12-19077709530267884*r**14
            -24532929653644612*r**16-18720354107602148*r**18-7625225608703619*r**20
            -2032712113319791*r**22-334201532157001*r**24-23516679541433*r**26+1287774679308*r**28)
            +2*Q2**11*(-145923410688+1756902196608*r**2+23169923415159*r**4+256581404597116*r**6
            +2008829720657154*r**8+9489771218005184*r**10+27417273092639817*r**12
            +54707989350397036*r**14+78533727503023244*r**16+77860286118576256*r**18
            +45426915377470721*r**20+12285696777348948*r**22+2849239929368674*r**24
            -45540448929984*r**26-7650360179761*r**28-4071932164284*r**30)+2*Q2**10*(71299108992
            -39679241088*r**2+6561276714933*r**4-154796844056147*r**6-1135228173009842*r**8
            -7052996487463826*r**10-20548043901894621*r**12-33784462795664293*r**14
            -36204947613007948*r**16-30651209926196428*r**18-25791196348372189*r**20
            -8063721186875509*r**22+6266528892019918*r**24+980120745325678*r**26+659132433577333*r**28
            +44724782069981*r**30+785413344576*r**32)+2*Q2**9*(11896649472-899777308800*r**2
            -13004443504109*r**4+33960022965320*r**6-5633862259335*r**8+2511668518427988*r**10
            +1266647148918295*r**12-29065163327294336*r**14-106655441425207035*r**16
            -194993645115843540*r**18-203422307155831647*r**20-123824430928085080*r**22
            -55713251955631901*r**24-23394534721655220*r**26-3729235552167435*r**28
            -514913580899248*r**30-29776293755425*r**32+1724031022836*r**34)+2*Q2**8*(
            -28032655488+675533430912*r**2+5954115608481*r**4+55900711679041*r**6
            +750413062255655*r**8+1000070059509063*r**10+15672016923771813*r**12+79650385100234309*r**14
            +231490055676909859*r**16+435254897763603555*r**18+542571267737148363*r**20
            +432647450597537163*r**22+221761928897194349*r**24+83300795844151309*r**26
            +19627890747576015*r**28+3039765236184687*r**30-28757098254263*r**32-5874547027639*r**34
            -1121679180384*r**36)-4*Q2**7*(-7708851456+52440717696*r**2+512630138631*r**4
            +49630149592548*r**6+473474679613262*r**8+1086689183376176*r**10+8941223768267084*r**12
            +31091285160977344*r**14+87393357036112762*r**16+172423701267976768*r**18
            +242411359855629486*r**20+235514559738133464*r**22+134756301795378594*r**24
            +48369521712044272*r**26+21758831545866148*r**28+49337353913344*r**30
            +167722087245206*r**32-136639190443744*r**34-9273555189157*r**36+105509725572*r**38)
            +4*Q2**6*(-1298565504-85626224256*r**2-242750337613*r**4+37816419556923*r**6
            +295680169748582*r**8+1074394322681822*r**10+7280533117817196*r**12+15975400018465628*r**14
            +36745045534731002*r**16+36877332159984378*r**18+8169899939312726*r**20
            -6353576419920554*r**22-21565999386857982*r**24-74778122639688398*r**26
            -69573904486290812*r**28-9840892657246572*r**30-6451588400819786*r**32
            -739677676594058*r**34-70679089245177*r**36-3740428108673*r**38+218887681128*r**40)
            -4*Q2**5*(2026601664-75142846336*r**2-521787733809*r**4+7933788824416*r**6
            +34793844958381*r**8+1188321511269628*r**10+6636481366148758*r**12+19829744867211424*r**14
            +44455989497082034*r**16+21276188841763144*r**18-72515739673155516*r**20
            -164816410128599216*r**22-170313714421154596*r**24-128274398098173616*r**26
            -127763228060550406*r**28-97544822313467008*r**30-21917501593647298*r**32
            -5060945816023144*r**34-663485173495459*r**36+7857531006256*r**38+1480385713607*r**40
            +42109867092*r**42)+9*(-1+r**2)**4*(-10936704+236968320*r**2+3685239423*r**4
            +28930351515*r**6-528215584605*r**8-30403230967929*r**10-89505680005380*r**12
            +74252309568268*r**14-1099766522892420*r**16+3123583583127740*r**18+5351323332019586*r**20
            -11010356961901830*r**22-8039096781489542*r**24+5939568929059170*r**26
            +2326737832634460*r**28-574334931501444*r**30+639226150299020*r**32+153303655092588*r**34
            +18960578011735*r**36+1845806621155*r**38-69098233509*r**40-6657039505*r**42
            +139959888*r**44)-4*Q2**4*(-1717118016+22027817600*r**2+342491414397*r**4
            +9636451045495*r**6+74133364745565*r**8-844502575879911*r**10-1859007523902720*r**12
            -15337505051540478*r**14-21796593341456130*r**16-6155274175731090*r**18
            +15118746534656684*r**20+48430723850831040*r**22+88386232725787432*r**24
            +61723958912900400*r**26+38554805780069610*r**28+37194720360657054*r**30
            +26320117444620930*r**32+11960434068634482*r**34+856552759767735*r**36
            +164304983514665*r**38-19994078597061*r**40-1683517421225*r**42+35972383542*r**44)
            -9*Q2*(-1+r**2)**2*(-74278656+1844132224*r**2+23382462707*r**4-52829277858*r**6
            -2855053610950*r**8-161928045051206*r**10-661393275703101*r**12+255332994094332*r**14
            -5995482498198568*r**16+8855497006619800*r**18+26722329264876854*r**20
            -17872494039525916*r**22-60301429858697188*r**24-20004567723494948*r**26
            +31567230244796750*r**28+11188432343822784*r**30-4440443945204136*r**32
            +4124093254294552*r**34+857320908156407*r**36+133296471003150*r**38+15671426276474*r**40
            -397013493446*r**42-48991983153*r**44+835183092*r**46)+3*Q2**3*(-267025152
            -12740076672*r**2-4034479101*r**4+11390890213564*r**6+66772387820410*r**8
            +187341933222208*r**10+5307872540470263*r**12-4944095885515356*r**14+36564171679701144*r**16
            +31613340002926720*r**18-29374261722874362*r**20-4346815593619432*r**22
            +24201051413842524*r**24-20592426698729216*r**26-124571753600594170*r**28
            -33969582039900792*r**30+18025225865652888*r**32-36756331516248576*r**34
            -68503071695881*r**36-1423547653805460*r**38-156789330576902*r**40-7651979332672*r**42
            -359866175741*r**44+22317199764*r**46)+3*Q2**2*(-449185152+15767268992*r**2
            +136000221657*r**4-3582156495359*r**6-23563337649386*r**8-833660836817802*r**10
            -4823173640132803*r**12+4430376638038197*r**14-41779552481620984*r**16
            +38593795940791784*r**18+89053295529137618*r**20-64258346549154718*r**22
            -95095189000462908*r**24-156365840085080444*r**26-124084374085147486*r**28
            +143764112152581778*r**30+73546875415219752*r**32-52303043156789528*r**34
            +30571093921242901*r**36+4071204241517789*r**38+1061347815193558*r**40
            +148242077886902*r**42-1049906000543*r**44-301350639239*r**46+1299275424*r**48))
            -2304*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(6144*Q2**25*(163744
            +711897*r**4)-2560*Q2**24*(5819808+5454976*r**2+21530139*r**4+26076726*r**6)
            +32*Q2**23*(3046634400+5795351616*r**2+12606145505*r**4+23968676338*r**6
            +14007043185*r**8)-32*Q2**22*(11473696680+33772352128*r**2+65808244938*r**4
            +132329540679*r**6+145477965464*r**8+53286085875*r**10)+8*Q2**21*(107130358080
            +449958920352*r**2+928432383116*r**4+1808983774853*r**6+2573386214073*r**8
            +1972464868731*r**10+480989380635*r**12)-Q2**20*(1196639815680+7363255930752*r**2
            +15790786603857*r**4+29136848245308*r**6+42907153626318*r**8+47308432062176*r**10
            +30510319064241*r**12+4411200585780*r**14)-10*Q2**19*(-69934272192-878628576000*r**2
            -1252443216203*r**4-871220176769*r**6+1380211347328*r**8+3739660331170*r**10
            -430557943087*r**12-2392242056769*r**14+92610098586*r**16)+2*Q2**18*(338616820800
            -1741495153344*r**2+15990123562955*r**4+78253701351643*r**6+202084221447255*r**8
            +375563109404580*r**10+373315922275321*r**12+147143225818215*r**14+17551724378133*r**16
            +5653362305610*r**18)-2*Q2**17*(839464735680+3525724758528*r**2+61735805801913*r**4
            +284972103542389*r**6+732627181891789*r**8+1427558692669035*r**10+1880416775569373*r**12
            +1377922784436923*r**14+440989881243019*r**16+62520795037989*r**18+7691909260050*r**20)
            +Q2**16*(1069319091840+14191138461696*r**2+194346736822763*r**4+1083176600921454*r**6
            +3017886798323224*r**8+6079578494091858*r**10+9062888490637466*r**12+9120901731351058*r**14
            +5195106806573144*r**16+1181987909503534*r**18+146829638004363*r**20+2953718254080*r**22)
            +8*Q2**15*(61425520320-1392381384704*r**2-18018023739829*r**4-150014318052591*r**6
            -443835863343216*r**8-847949566393558*r**10-1184826769243966*r**12-1289817883898442*r**14
            -1125381103368266*r**16-526705783769166*r**18-31966597217897*r**20-3044219879907*r**22
            +2001749566230*r**24)-40*Q2**14*(29386054272-20465093184*r**2+597267361115*r**4
            -13951896108451*r**6-24908231376671*r**8+41438949974356*r**10+267776194452498*r**12
            +587732888483430*r**14+600284865708962*r**16+272471019211154*r**18+87986042203403*r**20
            +43746465875785*r**22+4015538560357*r**24+467532359214*r**26)+8*Q2**13*(62644036800
            +962168268224*r**2+20282043552895*r**4+57627000643337*r**6+520579354921225*r**8
            +2542965137307555*r**10+7359022945747556*r**12+14570117288283940*r**14
            +18817950411838548*r**16+14327379209990580*r**18+5995836627547565*r**20
            +1706773003698019*r**22+355528746877475*r**24+27114197111257*r**26+183534149040*r**28)
            +2*Q2**12*(165461080320-4251089152128*r**2-74232200862713*r**4-517846800974024*r**6
            -3917304908318514*r**8-18512748341160300*r**10-54615133894939807*r**12
            -112734050434184532*r**14-165755005870848236*r**16-164366853641069776*r**18
            -98118074810082255*r**20-31601572221395768*r**22-7583067220322258*r**24
            -669895974466884*r**26-36807449544489*r**28+6647481522900*r**30)-4*Q2**11*(108611259840
            -825329013504*r**2-9182774448417*r**4-217274086034211*r**6-1700319649132056*r**8
            -9275798713063082*r**10-28727544106269811*r**12-57954862619350573*r**14
            -84723332233214114*r**16-93522611773897964*r**18-74539198922209583*r**20
            -32888166670847589*r**22-4434203907348852*r**24-911789367556506*r**26
            +356161621343539*r**28+28223537207013*r**30+2428672754430*r**32)-4*Q2**10*(
            -29701229760-465698588352*r**2-9763020488977*r**4+91097795153267*r**6
            +642195577403327*r**8+5349946589450828*r**10+14433843769138371*r**12+12633671685132289*r**14
            -18333015508267397*r**16-64068743788319582*r**18-73489950440631515*r**20
            -44984756696418691*r**22-26958029830388155*r**24-15320592179500408*r**26
            -2684244365535223*r**28-609385398273281*r**30-37643244584991*r**32+469308839130*r**34)
            +20*Q2**9*(3992930496-156341409024*r**2-1985833642139*r**4-3494513221783*r**6
            -72208690154967*r**8+150596459665959*r**10-1189370125642553*r**12-10744890127861035*r**14
            -36721066042941123*r**16-73690398430465413*r**18-94098722000882355*r**20
            -75989418868145389*r**22-40129961178091133*r**24-16240858252143843*r**26
            -4675166102139867*r**28-728391436925137*r**30-51593277640041*r**32-2217771570495*r**34
            +284571020322*r**36)+2*Q2**8*(-43450358400+752382210816*r**2+7654909316655*r**4
            +161115126472618*r**6+1753263133161220*r**8+3923861488517070*r**10+34554534519815044*r**12
            +157504972345960810*r**14+485927154849369692*r**16+1011592355976466950*r**18
            +1462648885212010890*r**20+1446247837810952454*r**22+923921983085488700*r**24
            +401801768165434202*r**26+146446349683459620*r**28+22766330691587390*r**30
            +3346452312420836*r**32-307910026169390*r**34-25543336586337*r**36-910659729240*r**38)
            -8*Q2**7*(-4503708480-20447179008*r**2+161160259357*r**4+43979599644051*r**6
            +409392499477196*r**8+1317279092835630*r**10+8654223034730228*r**12+28003954473855028*r**14
            +77614843865910554*r**16+148347195232036954*r**18+211502480531459490*r**20
            +235786171586921198*r**22+174352431073327038*r**24+54173850433867234*r**26
            +277224385809804*r**28+5983638121266460*r**30-3117264479830618*r**32-354297389896298*r**34
            -108295917439039*r**36-6454236786129*r**38+162198703350*r**40)+8*Q2**6*(364018080
            -81033818048*r**2-425082147839*r**4+22753729021863*r**6+184145217131943*r**8
            +1279198001850016*r**10+7495704403323888*r**12+21542839001747124*r**14
            +48588217525139332*r**16+47449283268239262*r**18-13734253786929206*r**20
            -81500043304603522*r**22-99116645113966566*r**24-112309260062359998*r**26
            -136057627593264808*r**28-88479809728502196*r**30-19104991325856828*r**32
            -6126105946718494*r**34-736920969667347*r**36-33280993173797*r**38-1020577356969*r**40
            +130498774110*r**42)-8*Q2**5*(1871859840-47572031136*r**2-469710997271*r**4
            -1112224977444*r**6-15702865481384*r**8+1033808966053960*r**10+4841905200660553*r**12
            +20901865642450330*r**14+43041163852874794*r**16+35943726257288134*r**18
            -33179148683024528*r**20-142881436826292886*r**22-211758178637770622*r**24
            -180156035716114306*r**26-147296215969396816*r**28-131251385367337234*r**30
            -72891220675867618*r**32-19469440739152462*r**34-3290491874643169*r**36
            -409966313001934*r**38+14665997658462*r**40+1603006500962*r**42+3068741775*r**44)
            +9*(-1+r**2)**4*(-10936704+226031616*r**2+3922207743*r**4+32615590938*r**6
            -499285233090*r**8-30931446552534*r**10-119908910973309*r**12-15253370437112*r**14
            -1025514213324152*r**16+2023817060235320*r**18+8474906915147326*r**20
            -5659033629882244*r**22-19049453743391372*r**24-2099527852430372*r**26
            +8266306761693630*r**28+1752402901133016*r**30+64891218797576*r**32+792529805391608*r**34
            +172264233104323*r**36+20806384632890*r**38+1776708387646*r**40-75755273014*r**42
            -6517079617*r**44+139959888*r**46)-5*Q2**4*(-1533909504+8604513664*r**2
            +289194698137*r**4+14817688096052*r**6+107079285325094*r**8-503890208974152*r**10
            +1021915444456053*r**12-16723667591663772*r**14-7768775706576600*r**16
            -3393490011993744*r**18-10453779146584142*r**20+48231486952218520*r**22
            +123974196109600292*r**24+107732697291712736*r**26+5479959594019506*r**28
            +40217871688640856*r**30+61627005763614120*r**32+8570642300855184*r**34
            +10212487619704245*r**36-37442397657356*r**38+21375125587942*r**40-21933264414232*r**42
            -1533955735591*r**44+42168226692*r**46)-18*Q2*(-1+r**2)**2*(-42607680
            +1014347648*r**2+14213480505*r**4-3824987081*r**6-1745136968510*r**8
            -97050484054680*r**10-426274377204217*r**12-91599921498835*r**14-3538963163069286*r**16
            +4128691723451040*r**18+16791107957184170*r**20-4869792408731162*r**22
            -29420491711944700*r**24-34649296026027856*r**26-3014417142835810*r**28
            +21733710460454170*r**30+5431311122277508*r**32-1007917133958240*r**34
            +2666496790288269*r**36+553922842424915*r**38+82083881907770*r**40+8625879415848*r**42
            -250824835605*r**44-27546879671*r**46+487571490*r**48)+6*Q2**3*(91080000
            -14387185408*r**2-76387388715*r**4+7484506114911*r**6+50863307841680*r**8
            +543887578930210*r**10+5159194056912637*r**12-2033299991541645*r**14+36699814137903386*r**16
            +14791857870918040*r**18-43407108624542630*r**20+15268634616330462*r**22
            +57474712410343000*r**24+79987232400096876*r**26-10539903107087950*r**28
            -151152723896538370*r**30-44745615794733828*r**32+16785968753096920*r**34
            -33697964254593679*r**36-2781627483509565*r**38-1320842399787960*r**40
            -156341693898238*r**42-3480969753935*r**44-18099168369*r**46+10508962170*r**48)
            +6*Q2**2*(-336010560+10648076224*r**2+105313624729*r**4-1869703243423*r**6
            -17661765961163*r**8-663018237894340*r**10-3339005597292761*r**12+1927888749626689*r**14
            -29425900564926893*r**16+30059814225252302*r**18+68347324865122730*r**20
            -81295008853998286*r**22-76427936546961566*r**24-1641817611211408*r**26
            -123312703335479778*r**28-98086024770181350*r**30+115780376201821334*r**32
            +46912036362003524*r**34-28612938936228563*r**36+21135270944857677*r**38
            +3475875116995545*r**40+757129853975364*r**42+98220777863499*r**44-1122919835963*r**46
            -226019205913*r**48+1902412350*r**50))*sqrtq2)+logq2*(-192*(Q2-(-1
            +r)**2)**4*r**4*(1-Q2+r**2)*(Q2-(1+r)**2)**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*(-74496*Q2**23*(160+241*r**4)+32*Q2**22*(4871904
            +2834080*r**2+7259211*r**4+8148933*r**6)-8*Q2**21*(113203104+134933344*r**2
            +90782111*r**4+426687779*r**6+203073348*r**8)+8*Q2**20*(377395488+686226400*r**2
            -233515577*r**4+811260305*r**6+2442714201*r**8+691998483*r**10)+Q2**19*(
            -6123499200-15114047040*r**2+31689898139*r**4+53174668913*r**6+28677568233*r**8
            -50832767785*r**10-10378592700*r**12)+Q2**18*(6913206720+22351678080*r**2
            -191119900473*r**4-452249888944*r**6-781500644910*r**8-606546606216*r**10
            +21429400535*r**12+6742703784*r**14)+Q2**17*(-1536916032-9731505600*r**2
            +694195377889*r**4+2000179019175*r**6+3965024899096*r**8+5669519365220*r**10
            +3208009217515*r**12+240628069637*r**14+14553680556*r**16)-Q2**16*(7333140672
            +25378307712*r**2+1568871344887*r**4+5731828395232*r**6+11834339107249*r**8
            +20177010342480*r**10+21006234829577*r**12+8340139869152*r**14+706058887087*r**16
            +39147072144*r**18)+4*Q2**15*(2456744256+13062010560*r**2+518360040771*r**4
            +2580672552293*r**6+5332911309127*r**8+9213655297385*r**10+12214502940023*r**12
            +10143827533941*r**14+2537283634603*r**16+194795500397*r**18+7467731076*r**20)
            +4*Q2**14*(-371035200-10232469120*r**2-266599812713*r**4-2594081794506*r**6
            -3669356870736*r**8-3247152230094*r**10-1006386082984*r**12-3806204454110*r**14
            -6829912748476*r**16+446342242334*r**18+37261970045*r**20+5274574200*r**22)
            -4*Q2**13*(1976107200-1045691840*r**2+292285103575*r**4-658625334263*r**6
            +6970110476090*r**8+29340960023046*r**10+67371109489730*r**12+93318136684698*r**14
            +56672430432234*r**16+12939873984210*r**18+6076205219183*r**20+355795735045*r**22
            +14866982484*r**24)+4*Q2**12*(1705808832+6492079360*r**2+612350653409*r**4
            +1704133228486*r**6+22206824382473*r**8+87612489658180*r**10+203913910974700*r**12
            +333615056136404*r**14+332321447829600*r**16+156824669457496*r**18+37015070204083*r**20
            +7920749851270*r**22+356394314263*r**24+8531246724*r**26)+2*Q2**11*(763648704
            -18917053376*r**2-727720279323*r**4-4788520489321*r**6-56037974290757*r**8
            -267566003619131*r**10-664501867687014*r**12-1143653157036662*r**14-1392756560326654*r**16
            -1061812582009858*r**18-337370116467203*r**20-73259390687641*r**22-3497374265653*r**24
            +46103467189*r**26+11843980668*r**28)-2*Q2**10*(2733133248-14698170240*r**2
            +164649121783*r**4-3051372172892*r**6-32414824580274*r**8-237415200063188*r**10
            -578311495209723*r**12-832830786631168*r**14-829396589684908*r**16-781994702156536*r**18
            -516769712984663*r**20+66587483292532*r**22-3894998473202*r**24+12661453456908*r**26
            +655204077931*r**28+21490145448*r**30)+2*Q2**9*(1091073600-684624960*r**2
            +466655115831*r**4-861069967183*r**6+9594419470332*r**8-92427975874224*r**10
            -33597224631469*r**12+758452696209317*r**14+2259170491247308*r**16+3300997478624048*r**18
            +2358957042613581*r**20+1029248642966411*r**22+637721010819044*r**24+76568493787872*r**26
            +14269699978377*r**28+457716759935*r**30+6875368500*r**32)+2*Q2**8*(795061440
            -11604228480*r**2-217906720481*r**4-822688354236*r**6-36272152800875*r**8
            -25496575268152*r**10-442108446213005*r**12-2166198509866980*r**14-5478461969961471*r**16
            -8641339497983920*r**18-8635793196858139*r**20-4978250941033220*r**22
            -2018316436050601*r**24-704908632739448*r**26-91270278162295*r**28-2692689445724*r**30
            +85560863315*r**32+7284068832*r**34)-4*Q2**7*(421829568-4940521920*r**2
            +12973814393*r**4-952147810297*r**6-15753435369607*r**8-19612901590665*r**10
            -212281773247565*r**12-820737266350471*r**14-2163466902635549*r**16-3784484549907067*r**18
            -4542108762882357*r**20-3287557831877015*r**22-1125255447205569*r**24
            -626299735374815*r**26-56429192169411*r**28-15909953736041*r**30+2971352823205*r**32
            +136125610787*r**34+3483451596*r**36)+4*Q2**6*(42973632+9846912*r**2
            +39383318595*r**4-957917241398*r**6-5088275625316*r**8-21532997983394*r**10
            -173982852257642*r**12-380552136955670*r**14-856308931562552*r**16-560345859302594*r**18
            -322851942690368*r**20-680618468488962*r**22+598742910390460*r**24+1863950806774538*r**26
            +94110205534226*r**28+223573771567870*r**30+16839993932832*r**32+2455727373530*r**34
            +52184789077*r**36+313990224*r**38)+4*Q2**5*(109608576-2297973120*r**2
            -24956203789*r**4+491368636689*r**6-2234933521038*r**8+40625950618638*r**10
            +188204606906728*r**12+420085156639444*r**14+893530366399286*r**16-232157913379162*r**18
            -1880010186927658*r**20-2865488362410146*r**22-1189732458926046*r**24
            -1428107159232534*r**26-2736235525783632*r**28-362569608365212*r**30-211441951859662*r**32
            -22829827599134*r**34-350931727841*r**36+21050087257*r**38+954484356*r**40)
            +3*(-1+r**2)**4*(497088-20352128*r**2-542486997*r**4+12680089748*r**6
            -8769615005*r**8+2523257152288*r**10+8642405931596*r**12-53440459420944*r**14
            +203463863583356*r**16-415391955305200*r**18-280106322734022*r**20+1272105351279960*r**22
            -360449483697446*r**24-399765007083856*r**26+217964476498940*r**28-80623752619472*r**30
            -5126152334196*r**32-2361073017488*r**34-267749683373*r**36+3430737140*r**38
            +248661243*r**40+4638768*r**42)-4*Q2**4*(51676800-1139063360*r**2-6602097919*r**4
            -24604401088*r**6-3022670165543*r**8+33349872998754*r**10+44733603878494*r**12
            +306941435006416*r**14+364996608425058*r**16-254565637039152*r**18-439375273735648*r**20
            -523272514518208*r**22-1733979273019100*r**24-442546107886252*r**26+24183937207458*r**28
            -850550313400816*r**30-223188236415826*r**32-42824461906272*r**34-8525702722593*r**36
            +472863038112*r**38+22085106035*r**40+462394650*r**42)+Q2**3*(-19381440
            +765891520*r**2+19963526771*r**4-1026507647511*r**6-4493996696855*r**8
            -6147931863721*r**10-524103401295880*r**12+856053920996348*r**14-2762769011718052*r**16
            -739473709843100*r**18+2489319564358018*r**20-2916395589964010*r**22-921766073216010*r**24
            +7614256724297162*r**26+2571447605213740*r**28-3882700390465988*r**30
            +3617768159453980*r**32-324131633644508*r**34+187442509307651*r**36+12015095947465*r**38
            +1110823051881*r**40+12969093015*r**42-134920476*r**44)-3*Q2*(-1+r**2)**2*(4542144
            -168373568*r**2-3491084627*r**4+92468976373*r**6-71412089939*r**8+13824961502193*r**10
            +61960591234584*r**12-235978555646212*r**14+766642001665756*r**16-958238961314228*r**18
            -1970585389621778*r**20+2255533218811086*r**22+4311690306331998*r**24
            -2307634218362506*r**26-1809851469578652*r**28+1284793688075676*r**30
            -519693406810052*r**32-15835881780052*r**34-17231671255123*r**36-2029300003931*r**38
            +10295828765*r**40+1793561825*r**42+41150268*r**44)+Q2**2*(43098048-1479710080*r**2
            -23835308705*r**4+811166970712*r**6-304210408166*r**8+73352986640800*r**10
            +454980571364475*r**12-1430434342799832*r**14+4395191551666168*r**16-5073139177816992*r**18
            -2838411831374338*r**20+2349781739131280*r**22+3200304763331836*r**24
            +18926212483235104*r**26-8674385061577618*r**28-12394711300505616*r**30
            +10120797515111160*r**32-3936164718492256*r**34+131133715593315*r**36
            -143985036533224*r**38-16458941469894*r**40-185174960960*r**42+10873189207*r**44
            +376185576*r**46))+192*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(595968*Q2**27*(160
            +241*r**4)-512*Q2**26*(2598912+1580000*r**2+3875064*r**4+4319925*r**6)
            +32*Q2**25*(257902176+324553536*r**2+245682563*r**4+962354662*r**6+459261891*r**8)
            -8*Q2**24*(3670702560+7235554688*r**2-562680227*r**4+9932509570*r**6
            +23886033389*r**8+6722598600*r**10)+8*Q2**23*(7918852800+22387778784*r**2
            -29162297703*r**4-51861007792*r**6-5731885682*r**8+71089381376*r**10
            +13710014025*r**12)+Q2**22*(-74786829120-315457349632*r**2+1625814743445*r**4
            +4294111745612*r**6+6887006473766*r**8+4661327630208*r**10-507310283627*r**12
            -83748401340*r**14)-2*Q2**21*(-5741331840-118760020032*r**2+3268946088237*r**4
            +10286848176927*r**6+20174359237048*r**8+27661753245882*r**10+14660681855249*r**12
            +998410847751*r**14+76807435050*r**16)+Q2**20*(105612166080+220384961280*r**2
            +16299739597527*r**4+64071050004506*r**6+133195798153865*r**8+228307287437060*r**10
            +231247125967785*r**12+86876516546346*r**14+7555154837943*r**16+476779082040*r**18)
            -8*Q2**19*(17884416960+95346902688*r**2+2974597771668*r**4+16090364477980*r**6
            +34186058934049*r**8+61718851775425*r**10+84583275981058*r**12+65722811485258*r**14
            +15604779535705*r**16+1239973770969*r**18+50026683600*r**20)+Q2**18*(13201108800
            +800758209792*r**2+13435547088891*r**4+149135449023024*r**6+264061652056344*r**8
            +364648181665588*r**10+480634621280922*r**12+668933084643116*r**14+518271184714264*r**16
            +8390460422444*r**18-415838018757*r**20-297608562300*r**22)+2*Q2**17*(74122727040
            -92746296896*r**2+8391304933725*r**4-23871664215809*r**6+126492479496758*r**8
            +630569422087144*r**10+1453396092619558*r**12+1945273576751618*r**14+1041385397235996*r**16
            +227663477608808*r**18+141344635669069*r**20+9343356288879*r**22+453154080990*r**24)
            -Q2**16*(127787378880+581649893376*r**2+37742313838559*r**4+132074364497574*r**6
            +1280572858580631*r**8+5145403735605472*r**10+11953251532964474*r**12
            +19748632683654612*r**14+19296557922936154*r**16+8685163000236336*r**18
            +2159898474524839*r**20+440635031912038*r**22+21659841451087*r**24+513758883600*r**26)
            -16*Q2**15*(2800952640-56693990240*r**2-1329267596137*r**4-14258851000306*r**6
            -123779783668000*r**8-600458443896434*r**10-1495146607171639*r**12-2698143137915190*r**14
            -3414055623341722*r**16-2535852311845034*r**18-801679295761205*r**20-173621071235400*r**22
            -8185932947286*r**24+74809469932*r**26+32488247205*r**28)+2*Q2**14*(65174784960
            -267062687232*r**2+6884664624393*r**4-77319180645660*r**6-653565623662526*r**8
            -5015840756907960*r**10-12884525490250593*r**12-22205223122161988*r**14
            -29403703939649300*r**16-30106726329519664*r**18-17511554529889185*r**20
            -1392263026089892*r**22-323792415600702*r**24+202137394017640*r**26+11975706150089*r**28
            +431820932100*r**30)-4*Q2**13*(10446595200+71675330752*r**2+6119889459801*r**4
            +1286169259539*r**6+132135337396124*r**8-910032682796922*r**10-775053092003637*r**12
            +4935175844686109*r**14+16756390701795186*r**16+24395505749591316*r**18
            +15077971898633447*r**20+6804219103775237*r**22+4980591804283976*r**24
            +744970553290294*r**26+128559561066149*r**28+4394456527163*r**30+42255843450*r**32)
            +2*Q2**12*(-30380708160+390319459584*r**2+3221380485075*r**4+60354108279066*r**6
            +912900994693753*r**8+2392408861217724*r**10+16583972602496555*r**12+67975179738328006*r**14
            +166714594972047689*r**16+270910338537015152*r**18+267188149700018441*r**20
            +143166943489635350*r**22+53957350908585771*r**24+15221268566944876*r**26
            +2164857337365753*r**28+36791870692394*r**30-3144990462381*r**32-247295411640*r**34)
            +16*Q2**11*(3232584000-25893818016*r**2+546173010036*r**4-8134955931794*r**6
            -85076720395391*r**8-486441753706055*r**10-3092314374283962*r**12-13076036837908810*r**14
            -34126634278374951*r**16-61205859563810739*r**18-75142869407240182*r**20
            -56272544754729038*r**22-21773262390262309*r**24-7248694179821669*r**26
            -650253650510126*r**28-95792388118374*r**30+19966782621147*r**32+954220637583*r**34
            +22973722650*r**36)+2*Q2**10*(3898416960-140542383360*r**2-3285197951349*r**4
            +28988552824168*r**6+4816267679620*r**8+2794755268614124*r**10+17608583591052964*r**12
            +89724424451003204*r**14+241236947240776764*r**16+408244168082400364*r**18
            +512781409275258914*r**20+494115683751500724*r**22+260848153437913340*r**24
            +7438745315778372*r**26+11357741285500324*r**28-9486608379764660*r**30
            -1194064664146940*r**32-124837287032732*r**34-2288362587381*r**36+41040646740*r**38)
            -4*Q2**9*(6358062720-108645180864*r**2+40258358451*r**4-4828531491975*r**6
            -154399129259682*r**8+743886509533540*r**10+2228575424169564*r**12+20869106354965884*r**14
            +29752468081892940*r**16-56204587188956468*r**18-231757473989668390*r**20
            -346671843757653626*r**22-252601694506239696*r**24-155365845214611460*r**26
            -114867554774500308*r**28-22344918815685540*r**30-5896648872789244*r**32
            -777438446744684*r**34+5440859242475*r**36+1297168175913*r**38+51061260450*r**40)
            +2*Q2**8*(3108772800-38174772224*r**2+831363133053*r**4-23595703389958*r**6
            -159866136408983*r**8+73465342615064*r**10-7453900721172616*r**12-2000992290902728*r**14
            -133772108619659712*r**16-665115723899620792*r**18-1662088673823639854*r**20
            -2582265529589502756*r**22-2575458401908491278*r**24-1592624211417421432*r**26
            -741807740932692992*r**28-262374102343599944*r**30-59316533933066504*r**32
            -2826146536819272*r**34-349654707764423*r**36+59462956406842*r**38+2026850945709*r**40
            +24205461600*r**42)+8*Q2**7*(790426560-20687462304*r**2-72004298515*r**4
            +3946315904924*r**6-6124909215078*r**8+414002283301076*r**10+3018936503546665*r**12
            +3011441185300636*r**14+40254161729601556*r**16+140718996303509028*r**18
            +369026159843903614*r**20+653323506303142228*r**22+768345821129544408*r**24
            +558447261515879436*r**26+262048467968261278*r**28+142486819662795284*r**30
            +12366108048282860*r**32+6366370923562316*r**34-915570651562491*r**36
            -152720061312928*r**38-5799248464434*r**40+38775063376*r**42+6611426505*r**44)
            -Q2**6*(3758391360-98515856384*r**2-98226722761*r**4+4232703377204*r**6
            -81380893017414*r**8+4006317471009968*r**10+12880175548496347*r**12+20006779056127996*r**14
            +241907273059078296*r**16+403921730265649984*r**18+978202763307473518*r**20
            +1076101122229422216*r**22+1174713152770506588*r**24+1324014127579192736*r**26
            -783621504998515346*r**28-1819733852466417160*r**30+23947430089634648*r**32
            -283546988966032320*r**34-33409192892586661*r**36-6067970741612924*r**38
            -965238727138886*r**40+16960205324848*r**42+1311906341047*r**44+32122673100*r**46)
            -2*Q2**5*(210076800-8292275520*r**2+6679849809*r**4+5630787950027*r**6
            -8355999832000*r**8-648516236259766*r**10+252971417172369*r**12-28612821520677945*r**14
            -132302144344743038*r**16-251404019629196616*r**18-502447187947323918*r**20
            +108411991156677142*r**22+1265358738157296920*r**24+1729643827467851036*r**26
            +743871200804882202*r**28+1135851163749479334*r**30+1675904193505073964*r**32
            +341628974196006584*r**34+128543192042164509*r**36+27564167098177119*r**38
            +642129323595800*r**40+6209073240170*r**42-9106551487243*r**44-161303444909*r**46
            +1614307170*r**48)-9*(-1+r**2)**4*(497088-27311360*r**2-304283477*r**4
            +22181048506*r**6-135011666879*r**8+1461677791876*r**10-26036914133435*r**12
            -411484860078542*r**14+103909768159511*r**16+1641046714206496*r**18-12833413287471874*r**20
            +41338503118657140*r**22+14179021173237338*r**24-111425278692664744*r**26
            +21607344802579386*r**28+40764182365322036*r**30-14128793791085410*r**32
            +4196770127822608*r**34+1861342605147431*r**36+216835170007506*r**38+53049558488981*r**40
            +1061456639940*r**42-339219102927*r**44-486564454*r**46+183718491*r**48
            +4638768*r**50)+Q2**4*(872637120-31564489984*r**2-64129142829*r**4+9196999747570*r**6
            -43278633683547*r**8+939734807583780*r**10+1630903831788281*r**12-63109303351770374*r**14
            -78271229739373025*r**16-463233213006963992*r**18-555294669738600930*r**20
            +256685227075386916*r**22+660497101347555026*r**24+935212450462503160*r**26
            +2428786564995272338*r**28+994861351476028740*r**30+104038877138617886*r**32
            +933086455948867136*r**34+551124802607342975*r**36+44828424690853738*r**38
            +22559025254525465*r**40-374234586593724*r**42-270876680926459*r**44-3018619434430*r**46
            +177016078963*r**48+7611310200*r**50)+18*Q2*(-1+r**2)**2*(2022528-102574656*r**2
            -644435967*r**4+68806763149*r**6-427541359377*r**8+1699087669185*r**10
            -51034105361651*r**12-1133048853081497*r**14-1489939573302931*r**16+6633971933341443*r**18
            -32032184821873080*r**20+52937752816761314*r**22+100046754200150518*r**24
            -134927545243973526*r**26-213965340940252342*r**28+107143205722135150*r**30
            +91709238779942074*r**32-48514655856043802*r**34+16745281836321249*r**36
            +4554288817678113*r**38+697890263791435*r**40+196813313269669*r**42+4510943418873*r**44
            -1016651427941*r**46-9467984087*r**48+514550407*r**50+18255750*r**52)
            -24*Q2**3*(6504000-251867808*r**2-1908559644*r**4+39014711984*r**6-335060504701*r**8
            +37794096424163*r**10-18348679661138*r**12-35131285313874*r**14+7141370283319179*r**16
            -11085551308141421*r**18+34258704249811428*r**20+21024933226923912*r**22
            -20006758413468714*r**24+20697665889894134*r**26-24682134386470156*r**28
            -109990530859542412*r**30-4463609511810978*r**32+41783293258734126*r**34
            -49078649456705116*r**36+4915290345660504*r**38-2076357819151737*r**40
            -259908732640313*r**42-15424926849394*r**44-3961292368306*r**46+82284561399*r**48
            +3980805183*r**50+62105700*r**52)-3*Q2**2*(25992000-1243440896*r**2-268905429*r**4
            +771848004256*r**6-4975526476112*r**8-64459656356316*r**10-185754311426402*r**12
            -11569190758740868*r**14-36956191844236944*r**16+113637693590380748*r**18
            -398819130934565691*r**20+393381201878759348*r**22+538753151096987232*r**24
            -156360477819722904*r**26-909561566481750172*r**28-1837804944594415656*r**30
            +1117235822834208928*r**32+1077940139817753752*r**34-850189734085051259*r**36
            +301794154866839048*r**38+28091236987255024*r**40+10154836413099188*r**42
            +3125426353392542*r**44+84129555482476*r**46-6507139058512*r**48-352000771236*r**50
            +229300459*r**52+220263396*r**54))*sqrtq2)))/(10206000*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2
            +10206000*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2
            +logq2**7*(-82282372300800000*r**32*(1+r**2)**2*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3-82282372300800000*r**32*(1+r**2)**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**6*(457124290560000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))+457124290560000*r**28*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))*sqrtq2)+logq2*(-612360000*(-Q2
            +(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(9+8*Q2**4-78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)
            -Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-612360000*(-Q2+(-1
            +r)**2)**3*r**8*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(9+8*Q2**4
            -78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)-Q2**2*(13+10*r**2
            +13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2)+logq2**2*(7348320000*(-Q2+(-1+r)**2)**3*r**12*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1
            +r**2)-Q2**6*(531+550*r**2+531*r**4)-2*Q2**5*(19+473*r**2+473*r**4
            +19*r**6)+Q2**4*(815-2120*r**2-11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1
            +225*r**2+494*r**4+494*r**6+225*r**8+r**10)+Q2**2*(-501+4554*r**2
            +26793*r**4+31188*r**6+26793*r**8+4554*r**10-501*r**12)-54*Q2*(1+15*r**2
            -311*r**4-1385*r**6-1385*r**8-311*r**10+15*r**12+r**14)+9*(17-316*r**2
            -184*r**4+13388*r**6+34670*r**8+13388*r**10-184*r**12-316*r**14+17*r**16))
            +7348320000*(-Q2+(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531+550*r**2
            +531*r**4)-2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815-2120*r**2
            -11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4+494*r**6
            +225*r**8+r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6+26793*r**8
            +4554*r**10-501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6-1385*r**8
            -311*r**10+15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6+34670*r**8
            +13388*r**10-184*r**12-316*r**14+17*r**16))*sqrtq2)+logq2**3*(-88179840000*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8+256*Q2**7*(1+r**2)
            -Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2+893*r**4+319*r**6)
            +Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)+12*Q2**3*(61
            +235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(-1071+9654*r**2
            +51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)-18*Q2*(23
            -35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12+23*r**14)
            +9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10-264*r**12
            -756*r**14+47*r**16))-88179840000*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8
            +256*Q2**7*(1+r**2)-Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2
            +893*r**4+319*r**6)+Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)
            +12*Q2**3*(61+235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(
            -1071+9654*r**2+51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)
            -18*Q2*(23-35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12
            +23*r**14)+9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10
            -264*r**12-756*r**14+47*r**16))*sqrtq2)+logq2**4*(1058158080000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513+770*r**2
            +513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105-3400*r**2
            -11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4-1178*r**6
            +75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6+19593*r**8
            +3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6-5785*r**8
            -2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4+25204*r**6
            +52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))+1058158080000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513
            +770*r**2+513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105
            -3400*r**2-11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4
            -1178*r**6+75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6
            +19593*r**8+3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6
            -5785*r**8-2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4
            +25204*r**6+52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))*sqrtq2)
            +logq2**5*(-2539579392000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(64*Q2**8+1088*Q2**7*(1+r**2)+Q2**6*(-63+130*r**2-63*r**4)
            -2*Q2**5*(2777+6379*r**2+6379*r**4+2777*r**6)+Q2**4*(1555-8080*r**2
            -22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743-315*r**2-6548*r**4-6548*r**6
            -315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2+199629*r**4+305844*r**6
            +199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83-375*r**2-2833*r**4
            -5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)+9*(301-4028*r**2
            +808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12-4028*r**14+301*r**16))
            -2539579392000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(64*Q2**8+1088*Q2**7*(1
            +r**2)+Q2**6*(-63+130*r**2-63*r**4)-2*Q2**5*(2777+6379*r**2+6379*r**4
            +2777*r**6)+Q2**4*(1555-8080*r**2-22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743
            -315*r**2-6548*r**4-6548*r**6-315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2
            +199629*r**4+305844*r**6+199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83
            -375*r**2-2833*r**4-5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)
            +9*(301-4028*r**2+808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12
            -4028*r**14+301*r**16))*sqrtq2))+((4*(Q2-(-1+r)**2)**4*r**4*(Q2-(1
            +r)**2)**4*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(-1059
            +24*Q2**14-322322*r**2-93757*r**4-25369844*r**6+127046277*r**8-457228062*r**10
            +815729139*r**12-694656216*r**14+236289183*r**16-15296334*r**18+10159121*r**20
            +3791308*r**22-43777*r**24-3714*r**26+57*r**28+56*Q2**13*(1+r**2)+Q2**12*(1627
            +3446*r**2-1457*r**4)+4*Q2**11*(-3797-54679*r**2-8387*r**4+1615*r**6)
            +4*Q2**10*(11639+338572*r**2+403567*r**4+30654*r**6-3472*r**8)+4*Q2**9*(
            -15387-727340*r**2-2055110*r**4-1044380*r**6-54495*r**8+4008*r**10)
            +Q2**8*(15423+1013978*r**2+12323485*r**4+13564420*r**6+3813345*r**8
            +170178*r**10-8157*r**12)-8*Q2**7*(-6327-651616*r**2-542973*r**4-1778395*r**6
            +98905*r**8-203412*r**10-2181*r**12+207*r**14)+8*Q2**6*(-5943-891191*r**2
            -3383193*r**4-11587780*r**6-10153075*r**8-1572643*r**10-622461*r**12
            -13398*r**14+420*r**16)+8*Q2**5*(-1284+8398*r**2+2312708*r**4+9155691*r**6
            +23311392*r**8+6859881*r**10+797988*r**12+185973*r**14+1356*r**16+57*r**18)
            +Q2**4*(34249+5785410*r**2+7369665*r**4+88484320*r**6-138504270*r**8
            -44549788*r**10+15777210*r**12-6455760*r**14+2109045*r**16+71530*r**18
            -1931*r**20)+4*Q2**3*(-3001-818121*r**2-3167815*r**4-34632105*r**6+13941570*r**8
            -19084558*r**10+6052382*r**12+3025010*r**14+3050295*r**16-323305*r**18
            -8471*r**20+119*r**22)+4*Q2**2*(-1567-223806*r**2+930087*r**4+2175310*r**6
            +12132160*r**8+4033124*r**10-13722438*r**12-13803764*r**14-5884315*r**16
            -87590*r**18-58337*r**20-4186*r**22+122*r**24)-4*Q2*(-1333-327586*r**2
            -53198*r**4-15606570*r**6+50223425*r**8-85305484*r**10+38454012*r**12
            +5455156*r**14+2058365*r**16+2960350*r**18+2220242*r**20-73226*r**22
            -4233*r**24+80*r**26))-4*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(192*Q2**19
            +88*Q2**18*(1+r**2)-16*Q2**17*(-761-1642*r**2+781*r**4)+Q2**16*(-145669
            -1825599*r**2-297995*r**4+73775*r**6)+4*Q2**15*(150207+3591900*r**2
            +4186230*r**4+340660*r**6-51861*r**8)+2*Q2**14*(-587263-22270690*r**2
            -56976461*r**4-30027301*r**6-1597940*r**8+160967*r**10)+4*Q2**13*(223639
            +12910234*r**2+73261216*r**4+81644768*r**6+24316527*r**8+917894*r**10
            -60326*r**12)-2*Q2**12*(-317131-18876162*r**2+114185636*r**4+219020933*r**6
            +179282069*r**8+19229600*r**10+281938*r**12+12701*r**14)+4*Q2**11*(-427377
            -40901932*r**2-95582026*r**4-235832836*r**6-191728516*r**8-18524260*r**10
            -23734310*r**12-833580*r**14+48165*r**16)+Q2**10*(645546+117202740*r**2
            +950023122*r**4+3458598670*r**6+6480987254*r**8+3090309622*r**10+555687430*r**12
            +116673738*r**14+2445960*r**16-86658*r**18)-4*Q2**9*(-279719-25380890*r**2
            +140458404*r**4+715979284*r**6+3392656990*r**8+3213841264*r**10+899717980*r**12
            +147373004*r**14-4363551*r**16-513590*r**18+21736*r**20)+2*Q2**8*(-565738
            -93325493*r**2-216617569*r**4-1312661502*r**6+4253144032*r**8+7526070378*r**10
            +4624178418*r**12+588840656*r**14+170257418*r**16-48534133*r**18-1641233*r**20
            +45422*r**22)+4*Q2**7*(-31163+7629684*r**2+211851218*r**4+1591348508*r**6
            +3260448139*r**8+4797578744*r**10+4261569596*r**12+998967992*r**14+339887083*r**16
            +10756724*r**18+7392018*r**20+68684*r**22+1573*r**24)-2*Q2**6*(-310899
            -50182914*r**2+196567371*r**4+1356019711*r**6+14011017886*r**8+28406379147*r**10
            +47692110982*r**12+23534560726*r**14+5007634041*r**16+777053636*r**18
            +209461039*r**20-18156501*r**22-801700*r**24+19635*r**26)+4*Q2**5*(-44419
            -13953970*r**2-51425816*r**4-710056600*r**6+3395263571*r**8+3934803926*r**10
            +29948143010*r**12+22670582320*r**14+5991109955*r**16+1165588042*r**18
            +98177028*r**20+79097960*r**22-5399059*r**24-153710*r**26+2162*r**28)
            +2*Q2**4*(-74771-9858590*r**2+173066644*r**4+1579897069*r**6+6085393995*r**8
            +27876860036*r**10-14689327610*r**12-21487760013*r**14-5085336893*r**16
            -1532121230*r**18-1709875624*r**20-14947725*r**22+49489669*r**24-2377176*r**26
            -213490*r**28+4909*r**30)-4*Q2**3*(-22333-5590428*r**2+30318494*r**4
            +103450092*r**6+3947265218*r**8+9973666948*r**10+13322010758*r**12+2238290812*r**14
            +1101385656*r**16-6233169716*r**18-3689404902*r**20-1239105212*r**22
            -61818306*r**24+47410252*r**26-1303102*r**28-73388*r**30+1157*r**32)
            -2*Q2**2*(-4107+408166*r**2+28432177*r**4+350402083*r**6-1139137991*r**8
            +6331072423*r**10-37591020251*r**12+32929105263*r**14-5509203441*r**16
            +4305412287*r**18+19284105635*r**20+2214797369*r**22-285387037*r**24
            -7830667*r**26-9379321*r**28+132149*r**30-17184*r**32+447*r**34)+12*Q2*(
            -1333-309198*r**2+4690768*r**4+26504868*r**6+321630628*r**8+1287006892*r**10
            -4395066128*r**12+10784577284*r**14-9208651006*r**16+7844999744*r**18
            -4976184960*r**20-574534900*r**22-751218972*r**24-346607692*r**26-20537872*r**28
            +3731276*r**30-24149*r**32-5330*r**34+80*r**36)-3*(-1059-308555*r**2
            +4210801*r**4+10774145*r**6+501804548*r**8+645428372*r**10-4220464300*r**12
            +24690211972*r**14-31128267770*r**16-10091920314*r**18+38650944158*r**20
            -14149245010*r**22-3260927372*r**24-1070939420*r**26-552049916*r**28
            -33999596*r**30+4755365*r**32-1651*r**34-4455*r**36+57*r**38))*sqrtq2
            +logq2**5*(-13063680000*(-Q2+(-1+r)**2)*(-1+r)*r**24*(1+r)*(1+r**2)*(1
            -Q2+r**2)*(1+3*r**2)*(-Q2+(1+r)**2)-13063680000*r**24*(-1-3*r**2
            +r**4+3*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**4*(
            -10368000*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(480*Q2**6*(1+r**2)
            -240*Q2**5*(12+17*r**2+5*r**4)-8*Q2**4*(-837-1483*r**2-503*r**4+171*r**6)
            +Q2**3*(-6324-14275*r**2-4737*r**4+7411*r**6+4197*r**8)+Q2**2*(-864
            +5213*r**2+3876*r**4-10278*r**6-7268*r**8+1257*r**10)-3*Q2*(-1812
            -611*r**2+1987*r**4+340*r**6-2976*r**8+271*r**10+2801*r**12)+3*(-848
            +75*r**2+908*r**4-4783*r**6-1808*r**8+3925*r**10+852*r**12+1679*r**14))
            +10368000*r**18*(480*Q2**9*(1+r**2)-240*Q2**8*(18+29*r**2+11*r**4)+8*Q2**7*(2097
            +4393*r**2+2783*r**4+459*r**6)+7*Q2**6*(-5076-12565*r**2-10263*r**4
            -2171*r**6+603*r**8)-2*Q2**5*(-20538-58597*r**2-55520*r**4-9418*r**6
            +14938*r**8+7119*r**10)+5*Q2**4*(-3528-14371*r**2-16085*r**4-264*r**6
            +13112*r**8+8491*r**10+357*r**12)-3*(-1+r**2)**3*(848+1621*r**2+638*r**4
            +4513*r**6+11104*r**8+8987*r**10+4210*r**12+1679*r**14)+4*Q2**3*(-3780
            +70*r**2+4677*r**4-5237*r**6-11782*r**8-9456*r**10+1925*r**12+7455*r**14)
            +Q2**2*(24804+17251*r**2-6283*r**4+45623*r**6+61833*r**8-29375*r**10
            -38777*r**12-33499*r**14-41577*r**16)+6*Q2*(-2178-135*r**2+2370*r**4
            -7578*r**6-9090*r**8-648*r**10+5414*r**12+6234*r**14+1692*r**16+3919*r**18))*sqrtq2)
            +logq2**3*(-345600*r**14*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -640*Q2**10+80*Q2**9*(109+81*r**2)-4*Q2**8*(10744+17565*r**2+6629*r**4)
            +4*Q2**7*(24047+67087*r**2+55577*r**4+13937*r**6)-Q2**6*(78778+441405*r**2
            +587331*r**4+300955*r**6+60123*r**8)+2*Q2**5*(-29057+100006*r**2+207494*r**4
            +162424*r**6+61691*r**8+16898*r**10)+Q2**4*(153860+296465*r**2+664749*r**4
            +542330*r**6-31266*r**8-47435*r**10-16975*r**12)+8*Q2**3*(-9293-50490*r**2
            -150185*r**4-148772*r**6+24933*r**8+80570*r**10+26545*r**12+612*r**14)
            +Q2**2*(-39058+131617*r**2+206511*r**4+593941*r**6-348657*r**8-1148689*r**10
            -284079*r**12-97573*r**14+18307*r**16)-6*Q2*(-7893-6060*r**2-116040*r**4
            +16620*r**6+110278*r**8-131432*r**10-66960*r**12+171020*r**14+26855*r**16
            +3612*r**18)+3*(-4072-7899*r**2-124223*r**4+73288*r**6+12024*r**8
            -157026*r**10+1734*r**12-80392*r**14+247472*r**16+36861*r**18+2233*r**20))
            +345600*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(640*Q2**10-80*Q2**9*(109
            +81*r**2)+4*Q2**8*(10744+17565*r**2+6629*r**4)-4*Q2**7*(24047+67087*r**2
            +55577*r**4+13937*r**6)+Q2**6*(78778+441405*r**2+587331*r**4+300955*r**6
            +60123*r**8)-2*Q2**5*(-29057+100006*r**2+207494*r**4+162424*r**6+61691*r**8
            +16898*r**10)+Q2**4*(-153860-296465*r**2-664749*r**4-542330*r**6+31266*r**8
            +47435*r**10+16975*r**12)-8*Q2**3*(-9293-50490*r**2-150185*r**4-148772*r**6
            +24933*r**8+80570*r**10+26545*r**12+612*r**14)+Q2**2*(39058-131617*r**2
            -206511*r**4-593941*r**6+348657*r**8+1148689*r**10+284079*r**12+97573*r**14
            -18307*r**16)+6*Q2*(-7893-6060*r**2-116040*r**4+16620*r**6+110278*r**8
            -131432*r**10-66960*r**12+171020*r**14+26855*r**16+3612*r**18)-3*(
            -4072-7899*r**2-124223*r**4+73288*r**6+12024*r**8-157026*r**10+1734*r**12
            -80392*r**14+247472*r**16+36861*r**18+2233*r**20))*sqrtq2)+logq2**2*(5760*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(11520*Q2**13-16*Q2**12*(6129+5467*r**2)
            +4*Q2**11*(81472+162683*r**2+68411*r**4)-4*Q2**10*(115431+488576*r**2
            +445435*r**4+107538*r**6)+5*Q2**9*(2286+525503*r**2+836313*r**4+485409*r**6
            +63513*r**8)-5*Q2**8*(-156696+37219*r**2-31124*r**4+156518*r**6+255372*r**8
            +4311*r**10)-2*Q2**7*(395556+2230843*r**2+9881570*r**4+14718735*r**6
            +6476095*r**8+461006*r**10+81363*r**12)+2*Q2**6*(-57588+2859143*r**2
            +16754391*r**4+43245765*r**6+36028570*r**8+10679877*r**10+969843*r**12
            +94431*r**14)-2*Q2**5*(-311994+477316*r**2+2545855*r**4+38935933*r**6
            +53179760*r**8+24313856*r**10+5004941*r**12+668895*r**14+47838*r**16)
            -10*Q2**4*(26328+392144*r**2+3683419*r**4+2309292*r**6-100423*r**8-798008*r**10
            -202923*r**12-290236*r**14-70913*r**16+7224*r**18)+10*Q2**3*(-11460
            +312497*r**2+3011748*r**4+7592889*r**6+9993411*r**8+4134399*r**10-3077805*r**12
            -3372825*r**14-830991*r**16-33744*r**18+11161*r**20)+2*Q2**2*(51538
            +83929*r**2+2099095*r**4-19815615*r**6-13787040*r**8-9064446*r**10+33675702*r**12
            +33703410*r**14+16351470*r**16+431045*r**18-179437*r**20-4051*r**22)
            -3*Q2*(3854+351281*r**2+4245317*r**4-2508915*r**6+22869135*r**8-11047218*r**10
            +3415638*r**12+21190806*r**14-28658760*r**16-6759935*r**18-2912411*r**20
            -202019*r**22+13227*r**24)+3*(-1288+110037*r**2+1257150*r**4-375994*r**6
            +15437670*r**8-7418889*r**10-19279324*r**12+10397140*r**14+33625068*r**16
            -26364045*r**18-5865698*r**20-1453338*r**22-73290*r**24+4801*r**26))
            -5760*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(11520*Q2**14-16*Q2**13*(6849
            +6187*r**2)+4*Q2**12*(105988+209067*r**2+90279*r**4)-4*Q2**11*(196903
            +732731*r**2+676529*r**4+175949*r**6)+Q2**10*(473154+5043543*r**2+7917609*r**4
            +4638937*r**6+747717*r**8)-10*Q2**9*(-77205+282504*r**2+665346*r**4
            +739120*r**6+402147*r**8+33912*r**10)-Q2**8*(1574592+5059071*r**2+19732665*r**4
            +28810500*r**6+10892740*r**8-376403*r**10+141171*r**12)+4*Q2**7*(168984
            +2742771*r**2+14433402*r**4+33923035*r**6+28611700*r**8+8808489*r**10
            +756106*r**12+87897*r**14)-2*Q2**6*(-369582+3278871*r**2+22159389*r**4
            +98936089*r**6+132454095*r**8+71022303*r**10+16654661*r**12+1733169*r**14
            +142269*r**16)+4*Q2**5*(-221817-897699*r**2-7696962*r**4+14967664*r**6
            +46308904*r**8+40741828*r**10+15166706*r**12+3562508*r**14+535649*r**16
            +5859*r**18)+10*Q2**4*(14868+730969*r**2+7087311*r**4+13585600*r**6
            +12202280*r**8+3235968*r**10-4078736*r**12-3865984*r**14-1192140*r**16
            -97433*r**18+18385*r**20)-4*Q2**3*(-54419+710628*r**2+7261065*r**4+36419400*r**6
            +50859270*r**8+39851748*r**10-14196366*r**12-32978280*r**14-18685275*r**16
            -2377360*r**18+33261*r**20+29928*r**22)-Q2**2*(114638+1324777*r**2+17101999*r**4
            -42959785*r**6+1402095*r**8-78844626*r**10+59469426*r**12+198330642*r**14
            +14133480*r**16+13285225*r**18-8234017*r**20-973033*r**22+31579*r**24)
            +6*Q2*(1283+232586*r**2+2926874*r**4+680204*r**6+17898945*r**8+2201514*r**10
            -13455452*r**12+17501792*r**14+13078557*r**16-30891370*r**18-7769022*r**20
            -2283884*r**22-131041*r**24+9014*r**26)-3*(-1288+108749*r**2+1367187*r**4
            +881156*r**6+15061676*r**8+8018781*r**10-26698213*r**12-8882184*r**14
            +44022208*r**16+7261023*r**18-32229743*r**20-7319036*r**22-1526628*r**24
            -68489*r**26+4801*r**28))*sqrtq2)+logq2*(-48*r**6*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-24832*Q2**16+32*Q2**15*(7391+8831*r**2)
            -8*Q2**14*(105120+310747*r**2+147195*r**4)+8*Q2**13*(149925+949863*r**2
            +1071463*r**4+279085*r**6)-Q2**12*(-269140+7147001*r**2+11059123*r**4
            +11171351*r**6+1391025*r**8)-4*Q2**11*(730411+2738804*r**2+12969654*r**4
            +10560284*r**6+330159*r**8+414176*r**10)+2*Q2**10*(1319262+15299499*r**2
            +92391625*r**4+176075950*r**6+77432240*r**8+8996279*r**10+1413177*r**12)
            +4*Q2**9*(365205-4054812*r**2-43791325*r**4-205409750*r**6-190977325*r**8
            -47505400*r**10-4236587*r**12+33930*r**14)+Q2**8*(-3625800-20966583*r**2
            -124396393*r**4+638600425*r**6+1143100575*r**8+659131035*r**10+85605557*r**12
            +5002867*r**14-2632035*r**16)+8*Q2**7*(113165+3632844*r**2+46580062*r**4
            +87545574*r**6+158298110*r**8+127385300*r**10+18149174*r**12+4626662*r**14
            +319169*r**16+139700*r**18)+4*Q2**6*(461246-828817*r**2-48003727*r**4
            -467276692*r**6-1374332532*r**8-2141159326*r**10-1024048542*r**12-170495852*r**14
            -23969242*r**16-1959057*r**18+264701*r**20)-8*Q2**5*(146598+1671809*r**2
            +18659510*r**4-133478905*r**6-437240570*r**8-1593563812*r**10-1271910682*r**12
            -335013240*r**14-39908980*r**16-9947845*r**18-886356*r**20+102873*r**22)
            -Q2**4*(340860-7395849*r**2-202457835*r**4-790689275*r**6-4645644325*r**8
            +2616114550*r**10+5891720898*r**12+434581850*r**14+114198850*r**16+95382675*r**18
            +4007465*r**20-1807199*r**22+178535*r**24)+4*Q2**3*(113225+229076*r**2
            -10748334*r**4-296233120*r**6-1492129325*r**8-1620955560*r**10-911801092*r**12
            -425924192*r**14+471635775*r**16+368745300*r**18+91618610*r**20-9485184*r**22
            -1294299*r**24+69120*r**26)-2*Q2**2*(12730+944813*r**2+21319199*r**4
            -99536842*r**6-5148760*r**8-2804453825*r**10-442052871*r**12+375339252*r**14
            +3068697954*r**16+2909071835*r**18+412512145*r**20+54726358*r**22-7406276*r**24
            -383687*r**26+5975*r**28)-12*Q2*(6209-44832*r**2-2222177*r**4-25078142*r**6
            -178749747*r**8+365365296*r**10-712704661*r**12+20753954*r**14-240045341*r**16
            +569882944*r**18+66295181*r**20+112256118*r**22+24862223*r**24-461392*r**26
            -119447*r**28+3814*r**30)+3*(6416-13331*r**2-1506565*r**4-40930255*r**6
            -210248305*r**8+628651937*r**10-3432125417*r**12+3719437205*r**14+2909531835*r**16
            -7282941065*r**18+2875929953*r**20+542905027*r**22+237587485*r**24+54892795*r**26
            -1008755*r**28-172681*r**30+3721*r**32))+48*r**6*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(24832*Q2**16-32*Q2**15*(7391+8831*r**2)+8*Q2**14*(105120
            +310747*r**2+147195*r**4)-8*Q2**13*(149925+949863*r**2+1071463*r**4
            +279085*r**6)+Q2**12*(-269140+7147001*r**2+11059123*r**4+11171351*r**6
            +1391025*r**8)+4*Q2**11*(730411+2738804*r**2+12969654*r**4+10560284*r**6
            +330159*r**8+414176*r**10)-2*Q2**10*(1319262+15299499*r**2+92391625*r**4
            +176075950*r**6+77432240*r**8+8996279*r**10+1413177*r**12)-4*Q2**9*(365205
            -4054812*r**2-43791325*r**4-205409750*r**6-190977325*r**8-47505400*r**10
            -4236587*r**12+33930*r**14)+Q2**8*(3625800+20966583*r**2+124396393*r**4
            -638600425*r**6-1143100575*r**8-659131035*r**10-85605557*r**12-5002867*r**14
            +2632035*r**16)-8*Q2**7*(113165+3632844*r**2+46580062*r**4+87545574*r**6
            +158298110*r**8+127385300*r**10+18149174*r**12+4626662*r**14+319169*r**16
            +139700*r**18)+4*Q2**6*(-461246+828817*r**2+48003727*r**4+467276692*r**6
            +1374332532*r**8+2141159326*r**10+1024048542*r**12+170495852*r**14+23969242*r**16
            +1959057*r**18-264701*r**20)+8*Q2**5*(146598+1671809*r**2+18659510*r**4
            -133478905*r**6-437240570*r**8-1593563812*r**10-1271910682*r**12-335013240*r**14
            -39908980*r**16-9947845*r**18-886356*r**20+102873*r**22)+Q2**4*(340860
            -7395849*r**2-202457835*r**4-790689275*r**6-4645644325*r**8+2616114550*r**10
            +5891720898*r**12+434581850*r**14+114198850*r**16+95382675*r**18+4007465*r**20
            -1807199*r**22+178535*r**24)-4*Q2**3*(113225+229076*r**2-10748334*r**4
            -296233120*r**6-1492129325*r**8-1620955560*r**10-911801092*r**12-425924192*r**14
            +471635775*r**16+368745300*r**18+91618610*r**20-9485184*r**22-1294299*r**24
            +69120*r**26)+2*Q2**2*(12730+944813*r**2+21319199*r**4-99536842*r**6
            -5148760*r**8-2804453825*r**10-442052871*r**12+375339252*r**14+3068697954*r**16
            +2909071835*r**18+412512145*r**20+54726358*r**22-7406276*r**24-383687*r**26
            +5975*r**28)+12*Q2*(6209-44832*r**2-2222177*r**4-25078142*r**6-178749747*r**8
            +365365296*r**10-712704661*r**12+20753954*r**14-240045341*r**16+569882944*r**18
            +66295181*r**20+112256118*r**22+24862223*r**24-461392*r**26-119447*r**28
            +3814*r**30)-3*(6416-13331*r**2-1506565*r**4-40930255*r**6-210248305*r**8
            +628651937*r**10-3432125417*r**12+3719437205*r**14+2909531835*r**16-7282941065*r**18
            +2875929953*r**20+542905027*r**22+237587485*r**24+54892795*r**26-1008755*r**28
            -172681*r**30+3721*r**32))*sqrtq2))*z3)/(-42000*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))-42000*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2+logq2**5*(-156764160000*r**22*(1+r**2)*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            +156764160000*r**22*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**2*(-36288000*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8
            +3*Q2**3*(1+r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4
            +7*r**6))-36288000*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8
            +3*Q2**3*(1+r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4
            +7*r**6))*sqrtq2)+logq2**3*(145152000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))+145152000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))*sqrtq2)+logq2**4*(-870912000*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(63+8*Q2**4-402*r**2
            -1122*r**4-402*r**6+63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)
            -3*Q2*(19+31*r**2+31*r**4+19*r**6))-870912000*(-Q2+(-1+r)**2)*r**18*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(63+8*Q2**4-402*r**2-1122*r**4-402*r**6
            +63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)-3*Q2*(19+31*r**2
            +31*r**4+19*r**6))*sqrtq2)+logq2*(504000*(-Q2+(-1+r)**2)*r**6*(1-Q2
            +r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1
            +r**2)-Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)
            +3*(9-86*r**2-446*r**4-86*r**6+9*r**8))+504000*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1+r**2)
            -Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)+3*(9
            -86*r**2-446*r**4-86*r**6+9*r**8))*sqrtq2))+((muWC*(-12096000*logq2**3*Q2*r**12*(1
            +r**2)*(19+10*r**2+19*r**4)+480*logq2*Q2*(Q2-(-1+r)**2)*r**4*(Q2-(1
            +r)**2)*(-23+1440*Q2**9-10999*r**2-228160*r**4-383296*r**6-3006322*r**8
            -3006322*r**10-383296*r**12-228160*r**14-10999*r**16-23*r**18-10248*Q2**8*(1
            +r**2)+512*Q2**7*(37+94*r**2+37*r**4)-Q2**6*(4319+70769*r**2+70769*r**4
            +4319*r**6)+Q2**5*(-17262+38144*r**2+60252*r**4+38144*r**6-17262*r**8)
            +Q2**4*(11375+66235*r**2+466262*r**4+466262*r**6+66235*r**8+11375*r**10)
            +4*Q2**3*(847-28698*r**2-220767*r**4-429164*r**6-220767*r**8-28698*r**10
            +847*r**12)+Q2**2*(-3729+4117*r**2+37563*r**4+1070849*r**6+1070849*r**8
            +37563*r**10+4117*r**12-3729*r**14)+2*Q2*(217+25092*r**2+198688*r**4
            -394052*r**6-869490*r**8-394052*r**10+198688*r**12+25092*r**14+217*r**16))
            +28800*logq2**2*Q2*r**8*(-781+80*Q2**6-4344*r**2-33555*r**4-43600*r**6
            -33555*r**8-4344*r**10-781*r**12-900*Q2**5*(1+r**2)+4*Q2**4*(951+1718*r**2
            +951*r**4)-Q2**3*(3931+13189*r**2+13189*r**4+3931*r**6)+Q2**2*(-1131
            +5648*r**2+11126*r**4+5648*r**6-1131*r**8)+3*Q2*(953-829*r**2-3484*r**4
            -3484*r**6-829*r**8+953*r**10))*sqrtq2+8*Q2*(250*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4-2708*r**6-1133*r**8-34*r**10
            +r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1-19*r**2
            -19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4-26*r**6+r**8)+Q2*(1-31*r**2
            -390*r**4-390*r**6-31*r**8+r**10))-7*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8-444*r**2
            -9976*r**4+31692*r**6-28170*r**8+31692*r**10-9976*r**12-444*r**14+13*r**16
            -24*Q2**7*(1+r**2)+Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61-193*r**2
            -193*r**4+61*r**6)+Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6-165*r**8)
            +4*Q2**3*(13-355*r**2-6138*r**4-6138*r**6-355*r**8+13*r**10)+Q2**2*(59
            -406*r**2+10313*r**4+35188*r**6+10313*r**8-406*r**10+59*r**12)-2*Q2*(27
            -595*r**2-7237*r**4+6605*r**6+6605*r**8-7237*r**10-595*r**12+27*r**14)))*sqrtq2))/(163296000*logq2**4*r**16
            +6804000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+7875*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-54432000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-378000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +(muWC**2*(-1512000*logq2**3*Q2*r**12*(1+r**2)*(19+10*r**2+19*r**4)+60*logq2*Q2*(Q2
            -(-1+r)**2)*r**4*(Q2-(1+r)**2)*(-23+1440*Q2**9-10999*r**2-228160*r**4
            -383296*r**6-3006322*r**8-3006322*r**10-383296*r**12-228160*r**14-10999*r**16
            -23*r**18-10248*Q2**8*(1+r**2)+512*Q2**7*(37+94*r**2+37*r**4)-Q2**6*(4319
            +70769*r**2+70769*r**4+4319*r**6)+Q2**5*(-17262+38144*r**2+60252*r**4
            +38144*r**6-17262*r**8)+Q2**4*(11375+66235*r**2+466262*r**4+466262*r**6
            +66235*r**8+11375*r**10)+4*Q2**3*(847-28698*r**2-220767*r**4-429164*r**6
            -220767*r**8-28698*r**10+847*r**12)+Q2**2*(-3729+4117*r**2+37563*r**4
            +1070849*r**6+1070849*r**8+37563*r**10+4117*r**12-3729*r**14)+2*Q2*(217
            +25092*r**2+198688*r**4-394052*r**6-869490*r**8-394052*r**10+198688*r**12
            +25092*r**14+217*r**16))+3600*logq2**2*Q2*r**8*(-781+80*Q2**6-4344*r**2
            -33555*r**4-43600*r**6-33555*r**8-4344*r**10-781*r**12-900*Q2**5*(1
            +r**2)+4*Q2**4*(951+1718*r**2+951*r**4)-Q2**3*(3931+13189*r**2+13189*r**4
            +3931*r**6)+Q2**2*(-1131+5648*r**2+11126*r**4+5648*r**6-1131*r**8)
            +3*Q2*(953-829*r**2-3484*r**4-3484*r**6-829*r**8+953*r**10))*sqrtq2
            +(250*Q2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4
            -2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2
            -6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4
            -26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6-31*r**8+r**10))-7*Q2*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6-28170*r**8+31692*r**10
            -9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)+Q2**6*(-11+10*r**2
            -11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)+Q2**4*(-165+1480*r**2
            +10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2-6138*r**4-6138*r**6
            -355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4+35188*r**6+10313*r**8
            -406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4+6605*r**6+6605*r**8
            -7237*r**10-595*r**12+27*r**14)))*sqrtq2))/(54432000*logq2**4*r**16+2268000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+2625*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-18144000*logq2**3*r**12*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2-126000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2))*nlo.X1Q2_DerivativeQ2(0,Q2,r)+((muWC*(-57600*logq2**2*Q2*r**8*(15
            +22*r**2+15*r**4)-16*Q2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(7+92*Q2**8
            -156*r**2+5096*r**4+19308*r**6+138690*r**8+19308*r**10+5096*r**12-156*r**14
            +7*r**16-156*Q2**7*(1+r**2)+Q2**6*(-89+190*r**2-89*r**4)+2*Q2**5*(79
            -247*r**2-247*r**4+79*r**6)+Q2**4*(165-1160*r**2-10298*r**4-1160*r**6
            +165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4-2439*r**6-280*r**8+19*r**10)
            +Q2**2*(-79+806*r**2+1787*r**4-14228*r**6+1787*r**8+806*r**10-79*r**12)
            +2*Q2*(27-635*r**2-2957*r**4+19165*r**6+19165*r**8-2957*r**10-635*r**12
            +27*r**14))-9600*logq2*Q2*r**4*(1+2*Q2**5+35*r**2+276*r**4+276*r**6
            +35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17+42*r**2+17*r**4)+Q2**2*(7
            -19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2+66*r**4+30*r**6-11*r**8))*sqrtq2))/(
            -388800*logq2**3*r**12-8100*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+97200*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+225*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(muWC**2*(-7200*logq2**2*Q2*r**8*(15+22*r**2
            +15*r**4)-2*Q2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(7+92*Q2**8-156*r**2
            +5096*r**4+19308*r**6+138690*r**8+19308*r**10+5096*r**12-156*r**14
            +7*r**16-156*Q2**7*(1+r**2)+Q2**6*(-89+190*r**2-89*r**4)+2*Q2**5*(79
            -247*r**2-247*r**4+79*r**6)+Q2**4*(165-1160*r**2-10298*r**4-1160*r**6
            +165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4-2439*r**6-280*r**8+19*r**10)
            +Q2**2*(-79+806*r**2+1787*r**4-14228*r**6+1787*r**8+806*r**10-79*r**12)
            +2*Q2*(27-635*r**2-2957*r**4+19165*r**6+19165*r**8-2957*r**10-635*r**12
            +27*r**14))-1200*logq2*Q2*r**4*(1+2*Q2**5+35*r**2+276*r**4+276*r**6
            +35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17+42*r**2+17*r**4)+Q2**2*(7
            -19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2+66*r**4+30*r**6-11*r**8))*sqrtq2))/(
            -129600*logq2**3*r**12-2700*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+32400*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+75*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2))*nlo.X1Q2_DerivativeQ2(1,Q2,r)+((muWC**2*(-360*logq2*Q2*r**4*(1
            +r**2)+2*Q2*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(720*logq2**2*r**8
            +5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(muWC*(-2880*logq2*Q2*r**4*(1
            +r**2)+16*Q2*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(2160*logq2**2*r**8
            +15*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-360*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))*nlo.X1Q2_DerivativeQ2(2,Q2,r)+((
            -4*muWC**2*Q2)/(-36*logq2*r**4+3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2)-(32*muWC*Q2)/(-108*logq2*r**4+9*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))*nlo.X1Q2_DerivativeQ2(3,Q2,r)
            +(pi2*(-4*(Q2-(-1+r)**2)**4*r**4*(Q2-(1+r)**2)**4*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(-1059+24*Q2**14-322322*r**2-93757*r**4
            -25369844*r**6+127046277*r**8-457228062*r**10+815729139*r**12-694656216*r**14
            +236289183*r**16-15296334*r**18+10159121*r**20+3791308*r**22-43777*r**24
            -3714*r**26+57*r**28+56*Q2**13*(1+r**2)+Q2**12*(1627+3446*r**2-1457*r**4)
            +4*Q2**11*(-3797-54679*r**2-8387*r**4+1615*r**6)+4*Q2**10*(11639+338572*r**2
            +403567*r**4+30654*r**6-3472*r**8)+4*Q2**9*(-15387-727340*r**2-2055110*r**4
            -1044380*r**6-54495*r**8+4008*r**10)+Q2**8*(15423+1013978*r**2+12323485*r**4
            +13564420*r**6+3813345*r**8+170178*r**10-8157*r**12)-8*Q2**7*(-6327
            -651616*r**2-542973*r**4-1778395*r**6+98905*r**8-203412*r**10-2181*r**12
            +207*r**14)+8*Q2**6*(-5943-891191*r**2-3383193*r**4-11587780*r**6-10153075*r**8
            -1572643*r**10-622461*r**12-13398*r**14+420*r**16)+8*Q2**5*(-1284+8398*r**2
            +2312708*r**4+9155691*r**6+23311392*r**8+6859881*r**10+797988*r**12
            +185973*r**14+1356*r**16+57*r**18)+Q2**4*(34249+5785410*r**2+7369665*r**4
            +88484320*r**6-138504270*r**8-44549788*r**10+15777210*r**12-6455760*r**14
            +2109045*r**16+71530*r**18-1931*r**20)+4*Q2**3*(-3001-818121*r**2-3167815*r**4
            -34632105*r**6+13941570*r**8-19084558*r**10+6052382*r**12+3025010*r**14
            +3050295*r**16-323305*r**18-8471*r**20+119*r**22)+4*Q2**2*(-1567-223806*r**2
            +930087*r**4+2175310*r**6+12132160*r**8+4033124*r**10-13722438*r**12
            -13803764*r**14-5884315*r**16-87590*r**18-58337*r**20-4186*r**22+122*r**24)
            -4*Q2*(-1333-327586*r**2-53198*r**4-15606570*r**6+50223425*r**8-85305484*r**10
            +38454012*r**12+5455156*r**14+2058365*r**16+2960350*r**18+2220242*r**20
            -73226*r**22-4233*r**24+80*r**26))*(3+math.log(4))+4*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(1059
            +24*Q2**15+323381*r**2+416079*r**4+25463601*r**6-101676433*r**8+330181785*r**10
            -358501077*r**12-121072923*r**14+458367033*r**16-220992849*r**18+5137213*r**20
            -13950429*r**22-3747531*r**24+47491*r**26+3657*r**28-57*r**30+32*Q2**14*(1
            +r**2)+Q2**13*(1571+3334*r**2-1513*r**4)+Q2**12*(-16815-223789*r**2
            -35537*r**4+7917*r**6)+4*Q2**11*(15436+397048*r**2+466633*r**4+37426*r**6
            -5087*r**8)+4*Q2**10*(-27026-1077551*r**2-2797249*r**4-1478601*r**6
            -81677*r**8+7480*r**10)+Q2**9*(76971+3984886*r**2+23453285*r**4+25962380*r**6
            +8208845*r**8+372126*r**10-24189*r**12)+3*Q2**8*(11731+1394509*r**2
            -2997893*r**4-3886915*r**6-6056335*r**8-785409*r**10-48191*r**12+2167*r**14)
            +8*Q2**7*(-12270-1549134*r**2-4577782*r**4-13909148*r**6-11832565*r**8
            -1677150*r**10-828054*r**12-15372*r**14+627*r**16)-8*Q2**6*(-4659-905532*r**2
            -6587092*r**4-24126664*r**6-45052247*r**8-18585599*r**10-2993092*r**12
            -821832*r**14-14334*r**16+363*r**18)-Q2**5*(-44521-5728498*r**2+11199183*r**4
            +3262872*r**6+398240934*r**8+285919972*r**10+45485742*r**12+14327448*r**14
            -610413*r**16-60226*r**18+2387*r**20)+Q2**4*(-46253-9092143*r**2-25826335*r**4
            -234382405*r**6+105786230*r**8+106715826*r**10+52982106*r**12+2778590*r**14
            +16547895*r**16-3473795*r**18-103483*r**20+2407*r**22)+4*Q2**3*(1434
            +597316*r**2+4916023*r**4+39975230*r**6+32822695*r**8+9176112*r**10
            -690262*r**12-22881156*r**14-11959620*r**16-2814580*r**18+273439*r**20
            +4166*r**22+3*r**24)-4*Q2**2*(-2900-552959*r**2+653083*r**4-12501173*r**6
            +64530895*r**8-69140200*r**10+28764698*r**12-22071046*r**14-17629714*r**16
            -3011555*r**18+2074315*r**20-135749*r**22-8297*r**24+202*r**26)+Q2*(
            -6391-1637998*r**2-1616893*r**4-88008916*r**6+265513697*r**8-597556298*r**10
            +628323251*r**12-519019544*r**14+266343267*r**16+4778526*r**18+30881489*r**20
            +12379372*r**22-353613*r**24-20326*r**26+377*r**28))*sqrtq2*(3+math.log(4))
            +logq2**5*(13063680000*(-Q2+(-1+r)**2)*(-1+r)*r**24*(1+r)*(1+r**2)*(1
            -Q2+r**2)*(1+3*r**2)*(-Q2+(1+r)**2)*(3+math.log(4))+13063680000*(-Q2
            +(-1+r)**2)*(-1+r)*r**24*(1+r)*(1+r**2)*(1+3*r**2)*(-Q2+(1+r)**2)*sqrtq2*(3
            +math.log(4)))+logq2**4*(10368000*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(480*Q2**6*(1
            +r**2)-240*Q2**5*(12+17*r**2+5*r**4)-8*Q2**4*(-837-1483*r**2-503*r**4
            +171*r**6)+Q2**3*(-6324-14275*r**2-4737*r**4+7411*r**6+4197*r**8)+Q2**2*(
            -864+5213*r**2+3876*r**4-10278*r**6-7268*r**8+1257*r**10)-3*Q2*(-1812
            -611*r**2+1987*r**4+340*r**6-2976*r**8+271*r**10+2801*r**12)+3*(-848
            +75*r**2+908*r**4-4783*r**6-1808*r**8+3925*r**10+852*r**12+1679*r**14))*(3
            +math.log(4))+10368000*(-Q2+(-1+r)**2)*r**18*(1-Q2+r**2)*(-Q2+(1+r)**2)*(480*Q2**6*(1
            +r**2)-240*Q2**5*(12+17*r**2+5*r**4)-8*Q2**4*(-837-1483*r**2-503*r**4
            +171*r**6)+Q2**3*(-6324-14275*r**2-4737*r**4+7411*r**6+4197*r**8)+Q2**2*(
            -864+5213*r**2+3876*r**4-10278*r**6-7268*r**8+1257*r**10)-3*Q2*(-1812
            -611*r**2+1987*r**4+340*r**6-2976*r**8+271*r**10+2801*r**12)+3*(-848
            +75*r**2+908*r**4-4783*r**6-1808*r**8+3925*r**10+852*r**12+1679*r**14))*sqrtq2*(3
            +math.log(4)))+logq2**3*(345600*r**14*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-640*Q2**10+80*Q2**9*(109+81*r**2)-4*Q2**8*(10744+17565*r**2
            +6629*r**4)+4*Q2**7*(24047+67087*r**2+55577*r**4+13937*r**6)-Q2**6*(78778
            +441405*r**2+587331*r**4+300955*r**6+60123*r**8)+2*Q2**5*(-29057+100006*r**2
            +207494*r**4+162424*r**6+61691*r**8+16898*r**10)+Q2**4*(153860+296465*r**2
            +664749*r**4+542330*r**6-31266*r**8-47435*r**10-16975*r**12)+8*Q2**3*(
            -9293-50490*r**2-150185*r**4-148772*r**6+24933*r**8+80570*r**10+26545*r**12
            +612*r**14)+Q2**2*(-39058+131617*r**2+206511*r**4+593941*r**6-348657*r**8
            -1148689*r**10-284079*r**12-97573*r**14+18307*r**16)-6*Q2*(-7893-6060*r**2
            -116040*r**4+16620*r**6+110278*r**8-131432*r**10-66960*r**12+171020*r**14
            +26855*r**16+3612*r**18)+3*(-4072-7899*r**2-124223*r**4+73288*r**6
            +12024*r**8-157026*r**10+1734*r**12-80392*r**14+247472*r**16+36861*r**18
            +2233*r**20))*(3+math.log(4))-345600*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(640*Q2**10-80*Q2**9*(109+81*r**2)+4*Q2**8*(10744+17565*r**2
            +6629*r**4)-4*Q2**7*(24047+67087*r**2+55577*r**4+13937*r**6)+Q2**6*(78778
            +441405*r**2+587331*r**4+300955*r**6+60123*r**8)-2*Q2**5*(-29057+100006*r**2
            +207494*r**4+162424*r**6+61691*r**8+16898*r**10)+Q2**4*(-153860-296465*r**2
            -664749*r**4-542330*r**6+31266*r**8+47435*r**10+16975*r**12)-8*Q2**3*(
            -9293-50490*r**2-150185*r**4-148772*r**6+24933*r**8+80570*r**10+26545*r**12
            +612*r**14)+Q2**2*(39058-131617*r**2-206511*r**4-593941*r**6+348657*r**8
            +1148689*r**10+284079*r**12+97573*r**14-18307*r**16)+6*Q2*(-7893-6060*r**2
            -116040*r**4+16620*r**6+110278*r**8-131432*r**10-66960*r**12+171020*r**14
            +26855*r**16+3612*r**18)-3*(-4072-7899*r**2-124223*r**4+73288*r**6
            +12024*r**8-157026*r**10+1734*r**12-80392*r**14+247472*r**16+36861*r**18
            +2233*r**20))*sqrtq2*(3+math.log(4)))+logq2**2*(-5760*r**10*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(11520*Q2**13-16*Q2**12*(6129+5467*r**2)+4*Q2**11*(81472
            +162683*r**2+68411*r**4)-4*Q2**10*(115431+488576*r**2+445435*r**4+107538*r**6)
            +5*Q2**9*(2286+525503*r**2+836313*r**4+485409*r**6+63513*r**8)-5*Q2**8*(
            -156696+37219*r**2-31124*r**4+156518*r**6+255372*r**8+4311*r**10)-2*Q2**7*(395556
            +2230843*r**2+9881570*r**4+14718735*r**6+6476095*r**8+461006*r**10+81363*r**12)
            +2*Q2**6*(-57588+2859143*r**2+16754391*r**4+43245765*r**6+36028570*r**8
            +10679877*r**10+969843*r**12+94431*r**14)-2*Q2**5*(-311994+477316*r**2
            +2545855*r**4+38935933*r**6+53179760*r**8+24313856*r**10+5004941*r**12
            +668895*r**14+47838*r**16)-10*Q2**4*(26328+392144*r**2+3683419*r**4
            +2309292*r**6-100423*r**8-798008*r**10-202923*r**12-290236*r**14-70913*r**16
            +7224*r**18)+10*Q2**3*(-11460+312497*r**2+3011748*r**4+7592889*r**6
            +9993411*r**8+4134399*r**10-3077805*r**12-3372825*r**14-830991*r**16
            -33744*r**18+11161*r**20)+2*Q2**2*(51538+83929*r**2+2099095*r**4-19815615*r**6
            -13787040*r**8-9064446*r**10+33675702*r**12+33703410*r**14+16351470*r**16
            +431045*r**18-179437*r**20-4051*r**22)-3*Q2*(3854+351281*r**2+4245317*r**4
            -2508915*r**6+22869135*r**8-11047218*r**10+3415638*r**12+21190806*r**14
            -28658760*r**16-6759935*r**18-2912411*r**20-202019*r**22+13227*r**24)
            +3*(-1288+110037*r**2+1257150*r**4-375994*r**6+15437670*r**8-7418889*r**10
            -19279324*r**12+10397140*r**14+33625068*r**16-26364045*r**18-5865698*r**20
            -1453338*r**22-73290*r**24+4801*r**26))*(3+math.log(4))+5760*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(11520*Q2**14-16*Q2**13*(6849+6187*r**2)
            +4*Q2**12*(105988+209067*r**2+90279*r**4)-4*Q2**11*(196903+732731*r**2
            +676529*r**4+175949*r**6)+Q2**10*(473154+5043543*r**2+7917609*r**4+4638937*r**6
            +747717*r**8)-10*Q2**9*(-77205+282504*r**2+665346*r**4+739120*r**6+402147*r**8
            +33912*r**10)-Q2**8*(1574592+5059071*r**2+19732665*r**4+28810500*r**6
            +10892740*r**8-376403*r**10+141171*r**12)+4*Q2**7*(168984+2742771*r**2
            +14433402*r**4+33923035*r**6+28611700*r**8+8808489*r**10+756106*r**12
            +87897*r**14)-2*Q2**6*(-369582+3278871*r**2+22159389*r**4+98936089*r**6
            +132454095*r**8+71022303*r**10+16654661*r**12+1733169*r**14+142269*r**16)
            +4*Q2**5*(-221817-897699*r**2-7696962*r**4+14967664*r**6+46308904*r**8
            +40741828*r**10+15166706*r**12+3562508*r**14+535649*r**16+5859*r**18)
            +10*Q2**4*(14868+730969*r**2+7087311*r**4+13585600*r**6+12202280*r**8
            +3235968*r**10-4078736*r**12-3865984*r**14-1192140*r**16-97433*r**18
            +18385*r**20)-4*Q2**3*(-54419+710628*r**2+7261065*r**4+36419400*r**6
            +50859270*r**8+39851748*r**10-14196366*r**12-32978280*r**14-18685275*r**16
            -2377360*r**18+33261*r**20+29928*r**22)-Q2**2*(114638+1324777*r**2+17101999*r**4
            -42959785*r**6+1402095*r**8-78844626*r**10+59469426*r**12+198330642*r**14
            +14133480*r**16+13285225*r**18-8234017*r**20-973033*r**22+31579*r**24)
            +6*Q2*(1283+232586*r**2+2926874*r**4+680204*r**6+17898945*r**8+2201514*r**10
            -13455452*r**12+17501792*r**14+13078557*r**16-30891370*r**18-7769022*r**20
            -2283884*r**22-131041*r**24+9014*r**26)-3*(-1288+108749*r**2+1367187*r**4
            +881156*r**6+15061676*r**8+8018781*r**10-26698213*r**12-8882184*r**14
            +44022208*r**16+7261023*r**18-32229743*r**20-7319036*r**22-1526628*r**24
            -68489*r**26+4801*r**28))*sqrtq2*(3+math.log(4)))+logq2*(48*r**6*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-24832*Q2**16+32*Q2**15*(7391
            +8831*r**2)-8*Q2**14*(105120+310747*r**2+147195*r**4)+8*Q2**13*(149925
            +949863*r**2+1071463*r**4+279085*r**6)-Q2**12*(-269140+7147001*r**2
            +11059123*r**4+11171351*r**6+1391025*r**8)-4*Q2**11*(730411+2738804*r**2
            +12969654*r**4+10560284*r**6+330159*r**8+414176*r**10)+2*Q2**10*(1319262
            +15299499*r**2+92391625*r**4+176075950*r**6+77432240*r**8+8996279*r**10
            +1413177*r**12)+4*Q2**9*(365205-4054812*r**2-43791325*r**4-205409750*r**6
            -190977325*r**8-47505400*r**10-4236587*r**12+33930*r**14)+Q2**8*(-3625800
            -20966583*r**2-124396393*r**4+638600425*r**6+1143100575*r**8+659131035*r**10
            +85605557*r**12+5002867*r**14-2632035*r**16)+8*Q2**7*(113165+3632844*r**2
            +46580062*r**4+87545574*r**6+158298110*r**8+127385300*r**10+18149174*r**12
            +4626662*r**14+319169*r**16+139700*r**18)+4*Q2**6*(461246-828817*r**2
            -48003727*r**4-467276692*r**6-1374332532*r**8-2141159326*r**10-1024048542*r**12
            -170495852*r**14-23969242*r**16-1959057*r**18+264701*r**20)-8*Q2**5*(146598
            +1671809*r**2+18659510*r**4-133478905*r**6-437240570*r**8-1593563812*r**10
            -1271910682*r**12-335013240*r**14-39908980*r**16-9947845*r**18-886356*r**20
            +102873*r**22)-Q2**4*(340860-7395849*r**2-202457835*r**4-790689275*r**6
            -4645644325*r**8+2616114550*r**10+5891720898*r**12+434581850*r**14+114198850*r**16
            +95382675*r**18+4007465*r**20-1807199*r**22+178535*r**24)+4*Q2**3*(113225
            +229076*r**2-10748334*r**4-296233120*r**6-1492129325*r**8-1620955560*r**10
            -911801092*r**12-425924192*r**14+471635775*r**16+368745300*r**18+91618610*r**20
            -9485184*r**22-1294299*r**24+69120*r**26)-2*Q2**2*(12730+944813*r**2
            +21319199*r**4-99536842*r**6-5148760*r**8-2804453825*r**10-442052871*r**12
            +375339252*r**14+3068697954*r**16+2909071835*r**18+412512145*r**20+54726358*r**22
            -7406276*r**24-383687*r**26+5975*r**28)-12*Q2*(6209-44832*r**2-2222177*r**4
            -25078142*r**6-178749747*r**8+365365296*r**10-712704661*r**12+20753954*r**14
            -240045341*r**16+569882944*r**18+66295181*r**20+112256118*r**22+24862223*r**24
            -461392*r**26-119447*r**28+3814*r**30)+3*(6416-13331*r**2-1506565*r**4
            -40930255*r**6-210248305*r**8+628651937*r**10-3432125417*r**12+3719437205*r**14
            +2909531835*r**16-7282941065*r**18+2875929953*r**20+542905027*r**22+237587485*r**24
            +54892795*r**26-1008755*r**28-172681*r**30+3721*r**32))*(3+math.log(4))
            -48*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(24832*Q2**16-32*Q2**15*(7391
            +8831*r**2)+8*Q2**14*(105120+310747*r**2+147195*r**4)-8*Q2**13*(149925
            +949863*r**2+1071463*r**4+279085*r**6)+Q2**12*(-269140+7147001*r**2
            +11059123*r**4+11171351*r**6+1391025*r**8)+4*Q2**11*(730411+2738804*r**2
            +12969654*r**4+10560284*r**6+330159*r**8+414176*r**10)-2*Q2**10*(1319262
            +15299499*r**2+92391625*r**4+176075950*r**6+77432240*r**8+8996279*r**10
            +1413177*r**12)-4*Q2**9*(365205-4054812*r**2-43791325*r**4-205409750*r**6
            -190977325*r**8-47505400*r**10-4236587*r**12+33930*r**14)+Q2**8*(3625800
            +20966583*r**2+124396393*r**4-638600425*r**6-1143100575*r**8-659131035*r**10
            -85605557*r**12-5002867*r**14+2632035*r**16)-8*Q2**7*(113165+3632844*r**2
            +46580062*r**4+87545574*r**6+158298110*r**8+127385300*r**10+18149174*r**12
            +4626662*r**14+319169*r**16+139700*r**18)+4*Q2**6*(-461246+828817*r**2
            +48003727*r**4+467276692*r**6+1374332532*r**8+2141159326*r**10+1024048542*r**12
            +170495852*r**14+23969242*r**16+1959057*r**18-264701*r**20)+8*Q2**5*(146598
            +1671809*r**2+18659510*r**4-133478905*r**6-437240570*r**8-1593563812*r**10
            -1271910682*r**12-335013240*r**14-39908980*r**16-9947845*r**18-886356*r**20
            +102873*r**22)+Q2**4*(340860-7395849*r**2-202457835*r**4-790689275*r**6
            -4645644325*r**8+2616114550*r**10+5891720898*r**12+434581850*r**14+114198850*r**16
            +95382675*r**18+4007465*r**20-1807199*r**22+178535*r**24)-4*Q2**3*(113225
            +229076*r**2-10748334*r**4-296233120*r**6-1492129325*r**8-1620955560*r**10
            -911801092*r**12-425924192*r**14+471635775*r**16+368745300*r**18+91618610*r**20
            -9485184*r**22-1294299*r**24+69120*r**26)+2*Q2**2*(12730+944813*r**2
            +21319199*r**4-99536842*r**6-5148760*r**8-2804453825*r**10-442052871*r**12
            +375339252*r**14+3068697954*r**16+2909071835*r**18+412512145*r**20+54726358*r**22
            -7406276*r**24-383687*r**26+5975*r**28)+12*Q2*(6209-44832*r**2-2222177*r**4
            -25078142*r**6-178749747*r**8+365365296*r**10-712704661*r**12+20753954*r**14
            -240045341*r**16+569882944*r**18+66295181*r**20+112256118*r**22+24862223*r**24
            -461392*r**26-119447*r**28+3814*r**30)-3*(6416-13331*r**2-1506565*r**4
            -40930255*r**6-210248305*r**8+628651937*r**10-3432125417*r**12+3719437205*r**14
            +2909531835*r**16-7282941065*r**18+2875929953*r**20+542905027*r**22+237587485*r**24
            +54892795*r**26-1008755*r**28-172681*r**30+3721*r**32))*sqrtq2*(3+math.log(4)))))/(
            -126000*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-126000*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2+logq2**5*(-470292480000*r**22*(1
            +r**2)*(-1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            +470292480000*r**22*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**2*(-108864000*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8
            +3*Q2**3*(1+r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4
            +7*r**6))-108864000*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8
            +3*Q2**3*(1+r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4
            +7*r**6))*sqrtq2)+logq2**3*(435456000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))+435456000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))*sqrtq2)+logq2**4*(-2612736000*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(63+8*Q2**4-402*r**2
            -1122*r**4-402*r**6+63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)
            -3*Q2*(19+31*r**2+31*r**4+19*r**6))-2612736000*(-Q2+(-1+r)**2)*r**18*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(63+8*Q2**4-402*r**2-1122*r**4-402*r**6
            +63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)-3*Q2*(19+31*r**2
            +31*r**4+19*r**6))*sqrtq2)+logq2*(1512000*(-Q2+(-1+r)**2)*r**6*(1-Q2
            +r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1
            +r**2)-Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)
            +3*(9-86*r**2-446*r**4-86*r**6+9*r**8))+1512000*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1+r**2)
            -Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)+3*(9
            -86*r**2-446*r**4-86*r**6+9*r**8))*sqrtq2))+((16*(Q2-(-1+r)**2)**6*r**6*(Q2
            -(1+r)**2)**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(-24*Q2**19
            +16*Q2**18*(1+229*r**2)+Q2**17*(-1507+76282*r**2-67015*r**4)+Q2**16*(19909
            -5990881*r**2-1268037*r**4+512929*r**6)+Q2**15*(-95414+54112638*r**2
            +83403964*r**4+9085966*r**6-2223314*r**8)+Q2**14*(228482-201271100*r**2
            -638543398*r**4-434327038*r**6-37276316*r**8+6184442*r**10)+2*Q2**13*(
            -128989+161432229*r**2+892573587*r**4+1120917346*r**6+597209997*r**8
            +48814233*r**10-5860771*r**12)+2*Q2**12*(-10777+17143802*r**2-487356300*r**4
            -17793609*r**6-1354521573*r**8-982772100*r**10-85768246*r**12+7776275*r**14)
            -2*Q2**11*(-223249+485479801*r**2+2763141872*r**4+12393132807*r**6+11233467240*r**8
            +558834783*r**10-1016585020*r**12-103141295*r**14+7274501*r**16)+2*Q2**10*(
            -247819+690785678*r**2+6243028551*r**4+32303721257*r**6+54562461809*r**8
            +28243778349*r**10+2925542093*r**12-644774917*r**14-85398522*r**16+4788641*r**18)
            -2*Q2**9*(-18304+95093625*r**2+2991098402*r**4+20468756352*r**6+79251756184*r**8
            +64930158794*r**10+29533522740*r**12+3348601672*r**14-136723648*r**16
            -49588891*r**18+2251106*r**20)+2*Q2**8*(183404-729715679*r**2-6203784919*r**4
            -40601219052*r**6+4697032056*r**8-22430439318*r**10+10458520674*r**12
            +24273440856*r**14+3830245308*r**16+270183701*r**18-21763115*r**20+804596*r**22)
            -2*Q2**7*(135473-721119173*r**2-9606170070*r**4-77897630473*r**6-95068523111*r**8
            -208758362394*r**10-145369160988*r**12+191132950*r**14+30740286507*r**16
            +4759238639*r**18+405002722*r**20-6540669*r**22+161915*r**24)-2*Q2**6*(25949
            -13292286*r**2+2542050773*r**4+26930074517*r**6+87767011740*r**8+145516684577*r**10
            +239722318378*r**12+60409833746*r**14-27006054331*r**16-22820988940*r**18
            -2528260095*r**20-215048359*r**22-2959678*r**24+151529*r**26)+2*Q2**5*(83309
            -450258113*r**2-4686952903*r**4-44978161318*r**6+37072166533*r**8-239289526195*r**10
            +221863231993*r**12-44159330788*r**14+50765196175*r**16-17732659495*r**18
            +2371786723*r**20+1198382282*r**22+43596863*r**24-6573605*r**26+205739*r**28)
            -2*Q2**4*(35783-267376050*r**2-4246419276*r**4-47590533521*r**6+26740482133*r**8
            -441331623168*r**10+389732934150*r**12-230016456443*r**14-61635935823*r**16
            +103793659494*r**18-22245798008*r**20+8910971385*r**22+1810928179*r**24
            +100963404*r**26-3672642*r**28+83603*r**30)-2*Q2**3*(7673-19365493*r**2
            +511208868*r**4+6762857769*r**6+1194628678*r**8+146536579835*r**10-312331261232*r**12
            +348400864289*r**14-159156197548*r**16+125406679849*r**18-52963655884*r**20
            +18391869443*r**22-2479777182*r**24-510615471*r**26-22282152*r**28-188749*r**30
            +16907*r**32)+(-1+r**2)**2*(1059-9980275*r**2-184231894*r**4-2956843282*r**6
            +12134567510*r**8-112543968046*r**10+430132951346*r**12-1003572638298*r**14
            +1202024565084*r**16-670525021140*r**18+179478246430*r**20-44624369942*r**22
            -7509659462*r**24-2656934402*r**26-92398970*r**28+3966082*r**30-142479*r**32
            +2679*r**34)+2*Q2**2*(12191-83513366*r**2-951699775*r**4-12711010389*r**6
            +42076386537*r**8-230582118009*r**10+440760354373*r**12-403648478425*r**14
            +68171152723*r**16-8887079849*r**18+6215429555*r**20-28296705743*r**22
            -11527541085*r**24-3322558059*r**26-62192313*r**28+21103613*r**30-1138814*r**32
            +28835*r**34)+Q2*(-8509+70143536*r**2+1018949427*r**4+14923494344*r**6
            -70888347540*r**8+484652832840*r**10-1618643959124*r**12+3050501923432*r**14
            -2710775755542*r**16+697874154440*r**18+269815377802*r**20-131226782760*r**22
            +63315559900*r**24+24727128792*r**26+8022044700*r**28+245593592*r**30
            -25778677*r**32+1002216*r**34-20869*r**36))+16*r**6*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(24*Q2**20
            -8*Q2**19*(5+461*r**2)+Q2**18*(1523-72602*r**2+70679*r**4)-8*Q2**17*(2677
            -758207*r**2-159663*r**4+72493*r**6)+Q2**16*(115323-60083610*r**2-90662882*r**4
            -9841074*r**6+2736243*r**8)+Q2**15*(-323896+255288324*r**2+776060000*r**4
            +526816968*r**6+44138968*r**8-8407756*r**10)+4*Q2**14*(121615-130976769*r**2
            -656240418*r**4-828676282*r**6-416505837*r**8-32180085*r**10+4476496*r**12)
            -4*Q2**13*(59106-72079719*r**2-770681058*r**4-1015642271*r**6-1536324458*r**8
            -814398165*r**10-64360854*r**12+6818523*r**14)+4*Q2**12*(-117013+251306413*r**2
            +1146464687*r**4+5943991449*r**6+4930576029*r**8-889229445*r**10-1042562683*r**12
            -90566633*r**14+7525388*r**16)-4*Q2**11*(-235534+588021115*r**2+4745825112*r**4
            +23729997968*r**6+39094530928*r**8+20018040186*r**10+1233895928*r**12
            -882250616*r**14-90632658*r**16+6031571*r**18)+2*Q2**10*(-266123+785631484*r**2
            +9924912631*r**4+59015506160*r**6+166117939250*r**8+147736398952*r**10
            +60702843182*r**12+5629368848*r**14-866897087*r**16-130198772*r**18+7039747*r**20)
            -4*Q2**9*(82550-317320179*r**2-1558796446*r**4-8570682149*r**6+52208772296*r**8
            +60875737830*r**10+52461101104*r**12+28577782634*r**14+3521061666*r**16
            +41935581*r**18-34550450*r**20+1527851*r**22)+2*Q2**8*(318877-1450651448*r**2
            -16539670668*r**4-124702634444*r**6-130972710107*r**8-226491769656*r**10
            -157341079632*r**12+34923094480*r**14+58843972671*r**16+8859667648*r**18
            +653423308*r**20-27499188*r**22+966511*r**24)-4*Q2**7*(54762-353845707*r**2
            -6434670008*r**4-57216937530*r**6-130366582662*r**8-224671785041*r**10
            -296924920880*r**12-102793930892*r**14+28968736894*r**16+29160257043*r**18
            +3846250728*r**20+306755206*r**22-1709538*r**24+5193*r**26)-4*Q2**6*(54629
            -231762225*r**2-1079097208*r**4-7753018014*r**6+75884626395*r**8-3002914939*r**10
            +303551117474*r**12+127986410668*r**14+42084487795*r**16-33779851383*r**18
            -11488731156*r**20-772463086*r**22-87205587*r**24-4690877*r**26+178634*r**28)
            +4*Q2**5*(59546-358775427*r**2-4691815146*r**4-48627823871*r**6+9417243674*r**8
            -321774491415*r**10+186153319974*r**12-26156277619*r**14-27515035218*r**16
            +68413098087*r**18-18803335390*r**20+6240570195*r**22+1526453662*r**24
            +68993331*r**26-5020254*r**28+144671*r**30)-4*Q2**4*(14055-123987387*r**2
            -2512502097*r**4-29299905283*r**6-11022340033*r**8-280563860435*r**10
            +130366286107*r**12-94342193291*r**14-66248097359*r**16-41624478089*r**18
            +67255758685*r**20-15863348033*r**22+6600838373*r**24+1211253527*r**26
            +59786457*r**28-1700145*r**30+33348*r**32)-4*Q2**3*(9932-51435593*r**2
            -229928200*r**4-2718471876*r**6+25016936492*r**8-41425454748*r**10+137482836488*r**12
            -183789437684*r**14+128707909732*r**16-21318298774*r**18+39329226760*r**20
            -31434246092*r**22+2192275588*r**24-3156475356*r**26-297544968*r**28
            -683644*r**30-655328*r**32+22871*r**34)+(-1+r**2)**2*(1059-9979216*r**2
            -194212169*r**4-3141075176*r**6+9177724228*r**8-100409400536*r**10+317588983300*r**12
            -573439686952*r**14+198451926786*r**16+531499543944*r**18-491046774710*r**20
            +134853876488*r**22-52134029404*r**24-10166593864*r**26-2749333372*r**28
            -88432888*r**30+3823603*r**32-139800*r**34+2679*r**36)+Q2**2*(32891
            -237145886*r**2-3089375709*r**4-42248914672*r**6+129619099836*r**8-861664295784*r**10
            +2039000431852*r**12-2976278171536*r**14+2039821104138*r**16-579306008692*r**18
            -275158678390*r**20+87064230384*r**22-142964053556*r**24-54427327080*r**26
            -14791545444*r**28-327770992*r**30+65708275*r**32-3222174*r**34+78539*r**36)
            -4*Q2*(2392-20029355*r**2-313340812*r**4-4635200885*r**6+18457218844*r**8
            -138383607912*r**10+450336645308*r**12-852060118336*r**14+824894156284*r**16
            -516311297126*r**18+438715830388*r**20-303173619746*r**22+82282137428*r**24
            -30076168528*r**26-8759340780*r**28-2683952168*r**30-80072132*r**32+7257545*r**34
            -282296*r**36+5887*r**38))*sqrtq2+logq2**7*(-112870195200000*r**34*(1+r**2)**2*(1
            -Q2+r**2)*(1-46*r**2+141*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3
            -112870195200000*(Q2-(-1+r)**2)**2*r**34*(1+r**2)**2*(1-46*r**2+141*r**4)*(Q2
            -(1+r)**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**6*(
            -89579520000*r**28*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-35040*Q2**8*(1
            +r**2)+240*Q2**7*(1168+1657*r**2+489*r**4)-8*Q2**6*(118041+200666*r**2
            +92257*r**4+12264*r**6)+Q2**5*(1649508+3082411*r**2+1751049*r**4+283013*r**6
            -35133*r**8)+Q2**4*(-1349040-2689089*r**2-1790644*r**4-406898*r**6+159204*r**8
            +73395*r**10)+Q2**3*(-61320+266836*r**2+486262*r**4+245778*r**6+299306*r**8
            -274726*r**10-486360*r**12)+3*(-1+r**2)**2*(61904+44043*r**2-25404*r**4
            -114143*r**6+35552*r**8+261813*r**10+125964*r**12+174751*r**14)+2*Q2**2*(521220
            +425248*r**2+20047*r**4-84032*r**6-232222*r**8+211532*r**10+631307*r**12
            +724500*r**14)-3*Q2*(256084+9557*r**2-158391*r**4-135977*r**6-160421*r**8
            +1066875*r**10+688567*r**12+188505*r**14+503121*r**16))-89579520000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(35040*Q2**9*(1+r**2)-240*Q2**8*(1314
            +1949*r**2+635*r**4)+8*Q2**7*(153081+285416*r**2+156637*r**4+26934*r**6)
            -7*Q2**6*(370548+804581*r**2+584919*r**4+159883*r**6+8997*r**8)+4*Q2**5*(749637
            +1855252*r**2+1656026*r**4+610240*r**6+22169*r**8-27132*r**10)+5*Q2**4*(
            -257544-860993*r**2-993199*r**4-488664*r**6-109400*r**8+101465*r**10
            +111951*r**12)-4*Q2**3*(275940+161245*r**2-178251*r**4-225026*r**6-252382*r**8
            +99621*r**10+505925*r**12+483840*r**14)+3*(-1+r**2)**2*(61904+105947*r**2
            +18639*r**4-139547*r**6-78591*r**8+297365*r**10+387777*r**12+300715*r**14
            +174751*r**16)+Q2**2*(1810692+1921607*r**2+415417*r**4-535901*r**6-1113771*r**8
            +3159245*r**10+3751379*r**12+3277129*r**14+2958363*r**16)-12*Q2*(79497
            +46469*r**2-50105*r**4-78415*r**6-14491*r**8+245755*r**10+348333*r**12
            +265427*r**14+117022*r**16+169468*r**18))*sqrtq2)+logq2**5*(-497664000*r**24*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(560640*Q2**12*(1+r**2)
            -480*Q2**11*(18685+31938*r**2+13253*r**4)+8*Q2**10*(6901632+16625399*r**2
            +13134574*r**4+3421335*r**6)-120*Q2**9*(1447731+4513058*r**2+5175196*r**4
            +2564174*r**6+454305*r**8)+45*Q2**8*(6420140+25510295*r**2+38180388*r**4
            +26963518*r**6+8923920*r**8+1050635*r**10)-20*Q2**7*(9191619+57030700*r**2
            +107220227*r**4+92573592*r**6+42167617*r**8+9359612*r**10+384441*r**12)
            +60*Q2**6*(-2963163-199556*r**2+2511841*r**4-3632538*r**6-3858201*r**8
            -74264*r**10+533043*r**12+45654*r**14)-12*Q2**5*(-35335599-98135903*r**2
            -229271533*r**4-346314505*r**6-245966445*r**8-68088689*r**10+6565597*r**12
            +11612057*r**14+3080940*r**16)+10*Q2**4*(-26545878-104821259*r**2-290887756*r**4
            -458350074*r**6-358002824*r**8-114511114*r**10+5363652*r**12+10821862*r**14
            +9522278*r**16+5636265*r**18)-60*Q2**3*(719795-3815770*r**2-7220521*r**4
            -8195448*r**6-12251582*r**8-11396056*r**10-5934426*r**12+4494496*r**14
            +5073971*r**16+430090*r**18+1130075*r**20)+60*Q2**2*(2431439+2217986*r**2
            +20545181*r**4+33120654*r**6+11646306*r**8-7884726*r**10-14705946*r**12
            +4880190*r**14+40094943*r**16+31676980*r**18+3906925*r**20+1255348*r**22)
            +9*(-1+r**2)**2*(1468784+3649451*r**2+28653266*r**4+37769151*r**6-10753584*r**8
            -37570182*r**10-12344436*r**12+11149074*r**14+78531264*r**16+87950299*r**18
            +13355938*r**20+1353775*r**22)-180*Q2*(415819+388295*r**2+5088035*r**4
            +4159267*r**6-4057338*r**8-5417886*r**10+2876466*r**12+9981594*r**14
            +4016187*r**16+9602807*r**18+11712811*r**20+1607203*r**22+269300*r**24))
            -497664000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(560640*Q2**12*(1
            +r**2)-480*Q2**11*(18685+31938*r**2+13253*r**4)+8*Q2**10*(6901632+16625399*r**2
            +13134574*r**4+3421335*r**6)-120*Q2**9*(1447731+4513058*r**2+5175196*r**4
            +2564174*r**6+454305*r**8)+45*Q2**8*(6420140+25510295*r**2+38180388*r**4
            +26963518*r**6+8923920*r**8+1050635*r**10)-20*Q2**7*(9191619+57030700*r**2
            +107220227*r**4+92573592*r**6+42167617*r**8+9359612*r**10+384441*r**12)
            +60*Q2**6*(-2963163-199556*r**2+2511841*r**4-3632538*r**6-3858201*r**8
            -74264*r**10+533043*r**12+45654*r**14)-12*Q2**5*(-35335599-98135903*r**2
            -229271533*r**4-346314505*r**6-245966445*r**8-68088689*r**10+6565597*r**12
            +11612057*r**14+3080940*r**16)+10*Q2**4*(-26545878-104821259*r**2-290887756*r**4
            -458350074*r**6-358002824*r**8-114511114*r**10+5363652*r**12+10821862*r**14
            +9522278*r**16+5636265*r**18)-60*Q2**3*(719795-3815770*r**2-7220521*r**4
            -8195448*r**6-12251582*r**8-11396056*r**10-5934426*r**12+4494496*r**14
            +5073971*r**16+430090*r**18+1130075*r**20)+60*Q2**2*(2431439+2217986*r**2
            +20545181*r**4+33120654*r**6+11646306*r**8-7884726*r**10-14705946*r**12
            +4880190*r**14+40094943*r**16+31676980*r**18+3906925*r**20+1255348*r**22)
            +9*(-1+r**2)**2*(1468784+3649451*r**2+28653266*r**4+37769151*r**6-10753584*r**8
            -37570182*r**10-12344436*r**12+11149074*r**14+78531264*r**16+87950299*r**18
            +13355938*r**20+1353775*r**22)-180*Q2*(415819+388295*r**2+5088035*r**4
            +4159267*r**6-4057338*r**8-5417886*r**10+2876466*r**12+9981594*r**14
            +4016187*r**16+9602807*r**18+11712811*r**20+1607203*r**22+269300*r**24))*sqrtq2)
            +logq2**4*(8294400*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(747520*Q2**16
            -5120*Q2**15*(5583+4904*r**2)+64*Q2**14*(4031331+6619068*r**2+2662937*r**4)
            -8*Q2**13*(137139632+335758223*r**2+264964750*r**4+66403279*r**6)+16*Q2**12*(157200069
            +551093888*r**2+670314190*r**4+339254884*r**6+59415633*r**8)-Q2**11*(2774700216
            +15897397897*r**2+27585462868*r**4+21820143106*r**6+8355950996*r**8+1199832597*r**10)
            +Q2**10*(-345203136+12468241841*r**2+29058257029*r**4+29763751814*r**6
            +20083081694*r**8+8474800585*r**10+1524487773*r**12)+Q2**9*(5068861032
            +8508953171*r**2+32379875944*r**4+67844082925*r**6+48987417840*r**8+5119324357*r**10
            -6871121024*r**12-2158027461*r**14)+Q2**8*(-5713188288-31496149987*r**2
            -143129389855*r**4-326870190061*r**6-344531504145*r**8-162570831213*r**10
            -21961265137*r**12+7119992125*r**14+2441816289*r**16)+2*Q2**7*(417173896
            +15141104587*r**2+81208997780*r**4+236623161466*r**6+322171060132*r**8
            +212212880486*r**10+62346035412*r**12+296278450*r**14-4214176084*r**16
            -877223453*r**18)+2*Q2**6*(1823867136-1746877323*r**2+994901093*r**4
            -78591902554*r**6-173314707274*r**8-137321487862*r**10-52138044478*r**12
            -7001475082*r**14+5226991766*r**16+2863520741*r**18+302130317*r**20)
            +2*Q2**5*(-1621749624-9944472281*r**2-88715561424*r**4-156650794439*r**6
            -184036126464*r**8-184423491844*r**10-99226491104*r**12-7269470124*r**14
            +19543630376*r**16+7436481421*r**18-162154240*r**20+125687747*r**22)
            +2*Q2**4*(249336392+9244592901*r**2+74842920669*r**4+176222851175*r**6
            +271650945495*r**8+295054349556*r**10+171708280428*r**12+33271162212*r**14
            -8683092060*r**16-16854016505*r**18-11108817033*r**20-879022539*r**22
            -279682691*r**24)+3*Q2**3*(264155448-1188227343*r**2-1404541340*r**4
            -32959755294*r**6-38360963900*r**8-22206170781*r**10-32553972264*r**12
            -31895548260*r**14-10153618512*r**16-2166648825*r**18-4595068092*r**20
            +6086599682*r**22+602572500*r**24+122738981*r**26)+9*(-1+r**2)**2*(-1153184
            -70076879*r**2-735040833*r**4-718022516*r**6-5152969028*r**8-5609881527*r**10
            +2214952303*r**12+7225348776*r**14+8822344232*r**16-5454051429*r**18
            -15439554139*r**20-4255433524*r**22-1074841668*r**24-75281941*r**26+2381357*r**28)
            -3*Q2**2*(177909632+1456961769*r**2+19428113125*r**4+3820368142*r**6
            +63879994854*r**8+102692069951*r**10+10576161747*r**12-49675149180*r**14
            -15720653484*r**16+88651950247*r**18+99196118667*r**20+20860698734*r**22
            +10783164230*r**24+931117617*r**26+15093949*r**28)-9*Q2*(-14484936-338134527*r**2
            -3522310248*r**4+535383879*r**6-17407945936*r**8-12953708075*r**10+18280103904*r**12
            +6488889491*r**14-9056343368*r**16+8304034707*r**18-18252336712*r**20
            -40405306427*r**22-9462363168*r**24-3218547561*r**26-268731696*r**28
            +6680673*r**30))-8294400*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(747520*Q2**17
            -5120*Q2**16*(5729+5050*r**2)+64*Q2**15*(4477971+7458028*r**2+3055257*r**4)
            -40*Q2**14*(33878056+84192283*r**2+67844158*r**4+17541355*r**6)+8*Q2**13*(451539770
            +1575085631*r**2+1941351353*r**4+1009877797*r**6+185234545*r**8)-Q2**12*(5289901320
            +27230101209*r**2+47127992116*r**4+37973248290*r**6+14734679268*r**8
            +2150482725*r**10)+2*Q2**11*(1214748540+15570169977*r**2+36270558897*r**4
            +39584678894*r**6+25129587898*r**8+9015292089*r**10+1362160185*r**12)
            -2*Q2**10*(-2707032084+1807042767*r**2+4573311463*r**4-4511037041*r**6
            +429707834*r**8+11719278961*r**10+8435204691*r**12+1841257617*r**14)
            +10*Q2**9*(-1078204932-4507396419*r**2-18401821897*r**4-42709414893*r**6
            -46136300491*r**8-21667757341*r**10-2020946847*r**12+1614914061*r**14
            +459984375*r**16)+Q2**8*(6547536080+67491547449*r**2+337043535402*r**4
            +943245902848*r**6+1315743814470*r**8+931528096330*r**10+309224167174*r**12
            +15433829912*r**14-17990160582*r**16-4196263195*r**18)+4*Q2**7*(703346620
            -8652577903*r**2-47677600637*r**4-198212030900*r**6-366054464436*r**8
            -335852714240*r**10-163348480188*r**12-34821894472*r**14+4572444700*r**16
            +3977460139*r**18+589676885*r**20)-4*Q2**6*(1722808380+5010731047*r**2
            +43981792597*r**4+39526896489*r**6-33935241682*r**8-63106351646*r**10
            -45116520618*r**12-25935024718*r**14-10659056846*r**16+327015543*r**18
            +1663902649*r**20+88221285*r**22)-4*Q2**5*(-935543008-10405407403*r**2
            -86751477187*r**4-210794603519*r**6-306168933199*r**8-331756983932*r**10
            -227679131688*r**12-69883561720*r**14+10478626156*r**16+21917064151*r**18
            +9191572107*r**20+421278023*r**22+202685219*r**24)+5*Q2**4*(58758712
            -4510508123*r**2-34477730232*r**4-120202161914*r**6-202166097008*r**8
            -240005820489*r**10-206237435352*r**12-101129106012*r**14-15927399168*r**16
            +8914854131*r**18+8428092560*r**20+8447095638*r**22+825025592*r**24+185516465*r**26)
            -6*Q2**3*(221032540+266444937*r**2+8417672221*r**4-15271964246*r**6-3720362170*r**8
            +21062467635*r**10-22091990649*r**12-57062334852*r**14-28884910128*r**16
            +38165841455*r**18+46217200875*r**20+11176115162*r**22+8736168206*r**24
            +828214549*r**26+68916465*r**28)+6*Q2**2*(110682220+1324637491*r**2+15726002819*r**4
            +10821164815*r**6+59962100402*r**8+102716594515*r**10+29213959993*r**12
            -29282827953*r**14-19113386280*r**16+24009596321*r**18+121302539525*r**20
            +120636368341*r**22+30015476234*r**24+10684962265*r**26+876203327*r**28
            -2474035*r**30)-9*(-1+r**2)**2*(-1153184-71230063*r**2-805117712*r**4
            -1453063349*r**6-5870991544*r**8-10762850555*r**10-3394929224*r**12+9440301079*r**14
            +16047693008*r**16+3368292803*r**18-20893605568*r**20-19694987663*r**22
            -5330275192*r**24-1150123609*r**26-72900584*r**28+2381357*r**30)+18*Q2*(
            -7819060-210194987*r**2-2228242517*r**4-1152472049*r**6-10662263443*r**8
            -13191809999*r**10+6804071079*r**12+10977278019*r**14-2990427447*r**16
            -8312849889*r**18-2828704527*r**20-18744009907*r**22-28935599177*r**24
            -7430971429*r**26-2204587843*r**28-171047839*r**30+4531015*r**32))*sqrtq2)
            +logq2**3*(-138240*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(
            -28395520*Q2**19+512*Q2**18*(751388+587055*r**2)-64*Q2**17*(35156757+58684222*r**2
            +23098985*r**4)+16*Q2**16*(446487688+1258562345*r**2+1059955578*r**4
            +274516345*r**6)-16*Q2**15*(760674811+3608237472*r**2+4900557622*r**4
            +2747526856*r**6+541633335*r**8)+Q2**14*(6239455320+84805895885*r**2
            +161417973236*r**4+144717618250*r**6+68081276980*r**8+12321033065*r**10)
            -2*Q2**13*(-8266311396+9541729635*r**2+6617334507*r**4-2408892718*r**6
            +33569387950*r**8+32414559819*r**10+7285584075*r**12)+Q2**12*(-34960714896
            -155100780201*r**2-673318012274*r**4-1343190897859*r**6-1009406719084*r**8
            -206425417791*r**10+49994433774*r**12+16073810475*r**14)+4*Q2**11*(4562992584
            +66822535455*r**2+361334630533*r**4+1022316179855*r**6+1217560353325*r**8
            +634642303173*r**10+110925664695*r**12-12713294451*r**14-3405936945*r**16)
            +Q2**10*(21722876488-129864464019*r**2-980229682208*r**4-5321612434704*r**6
            -9269098607400*r**8-7536463947934*r**10-3152415188048*r**12-537893270184*r**14
            +31388881488*r**16+3603038185*r**18)+2*Q2**9*(-17717093540-76324416585*r**2
            -501991572661*r**4+450519721480*r**6+1782212565160*r**8+1805262671830*r**10
            +1661711856070*r**12+1125491656864*r**14+343665557700*r**16+17189557195*r**18
            +3307570215*r**20)+Q2**8*(9431096448+267303410335*r**2+2450699894178*r**4
            +7341926507423*r**6+17810511635160*r**8+27819405067942*r**10+20060431944700*r**12
            +4412722839598*r**14-1545509246472*r**16-873273524325*r**18-81358242542*r**20
            -6414021805*r**22)-8*Q2**7*(-1968265642+14725378003*r**2+187856291929*r**4
            +1315435626869*r**6+4005141503029*r**8+7768853176242*r**10+7751258911782*r**12
            +3522508913094*r**14+344373327044*r**16-284427782421*r**18-102131272847*r**20
            -8463922347*r**22+42280385*r**24)+Q2**6*(-13076108696-73230087825*r**2
            -610817534908*r**4+4051192461090*r**6+10652017145540*r**8+37139800340949*r**10
            +53649679224040*r**12+32078216131724*r**14+7050754590960*r**16-2281087965735*r**18
            -2102797969708*r**20-441622993070*r**22-32616068636*r**24+2930683875*r**26)
            +2*Q2**5*(-127543524+55174154747*r**2+716391959611*r**4+2271814010798*r**6
            +12242171323250*r**8+13276989037381*r**10+6603013169757*r**12+5559332092932*r**14
            +2113552564776*r**16-1701934309275*r**18-986220873227*r**20+85682306126*r**22
            -3418074038*r**24+1306698331*r**26-426037645*r**28)-Q2**4*(-4253087280
            +39420905715*r**2+705967514414*r**4+5985130560485*r**6+26738040021500*r**8
            +40812729529155*r**10+39945733166610*r**12+34429770757197*r**14+16770747945240*r**16
            +1065188047905*r**18-5104584091950*r**20-3596629274825*r**22-473308664036*r**24
            -205423013975*r**26-17331674130*r**28+590157975*r**30)+12*Q2**3*(-115155408
            -1091920675*r**2-8558311097*r**4+151767589593*r**6+236465984995*r**8
            +1119724108193*r**10+703919213315*r**12+246497167229*r**14+851626202079*r**16
            +712185177255*r**18+404125599013*r**20+328463898875*r**22-124570119207*r**24
            -8590536997*r**26-12203166575*r**28-1261505873*r**30+31135285*r**32)
            +3*Q2**2*(-142674264+5498620061*r**2+86610475832*r**4+327362876012*r**6
            +2991210304272*r**8-1310223551776*r**10+5829617271464*r**12+8135377192076*r**14
            -2617125343824*r**16-2474480756094*r**18+5456944526344*r**20+7239620364964*r**22
            +1740942668752*r**24+1672062702312*r**26+241202626072*r**28+21606084196*r**30
            +566568136*r**32-13154535*r**34)+9*(-1+r**2)**2*(-6222496+65283461*r**2
            +2021027800*r**4+23210135420*r**6+123228056880*r**8-22688248672*r**10
            +524747765992*r**12+693064908860*r**14-471902729440*r**16-1548978088910*r**18
            -188237793368*r**20+1405794943508*r**22+431846684080*r**24+209276132520*r**26
            +37050384280*r**28+896618036*r**30-112106336*r**32+48385*r**34)-18*Q2*(
            -18636964+313252855*r**2+6166738179*r**4+46666636260*r**6+268712167980*r**8
            -322185159528*r**10+1004687768000*r**12+622273196148*r**14-837928593740*r**16
            -274642538610*r**18-933186201202*r**20+243532983660*r**22+1829953097892*r**24
            +444334996800*r**26+285317993880*r**28+52888528444*r**30+1832259360*r**32
            -165381469*r**34+492055*r**36))+138240*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(28395520*Q2**19-512*Q2**18*(751388+587055*r**2)+64*Q2**17*(35156757
            +58684222*r**2+23098985*r**4)-16*Q2**16*(446487688+1258562345*r**2+1059955578*r**4
            +274516345*r**6)+16*Q2**15*(760674811+3608237472*r**2+4900557622*r**4
            +2747526856*r**6+541633335*r**8)-Q2**14*(6239455320+84805895885*r**2
            +161417973236*r**4+144717618250*r**6+68081276980*r**8+12321033065*r**10)
            +2*Q2**13*(-8266311396+9541729635*r**2+6617334507*r**4-2408892718*r**6
            +33569387950*r**8+32414559819*r**10+7285584075*r**12)+Q2**12*(34960714896
            +155100780201*r**2+673318012274*r**4+1343190897859*r**6+1009406719084*r**8
            +206425417791*r**10-49994433774*r**12-16073810475*r**14)+4*Q2**11*(-4562992584
            -66822535455*r**2-361334630533*r**4-1022316179855*r**6-1217560353325*r**8
            -634642303173*r**10-110925664695*r**12+12713294451*r**14+3405936945*r**16)
            +Q2**10*(-21722876488+129864464019*r**2+980229682208*r**4+5321612434704*r**6
            +9269098607400*r**8+7536463947934*r**10+3152415188048*r**12+537893270184*r**14
            -31388881488*r**16-3603038185*r**18)-2*Q2**9*(-17717093540-76324416585*r**2
            -501991572661*r**4+450519721480*r**6+1782212565160*r**8+1805262671830*r**10
            +1661711856070*r**12+1125491656864*r**14+343665557700*r**16+17189557195*r**18
            +3307570215*r**20)+Q2**8*(-9431096448-267303410335*r**2-2450699894178*r**4
            -7341926507423*r**6-17810511635160*r**8-27819405067942*r**10-20060431944700*r**12
            -4412722839598*r**14+1545509246472*r**16+873273524325*r**18+81358242542*r**20
            +6414021805*r**22)+8*Q2**7*(-1968265642+14725378003*r**2+187856291929*r**4
            +1315435626869*r**6+4005141503029*r**8+7768853176242*r**10+7751258911782*r**12
            +3522508913094*r**14+344373327044*r**16-284427782421*r**18-102131272847*r**20
            -8463922347*r**22+42280385*r**24)+Q2**6*(13076108696+73230087825*r**2
            +610817534908*r**4-4051192461090*r**6-10652017145540*r**8-37139800340949*r**10
            -53649679224040*r**12-32078216131724*r**14-7050754590960*r**16+2281087965735*r**18
            +2102797969708*r**20+441622993070*r**22+32616068636*r**24-2930683875*r**26)
            +2*Q2**5*(127543524-55174154747*r**2-716391959611*r**4-2271814010798*r**6
            -12242171323250*r**8-13276989037381*r**10-6603013169757*r**12-5559332092932*r**14
            -2113552564776*r**16+1701934309275*r**18+986220873227*r**20-85682306126*r**22
            +3418074038*r**24-1306698331*r**26+426037645*r**28)+Q2**4*(-4253087280
            +39420905715*r**2+705967514414*r**4+5985130560485*r**6+26738040021500*r**8
            +40812729529155*r**10+39945733166610*r**12+34429770757197*r**14+16770747945240*r**16
            +1065188047905*r**18-5104584091950*r**20-3596629274825*r**22-473308664036*r**24
            -205423013975*r**26-17331674130*r**28+590157975*r**30)-12*Q2**3*(-115155408
            -1091920675*r**2-8558311097*r**4+151767589593*r**6+236465984995*r**8
            +1119724108193*r**10+703919213315*r**12+246497167229*r**14+851626202079*r**16
            +712185177255*r**18+404125599013*r**20+328463898875*r**22-124570119207*r**24
            -8590536997*r**26-12203166575*r**28-1261505873*r**30+31135285*r**32)
            -9*(-1+r**2)**2*(-6222496+65283461*r**2+2021027800*r**4+23210135420*r**6
            +123228056880*r**8-22688248672*r**10+524747765992*r**12+693064908860*r**14
            -471902729440*r**16-1548978088910*r**18-188237793368*r**20+1405794943508*r**22
            +431846684080*r**24+209276132520*r**26+37050384280*r**28+896618036*r**30
            -112106336*r**32+48385*r**34)+3*Q2**2*(142674264-5498620061*r**2-86610475832*r**4
            -327362876012*r**6-2991210304272*r**8+1310223551776*r**10-5829617271464*r**12
            -8135377192076*r**14+2617125343824*r**16+2474480756094*r**18-5456944526344*r**20
            -7239620364964*r**22-1740942668752*r**24-1672062702312*r**26-241202626072*r**28
            -21606084196*r**30-566568136*r**32+13154535*r**34)+18*Q2*(-18636964
            +313252855*r**2+6166738179*r**4+46666636260*r**6+268712167980*r**8-322185159528*r**10
            +1004687768000*r**12+622273196148*r**14-837928593740*r**16-274642538610*r**18
            -933186201202*r**20+243532983660*r**22+1829953097892*r**24+444334996800*r**26
            +285317993880*r**28+52888528444*r**30+1832259360*r**32-165381469*r**34
            +492055*r**36))*sqrtq2)+logq2**2*(-2304*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(-99006464*Q2**22+512*Q2**21*(2377994+2269969*r**2)-32*Q2**20*(195544677
            +404422186*r**2+182932677*r**4)+160*Q2**19*(103246396+374150109*r**2
            +358497926*r**4+104093269*r**6)-40*Q2**18*(482949119+3494450853*r**2
            +5323947597*r**4+3465373359*r**6+757376776*r**8)+Q2**17*(-9954055524
            +127922601095*r**2+241661601060*r**4+284554595070*r**6+199858313120*r**8
            +40069608411*r**10)+Q2**16*(61577525488+161363453803*r**2+783325650615*r**4
            +1209107219970*r**6+320111942170*r**8-176731323117*r**10-45501103937*r**12)
            +2*Q2**15*(-31928136832-302926219261*r**2-1708883672037*r**4-4156503403885*r**6
            -3544580033690*r**8-964780272627*r**10+44850608959*r**12+21754611613*r**14)
            -10*Q2**14*(2234323968-62447569893*r**2-493094186682*r**4-1981365455172*r**6
            -2686549622161*r**8-1579231834017*r**10-358110005256*r**12-1552658742*r**14
            +1917889107*r**16)-10*Q2**13*(-10066838168-12785738441*r**2+23674847291*r**4
            +1786826554608*r**6+3698229204221*r**8+3461586646148*r**10+1791979887909*r**12
            +410901193468*r**14+16095892667*r**16+1894703833*r**18)+2*Q2**12*(-28580865872
            -489031311205*r**2-4548952635690*r**4-7888545095835*r**6-13194354104245*r**8
            -15524162557413*r**10-1374577735145*r**12+5747815221135*r**14+2156282952585*r**16
            +170105245270*r**18+13371486863*r**20)+2*Q2**11*(-23978094816+428806192399*r**2
            +5671007355315*r**4+28782304140165*r**6+81801430597400*r**8+148420044947046*r**10
            +117219404662086*r**12+30713678476130*r**14-4122820056480*r**16-2361344931765*r**18
            -200774047121*r**20+1701963609*r**22)-2*Q2**10*(-34665591688-82090059189*r**2
            +314725775722*r**4+26301658847150*r**6+103419759743935*r**8+297786978842278*r**10
            +365550238514044*r**12+203251208034148*r**14+43592553455710*r**16-3599797690345*r**18
            -1454265034638*r**20-99213328154*r**22+10611036947*r**24)+10*Q2**9*(-563594572
            -82668441468*r**2-1031673453687*r**4-653919364956*r**6+225175543913*r**8
            +39655114261782*r**10+76756252902762*r**12+64211829778512*r**14+32227718028630*r**16
            +8715728861968*r**18+347581409133*r**20+118381117356*r**22+11487579693*r**24
            +665765302*r**26)+10*Q2**8*(-3297009408+45446192854*r**2+808414263921*r**4
            +5716837885149*r**6+28107855053549*r**8+46633791457845*r**10+66195106558776*r**12
            +75427618584618*r**14+28041634682610*r**16-11801359694352*r**18-9799199500111*r**20
            -1580452950471*r**22-285460732575*r**24-19475111483*r**26+645125478*r**28)
            -2*Q2**7*(-7343574208-103615057705*r**2-591794884665*r**4+24183126846435*r**6
            +146824394668290*r**8+568904787611743*r**10+1181200268826925*r**12+1698364511815715*r**14
            +1228270396357900*r**16+296517262192525*r**18-81995588242527*r**20-56848504779935*r**22
            -8845218765390*r**24-542176833475*r**26-11037120405*r**28+1265709977*r**30)
            +2*Q2**6*(3542640544-162513780821*r**2-2271063095490*r**4+1173288271840*r**6
            +10074624732895*r**8+359033808308121*r**10+700033587364816*r**12+1500090421708210*r**14
            +1539434142521205*r**16+603959319690605*r**18-24583383814714*r**20-122567666632164*r**22
            -40995274478695*r**24-6072813741745*r**26+102163353900*r**28+46224865874*r**30
            -994282381*r**32)+6*Q2**5*(-1061056184+10317950353*r**2+280933324961*r**4
            +4338241343860*r**6+30752026252355*r**8+45162326587834*r**10+247091323519257*r**12
            +120128310491864*r**14-56273419336285*r**16-4668699677440*r**18-19234040477461*r**20
            -16992953655308*r**22+5991913467089*r**24+853664241550*r**26+505737919835*r**28
            -7558784064*r**30-6848636927*r**32+103324711*r**34)+10*Q2**4*(-11971296
            +8046307081*r**2+61437250814*r**4-1895140820145*r**6-13542918249099*r**8
            -62933234415369*r**10-211488590623743*r**12-197402686569229*r**14-106123434397439*r**16
            -113609980549947*r**18-53743070662999*r**20+35341450478893*r**22+31032337679391*r**24
            +4538494298733*r**26+2823163163571*r**28+423136991889*r**30+5236179019*r**32
            -1869176626*r**34+53646501*r**36)-30*Q2**3*(-41015072+1396451461*r**2
            +18578277289*r**4-46831190965*r**6-219157339292*r**8-8926004930436*r**10
            -9218361711256*r**12-22725933362260*r**14-1152182622172*r**16-12154595094594*r**18
            -26352262501022*r**20-13594928322166*r**22-11116590289652*r**24+1913459862524*r**26
            -1156861707936*r**28+394111285180*r**30+134957252236*r**32+5837480773*r**34
            -506539987*r**36+4337347*r**38)+6*Q2**2*(-35865364-696163495*r**2+11083203290*r**4
            +814610466370*r**6+5898291328825*r**8+9618247909096*r**10+123003185106940*r**12
            -120814251024140*r**14+163285180038520*r**16+143284515755730*r**18-59543453059824*r**20
            +108705843111480*r**22+139383301818410*r**24+10048243073600*r**26+62473752439940*r**28
            +10986190246316*r**30+1527758965700*r**32+153455035565*r**34+3915631510*r**36
            -34201370*r**38-12617099*r**40)+9*(-1+r**2)**2*(2800784-155887615*r**2
            -1266614815*r**4+46382717725*r**6+384579507445*r**8+2613165665524*r**10
            +9675538686820*r**12-17516872543580*r**14+52611266516500*r**16+50373954000990*r**18
            -111548324306226*r**20-66138646606170*r**22+87302934744230*r**24+15517259545700*r**26
            +14968235003060*r**28+5121748636244*r**30+494016976340*r**32-7528913335*r**34
            -2356351175*r**36+30536005*r**38+685549*r**40)+9*Q2*(-9884708+818867657*r**2
            +3994911290*r**4-289696819470*r**6-1905721020890*r**8-8513321150963*r**10
            -42134554270088*r**12+104438753793880*r**14-185578015781840*r**16-94683222907630*r**18
            +155327968407612*r**20+167772901565772*r**22+13361259749620*r**24-201793705506910*r**26
            -26015905541320*r**28-41017742081128*r**30-13185287522908*r**32-1383411157915*r**34
            +12301226970*r**36+6915451090*r**38-180468938*r**40+940817*r**42))-2304*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(99006464*Q2**23-512*Q2**22*(2571366
            +2463341*r**2)+32*Q2**21*(233592581+478789594*r**2+219252181*r**4)-32*Q2**20*(711776657
            +2470717408*r**2+2379844493*r**4+703399022*r**6)+40*Q2**19*(895934703
            +5404036873*r**2+8254539737*r**4+5315738139*r**6+1173749852*r**8)-Q2**18*(9363909236
            +287018599975*r**2+594397539060*r**4+636127433310*r**6+368768318520*r**8
            +70364679451*r**10)+4*Q2**17*(-17882895253-10848727058*r**2-103435362115*r**4
            -170722755960*r**6+41075241505*r**8+104164811162*r**10+21392678087*r**12)
            +Q2**16*(125433799152+828793417813*r**2+4362456448492*r**4+10305439678355*r**6
            +8618379229520*r**8+2072941164307*r**10-311933644972*r**12-89010327163*r**14)
            +4*Q2**15*(-10378258496-323546102779*r**2-2238640412354*r**4-7886107175891*r**6
            -10566915774190*r**8-6202759738201*r**10-1355239844974*r**12+29420963431*r**14
            +15672028574*r**16)-20*Q2**14*(6150581068-23713753742*r**2-289608301933*r**4
            -2130643098231*r**6-4183072140777*r**8-3863684051163*r**10-1864660863591*r**12
            -385281928733*r**14-7865331151*r**16+11592637*r**18)-4*Q2**13*(-39457528356
            -301647097125*r**2-2247253545720*r**4+581980956830*r**6+7115462344950*r**8
            +10137458347216*r**10+12446627467570*r**12+8381110314010*r**14+2145634191630*r**16
            +130029113885*r**18+11422503014*r**20)+4*Q2**12*(-2301385528-473209184738*r**2
            -5354495651105*r**4-20609900935845*r**6-51442164898740*r**8-88569280804352*r**10
            -67059072477322*r**12-13170220495070*r**14+6013459115100*r**16+2343866564810*r**18
            +192125389627*r**20+5834761627*r**22)+4*Q2**11*(-29321843252+161369019197*r**2
            +3207269661718*r**4+30377485171315*r**6+107001747240750*r**8+264004227193362*r**10
            +315594844061588*r**12+175592145586182*r**14+35091705937680*r**16-5041981339295*r**18
            -2008192006762*r**20-149142705833*r**22+6156500278*r**24)-2*Q2**10*(-37483564548
            -530097858217*r**2-4925731551902*r**4+23346787798092*r**6+130847296310650*r**8
            +599482309895123*r**10+1047118481870132*r**12+889860595440752*r**14+407982351633008*r**16
            +83571400075205*r**18-3316155679318*r**20-961572776012*r**22-31164392742*r**24
            +13939863457*r**26)+20*Q2**9*(1366707418-64339114447*r**2-961378079538*r**4
            -3701215351896*r**6-14268299437296*r**8-3376750826075*r**10+25108130302884*r**12
            +32770232048328*r**14+34198956562266*r**16+26372403292475*r**18+9431254885606*r**20
            +1023207738480*r**22+207664714812*r**24+15814228239*r**26+10319912*r**28)
            +2*Q2**8*(-23828621248+107130859525*r**2+3677507399210*r**4+56809387591785*r**6
            +315947859361780*r**8+942613020168713*r**10+1745344758910030*r**12+2406478137532685*r**14
            +1745616662694040*r**16+377718637133815*r**18-189998384214842*r**20-113746767032845*r**22
            -18174787180620*r**24-2066856053765*r**26-105187050430*r**28+4491337367*r**30)
            -4*Q2**7*(-1900466832-136736206367*r**2-1483236518930*r**4+12382310116805*r**6
            +90541073123810*r**8+537381495294077*r**10+1225069321901742*r**12+2189827601175425*r**14
            +2233034525347410*r**16+1064373489120515*r**18+94969145067642*r**20-130705879827313*r**22
            -53344499012010*r**24-7730104670305*r**26-225525299990*r**28+18226727723*r**30
            +135713798*r**32)-4*Q2**6*(-3362904548+94962495668*r**2+1638188425597*r**4
            +7056249427615*r**6+40504082876165*r**8-116810726638757*r**10-158896712557583*r**12
            -919869538798717*r**14-1604172411119135*r**16-1078699780622065*r**18-318539028654137*r**20
            +48086094740477*r**22+90769340756063*r**24+24814540472545*r**26+3743932073675*r**28
            -85532285983*r**30-32888247137*r**32+652128257*r**34)+4*Q2**5*(-1561656036
            -6230426449*r**2+283283785936*r**4+11666614053594*r**6+86492697017070*r**8
            +271204615298706*r**10+967101951719994*r**12+1044336167439754*r**14+361090922726966*r**16
            +192611772854280*r**18+98503566425146*r**20-142694117396386*r**22-94082404480806*r**24
            -1077869183874*r**26-5018804666850*r**28-310573776066*r**30-34701579034*r**32
            -5445026759*r**34+20870814*r**36)+20*Q2**4*(-67508256+6111845084*r**2
            +62609194881*r**4-987098571113*r**6-8047765543560*r**8-51627083727888*r**10
            -151038455086440*r**12-238534538639876*r**14-153491334416592*r**16-128098600115584*r**18
            -123204919358006*r**20-29593202575302*r**22+16512008644664*r**24+20655605782848*r**26
            +1945536169248*r**28+2214317005500*r**30+416622463808*r**32+10439722356*r**34
            -1667575043*r**36+33329271*r**38)-12*Q2**3*(-120470362+3040509225*r**2
            +55478423520*r**4+336672948995*r**6+2284174338770*r**8-18053781719772*r**10
            +16140675949240*r**12-140267863195860*r**14+21947300058180*r**16+38375313585950*r**18
            -126038870518952*r**20-45515055502230*r**22+7912854379660*r**24-17983704531020*r**26
            +33128371606440*r**28+3586219066268*r**30+2086550826390*r**32+428714350305*r**34
            +15285167720*r**36-1272607285*r**38+4534818*r**40)+9*(-1+r**2)**2*(2800784
            -153086831*r**2-1422502430*r**4+45116102910*r**6+430962225170*r**8+2997745172969*r**10
            +12288704352344*r**12-7841333856760*r**14+35094393972920*r**16+102985220517490*r**18
            -61174370305236*r**20-177686970912396*r**22+21164288138060*r**24+102820194289930*r**26
            +30485494548760*r**28+20089983639304*r**30+5615765612584*r**32+486488063005*r**34
            -9885264510*r**36-2325815170*r**38+31221554*r**40+685549*r**42)-3*Q2**2*(42076604
            +3920660689*r**2-8789345720*r**4-2520477797730*r**6-19142966653060*r**8
            -56573041928731*r**10-391646528842336*r**12+308938393216040*r**14-641675905374280*r**16
            -897189060311390*r**18+298501779831024*r**20+404993924594004*r**22-456094510610920*r**24
            -904244206304750*r**26-223091707651040*r**28-269973111615896*r**30-64583760992756*r**32
            -7512661476275*r**34-277837653240*r**36+12983492990*r**38-447769876*r**40
            +28056649*r**42)+36*Q2*(-3171373+242618033*r**2+1441454437*r**4-83615491980*r**6
            -621491324385*r**8-3077357885053*r**10-13870415571067*r**12+24139745943872*r**14
            -44614953069610*r**16-51973946778470*r**18+55082427822922*r**20+28942228491528*r**22
            +18275564416262*r**24+9198702697910*r**26-74761565426030*r**28-14434046449568*r**30
            -14855446077737*r**32-4673721112763*r**34-469457095695*r**36+5500588260*r**38
            +2287929947*r**40-52173257*r**42+63817*r**44))*sqrtq2)+logq2*(-192*r**8*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(-571136*Q2**21+32*Q2**20*(223537+358027*r**2)
            -8*Q2**19*(4600460+16846557*r**2+10438225*r**4)+24*Q2**18*(3972905+25248381*r**2
            +33054383*r**4+13606263*r**6)-Q2**17*(102659580+1126117871*r**2+1580693717*r**4
            +2161202993*r**6+787574351*r**8)+Q2**16*(-86170696-319502661*r**2-7934889348*r**4
            -6060055482*r**6+2769088556*r**8+1237832095*r**10)+Q2**15*(393298344
            +5299334328*r**2+47053574098*r**4+86706972382*r**6+40055203902*r**8-605175830*r**10
            -1274486328*r**12)+Q2**14*(-372575160-8740766732*r**2-91940545990*r**4
            -291974231348*r**6-276758977700*r**8-93360843916*r**10-3209146462*r**12
            +819116620*r**14)+2*Q2**13*(-94098980+798561534*r**2+19008463027*r**4
            +199503988243*r**6+295926687536*r**8+212727049064*r**10+65550767231*r**12
            +3191336327*r**14-145220158*r**16)+2*Q2**12*(333678020+6183421944*r**2
            +75558219433*r**4+30063190318*r**6+72341996787*r**8-12158962996*r**10
            -169998895553*r**12-76435032210*r**14-4919398943*r**16+44251424*r**18)
            -2*Q2**11*(184438748+7269076596*r**2+132756840483*r**4+503542234921*r**6
            +1535515566743*r**8+2259596978425*r**10+988358985797*r**12-56699640229*r**14
            -82130626335*r**16-6135449521*r**18+85275012*r**20)+2*Q2**10*(-159765268
            -253598334*r**2+44190354793*r**4+695770937358*r**6+2810116424112*r**8
            +6722141637100*r**10+5788344505202*r**12+1941852941596*r**14+37228479468*r**16
            -53226914206*r**18-4101466467*r**20+134370310*r**22)-2*Q2**9*(-241687680
            -6394278291*r**2-99480074190*r**4+194550937002*r**6+923496229605*r**8
            +6898409753554*r**10+8858553370036*r**12+5574619689780*r**14+1937075160922*r**16
            +123120953265*r**18+8832819114*r**20-102557646*r**22+122650545*r**24)
            +2*Q2**8*(-40501620-3914668409*r**2-116974868567*r**4-594190282004*r**6
            -3751752917987*r**8-3150331137523*r**10-4060154051430*r**12-3104401399688*r**14
            +1595402533190*r**16+1770206325713*r**18+244300074877*r**20+40735066972*r**22
            +1088887633*r**24+67381723*r**26)+Q2**7*(-207944840-2885943288*r**2+29813319894*r**4
            +1611949045482*r**6+10716130915330*r**8+27201332120134*r**10+48113503667316*r**12
            +56688278689988*r**14+21991919183580*r**16-3521392284364*r**18-4260079624546*r**20
            -669799270830*r**22-46792469334*r**24+865676926*r**26-26497768*r**28)
            -2*Q2**6*(-64276812-2488617246*r**2-53163139063*r**4+242774787710*r**6
            +1054022046858*r**8+10236117791790*r**10+15117030015019*r**12+32042183649762*r**14
            +20080392451808*r**16+2505616884046*r**18-3434952643617*r**20-1459366011438*r**22
            -231172313374*r**24-3006013278*r**26+896689901*r**28+12003534*r**30)
            +2*Q2**5*(10895652-510220802*r**2-35233209883*r**4-351517433939*r**6
            -3348295692872*r**8-831463049780*r**10-19166399316745*r**12+4482837731287*r**14
            +6719710714158*r**16-18603356642*r**18+2659666227187*r**20-869637871877*r**22
            +175103902716*r**24+11643377176*r**26+1780092209*r**28-7552639*r**30
            +11622394*r**32)-2*Q2**4*(22508260+540880572*r**2-181558955*r**4-369702581426*r**6
            -2799099869605*r**8-5170868382812*r**10-28940754935867*r**12-3507198130190*r**14
            +381412777147*r**16-14977546003480*r**18+1917002418039*r**20+5240093783858*r**22
            -152354991895*r**24+574233637204*r**26+116024033135*r**28+3247549838*r**30
            -375758563*r**32+3696740*r**34)-2*Q2**3*(-4815740-283961928*r**2-8169980819*r**4
            +68534342395*r**6+147614708649*r**8+2990537377791*r**10+4721863369001*r**12
            -835514178201*r**14-2560370385979*r**16+12200552148427*r**18+912818668623*r**20
            +4675037757377*r**22-1709245623061*r**24+855420627213*r**26-148533889101*r**28
            -54066161699*r**30-2559637725*r**32+105421681*r**34+661096*r**36)+3*(
            -1+r**2)**2*(147568+5425621*r**2+36251368*r**4-6306935375*r**6-45291944312*r**8
            -52630566244*r**10-1420772966888*r**12+4822477681756*r**14-10116551692760*r**16
            +2082806643726*r**18+13364846735784*r**20-10067991215962*r**22+1443950903384*r**24
            -1030794566980*r**26-379638409016*r**28-56097379108*r**30-1374827896*r**32
            +196562117*r**34-2043760*r**36+36977*r**38)+2*Q2**2*(2720440+17562698*r**2
            -3168196209*r**4-82175050250*r**6-764587408564*r**8+937497006504*r**10
            -13318353265480*r**12+20903207276416*r**14-18426001082436*r**16-2150098270724*r**18
            -1858833650578*r**20-6068286081684*r**22+1428415719620*r**24-4384830696728*r**26
            -980122628160*r**28-204726637616*r**30-5980145284*r**32+316160298*r**34
            -50553461*r**36+1061198*r**38)-3*Q2*(1013932+26986213*r**2-188480771*r**4
            -34941233623*r**6-237371999107*r**8+177593713580*r**10-6395171141044*r**12
            +20498323864028*r**14-32995295458156*r**16+5412109103646*r**18+22992132029358*r**20
            -392843119626*r**22-13199723848418*r**24+2053981306156*r**26-2554420140596*r**28
            -1002523125284*r**30-172001060168*r**32-2900261339*r**34+701485373*r**36
            -18537943*r**38+263789*r**40))+192*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(4569088*Q2**25-1536*Q2**24*(39859+62274*r**2)+32*Q2**23*(10640743
            +37799758*r**2+23257703*r**4)-8*Q2**22*(121079728+750209739*r**2+983259782*r**4
            +389378955*r**6)+8*Q2**21*(151419097+1653251994*r**2+2790107984*r**4
            +3085605766*r**6+996156151*r**8)+Q2**20*(727148036-2538533237*r**2+46626986852*r**4
            +23666634662*r**6-39785759432*r**8-12913678225*r**10)+4*Q2**19*(-1160959201
            -13181168481*r**2-109691448690*r**4-202404748310*r**6-87423797425*r**8
            +6157474359*r**10+3154640324*r**12)+2*Q2**18*(2576212198+54943888803*r**2
            +530318905348*r**4+1684011125565*r**6+1611108271190*r**8+507381879213*r**10
            +10626172608*r**12-2713220237*r**14)-4*Q2**17*(-554284199+10770026978*r**2
            +187115645694*r**4+1491317245340*r**6+2332486575610*r**8+1566482063586*r**10
            +402460674318*r**12+15883042144*r**14+553709665*r**16)+Q2**16*(-10185643104
            -155092311033*r**2-1527561905768*r**4+1714580438188*r**6+5546014736608*r**8
            +7287020503966*r**10+6490524302472*r**12+1845332240692*r**14+100692911968*r**16
            +3102674043*r**18)+16*Q2**15*(390184811+14603045613*r**2+231093880347*r**4
            +815324652852*r**6+2175771043383*r**8+3216700161462*r**10+1307463227243*r**12
            -172349710508*r**14-115869771118*r**16-8513392427*r**18+82309190*r**20)
            -8*Q2**14*(-790989182+1935775593*r**2+236696081090*r**4+3148827835835*r**6
            +12080340085480*r**8+28366543438112*r**10+25170911753182*r**12+8164315547100*r**14
            +186889373490*r**16-152698835625*r**18-12071888092*r**20+538785513*r**22)
            +16*Q2**13*(-632708334-14806145394*r**2-183245772029*r**4+806667534960*r**6
            +4674235643820*r**8+22209767334814*r**10+31026387629694*r**12+19228605123344*r**14
            +5184829131400*r**16+247817417120*r**18+24533427051*r**20+1884225076*r**22
            +203472206*r**24)-2*Q2**12*(-449752028-87498413379*r**2-2265071519332*r**4
            -10599586747610*r**6-47018531767640*r**8+28649828233063*r**10+130399833881264*r**12
            +137263128007892*r**14+104525042696540*r**16+36773932084115*r**18+3882483286932*r**20
            +762004118006*r**22+42434424568*r**24+333944665*r**26)-8*Q2**11*(-818173457
            -9420874789*r**2+96367686916*r**4+4925429042854*r**6+29240101798739*r**8
            +78698528869277*r**10+137049164573304*r**12+172444379755164*r**14+73752797780021*r**16
            -8606805781579*r**18-10047697438812*r**20-1708264358354*r**22-108265043399*r**24
            -86275741*r**26+107044144*r**28)+4*Q2**10*(-885650006-37607854863*r**2
            -705033447192*r**4+3751410131183*r**6+29272623995542*r**8+237657888165229*r**10
            +595849724744528*r**12+1167930940763627*r**14+981425003087302*r**16+311745276124843*r**18
            -12072693111208*r**20-17364844250363*r**22-3068875318342*r**24+74897228023*r**26
            +15595453872*r**28+219899425*r**30)-8*Q2**9*(242148163-3358666902*r**2
            -259153028840*r**4-2863814096760*r**6-16106690287660*r**8+46164781306402*r**10
            +147824314472632*r**12+669186183356220*r**14+868774533502150*r**16+510295683344190*r**18
            +147125474065432*r**20+1836537856272*r**22+431269034140*r**24+19782829430*r**26
            +63009355800*r**28+2436531948*r**30+25984903*r**32)-2*Q2**8*(-1139695448
            -29064297883*r**2-195276131928*r**4+13662525759680*r**6+90644682647440*r**8
            +299888350173088*r**10+1115919079618688*r**12+460366088567528*r**14-153417925395240*r**16
            +18071721561490*r**18-553752892970072*r**20-465536513384432*r**22-80835525659232*r**24
            -26723221001080*r**26-4162889399760*r**28-87704509368*r**30+11402761552*r**32
            +135492577*r**34)+16*Q2**7*(-90919-1898924727*r**2-65412472561*r**4+138155919200*r**6
            +2399800256735*r**8+59754543536724*r**10+229744939875807*r**12+566292316559656*r**14
            +867078035931445*r**16+997518970464350*r**18+457060958502969*r**20-18235079188208*r**22
            -72621695042219*r**24-17074660908380*r**26-1963485155595*r**28-208731500184*r**30
            +2200534718*r**32+476334689*r**34+17065700*r**36)-16*Q2**6*(46391069
            +592026513*r**2-17387344092*r**4-794908869318*r**6-3600590826198*r**8
            +24446583098801*r**10+63392140676447*r**12+540476594951177*r**14+764178744642298*r**16
            +1246105959221703*r**18+875236244460121*r**20+145363957510497*r**22-126100373530038*r**24
            -67767895606197*r**26-16171230121007*r**28-663073569941*r**30+144490917493*r**32
            +8016250028*r**34-611458733*r**36+4731377*r**38)-8*Q2**5*(-24939567-1328016866*r**2
            -25136467434*r**4+800088787126*r**6+5120104559999*r**8+41864915072876*r**10
            +238183851910416*r**12-51928343242216*r**14+1150167903194334*r**16-137895534793504*r**18
            -723163825237596*r**20-162300773955764*r**22-58627677112486*r**24+81189288887044*r**26
            +11496716533936*r**28+9033775105992*r**30+1084620595489*r**32-147415247214*r**34
            -12010367354*r**36+511000094*r**38+4452695*r**40)+Q2**4*(119407076-507481809*r**2
            -130787209740*r**4-1787606230410*r**6+7299557924760*r**8+431786985652551*r**10
            +1654396276250816*r**12+4926313953847560*r**14+17025896537780520*r**16
            +4845990013572430*r**18-310189702674744*r**20+7662821933407716*r**22-1102703237662000*r**24
            -2957512199415210*r**26-347462653787040*r**28-324365058780344*r**30-78243470507244*r**32
            -3143187692445*r**34+475512344100*r**36+12089707350*r**38-2253590664*r**40
            +34576771*r**42)-12*Q2**3*(5284227+139572027*r**2-219985118*r**4-178490517510*r**6
            -222920961365*r**8+8196528259127*r**10+8973557790612*r**12+281631022683752*r**14
            +132324743204390*r**16-1675403123610*r**18+12992787768332*r**20+629419302111852*r**22
            +223335539351022*r**24+202851446253750*r**26-38857767163760*r**28+53229175435272*r**30
            +579339915127*r**32-4467586766753*r**34-697210317630*r**36+6912333610*r**38
            +3368964167*r**40-108128493*r**42+596972*r**44)-9*(-1+r**2)**2*(147568
            +3359669*r**2-53578718*r**4-7326528853*r**6+39521711220*r**8+1173806485843*r**10
            +3661831072474*r**12+30288352730117*r**14+56612955633232*r**16-289760180772510*r**18
            +866225952331588*r**20-246505468646786*r**22-1153175609941768*r**24+740120019428822*r**26
            +32636824369860*r**28+71870225779898*r**30+52345073768224*r**32+9576740948057*r**34
            +532204807322*r**36-55297977945*r**38-3935101772*r**40+221698919*r**42
            -2561438*r**44+36977*r**46)-6*Q2**2*(683054-62082033*r**2-3009874724*r**4
            +32553020945*r**6+567590761350*r**8+14530176437269*r**10+60142720396752*r**12
            -31235414104869*r**14+1295405517405180*r**16-1869225075307690*r**18+1038452111711304*r**20
            +1045284429386602*r**22+503548853415836*r**24+513463548556650*r**26-317484329619920*r**28
            +465897060325494*r**30+85967824894422*r**32+14185423304331*r**34+1954476312380*r**36
            +255291396885*r**38+16352492254*r**40-1134245743*r**42-25801824*r**44
            +536095*r**46)+36*Q2*(216591+2320982*r**2-157271618*r**4-7035519252*r**6
            +57987312498*r**8+1581774315606*r**10+3819175394742*r**12+18606423745032*r**14
            +92089422331713*r**16-386210887164372*r**18+703557945542236*r**20-1064891198968*r**22
            -682940620198788*r**24-18816860686052*r**26+375020953184828*r**28-31999350923904*r**30
            +64265002836657*r**32+31206157872702*r**34+6119506874598*r**36+333190503468*r**38
            -40296588654*r**40-1756991538*r**42+178161422*r**44-4926632*r**46+56703*r**48))*sqrtq2))*math.log(mu0)**2)/(168000*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2
            +168000*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2
            +logq2**7*(-1354442342400000*r**32*(1+r**2)**2*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3-1354442342400000*r**32*(1+r**2)**2*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**6*(7524679680000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))+7524679680000*r**28*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))*sqrtq2)+logq2*(-10080000*(-Q2
            +(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(9+8*Q2**4-78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)
            -Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-10080000*(-Q2+(-1+r)**2)**3*r**8*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(9+8*Q2**4-78*r**2-366*r**4
            -78*r**6+9*r**8-Q2**3*(1+r**2)-Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1
            +13*r**2+13*r**4+r**6))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*sqrtq2)+logq2**2*(120960000*(-Q2+(-1+r)**2)**3*r**12*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531
            +550*r**2+531*r**4)-2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815
            -2120*r**2-11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4
            +494*r**6+225*r**8+r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6
            +26793*r**8+4554*r**10-501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6
            -1385*r**8-311*r**10+15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6
            +34670*r**8+13388*r**10-184*r**12-316*r**14+17*r**16))+120960000*(
            -Q2+(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531+550*r**2+531*r**4)
            -2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815-2120*r**2-11502*r**4
            -2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4+494*r**6+225*r**8
            +r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6+26793*r**8+4554*r**10
            -501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6-1385*r**8-311*r**10
            +15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6+34670*r**8+13388*r**10
            -184*r**12-316*r**14+17*r**16))*sqrtq2)+logq2**3*(-1451520000*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8+256*Q2**7*(1+r**2)
            -Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2+893*r**4+319*r**6)
            +Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)+12*Q2**3*(61
            +235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(-1071+9654*r**2
            +51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)-18*Q2*(23
            -35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12+23*r**14)
            +9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10-264*r**12
            -756*r**14+47*r**16))-1451520000*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8
            +256*Q2**7*(1+r**2)-Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2
            +893*r**4+319*r**6)+Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)
            +12*Q2**3*(61+235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(
            -1071+9654*r**2+51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)
            -18*Q2*(23-35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12
            +23*r**14)+9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10
            -264*r**12-756*r**14+47*r**16))*sqrtq2)+logq2**4*(17418240000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513+770*r**2
            +513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105-3400*r**2
            -11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4-1178*r**6
            +75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6+19593*r**8
            +3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6-5785*r**8
            -2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4+25204*r**6
            +52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))+17418240000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513
            +770*r**2+513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105
            -3400*r**2-11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4
            -1178*r**6+75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6
            +19593*r**8+3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6
            -5785*r**8-2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4
            +25204*r**6+52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))*sqrtq2)
            +logq2**5*(-41803776000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(64*Q2**8+1088*Q2**7*(1+r**2)+Q2**6*(-63+130*r**2-63*r**4)
            -2*Q2**5*(2777+6379*r**2+6379*r**4+2777*r**6)+Q2**4*(1555-8080*r**2
            -22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743-315*r**2-6548*r**4-6548*r**6
            -315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2+199629*r**4+305844*r**6
            +199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83-375*r**2-2833*r**4
            -5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)+9*(301-4028*r**2
            +808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12-4028*r**14+301*r**16))
            -41803776000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(64*Q2**8+1088*Q2**7*(1
            +r**2)+Q2**6*(-63+130*r**2-63*r**4)-2*Q2**5*(2777+6379*r**2+6379*r**4
            +2777*r**6)+Q2**4*(1555-8080*r**2-22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743
            -315*r**2-6548*r**4-6548*r**6-315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2
            +199629*r**4+305844*r**6+199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83
            -375*r**2-2833*r**4-5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)
            +9*(301-4028*r**2+808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12
            -4028*r**14+301*r**16))*sqrtq2))+((-4*(Q2-(-1+r)**2)**4*r**4*(Q2-(1
            +r)**2)**4*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(-1059
            +24*Q2**14-322322*r**2-93757*r**4-25369844*r**6+127046277*r**8-457228062*r**10
            +815729139*r**12-694656216*r**14+236289183*r**16-15296334*r**18+10159121*r**20
            +3791308*r**22-43777*r**24-3714*r**26+57*r**28+56*Q2**13*(1+r**2)+Q2**12*(1627
            +3446*r**2-1457*r**4)+4*Q2**11*(-3797-54679*r**2-8387*r**4+1615*r**6)
            +4*Q2**10*(11639+338572*r**2+403567*r**4+30654*r**6-3472*r**8)+4*Q2**9*(
            -15387-727340*r**2-2055110*r**4-1044380*r**6-54495*r**8+4008*r**10)
            +Q2**8*(15423+1013978*r**2+12323485*r**4+13564420*r**6+3813345*r**8
            +170178*r**10-8157*r**12)-8*Q2**7*(-6327-651616*r**2-542973*r**4-1778395*r**6
            +98905*r**8-203412*r**10-2181*r**12+207*r**14)+8*Q2**6*(-5943-891191*r**2
            -3383193*r**4-11587780*r**6-10153075*r**8-1572643*r**10-622461*r**12
            -13398*r**14+420*r**16)+8*Q2**5*(-1284+8398*r**2+2312708*r**4+9155691*r**6
            +23311392*r**8+6859881*r**10+797988*r**12+185973*r**14+1356*r**16+57*r**18)
            +Q2**4*(34249+5785410*r**2+7369665*r**4+88484320*r**6-138504270*r**8
            -44549788*r**10+15777210*r**12-6455760*r**14+2109045*r**16+71530*r**18
            -1931*r**20)+4*Q2**3*(-3001-818121*r**2-3167815*r**4-34632105*r**6+13941570*r**8
            -19084558*r**10+6052382*r**12+3025010*r**14+3050295*r**16-323305*r**18
            -8471*r**20+119*r**22)+4*Q2**2*(-1567-223806*r**2+930087*r**4+2175310*r**6
            +12132160*r**8+4033124*r**10-13722438*r**12-13803764*r**14-5884315*r**16
            -87590*r**18-58337*r**20-4186*r**22+122*r**24)-4*Q2*(-1333-327586*r**2
            -53198*r**4-15606570*r**6+50223425*r**8-85305484*r**10+38454012*r**12
            +5455156*r**14+2058365*r**16+2960350*r**18+2220242*r**20-73226*r**22
            -4233*r**24+80*r**26))+4*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(192*Q2**19
            +88*Q2**18*(1+r**2)-16*Q2**17*(-761-1642*r**2+781*r**4)+Q2**16*(-145669
            -1825599*r**2-297995*r**4+73775*r**6)+4*Q2**15*(150207+3591900*r**2
            +4186230*r**4+340660*r**6-51861*r**8)+2*Q2**14*(-587263-22270690*r**2
            -56976461*r**4-30027301*r**6-1597940*r**8+160967*r**10)+4*Q2**13*(223639
            +12910234*r**2+73261216*r**4+81644768*r**6+24316527*r**8+917894*r**10
            -60326*r**12)-2*Q2**12*(-317131-18876162*r**2+114185636*r**4+219020933*r**6
            +179282069*r**8+19229600*r**10+281938*r**12+12701*r**14)+4*Q2**11*(-427377
            -40901932*r**2-95582026*r**4-235832836*r**6-191728516*r**8-18524260*r**10
            -23734310*r**12-833580*r**14+48165*r**16)+Q2**10*(645546+117202740*r**2
            +950023122*r**4+3458598670*r**6+6480987254*r**8+3090309622*r**10+555687430*r**12
            +116673738*r**14+2445960*r**16-86658*r**18)-4*Q2**9*(-279719-25380890*r**2
            +140458404*r**4+715979284*r**6+3392656990*r**8+3213841264*r**10+899717980*r**12
            +147373004*r**14-4363551*r**16-513590*r**18+21736*r**20)+2*Q2**8*(-565738
            -93325493*r**2-216617569*r**4-1312661502*r**6+4253144032*r**8+7526070378*r**10
            +4624178418*r**12+588840656*r**14+170257418*r**16-48534133*r**18-1641233*r**20
            +45422*r**22)+4*Q2**7*(-31163+7629684*r**2+211851218*r**4+1591348508*r**6
            +3260448139*r**8+4797578744*r**10+4261569596*r**12+998967992*r**14+339887083*r**16
            +10756724*r**18+7392018*r**20+68684*r**22+1573*r**24)-2*Q2**6*(-310899
            -50182914*r**2+196567371*r**4+1356019711*r**6+14011017886*r**8+28406379147*r**10
            +47692110982*r**12+23534560726*r**14+5007634041*r**16+777053636*r**18
            +209461039*r**20-18156501*r**22-801700*r**24+19635*r**26)+4*Q2**5*(-44419
            -13953970*r**2-51425816*r**4-710056600*r**6+3395263571*r**8+3934803926*r**10
            +29948143010*r**12+22670582320*r**14+5991109955*r**16+1165588042*r**18
            +98177028*r**20+79097960*r**22-5399059*r**24-153710*r**26+2162*r**28)
            +2*Q2**4*(-74771-9858590*r**2+173066644*r**4+1579897069*r**6+6085393995*r**8
            +27876860036*r**10-14689327610*r**12-21487760013*r**14-5085336893*r**16
            -1532121230*r**18-1709875624*r**20-14947725*r**22+49489669*r**24-2377176*r**26
            -213490*r**28+4909*r**30)-4*Q2**3*(-22333-5590428*r**2+30318494*r**4
            +103450092*r**6+3947265218*r**8+9973666948*r**10+13322010758*r**12+2238290812*r**14
            +1101385656*r**16-6233169716*r**18-3689404902*r**20-1239105212*r**22
            -61818306*r**24+47410252*r**26-1303102*r**28-73388*r**30+1157*r**32)
            -2*Q2**2*(-4107+408166*r**2+28432177*r**4+350402083*r**6-1139137991*r**8
            +6331072423*r**10-37591020251*r**12+32929105263*r**14-5509203441*r**16
            +4305412287*r**18+19284105635*r**20+2214797369*r**22-285387037*r**24
            -7830667*r**26-9379321*r**28+132149*r**30-17184*r**32+447*r**34)+12*Q2*(
            -1333-309198*r**2+4690768*r**4+26504868*r**6+321630628*r**8+1287006892*r**10
            -4395066128*r**12+10784577284*r**14-9208651006*r**16+7844999744*r**18
            -4976184960*r**20-574534900*r**22-751218972*r**24-346607692*r**26-20537872*r**28
            +3731276*r**30-24149*r**32-5330*r**34+80*r**36)-3*(-1059-308555*r**2
            +4210801*r**4+10774145*r**6+501804548*r**8+645428372*r**10-4220464300*r**12
            +24690211972*r**14-31128267770*r**16-10091920314*r**18+38650944158*r**20
            -14149245010*r**22-3260927372*r**24-1070939420*r**26-552049916*r**28
            -33999596*r**30+4755365*r**32-1651*r**34-4455*r**36+57*r**38))*sqrtq2
            +logq2**5*(13063680000*(-Q2+(-1+r)**2)*(-1+r)*r**24*(1+r)*(1+r**2)*(1
            -Q2+r**2)*(1+3*r**2)*(-Q2+(1+r)**2)+13063680000*r**24*(-1-3*r**2
            +r**4+3*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**4*(10368000*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(480*Q2**6*(1+r**2)-240*Q2**5*(12+17*r**2
            +5*r**4)-8*Q2**4*(-837-1483*r**2-503*r**4+171*r**6)+Q2**3*(-6324-14275*r**2
            -4737*r**4+7411*r**6+4197*r**8)+Q2**2*(-864+5213*r**2+3876*r**4-10278*r**6
            -7268*r**8+1257*r**10)-3*Q2*(-1812-611*r**2+1987*r**4+340*r**6-2976*r**8
            +271*r**10+2801*r**12)+3*(-848+75*r**2+908*r**4-4783*r**6-1808*r**8
            +3925*r**10+852*r**12+1679*r**14))+10368000*r**18*(-480*Q2**9*(1+r**2)
            +240*Q2**8*(18+29*r**2+11*r**4)-8*Q2**7*(2097+4393*r**2+2783*r**4+459*r**6)
            +7*Q2**6*(5076+12565*r**2+10263*r**4+2171*r**6-603*r**8)+2*Q2**5*(-20538
            -58597*r**2-55520*r**4-9418*r**6+14938*r**8+7119*r**10)-5*Q2**4*(-3528
            -14371*r**2-16085*r**4-264*r**6+13112*r**8+8491*r**10+357*r**12)+3*(
            -1+r**2)**3*(848+1621*r**2+638*r**4+4513*r**6+11104*r**8+8987*r**10
            +4210*r**12+1679*r**14)-4*Q2**3*(-3780+70*r**2+4677*r**4-5237*r**6
            -11782*r**8-9456*r**10+1925*r**12+7455*r**14)+Q2**2*(-24804-17251*r**2
            +6283*r**4-45623*r**6-61833*r**8+29375*r**10+38777*r**12+33499*r**14
            +41577*r**16)-6*Q2*(-2178-135*r**2+2370*r**4-7578*r**6-9090*r**8-648*r**10
            +5414*r**12+6234*r**14+1692*r**16+3919*r**18))*sqrtq2)+logq2**3*(345600*r**14*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-640*Q2**10+80*Q2**9*(109
            +81*r**2)-4*Q2**8*(10744+17565*r**2+6629*r**4)+4*Q2**7*(24047+67087*r**2
            +55577*r**4+13937*r**6)-Q2**6*(78778+441405*r**2+587331*r**4+300955*r**6
            +60123*r**8)+2*Q2**5*(-29057+100006*r**2+207494*r**4+162424*r**6+61691*r**8
            +16898*r**10)+Q2**4*(153860+296465*r**2+664749*r**4+542330*r**6-31266*r**8
            -47435*r**10-16975*r**12)+8*Q2**3*(-9293-50490*r**2-150185*r**4-148772*r**6
            +24933*r**8+80570*r**10+26545*r**12+612*r**14)+Q2**2*(-39058+131617*r**2
            +206511*r**4+593941*r**6-348657*r**8-1148689*r**10-284079*r**12-97573*r**14
            +18307*r**16)-6*Q2*(-7893-6060*r**2-116040*r**4+16620*r**6+110278*r**8
            -131432*r**10-66960*r**12+171020*r**14+26855*r**16+3612*r**18)+3*(
            -4072-7899*r**2-124223*r**4+73288*r**6+12024*r**8-157026*r**10+1734*r**12
            -80392*r**14+247472*r**16+36861*r**18+2233*r**20))-345600*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(640*Q2**10-80*Q2**9*(109+81*r**2)+4*Q2**8*(10744
            +17565*r**2+6629*r**4)-4*Q2**7*(24047+67087*r**2+55577*r**4+13937*r**6)
            +Q2**6*(78778+441405*r**2+587331*r**4+300955*r**6+60123*r**8)-2*Q2**5*(
            -29057+100006*r**2+207494*r**4+162424*r**6+61691*r**8+16898*r**10)
            +Q2**4*(-153860-296465*r**2-664749*r**4-542330*r**6+31266*r**8+47435*r**10
            +16975*r**12)-8*Q2**3*(-9293-50490*r**2-150185*r**4-148772*r**6+24933*r**8
            +80570*r**10+26545*r**12+612*r**14)+Q2**2*(39058-131617*r**2-206511*r**4
            -593941*r**6+348657*r**8+1148689*r**10+284079*r**12+97573*r**14-18307*r**16)
            +6*Q2*(-7893-6060*r**2-116040*r**4+16620*r**6+110278*r**8-131432*r**10
            -66960*r**12+171020*r**14+26855*r**16+3612*r**18)-3*(-4072-7899*r**2
            -124223*r**4+73288*r**6+12024*r**8-157026*r**10+1734*r**12-80392*r**14
            +247472*r**16+36861*r**18+2233*r**20))*sqrtq2)+logq2**2*(-5760*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(11520*Q2**13-16*Q2**12*(6129+5467*r**2)
            +4*Q2**11*(81472+162683*r**2+68411*r**4)-4*Q2**10*(115431+488576*r**2
            +445435*r**4+107538*r**6)+5*Q2**9*(2286+525503*r**2+836313*r**4+485409*r**6
            +63513*r**8)-5*Q2**8*(-156696+37219*r**2-31124*r**4+156518*r**6+255372*r**8
            +4311*r**10)-2*Q2**7*(395556+2230843*r**2+9881570*r**4+14718735*r**6
            +6476095*r**8+461006*r**10+81363*r**12)+2*Q2**6*(-57588+2859143*r**2
            +16754391*r**4+43245765*r**6+36028570*r**8+10679877*r**10+969843*r**12
            +94431*r**14)-2*Q2**5*(-311994+477316*r**2+2545855*r**4+38935933*r**6
            +53179760*r**8+24313856*r**10+5004941*r**12+668895*r**14+47838*r**16)
            -10*Q2**4*(26328+392144*r**2+3683419*r**4+2309292*r**6-100423*r**8-798008*r**10
            -202923*r**12-290236*r**14-70913*r**16+7224*r**18)+10*Q2**3*(-11460
            +312497*r**2+3011748*r**4+7592889*r**6+9993411*r**8+4134399*r**10-3077805*r**12
            -3372825*r**14-830991*r**16-33744*r**18+11161*r**20)+2*Q2**2*(51538
            +83929*r**2+2099095*r**4-19815615*r**6-13787040*r**8-9064446*r**10+33675702*r**12
            +33703410*r**14+16351470*r**16+431045*r**18-179437*r**20-4051*r**22)
            -3*Q2*(3854+351281*r**2+4245317*r**4-2508915*r**6+22869135*r**8-11047218*r**10
            +3415638*r**12+21190806*r**14-28658760*r**16-6759935*r**18-2912411*r**20
            -202019*r**22+13227*r**24)+3*(-1288+110037*r**2+1257150*r**4-375994*r**6
            +15437670*r**8-7418889*r**10-19279324*r**12+10397140*r**14+33625068*r**16
            -26364045*r**18-5865698*r**20-1453338*r**22-73290*r**24+4801*r**26))
            +5760*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(11520*Q2**14-16*Q2**13*(6849
            +6187*r**2)+4*Q2**12*(105988+209067*r**2+90279*r**4)-4*Q2**11*(196903
            +732731*r**2+676529*r**4+175949*r**6)+Q2**10*(473154+5043543*r**2+7917609*r**4
            +4638937*r**6+747717*r**8)-10*Q2**9*(-77205+282504*r**2+665346*r**4
            +739120*r**6+402147*r**8+33912*r**10)-Q2**8*(1574592+5059071*r**2+19732665*r**4
            +28810500*r**6+10892740*r**8-376403*r**10+141171*r**12)+4*Q2**7*(168984
            +2742771*r**2+14433402*r**4+33923035*r**6+28611700*r**8+8808489*r**10
            +756106*r**12+87897*r**14)-2*Q2**6*(-369582+3278871*r**2+22159389*r**4
            +98936089*r**6+132454095*r**8+71022303*r**10+16654661*r**12+1733169*r**14
            +142269*r**16)+4*Q2**5*(-221817-897699*r**2-7696962*r**4+14967664*r**6
            +46308904*r**8+40741828*r**10+15166706*r**12+3562508*r**14+535649*r**16
            +5859*r**18)+10*Q2**4*(14868+730969*r**2+7087311*r**4+13585600*r**6
            +12202280*r**8+3235968*r**10-4078736*r**12-3865984*r**14-1192140*r**16
            -97433*r**18+18385*r**20)-4*Q2**3*(-54419+710628*r**2+7261065*r**4+36419400*r**6
            +50859270*r**8+39851748*r**10-14196366*r**12-32978280*r**14-18685275*r**16
            -2377360*r**18+33261*r**20+29928*r**22)-Q2**2*(114638+1324777*r**2+17101999*r**4
            -42959785*r**6+1402095*r**8-78844626*r**10+59469426*r**12+198330642*r**14
            +14133480*r**16+13285225*r**18-8234017*r**20-973033*r**22+31579*r**24)
            +6*Q2*(1283+232586*r**2+2926874*r**4+680204*r**6+17898945*r**8+2201514*r**10
            -13455452*r**12+17501792*r**14+13078557*r**16-30891370*r**18-7769022*r**20
            -2283884*r**22-131041*r**24+9014*r**26)-3*(-1288+108749*r**2+1367187*r**4
            +881156*r**6+15061676*r**8+8018781*r**10-26698213*r**12-8882184*r**14
            +44022208*r**16+7261023*r**18-32229743*r**20-7319036*r**22-1526628*r**24
            -68489*r**26+4801*r**28))*sqrtq2)+logq2*(48*r**6*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-24832*Q2**16+32*Q2**15*(7391+8831*r**2)
            -8*Q2**14*(105120+310747*r**2+147195*r**4)+8*Q2**13*(149925+949863*r**2
            +1071463*r**4+279085*r**6)-Q2**12*(-269140+7147001*r**2+11059123*r**4
            +11171351*r**6+1391025*r**8)-4*Q2**11*(730411+2738804*r**2+12969654*r**4
            +10560284*r**6+330159*r**8+414176*r**10)+2*Q2**10*(1319262+15299499*r**2
            +92391625*r**4+176075950*r**6+77432240*r**8+8996279*r**10+1413177*r**12)
            +4*Q2**9*(365205-4054812*r**2-43791325*r**4-205409750*r**6-190977325*r**8
            -47505400*r**10-4236587*r**12+33930*r**14)+Q2**8*(-3625800-20966583*r**2
            -124396393*r**4+638600425*r**6+1143100575*r**8+659131035*r**10+85605557*r**12
            +5002867*r**14-2632035*r**16)+8*Q2**7*(113165+3632844*r**2+46580062*r**4
            +87545574*r**6+158298110*r**8+127385300*r**10+18149174*r**12+4626662*r**14
            +319169*r**16+139700*r**18)+4*Q2**6*(461246-828817*r**2-48003727*r**4
            -467276692*r**6-1374332532*r**8-2141159326*r**10-1024048542*r**12-170495852*r**14
            -23969242*r**16-1959057*r**18+264701*r**20)-8*Q2**5*(146598+1671809*r**2
            +18659510*r**4-133478905*r**6-437240570*r**8-1593563812*r**10-1271910682*r**12
            -335013240*r**14-39908980*r**16-9947845*r**18-886356*r**20+102873*r**22)
            -Q2**4*(340860-7395849*r**2-202457835*r**4-790689275*r**6-4645644325*r**8
            +2616114550*r**10+5891720898*r**12+434581850*r**14+114198850*r**16+95382675*r**18
            +4007465*r**20-1807199*r**22+178535*r**24)+4*Q2**3*(113225+229076*r**2
            -10748334*r**4-296233120*r**6-1492129325*r**8-1620955560*r**10-911801092*r**12
            -425924192*r**14+471635775*r**16+368745300*r**18+91618610*r**20-9485184*r**22
            -1294299*r**24+69120*r**26)-2*Q2**2*(12730+944813*r**2+21319199*r**4
            -99536842*r**6-5148760*r**8-2804453825*r**10-442052871*r**12+375339252*r**14
            +3068697954*r**16+2909071835*r**18+412512145*r**20+54726358*r**22-7406276*r**24
            -383687*r**26+5975*r**28)-12*Q2*(6209-44832*r**2-2222177*r**4-25078142*r**6
            -178749747*r**8+365365296*r**10-712704661*r**12+20753954*r**14-240045341*r**16
            +569882944*r**18+66295181*r**20+112256118*r**22+24862223*r**24-461392*r**26
            -119447*r**28+3814*r**30)+3*(6416-13331*r**2-1506565*r**4-40930255*r**6
            -210248305*r**8+628651937*r**10-3432125417*r**12+3719437205*r**14+2909531835*r**16
            -7282941065*r**18+2875929953*r**20+542905027*r**22+237587485*r**24+54892795*r**26
            -1008755*r**28-172681*r**30+3721*r**32))-48*r**6*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(24832*Q2**16-32*Q2**15*(7391+8831*r**2)+8*Q2**14*(105120
            +310747*r**2+147195*r**4)-8*Q2**13*(149925+949863*r**2+1071463*r**4
            +279085*r**6)+Q2**12*(-269140+7147001*r**2+11059123*r**4+11171351*r**6
            +1391025*r**8)+4*Q2**11*(730411+2738804*r**2+12969654*r**4+10560284*r**6
            +330159*r**8+414176*r**10)-2*Q2**10*(1319262+15299499*r**2+92391625*r**4
            +176075950*r**6+77432240*r**8+8996279*r**10+1413177*r**12)-4*Q2**9*(365205
            -4054812*r**2-43791325*r**4-205409750*r**6-190977325*r**8-47505400*r**10
            -4236587*r**12+33930*r**14)+Q2**8*(3625800+20966583*r**2+124396393*r**4
            -638600425*r**6-1143100575*r**8-659131035*r**10-85605557*r**12-5002867*r**14
            +2632035*r**16)-8*Q2**7*(113165+3632844*r**2+46580062*r**4+87545574*r**6
            +158298110*r**8+127385300*r**10+18149174*r**12+4626662*r**14+319169*r**16
            +139700*r**18)+4*Q2**6*(-461246+828817*r**2+48003727*r**4+467276692*r**6
            +1374332532*r**8+2141159326*r**10+1024048542*r**12+170495852*r**14+23969242*r**16
            +1959057*r**18-264701*r**20)+8*Q2**5*(146598+1671809*r**2+18659510*r**4
            -133478905*r**6-437240570*r**8-1593563812*r**10-1271910682*r**12-335013240*r**14
            -39908980*r**16-9947845*r**18-886356*r**20+102873*r**22)+Q2**4*(340860
            -7395849*r**2-202457835*r**4-790689275*r**6-4645644325*r**8+2616114550*r**10
            +5891720898*r**12+434581850*r**14+114198850*r**16+95382675*r**18+4007465*r**20
            -1807199*r**22+178535*r**24)-4*Q2**3*(113225+229076*r**2-10748334*r**4
            -296233120*r**6-1492129325*r**8-1620955560*r**10-911801092*r**12-425924192*r**14
            +471635775*r**16+368745300*r**18+91618610*r**20-9485184*r**22-1294299*r**24
            +69120*r**26)+2*Q2**2*(12730+944813*r**2+21319199*r**4-99536842*r**6
            -5148760*r**8-2804453825*r**10-442052871*r**12+375339252*r**14+3068697954*r**16
            +2909071835*r**18+412512145*r**20+54726358*r**22-7406276*r**24-383687*r**26
            +5975*r**28)+12*Q2*(6209-44832*r**2-2222177*r**4-25078142*r**6-178749747*r**8
            +365365296*r**10-712704661*r**12+20753954*r**14-240045341*r**16+569882944*r**18
            +66295181*r**20+112256118*r**22+24862223*r**24-461392*r**26-119447*r**28
            +3814*r**30)-3*(6416-13331*r**2-1506565*r**4-40930255*r**6-210248305*r**8
            +628651937*r**10-3432125417*r**12+3719437205*r**14+2909531835*r**16-7282941065*r**18
            +2875929953*r**20+542905027*r**22+237587485*r**24+54892795*r**26-1008755*r**28
            -172681*r**30+3721*r**32))*sqrtq2))*math.log(mus))/(-1260*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))-1260*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2+logq2**5*(-4702924800*r**22*(1+r**2)*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            +4702924800*r**22*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**2*(-1088640*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8+3*Q2**3*(1
            +r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4+7*r**6))
            -1088640*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8
            +3*Q2**3*(1+r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4
            +7*r**6))*sqrtq2)+logq2**3*(4354560*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))+4354560*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))*sqrtq2)+logq2**4*(-26127360*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(63+8*Q2**4-402*r**2
            -1122*r**4-402*r**6+63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)
            -3*Q2*(19+31*r**2+31*r**4+19*r**6))-26127360*(-Q2+(-1+r)**2)*r**18*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(63+8*Q2**4-402*r**2-1122*r**4-402*r**6
            +63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)-3*Q2*(19+31*r**2
            +31*r**4+19*r**6))*sqrtq2)+logq2*(15120*(-Q2+(-1+r)**2)*r**6*(1-Q2
            +r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1
            +r**2)-Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)
            +3*(9-86*r**2-446*r**4-86*r**6+9*r**8))+15120*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1+r**2)
            -Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)+3*(9
            -86*r**2-446*r**4-86*r**6+9*r**8))*sqrtq2))+math.log(mu0)*((16*(Q2-(-1
            +r)**2)**6*r**6*(Q2-(1+r)**2)**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**2*(7464*Q2**19+16*Q2**18*(-311+1513*r**2)+Q2**17*(468677+1617658*r**2
            -1039183*r**4)+Q2**16*(-6191699-122511481*r**2-22708749*r**4+7609561*r**6)
            +2*Q2**15*(14836877+546036567*r**2+712981502*r**4+69532943*r**6-14657905*r**8)
            +2*Q2**14*(-35528951-2013921502*r**2-5374418459*r**4-3313495127*r**6
            -242447854*r**8+35513269*r**10)+2*Q2**13*(40115579+3263468301*r**2+15547273851*r**4
            +18222344770*r**6+7987168005*r**8+529176465*r**10-57521947*r**12)+2*Q2**12*(3351647
            -405574*r**2-14075247708*r**4-17993856513*r**6-24588286509*r**8-10410219924*r**10
            -744217366*r**12+63209627*r**14)-2*Q2**11*(69430439+8657193313*r**2+24728284736*r**4
            +99470108463*r**6+83197869000*r**8-2618583465*r**10-6081062284*r**12
            -668090807*r**14+46679789*r**16)+2*Q2**10*(77071709+12367789742*r**2
            +71151198159*r**4+301760940785*r**6+493925584169*r**8+242809949397*r**10
            +26655034469*r**12+792821267*r**14-387653178*r**16+23757305*r**18)-2*Q2**9*(5692544
            +1350503121*r**2+45316312562*r**4+202950225456*r**6+781268009512*r**8
            +627825171626*r**10+244272824676*r**12+31383365272*r**14+2210974256*r**16
            -218787283*r**18+11531234*r**20)+2*Q2**8*(-57038644-13611995639*r**2
            -45779217247*r**4-360843416940*r**6+267301174200*r**8+184445110842*r**10
            +243453029202*r**12+182735796888*r**14+37392820380*r**16-525313315*r**18
            -218735891*r**20+8145332*r**22)+2*Q2**7*(42132103+13146365261*r**2+85252676118*r**4
            +697854383041*r**6+490558127903*r**8+910812714474*r**10+449992678620*r**12
            -237015948838*r**14-249783862659*r**16-51611141447*r**18+909923870*r**20
            +154962645*r**22-3787667*r**24)-2*Q2**6*(-8070139-398650110*r**2+30994995917*r**4
            +219428926493*r**6+667741877580*r**8+464148943577*r**10+891934628122*r**12
            -163977317278*r**14-391066096819*r**16-200076653980*r**18-24429189351*r**20
            -770060671*r**22-21457822*r**24+1643201*r**26)+2*Q2**5*(-25909099-8273245385*r**2
            -26910879439*r**4-440808522214*r**6+771386102557*r**8-2055894155707*r**10
            +1534882928833*r**12-656279403172*r**14+208743525031*r**16-172676796223*r**18
            +8148029995*r**20+25836481226*r**22-912458905*r**24-114891773*r**26+3112355*r**28)
            +2*Q2**4*(11128513+4844556498*r**2+28040139996*r**4+449632841033*r**6
            -827650686109*r**8+3588718983312*r**10-3610766474406*r**12+1397022794243*r**14
            +831902843079*r**16-697468170342*r**18+196498495112*r**20-61035986097*r**22
            -31800759019*r**24+26050308*r**26+62234946*r**28-1178267*r**30)+2*Q2**3*(2386303
            +376002109*r**2-6138206004*r**4-51063840705*r**6+116283470570*r**8-1223452216787*r**10
            +2841551601248*r**12-2872333421657*r**14+1094582555980*r**16-1452590180305*r**18
            +291081134620*r**20-164521674443*r**22+18177621486*r**24+5586505575*r**26
            +165234360*r**28+8962789*r**30-376739*r**32)+(-1+r**2)**2*(-329349-180298171*r**2
            -781653862*r**4-30818959906*r**6+194361702758*r**8-1273280879518*r**10
            +4430484151778*r**12-9010181581866*r**14+9275361181212*r**16-4085328519636*r**18
            +723994366318*r**20-268937886278*r**22-96122079062*r**24-26384137106*r**26
            +576301078*r**28+25929874*r**30-2451879*r**32+39615*r**34)+2*Q2**2*(
            -3791401-1519135766*r**2-2720409031*r**4-138568865853*r**6+631476769281*r**8
            -2458508237985*r**10+4166231744989*r**12-2894830577569*r**14+530838265531*r**16
            -255455433137*r**18-359740370917*r**20-183174222215*r**22-140439517269*r**24
            -42215340003*r**26+5973652431*r**28+40964453*r**30-22519358*r**32+479819*r**34)
            +Q2*(2646299+1267572512*r**2+3112537755*r**4+163230771176*r**6-1043647093140*r**8
            +5513361073704*r**10-16213552439828*r**12+26124870572296*r**14-19277615626278*r**16
            +3499937054600*r**18+662203632730*r**20+573053131320*r**22+276274404508*r**24
            +298484143608*r**26+93517805340*r**28-5521152808*r**30-136440829*r**32
            +18146616*r**34-323581*r**36))-16*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(7464*Q2**20
            +8*Q2**19*(-1555+2093*r**2)+Q2**18*(473653+1598426*r**2-1063391*r**4)
            +8*Q2**17*(-832547-15574727*r**2-2910903*r**4+1081093*r**6)+Q2**16*(35865453
            +1220776314*r**2+1571183234*r**4+154165074*r**6-36925371*r**8)+4*Q2**15*(
            -25182914-1287397473*r**2-3316718264*r**4-2048004786*r**6-148661446*r**8
            +25085587*r**10)+4*Q2**14*(37822265+2656459377*r**2+11467806906*r**4
            +13455129178*r**6+5771555493*r**8+368055525*r**10-46517608*r**12)+4*Q2**13*(
            -18381966-1651994727*r**2-16442994930*r**4-25881737567*r**6-25398899642*r**8
            -9463282197*r**10-607935942*r**12+60365787*r**14)-4*Q2**12*(36391043
            +4330069693*r**2+5326315727*r**4+33700502121*r**6+20307862989*r**8-18808544949*r**10
            -8617749787*r**12-674549273*r**14+54944708*r**16)+4*Q2**11*(73251074
            +10547206747*r**2+52268338104*r**4+212979666992*r**6+338296780816*r**8
            +161694617466*r**10+8977694360*r**12-2978165912*r**14-504532098*r**16
            +35218547*r**18)-2*Q2**10*(82764253+13795364572*r**2+128835300463*r**4
            +575862364400*r**6+1576954534466*r**8+1364560705192*r**10+513737808542*r**12
            +58831221008*r**14+2616142345*r**16-582683156*r**18+35288539*r**20)+4*Q2**9*(
            -25673050-6127899987*r**2+443799218*r**4-56288439461*r**6+625759704584*r**8
            +796769145990*r**10+557775512752*r**12+229195993418*r**14+35493579954*r**16
            +733436829*r**18-212995970*r**20+9838283*r**22)+2*Q2**8*(99170747+26815399544*r**2
            +144643889004*r**4+1104477017228*r**6+584100370643*r**8+459066429432*r**10
            +22094538576*r**12-663204774928*r**14-469912479927*r**16-88478648512*r**18
            +1653973076*r**20+365553204*r**22-11932999*r**24)+4*Q2**7*(-17030982
            -6394923627*r**2-64697018648*r**4-501267992826*r**6-928077194262*r**8
            -932759892977*r**10-1126370010608*r**12-24499706252*r**14+438932954158*r**16
            +250735829043*r**18+37565203464*r**20-147412922*r**22-64858578*r**24
            +1072233*r**26)+4*Q2**6*(-16989619-4339982817*r**2+1842733184*r**4-95192299902*r**6
            +829278453315*r**8-462001667275*r**10+1445483250266*r**12+35838953836*r**14
            -173149944533*r**16-381909773511*r**18-108178906668*r**20+318615602*r**22
            -851988699*r**24-67353197*r**26+2377778*r**28)-4*Q2**5*(-18518806-6571855491*r**2
            -31612132410*r**4-458676121343*r**6+579114133226*r**8-2436613518231*r**10
            +1544877623766*r**12-259209634291*r**14-639719360610*r**16+366767449575*r**18
            -180513630670*r**20+47510248659*r**22+28362390670*r**24-526700493*r**26
            -87007182*r**28+2145311*r**30)+4*Q2**4*(-4371105-2239841451*r**2-19511451249*r**4
            -264368410867*r**6+247150657823*r**8-1992260256995*r**10+1431799546171*r**12
            -329294870747*r**14-567171540671*r**16-793512426521*r**18+396025404925*r**20
            -149992091729*r**22+55507183301*r**24+18680607143*r**26+38474553*r**28
            -26046945*r**30+400764*r**32)+4*Q2**3*(-3088852-948762089*r**2+1520897432*r**4
            -40683409572*r**6+283128569708*r**8-675669745884*r**10+1274066180264*r**12
            -1432024378580*r**14+1154294565604*r**16+51276095594*r**18+400884337384*r**20
            -154866841196*r**22+2952267844*r**24-32989733532*r**26+110956248*r**28
            -66616348*r**30-15552704*r**32+428279*r**34)+Q2**2*(10229101+4313426846*r**2
            +11591627349*r**4+445809320944*r**6-2029462899996*r**8+9167424011112*r**10
            -19628999453836*r**12+23582068237456*r**14-14549631002202*r**16+2949171389812*r**18
            +1892595240838*r**20+1658882317584*r**22+923501883476*r**24+663793858152*r**26
            +166001180484*r**28-17550386576*r**30-173331019*r**32+62225694*r**34
            -1283219*r**36)-(-1+r**2)**2*(-329349-180627520*r**2-961952033*r**4
            -31600613768*r**6+163542742852*r**8-1078919176760*r**10+3157203272260*r**12
            -4579697430088*r**14+265179599346*r**16+5190032661576*r**18-3361334153318*r**20
            +455056480040*r**22-365059965340*r**24-122506216168*r**26-25807836028*r**28
            +602230952*r**30+23477995*r**32-2412264*r**34+39615*r**36)+4*Q2*(-743912
            -362464571*r**2-1200374284*r**4-48944814821*r**6+283908572668*r**8-1540634306376*r**10
            +4467899744924*r**12-7263937224352*r**14+6219738387676*r**16-3967138473062*r**18
            +3501967974868*r**20-1759377975650*r**22+79105130996*r**24-169459103344*r**26
            -108694863180*r**28-28876865480*r**30+1544895772*r**32+37291865*r**34
            -5088536*r**36+90799*r**38))*sqrtq2+logq2**7*(-112870195200000*r**34*(1
            +r**2)**2*(1-Q2+r**2)*(-311-1006*r**2+2085*r**4)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3-112870195200000*(Q2-(-1+r)**2)**2*r**34*(1+r**2)**2*(
            -311-1006*r**2+2085*r**4)*(Q2-(1+r)**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2**6*(-89579520000*r**28*(1+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-127200*Q2**8*(1+r**2)+240*Q2**7*(4240+5281*r**2
            +1041*r**4)-8*Q2**6*(428505+594098*r**2+171193*r**4+44520*r**6)+Q2**5*(5987940
            +8782339*r**2+3608673*r**4+2415629*r**6+1601355*r**8)-Q2**4*(4897200
            +7262025*r**2+5412292*r**4+7664402*r**6+5919180*r**8+1924965*r**10)
            +Q2**3*(-222600-484940*r**2+2045638*r**4+6584706*r**6+11527418*r**8
            +948170*r**10-6302520*r**12)+3*(-1+r**2)**2*(224720+389667*r**2+14964*r**4
            -3041831*r**6-828256*r**8+4262109*r**10+1601052*r**12+1893415*r**14)
            +2*Q2**2*(1892100+2248480*r**2+778279*r**4-3157904*r**6-3159934*r**8
            +2857244*r**10+6869075*r**12+9413460*r**14)-3*Q2*(929620+580157*r**2
            -274719*r**4-6280817*r**6-8432477*r**8+12783123*r**10+10926751*r**12
            +1949217*r**14+5882505*r**16))-89579520000*r**28*(1+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(127200*Q2**9*(1+r**2)-240*Q2**8*(4770+6341*r**2
            +1571*r**4)+8*Q2**7*(555705+879728*r**2+360853*r**4+75750*r**6)-7*Q2**6*(1345140
            +2423309*r**2+1390143*r**4+591619*r**6+279645*r**8)+4*Q2**5*(2721285
            +5508076*r**2+4450826*r**4+3422176*r**6+2484041*r**8+881580*r**10)+5*Q2**4*(
            -934920-2334857*r**2-2943991*r**4-3932280*r**6-5022200*r**8-1758463*r**10
            +875511*r**12)-4*Q2**3*(1001700+1301125*r**2-1035*r**4-3736538*r**6
            -6107998*r**8-1690275*r**10+4773125*r**12+6282360*r**14)+3*(-1+r**2)**2*(224720
            +614387*r**2+404631*r**4-3026867*r**6-3870087*r**8+3433853*r**10+5863161*r**12
            +3494467*r**14+1893415*r**16)+Q2**2*(6573060+10021631*r**2+5229361*r**4
            -23601701*r**6-37933107*r**8+37743989*r**10+52232891*r**12+38412721*r**14
            +36474435*r**16)-12*Q2*(288585+362501*r**2-58553*r**4-2309407*r**6
            -2360731*r**8+1806859*r**10+3989613*r**12+3957347*r**14+1411486*r**16
            +1943980*r**18))*sqrtq2)+logq2**5*(-497664000*r**24*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(2035200*Q2**12*(1+r**2)-480*Q2**11*(91741
            +157890*r**2+66149*r**4)+8*Q2**10*(38124864+90642863*r**2+70763038*r**4
            +18400719*r**6)-120*Q2**9*(8541459+25661042*r**2+27948700*r**4+12883550*r**6
            +2054433*r**8)+45*Q2**8*(39863084+148267887*r**2+203571092*r**4+123433566*r**6
            +28323808*r**8+56531*r**10)+20*Q2**7*(-61626915-337752412*r**2-576553427*r**4
            -397990392*r**6-75957121*r**8+43621396*r**10+22016055*r**12)-60*Q2**6*(17548923
            -2199652*r**2-42763825*r**4-14783694*r**6+37423929*r**8+45999296*r**10
            +21238749*r**12+5677266*r**14)-12*Q2**5*(-230473743-540998951*r**2-800255941*r**4
            -885049633*r**6-648894645*r**8-480347753*r**10-228913931*r**12+21774449*r**14
            +23916372*r**16)+10*Q2**4*(-184282902-552829331*r**2-985792540*r**4-1154486106*r**6
            -1140975992*r**8-1286896426*r**10-1147778700*r**12-564192122*r**14-24066250*r**16
            +65544081*r**18)-60*Q2**3*(3779603-17477146*r**2-21413161*r**4+3776808*r**6
            -68149790*r**8-244199128*r**10-304672986*r**12-75903296*r**14+46422131*r**16
            +727306*r**18+10958747*r**20)+9*(-1+r**2)**2*(10775408+9500867*r**2
            +100084082*r**4+284325255*r**6-53490672*r**8-697507830*r**10-324488820*r**12
            +270389058*r**14+887084160*r**16+976923187*r**18+153032962*r**20+9074743*r**22)
            +60*Q2**2*(16534895+7017194*r**2+61738829*r**4+154471926*r**6+86672418*r**8
            -88401942*r**10-175421658*r**12+21101598*r**14+462383103*r**16+423109804*r**18
            +54870013*r**20+9406060*r**22)-180*Q2*(2953003-300241*r**2+16316411*r**4
            +35044267*r**6-13649826*r**8-116922990*r**10-46234878*r**12+123279498*r**14
            +63380331*r**16+100472159*r**18+137971075*r**20+20997547*r**22+1834124*r**24))
            -497664000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(2035200*Q2**12*(1
            +r**2)-480*Q2**11*(91741+157890*r**2+66149*r**4)+8*Q2**10*(38124864
            +90642863*r**2+70763038*r**4+18400719*r**6)-120*Q2**9*(8541459+25661042*r**2
            +27948700*r**4+12883550*r**6+2054433*r**8)+45*Q2**8*(39863084+148267887*r**2
            +203571092*r**4+123433566*r**6+28323808*r**8+56531*r**10)+20*Q2**7*(
            -61626915-337752412*r**2-576553427*r**4-397990392*r**6-75957121*r**8
            +43621396*r**10+22016055*r**12)-60*Q2**6*(17548923-2199652*r**2-42763825*r**4
            -14783694*r**6+37423929*r**8+45999296*r**10+21238749*r**12+5677266*r**14)
            -12*Q2**5*(-230473743-540998951*r**2-800255941*r**4-885049633*r**6-648894645*r**8
            -480347753*r**10-228913931*r**12+21774449*r**14+23916372*r**16)+10*Q2**4*(
            -184282902-552829331*r**2-985792540*r**4-1154486106*r**6-1140975992*r**8
            -1286896426*r**10-1147778700*r**12-564192122*r**14-24066250*r**16+65544081*r**18)
            -60*Q2**3*(3779603-17477146*r**2-21413161*r**4+3776808*r**6-68149790*r**8
            -244199128*r**10-304672986*r**12-75903296*r**14+46422131*r**16+727306*r**18
            +10958747*r**20)+9*(-1+r**2)**2*(10775408+9500867*r**2+100084082*r**4
            +284325255*r**6-53490672*r**8-697507830*r**10-324488820*r**12+270389058*r**14
            +887084160*r**16+976923187*r**18+153032962*r**20+9074743*r**22)+60*Q2**2*(16534895
            +7017194*r**2+61738829*r**4+154471926*r**6+86672418*r**8-88401942*r**10
            -175421658*r**12+21101598*r**14+462383103*r**16+423109804*r**18+54870013*r**20
            +9406060*r**22)-180*Q2*(2953003-300241*r**2+16316411*r**4+35044267*r**6
            -13649826*r**8-116922990*r**10-46234878*r**12+123279498*r**14+63380331*r**16
            +100472159*r**18+137971075*r**20+20997547*r**22+1834124*r**24))*sqrtq2)
            +logq2**4*(8294400*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(2713600*Q2**16
            -5120*Q2**15*(32223+29024*r**2)+64*Q2**14*(25642563+41250348*r**2+16168553*r**4)
            -8*Q2**13*(934937456+2217166727*r**2+1677155902*r**4+394311751*r**6)
            +16*Q2**12*(1154766117+3892757120*r**2+4566110242*r**4+2190589420*r**6
            +347287077*r**8)-Q2**11*(22944176568+122156333905*r**2+206849799652*r**4
            +157992248482*r**6+57193400900*r**8+7631414253*r**10)+Q2**10*(1669361472
            +112725023609*r**2+269013660061*r**4+278553863606*r**6+170108707886*r**8
            +64147510609*r**10+11790946677*r**12)+Q2**9*(37899653736+37539777131*r**2
            +92354813656*r**4+220355911525*r**6+132201315120*r**8-36892635539*r**10
            -58041846704*r**12-18194570109*r**14)+Q2**8*(-51026426304-225389537083*r**2
            -842966419303*r**4-1736609981269*r**6-1630673731785*r**8-600543950229*r**10
            +13514169047*r**12+66875784997*r**14+20025468441*r**16)-2*Q2**7*(-7490145928
            -119111895715*r**2-525293503268*r**4-1316357662810*r**6-1536409399828*r**8
            -724322422598*r**10+9495591900*r**12+136776940142*r**14+45087038500*r**16
            +6442919957*r**18)+2*Q2**6*(14208749568-24664424355*r**2-24570692803*r**4
            -440368264138*r**6-867010036570*r**8-394659166534*r**10+235478322770*r**12
            +293914471622*r**14+148640442182*r**16+35858686445*r**18+1090462853*r**20)
            +2*Q2**5*(-16230208632-62771899169*r**2-542056743936*r**4-816182391311*r**6
            -509863847616*r**8-389788264036*r**10-496280404256*r**12-331165746636*r**14
            -7869189016*r**16+34917067189*r**18-3930647824*r**20+2385270443*r**22)
            +2*Q2**4*(4413004616+64073927661*r**2+469150116501*r**4+839812757375*r**6
            +736123800735*r**8+614921555988*r**10+749224597068*r**12+872033399748*r**14
            +641848577220*r**16+102286190335*r**18-97651858209*r**20-14605563459*r**22
            -2764841579*r**24)+3*Q2**3*(2184252984-11375164167*r**2-4976219852*r**4
            -126243752766*r**6-90495879500*r**8+1835768427*r**10-402846768456*r**12
            -918724440996*r**14-672270172848*r**16-201710078625*r**18-110324656236*r**20
            +50531232098*r**22+9146759748*r**24+717824189*r**26)+9*(-1+r**2)**2*(
            -24282272-435684743*r**2-4838778585*r**4+569882572*r**6-19658769092*r**8
            -46171724751*r**10+5995485751*r**12+76016238120*r**14+103700536616*r**16
            -43867428621*r**18-171768910627*r**20-51738641908*r**22-9863493060*r**24
            -512653213*r**26+27983813*r**28)+3*Q2**2*(-2024936576-6756800625*r**2
            -129702984061*r**4+20804021570*r**6-147504045366*r**8-527046498743*r**10
            -102598718715*r**12+496167187932*r**14+302186995020*r**16-972155254303*r**18
            -1360852265331*r**20-324752948510*r**22-94540580246*r**24-8066203065*r**26
            +251671019*r**28)-9*Q2*(-211464648-1847094135*r**2-23566989912*r**4
            +23047623663*r**6-60754773520*r**8-131766349187*r**10+129672313200*r**12
            +166027735259*r**14-72535144136*r**16+94317771435*r**18-138742158232*r**20
            -469656312515*r**22-132722232672*r**24-29706988977*r**26-1945530240*r**28
            +108634617*r**30))-8294400*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(2713600*Q2**17
            -35840*Q2**16*(4679+4222*r**2)+64*Q2**15*(28220403+46150108*r**2+18490473*r**4)
            -40*Q2**14*(228015592+550462003*r**2+427301422*r**4+104732035*r**6)+8*Q2**13*(3244469690
            +10937618423*r**2+13026543113*r**4+6452646493*r**6+1088885905*r**8)-Q2**12*(41420434440
            +202916705697*r**2+342191677444*r**4+266099443074*r**6+97799424852*r**8
            +13188007485*r**10)+2*Q2**11*(12306769020+128912767041*r**2+299009896809*r**4
            +321697955870*r**6+192647178634*r**8+64486162881*r**10+9711180465*r**12)
            -2*Q2**10*(-18115146132+38427303975*r**2+144691935007*r**4+163605806071*r**6
            +158230628186*r**8+135574427017*r**10+66990151995*r**12+14992758393*r**14)
            +10*Q2**9*(-8892608004-30082896795*r**2-97286101009*r**4-204932070645*r**6
            -198323095843*r**8-69585262981*r**10+10844865129*r**12+14311220181*r**14
            +3822003855*r**16)+Q2**8*(66006718160+514639754817*r**2+2118942962922*r**4
            +5212291726192*r**6+6440102512710*r**8+3679862527210*r**10+568038597382*r**12
            -353943834328*r**14-177075330438*r**16-32911308355*r**18)+4*Q2**7*(3359301820
            -75633232999*r**2-334488045893*r**4-1141009715108*r**6-1859888549604*r**8
            -1327695494480*r**10-239674253964*r**12+220093501832*r**14+165252210412*r**16
            +43694322451*r**18+3766691405*r**20)+4*Q2**6*(-15219479100-26158112191*r**2
            -246410813389*r**4-175621717185*r**6+398757226546*r**8+435940469534*r**10
            -168549780246*r**12-430279270514*r**14-225212051410*r**16-74791030719*r**18
            -20439898561*r**20+647403795*r**22)-4*Q2**5*(-10321606624-71538017731*r**2
            -536989379803*r**4-1099025946311*r**6-1031085019831*r**8-757286833820*r**10
            -817646632680*r**12-849739775320*r**14-490441756436*r**16-37619156081*r**18
            +64319138787*r**20+6530093039*r**22+2575056011*r**24)+5*Q2**4*(-454650056
            -34219871411*r**2-216275349576*r**4-599331401210*r**6-684672150944*r**8
            -539316681633*r**10-787366522296*r**12-1199737863324*r**14-1008914894496*r**16
            -418679954197*r**18-68048526592*r**20+75221707926*r**22+12436217864*r**24
            +1536631145*r**26)-6*Q2**3*(2104594780-1217055279*r**2+56675800021*r**4
            -76011997094*r**6-34617793450*r**8+219193193835*r**10-149206140657*r**12
            -908869198692*r**14-946590804432*r**16+49087501415*r**18+524408765235*r**20
            +132479762186*r**22+77109286046*r**24+8965393501*r**26+233076585*r**28)
            +6*Q2**2*(1329665260+7161509803*r**2+103580377211*r**4+19878045751*r**6
            +154482172178*r**8+534924795835*r**10+120314138929*r**12-445825837497*r**14
            -290374375272*r**16+193507472489*r**18+1374616997165*r**20+1547287075693*r**22
            +408730113386*r**24+95863875121*r**26+6825561383*r**28-288787435*r**30)
            -9*(-1+r**2)**2*(-24282272-459967015*r**2-5274463328*r**4-4268896013*r**6
            -19088886520*r**8-65830493843*r**10-40176239000*r**12+82011723871*r**14
            +179716774736*r**16+59833107995*r**18-215636339248*r**20-223507552535*r**22
            -61602134968*r**24-10376146273*r**26-484669400*r**28+27983813*r**30)
            +18*Q2*(-117873460-1222839491*r**2-14702887709*r**4+4646194375*r**6
            -31672231339*r**8-99402713351*r**10+38293065087*r**12+156776795163*r**14
            +25578068625*r**16-76734818217*r**18-12378951783*r**20-180233360011*r**22
            -340266832529*r**24-97476765325*r**26-20231361019*r**28-1202758231*r**30
            +68309215*r**32))*sqrtq2)+logq2**3*(-138240*r**16*(1-Q2+r**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**4*(-184698880*Q2**19+512*Q2**18*(5430524+4109799*r**2)
            -64*Q2**17*(278177301+455678302*r**2+176012681*r**4)+16*Q2**16*(3844136104
            +10548578129*r**2+8797799274*r**4+2277153889*r**6)-16*Q2**15*(7209645403
            +32319582624*r**2+43535177542*r**4+24206076904*r**6+4818972903*r**8)
            +Q2**14*(76873452120+831405509045*r**2+1620130776068*r**4+1438071339178*r**6
            +638640599140*r**8+112573938785*r**10)-2*Q2**13*(-67848516708+182406215547*r**2
            +493774271091*r**4+608270613602*r**6+628869110686*r**8+330328917027*r**10
            +62316772947*r**12)+Q2**12*(-347468957328-1152105690801*r**2-4070869960370*r**4
            -7582025623819*r**6-5033713388524*r**8-427053995415*r**10+538031512494*r**12
            +117852628947*r**14)-4*Q2**11*(-56797891272-589459880247*r**2-2762803136509*r**4
            -7277513862599*r**6-8300974768645*r**8-4066120699149*r**10-589823934879*r**12
            +119839912203*r**14+20587377513*r**16)-Q2**10*(-179503409224+1514997165483*r**2
            +9479541671216*r**4+43613312087616*r**6+73466992759992*r**8+57690263128702*r**10
            +23016430449536*r**12+3919089497976*r**14-210085212192*r**16+355290911*r**18)
            +2*Q2**9*(-188318219300-429773288145*r**2-2801495496493*r**4+7700880082312*r**6
            +24478070052520*r**8+26214484880710*r**10+18310399531990*r**12+9298503928672*r**14
            +2852321965572*r**16+203917942435*r**18+35844707535*r**20)+Q2**8*(143427314304
            +2280133462999*r**2+19605873018114*r**4+48043134255143*r**6+90781314888984*r**8
            +123131012242006*r**10+73883037589756*r**12+2905966289854*r**14-15589820098632*r**16
            -7040356914381*r**18-769101417806*r**20-48854732101*r**22)-8*Q2**7*(-17957251306
            +183092007883*r**2+1782974746801*r**4+9699481538909*r**6+24349394646589*r**8
            +39755774444418*r**10+32687751455862*r**12+8572347582198*r**14-4007941357516*r**16
            -3235432071261*r**18-827307263159*r**20-70683077187*r**22+2827831049*r**24)
            +Q2**6*(-151560374168-260429072793*r**2-3940678846924*r**4+34900067780706*r**6
            +70835253293780*r**8+181165590519117*r**10+212494233825352*r**12+44528418833612*r**14
            -68068234764528*r**16-62514408556095*r**18-25588159779964*r**20-3723630819374*r**22
            -192761777228*r**24+38311079307*r**26)+2*Q2**5*(7132353948+504432600659*r**2
            +6321274597699*r**4+12400910594462*r**6+71251197604994*r**8+67514443576813*r**10
            +6075300958869*r**12+21917003479332*r**14+36474321202824*r**16+8098161900813*r**18
            -1136714810771*r**20+1997082220862*r**22-238259065766*r**24-46240959821*r**26
            -2019758917*r**28)-Q2**4*(-41989005360+564843991755*r**2+6646724129582*r**4
            +37405786654877*r**6+154771425561980*r**8+173546016487995*r**10+64722960730770*r**12
            +57698872550181*r**14+121370122993176*r**16+122213425250985*r**18+27392195316690*r**20
            -21567330507425*r**22-6047843692388*r**24-2451881744303*r**26-218267993490*r**28
            +13453194975*r**30)+12*Q2**3*(-1487557584-2581083739*r**2-75354150161*r**4
            +1172395072353*r**6+712922069899*r**8+3728063460809*r**10+606192279179*r**12
            +320253177317*r**14+14513688588519*r**16+19676117559807*r**18+12083365111069*r**20
            +6998599050899*r**22-352968381231*r**24-239739449197*r**26-117064315031*r**28
            -9868241369*r**30+463928461*r**32)+9*(-1+r**2)**2*(-65653408+1225025645*r**2
            +17713404808*r**4+122916231980*r**6+808661093280*r**8-820449897616*r**10
            +1728262275160*r**12+6763667832236*r**14+130934261840*r**16-15796031160110*r**18
            -6268361487944*r**20+14756513091620*r**22+5900864533504*r**24+2081074126680*r**26
            +327575231080*r**28+1086494468*r**30-1398078800*r**32+27075577*r**34)
            +3*Q2**2*(-896516952+59071454981*r**2+792366633704*r**4+943508374172*r**6
            +20766856048512*r**8-14040744380752*r**10+12112521244184*r**12+43148134990460*r**14
            -22970855072544*r**16-33932767038174*r**18+55093124686360*r**20+105973069619764*r**22
            +32689322894368*r**24+15650432158872*r**26+2423338183912*r**28+75786225844*r**30
            -9659563304*r**32+484456593*r**34)-18*Q2*(-180453412+4434766063*r**2
            +53898886347*r**4+201568084932*r**6+1866445766220*r**8-3349044572904*r**10
            +3972855204416*r**12+6234042065364*r**14-3541855147436*r**16-1510583082690*r**18
            -12519790975906*r**20-2786731031796*r**22+20270938794756*r**24+7250173723776*r**26
            +2872918437720*r**28+489777370972*r**30+2230488192*r**32-2745547717*r**34
            +76023103*r**36))+138240*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(184698880*Q2**19
            -512*Q2**18*(5430524+4109799*r**2)+64*Q2**17*(278177301+455678302*r**2
            +176012681*r**4)-16*Q2**16*(3844136104+10548578129*r**2+8797799274*r**4
            +2277153889*r**6)+16*Q2**15*(7209645403+32319582624*r**2+43535177542*r**4
            +24206076904*r**6+4818972903*r**8)-Q2**14*(76873452120+831405509045*r**2
            +1620130776068*r**4+1438071339178*r**6+638640599140*r**8+112573938785*r**10)
            +2*Q2**13*(-67848516708+182406215547*r**2+493774271091*r**4+608270613602*r**6
            +628869110686*r**8+330328917027*r**10+62316772947*r**12)+Q2**12*(347468957328
            +1152105690801*r**2+4070869960370*r**4+7582025623819*r**6+5033713388524*r**8
            +427053995415*r**10-538031512494*r**12-117852628947*r**14)+4*Q2**11*(
            -56797891272-589459880247*r**2-2762803136509*r**4-7277513862599*r**6
            -8300974768645*r**8-4066120699149*r**10-589823934879*r**12+119839912203*r**14
            +20587377513*r**16)+Q2**10*(-179503409224+1514997165483*r**2+9479541671216*r**4
            +43613312087616*r**6+73466992759992*r**8+57690263128702*r**10+23016430449536*r**12
            +3919089497976*r**14-210085212192*r**16+355290911*r**18)-2*Q2**9*(-188318219300
            -429773288145*r**2-2801495496493*r**4+7700880082312*r**6+24478070052520*r**8
            +26214484880710*r**10+18310399531990*r**12+9298503928672*r**14+2852321965572*r**16
            +203917942435*r**18+35844707535*r**20)+Q2**8*(-143427314304-2280133462999*r**2
            -19605873018114*r**4-48043134255143*r**6-90781314888984*r**8-123131012242006*r**10
            -73883037589756*r**12-2905966289854*r**14+15589820098632*r**16+7040356914381*r**18
            +769101417806*r**20+48854732101*r**22)+8*Q2**7*(-17957251306+183092007883*r**2
            +1782974746801*r**4+9699481538909*r**6+24349394646589*r**8+39755774444418*r**10
            +32687751455862*r**12+8572347582198*r**14-4007941357516*r**16-3235432071261*r**18
            -827307263159*r**20-70683077187*r**22+2827831049*r**24)+Q2**6*(151560374168
            +260429072793*r**2+3940678846924*r**4-34900067780706*r**6-70835253293780*r**8
            -181165590519117*r**10-212494233825352*r**12-44528418833612*r**14+68068234764528*r**16
            +62514408556095*r**18+25588159779964*r**20+3723630819374*r**22+192761777228*r**24
            -38311079307*r**26)+2*Q2**5*(-7132353948-504432600659*r**2-6321274597699*r**4
            -12400910594462*r**6-71251197604994*r**8-67514443576813*r**10-6075300958869*r**12
            -21917003479332*r**14-36474321202824*r**16-8098161900813*r**18+1136714810771*r**20
            -1997082220862*r**22+238259065766*r**24+46240959821*r**26+2019758917*r**28)
            +Q2**4*(-41989005360+564843991755*r**2+6646724129582*r**4+37405786654877*r**6
            +154771425561980*r**8+173546016487995*r**10+64722960730770*r**12+57698872550181*r**14
            +121370122993176*r**16+122213425250985*r**18+27392195316690*r**20-21567330507425*r**22
            -6047843692388*r**24-2451881744303*r**26-218267993490*r**28+13453194975*r**30)
            -12*Q2**3*(-1487557584-2581083739*r**2-75354150161*r**4+1172395072353*r**6
            +712922069899*r**8+3728063460809*r**10+606192279179*r**12+320253177317*r**14
            +14513688588519*r**16+19676117559807*r**18+12083365111069*r**20+6998599050899*r**22
            -352968381231*r**24-239739449197*r**26-117064315031*r**28-9868241369*r**30
            +463928461*r**32)-9*(-1+r**2)**2*(-65653408+1225025645*r**2+17713404808*r**4
            +122916231980*r**6+808661093280*r**8-820449897616*r**10+1728262275160*r**12
            +6763667832236*r**14+130934261840*r**16-15796031160110*r**18-6268361487944*r**20
            +14756513091620*r**22+5900864533504*r**24+2081074126680*r**26+327575231080*r**28
            +1086494468*r**30-1398078800*r**32+27075577*r**34)-3*Q2**2*(-896516952
            +59071454981*r**2+792366633704*r**4+943508374172*r**6+20766856048512*r**8
            -14040744380752*r**10+12112521244184*r**12+43148134990460*r**14-22970855072544*r**16
            -33932767038174*r**18+55093124686360*r**20+105973069619764*r**22+32689322894368*r**24
            +15650432158872*r**26+2423338183912*r**28+75786225844*r**30-9659563304*r**32
            +484456593*r**34)+18*Q2*(-180453412+4434766063*r**2+53898886347*r**4
            +201568084932*r**6+1866445766220*r**8-3349044572904*r**10+3972855204416*r**12
            +6234042065364*r**14-3541855147436*r**16-1510583082690*r**18-12519790975906*r**20
            -2786731031796*r**22+20270938794756*r**24+7250173723776*r**26+2872918437720*r**28
            +489777370972*r**30+2230488192*r**32-2745547717*r**34+76023103*r**36))*sqrtq2)
            +logq2**2*(2304*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1022670848*Q2**22
            -512*Q2**21*(24834218+23212393*r**2)+32*Q2**20*(2083251429+4175791402*r**2
            +1877468229*r**4)-160*Q2**19*(1137301132+3976722213*r**2+3768699686*r**4
            +1081324669*r**6)+40*Q2**18*(5748783743+39561498957*r**2+60837521709*r**4
            +38179286583*r**6+7880317912*r**8)-Q2**17*(-71460877668+1784932323935*r**2
            +3949532812500*r**4+4254959451870*r**6+2356200908720*r**8+388829866467*r**10)
            +Q2**16*(-672794634736-911186431171*r**2-3760525339455*r**4-5533980223890*r**6
            +302013375350*r**8+2139356159829*r**10+343592999609*r**12)+Q2**15*(801749116928
            +5978443458314*r**2+28913744075418*r**4+67192112679050*r**6+55838368675060*r**8
            +14598761471478*r**10-654816895886*r**12-192776931722*r**14)-10*Q2**14*(
            -10849078656+761169887661*r**2+4916787904122*r**4+18156723058836*r**6
            +24281233152457*r**8+14077841980713*r**10+3254223831960*r**12+120915822102*r**14
            +4277317413*r**16)+10*Q2**13*(-112625852696+71743560271*r**2+1226677431827*r**4
            +19570384024896*r**6+40715457060437*r**8+37503564198308*r**10+17862360378285*r**12
            +3871977620908*r**14+247374594179*r**16+20621189281*r**18)-2*Q2**12*(
            -417142276304-4730846749165*r**2-38922327475050*r**4-37265757522915*r**6
            +4103610892355*r**8+35472517411299*r**10+86082063231535*r**12+68491044397815*r**14
            +18361854151665*r**16+1490873281270*r**18+35474563031*r**20)-2*Q2**11*(
            -190641171552+5343352654183*r**2+55543227223755*r**4+233753327169405*r**6
            +557855429499080*r**8+929048231491302*r**10+680114032359462*r**12+135269251523810*r**14
            -48794049911760*r**16-17617160221005*r**18-1310916238217*r**20+98952865953*r**22)
            +2*Q2**10*(-423688851976+262302710787*r**2+8759401835914*r**4+257119596408110*r**6
            +874270631319655*r**8+2276647129217686*r**10+2693272289275708*r**12+1440802952152996*r**14
            +295684056044590*r**16-27962007843025*r**18-8732928464046*r**20-349771542938*r**22
            +89656043099*r**24)+10*Q2**9*(22636088524+840648215196*r**2+9177949390047*r**4
            -6595423390116*r**6-37792968640721*r**8-376165438015926*r**10-693758081752218*r**12
            -559872595894992*r**14-258751331199462*r**16-70072280784496*r**18-5091655542693*r**20
            -1695867411756*r**22-180326535093*r**24+6513168938*r**26)-10*Q2**8*(-32494382976
            +617416863526*r**2+8118092904537*r**4+43487041541013*r**6+205055726759093*r**8
            +255613402584909*r**10+184513901619672*r**12+154467753169050*r**14-11454531058110*r**16
            -131016848887824*r**18-78462401029543*r**20-13986129175791*r**22-2689193597751*r**24
            -192533886371*r**26+12737502006*r**28)-2*Q2**7*(114367637056+593628222865*r**2
            +1723282188225*r**4-243053186630475*r**6-1232494380465090*r**8-3962302061988391*r**10
            -6565381228547365*r**12-7833681313392155*r**14-4530107347089100*r**16
            -7070390084725*r**18+1110450582117879*r**20+481002653742215*r**22+74189357544270*r**24
            +2884772847115*r**26-160860718995*r**28+2137851871*r**30)+2*Q2**6*(-16215316768
            +1786466633117*r**2+20112245960130*r**4-57086440306480*r**6-119013468151015*r**8
            -2713754086858977*r**10-3947903530812832*r**12-6422364240096370*r**14
            -4913208916693485*r**16+372623823865675*r**18+2378659171938778*r**20+1513915920140628*r**22
            +380932533205615*r**24+54152867420665*r**26-3249488625660*r**28-711401102258*r**30
            +30446863237*r**32)-6*Q2**5*(-12688717368+187040902841*r**2+3076773410537*r**4
            +35241771811140*r**6+259090817632875*r**8+154080077085898*r**10+1420221060731009*r**12
            +744404468835048*r**14-299651146981525*r**16+376788648225120*r**18+297777340575043*r**20
            +83169643037284*r**22+117626689362633*r**24+3750677818110*r**26+2626894486355*r**28
            -292693896848*r**30-69210861159*r**32+2145663007*r**34)-10*Q2**4*(1395281568
            +68730035377*r**2+282032812574*r**4-20056670830281*r**6-109395979790403*r**8
            -338832777604929*r**10-1166289796838583*r**12-758588051753989*r**14+228392886022633*r**16
            -221436763694019*r**18-689801931885871*r**20-103221698019995*r**22+156747774299511*r**24
            +34582081267077*r**26+32567239495947*r**28+6256271338857*r**30-40958178749*r**32
            -43850698546*r**34+1569541821*r**36)+30*Q2**3*(-336807584+16433599309*r**2
            +152417966833*r**4-1050839287405*r**6+422363326036*r**8-60769675669428*r**10
            -22503541242376*r**12-57482839657156*r**14+85509954860756*r**16-114323133746658*r**18
            -428151246999422*r**20-351387580911190*r**22-254451558008612*r**24-27014771400532*r**26
            -7876843169712*r**28+3761959111084*r**30+1498519269532*r**32+29806365085*r**34
            -8729471419*r**36+212112859*r**38)+9*(-1+r**2)**2*(-14234768+1567142455*r**2
            +3259918375*r**4-510454238725*r**6-2488195949005*r**8-11601993771028*r**10
            -77821459484740*r**12+195754818669500*r**14-239296651587700*r**16-718462470892110*r**18
            +752436663809442*r**20+1004436623192490*r**22-752290468997750*r**24-292728623927300*r**26
            -156085798629140*r**28-48696997274228*r**30-4106473414580*r**32+286749667375*r**34
            +19374104975*r**36-1189547245*r**38+17043707*r**40)+6*Q2**2*(695001748
            -1047254465*r**2-202830006650*r**4-7497688260610*r**6-49563662172625*r**8
            +28689269922968*r**10-939921451492060*r**12+939149422752620*r**14-252901861963000*r**16
            -510690333903330*r**18+654683903093328*r**20-1004033977446360*r**22-2319486327627290*r**24
            -628397786481920*r**26-560347700578340*r**28-131947273639052*r**30-8521752132740*r**32
            +300630493195*r**34-17074304470*r**36-6140333830*r**38+256732883*r**40)
            -9*Q2*(5282524+7234394609*r**2-8637928870*r**4-2974117122990*r**6-12992527078010*r**8
            -21907225243931*r**10-359428473618056*r**12+928764246339160*r**14-780328968048080*r**16
            -1302660780600670*r**18+313940351552124*r**20+1926730376420364*r**22+1173409700239540*r**24
            -2001517309309870*r**26-702802268295880*r**28-418479921923176*r**30-134185064059996*r**32
            -11318580927955*r**34+1090096749690*r**36+61128805810*r**38-6268370666*r**40
            +129144329*r**42))-2304*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1022670848*Q2**23
            -512*Q2**22*(26831622+25209797*r**2)+32*Q2**21*(2480598917+4944537178*r**2
            +2248866517*r**4)-32*Q2**20*(7769757089+26142653896*r**2+24896758061*r**4
            +7284091574*r**6)+40*Q2**19*(10297988271+60017592337*r**2+91819209305*r**4
            +57579384003*r**6+12205616588*r**8)-Q2**18*(158490472052+3597343631935*r**2
            +7965493639140*r**4+8215631783550*r**6+4198585088520*r**8+704042582947*r**10)
            +4*Q2**17*(-186063878101+200571253774*r**2+493484949245*r**4+667628010120*r**6
            +1728293433985*r**8+1221096733754*r**10+183105716519*r**12)+Q2**16*(1474543751664
            +7562424524221*r**2+33585455846044*r**4+76486618242395*r**6+61070335523600*r**8
            +12157391936299*r**10-3137766055324*r**12-536369931331*r**14)+4*Q2**15*(
            -173314582592-3597972862963*r**2-21015016643738*r**4-69418271835707*r**6
            -91460703219670*r**8-52803887488417*r**10-11621545723798*r**12-90391098353*r**14
            +37500939398*r**16)+20*Q2**14*(-61737465676+411032184638*r**2+3452317611805*r**4
            +21321947493927*r**6+41576706635865*r**8+37931319665739*r**10+17597213095479*r**12
            +3623558637485*r**14+186283866847*r**16+12449253347*r**18)-4*Q2**13*(
            -490135769892-2467629105645*r**2-16215111257280*r**4+33359774880350*r**6
            +152766408159510*r**8+213283811852512*r**10+181455843057250*r**12+88581367196890*r**14
            +19479307613550*r**16+1415426099285*r**18+69290254718*r**20)-4*Q2**12*(113250552376
            +5245670839826*r**2+49598200723985*r**4+154970706083685*r**6+295508788064820*r**8
            +444736051593824*r**10+279279725858314*r**12-9651928052770*r**14-67823474230620*r**16
            -18734943826970*r**18-1418632041259*r**20+31739151461*r**22)+4*Q2**11*(
            -307165011764+2707507096709*r**2+34822990856926*r**4+273208075400635*r**6
            +832939693994070*r**8+1881775395104034*r**10+2151217276563236*r**12+1128093118018134*r**14
            +191079628828320*r**16-47186608987895*r**18-13830502461634*r**20-780867457601*r**22
            +94304454526*r**24)-2*Q2**10*(-536869294596-4364627217169*r**2-36868042403534*r**4
            +298856115194604*r**6+1320355070931370*r**8+5031744950616971*r**10+8438709827254484*r**12
            +6933438220903664*r**14+3030243664194896*r**16+618083452124045*r**18-11236658593606*r**20
            -603362948204*r**22+641517175626*r**24+57090198409*r**26)-20*Q2**9*(-4929147226
            +740350583623*r**2+9068345254890*r**4+23034783770472*r**6+80333667364128*r**8
            -79172502035869*r**10-442704809074236*r**12-549581462239080*r**14-415039229076282*r**16
            -229920230435891*r**18-76813168678366*r**20-10386826065120*r**22-2282693772300*r**24
            -183173626263*r**26+9625335472*r**28)+2*Q2**8*(-276839551936+2330984179885*r**2
            +41954266652090*r**4+501078858858225*r**6+2475208221965620*r**8+6265647708708401*r**10
            +8766017749570270*r**12+9528589587335765*r**14+5245173457643800*r**16
            -705286509644945*r**18-2157846831704714*r**20-943245304768885*r**22-157565971411980*r**24
            -17293410267725*r**26-738121202830*r**28+61549658159*r**30)+4*Q2**7*(49076160144
            +1247231246519*r**2+11214578185610*r**4-149208172374365*r**6-797280517623290*r**8
            -3954275264656229*r**10-7237793410674294*r**12-10410713391017945*r**14
            -8638498788587370*r**16-2082276956654075*r**18+1741019681985966*r**20
            +1552684578000361*r**22+468062272246050*r**24+65613498906025*r**26-262788248770*r**28
            -435061984691*r**30+16292357554*r**32)-4*Q2**6*(-27140734436+1165687012436*r**2
            +15564516412429*r**4+34375560543535*r**6+300586272220565*r**8-1185263661876149*r**10
            -1200497217739391*r**12-4068527182202029*r**14-6117263298867215*r**16
            -1705109574076225*r**18+1822307508764791*r**20+2071042010595629*r**22
            +1123864260717071*r**24+223168717040305*r**26+29392031127035*r**28-2419485709231*r**30
            -444293411249*r**32+18441926129*r**34)-4*Q2**5*(22521279972-89703189767*r**2
            -4190639438632*r**4-107619494908218*r**6-714988833642030*r**8-1466838286090482*r**10
            -5277176198821818*r**12-5143408423734058*r**14-96147767723702*r**16-669298161100440*r**18
            -2736353812914922*r**20-829474720468478*r**22+90674937148902*r**24-95610847603422*r**26
            +71851740283170*r**28+12139377462882*r**30+440461690138*r**32-9028949137*r**34
            +705360042*r**36)+20*Q2**4*(192429408+59713057436*r**2+404008374225*r**4
            -11463577939961*r**6-64092780321288*r**8-315268892201808*r**10-786316599085320*r**12
            -1048663183782020*r**14-136832650574544*r**16-168006639455680*r**18-1097846218289078*r**20
            -923593186319718*r**22-354914298873160*r**24+55142770682496*r**26+21759395626944*r**28
            +25054694084028*r**30+5355435484352*r**32+2305108980*r**34-34234785491*r**36
            +1102940199*r**38)-12*Q2**3*(-1189519834+40765606545*r**2+523543918680*r**4
            +1502790828875*r**6+23210641182890*r**8-165212915819964*r**10+261777683466520*r**12
            -669540663625140*r**14+196518718990500*r**16+183312219736910*r**18-1683527903411864*r**20
            -1446830081053350*r**22-354854683485860*r**24-389466930281900*r**26+192944813863560*r**28
            +55686426672956*r**30+17412072017910*r**32+3670498839945*r**34+61229386400*r**36
            -18223229485*r**38+401915706*r**40)-9*(-1+r**2)**2*(-14234768+1552907687*r**2
            +4827060830*r**4-507194320350*r**6-2998650187730*r**8-14090189720033*r**10
            -89423453255768*r**12+117933359184760*r**14-43541832918200*r**16-957759122479810*r**18
            +33974192917332*r**20+1756873287001932*r**22+252146154194740*r**24-1045019092925050*r**26
            -448814422556440*r**28-204782795903368*r**30-52803470688808*r**32-3819723747205*r**34
            +306123772350*r**36+18184557730*r**38-1172503538*r**40+17043707*r**42)
            -3*Q2**2*(1405851068+20998678393*r**2-433668308840*r**4-24323387903490*r**6
            -153100282100500*r**8-107470460231107*r**10-2900749783992352*r**12+2784748681538600*r**14
            -968491782565000*r**16-5435166733534670*r**18+1229808193036368*r**20+5081490980555028*r**22
            -3126811509428680*r**24-11900320156148030*r**26-4485897779008160*r**28
            -2640029714204312*r**30-683493243723572*r**32-50397986062955*r**34+3837402626520*r**36
            +136957140830*r**38-30572313892*r**40+900898753*r**42)+36*Q2*(-2238061
            +2208822281*r**2-323033891*r**4-874540496220*r**6-4357667938545*r**8
            -10508952108421*r**10-109610341688419*r**12+227282879147264*r**14-140048117530090*r**16
            -531776024423990*r**18+240336131239354*r**20+255442888163496*r**22+272853256271654*r**24
            +347045332047590*r**26-756809649344510*r**28-287634053540576*r**30-153865815869609*r**32
            -46425236441411*r**34-3722270705655*r**36+349509366420*r**38+19157669579*r**40
            -1840715249*r**42+36547009*r**44))*sqrtq2)+logq2*(-192*r**8*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7
            +2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(-12490496*Q2**21+32*Q2**20*(4888657+6425851*r**2)-8*Q2**19*(100610060
            +297968709*r**2+166236217*r**4)+24*Q2**18*(86885705+450927949*r**2+539900815*r**4
            +192163015*r**6)-Q2**17*(2245120380+22106935271*r**2+35963549837*r**4
            +33943255961*r**6+9408257399*r**8)+Q2**16*(-1884515656+6631690707*r**2
            -40886691348*r**4-16787071002*r**6+42056257916*r**8+11063066791*r**10)
            +Q2**15*(8601263784+62290191672*r**2+452677120546*r**4+807841344814*r**6
            +355305606318*r**8-5907002534*r**10-5958838200*r**12)-2*Q2**14*(4074028380
            +60696269302*r**2+502177921691*r**4+1527902223418*r**6+1432479169138*r**8
            +469874679974*r**10+27050868887*r**12+210884266*r**14)+Q2**13*(-4115807560
            +46330212252*r**2+592770577430*r**4+4833859833974*r**6+7332682122592*r**8
            +4928708163664*r**10+1354576991854*r**12+86443968670*r**14-753553820*r**16)
            +2*Q2**12*(7297393220+66109582584*r**2+673347039793*r**4-581099311154*r**6
            -1832565049605*r**8-2520348005812*r**10-2305337639849*r**12-704962905906*r**14
            -45613344071*r**16+3357235616*r**18)-2*Q2**11*(4033595228+93967782708*r**2
            +1412442097563*r**4+4304021029825*r**6+10915339492463*r**8+15325349202673*r**10
            +5870466225581*r**12-874217826589*r**14-572337444759*r**16-39976569481*r**18
            +3332879556*r**20)+2*Q2**10*(-3493996948+15103421586*r**2+671961150481*r**4
            +7369150375086*r**6+24935062070400*r**8+55970753053372*r**10+47012125615250*r**12
            +15380892186892*r**14+650915431836*r**16-189576648766*r**18-12666053931*r**20
            +121492534*r**22)+2*Q2**9*(5285604480+64324734987*r**2+883947026286*r**4
            -3470000688714*r**6-11475332050269*r**8-64964503321762*r**10-83687682433972*r**12
            -49176860846196*r**14-15828349223434*r**16-1394985660249*r**18-253495307082*r**20
            -18538785618*r**22+1484987511*r**24)-2*Q2**8*(885752820+52163535041*r**2
            +1342904949695*r**4+4627757535764*r**6+29882484188027*r**8+10310302827259*r**10
            -9556858510794*r**12-11239485599800*r**14-21616421189846*r**16-14081997055673*r**18
            -2046238540981*r**20-296087570332*r**22-11734991065*r**24+198630845*r**26)
            -2*Q2**7*(2273831620+3958587324*r**2-394714420707*r**4-7982318251437*r**6
            -45883709011721*r**8-92410965128939*r**10-115551558820650*r**12-115620604256146*r**14
            -19517003720190*r**16+30376522307222*r**18+18316290727001*r**20+2973720971583*r**22
            +41561644995*r**24-15854388071*r**26+932710196*r**28)+2*Q2**6*(1405705932
            +24524883918*r**2+490597331023*r**4-3282854758622*r**6-8442421329738*r**8
            -78517925504238*r**10-67732898186707*r**12-126103405431762*r**14-38209730405408*r**16
            +39413403649634*r**18+42635400090921*r**20+13091739326574*r**22+2163379348894*r**24
            -50097767490*r**26-16583377061*r**28+497489730*r**30)+2*Q2**5*(238283172
            -10061377394*r**2-477121334131*r**4-2670936912443*r**6-29940421396232*r**8
            +18344939093932*r**10-123144824577745*r**12+13783050159199*r**14+26493344924766*r**16
            -35845077828818*r**18+5902500051211*r**20-12367209539549*r**22+2327906226012*r**24
            +542750305432*r**26-4476074695*r**28-2220184135*r**30+177391018*r**32)
            -2*Q2**4*(492245860+2304677724*r**2-93094267523*r**4-3415001972882*r**6
            -23799385065757*r**8-9027870951836*r**10-177934284490739*r**12+17897818038418*r**14
            +88804480773859*r**16-111727807935256*r**18-27121013527953*r**20+30743836105106*r**22
            -3765491349247*r**24+5785879065748*r**26+1724243193863*r**28-1007878546*r**30
            -8184642091*r**32+224045252*r**34)+2*Q2**3*(105318140+2851354152*r**2
            +80300504075*r**4-842955390403*r**6-99925745169*r**8-18046793023623*r**10
            -22692407421041*r**12+31161641644785*r**14+41984473163251*r**16-125109035081587*r**18
            -60926241509319*r**20-87996403723289*r**22-2184818814755*r**24-7014975422373*r**26
            +991057040181*r**28+637132437227*r**30+15715958853*r**32-2070599305*r**34
            +30462200*r**36)+3*(-1+r**2)**2*(3227248+22798525*r**2-777202280*r**4
            -55716196535*r**6-365012043608*r**8+948581348636*r**10-14738792051720*r**12
            +47647726296220*r**14-71135882467640*r**16-27370554763746*r**18+139459612554984*r**20
            -70417807332010*r**22-2311339894600*r**24-8972090180740*r**26-3886960156184*r**28
            -524794536868*r**30+17216031080*r**32+1593350285*r**34-87652960*r**36
            +1591913*r**38)+2*Q2**2*(59494840-635381062*r**2-56051891769*r**4-609005776490*r**6
            -7133361924004*r**8+21811574272248*r**10-120161445633496*r**12+166179596080720*r**14
            -62265447051252*r**16-13346332750100*r**18-6797472684466*r**20-99377532469572*r**22
            -28896090109708*r**24-34344924267176*r**26-13440012253488*r**28-1614109287872*r**30
            +229189254380*r**32+1355343882*r**34-1438322957*r**36+36077342*r**38)
            -3*Q2*(22174252+30357709*r**2-9235479851*r**4-288986757007*r**6-2038261074187*r**8
            +8208181271948*r**10-66929617774612*r**12+186313843950908*r**14-208322105115724*r**16
            -68451543365874*r**18+179048535697854*r**20+84378818589222*r**22-103141166213138*r**24
            -21825471431156*r**26-21002577223316*r**28-11192889413060*r**30-1687553259944*r**32
            +114526397581*r**34+5792815637*r**36-584708623*r**38+11441381*r**40))
            +192*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(99923968*Q2**25-1536*Q2**24*(871699
            +1127898*r**2)+32*Q2**23*(232708423+675919630*r**2+374721095*r**4)-8*Q2**22*(2647961008
            +13523030883*r**2+16173101750*r**4+5590958115*r**6)+8*Q2**21*(3311469817
            +32019078570*r**2+56552192432*r**4+48287261206*r**6+12207600919*r**8)
            -Q2**20*(-15902411396+165388867133*r**2+44227812460*r**4+328505254330*r**6
            +586999224248*r**8+118706162089*r**10)+4*Q2**19*(-25389672961-151414169817*r**2
            -1005119336730*r**4-1796026054310*r**6-710170172545*r**8+66230286399*r**10
            +12352075868*r**12)+2*Q2**18*(56340640678+782458587435*r**2+5817466940260*r**4
            +17571417553605*r**6+16593553047830*r**8+5164603882053*r**10+284102711520*r**12
            +26746391755*r**14)-4*Q2**17*(-12121954439+242163847586*r**2+2673110678670*r**4
            +17679481144460*r**6+27644191758490*r**8+17911907312706*r**10+4375971999006*r**12
            +289263061840*r**14+10900061185*r**16)+Q2**16*(-222755586144-1597777745025*r**2
            -12293444995544*r**4+41721035422588*r**6+121780477915312*r**8+136221962659966*r**10
            +83181099548280*r**12+18372578111716*r**14+1111337160208*r**16-77255712093*r**18)
            +16*Q2**15*(8533172171+195837470757*r**2+2462583137355*r**4+6855609806940*r**6
            +14046693439407*r**8+19372621506558*r**10+5852055691667*r**12-2334528894740*r**14
            -771001338310*r**16-44297442923*r**18+7137144686*r**20)+8*Q2**14*(17298589502
            -121272813441*r**2-3418117559330*r**4-33603685814435*r**6-109630778849560*r**8
            -241890608552912*r**10-210410030129374*r**12-68165610871980*r**14-4204438728450*r**16
            +144710706705*r**18-9494435588*r**20+240383919*r**22)-16*Q2**13*(13837056174
            +149560155570*r**2+1510459960325*r**4-11731717916520*r**6-52957631101500*r**8
            -217114760564734*r**10-300568241804670*r**12-182389227317360*r**14-49210966727080*r**16
            -4375837143200*r**18-614123282451*r**20-56142290620*r**22+5412623170*r**24)
            +2*Q2**12*(9835881308+1274249074683*r**2+25847912216020*r**4+81451443159770*r**6
            +317068144339880*r**8-716307195350383*r**10-2202898785357968*r**12-2164540830387860*r**14
            -1225639236491900*r**16-352942658284715*r**18-40883056788132*r**20-4935695053622*r**22
            -254232683560*r**24+12761338895*r**26)+8*Q2**11*(17893097777+12976451005*r**2
            -2326695671788*r**4-50940869531494*r**6-258900239114771*r**8-566465008064357*r**10
            -709965291520800*r**12-787495095498012*r**14-216672146848661*r**16+157250254949971*r**18
            +84045314353572*r**20+13680045233810*r**22-15713151673*r**24-99181322939*r**26
            +6525084824*r**28)-4*Q2**10*(19368780566+406903318647*r**2+6606621211320*r**4
            -53371438381415*r**6-304504801674358*r**8-2118044084489893*r**10-4581905874348272*r**12
            -8314070756145155*r**14-6741327153128710*r**16-2012342770177267*r**18
            +141971112484552*r**20+118433135607827*r**22+21439343315110*r**24-1268655547615*r**26
            -233691376848*r**28+8359372631*r**30)-8*Q2**9*(5295675043-98781161334*r**2
            -3499063519880*r**4-22656699951960*r**6-124711914479500*r**8+619263139492162*r**10
            +1574100774867064*r**12+5592457821424380*r**14+7076872919509030*r**16
            +3995570090597790*r**18+1150329552508792*r**20+40633612106544*r**22+20688122205820*r**24
            +4444590839510*r**26+216767024280*r**28-23558109972*r**30+2081185351*r**32)
            +2*Q2**8*(24924643928+174666842995*r**2-561810635160*r**4-141457171831760*r**6
            -814574591218240*r**8-1795356671658928*r**10-7419043181447600*r**12+678000093808840*r**14
            +10554734462969400*r**16+7181818412089550*r**18+5999833429784072*r**20
            +3756818403583040*r**22+691727143546320*r**24+236429531036680*r**26+50363141386560*r**28
            -203278710072*r**30-318745376800*r**32+9910550375*r**34)+16*Q2**7*(-1988359
            -28013378559*r**2-741580310065*r**4+3968772507320*r**6+28198081395335*r**8
            +538549797427644*r**10+1816653573041559*r**12+3673609081527040*r**14+4161666247104925*r**16
            +4213540798339190*r**18+1355034834069489*r**20-717675629754536*r**22-624885984615155*r**24
            -148540504782500*r**26-11975885929635*r**28-1306476819984*r**30+7496691926*r**32
            +4477900145*r**34+91923020*r**36)-16*Q2**6*(1014552509-4267997055*r**2
            -343145718276*r**4-6574991254878*r**6-27958905562062*r**8+302007251337521*r**10
            +443709401002175*r**12+3756411758279561*r**14+3703552437308098*r**16+4716003600334167*r**18
            +2076450304075561*r**20-1359277125046335*r**22-1762668419370654*r**24
            -631477299260757*r**26-156628169835023*r**28-4351466268341*r**30+3047202819565*r**32
            +48263508044*r**34-17265670613*r**36+458542793*r**38)+8*Q2**5*(545417487
            +11735969234*r**2+188475526170*r**4-9066408142390*r**6-47515208247551*r**8
            -286454121555884*r**10-2122457643532464*r**12+1889371129524040*r**14-7386583892940510*r**16
            -1650626350448384*r**18+2437561693042524*r**20-1227960680823724*r**22
            -828575454704090*r**24-1338890649617860*r**26-101993056169104*r**28-64426532328744*r**30
            -12312463547521*r**32+2610999312030*r**34+103294974410*r**36-12305946686*r**38
            +185759017*r**40)+Q2**4*(2611380836-48306455673*r**2-1884822589980*r**4
            -4214922999210*r**6+103386605213160*r**8+4081296519965871*r**10+12115218735026432*r**12
            +17980766847043080*r**14+102006796502916840*r**16+6682251915294910*r**18
            -54931561815684504*r**20+48080729110621092*r**22+7164203993148080*r**24
            -18262839530713050*r**26-1020131756661600*r**28-3027816949296824*r**30
            -1171910402191788*r**32-48788330840805*r**34+12426843558420*r**36+199533327030*r**38
            -59555688504*r**40+1388106187*r**42)-12*Q2**3*(115563747+51327075*r**2
            -24350565830*r**4-1515903705270*r**6-751244988485*r**8+96677882006687*r**10
            -113382941060820*r**12+1910353091321000*r**14+327925693153190*r**16-1966494078198090*r**18
            -1378719041417668*r**20+6396492358423500*r**22+5201427528759630*r**24
            +5001889886553030*r**26+933163877964160*r**28+477121647095112*r**30+36559644960535*r**32
            -52235655946265*r**34-8813192002950*r**36+589734167290*r**38+36821308247*r**40
            -3038904165*r**42+50506340*r**44)-9*(-1+r**2)**2*(3227248-22382947*r**2
            -1399742942*r**4-47023607437*r**6+487755770100*r**8+11306976063883*r**10
            +7071450715738*r**12+169878620662493*r**14+633597251322448*r**16-3303062801988750*r**18
            +6527613371006788*r**20+1593529845533518*r**22-11813613733190152*r**24
            +4662855427019078*r**26+1464297167669700*r**28+859210075831658*r**30+496036516864288*r**32
            +94536607386593*r**34+1819461881498*r**36-914365165425*r**38+3126218548*r**40
            +2670851903*r**42-109939742*r**44+1591913*r**46)-6*Q2**2*(14938094-1201947081*r**2
            -35155523780*r**4+704785660025*r**6+5646209263110*r**8+123266284685869*r**10
            +518130676449264*r**12-1643846862340365*r**14+11635584033720060*r**16
            -14241854885855770*r**18-1162563908841336*r**20+5171623638885754*r**22
            +4949497286866460*r**24+11106239046623130*r**26+1322274092062960*r**28
            +3464436470843814*r**30+1209202055466774*r**32+126300934995795*r**34-12316870045540*r**36
            +1546947575325*r**38+212331027934*r**40-6339814711*r**42-558039360*r**44
            +13343575*r**46)+36*Q2*(4736751-65231530*r**2-2677502834*r**4-29388461412*r**6
            +631270521042*r**8+14755598642166*r**10+11474481636870*r**12+33256933383096*r**14
            +1052266190972193*r**16-3749956782922068*r**18+4409588190540796*r**20
            +2703649240502120*r**22-5148902631836484*r**24-2554711863888932*r**26
            +2894478448700252*r**28+723324254338656*r**30+629877509768145*r**32+321729981368766*r**34
            +64320913917558*r**36-394132938468*r**38-774173716494*r**40+23189916270*r**42
            +2537826206*r**44-159135032*r**46+2462367*r**48))*sqrtq2))/(1008000*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2
            +1008000*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2
            +logq2**7*(-8126654054400000*r**32*(1+r**2)**2*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3-8126654054400000*r**32*(1+r**2)**2*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**6*(45148078080000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))+45148078080000*r**28*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))*sqrtq2)+logq2*(-60480000*(-Q2
            +(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(9+8*Q2**4-78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)
            -Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-60480000*(-Q2+(-1+r)**2)**3*r**8*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(9+8*Q2**4-78*r**2-366*r**4
            -78*r**6+9*r**8-Q2**3*(1+r**2)-Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1
            +13*r**2+13*r**4+r**6))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*sqrtq2)+logq2**2*(725760000*(-Q2+(-1+r)**2)**3*r**12*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531
            +550*r**2+531*r**4)-2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815
            -2120*r**2-11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4
            +494*r**6+225*r**8+r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6
            +26793*r**8+4554*r**10-501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6
            -1385*r**8-311*r**10+15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6
            +34670*r**8+13388*r**10-184*r**12-316*r**14+17*r**16))+725760000*(
            -Q2+(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531+550*r**2+531*r**4)
            -2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815-2120*r**2-11502*r**4
            -2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4+494*r**6+225*r**8
            +r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6+26793*r**8+4554*r**10
            -501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6-1385*r**8-311*r**10
            +15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6+34670*r**8+13388*r**10
            -184*r**12-316*r**14+17*r**16))*sqrtq2)+logq2**3*(-8709120000*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8+256*Q2**7*(1+r**2)
            -Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2+893*r**4+319*r**6)
            +Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)+12*Q2**3*(61
            +235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(-1071+9654*r**2
            +51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)-18*Q2*(23
            -35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12+23*r**14)
            +9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10-264*r**12
            -756*r**14+47*r**16))-8709120000*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8
            +256*Q2**7*(1+r**2)-Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2
            +893*r**4+319*r**6)+Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)
            +12*Q2**3*(61+235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(
            -1071+9654*r**2+51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)
            -18*Q2*(23-35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12
            +23*r**14)+9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10
            -264*r**12-756*r**14+47*r**16))*sqrtq2)+logq2**4*(104509440000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513+770*r**2
            +513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105-3400*r**2
            -11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4-1178*r**6
            +75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6+19593*r**8
            +3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6-5785*r**8
            -2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4+25204*r**6
            +52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))+104509440000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513
            +770*r**2+513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105
            -3400*r**2-11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4
            -1178*r**6+75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6
            +19593*r**8+3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6
            -5785*r**8-2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4
            +25204*r**6+52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))*sqrtq2)
            +logq2**5*(-250822656000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(64*Q2**8+1088*Q2**7*(1+r**2)+Q2**6*(-63+130*r**2-63*r**4)
            -2*Q2**5*(2777+6379*r**2+6379*r**4+2777*r**6)+Q2**4*(1555-8080*r**2
            -22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743-315*r**2-6548*r**4-6548*r**6
            -315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2+199629*r**4+305844*r**6
            +199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83-375*r**2-2833*r**4
            -5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)+9*(301-4028*r**2
            +808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12-4028*r**14+301*r**16))
            -250822656000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(64*Q2**8+1088*Q2**7*(1
            +r**2)+Q2**6*(-63+130*r**2-63*r**4)-2*Q2**5*(2777+6379*r**2+6379*r**4
            +2777*r**6)+Q2**4*(1555-8080*r**2-22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743
            -315*r**2-6548*r**4-6548*r**6-315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2
            +199629*r**4+305844*r**6+199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83
            -375*r**2-2833*r**4-5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)
            +9*(301-4028*r**2+808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12
            -4028*r**14+301*r**16))*sqrtq2))+((-4*(Q2-(-1+r)**2)**4*r**4*(Q2-(1
            +r)**2)**4*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(-1059
            +24*Q2**14-322322*r**2-93757*r**4-25369844*r**6+127046277*r**8-457228062*r**10
            +815729139*r**12-694656216*r**14+236289183*r**16-15296334*r**18+10159121*r**20
            +3791308*r**22-43777*r**24-3714*r**26+57*r**28+56*Q2**13*(1+r**2)+Q2**12*(1627
            +3446*r**2-1457*r**4)+4*Q2**11*(-3797-54679*r**2-8387*r**4+1615*r**6)
            +4*Q2**10*(11639+338572*r**2+403567*r**4+30654*r**6-3472*r**8)+4*Q2**9*(
            -15387-727340*r**2-2055110*r**4-1044380*r**6-54495*r**8+4008*r**10)
            +Q2**8*(15423+1013978*r**2+12323485*r**4+13564420*r**6+3813345*r**8
            +170178*r**10-8157*r**12)-8*Q2**7*(-6327-651616*r**2-542973*r**4-1778395*r**6
            +98905*r**8-203412*r**10-2181*r**12+207*r**14)+8*Q2**6*(-5943-891191*r**2
            -3383193*r**4-11587780*r**6-10153075*r**8-1572643*r**10-622461*r**12
            -13398*r**14+420*r**16)+8*Q2**5*(-1284+8398*r**2+2312708*r**4+9155691*r**6
            +23311392*r**8+6859881*r**10+797988*r**12+185973*r**14+1356*r**16+57*r**18)
            +Q2**4*(34249+5785410*r**2+7369665*r**4+88484320*r**6-138504270*r**8
            -44549788*r**10+15777210*r**12-6455760*r**14+2109045*r**16+71530*r**18
            -1931*r**20)+4*Q2**3*(-3001-818121*r**2-3167815*r**4-34632105*r**6+13941570*r**8
            -19084558*r**10+6052382*r**12+3025010*r**14+3050295*r**16-323305*r**18
            -8471*r**20+119*r**22)+4*Q2**2*(-1567-223806*r**2+930087*r**4+2175310*r**6
            +12132160*r**8+4033124*r**10-13722438*r**12-13803764*r**14-5884315*r**16
            -87590*r**18-58337*r**20-4186*r**22+122*r**24)-4*Q2*(-1333-327586*r**2
            -53198*r**4-15606570*r**6+50223425*r**8-85305484*r**10+38454012*r**12
            +5455156*r**14+2058365*r**16+2960350*r**18+2220242*r**20-73226*r**22
            -4233*r**24+80*r**26))+4*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(192*Q2**19
            +88*Q2**18*(1+r**2)-16*Q2**17*(-761-1642*r**2+781*r**4)+Q2**16*(-145669
            -1825599*r**2-297995*r**4+73775*r**6)+4*Q2**15*(150207+3591900*r**2
            +4186230*r**4+340660*r**6-51861*r**8)+2*Q2**14*(-587263-22270690*r**2
            -56976461*r**4-30027301*r**6-1597940*r**8+160967*r**10)+4*Q2**13*(223639
            +12910234*r**2+73261216*r**4+81644768*r**6+24316527*r**8+917894*r**10
            -60326*r**12)-2*Q2**12*(-317131-18876162*r**2+114185636*r**4+219020933*r**6
            +179282069*r**8+19229600*r**10+281938*r**12+12701*r**14)+4*Q2**11*(-427377
            -40901932*r**2-95582026*r**4-235832836*r**6-191728516*r**8-18524260*r**10
            -23734310*r**12-833580*r**14+48165*r**16)+Q2**10*(645546+117202740*r**2
            +950023122*r**4+3458598670*r**6+6480987254*r**8+3090309622*r**10+555687430*r**12
            +116673738*r**14+2445960*r**16-86658*r**18)-4*Q2**9*(-279719-25380890*r**2
            +140458404*r**4+715979284*r**6+3392656990*r**8+3213841264*r**10+899717980*r**12
            +147373004*r**14-4363551*r**16-513590*r**18+21736*r**20)+2*Q2**8*(-565738
            -93325493*r**2-216617569*r**4-1312661502*r**6+4253144032*r**8+7526070378*r**10
            +4624178418*r**12+588840656*r**14+170257418*r**16-48534133*r**18-1641233*r**20
            +45422*r**22)+4*Q2**7*(-31163+7629684*r**2+211851218*r**4+1591348508*r**6
            +3260448139*r**8+4797578744*r**10+4261569596*r**12+998967992*r**14+339887083*r**16
            +10756724*r**18+7392018*r**20+68684*r**22+1573*r**24)-2*Q2**6*(-310899
            -50182914*r**2+196567371*r**4+1356019711*r**6+14011017886*r**8+28406379147*r**10
            +47692110982*r**12+23534560726*r**14+5007634041*r**16+777053636*r**18
            +209461039*r**20-18156501*r**22-801700*r**24+19635*r**26)+4*Q2**5*(-44419
            -13953970*r**2-51425816*r**4-710056600*r**6+3395263571*r**8+3934803926*r**10
            +29948143010*r**12+22670582320*r**14+5991109955*r**16+1165588042*r**18
            +98177028*r**20+79097960*r**22-5399059*r**24-153710*r**26+2162*r**28)
            +2*Q2**4*(-74771-9858590*r**2+173066644*r**4+1579897069*r**6+6085393995*r**8
            +27876860036*r**10-14689327610*r**12-21487760013*r**14-5085336893*r**16
            -1532121230*r**18-1709875624*r**20-14947725*r**22+49489669*r**24-2377176*r**26
            -213490*r**28+4909*r**30)-4*Q2**3*(-22333-5590428*r**2+30318494*r**4
            +103450092*r**6+3947265218*r**8+9973666948*r**10+13322010758*r**12+2238290812*r**14
            +1101385656*r**16-6233169716*r**18-3689404902*r**20-1239105212*r**22
            -61818306*r**24+47410252*r**26-1303102*r**28-73388*r**30+1157*r**32)
            -2*Q2**2*(-4107+408166*r**2+28432177*r**4+350402083*r**6-1139137991*r**8
            +6331072423*r**10-37591020251*r**12+32929105263*r**14-5509203441*r**16
            +4305412287*r**18+19284105635*r**20+2214797369*r**22-285387037*r**24
            -7830667*r**26-9379321*r**28+132149*r**30-17184*r**32+447*r**34)+12*Q2*(
            -1333-309198*r**2+4690768*r**4+26504868*r**6+321630628*r**8+1287006892*r**10
            -4395066128*r**12+10784577284*r**14-9208651006*r**16+7844999744*r**18
            -4976184960*r**20-574534900*r**22-751218972*r**24-346607692*r**26-20537872*r**28
            +3731276*r**30-24149*r**32-5330*r**34+80*r**36)-3*(-1059-308555*r**2
            +4210801*r**4+10774145*r**6+501804548*r**8+645428372*r**10-4220464300*r**12
            +24690211972*r**14-31128267770*r**16-10091920314*r**18+38650944158*r**20
            -14149245010*r**22-3260927372*r**24-1070939420*r**26-552049916*r**28
            -33999596*r**30+4755365*r**32-1651*r**34-4455*r**36+57*r**38))*sqrtq2
            +logq2**5*(13063680000*(-Q2+(-1+r)**2)*(-1+r)*r**24*(1+r)*(1+r**2)*(1
            -Q2+r**2)*(1+3*r**2)*(-Q2+(1+r)**2)+13063680000*r**24*(-1-3*r**2
            +r**4+3*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**4*(10368000*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(480*Q2**6*(1+r**2)-240*Q2**5*(12+17*r**2
            +5*r**4)-8*Q2**4*(-837-1483*r**2-503*r**4+171*r**6)+Q2**3*(-6324-14275*r**2
            -4737*r**4+7411*r**6+4197*r**8)+Q2**2*(-864+5213*r**2+3876*r**4-10278*r**6
            -7268*r**8+1257*r**10)-3*Q2*(-1812-611*r**2+1987*r**4+340*r**6-2976*r**8
            +271*r**10+2801*r**12)+3*(-848+75*r**2+908*r**4-4783*r**6-1808*r**8
            +3925*r**10+852*r**12+1679*r**14))+10368000*r**18*(-480*Q2**9*(1+r**2)
            +240*Q2**8*(18+29*r**2+11*r**4)-8*Q2**7*(2097+4393*r**2+2783*r**4+459*r**6)
            +7*Q2**6*(5076+12565*r**2+10263*r**4+2171*r**6-603*r**8)+2*Q2**5*(-20538
            -58597*r**2-55520*r**4-9418*r**6+14938*r**8+7119*r**10)-5*Q2**4*(-3528
            -14371*r**2-16085*r**4-264*r**6+13112*r**8+8491*r**10+357*r**12)+3*(
            -1+r**2)**3*(848+1621*r**2+638*r**4+4513*r**6+11104*r**8+8987*r**10
            +4210*r**12+1679*r**14)-4*Q2**3*(-3780+70*r**2+4677*r**4-5237*r**6
            -11782*r**8-9456*r**10+1925*r**12+7455*r**14)+Q2**2*(-24804-17251*r**2
            +6283*r**4-45623*r**6-61833*r**8+29375*r**10+38777*r**12+33499*r**14
            +41577*r**16)-6*Q2*(-2178-135*r**2+2370*r**4-7578*r**6-9090*r**8-648*r**10
            +5414*r**12+6234*r**14+1692*r**16+3919*r**18))*sqrtq2)+logq2**3*(345600*r**14*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-640*Q2**10+80*Q2**9*(109
            +81*r**2)-4*Q2**8*(10744+17565*r**2+6629*r**4)+4*Q2**7*(24047+67087*r**2
            +55577*r**4+13937*r**6)-Q2**6*(78778+441405*r**2+587331*r**4+300955*r**6
            +60123*r**8)+2*Q2**5*(-29057+100006*r**2+207494*r**4+162424*r**6+61691*r**8
            +16898*r**10)+Q2**4*(153860+296465*r**2+664749*r**4+542330*r**6-31266*r**8
            -47435*r**10-16975*r**12)+8*Q2**3*(-9293-50490*r**2-150185*r**4-148772*r**6
            +24933*r**8+80570*r**10+26545*r**12+612*r**14)+Q2**2*(-39058+131617*r**2
            +206511*r**4+593941*r**6-348657*r**8-1148689*r**10-284079*r**12-97573*r**14
            +18307*r**16)-6*Q2*(-7893-6060*r**2-116040*r**4+16620*r**6+110278*r**8
            -131432*r**10-66960*r**12+171020*r**14+26855*r**16+3612*r**18)+3*(
            -4072-7899*r**2-124223*r**4+73288*r**6+12024*r**8-157026*r**10+1734*r**12
            -80392*r**14+247472*r**16+36861*r**18+2233*r**20))-345600*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(640*Q2**10-80*Q2**9*(109+81*r**2)+4*Q2**8*(10744
            +17565*r**2+6629*r**4)-4*Q2**7*(24047+67087*r**2+55577*r**4+13937*r**6)
            +Q2**6*(78778+441405*r**2+587331*r**4+300955*r**6+60123*r**8)-2*Q2**5*(
            -29057+100006*r**2+207494*r**4+162424*r**6+61691*r**8+16898*r**10)
            +Q2**4*(-153860-296465*r**2-664749*r**4-542330*r**6+31266*r**8+47435*r**10
            +16975*r**12)-8*Q2**3*(-9293-50490*r**2-150185*r**4-148772*r**6+24933*r**8
            +80570*r**10+26545*r**12+612*r**14)+Q2**2*(39058-131617*r**2-206511*r**4
            -593941*r**6+348657*r**8+1148689*r**10+284079*r**12+97573*r**14-18307*r**16)
            +6*Q2*(-7893-6060*r**2-116040*r**4+16620*r**6+110278*r**8-131432*r**10
            -66960*r**12+171020*r**14+26855*r**16+3612*r**18)-3*(-4072-7899*r**2
            -124223*r**4+73288*r**6+12024*r**8-157026*r**10+1734*r**12-80392*r**14
            +247472*r**16+36861*r**18+2233*r**20))*sqrtq2)+logq2**2*(-5760*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(11520*Q2**13-16*Q2**12*(6129+5467*r**2)
            +4*Q2**11*(81472+162683*r**2+68411*r**4)-4*Q2**10*(115431+488576*r**2
            +445435*r**4+107538*r**6)+5*Q2**9*(2286+525503*r**2+836313*r**4+485409*r**6
            +63513*r**8)-5*Q2**8*(-156696+37219*r**2-31124*r**4+156518*r**6+255372*r**8
            +4311*r**10)-2*Q2**7*(395556+2230843*r**2+9881570*r**4+14718735*r**6
            +6476095*r**8+461006*r**10+81363*r**12)+2*Q2**6*(-57588+2859143*r**2
            +16754391*r**4+43245765*r**6+36028570*r**8+10679877*r**10+969843*r**12
            +94431*r**14)-2*Q2**5*(-311994+477316*r**2+2545855*r**4+38935933*r**6
            +53179760*r**8+24313856*r**10+5004941*r**12+668895*r**14+47838*r**16)
            -10*Q2**4*(26328+392144*r**2+3683419*r**4+2309292*r**6-100423*r**8-798008*r**10
            -202923*r**12-290236*r**14-70913*r**16+7224*r**18)+10*Q2**3*(-11460
            +312497*r**2+3011748*r**4+7592889*r**6+9993411*r**8+4134399*r**10-3077805*r**12
            -3372825*r**14-830991*r**16-33744*r**18+11161*r**20)+2*Q2**2*(51538
            +83929*r**2+2099095*r**4-19815615*r**6-13787040*r**8-9064446*r**10+33675702*r**12
            +33703410*r**14+16351470*r**16+431045*r**18-179437*r**20-4051*r**22)
            -3*Q2*(3854+351281*r**2+4245317*r**4-2508915*r**6+22869135*r**8-11047218*r**10
            +3415638*r**12+21190806*r**14-28658760*r**16-6759935*r**18-2912411*r**20
            -202019*r**22+13227*r**24)+3*(-1288+110037*r**2+1257150*r**4-375994*r**6
            +15437670*r**8-7418889*r**10-19279324*r**12+10397140*r**14+33625068*r**16
            -26364045*r**18-5865698*r**20-1453338*r**22-73290*r**24+4801*r**26))
            +5760*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(11520*Q2**14-16*Q2**13*(6849
            +6187*r**2)+4*Q2**12*(105988+209067*r**2+90279*r**4)-4*Q2**11*(196903
            +732731*r**2+676529*r**4+175949*r**6)+Q2**10*(473154+5043543*r**2+7917609*r**4
            +4638937*r**6+747717*r**8)-10*Q2**9*(-77205+282504*r**2+665346*r**4
            +739120*r**6+402147*r**8+33912*r**10)-Q2**8*(1574592+5059071*r**2+19732665*r**4
            +28810500*r**6+10892740*r**8-376403*r**10+141171*r**12)+4*Q2**7*(168984
            +2742771*r**2+14433402*r**4+33923035*r**6+28611700*r**8+8808489*r**10
            +756106*r**12+87897*r**14)-2*Q2**6*(-369582+3278871*r**2+22159389*r**4
            +98936089*r**6+132454095*r**8+71022303*r**10+16654661*r**12+1733169*r**14
            +142269*r**16)+4*Q2**5*(-221817-897699*r**2-7696962*r**4+14967664*r**6
            +46308904*r**8+40741828*r**10+15166706*r**12+3562508*r**14+535649*r**16
            +5859*r**18)+10*Q2**4*(14868+730969*r**2+7087311*r**4+13585600*r**6
            +12202280*r**8+3235968*r**10-4078736*r**12-3865984*r**14-1192140*r**16
            -97433*r**18+18385*r**20)-4*Q2**3*(-54419+710628*r**2+7261065*r**4+36419400*r**6
            +50859270*r**8+39851748*r**10-14196366*r**12-32978280*r**14-18685275*r**16
            -2377360*r**18+33261*r**20+29928*r**22)-Q2**2*(114638+1324777*r**2+17101999*r**4
            -42959785*r**6+1402095*r**8-78844626*r**10+59469426*r**12+198330642*r**14
            +14133480*r**16+13285225*r**18-8234017*r**20-973033*r**22+31579*r**24)
            +6*Q2*(1283+232586*r**2+2926874*r**4+680204*r**6+17898945*r**8+2201514*r**10
            -13455452*r**12+17501792*r**14+13078557*r**16-30891370*r**18-7769022*r**20
            -2283884*r**22-131041*r**24+9014*r**26)-3*(-1288+108749*r**2+1367187*r**4
            +881156*r**6+15061676*r**8+8018781*r**10-26698213*r**12-8882184*r**14
            +44022208*r**16+7261023*r**18-32229743*r**20-7319036*r**22-1526628*r**24
            -68489*r**26+4801*r**28))*sqrtq2)+logq2*(48*r**6*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-24832*Q2**16+32*Q2**15*(7391+8831*r**2)
            -8*Q2**14*(105120+310747*r**2+147195*r**4)+8*Q2**13*(149925+949863*r**2
            +1071463*r**4+279085*r**6)-Q2**12*(-269140+7147001*r**2+11059123*r**4
            +11171351*r**6+1391025*r**8)-4*Q2**11*(730411+2738804*r**2+12969654*r**4
            +10560284*r**6+330159*r**8+414176*r**10)+2*Q2**10*(1319262+15299499*r**2
            +92391625*r**4+176075950*r**6+77432240*r**8+8996279*r**10+1413177*r**12)
            +4*Q2**9*(365205-4054812*r**2-43791325*r**4-205409750*r**6-190977325*r**8
            -47505400*r**10-4236587*r**12+33930*r**14)+Q2**8*(-3625800-20966583*r**2
            -124396393*r**4+638600425*r**6+1143100575*r**8+659131035*r**10+85605557*r**12
            +5002867*r**14-2632035*r**16)+8*Q2**7*(113165+3632844*r**2+46580062*r**4
            +87545574*r**6+158298110*r**8+127385300*r**10+18149174*r**12+4626662*r**14
            +319169*r**16+139700*r**18)+4*Q2**6*(461246-828817*r**2-48003727*r**4
            -467276692*r**6-1374332532*r**8-2141159326*r**10-1024048542*r**12-170495852*r**14
            -23969242*r**16-1959057*r**18+264701*r**20)-8*Q2**5*(146598+1671809*r**2
            +18659510*r**4-133478905*r**6-437240570*r**8-1593563812*r**10-1271910682*r**12
            -335013240*r**14-39908980*r**16-9947845*r**18-886356*r**20+102873*r**22)
            -Q2**4*(340860-7395849*r**2-202457835*r**4-790689275*r**6-4645644325*r**8
            +2616114550*r**10+5891720898*r**12+434581850*r**14+114198850*r**16+95382675*r**18
            +4007465*r**20-1807199*r**22+178535*r**24)+4*Q2**3*(113225+229076*r**2
            -10748334*r**4-296233120*r**6-1492129325*r**8-1620955560*r**10-911801092*r**12
            -425924192*r**14+471635775*r**16+368745300*r**18+91618610*r**20-9485184*r**22
            -1294299*r**24+69120*r**26)-2*Q2**2*(12730+944813*r**2+21319199*r**4
            -99536842*r**6-5148760*r**8-2804453825*r**10-442052871*r**12+375339252*r**14
            +3068697954*r**16+2909071835*r**18+412512145*r**20+54726358*r**22-7406276*r**24
            -383687*r**26+5975*r**28)-12*Q2*(6209-44832*r**2-2222177*r**4-25078142*r**6
            -178749747*r**8+365365296*r**10-712704661*r**12+20753954*r**14-240045341*r**16
            +569882944*r**18+66295181*r**20+112256118*r**22+24862223*r**24-461392*r**26
            -119447*r**28+3814*r**30)+3*(6416-13331*r**2-1506565*r**4-40930255*r**6
            -210248305*r**8+628651937*r**10-3432125417*r**12+3719437205*r**14+2909531835*r**16
            -7282941065*r**18+2875929953*r**20+542905027*r**22+237587485*r**24+54892795*r**26
            -1008755*r**28-172681*r**30+3721*r**32))-48*r**6*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(24832*Q2**16-32*Q2**15*(7391+8831*r**2)+8*Q2**14*(105120
            +310747*r**2+147195*r**4)-8*Q2**13*(149925+949863*r**2+1071463*r**4
            +279085*r**6)+Q2**12*(-269140+7147001*r**2+11059123*r**4+11171351*r**6
            +1391025*r**8)+4*Q2**11*(730411+2738804*r**2+12969654*r**4+10560284*r**6
            +330159*r**8+414176*r**10)-2*Q2**10*(1319262+15299499*r**2+92391625*r**4
            +176075950*r**6+77432240*r**8+8996279*r**10+1413177*r**12)-4*Q2**9*(365205
            -4054812*r**2-43791325*r**4-205409750*r**6-190977325*r**8-47505400*r**10
            -4236587*r**12+33930*r**14)+Q2**8*(3625800+20966583*r**2+124396393*r**4
            -638600425*r**6-1143100575*r**8-659131035*r**10-85605557*r**12-5002867*r**14
            +2632035*r**16)-8*Q2**7*(113165+3632844*r**2+46580062*r**4+87545574*r**6
            +158298110*r**8+127385300*r**10+18149174*r**12+4626662*r**14+319169*r**16
            +139700*r**18)+4*Q2**6*(-461246+828817*r**2+48003727*r**4+467276692*r**6
            +1374332532*r**8+2141159326*r**10+1024048542*r**12+170495852*r**14+23969242*r**16
            +1959057*r**18-264701*r**20)+8*Q2**5*(146598+1671809*r**2+18659510*r**4
            -133478905*r**6-437240570*r**8-1593563812*r**10-1271910682*r**12-335013240*r**14
            -39908980*r**16-9947845*r**18-886356*r**20+102873*r**22)+Q2**4*(340860
            -7395849*r**2-202457835*r**4-790689275*r**6-4645644325*r**8+2616114550*r**10
            +5891720898*r**12+434581850*r**14+114198850*r**16+95382675*r**18+4007465*r**20
            -1807199*r**22+178535*r**24)-4*Q2**3*(113225+229076*r**2-10748334*r**4
            -296233120*r**6-1492129325*r**8-1620955560*r**10-911801092*r**12-425924192*r**14
            +471635775*r**16+368745300*r**18+91618610*r**20-9485184*r**22-1294299*r**24
            +69120*r**26)+2*Q2**2*(12730+944813*r**2+21319199*r**4-99536842*r**6
            -5148760*r**8-2804453825*r**10-442052871*r**12+375339252*r**14+3068697954*r**16
            +2909071835*r**18+412512145*r**20+54726358*r**22-7406276*r**24-383687*r**26
            +5975*r**28)+12*Q2*(6209-44832*r**2-2222177*r**4-25078142*r**6-178749747*r**8
            +365365296*r**10-712704661*r**12+20753954*r**14-240045341*r**16+569882944*r**18
            +66295181*r**20+112256118*r**22+24862223*r**24-461392*r**26-119447*r**28
            +3814*r**30)-3*(6416-13331*r**2-1506565*r**4-40930255*r**6-210248305*r**8
            +628651937*r**10-3432125417*r**12+3719437205*r**14+2909531835*r**16-7282941065*r**18
            +2875929953*r**20+542905027*r**22+237587485*r**24+54892795*r**26-1008755*r**28
            -172681*r**30+3721*r**32))*sqrtq2))*math.log(mus))/(-840*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))-840*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2+logq2**5*(-3135283200*r**22*(1+r**2)*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            +3135283200*r**22*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**2*(-725760*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8+3*Q2**3*(1
            +r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4+7*r**6))
            -725760*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8
            +3*Q2**3*(1+r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4
            +7*r**6))*sqrtq2)+logq2**3*(2903040*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))+2903040*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))*sqrtq2)+logq2**4*(-17418240*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(63+8*Q2**4-402*r**2
            -1122*r**4-402*r**6+63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)
            -3*Q2*(19+31*r**2+31*r**4+19*r**6))-17418240*(-Q2+(-1+r)**2)*r**18*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(63+8*Q2**4-402*r**2-1122*r**4-402*r**6
            +63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)-3*Q2*(19+31*r**2
            +31*r**4+19*r**6))*sqrtq2)+logq2*(10080*(-Q2+(-1+r)**2)*r**6*(1-Q2
            +r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1
            +r**2)-Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)
            +3*(9-86*r**2-446*r**4-86*r**6+9*r**8))+10080*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1+r**2)
            -Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)+3*(9
            -86*r**2-446*r**4-86*r**6+9*r**8))*sqrtq2)))+((-16*(Q2-(-1+r)**2)**6*r**6*(Q2
            -(1+r)**2)**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(12264*Q2**19
            +16*Q2**18*(-511+1313*r**2)+Q2**17*(770077+2249258*r**2-1354583*r**4)
            +Q2**16*(-10173499-169272881*r**2-30586149*r**4+9807761*r**6)+2*Q2**15*(24378277
            +752673567*r**2+950828302*r**4+90341143*r**6-18272105*r**8)+2*Q2**14*(
            -58377151-2771813102*r**2-7142597059*r**4-4301700127*r**6-300969854*r**8
            +42269069*r**10)+2*Q2**13*(65913379+4499838501*r**2+20817922851*r**4
            +24024856370*r**6+9999386205*r**8+616112265*r**10-64190147*r**12)+2*Q2**12*(5507047
            -86647574*r**2-20455434108*r**4-29186024313*r**6-33210301509*r**8-12007739124*r**10
            -780625766*r**12+63836227*r**14)-2*Q2**11*(114080239+11649892313*r**2
            +26372892736*r**4+99673899063*r**6+79016133000*r**8-7063261665*r**10
            -4794781484*r**12-569633407*r**14+39459589*r**16)+2*Q2**10*(126635509
            +16657134142*r**2+84447103959*r**4+328927818985*r**6+529929276769*r**8
            +253380308397*r**10+28693089469*r**12+4523868667*r**14-202364778*r**16
            +14633905*r**18)-2*Q2**9*(9353344+1720254921*r**2+58725419362*r**4+227527137456*r**6
            +873590241512*r**8+695777460826*r**10+249291409476*r**12+34263962072*r**14
            +4282926256*r**16-107236283*r**18+7470034*r**20)+2*Q2**8*(-93719444-18486146239*r**2
            -43364758247*r**4-383435056140*r**6+411329335800*r**8+412588449642*r**10
            +343631627202*r**12+175556028888*r**14+41625333180*r**16-2209816715*r**18
            -246717691*r**20+9216532*r**22)+2*Q2**7*(69226703+17771701861*r**2+90521212518*r**4
            +744671523641*r**6+321285364903*r**8+434791282074*r**10+2995431420*r**12
            -384656629238*r**14-252204910059*r**16-60098434447*r**18+3511770670*r**20
            +219312045*r**22-5350267*r**24)-2*Q2**6*(-13259939-581917710*r**2+37677497317*r**4
            +221929447093*r**6+646178105580*r**8+25287167377*r**10+248772296522*r**12
            -569780444078*r**14-500795038619*r**16-211053921980*r**18-27064367151*r**20
            -174244871*r**22-20066222*r**24+1913401*r**26)+2*Q2**5*(-42570899-11201885185*r**2
            -20274676439*r**4-491581708214*r**6+1069071851957*r**8-2144657758307*r**10
            +1384398335033*r**12-846251037572*r**14+84995534831*r**16-191996871623*r**18
            +1360403795*r**20+36024207226*r**22-1703201105*r**24-153953173*r**26
            +4031755*r**28)+2*Q2**4*(18285113+6540824898*r**2+24321510396*r**4+492835708033*r**6
            -1212432397109*r**8+3625123997712*r**10-3919796569206*r**12+1119211598443*r**14
            +1044326264079*r**16-614157132342*r**18+208117373512*r**20-54608534697*r**22
            -42655513619*r**24+548782308*r**26+82832946*r**28-1497667*r**30)-2*Q2**3*(
            -3920903-514609109*r**2+7422554004*r**4+49158498105*r**6-195180335770*r**8
            +1255527187387*r**10-3056536874848*r**12+2925704272657*r**14-982565612780*r**16
            +1734306005705*r**18-207928713020*r**20+175422438643*r**22-17136495486*r**24
            -6527936175*r**26-157069560*r**28-13635389*r**30+528139*r**32)+(-1
            +r**2)**2*(-541149-243279971*r**2-347671862*r**4-35310629906*r**6+255355535158*r**8
            -1507092249518*r**10+5050810509778*r**12-9625605077466*r**14+9061671313212*r**16
            -3283528112436*r**18+277704958718*r**20-213729689878*r**22-118720701862*r**24
            -29599599106*r**26+1401061478*r**28+22294274*r**30-3274479*r**32+51015*r**34)
            +2*Q2**2*(-6229601-2052696166*r**2+347421169*r**4-161691613653*r**6+816345532281*r**8
            -2843367983385*r**10+4567579023989*r**12-2685202207769*r**14+521727948131*r**16
            -371040884137*r**18-616457491517*r**20-156089944015*r**22-170670983469*r**24
            -52017769803*r**26+10030825431*r**28-39201347*r**30-30926158*r**32+636019*r**34)
            +Q2*(4348099+1710471712*r**2-46746045*r**4+190718430376*r**6-1342418449140*r**8
            +6539153180904*r**10-18260198688628*r**12+27203776644296*r**14-17767527589878*r**16
            +2193945718600*r**18-275927646070*r**20+1590524851320*r**22+131916990908*r**24
            +361598321208*r**26+111913697340*r**28-10214508008*r**30-92686229*r**32
            +24497016*r**34-421781*r**36))+16*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(12264*Q2**20
            +8*Q2**19*(-2555+1093*r**2)+Q2**18*(778253+2236426*r**2-1375591*r**4)
            +8*Q2**17*(-1367947-21536527*r**2-3935103*r**4+1395293*r**6)+Q2**16*(58930053
            +1684793514*r**2+2101515634*r**4+201460674*r**6-46351971*r**8)+4*Q2**15*(
            -41377714-1774432473*r**2-4423049464*r**4-2671434786*r**6-186519446*r**8
            +30270587*r**10)+4*Q2**14*(62145265+3665014377*r**2+15366166506*r**4
            +17734576778*r**6+7301028093*r**8+437406525*r**10-53229608*r**12)+4*Q2**13*(
            -30203166-2326199727*r**2-22886597730*r**4-37014401767*r**6-33617272042*r**8
            -11311618797*r**10-666273942*r**12+64013187*r**14)-4*Q2**12*(59793643
            +5784375893*r**2+2915405527*r**4+25016220321*r**6+8309903589*r**8-26140651149*r**10
            -8791573187*r**12-643211473*r**14+51647908*r**16)+4*Q2**11*(120357874
            +14210553347*r**2+61234944504*r**4+227487305392*r**6+354309654416*r**8
            +162666589866*r**10+8417523160*r**12-420273112*r**14-366269298*r**16
            +27046747*r**18)-2*Q2**10*(135988853+18504024572*r**2+159829657463*r**4
            +640902060400*r**6+1732447337266*r**8+1479087045992*r**10+531364807342*r**12
            +67480920208*r**14+8604430145*r**16-294967156*r**18+22103939*r**20)+4*Q2**9*(
            -42183050-8378268987*r**2+8540458018*r**4-48591249661*r**6+756223357384*r**8
            +990978075990*r**10+644350248752*r**12+229555700218*r**14+40086110754*r**16
            +982936629*r**18-173241970*r**20+8343283*r**22)-2*Q2**8*(-162946147-36351567544*r**2
            -152372117004*r**4-1171471338028*r**6-293391085243*r**8+389126503368*r**10
            +753224645424*r**12+903844285328*r**14+469386272127*r**16+99513950912*r**18
            -5968305076*r**20-456813204*r**22+14566799*r**24)+4*Q2**7*(-27983382
            -8629505427*r**2-72985205848*r**4-528561091626*r**6-856067497062*r**8
            -390681907177*r**10-343279505008*r**12+475720820948*r**14+568828288958*r**16
            +261678633243*r**18+41825515464*r**20-1778418922*r**22-96947778*r**24
            +1718433*r**26)+4*Q2**6*(-27915419-5898531417*r**2+8410451584*r**4-115987381902*r**6
            +968589702315*r**8-736596242675*r**10+829228899466*r**12-583629592564*r**14
            -492789973933*r**16-451922916111*r**18-118378942668*r**20+4392797602*r**22
            -948756099*r**24-86052997*r**26+2972578*r**28)-4*Q2**5*(-30428006-8892640491*r**2
            -27899036010*r**4-502346046343*r**6+894961270426*r**8-2350354952031*r**10
            +1579768572966*r**12-290532150491*r**14-902790883410*r**16+253577897775*r**18
            -199376920670*r**20+45996572859*r**22+38488259870*r**24-1202968293*r**26
            -116377182*r**28+2764711*r**30)+4*Q2**4*(-7182105-3022250451*r**2-19142444649*r**4
            -283157858267*r**6+457388512423*r**8-1834109393995*r**10+1675604723171*r**12
            -62559650947*r**14-590486124871*r**16-1082237568721*r**18+306984235925*r**20
            -164465638729*r**22+57200271901*r**24+24317333743*r**26-237272847*r**28
            -33849945*r**30+484764*r**32)+4*Q2**3*(-5075252-1285613089*r**2+3627683032*r**4
            -52555280772*r**6+335161847308*r**8-891510565884*r**10+1383284668264*r**12
            -1408017404980*r**14+1232433304004*r**16+190349754394*r**18+454959900584*r**20
            -94298109196*r**22-6192520156*r**24-37841100732*r**26+1672909848*r**28
            -104953148*r**30-22016704*r**32+582079*r**34)+Q2**2*(16807301+5828323246*r**2
            +3363803949*r**4+513406815344*r**6-2651726286396*r**8+10593198083112*r**10
            -21708620769836*r**12+23439023011856*r**14-13440579070602*r**16+1892571590612*r**18
            +1699069105238*r**20+3135619722384*r**22+785438845876*r**24+806975827752*r**26
            +195887586084*r**28-30197756176*r**30+47568781*r**32+85077294*r**34-1693819*r**36)
            -(-1+r**2)**2*(-541149-243821120*r**2-590951833*r**4-35658301768*r**6
            +220044905252*r**8-1251736714360*r**10+3543718260260*r**12-4574794567688*r**14
            -563933764254*r**16+5778143200776*r**18-3005823153718*r**20+63975268840*r**22
            -332450391740*r**24-148320300968*r**26-28198537628*r**28+1423355752*r**30
            +19019795*r**32-3223464*r**34+51015*r**36)+4*Q2*(-1222312-489254371*r**2
            -381344684*r**4-56382562621*r**6+369332285468*r**8-1812462170376*r**10
            +5010349012924*r**12-7544474075552*r**14+5981860730876*r**16-3864723486262*r**18
            +3497103606068*r**20-1341816231250*r**22-283999551404*r**24-124850799344*r**26
            -132908115180*r**28-33519654280*r**30+2915098172*r**32+24270865*r**34
            -6862936*r**36+118199*r**38))*sqrtq2+logq2**7*(112870195200000*r**34*(1
            +r**2)**2*(1-Q2+r**2)*(-511-1406*r**2+2685*r**4)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3+112870195200000*(Q2-(-1+r)**2)**2*r**34*(1+r**2)**2*(
            -511-1406*r**2+2685*r**4)*(Q2-(1+r)**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2**6*(89579520000*r**28*(1+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-31200*Q2**8*(1+r**2)-240*Q2**7*(-1040-281*r**2+759*r**4)
            -8*Q2**6*(105105-39902*r**2-184207*r**4+10920*r**6)+Q2**5*(1468740-1171861*r**2
            -2911527*r**4+2510629*r**6+2781555*r**8)-Q2**4*(1201200-1672575*r**2
            -175708*r**4+10428802*r**6+10428780*r**8+3499965*r**10)+Q2**3*(-54600
            -2127340*r**2+889238*r**4+9480306*r**6+17253418*r**8+2920570*r**10-7814520*r**12)
            +3*(-1+r**2)**2*(55120+413067*r**2+151764*r**4-4376431*r**6-1525856*r**8
            +5621109*r**10+1973052*r**12+2204015*r**14)+2*Q2**2*(464100+1525280*r**2
            +1165679*r**4-4716304*r**6-3976334*r**8+3587644*r**10+8009275*r**12
            +11681460*r**14)-3*Q2*(228020+895957*r**2+347481*r**4-9536617*r**6
            -12914677*r**8+15446523*r**10+14323751*r**12+2225817*r**14+7047105*r**16))
            +89579520000*r**28*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(31200*Q2**9*(1
            +r**2)+240*Q2**8*(-1170-541*r**2+629*r**4)-8*Q2**7*(-136305+272*r**2
            +198547*r**4+11850*r**6)-7*Q2**6*(329940-92891*r**2-672057*r**4+160619*r**6
            +409845*r**8)+4*Q2**5*(667485-343924*r**2-1064774*r**4+2506976*r**6
            +3930241*r**8+1570380*r**10)+5*Q2**4*(-229320+519743*r**2+191809*r**4
            -3946680*r**6-7622200*r**8-3369863*r**10+862911*r**12)-4*Q2**3*(245700
            +1308125*r**2+892365*r**4-4950538*r**6-8671598*r**8-3249675*r**10+5228125*r**12
            +7794360*r**14)+3*(-1+r**2)**2*(55120+468187*r**2+564831*r**4-4224667*r**6
            -5902287*r**8+4095253*r**10+7594161*r**12+4177067*r**14+2204015*r**16)
            +Q2**2*(1612260+6666631*r**2+6424361*r**4-35711101*r**6-56129307*r**8
            +45562189*r**10+66165091*r**12+46058921*r**14+44504235*r**16)-12*Q2*(70785
            +356701*r**2+156047*r**4-3364007*r**6-3768131*r**8+1707059*r**10+4743813*r**12
            +5107147*r**14+1709486*r**16+2312780*r**18))*sqrtq2)+logq2**5*(497664000*r**24*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(499200*Q2**12*(1+r**2)
            -480*Q2**11*(55541+96690*r**2+41149*r**4)+8*Q2**10*(27411264+64084663*r**2
            +49249838*r**4+12776919*r**6)-120*Q2**9*(6635259+19113442*r**2+19514300*r**4
            +8099950*r**6+1063833*r**8)-45*Q2**8*(-32654284-113274487*r**2-139701492*r**4
            -65581166*r**6-1322208*r**8+5177669*r**10)+20*Q2**7*(-54162315-263462012*r**2
            -400247227*r**4-183195192*r**6+87919879*r**8+117914996*r**10+37747455*r**12)
            -60*Q2**6*(13689123-4579652*r**2-56976425*r**4-42272094*r**6+41535729*r**8
            +74466496*r**10+37228149*r**12+9465666*r**14)-12*Q2**5*(-197739543-387965551*r**2
            -152032541*r**4+297060967*r**6+177962355*r**8-439995553*r**10-405364531*r**12
            -22816151*r**14+23457972*r**16)+10*Q2**4*(-166675302-373681531*r**2-144846140*r**4
            +420632694*r**6-60695992*r**8-1519377626*r**10-1894291500*r**12-972196522*r**14
            -86915450*r**16+78367881*r**18)-60*Q2**3*(2539003-9295946*r**2+1377439*r**4
            +47250408*r**6-49426990*r**8-340143128*r**10-465925386*r**12-146034496*r**14
            +50077531*r**16-973894*r**18+12161347*r**20)+9*(-1+r**2)**2*(10164208
            -2846933*r**2+19117282*r**4+273147855*r**6-33090672*r**8-946377030*r**10
            -466014420*r**12+383991858*r**14+1049362560*r**16+1148284187*r**18+181989362*r**20
            +7974143*r**22)+60*Q2**2*(14706295+291994*r**2-2601371*r**4+85197126*r**6
            +82598418*r**8-104279142*r**10-211643658*r**12+9853998*r**14+551175303*r**16
            +529501004*r**18+69675413*r**20+9006860*r**22)-180*Q2*(2718803-2436041*r**2
            +1026211*r**4+36154067*r**6-1857426*r**8-163054590*r**10-89649678*r**12
            +150506298*r**14+82973331*r**16+115299559*r**18+165725675*r**20+26100947*r**22
            +1633324*r**24))+497664000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(499200*Q2**12*(1
            +r**2)-480*Q2**11*(55541+96690*r**2+41149*r**4)+8*Q2**10*(27411264+64084663*r**2
            +49249838*r**4+12776919*r**6)-120*Q2**9*(6635259+19113442*r**2+19514300*r**4
            +8099950*r**6+1063833*r**8)-45*Q2**8*(-32654284-113274487*r**2-139701492*r**4
            -65581166*r**6-1322208*r**8+5177669*r**10)+20*Q2**7*(-54162315-263462012*r**2
            -400247227*r**4-183195192*r**6+87919879*r**8+117914996*r**10+37747455*r**12)
            -60*Q2**6*(13689123-4579652*r**2-56976425*r**4-42272094*r**6+41535729*r**8
            +74466496*r**10+37228149*r**12+9465666*r**14)-12*Q2**5*(-197739543-387965551*r**2
            -152032541*r**4+297060967*r**6+177962355*r**8-439995553*r**10-405364531*r**12
            -22816151*r**14+23457972*r**16)+10*Q2**4*(-166675302-373681531*r**2-144846140*r**4
            +420632694*r**6-60695992*r**8-1519377626*r**10-1894291500*r**12-972196522*r**14
            -86915450*r**16+78367881*r**18)-60*Q2**3*(2539003-9295946*r**2+1377439*r**4
            +47250408*r**6-49426990*r**8-340143128*r**10-465925386*r**12-146034496*r**14
            +50077531*r**16-973894*r**18+12161347*r**20)+9*(-1+r**2)**2*(10164208
            -2846933*r**2+19117282*r**4+273147855*r**6-33090672*r**8-946377030*r**10
            -466014420*r**12+383991858*r**14+1049362560*r**16+1148284187*r**18+181989362*r**20
            +7974143*r**22)+60*Q2**2*(14706295+291994*r**2-2601371*r**4+85197126*r**6
            +82598418*r**8-104279142*r**10-211643658*r**12+9853998*r**14+551175303*r**16
            +529501004*r**18+69675413*r**20+9006860*r**22)-180*Q2*(2718803-2436041*r**2
            +1026211*r**4+36154067*r**6-1857426*r**8-163054590*r**10-89649678*r**12
            +150506298*r**14+82973331*r**16+115299559*r**18+165725675*r**20+26100947*r**22
            +1633324*r**24))*sqrtq2)+logq2**4*(-8294400*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(665600*Q2**16-35840*Q2**15*(3489+3232*r**2)+64*Q2**14*(21499563
            +33913548*r**2+12949153*r**4)-8*Q2**13*(833257456+1923186127*r**2+1399687502*r**4
            +308471951*r**6)+16*Q2**12*(1090293117+3569249920*r**2+4066797842*r**4
            +1862407820*r**6+267012477*r**8)-Q2**11*(23412248568+119007212105*r**2
            +198176506052*r**4+147604225682*r**6+51140606500*r**8+6398030853*r**10)
            +Q2**10*(4447409472+120862383409*r**2+291927518261*r**4+303910508806*r**6
            +176029745086*r**8+61858548809*r**10+11537056077*r**12)-Q2**9*(-36237437736
            -18397552531*r**2+12149383144*r**4-18226286525*r**6+30618764880*r**8
            +85699676539*r**10+59968416304*r**12+18777861909*r**14)+Q2**8*(-54362426304
            -208725171683*r**2-653581654703*r**4-1185919361069*r**6-924982006785*r**8
            -161658245229*r**10+132137548447*r**12+73092617597*r**14+20333266641*r**16)
            -2*Q2**7*(-10093753928-117847355915*r**2-447313265668*r**4-954835638410*r**6
            -883770477428*r**8-114052440598*r**10+328156328700*r**12+224016543742*r**14
            +52217840900*r**16+6082501357*r**18)+2*Q2**6*(13969133568-31366246155*r**2
            -44965615403*r**4-322269858938*r**6-541299928970*r**8+46665433066*r**10
            +644621067970*r**12+513303984022*r**14+215615055382*r**16+43978135045*r**18
            +258751453*r**20)+2*Q2**5*(-18271720632-52249090969*r**2-436935899136*r**4
            -542186175511*r**6+93537509184*r**8+290838488764*r**10-309740263456*r**12
            -502331881836*r**14-110827328216*r**16+19509678989*r**18-5581691024*r**20
            +3250329043*r**22)+Q2**4*(11858377232+115755610122*r**2+775800861402*r**4
            +964929524750*r**6-329738308530*r**8-958888224024*r**10+715450264536*r**12
            +2503771002696*r**14+2175626074440*r**16+501899430670*r**18-206314778418*r**20
            -38707532118*r**22-6190974758*r**24)+3*Q2**3*(2228772984-12547167567*r**2
            -1051385452*r**4-40078053966*r**6+45172980500*r**8+114365633427*r**10
            -492135163656*r**12-1334749553796*r**14-1042828934448*r**16-317306873625*r**18
            -156446356236*r**20+51683855698*r**22+11859098148*r**24+552251989*r**26)
            +9*(-1+r**2)**2*(-33722272-357358543*r**2-4185770385*r**4+4528542572*r**6
            -6138403492*r**8-46982177751*r**10-1355067649*r**12+87435327720*r**14
            +124466544616*r**16-44014774821*r**18-202021247627*r**20-62832794708*r**22
            -10656445860*r**24-456476213*r**26+33584413*r**28)+3*Q2**2*(-2402152576
            -3685394025*r**2-113576387861*r**4+53009016370*r**6+80418157434*r**8
            -342413231743*r**10-113877354915*r**12+558089441532*r**14+412796253420*r**16
            -1137007700903*r**18-1716515786331*r**20-423729348910*r**22-99728835046*r**24
            -8453201265*r**26+485164819*r**28)-9*Q2*(-271392648-1309174335*r**2
            -20675772312*r**4+34812233463*r**6-11532959120*r**8-149406903787*r**10
            +119284527600*r**12+237574205059*r**14-72588057736*r**16+111800839635*r**18
            -134180067032*r**20-561451836715*r**22-168473535072*r**24-32188875177*r**26
            -1817427840*r**28+143236017*r**30))+8294400*r**20*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(665600*Q2**17-5120*Q2**16*(24553+22754*r**2)+64*Q2**15*(23453403
            +37677308*r**2+14759073*r**4)-40*Q2**14*(201050792+473298203*r**2+354917822*r**4
            +82413035*r**6)+8*Q2**13*(3013843690+9894943423*r**2+11456469313*r**4
            +5432975093*r**6+842496905*r**8)-Q2**12*(40856938440+193559900697*r**2
            +320353270244*r**4+242471516274*r**6+85211331252*r**8+10670230485*r**10)
            +2*Q2**11*(13929829020+131640922041*r**2+304555618209*r**4+324845620270*r**6
            +187387288634*r**8+59698593081*r**10+8967543465*r**12)-2*Q2**10*(-15895014132
            +53456120175*r**2+212469642407*r**4+288805870271*r**6+255279509386*r**8
            +161793985217*r**10+66682010595*r**12+15157458993*r**14)+10*Q2**9*(-9059986404
            -26336016195*r**2-65982982409*r**4-119199626445*r**6-91258952843*r**8
            -4533980381*r**10+27780564129*r**12+15183889581*r**14+3911112855*r**16)
            +Q2**8*(74549934160+498782309817*r**2+1756933357722*r**4+3749172292592*r**6
            +3878442322710*r**8+1314745133210*r**10-626791960618*r**12-653263253528*r**14
            -197861566038*r**16-32498269355*r**18)+4*Q2**7*(1937689820-79653677999*r**2
            -305063118493*r**4-862209381508*r**6-1189953022404*r**8-475578742480*r**10
            +429362478036*r**12+532738428232*r**14+245924720012*r**16+51139238651*r**18
            +3170626405*r**20)+4*Q2**6*(-16120427100-17425989191*r**2-180302018789*r**4
            -87475350585*r**6+478553648546*r**8+392736492334*r**10-500513382246*r**12
            -830128466914*r**14-419873183810*r**16-120041755719*r**18-24909288761*r**20
            +1495788795*r**22)-4*Q2**5*(-12100454624-64199308331*r**2-438542710403*r**4
            -730793418511*r**6-141889756031*r**8+431910054980*r**10-188313453480*r**12
            -1031978823320*r**14-850486123636*r**16-171133682281*r**18+58542688587*r**20
            +8511202039*r**22+3172908211*r**24)+5*Q2**4*(-1034411656-33051098011*r**2
            -178942125576*r**4-372192909610*r**6-99934454944*r**8+326344686567*r**10
            -246593506296*r**12-1444693985724*r**14-1561576776096*r**16-725889225197*r**18
            -152984744192*r**20+80014775526*r**22+16095160264*r**24+1569546145*r**26)
            -6*Q2**3*(2315462780-3316500279*r**2+49988917421*r**4-47069227894*r**6
            -37661615450*r**8+250975922835*r**10-131946087657*r**12-1192487079492*r**14
            -1395187370832*r**16-111564053585*r**18+621381278235*r**20+159483424186*r**22
            +81635894446*r**24+10432275701*r**26+33543585*r**28)-9*(-1+r**2)**2*(
            -33722272-391080815*r**2-4543128928*r**4+342772187*r**6-1609860920*r**8
            -53120581243*r**10-48337245400*r**12+86080260071*r**14+211901872336*r**16
            +80451769795*r**18-246036022448*r**20-264854042335*r**22-73489240568*r**24
            -11112922073*r**26-422891800*r**28+33584413*r**30)-6*Q2**2*(-1608165260
            -5007534803*r**2-89644549411*r**4+21934664449*r**6+49414148222*r**8-355107892835*r**10
            -49218501929*r**12+578467350897*r**14+376560760872*r**16-194404464289*r**18
            -1628031844165*r**20-1912300322693*r**22-514439394586*r**24-102374330921*r**26
            -6710159983*r**28+457436435*r**30)+18*Q2*(-152557460-935240491*r**2
            -12744861109*r**4+13339592975*r**6+1949007661*r**8-95558345551*r**10
            +28174254087*r**12+200011008963*r**14+56613484425*r**16-83149877217*r**18
            -5952190383*r**20-199218489011*r**22-408468737929*r**24-121319394725*r**26
            -21858106019*r**28-1098918431*r**30+88410215*r**32))*sqrtq2)+logq2**3*(138240*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-158074880*Q2**19+512*Q2**18*(5066524
            +3741999*r**2)-64*Q2**17*(276248301+447029102*r**2+170508481*r**4)+16*Q2**16*(4014816104
            +10849568329*r**2+8997269274*r**4+2327952089*r**6)-16*Q2**15*(7914502403
            +34484901024*r**2+46250360342*r**4+25601601704*r**6+5123616303*r**8)
            +Q2**14*(93774900120+927304156045*r**2+1826266820068*r**4+1613827071578*r**6
            +697568739140*r**8+121354925785*r**10)-2*Q2**13*(-68925648708+248909274147*r**2
            +770160224091*r**4+1001713720402*r**6+854771309486*r**8+374850822027*r**10
            +64844735547*r**12)+Q2**12*(-389966285328-1096494060201*r**2-3245995892770*r**4
            -5598639066419*r**6-3126791530124*r**8+340563149985*r**10+624599564094*r**12
            +111120431547*r**14)-4*Q2**11*(-69521371272-623867150847*r**2-2682631407509*r**4
            -6712613814799*r**6-7398461879645*r**8-3432253786149*r**10-403252535079*r**12
            +131208913203*r**14+16411754913*r**16)-Q2**10*(-183089865224+1813480835283*r**2
            +10506315472816*r**4+44265608394816*r**6+73037026553592*r**8+56059260962702*r**10
            +21635307531136*r**12+3678301621176*r**14-184363682592*r**16+18649708711*r**18)
            +2*Q2**9*(-217522903300-316405235145*r**2-2040092935493*r**4+10269358019912*r**6
            +30885825244520*r**8+33595289586710*r**10+21455668925990*r**12+9483187736672*r**14
            +2916897203172*r**16+245548967435*r**18+41728184535*r**20)+Q2**8*(186047090304
            +2368977463199*r**2+19606044720114*r**4+41339511807343*r**6+58365779972184*r**8
            +60796072868006*r**10+19588104694556*r**12-17404890404146*r**14-17612231463432*r**16
            -7074318494181*r**18-843230243806*r**20-47314015901*r**22)-8*Q2**7*(-19343537306
            +224025540083*r**2+1958601337001*r**4+9182864939509*r**6+19526988767189*r**8
            +25714990140018*r**10+14303851870662*r**12-3720896131002*r**14-8248021591916*r**16
            -3837319100661*r**18-833738034559*r**20-72546210987*r**22+4388701249*r**24)
            +Q2**6*(-180997054168-56409242193*r**2-3347662274924*r**4+36461527399506*r**6
            +61819025161780*r**8+108467902614117*r**10+76630158610952*r**12-88447951210388*r**14
            -146108530370928*r**16-90267201553095*r**18-31083944119964*r**20-3843158640574*r**22
            -150023989228*r**24+47631209907*r**26)+2*Q2**5*(12243765948+543955712059*r**2
            +6691267651499*r**4+8781097746862*r**6+54520054670194*r**8+43250199863813*r**10
            -23234294275731*r**12+7774274160132*r**14+48741343575624*r**16+21711727026213*r**18
            +3097173700229*r**20+2819416874062*r**22-370493845366*r**24-81786130021*r**26
            -1149199517*r**28)-Q2**4*(-46982301360+721255744755*r**2+7273046395582*r**4
            +30838226887477*r**6+117697510445980*r**8+77648950816995*r**10-95053155007230*r**12
            -78814791090819*r**14+113347639877976*r**16+193493626421985*r**18+70168915098690*r**20
            -17049647942425*r**22-7465633272388*r**24-2958776811703*r**26-268183103490*r**28
            +18927759975*r**30)+12*Q2**3*(-1842613584+1277400061*r**2-79672433161*r**4
            +1146222254553*r**6-26141133901*r**8+449236247809*r**10-2544379148621*r**12
            -715310559683*r**14+19341700483119*r**16+28440152758407*r**18+17632180358069*r**20
            +9738967615099*r**22+50537933769*r**24-346958980997*r**26-129251764831*r**28
            -9727924369*r**30+598628261*r**32)+9*(-1+r**2)**2*(-75605408+1665626245*r**2
            +18682171208*r**4+83565227980*r**6+697586885280*r**8-1221041689616*r**10
            +179848574360*r**12+7528024297036*r**14+2579934949840*r**16-17930329874110*r**18
            -9254229287944*r**20+16957236316420*r**22+7434463944704*r**24+2336161942680*r**26
            +347118903080*r**28-2729461532*r**30-1712328400*r**32+43808177*r**34)
            +3*Q2**2*(-742988952+68527564381*r**2+854738312104*r**4-106895785028*r**6
            +18783892797312*r**8-16272064735952*r**10-9532881218216*r**12+29395857532060*r**14
            -24245997594144*r**16-42796040385774*r**18+62264014012760*r**20+136102290121364*r**22
            +44452195335968*r**24+17076093939672*r**26+2732878732712*r**28+14932026644*r**30
            -18557436904*r**32+854169993*r**34)-18*Q2*(-200113412+5644009463*r**2
            +56760943347*r**4+93878426532*r**6+1688858570220*r**8-3832783316904*r**10
            +1424487217216*r**12+7021412909364*r**14-1559677340236*r**16-1080139680690*r**18
            -15688631957906*r**20-5755379872596*r**22+23801543190756*r**24+9567097704576*r**26
            +3243059181720*r**28+531576206972*r**30-5561102208*r**32-3637394717*r**34
            +121218503*r**36))-138240*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(158074880*Q2**19
            -512*Q2**18*(5066524+3741999*r**2)+64*Q2**17*(276248301+447029102*r**2
            +170508481*r**4)-16*Q2**16*(4014816104+10849568329*r**2+8997269274*r**4
            +2327952089*r**6)+16*Q2**15*(7914502403+34484901024*r**2+46250360342*r**4
            +25601601704*r**6+5123616303*r**8)-Q2**14*(93774900120+927304156045*r**2
            +1826266820068*r**4+1613827071578*r**6+697568739140*r**8+121354925785*r**10)
            +2*Q2**13*(-68925648708+248909274147*r**2+770160224091*r**4+1001713720402*r**6
            +854771309486*r**8+374850822027*r**10+64844735547*r**12)+Q2**12*(389966285328
            +1096494060201*r**2+3245995892770*r**4+5598639066419*r**6+3126791530124*r**8
            -340563149985*r**10-624599564094*r**12-111120431547*r**14)+4*Q2**11*(
            -69521371272-623867150847*r**2-2682631407509*r**4-6712613814799*r**6
            -7398461879645*r**8-3432253786149*r**10-403252535079*r**12+131208913203*r**14
            +16411754913*r**16)+Q2**10*(-183089865224+1813480835283*r**2+10506315472816*r**4
            +44265608394816*r**6+73037026553592*r**8+56059260962702*r**10+21635307531136*r**12
            +3678301621176*r**14-184363682592*r**16+18649708711*r**18)-2*Q2**9*(-217522903300
            -316405235145*r**2-2040092935493*r**4+10269358019912*r**6+30885825244520*r**8
            +33595289586710*r**10+21455668925990*r**12+9483187736672*r**14+2916897203172*r**16
            +245548967435*r**18+41728184535*r**20)+Q2**8*(-186047090304-2368977463199*r**2
            -19606044720114*r**4-41339511807343*r**6-58365779972184*r**8-60796072868006*r**10
            -19588104694556*r**12+17404890404146*r**14+17612231463432*r**16+7074318494181*r**18
            +843230243806*r**20+47314015901*r**22)+8*Q2**7*(-19343537306+224025540083*r**2
            +1958601337001*r**4+9182864939509*r**6+19526988767189*r**8+25714990140018*r**10
            +14303851870662*r**12-3720896131002*r**14-8248021591916*r**16-3837319100661*r**18
            -833738034559*r**20-72546210987*r**22+4388701249*r**24)+Q2**6*(180997054168
            +56409242193*r**2+3347662274924*r**4-36461527399506*r**6-61819025161780*r**8
            -108467902614117*r**10-76630158610952*r**12+88447951210388*r**14+146108530370928*r**16
            +90267201553095*r**18+31083944119964*r**20+3843158640574*r**22+150023989228*r**24
            -47631209907*r**26)+2*Q2**5*(-12243765948-543955712059*r**2-6691267651499*r**4
            -8781097746862*r**6-54520054670194*r**8-43250199863813*r**10+23234294275731*r**12
            -7774274160132*r**14-48741343575624*r**16-21711727026213*r**18-3097173700229*r**20
            -2819416874062*r**22+370493845366*r**24+81786130021*r**26+1149199517*r**28)
            +Q2**4*(-46982301360+721255744755*r**2+7273046395582*r**4+30838226887477*r**6
            +117697510445980*r**8+77648950816995*r**10-95053155007230*r**12-78814791090819*r**14
            +113347639877976*r**16+193493626421985*r**18+70168915098690*r**20-17049647942425*r**22
            -7465633272388*r**24-2958776811703*r**26-268183103490*r**28+18927759975*r**30)
            -12*Q2**3*(-1842613584+1277400061*r**2-79672433161*r**4+1146222254553*r**6
            -26141133901*r**8+449236247809*r**10-2544379148621*r**12-715310559683*r**14
            +19341700483119*r**16+28440152758407*r**18+17632180358069*r**20+9738967615099*r**22
            +50537933769*r**24-346958980997*r**26-129251764831*r**28-9727924369*r**30
            +598628261*r**32)-9*(-1+r**2)**2*(-75605408+1665626245*r**2+18682171208*r**4
            +83565227980*r**6+697586885280*r**8-1221041689616*r**10+179848574360*r**12
            +7528024297036*r**14+2579934949840*r**16-17930329874110*r**18-9254229287944*r**20
            +16957236316420*r**22+7434463944704*r**24+2336161942680*r**26+347118903080*r**28
            -2729461532*r**30-1712328400*r**32+43808177*r**34)-3*Q2**2*(-742988952
            +68527564381*r**2+854738312104*r**4-106895785028*r**6+18783892797312*r**8
            -16272064735952*r**10-9532881218216*r**12+29395857532060*r**14-24245997594144*r**16
            -42796040385774*r**18+62264014012760*r**20+136102290121364*r**22+44452195335968*r**24
            +17076093939672*r**26+2732878732712*r**28+14932026644*r**30-18557436904*r**32
            +854169993*r**34)+18*Q2*(-200113412+5644009463*r**2+56760943347*r**4
            +93878426532*r**6+1688858570220*r**8-3832783316904*r**10+1424487217216*r**12
            +7021412909364*r**14-1559677340236*r**16-1080139680690*r**18-15688631957906*r**20
            -5755379872596*r**22+23801543190756*r**24+9567097704576*r**26+3243059181720*r**28
            +531576206972*r**30-5561102208*r**32-3637394717*r**34+121218503*r**36))*sqrtq2)
            +logq2**2*(-2304*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1167259648*Q2**22
            -512*Q2**21*(28477018+26380193*r**2)+32*Q2**20*(2408576829+4765392602*r**2
            +2137033629*r**4)-160*Q2**19*(1332492332+4593350013*r**2+4333412086*r**4
            +1237173269*r**6)+40*Q2**18*(6930721543+46837920357*r**2+72276983109*r**4
            +44734960383*r**6+9022201112*r**8)-Q2**17*(-66337638468+2262394088935*r**2
            +5213633128500*r**4+5495412549870*r**6+2831018716720*r**8+431634254667*r**10)
            +Q2**16*(-785756660336-673116713771*r**2-2189315392455*r**4-2939072677890*r**6
            +2096940593350*r**8+2594218589229*r**10+330793105009*r**12)+Q2**15*(984130889728
            +6687925558714*r**2+29899076566218*r**4+67623497141050*r**6+55289834591060*r**8
            +14073543358278*r**10-615448339486*r**12-95412132922*r**14)-10*Q2**14*(
            -6444368256+925175736261*r**2+5526213866922*r**4+19602365326836*r**6
            +26029719782657*r**8+14983163177313*r**10+3498326521560*r**12+188937484902*r**14
            +16578527613*r**16)+10*Q2**13*(-132745694296+180852944471*r**2+1877008876027*r**4
            +22878077810496*r**6+47693277390637*r**8+43654580517508*r**10+20073345503685*r**12
            +4238603372108*r**14+321736633579*r**16+24046617881*r**18)+2*Q2**12*(535321178704
            +5244073244165*r**2+40508977249050*r**4+21063498435915*r**6-72854986269355*r**8
            -135576478458699*r**10-146946442612535*r**12-82602970810815*r**14-19058776114665*r**16
            -1572397619270*r**18+9351350369*r**20)-2*Q2**11*(-189899110752+6542664951983*r**2
            +61922643136755*r**4+235944483312405*r**6+497318742803080*r**8+767097054008502*r**10
            +518583496348662*r**12+66027761689810*r**14-58707209447760*r**16-16818665404005*r**18
            -1125790132417*r**20+152455785753*r**22)+2*Q2**10*(-515453189576+838492794987*r**2
            +12672627936314*r**4+286402559186110*r**6+903682890484655*r**8+2210409698797286*r**10
            +2548363437340508*r**12+1324685891262596*r**14+262419873222590*r**16-27437635630025*r**18
            -6913999427646*r**20-71442337738*r**22+92645226499*r**24)+10*Q2**9*(34001186924
            +953062436796*r**2+9757611935847*r**4-14010331421316*r**6-60358212709321*r**8
            -413108713201926*r**10-743731786159818*r**12-588824293491792*r**14-259334144347062*r**16
            -70289490746096*r**18-6540561040893*r**20-2165346078156*r**22-235765969293*r**24
            +13935922138*r**26)-10*Q2**8*(-36330312576+776568788726*r**2+9153063934737*r**4
            +42077849352813*r**6+192637473674893*r**8+181972694699109*r**10-31816475089128*r**12
            -127007604516150*r**14-159283752700110*r**16-153967301134224*r**18-78505538978543*r**20
            -14827825459191*r**22-2943430423551*r**24-215563976971*r**26+17487657606*r**28)
            -2*Q2**7*(149238510656+446109577865*r**2-164540312775*r**4-274142949551475*r**6
            -1268794833831090*r**8-3593063040730991*r**10-4757092249194365*r**12-4226637563465155*r**14
            -1209696172309100*r**16+1475730680420275*r**18+1395394705113279*r**20
            +497438149355215*r**22+76338327714270*r**24+1974025624115*r**26-317072431995*r**28
            +9826586471*r**30)+2*Q2**6*(-8612929568+2091392267317*r**2+21330892478130*r**4
            -86992480514480*r**6-143099029460015*r**8-2614370776761177*r**10-2911937908176032*r**12
            -2924960394598370*r**14-272290908244485*r**16+3635506821602675*r**18+3746679298221578*r**20
            +1848320049973428*r**22+414142776074615*r**24+57645254559665*r**26-4774367493660*r**28
            -925571745058*r**30+44548809437*r**32)-6*Q2**5*(-15322114168+252556451441*r**2
            +3596714984737*r**4+35577722319140*r**6+267288063785875*r**8+24162499896698*r**10
            +1071312266108409*r**12+608591293223848*r**14-205271079452525*r**16+636436451137120*r**18
            +580943274364843*r**20+220544735375684*r**22+161320345554433*r**24+1820498436110*r**26
            +1737233751355*r**28-438288645648*r**30-78252720559*r**32+2972663207*r**34)
            -10*Q2**4*(2330110368+71463313577*r**2+150706672174*r**4-23125977582081*r**6
            -110055938284203*r**8-235614534521529*r**10-836748149094783*r**12-244084327114589*r**14
            +903866466713633*r**16+209562032986581*r**18-852721910934071*r**20-345198689776195*r**22
            +99374152270911*r**24+33500029152477*r**26+38825505444147*r**28+8056381309857*r**30
            -92900254549*r**32-61968118946*r**34+2284507221*r**36)+30*Q2**3*(-342253984
            +19732651109*r**2+154795238633*r**4-1474782710405*r**6+1786389683636*r**8
            -54099855121428*r**10+9623952455224*r**12+20463635102044*r**14+144900184226356*r**16
            -125035593301458*r**18-564410273326222*r**20-503505546010790*r**22-358225122705412*r**24
            -53549222999732*r**26-7012861668912*r**28+4143820446284*r**30+1761128204732*r**32
            +19214840885*r**34-11661854819*r**36+323344259*r**38)+9*(-1+r**2)**2*(
            -9111568+1767795455*r**2-1049172625*r**4-597847653725*r**6-2119267980005*r**8
            -5769184019828*r**10-78082995528740*r**12+230626190657500*r**14-125444939647700*r**16
            -916249830694110*r**18+664693760586642*r**20+1302447563846490*r**22-786062877175750*r**24
            -398428026787300*r**26-178869446657140*r**28-53539008675028*r**30-4203236802580*r**32
            +428767448375*r**34+19702189975*r**36-1782186245*r**38+31167907*r**40)
            +6*Q2**2*(950850548-5195569465*r**2-274406420650*r**4-8112612730610*r**6
            -51054152167625*r**8+94918268791768*r**10-912270022424060*r**12+921992942852620*r**14
            +407524205965000*r**16-112203943845330*r**18+766493482162128*r**20-1088289295662360*r**22
            -3074608530185290*r**24-971978878577920*r**26-598314898734340*r**28-159569688478252*r**30
            -6201802544740*r**32+1258793990195*r**34-8139666470*r**36-10161615830*r**38
            +354410683*r**40)-9*Q2*(58172924+7662892009*r**2-34090730870*r**4-3385742556990*r**6
            -11579836740010*r**8+7057880689469*r**10-373442291459656*r**12+987230839435160*r**14
            -338764605536080*r**16-1644475825954670*r**18-268306291525476*r**20+2293217626510764*r**22
            +1842074040203540*r**24-2244255657431870*r**26-1012943349151880*r**28
            -475118157204776*r**30-152180527305596*r**32-11476130560955*r**34+1711844043690*r**36
            +64768427810*r**38-9293210266*r**40+205393729*r**42))+2304*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1167259648*Q2**23-512*Q2**22*(30756822
            +28659997*r**2)+32*Q2**21*(2864209117+5643107978*r**2+2559116717*r**4)
            -32*Q2**20*(9071038489+30140719496*r**2+28569486661*r**4+8322899974*r**6)
            +40*Q2**19*(12260690871+70541289737*r**2+107984031505*r**4+67017301803*r**6
            +13970894188*r**8)-Q2**18*(210891223252+4413139764935*r**2+9978229267140*r**4
            +10175890289550*r**6+4981305176520*r**8+792522299147*r**10)+4*Q2**17*(
            -213023574701+380734934174*r**2+1321677956245*r**4+1942493250120*r**6
            +2605842964985*r**8+1464217890154*r**10+190606839919*r**12)+Q2**16*(1769887550064
            +8146798932821*r**2+32761508672444*r**4+72751885211395*r**6+56131966675600*r**8
            +9382384175699*r**10-3540460033724*r**12-426205237931*r**14)-4*Q2**15*(229921801792
            +4230953452763*r**2+22962285198538*r**4+73386556743907*r**6+95802632389670*r**8
            +54798752430617*r**10+12110340058598*r**12+294628594153*r**14+17593285802*r**16)
            +20*Q2**14*(-69595031276+549792156238*r**2+4164199239605*r**4+24003328502127*r**6
            +46662681250065*r**8+42333731738739*r**10+19277417601279*r**12+3962933689285*r**14
            +263626323047*r**16+20312572747*r**18)-4*Q2**13*(-599524825092-2501768496645*r**2
            -15109834073280*r**4+51355967498350*r**6+212855881137510*r**8+296157883999712*r**10
            +232793036359250*r**12+102081357594890*r**14+20930238071550*r**16+1650656938285*r**18
            +55440869518*r**20)-4*Q2**12*(172711033976+6161029687426*r**2+53837846814985*r**4
            +148758479498685*r**6+222763627484820*r**8+279332794640224*r**10+118030287638714*r**12
            -81760825866770*r**14-80184478186620*r**16-18724919568970*r**18-1344418200659*r**20
            +80903568061*r**22)+4*Q2**11*(-352676150164+3595629318109*r**2+40568968012526*r**4
            +292134842817635*r**6+818473058300070*r**8+1737412747804434*r**10+1917021993848836*r**12
            +954648574650534*r**14+134870212732320*r**16-51481755240895*r**18-12429227482034*r**20
            -522388342201*r**22+122550506126*r**24)-2*Q2**10*(-685459124196-4442272578569*r**2
            -35276938947934*r**4+369126844229004*r**6+1491876513217370*r**8+5179636155291571*r**10
            +8477432066936884*r**12+6817170796062064*r**14+2883776486220496*r**16
            +586429691323045*r**18-1648829853206*r**20+3841288625396*r**22+1200032735226*r**24
            +22965615809*r**26)-20*Q2**9*(-1164562826+881816206223*r**2+9931869153690*r**4
            +18912564933672*r**6+59134464772128*r**8-145747115606069*r**10-594328487225436*r**12
            -729781842083880*r**14-503721095269482*r**16-241795468113691*r**18-77667795382766*r**20
            -11766866289120*r**22-2672271235500*r**24-218697012063*r**26+15711789872*r**28)
            +2*Q2**8*(-330890073536+3255082802885*r**2+49812703930090*r**4+530297515989225*r**6
            +2442371448969620*r**8+5466113882601001*r**10+5507873347244270*r**12+3432517165438765*r**14
            -221760613772200*r**16-3041985949591945*r**18-2557758905677114*r**20-964104971543885*r**22
            -165194607127980*r**24-17768997626725*r**26-673309164830*r**28+77611701559*r**30)
            +4*Q2**7*(70312790544+1343370177919*r**2+10806230871610*r**4-180649985189365*r**6
            -843018406421290*r**8-3738114325661629*r**10-5631046599050694*r**12-5954345103628945*r**14
            -2854312322009370*r**16+1950770664856925*r**18+3308902341877566*r**20
            +1870576452220961*r**22+493959626572050*r**24+67978803949025*r**26-1558707150770*r**28
            -616408795291*r**30+27187697954*r**32)-4*Q2**6*(-27289636036+1420224346036*r**2
            +17106214849829*r**4+20535789460535*r**6+285886340691565*r**8-1342491153265549*r**10
            -1156185943305991*r**12-2005562211551429*r**14-1906532270600215*r**16
            +2636262633384775*r**18+4562507971459391*r**20+3128316777161029*r**22
            +1373211931355671*r**24+238624762971305*r**26+29041294160035*r**28-3507402587831*r**30
            -557890548649*r**32+26733399529*r**34)-4*Q2**5*(28808447172-177193221967*r**2
            -5397140473832*r**4-116576599911018*r**6-729438524868030*r**8-1026212181827682*r**10
            -3735082521744618*r**12-3130066156784858*r**14+1654685846127098*r**16
            -122842975060440*r**18-3957874365588122*r**20-2065228739051278*r**22-324362240717898*r**24
            -160961193104622*r**26+91727165329170*r**28+18192535616082*r**30+542561412938*r**32
            -42000211337*r**34+1252273242*r**36)+20*Q2**4*(651674208+66495688636*r**2
            +343277850825*r**4-13699809520561*r**6-63911373407688*r**8-253985019085008*r**10
            -521745413125320*r**12-509720785451620*r**14+547241346139056*r**16+369160859897920*r**18
            -1168195348963078*r**20-1354218619371318*r**22-660249952810760*r**24-13886743787904*r**26
            +25643474794944*r**28+29656674046428*r**30+6623432834752*r**32-48611925420*r**34
            -47334588091*r**36+1627269999*r**38)-12*Q2**3*(-1331060234+51073777545*r**2
            +573522934680*r**4+756337685875*r**6+26306093516890*r**8-178242797990364*r**10
            +344945254546520*r**12-385777502533140*r**14+209647445338500*r**16+105763449234910*r**18
            -2106861407650264*r**20-2125644900511350*r**22-617022406697860*r**24-543446424973900*r**26
            +147752237695560*r**28+72612241182556*r**30+17863272899910*r**32+3821460618945*r**34
            +22952298400*r**36-23265468485*r**38+631155306*r**40)-9*(-1+r**2)**2*(
            -9111568+1758683887*r**2+718622830*r**4-598896826350*r**6-2717115633730*r**8
            -7888451999833*r**10-83852179548568*r**12+152543195128760*r**14+105181251009800*r**16
            -1041694770341810*r**18-251556070107468*r**20+1967141324433132*r**22+516384686670740*r**24
            -1184490903963050*r**26-577297473444440*r**28-232408455332168*r**30-57742245477608*r**32
            -3774469354205*r**34+448469638350*r**36+17920003730*r**38-1751018338*r**40
            +31167907*r**42)-3*Q2**2*(2076219868+14499238193*r**2-661476172840*r**4
            -26931265973490*r**6-153073040016500*r**8+108901875316693*r**10-2755030381643552*r**12
            +2981138359162600*r**14+1642740481027000*r**16-4342786953624670*r**18
            +503660202057168*r**20+6236061252531828*r**22-2799573531084680*r**24-14825941789822030*r**26
            -6179417602080160*r**28-2941123646039512*r**30-788084563962772*r**32-44314408791955*r**34
            +7636840778520*r**36+157702718830*r**38-47494041092*r**40+1325002553*r**42)
            +36*Q2*(12265339+2376770881*r**2-7755428491*r**4-1003453700220*r**6
            -3972550285545*r**8-1662612941021*r**10-108762076559819*r**12+248702886417664*r**14
            -4078520648090*r**16-604493548057990*r**18+114741591211754*r**20+270430386741096*r**22
            +352256855608054*r**24+518490918545590*r**26-856318819210510*r**28-395572412126176*r**30
            -175823337655009*r**32-52090106372011*r**34-3701339006655*r**36+541048338420*r**38
            +19693236979*r**40-2733084649*r**42+59140409*r**44))*sqrtq2)+logq2*(192*r**8*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(-17456896*Q2**21+22496*Q2**20*(9719
            +12317*r**2)-8*Q2**19*(140614060+400286109*r**2+218104817*r**4)+24*Q2**18*(121432705
            +607003749*r**2+712606615*r**4+244396815*r**6)-Q2**17*(3137812380+30318842671*r**2
            +50582985637*r**4+44384404561*r**6+11356635199*r**8)+Q2**16*(-2633826056
            +12392011707*r**2-26722162548*r**4+3083382198*r**6+54534972316*r**8+11790596591*r**10)
            +Q2**15*(12021249384+74763870072*r**2+500481840146*r**4+879431041214*r**6
            +377163897918*r**8-6575087734*r**10-3302379000*r**12)-2*Q2**14*(5693920380
            +76829938502*r**2+586451111491*r**4+1753610874218*r**6+1636518829538*r**8
            +530333177974*r**10+35962645087*r**12+2397311066*r**14)+2*Q2**13*(-2876155780
            +33683359326*r**2+386866532915*r**4+2931599516387*r**6+4480715707696*r**8
            +2942434137832*r**10+773139504127*r**12+54313704535*r**14+115376290*r**16)
            +2*Q2**12*(10198941220+76543568184*r**2+716532797993*r**4-1096212059554*r**6
            -3344352525405*r**8-4039518101012*r**10-2898031354849*r**12-763572716706*r**14
            -49536950671*r**16+5240134816*r**18)-2*Q2**11*(5637410428+116422434708*r**2
            +1632120701763*r**4+4476863130425*r**6+10057167052663*r**8+13600316836073*r**10
            +4593722864581*r**12-1137929867189*r**14-519229252959*r**16-34266834881*r**18
            +4994747556*r**20)+2*Q2**10*(-4883260148+25844617986*r**2+871608995081*r**4
            +8499547162686*r**6+26473701993600*r**8+57346063370972*r**10+47454363592450*r**12
            +15284383506092*r**14+872286965436*r**16-41464633166*r**18-35534931*r**20
            -476294266*r**22)+2*Q2**9*(7387236480+72582107187*r**2+939186169086*r**4
            -4669745637114*r**6-14037941588469*r**8-71094425135762*r**10-91724833201172*r**12
            -52048273590996*r**14-16036341659834*r**16-1652050258449*r**18-368123993082*r**20
            -30676244418*r**22+3031189311*r**24)-2*Q2**8*(1237940820+65233245241*r**2
            +1598143821895*r**4+4548908181364*r**6+29800014497827*r**8+973408612259*r**10
            -35913028367994*r**12-33856850363000*r**14-27167017380646*r**16-14032057525873*r**18
            -2103817187981*r**20-277408595132*r**22-13630846865*r**24+661129045*r**26)
            -2*Q2**7*(3177939620-797015076*r**2-567417330507*r**4-8944401053637*r**6
            -47776615187521*r**8-82132367416339*r**10-67336852959450*r**12-45945049081346*r**14
            +23398778733810*r**16+40590286050022*r**18+19116273315601*r**20+3158375446983*r**22
            -49728782805*r**24-23623466671*r**26+1451029396*r**28)+2*Q2**6*(1964634732
            +27418893918*r**2+531532891223*r**4-4123391722222*r**6-8448844498938*r**8
            -76404435328638*r**10-34376570955707*r**12-44451954794562*r**14+38551027719392*r**16
            +76691358961234*r**18+52137455853921*r**20+13980022232574*r**22+2360245080494*r**24
            -96584208690*r**26-22482974461*r**28+869601330*r**30)+2*Q2**5*(333027972
            -13810349794*r**2-599538672731*r**4-2582408662243*r**6-31917885881032*r**8
            +34016815891532*r**10-104219200780745*r**12-59991653401*r**14+9399714336366*r**16
            -58225172484418*r**18-3736891651789*r**20-15759125880949*r**22+2909144473212*r**24
            +824633244632*r**26-16210753295*r**28-3574267535*r**30+230313818*r**32)
            -2*Q2**4*(687969860+1036736124*r**2-150549938923*r**4-3701761422082*r**6
            -24681257234357*r**8+11247411876164*r**10-144334438098139*r**12+46709982978818*r**14
            +142568229085259*r**16-106654102548056*r**18-53739842914953*r**20+23736366408706*r**22
            -5362138003847*r**24+6533220738548*r**26+2223334685263*r**28-17928428546*r**30
            -11431396691*r**32+345970852*r**34)+2*Q2**3*(147194140+3214776552*r**2
            +89667687475*r**4-1027708149803*r**6+577812138231*r**8-14361836284623*r**10
            -13236294862441*r**12+46508054321385*r**14+55465043743451*r**16-142353309623387*r**18
            -94546111202319*r**20-119718097556689*r**22-12127629974155*r**24-7122568152573*r**26
            +867411853581*r**28+765410270227*r**30+12730916253*r**32-2840019905*r**34
            +52876600*r**36)+3*(-1+r**2)**2*(4510448+9879125*r**2-1446301480*r**4
            -59014449535*r**6-366690093208*r**8+1807280959036*r**10-16853280024520*r**12
            +53332933093820*r**14-64993856715640*r**16-54977456276946*r**18+159861392284584*r**20
            -64069141253210*r**22-11002842792200*r**24-9427095600740*r**26-4419783280984*r**28
            -572453160068*r**30+34905469480*r**32+1606424485*r**34-132356960*r**36
            +2404513*r**38)+2*Q2**2*(83150840-1121827862*r**2-75303504369*r**4-578664318490*r**6
            -7770767977604*r**8+30784363125048*r**10-128697257238296*r**12+165523757754320*r**14
            -8884530682452*r**16-10929747536500*r**18-1735907468066*r**20-131246650849572*r**22
            -54177228584108*r**24-33884910908776*r**26-16950376659888*r**28-1599247963072*r**30
            +402876035980*r**32+619332282*r**34-2086533157*r**36+53373742*r**38)
            +3*Q2*(-30991052+85963291*r**2+14080391251*r**4+294915840407*r**6+2125587143987*r**8
            -12463624258348*r**10+76815667082612*r**12-200312121718108*r**14+173437930476524*r**16
            +138513246309474*r**18-175983632539854*r**20-139251272223222*r**22+101600962718338*r**24
            +45811253174356*r**26+21358198601716*r**28+13182045783460*r**30+1882879139944*r**32
            -200876546981*r**34-5906253037*r**36+858316823*r**38-17291581*r**40))
            -192*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(139655168*Q2**25-1079808*Q2**24*(1733
            +2166*r**2)+32*Q2**23*(325236623+910102430*r**2+493002895*r**4)-8*Q2**22*(3700828208
            +18238612683*r**2+21381266950*r**4+7143263115*r**6)+8*Q2**21*(4628157617
            +43801562970*r**2+78013840432*r**4+63085013606*r**6+14864874719*r**8)
            -Q2**20*(-22225437796+256348491733*r**2+305822613260*r**4+653168785130*r**6
            +755471417848*r**8+128359288289*r**10)+4*Q2**19*(-35484970361-180232240017*r**2
            -1085111654730*r**4-1906864968310*r**6-716928663545*r**8+76870092999*r**10
            +4273676668*r**12)+2*Q2**18*(78742485878+997447601235*r**2+6804874901060*r**4
            +20141529496605*r**6+18916240745830*r**8+5857737956253*r**10+408926116320*r**12
            +57123917555*r**14)-4*Q2**17*(-16941817039+339971767186*r**2+3410531063070*r**4
            +21283834236460*r**6+33276981196490*r**8+21284979917106*r**10+5100916578606*r**12
            +390955052240*r**14+14956728185*r**16)+Q2**16*(-311326395744-1821626808825*r**2
            -12339181515544*r**4+59278647909788*r**6+170314872913712*r**8+185078262740366*r**10
            +102777905271480*r**12+20635850955716*r**14+1303057451408*r**16-141253896693*r**18)
            +16*Q2**15*(11926083571+245375468157*r**2+2847430845555*r**4+7064395126140*r**6
            +11940439578807*r**8+15384546406158*r**10+2963246835067*r**12-2933733415540*r**14
            -673222761110*r**16-29369733523*r**18+11199007486*r**20)+8*Q2**14*(24176756302
            -187596706041*r**2-4373947597330*r**4-38878333543435*r**6-117773762025560*r**8
            -251268828645712*r**10-216079457153774*r**12-69953125915980*r**14-5903074302450*r**16
            -530449154295*r**18-75995714788*r**20+3093467319*r**22)-16*Q2**13*(19338867774
            +169065479970*r**2+1538355749725*r**4-15041045588520*r**6-62715465553500*r**8
            -241839915352334*r**10-333394035389070*r**12-200295425643760*r**14-54058824831080*r**16
            -5876337335200*r**18-876101881851*r**20-81890560220*r**22+9826667570*r**24)
            +2*Q2**12*(13746768508+1634287800483*r**2+30692639527220*r**4+79354107221770*r**6
            +280027323147880*r**8-1021704417598583*r**10-2929983496522768*r**12-2833152621187060*r**14
            -1469801553055900*r**16-389777267445715*r**18-47041796908932*r**20-4208210482822*r**22
            -200788976360*r**24+22437135895*r**26)+8*Q2**11*(25007649577-26139879595*r**2
            -3302090139788*r**4-58174372471094*r**6-274561320446971*r**8-526889319732157*r**10
            -467690667655200*r**12-416297639358012*r**14+17403235841939*r**16+212670824666171*r**18
            +86342326794372*r**20+13688779006210*r**22-568586818673*r**24-161796701539*r**26
            +11152945624*r**28)-4*Q2**10*(27070084966+473386378047*r**2+7212485558520*r**4
            -68017305047215*r**6-348594964501958*r**8-2253956924093693*r**10-4465986173026672*r**12
            -7668693470901355*r**14-6045356700733910*r**16-1710387009160667*r**18
            +170428521634952*r**20+105589487711227*r**22+19488459784310*r**24-1688390797415*r**26
            -301984634448*r**28+14703302431*r**30)-8*Q2**9*(7401311243-143866945734*r**2
            -4393006647880*r**4-22497569655960*r**6-122115295155500*r**8+775968399078962*r**10
            +1819559244513464*r**12+5742281241220380*r**14+7156294017623030*r**16
            +3941152926863790*r**18+1133605891057592*r**20+56897755840944*r**22+31495626865820*r**24
            +7131943945510*r**26+36636728280*r**28-50548934772*r**30+3255671951*r**32)
            +2*Q2**8*(34835039128+138398792795*r**2-1893484422360*r**4-161618278887760*r**6
            -870635487794240*r**8-1416829944558128*r**10-6473394620004400*r**12+3412124734780040*r**14
            +16402628544353400*r**16+11775167744115550*r**18+6984040505660872*r**20
            +3777211065970240*r**22+719967230237520*r**24+250626247668680*r**26+61059082570560*r**28
            -770623402872*r**30-461393204000*r**32+16803648175*r**34)+16*Q2**7*(-2778959
            -36052237959*r**2-878433306665*r**4+5764086083320*r**6+33840513584335*r**8
            +576489263969244*r**10+1803295613188959*r**12+3136474629520640*r**14+2421880641871925*r**16
            +1852029221301190*r**18-87882303205911*r**20-1076167790412136*r**22-652417285102555*r**24
            -156028415450500*r**26-9636076954635*r**28-1078655389584*r**30+1159647526*r**32
            +4896221545*r**34+63959020*r**36)-16*Q2**6*(1417953109-9913269255*r**2
            -471074850276*r**4-6710239092078*r**6-27428610234462*r**8+368737399642921*r**10
            +403942802626375*r**12+3400674453370561*r**14+2192657440549298*r**16+1422684432033567*r**18
            -1011599634235039*r**20-2940586708200135*r**22-2235311322900654*r**24
            -687486160960557*r**26-173718031193623*r**28-3753897433741*r**30+4232955471365*r**32
            +38315864044*r**34-25023664813*r**36+722299393*r**38)+8*Q2**5*(762283287
            +12433044034*r**2+180565674570*r**4-10737692057990*r**6-51624532239751*r**8
            -256068416836684*r**10-2258499542121264*r**12+2813474191333640*r**14-6248803747100910*r**16
            -3377140851261184*r**18+338659555827324*r**20-2811889754472524*r**22-1642115813076490*r**24
            -1771101520164260*r**26-108274763941904*r**28-59508871815144*r**30-14591773129721*r**32
            +3508602656430*r**34+107816626810*r**36-17458263886*r**38+324555617*r**40)
            +Q2**4*(3649703236-76047271473*r**2-2410543537980*r**4+2108542106790*r**6
            +131593590677160*r**8+4474400366201271*r**10+11413054800869632*r**12+4545190180123080*r**14
            +80564554622460840*r**16-13434154475479090*r**18-87815602062886104*r**20
            +39791170266332292*r**22+17186667876812080*r**24-14878978675159050*r**26
            +83046596714400*r**28-3299225400114424*r**30-1514206727040588*r**32-63611421311805*r**34
            +17832953154420*r**36+263994561030*r**38-85591402104*r**40+2084966387*r**42)
            -12*Q2**3*(161513547-616540725*r**2-38514004630*r**4-1571063307270*r**6
            -104146115485*r**8+116179860648487*r**10-229477864813620*r**12+1695497235428200*r**14
            -130176032540810*r**16-3191002450116090*r**18-2308287281896868*r**20+7249870378190700*r**22
            +7342332365092830*r**24+7120434285627030*r**26+1713117492556160*r**28
            +509277285723912*r**30+56575272320735*r**32-62577324794065*r**34-10841724580950*r**36
            +924803445290*r**38+43009142047*r**40-4401835965*r**42+79177540*r**44)
            -9*(-1+r**2)**2*(4510448-53267147*r**2-2008591342*r**4-39758012837*r**6
            +595330742100*r**8+12508558620083*r**10-6861588697462*r**12+124469090143093*r**14
            +746884778756048*r**16-3920605971774750*r**18+6275453968093988*r**20+3828999183908318*r**22
            -13436315208836552*r**24+3874075033030678*r**26+2218656147425700*r**28
            +1037422157080858*r**30+544485373741088*r**32+105773397231193*r**34+290824529098*r**36
            -1210278232425*r**38+24823417748*r**40+3233397703*r**42-166020142*r**44
            +2404513*r**46)-6*Q2**2*(20877694-1644135681*r**2-42100054180*r**4+983382207025*r**6
            +6339302161110*r**8+127670593894469*r**10+541321217687664*r**12-2517805200585765*r**14
            +12433289296716060*r**16-13795493935005770*r**18-7099981339895736*r**20
            +3171214989226154*r**22+5526993499744060*r**24+15494032562717130*r**26
            +3743683953518960*r**28+3299709190743414*r**30+1536135883875174*r**32
            +134337015598395*r**34-29842061609540*r**36+1236362246325*r**38+263435159534*r**40
            -4625613311*r**42-778493760*r**44+19020575*r**46)+36*Q2*(6620151-117770330*r**2
            -3567364834*r**4-12525958212*r**6+736205957442*r**8+16073093386566*r**10
            -487224645930*r**12-39216080144904*r**14+1250103690858393*r**16-4163918968255668*r**18
            +3645403003207196*r**20+4404068281313320*r**22-4951647252680484*r**24
            -4062032853481732*r**26+2828215641942652*r**28+1337317396489056*r**30
            +702452736774345*r**32+366921654338766*r**34+73954054306758*r**36-2312413168068*r**38
            -1057434536094*r**40+46541545470*r**42+3235340206*r**44-234195832*r**46
            +3721767*r**48))*sqrtq2))/(1008000*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2+1008000*(-Q2+(-1
            +r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2+logq2**7*(-8126654054400000*r**32*(1
            +r**2)**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-8126654054400000*r**32*(1
            +r**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**6*(45148078080000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))+45148078080000*r**28*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))*sqrtq2)+logq2*(-60480000*(-Q2
            +(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(9+8*Q2**4-78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)
            -Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-60480000*(-Q2+(-1+r)**2)**3*r**8*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(9+8*Q2**4-78*r**2-366*r**4
            -78*r**6+9*r**8-Q2**3*(1+r**2)-Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1
            +13*r**2+13*r**4+r**6))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*sqrtq2)+logq2**2*(725760000*(-Q2+(-1+r)**2)**3*r**12*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531
            +550*r**2+531*r**4)-2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815
            -2120*r**2-11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4
            +494*r**6+225*r**8+r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6
            +26793*r**8+4554*r**10-501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6
            -1385*r**8-311*r**10+15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6
            +34670*r**8+13388*r**10-184*r**12-316*r**14+17*r**16))+725760000*(
            -Q2+(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531+550*r**2+531*r**4)
            -2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815-2120*r**2-11502*r**4
            -2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4+494*r**6+225*r**8
            +r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6+26793*r**8+4554*r**10
            -501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6-1385*r**8-311*r**10
            +15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6+34670*r**8+13388*r**10
            -184*r**12-316*r**14+17*r**16))*sqrtq2)+logq2**3*(-8709120000*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8+256*Q2**7*(1+r**2)
            -Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2+893*r**4+319*r**6)
            +Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)+12*Q2**3*(61
            +235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(-1071+9654*r**2
            +51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)-18*Q2*(23
            -35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12+23*r**14)
            +9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10-264*r**12
            -756*r**14+47*r**16))-8709120000*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8
            +256*Q2**7*(1+r**2)-Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2
            +893*r**4+319*r**6)+Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)
            +12*Q2**3*(61+235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(
            -1071+9654*r**2+51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)
            -18*Q2*(23-35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12
            +23*r**14)+9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10
            -264*r**12-756*r**14+47*r**16))*sqrtq2)+logq2**4*(104509440000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513+770*r**2
            +513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105-3400*r**2
            -11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4-1178*r**6
            +75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6+19593*r**8
            +3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6-5785*r**8
            -2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4+25204*r**6
            +52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))+104509440000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513
            +770*r**2+513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105
            -3400*r**2-11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4
            -1178*r**6+75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6
            +19593*r**8+3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6
            -5785*r**8-2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4
            +25204*r**6+52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))*sqrtq2)
            +logq2**5*(-250822656000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(64*Q2**8+1088*Q2**7*(1+r**2)+Q2**6*(-63+130*r**2-63*r**4)
            -2*Q2**5*(2777+6379*r**2+6379*r**4+2777*r**6)+Q2**4*(1555-8080*r**2
            -22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743-315*r**2-6548*r**4-6548*r**6
            -315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2+199629*r**4+305844*r**6
            +199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83-375*r**2-2833*r**4
            -5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)+9*(301-4028*r**2
            +808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12-4028*r**14+301*r**16))
            -250822656000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(64*Q2**8+1088*Q2**7*(1
            +r**2)+Q2**6*(-63+130*r**2-63*r**4)-2*Q2**5*(2777+6379*r**2+6379*r**4
            +2777*r**6)+Q2**4*(1555-8080*r**2-22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743
            -315*r**2-6548*r**4-6548*r**6-315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2
            +199629*r**4+305844*r**6+199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83
            -375*r**2-2833*r**4-5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)
            +9*(301-4028*r**2+808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12
            -4028*r**14+301*r**16))*sqrtq2))+((-64*(Q2-(-1+r)**2)**6*r**6*(Q2-(1
            +r)**2)**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(24*Q2**19
            +8*Q2**18*(-2+17*r**2)+Q2**17*(1507+6468*r**2-4435*r**4)+Q2**16*(-19909
            -493169*r**2-93863*r**4+32821*r**6)+Q2**15*(95414+4407162*r**2+5952736*r**4
            +595334*r**6-130286*r**8)+2*Q2**14*(-114241-8140500*r**2-22512251*r**4
            -14195381*r**6-1081392*r**8+164029*r**10)+Q2**13*(257978+26331542*r**2
            +129283726*r**4+153852608*r**6+70728106*r**8+4973434*r**10-557858*r**12)
            +2*Q2**12*(10777+265148*r**2-53536650*r**4-59033941*r**6-101344727*r**8
            -49269250*r**10-3763304*r**12+327275*r**14)-2*Q2**11*(223249+35815299*r**2
            +123696578*r**4+517441943*r**6+446281260*r**8+135417*r**10-35658330*r**12
            -3784755*r**14+265499*r**16)+2*Q2**10*(247819+51123072*r**2+329375699*r**4
            +1487482543*r**6+2460955141*r**8+1231878051*r**10+132512457*r**12-7433083*r**14
            -2593228*r**16+152009*r**18)-2*Q2**9*(18304+5888025*r**2+194468198*r**4
            +980869598*r**6+3783001466*r**8+3059341456*r**10+1256701910*r**12+154528178*r**14
            +5094598*r**16-1485209*r**18+72644*r**20)+2*Q2**8*(-183404-55791021*r**2
            -245915731*r**4-1809382248*r**6+945856344*r**8+253644918*r**10+957535226*r**12
            +973998744*r**14+181637892*r**16+2484199*r**18-1052535*r**20+39104*r**22)
            +2*Q2**7*(135473+54136927*r**2+427697380*r**4+3489573877*r**6+3079559489*r**8
            +6218986806*r**10+3728937712*r**12-776925750*r**14-1293454893*r**16-242506261*r**18
            -3323828*r**20+607681*r**22-14885*r**24)-2*Q2**6*(-25949-1508364*r**2
            +140723477*r**4+1135109983*r**6+3544647510*r**8+3777456773*r**10+6638626122*r**12
            +403518454*r**14-1696757169*r**16-1008047810*r**18-119069055*r**20-5857141*r**22
            -116072*r**24+7721*r**26)+2*Q2**5*(-83309-34014087*r**2-160726147*r**4
            -2138533732*r**6+3095120217*r**8-10432707355*r**10+8460527407*r**12-2829407712*r**14
            +1470695725*r**16-839486205*r**18+63472227*r**20+102993668*r**22-2301913*r**24
            -477345*r**26+13361*r**28)+2*Q2**4*(35783+19975400*r**2+157566274*r**4
            +2207953829*r**6-3118258167*r**8+18578427082*r**10-17848404000*r**12
            +8137085707*r**14+3674535977*r**16-3890824156*r**18+987423242*r**20-337814165*r**22
            -131990521*r**24-1484246*r**26+260308*r**28-5147*r**30)-2*Q2**3*(-7673
            -1528807*r**2+27989682*r**4+271862081*r**6-361144978*r**8+6272747965*r**10
            -14133517518*r**12+14794675861*r**14-6048086652*r**16+6692548251*r**18
            -1773733466*r**20+823102707*r**22-97901518*r**24-26178929*r**26-885898*r**28
            -32201*r**30+1493*r**32)+(-1+r**2)**2*(-1059-743875*r**2-5416006*r**4
            -146595918*r**6+823283190*r**8-5907099554*r**10+21153072754*r**12-45020857302*r**14
            +48971388816*r**16-23762498760*r**18+5153836270*r**20-1571806058*r**22
            -430603638*r**24-127452798*r**26+445670*r**28+146318*r**30-10221*r**32
            +171*r**34)+2*Q2**2*(-12191-6258684*r**2-23675875*r**4-650056411*r**6
            +2716040913*r**8-11612066091*r**10+20455365177*r**12-15726872175*r**14
            +2793015127*r**16-972302551*r**18-1078092105*r**20-1037965457*r**22-637769765*r**24
            -189494241*r**26+18539763*r**28+461787*r**30-91236*r**32+2015*r**34)
            +Q2*(8509+5229414*r**2+26001623*r**4+764977156*r**6-4509781960*r**8
            +25536535260*r**10-78103114176*r**12+132723549268*r**14-105083947958*r**16
            +22276051560*r**18+6356206998*r**20-168450740*r**22+1886286800*r**24
            +1359016708*r**26+430063800*r**28-14211492*r**30-846223*r**32+74834*r**34
            -1381*r**36))+64*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(24*Q2**20+8*Q2**19*(
            -5+14*r**2)+Q2**18*(1523+6348*r**2-4571*r**4)+8*Q2**17*(-2677-62643*r**2
            -11987*r**4+4657*r**6)+Q2**16*(115323+4920240*r**2+6539768*r**4+656376*r**6
            -163107*r**8)+8*Q2**15*(-40487-2597947*r**2-6923050*r**4-4367354*r**6
            -328479*r**8+57293*r**10)+4*Q2**14*(121615+10710256*r**2+47647307*r**4
            +56816968*r**6+25320413*r**8+1702040*r**10-221479*r**12)+8*Q2**13*(-29553
            -3257403*r**2-32836071*r**4-50150527*r**6-53408771*r**8-21780005*r**10
            -1492773*r**12+151551*r**14)-4*Q2**12*(117013+18045612*r**2+35212538*r**4
            +202435676*r**6+142951296*r**8-75239280*r**10-44345442*r**12-3610392*r**14
            +296387*r**16)+8*Q2**11*(117767+21790405*r**2+122221894*r**4+532155266*r**6
            +856169586*r**8+419573682*r**10+24247386*r**12-11719042*r**14-1528121*r**16
            +104377*r**18)-2*Q2**10*(266123+57258916*r**2+574966969*r**4+2797727840*r**6
            +7731439150*r**8+6752174648*r**10+2621092418*r**12+279607552*r**14-4931713*r**16
            -3926428*r**18+224653*r**20)+8*Q2**9*(-41275-12471173*r**2-11389877*r**4
            -158511113*r**6+1427431852*r**8+1773996960*r**10+1318394648*r**12+596307208*r**14
            +85315167*r**16+1523397*r**18-616275*r**20+27937*r**22)+2*Q2**8*(318877
            +110111352*r**2+729404132*r**4+5544871856*r**6+3943085393*r**8+5019485544*r**10
            +2517757568*r**12-2708459720*r**14-2449091529*r**16-426628352*r**18-4755492*r**20
            +1621112*r**22-53989*r**24)+8*Q2**7*(-27381-13191009*r**2-155639446*r**4
            -1263095310*r**6-2528445219*r**8-3269000767*r**10-4146637660*r**12-838882604*r**14
            +941784453*r**16+636002241*r**18+91224786*r**20+2143322*r**22-119181*r**24
            +1791*r**26)+4*Q2**6*(-54629-17774200*r**2-10755517*r**4-431350136*r**6
            +3887438855*r**8-1555301536*r**10+9438305151*r**12+2106368432*r**14+88728505*r**16
            -1772145592*r**18-531822319*r**20-10966264*r**22-4137563*r**24-292848*r**26
            +10541*r**28)-8*Q2**5*(-29773-13518199*r**2-88076627*r**4-1126803427*r**6
            +1018711163*r**8-6479003555*r**10+3969056013*r**12-626491503*r**14-1258311991*r**16
            +1130508419*r**18-440859305*r**20+126070015*r**22+58170569*r**24-323753*r**26
            -181073*r**28+4627*r**30)+4*Q2**4*(-14055-9241188*r**2-102765678*r**4
            -1318691092*r**6+635724658*r**8-10866458440*r**10+6701747218*r**12-2541678784*r**14
            -2881767516*r**16-3238130036*r**18+2338567190*r**20-736355892*r**22+283853102*r**24
            +79826848*r**26+1054918*r**28-111480*r**30+1827*r**32)+8*Q2**3*(-4966
            -1948791*r**2+696250*r**4-87551162*r**6+656689504*r**8-1425115776*r**10
            +3148648906*r**12-3766428458*r**14+2884901084*r**16-81960238*r**18+960180670*r**20
            -497149054*r**22+21857856*r**24-78393672*r**26-2131266*r**28-114078*r**30
            -30486*r**32+877*r**34)+Q2**2*(32891+17771164*r**2+85870741*r**4+2112441728*r**6
            -8641750964*r**8+43328585616*r**10-95789712348*r**12+123266563264*r**14
            -79216233862*r**16+18634626408*r**18+10456996310*r**20+4063664384*r**22
            +5237757244*r**24+3013544720*r**26+771972756*r**28-52214592*r**30-1587325*r**32
            +253276*r**34-5411*r**36)-(-1+r**2)**2*(-1059-744934*r**2-6159881*r**4
            -152011924*r**6+676687272*r**8-5083816364*r**10+15245973200*r**12-23867784548*r**14
            +3950531514*r**16+25208890056*r**18-18608662490*r**20+3582030212*r**22
            -2002409696*r**24-558056436*r**26-127007128*r**28+591988*r**30+136097*r**32
            -10050*r**34+171*r**36)+16*Q2*(-598-373730*r**2-2197522*r**4-57967910*r**6
            +303491489*r**8-1795438447*r**10+5397320873*r**12-9240908591*r**14+8282910929*r**16
            -5244889831*r**18+4563622753*r**20-2614358351*r**22+384313043*r**24-255209693*r**26
            -122770805*r**28-34003133*r**30+950033*r**32+58645*r**34-5251*r**36
            +97*r**38))*sqrtq2+logq2**7*(451480780800000*r**34*(1+r**2)**2*(1-Q2+r**2)*(
            -1-4*r**2+9*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+451480780800000*(Q2
            -(-1+r)**2)**2*r**34*(1+r**2)**2*(-1-4*r**2+9*r**4)*(Q2-(1+r)**2)**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**6*(358318080000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-960*Q2**8*(1+r**2)+240*Q2**7*(32
            +43*r**2+11*r**4)-8*Q2**6*(3234+5059*r**2+1993*r**4+336*r**6)+Q2**5*(45192
            +76589*r**2+39001*r**4+12287*r**6+4683*r**8)-Q2**4*(36960+65511*r**2
            +45506*r**4+31352*r**6+16854*r**8+5145*r**10)-2*Q2**3*(840-1282*r**2
            -7119*r**4-12661*r**6-21147*r**8+587*r**10+14070*r**12)+3*(-1+r**2)**2*(1696
            +1957*r**2-346*r**4-11707*r**6-2152*r**8+17987*r**10+7186*r**12+8899*r**14)
            +Q2**2*(28560+27904*r**2+5706*r**4-23236*r**6-27856*r**8+25236*r**10
            +64486*r**12+84000*r**14)-3*Q2*(7016+2043*r**2-3359*r**4-22623*r**6
            -30029*r**8+58325*r**10+46383*r**12+9295*r**14+27029*r**16))+358318080000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(960*Q2**9*(1+r**2)-720*Q2**8*(12
            +17*r**2+5*r**4)+8*Q2**7*(4194+7309*r**2+3613*r**4+666*r**6)-7*Q2**6*(10152
            +20419*r**2+13631*r**4+4417*r**6+1053*r**8)+4*Q2**5*(20538+46823*r**2
            +40274*r**4+20660*r**6+8456*r**8+2457*r**10)+5*Q2**4*(-7056-21007*r**2
            -25051*r**4-20436*r**6-18100*r**8-4165*r**10+4599*r**12)-4*Q2**3*(7560
            +6755*r**2-2774*r**4-15699*r**6-23868*r**8-3971*r**10+23450*r**12+28035*r**14)
            +3*(-1+r**2)**2*(1696+3653*r**2+1611*r**4-12053*r**6-13859*r**8+15835*r**10
            +25173*r**12+16085*r**14+8899*r**16)+Q2**2*(49608+62593*r**2+23533*r**4
            -85399*r**6-141179*r**8+172355*r**10+228871*r**12+176371*r**14+165087*r**16)
            -24*Q2*(1089+953*r**2-485*r**4-4380*r**6-3967*r**8+4860*r**10+9221*r**12
            +8524*r**14+3214*r**16+4491*r**18))*sqrtq2)+logq2**5*(1990656000*r**24*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(15360*Q2**12*(1+r**2)
            -960*Q2**11*(295+506*r**2+211*r**4)+8*Q2**10*(231768+554401*r**2+435226*r**4
            +113265*r**6)-240*Q2**9*(25197+76971*r**2+85852*r**4+40963*r**6+6885*r**8)
            +15*Q2**8*(689880+2642015*r**2+3774586*r**4+2466496*r**6+693590*r**8
            +49545*r**10)+40*Q2**7*(-172053-994675*r**2-1774624*r**4-1369254*r**6
            -451729*r**8-1519*r**10+32958*r**12)-60*Q2**6*(103362-4081*r**2-178684*r**4
            +8187*r**6+182174*r**8+151361*r**10+61068*r**12+17829*r**14)-12*Q2**5*(
            -1301826-3291947*r**2-6176817*r**4-8272945*r**6-5942055*r**8-2626861*r**10
            -645447*r**12+251593*r**14+125985*r**16)+10*Q2**4*(-1014372-3434491*r**2
            -7740394*r**4-10894176*r**6-9290326*r**8-5982136*r**10-3664602*r**12
            -1674112*r**14+69422*r**16+301635*r**18)-120*Q2**3*(11765-58190*r**2
            -91077*r**4-57526*r**6-206484*r**8-487272*r**10-543562*r**12-88998*r**14
            +115227*r**16+4530*r**18+26675*r**20)+60*Q2**2*(91786+57389*r**2+520944*r**4
            +1019221*r**6+464044*r**8-411224*r**10-801404*r**12+144760*r**14+2133082*r**16
            +1873995*r**18+239900*r**20+50227*r**22)+9*(-1+r**2)**2*(58016+87749*r**2
            +772184*r**4+1515499*r**6-341816*r**8-2861618*r**10-1251464*r**12+1056226*r**14
            +4117336*r**16+4557101*r**18+707312*r**20+50675*r**22)-180*Q2*(16106
            +5055*r**2+132365*r**4+179083*r**6-107637*r**8-466014*r**10-106266*r**12
            +557706*r**14+269388*r**16+477343*r**18+632589*r**20+93547*r**22+10175*r**24))
            +1990656000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(15360*Q2**12*(1
            +r**2)-960*Q2**11*(295+506*r**2+211*r**4)+8*Q2**10*(231768+554401*r**2
            +435226*r**4+113265*r**6)-240*Q2**9*(25197+76971*r**2+85852*r**4+40963*r**6
            +6885*r**8)+15*Q2**8*(689880+2642015*r**2+3774586*r**4+2466496*r**6
            +693590*r**8+49545*r**10)+40*Q2**7*(-172053-994675*r**2-1774624*r**4
            -1369254*r**6-451729*r**8-1519*r**10+32958*r**12)-60*Q2**6*(103362-4081*r**2
            -178684*r**4+8187*r**6+182174*r**8+151361*r**10+61068*r**12+17829*r**14)
            -12*Q2**5*(-1301826-3291947*r**2-6176817*r**4-8272945*r**6-5942055*r**8
            -2626861*r**10-645447*r**12+251593*r**14+125985*r**16)+10*Q2**4*(-1014372
            -3434491*r**2-7740394*r**4-10894176*r**6-9290326*r**8-5982136*r**10
            -3664602*r**12-1674112*r**14+69422*r**16+301635*r**18)-120*Q2**3*(11765
            -58190*r**2-91077*r**4-57526*r**6-206484*r**8-487272*r**10-543562*r**12
            -88998*r**14+115227*r**16+4530*r**18+26675*r**20)+60*Q2**2*(91786+57389*r**2
            +520944*r**4+1019221*r**6+464044*r**8-411224*r**10-801404*r**12+144760*r**14
            +2133082*r**16+1873995*r**18+239900*r**20+50227*r**22)+9*(-1+r**2)**2*(58016
            +87749*r**2+772184*r**4+1515499*r**6-341816*r**8-2861618*r**10-1251464*r**12
            +1056226*r**14+4117336*r**16+4557101*r**18+707312*r**20+50675*r**22)
            -180*Q2*(16106+5055*r**2+132365*r**4+179083*r**6-107637*r**8-466014*r**10
            -106266*r**12+557706*r**14+269388*r**16+477343*r**18+632589*r**20+93547*r**22
            +10175*r**24))*sqrtq2)+logq2**4*(-33177600*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(20480*Q2**16-15360*Q2**15*(64+57*r**2)+384*Q2**14*(24399+39597*r**2
            +15698*r**4)-8*Q2**13*(5184568+12458777*r**2+9595050*r**4+2319721*r**6)
            +8*Q2**12*(12428412+42554624*r**2+50658345*r**4+24852682*r**6+4115109*r**8)
            -Q2**11*(118050384+645989903*r**2+1104220882*r**4+855068344*r**6+316639654*r**8
            +43569153*r**10)+Q2**10*(85536+561892159*r**2+1330103721*r**4+1372222186*r**6
            +867633806*r**8+341195015*r**10+62197977*r**12)+Q2**9*(202545168+254840629*r**2
            +804868806*r**4+1774078325*r**6+1193121160*r**8-40898157*r**10-296330926*r**12
            -92955789*r**14)+Q2**8*(-255424512-1225546013*r**2-4977345595*r**4-10751410939*r**6
            -10680001605*r**8-4487921587*r**10-297222613*r**12+329045675*r**14+103345461*r**16)
            +2*Q2**7*(30942704+624293213*r**2+2977561170*r**4+7976371184*r**6+10024633118*r**8
            +5663713864*r**10+938060138*r**12-442028000*r**14-212730266*r**16-34673797*r**18)
            +2*Q2**6*(74746464-107691877*r**2-64769343*r**4-2659566746*r**6-5525039326*r**8
            -3423163038*r**10-41466722*r**12+850925582*r**14+566617434*r**16+161602159*r**18
            +8256933*r**20)+2*Q2**5*(-78205776-359546719*r**2-3148977326*r**4-5100052811*r**6
            -4525456536*r**8-4139381156*r**10-3162873896*r**12-1194384876*r**14+278077624*r**16
            +229606579*r**18-15355610*r**20+9742503*r**22)+2*Q2**4*(18285808+352919899*r**2
            +2695279581*r**4+5481431325*r**6+6626117755*r**8+6594110044*r**10+5115451972*r**12
            +3364694788*r**14+1960936060*r**16+72038505*r**18-491542017*r**20-61356161*r**22
            -13375559*r**24)+3*Q2**3*(11238352-55613657*r**2-38080710*r**4-924543456*r**6
            -891764850*r**8-339164069*r**10-1821459236*r**12-3495778640*r**14-2353060988*r**16
            -692343675*r**18-431678358*r**20+259611568*r**22+39233950*r**24+4251769*r**26)
            +9*(-1+r**2)**2*(-97216-2511921*r**2-27225617*r**4-9299584*r**6-144288472*r**8
            -237966173*r**10+54005547*r**12+360530624*r**14+475753968*r**16-228019571*r**18
            -800879011*r**20-235091776*r**22-48915032*r**24-2844159*r**26+128393*r**28)
            +3*Q2**2*(-9377568-44709831*r**2-725512025*r**4+8552342*r**6-1474571646*r**8
            -3317204649*r**10-499416303*r**12+2392309620*r**14+1231117116*r**16-4552437753*r**18
            -5985585783*r**20-1384697866*r**22-476320670*r**24-40812183*r**26+587199*r**28)
            -9*Q2*(-915664-11287273*r**2-131704502*r**4+83581671*r**6-468967464*r**8
            -631615725*r**10+707567946*r**12+643008259*r**14-377623232*r**16+437059093*r**18
            -736753138*r**20-2161656123*r**22-580469832*r**24-147032639*r**26-10529954*r**28
            +458577*r**30))+33177600*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(20480*Q2**17
            -35840*Q2**16*(28+25*r**2)+384*Q2**15*(26959+44437*r**2+17978*r**4)
            -40*Q2**14*(1271144+3106117*r**2+2449842*r**4+614645*r**6)+8*Q2**13*(17612980
            +60197969*r**2+72712172*r**4+36767453*r**6+6434830*r**8)-Q2**12*(217477680
            +1085854191*r**2+1849924634*r**4+1459156560*r**6+548381982*r**8+76490025*r**10)
            +2*Q2**11*(59067960+662966223*r**2+1540157253*r**4+1665755706*r**6+1019670902*r**8
            +350701911*r**10+52883565*r**12)-2*Q2**10*(-101229816+153568533*r**2
            +543563537*r**4+464123791*r**6+523367416*r**8+624863489*r**10+349861959*r**12
            +77576883*r**14)+10*Q2**9*(-45796968-168293181*r**2-603705503*r**4-1333035807*r**6
            -1364720109*r**8-564014459*r**10+4000647*r**12+71833239*r**14+19630125*r**16)
            +Q2**8*(317309920+2729556951*r**2+12158013948*r**4+31681498902*r**6+41480678780*r**8
            +26495350920*r**10+6661264476*r**12-915879062*r**14-857851668*r**16-172693055*r**18)
            +4*Q2**7*(21901880-381463897*r**2-1833311863*r**4-6806749550*r**6-11763021814*r**8
            -9555755010*r**10-3321620362*r**12+177446722*r**14+610687850*r**16+204503111*r**18
            +21465365*r**20)+4*Q2**6*(-76476120-163300653*r**2-1488258053*r**4-1187858361*r**6
            +1829574768*r**8+2404410604*r**10+150877932*r**12-1001921868*r**14-569732696*r**16
            -249306507*r**18-92607351*r**20+742785*r**22)-4*Q2**5*(-48245792-395336197*r**2
            -3101901813*r**4-6865230731*r**6-8125813551*r**8-7629473868*r**10-6208853512*r**12
            -3860976780*r**14-1438621656*r**16+217822849*r**18+352896493*r**20+27871527*r**22
            +11559031*r**24)+5*Q2**4*(-571312-181850477*r**2-1242128218*r**4-3825410436*r**6
            -5378078542*r**8-5491589561*r**10-5776700348*r**12-5489525888*r**14-3542088932*r**16
            -1228596031*r**18-91205610*r**20+376926212*r**22+53433058*r**24+7901285*r**26)
            -6*Q2**3*(10307960+167263*r**2+315908829*r**4-485588254*r**6-170868330*r**8
            +1043137865*r**10-830603501*r**12-3854773748*r**14-3539978372*r**16+753516545*r**18
            +2430781875*r**20+606315538*r**22+387583094*r**24+42148951*r**26+1832285*r**28)
            -9*(-1+r**2)**2*(-97216-2609137*r**2-29737538*r**4-36525201*r**6-153588056*r**8
            -382254645*r**10-183960626*r**12+414536171*r**14+836284592*r**16+247734397*r**18
            -1028898582*r**20-1035970787*r**22-284006808*r**24-51759191*r**26-2715766*r**28
            +128393*r**30)-6*Q2**2*(-6062280-43974609*r**2-582667681*r**4-233107335*r**6
            -1436460848*r**8-3343311735*r**10-846958557*r**12+1910959047*r**14+1245278520*r**16
            -1005071679*r**18-6374141475*r**20-6927626009*r**22-1801214016*r**24
            -479115385*r**26-35907423*r**28+981465*r**30)+18*Q2*(-506440-7260213*r**2
            -82645383*r**4-2741551*r**6-269150357*r**8-529636001*r**10+230800821*r**12
            +682564781*r**14+37041647*r**16-379780511*r**18-84389973*r**20-879881293*r**22
            -1560868223*r**24-433804171*r**26-100330457*r**28-6586161*r**30+293485*r**32))*sqrtq2)
            +logq2**3*(552960*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(
            -1044480*Q2**19+4608*Q2**18*(3268+2505*r**2)-128*Q2**17*(727409+1200064*r**2
            +466895*r**4)+16*Q2**16*(19492612+54007755*r**2+45203722*r**4+11702755*r**6)
            -32*Q2**15*(17682957+80810464*r**2+109165739*r**4+60874322*r**6+12077370*r**8)
            +Q2**14*(348005680+4033051115*r**2+7799374114*r**4+6945295200*r**6+3143637270*r**8
            +559110685*r**10)-2*Q2**13*(-350039704+743942165*r**2+1715232443*r**4
            +1948812318*r**6+2575298450*r**8+1582491581*r**10+316732475*r**12)+Q2**12*(
            -1678036704-6172888599*r**2-23758698076*r**4-45636149091*r**6-32126728616*r**8
            -4603053109*r**10+2533976676*r**12+634678575*r**14)+4*Q2**11*(256392816
            +2963476845*r**2+14638048517*r**4+39654319745*r**6+46031093425*r**8+23142039127*r**10
            +3650176655*r**12-588934149*r**14-120166005*r**16)+Q2**10*(923799312
            -6965621781*r**2-46190683642*r**4-225131228046*r**6-383973034650*r**8
            -305524528216*r**10-124157284302*r**12-21158116066*r**14+1173903762*r**16
            +54843165*r**18)+2*Q2**9*(-890319960-2589725415*r**2-16950677189*r**4
            +32149144320*r**6+107632581840*r**8+113660969170*r**10+85619605430*r**12
            +47857380536*r**14+14655727600*r**16+933059805*r**18+168458535*r**20)
            +Q2**8*(614940352+11600371265*r**2+102113389872*r**4+270998904227*r**6
            +573273740440*r**8+834480735258*r**10+553065222200*r**12+78077739702*r**14
            -74929611128*r**16-36563280075*r**18-3776014408*r**20-259226345*r**22)
            -8*Q2**7*(-89231308+826752897*r**2+8742067321*r**4+52119106331*r**6+141764198671*r**8
            +250573130758*r**10+227219644318*r**12+82743893706*r**14-7734862594*r**16
            -14985985879*r**18-4288963303*r**20-362367253*r**22+9891215*r**24)+Q2**6*(
            -698153904-1988650375*r**2-22362102642*r**4+176932288060*r**6+396874526210*r**8
            +1168857889701*r**10+1527777909260*r**12+644007078176*r**14-112678431660*r**16
            -239591128765*r**18-116240458842*r**20-19023498780*r**22-1136410214*r**24
            +170654175*r**26)+2*Q2**5*(21307624+2504772653*r**2+31776712139*r**4
            +75805725202*r**6+422949102350*r**8+426831607219*r**10+122471406893*r**12
            +157978788668*r**14+151955431724*r**16-9944525*r**18-19041033723*r**20
            +7853089074*r**22-831142562*r**24-130685331*r**26-13217405*r**28)-Q2**4*(
            -203218720+2457182285*r**2+32677408236*r**4+215174399565*r**6+920991693000*r**8
            +1201066513345*r**10+832238279140*r**12+723565116753*r**14+656997398160*r**16
            +415633883095*r**18+10104411700*r**20-126329956425*r**22-27105515064*r**24
            -11199370725*r**26-982127620*r**28+53103275*r**30)+12*Q2**3*(-6647392
            -25400425*r**2-379087353*r**4+6187332807*r**6+6003461855*r**8+29577946107*r**10
            +12920741035*r**12+4877154171*r**14+60630320371*r**16+75320399045*r**18
            +45738646037*r**20+27958748725*r**22-3088826243*r**24-916374103*r**26
            -571941575*r**28-51831927*r**30+1998865*r**32)+9*(-1+r**2)**2*(-311104
            +5014939*r**2+89255150*r**4+762135830*r**6+4555990870*r**8-3031759278*r**10
            +13799835558*r**12+32858727790*r**14-6907401810*r**16-75656892840*r**18
            -23394636182*r**20+70036889442*r**22+25981108770*r**24+10048421230*r**26
            +1645555970*r**28+17484314*r**30-6307814*r**32+89165*r**34)+3*Q2**2*(
            -5145136+278359739*r**2+3933622318*r**4+8169264838*r**6+114305829078*r**8
            -66214108174*r**10+130164248486*r**12+267347604574*r**14-115688256626*r**16
            -149266246856*r**18+264721070506*r**20+458573871986*r**22+133804238498*r**24
            +77094601038*r**26+11662299778*r**28+583304554*r**30-22736086*r**32+1377485*r**34)
            -18*Q2*(-878936+19350345*r**2+271853971*r**4+1383559540*r**6+10271407020*r**8
            -15943854272*r**10+28589240400*r**12+30028939652*r**14-24589848660*r**16
            -9201546390*r**18-55387138498*r**20-5314505060*r**22+94636610308*r**24
            +30581270600*r**26+13816066120*r**28+2421390956*r**30+35762940*r**32
            -11535931*r**34+255895*r**36))-552960*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(1044480*Q2**19-4608*Q2**18*(3268+2505*r**2)+128*Q2**17*(727409
            +1200064*r**2+466895*r**4)-16*Q2**16*(19492612+54007755*r**2+45203722*r**4
            +11702755*r**6)+32*Q2**15*(17682957+80810464*r**2+109165739*r**4+60874322*r**6
            +12077370*r**8)-Q2**14*(348005680+4033051115*r**2+7799374114*r**4+6945295200*r**6
            +3143637270*r**8+559110685*r**10)+2*Q2**13*(-350039704+743942165*r**2
            +1715232443*r**4+1948812318*r**6+2575298450*r**8+1582491581*r**10+316732475*r**12)
            +Q2**12*(1678036704+6172888599*r**2+23758698076*r**4+45636149091*r**6
            +32126728616*r**8+4603053109*r**10-2533976676*r**12-634678575*r**14)
            +4*Q2**11*(-256392816-2963476845*r**2-14638048517*r**4-39654319745*r**6
            -46031093425*r**8-23142039127*r**10-3650176655*r**12+588934149*r**14
            +120166005*r**16)+Q2**10*(-923799312+6965621781*r**2+46190683642*r**4
            +225131228046*r**6+383973034650*r**8+305524528216*r**10+124157284302*r**12
            +21158116066*r**14-1173903762*r**16-54843165*r**18)-2*Q2**9*(-890319960
            -2589725415*r**2-16950677189*r**4+32149144320*r**6+107632581840*r**8
            +113660969170*r**10+85619605430*r**12+47857380536*r**14+14655727600*r**16
            +933059805*r**18+168458535*r**20)+Q2**8*(-614940352-11600371265*r**2
            -102113389872*r**4-270998904227*r**6-573273740440*r**8-834480735258*r**10
            -553065222200*r**12-78077739702*r**14+74929611128*r**16+36563280075*r**18
            +3776014408*r**20+259226345*r**22)+8*Q2**7*(-89231308+826752897*r**2
            +8742067321*r**4+52119106331*r**6+141764198671*r**8+250573130758*r**10
            +227219644318*r**12+82743893706*r**14-7734862594*r**16-14985985879*r**18
            -4288963303*r**20-362367253*r**22+9891215*r**24)+Q2**6*(698153904+1988650375*r**2
            +22362102642*r**4-176932288060*r**6-396874526210*r**8-1168857889701*r**10
            -1527777909260*r**12-644007078176*r**14+112678431660*r**16+239591128765*r**18
            +116240458842*r**20+19023498780*r**22+1136410214*r**24-170654175*r**26)
            +2*Q2**5*(-21307624-2504772653*r**2-31776712139*r**4-75805725202*r**6
            -422949102350*r**8-426831607219*r**10-122471406893*r**12-157978788668*r**14
            -151955431724*r**16+9944525*r**18+19041033723*r**20-7853089074*r**22
            +831142562*r**24+130685331*r**26+13217405*r**28)+Q2**4*(-203218720+2457182285*r**2
            +32677408236*r**4+215174399565*r**6+920991693000*r**8+1201066513345*r**10
            +832238279140*r**12+723565116753*r**14+656997398160*r**16+415633883095*r**18
            +10104411700*r**20-126329956425*r**22-27105515064*r**24-11199370725*r**26
            -982127620*r**28+53103275*r**30)-12*Q2**3*(-6647392-25400425*r**2-379087353*r**4
            +6187332807*r**6+6003461855*r**8+29577946107*r**10+12920741035*r**12
            +4877154171*r**14+60630320371*r**16+75320399045*r**18+45738646037*r**20
            +27958748725*r**22-3088826243*r**24-916374103*r**26-571941575*r**28-51831927*r**30
            +1998865*r**32)-9*(-1+r**2)**2*(-311104+5014939*r**2+89255150*r**4+762135830*r**6
            +4555990870*r**8-3031759278*r**10+13799835558*r**12+32858727790*r**14
            -6907401810*r**16-75656892840*r**18-23394636182*r**20+70036889442*r**22
            +25981108770*r**24+10048421230*r**26+1645555970*r**28+17484314*r**30
            -6307814*r**32+89165*r**34)-3*Q2**2*(-5145136+278359739*r**2+3933622318*r**4
            +8169264838*r**6+114305829078*r**8-66214108174*r**10+130164248486*r**12
            +267347604574*r**14-115688256626*r**16-149266246856*r**18+264721070506*r**20
            +458573871986*r**22+133804238498*r**24+77094601038*r**26+11662299778*r**28
            +583304554*r**30-22736086*r**32+1377485*r**34)+18*Q2*(-878936+19350345*r**2
            +271853971*r**4+1383559540*r**6+10271407020*r**8-15943854272*r**10+28589240400*r**12
            +30028939652*r**14-24589848660*r**16-9201546390*r**18-55387138498*r**20
            -5314505060*r**22+94636610308*r**24+30581270600*r**26+13816066120*r**28
            +2421390956*r**30+35762940*r**32-11535931*r**34+255895*r**36))*sqrtq2)
            +logq2**2*(-9216*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(4878336*Q2**22
            -1536*Q2**21*(39352+37027*r**2)+64*Q2**20*(4921049+9960882*r**2+4487049*r**4)
            -160*Q2**19*(5318554+18801191*r**2+17878624*r**4+5148931*r**6)+40*Q2**18*(26278806
            +183500147*r**2+281411678*r**4+178534691*r**6+37504674*r**8)-Q2**17*(
            -388068776+7816888405*r**2+16653089190*r**4+18317134680*r**6+10800439130*r**8
            +1892506539*r**10)+Q2**16*(-3154074112-5483530797*r**2-24455183635*r**4
            -36864324030*r**6-3989418330*r**8+9732880283*r**10+1829213213*r**12)
            +Q2**15*(3610583136+28939070878*r**2+147538912726*r**4+348622077730*r**6
            +292524721120*r**8+77662845046*r**10-3532506182*r**12-1305775974*r**14)
            +10*Q2**14*(70155632-3456179207*r**2-23719684668*r**4-90086280778*r**6
            -121046268789*r**8-70516540983*r**10-16192618394*r**12-418973608*r**14
            +15843243*r**16)+10*Q2**13*(-524242432+35538941*r**2+4373594909*r**4
            +91678678242*r**6+190435697729*r**8+176269320252*r**10+86181376191*r**12
            +19030392182*r**14+1057964483*r**16+96786767*r**18)+Q2**12*(3612769056
            +46098718590*r**2+395606988120*r**4+488605225830*r**6+383369348510*r**8
            +250930618874*r**10-519455807290*r**12-625983835230*r**14-186949849830*r**16
            -15024648960*r**18-647353974*r**20)-2*Q2**11*(-995222384+24113342901*r**2
            +269518097685*r**4+1210674944085*r**6+3093097698350*r**8+5340672823404*r**10
            +4042836985864*r**12+919103843620*r**14-223415208270*r**16-94230544985*r**18
            -7401386829*r**20+349576191*r**22)+2*Q2**10*(-1922338912-419429111*r**2
            +33494959928*r**4+1248417883100*r**6+4462345505815*r**8+12062804168322*r**10
            +14476526334256*r**12+7864023975952*r**14+1643105441790*r**16-147260465155*r**18
            -51120787712*r**20-2684257396*r**22+457695203*r**24)+10*Q2**9*(82676328
            +4030009132*r**2+46005469663*r**4-11372672456*r**6-126909627187*r**8
            -1844709319168*r**10-3458456914738*r**12-2826282999088*r**14-1345857069670*r**16
            -364286671132*r**18-22028941517*r**20-7377747944*r**22-767396207*r**24
            +10919952*r**26)-10*Q2**8*(-157354192+2722507646*r**2+39074401779*r**4
            +230862035901*r**6+1106482225751*r**8+1559529290505*r**10+1631408727924*r**12
            +1676799953082*r**14+398457582390*r**16-611256926048*r**18-408524655989*r**20
            -70236041079*r**22-13218347325*r**24-931411367*r**26+51620622*r**28)
            +2*Q2**7*(-487601392-3548967795*r**2-14825711335*r**4+1169556133815*r**6
            +6306747972460*r**8+21781246248107*r**10+39798506100325*r**12+51978501794785*r**14
            +33884124979600*r**16+4631963682475*r**18-4900566817373*r**20-2454289238815*r**22
            -379743334860*r**24-17847226275*r**26+353722655*r**28+12692423*r**30)
            +2*Q2**6*(-108014256+8359561879*r**2+100974746260*r**4-204647637410*r**6
            -545221662355*r**8-14442120606079*r**10-23772411855634*r**12-44288122542540*r**14
            -39971641311045*r**16-8170789373895*r**18+8149412483336*r**20+6848674285886*r**22
            +1881106451555*r**24+271223422255*r**26-12198883850*r**28-3041508176*r**30
            +114876069*r**32)-2*Q2**5*(-173778848+2313424241*r**2+43240752717*r**4
            +547529394670*r**6+3972085252685*r**8+3615328679898*r**10+25434715523929*r**12
            +12893957942558*r**14-5559488861895*r**16+3473409460820*r**18+2020212655783*r**20
            +22366610874*r**22+1431702561383*r**24+76548977350*r**26+49316290995*r**28
            -3219765958*r**30-997358669*r**32+25837467*r**34)-10*Q2**4*(4370096+349498619*r**2
            +1875895136*r**4-94950173505*r**6-567725544201*r**8-2084623084581*r**10
            -7095661860657*r**12-5545405041221*r**14-903718200461*r**16-2488963790203*r**18
            -3087836168501*r**20+212263604557*r**22+994193121909*r**24+183468241017*r**26
            +150226933629*r**28+27006280761*r**30-52357519*r**32-172243924*r**34
            +5959049*r**36)+30*Q2**3*(-1737328+75368039*r**2+786476511*r**4-4159338285*r**6
            -2027251858*r**8-337178223414*r**10-216767708294*r**12-540942667390*r**14
            +261316502022*r**16-562235522456*r**18-1807693366328*r**20-1358736414984*r**22
            -1003678578198*r**24-58472774474*r**26-43702667514*r**28+18410164670*r**30
            +6990973714*r**32+188064177*r**34-36378663*r**36+760053*r**38)+9*(-1
            +r**2)**2*(-90016+7540385*r**2+30332435*r**4-2387787275*r**6-14102646305*r**8
            -78502685276*r**10-404509612180*r**12+911491418420*r**14-1599158438500*r**16
            -3129057249010*r**18+4190852558474*r**20+4307917257830*r**22-3813520240270*r**24
            -1197070204300*r**26-742341291940*r**28-238625002556*r**30-21088016660*r**32
            +1053380665*r**34+99890075*r**36-4358995*r**38+44999*r**40)+6*Q2**2*(2826936
            +7401005*r**2-834593960*r**4-37144834380*r**6-253525107425*r**8-55817627104*r**10
            -4981114853060*r**12+4944570459860*r**14-3363830064480*r**16-3894738208270*r**18
            +3063318768476*r**20-4968239912020*r**22-9740565714090*r**24-2208161649400*r**26
            -2800818842060*r**28-601624670884*r**30-51573552800*r**32-1403524935*r**34
            -116616740*r**36-19519120*r**38+1034451*r**40)-9*Q2*(-136392+36351243*r**2
            +33887960*r**4-14214583280*r**6-72047280360*r**8-203861787887*r**10-1828595062512*r**12
            +4656128247120*r**14-5432602936160*r**16-5725420982370*r**18+3439464084288*r**20
            +8899325326128*r**22+4039345926880*r**24-9672333292590*r**26-2699314193680*r**28
            -2004063395472*r**30-643113351192*r**32-58462702585*r**34+3750818280*r**36
            +307100160*r**38-23273912*r**40+436333*r**42))+9216*r**12*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**4*(4878336*Q2**23-4608*Q2**22*(14176+13401*r**2)
            +64*Q2**21*(5865497+11793978*r**2+5375697*r**4)-32*Q2**20*(36434868+123769817*r**2
            +118288982*r**4+34718753*r**6)+40*Q2**19*(47553022+279979127*r**2+428130938*r**4
            +270644911*r**6+58100398*r**8)-Q2**18*(663083464+16208046525*r**2+35249562190*r**4
            +36714989440*r**6+19442013730*r**8+3392693499*r**10)+8*Q2**17*(-442767861
            +243161104*r**2+1849245*r**4-236762520*r**6+3141019435*r**8+2803228244*r**10
            +465214969*r**12)+Q2**16*(6764657248+37576675787*r**2+177477627158*r**4
            +409941585395*r**6+333378463480*r**8+71919383093*r**10-15094599678*r**12
            -3134989187*r**14)+4*Q2**15*(-727256704-16777861521*r**2-103418707571*r**4
            -349255949559*r**6-462902371685*r**8-268838243999*r**10-59014130701*r**12
            +162136519*r**14+366052101*r**16)+40*Q2**14*(-148599516+855390629*r**2
            +7887364696*r**4+51371160922*r**6+100392061824*r**8+91958032506*r**10
            +43222633892*r**12+8910496046*r**14+365273712*r**16+20235881*r**18)-4*Q2**13*(
            -2213798344-12746438375*r**2-87878912405*r**4+117979376420*r**6+609443602800*r**8
            +854029890234*r**10+785990692930*r**12+419525379740*r**14+96958354120*r**16
            +6643040365*r**18+403805411*r**20)-8*Q2**12*(202790536+12242271681*r**2
            +122592737760*r**4+413195262765*r**6+882271246380*r**8+1414455701774*r**10
            +977143597914*r**12+86596005590*r**14-157470512700*r**16-48804448595*r**18
            -3809347074*r**20+6474801*r**22)+4*Q2**11*(-1458780648+11349345703*r**2
            +163563200257*r**4+1364305462435*r**6+4383059074125*r**8+10248287345038*r**10
            +11930018071762*r**12+6412982402718*r**14+1169397038570*r**16-232453109205*r**18
            -76376359763*r**20-4868034017*r**22+403635697*r**24)-2*Q2**10*(-2335720552
            -22491813683*r**2-196951817498*r**4+1338776205308*r**6+6345311524850*r**8
            +25748696269977*r**10+43831615076268*r**12+36471965305648*r**14+16236414766092*r**16
            +3317278332295*r**18-88236545282*r**20-16916305388*r**22+1610418842*r**24
            +403095443*r**26)-20*Q2**9*(-37338932+3417596553*r**2+44554940287*r**4
            +132747416554*r**6+484099963054*r**8-206044827925*r**10-1835878752991*r**12
            -2303969980372*r**14-1886841243184*r**16-1160700333425*r**18-397420134319*r**20
            -49821365270*r**22-10681745738*r**24-843943811*r**26+31270287*r**28)
            +2*Q2**8*(-1274372352+9276799475*r**2+194158835790*r**4+2519238322215*r**6
            +12993469280720*r**8+35111303829387*r**10+55753196192470*r**12+68519545199815*r**14
            +44260412656960*r**16+3567966964185*r**18-9999474727558*r**20-4848092724155*r**22
            -797015276880*r**24-88596019735*r**26-4045231070*r**28+270795533*r**30)
            +4*Q2**7*(189793568+6198065533*r**2+59674712695*r**4-679689029945*r**6
            -4010762884315*r**8-21265057413323*r**10-42676082102033*r**12-68032565218825*r**14
            -62917134042715*r**16-23343439017985*r**18+4209007809117*r**20+7101765171037*r**22
            +2357569512615*r**24+334406991695*r**26+2647309885*r**28-1703961627*r**30
            +51091823*r**32)-16*Q2**6*(-35224138+1320621483*r**2+19071882607*r**4
            +55482062940*r**6+402776994115*r**8-1421501698567*r**10-1597477117223*r**12
            -6895822056952*r**14-11227406589435*r**16-5583627653015*r**18+249854470653*r**20
            +1877556672512*r**22+1270185412353*r**24+278609856395*r**26+38542603675*r**28
            -2307519748*r**30-490498847*r**32+17589192*r**34)-4*Q2**5*(97814664-196076149*r**2
            -18087350639*r**4-532760507456*r**6-3679121184180*r**8-9005264677744*r**10
            -32264176753556*r**12-33027849336296*r**14-5926530041484*r**16-5179369774970*r**18
            -10466401479554*r**20-490630621936*r**22+1758448218644*r**24-295455166824*r**26
            +312634699900*r**28+44467439384*r**30+1977668516*r**32+55150791*r**34
            +1978889*r**36)+80*Q2**4*(-105236+72496604*r**2+573102911*r**4-13194036653*r**6
            -83594684160*r**8-457985412378*r**10-1228823508765*r**12-1782986863006*r**14
            -708146716952*r**16-634923569754*r**18-1374985007211*r**20-868972726112*r**22
            -225572376016*r**24+125280379938*r**26+25323396513*r**28+29057963550*r**30
            +5990855548*r**32+42448886*r**34-34427608*r**36+1029901*r**38)-12*Q2**3*(
            -5756788+180376275*r**2+2571908355*r**4+10140262755*r**6+111296078355*r**8
            -820104874628*r**10+1105692597260*r**12-4366561169140*r**14+982849618820*r**16
            +1195071553050*r**18-7456481606198*r**20-5431954497270*r**22-1035754625910*r**24
            -1551297556980*r**26+1144970816060*r**28+237581078332*r**30+89289622360*r**32
            +18649357195*r**34+437522155*r**36-79286965*r**38+1382907*r**40)+3*Q2**2*(
            -5244696-129509611*r**2+1552722030*r**4+118602606520*r**6+797481724690*r**8
            +1230270832719*r**10+15559650147864*r**12-13895295954960*r**14+13136328017720*r**16
            +31693399492610*r**18-8655553373276*r**20-22888133691296*r**22+17299573471580*r**24
            +52914454604750*r**26+18115903563960*r**28+12817077212304*r**30+3235736500944*r**32
            +281342263225*r**34-8212171490*r**36-649028760*r**38+106791074*r**40
            -3377901*r**42)-9*(-1+r**2)**2*(-90016+7450369*r**2+37872820*r**4-2357454840*r**6
            -16490433580*r**8-92605331581*r**10-483012297456*r**12+506981806240*r**14
            -687667020080*r**16-4728215687510*r**18+1061795309464*r**20+8498769816304*r**22
            +494397017560*r**24-5010590444570*r**26-1939411496240*r**28-980966294496*r**30
            -259713019216*r**32-20034635995*r**34+1153270740*r**36+95531080*r**38
            -4313996*r**40+44999*r**42)+36*Q2*(-56602+10983817*r**2+21350213*r**4
            -4155401770*r**6-23889650740*r**8-82148562047*r**10-573515934583*r**12
            +1117385285528*r**14-1150781394140*r**16-2544318218030*r**18+1640962929978*r**20
            +1283986075572*r**22+1175042263888*r**24+1276225042090*r**26-3633342152470*r**28
            -1163597553032*r**30-733339012538*r**32-224242910587*r**34-19451693055*r**36
            +1226789990*r**38+98119828*r**40-6821643*r**42+120333*r**44))*sqrtq2)
            +logq2*(768*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(-49664*Q2**21+64*Q2**20*(9719
            +13274*r**2)-8*Q2**19*(400040+1234843*r**2+705075*r**4)+16*Q2**18*(518205
            +2797366*r**2+3415163*r**4+1258468*r**6)-Q2**17*(8926920+89691929*r**2
            +142005133*r**4+144431107*r**6+42963399*r**8)+Q2**16*(-7493104+16689061*r**2
            -256846802*r**4-149010368*r**6+180371994*r**8+55365555*r**10)+Q2**15*(34199856
            +285772672*r**2+2209548502*r**4+3985653518*r**6+1782812098*r**8-28695270*r**10
            -39267872*r**12)+2*Q2**14*(-16198920-266128834*r**2-2354350905*r**4-7258362376*r**6
            -6828518600*r**8-2259905592*r**10-113272719*r**12+5677290*r**14)+Q2**13*(
            -16365040+176111932*r**2+2526551546*r**4+21986474014*r**6+33143626528*r**8
            +22707254672*r**10+6461011938*r**12+381483446*r**14-6975084*r**16)+2*Q2**12*(29015480
            +311986256*r**2+3373184967*r**4-1430245968*r**6-4859643237*r**8-8418967704*r**10
            -10170233747*r**12-3490052440*r**14-225410407*r**16+11650576*r**18)-2*Q2**11*(16038152
            +419829504*r**2+6675694417*r**4+21881145729*r**6+59510167157*r**8+85165330525*r**10
            +34531919403*r**12-3735985221*r**14-3145504265*r**16-225905529*r**18
            +12208688*r**20)+2*Q2**10*(-13892632+45377134*r**2+2881097307*r**4+34877938992*r**6
            +125101933938*r**8+287252309450*r**10+243484343848*r**12+80407889854*r**14
            +2704163382*r**16-1446371344*r**18-105110483*r**20+2485290*r**22)+2*Q2**9*(21016320
            +309435409*r**2+4432706960*r**4-14354960648*r**6-51825934245*r**8-319360415846*r**10
            -410966550664*r**12-247231095120*r**14-81794758978*r**16-6468917835*r**18
            -965058536*r**20-58942696*r**22+2942695*r**24)+2*Q2**8*(-3521880-231182591*r**2
            -6203321983*r**4-24347254696*r**6-155893508613*r**8-82634140027*r**10
            -31901367470*r**12-11551283512*r**14+95384460710*r**16+73498495187*r**18
            +10479058573*r**20+1600008128*r**22+55244567*r**24+398727*r**26)-2*Q2**7*(9041080
            +35355056*r**2-1520605153*r**4-38593119709*r**6-233111613735*r**8-513160056083*r**10
            -751246400042*r**12-818112289506*r**14-234645282710*r**16+126559025418*r**18
            +92918234827*r**20+14915893535*r**22+499372133*r**24-58498887*r**26+3251616*r**28)
            +2*Q2**6*(5589288+118765354*r**2+2428336837*r**4-14493412840*r**6-43951039292*r**8
            -415497146660*r**10-456145379631*r**12-909823013338*r**14-436887403592*r**16
            +89755313746*r**18+192612900583*r**20+65433390612*r**22+10657522076*r**24
            -116866328*r**26-68089149*r**28+1437934*r**30)+2*Q2**5*(947448-40785098*r**2
            -2105640717*r**4-14185475111*r**6-149811614728*r**8+46980064580*r**10
            -700029014255*r**12+114685729363*r**14+190958620442*r**16-117338132858*r**18
            +60614261013*r**20-53901142273*r**22+10323278484*r**24+1953281024*r**26
            +13052391*r**28-7367211*r**30+759906*r**32)-2*Q2**4*(1957240+15932828*r**2
            -306813245*r**4-16897813024*r**6-121222245445*r**8-109852417888*r**10
            -1030865589033*r**12+3930103640*r**14+295911721503*r**16-597638867920*r**18
            -58764635639*r**20+181840002992*r**22-14663992655*r**24+27818806096*r**26
            +7433769565*r**28+47186712*r**30-32566787*r**32+789060*r**34)+2*Q2**3*(418760
            +13724572*r**2+389203281*r**4-3817851555*r**6-2620728051*r**8-105413241059*r**10
            -147493720799*r**12+114742323449*r**14+176893404521*r**16-598170269423*r**18
            -213137599177*r**20-360010395273*r**22+19433092839*r**24-36202904937*r**26
            +5544926699*r**28+2920870451*r**30+91104475*r**32-8399969*r**34+89196*r**36)
            +3*(-1+r**2)**2*(12832+158779*r**2-1974418*r**4-279967375*r**6-1895904188*r**8
            +2279453544*r**10-70211831812*r**12+230547022144*r**14-389533269740*r**16
            -57002335226*r**18+663127883416*r**20-386433664838*r**22+14896376716*r**24
            -45319593520*r**26-18593387484*r**28-2585612792*r**30+34847996*r**32
            +8258183*r**34-317990*r**36+5773*r**38)+2*Q2**2*(236560-1801798*r**2
            -232276991*r**4-3265932000*r**6-35177631886*r**8+85795650546*r**10-599388738170*r**12
            +867551145234*r**14-489724439014*r**16-77001046626*r**18-51089083272*r**20
            -418830244966*r**22-72155274570*r**24-180305376122*r**26-59121590790*r**28
            -8452873834*r**30+655445934*r**32+9339952*r**34-5482489*r**36+134302*r**38)
            -3*Q2*(88168+518587*r**2-33087279*r**4-1486765377*r**6-10345323243*r**8
            +29563503620*r**10-317955304356*r**12+927004524372*r**14-1193115567844*r**16
            -139400156846*r**18+942042463942*r**20+269425566026*r**22-541966600482*r**24
            -39343392156*r**26-108286367204*r**28-52131986316*r**30-8184033132*r**32
            +328896139*r**34+29819377*r**36-2197457*r**38+41461*r**40))-768*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(397312*Q2**25-1536*Q2**24*(3466+4651*r**2)
            +64*Q2**23*(462641+1397346*r**2+792561*r**4)-8*Q2**22*(10528672+55819061*r**2
            +68095018*r**4+24309045*r**6)+16*Q2**21*(6583439+65126303*r**2+114016958*r**4
            +102819267*r**6+27673237*r**8)-Q2**20*(-63230264+579520263*r**2-580318198*r**4
            +704846112*r**6+2535199318*r**8+588346625*r**10)+4*Q2**19*(-100952974
            -699309469*r**2-4987103685*r**4-9010817190*r**6-3677858700*r**8+311977091*r**10
            +89368351*r**12)+2*Q2**18*(224018452+3409063147*r**2+27239370852*r**4
            +83553129935*r**6+79226843060*r**8+24750984937*r**10+1092879092*r**12
            +45165437*r**14)-8*Q2**17*(-24099313+479083686*r**2+5818608203*r**4+40455445455*r**6
            +63262192820*r**8+41419086232*r**10+10272473891*r**12+595719603*r**14
            +22099855*r**16)+Q2**16*(-885708096-7628060167*r**2-63886623782*r**4
            +162886749962*r**6+483867254642*r**8+558085750584*r**10+372505209078*r**12
            +88676722758*r**14+5194081182*r**16-204045793*r**18)+16*Q2**15*(33929114
            +866470637*r**2+11633326828*r**4+35059284073*r**6+79687054617*r**8+113257948913*r**10
            +39431755007*r**12-10302094817*r**14-4318643707*r**16-276976198*r**18
            +24585085*r**20)-8*Q2**14*(-68781668+426094257*r**2+14840618160*r**4
            +158673283415*r**6+545758874270*r**8+1230784206238*r**10+1078316255468*r**12
            +349489788650*r**14+16634117510*r**16-2845993875*r**18-156634508*r**20
            +7589587*r**22)-16*Q2**13*(55018116+718512956*r**2+7780531071*r**4-50847228915*r**6
            -245581872930*r**8-1054183820136*r**10-1463733826156*r**12-894453329756*r**14
            -241283808100*r**16-18140830880*r**18-2386697999*r**20-212614949*r**22
            +14511806*r**24)+2*Q2**12*(39108872+5520968921*r**2+119610934718*r**4
            +430725823140*r**6+1766184546610*r**8-2784353375587*r**10-9220225949036*r**12
            -9201650077408*r**14-5626888844460*r**16-1724094092885*r**18-193846908418*r**20
            -27961189444*r**22-1489748382*r**24+36480415*r**26)+8*Q2**11*(71145518
            +188805561*r**2-9095499809*r**4-242900704596*r**6-1299905706886*r**8
            -3072981992823*r**10-4448534857921*r**12-5251862405736*r**14-1853890622654*r**16
            +647265708171*r**18+430617666413*r**20+71223169996*r**22+1631493126*r**24
            -322526941*r**26+19643269*r**28)-4*Q2**10*(77013044+1913259887*r**2+32531937108*r**4
            -232589311017*r**6-1449328931208*r**8-10610291379821*r**10-24223323419972*r**12
            -45302449171173*r**14-37267862355748*r**16-11416700249907*r**18+651244552292*r**20
            +656641177637*r**22+117708953208*r**24-5306838927*r**26-1005504628*r**28
            +23878825*r**30)-16*Q2**9*(10528181-187383124*r**2-7726998330*r**4-59248391870*r**6
            -328794018170*r**8+1369852890724*r**10+3718887982884*r**12+14331543975640*r**14
            +18306295224300*r**16+10489448705780*r**18+3021562841334*r**20+80615746314*r**22
            +37129314930*r**24+7410457660*r**26+843605600*r**28-19527524*r**30+3599911*r**32)
            +2*Q2**8*(99103952+1022116317*r**2+1200704522*r**4-674277672570*r**6
            -4068845613310*r**8-10523854553562*r**10-41571375393262*r**12-4941687851922*r**14
            +36850195232010*r**16+23170706039240*r**18+28199115727278*r**20+19503566507618*r**22
            +3515230687318*r**24+1187408774170*r**26+229161751990*r**28+699434282*r**30
            -1218072498*r**32+30256027*r**34)+16*Q2**7*(-7906-120990923*r**2-3438295714*r**4
            +15107088175*r**6+129379345015*r**8+2687374035601*r**10+9503133120593*r**12
            +20797937919119*r**14+27066868136555*r**16+29263750972275*r**18+11529013180981*r**20
            -2626941636267*r**22-3169296150131*r**24-750443739245*r**26-69625376405*r**28
            -7510575891*r**30+58683507*r**32+22026036*r**34+565425*r**36)-16*Q2**6*(4034006
            -4734688*r**2-1390770233*r**4-33825618707*r**6-147262662927*r**8+1366160484874*r**10
            +2434221494978*r**12+20667059659898*r**14+23971536251977*r**16+34768377632672*r**18
            +20384583423804*r**20-2179155849322*r**22-7715864019637*r**24-3115375138278*r**26
            -762810949618*r**28-24515727734*r**30+12196249957*r**32+282199772*r**34
            -65883667*r**36+1570873*r**38)+16*Q2**5*(1084329+29482317*r**2+503077833*r**4
            -21020818262*r**6-117370209563*r**8-793056291312*r**10-5316439359042*r**12
            +3488358874342*r**14-20998862186758*r**16-1623307871002*r**18+9600022043452*r**20
            -743549171882*r**22-897184743418*r**24-2816992660528*r**26-255873541782*r**28
            -175397240454*r**30-28531964443*r**32+5408659693*r**34+261991123*r**36
            -24063328*r**38+268685*r**40)+Q2**4*(10383224-165628491*r**2-8187597010*r**4
            -41548878840*r**6+451059629490*r**8+20038540267999*r**10+65276074353384*r**12
            +135286119603440*r**14+597734012613480*r**16+97143300613570*r**18-184195613898956*r**20
            +276109461577984*r**22+6254364491500*r**24-105605399686290*r**26-8731889983960*r**28
            -14928796463856*r**30-5042937963056*r**32-208169750055*r**34+47969835150*r**36
            +839473400*r**38-229502286*r**40+5070179*r**42)-12*Q2**3*(459498+2337023*r**2
            -82933957*r**4-7724394490*r**6-5918066760*r**8+443094816223*r**10-230762819937*r**12
            +10615585029048*r**14+3127584478860*r**16-6447456233890*r**18-4300135095482*r**20
            +30670481440948*r**22+20456193495528*r**24+19486229005750*r**26+2443184777510*r**28
            +2385359594328*r**30+128387222298*r**32-240012307197*r**34-39615703745*r**36
            +2033166390*r**38+172601808*r**40-11603957*r**42+174203*r**44)-9*(-1
            +r**2)**2*(12832-20869*r**2-5403532*r**4-267430397*r**6+2207024280*r**8
            +55166846057*r**10+80008381076*r**12+1025506725633*r**14+2948912356768*r**16
            -15289711541490*r**18+34779417790312*r**20+1372008277086*r**22-56500553933232*r**24
            +26730102924178*r**26+5288820701640*r**28+3922780664002*r**30+2433382536576*r**32
            +457555819943*r**34+14213547428*r**36-3845296305*r**38-50956328*r**40
            +12167381*r**42-398812*r**44+5773*r**46)-6*Q2**2*(59396-4889817*r**2
            -161580876*r**4+2807399555*r**6+27259473900*r**8+628363128681*r**10+2626730752148*r**12
            -5853341932731*r**14+58129944803320*r**16-75559581518810*r**18+12344788867896*r**20
            +33134722840798*r**22+23988995001064*r**24+44247405752850*r**26-617004039080*r**28
            +18554422929706*r**30+5284773060228*r**32+632913890819*r**34-9840526380*r**36
            +9019509615*r**38+947521196*r**40-38332107*r**42-2223276*r**44+51905*r**46)
            +72*Q2*(9417-88466*r**2-5593841*r**4-102660549*r**6+1481338376*r**8
            +36384607472*r**10+48415877279*r**12+198902021959*r**14+2433731454531*r**16
            -9124086673564*r**18+12667391606782*r**20+4405989352134*r**22-13714243704256*r**24
            -4317333008024*r**26+7640377132086*r**28+932287330102*r**30+1527852212759*r**32
            +767814937374*r**34+152576029651*r**36+1945947391*r**38-1577170648*r**40
            +24207544*r**42+5528139*r**44-298109*r**46+4461*r**48))*sqrtq2))*math.log(mu0))/(14000*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2
            +14000*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2
            +logq2**7*(-112870195200000*r**32*(1+r**2)**2*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3-112870195200000*r**32*(1+r**2)**2*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**6*(627056640000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))+627056640000*r**28*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))*sqrtq2)+logq2*(-840000*(-Q2+(
            -1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(9+8*Q2**4-78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)
            -Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-840000*(-Q2+(-1+r)**2)**3*r**8*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(9+8*Q2**4-78*r**2-366*r**4
            -78*r**6+9*r**8-Q2**3*(1+r**2)-Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1
            +13*r**2+13*r**4+r**6))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*sqrtq2)+logq2**2*(10080000*(-Q2+(-1+r)**2)**3*r**12*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531
            +550*r**2+531*r**4)-2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815
            -2120*r**2-11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4
            +494*r**6+225*r**8+r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6
            +26793*r**8+4554*r**10-501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6
            -1385*r**8-311*r**10+15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6
            +34670*r**8+13388*r**10-184*r**12-316*r**14+17*r**16))+10080000*(-Q2
            +(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531+550*r**2+531*r**4)
            -2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815-2120*r**2-11502*r**4
            -2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4+494*r**6+225*r**8
            +r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6+26793*r**8+4554*r**10
            -501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6-1385*r**8-311*r**10
            +15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6+34670*r**8+13388*r**10
            -184*r**12-316*r**14+17*r**16))*sqrtq2)+logq2**3*(-120960000*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8+256*Q2**7*(1+r**2)
            -Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2+893*r**4+319*r**6)
            +Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)+12*Q2**3*(61
            +235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(-1071+9654*r**2
            +51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)-18*Q2*(23
            -35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12+23*r**14)
            +9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10-264*r**12
            -756*r**14+47*r**16))-120960000*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8
            +256*Q2**7*(1+r**2)-Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2
            +893*r**4+319*r**6)+Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)
            +12*Q2**3*(61+235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(
            -1071+9654*r**2+51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)
            -18*Q2*(23-35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12
            +23*r**14)+9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10
            -264*r**12-756*r**14+47*r**16))*sqrtq2)+logq2**4*(1451520000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513+770*r**2
            +513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105-3400*r**2
            -11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4-1178*r**6
            +75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6+19593*r**8
            +3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6-5785*r**8
            -2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4+25204*r**6
            +52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))+1451520000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513
            +770*r**2+513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105
            -3400*r**2-11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4
            -1178*r**6+75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6
            +19593*r**8+3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6
            -5785*r**8-2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4
            +25204*r**6+52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))*sqrtq2)
            +logq2**5*(-3483648000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(64*Q2**8+1088*Q2**7*(1+r**2)+Q2**6*(-63+130*r**2-63*r**4)
            -2*Q2**5*(2777+6379*r**2+6379*r**4+2777*r**6)+Q2**4*(1555-8080*r**2
            -22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743-315*r**2-6548*r**4-6548*r**6
            -315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2+199629*r**4+305844*r**6
            +199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83-375*r**2-2833*r**4
            -5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)+9*(301-4028*r**2
            +808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12-4028*r**14+301*r**16))
            -3483648000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(64*Q2**8+1088*Q2**7*(1
            +r**2)+Q2**6*(-63+130*r**2-63*r**4)-2*Q2**5*(2777+6379*r**2+6379*r**4
            +2777*r**6)+Q2**4*(1555-8080*r**2-22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743
            -315*r**2-6548*r**4-6548*r**6-315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2
            +199629*r**4+305844*r**6+199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83
            -375*r**2-2833*r**4-5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)
            +9*(301-4028*r**2+808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12
            -4028*r**14+301*r**16))*sqrtq2))+((4*(Q2-(-1+r)**2)**4*r**4*(Q2-(1
            +r)**2)**4*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(-1059
            +24*Q2**14-322322*r**2-93757*r**4-25369844*r**6+127046277*r**8-457228062*r**10
            +815729139*r**12-694656216*r**14+236289183*r**16-15296334*r**18+10159121*r**20
            +3791308*r**22-43777*r**24-3714*r**26+57*r**28+56*Q2**13*(1+r**2)+Q2**12*(1627
            +3446*r**2-1457*r**4)+4*Q2**11*(-3797-54679*r**2-8387*r**4+1615*r**6)
            +4*Q2**10*(11639+338572*r**2+403567*r**4+30654*r**6-3472*r**8)+4*Q2**9*(
            -15387-727340*r**2-2055110*r**4-1044380*r**6-54495*r**8+4008*r**10)
            +Q2**8*(15423+1013978*r**2+12323485*r**4+13564420*r**6+3813345*r**8
            +170178*r**10-8157*r**12)-8*Q2**7*(-6327-651616*r**2-542973*r**4-1778395*r**6
            +98905*r**8-203412*r**10-2181*r**12+207*r**14)+8*Q2**6*(-5943-891191*r**2
            -3383193*r**4-11587780*r**6-10153075*r**8-1572643*r**10-622461*r**12
            -13398*r**14+420*r**16)+8*Q2**5*(-1284+8398*r**2+2312708*r**4+9155691*r**6
            +23311392*r**8+6859881*r**10+797988*r**12+185973*r**14+1356*r**16+57*r**18)
            +Q2**4*(34249+5785410*r**2+7369665*r**4+88484320*r**6-138504270*r**8
            -44549788*r**10+15777210*r**12-6455760*r**14+2109045*r**16+71530*r**18
            -1931*r**20)+4*Q2**3*(-3001-818121*r**2-3167815*r**4-34632105*r**6+13941570*r**8
            -19084558*r**10+6052382*r**12+3025010*r**14+3050295*r**16-323305*r**18
            -8471*r**20+119*r**22)+4*Q2**2*(-1567-223806*r**2+930087*r**4+2175310*r**6
            +12132160*r**8+4033124*r**10-13722438*r**12-13803764*r**14-5884315*r**16
            -87590*r**18-58337*r**20-4186*r**22+122*r**24)-4*Q2*(-1333-327586*r**2
            -53198*r**4-15606570*r**6+50223425*r**8-85305484*r**10+38454012*r**12
            +5455156*r**14+2058365*r**16+2960350*r**18+2220242*r**20-73226*r**22
            -4233*r**24+80*r**26))-4*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(192*Q2**19
            +88*Q2**18*(1+r**2)-16*Q2**17*(-761-1642*r**2+781*r**4)+Q2**16*(-145669
            -1825599*r**2-297995*r**4+73775*r**6)+4*Q2**15*(150207+3591900*r**2
            +4186230*r**4+340660*r**6-51861*r**8)+2*Q2**14*(-587263-22270690*r**2
            -56976461*r**4-30027301*r**6-1597940*r**8+160967*r**10)+4*Q2**13*(223639
            +12910234*r**2+73261216*r**4+81644768*r**6+24316527*r**8+917894*r**10
            -60326*r**12)-2*Q2**12*(-317131-18876162*r**2+114185636*r**4+219020933*r**6
            +179282069*r**8+19229600*r**10+281938*r**12+12701*r**14)+4*Q2**11*(-427377
            -40901932*r**2-95582026*r**4-235832836*r**6-191728516*r**8-18524260*r**10
            -23734310*r**12-833580*r**14+48165*r**16)+Q2**10*(645546+117202740*r**2
            +950023122*r**4+3458598670*r**6+6480987254*r**8+3090309622*r**10+555687430*r**12
            +116673738*r**14+2445960*r**16-86658*r**18)-4*Q2**9*(-279719-25380890*r**2
            +140458404*r**4+715979284*r**6+3392656990*r**8+3213841264*r**10+899717980*r**12
            +147373004*r**14-4363551*r**16-513590*r**18+21736*r**20)+2*Q2**8*(-565738
            -93325493*r**2-216617569*r**4-1312661502*r**6+4253144032*r**8+7526070378*r**10
            +4624178418*r**12+588840656*r**14+170257418*r**16-48534133*r**18-1641233*r**20
            +45422*r**22)+4*Q2**7*(-31163+7629684*r**2+211851218*r**4+1591348508*r**6
            +3260448139*r**8+4797578744*r**10+4261569596*r**12+998967992*r**14+339887083*r**16
            +10756724*r**18+7392018*r**20+68684*r**22+1573*r**24)-2*Q2**6*(-310899
            -50182914*r**2+196567371*r**4+1356019711*r**6+14011017886*r**8+28406379147*r**10
            +47692110982*r**12+23534560726*r**14+5007634041*r**16+777053636*r**18
            +209461039*r**20-18156501*r**22-801700*r**24+19635*r**26)+4*Q2**5*(-44419
            -13953970*r**2-51425816*r**4-710056600*r**6+3395263571*r**8+3934803926*r**10
            +29948143010*r**12+22670582320*r**14+5991109955*r**16+1165588042*r**18
            +98177028*r**20+79097960*r**22-5399059*r**24-153710*r**26+2162*r**28)
            +2*Q2**4*(-74771-9858590*r**2+173066644*r**4+1579897069*r**6+6085393995*r**8
            +27876860036*r**10-14689327610*r**12-21487760013*r**14-5085336893*r**16
            -1532121230*r**18-1709875624*r**20-14947725*r**22+49489669*r**24-2377176*r**26
            -213490*r**28+4909*r**30)-4*Q2**3*(-22333-5590428*r**2+30318494*r**4
            +103450092*r**6+3947265218*r**8+9973666948*r**10+13322010758*r**12+2238290812*r**14
            +1101385656*r**16-6233169716*r**18-3689404902*r**20-1239105212*r**22
            -61818306*r**24+47410252*r**26-1303102*r**28-73388*r**30+1157*r**32)
            -2*Q2**2*(-4107+408166*r**2+28432177*r**4+350402083*r**6-1139137991*r**8
            +6331072423*r**10-37591020251*r**12+32929105263*r**14-5509203441*r**16
            +4305412287*r**18+19284105635*r**20+2214797369*r**22-285387037*r**24
            -7830667*r**26-9379321*r**28+132149*r**30-17184*r**32+447*r**34)+12*Q2*(
            -1333-309198*r**2+4690768*r**4+26504868*r**6+321630628*r**8+1287006892*r**10
            -4395066128*r**12+10784577284*r**14-9208651006*r**16+7844999744*r**18
            -4976184960*r**20-574534900*r**22-751218972*r**24-346607692*r**26-20537872*r**28
            +3731276*r**30-24149*r**32-5330*r**34+80*r**36)-3*(-1059-308555*r**2
            +4210801*r**4+10774145*r**6+501804548*r**8+645428372*r**10-4220464300*r**12
            +24690211972*r**14-31128267770*r**16-10091920314*r**18+38650944158*r**20
            -14149245010*r**22-3260927372*r**24-1070939420*r**26-552049916*r**28
            -33999596*r**30+4755365*r**32-1651*r**34-4455*r**36+57*r**38))*sqrtq2
            +logq2**5*(-13063680000*(-Q2+(-1+r)**2)*(-1+r)*r**24*(1+r)*(1+r**2)*(1
            -Q2+r**2)*(1+3*r**2)*(-Q2+(1+r)**2)-13063680000*r**24*(-1-3*r**2
            +r**4+3*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**4*(
            -10368000*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(480*Q2**6*(1+r**2)
            -240*Q2**5*(12+17*r**2+5*r**4)-8*Q2**4*(-837-1483*r**2-503*r**4+171*r**6)
            +Q2**3*(-6324-14275*r**2-4737*r**4+7411*r**6+4197*r**8)+Q2**2*(-864
            +5213*r**2+3876*r**4-10278*r**6-7268*r**8+1257*r**10)-3*Q2*(-1812
            -611*r**2+1987*r**4+340*r**6-2976*r**8+271*r**10+2801*r**12)+3*(-848
            +75*r**2+908*r**4-4783*r**6-1808*r**8+3925*r**10+852*r**12+1679*r**14))
            +10368000*r**18*(480*Q2**9*(1+r**2)-240*Q2**8*(18+29*r**2+11*r**4)+8*Q2**7*(2097
            +4393*r**2+2783*r**4+459*r**6)+7*Q2**6*(-5076-12565*r**2-10263*r**4
            -2171*r**6+603*r**8)-2*Q2**5*(-20538-58597*r**2-55520*r**4-9418*r**6
            +14938*r**8+7119*r**10)+5*Q2**4*(-3528-14371*r**2-16085*r**4-264*r**6
            +13112*r**8+8491*r**10+357*r**12)-3*(-1+r**2)**3*(848+1621*r**2+638*r**4
            +4513*r**6+11104*r**8+8987*r**10+4210*r**12+1679*r**14)+4*Q2**3*(-3780
            +70*r**2+4677*r**4-5237*r**6-11782*r**8-9456*r**10+1925*r**12+7455*r**14)
            +Q2**2*(24804+17251*r**2-6283*r**4+45623*r**6+61833*r**8-29375*r**10
            -38777*r**12-33499*r**14-41577*r**16)+6*Q2*(-2178-135*r**2+2370*r**4
            -7578*r**6-9090*r**8-648*r**10+5414*r**12+6234*r**14+1692*r**16+3919*r**18))*sqrtq2)
            +logq2**3*(-345600*r**14*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -640*Q2**10+80*Q2**9*(109+81*r**2)-4*Q2**8*(10744+17565*r**2+6629*r**4)
            +4*Q2**7*(24047+67087*r**2+55577*r**4+13937*r**6)-Q2**6*(78778+441405*r**2
            +587331*r**4+300955*r**6+60123*r**8)+2*Q2**5*(-29057+100006*r**2+207494*r**4
            +162424*r**6+61691*r**8+16898*r**10)+Q2**4*(153860+296465*r**2+664749*r**4
            +542330*r**6-31266*r**8-47435*r**10-16975*r**12)+8*Q2**3*(-9293-50490*r**2
            -150185*r**4-148772*r**6+24933*r**8+80570*r**10+26545*r**12+612*r**14)
            +Q2**2*(-39058+131617*r**2+206511*r**4+593941*r**6-348657*r**8-1148689*r**10
            -284079*r**12-97573*r**14+18307*r**16)-6*Q2*(-7893-6060*r**2-116040*r**4
            +16620*r**6+110278*r**8-131432*r**10-66960*r**12+171020*r**14+26855*r**16
            +3612*r**18)+3*(-4072-7899*r**2-124223*r**4+73288*r**6+12024*r**8
            -157026*r**10+1734*r**12-80392*r**14+247472*r**16+36861*r**18+2233*r**20))
            +345600*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(640*Q2**10-80*Q2**9*(109
            +81*r**2)+4*Q2**8*(10744+17565*r**2+6629*r**4)-4*Q2**7*(24047+67087*r**2
            +55577*r**4+13937*r**6)+Q2**6*(78778+441405*r**2+587331*r**4+300955*r**6
            +60123*r**8)-2*Q2**5*(-29057+100006*r**2+207494*r**4+162424*r**6+61691*r**8
            +16898*r**10)+Q2**4*(-153860-296465*r**2-664749*r**4-542330*r**6+31266*r**8
            +47435*r**10+16975*r**12)-8*Q2**3*(-9293-50490*r**2-150185*r**4-148772*r**6
            +24933*r**8+80570*r**10+26545*r**12+612*r**14)+Q2**2*(39058-131617*r**2
            -206511*r**4-593941*r**6+348657*r**8+1148689*r**10+284079*r**12+97573*r**14
            -18307*r**16)+6*Q2*(-7893-6060*r**2-116040*r**4+16620*r**6+110278*r**8
            -131432*r**10-66960*r**12+171020*r**14+26855*r**16+3612*r**18)-3*(
            -4072-7899*r**2-124223*r**4+73288*r**6+12024*r**8-157026*r**10+1734*r**12
            -80392*r**14+247472*r**16+36861*r**18+2233*r**20))*sqrtq2)+logq2**2*(5760*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(11520*Q2**13-16*Q2**12*(6129+5467*r**2)
            +4*Q2**11*(81472+162683*r**2+68411*r**4)-4*Q2**10*(115431+488576*r**2
            +445435*r**4+107538*r**6)+5*Q2**9*(2286+525503*r**2+836313*r**4+485409*r**6
            +63513*r**8)-5*Q2**8*(-156696+37219*r**2-31124*r**4+156518*r**6+255372*r**8
            +4311*r**10)-2*Q2**7*(395556+2230843*r**2+9881570*r**4+14718735*r**6
            +6476095*r**8+461006*r**10+81363*r**12)+2*Q2**6*(-57588+2859143*r**2
            +16754391*r**4+43245765*r**6+36028570*r**8+10679877*r**10+969843*r**12
            +94431*r**14)-2*Q2**5*(-311994+477316*r**2+2545855*r**4+38935933*r**6
            +53179760*r**8+24313856*r**10+5004941*r**12+668895*r**14+47838*r**16)
            -10*Q2**4*(26328+392144*r**2+3683419*r**4+2309292*r**6-100423*r**8-798008*r**10
            -202923*r**12-290236*r**14-70913*r**16+7224*r**18)+10*Q2**3*(-11460
            +312497*r**2+3011748*r**4+7592889*r**6+9993411*r**8+4134399*r**10-3077805*r**12
            -3372825*r**14-830991*r**16-33744*r**18+11161*r**20)+2*Q2**2*(51538
            +83929*r**2+2099095*r**4-19815615*r**6-13787040*r**8-9064446*r**10+33675702*r**12
            +33703410*r**14+16351470*r**16+431045*r**18-179437*r**20-4051*r**22)
            -3*Q2*(3854+351281*r**2+4245317*r**4-2508915*r**6+22869135*r**8-11047218*r**10
            +3415638*r**12+21190806*r**14-28658760*r**16-6759935*r**18-2912411*r**20
            -202019*r**22+13227*r**24)+3*(-1288+110037*r**2+1257150*r**4-375994*r**6
            +15437670*r**8-7418889*r**10-19279324*r**12+10397140*r**14+33625068*r**16
            -26364045*r**18-5865698*r**20-1453338*r**22-73290*r**24+4801*r**26))
            -5760*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(11520*Q2**14-16*Q2**13*(6849
            +6187*r**2)+4*Q2**12*(105988+209067*r**2+90279*r**4)-4*Q2**11*(196903
            +732731*r**2+676529*r**4+175949*r**6)+Q2**10*(473154+5043543*r**2+7917609*r**4
            +4638937*r**6+747717*r**8)-10*Q2**9*(-77205+282504*r**2+665346*r**4
            +739120*r**6+402147*r**8+33912*r**10)-Q2**8*(1574592+5059071*r**2+19732665*r**4
            +28810500*r**6+10892740*r**8-376403*r**10+141171*r**12)+4*Q2**7*(168984
            +2742771*r**2+14433402*r**4+33923035*r**6+28611700*r**8+8808489*r**10
            +756106*r**12+87897*r**14)-2*Q2**6*(-369582+3278871*r**2+22159389*r**4
            +98936089*r**6+132454095*r**8+71022303*r**10+16654661*r**12+1733169*r**14
            +142269*r**16)+4*Q2**5*(-221817-897699*r**2-7696962*r**4+14967664*r**6
            +46308904*r**8+40741828*r**10+15166706*r**12+3562508*r**14+535649*r**16
            +5859*r**18)+10*Q2**4*(14868+730969*r**2+7087311*r**4+13585600*r**6
            +12202280*r**8+3235968*r**10-4078736*r**12-3865984*r**14-1192140*r**16
            -97433*r**18+18385*r**20)-4*Q2**3*(-54419+710628*r**2+7261065*r**4+36419400*r**6
            +50859270*r**8+39851748*r**10-14196366*r**12-32978280*r**14-18685275*r**16
            -2377360*r**18+33261*r**20+29928*r**22)-Q2**2*(114638+1324777*r**2+17101999*r**4
            -42959785*r**6+1402095*r**8-78844626*r**10+59469426*r**12+198330642*r**14
            +14133480*r**16+13285225*r**18-8234017*r**20-973033*r**22+31579*r**24)
            +6*Q2*(1283+232586*r**2+2926874*r**4+680204*r**6+17898945*r**8+2201514*r**10
            -13455452*r**12+17501792*r**14+13078557*r**16-30891370*r**18-7769022*r**20
            -2283884*r**22-131041*r**24+9014*r**26)-3*(-1288+108749*r**2+1367187*r**4
            +881156*r**6+15061676*r**8+8018781*r**10-26698213*r**12-8882184*r**14
            +44022208*r**16+7261023*r**18-32229743*r**20-7319036*r**22-1526628*r**24
            -68489*r**26+4801*r**28))*sqrtq2)+logq2*(-48*r**6*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-24832*Q2**16+32*Q2**15*(7391+8831*r**2)
            -8*Q2**14*(105120+310747*r**2+147195*r**4)+8*Q2**13*(149925+949863*r**2
            +1071463*r**4+279085*r**6)-Q2**12*(-269140+7147001*r**2+11059123*r**4
            +11171351*r**6+1391025*r**8)-4*Q2**11*(730411+2738804*r**2+12969654*r**4
            +10560284*r**6+330159*r**8+414176*r**10)+2*Q2**10*(1319262+15299499*r**2
            +92391625*r**4+176075950*r**6+77432240*r**8+8996279*r**10+1413177*r**12)
            +4*Q2**9*(365205-4054812*r**2-43791325*r**4-205409750*r**6-190977325*r**8
            -47505400*r**10-4236587*r**12+33930*r**14)+Q2**8*(-3625800-20966583*r**2
            -124396393*r**4+638600425*r**6+1143100575*r**8+659131035*r**10+85605557*r**12
            +5002867*r**14-2632035*r**16)+8*Q2**7*(113165+3632844*r**2+46580062*r**4
            +87545574*r**6+158298110*r**8+127385300*r**10+18149174*r**12+4626662*r**14
            +319169*r**16+139700*r**18)+4*Q2**6*(461246-828817*r**2-48003727*r**4
            -467276692*r**6-1374332532*r**8-2141159326*r**10-1024048542*r**12-170495852*r**14
            -23969242*r**16-1959057*r**18+264701*r**20)-8*Q2**5*(146598+1671809*r**2
            +18659510*r**4-133478905*r**6-437240570*r**8-1593563812*r**10-1271910682*r**12
            -335013240*r**14-39908980*r**16-9947845*r**18-886356*r**20+102873*r**22)
            -Q2**4*(340860-7395849*r**2-202457835*r**4-790689275*r**6-4645644325*r**8
            +2616114550*r**10+5891720898*r**12+434581850*r**14+114198850*r**16+95382675*r**18
            +4007465*r**20-1807199*r**22+178535*r**24)+4*Q2**3*(113225+229076*r**2
            -10748334*r**4-296233120*r**6-1492129325*r**8-1620955560*r**10-911801092*r**12
            -425924192*r**14+471635775*r**16+368745300*r**18+91618610*r**20-9485184*r**22
            -1294299*r**24+69120*r**26)-2*Q2**2*(12730+944813*r**2+21319199*r**4
            -99536842*r**6-5148760*r**8-2804453825*r**10-442052871*r**12+375339252*r**14
            +3068697954*r**16+2909071835*r**18+412512145*r**20+54726358*r**22-7406276*r**24
            -383687*r**26+5975*r**28)-12*Q2*(6209-44832*r**2-2222177*r**4-25078142*r**6
            -178749747*r**8+365365296*r**10-712704661*r**12+20753954*r**14-240045341*r**16
            +569882944*r**18+66295181*r**20+112256118*r**22+24862223*r**24-461392*r**26
            -119447*r**28+3814*r**30)+3*(6416-13331*r**2-1506565*r**4-40930255*r**6
            -210248305*r**8+628651937*r**10-3432125417*r**12+3719437205*r**14+2909531835*r**16
            -7282941065*r**18+2875929953*r**20+542905027*r**22+237587485*r**24+54892795*r**26
            -1008755*r**28-172681*r**30+3721*r**32))+48*r**6*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(24832*Q2**16-32*Q2**15*(7391+8831*r**2)+8*Q2**14*(105120
            +310747*r**2+147195*r**4)-8*Q2**13*(149925+949863*r**2+1071463*r**4
            +279085*r**6)+Q2**12*(-269140+7147001*r**2+11059123*r**4+11171351*r**6
            +1391025*r**8)+4*Q2**11*(730411+2738804*r**2+12969654*r**4+10560284*r**6
            +330159*r**8+414176*r**10)-2*Q2**10*(1319262+15299499*r**2+92391625*r**4
            +176075950*r**6+77432240*r**8+8996279*r**10+1413177*r**12)-4*Q2**9*(365205
            -4054812*r**2-43791325*r**4-205409750*r**6-190977325*r**8-47505400*r**10
            -4236587*r**12+33930*r**14)+Q2**8*(3625800+20966583*r**2+124396393*r**4
            -638600425*r**6-1143100575*r**8-659131035*r**10-85605557*r**12-5002867*r**14
            +2632035*r**16)-8*Q2**7*(113165+3632844*r**2+46580062*r**4+87545574*r**6
            +158298110*r**8+127385300*r**10+18149174*r**12+4626662*r**14+319169*r**16
            +139700*r**18)+4*Q2**6*(-461246+828817*r**2+48003727*r**4+467276692*r**6
            +1374332532*r**8+2141159326*r**10+1024048542*r**12+170495852*r**14+23969242*r**16
            +1959057*r**18-264701*r**20)+8*Q2**5*(146598+1671809*r**2+18659510*r**4
            -133478905*r**6-437240570*r**8-1593563812*r**10-1271910682*r**12-335013240*r**14
            -39908980*r**16-9947845*r**18-886356*r**20+102873*r**22)+Q2**4*(340860
            -7395849*r**2-202457835*r**4-790689275*r**6-4645644325*r**8+2616114550*r**10
            +5891720898*r**12+434581850*r**14+114198850*r**16+95382675*r**18+4007465*r**20
            -1807199*r**22+178535*r**24)-4*Q2**3*(113225+229076*r**2-10748334*r**4
            -296233120*r**6-1492129325*r**8-1620955560*r**10-911801092*r**12-425924192*r**14
            +471635775*r**16+368745300*r**18+91618610*r**20-9485184*r**22-1294299*r**24
            +69120*r**26)+2*Q2**2*(12730+944813*r**2+21319199*r**4-99536842*r**6
            -5148760*r**8-2804453825*r**10-442052871*r**12+375339252*r**14+3068697954*r**16
            +2909071835*r**18+412512145*r**20+54726358*r**22-7406276*r**24-383687*r**26
            +5975*r**28)+12*Q2*(6209-44832*r**2-2222177*r**4-25078142*r**6-178749747*r**8
            +365365296*r**10-712704661*r**12+20753954*r**14-240045341*r**16+569882944*r**18
            +66295181*r**20+112256118*r**22+24862223*r**24-461392*r**26-119447*r**28
            +3814*r**30)-3*(6416-13331*r**2-1506565*r**4-40930255*r**6-210248305*r**8
            +628651937*r**10-3432125417*r**12+3719437205*r**14+2909531835*r**16-7282941065*r**18
            +2875929953*r**20+542905027*r**22+237587485*r**24+54892795*r**26-1008755*r**28
            -172681*r**30+3721*r**32))*sqrtq2))*math.log(mus))/(-840*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))-840*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2+logq2**5*(-3135283200*r**22*(1+r**2)*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            +3135283200*r**22*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**2*(-725760*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8+3*Q2**3*(1
            +r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4+7*r**6))
            -725760*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8
            +3*Q2**3*(1+r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4
            +7*r**6))*sqrtq2)+logq2**3*(2903040*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))+2903040*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))*sqrtq2)+logq2**4*(-17418240*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(63+8*Q2**4-402*r**2
            -1122*r**4-402*r**6+63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)
            -3*Q2*(19+31*r**2+31*r**4+19*r**6))-17418240*(-Q2+(-1+r)**2)*r**18*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(63+8*Q2**4-402*r**2-1122*r**4-402*r**6
            +63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)-3*Q2*(19+31*r**2
            +31*r**4+19*r**6))*sqrtq2)+logq2*(10080*(-Q2+(-1+r)**2)*r**6*(1-Q2
            +r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1
            +r**2)-Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)
            +3*(9-86*r**2-446*r**4-86*r**6+9*r**8))+10080*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1+r**2)
            -Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)+3*(9
            -86*r**2-446*r**4-86*r**6+9*r**8))*sqrtq2)))*math.log(r)+((16*(Q2-(-1
            +r)**2)**6*r**6*(Q2-(1+r)**2)**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**2*(1176*Q2**19+16*Q2**18*(-49+179*r**2)+Q2**17*(73843+234182*r**2
            -145865*r**4)+Q2**16*(-975541-17681231*r**2-3237387*r**4+1062479*r**6)
            +Q2**15*(4675286+157431138*r**2+202327364*r**4+19490066*r**6-4030414*r**8)
            +2*Q2**14*(-5597809-290108450*r**2-761316349*r**4-464214769*r**6-33268658*r**8
            +4781171*r**10)+2*Q2**13*(6320461+470524779*r**2+2210235837*r**4+2571545246*r**6
            +1100264547*r**8+70548183*r**10-7527821*r**12)+2*Q2**12*(528073-4416698*r**2
            -2082402900*r**4-2815835559*r**6-3510025323*r**8-1382151900*r**10-94870346*r**12
            +7932925*r**14)-2*Q2**11*(10939201+1233654551*r**2+3174293872*r**4+12444080457*r**6
            +10188033240*r**8-552334767*r**10-695014820*r**12-78526945*r**14+5469451*r**16)
            +2*Q2**10*(12143131+1763121778*r**2+9567005001*r**4+39095440807*r**6
            +63563384959*r**8+30886368099*r**10+3435055843*r**12+287986933*r**14
            -39076422*r**16+2507791*r**18)-2*Q2**9*(896896+187531575*r**2+6343375102*r**4
            +26612984352*r**6+102332314184*r**8+81918231094*r**10+30788168940*r**12
            +4068750872*r**14+381264352*r**16-21701141*r**18+1235806*r**20)+2*Q2**8*(
            -8986796-1948253329*r**2-5600170169*r**4-46249128852*r**6+40704072456*r**8
            +34605395382*r**10+35503170174*r**12+22478498856*r**14+4888373508*r**16
            -150942149*r**18-28758565*r**20+1072396*r**22)+2*Q2**7*(6638177+1877453323*r**2
            +10923304170*r**4+89601915623*r**6+52750332361*r**8+89753004294*r**10
            +33619849188*r**12-37101303050*r**14-31345548357*r**16-6881061889*r**18
            +245458978*r**20+22628019*r**22-552565*r**24)-2*Q2**6*(-1271501-59109186*r**2
            +4212676123*r**4+27555204667*r**6+82376068740*r**8+35801240527*r**10
            +78931735478*r**12-41040947954*r**14-54438289781*r**16-25565305940*r**18
            -3187054545*r**20-66094409*r**22-2611778*r**24+219079*r**26)+2*Q2**5*(
            -4082141-1182418063*r**2-3027902153*r**4-57671457818*r**6+111493603883*r**8
            -261480426845*r**10+184242083543*r**12-91652239388*r**14+19828198625*r**16
            -22562678345*r**18+674880173*r**20+3745313782*r**22-154088687*r**24-16338955*r**26
            +435589*r**28)+2*Q2**4*(1753367+691443150*r**2+3316761876*r**4+58391250271*r**6
            -122935909883*r**8+450432876768*r**10-466990457850*r**12+160563657493*r**14
            +114741791073*r**16-82965899994*r**18+25150517608*r**20-7304108535*r**22
            -4524616829*r**24+29719596*r**26+8822142*r**28-163453*r**30)-2*Q2**3*(
            -375977-54017243*r**2+832295868*r**4+6286522119*r**6-18529587622*r**8
            +154555322485*r**10-366077579632*r**12+361743577039*r**14-131151961748*r**16
            +195835636199*r**18-32175550484*r**20+21117060493*r**22-2219495682*r**24
            -745973121*r**26-20240952*r**28-1356899*r**30+54757*r**32)+(-1+r**2)**2*(
            -51891-25725725*r**2-75736394*r**4-4079760782*r**6+27383025610*r**8
            -170996810546*r**10+585214540846*r**12-1157428512198*r**14+1148602098084*r**16
            -470074919340*r**18+67905894530*r**20-30822320842*r**22-13159315162*r**24
            -3460799902*r**26+113791130*r**28+3057182*r**30-348129*r**32+5529*r**34)
            +2*Q2**2*(-597359-216903466*r**2-184742225*r**4-18491697339*r**6+88293577287*r**8
            -326797054359*r**10+541097174123*r**12-351241385975*r**14+65893573373*r**16
            -37783442599*r**18-57963850595*r**20-21525636193*r**22-19085407635*r**24
            -5773165509*r**26+952100937*r**28+1062163*r**30-3240514*r**32+67885*r**34)
            +Q2*(416941+180868336*r**2+229128477*r**4+21795409144*r**6-145581186540*r**8
            +741100859640*r**10-2130305521324*r**12+3320228441432*r**14-2333253746442*r**16
            +371376320440*r**18+35282558102*r**20+123141147240*r**22+27226206500*r**24
            +40505673192*r**26+12621017700*r**28-927745208*r**30-14840027*r**32+2589816*r**34
            -45419*r**36))-16*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(1176*Q2**20+8*Q2**19*(
            -245+211*r**2)+Q2**18*(74627+232102*r**2-148729*r**4)+8*Q2**17*(-131173
            -2248657*r**2-415713*r**4+151043*r**6)+Q2**16*(5650827+176087910*r**2
            +223245982*r**4+21664974*r**6-5092893*r**8)+4*Q2**15*(-3967726-185580831*r**2
            -470597800*r**4-287561742*r**6-20499242*r**8+3398189*r**10)+4*Q2**14*(5959135
            +383115519*r**2+1630830318*r**4+1898538182*r**6+798873987*r**8+49517835*r**10
            -6154496*r**12)+4*Q2**13*(-2896194-240630969*r**2-2381581758*r**4-3798808321*r**6
            -3590917558*r**8-1276482315*r**10-78945354*r**12+7730373*r**14)-4*Q2**12*(5733637
            +614882963*r**2+543737137*r**4+3772920999*r**6+1931086179*r**8-2722255995*r**10
            -1086018533*r**12-82732183*r**14+6701188*r**16)+4*Q2**11*(11541166+1503857765*r**2
            +6987476712*r**4+27356907568*r**6+43097749328*r**8+20261033286*r**10
            +1093853128*r**12-242777416*r**14-56066958*r**16+3988621*r**18)-2*Q2**10*(13040027
            +1962796484*r**2+17673501881*r**4+75275430160*r**6+204991139950*r**8
            +176367984152*r**10+65109592882*r**12+7791793648*r**14+630174863*r**16
            -58269772*r**18+3743597*r**20)+4*Q2**9*(-4044950-879912429*r**2+465368254*r**4
            -6646384699*r**6+84824685496*r**8+109427970330*r**10+74104785104*r**12
            +28667709334*r**14+4669194366*r**16+104310531*r**18-24611950*r**20+1154101*r**22)
            +2*Q2**8*(15624973+3834693448*r**2+18471727668*r**4+141451214644*r**6
            +58295388757*r**8+14443536456*r**10-36488716368*r**12-95082972080*r**14
            -58712420721*r**16-11618493248*r**18+425159692*r**20+50314188*r**22-1624961*r**24)
            +4*Q2**7*(-2683338-912491157*r**2-8506716808*r**4-64040212230*r**6-112364158362*r**8
            -89152288591*r**10-101152294480*r**12+22261200908*r**14+61442570594*r**16
            +31895958093*r**18+4911328728*r**20-100996294*r**22-9731838*r**24+166743*r**26)
            +4*Q2**6*(-2676821-621399375*r**2+562832392*r**4-12951788514*r**6+110712438645*r**8
            -71651558789*r**10+149487529774*r**12-26880725932*r**14-37825519555*r**16
            -51283137033*r**18-14038740156*r**20+246082414*r**22-111397437*r**24
            -9365827*r**26+327334*r**28)-4*Q2**5*(-2917754-938971677*r**2-3763541046*r**4
            -59545305121*r**6+88379027974*r**8-300209849865*r**10+194876057274*r**12
            -33986906669*r**14-93282915918*r**16+40115710137*r**18-23519157890*r**20
            +5862151245*r**22+4057920962*r**24-100073619*r**26-12362754*r**28+299521*r**30)
            +4*Q2**4*(-688695-319589637*r**2-2420250447*r**4-33997267133*r**6+41537123617*r**8
            -241026144685*r**10+191317580357*r**12-27658388341*r**14-72076743409*r**16
            -113805763639*r**18+44995466435*r**20-19481734783*r**22+7024110523*r**24
            +2620435177*r**26-9150393*r**28-3650895*r**30+54348*r**32)+4*Q2**3*(
            -486668-135648343*r**2+296768200*r**4-5686439676*r**6+38025255892*r**8
            -95385659748*r**10+164787458488*r**12-177787694284*r**14+148242594332*r**16
            +13450115926*r**18+52848117560*r**20-16292063092*r**22-93921412*r**24
            -4369317156*r**26+92943432*r**28-10267844*r**30-2271328*r**32+61321*r**34)
            +Q2**2*(1611659+615869986*r**2+1032419859*r**4+59148288272*r**6-285184946436*r**8
            +1218107813784*r**10-2558905760852*r**12+2940516865136*r**14-1762558121238*r**16
            +315156058892*r**18+226777144490*r**20+282120120816*r**22+108448294156*r**24
            +90222819480*r**26+22263146844*r**28-2834071408*r**30-10483325*r**32
            +8935074*r**34-181189*r**36)-(-1+r**2)**2*(-51891-25777616*r**2-101462119*r**4
            -4155497176*r**6+23303264828*r**8-143613784936*r**10+414217730300*r**12
            -572213971352*r**14-8826414114*r**16+678527178744*r**18-402169024810*r**20
            +37083573688*r**22-43981636004*r**24-16620115064*r**26-3347008772*r**28
            +116848312*r**30+2709053*r**32-342600*r**34+5529*r**36)+4*Q2*(-117208
            -51726805*r**2-108583412*r**4-6494637835*r**6+39813147044*r**8-206340573912*r**10
            +585948962308*r**12-922194331136*r**14+765424742084*r**16-490707550426*r**18
            +437499738188*r**20-198783183646*r**22-8494033172*r**24-18924092528*r**26
            -14812653780*r**28-3844649368*r**30+262478468*r**32+4002295*r**34-725896*r**36
            +12737*r**38))*sqrtq2+logq2**7*(-112870195200000*r**34*(1+r**2)**2*(1-Q2
            +r**2)*(-49-146*r**2+291*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3
            -112870195200000*(Q2-(-1+r)**2)**2*r**34*(1+r**2)**2*(-49-146*r**2+291*r**4)*(Q2
            -(1+r)**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**6*(
            -89579520000*r**28*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-11040*Q2**8*(1
            +r**2)+240*Q2**7*(368+407*r**2+39*r**4)-8*Q2**6*(37191+42166*r**2+3407*r**4
            +3864*r**6)+Q2**5*(519708+593861*r**2+120999*r**4+306763*r**6+259917*r**8)
            -Q2**4*(425040+455439*r**2+393644*r**4+1097998*r**6+968196*r**8+320355*r**10)
            -2*Q2**3*(9660+71882*r**2-98581*r**4-484839*r**6-865403*r**8-109187*r**10
            +432180*r**12)+3*(-1+r**2)**2*(19504+49893*r**2+8796*r**4-447793*r**6
            -138848*r**8+601563*r**10+218964*r**12+252401*r**14)+2*Q2**2*(164220
            +244448*r**2+116897*r**4-473632*r**6-436322*r**8+394132*r**10+916357*r**12
            +1291500*r**14)-3*Q2*(80684+88507*r**2-2841*r**4-949927*r**6-1280971*r**8
            +1732725*r**10+1537817*r**12+257655*r**14+794271*r**16))-89579520000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(11040*Q2**9*(1+r**2)-240*Q2**8*(414
            +499*r**2+85*r**4)+8*Q2**7*(48231+65416*r**2+16787*r**4+5034*r**6)
            -7*Q2**6*(116748+175531*r**2+69369*r**4+52133*r**6+41547*r**8)+4*Q2**5*(236187
            +392252*r**2+277126*r**4+381440*r**6+383719*r**8+145068*r**10)+5*Q2**4*(
            -81144-147343*r**2-209249*r**4-492264*r**6-759400*r**8-301385*r**10
            +108801*r**12)-4*Q2**3*(86940+162995*r**2+45099*r**4-528526*r**6-893282*r**8
            -290229*r**10+619675*r**12+861840*r**14)+3*(-1+r**2)**2*(19504+69397*r**2
            +58689*r**4-438997*r**6-586641*r**8+462715*r**10+820527*r**12+471365*r**14
            +252401*r**16)+Q2**2*(570492+1082857*r**2+714167*r**4-3563251*r**6-5662821*r**8
            +5113795*r**10+7234429*r**12+5188679*r**14+4965813*r**16)-12*Q2*(25047
            +45019*r**2+3545*r**4-342065*r**6-366341*r**8+220805*r**10+536883*r**12
            +552877*r**14+191522*r**16+261668*r**18))*sqrtq2)+logq2**5*(-497664000*r**24*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(176640*Q2**12*(1+r**2)
            -22560*Q2**11*(205+354*r**2+149*r**4)+8*Q2**10*(4223232+9985849*r**2
            +7756274*r**4+2015385*r**6)-120*Q2**9*(971181+2876158*r**2+3066596*r**4
            +1368274*r**6+206655*r**8)-45*Q2**8*(-4617940-16761945*r**2-22212988*r**4
            -12500418*r**6-2173520*r**8+257915*r**10)+20*Q2**7*(-7325469-38458100*r**2
            -63143677*r**4-38874792*r**6-1198367*r**8+9213788*r**10+3548409*r**12)
            -60*Q2**6*(1998213-395444*r**2-6064991*r**4-3239562*r**6+4886151*r**8
            +7191064*r**10+3464307*r**12+901446*r**14)-12*Q2**5*(-27152049-59877553*r**2
            -67215683*r**4-50786855*r**6-39252195*r**8-58000639*r**10-37547053*r**12
            +464407*r**14+2966340*r**16)+10*Q2**4*(-22143978-60034309*r**2-80651156*r**4
            -64570374*r**6-87932824*r**8-172631414*r**10-181264548*r**12-91179238*r**14
            -6190022*r**16+8842215*r**18)-60*Q2**3*(409645-1770470*r**2-1522871*r**4
            +2672952*r**6-7570882*r**8-35382056*r**10-46247526*r**12-13038304*r**14
            +5987821*r**16+4790*r**18+1430725*r**20)+9*(-1+r**2)**2*(1315984+562501*r**2
            +8411566*r**4+34974801*r**6-5653584*r**8-99787482*r**10-47725836*r**12
            +39549774*r**14+119100864*r**16+130790549*r**18+20595038*r**20+1078625*r**22)
            +60*Q2**2*(1974289+536686*r**2+4460131*r**4+15801954*r**6+10627806*r**8
            -11854026*r**10-23761446*r**12+2068290*r**14+62292993*r**16+58274780*r**18
            +7608275*r**20+1155548*r**22)-180*Q2*(357269-145655*r**2+1265485*r**4
            +4436717*r**6-1109238*r**8-16950786*r**10-7977234*r**12+16788294*r**14
            +8914437*r**16+13309657*r**18+18651461*r**20+2883053*r**22+219100*r**24))
            -497664000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(176640*Q2**12*(1
            +r**2)-22560*Q2**11*(205+354*r**2+149*r**4)+8*Q2**10*(4223232+9985849*r**2
            +7756274*r**4+2015385*r**6)-120*Q2**9*(971181+2876158*r**2+3066596*r**4
            +1368274*r**6+206655*r**8)-45*Q2**8*(-4617940-16761945*r**2-22212988*r**4
            -12500418*r**6-2173520*r**8+257915*r**10)+20*Q2**7*(-7325469-38458100*r**2
            -63143677*r**4-38874792*r**6-1198367*r**8+9213788*r**10+3548409*r**12)
            -60*Q2**6*(1998213-395444*r**2-6064991*r**4-3239562*r**6+4886151*r**8
            +7191064*r**10+3464307*r**12+901446*r**14)-12*Q2**5*(-27152049-59877553*r**2
            -67215683*r**4-50786855*r**6-39252195*r**8-58000639*r**10-37547053*r**12
            +464407*r**14+2966340*r**16)+10*Q2**4*(-22143978-60034309*r**2-80651156*r**4
            -64570374*r**6-87932824*r**8-172631414*r**10-181264548*r**12-91179238*r**14
            -6190022*r**16+8842215*r**18)-60*Q2**3*(409645-1770470*r**2-1522871*r**4
            +2672952*r**6-7570882*r**8-35382056*r**10-46247526*r**12-13038304*r**14
            +5987821*r**16+4790*r**18+1430725*r**20)+9*(-1+r**2)**2*(1315984+562501*r**2
            +8411566*r**4+34974801*r**6-5653584*r**8-99787482*r**10-47725836*r**12
            +39549774*r**14+119100864*r**16+130790549*r**18+20595038*r**20+1078625*r**22)
            +60*Q2**2*(1974289+536686*r**2+4460131*r**4+15801954*r**6+10627806*r**8
            -11854026*r**10-23761446*r**12+2068290*r**14+62292993*r**16+58274780*r**18
            +7608275*r**20+1155548*r**22)-180*Q2*(357269-145655*r**2+1265485*r**4
            +4436717*r**6-1109238*r**8-16950786*r**10-7977234*r**12+16788294*r**14
            +8914437*r**16+13309657*r**18+18651461*r**20+2883053*r**22+219100*r**24))*sqrtq2)
            +logq2**4*(8294400*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(235520*Q2**16
            -35840*Q2**15*(519+472*r**2)+64*Q2**14*(2995581+4784868*r**2+1858087*r**4)
            -8*Q2**13*(111719632+262263073*r**2+195597650*r**4+44943329*r**6)+16*Q2**12*(141081819
            +470217088*r**2+545486090*r**4+257209484*r**6+39346983*r**8)-Q2**11*(2891718216
            +15110117447*r**2+25417139468*r**4+19223137406*r**6+6842752396*r**8+891486747*r**10)
            +Q2**10*(349308864+14502581791*r**2+34786721579*r**4+36102913114*r**6
            +21563340994*r**8+7902560135*r**10+1461015123*r**12)+Q2**9*(4653307032
            +3723397021*r**2+6253826744*r**4+17311676675*r**6+8282397840*r**8-7082435893*r**10
            -7352763424*r**12-2303850411*r**14)+Q2**8*(-6547188288-27330058637*r**2
            -95783198705*r**4-189197535011*r**6-168108572895*r**8-52849404963*r**10
            +7694579713*r**12+8674200275*r**14+2518765839*r**16)-2*Q2**7*(-1068075896
            -14824969637*r**2-61713938380*r**4-146242655366*r**6-159011329532*r**8
            -59645384986*r**10+17319148788*r**12+21513622450*r**14+5996876684*r**16
            +787118803*r**18)+2*Q2**6*(1763963136-3422332773*r**2-4103829557*r**4
            -49067301254*r**6-91887180374*r**8-26990337962*r**10+50147641822*r**12
            +47845903018*r**14+21970645066*r**16+4893382891*r**18+94202467*r**20)
            +2*Q2**5*(-2132127624-7313770231*r**2-62435350224*r**4-88151740489*r**6
            -33185787264*r**8-14266803644*r**10-52591455904*r**12-50061003924*r**14
            -6195904424*r**16+3584634371*r**18-574915040*r**20+341952397*r**22)+2*Q2**4*(628382392
            +7695562251*r**2+54530499219*r**4+86885852425*r**6+46402706745*r**8+21462932556*r**10
            +73833414228*r**12+128234187612*r**14+102808022940*r**16+20311864745*r**18
            -12485199783*r**20-2066073189*r**22-362344141*r**24)+3*Q2**3*(275285448
            -1481228193*r**2-423332740*r**4-11418330594*r**6-4443748900*r**8+5926295469*r**10
            -54876071064*r**12-135901826460*r**14-102793308912*r**16-31065847575*r**18
            -16125493092*r**20+6374755582*r**22+1280657100*r**24+81345931*r**26)
            +9*(-1+r**2)**2*(-3513184-50495329*r**2-571788783*r**4+271642484*r**6
            -1772877628*r**8-5812494777*r**10+377313953*r**12+10080121176*r**14+14013846232*r**16
            -5490887979*r**18-23002638389*r**20-7028971724*r**22-1273079868*r**24
            -61237691*r**26+3781507*r**28)+3*Q2**2*(-272213632-689110119*r**2-15396464075*r**4
            +4230880558*r**6-6899444154*r**8-56533753201*r**10-13395820797*r**12
            +65155712580*r**14+43372968084*r**16-129865061897*r**18-188111998917*r**20
            -45604798834*r**22-12080227930*r**24-1027867167*r**26+43279501*r**28)
            -9*Q2*(-29466936-203654577*r**2-2799505848*r**4+3476536329*r**6-5102492336*r**8
            -17363846725*r**10+15683157504*r**12+24375506941*r**14-9069571768*r**16
            +12674801757*r**18-17111813912*r**20-63354187477*r**22-18400188768*r**24
            -3839019111*r**26-236706096*r**28+15331023*r**30))-8294400*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(235520*Q2**17-5120*Q2**16*(3679+3350*r**2)
            +64*Q2**15*(3286221+5339828*r**2+2122407*r**4)-40*Q2**14*(27136856+64901333*r**2
            +49748258*r**4+11961605*r**6)+8*Q2**13*(393883270+1314416881*r**2+1548832903*r**4
            +754959947*r**6+123637295*r**8)-Q2**12*(5149027320+24890899959*r**2+41668390316*r**4
            +32066266590*r**6+11587655868*r**8+1521038475*r**10)+2*Q2**11*(1620513540
            +16252208727*r**2+37656989247*r**4+40371594994*r**6+23814615398*r**8
            +7818399639*r**10+1176250935*r**12)-2*Q2**10*(-2151999084+5564246817*r**2
            +21517738313*r**4+26788979009*r**6+24691928134*r**8+18274168511*r**10
            +8358169341*r**12+1882432767*r**14)+10*Q2**9*(-1120049532-3570676269*r**2
            -10576042247*r**4-21276303843*r**6-19370264741*r**8-5404936691*r**10
            +2212977903*r**12+1833081411*r**14+482261625*r**16)+Q2**8*(8683340080
            +63527186199*r**2+246541134102*r**4+577466044448*r**6+675328766970*r**8
            +340248747830*r**10+10516527674*r**12-59396024888*r**14-23186719482*r**16
            -4093003445*r**18)+4*Q2**7*(347943620-9657689153*r**2-40321368787*r**4
            -128511947500*r**6-198570582636*r**8-122823526240*r**10+3910702812*r**12
            +43339337128*r**14+24740572100*r**16+5838689189*r**18+440660635*r**20)
            +4*Q2**6*(-1948045380-2827700297*r**2-27454593947*r**4-17490304839*r**6
            +53884347182*r**8+52305357346*r**10-37874379882*r**12-74027274382*r**14
            -38006226254*r**16-11639696793*r**18-2781250199*r**20+123874965*r**22)
            -4*Q2**5*(-1380255008-8570730053*r**2-62139809837*r**4-118736471569*r**6
            -83870117249*r**8-34457761732*r**10-70345836888*r**12-115443323720*r**14
            -79532465644*r**16-11461567399*r**18+7747459557*r**20+916555273*r**22
            +352148269*r**24)+5*Q2**4*(-86181688-4218314773*r**2-25144424232*r**4
            -63417539014*r**6-55981673008*r**8-23590478439*r**10-71044181352*r**12
            -162368136612*r**14-154092869568*r**16-67887463619*r**18-12805961840*r**20
            +9645362538*r**22+1739761192*r**24+193745215*r**26)-6*Q2**3*(273749540
            -258416313*r**2+6745951571*r**4-8036271946*r**6-4481317670*r**8+29008149885*r**10
            -17776977399*r**12-127966805052*r**14-141034051728*r**16-1997047295*r**18
            +70460329125*r**20+17927030662*r**22+9867820306*r**24+1194935099*r**26
            +19033215*r**28)-9*(-1+r**2)**2*(-3513184-54008513*r**2-622284112*r**4
            -300146299*r**6-1501235144*r**8-7585372405*r**10-5435180824*r**12+10457435129*r**14
            +24093967408*r**16+8522958253*r**18-28493526368*r**20-30031610113*r**22
            -8302051592*r**24-1334317559*r**26-57456184*r**28+3781507*r**30)-6*Q2**2*(
            -180307220-786143741*r**2-12242045869*r**4-367987265*r**6-8988020302*r**8
            -57762368765*r**10-11440050743*r**12+62443206303*r**14+40659982680*r**16
            -24233844271*r**18-184656251275*r**20-211889680091*r**22-56442796534*r**24
            -12312576215*r**26-847352977*r**28+44636285*r**30)+18*Q2*(-16490060
            -138295237*r**2-1738735867*r**4+1020877601*r**6-2256953693*r**8-12230718049*r**10
            +4274368329*r**12+21785831469*r**14+4768426503*r**16-9916614639*r**18
            -1222014177*r**20-23490292157*r**22-45986075527*r**24-13391628779*r**26
            -2611274093*r**28-145087889*r**30+9556265*r**32))*sqrtq2)+logq2**3*(-138240*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-21739520*Q2**19+512*Q2**18*(660388
            +495105*r**2)-64*Q2**17*(34674507+56521922*r**2+21722935*r**4)+16*Q2**16*(489157688
            +1333809895*r**2+1109823078*r**4+287215895*r**6)-16*Q2**15*(936889061
            +4149567072*r**2+5579353322*r**4+3096408056*r**6+617794185*r**8)+Q2**14*(10464817320
            +108780557635*r**2+212951984236*r**4+188656551350*r**6+82813311980*r**8
            +14516279815*r**10)-2*Q2**13*(-8535594396+26167494285*r**2+75713822757*r**4
            +95951883982*r**6+90044937650*r**8+43545036069*r**10+7917574725*r**12)
            +Q2**12*(-45585046896-141197872551*r**2-467099495374*r**4-847344258509*r**6
            -532676254484*r**8-14521131441*r**10+71636446674*r**12+14390761125*r**14)
            -4*Q2**11*(-7743862584-75424353105*r**2-341291698283*r**4-881091167905*r**6
            -991932131075*r**8-476175574923*r**10-64282814745*r**12+15555544701*r**14
            +2362031295*r**16)-Q2**10*(-22619490488+204485381469*r**2+1236923132608*r**4
            +5484686511504*r**6+9161607055800*r**8+7128713406434*r**10+2807134458448*r**12
            +477696300984*r**14-24958499088*r**16+970566265*r**18)+Q2**9*(-50036529080
            -95964806670*r**2-623281864822*r**4+2185278411760*r**6+6768302726320*r**8
            +7300927696660*r**10+4896058409140*r**12+2343325217728*r**14+719618734200*r**16
            +55194626890*r**18+9556878930*r**20)+Q2**8*(20086040448+289514410385*r**2
            +2450742819678*r**4+5666020895473*r**6+9706627905960*r**8+12235670224442*r**10
            +6486698720900*r**12-664991333902*r**14-2051112087672*r**16-881763919275*r**18
            -99890449042*r**20-6028842755*r**22)-8*Q2**7*(-2314837142+24958761053*r**2
            +231762939479*r**4+1186281477019*r**6+2799540033179*r**8+4258657100142*r**10
            +3155284015482*r**12+449197984794*r**14-715646731556*r**16-434899539771*r**18
            -103738965697*r**20-8929705797*r**22+432497935*r**24)+Q2**6*(-20435278696
            -22225130175*r**2-462563391908*r**4+4441557365790*r**6+8397960112540*r**8
            +18965378364699*r**10+19683660420440*r**12-1165876379276*r**14-12459319310640*r**16
            -9219286214985*r**18-3476744054708*r**20-471504948370*r**22-21931621636*r**24
            +5260716525*r**26)+2*Q2**5*(1150309476+65054932597*r**2+808890223061*r**4
            +1366860798898*r**6+8059385589550*r**8+7210928109131*r**10-724385638893*r**12
            +2023649763132*r**14+5180308157976*r**16+1701456972075*r**18+72251254523*r**20
            +291265969426*r**22-36476768938*r**24-7579594219*r**26-208397795*r**28)
            -Q2**4*(-5501411280+78523843965*r**2+862548080914*r**4+4343240618635*r**6
            +17469561242500*r**8+16838463111405*r**10+1704232110*r**12+301354846947*r**14
            +14765127166440*r**16+18885238340655*r**18+5589595853550*r**20-2467208633575*r**22
            -827756059036*r**24-332146780825*r**26-29810451630*r**28+1958799225*r**30)
            +12*Q2**3*(-203919408-127299725*r**2-9637881847*r**4+145224385143*r**6
            +51700184045*r**8+300017304943*r**10-83723643635*r**12-12393767021*r**14
            +2058629175729*r**16+2903193976905*r**18+1791329410763*r**20+1013556039925*r**22
            -23693540457*r**24-35395419947*r**26-15250029025*r**28-1226426623*r**30
            +64810235*r**32)+9*(-1+r**2)**2*(-8710496+175433611*r**2+2263219400*r**4
            +13372384420*r**6+95459504880*r**8-122836196672*r**10+137644340792*r**12
            +884154025060*r**14+140347442560*r**16-2082552767410*r**18-934704743368*r**20
            +1955975749708*r**22+815246536880*r**24+273048086520*r**26+41936302280*r**28
            -57370964*r**30-190668736*r**32+4231535*r**34)+3*Q2**2*(-104292264+7862647411*r**2
            +102203395432*r**4+64761836212*r**6+2495469491472*r**8-1868053640576*r**10
            +418266655864*r**12+4697307827476*r**14-2935910974224*r**16-4690299092994*r**18
            +7249666857944*r**20+14771925490364*r**22+4681660779152*r**24+2028478147512*r**26
            +318587763272*r**28+6392534396*r**30-1657900264*r**32+79273815*r**34)
            -18*Q2*(-23551964+615563705*r**2+6882252429*r**4+19744221660*r**6+224315368980*r**8
            -443119845528*r**10+367595771200*r**12+819115907148*r**14-342384141940*r**16
            -167031688110*r**18-1725396446702*r**20-498629226540*r**22+2712604196892*r**24
            +1023565992000*r**26+377853179880*r**28+63338237444*r**30-115638240*r**32
            -388343219*r**34+11790905*r**36))+138240*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(21739520*Q2**19-512*Q2**18*(660388+495105*r**2)+64*Q2**17*(34674507
            +56521922*r**2+21722935*r**4)-16*Q2**16*(489157688+1333809895*r**2+1109823078*r**4
            +287215895*r**6)+16*Q2**15*(936889061+4149567072*r**2+5579353322*r**4
            +3096408056*r**6+617794185*r**8)-Q2**14*(10464817320+108780557635*r**2
            +212951984236*r**4+188656551350*r**6+82813311980*r**8+14516279815*r**10)
            +2*Q2**13*(-8535594396+26167494285*r**2+75713822757*r**4+95951883982*r**6
            +90044937650*r**8+43545036069*r**10+7917574725*r**12)+Q2**12*(45585046896
            +141197872551*r**2+467099495374*r**4+847344258509*r**6+532676254484*r**8
            +14521131441*r**10-71636446674*r**12-14390761125*r**14)+4*Q2**11*(-7743862584
            -75424353105*r**2-341291698283*r**4-881091167905*r**6-991932131075*r**8
            -476175574923*r**10-64282814745*r**12+15555544701*r**14+2362031295*r**16)
            +Q2**10*(-22619490488+204485381469*r**2+1236923132608*r**4+5484686511504*r**6
            +9161607055800*r**8+7128713406434*r**10+2807134458448*r**12+477696300984*r**14
            -24958499088*r**16+970566265*r**18)-2*Q2**9*(-25018264540-47982403335*r**2
            -311640932411*r**4+1092639205880*r**6+3384151363160*r**8+3650463848330*r**10
            +2448029204570*r**12+1171662608864*r**14+359809367100*r**16+27597313445*r**18
            +4778439465*r**20)+Q2**8*(-20086040448-289514410385*r**2-2450742819678*r**4
            -5666020895473*r**6-9706627905960*r**8-12235670224442*r**10-6486698720900*r**12
            +664991333902*r**14+2051112087672*r**16+881763919275*r**18+99890449042*r**20
            +6028842755*r**22)+8*Q2**7*(-2314837142+24958761053*r**2+231762939479*r**4
            +1186281477019*r**6+2799540033179*r**8+4258657100142*r**10+3155284015482*r**12
            +449197984794*r**14-715646731556*r**16-434899539771*r**18-103738965697*r**20
            -8929705797*r**22+432497935*r**24)+Q2**6*(20435278696+22225130175*r**2
            +462563391908*r**4-4441557365790*r**6-8397960112540*r**8-18965378364699*r**10
            -19683660420440*r**12+1165876379276*r**14+12459319310640*r**16+9219286214985*r**18
            +3476744054708*r**20+471504948370*r**22+21931621636*r**24-5260716525*r**26)
            +2*Q2**5*(-1150309476-65054932597*r**2-808890223061*r**4-1366860798898*r**6
            -8059385589550*r**8-7210928109131*r**10+724385638893*r**12-2023649763132*r**14
            -5180308157976*r**16-1701456972075*r**18-72251254523*r**20-291265969426*r**22
            +36476768938*r**24+7579594219*r**26+208397795*r**28)+Q2**4*(-5501411280
            +78523843965*r**2+862548080914*r**4+4343240618635*r**6+17469561242500*r**8
            +16838463111405*r**10+1704232110*r**12+301354846947*r**14+14765127166440*r**16
            +18885238340655*r**18+5589595853550*r**20-2467208633575*r**22-827756059036*r**24
            -332146780825*r**26-29810451630*r**28+1958799225*r**30)-12*Q2**3*(-203919408
            -127299725*r**2-9637881847*r**4+145224385143*r**6+51700184045*r**8+300017304943*r**10
            -83723643635*r**12-12393767021*r**14+2058629175729*r**16+2903193976905*r**18
            +1791329410763*r**20+1013556039925*r**22-23693540457*r**24-35395419947*r**26
            -15250029025*r**28-1226426623*r**30+64810235*r**32)-9*(-1+r**2)**2*(
            -8710496+175433611*r**2+2263219400*r**4+13372384420*r**6+95459504880*r**8
            -122836196672*r**10+137644340792*r**12+884154025060*r**14+140347442560*r**16
            -2082552767410*r**18-934704743368*r**20+1955975749708*r**22+815246536880*r**24
            +273048086520*r**26+41936302280*r**28-57370964*r**30-190668736*r**32
            +4231535*r**34)-3*Q2**2*(-104292264+7862647411*r**2+102203395432*r**4
            +64761836212*r**6+2495469491472*r**8-1868053640576*r**10+418266655864*r**12
            +4697307827476*r**14-2935910974224*r**16-4690299092994*r**18+7249666857944*r**20
            +14771925490364*r**22+4681660779152*r**24+2028478147512*r**26+318587763272*r**28
            +6392534396*r**30-1657900264*r**32+79273815*r**34)+18*Q2*(-23551964
            +615563705*r**2+6882252429*r**4+19744221660*r**6+224315368980*r**8-443119845528*r**10
            +367595771200*r**12+819115907148*r**14-342384141940*r**16-167031688110*r**18
            -1725396446702*r**20-498629226540*r**22+2712604196892*r**24+1023565992000*r**26
            +377853179880*r**28+63338237444*r**30-115638240*r**32-388343219*r**34
            +11790905*r**36))*sqrtq2)+logq2**2*(2304*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(135153664*Q2**22-512*Q2**21*(3288694+3061919*r**2)+32*Q2**20*(276876027
            +551822486*r**2+247824027*r**4)-160*Q2**19*(152044196+528307059*r**2
            +499676026*r**4+143055419*r**6)+40*Q2**18*(778433569+5313556203*r**2
            +8183812947*r**4+5104291809*r**6+1042847576*r**8)-Q2**17*(-8673245724
            +247288042345*r**2+557686680060*r**4+594667869570*r**6+318562765120*r**8
            +50770705461*r**10)+Q2**16*(-89818031888-101846024453*r**2-390523163865*r**4
            -560380333470*r**6+128619862330*r**8+290446930467*r**10+42301130287*r**12)
            +2*Q2**15*(54725858432+391611481811*r**2+1832050233387*r**4+4210426461635*r**6
            +3476013273190*r**8+899128008477*r**10-39929539409*r**12-9584011763*r**14)
            -10*Q2**14*(-1133146368+103449032043*r**2+645450677382*r**4+2342776022172*r**6
            +3123671279711*r**8+1805562133167*r**10+419135677656*r**12+18558074442*r**14
            +1157413443*r**16)+10*Q2**13*(-15096798568+14491607609*r**2+186257708341*r**4
            +2613750001008*r**6+5442684286771*r**8+4999340725948*r**10+2344726169259*r**12
            +502557631268*r**14+34686402517*r**16+2751060983*r**18)-2*Q2**12*(-58125591472
            -617337934955*r**2-4945615079190*r**4-3837980324085*r**6+3993489740005*r**8
            +9501827704437*r**10+13841517110105*r**12+9275796824385*r**14+2330513443335*r**16
            +190486329770*r**18+2165008513*r**20)-2*Q2**11*(-23792579616+728634266849*r**2
            +7265861333565*r**4+29330093175915*r**6+66667258923400*r**8+107932250576346*r**10
            +76836770659386*r**12+13403306017630*r**14-6601109940480*r**16-2161721227515*r**18
            -154492520671*r**20+15077693559*r**22)+2*Q2**10*(-57606676088+61957461861*r**2
            +1293032300822*r**4+33622399541650*r**6+110772824535185*r**8+281227621237178*r**10
            +329323025530244*r**12+174221942811548*r**14+35276507750210*r**16-3468704637095*r**18
            -999532775538*r**20-29631026854*r**22+11358332797*r**24)+10*Q2**9*(3404869172
            +110771996868*r**2+1176589090137*r**4-1199807642844*r**6-5866486561063*r**8
            -48890933058282*r**10-89249679004662*r**12-71449754177712*r**14-32373421315530*r**16
            -8770031352368*r**18-709807783683*r**20-235750783956*r**22-25347438243*r**24
            +1189922998*r**26)-10*Q2**8*(-4255991808+85234174154*r**2+1067157021471*r**4
            +5364539838099*r**6+25003291782499*r**8+28223614486395*r**10+12112512381576*r**12
            +5058779163318*r**14-8915670727890*r**16-17538972755952*r**18-9809983987361*r**20
            -1790877021321*r**22-349019939025*r**24-25232634133*r**26+1832664378*r**28)
            -2*Q2**7*(16061292608+66735396455*r**2+119839259415*r**4-31955567576685*r**6
            -155899508009790*r**8-476595032297393*r**10-729128023988675*r**12-796603574333965*r**14
            -398167602662900*r**16+74183005433725*r**18+153231618991377*r**20+60957378683185*r**22
            +9382461307890*r**24+314490027725*r**26-28015807845*r**28+656473673*r**30)
            +2*Q2**6*(-1642043744+238745189371*r**2+2575724724990*r**4-8649798323840*r**6
            -16096015060145*r**8-334187980783671*r**10-441042181705616*r**12-625739460333710*r**14
            -379204640408955*r**16+211761429743645*r**18+366588415385414*r**20+206168699090364*r**22
            +49297835195945*r**24+6945910526495*r**26-483383070900*r**28-99767526574*r**30
            +4519768931*r**32)-6*Q2**5*(-1719405384+26696837503*r**2+410918718511*r**4
            +4422228970860*r**6+32801337790605*r**8+12682932290534*r**10+159864124863607*r**12
            +86175016589064*r**14-32678402454035*r**16+60243251050560*r**18+51557442969989*r**20
            +17350819429292*r**22+16915327515039*r**24+371119396050*r**26+283322736085*r**28
            -43957471264*r**30-9109101777*r**32+310074761*r**34)-10*Q2**4*(221735904
            +8729626631*r**2+28605715714*r**4-2662467508095*r**6-13707907872549*r**8
            -37128673644519*r**10-129103178687793*r**12-68776755409379*r**14+62744960775311*r**16
            -5860281379797*r**18-94473065425049*r**20-25152797460157*r**22+16688932172241*r**24
            +4267981270083*r**26+4387729650621*r**28+873164484639*r**30-7749339931*r**32
            -6398531726*r**34+232387851*r**36)+30*Q2**3*(-42376672+2221214411*r**2
            +19172595239*r**4-152817046715*r**6+121849250108*r**8-7258549793436*r**10
            -1186488286856*r**12-3239314672460*r**14+13695374719228*r**16-14832709983294*r**18
            -60417019082722*r**20-51624419597066*r**22-37059981463852*r**24-4720153037276*r**26
            -940866332736*r**28+489576618980*r**30+200609486036*r**32+3189599723*r**34
            -1239635837*r**36+32145197*r**38)+9*(-1+r**2)**2*(-1519984+206050865*r**2
            +189342065*r**4-68231071475*r**6-292347515195*r**8-1154963227724*r**10
            -9740922697820*r**12+26234715540580*r**14-24148338531500*r**16-99820793951490*r**18
            +89612598500526*r**20+140641381769670*r**22-95746036788730*r**24-41942110260700*r**26
            -20664147010060*r**28-6332251486444*r**30-518207823340*r**32+43033358585*r**34
            +2438372425*r**36-178695755*r**38+2845501*r**40)+6*Q2**2*(99827564-340915255*r**2
            -28977306790*r**4-968341583870*r**6-6270913827575*r**8+6939001808104*r**10
            -116090327839940*r**12+116525131049140*r**14+1821336943480*r**16-43662918241230*r**18
            +87495847827024*r**20-129769672665480*r**22-328163852457910*r**24-95943516097600*r**26
            -71965551978940*r**28-17891793956116*r**30-947771568700*r**32+86085838685*r**34
            -1681972010*r**36-971119130*r**38+37036549*r**40)-9*Q2*(3337892+925992007*r**2
            -2368289210*r**4-392603177970*r**6-1552548436390*r**8-1272044667613*r**10
            -45638008730488*r**12+119055402067880*r**14-75186925153840*r**16-180136984246130*r**18
            +9766307638212*r**20+259394714088372*r**22+180527344740620*r**24-262478292537410*r**26
            -103551175755320*r**28-55177300901528*r**30-17684153334308*r**32-1422798566165*r**34
            +167738050470*r**36+7825356590*r**38-936678838*r**40+20003167*r**42))
            -2304*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(135153664*Q2**23-512*Q2**22*(3552666
            +3325891*r**2)+32*Q2**21*(329495131+653432294*r**2+296814731*r**4)-32*Q2**20*(1037097007
            +3470233808*r**2+3298026643*r**4+963101122*r**6)+40*Q2**19*(1386610353
            +8034961223*r**2+12295745287*r**4+7675217589*r**6+1615069252*r**8)-Q2**18*(22464097036
            +490967633225*r**2+1097581446060*r**4+1126192059810*r**6+564448340520*r**8
            +92484608501*r**10)+4*Q2**17*(-24622819403+34192193042*r**2+103612889635*r**4
            +147993554040*r**6+260462624255*r**8+164945100262*r**10+23267958937*r**12)
            +Q2**16*(199269748752+974887019963*r**2+4156469655092*r**4+9371756420605*r**6
            +7383787017520*r**8+1379189224157*r**10-412607139572*r**12-61469153813*r**14)
            +4*Q2**15*(-24530063296-481791250229*r**2-2725457551054*r**4-8878178402941*r**6
            -11652398066690*r**8-6701475973751*r**10-1477438428674*r**12-21638410519*r**14
            +1898472274*r**16)+20*Q2**14*(-8114972468+58403746642*r**2+467578708883*r**4
            +2800988350281*r**6+5454565794327*r**8+4964287069413*r**10+2284711990041*r**12
            +470125691683*r**14+27200945201*r**16+1954237213*r**18)-4*Q2**13*(-66804792156
            -310181944875*r**2-1970934249720*r**4+5081029111330*r**6+22137830589450*r**8
            +30855976384016*r**10+25280925793070*r**12+11756107913510*r**14+2508366806130*r**16
            +188836823635*r**18+7960156714*r**20)-4*Q2**12*(17166505928+702048896638*r**2
            +6414407173855*r**4+19056844289595*r**6+33255874753740*r**8+47218466565952*r**10
            +26746712922422*r**12-4857003958430*r**14-9103710104100*r**16-2341360500310*r**18
            -173571929477*r**20+6456342523*r**22)+4*Q2**11*(-40699627852+383399574547*r**2
            +4643763950618*r**4+35109177025565*r**6+103385088317250*r**8+227913565368462*r**10
            +257046023382988*r**12+132231009744282*r**14+21039351913680*r**16-6115767902545*r**18
            -1657873261862*r**20-84522926983*r**22+13218013178*r**24)-2*Q2**10*(-74631021948
            -549509198567*r**2-4527955688002*r**4+40914470056692*r**6+173727656882150*r**8
            +636455111063773*r**10+1056799041790732*r**12+860793739230352*r**14+371365557139408*r**16
            +75657959874955*r**18-919198494218*r**20+149590117388*r**22+108464497158*r**24
            +5408717807*r**26)-20*Q2**9*(-425561318+99705520097*r**2+1177259054238*r**4
            +2670660642696*r**6+8968498789296*r**8-13266902566475*r**10-63014049840684*r**12
            -77820327009528*r**14-56369423110566*r**16-29341212711925*r**18-9644911561706*r**20
            -1368217794480*r**22-305059080612*r**24-24695074689*r**26+1511293688*r**28)
            +2*Q2**8*(-37341251648+338155515275*r**2+5642116718710*r**4+64114051874535*r**6
            +307738666112780*r**8+742729563641863*r**10+930808658328530*r**12+882460032058435*r**14
            +378883144840040*r**16-206456222852935*r**18-289976402707942*r**20-118961683726595*r**22
            -20081946109620*r**24-2185752893515*r**26-88984040930*r**28+8506848217*r**30)
            +4*Q2**7*(7209624432+160770939217*r**2+1381149690430*r**4-20242763320555*r**6
            -101975545323310*r**8-483341260545427*r**10-823382618995842*r**12-1075735529328175*r**14
            -786987908702910*r**16-56111583742765*r**18+297001519905258*r**20+210178848382463*r**22
            +59818837593510*r**24+8321430931055*r**26-98454425510*r**28-63563430373*r**30
            +2588121302*r**32)-4*Q2**6*(-3400129948+158596829068*r**2+2023613034947*r**4
            +3596306656865*r**6+36829099993915*r**8-156117599486107*r**10-147818893949233*r**12
            -404128296136067*r**14-551489654052385*r**16+6643271243185*r**18+366511087019513*r**20
            +312404786381827*r**22+153106258415713*r**24+28678551955295*r**26+3656247831925*r**28
            -357511505633*r**30-61287531487*r**32+2724996607*r**34)-4*Q2**5*(3133447836
            -15642081601*r**2-584909044736*r**4-13905890304294*r**6-90105119823570*r**8
            -161048089233006*r**10-581578532450694*r**12-541000600702454*r**14+76617480735734*r**16
            -55997976344280*r**18-403883704593446*r**20-166244387249314*r**22-9676889985894*r**24
            -15259717191426*r**26+9987660928350*r**28+1823863314366*r**30+60226509734*r**32
            -2797788791*r**34+115857486*r**36)+20*Q2**4*(47302944+7807502884*r**2
            +47426564031*r**4-1546156466263*r**6-8002413815160*r**8-36306115448688*r**10
            -84895658596440*r**12-103798939057276*r**14+17527164761808*r**16+6193274722816*r**18
            -140792202026506*r**20-137249560838202*r**22-59821904839736*r**24+3398227165248*r**26
            +2916555961248*r**28+3364811996100*r**30+733621801408*r**32-2289536244*r**34
            -4942525693*r**36+164411721*r**38)-12*Q2**3*(-155855462+5617551975*r**2
            +67973177520*r**4+150059663245*r**6+3058037422270*r**8-21311252262372*r**10
            +36932568719240*r**12-69327072922860*r**14+25229481645180*r**16+18988120960450*r**18
            -231872246578552*r**20-215218760366730*r**22-57629076423340*r**24-56478578204020*r**26
            +21830227564440*r**28+7817672693668*r**30+2199351046890*r**32+466454795055*r**34
            +5715895720*r**36-2533167035*r**38+61844718*r**40)-9*(-1+r**2)**2*(-1519984
            +204530881*r**2+395392930*r**4-68041729410*r**6-360578586670*r**8-1447310742919*r**10
            -10895885925544*r**12+16493792842760*r**14+2086377009080*r**16-123969132482990*r**18
            -10208195450964*r**20+230253980270196*r**22+44895344980940*r**24-137688147049430*r**26
            -62606257270760*r**28-26996398496504*r**30-6850459309784*r**32-475174464755*r**34
            +45471731010*r**36+2259676670*r**38-175850254*r**40+2845501*r**42)-3*Q2**2*(209668804
            +2295800639*r**2-65741311720*r**4-3172447315230*r**6-19136156132060*r**8
            -2479958041781*r**10-355216678255136*r**12+358035812622040*r**14+11132160523720*r**16
            -624094115333890*r**18+116964782086224*r**20+693636492588204*r**22-374285016024920*r**24
            -1635649614723250*r**26-646471663419040*r**28-345246594574696*r**30-90731591052556*r**32
            -5991767158525*r**34+672021884760*r**36+18169887490*r**38-4678201676*r**40
            +134082599*r**42)+36*Q2*(454477+284605183*r**2-416644213*r**4-115843792980*r**6
            -525211911135*r**8-865773093203*r**10-13658349288917*r**12+29494747761472*r**14
            -10622553849110*r**16-70153327686970*r**18+23683792816022*r**20+32689103135928*r**22
            +38126464250362*r**24+52060099322410*r**26-99638857892530*r**28-41418636095968*r**30
            -20344826524087*r**32-6089938595413*r**34-464224170945*r**36+53385331260*r**38
            +2421821797*r**40-275265607*r**42+5712167*r**44))*sqrtq2)+logq2*(-192*r**8*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(-1812736*Q2**21+32*Q2**20*(709487+916277*r**2)
            -8*Q2**19*(14601460+42425907*r**2+23405375*r**4)+24*Q2**18*(12609655
            +64267331*r**2+76230833*r**4+26664713*r**6)-Q2**17*(325832580+3179094721*r**2
            +5235552667*r**4+4771490143*r**6+1274668801*r**8)+Q2**16*(-273498296
            +1120577589*r**2-4393757148*r**4-1092442182*r**6+5888767156*r**8+1419714545*r**10)
            +Q2**15*(1248294744+8417753928*r**2+59004753998*r**4+104604396482*r**6
            +45519776802*r**8-772197130*r**10-610371528*r**12)-2*Q2**14*(591260580
            +8403800666*r**2+67038570445*r**4+202414278374*r**6+189389403950*r**8
            +61795046458*r**10+3832517281*r**12+137048390*r**14)+Q2**13*(-597323960
            +6856249668*r**2+83257548154*r**4+656342776186*r**6+999040698272*r**8
            +664494126128*r**10+179027038562*r**12+11928532754*r**14-44363716*r**16)
            +2*Q2**12*(1059065020+8791918344*r**2+86354658983*r**4-98714996782*r**6
            -305604872163*r**8-391951486796*r**10-318172324303*r**12-91087484910*r**14
            -5900300593*r**16+514976224*r**18)-2*Q2**11*(585392548+12882739596*r**2
            +187676491533*r**4+546752760071*r**6+1320972456793*r**8+1828338886775*r**10
            +669173145547*r**12-122627650379*r**14-68853578385*r**16-4708015871*r**18
            +500742012*r**20)-2*Q2**10*(507081068-2431700766*r**2-94102315943*r**4
            -978370134258*r**6-3194776404912*r**8-7065969216500*r**10-5898903999502*r**12
            -1917725771396*r**14-92571362868*r**16+16198910306*r**18+943836717*r**20
            +15076390*r**22)+2*Q2**9*(767095680+8458621341*r**2+113289859890*r**4
            -494487174102*r**6-1564148614155*r**8-8430890207054*r**10-10867841061836*r**12
            -6292472875980*r**14-1989073270022*r**16-187387102815*r**18-37489990614*r**20
            -2931807054*r**22+263899905*r**24)-2*Q2**8*(128548620+7182095959*r**2
            +180784586617*r**4+574477943404*r**6+3731135495437*r**8+816107583773*r**10
            -2528888412870*r**12-2549939791112*r**14-2983051580890*r**16-1757721443263*r**18
            -258694736627*r**20-36065323172*r**22-1562851583*r**24+48242827*r**26)
            -2*Q2**7*(329999420+254071044*r**2-58082387397*r**4-1046495223291*r**6
            -5831292001615*r**8-11031016631917*r**10-12003075368358*r**12-10925250551294*r**14
            -267013978290*r**16+4314137077882*r**18+2330035459423*r**20+381063254265*r**22
            +573627717*r**24-2375108113*r**26+142828684*r**28)+2*Q2**6*(204009012
            +3212119746*r**2+63397029113*r**4-452909028610*r**6-1055627839158*r**8
            -9707745247890*r**10-6777948207269*r**12-11629320990462*r**14-890202920608*r**16
            +6813871943854*r**18+5810466584367*r**20+1681436737938*r**22+280388746274*r**24
            -8615597022*r**26-2371589251*r**28+81024366*r**30)+2*Q2**5*(34581852
            -1447463902*r**2-65837544533*r**4-329385371389*r**6-3842661814072*r**8
            +3086506149620*r**10-14434993367495*r**12+1022077278137*r**14+2446303067058*r**16
            -5613627020542*r**18+249818301437*r**20-1717616957227*r**22+320413464516*r**24
            +82114111976*r**26-1153577441*r**28-346073489*r**30+24853094*r**32)-2*Q2**4*(71439260
            +223895172*r**2-14545476805*r**4-441392443726*r**6-3019567911755*r**8
            -102047675812*r**10-20540793337717*r**12+3695843104910*r**14+13822349854997*r**16
            -13709119656680*r**18-4737704928711*r**20+3488226359758*r**22-551516655545*r**24
            +761069055404*r**26+240796905985*r**28-982587662*r**30-1187447213*r**32
            +34178140*r**34)+2*Q2**3*(15284740+374817528*r**2+10511776669*r**4-114722532245*r**6
            +21819762201*r**8-2069298193041*r**10-2357835229351*r**12+4672117347351*r**14
            +5930513031029*r**16-16511620783877*r**18-9317786091873*r**20-12605461215727*r**22
            -776457166789*r**24-882318809763*r**26+117622592451*r**28+86135619949*r**30
            +1813377075*r**32-297776831*r**34+4942504*r**36)+3*(-1+r**2)**2*(468368
            +2195771*r**2-131023432*r**4-7131498625*r**6-45711456712*r**8+162044336356*r**10
            -1949394960088*r**12+6243779381156*r**14-8581045254760*r**16-4818918734574*r**18
            +18465291668184*r**20-8480824696262*r**22-728924821016*r**24-1144545921980*r**26
            -512844190216*r**28-68012034908*r**30+3047531704*r**32+199830667*r**34
            -13219760*r**36+240127*r**38)+2*Q2**2*(8634440-104049002*r**2-7981099359*r**4
            -74589685750*r**6-923938921964*r**8+3180694219704*r**10-15452306166680*r**12
            +20739247694816*r**14-5080771990236*r**16-1545951967324*r**18-593442346478*r**20
            -14035565676684*r**22-4891868898980*r**24-4269827357128*r**26-1857713729760*r**28
            -201011306416*r**30+37441550116*r**32+132157398*r**34-212606011*r**36
            +5385298*r**38)+3*Q2*(-3218132+2094037*r**2+1399708621*r**4+36423504473*r**6
            +259203516557*r**8-1241454460180*r**10+8866683468044*r**12-23997893305828*r**14
            +24274251798356*r**16+12103316632254*r**18-22225906239858*r**20-13325270288874*r**22
            +12814672974718*r**24+3942464129644*r**26+2643325485196*r**28+1499812217884*r**30
            +220832530168*r**32-18687276011*r**34-729844723*r**36+86939993*r**38
            -1726339*r**40))+192*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(14501888*Q2**25
            -1536*Q2**24*(126509+160974*r**2)+32*Q2**23*(33772793+96345458*r**2+52828153*r**4)
            -8*Q2**22*(384296528+1929105189*r**2+2285301082*r**4+777455205*r**6)
            +8*Q2**21*(480591047+4598873094*r**2+8155519984*r**4+6785043866*r**6
            +1660474601*r**8)-Q2**20*(-2307904636+25278439387*r**2+18771713348*r**4
            +57499248038*r**6+81903807832*r**8+15326959775*r**10)+4*Q2**19*(-3684783551
            -20385686031*r**2-129689528190*r**4-230114476810*r**6-89113420175*r**8
            +8817426009*r**10+1135040524*r**12)+2*Q2**18*(8176673498+108691142253*r**2
            +777170895548*r**4+2326539111315*r**6+2191780195690*r**8+680665397763*r**10
            +41832023808*r**12+4881161213*r**14)-4*Q2**17*(-1759249849+35222006878*r**2
            +371470741794*r**4+2392405518340*r**6+3740683935110*r**8+2409750214686*r**10
            +583696819218*r**12+41306039744*r**14+1567876415*r**16)+Q2**16*(-32328345504
            -211054576983*r**2-1538996035768*r**4+6103983559988*r**6+17679613486208*r**8
            +19501095524066*r**10+11389725733272*r**12+2411150451692*r**14+148622984768*r**16
            -12896872107*r**18)+16*Q2**15*(1238412661+26987544963*r**2+327305807397*r**4
            +867520982652*r**6+1649207578233*r**8+2219681386362*r**10+585261013093*r**12
            -322150840708*r**14-91425126818*r**16-4781465077*r**18+1097774890*r**20)
            +8*Q2**14*(2510530882-18516748743*r**2-475653590590*r**4-4467489768085*r**6
            -14116085879480*r**8-30711098461312*r**10-26588268509282*r**12-8611194308100*r**14
            -611548266990*r**16-16091129625*r**18-4553431708*r**20+174485337*r**22)
            -16*Q2**13*(2008161234+19682476494*r**2+190219719379*r**4-1633999452960*r**6
            -7113694256820*r**8-28391056031714*r**10-39232836025794*r**12-23705154704944*r**14
            -6396793657400*r**16-622942465120*r**18-90028076901*r**20-8321292476*r**22
            +900038894*r**24)+2*Q2**12*(1427473828+177508094829*r**2+3476253347132*r**4
            +10075252763110*r**6+37758326469640*r**8-104999133795113*r**10-312171011672464*r**12
            -304416075707692*r**14-165565621837540*r**16-45982584374365*r**18-5422168317132*r**20
            -580132975306*r**22-29073497768*r**24+2085004585*r**26)+8*Q2**11*(2596811407
            -358207861*r**2-340216303916*r**4-6733804777754*r**6-33155372131789*r**8
            -68804606786227*r**10-76480508606904*r**12-79645015720164*r**14-15233952107371*r**16
            +22461948210629*r**18+10621950549012*r**20+1710447801454*r**22-29953373351*r**24
            -15567568909*r**26+1049921056*r**28)-4*Q2**10*(2810976106+54228619713*r**2
            +856499533992*r**4-7412876797633*r**6-40295164702442*r**8-271636098066179*r**10
            -566869799414128*r**12-1006586619452677*r**14-807432389988602*r**16-236256335870693*r**18
            +19187045398808*r**20+14153932276213*r**22+2581154435642*r**24-179831040473*r**26
            -32668768272*r**28+1366083025*r**30)-8*Q2**9*(768557213-14630113002*r**2
            -482638810840*r**4-2824031522760*r**6-15457535456660*r**8+85341096203102*r**10
            +209188931884232*r**12+706642038305220*r**14+888629808030650*r**16+496691392410690*r**18
            +142944558702632*r**20+5902573789872*r**22+3133145199140*r**24+691621105930*r**26
            +17976781800*r**28-4311174252*r**30+319606553*r**32)+2*Q2**8*(3617294248
            +19997285333*r**2-137642314872*r**4-18702802523680*r**6-104659906791440*r**8
            -205256668397888*r**10-879506939257888*r**12+223165071675272*r**14+1615391445741240*r**16
            +1130265611445010*r**18+799804661939272*r**20+470634678981232*r**22+87895547332032*r**24
            +30272400159080*r**26+6836874695760*r**28-54131663832*r**30-47064718352*r**32
            +1587781873*r**34)+16*Q2**7*(-288569-3908639577*r**2-99625721711*r**4
            +586984313200*r**6+3810408303985*r**8+69239410172124*r**10+226405449912657*r**12
            +432008703558056*r**14+432131634623195*r**16+407141076204850*r**18+96331674184119*r**20
            -107858119352608*r**22-79504520164069*r**24-18946638575380*r**26-1378532911845*r**28
            -151776142584*r**30+616273618*r**32+580915039*r**34+10074700*r**36)-16*Q2**6*(147241219
            -819291537*r**2-49369627092*r**4-828720828618*r**6-3468016994298*r**8
            +41129120175151*r**10+53450491082497*r**12+451542268723927*r**14+386454995452598*r**16
            +422776167146553*r**18+103223759882471*r**20-249963438277953*r**22-244261099412538*r**24
            -81770111031147*r**26-20443695460657*r**28-513681361291*r**30+440929080443*r**32
            +5529339028*r**34-2550957283*r**36+70670527*r**38)+8*Q2**5*(79156017
            +1502285566*r**2+23159004534*r**4-1217909766026*r**6-6147435558049*r**8
            -34268488893076*r**10-272194326557616*r**12+282954108694616*r**14-865722866734434*r**16
            -293733090409696*r**18+198438290933796*r**20-233681494456436*r**22-144757412480614*r**24
            -189242006523644*r**26-13067143477136*r**28-7804359977592*r**30-1654447991039*r**32
            +371816083314*r**34+13140780454*r**36-1799079394*r**38+30246455*r**40)
            +Q2**4*(378987676-7442685759*r**2-262217446740*r**4-206739953910*r**6
            +14351304290760*r**8+530062947211401*r**10+1478855292711616*r**12+1567419787117560*r**14
            +11665336067666520*r**16-183111584121070*r**18-8531199764475144*r**20
            +5590432222335516*r**22+1402912733254000*r**24-2111546985526710*r**26
            -71668065443040*r**28-392217171484744*r**30-163817551719444*r**32-6848960310195*r**34
            +1827039743100*r**36+28205015850*r**38-8762519064*r**40+208791821*r**42)
            -12*Q2**3*(16771677-27394923*r**2-3760844818*r**4-192280418010*r**6-61146243115*r**8
            +13072022919577*r**10-20050173147588*r**12+227917058710552*r**14+17799311780890*r**16
            -307802496103110*r**18-219399272351468*r**20+842763807053652*r**22+758561748434322*r**24
            +732487546022250*r**26+156130636484240*r**28+61268085092472*r**30+5583246755177*r**32
            -7053003978703*r**34-1204343462130*r**36+90679653110*r**38+4915922617*r**40
            -448861443*r**42+7764772*r**44)-9*(-1+r**2)**2*(468368-4361381*r**2
            -205790818*r**4-5510130203*r**6+66415454220*r**8+1474202124893*r**10
            +178571219174*r**12+18935970100267*r**14+84934837491632*r**16-444145973219010*r**18
            +803186101603388*r**20+312361865946914*r**22-1558850978853368*r**24+542924920931722*r**26
            +221226569308860*r**28+116423246092198*r**30+64457287987424*r**32+12385938409207*r**34
            +150045469222*r**36-129276244695*r**38+1489198028*r**40+362335369*r**42
            -16581538*r**44+240127*r**46)-6*Q2**2*(2167954-172629183*r**2-4746007324*r**4
            +102202157695*r**6+740863985850*r**8+15631253739419*r**10+65940355706352*r**12
            -249724998666219*r**14+1494831833154180*r**16-1757634837595190*r**18-445902246052296*r**20
            +545182266971702*r**22+647922906635236*r**24+1610411927580150*r**26+287868135744080*r**28
            +424715240300394*r**30+167701281996522*r**32+16194443454981*r**34-2426821578620*r**36
            +177645064635*r**38+29128525154*r**40-705695393*r**42-80915424*r**44
            +1955345*r**46)+36*Q2*(687441-10813718*r**2-379737118*r**4-2819893452*r**6
            +84221171598*r**8+1911148001706*r**10+828748824042*r**12+488170363032*r**14
            +141548797303263*r**16-489701433497772*r**18+512511648708836*r**20+424039869003832*r**22
            -633626775409788*r**24-395647108084252*r**26+358455251495428*r**28+121498934613696*r**30
            +82408809588207*r**32+42504076115202*r**34+8527791971898*r**36-146379553932*r**38
            -111111793554*r**40+4080915762*r**42+352539922*r**44-23691832*r**46+371553*r**48))*sqrtq2))*math.log(r)**2)/(168000*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2
            +168000*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2
            +logq2**7*(-1354442342400000*r**32*(1+r**2)**2*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3-1354442342400000*r**32*(1+r**2)**2*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**6*(7524679680000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))+7524679680000*r**28*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))*sqrtq2)+logq2*(-10080000*(-Q2
            +(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(9+8*Q2**4-78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)
            -Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-10080000*(-Q2+(-1+r)**2)**3*r**8*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(9+8*Q2**4-78*r**2-366*r**4
            -78*r**6+9*r**8-Q2**3*(1+r**2)-Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1
            +13*r**2+13*r**4+r**6))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*sqrtq2)+logq2**2*(120960000*(-Q2+(-1+r)**2)**3*r**12*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531
            +550*r**2+531*r**4)-2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815
            -2120*r**2-11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4
            +494*r**6+225*r**8+r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6
            +26793*r**8+4554*r**10-501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6
            -1385*r**8-311*r**10+15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6
            +34670*r**8+13388*r**10-184*r**12-316*r**14+17*r**16))+120960000*(
            -Q2+(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531+550*r**2+531*r**4)
            -2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815-2120*r**2-11502*r**4
            -2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4+494*r**6+225*r**8
            +r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6+26793*r**8+4554*r**10
            -501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6-1385*r**8-311*r**10
            +15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6+34670*r**8+13388*r**10
            -184*r**12-316*r**14+17*r**16))*sqrtq2)+logq2**3*(-1451520000*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8+256*Q2**7*(1+r**2)
            -Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2+893*r**4+319*r**6)
            +Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)+12*Q2**3*(61
            +235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(-1071+9654*r**2
            +51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)-18*Q2*(23
            -35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12+23*r**14)
            +9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10-264*r**12
            -756*r**14+47*r**16))-1451520000*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8
            +256*Q2**7*(1+r**2)-Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2
            +893*r**4+319*r**6)+Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)
            +12*Q2**3*(61+235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(
            -1071+9654*r**2+51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)
            -18*Q2*(23-35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12
            +23*r**14)+9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10
            -264*r**12-756*r**14+47*r**16))*sqrtq2)+logq2**4*(17418240000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513+770*r**2
            +513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105-3400*r**2
            -11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4-1178*r**6
            +75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6+19593*r**8
            +3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6-5785*r**8
            -2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4+25204*r**6
            +52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))+17418240000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513
            +770*r**2+513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105
            -3400*r**2-11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4
            -1178*r**6+75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6
            +19593*r**8+3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6
            -5785*r**8-2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4
            +25204*r**6+52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))*sqrtq2)
            +logq2**5*(-41803776000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(64*Q2**8+1088*Q2**7*(1+r**2)+Q2**6*(-63+130*r**2-63*r**4)
            -2*Q2**5*(2777+6379*r**2+6379*r**4+2777*r**6)+Q2**4*(1555-8080*r**2
            -22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743-315*r**2-6548*r**4-6548*r**6
            -315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2+199629*r**4+305844*r**6
            +199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83-375*r**2-2833*r**4
            -5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)+9*(301-4028*r**2
            +808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12-4028*r**14+301*r**16))
            -41803776000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(64*Q2**8+1088*Q2**7*(1
            +r**2)+Q2**6*(-63+130*r**2-63*r**4)-2*Q2**5*(2777+6379*r**2+6379*r**4
            +2777*r**6)+Q2**4*(1555-8080*r**2-22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743
            -315*r**2-6548*r**4-6548*r**6-315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2
            +199629*r**4+305844*r**6+199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83
            -375*r**2-2833*r**4-5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)
            +9*(301-4028*r**2+808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12
            -4028*r**14+301*r**16))*sqrtq2))+nlo.X1Q2_Derivativer(3,Q2,r)*((4*r)/(-36*logq2*r**4
            +3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)
            -(2*muWC**2*r)/(-36*logq2*r**4+3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2)-(16*muWC*r)/(-108*logq2*r**4+9*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(2*r*math.log(mu0))/(
            -12*logq2*r**4+(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)-(2*r*math.log(r))/(-12*logq2*r**4+(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+nlo.X1Q2_Derivativer(1,Q2,r)*((muWC*(
            -28800*logq2**2*r**9*(15+22*r**2+15*r**4)-8*(-Q2+(-1+r)**2)*r*(-Q2
            +(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4+19308*r**6+138690*r**8
            +19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1+r**2)+Q2**6*(
            -89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4+79*r**6)+Q2**4*(165
            -1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4
            -2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2+1787*r**4-14228*r**6
            +1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2-2957*r**4+19165*r**6
            +19165*r**8-2957*r**10-635*r**12+27*r**14))-4800*logq2*r**5*(1+2*Q2**5
            +35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17
            +42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2
            +66*r**4+30*r**6-11*r**8))*sqrtq2))/(-388800*logq2**3*r**12-8100*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+97200*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+225*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +(muWC**2*(-3600*logq2**2*r**9*(15+22*r**2+15*r**4)-(-Q2+(-1+r)**2)*r*(
            -Q2+(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4+19308*r**6+138690*r**8
            +19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1+r**2)+Q2**6*(
            -89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4+79*r**6)+Q2**4*(165
            -1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4
            -2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2+1787*r**4-14228*r**6
            +1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2-2957*r**4+19165*r**6
            +19165*r**8-2957*r**10-635*r**12+27*r**14))-600*logq2*r**5*(1+2*Q2**5
            +35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17
            +42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2
            +66*r**4+30*r**6-11*r**8))*sqrtq2))/(-129600*logq2**3*r**12-2700*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+32400*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+75*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +(7200*logq2**2*r**9*(15+22*r**2+15*r**4)+2*(-Q2+(-1+r)**2)*r*(-Q2
            +(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4+19308*r**6+138690*r**8
            +19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1+r**2)+Q2**6*(
            -89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4+79*r**6)+Q2**4*(165
            -1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4
            -2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2+1787*r**4-14228*r**6
            +1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2-2957*r**4+19165*r**6
            +19165*r**8-2957*r**10-635*r**12+27*r**14))+1200*logq2*r**5*(1+2*Q2**5
            +35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17
            +42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2
            +66*r**4+30*r**6-11*r**8))*sqrtq2)/(-129600*logq2**3*r**12-2700*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+32400*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+75*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((3600*logq2**2*r**9*(15+22*r**2+15*r**4)+(-Q2+(-1+r)**2)*r*(-Q2
            +(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4+19308*r**6+138690*r**8
            +19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1+r**2)+Q2**6*(
            -89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4+79*r**6)+Q2**4*(165
            -1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4
            -2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2+1787*r**4-14228*r**6
            +1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2-2957*r**4+19165*r**6
            +19165*r**8-2957*r**10-635*r**12+27*r**14))+600*logq2*r**5*(1+2*Q2**5
            +35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17
            +42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2
            +66*r**4+30*r**6-11*r**8))*sqrtq2)*math.log(mu0))/(-43200*logq2**3*r**12-900*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+10800*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+25*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((-3600*logq2**2*r**9*(15+22*r**2+15*r**4)-(-Q2+(-1+r)**2)*r*(-Q2
            +(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4+19308*r**6+138690*r**8
            +19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1+r**2)+Q2**6*(
            -89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4+79*r**6)+Q2**4*(165
            -1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4
            -2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2+1787*r**4-14228*r**6
            +1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2-2957*r**4+19165*r**6
            +19165*r**8-2957*r**10-635*r**12+27*r**14))-600*logq2*r**5*(1+2*Q2**5
            +35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17
            +42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2
            +66*r**4+30*r**6-11*r**8))*sqrtq2)*math.log(r))/(-43200*logq2**3*r**12-900*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+10800*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+25*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2))
            +nlo.X1Q2_Derivativer(2,Q2,r)*((360*logq2*r**5*(1+r**2)-2*r*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)/(720*logq2**2*r**8+5*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(muWC**2*(-180*logq2*r**5*(1+r**2)
            +r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2
            -11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(720*logq2**2*r**8
            +5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(muWC*(-1440*logq2*r**5*(1
            +r**2)+8*r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(2160*logq2**2*r**8
            +15*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-360*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((540*logq2*r**5*(1+r**2)
            -3*r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2
            -11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*math.log(mu0))/(720*logq2**2*r**8
            +5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((-540*logq2*r**5*(1+r**2)
            +3*r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2
            -11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*math.log(r))/(720*logq2**2*r**8
            +5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+flagPERP*muWC**3*((pi2*(
            -172800*logq2**3*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(301-1584*r**2
            -240*Q2**6*r**2+5717*r**4-6176*r**6+8279*r**8-72*r**10-1017*r**12+1272*r**14
            +20*Q2**5*(7+51*r**2+72*r**4)-4*Q2**4*(196+445*r**2+1206*r**4+837*r**6)
            +Q2**3*(1001+2581*r**2+5141*r**4+8403*r**6+3162*r**8)+Q2**2*(91-2396*r**2
            -1418*r**4-5364*r**6-6801*r**8+432*r**10)+Q2*(-749+2609*r**2-3480*r**4
            -158*r**6+3027*r**8+2589*r**10-2718*r**12))-48*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2
            -(1+r)**2)**2*(-2345-4786*r**2-4656*Q2**12*r**2-227548*r**4+481994*r**6
            +1802615*r**8-49508100*r**10+129325752*r**12-64400404*r**14-24624243*r**16
            +36020510*r**18-7593180*r**20+2793034*r**22+119077*r**24+9624*r**26
            +4*Q2**11*(-805+12483*r**2+10068*r**4)-4*Q2**10*(-4270+40169*r**2+101692*r**4
            +31629*r**6)+5*Q2**9*(-5705+35759*r**2+230039*r**4+218089*r**6+30234*r**8)
            +5*Q2**8*(-525+8796*r**2-146250*r**4-109268*r**6-153705*r**8+11736*r**10)
            -4*Q2**7*(-15225+43362*r**2+391830*r**4+2489570*r**6+2227745*r**8+377580*r**10
            +82962*r**12)+2*Q2**6*(-27930-43407*r**2+1131663*r**4+11081830*r**6
            +22772900*r**8+9808525*r**10+1462503*r**12+123228*r**14)+2*Q2**5*(-9555
            +140781*r**2-32367*r**4-4813089*r**6-29472945*r**8-31808175*r**10-3300179*r**12
            -377517*r**14+60246*r**16)-10*Q2**4*(-5565+7257*r**2+73677*r**4+1239897*r**6
            +13677*r**8-4040437*r**10-1987573*r**12+2016227*r**14+189432*r**16+25632*r**18)
            +20*Q2**3*(-1050-6669*r**2-15750*r**4+487512*r**6+1874250*r**8+2580692*r**10
            +822492*r**12+1358960*r**14+999352*r**16+75105*r**18+4146*r**20)+2*Q2**2*(
            -5950+43977*r**2+67185*r**4+926990*r**6-6384960*r**8-19560330*r**10
            -42812974*r**12+391620*r**14-15779010*r**16+594465*r**18+36285*r**20
            +28302*r**22)-Q2*(-10955+5893*r**2-461227*r**4+2684035*r**6+5334100*r**8
            -7411850*r**10+19731094*r**12-69809126*r**14+49679065*r**16-20660475*r**18
            +8352405*r**20+424163*r**22+46878*r**24))-72576000*logq2**4*r**14*(3-5*r**2
            +3*r**4+3*r**6)*sqrtq2+2880*logq2**2*r**6*(4320*Q2**11*r**2-8*Q2**10*(-7
            +5007*r**2+4986*r**4)+40*Q2**9*(-49+3857*r**2+7613*r**4+3759*r**6)
            -5*Q2**8*(-1785+59477*r**2+182793*r**4+184359*r**6+55980*r**8)+20*Q2**7*(
            -693+13253*r**2+62918*r**4+96754*r**6+66735*r**8+10305*r**10)+10*Q2**6*r**2*(203
            -53651*r**2-117893*r**4-127639*r**6-74214*r**8+14490*r**10)-2*Q2**5*(
            -12054+112469*r**2+304767*r**4+680760*r**6+961880*r**8+607101*r**10
            +176799*r**12+206262*r**14)+10*Q2**4*(-2499+18097*r**2+84256*r**4+244614*r**6
            +424315*r**8+462877*r**10+217370*r**12+75348*r**14+27414*r**16)+20*Q2**3*(105
            -212*r**2-14014*r**4-73778*r**6-81299*r**8-182225*r**10-173800*r**12
            -14564*r**14-25104*r**16+1755*r**18)-(-1+r**2)**2*(-1561+9259*r**2
            +17902*r**4-417650*r**6+974908*r**8-198572*r**10+237346*r**12-321422*r**14
            +301405*r**16-10303*r**18+13488*r**20)-10*Q2**2*(-1176+8281*r**2+7383*r**4
            -111243*r**6+173905*r**8-7005*r**10-34557*r**12-191033*r**14+148275*r**16
            -27480*r**18+14490*r**20)+10*Q2*(-770+5515*r**2+4639*r**4-115040*r**6
            +228502*r**8-24740*r**10+66736*r**12+144310*r**14-185396*r**16+125097*r**18
            -14511*r**20+7578*r**22))*sqrtq2+8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(279
            +51832*r**2+176*Q2**13*r**2-369279*r**4+4247926*r**6-14274463*r**8+27526342*r**10
            +129617771*r**12-553885372*r**14+660388553*r**16-367966084*r**18+98308279*r**20
            -19691578*r**22-449*r**24-240954*r**26-803*r**28+Q2**12*(-771+3063*r**2
            +750*r**4)-164*Q2**11*(-33+128*r**2+1019*r**4+62*r**6)+Q2**10*(-15111
            -9033*r**2+1230491*r**4+1032041*r**6+31932*r**8)-5*Q2**9*(-3879-36553*r**2
            +548994*r**4+1328318*r**6+448293*r**8+7979*r**10)+3*Q2**8*(-1965-51364*r**2
            +421575*r**4+3601030*r**6+3697755*r**8+297990*r**10+691*r**12)+2*Q2**7*(
            -6534-250623*r**2+1616565*r**4+1573020*r**6+4328420*r**8+225321*r**10
            +1865997*r**12+23610*r**14)-6*Q2**6*(-2121-155674*r**2+639433*r**4+3196174*r**6
            +14532525*r**8+12173384*r**10+3212001*r**12+870548*r**14+6754*r**16)
            +2*Q2**5*(1341-77562*r**2-628581*r**4+4567029*r**6+42074003*r**8+109470491*r**10
            +33108893*r**12+7934379*r**14+18744*r**16-3777*r**18)+5*Q2**4*(-1809
            -150223*r**2+876924*r**4+169908*r**6+7909498*r**8-20693230*r**10-36952648*r**12
            +12121444*r**14+636303*r**16+858453*r**18+5444*r**20)-2*Q2**3*(-1560
            -259383*r**2+945675*r**4-2691330*r**6+34366420*r**8+42739050*r**10+22169566*r**12
            -21456000*r**14+54405220*r**16+4550445*r**18+1210935*r**20+4962*r**22)
            +Q2**2*(1689+97333*r**2-1232405*r**4-268865*r**6-2372290*r**8+41581502*r**10
            +204873794*r**12-9518230*r**14+80995985*r**16+10862285*r**18+3461779*r**20
            -676457*r**22-4520*r**24)+Q2*(-1413-196377*r**2+1385164*r**4-8497688*r**6
            +31338675*r**8-29081629*r**10+114936104*r**12-332908368*r**14+324732521*r**16
            -173777275*r**18+47143692*r**20-249752*r**22+980329*r**24+4017*r**26))*sqrtq2))/(
            -326592000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-2268000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+979776000*logq2**4*r**16*sqrtq2+40824000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2+47250*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(4147200*logq2**4*(-Q2+(-1+r)**2)*r**16*(-Q2+(1+r)**2)*(-9960*Q2**8*r**2
            +30*Q2**7*(119+2075*r**2+3552*r**4)-6*Q2**6*(4522+29645*r**2+86700*r**4
            +74753*r**6)+Q2**5*(49602+375592*r**2+991380*r**4+1587213*r**6+934563*r**8)
            -Q2**4*(10290+462861*r**2+1076840*r**4+1890825*r**6+2293104*r**8+870660*r**10)
            +Q2**3*(-37170+386099*r**2+258739*r**4+1022065*r**6+1585971*r**8+1608066*r**10
            -94710*r**12)+(-1+r**2)**2*(-11802+47293*r**2+251763*r**4-512490*r**6
            +929510*r**8+36597*r**10-117123*r**12+195252*r**14)+Q2**2*(9240-229516*r**2
            +534707*r**4-369186*r**6+484976*r**8-213492*r**10-875079*r**12+931350*r**14)
            -Q2*(-23982+14631*r**2+782021*r**4-958557*r**6+864075*r**8+2343847*r**10
            +448569*r**12-938481*r**14+743877*r**16))-5760*logq2**2*r**8*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(-614952*Q2**14*r**2+Q2**13*(-31598+6368298*r**2
            +6213408*r**4)-2*Q2**12*(-213024+13651135*r**2+27203230*r**4+12958047*r**6)
            +Q2**11*(-1823192+58402777*r**2+191998139*r**4+187476333*r**6+54855627*r**8)
            -2*Q2**10*(-1537011+26235535*r**2+162853154*r**4+259403557*r**6+162019515*r**8
            +25755462*r**10)+Q2**9*(-71750-27844171*r**2+200467541*r**4+640586124*r**6
            +705319974*r**8+271288955*r**10-16324041*r**12)+2*Q2**8*(-3542847+57184882*r**2
            +91413515*r**4-102670664*r**6-408963675*r**8-320243238*r**10-24339333*r**12
            +44608392*r**14)-2*Q2**7*(-4415712+47794340*r**2+196908147*r**4+158331844*r**6
            -330397461*r**8-707483972*r**10-271127031*r**12+63047280*r**14+36630621*r**16)
            -2*Q2**6*(34818+5740787*r**2-101057559*r**4-185764167*r**6+152252947*r**8
            +560839861*r**10+747365927*r**12-42221109*r**14-122838237*r**16+4531932*r**18)
            +2*Q2**5*(-4152477+39534685*r**2+34142771*r**4-147858706*r**6-99534790*r**8
            -979100864*r**10-904917038*r**12-355657854*r**14-678556101*r**16-172394805*r**18
            +25517979*r**20)+Q2**4*(6316100-52171552*r**2-118836666*r**4+316364706*r**6
            +510376336*r**8+3828026072*r**10+7743910316*r**12+5067074868*r**14+2700258076*r**16
            +1631701256*r**18+236079870*r**20-27040182*r**22)-Q2**3*(-154392+3489737*r**2
            -53622587*r**4+10293337*r**6+723554565*r**8+1817002226*r**10+4975812826*r**12
            +8605154370*r**14+1527686738*r**16+2053893685*r**18+410357521*r**20-40266443*r**22
            +3217617*r**24)+2*(-1+r**2)**2*(-103859+903707*r**2-793819*r**4-46522157*r**6
            +250551930*r**8-217587852*r**10-964022994*r**12+685678458*r**14+352317549*r**16
            -620538505*r**18+35370061*r**20-56500013*r**22-8610964*r**24+178458*r**26)
            +2*Q2**2*(-1226561+11328050*r**2-12604673*r**4-199540464*r**6+727820544*r**8
            -384489018*r**10-764686914*r**12+430690548*r**14+2759068311*r**16-2173202374*r**18
            +529545379*r**20-254521156*r**22-82643190*r**24+4141518*r**26)+Q2*(1245678
            -12125153*r**2+17855893*r**4+343926028*r**6-1703496378*r**8+1724141799*r**10
            +1651586721*r**12+1105796784*r**14+2337351954*r**16-5108313459*r**18
            +4632460823*r**20-749675068*r**22+385623098*r**24+94074093*r**26-3012813*r**28))
            -8*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-31504*Q2**18*r**2+Q2**17*(113337
            -453765*r**2-86266*r**4)+Q2**16*(-1135575+5098068*r**2+37864993*r**4
            +2786566*r**6)-Q2**15*(-4834683+8473865*r**2+385835065*r**4+351599501*r**6
            +15136608*r**8)+Q2**14*(-10879470-40167645*r**2+1474442252*r**4+3120332652*r**6
            +1359633678*r**8+39619805*r**10)-Q2**13*(-11931255-154615377*r**2+2466958172*r**4
            +9893291456*r**6+9883382079*r**8+2456684921*r**10+53026628*r**12)+Q2**12*(561834
            -74017085*r**2+643356980*r**4+11434203799*r**6+17276303850*r**8+12734848865*r**10
            +993703240*r**12+18910293*r**14)+Q2**11*(-19062225-473590869*r**2+4129208225*r**4
            +5926212573*r**6+27239648889*r**8+20649544509*r**10+2355421431*r**12
            +4029380907*r**14+47505392*r**16)-Q2**10*(-21567546-907503795*r**2+5832074576*r**4
            +26828454686*r**6+123169508472*r**8+207729385428*r**10+102425693160*r**12
            +25958080314*r**14+6996863210*r**16+67781351*r**18)+Q2**9*(-2837835-225602685*r**2
            +52325726*r**4+19148356066*r**6+114703292944*r**8+392245910280*r**10
            +388914594330*r**12+100305235646*r**14+27200737451*r**16+1892074309*r**18
            +9200840*r**20)+Q2**8*(-13873860-1066083117*r**2+7039756594*r**4+3969357057*r**6
            +66888690888*r**8-233263717458*r**10-501514585788*r**12-323085278526*r**14
            +34650728892*r**16-5646593457*r**18+6124136682*r**20+52010893*r**22)
            -Q2**7*(-10531521-1226623365*r**2+6165033367*r**4+7047207283*r**6+189386214270*r**8
            +75358377318*r**10-250667866650*r**12-457795691154*r**14-145087811277*r**16
            +116830143855*r**18+9148982931*r**20+6592216495*r**22+42721888*r**24)
            +Q2**6*(2006550-79986991*r**2-1274295764*r**4+4557375416*r**6+79366039902*r**8
            +153122488317*r**10-84597701304*r**12-387112534504*r**14-502754041230*r**16
            +54694554027*r**18+36666739052*r**20+11678571664*r**22+160771322*r**24
            -4850457*r**26)+Q2**5*(-6461091-740904645*r**2+5685933232*r**4-17917079940*r**6
            +95564818353*r**8-155749291481*r**10+88921986300*r**12+65834078160*r**14
            +203007787967*r**16+300837281961*r**18-411097168368*r**20+54124464820*r**22
            -13095460557*r**24+3775265013*r**26+24478276*r**28)+Q2**4*(2747430+494436705*r**2
            -3365535028*r**4+20835794657*r**6-123591879222*r**8+187177115165*r**10
            -68541434680*r**12+214290838941*r**14+766425944986*r**16+321263821699*r**18
            +16217312940*r**20+531780979715*r**22-40883349898*r**24+8921198847*r**26
            -2253378112*r**28-11478145*r**30)-Q2**3*(-619605-12281369*r**2+503506097*r**4
            +1251318301*r**6-22712613141*r**8+57268390871*r**10+10629595369*r**12
            +37628335701*r**14+1087259059513*r**16+660327807677*r**18+208234380923*r**20
            +181629371039*r**22+128736408577*r**24+7674211461*r**26-1387575061*r**28
            +164694511*r**30+1913136*r**32)+(-1+r**2)**2*(-41013-9691061*r**2+97563000*r**4
            -1387033562*r**6+8331203128*r**8-29251865618*r**10-7106057264*r**12+455610112758*r**14
            -1398852543026*r**16+1472558748444*r**18-546000517000*r**20-76111435614*r**22
            +73815175184*r**24-36897743662*r**26+784036928*r**28-533378494*r**30
            +39377439*r**32+169433*r**34)+Q2**2*(-953442-146949015*r**2+1532072728*r**4
            -11950767366*r**6+55160882220*r**8-137931293142*r**10+107730410400*r**12
            +104376860010*r**14-233127945808*r**16+568032742500*r**18-159196986120*r**20
            -327062107330*r**22+439755824676*r**24-224750357226*r**26+21024832080*r**28
            -6002736546*r**30+685276770*r**32+3674611*r**34)-2*Q2*(-165375-32655771*r**2
            +359270252*r**4-3918575185*r**6+22714318233*r**8-75544459557*r**10+65775411261*r**12
            +303258631707*r**14-541334707817*r**16-539622001991*r**18+1216783090089*r**20
            -484772497859*r**22-274715416445*r**24+226446259689*r**26-88874146617*r**28
            +5173081593*r**30-1664568756*r**32+140627486*r**34+665063*r**36))+2612736000*logq2**5*r**20*(115
            -245*r**2+179*r**4+211*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            +69120*logq2**3*r**12*(162360*Q2**13*r**2-2*Q2**12*(53543+709419*r**2+559488*r**4)
            +2*Q2**11*(562751+2925879*r**2+3221589*r**4+1188021*r**6)+Q2**10*(-4660061
            -15977996*r**2-13892586*r**4-978546*r**6+332529*r**8)-5*Q2**9*(-1901074
            -5933007*r**2-3357748*r**4+5352522*r**6+7872318*r**8+1176861*r**10)
            -5*Q2**8*(1644699+7091177*r**2+3311976*r**4-4427792*r**6-11282523*r**8
            -12309993*r**10+1583208*r**12)+2*Q2**7*(-1900794+14807893*r**2+12114951*r**4
            +71475750*r**6+153269740*r**8+123760641*r**10+26068023*r**12+28938996*r**14)
            -2*Q2**6*(-7998123+12815048*r**2+21041188*r**4+207684212*r**6+499323160*r**8
            +642929262*r**10+425039538*r**12+122386698*r**14+50726817*r**16)+2*Q2**5*(
            -7069734+8644696*r**2+26189841*r**4+259718871*r**6+572139061*r**8+937750971*r**10
            +913040891*r**12+468237021*r**14+143835381*r**16+36873801*r**18)+20*Q2**4*(99099
            +805297*r**2-3836007*r**4-17788940*r**6-20231517*r**8-48274569*r**10
            -63890244*r**12-58021508*r**14-7704582*r**16-7944048*r**18+338139*r**20)
            +(-1+r**2)**4*(-220871+2350995*r**2-10551190*r**4+11748330*r**6+43393940*r**8
            -1333148*r**10+39613730*r**12-41813210*r**14+49728195*r**16+3023385*r**18
            +2339844*r**20)-10*Q2**3*(-572047+5007280*r**2-14394448*r**4-8394463*r**6
            +26135502*r**8-4756700*r**10+23748636*r**12+4387022*r**14-66268887*r**16
            +61288964*r**18-5554356*r**20+5581497*r**22)-Q2*(-1+r**2)**2*(-1659602
            +16224583*r**2-62735330*r**4+53154285*r**6+176011980*r**8+86692254*r**10
            +229259084*r**12+218786930*r**14-238410010*r**16+285119595*r**18+7599798*r**20
            +16196433*r**22)+Q2**2*(-4836601+46174652*r**2-168975726*r**4+153946490*r**6
            +290883575*r**8-143073828*r**10+484441256*r**12+454298192*r**14+747419385*r**16
            -942201000*r**18+646005654*r**20-36387258*r**22+44785209*r**24))*sqrtq2
            +48*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(982416*Q2**17*r**2
            -4*Q2**16*(-144095+3370725*r**2+2997096*r**4)+4*Q2**15*(-1196615+16565121*r**2
            +38155187*r**4+14843379*r**6)-Q2**14*(-15430695+151940603*r**2+677987639*r**4
            +661940855*r**6+149148090*r**8)+2*Q2**13*(-9904965+68744871*r**2+648561662*r**4
            +939336548*r**6+660593099*r**8+85054905*r**10)+Q2**12*(-9942555+83609599*r**2
            -535157452*r**4+1332268840*r**6+875298891*r**8-736102599*r**10+47268252*r**12)
            -4*Q2**11*(-15900570+67485087*r**2+498112055*r**4+4028325206*r**6+7201820096*r**8
            +3462877751*r**10+475197379*r**12+97020372*r**14)+Q2**10*(-65813825+79718965*r**2
            +3114258755*r**4+29291972259*r**6+86647998855*r**8+83486990755*r**10
            +26085416549*r**12+3929483093*r**14+393308322*r**16)+2*Q2**9*(-9165695
            +131730003*r**2-313888786*r**4-5497580840*r**6-49248927700*r**8-84461368250*r**10
            -51548952422*r**12-6463729136*r**14-1003752085*r**16+39238815*r**18)
            +Q2**8*(93655485-220579209*r**2-1869356958*r**4-29006952522*r**6+11049945564*r**8
            +136743201460*r**10+173997625886*r**12+52592132202*r**14-17873753817*r**16
            -1905984651*r**18-469729920*r**20)+4*Q2**7*(-15781535-36200649*r**2+304741221*r**4
            +9632905895*r**6+18523875262*r**8-6180037018*r**10-43282426318*r**12
            -39573774614*r**14+1265912505*r**16+6451339867*r**18+747304017*r**20
            +76600887*r**22)+Q2**6*(-21019075+299578071*r**2-185827313*r**4-7449237137*r**6
            -62065202052*r**8-15941714002*r**10+112505561798*r**12+247869594326*r**14
            +108083098413*r**16-48348175477*r**18-5637007557*r**20-1037392373*r**22
            +101958378*r**24)-2*Q2**5*(-25692765+63003491*r**2-420964378*r**4+9011630348*r**6
            -5565733375*r**8-14120618605*r**10+4670423964*r**12-33704018792*r**14
            +53325019181*r**16-50338858975*r**18-49286149570*r**20+3841519100*r**22
            +264043055*r**24+117741321*r**26)+Q2**4*(-22159305-55835403*r**2-1000543264*r**4
            +14033788060*r**6+10482709115*r**8-73902387655*r**10-12736398924*r**12
            -482989636352*r**14-494269476915*r**16-107448020505*r**18-248511237920*r**20
            -90135580828*r**22+3513228161*r**24+549303275*r**26+95768460*r**28)+4*Q2**3*(
            -1428420+19920023*r**2-22050929*r**4-87967356*r**6-2738700178*r**8+12441918525*r**10
            -1857092991*r**12+87464484498*r**14+161318232832*r**16+77260821121*r**18
            +27160443905*r**20+33716593168*r**22+1947467606*r**24+216505899*r**26
            -48875793*r**28+6912090*r**30)+Q2**2*(8852445-34601169*r**2+677801093*r**4
            -4690612795*r**6+8141005911*r**8+46359610991*r**10-181865531923*r**12
            +145849915949*r**14+170410391305*r**16-686026705227*r**18+483463592183*r**20
            -144718206217*r**22+2190306133*r**24+42261384365*r**26+2602391*r**28
            +72939031*r**30-38744466*r**32)-(-1+r**2)**2*(-419755-308543*r**2-70229597*r**4
            +392510303*r**6-266703267*r**8-22681717567*r**10+138301598507*r**12-245620913481*r**14
            -91481616081*r**16+405169263259*r**18-284216939551*r**20+47628858965*r**22
            -12066080297*r**24-5634381597*r**26-212008367*r**28-4235627*r**30+1722696*r**32)
            +2*Q2*(-1610105+3470401*r**2-191719654*r**4+1348648768*r**6-2196389582*r**8
            -34225012612*r**10+185038216930*r**12-269612122520*r**14+60284876064*r**16
            -305765851186*r**18+595581064814*r**20-438273542288*r**22+87976284302*r**24
            -7623917332*r**26-13532325482*r**28-322248472*r**30-17821543*r**32+6799497*r**34))*sqrtq2)/(
            -29393280000*logq2**4*(-Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-408240000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-283500*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5+70543872000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+4898880000*logq2**3*(-Q2+(-1
            +r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+17010000*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +((66355200*logq2**4*(-Q2+(-1+r)**2)*r**16*(-Q2+(1+r)**2)*(240*Q2**8*r**2
            -30*Q2**7*(7+50*r**2+36*r**4)+6*Q2**6*(266+735*r**2+837*r**4+140*r**6)
            +Q2**5*(-4431-8071*r**2-9867*r**4-2727*r**6+3255*r**8)+Q2**4*(5145
            +8463*r**2+10265*r**4+3621*r**6-7935*r**8-5985*r**10)-Q2**3*(840+6167*r**2
            +3532*r**4+304*r**6-7221*r**8-10755*r**10+1995*r**12)+(-1+r**2)**2*(
            -819+3026*r**2-3897*r**4-222*r**6+6253*r**8-138*r**10-1083*r**12+3180*r**14)
            +Q2**2*(-3570+9163*r**2-7256*r**4-1146*r**6+823*r**8-1104*r**10-7515*r**12
            +12705*r**14)+Q2*(3129-11202*r**2+16166*r**4+1809*r**6-13731*r**8
            -16370*r**10-5184*r**12+11343*r**14-11160*r**16))+18432*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(57168*Q2**14*r**2-2*Q2**13*(-5845+310746*r**2
            +288516*r**4)+Q2**12*(-97440+2678738*r**2+5412962*r**4+2400408*r**6)
            -Q2**11*(-311885+5670277*r**2+19448798*r**4+18479733*r**6+5158527*r**8)
            +Q2**10*(-406035+5114903*r**2+31187308*r**4+45167948*r**6+30074793*r**8
            +5502303*r**10)-Q2**9*(109375-1914214*r**2+10624190*r**4+9327810*r**6
            +20463435*r**8+19768700*r**10+1003236*r**12)-Q2**8*(-982695+8517566*r**2
            +37413211*r**4+139668380*r**6+179830575*r**8+66020850*r**10+4925001*r**12
            +4182336*r**14)+2*Q2**7*(-504735+2896037*r**2+27332808*r**4+118015867*r**6
            +226287510*r**8+172280965*r**10+46978302*r**12+6607803*r**14+2237967*r**16)
            -2*Q2**6*(55335-1171277*r**2+9893187*r**4+53666742*r**6+165987353*r**8
            +217919090*r**10+107190853*r**12+23966922*r**14+4429332*r**16+832023*r**18)
            +4*Q2**5*(242655-1333589*r**2-3588274*r**4-17464864*r**6-28069744*r**8
            +11650261*r**10+33903421*r**12+15583626*r**14+16154511*r**16+3465906*r**18
            +83511*r**20)-2*Q2**4*(324625-1038809*r**2-7383795*r**4-38767680*r**6
            -134930980*r**8-117932660*r**10-19151192*r**12+47345910*r**14+53577395*r**16
            +47152645*r**18+7911075*r**20+107466*r**22)+Q2**3*(-51135+1071683*r**2
            -4782482*r**4-18535145*r**6-74648325*r**8-136988350*r**10+3426424*r**12
            +174209514*r**14-6842005*r**16+143071675*r**18+13564810*r**20+2726143*r**22
            -362007*r**24)+(-1+r**2)**2*(19915-39592*r**2+357464*r**4+6433228*r**6
            -38999325*r**8+134836920*r**10-60268716*r**12-61967028*r**14-45600531*r**16
            +115400300*r**18-20550860*r**20+14446408*r**22+1214789*r**24+77028*r**26)
            +Q2**2*(260785-1356937*r**2+2139322*r**4+14240208*r**6-115580595*r**8
            +212437305*r**10-174402996*r**12-23795904*r**14-258619341*r**16+368938745*r**18
            -147183590*r**20+69561008*r**22+7284207*r**24+717783*r**26)-Q2*(124215
            -531098*r**2+1644178*r**4+17850358*r**6-138931683*r**8+395815020*r**10
            -330097044*r**12+110698164*r**14+132314889*r**16-381610794*r**18+445838090*r**20
            -130719658*r**22+53480483*r**24+5162328*r**26+402552*r**28))-128*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-176*Q2**18-Q2**17*(2535+1676*r**2)
            +Q2**16*(32913+364661*r**2+31652*r**4)-Q2**15*(68917+3787700*r**2+3771553*r**4
            +177696*r**6)+Q2**14*(-186186+14930971*r**2+33942285*r**4+15925827*r**6
            +525835*r**8)-Q2**13*(-732732+26050717*r**2+105692368*r**4+111027624*r**6
            +32799280*r**8+907327*r**10)+Q2**12*(324509+9485791*r**2+95086832*r**4
            +107830116*r**6+132834703*r**8+25415813*r**10+849708*r**12)+Q2**11*(
            -4735695+35935918*r**2+174035451*r**4+860194842*r**6+730239207*r**8
            +78154746*r**10+25696893*r**12-186626*r**14)-Q2**10*(-7878420+51117673*r**2
            +455427703*r**4+2689270611*r**6+4581253617*r**8+2298868719*r**10+369632889*r**12
            +71295877*r**14+445027*r**16)+Q2**9*(-2284128+6347953*r**2+273545720*r**4
            +2278224806*r**6+7588991340*r**8+7470882852*r**10+2238303088*r**12+320261170*r**14
            +42657116*r**16+366355*r**18)+Q2**8*(-7905711+29243549*r**2+120166776*r**4
            +1776146298*r**6-1548013800*r**8-4035751620*r**10-3769240026*r**12+219460086*r**14
            -2011977*r**16+29382855*r**18+121682*r**20)-Q2**7*(-9312237+5292944*r**2
            +126690299*r**4+4437162732*r**6+7584211446*r**8+12328513824*r**10+7299356238*r**12
            +1118301864*r**14+1733839047*r**16+122705136*r**18+50863751*r**20+262988*r**22)
            +Q2**6*(-631274-24250639*r**2-17896433*r**4+1874113581*r**6+6883024941*r**8
            +15156693138*r**10+20234085838*r**12+7332891090*r**14+985613736*r**16
            +858975661*r**18+78073619*r**20+12183601*r**22+6021*r**24)+Q2**5*(-5624664
            +13151621*r**2-112252680*r**4+1821627060*r**6-1866941356*r**8+2250779013*r**10
            -7611706416*r**12-8755730960*r**14-1615778544*r**16-1282968081*r**18
            -175004776*r**20-126163332*r**22+18061908*r**24+163367*r**26)+Q2**4*(3753939
            +7632901*r**2+209951320*r**4-2113533408*r**6+1413307675*r**8-10066028003*r**10
            -6957706272*r**12+699243080*r**14+1370609321*r**16+3452772735*r**18+2930899984*r**20
            +412158616*r**22+139818345*r**24-12844193*r**26-90440*r**28)-Q2**3*(
            -105655+8863882*r**2+44640383*r**4-316660626*r**6+585467545*r**8-2566777246*r**10
            -5087246889*r**12+3816175574*r**14-720240173*r**16+2043625630*r**18+2367671797*r**20
            +1524887882*r**22+224304843*r**24+13040374*r**26+118325*r**28+13554*r**30)
            +2*(-1+r**2)**2*(-36857-161613*r**2-6810851*r**4+35146072*r**6-233476106*r**8
            -16624739*r**10+3287333199*r**12-13455588938*r**14+20748902706*r**16
            -14279266723*r**18+4617951579*r**20-955820164*r**22-34667986*r**24-29099053*r**26
            -4448071*r**28+74742*r**30+803*r**32)+Q2**2*(-1128336+2016029*r**2-92595333*r**4
            +654708291*r**6-2153606607*r**8+3252444525*r**10-1274435037*r**12+2290651051*r**14
            +7064801553*r**16-16654038801*r**18+12936995113*r**20-3971069823*r**22
            -275119893*r**24-186126969*r**26-72474567*r**28+3043473*r**30+31331*r**32)
            +Q2*(500931+431635*r**2+65255680*r**4-451471698*r**6+2224528152*r**8
            -3042024930*r**10-6513831000*r**12+23634794558*r**14+2182533326*r**16
            -57386238084*r**18+60936658352*r**20-24714711430*r**22+5251155984*r**24
            +197165922*r**26+182264232*r**28+46919322*r**30-1182905*r**32-12047*r**34))
            +41803776000*logq2**5*r**20*(-1+r**4+2*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2+1105920*logq2**3*r**12*(12240*Q2**13*r**2-2*Q2**12*(805+65346*r**2
            +58056*r**4)+2*Q2**11*(6685+309522*r**2+509229*r**4+233412*r**6)-Q2**10*(45010
            +1658977*r**2+3781563*r**4+3251763*r**6+1023657*r**8)+5*Q2**9*(14840
            +527967*r**2+1486895*r**4+1785987*r**6+1082181*r**8+265818*r**10)-5*Q2**8*(9240
            +457741*r**2+1493862*r**4+2234432*r**6+1988952*r**8+1010871*r**10+229734*r**12)
            +2*Q2**7*(-18690+237437*r**2+747282*r**4+1541385*r**6+2560700*r**8+2909985*r**10
            +1622772*r**12+528777*r**14)-4*Q2**6*(-21315-277423*r**2-1283996*r**4
            -1999003*r**6-1593305*r**8+172455*r**10+1141077*r**12+719649*r**14+326187*r**16)
            +2*Q2**5*(-23940-631588*r**2-2903952*r**4-4675197*r**6-4455058*r**8
            -773655*r**10+2621752*r**12+2520273*r**14+1522998*r**16+488367*r**18)
            +10*Q2**4*(-945+68164*r**2+143010*r**4+497731*r**6+175533*r**8-268233*r**10
            -524859*r**12-520271*r**14+133824*r**16-214263*r**18+25461*r**20)+(
            -1+r**2)**4*(140+9813*r**2-202046*r**4+926700*r**6-769394*r**8+310202*r**10
            -49598*r**12-371164*r**14+840390*r**16+4209*r**18+56748*r**20)-10*Q2**3*(
            -2345+30131*r**2-240131*r**4+627487*r**6-420684*r**8-379492*r**10+6024*r**12
            +12172*r**14-385635*r**16+990889*r**18-153453*r**20+116637*r**22)-Q2*(
            -1+r**2)**2*(-1120+56771*r**2-1198771*r**4+4441728*r**6-3092088*r**8
            +162606*r**10+2100178*r**12+730096*r**14-2025728*r**16+4692663*r**18
            -192711*r**20+374376*r**22)+Q2**2*(-10010+155293*r**2-2812977*r**4+9699175*r**6
            -10402295*r**8+3060690*r**10+2470954*r**12+5101414*r**14+5242620*r**16
            -10614735*r**18+10741815*r**20-1516077*r**22+980133*r**24))*sqrtq2+768*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(9312*Q2**17*r**2-4*Q2**16*(-805+31950*r**2
            +31368*r**4)+4*Q2**15*(-6685+161502*r**2+404131*r**4+169116*r**6)-Q2**14*(
            -86205+1568566*r**2+7173691*r**4+7409140*r**6+1895670*r**8)+2*Q2**13*(
            -55335+877182*r**2+6391588*r**4+7546174*r**6+7529917*r**8+1386990*r**10)
            -Q2**12*(55545+325312*r**2+892928*r**4-68024936*r**6-55484733*r**8+7582332*r**10
            +1205856*r**12)-4*Q2**11*(-88830+138939*r**2+7316008*r**4+90026929*r**6
            +162887050*r**8+76015549*r**10+6217412*r**12+641391*r**14)+Q2**10*(-367675
            -1123030*r**2+36823099*r**4+594075420*r**6+1792409349*r**8+1705822874*r**10
            +526212217*r**12+49659184*r**14+4273698*r**16)-2*Q2**9*(51205-825816*r**2
            +4872884*r**4+96431950*r**6+833807240*r**8+1312272220*r**10+895413124*r**12
            +152528314*r**14+14089355*r**16+642180*r**18)-Q2**8*(-523215-2287872*r**2
            -5690958*r**4+626144376*r**6+913254048*r**8+1261991140*r**10+202088558*r**12
            -313915968*r**14+199085991*r**16+14213508*r**18+2551560*r**20)+4*Q2**7*(
            -88165-1312728*r**2-7969281*r**4+197575162*r**6+740554886*r**8+1732027876*r**10
            +2057652454*r**12+790695704*r**14+170255247*r**16+87188276*r**18+6605931*r**20
            +630894*r**22)+Q2**6*(-117425+1964862*r**2+15376235*r**4-107758348*r**6
            -1798025460*r**8-5044647308*r**10-10384226762*r**12-8058157568*r**14
            -1879903593*r**16-424735010*r**18-152762433*r**20-12860644*r**22+69294*r**24)
            +2*Q2**5*(143535+1355918*r**2+18809060*r**4-209996206*r**6-78374599*r**8
            -662949094*r**10+177607368*r**12+2139634132*r**14+1113700217*r**16+581191826*r**18
            +260611316*r**20+44953946*r**22+2255135*r**24-650394*r**26)+Q2**4*(-123795
            -2844816*r**2-44458316*r**4+296284040*r**6+471841525*r**8+2272449820*r**10
            +6261334512*r**12+1755882032*r**14-1136786505*r**16-924153720*r**18-2563155940*r**20
            -818410136*r**22-118116281*r**24-2390900*r**26+629280*r**28)+4*Q2**3*(
            -7980+107941*r**2+1499054*r**4+2511507*r**6-55651184*r**8-21011415*r**10
            -810178302*r**12+57571407*r**14+221197076*r**16+46474703*r**18+579675250*r**20
            +243457961*r**22+84712264*r**24+3269667*r**26-455394*r**28+30645*r**30)
            +Q2**2*(49455+643662*r**2+15312277*r**4-103829084*r**6+285839973*r**8
            +52386658*r**10-2229257831*r**12+3134616736*r**14-1959850417*r**16-6026543886*r**18
            +9059347279*r**20-5204165324*r**22+1817549687*r**24+163304926*r**26+83714563*r**28
            +3897608*r**30-216282*r**32)-(-1+r**2)**2*(-2345-65626*r**2-1854889*r**4
            +5984320*r**6-47439045*r**8-275719454*r**10+1938692851*r**12-6012321852*r**14
            +4658322525*r**16+2971961450*r**18-4803909227*r**20+1599597976*r**22
            -516519559*r**24-47590770*r**26-13103455*r**28-362524*r**30+9624*r**32)
            +2*Q2*(-8995-183028*r**2-4702628*r**4+26616782*r**6-116212870*r**8
            -241815308*r**10+2486307572*r**12-6566587018*r**14+5601093876*r**16-4012394060*r**18
            +7740793636*r**20-8223996790*r**22+3180020950*r**24-857273108*r**26-69788020*r**28
            -29502158*r**30-1047329*r**32+38496*r**34))*sqrtq2)*math.log(mu0))/(-9797760000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -136080000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3-94500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5+23514624000*logq2**5*r**22*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2+1632960000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+5670000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +((172800*logq2**3*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(301-1584*r**2
            -240*Q2**6*r**2+5717*r**4-6176*r**6+8279*r**8-72*r**10-1017*r**12+1272*r**14
            +20*Q2**5*(7+51*r**2+72*r**4)-4*Q2**4*(196+445*r**2+1206*r**4+837*r**6)
            +Q2**3*(1001+2581*r**2+5141*r**4+8403*r**6+3162*r**8)+Q2**2*(91-2396*r**2
            -1418*r**4-5364*r**6-6801*r**8+432*r**10)+Q2*(-749+2609*r**2-3480*r**4
            -158*r**6+3027*r**8+2589*r**10-2718*r**12))+48*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2
            -(1+r)**2)**2*(-2345-4786*r**2-4656*Q2**12*r**2-227548*r**4+481994*r**6
            +1802615*r**8-49508100*r**10+129325752*r**12-64400404*r**14-24624243*r**16
            +36020510*r**18-7593180*r**20+2793034*r**22+119077*r**24+9624*r**26
            +4*Q2**11*(-805+12483*r**2+10068*r**4)-4*Q2**10*(-4270+40169*r**2+101692*r**4
            +31629*r**6)+5*Q2**9*(-5705+35759*r**2+230039*r**4+218089*r**6+30234*r**8)
            +5*Q2**8*(-525+8796*r**2-146250*r**4-109268*r**6-153705*r**8+11736*r**10)
            -4*Q2**7*(-15225+43362*r**2+391830*r**4+2489570*r**6+2227745*r**8+377580*r**10
            +82962*r**12)+2*Q2**6*(-27930-43407*r**2+1131663*r**4+11081830*r**6
            +22772900*r**8+9808525*r**10+1462503*r**12+123228*r**14)+2*Q2**5*(-9555
            +140781*r**2-32367*r**4-4813089*r**6-29472945*r**8-31808175*r**10-3300179*r**12
            -377517*r**14+60246*r**16)-10*Q2**4*(-5565+7257*r**2+73677*r**4+1239897*r**6
            +13677*r**8-4040437*r**10-1987573*r**12+2016227*r**14+189432*r**16+25632*r**18)
            +20*Q2**3*(-1050-6669*r**2-15750*r**4+487512*r**6+1874250*r**8+2580692*r**10
            +822492*r**12+1358960*r**14+999352*r**16+75105*r**18+4146*r**20)+2*Q2**2*(
            -5950+43977*r**2+67185*r**4+926990*r**6-6384960*r**8-19560330*r**10
            -42812974*r**12+391620*r**14-15779010*r**16+594465*r**18+36285*r**20
            +28302*r**22)-Q2*(-10955+5893*r**2-461227*r**4+2684035*r**6+5334100*r**8
            -7411850*r**10+19731094*r**12-69809126*r**14+49679065*r**16-20660475*r**18
            +8352405*r**20+424163*r**22+46878*r**24))+72576000*logq2**4*r**14*(3-5*r**2
            +3*r**4+3*r**6)*sqrtq2+2880*logq2**2*r**6*(-4320*Q2**11*r**2+8*Q2**10*(-7
            +5007*r**2+4986*r**4)-40*Q2**9*(-49+3857*r**2+7613*r**4+3759*r**6)
            +5*Q2**8*(-1785+59477*r**2+182793*r**4+184359*r**6+55980*r**8)-20*Q2**7*(
            -693+13253*r**2+62918*r**4+96754*r**6+66735*r**8+10305*r**10)-10*Q2**6*r**2*(203
            -53651*r**2-117893*r**4-127639*r**6-74214*r**8+14490*r**10)+2*Q2**5*(
            -12054+112469*r**2+304767*r**4+680760*r**6+961880*r**8+607101*r**10
            +176799*r**12+206262*r**14)-10*Q2**4*(-2499+18097*r**2+84256*r**4+244614*r**6
            +424315*r**8+462877*r**10+217370*r**12+75348*r**14+27414*r**16)-20*Q2**3*(105
            -212*r**2-14014*r**4-73778*r**6-81299*r**8-182225*r**10-173800*r**12
            -14564*r**14-25104*r**16+1755*r**18)+(-1+r**2)**2*(-1561+9259*r**2
            +17902*r**4-417650*r**6+974908*r**8-198572*r**10+237346*r**12-321422*r**14
            +301405*r**16-10303*r**18+13488*r**20)+10*Q2**2*(-1176+8281*r**2+7383*r**4
            -111243*r**6+173905*r**8-7005*r**10-34557*r**12-191033*r**14+148275*r**16
            -27480*r**18+14490*r**20)-10*Q2*(-770+5515*r**2+4639*r**4-115040*r**6
            +228502*r**8-24740*r**10+66736*r**12+144310*r**14-185396*r**16+125097*r**18
            -14511*r**20+7578*r**22))*sqrtq2-8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(279
            +51832*r**2+176*Q2**13*r**2-369279*r**4+4247926*r**6-14274463*r**8+27526342*r**10
            +129617771*r**12-553885372*r**14+660388553*r**16-367966084*r**18+98308279*r**20
            -19691578*r**22-449*r**24-240954*r**26-803*r**28+Q2**12*(-771+3063*r**2
            +750*r**4)-164*Q2**11*(-33+128*r**2+1019*r**4+62*r**6)+Q2**10*(-15111
            -9033*r**2+1230491*r**4+1032041*r**6+31932*r**8)-5*Q2**9*(-3879-36553*r**2
            +548994*r**4+1328318*r**6+448293*r**8+7979*r**10)+3*Q2**8*(-1965-51364*r**2
            +421575*r**4+3601030*r**6+3697755*r**8+297990*r**10+691*r**12)+2*Q2**7*(
            -6534-250623*r**2+1616565*r**4+1573020*r**6+4328420*r**8+225321*r**10
            +1865997*r**12+23610*r**14)-6*Q2**6*(-2121-155674*r**2+639433*r**4+3196174*r**6
            +14532525*r**8+12173384*r**10+3212001*r**12+870548*r**14+6754*r**16)
            +2*Q2**5*(1341-77562*r**2-628581*r**4+4567029*r**6+42074003*r**8+109470491*r**10
            +33108893*r**12+7934379*r**14+18744*r**16-3777*r**18)+5*Q2**4*(-1809
            -150223*r**2+876924*r**4+169908*r**6+7909498*r**8-20693230*r**10-36952648*r**12
            +12121444*r**14+636303*r**16+858453*r**18+5444*r**20)-2*Q2**3*(-1560
            -259383*r**2+945675*r**4-2691330*r**6+34366420*r**8+42739050*r**10+22169566*r**12
            -21456000*r**14+54405220*r**16+4550445*r**18+1210935*r**20+4962*r**22)
            +Q2**2*(1689+97333*r**2-1232405*r**4-268865*r**6-2372290*r**8+41581502*r**10
            +204873794*r**12-9518230*r**14+80995985*r**16+10862285*r**18+3461779*r**20
            -676457*r**22-4520*r**24)+Q2*(-1413-196377*r**2+1385164*r**4-8497688*r**6
            +31338675*r**8-29081629*r**10+114936104*r**12-332908368*r**14+324732521*r**16
            -173777275*r**18+47143692*r**20-249752*r**22+980329*r**24+4017*r**26))*sqrtq2)*math.log(mus))/(
            -39191040*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-272160*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+117573120*logq2**4*r**16*sqrtq2+4898880*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2+5670*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +((-172800*logq2**3*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(301-1584*r**2
            -240*Q2**6*r**2+5717*r**4-6176*r**6+8279*r**8-72*r**10-1017*r**12+1272*r**14
            +20*Q2**5*(7+51*r**2+72*r**4)-4*Q2**4*(196+445*r**2+1206*r**4+837*r**6)
            +Q2**3*(1001+2581*r**2+5141*r**4+8403*r**6+3162*r**8)+Q2**2*(91-2396*r**2
            -1418*r**4-5364*r**6-6801*r**8+432*r**10)+Q2*(-749+2609*r**2-3480*r**4
            -158*r**6+3027*r**8+2589*r**10-2718*r**12))-48*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2
            -(1+r)**2)**2*(-2345-4786*r**2-4656*Q2**12*r**2-227548*r**4+481994*r**6
            +1802615*r**8-49508100*r**10+129325752*r**12-64400404*r**14-24624243*r**16
            +36020510*r**18-7593180*r**20+2793034*r**22+119077*r**24+9624*r**26
            +4*Q2**11*(-805+12483*r**2+10068*r**4)-4*Q2**10*(-4270+40169*r**2+101692*r**4
            +31629*r**6)+5*Q2**9*(-5705+35759*r**2+230039*r**4+218089*r**6+30234*r**8)
            +5*Q2**8*(-525+8796*r**2-146250*r**4-109268*r**6-153705*r**8+11736*r**10)
            -4*Q2**7*(-15225+43362*r**2+391830*r**4+2489570*r**6+2227745*r**8+377580*r**10
            +82962*r**12)+2*Q2**6*(-27930-43407*r**2+1131663*r**4+11081830*r**6
            +22772900*r**8+9808525*r**10+1462503*r**12+123228*r**14)+2*Q2**5*(-9555
            +140781*r**2-32367*r**4-4813089*r**6-29472945*r**8-31808175*r**10-3300179*r**12
            -377517*r**14+60246*r**16)-10*Q2**4*(-5565+7257*r**2+73677*r**4+1239897*r**6
            +13677*r**8-4040437*r**10-1987573*r**12+2016227*r**14+189432*r**16+25632*r**18)
            +20*Q2**3*(-1050-6669*r**2-15750*r**4+487512*r**6+1874250*r**8+2580692*r**10
            +822492*r**12+1358960*r**14+999352*r**16+75105*r**18+4146*r**20)+2*Q2**2*(
            -5950+43977*r**2+67185*r**4+926990*r**6-6384960*r**8-19560330*r**10
            -42812974*r**12+391620*r**14-15779010*r**16+594465*r**18+36285*r**20
            +28302*r**22)-Q2*(-10955+5893*r**2-461227*r**4+2684035*r**6+5334100*r**8
            -7411850*r**10+19731094*r**12-69809126*r**14+49679065*r**16-20660475*r**18
            +8352405*r**20+424163*r**22+46878*r**24))-72576000*logq2**4*r**14*(3-5*r**2
            +3*r**4+3*r**6)*sqrtq2+2880*logq2**2*r**6*(4320*Q2**11*r**2-8*Q2**10*(-7
            +5007*r**2+4986*r**4)+40*Q2**9*(-49+3857*r**2+7613*r**4+3759*r**6)
            -5*Q2**8*(-1785+59477*r**2+182793*r**4+184359*r**6+55980*r**8)+20*Q2**7*(
            -693+13253*r**2+62918*r**4+96754*r**6+66735*r**8+10305*r**10)+10*Q2**6*r**2*(203
            -53651*r**2-117893*r**4-127639*r**6-74214*r**8+14490*r**10)-2*Q2**5*(
            -12054+112469*r**2+304767*r**4+680760*r**6+961880*r**8+607101*r**10
            +176799*r**12+206262*r**14)+10*Q2**4*(-2499+18097*r**2+84256*r**4+244614*r**6
            +424315*r**8+462877*r**10+217370*r**12+75348*r**14+27414*r**16)+20*Q2**3*(105
            -212*r**2-14014*r**4-73778*r**6-81299*r**8-182225*r**10-173800*r**12
            -14564*r**14-25104*r**16+1755*r**18)-(-1+r**2)**2*(-1561+9259*r**2
            +17902*r**4-417650*r**6+974908*r**8-198572*r**10+237346*r**12-321422*r**14
            +301405*r**16-10303*r**18+13488*r**20)-10*Q2**2*(-1176+8281*r**2+7383*r**4
            -111243*r**6+173905*r**8-7005*r**10-34557*r**12-191033*r**14+148275*r**16
            -27480*r**18+14490*r**20)+10*Q2*(-770+5515*r**2+4639*r**4-115040*r**6
            +228502*r**8-24740*r**10+66736*r**12+144310*r**14-185396*r**16+125097*r**18
            -14511*r**20+7578*r**22))*sqrtq2+8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(279
            +51832*r**2+176*Q2**13*r**2-369279*r**4+4247926*r**6-14274463*r**8+27526342*r**10
            +129617771*r**12-553885372*r**14+660388553*r**16-367966084*r**18+98308279*r**20
            -19691578*r**22-449*r**24-240954*r**26-803*r**28+Q2**12*(-771+3063*r**2
            +750*r**4)-164*Q2**11*(-33+128*r**2+1019*r**4+62*r**6)+Q2**10*(-15111
            -9033*r**2+1230491*r**4+1032041*r**6+31932*r**8)-5*Q2**9*(-3879-36553*r**2
            +548994*r**4+1328318*r**6+448293*r**8+7979*r**10)+3*Q2**8*(-1965-51364*r**2
            +421575*r**4+3601030*r**6+3697755*r**8+297990*r**10+691*r**12)+2*Q2**7*(
            -6534-250623*r**2+1616565*r**4+1573020*r**6+4328420*r**8+225321*r**10
            +1865997*r**12+23610*r**14)-6*Q2**6*(-2121-155674*r**2+639433*r**4+3196174*r**6
            +14532525*r**8+12173384*r**10+3212001*r**12+870548*r**14+6754*r**16)
            +2*Q2**5*(1341-77562*r**2-628581*r**4+4567029*r**6+42074003*r**8+109470491*r**10
            +33108893*r**12+7934379*r**14+18744*r**16-3777*r**18)+5*Q2**4*(-1809
            -150223*r**2+876924*r**4+169908*r**6+7909498*r**8-20693230*r**10-36952648*r**12
            +12121444*r**14+636303*r**16+858453*r**18+5444*r**20)-2*Q2**3*(-1560
            -259383*r**2+945675*r**4-2691330*r**6+34366420*r**8+42739050*r**10+22169566*r**12
            -21456000*r**14+54405220*r**16+4550445*r**18+1210935*r**20+4962*r**22)
            +Q2**2*(1689+97333*r**2-1232405*r**4-268865*r**6-2372290*r**8+41581502*r**10
            +204873794*r**12-9518230*r**14+80995985*r**16+10862285*r**18+3461779*r**20
            -676457*r**22-4520*r**24)+Q2*(-1413-196377*r**2+1385164*r**4-8497688*r**6
            +31338675*r**8-29081629*r**10+114936104*r**12-332908368*r**14+324732521*r**16
            -173777275*r**18+47143692*r**20-249752*r**22+980329*r**24+4017*r**26))*sqrtq2)*math.log(2*muWC))/(
            -36288000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-252000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+108864000*logq2**4*r**16*sqrtq2+4536000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2+5250*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +((-16588800*logq2**4*(-Q2+(-1+r)**2)*r**16*(-Q2+(1+r)**2)*(3000*Q2**8*r**2
            -10*Q2**7*(259+1875*r**2+1392*r**4)+2*Q2**6*(9842+27545*r**2+32448*r**4
            +6657*r**6)+Q2**5*(-54474-101164*r**2-127296*r**4-44115*r**6+33411*r**8)
            +Q2**4*(62930+106547*r**2+132740*r**4+57103*r**6-81348*r**8-67200*r**10)
            -Q2**3*(10010+77973*r**2+44913*r**4+10667*r**6-77435*r**8-120462*r**10
            +23730*r**12)+(-1+r**2)**2*(-9926+36649*r**2-49325*r**4+774*r**6+70074*r**8
            -1935*r**10-12435*r**12+37524*r**14)+Q2**2*(-43680+113512*r**2-92289*r**4
            -11490*r**6+6756*r**8-12036*r**10-85863*r**12+148890*r**14)+Q2*(38066
            -136763*r**2+202831*r**4+15581*r**6-161883*r**8-184059*r**10-60285*r**12
            +132201*r**14-131289*r**16))-4608*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(677544*Q2**14*r**2-6*Q2**13*(-23625+1229431*r**2+1139776*r**4)
            +6*Q2**12*(-196000+5299889*r**2+10713886*r**4+4740989*r**6)-Q2**11*(
            -3748500+67291181*r**2+231088779*r**4+219402849*r**6+61159431*r**8)
            +Q2**10*(-4856250+60707554*r**2+369958324*r**4+534201354*r**6+356422674*r**8
            +65473344*r**10)-Q2**9*(1338750-22440187*r**2+122984405*r**4+92175620*r**6
            +226025370*r**8+232300275*r**10+12812463*r**12)-2*Q2**8*(-5882625+50087414*r**2
            +225442149*r**4+856704480*r**6+1112467175*r**8+414203670*r**10+30913929*r**12
            +24031944*r**14)+2*Q2**7*(-6016500+33757216*r**2+327246139*r**4+1436495496*r**6
            +2775947995*r**8+2128939000*r**10+583188201*r**12+78587604*r**14+26096841*r**16)
            -2*Q2**6*(677250-14115031*r**2+117434531*r**4+649364951*r**6+2033160209*r**8
            +2681543435*r**10+1335044909*r**12+291384261*r**14+49938021*r**16+10319544*r**18)
            +2*Q2**5*(5788125-31242029*r**2-86519499*r**4-431789694*r**6-689280234*r**8
            +251375736*r**10+797663286*r**12+368694526*r**14+371661381*r**16+78826941*r**18
            +2908581*r**20)-2*Q2**4*(3858750-11804572*r**2-88191865*r**4-479031735*r**6
            -1657224360*r**8-1505966820*r**10-365682426*r**12+492282770*r**14+608669090*r**16
            +548346240*r**18+92640075*r**20+1772853*r**22)-Q2**3*(619500-12974789*r**2
            +56606971*r**4+226806715*r**6+936640575*r**8+1735483590*r**10+127382358*r**12
            -1835745002*r**14+135555610*r**16-1678144625*r**18-151772865*r**20-34676769*r**22
            +4532331*r**24)+2*(-1+r**2)**2*(118125-211123*r**2+2156691*r**4+37717197*r**6
            -229718600*r**8+816296700*r**10-400962054*r**12-355224482*r**14-266582919*r**16
            +683855625*r**18-124338925*r**20+86329077*r**22+7128066*r**24+476622*r**26)
            +2*Q2**2*(1551375-7904008*r**2+12640053*r**4+80204112*r**6-681307970*r**8
            +1284668400*r**10-1091410374*r**12-130716116*r**14-1486019229*r**16+2179870620*r**18
            -881109775*r**20+416280132*r**22+41687088*r**24+4525692*r**26)-Q2*(1475250
            -6076369*r**2+19480709*r**4+206391924*r**6-1639481774*r**8+4777299775*r**10
            -4089198807*r**12+1314863392*r**14+1537080142*r**16-4488649107*r**18
            +5289543575*r**20-1571592724*r**22+640291374*r**24+59871909*r**26+5020731*r**28))
            +32*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-1936*Q2**18*r**2-3*Q2**17*(257
            +9295*r**2+6630*r**4)+Q2**16*(7725+367440*r**2+4197729*r**4+367758*r**6)
            -Q2**15*(32889+784361*r**2+43652205*r**4+43687821*r**6+2068064*r**8)
            +3*Q2**14*(24670-667171*r**2+57463904*r**4+131156488*r**6+61775854*r**8
            +2051655*r**10)-3*Q2**13*(27055-2633495*r**2+100499160*r**4+408004992*r**6
            +429755625*r**8+128006399*r**10+3574904*r**12)+Q2**12*(-3822+4468267*r**2
            +111517848*r**4+1083957459*r**6+1199908738*r**8+1536301209*r**10+303762564*r**12
            +10252825*r**14)+3*Q2**11*(43225-18212511*r**2+136987983*r**4+695332103*r**6
            +3441429223*r**8+2927120343*r**10+312948985*r**12+95515281*r**14-867768*r**16)
            -3*Q2**10*(48906-30027525*r**2+194955252*r**4+1793922222*r**6+10672926324*r**8
            +18186399344*r**10+9130028404*r**12+1446491130*r**14+274491002*r**16
            +1658701*r**18)+Q2**9*(19305-26372049*r**2+77201346*r**4+3211835082*r**6
            +27054343256*r**8+90051581880*r**10+88631231346*r**12+26664538166*r**14
            +3727811727*r**16+508300041*r**18+4413420*r**20)+3*Q2**8*(31460-29779079*r**2
            +103133010*r**4+480385879*r**6+7081791520*r**8-5775440062*r**10-15298628852*r**12
            -14617845370*r**14+815191804*r**16+4610165*r**18+105776578*r**20+377619*r**22)
            -3*Q2**7*(23881-35143207*r**2+7576177*r**4+499974081*r**6+17641174722*r**8
            +30716293378*r**10+50777049194*r**12+30765168922*r**14+4883351381*r**16
            +6796246677*r**18+478978325*r**20+192197461*r**22+974160*r**24)+Q2**6*(
            -13650-7168579*r**2-287618040*r**4-249655572*r**6+22357428242*r**8+83052995277*r**10
            +185755228416*r**12+249847147616*r**14+93011064210*r**16+11669848407*r**18
            +10245262232*r**20+874432980*r**22+147761742*r**24+106559*r**26)+3*Q2**5*(14651
            -21226739*r**2+40667524*r**4-416527740*r**6+7201989527*r**8-7250062095*r**10
            +8964800728*r**12-31148432656*r**14-36118595447*r**16-7262529585*r**18
            -4292774388*r**20-835449076*r**22-484113115*r**24+64997555*r**26+609816*r**28)
            -3*Q2**4*(6230-14166979*r**2-38717064*r**4-807793143*r**6+8327242906*r**8
            -5331345735*r**10+40839103988*r**12+28821612933*r**14-1109783734*r**16
            -4853402537*r**18-14024858320*r**20-10730420389*r**22-1771247674*r**24
            -549189453*r**26+47199076*r**28+342295*r**30)-Q2**3*(4215-1207313*r**2
            +104870925*r**4+536889861*r**6-3714352865*r**8+6763478367*r**10-31432391355*r**12
            -62410365635*r**14+39228518853*r**16-13291694955*r**18+23551818031*r**20
            +27691899159*r**22+17754845085*r**24+2688280861*r**26+168762495*r**28
            +325287*r**30+152584*r**32)+(-1+r**2)**2*(279-834689*r**2-4612768*r**4
            -156990090*r**6+802132568*r**8-5506083722*r**10-357891192*r**12+77227828150*r**14
            -319276346410*r**16+496989794364*r**18-345204935728*r**20+113359139506*r**22
            -23857967376*r**24-596120150*r**26-716379832*r**28-105061854*r**30+1558475*r**32
            +18469*r**34)+3*Q2**2*(2162-4262001*r**2+4736316*r**4-350001022*r**6
            +2541258976*r**8-8457927830*r**10+13001496500*r**12-5426898382*r**14
            +9857454044*r**16+27483788768*r**18-67463620636*r**20+53428356758*r**22
            -17169608224*r**24-610804922*r**26-805689044*r**28-281545546*r**30+10840818*r**32
            +119265*r**34)-6*Q2*(375-945987*r**2-1693602*r**4-123993255*r**6+867816931*r**8
            -4358462179*r**10+6045267519*r**12+12576330173*r**14-46899570987*r**16
            -3220618877*r**18+114095371223*r**20-122984913157*r**22+50949039185*r**24
            -11206313681*r**26-199956579*r**28-382871569*r**30-91766400*r**32+2089844*r**34
            +23023*r**36))-3483648000*logq2**5*r**20*(-39+5*r**2+33*r**4+69*r**6)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-276480*logq2**3*r**12*(148440*Q2**13*r**2
            -6*Q2**12*(3157+264517*r**2+235168*r**4)+2*Q2**11*(77847+3761739*r**2
            +6199685*r**4+2843673*r**6)-Q2**10*(518217+20160168*r**2+46107446*r**4
            +39722366*r**6+12508983*r**8)+5*Q2**9*(168378+6410175*r**2+18143576*r**4
            +21857042*r**6+13275302*r**8+3255687*r**10)-15*Q2**8*(33901+1848099*r**2
            +6076336*r**4+9109904*r**6+8125715*r**8+4144749*r**10+932016*r**12)
            +6*Q2**7*(-71806+933399*r**2+3015881*r**4+6115310*r**6+10081060*r**8
            +11570459*r**10+6549729*r**12+2087856*r**14)-6*Q2**6*(-155477-2288704*r**2
            -10506020*r**4-16753068*r**6-14109920*r**8-53222*r**10+8330406*r**12
            +5584110*r**14+2541807*r**16)+2*Q2**5*(-244398-7775352*r**2-35657739*r**4
            -58886889*r**6-58322607*r**8-15831533*r**10+25820583*r**12+27606621*r**14
            +17629041*r**16+5715873*r**18)+20*Q2**4*(-6447+410925*r**2+899721*r**4
            +3161574*r**6+1209933*r**8-1310195*r**10-2771654*r**12-2783550*r**14
            +869922*r**16-1254858*r**18+153237*r**20)+(-1+r**2)**4*(3213+103899*r**2
            -2396758*r**4+11242210*r**6-9695412*r**8+3799020*r**10-875454*r**12
            -4250322*r**14+9929335*r**16+30857*r**18+677412*r**20)-10*Q2**3*(-24759
            +334068*r**2-2835924*r**4+7723545*r**6-5317578*r**8-4604156*r**10-87956*r**12
            +118870*r**14-4260759*r**16+11689440*r**18-1837056*r**20+1387065*r**22)
            -Q2*(-1+r**2)**2*(-2394+583239*r**2-14219438*r**4+53906049*r**6-38975524*r**8
            +1396926*r**10+24099732*r**12+7431738*r**14-23127874*r**16+55393899*r**18
            -2406182*r**20+4463829*r**22)+Q2**2*(-89397+1583208*r**2-33218578*r**4
            +117454230*r**6-129070785*r**8+38367844*r**10+26893824*r**12+59237016*r**14
            +58968205*r**16-123277980*r**18+126845538*r**20-18275422*r**22+11670297*r**24))*sqrtq2
            -192*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(107088*Q2**17*r**2
            -4*Q2**16*(-8855+367425*r**2+362856*r**4)+4*Q2**15*(-73535+1860493*r**2
            +4677987*r**4+1965231*r**6)-Q2**14*(-948255+18130639*r**2+83033751*r**4
            +86019555*r**6+22146090*r**8)+2*Q2**13*(-608685+10249483*r**2+73678438*r**4
            +85806748*r**6+87504339*r**8+16367205*r**10)-Q2**12*(610995+4543333*r**2
            +7268988*r**4-822044328*r**6-671940691*r**8+87631059*r**10+15054324*r**12)
            -4*Q2**11*(-977130+1238431*r**2+85996179*r**4+1072517274*r**6+1941111032*r**8
            +905177199*r**10+72729759*r**12+7176312*r**14)+Q2**10*(-4044425-14263135*r**2
            +428707667*r**4+7058962463*r**6+21309654367*r**8+20273271367*r**10+6251644389*r**12
            +579989193*r**14+49539138*r**16)-2*Q2**9*(563255-9193439*r**2+57400074*r**4
            +1140776880*r**6+9852169220*r**8+15458364210*r**10+10589204206*r**12
            +1819572264*r**14+165311085*r**16+8112885*r**18)-Q2**8*(-5755365-29453043*r**2
            -82247058*r**4+7452709842*r**6+11233021876*r**8+16348838700*r**10+3652712082*r**12
            -3477557458*r**14+2310780177*r**16+160690311*r**18+27978720*r**20)+4*Q2**7*(
            -969815-15792237*r**2-99439251*r**4+2348381531*r**6+8921855102*r**8
            +21203415662*r**10+25434192066*r**12+9929682034*r**14+2071513681*r**16
            +1021352407*r**18+75625497*r**20+7186971*r**22)+Q2**6*(-1291675+21968123*r**2
            +189126159*r**4-1265882693*r**6-21545500164*r**8-61525475178*r**10-127636577050*r**12
            -100138235282*r**14-23703333003*r**16-4860380289*r**18-1828056613*r**20
            -150070233*r**22+153018*r**24)+2*Q2**5*(1578885+16994777*r**2+226939506*r**4
            -2504364324*r**6-995418457*r**8-8195763207*r**10+2201722836*r**12+25912101240*r**14
            +13969595979*r**16+6758378643*r**18+2848787578*r**20+575366028*r**22
            +29348745*r**24-7145349*r**26)+Q2**4*(-1361745-34377239*r**2-536371376*r**4
            +3524437740*r**6+5693501155*r**8+28266818125*r**10+76585667908*r**12
            +24738460992*r**14-10526524395*r**16-10560082045*r**18-29625284560*r**20
            -9385911724*r**22-1467007271*r**24-32948025*r**26+7036860*r**28)+4*Q2**3*(
            -87780+1183279*r**2+18464979*r**4+31283224*r**6-661298138*r**8-341349795*r**10
            -9885871683*r**12+108392942*r**14+1605113712*r**16+42229561*r**18+6897525885*r**20
            +2745128604*r**22+1021739854*r**24+38474939*r**26-5231373*r**28+327390*r**30)
            +Q2**2*(544005+8099443*r**2+182469717*r**4-1236642327*r**6+3436922351*r**8
            +324672291*r**10-25999194099*r**12+37305590081*r**14-25104093471*r**16
            -68963579007*r**18+107395402183*r**20-62598385821*r**22+22191353277*r**24
            +1707716073*r**26+1022780631*r**28+47123571*r**30-2378898*r**32)-(-1
            +r**2)**2*(-25795-799699*r**2-22184701*r**4+70444411*r**6-577781099*r**8
            -3214356611*r**10+22745515387*r**12-71785776413*r**14+57536250823*r**16
            +33554241503*r**18-56759211103*r**20+19219381673*r**22-6228592161*r**24
            -543120009*r**26-158651679*r**28-4400391*r**30+105864*r**32)+2*Q2*(
            -98945-2259787*r**2-56151022*r**4+316021032*r**6-1404911054*r**8-2721600548*r**10
            +29118164506*r**12-78394409264*r**14+68022311056*r**16-46942135242*r**18
            +90523022486*r**20-97496766616*r**22+38254022734*r**24-10422031188*r**26
            -760591554*r**28-358255968*r**30-12674703*r**32+424077*r**34))*sqrtq2)*math.log(r))/(
            -29393280000*logq2**4*(-Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-408240000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-283500*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5+70543872000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+4898880000*logq2**3*(-Q2+(-1
            +r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+17010000*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2))
            +muWC**3*((pi2*(86400*logq2**3*r**8*(-240*Q2**8*(1+5*r**4)+20*Q2**7*(117
            +166*r**2+501*r**4+480*r**6)-4*Q2**6*(2415+5900*r**2+10136*r**4+14688*r**6
            +8085*r**8)+Q2**5*(19425+64530*r**2+93454*r**4+122436*r**6+133377*r**8
            +56490*r**10)-Q2**4*(17325+75505*r**2+111190*r**4+115462*r**6+146261*r**8
            +133785*r**10+46200*r**12)+Q2**3*(-210+29530*r**2+62170*r**4+36808*r**6
            +70082*r**8+98834*r**10+33270*r**12-2100*r**14)+(-1+r**2)**2*(2175
            +355*r**2-4569*r**4+39419*r**6+18349*r**8+115649*r**10-35691*r**12
            +5793*r**14+6360*r**16)+2*Q2**2*(6405+1710*r**2-17795*r**4+18194*r**6
            +29*r**8+40550*r**10-56313*r**12+14010*r**14+17850*r**16)-Q2*(9315
            -2300*r**2-25984*r**4+128230*r**6+56718*r**8+228638*r**10+286248*r**12
            -121038*r**14+5223*r**16+26310*r**18))-24*logq2*(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(4656*Q2**14*(1+5*r**4)-4*Q2**13*(9981+4346*r**2+38205*r**4
            +61980*r**6)+4*Q2**12*(35289+31746*r**2-3186*r**4+392890*r**6+264645*r**8)
            -Q2**11*(246759+384626*r**2-2256934*r**4+587244*r**6+5876815*r**8+2222370*r**10)
            +Q2**10*(155661+594681*r**2-8831714*r**4-13613034*r**6-7003739*r**8
            +8957825*r**10+1850880*r**12)+Q2**9*(185163-401150*r**2+21101265*r**4
            +55561850*r**6+91934525*r**8+68897718*r**10+939175*r**12+1490190*r**14)
            -Q2**8*(427977+170877*r**2+34467885*r**4+141383925*r**6+309486275*r**8
            +391317767*r**10+205760327*r**12+22704135*r**14+4844160*r**16)+Q2**7*(243738
            +632892*r**2+27746208*r**4+216896700*r**6+571666860*r**8+909856288*r**10
            +774178672*r**12+248138668*r**14+29796330*r**16+3521340*r**18)+2*Q2**6*(68409
            -318579*r**2+7216116*r**4-73107126*r**6-189303760*r**8-437701626*r**10
            -485681424*r**12-303122814*r**14+1309859*r**16-3843135*r**18+627120*r**20)
            -2*Q2**5*(130911-142854*r**2+27383571*r**4+15435336*r**6+182291046*r**8
            +165362706*r**10+80090386*r**12+79355246*r**14+52021411*r**16+162885196*r**18
            +8394675*r**20+1790130*r**22)+2*Q2**4*(54153+49975*r**2+21185265*r**4
            +52066275*r**6+329756050*r**8+567660684*r**10+603473600*r**12+564545620*r**14
            +392790475*r**16+229278725*r**18+152733063*r**20+8436225*r**22+913890*r**24)
            +Q2**3*(35901-262314*r**2+1570530*r**4-68997280*r**6-109705125*r**8
            -634573542*r**10-618767172*r**12-988466560*r**14-589938125*r**16-4908950*r**18
            -329195934*r**20-22813664*r**22-3502795*r**24+385830*r**26)-(-1+r**2)**2*(2589
            -4733*r**2+2241614*r**4-5780470*r**6+73049315*r**8-233520403*r**10-35002404*r**12
            +1228727532*r**14-742870045*r**16+129396765*r**18+122562014*r**20-23266038*r**22
            +16198429*r**24+441715*r**26+48120*r**28)-Q2**2*(51519-191549*r**2+21023614*r**4
            -48309390*r**6+383527965*r**8-515789363*r**10+29328068*r**12+329218412*r**14
            -1181695175*r**16-132837235*r**18+696010894*r**20-243046494*r**22+126648299*r**24
            +3036515*r**26+799920*r**28)+Q2*(19191-68166*r**2+12008609*r**4-34826154*r**6
            +321469335*r**8-789979722*r**10+85768417*r**12+1505869722*r**14+1701505453*r**16
            -981466970*r**18-175522149*r**20+583848074*r**22-180867131*r**24+78850026*r**26
            +1956835*r**28+330630*r**30))+36288000*logq2**4*r**12*(9+12*r**2-26*r**4
            +84*r**6+9*r**8)*sqrtq2+1440*logq2**2*r**4*(-4320*Q2**11*(1+5*r**4)+8*Q2**10*(4965
            +4916*r**2+20601*r**4+24930*r**6)-40*Q2**9*(3612+7217*r**2+19493*r**4
            +31427*r**6+18795*r**8)+5*Q2**8*(50625+163440*r**2+459434*r**4+829380*r**6
            +751365*r**8+279900*r**10)-20*Q2**7*(8226+54837*r**2+165173*r**4+369290*r**6
            +407620*r**8+259473*r**10+51525*r**12)-20*Q2**6*(7245-29757*r**2-13760*r**4
            -167221*r**6-237535*r**8-163463*r**10-111678*r**12+36225*r**14)+2*Q2**5*(170100
            +80262*r**2+2890847*r**4+5149485*r**6+5819760*r**8+6516920*r**10+5177967*r**12
            +1268757*r**14+1031310*r**16)-10*Q2**4*(19917+43302*r**2+696535*r**4
            +1674070*r**6+2004837*r**8+2248840*r**10+2048341*r**12+1426478*r**14
            +375522*r**16+137070*r**18)-20*Q2**3*(2070-18825*r**2-40178*r**4-413134*r**6
            -493868*r**8-490217*r**10-921311*r**12-312148*r**14-100640*r**16-102060*r**18
            +8775*r**20)+20*Q2**2*(5481-14553*r**2+216497*r**4-202152*r**6-195594*r**8
            +245543*r**10+79464*r**12-737049*r**14-42235*r**16+428850*r**18-42237*r**20
            +36225*r**22)+(-1+r**2)**2*(8805-17242*r**2+789439*r**4-1773860*r**6
            -986474*r**8+9561352*r**10+5375842*r**12-326924*r**14-1127675*r**16
            +1722514*r**18+12383*r**20+67440*r**22)-10*Q2*(5268-15566*r**2+341497*r**4
            -654419*r**6-274184*r**8+2240122*r**10+1166944*r**12+2977672*r**14-436142*r**16
            -719852*r**18+696519*r**20-43509*r**22+37890*r**24))*sqrtq2+(-126*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**3*(5*Q2**5-Q2**4*(7+15*r**2)+2*Q2**3*(4+2*r**2+5*r**4)+(-1
            +r**2)**2*(17+r**2-11*r**4+5*r**6)+2*Q2**2*(7-6*r**2-4*r**4+5*r**6)
            -Q2*(37+20*r**2+8*r**4-32*r**6+15*r**8))+10*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(32256*Q2**14-288*Q2**13*(339+518*r**2)+8*Q2**12*(11745+40478*r**2
            +23877*r**4)+Q2**11*(95499-358507*r**2-508135*r**4+99351*r**6)-Q2**10*(383589
            +356080*r**2+1976274*r**4-329264*r**6+354249*r**8)+Q2**9*(21459+1400491*r**2
            +7390760*r**4+10034036*r**6+1055725*r**8+34713*r**10)+3*Q2**8*(374345
            -756146*r**2-3663623*r**4-3769244*r**6-2403589*r**8-751922*r**10+107331*r**12)
            -6*Q2**7*(199739-371663*r**2-1833699*r**4-4168441*r**6-937469*r**8+2363425*r**10
            -467*r**12+14847*r**14)+Q2**6*(-288642+2265816*r**2+231180*r**4-8496168*r**6
            +23003492*r**8-6870072*r**10+13567596*r**12+2449800*r**14-179802*r**16)
            +2*Q2**5*(556707-2541849*r**2+17102856*r**4+26213580*r**6-16538884*r**8
            -58976872*r**10-14698344*r**12+5756076*r**14-244239*r**16+26649*r**18)
            +2*Q2**4*(-280545+498702*r**2-36732645*r**4-57585012*r**6-82444840*r**8
            -153525108*r**10-68689312*r**12+19803180*r**14-6641823*r**16-733650*r**18
            +33453*r**20)+Q2**3*(-80553+1343297*r**2+18298989*r**4+65629323*r**6
            +235764138*r**8+98850070*r**10+231769822*r**12+308404866*r**14+33807807*r**16
            -440343*r**18+313973*r**20-15309*r**22)+Q2**2*(240999-890072*r**2+38735950*r**4
            -99122616*r**6-171385291*r**8-436767904*r**10-226505772*r**12+241352384*r**14
            +125268401*r**16-35938824*r**18+3304030*r**20+469624*r**22-15309*r**24)
            +(-1+r**2)**2*(33375-463432*r**2+9716288*r**4+34210932*r**6+429107767*r**8
            +185694112*r**10-23101104*r**12-160832984*r**14+74725573*r**16+11512488*r**18
            +710768*r**20-61084*r**22+1701*r**24)+Q2*(-144057+1075351*r**2-33791760*r**4
            +4965436*r**6-891123325*r**8-1407498441*r**10-371766112*r**12+416999240*r**14
            +306799653*r**16-255890035*r**18-12685712*r**20-1896324*r**22-63215*r**24
            +1701*r**26)))*sqrtq2))/(-489888000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -3402000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+1469664000*logq2**4*r**16*sqrtq2
            +61236000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+70875*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+(-32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(-22896*Q2**21
            +16*Q2**20*(-2403+23*r**2)-2*Q2**19*(-188487+1220444*r**2+557713*r**4)
            +Q2**18*(21858642+29593562*r**2+237404666*r**4+23336402*r**6)-8*Q2**17*(27106425
            +21924259*r**2+256545941*r**4+325004921*r**6+19308753*r**8)+Q2**16*(893624517
            +553332475*r**2+6108225138*r**4+19463196782*r**6+12570133185*r**8+538901775*r**10)
            -2*Q2**15*(940983516+532298899*r**2+1253333145*r**4+23595587002*r**6
            +38610938370*r**8+16075427107*r**10+557898825*r**12)+2*Q2**14*(764476254
            +1252971707*r**2-15531915764*r**4-2784042659*r**6+39679332150*r**8+70914892861*r**10
            +19494857872*r**12+661086939*r**14)+Q2**13*(2004498504-9032522906*r**2
            +99966293898*r**4+306221911838*r**6+551314302570*r**8+357189527650*r**10
            -49107268642*r**12+8587756122*r**14-549992346*r**16)-2*Q2**12*(3311998560
            -11203052723*r**2+80511476274*r**4+458726175646*r**6+1206414500178*r**8
            +1627800255456*r**10+905789198982*r**12+145009193586*r**14+49938610678*r**16
            +375065379*r**18)+2*Q2**11*(3148021890-13481616195*r**2+56368513033*r**4
            +754772464816*r**6+2334425515904*r**8+4135500080250*r**10+3877535185254*r**12
            +1547779351960*r**14+281593531174*r**16+64932724225*r**18+576991753*r**20)
            -2*Q2**10*(-375955632-35352933*r**2-81660273926*r**4+663189874223*r**6
            +2228618227012*r**8+4893715555586*r**10+5887999267872*r**12+4091923697066*r**14
            +660080750924*r**16+181053107123*r**18+12119135270*r**20+70567159*r**22)
            -2*Q2**9*(3633590844-21442300443*r**2+286775999543*r**4-94012001493*r**6
            -308680440635*r**8-1945107371470*r**10-2817503026682*r**12-2169414833050*r**14
            -861033434618*r**16+1646172782105*r**18+62900815283*r**20+57949425087*r**22
            +493186889*r**24)+2*Q2**8*(3026685033-24554797262*r**2+325954394768*r**4
            +402394324334*r**6+1204163593725*r**8+1170721388736*r**10+814152111528*r**12
            +1425576808540*r**14+1919840595723*r**16+1888557109050*r**18+2709480115672*r**20
            +173740103174*r**22+63872911679*r**24+455382468*r**26)-2*Q2**7*(-63455220
            -2496877087*r**2+51105561795*r**4+548579219986*r**6+91974746298*r**8
            +1522655956023*r**10+455216874477*r**12+273446429660*r**14+535809382072*r**16
            -98778088209*r**18+2380847841293*r**20+977882061138*r**22+114843973186*r**24
            +9176703417*r**26+15289731*r**28)-2*Q2**6*(1814983326-17965203265*r**2
            +279652792308*r**4-763774375555*r**6+2417663950098*r**8-2521564265209*r**10
            -859250511072*r**12-773975299699*r**14-2466621775150*r**16-2301657019867*r**18
            +4347083913620*r**20-4066659537537*r**22+1354261241342*r**24-50258025579*r**26
            +32418650840*r**28+238414839*r**30)+2*Q2**5*(1227744180-16033351055*r**2
            +305360143823*r**4-897648524503*r**6+3462676239819*r**8-5244623526259*r**10
            -796011125989*r**12-2130513942075*r**14-4707083710721*r**16-5758730001485*r**18
            -9608724376003*r**20+6599133381467*r**22-5661125792143*r**24+1676035915599*r**26
            -26322254119*r**28+26830126007*r**30+161232657*r**32)+(-1+r**2)**4*(10616481
            -215276027*r**2+6760531548*r**4-58320537116*r**6+395723263360*r**8-1664842412456*r**10
            +4860101253916*r**12-6014608897020*r**14+949894791082*r**16-601505427510*r**18
            +2781997933364*r**20-3032495634996*r**22+1166501226536*r**24-351721101616*r**26
            +30518556500*r**28-1739018164*r**30+262866957*r**32+1233161*r**34)-2*Q2**4*(93260772
            -2530141669*r**2+80369539230*r**4-350504498066*r**6+1554853541310*r**8
            -4057738222774*r**10+1603543821814*r**12+148722941622*r**14-7078551227618*r**16
            -1629304113280*r**18+1756835858362*r**20-9033062239286*r**22+4062553470586*r**24
            -2581975537866*r**26+460302337970*r**28+5415292690*r**30+4028256966*r**32
            +11364837*r**34)-2*Q2*(-1+r**2)**2*(50925312-978722381*r**2+26565826095*r**4
            -204167033292*r**6+1204460905232*r**8-4312828492840*r**10+9810763267364*r**12
            -5828997281708*r**14-7408527693760*r**16-188673989194*r**18+949506028394*r**20
            +5293674745020*r**22-8109972068784*r**24+3720889692736*r**26-1206936552188*r**28
            +126763191484*r**30-7500730528*r**32+1197765247*r**34+6089791*r**36)
            -2*Q2**3*(311360481-4560503059*r**2+82262526300*r**4-417696262396*r**6
            +1712466911460*r**8-3404251566144*r**10+4372784667312*r**12+467027355108*r**14
            +1944991569118*r**16+3027430817730*r**18+4678050601720*r**20-2764476525012*r**22
            -4957072120556*r**24+4529140061832*r**26-2211936355440*r**28+405679455468*r**30
            -32096183991*r**32+6009400073*r**34+39621996*r**36)+2*Q2**2*(193733415
            -3522325774*r**2+80722127333*r**4-565113720634*r**6+2923253346688*r**8
            -9293250572916*r**10+18232475373504*r**12-12151636897820*r**14+2445124420342*r**16
            -17938292610224*r**18+4372409776002*r**20-3083262817136*r**22+14917076707576*r**24
            -19214984185612*r**26+9852698714664*r**28-3223111419876*r**30+402655559531*r**32
            -27112555714*r**34+4245220529*r**36+23870122*r**38))-32*r**4*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**4*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**2*(22896*Q2**22-32*Q2**21*(-486+727*r**2)+2*Q2**20*(-207711+1201404*r**2
            +557897*r**4)-4*Q2**19*(5370417+7914369*r**2+60240245*r**4+6112957*r**6)
            +2*Q2**18*(119355021+113423138*r**2+1159682878*r**4+1430390218*r**6+88903213*r**8)
            -Q2**17*(1110475917+945577947*r**2+8335986738*r**4+24115603678*r**6+15324642577*r**8
            +693371799*r**10)+Q2**16*(2775591549+2511554790*r**2+9168223903*r**4
            +72762595924*r**6+109255206707*r**8+45259889174*r**10+1654699425*r**12)
            -4*Q2**15*(852729885+1363127061*r**2-6873141860*r**4+11032438744*r**6
            +50942928761*r**8+62800629169*r**10+18064091902*r**12+609492882*r**14)
            +4*Q2**14*(-118886499+3266854707*r**2-32131045503*r**4-85713457171*r**6
            -119380930897*r**8-34000269407*r**10+57481692527*r**12+7931033375*r**14
            +468041556*r**16)+4*Q2**13*(2157123906-7358532462*r**2+62989180885*r**4
            +330910139257*r**6+817591303691*r**8+1041026085283*r**10+529915164243*r**12
            +62374718663*r**14+26978746283*r**16+50034603*r**18)-4*Q2**12*(3230010225
            -10686335179*r**2+62838468292*r**4+647005058368*r**6+1999783095864*r**8
            +3484857417942*r**10+3205562319846*r**12+1299288872264*r**14+238270667719*r**16
            +57623200141*r**18+476028566*r**20)+4*Q2**11*(1386033129-5184473619*r**2
            -19386688544*r**4+737165426036*r**6+2658908103866*r**8+5681820575870*r**10
            +6950517266688*r**12+4758619117140*r**14+1244726817029*r**16+263789681261*r**18
            +38814425624*r**20+323779456*r**22)+4*Q2**10*(2004773238-10515495939*r**2
            +184235813201*r**4-337770800895*r**6-1600244270935*r**8-4533720577034*r**10
            -6799608925070*r**12-6074668898994*r**14-2806518941304*r**16+402519462029*r**18
            -65135713555*r**20+22879861329*r**22+211309865*r**24)-2*Q2**9*(6660275877
            -42363506861*r**2+591288093868*r**4+595158322384*r**6+801471151597*r**8
            -1083066423369*r**10-3948458286624*r**12-3561341051192*r**14-1110607671945*r**16
            +2673696456537*r**18+4418553713060*r**20+294590343544*r**22+122315523655*r**24
            +948569357*r**26)+2*Q2**8*(2963229813-24024989316*r**2+352505159301*r**4
            +1276927939088*r**6+1698532664357*r**8+3897540938484*r**10+2440090374741*r**12
            +2513175349728*r**14+3881226786335*r**16+3709619616564*r**18+6978885066015*r**20
            +3861102279984*r**22+352456988039*r**24+73504997564*r**26+470672199*r**28)
            +4*Q2**7*(939219273-7702435479*r**2+115522053800*r**4-681729578668*r**6
            +888554991907*r**8-2068097483765*r**10-1418561670786*r**12-751319301918*r**14
            -1637938793441*r**16-1369344156865*r**18+1032507080268*r**20-3712694719984*r**22
            +130767603509*r**24-87139351091*r**26+11613328846*r**28+111562554*r**30)
            -4*Q2**6*(1521363753-16091785497*r**2+283523866433*r**4-690885053875*r**6
            +2558282907181*r**8-2674261920685*r**10-2088412951135*r**12-1881869876423*r**14
            -3973840392785*r**16-5263504398251*r**18-3781648741125*r**20+3439778878775*r**22
            -4186762044169*r**24+1490019565681*r**26-22080814429*r**28+29743595843*r**30
            +199823748*r**32)+4*Q2**5*(660502476-8667874272*r**2+184848165999*r**4
            -471396439373*r**6+2059940628313*r**8-2919842754607*r**10-2218545415217*r**12
            -1388901063221*r**14-6958074440207*r**16-6047558912743*r**18-6805309259563*r**20
            -6021326616911*r**22+2500280529955*r**24-3283532707205*r**26+1055007999725*r**28
            +2961582289*r**30+15509807815*r**32+86298747*r**34)+(-1+r**2)**4*(10616481
            -204659546*r**2+6545255521*r**4-51560005568*r**6+337402726244*r**8-1269119149096*r**10
            +3195258841460*r**12-1154507643104*r**14-5064714105938*r**16+348389363572*r**18
            +2180492505854*r**20-250497701632*r**22-1865994408460*r**24+814780124920*r**26
            -321202545116*r**28+28779538336*r**30-1476151207*r**32+264100118*r**34
            +1233161*r**36)+2*Q2**4*(218099709-2123622162*r**2+4423128739*r**4-147561303560*r**6
            +508117868216*r**8-901366884680*r**10+6826979068272*r**12-1285239408328*r**14
            +8874819855114*r**16+11735286158628*r**18+4550518856638*r**20+4511749855912*r**22
            +13436648144*r**24+3048562129112*r**26-90263155544*r**28-60038175192*r**30
            -41539733647*r**32+1969778270*r**34+28257159*r**36)-Q2*(-1+r**2)**2*(112467105
            -2092103127*r**2+58375907511*r**4-427259290633*r**6+2519712613020*r**8
            -8731344651508*r**10+19581378891236*r**12-9436121845996*r**14-8635836111898*r**16
            -23710307272602*r**18+6456567657866*r**20+3288364617594*r**22+4380895782364*r**24
            -14495383941780*r**26+6928368267364*r**28-2574843954188*r**30+272784381697*r**32
            -14869449479*r**34+2668110711*r**36+13412743*r**38)-4*Q2**3*(252546948
            -3885734176*r**2+79212075287*r**4-450273728365*r**6+2109011997876*r**8
            -5492517613800*r**10+9600504237336*r**12-3655912437700*r**14+2428571672284*r**16
            -6482935111688*r**18+6038945597726*r**20-584844370214*r**22+3597764031004*r**24
            -9821458122168*r**26+6084951210528*r**28-2514684159924*r**30+388119415504*r**32
            -26599669816*r**34+5147121299*r**36+31746059*r**38)+2*Q2**2*(244658727
            -4409165364*r**2+105773997728*r**4-742669001164*r**6+3997500423965*r**8
            -13295914562824*r**10+28580105958864*r**12-23682513833592*r**14+4353717659542*r**16
            -6693784073264*r**18-19647556521200*r**20+4495135657904*r**22-5914001639990*r**24
            +20936601097288*r**26-26120973477392*r**28+12891113283384*r**30-4288419526029*r**32
            +518505421604*r**34-32757506416*r**36+5454676316*r**38+29959913*r**40))*sqrtq2
            +logq2**7*(338610585600000*r**28*(1+r**2)**2*(1-Q2+r**2)*(249+460*r**2
            -1994*r**4+5300*r**6+681*r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3
            +338610585600000*(Q2-(-1+r)**2)**2*r**28*(1+r**2)**2*(249+460*r**2-1994*r**4
            +5300*r**6+681*r**8)*(Q2-(1+r)**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2**6*(537477120000*r**24*(1+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(120*Q2**10*(-19-19*r**2+65*r**4+65*r**6)+30*Q2**9*(893
            +3739*r**2+10235*r**4+9269*r**6+1880*r**8)-2*Q2**8*(76227+470845*r**2
            +1404376*r**4+2673896*r**6+1886301*r**8+413235*r**10)+Q2**7*(404892
            +3408297*r**2+10608601*r**4+21947332*r**6+27601332*r**8+16673031*r**10
            +3413835*r**12)-Q2**6*(478737+5968830*r**2+20644913*r**4+40939656*r**6
            +57062707*r**8+61673586*r**10+34851411*r**12+6748560*r**14)+Q2**5*(106134
            +5280583*r**2+22323985*r**4+36776435*r**6+47891245*r**8+64039405*r**10
            +63360491*r**12+33445377*r**14+5859945*r**16)+(-1+r**2)**4*(-37959+139626*r**2
            +88759*r**4+1538272*r**6+1840455*r**8+25778054*r**10+12637409*r**12
            -2831844*r**14+1594968*r**16+670980*r**18)+Q2**4*(254205-2439360*r**2
            -18313619*r**4-17674970*r**6-16321557*r**8-16911062*r**10-34022777*r**12
            -26764950*r**14-3005100*r**16+1552950*r**18)+Q2**3*(-113976+623775*r**2
            +14256553*r**4+961758*r**6+5426000*r**8-69169460*r**10-126138174*r**12
            -8972110*r**14+17737632*r**16-20991483*r**18-8715555*r**20)-Q2*(-1
            +r**2)**2*(-152832+407481*r**2-851065*r**4+9868068*r**6+11517526*r**8
            +102381922*r**10+165126744*r**12+44265620*r**14-13763958*r**16+8751789*r**18
            +3798465*r**20)+Q2**2*(-159447+349018*r**2-6858065*r**4+18990434*r**6
            +18585532*r**8+145584298*r**10+197942072*r**12+238200130*r**14+64579411*r**16
            -37501132*r**18+14460129*r**20+8527140*r**22))-537477120000*r**24*(1
            +r**2)*(120*Q2**13*(-19-19*r**2+65*r**4+65*r**6)+30*Q2**12*(1121+4195*r**2
            +9683*r**4+7709*r**6+1100*r**8)-2*Q2**11*(119832+684985*r**2+2027206*r**4
            +3535496*r**6+2368506*r**8+486135*r**10)+Q2**10*(944904+7080819*r**2
            +23073427*r**4+48201784*r**6+56626884*r**8+31417257*r**10+6054645*r**12)
            -5*Q2**9*(435513+4124751*r**2+14726139*r**4+32595809*r**6+47146359*r**8
            +44107449*r**10+21660885*r**12+3905175*r**14)+5*Q2**8*(581895+7289439*r**2
            +28747379*r**4+64112807*r**6+99396109*r**8+117165373*r**10+96015153*r**12
            +43607637*r**14+7434720*r**16)-5*Q2**7*(381060+8093376*r**2+36646269*r**4
            +77065368*r**6+116756093*r**8+150480224*r**10+159279759*r**12+119933256*r**14
            +50446323*r**16+7937280*r**18)-(-1+r**2)**6*(-37959+101667*r**2+228385*r**4
            +1627031*r**6+3378727*r**8+27618509*r**10+38415463*r**12+9805565*r**14
            -1236876*r**16+2265948*r**18+670980*r**20)+Q2**6*(-79452+28723350*r**2
            +168564359*r**4+294551199*r**6+393061109*r**8+413074543*r**10+445552135*r**12
            +559852669*r**14+401673459*r**16+123523839*r**18+10953990*r**20)+Q2*(
            -1+r**2)**4*(-266709+597609*r**2-11932*r**4+14228215*r**6+30249780*r**8
            +199529336*r**10+362498366*r**12+303505812*r**14+67535105*r**16-8304825*r**18
            +18677118*r**20+5811405*r**22)+Q2**5*(838962-13164498*r**2-127493279*r**4
            -132912728*r**6-133904618*r**8+198717758*r**10+610803572*r**12+490520666*r**14
            -99424168*r**16-133440948*r**18+70086411*r**20+33472710*r**22)-5*Q2**2*(
            -1+r**2)**2*(-146364+327821*r**2-1748900*r**4+9014534*r**6+18074127*r**8
            +118283822*r**10+207578908*r**12+217623552*r**14+179620302*r**16+40447677*r**18
            -10145456*r**20+11922306*r**22+4387095*r**24)-5*Q2**4*(-7008-611016*r**2
            -16229949*r**4+3687459*r**6+11982944*r**8+154853476*r**10+296893970*r**12
            +323873810*r**14+271037516*r**16+42699180*r**18-21397629*r**20+29192835*r**22
            +11415900*r**24)+5*Q2**3*(-172164+392562*r**2-7623179*r**4+18196812*r**6
            +17335855*r**8+172012434*r**10+219994810*r**12+163152528*r**14+161087618*r**16
            +253962014*r**18+73325921*r**20-37914972*r**22+17296323*r**24+9272670*r**26))*sqrtq2)
            +logq2**5*(1492992000*r**20*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-3840*Q2**14*(-19-19*r**2+65*r**4+65*r**6)+240*Q2**13*(2717
            -2378*r**2+49050*r**4+130326*r**6+76181*r**8)-4*Q2**12*(3480237+6215768*r**2
            +33032126*r**4+98955136*r**6+112654533*r**8+43231704*r**10)+4*Q2**11*(21768474
            +67490065*r**2+194288853*r**4+544569454*r**6+841855808*r**8+633200529*r**10
            +187346913*r**12)-Q2**10*(277466673+1158286976*r**2+2776603343*r**4+6278534478*r**6
            +11215532223*r**8+12358191436*r**10+7387932465*r**12+1850293206*r**14)
            +10*Q2**9*(47814414+250255087*r**2+591706731*r**4+1052476547*r**6+1747712267*r**8
            +2421832549*r**10+2283114329*r**12+1220052105*r**14+274268547*r**16)
            -5*Q2**8*(68541279+514405240*r**2+1403449900*r**4+2335004672*r**6+3320200626*r**8
            +4839285128*r**10+5609647068*r**12+4533587600*r**14+2234128743*r**16
            +450370800*r**18)+4*Q2**7*(-63474996+64489381*r**2+1109399677*r**4+3647822427*r**6
            +8009977681*r**8+14322547197*r**10+17525764371*r**12+12214204497*r**14
            +4782632327*r**16+1225379826*r**18+110144268*r**20)+2*Q2**6*(386860179
            +1060315730*r**2-1290168237*r**4-12205130786*r**6-35808525272*r**8-69607310832*r**10
            -97266706292*r**12-97380245852*r**14-58640478811*r**16-16191189722*r**18
            -672241311*r**20+543157398*r**22)-4*Q2**5*(157866606+495539402*r**2-754818394*r**4
            -6633881519*r**6-19668893949*r**8-35076171132*r**10-49746067528*r**12
            -60872866542*r**14-56756350784*r**16-34172070774*r**18-10362043958*r**20
            -555655035*r**22+315202407*r**24)+3*(-1+r**2)**4*(-3250701+214424*r**2
            +15482166*r**4-275523080*r**6-904837495*r**8+1669665960*r**10+7570783588*r**12
            +13282038032*r**14+6731540037*r**16-429596120*r**18+1096881126*r**20
            +955081848*r**22+110653887*r**24+2344728*r**26)+10*Q2**4*(6652695+58885882*r**2
            -153359966*r**4-1522207866*r**6-5493846365*r**8-7274842032*r**10-7588010268*r**12
            -12029116052*r**14-14373137067*r**16-8494974486*r**18-2796203478*r**20
            -1131669970*r**22-123662655*r**24+68015148*r**26)-6*Q2*(-1+r**2)**2*(
            -12257466+5318713*r**2+71536165*r**4-733996644*r**6-2851979190*r**8
            +2477943645*r**10+16886188473*r**12+39582858960*r**14+45317521074*r**16
            +14607425427*r**18-2397696409*r**20+3409486484*r**22+2623273470*r**24
            +293920215*r**26+6370683*r**28)-20*Q2**3*(-13323162+4913454*r**2+54057650*r**4
            -471570069*r**6-2642782145*r**8-2299470865*r**10+187274445*r**12+4486997686*r**14
            +5247184388*r**16-1800431100*r**18-1084960508*r**20+3141431919*r**22
            +1417484295*r**24+115506255*r**26+12442317*r**28)+Q2**2*(-216985893+235491948*r**2
            +1264939921*r**4-9571584854*r**6-37217298177*r**8+23073243720*r**10+132454888989*r**12
            +302134307238*r**14+470634299793*r**16+446924044524*r**18+103534696179*r**20
            -69140036362*r**22+32474184341*r**24+31352816736*r**26+3395185503*r**28
            +98769594*r**30))-1492992000*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(3840*Q2**14*(
            -19-19*r**2+65*r**4+65*r**6)-240*Q2**13*(2717-2378*r**2+49050*r**4
            +130326*r**6+76181*r**8)+4*Q2**12*(3480237+6215768*r**2+33032126*r**4
            +98955136*r**6+112654533*r**8+43231704*r**10)-4*Q2**11*(21768474+67490065*r**2
            +194288853*r**4+544569454*r**6+841855808*r**8+633200529*r**10+187346913*r**12)
            +Q2**10*(277466673+1158286976*r**2+2776603343*r**4+6278534478*r**6+11215532223*r**8
            +12358191436*r**10+7387932465*r**12+1850293206*r**14)-10*Q2**9*(47814414
            +250255087*r**2+591706731*r**4+1052476547*r**6+1747712267*r**8+2421832549*r**10
            +2283114329*r**12+1220052105*r**14+274268547*r**16)+5*Q2**8*(68541279
            +514405240*r**2+1403449900*r**4+2335004672*r**6+3320200626*r**8+4839285128*r**10
            +5609647068*r**12+4533587600*r**14+2234128743*r**16+450370800*r**18)
            -4*Q2**7*(-63474996+64489381*r**2+1109399677*r**4+3647822427*r**6+8009977681*r**8
            +14322547197*r**10+17525764371*r**12+12214204497*r**14+4782632327*r**16
            +1225379826*r**18+110144268*r**20)+2*Q2**6*(-386860179-1060315730*r**2
            +1290168237*r**4+12205130786*r**6+35808525272*r**8+69607310832*r**10
            +97266706292*r**12+97380245852*r**14+58640478811*r**16+16191189722*r**18
            +672241311*r**20-543157398*r**22)+4*Q2**5*(157866606+495539402*r**2-754818394*r**4
            -6633881519*r**6-19668893949*r**8-35076171132*r**10-49746067528*r**12
            -60872866542*r**14-56756350784*r**16-34172070774*r**18-10362043958*r**20
            -555655035*r**22+315202407*r**24)-3*(-1+r**2)**4*(-3250701+214424*r**2
            +15482166*r**4-275523080*r**6-904837495*r**8+1669665960*r**10+7570783588*r**12
            +13282038032*r**14+6731540037*r**16-429596120*r**18+1096881126*r**20
            +955081848*r**22+110653887*r**24+2344728*r**26)-10*Q2**4*(6652695+58885882*r**2
            -153359966*r**4-1522207866*r**6-5493846365*r**8-7274842032*r**10-7588010268*r**12
            -12029116052*r**14-14373137067*r**16-8494974486*r**18-2796203478*r**20
            -1131669970*r**22-123662655*r**24+68015148*r**26)+6*Q2*(-1+r**2)**2*(
            -12257466+5318713*r**2+71536165*r**4-733996644*r**6-2851979190*r**8
            +2477943645*r**10+16886188473*r**12+39582858960*r**14+45317521074*r**16
            +14607425427*r**18-2397696409*r**20+3409486484*r**22+2623273470*r**24
            +293920215*r**26+6370683*r**28)+20*Q2**3*(-13323162+4913454*r**2+54057650*r**4
            -471570069*r**6-2642782145*r**8-2299470865*r**10+187274445*r**12+4486997686*r**14
            +5247184388*r**16-1800431100*r**18-1084960508*r**20+3141431919*r**22
            +1417484295*r**24+115506255*r**26+12442317*r**28)-Q2**2*(-216985893+235491948*r**2
            +1264939921*r**4-9571584854*r**6-37217298177*r**8+23073243720*r**10+132454888989*r**12
            +302134307238*r**14+470634299793*r**16+446924044524*r**18+103534696179*r**20
            -69140036362*r**22+32474184341*r**24+31352816736*r**26+3395185503*r**28
            +98769594*r**30))*sqrtq2)+logq2**4*(-16588800*r**16*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-7680*Q2**18*(-19+65*r**4)+1920*Q2**17*(5529+3576*r**2
            +75857*r**4+81366*r**6)-48*Q2**16*(3651931+6616274*r**2+37730142*r**4
            +73995922*r**6+39970603*r**8)+4*Q2**15*(293754507+830834400*r**2+2849440142*r**4
            +6958143768*r**6+7316477775*r**8+2701832496*r**10)-4*Q2**14*(1072972485
            +4103243226*r**2+11752254309*r**4+29632129672*r**6+43894200267*r**8+31934168478*r**10
            +8948760075*r**12)+2*Q2**13*(4505905320+22495328823*r**2+66014290685*r**4
            +166156224553*r**6+292851089722*r**8+306558366675*r**10+169089947229*r**12
            +37130021385*r**14)-2*Q2**12*(4702345515+34540837317*r**2+120736325634*r**4
            +323352052030*r**6+623325272889*r**8+794851061367*r**10+631943577762*r**12
            +275339889486*r**14+45453574080*r**16)+2*Q2**11*(-727435098+22878416496*r**2
            +122755176609*r**4+388473989630*r**6+799590662223*r**8+1078016262690*r**10
            +1031256680019*r**12+676627871754*r**14+236185382223*r**16+18662038686*r**18)
            +Q2**10*(17885676456+28160770536*r**2-7059872115*r**4-183608262719*r**6
            -520986054923*r**8-344164350187*r**10+355172970819*r**12+391624094523*r**14
            +13761947031*r**16+32629579623*r**18+74001124188*r**20)-2*Q2**9*(10833257760
            +43342647921*r**2+184697212929*r**4+564566189992*r**6+1017884325807*r**8
            +1643711153173*r**10+2735709156661*r**12+3457949572599*r**14+2586419531637*r**16
            +1053600840822*r**18+292679422038*r**20+71769455925*r**22)+Q2**8*(6187573710
            +77589671958*r**2+478211553645*r**4+1762775284153*r**6+3439079388492*r**8
            +4368301960740*r**10+5379814490282*r**12+7690354648770*r**14+8939628520518*r**16
            +6637222413102*r**18+2721673539105*r**20+656439705309*r**22+93337099560*r**24)
            +4*Q2**7*(2836077105-6782692548*r**2-14965133871*r**4-137402591705*r**6
            -547452503576*r**8-1000323759218*r**10-1436546645866*r**12-2070499943950*r**14
            -2141934432055*r**16-1428626186796*r**18-795050782503*r**20-323506830513*r**22
            -70881994194*r**24+5396502090*r**26)-2*Q2**6*(6806950122+6940102164*r**2
            +244049364349*r**4+487847675221*r**6-778133987865*r**8-3953634565561*r**10
            -8951406824570*r**12-14900596888284*r**14-17618176584574*r**16-13742537251652*r**18
            -5534441789397*r**20-671828523665*r**22+95059183269*r**24+21936902337*r**26
            +40763044506*r**28)+2*Q2**5*(2363615352+13694524389*r**2+263313807303*r**4
            +423062426731*r**6-1270584414132*r**8-4979245213485*r**10-10572802182585*r**12
            -17326530833523*r**14-23542802004252*r**16-24888783760305*r**18-19300066583823*r**20
            -9094977743319*r**22-1501499887000*r**24+214391821161*r**26+55575940977*r**28
            +26940566511*r**30)+9*(-1+r**2)**4*(1431618+39924426*r**2+890845645*r**4
            -2757105639*r**6+3633710728*r**8+71479683112*r**10+76061158987*r**12
            -375327261945*r**14-703178958462*r**16-383785350606*r**18+3447540387*r**20
            -66660946297*r**22-86372535300*r**24-25783449124*r**26-2599100347*r**28
            -205452967*r**30+41945784*r**32)-2*Q2**4*(-983996355+9908048127*r**2
            +52943264753*r**4+36190048439*r**6-803388283441*r**8-2760299435979*r**10
            -6205755933039*r**12-7780805235261*r**14-11033955213933*r**16-15632503582503*r**18
            -11460007215597*r**20-5058970758563*r**22-3569294595767*r**24-1175582933981*r**26
            +94709095419*r**28+41173285881*r**30+1706641800*r**32)-18*Q2*(-1+r**2)**2*(10783104
            +103947667*r**2+3281480233*r**4-8703672117*r**6+488458132*r**8+185055169050*r**10
            +296455013587*r**12-598935169679*r**14-1968951974826*r**16-2355557188434*r**18
            -1088712068017*r**20+63501151085*r**22-169348329816*r**24-248812223782*r**26
            -67117006923*r**28-6429293737*r**30-804503314*r**32+179747787*r**34)
            -6*Q2**3*(427732170-991455816*r**2+32285113965*r**4-23950197036*r**6
            -46381436569*r**8+787391716110*r**10+2439857571969*r**12+1545317737920*r**14
            -237652291593*r**16-545570207022*r**18+2066713190295*r**20+1832626993140*r**22
            -2026145115915*r**24-1447535558846*r**26-157615539909*r**28-29178736200*r**30
            -11974876893*r**32+2752960230*r**34)+3*Q2**2*(348130560+444586552*r**2
            +56414488779*r**4-142929325805*r**6-60043954481*r**8+2087633950427*r**10
            +3400066334383*r**12-4451052804477*r**14-13380698349225*r**16-22616964370173*r**18
            -25993912189459*r**20-10680994876287*r**22+4565384843237*r**24-659077420855*r**26
            -2920456836371*r**28-701480353303*r**30-60420742923*r**32-17516681439*r**34
            +3707410860*r**36))-16588800*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7680*Q2**19*(
            -19+65*r**4)-1920*Q2**18*(5453+3500*r**2+76117*r**4+81626*r**6)+48*Q2**17*(3873091
            +6980474*r**2+40907462*r**4+80284842*r**6+43225243*r**8)-4*Q2**16*(337577679
            +954052860*r**2+3381597134*r**4+8298856536*r**6+8684076075*r**8+3181479732*r**10)
            +4*Q2**15*(1366726992+5227832133*r**2+15432528851*r**4+39439713582*r**6
            +58168821810*r**8+41952478749*r**10+11650592571*r**12)-10*Q2**14*(1330370058
            +6569552049*r**2+19545057151*r**4+49784998503*r**6+87980749920*r**8+91643020833*r**10
            +50171160867*r**12+11005508307*r**14)+2*Q2**13*(9208250835+61542071460*r**2
            +209245945142*r**4+555522567268*r**6+1082332587164*r**8+1394260517764*r**10
            +1107591891666*r**12+481559858100*r**14+82583595465*r**16)-2*Q2**12*(3974910417
            +62121599328*r**2+278032339560*r**4+832562367294*r**6+1746267987142*r**8
            +2496192596946*r**10+2458051319148*r**12+1583911339002*r**14+556978845789*r**16
            +64115612766*r**18)+Q2**11*(-19340546652+16141192260*r**2+298327058325*r**4
            +1206066595197*r**6+2897115358629*r**8+4099378200013*r**10+3863372914599*r**12
            +3024145009023*r**14+1811864560923*r**16+477065262195*r**18-36677046816*r**20)
            +Q2**10*(39552191976+132731742834*r**2+390495324279*r**4+938464245150*r**6
            +1331174333972*r**8+2422271901236*r**10+5482426933954*r**12+7662696210540*r**14
            +5578225104828*r**16+2153593208298*r**18+691989547887*r**20+217540036038*r**22)
            -5*Q2**9*(5570817846+37188296664*r**2+186858255069*r**4+652260417999*r**6
            +1320796084018*r**8+1938298583740*r**10+2827731021990*r**12+4015534421458*r**14
            +4205673345798*r**16+2783452631604*r**18+1082846812965*r**20+277067492247*r**22
            +47375202282*r**24)+Q2**8*(-5156734710+110908015860*r**2+615661761087*r**4
            +2790597204618*r**6+7391664686949*r**8+11808676386104*r**10+15494303034486*r**12
            +21352168914852*r**14+25197720897508*r**16+21291355680804*r**18+12539099082219*r**20
            +4672140566466*r**22+1033304781645*r**24+71751091200*r**26)+2*Q2**7*(12479104332
            -953128722*r**2+200553711511*r**4+183112224069*r**6-2147844178427*r**8
            -7049187091149*r**10-13825147634738*r**12-21914690067916*r**14-26043045336584*r**16
            -20883658489354*r**18-9981795727995*r**20-2908943749697*r**22-693718466145*r**24
            -109034081871*r**26+51556048686*r**28)-2*Q2**6*(9170565474+27441576675*r**2
            +514303273816*r**4+1154959466301*r**6-1560870726776*r**8-9711013766911*r**10
            -23477843572716*r**12-41178534546377*r**14-56061575477110*r**16-56249497596531*r**18
            -38577045624872*r**20-15301248056381*r**22-2078269227396*r**24+331387906767*r**26
            +118275887820*r**28+67703611017*r**30)+2*Q2**5*(1379618997+25966187868*r**2
            +329951596445*r**4+722566282473*r**6-1650910270842*r**8-9010129063596*r**10
            -21757803329109*r**12-35680138251369*r**14-51903288051708*r**16-64064089347060*r**18
            -55648857559725*r**20-33454015085705*r**22-14165772226086*r**24-2462690999820*r**26
            +364676857557*r**28+123689793369*r**30+28647208311*r**32)+9*(-1+r**2)**4*(1431618
            +41356044*r**2+930770071*r**4-1866259994*r**6+876605089*r**8+75113393840*r**10
            +147540842099*r**12-299266102958*r**14-1078506220407*r**16-1086964309068*r**18
            -380337810219*r**20-63213405910*r**22-153033481597*r**24-112155984424*r**26
            -28382549471*r**28-2804553314*r**30-163507183*r**32+41945784*r**34)+10*Q2**4*(453438573
            -2379683844*r**2+6800805803*r**4-32196780860*r**6+125610785059*r**8+1185172573550*r**10
            +3257125616985*r**12+3724502876412*r**14+3620360714883*r**16+5005949635074*r**18
            +6658530073797*r**20+4403371790716*r**22+509966001317*r**24+80454170642*r**26
            +121605443767*r**28-44683717980*r**30-15760911672*r**32+1310447778*r**34)
            -9*Q2*(-1+r**2)**2*(22997826+266522732*r**2+7583284211*r**4-15343256271*r**6
            -6391660319*r**8+432542410381*r**10+899755868765*r**12-1060930208991*r**14
            -5012237564595*r**16-8001773022147*r**18-6820699229765*r**20-2507763211541*r**22
            -161297459781*r**24-756020432017*r**26-669263198809*r**28-167883302717*r**30
            -16613842731*r**32-1538855589*r**34+401441358*r**36)-3*Q2**3*(1203594900
            -682860740*r**2+119001805077*r**4-126259491947*r**6-200707221691*r**8
            +3569654509509*r**10+9854564910541*r**12+3519297815301*r**14-10765367456571*r**16
            -24183409367403*r**18-22951626222913*r**20-2882314509417*r**22+4178348597687*r**24
            -7606438770377*r**26-6130759033881*r**28-1075068905521*r**30-142727969109*r**32
            -35960514765*r**34+9213331320*r**36)+3*Q2**2*(412829184+1287005866*r**2
            +75365283349*r**4-177490946522*r**6-75909584692*r**8+3079837479960*r**10
            +5048699086524*r**12-7091726636912*r**14-20679510884988*r**16-30097193170164*r**18
            -38690174555482*r**20-37362698473636*r**22-14425986233068*r**24+4826620943992*r**26
            -2012579592276*r**28-4347982211712*r**30-1092278632804*r**32-105780660294*r**34
            -20793263907*r**36+4785897582*r**38))*sqrtq2)+logq2**3*(138240*r**12*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(15360*Q2**21*(2185
            +27597*r**4)-256*Q2**20*(2775057+2839298*r**2+27274329*r**4+29238252*r**6)
            +160*Q2**19*(37613751+74754598*r**2+343124834*r**4+669258222*r**6+363840123*r**8)
            -40*Q2**18*(682284981+2029371072*r**2+7016762270*r**4+17172197376*r**6
            +18008691357*r**8+6465482928*r**10)+40*Q2**17*(1794674496+7436959927*r**2
            +24563850665*r**4+66477532434*r**6+97494708374*r**8+68361693639*r**10
            +17646172689*r**12)-5*Q2**16*(20373773397+126145239442*r**2+450751585323*r**4
            +1326429927720*r**6+2380794275083*r**8+2408241468178*r**10+1245719960037*r**12
            +228562796964*r**14)+4*Q2**15*(7116413667+176940610908*r**2+724722691574*r**4
            +2429931718572*r**6+5008094895420*r**8+6221042822612*r**10+4875256042458*r**12
            +1982059458084*r**14+192298643217*r**16)+20*Q2**14*(8155551741-4691478757*r**2
            -14504846014*r**4-153374137404*r**6-390319071344*r**8-255663147970*r**10
            -147645011514*r**12-305392061748*r**14-128216597973*r**16+43082280663*r**18)
            -20*Q2**13*(14349255009+47322950668*r**2+307063051873*r**4+1013514270666*r**6
            +2449797819528*r**8+5398635366282*r**10+7709699480376*r**12+5841903464446*r**14
            +2109963819951*r**16+454271874978*r**18+124060235727*r**20)+20*Q2**12*(6898340904
            +73066977693*r**2+522806835252*r**4+2366230628943*r**6+6968103246474*r**8
            +16143061574066*r**10+26307237646302*r**12+26751686958762*r**14+15586247255886*r**16
            +4734124078809*r**18+839910270606*r**20+98472921471*r**22)+20*Q2**11*(8307783939
            -46033721996*r**2-210171893028*r**4-2306410057164*r**6-9559271198313*r**8
            -25286009899076*r**10-45756913431732*r**12-55158464259076*r**14-42965735019459*r**16
            -19312015316352*r**18-4264197037016*r**20-605659950816*r**22+28143269337*r**24)
            -4*Q2**10*(69047281563+48418273717*r**2+2583661009676*r**4-1236010015002*r**6
            -28321234609545*r**8-94762905541033*r**10-190997208352632*r**12-242603081045556*r**14
            -213748275675023*r**16-131590606273125*r**18-37536730444532*r**20+1612557271502*r**22
            +149167112541*r**24+572279839833*r**26)+20*Q2**9*(4972555419+49821705912*r**2
            +869853064237*r**4+2126263237590*r**6+4226083083861*r**8+7469634301598*r**10
            +7462380752727*r**12+12919175764884*r**14+29352772717109*r**16+35414738502732*r**18
            +23125227101451*r**20+12509529016246*r**22+5090377103355*r**24+502124505918*r**26
            +72966882897*r**28)+10*Q2**8*(9684514383-95140866664*r**2-773346379643*r**4
            -5677798999254*r**6-21235090780229*r**8-53995953492580*r**10-81263036723559*r**12
            -88508671264354*r**14-115815955373227*r**16-164514811233456*r**18-166368185586297*r**20
            -103439764292762*r**22-41639570937951*r**24-10130338792484*r**26-1025719745829*r**28
            +34985450994*r**30)-20*Q2**7*(5432837259-12109228852*r**2+336513868194*r**4
            -1794743713620*r**6-4230474397858*r**8-11790287564796*r**10-26424625704846*r**12
            -27465475227212*r**14-23696414753332*r**16-31067097351804*r**18-37706168888890*r**20
            -38403947718652*r**22-29763300141006*r**24-12177300967444*r**26-761723866138*r**28
            -186923760804*r**30+48192819801*r**32)+20*Q2**6*(966090831+18934064961*r**2
            +508033453058*r**4-147255011472*r**6+8044785916002*r**8+11342924100400*r**10
            -24755234931630*r**12-77484429199992*r**14-139990498187064*r**16-198239545327950*r**18
            -186508043217162*r**20-98709375957440*r**22-18447897148434*r**24-2017323794712*r**26
            -1674870062410*r**28+2535798731208*r**30+133898623641*r**32+20491371765*r**34)
            +4*Q2**5*(6665099217-103245523252*r**2-978172591771*r**4-4752489169158*r**6
            -50454088176950*r**8-31769448743102*r**10+237751619518482*r**12+556916894764866*r**14
            +954216198790188*r**16+1490900041572210*r**18+1859801639253868*r**20+1688182887200302*r**22
            +1052527074705126*r**24+309453599530118*r**26+9575104475390*r**28-6231696599658*r**30
            -10626967542957*r**32-1026804925446*r**34+26727562527*r**36)+9*(-1+r**2)**4*(13853187
            -230678554*r**2-1144655189*r**4-39201710312*r**6-232777314732*r**8+1303880061184*r**10
            -4267397781788*r**12-22964467053848*r**14+9352146760786*r**16+112964911174716*r**18
            +65461484122546*r**20-18996998239912*r**22+10969568635988*r**24+17538480244464*r**26
            +6039039703364*r**28+1544922097208*r**30+280771909379*r**32-20628087826*r**34
            -3601095813*r**36+98455152*r**38)-20*Q2**4*(811844418-5638893811*r**2
            +61856693270*r**4-943965362913*r**6-1536683892774*r**8+3783823854748*r**10
            +28281941567118*r**12+50056727709664*r**14+87502291715142*r**16+144486551987622*r**18
            +210307394688370*r**20+194677500698302*r**22+108408658660062*r**24+87903859377900*r**26
            +48964237688858*r**28+5766833537064*r**30-1597500779584*r**32-297015910971*r**34
            -85886009904*r**36+7631227419*r**38)-180*Q2*(-1+r**2)**2*(5753823-109211516*r**2
            -696163184*r**4-10002507026*r**6-102373698625*r**8+448938967244*r**10
            -785921157372*r**12-6068291223012*r**14-2747030137718*r**16+22515934150244*r**18
            +36274728449236*r**20+14782555863992*r**22-2439065022094*r**24+2971822307524*r**26
            +4612340189452*r**28+1676345813124*r**30+359844364071*r**32+92989736840*r**34
            -9122244980*r**36-1379512646*r**38+33442623*r**40)+60*Q2**3*(3836739
            +1207102548*r**2+28506625224*r**4-107688124860*r**6+1415952621073*r**8
            -1532295862004*r**10-61183992284*r**12+20339842717980*r**14+42987643500050*r**16
            +22766322920852*r**18+14683897266548*r**20+50185872796644*r**22+44734025290038*r**24
            -23726229351580*r**26-28343863903348*r**28-4095046367020*r**30-89491790133*r**32
            -891402939992*r**34+154448721940*r**36+6419663848*r**38+649027737*r**40)
            +60*Q2**2*(46715871-1142416633*r**2-10338757796*r**4-21868493602*r**6
            -1029838391935*r**8+3699918216015*r**10-3475403239112*r**12-31595135735344*r**14
            -20921315368322*r**16+69166359538230*r**18+139749888408496*r**20+180332189589852*r**22
            +91399400220106*r**24-31669193222210*r**26-1754866037880*r**28+24580344224864*r**30
            +9130732602259*r**32+1152300880259*r**34+801821330484*r**36-93512643690*r**38
            -11237395771*r**40+138935859*r**42))+138240*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(15360*Q2**21*(2185+27597*r**4)-256*Q2**20*(2775057
            +2839298*r**2+27274329*r**4+29238252*r**6)+160*Q2**19*(37613751+74754598*r**2
            +343124834*r**4+669258222*r**6+363840123*r**8)-40*Q2**18*(682284981+2029371072*r**2
            +7016762270*r**4+17172197376*r**6+18008691357*r**8+6465482928*r**10)
            +40*Q2**17*(1794674496+7436959927*r**2+24563850665*r**4+66477532434*r**6
            +97494708374*r**8+68361693639*r**10+17646172689*r**12)-5*Q2**16*(20373773397
            +126145239442*r**2+450751585323*r**4+1326429927720*r**6+2380794275083*r**8
            +2408241468178*r**10+1245719960037*r**12+228562796964*r**14)+4*Q2**15*(7116413667
            +176940610908*r**2+724722691574*r**4+2429931718572*r**6+5008094895420*r**8
            +6221042822612*r**10+4875256042458*r**12+1982059458084*r**14+192298643217*r**16)
            +20*Q2**14*(8155551741-4691478757*r**2-14504846014*r**4-153374137404*r**6
            -390319071344*r**8-255663147970*r**10-147645011514*r**12-305392061748*r**14
            -128216597973*r**16+43082280663*r**18)-20*Q2**13*(14349255009+47322950668*r**2
            +307063051873*r**4+1013514270666*r**6+2449797819528*r**8+5398635366282*r**10
            +7709699480376*r**12+5841903464446*r**14+2109963819951*r**16+454271874978*r**18
            +124060235727*r**20)+20*Q2**12*(6898340904+73066977693*r**2+522806835252*r**4
            +2366230628943*r**6+6968103246474*r**8+16143061574066*r**10+26307237646302*r**12
            +26751686958762*r**14+15586247255886*r**16+4734124078809*r**18+839910270606*r**20
            +98472921471*r**22)+20*Q2**11*(8307783939-46033721996*r**2-210171893028*r**4
            -2306410057164*r**6-9559271198313*r**8-25286009899076*r**10-45756913431732*r**12
            -55158464259076*r**14-42965735019459*r**16-19312015316352*r**18-4264197037016*r**20
            -605659950816*r**22+28143269337*r**24)-4*Q2**10*(69047281563+48418273717*r**2
            +2583661009676*r**4-1236010015002*r**6-28321234609545*r**8-94762905541033*r**10
            -190997208352632*r**12-242603081045556*r**14-213748275675023*r**16-131590606273125*r**18
            -37536730444532*r**20+1612557271502*r**22+149167112541*r**24+572279839833*r**26)
            +20*Q2**9*(4972555419+49821705912*r**2+869853064237*r**4+2126263237590*r**6
            +4226083083861*r**8+7469634301598*r**10+7462380752727*r**12+12919175764884*r**14
            +29352772717109*r**16+35414738502732*r**18+23125227101451*r**20+12509529016246*r**22
            +5090377103355*r**24+502124505918*r**26+72966882897*r**28)+10*Q2**8*(9684514383
            -95140866664*r**2-773346379643*r**4-5677798999254*r**6-21235090780229*r**8
            -53995953492580*r**10-81263036723559*r**12-88508671264354*r**14-115815955373227*r**16
            -164514811233456*r**18-166368185586297*r**20-103439764292762*r**22-41639570937951*r**24
            -10130338792484*r**26-1025719745829*r**28+34985450994*r**30)-20*Q2**7*(5432837259
            -12109228852*r**2+336513868194*r**4-1794743713620*r**6-4230474397858*r**8
            -11790287564796*r**10-26424625704846*r**12-27465475227212*r**14-23696414753332*r**16
            -31067097351804*r**18-37706168888890*r**20-38403947718652*r**22-29763300141006*r**24
            -12177300967444*r**26-761723866138*r**28-186923760804*r**30+48192819801*r**32)
            +20*Q2**6*(966090831+18934064961*r**2+508033453058*r**4-147255011472*r**6
            +8044785916002*r**8+11342924100400*r**10-24755234931630*r**12-77484429199992*r**14
            -139990498187064*r**16-198239545327950*r**18-186508043217162*r**20-98709375957440*r**22
            -18447897148434*r**24-2017323794712*r**26-1674870062410*r**28+2535798731208*r**30
            +133898623641*r**32+20491371765*r**34)+4*Q2**5*(6665099217-103245523252*r**2
            -978172591771*r**4-4752489169158*r**6-50454088176950*r**8-31769448743102*r**10
            +237751619518482*r**12+556916894764866*r**14+954216198790188*r**16+1490900041572210*r**18
            +1859801639253868*r**20+1688182887200302*r**22+1052527074705126*r**24
            +309453599530118*r**26+9575104475390*r**28-6231696599658*r**30-10626967542957*r**32
            -1026804925446*r**34+26727562527*r**36)+9*(-1+r**2)**4*(13853187-230678554*r**2
            -1144655189*r**4-39201710312*r**6-232777314732*r**8+1303880061184*r**10
            -4267397781788*r**12-22964467053848*r**14+9352146760786*r**16+112964911174716*r**18
            +65461484122546*r**20-18996998239912*r**22+10969568635988*r**24+17538480244464*r**26
            +6039039703364*r**28+1544922097208*r**30+280771909379*r**32-20628087826*r**34
            -3601095813*r**36+98455152*r**38)-20*Q2**4*(811844418-5638893811*r**2
            +61856693270*r**4-943965362913*r**6-1536683892774*r**8+3783823854748*r**10
            +28281941567118*r**12+50056727709664*r**14+87502291715142*r**16+144486551987622*r**18
            +210307394688370*r**20+194677500698302*r**22+108408658660062*r**24+87903859377900*r**26
            +48964237688858*r**28+5766833537064*r**30-1597500779584*r**32-297015910971*r**34
            -85886009904*r**36+7631227419*r**38)-180*Q2*(-1+r**2)**2*(5753823-109211516*r**2
            -696163184*r**4-10002507026*r**6-102373698625*r**8+448938967244*r**10
            -785921157372*r**12-6068291223012*r**14-2747030137718*r**16+22515934150244*r**18
            +36274728449236*r**20+14782555863992*r**22-2439065022094*r**24+2971822307524*r**26
            +4612340189452*r**28+1676345813124*r**30+359844364071*r**32+92989736840*r**34
            -9122244980*r**36-1379512646*r**38+33442623*r**40)+60*Q2**3*(3836739
            +1207102548*r**2+28506625224*r**4-107688124860*r**6+1415952621073*r**8
            -1532295862004*r**10-61183992284*r**12+20339842717980*r**14+42987643500050*r**16
            +22766322920852*r**18+14683897266548*r**20+50185872796644*r**22+44734025290038*r**24
            -23726229351580*r**26-28343863903348*r**28-4095046367020*r**30-89491790133*r**32
            -891402939992*r**34+154448721940*r**36+6419663848*r**38+649027737*r**40)
            +60*Q2**2*(46715871-1142416633*r**2-10338757796*r**4-21868493602*r**6
            -1029838391935*r**8+3699918216015*r**10-3475403239112*r**12-31595135735344*r**14
            -20921315368322*r**16+69166359538230*r**18+139749888408496*r**20+180332189589852*r**22
            +91399400220106*r**24-31669193222210*r**26-1754866037880*r**28+24580344224864*r**30
            +9130732602259*r**32+1152300880259*r**34+801821330484*r**36-93512643690*r**38
            -11237395771*r**40+138935859*r**42))*sqrtq2)+logq2**2*(4608*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1536*Q2**24*(105523+1064031*r**4)-128*Q2**23*(18093669
            +17390464*r**2+168811893*r**4+184016118*r**6)+8*Q2**22*(1781889411+3439588734*r**2
            +17854910858*r**4+34912607558*r**6+18676656567*r**8)-2*Q2**21*(24127263381
            +73073260264*r**2+293935877686*r**4+763856996624*r**6+790746703413*r**8
            +267851905032*r**10)+2*Q2**20*(45522065409+213875614604*r**2+764815877867*r**4
            +2400186886552*r**6+3635588721247*r**8+2514315468108*r**10+565532692773*r**12)
            -Q2**19*(65326153812+707599096175*r**2+2181938395554*r**4+8436881844975*r**6
            +16631250813600*r**8+17594767863737*r**10+9251866050930*r**12+1180658671089*r**14)
            +Q2**18*(-103318819197+480689011573*r**2-20640794199*r**4+3337305212991*r**6
            +8364327584505*r**8+9927595321543*r**10+13191455489843*r**12+7528177862421*r**14
            -369415427784*r**16)+Q2**17*(300932868648+546277842547*r**2+7160548521024*r**4
            +24840597903344*r**6+68359831880196*r**8+137182597533298*r**10+131729261407392*r**12
            +48515033825024*r**14+6857974170084*r**16+2916708674331*r**18)-Q2**16*(239484128127
            +1722620713373*r**2+14665055655127*r**4+75963881749503*r**6+247088500565201*r**8
            +579114571252121*r**10+782876679709833*r**12+545637790631077*r**14+171309449695388*r**16
            +27145707642246*r**18+3447101357844*r**20)+2*Q2**15*(-67100190336+905652603794*r**2
            +4864922060227*r**4+54182084482577*r**6+212450862180737*r**8+583655696550827*r**10
            +986874085020547*r**12+971683287618997*r**14+510407515149227*r**16+115078879570087*r**18
            +15772766697198*r**20+67450792758*r**22)+2*Q2**14*(204583621734-162474549350*r**2
            +6899632246033*r**4-27984294448550*r**6-158551672779050*r**8-557783653070794*r**10
            -1148824359110060*r**12-1410913608216298*r**14-1078279715101900*r**16
            -412250320565800*r**18-26797714735941*r**20-3470598565080*r**22+1919529532848*r**24)
            -2*Q2**13*(113359047246+845255164546*r**2+18000253698677*r**4+40909431005287*r**6
            +116017112265120*r**8+186381593010734*r**10+267438944096874*r**12+627426973596878*r**14
            +709706431988958*r**16+347509368614190*r**18+219470278617481*r**20+141282089758451*r**22
            +13960024309132*r**24+1826801880762*r**26)+2*Q2**12*(-80876820336+1174908320326*r**2
            +12873262177147*r**4+95442836736392*r**6+390610837977723*r**8+1312012142517466*r**10
            +3261347147011424*r**12+6452251777299748*r**14+8459084942739258*r**16
            +6447539658264702*r**18+2834065351170799*r**20+913605826401796*r**22+201834151128347*r**24
            +18744549048882*r**26-114226128042*r**28)+2*Q2**11*(132455593164-428944133969*r**2
            +6253397202469*r**4-78725746828714*r**6-281965822809133*r**8-1757273340009956*r**10
            -5870309088714906*r**12-13246372711734879*r**14-20245782816308646*r**16
            -19733531603057137*r**18-11440397304988199*r**20-3824393035265264*r**22
            -960471017570281*r**24-60329337718474*r**26-6092141768628*r**28+1381845265833*r**30)
            -2*Q2**10*(29868608571+599468362181*r**2+17289808223358*r**4-4727595297057*r**6
            +211430248887843*r**8-893617094411789*r**10-5173770899108994*r**12-13472577467793063*r**14
            -23017580187826263*r**16-26221069725723813*r**18-19520748960970646*r**20
            -8128434280064271*r**22-1439410166685927*r**24-311754615725907*r**26+116538097706618*r**28
            +9000682466967*r**30+833914902912*r**32)-2*Q2**9*(51122748156-793373119525*r**2
            -8974639085283*r**4-60118722227625*r**6-552807259441500*r**8-690374131105406*r**10
            +148436406542135*r**12+2181360088077153*r**14+5853854624024250*r**16+6325199707458150*r**18
            +2820708658075819*r**20-841172508504855*r**22-3324472663754352*r**24-2490179929713150*r**26
            -425056800625375*r**28-131182259152769*r**30-11065605825930*r**32+219245470107*r**34)
            +2*Q2**8*(36132419739-176650064171*r**2+4171965108198*r**4-67149850286767*r**6
            -335337217065330*r**8-1764880603012759*r**10-4539472973578014*r**12-8935372082212583*r**14
            -10686217338490608*r**16-11269823759155005*r**18-16674656696423254*r**20
            -21079563404785149*r**22-18276237789601118*r**24-11025863554809933*r**26
            -3801901297282490*r**28-693805745621901*r**30-24502576624891*r**32-2641436263572*r**34
            +480415554408*r**36)+2*Q2**7*(3892644624-305636957654*r**2-6685433593183*r**4
            +23864752681647*r**6-142195761904937*r**8+1578340051886921*r**10+2492375888811219*r**12
            +4748398225908733*r**14+6793557851566883*r**16+3053811304843857*r**18
            +120855074666201*r**20+2868423028565959*r**22+8436798081172533*r**24+11481003907881563*r**26
            +7831075080940177*r**28+1330498645286079*r**30+405729635915201*r**32-43626527095583*r**34
            -3612853476318*r**36-152048783922*r**38)-2*Q2**6*(12512560926-234615371866*r**2
            -1764874762559*r**4-20021365259866*r**6-325774777841782*r**8+474171352346266*r**10
            -3498948070081294*r**12-3221941893382366*r**14+9032497766939986*r**16
            +17945789148583022*r**18+25654718055547252*r**20+30398726574232406*r**22
            +16999898526260434*r**24+2572073320703806*r**26+1323526025376062*r**28
            +2176947538206934*r**30-1363881014795096*r**32-62026408533484*r**34-33024812044901*r**36
            -3039328913652*r**38+81894149772*r**40)+2*Q2**5*(3152342139-294309186*r**2
            +1210196852567*r**4-27162786725053*r**6-159294668984263*r**8-482854149873166*r**10
            -4505277814007536*r**12+401067565508528*r**14+20422303325428178*r**16
            +30402532690048688*r**18+45463569347567798*r**20+70047028479398638*r**22
            +80843823685622518*r**24+58449002181648328*r**26+21975965253150088*r**28
            +4317641914498696*r**30+1046756178551251*r**32-1405330962190238*r**34
            -254930773580453*r**36-5597622929513*r**38-347725061967*r**40+73627043958*r**42)
            +9*(-1+r**2)**4*(-2882823+125632215*r**2+917593689*r**4-34862117925*r**6
            -158202512610*r**8-1825865042598*r**10-9869263237080*r**12+73804469261564*r**14
            -352936780973850*r**16-677347778164070*r**18+1617423417504382*r**20+2750041645727850*r**22
            -817424015394976*r**24-285870870152400*r**26+664491420536220*r**28+196199873146572*r**30
            +34510064213305*r**32+30033892941879*r**34+158513565425*r**36-467982385165*r**38
            -9904651158*r**40+835253710*r**42+19337844*r**44)-2*Q2**4*(-1640383539
            +64665461150*r**2+821930091222*r**4-9173783353100*r**6+21673168218150*r**8
            -625935936854694*r**10-221059752148185*r**12+3217388358067092*r**14+10757504078131650*r**16
            +6847590086715600*r**18+19185617767375316*r**20+42260054140737180*r**22
            +36741610311677092*r**24+28071504282003000*r**26+28416238796650350*r**28
            +17280945758935356*r**30+5289811483056345*r**32+351137675274402*r**34
            -165545982934050*r**36-137234218261600*r**38+3668090260686*r**40+613181788510*r**42
            +10989092067*r**44)+3*Q2**3*(-637856844+14692179251*r**2+21503608112*r**4
            +2564863262657*r**6+35962179868590*r**8-179494751488269*r**10+1595207446304286*r**12
            -2111559086718183*r**14+701446009093472*r**16+12259903538050230*r**18
            +21722794130797896*r**20+14402625921413586*r**22+27522187189757252*r**24
            +30879643106605742*r**26-8373267656671980*r**28-14318673362611734*r**30
            -2276803531021284*r**32+702681535665847*r**34-1139929926759528*r**36+197997618406285*r**38
            +4889569103326*r**40+1823495742911*r**42+205588588222*r**44-6040119843*r**46)
            -9*Q2*(-1+r**2)**2*(-15568032+808490813*r**2+7848472456*r**4-303966298659*r**6
            -1315820290730*r**8-8481324242107*r**10-93124714085982*r**12+510594494143601*r**14
            -1399296579212344*r**16-4490303512726710*r**18+3251630095873288*r**20
            +17074169490477018*r**22+10244580077908836*r**24-4156273379621214*r**26
            +159972842102860*r**28+3389152986051498*r**30+960764421226408*r**32+146069670754201*r**34
            +184752255192096*r**36-3376123682295*r**38-3389716336522*r**40-76775552007*r**42
            +4035095906*r**44+239427621*r**46)+3*Q2**2*(23588121+2760774079*r**2
            +66461800353*r**4-2909328545587*r**6-14420914003393*r**8+6559617313101*r**10
            -1038569064013001*r**12+4265408190078663*r**14-6727653870233822*r**16
            -22489428570103658*r**18+1172818127049946*r**20+54093927516587554*r**22
            +78513415359397518*r**24+52906122155942138*r**26-22770172839222818*r**28
            -5149275351329554*r**30+15662166313052829*r**32+5165122618281563*r**34
            -263015320544587*r**36+1360659827281057*r**38-71031466460989*r**40-24448766462711*r**42
            -785459350597*r**44-17401032517*r**46+3405756312*r**48))-4608*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1536*Q2**25*(105523+1064031*r**4)-640*Q2**24*(3871989
            +3731348*r**2+36316053*r**4+39356898*r**6)+8*Q2**23*(2071388115+4007334862*r**2
            +20834148570*r**4+40557855734*r**6+21620914455*r**8)-2*Q2**22*(31254821025
            +93959172844*r**2+379113876054*r**4+974927070288*r**6+1005103759913*r**8
            +342558531300*r**10)+2*Q2**21*(69649328790+311076138249*r**2+1131825015817*r**4
            +3457979760862*r**6+5190192421284*r**8+3572914076553*r**10+833384597805*r**12)
            -Q2**20*(156370284630+1226394456201*r**2+4139321380496*r**4+14766887373813*r**6
            +28702802029198*r**8+29894576242447*r**10+15411562372692*r**12+2311724056635*r**14)
            +5*Q2**19*(-7598533077+250722852312*r**2+573779339506*r**4+2791225090704*r**6
            +6686492048616*r**8+8830722799776*r**10+8007617880902*r**12+3592140516888*r**14
            +162248648661*r**16)+Q2**18*(404251687845+168907650171*r**2+6700500303650*r**4
            +21523933484552*r**6+56658199082700*r**8+118890674627250*r**10+108610210596006*r**12
            +27795400472760*r**14-300788264553*r**16+3286124102115*r**18)-Q2**17*(540416996775
            +2569831424568*r**2+22371882018698*r**4+107965028173871*r**6+340288930348741*r**8
            +784657000665615*r**10+1051788538650523*r**12+725882085863493*r**14+226682457690496*r**16
            +36920390486661*r**18+6363810032175*r**20)+Q2**16*(105283747455+3773410049088*r**2
            +26117520488954*r**4+198993106369784*r**6+747954106676178*r**8+1993514464918976*r**10
            +3335739421003048*r**12+3271881045578904*r**14+1737762270624919*r**16
            +428612916477808*r**18+62138342394486*r**20+3582002943360*r**22)+4*Q2**15*(135841906035
            -500513481404*r**2+564528791006*r**4-43515650495677*r**6-212592309721182*r**8
            -676945105901179*r**10-1359677070340717*r**12-1684735490427921*r**14-1280185258935062*r**16
            -518868357642557*r**18-78824680501613*r**20-9655408027518*r**22+926039370045*r**24)
            -20*Q2**14*(31794266898+88736423693*r**2+2473741139536*r**4+1982476880277*r**6
            -7051885496248*r**8-52995373283911*r**10-143916906808398*r**12-193231099372948*r**14
            -177948689132924*r**16-114302066705351*r**18-21957775668426*r**20+11101377645743*r**22
            +1240895527690*r**24+374633141361*r**26)+4*Q2**13*(16241113455+1066761266059*r**2
            +15859385520185*r**4+77176260720178*r**6+273768690624065*r**8+807205423896660*r**10
            +1857583842059516*r**12+3673558847496750*r**14+4898109174162547*r**16
            +3752377729433925*r**18+1700522499201235*r**20+637179097388864*r**22+178538132597965*r**24
            +17265687619388*r**26+856287876360*r**28)+2*Q2**12*(213332413500-1522975633959*r**2
            -7794773295004*r**4-187041845742253*r**6-768019497523248*r**8-3459896320505145*r**10
            -10443668378243796*r**12-22959971636046051*r**14-35157119536347652*r**16
            -34640156204061097*r**18-20722002314423700*r**20-7572064212837859*r**22
            -2075910995100424*r**24-280908037895703*r**26-24722464689468*r**28+1496071393875*r**30)
            +2*Q2**11*(-162324201735-302979821376*r**2-23114261291858*r**4+77199944923302*r**6
            +149261320750004*r**8+2932856257230878*r**10+12801353327833856*r**12+32589259268242848*r**14
            +56509735715869788*r**16+66200384145089596*r**18+50694677869015982*r**20
            +23393224620317734*r**22+6224274219521472*r**24+1332554971014662*r**26
            -50116618219516*r**28-4290385964172*r**30-2215760168745*r**32)+2*Q2**10*(
            -21254139585+1422710090277*r**2+26863915670822*r**4+72680935153926*r**6
            +759509913032286*r**8+8187285581460*r**10-6215824400062918*r**12-20827708454979210*r**14
            -42344012279643576*r**16-55563849621008226*r**18-48562527344770278*r**20
            -26808010732530062*r**22-6243371782995846*r**24+739015147301316*r**26
            +229840282606086*r**28+256721039326354*r**30+20900203195809*r**32+614669432805*r**34)
            +10*Q2**9*(17451033579-183780087108*r**2-1119209419322*r**4-27248642319935*r**6
            -189652639746891*r**8-601612398711933*r**10-1016282139628257*r**12-1321115117518659*r**14
            -530200525277841*r**16+181846114465479*r**18-1505749666177857*r**20-3820005451042837*r**22
            -4488376592372065*r**24-3368103229655487*r**26-1343427605524203*r**28
            -250008961080009*r**30-33350088320718*r**32-2697559323879*r**34+139932204903*r**36)
            +2*Q2**8*(-32239775115-165119313222*r**2-10680748637210*r**4+86842637860216*r**6
            +260291305447160*r**8+3678557871965010*r**10+8796729465401992*r**12+18223243281699330*r**14
            +26415147272270074*r**16+25009852402489470*r**18+28065335530244460*r**20
            +40622643129774362*r**22+47792599275558800*r**24+40783105252292614*r**26
            +22658839933032600*r**28+5826205688190470*r**30+1124037958161993*r**32
            -16482514207120*r**34-1451832767154*r**36-632464338330*r**38)+4*Q2**7*(
            -8202602775+268179842448*r**2+4377972656698*r**4+1421023085701*r**6+222052893532536*r**8
            -955157821164125*r**10-285883935308423*r**12-2009416110668793*r**14-10287226922207801*r**16
            -13896579152496881*r**18-14414692217528655*r**20-16694002338732283*r**22
            -14152559817999463*r**24-11244937654878951*r**26-10317802507098901*r**28
            -5669260632216595*r**30-186173633203092*r**32-150038350143067*r**34+40132096308401*r**36
            +3402115586946*r**38+35077317075*r**40)+2*Q2**6*(15664903065-222397120126*r**2
            -789293281858*r**4-48949026747478*r**6-505090812085911*r**8-334457575368682*r**10
            -7530054531742564*r**12-6319822397955132*r**14+26232859198985798*r**16
            +57380819605571696*r**18+89064076551698072*r**20+126100473109178296*r**22
            +128242448786115358*r**24+78020974028612568*r**26+25871564599229956*r**28
            +7818115478081692*r**30+1859822701963089*r**32-2831238385518818*r**34
            -349981994158838*r**36-41661763888066*r**38-3305159825847*r**40+155521193730*r**42)
            -2*Q2**5*(1511958600+67523494103*r**2+2031832634603*r**4-35126373225586*r**6
            -164784287491166*r**8-1268084755712123*r**10-5209191716028887*r**12-886821890431916*r**14
            +31580874969068356*r**16+57672426102192466*r**18+95051719804991802*r**20
            +157770651967703616*r**22+187632462476698248*r**24+167364330149273846*r**26
            +108841206231448766*r**28+43574552926584140*r**30+10654209576106292*r**32
            -7437108364585*r**34-1825807718704741*r**36-397762614771566*r**38-2277257730794*r**40
            +339083770501*r**42+84616136025*r**44)-9*(-1+r**2)**4*(-2882823+122749392*r**2
            +1043225904*r**4-33944524236*r**6-193064630535*r**8-1984067555208*r**10
            -11695128279678*r**12+63935206024484*r**14-279132311712286*r**16-1030284559137920*r**18
            +940075639340312*r**20+4367465063232232*r**22+1932617630332874*r**24-1103294885547376*r**26
            +378620550383820*r**28+860691293682792*r**30+230709937359877*r**32+64543957155184*r**34
            +30192406507304*r**36-309468819740*r**38-477887036323*r**40-9069397448*r**42
            +854591554*r**44+19337844*r**46)+5*Q2**4*(-1038867522+34025338595*r**2
            +367540385816*r**4-1801823347157*r**6+26577061867174*r**8-349401958347579*r**10
            +618326192181420*r**12-68404009663347*r**14+6010824579935580*r**16+14397979788769038*r**18
            +23446959620115104*r**20+33219844316093150*r**22+48113978094820060*r**24
            +44453031701435482*r**26+17571136637458152*r**28+9687669804667242*r**30
            +7662220778183910*r**32+2677988584731807*r**34-609721279119576*r**36-2313509434489*r**38
            -50492709738370*r**40+2806606265425*r**42+373021505164*r**44+771564921*r**46)
            +9*Q2*(-1+r**2)**2*(-18450855+924320642*r**2+9320409705*r**4-332689499291*r**6
            -1707347272460*r**8-11341466668140*r**10-107981773992583*r**12+509186910750745*r**14
            -1399117067802801*r**16-5787269838893860*r**18+1380508776005250*r**20
            +19163646618905322*r**22+22618665679039560*r**24+10187325504653024*r**26
            -3577491392072310*r**28+2130471990076090*r**30+4656519145734287*r**32
            +1264047729642450*r**34+305422717841269*r**36+210625014935665*r**38-5681266334220*r**40
            -3913829717668*r**42-84296276835*r**44+5071101549*r**46+258765465*r**48)
            +3*Q2**3*(661444965-11293548328*r**2+30266012990*r**4-5495695416356*r**6
            -52947957134640*r**8+150092188932780*r**10-2454281758829018*r**12+4781759830492560*r**14
            -5317540792609111*r**16-35450778117247360*r**18-32809879541798180*r**20
            +17968507464376072*r**22+36588602248226680*r**24-5495708140420856*r**26
            -45276548289156580*r**28+17542665667954160*r**30+32257643206685847*r**32
            +6739244613637000*r**34+174233070549094*r**36+2302592135634300*r**38-273918653970600*r**40
            -31161831308948*r**42-2814543681730*r**44-216949500896*r**46+9445876155*r**48)
            -3*Q2**2*(-23115975+5303242831*r**2+87870342826*r**4-3799431003508*r**6
            -19430360211848*r**8-26322246568210*r**10-1264443104377394*r**12+5291926920286036*r**14
            -10003076524911743*r**16-32760430020812743*r**18+11182211183289380*r**20
            +73508563001648696*r**22+70650956454469336*r**24+108705745380454052*r**26
            +86287248354481692*r**28-31180646423878680*r**30-6459815164597909*r**32
            +25668370374393041*r**34+7462239302467282*r**36+417211616799612*r**38
            +1853972719480560*r**40-85500632607474*r**42-34930616223114*r**44-1056679331708*r**46
            -3326554213*r**48+4124039175*r**50))*sqrtq2)+logq2*(-192*(Q2-(-1+r)**2)**4*r**4*(1
            -Q2+r**2)*(Q2-(1+r)**2)**4*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*(-37248*Q2**23*(147+1343*r**4)+16*Q2**22*(4260501+2360483*r**2
            +39041025*r**4+46770219*r**6)-4*Q2**21*(92116521+103231147*r**2+729686051*r**4
            +2186708509*r**6+1199498364*r**8)+4*Q2**20*(272926521+492045995*r**2
            +1334559560*r**4+9009248096*r**6+12576175127*r**8+4237924029*r**10)-Q2**19*(1737749475
            +5216682005*r**2-6831674264*r**4+47956806290*r**6+139119588955*r**8+149391284097*r**10
            +33962213250*r**12)+Q2**18*(691699239+7759454230*r**2-69597066495*r**4
            -149006451704*r**6-247999712695*r**8-29170107354*r**10+209447169663*r**12
            +29333481516*r**14)+Q2**17*(2859863391-4029128807*r**2+221737521279*r**4
            +934968757131*r**6+2757191588703*r**8+3987098093007*r**10+1888427314473*r**12
            +45534630333*r**14+27128366154*r**16)-Q2**16*(5841864819+8248336178*r**2
            +409700506120*r**4+2491614641678*r**6+8840829117426*r**8+18475470626054*r**10
            +17977410078888*r**12+6614435985250*r**14+696503085003*r**16+102190071096*r**18)
            +4*Q2**15*(824467581+5286183895*r**2+84687027681*r**4+951549437917*r**6
            +3707309461389*r**8+10046500000927*r**10+14354604906341*r**12+10149138202391*r**14
            +2618325819522*r**16+281215051974*r**18+23014976094*r**20)+4*Q2**14*(977421375
            -5210261990*r**2+89948197152*r**4-640748638770*r**6-2424460949720*r**8
            -9407643592702*r**10-17982750369810*r**12-19740867852706*r**14-11025667011695*r**16
            -1185052251180*r**18-131710887846*r**20+9369701700*r**22)-4*Q2**13*(1911637539
            -490898415*r**2+343950997414*r**4+445109205872*r**6+3040834466410*r**8
            +6975408660164*r**10+14539346245562*r**12+19257246505250*r**14+7122224720589*r**16
            +1119117756715*r**18+2917198111088*r**20+189001845966*r**22+37151430966*r**24)
            +4*Q2**12*(789336639+5619337932*r**2+369020886247*r**4+1361399997852*r**6
            +8307394976144*r**8+35982108907082*r**10+98027402391338*r**12+172612370610412*r**14
            +163835204130371*r**16+74421852584028*r**18+21144334307647*r**20+5705327244712*r**22
            +329948752094*r**24+23997284766*r**26)+2*Q2**11*(1818914643-14664453219*r**2
            -20620765958*r**4-2419111508000*r**6-11504683098833*r**8-112139477618203*r**10
            -374659954603026*r**12-779576985333152*r**14-977545850250975*r**16-684974481331977*r**18
            -237768414757722*r**20-59436823596304*r**22-6494841750803*r**24-289847362025*r**26
            +25724640162*r**28)-2*Q2**10*(2384638263-5178788290*r**2+761599757731*r**4
            -857331003796*r**6+12457984559263*r**8-80898629073618*r**10-349894955210061*r**12
            -842449694922876*r**14-1255372990354699*r**16-1163388580294198*r**18-582655597226311*r**20
            -101150916635516*r**22-30759864656779*r**24+4431356359594*r**26+228507820593*r**28
            +53884212012*r**30)+2*Q2**9*(470999025+7148028655*r**2+714239080371*r**4
            +406243466515*r**6+35604739995275*r**8+20682490607751*r**10-36582745838565*r**12
            -222768786230949*r**14-473508218972635*r**16-434590597799155*r**18-230135594132663*r**20
            +112363098227145*r**22+196061637935833*r**24+18863282763965*r**26+9357417457065*r**28
            +358559966217*r**30+18891994950*r**32)+2*Q2**8*(910518147-9727697630*r**2
            -34608729786*r**4-1308771190206*r**6-30278064496530*r**8-104499449552958*r**10
            -226321906772154*r**12-377472081253422*r**14-325082759549276*r**16-396552788968170*r**18
            -624503612820574*r**20-638623123245658*r**22-620762612765790*r**24-313027523886858*r**26
            -43759061233710*r**28-4768103468730*r**30-152821061943*r**32+17382685968*r**34)
            -4*Q2**7*(337537431-1520703107*r**2+190119390197*r**4-818563924475*r**6
            +1739036658459*r**8-51577810839887*r**10-37494830855673*r**12-128053323631511*r**14
            -128206405215763*r**16-28033810043841*r**18-35927549179363*r**20-80055715247313*r**22
            -164615058821335*r**24-241334397008661*r**26-51807455302163*r**28-14421069392541*r**30
            +868917282488*r**32+24553848744*r**34+8757006714*r**36)+4*Q2**6*(-1217601
            +1419834878*r**2+124280765502*r**4-385782310018*r**6+14789605912446*r**8
            -29851569153934*r**10+130805978843062*r**12-22254868732522*r**14-259993881043172*r**16
            -202003361068786*r**18-350838199263734*r**20-385772347216718*r**22+21333253303218*r**24
            +29089597447638*r**26-148914958168846*r**28+70044376496674*r**30-221726144267*r**32
            +1770257749932*r**34+47822998032*r**36+908366616*r**38)+4*Q2**5*(101185686
            -1495646830*r**2+734489823*r**4-209141291181*r**6-11551571966512*r**8
            +12170026483030*r**10-157851006890514*r**12+135180408655802*r**14+484735548794326*r**16
            +311263175596362*r**18+733416507009556*r**20+996683580163848*r**22+1210968155040042*r**24
            +375541794073186*r**26+38106528738962*r**28+165681721340214*r**30-73915675897604*r**32
            -6089047302292*r**34-831907010931*r**36-24700768587*r**38+2337907614*r**40)
            +3*(-1+r**2)**4*(380583-6436858*r**2+295912722*r**4-6301307522*r**6
            -103015449265*r**8+686213017808*r**10-7464460526648*r**12+34540767458664*r**14
            -109649215813394*r**16-17527026571580*r**18+339420619864188*r**20+20860378321812*r**22
            -170988383849194*r**24+80276915087704*r**26+51337555141480*r**28-15957602137432*r**30
            +9722042175627*r**32-382233252442*r**34-47488847038*r**36-4286239010*r**38
            -133835397*r**40+11385192*r**42)-4*Q2**4*(40153050-343131445*r**2+33975568091*r**4
            -321967463960*r**6-1041252341665*r**8-5251937888357*r**10-28303647674480*r**12
            +124423087550732*r**14+235102832082060*r**16-102726622251350*r**18+581593467750046*r**20
            +711941099963020*r**22+137442758977838*r**24+593034835657810*r**26+319908410558120*r**28
            +56649954560804*r**30+70609104657730*r**32-12168337670661*r**34-3962260772785*r**36
            +55822429020*r**38-1288810293*r**40+1153728675*r**42)+Q2**3*(-23166171
            +949562995*r**2+52928265412*r**4-374836165646*r**6+14809740670645*r**8
            -71177872690049*r**10+375999087511918*r**12-657474006297272*r**14+648626744763818*r**16
            +1359553564529910*r**18+1637333212842608*r**20+783622743432316*r**22+3808389033959634*r**24
            +176427285819302*r**26-2008626898816780*r**28-408906855876760*r**30+504140686809809*r**32
            -389242392811625*r**34+71930593833276*r**36-2762645925150*r**38+986308961497*r**40
            +24770490587*r**42-310424274*r**44)-3*Q2*(-1+r**2)**2*(3582243-66062453*r**2
            +1691890482*r**4-38681573220*r**6-919073572635*r**8+5684380552293*r**10
            -49807975708918*r**12+193010987780832*r**14-431432885999010*r**16-478874398965490*r**18
            +1231109882607028*r**20+1435384719736632*r**22-236427516941398*r**24-635418709406070*r**26
            +487090624529460*r**28+243957343178368*r**30-105588848023473*r**32+64383666301047*r**34
            -4045878678950*r**36-309513265460*r**38-41351667807*r**40-1345649663*r**42
            +101196162*r**44)+Q2**2*(35840511-769756202*r**2+1995650621*r**4-165593175568*r**6
            -9763170593443*r**8+60042126775142*r**10-413081449063017*r**12+1385642222892300*r**14
            -2386480972441930*r**16-1994682976795956*r**18+2716383301751458*r**20
            +5697352817374768*r**22+6496147235898554*r**24-931890988642852*r**26-3511672573927634*r**28
            +2108730355838664*r**30+1623121701724923*r**32-990526213743842*r**34+505672292897841*r**36
            -46728671278592*r**38-1286471480775*r**40-496077566722*r**42-16146930133*r**44
            +923791884*r**46))+192*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(297984*Q2**27*(147
            +1343*r**4)-256*Q2**26*(2279970+1329961*r**2+20888358*r**4+24752955*r**6)
            +16*Q2**25*(211661037+253493614*r**2+1724901618*r**4+4980348734*r**6
            +2704502733*r**8)-4*Q2**24*(2704827195+5316964632*r**2+15320992466*r**4
            +91834007168*r**6+124006560707*r**8+40952796600*r**10)+4*Q2**23*(4694149530
            +15726354683*r**2-6366289365*r**4+158019946138*r**6+427982435076*r**8
            +408753223387*r**10+88669681575*r**12)-Q2**22*(9155003445+107333632028*r**2
            -611060716405*r**4-1114440431998*r**6-831522626021*r**8+1716977414928*r**10
            +2743359991381*r**12+341592462210*r**14)-2*Q2**21*(16185489390-37117388361*r**2
            +1094102498467*r**4+4747196838491*r**6+12825205021331*r**8+17473618141469*r**10
            +7179281983457*r**12-281294800335*r**14+142944579675*r**16)+Q2**20*(73533987135
            +108986029572*r**2+4428225183508*r**4+28099679211624*r**6+96669881636538*r**8
            +200959389718216*r**10+191856764890388*r**12+67187228878760*r**14+7376606830431*r**16
            +1263785053860*r**18)-4*Q2**19*(11029705470+89875159947*r**2+1074337146641*r**4
            +11848667926243*r**6+46338955124597*r**8+128795750814145*r**10+186684816070347*r**12
            +128778134032601*r**14+32278081675873*r**16+3740955949752*r**18+312006243600*r**20)
            +Q2**18*(-59740133355+404007885072*r**2-3225443168975*r**4+36950988757862*r**6
            +153355318692854*r**8+610983453694568*r**10+1244154702627022*r**12+1354136053828860*r**14
            +704414844310037*r**16+87374370391304*r**18+9424344650913*r**20-540127164450*r**22)
            +2*Q2**17*(60285648150-14322879869*r**2+8233648442975*r**4+12063505348359*r**6
            +67098732077753*r**8+114856466558814*r**10+130791587518158*r**12+85284243211822*r**14
            -149981856112816*r**16-70337232693377*r**18+62786299557011*r**20+5016215950827*r**22
            +1160400941985*r**24)-Q2**16*(43784841555+548524015928*r**2+19812324534614*r**4
            +96320909816312*r**6+525441139155777*r**8+2236152873344488*r**10+5922171845797604*r**12
            +10396658909186480*r**14+9647938013162517*r**16+4194144206108392*r**18
            +1256468082525958*r**20+330898462703704*r**22+23192591804695*r**24+1515411031800*r**26)
            -8*Q2**15*(10268715870-88716438459*r**2-36937279111*r**4-13154084960748*r**6
            -66477026287626*r**8-518484543385755*r**10-1728534232852231*r**12-3789630392553808*r**14
            -4922929466595886*r**16-3432725948837833*r**18-1170986550826157*r**20
            -285879868031316*r**22-28944015735990*r**24-1607809152977*r**26+146065808715*r**28)
            +2*Q2**14*(48465518535-71584192484*r**2+12544518964013*r**4-17717172239026*r**6
            +95396760999391*r**8-1710278917622680*r**10-7537266363407731*r**12-20475055411380238*r**14
            -34023251486551899*r**16-33295707326034596*r**18-17106867574222745*r**20
            -3562170533387134*r**22-734741775697227*r**24+70756958567104*r**26+4761833803871*r**28
            +1113798539550*r**30)-4*Q2**13*(497126070+144528467027*r**2+5937759199135*r**4
            +14563419906087*r**6+295315765083059*r**8+269378272963023*r**10-453531816815517*r**12
            -3551162565814845*r**14-8443551532016717*r**16-10325019891102319*r**18
            -7932379271336283*r**20-1542353605146163*r**22+1312372726369105*r**24
            +224216593560237*r**26+91190206231609*r**28+4654092807913*r**30+134664042675*r**32)
            +2*Q2**12*(-30872383605+308781362316*r**2-1690624289000*r**4+58026746286104*r**6
            +627204823766228*r**8+2984931135191552*r**10+8182361873534936*r**12+21459017803904664*r**14
            +44234471868335386*r**16+72227114476831032*r**18+71510133227224040*r**20
            +41073775148318344*r**22+21154412296575524*r**24+7737610902339104*r**26
            +1265026508945768*r**28+93003677099336*r**30+4127480522787*r**32-605164636260*r**34)
            +8*Q2**11*(4192097490-2699739111*r**2+2514031291447*r**4-11557467513309*r**6
            +6782399484741*r**8-786324587474081*r**10-2172333262704355*r**12-10346723925746441*r**14
            -28723693499036611*r**16-54677050708477051*r**18-67894137850797969*r**20
            -50014293801786911*r**22-22073365263281577*r**24-8054371224757299*r**26
            -1246745623679369*r**28-218903015557531*r**30+15728416903157*r**32+693562539990*r**34
            +119628397350*r**36)+2*Q2**10*(7408502325-197660248344*r**2-4906754889971*r**4
            -4802822459218*r**6-670115835923216*r**8+1063272172139552*r**10-1593872849327784*r**12
            +34245223964844512*r**14+131164788385313754*r**16+280346993131344832*r**18
            +407509062558146866*r**20+383388348612762860*r**22+206034674690037480*r**24
            +61420798964047552*r**26+20177611525454240*r**28-2259156037210992*r**30
            -185687393976551*r**32-100897068017800*r**34-4365890258487*r**36+89523493110*r**38)
            -4*Q2**9*(5253046470-61999524603*r**2+1410621138601*r**4-22601109154927*r**6
            -257345155610353*r**8-592021472118340*r**10-5751175410806372*r**12+756847512493164*r**14
            +23013175275174872*r**16+57047178762704598*r**18+99217504356969630*r**20
            +103735028526202878*r**22+69110476506858954*r**24+4353206925861292*r**26
            -16236307286616532*r**28-1664883477319460*r**30-2505817650717078*r**32
            -365647335678019*r**34-14362035388687*r**36-759300629463*r**38+128055762975*r**40)
            +2*Q2**8*(1335672135+30893165536*r**2+3438021504610*r**4-31536466076424*r**6
            +106624801497847*r**8-2255609555660256*r**10-9578458810738776*r**12-33568125400076240*r**14
            -62431169069914426*r**16-104182279432476272*r**18-96114561852693844*r**20
            -116903399828213536*r**22-180214640190548370*r**24-189158656731804976*r**26
            -178011002065482072*r**28-90237382638721584*r**30-20850056339514349*r**32
            -1974596923953200*r**34-426596805415774*r**36+29308414072872*r**38+1090084133499*r**40
            +64301480400*r**42)+4*Q2**7*(1489825890-33488543297*r**2-119428345945*r**4
            -3430886005578*r**6-167469141756816*r**8+852817939341055*r**10-1017247289596117*r**12
            +21003228651878248*r**14+20394266876723628*r**16+32240931114816206*r**18
            +29640772654657358*r**20-5064832590425244*r**22-11918412778346456*r**24
            +20846595896407878*r**26+68543732552286446*r**28+74528502108847144*r**30
            +19689738489411842*r**32+9862191685703763*r**34-496954155523253*r**36
            -34652657871786*r**38-12708559349672*r**40-633802236709*r**42+32456021415*r**44)
            +Q2**6*(-2772789705+36633429252*r**2-2041098778959*r**4+37885825369958*r**6
            +214045371136373*r**8+2934419128512*r**10+18228036875955523*r**12-46272942994839314*r**14
            +147017252487102662*r**16+67251207629413592*r**18-258101593492396982*r**20
            -246499954108276916*r**22-315784025683446070*r**24-210421485962415408*r**26
            +174346506868822182*r**28+3825369275570828*r**30-151093995512202445*r**32
            +73361569014734788*r**34-7167683415766187*r**36+2266267491814478*r**38
            +423412629790097*r**40+4287328496336*r**42+529455066055*r**44-80822998650*r**46)
            -2*Q2**5*(278848710-12663797101*r**2-361317523249*r**4+6109504718023*r**6
            -72350748262649*r**8+1102034209573021*r**10+4861452315554705*r**12+1163371751900865*r**14
            +94120838113621767*r**16-70643166690475090*r**18-333194354038350010*r**20
            -262406418528964906*r**22-466615840986678138*r**24-706625991601286006*r**26
            -760431682516163918*r**28-230560894773534158*r**30-46189286569805724*r**32
            -86817794139861873*r**34+34199590335402619*r**36+8190007335474227*r**38
            +306162832117187*r**40+93992277051401*r**42-5749735942355*r**44-275859550403*r**46
            +3743933055*r**48)-9*(-1+r**2)**4*(380583-11765020*r**2+350253932*r**4
            -9844349140*r**6-42522443230*r**8+2716602999620*r**10-7299476327020*r**12
            +75975106139972*r**14+98729331571645*r**16-1624081485907600*r**18+10400790073377400*r**20
            -1513858013202120*r**22-32232842791399508*r**24-4256176977944120*r**26
            +15047744149096680*r**28-5866015640151800*r**30-5887466906276495*r**32
            +725074920314372*r**34-633824202756260*r**36-115475709247140*r**38+19597132842130*r**40
            +687402153780*r**42+24939633732*r**44-3482751500*r**46-293228085*r**48
            +11385192*r**50)+Q2**4*(717857595-18282877628*r**2+262990076556*r**4
            -6430201295512*r**6-99373520943978*r**8+1432820158863480*r**10-2889208077400388*r**12
            +28661743561079336*r**14+363967917735653*r**16-191093323290367108*r**18
            -232139600956349160*r**20+121759735011582032*r**22-607237728111746444*r**24
            -727194713324227312*r**26-239251752883085608*r**28-818392049585084400*r**30
            -533199139811626763*r**32-110053261461115844*r**34-71746454448565412*r**36
            -12180024670117048*r**38+12716850011959510*r**40-62740775989128*r**42
            -15787400083604*r**44-5069910356792*r**46-374034918133*r**48+18844196100*r**50)
            +18*Q2*(-1+r**2)**2*(1600830-52414709*r**2+947937555*r**4-22993736290*r**6
            -259005553794*r**8+10105146371136*r**10-12376134777964*r**12+115079943097850*r**14
            +1053273931876040*r**16-6801327741703189*r**18+22987193081244031*r**20
            +20910664141891436*r**22-67331932124654180*r**24-78355354947955080*r**26
            +9983328223566656*r**28+29801532491643316*r**30-22344164912310034*r**32
            -13963626273739535*r**34+3374319402601825*r**36-2322503893665194*r**38
            -237455259012794*r**40+68313133894536*r**42+2005685622060*r**44+193860774130*r**46
            -14807627604*r**48-1240276519*r**50+44905485*r**52)-12*Q2**3*(8771490
            -89203811*r**2+15658387135*r**4-408122060711*r**6+476541925343*r**8-6967500655249*r**10
            -341990336835451*r**12+1919694691783455*r**14-10755103772144181*r**16
            +15666368206997478*r**18-3317195339863054*r**20-41194768384156406*r**22
            -67685390058979850*r**24-71845968225692466*r**26-106292670768240742*r**28
            +3226770474885806*r**30+54789030154105384*r**32+2654719106053545*r**34
            -11338241920553181*r**36+9703575741343053*r**38-2081025333009029*r**40
            +79529674991059*r**42-7984956055535*r**44-3958202894461*r**46+25250729243*r**48
            -1763739964*r**50+310511100*r**52)-3*Q2**2*(22429701-877153024*r**2-664026471*r**4
            +115980082454*r**6-5916653111302*r**8+153181315438008*r**10+150311190932738*r**12
            -1544737619847932*r**14+28849864995695859*r**16-118996610475921272*r**18
            +225557080852009503*r**20+275501536955393218*r**22-302241451730847732*r**24
            -774475442610992976*r**26-703996200718154372*r**28+150124093560624408*r**30
            +333366838523296283*r**32-233560832819933552*r**34-153761095379920441*r**36
            +77317203247513018*r**38-39839396332365862*r**40-254850974360552*r**42
            +872271112684258*r**44+21233403517604*r**46+6736355447053*r**48-263585722008*r**50
            -19818013663*r**52+540507054*r**54))*sqrtq2))/(3402000*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2
            +3402000*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2
            +logq2**7*(-27427457433600000*r**32*(1+r**2)**2*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3-27427457433600000*r**32*(1+r**2)**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**6*(152374763520000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))+152374763520000*r**28*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))*sqrtq2)+logq2*(-204120000*(-Q2
            +(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(9+8*Q2**4-78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)
            -Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-204120000*(-Q2+(-1
            +r)**2)**3*r**8*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(9+8*Q2**4
            -78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)-Q2**2*(13+10*r**2
            +13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2)+logq2**2*(2449440000*(-Q2+(-1+r)**2)**3*r**12*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1
            +r**2)-Q2**6*(531+550*r**2+531*r**4)-2*Q2**5*(19+473*r**2+473*r**4
            +19*r**6)+Q2**4*(815-2120*r**2-11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1
            +225*r**2+494*r**4+494*r**6+225*r**8+r**10)+Q2**2*(-501+4554*r**2
            +26793*r**4+31188*r**6+26793*r**8+4554*r**10-501*r**12)-54*Q2*(1+15*r**2
            -311*r**4-1385*r**6-1385*r**8-311*r**10+15*r**12+r**14)+9*(17-316*r**2
            -184*r**4+13388*r**6+34670*r**8+13388*r**10-184*r**12-316*r**14+17*r**16))
            +2449440000*(-Q2+(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531+550*r**2
            +531*r**4)-2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815-2120*r**2
            -11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4+494*r**6
            +225*r**8+r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6+26793*r**8
            +4554*r**10-501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6-1385*r**8
            -311*r**10+15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6+34670*r**8
            +13388*r**10-184*r**12-316*r**14+17*r**16))*sqrtq2)+logq2**3*(-29393280000*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8+256*Q2**7*(1+r**2)
            -Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2+893*r**4+319*r**6)
            +Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)+12*Q2**3*(61
            +235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(-1071+9654*r**2
            +51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)-18*Q2*(23
            -35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12+23*r**14)
            +9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10-264*r**12
            -756*r**14+47*r**16))-29393280000*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8
            +256*Q2**7*(1+r**2)-Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2
            +893*r**4+319*r**6)+Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)
            +12*Q2**3*(61+235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(
            -1071+9654*r**2+51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)
            -18*Q2*(23-35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12
            +23*r**14)+9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10
            -264*r**12-756*r**14+47*r**16))*sqrtq2)+logq2**4*(352719360000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513+770*r**2
            +513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105-3400*r**2
            -11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4-1178*r**6
            +75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6+19593*r**8
            +3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6-5785*r**8
            -2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4+25204*r**6
            +52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))+352719360000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513
            +770*r**2+513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105
            -3400*r**2-11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4
            -1178*r**6+75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6
            +19593*r**8+3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6
            -5785*r**8-2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4
            +25204*r**6+52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))*sqrtq2)
            +logq2**5*(-846526464000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(64*Q2**8+1088*Q2**7*(1+r**2)+Q2**6*(-63+130*r**2-63*r**4)
            -2*Q2**5*(2777+6379*r**2+6379*r**4+2777*r**6)+Q2**4*(1555-8080*r**2
            -22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743-315*r**2-6548*r**4-6548*r**6
            -315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2+199629*r**4+305844*r**6
            +199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83-375*r**2-2833*r**4
            -5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)+9*(301-4028*r**2
            +808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12-4028*r**14+301*r**16))
            -846526464000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(64*Q2**8+1088*Q2**7*(1
            +r**2)+Q2**6*(-63+130*r**2-63*r**4)-2*Q2**5*(2777+6379*r**2+6379*r**4
            +2777*r**6)+Q2**4*(1555-8080*r**2-22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743
            -315*r**2-6548*r**4-6548*r**6-315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2
            +199629*r**4+305844*r**6+199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83
            -375*r**2-2833*r**4-5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)
            +9*(301-4028*r**2+808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12
            -4028*r**14+301*r**16))*sqrtq2))+((-66355200*logq2**4*r**14*(240*Q2**10*(2
            +5*r**4)-60*Q2**9*(94+101*r**2+207*r**4+130*r**6)+6*Q2**8*(4860+9135*r**2
            +12334*r**4+10171*r**6+2700*r**8)+Q2**7*(-83115-206985*r**2-257752*r**4
            -220950*r**6-90333*r**8+2475*r**10)+Q2**6*(136395+397005*r**2+493517*r**4
            +440608*r**6+218607*r**8-7497*r**10-58275*r**12)+3*Q2**5*(-38745-126315*r**2
            -149848*r**4-154328*r**6-81845*r**8-5447*r**10+29078*r**12+22050*r**14)
            +(-1+r**2)**4*(-5295-1515*r**2+12089*r**4-30135*r**6+33915*r**8+73675*r**10
            -38745*r**12+15711*r**14+15900*r**16)+Q2**4*(12915+126105*r**2+139415*r**4
            +167910*r**6+101619*r**8-10879*r**10-61995*r**12+75600*r**14+53550*r**16)
            -Q2*(-1+r**2)**2*(-32055-8775*r**2+61087*r**4-181678*r**6+89880*r**8
            +411845*r**10+258475*r**12-156672*r**14+75093*r**16+87600*r**18)-Q2**3*(
            -75015-29085*r**2+56014*r**4-169219*r**6+1941*r**8+304330*r**10+155324*r**12
            -159411*r**14+206136*r**16+192825*r**18)+3*Q2**2*(-25245+6885*r**2+42599*r**4
            -131085*r**6+33124*r**8+167335*r**10+177730*r**12+174821*r**14-120075*r**16
            +13436*r**18+63675*r**20))-18432*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(48*Q2**16*(838+5955*r**4)-4*Q2**15*(115086+92281*r**2+723555*r**4
            +864210*r**6)+2*Q2**14*(1132020+1819411*r**2+7153190*r**4+15360775*r**6
            +9029100*r**8)-Q2**13*(6062805+14976983*r**2+43559448*r**4+120434570*r**6
            +134641855*r**8+52681875*r**10)+Q2**12*(8763615+31761437*r**2+69492641*r**4
            +252228032*r**6+387303175*r**8+308413235*r**10+91098825*r**12)-Q2**11*(3704022
            +30348218*r**2-33218587*r**4+125513553*r**6+328176528*r**8+448962072*r**10
            +365622605*r**12+85831845*r**14)+Q2**10*(-9696918-11224756*r**2-431228895*r**4
            -915897800*r**6-1320104945*r**8-1171642776*r**10-347392653*r**12+124808260*r**14
            +16632195*r**16)+Q2**9*(18851745+64970231*r**2+933837305*r**4+2852840125*r**6
            +5100395095*r**8+6044378435*r**10+4203949251*r**12+1544529415*r**14+224658700*r**16
            +59186850*r**18)-Q2**8*(11581515+70765809*r**2+838223784*r**4+3722446430*r**6
            +7260934980*r**8+10218802340*r**10+9198204694*r**12+5047360794*r**14
            +1782447585*r**16+336651315*r**18+73991250*r**20)+2*Q2**7*(-2548590+10700688*r**2
            -81188991*r**4+914255153*r**6+1352749420*r**8+2471321070*r**10+3402726318*r**12
            +2896150584*r**14+1375226418*r**16+669262050*r**18+127026465*r**20+20345175*r**22)
            -2*Q2**6*(-6607986-12613643*r**2-573488343*r**4-406225493*r**6-2402483023*r**8
            -3611757844*r**10-2348027518*r**12+30572132*r**14+1444601632*r**16+735581727*r**18
            +732147589*r**20+107602545*r**22+6367665*r**24)+Q2**5*(-7975107-30764441*r**2
            -1047937990*r**4-1369733260*r**6-6109730745*r**8-10866330877*r**10-10013433212*r**12
            -5705151680*r**14+156001995*r**16+3541298405*r**18+1584877714*r**20+1393134428*r**22
            +175143265*r**24+2009505*r**26)+(-1+r**2)**4*(-54381-210203*r**2-16395496*r**4
            +37320860*r**6-211843025*r**8+198926577*r**10+736984476*r**12-215859408*r**14
            -899793615*r**16+437532135*r**18+419929304*r**20-32371148*r**22+83990029*r**24
            +5778755*r**26+385140*r**28)+Q2**4*(-122535+13857947*r**2+182210865*r**4
            +759602400*r**6+1152709455*r**8+4433877135*r**10+3314220251*r**12+2455541080*r**14
            +355871775*r**16+930412745*r**18-546174625*r**20-844170648*r**22-73416295*r**24
            -32457875*r**26+6134325*r**28)-Q2*(-1+r**2)**2*(-492951-1061959*r**2
            -118227404*r**4+274064934*r**6-1369318985*r**8+945468947*r**10+3247233198*r**12
            -850025412*r**14+474010287*r**16-2528283225*r**18+1619857264*r**20+2474718686*r**22
            -348999759*r**24+496834829*r**26+35998510*r**28+2783040*r**30)-Q2**3*(
            -2922570+2247458*r**2-377729407*r**4+807717625*r**6-3163267960*r**8
            +1251681580*r**10+504013719*r**12-2325064401*r**14-579670770*r**16-2555941470*r**18
            +3172963615*r**20+4532850823*r**22-804813292*r**24+1182172720*r**26+86585705*r**28
            +11000625*r**30)+Q2**2*(-1796310-243688*r**2-332550859*r**4+936445312*r**6
            -3755572965*r**8+3679851120*r**10+2800326121*r**12-3482035632*r**14+2816936931*r**16
            +6250094040*r**18-4955843345*r**20-594358208*r**22+5816223041*r**24-1664897568*r**26
            +1106087475*r**28+82454960*r**30+7999575*r**32))+128*(Q2-(-1+r)**2)**2*r**2*(Q2
            -(1+r)**2)**2*(-1088*Q2**20*r**2-4*Q2**19*r**2*(3254+2527*r**2)+4*Q2**18*(6984
            +21070*r**2+437053*r**4+61039*r**6)-4*Q2**17*(73854-171626*r**2+3014129*r**4
            +5281142*r**6+424263*r**8)+Q2**16*(1326024-7616863*r**2+10708800*r**4
            +133192066*r**6+110588280*r**8+6453933*r**10)-Q2**15*(3118554-31531241*r**2
            -150313053*r**4+168955990*r**6+559106952*r**8+310985011*r**10+15463707*r**12)
            +Q2**14*(3388050-76009897*r**2-739442852*r**4-828150155*r**6-117685638*r**8
            +976472905*r**10+461342488*r**12+24222699*r**14)+Q2**13*(1176462+117929405*r**2
            +1833019065*r**4+4035889717*r**6+6813848013*r**8+5387219375*r**10+114960835*r**12
            -172718721*r**14-23983863*r**16)+Q2**12*(-8597862-111367537*r**2-2873005284*r**4
            -9065034328*r**6-21798363408*r**8-33373604106*r**10-21103165356*r**12
            -3496517712*r**14-615526906*r**16+12576291*r**18)+Q2**11*(9946638+24048549*r**2
            +2376833185*r**4+12146252716*r**6+31815516512*r**8+71668770270*r**10
            +76615036110*r**12+36282863212*r**14+6183276442*r**16+1160980645*r**18
            -637559*r**20)-Q2**10*(815958-115695195*r**2-1128092708*r**4+6620899277*r**6
            +2012840548*r**8+49048420610*r**10+88665167472*r**12+76598873210*r**14
            +24815634998*r**16+4453422329*r**18+720515972*r**20+881881*r**22)-Q2**9*(9459450
            +204896583*r**2+5985540467*r**4+7571950725*r**6+84026083939*r**8+109965770630*r**10
            +82424373502*r**12+25337876474*r**14-6487207040*r**16+11502502019*r**18
            -201432865*r**20+254002353*r**22+4454099*r**24)+Q2**8*(9284418+148767325*r**2
            +6790054364*r**4+16708903958*r**6+146759336214*r**8+294394151871*r**10
            +359794833240*r**12+295372365172*r**14+138383580222*r**16+46805498859*r**18
            +33170043532*r**20+1901361590*r**22+651899306*r**24+5602233*r**26)-Q2**7*(904878
            -9202987*r**2+1263538329*r**4+12129584710*r**6+68122705248*r**8+257617249959*r**10
            +309010861599*r**12+384739997348*r**14+246136316902*r**16+97896992451*r**18
            +37377275975*r**20+23120353110*r**22+1889799628*r**24+267617409*r**26
            +795201*r**28)+Q2**6*(-4702698-113996459*r**2-4785719340*r**4+5289423595*r**6
            -105134994174*r**8+96159586285*r**10-134605463928*r**12+14050429531*r**14
            +150135100474*r**16+68074935271*r**18+64288585396*r**20+33751587849*r**22
            +7012162606*r**24+2151622743*r**26-161640080*r**28-2970831*r**30)+Q2**5*(3603978
            +91016839*r**2+5075059355*r**4-4257705781*r**6+175555714407*r**8-116949353701*r**10
            +405247882799*r**12+228394781439*r**14+159936830335*r**16-142688920811*r**18
            +12865882481*r**20-101359146943*r**22-45176325499*r**24-1821897399*r**26
            -2004503611*r**28+193228277*r**30+2333835*r**32)+2*(-1+r**2)**4*(7767
            +336787*r**2+25802988*r**4-145684328*r**6+2324017000*r**8-13079872076*r**10
            +42016399156*r**12-71280856848*r**14+24865187926*r**16+58748744970*r**18
            -65447245804*r**20+24238088472*r**22-5593858048*r**24-419913148*r**26
            -150164020*r**28-20401312*r**30+301035*r**32+5483*r**34)-Q2**4*(464850
            +16192379*r**2+1317687948*r**4-1304476580*r**6+76708683348*r**8-138390616000*r**10
            +294096844876*r**12+18699514236*r**14+18436502920*r**16+232070889134*r**18
            -227361498620*r**20+80541018676*r**22-42375593876*r**24-23240391240*r**26
            +86028068*r**28-490707980*r**30+41707494*r**32+230367*r**34)-Q2*(-1
            +r**2)**2*(146214+5417905*r**2+391529241*r**4-2086623996*r**6+29902437860*r**8
            -141284837416*r**10+376241404400*r**12-445599218156*r**14-119078627440*r**16
            +392652404210*r**18+160834888250*r**20-464754914100*r**22+213029257884*r**24
            -56006326832*r**26-5088138920*r**28-1576114148*r**30-294597430*r**32
            +6144181*r**34+104293*r**36)-Q2**3*(802566+21028385*r**2+1180633641*r**4
            -4770241744*r**6+46743767352*r**8-104754704844*r**10+154813560420*r**12
            -49355881920*r**14+62641812964*r**16+220115144526*r**18-337889367890*r**20
            +17284569840*r**22+78166419832*r**24-73529655996*r**26-7278006828*r**28
            -2601332832*r**30-820918170*r**32+31766297*r**34+604401*r**36)+Q2**2*(539406
            +16673921*r**2+1123640504*r**4-6095670319*r**6+72517673608*r**8-300943086180*r**10
            +713437302960*r**12-799267034132*r**14+260644081396*r**16-336941934074*r**18
            +574188341952*r**20+87707883382*r**22-647947135928*r**24+366104173340*r**26
            -96457539696*r**28-10124528628*r**30-2576048338*r**32-822259519*r**34
            +23208008*r**36+390337*r**38))-83607552000*logq2**5*r**18*(-3-2*r**2+14*r**6
            +3*r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-1105920*logq2**3*r**10*(240*Q2**13*(64
            +255*r**4)-4*Q2**12*(43920+41885*r**2+155079*r**4+145140*r**6)+2*Q2**11*(428160
            +783895*r**2+1807566*r**4+2413191*r**6+1167060*r**8)-Q2**10*(2271465
            +6056755*r**2+13248946*r**4+19439868*r**6+15303561*r**8+5118285*r**10)
            +5*Q2**9*(668190+2436539*r**2+5606946*r**4+8989754*r**6+8713014*r**8
            +4994739*r**10+1329090*r**12)-5*Q2**8*(390429+2513814*r**2+5592871*r**4
            +10181682*r**6+11862563*r**8+9114906*r**10+4408953*r**12+1148670*r**14)
            +2*Q2**7*(-943020+1798410*r**2-2905804*r**4-3376800*r**6+3525405*r**8
            +10477370*r**10+12366390*r**12+6044916*r**14+2643885*r**16)+Q2**6*(4580910
            +5816370*r**2+47913076*r**4+93829676*r**6+93769570*r**8+55259630*r**10
            +1345440*r**12-24375024*r**14-9379524*r**16-6523740*r**18)+2*Q2**5*(
            -1679310-3454065*r**2-24735604*r**4-52216407*r**6-57160479*r**8-46499485*r**10
            -14215635*r**12+7140931*r**14+16229193*r**16+4592226*r**18+2441835*r**20)
            +10*Q2**4*(18255+370188*r**2+977857*r**4+3641739*r**6+3832564*r**8+3781350*r**10
            +929160*r**12-1217124*r**14+1445605*r**16+151038*r**18-382737*r**20
            +127305*r**22)+(-1+r**2)**4*(-48165+13550*r**2-1655781*r**4+1417708*r**6
            +4541262*r**8-4479524*r**10+7586390*r**12-4775864*r**14+1422647*r**16
            +4444518*r**18+321519*r**20+283740*r**22)-10*Q2**3*(-146916+243673*r**2
            -2417218*r**4+287293*r**6+1287721*r**8-2508126*r**10-143152*r**12+1672986*r**14
            -3061934*r**16+3795669*r**18+4878538*r**20-117159*r**22+583185*r**24)
            -Q2*(-1+r**2)**2*(-369270+336545*r**2-10337182*r**4+6100739*r**6+21858300*r**8
            -21620574*r**10+26197332*r**12+35776222*r**14-20172494*r**16+7590445*r**18
            +24581514*r**20+762543*r**22+1871880*r**24)+Q2**2*(-1122405+2141545*r**2
            -25839026*r**4+23762820*r**6+27255595*r**8-55974305*r**10+34948620*r**12
            +64970392*r**14+83670265*r**16-50727345*r**18-12109290*r**20+52512660*r**22
            -3238191*r**24+4900665*r**26))*sqrtq2+1536*logq2*r**4*(-23280*Q2**21*r**2
            +4*Q2**20*(-1901+67017*r**2+101700*r**4)-2*Q2**19*(-41999+448466*r**2
            +2233249*r**4+1542780*r**6)+Q2**18*(-459281-1559330*r**2+15642922*r**4
            +29852110*r**6+13479015*r**8)+Q2**17*(1790765+25708162*r**2+1763942*r**4
            -63318368*r**6-104663043*r**8-37316610*r**10)+2*Q2**16*(-2867207-61671801*r**2
            -105688319*r**4-144588394*r**6-50424471*r**8+96399759*r**10+33133905*r**12)
            +Q2**15*(14785748+375739980*r**2+951504816*r**4+2177714094*r**6+3122669772*r**8
            +1618383720*r**10-88767984*r**12-67902210*r**14)+2*Q2**14*(-13987292
            -390441682*r**2-1236100760*r**4-3341185983*r**6-6730888595*r**8-6869872632*r**10
            -3000297082*r**12-216959823*r**14+7113465*r**16)+2*Q2**13*(16969864+506705280*r**2
            +2031835975*r**4+5593514577*r**6+14434495681*r**8+20359789241*r**10+15994937513*r**12
            +5894938467*r**14+583333335*r**16+32718915*r**18)-2*Q2**12*(8093930+228108348*r**2
            +1753935795*r**4+2486972684*r**6+11922502594*r**8+24399961008*r**10+28605474124*r**12
            +20167841132*r**14+6427363428*r**16+707976828*r**18+46605585*r**20)+2*Q2**11*(
            -11419824-505875682*r**2-359138540*r**4-11762023525*r**6-22053851624*r**8
            -22891251572*r**10-10373232704*r**12+6301646226*r**14+9911683256*r**16
            +2546333638*r**18+408310188*r**20+18295875*r**22)+2*Q2**10*(25377495
            +1129233976*r**2+2929278924*r**4+30578647613*r**6+81386925062*r**8+128940233264*r**10
            +138131797516*r**12+91744005734*r**14+35877627579*r**16+7679273944*r**18
            +2924456392*r**20+42971357*r**22+19904040*r**24)-2*Q2**9*(19227663+917275138*r**2
            +3409864633*r**4+31792876459*r**6+107221525520*r**8+184717808607*r**10
            +238473483262*r**12+213961798674*r**14+126209036139*r**16+52933835940*r**18
            +15924577913*r**20+5286211363*r**22+267784582*r**24+28106715*r**26)+2*Q2**8*(
            -309244-23374190*r**2+1585832717*r**4+3774731746*r**6+59527138458*r**8
            +79160255820*r**10+117817470339*r**12+153782240156*r**14+145785056816*r**16
            +82294322258*r**18+42678519187*r**20+13314568514*r**22+4053031858*r**24
            +234271440*r**26+7997085*r**28)+2*Q2**7*(13274150+759597978*r**2+161396852*r**4
            +30272158165*r**6+2766961710*r**8+81700868796*r**10+118924170204*r**12
            +80617398739*r**14-7626953486*r**16-75287733526*r**18-42707036724*r**20
            -40517465125*r**22-10135336454*r**24-2172501792*r**26-136057692*r**28
            +9941085*r**30)+2*(-1+r**2)**6*(17587+1690505*r**2-1956685*r**4+205369507*r**6
            -876454659*r**8+2486920321*r**10-1700432405*r**12-9649384245*r**14+14466855531*r**16
            -2950948477*r**18-4573545263*r**20+1879026145*r**22-832379545*r**24-71840013*r**26
            -15449839*r**28-460495*r**30+12030*r**32)-2*Q2**6*(11208856+699610998*r**2
            +507200388*r**4+36664028793*r**6+10378266609*r**8+114852463440*r**10
            +171898395918*r**12+147713419207*r**14+101353358607*r**16+19253914238*r**18
            -69733046584*r**20-21113445321*r**22-38125271505*r**24-7760402340*r**26
            -1009435962*r**28-61940247*r**30+10426905*r**32)-Q2*(-1+r**2)**4*(391351
            +34643162*r**2-52644702*r**4+3693361850*r**6-13506634574*r**8+34878803658*r**10
            -14371761366*r**12-107430449846*r**14+51028639920*r**16+100282304558*r**18
            -47641227194*r**20-56438082114*r**22+24681311278*r**24-12949489570*r**26
            -1128662034*r**28-262871490*r**30-8961607*r**32+288720*r**34)+2*Q2**5*(2739596
            +197222392*r**2+356755553*r**4+14589850563*r**6-1755938077*r**8+36411578703*r**10
            +68181636305*r**12+16507990519*r**14+19392144531*r**16+20990441923*r**18
            +58414254027*r**20-30589374503*r**22+4090000113*r**24-8780221699*r**26
            -2675848701*r**28-12200531*r**30+2501901*r**32+2675385*r**34)+Q2**2*(
            -1+r**2)**2*(1838795+148782168*r**2-319681765*r**4+13838127558*r**6-47109494458*r**8
            +117465073430*r**10-64301379602*r**12-185374231242*r**14+16369175364*r**16
            +60633904006*r**18+155921352540*r**20-92489899070*r**22-165541722246*r**24
            +78918328018*r**26-40556181998*r**28-3411110590*r**30-921061071*r**32
            -37434822*r**34+1454985*r**36)+2*Q2**4*(2127956+138033786*r**2-461964733*r**4
            +7840297272*r**6-19790272210*r**8+52974872524*r**10-33107466886*r**12
            +22515073360*r**14+10975752926*r**16+33939524200*r**18+42486769024*r**20
            -97182377736*r**22-47804694006*r**24+18809275172*r**26-25292019290*r**28
            -1819800704*r**30-759732714*r**32-43547346*r**34+1845405*r**36)+2*Q2**3*(
            -2213167-161652300*r**2+511472097*r**4-13028240203*r**6+45629624116*r**8
            -114699478476*r**10+108629300948*r**12+24428453500*r**14-29581682274*r**16
            +35062830868*r**18+66581988318*r**20-123225830586*r**22+5632289764*r**24
            +139053641132*r**26-74902667964*r**28+31484497900*r**30+2238971513*r**32
            +817861464*r**34+42133545*r**36-1860195*r**38))*sqrtq2)*math.log(mu0))/(-29393280000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -408240000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3-283500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5+70543872000*logq2**5*r**22*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2+4898880000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+17010000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +((-86400*logq2**3*r**8*(-240*Q2**8*(1+5*r**4)+20*Q2**7*(117+166*r**2+501*r**4
            +480*r**6)-4*Q2**6*(2415+5900*r**2+10136*r**4+14688*r**6+8085*r**8)
            +Q2**5*(19425+64530*r**2+93454*r**4+122436*r**6+133377*r**8+56490*r**10)
            -Q2**4*(17325+75505*r**2+111190*r**4+115462*r**6+146261*r**8+133785*r**10
            +46200*r**12)+Q2**3*(-210+29530*r**2+62170*r**4+36808*r**6+70082*r**8
            +98834*r**10+33270*r**12-2100*r**14)+(-1+r**2)**2*(2175+355*r**2-4569*r**4
            +39419*r**6+18349*r**8+115649*r**10-35691*r**12+5793*r**14+6360*r**16)
            +2*Q2**2*(6405+1710*r**2-17795*r**4+18194*r**6+29*r**8+40550*r**10
            -56313*r**12+14010*r**14+17850*r**16)-Q2*(9315-2300*r**2-25984*r**4
            +128230*r**6+56718*r**8+228638*r**10+286248*r**12-121038*r**14+5223*r**16
            +26310*r**18))+24*logq2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(4656*Q2**14*(1
            +5*r**4)-4*Q2**13*(9981+4346*r**2+38205*r**4+61980*r**6)+4*Q2**12*(35289
            +31746*r**2-3186*r**4+392890*r**6+264645*r**8)-Q2**11*(246759+384626*r**2
            -2256934*r**4+587244*r**6+5876815*r**8+2222370*r**10)+Q2**10*(155661
            +594681*r**2-8831714*r**4-13613034*r**6-7003739*r**8+8957825*r**10+1850880*r**12)
            +Q2**9*(185163-401150*r**2+21101265*r**4+55561850*r**6+91934525*r**8
            +68897718*r**10+939175*r**12+1490190*r**14)-Q2**8*(427977+170877*r**2
            +34467885*r**4+141383925*r**6+309486275*r**8+391317767*r**10+205760327*r**12
            +22704135*r**14+4844160*r**16)+Q2**7*(243738+632892*r**2+27746208*r**4
            +216896700*r**6+571666860*r**8+909856288*r**10+774178672*r**12+248138668*r**14
            +29796330*r**16+3521340*r**18)+2*Q2**6*(68409-318579*r**2+7216116*r**4
            -73107126*r**6-189303760*r**8-437701626*r**10-485681424*r**12-303122814*r**14
            +1309859*r**16-3843135*r**18+627120*r**20)-2*Q2**5*(130911-142854*r**2
            +27383571*r**4+15435336*r**6+182291046*r**8+165362706*r**10+80090386*r**12
            +79355246*r**14+52021411*r**16+162885196*r**18+8394675*r**20+1790130*r**22)
            +2*Q2**4*(54153+49975*r**2+21185265*r**4+52066275*r**6+329756050*r**8
            +567660684*r**10+603473600*r**12+564545620*r**14+392790475*r**16+229278725*r**18
            +152733063*r**20+8436225*r**22+913890*r**24)+Q2**3*(35901-262314*r**2
            +1570530*r**4-68997280*r**6-109705125*r**8-634573542*r**10-618767172*r**12
            -988466560*r**14-589938125*r**16-4908950*r**18-329195934*r**20-22813664*r**22
            -3502795*r**24+385830*r**26)-(-1+r**2)**2*(2589-4733*r**2+2241614*r**4
            -5780470*r**6+73049315*r**8-233520403*r**10-35002404*r**12+1228727532*r**14
            -742870045*r**16+129396765*r**18+122562014*r**20-23266038*r**22+16198429*r**24
            +441715*r**26+48120*r**28)-Q2**2*(51519-191549*r**2+21023614*r**4-48309390*r**6
            +383527965*r**8-515789363*r**10+29328068*r**12+329218412*r**14-1181695175*r**16
            -132837235*r**18+696010894*r**20-243046494*r**22+126648299*r**24+3036515*r**26
            +799920*r**28)+Q2*(19191-68166*r**2+12008609*r**4-34826154*r**6+321469335*r**8
            -789979722*r**10+85768417*r**12+1505869722*r**14+1701505453*r**16-981466970*r**18
            -175522149*r**20+583848074*r**22-180867131*r**24+78850026*r**26+1956835*r**28
            +330630*r**30))-36288000*logq2**4*r**12*(9+12*r**2-26*r**4+84*r**6+9*r**8)*sqrtq2
            -1440*logq2**2*r**4*(-4320*Q2**11*(1+5*r**4)+8*Q2**10*(4965+4916*r**2+20601*r**4
            +24930*r**6)-40*Q2**9*(3612+7217*r**2+19493*r**4+31427*r**6+18795*r**8)
            +5*Q2**8*(50625+163440*r**2+459434*r**4+829380*r**6+751365*r**8+279900*r**10)
            -20*Q2**7*(8226+54837*r**2+165173*r**4+369290*r**6+407620*r**8+259473*r**10
            +51525*r**12)-20*Q2**6*(7245-29757*r**2-13760*r**4-167221*r**6-237535*r**8
            -163463*r**10-111678*r**12+36225*r**14)+2*Q2**5*(170100+80262*r**2+2890847*r**4
            +5149485*r**6+5819760*r**8+6516920*r**10+5177967*r**12+1268757*r**14
            +1031310*r**16)-10*Q2**4*(19917+43302*r**2+696535*r**4+1674070*r**6
            +2004837*r**8+2248840*r**10+2048341*r**12+1426478*r**14+375522*r**16
            +137070*r**18)-20*Q2**3*(2070-18825*r**2-40178*r**4-413134*r**6-493868*r**8
            -490217*r**10-921311*r**12-312148*r**14-100640*r**16-102060*r**18+8775*r**20)
            +20*Q2**2*(5481-14553*r**2+216497*r**4-202152*r**6-195594*r**8+245543*r**10
            +79464*r**12-737049*r**14-42235*r**16+428850*r**18-42237*r**20+36225*r**22)
            +(-1+r**2)**2*(8805-17242*r**2+789439*r**4-1773860*r**6-986474*r**8
            +9561352*r**10+5375842*r**12-326924*r**14-1127675*r**16+1722514*r**18
            +12383*r**20+67440*r**22)-10*Q2*(5268-15566*r**2+341497*r**4-654419*r**6
            -274184*r**8+2240122*r**10+1166944*r**12+2977672*r**14-436142*r**16
            -719852*r**18+696519*r**20-43509*r**22+37890*r**24))*sqrtq2+(126*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**3*(5*Q2**5-Q2**4*(7+15*r**2)+2*Q2**3*(4+2*r**2+5*r**4)+(-1
            +r**2)**2*(17+r**2-11*r**4+5*r**6)+2*Q2**2*(7-6*r**2-4*r**4+5*r**6)
            -Q2*(37+20*r**2+8*r**4-32*r**6+15*r**8))-10*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(32256*Q2**14-288*Q2**13*(339+518*r**2)+8*Q2**12*(11745+40478*r**2
            +23877*r**4)+Q2**11*(95499-358507*r**2-508135*r**4+99351*r**6)-Q2**10*(383589
            +356080*r**2+1976274*r**4-329264*r**6+354249*r**8)+Q2**9*(21459+1400491*r**2
            +7390760*r**4+10034036*r**6+1055725*r**8+34713*r**10)+3*Q2**8*(374345
            -756146*r**2-3663623*r**4-3769244*r**6-2403589*r**8-751922*r**10+107331*r**12)
            -6*Q2**7*(199739-371663*r**2-1833699*r**4-4168441*r**6-937469*r**8+2363425*r**10
            -467*r**12+14847*r**14)+Q2**6*(-288642+2265816*r**2+231180*r**4-8496168*r**6
            +23003492*r**8-6870072*r**10+13567596*r**12+2449800*r**14-179802*r**16)
            +2*Q2**5*(556707-2541849*r**2+17102856*r**4+26213580*r**6-16538884*r**8
            -58976872*r**10-14698344*r**12+5756076*r**14-244239*r**16+26649*r**18)
            +2*Q2**4*(-280545+498702*r**2-36732645*r**4-57585012*r**6-82444840*r**8
            -153525108*r**10-68689312*r**12+19803180*r**14-6641823*r**16-733650*r**18
            +33453*r**20)+Q2**3*(-80553+1343297*r**2+18298989*r**4+65629323*r**6
            +235764138*r**8+98850070*r**10+231769822*r**12+308404866*r**14+33807807*r**16
            -440343*r**18+313973*r**20-15309*r**22)+Q2**2*(240999-890072*r**2+38735950*r**4
            -99122616*r**6-171385291*r**8-436767904*r**10-226505772*r**12+241352384*r**14
            +125268401*r**16-35938824*r**18+3304030*r**20+469624*r**22-15309*r**24)
            +(-1+r**2)**2*(33375-463432*r**2+9716288*r**4+34210932*r**6+429107767*r**8
            +185694112*r**10-23101104*r**12-160832984*r**14+74725573*r**16+11512488*r**18
            +710768*r**20-61084*r**22+1701*r**24)+Q2*(-144057+1075351*r**2-33791760*r**4
            +4965436*r**6-891123325*r**8-1407498441*r**10-371766112*r**12+416999240*r**14
            +306799653*r**16-255890035*r**18-12685712*r**20-1896324*r**22-63215*r**24
            +1701*r**26)))*sqrtq2)*math.log(mus))/(-58786560*logq2**3*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))-408240*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+176359680*logq2**4*r**16*sqrtq2
            +7348320*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+8505*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+((86400*logq2**3*r**8*(-240*Q2**8*(1+5*r**4)
            +20*Q2**7*(117+166*r**2+501*r**4+480*r**6)-4*Q2**6*(2415+5900*r**2
            +10136*r**4+14688*r**6+8085*r**8)+Q2**5*(19425+64530*r**2+93454*r**4
            +122436*r**6+133377*r**8+56490*r**10)-Q2**4*(17325+75505*r**2+111190*r**4
            +115462*r**6+146261*r**8+133785*r**10+46200*r**12)+Q2**3*(-210+29530*r**2
            +62170*r**4+36808*r**6+70082*r**8+98834*r**10+33270*r**12-2100*r**14)
            +(-1+r**2)**2*(2175+355*r**2-4569*r**4+39419*r**6+18349*r**8+115649*r**10
            -35691*r**12+5793*r**14+6360*r**16)+2*Q2**2*(6405+1710*r**2-17795*r**4
            +18194*r**6+29*r**8+40550*r**10-56313*r**12+14010*r**14+17850*r**16)
            -Q2*(9315-2300*r**2-25984*r**4+128230*r**6+56718*r**8+228638*r**10
            +286248*r**12-121038*r**14+5223*r**16+26310*r**18))-24*logq2*(Q2-(
            -1+r)**2)*(Q2-(1+r)**2)*(4656*Q2**14*(1+5*r**4)-4*Q2**13*(9981+4346*r**2
            +38205*r**4+61980*r**6)+4*Q2**12*(35289+31746*r**2-3186*r**4+392890*r**6
            +264645*r**8)-Q2**11*(246759+384626*r**2-2256934*r**4+587244*r**6+5876815*r**8
            +2222370*r**10)+Q2**10*(155661+594681*r**2-8831714*r**4-13613034*r**6
            -7003739*r**8+8957825*r**10+1850880*r**12)+Q2**9*(185163-401150*r**2
            +21101265*r**4+55561850*r**6+91934525*r**8+68897718*r**10+939175*r**12
            +1490190*r**14)-Q2**8*(427977+170877*r**2+34467885*r**4+141383925*r**6
            +309486275*r**8+391317767*r**10+205760327*r**12+22704135*r**14+4844160*r**16)
            +Q2**7*(243738+632892*r**2+27746208*r**4+216896700*r**6+571666860*r**8
            +909856288*r**10+774178672*r**12+248138668*r**14+29796330*r**16+3521340*r**18)
            +2*Q2**6*(68409-318579*r**2+7216116*r**4-73107126*r**6-189303760*r**8
            -437701626*r**10-485681424*r**12-303122814*r**14+1309859*r**16-3843135*r**18
            +627120*r**20)-2*Q2**5*(130911-142854*r**2+27383571*r**4+15435336*r**6
            +182291046*r**8+165362706*r**10+80090386*r**12+79355246*r**14+52021411*r**16
            +162885196*r**18+8394675*r**20+1790130*r**22)+2*Q2**4*(54153+49975*r**2
            +21185265*r**4+52066275*r**6+329756050*r**8+567660684*r**10+603473600*r**12
            +564545620*r**14+392790475*r**16+229278725*r**18+152733063*r**20+8436225*r**22
            +913890*r**24)+Q2**3*(35901-262314*r**2+1570530*r**4-68997280*r**6-109705125*r**8
            -634573542*r**10-618767172*r**12-988466560*r**14-589938125*r**16-4908950*r**18
            -329195934*r**20-22813664*r**22-3502795*r**24+385830*r**26)-(-1+r**2)**2*(2589
            -4733*r**2+2241614*r**4-5780470*r**6+73049315*r**8-233520403*r**10-35002404*r**12
            +1228727532*r**14-742870045*r**16+129396765*r**18+122562014*r**20-23266038*r**22
            +16198429*r**24+441715*r**26+48120*r**28)-Q2**2*(51519-191549*r**2+21023614*r**4
            -48309390*r**6+383527965*r**8-515789363*r**10+29328068*r**12+329218412*r**14
            -1181695175*r**16-132837235*r**18+696010894*r**20-243046494*r**22+126648299*r**24
            +3036515*r**26+799920*r**28)+Q2*(19191-68166*r**2+12008609*r**4-34826154*r**6
            +321469335*r**8-789979722*r**10+85768417*r**12+1505869722*r**14+1701505453*r**16
            -981466970*r**18-175522149*r**20+583848074*r**22-180867131*r**24+78850026*r**26
            +1956835*r**28+330630*r**30))+36288000*logq2**4*r**12*(9+12*r**2-26*r**4
            +84*r**6+9*r**8)*sqrtq2+1440*logq2**2*r**4*(-4320*Q2**11*(1+5*r**4)+8*Q2**10*(4965
            +4916*r**2+20601*r**4+24930*r**6)-40*Q2**9*(3612+7217*r**2+19493*r**4
            +31427*r**6+18795*r**8)+5*Q2**8*(50625+163440*r**2+459434*r**4+829380*r**6
            +751365*r**8+279900*r**10)-20*Q2**7*(8226+54837*r**2+165173*r**4+369290*r**6
            +407620*r**8+259473*r**10+51525*r**12)-20*Q2**6*(7245-29757*r**2-13760*r**4
            -167221*r**6-237535*r**8-163463*r**10-111678*r**12+36225*r**14)+2*Q2**5*(170100
            +80262*r**2+2890847*r**4+5149485*r**6+5819760*r**8+6516920*r**10+5177967*r**12
            +1268757*r**14+1031310*r**16)-10*Q2**4*(19917+43302*r**2+696535*r**4
            +1674070*r**6+2004837*r**8+2248840*r**10+2048341*r**12+1426478*r**14
            +375522*r**16+137070*r**18)-20*Q2**3*(2070-18825*r**2-40178*r**4-413134*r**6
            -493868*r**8-490217*r**10-921311*r**12-312148*r**14-100640*r**16-102060*r**18
            +8775*r**20)+20*Q2**2*(5481-14553*r**2+216497*r**4-202152*r**6-195594*r**8
            +245543*r**10+79464*r**12-737049*r**14-42235*r**16+428850*r**18-42237*r**20
            +36225*r**22)+(-1+r**2)**2*(8805-17242*r**2+789439*r**4-1773860*r**6
            -986474*r**8+9561352*r**10+5375842*r**12-326924*r**14-1127675*r**16
            +1722514*r**18+12383*r**20+67440*r**22)-10*Q2*(5268-15566*r**2+341497*r**4
            -654419*r**6-274184*r**8+2240122*r**10+1166944*r**12+2977672*r**14-436142*r**16
            -719852*r**18+696519*r**20-43509*r**22+37890*r**24))*sqrtq2+(-126*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**3*(5*Q2**5-Q2**4*(7+15*r**2)+2*Q2**3*(4+2*r**2+5*r**4)+(-1
            +r**2)**2*(17+r**2-11*r**4+5*r**6)+2*Q2**2*(7-6*r**2-4*r**4+5*r**6)
            -Q2*(37+20*r**2+8*r**4-32*r**6+15*r**8))+10*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(32256*Q2**14-288*Q2**13*(339+518*r**2)+8*Q2**12*(11745+40478*r**2
            +23877*r**4)+Q2**11*(95499-358507*r**2-508135*r**4+99351*r**6)-Q2**10*(383589
            +356080*r**2+1976274*r**4-329264*r**6+354249*r**8)+Q2**9*(21459+1400491*r**2
            +7390760*r**4+10034036*r**6+1055725*r**8+34713*r**10)+3*Q2**8*(374345
            -756146*r**2-3663623*r**4-3769244*r**6-2403589*r**8-751922*r**10+107331*r**12)
            -6*Q2**7*(199739-371663*r**2-1833699*r**4-4168441*r**6-937469*r**8+2363425*r**10
            -467*r**12+14847*r**14)+Q2**6*(-288642+2265816*r**2+231180*r**4-8496168*r**6
            +23003492*r**8-6870072*r**10+13567596*r**12+2449800*r**14-179802*r**16)
            +2*Q2**5*(556707-2541849*r**2+17102856*r**4+26213580*r**6-16538884*r**8
            -58976872*r**10-14698344*r**12+5756076*r**14-244239*r**16+26649*r**18)
            +2*Q2**4*(-280545+498702*r**2-36732645*r**4-57585012*r**6-82444840*r**8
            -153525108*r**10-68689312*r**12+19803180*r**14-6641823*r**16-733650*r**18
            +33453*r**20)+Q2**3*(-80553+1343297*r**2+18298989*r**4+65629323*r**6
            +235764138*r**8+98850070*r**10+231769822*r**12+308404866*r**14+33807807*r**16
            -440343*r**18+313973*r**20-15309*r**22)+Q2**2*(240999-890072*r**2+38735950*r**4
            -99122616*r**6-171385291*r**8-436767904*r**10-226505772*r**12+241352384*r**14
            +125268401*r**16-35938824*r**18+3304030*r**20+469624*r**22-15309*r**24)
            +(-1+r**2)**2*(33375-463432*r**2+9716288*r**4+34210932*r**6+429107767*r**8
            +185694112*r**10-23101104*r**12-160832984*r**14+74725573*r**16+11512488*r**18
            +710768*r**20-61084*r**22+1701*r**24)+Q2*(-144057+1075351*r**2-33791760*r**4
            +4965436*r**6-891123325*r**8-1407498441*r**10-371766112*r**12+416999240*r**14
            +306799653*r**16-255890035*r**18-12685712*r**20-1896324*r**22-63215*r**24
            +1701*r**26)))*sqrtq2)*math.log(2*muWC))/(-54432000*logq2**3*r**12*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))-378000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+163296000*logq2**4*r**16*sqrtq2
            +6804000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+7875*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+((16588800*logq2**4*r**14*(120*Q2**10*(49
            +125*r**4)-10*Q2**9*(6909+7462*r**2+15525*r**4+9960*r**6)+6*Q2**8*(59535
            +112490*r**2+153730*r**4+130018*r**6+36795*r**8)-3*Q2**7*(339255+849485*r**2
            +1069070*r**4+935628*r**6+412343*r**8+11895*r**10)+Q2**6*(1668870+4886070*r**2
            +6138510*r**4+5556474*r**6+2921780*r**8+163044*r**10-603540*r**12)+3*Q2**5*(
            -473445-1554665*r**2-1868125*r**4-1930411*r**6-1073067*r**8-155507*r**10
            +280469*r**12+240135*r**14)+(-1+r**2)**4*(-64470-19250*r**2+144325*r**4
            -377987*r**6+391068*r**8+814428*r**10-446727*r**12+185793*r**14+187620*r**16)
            +3*Q2**4*(52080+519610*r**2+590065*r**4+691355*r**6+442860*r**8-12064*r**10
            -200615*r**12+314755*r**14+215250*r**16)+Q2**3*(916965+350595*r**2-706530*r**4
            +2121252*r**6+18390*r**8-3398292*r**10-1672722*r**12+1747880*r**14-2426823*r**16
            -2263995*r**18)-3*Q2*(-1+r**2)**2*(-130235-36575*r**2+244670*r**4-758452*r**6
            +324966*r**8+1541076*r**10+943206*r**12-595464*r**14+295713*r**16+343895*r**18)
            +6*Q2**2*(-154035+41615*r**2+259255*r**4-815756*r**6+174719*r**8+923488*r**10
            +1009553*r**12+965488*r**14-685476*r**16+79789*r**18+374160*r**20))
            +4608*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(24*Q2**16*(19759
            +141155*r**4)-6*Q2**15*(902841+718686*r**2+5709385*r**4+6828120*r**6)
            +6*Q2**14*(4433435+7074308*r**2+28040740*r**4+60639880*r**6+35667325*r**8)
            -Q2**13*(71144745+174422877*r**2+506867732*r**4+1419191580*r**6+1594603395*r**8
            +624449775*r**10)+2*Q2**12*(51378705+184350729*r**2+394897342*r**4+1469473504*r**6
            +2275566135*r**8+1824823635*r**10+540595350*r**12)-2*Q2**11*(21764274
            +173791161*r**2-236171109*r**4+660774091*r**6+1829868486*r**8+2580820269*r**10
            +2156524125*r**12+512296455*r**14)+2*Q2**10*(-56560581-72919482*r**2
            -2622526690*r**4-5624295580*r**6-8202278350*r**8-7364967262*r**10-2278836486*r**12
            +717150300*r**14+107585955*r**16)+Q2**9*(220007205+779006529*r**2+11232829130*r**4
            +34506742590*r**6+62131512240*r**8+74034163440*r**10+51722803694*r**12
            +19036761570*r**14+2719923315*r**16+677544975*r**18)-2*Q2**8*(67567005
            +419308173*r**2+5021614203*r**4+22446825485*r**6+44093246445*r**8+62425168125*r**10
            +56391940163*r**12+31055910483*r**14+10883009070*r**16+2008883430*r**18
            +432725850*r**20)+2*Q2**7*(-29673435+119977992*r**2-982994709*r**4+10991631232*r**6
            +16303822210*r**8+30090139750*r**10+41462662522*r**12+35245595866*r**14
            +16820035617*r**16+7991350530*r**18+1488239955*r**20+248222550*r**22)
            -2*Q2**6*(-76952799-160500672*r**2-6877218012*r**4-5004298342*r**6-29627077437*r**8
            -44624971686*r**10-29770364562*r**12-1194749142*r**14+16136178233*r**16
            +8375851638*r**18+8527030686*r**20+1238729100*r**22+89547795*r**24)+Q2**5*(
            -92820063-379554699*r**2-12555020520*r**4-16828610740*r**6-75426266175*r**8
            -134068209123*r**10-125004826728*r**12-73910771520*r**14-2625276765*r**16
            +39368632175*r**18+17620222896*r**20+16219567092*r**22+2027209755*r**24
            +41881215*r**26)+2*(-1+r**2)**4*(-315927-1358631*r**2-97872757*r**4
            +216407235*r**6-1281961440*r**8+1289030974*r**10+4360129752*r**12-1734680526*r**14
            -5246680115*r**16+2614444305*r**18+2483337303*r**20-204916021*r**22+501345258*r**24
            +33987480*r**26+2383110*r**28)+2*Q2**4*(-723345+81921999*r**2+1094787940*r**4
            +4641678340*r**6+7267884355*r**8+27447649545*r**10+20835204822*r**12
            +15965800140*r**14+3889739145*r**16+6380102845*r**18-3123746900*r**20
            -4730246096*r**22-358825755*r**24-196030485*r**26+36425850*r**28)-Q2*(
            -1+r**2)**2*(-5729859-14455821*r**2-1410678521*r**4+3196342681*r**6-16608271215*r**8
            +12321912263*r**10+38699009147*r**12-13466485923*r**14+2982814103*r**16
            -29711589175*r**18+19633108101*r**20+29222621899*r**22-4293732581*r**24
            +5932450941*r**26+420527865*r**28+34636095*r**30)-2*Q2**3*(-17002440
            +9121701*r**2-2251878419*r**4+4772626725*r**6-19239473280*r**8+8135269865*r**10
            +3077855313*r**12-14591063907*r**14-3814237440*r**16-14225145505*r**18
            +19440856575*r**20+26356966311*r**22-4838408024*r**24+7071358515*r**26
            +494958435*r**28+69139575*r**30)+2*Q2**2*(-10444395-4595346*r**2-1981390158*r**4
            +5507146814*r**6-22726862670*r**8+23109834780*r**10+16242160732*r**12
            -22636150884*r**14+15627104382*r**16+34534952710*r**18-29388383670*r**20
            -2718400986*r**22+34297667042*r**24-10060815696*r**26+6615513960*r**28
            +475028160*r**30+50115225*r**32))-32*(Q2-(-1+r)**2)**2*r**2*(Q2-(1
            +r)**2)**2*(144*Q2**21-16*Q2**20*(-9+829*r**2)-2*Q2**19*(-639+73460*r**2
            +58337*r**4)+2*Q2**18*(79281+451885*r**2+10061797*r**4+1417753*r**6)
            -8*Q2**17*(245886-1124459*r**2+17359677*r**4+30558891*r**6+2468776*r**8)
            +Q2**16*(9586977-94123733*r**2+122747002*r**4+1545629502*r**6+1284911293*r**8
            +75401263*r**10)-2*Q2**15*(12049368-192123143*r**2-870450449*r**4+988400902*r**6
            +3249985546*r**8+1814225713*r**10+90868591*r**12)+2*Q2**14*(14519538
            -464122255*r**2-4293745452*r**4-4784550705*r**6-753149926*r**8+5645635335*r**10
            +2711051280*r**12+143652521*r**14)+Q2**13*(3083184+1475786170*r**2+21397231102*r**4
            +46750198770*r**6+80043855694*r**8+64192938814*r**10+1766035674*r**12
            -2130713642*r**14-289172438*r**16)+2*Q2**12*(-31038228-741966823*r**2
            -16865727634*r**4-52333925158*r**6-127135156666*r**8-196976667580*r**10
            -125435442790*r**12-20915358874*r**14-3516204058*r**16+79032707*r**18)
            +2*Q2**11*(40048710+226742607*r**2+14067428139*r**4+69509397816*r**6
            +182692966000*r**8+419140534806*r**10+452109281058*r**12+215679109696*r**14
            +36735805314*r**16+6762322083*r**18-7458789*r**20)-2*Q2**10*(7911228
            -714116403*r**2-6343153470*r**4+36545240817*r**6+1748131676*r**8+275215390982*r**10
            +511823684304*r**12+449260340606*r**14+148353990440*r**16+26262906045*r**18
            +4325435598*r**20+4956705*r**22)-2*Q2**9*(32904768+1401728835*r**2+34589598885*r**4
            +46187619765*r**6+510932357123*r**8+680730200606*r**10+527629513490*r**12
            +179501968538*r**14-29890144570*r**16+65709909743*r**18-821245863*r**20
            +1279918305*r**22+24091431*r**24)+2*Q2**8*(36077073+1077606400*r**2+39227906232*r**4
            +98618232906*r**6+883778707981*r**8+1786812240402*r**10+2203200887256*r**12
            +1824887727940*r**14+861631855443*r**16+286313900076*r**18+193990355008*r**20
            +11611711746*r**22+3672890751*r**24+31335154*r**26)-2*Q2**7*(5973312
            -39367213*r**2+7345640933*r**4+70010002782*r**6+412625300306*r**8+1559808218189*r**10
            +1890622789659*r**12+2362447769444*r**14+1527989523788*r**16+609006473037*r**18
            +220930406123*r**20+137603703038*r**22+11153178978*r**24+1585747667*r**26
            +4753877*r**28)-2*Q2**6*(16348386+819656477*r**2+27338412956*r**4-27274569265*r**6
            +625897809662*r**8-568356665515*r**10+818960810720*r**12-80268688225*r**14
            -894428405650*r**16-416289998929*r**18-387622531492*r**20-182730839131*r**22
            -46565103310*r**24-12362417569*r**26+835692968*r**28+16638317*r**30)
            +2*Q2**5*(13645872+665852143*r**2+28919080413*r**4-20213647905*r**6+1047962971825*r**8
            -675926973837*r**10+2469543903441*r**12+1420284025507*r**14+1011299478309*r**16
            -804657512403*r**18+102443952103*r**20-609438587715*r**22-243805341885*r**24
            -16169915279*r**26-11562677397*r**28+1053653697*r**30+13232311*r**32)
            +(-1+r**2)**4*(117429+9701977*r**2+584363420*r**4-3161529468*r**6+54213207056*r**8
            -307919637176*r**10+995299452636*r**12-1707000309596*r**14+626369443586*r**16
            +1391144142978*r**18-1575558189580*r**20+593693771692*r**22-139409449608*r**24
            -8525183168*r**26-3744319084*r**28-480315348*r**30+6142145*r**32+126109*r**34)
            -2*Q2**4*(2204784+116234825*r**2+7498503326*r**4-5721728370*r**6+457474936526*r**8
            -815461940206*r**10+1776037166550*r**12+132692078006*r**14+157921140230*r**16
            +1416902119668*r**18-1354483283590*r**20+502952216810*r**22-260731808310*r**24
            -128041759810*r**26-849843694*r**28-2886325038*r**30+235611890*r**32
            +1334003*r**34)-2*Q2*(-1+r**2)**2*(546072+39791845*r**2+2210458677*r**4
            -11357750884*r**6+174782380952*r**8-832676189112*r**10+2234802049732*r**12
            -2688237929060*r**14-653673046632*r**16+2389191338426*r**18+916836776678*r**20
            -2788047409164*r**22+1306795530664*r**24-351637605344*r**26-25239726828*r**28
            -10010572588*r**30-1725077488*r**32+31979769*r**34+598285*r**36)-2*Q2**3*(2779821
            +159668495*r**2+6651915830*r**4-26296567756*r**6+274448498228*r**8-615712068136*r**10
            +923952146168*r**12-313519799308*r**14+395765608070*r**16+1299760181774*r**18
            -2074691953756*r**20+134744197244*r**22+483846131876*r**24-458948899552*r**26
            -33833222152*r**28-17309373604*r**30-4735440907*r**32+166005227*r**34
            +3440438*r**36)+2*Q2**2*(1974459+125952524*r**2+6313263525*r**4-33402460296*r**6
            +423721105376*r**8-1773355582476*r**10+4238297227824*r**12-4806139130900*r**14
            +1601964946206*r**16-1958981929668*r**18+3500783344370*r**20+447407864460*r**22
            -3896240143560*r**24+2260921911676*r**26-618693140232*r**28-46722711228*r**30
            -17176776433*r**32-4777696440*r**34+122036289*r**36+2232524*r**38))+3483648000*logq2**5*(
            -Q2+(-1+r)**2)*r**18*(-225-156*r**2+26*r**4+924*r**6+207*r**8)*(-Q2
            +(1+r)**2)*sqrtq2+276480*logq2**3*r**10*(120*Q2**13*(1549+6185*r**4)-6*Q2**12*(354115
            +337394*r**2+1252291*r**4+1175840*r**6)+2*Q2**11*(5173530+9464949*r**2
            +21889965*r**4+29293871*r**6+14218365*r**8)-Q2**10*(27416970+73061289*r**2
            +160477758*r**4+236166932*r**6+186286256*r**8+62544915*r**10)+5*Q2**9*(8055045
            +29362194*r**2+67902261*r**4+109373792*r**6+106214243*r**8+61002062*r**10
            +16278435*r**12)-15*Q2**8*(1565619+10087488*r**2+22520673*r**4+41290352*r**6
            +48192157*r**8+37022992*r**10+17976863*r**12+4660080*r**14)+6*Q2**7*(
            -3790470+7193853*r**2-12407388*r**4-14601115*r**6+12697870*r**8+40062635*r**10
            +48075108*r**12+24173107*r**14+10439280*r**16)-6*Q2**6*(-9184380-11708634*r**2
            -98184090*r**4-192926441*r**6-195210780*r**8-119326005*r**10-10890034*r**12
            +43477005*r**14+17817044*r**16+12709035*r**18)+2*Q2**5*(-20167605-41750181*r**2
            -304209387*r**4-644480208*r**6-711818454*r**8-587792490*r**10-202363226*r**12
            +61757688*r**14+178807947*r**16+52017351*r**18+28579365*r**20)+10*Q2**4*(215340
            +4476033*r**2+12094302*r**4+45361086*r**6+48083250*r**8+47408730*r**10
            +14219906*r**12-10967728*r**14+18386898*r**16+2356581*r**18-4312176*r**20
            +1532370*r**22)+(-1+r**2)**4*(-576945+134046*r**2-20319789*r**4+18077156*r**6
            +54425266*r**8-59268204*r**10+86013114*r**12-58485816*r**14+18463839*r**16
            +52171054*r**18+3755219*r**20+3387060*r**22)-10*Q2**3*(-1765428+2913288*r**2
            -29668947*r**4+4330620*r**6+16010685*r**8-31583844*r**10-2886986*r**12
            +18003556*r**14-34312310*r**16+45837708*r**18+56877165*r**20-1392912*r**22
            +6935325*r**24)-Q2*(-1+r**2)**2*(-4426785+3882582*r**2-126901656*r**4
            +78660574*r**6+263836419*r**8-284126836*r**10+282716520*r**12+393634956*r**14
            -242486379*r**16+98415326*r**18+288022416*r**20+8661718*r**22+22319145*r**24)
            +Q2**2*(-13467990+25409421*r**2-316881726*r**4+299702450*r**6+325648860*r**8
            -707379885*r**10+382426708*r**12+723911292*r**14+939019410*r**16-604295165*r**18
            -122767830*r**20+614046066*r**22-39307096*r**24+58351485*r**26))*sqrtq2
            -192*logq2*r**2*(-4656*Q2**21*(-1+115*r**4)+4*Q2**20*(-15801-55790*r**2
            +1541031*r**4+2349720*r**6)-4*Q2**19*(-95670-621337*r**2+5109167*r**4
            +25835157*r**6+17886435*r**8)+Q2**18*(-1335135-13425518*r**2-37842350*r**4
            +362576908*r**6+692853237*r**8+313633410*r**10)+Q2**17*(2836200+50087426*r**2
            +603197070*r**4+39162108*r**6-1459670100*r**8-2432045742*r**10-871985490*r**12)
            +Q2**16*(-3278229-150840310*r**2-2891633827*r**4-4902389796*r**6-6830451435*r**8
            -2514852318*r**10+4471601235*r**12+1558818120*r**14)+4*Q2**15*(48144
            +92580701*r**2+2207308526*r**4+5523033821*r**6+12749345904*r**8+18479221383*r**10
            +9654866550*r**12-497333937*r**14-405454740*r**16)+4*Q2**14*(1495065
            -170328601*r**2-4600170054*r**4-14337475053*r**6-38873586580*r**8-79164043221*r**10
            -81323810742*r**12-35667594559*r**14-2584137849*r**16+98811930*r**18)
            +4*Q2**13*(-2401080+203436611*r**2+5988935480*r**4+23477151240*r**6+64223530478*r**8
            +168206973062*r**10+239276762802*r**12+189203192600*r**14+70058922914*r**16
            +6904122711*r**18+367077630*r**20)-4*Q2**12*(-1309425+94132597*r**2+2729693785*r**4
            +19988130340*r**6+25434173692*r**8+133437784054*r**10+279861712876*r**12
            +332983625212*r**14+237940437445*r**16+76570491325*r**18+8387565771*r**20
            +542407320*r**22)+4*Q2**11*(1052844-142371645*r**2-5904682056*r**4-4877536107*r**6
            -145198439682*r**8-276882814518*r**10-296903454480*r**12-148911477162*r**14
            +60483997008*r**16+115276514307*r**18+30891501512*r**20+4878112005*r**22
            +229442070*r**24)+2*Q2**10*(-4693377+620821344*r**2+26512180422*r**4
            +69579182046*r**6+737707848345*r**8+1976817902118*r**10+3154759387548*r**12
            +3402407732604*r**14+2277338670081*r**16+896231297628*r**18+187678236910*r**20
            +67607496070*r**22+869924055*r**24+420671550*r**26)-4*Q2**9*(-1471860
            +233475684*r**2+10793500341*r**4+39919153548*r**6+381765748560*r**8+1296480453948*r**10
            +2247837707709*r**12+2917024540224*r**14+2627653367316*r**16+1556785608780*r**18
            +649684351783*r**20+190497825412*r**22+62271302656*r**24+3112785156*r**26
            +316592055*r**28)+2*Q2**8*(476085-12778792*r**2-473318445*r**4+35960084328*r**6
            +90653251065*r**8+1437308832672*r**10+1920990090543*r**12+2876377540920*r**14
            +3754746815079*r**16+3559355772744*r**18+2019092128497*r**20+1029032416824*r**22
            +313383365355*r**24+97358569632*r**26+5528931213*r**28+194631240*r**30)
            +4*Q2**7*(-1020000+164896687*r**2+8878545730*r**4+2782992099*r**6+363292115904*r**8
            +38414949267*r**10+1006474201446*r**12+1466823330999*r**14+1020486412380*r**16
            -43173946851*r**18-869533390770*r**20-503183086215*r**22-473906992056*r**24
            -116203224351*r**26-27114986550*r**28-1637683539*r**30+105557820*r**32)
            +(-1+r**2)**6*(-2589+867032*r**2+79025576*r**4-74757304*r**6+9814794748*r**8
            -41669372096*r**10+119690495752*r**12-89157770792*r**14-448031220422*r**16
            +698992575904*r**18-152559801736*r**20-213097999240*r**22+89549984396*r**24
            -39850269024*r**26-3311482152*r**28-752119704*r**30-22197669*r**32+529320*r**34)
            -4*Q2**6*(-671109+138343415*r**2+8189024534*r**4+6629732339*r**6+440464005186*r**8
            +134512912893*r**10+1416860288130*r**12+2118761583519*r**14+1853200215372*r**16
            +1306250510415*r**18+300279072522*r**20-784626381975*r**22-237097629018*r**24
            -441582808401*r**26-87871526946*r**28-13070586171*r**30-762542895*r**32
            +114899790*r**34)-2*Q2*(-1+r**2)**4*(-16068+4842953*r**2+404677969*r**4
            -540318404*r**6+44122824984*r**8-160393820848*r**10+420388501964*r**12
            -195782422228*r**14-1264344722272*r**16+666588921242*r**18+1195463046150*r**20
            -594509528972*r**22-656585634296*r**24+294046533176*r**26-155034401076*r**28
            -12908133084*r**30-3208071420*r**32-107778795*r**34+3179025*r**36)+4*Q2**5*(
            -85476+33187213*r**2+2315234376*r**4+4338650436*r**6+176003994058*r**8
            -16487848992*r**10+453674808318*r**12+840998789772*r**14+229562458698*r**16
            +266488273722*r**18+306529972518*r**20+722025439164*r**22-353870126370*r**24
            +51536901336*r**26-97004463270*r**28-30344694540*r**30-388106510*r**32
            +16365057*r**34+30271290*r**36)+4*Q2**4*(-154470+27002323*r**2+1605580312*r**4
            -5168806992*r**6+92846502550*r**8-234030257156*r**10+638392504746*r**12
            -417085337712*r**14+272483516226*r**16+154749915930*r**18+431391882642*r**20
            +473879548464*r**22-1181795812782*r**24-548052993396*r**26+228242275710*r**28
            -305942628816*r**30-19990170308*r**32-9352837493*r**34-514864338*r**36
            +19966560*r**38)+Q2**2*(-1+r**2)**2*(-170775+45769664*r**2+3473155753*r**4
            -6905653302*r**6+330289307420*r**8-1118253748568*r**10+2830364862684*r**12
            -1662098482512*r**14-4358977280394*r**16+602605484520*r**18+1670832500086*r**20
            +3718578048020*r**22-2340701552100*r**24-3858301142216*r**26+1883328198620*r**28
            -973200521568*r**30-76784417943*r**32-22567950216*r**34-897000663*r**36
            +32033490*r**38)-4*Q2**3*(-119790+27788648*r**2+1883895545*r**4-5698579744*r**6
            +155047770251*r**8-541365721612*r**10+1378018879916*r**12-1343586806940*r**14
            -251324026200*r**16+389955930756*r**18-408042861546*r**20-710056392636*r**22
            +1484123986530*r**24-130431277188*r**26-1627416872340*r**28+897423708108*r**30
            -380184118978*r**32-24199924060*r**34-10073845543*r**36-501355092*r**38
            +20421915*r**40))*sqrtq2)*math.log(r))/(-88179840000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-1224720000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-850500*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5+211631616000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2+14696640000*logq2**3*(-Q2+(-1
            +r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+51030000*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2))
            +nlo.X1Q2_Derivativer(0,Q2,r)*((muWC*(-6048000*logq2**3*r**13*(1+r**2)*(19+10*r**2
            +19*r**4)-240*logq2*(-Q2+(-1+r)**2)*r**5*(-Q2+(1+r)**2)*(23-1440*Q2**9
            +10999*r**2+228160*r**4+383296*r**6+3006322*r**8+3006322*r**10+383296*r**12
            +228160*r**14+10999*r**16+23*r**18+10248*Q2**8*(1+r**2)-512*Q2**7*(37
            +94*r**2+37*r**4)+Q2**6*(4319+70769*r**2+70769*r**4+4319*r**6)+2*Q2**5*(8631
            -19072*r**2-30126*r**4-19072*r**6+8631*r**8)-Q2**4*(11375+66235*r**2
            +466262*r**4+466262*r**6+66235*r**8+11375*r**10)-4*Q2**3*(847-28698*r**2
            -220767*r**4-429164*r**6-220767*r**8-28698*r**10+847*r**12)+Q2**2*(3729
            -4117*r**2-37563*r**4-1070849*r**6-1070849*r**8-37563*r**10-4117*r**12
            +3729*r**14)-2*Q2*(217+25092*r**2+198688*r**4-394052*r**6-869490*r**8
            -394052*r**10+198688*r**12+25092*r**14+217*r**16))-14400*logq2**2*r**9*(781
            -80*Q2**6+4344*r**2+33555*r**4+43600*r**6+33555*r**8+4344*r**10+781*r**12
            +900*Q2**5*(1+r**2)-4*Q2**4*(951+1718*r**2+951*r**4)+Q2**3*(3931+13189*r**2
            +13189*r**4+3931*r**6)+Q2**2*(1131-5648*r**2-11126*r**4-5648*r**6+1131*r**8)
            -3*Q2*(953-829*r**2-3484*r**4-3484*r**6-829*r**8+953*r**10))*sqrtq2
            +4*r*(250*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4
            -2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2
            -6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4
            -26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6-31*r**8+r**10))-7*(
            -Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7
            +2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6-28170*r**8
            +31692*r**10-9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)+Q2**6*(
            -11+10*r**2-11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)+Q2**4*(
            -165+1480*r**2+10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2
            -6138*r**4-6138*r**6-355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4
            +35188*r**6+10313*r**8-406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4
            +6605*r**6+6605*r**8-7237*r**10-595*r**12+27*r**14)))*sqrtq2))/(163296000*logq2**4*r**16
            +6804000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+7875*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-54432000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-378000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +(muWC**2*(-1512000*logq2**3*r**13*(1+r**2)*(19+10*r**2+19*r**4)-60*logq2*(
            -Q2+(-1+r)**2)*r**5*(-Q2+(1+r)**2)*(23-1440*Q2**9+10999*r**2+228160*r**4
            +383296*r**6+3006322*r**8+3006322*r**10+383296*r**12+228160*r**14+10999*r**16
            +23*r**18+10248*Q2**8*(1+r**2)-512*Q2**7*(37+94*r**2+37*r**4)+Q2**6*(4319
            +70769*r**2+70769*r**4+4319*r**6)+2*Q2**5*(8631-19072*r**2-30126*r**4
            -19072*r**6+8631*r**8)-Q2**4*(11375+66235*r**2+466262*r**4+466262*r**6
            +66235*r**8+11375*r**10)-4*Q2**3*(847-28698*r**2-220767*r**4-429164*r**6
            -220767*r**8-28698*r**10+847*r**12)+Q2**2*(3729-4117*r**2-37563*r**4
            -1070849*r**6-1070849*r**8-37563*r**10-4117*r**12+3729*r**14)-2*Q2*(217
            +25092*r**2+198688*r**4-394052*r**6-869490*r**8-394052*r**10+198688*r**12
            +25092*r**14+217*r**16))-3600*logq2**2*r**9*(781-80*Q2**6+4344*r**2+33555*r**4
            +43600*r**6+33555*r**8+4344*r**10+781*r**12+900*Q2**5*(1+r**2)-4*Q2**4*(951
            +1718*r**2+951*r**4)+Q2**3*(3931+13189*r**2+13189*r**4+3931*r**6)+Q2**2*(1131
            -5648*r**2-11126*r**4-5648*r**6+1131*r**8)-3*Q2*(953-829*r**2-3484*r**4
            -3484*r**6-829*r**8+953*r**10))*sqrtq2+(250*r*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1
            +8*Q2**6-34*r**2-1133*r**4-2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1
            +r**2)+Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1
            -26*r**2-118*r**4-26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6
            -31*r**8+r**10))-7*(-Q2+(-1+r)**2)*r*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6
            -28170*r**8+31692*r**10-9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)
            +Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)
            +Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2
            -6138*r**4-6138*r**6-355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4
            +35188*r**6+10313*r**8-406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4
            +6605*r**6+6605*r**8-7237*r**10-595*r**12+27*r**14)))*sqrtq2))/(108864000*logq2**4*r**16
            +4536000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+5250*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-36288000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-252000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +(1512000*logq2**3*r**13*(1+r**2)*(19+10*r**2+19*r**4)+60*logq2*(-Q2
            +(-1+r)**2)*r**5*(-Q2+(1+r)**2)*(23-1440*Q2**9+10999*r**2+228160*r**4
            +383296*r**6+3006322*r**8+3006322*r**10+383296*r**12+228160*r**14+10999*r**16
            +23*r**18+10248*Q2**8*(1+r**2)-512*Q2**7*(37+94*r**2+37*r**4)+Q2**6*(4319
            +70769*r**2+70769*r**4+4319*r**6)+2*Q2**5*(8631-19072*r**2-30126*r**4
            -19072*r**6+8631*r**8)-Q2**4*(11375+66235*r**2+466262*r**4+466262*r**6
            +66235*r**8+11375*r**10)-4*Q2**3*(847-28698*r**2-220767*r**4-429164*r**6
            -220767*r**8-28698*r**10+847*r**12)+Q2**2*(3729-4117*r**2-37563*r**4
            -1070849*r**6-1070849*r**8-37563*r**10-4117*r**12+3729*r**14)-2*Q2*(217
            +25092*r**2+198688*r**4-394052*r**6-869490*r**8-394052*r**10+198688*r**12
            +25092*r**14+217*r**16))+3600*logq2**2*r**9*(781-80*Q2**6+4344*r**2+33555*r**4
            +43600*r**6+33555*r**8+4344*r**10+781*r**12+900*Q2**5*(1+r**2)-4*Q2**4*(951
            +1718*r**2+951*r**4)+Q2**3*(3931+13189*r**2+13189*r**4+3931*r**6)+Q2**2*(1131
            -5648*r**2-11126*r**4-5648*r**6+1131*r**8)-3*Q2*(953-829*r**2-3484*r**4
            -3484*r**6-829*r**8+953*r**10))*sqrtq2+(-250*r*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4-2708*r**6-1133*r**8-34*r**10
            +r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1-19*r**2
            -19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4-26*r**6+r**8)+Q2*(1-31*r**2
            -390*r**4-390*r**6-31*r**8+r**10))+7*(-Q2+(-1+r)**2)*r*(-Q2+(1
            +r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8
            -444*r**2-9976*r**4+31692*r**6-28170*r**8+31692*r**10-9976*r**12-444*r**14
            +13*r**16-24*Q2**7*(1+r**2)+Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61
            -193*r**2-193*r**4+61*r**6)+Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6
            -165*r**8)+4*Q2**3*(13-355*r**2-6138*r**4-6138*r**6-355*r**8+13*r**10)
            +Q2**2*(59-406*r**2+10313*r**4+35188*r**6+10313*r**8-406*r**10+59*r**12)
            -2*Q2*(27-595*r**2-7237*r**4+6605*r**6+6605*r**8-7237*r**10-595*r**12
            +27*r**14)))*sqrtq2)/(54432000*logq2**4*r**16+2268000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+2625*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-18144000*logq2**3*r**12*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2-126000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((1512000*logq2**3*r**13*(1+r**2)*(19
            +10*r**2+19*r**4)+60*logq2*(-Q2+(-1+r)**2)*r**5*(-Q2+(1+r)**2)*(23
            -1440*Q2**9+10999*r**2+228160*r**4+383296*r**6+3006322*r**8+3006322*r**10
            +383296*r**12+228160*r**14+10999*r**16+23*r**18+10248*Q2**8*(1+r**2)
            -512*Q2**7*(37+94*r**2+37*r**4)+Q2**6*(4319+70769*r**2+70769*r**4+4319*r**6)
            +2*Q2**5*(8631-19072*r**2-30126*r**4-19072*r**6+8631*r**8)-Q2**4*(11375
            +66235*r**2+466262*r**4+466262*r**6+66235*r**8+11375*r**10)-4*Q2**3*(847
            -28698*r**2-220767*r**4-429164*r**6-220767*r**8-28698*r**10+847*r**12)
            +Q2**2*(3729-4117*r**2-37563*r**4-1070849*r**6-1070849*r**8-37563*r**10
            -4117*r**12+3729*r**14)-2*Q2*(217+25092*r**2+198688*r**4-394052*r**6
            -869490*r**8-394052*r**10+198688*r**12+25092*r**14+217*r**16))+3600*logq2**2*r**9*(781
            -80*Q2**6+4344*r**2+33555*r**4+43600*r**6+33555*r**8+4344*r**10+781*r**12
            +900*Q2**5*(1+r**2)-4*Q2**4*(951+1718*r**2+951*r**4)+Q2**3*(3931+13189*r**2
            +13189*r**4+3931*r**6)+Q2**2*(1131-5648*r**2-11126*r**4-5648*r**6+1131*r**8)
            -3*Q2*(953-829*r**2-3484*r**4-3484*r**6-829*r**8+953*r**10))*sqrtq2
            +(-250*r*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4
            -2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2
            -6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4
            -26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6-31*r**8+r**10))+7*(
            -Q2+(-1+r)**2)*r*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6-28170*r**8
            +31692*r**10-9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)+Q2**6*(
            -11+10*r**2-11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)+Q2**4*(
            -165+1480*r**2+10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2
            -6138*r**4-6138*r**6-355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4
            +35188*r**6+10313*r**8-406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4
            +6605*r**6+6605*r**8-7237*r**10-595*r**12+27*r**14)))*sqrtq2)*math.log(mu0))/(36288000*logq2**4*r**16
            +1512000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+1750*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-12096000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-84000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((-1512000*logq2**3*r**13*(1+r**2)*(19+10*r**2+19*r**4)-60*logq2*(-Q2
            +(-1+r)**2)*r**5*(-Q2+(1+r)**2)*(23-1440*Q2**9+10999*r**2+228160*r**4
            +383296*r**6+3006322*r**8+3006322*r**10+383296*r**12+228160*r**14+10999*r**16
            +23*r**18+10248*Q2**8*(1+r**2)-512*Q2**7*(37+94*r**2+37*r**4)+Q2**6*(4319
            +70769*r**2+70769*r**4+4319*r**6)+2*Q2**5*(8631-19072*r**2-30126*r**4
            -19072*r**6+8631*r**8)-Q2**4*(11375+66235*r**2+466262*r**4+466262*r**6
            +66235*r**8+11375*r**10)-4*Q2**3*(847-28698*r**2-220767*r**4-429164*r**6
            -220767*r**8-28698*r**10+847*r**12)+Q2**2*(3729-4117*r**2-37563*r**4
            -1070849*r**6-1070849*r**8-37563*r**10-4117*r**12+3729*r**14)-2*Q2*(217
            +25092*r**2+198688*r**4-394052*r**6-869490*r**8-394052*r**10+198688*r**12
            +25092*r**14+217*r**16))-3600*logq2**2*r**9*(781-80*Q2**6+4344*r**2+33555*r**4
            +43600*r**6+33555*r**8+4344*r**10+781*r**12+900*Q2**5*(1+r**2)-4*Q2**4*(951
            +1718*r**2+951*r**4)+Q2**3*(3931+13189*r**2+13189*r**4+3931*r**6)+Q2**2*(1131
            -5648*r**2-11126*r**4-5648*r**6+1131*r**8)-3*Q2*(953-829*r**2-3484*r**4
            -3484*r**6-829*r**8+953*r**10))*sqrtq2+(250*r*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1
            +8*Q2**6-34*r**2-1133*r**4-2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1
            +r**2)+Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1
            -26*r**2-118*r**4-26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6
            -31*r**8+r**10))-7*(-Q2+(-1+r)**2)*r*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6
            -28170*r**8+31692*r**10-9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)
            +Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)
            +Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2
            -6138*r**4-6138*r**6-355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4
            +35188*r**6+10313*r**8-406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4
            +6605*r**6+6605*r**8-7237*r**10-595*r**12+27*r**14)))*sqrtq2)*math.log(r))/(36288000*logq2**4*r**16
            +1512000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+1750*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-12096000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-84000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2))
            +muWC*((pi2*(-16*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(-57-24*Q2**14+3714*r**2+43777*r**4
            -3791308*r**6-10159121*r**8+15296334*r**10-236289183*r**12+694656216*r**14
            -815729139*r**16+457228062*r**18-127046277*r**20+25369844*r**22+93757*r**24
            +322322*r**26+1059*r**28-56*Q2**13*(1+r**2)+Q2**12*(1457-3446*r**2
            -1627*r**4)+4*Q2**11*(-1615+8387*r**2+54679*r**4+3797*r**6)-4*Q2**10*(
            -3472+30654*r**2+403567*r**4+338572*r**6+11639*r**8)+4*Q2**9*(-4008
            +54495*r**2+1044380*r**4+2055110*r**6+727340*r**8+15387*r**10)-Q2**8*(
            -8157+170178*r**2+3813345*r**4+13564420*r**6+12323485*r**8+1013978*r**10
            +15423*r**12)-8*Q2**7*(-207+2181*r**2+203412*r**4-98905*r**6+1778395*r**8
            +542973*r**10+651616*r**12+6327*r**14)+8*Q2**6*(-420+13398*r**2+622461*r**4
            +1572643*r**6+10153075*r**8+11587780*r**10+3383193*r**12+891191*r**14
            +5943*r**16)+8*Q2**5*(-57-1356*r**2-185973*r**4-797988*r**6-6859881*r**8
            -23311392*r**10-9155691*r**12-2312708*r**14-8398*r**16+1284*r**18)-Q2**4*(
            -1931+71530*r**2+2109045*r**4-6455760*r**6+15777210*r**8-44549788*r**10
            -138504270*r**12+88484320*r**14+7369665*r**16+5785410*r**18+34249*r**20)
            +4*Q2**3*(-119+8471*r**2+323305*r**4-3050295*r**6-3025010*r**8-6052382*r**10
            +19084558*r**12-13941570*r**14+34632105*r**16+3167815*r**18+818121*r**20
            +3001*r**22)+4*Q2**2*(-122+4186*r**2+58337*r**4+87590*r**6+5884315*r**8
            +13803764*r**10+13722438*r**12-4033124*r**14-12132160*r**16-2175310*r**18
            -930087*r**20+223806*r**22+1567*r**24)-4*Q2*(-80+4233*r**2+73226*r**4
            -2220242*r**6-2960350*r**8-2058365*r**10-5455156*r**12-38454012*r**14
            +85305484*r**16-50223425*r**18+15606570*r**20+53198*r**22+327586*r**24
            +1333*r**26))-16*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(192*Q2**19
            +88*Q2**18*(1+r**2)+16*Q2**17*(-781+1642*r**2+761*r**4)-Q2**16*(-73775
            +297995*r**2+1825599*r**4+145669*r**6)+4*Q2**15*(-51861+340660*r**2
            +4186230*r**4+3591900*r**6+150207*r**8)-2*Q2**14*(-160967+1597940*r**2
            +30027301*r**4+56976461*r**6+22270690*r**8+587263*r**10)+4*Q2**13*(-60326
            +917894*r**2+24316527*r**4+81644768*r**6+73261216*r**8+12910234*r**10
            +223639*r**12)+Q2**12*(-25402-563876*r**2-38459200*r**4-358564138*r**6
            -438041866*r**8-228371272*r**10+37752324*r**12+634262*r**14)-4*Q2**11*(
            -48165+833580*r**2+23734310*r**4+18524260*r**6+191728516*r**8+235832836*r**10
            +95582026*r**12+40901932*r**14+427377*r**16)+2*Q2**10*(-43329+1222980*r**2
            +58336869*r**4+277843715*r**6+1545154811*r**8+3240493627*r**10+1729299335*r**12
            +475011561*r**14+58601370*r**16+322773*r**18)+4*Q2**9*(-21736+513590*r**2
            +4363551*r**4-147373004*r**6-899717980*r**8-3213841264*r**10-3392656990*r**12
            -715979284*r**14-140458404*r**16+25380890*r**18+279719*r**20)-2*Q2**8*(
            -45422+1641233*r**2+48534133*r**4-170257418*r**6-588840656*r**8-4624178418*r**10
            -7526070378*r**12-4253144032*r**14+1312661502*r**16+216617569*r**18+93325493*r**20
            +565738*r**22)+4*Q2**7*(1573+68684*r**2+7392018*r**4+10756724*r**6+339887083*r**8
            +998967992*r**10+4261569596*r**12+4797578744*r**14+3260448139*r**16+1591348508*r**18
            +211851218*r**20+7629684*r**22-31163*r**24)+2*Q2**6*(-19635+801700*r**2
            +18156501*r**4-209461039*r**6-777053636*r**8-5007634041*r**10-23534560726*r**12
            -47692110982*r**14-28406379147*r**16-14011017886*r**18-1356019711*r**20
            -196567371*r**22+50182914*r**24+310899*r**26)-4*Q2**5*(-2162+153710*r**2
            +5399059*r**4-79097960*r**6-98177028*r**8-1165588042*r**10-5991109955*r**12
            -22670582320*r**14-29948143010*r**16-3934803926*r**18-3395263571*r**20
            +710056600*r**22+51425816*r**24+13953970*r**26+44419*r**28)-2*Q2**4*(
            -4909+213490*r**2+2377176*r**4-49489669*r**6+14947725*r**8+1709875624*r**10
            +1532121230*r**12+5085336893*r**14+21487760013*r**16+14689327610*r**18
            -27876860036*r**20-6085393995*r**22-1579897069*r**24-173066644*r**26
            +9858590*r**28+74771*r**30)+4*Q2**3*(-1157+73388*r**2+1303102*r**4-47410252*r**6
            +61818306*r**8+1239105212*r**10+3689404902*r**12+6233169716*r**14-1101385656*r**16
            -2238290812*r**18-13322010758*r**20-9973666948*r**22-3947265218*r**24
            -103450092*r**26-30318494*r**28+5590428*r**30+22333*r**32)+2*Q2**2*(
            -447+17184*r**2-132149*r**4+9379321*r**6+7830667*r**8+285387037*r**10
            -2214797369*r**12-19284105635*r**14-4305412287*r**16+5509203441*r**18
            -32929105263*r**20+37591020251*r**22-6331072423*r**24+1139137991*r**26
            -350402083*r**28-28432177*r**30-408166*r**32+4107*r**34)-12*Q2*(-80
            +5330*r**2+24149*r**4-3731276*r**6+20537872*r**8+346607692*r**10+751218972*r**12
            +574534900*r**14+4976184960*r**16-7844999744*r**18+9208651006*r**20-10784577284*r**22
            +4395066128*r**24-1287006892*r**26-321630628*r**28-26504868*r**30-4690768*r**32
            +309198*r**34+1333*r**36)+3*(-57+4455*r**2+1651*r**4-4755365*r**6
            +33999596*r**8+552049916*r**10+1070939420*r**12+3260927372*r**14+14149245010*r**16
            -38650944158*r**18+10091920314*r**20+31128267770*r**22-24690211972*r**24
            +4220464300*r**26-645428372*r**28-501804548*r**30-10774145*r**32-4210801*r**34
            +308555*r**36+1059*r**38))*sqrtq2+logq2**5*(52254720000*(-Q2+(-1+r)**2)*(
            -1+r)*r**22*(1+r)*(1+r**2)*(3+r**2)*(1-Q2+r**2)*(-Q2+(1+r)**2)
            +52254720000*r**22*(-3-r**2+3*r**4+r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2**4*(41472000*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-480*Q2**6*(1+r**2)+240*Q2**5*(5+17*r**2+12*r**4)-8*Q2**4*(
            -171+503*r**2+1483*r**4+837*r**6)+Q2**3*(-4197-7411*r**2+4737*r**4
            +14275*r**6+6324*r**8)+Q2**2*(-1257+7268*r**2+10278*r**4-3876*r**6
            -5213*r**8+864*r**10)+Q2*(8403+813*r**2-8928*r**4+1020*r**6+5961*r**8
            -1833*r**10-5436*r**12)+3*(-1679-852*r**2-3925*r**4+1808*r**6+4783*r**8
            -908*r**10-75*r**12+848*r**14))+41472000*r**18*(480*Q2**9*(1+r**2)-240*Q2**8*(11
            +29*r**2+18*r**4)+8*Q2**7*(459+2783*r**2+4393*r**4+2097*r**6)-7*Q2**6*(
            -603+2171*r**2+10263*r**4+12565*r**6+5076*r**8)+2*Q2**5*(-7119-14938*r**2
            +9418*r**4+55520*r**6+58597*r**8+20538*r**10)-5*Q2**4*(-357-8491*r**2
            -13112*r**4+264*r**6+16085*r**8+14371*r**10+3528*r**12)+3*(-1+r**2)**3*(1679
            +4210*r**2+8987*r**4+11104*r**6+4513*r**8+638*r**10+1621*r**12+848*r**14)
            -4*Q2**3*(-7455-1925*r**2+9456*r**4+11782*r**6+5237*r**8-4677*r**10
            -70*r**12+3780*r**14)+Q2**2*(-41577-33499*r**2-38777*r**4-29375*r**6
            +61833*r**8+45623*r**10-6283*r**12+17251*r**14+24804*r**16)-6*Q2*(
            -3919-1692*r**2-6234*r**4-5414*r**6+648*r**8+9090*r**10+7578*r**12
            -2370*r**14+135*r**16+2178*r**18))*sqrtq2)+logq2**3*(1382400*r**14*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(640*Q2**10-80*Q2**9*(81
            +109*r**2)+4*Q2**8*(6629+17565*r**2+10744*r**4)-4*Q2**7*(13937+55577*r**2
            +67087*r**4+24047*r**6)+Q2**6*(60123+300955*r**2+587331*r**4+441405*r**6
            +78778*r**8)+2*Q2**5*(-16898-61691*r**2-162424*r**4-207494*r**6-100006*r**8
            +29057*r**10)+Q2**4*(16975+47435*r**2+31266*r**4-542330*r**6-664749*r**8
            -296465*r**10-153860*r**12)+8*Q2**3*(-612-26545*r**2-80570*r**4-24933*r**6
            +148772*r**8+150185*r**10+50490*r**12+9293*r**14)+Q2**2*(-18307+97573*r**2
            +284079*r**4+1148689*r**6+348657*r**8-593941*r**10-206511*r**12-131617*r**14
            +39058*r**16)-6*Q2*(-3612-26855*r**2-171020*r**4+66960*r**6+131432*r**8
            -110278*r**10-16620*r**12+116040*r**14+6060*r**16+7893*r**18)+3*(-2233
            -36861*r**2-247472*r**4+80392*r**6-1734*r**8+157026*r**10-12024*r**12
            -73288*r**14+124223*r**16+7899*r**18+4072*r**20))+1382400*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(640*Q2**10-80*Q2**9*(81+109*r**2)+4*Q2**8*(6629
            +17565*r**2+10744*r**4)-4*Q2**7*(13937+55577*r**2+67087*r**4+24047*r**6)
            +Q2**6*(60123+300955*r**2+587331*r**4+441405*r**6+78778*r**8)+2*Q2**5*(
            -16898-61691*r**2-162424*r**4-207494*r**6-100006*r**8+29057*r**10)
            +Q2**4*(16975+47435*r**2+31266*r**4-542330*r**6-664749*r**8-296465*r**10
            -153860*r**12)+8*Q2**3*(-612-26545*r**2-80570*r**4-24933*r**6+148772*r**8
            +150185*r**10+50490*r**12+9293*r**14)+Q2**2*(-18307+97573*r**2+284079*r**4
            +1148689*r**6+348657*r**8-593941*r**10-206511*r**12-131617*r**14+39058*r**16)
            -6*Q2*(-3612-26855*r**2-171020*r**4+66960*r**6+131432*r**8-110278*r**10
            -16620*r**12+116040*r**14+6060*r**16+7893*r**18)+3*(-2233-36861*r**2
            -247472*r**4+80392*r**6-1734*r**8+157026*r**10-12024*r**12-73288*r**14
            +124223*r**16+7899*r**18+4072*r**20))*sqrtq2)+logq2**2*(-23040*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-11520*Q2**13+16*Q2**12*(5467+6129*r**2)
            -4*Q2**11*(68411+162683*r**2+81472*r**4)+4*Q2**10*(107538+445435*r**2
            +488576*r**4+115431*r**6)-5*Q2**9*(63513+485409*r**2+836313*r**4+525503*r**6
            +2286*r**8)-5*Q2**8*(-4311-255372*r**2-156518*r**4+31124*r**6-37219*r**8
            +156696*r**10)+2*Q2**7*(81363+461006*r**2+6476095*r**4+14718735*r**6
            +9881570*r**8+2230843*r**10+395556*r**12)+2*Q2**6*(-94431-969843*r**2
            -10679877*r**4-36028570*r**6-43245765*r**8-16754391*r**10-2859143*r**12
            +57588*r**14)+2*Q2**5*(47838+668895*r**2+5004941*r**4+24313856*r**6
            +53179760*r**8+38935933*r**10+2545855*r**12+477316*r**14-311994*r**16)
            +10*Q2**4*(7224-70913*r**2-290236*r**4-202923*r**6-798008*r**8-100423*r**10
            +2309292*r**12+3683419*r**14+392144*r**16+26328*r**18)+10*Q2**3*(-11161
            +33744*r**2+830991*r**4+3372825*r**6+3077805*r**8-4134399*r**10-9993411*r**12
            -7592889*r**14-3011748*r**16-312497*r**18+11460*r**20)-2*Q2**2*(-4051
            -179437*r**2+431045*r**4+16351470*r**6+33703410*r**8+33675702*r**10
            -9064446*r**12-13787040*r**14-19815615*r**16+2099095*r**18+83929*r**20
            +51538*r**22)+3*Q2*(13227-202019*r**2-2912411*r**4-6759935*r**6-28658760*r**8
            +21190806*r**10+3415638*r**12-11047218*r**14+22869135*r**16-2508915*r**18
            +4245317*r**20+351281*r**22+3854*r**24)+3*(-4801+73290*r**2+1453338*r**4
            +5865698*r**6+26364045*r**8-33625068*r**10-10397140*r**12+19279324*r**14
            +7418889*r**16-15437670*r**18+375994*r**20-1257150*r**22-110037*r**24
            +1288*r**26))-23040*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(11520*Q2**14
            -16*Q2**13*(6187+6849*r**2)+4*Q2**12*(90279+209067*r**2+105988*r**4)
            -4*Q2**11*(175949+676529*r**2+732731*r**4+196903*r**6)+Q2**10*(747717
            +4638937*r**2+7917609*r**4+5043543*r**6+473154*r**8)+10*Q2**9*(-33912
            -402147*r**2-739120*r**4-665346*r**6-282504*r**8+77205*r**10)-Q2**8*(141171
            -376403*r**2+10892740*r**4+28810500*r**6+19732665*r**8+5059071*r**10
            +1574592*r**12)+4*Q2**7*(87897+756106*r**2+8808489*r**4+28611700*r**6
            +33923035*r**8+14433402*r**10+2742771*r**12+168984*r**14)+2*Q2**6*(-142269
            -1733169*r**2-16654661*r**4-71022303*r**6-132454095*r**8-98936089*r**10
            -22159389*r**12-3278871*r**14+369582*r**16)-4*Q2**5*(-5859-535649*r**2
            -3562508*r**4-15166706*r**6-40741828*r**8-46308904*r**10-14967664*r**12
            +7696962*r**14+897699*r**16+221817*r**18)+10*Q2**4*(18385-97433*r**2
            -1192140*r**4-3865984*r**6-4078736*r**8+3235968*r**10+12202280*r**12
            +13585600*r**14+7087311*r**16+730969*r**18+14868*r**20)+4*Q2**3*(-29928
            -33261*r**2+2377360*r**4+18685275*r**6+32978280*r**8+14196366*r**10
            -39851748*r**12-50859270*r**14-36419400*r**16-7261065*r**18-710628*r**20
            +54419*r**22)-Q2**2*(31579-973033*r**2-8234017*r**4+13285225*r**6+14133480*r**8
            +198330642*r**10+59469426*r**12-78844626*r**14+1402095*r**16-42959785*r**18
            +17101999*r**20+1324777*r**22+114638*r**24)+6*Q2*(9014-131041*r**2
            -2283884*r**4-7769022*r**6-30891370*r**8+13078557*r**10+17501792*r**12
            -13455452*r**14+2201514*r**16+17898945*r**18+680204*r**20+2926874*r**22
            +232586*r**24+1283*r**26)+3*(-4801+68489*r**2+1526628*r**4+7319036*r**6
            +32229743*r**8-7261023*r**10-44022208*r**12+8882184*r**14+26698213*r**16
            -8018781*r**18-15061676*r**20-881156*r**22-1367187*r**24-108749*r**26
            +1288*r**28))*sqrtq2)+logq2*(-192*r**6*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-24832*Q2**16+32*Q2**15*(8831+7391*r**2)-8*Q2**14*(147195
            +310747*r**2+105120*r**4)+8*Q2**13*(279085+1071463*r**2+949863*r**4
            +149925*r**6)+Q2**12*(-1391025-11171351*r**2-11059123*r**4-7147001*r**6
            +269140*r**8)-4*Q2**11*(414176+330159*r**2+10560284*r**4+12969654*r**6
            +2738804*r**8+730411*r**10)+2*Q2**10*(1413177+8996279*r**2+77432240*r**4
            +176075950*r**6+92391625*r**8+15299499*r**10+1319262*r**12)+4*Q2**9*(33930
            -4236587*r**2-47505400*r**4-190977325*r**6-205409750*r**8-43791325*r**10
            -4054812*r**12+365205*r**14)+Q2**8*(-2632035+5002867*r**2+85605557*r**4
            +659131035*r**6+1143100575*r**8+638600425*r**10-124396393*r**12-20966583*r**14
            -3625800*r**16)+8*Q2**7*(139700+319169*r**2+4626662*r**4+18149174*r**6
            +127385300*r**8+158298110*r**10+87545574*r**12+46580062*r**14+3632844*r**16
            +113165*r**18)+4*Q2**6*(264701-1959057*r**2-23969242*r**4-170495852*r**6
            -1024048542*r**8-2141159326*r**10-1374332532*r**12-467276692*r**14-48003727*r**16
            -828817*r**18+461246*r**20)-8*Q2**5*(102873-886356*r**2-9947845*r**4
            -39908980*r**6-335013240*r**8-1271910682*r**10-1593563812*r**12-437240570*r**14
            -133478905*r**16+18659510*r**18+1671809*r**20+146598*r**22)-Q2**4*(178535
            -1807199*r**2+4007465*r**4+95382675*r**6+114198850*r**8+434581850*r**10
            +5891720898*r**12+2616114550*r**14-4645644325*r**16-790689275*r**18-202457835*r**20
            -7395849*r**22+340860*r**24)+4*Q2**3*(69120-1294299*r**2-9485184*r**4
            +91618610*r**6+368745300*r**8+471635775*r**10-425924192*r**12-911801092*r**14
            -1620955560*r**16-1492129325*r**18-296233120*r**20-10748334*r**22+229076*r**24
            +113225*r**26)-2*Q2**2*(5975-383687*r**2-7406276*r**4+54726358*r**6
            +412512145*r**8+2909071835*r**10+3068697954*r**12+375339252*r**14-442052871*r**16
            -2804453825*r**18-5148760*r**20-99536842*r**22+21319199*r**24+944813*r**26
            +12730*r**28)-12*Q2*(3814-119447*r**2-461392*r**4+24862223*r**6+112256118*r**8
            +66295181*r**10+569882944*r**12-240045341*r**14+20753954*r**16-712704661*r**18
            +365365296*r**20-178749747*r**22-25078142*r**24-2222177*r**26-44832*r**28
            +6209*r**30)+3*(3721-172681*r**2-1008755*r**4+54892795*r**6+237587485*r**8
            +542905027*r**10+2875929953*r**12-7282941065*r**14+2909531835*r**16+3719437205*r**18
            -3432125417*r**20+628651937*r**22-210248305*r**24-40930255*r**26-1506565*r**28
            -13331*r**30+6416*r**32))+192*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(24832*Q2**16
            -32*Q2**15*(8831+7391*r**2)+8*Q2**14*(147195+310747*r**2+105120*r**4)
            -8*Q2**13*(279085+1071463*r**2+949863*r**4+149925*r**6)+Q2**12*(1391025
            +11171351*r**2+11059123*r**4+7147001*r**6-269140*r**8)+4*Q2**11*(414176
            +330159*r**2+10560284*r**4+12969654*r**6+2738804*r**8+730411*r**10)
            -2*Q2**10*(1413177+8996279*r**2+77432240*r**4+176075950*r**6+92391625*r**8
            +15299499*r**10+1319262*r**12)-4*Q2**9*(33930-4236587*r**2-47505400*r**4
            -190977325*r**6-205409750*r**8-43791325*r**10-4054812*r**12+365205*r**14)
            +Q2**8*(2632035-5002867*r**2-85605557*r**4-659131035*r**6-1143100575*r**8
            -638600425*r**10+124396393*r**12+20966583*r**14+3625800*r**16)-8*Q2**7*(139700
            +319169*r**2+4626662*r**4+18149174*r**6+127385300*r**8+158298110*r**10
            +87545574*r**12+46580062*r**14+3632844*r**16+113165*r**18)+4*Q2**6*(
            -264701+1959057*r**2+23969242*r**4+170495852*r**6+1024048542*r**8+2141159326*r**10
            +1374332532*r**12+467276692*r**14+48003727*r**16+828817*r**18-461246*r**20)
            +8*Q2**5*(102873-886356*r**2-9947845*r**4-39908980*r**6-335013240*r**8
            -1271910682*r**10-1593563812*r**12-437240570*r**14-133478905*r**16+18659510*r**18
            +1671809*r**20+146598*r**22)+Q2**4*(178535-1807199*r**2+4007465*r**4
            +95382675*r**6+114198850*r**8+434581850*r**10+5891720898*r**12+2616114550*r**14
            -4645644325*r**16-790689275*r**18-202457835*r**20-7395849*r**22+340860*r**24)
            -4*Q2**3*(69120-1294299*r**2-9485184*r**4+91618610*r**6+368745300*r**8
            +471635775*r**10-425924192*r**12-911801092*r**14-1620955560*r**16-1492129325*r**18
            -296233120*r**20-10748334*r**22+229076*r**24+113225*r**26)+2*Q2**2*(5975
            -383687*r**2-7406276*r**4+54726358*r**6+412512145*r**8+2909071835*r**10
            +3068697954*r**12+375339252*r**14-442052871*r**16-2804453825*r**18-5148760*r**20
            -99536842*r**22+21319199*r**24+944813*r**26+12730*r**28)+12*Q2*(3814
            -119447*r**2-461392*r**4+24862223*r**6+112256118*r**8+66295181*r**10
            +569882944*r**12-240045341*r**14+20753954*r**16-712704661*r**18+365365296*r**20
            -178749747*r**22-25078142*r**24-2222177*r**26-44832*r**28+6209*r**30)
            -3*(3721-172681*r**2-1008755*r**4+54892795*r**6+237587485*r**8+542905027*r**10
            +2875929953*r**12-7282941065*r**14+2909531835*r**16+3719437205*r**18
            -3432125417*r**20+628651937*r**22-210248305*r**24-40930255*r**26-1506565*r**28
            -13331*r**30+6416*r**32))*sqrtq2)))/(-31500*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))-31500*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2+logq2**5*(-117573120000*r**22*(1+r**2)*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            +117573120000*r**22*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**2*(-27216000*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8
            +3*Q2**3*(1+r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4
            +7*r**6))-27216000*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8
            +3*Q2**3*(1+r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4
            +7*r**6))*sqrtq2)+logq2**3*(108864000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))+108864000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))*sqrtq2)+logq2**4*(-653184000*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(63+8*Q2**4-402*r**2
            -1122*r**4-402*r**6+63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)
            -3*Q2*(19+31*r**2+31*r**4+19*r**6))-653184000*(-Q2+(-1+r)**2)*r**18*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(63+8*Q2**4-402*r**2-1122*r**4-402*r**6
            +63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)-3*Q2*(19+31*r**2
            +31*r**4+19*r**6))*sqrtq2)+logq2*(378000*(-Q2+(-1+r)**2)*r**6*(1-Q2
            +r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1
            +r**2)-Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)
            +3*(9-86*r**2-446*r**4-86*r**6+9*r**8))+378000*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1+r**2)
            -Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)+3*(9
            -86*r**2-446*r**4-86*r**6+9*r**8))*sqrtq2))+(-32*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(
            -4392*Q2**19+Q2**18*(2928-1936*r**2)+Q2**17*(288591-683834*r**2-381701*r**4)
            +Q2**16*(-2011353+8784845*r**2+58164729*r**4+5220371*r**6)-2*Q2**15*(
            -3306993+23330831*r**2+296946238*r**4+268389271*r**6+13021709*r**8)
            +2*Q2**14*(-6181557+66387950*r**2+1236811799*r**4+2305099931*r**6+1026075038*r**8
            +33746423*r**10)-2*Q2**13*(-6101403+102859601*r**2+2513321605*r**4+7443325570*r**6
            +6956671291*r**8+1803420685*r**10+46918331*r**12)+2*Q2**12*(-573339+58714966*r**2
            +1932283860*r**4+9983572205*r**6+11862274177*r**8+7932299036*r**10+549465222*r**12
            +23429089*r**14)+2*Q2**11*(-6606483+76108745*r**2+1855237556*r**4-1061249897*r**6
            +12324333000*r**8+16337089839*r**10+4510446976*r**12+3416610209*r**14
            +26874791*r**16)-2*Q2**10*(-8347911+168950342*r**2+5101155923*r**4+11140177125*r**6
            +55896303253*r**8+113341658665*r**10+71082118321*r**12+21441110607*r**14
            +5611997678*r**16+44762333*r**18)+2*Q2**9*(-3715998+102730925*r**2+2952017392*r**4
            +10090203608*r**6+44070476324*r**8+175030218218*r**10+197328715880*r**12
            +61966345712*r**14+19723790258*r**16+1394504209*r**18+4011392*r**20)
            +2*Q2**8*(-980148+31408531*r**2+2086811875*r**4-3603771420*r**6+20712621672*r**8
            -113956511826*r**10-230907877306*r**12-154078862520*r**14+34814483820*r**16
            -1940252193*r**18+5005339063*r**20+39368116*r**22)-2*Q2**7*(-1429779
            +65056981*r**2+3445388766*r**4-4495527815*r**6+39825357309*r**8-75353749286*r**10
            -258876577444*r**12-285433706902*r**14-95147104865*r**16+84878299329*r**18
            +8091056086*r**20+5296881933*r**22+30968839*r**24)-2*Q2**6*(-247233-1151330*r**2
            -810588097*r**4+308745575*r**6-9411284900*r**8+65417783987*r**10+275390499102*r**12
            +414615952870*r**14+305639163303*r**16-15253346380*r**18-21743461469*r**20
            -8216930893*r**22-97726786*r**24+4870651*r**26)+2*Q2**5*(-841251+39398077*r**2
            +1103155225*r**4-12153526922*r**6+2321306773*r**8-17040156737*r**10+109181696921*r**12
            +161536895780*r**14+125406253631*r**16+77170982267*r**18-307100486429*r**20
            +42568093990*r**22-8903883377*r**24+3059331529*r**26+18902443*r**28)
            -2*Q2**4*(-292251+20805250*r**2+750901316*r**4-12908679211*r**6-2409732913*r**8
            -48467116344*r**10+7112233050*r**12+258585991303*r**14-351028965373*r**16
            -218543975654*r**18-35806778544*r**20-411173655645*r**22+31239772361*r**24
            -6379124836*r**26+1824687122*r**28+8506369*r**30)-2*Q2**3*(-138531+4564837*r**2
            -4713480*r**4+1102157735*r**6+2634337006*r**8+9698064949*r**10-24470190372*r**12
            -381294793745*r**14+37802900940*r**16+91464075303*r**18+73186711840*r**20
            +22265677293*r**22+91862895850*r**24+5330355775*r**26-934429684*r**28
            +129582717*r**30+1693567*r**32)+(-1+r**2)**2*(-10431+820455*r**2+9753838*r**4
            -1136279318*r**6+407079954*r**8+17745762390*r**10-127313227834*r**12
            +787496484242*r**14-1878911528364*r**16+1865181807972*r**18-582151657302*r**20
            -188456941282*r**22+137139675422*r**24-58741334118*r**26+1574810274*r**28
            -778717082*r**30+64055611*r**32+261573*r**34)+2*Q2**2*(-142923+8357182*r**2
            +138553819*r**4-5283062095*r**6+4104268707*r**8+13124415573*r**10-94957363001*r**12
            +340615521125*r**14+111424503665*r**16-222704905659*r**18-186146142367*r**20
            -261513404509*r**22+281971418593*r**24-183692294145*r**26+16292359677*r**28
            -4377813433*r**30+553409878*r**32+2895913*r**34)-Q2*(-89853+6320120*r**2
            +90804035*r**4-6312391848*r**6+8522758300*r**8+45837398904*r**10-331557505252*r**12
            +1830999472824*r**14-2840985438758*r**16+53520751240*r**18+2630233376986*r**20
            -995396262776*r**22-972668468628*r**24+739129306280*r**26-285287864340*r**28
            +16841725288*r**30-4908716517*r**32+456021344*r**34+2066651*r**36))-32*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7
            +2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2*(4392*Q2**20-8*Q2**19*(915+307*r**2)+Q2**18*(-285663
            +684826*r**2+379765*r**4)-8*Q2**17*(-287493+1147511*r**2+7403783*r**4
            +700259*r**6)+Q2**16*(-8625339+53435154*r**2+660842050*r**4+600163642*r**6
            +31263789*r**8)-4*Q2**15*(-4744275+43205894*r**2+778544434*r**4+1435217720*r**6
            +653743009*r**8+23384066*r**10)+4*Q2**14*(-6141480+81532997*r**2+1908260677*r**4
            +5492618650*r**6+5143923130*r**8+1431621073*r**10+40332377*r**12)-4*Q2**13*(
            -3337371+77736582*r**2+2274232533*r**4+9970109690*r**6+13131135519*r**8
            +8346195506*r**10+1199902119*r**12+35173710*r**14)-4*Q2**12*(-3016572
            +8983559*r**2-67880635*r**4-6488552981*r**6-4760756691*r**8-1728741687*r**10
            -1985658641*r**12+1421857949*r**14+1722851*r**16)+4*Q2**11*(-7477197
            +119226302*r**2+3516251112*r**4+5967082392*r**6+33579693178*r**8+71001540752*r**10
            +45964827568*r**12+14684083896*r**14+4527741339*r**16+35818562*r**18)
            -2*Q2**10*(-12063909+263333356*r**2+8222123657*r**4+26331536656*r**6
            +111106956702*r**8+344268180136*r**10+381752492866*r**12+154489574640*r**14
            +46776898543*r**16+7051264220*r**18+48773725*r**20)+4*Q2**9*(-1367925
            +33803198*r**2+483968221*r**4+8322996210*r**6+16724029130*r**8+166528603184*r**10
            +301633405702*r**12+206686962056*r**14+23437826075*r**16+11529273330*r**18
            -1803411731*r**20-17678362*r**22)+2*Q2**8*(-2409927+95485364*r**2+5563609172*r**4
            -6012487360*r**6+56934207561*r**8-168597639440*r**10-603740966576*r**12
            -670420446728*r**14-214411483565*r**16+117752530956*r**18+11156142956*r**20
            +10341589112*r**22+70336955*r**24)-4*Q2**7*(-591273+32389266*r**2+2160516922*r**4
            -679442312*r**6+22370557197*r**8-50473087982*r**10-304810412916*r**12
            -479463118608*r**14-343109987535*r**16+2492270422*r**18+57356408442*r**20
            +10802434456*r**22+2712788779*r**24+13049094*r**26)-4*Q2**6*(-544242
            +18999757*r**2+145707899*r**4-6327684722*r**6-3390616276*r**8+19483171175*r**10
            +224994990005*r**12+425771673876*r**14+422830684902*r**16+183778399595*r**18
            -172048647139*r**20+6303850814*r**22-8609270528*r**24+1483237697*r**26
            +11886547*r**28)+4*Q2**5*(-566751+29681038*r**2+946727309*r**4-11979525454*r**6
            -6120976531*r**8-31592983154*r**10+49626886617*r**12+264652292002*r**14
            -32042907981*r**16-7983369878*r**18-132868141353*r**20-337853024042*r**22
            +32451991487*r**24-6111838342*r**26+2451460547*r**28+13704406*r**30)
            -4*Q2**4*(-76860+7974081*r**2+388210023*r**4-6629967815*r**6-8976374565*r**8
            -30287457103*r**10-8442346461*r**12+323496509049*r**14-65122937505*r**16
            -330518508165*r**18-163768733019*r**20-234623055741*r**22-235898389567*r**24
            +9765145875*r**26-1810004015*r**28+851805387*r**30+3406401*r**32)-4*Q2**3*(
            -140727+6391744*r**2+69202588*r**4-2092808920*r**6+3920381724*r**8+12728408764*r**10
            -54864744212*r**12-32574731496*r**14-116033694570*r**16-46718964708*r**18
            -10747677612*r**20-83030507688*r**22+198049995868*r**24-43249521260*r**26
            +10344142884*r**28-2591330200*r**30+342343081*r**32+2294740*r**34)+(
            -1+r**2)**2*(-10431+810024*r**2+10574293*r**4-1126525480*r**6-729199364*r**8
            +18152842344*r**10-109567465444*r**12+660183256408*r**14-1091415044122*r**16
            -13729720392*r**18+1283030150670*r**20-770608598584*r**22-51317265860*r**24
            +78398341304*r**26-57166523844*r**28+796093192*r**30-714661471*r**32
            +64317184*r**34+261573*r**36)+Q2**2*(-375699+22748638*r**2+384626037*r**4
            -16601408400*r**6+6165171524*r**8+80294767464*r**10-495223400108*r**12
            +2322315789072*r**14-1936905389178*r**16-169040052748*r**18+1812531280934*r**20
            -1890715356528*r**22-931752440460*r**24+935687555176*r**26-620087733276*r**28
            +40670817776*r**30-12557523627*r**32+1568632926*r**34+7858477*r**36)
            -4*Q2*(-25071+1767896*r**2+26306663*r**4-1844138588*r**6+1224939720*r**8
            +17538870092*r**10-112029444752*r**12+639827667468*r**14-1147800922654*r**16
            +905759165356*r**18-876918168346*r**20+1118966323876*r**22-509040707680*r**24
            -188754197148*r**26+177509648968*r**28-82778952700*r**30+3782327205*r**32
            -1339815476*r**34+130405115*r**36+582056*r**38))*sqrtq2+logq2**7*(225740390400000*r**32*(1
            +r**2)**2*(1-Q2+r**2)*(-549+430*r**2+247*r**4)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3+225740390400000*(Q2-(-1+r)**2)**2*r**32*(1+r**2)**2*(
            -549+430*r**2+247*r**4)*(Q2-(1+r)**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2**6*(1254113280000*r**28*(1+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-8160*Q2**8*(1+r**2)+720*Q2**7*(51+163*r**2+112*r**4)
            -8*Q2**6*(2472+37217*r**2+73634*r**4+40353*r**6)+Q2**5*(-94749+29557*r**2
            +817193*r**4+1343131*r**6+650244*r**8)+Q2**4*(96435+397332*r**2+265502*r**4
            -826276*r**6-1360017*r**8-592560*r**10)-2*Q2**3*(-80580+125299*r**2
            +334683*r**4+153847*r**6-115131*r**8-110954*r**10+29220*r**12)+3*(
            -1+r**2)**2*(-21217-41284*r**2-188603*r**4+129184*r**6+212449*r**8-28844*r**10
            +4283*r**12+41552*r**14)+2*Q2**2*(-180300-54869*r**2-112836*r**4+124946*r**6
            +221936*r**8-68001*r**10+188704*r**12+302820*r**14)-3*Q2*(-84207-39511*r**2
            -489897*r**4-237269*r**6+756603*r**8+536455*r**10-127191*r**12-44635*r**14
            +159732*r**16))+1254113280000*r**28*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(8160*Q2**9*(1+r**2)-240*Q2**8*(187+557*r**2+370*r**4)+8*Q2**7*(7062
            +56477*r**2+98384*r**4+50433*r**6)-Q2**6*(-74973+347069*r**2+1704001*r**4
            +2255027*r**6+973068*r**8)+4*Q2**5*(-47796-115631*r**2+145312*r**4+746650*r**6
            +838348*r**8+310701*r**10)-5*Q2**4*(12945-148873*r**2-266440*r**4+50616*r**6
            +483311*r**8+434897*r**10+106824*r**12)-4*Q2**3*(-130440-5075*r**2+173573*r**4
            +306738*r**6+130326*r**8-147043*r**10+53485*r**12+166020*r**14)+3*(
            -1+r**2)**2*(-21217-62501*r**2-229887*r**4-59419*r**6+341633*r**8+183605*r**10
            -24561*r**12+45835*r**14+41552*r**16)+Q2**2*(-613221-588871*r**2-1805101*r**4
            -687587*r**6+2963573*r**8+1917235*r**10-140167*r**12+849143*r**14+1084836*r**16)
            -12*Q2*(-26356-30642*r**2-164165*r**4-65515*r**6+71203*r**8+242125*r**10
            +170921*r**12-41921*r**14+9069*r**16+50321*r**18))*sqrtq2)+logq2**5*(995328000*r**24*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(913920*Q2**12*(1+r**2)
            -480*Q2**11*(7579+25406*r**2+17827*r**4)+8*Q2**10*(344241+4756706*r**2
            +9372881*r**4+5001408*r**6)-840*Q2**9*(14121+127246*r**2+337148*r**4
            +357826*r**6+133803*r**8)+15*Q2**8*(5748999+26410912*r**2+59642150*r**4
            +76159364*r**6+48348403*r**8+11169276*r**10)-20*Q2**7*(9068535+38605204*r**2
            +78588607*r**4+101915400*r**6+89961325*r**8+38602276*r**10+1504413*r**12)
            -60*Q2**6*(-1453746-10007613*r**2-20065248*r**4+2562599*r**6+31476782*r**8
            +18986769*r**10+6800388*r**12+5544357*r**14)+12*Q2**5*(15290772-7369103*r**2
            -115837323*r**4+61788311*r**6+750518475*r**8+1106497247*r**10+638739387*r**12
            +173456857*r**14+45662001*r**16)-10*Q2**4*(24992721-1756234*r**2-215650234*r**4
            -461022156*r**6-53862250*r**8+1147314248*r**10+1663270758*r**12+927139748*r**14
            +219671021*r**16+29369898*r**18)-60*Q2**3*(-70619-1225162*r**2-7246771*r**4
            +59409984*r**6+133064538*r**8+68164952*r**10-31612770*r**12-44538408*r**14
            -24755479*r**16-10267558*r**18+2164909*r**20)+420*Q2**2*(430124-1383227*r**2
            -9020628*r**4-4693993*r**6+2620622*r**8+3159062*r**10+499706*r**12+1682930*r**14
            +15967622*r**16+13296405*r**18+1431130*r**20+616967*r**22)+9*(-1+r**2)**2*(3156937
            -17760194*r**2-93221363*r**4-94623616*r**6-124676674*r**8+157381364*r**10
            +255600758*r**12-39396112*r**14+64088441*r**16+137658574*r**18+20033149*r**20
            +2709136*r**22)-180*Q2*(706228-3614315*r**2-15379459*r**4-8122399*r**6
            -24596139*r**8-17864970*r**10+59079678*r**12+49257966*r**14-17458590*r**16
            +4429205*r**18+24006533*r**20+3009553*r**22+736789*r**24))+995328000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(913920*Q2**12*(1+r**2)-480*Q2**11*(7579
            +25406*r**2+17827*r**4)+8*Q2**10*(344241+4756706*r**2+9372881*r**4+5001408*r**6)
            -840*Q2**9*(14121+127246*r**2+337148*r**4+357826*r**6+133803*r**8)+15*Q2**8*(5748999
            +26410912*r**2+59642150*r**4+76159364*r**6+48348403*r**8+11169276*r**10)
            -20*Q2**7*(9068535+38605204*r**2+78588607*r**4+101915400*r**6+89961325*r**8
            +38602276*r**10+1504413*r**12)-60*Q2**6*(-1453746-10007613*r**2-20065248*r**4
            +2562599*r**6+31476782*r**8+18986769*r**10+6800388*r**12+5544357*r**14)
            +12*Q2**5*(15290772-7369103*r**2-115837323*r**4+61788311*r**6+750518475*r**8
            +1106497247*r**10+638739387*r**12+173456857*r**14+45662001*r**16)-10*Q2**4*(24992721
            -1756234*r**2-215650234*r**4-461022156*r**6-53862250*r**8+1147314248*r**10
            +1663270758*r**12+927139748*r**14+219671021*r**16+29369898*r**18)-60*Q2**3*(
            -70619-1225162*r**2-7246771*r**4+59409984*r**6+133064538*r**8+68164952*r**10
            -31612770*r**12-44538408*r**14-24755479*r**16-10267558*r**18+2164909*r**20)
            +420*Q2**2*(430124-1383227*r**2-9020628*r**4-4693993*r**6+2620622*r**8
            +3159062*r**10+499706*r**12+1682930*r**14+15967622*r**16+13296405*r**18
            +1431130*r**20+616967*r**22)+9*(-1+r**2)**2*(3156937-17760194*r**2-93221363*r**4
            -94623616*r**6-124676674*r**8+157381364*r**10+255600758*r**12-39396112*r**14
            +64088441*r**16+137658574*r**18+20033149*r**20+2709136*r**22)-180*Q2*(706228
            -3614315*r**2-15379459*r**4-8122399*r**6-24596139*r**8-17864970*r**10
            +59079678*r**12+49257966*r**14-17458590*r**16+4429205*r**18+24006533*r**20
            +3009553*r**22+736789*r**24))*sqrtq2)+logq2**4*(-16588800*r**20*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**4*(1218560*Q2**16-5120*Q2**15*(160+1441*r**2)
            +64*Q2**14*(-778601-843820*r**2+66493*r**4)+8*Q2**13*(35236807+100143422*r**2
            +85034759*r**4+20743024*r**6)-16*Q2**12*(51017349+241394236*r**2+376186722*r**4
            +245671312*r**6+65475813*r**8)+Q2**11*(1558078701+9996188804*r**2+23125093986*r**4
            +24694071204*r**6+12653049233*r**8+3114910392*r**10)-Q2**10*(2043090549
            +13529843089*r**2+43275206702*r**4+71838910262*r**6+58823637917*r**8
            +23069927353*r**10+4817314368*r**12)+Q2**9*(1575805053+6785859440*r**2
            +39537789651*r**4+111250117840*r**6+147218351515*r**8+90500687208*r**10
            +22538183765*r**12+2563020696*r**14)+Q2**8*(218879463+1132825883*r**2
            -39885466839*r**4-172035486379*r**6-311422145335*r**8-274336983787*r**10
            -104632134297*r**12-8426666629*r**14+3552954816*r**16)+Q2**7*(-2678272982
            +4448241992*r**2+84969832924*r**4+307730236344*r**6+606179416436*r**8
            +683714577368*r**10+386166392652*r**12+68025193144*r**14-6287018566*r**16
            -6783309584*r**18)+2*Q2**6*(1980334459-4413212269*r**2-36825149766*r**4
            -142780650054*r**6-269469860178*r**8-268380133818*r**10-193128996774*r**12
            -50099286966*r**14+43117975491*r**16+9148250147*r**18+1438567168*r**20)
            +2*Q2**5*(-1355425451-3120067056*r**2-22407444533*r**4+48886959512*r**6
            +134838144972*r**8-172484891488*r**10-624574141468*r**12-573891110208*r**14
            -296026275313*r**16-132690777728*r**18-14259141087*r**20+1304086648*r**22)
            +2*Q2**4*(88705643+9634265795*r**2+44283308961*r**4-46525367295*r**6
            -274034763460*r**8-217314487876*r**10+462446566580*r**12+1131594771308*r**14
            +958431271265*r**16+416475173505*r**18+113589210603*r**20+10959112595*r**22
            -1601143624*r**24)+3*Q2**3*(391977027-3159681028*r**2-36525986*r**4+14497884204*r**6
            +72646285025*r**8+310340910896*r**10+325833628196*r**12+26869531592*r**14
            -131685182443*r**16-157261789300*r**18-106545085698*r**20-2573098868*r**22
            +394491719*r**24+199742664*r**26)+9*(-1+r**2)**2*(-3704261-169380003*r**2
            -459111868*r**4+7953406324*r**6+16573881763*r**8-7091078323*r**10-13744454184*r**12
            -4392650024*r**14+11982199497*r**16-6484335601*r**18-23478141116*r**20
            -5819917388*r**22-1782166183*r**24-189646521*r**26+10057888*r**28)+3*Q2**2*(
            -300666603-1545011847*r**2-16597690474*r**4+75908004766*r**6+215663285619*r**8
            +23194326111*r**10-93684892236*r**12+2999377188*r**14+17842531323*r**16
            -296585101833*r**18-318317651658*r**20-44122971842*r**22-36100779139*r**24
            -4709452239*r**26+258132864*r**28)-9*Q2*(-31621369-628790976*r**2-2420015119*r**4
            +29415003744*r**6+50462182083*r**8-16623841960*r**10+4702201237*r**12
            -20360704312*r**14-85874140123*r**16+30204032464*r**18+3691578947*r**20
            -78568682736*r**22-14062055919*r**24-7336405096*r**26-1003773897*r**28
            +54873032*r**30))+16588800*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1218560*Q2**17
            -5120*Q2**16*(398+1679*r**2)+192*Q2**15*(-255267-238580*r**2+60591*r**4)
            +40*Q2**14*(8293123+22624558*r**2+18250675*r**4+4042216*r**6)-8*Q2**13*(137271505
            +618168701*r**2+937551625*r**4+597120407*r**6+151694650*r**8)+Q2**12*(2374356285
            +14674774164*r**2+33006389314*r**4+34643799748*r**6+17631403233*r**8
            +4162523400*r**10)-2*Q2**11*(1800584625+12542055297*r**2+38198244746*r**4
            +59829037726*r**6+48085379177*r**8+19418943489*r**10+3966112380*r**12)
            +2*Q2**10*(1809447801+11179396539*r**2+48171419721*r**4+113182117402*r**6
            +138940449847*r**8+86197126239*r**10+25212712743*r**12+3690167532*r**14)
            +10*Q2**9*(-135692559-722883861*r**2-8620911593*r**4-32282339387*r**6
            -56989061469*r**8-51205602251*r**10-21767100527*r**12-3352787109*r**14
            +98993412*r**16)+Q2**8*(-2897152445+3096536646*r**2+123722473880*r**4
            +519651189562*r**6+1089637048150*r**8+1269473706490*r**10+765135510736*r**12
            +181083994070*r**14-1413306753*r**16-10336264400*r**18)+4*Q2**7*(1659735475
            -2649098387*r**2-40767093612*r**4-169565342344*r**6-363212343284*r**8
            -456663565360*r**10-364034740892*r**12-138597539932*r**14+6124444101*r**16
            +7841707111*r**18+2415110980*r**20)-4*Q2**6*(1667879955+343594623*r**2
            -9415458751*r**4-114246379666*r**6-273544327602*r**8-182682551254*r**10
            +81532505438*r**12+165331413234*r**14+144522481919*r**16+92478501683*r**18
            +12422979201*r**20+67240260*r**22)-4*Q2**5*(-722065547-7054879151*r**2
            -34905410275*r**4+36502441137*r**6+228879933972*r**8+89833870680*r**10
            -629752799768*r**12-1165030011492*r**14-914174328393*r**16-422596113273*r**18
            -130269564709*r**20-11957083517*r**22+1452615136*r**24)+5*Q2**4*(199703959
            -5784997192*r**2-21588945494*r**4+9595553856*r**6+171811823317*r**8+382744247072*r**10
            +97447345436*r**12-621494816200*r**14-915021526495*r**16-644319651488*r**18
            -275952805062*r**20-51363188600*r**22-3506492557*r**24+760303048*r**26)
            +6*Q2**3*(-346321815+611346077*r**2-6700741730*r**4+30723323274*r**6
            +64259558195*r**8-179896434905*r**10-364929715664*r**12-174851891300*r**14
            +61329091087*r**16-3819065045*r**18-27255388330*r**20+32497606362*r**22
            -16961085995*r**24-2651843311*r**26+29195100*r**28)-9*(-1+r**2)**2*(
            -3704261-173084264*r**2-628491871*r**4+7494294456*r**6+24527288087*r**8
            +9482803440*r**10-20835532507*r**12-18137104208*r**14+7589549473*r**16
            +5497863896*r**18-29962476717*r**20-29298058504*r**22-7602083571*r**24
            -1971812704*r**26-179588633*r**28+10057888*r**30)-6*Q2**2*(-197765355
            -1866025689*r**2-12701373839*r**4+73777662762*r**6+221478918317*r**8
            +94493042925*r**10-28191981207*r**12-75883813992*r**14-118390255929*r**16
            -94065236559*r**18-301914008325*r**20-299073335854*r**22-61204959369*r**24
            -31409723333*r**26-3731320533*r**28+211375980*r**30)+18*Q2*(-17662815
            -411191913*r**2-1586431109*r**4+17848619341*r**6+40042571537*r**8+776452299*r**10
            +2544971751*r**12+173338473*r**14-49605899537*r**16-45255746139*r**18
            +17684170497*r**20-20112537273*r**22-53125605589*r**24-11921846279*r**26
            -4866497123*r**28-579331581*r**30+32465460*r**32))*sqrtq2)+logq2**3*(276480*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(9062400*Q2**19-512*Q2**18*(495079
            +498556*r**2)+64*Q2**17*(33073161+70250590*r**2+36344469*r**4)-16*Q2**16*(546815329
            +1805582826*r**2+1898473809*r**4+656507176*r**6)+16*Q2**15*(1265552423
            +5915536168*r**2+9695088070*r**4+6619897312*r**6+1631747867*r**8)-Q2**14*(25071435105
            +171407361700*r**2+406098665578*r**4+433896650692*r**6+205235375605*r**8
            +32501656920*r**10)+2*Q2**13*(4160193107+78926317283*r**2+280542870686*r**4
            +432044842210*r**6+326735505779*r**8+99039072827*r**10+861531548*r**12)
            +Q2**12*(21523097133-21297130350*r**2-245369809961*r**4-489646564500*r**6
            -559611764085*r**8-297759893774*r**10+7027994865*r**12+54248191632*r**14)
            -4*Q2**11*(8932609047+29147200053*r**2+137414518559*r**4+453803686861*r**6
            +694136650245*r**8+516908368519*r**10+234770217341*r**12+71032488567*r**14
            +16753898568*r**16)+Q2**10*(25442332191+163528614816*r**2+1175605122232*r**4
            +4639964602688*r**6+10062606499518*r**8+11161554402552*r**10+6500543194112*r**12
            +2335424057968*r**14+413105973099*r**16+5421332664*r**18)+2*Q2**9*(-3596396495
            -77176319075*r**2-430355443972*r**4-1831067991648*r**6-6403846484950*r**8
            -11066428433350*r**10-9389020990120*r**12-4012239620232*r**14-1067952444883*r**16
            -142815699695*r**18+28509270820*r**20)+Q2**8*(-8166966459+96612865934*r**2
            -128215007219*r**4+113365257800*r**6+9398921960514*r**8+29048831226244*r**10
            +36405437154346*r**12+20474702534376*r**14+4396673398745*r**16-159446960066*r**18
            -52507270039*r**20-45754306176*r**22)-8*Q2**7*(-2002304009-3128727165*r**2
            -85129022153*r**4+136645903005*r**6+1822133163980*r**8+5935806920586*r**10
            +9567373238410*r**12+7534806561534*r**14+2354961129155*r**16+58623459555*r**18
            -251711508017*r**20-42287676555*r**22+694343914*r**24)+Q2**6*(-9706221707
            -126720269428*r**2-692639862546*r**4+3519808864316*r**6+16709946603135*r**8
            +50266273412208*r**10+86370500526772*r**12+89012750757688*r**14+45377787365427*r**16
            -434010248340*r**18-2937569357986*r**20-1344617982324*r**22-274293338407*r**24
            +25756259992*r**26)-2*Q2**5*(1575558843-60314664077*r**2-393163126438*r**4
            -241404388674*r**6-740318147219*r**8+9288484002893*r**10+11168550879368*r**12
            -12916095924700*r**14-26874054231403*r**16-25369711084243*r**18-19923321920126*r**20
            -4305969351906*r**22+66375341123*r**24+8372813587*r**26+5455938972*r**28)
            -Q2**4*(-6752745695+39554813650*r**2+650088869103*r**4+4792367587812*r**6
            +9766569069345*r**8-20573355419410*r**10-48707318174185*r**12+24165382341864*r**14
            +141734812522971*r**16+162709211797550*r**18+106313158270085*r**20+47822880947460*r**22
            +9504407309283*r**24-386804990958*r**26-149234265995*r**28+2825347120*r**30)
            +12*Q2**3*(-148731661-2082681319*r**2+2800823831*r**4+214074885165*r**6
            -197954723281*r**8-1551018904659*r**10-4235189441181*r**12-7110645752127*r**14
            -3046212561895*r**16+1855987273947*r**18+3724749366261*r**20+3956545231479*r**22
            +847496386421*r**24+139917141855*r**26-4399463791*r**28-5484803941*r**30
            +299394896*r**32)+3*Q2**2*(-484196753+11236036840*r**2+118205563532*r**4
            +207070725080*r**6+1895747500200*r**8-10621995730016*r**10-18624240361460*r**12
            +2166267482024*r**14+4772325244190*r**16-2170814461600*r**18+21310965090116*r**20
            +28749539650600*r**22+2182690679056*r**24+5014639404480*r**26+1451420132900*r**28
            +5453885528*r**30-5557857605*r**32-286387112*r**34)+9*(-1+r**2)**2*(
            -20488697+236528144*r**2+5882756668*r**4+25394368600*r**6-34298023960*r**8
            -1307975697984*r**10-828828436452*r**12+3416657223176*r**14+556326135150*r**16
            -3637392817680*r**18-14797979116*r**20+2601631850472*r**22+461809252944*r**24
            +300740228000*r**26+79282997140*r**28+1504735672*r**30-454159789*r**32
            +3927712*r**34)-18*Q2*(-56204863+830320133*r**2+13059415168*r**4+41328995492*r**6
            +13217723560*r**8-2266657693056*r**10-1462156343044*r**12+3223630579956*r**14
            +1902600549794*r**16-281457601470*r**18-2810581642324*r**20-213127431636*r**22
            +4100103387584*r**24+295948700136*r**26+514388788660*r**28+178110967868*r**30
            +3311327797*r**32-1092177583*r**34+3137828*r**36))+276480*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(9062400*Q2**19-512*Q2**18*(495079+498556*r**2)
            +64*Q2**17*(33073161+70250590*r**2+36344469*r**4)-16*Q2**16*(546815329
            +1805582826*r**2+1898473809*r**4+656507176*r**6)+16*Q2**15*(1265552423
            +5915536168*r**2+9695088070*r**4+6619897312*r**6+1631747867*r**8)-Q2**14*(25071435105
            +171407361700*r**2+406098665578*r**4+433896650692*r**6+205235375605*r**8
            +32501656920*r**10)+2*Q2**13*(4160193107+78926317283*r**2+280542870686*r**4
            +432044842210*r**6+326735505779*r**8+99039072827*r**10+861531548*r**12)
            +Q2**12*(21523097133-21297130350*r**2-245369809961*r**4-489646564500*r**6
            -559611764085*r**8-297759893774*r**10+7027994865*r**12+54248191632*r**14)
            -4*Q2**11*(8932609047+29147200053*r**2+137414518559*r**4+453803686861*r**6
            +694136650245*r**8+516908368519*r**10+234770217341*r**12+71032488567*r**14
            +16753898568*r**16)+Q2**10*(25442332191+163528614816*r**2+1175605122232*r**4
            +4639964602688*r**6+10062606499518*r**8+11161554402552*r**10+6500543194112*r**12
            +2335424057968*r**14+413105973099*r**16+5421332664*r**18)+2*Q2**9*(-3596396495
            -77176319075*r**2-430355443972*r**4-1831067991648*r**6-6403846484950*r**8
            -11066428433350*r**10-9389020990120*r**12-4012239620232*r**14-1067952444883*r**16
            -142815699695*r**18+28509270820*r**20)+Q2**8*(-8166966459+96612865934*r**2
            -128215007219*r**4+113365257800*r**6+9398921960514*r**8+29048831226244*r**10
            +36405437154346*r**12+20474702534376*r**14+4396673398745*r**16-159446960066*r**18
            -52507270039*r**20-45754306176*r**22)-8*Q2**7*(-2002304009-3128727165*r**2
            -85129022153*r**4+136645903005*r**6+1822133163980*r**8+5935806920586*r**10
            +9567373238410*r**12+7534806561534*r**14+2354961129155*r**16+58623459555*r**18
            -251711508017*r**20-42287676555*r**22+694343914*r**24)+Q2**6*(-9706221707
            -126720269428*r**2-692639862546*r**4+3519808864316*r**6+16709946603135*r**8
            +50266273412208*r**10+86370500526772*r**12+89012750757688*r**14+45377787365427*r**16
            -434010248340*r**18-2937569357986*r**20-1344617982324*r**22-274293338407*r**24
            +25756259992*r**26)-2*Q2**5*(1575558843-60314664077*r**2-393163126438*r**4
            -241404388674*r**6-740318147219*r**8+9288484002893*r**10+11168550879368*r**12
            -12916095924700*r**14-26874054231403*r**16-25369711084243*r**18-19923321920126*r**20
            -4305969351906*r**22+66375341123*r**24+8372813587*r**26+5455938972*r**28)
            -Q2**4*(-6752745695+39554813650*r**2+650088869103*r**4+4792367587812*r**6
            +9766569069345*r**8-20573355419410*r**10-48707318174185*r**12+24165382341864*r**14
            +141734812522971*r**16+162709211797550*r**18+106313158270085*r**20+47822880947460*r**22
            +9504407309283*r**24-386804990958*r**26-149234265995*r**28+2825347120*r**30)
            +12*Q2**3*(-148731661-2082681319*r**2+2800823831*r**4+214074885165*r**6
            -197954723281*r**8-1551018904659*r**10-4235189441181*r**12-7110645752127*r**14
            -3046212561895*r**16+1855987273947*r**18+3724749366261*r**20+3956545231479*r**22
            +847496386421*r**24+139917141855*r**26-4399463791*r**28-5484803941*r**30
            +299394896*r**32)+3*Q2**2*(-484196753+11236036840*r**2+118205563532*r**4
            +207070725080*r**6+1895747500200*r**8-10621995730016*r**10-18624240361460*r**12
            +2166267482024*r**14+4772325244190*r**16-2170814461600*r**18+21310965090116*r**20
            +28749539650600*r**22+2182690679056*r**24+5014639404480*r**26+1451420132900*r**28
            +5453885528*r**30-5557857605*r**32-286387112*r**34)+9*(-1+r**2)**2*(
            -20488697+236528144*r**2+5882756668*r**4+25394368600*r**6-34298023960*r**8
            -1307975697984*r**10-828828436452*r**12+3416657223176*r**14+556326135150*r**16
            -3637392817680*r**18-14797979116*r**20+2601631850472*r**22+461809252944*r**24
            +300740228000*r**26+79282997140*r**28+1504735672*r**30-454159789*r**32
            +3927712*r**34)-18*Q2*(-56204863+830320133*r**2+13059415168*r**4+41328995492*r**6
            +13217723560*r**8-2266657693056*r**10-1462156343044*r**12+3223630579956*r**14
            +1902600549794*r**16-281457601470*r**18-2810581642324*r**20-213127431636*r**22
            +4100103387584*r**24+295948700136*r**26+514388788660*r**28+178110967868*r**30
            +3311327797*r**32-1092177583*r**34+3137828*r**36))*sqrtq2)+logq2**2*(4608*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(288405504*Q2**22-512*Q2**21*(6602729
            +7037354*r**2)+32*Q2**20*(545084357+1184978986*r**2+605254757*r**4)-160*Q2**19*(315311965
            +1111953606*r**2+1159456197*r**4+351310444*r**6)+40*Q2**18*(2092812248
            +11834866007*r**2+19585914029*r**4+12494350061*r**6+2129462207*r**8)
            -Q2**17*(60380913251+722769278960*r**2+1694414396190*r**4+1716051600660*r**6
            +725188499615*r**8+25902661916*r**10)+Q2**16*(-48591258823+435417540757*r**2
            +1124539980790*r**4+1142504621550*r**6+919838677825*r**8+237052209277*r**10
            -140239608688*r**12)+2*Q2**15*(80459580667+279683577721*r**2+1703440688507*r**4
            +5038499736570*r**6+5486812471365*r**8+2394517589837*r**10+586260524101*r**12
            +119354846272*r**14)-10*Q2**14*(14636079845+144986549142*r**2+937366235224*r**4
            +3483474295721*r**6+5589339974089*r**8+3977868076052*r**10+1271637030202*r**12
            +232812079149*r**14+7410782528*r**16)+10*Q2**13*(15047009+115230674051*r**2
            +833887776812*r**4+4949089792173*r**6+11703150438628*r**8+12459676108693*r**10
            +5952578216256*r**12+1093478485907*r**14+147024494543*r**16-21528875224*r**18)
            +2*Q2**12*(64447215977+46595212490*r**2+634097339535*r**4-13610243800695*r**6
            -56505108918255*r**8-88672045503587*r**10-63721710254595*r**12-15522898197405*r**14
            +2723565478890*r**16+590792224685*r**18+131565200912*r**20)-2*Q2**11*(56685181409
            +466586039479*r**2+4339402717235*r**4+8008235215920*r**6+6006885270050*r**8
            +5739756485606*r**10+5354869538726*r**12+13971780141320*r**14+19083684062205*r**16
            +9445945520075*r**18+1394566405159*r**20+8408995424*r**22)+2*Q2**10*(
            -3558255973+431927100006*r**2+4023988856082*r**4+21272881509935*r**6
            +83876803701230*r**8+226878697622948*r**10+343348897761724*r**12+272518559502998*r**14
            +141225748119335*r**16+47586991876910*r**18+5940270669642*r**20+704469804291*r**22
            -90257727688*r**24)+10*Q2**9*(8551260010-47571201653*r**2-514811036396*r**4
            -3870538617701*r**6-16008412530992*r**8-56984670651046*r**10-132712606552912*r**12
            -151947742784794*r**14-90254493416182*r**16-36456863738897*r**18-9329430935396*r**20
            +445153172767*r**22+106014893404*r**24+12158505868*r**26)+10*Q2**8*(-5172677494
            +3716162339*r**2+204915947703*r**4+1542361261167*r**6-805001577305*r**8
            +12990247670416*r**10+108051973397886*r**12+215489941248102*r**14+170730530284008*r**16
            +59371831580467*r**18+10518228771403*r**20+2061620014059*r**22-974709240537*r**24
            -162980382118*r**26+2683590464*r**28)-2*Q2**7*(8804069023-205729098835*r**2
            -1374195950965*r**4-1815261959730*r**6-39305057258745*r**8+40145968319607*r**10
            +631560126179915*r**12+1694692183071860*r**14+1956960989331365*r**16+929381562775835*r**18
            +117275800229337*r**20-87558450574530*r**22-32228702737995*r**24-2268219830335*r**26
            -197774941615*r**28+33675726208*r**30)+2*Q2**6*(16417025861-217974066994*r**2
            -2315771617340*r**4-5129947584135*r**6-17685599031825*r**8+221621232433364*r**10
            +835167630921754*r**12+2076311994367435*r**14+3045160838512275*r**16+2290898570068750*r**18
            +531337760085664*r**20+6577182375839*r**22-70111259854695*r**24-35689508606640*r**26
            +194554110850*r**28+256999026461*r**30+10469929376*r**32)+2*Q2**5*(-3314682653
            +13457383221*r**2+791768658992*r**4+9163918341895*r**6+38737485036870*r**8
            -66514828666267*r**10-111357546949676*r**12-694925057590857*r**14-734007475318240*r**16
            -280347541691905*r**18+455172597714888*r**20+1223491722758269*r**22+410048006964578*r**24
            +10937701943295*r**26+5799615479860*r**28-1035128547643*r**30-191202701739*r**32
            +6184107112*r**34)-10*Q2**4*(830793725-20809706866*r**2-103920462397*r**4
            +2073090543849*r**6+10917924745419*r**8+36660911277957*r**10+52691313804471*r**12
            -155573714756123*r**14-108946946408687*r**16+472894646486717*r**18+658183160752681*r**20
            +536606140745851*r**22+406718785646217*r**24+132095681384127*r**26+4587749380989*r**28
            -2382425757513*r**30-176556881506*r**32-1731317647*r**34+1031968736*r**36)
            +30*Q2**3*(141266331-3197671931*r**2-26779078627*r**4+173908034972*r**6
            +656420080108*r**8+8430467933712*r**10-16910232379924*r**12-76457841714788*r**14
            -123264175600022*r**16-93994609283902*r**18+20880499312478*r**20+70265822335636*r**22
            +89815994387452*r**24+36765447566648*r**26+13742810661900*r**28+1555101075604*r**30
            -454287372781*r**32-14912630287*r**34+2504091277*r**36+34506144*r**38)
            +9*(-1+r**2)**2*(18263291-687243565*r**2-2738803825*r**4+164406623215*r**6
            +539831606860*r**8+881394177676*r**10-8028267656980*r**12-109144420452100*r**14
            +74920138280330*r**16+277871909961770*r**18-256508631866974*r**20-175783534955470*r**22
            +209996208188300*r**24+19477838533820*r**26+12579464808380*r**28+10648855531756*r**30
            +965939198515*r**32-45504621125*r**34-6981819865*r**36+38618615*r**38
            +10027376*r**40)+6*Q2**2*(103097619-4886809990*r**2+7866336490*r**4+1426626277515*r**6
            +6796003446460*r**8-4275633675916*r**10+87249605222620*r**12-389072380107520*r**14
            -491445822761370*r**16+82949108020520*r**18+34661572159184*r**20+524657771091230*r**22
            +803780844733320*r**24-90393859948180*r**26+147290649132580*r**28+81598409866904*r**30
            +3309451228015*r**32-12749212290*r**34-65801276090*r**36-5003045185*r**38
            +247824084*r**40)-9*Q2*(94742537-3518440618*r**2-7863115790*r**4+766392756410*r**6
            +2318312706925*r**8+563895430052*r**10-6633731609448*r**12-366574559182280*r**14
            +61897446085970*r**16+658065163214900*r**18+140073506597772*r**20-728018005650948*r**22
            -266523474351070*r**24+688034426316080*r**26-29298537516200*r**28+32367610348152*r**30
            +43532816228837*r**32+3755082280390*r**34-179143289710*r**36-34482683750*r**38
            -358637263*r**40+73369052*r**42))-4608*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(288405504*Q2**23-9728*Q2**22*(377159+400034*r**2)+32*Q2**21*(650728021
            +1403220314*r**2+717852421*r**4)-32*Q2**20*(2121644182+7289831373*r**2
            +7587514728*r**4+2361806977*r**6)+40*Q2**19*(3354060108+17543928291*r**2
            +28671553241*r**4+18537416625*r**6+3534703983*r**8)-Q2**18*(144093403171
            +1279876409160*r**2+2951245597630*r**4+2999262164260*r**6+1310140990335*r**8
            +111081150196*r**10)+4*Q2**17*(2947413607+304641933242*r**2+885430913985*r**4
            +1138242654600*r**6+840269694525*r**8+247035842702*r**10-28584236693*r**12)
            +Q2**16*(209510420157+172540873508*r**2+1846923855467*r**4+7809954870800*r**6
            +8911281643355*r**8+3632144292572*r**10+1075708447613*r**12+378949301232*r**14)
            -4*Q2**15*(76819989946+542537952049*r**2+3334977721174*r**4+12079655951841*r**6
            +19236006039190*r**8+13885335220731*r**10+4669481632474*r**12+934837883059*r**14
            +78204379456*r**16)-20*Q2**14*(-7325563427-137426651519*r**2-958120280589*r**4
            -4684965161559*r**6-10387982354219*r**8-11013442079417*r**10-5601041661255*r**12
            -1298963797629*r**14-193623678110*r**16+7059046348*r**18)+4*Q2**13*(32185990466
            -264816696405*r**2-2055747457390*r**4-21262565822810*r**6-69883155036130*r**8
            -104743089120096*r**10-77891490939670*r**12-25376590854110*r**14-1739474711680*r**16
            -18342935955*r**18+119604788516*r**20)-4*Q2**12*(60566198693+288814233973*r**2
            +2510047634630*r**4-2483955622620*r**6-32054233724450*r**8-69718698968118*r**10
            -73519443109728*r**12-32636414155340*r**14+3142175671845*r**16+6380151611825*r**18
            +1058461915378*r**20+69987098168*r**22)+4*Q2**11*(26563462718+477599160447*r**2
            +4414988806398*r**4+16810259721545*r**6+48945962093600*r**8+119312669689302*r**10
            +177221761893028*r**12+145922604591522*r**14+87140606161430*r**16+38058310729595*r**18
            +8390391297438*r**20+1053722602437*r**22-40924366132*r**24)+2*Q2**10*(46314556023
            -666224852298*r**2-7029971138068*r**4-44649563454522*r**6-185191747866125*r**8
            -595678854579408*r**10-1233790628149232*r**12-1375606171188692*r**14-865016774703243*r**16
            -371097058690730*r**18-100174417223532*r**20-4418974610098*r**22-84137609583*r**24
            +151050257028*r**26)-20*Q2**9*(6861968752-21368051991*r**2-383649092876*r**4
            -2963855457632*r**6-9536974785694*r**8-42991665426227*r**10-148874625300922*r**12
            -250075145292904*r**14-206466383242492*r**16-93041594367773*r**18-28152261722848*r**20
            -5472948888344*r**22+762938653354*r**24+140576890695*r**26+4737457702*r**28)
            -2*Q2**8*(-17059318447-213011674610*r**2-331035400755*r**4+6921124084620*r**6
            -35618258839435*r**8+101072198785162*r**10+1236771231521425*r**12+3312401756301800*r**14
            +3888063346991915*r**16+2079893372098210*r**18+466726101988687*r**20-24659206647220*r**22
            -26794148870385*r**24-7956667943610*r**26-999258899885*r**28+47093678528*r**30)
            +4*Q2**7*(12610547442-207449548403*r**2-1947848333570*r**4-4159702747415*r**6
            -29402959125150*r**8+111231071747113*r**10+753436862710638*r**12+2201282151809605*r**14
            +3348407005457750*r**16+2588620561087975*r**18+788997561545418*r**20+18147266015323*r**22
            -94949206583610*r**24-35093215587485*r**26-1135720330550*r**28+46449905527*r**30
            +22072827792*r**32)-4*Q2**6*(9865854257-107507212177*r**2-1662757171663*r**4
            -8304818771685*r**6-30776515826415*r**8+135225231033903*r**10+584073205152397*r**12
            +1803202341440023*r**14+2927740154098975*r**16+2808203475136465*r**18
            +1183531866219763*r**20-342788390148383*r**22-236791042221717*r**24-58369235202315*r**26
            -20647284987825*r**28+743340842477*r**30+229335828788*r**32+2142911132*r**34)
            -4*Q2**5*(419642986-46952916881*r**2+142811865114*r**4+10160569860066*r**6
            +51245513552930*r**8+77763606380194*r**10+42792096703206*r**12-792075589160574*r**14
            -986833632476266*r**16+675059107711720*r**18+1732870429893194*r**20+2180847512101206*r**22
            +1833566828976966*r**24+540732057914254*r**26+19838032164050*r**28-3573820927674*r**30
            -1054557828456*r**32-96837591431*r**34+5671975396*r**36)+20*Q2**4*(627296359
            -14785964467*r**2-102533702572*r**4+1245447093184*r**6+7480137764796*r**8
            +36435119912256*r**10+19310763971328*r**12-166127963048008*r**14-317156593982438*r**16
            +40981936113162*r**18+596859652588416*r**20+702793384252720*r**22+606386454777212*r**24
            +324555404865144*r**26+88955931375408*r**28+3435313425144*r**30-1960922378681*r**32
            -111513045007*r**34+3406462460*r**36+567743584*r**38)+12*Q2**3*(-301617018
            +5197609005*r**2+78875044640*r**4+345490747895*r**6+1322181435530*r**8
            -24855036872508*r**10+64824213726840*r**12+38883995183020*r**14+253582131906340*r**16
            +584621516220070*r**18+200116061008152*r**20+34463081425330*r**22+1685880558940*r**24
            -361650534859340*r**26-52625321005080*r**28+2554425589692*r**30-1097308643050*r**32
            +1166625401525*r**34-1879290520*r**36-8848016145*r**38+37646682*r**40)
            -9*(-1+r**2)**2*(18263291-668980274*r**2-3426047390*r**4+161667819390*r**6
            +704238230075*r**8+1421225784536*r**10-7146873479304*r**12-117172688109080*r**14
            -34224282171770*r**16+352792048242100*r**18+21363278094796*r**20-432292166822444*r**22
            +34212673232830*r**24+229474046722120*r**26+32057303342200*r**28+23228320340136*r**30
            +11614794730271*r**32+920434577390*r**34-52486440990*r**36-6943201250*r**38
            +48645991*r**40+10027376*r**42)-3*Q2**2*(490422849-20122746596*r**2-17630294370*r**4
            +5168163497240*r**6+23400197568725*r**8+6732425831244*r**10+146046748265064*r**12
            -1703369227316640*r**14-1575344067479870*r**16+1157202060163000*r**18
            +655441880152724*r**20-1065415330452016*r**22+1857306808595890*r**24+3490877248518520*r**26
            +25897965820200*r**28+554880949043424*r**30+300414170876349*r**32+17858650872620*r**34
            -694530845890*r**36-245056693800*r**38-10586353991*r**40+715755324*r**42)
            +36*Q2*(28251457-1036867057*r**2-3181902453*r**4+231931656980*r**6+823246254985*r**8
            +712086431037*r**10-3830265146217*r**12-116353695438048*r**14-4874100392190*r**16
            +184712455562470*r**18+15201589075622*r**20+6790284921768*r**22-172371708442438*r**24
            -38696790208310*r**26+210588971182230*r**28+2009209320192*r**30+17037029880093*r**32
            +13989842755707*r**34+1156476402895*r**36-61282084060*r**38-10472587683*r**40
            -66676087*r**42+20849107*r**44))*sqrtq2)+logq2*(-384*r**8*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7
            +2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(-6133504*Q2**21+7712*Q2**20*(11435+10337*r**2)-8*Q2**19*(64059321
            +131503301*r**2+53203212*r**4)+8*Q2**18*(194033429+662354541*r**2+616705191*r**4
            +145483163*r**6)-Q2**17*(2430825463+12960157017*r**2+17575247629*r**4
            +10920401319*r**6+1464872956*r**8)+Q2**16*(967386663+13488002492*r**2
            +10575385894*r**4+5354465068*r**6+7340672531*r**8-383922120*r**10)+2*Q2**15*(1590359396
            +3088566957*r**2+43822147159*r**4+97973499671*r**6+55692637969*r**8+9100923804*r**10
            +1939672724*r**12)-2*Q2**14*(2674974698+16433264343*r**2+133095966246*r**4
            +415443978866*r**6+435271105082*r**8+154886409243*r**10+23041296438*r**12
            +2156595356*r**14)+2*Q2**13*(637279602+16524860623*r**2+160733502583*r**4
            +791819174056*r**6+1281006444720*r**8+825298606267*r**10+155820168523*r**12
            +16000138318*r**14-561741156*r**16)+2*Q2**12*(2284475232-1961045127*r**2
            -41257644274*r**4-686832364649*r**6-1589281543348*r**8-1582526446597*r**10
            -615845780210*r**12+51885301361*r**14+11176151736*r**16+3216538884*r**18)
            -2*Q2**11*(2077030020+11234123383*r**2+146257292521*r**4+153322633059*r**6
            +460292702573*r**8+1196816045041*r**10+843285095471*r**12+552769672257*r**14
            +298669219867*r**16+26555722804*r**18+2023911708*r**20)+2*Q2**10*(-650636298
            +14761218197*r**2+230537788098*r**4+964786780188*r**6+3585843847116*r**8
            +9130720148690*r**10+9984481340156*r**12+5082004819776*r**14+1796544887598*r**16
            +277693071633*r**18+13032488018*r**20-1374837204*r**22)+2*Q2**9*(1842125623
            -10589222802*r**2-137756501514*r**4-784779077273*r**6-3024239228106*r**8
            -11994634975988*r**10-21096430452788*r**12-14976170774306*r**14-5178713876253*r**16
            -1647331597706*r**18+17672561838*r**20+8072047563*r**22+2350344256*r**24)
            -2*Q2**8*(567940477-269496537*r**2+35548535908*r**4-69238052277*r**6
            +719487807175*r**8-4789032094742*r**10-20643305443128*r**12-24064312104138*r**14
            -8253494786885*r**16+598333370875*r**18-88700749548*r**20+252000841663*r**22
            +13423996353*r**24+467006644*r**26)-2*Q2**7*(617833332-8448331367*r**2
            -120807744829*r**4-95632377409*r**6-1708946610215*r**8+2379583671190*r**10
            +22413899657026*r**12+39065522006894*r**14+27262414574614*r**16+2438906753557*r**18
            -4172939829641*r**20-1144896986413*r**22-195300165859*r**24-5691000644*r**26
            +970830084*r**28)+2*Q2**6*(454484866-6192292197*r**2-68337716674*r**4
            -31344566114*r**6-612857121298*r**8+5681095688233*r**10+23667530650018*r**12
            +50032241418016*r**14+54507225066862*r**16+20079240956269*r**18-1079441824238*r**20
            -1431513180106*r**22-980568032222*r**24+11653414607*r**26+1853858574*r**28
            +625422604*r**30)+2*Q2**5*(56346218-1478338503*r**2-11258786823*r**4
            +405361125656*r**6+1358972740316*r**8-1531404602461*r**10-3446165341109*r**12
            -21408113200978*r**14-13687843262242*r**16-13596709849633*r**18+22690823841391*r**20
            +15911966119724*r**22-982240259464*r**24+228441585221*r**26-112533420723*r**28
            -3669661938*r**30+94613348*r**32)-2*Q2**4*(145200516-3605429099*r**2
            -28021835858*r**4+578117911111*r**6+1603596885012*r**8+3381007984769*r**10
            +5342212164434*r**12-26261054187217*r**14+9776861096808*r**16+54328250372451*r**18
            +24458305622354*r**20+42497906385869*r**22+23393823461348*r**24+112866220131*r**26
            -140935699538*r**28-65111471939*r**30-1794815204*r**32+212726052*r**34)
            +2*Q2**3*(28537784-912493449*r**2-8312570939*r**4+131882481515*r**6+58414655605*r**8
            +2723384915291*r**10-6351049263971*r**12-29392302742681*r**14-26590446122247*r**16
            -2199630309235*r**18+16506456727731*r**20+13675014713969*r**22+11398965937999*r**24
            +6193567679609*r**26+791680164655*r**28-154540510531*r**30+2989715851*r**32
            +124057896*r**34+46345148*r**36)+3*(-1+r**2)**2*(948841-52186400*r**2
            -246023347*r**4+23561630696*r**6+16255829980*r**8-148299859608*r**10
            +815494431740*r**12-12601330597064*r**14+21222266454742*r**16+7240390453480*r**18
            -36687552883682*r**20+21033190555720*r**22+553358774044*r**24-702932104072*r**26
            +1124943443100*r**28+58328054824*r**30+4357893065*r**32-870212008*r**34
            -23103491*r**36+1379440*r**38)+2*Q2**2*(19564894-712318669*r**2-2198738678*r**4
            +231567151212*r**6+528178036736*r**8-1923247016688*r**10+9670239442456*r**12
            -35043888216012*r**14-15967862780932*r**16+8878789038606*r**18+6458632336044*r**20
            +62035919014220*r**22-12511738580592*r**24+1439059601128*r**26+9498838215480*r**28
            -68646614500*r**30+100406180118*r**32-19140513593*r**34-564305158*r**36
            +25383928*r**38)-3*Q2*(6790117-312756431*r**2-1038473707*r**4+114814207949*r**6
            +58864198488*r**8-814361046212*r**10+3789275091308*r**12-37263344583924*r**14
            +36283875406318*r**16+40665303760806*r**18-25816649377346*r**20-73649449507698*r**22
            +66793609003444*r**24-2507930131908*r**26-4931066464276*r**28+4899447365260*r**30
            +157684024821*r**32+30378709937*r**34-5575362859*r**36-168838643*r**38
            +9504556*r**40))+384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(49068032*Q2**25
            -1536*Q2**24*(487258+443155*r**2)+96*Q2**23*(48689261+100039770*r**2
            +40834413*r**4)-8*Q2**22*(1921219235+6645367990*r**2+6194654179*r**4
            +1464233648*r**6)+8*Q2**21*(3309874263+18464143062*r**2+26447239472*r**4
            +15705172842*r**6+2083238073*r**8)+Q2**20*(-12616135977-191944473976*r**2
            -285682034042*r**4-227974146092*r**6-121020473341*r**8+2002043652*r**10)
            -4*Q2**19*(9702300132+4282082945*r**2+155743348545*r**4+398657184550*r**6
            +222752300250*r**8+40386040217*r**10+11547761985*r**12)+Q2**18*(74472007446
            +428880396480*r**2+3030421798538*r**4+9538562970540*r**6+9991349338890*r**8
            +3568943011016*r**10+593883460950*r**12+59876511948*r**14)+4*Q2**17*(
            -5247692865-141697265680*r**2-1193379098398*r**4-5699054388866*r**6-9222279606810*r**8
            -5910676035020*r**10-1204794459790*r**12-138143340898*r**14+2874331719*r**16)
            +Q2**16*(-77523651421+138879433936*r**2+2160128519716*r**4+25582231499576*r**6
            +60907244016574*r**8+60612700866544*r**10+23716369688636*r**12+47384951656*r**14
            -241366525889*r**16-100007603296*r**18)+16*Q2**15*(5040296238+28136435589*r**2
            +272440499898*r**4+33895643628*r**6-507252028461*r**8+86451596254*r**10
            +208785792879*r**12+773206347228*r**14+535108754763*r**16+59804849109*r**18
            +4428205707*r**20)+8*Q2**14*(3192573039-80289396260*r**2-1044183564495*r**4
            -5043115950850*r**6-17459647938540*r**8-43104995484254*r**10-46498541141840*r**12
            -23274901279320*r**14-8315167072675*r**16-1300996776450*r**18-80127087521*r**20
            +6875524350*r**22)-16*Q2**13*(5324491714-20933128940*r**2-291159457203*r**4
            -2934459353680*r**6-13536030874920*r**8-48440356276944*r**10-77912239435710*r**12
            -54679701438942*r**14-18028659233340*r**16-4589536497880*r**18-25924391451*r**20
            +20473909570*r**22+6319798702*r**24)+2*Q2**12*(12261613455+108235622040*r**2
            +1510790711434*r**4-5476301524452*r**6-40396672551915*r**8-353583511677820*r**10
            -913266986041620*r**12-966769708176144*r**14-409613450378863*r**16-40585356560280*r**18
            -1760116697190*r**20+5278067818900*r**22+388770064059*r**24+6986720988*r**26)
            +8*Q2**11*(5511240408-66693028123*r**2-747096337913*r**4-2389233791918*r**6
            -14228167156252*r**8+5278791136307*r**10+103935302566443*r**12+173384676841828*r**14
            +111437608241568*r**16-9219275330053*r**18-30659822958547*r**20-9015880383398*r**22
            -1133702870828*r**24-45191399203*r**26+7786562673*r**28)-4*Q2**10*(7755381783
            -64160807696*r**2-533816800287*r**4-5350226408602*r**6-43084541586861*r**8
            -150462334328568*r**10-370794504567219*r**12-709372675684038*r**14-755665423627203*r**16
            -541017499188144*r**18-300861111938661*r**20-71675102748726*r**22-16966135977127*r**24
            +404606830968*r**26+59159522359*r**28+8997379542*r**30)-8*Q2**9*(1354191111
            -30405615540*r**2-244397870120*r**4+2791040383350*r**6+15670094938620*r**8
            +81372796478864*r**10+290219189396280*r**12+784291076190270*r**14+1262364678896550*r**16
            +971171210120220*r**18+530115839350584*r**20+209876417483810*r**22+8157134856180*r**24
            +477716512200*r**26-897536611400*r**28-46962503574*r**30+2206192995*r**32)
            +2*Q2**8*(8294743143-153447877600*r**2-922344153976*r**4+9589375826560*r**6
            +17518573784520*r**8+106388146870032*r**10+142067523691520*r**12+1367381432468296*r**14
            +5350457650918030*r**16+6498366096580600*r**18+2968556004529672*r**20
            +988676671327760*r**22+426900422844816*r**24-46767142300800*r**26-18644823313040*r**28
            -1621705275352*r**30-56110381645*r**32+11055570264*r**34)-16*Q2**7*(45029620
            -417671105*r**2-5784275798*r**4-340081656496*r**6-3095721874205*r**8
            -694365816540*r**10-65927236750285*r**12+46951051990248*r**14+685279391887311*r**16
            +1302332708232170*r**18+956914040068515*r**20+210408748574400*r**22-78895843431127*r**24
            -42260415963324*r**26-6117622115015*r**28-1774336969720*r**30+113637820465*r**32
            +7320649327*r**34+20165959*r**36)-48*Q2**6*(104402147-2874956087*r**2
            -8370511372*r**4+466876869583*r**6+951825671737*r**8-780368014437*r**10
            +6146491334937*r**12-104885107683498*r**14-318978970359413*r**16-656609807246237*r**18
            -719216922393187*r**20-297502521508938*r**22-69228900104093*r**24+11100381648757*r**26
            +24784734933083*r**28+931307252102*r**30+63971720438*r**32-44354865212*r**34
            -2230575877*r**36+146993567*r**38)+8*Q2**5*(171190761-5963307742*r**2
            -17826129654*r**4+1147944044926*r**6+617338032063*r**8+28477267382872*r**10
            +62445706159472*r**12-404276142604356*r**14-315494495673946*r**16-1429486172812908*r**18
            -1944352943951908*r**20-1559951838667968*r**22+1469963765680034*r**24
            +836751105501384*r**26-56284868437168*r**28+51780527830996*r**30-1057125153087*r**32
            -1202587797974*r**34-29200955814*r**36-611114062*r**38+242624079*r**40)
            +Q2**4*(808520267-28798373880*r**2+48459805430*r**4+6718922889300*r**6
            -11484761479845*r**8-448030012806188*r**10-923279065769400*r**12-2215987127709280*r**14
            -4299852348121050*r**16+9472889263547440*r**18-9277581508200668*r**20
            -31781531991865880*r**22-18104177037563330*r**24-27015736351570200*r**26
            -15518947971280120*r**28-1317420333024768*r**30+224861143735855*r**32
            +27887758000680*r**34+7558303180950*r**36-491556891100*r**38-30358542393*r**40
            +1120958180*r**42)-12*Q2**3*(34273572-1577509605*r**2+2292476311*r**4
            +457761234170*r**6-1438437044550*r**8-11253279639193*r**10-7846259702825*r**12
            -203786323376824*r**14+633780268652800*r**16+1890930048694470*r**18+1634719669834702*r**20
            -65503397552180*r**22-1174763195448644*r**24-1167963236763210*r**26-499040367708890*r**28
            -429801840864088*r**30-132387413971220*r**32+16053657813791*r**34+1009765733115*r**36
            +100701808970*r**38-16328938118*r**40-941526045*r**42+50083491*r**44)
            -9*(-1+r**2)**2*(948841-65470174*r**2+395395199*r**4+31898195380*r**6
            -289749246705*r**8-2587282624294*r**10+1033535595041*r**12-10282085827296*r**14
            +123076872094570*r**16+883088514307140*r**18-1955711943187514*r**20-455650832663304*r**22
            +3074575462166094*r**24-1464703736353340*r**26-372201952523790*r**28+63670905353296*r**30
            -96162510294819*r**32-21996858175846*r**34-89131407925*r**36+79442308980*r**38
            +18693277171*r**40-676430494*r**42-42415651*r**44+1379440*r**46)-6*Q2**2*(6058775
            -214812480*r**2+2878939977*r**4+50550118814*r**6-574225127715*r**8-26530932798180*r**10
            -38616586299565*r**12+160098748329942*r**14-1196100038781146*r**16+3571296396743920*r**18
            +3139365094209690*r**20-591831069491300*r**22-2950614018712838*r**24-6308202922431096*r**26
            +1764126643539430*r**28-315474261847940*r**30-938717584158285*r**32-24750254817808*r**34
            -6465439591251*r**36+344140449990*r**38+258705678905*r**40-5043799620*r**42
            -417699273*r**44+6299054*r**46)+36*Q2*(1460319-85824184*r**2+564514846*r**4
            +33127949806*r**6-288224145806*r**8-3084402626916*r**10+1206077360886*r**12
            +2655322924606*r**14+5095156230161*r**16+847429045018464*r**18-860556991249316*r**20
            -1271037141287204*r**22+976588857114556*r**24+1664044986532456*r**26-1499155969476356*r**28
            -93150079629396*r**30+119710135915361*r**32-105007865221064*r**34-18553207343994*r**36
            -123668525706*r**38+66975428434*r**40+27190399516*r**42-887934194*r**44
            -65216554*r**46+2031279*r**48))*sqrtq2))/(378000*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2+378000*(
            -Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2
            +logq2**7*(-3047495270400000*r**32*(1+r**2)**2*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3-3047495270400000*r**32*(1+r**2)**2*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**6*(16930529280000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))+16930529280000*r**28*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))*sqrtq2)+logq2*(-22680000*(-Q2
            +(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(9+8*Q2**4-78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)
            -Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-22680000*(-Q2+(-1+r)**2)**3*r**8*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(9+8*Q2**4-78*r**2-366*r**4
            -78*r**6+9*r**8-Q2**3*(1+r**2)-Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1
            +13*r**2+13*r**4+r**6))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*sqrtq2)+logq2**2*(272160000*(-Q2+(-1+r)**2)**3*r**12*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531
            +550*r**2+531*r**4)-2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815
            -2120*r**2-11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4
            +494*r**6+225*r**8+r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6
            +26793*r**8+4554*r**10-501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6
            -1385*r**8-311*r**10+15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6
            +34670*r**8+13388*r**10-184*r**12-316*r**14+17*r**16))+272160000*(
            -Q2+(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531+550*r**2+531*r**4)
            -2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815-2120*r**2-11502*r**4
            -2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4+494*r**6+225*r**8
            +r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6+26793*r**8+4554*r**10
            -501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6-1385*r**8-311*r**10
            +15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6+34670*r**8+13388*r**10
            -184*r**12-316*r**14+17*r**16))*sqrtq2)+logq2**3*(-3265920000*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8+256*Q2**7*(1+r**2)
            -Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2+893*r**4+319*r**6)
            +Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)+12*Q2**3*(61
            +235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(-1071+9654*r**2
            +51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)-18*Q2*(23
            -35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12+23*r**14)
            +9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10-264*r**12
            -756*r**14+47*r**16))-3265920000*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8
            +256*Q2**7*(1+r**2)-Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2
            +893*r**4+319*r**6)+Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)
            +12*Q2**3*(61+235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(
            -1071+9654*r**2+51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)
            -18*Q2*(23-35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12
            +23*r**14)+9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10
            -264*r**12-756*r**14+47*r**16))*sqrtq2)+logq2**4*(39191040000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513+770*r**2
            +513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105-3400*r**2
            -11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4-1178*r**6
            +75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6+19593*r**8
            +3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6-5785*r**8
            -2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4+25204*r**6
            +52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))+39191040000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513
            +770*r**2+513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105
            -3400*r**2-11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4
            -1178*r**6+75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6
            +19593*r**8+3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6
            -5785*r**8-2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4
            +25204*r**6+52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))*sqrtq2)
            +logq2**5*(-94058496000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(64*Q2**8+1088*Q2**7*(1+r**2)+Q2**6*(-63+130*r**2-63*r**4)
            -2*Q2**5*(2777+6379*r**2+6379*r**4+2777*r**6)+Q2**4*(1555-8080*r**2
            -22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743-315*r**2-6548*r**4-6548*r**6
            -315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2+199629*r**4+305844*r**6
            +199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83-375*r**2-2833*r**4
            -5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)+9*(301-4028*r**2
            +808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12-4028*r**14+301*r**16))
            -94058496000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(64*Q2**8+1088*Q2**7*(1
            +r**2)+Q2**6*(-63+130*r**2-63*r**4)-2*Q2**5*(2777+6379*r**2+6379*r**4
            +2777*r**6)+Q2**4*(1555-8080*r**2-22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743
            -315*r**2-6548*r**4-6548*r**6-315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2
            +199629*r**4+305844*r**6+199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83
            -375*r**2-2833*r**4-5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)
            +9*(301-4028*r**2+808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12
            -4028*r**14+301*r**16))*sqrtq2))+((-1024*(Q2-(-1+r)**2)**6*r**6*(Q2
            -(1+r)**2)**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(-76*Q2**18
            -1655*Q2**17*(1+r**2)+Q2**16*(24641+240282*r**2+24641*r**4)-2*Q2**15*(67052
            +1239319*r**2+1239319*r**4+67052*r**6)+2*Q2**14*(200630+5196941*r**2
            +10737758*r**4+5196941*r**6+200630*r**8)-2*Q2**13*(364271+10502218*r**2
            +33344179*r**4+33344179*r**6+10502218*r**8+364271*r**10)+2*Q2**12*(396895
            +7352403*r**2+32725445*r**4+25335010*r**6+32725445*r**8+7352403*r**10
            +396895*r**12)+Q2**11*(-436868+21196582*r**2+93925958*r**4+504706920*r**6
            +504706920*r**8+93925958*r**10+21196582*r**12-436868*r**14)+2*Q2**10*(9196
            -26363243*r**2-144927450*r**4-722256637*r**6-1256223124*r**8-722256637*r**10
            -144927450*r**12-26363243*r**14+9196*r**16)+2*Q2**9*(10340+16502833*r**2
            +116475899*r**4+616851113*r**6+1763341775*r**8+1763341775*r**10+616851113*r**12
            +116475899*r**14+16502833*r**16+10340*r**18)+2*Q2**8*(90706+8523301*r**2
            +4202778*r**4+220986468*r**6-348329604*r**8-346198786*r**10-348329604*r**12
            +220986468*r**14+4202778*r**16+8523301*r**18+90706*r**20)-2*Q2**7*(96520
            +16635921*r**2+51099145*r**4+656884620*r**6+933398020*r**8+2345717246*r**10
            +2345717246*r**12+933398020*r**14+656884620*r**16+51099145*r**18+16635921*r**20
            +96520*r**22)+Q2**6*(-3812+8294270*r**2+65701316*r**4+607983910*r**6
            +1093256180*r**8+2997480060*r**10+5433674392*r**12+2997480060*r**14+1093256180*r**16
            +607983910*r**18+65701316*r**20+8294270*r**22-3812*r**24)+2*Q2**5*(57139
            +5931658*r**2-44246213*r**4-60771425*r**6-542469152*r**8-63245533*r**10
            -191986714*r**12-191986714*r**14-63245533*r**16-542469152*r**18-60771425*r**20
            -44246213*r**22+5931658*r**24+57139*r**26)+Q2**4*(-61190-8518798*r**2
            +93018086*r**4+259089092*r**6+1846824690*r**8+2159917710*r**10-2006830034*r**12
            +3025991288*r**14-2006830034*r**16+2159917710*r**18+1846824690*r**20
            +259089092*r**22+93018086*r**24-8518798*r**26-61190*r**28)-2*Q2**3*(4522
            +43083*r**2+3761699*r**4+56046364*r**6+307379128*r**8+806473053*r**10
            -1930075211*r**12+2192162562*r**14+2192162562*r**16-1930075211*r**18
            +806473053*r**20+307379128*r**22+56046364*r**24+3761699*r**26+43083*r**28
            +4522*r**30)+(-1+r**2)**2*(1059+100426*r**2-5962868*r**4-39610434*r**6
            -45812148*r**8-1199964502*r**10+5924088692*r**12-17894752434*r**14+26088368418*r**16
            -17894752434*r**18+5924088692*r**20-1199964502*r**22-45812148*r**24-39610434*r**26
            -5962868*r**28+100426*r**30+1059*r**32)+2*Q2**2*(10390+1018783*r**2
            -24542950*r**4-76014915*r**6-227146500*r**8-1096488257*r**10+1651864934*r**12
            +88497125*r**14-3610013220*r**16+88497125*r**18+1651864934*r**20-1096488257*r**22
            -227146500*r**24-76014915*r**26-24542950*r**28+1018783*r**30+10390*r**32)
            +Q2*(-7961-793259*r**2+31530810*r**4+129835670*r**6+186126150*r**8
            +3116726122*r**10-14062700766*r**12+30978051854*r**14-19507856620*r**16
            -19507856620*r**18+30978051854*r**20-14062700766*r**22+3116726122*r**24
            +186126150*r**26+129835670*r**28+31530810*r**30-793259*r**32-7961*r**34))
            -1024*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))**2*(76*Q2**19+1579*Q2**18*(1+r**2)-8*Q2**17*(3287
            +30449*r**2+3287*r**4)+Q2**16*(158745+2743561*r**2+2743561*r**4+158745*r**6)
            -4*Q2**15*(133841+3251656*r**2+6608198*r**4+3251656*r**6+133841*r**8)
            +2*Q2**14*(564901+15899789*r**2+49278878*r**4+49278878*r**6+15899789*r**8
            +564901*r**10)-4*Q2**13*(380583+9109446*r**2+38285921*r**4+46011684*r**6
            +38285921*r**8+9109446*r**10+380583*r**12)+2*Q2**12*(615329-2848993*r**2
            -6885131*r**4-194293005*r**6-194293005*r**8-6885131*r**10-2848993*r**12
            +615329*r**14)+4*Q2**11*(-113815+18371550*r**2+101244360*r**4+510786538*r**6
            +880465022*r**8+510786538*r**10+101244360*r**12+18371550*r**14-113815*r**16)
            -16*Q2**10*(143+5357110*r**2+35970824*r**4+185504400*r**6+467727692*r**8
            +467727692*r**10+185504400*r**12+35970824*r**14+5357110*r**16+143*r**18)
            +4*Q2**9*(-40183+3994936*r**2+64387977*r**4+256170272*r**6+1364261246*r**8
            +1936441168*r**10+1364261246*r**12+256170272*r**14+64387977*r**16+3994936*r**18
            -40183*r**20)+4*Q2**8*(93613+12624964*r**2+31912612*r**4+441036933*r**6
            +403027442*r**8+825594428*r**10+825594428*r**12+403027442*r**14+441036933*r**16
            +31912612*r**18+12624964*r**20+93613*r**22)-4*Q2**7*(47307+10439788*r**2
            +50292862*r**4+505987860*r**6+1068455365*r**8+2388927648*r**10+3704135844*r**12
            +2388927648*r**14+1068455365*r**16+505987860*r**18+50292862*r**20+10439788*r**22
            +47307*r**24)+2*Q2**6*(-59045-1786429*r**2+81244006*r**4+397614038*r**6
            +1393089197*r**8+2108613653*r**10+4407563940*r**12+4407563940*r**14+2108613653*r**16
            +1393089197*r**18+397614038*r**20+81244006*r**22-1786429*r**24-59045*r**26)
            +4*Q2**5*(43867+5124098*r**2-42411799*r**4-117281092*r**6-763326461*r**8
            -842836770*r**10+374091385*r**12-948484536*r**14+374091385*r**16-842836770*r**18
            -763326461*r**20-117281092*r**22-42411799*r**24+5124098*r**26+43867*r**28)
            +Q2**4*(-52146-8493822*r**2+92022686*r**4+464199906*r**6+2720672038*r**8
            +5619688506*r**10-3707062746*r**12+5403486378*r**14+5403486378*r**16
            -3707062746*r**18+5619688506*r**20+2720672038*r**22+464199906*r**24+92022686*r**26
            -8493822*r**28-52146*r**30)-8*Q2**3*(3728+266597*r**2-5184542*r**4-4051713*r**6
            +34069748*r**8+4340981*r**10+132065694*r**12+87646119*r**14+193577976*r**16
            +87646119*r**18+132065694*r**20+4340981*r**22+34069748*r**24-4051713*r**26
            -5184542*r**28+266597*r**30+3728*r**32)+(-1+r**2)**2*(1059+101485*r**2
            -5862442*r**4-45573302*r**6-85422582*r**8-1245776650*r**10+4724124190*r**12
            -11970663742*r**14+8193615984*r**16+8193615984*r**18-11970663742*r**20
            +4724124190*r**22-1245776650*r**24-85422582*r**26-45573302*r**28-5862442*r**30
            +101485*r**32+1059*r**34)+Q2**2*(28741+2851605*r**2-78579144*r**4-330951400*r**6
            -792448980*r**8-5763995636*r**10+15173454120*r**12-27497327736*r**14
            +12464824430*r**16+12464824430*r**18-27497327736*r**20+15173454120*r**22
            -5763995636*r**24-792448980*r**26-330951400*r**28-78579144*r**30+2851605*r**32
            +28741*r**34)-4*Q2*(2255+224882*r**2-9225053*r**4-47237688*r**6-72128992*r**8
            -1112700728*r**10+4806045048*r**12-11964561352*r**14+14082941686*r**16
            -12237632116*r**18+14082941686*r**20-11964561352*r**22+4806045048*r**24
            -1112700728*r**26-72128992*r**28-47237688*r**30-9225053*r**32+224882*r**34
            +2255*r**36))*sqrtq2+logq2**7*(7223692492800000*(-Q2+(-1+r)**2)**3*r**34*(1
            +r**2)**3*(1-Q2+r**2)*(-Q2+(1+r)**2)**3+7223692492800000*r**34*(1+r**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**6*(5733089280000*r**28*(1
            +r**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(480*Q2**8-2160*Q2**7*(1
            +r**2)+4*Q2**6*(420+1601*r**2+420*r**4)+Q2**5*(6510-1919*r**2-1919*r**4
            +6510*r**6)-Q2**4*(11970+9045*r**2+1438*r**4+9045*r**6+11970*r**8)
            +Q2**3*(-3990+4780*r**2+3872*r**4+3872*r**6+4780*r**8-3990*r**10)+3*(
            -1+r**2)**2*(2120-1317*r**2+118*r**4+4038*r**6+118*r**8-1317*r**10
            +2120*r**12)+2*Q2**2*(12705-2405*r**2+506*r**4+1488*r**6+506*r**8-2405*r**10
            +12705*r**12)-3*Q2*(7440-7807*r**2+2791*r**4+9336*r**6+9336*r**8+2791*r**10
            -7807*r**12+7440*r**14))+5733089280000*(-Q2+(-1+r)**2)*r**28*(1+r**2)**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(480*Q2**8
            -2160*Q2**7*(1+r**2)+4*Q2**6*(420+1601*r**2+420*r**4)+Q2**5*(6510-1919*r**2
            -1919*r**4+6510*r**6)-Q2**4*(11970+9045*r**2+1438*r**4+9045*r**6+11970*r**8)
            +Q2**3*(-3990+4780*r**2+3872*r**4+3872*r**6+4780*r**8-3990*r**10)+3*(
            -1+r**2)**2*(2120-1317*r**2+118*r**4+4038*r**6+118*r**8-1317*r**10
            +2120*r**12)+2*Q2**2*(12705-2405*r**2+506*r**4+1488*r**6+506*r**8-2405*r**10
            +12705*r**12)-3*Q2*(7440-7807*r**2+2791*r**4+9336*r**6+9336*r**8+2791*r**10
            -7807*r**12+7440*r**14))*sqrtq2)+logq2**5*(31850496000*r**24*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-7680*Q2**12+114720*Q2**11*(1
            +r**2)-128*Q2**10*(4689+9889*r**2+4689*r**4)+120*Q2**9*(12618+41855*r**2
            +41855*r**4+12618*r**6)-15*Q2**8*(134670+610775*r**2+938642*r**4+610775*r**6
            +134670*r**8)+40*Q2**7*(41607+187873*r**2+369618*r**4+369618*r**6+187873*r**8
            +41607*r**10)-30*Q2**6*(62895+81564*r**2+105381*r**4+92272*r**6+105381*r**8
            +81564*r**10+62895*r**12)+24*Q2**5*(122736+138446*r**2+217921*r**4-23655*r**6
            -23655*r**8+217921*r**10+138446*r**12+122736*r**14)-10*Q2**4*(207171
            +663935*r**2+1799718*r**4+1669611*r**6+812546*r**8+1669611*r**10+1799718*r**12
            +663935*r**14+207171*r**16)-60*Q2**3*(16090-59555*r**2-1415*r**4-72961*r**6
            -153311*r**8-153311*r**10-72961*r**12-1415*r**14-59555*r**16+16090*r**18)
            +9*(-1+r**2)**2*(33592+102891*r**2+890452*r**4-48872*r**6-275036*r**8
            +710746*r**10-275036*r**12-48872*r**14+890452*r**16+102891*r**18+33592*r**20)
            +30*Q2**2*(82675+38086*r**2+1030775*r**4+481316*r**6-229666*r**8-115012*r**10
            -229666*r**12+481316*r**14+1030775*r**16+38086*r**18+82675*r**20)-180*Q2*(8164
            +8325*r**2+148175*r**4-63102*r**6-41094*r**8+151212*r**10+151212*r**12
            -41094*r**14-63102*r**16+148175*r**18+8325*r**20+8164*r**22))+31850496000*r**24*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-7680*Q2**12+114720*Q2**11*(1
            +r**2)-128*Q2**10*(4689+9889*r**2+4689*r**4)+120*Q2**9*(12618+41855*r**2
            +41855*r**4+12618*r**6)-15*Q2**8*(134670+610775*r**2+938642*r**4+610775*r**6
            +134670*r**8)+40*Q2**7*(41607+187873*r**2+369618*r**4+369618*r**6+187873*r**8
            +41607*r**10)-30*Q2**6*(62895+81564*r**2+105381*r**4+92272*r**6+105381*r**8
            +81564*r**10+62895*r**12)+24*Q2**5*(122736+138446*r**2+217921*r**4-23655*r**6
            -23655*r**8+217921*r**10+138446*r**12+122736*r**14)-10*Q2**4*(207171
            +663935*r**2+1799718*r**4+1669611*r**6+812546*r**8+1669611*r**10+1799718*r**12
            +663935*r**14+207171*r**16)-60*Q2**3*(16090-59555*r**2-1415*r**4-72961*r**6
            -153311*r**8-153311*r**10-72961*r**12-1415*r**14-59555*r**16+16090*r**18)
            +9*(-1+r**2)**2*(33592+102891*r**2+890452*r**4-48872*r**6-275036*r**8
            +710746*r**10-275036*r**12-48872*r**14+890452*r**16+102891*r**18+33592*r**20)
            +30*Q2**2*(82675+38086*r**2+1030775*r**4+481316*r**6-229666*r**8-115012*r**10
            -229666*r**12+481316*r**14+1030775*r**16+38086*r**18+82675*r**20)-180*Q2*(8164
            +8325*r**2+148175*r**4-63102*r**6-41094*r**8+151212*r**10+151212*r**12
            -41094*r**14-63102*r**16+148175*r**18+8325*r**20+8164*r**22))*sqrtq2)
            +logq2**4*(-530841600*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-10240*Q2**16
            +455680*Q2**15*(1+r**2)-64*Q2**14*(58193+118078*r**2+58193*r**4)+64*Q2**13*(222227
            +691459*r**2+691459*r**4+222227*r**6)-4*Q2**12*(7779288+33855025*r**2
            +52066098*r**4+33855025*r**6+7779288*r**8)+Q2**11*(41978508+242726495*r**2
            +509845857*r**4+509845857*r**6+242726495*r**8+41978508*r**10)-Q2**10*(35553132
            +244128799*r**2+591522776*r**4+759962186*r**6+591522776*r**8+244128799*r**10
            +35553132*r**12)+Q2**9*(16282704+78485129*r**2-80010201*r**4-589535240*r**6
            -589535240*r**8-80010201*r**10+78485129*r**12+16282704*r**14)+Q2**8*(7820544
            +106581683*r**2+1072733208*r**4+3586639589*r**6+5223215360*r**8+3586639589*r**10
            +1072733208*r**12+106581683*r**14+7820544*r**16)-4*Q2**7*(7885574+33598150*r**2
            +291713444*r**4+1075855125*r**6+1994588479*r**8+1994588479*r**10+1075855125*r**12
            +291713444*r**14+33598150*r**16+7885574*r**18)+4*Q2**6*(9525926+23563150*r**2
            +191067354*r**4+452818389*r**6+819498060*r**8+1058061522*r**10+819498060*r**12
            +452818389*r**14+191067354*r**16+23563150*r**18+9525926*r**20)-4*Q2**5*(4405444
            +36177903*r**2+285196912*r**4+354060452*r**6+170147412*r**8+14067677*r**10
            +14067677*r**12+170147412*r**14+354060452*r**16+285196912*r**18+36177903*r**20
            +4405444*r**22)+4*Q2**4*(-1670588+41325472*r**2+306607407*r**4+699232485*r**6
            +1047052480*r**8+1017579571*r**10+814254346*r**12+1017579571*r**14+1047052480*r**16
            +699232485*r**18+306607407*r**20+41325472*r**22-1670588*r**24)+3*Q2**3*(3757476
            -10592053*r**2+15908197*r**4-432866739*r**6-517574725*r**8-448755562*r**10
            -856708594*r**12-856708594*r**14-448755562*r**16-517574725*r**18-432866739*r**20
            +15908197*r**22-10592053*r**24+3757476*r**26)+9*(-1+r**2)**2*(22192
            -1843407*r**2-18510370*r**4-34339742*r**6-173546978*r**8-112904689*r**10
            +82131924*r**12+94622140*r**14+82131924*r**16-112904689*r**18-173546978*r**20
            -34339742*r**22-18510370*r**24-1843407*r**26+22192*r**28)-3*Q2**2*(1359684
            +29673675*r**2+333514744*r**4+228990650*r**6+1715138064*r**8+1994463477*r**10
            -117540300*r**12-932159988*r**14-117540300*r**16+1994463477*r**18+1715138064*r**20
            +228990650*r**22+333514744*r**24+29673675*r**26+1359684*r**28)-9*Q2*(608
            -7993395*r**2-73295953*r**4-51522468*r**6-523917540*r**8-194523883*r**10
            +323425135*r**12-318892504*r**14-318892504*r**16+323425135*r**18-194523883*r**20
            -523917540*r**22-51522468*r**24-73295953*r**26-7993395*r**28+608*r**30))
            -530841600*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(10240*Q2**17-465920*Q2**16*(1
            +r**2)+576*Q2**15*(7257+14702*r**2+7257*r**4)-640*Q2**14*(28042+86773*r**2
            +86773*r**4+28042*r**6)+4*Q2**13*(11334920+48474001*r**2+74192786*r**4
            +48474001*r**6+11334920*r**8)-29*Q2**12*(2520540+14112543*r**2+29432081*r**4
            +29432081*r**6+14112543*r**8+2520540*r**10)+2*Q2**11*(38765820+264416901*r**2
            +672047564*r**4+889826950*r**6+672047564*r**8+264416901*r**10+38765820*r**12)
            -2*Q2**10*(25917918+179083530*r**2+377820687*r**4+380974861*r**6+380974861*r**8
            +377820687*r**10+179083530*r**12+25917918*r**14)+10*Q2**9*(846216-1181385*r**2
            -107425828*r**4-425618503*r**6-640228584*r**8-425618503*r**10-107425828*r**12
            -1181385*r**14+846216*r**16)+Q2**8*(39362840+248794827*r**2+2346168667*r**4
            +8962793297*r**6+16788208865*r**8+16788208865*r**10+8962793297*r**12
            +2346168667*r**14+248794827*r**16+39362840*r**18)-8*Q2**7*(8705750+32523437*r**2
            +258189474*r**4+910193479*r**6+1944970832*r**8+2523619240*r**10+1944970832*r**12
            +910193479*r**14+258189474*r**16+32523437*r**18+8705750*r**20)+4*Q2**6*(13931370
            +69266979*r**2+499827416*r**4+997946195*r**6+1442463861*r**8+1891627259*r**10
            +1891627259*r**12+1442463861*r**14+997946195*r**16+499827416*r**18+69266979*r**20
            +13931370*r**22)-4*Q2**5*(2734856+81908819*r**2+627982222*r**4+1338489849*r**6
            +1571260344*r**8+1201794660*r**10+842389700*r**12+1201794660*r**14+1571260344*r**16
            +1338489849*r**18+627982222*r**20+81908819*r**22+2734856*r**24)+5*Q2**4*(
            -3590956+38079139*r**2+268801385*r**4+1064391957*r**6+1707572807*r**8
            +1920958978*r**10+1979492290*r**12+1979492290*r**14+1920958978*r**16
            +1707572807*r**18+1064391957*r**20+268801385*r**22+38079139*r**24-3590956*r**26)
            +6*Q2**3*(2558580+11419549*r**2+169415444*r**4-93983946*r**6+382348300*r**8
            +514066595*r**10-711502228*r**12-1322788588*r**14-711502228*r**16+514066595*r**18
            +382348300*r**20-93983946*r**22+169415444*r**24+11419549*r**26+2558580*r**28)
            +9*(-1+r**2)**2*(22192-1821215*r**2-20353777*r**4-52850112*r**6-207886720*r**8
            -286451667*r**10-30772765*r**12+176754064*r**14+176754064*r**16-30772765*r**18
            -286451667*r**20-207886720*r**22-52850112*r**24-20353777*r**26-1821215*r**28
            +22192*r**30)-6*Q2**2*(678930+27506772*r**2+291538139*r**4+358536399*r**6
            +1757940667*r**8+2146586595*r**10+453323886*r**12-46511388*r**14-46511388*r**16
            +453323886*r**18+2146586595*r**20+1757940667*r**22+358536399*r**24+291538139*r**26
            +27506772*r**28+678930*r**30)-18*Q2*(11400-4940289*r**2-48045356*r**4
            -61990415*r**6-349408936*r**8-259295949*r**10+131647788*r**12-89006883*r**14
            -331382720*r**16-89006883*r**18+131647788*r**20-259295949*r**22-349408936*r**24
            -61990415*r**26-48045356*r**28-4940289*r**30+11400*r**32))*sqrtq2)+logq2**3*(
            -8847360*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-522240*Q2**19
            +6652928*Q2**18*(1+r**2)-64*Q2**17*(595461+1221322*r**2+595461*r**4)
            +32*Q2**16*(3908867+12680217*r**2+12680217*r**4+3908867*r**6)-16*Q2**15*(15418808
            +72478609*r**2+112667122*r**4+72478609*r**6+15418808*r**8)+Q2**14*(266200500
            +1835751775*r**2+3832533913*r**4+3832533913*r**6+1835751775*r**8+266200500*r**10)
            -2*Q2**13*(28861052+596699597*r**2+1153786856*r**4+1125693742*r**6+1153786856*r**8
            +596699597*r**10+28861052*r**12)-Q2**12*(240049008+904884951*r**2+7140623095*r**4
            +19612295874*r**6+19612295874*r**8+7140623095*r**10+904884951*r**12+240049008*r**14)
            +4*Q2**11*(79873662+617966187*r**2+4814489834*r**4+16152998629*r**6+23748999120*r**8
            +16152998629*r**10+4814489834*r**12+617966187*r**14+79873662*r**16)-Q2**10*(135983436
            +2187397113*r**2+21811344211*r**4+92245188641*r**6+180546460647*r**8
            +180546460647*r**10+92245188641*r**12+21811344211*r**14+2187397113*r**16
            +135983436*r**18)+2*Q2**9*(-27921640+610686425*r**2+5801079712*r**4+25970036052*r**6
            +55092577960*r**8+67390501990*r**10+55092577960*r**12+25970036052*r**14
            +5801079712*r**16+610686425*r**18-27921640*r**20)+Q2**8*(105581424-449765471*r**2
            +2488903949*r**4+27142830328*r**6+143523623664*r**8+322359880826*r**10
            +322359880826*r**12+143523623664*r**14+27142830328*r**16+2488903949*r**18
            -449765471*r**20+105581424*r**22)-8*Q2**7*(8970434+75523353*r**2+1422080906*r**4
            +6470011389*r**6+32149066414*r**8+83007985578*r**10+113342107532*r**12
            +83007985578*r**14+32149066414*r**16+6470011389*r**18+1422080906*r**20
            +75523353*r**22+8970434*r**24)+Q2**6*(18410972+1368987397*r**2+12531372171*r**4
            +23575528231*r**6+135685296705*r**8+330321829182*r**10+551607469742*r**12
            +551607469742*r**14+330321829182*r**16+135685296705*r**18+23575528231*r**20
            +12531372171*r**22+1368987397*r**24+18410972*r**26)+2*Q2**5*(12171828
            -434231771*r**2-4252629736*r**4-15528759318*r**6-72098845856*r**8-49498876357*r**10
            -871477996*r**12+382834412*r**14-871477996*r**16-49498876357*r**18-72098845856*r**20
            -15528759318*r**22-4252629736*r**24-434231771*r**26+12171828*r**28)+Q2**4*(
            -27242480-95586125*r**2+2910623163*r**4+54610783158*r**6+217191384630*r**8
            +290114737205*r**10+258032279645*r**12+262887660804*r**14+262887660804*r**16
            +258032279645*r**18+290114737205*r**20+217191384630*r**22+54610783158*r**24
            +2910623163*r**26-95586125*r**28-27242480*r**30)+12*Q2**3*(398146+30535801*r**2
            +130479574*r**4-1812015837*r**6-2675836796*r**8-14944036431*r**10-13155882966*r**12
            -14194475853*r**14-21428411276*r**16-14194475853*r**18-13155882966*r**20
            -14944036431*r**22-2675836796*r**24-1812015837*r**26+130479574*r**28
            +30535801*r**30+398146*r**32)+9*(-1+r**2)**2*(80912+797035*r**2-37361827*r**4
            -676200445*r**6-3111051995*r**8-1488558801*r**10-18513020535*r**12-10696690409*r**14
            +21821206065*r**16+21821206065*r**18-10696690409*r**20-18513020535*r**22
            -1488558801*r**24-3111051995*r**26-676200445*r**28-37361827*r**30+797035*r**32
            +80912*r**34)+3*Q2**2*(2279828-48351289*r**2-976937051*r**4-7660942613*r**6
            -50003562963*r**8-2203633657*r**10-139749943711*r**12-136369237745*r**14
            +52149529201*r**16+52149529201*r**18-136369237745*r**20-139749943711*r**22
            -2203633657*r**24-50003562963*r**26-7660942613*r**28-976937051*r**30
            -48351289*r**32+2279828*r**34)-18*Q2*(232048-223127*r**2-92657968*r**4
            -1243358288*r**6-5498382880*r**8+2291753916*r**10-27630416864*r**12-7926826416*r**14
            +15576389824*r**16-1756220490*r**18+15576389824*r**20-7926826416*r**22
            -27630416864*r**24+2291753916*r**26-5498382880*r**28-1243358288*r**30
            -92657968*r**32-223127*r**34+232048*r**36))+8847360*r**16*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**4*(522240*Q2**19-6652928*Q2**18*(1+r**2)+64*Q2**17*(595461
            +1221322*r**2+595461*r**4)-32*Q2**16*(3908867+12680217*r**2+12680217*r**4
            +3908867*r**6)+16*Q2**15*(15418808+72478609*r**2+112667122*r**4+72478609*r**6
            +15418808*r**8)-Q2**14*(266200500+1835751775*r**2+3832533913*r**4+3832533913*r**6
            +1835751775*r**8+266200500*r**10)+2*Q2**13*(28861052+596699597*r**2+1153786856*r**4
            +1125693742*r**6+1153786856*r**8+596699597*r**10+28861052*r**12)+Q2**12*(240049008
            +904884951*r**2+7140623095*r**4+19612295874*r**6+19612295874*r**8+7140623095*r**10
            +904884951*r**12+240049008*r**14)-4*Q2**11*(79873662+617966187*r**2+4814489834*r**4
            +16152998629*r**6+23748999120*r**8+16152998629*r**10+4814489834*r**12
            +617966187*r**14+79873662*r**16)+Q2**10*(135983436+2187397113*r**2+21811344211*r**4
            +92245188641*r**6+180546460647*r**8+180546460647*r**10+92245188641*r**12
            +21811344211*r**14+2187397113*r**16+135983436*r**18)+2*Q2**9*(27921640
            -610686425*r**2-5801079712*r**4-25970036052*r**6-55092577960*r**8-67390501990*r**10
            -55092577960*r**12-25970036052*r**14-5801079712*r**16-610686425*r**18
            +27921640*r**20)-Q2**8*(105581424-449765471*r**2+2488903949*r**4+27142830328*r**6
            +143523623664*r**8+322359880826*r**10+322359880826*r**12+143523623664*r**14
            +27142830328*r**16+2488903949*r**18-449765471*r**20+105581424*r**22)
            +8*Q2**7*(8970434+75523353*r**2+1422080906*r**4+6470011389*r**6+32149066414*r**8
            +83007985578*r**10+113342107532*r**12+83007985578*r**14+32149066414*r**16
            +6470011389*r**18+1422080906*r**20+75523353*r**22+8970434*r**24)-Q2**6*(18410972
            +1368987397*r**2+12531372171*r**4+23575528231*r**6+135685296705*r**8
            +330321829182*r**10+551607469742*r**12+551607469742*r**14+330321829182*r**16
            +135685296705*r**18+23575528231*r**20+12531372171*r**22+1368987397*r**24
            +18410972*r**26)+2*Q2**5*(-12171828+434231771*r**2+4252629736*r**4+15528759318*r**6
            +72098845856*r**8+49498876357*r**10+871477996*r**12-382834412*r**14+871477996*r**16
            +49498876357*r**18+72098845856*r**20+15528759318*r**22+4252629736*r**24
            +434231771*r**26-12171828*r**28)+Q2**4*(27242480+95586125*r**2-2910623163*r**4
            -54610783158*r**6-217191384630*r**8-290114737205*r**10-258032279645*r**12
            -262887660804*r**14-262887660804*r**16-258032279645*r**18-290114737205*r**20
            -217191384630*r**22-54610783158*r**24-2910623163*r**26+95586125*r**28
            +27242480*r**30)-12*Q2**3*(398146+30535801*r**2+130479574*r**4-1812015837*r**6
            -2675836796*r**8-14944036431*r**10-13155882966*r**12-14194475853*r**14
            -21428411276*r**16-14194475853*r**18-13155882966*r**20-14944036431*r**22
            -2675836796*r**24-1812015837*r**26+130479574*r**28+30535801*r**30+398146*r**32)
            +3*Q2**2*(-2279828+48351289*r**2+976937051*r**4+7660942613*r**6+50003562963*r**8
            +2203633657*r**10+139749943711*r**12+136369237745*r**14-52149529201*r**16
            -52149529201*r**18+136369237745*r**20+139749943711*r**22+2203633657*r**24
            +50003562963*r**26+7660942613*r**28+976937051*r**30+48351289*r**32-2279828*r**34)
            -9*(-1+r**2)**2*(80912+797035*r**2-37361827*r**4-676200445*r**6-3111051995*r**8
            -1488558801*r**10-18513020535*r**12-10696690409*r**14+21821206065*r**16
            +21821206065*r**18-10696690409*r**20-18513020535*r**22-1488558801*r**24
            -3111051995*r**26-676200445*r**28-37361827*r**30+797035*r**32+80912*r**34)
            +18*Q2*(232048-223127*r**2-92657968*r**4-1243358288*r**6-5498382880*r**8
            +2291753916*r**10-27630416864*r**12-7926826416*r**14+15576389824*r**16
            -1756220490*r**18+15576389824*r**20-7926826416*r**22-27630416864*r**24
            +2291753916*r**26-5498382880*r**28-1243358288*r**30-92657968*r**32-223127*r**34
            +232048*r**36))*sqrtq2)+logq2**2*(147456*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(2439168*Q2**22-29633536*Q2**21*(1+r**2)+32*Q2**20*(4805969
            +10085842*r**2+4805969*r**4)-80*Q2**19*(5397203+18601305*r**2+18601305*r**4
            +5397203*r**6)+20*Q2**18*(32749660+182388265*r**2+284962714*r**4+182388265*r**6
            +32749660*r**8)-Q2**17*(331482782+4504859135*r**2+8740622055*r**4+8740622055*r**6
            +4504859135*r**8+331482782*r**10)-Q2**16*(576239926-300287779*r**2+8090912870*r**4
            +19247434110*r**6+8090912870*r**8-300287779*r**10+576239926*r**12)+2*Q2**15*(561174769
            +4088632237*r**2+30370749614*r**4+82647720000*r**6+82647720000*r**8+30370749614*r**10
            +4088632237*r**12+561174769*r**14)-10*Q2**14*(52819883+1292917620*r**2
            +11156441785*r**4+41486021888*r**6+62335542304*r**8+41486021888*r**10
            +11156441785*r**12+1292917620*r**14+52819883*r**16)-10*Q2**13*(48737815
            -737334500*r**2-7787893976*r**4-45719350038*r**6-94921414165*r**8-94921414165*r**10
            -45719350038*r**12-7787893976*r**14-737334500*r**16+48737815*r**18)+Q2**12*(732234538
            +3787186930*r**2+39743154240*r**4-21807222900*r**6-25443805770*r**8+91346214212*r**10
            -25443805770*r**12-21807222900*r**14+39743154240*r**16+3787186930*r**18
            +732234538*r**20)-2*Q2**11*(120781403+4643682073*r**2+56387186870*r**4
            +266855877990*r**6+1083794507315*r**8+2399065577117*r**10+2399065577117*r**12
            +1083794507315*r**14+266855877990*r**16+56387186870*r**18+4643682073*r**20
            +120781403*r**22)+2*Q2**10*(-98333731+2769623082*r**2+36869824809*r**4
            +324891889610*r**6+1786148921615*r**8+5205090755276*r**10+7436570270038*r**12
            +5205090755276*r**14+1786148921615*r**16+324891889610*r**18+36869824809*r**20
            +2769623082*r**22-98333731*r**24)+10*Q2**9*(27491263+49310635*r**2-1331844635*r**4
            -39762345107*r**6-247026022127*r**8-882053072203*r**10-1659715675810*r**12
            -1659715675810*r**14-882053072203*r**16-247026022127*r**18-39762345107*r**20
            -1331844635*r**22+49310635*r**24+27491263*r**26)-10*Q2**8*(12910705+271193290*r**2
            +432980436*r**4-12065768154*r**6+13194887510*r**8+125147127110*r**10
            +425183818821*r**12+657187672404*r**14+425183818821*r**16+125147127110*r**18
            +13194887510*r**20-12065768154*r**22+432980436*r**24+271193290*r**26
            +12910705*r**28)+2*Q2**7*(-27638701+981177835*r**2+8450972530*r**4+59087026020*r**6
            +849117746010*r**8+3446529753456*r**10+11331294583315*r**12+20991938153935*r**14
            +20991938153935*r**16+11331294583315*r**18+3446529753456*r**20+849117746010*r**22
            +59087026020*r**24+8450972530*r**26+981177835*r**28-27638701*r**30)+2*Q2**6*(54902267
            -343873888*r**2-14382928955*r**4-130085653380*r**6-751140175890*r**8
            -1318102286932*r**10-6508918509797*r**12-14206655446280*r**14-18769986550290*r**16
            -14206655446280*r**18-6508918509797*r**20-1318102286932*r**22-751140175890*r**24
            -130085653380*r**26-14382928955*r**28-343873888*r**30+54902267*r**32)
            +2*Q2**5*(-16321361-177539388*r**2+6126735524*r**4+105028119130*r**6
            +522486603645*r**8+834754024691*r**10+4152141898738*r**12+1286959854096*r**14
            -332410255075*r**16-332410255075*r**18+1286959854096*r**20+4152141898738*r**22
            +834754024691*r**24+522486603645*r**26+105028119130*r**28+6126735524*r**30
            -177539388*r**32-16321361*r**34)-10*Q2**4*(2759381-66129175*r**2-881147860*r**4
            +6656092506*r**6+81118928169*r**8+588296702544*r**10+1643565280635*r**12
            +1028675510950*r**14+626950537819*r**16+1227042930062*r**18+626950537819*r**20
            +1028675510950*r**22+1643565280635*r**24+588296702544*r**26+81118928169*r**28
            +6656092506*r**30-881147860*r**32-66129175*r**34+2759381*r**36)+30*Q2**3*(617025
            -8039705*r**2-266997406*r**4-1037174074*r**6+4797139975*r**8+119373825945*r**10
            +115137356771*r**12+288983905981*r**14+248808788533*r**16+479412496955*r**18
            +479412496955*r**20+248808788533*r**22+288983905981*r**24+115137356771*r**26
            +119373825945*r**28+4797139975*r**30-1037174074*r**32-266997406*r**34
            -8039705*r**36+617025*r**38)+9*(-1+r**2)**2*(83432-2265295*r**2-47484400*r**4
            +538443025*r**6+9818282920*r**8+82997415772*r**10+200293285760*r**12
            -194210419300*r**14+1653467058800*r**16+81123425990*r**18-2753498053408*r**20
            +81123425990*r**22+1653467058800*r**24-194210419300*r**26+200293285760*r**28
            +82997415772*r**30+9818282920*r**32+538443025*r**34-47484400*r**36-2265295*r**38
            +83432*r**40)+6*Q2**2*(214413-18864640*r**2-4825895*r**4+8592291840*r**6
            +73019524585*r**8+328107435968*r**10+1906087367740*r**12-1167120013120*r**14
            +3117046759050*r**16+2500667565440*r**18-1056940510762*r**20+2500667565440*r**22
            +3117046759050*r**24-1167120013120*r**26+1906087367740*r**28+328107435968*r**30
            +73019524585*r**32+8592291840*r**34-4825895*r**36-18864640*r**38+214413*r**40)
            -9*Q2*(390224-11729881*r**2-174896405*r**4+3085843475*r**6+38476103455*r**8
            +266089754684*r**10+706097713644*r**12-1293679221860*r**14+4437547415900*r**16
            +722457689810*r**18-3050973863046*r**20-3050973863046*r**22+722457689810*r**24
            +4437547415900*r**26-1293679221860*r**28+706097713644*r**30+266089754684*r**32
            +38476103455*r**34+3085843475*r**36-174896405*r**38-11729881*r**40+390224*r**42))
            -147456*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(2439168*Q2**23-32072704*Q2**22*(1
            +r**2)+32*Q2**21*(5732017+11937938*r**2+5732017*r**4)-16*Q2**20*(36597953
            +122790147*r**2+122790147*r**4+36597953*r**6)+20*Q2**19*(54338472+278382297*r**2
            +433773154*r**4+278382297*r**6+54338472*r**8)-Q2**18*(986475982+8807617635*r**2
            +18087641635*r**4+18087641635*r**6+8807617635*r**8+986475982*r**10)-8*Q2**17*(30594643
            -642078712*r**2-644321040*r**4+220773750*r**6-644321040*r**8-642078712*r**10
            +30594643*r**12)+Q2**16*(1698589464+8453216621*r**2+68532124319*r**4
            +192633786980*r**6+192633786980*r**8+68532124319*r**10+8453216621*r**12
            +1698589464*r**14)-4*Q2**15*(412637092+5557197553*r**2+45120795388*r**4
            +160224289527*r**6+238486575760*r**8+160224289527*r**10+45120795388*r**12
            +5557197553*r**14+412637092*r**16)+10*Q2**14*(4082068+2083072003*r**2
            +20237253381*r**4+98361813711*r**6+198742978357*r**8+198742978357*r**10
            +98361813711*r**12+20237253381*r**14+2083072003*r**16+4082068*r**18)
            +8*Q2**13*(152451586-387347490*r**2-5688641315*r**4-69609957880*r**6
            -178981430975*r**8-225885258636*r**10-178981430975*r**12-69609957880*r**14
            -5688641315*r**16-387347490*r**18+152451586*r**20)-2*Q2**12*(486898672
            +6903392807*r**2+78152357455*r**4+275823843660*r**6+1060168992980*r**8
            +2432016781338*r**10+2432016781338*r**12+1060168992980*r**14+275823843660*r**16
            +78152357455*r**18+6903392807*r**20+486898672*r**22)+4*Q2**11*(11223836
            +3767043279*r**2+48950346876*r**4+324067477235*r**6+1568399653460*r**8
            +4343975419854*r**10+6117350712136*r**12+4343975419854*r**14+1568399653460*r**16
            +324067477235*r**18+48950346876*r**20+3767043279*r**22+11223836*r**24)
            +4*Q2**10*(117895023-1212368088*r**2-23149335533*r**4-280286719977*r**6
            -1673085460930*r**8-5700752518953*r**10-10470119702182*r**12-10470119702182*r**14
            -5700752518953*r**16-1673085460930*r**18-280286719977*r**20-23149335533*r**22
            -1212368088*r**24+117895023*r**26)-40*Q2**9*(10100492+86998797*r**2-212388391*r**4
            -13289989474*r**6-68398369931*r**8-250982991805*r**10-529146232298*r**12
            -665560919804*r**14-529146232298*r**16-250982991805*r**18-68398369931*r**20
            -13289989474*r**22-212388391*r**24+86998797*r**26+10100492*r**28)+4*Q2**8*(18457412
            +1200848905*r**2+5985920580*r**4+461543715*r**6+427381671395*r**8+2069119913278*r**10
            +7041474656485*r**12+13201897805030*r**14+13201897805030*r**16+7041474656485*r**18
            +2069119913278*r**20+427381671395*r**22+461543715*r**24+5985920580*r**26
            +1200848905*r**28+18457412*r**30)+4*Q2**7*(41270484-648706511*r**2-11907539660*r**4
            -98811825965*r**6-829672473960*r**8-2806874893199*r**10-10643371423284*r**12
            -23264944091765*r**14-30376931429080*r**16-23264944091765*r**18-10643371423284*r**20
            -2806874893199*r**22-829672473960*r**24-98811825965*r**26-11907539660*r**28
            -648706511*r**30+41270484*r**32)+Q2**6*(-142447256+222864466*r**2+41707076734*r**4
            +498993402930*r**6+2807424865830*r**8+5807992975026*r**10+23958325390934*r**12
            +44005067620346*r**14+65288463482990*r**16+65288463482990*r**18+44005067620346*r**20
            +23958325390934*r**22+5807992975026*r**24+2807424865830*r**26+498993402930*r**28
            +41707076734*r**30+222864466*r**32-142447256*r**34)+8*Q2**5*(631114+131126656*r**2
            -385864209*r**4-36108829296*r**6-258277340905*r**8-1074681035264*r**10
            -3301180581651*r**12-2645619826896*r**14-1022325572029*r**16-1367598535040*r**18
            -1022325572029*r**20-2645619826896*r**22-3301180581651*r**24-1074681035264*r**26
            -258277340905*r**28-36108829296*r**30-385864209*r**32+131126656*r**34
            +631114*r**36)+10*Q2**4*(4610456-87488909*r**2-1748269253*r**4+2663422424*r**6
            +102166440600*r**8+1027537108548*r**10+2577274053492*r**12+3539192509528*r**14
            +2402052414368*r**16+3292230958746*r**18+3292230958746*r**20+2402052414368*r**22
            +3539192509528*r**24+2577274053492*r**26+1027537108548*r**28+102166440600*r**30
            +2663422424*r**32-1748269253*r**34-87488909*r**36+4610456*r**38)-24*Q2**3*(717678
            -4562190*r**2-342589915*r**4-3778287310*r**6-13554923770*r**8+73186848408*r**10
            -183382863540*r**12+796931581720*r**14-107020821620*r**16+285109715500*r**18
            +1462766370078*r**20+285109715500*r**22-107020821620*r**24+796931581720*r**26
            -183382863540*r**28+73186848408*r**30-13554923770*r**32-3778287310*r**34
            -342589915*r**36-4562190*r**38+717678*r**40)-9*(-1+r**2)**2*(83432-2181863*r**2
            -49749695*r**4+490958625*r**6+10356725945*r**8+92815698692*r**10+283290701532*r**12
            +6082866460*r**14+1459256639500*r**16+1734590484790*r**18-2672374627418*r**20
            -2672374627418*r**22+1734590484790*r**24+1459256639500*r**26+6082866460*r**28
            +283290701532*r**30+92815698692*r**32+10356725945*r**34+490958625*r**36
            -49749695*r**38-2181863*r**40+83432*r**42)-3*Q2**2*(1599498-72490097*r**2
            -572070285*r**4+26432462315*r**6+278651943215*r**8+1600523185158*r**10
            +6586682748348*r**12-2403102956340*r**14+17212495739560*r**16+13402801718410*r**18
            -6265467479782*r**20-6265467479782*r**22+13402801718410*r**24+17212495739560*r**26
            -2403102956340*r**28+6586682748348*r**30+1600523185158*r**32+278651943215*r**34
            +26432462315*r**36-572070285*r**38-72490097*r**40+1599498*r**42)+72*Q2*(59207
            -1721477*r**2-28687083*r**4+442761700*r**6+6281982425*r**8+46058143887*r**10
            +127038025683*r**12-137422635408*r**14+673256172150*r**16+217497999350*r**18
            -448849252478*r**20-54088095912*r**22-448849252478*r**24+217497999350*r**26
            +673256172150*r**28-137422635408*r**30+127038025683*r**32+46058143887*r**34
            +6281982425*r**36+442761700*r**38-28687083*r**40-1721477*r**42+59207*r**44))*sqrtq2)
            +logq2*(-12288*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(-24832*Q2**21+356320*Q2**20*(1
            +r**2)-64*Q2**19*(32421+73990*r**2+32421*r**4)+16*Q2**18*(395716+1470915*r**2
            +1470915*r**4+395716*r**6)-Q2**17*(10125934+53226657*r**2+65600998*r**4
            +53226657*r**6+10125934*r**8)+Q2**16*(4714014+32343419*r**2-118844981*r**4
            -118844981*r**6+32343419*r**8+4714014*r**10)+2*Q2**15*(5859833+53034624*r**2
            +528468418*r**4+1019081462*r**6+528468418*r**8+53034624*r**10+5859833*r**12)
            -2*Q2**14*(10537409+129359205*r**2+1215256884*r**4+3574182650*r**6+3574182650*r**8
            +1215256884*r**10+129359205*r**12+10537409*r**14)+2*Q2**13*(2921241+99624010*r**2
            +1141091095*r**4+5537123794*r**6+8372713176*r**8+5537123794*r**10+1141091095*r**12
            +99624010*r**14+2921241*r**16)+2*Q2**12*(8775351+25453983*r**2+193286447*r**4
            -2258087741*r**6-3113139160*r**8-3113139160*r**10-2258087741*r**12+193286447*r**14
            +25453983*r**16+8775351*r**18)-2*Q2**11*(8694075+93901816*r**2+1525989016*r**4
            +6165924222*r**6+25445513717*r**8+43362822820*r**10+25445513717*r**12
            +6165924222*r**14+1525989016*r**16+93901816*r**18+8694075*r**20)+2*Q2**10*(
            -1619709+50067083*r**2+1484613966*r**4+11909872296*r**6+57408582657*r**8
            +136344881243*r**10+136344881243*r**12+57408582657*r**14+11909872296*r**16
            +1484613966*r**18+50067083*r**20-1619709*r**22)+2*Q2**9*(6677359+8071125*r**2
            -513613341*r**4-8586952655*r**6-44280096075*r**8-146363942414*r**10-214725585950*r**12
            -146363942414*r**14-44280096075*r**16-8586952655*r**18-513613341*r**20
            +8071125*r**22+6677359*r**24)-2*Q2**8*(2261791+22893930*r**2+288394900*r**4
            -258649848*r**6+10528017772*r**8+4527553435*r**10+805989300*r**12+805989300*r**14
            +4527553435*r**16+10528017772*r**18-258649848*r**20+288394900*r**22+22893930*r**24
            +2261791*r**26)+Q2**7*(-4486602+41863264*r**2+1164906356*r**4+8268475700*r**6
            +76279083712*r**8+217687817296*r**10+526688790262*r**12+771487843064*r**14
            +526688790262*r**16+217687817296*r**18+76279083712*r**20+8268475700*r**22
            +1164906356*r**24+41863264*r**26-4486602*r**28)+Q2**6*(3562586-24817518*r**2
            -806331968*r**4-6608647204*r**6-44551124384*r**8-94165166716*r**10-326306201878*r**12
            -631370383318*r**14-631370383318*r**16-326306201878*r**18-94165166716*r**20
            -44551124384*r**22-6608647204*r**24-806331968*r**26-24817518*r**28+3562586*r**30)
            +2*Q2**5*(123779-3739878*r**2-8149311*r**4+2303722442*r**6+12924058502*r**8
            +24565607030*r**10+83966844799*r**12-14536352986*r**14+30512948846*r**16
            -14536352986*r**18+83966844799*r**20+24565607030*r**22+12924058502*r**24
            +2303722442*r**26-8149311*r**28-3739878*r**30+123779*r**32)-2*Q2**4*(525603
            -9916385*r**2-195930197*r**4+1897643695*r**6+14371550850*r**8+75655307402*r**10
            +183656983385*r**12-29762895283*r**14+80225322930*r**16+80225322930*r**18
            -29762895283*r**20+183656983385*r**22+75655307402*r**24+14371550850*r**26
            +1897643695*r**28-195930197*r**30-9916385*r**32+525603*r**34)+2*Q2**3*(125447
            -3257400*r**2-87207140*r**4+226691630*r**6+2680468771*r**8+44091129116*r**10
            +42915983545*r**12-5733638830*r**14+65183353857*r**16+212170014008*r**18
            +65183353857*r**20-5733638830*r**22+42915983545*r**24+44091129116*r**26
            +2680468771*r**28+226691630*r**30-87207140*r**32-3257400*r**34+125447*r**36)
            +3*(-1+r**2)**2*(3208-176285*r**2-4031035*r**4+115246790*r**6+935366722*r**8
            +5300520306*r**10+19247256110*r**12-72634460090*r**14+240831828010*r**16
            -178550593736*r**18-178550593736*r**20+240831828010*r**22-72634460090*r**24
            +19247256110*r**26+5300520306*r**28+935366722*r**30+115246790*r**32-4031035*r**34
            -176285*r**36+3208*r**38)+2*Q2**2*(58417-1862599*r**2-23832626*r**4
            +1135058532*r**6+8040311321*r**8+20136506487*r**10+144520737805*r**12
            -186119476749*r**14+206130945887*r**16+66366513525*r**18+66366513525*r**20
            +206130945887*r**22-186119476749*r**24+144520737805*r**26+20136506487*r**28
            +8040311321*r**30+1135058532*r**32-23832626*r**34-1862599*r**36+58417*r**38)
            -3*Q2*(22456-975077*r**2-17847952*r**4+559434707*r**6+3712302792*r**8
            +15714328636*r**10+64291697696*r**12-239318035764*r**14+544915456384*r**16
            -149109239286*r**18-359566609184*r**20-149109239286*r**22+544915456384*r**24
            -239318035764*r**26+64291697696*r**28+15714328636*r**30+3712302792*r**32
            +559434707*r**34-17847952*r**36-975077*r**38+22456*r**40))+12288*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(198656*Q2**25-3024384*Q2**24*(1+r**2)
            +96*Q2**23*(197083+447094*r**2+197083*r**4)-32*Q2**22*(1956485+7343347*r**2
            +7343347*r**4+1956485*r**6)+8*Q2**21*(13726074+76940619*r**2+106403618*r**4
            +76940619*r**6+13726074*r**8)-Q2**20*(59117586+590506513*r**2-177892135*r**4
            -177892135*r**6+590506513*r**8+59117586*r**10)-4*Q2**19*(36102576+219023531*r**2
            +2336864520*r**4+4644368410*r**6+2336864520*r**8+219023531*r**10+36102576*r**12)
            +Q2**18*(295017738+3132086964*r**2+27531038168*r**4+82625695050*r**6
            +82625695050*r**8+27531038168*r**10+3132086964*r**12+295017738*r**14)
            -4*Q2**17*(23997540+760142101*r**2+8282106376*r**4+40823327435*r**6+63566832360*r**8
            +40823327435*r**10+8282106376*r**12+760142101*r**14+23997540*r**16)+Q2**16*(
            -296333008-571009883*r**2+1394279179*r**4+119549285357*r**6+253183272547*r**8
            +253183272547*r**10+119549285357*r**12+1394279179*r**14-571009883*r**16
            -296333008*r**18)+4*Q2**15*(82730736+904848843*r**2+11435818860*r**4
            +36385486260*r**6+133500504708*r**8+233471269570*r**10+133500504708*r**12
            +36385486260*r**14+11435818860*r**16+904848843*r**18+82730736*r**20)
            +4*Q2**14*(18187554-607522681*r**2-13325384115*r**4-109027012520*r**6
            -494502239790*r**8-1184920929904*r**10-1184920929904*r**12-494502239790*r**14
            -109027012520*r**16-13325384115*r**18-607522681*r**20+18187554*r**22)
            -4*Q2**13*(80352568+164158609*r**2-3215564922*r**4-97593854875*r**6-568765044360*r**8
            -2003511550518*r**10-2992289894124*r**12-2003511550518*r**14-568765044360*r**16
            -97593854875*r**18-3215564922*r**20+164158609*r**22+80352568*r**24)+2*Q2**12*(53254050
            +927103593*r**2+13205348893*r**4+2483526345*r**6-104578205775*r**8-2033984250340*r**10
            -4710737460318*r**12-4710737460318*r**14-2033984250340*r**16-104578205775*r**18
            +2483526345*r**20+13205348893*r**22+927103593*r**24+53254050*r**26)+4*Q2**11*(39898368
            -293748647*r**2-7538029144*r**4-74913287302*r**6-510310423112*r**8-1419719692313*r**10
            -3445114768608*r**12-5195656110196*r**14-3445114768608*r**16-1419719692313*r**18
            -510310423112*r**20-74913287302*r**22-7538029144*r**24-293748647*r**26
            +39898368*r**28)+4*Q2**10*(-30479469+26132453*r**2+2339985105*r**4+55705749655*r**6
            +489571933773*r**8+2757825995331*r**10+10110687904647*r**12+21034150619145*r**14
            +21034150619145*r**16+10110687904647*r**18+2757825995331*r**20+489571933773*r**22
            +55705749655*r**24+2339985105*r**26+26132453*r**28-30479469*r**30)-4*Q2**9*(8735496
            -178406589*r**2-2486832790*r**4+10378509105*r**6+180663380460*r**8+2077847030059*r**10
            +9547541863254*r**12+26065086906465*r**14+37177949191320*r**16+26065086906465*r**18
            +9547541863254*r**20+2077847030059*r**22+180663380460*r**24+10378509105*r**26
            -2486832790*r**28-178406589*r**30+8735496*r**32)+2*Q2**8*(31055604-358204933*r**2
            -6300371251*r**4-3084536825*r**6+70759032285*r**8+1258569805431*r**10
            +1928253712613*r**12+7294249344391*r**14+17930359564285*r**16+17930359564285*r**18
            +7294249344391*r**20+1928253712613*r**22+1258569805431*r**24+70759032285*r**26
            -3084536825*r**28-6300371251*r**30-358204933*r**32+31055604*r**34)+4*Q2**7*(
            -1215160+2181689*r**2+723916964*r**4+8226565480*r**6+59674791380*r**8
            +471612754860*r**10+5694898543516*r**12+17566829688216*r**14+39686861794980*r**16
            +53653149047350*r**18+39686861794980*r**20+17566829688216*r**22+5694898543516*r**24
            +471612754860*r**26+59674791380*r**28+8226565480*r**30+723916964*r**32
            +2181689*r**34-1215160*r**36)-12*Q2**6*(1497274-31797991*r**2-333529997*r**4
            +6576394424*r**6+48097948574*r**8+277002481246*r**10+1451824634586*r**12
            +2454436118322*r**14+10207528281406*r**16+17827838996156*r**18+17827838996156*r**20
            +10207528281406*r**22+2454436118322*r**24+1451824634586*r**26+277002481246*r**28
            +48097948574*r**30+6576394424*r**32-333529997*r**34-31797991*r**36+1497274*r**38)
            +4*Q2**5*(1380996-39029297*r**2-686357550*r**4+10207405775*r**6+84465821868*r**8
            +749300250404*r**10+2131045899112*r**12-275099876700*r**14+13402966632400*r**16
            +619029049242*r**18-745546512500*r**20+619029049242*r**22+13402966632400*r**24
            -275099876700*r**26+2131045899112*r**28+749300250404*r**30+84465821868*r**32
            +10207405775*r**34-686357550*r**36-39029297*r**38+1380996*r**40)+Q2**4*(2670206
            -77745249*r**2-164409745*r**4+27692697015*r**6+32474473455*r**8-2106701180774*r**10
            -10545942707364*r**12-50396801891380*r**14-115563828608640*r**16+4723981406170*r**18
            -26447424463694*r**20-26447424463694*r**22+4723981406170*r**24-115563828608640*r**26
            -50396801891380*r**28-10545942707364*r**30-2106701180774*r**32+32474473455*r**34
            +27692697015*r**36-164409745*r**38-77745249*r**40+2670206*r**42)-24*Q2**3*(62808
            -2581461*r**2-26323372*r**4+1181037850*r**6+3263048940*r**8-13989473777*r**10
            -204379365136*r**12-1821943224392*r**14-624041317960*r**16-371391222330*r**18
            -2532876995392*r**20-6612064731556*r**22-2532876995392*r**24-371391222330*r**26
            -624041317960*r**28-1821943224392*r**30-204379365136*r**32-13989473777*r**34
            +3263048940*r**36+1181037850*r**38-26323372*r**40-2581461*r**42+62808*r**44)
            -9*(-1+r**2)**2*(3208-221197*r**2-1864597*r**4+188207158*r**6-296699850*r**8
            -18571553857*r**10-144501986137*r**12-853324841712*r**14-624799722632*r**16
            +3013281997350*r**18-19280904417002*r**20+16080015899268*r**22+16080015899268*r**24
            -19280904417002*r**26+3013281997350*r**28-624799722632*r**30-853324841712*r**32
            -144501986137*r**34-18571553857*r**36-296699850*r**38+188207158*r**40
            -1864597*r**42-221197*r**44+3208*r**46)-6*Q2**2*(13505-204636*r**2+20475714*r**4
            +59216225*r**6-4531867995*r**8-163990351830*r**10-718275000796*r**12
            -2172589135371*r**14-16333977773270*r**16+21182912086120*r**18-13679155828380*r**20
            -17503751629286*r**22-17503751629286*r**24-13679155828380*r**26+21182912086120*r**28
            -16333977773270*r**30-2172589135371*r**32-718275000796*r**34-163990351830*r**36
            -4531867995*r**38+59216225*r**40+20475714*r**42-204636*r**44+13505*r**46)
            +72*Q2*(2406-133934*r**2-575863*r**4+91884446*r**6-226878874*r**8-10384189194*r**10
            -59439422619*r**12-302305139398*r**14-478993566254*r**16+2231447812116*r**18
            -6249425961454*r**20+845012220236*r**22+6219532696772*r**24+845012220236*r**26
            -6249425961454*r**28+2231447812116*r**30-478993566254*r**32-302305139398*r**34
            -59439422619*r**36-10384189194*r**38-226878874*r**40+91884446*r**42-575863*r**44
            -133934*r**46+2406*r**48))*sqrtq2))*math.log(mu0))/(126000*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2+126000*(
            -Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2
            +logq2**7*(-1015831756800000*r**32*(1+r**2)**2*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3-1015831756800000*r**32*(1+r**2)**2*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**6*(5643509760000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))+5643509760000*r**28*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))*sqrtq2)+logq2*(-7560000*(-Q2+(
            -1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(9+8*Q2**4-78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)
            -Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-7560000*(-Q2+(-1+r)**2)**3*r**8*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(9+8*Q2**4-78*r**2-366*r**4
            -78*r**6+9*r**8-Q2**3*(1+r**2)-Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1
            +13*r**2+13*r**4+r**6))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*sqrtq2)+logq2**2*(90720000*(-Q2+(-1+r)**2)**3*r**12*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531
            +550*r**2+531*r**4)-2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815
            -2120*r**2-11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4
            +494*r**6+225*r**8+r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6
            +26793*r**8+4554*r**10-501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6
            -1385*r**8-311*r**10+15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6
            +34670*r**8+13388*r**10-184*r**12-316*r**14+17*r**16))+90720000*(-Q2
            +(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531+550*r**2+531*r**4)
            -2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815-2120*r**2-11502*r**4
            -2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4+494*r**6+225*r**8
            +r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6+26793*r**8+4554*r**10
            -501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6-1385*r**8-311*r**10
            +15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6+34670*r**8+13388*r**10
            -184*r**12-316*r**14+17*r**16))*sqrtq2)+logq2**3*(-1088640000*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8+256*Q2**7*(1+r**2)
            -Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2+893*r**4+319*r**6)
            +Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)+12*Q2**3*(61
            +235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(-1071+9654*r**2
            +51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)-18*Q2*(23
            -35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12+23*r**14)
            +9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10-264*r**12
            -756*r**14+47*r**16))-1088640000*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8
            +256*Q2**7*(1+r**2)-Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2
            +893*r**4+319*r**6)+Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)
            +12*Q2**3*(61+235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(
            -1071+9654*r**2+51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)
            -18*Q2*(23-35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12
            +23*r**14)+9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10
            -264*r**12-756*r**14+47*r**16))*sqrtq2)+logq2**4*(13063680000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513+770*r**2
            +513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105-3400*r**2
            -11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4-1178*r**6
            +75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6+19593*r**8
            +3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6-5785*r**8
            -2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4+25204*r**6
            +52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))+13063680000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513
            +770*r**2+513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105
            -3400*r**2-11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4
            -1178*r**6+75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6
            +19593*r**8+3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6
            -5785*r**8-2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4
            +25204*r**6+52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))*sqrtq2)
            +logq2**5*(-31352832000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(64*Q2**8+1088*Q2**7*(1+r**2)+Q2**6*(-63+130*r**2-63*r**4)
            -2*Q2**5*(2777+6379*r**2+6379*r**4+2777*r**6)+Q2**4*(1555-8080*r**2
            -22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743-315*r**2-6548*r**4-6548*r**6
            -315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2+199629*r**4+305844*r**6
            +199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83-375*r**2-2833*r**4
            -5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)+9*(301-4028*r**2
            +808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12-4028*r**14+301*r**16))
            -31352832000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(64*Q2**8+1088*Q2**7*(1
            +r**2)+Q2**6*(-63+130*r**2-63*r**4)-2*Q2**5*(2777+6379*r**2+6379*r**4
            +2777*r**6)+Q2**4*(1555-8080*r**2-22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743
            -315*r**2-6548*r**4-6548*r**6-315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2
            +199629*r**4+305844*r**6+199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83
            -375*r**2-2833*r**4-5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)
            +9*(301-4028*r**2+808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12
            -4028*r**14+301*r**16))*sqrtq2))+((16*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(-57
            -24*Q2**14+3714*r**2+43777*r**4-3791308*r**6-10159121*r**8+15296334*r**10
            -236289183*r**12+694656216*r**14-815729139*r**16+457228062*r**18-127046277*r**20
            +25369844*r**22+93757*r**24+322322*r**26+1059*r**28-56*Q2**13*(1+r**2)
            +Q2**12*(1457-3446*r**2-1627*r**4)+4*Q2**11*(-1615+8387*r**2+54679*r**4
            +3797*r**6)-4*Q2**10*(-3472+30654*r**2+403567*r**4+338572*r**6+11639*r**8)
            +4*Q2**9*(-4008+54495*r**2+1044380*r**4+2055110*r**6+727340*r**8+15387*r**10)
            -Q2**8*(-8157+170178*r**2+3813345*r**4+13564420*r**6+12323485*r**8+1013978*r**10
            +15423*r**12)-8*Q2**7*(-207+2181*r**2+203412*r**4-98905*r**6+1778395*r**8
            +542973*r**10+651616*r**12+6327*r**14)+8*Q2**6*(-420+13398*r**2+622461*r**4
            +1572643*r**6+10153075*r**8+11587780*r**10+3383193*r**12+891191*r**14
            +5943*r**16)+8*Q2**5*(-57-1356*r**2-185973*r**4-797988*r**6-6859881*r**8
            -23311392*r**10-9155691*r**12-2312708*r**14-8398*r**16+1284*r**18)-Q2**4*(
            -1931+71530*r**2+2109045*r**4-6455760*r**6+15777210*r**8-44549788*r**10
            -138504270*r**12+88484320*r**14+7369665*r**16+5785410*r**18+34249*r**20)
            +4*Q2**3*(-119+8471*r**2+323305*r**4-3050295*r**6-3025010*r**8-6052382*r**10
            +19084558*r**12-13941570*r**14+34632105*r**16+3167815*r**18+818121*r**20
            +3001*r**22)+4*Q2**2*(-122+4186*r**2+58337*r**4+87590*r**6+5884315*r**8
            +13803764*r**10+13722438*r**12-4033124*r**14-12132160*r**16-2175310*r**18
            -930087*r**20+223806*r**22+1567*r**24)-4*Q2*(-80+4233*r**2+73226*r**4
            -2220242*r**6-2960350*r**8-2058365*r**10-5455156*r**12-38454012*r**14
            +85305484*r**16-50223425*r**18+15606570*r**20+53198*r**22+327586*r**24
            +1333*r**26))+16*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(192*Q2**19
            +88*Q2**18*(1+r**2)+16*Q2**17*(-781+1642*r**2+761*r**4)-Q2**16*(-73775
            +297995*r**2+1825599*r**4+145669*r**6)+4*Q2**15*(-51861+340660*r**2
            +4186230*r**4+3591900*r**6+150207*r**8)-2*Q2**14*(-160967+1597940*r**2
            +30027301*r**4+56976461*r**6+22270690*r**8+587263*r**10)+4*Q2**13*(-60326
            +917894*r**2+24316527*r**4+81644768*r**6+73261216*r**8+12910234*r**10
            +223639*r**12)+Q2**12*(-25402-563876*r**2-38459200*r**4-358564138*r**6
            -438041866*r**8-228371272*r**10+37752324*r**12+634262*r**14)-4*Q2**11*(
            -48165+833580*r**2+23734310*r**4+18524260*r**6+191728516*r**8+235832836*r**10
            +95582026*r**12+40901932*r**14+427377*r**16)+2*Q2**10*(-43329+1222980*r**2
            +58336869*r**4+277843715*r**6+1545154811*r**8+3240493627*r**10+1729299335*r**12
            +475011561*r**14+58601370*r**16+322773*r**18)+4*Q2**9*(-21736+513590*r**2
            +4363551*r**4-147373004*r**6-899717980*r**8-3213841264*r**10-3392656990*r**12
            -715979284*r**14-140458404*r**16+25380890*r**18+279719*r**20)-2*Q2**8*(
            -45422+1641233*r**2+48534133*r**4-170257418*r**6-588840656*r**8-4624178418*r**10
            -7526070378*r**12-4253144032*r**14+1312661502*r**16+216617569*r**18+93325493*r**20
            +565738*r**22)+4*Q2**7*(1573+68684*r**2+7392018*r**4+10756724*r**6+339887083*r**8
            +998967992*r**10+4261569596*r**12+4797578744*r**14+3260448139*r**16+1591348508*r**18
            +211851218*r**20+7629684*r**22-31163*r**24)+2*Q2**6*(-19635+801700*r**2
            +18156501*r**4-209461039*r**6-777053636*r**8-5007634041*r**10-23534560726*r**12
            -47692110982*r**14-28406379147*r**16-14011017886*r**18-1356019711*r**20
            -196567371*r**22+50182914*r**24+310899*r**26)-4*Q2**5*(-2162+153710*r**2
            +5399059*r**4-79097960*r**6-98177028*r**8-1165588042*r**10-5991109955*r**12
            -22670582320*r**14-29948143010*r**16-3934803926*r**18-3395263571*r**20
            +710056600*r**22+51425816*r**24+13953970*r**26+44419*r**28)-2*Q2**4*(
            -4909+213490*r**2+2377176*r**4-49489669*r**6+14947725*r**8+1709875624*r**10
            +1532121230*r**12+5085336893*r**14+21487760013*r**16+14689327610*r**18
            -27876860036*r**20-6085393995*r**22-1579897069*r**24-173066644*r**26
            +9858590*r**28+74771*r**30)+4*Q2**3*(-1157+73388*r**2+1303102*r**4-47410252*r**6
            +61818306*r**8+1239105212*r**10+3689404902*r**12+6233169716*r**14-1101385656*r**16
            -2238290812*r**18-13322010758*r**20-9973666948*r**22-3947265218*r**24
            -103450092*r**26-30318494*r**28+5590428*r**30+22333*r**32)+2*Q2**2*(
            -447+17184*r**2-132149*r**4+9379321*r**6+7830667*r**8+285387037*r**10
            -2214797369*r**12-19284105635*r**14-4305412287*r**16+5509203441*r**18
            -32929105263*r**20+37591020251*r**22-6331072423*r**24+1139137991*r**26
            -350402083*r**28-28432177*r**30-408166*r**32+4107*r**34)-12*Q2*(-80
            +5330*r**2+24149*r**4-3731276*r**6+20537872*r**8+346607692*r**10+751218972*r**12
            +574534900*r**14+4976184960*r**16-7844999744*r**18+9208651006*r**20-10784577284*r**22
            +4395066128*r**24-1287006892*r**26-321630628*r**28-26504868*r**30-4690768*r**32
            +309198*r**34+1333*r**36)+3*(-57+4455*r**2+1651*r**4-4755365*r**6
            +33999596*r**8+552049916*r**10+1070939420*r**12+3260927372*r**14+14149245010*r**16
            -38650944158*r**18+10091920314*r**20+31128267770*r**22-24690211972*r**24
            +4220464300*r**26-645428372*r**28-501804548*r**30-10774145*r**32-4210801*r**34
            +308555*r**36+1059*r**38))*sqrtq2+logq2**5*(-52254720000*(-Q2+(-1+r)**2)*(
            -1+r)*r**22*(1+r)*(1+r**2)*(3+r**2)*(1-Q2+r**2)*(-Q2+(1+r)**2)
            -52254720000*r**22*(-3-r**2+3*r**4+r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2**4*(-41472000*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-480*Q2**6*(1+r**2)+240*Q2**5*(5+17*r**2+12*r**4)-8*Q2**4*(
            -171+503*r**2+1483*r**4+837*r**6)+Q2**3*(-4197-7411*r**2+4737*r**4
            +14275*r**6+6324*r**8)+Q2**2*(-1257+7268*r**2+10278*r**4-3876*r**6
            -5213*r**8+864*r**10)+Q2*(8403+813*r**2-8928*r**4+1020*r**6+5961*r**8
            -1833*r**10-5436*r**12)+3*(-1679-852*r**2-3925*r**4+1808*r**6+4783*r**8
            -908*r**10-75*r**12+848*r**14))-41472000*r**18*(480*Q2**9*(1+r**2)-240*Q2**8*(11
            +29*r**2+18*r**4)+8*Q2**7*(459+2783*r**2+4393*r**4+2097*r**6)-7*Q2**6*(
            -603+2171*r**2+10263*r**4+12565*r**6+5076*r**8)+2*Q2**5*(-7119-14938*r**2
            +9418*r**4+55520*r**6+58597*r**8+20538*r**10)-5*Q2**4*(-357-8491*r**2
            -13112*r**4+264*r**6+16085*r**8+14371*r**10+3528*r**12)+3*(-1+r**2)**3*(1679
            +4210*r**2+8987*r**4+11104*r**6+4513*r**8+638*r**10+1621*r**12+848*r**14)
            -4*Q2**3*(-7455-1925*r**2+9456*r**4+11782*r**6+5237*r**8-4677*r**10
            -70*r**12+3780*r**14)+Q2**2*(-41577-33499*r**2-38777*r**4-29375*r**6
            +61833*r**8+45623*r**10-6283*r**12+17251*r**14+24804*r**16)-6*Q2*(
            -3919-1692*r**2-6234*r**4-5414*r**6+648*r**8+9090*r**10+7578*r**12
            -2370*r**14+135*r**16+2178*r**18))*sqrtq2)+logq2**3*(-1382400*r**14*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(640*Q2**10-80*Q2**9*(81
            +109*r**2)+4*Q2**8*(6629+17565*r**2+10744*r**4)-4*Q2**7*(13937+55577*r**2
            +67087*r**4+24047*r**6)+Q2**6*(60123+300955*r**2+587331*r**4+441405*r**6
            +78778*r**8)+2*Q2**5*(-16898-61691*r**2-162424*r**4-207494*r**6-100006*r**8
            +29057*r**10)+Q2**4*(16975+47435*r**2+31266*r**4-542330*r**6-664749*r**8
            -296465*r**10-153860*r**12)+8*Q2**3*(-612-26545*r**2-80570*r**4-24933*r**6
            +148772*r**8+150185*r**10+50490*r**12+9293*r**14)+Q2**2*(-18307+97573*r**2
            +284079*r**4+1148689*r**6+348657*r**8-593941*r**10-206511*r**12-131617*r**14
            +39058*r**16)-6*Q2*(-3612-26855*r**2-171020*r**4+66960*r**6+131432*r**8
            -110278*r**10-16620*r**12+116040*r**14+6060*r**16+7893*r**18)+3*(-2233
            -36861*r**2-247472*r**4+80392*r**6-1734*r**8+157026*r**10-12024*r**12
            -73288*r**14+124223*r**16+7899*r**18+4072*r**20))-1382400*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(640*Q2**10-80*Q2**9*(81+109*r**2)+4*Q2**8*(6629
            +17565*r**2+10744*r**4)-4*Q2**7*(13937+55577*r**2+67087*r**4+24047*r**6)
            +Q2**6*(60123+300955*r**2+587331*r**4+441405*r**6+78778*r**8)+2*Q2**5*(
            -16898-61691*r**2-162424*r**4-207494*r**6-100006*r**8+29057*r**10)
            +Q2**4*(16975+47435*r**2+31266*r**4-542330*r**6-664749*r**8-296465*r**10
            -153860*r**12)+8*Q2**3*(-612-26545*r**2-80570*r**4-24933*r**6+148772*r**8
            +150185*r**10+50490*r**12+9293*r**14)+Q2**2*(-18307+97573*r**2+284079*r**4
            +1148689*r**6+348657*r**8-593941*r**10-206511*r**12-131617*r**14+39058*r**16)
            -6*Q2*(-3612-26855*r**2-171020*r**4+66960*r**6+131432*r**8-110278*r**10
            -16620*r**12+116040*r**14+6060*r**16+7893*r**18)+3*(-2233-36861*r**2
            -247472*r**4+80392*r**6-1734*r**8+157026*r**10-12024*r**12-73288*r**14
            +124223*r**16+7899*r**18+4072*r**20))*sqrtq2)+logq2**2*(23040*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-11520*Q2**13+16*Q2**12*(5467+6129*r**2)
            -4*Q2**11*(68411+162683*r**2+81472*r**4)+4*Q2**10*(107538+445435*r**2
            +488576*r**4+115431*r**6)-5*Q2**9*(63513+485409*r**2+836313*r**4+525503*r**6
            +2286*r**8)-5*Q2**8*(-4311-255372*r**2-156518*r**4+31124*r**6-37219*r**8
            +156696*r**10)+2*Q2**7*(81363+461006*r**2+6476095*r**4+14718735*r**6
            +9881570*r**8+2230843*r**10+395556*r**12)+2*Q2**6*(-94431-969843*r**2
            -10679877*r**4-36028570*r**6-43245765*r**8-16754391*r**10-2859143*r**12
            +57588*r**14)+2*Q2**5*(47838+668895*r**2+5004941*r**4+24313856*r**6
            +53179760*r**8+38935933*r**10+2545855*r**12+477316*r**14-311994*r**16)
            +10*Q2**4*(7224-70913*r**2-290236*r**4-202923*r**6-798008*r**8-100423*r**10
            +2309292*r**12+3683419*r**14+392144*r**16+26328*r**18)+10*Q2**3*(-11161
            +33744*r**2+830991*r**4+3372825*r**6+3077805*r**8-4134399*r**10-9993411*r**12
            -7592889*r**14-3011748*r**16-312497*r**18+11460*r**20)-2*Q2**2*(-4051
            -179437*r**2+431045*r**4+16351470*r**6+33703410*r**8+33675702*r**10
            -9064446*r**12-13787040*r**14-19815615*r**16+2099095*r**18+83929*r**20
            +51538*r**22)+3*Q2*(13227-202019*r**2-2912411*r**4-6759935*r**6-28658760*r**8
            +21190806*r**10+3415638*r**12-11047218*r**14+22869135*r**16-2508915*r**18
            +4245317*r**20+351281*r**22+3854*r**24)+3*(-4801+73290*r**2+1453338*r**4
            +5865698*r**6+26364045*r**8-33625068*r**10-10397140*r**12+19279324*r**14
            +7418889*r**16-15437670*r**18+375994*r**20-1257150*r**22-110037*r**24
            +1288*r**26))+23040*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(11520*Q2**14
            -16*Q2**13*(6187+6849*r**2)+4*Q2**12*(90279+209067*r**2+105988*r**4)
            -4*Q2**11*(175949+676529*r**2+732731*r**4+196903*r**6)+Q2**10*(747717
            +4638937*r**2+7917609*r**4+5043543*r**6+473154*r**8)+10*Q2**9*(-33912
            -402147*r**2-739120*r**4-665346*r**6-282504*r**8+77205*r**10)-Q2**8*(141171
            -376403*r**2+10892740*r**4+28810500*r**6+19732665*r**8+5059071*r**10
            +1574592*r**12)+4*Q2**7*(87897+756106*r**2+8808489*r**4+28611700*r**6
            +33923035*r**8+14433402*r**10+2742771*r**12+168984*r**14)+2*Q2**6*(-142269
            -1733169*r**2-16654661*r**4-71022303*r**6-132454095*r**8-98936089*r**10
            -22159389*r**12-3278871*r**14+369582*r**16)-4*Q2**5*(-5859-535649*r**2
            -3562508*r**4-15166706*r**6-40741828*r**8-46308904*r**10-14967664*r**12
            +7696962*r**14+897699*r**16+221817*r**18)+10*Q2**4*(18385-97433*r**2
            -1192140*r**4-3865984*r**6-4078736*r**8+3235968*r**10+12202280*r**12
            +13585600*r**14+7087311*r**16+730969*r**18+14868*r**20)+4*Q2**3*(-29928
            -33261*r**2+2377360*r**4+18685275*r**6+32978280*r**8+14196366*r**10
            -39851748*r**12-50859270*r**14-36419400*r**16-7261065*r**18-710628*r**20
            +54419*r**22)-Q2**2*(31579-973033*r**2-8234017*r**4+13285225*r**6+14133480*r**8
            +198330642*r**10+59469426*r**12-78844626*r**14+1402095*r**16-42959785*r**18
            +17101999*r**20+1324777*r**22+114638*r**24)+6*Q2*(9014-131041*r**2
            -2283884*r**4-7769022*r**6-30891370*r**8+13078557*r**10+17501792*r**12
            -13455452*r**14+2201514*r**16+17898945*r**18+680204*r**20+2926874*r**22
            +232586*r**24+1283*r**26)+3*(-4801+68489*r**2+1526628*r**4+7319036*r**6
            +32229743*r**8-7261023*r**10-44022208*r**12+8882184*r**14+26698213*r**16
            -8018781*r**18-15061676*r**20-881156*r**22-1367187*r**24-108749*r**26
            +1288*r**28))*sqrtq2)+logq2*(192*r**6*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-24832*Q2**16+32*Q2**15*(8831+7391*r**2)-8*Q2**14*(147195
            +310747*r**2+105120*r**4)+8*Q2**13*(279085+1071463*r**2+949863*r**4
            +149925*r**6)+Q2**12*(-1391025-11171351*r**2-11059123*r**4-7147001*r**6
            +269140*r**8)-4*Q2**11*(414176+330159*r**2+10560284*r**4+12969654*r**6
            +2738804*r**8+730411*r**10)+2*Q2**10*(1413177+8996279*r**2+77432240*r**4
            +176075950*r**6+92391625*r**8+15299499*r**10+1319262*r**12)+4*Q2**9*(33930
            -4236587*r**2-47505400*r**4-190977325*r**6-205409750*r**8-43791325*r**10
            -4054812*r**12+365205*r**14)+Q2**8*(-2632035+5002867*r**2+85605557*r**4
            +659131035*r**6+1143100575*r**8+638600425*r**10-124396393*r**12-20966583*r**14
            -3625800*r**16)+8*Q2**7*(139700+319169*r**2+4626662*r**4+18149174*r**6
            +127385300*r**8+158298110*r**10+87545574*r**12+46580062*r**14+3632844*r**16
            +113165*r**18)+4*Q2**6*(264701-1959057*r**2-23969242*r**4-170495852*r**6
            -1024048542*r**8-2141159326*r**10-1374332532*r**12-467276692*r**14-48003727*r**16
            -828817*r**18+461246*r**20)-8*Q2**5*(102873-886356*r**2-9947845*r**4
            -39908980*r**6-335013240*r**8-1271910682*r**10-1593563812*r**12-437240570*r**14
            -133478905*r**16+18659510*r**18+1671809*r**20+146598*r**22)-Q2**4*(178535
            -1807199*r**2+4007465*r**4+95382675*r**6+114198850*r**8+434581850*r**10
            +5891720898*r**12+2616114550*r**14-4645644325*r**16-790689275*r**18-202457835*r**20
            -7395849*r**22+340860*r**24)+4*Q2**3*(69120-1294299*r**2-9485184*r**4
            +91618610*r**6+368745300*r**8+471635775*r**10-425924192*r**12-911801092*r**14
            -1620955560*r**16-1492129325*r**18-296233120*r**20-10748334*r**22+229076*r**24
            +113225*r**26)-2*Q2**2*(5975-383687*r**2-7406276*r**4+54726358*r**6
            +412512145*r**8+2909071835*r**10+3068697954*r**12+375339252*r**14-442052871*r**16
            -2804453825*r**18-5148760*r**20-99536842*r**22+21319199*r**24+944813*r**26
            +12730*r**28)-12*Q2*(3814-119447*r**2-461392*r**4+24862223*r**6+112256118*r**8
            +66295181*r**10+569882944*r**12-240045341*r**14+20753954*r**16-712704661*r**18
            +365365296*r**20-178749747*r**22-25078142*r**24-2222177*r**26-44832*r**28
            +6209*r**30)+3*(3721-172681*r**2-1008755*r**4+54892795*r**6+237587485*r**8
            +542905027*r**10+2875929953*r**12-7282941065*r**14+2909531835*r**16+3719437205*r**18
            -3432125417*r**20+628651937*r**22-210248305*r**24-40930255*r**26-1506565*r**28
            -13331*r**30+6416*r**32))-192*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(24832*Q2**16
            -32*Q2**15*(8831+7391*r**2)+8*Q2**14*(147195+310747*r**2+105120*r**4)
            -8*Q2**13*(279085+1071463*r**2+949863*r**4+149925*r**6)+Q2**12*(1391025
            +11171351*r**2+11059123*r**4+7147001*r**6-269140*r**8)+4*Q2**11*(414176
            +330159*r**2+10560284*r**4+12969654*r**6+2738804*r**8+730411*r**10)
            -2*Q2**10*(1413177+8996279*r**2+77432240*r**4+176075950*r**6+92391625*r**8
            +15299499*r**10+1319262*r**12)-4*Q2**9*(33930-4236587*r**2-47505400*r**4
            -190977325*r**6-205409750*r**8-43791325*r**10-4054812*r**12+365205*r**14)
            +Q2**8*(2632035-5002867*r**2-85605557*r**4-659131035*r**6-1143100575*r**8
            -638600425*r**10+124396393*r**12+20966583*r**14+3625800*r**16)-8*Q2**7*(139700
            +319169*r**2+4626662*r**4+18149174*r**6+127385300*r**8+158298110*r**10
            +87545574*r**12+46580062*r**14+3632844*r**16+113165*r**18)+4*Q2**6*(
            -264701+1959057*r**2+23969242*r**4+170495852*r**6+1024048542*r**8+2141159326*r**10
            +1374332532*r**12+467276692*r**14+48003727*r**16+828817*r**18-461246*r**20)
            +8*Q2**5*(102873-886356*r**2-9947845*r**4-39908980*r**6-335013240*r**8
            -1271910682*r**10-1593563812*r**12-437240570*r**14-133478905*r**16+18659510*r**18
            +1671809*r**20+146598*r**22)+Q2**4*(178535-1807199*r**2+4007465*r**4
            +95382675*r**6+114198850*r**8+434581850*r**10+5891720898*r**12+2616114550*r**14
            -4645644325*r**16-790689275*r**18-202457835*r**20-7395849*r**22+340860*r**24)
            -4*Q2**3*(69120-1294299*r**2-9485184*r**4+91618610*r**6+368745300*r**8
            +471635775*r**10-425924192*r**12-911801092*r**14-1620955560*r**16-1492129325*r**18
            -296233120*r**20-10748334*r**22+229076*r**24+113225*r**26)+2*Q2**2*(5975
            -383687*r**2-7406276*r**4+54726358*r**6+412512145*r**8+2909071835*r**10
            +3068697954*r**12+375339252*r**14-442052871*r**16-2804453825*r**18-5148760*r**20
            -99536842*r**22+21319199*r**24+944813*r**26+12730*r**28)+12*Q2*(3814
            -119447*r**2-461392*r**4+24862223*r**6+112256118*r**8+66295181*r**10
            +569882944*r**12-240045341*r**14+20753954*r**16-712704661*r**18+365365296*r**20
            -178749747*r**22-25078142*r**24-2222177*r**26-44832*r**28+6209*r**30)
            -3*(3721-172681*r**2-1008755*r**4+54892795*r**6+237587485*r**8+542905027*r**10
            +2875929953*r**12-7282941065*r**14+2909531835*r**16+3719437205*r**18
            -3432125417*r**20+628651937*r**22-210248305*r**24-40930255*r**26-1506565*r**28
            -13331*r**30+6416*r**32))*sqrtq2))*math.log(mus))/(-3780*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))-3780*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2+logq2**5*(-14108774400*r**22*(1+r**2)*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            +14108774400*r**22*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**2*(-3265920*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8+3*Q2**3*(1
            +r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4+7*r**6))
            -3265920*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8
            +3*Q2**3*(1+r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4
            +7*r**6))*sqrtq2)+logq2**3*(13063680*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))+13063680*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))*sqrtq2)+logq2**4*(-78382080*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(63+8*Q2**4-402*r**2
            -1122*r**4-402*r**6+63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)
            -3*Q2*(19+31*r**2+31*r**4+19*r**6))-78382080*(-Q2+(-1+r)**2)*r**18*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(63+8*Q2**4-402*r**2-1122*r**4-402*r**6
            +63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)-3*Q2*(19+31*r**2
            +31*r**4+19*r**6))*sqrtq2)+logq2*(45360*(-Q2+(-1+r)**2)*r**6*(1-Q2
            +r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1
            +r**2)-Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)
            +3*(9-86*r**2-446*r**4-86*r**6+9*r**8))+45360*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1+r**2)
            -Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)+3*(9
            -86*r**2-446*r**4-86*r**6+9*r**8))*sqrtq2))+((-16*r**2*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(
            -57-24*Q2**14+3714*r**2+43777*r**4-3791308*r**6-10159121*r**8+15296334*r**10
            -236289183*r**12+694656216*r**14-815729139*r**16+457228062*r**18-127046277*r**20
            +25369844*r**22+93757*r**24+322322*r**26+1059*r**28-56*Q2**13*(1+r**2)
            +Q2**12*(1457-3446*r**2-1627*r**4)+4*Q2**11*(-1615+8387*r**2+54679*r**4
            +3797*r**6)-4*Q2**10*(-3472+30654*r**2+403567*r**4+338572*r**6+11639*r**8)
            +4*Q2**9*(-4008+54495*r**2+1044380*r**4+2055110*r**6+727340*r**8+15387*r**10)
            -Q2**8*(-8157+170178*r**2+3813345*r**4+13564420*r**6+12323485*r**8+1013978*r**10
            +15423*r**12)-8*Q2**7*(-207+2181*r**2+203412*r**4-98905*r**6+1778395*r**8
            +542973*r**10+651616*r**12+6327*r**14)+8*Q2**6*(-420+13398*r**2+622461*r**4
            +1572643*r**6+10153075*r**8+11587780*r**10+3383193*r**12+891191*r**14
            +5943*r**16)+8*Q2**5*(-57-1356*r**2-185973*r**4-797988*r**6-6859881*r**8
            -23311392*r**10-9155691*r**12-2312708*r**14-8398*r**16+1284*r**18)-Q2**4*(
            -1931+71530*r**2+2109045*r**4-6455760*r**6+15777210*r**8-44549788*r**10
            -138504270*r**12+88484320*r**14+7369665*r**16+5785410*r**18+34249*r**20)
            +4*Q2**3*(-119+8471*r**2+323305*r**4-3050295*r**6-3025010*r**8-6052382*r**10
            +19084558*r**12-13941570*r**14+34632105*r**16+3167815*r**18+818121*r**20
            +3001*r**22)+4*Q2**2*(-122+4186*r**2+58337*r**4+87590*r**6+5884315*r**8
            +13803764*r**10+13722438*r**12-4033124*r**14-12132160*r**16-2175310*r**18
            -930087*r**20+223806*r**22+1567*r**24)-4*Q2*(-80+4233*r**2+73226*r**4
            -2220242*r**6-2960350*r**8-2058365*r**10-5455156*r**12-38454012*r**14
            +85305484*r**16-50223425*r**18+15606570*r**20+53198*r**22+327586*r**24
            +1333*r**26))-16*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(192*Q2**19
            +88*Q2**18*(1+r**2)+16*Q2**17*(-781+1642*r**2+761*r**4)-Q2**16*(-73775
            +297995*r**2+1825599*r**4+145669*r**6)+4*Q2**15*(-51861+340660*r**2
            +4186230*r**4+3591900*r**6+150207*r**8)-2*Q2**14*(-160967+1597940*r**2
            +30027301*r**4+56976461*r**6+22270690*r**8+587263*r**10)+4*Q2**13*(-60326
            +917894*r**2+24316527*r**4+81644768*r**6+73261216*r**8+12910234*r**10
            +223639*r**12)+Q2**12*(-25402-563876*r**2-38459200*r**4-358564138*r**6
            -438041866*r**8-228371272*r**10+37752324*r**12+634262*r**14)-4*Q2**11*(
            -48165+833580*r**2+23734310*r**4+18524260*r**6+191728516*r**8+235832836*r**10
            +95582026*r**12+40901932*r**14+427377*r**16)+2*Q2**10*(-43329+1222980*r**2
            +58336869*r**4+277843715*r**6+1545154811*r**8+3240493627*r**10+1729299335*r**12
            +475011561*r**14+58601370*r**16+322773*r**18)+4*Q2**9*(-21736+513590*r**2
            +4363551*r**4-147373004*r**6-899717980*r**8-3213841264*r**10-3392656990*r**12
            -715979284*r**14-140458404*r**16+25380890*r**18+279719*r**20)-2*Q2**8*(
            -45422+1641233*r**2+48534133*r**4-170257418*r**6-588840656*r**8-4624178418*r**10
            -7526070378*r**12-4253144032*r**14+1312661502*r**16+216617569*r**18+93325493*r**20
            +565738*r**22)+4*Q2**7*(1573+68684*r**2+7392018*r**4+10756724*r**6+339887083*r**8
            +998967992*r**10+4261569596*r**12+4797578744*r**14+3260448139*r**16+1591348508*r**18
            +211851218*r**20+7629684*r**22-31163*r**24)+2*Q2**6*(-19635+801700*r**2
            +18156501*r**4-209461039*r**6-777053636*r**8-5007634041*r**10-23534560726*r**12
            -47692110982*r**14-28406379147*r**16-14011017886*r**18-1356019711*r**20
            -196567371*r**22+50182914*r**24+310899*r**26)-4*Q2**5*(-2162+153710*r**2
            +5399059*r**4-79097960*r**6-98177028*r**8-1165588042*r**10-5991109955*r**12
            -22670582320*r**14-29948143010*r**16-3934803926*r**18-3395263571*r**20
            +710056600*r**22+51425816*r**24+13953970*r**26+44419*r**28)-2*Q2**4*(
            -4909+213490*r**2+2377176*r**4-49489669*r**6+14947725*r**8+1709875624*r**10
            +1532121230*r**12+5085336893*r**14+21487760013*r**16+14689327610*r**18
            -27876860036*r**20-6085393995*r**22-1579897069*r**24-173066644*r**26
            +9858590*r**28+74771*r**30)+4*Q2**3*(-1157+73388*r**2+1303102*r**4-47410252*r**6
            +61818306*r**8+1239105212*r**10+3689404902*r**12+6233169716*r**14-1101385656*r**16
            -2238290812*r**18-13322010758*r**20-9973666948*r**22-3947265218*r**24
            -103450092*r**26-30318494*r**28+5590428*r**30+22333*r**32)+2*Q2**2*(
            -447+17184*r**2-132149*r**4+9379321*r**6+7830667*r**8+285387037*r**10
            -2214797369*r**12-19284105635*r**14-4305412287*r**16+5509203441*r**18
            -32929105263*r**20+37591020251*r**22-6331072423*r**24+1139137991*r**26
            -350402083*r**28-28432177*r**30-408166*r**32+4107*r**34)-12*Q2*(-80
            +5330*r**2+24149*r**4-3731276*r**6+20537872*r**8+346607692*r**10+751218972*r**12
            +574534900*r**14+4976184960*r**16-7844999744*r**18+9208651006*r**20-10784577284*r**22
            +4395066128*r**24-1287006892*r**26-321630628*r**28-26504868*r**30-4690768*r**32
            +309198*r**34+1333*r**36)+3*(-57+4455*r**2+1651*r**4-4755365*r**6
            +33999596*r**8+552049916*r**10+1070939420*r**12+3260927372*r**14+14149245010*r**16
            -38650944158*r**18+10091920314*r**20+31128267770*r**22-24690211972*r**24
            +4220464300*r**26-645428372*r**28-501804548*r**30-10774145*r**32-4210801*r**34
            +308555*r**36+1059*r**38))*sqrtq2+logq2**5*(52254720000*(-Q2+(-1+r)**2)*(
            -1+r)*r**22*(1+r)*(1+r**2)*(3+r**2)*(1-Q2+r**2)*(-Q2+(1+r)**2)
            +52254720000*r**22*(-3-r**2+3*r**4+r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2**4*(41472000*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-480*Q2**6*(1+r**2)+240*Q2**5*(5+17*r**2+12*r**4)-8*Q2**4*(
            -171+503*r**2+1483*r**4+837*r**6)+Q2**3*(-4197-7411*r**2+4737*r**4
            +14275*r**6+6324*r**8)+Q2**2*(-1257+7268*r**2+10278*r**4-3876*r**6
            -5213*r**8+864*r**10)+Q2*(8403+813*r**2-8928*r**4+1020*r**6+5961*r**8
            -1833*r**10-5436*r**12)+3*(-1679-852*r**2-3925*r**4+1808*r**6+4783*r**8
            -908*r**10-75*r**12+848*r**14))+41472000*r**18*(480*Q2**9*(1+r**2)-240*Q2**8*(11
            +29*r**2+18*r**4)+8*Q2**7*(459+2783*r**2+4393*r**4+2097*r**6)-7*Q2**6*(
            -603+2171*r**2+10263*r**4+12565*r**6+5076*r**8)+2*Q2**5*(-7119-14938*r**2
            +9418*r**4+55520*r**6+58597*r**8+20538*r**10)-5*Q2**4*(-357-8491*r**2
            -13112*r**4+264*r**6+16085*r**8+14371*r**10+3528*r**12)+3*(-1+r**2)**3*(1679
            +4210*r**2+8987*r**4+11104*r**6+4513*r**8+638*r**10+1621*r**12+848*r**14)
            -4*Q2**3*(-7455-1925*r**2+9456*r**4+11782*r**6+5237*r**8-4677*r**10
            -70*r**12+3780*r**14)+Q2**2*(-41577-33499*r**2-38777*r**4-29375*r**6
            +61833*r**8+45623*r**10-6283*r**12+17251*r**14+24804*r**16)-6*Q2*(
            -3919-1692*r**2-6234*r**4-5414*r**6+648*r**8+9090*r**10+7578*r**12
            -2370*r**14+135*r**16+2178*r**18))*sqrtq2)+logq2**3*(1382400*r**14*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(640*Q2**10-80*Q2**9*(81
            +109*r**2)+4*Q2**8*(6629+17565*r**2+10744*r**4)-4*Q2**7*(13937+55577*r**2
            +67087*r**4+24047*r**6)+Q2**6*(60123+300955*r**2+587331*r**4+441405*r**6
            +78778*r**8)+2*Q2**5*(-16898-61691*r**2-162424*r**4-207494*r**6-100006*r**8
            +29057*r**10)+Q2**4*(16975+47435*r**2+31266*r**4-542330*r**6-664749*r**8
            -296465*r**10-153860*r**12)+8*Q2**3*(-612-26545*r**2-80570*r**4-24933*r**6
            +148772*r**8+150185*r**10+50490*r**12+9293*r**14)+Q2**2*(-18307+97573*r**2
            +284079*r**4+1148689*r**6+348657*r**8-593941*r**10-206511*r**12-131617*r**14
            +39058*r**16)-6*Q2*(-3612-26855*r**2-171020*r**4+66960*r**6+131432*r**8
            -110278*r**10-16620*r**12+116040*r**14+6060*r**16+7893*r**18)+3*(-2233
            -36861*r**2-247472*r**4+80392*r**6-1734*r**8+157026*r**10-12024*r**12
            -73288*r**14+124223*r**16+7899*r**18+4072*r**20))+1382400*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(640*Q2**10-80*Q2**9*(81+109*r**2)+4*Q2**8*(6629
            +17565*r**2+10744*r**4)-4*Q2**7*(13937+55577*r**2+67087*r**4+24047*r**6)
            +Q2**6*(60123+300955*r**2+587331*r**4+441405*r**6+78778*r**8)+2*Q2**5*(
            -16898-61691*r**2-162424*r**4-207494*r**6-100006*r**8+29057*r**10)
            +Q2**4*(16975+47435*r**2+31266*r**4-542330*r**6-664749*r**8-296465*r**10
            -153860*r**12)+8*Q2**3*(-612-26545*r**2-80570*r**4-24933*r**6+148772*r**8
            +150185*r**10+50490*r**12+9293*r**14)+Q2**2*(-18307+97573*r**2+284079*r**4
            +1148689*r**6+348657*r**8-593941*r**10-206511*r**12-131617*r**14+39058*r**16)
            -6*Q2*(-3612-26855*r**2-171020*r**4+66960*r**6+131432*r**8-110278*r**10
            -16620*r**12+116040*r**14+6060*r**16+7893*r**18)+3*(-2233-36861*r**2
            -247472*r**4+80392*r**6-1734*r**8+157026*r**10-12024*r**12-73288*r**14
            +124223*r**16+7899*r**18+4072*r**20))*sqrtq2)+logq2**2*(-23040*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-11520*Q2**13+16*Q2**12*(5467+6129*r**2)
            -4*Q2**11*(68411+162683*r**2+81472*r**4)+4*Q2**10*(107538+445435*r**2
            +488576*r**4+115431*r**6)-5*Q2**9*(63513+485409*r**2+836313*r**4+525503*r**6
            +2286*r**8)-5*Q2**8*(-4311-255372*r**2-156518*r**4+31124*r**6-37219*r**8
            +156696*r**10)+2*Q2**7*(81363+461006*r**2+6476095*r**4+14718735*r**6
            +9881570*r**8+2230843*r**10+395556*r**12)+2*Q2**6*(-94431-969843*r**2
            -10679877*r**4-36028570*r**6-43245765*r**8-16754391*r**10-2859143*r**12
            +57588*r**14)+2*Q2**5*(47838+668895*r**2+5004941*r**4+24313856*r**6
            +53179760*r**8+38935933*r**10+2545855*r**12+477316*r**14-311994*r**16)
            +10*Q2**4*(7224-70913*r**2-290236*r**4-202923*r**6-798008*r**8-100423*r**10
            +2309292*r**12+3683419*r**14+392144*r**16+26328*r**18)+10*Q2**3*(-11161
            +33744*r**2+830991*r**4+3372825*r**6+3077805*r**8-4134399*r**10-9993411*r**12
            -7592889*r**14-3011748*r**16-312497*r**18+11460*r**20)-2*Q2**2*(-4051
            -179437*r**2+431045*r**4+16351470*r**6+33703410*r**8+33675702*r**10
            -9064446*r**12-13787040*r**14-19815615*r**16+2099095*r**18+83929*r**20
            +51538*r**22)+3*Q2*(13227-202019*r**2-2912411*r**4-6759935*r**6-28658760*r**8
            +21190806*r**10+3415638*r**12-11047218*r**14+22869135*r**16-2508915*r**18
            +4245317*r**20+351281*r**22+3854*r**24)+3*(-4801+73290*r**2+1453338*r**4
            +5865698*r**6+26364045*r**8-33625068*r**10-10397140*r**12+19279324*r**14
            +7418889*r**16-15437670*r**18+375994*r**20-1257150*r**22-110037*r**24
            +1288*r**26))-23040*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(11520*Q2**14
            -16*Q2**13*(6187+6849*r**2)+4*Q2**12*(90279+209067*r**2+105988*r**4)
            -4*Q2**11*(175949+676529*r**2+732731*r**4+196903*r**6)+Q2**10*(747717
            +4638937*r**2+7917609*r**4+5043543*r**6+473154*r**8)+10*Q2**9*(-33912
            -402147*r**2-739120*r**4-665346*r**6-282504*r**8+77205*r**10)-Q2**8*(141171
            -376403*r**2+10892740*r**4+28810500*r**6+19732665*r**8+5059071*r**10
            +1574592*r**12)+4*Q2**7*(87897+756106*r**2+8808489*r**4+28611700*r**6
            +33923035*r**8+14433402*r**10+2742771*r**12+168984*r**14)+2*Q2**6*(-142269
            -1733169*r**2-16654661*r**4-71022303*r**6-132454095*r**8-98936089*r**10
            -22159389*r**12-3278871*r**14+369582*r**16)-4*Q2**5*(-5859-535649*r**2
            -3562508*r**4-15166706*r**6-40741828*r**8-46308904*r**10-14967664*r**12
            +7696962*r**14+897699*r**16+221817*r**18)+10*Q2**4*(18385-97433*r**2
            -1192140*r**4-3865984*r**6-4078736*r**8+3235968*r**10+12202280*r**12
            +13585600*r**14+7087311*r**16+730969*r**18+14868*r**20)+4*Q2**3*(-29928
            -33261*r**2+2377360*r**4+18685275*r**6+32978280*r**8+14196366*r**10
            -39851748*r**12-50859270*r**14-36419400*r**16-7261065*r**18-710628*r**20
            +54419*r**22)-Q2**2*(31579-973033*r**2-8234017*r**4+13285225*r**6+14133480*r**8
            +198330642*r**10+59469426*r**12-78844626*r**14+1402095*r**16-42959785*r**18
            +17101999*r**20+1324777*r**22+114638*r**24)+6*Q2*(9014-131041*r**2
            -2283884*r**4-7769022*r**6-30891370*r**8+13078557*r**10+17501792*r**12
            -13455452*r**14+2201514*r**16+17898945*r**18+680204*r**20+2926874*r**22
            +232586*r**24+1283*r**26)+3*(-4801+68489*r**2+1526628*r**4+7319036*r**6
            +32229743*r**8-7261023*r**10-44022208*r**12+8882184*r**14+26698213*r**16
            -8018781*r**18-15061676*r**20-881156*r**22-1367187*r**24-108749*r**26
            +1288*r**28))*sqrtq2)+logq2*(-192*r**6*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-24832*Q2**16+32*Q2**15*(8831+7391*r**2)-8*Q2**14*(147195
            +310747*r**2+105120*r**4)+8*Q2**13*(279085+1071463*r**2+949863*r**4
            +149925*r**6)+Q2**12*(-1391025-11171351*r**2-11059123*r**4-7147001*r**6
            +269140*r**8)-4*Q2**11*(414176+330159*r**2+10560284*r**4+12969654*r**6
            +2738804*r**8+730411*r**10)+2*Q2**10*(1413177+8996279*r**2+77432240*r**4
            +176075950*r**6+92391625*r**8+15299499*r**10+1319262*r**12)+4*Q2**9*(33930
            -4236587*r**2-47505400*r**4-190977325*r**6-205409750*r**8-43791325*r**10
            -4054812*r**12+365205*r**14)+Q2**8*(-2632035+5002867*r**2+85605557*r**4
            +659131035*r**6+1143100575*r**8+638600425*r**10-124396393*r**12-20966583*r**14
            -3625800*r**16)+8*Q2**7*(139700+319169*r**2+4626662*r**4+18149174*r**6
            +127385300*r**8+158298110*r**10+87545574*r**12+46580062*r**14+3632844*r**16
            +113165*r**18)+4*Q2**6*(264701-1959057*r**2-23969242*r**4-170495852*r**6
            -1024048542*r**8-2141159326*r**10-1374332532*r**12-467276692*r**14-48003727*r**16
            -828817*r**18+461246*r**20)-8*Q2**5*(102873-886356*r**2-9947845*r**4
            -39908980*r**6-335013240*r**8-1271910682*r**10-1593563812*r**12-437240570*r**14
            -133478905*r**16+18659510*r**18+1671809*r**20+146598*r**22)-Q2**4*(178535
            -1807199*r**2+4007465*r**4+95382675*r**6+114198850*r**8+434581850*r**10
            +5891720898*r**12+2616114550*r**14-4645644325*r**16-790689275*r**18-202457835*r**20
            -7395849*r**22+340860*r**24)+4*Q2**3*(69120-1294299*r**2-9485184*r**4
            +91618610*r**6+368745300*r**8+471635775*r**10-425924192*r**12-911801092*r**14
            -1620955560*r**16-1492129325*r**18-296233120*r**20-10748334*r**22+229076*r**24
            +113225*r**26)-2*Q2**2*(5975-383687*r**2-7406276*r**4+54726358*r**6
            +412512145*r**8+2909071835*r**10+3068697954*r**12+375339252*r**14-442052871*r**16
            -2804453825*r**18-5148760*r**20-99536842*r**22+21319199*r**24+944813*r**26
            +12730*r**28)-12*Q2*(3814-119447*r**2-461392*r**4+24862223*r**6+112256118*r**8
            +66295181*r**10+569882944*r**12-240045341*r**14+20753954*r**16-712704661*r**18
            +365365296*r**20-178749747*r**22-25078142*r**24-2222177*r**26-44832*r**28
            +6209*r**30)+3*(3721-172681*r**2-1008755*r**4+54892795*r**6+237587485*r**8
            +542905027*r**10+2875929953*r**12-7282941065*r**14+2909531835*r**16+3719437205*r**18
            -3432125417*r**20+628651937*r**22-210248305*r**24-40930255*r**26-1506565*r**28
            -13331*r**30+6416*r**32))+192*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(24832*Q2**16
            -32*Q2**15*(8831+7391*r**2)+8*Q2**14*(147195+310747*r**2+105120*r**4)
            -8*Q2**13*(279085+1071463*r**2+949863*r**4+149925*r**6)+Q2**12*(1391025
            +11171351*r**2+11059123*r**4+7147001*r**6-269140*r**8)+4*Q2**11*(414176
            +330159*r**2+10560284*r**4+12969654*r**6+2738804*r**8+730411*r**10)
            -2*Q2**10*(1413177+8996279*r**2+77432240*r**4+176075950*r**6+92391625*r**8
            +15299499*r**10+1319262*r**12)-4*Q2**9*(33930-4236587*r**2-47505400*r**4
            -190977325*r**6-205409750*r**8-43791325*r**10-4054812*r**12+365205*r**14)
            +Q2**8*(2632035-5002867*r**2-85605557*r**4-659131035*r**6-1143100575*r**8
            -638600425*r**10+124396393*r**12+20966583*r**14+3625800*r**16)-8*Q2**7*(139700
            +319169*r**2+4626662*r**4+18149174*r**6+127385300*r**8+158298110*r**10
            +87545574*r**12+46580062*r**14+3632844*r**16+113165*r**18)+4*Q2**6*(
            -264701+1959057*r**2+23969242*r**4+170495852*r**6+1024048542*r**8+2141159326*r**10
            +1374332532*r**12+467276692*r**14+48003727*r**16+828817*r**18-461246*r**20)
            +8*Q2**5*(102873-886356*r**2-9947845*r**4-39908980*r**6-335013240*r**8
            -1271910682*r**10-1593563812*r**12-437240570*r**14-133478905*r**16+18659510*r**18
            +1671809*r**20+146598*r**22)+Q2**4*(178535-1807199*r**2+4007465*r**4
            +95382675*r**6+114198850*r**8+434581850*r**10+5891720898*r**12+2616114550*r**14
            -4645644325*r**16-790689275*r**18-202457835*r**20-7395849*r**22+340860*r**24)
            -4*Q2**3*(69120-1294299*r**2-9485184*r**4+91618610*r**6+368745300*r**8
            +471635775*r**10-425924192*r**12-911801092*r**14-1620955560*r**16-1492129325*r**18
            -296233120*r**20-10748334*r**22+229076*r**24+113225*r**26)+2*Q2**2*(5975
            -383687*r**2-7406276*r**4+54726358*r**6+412512145*r**8+2909071835*r**10
            +3068697954*r**12+375339252*r**14-442052871*r**16-2804453825*r**18-5148760*r**20
            -99536842*r**22+21319199*r**24+944813*r**26+12730*r**28)+12*Q2*(3814
            -119447*r**2-461392*r**4+24862223*r**6+112256118*r**8+66295181*r**10
            +569882944*r**12-240045341*r**14+20753954*r**16-712704661*r**18+365365296*r**20
            -178749747*r**22-25078142*r**24-2222177*r**26-44832*r**28+6209*r**30)
            -3*(3721-172681*r**2-1008755*r**4+54892795*r**6+237587485*r**8+542905027*r**10
            +2875929953*r**12-7282941065*r**14+2909531835*r**16+3719437205*r**18
            -3432125417*r**20+628651937*r**22-210248305*r**24-40930255*r**26-1506565*r**28
            -13331*r**30+6416*r**32))*sqrtq2))*math.log(2*muWC))/(-3500*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))-3500*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2+logq2**5*(-13063680000*r**22*(1+r**2)*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            +13063680000*r**22*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**2*(-3024000*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8+3*Q2**3*(1
            +r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4+7*r**6))
            -3024000*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8
            +3*Q2**3*(1+r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4
            +7*r**6))*sqrtq2)+logq2**3*(12096000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))+12096000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))*sqrtq2)+logq2**4*(-72576000*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(63+8*Q2**4-402*r**2
            -1122*r**4-402*r**6+63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)
            -3*Q2*(19+31*r**2+31*r**4+19*r**6))-72576000*(-Q2+(-1+r)**2)*r**18*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(63+8*Q2**4-402*r**2-1122*r**4-402*r**6
            +63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)-3*Q2*(19+31*r**2
            +31*r**4+19*r**6))*sqrtq2)+logq2*(42000*(-Q2+(-1+r)**2)*r**6*(1-Q2
            +r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1
            +r**2)-Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)
            +3*(9-86*r**2-446*r**4-86*r**6+9*r**8))+42000*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1+r**2)
            -Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)+3*(9
            -86*r**2-446*r**4-86*r**6+9*r**8))*sqrtq2))+((128*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(24*Q2**19
            -16*Q2**18*(1+115*r**2)-Q2**17*(1577+36562*r**2+38213*r**4)+Q2**16*(10991
            +551997*r**2+5532961*r**4+571475*r**6)-2*Q2**15*(18071+1505207*r**2
            +28554422*r**4+28710471*r**6+1561541*r**8)+Q2**14*(67558+9045020*r**2
            +239571118*r**4+497730598*r**6+241874252*r**8+9401758*r**10)-2*Q2**13*(33341
            +8307825*r**2+241992141*r**4+771247738*r**6+773907051*r**8+245871381*r**10
            +8613515*r**12)+2*Q2**12*(3133+9343438*r**2+168470076*r**4+742300605*r**6
            +552079401*r**8+753509748*r**10+176026462*r**12+9536257*r**14)+2*Q2**11*(36101
            -5734703*r**2+247927580*r**4+1149334887*r**6+6077391720*r**8+6055464087*r**10
            +1118888456*r**12+239395489*r**14-5465665*r**16)+2*Q2**10*(-45617+1147146*r**2
            -614062595*r**4-3468068525*r**6-17281307493*r**8-29969336513*r**10-17198324897*r**12
            -3411779271*r**14-611271110*r**16+468523*r**18)+Q2**9*(40612-619190*r**2
            +771416464*r**4+5562037184*r**6+29558667576*r**8+83960882308*r**10+83717182880*r**12
            +29363084304*r**14+5456752084*r**16+788438466*r**18+459712*r**20)+2*Q2**8*(5356
            +2037035*r**2+196136707*r**4+122029236*r**6+5267776392*r**8-7859017506*r**10
            -7168054170*r**12-7639769688*r**14+5190717036*r**16+112938967*r**18+180188471*r**20
            +1993540*r**22)-2*Q2**7*(7813+1994733*r**2+386252870*r**4+1268815945*r**6
            +15777336117*r**8+23139755882*r**10+58532200140*r**12+58677321066*r**14
            +23247916295*r**16+15531145177*r**18+1200036798*r**20+376135421*r**22
            +2181007*r**24)+2*Q2**6*(-1351-52702*r**2+96552161*r**4+801591681*r**6
            +7350693260*r**8+13667718869*r**10+37998776354*r**12+68419904362*r**14
            +38164069601*r**16+13226893020*r**18+7283304317*r**20+755003285*r**22
            +100447578*r**24-19795*r**26)+2*Q2**5*(4597+1176029*r**2+138406081*r**4
            -1010970482*r**6-1492452331*r**8-13115860025*r**10-2136632743*r**12-5557539308*r**14
            -5360104105*r**16-1961710805*r**18-11530830901*r**20-1712380130*r**22
            -1028728097*r**24+127716593*r**26+1288027*r**28)-2*Q2**4*(1597+631290*r**2
            +99611916*r**4-1061943259*r**6-3141206361*r**8-22219990672*r**10-26335567710*r**12
            +23019843303*r**14-34922839477*r**16+25627110882*r**18-26101037592*r**20
            -20237987725*r**22-3325083439*r**24-1097623884*r**26+93744234*r**28+698497*r**30)
            -2*Q2**3*(757+85165*r**2+1074816*r**4+85573623*r**6+1350318366*r**8
            +7431602893*r**10+19771115380*r**12-44913225937*r**14+53171986204*r**16
            +52878755743*r**18-47396731432*r**20+19515728125*r**22+6982614746*r**24
            +1335586023*r**26+96702516*r**28+340957*r**30+100855*r**32)+(-1+r**2)**2*(57
            +21303*r**2+2392046*r**4-138985030*r**6-966727726*r**8-1212484666*r**10
            -28523107066*r**12+139946681570*r**14-425465056380*r**16+625052392692*r**18
            -432551175894*r**20+145279760398*r**22-29968204898*r**24-794522390*r**26
            -973108766*r**28-140938922*r**30+2095315*r**32+24357*r**34)+2*Q2**2*(781
            +207326*r**2+24049963*r**4-568744935*r**6-1873370109*r**8-5602673331*r**10
            -26180296777*r**12+38361172813*r**14+1546003745*r**16-86685868867*r**18
            +3172072849*r**20+41651494811*r**22-28240016895*r**24-4527172185*r**26
            -1939971699*r**28-573691649*r**30+21782990*r**32+237169*r**34)+Q2*(
            -491-159312*r**2-18819443*r**4+733272664*r**6+3208035540*r**8+4782598488*r**10
            +74079639860*r**12-332417459784*r**14+738782588102*r**16-474718515560*r**18
            -460638118698*r**20+748867774856*r**22-347738049628*r**24+79930387464*r**26
            +2973170820*r**28+3253494376*r**30+740943021*r**32-16823720*r**34-182555*r**36))
            -128*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))**2*(24*Q2**20-8*Q2**19*(5+233*r**2)-Q2**18*(1561
            +34706*r**2+36373*r**4)+8*Q2**17*(1571+73767*r**2+700967*r**4+76211*r**6)
            -Q2**16*(47133+3573402*r**2+63193802*r**4+63525378*r**6+3694557*r**8)
            +4*Q2**15*(25925+3022894*r**2+74922594*r**4+153065096*r**6+75604569*r**8
            +3131210*r**10)-4*Q2**14*(33560+6432057*r**2+183150105*r**4+569949298*r**6
            +571854738*r**8+185754693*r**10+6657197*r**12)+4*Q2**13*(18237+8842302*r**2
            +209385021*r**4+877770242*r**6+1048617095*r**8+886644090*r**10+215255679*r**12
            +9074886*r**14)+4*Q2**12*(16484-7540637*r**2+35057033*r**4+119282103*r**6
            +2391505857*r**8+2374937469*r**10+94676123*r**12+26916385*r**14-7500961*r**16)
            +4*Q2**11*(-40859+3422874*r**2-428127736*r**4-2432665496*r**6-12254017050*r**8
            -21051096160*r**10-12186338720*r**12-2385031608*r**14-422600467*r**16
            +2967094*r**18)+2*Q2**10*(65923-1411124*r**2+998623681*r**4+6863149712*r**6
            +35528709806*r**8+89231085160*r**10+89026252850*r**12+35291646320*r**14
            +6751426423*r**16+1005021820*r**18-238667*r**20)+4*Q2**9*(-7475+1163162*r**2
            -94630965*r**4-1522348794*r**6-6146287994*r**8-32309396224*r**10-45503543382*r**12
            -32089951640*r**14-6109600579*r**16-1504828154*r**18-107130309*r**20
            +881842*r**22)-2*Q2**8*(13169+4037124*r**2+584426612*r**4+1586981888*r**6
            +21167141745*r**8+20548514768*r**10+43505128464*r**12+43869497208*r**14
            +20798863643*r**16+20834801180*r**18+1493164236*r**20+558317432*r**22
            +4174547*r**24)+4*Q2**7*(3231+974922*r**2+242399882*r**4+1228330248*r**6
            +12198422661*r**8+26292405434*r**10+59835366188*r**12+92814712784*r**14
            +60044653481*r**16+26002977246*r**18+12007243146*r**20+1165587752*r**22
            +239382003*r**24+1080606*r**26)+4*Q2**6*(2974+615041*r**2+20953311*r**4
            -954557162*r**6-4822368636*r**8-17067136077*r**10-26901563983*r**12-55988110012*r**14
            -55972039034*r**16-26676336713*r**18-16020514119*r**20-4875343866*r**22
            -942089480*r**24+13644405*r**26+653911*r**28)-4*Q2**5*(3097+905958*r**2
            +119597013*r**4-967253830*r**6-2822314587*r**8-18414151514*r**10-20794030239*r**12
            +7662835626*r**14-22920241445*r**16+9152647986*r**18-19796789649*r**20
            -16740599378*r**22-3033095833*r**24-999317694*r**26+111374427*r**28+993262*r**30)
            +4*Q2**4*(420+273861*r**2+49584195*r**4-523952483*r**6-2776733993*r**8
            -16396399963*r**10-34163336881*r**12+20798750765*r**14-32537491189*r**16
            -31087242169*r**18+23461402361*r**20-32927376721*r**22-15272842955*r**24
            -2879146673*r**26-550291083*r**28+47050887*r**30+298821*r**32)+4*Q2**3*(769
            +146624*r**2+12604972*r**4-241048248*r**6-218739060*r**8+1589623964*r**10
            +511210748*r**12+6609531128*r**14+4902382006*r**16+9682436540*r**18+4327048580*r**20
            +6885245752*r**22-870837012*r**24+1895514292*r**26-253841580*r**28-238324088*r**30
            +11112401*r**32+169012*r**34)+Q2**2*(-2053-575526*r**2-67334021*r**4
            +1822662608*r**6+8092265628*r**8+19734685368*r**10+137645580076*r**12
            -356779211856*r**14+658968234986*r**16-304438785316*r**18-293610526662*r**20
            +659220639536*r**22-374561005460*r**24+145464765624*r**26+15907458588*r**28
            +8280821072*r**30+1844760339*r**32-60864038*r**34-656893*r**36)-(-1
            +r**2)**2*(57+21360*r**2+2413349*r**4-136592984*r**6-1105712756*r**8
            -2179212392*r**10-29735591732*r**12+111423574504*r**14-285518374810*r**16
            +199587336312*r**18+192501216798*r**20-287271415496*r**22+115311555500*r**24
            -30762727288*r**26-1767631156*r**28-1114047688*r**30-138843607*r**32
            +2119672*r**34+24357*r**36)+4*Q2*(137+45248*r**2+5332063*r**4-214550260*r**6
            -1156918456*r**8-1852162068*r**10-26481775952*r**12+113529557740*r**14
            -285061663726*r**16+337966278620*r**18-293191095850*r**20+336801212180*r**22
            -288552156704*r**24+118057327492*r**26-28063956792*r**28-1303977244*r**30
            -1170893251*r**32-217306124*r**34+4763219*r**36+51728*r**38))*sqrtq2
            +logq2**7*(-902961561600000*r**32*(1+r**2)**2*(1-Q2+r**2)*(3+22*r**2
            +23*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-902961561600000*(Q2
            -(-1+r)**2)**2*r**32*(1+r**2)**2*(3+22*r**2+23*r**4)*(Q2-(1+r)**2)**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**6*(-716636160000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(12000*Q2**8*(1+r**2)-240*Q2**7*(225
            +457*r**2+232*r**4)+8*Q2**6*(5208+26029*r**2+27422*r**4+6657*r**6)
            +Q2**5*(162141+110659*r**2-124713*r**4+60413*r**6+133644*r**8)-Q2**4*(295155
            +526908*r**2+265414*r**4+223652*r**6+459687*r**8+268800*r**10)+Q2**3*(
            -103320+28822*r**2+236278*r**4+200334*r**6+201866*r**8+10748*r**10
            -94920*r**12)+3*(-1+r**2)**2*(52433+21132*r**2-21981*r**4+96256*r**6
            +93071*r**8-28092*r**10+19389*r**12+50032*r**14)+Q2**2*(632520+505802*r**2
            -83848*r**4+87548*r**6+80128*r**8-87278*r**10+487168*r**12+595560*r**14)
            -3*Q2*(184383-7425*r**2-103399*r**4+304365*r**6+425717*r**8+274769*r**10
            -117273*r**12-7229*r**14+175052*r**16))+716636160000*r**28*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(12000*Q2**9*(1+r**2)-240*Q2**8*(275
            +557*r**2+282*r**4)+8*Q2**7*(11958+46489*r**2+48092*r**4+13617*r**6)
            +7*Q2**6*(17211-19891*r**2-78903*r**4-30317*r**6+11484*r**8)-4*Q2**5*(114324
            +199927*r**2+62840*r**4+39838*r**6+163436*r**8+100611*r**10)+5*Q2**4*(38367
            +170177*r**2+205720*r**4+137880*r**6+177041*r**8+147847*r**10+34776*r**12)
            +4*Q2**3*(183960+145075*r**2-87237*r**4-87266*r**6-80518*r**8-74973*r**10
            +142835*r**12+172620*r**14)-3*(-1+r**2)**2*(52433+73565*r**2-849*r**4
            +74275*r**6+189327*r**8+64979*r**10-8703*r**12+69421*r**14+50032*r**16)
            -Q2**2*(1185669+1116047*r**2+111757*r**4+916795*r**6+1444827*r**8+817157*r**10
            +48071*r**12+1061041*r**14+1120716*r**16)+12*Q2*(59204+23306*r**2-30659*r**4
            +90579*r**6+152165*r**8+145627*r**10+81535*r**12-35335*r**14+21787*r**16
            +56271*r**18))*sqrtq2)+logq2**5*(-3981312000*r**24*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-192000*Q2**12*(1+r**2)+480*Q2**11*(5861
            +11778*r**2+5917*r**4)-8*Q2**10*(1828695+5705518*r**2+5730743*r**4+1854144*r**6)
            +120*Q2**9*(307785+1331270*r**2+2051212*r**4+1340090*r**6+312363*r**8)
            -45*Q2**8*(1103531+6098568*r**2+12684598*r**4+12714684*r**6+6138527*r**8
            +1113404*r**10)+20*Q2**7*(2075793+11386508*r**2+27578953*r**4+36557304*r**6
            +27641099*r**8+11386492*r**10+2034459*r**12)-60*Q2**6*(773682+1813455*r**2
            +2385676*r**4+2392395*r**6+2234394*r**8+2172277*r**10+1721608*r**12
            +735441*r**14)+12*Q2**5*(5893620+12759689*r**2+17987869*r**4+9123007*r**6
            -6405165*r**8+3414215*r**10+13864499*r**12+11771569*r**14+5727657*r**16)
            -10*Q2**4*(4907985+21220790*r**2+61167694*r**4+86996460*r**6+60734174*r**8
            +54170368*r**10+75388302*r**12+54922940*r**14+20010805*r**16+4884066*r**18)
            -60*Q2**3*(392173-1051666*r**2-1445003*r**4-2135680*r**6-6236790*r**8
            -7838648*r**10-5336914*r**12-1567656*r**14-1349327*r**16-1002254*r**18
            +379957*r**20)+9*(-1+r**2)**2*(800705+3420374*r**2+24697037*r**4+21009312*r**6
            -7205778*r**8+9749412*r**10+9212694*r**12-7671792*r**14+20142033*r**16
            +23435398*r**18+3213853*r**20+803152*r**22)+60*Q2**2*(990104+1523159*r**2
            +13358288*r**4+18589053*r**6+2963562*r**8-4317246*r**10-4215522*r**12
            +2999430*r**14+17798718*r**16+12504631*r**18+1415506*r**20+982957*r**22)
            -180*Q2*(194932+421253*r**2+3894773*r**4+2115889*r**6-2402739*r**8
            +2778966*r**10+7041102*r**12+2412174*r**14-2441742*r**16+2047301*r**18
            +3679549*r**20+385057*r**22+194765*r**24))+3981312000*r**24*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*(192000*Q2**12*(1+r**2)-480*Q2**11*(5861
            +11778*r**2+5917*r**4)+8*Q2**10*(1828695+5705518*r**2+5730743*r**4+1854144*r**6)
            -120*Q2**9*(307785+1331270*r**2+2051212*r**4+1340090*r**6+312363*r**8)
            +45*Q2**8*(1103531+6098568*r**2+12684598*r**4+12714684*r**6+6138527*r**8
            +1113404*r**10)-20*Q2**7*(2075793+11386508*r**2+27578953*r**4+36557304*r**6
            +27641099*r**8+11386492*r**10+2034459*r**12)+60*Q2**6*(773682+1813455*r**2
            +2385676*r**4+2392395*r**6+2234394*r**8+2172277*r**10+1721608*r**12
            +735441*r**14)-12*Q2**5*(5893620+12759689*r**2+17987869*r**4+9123007*r**6
            -6405165*r**8+3414215*r**10+13864499*r**12+11771569*r**14+5727657*r**16)
            +10*Q2**4*(4907985+21220790*r**2+61167694*r**4+86996460*r**6+60734174*r**8
            +54170368*r**10+75388302*r**12+54922940*r**14+20010805*r**16+4884066*r**18)
            +60*Q2**3*(392173-1051666*r**2-1445003*r**4-2135680*r**6-6236790*r**8
            -7838648*r**10-5336914*r**12-1567656*r**14-1349327*r**16-1002254*r**18
            +379957*r**20)-9*(-1+r**2)**2*(800705+3420374*r**2+24697037*r**4+21009312*r**6
            -7205778*r**8+9749412*r**10+9212694*r**12-7671792*r**14+20142033*r**16
            +23435398*r**18+3213853*r**20+803152*r**22)-60*Q2**2*(990104+1523159*r**2
            +13358288*r**4+18589053*r**6+2963562*r**8-4317246*r**10-4215522*r**12
            +2999430*r**14+17798718*r**16+12504631*r**18+1415506*r**20+982957*r**22)
            +180*Q2*(194932+421253*r**2+3894773*r**4+2115889*r**6-2402739*r**8
            +2778966*r**10+7041102*r**12+2412174*r**14-2441742*r**16+2047301*r**18
            +3679549*r**20+385057*r**22+194765*r**24))*sqrtq2)+logq2**4*(66355200*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(-256000*Q2**16+5120*Q2**15*(2168+2175*r**2)
            -64*Q2**14*(1412729+2870556*r**2+1417347*r**4)+8*Q2**13*(43096783+134147470*r**2
            +134230031*r**4+43175984*r**6)-16*Q2**12*(47077101+204771058*r**2+314893150*r**4
            +204747686*r**6+46998093*r**8)+Q2**11*(1013651109+5855699852*r**2+12288240682*r**4
            +12279667036*r**6+5841181489*r**8+1005143832*r**10)-Q2**10*(854544621
            +5870535985*r**2+14166941438*r**4+18112309238*r**6+14081977333*r**8+5818404377*r**10
            +839384928*r**12)+Q2**9*(387868437+1874010248*r**2-2164280029*r**4-14962946160*r**6
            -15159493885*r**8-2442765808*r**10+1787931973*r**12+382473816*r**14)
            +Q2**8*(189232047+2589044555*r**2+26338713889*r**4+88273778661*r**6+128885627265*r**8
            +88832803237*r**10+26692520815*r**12+2641282219*r**14+171013056*r**16)
            -2*Q2**7*(376705459+1648365212*r**2+14438443330*r**4+53234349684*r**6
            +98791596902*r**8+99003441604*r**10+53448656122*r**12+14392146500*r**14
            +1619033899*r**16+365489512*r**18)+2*Q2**6*(453085891+1171628443*r**2
            +9506106058*r**4+22832230234*r**6+41381620606*r**8+52993576054*r**10
            +40964457418*r**12+22325774698*r**14+9069258379*r**16+1097522091*r**18
            +456046368*r**20)-2*Q2**5*(207136019+1744794560*r**2+13766488717*r**4
            +17509692392*r**6+9022906452*r**8-257452208*r**10-2727885268*r**12+5150068992*r**14
            +15624920617*r**16+13163847552*r**18+1683925303*r**20+221668872*r**22)
            +2*Q2**4*(-81841453+1959881643*r**2+14689627881*r**4+34306476905*r**6
            +52488341340*r**8+50743079916*r**10+37126711284*r**12+43371991068*r**14
            +45753554265*r**16+31776419305*r**18+14310907107*r**20+1952642043*r**22
            -72607304*r**24)+3*Q2**3*(89351563-240647580*r**2+387559846*r**4-10619410236*r**6
            -12999777375*r**8-12622927296*r**10-22641131820*r**12-21007448232*r**14
            -10207484163*r**16-11743449100*r**18-9957973242*r**20+401420900*r**22
            -260069289*r**24+90402024*r**26)+9*(-1+r**2)**2*(560611-43960883*r**2
            -448213644*r**4-879624572*r**6-4316389157*r**8-2710449267*r**10+2074996216*r**12
            +2328026808*r**14+1934413409*r**16-2713764801*r**18-4097525644*r**20
            -804360508*r**22-440983839*r**24-43850137*r**26+485408*r**28)-3*Q2**2*(31464947
            +714103191*r**2+8030295130*r**4+5990657602*r**6+42941631141*r**8+48691385681*r**10
            -3374013492*r**12-22681450980*r**14-2764574019*r**16+46943957113*r**18
            +40023702522*r**20+5334750626*r**22+7923720875*r**24+696811167*r**26
            +34518496*r**28)+9*Q2*(-187599+191200968*r**2+1771512303*r**4+1415295744*r**6
            +13032998581*r**8+4645762736*r**10-7849618581*r**12+7653684664*r**14
            +7295687747*r**16-7710264312*r**18+4756775965*r**20+12327911888*r**22
            +1177716183*r**24+1744646784*r**26+189151881*r**28+285048*r**30))+66355200*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(256000*Q2**17-5120*Q2**16*(2218+2225*r**2)
            +64*Q2**15*(1586169+3217996*r**2+1591347*r**4)-40*Q2**14*(10879723+33682750*r**2
            +33706651*r**4+10902952*r**6)+8*Q2**13*(137250985+586786369*r**2+898163801*r**4
            +586901387*r**6+137172170*r**8)-Q2**12*(1766884725+9885270396*r**2+20602868010*r**4
            +20593920412*r**6+9869113953*r**8+1757113320*r**10)+2*Q2**11*(934097865
            +6369943473*r**2+16155440986*r**4+21340108478*r**6+16101412929*r**8+6332364849*r**10
            +922264380*r**12)-2*Q2**10*(621206529+4299545427*r**2+8936598697*r**4
            +8658152258*r**6+8517396343*r**8+8728807951*r**10+4222860639*r**12+610929372*r**14)
            +10*Q2**9*(19863639-32716587*r**2-2662898367*r**4-10540100485*r**6-15900806731*r**8
            -10643506293*r**10-2734735465*r**12-47087643*r**14+21146076*r**16)+Q2**8*(942642965
            +6075007026*r**2+57804645104*r**4+221081191918*r**6+414742599730*r**8
            +415725313710*r**10+222422636296*r**12+58118096034*r**14+6050363073*r**16
            +901992080*r**18)-4*Q2**7*(414895675+1598349557*r**2+12796457300*r**4
            +45252511624*r**6+96703783596*r**8+125394307280*r**10+96708277572*r**12
            +45083288660*r**14+12540219389*r**16+1541022751*r**18+410767940*r**20)
            +4*Q2**6*(330110955+1684754447*r**2+12222111609*r**4+24924014342*r**6
            +36618378646*r**8+47058872226*r**10+45615074102*r**12+34220150554*r**14
            +23509976847*r**16+11665314011*r**18+1618746881*r**20+338857620*r**22)
            -4*Q2**5*(62647283+1955906111*r**2+15100455579*r**4+32791329007*r**6
            +39510470092*r**8+29754267080*r**10+17070686904*r**12+22897087396*r**14
            +33264271937*r**16+30282593737*r**18+14579339981*r**20+1929118109*r**22
            +74530784*r**24)-5*Q2**4*(86347519-895604624*r**2-6427267902*r**4-25970088056*r**6
            -42517793723*r**8-48866324880*r**10-48732595572*r**12-44803949880*r**14
            -41774708631*r**16-38058058888*r**18-24409714510*r**20-6264567120*r**22
            -908055469*r**24+83284136*r**26)+6*Q2**3*(60408255+281403587*r**2+4088603698*r**4
            -2120596394*r**6+9661221765*r**8+11534340505*r**10-19319036304*r**12
            -33165015516*r**14-16989753207*r**16+12496511925*r**18+9161140090*r**20
            -2110900858*r**22+4032536243*r**24+263571951*r**26+62460260*r**28)+9*(
            -1+r**2)**2*(560611-43400272*r**2-492174527*r**4-1327838216*r**6-5196013729*r**8
            -7026838424*r**10-635453051*r**12+4403023024*r**14+4262440217*r**16-779351392*r**18
            -6811290445*r**20-4901886152*r**22-1245344347*r**24-484833976*r**26-43364729*r**28
            +485408*r**30)-6*Q2**2*(15451075+659585521*r**2+7029467615*r**4+9133419982*r**6
            +44015642243*r**8+52785152515*r**10+10884258223*r**12-1547205240*r**14
            -1779480879*r**16+10524295079*r**18+50618993765*r**20+41171094406*r**22
            +8395810025*r**24+6927236197*r**26+649392653*r**28+17686820*r**30)-18*Q2*(374105
            -118047737*r**2-1161222269*r**4-1606983107*r**6-8726823991*r**8-6318028421*r**10
            +3191680719*r**12-2168240487*r**14-7798008201*r**16-1919994123*r**18
            +3108952857*r**20-6203880937*r**22-8217708269*r**24-1444302967*r**26
            -1143298411*r**28-117128941*r**30+100180*r**32))*sqrtq2)+logq2**3*(1105920*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-12666880*Q2**19+512*Q2**18*(313695
            +313676*r**2)-64*Q2**17*(14318585+29354974*r**2+14300709*r**4)+16*Q2**16*(187371625
            +607653066*r**2+607145465*r**4+186772216*r**6)-16*Q2**15*(368528175+1732508992*r**2
            +2690435014*r**4+1728660024*r**6+366527107*r**8)+Q2**14*(6344907065+43763401900*r**2
            +91102035250*r**4+90950133692*r**6+43578549365*r**8+6304304760*r**10)
            -2*Q2**13*(680025435+14098180803*r**2+26561373550*r**4+25049434274*r**6
            +26308954779*r**8+13988275035*r**10+698050908*r**12)-Q2**12*(5727515205
            +22150079082*r**2+175213040007*r**4+480229710268*r**6+480612033763*r**8
            +175499324618*r**10+21995296977*r**12+5548689552*r**14)+4*Q2**11*(1896089775
            +14888033493*r**2+116480613015*r**4+390841301661*r**6+574488543325*r**8
            +390496467335*r**10+115948614661*r**12+14659152135*r**14+1853350488*r**16)
            -Q2**10*(3172130375+52368923064*r**2+524676200448*r**4+2220790141976*r**6
            +4341270066358*r**8+4335264886560*r**10+2210623045848*r**12+518338392056*r**14
            +51005112363*r**16+3281534744*r**18)+2*Q2**9*(-699536745+14448319075*r**2
            +138903036900*r**4+622357446208*r**6+1306495524070*r**8+1580468024230*r**10
            +1290183095080*r**12+610438475560*r**14+135418900283*r**16+14089633935*r**18
            -524095940*r**20)+Q2**8*(2526250595-10423727174*r**2+59903502675*r**4
            +661539984696*r**6+3546121251406*r**8+8008111804300*r**10+8048311836694*r**12
            +3606644642520*r**14+684946040111*r**16+59732836266*r**18-11238591305*r**20
            +2320855296*r**22)-8*Q2**7*(207486065+1821876141*r**2+34162095601*r**4
            +158289708483*r**6+792777995108*r**8+2053657872438*r**10+2812130078694*r**12
            +2062395575394*r**14+795689623333*r**16+157863356333*r**18+33251808793*r**20
            +1607892811*r**22+222221846*r**24)+Q2**6*(395262675+32642008588*r**2
            +301350571210*r**4+593291599244*r**6+3395211085905*r**8+8317925378400*r**10
            +13903461124028*r**12+13917899649880*r**14+8291212339893*r**16+3301528261580*r**18
            +558005379450*r**20+297787849244*r**22+31835598375*r**24+589046728*r**26)
            +2*Q2**5*(287771075-10243836653*r**2-101401939766*r**4-376801896898*r**6
            -1751541743099*r**8-1256040858195*r**10-82250583768*r**12+79901672484*r**14
            +125632504269*r**16-1066651814003*r**18-1646716585870*r**20-354591159394*r**22
            -103913078933*r**24-10619178061*r**26+266566812*r**28)+Q2**4*(-626446695
            -2543642550*r**2+67320480575*r**4+1303569847892*r**6+5235181643945*r**8
            +7176637291830*r**10+6549175717335*r**12+6269191443720*r**14+5626735541091*r**16
            +5393894132790*r**18+6483268364565*r**20+5027223655540*r**22+1277820996955*r**24
            +72986567242*r**26-1512008235*r**28-678786000*r**30)+12*Q2**3*(8882005
            +732157639*r**2+3192447025*r**4-42952282429*r**6-66237614679*r**8-372358717165*r**10
            -343485267419*r**12-384487596465*r**14-538421930097*r**16-335489601787*r**18
            -299988334045*r**20-342262738279*r**22-60524767085*r**24-43357515999*r**26
            +3153101191*r**28+713566805*r**30+11330784*r**32)+9*(-1+r**2)**2*(1858225
            +20700088*r**2-877604068*r**4-16326529040*r**6-75940686960*r**8-43393408280*r**10
            -455316108964*r**12-241791230816*r**14+534380439130*r**16+511463942120*r**18
            -260542352140*r**20-436570424336*r**22-33722452264*r**24-74109876840*r**26
            -16032055660*r**28-901527680*r**30+16925837*r**32+1991648*r**34)+3*Q2**2*(52867305
            -1115941568*r**2-23142218228*r**4-185410325456*r**6-1207213820016*r**8
            -111701569976*r**10-3504644751572*r**12-3308716152512*r**14+1295905067562*r**16
            +1257964413432*r**18-3204100318588*r**20-3245771636752*r**22-41730605992*r**24
            -1190170694856*r**26-178610601916*r**28-23758347616*r**30-1207711483*r**32
            +53948232*r**34)-18*Q2*(5343175-895813*r**2-2184833280*r**4-30049593092*r**6
            -133811892840*r**8+43417474080*r**10-680783026716*r**12-175400589780*r**14
            +389677560686*r**16-44301508770*r**18+363922466740*r**20-194180688204*r**22
            -650388164800*r**24+57420787704*r**26-131073253140*r**28-29302150620*r**30
            -2238101517*r**32-11401265*r**34+5667452*r**36))-1105920*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(12666880*Q2**19-512*Q2**18*(313695+313676*r**2)
            +64*Q2**17*(14318585+29354974*r**2+14300709*r**4)-16*Q2**16*(187371625
            +607653066*r**2+607145465*r**4+186772216*r**6)+16*Q2**15*(368528175+1732508992*r**2
            +2690435014*r**4+1728660024*r**6+366527107*r**8)-Q2**14*(6344907065+43763401900*r**2
            +91102035250*r**4+90950133692*r**6+43578549365*r**8+6304304760*r**10)
            +2*Q2**13*(680025435+14098180803*r**2+26561373550*r**4+25049434274*r**6
            +26308954779*r**8+13988275035*r**10+698050908*r**12)+Q2**12*(5727515205
            +22150079082*r**2+175213040007*r**4+480229710268*r**6+480612033763*r**8
            +175499324618*r**10+21995296977*r**12+5548689552*r**14)-4*Q2**11*(1896089775
            +14888033493*r**2+116480613015*r**4+390841301661*r**6+574488543325*r**8
            +390496467335*r**10+115948614661*r**12+14659152135*r**14+1853350488*r**16)
            +Q2**10*(3172130375+52368923064*r**2+524676200448*r**4+2220790141976*r**6
            +4341270066358*r**8+4335264886560*r**10+2210623045848*r**12+518338392056*r**14
            +51005112363*r**16+3281534744*r**18)+2*Q2**9*(699536745-14448319075*r**2
            -138903036900*r**4-622357446208*r**6-1306495524070*r**8-1580468024230*r**10
            -1290183095080*r**12-610438475560*r**14-135418900283*r**16-14089633935*r**18
            +524095940*r**20)-Q2**8*(2526250595-10423727174*r**2+59903502675*r**4
            +661539984696*r**6+3546121251406*r**8+8008111804300*r**10+8048311836694*r**12
            +3606644642520*r**14+684946040111*r**16+59732836266*r**18-11238591305*r**20
            +2320855296*r**22)+8*Q2**7*(207486065+1821876141*r**2+34162095601*r**4
            +158289708483*r**6+792777995108*r**8+2053657872438*r**10+2812130078694*r**12
            +2062395575394*r**14+795689623333*r**16+157863356333*r**18+33251808793*r**20
            +1607892811*r**22+222221846*r**24)-Q2**6*(395262675+32642008588*r**2
            +301350571210*r**4+593291599244*r**6+3395211085905*r**8+8317925378400*r**10
            +13903461124028*r**12+13917899649880*r**14+8291212339893*r**16+3301528261580*r**18
            +558005379450*r**20+297787849244*r**22+31835598375*r**24+589046728*r**26)
            +Q2**5*(-575542150+20487673306*r**2+202803879532*r**4+753603793796*r**6
            +3503083486198*r**8+2512081716390*r**10+164501167536*r**12-159803344968*r**14
            -251265008538*r**16+2133303628006*r**18+3293433171740*r**20+709182318788*r**22
            +207826157866*r**24+21238356122*r**26-533133624*r**28)+Q2**4*(626446695
            +2543642550*r**2-67320480575*r**4-1303569847892*r**6-5235181643945*r**8
            -7176637291830*r**10-6549175717335*r**12-6269191443720*r**14-5626735541091*r**16
            -5393894132790*r**18-6483268364565*r**20-5027223655540*r**22-1277820996955*r**24
            -72986567242*r**26+1512008235*r**28+678786000*r**30)-12*Q2**3*(8882005
            +732157639*r**2+3192447025*r**4-42952282429*r**6-66237614679*r**8-372358717165*r**10
            -343485267419*r**12-384487596465*r**14-538421930097*r**16-335489601787*r**18
            -299988334045*r**20-342262738279*r**22-60524767085*r**24-43357515999*r**26
            +3153101191*r**28+713566805*r**30+11330784*r**32)+3*Q2**2*(-52867305
            +1115941568*r**2+23142218228*r**4+185410325456*r**6+1207213820016*r**8
            +111701569976*r**10+3504644751572*r**12+3308716152512*r**14-1295905067562*r**16
            -1257964413432*r**18+3204100318588*r**20+3245771636752*r**22+41730605992*r**24
            +1190170694856*r**26+178610601916*r**28+23758347616*r**30+1207711483*r**32
            -53948232*r**34)-9*(-1+r**2)**2*(1858225+20700088*r**2-877604068*r**4
            -16326529040*r**6-75940686960*r**8-43393408280*r**10-455316108964*r**12
            -241791230816*r**14+534380439130*r**16+511463942120*r**18-260542352140*r**20
            -436570424336*r**22-33722452264*r**24-74109876840*r**26-16032055660*r**28
            -901527680*r**30+16925837*r**32+1991648*r**34)+18*Q2*(5343175-895813*r**2
            -2184833280*r**4-30049593092*r**6-133811892840*r**8+43417474080*r**10
            -680783026716*r**12-175400589780*r**14+389677560686*r**16-44301508770*r**18
            +363922466740*r**20-194180688204*r**22-650388164800*r**24+57420787704*r**26
            -131073253140*r**28-29302150620*r**30-2238101517*r**32-11401265*r**34
            +5667452*r**36))*sqrtq2)+logq2**2*(-18432*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(57817088*Q2**22-512*Q2**21*(1373233+1370858*r**2)+32*Q2**20*(114045429
            +239112202*r**2+113716629*r**4)-160*Q2**19*(63987193+220392098*r**2+220132521*r**4
            +63790480*r**6)+40*Q2**18*(387286504+2155880811*r**2+3362355261*r**4
            +2152277073*r**6+387086231*r**8)-Q2**17*(7741564827+105742530200*r**2
            +203572663830*r**4+203454427740*r**6+105729310415*r**8+7929970572*r**10)
            -Q2**16*(13765758751-4932594549*r**2+203156544970*r**4+474912956370*r**6
            +202037958615*r**8-6016558109*r**10+13264948096*r**12)+2*Q2**15*(13224782459
            +98028752297*r**2+730211036019*r**4+1984916615210*r**6+1982466818845*r**8
            +726434659509*r**10+96353468437*r**12+13012240024*r**14)-10*Q2**14*(1206171141
            +30689914566*r**2+266534089392*r**4+991137919329*r**6+1487310582145*r**8
            +988436313972*r**10+264707473026*r**12+30209993637*r**14+1245653640*r**16)
            -10*Q2**13*(1186834703-17324217803*r**2-185076326668*r**4-1086209475285*r**6
            -2247358858364*r**8-2243224838309*r**10-1080725931984*r**12-183657798203*r**14
            -17150481079*r**16+1069108352*r**18)+2*Q2**12*(8562684889+45853864850*r**2
            +480402460695*r**4-191127042735*r**6-1003772335*r**8+1596674375781*r**10
            +38431207645*r**12-180675379365*r**14+468984602010*r**16+42880110685*r**18
            +8195919944*r**20)-2*Q2**11*(2631239073+110522739223*r**2+1349300010795*r**4
            +6454106869440*r**6+26357275624730*r**8+58385226530862*r**10+58387329738222*r**12
            +26313751609040*r**14+6393585291045*r**16+1321395405315*r**18+105451808263*r**20
            +2895043368*r**22)+2*Q2**10*(-2374955461+65079307942*r**2+875781150234*r**4
            +7794783489575*r**6+43033895032870*r**8+125502763431076*r**10+179202230740588*r**12
            +125253365278726*r**14+42720512822935*r**16+7650990536750*r**18+865309664914*r**20
            +63590003547*r**22-1901187856*r**24)+10*Q2**9*(622676546+1460652411*r**2
            -29616877908*r**4-947051755077*r**6-5927538481240*r**8-21166359667134*r**10
            -39688417731456*r**12-39583307697402*r**14-20984557356942*r**16-5815798310705*r**18
            -917221742412*r**20-34862583969*r**22+621384132*r**24+602964820*r**26)
            -10*Q2**8*(286106142+6623789413*r**2+11662714593*r**4-285369954279*r**6
            +316892989985*r**8+3118283311872*r**10+10943557759914*r**12+17179880926122*r**14
            +11286063535248*r**16+3371734590069*r**18+378768565661*r**20-282532474755*r**22
            +5216675313*r**24+5712879334*r**26+329036568*r**28)+2*Q2**7*(-624885151
            +22767209475*r**2+198269604605*r**4+1428833475330*r**6+20461003382305*r**8
            +84141434697921*r**10+279365075352085*r**12+520408571568340*r**14+521841734444075*r**16
            +280992514896325*r**18+84562909189231*r**20+20197323637410*r**22+1262639809875*r**24
            +193384228215*r**26+22810674815*r**28-488974456*r**30)+2*Q2**6*(1247144677
            -7182120098*r**2-337565900580*r**4-3139517616815*r**6-18193415435705*r**8
            -33306475535532*r**10-163054144866542*r**12-357274145699405*r**14-473684267249205*r**16
            -358446749938210*r**18-161393872348312*r**20-32131371436857*r**22-17906936414815*r**24
            -2972525480080*r**26-351283527510*r**28-9777601483*r**30+1279642472*r**32)
            -6*Q2**5*(126435887+1465524401*r**2-48285910448*r**4-835776649365*r**6
            -4170241932250*r**8-6896500478487*r**10-33904010651596*r**12-11711508501717*r**14
            +1361043026040*r**16+2187381702955*r**18-9616612954712*r**20-31472591216791*r**22
            -6028444311582*r**24-4220879059925*r**26-841904705580*r**28-51613592063*r**30
            +1092737361*r**32+143737872*r**34)-10*Q2**4*(62650317-1496513098*r**2
            -20887838261*r**4+150745670289*r**6+1915562946315*r**8+14124531121629*r**10
            +39732434845383*r**12+25898097221581*r**14+15861412802897*r**16+27294036338085*r**18
            +11669445004201*r**20+22115693639603*r**22+37797858496521*r**24+13603029645639*r**26
            +1950154068525*r**28+175092753903*r**30-20490917938*r**32-1600766591*r**34
            +61551000*r**36)+30*Q2**3*(14252443-178291003*r**2-6354980123*r**4-26205222452*r**6
            +113222052724*r**8+2860651915176*r**10+2895968820500*r**12+7454481567028*r**14
            +6732000750290*r**16+12187195058554*r**18+11559462224694*r**20+5674459777964*r**22
            +6545881369748*r**24+2602659094016*r**26+2831622719940*r**28+108311227612*r**30
            -22772460661*r**32-6419824103*r**34-209448179*r**36+14835832*r**38)+9*(
            -1+r**2)**2*(1931747-51403885*r**2-1141266025*r**4+12212543695*r**6+236122607020*r**8
            +2016148035532*r**10+4920957098380*r**12-4132553048900*r**14+39852071452090*r**16
            +456907520490*r**18-65645238765678*r**20+2935899022770*r**22+39113950851500*r**24
            -4835406923140*r**26+4808346538460*r**28+1962773929772*r**30+233794150235*r**32
            +13359599675*r**34-1118080145*r**36-55370345*r**38+1976752*r**40)+6*Q2**2*(4657523
            -432644950*r**2-160494670*r**4+201424186675*r**6+1740868842100*r**8+8012690537428*r**10
            +45935932816540*r**12-26292974854400*r**14+78584733229990*r**16+60437298161640*r**18
            -25925620153632*r**20+58023589620270*r**22+71506991877560*r**24-27925097915380*r**26
            +45607839680420*r**28+7543433468888*r**30+1759921040015*r**32+209289626510*r**34
            +242060590*r**36-432009785*r**38+3866668*r**40)-9*Q2*(8984129-266392946*r**2
            -4215711830*r**4+70951506930*r**6+924214231085*r**8+6476131428644*r**10
            +17229536303864*r**12-29497595920360*r**14+107714829722210*r**16+13995662855620*r**18
            -75055808963556*r**20-70312139497716*r**22+19048059782210*r**24+104293316169040*r**26
            -31340634290120*r**28+17016414216664*r**30+6241328582749*r**32+916363031230*r**34
            +76118370570*r**36-4070249710*r**38-283659631*r**40+9100924*r**42))+18432*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(57817088*Q2**23-512*Q2**22*(1486157
            +1483782*r**2)+32*Q2**21*(136017157+283017658*r**2+135650357*r**4)-32*Q2**20*(433981394
            +1455118121*r**2+1453491436*r**4+432669029*r**6)+40*Q2**19*(643235276
            +3293397975*r**2+5124453737*r**4+3287969077*r**6+642248151*r**8)-Q2**18*(23233024987
            +207469222800*r**2+424302106710*r**4+424039721100*r**6+207303842575*r**8
            +23413419812*r**10)-4*Q2**17*(1506048481-29604172394*r**2-26539662265*r**4
            +16971466200*r**6-26786444885*r**8-29918959774*r**10+1333744381*r**12)
            +Q2**16*(40215323669+204890668796*r**2+1658646022459*r**4+4647902731760*r**6
            +4641884552675*r**8+1648890719524*r**10+199955326861*r**12+39289428144*r**14)
            -4*Q2**15*(9627819082+132351553793*r**2+1080455117638*r**4+3835408623937*r**6
            +5701968172390*r**8+3825541524107*r**10+1073162746538*r**12+130207838323*r**14
            +9620254112*r**16)+20*Q2**14*(9668219+24610151755*r**2+241150165313*r**4
            +1171940742003*r**6+2362903679919*r**8+2359485867213*r**10+1166934859491*r**12
            +239287632433*r**14+24303064178*r**16+88272644*r**18)+4*Q2**13*(7248429202
            -17416525325*r**2-265800130830*r**4-3273778026250*r**6-8334422720290*r**8
            -10428122053792*r**10-8290661321910*r**12-3251297015150*r**14-267528397200*r**16
            -18763376475*r**18+6770730852*r**20)-4*Q2**12*(5596961981+82469644481*r**2
            +937778168170*r**4+3371691143700*r**6+13082572404830*r**8+29990448567154*r**10
            +30011217660824*r**12+13085753718660*r**14+3340947256845*r**16+916630059005*r**18
            +78263919446*r**20+5545481656*r**22)+4*Q2**11*(128141806+89116643119*r**2
            +1167801950126*r**4+7799095184905*r**6+37922638763520*r**8+105122632793334*r**10
            +147987393504836*r**12+104977223312994*r**14+37713924861510*r**16+7682985616555*r**18
            +1146078439246*r**20+85968427589*r**22+496927756*r**24)+2*Q2**10*(5488338191
            -55401090426*r**2-1088944847716*r**4-13405823415194*r**6-80466370928645*r**8
            -274368456799616*r**10-503147082828944*r**12-502372134506324*r**14-272896664886371*r**16
            -79450494913210*r**18-13102408913724*r**20-1103212588306*r**22-58581895031*r**24
            +4916011956*r**26)-20*Q2**9*(454391344+4353559185*r**2-8246755452*r**4
            -631019293632*r**6-3278848623166*r**8-11987807418251*r**10-24955609819338*r**12
            -31045922251368*r**14-24640900759548*r**16-11714310538789*r**18-3177125743728*r**20
            -617308400568*r**22-14512262262*r**24+3468614143*r**26+466000694*r**28)
            +2*Q2**8*(805645559+57316687250*r**2+289702124635*r**4+60297276900*r**6
            +20618618560835*r**8+101317316207206*r**10+349674280711015*r**12+661025764998520*r**14
            +664171456750925*r**16+354281505522910*r**18+103315424967881*r**20+20678504091940*r**22
            -123939187335*r**24+248032001450*r**26+53020254325*r**28+1156208384*r**30)
            +4*Q2**7*(936014914-14662222211*r**2-279301357330*r**4-2383310348375*r**6
            -20041626146670*r**8-68954456807879*r**10-263280327458274*r**12-578523896309915*r**14
            -757967286630810*r**16-580640499639305*r**18-263474648216934*r**20-68445802131749*r**22
            -19683449931050*r**24-2214274759085*r**26-283739215270*r**28-16049650921*r**30
            +884308464*r**32)+4*Q2**6*(-813226169+769201109*r**2+244802876011*r**4
            +2992206732745*r**6+16921829424635*r**8+36094696203349*r**10+149036326178431*r**12
            +277731408035549*r**14+413437641935245*r**16+412784436039275*r**18+274345230575329*r**20
            +143971508717771*r**22+34061820393209*r**24+16771049537335*r**26+2924761562165*r**28
            +257950952591*r**30+2609873464*r**32-855428044*r**34)+4*Q2**5*(33028038
            +6129223177*r**2-18010983418*r**4-1702958015442*r**6-12297935238210*r**8
            -51911441420178*r**10-160531853808582*r**12-133168521783922*r**14-55179230220758*r**16
            -62912453751720*r**18-40317459388138*r**20-116923040356262*r**22-150746199533862*r**24
            -49381559171358*r**26-12469560819570*r**28-1778009331222*r**30-24553987208*r**32
            +5856629327*r**34+61729308*r**36)+20*Q2**4*(52703823-984367895*r**2-20724645864*r**4
            +25621082336*r**6+1202987387388*r**8+12311024906736*r**10+31272436214256*r**12
            +43996988384024*r**14+30977756137674*r**16+39858517158322*r**18+36820934008184*r**20
            +25404258988848*r**22+39775598122684*r**24+29604432712104*r**26+12024025936992*r**28
            +1225090252632*r**30+43142226991*r**32-20675578419*r**34-1083780064*r**36
            +53029248*r**38)-12*Q2**3*(33302346-193773925*r**2-16252930480*r**4-182112599775*r**6
            -652892345370*r**8+3428339651036*r**10-8576414569080*r**12+39022613396020*r**14
            -3826160821700*r**16+17079340441290*r**18+72329453284936*r**20+14073010196510*r**22
            -5202643069500*r**24+36833900117100*r**26-9218215305320*r**28+3578118134436*r**30
            -666113602630*r**32-177625525165*r**34-16694211000*r**36-270525975*r**38
            +35156246*r**40)-9*(-1+r**2)**2*(1931747-49472138*r**2-1192669910*r**4
            +11071277670*r**6+248335150715*r**8+2252270642552*r**10+6937105133912*r**12
            +788404049480*r**14+35719518403190*r**16+40308978972580*r**18-65188331245188*r**20
            -62709339742908*r**22+42049849874270*r**24+34278543928360*r**26-27060384680*r**28
            +6771120468232*r**30+2196568080007*r**32+247153749910*r**34+12241519530*r**36
            -1173450490*r**38-53393593*r**40+1976752*r**42)-3*Q2**2*(36267433-1655153692*r**2
            -13833414730*r**4+615381904800*r**6+6657228750805*r**8+38935513044988*r**10
            +159585855619528*r**12-49206871836800*r**14+427728005917810*r**16+320031051350120*r**18
            -156144070874652*r**20-146740479559872*r**22+316205342342290*r**24+400043736431480*r**26
            -58656419340280*r**28+157351788948608*r**30+37330694766053*r**32+6687510426740*r**34
            +647418485910*r**36-12590647520*r**38-1707265127*r**40+35036108*r**42)
            +36*Q2*(2728969-78169049*r**2-1379657821*r**4+20294866740*r**6+301430497905*r**8
            +2239115256229*r**10+6207612841711*r**12-6056594706656*r**14+32813842112530*r**16
            +9582676036310*r**18-21941782115626*r**20-2671166096664*r**22-20916791418806*r**24
            +10803491586970*r**26+31636448278790*r**28-6703386535936*r**30+6093583907141*r**32
            +2166559210739*r**34+299609568135*r**36+21897127620*r**38-1339818011*r**40
            -83470639*r**42+2769419*r**44))*sqrtq2)+logq2*(1536*r**8*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7
            +2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(-571136*Q2**21+32*Q2**20*(256075+257521*r**2)-8*Q2**19*(5965489
            +13694493*r**2+6024812*r**4)+24*Q2**18*(6070287+22671111*r**2+22754261*r**4
            +6158721*r**6)-Q2**17*(233280527+1225234025*r**2+1501326773*r**4+1236380231*r**6
            +238558956*r**8)+Q2**16*(109498687+713848484*r**2-2951631810*r**4-2923102188*r**6
            +747440451*r**8+116882888*r**10)+Q2**15*(267989688+2549002378*r**2+25257192606*r**4
            +48557961694*r**6+25127460466*r**8+2483293560*r**10+264172056*r**12)
            -2*Q2**14*(241965682+3060062039*r**2+28863872726*r**4+84760185298*r**6
            +84651840346*r**8+28744799267*r**10+3023952574*r**12+244798356*r**14)
            +2*Q2**13*(67649018+2335517639*r**2+26906931239*r**4+130500570776*r**6
            +196873242992*r**8+130317623059*r**10+26933780059*r**12+2338384974*r**14
            +74201044*r**16)+2*Q2**12*(201193928+630513625*r**2+4931923782*r**4-51230637209*r**6
            -67119489364*r**8-67156402461*r**10-51618542042*r**12+4422945937*r**14
            +558725664*r**16+196100684*r**18)-2*Q2**11*(200348460+2225094911*r**2
            +36358195425*r**4+149300741531*r**6+617076046013*r**8+1049332909513*r**10
            +614983191407*r**12+147117970825*r**14+35525343363*r**16+2141370324*r**18
            +200638724*r**20)+Q2**10*(-71768164+2276914794*r**2+69780350212*r**4
            +569460154872*r**6+2756577054344*r**8+6540131919892*r**10+6530801196488*r**12
            +2740225568304*r**14+560369902332*r**16+69264991922*r**18+2295808020*r**20
            -63853400*r**22)+2*Q2**9*(152525607+254394294*r**2-11753576754*r**4-204801540729*r**6
            -1061682343618*r**8-3498377554212*r**10-5113228308964*r**12-3482085008866*r**14
            -1049909258109*r**16-200088138978*r**18-12602915898*r**20+152420139*r**22
            +149748456*r**24)-2*Q2**8*(51970493+558933599*r**2+6828082724*r**4-5919703117*r**6
            +252422728879*r**8+136414263394*r**10+132430567016*r**12+151124592486*r**14
            +155345753515*r**16+253084774979*r**18-5813349580*r**20+5645283239*r**22
            +484105769*r**24+52522044*r**26)+2*Q2**7*(-51247628+463513775*r**2+13522424133*r**4
            +100144980777*r**6+919348917487*r**8+2663322626266*r**10+6534844395414*r**12
            +9606231892642*r**14+6561339012450*r**16+2663646796115*r**18+905884473665*r**20
            +94411294389*r**22+13115361723*r**24+478581156*r**26-49318684*r**28)
            +2*Q2**6*(40890474-268312229*r**2-9443551410*r**4-80288095106*r**6-539054907138*r**8
            -1177492279407*r**10-4102064199094*r**12-7960248390440*r**14-7984701853002*r**16
            -4082456058691*r**18-1140549451470*r**20-534581376762*r**22-75101081630*r**24
            -9880661417*r**26-312280266*r**28+39956388*r**30)+2*Q2**5*(2706082-82986655*r**2
            -136910071*r**4+53879923912*r**6+307271212812*r**8+606534150427*r**10
            +2063401233691*r**12-236971998386*r**14+817778925246*r**16-279657262601*r**18
            +1920576156191*r**20+511215184732*r**22+320064726472*r**24+54846697357*r**26
            +416503229*r**28-71012210*r**30+2496972*r**32)-2*Q2**4*(12004844-221759467*r**2
            -4617721978*r**4+43047991223*r**6+341180512036*r**8+1823710610921*r**10
            +4442804949722*r**12-581215339857*r**14+1900039223384*r**16+1656589008763*r**18
            -858370311494*r**20+4239768369277*r**22+1714350963508*r**24+349326581243*r**26
            +46977245926*r**28-4415046371*r**30-231653532*r**32+11635852*r**34)+2*Q2**3*(2898656
            -74330497*r**2-2078046147*r**4+4799209955*r**6+64949476437*r**8+1058725062435*r**10
            +1079697660877*r**12+21001137247*r**14+1732499841033*r**16+5178301708901*r**18
            +1496997639667*r**20-214339395303*r**22+982703042287*r**24+1039762315089*r**26
            +60942561087*r**28+6364362917*r**30-2139807277*r**32-79994712*r**34+2801348*r**36)
            +3*(-1+r**2)**2*(72929-4007320*r**2-96810211*r**4+2677475768*r**6+22687094444*r**8
            +129876602968*r**10+464209173740*r**12-1699769527672*r**14+5748220541846*r**16
            -4387223148312*r**18-4147179742098*r**20+5749253743480*r**22-1771653076148*r**24
            +472506586504*r**26+122918989292*r**28+22457191576*r**30+2782414225*r**32
            -93399344*r**34-4166243*r**36+70576*r**38)+2*Q2**2*(1315526-41461325*r**2
            -568302966*r**4+26372970860*r**6+192893165080*r**8+500827977720*r**10
            +3466197640528*r**12-4340461749604*r**14+5106488293188*r**16+1567488498518*r**18
            +1580713398532*r**20+4680238119444*r**22-4463588250344*r**24+3511176765344*r**26
            +438412211424*r**28+196154501972*r**30+27089697478*r**32-475724961*r**34
            -42270142*r**36+1283728*r**38)-3*Q2*(509693-22033807*r**2-428918035*r**4
            +12994682221*r**6+90071896408*r**8+387089669116*r**10+1544778851596*r**12
            -5623703949620*r**14+13070269935742*r**16-3852984011034*r**18-8614274104626*r**20
            -3228313228146*r**22+12903550080020*r**24-5813624247172*r**26+1592430991244*r**28
            +355866672332*r**30+89531897357*r**32+13456078385*r**34-404126291*r**36
            -22820243*r**38+494860*r**40))-1536*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(4569088*Q2**25-1536*Q2**24*(45282+45523*r**2)+32*Q2**23*(13598567
            +31019854*r**2+13727335*r**4)-8*Q2**22*(180061035+678920486*r**2+681383403*r**4
            +182558224*r**6)+8*Q2**21*(316139407+1772586094*r**2+2446378592*r**4
            +1787662434*r**6+322842337*r**8)-Q2**20*(1370556433+13329795344*r**2
            -5892728894*r**4-5577385244*r**6+13717358189*r**8+1450437196*r**10)-4*Q2**19*(826069828
            +5309763777*r**2+56050956025*r**4+110910647270*r**6+55684786890*r**8
            +5112474393*r**10+815985337*r**12)+2*Q2**18*(3388325227+36960926544*r**2
            +326906787645*r**4+979894902110*r**6+978657780885*r**8+325435418212*r**10
            +36510098499*r**12+3428203630*r**14)-4*Q2**17*(555657625+17734950472*r**2
            +195145830126*r**4+962894495418*r**6+1497440029450*r**8+961738092980*r**10
            +195083451102*r**12+17754370826*r**14+600040273*r**16)+Q2**16*(-6792001269
            -14662838648*r**2+22146336076*r**4+2771198819952*r**6+5832117040726*r**8
            +5833726566136*r**10+2781394786132*r**12+33691382896*r**14-12584991873*r**16
            -6669138144*r**18)+16*Q2**15*(476075102+5354454511*r**2+68126020274*r**4
            +221308940164*r**6+815447072531*r**8+1420767992922*r**10+811534297551*r**12
            +217268990964*r**14+66690674619*r**16+5181403071*r**18+479419859*r**20)
            +8*Q2**14*(203985231-6957765776*r**2-156528810075*r**4-1299830972370*r**6
            -5925089302260*r**8-14190704023726*r**10-14172160058384*r**12-5893311961600*r**14
            -1281950911595*r**16-155125459190*r**18-6958652709*r**20+183859814*r**22)
            -16*Q2**13*(460045186+1113693002*r**2-17983496535*r**4-578060628290*r**6
            -3388350975640*r**8-11931538311476*r**10-17789610396822*r**12-11897443529170*r**14
            -3363801093900*r**16-569016490890*r**18-19432868479*r**20+887425032*r**22
            +454606350*r**24)+2*Q2**12*(1229718215+21983267696*r**2+313290950578*r**4
            +90398332884*r**6-2325703892795*r**8-47594810425340*r**10-109714640093636*r**12
            -109422275491808*r**14-47288635896919*r**16-2324672832640*r**18+70091311970*r**20
            +292704736876*r**22+20450292603*r**24+1258542764*r**26)+8*Q2**11*(455641112
            -3211906871*r**2-87691981393*r**4-899003116486*r**6-6135210139548*r**8
            -17313739156337*r**10-42511754136749*r**12-64203860603052*r**14-42552750342624*r**16
            -17234514749417*r**18-6045419670683*r**20-862791932926*r**22-85579377388*r**24
            -3329402111*r**26+443207657*r**28)+4*Q2**10*(-699787607+285712584*r**2
            +54060966271*r**4+1327183574066*r**6+11685508171069*r**8+66330110933696*r**10
            +244166288516611*r**12+508299467121454*r**14+508046501285699*r**16+243236108218136*r**18
            +65508259689925*r**20+11529275596414*r**22+1263708658391*r**24+59188964256*r**26
            +959594169*r**28-693000734*r**30)-8*Q2**9*(98953519-2005924944*r**2-28941342000*r**4
            +111105343730*r**6+2113923042220*r**8+24852843642036*r**10+114654120666304*r**12
            +313053128696250*r**14+445738284805270*r**16+312031925778600*r**18+113343210010816*r**20
            +24150638062774*r**22+2154977468900*r**24+123746457780*r**26-25372277840*r**28
            -1915450146*r**30+94297771*r**32)+2*Q2**8*(710869007-7883679256*r**2
            -148372186560*r**4-127508589720*r**6+1627233191680*r**8+30064474896888*r**10
            +46176125790776*r**12+170140948886000*r**14+407361882882710*r**16+401089159135920*r**18
            +161391361060528*r**20+41549846295496*r**22+28313041694840*r**24+1978521257720*r**26
            +26776651480*r**28-144550541088*r**30-8415578141*r**32+695782520*r**34)
            -16*Q2**7*(7151140-10998527*r**2-4375187006*r**4-48220285728*r**6-346349703405*r**8
            -2867116082500*r**10-34307047763533*r**12-107193438932584*r**14-245335756456257*r**16
            -333726452169290*r**18-246820098796045*r**20-108086650389328*r**22-34236181060359*r**24
            -2639979196452*r**26-329836587335*r**28-40382825000*r**30-5027766767*r**32
            -53284431*r**34+7287007*r**36)-16*Q2**6*(25632149-533573867*r**2-5953801726*r**4
            +112446336373*r**6+862775230159*r**8+5071493969221*r**10+26412887731047*r**12
            +46543064647446*r**14+191642056981077*r**16+336341351622361*r**18+337367697772311*r**20
            +191289984049102*r**22+45958536654341*r**24+26331676414427*r**26+4652393920901*r**28
            +863111597694*r**30+119051338818*r**32-5363894286*r**34-544137477*r**36
            +24933929*r**38)+8*Q2**5*(15877969-442589978*r**2-8258898862*r**4+118000852578*r**6
            +1024986410327*r**8+8967014702280*r**10+25603959328208*r**12-1140144167668*r**14
            +164903301380662*r**16+15347993959148*r**18+1547952536076*r**20+16060921094968*r**22
            +155146698859602*r**24-7921713829448*r**26+26252760282288*r**28+8839674481252*r**30
            +1034136482377*r**32+130845288878*r**34-8196741342*r**36-471836938*r**38
            +15487623*r**40)+Q2**4*(60600643-1735707408*r**2-4268140050*r**4+637594180380*r**6
            +853502815275*r**8-48849346714332*r**10-251745582722648*r**12-1215039137160000*r**14
            -2790451190885130*r**16+63263234329760*r**18-593290392907212*r**20-470317985892648*r**22
            +213957585701950*r**24-2666320677205080*r**26-1142345362058520*r**28-249591805305952*r**30
            -52526347569753*r**32+638352435600*r**34+633007402830*r**36-1317229140*r**38
            -1727181897*r**40+58893332*r**42)-12*Q2**3*(2871428-117095469*r**2-1294461025*r**4
            +55014470410*r**6+166769012010*r**8-619786397057*r**10-9910287663329*r**12
            -87614052963960*r**14-33853751335040*r**16-28419500667210*r**18-132282619960482*r**20
            -321645997213524*r**22-116930254576420*r**24-11704236812250*r**26-27663474633610*r**28
            -86378995491352*r**30-9229734907764*r**32-769004634505*r**34+153390854755*r**36
            +56965614810*r**38-1192704662*r**40-120570789*r**42+2785035*r**44)-9*(
            -1+r**2)**2*(72929-5028326*r**2-47563057*r**4+4408485796*r**6-5641231065*r**8
            -438074105806*r**10-3524231616511*r**12-20722040485472*r**14-15886253749414*r**16
            +68546973037620*r**18-458797804038106*r**20+394033888960664*r**22+374743034890558*r**24
            -461480908993484*r**26+75406483785330*r**28-15561630980336*r**30-20252748548491*r**32
            -3398382470222*r**34-451725205349*r**36-7658671260*r**38+4480643819*r**40
            -41706086*r**42-5154307*r**44+70576*r**46)-6*Q2**2*(295735-3808992*r**2
            +482846129*r**4+1165668742*r**6-107211905235*r**8-3848142486100*r**10
            -17278780422117*r**12-53776808390946*r**14-391191830157978*r**16+496282840759600*r**18
            -350238707461590*r**20-422977520167252*r**22-410087995854566*r**24-298612652725848*r**26
            +506158085312630*r**28-396003992873460*r**30-47772347557677*r**32-17354552725296*r**34
            -3957789989963*r**36-112230296370*r**38+28206665*r**40+526139788*r**42
            -2700321*r**44+294422*r**46)+36*Q2*(109191-6053528*r**2-31128994*r**4
            +4293695262*r**6-9473881854*r**8-488849680164*r**10-2901257987658*r**12
            -14736605055954*r**14-23354567315223*r**16+104039529270816*r**18-299641132116004*r**20
            +48097191519292*r**22+297551292549276*r**24+32058491367272*r**26-296151520213124*r**28
            +109179305908236*r**30-23980878679623*r**32-14148281623464*r**34-2793283754298*r**36
            -505028555034*r**38-11414863134*r**40+4326140892*r**42-23192114*r**44
            -6166138*r**46+106071*r**48))*sqrtq2))*math.log(r))/(378000*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2
            +378000*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2
            +logq2**7*(-3047495270400000*r**32*(1+r**2)**2*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3-3047495270400000*r**32*(1+r**2)**2*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**6*(16930529280000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))+16930529280000*r**28*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))*sqrtq2)+logq2*(-22680000*(-Q2
            +(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(9+8*Q2**4-78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)
            -Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-22680000*(-Q2+(-1+r)**2)**3*r**8*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(9+8*Q2**4-78*r**2-366*r**4
            -78*r**6+9*r**8-Q2**3*(1+r**2)-Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1
            +13*r**2+13*r**4+r**6))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*sqrtq2)+logq2**2*(272160000*(-Q2+(-1+r)**2)**3*r**12*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531
            +550*r**2+531*r**4)-2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815
            -2120*r**2-11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4
            +494*r**6+225*r**8+r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6
            +26793*r**8+4554*r**10-501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6
            -1385*r**8-311*r**10+15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6
            +34670*r**8+13388*r**10-184*r**12-316*r**14+17*r**16))+272160000*(
            -Q2+(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531+550*r**2+531*r**4)
            -2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815-2120*r**2-11502*r**4
            -2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4+494*r**6+225*r**8
            +r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6+26793*r**8+4554*r**10
            -501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6-1385*r**8-311*r**10
            +15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6+34670*r**8+13388*r**10
            -184*r**12-316*r**14+17*r**16))*sqrtq2)+logq2**3*(-3265920000*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8+256*Q2**7*(1+r**2)
            -Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2+893*r**4+319*r**6)
            +Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)+12*Q2**3*(61
            +235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(-1071+9654*r**2
            +51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)-18*Q2*(23
            -35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12+23*r**14)
            +9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10-264*r**12
            -756*r**14+47*r**16))-3265920000*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8
            +256*Q2**7*(1+r**2)-Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2
            +893*r**4+319*r**6)+Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)
            +12*Q2**3*(61+235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(
            -1071+9654*r**2+51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)
            -18*Q2*(23-35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12
            +23*r**14)+9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10
            -264*r**12-756*r**14+47*r**16))*sqrtq2)+logq2**4*(39191040000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513+770*r**2
            +513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105-3400*r**2
            -11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4-1178*r**6
            +75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6+19593*r**8
            +3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6-5785*r**8
            -2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4+25204*r**6
            +52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))+39191040000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513
            +770*r**2+513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105
            -3400*r**2-11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4
            -1178*r**6+75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6
            +19593*r**8+3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6
            -5785*r**8-2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4
            +25204*r**6+52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))*sqrtq2)
            +logq2**5*(-94058496000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(64*Q2**8+1088*Q2**7*(1+r**2)+Q2**6*(-63+130*r**2-63*r**4)
            -2*Q2**5*(2777+6379*r**2+6379*r**4+2777*r**6)+Q2**4*(1555-8080*r**2
            -22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743-315*r**2-6548*r**4-6548*r**6
            -315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2+199629*r**4+305844*r**6
            +199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83-375*r**2-2833*r**4
            -5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)+9*(301-4028*r**2
            +808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12-4028*r**14+301*r**16))
            -94058496000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(64*Q2**8+1088*Q2**7*(1
            +r**2)+Q2**6*(-63+130*r**2-63*r**4)-2*Q2**5*(2777+6379*r**2+6379*r**4
            +2777*r**6)+Q2**4*(1555-8080*r**2-22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743
            -315*r**2-6548*r**4-6548*r**6-315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2
            +199629*r**4+305844*r**6+199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83
            -375*r**2-2833*r**4-5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)
            +9*(301-4028*r**2+808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12
            -4028*r**14+301*r**16))*sqrtq2)))+muWC**2*((pi2*(-4*r**2*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(
            -57-24*Q2**14+3714*r**2+43777*r**4-3791308*r**6-10159121*r**8+15296334*r**10
            -236289183*r**12+694656216*r**14-815729139*r**16+457228062*r**18-127046277*r**20
            +25369844*r**22+93757*r**24+322322*r**26+1059*r**28-56*Q2**13*(1+r**2)
            +Q2**12*(1457-3446*r**2-1627*r**4)+4*Q2**11*(-1615+8387*r**2+54679*r**4
            +3797*r**6)-4*Q2**10*(-3472+30654*r**2+403567*r**4+338572*r**6+11639*r**8)
            +4*Q2**9*(-4008+54495*r**2+1044380*r**4+2055110*r**6+727340*r**8+15387*r**10)
            -Q2**8*(-8157+170178*r**2+3813345*r**4+13564420*r**6+12323485*r**8+1013978*r**10
            +15423*r**12)-8*Q2**7*(-207+2181*r**2+203412*r**4-98905*r**6+1778395*r**8
            +542973*r**10+651616*r**12+6327*r**14)+8*Q2**6*(-420+13398*r**2+622461*r**4
            +1572643*r**6+10153075*r**8+11587780*r**10+3383193*r**12+891191*r**14
            +5943*r**16)+8*Q2**5*(-57-1356*r**2-185973*r**4-797988*r**6-6859881*r**8
            -23311392*r**10-9155691*r**12-2312708*r**14-8398*r**16+1284*r**18)-Q2**4*(
            -1931+71530*r**2+2109045*r**4-6455760*r**6+15777210*r**8-44549788*r**10
            -138504270*r**12+88484320*r**14+7369665*r**16+5785410*r**18+34249*r**20)
            +4*Q2**3*(-119+8471*r**2+323305*r**4-3050295*r**6-3025010*r**8-6052382*r**10
            +19084558*r**12-13941570*r**14+34632105*r**16+3167815*r**18+818121*r**20
            +3001*r**22)+4*Q2**2*(-122+4186*r**2+58337*r**4+87590*r**6+5884315*r**8
            +13803764*r**10+13722438*r**12-4033124*r**14-12132160*r**16-2175310*r**18
            -930087*r**20+223806*r**22+1567*r**24)-4*Q2*(-80+4233*r**2+73226*r**4
            -2220242*r**6-2960350*r**8-2058365*r**10-5455156*r**12-38454012*r**14
            +85305484*r**16-50223425*r**18+15606570*r**20+53198*r**22+327586*r**24
            +1333*r**26))-4*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(192*Q2**19
            +88*Q2**18*(1+r**2)+16*Q2**17*(-781+1642*r**2+761*r**4)-Q2**16*(-73775
            +297995*r**2+1825599*r**4+145669*r**6)+4*Q2**15*(-51861+340660*r**2
            +4186230*r**4+3591900*r**6+150207*r**8)-2*Q2**14*(-160967+1597940*r**2
            +30027301*r**4+56976461*r**6+22270690*r**8+587263*r**10)+4*Q2**13*(-60326
            +917894*r**2+24316527*r**4+81644768*r**6+73261216*r**8+12910234*r**10
            +223639*r**12)+Q2**12*(-25402-563876*r**2-38459200*r**4-358564138*r**6
            -438041866*r**8-228371272*r**10+37752324*r**12+634262*r**14)-4*Q2**11*(
            -48165+833580*r**2+23734310*r**4+18524260*r**6+191728516*r**8+235832836*r**10
            +95582026*r**12+40901932*r**14+427377*r**16)+2*Q2**10*(-43329+1222980*r**2
            +58336869*r**4+277843715*r**6+1545154811*r**8+3240493627*r**10+1729299335*r**12
            +475011561*r**14+58601370*r**16+322773*r**18)+4*Q2**9*(-21736+513590*r**2
            +4363551*r**4-147373004*r**6-899717980*r**8-3213841264*r**10-3392656990*r**12
            -715979284*r**14-140458404*r**16+25380890*r**18+279719*r**20)-2*Q2**8*(
            -45422+1641233*r**2+48534133*r**4-170257418*r**6-588840656*r**8-4624178418*r**10
            -7526070378*r**12-4253144032*r**14+1312661502*r**16+216617569*r**18+93325493*r**20
            +565738*r**22)+4*Q2**7*(1573+68684*r**2+7392018*r**4+10756724*r**6+339887083*r**8
            +998967992*r**10+4261569596*r**12+4797578744*r**14+3260448139*r**16+1591348508*r**18
            +211851218*r**20+7629684*r**22-31163*r**24)+2*Q2**6*(-19635+801700*r**2
            +18156501*r**4-209461039*r**6-777053636*r**8-5007634041*r**10-23534560726*r**12
            -47692110982*r**14-28406379147*r**16-14011017886*r**18-1356019711*r**20
            -196567371*r**22+50182914*r**24+310899*r**26)-4*Q2**5*(-2162+153710*r**2
            +5399059*r**4-79097960*r**6-98177028*r**8-1165588042*r**10-5991109955*r**12
            -22670582320*r**14-29948143010*r**16-3934803926*r**18-3395263571*r**20
            +710056600*r**22+51425816*r**24+13953970*r**26+44419*r**28)-2*Q2**4*(
            -4909+213490*r**2+2377176*r**4-49489669*r**6+14947725*r**8+1709875624*r**10
            +1532121230*r**12+5085336893*r**14+21487760013*r**16+14689327610*r**18
            -27876860036*r**20-6085393995*r**22-1579897069*r**24-173066644*r**26
            +9858590*r**28+74771*r**30)+4*Q2**3*(-1157+73388*r**2+1303102*r**4-47410252*r**6
            +61818306*r**8+1239105212*r**10+3689404902*r**12+6233169716*r**14-1101385656*r**16
            -2238290812*r**18-13322010758*r**20-9973666948*r**22-3947265218*r**24
            -103450092*r**26-30318494*r**28+5590428*r**30+22333*r**32)+2*Q2**2*(
            -447+17184*r**2-132149*r**4+9379321*r**6+7830667*r**8+285387037*r**10
            -2214797369*r**12-19284105635*r**14-4305412287*r**16+5509203441*r**18
            -32929105263*r**20+37591020251*r**22-6331072423*r**24+1139137991*r**26
            -350402083*r**28-28432177*r**30-408166*r**32+4107*r**34)-12*Q2*(-80
            +5330*r**2+24149*r**4-3731276*r**6+20537872*r**8+346607692*r**10+751218972*r**12
            +574534900*r**14+4976184960*r**16-7844999744*r**18+9208651006*r**20-10784577284*r**22
            +4395066128*r**24-1287006892*r**26-321630628*r**28-26504868*r**30-4690768*r**32
            +309198*r**34+1333*r**36)+3*(-57+4455*r**2+1651*r**4-4755365*r**6
            +33999596*r**8+552049916*r**10+1070939420*r**12+3260927372*r**14+14149245010*r**16
            -38650944158*r**18+10091920314*r**20+31128267770*r**22-24690211972*r**24
            +4220464300*r**26-645428372*r**28-501804548*r**30-10774145*r**32-4210801*r**34
            +308555*r**36+1059*r**38))*sqrtq2+logq2**5*(13063680000*(-Q2+(-1+r)**2)*(
            -1+r)*r**22*(1+r)*(1+r**2)*(3+r**2)*(1-Q2+r**2)*(-Q2+(1+r)**2)
            +13063680000*r**22*(-3-r**2+3*r**4+r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2**4*(10368000*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-480*Q2**6*(1+r**2)+240*Q2**5*(5+17*r**2+12*r**4)-8*Q2**4*(
            -171+503*r**2+1483*r**4+837*r**6)+Q2**3*(-4197-7411*r**2+4737*r**4
            +14275*r**6+6324*r**8)+Q2**2*(-1257+7268*r**2+10278*r**4-3876*r**6
            -5213*r**8+864*r**10)+Q2*(8403+813*r**2-8928*r**4+1020*r**6+5961*r**8
            -1833*r**10-5436*r**12)+3*(-1679-852*r**2-3925*r**4+1808*r**6+4783*r**8
            -908*r**10-75*r**12+848*r**14))+10368000*r**18*(480*Q2**9*(1+r**2)-240*Q2**8*(11
            +29*r**2+18*r**4)+8*Q2**7*(459+2783*r**2+4393*r**4+2097*r**6)-7*Q2**6*(
            -603+2171*r**2+10263*r**4+12565*r**6+5076*r**8)+2*Q2**5*(-7119-14938*r**2
            +9418*r**4+55520*r**6+58597*r**8+20538*r**10)-5*Q2**4*(-357-8491*r**2
            -13112*r**4+264*r**6+16085*r**8+14371*r**10+3528*r**12)+3*(-1+r**2)**3*(1679
            +4210*r**2+8987*r**4+11104*r**6+4513*r**8+638*r**10+1621*r**12+848*r**14)
            -4*Q2**3*(-7455-1925*r**2+9456*r**4+11782*r**6+5237*r**8-4677*r**10
            -70*r**12+3780*r**14)+Q2**2*(-41577-33499*r**2-38777*r**4-29375*r**6
            +61833*r**8+45623*r**10-6283*r**12+17251*r**14+24804*r**16)-6*Q2*(
            -3919-1692*r**2-6234*r**4-5414*r**6+648*r**8+9090*r**10+7578*r**12
            -2370*r**14+135*r**16+2178*r**18))*sqrtq2)+logq2**3*(345600*r**14*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(640*Q2**10-80*Q2**9*(81
            +109*r**2)+4*Q2**8*(6629+17565*r**2+10744*r**4)-4*Q2**7*(13937+55577*r**2
            +67087*r**4+24047*r**6)+Q2**6*(60123+300955*r**2+587331*r**4+441405*r**6
            +78778*r**8)+2*Q2**5*(-16898-61691*r**2-162424*r**4-207494*r**6-100006*r**8
            +29057*r**10)+Q2**4*(16975+47435*r**2+31266*r**4-542330*r**6-664749*r**8
            -296465*r**10-153860*r**12)+8*Q2**3*(-612-26545*r**2-80570*r**4-24933*r**6
            +148772*r**8+150185*r**10+50490*r**12+9293*r**14)+Q2**2*(-18307+97573*r**2
            +284079*r**4+1148689*r**6+348657*r**8-593941*r**10-206511*r**12-131617*r**14
            +39058*r**16)-6*Q2*(-3612-26855*r**2-171020*r**4+66960*r**6+131432*r**8
            -110278*r**10-16620*r**12+116040*r**14+6060*r**16+7893*r**18)+3*(-2233
            -36861*r**2-247472*r**4+80392*r**6-1734*r**8+157026*r**10-12024*r**12
            -73288*r**14+124223*r**16+7899*r**18+4072*r**20))+345600*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(640*Q2**10-80*Q2**9*(81+109*r**2)+4*Q2**8*(6629
            +17565*r**2+10744*r**4)-4*Q2**7*(13937+55577*r**2+67087*r**4+24047*r**6)
            +Q2**6*(60123+300955*r**2+587331*r**4+441405*r**6+78778*r**8)+2*Q2**5*(
            -16898-61691*r**2-162424*r**4-207494*r**6-100006*r**8+29057*r**10)
            +Q2**4*(16975+47435*r**2+31266*r**4-542330*r**6-664749*r**8-296465*r**10
            -153860*r**12)+8*Q2**3*(-612-26545*r**2-80570*r**4-24933*r**6+148772*r**8
            +150185*r**10+50490*r**12+9293*r**14)+Q2**2*(-18307+97573*r**2+284079*r**4
            +1148689*r**6+348657*r**8-593941*r**10-206511*r**12-131617*r**14+39058*r**16)
            -6*Q2*(-3612-26855*r**2-171020*r**4+66960*r**6+131432*r**8-110278*r**10
            -16620*r**12+116040*r**14+6060*r**16+7893*r**18)+3*(-2233-36861*r**2
            -247472*r**4+80392*r**6-1734*r**8+157026*r**10-12024*r**12-73288*r**14
            +124223*r**16+7899*r**18+4072*r**20))*sqrtq2)+logq2**2*(-5760*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-11520*Q2**13+16*Q2**12*(5467+6129*r**2)
            -4*Q2**11*(68411+162683*r**2+81472*r**4)+4*Q2**10*(107538+445435*r**2
            +488576*r**4+115431*r**6)-5*Q2**9*(63513+485409*r**2+836313*r**4+525503*r**6
            +2286*r**8)-5*Q2**8*(-4311-255372*r**2-156518*r**4+31124*r**6-37219*r**8
            +156696*r**10)+2*Q2**7*(81363+461006*r**2+6476095*r**4+14718735*r**6
            +9881570*r**8+2230843*r**10+395556*r**12)+2*Q2**6*(-94431-969843*r**2
            -10679877*r**4-36028570*r**6-43245765*r**8-16754391*r**10-2859143*r**12
            +57588*r**14)+2*Q2**5*(47838+668895*r**2+5004941*r**4+24313856*r**6
            +53179760*r**8+38935933*r**10+2545855*r**12+477316*r**14-311994*r**16)
            +10*Q2**4*(7224-70913*r**2-290236*r**4-202923*r**6-798008*r**8-100423*r**10
            +2309292*r**12+3683419*r**14+392144*r**16+26328*r**18)+10*Q2**3*(-11161
            +33744*r**2+830991*r**4+3372825*r**6+3077805*r**8-4134399*r**10-9993411*r**12
            -7592889*r**14-3011748*r**16-312497*r**18+11460*r**20)-2*Q2**2*(-4051
            -179437*r**2+431045*r**4+16351470*r**6+33703410*r**8+33675702*r**10
            -9064446*r**12-13787040*r**14-19815615*r**16+2099095*r**18+83929*r**20
            +51538*r**22)+3*Q2*(13227-202019*r**2-2912411*r**4-6759935*r**6-28658760*r**8
            +21190806*r**10+3415638*r**12-11047218*r**14+22869135*r**16-2508915*r**18
            +4245317*r**20+351281*r**22+3854*r**24)+3*(-4801+73290*r**2+1453338*r**4
            +5865698*r**6+26364045*r**8-33625068*r**10-10397140*r**12+19279324*r**14
            +7418889*r**16-15437670*r**18+375994*r**20-1257150*r**22-110037*r**24
            +1288*r**26))-5760*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(11520*Q2**14
            -16*Q2**13*(6187+6849*r**2)+4*Q2**12*(90279+209067*r**2+105988*r**4)
            -4*Q2**11*(175949+676529*r**2+732731*r**4+196903*r**6)+Q2**10*(747717
            +4638937*r**2+7917609*r**4+5043543*r**6+473154*r**8)+10*Q2**9*(-33912
            -402147*r**2-739120*r**4-665346*r**6-282504*r**8+77205*r**10)-Q2**8*(141171
            -376403*r**2+10892740*r**4+28810500*r**6+19732665*r**8+5059071*r**10
            +1574592*r**12)+4*Q2**7*(87897+756106*r**2+8808489*r**4+28611700*r**6
            +33923035*r**8+14433402*r**10+2742771*r**12+168984*r**14)+2*Q2**6*(-142269
            -1733169*r**2-16654661*r**4-71022303*r**6-132454095*r**8-98936089*r**10
            -22159389*r**12-3278871*r**14+369582*r**16)-4*Q2**5*(-5859-535649*r**2
            -3562508*r**4-15166706*r**6-40741828*r**8-46308904*r**10-14967664*r**12
            +7696962*r**14+897699*r**16+221817*r**18)+10*Q2**4*(18385-97433*r**2
            -1192140*r**4-3865984*r**6-4078736*r**8+3235968*r**10+12202280*r**12
            +13585600*r**14+7087311*r**16+730969*r**18+14868*r**20)+4*Q2**3*(-29928
            -33261*r**2+2377360*r**4+18685275*r**6+32978280*r**8+14196366*r**10
            -39851748*r**12-50859270*r**14-36419400*r**16-7261065*r**18-710628*r**20
            +54419*r**22)-Q2**2*(31579-973033*r**2-8234017*r**4+13285225*r**6+14133480*r**8
            +198330642*r**10+59469426*r**12-78844626*r**14+1402095*r**16-42959785*r**18
            +17101999*r**20+1324777*r**22+114638*r**24)+6*Q2*(9014-131041*r**2
            -2283884*r**4-7769022*r**6-30891370*r**8+13078557*r**10+17501792*r**12
            -13455452*r**14+2201514*r**16+17898945*r**18+680204*r**20+2926874*r**22
            +232586*r**24+1283*r**26)+3*(-4801+68489*r**2+1526628*r**4+7319036*r**6
            +32229743*r**8-7261023*r**10-44022208*r**12+8882184*r**14+26698213*r**16
            -8018781*r**18-15061676*r**20-881156*r**22-1367187*r**24-108749*r**26
            +1288*r**28))*sqrtq2)+logq2*(-48*r**6*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-24832*Q2**16+32*Q2**15*(8831+7391*r**2)-8*Q2**14*(147195
            +310747*r**2+105120*r**4)+8*Q2**13*(279085+1071463*r**2+949863*r**4
            +149925*r**6)+Q2**12*(-1391025-11171351*r**2-11059123*r**4-7147001*r**6
            +269140*r**8)-4*Q2**11*(414176+330159*r**2+10560284*r**4+12969654*r**6
            +2738804*r**8+730411*r**10)+2*Q2**10*(1413177+8996279*r**2+77432240*r**4
            +176075950*r**6+92391625*r**8+15299499*r**10+1319262*r**12)+4*Q2**9*(33930
            -4236587*r**2-47505400*r**4-190977325*r**6-205409750*r**8-43791325*r**10
            -4054812*r**12+365205*r**14)+Q2**8*(-2632035+5002867*r**2+85605557*r**4
            +659131035*r**6+1143100575*r**8+638600425*r**10-124396393*r**12-20966583*r**14
            -3625800*r**16)+8*Q2**7*(139700+319169*r**2+4626662*r**4+18149174*r**6
            +127385300*r**8+158298110*r**10+87545574*r**12+46580062*r**14+3632844*r**16
            +113165*r**18)+4*Q2**6*(264701-1959057*r**2-23969242*r**4-170495852*r**6
            -1024048542*r**8-2141159326*r**10-1374332532*r**12-467276692*r**14-48003727*r**16
            -828817*r**18+461246*r**20)-8*Q2**5*(102873-886356*r**2-9947845*r**4
            -39908980*r**6-335013240*r**8-1271910682*r**10-1593563812*r**12-437240570*r**14
            -133478905*r**16+18659510*r**18+1671809*r**20+146598*r**22)-Q2**4*(178535
            -1807199*r**2+4007465*r**4+95382675*r**6+114198850*r**8+434581850*r**10
            +5891720898*r**12+2616114550*r**14-4645644325*r**16-790689275*r**18-202457835*r**20
            -7395849*r**22+340860*r**24)+4*Q2**3*(69120-1294299*r**2-9485184*r**4
            +91618610*r**6+368745300*r**8+471635775*r**10-425924192*r**12-911801092*r**14
            -1620955560*r**16-1492129325*r**18-296233120*r**20-10748334*r**22+229076*r**24
            +113225*r**26)-2*Q2**2*(5975-383687*r**2-7406276*r**4+54726358*r**6
            +412512145*r**8+2909071835*r**10+3068697954*r**12+375339252*r**14-442052871*r**16
            -2804453825*r**18-5148760*r**20-99536842*r**22+21319199*r**24+944813*r**26
            +12730*r**28)-12*Q2*(3814-119447*r**2-461392*r**4+24862223*r**6+112256118*r**8
            +66295181*r**10+569882944*r**12-240045341*r**14+20753954*r**16-712704661*r**18
            +365365296*r**20-178749747*r**22-25078142*r**24-2222177*r**26-44832*r**28
            +6209*r**30)+3*(3721-172681*r**2-1008755*r**4+54892795*r**6+237587485*r**8
            +542905027*r**10+2875929953*r**12-7282941065*r**14+2909531835*r**16+3719437205*r**18
            -3432125417*r**20+628651937*r**22-210248305*r**24-40930255*r**26-1506565*r**28
            -13331*r**30+6416*r**32))+48*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(24832*Q2**16
            -32*Q2**15*(8831+7391*r**2)+8*Q2**14*(147195+310747*r**2+105120*r**4)
            -8*Q2**13*(279085+1071463*r**2+949863*r**4+149925*r**6)+Q2**12*(1391025
            +11171351*r**2+11059123*r**4+7147001*r**6-269140*r**8)+4*Q2**11*(414176
            +330159*r**2+10560284*r**4+12969654*r**6+2738804*r**8+730411*r**10)
            -2*Q2**10*(1413177+8996279*r**2+77432240*r**4+176075950*r**6+92391625*r**8
            +15299499*r**10+1319262*r**12)-4*Q2**9*(33930-4236587*r**2-47505400*r**4
            -190977325*r**6-205409750*r**8-43791325*r**10-4054812*r**12+365205*r**14)
            +Q2**8*(2632035-5002867*r**2-85605557*r**4-659131035*r**6-1143100575*r**8
            -638600425*r**10+124396393*r**12+20966583*r**14+3625800*r**16)-8*Q2**7*(139700
            +319169*r**2+4626662*r**4+18149174*r**6+127385300*r**8+158298110*r**10
            +87545574*r**12+46580062*r**14+3632844*r**16+113165*r**18)+4*Q2**6*(
            -264701+1959057*r**2+23969242*r**4+170495852*r**6+1024048542*r**8+2141159326*r**10
            +1374332532*r**12+467276692*r**14+48003727*r**16+828817*r**18-461246*r**20)
            +8*Q2**5*(102873-886356*r**2-9947845*r**4-39908980*r**6-335013240*r**8
            -1271910682*r**10-1593563812*r**12-437240570*r**14-133478905*r**16+18659510*r**18
            +1671809*r**20+146598*r**22)+Q2**4*(178535-1807199*r**2+4007465*r**4
            +95382675*r**6+114198850*r**8+434581850*r**10+5891720898*r**12+2616114550*r**14
            -4645644325*r**16-790689275*r**18-202457835*r**20-7395849*r**22+340860*r**24)
            -4*Q2**3*(69120-1294299*r**2-9485184*r**4+91618610*r**6+368745300*r**8
            +471635775*r**10-425924192*r**12-911801092*r**14-1620955560*r**16-1492129325*r**18
            -296233120*r**20-10748334*r**22+229076*r**24+113225*r**26)+2*Q2**2*(5975
            -383687*r**2-7406276*r**4+54726358*r**6+412512145*r**8+2909071835*r**10
            +3068697954*r**12+375339252*r**14-442052871*r**16-2804453825*r**18-5148760*r**20
            -99536842*r**22+21319199*r**24+944813*r**26+12730*r**28)+12*Q2*(3814
            -119447*r**2-461392*r**4+24862223*r**6+112256118*r**8+66295181*r**10
            +569882944*r**12-240045341*r**14+20753954*r**16-712704661*r**18+365365296*r**20
            -178749747*r**22-25078142*r**24-2222177*r**26-44832*r**28+6209*r**30)
            -3*(3721-172681*r**2-1008755*r**4+54892795*r**6+237587485*r**8+542905027*r**10
            +2875929953*r**12-7282941065*r**14+2909531835*r**16+3719437205*r**18
            -3432125417*r**20+628651937*r**22-210248305*r**24-40930255*r**26-1506565*r**28
            -13331*r**30+6416*r**32))*sqrtq2)))/(-21000*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))-21000*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2+logq2**5*(-78382080000*r**22*(1+r**2)*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            +78382080000*r**22*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**2*(-18144000*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8
            +3*Q2**3*(1+r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4
            +7*r**6))-18144000*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8
            +3*Q2**3*(1+r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4
            +7*r**6))*sqrtq2)+logq2**3*(72576000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))+72576000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))*sqrtq2)+logq2**4*(-435456000*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(63+8*Q2**4-402*r**2
            -1122*r**4-402*r**6+63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)
            -3*Q2*(19+31*r**2+31*r**4+19*r**6))-435456000*(-Q2+(-1+r)**2)*r**18*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(63+8*Q2**4-402*r**2-1122*r**4-402*r**6
            +63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)-3*Q2*(19+31*r**2
            +31*r**4+19*r**6))*sqrtq2)+logq2*(252000*(-Q2+(-1+r)**2)*r**6*(1-Q2
            +r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1
            +r**2)-Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)
            +3*(9-86*r**2-446*r**4-86*r**6+9*r**8))+252000*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1+r**2)
            -Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)+3*(9
            -86*r**2-446*r**4-86*r**6+9*r**8))*sqrtq2))+(-16*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(
            -9960*Q2**19-16*Q2**18*(801+269*r**2)+Q2**17*(1020279-1972570*r**2-863725*r**4)
            +Q2**16*(-7355505+26866837*r**2+164828849*r**4+11810539*r**6)-2*Q2**15*(
            -13524681+77616631*r**2+900747198*r**4+757044399*r**6+29453893*r**8)
            +2*Q2**14*(-30690285+251287966*r**2+3983442447*r**4+6965141571*r**6+2877917950*r**8
            +76300735*r**10)-2*Q2**13*(-45271779+495507673*r**2+8926451293*r**4+22974732834*r**6
            +20639101555*r**8+4971729317*r**10+105985459*r**12)+2*Q2**12*(-42790371
            +591101846*r**2+9657650084*r**4+30057180661*r**6+27265346681*r**8+20720722764*r**10
            +1148564358*r**12+52680425*r**14)+2*Q2**11*(23622885-374616767*r**2-1192299388*r**4
            +401889135*r**6+87462108360*r**8+102863906455*r**10+24955843440*r**12
            +10405035241*r**14+61193839*r**16)-2*Q2**10*(6365073-67368554*r**2+8198925387*r**4
            +40755756221*r**6+276853811421*r**8+547563686785*r**10+333387191449*r**12
            +82109267095*r**14+16495269422*r**16+101520661*r**18)+2*Q2**9*(3470610
            -28542107*r**2+6001767616*r**4+40685792648*r**6+256886073940*r**8+743028456970*r**10
            +870627806168*r**12+249645737536*r**14+60906527058*r**16+3660668985*r**18
            +9085120*r**20)+2*Q2**8*(-6542484+187940027*r**2+3326640251*r**4-28718106012*r**6
            -82546820760*r**8-316480260034*r**10-409704865866*r**12-377909486904*r**14
            +295841981388*r**16+28617664935*r**18+15363012143*r**20+89174324*r**22)
            -2*Q2**7*(-4147611+184023437*r**2+5703772798*r**4-35861789983*r**6-74445044043*r**8
            -176901557494*r**10+173646260828*r**12+450722839098*r**14+285686514567*r**16
            +608439438297*r**18+69663891254*r**20+15962457301*r**22+70120175*r**24)
            +2*Q2**6*(1376025-13134734*r**2+702469065*r**4-14291824431*r**6-101007657740*r**8
            -295931504155*r**10-314858560526*r**12+318030753994*r**14+69566382417*r**16
            +501485313420*r**18+192657166405*r**20+32332489317*r**22+141127842*r**24
            -11043299*r**26)+2*Q2**5*(-3029547+125381285*r**2+2283518673*r**4-34174030986*r**6
            -7135286659*r**8+57062984551*r**10-19778043615*r**12+607127395684*r**14
            -894648202809*r**16+1453654954419*r**18-901469996053*r**20+337840754406*r**22
            +4678540839*r**24+9410560001*r**26+42801251*r**28)-2*Q2**4*(-1117155
            +67283234*r**2+1173490388*r**4-39168661731*r**6-52671234985*r**8+10091887800*r**10
            -533988227558*r**12+919659976639*r**14+425016531787*r**16-2583562135590*r**18
            +2274765787040*r**20-1084270178341*r**22+325959789633*r**24+8134947404*r**26
            +5604349810*r**28+19255625*r**30)-2*Q2**3*(-408363+11478077*r**2+107882408*r**4
            +5243540479*r**6+19108054910*r**8-76737148691*r**10+223846278284*r**12
            -1538839215961*r**14+929082186892*r**16-1654634272465*r**18+1839663279536*r**20
            -732807202699*r**22+203706153178*r**24-23993503321*r**26-4884034020*r**28
            +400792293*r**30+3835463*r**32)+(-1+r**2)**2*(-38247+2641215*r**2+949726*r**4
            -2099229926*r**6+15224243618*r**8+80949340070*r**10-50827474698*r**12
            +833803028994*r**14-685828093548*r**16-2204967755676*r**18+4068958100346*r**20
            -2744692864594*r**22+918833170574*r**24-199503347126*r**26+19505921458*r**28
            -788168394*r**30+200056227*r**32+591981*r**34)+2*Q2**2*(-482067+25238126*r**2
            +202633939*r**4-11729317719*r**6+27375601851*r**8+92307587917*r**10-63900669729*r**12
            +744253407997*r**14+303063434713*r**16-864274534467*r**18+1724966513737*r**20
            -2956351537525*r**22+1880723885289*r**24-645649007769*r**26+105442215941*r**28
            -4906009137*r**30+1713475478*r**32+6555425*r**34)-Q2*(-317685+19837960*r**2
            +68700603*r**4-13094472328*r**6+62749934940*r**8+237720817880*r**10-414516739684*r**12
            +3463539133784*r**14-4993463356310*r**16+3786368385800*r**18-8474637653110*r**20
            +14076005052648*r**22-10909107071252*r**24+4291879625544*r**26-1032791152340*r**28
            +118665530440*r**30-5745801149*r**32+1419154640*r**34+4677619*r**36))
            -16*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))**2*(9960*Q2**20-56*Q2**19*(-51+101*r**2)+Q2**18*(
            -1033095+1955450*r**2+859421*r**4)-8*Q2**17*(-1046973+3477391*r**2+20958143*r**4
            +1584283*r**6)+3*Q2**16*(-11468289+58248198*r**2+664396694*r**4+563576062*r**6
            +23572775*r**8)-4*Q2**15*(-22107483+157689958*r**2+2480903138*r**4+4311466584*r**6
            +1832208121*r**8+52877314*r**10)+4*Q2**14*(-37981032+358052677*r**2+6580590853*r**4
            +16961658426*r**6+15241080538*r**8+3962974001*r**10+91143097*r**12)-4*Q2**13*(
            -44031075+520668870*r**2+9539804525*r**4+30979182394*r**6+35439590535*r**8
            +23165776818*r**10+3113139567*r**12+79332942*r**14)-4*Q2**12*(33206628
            -461464121*r**2-5720525659*r**4-19656470805*r**6+15069790509*r**8+27438918505*r**10
            +1543278159*r**12+4601895229*r**14+4256707*r**16)+4*Q2**11*(14993979
            -209181218*r**2+3316004616*r**4+19982672984*r**6+182358904458*r**8+368944850800*r**10
            +230603470672*r**12+58735072888*r**14+13480749251*r**16+81357250*r**18)
            -2*Q2**10*(9835683-89545588*r**2+14133324449*r**4+89640474256*r**6+574495641582*r**8
            +1567445955176*r**10+1751578684402*r**12+665142196080*r**14+159511063575*r**16
            +20257459068*r**18+110605781*r**20)+4*Q2**9*(5006547-106505762*r**2+1323292629*r**4
            +37702833138*r**6+190059343674*r**8+658197395472*r**10+1011680564502*r**12
            +749091515304*r**14+7355141603*r**16+17974765554*r**18-5846629019*r**20
            -40044602*r**22)+2*Q2**8*(-10690095+365420980*r**2+9218353076*r**4-61253255744*r**6
            -185709970815*r**8-575928638288*r**10-552538865072*r**12-336891513672*r**14
            +203619009051*r**16+932899084620*r**18+113644568332*r**20+31414643768*r**22
            +159294499*r**24)-4*Q2**7*(-1385793+83370546*r**2+3295132650*r**4-22224920808*r**6
            -105657245883*r**8-273639052846*r**10-159056928596*r**12+471199926960*r**14
            +402987868041*r**16+697805633142*r**18+435380247978*r**20+58979418936*r**22
            +8086852659*r**24+29538438*r**26)-4*Q2**6*(-2202786+68569997*r**2+797092171*r**4
            -10292337810*r**6+54082097756*r**8+227001073223*r**10+295506010533*r**12
            +301977601108*r**14-641122669610*r**16+441301629291*r**18-797806237939*r**20
            +56425549342*r**22-13897538160*r**24+4640237729*r**26+26922275*r**28)
            +4*Q2**5*(-2073351+94817486*r**2+1791195173*r**4-35529587022*r**6-46990276315*r**8
            +30009792846*r**10-248351643311*r**12+753504664354*r**14+68747862331*r**16
            -1012277691990*r**18+1413475372703*r**20-823949709994*r**22+334239542439*r**24
            +11112024122*r**26+7528855531*r**28+31028438*r**30)-4*Q2**4*(-354396
            +27344001*r**2+566445607*r**4-21619355911*r**6-55473975813*r**8+17078900753*r**10
            -373871309021*r**12+962255482521*r**14+207797160767*r**16-251955665669*r**18
            -1074229814043*r**20+961651405699*r**22-481008270943*r**24+179044120179*r**26
            +9311665617*r**28+2611406571*r**30+7710081*r**32)-4*Q2**3*(-445215+18153920*r**2
            +160997212*r**4-3188947416*r**6+25863598620*r**8+17339247068*r**10+41604229932*r**12
            -285369764840*r**14-153346797178*r**16-794913310020*r**18+954997760404*r**20
            -924747730344*r**22+675811417884*r**24-232968178956*r**26+38282339300*r**28
            -4694625432*r**30+1059051617*r**32+5195444*r**34)+(-1+r**2)**2*(-38247
            +2602968*r**2+3590941*r**4-2098280200*r**6+13125013692*r**8+96173583688*r**10
            +30121865372*r**12+782975554296*r**14+147974935446*r**16-2890795849224*r**18
            +1863990344670*r**20+1324265235752*r**22-1825859694020*r**24+719329823448*r**26
            -179997425668*r**28+18717753064*r**30-588112167*r**32+200648208*r**34
            +591981*r**36)+Q2**2*(-1281819+69350078*r**2+524444733*r**4-36147839888*r**6
            +94042503204*r**8+477087197416*r**10-357702903308*r**12+4824244610320*r**14
            -2898829670890*r**16+2663946186292*r**18-6753253694570*r**20+11613235005072*r**22
            -13060362375724*r**24+6762029380584*r**26-2113204735996*r**28+319737944048*r**30
            -12130868467*r**32+4859216446*r**34+17788469*r**36)-4*Q2*(-88983+5559496*r**2
            +21041903*r**4-3781064972*r**6+17269778952*r**8+87218093932*r**10-93574458256*r**12
            +1016357428140*r**14-983546462190*r**16-301650877524*r**18+776199062710*r**20
            -1871552355356*r**22+3411018745376*r**24-2849772499644*r**26+1149108564872*r**28
            -288357245084*r**30+33550510941*r**32-1378583844*r**34+405676131*r**36
            +1317400*r**38))*sqrtq2+logq2**7*(112870195200000*r**32*(1+r**2)**2*(1-Q2
            +r**2)*(-2013+1230*r**2+559*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3
            +112870195200000*(Q2-(-1+r)**2)**2*r**32*(1+r**2)**2*(-2013+1230*r**2
            +559*r**4)*(Q2-(1+r)**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**6*(89579520000*r**28*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(54240*Q2**8*(1
            +r**2)-240*Q2**7*(121+921*r**2+800*r**4)-8*Q2**6*(-25032+109383*r**2
            +116726*r**4+19887*r**6)+Q2**5*(-1355571-1047957*r**2+3811687*r**4+5141989*r**6
            +1637916*r**8)+Q2**4*(1195005+5602428*r**2+6470418*r**4-3703564*r**6
            -7461903*r**8-2296560*r**10)-2*Q2**3*(-2598540+1283181*r**2+6192277*r**4
            +3140633*r**6-541429*r**8-1071206*r**10+300300*r**12)+3*(-1+r**2)**2*(
            -1279503-1337996*r**2-4425157*r**4+1874976*r**6+4012111*r**8-324676*r**10
            -168443*r**12+331568*r**14)+2*Q2**2*(-6801060-4280091*r**2-2936684*r**4
            +3241454*r**6+4010544*r**8-1194559*r**10+735136*r**12+2050860*r**14)
            +3*Q2*(4059553+1639529*r**2+11534023*r**4+9541291*r**6-12964437*r**8
            -9314105*r**10+1185209*r**12+767525*r**14-1180108*r**16))-89579520000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(54240*Q2**9*(1+r**2)-240*Q2**8*(347
            +1373*r**2+1026*r**4)+8*Q2**7*(28662-78123*r**2-65096*r**4+4113*r**6)
            +7*Q2**6*(-222261-53307*r**2+802937*r**4+890699*r**6+256716*r**8)-4*Q2**5*(
            -637644-2001489*r**2-926672*r**4+3164310*r**6+3560452*r**8+983619*r**10)
            +5*Q2**4*(800415-1872759*r**2-4891480*r**4-1809624*r**6+2449665*r**8
            +2380175*r**10+339192*r**12)+4*Q2**3*(-4699800-2797725*r**2+2269387*r**4
            +6287182*r**6+3304874*r**8-1403597*r**10-17885*r**12+1175580*r**14)
            +Q2**2*(25780779+27080889*r**2+49035619*r**4+28014333*r**6-53397307*r**8
            -33574285*r**10+4474473*r**12-3269417*r**14-7642044*r**16)-3*(-1+r**2)**2*(
            -1279503-2617499*r**2-5763153*r**4-2550181*r**6+5887087*r**8+3687435*r**10
            -493119*r**12+163125*r**14+331568*r**16)+12*Q2*(-1334764-1119518*r**2
            -4050555*r**4-2922005*r**6-184963*r**8+3951155*r**10+3155479*r**12-402239*r**14
            -104749*r**16+377919*r**18))*sqrtq2)+logq2**5*(-497664000*r**24*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(867840*Q2**12*(1+r**2)
            -480*Q2**11*(52557+110546*r**2+57989*r**4)+8*Q2**10*(17231223+58425198*r**2
            +66440023*r**4+25095744*r**6)-120*Q2**9*(2158041+11466174*r**2+21928988*r**4
            +18152882*r**6+5532027*r**8)+15*Q2**8*(3201009+79881712*r**2+289772954*r**4
            +431304428*r**6+294875413*r**8+76663236*r**10)-20*Q2**7*(-19028991-40132212*r**2
            +41036537*r**4+255197880*r**6+361861755*r**8+214120316*r**10+45316683*r**12)
            -60*Q2**6*(3190026+20360445*r**2+46764600*r**4+14987689*r**6-52628934*r**8
            -56726673*r**10-14338716*r**12+3163083*r**14)+12*Q2**5*(-50816244-43436809*r**2
            +233190131*r**4+222384193*r**6-412331475*r**8-693340359*r**10-242201699*r**12
            +126545871*r**14+84312183*r**16)-10*Q2**4*(-86844057-44136678*r**2+445006618*r**4
            +1040731548*r**6+741893322*r**8-718470680*r**10-1365424326*r**12-570753684*r**14
            +57098491*r**16+74740086*r**18)+60*Q2**3*(-6237571-4977418*r**2-43523291*r**4
            +112711616*r**6+337965898*r**8+218267704*r**10-6590482*r**12-58368104*r**14
            -18168479*r**16-3102342*r**18+1085381*r**20)+9*(-1+r**2)**2*(69791+112434818*r**2
            +686170571*r**4+638700992*r**6+344859698*r**8-426018868*r**10-786156646*r**12
            +32164304*r**14+56756783*r**16-160389198*r**18-26140773*r**20+1711728*r**22)
            +60*Q2**2*(-96396+43258157*r**2+315584740*r**4+291580751*r**6-15729826*r**8
            -129741466*r**10-50603638*r**12+35432642*r**14-77819602*r**16-102605347*r**18
            -10999662*r**20+3171967*r**22)-180*Q2*(-161364+16922979*r**2+98263243*r**4
            +70126711*r**6+77601843*r**8+94599834*r**10-119451342*r**12-141705630*r**14
            +18148782*r**16+12264675*r**18-27534717*r**20-4792249*r**22+549875*r**24))
            -497664000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(867840*Q2**12*(1
            +r**2)-480*Q2**11*(52557+110546*r**2+57989*r**4)+8*Q2**10*(17231223
            +58425198*r**2+66440023*r**4+25095744*r**6)-120*Q2**9*(2158041+11466174*r**2
            +21928988*r**4+18152882*r**6+5532027*r**8)+15*Q2**8*(3201009+79881712*r**2
            +289772954*r**4+431304428*r**6+294875413*r**8+76663236*r**10)-20*Q2**7*(
            -19028991-40132212*r**2+41036537*r**4+255197880*r**6+361861755*r**8
            +214120316*r**10+45316683*r**12)-60*Q2**6*(3190026+20360445*r**2+46764600*r**4
            +14987689*r**6-52628934*r**8-56726673*r**10-14338716*r**12+3163083*r**14)
            +12*Q2**5*(-50816244-43436809*r**2+233190131*r**4+222384193*r**6-412331475*r**8
            -693340359*r**10-242201699*r**12+126545871*r**14+84312183*r**16)-10*Q2**4*(
            -86844057-44136678*r**2+445006618*r**4+1040731548*r**6+741893322*r**8
            -718470680*r**10-1365424326*r**12-570753684*r**14+57098491*r**16+74740086*r**18)
            +60*Q2**3*(-6237571-4977418*r**2-43523291*r**4+112711616*r**6+337965898*r**8
            +218267704*r**10-6590482*r**12-58368104*r**14-18168479*r**16-3102342*r**18
            +1085381*r**20)+9*(-1+r**2)**2*(69791+112434818*r**2+686170571*r**4
            +638700992*r**6+344859698*r**8-426018868*r**10-786156646*r**12+32164304*r**14
            +56756783*r**16-160389198*r**18-26140773*r**20+1711728*r**22)+60*Q2**2*(
            -96396+43258157*r**2+315584740*r**4+291580751*r**6-15729826*r**8-129741466*r**10
            -50603638*r**12+35432642*r**14-77819602*r**16-102605347*r**18-10999662*r**20
            +3171967*r**22)-180*Q2*(-161364+16922979*r**2+98263243*r**4+70126711*r**6
            +77601843*r**8+94599834*r**10-119451342*r**12-141705630*r**14+18148782*r**16
            +12264675*r**18-27534717*r**20-4792249*r**22+549875*r**24))*sqrtq2)+logq2**4*(
            -8294400*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-1157120*Q2**16+5120*Q2**15*(25520
            +26199*r**2)-64*Q2**14*(15816017+36885420*r**2+21173019*r**4)+8*Q2**13*(429749679
            +1626560014*r**2+1969422063*r**4+773719408*r**6)-16*Q2**12*(428227293
            +2338411952*r**2+4400000314*r**4+3478044004*r**6+982953981*r**8)+Q2**11*(9851851557
            +66796731028*r**2+167959738722*r**4+202311899988*r**6+113120333081*r**8
            +21827037624*r**10)-Q2**10*(12716659053+75542848793*r**2+204733095294*r**4
            +321465780454*r**6+288313942549*r**8+118753854721*r**10+9117098496*r**12)
            +Q2**9*(15080074101+51996844480*r**2+63751598987*r**4-3965768240*r**6
            -21919088285*r**8+35418846296*r**10+6151350365*r**12-21195792168*r**14)
            +Q2**8*(-12543751089-35691238829*r**2+22293526977*r**4+461129077277*r**6
            +1106515591905*r**8+1102415661021*r**10+519806680911*r**12+148304287667*r**14
            +38607655872*r**16)-2*Q2**7*(-1650000013-27785908292*r**2-97754943294*r**4
            -27360183644*r**6+423659432374*r**8+921057667412*r**10+812037682538*r**12
            +353239660676*r**14+87771183851*r**16+9967888904*r**18)+Q2**6*(5760170246
            -51100595786*r**2-227216407084*r**4-586661457516*r**6-691593315332*r**8
            +219171573548*r**10+951652941204*r**12+602730056116*r**14+185169175574*r**16
            +60375723478*r**18-12960463488*r**20)+2*Q2**5*(-3757167347-6084470992*r**2
            -89416750701*r**4+10181583704*r**6+349502213484*r**8+133111265664*r**10
            -450910093276*r**12-335624965056*r**14+157652779959*r**16+170083974784*r**18
            +20502514201*r**20+11671141176*r**22)-2*Q2**4*(-1705418931-26568995275*r**2
            -159120748377*r**4+21174131335*r**6+589407701540*r**8+682705782212*r**10
            -141529131220*r**12-1019431564396*r**14-746332932025*r**16-12550118905*r**18
            +140099554029*r**20+24380575205*r**22+4997436808*r**24)-3*Q2**3*(-234446219
            +10439406836*r**2+32593515202*r**4-59106658908*r**6-179970630825*r**8
            -768322828432*r**10-921089665252*r**12-237909591784*r**14+182688156371*r**16
            +155069673700*r**18+67639025826*r**20-1532973884*r**22-7275117343*r**24
            +961318712*r**26)+9*(-1+r**2)**2*(-21275517+17987749*r**2+4733518084*r**4
            +41066933748*r**6+120933852171*r**8+13139671669*r**10-78868732328*r**12
            -48908725288*r**14+15462331169*r**16+15364394983*r**18-25923565052*r**20
            -9435253196*r**22-117681071*r**24-56322817*r**26+29185696*r**28)+3*Q2**2*(
            -606019571+1506292641*r**2+20388068262*r**4+286297807822*r**6+1029552251643*r**8
            +532072552567*r**10-299381473452*r**12-260843027004*r**14+97035932931*r**16
            -127549283761*r**18-385303071546*r**20-80283520914*r**22+21697750517*r**24
            -2957619303*r**26+1545839168*r**28)-9*Q2*(-108263313+12958288*r**2+11827067257*r**4
            +118184022048*r**6+332974435211*r**8+59746361640*r**10-34458547331*r**12
            +2491184136*r**14-230894761891*r**16-29089005312*r**18+78149569499*r**20
            -86049594032*r**22-34999904343*r**24+2154661768*r**26-478192849*r**28
            +203289224*r**30))-8294400*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1157120*Q2**17
            -35840*Q2**16*(3678+3775*r**2)+64*Q2**15*(17857617+41022940*r**2+23268939*r**4)
            -40*Q2**14*(111255563+409634302*r**2+486777915*r**4+188620712*r**6)+8*Q2**13*(1286204265
            +6733133597*r**2+12395982705*r**4+9699229479*r**6+2739627370*r**8)-Q2**12*(16703488245
            +111062958948*r**2+275774334978*r**4+328360609076*r**6+184496300841*r**8
            +37554301320*r**10)+2*Q2**11*(11284255305+76095715689*r**2+219744782522*r**4
            +345868709582*r**6+301873087809*r**8+126850612713*r**10+15472068060*r**12)
            +2*Q2**10*(-13898366577-70128176163*r**2-172013771537*r**4-261116553754*r**6
            -293930317359*r**8-221243321783*r**10-67011151791*r**12+6039346836*r**14)
            -10*Q2**9*(-2762382519-10276815741*r**2-9345491649*r**4+40134324653*r**6
            +113240044843*r**8+108891590301*r**10+47823648425*r**12+16334872947*r**14
            +5980344804*r**16)+Q2**8*(-15843751115-103806806502*r**2-208907598440*r**4
            +428702236966*r**6+2414963533930*r**8+4051046587750*r**10+3246297707008*r**12
            +1374590289930*r**14+362454311241*r**16+58543433680*r**18)-4*Q2**7*(615042555
            -27493103099*r**2-119574527564*r**4-209222927848*r**6+25251295532*r**8
            +727151443280*r**10+1104460910276*r**12+733321185636*r**14+266797716157*r**16
            +63963467247*r**18+1743828580*r**20)-4*Q2**6*(-3318626235+8292870889*r**2
            +24870875367*r**4+208560258002*r**6+494314799954*r**8+184661068278*r**10
            -518161175326*r**12-556408231858*r**14-118148417943*r**16+23655762629*r**18
            -1602557897*r**20+9075686460*r**22)+4*Q2**5*(-2731293139-18205316807*r**2
            -127310985035*r**4-29030517831*r**6+474545749364*r**8+582659630680*r**10
            -229663979416*r**12-902983311364*r**14-462152558561*r**16+157593317919*r**18
            +165343021507*r**20+28277115291*r**22+8334288992*r**24)-5*Q2**4*(-541499841
            -17573409784*r**2-93832006582*r**4-19714651472*r**6+352215111645*r**8
            +969839090560*r**10+769124459548*r**12-321638523176*r**14-815918692391*r**16
            -396595024592*r**18+10436358554*r**20+66711836024*r**22+16116275211*r**24
            +1422183496*r**26)-6*Q2**3*(-420232895+5855626629*r**2+31710495150*r**4
            +129892332058*r**6+395237480955*r**8-208110453345*r**10-994396983568*r**12
            -709921142020*r**14+20907248759*r**16+105104273155*r**18-81297186010*r**20
            -7088734486*r**22+6444829645*r**24-4635708967*r**26+1253578940*r**28)
            +9*(-1+r**2)**2*(-21275517-3287768*r**2+4751505833*r**4+45800451832*r**6
            +162000785919*r**8+134073523840*r**10-65729060659*r**12-127777457616*r**14
            -33446394119*r**16+30826726152*r**18-10559170069*r**20-35358818248*r**22
            -9552934267*r**24-174003888*r**26-27137121*r**28+29185696*r**30)+6*Q2**2*(
            -465404755+469573967*r**2+28687781337*r**4+330618971114*r**6+1157386682549*r**8
            +870431944565*r**10+64657718561*r**12-276375474024*r**14-428245689873*r**16
            -58890183383*r**18-139201823405*r**20-361867687278*r**22-81792741713*r**24
            +12602058259*r**26-1423179341*r**28+1077853420*r**30)-18*Q2*(-64769415
            -17383121*r**2+8258146307*r**4+80814487317*r**6+247345980009*r**8+102529848963*r**10
            +20536795407*r**12+45000523921*r**14-96996264169*r**16-162226379923*r**18
            +3935270169*r**20+24938123679*r**22-64110119053*r**24-21050728223*r**26
            +850309589*r**28-194798917*r**30+116237460*r**32))*sqrtq2)+logq2**3*(138240*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(170690560*Q2**19-512*Q2**18*(4229103
            +5113532*r**2)+64*Q2**17*(197372977+470675150*r**2+269194973*r**4)-16*Q2**16*(2696601753
            +9724218362*r**2+10996816073*r**4+3865733832*r**6)+16*Q2**15*(5749278351
            +28023324216*r**2+48066782070*r**4+34231630384*r**6+7758615139*r**8)
            -Q2**14*(122499756025+751295707060*r**2+1693092145066*r**4+1846009993204*r**6
            +918193356765*r**8+107131176920*r**10)+2*Q2**13*(48325374619+352372598011*r**2
            +819953164142*r**4+976138733810*r**6+782308902523*r**8+276581228179*r**10
            -42194775044*r**12)+Q2**12*(-37011097179-318270735630*r**2+515909919983*r**4
            +4199959001900*r**6+5819437979635*r**8+2885668792402*r**10+840630483705*r**12
            +310339420944*r**14)-4*Q2**11*(2112577119-2710956579*r**2+892779189223*r**4
            +4378613790677*r**6+8016729835965*r**8+6591153161343*r**10+2451910315157*r**12
            +517686600399*r**14+62578281576*r**16)+Q2**10*(38814179207+201635897712*r**2
            +5503541819624*r**4+27193528167056*r**6+62765341836606*r**8+74530237262184*r**10
            +43036149555024*r**12+10526661477856*r**14+1634908838403*r**16-103811261512*r**18)
            +2*Q2**9*(-25984765815-267111021115*r**2-2803954077284*r**4-10130451164576*r**6
            -23406102301670*r**8-34844291093430*r**10-30905430402280*r**12-11540541504904*r**14
            +241718526629*r**16+80862851865*r**18+159890392580*r**20)-Q2**8*(-15766319357
            -654470937358*r**2-4370432547957*r**4-8584582965640*r**6+1515273133582*r**8
            +39298942575932*r**10+63782718950278*r**12+47530147978328*r**14+28976729095695*r**16
            +13429162464642*r**18+1547572434383*r**20+155075468672*r**22)-8*Q2**7*(
            -4797666753+38181242555*r**2+353435809279*r**4+1850232439685*r**6+2445111984780*r**8
            -4903563589158*r**10-19024482052550*r**12-23877985183442*r**14-15855130556565*r**16
            -6861582430245*r**18-1575788424489*r**20-175439352355*r**22+12119185338*r**24)
            +Q2**6*(-37869301779-113002403556*r**2+802012674638*r**4+19370353194412*r**6
            +50954239707095*r**8+78844320045456*r**10+28956709363764*r**12-80022100095464*r**14
            -92858971140261*r**16-57400334710980*r**18-28282903489922*r**20+206852764732*r**22
            -235355394079*r**24+128954155544*r**26)-2*Q2**5*(1310168131-130264416629*r**2
            -908521838646*r**4-50895712978*r**6-6743856106523*r**8+12406354860341*r**10
            +36927979534216*r**12-18403468220*r**14-26508421910771*r**16+12687417800469*r**18
            +19746061186098*r**20+2272560047758*r**22+3985980504011*r**24+314797189419*r**26
            +11814995324*r**28)+Q2**4*(18576137095-183576116210*r**2-2580043609991*r**4
            -13367986750244*r**6-40962919328345*r**8+20901435427250*r**10+118331577447665*r**12
            +34727580538392*r**14-141136595536227*r**16-159908874622990*r**18-25652297687245*r**20
            +33410309125820*r**22+10253922103349*r**24+4662350970446*r**26+552734600035*r**28
            -29254458800*r**30)+12*Q2**3*(-506481957+2035976417*r**2+71908453407*r**4
            +532086193845*r**6+201658695703*r**8-5359207480363*r**10-11922649425077*r**12
            -20173397064919*r**14-11603186852495*r**16+2905762751539*r**18+4761662293517*r**20
            +3071081195023*r**22+677433078637*r**24-493490325225*r**26+35930858633*r**28
            -6682825197*r**30+1303038512*r**32)+9*(-1+r**2)**2*(-47075729+1143575328*r**2
            +8618007756*r**4-141303469400*r**6-1204257446120*r**8-5311944610288*r**10
            -9456884719124*r**12+8819557143192*r**14+9604547264750*r**16-5772422228960*r**18
            -3762445265212*r**20+3121469666264*r**22+1177266876448*r**24+24216144400*r**26
            +56288168580*r**28-7434735896*r**30-1388947093*r**32+42451104*r**34)
            +3*Q2**2*(-1035152041+22641253240*r**2+153341728284*r**4-833789322840*r**6
            -4713420521640*r**8-33689341234832*r**10-81808895139620*r**12-24537352972872*r**14
            +24315344646430*r**16+9128394161680*r**18+5151195002612*r**20+34524120621720*r**22
            +11994673802592*r**24-4585080789840*r**26+1564839805460*r**28-452328079864*r**30
            -42236977965*r**32+109969496*r**34)-18*Q2*(-131024871+2788529901*r**2
            +19946023296*r**4-190875778556*r**6-1507841296280*r**8-7569201113152*r**10
            -13201123399268*r**12+6081730738132*r**14+9393840402258*r**16+813007406610*r**18
            -1939924659508*r**20-3832118432692*r**22+3976265318848*r**24+2404965880552*r**26
            -268135337580*r**28+156482632156*r**30-25561612691*r**32-4179978151*r**34
            +107300996*r**36))+138240*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(170690560*Q2**19
            -512*Q2**18*(4229103+5113532*r**2)+64*Q2**17*(197372977+470675150*r**2
            +269194973*r**4)-16*Q2**16*(2696601753+9724218362*r**2+10996816073*r**4
            +3865733832*r**6)+16*Q2**15*(5749278351+28023324216*r**2+48066782070*r**4
            +34231630384*r**6+7758615139*r**8)-Q2**14*(122499756025+751295707060*r**2
            +1693092145066*r**4+1846009993204*r**6+918193356765*r**8+107131176920*r**10)
            +2*Q2**13*(48325374619+352372598011*r**2+819953164142*r**4+976138733810*r**6
            +782308902523*r**8+276581228179*r**10-42194775044*r**12)+Q2**12*(-37011097179
            -318270735630*r**2+515909919983*r**4+4199959001900*r**6+5819437979635*r**8
            +2885668792402*r**10+840630483705*r**12+310339420944*r**14)-4*Q2**11*(2112577119
            -2710956579*r**2+892779189223*r**4+4378613790677*r**6+8016729835965*r**8
            +6591153161343*r**10+2451910315157*r**12+517686600399*r**14+62578281576*r**16)
            +Q2**10*(38814179207+201635897712*r**2+5503541819624*r**4+27193528167056*r**6
            +62765341836606*r**8+74530237262184*r**10+43036149555024*r**12+10526661477856*r**14
            +1634908838403*r**16-103811261512*r**18)+2*Q2**9*(-25984765815-267111021115*r**2
            -2803954077284*r**4-10130451164576*r**6-23406102301670*r**8-34844291093430*r**10
            -30905430402280*r**12-11540541504904*r**14+241718526629*r**16+80862851865*r**18
            +159890392580*r**20)-Q2**8*(-15766319357-654470937358*r**2-4370432547957*r**4
            -8584582965640*r**6+1515273133582*r**8+39298942575932*r**10+63782718950278*r**12
            +47530147978328*r**14+28976729095695*r**16+13429162464642*r**18+1547572434383*r**20
            +155075468672*r**22)-8*Q2**7*(-4797666753+38181242555*r**2+353435809279*r**4
            +1850232439685*r**6+2445111984780*r**8-4903563589158*r**10-19024482052550*r**12
            -23877985183442*r**14-15855130556565*r**16-6861582430245*r**18-1575788424489*r**20
            -175439352355*r**22+12119185338*r**24)+Q2**6*(-37869301779-113002403556*r**2
            +802012674638*r**4+19370353194412*r**6+50954239707095*r**8+78844320045456*r**10
            +28956709363764*r**12-80022100095464*r**14-92858971140261*r**16-57400334710980*r**18
            -28282903489922*r**20+206852764732*r**22-235355394079*r**24+128954155544*r**26)
            -2*Q2**5*(1310168131-130264416629*r**2-908521838646*r**4-50895712978*r**6
            -6743856106523*r**8+12406354860341*r**10+36927979534216*r**12-18403468220*r**14
            -26508421910771*r**16+12687417800469*r**18+19746061186098*r**20+2272560047758*r**22
            +3985980504011*r**24+314797189419*r**26+11814995324*r**28)+Q2**4*(18576137095
            -183576116210*r**2-2580043609991*r**4-13367986750244*r**6-40962919328345*r**8
            +20901435427250*r**10+118331577447665*r**12+34727580538392*r**14-141136595536227*r**16
            -159908874622990*r**18-25652297687245*r**20+33410309125820*r**22+10253922103349*r**24
            +4662350970446*r**26+552734600035*r**28-29254458800*r**30)+12*Q2**3*(
            -506481957+2035976417*r**2+71908453407*r**4+532086193845*r**6+201658695703*r**8
            -5359207480363*r**10-11922649425077*r**12-20173397064919*r**14-11603186852495*r**16
            +2905762751539*r**18+4761662293517*r**20+3071081195023*r**22+677433078637*r**24
            -493490325225*r**26+35930858633*r**28-6682825197*r**30+1303038512*r**32)
            +9*(-1+r**2)**2*(-47075729+1143575328*r**2+8618007756*r**4-141303469400*r**6
            -1204257446120*r**8-5311944610288*r**10-9456884719124*r**12+8819557143192*r**14
            +9604547264750*r**16-5772422228960*r**18-3762445265212*r**20+3121469666264*r**22
            +1177266876448*r**24+24216144400*r**26+56288168580*r**28-7434735896*r**30
            -1388947093*r**32+42451104*r**34)+3*Q2**2*(-1035152041+22641253240*r**2
            +153341728284*r**4-833789322840*r**6-4713420521640*r**8-33689341234832*r**10
            -81808895139620*r**12-24537352972872*r**14+24315344646430*r**16+9128394161680*r**18
            +5151195002612*r**20+34524120621720*r**22+11994673802592*r**24-4585080789840*r**26
            +1564839805460*r**28-452328079864*r**30-42236977965*r**32+109969496*r**34)
            -18*Q2*(-131024871+2788529901*r**2+19946023296*r**4-190875778556*r**6
            -1507841296280*r**8-7569201113152*r**10-13201123399268*r**12+6081730738132*r**14
            +9393840402258*r**16+813007406610*r**18-1939924659508*r**20-3832118432692*r**22
            +3976265318848*r**24+2404965880552*r**26-268135337580*r**28+156482632156*r**30
            -25561612691*r**32-4179978151*r**34+107300996*r**36))*sqrtq2)+logq2**2*(2304*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1183152128*Q2**22-512*Q2**21*(27098593
            +28673018*r**2)+32*Q2**20*(2213220429+4848424762*r**2+2418690029*r**4)
            -160*Q2**19*(1271304525+4438120126*r**2+4630707301*r**4+1349472900*r**6)
            +40*Q2**18*(8797176184+45391787431*r**2+72953637301*r**4+47061638605*r**6
            +7417743431*r**8)-Q2**17*(351398654667+2712519478560*r**2+5383293010590*r**4
            +5204228945700*r**6+2334419064055*r**8+5412565532*r**10)+Q2**16*(132792893169
            +1941777702589*r**2+899983558310*r**4-3766571659170*r**6-2040668684615*r**8
            -317020457371*r**10-648800542416*r**12)+2*Q2**15*(67098747539+390929585697*r**2
            +8966966031139*r**4+30229280626410*r**6+34522603006205*r**8+14522854421029*r**10
            +2949916985357*r**12+442745409424*r**14)-10*Q2**14*(23230364685+337419845222*r**2
            +4029470131048*r**4+16299240314817*r**6+26979318811105*r**8+19579527746036*r**10
            +5517173511162*r**12+863919468517*r**14+4946901680*r**16)+10*Q2**13*(10285950857
            +348305148363*r**2+4083454884812*r**4+20787566212869*r**6+45057865050068*r**8
            +48057625122909*r**10+23064997802784*r**12+2614502503323*r**14+267297118775*r**16
            -102993249352*r**18)+2*Q2**12*(75615418129-805887499510*r**2-10103366300745*r**4
            -61883699906175*r**6-122417510093735*r**8-121012697071819*r**10-75954539376795*r**12
            +6450372614475*r**14+30457196770650*r**16+3959475469045*r**18+453524831264*r**20)
            +2*Q2**11*(-138914964393+13031333777*r**2+2795914786405*r**4+4395284162160*r**6
            -174350163124930*r**8-631152258119942*r**10-796671624812742*r**12-465112769033400*r**14
            -196537948338645*r**16-51772533248115*r**18-5476211257183*r**20+108931085872*r**22)
            +Q2**10*(97428813798+909286373164*r**2+2751914225188*r**4+57375133379310*r**6
            +839577677824220*r**8+3179000310607752*r**10+5431834574286456*r**12+4397042579303372*r**14
            +1741184522717310*r**16+497205945454140*r**18+30424178194708*r**20+2343943136854*r**22
            -783802524912*r**24)+10*Q2**9*(16008146570-170681571133*r**2-1809839250556*r**4
            -10624661599501*r**6-82512137386080*r**8-300121684181798*r**10-642308967251312*r**12
            -753393808228010*r**14-416152035142646*r**16-84197304704665*r**18-17821872794548*r**20
            +6528730242647*r**22+684256308332*r**24+30850228060*r**26)+10*Q2**8*(
            -15283054422+113217001227*r**2+1994429119839*r**4+11935518038967*r**6
            +50452995121967*r**8+93153599203888*r**10+99905892600126*r**12+94651719457590*r**14
            +40387303492632*r**16-111966519672357*r**18-125709595521741*r**20-25790679191085*r**22
            -6549056038833*r**24-615915825110*r**26+23786754032*r**28)+2*Q2**7*(-13388676951
            +410729916235*r**2+239417346125*r**4-43182387309150*r**6-215461003347535*r**8
            -539867084624479*r**10+96778235179485*r**12+2595217055746140*r**14+4499979542753875*r**16
            +4131020515467405*r**18+2754441808750991*r**20+981627846480530*r**22+202825526666835*r**24
            +2028274282375*r**26-101289013945*r**28-116432654736*r**30)+2*Q2**6*(42846356077
            -746165758818*r**2-5820800077900*r**4+20995839506385*r**6+180274138987895*r**8
            +1166693505585268*r**10+2068949413672058*r**12+1590617677629715*r**14
            -1159530808931205*r**16-2695863551419810*r**18-2493542314448112*r**20
            -1895783116905977*r**22-212515338588015*r**24-87842399373680*r**26+12602383505090*r**28
            +1458074365717*r**30+4989527312*r**32)+2*Q2**5*(-9217707621+141021442477*r**2
            +1921165351664*r**4+12641553371535*r**6+73749224063590*r**8-251154538207219*r**10
            +3645734709588*r**12-1292294345915489*r**14-1610247279251920*r**16+257441306879415*r**18
            -880428676651384*r**20-1155682792794347*r**22+216737678328066*r**24-468477986107465*r**26
            -56405980299980*r**28-6890914909251*r**30-603728411443*r**32+31230189784*r**34)
            -10*Q2**4*(2186084485-57568321746*r**2-208123933045*r**4+6998439066657*r**6
            +39890784796515*r**8+106645915232061*r**10+281598972404751*r**12-171937968210051*r**14
            -538752322056359*r**16+476590090019605*r**18+943909536078513*r**20+176630273158051*r**22
            -198679053240303*r**24-33998850835353*r**26-61934784439995*r**28-15599600076609*r**30
            -75223725906*r**32+39135476249*r**34+2298202480*r**36)-30*Q2**3*(-345755443
            +10022156563*r**2+29574249035*r**4-1122335390748*r**6-3595260250172*r**8
            -12835702947936*r**10+28981673802500*r**12+235772240887988*r**14+356379075487126*r**16
            +357881054107422*r**18+18303126773986*r**20-154501956947204*r**22-84226212314796*r**24
            -34936466169448*r**26+16397789174532*r**28-2388677741732*r**30+1290107179141*r**32
            -65632751977*r**34-13223530805*r**36+141341968*r**38)+9*(-1+r**2)**2*(38042307
            -1734590805*r**2+6418977975*r**4+416164036455*r**6-1424288853780*r**8
            -25540658816148*r**10-98871987139060*r**12-332869929633700*r**14-298494740022790*r**16
            +990740882183290*r**18+14014341669202*r**20-672662415846590*r**22+196784182973100*r**24
            +138745019981340*r**26-23310301432740*r**28+10273366148812*r**30+138105648955*r**32
            -353510526125*r**34-9138747505*r**36+926903855*r**38+7843952*r**40)+6*Q2**2*(303452843
            -10985495190*r**2-2800666070*r**4+2432603451475*r**6+7242524440620*r**8
            -69398652388012*r**10-138511160182980*r**12-943748840170240*r**14-1881538038771050*r**16
            -396744960955160*r**18+400352114778928*r**20+433397608498030*r**22+965995892526440*r**24
            +440220188316300*r**26-323426319524540*r**28+135141427886808*r**30-24075255352985*r**32
            -4399665390130*r**34-210235109850*r**36-7722011545*r**38+759866308*r**40)
            -9*Q2*(221460769-9008808426*r**2+19346595730*r**4+1816673567130*r**6
            -2168750756715*r**8-69825074035516*r**10-236117911484776*r**12-976854475767240*r**14
            -947381363116990*r**16+1580603513821620*r**18+1225682609345484*r**20-834612766306116*r**22
            -1119324568493710*r**24+577278512265840*r**26+493594168776280*r**28-152491925839496*r**30
            +53787542839389*r**32-1654282353530*r**34-1965787697230*r**36-57372194310*r**38
            +3578750009*r**40+114631804*r**42))-2304*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(1183152128*Q2**23-512*Q2**22*(29409437+30983862*r**2)+32*Q2**21*(2646797917
            +5740770538*r**2+2877458317*r**4)-32*Q2**20*(8569743054+29252245821*r**2
            +30420651296*r**4+9166054529*r**6)+40*Q2**19*(13882394284+68229486035*r**2
            +109228947009*r**4+70982359409*r**6+12815635031*r**8)-Q2**18*(703285702027
            +4880078023160*r**2+10117109999870*r**4+10004839981940*r**6+4513594345495*r**8
            +302122302772*r**10)+Q2**17*(484191547836+5005695835816*r**2+8995796047460*r**4
            +6820950297120*r**6+5497979325140*r**8+2022811172216*r**10-643387976884*r**12)
            +Q2**16*(1404601909-1292711424364*r**2+15092170801379*r**4+63325149353680*r**6
            +74852446356195*r**8+31403397984044*r**10+6865654970501*r**12+1534291361264*r**14)
            -4*Q2**15*(91625285482+1072563779673*r**2+14752623136038*r**4+60346224115817*r**6
            +99824238844070*r**8+73471548078707*r**10+22529319481098*r**12+3856129868683*r**14
            +233739958912*r**16)-20*Q2**14*(-16758157771-354477679135*r**2-4225172430541*r**4
            -20558138329367*r**6-44168212087995*r**8-47308235840025*r**10-24080849529991*r**12
            -4497797741501*r**14-568081744486*r**16+49023173836*r**18)+4*Q2**13*(12092831922
            -1299421497805*r**2-16131083233310*r**4-93119402697290*r**6-225822333204210*r**8
            -293295073968352*r**10-215783827002630*r**12-60973564458030*r**14+8024099330080*r**16
            +1568978060965*r**18+484245539012*r**20)-4*Q2**12*(107265191261-371651707579*r**2
            -6852584293330*r**4-38191175184540*r**6-4975523437490*r**8+193861025477194*r**10
            +299852194182064*r**12+197804301135540*r**14+116722758861885*r**16+43094602743905*r**18
            +4944605778746*r**20+172296872696*r**22)+4*Q2**11*(93814685646+290263408599*r**2
            -716494503794*r**4+10748183870545*r**6+294871858937440*r**8+1197501288274374*r**10
            +2071870585037956*r**12+1730152841748914*r**14+766121489365350*r**16+248456727156915*r**18
            +36230416801326*r**20+3269625869869*r**22-250416174164*r**24)+2*Q2**10*(31326325951
            -1356765449146*r**2-10879796551956*r**4-83186831799754*r**6-861037092532165*r**8
            -3509897415124976*r**10-7516962278703664*r**12-8681407617934964*r**14
            -5149873726723571*r**16-1540181757609050*r**18-352924425797164*r**20+16259590547454*r**22
            +2641211235689*r**24+546152402756*r**26)-20*Q2**9*(15645600496-133945212895*r**2
            -1987474970764*r**4-12185009444512*r**6-71794897053774*r**8-237893710385883*r**10
            -521168272016618*r**12-745177247468456*r**14-604966573431644*r**16-194191410087477*r**18
            +11845209011264*r**20+7248768319592*r**22+6881021294906*r**24+665511180751*r**26
            +3531737014*r**28)-2*Q2**8*(-63026595159+78939817790*r**2+10298813259205*r**4
            +112832123103180*r**6+527403569152205*r**8+1257900056253754*r**10+868519223840585*r**12
            -1622428995457560*r**14-3824784428002765*r**16-4488916596366030*r**18
            -3942822384721481*r**20-1739129220044660*r**22-364524202816425*r**24-37853133602090*r**26
            -2859356341445*r**28+235366424896*r**30)+4*Q2**7*(28117516514-571753499051*r**2
            -3235473670130*r**4+31969404734705*r**6+219458764822290*r**8+961010796778641*r**10
            +1256019131558526*r**12-550688806647955*r**14-4127363703715610*r**16-5663431804820545*r**18
            -4689502319333254*r**20-2815926386068749*r**22-698484355867690*r**24-146348100161445*r**26
            +5337699118330*r**28+837898017199*r**30+60711091024*r**32)+4*Q2**6*(-26032031849
            +422170422609*r**2+4244065594191*r**4-1266743028475*r**6-63760377215345*r**8
            -799061091390191*r**10-1615998592273869*r**12-2475930718608631*r**14-1020667073975215*r**16
            +2056417833615215*r**18+2154488594608269*r**20+1616821319279871*r**22
            +1162518066911029*r**24-84060124072885*r**26+9417017784305*r**28-10475686390029*r**30
            -1033396152236*r**32+13120331236*r**34)-4*Q2**5*(856357402-78018936937*r**2
            +510783564458*r**4+24777457028242*r**6+142922350708850*r**8+177912131008338*r**10
            +580243029263062*r**12-1074169226128078*r**14-2798151617724602*r**16+515072238862760*r**18
            +2048280155310298*r**20-576480051827738*r**22-966170190333898*r**24-210867280978082*r**26
            -417278944303710*r**28-70647447796138*r**30-3935380975112*r**32-188410420207*r**34
            +21360601092*r**36)+20*Q2**4*(1611675407-42724353475*r**2-177207500948*r**4
            +5078660652928*r**6+28837502306844*r**8+92521904436192*r**10+150649933114656*r**12
            -298827859234632*r**14-889913758363894*r**16-567902697179510*r**18+682795122888080*r**20
            +792022840039088*r**22+115314928431068*r**24-63934252783656*r**26-72563501399472*r**28
            -35184175645704*r**30-9772572669969*r**32+80405003137*r**34+40552135572*r**36
            +937088288*r**38)+12*Q2**3*(-712662186+18698255205*r**2+97590680960*r**4
            -1515601128545*r**6-8172726881990*r**8-75776734189276*r**10-28890652955080*r**12
            +190010366641100*r**14+539609271552260*r**16+1587277843508790*r**18+1140636509592984*r**20
            -123798271184030*r**22-113822476891780*r**24-77796602052460*r**26-208059852249560*r**28
            +102593492525404*r**30-14784054082970*r**32+861353372845*r**34-302258261880*r**36
            -36566477865*r**38+733288074*r**40)-9*(-1+r**2)**2*(38042307-1696548498*r**2
            +4684387170*r**4+422583014430*r**6-1008124817325*r**8-26964947669928*r**10
            -124412645955208*r**12-431741916772760*r**14-631364669656490*r**16+692246142160500*r**18
            +1004755223852492*r**20-658648074177388*r**22-475878232873490*r**24+335529202954440*r**26
            +115434718548600*r**28-13036935283928*r**30+10411471797767*r**32-215404877170*r**34
            -362649273630*r**36-8211843650*r**38+934747807*r**40+7843952*r**42)-3*Q2**2*(1271287993
            -48390509972*r**2+30467464670*r**4+10309626272200*r**6+12844003514045*r**8
            -333787478001332*r**10-1124173359596312*r**12-5095083428008160*r**14-8492717847233550*r**16
            +185244542012440*r**18+3684262135683988*r**20-836338852364432*r**22-559186703432190*r**24
            +4544267698483000*r**26+1714370243912360*r**28-834045560793952*r**30+383494973585813*r**32
            -61912688546820*r**34-15117164091650*r**36-608030825720*r**38-3188040447*r**40
            +1863628028*r**42)+36*Q2*(64875769-2649505769*r**2+5065997299*r**4+559402913140*r**6
            -650568784575*r**8-23567435466091*r**10-88789485970209*r**12-343409750355936*r**14
            -413965676694670*r**16+472020645824950*r**18+135080990111734*r**20+170279906509416*r**22
            -99453494616086*r**24-367382954509830*r**26+241714130654950*r**28+134185307983104*r**30
            -35605827770379*r**32+15444226202659*r**34-696020524265*r**36-589366504700*r**38
            -16194538891*r**40+1151149441*r**42+30618939*r**44))*sqrtq2)+logq2*(
            -192*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(-17059584*Q2**21+96*Q2**20*(2735313
            +2293619*r**2)-8*Q2**19*(202030033+390121853*r**2+145959852*r**4)+8*Q2**18*(661000525
            +2041403717*r**2+1811655535*r**4+395351523*r**6)-Q2**17*(9753371711+41134868545*r**2
            +48602091109*r**4+30929292639*r**6+3881793276*r**8)+Q2**16*(8809614319
            +45652022732*r**2-7672904026*r**4-29663969092*r**6+15059712779*r**8-1355559720*r**10)
            +2*Q2**15*(236681620+5321137445*r**2+205882750687*r**4+453195162847*r**6
            +251810442633*r**8+34876301116*r**10+5486446404*r**12)-2*Q2**14*(3928216234
            +45915032399*r**2+551022851702*r**4+1681529595074*r**6+1767644599626*r**8
            +597285934499*r**10+75844031574*r**12+5915393676*r**14)+2*Q2**13*(680493170
            +54677416471*r**2+715368078479*r**4+2936655005704*r**6+4495490412720*r**8
            +2943031038371*r**10+455857002051*r**12+40710714430*r**14-1800895476*r**16)
            +2*Q2**12*(5456884624-30817534015*r**2-502998542450*r**4-2477470035345*r**6
            -3705928991764*r**8-3239741401149*r**10-1247422912562*r**12+521572487161*r**14
            +58572383656*r**16+9141353364*r**18)-2*Q2**11*(5199439444-7200577057*r**2
            -106671872383*r**4+31260201419*r**6+6252112935797*r**8+14669987347209*r**10
            +10049977920231*r**12+3936708155641*r**14+1389470100707*r**16+99482463636*r**18
            +5606305068*r**20)+2*Q2**10*(-772945034+11880312893*r**2+241189621458*r**4
            +2378822674236*r**6+18420555846972*r**8+51434270408818*r**10+58375528814348*r**12
            +26487831736464*r**14+7801517191806*r**16+869059523401*r**18+28431549938*r**20
            -4005087684*r**22)+2*Q2**9*(3557004239-23799676466*r**2-361979978122*r**4
            -2433430363617*r**6-17144532130218*r**8-56842465171764*r**10-95057514212724*r**12
            -70750978738994*r**14-16687398105477*r**16-4795590146218*r**18+572694339694*r**20
            +52619303459*r**22+6667470576*r**24)-2*Q2**8*(938345765-6495131729*r**2
            -136467845372*r**4-1461190433901*r**6-7820109599505*r**8-19522348810038*r**10
            -30861291686456*r**12-33621666249722*r**14-2169305580429*r**16+21352059656195*r**18
            +2966054199412*r**20+1201821861031*r**22+51643131705*r**24+1281888324*r**26)
            -2*Q2**7*(1483030244-21650640335*r**2-150955388501*r**4+1578883294279*r**6
            +7549415045233*r**8+15182783379110*r**10-6372041264254*r**12-60281076081538*r**14
            -64893029193418*r**16-66608222306355*r**18-38046700947617*r**20-6915838394309*r**22
            -526339392779*r**24-5312997284*r**26+2777688564*r**28)+2*Q2**6*(974541890
            -18968194637*r**2-139722834802*r**4+1170842551886*r**6+6442479012798*r**8
            +31510009290977*r**10+41488499496418*r**12+8771432650416*r**14-44746181641778*r**16
            -34014325551499*r**18-56930668374046*r**20-8842631232826*r**22-3537149984974*r**24
            +311513742327*r**26+17568008366*r**28+1773997884*r**30)+2*Q2**5*(191036362
            -3424655119*r**2-16342058527*r**4+986258020472*r**6+4016520954972*r**8
            -8229298748533*r**10+6017323966915*r**12-49227951666594*r**14+4307208156046*r**16
            -7278226472601*r**18-50354218024889*r**20+32040038883116*r**22-20152483796584*r**24
            -1356966743523*r**26-446364393451*r**28-11138810370*r**30+275056308*r**32)
            -2*Q2**4*(351649748-10255601027*r**2-46455038482*r**4+1940979486559*r**6
            +6702745803156*r**8+6726185256697*r**10+39666406976082*r**12-50005750452889*r**14
            -57664561361208*r**16+126580125681163*r**18+37562653034642*r**20-57288410215403*r**22
            +25928285634404*r**24-14712430656501*r**26-2301159184594*r**28-149934932187*r**30
            -1208053652*r**32+607077492*r**34)+2*Q2**3*(61646120-2648380193*r**2
            -5179991491*r**4+590593702803*r**6+918307277725*r**8+1560755192931*r**10
            -5600596499867*r**12-92427605237393*r**14-66139722748703*r**16-70758846436475*r**18
            +51373377516683*r**20+35883475600873*r**22+870226889799*r**24-1855859342383*r**26
            +1023088175175*r**28-721161614059*r**30+50702099987*r**32+1809190760*r**34
            +131757708*r**36)+3*(-1+r**2)**2*(2366977-130238000*r**2+495339861*r**4
            +46440425352*r**6-264655753700*r**8-2381279857976*r**10-3682235868420*r**12
            -21024932691368*r**14-5673390042746*r**16+88445637491240*r**18-72623488078354*r**20
            -6366668339160*r**22+27208928336028*r**24-9249799833064*r**26+2287278918620*r**28
            -110390929272*r**30-23973279295*r**32-1793351896*r**34-23600667*r**36
            +3945840*r**38)+2*Q2**2*(50423038-1900154485*r**2-3292560934*r**4+496586039756*r**6
            +97162980560*r**8-9705279610176*r**10-1607982730392*r**12-72315513507580*r**14
            -69659600023220*r**16+10280721374318*r**18+3168443760988*r**20+43599743003164*r**22
            +83304213939712*r**24-68159661894728*r**26+26757452207784*r**28-4259609738100*r**30
            -211050875162*r**32-60789417073*r**34-1196895558*r**36+72638088*r**38)
            -3*Q2*(16935709-814313351*r**2+1409557837*r**4+246569767989*r**6-793277276648*r**8
            -7264470316388*r**10-5112967211892*r**12-73917348147476*r**14+11306292872638*r**16
            +91756712958934*r**18+64405707630350*r**20-139853494257538*r**22-24192176357484*r**24
            +104282310565532*r**26-45626755246324*r**28+12153552472428*r**30-914942683219*r**32
            -118255605127*r**34-13757724659*r**36-240952587*r**38+27171276*r**40))
            +192*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(136476672*Q2**25-1536*Q2**24*(1445402
            +1224555*r**2)+32*Q2**23*(457769855+886917502*r**2+336353919*r**4)-8*Q2**22*(6466050795
            +20419647238*r**2+18141467563*r**4+3985469808*r**6)+8*Q2**21*(12874091231
            +58635956182*r**2+75307927120*r**4+44659647818*r**6+5551362033*r**8)
            +Q2**20*(-97673536481-651296048392*r**2-530496001594*r**4-275491342364*r**6
            -289738592837*r**8+8654084292*r**10)-4*Q2**19*(5352124868-23661801655*r**2
            +816972839065*r**4+1981227492950*r**6+1089646738890*r**8+162404931233*r**10
            +32607503385*r**12)+2*Q2**18*(70614202595+544520371072*r**2+6145008216509*r**4
            +19423142801910*r**6+20331961313485*r**8+6885804640900*r**10+970379579027*r**12
            +82062286854*r**14)+4*Q2**17*(-14934525785-407892687136*r**2-4862672105966*r**4
            -21322204413346*r**6-33431798065290*r**8-21407399874140*r**10-3740385269726*r**12
            -372460250786*r**14+9630281199*r**16)+Q2**16*(-160627209557+857735586016*r**2
            +14799193245940*r**4+93017180066184*r**6+178002157936894*r**8+168040256663648*r**10
            +63259775005676*r**12-8042343548520*r**14-1379840531081*r**16-283141701216*r**18)
            +16*Q2**15*(11953970494+18542867993*r**2-784657254*r**4-868649118564*r**6
            +5707842101163*r**8+17179095396310*r**10+11983486870503*r**12+6097072799756*r**14
            +2453011774211*r**16+214569826153*r**18+12190060947*r**20)+8*Q2**14*(4432211431
            -119121751660*r**2-1563994840815*r**4-12416653991410*r**6-82903938300220*r**8
            -231474415433006*r**10-256312431184720*r**12-117146478029000*r**14-35729244669675*r**16
            -4230642885290*r**18-193456483809*r**20+19983726750*r**22)-16*Q2**13*(11084357330
            -58253770424*r**2-797196971203*r**4-7988622903660*r**6-58316545413000*r**8
            -212311836625800*r**10-342185379730046*r**12-242542541916262*r**14-65912513770620*r**16
            -14770709285940*r**18+920178097685*r**20+125869508806*r**22+17830110942*r**24)
            +2*Q2**12*(26222845015+19506844328*r**2-633521649142*r**4-33292568557172*r**6
            -288600969666915*r**8-1363508428409180*r**10-2815615323990868*r**12-2901901676283888*r**14
            -1087535978050263*r**16+157858781923960*r**18+52480856084570*r**20+24163953576068*r**22
            +1356842510803*r**24+18286641948*r**26)+8*Q2**11*(12028001176-152286419323*r**2
            -1127280690385*r**4+3735342037138*r**6+21672923689348*r**8+60158710342099*r**10
            -149448088878477*r**12-513657278307420*r**14-469796639906528*r**16-438770400171173*r**18
            -225603932657179*r**20-46865123592358*r**22-3106653135500*r**24-53114725187*r**26
            +22188690633*r**28)-4*Q2**10*(16549072399-230468490272*r**2-1618553321239*r**4
            +4245600193606*r**6-4878922457397*r**8-272931258503464*r**10-2483970173198443*r**12
            -6800486471506086*r**14-7901514778742171*r**16-4390179684629088*r**18
            -1950279164776205*r**20-319281845315542*r**22-58809878425919*r**24+4696545432936*r**26
            +336537382543*r**28+25298084982*r**30)-8*Q2**9*(3235921199-56576154140*r**2
            -221575902040*r**4+6500681523630*r**6+38021637202300*r**8+193581663479496*r**10
            +1436944647353320*r**12+4483896495986870*r**14+7477193194989430*r**16
            +5760558122436580*r**18+1991691241715176*r**20+725159373696650*r**22-67437356528460*r**24
            -14191983688400*r**26-3439971922040*r**28-125513454766*r**30+6345757995*r**32)
            +2*Q2**8*(18236373775-412194422128*r**2-1631865506216*r**4+44237206550960*r**6
            +182549912109720*r**8+671708104360640*r**10+2803388518117008*r**12+6072195872567096*r**14
            +12139278441737070*r**16+15690524773740360*r**18+4341304720339960*r**20
            -3686461830050272*r**22-622633477484224*r**24-591070324441200*r**26-115682904017120*r**28
            -2664515165960*r**30+27204726187*r**32+31378729944*r**34)-16*Q2**7*(11499700
            -3498164621*r**2-24478840886*r**4+338273604144*r**6+3406129811035*r**8
            +89823891256980*r**10+240160975849611*r**12+218278911210056*r**14-833854619794649*r**16
            -2288504377106270*r**18-2396693802588965*r**20-2523753983793824*r**22
            -1402248714613999*r**24-415405070219084*r**26-26805738842815*r**28-4806138625240*r**30
            +610424890809*r**32+26944060579*r**34+45892239*r**36)-16*Q2**6*(741268057
            -23000014081*r**2-14174538000*r**4+3972925647621*r**6+2914076573691*r**8
            -92247484626127*r**10-322343673703509*r**12-1400794060300310*r**14-1445698146147071*r**16
            +103281628356049*r**18+1649845942055503*r**20+2002635374296026*r**22+2399979704701305*r**24
            +411312343223199*r**26+300542572856689*r**28-12894068613558*r**30-3813509243086*r**32
            -397618133920*r**34-12141188699*r**36+1256938221*r**38)+8*Q2**5*(367388193
            -16363896534*r**2+24140555082*r**4+3407610896422*r**6-4493452973369*r**8
            +16104767309880*r**10+78917427385904*r**12-1361179911451652*r**14-432096111046602*r**16
            -2418716717142396*r**18-607998272680100*r**20-2848545032097456*r**22-2777980612997422*r**24
            +2199300574405928*r**26-1402793295653616*r**28-105469306274732*r**30-29862114402439*r**32
            -7044688678158*r**34+68019544602*r**36+5737666106*r**38+688222359*r**40)
            +Q2**4*(2033486963-77932857480*r**2+176279462710*r**4+17885654539620*r**6
            -43240538655405*r**8-1440056255460652*r**10-3818972824157240*r**12-6791760453211040*r**14
            -25302842151769290*r**16+15863047650458320*r**18+19638065017655588*r**20
            -74574065456572600*r**22-15752447369735250*r**24+29099145196426920*r**26
            -9220568680148600*r**28+5829116521857728*r**30+2825672203620215*r**32
            +102888980893080*r**34+7743664305750*r**36-1826096980940*r**38-72203833377*r**40
            +3203554980*r**42)-12*Q2**3*(81529860-4184574397*r**2+23391441791*r**4
            +1081208612650*r**6-7041996234070*r**8-49590838565585*r**10-13705267443137*r**12
            -173250279118584*r**14+1252237188888320*r**16+5427387853376150*r**18+4961122632892830*r**20
            +3246144440119148*r**22-2613816291982244*r**24-2689404583671290*r**26
            -436769062649290*r**28+525757081887080*r**30-254995113696372*r**32+80672507379751*r**34
            +1110832432195*r**36-727737622790*r**38-38521212310*r**40-1402712117*r**42
            +142842411*r**44)-9*(-1+r**2)**2*(2366977-163375678*r**2+2096176023*r**4
            +51714901620*r**6-959557956585*r**8-3048564285318*r**10+53883652375977*r**12
            +258118297093408*r**14+667879101525850*r**16+2193386793378180*r**18-486896927126858*r**20
            -7245125231511688*r**22+5699037849529438*r**24+1313466497931780*r**26
            -2409344918335230*r**28+450057223474512*r**30-56776592620843*r**32-30561124783942*r**34
            +6111323508035*r**36+394144414260*r**38+3296868187*r**40-1833851518*r**42
            -78842427*r**44+3945840*r**46)-6*Q2**2*(16735055-630398976*r**2+501872129*r**4
            +203144278334*r**6+56218292325*r**8-50022847934500*r**10-10886846425061*r**12
            +832748159981814*r**14-213510311292586*r**16+6446085974588400*r**18+9990353192672970*r**20
            +1378758190998364*r**22-1149882123256566*r**24-8909859477759096*r**26
            -5980759129536650*r**28+6233247187873340*r**30-2316210818265141*r**32
            +266068362837424*r**34+63136053521989*r**36+3831211976550*r**38+767660324385*r**40
            -27699250436*r**42-1289904801*r**44+18070734*r**46)+36*Q2*(3642183-222601144*r**2
            +2250287630*r**4+66169439614*r**6-875576077726*r**8-5245216085252*r**10
            +35764466334886*r**12+174346794533070*r**14+357325470139049*r**16+1762402685381344*r**18
            +61014741218108*r**20-3024879350691844*r**22-1436559502530340*r**24+3811398117138344*r**26
            +346411830613724*r**28-2287144954496692*r**30+768981917615481*r**32-140143736937800*r**34
            -21889137646666*r**36+8214417983174*r**38+464463859778*r**40+24379311996*r**42
            -2874823810*r**44-136613466*r**46+5806359*r**48))*sqrtq2))/(1134000*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2
            +1134000*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2
            +logq2**7*(-9142485811200000*r**32*(1+r**2)**2*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3-9142485811200000*r**32*(1+r**2)**2*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**6*(50791587840000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))+50791587840000*r**28*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))*sqrtq2)+logq2*(-68040000*(-Q2
            +(-1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(9+8*Q2**4-78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)
            -Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-68040000*(-Q2+(-1+r)**2)**3*r**8*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(9+8*Q2**4-78*r**2-366*r**4
            -78*r**6+9*r**8-Q2**3*(1+r**2)-Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1
            +13*r**2+13*r**4+r**6))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*sqrtq2)+logq2**2*(816480000*(-Q2+(-1+r)**2)**3*r**12*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531
            +550*r**2+531*r**4)-2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815
            -2120*r**2-11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4
            +494*r**6+225*r**8+r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6
            +26793*r**8+4554*r**10-501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6
            -1385*r**8-311*r**10+15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6
            +34670*r**8+13388*r**10-184*r**12-316*r**14+17*r**16))+816480000*(
            -Q2+(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531+550*r**2+531*r**4)
            -2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815-2120*r**2-11502*r**4
            -2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4+494*r**6+225*r**8
            +r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6+26793*r**8+4554*r**10
            -501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6-1385*r**8-311*r**10
            +15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6+34670*r**8+13388*r**10
            -184*r**12-316*r**14+17*r**16))*sqrtq2)+logq2**3*(-9797760000*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8+256*Q2**7*(1+r**2)
            -Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2+893*r**4+319*r**6)
            +Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)+12*Q2**3*(61
            +235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(-1071+9654*r**2
            +51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)-18*Q2*(23
            -35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12+23*r**14)
            +9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10-264*r**12
            -756*r**14+47*r**16))-9797760000*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8
            +256*Q2**7*(1+r**2)-Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2
            +893*r**4+319*r**6)+Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)
            +12*Q2**3*(61+235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(
            -1071+9654*r**2+51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)
            -18*Q2*(23-35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12
            +23*r**14)+9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10
            -264*r**12-756*r**14+47*r**16))*sqrtq2)+logq2**4*(117573120000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513+770*r**2
            +513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105-3400*r**2
            -11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4-1178*r**6
            +75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6+19593*r**8
            +3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6-5785*r**8
            -2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4+25204*r**6
            +52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))+117573120000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513
            +770*r**2+513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105
            -3400*r**2-11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4
            -1178*r**6+75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6
            +19593*r**8+3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6
            -5785*r**8-2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4
            +25204*r**6+52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))*sqrtq2)
            +logq2**5*(-282175488000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(64*Q2**8+1088*Q2**7*(1+r**2)+Q2**6*(-63+130*r**2-63*r**4)
            -2*Q2**5*(2777+6379*r**2+6379*r**4+2777*r**6)+Q2**4*(1555-8080*r**2
            -22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743-315*r**2-6548*r**4-6548*r**6
            -315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2+199629*r**4+305844*r**6
            +199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83-375*r**2-2833*r**4
            -5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)+9*(301-4028*r**2
            +808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12-4028*r**14+301*r**16))
            -282175488000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(64*Q2**8+1088*Q2**7*(1
            +r**2)+Q2**6*(-63+130*r**2-63*r**4)-2*Q2**5*(2777+6379*r**2+6379*r**4
            +2777*r**6)+Q2**4*(1555-8080*r**2-22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743
            -315*r**2-6548*r**4-6548*r**6-315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2
            +199629*r**4+305844*r**6+199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83
            -375*r**2-2833*r**4-5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)
            +9*(301-4028*r**2+808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12
            -4028*r**14+301*r**16))*sqrtq2))+((-128*(Q2-(-1+r)**2)**6*r**6*(Q2-(1
            +r)**2)**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(-76*Q2**18
            -1655*Q2**17*(1+r**2)+Q2**16*(24641+240282*r**2+24641*r**4)-2*Q2**15*(67052
            +1239319*r**2+1239319*r**4+67052*r**6)+2*Q2**14*(200630+5196941*r**2
            +10737758*r**4+5196941*r**6+200630*r**8)-2*Q2**13*(364271+10502218*r**2
            +33344179*r**4+33344179*r**6+10502218*r**8+364271*r**10)+2*Q2**12*(396895
            +7352403*r**2+32725445*r**4+25335010*r**6+32725445*r**8+7352403*r**10
            +396895*r**12)+Q2**11*(-436868+21196582*r**2+93925958*r**4+504706920*r**6
            +504706920*r**8+93925958*r**10+21196582*r**12-436868*r**14)+2*Q2**10*(9196
            -26363243*r**2-144927450*r**4-722256637*r**6-1256223124*r**8-722256637*r**10
            -144927450*r**12-26363243*r**14+9196*r**16)+2*Q2**9*(10340+16502833*r**2
            +116475899*r**4+616851113*r**6+1763341775*r**8+1763341775*r**10+616851113*r**12
            +116475899*r**14+16502833*r**16+10340*r**18)+2*Q2**8*(90706+8523301*r**2
            +4202778*r**4+220986468*r**6-348329604*r**8-346198786*r**10-348329604*r**12
            +220986468*r**14+4202778*r**16+8523301*r**18+90706*r**20)-2*Q2**7*(96520
            +16635921*r**2+51099145*r**4+656884620*r**6+933398020*r**8+2345717246*r**10
            +2345717246*r**12+933398020*r**14+656884620*r**16+51099145*r**18+16635921*r**20
            +96520*r**22)+Q2**6*(-3812+8294270*r**2+65701316*r**4+607983910*r**6
            +1093256180*r**8+2997480060*r**10+5433674392*r**12+2997480060*r**14+1093256180*r**16
            +607983910*r**18+65701316*r**20+8294270*r**22-3812*r**24)+2*Q2**5*(57139
            +5931658*r**2-44246213*r**4-60771425*r**6-542469152*r**8-63245533*r**10
            -191986714*r**12-191986714*r**14-63245533*r**16-542469152*r**18-60771425*r**20
            -44246213*r**22+5931658*r**24+57139*r**26)+Q2**4*(-61190-8518798*r**2
            +93018086*r**4+259089092*r**6+1846824690*r**8+2159917710*r**10-2006830034*r**12
            +3025991288*r**14-2006830034*r**16+2159917710*r**18+1846824690*r**20
            +259089092*r**22+93018086*r**24-8518798*r**26-61190*r**28)-2*Q2**3*(4522
            +43083*r**2+3761699*r**4+56046364*r**6+307379128*r**8+806473053*r**10
            -1930075211*r**12+2192162562*r**14+2192162562*r**16-1930075211*r**18
            +806473053*r**20+307379128*r**22+56046364*r**24+3761699*r**26+43083*r**28
            +4522*r**30)+(-1+r**2)**2*(1059+100426*r**2-5962868*r**4-39610434*r**6
            -45812148*r**8-1199964502*r**10+5924088692*r**12-17894752434*r**14+26088368418*r**16
            -17894752434*r**18+5924088692*r**20-1199964502*r**22-45812148*r**24-39610434*r**26
            -5962868*r**28+100426*r**30+1059*r**32)+2*Q2**2*(10390+1018783*r**2
            -24542950*r**4-76014915*r**6-227146500*r**8-1096488257*r**10+1651864934*r**12
            +88497125*r**14-3610013220*r**16+88497125*r**18+1651864934*r**20-1096488257*r**22
            -227146500*r**24-76014915*r**26-24542950*r**28+1018783*r**30+10390*r**32)
            +Q2*(-7961-793259*r**2+31530810*r**4+129835670*r**6+186126150*r**8
            +3116726122*r**10-14062700766*r**12+30978051854*r**14-19507856620*r**16
            -19507856620*r**18+30978051854*r**20-14062700766*r**22+3116726122*r**24
            +186126150*r**26+129835670*r**28+31530810*r**30-793259*r**32-7961*r**34))
            -128*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))**2*(76*Q2**19+1579*Q2**18*(1+r**2)-8*Q2**17*(3287
            +30449*r**2+3287*r**4)+Q2**16*(158745+2743561*r**2+2743561*r**4+158745*r**6)
            -4*Q2**15*(133841+3251656*r**2+6608198*r**4+3251656*r**6+133841*r**8)
            +2*Q2**14*(564901+15899789*r**2+49278878*r**4+49278878*r**6+15899789*r**8
            +564901*r**10)-4*Q2**13*(380583+9109446*r**2+38285921*r**4+46011684*r**6
            +38285921*r**8+9109446*r**10+380583*r**12)+2*Q2**12*(615329-2848993*r**2
            -6885131*r**4-194293005*r**6-194293005*r**8-6885131*r**10-2848993*r**12
            +615329*r**14)+4*Q2**11*(-113815+18371550*r**2+101244360*r**4+510786538*r**6
            +880465022*r**8+510786538*r**10+101244360*r**12+18371550*r**14-113815*r**16)
            -16*Q2**10*(143+5357110*r**2+35970824*r**4+185504400*r**6+467727692*r**8
            +467727692*r**10+185504400*r**12+35970824*r**14+5357110*r**16+143*r**18)
            +4*Q2**9*(-40183+3994936*r**2+64387977*r**4+256170272*r**6+1364261246*r**8
            +1936441168*r**10+1364261246*r**12+256170272*r**14+64387977*r**16+3994936*r**18
            -40183*r**20)+4*Q2**8*(93613+12624964*r**2+31912612*r**4+441036933*r**6
            +403027442*r**8+825594428*r**10+825594428*r**12+403027442*r**14+441036933*r**16
            +31912612*r**18+12624964*r**20+93613*r**22)-4*Q2**7*(47307+10439788*r**2
            +50292862*r**4+505987860*r**6+1068455365*r**8+2388927648*r**10+3704135844*r**12
            +2388927648*r**14+1068455365*r**16+505987860*r**18+50292862*r**20+10439788*r**22
            +47307*r**24)+2*Q2**6*(-59045-1786429*r**2+81244006*r**4+397614038*r**6
            +1393089197*r**8+2108613653*r**10+4407563940*r**12+4407563940*r**14+2108613653*r**16
            +1393089197*r**18+397614038*r**20+81244006*r**22-1786429*r**24-59045*r**26)
            +4*Q2**5*(43867+5124098*r**2-42411799*r**4-117281092*r**6-763326461*r**8
            -842836770*r**10+374091385*r**12-948484536*r**14+374091385*r**16-842836770*r**18
            -763326461*r**20-117281092*r**22-42411799*r**24+5124098*r**26+43867*r**28)
            +Q2**4*(-52146-8493822*r**2+92022686*r**4+464199906*r**6+2720672038*r**8
            +5619688506*r**10-3707062746*r**12+5403486378*r**14+5403486378*r**16
            -3707062746*r**18+5619688506*r**20+2720672038*r**22+464199906*r**24+92022686*r**26
            -8493822*r**28-52146*r**30)-8*Q2**3*(3728+266597*r**2-5184542*r**4-4051713*r**6
            +34069748*r**8+4340981*r**10+132065694*r**12+87646119*r**14+193577976*r**16
            +87646119*r**18+132065694*r**20+4340981*r**22+34069748*r**24-4051713*r**26
            -5184542*r**28+266597*r**30+3728*r**32)+(-1+r**2)**2*(1059+101485*r**2
            -5862442*r**4-45573302*r**6-85422582*r**8-1245776650*r**10+4724124190*r**12
            -11970663742*r**14+8193615984*r**16+8193615984*r**18-11970663742*r**20
            +4724124190*r**22-1245776650*r**24-85422582*r**26-45573302*r**28-5862442*r**30
            +101485*r**32+1059*r**34)+Q2**2*(28741+2851605*r**2-78579144*r**4-330951400*r**6
            -792448980*r**8-5763995636*r**10+15173454120*r**12-27497327736*r**14
            +12464824430*r**16+12464824430*r**18-27497327736*r**20+15173454120*r**22
            -5763995636*r**24-792448980*r**26-330951400*r**28-78579144*r**30+2851605*r**32
            +28741*r**34)-4*Q2*(2255+224882*r**2-9225053*r**4-47237688*r**6-72128992*r**8
            -1112700728*r**10+4806045048*r**12-11964561352*r**14+14082941686*r**16
            -12237632116*r**18+14082941686*r**20-11964561352*r**22+4806045048*r**24
            -1112700728*r**26-72128992*r**28-47237688*r**30-9225053*r**32+224882*r**34
            +2255*r**36))*sqrtq2+logq2**7*(902961561600000*(-Q2+(-1+r)**2)**3*r**34*(1
            +r**2)**3*(1-Q2+r**2)*(-Q2+(1+r)**2)**3+902961561600000*r**34*(1+r**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**6*(716636160000*r**28*(1
            +r**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(480*Q2**8-2160*Q2**7*(1
            +r**2)+4*Q2**6*(420+1601*r**2+420*r**4)+Q2**5*(6510-1919*r**2-1919*r**4
            +6510*r**6)-Q2**4*(11970+9045*r**2+1438*r**4+9045*r**6+11970*r**8)
            +Q2**3*(-3990+4780*r**2+3872*r**4+3872*r**6+4780*r**8-3990*r**10)+3*(
            -1+r**2)**2*(2120-1317*r**2+118*r**4+4038*r**6+118*r**8-1317*r**10
            +2120*r**12)+2*Q2**2*(12705-2405*r**2+506*r**4+1488*r**6+506*r**8-2405*r**10
            +12705*r**12)-3*Q2*(7440-7807*r**2+2791*r**4+9336*r**6+9336*r**8+2791*r**10
            -7807*r**12+7440*r**14))+716636160000*(-Q2+(-1+r)**2)*r**28*(1+r**2)**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(480*Q2**8
            -2160*Q2**7*(1+r**2)+4*Q2**6*(420+1601*r**2+420*r**4)+Q2**5*(6510-1919*r**2
            -1919*r**4+6510*r**6)-Q2**4*(11970+9045*r**2+1438*r**4+9045*r**6+11970*r**8)
            +Q2**3*(-3990+4780*r**2+3872*r**4+3872*r**6+4780*r**8-3990*r**10)+3*(
            -1+r**2)**2*(2120-1317*r**2+118*r**4+4038*r**6+118*r**8-1317*r**10
            +2120*r**12)+2*Q2**2*(12705-2405*r**2+506*r**4+1488*r**6+506*r**8-2405*r**10
            +12705*r**12)-3*Q2*(7440-7807*r**2+2791*r**4+9336*r**6+9336*r**8+2791*r**10
            -7807*r**12+7440*r**14))*sqrtq2)+logq2**5*(3981312000*r**24*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-7680*Q2**12+114720*Q2**11*(1
            +r**2)-128*Q2**10*(4689+9889*r**2+4689*r**4)+120*Q2**9*(12618+41855*r**2
            +41855*r**4+12618*r**6)-15*Q2**8*(134670+610775*r**2+938642*r**4+610775*r**6
            +134670*r**8)+40*Q2**7*(41607+187873*r**2+369618*r**4+369618*r**6+187873*r**8
            +41607*r**10)-30*Q2**6*(62895+81564*r**2+105381*r**4+92272*r**6+105381*r**8
            +81564*r**10+62895*r**12)+24*Q2**5*(122736+138446*r**2+217921*r**4-23655*r**6
            -23655*r**8+217921*r**10+138446*r**12+122736*r**14)-10*Q2**4*(207171
            +663935*r**2+1799718*r**4+1669611*r**6+812546*r**8+1669611*r**10+1799718*r**12
            +663935*r**14+207171*r**16)-60*Q2**3*(16090-59555*r**2-1415*r**4-72961*r**6
            -153311*r**8-153311*r**10-72961*r**12-1415*r**14-59555*r**16+16090*r**18)
            +9*(-1+r**2)**2*(33592+102891*r**2+890452*r**4-48872*r**6-275036*r**8
            +710746*r**10-275036*r**12-48872*r**14+890452*r**16+102891*r**18+33592*r**20)
            +30*Q2**2*(82675+38086*r**2+1030775*r**4+481316*r**6-229666*r**8-115012*r**10
            -229666*r**12+481316*r**14+1030775*r**16+38086*r**18+82675*r**20)-180*Q2*(8164
            +8325*r**2+148175*r**4-63102*r**6-41094*r**8+151212*r**10+151212*r**12
            -41094*r**14-63102*r**16+148175*r**18+8325*r**20+8164*r**22))+3981312000*r**24*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-7680*Q2**12+114720*Q2**11*(1
            +r**2)-128*Q2**10*(4689+9889*r**2+4689*r**4)+120*Q2**9*(12618+41855*r**2
            +41855*r**4+12618*r**6)-15*Q2**8*(134670+610775*r**2+938642*r**4+610775*r**6
            +134670*r**8)+40*Q2**7*(41607+187873*r**2+369618*r**4+369618*r**6+187873*r**8
            +41607*r**10)-30*Q2**6*(62895+81564*r**2+105381*r**4+92272*r**6+105381*r**8
            +81564*r**10+62895*r**12)+24*Q2**5*(122736+138446*r**2+217921*r**4-23655*r**6
            -23655*r**8+217921*r**10+138446*r**12+122736*r**14)-10*Q2**4*(207171
            +663935*r**2+1799718*r**4+1669611*r**6+812546*r**8+1669611*r**10+1799718*r**12
            +663935*r**14+207171*r**16)-60*Q2**3*(16090-59555*r**2-1415*r**4-72961*r**6
            -153311*r**8-153311*r**10-72961*r**12-1415*r**14-59555*r**16+16090*r**18)
            +9*(-1+r**2)**2*(33592+102891*r**2+890452*r**4-48872*r**6-275036*r**8
            +710746*r**10-275036*r**12-48872*r**14+890452*r**16+102891*r**18+33592*r**20)
            +30*Q2**2*(82675+38086*r**2+1030775*r**4+481316*r**6-229666*r**8-115012*r**10
            -229666*r**12+481316*r**14+1030775*r**16+38086*r**18+82675*r**20)-180*Q2*(8164
            +8325*r**2+148175*r**4-63102*r**6-41094*r**8+151212*r**10+151212*r**12
            -41094*r**14-63102*r**16+148175*r**18+8325*r**20+8164*r**22))*sqrtq2)
            +logq2**4*(-66355200*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-10240*Q2**16
            +455680*Q2**15*(1+r**2)-64*Q2**14*(58193+118078*r**2+58193*r**4)+64*Q2**13*(222227
            +691459*r**2+691459*r**4+222227*r**6)-4*Q2**12*(7779288+33855025*r**2
            +52066098*r**4+33855025*r**6+7779288*r**8)+Q2**11*(41978508+242726495*r**2
            +509845857*r**4+509845857*r**6+242726495*r**8+41978508*r**10)-Q2**10*(35553132
            +244128799*r**2+591522776*r**4+759962186*r**6+591522776*r**8+244128799*r**10
            +35553132*r**12)+Q2**9*(16282704+78485129*r**2-80010201*r**4-589535240*r**6
            -589535240*r**8-80010201*r**10+78485129*r**12+16282704*r**14)+Q2**8*(7820544
            +106581683*r**2+1072733208*r**4+3586639589*r**6+5223215360*r**8+3586639589*r**10
            +1072733208*r**12+106581683*r**14+7820544*r**16)-4*Q2**7*(7885574+33598150*r**2
            +291713444*r**4+1075855125*r**6+1994588479*r**8+1994588479*r**10+1075855125*r**12
            +291713444*r**14+33598150*r**16+7885574*r**18)+4*Q2**6*(9525926+23563150*r**2
            +191067354*r**4+452818389*r**6+819498060*r**8+1058061522*r**10+819498060*r**12
            +452818389*r**14+191067354*r**16+23563150*r**18+9525926*r**20)-4*Q2**5*(4405444
            +36177903*r**2+285196912*r**4+354060452*r**6+170147412*r**8+14067677*r**10
            +14067677*r**12+170147412*r**14+354060452*r**16+285196912*r**18+36177903*r**20
            +4405444*r**22)+4*Q2**4*(-1670588+41325472*r**2+306607407*r**4+699232485*r**6
            +1047052480*r**8+1017579571*r**10+814254346*r**12+1017579571*r**14+1047052480*r**16
            +699232485*r**18+306607407*r**20+41325472*r**22-1670588*r**24)+3*Q2**3*(3757476
            -10592053*r**2+15908197*r**4-432866739*r**6-517574725*r**8-448755562*r**10
            -856708594*r**12-856708594*r**14-448755562*r**16-517574725*r**18-432866739*r**20
            +15908197*r**22-10592053*r**24+3757476*r**26)+9*(-1+r**2)**2*(22192
            -1843407*r**2-18510370*r**4-34339742*r**6-173546978*r**8-112904689*r**10
            +82131924*r**12+94622140*r**14+82131924*r**16-112904689*r**18-173546978*r**20
            -34339742*r**22-18510370*r**24-1843407*r**26+22192*r**28)-3*Q2**2*(1359684
            +29673675*r**2+333514744*r**4+228990650*r**6+1715138064*r**8+1994463477*r**10
            -117540300*r**12-932159988*r**14-117540300*r**16+1994463477*r**18+1715138064*r**20
            +228990650*r**22+333514744*r**24+29673675*r**26+1359684*r**28)-9*Q2*(608
            -7993395*r**2-73295953*r**4-51522468*r**6-523917540*r**8-194523883*r**10
            +323425135*r**12-318892504*r**14-318892504*r**16+323425135*r**18-194523883*r**20
            -523917540*r**22-51522468*r**24-73295953*r**26-7993395*r**28+608*r**30))
            -66355200*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(10240*Q2**17-465920*Q2**16*(1
            +r**2)+576*Q2**15*(7257+14702*r**2+7257*r**4)-640*Q2**14*(28042+86773*r**2
            +86773*r**4+28042*r**6)+4*Q2**13*(11334920+48474001*r**2+74192786*r**4
            +48474001*r**6+11334920*r**8)-29*Q2**12*(2520540+14112543*r**2+29432081*r**4
            +29432081*r**6+14112543*r**8+2520540*r**10)+2*Q2**11*(38765820+264416901*r**2
            +672047564*r**4+889826950*r**6+672047564*r**8+264416901*r**10+38765820*r**12)
            -2*Q2**10*(25917918+179083530*r**2+377820687*r**4+380974861*r**6+380974861*r**8
            +377820687*r**10+179083530*r**12+25917918*r**14)+10*Q2**9*(846216-1181385*r**2
            -107425828*r**4-425618503*r**6-640228584*r**8-425618503*r**10-107425828*r**12
            -1181385*r**14+846216*r**16)+Q2**8*(39362840+248794827*r**2+2346168667*r**4
            +8962793297*r**6+16788208865*r**8+16788208865*r**10+8962793297*r**12
            +2346168667*r**14+248794827*r**16+39362840*r**18)-8*Q2**7*(8705750+32523437*r**2
            +258189474*r**4+910193479*r**6+1944970832*r**8+2523619240*r**10+1944970832*r**12
            +910193479*r**14+258189474*r**16+32523437*r**18+8705750*r**20)+4*Q2**6*(13931370
            +69266979*r**2+499827416*r**4+997946195*r**6+1442463861*r**8+1891627259*r**10
            +1891627259*r**12+1442463861*r**14+997946195*r**16+499827416*r**18+69266979*r**20
            +13931370*r**22)-4*Q2**5*(2734856+81908819*r**2+627982222*r**4+1338489849*r**6
            +1571260344*r**8+1201794660*r**10+842389700*r**12+1201794660*r**14+1571260344*r**16
            +1338489849*r**18+627982222*r**20+81908819*r**22+2734856*r**24)+5*Q2**4*(
            -3590956+38079139*r**2+268801385*r**4+1064391957*r**6+1707572807*r**8
            +1920958978*r**10+1979492290*r**12+1979492290*r**14+1920958978*r**16
            +1707572807*r**18+1064391957*r**20+268801385*r**22+38079139*r**24-3590956*r**26)
            +6*Q2**3*(2558580+11419549*r**2+169415444*r**4-93983946*r**6+382348300*r**8
            +514066595*r**10-711502228*r**12-1322788588*r**14-711502228*r**16+514066595*r**18
            +382348300*r**20-93983946*r**22+169415444*r**24+11419549*r**26+2558580*r**28)
            +9*(-1+r**2)**2*(22192-1821215*r**2-20353777*r**4-52850112*r**6-207886720*r**8
            -286451667*r**10-30772765*r**12+176754064*r**14+176754064*r**16-30772765*r**18
            -286451667*r**20-207886720*r**22-52850112*r**24-20353777*r**26-1821215*r**28
            +22192*r**30)-6*Q2**2*(678930+27506772*r**2+291538139*r**4+358536399*r**6
            +1757940667*r**8+2146586595*r**10+453323886*r**12-46511388*r**14-46511388*r**16
            +453323886*r**18+2146586595*r**20+1757940667*r**22+358536399*r**24+291538139*r**26
            +27506772*r**28+678930*r**30)-18*Q2*(11400-4940289*r**2-48045356*r**4
            -61990415*r**6-349408936*r**8-259295949*r**10+131647788*r**12-89006883*r**14
            -331382720*r**16-89006883*r**18+131647788*r**20-259295949*r**22-349408936*r**24
            -61990415*r**26-48045356*r**28-4940289*r**30+11400*r**32))*sqrtq2)+logq2**3*(
            -1105920*r**16*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-522240*Q2**19
            +6652928*Q2**18*(1+r**2)-64*Q2**17*(595461+1221322*r**2+595461*r**4)
            +32*Q2**16*(3908867+12680217*r**2+12680217*r**4+3908867*r**6)-16*Q2**15*(15418808
            +72478609*r**2+112667122*r**4+72478609*r**6+15418808*r**8)+Q2**14*(266200500
            +1835751775*r**2+3832533913*r**4+3832533913*r**6+1835751775*r**8+266200500*r**10)
            -2*Q2**13*(28861052+596699597*r**2+1153786856*r**4+1125693742*r**6+1153786856*r**8
            +596699597*r**10+28861052*r**12)-Q2**12*(240049008+904884951*r**2+7140623095*r**4
            +19612295874*r**6+19612295874*r**8+7140623095*r**10+904884951*r**12+240049008*r**14)
            +4*Q2**11*(79873662+617966187*r**2+4814489834*r**4+16152998629*r**6+23748999120*r**8
            +16152998629*r**10+4814489834*r**12+617966187*r**14+79873662*r**16)-Q2**10*(135983436
            +2187397113*r**2+21811344211*r**4+92245188641*r**6+180546460647*r**8
            +180546460647*r**10+92245188641*r**12+21811344211*r**14+2187397113*r**16
            +135983436*r**18)+2*Q2**9*(-27921640+610686425*r**2+5801079712*r**4+25970036052*r**6
            +55092577960*r**8+67390501990*r**10+55092577960*r**12+25970036052*r**14
            +5801079712*r**16+610686425*r**18-27921640*r**20)+Q2**8*(105581424-449765471*r**2
            +2488903949*r**4+27142830328*r**6+143523623664*r**8+322359880826*r**10
            +322359880826*r**12+143523623664*r**14+27142830328*r**16+2488903949*r**18
            -449765471*r**20+105581424*r**22)-8*Q2**7*(8970434+75523353*r**2+1422080906*r**4
            +6470011389*r**6+32149066414*r**8+83007985578*r**10+113342107532*r**12
            +83007985578*r**14+32149066414*r**16+6470011389*r**18+1422080906*r**20
            +75523353*r**22+8970434*r**24)+Q2**6*(18410972+1368987397*r**2+12531372171*r**4
            +23575528231*r**6+135685296705*r**8+330321829182*r**10+551607469742*r**12
            +551607469742*r**14+330321829182*r**16+135685296705*r**18+23575528231*r**20
            +12531372171*r**22+1368987397*r**24+18410972*r**26)+2*Q2**5*(12171828
            -434231771*r**2-4252629736*r**4-15528759318*r**6-72098845856*r**8-49498876357*r**10
            -871477996*r**12+382834412*r**14-871477996*r**16-49498876357*r**18-72098845856*r**20
            -15528759318*r**22-4252629736*r**24-434231771*r**26+12171828*r**28)+Q2**4*(
            -27242480-95586125*r**2+2910623163*r**4+54610783158*r**6+217191384630*r**8
            +290114737205*r**10+258032279645*r**12+262887660804*r**14+262887660804*r**16
            +258032279645*r**18+290114737205*r**20+217191384630*r**22+54610783158*r**24
            +2910623163*r**26-95586125*r**28-27242480*r**30)+12*Q2**3*(398146+30535801*r**2
            +130479574*r**4-1812015837*r**6-2675836796*r**8-14944036431*r**10-13155882966*r**12
            -14194475853*r**14-21428411276*r**16-14194475853*r**18-13155882966*r**20
            -14944036431*r**22-2675836796*r**24-1812015837*r**26+130479574*r**28
            +30535801*r**30+398146*r**32)+9*(-1+r**2)**2*(80912+797035*r**2-37361827*r**4
            -676200445*r**6-3111051995*r**8-1488558801*r**10-18513020535*r**12-10696690409*r**14
            +21821206065*r**16+21821206065*r**18-10696690409*r**20-18513020535*r**22
            -1488558801*r**24-3111051995*r**26-676200445*r**28-37361827*r**30+797035*r**32
            +80912*r**34)+3*Q2**2*(2279828-48351289*r**2-976937051*r**4-7660942613*r**6
            -50003562963*r**8-2203633657*r**10-139749943711*r**12-136369237745*r**14
            +52149529201*r**16+52149529201*r**18-136369237745*r**20-139749943711*r**22
            -2203633657*r**24-50003562963*r**26-7660942613*r**28-976937051*r**30
            -48351289*r**32+2279828*r**34)-18*Q2*(232048-223127*r**2-92657968*r**4
            -1243358288*r**6-5498382880*r**8+2291753916*r**10-27630416864*r**12-7926826416*r**14
            +15576389824*r**16-1756220490*r**18+15576389824*r**20-7926826416*r**22
            -27630416864*r**24+2291753916*r**26-5498382880*r**28-1243358288*r**30
            -92657968*r**32-223127*r**34+232048*r**36))+1105920*r**16*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**4*(522240*Q2**19-6652928*Q2**18*(1+r**2)+64*Q2**17*(595461
            +1221322*r**2+595461*r**4)-32*Q2**16*(3908867+12680217*r**2+12680217*r**4
            +3908867*r**6)+16*Q2**15*(15418808+72478609*r**2+112667122*r**4+72478609*r**6
            +15418808*r**8)-Q2**14*(266200500+1835751775*r**2+3832533913*r**4+3832533913*r**6
            +1835751775*r**8+266200500*r**10)+2*Q2**13*(28861052+596699597*r**2+1153786856*r**4
            +1125693742*r**6+1153786856*r**8+596699597*r**10+28861052*r**12)+Q2**12*(240049008
            +904884951*r**2+7140623095*r**4+19612295874*r**6+19612295874*r**8+7140623095*r**10
            +904884951*r**12+240049008*r**14)-4*Q2**11*(79873662+617966187*r**2+4814489834*r**4
            +16152998629*r**6+23748999120*r**8+16152998629*r**10+4814489834*r**12
            +617966187*r**14+79873662*r**16)+Q2**10*(135983436+2187397113*r**2+21811344211*r**4
            +92245188641*r**6+180546460647*r**8+180546460647*r**10+92245188641*r**12
            +21811344211*r**14+2187397113*r**16+135983436*r**18)+2*Q2**9*(27921640
            -610686425*r**2-5801079712*r**4-25970036052*r**6-55092577960*r**8-67390501990*r**10
            -55092577960*r**12-25970036052*r**14-5801079712*r**16-610686425*r**18
            +27921640*r**20)-Q2**8*(105581424-449765471*r**2+2488903949*r**4+27142830328*r**6
            +143523623664*r**8+322359880826*r**10+322359880826*r**12+143523623664*r**14
            +27142830328*r**16+2488903949*r**18-449765471*r**20+105581424*r**22)
            +8*Q2**7*(8970434+75523353*r**2+1422080906*r**4+6470011389*r**6+32149066414*r**8
            +83007985578*r**10+113342107532*r**12+83007985578*r**14+32149066414*r**16
            +6470011389*r**18+1422080906*r**20+75523353*r**22+8970434*r**24)-Q2**6*(18410972
            +1368987397*r**2+12531372171*r**4+23575528231*r**6+135685296705*r**8
            +330321829182*r**10+551607469742*r**12+551607469742*r**14+330321829182*r**16
            +135685296705*r**18+23575528231*r**20+12531372171*r**22+1368987397*r**24
            +18410972*r**26)+2*Q2**5*(-12171828+434231771*r**2+4252629736*r**4+15528759318*r**6
            +72098845856*r**8+49498876357*r**10+871477996*r**12-382834412*r**14+871477996*r**16
            +49498876357*r**18+72098845856*r**20+15528759318*r**22+4252629736*r**24
            +434231771*r**26-12171828*r**28)+Q2**4*(27242480+95586125*r**2-2910623163*r**4
            -54610783158*r**6-217191384630*r**8-290114737205*r**10-258032279645*r**12
            -262887660804*r**14-262887660804*r**16-258032279645*r**18-290114737205*r**20
            -217191384630*r**22-54610783158*r**24-2910623163*r**26+95586125*r**28
            +27242480*r**30)-12*Q2**3*(398146+30535801*r**2+130479574*r**4-1812015837*r**6
            -2675836796*r**8-14944036431*r**10-13155882966*r**12-14194475853*r**14
            -21428411276*r**16-14194475853*r**18-13155882966*r**20-14944036431*r**22
            -2675836796*r**24-1812015837*r**26+130479574*r**28+30535801*r**30+398146*r**32)
            +3*Q2**2*(-2279828+48351289*r**2+976937051*r**4+7660942613*r**6+50003562963*r**8
            +2203633657*r**10+139749943711*r**12+136369237745*r**14-52149529201*r**16
            -52149529201*r**18+136369237745*r**20+139749943711*r**22+2203633657*r**24
            +50003562963*r**26+7660942613*r**28+976937051*r**30+48351289*r**32-2279828*r**34)
            -9*(-1+r**2)**2*(80912+797035*r**2-37361827*r**4-676200445*r**6-3111051995*r**8
            -1488558801*r**10-18513020535*r**12-10696690409*r**14+21821206065*r**16
            +21821206065*r**18-10696690409*r**20-18513020535*r**22-1488558801*r**24
            -3111051995*r**26-676200445*r**28-37361827*r**30+797035*r**32+80912*r**34)
            +18*Q2*(232048-223127*r**2-92657968*r**4-1243358288*r**6-5498382880*r**8
            +2291753916*r**10-27630416864*r**12-7926826416*r**14+15576389824*r**16
            -1756220490*r**18+15576389824*r**20-7926826416*r**22-27630416864*r**24
            +2291753916*r**26-5498382880*r**28-1243358288*r**30-92657968*r**32-223127*r**34
            +232048*r**36))*sqrtq2)+logq2**2*(18432*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(2439168*Q2**22-29633536*Q2**21*(1+r**2)+32*Q2**20*(4805969
            +10085842*r**2+4805969*r**4)-80*Q2**19*(5397203+18601305*r**2+18601305*r**4
            +5397203*r**6)+20*Q2**18*(32749660+182388265*r**2+284962714*r**4+182388265*r**6
            +32749660*r**8)-Q2**17*(331482782+4504859135*r**2+8740622055*r**4+8740622055*r**6
            +4504859135*r**8+331482782*r**10)-Q2**16*(576239926-300287779*r**2+8090912870*r**4
            +19247434110*r**6+8090912870*r**8-300287779*r**10+576239926*r**12)+2*Q2**15*(561174769
            +4088632237*r**2+30370749614*r**4+82647720000*r**6+82647720000*r**8+30370749614*r**10
            +4088632237*r**12+561174769*r**14)-10*Q2**14*(52819883+1292917620*r**2
            +11156441785*r**4+41486021888*r**6+62335542304*r**8+41486021888*r**10
            +11156441785*r**12+1292917620*r**14+52819883*r**16)-10*Q2**13*(48737815
            -737334500*r**2-7787893976*r**4-45719350038*r**6-94921414165*r**8-94921414165*r**10
            -45719350038*r**12-7787893976*r**14-737334500*r**16+48737815*r**18)+Q2**12*(732234538
            +3787186930*r**2+39743154240*r**4-21807222900*r**6-25443805770*r**8+91346214212*r**10
            -25443805770*r**12-21807222900*r**14+39743154240*r**16+3787186930*r**18
            +732234538*r**20)-2*Q2**11*(120781403+4643682073*r**2+56387186870*r**4
            +266855877990*r**6+1083794507315*r**8+2399065577117*r**10+2399065577117*r**12
            +1083794507315*r**14+266855877990*r**16+56387186870*r**18+4643682073*r**20
            +120781403*r**22)+2*Q2**10*(-98333731+2769623082*r**2+36869824809*r**4
            +324891889610*r**6+1786148921615*r**8+5205090755276*r**10+7436570270038*r**12
            +5205090755276*r**14+1786148921615*r**16+324891889610*r**18+36869824809*r**20
            +2769623082*r**22-98333731*r**24)+10*Q2**9*(27491263+49310635*r**2-1331844635*r**4
            -39762345107*r**6-247026022127*r**8-882053072203*r**10-1659715675810*r**12
            -1659715675810*r**14-882053072203*r**16-247026022127*r**18-39762345107*r**20
            -1331844635*r**22+49310635*r**24+27491263*r**26)-10*Q2**8*(12910705+271193290*r**2
            +432980436*r**4-12065768154*r**6+13194887510*r**8+125147127110*r**10
            +425183818821*r**12+657187672404*r**14+425183818821*r**16+125147127110*r**18
            +13194887510*r**20-12065768154*r**22+432980436*r**24+271193290*r**26
            +12910705*r**28)+2*Q2**7*(-27638701+981177835*r**2+8450972530*r**4+59087026020*r**6
            +849117746010*r**8+3446529753456*r**10+11331294583315*r**12+20991938153935*r**14
            +20991938153935*r**16+11331294583315*r**18+3446529753456*r**20+849117746010*r**22
            +59087026020*r**24+8450972530*r**26+981177835*r**28-27638701*r**30)+2*Q2**6*(54902267
            -343873888*r**2-14382928955*r**4-130085653380*r**6-751140175890*r**8
            -1318102286932*r**10-6508918509797*r**12-14206655446280*r**14-18769986550290*r**16
            -14206655446280*r**18-6508918509797*r**20-1318102286932*r**22-751140175890*r**24
            -130085653380*r**26-14382928955*r**28-343873888*r**30+54902267*r**32)
            +2*Q2**5*(-16321361-177539388*r**2+6126735524*r**4+105028119130*r**6
            +522486603645*r**8+834754024691*r**10+4152141898738*r**12+1286959854096*r**14
            -332410255075*r**16-332410255075*r**18+1286959854096*r**20+4152141898738*r**22
            +834754024691*r**24+522486603645*r**26+105028119130*r**28+6126735524*r**30
            -177539388*r**32-16321361*r**34)-10*Q2**4*(2759381-66129175*r**2-881147860*r**4
            +6656092506*r**6+81118928169*r**8+588296702544*r**10+1643565280635*r**12
            +1028675510950*r**14+626950537819*r**16+1227042930062*r**18+626950537819*r**20
            +1028675510950*r**22+1643565280635*r**24+588296702544*r**26+81118928169*r**28
            +6656092506*r**30-881147860*r**32-66129175*r**34+2759381*r**36)+30*Q2**3*(617025
            -8039705*r**2-266997406*r**4-1037174074*r**6+4797139975*r**8+119373825945*r**10
            +115137356771*r**12+288983905981*r**14+248808788533*r**16+479412496955*r**18
            +479412496955*r**20+248808788533*r**22+288983905981*r**24+115137356771*r**26
            +119373825945*r**28+4797139975*r**30-1037174074*r**32-266997406*r**34
            -8039705*r**36+617025*r**38)+9*(-1+r**2)**2*(83432-2265295*r**2-47484400*r**4
            +538443025*r**6+9818282920*r**8+82997415772*r**10+200293285760*r**12
            -194210419300*r**14+1653467058800*r**16+81123425990*r**18-2753498053408*r**20
            +81123425990*r**22+1653467058800*r**24-194210419300*r**26+200293285760*r**28
            +82997415772*r**30+9818282920*r**32+538443025*r**34-47484400*r**36-2265295*r**38
            +83432*r**40)+6*Q2**2*(214413-18864640*r**2-4825895*r**4+8592291840*r**6
            +73019524585*r**8+328107435968*r**10+1906087367740*r**12-1167120013120*r**14
            +3117046759050*r**16+2500667565440*r**18-1056940510762*r**20+2500667565440*r**22
            +3117046759050*r**24-1167120013120*r**26+1906087367740*r**28+328107435968*r**30
            +73019524585*r**32+8592291840*r**34-4825895*r**36-18864640*r**38+214413*r**40)
            -9*Q2*(390224-11729881*r**2-174896405*r**4+3085843475*r**6+38476103455*r**8
            +266089754684*r**10+706097713644*r**12-1293679221860*r**14+4437547415900*r**16
            +722457689810*r**18-3050973863046*r**20-3050973863046*r**22+722457689810*r**24
            +4437547415900*r**26-1293679221860*r**28+706097713644*r**30+266089754684*r**32
            +38476103455*r**34+3085843475*r**36-174896405*r**38-11729881*r**40+390224*r**42))
            -18432*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(2439168*Q2**23-32072704*Q2**22*(1
            +r**2)+32*Q2**21*(5732017+11937938*r**2+5732017*r**4)-16*Q2**20*(36597953
            +122790147*r**2+122790147*r**4+36597953*r**6)+20*Q2**19*(54338472+278382297*r**2
            +433773154*r**4+278382297*r**6+54338472*r**8)-Q2**18*(986475982+8807617635*r**2
            +18087641635*r**4+18087641635*r**6+8807617635*r**8+986475982*r**10)-8*Q2**17*(30594643
            -642078712*r**2-644321040*r**4+220773750*r**6-644321040*r**8-642078712*r**10
            +30594643*r**12)+Q2**16*(1698589464+8453216621*r**2+68532124319*r**4
            +192633786980*r**6+192633786980*r**8+68532124319*r**10+8453216621*r**12
            +1698589464*r**14)-4*Q2**15*(412637092+5557197553*r**2+45120795388*r**4
            +160224289527*r**6+238486575760*r**8+160224289527*r**10+45120795388*r**12
            +5557197553*r**14+412637092*r**16)+10*Q2**14*(4082068+2083072003*r**2
            +20237253381*r**4+98361813711*r**6+198742978357*r**8+198742978357*r**10
            +98361813711*r**12+20237253381*r**14+2083072003*r**16+4082068*r**18)
            +8*Q2**13*(152451586-387347490*r**2-5688641315*r**4-69609957880*r**6
            -178981430975*r**8-225885258636*r**10-178981430975*r**12-69609957880*r**14
            -5688641315*r**16-387347490*r**18+152451586*r**20)-2*Q2**12*(486898672
            +6903392807*r**2+78152357455*r**4+275823843660*r**6+1060168992980*r**8
            +2432016781338*r**10+2432016781338*r**12+1060168992980*r**14+275823843660*r**16
            +78152357455*r**18+6903392807*r**20+486898672*r**22)+4*Q2**11*(11223836
            +3767043279*r**2+48950346876*r**4+324067477235*r**6+1568399653460*r**8
            +4343975419854*r**10+6117350712136*r**12+4343975419854*r**14+1568399653460*r**16
            +324067477235*r**18+48950346876*r**20+3767043279*r**22+11223836*r**24)
            +4*Q2**10*(117895023-1212368088*r**2-23149335533*r**4-280286719977*r**6
            -1673085460930*r**8-5700752518953*r**10-10470119702182*r**12-10470119702182*r**14
            -5700752518953*r**16-1673085460930*r**18-280286719977*r**20-23149335533*r**22
            -1212368088*r**24+117895023*r**26)-40*Q2**9*(10100492+86998797*r**2-212388391*r**4
            -13289989474*r**6-68398369931*r**8-250982991805*r**10-529146232298*r**12
            -665560919804*r**14-529146232298*r**16-250982991805*r**18-68398369931*r**20
            -13289989474*r**22-212388391*r**24+86998797*r**26+10100492*r**28)+4*Q2**8*(18457412
            +1200848905*r**2+5985920580*r**4+461543715*r**6+427381671395*r**8+2069119913278*r**10
            +7041474656485*r**12+13201897805030*r**14+13201897805030*r**16+7041474656485*r**18
            +2069119913278*r**20+427381671395*r**22+461543715*r**24+5985920580*r**26
            +1200848905*r**28+18457412*r**30)+4*Q2**7*(41270484-648706511*r**2-11907539660*r**4
            -98811825965*r**6-829672473960*r**8-2806874893199*r**10-10643371423284*r**12
            -23264944091765*r**14-30376931429080*r**16-23264944091765*r**18-10643371423284*r**20
            -2806874893199*r**22-829672473960*r**24-98811825965*r**26-11907539660*r**28
            -648706511*r**30+41270484*r**32)+Q2**6*(-142447256+222864466*r**2+41707076734*r**4
            +498993402930*r**6+2807424865830*r**8+5807992975026*r**10+23958325390934*r**12
            +44005067620346*r**14+65288463482990*r**16+65288463482990*r**18+44005067620346*r**20
            +23958325390934*r**22+5807992975026*r**24+2807424865830*r**26+498993402930*r**28
            +41707076734*r**30+222864466*r**32-142447256*r**34)+8*Q2**5*(631114+131126656*r**2
            -385864209*r**4-36108829296*r**6-258277340905*r**8-1074681035264*r**10
            -3301180581651*r**12-2645619826896*r**14-1022325572029*r**16-1367598535040*r**18
            -1022325572029*r**20-2645619826896*r**22-3301180581651*r**24-1074681035264*r**26
            -258277340905*r**28-36108829296*r**30-385864209*r**32+131126656*r**34
            +631114*r**36)+10*Q2**4*(4610456-87488909*r**2-1748269253*r**4+2663422424*r**6
            +102166440600*r**8+1027537108548*r**10+2577274053492*r**12+3539192509528*r**14
            +2402052414368*r**16+3292230958746*r**18+3292230958746*r**20+2402052414368*r**22
            +3539192509528*r**24+2577274053492*r**26+1027537108548*r**28+102166440600*r**30
            +2663422424*r**32-1748269253*r**34-87488909*r**36+4610456*r**38)-24*Q2**3*(717678
            -4562190*r**2-342589915*r**4-3778287310*r**6-13554923770*r**8+73186848408*r**10
            -183382863540*r**12+796931581720*r**14-107020821620*r**16+285109715500*r**18
            +1462766370078*r**20+285109715500*r**22-107020821620*r**24+796931581720*r**26
            -183382863540*r**28+73186848408*r**30-13554923770*r**32-3778287310*r**34
            -342589915*r**36-4562190*r**38+717678*r**40)-9*(-1+r**2)**2*(83432-2181863*r**2
            -49749695*r**4+490958625*r**6+10356725945*r**8+92815698692*r**10+283290701532*r**12
            +6082866460*r**14+1459256639500*r**16+1734590484790*r**18-2672374627418*r**20
            -2672374627418*r**22+1734590484790*r**24+1459256639500*r**26+6082866460*r**28
            +283290701532*r**30+92815698692*r**32+10356725945*r**34+490958625*r**36
            -49749695*r**38-2181863*r**40+83432*r**42)-3*Q2**2*(1599498-72490097*r**2
            -572070285*r**4+26432462315*r**6+278651943215*r**8+1600523185158*r**10
            +6586682748348*r**12-2403102956340*r**14+17212495739560*r**16+13402801718410*r**18
            -6265467479782*r**20-6265467479782*r**22+13402801718410*r**24+17212495739560*r**26
            -2403102956340*r**28+6586682748348*r**30+1600523185158*r**32+278651943215*r**34
            +26432462315*r**36-572070285*r**38-72490097*r**40+1599498*r**42)+72*Q2*(59207
            -1721477*r**2-28687083*r**4+442761700*r**6+6281982425*r**8+46058143887*r**10
            +127038025683*r**12-137422635408*r**14+673256172150*r**16+217497999350*r**18
            -448849252478*r**20-54088095912*r**22-448849252478*r**24+217497999350*r**26
            +673256172150*r**28-137422635408*r**30+127038025683*r**32+46058143887*r**34
            +6281982425*r**36+442761700*r**38-28687083*r**40-1721477*r**42+59207*r**44))*sqrtq2)
            +logq2*(-1536*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(-24832*Q2**21+356320*Q2**20*(1
            +r**2)-64*Q2**19*(32421+73990*r**2+32421*r**4)+16*Q2**18*(395716+1470915*r**2
            +1470915*r**4+395716*r**6)-Q2**17*(10125934+53226657*r**2+65600998*r**4
            +53226657*r**6+10125934*r**8)+Q2**16*(4714014+32343419*r**2-118844981*r**4
            -118844981*r**6+32343419*r**8+4714014*r**10)+2*Q2**15*(5859833+53034624*r**2
            +528468418*r**4+1019081462*r**6+528468418*r**8+53034624*r**10+5859833*r**12)
            -2*Q2**14*(10537409+129359205*r**2+1215256884*r**4+3574182650*r**6+3574182650*r**8
            +1215256884*r**10+129359205*r**12+10537409*r**14)+2*Q2**13*(2921241+99624010*r**2
            +1141091095*r**4+5537123794*r**6+8372713176*r**8+5537123794*r**10+1141091095*r**12
            +99624010*r**14+2921241*r**16)+2*Q2**12*(8775351+25453983*r**2+193286447*r**4
            -2258087741*r**6-3113139160*r**8-3113139160*r**10-2258087741*r**12+193286447*r**14
            +25453983*r**16+8775351*r**18)-2*Q2**11*(8694075+93901816*r**2+1525989016*r**4
            +6165924222*r**6+25445513717*r**8+43362822820*r**10+25445513717*r**12
            +6165924222*r**14+1525989016*r**16+93901816*r**18+8694075*r**20)+2*Q2**10*(
            -1619709+50067083*r**2+1484613966*r**4+11909872296*r**6+57408582657*r**8
            +136344881243*r**10+136344881243*r**12+57408582657*r**14+11909872296*r**16
            +1484613966*r**18+50067083*r**20-1619709*r**22)+2*Q2**9*(6677359+8071125*r**2
            -513613341*r**4-8586952655*r**6-44280096075*r**8-146363942414*r**10-214725585950*r**12
            -146363942414*r**14-44280096075*r**16-8586952655*r**18-513613341*r**20
            +8071125*r**22+6677359*r**24)-2*Q2**8*(2261791+22893930*r**2+288394900*r**4
            -258649848*r**6+10528017772*r**8+4527553435*r**10+805989300*r**12+805989300*r**14
            +4527553435*r**16+10528017772*r**18-258649848*r**20+288394900*r**22+22893930*r**24
            +2261791*r**26)+Q2**7*(-4486602+41863264*r**2+1164906356*r**4+8268475700*r**6
            +76279083712*r**8+217687817296*r**10+526688790262*r**12+771487843064*r**14
            +526688790262*r**16+217687817296*r**18+76279083712*r**20+8268475700*r**22
            +1164906356*r**24+41863264*r**26-4486602*r**28)+Q2**6*(3562586-24817518*r**2
            -806331968*r**4-6608647204*r**6-44551124384*r**8-94165166716*r**10-326306201878*r**12
            -631370383318*r**14-631370383318*r**16-326306201878*r**18-94165166716*r**20
            -44551124384*r**22-6608647204*r**24-806331968*r**26-24817518*r**28+3562586*r**30)
            +2*Q2**5*(123779-3739878*r**2-8149311*r**4+2303722442*r**6+12924058502*r**8
            +24565607030*r**10+83966844799*r**12-14536352986*r**14+30512948846*r**16
            -14536352986*r**18+83966844799*r**20+24565607030*r**22+12924058502*r**24
            +2303722442*r**26-8149311*r**28-3739878*r**30+123779*r**32)-2*Q2**4*(525603
            -9916385*r**2-195930197*r**4+1897643695*r**6+14371550850*r**8+75655307402*r**10
            +183656983385*r**12-29762895283*r**14+80225322930*r**16+80225322930*r**18
            -29762895283*r**20+183656983385*r**22+75655307402*r**24+14371550850*r**26
            +1897643695*r**28-195930197*r**30-9916385*r**32+525603*r**34)+2*Q2**3*(125447
            -3257400*r**2-87207140*r**4+226691630*r**6+2680468771*r**8+44091129116*r**10
            +42915983545*r**12-5733638830*r**14+65183353857*r**16+212170014008*r**18
            +65183353857*r**20-5733638830*r**22+42915983545*r**24+44091129116*r**26
            +2680468771*r**28+226691630*r**30-87207140*r**32-3257400*r**34+125447*r**36)
            +3*(-1+r**2)**2*(3208-176285*r**2-4031035*r**4+115246790*r**6+935366722*r**8
            +5300520306*r**10+19247256110*r**12-72634460090*r**14+240831828010*r**16
            -178550593736*r**18-178550593736*r**20+240831828010*r**22-72634460090*r**24
            +19247256110*r**26+5300520306*r**28+935366722*r**30+115246790*r**32-4031035*r**34
            -176285*r**36+3208*r**38)+2*Q2**2*(58417-1862599*r**2-23832626*r**4
            +1135058532*r**6+8040311321*r**8+20136506487*r**10+144520737805*r**12
            -186119476749*r**14+206130945887*r**16+66366513525*r**18+66366513525*r**20
            +206130945887*r**22-186119476749*r**24+144520737805*r**26+20136506487*r**28
            +8040311321*r**30+1135058532*r**32-23832626*r**34-1862599*r**36+58417*r**38)
            -3*Q2*(22456-975077*r**2-17847952*r**4+559434707*r**6+3712302792*r**8
            +15714328636*r**10+64291697696*r**12-239318035764*r**14+544915456384*r**16
            -149109239286*r**18-359566609184*r**20-149109239286*r**22+544915456384*r**24
            -239318035764*r**26+64291697696*r**28+15714328636*r**30+3712302792*r**32
            +559434707*r**34-17847952*r**36-975077*r**38+22456*r**40))+1536*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(198656*Q2**25-3024384*Q2**24*(1+r**2)
            +96*Q2**23*(197083+447094*r**2+197083*r**4)-32*Q2**22*(1956485+7343347*r**2
            +7343347*r**4+1956485*r**6)+8*Q2**21*(13726074+76940619*r**2+106403618*r**4
            +76940619*r**6+13726074*r**8)-Q2**20*(59117586+590506513*r**2-177892135*r**4
            -177892135*r**6+590506513*r**8+59117586*r**10)-4*Q2**19*(36102576+219023531*r**2
            +2336864520*r**4+4644368410*r**6+2336864520*r**8+219023531*r**10+36102576*r**12)
            +Q2**18*(295017738+3132086964*r**2+27531038168*r**4+82625695050*r**6
            +82625695050*r**8+27531038168*r**10+3132086964*r**12+295017738*r**14)
            -4*Q2**17*(23997540+760142101*r**2+8282106376*r**4+40823327435*r**6+63566832360*r**8
            +40823327435*r**10+8282106376*r**12+760142101*r**14+23997540*r**16)+Q2**16*(
            -296333008-571009883*r**2+1394279179*r**4+119549285357*r**6+253183272547*r**8
            +253183272547*r**10+119549285357*r**12+1394279179*r**14-571009883*r**16
            -296333008*r**18)+4*Q2**15*(82730736+904848843*r**2+11435818860*r**4
            +36385486260*r**6+133500504708*r**8+233471269570*r**10+133500504708*r**12
            +36385486260*r**14+11435818860*r**16+904848843*r**18+82730736*r**20)
            +4*Q2**14*(18187554-607522681*r**2-13325384115*r**4-109027012520*r**6
            -494502239790*r**8-1184920929904*r**10-1184920929904*r**12-494502239790*r**14
            -109027012520*r**16-13325384115*r**18-607522681*r**20+18187554*r**22)
            -4*Q2**13*(80352568+164158609*r**2-3215564922*r**4-97593854875*r**6-568765044360*r**8
            -2003511550518*r**10-2992289894124*r**12-2003511550518*r**14-568765044360*r**16
            -97593854875*r**18-3215564922*r**20+164158609*r**22+80352568*r**24)+2*Q2**12*(53254050
            +927103593*r**2+13205348893*r**4+2483526345*r**6-104578205775*r**8-2033984250340*r**10
            -4710737460318*r**12-4710737460318*r**14-2033984250340*r**16-104578205775*r**18
            +2483526345*r**20+13205348893*r**22+927103593*r**24+53254050*r**26)+4*Q2**11*(39898368
            -293748647*r**2-7538029144*r**4-74913287302*r**6-510310423112*r**8-1419719692313*r**10
            -3445114768608*r**12-5195656110196*r**14-3445114768608*r**16-1419719692313*r**18
            -510310423112*r**20-74913287302*r**22-7538029144*r**24-293748647*r**26
            +39898368*r**28)+4*Q2**10*(-30479469+26132453*r**2+2339985105*r**4+55705749655*r**6
            +489571933773*r**8+2757825995331*r**10+10110687904647*r**12+21034150619145*r**14
            +21034150619145*r**16+10110687904647*r**18+2757825995331*r**20+489571933773*r**22
            +55705749655*r**24+2339985105*r**26+26132453*r**28-30479469*r**30)-4*Q2**9*(8735496
            -178406589*r**2-2486832790*r**4+10378509105*r**6+180663380460*r**8+2077847030059*r**10
            +9547541863254*r**12+26065086906465*r**14+37177949191320*r**16+26065086906465*r**18
            +9547541863254*r**20+2077847030059*r**22+180663380460*r**24+10378509105*r**26
            -2486832790*r**28-178406589*r**30+8735496*r**32)+2*Q2**8*(31055604-358204933*r**2
            -6300371251*r**4-3084536825*r**6+70759032285*r**8+1258569805431*r**10
            +1928253712613*r**12+7294249344391*r**14+17930359564285*r**16+17930359564285*r**18
            +7294249344391*r**20+1928253712613*r**22+1258569805431*r**24+70759032285*r**26
            -3084536825*r**28-6300371251*r**30-358204933*r**32+31055604*r**34)+4*Q2**7*(
            -1215160+2181689*r**2+723916964*r**4+8226565480*r**6+59674791380*r**8
            +471612754860*r**10+5694898543516*r**12+17566829688216*r**14+39686861794980*r**16
            +53653149047350*r**18+39686861794980*r**20+17566829688216*r**22+5694898543516*r**24
            +471612754860*r**26+59674791380*r**28+8226565480*r**30+723916964*r**32
            +2181689*r**34-1215160*r**36)-12*Q2**6*(1497274-31797991*r**2-333529997*r**4
            +6576394424*r**6+48097948574*r**8+277002481246*r**10+1451824634586*r**12
            +2454436118322*r**14+10207528281406*r**16+17827838996156*r**18+17827838996156*r**20
            +10207528281406*r**22+2454436118322*r**24+1451824634586*r**26+277002481246*r**28
            +48097948574*r**30+6576394424*r**32-333529997*r**34-31797991*r**36+1497274*r**38)
            +4*Q2**5*(1380996-39029297*r**2-686357550*r**4+10207405775*r**6+84465821868*r**8
            +749300250404*r**10+2131045899112*r**12-275099876700*r**14+13402966632400*r**16
            +619029049242*r**18-745546512500*r**20+619029049242*r**22+13402966632400*r**24
            -275099876700*r**26+2131045899112*r**28+749300250404*r**30+84465821868*r**32
            +10207405775*r**34-686357550*r**36-39029297*r**38+1380996*r**40)+Q2**4*(2670206
            -77745249*r**2-164409745*r**4+27692697015*r**6+32474473455*r**8-2106701180774*r**10
            -10545942707364*r**12-50396801891380*r**14-115563828608640*r**16+4723981406170*r**18
            -26447424463694*r**20-26447424463694*r**22+4723981406170*r**24-115563828608640*r**26
            -50396801891380*r**28-10545942707364*r**30-2106701180774*r**32+32474473455*r**34
            +27692697015*r**36-164409745*r**38-77745249*r**40+2670206*r**42)-24*Q2**3*(62808
            -2581461*r**2-26323372*r**4+1181037850*r**6+3263048940*r**8-13989473777*r**10
            -204379365136*r**12-1821943224392*r**14-624041317960*r**16-371391222330*r**18
            -2532876995392*r**20-6612064731556*r**22-2532876995392*r**24-371391222330*r**26
            -624041317960*r**28-1821943224392*r**30-204379365136*r**32-13989473777*r**34
            +3263048940*r**36+1181037850*r**38-26323372*r**40-2581461*r**42+62808*r**44)
            -9*(-1+r**2)**2*(3208-221197*r**2-1864597*r**4+188207158*r**6-296699850*r**8
            -18571553857*r**10-144501986137*r**12-853324841712*r**14-624799722632*r**16
            +3013281997350*r**18-19280904417002*r**20+16080015899268*r**22+16080015899268*r**24
            -19280904417002*r**26+3013281997350*r**28-624799722632*r**30-853324841712*r**32
            -144501986137*r**34-18571553857*r**36-296699850*r**38+188207158*r**40
            -1864597*r**42-221197*r**44+3208*r**46)-6*Q2**2*(13505-204636*r**2+20475714*r**4
            +59216225*r**6-4531867995*r**8-163990351830*r**10-718275000796*r**12
            -2172589135371*r**14-16333977773270*r**16+21182912086120*r**18-13679155828380*r**20
            -17503751629286*r**22-17503751629286*r**24-13679155828380*r**26+21182912086120*r**28
            -16333977773270*r**30-2172589135371*r**32-718275000796*r**34-163990351830*r**36
            -4531867995*r**38+59216225*r**40+20475714*r**42-204636*r**44+13505*r**46)
            +72*Q2*(2406-133934*r**2-575863*r**4+91884446*r**6-226878874*r**8-10384189194*r**10
            -59439422619*r**12-302305139398*r**14-478993566254*r**16+2231447812116*r**18
            -6249425961454*r**20+845012220236*r**22+6219532696772*r**24+845012220236*r**26
            -6249425961454*r**28+2231447812116*r**30-478993566254*r**32-302305139398*r**34
            -59439422619*r**36-10384189194*r**38-226878874*r**40+91884446*r**42-575863*r**44
            -133934*r**46+2406*r**48))*sqrtq2))*math.log(mu0))/(42000*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2+42000*(
            -Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2
            +logq2**7*(-338610585600000*r**32*(1+r**2)**2*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3-338610585600000*r**32*(1+r**2)**2*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**6*(1881169920000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))+1881169920000*r**28*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))*sqrtq2)+logq2*(-2520000*(-Q2+(
            -1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(9+8*Q2**4-78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)
            -Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-2520000*(-Q2+(-1+r)**2)**3*r**8*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(9+8*Q2**4-78*r**2-366*r**4
            -78*r**6+9*r**8-Q2**3*(1+r**2)-Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1
            +13*r**2+13*r**4+r**6))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*sqrtq2)+logq2**2*(30240000*(-Q2+(-1+r)**2)**3*r**12*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531
            +550*r**2+531*r**4)-2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815
            -2120*r**2-11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4
            +494*r**6+225*r**8+r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6
            +26793*r**8+4554*r**10-501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6
            -1385*r**8-311*r**10+15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6
            +34670*r**8+13388*r**10-184*r**12-316*r**14+17*r**16))+30240000*(-Q2
            +(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531+550*r**2+531*r**4)
            -2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815-2120*r**2-11502*r**4
            -2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4+494*r**6+225*r**8
            +r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6+26793*r**8+4554*r**10
            -501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6-1385*r**8-311*r**10
            +15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6+34670*r**8+13388*r**10
            -184*r**12-316*r**14+17*r**16))*sqrtq2)+logq2**3*(-362880000*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8+256*Q2**7*(1+r**2)
            -Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2+893*r**4+319*r**6)
            +Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)+12*Q2**3*(61
            +235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(-1071+9654*r**2
            +51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)-18*Q2*(23
            -35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12+23*r**14)
            +9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10-264*r**12
            -756*r**14+47*r**16))-362880000*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8
            +256*Q2**7*(1+r**2)-Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2
            +893*r**4+319*r**6)+Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)
            +12*Q2**3*(61+235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(
            -1071+9654*r**2+51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)
            -18*Q2*(23-35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12
            +23*r**14)+9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10
            -264*r**12-756*r**14+47*r**16))*sqrtq2)+logq2**4*(4354560000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513+770*r**2
            +513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105-3400*r**2
            -11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4-1178*r**6
            +75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6+19593*r**8
            +3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6-5785*r**8
            -2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4+25204*r**6
            +52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))+4354560000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513
            +770*r**2+513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105
            -3400*r**2-11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4
            -1178*r**6+75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6
            +19593*r**8+3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6
            -5785*r**8-2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4
            +25204*r**6+52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))*sqrtq2)
            +logq2**5*(-10450944000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(64*Q2**8+1088*Q2**7*(1+r**2)+Q2**6*(-63+130*r**2-63*r**4)
            -2*Q2**5*(2777+6379*r**2+6379*r**4+2777*r**6)+Q2**4*(1555-8080*r**2
            -22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743-315*r**2-6548*r**4-6548*r**6
            -315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2+199629*r**4+305844*r**6
            +199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83-375*r**2-2833*r**4
            -5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)+9*(301-4028*r**2
            +808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12-4028*r**14+301*r**16))
            -10450944000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(64*Q2**8+1088*Q2**7*(1
            +r**2)+Q2**6*(-63+130*r**2-63*r**4)-2*Q2**5*(2777+6379*r**2+6379*r**4
            +2777*r**6)+Q2**4*(1555-8080*r**2-22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743
            -315*r**2-6548*r**4-6548*r**6-315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2
            +199629*r**4+305844*r**6+199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83
            -375*r**2-2833*r**4-5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)
            +9*(301-4028*r**2+808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12
            -4028*r**14+301*r**16))*sqrtq2))+((4*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(-57
            -24*Q2**14+3714*r**2+43777*r**4-3791308*r**6-10159121*r**8+15296334*r**10
            -236289183*r**12+694656216*r**14-815729139*r**16+457228062*r**18-127046277*r**20
            +25369844*r**22+93757*r**24+322322*r**26+1059*r**28-56*Q2**13*(1+r**2)
            +Q2**12*(1457-3446*r**2-1627*r**4)+4*Q2**11*(-1615+8387*r**2+54679*r**4
            +3797*r**6)-4*Q2**10*(-3472+30654*r**2+403567*r**4+338572*r**6+11639*r**8)
            +4*Q2**9*(-4008+54495*r**2+1044380*r**4+2055110*r**6+727340*r**8+15387*r**10)
            -Q2**8*(-8157+170178*r**2+3813345*r**4+13564420*r**6+12323485*r**8+1013978*r**10
            +15423*r**12)-8*Q2**7*(-207+2181*r**2+203412*r**4-98905*r**6+1778395*r**8
            +542973*r**10+651616*r**12+6327*r**14)+8*Q2**6*(-420+13398*r**2+622461*r**4
            +1572643*r**6+10153075*r**8+11587780*r**10+3383193*r**12+891191*r**14
            +5943*r**16)+8*Q2**5*(-57-1356*r**2-185973*r**4-797988*r**6-6859881*r**8
            -23311392*r**10-9155691*r**12-2312708*r**14-8398*r**16+1284*r**18)-Q2**4*(
            -1931+71530*r**2+2109045*r**4-6455760*r**6+15777210*r**8-44549788*r**10
            -138504270*r**12+88484320*r**14+7369665*r**16+5785410*r**18+34249*r**20)
            +4*Q2**3*(-119+8471*r**2+323305*r**4-3050295*r**6-3025010*r**8-6052382*r**10
            +19084558*r**12-13941570*r**14+34632105*r**16+3167815*r**18+818121*r**20
            +3001*r**22)+4*Q2**2*(-122+4186*r**2+58337*r**4+87590*r**6+5884315*r**8
            +13803764*r**10+13722438*r**12-4033124*r**14-12132160*r**16-2175310*r**18
            -930087*r**20+223806*r**22+1567*r**24)-4*Q2*(-80+4233*r**2+73226*r**4
            -2220242*r**6-2960350*r**8-2058365*r**10-5455156*r**12-38454012*r**14
            +85305484*r**16-50223425*r**18+15606570*r**20+53198*r**22+327586*r**24
            +1333*r**26))+4*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(192*Q2**19
            +88*Q2**18*(1+r**2)+16*Q2**17*(-781+1642*r**2+761*r**4)-Q2**16*(-73775
            +297995*r**2+1825599*r**4+145669*r**6)+4*Q2**15*(-51861+340660*r**2
            +4186230*r**4+3591900*r**6+150207*r**8)-2*Q2**14*(-160967+1597940*r**2
            +30027301*r**4+56976461*r**6+22270690*r**8+587263*r**10)+4*Q2**13*(-60326
            +917894*r**2+24316527*r**4+81644768*r**6+73261216*r**8+12910234*r**10
            +223639*r**12)+Q2**12*(-25402-563876*r**2-38459200*r**4-358564138*r**6
            -438041866*r**8-228371272*r**10+37752324*r**12+634262*r**14)-4*Q2**11*(
            -48165+833580*r**2+23734310*r**4+18524260*r**6+191728516*r**8+235832836*r**10
            +95582026*r**12+40901932*r**14+427377*r**16)+2*Q2**10*(-43329+1222980*r**2
            +58336869*r**4+277843715*r**6+1545154811*r**8+3240493627*r**10+1729299335*r**12
            +475011561*r**14+58601370*r**16+322773*r**18)+4*Q2**9*(-21736+513590*r**2
            +4363551*r**4-147373004*r**6-899717980*r**8-3213841264*r**10-3392656990*r**12
            -715979284*r**14-140458404*r**16+25380890*r**18+279719*r**20)-2*Q2**8*(
            -45422+1641233*r**2+48534133*r**4-170257418*r**6-588840656*r**8-4624178418*r**10
            -7526070378*r**12-4253144032*r**14+1312661502*r**16+216617569*r**18+93325493*r**20
            +565738*r**22)+4*Q2**7*(1573+68684*r**2+7392018*r**4+10756724*r**6+339887083*r**8
            +998967992*r**10+4261569596*r**12+4797578744*r**14+3260448139*r**16+1591348508*r**18
            +211851218*r**20+7629684*r**22-31163*r**24)+2*Q2**6*(-19635+801700*r**2
            +18156501*r**4-209461039*r**6-777053636*r**8-5007634041*r**10-23534560726*r**12
            -47692110982*r**14-28406379147*r**16-14011017886*r**18-1356019711*r**20
            -196567371*r**22+50182914*r**24+310899*r**26)-4*Q2**5*(-2162+153710*r**2
            +5399059*r**4-79097960*r**6-98177028*r**8-1165588042*r**10-5991109955*r**12
            -22670582320*r**14-29948143010*r**16-3934803926*r**18-3395263571*r**20
            +710056600*r**22+51425816*r**24+13953970*r**26+44419*r**28)-2*Q2**4*(
            -4909+213490*r**2+2377176*r**4-49489669*r**6+14947725*r**8+1709875624*r**10
            +1532121230*r**12+5085336893*r**14+21487760013*r**16+14689327610*r**18
            -27876860036*r**20-6085393995*r**22-1579897069*r**24-173066644*r**26
            +9858590*r**28+74771*r**30)+4*Q2**3*(-1157+73388*r**2+1303102*r**4-47410252*r**6
            +61818306*r**8+1239105212*r**10+3689404902*r**12+6233169716*r**14-1101385656*r**16
            -2238290812*r**18-13322010758*r**20-9973666948*r**22-3947265218*r**24
            -103450092*r**26-30318494*r**28+5590428*r**30+22333*r**32)+2*Q2**2*(
            -447+17184*r**2-132149*r**4+9379321*r**6+7830667*r**8+285387037*r**10
            -2214797369*r**12-19284105635*r**14-4305412287*r**16+5509203441*r**18
            -32929105263*r**20+37591020251*r**22-6331072423*r**24+1139137991*r**26
            -350402083*r**28-28432177*r**30-408166*r**32+4107*r**34)-12*Q2*(-80
            +5330*r**2+24149*r**4-3731276*r**6+20537872*r**8+346607692*r**10+751218972*r**12
            +574534900*r**14+4976184960*r**16-7844999744*r**18+9208651006*r**20-10784577284*r**22
            +4395066128*r**24-1287006892*r**26-321630628*r**28-26504868*r**30-4690768*r**32
            +309198*r**34+1333*r**36)+3*(-57+4455*r**2+1651*r**4-4755365*r**6
            +33999596*r**8+552049916*r**10+1070939420*r**12+3260927372*r**14+14149245010*r**16
            -38650944158*r**18+10091920314*r**20+31128267770*r**22-24690211972*r**24
            +4220464300*r**26-645428372*r**28-501804548*r**30-10774145*r**32-4210801*r**34
            +308555*r**36+1059*r**38))*sqrtq2+logq2**5*(-13063680000*(-Q2+(-1+r)**2)*(
            -1+r)*r**22*(1+r)*(1+r**2)*(3+r**2)*(1-Q2+r**2)*(-Q2+(1+r)**2)
            -13063680000*r**22*(-3-r**2+3*r**4+r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2**4*(-10368000*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-480*Q2**6*(1+r**2)+240*Q2**5*(5+17*r**2+12*r**4)-8*Q2**4*(
            -171+503*r**2+1483*r**4+837*r**6)+Q2**3*(-4197-7411*r**2+4737*r**4
            +14275*r**6+6324*r**8)+Q2**2*(-1257+7268*r**2+10278*r**4-3876*r**6
            -5213*r**8+864*r**10)+Q2*(8403+813*r**2-8928*r**4+1020*r**6+5961*r**8
            -1833*r**10-5436*r**12)+3*(-1679-852*r**2-3925*r**4+1808*r**6+4783*r**8
            -908*r**10-75*r**12+848*r**14))-10368000*r**18*(480*Q2**9*(1+r**2)-240*Q2**8*(11
            +29*r**2+18*r**4)+8*Q2**7*(459+2783*r**2+4393*r**4+2097*r**6)-7*Q2**6*(
            -603+2171*r**2+10263*r**4+12565*r**6+5076*r**8)+2*Q2**5*(-7119-14938*r**2
            +9418*r**4+55520*r**6+58597*r**8+20538*r**10)-5*Q2**4*(-357-8491*r**2
            -13112*r**4+264*r**6+16085*r**8+14371*r**10+3528*r**12)+3*(-1+r**2)**3*(1679
            +4210*r**2+8987*r**4+11104*r**6+4513*r**8+638*r**10+1621*r**12+848*r**14)
            -4*Q2**3*(-7455-1925*r**2+9456*r**4+11782*r**6+5237*r**8-4677*r**10
            -70*r**12+3780*r**14)+Q2**2*(-41577-33499*r**2-38777*r**4-29375*r**6
            +61833*r**8+45623*r**10-6283*r**12+17251*r**14+24804*r**16)-6*Q2*(
            -3919-1692*r**2-6234*r**4-5414*r**6+648*r**8+9090*r**10+7578*r**12
            -2370*r**14+135*r**16+2178*r**18))*sqrtq2)+logq2**3*(-345600*r**14*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(640*Q2**10-80*Q2**9*(81
            +109*r**2)+4*Q2**8*(6629+17565*r**2+10744*r**4)-4*Q2**7*(13937+55577*r**2
            +67087*r**4+24047*r**6)+Q2**6*(60123+300955*r**2+587331*r**4+441405*r**6
            +78778*r**8)+2*Q2**5*(-16898-61691*r**2-162424*r**4-207494*r**6-100006*r**8
            +29057*r**10)+Q2**4*(16975+47435*r**2+31266*r**4-542330*r**6-664749*r**8
            -296465*r**10-153860*r**12)+8*Q2**3*(-612-26545*r**2-80570*r**4-24933*r**6
            +148772*r**8+150185*r**10+50490*r**12+9293*r**14)+Q2**2*(-18307+97573*r**2
            +284079*r**4+1148689*r**6+348657*r**8-593941*r**10-206511*r**12-131617*r**14
            +39058*r**16)-6*Q2*(-3612-26855*r**2-171020*r**4+66960*r**6+131432*r**8
            -110278*r**10-16620*r**12+116040*r**14+6060*r**16+7893*r**18)+3*(-2233
            -36861*r**2-247472*r**4+80392*r**6-1734*r**8+157026*r**10-12024*r**12
            -73288*r**14+124223*r**16+7899*r**18+4072*r**20))-345600*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(640*Q2**10-80*Q2**9*(81+109*r**2)+4*Q2**8*(6629
            +17565*r**2+10744*r**4)-4*Q2**7*(13937+55577*r**2+67087*r**4+24047*r**6)
            +Q2**6*(60123+300955*r**2+587331*r**4+441405*r**6+78778*r**8)+2*Q2**5*(
            -16898-61691*r**2-162424*r**4-207494*r**6-100006*r**8+29057*r**10)
            +Q2**4*(16975+47435*r**2+31266*r**4-542330*r**6-664749*r**8-296465*r**10
            -153860*r**12)+8*Q2**3*(-612-26545*r**2-80570*r**4-24933*r**6+148772*r**8
            +150185*r**10+50490*r**12+9293*r**14)+Q2**2*(-18307+97573*r**2+284079*r**4
            +1148689*r**6+348657*r**8-593941*r**10-206511*r**12-131617*r**14+39058*r**16)
            -6*Q2*(-3612-26855*r**2-171020*r**4+66960*r**6+131432*r**8-110278*r**10
            -16620*r**12+116040*r**14+6060*r**16+7893*r**18)+3*(-2233-36861*r**2
            -247472*r**4+80392*r**6-1734*r**8+157026*r**10-12024*r**12-73288*r**14
            +124223*r**16+7899*r**18+4072*r**20))*sqrtq2)+logq2**2*(5760*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-11520*Q2**13+16*Q2**12*(5467+6129*r**2)
            -4*Q2**11*(68411+162683*r**2+81472*r**4)+4*Q2**10*(107538+445435*r**2
            +488576*r**4+115431*r**6)-5*Q2**9*(63513+485409*r**2+836313*r**4+525503*r**6
            +2286*r**8)-5*Q2**8*(-4311-255372*r**2-156518*r**4+31124*r**6-37219*r**8
            +156696*r**10)+2*Q2**7*(81363+461006*r**2+6476095*r**4+14718735*r**6
            +9881570*r**8+2230843*r**10+395556*r**12)+2*Q2**6*(-94431-969843*r**2
            -10679877*r**4-36028570*r**6-43245765*r**8-16754391*r**10-2859143*r**12
            +57588*r**14)+2*Q2**5*(47838+668895*r**2+5004941*r**4+24313856*r**6
            +53179760*r**8+38935933*r**10+2545855*r**12+477316*r**14-311994*r**16)
            +10*Q2**4*(7224-70913*r**2-290236*r**4-202923*r**6-798008*r**8-100423*r**10
            +2309292*r**12+3683419*r**14+392144*r**16+26328*r**18)+10*Q2**3*(-11161
            +33744*r**2+830991*r**4+3372825*r**6+3077805*r**8-4134399*r**10-9993411*r**12
            -7592889*r**14-3011748*r**16-312497*r**18+11460*r**20)-2*Q2**2*(-4051
            -179437*r**2+431045*r**4+16351470*r**6+33703410*r**8+33675702*r**10
            -9064446*r**12-13787040*r**14-19815615*r**16+2099095*r**18+83929*r**20
            +51538*r**22)+3*Q2*(13227-202019*r**2-2912411*r**4-6759935*r**6-28658760*r**8
            +21190806*r**10+3415638*r**12-11047218*r**14+22869135*r**16-2508915*r**18
            +4245317*r**20+351281*r**22+3854*r**24)+3*(-4801+73290*r**2+1453338*r**4
            +5865698*r**6+26364045*r**8-33625068*r**10-10397140*r**12+19279324*r**14
            +7418889*r**16-15437670*r**18+375994*r**20-1257150*r**22-110037*r**24
            +1288*r**26))+5760*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(11520*Q2**14
            -16*Q2**13*(6187+6849*r**2)+4*Q2**12*(90279+209067*r**2+105988*r**4)
            -4*Q2**11*(175949+676529*r**2+732731*r**4+196903*r**6)+Q2**10*(747717
            +4638937*r**2+7917609*r**4+5043543*r**6+473154*r**8)+10*Q2**9*(-33912
            -402147*r**2-739120*r**4-665346*r**6-282504*r**8+77205*r**10)-Q2**8*(141171
            -376403*r**2+10892740*r**4+28810500*r**6+19732665*r**8+5059071*r**10
            +1574592*r**12)+4*Q2**7*(87897+756106*r**2+8808489*r**4+28611700*r**6
            +33923035*r**8+14433402*r**10+2742771*r**12+168984*r**14)+2*Q2**6*(-142269
            -1733169*r**2-16654661*r**4-71022303*r**6-132454095*r**8-98936089*r**10
            -22159389*r**12-3278871*r**14+369582*r**16)-4*Q2**5*(-5859-535649*r**2
            -3562508*r**4-15166706*r**6-40741828*r**8-46308904*r**10-14967664*r**12
            +7696962*r**14+897699*r**16+221817*r**18)+10*Q2**4*(18385-97433*r**2
            -1192140*r**4-3865984*r**6-4078736*r**8+3235968*r**10+12202280*r**12
            +13585600*r**14+7087311*r**16+730969*r**18+14868*r**20)+4*Q2**3*(-29928
            -33261*r**2+2377360*r**4+18685275*r**6+32978280*r**8+14196366*r**10
            -39851748*r**12-50859270*r**14-36419400*r**16-7261065*r**18-710628*r**20
            +54419*r**22)-Q2**2*(31579-973033*r**2-8234017*r**4+13285225*r**6+14133480*r**8
            +198330642*r**10+59469426*r**12-78844626*r**14+1402095*r**16-42959785*r**18
            +17101999*r**20+1324777*r**22+114638*r**24)+6*Q2*(9014-131041*r**2
            -2283884*r**4-7769022*r**6-30891370*r**8+13078557*r**10+17501792*r**12
            -13455452*r**14+2201514*r**16+17898945*r**18+680204*r**20+2926874*r**22
            +232586*r**24+1283*r**26)+3*(-4801+68489*r**2+1526628*r**4+7319036*r**6
            +32229743*r**8-7261023*r**10-44022208*r**12+8882184*r**14+26698213*r**16
            -8018781*r**18-15061676*r**20-881156*r**22-1367187*r**24-108749*r**26
            +1288*r**28))*sqrtq2)+logq2*(48*r**6*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-24832*Q2**16+32*Q2**15*(8831+7391*r**2)-8*Q2**14*(147195
            +310747*r**2+105120*r**4)+8*Q2**13*(279085+1071463*r**2+949863*r**4
            +149925*r**6)+Q2**12*(-1391025-11171351*r**2-11059123*r**4-7147001*r**6
            +269140*r**8)-4*Q2**11*(414176+330159*r**2+10560284*r**4+12969654*r**6
            +2738804*r**8+730411*r**10)+2*Q2**10*(1413177+8996279*r**2+77432240*r**4
            +176075950*r**6+92391625*r**8+15299499*r**10+1319262*r**12)+4*Q2**9*(33930
            -4236587*r**2-47505400*r**4-190977325*r**6-205409750*r**8-43791325*r**10
            -4054812*r**12+365205*r**14)+Q2**8*(-2632035+5002867*r**2+85605557*r**4
            +659131035*r**6+1143100575*r**8+638600425*r**10-124396393*r**12-20966583*r**14
            -3625800*r**16)+8*Q2**7*(139700+319169*r**2+4626662*r**4+18149174*r**6
            +127385300*r**8+158298110*r**10+87545574*r**12+46580062*r**14+3632844*r**16
            +113165*r**18)+4*Q2**6*(264701-1959057*r**2-23969242*r**4-170495852*r**6
            -1024048542*r**8-2141159326*r**10-1374332532*r**12-467276692*r**14-48003727*r**16
            -828817*r**18+461246*r**20)-8*Q2**5*(102873-886356*r**2-9947845*r**4
            -39908980*r**6-335013240*r**8-1271910682*r**10-1593563812*r**12-437240570*r**14
            -133478905*r**16+18659510*r**18+1671809*r**20+146598*r**22)-Q2**4*(178535
            -1807199*r**2+4007465*r**4+95382675*r**6+114198850*r**8+434581850*r**10
            +5891720898*r**12+2616114550*r**14-4645644325*r**16-790689275*r**18-202457835*r**20
            -7395849*r**22+340860*r**24)+4*Q2**3*(69120-1294299*r**2-9485184*r**4
            +91618610*r**6+368745300*r**8+471635775*r**10-425924192*r**12-911801092*r**14
            -1620955560*r**16-1492129325*r**18-296233120*r**20-10748334*r**22+229076*r**24
            +113225*r**26)-2*Q2**2*(5975-383687*r**2-7406276*r**4+54726358*r**6
            +412512145*r**8+2909071835*r**10+3068697954*r**12+375339252*r**14-442052871*r**16
            -2804453825*r**18-5148760*r**20-99536842*r**22+21319199*r**24+944813*r**26
            +12730*r**28)-12*Q2*(3814-119447*r**2-461392*r**4+24862223*r**6+112256118*r**8
            +66295181*r**10+569882944*r**12-240045341*r**14+20753954*r**16-712704661*r**18
            +365365296*r**20-178749747*r**22-25078142*r**24-2222177*r**26-44832*r**28
            +6209*r**30)+3*(3721-172681*r**2-1008755*r**4+54892795*r**6+237587485*r**8
            +542905027*r**10+2875929953*r**12-7282941065*r**14+2909531835*r**16+3719437205*r**18
            -3432125417*r**20+628651937*r**22-210248305*r**24-40930255*r**26-1506565*r**28
            -13331*r**30+6416*r**32))-48*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(24832*Q2**16
            -32*Q2**15*(8831+7391*r**2)+8*Q2**14*(147195+310747*r**2+105120*r**4)
            -8*Q2**13*(279085+1071463*r**2+949863*r**4+149925*r**6)+Q2**12*(1391025
            +11171351*r**2+11059123*r**4+7147001*r**6-269140*r**8)+4*Q2**11*(414176
            +330159*r**2+10560284*r**4+12969654*r**6+2738804*r**8+730411*r**10)
            -2*Q2**10*(1413177+8996279*r**2+77432240*r**4+176075950*r**6+92391625*r**8
            +15299499*r**10+1319262*r**12)-4*Q2**9*(33930-4236587*r**2-47505400*r**4
            -190977325*r**6-205409750*r**8-43791325*r**10-4054812*r**12+365205*r**14)
            +Q2**8*(2632035-5002867*r**2-85605557*r**4-659131035*r**6-1143100575*r**8
            -638600425*r**10+124396393*r**12+20966583*r**14+3625800*r**16)-8*Q2**7*(139700
            +319169*r**2+4626662*r**4+18149174*r**6+127385300*r**8+158298110*r**10
            +87545574*r**12+46580062*r**14+3632844*r**16+113165*r**18)+4*Q2**6*(
            -264701+1959057*r**2+23969242*r**4+170495852*r**6+1024048542*r**8+2141159326*r**10
            +1374332532*r**12+467276692*r**14+48003727*r**16+828817*r**18-461246*r**20)
            +8*Q2**5*(102873-886356*r**2-9947845*r**4-39908980*r**6-335013240*r**8
            -1271910682*r**10-1593563812*r**12-437240570*r**14-133478905*r**16+18659510*r**18
            +1671809*r**20+146598*r**22)+Q2**4*(178535-1807199*r**2+4007465*r**4
            +95382675*r**6+114198850*r**8+434581850*r**10+5891720898*r**12+2616114550*r**14
            -4645644325*r**16-790689275*r**18-202457835*r**20-7395849*r**22+340860*r**24)
            -4*Q2**3*(69120-1294299*r**2-9485184*r**4+91618610*r**6+368745300*r**8
            +471635775*r**10-425924192*r**12-911801092*r**14-1620955560*r**16-1492129325*r**18
            -296233120*r**20-10748334*r**22+229076*r**24+113225*r**26)+2*Q2**2*(5975
            -383687*r**2-7406276*r**4+54726358*r**6+412512145*r**8+2909071835*r**10
            +3068697954*r**12+375339252*r**14-442052871*r**16-2804453825*r**18-5148760*r**20
            -99536842*r**22+21319199*r**24+944813*r**26+12730*r**28)+12*Q2*(3814
            -119447*r**2-461392*r**4+24862223*r**6+112256118*r**8+66295181*r**10
            +569882944*r**12-240045341*r**14+20753954*r**16-712704661*r**18+365365296*r**20
            -178749747*r**22-25078142*r**24-2222177*r**26-44832*r**28+6209*r**30)
            -3*(3721-172681*r**2-1008755*r**4+54892795*r**6+237587485*r**8+542905027*r**10
            +2875929953*r**12-7282941065*r**14+2909531835*r**16+3719437205*r**18
            -3432125417*r**20+628651937*r**22-210248305*r**24-40930255*r**26-1506565*r**28
            -13331*r**30+6416*r**32))*sqrtq2))*math.log(mus))/(-2520*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))-2520*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2+logq2**5*(-9405849600*r**22*(1+r**2)*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            +9405849600*r**22*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**2*(-2177280*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8+3*Q2**3*(1
            +r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4+7*r**6))
            -2177280*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8
            +3*Q2**3*(1+r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4
            +7*r**6))*sqrtq2)+logq2**3*(8709120*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))+8709120*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))*sqrtq2)+logq2**4*(-52254720*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(63+8*Q2**4-402*r**2
            -1122*r**4-402*r**6+63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)
            -3*Q2*(19+31*r**2+31*r**4+19*r**6))-52254720*(-Q2+(-1+r)**2)*r**18*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(63+8*Q2**4-402*r**2-1122*r**4-402*r**6
            +63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)-3*Q2*(19+31*r**2
            +31*r**4+19*r**6))*sqrtq2)+logq2*(30240*(-Q2+(-1+r)**2)*r**6*(1-Q2
            +r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1
            +r**2)-Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)
            +3*(9-86*r**2-446*r**4-86*r**6+9*r**8))+30240*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1+r**2)
            -Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)+3*(9
            -86*r**2-446*r**4-86*r**6+9*r**8))*sqrtq2))+((-12*r**2*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(
            -57-24*Q2**14+3714*r**2+43777*r**4-3791308*r**6-10159121*r**8+15296334*r**10
            -236289183*r**12+694656216*r**14-815729139*r**16+457228062*r**18-127046277*r**20
            +25369844*r**22+93757*r**24+322322*r**26+1059*r**28-56*Q2**13*(1+r**2)
            +Q2**12*(1457-3446*r**2-1627*r**4)+4*Q2**11*(-1615+8387*r**2+54679*r**4
            +3797*r**6)-4*Q2**10*(-3472+30654*r**2+403567*r**4+338572*r**6+11639*r**8)
            +4*Q2**9*(-4008+54495*r**2+1044380*r**4+2055110*r**6+727340*r**8+15387*r**10)
            -Q2**8*(-8157+170178*r**2+3813345*r**4+13564420*r**6+12323485*r**8+1013978*r**10
            +15423*r**12)-8*Q2**7*(-207+2181*r**2+203412*r**4-98905*r**6+1778395*r**8
            +542973*r**10+651616*r**12+6327*r**14)+8*Q2**6*(-420+13398*r**2+622461*r**4
            +1572643*r**6+10153075*r**8+11587780*r**10+3383193*r**12+891191*r**14
            +5943*r**16)+8*Q2**5*(-57-1356*r**2-185973*r**4-797988*r**6-6859881*r**8
            -23311392*r**10-9155691*r**12-2312708*r**14-8398*r**16+1284*r**18)-Q2**4*(
            -1931+71530*r**2+2109045*r**4-6455760*r**6+15777210*r**8-44549788*r**10
            -138504270*r**12+88484320*r**14+7369665*r**16+5785410*r**18+34249*r**20)
            +4*Q2**3*(-119+8471*r**2+323305*r**4-3050295*r**6-3025010*r**8-6052382*r**10
            +19084558*r**12-13941570*r**14+34632105*r**16+3167815*r**18+818121*r**20
            +3001*r**22)+4*Q2**2*(-122+4186*r**2+58337*r**4+87590*r**6+5884315*r**8
            +13803764*r**10+13722438*r**12-4033124*r**14-12132160*r**16-2175310*r**18
            -930087*r**20+223806*r**22+1567*r**24)-4*Q2*(-80+4233*r**2+73226*r**4
            -2220242*r**6-2960350*r**8-2058365*r**10-5455156*r**12-38454012*r**14
            +85305484*r**16-50223425*r**18+15606570*r**20+53198*r**22+327586*r**24
            +1333*r**26))-12*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(192*Q2**19
            +88*Q2**18*(1+r**2)+16*Q2**17*(-781+1642*r**2+761*r**4)-Q2**16*(-73775
            +297995*r**2+1825599*r**4+145669*r**6)+4*Q2**15*(-51861+340660*r**2
            +4186230*r**4+3591900*r**6+150207*r**8)-2*Q2**14*(-160967+1597940*r**2
            +30027301*r**4+56976461*r**6+22270690*r**8+587263*r**10)+4*Q2**13*(-60326
            +917894*r**2+24316527*r**4+81644768*r**6+73261216*r**8+12910234*r**10
            +223639*r**12)+Q2**12*(-25402-563876*r**2-38459200*r**4-358564138*r**6
            -438041866*r**8-228371272*r**10+37752324*r**12+634262*r**14)-4*Q2**11*(
            -48165+833580*r**2+23734310*r**4+18524260*r**6+191728516*r**8+235832836*r**10
            +95582026*r**12+40901932*r**14+427377*r**16)+2*Q2**10*(-43329+1222980*r**2
            +58336869*r**4+277843715*r**6+1545154811*r**8+3240493627*r**10+1729299335*r**12
            +475011561*r**14+58601370*r**16+322773*r**18)+4*Q2**9*(-21736+513590*r**2
            +4363551*r**4-147373004*r**6-899717980*r**8-3213841264*r**10-3392656990*r**12
            -715979284*r**14-140458404*r**16+25380890*r**18+279719*r**20)-2*Q2**8*(
            -45422+1641233*r**2+48534133*r**4-170257418*r**6-588840656*r**8-4624178418*r**10
            -7526070378*r**12-4253144032*r**14+1312661502*r**16+216617569*r**18+93325493*r**20
            +565738*r**22)+4*Q2**7*(1573+68684*r**2+7392018*r**4+10756724*r**6+339887083*r**8
            +998967992*r**10+4261569596*r**12+4797578744*r**14+3260448139*r**16+1591348508*r**18
            +211851218*r**20+7629684*r**22-31163*r**24)+2*Q2**6*(-19635+801700*r**2
            +18156501*r**4-209461039*r**6-777053636*r**8-5007634041*r**10-23534560726*r**12
            -47692110982*r**14-28406379147*r**16-14011017886*r**18-1356019711*r**20
            -196567371*r**22+50182914*r**24+310899*r**26)-4*Q2**5*(-2162+153710*r**2
            +5399059*r**4-79097960*r**6-98177028*r**8-1165588042*r**10-5991109955*r**12
            -22670582320*r**14-29948143010*r**16-3934803926*r**18-3395263571*r**20
            +710056600*r**22+51425816*r**24+13953970*r**26+44419*r**28)-2*Q2**4*(
            -4909+213490*r**2+2377176*r**4-49489669*r**6+14947725*r**8+1709875624*r**10
            +1532121230*r**12+5085336893*r**14+21487760013*r**16+14689327610*r**18
            -27876860036*r**20-6085393995*r**22-1579897069*r**24-173066644*r**26
            +9858590*r**28+74771*r**30)+4*Q2**3*(-1157+73388*r**2+1303102*r**4-47410252*r**6
            +61818306*r**8+1239105212*r**10+3689404902*r**12+6233169716*r**14-1101385656*r**16
            -2238290812*r**18-13322010758*r**20-9973666948*r**22-3947265218*r**24
            -103450092*r**26-30318494*r**28+5590428*r**30+22333*r**32)+2*Q2**2*(
            -447+17184*r**2-132149*r**4+9379321*r**6+7830667*r**8+285387037*r**10
            -2214797369*r**12-19284105635*r**14-4305412287*r**16+5509203441*r**18
            -32929105263*r**20+37591020251*r**22-6331072423*r**24+1139137991*r**26
            -350402083*r**28-28432177*r**30-408166*r**32+4107*r**34)-12*Q2*(-80
            +5330*r**2+24149*r**4-3731276*r**6+20537872*r**8+346607692*r**10+751218972*r**12
            +574534900*r**14+4976184960*r**16-7844999744*r**18+9208651006*r**20-10784577284*r**22
            +4395066128*r**24-1287006892*r**26-321630628*r**28-26504868*r**30-4690768*r**32
            +309198*r**34+1333*r**36)+3*(-57+4455*r**2+1651*r**4-4755365*r**6
            +33999596*r**8+552049916*r**10+1070939420*r**12+3260927372*r**14+14149245010*r**16
            -38650944158*r**18+10091920314*r**20+31128267770*r**22-24690211972*r**24
            +4220464300*r**26-645428372*r**28-501804548*r**30-10774145*r**32-4210801*r**34
            +308555*r**36+1059*r**38))*sqrtq2+logq2**5*(39191040000*(-Q2+(-1+r)**2)*(
            -1+r)*r**22*(1+r)*(1+r**2)*(3+r**2)*(1-Q2+r**2)*(-Q2+(1+r)**2)
            +39191040000*r**22*(-3-r**2+3*r**4+r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2**4*(31104000*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-480*Q2**6*(1+r**2)+240*Q2**5*(5+17*r**2+12*r**4)-8*Q2**4*(
            -171+503*r**2+1483*r**4+837*r**6)+Q2**3*(-4197-7411*r**2+4737*r**4
            +14275*r**6+6324*r**8)+Q2**2*(-1257+7268*r**2+10278*r**4-3876*r**6
            -5213*r**8+864*r**10)+Q2*(8403+813*r**2-8928*r**4+1020*r**6+5961*r**8
            -1833*r**10-5436*r**12)+3*(-1679-852*r**2-3925*r**4+1808*r**6+4783*r**8
            -908*r**10-75*r**12+848*r**14))+31104000*r**18*(480*Q2**9*(1+r**2)-240*Q2**8*(11
            +29*r**2+18*r**4)+8*Q2**7*(459+2783*r**2+4393*r**4+2097*r**6)-7*Q2**6*(
            -603+2171*r**2+10263*r**4+12565*r**6+5076*r**8)+2*Q2**5*(-7119-14938*r**2
            +9418*r**4+55520*r**6+58597*r**8+20538*r**10)-5*Q2**4*(-357-8491*r**2
            -13112*r**4+264*r**6+16085*r**8+14371*r**10+3528*r**12)+3*(-1+r**2)**3*(1679
            +4210*r**2+8987*r**4+11104*r**6+4513*r**8+638*r**10+1621*r**12+848*r**14)
            -4*Q2**3*(-7455-1925*r**2+9456*r**4+11782*r**6+5237*r**8-4677*r**10
            -70*r**12+3780*r**14)+Q2**2*(-41577-33499*r**2-38777*r**4-29375*r**6
            +61833*r**8+45623*r**10-6283*r**12+17251*r**14+24804*r**16)-6*Q2*(
            -3919-1692*r**2-6234*r**4-5414*r**6+648*r**8+9090*r**10+7578*r**12
            -2370*r**14+135*r**16+2178*r**18))*sqrtq2)+logq2**3*(1036800*r**14*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(640*Q2**10-80*Q2**9*(81
            +109*r**2)+4*Q2**8*(6629+17565*r**2+10744*r**4)-4*Q2**7*(13937+55577*r**2
            +67087*r**4+24047*r**6)+Q2**6*(60123+300955*r**2+587331*r**4+441405*r**6
            +78778*r**8)+2*Q2**5*(-16898-61691*r**2-162424*r**4-207494*r**6-100006*r**8
            +29057*r**10)+Q2**4*(16975+47435*r**2+31266*r**4-542330*r**6-664749*r**8
            -296465*r**10-153860*r**12)+8*Q2**3*(-612-26545*r**2-80570*r**4-24933*r**6
            +148772*r**8+150185*r**10+50490*r**12+9293*r**14)+Q2**2*(-18307+97573*r**2
            +284079*r**4+1148689*r**6+348657*r**8-593941*r**10-206511*r**12-131617*r**14
            +39058*r**16)-6*Q2*(-3612-26855*r**2-171020*r**4+66960*r**6+131432*r**8
            -110278*r**10-16620*r**12+116040*r**14+6060*r**16+7893*r**18)+3*(-2233
            -36861*r**2-247472*r**4+80392*r**6-1734*r**8+157026*r**10-12024*r**12
            -73288*r**14+124223*r**16+7899*r**18+4072*r**20))+1036800*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(640*Q2**10-80*Q2**9*(81+109*r**2)+4*Q2**8*(6629
            +17565*r**2+10744*r**4)-4*Q2**7*(13937+55577*r**2+67087*r**4+24047*r**6)
            +Q2**6*(60123+300955*r**2+587331*r**4+441405*r**6+78778*r**8)+2*Q2**5*(
            -16898-61691*r**2-162424*r**4-207494*r**6-100006*r**8+29057*r**10)
            +Q2**4*(16975+47435*r**2+31266*r**4-542330*r**6-664749*r**8-296465*r**10
            -153860*r**12)+8*Q2**3*(-612-26545*r**2-80570*r**4-24933*r**6+148772*r**8
            +150185*r**10+50490*r**12+9293*r**14)+Q2**2*(-18307+97573*r**2+284079*r**4
            +1148689*r**6+348657*r**8-593941*r**10-206511*r**12-131617*r**14+39058*r**16)
            -6*Q2*(-3612-26855*r**2-171020*r**4+66960*r**6+131432*r**8-110278*r**10
            -16620*r**12+116040*r**14+6060*r**16+7893*r**18)+3*(-2233-36861*r**2
            -247472*r**4+80392*r**6-1734*r**8+157026*r**10-12024*r**12-73288*r**14
            +124223*r**16+7899*r**18+4072*r**20))*sqrtq2)+logq2**2*(-17280*r**10*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-11520*Q2**13+16*Q2**12*(5467+6129*r**2)
            -4*Q2**11*(68411+162683*r**2+81472*r**4)+4*Q2**10*(107538+445435*r**2
            +488576*r**4+115431*r**6)-5*Q2**9*(63513+485409*r**2+836313*r**4+525503*r**6
            +2286*r**8)-5*Q2**8*(-4311-255372*r**2-156518*r**4+31124*r**6-37219*r**8
            +156696*r**10)+2*Q2**7*(81363+461006*r**2+6476095*r**4+14718735*r**6
            +9881570*r**8+2230843*r**10+395556*r**12)+2*Q2**6*(-94431-969843*r**2
            -10679877*r**4-36028570*r**6-43245765*r**8-16754391*r**10-2859143*r**12
            +57588*r**14)+2*Q2**5*(47838+668895*r**2+5004941*r**4+24313856*r**6
            +53179760*r**8+38935933*r**10+2545855*r**12+477316*r**14-311994*r**16)
            +10*Q2**4*(7224-70913*r**2-290236*r**4-202923*r**6-798008*r**8-100423*r**10
            +2309292*r**12+3683419*r**14+392144*r**16+26328*r**18)+10*Q2**3*(-11161
            +33744*r**2+830991*r**4+3372825*r**6+3077805*r**8-4134399*r**10-9993411*r**12
            -7592889*r**14-3011748*r**16-312497*r**18+11460*r**20)-2*Q2**2*(-4051
            -179437*r**2+431045*r**4+16351470*r**6+33703410*r**8+33675702*r**10
            -9064446*r**12-13787040*r**14-19815615*r**16+2099095*r**18+83929*r**20
            +51538*r**22)+3*Q2*(13227-202019*r**2-2912411*r**4-6759935*r**6-28658760*r**8
            +21190806*r**10+3415638*r**12-11047218*r**14+22869135*r**16-2508915*r**18
            +4245317*r**20+351281*r**22+3854*r**24)+3*(-4801+73290*r**2+1453338*r**4
            +5865698*r**6+26364045*r**8-33625068*r**10-10397140*r**12+19279324*r**14
            +7418889*r**16-15437670*r**18+375994*r**20-1257150*r**22-110037*r**24
            +1288*r**26))-17280*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(11520*Q2**14
            -16*Q2**13*(6187+6849*r**2)+4*Q2**12*(90279+209067*r**2+105988*r**4)
            -4*Q2**11*(175949+676529*r**2+732731*r**4+196903*r**6)+Q2**10*(747717
            +4638937*r**2+7917609*r**4+5043543*r**6+473154*r**8)+10*Q2**9*(-33912
            -402147*r**2-739120*r**4-665346*r**6-282504*r**8+77205*r**10)-Q2**8*(141171
            -376403*r**2+10892740*r**4+28810500*r**6+19732665*r**8+5059071*r**10
            +1574592*r**12)+4*Q2**7*(87897+756106*r**2+8808489*r**4+28611700*r**6
            +33923035*r**8+14433402*r**10+2742771*r**12+168984*r**14)+2*Q2**6*(-142269
            -1733169*r**2-16654661*r**4-71022303*r**6-132454095*r**8-98936089*r**10
            -22159389*r**12-3278871*r**14+369582*r**16)-4*Q2**5*(-5859-535649*r**2
            -3562508*r**4-15166706*r**6-40741828*r**8-46308904*r**10-14967664*r**12
            +7696962*r**14+897699*r**16+221817*r**18)+10*Q2**4*(18385-97433*r**2
            -1192140*r**4-3865984*r**6-4078736*r**8+3235968*r**10+12202280*r**12
            +13585600*r**14+7087311*r**16+730969*r**18+14868*r**20)+4*Q2**3*(-29928
            -33261*r**2+2377360*r**4+18685275*r**6+32978280*r**8+14196366*r**10
            -39851748*r**12-50859270*r**14-36419400*r**16-7261065*r**18-710628*r**20
            +54419*r**22)-Q2**2*(31579-973033*r**2-8234017*r**4+13285225*r**6+14133480*r**8
            +198330642*r**10+59469426*r**12-78844626*r**14+1402095*r**16-42959785*r**18
            +17101999*r**20+1324777*r**22+114638*r**24)+6*Q2*(9014-131041*r**2
            -2283884*r**4-7769022*r**6-30891370*r**8+13078557*r**10+17501792*r**12
            -13455452*r**14+2201514*r**16+17898945*r**18+680204*r**20+2926874*r**22
            +232586*r**24+1283*r**26)+3*(-4801+68489*r**2+1526628*r**4+7319036*r**6
            +32229743*r**8-7261023*r**10-44022208*r**12+8882184*r**14+26698213*r**16
            -8018781*r**18-15061676*r**20-881156*r**22-1367187*r**24-108749*r**26
            +1288*r**28))*sqrtq2)+logq2*(-144*r**6*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-24832*Q2**16+32*Q2**15*(8831+7391*r**2)-8*Q2**14*(147195
            +310747*r**2+105120*r**4)+8*Q2**13*(279085+1071463*r**2+949863*r**4
            +149925*r**6)+Q2**12*(-1391025-11171351*r**2-11059123*r**4-7147001*r**6
            +269140*r**8)-4*Q2**11*(414176+330159*r**2+10560284*r**4+12969654*r**6
            +2738804*r**8+730411*r**10)+2*Q2**10*(1413177+8996279*r**2+77432240*r**4
            +176075950*r**6+92391625*r**8+15299499*r**10+1319262*r**12)+4*Q2**9*(33930
            -4236587*r**2-47505400*r**4-190977325*r**6-205409750*r**8-43791325*r**10
            -4054812*r**12+365205*r**14)+Q2**8*(-2632035+5002867*r**2+85605557*r**4
            +659131035*r**6+1143100575*r**8+638600425*r**10-124396393*r**12-20966583*r**14
            -3625800*r**16)+8*Q2**7*(139700+319169*r**2+4626662*r**4+18149174*r**6
            +127385300*r**8+158298110*r**10+87545574*r**12+46580062*r**14+3632844*r**16
            +113165*r**18)+4*Q2**6*(264701-1959057*r**2-23969242*r**4-170495852*r**6
            -1024048542*r**8-2141159326*r**10-1374332532*r**12-467276692*r**14-48003727*r**16
            -828817*r**18+461246*r**20)-8*Q2**5*(102873-886356*r**2-9947845*r**4
            -39908980*r**6-335013240*r**8-1271910682*r**10-1593563812*r**12-437240570*r**14
            -133478905*r**16+18659510*r**18+1671809*r**20+146598*r**22)-Q2**4*(178535
            -1807199*r**2+4007465*r**4+95382675*r**6+114198850*r**8+434581850*r**10
            +5891720898*r**12+2616114550*r**14-4645644325*r**16-790689275*r**18-202457835*r**20
            -7395849*r**22+340860*r**24)+4*Q2**3*(69120-1294299*r**2-9485184*r**4
            +91618610*r**6+368745300*r**8+471635775*r**10-425924192*r**12-911801092*r**14
            -1620955560*r**16-1492129325*r**18-296233120*r**20-10748334*r**22+229076*r**24
            +113225*r**26)-2*Q2**2*(5975-383687*r**2-7406276*r**4+54726358*r**6
            +412512145*r**8+2909071835*r**10+3068697954*r**12+375339252*r**14-442052871*r**16
            -2804453825*r**18-5148760*r**20-99536842*r**22+21319199*r**24+944813*r**26
            +12730*r**28)-12*Q2*(3814-119447*r**2-461392*r**4+24862223*r**6+112256118*r**8
            +66295181*r**10+569882944*r**12-240045341*r**14+20753954*r**16-712704661*r**18
            +365365296*r**20-178749747*r**22-25078142*r**24-2222177*r**26-44832*r**28
            +6209*r**30)+3*(3721-172681*r**2-1008755*r**4+54892795*r**6+237587485*r**8
            +542905027*r**10+2875929953*r**12-7282941065*r**14+2909531835*r**16+3719437205*r**18
            -3432125417*r**20+628651937*r**22-210248305*r**24-40930255*r**26-1506565*r**28
            -13331*r**30+6416*r**32))+144*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(24832*Q2**16
            -32*Q2**15*(8831+7391*r**2)+8*Q2**14*(147195+310747*r**2+105120*r**4)
            -8*Q2**13*(279085+1071463*r**2+949863*r**4+149925*r**6)+Q2**12*(1391025
            +11171351*r**2+11059123*r**4+7147001*r**6-269140*r**8)+4*Q2**11*(414176
            +330159*r**2+10560284*r**4+12969654*r**6+2738804*r**8+730411*r**10)
            -2*Q2**10*(1413177+8996279*r**2+77432240*r**4+176075950*r**6+92391625*r**8
            +15299499*r**10+1319262*r**12)-4*Q2**9*(33930-4236587*r**2-47505400*r**4
            -190977325*r**6-205409750*r**8-43791325*r**10-4054812*r**12+365205*r**14)
            +Q2**8*(2632035-5002867*r**2-85605557*r**4-659131035*r**6-1143100575*r**8
            -638600425*r**10+124396393*r**12+20966583*r**14+3625800*r**16)-8*Q2**7*(139700
            +319169*r**2+4626662*r**4+18149174*r**6+127385300*r**8+158298110*r**10
            +87545574*r**12+46580062*r**14+3632844*r**16+113165*r**18)+4*Q2**6*(
            -264701+1959057*r**2+23969242*r**4+170495852*r**6+1024048542*r**8+2141159326*r**10
            +1374332532*r**12+467276692*r**14+48003727*r**16+828817*r**18-461246*r**20)
            +8*Q2**5*(102873-886356*r**2-9947845*r**4-39908980*r**6-335013240*r**8
            -1271910682*r**10-1593563812*r**12-437240570*r**14-133478905*r**16+18659510*r**18
            +1671809*r**20+146598*r**22)+Q2**4*(178535-1807199*r**2+4007465*r**4
            +95382675*r**6+114198850*r**8+434581850*r**10+5891720898*r**12+2616114550*r**14
            -4645644325*r**16-790689275*r**18-202457835*r**20-7395849*r**22+340860*r**24)
            -4*Q2**3*(69120-1294299*r**2-9485184*r**4+91618610*r**6+368745300*r**8
            +471635775*r**10-425924192*r**12-911801092*r**14-1620955560*r**16-1492129325*r**18
            -296233120*r**20-10748334*r**22+229076*r**24+113225*r**26)+2*Q2**2*(5975
            -383687*r**2-7406276*r**4+54726358*r**6+412512145*r**8+2909071835*r**10
            +3068697954*r**12+375339252*r**14-442052871*r**16-2804453825*r**18-5148760*r**20
            -99536842*r**22+21319199*r**24+944813*r**26+12730*r**28)+12*Q2*(3814
            -119447*r**2-461392*r**4+24862223*r**6+112256118*r**8+66295181*r**10
            +569882944*r**12-240045341*r**14+20753954*r**16-712704661*r**18+365365296*r**20
            -178749747*r**22-25078142*r**24-2222177*r**26-44832*r**28+6209*r**30)
            -3*(3721-172681*r**2-1008755*r**4+54892795*r**6+237587485*r**8+542905027*r**10
            +2875929953*r**12-7282941065*r**14+2909531835*r**16+3719437205*r**18
            -3432125417*r**20+628651937*r**22-210248305*r**24-40930255*r**26-1506565*r**28
            -13331*r**30+6416*r**32))*sqrtq2))*math.log(2*muWC))/(-7000*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))-7000*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2+logq2**5*(-26127360000*r**22*(1+r**2)*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            +26127360000*r**22*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**2*(-6048000*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8+3*Q2**3*(1
            +r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4+7*r**6))
            -6048000*(-Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(13+8*Q2**4-102*r**2-422*r**4-102*r**6+13*r**8
            +3*Q2**3*(1+r**2)-Q2**2*(17+18*r**2+17*r**4)-Q2*(7+43*r**2+43*r**4
            +7*r**6))*sqrtq2)+logq2**3*(24192000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))+24192000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(51+16*Q2**4-354*r**2-1194*r**4
            -354*r**6+51*r**8+31*Q2**3*(1+r**2)-Q2**2*(59+86*r**2+59*r**4)-3*Q2*(13
            +37*r**2+37*r**4+13*r**6))*sqrtq2)+logq2**4*(-145152000*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(63+8*Q2**4-402*r**2
            -1122*r**4-402*r**6+63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)
            -3*Q2*(19+31*r**2+31*r**4+19*r**6))-145152000*(-Q2+(-1+r)**2)*r**18*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(63+8*Q2**4-402*r**2-1122*r**4-402*r**6
            +63*r**8+53*Q2**3*(1+r**2)-Q2**2*(67+118*r**2+67*r**4)-3*Q2*(19+31*r**2
            +31*r**4+19*r**6))*sqrtq2)+logq2*(84000*(-Q2+(-1+r)**2)*r**6*(1-Q2
            +r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1
            +r**2)-Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)
            +3*(9-86*r**2-446*r**4-86*r**6+9*r**8))+84000*(-Q2+(-1+r)**2)*r**6*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(32*Q2**4-13*Q2**3*(1+r**2)
            -Q2**2*(43+22*r**2+43*r**4)-3*Q2*(1+49*r**2+49*r**4+r**6)+3*(9
            -86*r**2-446*r**4-86*r**6+9*r**8))*sqrtq2))+((16*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(24*Q2**19
            -16*Q2**18*(1+115*r**2)-Q2**17*(1577+36562*r**2+38213*r**4)+Q2**16*(10991
            +551997*r**2+5532961*r**4+571475*r**6)-2*Q2**15*(18071+1505207*r**2
            +28554422*r**4+28710471*r**6+1561541*r**8)+Q2**14*(67558+9045020*r**2
            +239571118*r**4+497730598*r**6+241874252*r**8+9401758*r**10)-2*Q2**13*(33341
            +8307825*r**2+241992141*r**4+771247738*r**6+773907051*r**8+245871381*r**10
            +8613515*r**12)+2*Q2**12*(3133+9343438*r**2+168470076*r**4+742300605*r**6
            +552079401*r**8+753509748*r**10+176026462*r**12+9536257*r**14)+2*Q2**11*(36101
            -5734703*r**2+247927580*r**4+1149334887*r**6+6077391720*r**8+6055464087*r**10
            +1118888456*r**12+239395489*r**14-5465665*r**16)+2*Q2**10*(-45617+1147146*r**2
            -614062595*r**4-3468068525*r**6-17281307493*r**8-29969336513*r**10-17198324897*r**12
            -3411779271*r**14-611271110*r**16+468523*r**18)+Q2**9*(40612-619190*r**2
            +771416464*r**4+5562037184*r**6+29558667576*r**8+83960882308*r**10+83717182880*r**12
            +29363084304*r**14+5456752084*r**16+788438466*r**18+459712*r**20)+2*Q2**8*(5356
            +2037035*r**2+196136707*r**4+122029236*r**6+5267776392*r**8-7859017506*r**10
            -7168054170*r**12-7639769688*r**14+5190717036*r**16+112938967*r**18+180188471*r**20
            +1993540*r**22)-2*Q2**7*(7813+1994733*r**2+386252870*r**4+1268815945*r**6
            +15777336117*r**8+23139755882*r**10+58532200140*r**12+58677321066*r**14
            +23247916295*r**16+15531145177*r**18+1200036798*r**20+376135421*r**22
            +2181007*r**24)+2*Q2**6*(-1351-52702*r**2+96552161*r**4+801591681*r**6
            +7350693260*r**8+13667718869*r**10+37998776354*r**12+68419904362*r**14
            +38164069601*r**16+13226893020*r**18+7283304317*r**20+755003285*r**22
            +100447578*r**24-19795*r**26)+2*Q2**5*(4597+1176029*r**2+138406081*r**4
            -1010970482*r**6-1492452331*r**8-13115860025*r**10-2136632743*r**12-5557539308*r**14
            -5360104105*r**16-1961710805*r**18-11530830901*r**20-1712380130*r**22
            -1028728097*r**24+127716593*r**26+1288027*r**28)-2*Q2**4*(1597+631290*r**2
            +99611916*r**4-1061943259*r**6-3141206361*r**8-22219990672*r**10-26335567710*r**12
            +23019843303*r**14-34922839477*r**16+25627110882*r**18-26101037592*r**20
            -20237987725*r**22-3325083439*r**24-1097623884*r**26+93744234*r**28+698497*r**30)
            -2*Q2**3*(757+85165*r**2+1074816*r**4+85573623*r**6+1350318366*r**8
            +7431602893*r**10+19771115380*r**12-44913225937*r**14+53171986204*r**16
            +52878755743*r**18-47396731432*r**20+19515728125*r**22+6982614746*r**24
            +1335586023*r**26+96702516*r**28+340957*r**30+100855*r**32)+(-1+r**2)**2*(57
            +21303*r**2+2392046*r**4-138985030*r**6-966727726*r**8-1212484666*r**10
            -28523107066*r**12+139946681570*r**14-425465056380*r**16+625052392692*r**18
            -432551175894*r**20+145279760398*r**22-29968204898*r**24-794522390*r**26
            -973108766*r**28-140938922*r**30+2095315*r**32+24357*r**34)+2*Q2**2*(781
            +207326*r**2+24049963*r**4-568744935*r**6-1873370109*r**8-5602673331*r**10
            -26180296777*r**12+38361172813*r**14+1546003745*r**16-86685868867*r**18
            +3172072849*r**20+41651494811*r**22-28240016895*r**24-4527172185*r**26
            -1939971699*r**28-573691649*r**30+21782990*r**32+237169*r**34)+Q2*(
            -491-159312*r**2-18819443*r**4+733272664*r**6+3208035540*r**8+4782598488*r**10
            +74079639860*r**12-332417459784*r**14+738782588102*r**16-474718515560*r**18
            -460638118698*r**20+748867774856*r**22-347738049628*r**24+79930387464*r**26
            +2973170820*r**28+3253494376*r**30+740943021*r**32-16823720*r**34-182555*r**36))
            -16*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))**2*(24*Q2**20-8*Q2**19*(5+233*r**2)-Q2**18*(1561
            +34706*r**2+36373*r**4)+8*Q2**17*(1571+73767*r**2+700967*r**4+76211*r**6)
            -Q2**16*(47133+3573402*r**2+63193802*r**4+63525378*r**6+3694557*r**8)
            +4*Q2**15*(25925+3022894*r**2+74922594*r**4+153065096*r**6+75604569*r**8
            +3131210*r**10)-4*Q2**14*(33560+6432057*r**2+183150105*r**4+569949298*r**6
            +571854738*r**8+185754693*r**10+6657197*r**12)+4*Q2**13*(18237+8842302*r**2
            +209385021*r**4+877770242*r**6+1048617095*r**8+886644090*r**10+215255679*r**12
            +9074886*r**14)+4*Q2**12*(16484-7540637*r**2+35057033*r**4+119282103*r**6
            +2391505857*r**8+2374937469*r**10+94676123*r**12+26916385*r**14-7500961*r**16)
            +4*Q2**11*(-40859+3422874*r**2-428127736*r**4-2432665496*r**6-12254017050*r**8
            -21051096160*r**10-12186338720*r**12-2385031608*r**14-422600467*r**16
            +2967094*r**18)+2*Q2**10*(65923-1411124*r**2+998623681*r**4+6863149712*r**6
            +35528709806*r**8+89231085160*r**10+89026252850*r**12+35291646320*r**14
            +6751426423*r**16+1005021820*r**18-238667*r**20)+4*Q2**9*(-7475+1163162*r**2
            -94630965*r**4-1522348794*r**6-6146287994*r**8-32309396224*r**10-45503543382*r**12
            -32089951640*r**14-6109600579*r**16-1504828154*r**18-107130309*r**20
            +881842*r**22)-2*Q2**8*(13169+4037124*r**2+584426612*r**4+1586981888*r**6
            +21167141745*r**8+20548514768*r**10+43505128464*r**12+43869497208*r**14
            +20798863643*r**16+20834801180*r**18+1493164236*r**20+558317432*r**22
            +4174547*r**24)+4*Q2**7*(3231+974922*r**2+242399882*r**4+1228330248*r**6
            +12198422661*r**8+26292405434*r**10+59835366188*r**12+92814712784*r**14
            +60044653481*r**16+26002977246*r**18+12007243146*r**20+1165587752*r**22
            +239382003*r**24+1080606*r**26)+4*Q2**6*(2974+615041*r**2+20953311*r**4
            -954557162*r**6-4822368636*r**8-17067136077*r**10-26901563983*r**12-55988110012*r**14
            -55972039034*r**16-26676336713*r**18-16020514119*r**20-4875343866*r**22
            -942089480*r**24+13644405*r**26+653911*r**28)-4*Q2**5*(3097+905958*r**2
            +119597013*r**4-967253830*r**6-2822314587*r**8-18414151514*r**10-20794030239*r**12
            +7662835626*r**14-22920241445*r**16+9152647986*r**18-19796789649*r**20
            -16740599378*r**22-3033095833*r**24-999317694*r**26+111374427*r**28+993262*r**30)
            +4*Q2**4*(420+273861*r**2+49584195*r**4-523952483*r**6-2776733993*r**8
            -16396399963*r**10-34163336881*r**12+20798750765*r**14-32537491189*r**16
            -31087242169*r**18+23461402361*r**20-32927376721*r**22-15272842955*r**24
            -2879146673*r**26-550291083*r**28+47050887*r**30+298821*r**32)+4*Q2**3*(769
            +146624*r**2+12604972*r**4-241048248*r**6-218739060*r**8+1589623964*r**10
            +511210748*r**12+6609531128*r**14+4902382006*r**16+9682436540*r**18+4327048580*r**20
            +6885245752*r**22-870837012*r**24+1895514292*r**26-253841580*r**28-238324088*r**30
            +11112401*r**32+169012*r**34)+Q2**2*(-2053-575526*r**2-67334021*r**4
            +1822662608*r**6+8092265628*r**8+19734685368*r**10+137645580076*r**12
            -356779211856*r**14+658968234986*r**16-304438785316*r**18-293610526662*r**20
            +659220639536*r**22-374561005460*r**24+145464765624*r**26+15907458588*r**28
            +8280821072*r**30+1844760339*r**32-60864038*r**34-656893*r**36)-(-1
            +r**2)**2*(57+21360*r**2+2413349*r**4-136592984*r**6-1105712756*r**8
            -2179212392*r**10-29735591732*r**12+111423574504*r**14-285518374810*r**16
            +199587336312*r**18+192501216798*r**20-287271415496*r**22+115311555500*r**24
            -30762727288*r**26-1767631156*r**28-1114047688*r**30-138843607*r**32
            +2119672*r**34+24357*r**36)+4*Q2*(137+45248*r**2+5332063*r**4-214550260*r**6
            -1156918456*r**8-1852162068*r**10-26481775952*r**12+113529557740*r**14
            -285061663726*r**16+337966278620*r**18-293191095850*r**20+336801212180*r**22
            -288552156704*r**24+118057327492*r**26-28063956792*r**28-1303977244*r**30
            -1170893251*r**32-217306124*r**34+4763219*r**36+51728*r**38))*sqrtq2
            +logq2**7*(-112870195200000*r**32*(1+r**2)**2*(1-Q2+r**2)*(3+22*r**2
            +23*r**4)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-112870195200000*(Q2
            -(-1+r)**2)**2*r**32*(1+r**2)**2*(3+22*r**2+23*r**4)*(Q2-(1+r)**2)**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**6*(-89579520000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(12000*Q2**8*(1+r**2)-240*Q2**7*(225
            +457*r**2+232*r**4)+8*Q2**6*(5208+26029*r**2+27422*r**4+6657*r**6)
            +Q2**5*(162141+110659*r**2-124713*r**4+60413*r**6+133644*r**8)-Q2**4*(295155
            +526908*r**2+265414*r**4+223652*r**6+459687*r**8+268800*r**10)+Q2**3*(
            -103320+28822*r**2+236278*r**4+200334*r**6+201866*r**8+10748*r**10
            -94920*r**12)+3*(-1+r**2)**2*(52433+21132*r**2-21981*r**4+96256*r**6
            +93071*r**8-28092*r**10+19389*r**12+50032*r**14)+Q2**2*(632520+505802*r**2
            -83848*r**4+87548*r**6+80128*r**8-87278*r**10+487168*r**12+595560*r**14)
            -3*Q2*(184383-7425*r**2-103399*r**4+304365*r**6+425717*r**8+274769*r**10
            -117273*r**12-7229*r**14+175052*r**16))+89579520000*r**28*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(12000*Q2**9*(1+r**2)-240*Q2**8*(275
            +557*r**2+282*r**4)+8*Q2**7*(11958+46489*r**2+48092*r**4+13617*r**6)
            +7*Q2**6*(17211-19891*r**2-78903*r**4-30317*r**6+11484*r**8)-4*Q2**5*(114324
            +199927*r**2+62840*r**4+39838*r**6+163436*r**8+100611*r**10)+5*Q2**4*(38367
            +170177*r**2+205720*r**4+137880*r**6+177041*r**8+147847*r**10+34776*r**12)
            +4*Q2**3*(183960+145075*r**2-87237*r**4-87266*r**6-80518*r**8-74973*r**10
            +142835*r**12+172620*r**14)-3*(-1+r**2)**2*(52433+73565*r**2-849*r**4
            +74275*r**6+189327*r**8+64979*r**10-8703*r**12+69421*r**14+50032*r**16)
            -Q2**2*(1185669+1116047*r**2+111757*r**4+916795*r**6+1444827*r**8+817157*r**10
            +48071*r**12+1061041*r**14+1120716*r**16)+12*Q2*(59204+23306*r**2-30659*r**4
            +90579*r**6+152165*r**8+145627*r**10+81535*r**12-35335*r**14+21787*r**16
            +56271*r**18))*sqrtq2)+logq2**5*(-497664000*r**24*(1-Q2+r**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*(-192000*Q2**12*(1+r**2)+480*Q2**11*(5861
            +11778*r**2+5917*r**4)-8*Q2**10*(1828695+5705518*r**2+5730743*r**4+1854144*r**6)
            +120*Q2**9*(307785+1331270*r**2+2051212*r**4+1340090*r**6+312363*r**8)
            -45*Q2**8*(1103531+6098568*r**2+12684598*r**4+12714684*r**6+6138527*r**8
            +1113404*r**10)+20*Q2**7*(2075793+11386508*r**2+27578953*r**4+36557304*r**6
            +27641099*r**8+11386492*r**10+2034459*r**12)-60*Q2**6*(773682+1813455*r**2
            +2385676*r**4+2392395*r**6+2234394*r**8+2172277*r**10+1721608*r**12
            +735441*r**14)+12*Q2**5*(5893620+12759689*r**2+17987869*r**4+9123007*r**6
            -6405165*r**8+3414215*r**10+13864499*r**12+11771569*r**14+5727657*r**16)
            -10*Q2**4*(4907985+21220790*r**2+61167694*r**4+86996460*r**6+60734174*r**8
            +54170368*r**10+75388302*r**12+54922940*r**14+20010805*r**16+4884066*r**18)
            -60*Q2**3*(392173-1051666*r**2-1445003*r**4-2135680*r**6-6236790*r**8
            -7838648*r**10-5336914*r**12-1567656*r**14-1349327*r**16-1002254*r**18
            +379957*r**20)+9*(-1+r**2)**2*(800705+3420374*r**2+24697037*r**4+21009312*r**6
            -7205778*r**8+9749412*r**10+9212694*r**12-7671792*r**14+20142033*r**16
            +23435398*r**18+3213853*r**20+803152*r**22)+60*Q2**2*(990104+1523159*r**2
            +13358288*r**4+18589053*r**6+2963562*r**8-4317246*r**10-4215522*r**12
            +2999430*r**14+17798718*r**16+12504631*r**18+1415506*r**20+982957*r**22)
            -180*Q2*(194932+421253*r**2+3894773*r**4+2115889*r**6-2402739*r**8
            +2778966*r**10+7041102*r**12+2412174*r**14-2441742*r**16+2047301*r**18
            +3679549*r**20+385057*r**22+194765*r**24))+497664000*r**24*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3*(192000*Q2**12*(1+r**2)-480*Q2**11*(5861+11778*r**2
            +5917*r**4)+8*Q2**10*(1828695+5705518*r**2+5730743*r**4+1854144*r**6)
            -120*Q2**9*(307785+1331270*r**2+2051212*r**4+1340090*r**6+312363*r**8)
            +45*Q2**8*(1103531+6098568*r**2+12684598*r**4+12714684*r**6+6138527*r**8
            +1113404*r**10)-20*Q2**7*(2075793+11386508*r**2+27578953*r**4+36557304*r**6
            +27641099*r**8+11386492*r**10+2034459*r**12)+60*Q2**6*(773682+1813455*r**2
            +2385676*r**4+2392395*r**6+2234394*r**8+2172277*r**10+1721608*r**12
            +735441*r**14)-12*Q2**5*(5893620+12759689*r**2+17987869*r**4+9123007*r**6
            -6405165*r**8+3414215*r**10+13864499*r**12+11771569*r**14+5727657*r**16)
            +10*Q2**4*(4907985+21220790*r**2+61167694*r**4+86996460*r**6+60734174*r**8
            +54170368*r**10+75388302*r**12+54922940*r**14+20010805*r**16+4884066*r**18)
            +60*Q2**3*(392173-1051666*r**2-1445003*r**4-2135680*r**6-6236790*r**8
            -7838648*r**10-5336914*r**12-1567656*r**14-1349327*r**16-1002254*r**18
            +379957*r**20)-9*(-1+r**2)**2*(800705+3420374*r**2+24697037*r**4+21009312*r**6
            -7205778*r**8+9749412*r**10+9212694*r**12-7671792*r**14+20142033*r**16
            +23435398*r**18+3213853*r**20+803152*r**22)-60*Q2**2*(990104+1523159*r**2
            +13358288*r**4+18589053*r**6+2963562*r**8-4317246*r**10-4215522*r**12
            +2999430*r**14+17798718*r**16+12504631*r**18+1415506*r**20+982957*r**22)
            +180*Q2*(194932+421253*r**2+3894773*r**4+2115889*r**6-2402739*r**8
            +2778966*r**10+7041102*r**12+2412174*r**14-2441742*r**16+2047301*r**18
            +3679549*r**20+385057*r**22+194765*r**24))*sqrtq2)+logq2**4*(8294400*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(-256000*Q2**16+5120*Q2**15*(2168+2175*r**2)
            -64*Q2**14*(1412729+2870556*r**2+1417347*r**4)+8*Q2**13*(43096783+134147470*r**2
            +134230031*r**4+43175984*r**6)-16*Q2**12*(47077101+204771058*r**2+314893150*r**4
            +204747686*r**6+46998093*r**8)+Q2**11*(1013651109+5855699852*r**2+12288240682*r**4
            +12279667036*r**6+5841181489*r**8+1005143832*r**10)-Q2**10*(854544621
            +5870535985*r**2+14166941438*r**4+18112309238*r**6+14081977333*r**8+5818404377*r**10
            +839384928*r**12)+Q2**9*(387868437+1874010248*r**2-2164280029*r**4-14962946160*r**6
            -15159493885*r**8-2442765808*r**10+1787931973*r**12+382473816*r**14)
            +Q2**8*(189232047+2589044555*r**2+26338713889*r**4+88273778661*r**6+128885627265*r**8
            +88832803237*r**10+26692520815*r**12+2641282219*r**14+171013056*r**16)
            -2*Q2**7*(376705459+1648365212*r**2+14438443330*r**4+53234349684*r**6
            +98791596902*r**8+99003441604*r**10+53448656122*r**12+14392146500*r**14
            +1619033899*r**16+365489512*r**18)+2*Q2**6*(453085891+1171628443*r**2
            +9506106058*r**4+22832230234*r**6+41381620606*r**8+52993576054*r**10
            +40964457418*r**12+22325774698*r**14+9069258379*r**16+1097522091*r**18
            +456046368*r**20)-2*Q2**5*(207136019+1744794560*r**2+13766488717*r**4
            +17509692392*r**6+9022906452*r**8-257452208*r**10-2727885268*r**12+5150068992*r**14
            +15624920617*r**16+13163847552*r**18+1683925303*r**20+221668872*r**22)
            +2*Q2**4*(-81841453+1959881643*r**2+14689627881*r**4+34306476905*r**6
            +52488341340*r**8+50743079916*r**10+37126711284*r**12+43371991068*r**14
            +45753554265*r**16+31776419305*r**18+14310907107*r**20+1952642043*r**22
            -72607304*r**24)+3*Q2**3*(89351563-240647580*r**2+387559846*r**4-10619410236*r**6
            -12999777375*r**8-12622927296*r**10-22641131820*r**12-21007448232*r**14
            -10207484163*r**16-11743449100*r**18-9957973242*r**20+401420900*r**22
            -260069289*r**24+90402024*r**26)+9*(-1+r**2)**2*(560611-43960883*r**2
            -448213644*r**4-879624572*r**6-4316389157*r**8-2710449267*r**10+2074996216*r**12
            +2328026808*r**14+1934413409*r**16-2713764801*r**18-4097525644*r**20
            -804360508*r**22-440983839*r**24-43850137*r**26+485408*r**28)-3*Q2**2*(31464947
            +714103191*r**2+8030295130*r**4+5990657602*r**6+42941631141*r**8+48691385681*r**10
            -3374013492*r**12-22681450980*r**14-2764574019*r**16+46943957113*r**18
            +40023702522*r**20+5334750626*r**22+7923720875*r**24+696811167*r**26
            +34518496*r**28)+9*Q2*(-187599+191200968*r**2+1771512303*r**4+1415295744*r**6
            +13032998581*r**8+4645762736*r**10-7849618581*r**12+7653684664*r**14
            +7295687747*r**16-7710264312*r**18+4756775965*r**20+12327911888*r**22
            +1177716183*r**24+1744646784*r**26+189151881*r**28+285048*r**30))+8294400*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(256000*Q2**17-5120*Q2**16*(2218+2225*r**2)
            +64*Q2**15*(1586169+3217996*r**2+1591347*r**4)-40*Q2**14*(10879723+33682750*r**2
            +33706651*r**4+10902952*r**6)+8*Q2**13*(137250985+586786369*r**2+898163801*r**4
            +586901387*r**6+137172170*r**8)-Q2**12*(1766884725+9885270396*r**2+20602868010*r**4
            +20593920412*r**6+9869113953*r**8+1757113320*r**10)+2*Q2**11*(934097865
            +6369943473*r**2+16155440986*r**4+21340108478*r**6+16101412929*r**8+6332364849*r**10
            +922264380*r**12)-2*Q2**10*(621206529+4299545427*r**2+8936598697*r**4
            +8658152258*r**6+8517396343*r**8+8728807951*r**10+4222860639*r**12+610929372*r**14)
            +10*Q2**9*(19863639-32716587*r**2-2662898367*r**4-10540100485*r**6-15900806731*r**8
            -10643506293*r**10-2734735465*r**12-47087643*r**14+21146076*r**16)+Q2**8*(942642965
            +6075007026*r**2+57804645104*r**4+221081191918*r**6+414742599730*r**8
            +415725313710*r**10+222422636296*r**12+58118096034*r**14+6050363073*r**16
            +901992080*r**18)-4*Q2**7*(414895675+1598349557*r**2+12796457300*r**4
            +45252511624*r**6+96703783596*r**8+125394307280*r**10+96708277572*r**12
            +45083288660*r**14+12540219389*r**16+1541022751*r**18+410767940*r**20)
            +4*Q2**6*(330110955+1684754447*r**2+12222111609*r**4+24924014342*r**6
            +36618378646*r**8+47058872226*r**10+45615074102*r**12+34220150554*r**14
            +23509976847*r**16+11665314011*r**18+1618746881*r**20+338857620*r**22)
            -4*Q2**5*(62647283+1955906111*r**2+15100455579*r**4+32791329007*r**6
            +39510470092*r**8+29754267080*r**10+17070686904*r**12+22897087396*r**14
            +33264271937*r**16+30282593737*r**18+14579339981*r**20+1929118109*r**22
            +74530784*r**24)-5*Q2**4*(86347519-895604624*r**2-6427267902*r**4-25970088056*r**6
            -42517793723*r**8-48866324880*r**10-48732595572*r**12-44803949880*r**14
            -41774708631*r**16-38058058888*r**18-24409714510*r**20-6264567120*r**22
            -908055469*r**24+83284136*r**26)+6*Q2**3*(60408255+281403587*r**2+4088603698*r**4
            -2120596394*r**6+9661221765*r**8+11534340505*r**10-19319036304*r**12
            -33165015516*r**14-16989753207*r**16+12496511925*r**18+9161140090*r**20
            -2110900858*r**22+4032536243*r**24+263571951*r**26+62460260*r**28)+9*(
            -1+r**2)**2*(560611-43400272*r**2-492174527*r**4-1327838216*r**6-5196013729*r**8
            -7026838424*r**10-635453051*r**12+4403023024*r**14+4262440217*r**16-779351392*r**18
            -6811290445*r**20-4901886152*r**22-1245344347*r**24-484833976*r**26-43364729*r**28
            +485408*r**30)-6*Q2**2*(15451075+659585521*r**2+7029467615*r**4+9133419982*r**6
            +44015642243*r**8+52785152515*r**10+10884258223*r**12-1547205240*r**14
            -1779480879*r**16+10524295079*r**18+50618993765*r**20+41171094406*r**22
            +8395810025*r**24+6927236197*r**26+649392653*r**28+17686820*r**30)-18*Q2*(374105
            -118047737*r**2-1161222269*r**4-1606983107*r**6-8726823991*r**8-6318028421*r**10
            +3191680719*r**12-2168240487*r**14-7798008201*r**16-1919994123*r**18
            +3108952857*r**20-6203880937*r**22-8217708269*r**24-1444302967*r**26
            -1143298411*r**28-117128941*r**30+100180*r**32))*sqrtq2)+logq2**3*(138240*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-12666880*Q2**19+512*Q2**18*(313695
            +313676*r**2)-64*Q2**17*(14318585+29354974*r**2+14300709*r**4)+16*Q2**16*(187371625
            +607653066*r**2+607145465*r**4+186772216*r**6)-16*Q2**15*(368528175+1732508992*r**2
            +2690435014*r**4+1728660024*r**6+366527107*r**8)+Q2**14*(6344907065+43763401900*r**2
            +91102035250*r**4+90950133692*r**6+43578549365*r**8+6304304760*r**10)
            -2*Q2**13*(680025435+14098180803*r**2+26561373550*r**4+25049434274*r**6
            +26308954779*r**8+13988275035*r**10+698050908*r**12)-Q2**12*(5727515205
            +22150079082*r**2+175213040007*r**4+480229710268*r**6+480612033763*r**8
            +175499324618*r**10+21995296977*r**12+5548689552*r**14)+4*Q2**11*(1896089775
            +14888033493*r**2+116480613015*r**4+390841301661*r**6+574488543325*r**8
            +390496467335*r**10+115948614661*r**12+14659152135*r**14+1853350488*r**16)
            -Q2**10*(3172130375+52368923064*r**2+524676200448*r**4+2220790141976*r**6
            +4341270066358*r**8+4335264886560*r**10+2210623045848*r**12+518338392056*r**14
            +51005112363*r**16+3281534744*r**18)+2*Q2**9*(-699536745+14448319075*r**2
            +138903036900*r**4+622357446208*r**6+1306495524070*r**8+1580468024230*r**10
            +1290183095080*r**12+610438475560*r**14+135418900283*r**16+14089633935*r**18
            -524095940*r**20)+Q2**8*(2526250595-10423727174*r**2+59903502675*r**4
            +661539984696*r**6+3546121251406*r**8+8008111804300*r**10+8048311836694*r**12
            +3606644642520*r**14+684946040111*r**16+59732836266*r**18-11238591305*r**20
            +2320855296*r**22)-8*Q2**7*(207486065+1821876141*r**2+34162095601*r**4
            +158289708483*r**6+792777995108*r**8+2053657872438*r**10+2812130078694*r**12
            +2062395575394*r**14+795689623333*r**16+157863356333*r**18+33251808793*r**20
            +1607892811*r**22+222221846*r**24)+Q2**6*(395262675+32642008588*r**2
            +301350571210*r**4+593291599244*r**6+3395211085905*r**8+8317925378400*r**10
            +13903461124028*r**12+13917899649880*r**14+8291212339893*r**16+3301528261580*r**18
            +558005379450*r**20+297787849244*r**22+31835598375*r**24+589046728*r**26)
            +2*Q2**5*(287771075-10243836653*r**2-101401939766*r**4-376801896898*r**6
            -1751541743099*r**8-1256040858195*r**10-82250583768*r**12+79901672484*r**14
            +125632504269*r**16-1066651814003*r**18-1646716585870*r**20-354591159394*r**22
            -103913078933*r**24-10619178061*r**26+266566812*r**28)+Q2**4*(-626446695
            -2543642550*r**2+67320480575*r**4+1303569847892*r**6+5235181643945*r**8
            +7176637291830*r**10+6549175717335*r**12+6269191443720*r**14+5626735541091*r**16
            +5393894132790*r**18+6483268364565*r**20+5027223655540*r**22+1277820996955*r**24
            +72986567242*r**26-1512008235*r**28-678786000*r**30)+12*Q2**3*(8882005
            +732157639*r**2+3192447025*r**4-42952282429*r**6-66237614679*r**8-372358717165*r**10
            -343485267419*r**12-384487596465*r**14-538421930097*r**16-335489601787*r**18
            -299988334045*r**20-342262738279*r**22-60524767085*r**24-43357515999*r**26
            +3153101191*r**28+713566805*r**30+11330784*r**32)+9*(-1+r**2)**2*(1858225
            +20700088*r**2-877604068*r**4-16326529040*r**6-75940686960*r**8-43393408280*r**10
            -455316108964*r**12-241791230816*r**14+534380439130*r**16+511463942120*r**18
            -260542352140*r**20-436570424336*r**22-33722452264*r**24-74109876840*r**26
            -16032055660*r**28-901527680*r**30+16925837*r**32+1991648*r**34)+3*Q2**2*(52867305
            -1115941568*r**2-23142218228*r**4-185410325456*r**6-1207213820016*r**8
            -111701569976*r**10-3504644751572*r**12-3308716152512*r**14+1295905067562*r**16
            +1257964413432*r**18-3204100318588*r**20-3245771636752*r**22-41730605992*r**24
            -1190170694856*r**26-178610601916*r**28-23758347616*r**30-1207711483*r**32
            +53948232*r**34)-18*Q2*(5343175-895813*r**2-2184833280*r**4-30049593092*r**6
            -133811892840*r**8+43417474080*r**10-680783026716*r**12-175400589780*r**14
            +389677560686*r**16-44301508770*r**18+363922466740*r**20-194180688204*r**22
            -650388164800*r**24+57420787704*r**26-131073253140*r**28-29302150620*r**30
            -2238101517*r**32-11401265*r**34+5667452*r**36))-138240*r**16*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**4*(12666880*Q2**19-512*Q2**18*(313695+313676*r**2)
            +64*Q2**17*(14318585+29354974*r**2+14300709*r**4)-16*Q2**16*(187371625
            +607653066*r**2+607145465*r**4+186772216*r**6)+16*Q2**15*(368528175+1732508992*r**2
            +2690435014*r**4+1728660024*r**6+366527107*r**8)-Q2**14*(6344907065+43763401900*r**2
            +91102035250*r**4+90950133692*r**6+43578549365*r**8+6304304760*r**10)
            +2*Q2**13*(680025435+14098180803*r**2+26561373550*r**4+25049434274*r**6
            +26308954779*r**8+13988275035*r**10+698050908*r**12)+Q2**12*(5727515205
            +22150079082*r**2+175213040007*r**4+480229710268*r**6+480612033763*r**8
            +175499324618*r**10+21995296977*r**12+5548689552*r**14)-4*Q2**11*(1896089775
            +14888033493*r**2+116480613015*r**4+390841301661*r**6+574488543325*r**8
            +390496467335*r**10+115948614661*r**12+14659152135*r**14+1853350488*r**16)
            +Q2**10*(3172130375+52368923064*r**2+524676200448*r**4+2220790141976*r**6
            +4341270066358*r**8+4335264886560*r**10+2210623045848*r**12+518338392056*r**14
            +51005112363*r**16+3281534744*r**18)+2*Q2**9*(699536745-14448319075*r**2
            -138903036900*r**4-622357446208*r**6-1306495524070*r**8-1580468024230*r**10
            -1290183095080*r**12-610438475560*r**14-135418900283*r**16-14089633935*r**18
            +524095940*r**20)-Q2**8*(2526250595-10423727174*r**2+59903502675*r**4
            +661539984696*r**6+3546121251406*r**8+8008111804300*r**10+8048311836694*r**12
            +3606644642520*r**14+684946040111*r**16+59732836266*r**18-11238591305*r**20
            +2320855296*r**22)+8*Q2**7*(207486065+1821876141*r**2+34162095601*r**4
            +158289708483*r**6+792777995108*r**8+2053657872438*r**10+2812130078694*r**12
            +2062395575394*r**14+795689623333*r**16+157863356333*r**18+33251808793*r**20
            +1607892811*r**22+222221846*r**24)-Q2**6*(395262675+32642008588*r**2
            +301350571210*r**4+593291599244*r**6+3395211085905*r**8+8317925378400*r**10
            +13903461124028*r**12+13917899649880*r**14+8291212339893*r**16+3301528261580*r**18
            +558005379450*r**20+297787849244*r**22+31835598375*r**24+589046728*r**26)
            +Q2**5*(-575542150+20487673306*r**2+202803879532*r**4+753603793796*r**6
            +3503083486198*r**8+2512081716390*r**10+164501167536*r**12-159803344968*r**14
            -251265008538*r**16+2133303628006*r**18+3293433171740*r**20+709182318788*r**22
            +207826157866*r**24+21238356122*r**26-533133624*r**28)+Q2**4*(626446695
            +2543642550*r**2-67320480575*r**4-1303569847892*r**6-5235181643945*r**8
            -7176637291830*r**10-6549175717335*r**12-6269191443720*r**14-5626735541091*r**16
            -5393894132790*r**18-6483268364565*r**20-5027223655540*r**22-1277820996955*r**24
            -72986567242*r**26+1512008235*r**28+678786000*r**30)-12*Q2**3*(8882005
            +732157639*r**2+3192447025*r**4-42952282429*r**6-66237614679*r**8-372358717165*r**10
            -343485267419*r**12-384487596465*r**14-538421930097*r**16-335489601787*r**18
            -299988334045*r**20-342262738279*r**22-60524767085*r**24-43357515999*r**26
            +3153101191*r**28+713566805*r**30+11330784*r**32)+3*Q2**2*(-52867305
            +1115941568*r**2+23142218228*r**4+185410325456*r**6+1207213820016*r**8
            +111701569976*r**10+3504644751572*r**12+3308716152512*r**14-1295905067562*r**16
            -1257964413432*r**18+3204100318588*r**20+3245771636752*r**22+41730605992*r**24
            +1190170694856*r**26+178610601916*r**28+23758347616*r**30+1207711483*r**32
            -53948232*r**34)-9*(-1+r**2)**2*(1858225+20700088*r**2-877604068*r**4
            -16326529040*r**6-75940686960*r**8-43393408280*r**10-455316108964*r**12
            -241791230816*r**14+534380439130*r**16+511463942120*r**18-260542352140*r**20
            -436570424336*r**22-33722452264*r**24-74109876840*r**26-16032055660*r**28
            -901527680*r**30+16925837*r**32+1991648*r**34)+18*Q2*(5343175-895813*r**2
            -2184833280*r**4-30049593092*r**6-133811892840*r**8+43417474080*r**10
            -680783026716*r**12-175400589780*r**14+389677560686*r**16-44301508770*r**18
            +363922466740*r**20-194180688204*r**22-650388164800*r**24+57420787704*r**26
            -131073253140*r**28-29302150620*r**30-2238101517*r**32-11401265*r**34
            +5667452*r**36))*sqrtq2)+logq2**2*(-2304*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(57817088*Q2**22-512*Q2**21*(1373233+1370858*r**2)+32*Q2**20*(114045429
            +239112202*r**2+113716629*r**4)-160*Q2**19*(63987193+220392098*r**2+220132521*r**4
            +63790480*r**6)+40*Q2**18*(387286504+2155880811*r**2+3362355261*r**4
            +2152277073*r**6+387086231*r**8)-Q2**17*(7741564827+105742530200*r**2
            +203572663830*r**4+203454427740*r**6+105729310415*r**8+7929970572*r**10)
            -Q2**16*(13765758751-4932594549*r**2+203156544970*r**4+474912956370*r**6
            +202037958615*r**8-6016558109*r**10+13264948096*r**12)+2*Q2**15*(13224782459
            +98028752297*r**2+730211036019*r**4+1984916615210*r**6+1982466818845*r**8
            +726434659509*r**10+96353468437*r**12+13012240024*r**14)-10*Q2**14*(1206171141
            +30689914566*r**2+266534089392*r**4+991137919329*r**6+1487310582145*r**8
            +988436313972*r**10+264707473026*r**12+30209993637*r**14+1245653640*r**16)
            -10*Q2**13*(1186834703-17324217803*r**2-185076326668*r**4-1086209475285*r**6
            -2247358858364*r**8-2243224838309*r**10-1080725931984*r**12-183657798203*r**14
            -17150481079*r**16+1069108352*r**18)+2*Q2**12*(8562684889+45853864850*r**2
            +480402460695*r**4-191127042735*r**6-1003772335*r**8+1596674375781*r**10
            +38431207645*r**12-180675379365*r**14+468984602010*r**16+42880110685*r**18
            +8195919944*r**20)-2*Q2**11*(2631239073+110522739223*r**2+1349300010795*r**4
            +6454106869440*r**6+26357275624730*r**8+58385226530862*r**10+58387329738222*r**12
            +26313751609040*r**14+6393585291045*r**16+1321395405315*r**18+105451808263*r**20
            +2895043368*r**22)+2*Q2**10*(-2374955461+65079307942*r**2+875781150234*r**4
            +7794783489575*r**6+43033895032870*r**8+125502763431076*r**10+179202230740588*r**12
            +125253365278726*r**14+42720512822935*r**16+7650990536750*r**18+865309664914*r**20
            +63590003547*r**22-1901187856*r**24)+10*Q2**9*(622676546+1460652411*r**2
            -29616877908*r**4-947051755077*r**6-5927538481240*r**8-21166359667134*r**10
            -39688417731456*r**12-39583307697402*r**14-20984557356942*r**16-5815798310705*r**18
            -917221742412*r**20-34862583969*r**22+621384132*r**24+602964820*r**26)
            -10*Q2**8*(286106142+6623789413*r**2+11662714593*r**4-285369954279*r**6
            +316892989985*r**8+3118283311872*r**10+10943557759914*r**12+17179880926122*r**14
            +11286063535248*r**16+3371734590069*r**18+378768565661*r**20-282532474755*r**22
            +5216675313*r**24+5712879334*r**26+329036568*r**28)+2*Q2**7*(-624885151
            +22767209475*r**2+198269604605*r**4+1428833475330*r**6+20461003382305*r**8
            +84141434697921*r**10+279365075352085*r**12+520408571568340*r**14+521841734444075*r**16
            +280992514896325*r**18+84562909189231*r**20+20197323637410*r**22+1262639809875*r**24
            +193384228215*r**26+22810674815*r**28-488974456*r**30)+2*Q2**6*(1247144677
            -7182120098*r**2-337565900580*r**4-3139517616815*r**6-18193415435705*r**8
            -33306475535532*r**10-163054144866542*r**12-357274145699405*r**14-473684267249205*r**16
            -358446749938210*r**18-161393872348312*r**20-32131371436857*r**22-17906936414815*r**24
            -2972525480080*r**26-351283527510*r**28-9777601483*r**30+1279642472*r**32)
            -6*Q2**5*(126435887+1465524401*r**2-48285910448*r**4-835776649365*r**6
            -4170241932250*r**8-6896500478487*r**10-33904010651596*r**12-11711508501717*r**14
            +1361043026040*r**16+2187381702955*r**18-9616612954712*r**20-31472591216791*r**22
            -6028444311582*r**24-4220879059925*r**26-841904705580*r**28-51613592063*r**30
            +1092737361*r**32+143737872*r**34)-10*Q2**4*(62650317-1496513098*r**2
            -20887838261*r**4+150745670289*r**6+1915562946315*r**8+14124531121629*r**10
            +39732434845383*r**12+25898097221581*r**14+15861412802897*r**16+27294036338085*r**18
            +11669445004201*r**20+22115693639603*r**22+37797858496521*r**24+13603029645639*r**26
            +1950154068525*r**28+175092753903*r**30-20490917938*r**32-1600766591*r**34
            +61551000*r**36)+30*Q2**3*(14252443-178291003*r**2-6354980123*r**4-26205222452*r**6
            +113222052724*r**8+2860651915176*r**10+2895968820500*r**12+7454481567028*r**14
            +6732000750290*r**16+12187195058554*r**18+11559462224694*r**20+5674459777964*r**22
            +6545881369748*r**24+2602659094016*r**26+2831622719940*r**28+108311227612*r**30
            -22772460661*r**32-6419824103*r**34-209448179*r**36+14835832*r**38)+9*(
            -1+r**2)**2*(1931747-51403885*r**2-1141266025*r**4+12212543695*r**6+236122607020*r**8
            +2016148035532*r**10+4920957098380*r**12-4132553048900*r**14+39852071452090*r**16
            +456907520490*r**18-65645238765678*r**20+2935899022770*r**22+39113950851500*r**24
            -4835406923140*r**26+4808346538460*r**28+1962773929772*r**30+233794150235*r**32
            +13359599675*r**34-1118080145*r**36-55370345*r**38+1976752*r**40)+6*Q2**2*(4657523
            -432644950*r**2-160494670*r**4+201424186675*r**6+1740868842100*r**8+8012690537428*r**10
            +45935932816540*r**12-26292974854400*r**14+78584733229990*r**16+60437298161640*r**18
            -25925620153632*r**20+58023589620270*r**22+71506991877560*r**24-27925097915380*r**26
            +45607839680420*r**28+7543433468888*r**30+1759921040015*r**32+209289626510*r**34
            +242060590*r**36-432009785*r**38+3866668*r**40)-9*Q2*(8984129-266392946*r**2
            -4215711830*r**4+70951506930*r**6+924214231085*r**8+6476131428644*r**10
            +17229536303864*r**12-29497595920360*r**14+107714829722210*r**16+13995662855620*r**18
            -75055808963556*r**20-70312139497716*r**22+19048059782210*r**24+104293316169040*r**26
            -31340634290120*r**28+17016414216664*r**30+6241328582749*r**32+916363031230*r**34
            +76118370570*r**36-4070249710*r**38-283659631*r**40+9100924*r**42))+2304*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(57817088*Q2**23-512*Q2**22*(1486157
            +1483782*r**2)+32*Q2**21*(136017157+283017658*r**2+135650357*r**4)-32*Q2**20*(433981394
            +1455118121*r**2+1453491436*r**4+432669029*r**6)+40*Q2**19*(643235276
            +3293397975*r**2+5124453737*r**4+3287969077*r**6+642248151*r**8)-Q2**18*(23233024987
            +207469222800*r**2+424302106710*r**4+424039721100*r**6+207303842575*r**8
            +23413419812*r**10)-4*Q2**17*(1506048481-29604172394*r**2-26539662265*r**4
            +16971466200*r**6-26786444885*r**8-29918959774*r**10+1333744381*r**12)
            +Q2**16*(40215323669+204890668796*r**2+1658646022459*r**4+4647902731760*r**6
            +4641884552675*r**8+1648890719524*r**10+199955326861*r**12+39289428144*r**14)
            -4*Q2**15*(9627819082+132351553793*r**2+1080455117638*r**4+3835408623937*r**6
            +5701968172390*r**8+3825541524107*r**10+1073162746538*r**12+130207838323*r**14
            +9620254112*r**16)+20*Q2**14*(9668219+24610151755*r**2+241150165313*r**4
            +1171940742003*r**6+2362903679919*r**8+2359485867213*r**10+1166934859491*r**12
            +239287632433*r**14+24303064178*r**16+88272644*r**18)+4*Q2**13*(7248429202
            -17416525325*r**2-265800130830*r**4-3273778026250*r**6-8334422720290*r**8
            -10428122053792*r**10-8290661321910*r**12-3251297015150*r**14-267528397200*r**16
            -18763376475*r**18+6770730852*r**20)-4*Q2**12*(5596961981+82469644481*r**2
            +937778168170*r**4+3371691143700*r**6+13082572404830*r**8+29990448567154*r**10
            +30011217660824*r**12+13085753718660*r**14+3340947256845*r**16+916630059005*r**18
            +78263919446*r**20+5545481656*r**22)+4*Q2**11*(128141806+89116643119*r**2
            +1167801950126*r**4+7799095184905*r**6+37922638763520*r**8+105122632793334*r**10
            +147987393504836*r**12+104977223312994*r**14+37713924861510*r**16+7682985616555*r**18
            +1146078439246*r**20+85968427589*r**22+496927756*r**24)+2*Q2**10*(5488338191
            -55401090426*r**2-1088944847716*r**4-13405823415194*r**6-80466370928645*r**8
            -274368456799616*r**10-503147082828944*r**12-502372134506324*r**14-272896664886371*r**16
            -79450494913210*r**18-13102408913724*r**20-1103212588306*r**22-58581895031*r**24
            +4916011956*r**26)-20*Q2**9*(454391344+4353559185*r**2-8246755452*r**4
            -631019293632*r**6-3278848623166*r**8-11987807418251*r**10-24955609819338*r**12
            -31045922251368*r**14-24640900759548*r**16-11714310538789*r**18-3177125743728*r**20
            -617308400568*r**22-14512262262*r**24+3468614143*r**26+466000694*r**28)
            +2*Q2**8*(805645559+57316687250*r**2+289702124635*r**4+60297276900*r**6
            +20618618560835*r**8+101317316207206*r**10+349674280711015*r**12+661025764998520*r**14
            +664171456750925*r**16+354281505522910*r**18+103315424967881*r**20+20678504091940*r**22
            -123939187335*r**24+248032001450*r**26+53020254325*r**28+1156208384*r**30)
            +4*Q2**7*(936014914-14662222211*r**2-279301357330*r**4-2383310348375*r**6
            -20041626146670*r**8-68954456807879*r**10-263280327458274*r**12-578523896309915*r**14
            -757967286630810*r**16-580640499639305*r**18-263474648216934*r**20-68445802131749*r**22
            -19683449931050*r**24-2214274759085*r**26-283739215270*r**28-16049650921*r**30
            +884308464*r**32)+4*Q2**6*(-813226169+769201109*r**2+244802876011*r**4
            +2992206732745*r**6+16921829424635*r**8+36094696203349*r**10+149036326178431*r**12
            +277731408035549*r**14+413437641935245*r**16+412784436039275*r**18+274345230575329*r**20
            +143971508717771*r**22+34061820393209*r**24+16771049537335*r**26+2924761562165*r**28
            +257950952591*r**30+2609873464*r**32-855428044*r**34)+4*Q2**5*(33028038
            +6129223177*r**2-18010983418*r**4-1702958015442*r**6-12297935238210*r**8
            -51911441420178*r**10-160531853808582*r**12-133168521783922*r**14-55179230220758*r**16
            -62912453751720*r**18-40317459388138*r**20-116923040356262*r**22-150746199533862*r**24
            -49381559171358*r**26-12469560819570*r**28-1778009331222*r**30-24553987208*r**32
            +5856629327*r**34+61729308*r**36)+20*Q2**4*(52703823-984367895*r**2-20724645864*r**4
            +25621082336*r**6+1202987387388*r**8+12311024906736*r**10+31272436214256*r**12
            +43996988384024*r**14+30977756137674*r**16+39858517158322*r**18+36820934008184*r**20
            +25404258988848*r**22+39775598122684*r**24+29604432712104*r**26+12024025936992*r**28
            +1225090252632*r**30+43142226991*r**32-20675578419*r**34-1083780064*r**36
            +53029248*r**38)-12*Q2**3*(33302346-193773925*r**2-16252930480*r**4-182112599775*r**6
            -652892345370*r**8+3428339651036*r**10-8576414569080*r**12+39022613396020*r**14
            -3826160821700*r**16+17079340441290*r**18+72329453284936*r**20+14073010196510*r**22
            -5202643069500*r**24+36833900117100*r**26-9218215305320*r**28+3578118134436*r**30
            -666113602630*r**32-177625525165*r**34-16694211000*r**36-270525975*r**38
            +35156246*r**40)-9*(-1+r**2)**2*(1931747-49472138*r**2-1192669910*r**4
            +11071277670*r**6+248335150715*r**8+2252270642552*r**10+6937105133912*r**12
            +788404049480*r**14+35719518403190*r**16+40308978972580*r**18-65188331245188*r**20
            -62709339742908*r**22+42049849874270*r**24+34278543928360*r**26-27060384680*r**28
            +6771120468232*r**30+2196568080007*r**32+247153749910*r**34+12241519530*r**36
            -1173450490*r**38-53393593*r**40+1976752*r**42)-3*Q2**2*(36267433-1655153692*r**2
            -13833414730*r**4+615381904800*r**6+6657228750805*r**8+38935513044988*r**10
            +159585855619528*r**12-49206871836800*r**14+427728005917810*r**16+320031051350120*r**18
            -156144070874652*r**20-146740479559872*r**22+316205342342290*r**24+400043736431480*r**26
            -58656419340280*r**28+157351788948608*r**30+37330694766053*r**32+6687510426740*r**34
            +647418485910*r**36-12590647520*r**38-1707265127*r**40+35036108*r**42)
            +36*Q2*(2728969-78169049*r**2-1379657821*r**4+20294866740*r**6+301430497905*r**8
            +2239115256229*r**10+6207612841711*r**12-6056594706656*r**14+32813842112530*r**16
            +9582676036310*r**18-21941782115626*r**20-2671166096664*r**22-20916791418806*r**24
            +10803491586970*r**26+31636448278790*r**28-6703386535936*r**30+6093583907141*r**32
            +2166559210739*r**34+299609568135*r**36+21897127620*r**38-1339818011*r**40
            -83470639*r**42+2769419*r**44))*sqrtq2)+logq2*(192*r**8*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7
            +2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(-571136*Q2**21+32*Q2**20*(256075+257521*r**2)-8*Q2**19*(5965489
            +13694493*r**2+6024812*r**4)+24*Q2**18*(6070287+22671111*r**2+22754261*r**4
            +6158721*r**6)-Q2**17*(233280527+1225234025*r**2+1501326773*r**4+1236380231*r**6
            +238558956*r**8)+Q2**16*(109498687+713848484*r**2-2951631810*r**4-2923102188*r**6
            +747440451*r**8+116882888*r**10)+Q2**15*(267989688+2549002378*r**2+25257192606*r**4
            +48557961694*r**6+25127460466*r**8+2483293560*r**10+264172056*r**12)
            -2*Q2**14*(241965682+3060062039*r**2+28863872726*r**4+84760185298*r**6
            +84651840346*r**8+28744799267*r**10+3023952574*r**12+244798356*r**14)
            +2*Q2**13*(67649018+2335517639*r**2+26906931239*r**4+130500570776*r**6
            +196873242992*r**8+130317623059*r**10+26933780059*r**12+2338384974*r**14
            +74201044*r**16)+2*Q2**12*(201193928+630513625*r**2+4931923782*r**4-51230637209*r**6
            -67119489364*r**8-67156402461*r**10-51618542042*r**12+4422945937*r**14
            +558725664*r**16+196100684*r**18)-2*Q2**11*(200348460+2225094911*r**2
            +36358195425*r**4+149300741531*r**6+617076046013*r**8+1049332909513*r**10
            +614983191407*r**12+147117970825*r**14+35525343363*r**16+2141370324*r**18
            +200638724*r**20)+Q2**10*(-71768164+2276914794*r**2+69780350212*r**4
            +569460154872*r**6+2756577054344*r**8+6540131919892*r**10+6530801196488*r**12
            +2740225568304*r**14+560369902332*r**16+69264991922*r**18+2295808020*r**20
            -63853400*r**22)+2*Q2**9*(152525607+254394294*r**2-11753576754*r**4-204801540729*r**6
            -1061682343618*r**8-3498377554212*r**10-5113228308964*r**12-3482085008866*r**14
            -1049909258109*r**16-200088138978*r**18-12602915898*r**20+152420139*r**22
            +149748456*r**24)-2*Q2**8*(51970493+558933599*r**2+6828082724*r**4-5919703117*r**6
            +252422728879*r**8+136414263394*r**10+132430567016*r**12+151124592486*r**14
            +155345753515*r**16+253084774979*r**18-5813349580*r**20+5645283239*r**22
            +484105769*r**24+52522044*r**26)+2*Q2**7*(-51247628+463513775*r**2+13522424133*r**4
            +100144980777*r**6+919348917487*r**8+2663322626266*r**10+6534844395414*r**12
            +9606231892642*r**14+6561339012450*r**16+2663646796115*r**18+905884473665*r**20
            +94411294389*r**22+13115361723*r**24+478581156*r**26-49318684*r**28)
            +2*Q2**6*(40890474-268312229*r**2-9443551410*r**4-80288095106*r**6-539054907138*r**8
            -1177492279407*r**10-4102064199094*r**12-7960248390440*r**14-7984701853002*r**16
            -4082456058691*r**18-1140549451470*r**20-534581376762*r**22-75101081630*r**24
            -9880661417*r**26-312280266*r**28+39956388*r**30)+2*Q2**5*(2706082-82986655*r**2
            -136910071*r**4+53879923912*r**6+307271212812*r**8+606534150427*r**10
            +2063401233691*r**12-236971998386*r**14+817778925246*r**16-279657262601*r**18
            +1920576156191*r**20+511215184732*r**22+320064726472*r**24+54846697357*r**26
            +416503229*r**28-71012210*r**30+2496972*r**32)-2*Q2**4*(12004844-221759467*r**2
            -4617721978*r**4+43047991223*r**6+341180512036*r**8+1823710610921*r**10
            +4442804949722*r**12-581215339857*r**14+1900039223384*r**16+1656589008763*r**18
            -858370311494*r**20+4239768369277*r**22+1714350963508*r**24+349326581243*r**26
            +46977245926*r**28-4415046371*r**30-231653532*r**32+11635852*r**34)+2*Q2**3*(2898656
            -74330497*r**2-2078046147*r**4+4799209955*r**6+64949476437*r**8+1058725062435*r**10
            +1079697660877*r**12+21001137247*r**14+1732499841033*r**16+5178301708901*r**18
            +1496997639667*r**20-214339395303*r**22+982703042287*r**24+1039762315089*r**26
            +60942561087*r**28+6364362917*r**30-2139807277*r**32-79994712*r**34+2801348*r**36)
            +3*(-1+r**2)**2*(72929-4007320*r**2-96810211*r**4+2677475768*r**6+22687094444*r**8
            +129876602968*r**10+464209173740*r**12-1699769527672*r**14+5748220541846*r**16
            -4387223148312*r**18-4147179742098*r**20+5749253743480*r**22-1771653076148*r**24
            +472506586504*r**26+122918989292*r**28+22457191576*r**30+2782414225*r**32
            -93399344*r**34-4166243*r**36+70576*r**38)+2*Q2**2*(1315526-41461325*r**2
            -568302966*r**4+26372970860*r**6+192893165080*r**8+500827977720*r**10
            +3466197640528*r**12-4340461749604*r**14+5106488293188*r**16+1567488498518*r**18
            +1580713398532*r**20+4680238119444*r**22-4463588250344*r**24+3511176765344*r**26
            +438412211424*r**28+196154501972*r**30+27089697478*r**32-475724961*r**34
            -42270142*r**36+1283728*r**38)-3*Q2*(509693-22033807*r**2-428918035*r**4
            +12994682221*r**6+90071896408*r**8+387089669116*r**10+1544778851596*r**12
            -5623703949620*r**14+13070269935742*r**16-3852984011034*r**18-8614274104626*r**20
            -3228313228146*r**22+12903550080020*r**24-5813624247172*r**26+1592430991244*r**28
            +355866672332*r**30+89531897357*r**32+13456078385*r**34-404126291*r**36
            -22820243*r**38+494860*r**40))-192*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(4569088*Q2**25-1536*Q2**24*(45282+45523*r**2)+32*Q2**23*(13598567
            +31019854*r**2+13727335*r**4)-8*Q2**22*(180061035+678920486*r**2+681383403*r**4
            +182558224*r**6)+8*Q2**21*(316139407+1772586094*r**2+2446378592*r**4
            +1787662434*r**6+322842337*r**8)-Q2**20*(1370556433+13329795344*r**2
            -5892728894*r**4-5577385244*r**6+13717358189*r**8+1450437196*r**10)-4*Q2**19*(826069828
            +5309763777*r**2+56050956025*r**4+110910647270*r**6+55684786890*r**8
            +5112474393*r**10+815985337*r**12)+2*Q2**18*(3388325227+36960926544*r**2
            +326906787645*r**4+979894902110*r**6+978657780885*r**8+325435418212*r**10
            +36510098499*r**12+3428203630*r**14)-4*Q2**17*(555657625+17734950472*r**2
            +195145830126*r**4+962894495418*r**6+1497440029450*r**8+961738092980*r**10
            +195083451102*r**12+17754370826*r**14+600040273*r**16)+Q2**16*(-6792001269
            -14662838648*r**2+22146336076*r**4+2771198819952*r**6+5832117040726*r**8
            +5833726566136*r**10+2781394786132*r**12+33691382896*r**14-12584991873*r**16
            -6669138144*r**18)+16*Q2**15*(476075102+5354454511*r**2+68126020274*r**4
            +221308940164*r**6+815447072531*r**8+1420767992922*r**10+811534297551*r**12
            +217268990964*r**14+66690674619*r**16+5181403071*r**18+479419859*r**20)
            +8*Q2**14*(203985231-6957765776*r**2-156528810075*r**4-1299830972370*r**6
            -5925089302260*r**8-14190704023726*r**10-14172160058384*r**12-5893311961600*r**14
            -1281950911595*r**16-155125459190*r**18-6958652709*r**20+183859814*r**22)
            -16*Q2**13*(460045186+1113693002*r**2-17983496535*r**4-578060628290*r**6
            -3388350975640*r**8-11931538311476*r**10-17789610396822*r**12-11897443529170*r**14
            -3363801093900*r**16-569016490890*r**18-19432868479*r**20+887425032*r**22
            +454606350*r**24)+2*Q2**12*(1229718215+21983267696*r**2+313290950578*r**4
            +90398332884*r**6-2325703892795*r**8-47594810425340*r**10-109714640093636*r**12
            -109422275491808*r**14-47288635896919*r**16-2324672832640*r**18+70091311970*r**20
            +292704736876*r**22+20450292603*r**24+1258542764*r**26)+8*Q2**11*(455641112
            -3211906871*r**2-87691981393*r**4-899003116486*r**6-6135210139548*r**8
            -17313739156337*r**10-42511754136749*r**12-64203860603052*r**14-42552750342624*r**16
            -17234514749417*r**18-6045419670683*r**20-862791932926*r**22-85579377388*r**24
            -3329402111*r**26+443207657*r**28)+4*Q2**10*(-699787607+285712584*r**2
            +54060966271*r**4+1327183574066*r**6+11685508171069*r**8+66330110933696*r**10
            +244166288516611*r**12+508299467121454*r**14+508046501285699*r**16+243236108218136*r**18
            +65508259689925*r**20+11529275596414*r**22+1263708658391*r**24+59188964256*r**26
            +959594169*r**28-693000734*r**30)-8*Q2**9*(98953519-2005924944*r**2-28941342000*r**4
            +111105343730*r**6+2113923042220*r**8+24852843642036*r**10+114654120666304*r**12
            +313053128696250*r**14+445738284805270*r**16+312031925778600*r**18+113343210010816*r**20
            +24150638062774*r**22+2154977468900*r**24+123746457780*r**26-25372277840*r**28
            -1915450146*r**30+94297771*r**32)+2*Q2**8*(710869007-7883679256*r**2
            -148372186560*r**4-127508589720*r**6+1627233191680*r**8+30064474896888*r**10
            +46176125790776*r**12+170140948886000*r**14+407361882882710*r**16+401089159135920*r**18
            +161391361060528*r**20+41549846295496*r**22+28313041694840*r**24+1978521257720*r**26
            +26776651480*r**28-144550541088*r**30-8415578141*r**32+695782520*r**34)
            -16*Q2**7*(7151140-10998527*r**2-4375187006*r**4-48220285728*r**6-346349703405*r**8
            -2867116082500*r**10-34307047763533*r**12-107193438932584*r**14-245335756456257*r**16
            -333726452169290*r**18-246820098796045*r**20-108086650389328*r**22-34236181060359*r**24
            -2639979196452*r**26-329836587335*r**28-40382825000*r**30-5027766767*r**32
            -53284431*r**34+7287007*r**36)-16*Q2**6*(25632149-533573867*r**2-5953801726*r**4
            +112446336373*r**6+862775230159*r**8+5071493969221*r**10+26412887731047*r**12
            +46543064647446*r**14+191642056981077*r**16+336341351622361*r**18+337367697772311*r**20
            +191289984049102*r**22+45958536654341*r**24+26331676414427*r**26+4652393920901*r**28
            +863111597694*r**30+119051338818*r**32-5363894286*r**34-544137477*r**36
            +24933929*r**38)+8*Q2**5*(15877969-442589978*r**2-8258898862*r**4+118000852578*r**6
            +1024986410327*r**8+8967014702280*r**10+25603959328208*r**12-1140144167668*r**14
            +164903301380662*r**16+15347993959148*r**18+1547952536076*r**20+16060921094968*r**22
            +155146698859602*r**24-7921713829448*r**26+26252760282288*r**28+8839674481252*r**30
            +1034136482377*r**32+130845288878*r**34-8196741342*r**36-471836938*r**38
            +15487623*r**40)+Q2**4*(60600643-1735707408*r**2-4268140050*r**4+637594180380*r**6
            +853502815275*r**8-48849346714332*r**10-251745582722648*r**12-1215039137160000*r**14
            -2790451190885130*r**16+63263234329760*r**18-593290392907212*r**20-470317985892648*r**22
            +213957585701950*r**24-2666320677205080*r**26-1142345362058520*r**28-249591805305952*r**30
            -52526347569753*r**32+638352435600*r**34+633007402830*r**36-1317229140*r**38
            -1727181897*r**40+58893332*r**42)-12*Q2**3*(2871428-117095469*r**2-1294461025*r**4
            +55014470410*r**6+166769012010*r**8-619786397057*r**10-9910287663329*r**12
            -87614052963960*r**14-33853751335040*r**16-28419500667210*r**18-132282619960482*r**20
            -321645997213524*r**22-116930254576420*r**24-11704236812250*r**26-27663474633610*r**28
            -86378995491352*r**30-9229734907764*r**32-769004634505*r**34+153390854755*r**36
            +56965614810*r**38-1192704662*r**40-120570789*r**42+2785035*r**44)-9*(
            -1+r**2)**2*(72929-5028326*r**2-47563057*r**4+4408485796*r**6-5641231065*r**8
            -438074105806*r**10-3524231616511*r**12-20722040485472*r**14-15886253749414*r**16
            +68546973037620*r**18-458797804038106*r**20+394033888960664*r**22+374743034890558*r**24
            -461480908993484*r**26+75406483785330*r**28-15561630980336*r**30-20252748548491*r**32
            -3398382470222*r**34-451725205349*r**36-7658671260*r**38+4480643819*r**40
            -41706086*r**42-5154307*r**44+70576*r**46)-6*Q2**2*(295735-3808992*r**2
            +482846129*r**4+1165668742*r**6-107211905235*r**8-3848142486100*r**10
            -17278780422117*r**12-53776808390946*r**14-391191830157978*r**16+496282840759600*r**18
            -350238707461590*r**20-422977520167252*r**22-410087995854566*r**24-298612652725848*r**26
            +506158085312630*r**28-396003992873460*r**30-47772347557677*r**32-17354552725296*r**34
            -3957789989963*r**36-112230296370*r**38+28206665*r**40+526139788*r**42
            -2700321*r**44+294422*r**46)+36*Q2*(109191-6053528*r**2-31128994*r**4
            +4293695262*r**6-9473881854*r**8-488849680164*r**10-2901257987658*r**12
            -14736605055954*r**14-23354567315223*r**16+104039529270816*r**18-299641132116004*r**20
            +48097191519292*r**22+297551292549276*r**24+32058491367272*r**26-296151520213124*r**28
            +109179305908236*r**30-23980878679623*r**32-14148281623464*r**34-2793283754298*r**36
            -505028555034*r**38-11414863134*r**40+4326140892*r**42-23192114*r**44
            -6166138*r**46+106071*r**48))*sqrtq2))*math.log(r))/(126000*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2
            +126000*(-Q2+(-1+r)**2)**3*r**4*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2
            +logq2**7*(-1015831756800000*r**32*(1+r**2)**2*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3-1015831756800000*r**32*(1+r**2)**2*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2**6*(5643509760000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))+5643509760000*r**28*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(81+16*Q2**4-534*r**2
            -1614*r**4-534*r**6+81*r**8+61*Q2**3*(1+r**2)-Q2**2*(89+146*r**2+89*r**4)
            -3*Q2*(23+47*r**2+47*r**4+23*r**6))*sqrtq2)+logq2*(-7560000*(-Q2+(
            -1+r)**2)**3*r**8*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(9+8*Q2**4-78*r**2-366*r**4-78*r**6+9*r**8-Q2**3*(1+r**2)
            -Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1+13*r**2+13*r**4+r**6))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-7560000*(-Q2+(-1+r)**2)**3*r**8*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(9+8*Q2**4-78*r**2-366*r**4
            -78*r**6+9*r**8-Q2**3*(1+r**2)-Q2**2*(13+10*r**2+13*r**4)-3*Q2*(1
            +13*r**2+13*r**4+r**6))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*sqrtq2)+logq2**2*(90720000*(-Q2+(-1+r)**2)**3*r**12*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531
            +550*r**2+531*r**4)-2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815
            -2120*r**2-11502*r**4-2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4
            +494*r**6+225*r**8+r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6
            +26793*r**8+4554*r**10-501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6
            -1385*r**8-311*r**10+15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6
            +34670*r**8+13388*r**10-184*r**12-316*r**14+17*r**16))+90720000*(-Q2
            +(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(128*Q2**8+16*Q2**7*(1+r**2)-Q2**6*(531+550*r**2+531*r**4)
            -2*Q2**5*(19+473*r**2+473*r**4+19*r**6)+Q2**4*(815-2120*r**2-11502*r**4
            -2120*r**6+815*r**8)+12*Q2**3*(1+225*r**2+494*r**4+494*r**6+225*r**8
            +r**10)+Q2**2*(-501+4554*r**2+26793*r**4+31188*r**6+26793*r**8+4554*r**10
            -501*r**12)-54*Q2*(1+15*r**2-311*r**4-1385*r**6-1385*r**8-311*r**10
            +15*r**12+r**14)+9*(17-316*r**2-184*r**4+13388*r**6+34670*r**8+13388*r**10
            -184*r**12-316*r**14+17*r**16))*sqrtq2)+logq2**3*(-1088640000*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8+256*Q2**7*(1+r**2)
            -Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2+893*r**4+319*r**6)
            +Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)+12*Q2**3*(61
            +235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(-1071+9654*r**2
            +51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)-18*Q2*(23
            -35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12+23*r**14)
            +9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10-264*r**12
            -756*r**14+47*r**16))-1088640000*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(128*Q2**8
            +256*Q2**7*(1+r**2)-Q2**6*(801+1090*r**2+801*r**4)-2*Q2**5*(319+893*r**2
            +893*r**4+319*r**6)+Q2**4*(1385-3680*r**2-15762*r**4-3680*r**6+1385*r**8)
            +12*Q2**3*(61+235*r**2-176*r**4-176*r**6+235*r**8+61*r**10)+Q2**2*(
            -1071+9654*r**2+51483*r**4+69228*r**6+51483*r**8+9654*r**10-1071*r**12)
            -18*Q2*(23-35*r**2-2053*r**4-6335*r**6-6335*r**8-2053*r**10-35*r**12
            +23*r**14)+9*(47-756*r**2-264*r**4+23908*r**6+54930*r**8+23908*r**10
            -264*r**12-756*r**14+47*r**16))*sqrtq2)+logq2**4*(13063680000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513+770*r**2
            +513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105-3400*r**2
            -11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4-1178*r**6
            +75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6+19593*r**8
            +3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6-5785*r**8
            -2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4+25204*r**6
            +52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))+13063680000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(64*Q2**8+368*Q2**7*(1+r**2)-Q2**6*(513
            +770*r**2+513*r**4)-2*Q2**5*(617+1339*r**2+1339*r**4+617*r**6)+Q2**4*(1105
            -3400*r**2-11826*r**4-3400*r**6+1105*r**8)+12*Q2**3*(143+75*r**2-1178*r**4
            -1178*r**6+75*r**8+143*r**10)+3*Q2**2*(-421+3834*r**2+19593*r**4+28628*r**6
            +19593*r**8+3834*r**10-421*r**12)-18*Q2*(49-185*r**2-2479*r**4-5785*r**6
            -5785*r**8-2479*r**10-185*r**12+49*r**14)+9*(71-1028*r**2-72*r**4
            +25204*r**6+52450*r**8+25204*r**10-72*r**12-1028*r**14+71*r**16))*sqrtq2)
            +logq2**5*(-31352832000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(64*Q2**8+1088*Q2**7*(1+r**2)+Q2**6*(-63+130*r**2-63*r**4)
            -2*Q2**5*(2777+6379*r**2+6379*r**4+2777*r**6)+Q2**4*(1555-8080*r**2
            -22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743-315*r**2-6548*r**4-6548*r**6
            -315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2+199629*r**4+305844*r**6
            +199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83-375*r**2-2833*r**4
            -5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)+9*(301-4028*r**2
            +808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12-4028*r**14+301*r**16))
            -31352832000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(64*Q2**8+1088*Q2**7*(1
            +r**2)+Q2**6*(-63+130*r**2-63*r**4)-2*Q2**5*(2777+6379*r**2+6379*r**4
            +2777*r**6)+Q2**4*(1555-8080*r**2-22086*r**4-8080*r**6+1555*r**8)+12*Q2**3*(743
            -315*r**2-6548*r**4-6548*r**6-315*r**8+743*r**10)+Q2**2*(-4233+39402*r**2
            +199629*r**4+305844*r**6+199629*r**8+39402*r**10-4233*r**12)-54*Q2*(83
            -375*r**2-2833*r**4-5275*r**6-5275*r**8-2833*r**10-375*r**12+83*r**14)
            +9*(301-4028*r**2+808*r**4+78604*r**6+151030*r**8+78604*r**10+808*r**12
            -4028*r**14+301*r**16))*sqrtq2)))+((145152000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -38-29*r**2+19*r**6)*(-Q2+(1+r)**2)+11520*logq2**2*r**10*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(-7879+5120*Q2**9-87678*r**2-1053462*r**4
            -634926*r**6-2518500*r**8-240126*r**10-109002*r**12+933582*r**14+79371*r**16
            +9820*r**18-2*Q2**8*(20272+17415*r**2)+8*Q2**7*(12884+25749*r**2+10305*r**4)
            -Q2**6*(80507+405405*r**2+353837*r**4+64575*r**6)+Q2**5*(-70826+265853*r**2
            +400483*r**4+189179*r**6+7455*r**8)+Q2**4*(151375+281470*r**2+941126*r**4
            +638170*r**6+65095*r**8-34020*r**10)+2*Q2**3*(-27118-288225*r**2-1298122*r**4
            -1742567*r**6-748125*r**8-40208*r**10+22365*r**12)+Q2**2*(-43277+192283*r**2
            +816061*r**4+2877491*r**6+1836221*r**8+63893*r**10-121557*r**12+23685*r**14)
            +Q2*(37702+158765*r**2+1377033*r**4-1139165*r**6-1466725*r**8+1443*r**10
            -195545*r**12+56717*r**14-39825*r**16))+8*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(479+3996*Q2**14-80178*r**2-5676403*r**4-71498636*r**6-45389657*r**8
            -1456348118*r**10+2781783741*r**12-3623258664*r**14+1517597397*r**16
            -47392766*r**18+72430239*r**20+6783412*r**22+138917*r**24-1786*r**26
            +23*r**28-3976*Q2**13*(1+r**2)+Q2**12*(23253+78474*r**2-36423*r**4)
            +2*Q2**11*(-79371-741497*r**2-162901*r**4+41145*r**6)+4*Q2**10*(66391
            +1313668*r**2+1217173*r**4+77646*r**6-7658*r**8)-2*Q2**9*(21921+2920315*r**2
            +9036220*r**4+3093220*r**6-55965*r**8+16161*r**10)+Q2**8*(-197683-4276678*r**2
            +19602875*r**4+10181700*r**6+6199915*r**8+468162*r**10-34003*r**12)
            +4*Q2**7*(12281+3807223*r**2+7906579*r**4+32189785*r**6+11377365*r**8
            -1707269*r**10-355297*r**12+19829*r**14)+4*Q2**6*(29351-2036048*r**2
            -21582324*r**4-95027160*r**6-88987060*r**8-12961824*r**10+848652*r**12
            +68096*r**14+1085*r**16)-4*Q2**5*(6067+1931161*r**2-10393484*r**4-55609088*r**6
            -186900976*r**8-62943748*r**10+8196796*r**12-775504*r**14-273363*r**16
            +12379*r**18)+Q2**4*(-48129+8934830*r**2+53142415*r**4+346647240*r**6
            -597707450*r**8-191096492*r**10-100227650*r**12+33755240*r**14-6973685*r**16
            -395730*r**18+8451*r**20)+2*Q2**3*(6217-253573*r**2-31204425*r**4-238619075*r**6
            -168172610*r**8-766715654*r**10-373737854*r**12+35730710*r**14+14210425*r**16
            +1932555*r**18-158393*r**20+5677*r**22)-4*Q2**2*(-1787+560004*r**2-626683*r**4
            -8594090*r**6-193891400*r**8-305027136*r**10-171392098*r**12+27508156*r**14
            -5541495*r**16+4286140*r**18-442787*r**20-21266*r**22+442*r**24)-2*Q2*(1381
            -401793*r**2-9764124*r**4-85367100*r**6+183042405*r**8-785675337*r**10
            +859966136*r**12+407836408*r**14-335635065*r**16+50429845*r**18+4947556*r**20
            +945732*r**22-22609*r**24+565*r**26))+691200*logq2**3*r**14*(160*Q2**8
            -10*Q2**7*(212+163*r**2)+2*Q2**6*(5684+7939*r**2+3087*r**4)-Q2**5*(26873
            +55466*r**2+41137*r**4+11564*r**6)+Q2**4*(27055+72774*r**2+81584*r**4
            +44802*r**6+10185*r**8)-2*Q2**3*(805+15588*r**2+22716*r**4+18012*r**6
            +7419*r**8+2660*r**10)+(-1+r**2)**2*(-3557-7134*r**2-32215*r**4-14120*r**6
            +10065*r**8+3142*r**10+3499*r**12)+2*Q2**2*(-9625-1868*r**2-9937*r**4
            -1926*r**6+8515*r**8+4306*r**10+3815*r**12)+Q2*(14827+3376*r**2+82189*r**4
            +106850*r**6+4405*r**8-33892*r**10-7341*r**12-9134*r**14))*sqrtq2+192*logq2*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-207+13408*Q2**12-79436*r**2-2918122*r**4
            -11164160*r**6-94400645*r**8+44076984*r**10-82613068*r**12-94146656*r**14
            +85506135*r**16+7209620*r**18+3270198*r**20+107104*r**22+253*r**24-2*Q2**11*(36748
            +36653*r**2)+2*Q2**10*(68044+189497*r**2+64429*r**4)-5*Q2**9*(8347+139994*r**2
            +121067*r**4+24960*r**6)+5*Q2**8*(-35523-23058*r**2-367772*r**4-20278*r**6
            +43959*r**8)+2*Q2**7*(103182+1101345*r**2+6986390*r**4+6755450*r**6
            +678760*r**8-156363*r**10)+2*Q2**6*(4046-1213149*r**2-11162995*r**4
            -23153140*r**6-9345350*r**8-278859*r**10+20111*r**12)+2*Q2**5*(-67653
            -245679*r**2+1168807*r**4+27972165*r**6+23403095*r**8+2927107*r**10
            -632149*r**12+133107*r**14)-10*Q2**4*(-6231-228987*r**2-2627851*r**4
            +68503*r**6-274537*r**8-35441*r**10+275003*r**12-3851*r**14+15600*r**16)
            -20*Q2**3*(-897+47208*r**2+1099417*r**4+3289212*r**6+8344671*r**8+8024462*r**10
            +1464631*r**12-311908*r**14-65982*r**16+1986*r**18)+4*Q2**2*(-5143-112760*r**2
            -694795*r**4+11398055*r**6+24649385*r**8+42550031*r**10+8859965*r**12
            -3785575*r**14+307550*r**16-17655*r**18+10942*r**20)+Q2*(4729+409304*r**2
            +9738065*r**4+1950450*r**6+94978350*r**8-103830768*r**10-78550338*r**12
            -13931940*r**14+23451225*r**16-6260200*r**18-528911*r**20-5966*r**22))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(2612736000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+181440000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+630000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-15120000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            -10500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
            -1088640000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC**2*(72576000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(95+116*r**2+87*r**4+38*r**6)*(-Q2+(1+r)**2)
            -5760*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-2056-3040*Q2**9
            -112599*r**2-1413102*r**4-2866710*r**6-10794378*r**8-8516004*r**10-2340786*r**12
            +573942*r**14+54450*r**16+15643*r**18+Q2**8*(24134+29848*r**2)-8*Q2**7*(11349
            +24557*r**2+13928*r**4)+Q2**6*(123487+447549*r**2+499117*r**4+139419*r**6)
            +Q2**5*(-22939-325851*r**2-704939*r**4-402525*r**6+55342*r**8)+Q2**4*(
            -60480+203085*r**2+1104694*r**4+801738*r**6-13290*r**8-245875*r**10)
            +2*Q2**3*(13223-94404*r**2-515143*r**4-688049*r**6+34854*r**8+153613*r**10
            +62706*r**12)+Q2**2*(947-81979*r**2-238757*r**4+533547*r**6-507723*r**8
            -990925*r**10-395819*r**12+67909*r**14)+Q2*(4293+225211*r**2+777497*r**4
            -2886891*r**6-4095875*r**8-1746283*r**10-795081*r**12+123163*r**14-73234*r**16))
            -4*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(69-6208*Q2**15-3442*r**2
            +96039*r**4-2355376*r**6-68703827*r**8-323736926*r**10-1272600281*r**12
            +257358972*r**14-6147683433*r**16+1701345234*r**18-325740035*r**20+75225048*r**22
            +10104439*r**24+315134*r**26-5707*r**28+92*r**30+12*Q2**14*(1439+1772*r**2)
            -8*Q2**13*(275+7255*r**2+772*r**4)+Q2**12*(-3653+5858*r**2+61079*r**4
            -40076*r**6)+Q2**11*(-86826+510250*r**2+3259746*r**4+343190*r**6-4536*r**8)
            +4*Q2**10*(33910-309598*r**2-3555649*r**4-3652144*r**6-298343*r**8+26252*r**10)
            +2*Q2**9*(6397+195891*r**2+8954760*r**4+25036060*r**6+8781855*r**8+273777*r**10
            -9764*r**12)-Q2**8*(112345-1306330*r**2+1503863*r**4+65155240*r**6+74576415*r**8
            -8972730*r**10-1972175*r**12+146348*r**14)+4*Q2**7*(-241-115199*r**2
            -3228307*r**4+510603*r**6-9490225*r**8+3981389*r**10-8742799*r**12-482777*r**14
            +19588*r**16)+4*Q2**6*(18183-311620*r**2+2481252*r**4+23544720*r**6
            +104354388*r**8+110394488*r**10+32165220*r**12+5365952*r**14-272875*r**16
            +19268*r**18)-4*Q2**5*(1969-119821*r**2-104908*r**4+16081412*r**6+78450324*r**8
            +225195824*r**10+71115664*r**12+34671692*r**14-2811573*r**16-399251*r**18
            +14348*r**20)-Q2**4*(27687-614454*r**2+6120695*r**4+17954620*r**6+66047430*r**8
            -706225204*r**10-1112836162*r**12+512922320*r**14+37341795*r**16+22029210*r**18
            -266853*r**20+19236*r**22)+2*Q2**3*(3335-135495*r**2+1342157*r**4+6137095*r**6
            -16278090*r**8-228421890*r**10-266480810*r**12-433987134*r**14+258071695*r**16
            +51551945*r**18+3528285*r**20-300105*r**22+9012*r**24)+4*Q2**2*(998
            -26178*r**2+331081*r**4-1034584*r**6+8364545*r**8+4076104*r**10-12162874*r**12
            -145797912*r**14-217323452*r**16+5311950*r**18-5947407*r**20+1333872*r**22
            -6699*r**24+556*r**26)-2*Q2*(703-26815*r**2+456552*r**4-4833540*r**6
            -32738257*r**8-23555191*r**10+302312100*r**12+722229896*r**14+1495823845*r**16
            -542232661*r**18+103058688*r**20+9878140*r**22+1804077*r**24-50805*r**26
            +1268*r**28))-2419200*logq2**3*r**14*(-70*Q2**7+Q2**6*(742+678*r**2)+Q2**5*(
            -1712-3445*r**2-1398*r**4+475*r**6)+Q2**4*(985+3346*r**2+3104*r**4
            -650*r**6-1425*r**8)+2*Q2**3*(740-867*r**2-1620*r**4-948*r**6+300*r**8
            +475*r**10)+(-1+r**2)**2*(-533-2730*r**2-14095*r**4-14120*r**6-8055*r**8
            -1262*r**10+475*r**12)+2*Q2**2*(-1445-302*r**2-3169*r**4-2326*r**6
            -533*r**8+580*r**10+475*r**12)+Q2*(1998+3423*r**2+33880*r**4+59425*r**6
            +44790*r**8+17297*r**10+1892*r**12-1425*r**14))*sqrtq2+96*logq2*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(69+24704*Q2**12-3568*r**2+1861894*r**4
            +23027780*r**6+121084175*r**8+106132032*r**10+578291476*r**12+244355672*r**14
            -58822605*r**16+4654000*r**18-4326426*r**20-190108*r**22-391*r**24-2*Q2**11*(91329
            +91424*r**2)+2*Q2**10*(203857+524641*r**2+207472*r**4)-5*Q2**9*(49724
            +393743*r**2+412670*r**4+33111*r**6)-5*Q2**8*(43617-258250*r**2-451604*r**4
            -255470*r**6+123099*r**8)+2*Q2**7*(116421+679440*r**2+4904690*r**4+5135630*r**6
            +1102025*r**8+375966*r**10)+Q2**6*(98126-3248294*r**2-25776540*r**4
            -54534280*r**6-29411830*r**8-5116874*r**10+65996*r**12)+2*Q2**5*(-56529
            +588343*r**2+6020831*r**4+30088115*r**6+34657185*r**8+4262531*r**10
            +974813*r**12-257289*r**14)+10*Q2**4*(-3528+146739*r**2+535525*r**4
            -3364087*r**6-10384039*r**8-3468031*r**10+3438379*r**12+371875*r**14
            +18303*r**16)+20*Q2**3*(1728-44860*r**2-4776*r**4+1510197*r**6+3814922*r**8
            +3494713*r**10-314384*r**12-1416101*r**14-158050*r**16+4611*r**18)-4*Q2**2*(
            -576+33495*r**2-195280*r**4-2905*r**6+4535*r**8-4595023*r**10-15784885*r**12
            -15186535*r**14+807065*r**16+128600*r**18+15509*r**20)+Q2*(-2618+91117*r**2
            -4586860*r**4-16019475*r**6-2530380*r**8+237526086*r**10+212245656*r**12
            +106379910*r**14-37520250*r**16+11411405*r**18+1029332*r**20+8077*r**22))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(2612736000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+181440000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+630000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-15120000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            -10500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
            -1088640000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC*(580608000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(95+116*r**2+87*r**4+38*r**6)*(-Q2+(1+r)**2)
            -46080*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-2056-3040*Q2**9
            -112599*r**2-1413102*r**4-2866710*r**6-10794378*r**8-8516004*r**10-2340786*r**12
            +573942*r**14+54450*r**16+15643*r**18+Q2**8*(24134+29848*r**2)-8*Q2**7*(11349
            +24557*r**2+13928*r**4)+Q2**6*(123487+447549*r**2+499117*r**4+139419*r**6)
            +Q2**5*(-22939-325851*r**2-704939*r**4-402525*r**6+55342*r**8)+Q2**4*(
            -60480+203085*r**2+1104694*r**4+801738*r**6-13290*r**8-245875*r**10)
            +2*Q2**3*(13223-94404*r**2-515143*r**4-688049*r**6+34854*r**8+153613*r**10
            +62706*r**12)+Q2**2*(947-81979*r**2-238757*r**4+533547*r**6-507723*r**8
            -990925*r**10-395819*r**12+67909*r**14)+Q2*(4293+225211*r**2+777497*r**4
            -2886891*r**6-4095875*r**8-1746283*r**10-795081*r**12+123163*r**14-73234*r**16))
            -32*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(69-6208*Q2**15-3442*r**2
            +96039*r**4-2355376*r**6-68703827*r**8-323736926*r**10-1272600281*r**12
            +257358972*r**14-6147683433*r**16+1701345234*r**18-325740035*r**20+75225048*r**22
            +10104439*r**24+315134*r**26-5707*r**28+92*r**30+12*Q2**14*(1439+1772*r**2)
            -8*Q2**13*(275+7255*r**2+772*r**4)+Q2**12*(-3653+5858*r**2+61079*r**4
            -40076*r**6)+Q2**11*(-86826+510250*r**2+3259746*r**4+343190*r**6-4536*r**8)
            +4*Q2**10*(33910-309598*r**2-3555649*r**4-3652144*r**6-298343*r**8+26252*r**10)
            +2*Q2**9*(6397+195891*r**2+8954760*r**4+25036060*r**6+8781855*r**8+273777*r**10
            -9764*r**12)-Q2**8*(112345-1306330*r**2+1503863*r**4+65155240*r**6+74576415*r**8
            -8972730*r**10-1972175*r**12+146348*r**14)+4*Q2**7*(-241-115199*r**2
            -3228307*r**4+510603*r**6-9490225*r**8+3981389*r**10-8742799*r**12-482777*r**14
            +19588*r**16)+4*Q2**6*(18183-311620*r**2+2481252*r**4+23544720*r**6
            +104354388*r**8+110394488*r**10+32165220*r**12+5365952*r**14-272875*r**16
            +19268*r**18)-4*Q2**5*(1969-119821*r**2-104908*r**4+16081412*r**6+78450324*r**8
            +225195824*r**10+71115664*r**12+34671692*r**14-2811573*r**16-399251*r**18
            +14348*r**20)-Q2**4*(27687-614454*r**2+6120695*r**4+17954620*r**6+66047430*r**8
            -706225204*r**10-1112836162*r**12+512922320*r**14+37341795*r**16+22029210*r**18
            -266853*r**20+19236*r**22)+2*Q2**3*(3335-135495*r**2+1342157*r**4+6137095*r**6
            -16278090*r**8-228421890*r**10-266480810*r**12-433987134*r**14+258071695*r**16
            +51551945*r**18+3528285*r**20-300105*r**22+9012*r**24)+4*Q2**2*(998
            -26178*r**2+331081*r**4-1034584*r**6+8364545*r**8+4076104*r**10-12162874*r**12
            -145797912*r**14-217323452*r**16+5311950*r**18-5947407*r**20+1333872*r**22
            -6699*r**24+556*r**26)-2*Q2*(703-26815*r**2+456552*r**4-4833540*r**6
            -32738257*r**8-23555191*r**10+302312100*r**12+722229896*r**14+1495823845*r**16
            -542232661*r**18+103058688*r**20+9878140*r**22+1804077*r**24-50805*r**26
            +1268*r**28))-19353600*logq2**3*r**14*(-70*Q2**7+Q2**6*(742+678*r**2)+Q2**5*(
            -1712-3445*r**2-1398*r**4+475*r**6)+Q2**4*(985+3346*r**2+3104*r**4
            -650*r**6-1425*r**8)+2*Q2**3*(740-867*r**2-1620*r**4-948*r**6+300*r**8
            +475*r**10)+(-1+r**2)**2*(-533-2730*r**2-14095*r**4-14120*r**6-8055*r**8
            -1262*r**10+475*r**12)+2*Q2**2*(-1445-302*r**2-3169*r**4-2326*r**6
            -533*r**8+580*r**10+475*r**12)+Q2*(1998+3423*r**2+33880*r**4+59425*r**6
            +44790*r**8+17297*r**10+1892*r**12-1425*r**14))*sqrtq2+768*logq2*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(69+24704*Q2**12-3568*r**2+1861894*r**4
            +23027780*r**6+121084175*r**8+106132032*r**10+578291476*r**12+244355672*r**14
            -58822605*r**16+4654000*r**18-4326426*r**20-190108*r**22-391*r**24-2*Q2**11*(91329
            +91424*r**2)+2*Q2**10*(203857+524641*r**2+207472*r**4)-5*Q2**9*(49724
            +393743*r**2+412670*r**4+33111*r**6)-5*Q2**8*(43617-258250*r**2-451604*r**4
            -255470*r**6+123099*r**8)+2*Q2**7*(116421+679440*r**2+4904690*r**4+5135630*r**6
            +1102025*r**8+375966*r**10)+Q2**6*(98126-3248294*r**2-25776540*r**4
            -54534280*r**6-29411830*r**8-5116874*r**10+65996*r**12)+2*Q2**5*(-56529
            +588343*r**2+6020831*r**4+30088115*r**6+34657185*r**8+4262531*r**10
            +974813*r**12-257289*r**14)+10*Q2**4*(-3528+146739*r**2+535525*r**4
            -3364087*r**6-10384039*r**8-3468031*r**10+3438379*r**12+371875*r**14
            +18303*r**16)+20*Q2**3*(1728-44860*r**2-4776*r**4+1510197*r**6+3814922*r**8
            +3494713*r**10-314384*r**12-1416101*r**14-158050*r**16+4611*r**18)-4*Q2**2*(
            -576+33495*r**2-195280*r**4-2905*r**6+4535*r**8-4595023*r**10-15784885*r**12
            -15186535*r**14+807065*r**16+128600*r**18+15509*r**20)+Q2*(-2618+91117*r**2
            -4586860*r**4-16019475*r**6-2530380*r**8+237526086*r**10+212245656*r**12
            +106379910*r**14-37520250*r**16+11411405*r**18+1029332*r**20+8077*r**22))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(7838208000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+544320000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+1890000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-45360000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            -31500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
            -3265920000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(flagPERP*muWC**3*(
            -86400*logq2**3*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(-360*Q2**6*r**2
            +10*Q2**5*(56+237*r**2+405*r**4)-2*Q2**4*(2576+3407*r**2+10086*r**4
            +8559*r**6)+Q2**3*(5138+32029*r**2+55679*r**4+73515*r**6+34647*r**8)
            -2*Q2**2*(-1379+14446*r**2+30670*r**4+50580*r**6+43557*r**8+5934*r**10)
            +Q2*(-3122+10343*r**2-34011*r**4-39374*r**6+10956*r**8+8871*r**10
            -29823*r**12)+2*(-91+282*r**2+28681*r**4-101848*r**6-99713*r**8-57342*r**10
            -8685*r**12+10236*r**14))-24*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(
            -122808*Q2**12*r**2+14*Q2**11*(-1880+66429*r**2+60789*r**4)-2*Q2**10*(
            -52640+1036399*r**2+2717462*r**4+931119*r**6)+5*Q2**9*(-20090+184997*r**2
            +2184863*r**4+2210563*r**6+142947*r**8)+10*Q2**8*(-12285+188958*r**2
            -439302*r**4-936244*r**6-639789*r**8+270774*r**10)-4*Q2**7*(-68250+214896*r**2
            +3408825*r**4+19474085*r**6+16503395*r**8+3229605*r**10+821016*r**12)
            -4*Q2**6*(16590+656523*r**2-3938937*r**4-48083585*r**6-95232460*r**8
            -41391365*r**10-6366717*r**12+66423*r**14)+2*Q2**5*(-84630+820743*r**2
            +2675019*r**4-37336017*r**6-260265345*r**8-268793145*r**10-25507697*r**12
            -3283581*r**14+1117053*r**16)-20*Q2**4*(-5985-81312*r**2+472977*r**4
            +6023430*r**6-3751077*r**8-29989724*r**10-11659661*r**12+8984182*r**14
            +961842*r**16+41328*r**18)-10*Q2**3*(-1260+152523*r**2+685473*r**4-7421658*r**6
            -28403958*r**8-36666196*r**10-3852300*r**12-20030230*r**14-15885134*r**16
            -1401159*r**18+38619*r**20)+2*Q2**2*(-17500-65379*r**2+2675700*r**4
            +8946965*r**6-99187440*r**8-457949610*r**10-634743232*r**12-253335450*r**14
            -196325940*r**16+6690765*r**18+1501260*r**20+139461*r**22)-Q2*(-10430
            -428561*r**2-3675031*r**4+23936125*r**6+81525565*r**8+182986690*r**10
            +176301262*r**12-107945498*r**14+562295200*r**16-160505265*r**18+63205065*r**20
            +4801949*r**22+40929*r**24)+2*(-385-51794*r**2-1065032*r**4+974056*r**6
            -25793945*r**8-153620310*r**10+410527248*r**12-810987536*r**14-482355147*r**16
            +225241570*r**18+2827320*r**20+11328296*r**22+446693*r**24+966*r**26))
            +18144000*logq2**4*r**14*(-108+205*r**2+243*r**4+147*r**6+57*r**8)*sqrtq2
            -1440*logq2**2*r**6*(-22920*Q2**11*r**2+Q2**10*(2464+241602*r**2+248994*r**4)
            -20*Q2**9*(-392+54733*r**2+107146*r**4+53949*r**6)+10*Q2**8*(-7161+231247*r**2
            +728637*r**4+724587*r**6+220662*r**8)-5*Q2**7*(-25032+413045*r**2+2160632*r**4
            +3487006*r**6+2235312*r**8+338157*r**10)-5*Q2**6*(1008+42133*r**2-1047133*r**4
            -3132004*r**6-3299180*r**8-1349649*r**10+258489*r**12)+Q2**5*(-196728
            +1810291*r**2+3976932*r**4+5029485*r**6+4065040*r**8+2633037*r**10+2270436*r**12
            +3484467*r**14)-5*Q2**4*(-37212+200873*r**2+1228511*r**4+5057133*r**6
            +10219499*r**8+9808031*r**10+4391209*r**12+1337931*r**14+419049*r**16)
            -5*Q2**3*(168+69319*r**2-506056*r**4-4246772*r**6-8156648*r**8-13279886*r**10
            -9961912*r**12-2498660*r**14-1102656*r**16+94239*r**18)+(-1+r**2)**2*(
            -8386-11465*r**2-62195*r**4-2717840*r**6+6917980*r**8-22099358*r**10
            -21383090*r**12-6768560*r**14+4537510*r**16+392615*r**18+76389*r**20)
            +5*Q2**2*(-17472+107975*r**2-9963*r**4-1607190*r**6+4321574*r**8+738744*r**10
            -1773696*r**12-1608826*r**14+2807850*r**16-446703*r**18+229467*r**20)
            -5*Q2*(-9688+33023*r**2+18428*r**4-1242421*r**6+3091472*r**8-8440858*r**10
            -17277112*r**12-8770810*r**14-3667576*r**16+3258651*r**18+3324*r**20
            +102447*r**22))*sqrtq2+(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(252*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(-3+5*Q2**3+5*r**2-19*r**4+5*r**6-5*Q2**2*(1
            +r**2)+Q2*(-5+8*r**2-5*r**4))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7
            +2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**3-150*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(-115+200*Q2**6
            -4126*r**2+5499*r**4+16524*r**6-2201*r**8-486*r**10+25*r**12-150*Q2**5*(1
            +r**2)-6*Q2**4*(25-54*r**2+25*r**4)+Q2**3*(-115+309*r**2-111*r**4
            +25*r**6)+Q2**2*(-115-6*r**2+886*r**4-286*r**6+25*r**8)+Q2*(-115
            -1111*r**2+3466*r**4+666*r**6-411*r**8+25*r**10))-5*(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(
            -381+118368*Q2**12+187378*r**2-3610610*r**4-30687966*r**6-117894619*r**8
            -252076420*r**10-1046392476*r**12-962795428*r**14+114616301*r**16+45159954*r**18
            +1455886*r**20-242942*r**22+6123*r**24-310896*Q2**11*(1+r**2)-16*Q2**10*(2427
            -51158*r**2+2427*r**4)+Q2**9*(422697-731485*r**2-1266589*r**4+601065*r**6)
            -3*Q2**8*(-60785+412516*r**2+2286730*r**4+240036*r**6+25455*r**8)-6*Q2**7*(55198
            -576833*r**2-2491341*r**4-2328181*r**6-702933*r**8+98226*r**10)+6*Q2**6*(
            -47922+236827*r**2+2432442*r**4-1080910*r**6+2727022*r**8+7931*r**10
            +6482*r**12)+6*Q2**5*(12633-478566*r**2-1452790*r**4+290387*r**6+5644527*r**8
            -2761034*r**10-830186*r**12+59589*r**14)+2*Q2**4*(90369-963255*r**2
            -9543264*r**4+22046055*r**6+79006682*r**8+21799407*r**10-10363320*r**12
            -231183*r**14+13005*r**16)-2*Q2**3*(-29790+241731*r**2+7912671*r**4
            +30128553*r**6+17319703*r**8+21228703*r**10+50775033*r**12-3064785*r**14
            -1443489*r**16+63030*r**18)-6*Q2**2*(6970-134257*r**2-204102*r**4+20005912*r**6
            +76500400*r**8+74888866*r**10+83784840*r**12+17577720*r**14-1039834*r**16
            -111137*r**18+4302*r**20)+Q2*(-28887+867889*r**2+983121*r**4-73655271*r**6
            -307238698*r**8+30896982*r**10-515497818*r**12-292032346*r**14+29433921*r**16
            +767673*r**18-653495*r**20+19329*r**22)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(2449440000*logq2**4*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+34020000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +23625*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-5878656000*logq2**5*r**20*sqrtq2
            -408240000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-1417500*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+(muWC**3*(172800*logq2**3*r**8*(-240*Q2**8*(2
            +5*r**4)+20*Q2**7*(360+458*r**2+921*r**4+795*r**6)-4*Q2**6*(10878+24988*r**2
            +37177*r**4+44382*r**6+21315*r**8)+Q2**5*(104622+336729*r**2+610940*r**4
            +754746*r**6+592878*r**8+226485*r**10)-Q2**4*(100170+406601*r**2+950681*r**4
            +1445654*r**6+1340944*r**8+821745*r**10+277725*r**12)+2*Q2**3*(-210
            +76507*r**2+268474*r**4+442105*r**6+545546*r**8+427613*r**10+142110*r**12
            +30975*r**14)+(-1+r**2)**2*(10398+20051*r**2+344043*r**4+653275*r**6
            +46655*r**8+236257*r**10-20391*r**12+42417*r**14+51615*r**16)+2*Q2**2*(35490
            +5457*r**2+90893*r**4+164401*r**6-148211*r**8-43133*r**10-92097*r**12
            +120795*r**14+97125*r**16)-Q2*(48618+2519*r**2+743284*r**4+2018828*r**6
            +1239000*r**8+675682*r**10+732396*r**12-186084*r**14+77022*r**16+186015*r**18))
            -48*logq2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(48*Q2**14*(838+5955*r**4)
            -4*Q2**13*(65364+42334*r**2+454635*r**4+623565*r**6)+4*Q2**12*(163146
            +208224*r**2+894561*r**4+3342410*r**6+2065935*r**8)-Q2**11*(656226+1833679*r**2
            +84304*r**4+22306266*r**6+38121590*r**8+11742735*r**10)+Q2**10*(-149166
            +2219769*r**2-19515511*r**4-5678706*r**6+22929104*r**8+48201385*r**10
            +1293765*r**12)+Q2**9*(932202-342925*r**2+76673940*r**4+152248645*r**6
            +257519050*r**8+211707117*r**10+2145800*r**12+17529195*r**14)-Q2**8*(643938
            +3798333*r**2+146675925*r**4+437213085*r**6+882677905*r**8+1358502463*r**10
            +809696023*r**12+100729095*r**14+19767105*r**16)+2*Q2**7*(-95034+2588349*r**2
            +53176656*r**4+284990610*r**6+610277460*r**8+1237277626*r**10+1342363624*r**12
            +507031666*r**14+68458110*r**16+600885*r**18)+2*Q2**6*(217626-214491*r**2
            +35738589*r**4-171511494*r**6-182677310*r**8-838490994*r**10-1530284226*r**12
            -1109220606*r**14+19096696*r**16-15779535*r**18+6071985*r**20)-2*Q2**5*(65934
            +2080929*r**2+91484994*r**4-11418171*r**6+938823504*r**8+1735891344*r**10
            +1264896044*r**12+128316124*r**14-103897846*r**16+641803679*r**18+49148010*r**20
            +3864015*r**22)+2*Q2**4*(-35838+1452875*r**2+51882885*r**4+85761615*r**6
            +1613697575*r**8+4539789096*r**10+6092626300*r**12+5792334320*r**14+2702174210*r**16
            +677749525*r**18+545560167*r**20+46791225*r**22-215955*r**24)+Q2**3*(51894
            +280869*r**2+20582640*r**4-238788530*r**6-955856370*r**8-5773454613*r**10
            -9598500528*r**12-11078392700*r**14-7478849710*r**16-3189519205*r**18
            -1747630656*r**20-49296466*r**22-6995990*r**24+2161365*r**26)-(-1+r**2)**2*(
            -534+48893*r**2+3628921*r**4+4981510*r**6+416786020*r**8-537515837*r**10
            +2356443219*r**12+6031181748*r**14-4075225670*r**16-816998205*r**18+1469546671*r**20
            +74778438*r**22+53899256*r**24+1993085*r**26+4485*r**28)-Q2**2*(5766
            +1036019*r**2+51050531*r**4-168655590*r**6+1958971260*r**8-1187137387*r**10
            -1213972463*r**12-3140772932*r**14-7657593370*r**16+2403993805*r**18
            +4634750021*r**20-1107742806*r**22+412538776*r**24+29160235*r**26+816135*r**28)
            +Q2*(-2526+405111*r**2+22928476*r**4-51338271*r**6+1773922710*r**8
            -1998482013*r**10+3593369168*r**12+15385804533*r**14+9033069422*r**16
            -10589866795*r**18-2504580276*r**20+5323069171*r**22-314544934*r**24
            +245900049*r**26+14449160*r**28+105015*r**30))+72576000*logq2**4*r**12*(138
            +387*r**2+11*r**4+45*r**6+243*r**8)*sqrtq2-2880*logq2**2*r**4*(240*Q2**11*(64
            +255*r**4)-4*Q2**10*(39012+41168*r**2+144009*r**4+162585*r**6)+40*Q2**9*(13902
            +28126*r**2+68281*r**4+114094*r**6+68145*r**8)-5*Q2**8*(174834+551055*r**2
            +1289626*r**4+2645436*r**6+2787060*r**8+1078965*r**10)+10*Q2**7*(39204
            +315906*r**2+679997*r**4+1754018*r**6+2666128*r**8+1948404*r**10+396135*r**12)
            +10*Q2**6*(64512-152460*r**2+413806*r**4+113261*r**6-949288*r**8-1613582*r**10
            -957054*r**12+322245*r**14)-2*Q2**5*(494172+330078*r**2+12922009*r**4
            +32645910*r**6+45077655*r**8+36674062*r**10+17152923*r**12+3633294*r**14
            +4126185*r**16)+10*Q2**4*(37062+190281*r**2+3112430*r**4+10882625*r**6
            +20459910*r**8+23905019*r**10+16846118*r**12+7520071*r**14+1493184*r**16
            +484020*r**18)+10*Q2**3*(21132-153210*r**2-390653*r**4-5537254*r**6
            -13279970*r**8-18008558*r**10-18413960*r**12-8400010*r**14-3016082*r**16
            -1144680*r**18+115245*r**20)-(-1+r**2)**2*(11058+89563*r**2+3450374*r**4
            +1692575*r**6+38015816*r**8+76898906*r**10+13179992*r**12-28558654*r**14
            +4508870*r**16+14059979*r**18+1063906*r**20+176415*r**22)-10*Q2**2*(24864
            -36624*r**2+1909688*r**4-490773*r**6+77604*r**8-1242028*r**10-6830988*r**12
            -6346062*r**14+4137692*r**16+4738548*r**18-362316*r**20+267435*r**22)
            +10*Q2*(8772+15110*r**2+1429913*r**4-432166*r**6+8402753*r**8+21283532*r**10
            +17981306*r**12+3226292*r**14-7328794*r**16+151982*r**18+4887981*r**20
            +90354*r**22+118485*r**24))*sqrtq2+(-1008*(Q2-(-1+r)**2)*(Q2-(1
            +r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**3*(5*Q2**5
            -Q2**4*(7+15*r**2)+2*Q2**3*(4+2*r**2+5*r**4)+(-1+r**2)**2*(17+r**2
            -11*r**4+5*r**6)+2*Q2**2*(7-6*r**2-4*r**4+5*r**6)-Q2*(37+20*r**2
            +8*r**4-32*r**6+15*r**8))+20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(124368*Q2**14
            -12*Q2**13*(31607+48011*r**2)+4*Q2**12*(90147+312950*r**2+184707*r**4)
            +Q2**11*(371985-1453151*r**2-2008817*r**4+392583*r**6)-Q2**10*(1330575
            +1047134*r**2+5511696*r**4-1664614*r**6+1415577*r**8)+Q2**9*(-137583
            +4550843*r**2+22675900*r**4+30847768*r**6+3085235*r**8+216189*r**10)
            +3*Q2**8*(1184187-2216408*r**2-8366339*r**4-9087572*r**6-6611567*r**8
            -2629444*r**10+398663*r**12)-6*Q2**7*(408713-622003*r**2-460117*r**4
            -7540753*r**6-1337767*r**8+8012741*r**10-76045*r**12+62351*r**14)+Q2**6*(
            -2194182+12374268*r**2+30175344*r**4+33186516*r**6+91383376*r**8-34206132*r**10
            +36823248*r**12+8414724*r**14-642666*r**16)+2*Q2**5*(1194639-5548923*r**2
            +64485252*r**4+49440888*r**6-102815012*r**8-197673968*r**10-42786108*r**12
            +21745512*r**14-879699*r**16+97227*r**18)+2*Q2**4*(161295-6325704*r**2
            -116360655*r**4-60436236*r**6-97257380*r**8-381221244*r**10-207762356*r**12
            +62111700*r**14-17138499*r**16-2530980*r**18+121659*r**20)+Q2**3*(-688827
            +9820381*r**2+8125467*r**4+27128619*r**6+399694734*r**8-38526994*r**10
            +601434146*r**12+982049778*r**14+133134381*r**16-10216779*r**18+945091*r**20
            -51357*r**22)+Q2**2*(14565+5151122*r**2+105308600*r**4-474631098*r**6
            -628285703*r**8-1402253348*r**10-700221072*r**12+701722132*r**14+394628383*r**16
            -112997742*r**18+7661528*r**20+1675430*r**22-57597*r**24)+(-1+r**2)**2*(20997
            -485606*r**2+12779698*r**4+181474206*r**6+1526622767*r**8+690798284*r**10
            -57575364*r**12-500522236*r**14+199723379*r**16+48433818*r**18+1265554*r**20
            -257570*r**22+6873*r**24)+Q2*(25797-2877937*r**2-47186412*r**4-24294112*r**6
            -3489882275*r**8-4940138109*r**10-1319224616*r**12+1185768064*r**14+1038599799*r**16
            -735216755*r**18-72991468*r**20-1601952*r**22-124057*r**24+4833*r**26)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(7348320000*logq2**4*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+102060000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +70875*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-17635968000*logq2**5*r**20*sqrtq2
            -1224720000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-4252500*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+((72576000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -38-29*r**2+19*r**6)*(-Q2+(1+r)**2)+5760*logq2**2*r**10*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(-7879+5120*Q2**9-87678*r**2-1053462*r**4
            -634926*r**6-2518500*r**8-240126*r**10-109002*r**12+933582*r**14+79371*r**16
            +9820*r**18-2*Q2**8*(20272+17415*r**2)+8*Q2**7*(12884+25749*r**2+10305*r**4)
            -Q2**6*(80507+405405*r**2+353837*r**4+64575*r**6)+Q2**5*(-70826+265853*r**2
            +400483*r**4+189179*r**6+7455*r**8)+Q2**4*(151375+281470*r**2+941126*r**4
            +638170*r**6+65095*r**8-34020*r**10)+2*Q2**3*(-27118-288225*r**2-1298122*r**4
            -1742567*r**6-748125*r**8-40208*r**10+22365*r**12)+Q2**2*(-43277+192283*r**2
            +816061*r**4+2877491*r**6+1836221*r**8+63893*r**10-121557*r**12+23685*r**14)
            +Q2*(37702+158765*r**2+1377033*r**4-1139165*r**6-1466725*r**8+1443*r**10
            -195545*r**12+56717*r**14-39825*r**16))+4*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(479+3996*Q2**14-80178*r**2-5676403*r**4-71498636*r**6-45389657*r**8
            -1456348118*r**10+2781783741*r**12-3623258664*r**14+1517597397*r**16
            -47392766*r**18+72430239*r**20+6783412*r**22+138917*r**24-1786*r**26
            +23*r**28-3976*Q2**13*(1+r**2)+Q2**12*(23253+78474*r**2-36423*r**4)
            +2*Q2**11*(-79371-741497*r**2-162901*r**4+41145*r**6)+4*Q2**10*(66391
            +1313668*r**2+1217173*r**4+77646*r**6-7658*r**8)-2*Q2**9*(21921+2920315*r**2
            +9036220*r**4+3093220*r**6-55965*r**8+16161*r**10)+Q2**8*(-197683-4276678*r**2
            +19602875*r**4+10181700*r**6+6199915*r**8+468162*r**10-34003*r**12)
            +4*Q2**7*(12281+3807223*r**2+7906579*r**4+32189785*r**6+11377365*r**8
            -1707269*r**10-355297*r**12+19829*r**14)+4*Q2**6*(29351-2036048*r**2
            -21582324*r**4-95027160*r**6-88987060*r**8-12961824*r**10+848652*r**12
            +68096*r**14+1085*r**16)-4*Q2**5*(6067+1931161*r**2-10393484*r**4-55609088*r**6
            -186900976*r**8-62943748*r**10+8196796*r**12-775504*r**14-273363*r**16
            +12379*r**18)+Q2**4*(-48129+8934830*r**2+53142415*r**4+346647240*r**6
            -597707450*r**8-191096492*r**10-100227650*r**12+33755240*r**14-6973685*r**16
            -395730*r**18+8451*r**20)+2*Q2**3*(6217-253573*r**2-31204425*r**4-238619075*r**6
            -168172610*r**8-766715654*r**10-373737854*r**12+35730710*r**14+14210425*r**16
            +1932555*r**18-158393*r**20+5677*r**22)-4*Q2**2*(-1787+560004*r**2-626683*r**4
            -8594090*r**6-193891400*r**8-305027136*r**10-171392098*r**12+27508156*r**14
            -5541495*r**16+4286140*r**18-442787*r**20-21266*r**22+442*r**24)-2*Q2*(1381
            -401793*r**2-9764124*r**4-85367100*r**6+183042405*r**8-785675337*r**10
            +859966136*r**12+407836408*r**14-335635065*r**16+50429845*r**18+4947556*r**20
            +945732*r**22-22609*r**24+565*r**26))+345600*logq2**3*r**14*(160*Q2**8
            -10*Q2**7*(212+163*r**2)+2*Q2**6*(5684+7939*r**2+3087*r**4)-Q2**5*(26873
            +55466*r**2+41137*r**4+11564*r**6)+Q2**4*(27055+72774*r**2+81584*r**4
            +44802*r**6+10185*r**8)-2*Q2**3*(805+15588*r**2+22716*r**4+18012*r**6
            +7419*r**8+2660*r**10)+(-1+r**2)**2*(-3557-7134*r**2-32215*r**4-14120*r**6
            +10065*r**8+3142*r**10+3499*r**12)+2*Q2**2*(-9625-1868*r**2-9937*r**4
            -1926*r**6+8515*r**8+4306*r**10+3815*r**12)+Q2*(14827+3376*r**2+82189*r**4
            +106850*r**6+4405*r**8-33892*r**10-7341*r**12-9134*r**14))*sqrtq2+96*logq2*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-207+13408*Q2**12-79436*r**2-2918122*r**4
            -11164160*r**6-94400645*r**8+44076984*r**10-82613068*r**12-94146656*r**14
            +85506135*r**16+7209620*r**18+3270198*r**20+107104*r**22+253*r**24-2*Q2**11*(36748
            +36653*r**2)+2*Q2**10*(68044+189497*r**2+64429*r**4)-5*Q2**9*(8347+139994*r**2
            +121067*r**4+24960*r**6)+5*Q2**8*(-35523-23058*r**2-367772*r**4-20278*r**6
            +43959*r**8)+2*Q2**7*(103182+1101345*r**2+6986390*r**4+6755450*r**6
            +678760*r**8-156363*r**10)+2*Q2**6*(4046-1213149*r**2-11162995*r**4
            -23153140*r**6-9345350*r**8-278859*r**10+20111*r**12)+2*Q2**5*(-67653
            -245679*r**2+1168807*r**4+27972165*r**6+23403095*r**8+2927107*r**10
            -632149*r**12+133107*r**14)-10*Q2**4*(-6231-228987*r**2-2627851*r**4
            +68503*r**6-274537*r**8-35441*r**10+275003*r**12-3851*r**14+15600*r**16)
            -20*Q2**3*(-897+47208*r**2+1099417*r**4+3289212*r**6+8344671*r**8+8024462*r**10
            +1464631*r**12-311908*r**14-65982*r**16+1986*r**18)+4*Q2**2*(-5143-112760*r**2
            -694795*r**4+11398055*r**6+24649385*r**8+42550031*r**10+8859965*r**12
            -3785575*r**14+307550*r**16-17655*r**18+10942*r**20)+Q2*(4729+409304*r**2
            +9738065*r**4+1950450*r**6+94978350*r**8-103830768*r**10-78550338*r**12
            -13931940*r**14+23451225*r**16-6260200*r**18-528911*r**20-5966*r**22))*sqrtq2)*math.log(mu0)*nlo.X1Q2(0,'SM',Q2,r))/(870912000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+60480000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+210000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-5040000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            -3500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
            -362880000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((1512000*logq2**3*r**12*(1
            +r**2)*(19+10*r**2+19*r**4)+60*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1
            +r)**2)*(23-1440*Q2**9+10999*r**2+228160*r**4+383296*r**6+3006322*r**8
            +3006322*r**10+383296*r**12+228160*r**14+10999*r**16+23*r**18+10248*Q2**8*(1
            +r**2)-512*Q2**7*(37+94*r**2+37*r**4)+Q2**6*(4319+70769*r**2+70769*r**4
            +4319*r**6)+2*Q2**5*(8631-19072*r**2-30126*r**4-19072*r**6+8631*r**8)
            -Q2**4*(11375+66235*r**2+466262*r**4+466262*r**6+66235*r**8+11375*r**10)
            -4*Q2**3*(847-28698*r**2-220767*r**4-429164*r**6-220767*r**8-28698*r**10
            +847*r**12)+Q2**2*(3729-4117*r**2-37563*r**4-1070849*r**6-1070849*r**8
            -37563*r**10-4117*r**12+3729*r**14)-2*Q2*(217+25092*r**2+198688*r**4
            -394052*r**6-869490*r**8-394052*r**10+198688*r**12+25092*r**14+217*r**16))
            +3600*logq2**2*r**8*(781-80*Q2**6+4344*r**2+33555*r**4+43600*r**6+33555*r**8
            +4344*r**10+781*r**12+900*Q2**5*(1+r**2)-4*Q2**4*(951+1718*r**2+951*r**4)
            +Q2**3*(3931+13189*r**2+13189*r**4+3931*r**6)+Q2**2*(1131-5648*r**2
            -11126*r**4-5648*r**6+1131*r**8)-3*Q2*(953-829*r**2-3484*r**4-3484*r**6
            -829*r**8+953*r**10))*sqrtq2+(-250*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1+8*Q2**6
            -34*r**2-1133*r**4-2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1+r**2)
            +Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1
            -26*r**2-118*r**4-26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6
            -31*r**8+r**10))+7*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6
            -28170*r**8+31692*r**10-9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)
            +Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)
            +Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2
            -6138*r**4-6138*r**6-355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4
            +35188*r**6+10313*r**8-406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4
            +6605*r**6+6605*r**8-7237*r**10-595*r**12+27*r**14)))*sqrtq2)*math.log(mus)*nlo.X1Q2(0,'SM',Q2,r))/(17418240*logq2**4*r**16
            +725760*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+840*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-5806080*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-40320*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((-72576000*logq2**4*(-Q2+(-1+r)**2)*r**18*(-38-29*r**2+19*r**6)*(-Q2
            +(1+r)**2)-5760*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -7879+5120*Q2**9-87678*r**2-1053462*r**4-634926*r**6-2518500*r**8-240126*r**10
            -109002*r**12+933582*r**14+79371*r**16+9820*r**18-2*Q2**8*(20272+17415*r**2)
            +8*Q2**7*(12884+25749*r**2+10305*r**4)-Q2**6*(80507+405405*r**2+353837*r**4
            +64575*r**6)+Q2**5*(-70826+265853*r**2+400483*r**4+189179*r**6+7455*r**8)
            +Q2**4*(151375+281470*r**2+941126*r**4+638170*r**6+65095*r**8-34020*r**10)
            +2*Q2**3*(-27118-288225*r**2-1298122*r**4-1742567*r**6-748125*r**8-40208*r**10
            +22365*r**12)+Q2**2*(-43277+192283*r**2+816061*r**4+2877491*r**6+1836221*r**8
            +63893*r**10-121557*r**12+23685*r**14)+Q2*(37702+158765*r**2+1377033*r**4
            -1139165*r**6-1466725*r**8+1443*r**10-195545*r**12+56717*r**14-39825*r**16))
            -4*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(479+3996*Q2**14-80178*r**2
            -5676403*r**4-71498636*r**6-45389657*r**8-1456348118*r**10+2781783741*r**12
            -3623258664*r**14+1517597397*r**16-47392766*r**18+72430239*r**20+6783412*r**22
            +138917*r**24-1786*r**26+23*r**28-3976*Q2**13*(1+r**2)+Q2**12*(23253
            +78474*r**2-36423*r**4)+2*Q2**11*(-79371-741497*r**2-162901*r**4+41145*r**6)
            +4*Q2**10*(66391+1313668*r**2+1217173*r**4+77646*r**6-7658*r**8)-2*Q2**9*(21921
            +2920315*r**2+9036220*r**4+3093220*r**6-55965*r**8+16161*r**10)+Q2**8*(
            -197683-4276678*r**2+19602875*r**4+10181700*r**6+6199915*r**8+468162*r**10
            -34003*r**12)+4*Q2**7*(12281+3807223*r**2+7906579*r**4+32189785*r**6
            +11377365*r**8-1707269*r**10-355297*r**12+19829*r**14)+4*Q2**6*(29351
            -2036048*r**2-21582324*r**4-95027160*r**6-88987060*r**8-12961824*r**10
            +848652*r**12+68096*r**14+1085*r**16)-4*Q2**5*(6067+1931161*r**2-10393484*r**4
            -55609088*r**6-186900976*r**8-62943748*r**10+8196796*r**12-775504*r**14
            -273363*r**16+12379*r**18)+Q2**4*(-48129+8934830*r**2+53142415*r**4
            +346647240*r**6-597707450*r**8-191096492*r**10-100227650*r**12+33755240*r**14
            -6973685*r**16-395730*r**18+8451*r**20)+2*Q2**3*(6217-253573*r**2-31204425*r**4
            -238619075*r**6-168172610*r**8-766715654*r**10-373737854*r**12+35730710*r**14
            +14210425*r**16+1932555*r**18-158393*r**20+5677*r**22)-4*Q2**2*(-1787
            +560004*r**2-626683*r**4-8594090*r**6-193891400*r**8-305027136*r**10
            -171392098*r**12+27508156*r**14-5541495*r**16+4286140*r**18-442787*r**20
            -21266*r**22+442*r**24)-2*Q2*(1381-401793*r**2-9764124*r**4-85367100*r**6
            +183042405*r**8-785675337*r**10+859966136*r**12+407836408*r**14-335635065*r**16
            +50429845*r**18+4947556*r**20+945732*r**22-22609*r**24+565*r**26))-345600*logq2**3*r**14*(160*Q2**8
            -10*Q2**7*(212+163*r**2)+2*Q2**6*(5684+7939*r**2+3087*r**4)-Q2**5*(26873
            +55466*r**2+41137*r**4+11564*r**6)+Q2**4*(27055+72774*r**2+81584*r**4
            +44802*r**6+10185*r**8)-2*Q2**3*(805+15588*r**2+22716*r**4+18012*r**6
            +7419*r**8+2660*r**10)+(-1+r**2)**2*(-3557-7134*r**2-32215*r**4-14120*r**6
            +10065*r**8+3142*r**10+3499*r**12)+2*Q2**2*(-9625-1868*r**2-9937*r**4
            -1926*r**6+8515*r**8+4306*r**10+3815*r**12)+Q2*(14827+3376*r**2+82189*r**4
            +106850*r**6+4405*r**8-33892*r**10-7341*r**12-9134*r**14))*sqrtq2-96*logq2*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-207+13408*Q2**12-79436*r**2-2918122*r**4
            -11164160*r**6-94400645*r**8+44076984*r**10-82613068*r**12-94146656*r**14
            +85506135*r**16+7209620*r**18+3270198*r**20+107104*r**22+253*r**24-2*Q2**11*(36748
            +36653*r**2)+2*Q2**10*(68044+189497*r**2+64429*r**4)-5*Q2**9*(8347+139994*r**2
            +121067*r**4+24960*r**6)+5*Q2**8*(-35523-23058*r**2-367772*r**4-20278*r**6
            +43959*r**8)+2*Q2**7*(103182+1101345*r**2+6986390*r**4+6755450*r**6
            +678760*r**8-156363*r**10)+2*Q2**6*(4046-1213149*r**2-11162995*r**4
            -23153140*r**6-9345350*r**8-278859*r**10+20111*r**12)+2*Q2**5*(-67653
            -245679*r**2+1168807*r**4+27972165*r**6+23403095*r**8+2927107*r**10
            -632149*r**12+133107*r**14)-10*Q2**4*(-6231-228987*r**2-2627851*r**4
            +68503*r**6-274537*r**8-35441*r**10+275003*r**12-3851*r**14+15600*r**16)
            -20*Q2**3*(-897+47208*r**2+1099417*r**4+3289212*r**6+8344671*r**8+8024462*r**10
            +1464631*r**12-311908*r**14-65982*r**16+1986*r**18)+4*Q2**2*(-5143-112760*r**2
            -694795*r**4+11398055*r**6+24649385*r**8+42550031*r**10+8859965*r**12
            -3785575*r**14+307550*r**16-17655*r**18+10942*r**20)+Q2*(4729+409304*r**2
            +9738065*r**4+1950450*r**6+94978350*r**8-103830768*r**10-78550338*r**12
            -13931940*r**14+23451225*r**16-6260200*r**18-528911*r**20-5966*r**22))*sqrtq2)*math.log(r)*nlo.X1Q2(0,'SM',Q2,r))/(870912000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+60480000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+210000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-5040000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            -3500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
            -362880000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((-3024000*logq2**3*r**12*(1
            +r**2)*(16+19*r**2+16*r**4)+600*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1
            +r)**2)*(2+128*Q2**9-173*r**2-19829*r**4-117155*r**6-633965*r**8-633965*r**10
            -117155*r**12-19829*r**14-173*r**16+2*r**18-1106*Q2**8*(1+r**2)+2*Q2**7*(965
            +2354*r**2+965*r**4)+Q2**6*(70-5573*r**2-5573*r**4+70*r**6)+Q2**5*(
            -2072+3870*r**2+8012*r**4+3870*r**6-2072*r**8)+Q2**4*(532+6047*r**2
            +52389*r**4+52389*r**6+6047*r**8+532*r**10)+2*Q2**3*(413-6346*r**2
            -48669*r**4-91628*r**6-48669*r**8-6346*r**10+413*r**12)-Q2**2*(170
            +1051*r**2+13203*r**4-70620*r**6-70620*r**8+13203*r**10+1051*r**12
            +170*r**14)-2*Q2*(70-2985*r**2-16646*r**4+71917*r**6+152328*r**8+71917*r**10
            -16646*r**12-2985*r**14+70*r**16))-7200*logq2**2*r**8*(169-20*Q2**6+3963*r**2
            +33657*r**4+52942*r**6+33657*r**8+3963*r**10+169*r**12+330*Q2**5*(1
            +r**2)-Q2**4*(2001+3706*r**2+2001*r**4)+Q2**3*(2059+6848*r**2+6848*r**4
            +2059*r**6)+Q2**2*(834-1825*r**2-4486*r**4-1825*r**6+834*r**8)-3*Q2*(457
            -790*r**2-3237*r**4-3237*r**6-790*r**8+457*r**10))*sqrtq2+(125*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4-2708*r**6-1133*r**8
            -34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1
            -19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4-26*r**6+r**8)+Q2*(1
            -31*r**2-390*r**4-390*r**6-31*r**8+r**10))+21*(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(-1+14*Q2**8
            +48*r**2+2512*r**4-2064*r**6+27810*r**8-2064*r**10+2512*r**12+48*r**14
            -r**16-22*Q2**7*(1+r**2)+Q2**6*(-13+30*r**2-13*r**4)+6*Q2**5*(1-3*r**2
            -3*r**4+r**6)+Q2**4*(55-440*r**2-3406*r**4-440*r**6+55*r**8)+Q2**3*(
            -34+610*r**2+7344*r**4+7344*r**6+610*r**8-34*r**10)-Q2**2*(23-202*r**2
            +1421*r**4+8236*r**6+1421*r**8-202*r**10+23*r**12)+2*Q2*(9-205*r**2
            -1699*r**4+4295*r**6+4295*r**8-1699*r**10-205*r**12+9*r**14)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r)**2)/(
            -435456000*logq2**5*r**20-30240000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -105000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+181440000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+2520000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+1750*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +(flagPERP*muWC**3*(-1440*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(
            -64+133*r**2+60*Q2**5*r**2+1223*r**4-10172*r**6-7372*r**8-1313*r**10
            +1005*r**12-32*Q2**4*(2+9*r**2+15*r**4)+Q2**3*(16+1453*r**2+2522*r**4
            +1485*r**6)-Q2**2*(-96+1069*r**2+3351*r**4+3783*r**6+765*r**8)-Q2*(
            -16+409*r**2+1378*r**4+146*r**6-462*r**8+1305*r**10))-2*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(27+460*Q2**11-5281*r**2+3007*r**4-221525*r**6
            -568062*r**8+1862442*r**10-6856934*r**12+1636338*r**14+127395*r**16
            +49207*r**18-1049*r**20+35*r**22-1240*Q2**10*(1+r**2)+Q2**9*(-125+3558*r**2
            -125*r**4)+Q2**8*(987+r**2-4463*r**4+2475*r**6)-2*Q2**7*(-1802+8311*r**2
            +50954*r**4+4407*r**6+150*r**8)+Q2**6*(-4604+20782*r**2+325038*r**4
            +294014*r**6+28150*r**8-2820*r**10)+2*Q2**5*(-1011+10443*r**2-67095*r**4
            -357658*r**6-48031*r**8-853*r**10+165*r**12)+Q2**4*(3490-20928*r**2
            -209888*r**4+392158*r**6+839654*r**8-327160*r**10-38328*r**12+2250*r**14)
            +Q2**3*(328-32346*r**2+87100*r**4+421330*r**6+1121864*r**8-91758*r**10
            +273404*r**12+15718*r**14-600*r**16)-2*Q2**2*(482-8581*r**2-6865*r**4
            +350793*r**6+1495671*r**8+1043439*r**10+497177*r**12-5249*r**14-7697*r**16
            +350*r**18)+Q2*(59+14028*r**2-55101*r**4-351056*r**6-1362670*r**8
            +2088136*r**10-2583118*r**12+371376*r**14-101869*r**16-7220*r**18+235*r**20))
            +86400*logq2**3*r**10*(-16+47*r**2+46*r**4+15*r**6)*sqrtq2+24*logq2*r**2*(
            -80*(-1+Q2)**6*(-1+Q2+6*Q2**2+4*Q2**3)-(-1+Q2)**5*(1181+3445*Q2
            +255*Q2**2-6905*Q2**3-5520*Q2**4+1544*Q2**5)*r**2+10*(-1+Q2)**2*(457
            +936*Q2+3159*Q2**2-1584*Q2**3+1995*Q2**4+2812*Q2**5-5163*Q2**6+1228*Q2**7)*r**4
            -5*(-9353+6648*Q2+6152*Q2**2+121012*Q2**3-153418*Q2**4+37808*Q2**5
            +34544*Q2**6-29564*Q2**7+6651*Q2**8)*r**6+20*(-11504-3858*Q2-25076*Q2**2
            -65995*Q2**3+69164*Q2**4-5792*Q2**5-5824*Q2**6+1557*Q2**7)*r**8+10*(111543
            -146944*Q2+30208*Q2**2-149158*Q2**3+65341*Q2**4+646*Q2**5+1788*Q2**6)*r**10
            -4*(340133+504680*Q2-76300*Q2**2+114425*Q2**3-22765*Q2**4+14283*Q2**5)*r**12
            +10*(-13177-95780*Q2-44612*Q2**2-11846*Q2**3+3237*Q2**4)*r**14+20*(34668
            +27678*Q2+2204*Q2**2+519*Q2**3)*r**16-5*(24359-5036*Q2+3528*Q2**2)*r**18
            +10*(-1671+602*Q2)*r**20-499*r**22)*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(-1555200*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-10800*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +4665600*logq2**4*r**16*sqrtq2+194400*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2+225*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)+((-1382400*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(15+11*r**2)*(-Q2+(1+r)**2)+384*logq2*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-71-376*Q2**8-2467*r**2-44893*r**4
            -42159*r**6-164195*r**8-72149*r**10+40997*r**12+4023*r**14+114*r**16
            +4*Q2**7*(342+337*r**2)-Q2**6*(1283+3945*r**2+858*r**4)+Q2**5*(-874
            +4582*r**2+3202*r**4+266*r**6)+Q2**4*(2055+5195*r**2+24779*r**4+4445*r**6
            -2570*r**8)+4*Q2**3*(-161-3545*r**2-20444*r**4-19529*r**6-2385*r**8
            +564*r**10)+Q2**2*(-613+3617*r**2+30404*r**4+70334*r**6+3699*r**8-5923*r**10
            +1082*r**12)+Q2*(438+5850*r**2+40342*r**4-73690*r**6-62590*r**8-9058*r**10
            +6370*r**12-1262*r**14))-115200*logq2**2*r**10*(8*Q2**7-2*Q2**6*(40+31*r**2)
            +3*Q2**5*(78+125*r**2+55*r**4)-2*Q2**4*(131+287*r**2+259*r**4+83*r**6)
            +Q2**3*(28+287*r**2+327*r**4+195*r**6+55*r**8)+Q2**2*(180+21*r**2
            +344*r**4-32*r**6-144*r**8-57*r**10)-(-1+r**2)**2*(-34-131*r**2-572*r**4
            -224*r**6-22*r**8+47*r**10)+2*Q2*(-71-55*r**2-751*r**4-869*r**6-206*r**8
            +28*r**10+52*r**12))*sqrtq2-32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -1+106*Q2**10+4478*r**2+53025*r**4+449632*r**6-390566*r**8+1472148*r**10
            -417338*r**12-37760*r**14-10617*r**16+206*r**18-7*r**20-47*Q2**9*(1
            +r**2)+Q2**8*(414+1464*r**2-702*r**4)+3*Q2**7*(-665-5717*r**2-1501*r**4
            +311*r**6)+3*Q2**6*(517+11104*r**2+8296*r**4+124*r**6+71*r**8)-3*Q2**5*(
            -405+2601*r**2+22548*r**4+4756*r**6-1643*r**8+183*r**10)+Q2**4*(-1233
            -46218*r**2+32691*r**4-53572*r**6+35565*r**8+3822*r**10-303*r**12)
            +Q2**3*(-369+46911*r**2+137493*r**4+590141*r**6+244325*r**8-25179*r**10
            -6849*r**12+327*r**14)+3*Q2**2*(105+2332*r**2-37722*r**4-125680*r**6
            -47576*r**8+21404*r**10-1838*r**12-664*r**14+39*r**16)-2*Q2*(-22+10971*r**2
            +2241*r**4+152179*r**6-355599*r**8-159423*r**10+76039*r**12-5931*r**14
            -1299*r**16+44*r**18))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(-6220800*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-259200*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-300*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+14400*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+2073600*logq2**3*r**14*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC*(2764800*logq2**3*(-Q2+(-1+r)**2)*r**14*(75+88*r**2
            +45*r**4)*(-Q2+(1+r)**2)-768*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-13+792*Q2**8-266*r**2-101474*r**4-427242*r**6-1313560*r**8
            -487222*r**10+70306*r**12+12714*r**14+357*r**16-8*Q2**7*(802+807*r**2)
            +Q2**6*(9911+25440*r**2+10761*r**4)+Q2**5*(678-22934*r**2-25694*r**4
            +2958*r**6)+Q2**4*(-8435+20910*r**2+75432*r**4+19410*r**6-17685*r**8)
            +4*Q2**3*(437-655*r**2+1918*r**4+3748*r**6+1665*r**8+1887*r**10)+Q2**2*(2481
            -25684*r**2-91583*r**4-152528*r**6-144993*r**8-44764*r**10+5871*r**12)
            -2*Q2*(373-5805*r**2+19157*r**4+153735*r**6+142635*r**8+68557*r**10
            -6325*r**12+2073*r**14))-230400*logq2**2*r**10*(-4*Q2**7+Q2**6*(76+40*r**2)
            +Q2**5*(-105-160*r**2+33*r**4)-Q2**4*(127+381*r**2+493*r**4+319*r**6)
            +2*Q2**3*(170+70*r**2+127*r**4+162*r**6+143*r**8)+2*Q2**2*(-132-4*r**2
            -877*r**4-501*r**6+161*r**8+105*r**10)+(-1+r**2)**2*(-29-721*r**2
            -3532*r**4-2836*r**6-503*r**8+133*r**10)+Q2*(113+1032*r**2+8711*r**4
            +13244*r**6+6531*r**8+700*r**10-379*r**12))*sqrtq2-64*r**2*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(21+460*Q2**11-613*r**2+9461*r**4-151845*r**6
            -996146*r**8-2463614*r**10-6189042*r**12+737794*r**14+29725*r**16+39651*r**18
            -1027*r**20+35*r**22-4*Q2**10*(257+310*r**2)+Q2**9*(-219+2416*r**2
            -125*r**4)+3*Q2**8*(357-829*r**2-1529*r**4+825*r**6)-6*Q2**7*(-261
            +1566*r**2+11507*r**4+730*r**6+50*r**8)-6*Q2**6*(399-3909*r**2-33721*r**4
            -36529*r**6-4302*r**8+470*r**10)+2*Q2**5*(-384+624*r**2-34203*r**4
            -176894*r**6-27738*r**8-3090*r**10+165*r**12)+2*Q2**4*(822-12558*r**2
            -42435*r**4+217003*r**6+303266*r**8-124218*r**10-17613*r**12+1125*r**14)
            +2*Q2**3*(27+2046*r**2+13491*r**4-87150*r**6+64561*r**8-193982*r**10
            +85581*r**12+8526*r**14-300*r**16)-2*Q2**2*(233-4953*r**2+11469*r**4
            +170593*r**6+394563*r**8+628875*r**10+347971*r**12-1041*r**14-7260*r**16
            +350*r**18)+Q2*(59-2264*r**2+11199*r**4+43444*r**6-1030498*r**8-1512924*r**10
            -2276906*r**12+338636*r**14-56409*r**16-7372*r**18+235*r**20))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(
            -18662400*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-777600*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -900*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4
            +43200*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*sqrtq2+6220800*logq2**3*r**14*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC**2*(345600*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(75+88*r**2+45*r**4)*(-Q2+(1+r)**2)-96*logq2*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-13+792*Q2**8-266*r**2-101474*r**4
            -427242*r**6-1313560*r**8-487222*r**10+70306*r**12+12714*r**14+357*r**16
            -8*Q2**7*(802+807*r**2)+Q2**6*(9911+25440*r**2+10761*r**4)+Q2**5*(678
            -22934*r**2-25694*r**4+2958*r**6)+Q2**4*(-8435+20910*r**2+75432*r**4
            +19410*r**6-17685*r**8)+4*Q2**3*(437-655*r**2+1918*r**4+3748*r**6+1665*r**8
            +1887*r**10)+Q2**2*(2481-25684*r**2-91583*r**4-152528*r**6-144993*r**8
            -44764*r**10+5871*r**12)-2*Q2*(373-5805*r**2+19157*r**4+153735*r**6
            +142635*r**8+68557*r**10-6325*r**12+2073*r**14))-28800*logq2**2*r**10*(
            -4*Q2**7+Q2**6*(76+40*r**2)+Q2**5*(-105-160*r**2+33*r**4)-Q2**4*(127
            +381*r**2+493*r**4+319*r**6)+2*Q2**3*(170+70*r**2+127*r**4+162*r**6
            +143*r**8)+2*Q2**2*(-132-4*r**2-877*r**4-501*r**6+161*r**8+105*r**10)
            +(-1+r**2)**2*(-29-721*r**2-3532*r**4-2836*r**6-503*r**8+133*r**10)
            +Q2*(113+1032*r**2+8711*r**4+13244*r**6+6531*r**8+700*r**10-379*r**12))*sqrtq2
            -8*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(21+460*Q2**11-613*r**2
            +9461*r**4-151845*r**6-996146*r**8-2463614*r**10-6189042*r**12+737794*r**14
            +29725*r**16+39651*r**18-1027*r**20+35*r**22-4*Q2**10*(257+310*r**2)
            +Q2**9*(-219+2416*r**2-125*r**4)+3*Q2**8*(357-829*r**2-1529*r**4+825*r**6)
            -6*Q2**7*(-261+1566*r**2+11507*r**4+730*r**6+50*r**8)-6*Q2**6*(399
            -3909*r**2-33721*r**4-36529*r**6-4302*r**8+470*r**10)+2*Q2**5*(-384
            +624*r**2-34203*r**4-176894*r**6-27738*r**8-3090*r**10+165*r**12)+2*Q2**4*(822
            -12558*r**2-42435*r**4+217003*r**6+303266*r**8-124218*r**10-17613*r**12
            +1125*r**14)+2*Q2**3*(27+2046*r**2+13491*r**4-87150*r**6+64561*r**8
            -193982*r**10+85581*r**12+8526*r**14-300*r**16)-2*Q2**2*(233-4953*r**2
            +11469*r**4+170593*r**6+394563*r**8+628875*r**10+347971*r**12-1041*r**14
            -7260*r**16+350*r**18)+Q2*(59-2264*r**2+11199*r**4+43444*r**6-1030498*r**8
            -1512924*r**10-2276906*r**12+338636*r**14-56409*r**16-7372*r**18+235*r**20))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(
            -6220800*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-259200*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -300*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4
            +14400*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*sqrtq2+2073600*logq2**3*r**14*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC**3*(5760*logq2**2*r**4*(20*Q2**7*(2
            +5*r**4)-8*Q2**6*(56+70*r**2+137*r**4+125*r**6)+Q2**5*(1278+2808*r**2
            +5511*r**4+6236*r**6+3675*r**8)-Q2**4*(1310+3674*r**2+9025*r**4+13293*r**6
            +11565*r**8+5525*r**10)+2*Q2**3*(10+858*r**2+2748*r**4+4516*r**6+5401*r**8
            +2730*r**10+925*r**12)+(-1+r**2)**2*(122+222*r**2+7521*r**4+14321*r**6
            +7246*r**8-1086*r**10-r**12+1175*r**14)+2*Q2**2*(450-432*r**2+2549*r**4
            +2364*r**6-687*r**8-2179*r**10+980*r**12+1875*r**14)-Q2*(602-596*r**2
            +17123*r**4+40792*r**6+43217*r**8+18200*r**10-3927*r**12-1356*r**14
            +4025*r**16))+8*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(460*Q2**13-16*Q2**12*(82
            +135*r**2)+Q2**11*(1529+4740*r**2+2815*r**4)+Q2**10*(1819-3033*r**2
            -6551*r**4+1485*r**6)-Q2**9*(23303+17090*r**2+115130*r**4+6710*r**6
            +5375*r**8)+Q2**8*(62417+40597*r**2+327980*r**4+552804*r**6+50555*r**8
            +255*r**10)+Q2**7*(-57754-28928*r**2-262978*r**4-974832*r**6-812682*r**8
            -74656*r**10+5670*r**12)-2*Q2**6*(11903-48025*r**2+142215*r**4-388557*r**6
            -706385*r**8-20297*r**10+995*r**12+615*r**14)+2*Q2**5*(42997-133354*r**2
            +970036*r**4+850926*r**6+851232*r**8-683938*r**10+495816*r**12+47086*r**14
            -2385*r**16)+Q2**4*(-50522+207550*r**2-3318940*r**4-4644060*r**6-7089020*r**8
            -8579388*r**10-8740*r**12-892740*r**14-60490*r**16+2750*r**18)+Q2**3*(
            -11727+89948*r**2+1125795*r**4+3085184*r**6+6539270*r**8+4213752*r**10
            +5518802*r**12+1736640*r**14+112201*r**16-21780*r**18+1035*r**20)+Q2**2*(24291
            -184457*r**2+2140933*r**4-3316247*r**6+66738*r**8-8819574*r**10-3668978*r**12
            +7653702*r**14-1290453*r**16+279487*r**18+30893*r**20-1135*r**22)+(
            -1+r**2)**2*(937+3615*r**2+431077*r**4-1573101*r**6+8535566*r**8+2653074*r**10
            -5607690*r**12+2405258*r**14+183561*r**16+53519*r**18-1051*r**20+35*r**22)
            +Q2*(-9023+61750*r**2-1974350*r**4+5447050*r**6-15554525*r**8-20228524*r**10
            -3778340*r**12+16573420*r**14-8765065*r**16+104310*r**18-210318*r**20
            -5750*r**22+165*r**24))+345600*logq2**3*r**8*(27+66*r**2+25*r**4+46*r**6)*sqrtq2
            +96*logq2*(8*Q2**10*(47+240*r**4)-40*Q2**9*(47+33*r**2+254*r**4+360*r**6)
            +5*Q2**8*(663+822*r**2+3147*r**4+11002*r**6+7530*r**8)-20*Q2**7*(78
            +311*r**2+197*r**4+3147*r**6+5189*r**8+1710*r**10)-20*Q2**6*(117-375*r**2
            +2667*r**4+739*r**6-2220*r**8-4132*r**10+1020*r**12)+4*Q2**5*(822-855*r**2
            +49350*r**4+99260*r**6+128770*r**8+87217*r**10+1010*r**12+15690*r**14)
            -10*Q2**4*(87+628*r**2+24775*r**4+70724*r**6+117149*r**8+150572*r**10
            +90983*r**12+10444*r**14+3510*r**16)-20*Q2**3*(42-387*r**2-1779*r**4
            -19931*r**6-42087*r**8-57495*r**10-46105*r**12-22757*r**14-6487*r**16
            +570*r**18)+(-1+r**2)**2*(11+592*r**2+30668*r**4-22346*r**6+715940*r**8
            +1405134*r**10-430102*r**12-161478*r**14+212161*r**16+20050*r**18+570*r**20)
            +20*Q2**2*(33-39*r**2+7809*r**4-8255*r**6+4379*r**8-15091*r**10-55217*r**12
            +5335*r**14+32452*r**16-1886*r**18+960*r**20)-20*Q2*(8+95*r**2+6056*r**4
            -7924*r**6+74172*r**8+189052*r**10+137992*r**12-51814*r**14-31044*r**16
            +35605*r**18+1712*r**20+330*r**22))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(-4665600*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-32400*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +13996800*logq2**4*r**16*sqrtq2+583200*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2+675*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)+((-691200*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(15+11*r**2)*(-Q2+(1+r)**2)+192*logq2*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-71-376*Q2**8-2467*r**2-44893*r**4
            -42159*r**6-164195*r**8-72149*r**10+40997*r**12+4023*r**14+114*r**16
            +4*Q2**7*(342+337*r**2)-Q2**6*(1283+3945*r**2+858*r**4)+Q2**5*(-874
            +4582*r**2+3202*r**4+266*r**6)+Q2**4*(2055+5195*r**2+24779*r**4+4445*r**6
            -2570*r**8)+4*Q2**3*(-161-3545*r**2-20444*r**4-19529*r**6-2385*r**8
            +564*r**10)+Q2**2*(-613+3617*r**2+30404*r**4+70334*r**6+3699*r**8-5923*r**10
            +1082*r**12)+Q2*(438+5850*r**2+40342*r**4-73690*r**6-62590*r**8-9058*r**10
            +6370*r**12-1262*r**14))-57600*logq2**2*r**10*(8*Q2**7-2*Q2**6*(40+31*r**2)
            +3*Q2**5*(78+125*r**2+55*r**4)-2*Q2**4*(131+287*r**2+259*r**4+83*r**6)
            +Q2**3*(28+287*r**2+327*r**4+195*r**6+55*r**8)+Q2**2*(180+21*r**2
            +344*r**4-32*r**6-144*r**8-57*r**10)-(-1+r**2)**2*(-34-131*r**2-572*r**4
            -224*r**6-22*r**8+47*r**10)+2*Q2*(-71-55*r**2-751*r**4-869*r**6-206*r**8
            +28*r**10+52*r**12))*sqrtq2-16*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -1+106*Q2**10+4478*r**2+53025*r**4+449632*r**6-390566*r**8+1472148*r**10
            -417338*r**12-37760*r**14-10617*r**16+206*r**18-7*r**20-47*Q2**9*(1
            +r**2)+Q2**8*(414+1464*r**2-702*r**4)+3*Q2**7*(-665-5717*r**2-1501*r**4
            +311*r**6)+3*Q2**6*(517+11104*r**2+8296*r**4+124*r**6+71*r**8)-3*Q2**5*(
            -405+2601*r**2+22548*r**4+4756*r**6-1643*r**8+183*r**10)+Q2**4*(-1233
            -46218*r**2+32691*r**4-53572*r**6+35565*r**8+3822*r**10-303*r**12)
            +Q2**3*(-369+46911*r**2+137493*r**4+590141*r**6+244325*r**8-25179*r**10
            -6849*r**12+327*r**14)+3*Q2**2*(105+2332*r**2-37722*r**4-125680*r**6
            -47576*r**8+21404*r**10-1838*r**12-664*r**14+39*r**16)-2*Q2*(-22+10971*r**2
            +2241*r**4+152179*r**6-355599*r**8-159423*r**10+76039*r**12-5931*r**14
            -1299*r**16+44*r**18))*sqrtq2)*math.log(mu0)*nlo.X1Q2(1,'SM',Q2,r))/(-2073600*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-86400*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-100*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+4800*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+691200*logq2**3*r**14*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+((3600*logq2**2*r**8*(15+22*r**2+15*r**4)+(Q2-(-1
            +r)**2)*(Q2-(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4+19308*r**6+138690*r**8
            +19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1+r**2)+Q2**6*(
            -89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4+79*r**6)+Q2**4*(165
            -1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4
            -2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2+1787*r**4-14228*r**6
            +1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2-2957*r**4+19165*r**6
            +19165*r**8-2957*r**10-635*r**12+27*r**14))+600*logq2*r**4*(1+2*Q2**5
            +35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17
            +42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2
            +66*r**4+30*r**6-11*r**8))*sqrtq2)*math.log(mus)*nlo.X1Q2(1,'SM',Q2,r))/(-20736*logq2**3*r**12
            -432*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+5184*logq2**2*r**8*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((691200*logq2**3*(-Q2+(-1+r)**2)*r**14*(15
            +11*r**2)*(-Q2+(1+r)**2)-192*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-71-376*Q2**8-2467*r**2-44893*r**4-42159*r**6-164195*r**8
            -72149*r**10+40997*r**12+4023*r**14+114*r**16+4*Q2**7*(342+337*r**2)
            -Q2**6*(1283+3945*r**2+858*r**4)+Q2**5*(-874+4582*r**2+3202*r**4+266*r**6)
            +Q2**4*(2055+5195*r**2+24779*r**4+4445*r**6-2570*r**8)+4*Q2**3*(-161
            -3545*r**2-20444*r**4-19529*r**6-2385*r**8+564*r**10)+Q2**2*(-613+3617*r**2
            +30404*r**4+70334*r**6+3699*r**8-5923*r**10+1082*r**12)+Q2*(438+5850*r**2
            +40342*r**4-73690*r**6-62590*r**8-9058*r**10+6370*r**12-1262*r**14))
            +57600*logq2**2*r**10*(8*Q2**7-2*Q2**6*(40+31*r**2)+3*Q2**5*(78+125*r**2
            +55*r**4)-2*Q2**4*(131+287*r**2+259*r**4+83*r**6)+Q2**3*(28+287*r**2
            +327*r**4+195*r**6+55*r**8)+Q2**2*(180+21*r**2+344*r**4-32*r**6-144*r**8
            -57*r**10)-(-1+r**2)**2*(-34-131*r**2-572*r**4-224*r**6-22*r**8+47*r**10)
            +2*Q2*(-71-55*r**2-751*r**4-869*r**6-206*r**8+28*r**10+52*r**12))*sqrtq2
            +16*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-1+106*Q2**10+4478*r**2
            +53025*r**4+449632*r**6-390566*r**8+1472148*r**10-417338*r**12-37760*r**14
            -10617*r**16+206*r**18-7*r**20-47*Q2**9*(1+r**2)+Q2**8*(414+1464*r**2
            -702*r**4)+3*Q2**7*(-665-5717*r**2-1501*r**4+311*r**6)+3*Q2**6*(517
            +11104*r**2+8296*r**4+124*r**6+71*r**8)-3*Q2**5*(-405+2601*r**2+22548*r**4
            +4756*r**6-1643*r**8+183*r**10)+Q2**4*(-1233-46218*r**2+32691*r**4
            -53572*r**6+35565*r**8+3822*r**10-303*r**12)+Q2**3*(-369+46911*r**2
            +137493*r**4+590141*r**6+244325*r**8-25179*r**10-6849*r**12+327*r**14)
            +3*Q2**2*(105+2332*r**2-37722*r**4-125680*r**6-47576*r**8+21404*r**10
            -1838*r**12-664*r**14+39*r**16)-2*Q2*(-22+10971*r**2+2241*r**4+152179*r**6
            -355599*r**8-159423*r**10+76039*r**12-5931*r**14-1299*r**16+44*r**18))*sqrtq2)*math.log(r)*nlo.X1Q2(1,'SM',Q2,r))/(
            -2073600*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-86400*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -100*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4
            +4800*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*sqrtq2+691200*logq2**3*r**14*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((
            -3600*logq2**2*r**8*(57+98*r**2+57*r**4)-(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(41
            +376*Q2**8-1068*r**2+10408*r**4+108924*r**6+526590*r**8+108924*r**10
            +10408*r**12-1068*r**14+41*r**16-648*Q2**7*(1+r**2)+Q2**6*(-367+770*r**2
            -367*r**4)+Q2**5*(754-2362*r**2-2362*r**4+754*r**6)+Q2**4*(495-3160*r**2
            -31054*r**4-3160*r**6+495*r**8)+Q2**3*(-556+7540*r**2+53496*r**4+53496*r**6
            +7540*r**8-556*r**10)+Q2**2*(-257+2818*r**2+17461*r**4-21724*r**6+17461*r**8
            +2818*r**10-257*r**12)+2*Q2*(81-1945*r**2-4591*r**4+70055*r**6+70055*r**8
            -4591*r**10-1945*r**12+81*r**14))+120*logq2*r**4*(17-20*Q2**5-701*r**2
            -5676*r**4-5676*r**6-701*r**8+17*r**10+232*Q2**4*(1+r**2)-Q2**3*(233
            +546*r**2+233*r**4)+Q2**2*(-133+145*r**2+145*r**4-133*r**6)+Q2*(137
            -570*r**2-1254*r**4-570*r**6+137*r**8))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r)*nlo.X1Q2(1,'SM',Q2,r))/(1036800*logq2**4*r**16
            +43200*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+50*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-345600*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-2400*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((-540*logq2*r**4*(1+r**2)+3*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r)**2)/(-8640*logq2**3*r**12-180*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+2160*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+5*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +(flagPERP*muWC**3*(-48*logq2*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(
            -10-11*r**2-36*Q2**4*r**2+14*r**4-1326*r**6-416*r**8+189*r**10+2*Q2**3*(
            -5+132*r**2+117*r**4)-Q2**2*(-10+191*r**2+524*r**4+171*r**6)-2*Q2*(
            -5+93*r**2+2*r**4-68*r**6+108*r**8))+1440*logq2**2*r**6*(-4+21*r**2
            +9*r**4)*sqrtq2+(-10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(-15+24*Q2**4-22*r**2
            -22*r**4-70*r**6+9*r**8-21*Q2**3*(1+r**2)+Q2**2*(-21+38*r**2-21*r**4)
            +Q2*(-15+29*r**2-43*r**4+9*r**6))+12*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(
            -3+5*Q2**3+5*r**2-19*r**4+5*r**6-5*Q2**2*(1+r**2)+Q2*(-5+8*r**2
            -5*r**4))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8)))*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(19440*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+45*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-77760*logq2**3*r**12*sqrtq2
            -1620*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((-34560*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(2+r**2)*(-Q2+(1+r)**2)-16*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(-17*Q2**6-4*Q2**5*(1+r**2)+Q2**4*(-57-182*r**2
            +75*r**4)+Q2**3*(128+964*r**2+316*r**4-40*r**6)+Q2**2*(13-424*r**2
            +258*r**4+224*r**6-35*r**8)+12*Q2*(-5-28*r**2+149*r**4+77*r**6-14*r**8
            +r**10)+3*(-1+314*r**2+377*r**4+1852*r**6-323*r**8-62*r**10+3*r**12))
            +384*logq2*r**6*(16*Q2**6-61*Q2**5*(1+r**2)+Q2**4*(75+103*r**2+60*r**4)
            -2*Q2**3*(5+31*r**2+16*r**4+5*r**6)+9*(-1+r**2)**2*(-1-11*r**2-41*r**4
            -11*r**6+4*r**8)+Q2**2*(-50-22*r**2-216*r**4+68*r**6+40*r**8)+Q2*(39
            +123*r**2+1008*r**4+978*r**6+93*r**8-81*r**10))*sqrtq2)/(34560*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+720*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-20*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-8640*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC*(138240*logq2**2*(-Q2+(-1+r)**2)*r**10*(5+4*r**2)*(
            -Q2+(1+r)**2)+64*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(48*Q2**7
            -Q2**6*(73+90*r**2)-4*Q2**5*(11-25*r**2+12*r**4)+4*Q2**3*(10-37*r**2
            -397*r**4+10*r**6)+5*Q2**4*(15-56*r**2-81*r**4+30*r**6)+Q2**2*(-43
            +514*r**2+2034*r**4+2716*r**6+725*r**8-78*r**10)-12*Q2*(1-8*r**2
            -151*r**4-127*r**6-256*r**8+r**10)+3*(3-64*r**2+305*r**4+2606*r**6
            +4081*r**8-332*r**10-125*r**12+6*r**14))-1536*logq2*r**6*(8*Q2**6+37*Q2**5*(1
            +r**2)-Q2**4*(150+331*r**2+165*r**4)+2*Q2**3*(65+82*r**2+97*r**4+65*r**6)
            +9*(-1+r**2)**2*(2-33*r**2-123*r**4-33*r**6+7*r**8)+2*Q2**2*(10-28*r**2
            -324*r**4+17*r**6+55*r**8)+3*Q2*(-21+173*r**2+958*r**4+948*r**6+163*r**8
            -61*r**10))*sqrtq2))/(103680*logq2**3*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))+2160*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2-60*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2-25920*logq2**2*r**10*(Q2**5-3*Q2**4*(1+r**2)
            +2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1
            -2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)
            +(muWC**2*(17280*logq2**2*(-Q2+(-1+r)**2)*r**10*(5+4*r**2)*(-Q2+(1+r)**2)
            +8*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(48*Q2**7-Q2**6*(73+90*r**2)
            -4*Q2**5*(11-25*r**2+12*r**4)+4*Q2**3*(10-37*r**2-397*r**4+10*r**6)
            +5*Q2**4*(15-56*r**2-81*r**4+30*r**6)+Q2**2*(-43+514*r**2+2034*r**4
            +2716*r**6+725*r**8-78*r**10)-12*Q2*(1-8*r**2-151*r**4-127*r**6-256*r**8
            +r**10)+3*(3-64*r**2+305*r**4+2606*r**6+4081*r**8-332*r**10-125*r**12
            +6*r**14))-192*logq2*r**6*(8*Q2**6+37*Q2**5*(1+r**2)-Q2**4*(150+331*r**2
            +165*r**4)+2*Q2**3*(65+82*r**2+97*r**4+65*r**6)+9*(-1+r**2)**2*(2
            -33*r**2-123*r**4-33*r**6+7*r**8)+2*Q2**2*(10-28*r**2-324*r**4+17*r**6
            +55*r**8)+3*Q2*(-21+173*r**2+958*r**4+948*r**6+163*r**8-61*r**10))*sqrtq2))/(34560*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+720*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-20*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-8640*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC**3*(-96*logq2*(24*Q2**6*(2+5*r**4)-Q2**5*(168
            +133*r**2+540*r**4+795*r**6)-2*Q2**3*r**2*(73+268*r**2+570*r**4+590*r**6
            +375*r**8)+Q2**4*(180+159*r**2+645*r**4+1825*r**6+1575*r**8)-(-1
            +r**2)**2*(12+37*r**2+2117*r**4+3922*r**6-558*r**8-415*r**10+405*r**12)
            -2*Q2**2*(60-167*r**2+799*r**4+538*r**6-700*r**8-135*r**10+525*r**12)
            +Q2*(72-201*r**2+4924*r**4+10719*r**6+7964*r**8-1103*r**10-1600*r**12
            +1305*r**14))+5760*logq2**2*r**4*(12+19*r**2+15*r**4)*sqrtq2-8*(120*Q2**9
            -3*Q2**8*(87+155*r**2)+Q2**7*(258+596*r**2+450*r**4)+Q2**6*(420-514*r**2
            -808*r**4+390*r**6)-6*Q2**5*(441+230*r**2+1306*r**4-98*r**6+145*r**8)
            +2*Q2**4*(1905+622*r**2+6030*r**4+13410*r**6+955*r**8+90*r**10)+2*Q2**3*(
            -477-362*r**2-6203*r**4-3468*r**6-8555*r**8-1802*r**10+195*r**12)
            -6*Q2**2*(378-1147*r**2+1784*r**4-3549*r**6-2410*r**8+3143*r**10-64*r**12
            +25*r**14)+(-1+r**2)**2*(-549+3179*r**2-33609*r**4-12869*r**6+18541*r**8
            -6915*r**10-943*r**12+45*r**14)+Q2*(2070-9916*r**2+66480*r**4+75468*r**6
            +27908*r**8-53892*r**10+22224*r**12+2228*r**14-90*r**16))*sqrtq2))/(58320*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+135*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-233280*logq2**3*r**12*sqrtq2
            -4860*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((-51840*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(2+r**2)*(-Q2+(1+r)**2)-24*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(-17*Q2**6-4*Q2**5*(1+r**2)+Q2**4*(-57-182*r**2
            +75*r**4)+Q2**3*(128+964*r**2+316*r**4-40*r**6)+Q2**2*(13-424*r**2
            +258*r**4+224*r**6-35*r**8)+12*Q2*(-5-28*r**2+149*r**4+77*r**6-14*r**8
            +r**10)+3*(-1+314*r**2+377*r**4+1852*r**6-323*r**8-62*r**10+3*r**12))
            +576*logq2*r**6*(16*Q2**6-61*Q2**5*(1+r**2)+Q2**4*(75+103*r**2+60*r**4)
            -2*Q2**3*(5+31*r**2+16*r**4+5*r**6)+9*(-1+r**2)**2*(-1-11*r**2-41*r**4
            -11*r**6+4*r**8)+Q2**2*(-50-22*r**2-216*r**4+68*r**6+40*r**8)+Q2*(39
            +123*r**2+1008*r**4+978*r**6+93*r**8-81*r**10))*sqrtq2)*math.log(mu0))/(34560*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+720*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-20*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-8640*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+((900*logq2*r**4*(1+r**2)-5*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2)*math.log(mus))/(576*logq2**2*r**8+4*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-96*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((51840*logq2**2*(-Q2+(-1+r)**2)*r**10*(2
            +r**2)*(-Q2+(1+r)**2)+24*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -17*Q2**6-4*Q2**5*(1+r**2)+Q2**4*(-57-182*r**2+75*r**4)+Q2**3*(128
            +964*r**2+316*r**4-40*r**6)+Q2**2*(13-424*r**2+258*r**4+224*r**6-35*r**8)
            +12*Q2*(-5-28*r**2+149*r**4+77*r**6-14*r**8+r**10)+3*(-1+314*r**2
            +377*r**4+1852*r**6-323*r**8-62*r**10+3*r**12))-576*logq2*r**6*(16*Q2**6
            -61*Q2**5*(1+r**2)+Q2**4*(75+103*r**2+60*r**4)-2*Q2**3*(5+31*r**2
            +16*r**4+5*r**6)+9*(-1+r**2)**2*(-1-11*r**2-41*r**4-11*r**6+4*r**8)
            +Q2**2*(-50-22*r**2-216*r**4+68*r**6+40*r**8)+Q2*(39+123*r**2+1008*r**4
            +978*r**6+93*r**8-81*r**10))*sqrtq2)*math.log(r))/(34560*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+720*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-20*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-8640*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2))*nlo.X1Q2(2,'SM',Q2,r)+((-540*logq2*r**4*(1+r**2)+3*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r)*nlo.X1Q2(2,'SM',Q2,r))/(
            -8640*logq2**3*r**12-180*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+2160*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+5*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)-(3*nlo.X1Q2(1,'SM',Q2,r)*nlo.X1Q2(2,'SM',Q2,r))/(144*logq2**2*r**8
            +(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-24*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(flagPERP*muWC**3*(-4*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(-3+5*Q2**3+5*r**2-19*r**4+5*r**6-5*Q2**2*(1
            +r**2)+Q2*(-5+8*r**2-5*r**4))+48*logq2*r**4*sqrtq2)*nlo.X1Q2(3,'SM',Q2,r))/(
            -216*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+1296*logq2**2*r**8*sqrtq2
            +9*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((muWC**3*(16*(5*Q2**5-Q2**4*(7
            +15*r**2)+2*Q2**3*(4+2*r**2+5*r**4)+(-1+r**2)**2*(17+r**2-11*r**4
            +5*r**6)+2*Q2**2*(7-6*r**2-4*r**4+5*r**6)-Q2*(37+20*r**2+8*r**4
            -32*r**6+15*r**8))+192*logq2*sqrtq2))/(-648*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+3888*logq2**2*r**8*sqrtq2+27*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)
            +(-768*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)+64*r**4*(-Q2**4+Q2**3*(1
            +r**2)+2*(-1+r**2)**2*(-2-5*r**2+r**4)+Q2**2*(-3-4*r**2+3*r**4)+Q2*(7
            +29*r**2+17*r**4-5*r**6))*sqrtq2)/(-1728*logq2**2*r**10*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))-12*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+288*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC**2*(960*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)-16*r**2*(7*Q2**5-Q2**4*(19+21*r**2)
            +2*Q2**3*(6+6*r**2+7*r**4)+(-1+r**2)**2*(3-29*r**2-41*r**4+7*r**6)
            +2*Q2**2*(4-10*r**2-11*r**4+7*r**6)+Q2*(-11+64*r**2+124*r**4+84*r**6
            -21*r**8))*sqrtq2))/(-1728*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))
            -12*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            +288*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1
            +r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(
            -3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC*(7680*logq2*(-Q2
            +(-1+r)**2)*r**6*(-Q2+(1+r)**2)-128*r**2*(7*Q2**5-Q2**4*(19+21*r**2)
            +2*Q2**3*(6+6*r**2+7*r**4)+(-1+r**2)**2*(3-29*r**2-41*r**4+7*r**6)
            +2*Q2**2*(4-10*r**2-11*r**4+7*r**6)+Q2*(-11+64*r**2+124*r**4+84*r**6
            -21*r**8))*sqrtq2))/(-5184*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))
            -36*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            +864*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1
            +r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(
            -3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((-384*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)+32*r**4*(-Q2**4+Q2**3*(1+r**2)+2*(-1+r**2)**2*(
            -2-5*r**2+r**4)+Q2**2*(-3-4*r**2+3*r**4)+Q2*(7+29*r**2+17*r**4
            -5*r**6))*sqrtq2)*math.log(mu0))/(-576*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))-4*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+96*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(25*math.log(mus))/(-72*logq2*r**4
            +6*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)
            +((384*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)-32*r**4*(-Q2**4+Q2**3*(1
            +r**2)+2*(-1+r**2)**2*(-2-5*r**2+r**4)+Q2**2*(-3-4*r**2+3*r**4)+Q2*(7
            +29*r**2+17*r**4-5*r**6))*sqrtq2)*math.log(r))/(-576*logq2**2*r**10*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))-4*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+96*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2))*nlo.X1Q2(3,'SM',Q2,r)
            -(nlo.X1Q2(0,'SM',Q2,r)*nlo.X1Q2(3,'SM',Q2,r))/(144*logq2**2*r**8+(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-24*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((1512000*logq2**3*r**12*(1+r**2)*(19
            +10*r**2+19*r**4)+60*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(23
            -1440*Q2**9+10999*r**2+228160*r**4+383296*r**6+3006322*r**8+3006322*r**10
            +383296*r**12+228160*r**14+10999*r**16+23*r**18+10248*Q2**8*(1+r**2)
            -512*Q2**7*(37+94*r**2+37*r**4)+Q2**6*(4319+70769*r**2+70769*r**4+4319*r**6)
            +2*Q2**5*(8631-19072*r**2-30126*r**4-19072*r**6+8631*r**8)-Q2**4*(11375
            +66235*r**2+466262*r**4+466262*r**6+66235*r**8+11375*r**10)-4*Q2**3*(847
            -28698*r**2-220767*r**4-429164*r**6-220767*r**8-28698*r**10+847*r**12)
            +Q2**2*(3729-4117*r**2-37563*r**4-1070849*r**6-1070849*r**8-37563*r**10
            -4117*r**12+3729*r**14)-2*Q2*(217+25092*r**2+198688*r**4-394052*r**6
            -869490*r**8-394052*r**10+198688*r**12+25092*r**14+217*r**16))+3600*logq2**2*r**8*(781
            -80*Q2**6+4344*r**2+33555*r**4+43600*r**6+33555*r**8+4344*r**10+781*r**12
            +900*Q2**5*(1+r**2)-4*Q2**4*(951+1718*r**2+951*r**4)+Q2**3*(3931+13189*r**2
            +13189*r**4+3931*r**6)+Q2**2*(1131-5648*r**2-11126*r**4-5648*r**6+1131*r**8)
            -3*Q2*(953-829*r**2-3484*r**4-3484*r**6-829*r**8+953*r**10))*sqrtq2
            +(-250*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4
            -2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2
            -6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4
            -26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6-31*r**8+r**10))+7*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6-28170*r**8+31692*r**10
            -9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)+Q2**6*(-11+10*r**2
            -11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)+Q2**4*(-165+1480*r**2
            +10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2-6138*r**4-6138*r**6
            -355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4+35188*r**6+10313*r**8
            -406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4+6605*r**6+6605*r**8
            -7237*r**10-595*r**12+27*r**14)))*sqrtq2)*nnlo.X2Q2(0,Q2,r))/(72576000*logq2**4*r**16
            +3024000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+3500*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-24192000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-168000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((3600*logq2**2*r**8*(15+22*r**2+15*r**4)+(Q2-(-1+r)**2)*(Q2-(1
            +r)**2)*(7+92*Q2**8-156*r**2+5096*r**4+19308*r**6+138690*r**8+19308*r**10
            +5096*r**12-156*r**14+7*r**16-156*Q2**7*(1+r**2)+Q2**6*(-89+190*r**2
            -89*r**4)+2*Q2**5*(79-247*r**2-247*r**4+79*r**6)+Q2**4*(165-1160*r**2
            -10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4-2439*r**6
            -280*r**8+19*r**10)+Q2**2*(-79+806*r**2+1787*r**4-14228*r**6+1787*r**8
            +806*r**10-79*r**12)+2*Q2*(27-635*r**2-2957*r**4+19165*r**6+19165*r**8
            -2957*r**10-635*r**12+27*r**14))+600*logq2*r**4*(1+2*Q2**5+35*r**2
            +276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17+42*r**2
            +17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2+66*r**4
            +30*r**6-11*r**8))*sqrtq2)*nnlo.X2Q2(1,Q2,r))/(-86400*logq2**3*r**12-1800*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+21600*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+50*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((540*logq2*r**4*(1+r**2)-3*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*sqrtq2)*nnlo.X2Q2(2,Q2,r))/(1440*logq2**2*r**8+10*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2-240*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))*sqrtq2)+nnlo.X2Q2(3,Q2,r)/(-12*logq2*r**4+(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))
        if( flagDEBUG == 1):
            print("Q2moment n. 3 NNLO = api^2*",resNNLO*par.mbkin**6)
        res += api**2*resNNLO

    if((kwargs.get('flag_includeNNLO', 1) == 1) and (kwargs.get('flag_includeNLOpw', 1) == 1)):
        resNNLO = 0
        resNNLO +=(FLAGcD*flagPERP*muWC**3*((172800*logq2**3*(-Q2+(-1+r)**2)*r**10*(-Q2+(1
            +r)**2)*(301-1584*r**2-240*Q2**6*r**2+5717*r**4-6176*r**6+8279*r**8
            -72*r**10-1017*r**12+1272*r**14+20*Q2**5*(7+51*r**2+72*r**4)-4*Q2**4*(196
            +445*r**2+1206*r**4+837*r**6)+Q2**3*(1001+2581*r**2+5141*r**4+8403*r**6
            +3162*r**8)+Q2**2*(91-2396*r**2-1418*r**4-5364*r**6-6801*r**8+432*r**10)
            +Q2*(-749+2609*r**2-3480*r**4-158*r**6+3027*r**8+2589*r**10-2718*r**12))
            +48*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(-2345-4786*r**2
            -4656*Q2**12*r**2-227548*r**4+481994*r**6+1802615*r**8-49508100*r**10
            +129325752*r**12-64400404*r**14-24624243*r**16+36020510*r**18-7593180*r**20
            +2793034*r**22+119077*r**24+9624*r**26+4*Q2**11*(-805+12483*r**2+10068*r**4)
            -4*Q2**10*(-4270+40169*r**2+101692*r**4+31629*r**6)+5*Q2**9*(-5705+35759*r**2
            +230039*r**4+218089*r**6+30234*r**8)+5*Q2**8*(-525+8796*r**2-146250*r**4
            -109268*r**6-153705*r**8+11736*r**10)-4*Q2**7*(-15225+43362*r**2+391830*r**4
            +2489570*r**6+2227745*r**8+377580*r**10+82962*r**12)+2*Q2**6*(-27930
            -43407*r**2+1131663*r**4+11081830*r**6+22772900*r**8+9808525*r**10+1462503*r**12
            +123228*r**14)+2*Q2**5*(-9555+140781*r**2-32367*r**4-4813089*r**6-29472945*r**8
            -31808175*r**10-3300179*r**12-377517*r**14+60246*r**16)-10*Q2**4*(-5565
            +7257*r**2+73677*r**4+1239897*r**6+13677*r**8-4040437*r**10-1987573*r**12
            +2016227*r**14+189432*r**16+25632*r**18)+20*Q2**3*(-1050-6669*r**2-15750*r**4
            +487512*r**6+1874250*r**8+2580692*r**10+822492*r**12+1358960*r**14+999352*r**16
            +75105*r**18+4146*r**20)+2*Q2**2*(-5950+43977*r**2+67185*r**4+926990*r**6
            -6384960*r**8-19560330*r**10-42812974*r**12+391620*r**14-15779010*r**16
            +594465*r**18+36285*r**20+28302*r**22)-Q2*(-10955+5893*r**2-461227*r**4
            +2684035*r**6+5334100*r**8-7411850*r**10+19731094*r**12-69809126*r**14
            +49679065*r**16-20660475*r**18+8352405*r**20+424163*r**22+46878*r**24))
            +72576000*logq2**4*r**14*(3-5*r**2+3*r**4+3*r**6)*sqrtq2+2880*logq2**2*r**6*(
            -4320*Q2**11*r**2+8*Q2**10*(-7+5007*r**2+4986*r**4)-40*Q2**9*(-49+3857*r**2
            +7613*r**4+3759*r**6)+5*Q2**8*(-1785+59477*r**2+182793*r**4+184359*r**6
            +55980*r**8)-20*Q2**7*(-693+13253*r**2+62918*r**4+96754*r**6+66735*r**8
            +10305*r**10)-10*Q2**6*r**2*(203-53651*r**2-117893*r**4-127639*r**6-74214*r**8
            +14490*r**10)+2*Q2**5*(-12054+112469*r**2+304767*r**4+680760*r**6+961880*r**8
            +607101*r**10+176799*r**12+206262*r**14)-10*Q2**4*(-2499+18097*r**2
            +84256*r**4+244614*r**6+424315*r**8+462877*r**10+217370*r**12+75348*r**14
            +27414*r**16)-20*Q2**3*(105-212*r**2-14014*r**4-73778*r**6-81299*r**8
            -182225*r**10-173800*r**12-14564*r**14-25104*r**16+1755*r**18)+(-1
            +r**2)**2*(-1561+9259*r**2+17902*r**4-417650*r**6+974908*r**8-198572*r**10
            +237346*r**12-321422*r**14+301405*r**16-10303*r**18+13488*r**20)+10*Q2**2*(
            -1176+8281*r**2+7383*r**4-111243*r**6+173905*r**8-7005*r**10-34557*r**12
            -191033*r**14+148275*r**16-27480*r**18+14490*r**20)-10*Q2*(-770+5515*r**2
            +4639*r**4-115040*r**6+228502*r**8-24740*r**10+66736*r**12+144310*r**14
            -185396*r**16+125097*r**18-14511*r**20+7578*r**22))*sqrtq2-8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(279+51832*r**2+176*Q2**13*r**2-369279*r**4
            +4247926*r**6-14274463*r**8+27526342*r**10+129617771*r**12-553885372*r**14
            +660388553*r**16-367966084*r**18+98308279*r**20-19691578*r**22-449*r**24
            -240954*r**26-803*r**28+Q2**12*(-771+3063*r**2+750*r**4)-164*Q2**11*(
            -33+128*r**2+1019*r**4+62*r**6)+Q2**10*(-15111-9033*r**2+1230491*r**4
            +1032041*r**6+31932*r**8)-5*Q2**9*(-3879-36553*r**2+548994*r**4+1328318*r**6
            +448293*r**8+7979*r**10)+3*Q2**8*(-1965-51364*r**2+421575*r**4+3601030*r**6
            +3697755*r**8+297990*r**10+691*r**12)+2*Q2**7*(-6534-250623*r**2+1616565*r**4
            +1573020*r**6+4328420*r**8+225321*r**10+1865997*r**12+23610*r**14)-6*Q2**6*(
            -2121-155674*r**2+639433*r**4+3196174*r**6+14532525*r**8+12173384*r**10
            +3212001*r**12+870548*r**14+6754*r**16)+2*Q2**5*(1341-77562*r**2-628581*r**4
            +4567029*r**6+42074003*r**8+109470491*r**10+33108893*r**12+7934379*r**14
            +18744*r**16-3777*r**18)+5*Q2**4*(-1809-150223*r**2+876924*r**4+169908*r**6
            +7909498*r**8-20693230*r**10-36952648*r**12+12121444*r**14+636303*r**16
            +858453*r**18+5444*r**20)-2*Q2**3*(-1560-259383*r**2+945675*r**4-2691330*r**6
            +34366420*r**8+42739050*r**10+22169566*r**12-21456000*r**14+54405220*r**16
            +4550445*r**18+1210935*r**20+4962*r**22)+Q2**2*(1689+97333*r**2-1232405*r**4
            -268865*r**6-2372290*r**8+41581502*r**10+204873794*r**12-9518230*r**14
            +80995985*r**16+10862285*r**18+3461779*r**20-676457*r**22-4520*r**24)
            +Q2*(-1413-196377*r**2+1385164*r**4-8497688*r**6+31338675*r**8-29081629*r**10
            +114936104*r**12-332908368*r**14+324732521*r**16-173777275*r**18+47143692*r**20
            -249752*r**22+980329*r**24+4017*r**26))*sqrtq2)/(-108864000*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-756000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +326592000*logq2**4*r**16*sqrtq2+13608000*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*sqrtq2+15750*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)+((-345600*logq2**3*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(301-1584*r**2-240*Q2**6*r**2
            +5717*r**4-6176*r**6+8279*r**8-72*r**10-1017*r**12+1272*r**14+20*Q2**5*(7
            +51*r**2+72*r**4)-4*Q2**4*(196+445*r**2+1206*r**4+837*r**6)+Q2**3*(1001
            +2581*r**2+5141*r**4+8403*r**6+3162*r**8)+Q2**2*(91-2396*r**2-1418*r**4
            -5364*r**6-6801*r**8+432*r**10)+Q2*(-749+2609*r**2-3480*r**4-158*r**6
            +3027*r**8+2589*r**10-2718*r**12))-96*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2
            -(1+r)**2)**2*(-2345-4786*r**2-4656*Q2**12*r**2-227548*r**4+481994*r**6
            +1802615*r**8-49508100*r**10+129325752*r**12-64400404*r**14-24624243*r**16
            +36020510*r**18-7593180*r**20+2793034*r**22+119077*r**24+9624*r**26
            +4*Q2**11*(-805+12483*r**2+10068*r**4)-4*Q2**10*(-4270+40169*r**2+101692*r**4
            +31629*r**6)+5*Q2**9*(-5705+35759*r**2+230039*r**4+218089*r**6+30234*r**8)
            +5*Q2**8*(-525+8796*r**2-146250*r**4-109268*r**6-153705*r**8+11736*r**10)
            -4*Q2**7*(-15225+43362*r**2+391830*r**4+2489570*r**6+2227745*r**8+377580*r**10
            +82962*r**12)+2*Q2**6*(-27930-43407*r**2+1131663*r**4+11081830*r**6
            +22772900*r**8+9808525*r**10+1462503*r**12+123228*r**14)+2*Q2**5*(-9555
            +140781*r**2-32367*r**4-4813089*r**6-29472945*r**8-31808175*r**10-3300179*r**12
            -377517*r**14+60246*r**16)-10*Q2**4*(-5565+7257*r**2+73677*r**4+1239897*r**6
            +13677*r**8-4040437*r**10-1987573*r**12+2016227*r**14+189432*r**16+25632*r**18)
            +20*Q2**3*(-1050-6669*r**2-15750*r**4+487512*r**6+1874250*r**8+2580692*r**10
            +822492*r**12+1358960*r**14+999352*r**16+75105*r**18+4146*r**20)+2*Q2**2*(
            -5950+43977*r**2+67185*r**4+926990*r**6-6384960*r**8-19560330*r**10
            -42812974*r**12+391620*r**14-15779010*r**16+594465*r**18+36285*r**20
            +28302*r**22)-Q2*(-10955+5893*r**2-461227*r**4+2684035*r**6+5334100*r**8
            -7411850*r**10+19731094*r**12-69809126*r**14+49679065*r**16-20660475*r**18
            +8352405*r**20+424163*r**22+46878*r**24))-145152000*logq2**4*r**14*(3
            -5*r**2+3*r**4+3*r**6)*sqrtq2+5760*logq2**2*r**6*(4320*Q2**11*r**2-8*Q2**10*(
            -7+5007*r**2+4986*r**4)+40*Q2**9*(-49+3857*r**2+7613*r**4+3759*r**6)
            -5*Q2**8*(-1785+59477*r**2+182793*r**4+184359*r**6+55980*r**8)+20*Q2**7*(
            -693+13253*r**2+62918*r**4+96754*r**6+66735*r**8+10305*r**10)+10*Q2**6*r**2*(203
            -53651*r**2-117893*r**4-127639*r**6-74214*r**8+14490*r**10)-2*Q2**5*(
            -12054+112469*r**2+304767*r**4+680760*r**6+961880*r**8+607101*r**10
            +176799*r**12+206262*r**14)+10*Q2**4*(-2499+18097*r**2+84256*r**4+244614*r**6
            +424315*r**8+462877*r**10+217370*r**12+75348*r**14+27414*r**16)+20*Q2**3*(105
            -212*r**2-14014*r**4-73778*r**6-81299*r**8-182225*r**10-173800*r**12
            -14564*r**14-25104*r**16+1755*r**18)-(-1+r**2)**2*(-1561+9259*r**2
            +17902*r**4-417650*r**6+974908*r**8-198572*r**10+237346*r**12-321422*r**14
            +301405*r**16-10303*r**18+13488*r**20)-10*Q2**2*(-1176+8281*r**2+7383*r**4
            -111243*r**6+173905*r**8-7005*r**10-34557*r**12-191033*r**14+148275*r**16
            -27480*r**18+14490*r**20)+10*Q2*(-770+5515*r**2+4639*r**4-115040*r**6
            +228502*r**8-24740*r**10+66736*r**12+144310*r**14-185396*r**16+125097*r**18
            -14511*r**20+7578*r**22))*sqrtq2+16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(279
            +51832*r**2+176*Q2**13*r**2-369279*r**4+4247926*r**6-14274463*r**8+27526342*r**10
            +129617771*r**12-553885372*r**14+660388553*r**16-367966084*r**18+98308279*r**20
            -19691578*r**22-449*r**24-240954*r**26-803*r**28+Q2**12*(-771+3063*r**2
            +750*r**4)-164*Q2**11*(-33+128*r**2+1019*r**4+62*r**6)+Q2**10*(-15111
            -9033*r**2+1230491*r**4+1032041*r**6+31932*r**8)-5*Q2**9*(-3879-36553*r**2
            +548994*r**4+1328318*r**6+448293*r**8+7979*r**10)+3*Q2**8*(-1965-51364*r**2
            +421575*r**4+3601030*r**6+3697755*r**8+297990*r**10+691*r**12)+2*Q2**7*(
            -6534-250623*r**2+1616565*r**4+1573020*r**6+4328420*r**8+225321*r**10
            +1865997*r**12+23610*r**14)-6*Q2**6*(-2121-155674*r**2+639433*r**4+3196174*r**6
            +14532525*r**8+12173384*r**10+3212001*r**12+870548*r**14+6754*r**16)
            +2*Q2**5*(1341-77562*r**2-628581*r**4+4567029*r**6+42074003*r**8+109470491*r**10
            +33108893*r**12+7934379*r**14+18744*r**16-3777*r**18)+5*Q2**4*(-1809
            -150223*r**2+876924*r**4+169908*r**6+7909498*r**8-20693230*r**10-36952648*r**12
            +12121444*r**14+636303*r**16+858453*r**18+5444*r**20)-2*Q2**3*(-1560
            -259383*r**2+945675*r**4-2691330*r**6+34366420*r**8+42739050*r**10+22169566*r**12
            -21456000*r**14+54405220*r**16+4550445*r**18+1210935*r**20+4962*r**22)
            +Q2**2*(1689+97333*r**2-1232405*r**4-268865*r**6-2372290*r**8+41581502*r**10
            +204873794*r**12-9518230*r**14+80995985*r**16+10862285*r**18+3461779*r**20
            -676457*r**22-4520*r**24)+Q2*(-1413-196377*r**2+1385164*r**4-8497688*r**6
            +31338675*r**8-29081629*r**10+114936104*r**12-332908368*r**14+324732521*r**16
            -173777275*r**18+47143692*r**20-249752*r**22+980329*r**24+4017*r**26))*sqrtq2)*math.log(murhoD))/(
            -58786560*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-408240*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+176359680*logq2**4*r**16*sqrtq2+7348320*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2+8505*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2))
            +FLAGcD*muWC**3*((-86400*logq2**3*r**8*(-240*Q2**8*(1+5*r**4)+20*Q2**7*(117
            +166*r**2+501*r**4+480*r**6)-4*Q2**6*(2415+5900*r**2+10136*r**4+14688*r**6
            +8085*r**8)+Q2**5*(19425+64530*r**2+93454*r**4+122436*r**6+133377*r**8
            +56490*r**10)-Q2**4*(17325+75505*r**2+111190*r**4+115462*r**6+146261*r**8
            +133785*r**10+46200*r**12)+Q2**3*(-210+29530*r**2+62170*r**4+36808*r**6
            +70082*r**8+98834*r**10+33270*r**12-2100*r**14)+(-1+r**2)**2*(2175
            +355*r**2-4569*r**4+39419*r**6+18349*r**8+115649*r**10-35691*r**12
            +5793*r**14+6360*r**16)+2*Q2**2*(6405+1710*r**2-17795*r**4+18194*r**6
            +29*r**8+40550*r**10-56313*r**12+14010*r**14+17850*r**16)-Q2*(9315
            -2300*r**2-25984*r**4+128230*r**6+56718*r**8+228638*r**10+286248*r**12
            -121038*r**14+5223*r**16+26310*r**18))+24*logq2*(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(4656*Q2**14*(1+5*r**4)-4*Q2**13*(9981+4346*r**2+38205*r**4
            +61980*r**6)+4*Q2**12*(35289+31746*r**2-3186*r**4+392890*r**6+264645*r**8)
            -Q2**11*(246759+384626*r**2-2256934*r**4+587244*r**6+5876815*r**8+2222370*r**10)
            +Q2**10*(155661+594681*r**2-8831714*r**4-13613034*r**6-7003739*r**8
            +8957825*r**10+1850880*r**12)+Q2**9*(185163-401150*r**2+21101265*r**4
            +55561850*r**6+91934525*r**8+68897718*r**10+939175*r**12+1490190*r**14)
            -Q2**8*(427977+170877*r**2+34467885*r**4+141383925*r**6+309486275*r**8
            +391317767*r**10+205760327*r**12+22704135*r**14+4844160*r**16)+Q2**7*(243738
            +632892*r**2+27746208*r**4+216896700*r**6+571666860*r**8+909856288*r**10
            +774178672*r**12+248138668*r**14+29796330*r**16+3521340*r**18)+2*Q2**6*(68409
            -318579*r**2+7216116*r**4-73107126*r**6-189303760*r**8-437701626*r**10
            -485681424*r**12-303122814*r**14+1309859*r**16-3843135*r**18+627120*r**20)
            -2*Q2**5*(130911-142854*r**2+27383571*r**4+15435336*r**6+182291046*r**8
            +165362706*r**10+80090386*r**12+79355246*r**14+52021411*r**16+162885196*r**18
            +8394675*r**20+1790130*r**22)+2*Q2**4*(54153+49975*r**2+21185265*r**4
            +52066275*r**6+329756050*r**8+567660684*r**10+603473600*r**12+564545620*r**14
            +392790475*r**16+229278725*r**18+152733063*r**20+8436225*r**22+913890*r**24)
            +Q2**3*(35901-262314*r**2+1570530*r**4-68997280*r**6-109705125*r**8
            -634573542*r**10-618767172*r**12-988466560*r**14-589938125*r**16-4908950*r**18
            -329195934*r**20-22813664*r**22-3502795*r**24+385830*r**26)-(-1+r**2)**2*(2589
            -4733*r**2+2241614*r**4-5780470*r**6+73049315*r**8-233520403*r**10-35002404*r**12
            +1228727532*r**14-742870045*r**16+129396765*r**18+122562014*r**20-23266038*r**22
            +16198429*r**24+441715*r**26+48120*r**28)-Q2**2*(51519-191549*r**2+21023614*r**4
            -48309390*r**6+383527965*r**8-515789363*r**10+29328068*r**12+329218412*r**14
            -1181695175*r**16-132837235*r**18+696010894*r**20-243046494*r**22+126648299*r**24
            +3036515*r**26+799920*r**28)+Q2*(19191-68166*r**2+12008609*r**4-34826154*r**6
            +321469335*r**8-789979722*r**10+85768417*r**12+1505869722*r**14+1701505453*r**16
            -981466970*r**18-175522149*r**20+583848074*r**22-180867131*r**24+78850026*r**26
            +1956835*r**28+330630*r**30))-36288000*logq2**4*r**12*(9+12*r**2-26*r**4
            +84*r**6+9*r**8)*sqrtq2-1440*logq2**2*r**4*(-4320*Q2**11*(1+5*r**4)+8*Q2**10*(4965
            +4916*r**2+20601*r**4+24930*r**6)-40*Q2**9*(3612+7217*r**2+19493*r**4
            +31427*r**6+18795*r**8)+5*Q2**8*(50625+163440*r**2+459434*r**4+829380*r**6
            +751365*r**8+279900*r**10)-20*Q2**7*(8226+54837*r**2+165173*r**4+369290*r**6
            +407620*r**8+259473*r**10+51525*r**12)-20*Q2**6*(7245-29757*r**2-13760*r**4
            -167221*r**6-237535*r**8-163463*r**10-111678*r**12+36225*r**14)+2*Q2**5*(170100
            +80262*r**2+2890847*r**4+5149485*r**6+5819760*r**8+6516920*r**10+5177967*r**12
            +1268757*r**14+1031310*r**16)-10*Q2**4*(19917+43302*r**2+696535*r**4
            +1674070*r**6+2004837*r**8+2248840*r**10+2048341*r**12+1426478*r**14
            +375522*r**16+137070*r**18)-20*Q2**3*(2070-18825*r**2-40178*r**4-413134*r**6
            -493868*r**8-490217*r**10-921311*r**12-312148*r**14-100640*r**16-102060*r**18
            +8775*r**20)+20*Q2**2*(5481-14553*r**2+216497*r**4-202152*r**6-195594*r**8
            +245543*r**10+79464*r**12-737049*r**14-42235*r**16+428850*r**18-42237*r**20
            +36225*r**22)+(-1+r**2)**2*(8805-17242*r**2+789439*r**4-1773860*r**6
            -986474*r**8+9561352*r**10+5375842*r**12-326924*r**14-1127675*r**16
            +1722514*r**18+12383*r**20+67440*r**22)-10*Q2*(5268-15566*r**2+341497*r**4
            -654419*r**6-274184*r**8+2240122*r**10+1166944*r**12+2977672*r**14-436142*r**16
            -719852*r**18+696519*r**20-43509*r**22+37890*r**24))*sqrtq2+(126*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**3*(5*Q2**5-Q2**4*(7+15*r**2)+2*Q2**3*(4+2*r**2+5*r**4)+(-1
            +r**2)**2*(17+r**2-11*r**4+5*r**6)+2*Q2**2*(7-6*r**2-4*r**4+5*r**6)
            -Q2*(37+20*r**2+8*r**4-32*r**6+15*r**8))-10*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(32256*Q2**14-288*Q2**13*(339+518*r**2)+8*Q2**12*(11745+40478*r**2
            +23877*r**4)+Q2**11*(95499-358507*r**2-508135*r**4+99351*r**6)-Q2**10*(383589
            +356080*r**2+1976274*r**4-329264*r**6+354249*r**8)+Q2**9*(21459+1400491*r**2
            +7390760*r**4+10034036*r**6+1055725*r**8+34713*r**10)+3*Q2**8*(374345
            -756146*r**2-3663623*r**4-3769244*r**6-2403589*r**8-751922*r**10+107331*r**12)
            -6*Q2**7*(199739-371663*r**2-1833699*r**4-4168441*r**6-937469*r**8+2363425*r**10
            -467*r**12+14847*r**14)+Q2**6*(-288642+2265816*r**2+231180*r**4-8496168*r**6
            +23003492*r**8-6870072*r**10+13567596*r**12+2449800*r**14-179802*r**16)
            +2*Q2**5*(556707-2541849*r**2+17102856*r**4+26213580*r**6-16538884*r**8
            -58976872*r**10-14698344*r**12+5756076*r**14-244239*r**16+26649*r**18)
            +2*Q2**4*(-280545+498702*r**2-36732645*r**4-57585012*r**6-82444840*r**8
            -153525108*r**10-68689312*r**12+19803180*r**14-6641823*r**16-733650*r**18
            +33453*r**20)+Q2**3*(-80553+1343297*r**2+18298989*r**4+65629323*r**6
            +235764138*r**8+98850070*r**10+231769822*r**12+308404866*r**14+33807807*r**16
            -440343*r**18+313973*r**20-15309*r**22)+Q2**2*(240999-890072*r**2+38735950*r**4
            -99122616*r**6-171385291*r**8-436767904*r**10-226505772*r**12+241352384*r**14
            +125268401*r**16-35938824*r**18+3304030*r**20+469624*r**22-15309*r**24)
            +(-1+r**2)**2*(33375-463432*r**2+9716288*r**4+34210932*r**6+429107767*r**8
            +185694112*r**10-23101104*r**12-160832984*r**14+74725573*r**16+11512488*r**18
            +710768*r**20-61084*r**22+1701*r**24)+Q2*(-144057+1075351*r**2-33791760*r**4
            +4965436*r**6-891123325*r**8-1407498441*r**10-371766112*r**12+416999240*r**14
            +306799653*r**16-255890035*r**18-12685712*r**20-1896324*r**22-63215*r**24
            +1701*r**26)))*sqrtq2)/(-163296000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            -1134000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+489888000*logq2**4*r**16*sqrtq2
            +20412000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+23625*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+((345600*logq2**3*r**8*(-240*Q2**8*(1+5*r**4)
            +20*Q2**7*(117+166*r**2+501*r**4+480*r**6)-4*Q2**6*(2415+5900*r**2
            +10136*r**4+14688*r**6+8085*r**8)+Q2**5*(19425+64530*r**2+93454*r**4
            +122436*r**6+133377*r**8+56490*r**10)-Q2**4*(17325+75505*r**2+111190*r**4
            +115462*r**6+146261*r**8+133785*r**10+46200*r**12)+Q2**3*(-210+29530*r**2
            +62170*r**4+36808*r**6+70082*r**8+98834*r**10+33270*r**12-2100*r**14)
            +(-1+r**2)**2*(2175+355*r**2-4569*r**4+39419*r**6+18349*r**8+115649*r**10
            -35691*r**12+5793*r**14+6360*r**16)+2*Q2**2*(6405+1710*r**2-17795*r**4
            +18194*r**6+29*r**8+40550*r**10-56313*r**12+14010*r**14+17850*r**16)
            -Q2*(9315-2300*r**2-25984*r**4+128230*r**6+56718*r**8+228638*r**10
            +286248*r**12-121038*r**14+5223*r**16+26310*r**18))-96*logq2*(Q2-(
            -1+r)**2)*(Q2-(1+r)**2)*(4656*Q2**14*(1+5*r**4)-4*Q2**13*(9981+4346*r**2
            +38205*r**4+61980*r**6)+4*Q2**12*(35289+31746*r**2-3186*r**4+392890*r**6
            +264645*r**8)-Q2**11*(246759+384626*r**2-2256934*r**4+587244*r**6+5876815*r**8
            +2222370*r**10)+Q2**10*(155661+594681*r**2-8831714*r**4-13613034*r**6
            -7003739*r**8+8957825*r**10+1850880*r**12)+Q2**9*(185163-401150*r**2
            +21101265*r**4+55561850*r**6+91934525*r**8+68897718*r**10+939175*r**12
            +1490190*r**14)-Q2**8*(427977+170877*r**2+34467885*r**4+141383925*r**6
            +309486275*r**8+391317767*r**10+205760327*r**12+22704135*r**14+4844160*r**16)
            +Q2**7*(243738+632892*r**2+27746208*r**4+216896700*r**6+571666860*r**8
            +909856288*r**10+774178672*r**12+248138668*r**14+29796330*r**16+3521340*r**18)
            +2*Q2**6*(68409-318579*r**2+7216116*r**4-73107126*r**6-189303760*r**8
            -437701626*r**10-485681424*r**12-303122814*r**14+1309859*r**16-3843135*r**18
            +627120*r**20)-2*Q2**5*(130911-142854*r**2+27383571*r**4+15435336*r**6
            +182291046*r**8+165362706*r**10+80090386*r**12+79355246*r**14+52021411*r**16
            +162885196*r**18+8394675*r**20+1790130*r**22)+2*Q2**4*(54153+49975*r**2
            +21185265*r**4+52066275*r**6+329756050*r**8+567660684*r**10+603473600*r**12
            +564545620*r**14+392790475*r**16+229278725*r**18+152733063*r**20+8436225*r**22
            +913890*r**24)+Q2**3*(35901-262314*r**2+1570530*r**4-68997280*r**6-109705125*r**8
            -634573542*r**10-618767172*r**12-988466560*r**14-589938125*r**16-4908950*r**18
            -329195934*r**20-22813664*r**22-3502795*r**24+385830*r**26)-(-1+r**2)**2*(2589
            -4733*r**2+2241614*r**4-5780470*r**6+73049315*r**8-233520403*r**10-35002404*r**12
            +1228727532*r**14-742870045*r**16+129396765*r**18+122562014*r**20-23266038*r**22
            +16198429*r**24+441715*r**26+48120*r**28)-Q2**2*(51519-191549*r**2+21023614*r**4
            -48309390*r**6+383527965*r**8-515789363*r**10+29328068*r**12+329218412*r**14
            -1181695175*r**16-132837235*r**18+696010894*r**20-243046494*r**22+126648299*r**24
            +3036515*r**26+799920*r**28)+Q2*(19191-68166*r**2+12008609*r**4-34826154*r**6
            +321469335*r**8-789979722*r**10+85768417*r**12+1505869722*r**14+1701505453*r**16
            -981466970*r**18-175522149*r**20+583848074*r**22-180867131*r**24+78850026*r**26
            +1956835*r**28+330630*r**30))+145152000*logq2**4*r**12*(9+12*r**2-26*r**4
            +84*r**6+9*r**8)*sqrtq2+5760*logq2**2*r**4*(-4320*Q2**11*(1+5*r**4)+8*Q2**10*(4965
            +4916*r**2+20601*r**4+24930*r**6)-40*Q2**9*(3612+7217*r**2+19493*r**4
            +31427*r**6+18795*r**8)+5*Q2**8*(50625+163440*r**2+459434*r**4+829380*r**6
            +751365*r**8+279900*r**10)-20*Q2**7*(8226+54837*r**2+165173*r**4+369290*r**6
            +407620*r**8+259473*r**10+51525*r**12)-20*Q2**6*(7245-29757*r**2-13760*r**4
            -167221*r**6-237535*r**8-163463*r**10-111678*r**12+36225*r**14)+2*Q2**5*(170100
            +80262*r**2+2890847*r**4+5149485*r**6+5819760*r**8+6516920*r**10+5177967*r**12
            +1268757*r**14+1031310*r**16)-10*Q2**4*(19917+43302*r**2+696535*r**4
            +1674070*r**6+2004837*r**8+2248840*r**10+2048341*r**12+1426478*r**14
            +375522*r**16+137070*r**18)-20*Q2**3*(2070-18825*r**2-40178*r**4-413134*r**6
            -493868*r**8-490217*r**10-921311*r**12-312148*r**14-100640*r**16-102060*r**18
            +8775*r**20)+20*Q2**2*(5481-14553*r**2+216497*r**4-202152*r**6-195594*r**8
            +245543*r**10+79464*r**12-737049*r**14-42235*r**16+428850*r**18-42237*r**20
            +36225*r**22)+(-1+r**2)**2*(8805-17242*r**2+789439*r**4-1773860*r**6
            -986474*r**8+9561352*r**10+5375842*r**12-326924*r**14-1127675*r**16
            +1722514*r**18+12383*r**20+67440*r**22)-10*Q2*(5268-15566*r**2+341497*r**4
            -654419*r**6-274184*r**8+2240122*r**10+1166944*r**12+2977672*r**14-436142*r**16
            -719852*r**18+696519*r**20-43509*r**22+37890*r**24))*sqrtq2+(-504*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**3*(5*Q2**5-Q2**4*(7+15*r**2)+2*Q2**3*(4+2*r**2+5*r**4)+(-1
            +r**2)**2*(17+r**2-11*r**4+5*r**6)+2*Q2**2*(7-6*r**2-4*r**4+5*r**6)
            -Q2*(37+20*r**2+8*r**4-32*r**6+15*r**8))+40*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(32256*Q2**14-288*Q2**13*(339+518*r**2)+8*Q2**12*(11745+40478*r**2
            +23877*r**4)+Q2**11*(95499-358507*r**2-508135*r**4+99351*r**6)-Q2**10*(383589
            +356080*r**2+1976274*r**4-329264*r**6+354249*r**8)+Q2**9*(21459+1400491*r**2
            +7390760*r**4+10034036*r**6+1055725*r**8+34713*r**10)+3*Q2**8*(374345
            -756146*r**2-3663623*r**4-3769244*r**6-2403589*r**8-751922*r**10+107331*r**12)
            -6*Q2**7*(199739-371663*r**2-1833699*r**4-4168441*r**6-937469*r**8+2363425*r**10
            -467*r**12+14847*r**14)+Q2**6*(-288642+2265816*r**2+231180*r**4-8496168*r**6
            +23003492*r**8-6870072*r**10+13567596*r**12+2449800*r**14-179802*r**16)
            +2*Q2**5*(556707-2541849*r**2+17102856*r**4+26213580*r**6-16538884*r**8
            -58976872*r**10-14698344*r**12+5756076*r**14-244239*r**16+26649*r**18)
            +2*Q2**4*(-280545+498702*r**2-36732645*r**4-57585012*r**6-82444840*r**8
            -153525108*r**10-68689312*r**12+19803180*r**14-6641823*r**16-733650*r**18
            +33453*r**20)+Q2**3*(-80553+1343297*r**2+18298989*r**4+65629323*r**6
            +235764138*r**8+98850070*r**10+231769822*r**12+308404866*r**14+33807807*r**16
            -440343*r**18+313973*r**20-15309*r**22)+Q2**2*(240999-890072*r**2+38735950*r**4
            -99122616*r**6-171385291*r**8-436767904*r**10-226505772*r**12+241352384*r**14
            +125268401*r**16-35938824*r**18+3304030*r**20+469624*r**22-15309*r**24)
            +(-1+r**2)**2*(33375-463432*r**2+9716288*r**4+34210932*r**6+429107767*r**8
            +185694112*r**10-23101104*r**12-160832984*r**14+74725573*r**16+11512488*r**18
            +710768*r**20-61084*r**22+1701*r**24)+Q2*(-144057+1075351*r**2-33791760*r**4
            +4965436*r**6-891123325*r**8-1407498441*r**10-371766112*r**12+416999240*r**14
            +306799653*r**16-255890035*r**18-12685712*r**20-1896324*r**22-63215*r**24
            +1701*r**26)))*sqrtq2)*math.log(murhoD))/(-176359680*logq2**3*r**12*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))-1224720*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+529079040*logq2**4*r**16*sqrtq2
            +22044960*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+25515*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2))+(muWC**3*(-3024000*logq2**3*r**12*(1+r**2)*(19
            +10*r**2+19*r**4)-120*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(23
            -1440*Q2**9+10999*r**2+228160*r**4+383296*r**6+3006322*r**8+3006322*r**10
            +383296*r**12+228160*r**14+10999*r**16+23*r**18+10248*Q2**8*(1+r**2)
            -512*Q2**7*(37+94*r**2+37*r**4)+Q2**6*(4319+70769*r**2+70769*r**4+4319*r**6)
            +2*Q2**5*(8631-19072*r**2-30126*r**4-19072*r**6+8631*r**8)-Q2**4*(11375
            +66235*r**2+466262*r**4+466262*r**6+66235*r**8+11375*r**10)-4*Q2**3*(847
            -28698*r**2-220767*r**4-429164*r**6-220767*r**8-28698*r**10+847*r**12)
            +Q2**2*(3729-4117*r**2-37563*r**4-1070849*r**6-1070849*r**8-37563*r**10
            -4117*r**12+3729*r**14)-2*Q2*(217+25092*r**2+198688*r**4-394052*r**6
            -869490*r**8-394052*r**10+198688*r**12+25092*r**14+217*r**16))-7200*logq2**2*r**8*(781
            -80*Q2**6+4344*r**2+33555*r**4+43600*r**6+33555*r**8+4344*r**10+781*r**12
            +900*Q2**5*(1+r**2)-4*Q2**4*(951+1718*r**2+951*r**4)+Q2**3*(3931+13189*r**2
            +13189*r**4+3931*r**6)+Q2**2*(1131-5648*r**2-11126*r**4-5648*r**6+1131*r**8)
            -3*Q2*(953-829*r**2-3484*r**4-3484*r**6-829*r**8+953*r**10))*sqrtq2
            +(500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4
            -2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2
            -6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4
            -26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6-31*r**8+r**10))-14*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6-28170*r**8+31692*r**10
            -9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)+Q2**6*(-11+10*r**2
            -11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)+Q2**4*(-165+1480*r**2
            +10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2-6138*r**4-6138*r**6
            -355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4+35188*r**6+10313*r**8
            -406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4+6605*r**6+6605*r**8
            -7237*r**10-595*r**12+27*r**14)))*sqrtq2)*nlopw.X1Q2RhoD(0,Q2,r))/(163296000*logq2**4*r**16
            +6804000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+7875*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-54432000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-378000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +(muWC**3*(-14400*logq2**2*r**8*(15+22*r**2+15*r**4)-4*(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(7+92*Q2**8-156*r**2+5096*r**4+19308*r**6+138690*r**8
            +19308*r**10+5096*r**12-156*r**14+7*r**16-156*Q2**7*(1+r**2)+Q2**6*(
            -89+190*r**2-89*r**4)+2*Q2**5*(79-247*r**2-247*r**4+79*r**6)+Q2**4*(165
            -1160*r**2-10298*r**4-1160*r**6+165*r**8)-8*Q2**3*(19-280*r**2-2439*r**4
            -2439*r**6-280*r**8+19*r**10)+Q2**2*(-79+806*r**2+1787*r**4-14228*r**6
            +1787*r**8+806*r**10-79*r**12)+2*Q2*(27-635*r**2-2957*r**4+19165*r**6
            +19165*r**8-2957*r**10-635*r**12+27*r**14))-2400*logq2*r**4*(1+2*Q2**5
            +35*r**2+276*r**4+276*r**6+35*r**8+r**10-16*Q2**4*(1+r**2)+Q2**3*(17
            +42*r**2+17*r**4)+Q2**2*(7-19*r**2-19*r**4+7*r**6)+Q2*(-11+30*r**2
            +66*r**4+30*r**6-11*r**8))*sqrtq2)*nlopw.X1Q2RhoD(1,Q2,r))/(-388800*logq2**3*r**12
            -8100*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+97200*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+225*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(muWC**3*(-720*logq2*r**4*(1+r**2)+4*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*nlopw.X1Q2RhoD(2,Q2,r))/(2160*logq2**2*r**8
            +15*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-360*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)-(8*muWC**3*nlopw.X1Q2RhoD(3,Q2,r))/(
            -108*logq2*r**4+9*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2))
        if( flagDEBUG == 1):
            print("Q2moment n. 3 NNLO pw = api^2*",resNNLO*par.mbkin**6)
        res += api**2*resNNLO

    return res*par.mbkin**6


def moment_4_KIN_MS(q2cut, par, hqe, wc, **kwargs):
    """ Central moment of the q2 spectrum. SM Part. Moment n. 4 """
    Q2=q2cut/par.mbkin**2
    r=par.mcMS/par.mbkin
    mus=par.scale_alphas/par.mbkin
    mu0=par.scale_mcMS/par.mbkin
    mumuG=par.scale_muG/par.mbkin
    murhoD=par.scale_rhoD/par.mbkin
    murhoLS=par.scale_rhoLS/par.mbkin
    muWC=par.scale_mbkin/par.mbkin
    api=par.alphas/math.pi

    rhoD=hqe.rhoD/par.mbkin**3
    rhoLS=hqe.rhoLS/par.mbkin**3
    muG=hqe.muG/par.mbkin**2

    pi2=math.pi**2
    z3=1.202056903159594
    flagPERP=kwargs.get('flag_basisPERP', 1)
    flagDEBUG=kwargs.get('flag_DEBUG', 0)
    FLAGcf=1
    FLAGcD=1
    FLAGcs=1

    sqrtq2=math.sqrt(1-2*Q2+Q2**2-2*r**2-2*Q2*r**2+r**4)
    logq2 =math.log((1-Q2+r**2-sqrtq2)/(1-Q2+r**2+sqrtq2))

    res = 0
    res +=((flagPERP*rhoD*(-2592000*logq2**4*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(340
        -1741*r**2+105*Q2**7*r**2+5955*r**4-5175*r**6+3561*r**8+12591*r**10
        -4573*r**12+841*r**14+801*r**16-5*Q2**6*(16+111*r**2+159*r**4)+5*Q2**5*(96
        +279*r**2+724*r**4+471*r**6)-Q2**4*(1200+2331*r**2+6259*r**4+9055*r**6
        +3399*r**8)+Q2**3*(1075+2834*r**2+6055*r**4+10016*r**6+11036*r**8+1956*r**10)
        +Q2**2*(270-2591*r**2-1978*r**4-3537*r**6-9223*r**8-5456*r**10+1011*r**12)
        -Q2*(885-2989*r**2+1628*r**4+3750*r**6-2139*r**8-6015*r**10+746*r**12
        +2034*r**14))-720*logq2**2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
        -4656+9857*r**2+9795*Q2**13*r**2-360589*r**4+1247426*r**6+7361182*r**8
        -110253713*r**10+191149981*r**12+55415668*r**14-108222692*r**16+14298391*r**18
        +43828469*r**20-8037238*r**22+4174646*r**24+77241*r**26+36027*r**28
        -Q2**12*(176+99615*r**2+100143*r**4)+Q2**11*(-5648+421432*r**2+902836*r**4
        +410136*r**6)-2*Q2**10*(-16752+433534*r**2+1590537*r**4+1611252*r**6
        +398709*r**8)+5*Q2**9*(-11871+142514*r**2+1005296*r**4+1552692*r**6
        +1056027*r**8+99342*r**10)+5*Q2**8*(-24+71123*r**2-372041*r**4-2468*r**6
        -278440*r**8-442443*r**10+168525*r**12)-2*Q2**7*(-60246+537940*r**2
        +2273487*r**4+14694780*r**6+25759600*r**8+12425514*r**10+2765355*r**12
        +886122*r**14)+2*Q2**6*(-59052+203748*r**2+2708799*r**4+21785399*r**6
        +64454790*r**8+64322268*r**10+18579313*r**12+4286709*r**14+393714*r**16)
        +Q2**5*(-30498+538711*r**2-1098862*r**4-8740592*r**6-94734134*r**8-181196498*r**10
        -110016034*r**12+744928*r**14-2852712*r**16+893691*r**18)-5*Q2**4*(-21816
        +101869*r**2+36771*r**4+5194326*r**6+7971754*r**8-4244340*r**10-9474900*r**12
        +2307154*r**14+8546022*r**16+621087*r**18+228057*r**20)+10*Q2**3*(-4378
        +1164*r**2-74427*r**4+1524972*r**6+8392172*r**8+11921018*r**10+15535886*r**12
        +7500786*r**14+7836870*r**16+2814850*r**18+305589*r**20+24138*r**22)
        +2*Q2**2*(-11108+77610*r**2-109354*r**4+2494245*r**6-11916315*r**8-37141854*r**10
        -61205670*r**12-93691512*r**14-2752980*r**16-28238020*r**18+4228152*r**20
        -337925*r**22+141531*r**24)-3*Q2*(-7159+23476*r**2-315922*r**4+1964468*r**6
        +4565555*r**8-22863892*r**10+43126788*r**12-35799496*r**14-27648481*r**16
        +25613020*r**18-8809874*r**20+4904436*r**22+63493*r**24+63588*r**26))
        -(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**17*r**2+6*Q2**16*(-503
        +1857*r**2+348*r**4)-Q2**15*(-26898+102167*r**2+795672*r**4+48371*r**6)
        +Q2**14*(-98640-56049*r**2+7994969*r**4+6700457*r**6+211055*r**8)-Q2**13*(
        -177975-1898941*r**2+27560140*r**4+63311870*r**6+22428463*r**8+399935*r**10)
        +2*Q2**12*(-57195-2309884*r**2+17136106*r**4+101613869*r**6+95944414*r**8
        +14856441*r**10+111733*r**12)+Q2**11*(-137556+373945*r**2+19063926*r**4
        -223999621*r**6-431226616*r**8-214206393*r**10+13775206*r**12+451941*r**14)
        -Q2**10*(-294096-13637297*r**2+90239625*r**4+147158379*r**6+237617085*r**8
        +126892013*r**10+149456939*r**12+90174137*r**14+864127*r**16)+Q2**9*(
        -82995-18238327*r**2+48326482*r**4+551909576*r**6+1906001960*r**8+3380058850*r**10
        +1563679558*r**12+632089712*r**14+84181011*r**16+257565*r**18)+2*Q2**8*(
        -126225-1009991*r**2+46086545*r**4-193715485*r**6-853227627*r**8-3255304445*r**10
        -3266464121*r**12-698363155*r**14-250698540*r**16+20066388*r**18+349360*r**20)
        -Q2**7*(-270930-22679187*r**2+132341324*r**4+45799181*r**6+1014675076*r**8
        -843528166*r**10-3741360624*r**12-2052704686*r**14+1341959486*r**16+200656521*r**18
        +125143764*r**20+760881*r**22)+Q2**6*(-14784-14394991*r**2+11307799*r**4
        +195247027*r**6+1774319317*r**8+7423701738*r**10+17856696358*r**12+11717789766*r**14
        +7166277802*r**16+2527824517*r**18+562002755*r**20+57687687*r**22+36929*r**24)
        +Q2**5*(-139311-6909393*r**2+94005896*r**4-225483814*r**6+422091965*r**8
        -4834215971*r**10-21741140296*r**12-43522669716*r**14-12347107893*r**16
        -8634004135*r**18-44297888*r**20-276307526*r**22+46636615*r**24+403867*r**26)
        -2*Q2**4*(-42255-5827438*r**2+34822088*r**4-116753271*r**6+605172420*r**8
        +534178775*r**10+2627004171*r**12-11002393566*r**14-17819750663*r**16
        +6074554120*r**18-930477570*r**20+950406917*r**22+35981378*r**24+28343359*r**26
        +123935*r**28)+Q2**3*(3600-2982709*r**2-596050*r**4-46349435*r**6-106353308*r**8
        +1201901155*r**10+13462806858*r**12+14229490325*r**14+3687037960*r**16
        -6454737479*r**18+18543504930*r**20+3071947751*r**22+885610500*r**24
        +125097625*r**26+10537062*r**28-6785*r**30)+Q2**2*(-23040-2142577*r**2
        +24290137*r**4-132014257*r**6+694056873*r**8-696848773*r**10-872984739*r**12
        -4977016789*r**14-35888913091*r**16+7774277309*r**18-20252527269*r**20
        +2796606109*r**22-2790985173*r**24+437225273*r**26-48682257*r**28+11649257*r**30
        +65007*r**32)+Q2*(9483+1473529*r**2-12345038*r**4+104663644*r**6-278087326*r**8
        +723773040*r**10-4072964318*r**12+4203800668*r**14-17674051888*r**16
        +59843857002*r**18-65906419354*r**20+39123878324*r**22-11142159922*r**24
        +974218744*r**26-446730426*r**28+7287956*r**30-6977035*r**32-27083*r**34)
        +2*(-654-131806*r**2+1042713*r**4-11829543*r**6+9308985*r**8-75573153*r**10
        +468182403*r**12-2736829079*r**14-10699576611*r**16+52263253755*r**18
        -64276935707*r**20+35970149187*r**22-9421707981*r**24+1788128901*r**26
        -61350615*r**28+49334139*r**30-137659*r**32+590847*r**34+1878*r**36))
        +544320000*logq2**5*r**18*(-3-4*r**2+20*r**4-28*r**6+3*r**8)*sqrtq2-43200*logq2**3*r**10*(2265*Q2**12*r**2
        -10*Q2**11*(-8+2487*r**2+2463*r**4)+2*Q2**10*(60+57651*r**2+114071*r**4
        +57771*r**6)-10*Q2**9*(168+29587*r**2+86688*r**4+87891*r**6+29466*r**8)
        +10*Q2**8*(345+43559*r**2+170411*r**4+257585*r**6+177420*r**8+40572*r**10)
        -5*Q2**7*(639+62946*r**2+327965*r**4+670680*r**6+694545*r**8+365346*r**10
        +36639*r**12)-5*Q2**6*(-945+4277*r**2-25333*r**4-189343*r**6-197327*r**8
        -215481*r**10-98931*r**12+60795*r**14)+Q2**5*(-9975+232676*r**2+1416716*r**4
        +2721336*r**6+4815470*r**8+5443880*r**10+2655296*r**12+873516*r**14
        +546381*r**16)-5*Q2**4*(-1881+33246*r**2+266324*r**4+737376*r**6+1289802*r**8
        +1843588*r**10+1626060*r**12+612432*r**14+201183*r**16+58158*r**18)
        +5*Q2**3*(-45+2092*r**2+31513*r**4+543628*r**6+348974*r**8+863344*r**10
        +1386718*r**12+884156*r**14+44967*r**16+106140*r**18-15519*r**20)+(
        -1+r**2)**2*(-795+6057*r**2+62201*r**4-540963*r**6+687258*r**8+728234*r**10
        +339426*r**12+49434*r**14-147727*r**16+329277*r**18-14379*r**20+13977*r**22)
        +5*Q2**2*(-1141+10783*r**2+93415*r**4-524683*r**6+442474*r**8+314470*r**10
        -47806*r**12-472190*r**14-254261*r**16+360507*r**18-57129*r**20+34761*r**22)
        -5*Q2*(-759+6954*r**2+57322*r**4-424866*r**6+607083*r**8+102120*r**10
        +166800*r**12+757680*r**14-67773*r**16-263202*r**18+284310*r**20-32638*r**22
        +16569*r**24))*sqrtq2-6*logq2*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
        -11815-17342*r**2+20598*Q2**16*r**2-1539738*r**4-1828220*r**6-93296530*r**8
        +531809700*r**10-1202798314*r**12-12016064876*r**14+34941377640*r**16
        -16859928440*r**18-10427104030*r**20+13402061004*r**22-3848051134*r**24
        +1002915580*r**26-360030*r**28+15413020*r**30+576527*r**32+46998*r**34
        -12*Q2**15*(-1480+23619*r**2+19179*r**4)+4*Q2**14*(-32820+315810*r**2
        +775091*r**4+250170*r**6)-4*Q2**13*(-89680+561415*r**2+3441914*r**4
        +3172239*r**6+501840*r**8)+3*Q2**12*(-102835+108210*r**2+8242288*r**4
        +14188924*r**6+7455783*r**8+347210*r**10)+Q2**11*(-501830+4084716*r**2
        -5212386*r**4-3865176*r**6-7029506*r**8-4035196*r**10+3308706*r**12)
        -2*Q2**10*(-682770+1489843*r**2+22024696*r**4+119695125*r**6+221267970*r**8
        +106897065*r**10+24392896*r**12+3266703*r**14)+2*Q2**9*(-367345-3071840*r**2
        +26710386*r**4+227220060*r**6+714133400*r**8+705569180*r**10+204029050*r**12
        +35732936*r**14+1173645*r**16)+Q2**8*(-1049565+10126620*r**2-78738*r**4
        -171444948*r**6-1341551320*r**8-2311353340*r**10-1458873670*r**12-92048748*r**14
        -9710163*r**16+5670720*r**18)-4*Q2**7*(-406065+252615*r**2+7631982*r**4
        +81058936*r**6+189015752*r**8+480461830*r**10+282469470*r**12+143391072*r**14
        +131845761*r**16+16615587*r**18+1761540*r**20)+4*Q2**6*(-86460-2028669*r**2
        +1555743*r**4+74640153*r**6+482523418*r**8+2086011688*r**10+3349274064*r**12
        +1600218868*r**14+600107578*r**16+136941693*r**18+14561673*r**20+206811*r**22)
        +4*Q2**5*(-201465+1468989*r**2+1303132*r**4+13924205*r**6-125757445*r**8
        -1264814850*r**10-4711887796*r**12-4758378986*r**14-842818895*r**16-375154195*r**18
        +18838800*r**20+882517*r**22+946389*r**24)-Q2**4*(-642845-567190*r**2
        -8788364*r**4+119119700*r**6+481332275*r**8+3568163190*r**10-1523155600*r**12
        -13344747272*r**14-6577893895*r**16+5528768150*r**18+405581180*r**20
        +405698740*r**22+29345361*r**24+2648970*r**26)+2*Q2**3*(-18015-1180230*r**2
        -3200553*r**4-5407748*r**6-36754535*r**8+2081584130*r**10+4548956715*r**12
        +5193822776*r**14+943425851*r**16+2957420990*r**18+3054240885*r**20+424070540*r**22
        +85143627*r**24+6359622*r**26+15945*r**28)+2*Q2**2*(-80690+490665*r**2
        -3006468*r**4+17883911*r**6+95819042*r**8-120874895*r**10-1518601440*r**12
        -4189196169*r**14-9293444622*r**16+968976371*r**18-4244198580*r**20+292174125*r**22
        -168527138*r**24+35301811*r**26+1076312*r**28+351765*r**30)-2*Q2*(-38835
        +44444*r**2-3174082*r**4+2322168*r**6-63994442*r**8+565501168*r**10
        +36509186*r**12-748140236*r**14+1938362164*r**16-8068634516*r**18+7204485794*r**20
        -4164681904*r**22+1469846818*r**24-20195832*r**26+35804958*r**28+1423748*r**30
        +159399*r**32))*sqrtq2))/(1360800000*logq2**4*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
        +18900000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
        -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+13125*(Q2**2+(
        -1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**5-3265920000*logq2**5*r**20*sqrtq2-226800000*logq2**3*r**12*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2*sqrtq2-787500*logq2*r**4*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))**4*sqrtq2)+(-272160000*logq2**4*r**16*(-1+r**2)**2*(1+6*r**2+r**4)
        -7200*logq2**2*(-Q2+(-1+r)**2)*r**8*(-Q2+(1+r)**2)*(460*Q2**10-4400*Q2**9*(1
        +r**2)+4*Q2**8*(4567+7802*r**2+4567*r**4)-8*Q2**7*(4633+11501*r**2
        +11501*r**4+4633*r**6)+Q2**6*(30079+120124*r**2+71338*r**4+120124*r**6
        +30079*r**8)+2*Q2**5*(6671-13557*r**2+231790*r**4+231790*r**6-13557*r**8
        +6671*r**10)-Q2**4*(41615+94790*r**2+1273777*r**4+2403092*r**6+1273777*r**8
        +94790*r**10+41615*r**12)-18*Q2*(-1+r**2)**2*(633+1899*r**2+42925*r**4
        +73823*r**6+73823*r**8+42925*r**10+1899*r**12+633*r**14)+4*Q2**3*(5023
        +22513*r**2+261675*r**4+906349*r**6+906349*r**8+261675*r**10+22513*r**12
        +5023*r**14)+3*(-1+r**2)**2*(961+3160*r**2+95440*r**4+143944*r**6+117790*r**8
        +143944*r**10+95440*r**12+3160*r**14+961*r**16)+Q2**2*(9349-15392*r**2
        +211336*r**4-1855760*r**6-3230906*r**8-1855760*r**10+211336*r**12-15392*r**14
        +9349*r**16))+(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(184*Q2**16-1104*Q2**15*(1
        +r**2)+32*Q2**14*(25+96*r**2+25*r**4)+32*Q2**13*(340-949*r**2-949*r**4
        +340*r**6)+Q2**12*(-41925+251692*r**2+1983186*r**4+251692*r**6-41925*r**8)
        +4*Q2**11*(16627-208937*r**2-3638162*r**4-3638162*r**6-208937*r**8+16627*r**10)
        +Q2**10*(-35178+1180044*r**2+41638570*r**4+96133800*r**6+41638570*r**8
        +1180044*r**10-35178*r**12)-4*Q2**9*(10725+29511*r**2+11409365*r**4
        +60630575*r**6+60630575*r**8+11409365*r**10+29511*r**12+10725*r**14)
        +Q2**8*(79365-1766064*r**2-21842444*r**4+238855120*r**6+460588750*r**8
        +238855120*r**10-21842444*r**12-1766064*r**14+79365*r**16)-8*Q2**7*(3575
        -237777*r**2-12764516*r**4-7282692*r**6+20374770*r**8+20374770*r**10
        -7282692*r**12-12764516*r**14-237777*r**16+3575*r**18)-4*Q2**6*(9867
        -51174*r**2+18302231*r**4+85840256*r**6+93775326*r**8+193578508*r**10
        +93775326*r**12+85840256*r**14+18302231*r**16-51174*r**18+9867*r**20)
        +8*Q2**5*(6071-218547*r**2-4310735*r**4+37857515*r**6+17390190*r**8
        +107970706*r**10+107970706*r**12+17390190*r**14+37857515*r**16-4310735*r**18
        -218547*r**20+6071*r**22)+Q2**4*(-15275+1136972*r**2+73299210*r**4-83178500*r**6
        +444108875*r**8+821131640*r**10+2768493356*r**12+821131640*r**14+444108875*r**16
        -83178500*r**18+73299210*r**20+1136972*r**22-15275*r**24)-12*Q2*(-1
        +r**2)**2*(227-15217*r**2-1043942*r**4+2236202*r**6-20410375*r**8-40019179*r**10
        -370155716*r**12-370155716*r**14-40019179*r**16-20410375*r**18+2236202*r**20
        -1043942*r**22-15217*r**24+227*r**26)-4*Q2**3*(1905-17483*r**2+6212222*r**4
        +16296750*r**6+57823075*r**8+428840695*r**10+1707002836*r**12+1707002836*r**14
        +428840695*r**16+57823075*r**18+16296750*r**20+6212222*r**22-17483*r**24
        +1905*r**26)+3*(-1+r**2)**2*(113-9462*r**2-851917*r**4+2107988*r**6
        -21795887*r**8-84681226*r**10-753334901*r**12+991370584*r**14-753334901*r**16
        -84681226*r**18-21795887*r**20+2107988*r**22-851917*r**24-9462*r**26
        +113*r**28)+2*Q2**2*(4075-203954*r**2-7046007*r**4+46363836*r**6-151597645*r**8
        +463355570*r**10+1337067993*r**12+4462320264*r**14+1337067993*r**16+463355570*r**18
        -151597645*r**20+46363836*r**22-7046007*r**24-203954*r**26+4075*r**28))
        -864000*logq2**3*r**12*(70*Q2**7-530*Q2**6*(1+r**2)+10*Q2**5*(157+328*r**2
        +157*r**4)-3*Q2*(-1+r**4)**2*(417+160*r**2+417*r**4)-2*Q2**4*(1133
        +3733*r**2+3733*r**4+1133*r**6)+Q2**3*(1199+7188*r**2+12818*r**4+7188*r**6
        +1199*r**8)+3*(-1+r**2)**2*(143+257*r**2+1280*r**4+1280*r**6+257*r**8
        +143*r**10)+Q2**2*(779-1905*r**2-7946*r**4-7946*r**6-1905*r**8+779*r**10))*sqrtq2
        +240*logq2*r**4*(-350*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(-3+15*Q2**7+381*r**2
        +4995*r**4+14067*r**6+14067*r**8+4995*r**10+381*r**12-3*r**14-45*Q2**6*(1
        +r**2)+15*Q2**5*(1+4*r**2+r**4)-Q2**4*(53+421*r**2+421*r**4+53*r**6)
        +Q2**3*(97+696*r**2+1138*r**4+696*r**6+97*r**8)+Q2**2*(37+117*r**2
        -298*r**4-298*r**6+117*r**8+37*r**10)-3*Q2*(21-4*r**2-601*r**4-992*r**6
        -601*r**8-4*r**10+21*r**12))-(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4
        -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
        +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(1417-480*Q2**9-27059*r**2
        -125780*r**4+878324*r**6+1994698*r**8+1994698*r**10+878324*r**12-125780*r**14
        -27059*r**16+1417*r**18+1092*Q2**8*(1+r**2)+4*Q2**7*(841+1762*r**2
        +841*r**4)-Q2**6*(8519+16749*r**2+16749*r**4+8519*r**6)+2*Q2**5*(49
        -8728*r**2-27794*r**4-8728*r**6+49*r**8)+Q2**4*(7595+21275*r**2+154362*r**4
        +154362*r**6+21275*r**8+7595*r**10)+8*Q2**3*(56-649*r**2-39796*r**4
        -77862*r**6-39796*r**8-649*r**10+56*r**12)+Q2**2*(-4049+23137*r**2
        +272183*r**4+852809*r**6+852809*r**8+272183*r**10+23137*r**12-4049*r**14)
        +Q2*(-966+13904*r**2+310576*r**4+334736*r**6+497900*r**8+334736*r**10
        +310576*r**12+13904*r**14-966*r**16)))*sqrtq2)/(1451520000*logq2**4*r**16
        +60480000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
        -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+70000*(Q2**2+(
        -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**4-483840000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2-3360000*logq2*r**4*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**3*sqrtq2)+(flagPERP*rhoLS*(2177280000*logq2**5*r**18*(
        -3-4*r**2+20*r**4-28*r**6+3*r**8)-172800*logq2**3*(-Q2+(-1+r)**2)*r**10*(
        -Q2+(1+r)**2)*(-795+6057*r**2+2265*Q2**10*r**2+62201*r**4-540963*r**6
        +687258*r**8+728234*r**10+339426*r**12+49434*r**14-147727*r**16+329277*r**18
        -14379*r**20+13977*r**22-20*Q2**9*(-4+1017*r**2+1005*r**4)+Q2**8*(280
        +72517*r**2+151792*r**4+73077*r**6)-2*Q2**7*(600+64888*r**2+219461*r**4
        +224516*r**6+64203*r**8)+Q2**6*(770+101681*r**2+559676*r**4+957932*r**6
        +613686*r**8+75831*r**10)+Q2**5*(-455+17548*r**2-136541*r**4-617220*r**6
        -660225*r**8-255476*r**10+96873*r**12)-Q2**4*(-3045+87340*r**2+468405*r**4
        +501068*r**6+825753*r**8+560388*r**10+284575*r**12+186060*r**14)+2*Q2**3*(
        -1715+22814*r**2+238659*r**4+554490*r**6+862077*r**8+1111922*r**10
        +508885*r**12+190734*r**14+38694*r**16)+2*Q2**2*(-250+5798*r**2+2476*r**4
        -431343*r**6-245360*r**8-955997*r**10-828760*r**12-43193*r**14-87874*r**16
        +25023*r**18)+Q2*(2205-19836*r**2-191971*r**4+802700*r**6-945454*r**8
        -373224*r**10+1500326*r**12+363196*r**14-631655*r**16+52604*r**18-54891*r**20))
        -24*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(-11815-17342*r**2
        +20598*Q2**16*r**2-1539738*r**4-1828220*r**6-93296530*r**8+531809700*r**10
        -1202798314*r**12-12016064876*r**14+34941377640*r**16-16859928440*r**18
        -10427104030*r**20+13402061004*r**22-3848051134*r**24+1002915580*r**26
        -360030*r**28+15413020*r**30+576527*r**32+46998*r**34-12*Q2**15*(-1480
        +23619*r**2+19179*r**4)+4*Q2**14*(-32820+315810*r**2+775091*r**4+250170*r**6)
        -4*Q2**13*(-89680+561415*r**2+3441914*r**4+3172239*r**6+501840*r**8)
        +3*Q2**12*(-102835+108210*r**2+8242288*r**4+14188924*r**6+7455783*r**8
        +347210*r**10)+Q2**11*(-501830+4084716*r**2-5212386*r**4-3865176*r**6
        -7029506*r**8-4035196*r**10+3308706*r**12)-2*Q2**10*(-682770+1489843*r**2
        +22024696*r**4+119695125*r**6+221267970*r**8+106897065*r**10+24392896*r**12
        +3266703*r**14)+2*Q2**9*(-367345-3071840*r**2+26710386*r**4+227220060*r**6
        +714133400*r**8+705569180*r**10+204029050*r**12+35732936*r**14+1173645*r**16)
        +Q2**8*(-1049565+10126620*r**2-78738*r**4-171444948*r**6-1341551320*r**8
        -2311353340*r**10-1458873670*r**12-92048748*r**14-9710163*r**16+5670720*r**18)
        -4*Q2**7*(-406065+252615*r**2+7631982*r**4+81058936*r**6+189015752*r**8
        +480461830*r**10+282469470*r**12+143391072*r**14+131845761*r**16+16615587*r**18
        +1761540*r**20)+4*Q2**6*(-86460-2028669*r**2+1555743*r**4+74640153*r**6
        +482523418*r**8+2086011688*r**10+3349274064*r**12+1600218868*r**14+600107578*r**16
        +136941693*r**18+14561673*r**20+206811*r**22)+4*Q2**5*(-201465+1468989*r**2
        +1303132*r**4+13924205*r**6-125757445*r**8-1264814850*r**10-4711887796*r**12
        -4758378986*r**14-842818895*r**16-375154195*r**18+18838800*r**20+882517*r**22
        +946389*r**24)-Q2**4*(-642845-567190*r**2-8788364*r**4+119119700*r**6
        +481332275*r**8+3568163190*r**10-1523155600*r**12-13344747272*r**14-6577893895*r**16
        +5528768150*r**18+405581180*r**20+405698740*r**22+29345361*r**24+2648970*r**26)
        +2*Q2**3*(-18015-1180230*r**2-3200553*r**4-5407748*r**6-36754535*r**8
        +2081584130*r**10+4548956715*r**12+5193822776*r**14+943425851*r**16+2957420990*r**18
        +3054240885*r**20+424070540*r**22+85143627*r**24+6359622*r**26+15945*r**28)
        +2*Q2**2*(-80690+490665*r**2-3006468*r**4+17883911*r**6+95819042*r**8
        -120874895*r**10-1518601440*r**12-4189196169*r**14-9293444622*r**16+968976371*r**18
        -4244198580*r**20+292174125*r**22-168527138*r**24+35301811*r**26+1076312*r**28
        +351765*r**30)-2*Q2*(-38835+44444*r**2-3174082*r**4+2322168*r**6-63994442*r**8
        +565501168*r**10+36509186*r**12-748140236*r**14+1938362164*r**16-8068634516*r**18
        +7204485794*r**20-4164681904*r**22+1469846818*r**24-20195832*r**26+35804958*r**28
        +1423748*r**30+159399*r**32))-10368000*logq2**4*r**14*(340-1741*r**2+105*Q2**7*r**2
        +5955*r**4-5175*r**6+3561*r**8+12591*r**10-4573*r**12+841*r**14+801*r**16
        -5*Q2**6*(16+111*r**2+159*r**4)+5*Q2**5*(96+279*r**2+724*r**4+471*r**6)
        -Q2**4*(1200+2331*r**2+6259*r**4+9055*r**6+3399*r**8)+Q2**3*(1075+2834*r**2
        +6055*r**4+10016*r**6+11036*r**8+1956*r**10)+Q2**2*(270-2591*r**2-1978*r**4
        -3537*r**6-9223*r**8-5456*r**10+1011*r**12)-Q2*(885-2989*r**2+1628*r**4
        +3750*r**6-2139*r**8-6015*r**10+746*r**12+2034*r**14))*sqrtq2-2880*logq2**2*r**6*(9795*Q2**15*r**2
        -Q2**14*(176+119205*r**2+119733*r**4)+Q2**13*(-5296+630809*r**2+1282762*r**4
        +620217*r**6)-Q2**12*(-44624+1797899*r**2+5730699*r**4+5747777*r**6
        +1717833*r**8)+Q2**11*(-132011+2812426*r**2+13177088*r**4+19596512*r**6
        +13402543*r**8+2501682*r**10)-Q2**10*(-152094+1884891*r**2+14751739*r**4
        +23319644*r**6+25012874*r**8+15393573*r**10+948213*r**12)-Q2**9*(-61377
        +955590*r**2-2004191*r**4+27221400*r**6+53930425*r**8+19942298*r**10
        -1495185*r**12+2960784*r**14)+Q2**8*(-359208+2674127*r**2+14091751*r**4
        +115507551*r**6+287499375*r**8+281944837*r**10+101796957*r**12+19281861*r**14
        +5174541*r**16)-Q2**7*(-326202+1356937*r**2+15023772*r**4+128088876*r**6
        +436981944*r**8+647506918*r**10+448970212*r**12+106281012*r**14+23560626*r**16
        +2453409*r**18)+Q2**6*(51972-882067*r**2+5420949*r**4+26850376*r**6
        +214276264*r**8+487479138*r**10+538578698*r**12+269907144*r**14-17715324*r**16
        +7811169*r**18-2140239*r**20)+Q2**5*(-292438+1411877*r**2-1564652*r**4
        +61556533*r**6+137230708*r**8+156015498*r**10+175809288*r**12+42910898*r**14
        +72541858*r**16+127163633*r**18+6907236*r**20+3415641*r**22)-Q2**4*(
        -174424+508005*r**2-2190467*r**4+50135675*r**6+210274875*r**8+405579898*r**10
        +706477090*r**12+733179534*r**14+284543150*r**16+198691425*r**18+91612001*r**20
        +8095255*r**22+1339983*r**24)+Q2**3*(22129-237236*r**2+263412*r**4+1316932*r**6
        +76669625*r**8+231440812*r**10+264869952*r**12+610487536*r**14+552435251*r**16
        -6456100*r**18+147596684*r**20-7996116*r**22+3168227*r**24-515508*r**26)
        +(-1+r**2)**2*(-4656+9857*r**2-360589*r**4+1247426*r**6+7361182*r**8
        -110253713*r**10+191149981*r**12+55415668*r**14-108222692*r**16+14298391*r**18
        +43828469*r**20-8037238*r**22+4174646*r**24+77241*r**26+36027*r**28)
        +Q2**2*(-69826+307411*r**2-2666629*r**4+16719828*r**6+12513002*r**8
        -241673693*r**10+315050803*r**12+82535368*r**14-242061806*r**16-230761519*r**18
        +260549769*r**20-105534364*r**22+44073286*r**24-402247*r**26+700617*r**28)
        -Q2*(-30789+123784*r**2-1811563*r**4+9633038*r**6+18179307*r**8-295876664*r**10
        +442052917*r**12+58380406*r**14+155617849*r**16-52517144*r**18-146799465*r**20
        +215994074*r**22-63390943*r**24+23026888*r**26+35487*r**28+262818*r**30))*sqrtq2
        +(-125*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(-291+525*Q2**7-20147*r**2-5111*r**4
        +211609*r**6+130409*r**8-10375*r**10-1219*r**12+45*r**14-375*Q2**6*(1
        +r**2)-5*Q2**5*(75-172*r**2+75*r**4)+Q2**4*(-291+869*r**2-139*r**4
        +45*r**6)+Q2**3*(-291+128*r**2+2840*r**4-544*r**6+45*r**8)+Q2**2*(
        -291-2315*r**2+9816*r**4+3768*r**6-859*r**8+45*r**10)+Q2*(-291-7580*r**2
        +15313*r**4+43104*r**6+1313*r**8-1084*r**10+45*r**12))+42*(Q2-(-1
        +r)**2)**2*(Q2-(1+r)**2)**2*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
        -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
        +r**8))**2*(375*Q2**11-1050*Q2**10*(1+r**2)+Q2**9*(-75+2636*r**2-75*r**4)
        +Q2**8*(2019-4273*r**2-5641*r**4+2475*r**6)-6*Q2**7*(122-611*r**2-3199*r**4
        -817*r**6+225*r**8)-4*Q2**6*(222-1391*r**2+9786*r**4+10698*r**6-2075*r**8
        +450*r**10)+2*Q2**5*(18-1019*r**2+28135*r**4+77994*r**6+34708*r**8
        -5291*r**10+675*r**12)+6*Q2**4*(5-791*r**2+3709*r**4-10219*r**6-14477*r**8
        +4515*r**10-521*r**12+75*r**14)+Q2**3*(261-3562*r**2-66630*r**4-26970*r**6
        +109988*r**8+83514*r**10-128082*r**12+1226*r**14-225*r**16)-2*Q2**2*(
        -81+53*r**2+22820*r**4+69696*r**6+139532*r**8+221348*r**10+99744*r**12
        -9148*r**14-1879*r**16+75*r**18)-3*Q2*(19-662*r**2+3229*r**4+59504*r**6
        +5830*r**8+59556*r**10+27322*r**12+78336*r**14-16489*r**16-670*r**18
        +25*r**20)+3*(-27+641*r**2+3833*r**4-38555*r**6+4522*r**8-164262*r**10
        -142766*r**12-158558*r**14+66705*r**16-2747*r**18-811*r**20+25*r**22))
        -25*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(21+37695*Q2**13
        +81479*r**2-1584410*r**4-14507670*r**6-82841935*r**8-255824893*r**10
        -460434400*r**12-1068299008*r**14-361893349*r**16+58874825*r**18+14340762*r**20
        +293686*r**22-42817*r**24+909*r**26-95691*Q2**12*(1+r**2)-6*Q2**11*(2458
        -41935*r**2+2458*r**4)+6*Q2**10*(20677-36566*r**2-60482*r**4+28649*r**6)
        -Q2**9*(-51093+388582*r**2+1885604*r**4+276886*r**6+4755*r**8)+Q2**8*(
        -80445+788749*r**2+2948334*r**4+2390142*r**6+1102213*r**8-156885*r**10)
        -4*Q2**7*(15414-241967*r**2-1034942*r**4+602597*r**6-1322108*r**8-82211*r**10
        +4632*r**12)+4*Q2**6*(-2205-200162*r**2+605612*r**4+3121748*r**6+4660100*r**8
        +195992*r**10-295106*r**12+21399*r**14)+Q2**5*(21057-1052948*r**2-3524496*r**4
        +6693768*r**6+25597478*r**8+12429480*r**10-7130400*r**12-573236*r**14
        +30297*r**16)+Q2**4*(36147+126647*r**2-8436724*r**4-4697096*r**6+54517930*r**8
        +74607994*r**10-16624424*r**12-5695156*r**14+484391*r**16-21645*r**18)
        -2*Q2**3*(-4770-34853*r**2+3342806*r**4+23536190*r**6+31970104*r**8
        +1598142*r**10+56702896*r**12+19694990*r**14-2068534*r**16-255821*r**18
        +8730*r**20)-2*Q2**2*(6069-34214*r**2-1213662*r**4+22232499*r**6+117743552*r**8
        +164919060*r**10+202917204*r**12+122870000*r**14+11530119*r**16-1226034*r**18
        -2426*r**20+153*r**22)+Q2*(-6117+202778*r**2+1417412*r**4-24058658*r**6
        -194508899*r**8-146410808*r**10-174487352*r**12-481304024*r**14-81326867*r**16
        +15112174*r**18-400060*r**20-151606*r**22+3627*r**24)))*sqrtq2))/(-13063680000*logq2**5*r**20
        -907200000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
        -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-3150000*logq2*r**4*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**4+5443200000*logq2**4*r**16*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+75600000*logq2**2*r**8*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**3*sqrtq2+52500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
        )
    res += ((muG*(-2177280000*logq2**5*r**18*(-3-4*r**2+20*r**4-28*r**6+3*r**8)
        +172800*logq2**3*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(-795+6057*r**2
        +2265*Q2**10*r**2+62201*r**4-540963*r**6+687258*r**8+728234*r**10+339426*r**12
        +49434*r**14-147727*r**16+329277*r**18-14379*r**20+13977*r**22-20*Q2**9*(
        -4+1017*r**2+1005*r**4)+Q2**8*(280+72517*r**2+151792*r**4+73077*r**6)
        -2*Q2**7*(600+64888*r**2+219461*r**4+224516*r**6+64203*r**8)+Q2**6*(770
        +101681*r**2+559676*r**4+957932*r**6+613686*r**8+75831*r**10)+Q2**5*(
        -455+17548*r**2-136541*r**4-617220*r**6-660225*r**8-255476*r**10+96873*r**12)
        -Q2**4*(-3045+87340*r**2+468405*r**4+501068*r**6+825753*r**8+560388*r**10
        +284575*r**12+186060*r**14)+2*Q2**3*(-1715+22814*r**2+238659*r**4+554490*r**6
        +862077*r**8+1111922*r**10+508885*r**12+190734*r**14+38694*r**16)+2*Q2**2*(
        -250+5798*r**2+2476*r**4-431343*r**6-245360*r**8-955997*r**10-828760*r**12
        -43193*r**14-87874*r**16+25023*r**18)+Q2*(2205-19836*r**2-191971*r**4
        +802700*r**6-945454*r**8-373224*r**10+1500326*r**12+363196*r**14-631655*r**16
        +52604*r**18-54891*r**20))+24*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1
        +r)**2)**2*(-11815-17342*r**2+20598*Q2**16*r**2-1539738*r**4-1828220*r**6
        -93296530*r**8+531809700*r**10-1202798314*r**12-12016064876*r**14+34941377640*r**16
        -16859928440*r**18-10427104030*r**20+13402061004*r**22-3848051134*r**24
        +1002915580*r**26-360030*r**28+15413020*r**30+576527*r**32+46998*r**34
        -12*Q2**15*(-1480+23619*r**2+19179*r**4)+4*Q2**14*(-32820+315810*r**2
        +775091*r**4+250170*r**6)-4*Q2**13*(-89680+561415*r**2+3441914*r**4
        +3172239*r**6+501840*r**8)+3*Q2**12*(-102835+108210*r**2+8242288*r**4
        +14188924*r**6+7455783*r**8+347210*r**10)+Q2**11*(-501830+4084716*r**2
        -5212386*r**4-3865176*r**6-7029506*r**8-4035196*r**10+3308706*r**12)
        -2*Q2**10*(-682770+1489843*r**2+22024696*r**4+119695125*r**6+221267970*r**8
        +106897065*r**10+24392896*r**12+3266703*r**14)+2*Q2**9*(-367345-3071840*r**2
        +26710386*r**4+227220060*r**6+714133400*r**8+705569180*r**10+204029050*r**12
        +35732936*r**14+1173645*r**16)+Q2**8*(-1049565+10126620*r**2-78738*r**4
        -171444948*r**6-1341551320*r**8-2311353340*r**10-1458873670*r**12-92048748*r**14
        -9710163*r**16+5670720*r**18)-4*Q2**7*(-406065+252615*r**2+7631982*r**4
        +81058936*r**6+189015752*r**8+480461830*r**10+282469470*r**12+143391072*r**14
        +131845761*r**16+16615587*r**18+1761540*r**20)+4*Q2**6*(-86460-2028669*r**2
        +1555743*r**4+74640153*r**6+482523418*r**8+2086011688*r**10+3349274064*r**12
        +1600218868*r**14+600107578*r**16+136941693*r**18+14561673*r**20+206811*r**22)
        +4*Q2**5*(-201465+1468989*r**2+1303132*r**4+13924205*r**6-125757445*r**8
        -1264814850*r**10-4711887796*r**12-4758378986*r**14-842818895*r**16-375154195*r**18
        +18838800*r**20+882517*r**22+946389*r**24)-Q2**4*(-642845-567190*r**2
        -8788364*r**4+119119700*r**6+481332275*r**8+3568163190*r**10-1523155600*r**12
        -13344747272*r**14-6577893895*r**16+5528768150*r**18+405581180*r**20
        +405698740*r**22+29345361*r**24+2648970*r**26)+2*Q2**3*(-18015-1180230*r**2
        -3200553*r**4-5407748*r**6-36754535*r**8+2081584130*r**10+4548956715*r**12
        +5193822776*r**14+943425851*r**16+2957420990*r**18+3054240885*r**20+424070540*r**22
        +85143627*r**24+6359622*r**26+15945*r**28)+2*Q2**2*(-80690+490665*r**2
        -3006468*r**4+17883911*r**6+95819042*r**8-120874895*r**10-1518601440*r**12
        -4189196169*r**14-9293444622*r**16+968976371*r**18-4244198580*r**20+292174125*r**22
        -168527138*r**24+35301811*r**26+1076312*r**28+351765*r**30)-2*Q2*(-38835
        +44444*r**2-3174082*r**4+2322168*r**6-63994442*r**8+565501168*r**10
        +36509186*r**12-748140236*r**14+1938362164*r**16-8068634516*r**18+7204485794*r**20
        -4164681904*r**22+1469846818*r**24-20195832*r**26+35804958*r**28+1423748*r**30
        +159399*r**32))+10368000*logq2**4*r**14*(340-1741*r**2+105*Q2**7*r**2+5955*r**4
        -5175*r**6+3561*r**8+12591*r**10-4573*r**12+841*r**14+801*r**16-5*Q2**6*(16
        +111*r**2+159*r**4)+5*Q2**5*(96+279*r**2+724*r**4+471*r**6)-Q2**4*(1200
        +2331*r**2+6259*r**4+9055*r**6+3399*r**8)+Q2**3*(1075+2834*r**2+6055*r**4
        +10016*r**6+11036*r**8+1956*r**10)+Q2**2*(270-2591*r**2-1978*r**4-3537*r**6
        -9223*r**8-5456*r**10+1011*r**12)-Q2*(885-2989*r**2+1628*r**4+3750*r**6
        -2139*r**8-6015*r**10+746*r**12+2034*r**14))*sqrtq2+2880*logq2**2*r**6*(9795*Q2**15*r**2
        -Q2**14*(176+119205*r**2+119733*r**4)+Q2**13*(-5296+630809*r**2+1282762*r**4
        +620217*r**6)-Q2**12*(-44624+1797899*r**2+5730699*r**4+5747777*r**6
        +1717833*r**8)+Q2**11*(-132011+2812426*r**2+13177088*r**4+19596512*r**6
        +13402543*r**8+2501682*r**10)-Q2**10*(-152094+1884891*r**2+14751739*r**4
        +23319644*r**6+25012874*r**8+15393573*r**10+948213*r**12)-Q2**9*(-61377
        +955590*r**2-2004191*r**4+27221400*r**6+53930425*r**8+19942298*r**10
        -1495185*r**12+2960784*r**14)+Q2**8*(-359208+2674127*r**2+14091751*r**4
        +115507551*r**6+287499375*r**8+281944837*r**10+101796957*r**12+19281861*r**14
        +5174541*r**16)-Q2**7*(-326202+1356937*r**2+15023772*r**4+128088876*r**6
        +436981944*r**8+647506918*r**10+448970212*r**12+106281012*r**14+23560626*r**16
        +2453409*r**18)+Q2**6*(51972-882067*r**2+5420949*r**4+26850376*r**6
        +214276264*r**8+487479138*r**10+538578698*r**12+269907144*r**14-17715324*r**16
        +7811169*r**18-2140239*r**20)+Q2**5*(-292438+1411877*r**2-1564652*r**4
        +61556533*r**6+137230708*r**8+156015498*r**10+175809288*r**12+42910898*r**14
        +72541858*r**16+127163633*r**18+6907236*r**20+3415641*r**22)-Q2**4*(
        -174424+508005*r**2-2190467*r**4+50135675*r**6+210274875*r**8+405579898*r**10
        +706477090*r**12+733179534*r**14+284543150*r**16+198691425*r**18+91612001*r**20
        +8095255*r**22+1339983*r**24)+Q2**3*(22129-237236*r**2+263412*r**4+1316932*r**6
        +76669625*r**8+231440812*r**10+264869952*r**12+610487536*r**14+552435251*r**16
        -6456100*r**18+147596684*r**20-7996116*r**22+3168227*r**24-515508*r**26)
        +(-1+r**2)**2*(-4656+9857*r**2-360589*r**4+1247426*r**6+7361182*r**8
        -110253713*r**10+191149981*r**12+55415668*r**14-108222692*r**16+14298391*r**18
        +43828469*r**20-8037238*r**22+4174646*r**24+77241*r**26+36027*r**28)
        +Q2**2*(-69826+307411*r**2-2666629*r**4+16719828*r**6+12513002*r**8
        -241673693*r**10+315050803*r**12+82535368*r**14-242061806*r**16-230761519*r**18
        +260549769*r**20-105534364*r**22+44073286*r**24-402247*r**26+700617*r**28)
        -Q2*(-30789+123784*r**2-1811563*r**4+9633038*r**6+18179307*r**8-295876664*r**10
        +442052917*r**12+58380406*r**14+155617849*r**16-52517144*r**18-146799465*r**20
        +215994074*r**22-63390943*r**24+23026888*r**26+35487*r**28+262818*r**30))*sqrtq2
        +(125*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(-291+525*Q2**7-20147*r**2-5111*r**4
        +211609*r**6+130409*r**8-10375*r**10-1219*r**12+45*r**14-375*Q2**6*(1
        +r**2)-5*Q2**5*(75-172*r**2+75*r**4)+Q2**4*(-291+869*r**2-139*r**4
        +45*r**6)+Q2**3*(-291+128*r**2+2840*r**4-544*r**6+45*r**8)+Q2**2*(
        -291-2315*r**2+9816*r**4+3768*r**6-859*r**8+45*r**10)+Q2*(-291-7580*r**2
        +15313*r**4+43104*r**6+1313*r**8-1084*r**10+45*r**12))-42*(Q2-(-1
        +r)**2)**2*(Q2-(1+r)**2)**2*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
        -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
        +r**8))**2*(375*Q2**11-1050*Q2**10*(1+r**2)+Q2**9*(-75+2636*r**2-75*r**4)
        +Q2**8*(2019-4273*r**2-5641*r**4+2475*r**6)-6*Q2**7*(122-611*r**2-3199*r**4
        -817*r**6+225*r**8)-4*Q2**6*(222-1391*r**2+9786*r**4+10698*r**6-2075*r**8
        +450*r**10)+2*Q2**5*(18-1019*r**2+28135*r**4+77994*r**6+34708*r**8
        -5291*r**10+675*r**12)+6*Q2**4*(5-791*r**2+3709*r**4-10219*r**6-14477*r**8
        +4515*r**10-521*r**12+75*r**14)+Q2**3*(261-3562*r**2-66630*r**4-26970*r**6
        +109988*r**8+83514*r**10-128082*r**12+1226*r**14-225*r**16)-2*Q2**2*(
        -81+53*r**2+22820*r**4+69696*r**6+139532*r**8+221348*r**10+99744*r**12
        -9148*r**14-1879*r**16+75*r**18)-3*Q2*(19-662*r**2+3229*r**4+59504*r**6
        +5830*r**8+59556*r**10+27322*r**12+78336*r**14-16489*r**16-670*r**18
        +25*r**20)+3*(-27+641*r**2+3833*r**4-38555*r**6+4522*r**8-164262*r**10
        -142766*r**12-158558*r**14+66705*r**16-2747*r**18-811*r**20+25*r**22))
        +25*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(21+37695*Q2**13
        +81479*r**2-1584410*r**4-14507670*r**6-82841935*r**8-255824893*r**10
        -460434400*r**12-1068299008*r**14-361893349*r**16+58874825*r**18+14340762*r**20
        +293686*r**22-42817*r**24+909*r**26-95691*Q2**12*(1+r**2)-6*Q2**11*(2458
        -41935*r**2+2458*r**4)+6*Q2**10*(20677-36566*r**2-60482*r**4+28649*r**6)
        -Q2**9*(-51093+388582*r**2+1885604*r**4+276886*r**6+4755*r**8)+Q2**8*(
        -80445+788749*r**2+2948334*r**4+2390142*r**6+1102213*r**8-156885*r**10)
        -4*Q2**7*(15414-241967*r**2-1034942*r**4+602597*r**6-1322108*r**8-82211*r**10
        +4632*r**12)+4*Q2**6*(-2205-200162*r**2+605612*r**4+3121748*r**6+4660100*r**8
        +195992*r**10-295106*r**12+21399*r**14)+Q2**5*(21057-1052948*r**2-3524496*r**4
        +6693768*r**6+25597478*r**8+12429480*r**10-7130400*r**12-573236*r**14
        +30297*r**16)+Q2**4*(36147+126647*r**2-8436724*r**4-4697096*r**6+54517930*r**8
        +74607994*r**10-16624424*r**12-5695156*r**14+484391*r**16-21645*r**18)
        -2*Q2**3*(-4770-34853*r**2+3342806*r**4+23536190*r**6+31970104*r**8
        +1598142*r**10+56702896*r**12+19694990*r**14-2068534*r**16-255821*r**18
        +8730*r**20)-2*Q2**2*(6069-34214*r**2-1213662*r**4+22232499*r**6+117743552*r**8
        +164919060*r**10+202917204*r**12+122870000*r**14+11530119*r**16-1226034*r**18
        -2426*r**20+153*r**22)+Q2*(-6117+202778*r**2+1417412*r**4-24058658*r**6
        -194508899*r**8-146410808*r**10-174487352*r**12-481304024*r**14-81326867*r**16
        +15112174*r**18-400060*r**20-151606*r**22+3627*r**24)))*sqrtq2))/(-13063680000*logq2**5*r**20
        -907200000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
        -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-3150000*logq2*r**4*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**4+5443200000*logq2**4*r**16*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+75600000*logq2**2*r**8*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**3*sqrtq2+52500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
        )
    res += ((rhoD*(2592000*logq2**4*r**12*(105*Q2**9*(1+5*r**4)-5*Q2**8*(249+361*r**2
        +1101*r**4+1005*r**6)+10*Q2**7*(597+1621*r**2+3496*r**4+4343*r**6+2025*r**8)
        -2*Q2**6*(7812+29149*r**2+64765*r**4+93125*r**6+69133*r**8+22260*r**10)
        +Q2**5*(22974+106027*r**2+250778*r**4+470915*r**6+412871*r**8+222906*r**10
        +55545*r**12)-Q2**4*(15540+92822*r**2+231869*r**4+588590*r**6+701120*r**8
        +419048*r**10+170935*r**12+31500*r**14)+2*Q2**3*(-1575+11024*r**2+40642*r**4
        +140278*r**6+184250*r**8+213791*r**10+81491*r**12+6005*r**14-5250*r**16)
        +(-1+r**2)**2*(1821+1633*r**2+608*r**4+116088*r**6-193788*r**8-187194*r**10
        +70224*r**12-1996*r**14+12199*r**16+4005*r**18)+Q2**2*(13020+15118*r**2
        -11915*r**4+119156*r**6-143159*r**8-108758*r**10-29109*r**12-13188*r**14
        +70635*r**16+29400*r**18)+Q2*(-8331-4469*r**2+12109*r**4-306011*r**6
        +264845*r**8+760417*r**10+146475*r**12-137073*r**14+34282*r**16-38464*r**18
        -18180*r**20))+720*logq2**2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(9795*Q2**15*(1
        +5*r**4)-Q2**14*(120261+121493*r**2+521937*r**4+598665*r**6)+Q2**13*(604329
        +1271816*r**2+3448100*r**4+5662978*r**6+3101085*r**8)-Q2**12*(1583961
        +5382217*r**2+14984690*r**4+28081086*r**6+25269377*r**8+8589165*r**10)
        +Q2**11*(2105649+11648083*r**2+36582862*r**4+85246604*r**6+92230079*r**8
        +57617593*r**10+12508410*r**12)-Q2**10*(491931+12207009*r**2+35377311*r**4
        +134400931*r**6+171469901*r**8+105720395*r**10+60971217*r**12+4741065*r**14)
        -Q2**9*(2776653-630711*r**2+40542531*r**4-18250145*r**6-76727145*r**8
        +99740803*r**10+137775089*r**12+9194301*r**14+14803920*r**16)+Q2**8*(4096917
        +13919013*r**2+148377380*r**4+308632144*r**6+276891690*r**8+613334922*r**10
        +965758108*r**12+553194480*r**14+104109969*r**16+25872705*r**18)-Q2**7*(1474803
        +15840426*r**2+133162825*r**4+526474548*r**6+441833406*r**8+535880328*r**10
        +1378107826*r**12+1544646700*r**14+552418143*r**16+112180446*r**18+12267045*r**20)
        -Q2**6*(1984323-5804169*r**2+37730299*r**4-375497397*r**6+59872778*r**8
        +1109296634*r**10+899482146*r**12-562848086*r**14-848754237*r**16+108366543*r**18
        -25743789*r**20+10701195*r**22)+Q2**5*(2538327+2759198*r**2+163842602*r**4
        -105799688*r**6+754730047*r**8+3936007492*r**10+6253024212*r**12+5020022232*r**14
        +1457563277*r**16+277470622*r**18+679323650*r**20+45080784*r**22+17078205*r**24)
        -Q2**4*(816711+4176143*r**2+106088382*r**4+37433530*r**6+675121145*r**8
        +5072470653*r**10+10494698764*r**12+12060215356*r**14+7391704305*r**16
        +1851552905*r**18+608344086*r**20+492090218*r**22+42539887*r**24+6699915*r**26)
        +Q2**3*(-449121+2478871*r**2-15046580*r**4+146543328*r**6-217727825*r**8
        +2390168207*r**10+6033710428*r**12+8865032760*r**14+8622117469*r**16
        +3173450165*r**18-114834436*r**20+529359176*r**22-28759755*r**24+12234053*r**26
        -2577540*r**28)+(-1+r**2)**2*(22059-8871*r**2+4419683*r**4-20995819*r**6
        +139149983*r**8+108523417*r**10-822294713*r**12+958091149*r**14-873751727*r**16
        -1787782061*r**18+714996889*r**20+332955959*r**22-45911707*r**24+21722171*r**26
        +603453*r**28+180135*r**30)+Q2**2*(491139-1071907*r**2+52895515*r**4
        -206636041*r**6+887443983*r**8+331547957*r**10-575705201*r**12+1159538095*r**14
        -467647463*r**16-3196260881*r**18+1744035569*r**20+1843553133*r**22-528696235*r**24
        +221511679*r**26+1577573*r**28+3503085*r**30)-Q2*(170451-340323*r**2
        +26200363*r**4-129435949*r**6+685390901*r**8+206205825*r**10-1660142489*r**12
        +533888479*r**14-2084679017*r**16-716426537*r**18-4677079583*r**20+1411398297*r**22
        +1553436983*r**24-348894709*r**26+117080461*r**28+1592757*r**30+1314090*r**32))
        +(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(552*Q2**20+Q2**19*(1230-86*r**2)
        +8*Q2**18*(993+5225*r**2+2309*r**4)-Q2**17*(793689+350881*r**2+3840383*r**4
        +361615*r**6)+Q2**16*(6432021+485746*r**2+21116616*r**4+38837094*r**6
        +2083563*r**8)-2*Q2**15*(11471247-3133150*r**2-25946401*r**4+101248489*r**6
        +84688408*r**8+2973871*r**10)+Q2**14*(40359885-25706302*r**2-675511331*r**4
        -240427744*r**6+819403091*r**8+369434110*r**10+8820563*r**12)-2*Q2**13*(9542901
        +2669295*r**2-1085865336*r**4-1900280100*r**6-466447889*r**8+803851653*r**10
        +146175660*r**12+1926168*r**14)-Q2**12*(59715123-229084978*r**2+3370785104*r**4
        +12061520622*r**6+13661765622*r**8+4700526258*r**10-1023582864*r**12
        +443437586*r**14+8895575*r**16)+2*Q2**11*(59958951-268593854*r**2+1107903779*r**4
        +11402737423*r**6+22250625111*r**8+21253490637*r**10+7314514917*r**12
        +1008667129*r**14+657468074*r**16+7744633*r**18)-Q2**10*(58479135-343542210*r**2
        -1563244539*r**4+28898194668*r**6+83780882714*r**8+119396855352*r**10
        +86936703870*r**12+20253826772*r**14+5147480295*r**16+1012294602*r**18
        +4642781*r**20)-2*Q2**9*(40320930-289047506*r**2+3077122489*r**4-7457575429*r**6
        -38957895394*r**8-82778419030*r**10-77053270204*r**12-39150651796*r**14
        +935601416*r**16-2231515984*r**18+284894555*r**20+6165809*r**22)+Q2**8*(131865747
        -1224415370*r**2+8366116250*r**4+22850768770*r**6+14448039489*r**8-64268195484*r**10
        -79801386780*r**12+13590947148*r**14+34024103325*r**16+42359779974*r**18
        -138163070*r**20+1608087890*r**22+15087631*r**24)-2*Q2**7*(23013981-298988206*r**2
        +2129722329*r**4+24289171323*r**6+44661674978*r**8+47234796729*r**10
        +36834968682*r**12+99832766070*r**14+112780665993*r**16+70234457628*r**18
        +22785681581*r**20+1785794655*r**22+443650152*r**24+1609065*r**26)+Q2**6*(
        -50293017+573373078*r**2-4626548429*r**4+31899242456*r**6+36006884167*r**8
        +122998331518*r**10-10829320837*r**12+138039439968*r**14+312641956557*r**16
        +104398998674*r**18+120087044929*r**20-4550430776*r**22+3888809861*r**24
        -428397478*r**26-6511471*r**28)+2*Q2**5*(29194197-444109285*r**2+4525970488*r**4
        -275635120*r**6+18388466093*r**8-60188517893*r**10+167931853520*r**12
        +190859318848*r**14+102048773903*r**16-113442017999*r**18+106822746176*r**20
        -18953374040*r**22+21874725359*r**24-911000263*r**26+391781176*r**28
        +2932040*r**30)-Q2**4*(16040505-330507126*r**2+4716323316*r**4+11233089714*r**6
        +15112005104*r**8-109573193430*r**10+588173222796*r**12+1020409892898*r**14
        +1022875599762*r**16+793357092462*r**18-158390301780*r**20+246316285446*r**22
        +12506888136*r**24+28602910174*r**26+237801684*r**28+303592230*r**30
        +1130109*r**32)+2*Q2**3*(-4614882+74166205*r**2-641187947*r**4+4894880565*r**6
        -13870779821*r**8+15069143875*r**10+131583868765*r**12+374509317573*r**14
        +620236955535*r**16+357597187597*r**18+244037521191*r**20+44917866615*r**22
        -6716860655*r**24+18960340425*r**26-1947071001*r**28+487848591*r**30
        -44487185*r**32-543446*r**34)+2*(-1+r**2)**2*(156654-4170412*r**2+84909051*r**4
        -230578818*r**6+358432710*r**8-5882078502*r**10+74768865726*r**12-231116744978*r**14
        +245764096194*r**16+10125137730*r**18-301537274708*r**20+192462278634*r**22
        -40827260622*r**24+11311878366*r**26-1463840190*r**28+470139306*r**30
        -9537448*r**32+2698674*r**34+12633*r**36)+Q2**2*(8644899-184657634*r**2
        +2643449645*r**4-7304295692*r**6+26751377328*r**8-128117752164*r**10
        +487154478120*r**12-363509890492*r**14+372778090654*r**16-540957326056*r**18
        -236996217094*r**20+896363366812*r**22-445606313176*r**24+180868302468*r**26
        -43091242272*r**28+13124189484*r**30-673003673*r**32+121417898*r**34
        +820945*r**36)-Q2*(2682531-67137509*r**2+1183056495*r**4-3779339229*r**6
        +10174715552*r**8-75459588888*r**10+590033884272*r**12-1177510543480*r**14
        +327748803822*r**16+838933914054*r**18-299472890442*r**20-1671324890442*r**22
        +1404998019000*r**24-419673325232*r**26+125884294536*r**28-23421714576*r**30
        +6145926679*r**32-221450265*r**34+42311139*r**36+231983*r**38))+544320000*logq2**5*r**16*(9
        +33*r**2+124*r**4-512*r**6+163*r**8+15*r**10)*sqrtq2+43200*logq2**3*r**8*(2265*Q2**12*(1
        +5*r**4)-10*Q2**11*(2439+2383*r**2+10431*r**4+12315*r**6)+2*Q2**10*(57951
        +108258*r**2+244605*r**4+469607*r**6+288855*r**8)-10*Q2**9*(29970+83928*r**2
        +146473*r**4+295842*r**6+354501*r**8+147330*r**10)+10*Q2**8*(41607+170403*r**2
        +278381*r**4+438443*r**6+778226*r**8+693972*r**10+202860*r**12)-5*Q2**7*(38556
        +357489*r**2+504564*r**4+81617*r**6+473328*r**8+1688379*r**10+1329480*r**12
        +183195*r**14)-5*Q2**6*(57960-124467*r**2+295925*r**4+2741021*r**6+5136449*r**8
        +4066963*r**10+490035*r**12-165669*r**14+303975*r**16)+Q2**5*(516456
        +573363*r**2+6551210*r**4+31603502*r**6+74308470*r**8+90473156*r**10
        +56145758*r**12+15840170*r**14+4559562*r**16+2731905*r**18)-5*Q2**4*(52515
        +155709*r**2+1212342*r**4+6057464*r**6+18583638*r**8+30158754*r**10
        +25695316*r**12+11271144*r**14+2845431*r**16+897153*r**18+290790*r**20)
        -5*Q2**3*(15654-103659*r**2+43130*r**4-1514209*r**6-9251464*r**8-16383518*r**10
        -20394136*r**12-15196618*r**14-1758062*r**16+32217*r**18-420306*r**20
        +77595*r**22)+(-1+r**2)**2*(11592-18345*r**2+695733*r**4-81745*r**6
        +3122037*r**8-1180470*r**10-14149954*r**12-15771798*r**14+390*r**16
        +4605983*r**18+1554573*r**20-25881*r**22+69885*r**24)+5*Q2**2*(31338
        -69451*r**2+887491*r**4+908653*r**6-272311*r**8+1288894*r**10-641462*r**12
        -3234082*r**14-4073984*r**16+4774573*r**18+1844691*r**20-206955*r**22
        +173805*r**24)-5*Q2*(14292-36669*r**2+633636*r**4+13564*r**6+1113684*r**8
        +2288967*r**10-11520768*r**12-8298456*r**14-2304012*r**16-3015687*r**18
        +2866908*r**20+1350204*r**22-122908*r**24+82845*r**26))*sqrtq2+6*logq2*(
        -250*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(111+105*Q2**7-4517*r**2-91999*r**4
        -164085*r**6+1160315*r**8+1928089*r**10+482547*r**12+59769*r**14+1530*r**16
        -5*Q2**6*(-81+31*r**2+240*r**4)+15*Q2**5*(-29-16*r**2+59*r**4+60*r**6)
        -Q2**4*(-321+243*r**2+50107*r**4+69411*r**6+9180*r**8)+Q2**3*(-729
        -1592*r**2+81550*r**4+220582*r**6+137739*r**8+14130*r**10)+Q2**2*(-309
        -1389*r**2-6978*r**4-105212*r**6-125831*r**8-9611*r**10+3210*r**12)
        +Q2*(531-5304*r**2-92255*r**4+33430*r**6+433925*r**8+246424*r**10
        -45401*r**12-9390*r**14))+21*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4
        -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
        +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(12*Q2**10*(16+205*r**4)
        -60*Q2**9*(12+12*r**2+211*r**4+275*r**6)+5*Q2**8*(135+270*r**2+4314*r**4
        +11146*r**6+7335*r**8)-60*Q2**7*(-8+24*r**2+157*r**4+1047*r**6+1313*r**8
        +335*r**10)-30*Q2**6*(30-60*r**2+1447*r**4-433*r**6-2349*r**8-1871*r**10
        +1260*r**12)-60*Q2**3*r**4*(911-1449*r**2-3631*r**4-8165*r**6-7971*r**8
        -5223*r**10-2237*r**12+405*r**14)+4*Q2**5*(-36+540*r**2+28785*r**4
        +42905*r**6+47430*r**8+26514*r**10-8755*r**12+13545*r**14)-30*Q2**4*(
        -19+186*r**2+2071*r**4+5553*r**6+13432*r**8+25138*r**10+17181*r**12
        +1723*r**14+175*r**16)+120*Q2*r**4*(116-1379*r**2-13454*r**4-26131*r**6
        -17070*r**8+5559*r**10+4294*r**12-3241*r**14-574*r**16+40*r**18)-3*(
        -1+r**2)**2*(-9+252*r**2+1793*r**4-41806*r**6-222100*r**8-331426*r**10
        +64268*r**12+55502*r**14-35299*r**16-10330*r**18+755*r**20)+10*Q2**2*(
        -18+324*r**2+3303*r**4-12811*r**6+4917*r**8-22143*r**10-69061*r**12
        +4839*r**14+41457*r**16-3457*r**18+810*r**20))-5*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))*(30*Q2**15*(1408+21355*r**4)-2*Q2**14*(96000+94432*r**2+1841499*r**4
        +2340195*r**6)+2*Q2**13*(104790+289648*r**2+3915889*r**4+9514666*r**6
        +5723805*r**8)-2*Q2**12*(-133320+288212*r**2+3327327*r**4+13894203*r**6
        +15357559*r**8+3207495*r**10)-Q2**11*(609120+109589*r**2+10179979*r**4
        -5890972*r**6+7743536*r**8-6924137*r**10+16303365*r**12)+Q2**10*(-40920
        +1633551*r**2+30535728*r**4+65571913*r**6+235481588*r**8+272338493*r**10
        +42702732*r**12+22088835*r**14)+Q2**9*(641100-1712547*r**2+31855101*r**4
        +21155575*r**6-292239145*r**8-760113305*r**10-578560777*r**12-81091979*r**14
        +9040905*r**16)-Q2**8*(42360+3220167*r**2+163398546*r**4+343826564*r**6
        +457158230*r**8+205758050*r**10+11525982*r**12+39997316*r**14-36530286*r**16
        +27976095*r**18)+2*Q2**7*(-254640+2882199*r**2+59353974*r**4+212515616*r**6
        +792221208*r**8+1247452960*r**10+1272164694*r**12+879465024*r**14+591679136*r**16
        +53346393*r**18+2437740*r**20)+2*Q2**6*(27720+789339*r**2+49458789*r**4
        -137890762*r**6-928880024*r**8-2512926912*r**10-3883645666*r**12-2844620746*r**14
        -654115832*r**16-302888899*r**18-64932987*r**20+7687740*r**22)-2*Q2**5*(
        -155010+3179651*r**2+75489978*r**4+9011143*r**6+1178158688*r**8+1814989088*r**10
        +143656338*r**12-3265427532*r**14-2615233912*r**16-196798587*r**18+465594828*r**20
        +20256957*r**22+3747810*r**24)+2*Q2**4*(-34800+429893*r**2+13092911*r**4
        +254473345*r**6+3066154535*r**8+5518907760*r**10+6022535174*r**12+6239930638*r**14
        +7188662350*r**16+3828621065*r**18+247777115*r**20+414022033*r**22+54467051*r**24
        -1103070*r**26)+Q2**3*(-102720+2946871*r**2+35076693*r**4-430516868*r**6
        -1622270680*r**8-2407501785*r**10-3972479207*r**12-2896383656*r**14-1879468064*r**16
        -11455837155*r**18-12282676545*r**20-2245358164*r**22+56844088*r**24
        -12757243*r**26+1697235*r**28)-(-1+r**2)**2*(6840-262821*r**2+694140*r**4
        +53693853*r**6+340327528*r**8+1056435675*r**10+19830812092*r**12+41828023405*r**14
        +31273693864*r**16+1060482649*r**18-2366456780*r**20+2425860079*r**22
        +553946680*r**24+35499633*r**26-2265452*r**28+132615*r**30)-Q2**2*(-29640
        +759349*r**2+18796244*r**4+90389751*r**6+2573379748*r**8-4264509115*r**10
        -16074629528*r**12-38907744713*r**14-43242750992*r**16-9250682441*r**18
        +9496395540*r**20+4191654029*r**22-988650956*r**24+236074191*r**26+30677168*r**28
        +247365*r**30)+Q2*(18180-712839*r**2+5167701*r**4+197422827*r**6+1553553159*r**8
        -2371820983*r**10+36772678093*r**12+121033122043*r**14+172424472631*r**16
        +58661293507*r**18-8400275609*r**20-4648158839*r**22+8076387181*r**24
        +934073467*r**26+119024759*r**28+5960337*r**30+290385*r**32)))*sqrtq2))/(4082400000*logq2**4*r**16*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))+56700000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
        +39375*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-9797760000*logq2**5*r**20*sqrtq2
        -680400000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
        -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-2362500*logq2*r**4*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**4*sqrtq2))

    if( flagDEBUG == 1):
        print("Q2moment n. 4 LO = ",res*par.mbkin**8)
    resNLO = 0
    resNLO +=((flagPERP*muWC**3*(20736000*logq2**4*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(340
        -1741*r**2+105*Q2**7*r**2+5955*r**4-5175*r**6+3561*r**8+12591*r**10
        -4573*r**12+841*r**14+801*r**16-5*Q2**6*(16+111*r**2+159*r**4)+5*Q2**5*(96
        +279*r**2+724*r**4+471*r**6)-Q2**4*(1200+2331*r**2+6259*r**4+9055*r**6
        +3399*r**8)+Q2**3*(1075+2834*r**2+6055*r**4+10016*r**6+11036*r**8+1956*r**10)
        +Q2**2*(270-2591*r**2-1978*r**4-3537*r**6-9223*r**8-5456*r**10+1011*r**12)
        -Q2*(885-2989*r**2+1628*r**4+3750*r**6-2139*r**8-6015*r**10+746*r**12
        +2034*r**14))+5760*logq2**2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
        -4656+9857*r**2+9795*Q2**13*r**2-360589*r**4+1247426*r**6+7361182*r**8
        -110253713*r**10+191149981*r**12+55415668*r**14-108222692*r**16+14298391*r**18
        +43828469*r**20-8037238*r**22+4174646*r**24+77241*r**26+36027*r**28
        -Q2**12*(176+99615*r**2+100143*r**4)+Q2**11*(-5648+421432*r**2+902836*r**4
        +410136*r**6)-2*Q2**10*(-16752+433534*r**2+1590537*r**4+1611252*r**6
        +398709*r**8)+5*Q2**9*(-11871+142514*r**2+1005296*r**4+1552692*r**6
        +1056027*r**8+99342*r**10)+5*Q2**8*(-24+71123*r**2-372041*r**4-2468*r**6
        -278440*r**8-442443*r**10+168525*r**12)-2*Q2**7*(-60246+537940*r**2
        +2273487*r**4+14694780*r**6+25759600*r**8+12425514*r**10+2765355*r**12
        +886122*r**14)+2*Q2**6*(-59052+203748*r**2+2708799*r**4+21785399*r**6
        +64454790*r**8+64322268*r**10+18579313*r**12+4286709*r**14+393714*r**16)
        +Q2**5*(-30498+538711*r**2-1098862*r**4-8740592*r**6-94734134*r**8-181196498*r**10
        -110016034*r**12+744928*r**14-2852712*r**16+893691*r**18)-5*Q2**4*(-21816
        +101869*r**2+36771*r**4+5194326*r**6+7971754*r**8-4244340*r**10-9474900*r**12
        +2307154*r**14+8546022*r**16+621087*r**18+228057*r**20)+10*Q2**3*(-4378
        +1164*r**2-74427*r**4+1524972*r**6+8392172*r**8+11921018*r**10+15535886*r**12
        +7500786*r**14+7836870*r**16+2814850*r**18+305589*r**20+24138*r**22)
        +2*Q2**2*(-11108+77610*r**2-109354*r**4+2494245*r**6-11916315*r**8-37141854*r**10
        -61205670*r**12-93691512*r**14-2752980*r**16-28238020*r**18+4228152*r**20
        -337925*r**22+141531*r**24)-3*Q2*(-7159+23476*r**2-315922*r**4+1964468*r**6
        +4565555*r**8-22863892*r**10+43126788*r**12-35799496*r**14-27648481*r**16
        +25613020*r**18-8809874*r**20+4904436*r**22+63493*r**24+63588*r**26))
        +8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**17*r**2+6*Q2**16*(-503
        +1857*r**2+348*r**4)-Q2**15*(-26898+102167*r**2+795672*r**4+48371*r**6)
        +Q2**14*(-98640-56049*r**2+7994969*r**4+6700457*r**6+211055*r**8)-Q2**13*(
        -177975-1898941*r**2+27560140*r**4+63311870*r**6+22428463*r**8+399935*r**10)
        +2*Q2**12*(-57195-2309884*r**2+17136106*r**4+101613869*r**6+95944414*r**8
        +14856441*r**10+111733*r**12)+Q2**11*(-137556+373945*r**2+19063926*r**4
        -223999621*r**6-431226616*r**8-214206393*r**10+13775206*r**12+451941*r**14)
        -Q2**10*(-294096-13637297*r**2+90239625*r**4+147158379*r**6+237617085*r**8
        +126892013*r**10+149456939*r**12+90174137*r**14+864127*r**16)+Q2**9*(
        -82995-18238327*r**2+48326482*r**4+551909576*r**6+1906001960*r**8+3380058850*r**10
        +1563679558*r**12+632089712*r**14+84181011*r**16+257565*r**18)+2*Q2**8*(
        -126225-1009991*r**2+46086545*r**4-193715485*r**6-853227627*r**8-3255304445*r**10
        -3266464121*r**12-698363155*r**14-250698540*r**16+20066388*r**18+349360*r**20)
        -Q2**7*(-270930-22679187*r**2+132341324*r**4+45799181*r**6+1014675076*r**8
        -843528166*r**10-3741360624*r**12-2052704686*r**14+1341959486*r**16+200656521*r**18
        +125143764*r**20+760881*r**22)+Q2**6*(-14784-14394991*r**2+11307799*r**4
        +195247027*r**6+1774319317*r**8+7423701738*r**10+17856696358*r**12+11717789766*r**14
        +7166277802*r**16+2527824517*r**18+562002755*r**20+57687687*r**22+36929*r**24)
        +Q2**5*(-139311-6909393*r**2+94005896*r**4-225483814*r**6+422091965*r**8
        -4834215971*r**10-21741140296*r**12-43522669716*r**14-12347107893*r**16
        -8634004135*r**18-44297888*r**20-276307526*r**22+46636615*r**24+403867*r**26)
        -2*Q2**4*(-42255-5827438*r**2+34822088*r**4-116753271*r**6+605172420*r**8
        +534178775*r**10+2627004171*r**12-11002393566*r**14-17819750663*r**16
        +6074554120*r**18-930477570*r**20+950406917*r**22+35981378*r**24+28343359*r**26
        +123935*r**28)+Q2**3*(3600-2982709*r**2-596050*r**4-46349435*r**6-106353308*r**8
        +1201901155*r**10+13462806858*r**12+14229490325*r**14+3687037960*r**16
        -6454737479*r**18+18543504930*r**20+3071947751*r**22+885610500*r**24
        +125097625*r**26+10537062*r**28-6785*r**30)+Q2**2*(-23040-2142577*r**2
        +24290137*r**4-132014257*r**6+694056873*r**8-696848773*r**10-872984739*r**12
        -4977016789*r**14-35888913091*r**16+7774277309*r**18-20252527269*r**20
        +2796606109*r**22-2790985173*r**24+437225273*r**26-48682257*r**28+11649257*r**30
        +65007*r**32)+Q2*(9483+1473529*r**2-12345038*r**4+104663644*r**6-278087326*r**8
        +723773040*r**10-4072964318*r**12+4203800668*r**14-17674051888*r**16
        +59843857002*r**18-65906419354*r**20+39123878324*r**22-11142159922*r**24
        +974218744*r**26-446730426*r**28+7287956*r**30-6977035*r**32-27083*r**34)
        +2*(-654-131806*r**2+1042713*r**4-11829543*r**6+9308985*r**8-75573153*r**10
        +468182403*r**12-2736829079*r**14-10699576611*r**16+52263253755*r**18
        -64276935707*r**20+35970149187*r**22-9421707981*r**24+1788128901*r**26
        -61350615*r**28+49334139*r**30-137659*r**32+590847*r**34+1878*r**36))
        -4354560000*logq2**5*r**18*(-3-4*r**2+20*r**4-28*r**6+3*r**8)*sqrtq2
        +345600*logq2**3*r**10*(2265*Q2**12*r**2-10*Q2**11*(-8+2487*r**2+2463*r**4)
        +2*Q2**10*(60+57651*r**2+114071*r**4+57771*r**6)-10*Q2**9*(168+29587*r**2
        +86688*r**4+87891*r**6+29466*r**8)+10*Q2**8*(345+43559*r**2+170411*r**4
        +257585*r**6+177420*r**8+40572*r**10)-5*Q2**7*(639+62946*r**2+327965*r**4
        +670680*r**6+694545*r**8+365346*r**10+36639*r**12)-5*Q2**6*(-945+4277*r**2
        -25333*r**4-189343*r**6-197327*r**8-215481*r**10-98931*r**12+60795*r**14)
        +Q2**5*(-9975+232676*r**2+1416716*r**4+2721336*r**6+4815470*r**8+5443880*r**10
        +2655296*r**12+873516*r**14+546381*r**16)-5*Q2**4*(-1881+33246*r**2
        +266324*r**4+737376*r**6+1289802*r**8+1843588*r**10+1626060*r**12+612432*r**14
        +201183*r**16+58158*r**18)+5*Q2**3*(-45+2092*r**2+31513*r**4+543628*r**6
        +348974*r**8+863344*r**10+1386718*r**12+884156*r**14+44967*r**16+106140*r**18
        -15519*r**20)+(-1+r**2)**2*(-795+6057*r**2+62201*r**4-540963*r**6+687258*r**8
        +728234*r**10+339426*r**12+49434*r**14-147727*r**16+329277*r**18-14379*r**20
        +13977*r**22)+5*Q2**2*(-1141+10783*r**2+93415*r**4-524683*r**6+442474*r**8
        +314470*r**10-47806*r**12-472190*r**14-254261*r**16+360507*r**18-57129*r**20
        +34761*r**22)-5*Q2*(-759+6954*r**2+57322*r**4-424866*r**6+607083*r**8
        +102120*r**10+166800*r**12+757680*r**14-67773*r**16-263202*r**18+284310*r**20
        -32638*r**22+16569*r**24))*sqrtq2+48*logq2*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**2*(-11815-17342*r**2+20598*Q2**16*r**2-1539738*r**4-1828220*r**6
        -93296530*r**8+531809700*r**10-1202798314*r**12-12016064876*r**14+34941377640*r**16
        -16859928440*r**18-10427104030*r**20+13402061004*r**22-3848051134*r**24
        +1002915580*r**26-360030*r**28+15413020*r**30+576527*r**32+46998*r**34
        -12*Q2**15*(-1480+23619*r**2+19179*r**4)+4*Q2**14*(-32820+315810*r**2
        +775091*r**4+250170*r**6)-4*Q2**13*(-89680+561415*r**2+3441914*r**4
        +3172239*r**6+501840*r**8)+3*Q2**12*(-102835+108210*r**2+8242288*r**4
        +14188924*r**6+7455783*r**8+347210*r**10)+Q2**11*(-501830+4084716*r**2
        -5212386*r**4-3865176*r**6-7029506*r**8-4035196*r**10+3308706*r**12)
        -2*Q2**10*(-682770+1489843*r**2+22024696*r**4+119695125*r**6+221267970*r**8
        +106897065*r**10+24392896*r**12+3266703*r**14)+2*Q2**9*(-367345-3071840*r**2
        +26710386*r**4+227220060*r**6+714133400*r**8+705569180*r**10+204029050*r**12
        +35732936*r**14+1173645*r**16)+Q2**8*(-1049565+10126620*r**2-78738*r**4
        -171444948*r**6-1341551320*r**8-2311353340*r**10-1458873670*r**12-92048748*r**14
        -9710163*r**16+5670720*r**18)-4*Q2**7*(-406065+252615*r**2+7631982*r**4
        +81058936*r**6+189015752*r**8+480461830*r**10+282469470*r**12+143391072*r**14
        +131845761*r**16+16615587*r**18+1761540*r**20)+4*Q2**6*(-86460-2028669*r**2
        +1555743*r**4+74640153*r**6+482523418*r**8+2086011688*r**10+3349274064*r**12
        +1600218868*r**14+600107578*r**16+136941693*r**18+14561673*r**20+206811*r**22)
        +4*Q2**5*(-201465+1468989*r**2+1303132*r**4+13924205*r**6-125757445*r**8
        -1264814850*r**10-4711887796*r**12-4758378986*r**14-842818895*r**16-375154195*r**18
        +18838800*r**20+882517*r**22+946389*r**24)-Q2**4*(-642845-567190*r**2
        -8788364*r**4+119119700*r**6+481332275*r**8+3568163190*r**10-1523155600*r**12
        -13344747272*r**14-6577893895*r**16+5528768150*r**18+405581180*r**20
        +405698740*r**22+29345361*r**24+2648970*r**26)+2*Q2**3*(-18015-1180230*r**2
        -3200553*r**4-5407748*r**6-36754535*r**8+2081584130*r**10+4548956715*r**12
        +5193822776*r**14+943425851*r**16+2957420990*r**18+3054240885*r**20+424070540*r**22
        +85143627*r**24+6359622*r**26+15945*r**28)+2*Q2**2*(-80690+490665*r**2
        -3006468*r**4+17883911*r**6+95819042*r**8-120874895*r**10-1518601440*r**12
        -4189196169*r**14-9293444622*r**16+968976371*r**18-4244198580*r**20+292174125*r**22
        -168527138*r**24+35301811*r**26+1076312*r**28+351765*r**30)-2*Q2*(-38835
        +44444*r**2-3174082*r**4+2322168*r**6-63994442*r**8+565501168*r**10
        +36509186*r**12-748140236*r**14+1938362164*r**16-8068634516*r**18+7204485794*r**20
        -4164681904*r**22+1469846818*r**24-20195832*r**26+35804958*r**28+1423748*r**30
        +159399*r**32))*sqrtq2))/(12247200000*logq2**4*r**16*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))+170100000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+118125*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**5-29393280000*logq2**5*r**20*sqrtq2-2041200000*logq2**3*r**12*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2*sqrtq2-7087500*logq2*r**4*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
        +r**4))**4*sqrtq2)+(-26127360000*logq2**5*(-Q2+(-1+r)**2)*(-1+r)*r**24*(1
        +r)*(-1+4*r**2+r**4)*(-Q2+(1+r)**2)-691200*logq2**3*r**14*(Q2**2+(
        -1+r**2)**2-2*Q2*(1+r**2))**2*(-1510*Q2**10+10*Q2**9*(1340+1217*r**2)
        -2*Q2**8*(24359+44148*r**2+19457*r**4)+4*Q2**7*(21401+62513*r**2+55655*r**4
        +14978*r**6)-Q2**6*(50554+311803*r**2+437641*r**4+249593*r**6+40537*r**8)
        +2*Q2**5*(-32291+36896*r**2+87946*r**4+157854*r**6+58597*r**8+4522*r**10)
        +Q2**4*(124040+214555*r**2+494927*r**4+83994*r**6-435854*r**8-70685*r**10
        -13825*r**12)+4*Q2**3*(-12898-53701*r**2-157876*r**4-99536*r**6+239270*r**8
        +173821*r**10+26604*r**12+4196*r**14)+Q2**2*(-33364+79283*r**2+16137*r**4
        +296499*r**6-722823*r**8-1296899*r**10+37639*r**12-20915*r**14+11483*r**16)
        -6*Q2*(-6099+4007*r**2-67848*r**4+21698*r**6+64982*r**8-104896*r**10
        -66872*r**12+141998*r**14+9277*r**16+3753*r**18)+3*(-3106+3031*r**2
        -69535*r**4+58604*r**6-11272*r**8-54546*r**10-60846*r**12-31980*r**14
        +158506*r**16+8507*r**18+2637*r**20))+96*logq2*r**6*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))**3*(13732*Q2**16-4*Q2**15*(38358+47353*r**2)+16*Q2**14*(41695
        +126801*r**2+61440*r**4)-4*Q2**13*(334560+2025701*r**2+2355206*r**4
        +625335*r**6)+Q2**12*(694420+13567351*r**2+26919373*r**4+19852261*r**6
        +2909075*r**8)+4*Q2**11*(551451-23561*r**2+413174*r**4-3135646*r**6
        -3789481*r**8+67591*r**10)-2*Q2**10*(2177802+17403309*r**2+75093455*r**4
        +121618470*r**6+46469020*r**8+6956709*r**10+2387187*r**12)+4*Q2**9*(391215
        +11773167*r**2+67035635*r**4+192722225*r**6+158346325*r**8+44889845*r**10
        +9452817*r**12+1050555*r**14)+Q2**8*(3780480-3184167*r**2-43163017*r**4
        -710809155*r**6-792237525*r**8-410937005*r**10-95749107*r**12-28210377*r**14
        +1715505*r**16)-4*Q2**7*(1174360+11732163*r**2+91548124*r**4+123976528*r**6
        +362349120*r**8+417275330*r**10+97266748*r**12+1422224*r**14-946032*r**16
        +1252075*r**18)+4*Q2**6*(137874+9613897*r**2+91052087*r**4+352634752*r**6
        +1011964312*r**8+1820065866*r**10+956701522*r**12+116345712*r**14-6878698*r**16
        +2517837*r**18+508519*r**20)+4*Q2**5*(630926+1073793*r**2+13982000*r**4
        -182395465*r**6-322047760*r**8-2162635754*r**10-1911058044*r**12-486082550*r**14
        +27584610*r**16+2418665*r**18-3628692*r**20+417471*r**22)-Q2**4*(1765980
        +20732359*r**2+269938805*r**4+348423425*r**6+4348988575*r**8-1647663930*r**10
        -4597246318*r**12-2303000990*r**14+30034650*r**16+119693075*r**18-98084775*r**20
        -11108291*r**22+1738635*r**24)+4*Q2**3*(5315+2130149*r**2+27550654*r**4
        +122984030*r**6+1035739625*r**8+774057155*r**10+129171892*r**12-926702748*r**14
        -856597195*r**16-121705525*r**18-48289970*r**20-21579266*r**22-168481*r**24
        +44365*r**26)+2*Q2**2*(234510+844963*r**2+24148449*r**4-81245162*r**6
        +235556140*r**8-1909042435*r**10+1124047779*r**12+1270605252*r**14+3719022894*r**16
        +1464102285*r**18-37783225*r**20+75992358*r**22-5295976*r**24-2739757*r**26
        +207925*r**28)-12*Q2*(17711+167737*r**2+3966887*r**4-998773*r**6+164743127*r**8
        -408775791*r**10+669430751*r**12-399847749*r**14+629740421*r**16-475362829*r**18
        -91556851*r**20-89227863*r**22+869237*r**24-2883773*r**26-299923*r**28
        +17681*r**30)+3*(10444+133661*r**2+3390395*r**4+96725*r**6+221868235*r**8
        -848905207*r**10+2709352287*r**12-2218074815*r**14-2856327225*r**16+5652935255*r**18
        -2279536943*r**20-204955457*r**22-173583455*r**24-2816125*r**26-3355115*r**28
        -243669*r**30+11009*r**32))+20736000*logq2**4*r**18*(140*Q2**9-20*Q2**8*(67
        +37*r**2)+40*Q2**7*(135+143*r**2+15*r**4)+4*Q2**6*(-2968-4419*r**2
        -820*r**4+959*r**6)+Q2**5*(14812+28433*r**2+3131*r**4-16461*r**6-10451*r**8)
        +Q2**4*(-8400-23801*r**2+3892*r**4+32250*r**6+27268*r**8+7455*r**10)
        -3*(-1+r**2)**3*(356+575*r**2-1481*r**4+2700*r**6+4256*r**8+1101*r**10
        +893*r**12)+2*Q2**3*(-1400+3342*r**2-4037*r**4-9479*r**6-14331*r**8
        -4951*r**10+3640*r**12)-2*Q2**2*(-3920-1032*r**2+1673*r**4-6060*r**6
        -970*r**8+808*r**10+1241*r**12+8260*r**14)+3*Q2*(-1616+265*r**2+5057*r**4
        -8005*r**6-11197*r**8+6919*r**10+6303*r**12-1419*r**14+3693*r**16))*sqrtq2
        +11520*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(6530*Q2**13
        -2*Q2**12*(33381+29810*r**2)+Q2**11*(273424+535554*r**2+222950*r**4)
        -2*Q2**10*(265806+938723*r**2+810536*r**4+212055*r**6)+5*Q2**9*(66228
        +588671*r**2+695193*r**4+420981*r**6+80199*r**8)-5*Q2**8*(-112350+172139*r**2
        -350048*r**4-494014*r**6+104542*r**8+23163*r**10)-2*Q2**7*(590748+1900265*r**2
        +8876090*r**4+15766105*r**6+7968365*r**8+592898*r**10+42345*r**12)+2*Q2**6*(262476
        +2623271*r**2+11248305*r**4+33736125*r**6+30452290*r**8+8900241*r**10
        +237321*r**12+47835*r**14)-2*Q2**5*(-297897+711224*r**2-2043767*r**4
        +22955095*r**6+36578550*r**8+20310488*r**10+2210999*r**12-168047*r**14
        +73755*r**16)+10*Q2**4*(-76019-213868*r**2-3000409*r**4-2109244*r**6
        +227915*r**8+3764684*r**10+1528049*r**12-14524*r**14+81392*r**16+18088*r**18)
        -10*Q2**3*(-16092-186752*r**2-1828251*r**4-4553667*r**6-4183053*r**8
        +1949469*r**10+7861977*r**12+2304099*r**14+384777*r**16+129699*r**18
        +4034*r**20)-2*Q2**2*(-94354+164900*r**2-3096415*r**4+13924200*r**6
        -2466180*r**8+838788*r**10-54958890*r**12-23915580*r**14-4106970*r**16
        +275560*r**18-93479*r**20+45220*r**22)+3*Q2*(-42392-52457*r**2-3298745*r**4
        +4811955*r**6-15281685*r**8+9374994*r**10-595086*r**12-27984390*r**14
        +27092370*r**16+4216535*r**18+1604423*r**20+130643*r**22+23835*r**24)
        -3*(-8006-17873*r**2-921646*r**4+1737470*r**6-8610260*r**8-69143*r**10
        +16824396*r**12-4527628*r**14-28542230*r**16+21389585*r**18+2005474*r**20
        +684302*r**22+50224*r**24+5335*r**26))*sqrtq2+8*r**4*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))**3*(92*Q2**18+60*Q2**17*(1+r**2)+Q2**16*(5996+12912*r**2
        -6076*r**4)+Q2**15*(-72623-1046341*r**2-160589*r**4+34969*r**6)+Q2**14*(299825
        +8852676*r**2+10808350*r**4+776500*r**6-94735*r**8)+Q2**13*(-576101
        -29535579*r**2-82368756*r**4-43289452*r**6-1877655*r**8+135799*r**10)
        +Q2**12*(381315+38482536*r**2+239240429*r**4+277504064*r**6+79598981*r**8
        +2114840*r**10-76245*r**12)-Q2**11*(-493297-20511955*r**2+237317447*r**4
        +530987613*r**6+387002253*r**8+41680119*r**10-50819*r**12+56927*r**14)
        +Q2**10*(-1074711-122446116*r**2-261376636*r**4-280696044*r**6-60797850*r**8
        +63891428*r**10-87830460*r**12-2723028*r**14+101673*r**16)+Q2**9*(341275
        +112792173*r**2+851014790*r**4+2103692810*r**6+3429691340*r**8+1396512740*r**10
        +436523258*r**12+153045270*r**14+1716825*r**16+9295*r**18)-Q2**8*(-889251
        -54890208*r**2+590459833*r**4+1670586336*r**6+6297176130*r**8+4841499376*r**10
        +1065281922*r**12+528837568*r**14+37227201*r**16-2320560*r**18+120549*r**20)
        +Q2**7*(-994085-168225927*r**2-357891963*r**4-1950721473*r**6+778030638*r**8
        -777200710*r**10-1046459542*r**12-511955778*r**14+340834967*r**16-105058067*r**18
        -3712335*r**20+89635*r**22)+Q2**6*(70043+76673404*r**2+764189182*r**4
        +3289645276*r**6+8434570341*r**8+17554642744*r**10+19515767172*r**12
        +5395152088*r**14+193046501*r**16-158583284*r**18+89263870*r**20+875276*r**22
        +10907*r**24)-Q2**5*(-508441-63392055*r**2+323302736*r**4-37241456*r**6
        +8386679415*r**8+12693116089*r**10+39203740728*r**12+16900419912*r**14
        +1763653493*r**16-848638885*r**18+178260472*r**20-9932888*r**22-1674323*r**24
        +48803*r**26)+Q2**4*(-316975-76375224*r**2-131177365*r**4-2445366560*r**6
        +714459345*r**8-20178975160*r**10+29566065683*r**12+14255612160*r**14
        +701297035*r**16-975854760*r**18-224047815*r**20+417821216*r**22-41907245*r**24
        -1300200*r**26+21065*r**28)+Q2**3*(-9117+14144121*r**2+170056239*r**4
        +1061850213*r**6+3845099135*r**8+26031776957*r**10-12379537797*r**12
        +4354598937*r**14-11620863591*r**16-3295991205*r**18-152368323*r**20
        -570114849*r**22-193648251*r**24+13345903*r**26-7655*r**28+5283*r**30)
        +Q2**2*(84335+15657956*r**2-57506816*r**4+600798684*r**6-3037842044*r**8
        +3267499140*r**10-12997085632*r**12+6908662492*r**14+18283866522*r**16
        +18885157708*r**18+2821795840*r**20+279101876*r**22+403896324*r**24-108011956*r**26
        +5478336*r**28+391060*r**30-7825*r**32)+3*Q2*(-11737-3122007*r**2+2026122*r**4
        -191370746*r**6+336016054*r**8-4793498550*r**10+15426377970*r**12-23365152962*r**14
        +7896633092*r**16+2428061692*r**18-53763714*r**20+2180654706*r**22+134272058*r**24
        -35892346*r**26+40213254*r**28-1384374*r**30-59419*r**32+907*r**34)
        -3*(-1631-528384*r**2-60287*r**4-41405248*r**6+39342620*r**8-1532131152*r**10
        +8274408172*r**12-29995134624*r**14+52589566534*r**16-43249613040*r**18
        +13813606422*r**20-1374664192*r**22+1391081884*r**24+82272976*r**26-6254580*r**28
        +9760736*r**30-237471*r**32-8848*r**34+113*r**36))*sqrtq2)/(13063680000*logq2**5*r**22*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))+907200000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
        -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+3150000*logq2*(-Q2+(
        -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-75600000*logq2**2*(
        -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
        -52500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
        -5443200000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
        +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
        +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC**2*(-13063680000*logq2**5*(
        -Q2+(-1+r)**2)*(-1+r)*r**22*(1+r)*(-1-4*r**2+r**4)*(-Q2+(1+r)**2)
        +345600*logq2**3*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1510*Q2**10
        -10*Q2**9*(1217+1340*r**2)+Q2**8*(38914+88296*r**2+48718*r**4)-4*Q2**7*(14978
        +55655*r**2+62513*r**4+21401*r**6)+Q2**6*(40537+249593*r**2+437641*r**4
        +311803*r**6+50554*r**8)+2*Q2**5*(-4522-58597*r**2-157854*r**4-87946*r**6
        -36896*r**8+32291*r**10)+Q2**4*(13825+70685*r**2+435854*r**4-83994*r**6
        -494927*r**8-214555*r**10-124040*r**12)+4*Q2**3*(-4196-26604*r**2-173821*r**4
        -239270*r**6+99536*r**8+157876*r**10+53701*r**12+12898*r**14)+Q2**2*(
        -11483+20915*r**2-37639*r**4+1296899*r**6+722823*r**8-296499*r**10
        -16137*r**12-79283*r**14+33364*r**16)-6*Q2*(-3753-9277*r**2-141998*r**4
        +66872*r**6+104896*r**8-64982*r**10-21698*r**12+67848*r**14-4007*r**16
        +6099*r**18)+3*(-2637-8507*r**2-158506*r**4+31980*r**6+60846*r**8
        +54546*r**10+11272*r**12-58604*r**14+69535*r**16-3031*r**18+3106*r**20))
        +48*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(13732*Q2**16-4*Q2**15*(47353
        +38358*r**2)+16*Q2**14*(61440+126801*r**2+41695*r**4)-4*Q2**13*(625335
        +2355206*r**2+2025701*r**4+334560*r**6)+Q2**12*(2909075+19852261*r**2
        +26919373*r**4+13567351*r**6+694420*r**8)+4*Q2**11*(67591-3789481*r**2
        -3135646*r**4+413174*r**6-23561*r**8+551451*r**10)-2*Q2**10*(2387187
        +6956709*r**2+46469020*r**4+121618470*r**6+75093455*r**8+17403309*r**10
        +2177802*r**12)+4*Q2**9*(1050555+9452817*r**2+44889845*r**4+158346325*r**6
        +192722225*r**8+67035635*r**10+11773167*r**12+391215*r**14)+Q2**8*(1715505
        -28210377*r**2-95749107*r**4-410937005*r**6-792237525*r**8-710809155*r**10
        -43163017*r**12-3184167*r**14+3780480*r**16)-4*Q2**7*(1252075-946032*r**2
        +1422224*r**4+97266748*r**6+417275330*r**8+362349120*r**10+123976528*r**12
        +91548124*r**14+11732163*r**16+1174360*r**18)+4*Q2**6*(508519+2517837*r**2
        -6878698*r**4+116345712*r**6+956701522*r**8+1820065866*r**10+1011964312*r**12
        +352634752*r**14+91052087*r**16+9613897*r**18+137874*r**20)+4*Q2**5*(417471
        -3628692*r**2+2418665*r**4+27584610*r**6-486082550*r**8-1911058044*r**10
        -2162635754*r**12-322047760*r**14-182395465*r**16+13982000*r**18+1073793*r**20
        +630926*r**22)-Q2**4*(1738635-11108291*r**2-98084775*r**4+119693075*r**6
        +30034650*r**8-2303000990*r**10-4597246318*r**12-1647663930*r**14+4348988575*r**16
        +348423425*r**18+269938805*r**20+20732359*r**22+1765980*r**24)+4*Q2**3*(44365
        -168481*r**2-21579266*r**4-48289970*r**6-121705525*r**8-856597195*r**10
        -926702748*r**12+129171892*r**14+774057155*r**16+1035739625*r**18+122984030*r**20
        +27550654*r**22+2130149*r**24+5315*r**26)+2*Q2**2*(207925-2739757*r**2
        -5295976*r**4+75992358*r**6-37783225*r**8+1464102285*r**10+3719022894*r**12
        +1270605252*r**14+1124047779*r**16-1909042435*r**18+235556140*r**20-81245162*r**22
        +24148449*r**24+844963*r**26+234510*r**28)-12*Q2*(17681-299923*r**2
        -2883773*r**4+869237*r**6-89227863*r**8-91556851*r**10-475362829*r**12
        +629740421*r**14-399847749*r**16+669430751*r**18-408775791*r**20+164743127*r**22
        -998773*r**24+3966887*r**26+167737*r**28+17711*r**30)+3*(11009-243669*r**2
        -3355115*r**4-2816125*r**6-173583455*r**8-204955457*r**10-2279536943*r**12
        +5652935255*r**14-2856327225*r**16-2218074815*r**18+2709352287*r**20
        -848905207*r**22+221868235*r**24+96725*r**26+3390395*r**28+133661*r**30
        +10444*r**32))+10368000*logq2**4*r**18*(140*Q2**9-20*Q2**8*(37+67*r**2)
        +40*Q2**7*(15+143*r**2+135*r**4)-4*Q2**6*(-959+820*r**2+4419*r**4+2968*r**6)
        +Q2**5*(-10451-16461*r**2+3131*r**4+28433*r**6+14812*r**8)+Q2**4*(7455
        +27268*r**2+32250*r**4+3892*r**6-23801*r**8-8400*r**10)+3*(-1+r**2)**3*(893
        +1101*r**2+4256*r**4+2700*r**6-1481*r**8+575*r**10+356*r**12)-2*Q2**3*(
        -3640+4951*r**2+14331*r**4+9479*r**6+4037*r**8-3342*r**10+1400*r**12)
        +2*Q2**2*(-8260-1241*r**2-808*r**4+970*r**6+6060*r**8-1673*r**10+1032*r**12
        +3920*r**14)-3*Q2*(-3693+1419*r**2-6303*r**4-6919*r**6+11197*r**8
        +8005*r**10-5057*r**12-265*r**14+1616*r**16))*sqrtq2+5760*logq2**2*r**10*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(6530*Q2**13-2*Q2**12*(29810+33381*r**2)
        +Q2**11*(222950+535554*r**2+273424*r**4)-2*Q2**10*(212055+810536*r**2
        +938723*r**4+265806*r**6)+5*Q2**9*(80199+420981*r**2+695193*r**4+588671*r**6
        +66228*r**8)+5*Q2**8*(-23163-104542*r**2+494014*r**4+350048*r**6-172139*r**8
        +112350*r**10)-2*Q2**7*(42345+592898*r**2+7968365*r**4+15766105*r**6
        +8876090*r**8+1900265*r**10+590748*r**12)+2*Q2**6*(47835+237321*r**2
        +8900241*r**4+30452290*r**6+33736125*r**8+11248305*r**10+2623271*r**12
        +262476*r**14)+2*Q2**5*(-73755+168047*r**2-2210999*r**4-20310488*r**6
        -36578550*r**8-22955095*r**10+2043767*r**12-711224*r**14+297897*r**16)
        -10*Q2**4*(-18088-81392*r**2+14524*r**4-1528049*r**6-3764684*r**8-227915*r**10
        +2109244*r**12+3000409*r**14+213868*r**16+76019*r**18)+10*Q2**3*(-4034
        -129699*r**2-384777*r**4-2304099*r**6-7861977*r**8-1949469*r**10+4183053*r**12
        +4553667*r**14+1828251*r**16+186752*r**18+16092*r**20)+2*Q2**2*(-45220
        +93479*r**2-275560*r**4+4106970*r**6+23915580*r**8+54958890*r**10-838788*r**12
        +2466180*r**14-13924200*r**16+3096415*r**18-164900*r**20+94354*r**22)
        -3*Q2*(-23835-130643*r**2-1604423*r**4-4216535*r**6-27092370*r**8+27984390*r**10
        +595086*r**12-9374994*r**14+15281685*r**16-4811955*r**18+3298745*r**20
        +52457*r**22+42392*r**24)+3*(-5335-50224*r**2-684302*r**4-2005474*r**6
        -21389585*r**8+28542230*r**10+4527628*r**12-16824396*r**14+69143*r**16
        +8610260*r**18-1737470*r**20+921646*r**22+17873*r**24+8006*r**26))*sqrtq2
        +4*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(92*Q2**18+60*Q2**17*(1
        +r**2)+4*Q2**16*(-1519+3228*r**2+1499*r**4)-Q2**15*(-34969+160589*r**2
        +1046341*r**4+72623*r**6)+Q2**14*(-94735+776500*r**2+10808350*r**4+8852676*r**6
        +299825*r**8)-Q2**13*(-135799+1877655*r**2+43289452*r**4+82368756*r**6
        +29535579*r**8+576101*r**10)+Q2**12*(-76245+2114840*r**2+79598981*r**4
        +277504064*r**6+239240429*r**8+38482536*r**10+381315*r**12)+Q2**11*(
        -56927+50819*r**2-41680119*r**4-387002253*r**6-530987613*r**8-237317447*r**10
        +20511955*r**12+493297*r**14)-Q2**10*(-101673+2723028*r**2+87830460*r**4
        -63891428*r**6+60797850*r**8+280696044*r**10+261376636*r**12+122446116*r**14
        +1074711*r**16)+Q2**9*(9295+1716825*r**2+153045270*r**4+436523258*r**6
        +1396512740*r**8+3429691340*r**10+2103692810*r**12+851014790*r**14+112792173*r**16
        +341275*r**18)+Q2**8*(-120549+2320560*r**2-37227201*r**4-528837568*r**6
        -1065281922*r**8-4841499376*r**10-6297176130*r**12-1670586336*r**14-590459833*r**16
        +54890208*r**18+889251*r**20)-Q2**7*(-89635+3712335*r**2+105058067*r**4
        -340834967*r**6+511955778*r**8+1046459542*r**10+777200710*r**12-778030638*r**14
        +1950721473*r**16+357891963*r**18+168225927*r**20+994085*r**22)+Q2**6*(10907
        +875276*r**2+89263870*r**4-158583284*r**6+193046501*r**8+5395152088*r**10
        +19515767172*r**12+17554642744*r**14+8434570341*r**16+3289645276*r**18
        +764189182*r**20+76673404*r**22+70043*r**24)+Q2**5*(-48803+1674323*r**2
        +9932888*r**4-178260472*r**6+848638885*r**8-1763653493*r**10-16900419912*r**12
        -39203740728*r**14-12693116089*r**16-8386679415*r**18+37241456*r**20
        -323302736*r**22+63392055*r**24+508441*r**26)-Q2**4*(-21065+1300200*r**2
        +41907245*r**4-417821216*r**6+224047815*r**8+975854760*r**10-701297035*r**12
        -14255612160*r**14-29566065683*r**16+20178975160*r**18-714459345*r**20
        +2445366560*r**22+131177365*r**24+76375224*r**26+316975*r**28)+Q2**3*(5283
        -7655*r**2+13345903*r**4-193648251*r**6-570114849*r**8-152368323*r**10
        -3295991205*r**12-11620863591*r**14+4354598937*r**16-12379537797*r**18
        +26031776957*r**20+3845099135*r**22+1061850213*r**24+170056239*r**26
        +14144121*r**28-9117*r**30)+Q2**2*(-7825+391060*r**2+5478336*r**4-108011956*r**6
        +403896324*r**8+279101876*r**10+2821795840*r**12+18885157708*r**14+18283866522*r**16
        +6908662492*r**18-12997085632*r**20+3267499140*r**22-3037842044*r**24
        +600798684*r**26-57506816*r**28+15657956*r**30+84335*r**32)-3*Q2*(-907
        +59419*r**2+1384374*r**4-40213254*r**6+35892346*r**8-134272058*r**10
        -2180654706*r**12+53763714*r**14-2428061692*r**16-7896633092*r**18+23365152962*r**20
        -15426377970*r**22+4793498550*r**24-336016054*r**26+191370746*r**28-2026122*r**30
        +3122007*r**32+11737*r**34)+3*(-113+8848*r**2+237471*r**4-9760736*r**6
        +6254580*r**8-82272976*r**10-1391081884*r**12+1374664192*r**14-13813606422*r**16
        +43249613040*r**18-52589566534*r**20+29995134624*r**22-8274408172*r**24
        +1532131152*r**26-39342620*r**28+41405248*r**30+60287*r**32+528384*r**34
        +1631*r**36))*sqrtq2))/(13063680000*logq2**5*r**22*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))+907200000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2+3150000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
        +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-75600000*logq2**2*(-Q2+(-1+r)**2)*r**10*(
        -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-52500*(-Q2+(
        -1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2-5443200000*logq2**4*r**18*(Q2**5
        -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
        +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
        -3*r**8))*sqrtq2)+(muWC*(-104509440000*logq2**5*(-Q2+(-1+r)**2)*(-1
        +r)*r**22*(1+r)*(-1-4*r**2+r**4)*(-Q2+(1+r)**2)+2764800*logq2**3*r**14*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1510*Q2**10-10*Q2**9*(1217+1340*r**2)
        +Q2**8*(38914+88296*r**2+48718*r**4)-4*Q2**7*(14978+55655*r**2+62513*r**4
        +21401*r**6)+Q2**6*(40537+249593*r**2+437641*r**4+311803*r**6+50554*r**8)
        +2*Q2**5*(-4522-58597*r**2-157854*r**4-87946*r**6-36896*r**8+32291*r**10)
        +Q2**4*(13825+70685*r**2+435854*r**4-83994*r**6-494927*r**8-214555*r**10
        -124040*r**12)+4*Q2**3*(-4196-26604*r**2-173821*r**4-239270*r**6+99536*r**8
        +157876*r**10+53701*r**12+12898*r**14)+Q2**2*(-11483+20915*r**2-37639*r**4
        +1296899*r**6+722823*r**8-296499*r**10-16137*r**12-79283*r**14+33364*r**16)
        -6*Q2*(-3753-9277*r**2-141998*r**4+66872*r**6+104896*r**8-64982*r**10
        -21698*r**12+67848*r**14-4007*r**16+6099*r**18)+3*(-2637-8507*r**2
        -158506*r**4+31980*r**6+60846*r**8+54546*r**10+11272*r**12-58604*r**14
        +69535*r**16-3031*r**18+3106*r**20))+384*logq2*r**6*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))**3*(13732*Q2**16-4*Q2**15*(47353+38358*r**2)+16*Q2**14*(61440
        +126801*r**2+41695*r**4)-4*Q2**13*(625335+2355206*r**2+2025701*r**4
        +334560*r**6)+Q2**12*(2909075+19852261*r**2+26919373*r**4+13567351*r**6
        +694420*r**8)+4*Q2**11*(67591-3789481*r**2-3135646*r**4+413174*r**6
        -23561*r**8+551451*r**10)-2*Q2**10*(2387187+6956709*r**2+46469020*r**4
        +121618470*r**6+75093455*r**8+17403309*r**10+2177802*r**12)+4*Q2**9*(1050555
        +9452817*r**2+44889845*r**4+158346325*r**6+192722225*r**8+67035635*r**10
        +11773167*r**12+391215*r**14)+Q2**8*(1715505-28210377*r**2-95749107*r**4
        -410937005*r**6-792237525*r**8-710809155*r**10-43163017*r**12-3184167*r**14
        +3780480*r**16)-4*Q2**7*(1252075-946032*r**2+1422224*r**4+97266748*r**6
        +417275330*r**8+362349120*r**10+123976528*r**12+91548124*r**14+11732163*r**16
        +1174360*r**18)+4*Q2**6*(508519+2517837*r**2-6878698*r**4+116345712*r**6
        +956701522*r**8+1820065866*r**10+1011964312*r**12+352634752*r**14+91052087*r**16
        +9613897*r**18+137874*r**20)+4*Q2**5*(417471-3628692*r**2+2418665*r**4
        +27584610*r**6-486082550*r**8-1911058044*r**10-2162635754*r**12-322047760*r**14
        -182395465*r**16+13982000*r**18+1073793*r**20+630926*r**22)-Q2**4*(1738635
        -11108291*r**2-98084775*r**4+119693075*r**6+30034650*r**8-2303000990*r**10
        -4597246318*r**12-1647663930*r**14+4348988575*r**16+348423425*r**18+269938805*r**20
        +20732359*r**22+1765980*r**24)+4*Q2**3*(44365-168481*r**2-21579266*r**4
        -48289970*r**6-121705525*r**8-856597195*r**10-926702748*r**12+129171892*r**14
        +774057155*r**16+1035739625*r**18+122984030*r**20+27550654*r**22+2130149*r**24
        +5315*r**26)+2*Q2**2*(207925-2739757*r**2-5295976*r**4+75992358*r**6
        -37783225*r**8+1464102285*r**10+3719022894*r**12+1270605252*r**14+1124047779*r**16
        -1909042435*r**18+235556140*r**20-81245162*r**22+24148449*r**24+844963*r**26
        +234510*r**28)-12*Q2*(17681-299923*r**2-2883773*r**4+869237*r**6-89227863*r**8
        -91556851*r**10-475362829*r**12+629740421*r**14-399847749*r**16+669430751*r**18
        -408775791*r**20+164743127*r**22-998773*r**24+3966887*r**26+167737*r**28
        +17711*r**30)+3*(11009-243669*r**2-3355115*r**4-2816125*r**6-173583455*r**8
        -204955457*r**10-2279536943*r**12+5652935255*r**14-2856327225*r**16-2218074815*r**18
        +2709352287*r**20-848905207*r**22+221868235*r**24+96725*r**26+3390395*r**28
        +133661*r**30+10444*r**32))+82944000*logq2**4*r**18*(140*Q2**9-20*Q2**8*(37
        +67*r**2)+40*Q2**7*(15+143*r**2+135*r**4)-4*Q2**6*(-959+820*r**2+4419*r**4
        +2968*r**6)+Q2**5*(-10451-16461*r**2+3131*r**4+28433*r**6+14812*r**8)
        +Q2**4*(7455+27268*r**2+32250*r**4+3892*r**6-23801*r**8-8400*r**10)
        +3*(-1+r**2)**3*(893+1101*r**2+4256*r**4+2700*r**6-1481*r**8+575*r**10
        +356*r**12)-2*Q2**3*(-3640+4951*r**2+14331*r**4+9479*r**6+4037*r**8
        -3342*r**10+1400*r**12)+2*Q2**2*(-8260-1241*r**2-808*r**4+970*r**6
        +6060*r**8-1673*r**10+1032*r**12+3920*r**14)-3*Q2*(-3693+1419*r**2
        -6303*r**4-6919*r**6+11197*r**8+8005*r**10-5057*r**12-265*r**14+1616*r**16))*sqrtq2
        +46080*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(6530*Q2**13
        -2*Q2**12*(29810+33381*r**2)+Q2**11*(222950+535554*r**2+273424*r**4)
        -2*Q2**10*(212055+810536*r**2+938723*r**4+265806*r**6)+5*Q2**9*(80199
        +420981*r**2+695193*r**4+588671*r**6+66228*r**8)+5*Q2**8*(-23163-104542*r**2
        +494014*r**4+350048*r**6-172139*r**8+112350*r**10)-2*Q2**7*(42345+592898*r**2
        +7968365*r**4+15766105*r**6+8876090*r**8+1900265*r**10+590748*r**12)
        +2*Q2**6*(47835+237321*r**2+8900241*r**4+30452290*r**6+33736125*r**8
        +11248305*r**10+2623271*r**12+262476*r**14)+2*Q2**5*(-73755+168047*r**2
        -2210999*r**4-20310488*r**6-36578550*r**8-22955095*r**10+2043767*r**12
        -711224*r**14+297897*r**16)-10*Q2**4*(-18088-81392*r**2+14524*r**4-1528049*r**6
        -3764684*r**8-227915*r**10+2109244*r**12+3000409*r**14+213868*r**16
        +76019*r**18)+10*Q2**3*(-4034-129699*r**2-384777*r**4-2304099*r**6-7861977*r**8
        -1949469*r**10+4183053*r**12+4553667*r**14+1828251*r**16+186752*r**18
        +16092*r**20)+2*Q2**2*(-45220+93479*r**2-275560*r**4+4106970*r**6+23915580*r**8
        +54958890*r**10-838788*r**12+2466180*r**14-13924200*r**16+3096415*r**18
        -164900*r**20+94354*r**22)-3*Q2*(-23835-130643*r**2-1604423*r**4-4216535*r**6
        -27092370*r**8+27984390*r**10+595086*r**12-9374994*r**14+15281685*r**16
        -4811955*r**18+3298745*r**20+52457*r**22+42392*r**24)+3*(-5335-50224*r**2
        -684302*r**4-2005474*r**6-21389585*r**8+28542230*r**10+4527628*r**12
        -16824396*r**14+69143*r**16+8610260*r**18-1737470*r**20+921646*r**22
        +17873*r**24+8006*r**26))*sqrtq2+32*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**3*(92*Q2**18+60*Q2**17*(1+r**2)+4*Q2**16*(-1519+3228*r**2+1499*r**4)
        -Q2**15*(-34969+160589*r**2+1046341*r**4+72623*r**6)+Q2**14*(-94735
        +776500*r**2+10808350*r**4+8852676*r**6+299825*r**8)-Q2**13*(-135799
        +1877655*r**2+43289452*r**4+82368756*r**6+29535579*r**8+576101*r**10)
        +Q2**12*(-76245+2114840*r**2+79598981*r**4+277504064*r**6+239240429*r**8
        +38482536*r**10+381315*r**12)+Q2**11*(-56927+50819*r**2-41680119*r**4
        -387002253*r**6-530987613*r**8-237317447*r**10+20511955*r**12+493297*r**14)
        -Q2**10*(-101673+2723028*r**2+87830460*r**4-63891428*r**6+60797850*r**8
        +280696044*r**10+261376636*r**12+122446116*r**14+1074711*r**16)+Q2**9*(9295
        +1716825*r**2+153045270*r**4+436523258*r**6+1396512740*r**8+3429691340*r**10
        +2103692810*r**12+851014790*r**14+112792173*r**16+341275*r**18)+Q2**8*(
        -120549+2320560*r**2-37227201*r**4-528837568*r**6-1065281922*r**8-4841499376*r**10
        -6297176130*r**12-1670586336*r**14-590459833*r**16+54890208*r**18+889251*r**20)
        -Q2**7*(-89635+3712335*r**2+105058067*r**4-340834967*r**6+511955778*r**8
        +1046459542*r**10+777200710*r**12-778030638*r**14+1950721473*r**16+357891963*r**18
        +168225927*r**20+994085*r**22)+Q2**6*(10907+875276*r**2+89263870*r**4
        -158583284*r**6+193046501*r**8+5395152088*r**10+19515767172*r**12+17554642744*r**14
        +8434570341*r**16+3289645276*r**18+764189182*r**20+76673404*r**22+70043*r**24)
        +Q2**5*(-48803+1674323*r**2+9932888*r**4-178260472*r**6+848638885*r**8
        -1763653493*r**10-16900419912*r**12-39203740728*r**14-12693116089*r**16
        -8386679415*r**18+37241456*r**20-323302736*r**22+63392055*r**24+508441*r**26)
        -Q2**4*(-21065+1300200*r**2+41907245*r**4-417821216*r**6+224047815*r**8
        +975854760*r**10-701297035*r**12-14255612160*r**14-29566065683*r**16
        +20178975160*r**18-714459345*r**20+2445366560*r**22+131177365*r**24+76375224*r**26
        +316975*r**28)+Q2**3*(5283-7655*r**2+13345903*r**4-193648251*r**6-570114849*r**8
        -152368323*r**10-3295991205*r**12-11620863591*r**14+4354598937*r**16
        -12379537797*r**18+26031776957*r**20+3845099135*r**22+1061850213*r**24
        +170056239*r**26+14144121*r**28-9117*r**30)+Q2**2*(-7825+391060*r**2
        +5478336*r**4-108011956*r**6+403896324*r**8+279101876*r**10+2821795840*r**12
        +18885157708*r**14+18283866522*r**16+6908662492*r**18-12997085632*r**20
        +3267499140*r**22-3037842044*r**24+600798684*r**26-57506816*r**28+15657956*r**30
        +84335*r**32)-3*Q2*(-907+59419*r**2+1384374*r**4-40213254*r**6+35892346*r**8
        -134272058*r**10-2180654706*r**12+53763714*r**14-2428061692*r**16-7896633092*r**18
        +23365152962*r**20-15426377970*r**22+4793498550*r**24-336016054*r**26
        +191370746*r**28-2026122*r**30+3122007*r**32+11737*r**34)+3*(-113+8848*r**2
        +237471*r**4-9760736*r**6+6254580*r**8-82272976*r**10-1391081884*r**12
        +1374664192*r**14-13813606422*r**16+43249613040*r**18-52589566534*r**20
        +29995134624*r**22-8274408172*r**24+1532131152*r**26-39342620*r**28+41405248*r**30
        +60287*r**32+528384*r**34+1631*r**36))*sqrtq2))/(39191040000*logq2**5*r**22*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))+2721600000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
        -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+9450000*logq2*(-Q2+(
        -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-226800000*logq2**2*(
        -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
        -157500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
        -16329600000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
        +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
        +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC**3*(-20736000*logq2**4*r**12*(105*Q2**9*(1
        +5*r**4)-5*Q2**8*(249+361*r**2+1101*r**4+1005*r**6)+10*Q2**7*(597+1621*r**2
        +3496*r**4+4343*r**6+2025*r**8)-2*Q2**6*(7812+29149*r**2+64765*r**4
        +93125*r**6+69133*r**8+22260*r**10)+Q2**5*(22974+106027*r**2+250778*r**4
        +470915*r**6+412871*r**8+222906*r**10+55545*r**12)-Q2**4*(15540+92822*r**2
        +231869*r**4+588590*r**6+701120*r**8+419048*r**10+170935*r**12+31500*r**14)
        +2*Q2**3*(-1575+11024*r**2+40642*r**4+140278*r**6+184250*r**8+213791*r**10
        +81491*r**12+6005*r**14-5250*r**16)+(-1+r**2)**2*(1821+1633*r**2+608*r**4
        +116088*r**6-193788*r**8-187194*r**10+70224*r**12-1996*r**14+12199*r**16
        +4005*r**18)+Q2**2*(13020+15118*r**2-11915*r**4+119156*r**6-143159*r**8
        -108758*r**10-29109*r**12-13188*r**14+70635*r**16+29400*r**18)+Q2*(
        -8331-4469*r**2+12109*r**4-306011*r**6+264845*r**8+760417*r**10+146475*r**12
        -137073*r**14+34282*r**16-38464*r**18-18180*r**20))-5760*logq2**2*(-Q2
        +(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(9795*Q2**15*(1+5*r**4)-Q2**14*(120261
        +121493*r**2+521937*r**4+598665*r**6)+Q2**13*(604329+1271816*r**2+3448100*r**4
        +5662978*r**6+3101085*r**8)-Q2**12*(1583961+5382217*r**2+14984690*r**4
        +28081086*r**6+25269377*r**8+8589165*r**10)+Q2**11*(2105649+11648083*r**2
        +36582862*r**4+85246604*r**6+92230079*r**8+57617593*r**10+12508410*r**12)
        -Q2**10*(491931+12207009*r**2+35377311*r**4+134400931*r**6+171469901*r**8
        +105720395*r**10+60971217*r**12+4741065*r**14)-Q2**9*(2776653-630711*r**2
        +40542531*r**4-18250145*r**6-76727145*r**8+99740803*r**10+137775089*r**12
        +9194301*r**14+14803920*r**16)+Q2**8*(4096917+13919013*r**2+148377380*r**4
        +308632144*r**6+276891690*r**8+613334922*r**10+965758108*r**12+553194480*r**14
        +104109969*r**16+25872705*r**18)-Q2**7*(1474803+15840426*r**2+133162825*r**4
        +526474548*r**6+441833406*r**8+535880328*r**10+1378107826*r**12+1544646700*r**14
        +552418143*r**16+112180446*r**18+12267045*r**20)-Q2**6*(1984323-5804169*r**2
        +37730299*r**4-375497397*r**6+59872778*r**8+1109296634*r**10+899482146*r**12
        -562848086*r**14-848754237*r**16+108366543*r**18-25743789*r**20+10701195*r**22)
        +Q2**5*(2538327+2759198*r**2+163842602*r**4-105799688*r**6+754730047*r**8
        +3936007492*r**10+6253024212*r**12+5020022232*r**14+1457563277*r**16
        +277470622*r**18+679323650*r**20+45080784*r**22+17078205*r**24)-Q2**4*(816711
        +4176143*r**2+106088382*r**4+37433530*r**6+675121145*r**8+5072470653*r**10
        +10494698764*r**12+12060215356*r**14+7391704305*r**16+1851552905*r**18
        +608344086*r**20+492090218*r**22+42539887*r**24+6699915*r**26)+Q2**3*(
        -449121+2478871*r**2-15046580*r**4+146543328*r**6-217727825*r**8+2390168207*r**10
        +6033710428*r**12+8865032760*r**14+8622117469*r**16+3173450165*r**18
        -114834436*r**20+529359176*r**22-28759755*r**24+12234053*r**26-2577540*r**28)
        +(-1+r**2)**2*(22059-8871*r**2+4419683*r**4-20995819*r**6+139149983*r**8
        +108523417*r**10-822294713*r**12+958091149*r**14-873751727*r**16-1787782061*r**18
        +714996889*r**20+332955959*r**22-45911707*r**24+21722171*r**26+603453*r**28
        +180135*r**30)+Q2**2*(491139-1071907*r**2+52895515*r**4-206636041*r**6
        +887443983*r**8+331547957*r**10-575705201*r**12+1159538095*r**14-467647463*r**16
        -3196260881*r**18+1744035569*r**20+1843553133*r**22-528696235*r**24+221511679*r**26
        +1577573*r**28+3503085*r**30)-Q2*(170451-340323*r**2+26200363*r**4
        -129435949*r**6+685390901*r**8+206205825*r**10-1660142489*r**12+533888479*r**14
        -2084679017*r**16-716426537*r**18-4677079583*r**20+1411398297*r**22+1553436983*r**24
        -348894709*r**26+117080461*r**28+1592757*r**30+1314090*r**32))-8*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(552*Q2**20+Q2**19*(1230-86*r**2)+8*Q2**18*(993
        +5225*r**2+2309*r**4)-Q2**17*(793689+350881*r**2+3840383*r**4+361615*r**6)
        +Q2**16*(6432021+485746*r**2+21116616*r**4+38837094*r**6+2083563*r**8)
        -2*Q2**15*(11471247-3133150*r**2-25946401*r**4+101248489*r**6+84688408*r**8
        +2973871*r**10)+Q2**14*(40359885-25706302*r**2-675511331*r**4-240427744*r**6
        +819403091*r**8+369434110*r**10+8820563*r**12)-2*Q2**13*(9542901+2669295*r**2
        -1085865336*r**4-1900280100*r**6-466447889*r**8+803851653*r**10+146175660*r**12
        +1926168*r**14)-Q2**12*(59715123-229084978*r**2+3370785104*r**4+12061520622*r**6
        +13661765622*r**8+4700526258*r**10-1023582864*r**12+443437586*r**14+8895575*r**16)
        +2*Q2**11*(59958951-268593854*r**2+1107903779*r**4+11402737423*r**6+22250625111*r**8
        +21253490637*r**10+7314514917*r**12+1008667129*r**14+657468074*r**16
        +7744633*r**18)-Q2**10*(58479135-343542210*r**2-1563244539*r**4+28898194668*r**6
        +83780882714*r**8+119396855352*r**10+86936703870*r**12+20253826772*r**14
        +5147480295*r**16+1012294602*r**18+4642781*r**20)-2*Q2**9*(40320930-289047506*r**2
        +3077122489*r**4-7457575429*r**6-38957895394*r**8-82778419030*r**10-77053270204*r**12
        -39150651796*r**14+935601416*r**16-2231515984*r**18+284894555*r**20+6165809*r**22)
        +Q2**8*(131865747-1224415370*r**2+8366116250*r**4+22850768770*r**6+14448039489*r**8
        -64268195484*r**10-79801386780*r**12+13590947148*r**14+34024103325*r**16
        +42359779974*r**18-138163070*r**20+1608087890*r**22+15087631*r**24)-2*Q2**7*(23013981
        -298988206*r**2+2129722329*r**4+24289171323*r**6+44661674978*r**8+47234796729*r**10
        +36834968682*r**12+99832766070*r**14+112780665993*r**16+70234457628*r**18
        +22785681581*r**20+1785794655*r**22+443650152*r**24+1609065*r**26)+Q2**6*(
        -50293017+573373078*r**2-4626548429*r**4+31899242456*r**6+36006884167*r**8
        +122998331518*r**10-10829320837*r**12+138039439968*r**14+312641956557*r**16
        +104398998674*r**18+120087044929*r**20-4550430776*r**22+3888809861*r**24
        -428397478*r**26-6511471*r**28)+2*Q2**5*(29194197-444109285*r**2+4525970488*r**4
        -275635120*r**6+18388466093*r**8-60188517893*r**10+167931853520*r**12
        +190859318848*r**14+102048773903*r**16-113442017999*r**18+106822746176*r**20
        -18953374040*r**22+21874725359*r**24-911000263*r**26+391781176*r**28
        +2932040*r**30)-Q2**4*(16040505-330507126*r**2+4716323316*r**4+11233089714*r**6
        +15112005104*r**8-109573193430*r**10+588173222796*r**12+1020409892898*r**14
        +1022875599762*r**16+793357092462*r**18-158390301780*r**20+246316285446*r**22
        +12506888136*r**24+28602910174*r**26+237801684*r**28+303592230*r**30
        +1130109*r**32)+2*Q2**3*(-4614882+74166205*r**2-641187947*r**4+4894880565*r**6
        -13870779821*r**8+15069143875*r**10+131583868765*r**12+374509317573*r**14
        +620236955535*r**16+357597187597*r**18+244037521191*r**20+44917866615*r**22
        -6716860655*r**24+18960340425*r**26-1947071001*r**28+487848591*r**30
        -44487185*r**32-543446*r**34)+2*(-1+r**2)**2*(156654-4170412*r**2+84909051*r**4
        -230578818*r**6+358432710*r**8-5882078502*r**10+74768865726*r**12-231116744978*r**14
        +245764096194*r**16+10125137730*r**18-301537274708*r**20+192462278634*r**22
        -40827260622*r**24+11311878366*r**26-1463840190*r**28+470139306*r**30
        -9537448*r**32+2698674*r**34+12633*r**36)+Q2**2*(8644899-184657634*r**2
        +2643449645*r**4-7304295692*r**6+26751377328*r**8-128117752164*r**10
        +487154478120*r**12-363509890492*r**14+372778090654*r**16-540957326056*r**18
        -236996217094*r**20+896363366812*r**22-445606313176*r**24+180868302468*r**26
        -43091242272*r**28+13124189484*r**30-673003673*r**32+121417898*r**34
        +820945*r**36)-Q2*(2682531-67137509*r**2+1183056495*r**4-3779339229*r**6
        +10174715552*r**8-75459588888*r**10+590033884272*r**12-1177510543480*r**14
        +327748803822*r**16+838933914054*r**18-299472890442*r**20-1671324890442*r**22
        +1404998019000*r**24-419673325232*r**26+125884294536*r**28-23421714576*r**30
        +6145926679*r**32-221450265*r**34+42311139*r**36+231983*r**38))-4354560000*logq2**5*r**16*(9
        +33*r**2+124*r**4-512*r**6+163*r**8+15*r**10)*sqrtq2-345600*logq2**3*r**8*(2265*Q2**12*(1
        +5*r**4)-10*Q2**11*(2439+2383*r**2+10431*r**4+12315*r**6)+2*Q2**10*(57951
        +108258*r**2+244605*r**4+469607*r**6+288855*r**8)-10*Q2**9*(29970+83928*r**2
        +146473*r**4+295842*r**6+354501*r**8+147330*r**10)+10*Q2**8*(41607+170403*r**2
        +278381*r**4+438443*r**6+778226*r**8+693972*r**10+202860*r**12)-5*Q2**7*(38556
        +357489*r**2+504564*r**4+81617*r**6+473328*r**8+1688379*r**10+1329480*r**12
        +183195*r**14)-5*Q2**6*(57960-124467*r**2+295925*r**4+2741021*r**6+5136449*r**8
        +4066963*r**10+490035*r**12-165669*r**14+303975*r**16)+Q2**5*(516456
        +573363*r**2+6551210*r**4+31603502*r**6+74308470*r**8+90473156*r**10
        +56145758*r**12+15840170*r**14+4559562*r**16+2731905*r**18)-5*Q2**4*(52515
        +155709*r**2+1212342*r**4+6057464*r**6+18583638*r**8+30158754*r**10
        +25695316*r**12+11271144*r**14+2845431*r**16+897153*r**18+290790*r**20)
        -5*Q2**3*(15654-103659*r**2+43130*r**4-1514209*r**6-9251464*r**8-16383518*r**10
        -20394136*r**12-15196618*r**14-1758062*r**16+32217*r**18-420306*r**20
        +77595*r**22)+(-1+r**2)**2*(11592-18345*r**2+695733*r**4-81745*r**6
        +3122037*r**8-1180470*r**10-14149954*r**12-15771798*r**14+390*r**16
        +4605983*r**18+1554573*r**20-25881*r**22+69885*r**24)+5*Q2**2*(31338
        -69451*r**2+887491*r**4+908653*r**6-272311*r**8+1288894*r**10-641462*r**12
        -3234082*r**14-4073984*r**16+4774573*r**18+1844691*r**20-206955*r**22
        +173805*r**24)-5*Q2*(14292-36669*r**2+633636*r**4+13564*r**6+1113684*r**8
        +2288967*r**10-11520768*r**12-8298456*r**14-2304012*r**16-3015687*r**18
        +2866908*r**20+1350204*r**22-122908*r**24+82845*r**26))*sqrtq2+48*logq2*(250*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**3*(111+105*Q2**7-4517*r**2-91999*r**4-164085*r**6
        +1160315*r**8+1928089*r**10+482547*r**12+59769*r**14+1530*r**16-5*Q2**6*(
        -81+31*r**2+240*r**4)+15*Q2**5*(-29-16*r**2+59*r**4+60*r**6)-Q2**4*(
        -321+243*r**2+50107*r**4+69411*r**6+9180*r**8)+Q2**3*(-729-1592*r**2
        +81550*r**4+220582*r**6+137739*r**8+14130*r**10)+Q2**2*(-309-1389*r**2
        -6978*r**4-105212*r**6-125831*r**8-9611*r**10+3210*r**12)+Q2*(531
        -5304*r**2-92255*r**4+33430*r**6+433925*r**8+246424*r**10-45401*r**12
        -9390*r**14))-21*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1
        +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
        -14*r**2-94*r**4-14*r**6+r**8))**2*(12*Q2**10*(16+205*r**4)-60*Q2**9*(12
        +12*r**2+211*r**4+275*r**6)+5*Q2**8*(135+270*r**2+4314*r**4+11146*r**6
        +7335*r**8)-60*Q2**7*(-8+24*r**2+157*r**4+1047*r**6+1313*r**8+335*r**10)
        -30*Q2**6*(30-60*r**2+1447*r**4-433*r**6-2349*r**8-1871*r**10+1260*r**12)
        -60*Q2**3*r**4*(911-1449*r**2-3631*r**4-8165*r**6-7971*r**8-5223*r**10
        -2237*r**12+405*r**14)+4*Q2**5*(-36+540*r**2+28785*r**4+42905*r**6
        +47430*r**8+26514*r**10-8755*r**12+13545*r**14)-30*Q2**4*(-19+186*r**2
        +2071*r**4+5553*r**6+13432*r**8+25138*r**10+17181*r**12+1723*r**14
        +175*r**16)+120*Q2*r**4*(116-1379*r**2-13454*r**4-26131*r**6-17070*r**8
        +5559*r**10+4294*r**12-3241*r**14-574*r**16+40*r**18)-3*(-1+r**2)**2*(
        -9+252*r**2+1793*r**4-41806*r**6-222100*r**8-331426*r**10+64268*r**12
        +55502*r**14-35299*r**16-10330*r**18+755*r**20)+10*Q2**2*(-18+324*r**2
        +3303*r**4-12811*r**6+4917*r**8-22143*r**10-69061*r**12+4839*r**14
        +41457*r**16-3457*r**18+810*r**20))+5*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(30*Q2**15*(1408
        +21355*r**4)-2*Q2**14*(96000+94432*r**2+1841499*r**4+2340195*r**6)+2*Q2**13*(104790
        +289648*r**2+3915889*r**4+9514666*r**6+5723805*r**8)-2*Q2**12*(-133320
        +288212*r**2+3327327*r**4+13894203*r**6+15357559*r**8+3207495*r**10)
        -Q2**11*(609120+109589*r**2+10179979*r**4-5890972*r**6+7743536*r**8
        -6924137*r**10+16303365*r**12)+Q2**10*(-40920+1633551*r**2+30535728*r**4
        +65571913*r**6+235481588*r**8+272338493*r**10+42702732*r**12+22088835*r**14)
        +Q2**9*(641100-1712547*r**2+31855101*r**4+21155575*r**6-292239145*r**8
        -760113305*r**10-578560777*r**12-81091979*r**14+9040905*r**16)-Q2**8*(42360
        +3220167*r**2+163398546*r**4+343826564*r**6+457158230*r**8+205758050*r**10
        +11525982*r**12+39997316*r**14-36530286*r**16+27976095*r**18)+2*Q2**7*(
        -254640+2882199*r**2+59353974*r**4+212515616*r**6+792221208*r**8+1247452960*r**10
        +1272164694*r**12+879465024*r**14+591679136*r**16+53346393*r**18+2437740*r**20)
        +2*Q2**6*(27720+789339*r**2+49458789*r**4-137890762*r**6-928880024*r**8
        -2512926912*r**10-3883645666*r**12-2844620746*r**14-654115832*r**16-302888899*r**18
        -64932987*r**20+7687740*r**22)-2*Q2**5*(-155010+3179651*r**2+75489978*r**4
        +9011143*r**6+1178158688*r**8+1814989088*r**10+143656338*r**12-3265427532*r**14
        -2615233912*r**16-196798587*r**18+465594828*r**20+20256957*r**22+3747810*r**24)
        +2*Q2**4*(-34800+429893*r**2+13092911*r**4+254473345*r**6+3066154535*r**8
        +5518907760*r**10+6022535174*r**12+6239930638*r**14+7188662350*r**16
        +3828621065*r**18+247777115*r**20+414022033*r**22+54467051*r**24-1103070*r**26)
        +Q2**3*(-102720+2946871*r**2+35076693*r**4-430516868*r**6-1622270680*r**8
        -2407501785*r**10-3972479207*r**12-2896383656*r**14-1879468064*r**16
        -11455837155*r**18-12282676545*r**20-2245358164*r**22+56844088*r**24
        -12757243*r**26+1697235*r**28)-(-1+r**2)**2*(6840-262821*r**2+694140*r**4
        +53693853*r**6+340327528*r**8+1056435675*r**10+19830812092*r**12+41828023405*r**14
        +31273693864*r**16+1060482649*r**18-2366456780*r**20+2425860079*r**22
        +553946680*r**24+35499633*r**26-2265452*r**28+132615*r**30)-Q2**2*(-29640
        +759349*r**2+18796244*r**4+90389751*r**6+2573379748*r**8-4264509115*r**10
        -16074629528*r**12-38907744713*r**14-43242750992*r**16-9250682441*r**18
        +9496395540*r**20+4191654029*r**22-988650956*r**24+236074191*r**26+30677168*r**28
        +247365*r**30)+Q2*(18180-712839*r**2+5167701*r**4+197422827*r**6+1553553159*r**8
        -2371820983*r**10+36772678093*r**12+121033122043*r**14+172424472631*r**16
        +58661293507*r**18-8400275609*r**20-4648158839*r**22+8076387181*r**24
        +934073467*r**26+119024759*r**28+5960337*r**30+290385*r**32)))*sqrtq2))/(36741600000*logq2**4*r**16*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))+510300000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
        +354375*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
        +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-88179840000*logq2**5*r**20*sqrtq2
        -6123600000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
        -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-21262500*logq2*r**4*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**4*sqrtq2)+((-13063680000*logq2**5*(-Q2+(-1+r)**2)*(
        -1+r)*r**24*(1+r)*(-1+4*r**2+r**4)*(-Q2+(1+r)**2)-345600*logq2**3*r**14*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-1510*Q2**10+10*Q2**9*(1340+1217*r**2)
        -2*Q2**8*(24359+44148*r**2+19457*r**4)+4*Q2**7*(21401+62513*r**2+55655*r**4
        +14978*r**6)-Q2**6*(50554+311803*r**2+437641*r**4+249593*r**6+40537*r**8)
        +2*Q2**5*(-32291+36896*r**2+87946*r**4+157854*r**6+58597*r**8+4522*r**10)
        +Q2**4*(124040+214555*r**2+494927*r**4+83994*r**6-435854*r**8-70685*r**10
        -13825*r**12)+4*Q2**3*(-12898-53701*r**2-157876*r**4-99536*r**6+239270*r**8
        +173821*r**10+26604*r**12+4196*r**14)+Q2**2*(-33364+79283*r**2+16137*r**4
        +296499*r**6-722823*r**8-1296899*r**10+37639*r**12-20915*r**14+11483*r**16)
        -6*Q2*(-6099+4007*r**2-67848*r**4+21698*r**6+64982*r**8-104896*r**10
        -66872*r**12+141998*r**14+9277*r**16+3753*r**18)+3*(-3106+3031*r**2
        -69535*r**4+58604*r**6-11272*r**8-54546*r**10-60846*r**12-31980*r**14
        +158506*r**16+8507*r**18+2637*r**20))+48*logq2*r**6*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))**3*(13732*Q2**16-4*Q2**15*(38358+47353*r**2)+16*Q2**14*(41695
        +126801*r**2+61440*r**4)-4*Q2**13*(334560+2025701*r**2+2355206*r**4
        +625335*r**6)+Q2**12*(694420+13567351*r**2+26919373*r**4+19852261*r**6
        +2909075*r**8)+4*Q2**11*(551451-23561*r**2+413174*r**4-3135646*r**6
        -3789481*r**8+67591*r**10)-2*Q2**10*(2177802+17403309*r**2+75093455*r**4
        +121618470*r**6+46469020*r**8+6956709*r**10+2387187*r**12)+4*Q2**9*(391215
        +11773167*r**2+67035635*r**4+192722225*r**6+158346325*r**8+44889845*r**10
        +9452817*r**12+1050555*r**14)+Q2**8*(3780480-3184167*r**2-43163017*r**4
        -710809155*r**6-792237525*r**8-410937005*r**10-95749107*r**12-28210377*r**14
        +1715505*r**16)-4*Q2**7*(1174360+11732163*r**2+91548124*r**4+123976528*r**6
        +362349120*r**8+417275330*r**10+97266748*r**12+1422224*r**14-946032*r**16
        +1252075*r**18)+4*Q2**6*(137874+9613897*r**2+91052087*r**4+352634752*r**6
        +1011964312*r**8+1820065866*r**10+956701522*r**12+116345712*r**14-6878698*r**16
        +2517837*r**18+508519*r**20)+4*Q2**5*(630926+1073793*r**2+13982000*r**4
        -182395465*r**6-322047760*r**8-2162635754*r**10-1911058044*r**12-486082550*r**14
        +27584610*r**16+2418665*r**18-3628692*r**20+417471*r**22)-Q2**4*(1765980
        +20732359*r**2+269938805*r**4+348423425*r**6+4348988575*r**8-1647663930*r**10
        -4597246318*r**12-2303000990*r**14+30034650*r**16+119693075*r**18-98084775*r**20
        -11108291*r**22+1738635*r**24)+4*Q2**3*(5315+2130149*r**2+27550654*r**4
        +122984030*r**6+1035739625*r**8+774057155*r**10+129171892*r**12-926702748*r**14
        -856597195*r**16-121705525*r**18-48289970*r**20-21579266*r**22-168481*r**24
        +44365*r**26)+2*Q2**2*(234510+844963*r**2+24148449*r**4-81245162*r**6
        +235556140*r**8-1909042435*r**10+1124047779*r**12+1270605252*r**14+3719022894*r**16
        +1464102285*r**18-37783225*r**20+75992358*r**22-5295976*r**24-2739757*r**26
        +207925*r**28)-12*Q2*(17711+167737*r**2+3966887*r**4-998773*r**6+164743127*r**8
        -408775791*r**10+669430751*r**12-399847749*r**14+629740421*r**16-475362829*r**18
        -91556851*r**20-89227863*r**22+869237*r**24-2883773*r**26-299923*r**28
        +17681*r**30)+3*(10444+133661*r**2+3390395*r**4+96725*r**6+221868235*r**8
        -848905207*r**10+2709352287*r**12-2218074815*r**14-2856327225*r**16+5652935255*r**18
        -2279536943*r**20-204955457*r**22-173583455*r**24-2816125*r**26-3355115*r**28
        -243669*r**30+11009*r**32))+10368000*logq2**4*r**18*(140*Q2**9-20*Q2**8*(67
        +37*r**2)+40*Q2**7*(135+143*r**2+15*r**4)+4*Q2**6*(-2968-4419*r**2
        -820*r**4+959*r**6)+Q2**5*(14812+28433*r**2+3131*r**4-16461*r**6-10451*r**8)
        +Q2**4*(-8400-23801*r**2+3892*r**4+32250*r**6+27268*r**8+7455*r**10)
        -3*(-1+r**2)**3*(356+575*r**2-1481*r**4+2700*r**6+4256*r**8+1101*r**10
        +893*r**12)+2*Q2**3*(-1400+3342*r**2-4037*r**4-9479*r**6-14331*r**8
        -4951*r**10+3640*r**12)-2*Q2**2*(-3920-1032*r**2+1673*r**4-6060*r**6
        -970*r**8+808*r**10+1241*r**12+8260*r**14)+3*Q2*(-1616+265*r**2+5057*r**4
        -8005*r**6-11197*r**8+6919*r**10+6303*r**12-1419*r**14+3693*r**16))*sqrtq2
        +5760*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(6530*Q2**13
        -2*Q2**12*(33381+29810*r**2)+Q2**11*(273424+535554*r**2+222950*r**4)
        -2*Q2**10*(265806+938723*r**2+810536*r**4+212055*r**6)+5*Q2**9*(66228
        +588671*r**2+695193*r**4+420981*r**6+80199*r**8)-5*Q2**8*(-112350+172139*r**2
        -350048*r**4-494014*r**6+104542*r**8+23163*r**10)-2*Q2**7*(590748+1900265*r**2
        +8876090*r**4+15766105*r**6+7968365*r**8+592898*r**10+42345*r**12)+2*Q2**6*(262476
        +2623271*r**2+11248305*r**4+33736125*r**6+30452290*r**8+8900241*r**10
        +237321*r**12+47835*r**14)-2*Q2**5*(-297897+711224*r**2-2043767*r**4
        +22955095*r**6+36578550*r**8+20310488*r**10+2210999*r**12-168047*r**14
        +73755*r**16)+10*Q2**4*(-76019-213868*r**2-3000409*r**4-2109244*r**6
        +227915*r**8+3764684*r**10+1528049*r**12-14524*r**14+81392*r**16+18088*r**18)
        -10*Q2**3*(-16092-186752*r**2-1828251*r**4-4553667*r**6-4183053*r**8
        +1949469*r**10+7861977*r**12+2304099*r**14+384777*r**16+129699*r**18
        +4034*r**20)-2*Q2**2*(-94354+164900*r**2-3096415*r**4+13924200*r**6
        -2466180*r**8+838788*r**10-54958890*r**12-23915580*r**14-4106970*r**16
        +275560*r**18-93479*r**20+45220*r**22)+3*Q2*(-42392-52457*r**2-3298745*r**4
        +4811955*r**6-15281685*r**8+9374994*r**10-595086*r**12-27984390*r**14
        +27092370*r**16+4216535*r**18+1604423*r**20+130643*r**22+23835*r**24)
        -3*(-8006-17873*r**2-921646*r**4+1737470*r**6-8610260*r**8-69143*r**10
        +16824396*r**12-4527628*r**14-28542230*r**16+21389585*r**18+2005474*r**20
        +684302*r**22+50224*r**24+5335*r**26))*sqrtq2+4*r**4*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))**3*(92*Q2**18+60*Q2**17*(1+r**2)+Q2**16*(5996+12912*r**2
        -6076*r**4)+Q2**15*(-72623-1046341*r**2-160589*r**4+34969*r**6)+Q2**14*(299825
        +8852676*r**2+10808350*r**4+776500*r**6-94735*r**8)+Q2**13*(-576101
        -29535579*r**2-82368756*r**4-43289452*r**6-1877655*r**8+135799*r**10)
        +Q2**12*(381315+38482536*r**2+239240429*r**4+277504064*r**6+79598981*r**8
        +2114840*r**10-76245*r**12)-Q2**11*(-493297-20511955*r**2+237317447*r**4
        +530987613*r**6+387002253*r**8+41680119*r**10-50819*r**12+56927*r**14)
        +Q2**10*(-1074711-122446116*r**2-261376636*r**4-280696044*r**6-60797850*r**8
        +63891428*r**10-87830460*r**12-2723028*r**14+101673*r**16)+Q2**9*(341275
        +112792173*r**2+851014790*r**4+2103692810*r**6+3429691340*r**8+1396512740*r**10
        +436523258*r**12+153045270*r**14+1716825*r**16+9295*r**18)-Q2**8*(-889251
        -54890208*r**2+590459833*r**4+1670586336*r**6+6297176130*r**8+4841499376*r**10
        +1065281922*r**12+528837568*r**14+37227201*r**16-2320560*r**18+120549*r**20)
        +Q2**7*(-994085-168225927*r**2-357891963*r**4-1950721473*r**6+778030638*r**8
        -777200710*r**10-1046459542*r**12-511955778*r**14+340834967*r**16-105058067*r**18
        -3712335*r**20+89635*r**22)+Q2**6*(70043+76673404*r**2+764189182*r**4
        +3289645276*r**6+8434570341*r**8+17554642744*r**10+19515767172*r**12
        +5395152088*r**14+193046501*r**16-158583284*r**18+89263870*r**20+875276*r**22
        +10907*r**24)-Q2**5*(-508441-63392055*r**2+323302736*r**4-37241456*r**6
        +8386679415*r**8+12693116089*r**10+39203740728*r**12+16900419912*r**14
        +1763653493*r**16-848638885*r**18+178260472*r**20-9932888*r**22-1674323*r**24
        +48803*r**26)+Q2**4*(-316975-76375224*r**2-131177365*r**4-2445366560*r**6
        +714459345*r**8-20178975160*r**10+29566065683*r**12+14255612160*r**14
        +701297035*r**16-975854760*r**18-224047815*r**20+417821216*r**22-41907245*r**24
        -1300200*r**26+21065*r**28)+Q2**3*(-9117+14144121*r**2+170056239*r**4
        +1061850213*r**6+3845099135*r**8+26031776957*r**10-12379537797*r**12
        +4354598937*r**14-11620863591*r**16-3295991205*r**18-152368323*r**20
        -570114849*r**22-193648251*r**24+13345903*r**26-7655*r**28+5283*r**30)
        +Q2**2*(84335+15657956*r**2-57506816*r**4+600798684*r**6-3037842044*r**8
        +3267499140*r**10-12997085632*r**12+6908662492*r**14+18283866522*r**16
        +18885157708*r**18+2821795840*r**20+279101876*r**22+403896324*r**24-108011956*r**26
        +5478336*r**28+391060*r**30-7825*r**32)+3*Q2*(-11737-3122007*r**2+2026122*r**4
        -191370746*r**6+336016054*r**8-4793498550*r**10+15426377970*r**12-23365152962*r**14
        +7896633092*r**16+2428061692*r**18-53763714*r**20+2180654706*r**22+134272058*r**24
        -35892346*r**26+40213254*r**28-1384374*r**30-59419*r**32+907*r**34)
        -3*(-1631-528384*r**2-60287*r**4-41405248*r**6+39342620*r**8-1532131152*r**10
        +8274408172*r**12-29995134624*r**14+52589566534*r**16-43249613040*r**18
        +13813606422*r**20-1374664192*r**22+1391081884*r**24+82272976*r**26-6254580*r**28
        +9760736*r**30-237471*r**32-8848*r**34+113*r**36))*sqrtq2)*math.log(mu0))/(4354560000*logq2**5*r**22*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))+302400000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
        -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+1050000*logq2*(-Q2+(
        -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-25200000*logq2**2*(
        -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
        -17500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
        -1814400000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
        +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
        +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((13063680000*logq2**5*(
        -Q2+(-1+r)**2)*(-1+r)*r**24*(1+r)*(-1+4*r**2+r**4)*(-Q2+(1+r)**2)
        +345600*logq2**3*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-1510*Q2**10
        +10*Q2**9*(1340+1217*r**2)-2*Q2**8*(24359+44148*r**2+19457*r**4)+4*Q2**7*(21401
        +62513*r**2+55655*r**4+14978*r**6)-Q2**6*(50554+311803*r**2+437641*r**4
        +249593*r**6+40537*r**8)+2*Q2**5*(-32291+36896*r**2+87946*r**4+157854*r**6
        +58597*r**8+4522*r**10)+Q2**4*(124040+214555*r**2+494927*r**4+83994*r**6
        -435854*r**8-70685*r**10-13825*r**12)+4*Q2**3*(-12898-53701*r**2-157876*r**4
        -99536*r**6+239270*r**8+173821*r**10+26604*r**12+4196*r**14)+Q2**2*(
        -33364+79283*r**2+16137*r**4+296499*r**6-722823*r**8-1296899*r**10
        +37639*r**12-20915*r**14+11483*r**16)-6*Q2*(-6099+4007*r**2-67848*r**4
        +21698*r**6+64982*r**8-104896*r**10-66872*r**12+141998*r**14+9277*r**16
        +3753*r**18)+3*(-3106+3031*r**2-69535*r**4+58604*r**6-11272*r**8-54546*r**10
        -60846*r**12-31980*r**14+158506*r**16+8507*r**18+2637*r**20))-48*logq2*r**6*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**3*(13732*Q2**16-4*Q2**15*(38358+47353*r**2)
        +16*Q2**14*(41695+126801*r**2+61440*r**4)-4*Q2**13*(334560+2025701*r**2
        +2355206*r**4+625335*r**6)+Q2**12*(694420+13567351*r**2+26919373*r**4
        +19852261*r**6+2909075*r**8)+4*Q2**11*(551451-23561*r**2+413174*r**4
        -3135646*r**6-3789481*r**8+67591*r**10)-2*Q2**10*(2177802+17403309*r**2
        +75093455*r**4+121618470*r**6+46469020*r**8+6956709*r**10+2387187*r**12)
        +4*Q2**9*(391215+11773167*r**2+67035635*r**4+192722225*r**6+158346325*r**8
        +44889845*r**10+9452817*r**12+1050555*r**14)+Q2**8*(3780480-3184167*r**2
        -43163017*r**4-710809155*r**6-792237525*r**8-410937005*r**10-95749107*r**12
        -28210377*r**14+1715505*r**16)-4*Q2**7*(1174360+11732163*r**2+91548124*r**4
        +123976528*r**6+362349120*r**8+417275330*r**10+97266748*r**12+1422224*r**14
        -946032*r**16+1252075*r**18)+4*Q2**6*(137874+9613897*r**2+91052087*r**4
        +352634752*r**6+1011964312*r**8+1820065866*r**10+956701522*r**12+116345712*r**14
        -6878698*r**16+2517837*r**18+508519*r**20)+4*Q2**5*(630926+1073793*r**2
        +13982000*r**4-182395465*r**6-322047760*r**8-2162635754*r**10-1911058044*r**12
        -486082550*r**14+27584610*r**16+2418665*r**18-3628692*r**20+417471*r**22)
        -Q2**4*(1765980+20732359*r**2+269938805*r**4+348423425*r**6+4348988575*r**8
        -1647663930*r**10-4597246318*r**12-2303000990*r**14+30034650*r**16+119693075*r**18
        -98084775*r**20-11108291*r**22+1738635*r**24)+4*Q2**3*(5315+2130149*r**2
        +27550654*r**4+122984030*r**6+1035739625*r**8+774057155*r**10+129171892*r**12
        -926702748*r**14-856597195*r**16-121705525*r**18-48289970*r**20-21579266*r**22
        -168481*r**24+44365*r**26)+2*Q2**2*(234510+844963*r**2+24148449*r**4
        -81245162*r**6+235556140*r**8-1909042435*r**10+1124047779*r**12+1270605252*r**14
        +3719022894*r**16+1464102285*r**18-37783225*r**20+75992358*r**22-5295976*r**24
        -2739757*r**26+207925*r**28)-12*Q2*(17711+167737*r**2+3966887*r**4
        -998773*r**6+164743127*r**8-408775791*r**10+669430751*r**12-399847749*r**14
        +629740421*r**16-475362829*r**18-91556851*r**20-89227863*r**22+869237*r**24
        -2883773*r**26-299923*r**28+17681*r**30)+3*(10444+133661*r**2+3390395*r**4
        +96725*r**6+221868235*r**8-848905207*r**10+2709352287*r**12-2218074815*r**14
        -2856327225*r**16+5652935255*r**18-2279536943*r**20-204955457*r**22-173583455*r**24
        -2816125*r**26-3355115*r**28-243669*r**30+11009*r**32))+10368000*logq2**4*r**18*(
        -140*Q2**9+20*Q2**8*(67+37*r**2)-40*Q2**7*(135+143*r**2+15*r**4)-4*Q2**6*(
        -2968-4419*r**2-820*r**4+959*r**6)+Q2**5*(-14812-28433*r**2-3131*r**4
        +16461*r**6+10451*r**8)-Q2**4*(-8400-23801*r**2+3892*r**4+32250*r**6
        +27268*r**8+7455*r**10)+Q2**3*(2800-6684*r**2+8074*r**4+18958*r**6
        +28662*r**8+9902*r**10-7280*r**12)+3*(-1+r**2)**3*(356+575*r**2-1481*r**4
        +2700*r**6+4256*r**8+1101*r**10+893*r**12)+2*Q2**2*(-3920-1032*r**2
        +1673*r**4-6060*r**6-970*r**8+808*r**10+1241*r**12+8260*r**14)-3*Q2*(
        -1616+265*r**2+5057*r**4-8005*r**6-11197*r**8+6919*r**10+6303*r**12
        -1419*r**14+3693*r**16))*sqrtq2-5760*logq2**2*r**10*(Q2**2+(-1+r**2)**2
        -2*Q2*(1+r**2))**2*(6530*Q2**13-2*Q2**12*(33381+29810*r**2)+Q2**11*(273424
        +535554*r**2+222950*r**4)-2*Q2**10*(265806+938723*r**2+810536*r**4+212055*r**6)
        +5*Q2**9*(66228+588671*r**2+695193*r**4+420981*r**6+80199*r**8)-5*Q2**8*(
        -112350+172139*r**2-350048*r**4-494014*r**6+104542*r**8+23163*r**10)
        -2*Q2**7*(590748+1900265*r**2+8876090*r**4+15766105*r**6+7968365*r**8
        +592898*r**10+42345*r**12)+2*Q2**6*(262476+2623271*r**2+11248305*r**4
        +33736125*r**6+30452290*r**8+8900241*r**10+237321*r**12+47835*r**14)
        -2*Q2**5*(-297897+711224*r**2-2043767*r**4+22955095*r**6+36578550*r**8
        +20310488*r**10+2210999*r**12-168047*r**14+73755*r**16)+10*Q2**4*(-76019
        -213868*r**2-3000409*r**4-2109244*r**6+227915*r**8+3764684*r**10+1528049*r**12
        -14524*r**14+81392*r**16+18088*r**18)-10*Q2**3*(-16092-186752*r**2-1828251*r**4
        -4553667*r**6-4183053*r**8+1949469*r**10+7861977*r**12+2304099*r**14
        +384777*r**16+129699*r**18+4034*r**20)-2*Q2**2*(-94354+164900*r**2-3096415*r**4
        +13924200*r**6-2466180*r**8+838788*r**10-54958890*r**12-23915580*r**14
        -4106970*r**16+275560*r**18-93479*r**20+45220*r**22)+3*Q2*(-42392-52457*r**2
        -3298745*r**4+4811955*r**6-15281685*r**8+9374994*r**10-595086*r**12
        -27984390*r**14+27092370*r**16+4216535*r**18+1604423*r**20+130643*r**22
        +23835*r**24)-3*(-8006-17873*r**2-921646*r**4+1737470*r**6-8610260*r**8
        -69143*r**10+16824396*r**12-4527628*r**14-28542230*r**16+21389585*r**18
        +2005474*r**20+684302*r**22+50224*r**24+5335*r**26))*sqrtq2-4*r**4*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))**3*(92*Q2**18+60*Q2**17*(1+r**2)+Q2**16*(5996
        +12912*r**2-6076*r**4)+Q2**15*(-72623-1046341*r**2-160589*r**4+34969*r**6)
        +Q2**14*(299825+8852676*r**2+10808350*r**4+776500*r**6-94735*r**8)+Q2**13*(
        -576101-29535579*r**2-82368756*r**4-43289452*r**6-1877655*r**8+135799*r**10)
        +Q2**12*(381315+38482536*r**2+239240429*r**4+277504064*r**6+79598981*r**8
        +2114840*r**10-76245*r**12)-Q2**11*(-493297-20511955*r**2+237317447*r**4
        +530987613*r**6+387002253*r**8+41680119*r**10-50819*r**12+56927*r**14)
        +Q2**10*(-1074711-122446116*r**2-261376636*r**4-280696044*r**6-60797850*r**8
        +63891428*r**10-87830460*r**12-2723028*r**14+101673*r**16)+Q2**9*(341275
        +112792173*r**2+851014790*r**4+2103692810*r**6+3429691340*r**8+1396512740*r**10
        +436523258*r**12+153045270*r**14+1716825*r**16+9295*r**18)-Q2**8*(-889251
        -54890208*r**2+590459833*r**4+1670586336*r**6+6297176130*r**8+4841499376*r**10
        +1065281922*r**12+528837568*r**14+37227201*r**16-2320560*r**18+120549*r**20)
        +Q2**7*(-994085-168225927*r**2-357891963*r**4-1950721473*r**6+778030638*r**8
        -777200710*r**10-1046459542*r**12-511955778*r**14+340834967*r**16-105058067*r**18
        -3712335*r**20+89635*r**22)+Q2**6*(70043+76673404*r**2+764189182*r**4
        +3289645276*r**6+8434570341*r**8+17554642744*r**10+19515767172*r**12
        +5395152088*r**14+193046501*r**16-158583284*r**18+89263870*r**20+875276*r**22
        +10907*r**24)-Q2**5*(-508441-63392055*r**2+323302736*r**4-37241456*r**6
        +8386679415*r**8+12693116089*r**10+39203740728*r**12+16900419912*r**14
        +1763653493*r**16-848638885*r**18+178260472*r**20-9932888*r**22-1674323*r**24
        +48803*r**26)+Q2**4*(-316975-76375224*r**2-131177365*r**4-2445366560*r**6
        +714459345*r**8-20178975160*r**10+29566065683*r**12+14255612160*r**14
        +701297035*r**16-975854760*r**18-224047815*r**20+417821216*r**22-41907245*r**24
        -1300200*r**26+21065*r**28)+Q2**3*(-9117+14144121*r**2+170056239*r**4
        +1061850213*r**6+3845099135*r**8+26031776957*r**10-12379537797*r**12
        +4354598937*r**14-11620863591*r**16-3295991205*r**18-152368323*r**20
        -570114849*r**22-193648251*r**24+13345903*r**26-7655*r**28+5283*r**30)
        +Q2**2*(84335+15657956*r**2-57506816*r**4+600798684*r**6-3037842044*r**8
        +3267499140*r**10-12997085632*r**12+6908662492*r**14+18283866522*r**16
        +18885157708*r**18+2821795840*r**20+279101876*r**22+403896324*r**24-108011956*r**26
        +5478336*r**28+391060*r**30-7825*r**32)+3*Q2*(-11737-3122007*r**2+2026122*r**4
        -191370746*r**6+336016054*r**8-4793498550*r**10+15426377970*r**12-23365152962*r**14
        +7896633092*r**16+2428061692*r**18-53763714*r**20+2180654706*r**22+134272058*r**24
        -35892346*r**26+40213254*r**28-1384374*r**30-59419*r**32+907*r**34)
        -3*(-1631-528384*r**2-60287*r**4-41405248*r**6+39342620*r**8-1532131152*r**10
        +8274408172*r**12-29995134624*r**14+52589566534*r**16-43249613040*r**18
        +13813606422*r**20-1374664192*r**22+1391081884*r**24+82272976*r**26-6254580*r**28
        +9760736*r**30-237471*r**32-8848*r**34+113*r**36))*sqrtq2)*math.log(r))/(4354560000*logq2**5*r**22*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))+302400000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
        -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+1050000*logq2*(-Q2+(
        -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-25200000*logq2**2*(
        -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
        -17500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
        -1814400000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
        +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
        +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((272160000*logq2**4*r**16*(9
        +28*r**2+34*r**4+28*r**6+9*r**8)+7200*logq2**2*(-Q2+(-1+r)**2)*r**8*(
        -Q2+(1+r)**2)*(755*Q2**10-6460*Q2**9*(1+r**2)+19*Q2**8*(1397+2670*r**2
        +1397*r**4)-2*Q2**7*(22697+75917*r**2+75917*r**4+22697*r**6)+Q2**6*(18389
        +192140*r**2+288058*r**4+192140*r**6+18389*r**8)+Q2**5*(33782-72026*r**2
        -3024*r**4-3024*r**6-72026*r**8+33782*r**10)-Q2**4*(39655+164510*r**2
        +1238017*r**4+2141020*r**6+1238017*r**8+164510*r**10+39655*r**12)+2*Q2**3*(3721
        +115075*r**2+794925*r**4+2094619*r**6+2094619*r**8+794925*r**10+115075*r**12
        +3721*r**14)+4*Q2**2*(2651-3949*r**2+57848*r**4-355357*r**6-683806*r**8
        -355357*r**10+57848*r**12-3949*r**14+2651*r**16)-18*Q2*(453+4355*r**2
        +39700*r**4-68700*r**6-202608*r**8-202608*r**10-68700*r**12+39700*r**14
        +4355*r**16+453*r**18)+12*(179+1333*r**2+22836*r**4+74334*r**6+510837*r**8
        +822162*r**10+510837*r**12+74334*r**14+22836*r**16+1333*r**18+179*r**20))
        +(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(6866*Q2**16-23436*Q2**15*(1
        +r**2)+8*Q2**14*(865+8596*r**2+865*r**4)+8*Q2**13*(5380-11099*r**2
        -11099*r**4+5380*r**6)+Q2**12*(10045-259012*r**2-2562366*r**4-259012*r**6
        +10045*r**8)-4*Q2**11*(34147-324527*r**2-3988562*r**4-3988562*r**6-324527*r**8
        +34147*r**10)+2*Q2**10*(35759-646722*r**2-15796615*r**4-38576020*r**6
        -15796615*r**8-646722*r**10+35759*r**12)+8*Q2**9*(13745-127492*r**2
        +2119265*r**4+19072200*r**6+19072200*r**8+2119265*r**10-127492*r**12
        +13745*r**14)+Q2**8*(-91205+2043184*r**2+31186064*r**4-92196960*r**6
        -136611350*r**8-92196960*r**10+31186064*r**12+2043184*r**14-91205*r**16)
        -4*Q2**7*(8785+21669*r**2+14208392*r**4+33962024*r**6+101173570*r**8
        +101173570*r**10+33962024*r**12+14208392*r**14+21669*r**16+8785*r**18)
        +4*Q2**6*(10807-257354*r**2+4036831*r**4+57257856*r**6+179616146*r**8
        +416911988*r**10+179616146*r**12+57257856*r**14+4036831*r**16-257354*r**18
        +10807*r**20)-8*Q2**5*(266-53737*r**2-4403625*r**4+12575730*r**6+21507400*r**8
        +309675766*r**10+309675766*r**12+21507400*r**14+12575730*r**16-4403625*r**18
        -53737*r**20+266*r**22)-Q2**4*(2005+87332*r**2+26936590*r**4+29645300*r**6
        +614859675*r**8-231352920*r**10+1158640836*r**12-231352920*r**14+614859675*r**16
        +29645300*r**18+26936590*r**20+87332*r**22+2005*r**24)+4*Q2**3*(135
        -9223*r**2-887018*r**4+22918230*r**6+168130475*r**8+734118485*r**10
        +2173168916*r**12+2173168916*r**14+734118485*r**16+168130475*r**18+22918230*r**20
        -887018*r**22-9223*r**24+135*r**26)-2*Q2**2*(1265-69094*r**2-3667317*r**4
        +24306396*r**6-83158055*r**8+480299590*r**10+308598123*r**12+3065234184*r**14
        +308598123*r**16+480299590*r**18-83158055*r**20+24306396*r**22-3667317*r**24
        -69094*r**26+1265*r**28)+24*Q2*(31-1758*r**2-54453*r**4-686878*r**6
        -12831908*r**8+1292719*r**10-99093084*r**12+519615331*r**14+519615331*r**16
        -99093084*r**18+1292719*r**20-12831908*r**22-686878*r**24-54453*r**26
        -1758*r**28+31*r**30)+3*(57-3672*r**2+19060*r**4+3841960*r**6+9425060*r**8
        +68973464*r**10+826635276*r**12-1542120*r**14+7983061830*r**16-1542120*r**18
        +826635276*r**20+68973464*r**22+9425060*r**24+3841960*r**26+19060*r**28
        -3672*r**30+57*r**32))+432000*logq2**3*r**12*(867+35*Q2**7+3267*r**2
        +42957*r**4+88989*r**6+88989*r**8+42957*r**10+3267*r**12+867*r**14
        -505*Q2**6*(1+r**2)+5*Q2**5*(445+904*r**2+445*r**4)-Q2**4*(5293+15125*r**2
        +15125*r**4+5293*r**6)-3*Q2*(1+r**2)**2*(1111-2778*r**2-446*r**4-2778*r**6
        +1111*r**8)+Q2**3*(4157+17952*r**2+28010*r**4+17952*r**6+4157*r**8)
        +Q2**2*(1847-3657*r**2-14318*r**4-14318*r**6-3657*r**8+1847*r**10))*sqrtq2
        +120*logq2*r**4*(25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(105*Q2**7-555*Q2**6*(1
        +r**2)+15*Q2**5*(19+52*r**2+19*r**4)-Q2**4*(751+5687*r**2+5687*r**4
        +751*r**6)+Q2**3*(1139+8352*r**2+14006*r**4+8352*r**6+1139*r**8)+Q2**2*(719
        +3879*r**2+4474*r**4+4474*r**6+3879*r**8+719*r**10)+Q2*(-681+2244*r**2
        +38061*r**4+66912*r**6+38061*r**8+2244*r**10-681*r**12)+3*(-87+1849*r**2
        +34455*r**4+109943*r**6+109943*r**8+34455*r**10+1849*r**12-87*r**14))
        +2*(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
        -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
        -14*r**6+r**8))*(971+40*Q2**9-18517*r**2-136600*r**4+561592*r**6+1104554*r**8
        +1104554*r**10+561592*r**12-136600*r**14-18517*r**16+971*r**18-889*Q2**8*(1
        +r**2)+23*Q2**7*(169+418*r**2+169*r**4)-Q2**6*(4347+16967*r**2+16967*r**4
        +4347*r**6)-2*Q2**5*(1113+3489*r**2+13232*r**4+3489*r**6+1113*r**8)
        +2*Q2**4*(2240+11225*r**2+82043*r**4+82043*r**6+11225*r**8+2240*r**10)
        +Q2**3*(1659-18836*r**2-355219*r**4-699528*r**6-355219*r**8-18836*r**10
        +1659*r**12)+Q2**2*(-2567+13091*r**2+205549*r**4+793607*r**6+793607*r**8
        +205549*r**10+13091*r**12-2567*r**14)-8*Q2*(126-2129*r**2-34216*r**4
        -21131*r**6-11300*r**8-21131*r**10-34216*r**12-2129*r**14+126*r**16)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(
        -4354560000*logq2**5*r**20-302400000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
        -1050000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
        -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+1814400000*logq2**4*r**16*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+25200000*logq2**2*r**8*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**3*sqrtq2+17500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
        +((1512000*logq2**3*r**12*(1+r**2)*(29+50*r**2+29*r**4)+60*logq2*(-Q2
        +(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(1873-640*Q2**9-8851*r**2+85460*r**4
        +1289996*r**6+6796322*r**8+6796322*r**10+1289996*r**12+85460*r**14-8851*r**16
        +1873*r**18+8848*Q2**8*(1+r**2)-32*Q2**7*(617+1454*r**2+617*r**4)+Q2**6*(8169
        +72819*r**2+72819*r**4+8169*r**6)+2*Q2**5*(6881-28372*r**2-46826*r**4
        -28372*r**6+6881*r**8)-Q2**4*(13825+65585*r**2+481262*r**4+481262*r**6
        +65585*r**8+13825*r**10)+4*Q2**3*(903+32098*r**2+185817*r**4+339964*r**6
        +185817*r**8+32098*r**10+903*r**12)+Q2**2*(1879+11233*r**2+272487*r**4
        -159599*r**6-159599*r**8+272487*r**10+11233*r**12+1879*r**14)-2*Q2*(1967
        +21792*r**2+88088*r**4-781552*r**6-1382190*r**8-781552*r**10+88088*r**12
        +21792*r**14+1967*r**16))+3600*logq2**2*r**8*(71-160*Q2**6+6084*r**2
        +70785*r**4+118280*r**6+70785*r**8+6084*r**10+71*r**12+960*Q2**5*(1
        +r**2)-288*Q2**4*(13+24*r**2+13*r**4)+Q2**3*(3221+9879*r**2+9879*r**4
        +3221*r**6)+3*Q2**2*(607-396*r**2-982*r**4-396*r**6+607*r**8)-3*Q2*(723
        -2099*r**2-6184*r**4-6184*r**6-2099*r**8+723*r**10))*sqrtq2+(-500*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4-2708*r**6-1133*r**8
        -34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1
        -19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4-26*r**6+r**8)+Q2*(1
        -31*r**2-390*r**4-390*r**6-31*r**8+r**10))+7*(Q2-(-1+r)**2)*(Q2
        -(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
        -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8
        -444*r**2-9976*r**4+31692*r**6-28170*r**8+31692*r**10-9976*r**12-444*r**14
        +13*r**16-24*Q2**7*(1+r**2)+Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61
        -193*r**2-193*r**4+61*r**6)+Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6
        -165*r**8)+4*Q2**3*(13-355*r**2-6138*r**4-6138*r**6-355*r**8+13*r**10)
        +Q2**2*(59-406*r**2+10313*r**4+35188*r**6+10313*r**8-406*r**10+59*r**12)
        -2*Q2*(27-595*r**2-7237*r**4+6605*r**6+6605*r**8-7237*r**10-595*r**12
        +27*r**14)))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(36288000*logq2**4*r**16+1512000*logq2**2*r**8*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2+1750*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-12096000*logq2**3*r**12*(1
        +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2-84000*logq2*r**4*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**3*sqrtq2)+((97200*logq2**2*r**8*(1+r**2)**2+3*(Q2
        -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
        -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
        +r**8))**2-1080*logq2*r**4*(1+r**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
        -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
        -14*r**6+r**8))*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(-86400*logq2**3*r**12-1800*logq2*r**4*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2+21600*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
        -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+50*(Q2**2+(-1+r**2)**2-2*Q2*(1
        +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
        +((360*logq2*r**4*(1+r**2)+2*(-3-8*Q2**4+42*r**2+282*r**4+42*r**6
        -3*r**8+7*Q2**3*(1+r**2)+Q2**2*(7-2*r**2+7*r**4)-3*Q2*(1-11*r**2
        -11*r**4+r**6))*sqrtq2)*nlo.X1Q2(3,'SM',Q2,r))/(720*logq2**2*r**8+5*(Q2**2
        +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
        +r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6
        -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+nlo.X1Q2(4,'SM',Q2,r)/(-12*logq2*r**4
        +(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))

    if( flagDEBUG == 1):
        print("Q2moment n. 4 NLO = api*",resNLO*par.mbkin**8)
    res += api*resNLO

    if(kwargs.get('flag_includeNLOpw', 1) == 1):
        resNLO = 0
        resNLO +=(muG*((-209018880000*logq2**6*(-Q2+(-1+r)**2)*r**24*(3+20*r**4-56*r**6
            +9*r**8)*(-Q2+(1+r)**2)+16588800*logq2**4*(-Q2+(-1+r)**2)*r**16*(-Q2
            +(1+r)**2)*(-13260*Q2**12*r**2+60*Q2**11*(40+2238*r**2+1959*r**4)-6*Q2**10*(4300
            +99468*r**2+166571*r**4+70764*r**6)+20*Q2**9*(5320+75526*r**2+178311*r**4
            +146971*r**6+38799*r**8)-5*Q2**8*(41775+454008*r**2+1346469*r**4+1599112*r**6
            +837648*r**8+145368*r**10)+10*Q2**7*(16140+179682*r**2+635805*r**4+1009580*r**6
            +801145*r**8+286020*r**10+46008*r**12)-10*Q2**6*(-9765+25368*r**2+51105*r**4
            +338080*r**6+549977*r**8+440226*r**10+137529*r**12+85806*r**14)+2*Q2**5*(
            -145950-355872*r**2-2787054*r**4-3031231*r**6-1202400*r**8+2226030*r**10
            +2835008*r**12+1194921*r**14+786024*r**16)-5*Q2**4*(-37320-119136*r**2
            -1110951*r**4-1531468*r**6-1043807*r**8+418104*r**10+2344655*r**12+1523788*r**14
            +656919*r**16+209736*r**18)-20*Q2**3*(-1500+23193*r**2+22344*r**4+233727*r**6
            +106571*r**8-104556*r**10-499797*r**12-497963*r**14-5175*r**16-110697*r**18
            +23673*r**20)+10*Q2**2*(-9765+53544*r**2-343110*r**4+644296*r**6-142215*r**8
            -217770*r**10-185387*r**12-573450*r**14-242136*r**16+874090*r**18-122715*r**20
            +113418*r**22)+(-1+r**2)**2*(-7925+64002*r**2-644137*r**4+2092860*r**6
            -501548*r**8-14416*r**10+1553052*r**12-405848*r**14+305105*r**16+1974638*r**18
            -7619*r**20+127836*r**22)-10*Q2*(-4770+34320*r**2-287841*r**4+805951*r**6
            -521110*r**8-364818*r**10+955666*r**12+1102928*r**14-243846*r**16-406190*r**18
            +759863*r**20-80031*r**22+64278*r**24))+2304*logq2**2*r**8*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(-556584*Q2**18*r**2+24*Q2**17*(-6440+323208*r**2
            +306463*r**4)-8*Q2**16*(-206850+5519389*r**2+11628335*r**4+5174919*r**6)
            +16*Q2**15*(-453390+8198464*r**2+29667243*r**4+28688323*r**6+7989399*r**8)
            -Q2**14*(-15560475+202083880*r**2+1220893040*r**4+1833745864*r**6+1181704395*r**8
            +225561240*r**10)+2*Q2**13*(-5645325+43616511*r**2+717343940*r**4+1230354128*r**6
            +1303767993*r**8+779996385*r**10+94366656*r**12)+Q2**12*(-21123795+215895094*r**2
            +268889069*r**4+4014555896*r**6+6997825091*r**8+2134796386*r**10-510499101*r**12
            +59589024*r**14)-4*Q2**11*(-14212275+86070211*r**2+743035225*r**4+4686585867*r**6
            +11081489235*r**8+9824682745*r**10+3123228847*r**12+360722385*r**14+78294696*r**16)
            +Q2**10*(-39352005+41037548*r**2+3285943206*r**4+23975557532*r**6+82036551836*r**8
            +111640348140*r**10+68855674586*r**12+16275034772*r**14+2141869801*r**16
            +285317208*r**18)-2*Q2**9*(15644475-159295005*r**2+299102910*r**4+1564699086*r**6
            +23439363700*r**8+50040687620*r**10+51591022530*r**12+24569424530*r**14
            +2959354561*r**16+549580505*r**18+16391760*r**20)-Q2**8*(-72689925+241774542*r**2
            +1376541385*r**4+23642841412*r**6+53046035202*r**8+80273670480*r**10
            +65852812518*r**12+5296665100*r**14-1699708733*r**16+5042504322*r**18
            -160900335*r**20+132289872*r**22)+8*Q2**7*(-4477935-12549833*r**2+113135397*r**4
            +2869845901*r**6+12111514456*r**8+27782911496*r**10+40552191738*r**12
            +27367406188*r**14+7124939001*r**16+1485846481*r**18+625020601*r**20
            +805847*r**22+13167702*r**24)-Q2**6*(22941975-222773024*r**2+320246860*r**4
            +1186948608*r**6+42075249355*r**8+123826787000*r**10+253894842256*r**12
            +302901668880*r**14+128639342541*r**16+31928011680*r**18+5192478500*r**20
            +3260490288*r**22+390413905*r**24+33194376*r**26)+2*Q2**5*(17956365-41277559*r**2
            +323114312*r**4-5311848084*r**6-7966543787*r**8-13823328875*r**10-38085421224*r**12
            +36373118112*r**14+58882418407*r**16+19450066291*r**18+33943885680*r**20
            +8402339828*r**22+2995570871*r**24+427633647*r**26+3519216*r**28)+Q2**4*(
            -12569025-42558630*r**2-532283765*r**4+5857073536*r**6+20006350895*r**8
            +34234549530*r**10+191812969715*r**12+100524001040*r**14-70382940747*r**16
            -93491962450*r**18-82418789815*r**20-95990523760*r**22-24050384675*r**24
            -5151956514*r**26-571345095*r**28+1409760*r**30)-4*Q2**3*(1243725-12088901*r**2
            +33945405*r**4-197600789*r**6+1481269421*r**8+1734068835*r**10+12345396741*r**12
            +16114316675*r**14-14472290177*r**16-38680880487*r**18+1084023295*r**20
            -28955989079*r**22-2626870105*r**24-2641517559*r**26+73361791*r**28+12920745*r**30
            +2530464*r**32)+(-1+r**2)**2*(246015+536676*r**2+32866994*r**4-76476220*r**6
            +175415270*r**8+9083955020*r**10-45076434838*r**12+107812661588*r**14
            +2554205940*r**16-117106438140*r**18+3423157590*r**20+86477254348*r**22
            -27968873558*r**24+12315091780*r**26+668521870*r**28+322313500*r**30
            +20632189*r**32+563976*r**34)+Q2**2*(5835585-16402172*r**2+385462518*r**4
            -2053395604*r**6+1536932986*r**8+27486858996*r**10-116893034098*r**12
            +168733564812*r**14-98504943492*r**16-29664224772*r**18-184808077822*r**20
            +263810299812*r**22-154780905578*r**24+66730605596*r**26+491409786*r**28
            +2847158116*r**30+251116083*r**32+9739248*r**34)-2*Q2*(987525-952091*r**2
            +95622530*r**4-441681714*r**6+600269490*r**8+14843714010*r**10-78143641962*r**12
            +165889979990*r**14-93319820228*r**16+36498450420*r**18-1688578270*r**20
            -108839318678*r**22+176852299230*r**24-73189265802*r**26+24791391090*r**28
            +519434610*r**30+787021231*r**32+60572375*r**34+1916244*r**36))-32*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**22+Q2**21*(9168+5492*r**2)
            -Q2**20*(149367+1710440*r**2+145885*r**4)+2*Q2**19*(166081+11225142*r**2
            +11373357*r**4+513816*r**6)-4*Q2**18*(-500241+29074056*r**2+68728671*r**4
            +32028984*r**6+949307*r**8)+2*Q2**17*(-5615008+146448803*r**2+643844310*r**4
            +678188618*r**6+190108966*r**8+4125635*r**10)-4*Q2**16*(-3973359+74266084*r**2
            +679947566*r**4+1166558084*r**6+813909434*r**8+142704876*r**10+2477669*r**12)
            +2*Q2**15*(11775989-110636094*r**2+664396723*r**4+951187330*r**6+1749762163*r**8
            +1506240170*r**10+59782461*r**12+1513106*r**14)+2*Q2**14*(-55171233+425567014*r**2
            +2711053775*r**4+12958211190*r**6+21658743637*r**8+9739250642*r**10+1595151489*r**12
            +544099234*r**14+4360652*r**16)-2*Q2**13*(-64251489+244237704*r**2+5532279198*r**4
            +32275758294*r**6+86358159924*r**8+82047028890*r**10+28156092330*r**12
            +5697080754*r**14+880213701*r**16+5410358*r**18)+Q2**12*(32404320-689625728*r**2
            +6029515422*r**4+40568180232*r**6+219931592136*r**8+336188308392*r**10
            +225093896652*r**12+50076188856*r**14+10603021032*r**16+512577624*r**18
            -2528058*r**20)+2*Q2**11*(-115033373+399321098*r**2+2210312267*r**4+31587831686*r**6
            +31061512558*r**8+34431825288*r**10-6092006098*r**12-19785079664*r**14
            +9780730671*r**16+148443454*r**18+792861927*r**20+7594938*r**22)-2*Q2**10*(
            -93871869-301375562*r**2+3319994183*r**4+57918106482*r**6+221297158884*r**8
            +548728816820*r**10+745806838042*r**12+376195573260*r**14+111602538743*r**16
            +34133271638*r**18+4291667039*r**20+952597698*r**22+5111938*r**24)+2*Q2**9*(35349973
            -660880954*r**2+1254992504*r**4+13592393802*r**6+188409941901*r**8+595751483472*r**10
            +1400248406784*r**12+1275737968812*r**14+420777203271*r**16+112212418766*r**18
            +17786796808*r**20+3853561546*r**22+74351511*r**24-2393252*r**26)+2*Q2**8*(
            -108253049+118145044*r**2-1124814378*r**4+38306461532*r**6+18754759225*r**8
            +173212341792*r**10-500295246472*r**12-989355332216*r**14-692859876855*r**16
            -17789612956*r**18-28297635746*r**20+5682638556*r**22-1939300841*r**24
            +618754856*r**26+5264308*r**28)-2*Q2**7*(-54052263-448577294*r**2-1520978173*r**4
            +28731627586*r**6+112888864569*r**8+706645991774*r**10+929096410339*r**12
            +1001121957078*r**14+418146169379*r**16+16355794270*r**18+193861735857*r**20
            +135446846*r**22+5076541451*r**24-433805614*r**26+430061097*r**28+2026538*r**30)
            +2*Q2**6*(26086756-338891526*r**2+444452537*r**4-9932112558*r**6+69997798893*r**8
            +300770174994*r**10+915081187041*r**12+1489407656154*r**14+1687384602261*r**16
            +547655973486*r**18-13794033501*r**20+77006155926*r**22+1117169999*r**24
            -1921129978*r**26+1260136771*r**28-59789634*r**30-1335221*r**32)+2*Q2**5*(
            -41065221-30301762*r**2-2100878558*r**4+19379453494*r**6-37887938426*r**8
            +262142876010*r**10-288763677838*r**12+154465718158*r**14-604942387500*r**16
            -650739335506*r**18-222381517226*r**20-50316474078*r**22-61839285638*r**24
            -28061823154*r**26-913977578*r**28-2037242598*r**30+205606193*r**32+1540828*r**34)
            +Q2**4*(27030983+281559096*r**2+2329355103*r**4-8747645416*r**6+40739366524*r**8
            -535300669288*r**10+403110641524*r**12-1808455964520*r**14-1432781657230*r**16
            +955373106632*r**18+122065779642*r**20+994249714184*r**22+578840269196*r**24
            +246283782728*r**26+66968062644*r**28+8072207688*r**30+1963310271*r**32
            -157780704*r**34-693057*r**36)-4*Q2**3*(-2393664+28989864*r**2-155289084*r**4
            +2427128335*r**6-6125332244*r**8-451871134*r**10+21267853224*r**12-132493087338*r**14
            -254737602684*r**16+394463082666*r**18-13968192200*r**20+181366227780*r**22
            +40316224628*r**24+110206678118*r**26+21963685960*r**28+2782514298*r**30
            +999139932*r**32-155130906*r**34+9843156*r**36+123293*r**38)+2*(-1
            +r**2)**2*(-190141-1529518*r**2-33679497*r**4+9807032*r**6-1746945342*r**8
            +6647955444*r**10-39233655776*r**12-41613662324*r**14+844981789254*r**16
            -3200025798184*r**18+4808873592694*r**20-3353175039444*r**22+1172325161764*r**24
            -289357902804*r**26+26173110744*r**28-10693057756*r**30-1369313137*r**32
            -113407818*r**34-30256357*r**36+935532*r**38+5634*r**40)+2*Q2**2*(-5256619
            -1096858*r**2-569910819*r**4+3574594202*r**6-23996575640*r**8+106537748288*r**10
            -268025666192*r**12+237211890976*r**14+208084980498*r**16-175106578276*r**18
            +1047462497634*r**20-2262696717692*r**22+2130463827880*r**24-852248583952*r**26
            +143057076472*r**28-47330360656*r**30-10657058383*r**32-95706162*r**34
            -538547623*r**36+25490194*r**38+192728*r**40)-2*Q2*(-1647815-6079975*r**2
            -224696078*r**4+905703860*r**6-11449882667*r**8+57888034035*r**10-231966314240*r**12
            +211288930984*r**14+1134859600730*r**16-3216199321134*r**18-86321246700*r**20
            +6808527240080*r**22-7559948172934*r**24+3468174980510*r**26-972610147056*r**28
            +129588947480*r**30-38974080115*r**32-6566340347*r**34-280835350*r**36
            -221131268*r**38+8084625*r**40+53375*r**42))+497664000*logq2**5*r**20*(
            -420*Q2**9*r**2+60*Q2**8*(8+51*r**2+37*r**4)-40*Q2**7*(96+281*r**2+328*r**4
            +45*r**6)+4*Q2**6*(3360+6676*r**2+8487*r**4+1690*r**6-2877*r**8)+Q2**5*(
            -24675-44164*r**2-44222*r**4-19828*r**6+50433*r**8+32928*r**10)+Q2**4*(21315
            +47095*r**2+28212*r**4+23434*r**6-49925*r**8-104449*r**10-27090*r**12)
            -2*Q2**3*(-105+17105*r**2+3224*r**4+7017*r**6-23847*r**8-36323*r**10
            -32108*r**12+9345*r**14)+(-1+r**2)**2*(-2985+7299*r**2+5207*r**4-35113*r**6
            +43049*r**8+48649*r**10-24515*r**12+9277*r**14+9612*r**16)+2*Q2**2*(
            -8085+16460*r**2+1611*r**4-17045*r**6+6832*r**8+7890*r**10-25141*r**12
            +1203*r**14+26355*r**16)+Q2*(12225-33014*r**2+4784*r**4+97176*r**6
            -51266*r**8-200968*r**10-101904*r**12+68368*r**14+641*r**16-37962*r**18))*sqrtq2
            +276480*logq2**3*r**12*(-126720*Q2**17*r**2+12*Q2**16*(-64+148560*r**2+138255*r**4)
            -4*Q2**15*(-9402+2776908*r**2+5100805*r**4+2401605*r**6)+8*Q2**14*(-42285
            +4951722*r**2+13565140*r**4+12643185*r**6+4002255*r**8)-Q2**13*(-1363635
            +86687004*r**2+319732814*r**4+437695680*r**6+280496045*r**8+66584340*r**10)
            +Q2**12*(-2802555+111962901*r**2+542290348*r**4+945654486*r**6+904945125*r**8
            +465384085*r**10+86140890*r**12)-2*Q2**11*(-1092252+29218287*r**2+219760557*r**4
            +405974987*r**6+486509332*r**8+451858283*r**10+223847415*r**12+30432915*r**14)
            +2*Q2**10*(1385538-29861319*r**2-68113660*r**4-387181820*r**6-737442725*r**8
            -445060159*r**10+52256838*r**12+99728830*r**14+2599965*r**16)+Q2**9*(
            -8500965+136135098*r**2+715457180*r**4+2772737440*r**6+5644372370*r**8
            +6002352080*r**10+3224455148*r**12+684729560*r**14+22868715*r**16+33361470*r**18)
            -Q2**8*(-7365105+96724917*r**2+686589312*r**4+2903638200*r**6+6505159010*r**8
            +8811795550*r**10+7201188432*r**12+3278624872*r**14+814095615*r**16+77257485*r**18
            +41483520*r**20)+4*Q2**7*(269940-682623*r**2+38800926*r**4+259603572*r**6
            +498137280*r**8+958477090*r**10+1311563782*r**12+1116769876*r**14+548184932*r**16
            +250108425*r**18+28823820*r**20+10983420*r**22)-4*Q2**6*(1881726-14621547*r**2
            -58707772*r**4-128619222*r**6-667206707*r**8-751627606*r**10-190050502*r**12
            +697344318*r**14+912065228*r**16+595598293*r**18+375456966*r**20+49347500*r**22
            +10823805*r**24)+Q2**5*(5889849-43983528*r**2-211838870*r**4-668278800*r**6
            -2924363345*r**8-3824050776*r**10-2187239636*r**12+1501306400*r**14+4609291255*r**16
            +3553121880*r**18+2570294762*r**20+1192988944*r**22+184693665*r**24+22120200*r**26)
            +(-1+r**2)**4*(52467-214959*r**2-513578*r**4+24544170*r**6-126468135*r**8
            +333630851*r**10+143760988*r**12-186943764*r**14-290848075*r**16+152935495*r**18
            +307080582*r**20-41295254*r**22+44394367*r**24+2264805*r**26+500040*r**28)
            +Q2**4*(-638505+6880251*r**2+44455100*r**4+448931430*r**6+397599665*r**8
            +1914277805*r**10+7020098*r**12-2100059420*r**14-3651324935*r**16-3341122955*r**18
            +201357400*r**20-1839597674*r**22+74905695*r**24-69432445*r**26+8060490*r**28)
            -Q2*(-1+r**2)**2*(435207-2268252*r**2-4712327*r**4+151262062*r**6-772834785*r**8
            +1742771556*r**10+291253569*r**12-141006026*r**14+67038701*r**16-528832500*r**18
            +306950227*r**20+1870194058*r**22-383056147*r**24+289189612*r**26+12642035*r**28
            +4013010*r**30)-2*Q2**3*(960120-5602773*r**2-11544763*r**4+233427435*r**6
            -847334440*r**8+1409551585*r**10-428587659*r**12-648258219*r**14-404094200*r**16
            -558440195*r**18-617977625*r**20+2218890357*r**22-815882968*r**24+459359415*r**26
            +5504735*r**28+10029195*r**30)+2*Q2**2*(709710-4630407*r**2-5798076*r**4
            +192173588*r**6-1015157385*r**8+2272016695*r**10-1191508706*r**12+317702*r**14
            +757734969*r**16+1316552935*r**18-15793960*r**20-1505521512*r**22+2545158449*r**24
            -831291607*r**26+372854150*r**28+8703630*r**30+6519825*r**32))*sqrtq2
            -192*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(41196*Q2**21*r**2
            -12*Q2**20*(-1480+57537*r**2+57537*r**4)+120*Q2**19*(-1538+36356*r**2
            +93839*r**4+39453*r**6)-4*Q2**18*(-197020+3429590*r**2+17022939*r**4
            +17758976*r**6+4374255*r**8)+Q2**17*(-1611705+21307800*r**2+196865022*r**4
            +326801204*r**6+226422315*r**8+36585180*r**10)-Q2**16*(-825285+8328699*r**2
            +243045288*r**4+271652546*r**6+393855835*r**8+353632323*r**10+35295714*r**12)
            -2*Q2**15*(-1691530+8632397*r**2+47034651*r**4+1203624515*r**6+2322591946*r**8
            +888276297*r**10-27952759*r**12+9161007*r**14)+6*Q2**14*(-1276570+306365*r**2
            +107405990*r**4+1468114024*r**6+4369816345*r**8+4133678157*r**10+1278770820*r**12
            +132717130*r**14+15579195*r**16)-6*Q2**13*(-694360-9541905*r**2+108142642*r**4
            +1891948324*r**6+8996254464*r**8+13405058556*r**10+8681955634*r**12+1980123832*r**14
            +229100148*r**16+14985465*r**18)+Q2**12*(7231640-45106750*r**2+147589494*r**4
            -510307928*r**6+31590484676*r**8+63259793076*r**10+72748902136*r**12
            +42509817224*r**14+5135819268*r**16+692981210*r**18-25514190*r**20)+2*Q2**11*(
            -6692790-43045977*r**2-138804633*r**4+9040529951*r**6+31325757150*r**8
            +94929285204*r**10+132949671332*r**12+57641585244*r**14+10260629376*r**16
            +4505870285*r**18+355067277*r**20+63349533*r**22)-2*Q2**10*(-2475330
            -80127723*r**2-427329540*r**4+8482224308*r**6+62173944523*r**8+237632761038*r**10
            +504894152264*r**12+446597123224*r**14+157735353072*r**16+33855112253*r**18
            +6979631884*r**20+627808500*r**22+42879447*r**24)+2*Q2**9*(4015635-17649645*r**2
            -80633610*r**4-1824953034*r**6+29923651135*r**8+140347883043*r**10+544580901140*r**12
            +778778866780*r**14+486715657641*r**16+108009326625*r**18+22472141078*r**20
            +2820445950*r**22+299041125*r**24-17911335*r**26)+2*Q2**8*(-5095155-64812390*r**2
            -726733239*r**4+7729275950*r**6+19926490149*r**8+145558773576*r**10+76967287949*r**12
            -135228948996*r**14-279692483433*r**16-138804933646*r**18+24195819291*r**20
            -3024656826*r**22+968352551*r**24+82666044*r**26+42145695*r**28)-2*Q2**7*(
            -1141230-61180425*r**2-771079923*r**4+3106696853*r**6+26175882046*r**8
            +242266876761*r**10+592831687421*r**12+912351757243*r**14+868180549830*r**16
            +280334574881*r**18+70627874791*r**20+55988355171*r**22-628241398*r**24
            +1023832399*r**26+176923695*r**28+16904205*r**30)+2*Q2**6*(1923590-152827*r**2
            +31246698*r**4-2840959408*r**6+8847417085*r**8+65995782819*r**10+378992755352*r**12
            +759043973518*r**14+1225994189751*r**16+848962846475*r**18+178485168418*r**20
            +17273411172*r**22+24761709059*r**24+567468397*r**26+703397820*r**28
            +117341918*r**30-10364637*r**32)+2*Q2**5*(-1687020-30111117*r**2-526241814*r**4
            +3031195536*r**6-5399320116*r**8+87944018802*r**10-73099714*r**12+85799140020*r**14
            -12540830160*r**16-548859502468*r**18-205049783706*r**20-196227938040*r**22
            -67969411444*r**24-38817508986*r**26-8582403726*r**28-1238044236*r**30
            -53687964*r**32+12470553*r**34)+2*Q2**4*(309480+16643565*r**2+303501675*r**4
            -468666468*r**6+6072438630*r**8-72665356764*r**10-49742477450*r**12-222911612740*r**14
            -809622560514*r**16+56447378230*r**18+316674193628*r**20+117897252180*r**22
            +397604133970*r**24+157953921812*r**26+45568320090*r**28+9012406356*r**30
            +894533730*r**32+1524645*r**34-2924055*r**36)-2*Q2**3*(-289910-474605*r**2
            -31915293*r**4+714305651*r**6-771979178*r**8-2462298942*r**10-13502542778*r**12
            -21154868422*r**14-399967899894*r**16+182040594376*r**18+323036215364*r**20
            +30667931616*r**22+367504684738*r**24+62106880670*r**26+100384759962*r**28
            +4651250438*r**30+1576907092*r**32-89419323*r**34-26686727*r**36+1965165*r**38)
            +(-1+r**2)**2*(-11815-403479*r**2-12116849*r**4+7431355*r**6-1021262296*r**8
            +3713843244*r**10-19357856828*r**12-79702366908*r**14+643446898310*r**16
            -1875974607162*r**18+1346326900378*r**20+947285878418*r**22-1500221460412*r**24
            +547694052940*r**26-160473203388*r**28-1314878428*r**30-6495045111*r**32
            -596417831*r**34-67757105*r**36-1871029*r**38+93996*r**40)+2*Q2**2*(
            -209010-3774075*r**2-100503306*r**4+495159340*r**6-4934409087*r**8+23742388308*r**10
            -47797118772*r**12-65442601284*r**14+435289265808*r**16-512251145506*r**18
            +201626183424*r**20+843810468444*r**22-1273773051514*r**24+942040248564*r**26
            -363615254652*r**28+28925356068*r**30-22402113222*r**32-2276793771*r**34
            -420155462*r**36-21995880*r**38+1575585*r**40)+Q2*(113115+2926986*r**2
            +81610158*r**4-276256040*r**6+5678145215*r**8-28132582398*r**10+96147156696*r**12
            +166092974016*r**14-1702057063770*r**16+4055392372820*r**18-2870556455516*r**20
            +1790627790576*r**22-4370925867706*r**24+5072448079060*r**26-2208592193160*r**28
            +617619359616*r**30-27933564609*r**32+28296357282*r**34+2726470750*r**36
            +402827000*r**38+15322683*r**40-882774*r**42))*sqrtq2)/(-470292480000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-48988800000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-340200000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-157500*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6+5443200000*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            +11340000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*sqrtq2+235146240000*logq2**5*r**22*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC*(3344302080000*logq2**6*(
            -Q2+(-1+r)**2)*r**24*(3+3*r**2-10*r**4+7*r**6)*(-Q2+(1+r)**2)-66355200*logq2**4*(
            -Q2+(-1+r)**2)*r**16*(-Q2+(1+r)**2)*(15000*Q2**12*r**2-60*Q2**11*(56
            +2133*r**2+2700*r**4)+24*Q2**10*(1310+19344*r**2+48907*r**4+31290*r**6)
            -20*Q2**9*(6104+46982*r**2+169176*r**4+225587*r**6+94392*r**8)+30*Q2**8*(8070
            +39313*r**2+162731*r**4+330797*r**6+303996*r**8+85071*r**10)-10*Q2**7*(24078
            +104310*r**2+358975*r**4+929270*r**6+1355535*r**8+947982*r**10+107190*r**12)
            +5*Q2**6*(13860+206157*r**2+372408*r**4+496804*r**6+789044*r**8+1112409*r**10
            +528192*r**12-414666*r**14)+6*Q2**5*(13650-220417*r**2-465306*r**4-154130*r**6
            +853140*r**8+1831575*r**10+1134988*r**12+786324*r**14+603420*r**16)
            -10*Q2**4*(8022-111204*r**2-318812*r**4-439510*r**6-94896*r**8+1129435*r**10
            +1754300*r**12+790578*r**14+569406*r**16+193401*r**18)-20*Q2**3*(-1095
            +14187*r**2+7674*r**4+315531*r**6+99272*r**8-62145*r**10-325719*r**12
            -420941*r**14+23013*r**16-155436*r**18+25599*r**20)+2*(-1+r**2)**2*(
            -220-7992*r**2-297155*r**4+1600377*r**6-1308961*r**8-875729*r**10-653703*r**12
            -665005*r**14+670513*r**16+372901*r**18-17986*r**20+48960*r**22)+15*Q2**2*(
            -28-12745*r**2-166600*r**4+601296*r**6-317480*r**8-240400*r**10-156200*r**12
            -53670*r**14+71444*r**16+352785*r**18-106272*r**20+78270*r**22)-10*Q2*(
            -66-12177*r**2-203651*r**4+986498*r**6-1255218*r**8-237950*r**10+333824*r**12
            -591636*r**14-404588*r**16+142703*r**18+365931*r**20-87822*r**22+56952*r**24))
            -36864*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(119808*Q2**18*r**2
            -2*Q2**17*(-14440+842037*r**2+790992*r**4)+4*Q2**16*(-80630+2398301*r**2
            +5121860*r**4+2202426*r**6)-4*Q2**15*(-365820+7306232*r**2+25849029*r**4
            +25701764*r**6+6525342*r**8)+Q2**14*(-3376125+52386010*r**2+262365360*r**4
            +402415783*r**6+263947020*r**8+39725055*r**10)-2*Q2**13*(-1810350+29147452*r**2
            +167072490*r**4+246923751*r**6+258128251*r**8+153057540*r**10+5049072*r**12)
            -Q2**12*(-469335-47092702*r**2-127281577*r**4+865768712*r**6+2019060812*r**8
            +969771002*r**10+116029938*r**12+73986318*r**14)+4*Q2**11*(-1519835-10168568*r**2
            +42459675*r**4+884089999*r**6+2588788950*r**8+2796057465*r**10+1074168689*r**12
            +214079640*r**14+32253867*r**16)-Q2**10*(-6729635-31981409*r**2+218014352*r**4
            +4540225744*r**6+17057321897*r**8+27807816530*r**10+20746466482*r**12
            +5173007344*r**14+1009783592*r**16+54619191*r**18)+2*Q2**9*(-1072500
            -653685*r**2+79840790*r**4+1359602792*r**6+5141135695*r**8+10110788865*r**10
            +12215966510*r**12+6367305330*r**14-420487033*r**16+45045130*r**18-47378430*r**20)
            +Q2**8*(-1543025-21519591*r**2-249581865*r**4-1199014846*r**6+2076436389*r**8
            +16731298890*r**10+32411417671*r**12+20388730690*r**14+13582406364*r**16
            +8589928729*r**18+938804610*r**20+145206864*r**22)-4*Q2**7*(-495110-1767742*r**2
            -67977787*r**4-284021381*r**6+1030397284*r**8+7781070929*r**10+21684648052*r**12
            +27259612237*r**14+13519911194*r**16+7294068409*r**18+1919058359*r**20
            +225700388*r**22+12268728*r**24)+Q2**6*(-1725135+9870332*r**2-96596520*r**4
            -383044829*r**6+673534470*r**8+15745113805*r**10+48162036272*r**12+108610755150*r**14
            +100059309637*r**16+16400245270*r**18+17762512160*r**20-1047012849*r**22
            +101114060*r**24-56619423*r**26)+2*Q2**5*(752070-239942*r**2-9433674*r**4
            -377114197*r**6-364158601*r**8-8318674200*r**10-1511584372*r**12-2220573234*r**14
            -21040289544*r**16-6445938182*r**18+21971689890*r**20+270002799*r**22
            +3102441043*r**24+189696876*r**26+32648868*r**28)-Q2**4*(463875+10173640*r**2
            -8722935*r**4-649812008*r**6-971352890*r**8-23208069640*r**10-14172187520*r**12
            +20174450390*r**14+38623683191*r**16-524813840*r**18+40515037945*r**20
            +42705594380*r**22+6948060720*r**24+3605274592*r**26+265170030*r**28
            +17930070*r**30)-4*Q2**3*(139575-1250078*r**2+4741945*r**4+6468788*r**6
            +20797428*r**8+2458005740*r**10+2115412463*r**12+2928537640*r**14-3406292316*r**16
            -8764594966*r**18+8636151915*r**20-12611372092*r**22+810623340*r**24
            -1394561672*r**26+107725213*r**28-7885680*r**30+2672757*r**32)+(-1
            +r**2)**2*(35445+465543*r**2+6394082*r**4+9986315*r**6+122550065*r**8
            +590572295*r**10-3522171544*r**12+32188986359*r**14-40150751355*r**16
            -12318431655*r**18+14351474250*r**20+7644158209*r**22-5846671889*r**24
            +2858665165*r**26-115832660*r**28+94381885*r**30+3413542*r**32+375948*r**34)
            +Q2**2*(626345+1723529*r**2+42051384*r**4-121132562*r**6+146391623*r**8
            -1588389282*r**10-4630106494*r**12+19038317646*r**14-10845765801*r**16
            -16000126496*r**18-18079823996*r**20+71714764026*r**22-56680964119*r**24
            +25863508738*r**26-3467189502*r**28+1361442058*r**30+38594064*r**32+10078839*r**34)
            -2*Q2*(122440+937132*r**2+13343810*r**4-17796252*r**6+163112235*r**8
            -390136755*r**10-2373306346*r**12+28947460610*r**14-35579601959*r**16
            +1779184655*r**18-13519369660*r**20-5102491904*r**22+31145300925*r**24
            -20561860101*r**26+7793026110*r**28-768626150*r**30+295034743*r**32+9281405*r**34
            +1585062*r**36))-128*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(4*Q2**21*(
            -1509+3608*r**2)-2*Q2**20*(-41856+81971*r**2+474413*r**4)+2*Q2**19*(
            -257112-196985*r**2+8318638*r**4+5250703*r**6)+Q2**18*(1820211+8892828*r**2
            -97950690*r**4-176937772*r**6-51288305*r**8)+2*Q2**17*(-2001687-18509780*r**2
            +141850870*r**4+474352174*r**6+389699017*r**8+63205682*r**10)-2*Q2**16*(
            -2673540-29350609*r**2+229439716*r**4+1109833450*r**6+1444214882*r**8
            +774725723*r**10+57428050*r**12)-2*Q2**15*(1731606-12453717*r**2-238978928*r**4
            -930452825*r**6+219095810*r**8+205068713*r**10-138994000*r**12+95504437*r**14)
            +2*Q2**14*(-333564-125457790*r**2-265200529*r**4+798745710*r**6+12130501559*r**8
            +22490174606*r**10+11222524977*r**12+2536596386*r**14+330071861*r**16)
            -2*Q2**13*(-955746-194898083*r**2-399603740*r**4+2292922336*r**6+28480657708*r**8
            +78694495954*r**10+78713551540*r**12+25614856408*r**14+4832888062*r**16
            +297718585*r**18)+2*Q2**12*(1048086-75708490*r**2-408935415*r**4+2065658036*r**6
            +26196832140*r**8+94962413832*r**10+148410820502*r**12+99805628892*r**14
            +13024687470*r**16+1718462114*r**18-182957151*r**20)+2*Q2**11*(-3005262
            -144167933*r**2+102638908*r**4-2104665775*r**6-6212826960*r**8+3898238990*r**10
            +64533590012*r**12+27016686066*r**14+27468332750*r**16+36991137743*r**18
            +5909629432*r**20+625220349*r**22)-2*Q2**10*(-1997307-195348010*r**2
            -278228049*r**4-2857724562*r**6+1434535266*r**8+97381003972*r**10+497233017218*r**12
            +809201730084*r**14+448678140757*r**16+225276271814*r**18+66332581535*r**20
            +8641791374*r**22+404291316*r**24)+2*Q2**9*(685464-23796565*r**2-536137256*r**4
            -1162004574*r**6-2200966428*r**8+57270887121*r**10+506171672336*r**12
            +1308487552476*r**14+1445223399888*r**16+442017064397*r**18+226075059544*r**20
            +19543353026*r**22+1742853364*r**24-251579081*r**26)+2*Q2**8*(-1723746
            -126584758*r**2+650507255*r**4-2058657640*r**6-7335292044*r**8-2908807174*r**10
            -120881624371*r**12-339577895904*r**14-852114205474*r**16-688283494354*r**18
            +320262322209*r**20+9598137128*r**22+51236073776*r**24+6128115182*r**26
            +529312315*r**28)-2*Q2**7*(-634014-96042095*r**2+382702880*r**4-1963535911*r**6
            -18028264014*r**8-25476846563*r**10-9506085496*r**12+508864002549*r**14
            +1462144733542*r**16+861605798483*r**18+869506217376*r**20+819640449739*r**22
            +187654152134*r**24+55272850687*r**26+5766246904*r**28+216534119*r**30)
            +2*Q2**6*(497976+6271950*r**2-230714843*r**4+1014511930*r**6-10320164919*r**8
            -32919800898*r**10-55927772971*r**12+157366201242*r**14+1348219801425*r**16
            +3059537660954*r**18+601499179095*r**20+1573556080158*r**22+230618748371*r**24
            +139239741530*r**26+3594329135*r**28+281849102*r**30-148624037*r**32)
            +2*Q2**5*(-543720-41475887*r**2+544295620*r**4-2256288444*r**6-757290208*r**8
            +9046063256*r**10-66322381156*r**12+98574976980*r**14-360828116200*r**16
            -270102245230*r**18-3101957627076*r**20+2366189932556*r**22-1395044734000*r**24
            +553045219664*r**26-12633614492*r**28+26781962460*r**30+2497764832*r**32
            +189233845*r**34)-2*Q2**4*(-118962-17576965*r**2+285990728*r**4-904117036*r**6
            -2007803444*r**8+5051174552*r**10-119999333872*r**12+23057063172*r**14
            -956999887280*r**16+977534602838*r**18+1169678186472*r**20-3057831703556*r**22
            +3633470915012*r**24-767334720992*r**26+493344165856*r**28+38906156588*r**30
            +15984440018*r**32+1446486263*r**34+54096608*r**36)-4*Q2**3*(-43791-1559193*r**2
            +28727325*r**4-225009056*r**6+542174254*r**8-1872114764*r**10+12986710882*r**12
            -1634679816*r**14+378924961704*r**16-334862887798*r**18-64116848444*r**20
            -92915200440*r**22+222970225442*r**24-242036993740*r**26-141581414626*r**28
            +2408774024*r**30-13954863849*r**32+337820199*r**34-641633*r**36+12399320*r**38)
            +2*(-1+r**2)**2*(-1962-191543*r**2+7439317*r**4-20940141*r**6+244247935*r**8
            +1576285740*r**10-3887349336*r**12+22806301244*r**14+56929793228*r**16
            -404622961290*r**18+2126147283802*r**20-4480774553974*r**22+4076142193686*r**24
            -1917308847508*r**26+557389459200*r**28-90552576276*r**30+16309377478*r**32
            +153907753*r**34+251898921*r**36+17396155*r**38+797571*r**40)+Q2**2*(
            -135201-9936400*r**2+254408600*r**4-1186241992*r**6+3461335733*r**8
            +9564943696*r**10-70658869416*r**12+145611085744*r**14-206084366930*r**16
            -943452349520*r**18+3643998412712*r**20-8821298494368*r**22+14045524045762*r**24
            -12294834139664*r**26+6120089548616*r**28-1770381529008*r**30+386534229059*r**32
            -20908869856*r**34+8272802336*r**36+603048296*r**38+47311801*r**40)-2*Q2*(
            -18639-1622533*r**2+53420974*r**4-237605420*r**6+1262298689*r**8+4866304169*r**10
            -27251283464*r**12+95608777648*r**14-155142584830*r**16+540351722318*r**18
            -1205232098428*r**20+5346242761080*r**22-13336159542518*r**24+14439524124370*r**26
            -8147724489128*r**28+2758227554480*r**30-568886913811*r**32+98530551271*r**34
            -2566762370*r**36+1643942996*r**38+120198293*r**40+7104853*r**42))-3981312000*logq2**5*r**20*(315*Q2**9*r**2
            -5*Q2**8*(16+327*r**2+603*r**4)+10*Q2**7*(8+343*r**2+1291*r**4+1215*r**6)
            -2*Q2**6*(-840+935*r**2+9957*r**4+20750*r**6+13356*r**8)+Q2**5*(-5495
            -6175*r**2+4284*r**4+50334*r**6+70227*r**8+33327*r**10)+Q2**4*(5285
            +12480*r**2+18940*r**4-11482*r**6-63375*r**8-64376*r**10-18900*r**12)
            +Q2**3*(3150-18530*r**2-15055*r**4+2278*r**6+7198*r**8+31904*r**10
            +26519*r**12-6300*r**14)+(-1+r**2)**2*(-2355+7980*r**2-18884*r**4+5476*r**6
            +7954*r**8-23686*r**10+4034*r**12+1958*r**14+2403*r**16)+Q2**2*(-10850
            +29350*r**2-17985*r**4-5817*r**6-3796*r**8-17508*r**10+6107*r**12-2181*r**14
            +17640*r**16)+Q2*(8585-30055*r**2+60079*r**4+23453*r**6-52105*r**8
            +17587*r**10+49997*r**12-9037*r**14+2884*r**16-10908*r**18))*sqrtq2
            -2211840*logq2**3*r**12*(62595*Q2**17*r**2+Q2**16*(960-822645*r**2-880443*r**4)
            +6*Q2**15*(-1600+795650*r**2+1687878*r**4+911283*r**6)-2*Q2**14*(-21960
            +8021340*r**2+25017445*r**4+27067227*r**6+9674100*r**8)+Q2**13*(-95265
            +34401750*r**2+137334570*r**4+216616186*r**6+161006691*r**8+41260590*r**10)
            -Q2**12*(-26325+49270185*r**2+223955665*r**4+428701424*r**6+467460017*r**8
            +276789429*r**10+47873385*r**12)+Q2**11*(325260+48984435*r**2+207606939*r**4
            +356374811*r**6+375399076*r**8+383002811*r**10+228030321*r**12+6236559*r**14)
            +Q2**10*(-703320-36561495*r**2-73106134*r**4+166335362*r**6+855349355*r**8
            +1118035565*r**10+468789420*r**12+72841092*r**14+71803611*r**16)-Q2**9*(
            -604635-22973160*r**2+56324345*r**4+671459967*r**6+2344097905*r**8+4072404615*r**10
            +3680249915*r**12+1493161625*r**14+391385142*r**16+110372625*r**18)+Q2**8*(
            -355995-10024875*r**2+85493760*r**4+715968928*r**6+2331210378*r**8+4740453840*r**10
            +6071066350*r**12+4409320300*r**14+1286859813*r**16+399007143*r**18+55730070*r**20)
            +2*Q2**7*(414600-1796445*r**2-24740835*r**4-303727426*r**6-669860708*r**8
            -1091594416*r**10-1490952920*r**12-1659833150*r**14-915742996*r**16+152145417*r**18
            -65923821*r**20+19465380*r**22)-2*Q2**6*(789900-5659095*r**2-6753963*r**4
            -333424289*r**6-503563669*r**8-288168424*r**10+370099406*r**12+897167898*r**14
            +521711836*r**16+552970531*r**18+778106481*r**20+43535691*r**22+38571057*r**24)
            +Q2**5*(1248165-8662410*r**2+2358464*r**4-601747268*r**6-862820055*r**8
            -841891480*r**10+369278580*r**12+2333718324*r**14+3347556219*r**16+1781758570*r**18
            +1657959580*r**20+1212089840*r**22+115314087*r**24+42951384*r**26)+(
            -1+r**2)**4*(27255-35100*r**2+474347*r**4+2754216*r**6-43940973*r**8
            +330443770*r**10-290669335*r**12-227122344*r**14+848653*r**16+65195816*r**18
            +78529125*r**20-26127040*r**22+18425897*r**24+174906*r**26+300807*r**28)
            +Q2**4*(7695+1541145*r**2-803265*r**4+266221296*r**6+162955955*r**8
            +991870235*r**10+32941185*r**12-674227600*r**14-851354067*r**16-1240503305*r**18
            +291257945*r**20-1123953680*r**22-67022335*r**24-65374779*r**26+2395575*r**28)
            +Q2**3*(-763740+2509875*r**2-7085705*r**4+2048511*r**6+355383556*r**8
            -1674020095*r**10+1087993175*r**12+1169934425*r**14+452175388*r**16-82357547*r**18
            -36789155*r**20-1879174975*r**22+1131520380*r**24-538483849*r**26+33947541*r**28
            -16837785*r**30)-Q2*(-1+r**2)**2*(203295-513555*r**2+2980892*r**4-2700022*r**6
            -199265197*r**8+1358348647*r**10-807543300*r**12-1120097164*r**14-508545731*r**16
            -162490101*r**18+257389556*r**20+566296730*r**22-248557103*r**24+137262753*r**26
            -1261452*r**28+2731752*r**30)+Q2**2*(597600-2363895*r**2+8676210*r**4
            -42095974*r**6-353924917*r**8+2430713111*r**10-2656571300*r**12-148492300*r**14
            -421589367*r**16-578121641*r**18-427590382*r**20-659504310*r**22+2055852365*r**24
            -1067544759*r**26+418938208*r**28-18545304*r**30+10046655*r**32))*sqrtq2
            -1536*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(10299*Q2**21*r**2
            -9*Q2**20*(-2960+28059*r**2+16219*r**4)+6*Q2**19*(-48200+302490*r**2
            +588269*r**4+144360*r**6)-2*Q2**18*(-663080+3114982*r**2+12485664*r**4
            +9888703*r**6+1357125*r**8)+3*Q2**17*(-1048905+4024088*r**2+26786120*r**4
            +33675356*r**6+18015393*r**8+1423830*r**10)-Q2**16*(-3266625+16853007*r**2
            +126194603*r**4+33852340*r**6+14631429*r**8+53039631*r**10+559251*r**12)
            -Q2**15*(-2011520-30174860*r**2-74288217*r**4+1117207984*r**6+2404082336*r**8
            +1094463786*r**10+100066717*r**12+10811586*r**14)+3*Q2**14*(-3400000
            -21724190*r**2+10254891*r**4+1269232671*r**6+3961035900*r**8+3947706908*r**10
            +1194750435*r**12+124128911*r**14+6278490*r**16)-3*Q2**13*(-3454940-31547529*r**2
            +22426687*r**4+1891199361*r**6+7809837701*r**8+12017129277*r**10+7936858933*r**12
            +1430099547*r**14+127950819*r**16+2158800*r**18)+Q2**12*(2365220-62504977*r**2
            +171589350*r**4+4188811036*r**6+16820931410*r**8+23335477074*r**10+27626698330*r**12
            +13509957164*r**14-1723104774*r**16-163476937*r**18-20657520*r**20)+3*Q2**11*(
            -4830800-7423746*r**2-156434197*r**4-591523868*r**6+2906122578*r**8
            +28081437382*r**10+49789556084*r**12+27554590706*r**14+10860301718*r**16
            +3738874084*r**18+260699881*r**20+10151778*r**22)-Q2**10*(-10467600-76892736*r**2
            -571709675*r**4-1335050869*r**6+19899141678*r**8+183462119344*r**10+477196516574*r**12
            +505612423002*r**14+205145314468*r**16+69046431968*r**18+11266868877*r**20
            +621641163*r**22+7511166*r**24)+Q2**9*(3769350-62146905*r**2-234167913*r**4
            -225650391*r**6+9034683605*r**8+130440448632*r**10+452198322010*r**12
            +764745192758*r**14+561659499924*r**16+98879964555*r**18+37427416927*r**20
            -2067999855*r**22-219285183*r**24-20554170*r**26)+3*Q2**8*(-3338790+5959831*r**2
            -13971548*r**4-905283192*r**6-2251537378*r**8-10431215221*r**10-5250069552*r**12
            +4686151408*r**14-46508182450*r**16+11799525317*r**18+68066609724*r**20
            +11064047080*r**22+4440982522*r**24+235118169*r**26+7335600*r**28)-Q2**7*(
            -4282080-17754312*r**2+35261605*r**4-3090399664*r**6-14374096788*r**8
            -22796947742*r**10+160404392981*r**12+794769279198*r**14+1378010275024*r**16
            +810244423916*r**18+666208430463*r**20+299280564652*r**22+58011815108*r**24
            +9221440506*r**26+376434663*r**28+3323430*r**30)+Q2**6*(2384800-34878674*r**2
            +65896791*r**4-163205057*r**6-10624669696*r**8-17610125544*r**10+21664234033*r**12
            +455437362521*r**14+1387553325450*r**16+1870852045078*r**18+455570797337*r**20
            +635302402737*r**22+41612038108*r**24+23536287812*r**26-2069537217*r**28
            -144020393*r**30-9096486*r**32)+3*Q2**5*(-1021940+9328574*r**2+30782211*r**4
            -511670107*r**6+763095773*r**8-8565791833*r**10+670248015*r**12-79713478095*r**14
            +5967878161*r**16-259766160881*r**18-287083696471*r**20+279490313759*r**22
            -82090810009*r**24+65015842661*r**26+3649031173*r**28+2078933259*r**30
            +87294367*r**32+2367783*r**34)-Q2**4*(-776100+6257340*r**2+136371999*r**4
            -723702468*r**6+331362030*r**8-27940793444*r**10-32739433210*r**12-478286239044*r**14
            +91758483046*r**16+753907985540*r**18-346750060932*r**20+76728056980*r**22
            +1070403461306*r**24+14634580212*r**26+147581929530*r**28+14333513076*r**30
            +2828202390*r**32+95663664*r**34+1058085*r**36)-Q2**3*(-456640+7665866*r**2
            -26401533*r**4-192643940*r**6+1157112938*r**8-883832994*r**10+16125469130*r**12
            +265533408958*r**14-20716803846*r**16+146477708714*r**18-917975696792*r**20
            +998495945502*r**22-804386223922*r**24+26892035242*r**26-157261910202*r**28
            +3681272026*r**30-4883862898*r**32+500067972*r**34+24795269*r**36+1311150*r**38)
            +(-1+r**2)**2*(-11815+303708*r**2+4845802*r**4+3617332*r**6+477001157*r**8
            -118560714*r**10+3721039246*r**12+25923427374*r**14-113294630176*r**16
            +734374889094*r**18-1210262942678*r**20+271047673934*r**22+471990817496*r**24
            -331770164894*r**26+119484303066*r**28-15250247542*r**30+4298699487*r**32
            +130675078*r**34+46905988*r**36+1295558*r**38+23499*r**40)+3*Q2**2*(
            -128320+2387592*r**2+12821215*r**4-81000881*r**6+1039831916*r**8-3445695052*r**10
            +4974719652*r**12-10475861052*r**14-31665237484*r**16+51968179100*r**18
            +70226581234*r**20-415661089630*r**22+731328149684*r**24-600059322164*r**26
            +280741368052*r**28-66174241932*r**30+17472654636*r**32-45431972*r**34
            +312176279*r**36+10766807*r**38+292320*r**40)-Q2*(-109725+2484255*r**2
            +23964347*r**4-67297751*r**6+2150789184*r**8-5178983904*r**10+15163881864*r**12
            -13348086096*r**14+12806974678*r**16+615707436638*r**18-612347723898*r**20
            -390265087622*r**22-1197497629024*r**24+2607096681072*r**26-1731346742928*r**28
            +626489400408*r**30-112208553393*r**32+25444684523*r**34+256215751*r**36
            +342768981*r**38+10542744*r**40+229896*r**42))*sqrtq2))/(-1410877440000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-146966400000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-1020600000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-472500*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6+16329600000*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            +34020000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*sqrtq2+705438720000*logq2**5*r**22*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC**2*(418037760000*logq2**6*(
            -Q2+(-1+r)**2)*r**24*(3+3*r**2-10*r**4+7*r**6)*(-Q2+(1+r)**2)-8294400*logq2**4*(
            -Q2+(-1+r)**2)*r**16*(-Q2+(1+r)**2)*(15000*Q2**12*r**2-60*Q2**11*(56
            +2133*r**2+2700*r**4)+24*Q2**10*(1310+19344*r**2+48907*r**4+31290*r**6)
            -20*Q2**9*(6104+46982*r**2+169176*r**4+225587*r**6+94392*r**8)+30*Q2**8*(8070
            +39313*r**2+162731*r**4+330797*r**6+303996*r**8+85071*r**10)-10*Q2**7*(24078
            +104310*r**2+358975*r**4+929270*r**6+1355535*r**8+947982*r**10+107190*r**12)
            +5*Q2**6*(13860+206157*r**2+372408*r**4+496804*r**6+789044*r**8+1112409*r**10
            +528192*r**12-414666*r**14)+6*Q2**5*(13650-220417*r**2-465306*r**4-154130*r**6
            +853140*r**8+1831575*r**10+1134988*r**12+786324*r**14+603420*r**16)
            -10*Q2**4*(8022-111204*r**2-318812*r**4-439510*r**6-94896*r**8+1129435*r**10
            +1754300*r**12+790578*r**14+569406*r**16+193401*r**18)-20*Q2**3*(-1095
            +14187*r**2+7674*r**4+315531*r**6+99272*r**8-62145*r**10-325719*r**12
            -420941*r**14+23013*r**16-155436*r**18+25599*r**20)+2*(-1+r**2)**2*(
            -220-7992*r**2-297155*r**4+1600377*r**6-1308961*r**8-875729*r**10-653703*r**12
            -665005*r**14+670513*r**16+372901*r**18-17986*r**20+48960*r**22)+15*Q2**2*(
            -28-12745*r**2-166600*r**4+601296*r**6-317480*r**8-240400*r**10-156200*r**12
            -53670*r**14+71444*r**16+352785*r**18-106272*r**20+78270*r**22)-10*Q2*(
            -66-12177*r**2-203651*r**4+986498*r**6-1255218*r**8-237950*r**10+333824*r**12
            -591636*r**14-404588*r**16+142703*r**18+365931*r**20-87822*r**22+56952*r**24))
            -4608*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(119808*Q2**18*r**2
            -2*Q2**17*(-14440+842037*r**2+790992*r**4)+4*Q2**16*(-80630+2398301*r**2
            +5121860*r**4+2202426*r**6)-4*Q2**15*(-365820+7306232*r**2+25849029*r**4
            +25701764*r**6+6525342*r**8)+Q2**14*(-3376125+52386010*r**2+262365360*r**4
            +402415783*r**6+263947020*r**8+39725055*r**10)-2*Q2**13*(-1810350+29147452*r**2
            +167072490*r**4+246923751*r**6+258128251*r**8+153057540*r**10+5049072*r**12)
            -Q2**12*(-469335-47092702*r**2-127281577*r**4+865768712*r**6+2019060812*r**8
            +969771002*r**10+116029938*r**12+73986318*r**14)+4*Q2**11*(-1519835-10168568*r**2
            +42459675*r**4+884089999*r**6+2588788950*r**8+2796057465*r**10+1074168689*r**12
            +214079640*r**14+32253867*r**16)-Q2**10*(-6729635-31981409*r**2+218014352*r**4
            +4540225744*r**6+17057321897*r**8+27807816530*r**10+20746466482*r**12
            +5173007344*r**14+1009783592*r**16+54619191*r**18)+2*Q2**9*(-1072500
            -653685*r**2+79840790*r**4+1359602792*r**6+5141135695*r**8+10110788865*r**10
            +12215966510*r**12+6367305330*r**14-420487033*r**16+45045130*r**18-47378430*r**20)
            +Q2**8*(-1543025-21519591*r**2-249581865*r**4-1199014846*r**6+2076436389*r**8
            +16731298890*r**10+32411417671*r**12+20388730690*r**14+13582406364*r**16
            +8589928729*r**18+938804610*r**20+145206864*r**22)-4*Q2**7*(-495110-1767742*r**2
            -67977787*r**4-284021381*r**6+1030397284*r**8+7781070929*r**10+21684648052*r**12
            +27259612237*r**14+13519911194*r**16+7294068409*r**18+1919058359*r**20
            +225700388*r**22+12268728*r**24)+Q2**6*(-1725135+9870332*r**2-96596520*r**4
            -383044829*r**6+673534470*r**8+15745113805*r**10+48162036272*r**12+108610755150*r**14
            +100059309637*r**16+16400245270*r**18+17762512160*r**20-1047012849*r**22
            +101114060*r**24-56619423*r**26)+2*Q2**5*(752070-239942*r**2-9433674*r**4
            -377114197*r**6-364158601*r**8-8318674200*r**10-1511584372*r**12-2220573234*r**14
            -21040289544*r**16-6445938182*r**18+21971689890*r**20+270002799*r**22
            +3102441043*r**24+189696876*r**26+32648868*r**28)-Q2**4*(463875+10173640*r**2
            -8722935*r**4-649812008*r**6-971352890*r**8-23208069640*r**10-14172187520*r**12
            +20174450390*r**14+38623683191*r**16-524813840*r**18+40515037945*r**20
            +42705594380*r**22+6948060720*r**24+3605274592*r**26+265170030*r**28
            +17930070*r**30)-4*Q2**3*(139575-1250078*r**2+4741945*r**4+6468788*r**6
            +20797428*r**8+2458005740*r**10+2115412463*r**12+2928537640*r**14-3406292316*r**16
            -8764594966*r**18+8636151915*r**20-12611372092*r**22+810623340*r**24
            -1394561672*r**26+107725213*r**28-7885680*r**30+2672757*r**32)+(-1
            +r**2)**2*(35445+465543*r**2+6394082*r**4+9986315*r**6+122550065*r**8
            +590572295*r**10-3522171544*r**12+32188986359*r**14-40150751355*r**16
            -12318431655*r**18+14351474250*r**20+7644158209*r**22-5846671889*r**24
            +2858665165*r**26-115832660*r**28+94381885*r**30+3413542*r**32+375948*r**34)
            +Q2**2*(626345+1723529*r**2+42051384*r**4-121132562*r**6+146391623*r**8
            -1588389282*r**10-4630106494*r**12+19038317646*r**14-10845765801*r**16
            -16000126496*r**18-18079823996*r**20+71714764026*r**22-56680964119*r**24
            +25863508738*r**26-3467189502*r**28+1361442058*r**30+38594064*r**32+10078839*r**34)
            -2*Q2*(122440+937132*r**2+13343810*r**4-17796252*r**6+163112235*r**8
            -390136755*r**10-2373306346*r**12+28947460610*r**14-35579601959*r**16
            +1779184655*r**18-13519369660*r**20-5102491904*r**22+31145300925*r**24
            -20561860101*r**26+7793026110*r**28-768626150*r**30+295034743*r**32+9281405*r**34
            +1585062*r**36))-16*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(4*Q2**21*(
            -1509+3608*r**2)-2*Q2**20*(-41856+81971*r**2+474413*r**4)+2*Q2**19*(
            -257112-196985*r**2+8318638*r**4+5250703*r**6)+Q2**18*(1820211+8892828*r**2
            -97950690*r**4-176937772*r**6-51288305*r**8)+2*Q2**17*(-2001687-18509780*r**2
            +141850870*r**4+474352174*r**6+389699017*r**8+63205682*r**10)-2*Q2**16*(
            -2673540-29350609*r**2+229439716*r**4+1109833450*r**6+1444214882*r**8
            +774725723*r**10+57428050*r**12)-2*Q2**15*(1731606-12453717*r**2-238978928*r**4
            -930452825*r**6+219095810*r**8+205068713*r**10-138994000*r**12+95504437*r**14)
            +2*Q2**14*(-333564-125457790*r**2-265200529*r**4+798745710*r**6+12130501559*r**8
            +22490174606*r**10+11222524977*r**12+2536596386*r**14+330071861*r**16)
            -2*Q2**13*(-955746-194898083*r**2-399603740*r**4+2292922336*r**6+28480657708*r**8
            +78694495954*r**10+78713551540*r**12+25614856408*r**14+4832888062*r**16
            +297718585*r**18)+2*Q2**12*(1048086-75708490*r**2-408935415*r**4+2065658036*r**6
            +26196832140*r**8+94962413832*r**10+148410820502*r**12+99805628892*r**14
            +13024687470*r**16+1718462114*r**18-182957151*r**20)+2*Q2**11*(-3005262
            -144167933*r**2+102638908*r**4-2104665775*r**6-6212826960*r**8+3898238990*r**10
            +64533590012*r**12+27016686066*r**14+27468332750*r**16+36991137743*r**18
            +5909629432*r**20+625220349*r**22)-2*Q2**10*(-1997307-195348010*r**2
            -278228049*r**4-2857724562*r**6+1434535266*r**8+97381003972*r**10+497233017218*r**12
            +809201730084*r**14+448678140757*r**16+225276271814*r**18+66332581535*r**20
            +8641791374*r**22+404291316*r**24)+2*Q2**9*(685464-23796565*r**2-536137256*r**4
            -1162004574*r**6-2200966428*r**8+57270887121*r**10+506171672336*r**12
            +1308487552476*r**14+1445223399888*r**16+442017064397*r**18+226075059544*r**20
            +19543353026*r**22+1742853364*r**24-251579081*r**26)+2*Q2**8*(-1723746
            -126584758*r**2+650507255*r**4-2058657640*r**6-7335292044*r**8-2908807174*r**10
            -120881624371*r**12-339577895904*r**14-852114205474*r**16-688283494354*r**18
            +320262322209*r**20+9598137128*r**22+51236073776*r**24+6128115182*r**26
            +529312315*r**28)-2*Q2**7*(-634014-96042095*r**2+382702880*r**4-1963535911*r**6
            -18028264014*r**8-25476846563*r**10-9506085496*r**12+508864002549*r**14
            +1462144733542*r**16+861605798483*r**18+869506217376*r**20+819640449739*r**22
            +187654152134*r**24+55272850687*r**26+5766246904*r**28+216534119*r**30)
            +2*Q2**6*(497976+6271950*r**2-230714843*r**4+1014511930*r**6-10320164919*r**8
            -32919800898*r**10-55927772971*r**12+157366201242*r**14+1348219801425*r**16
            +3059537660954*r**18+601499179095*r**20+1573556080158*r**22+230618748371*r**24
            +139239741530*r**26+3594329135*r**28+281849102*r**30-148624037*r**32)
            +2*Q2**5*(-543720-41475887*r**2+544295620*r**4-2256288444*r**6-757290208*r**8
            +9046063256*r**10-66322381156*r**12+98574976980*r**14-360828116200*r**16
            -270102245230*r**18-3101957627076*r**20+2366189932556*r**22-1395044734000*r**24
            +553045219664*r**26-12633614492*r**28+26781962460*r**30+2497764832*r**32
            +189233845*r**34)-2*Q2**4*(-118962-17576965*r**2+285990728*r**4-904117036*r**6
            -2007803444*r**8+5051174552*r**10-119999333872*r**12+23057063172*r**14
            -956999887280*r**16+977534602838*r**18+1169678186472*r**20-3057831703556*r**22
            +3633470915012*r**24-767334720992*r**26+493344165856*r**28+38906156588*r**30
            +15984440018*r**32+1446486263*r**34+54096608*r**36)-4*Q2**3*(-43791-1559193*r**2
            +28727325*r**4-225009056*r**6+542174254*r**8-1872114764*r**10+12986710882*r**12
            -1634679816*r**14+378924961704*r**16-334862887798*r**18-64116848444*r**20
            -92915200440*r**22+222970225442*r**24-242036993740*r**26-141581414626*r**28
            +2408774024*r**30-13954863849*r**32+337820199*r**34-641633*r**36+12399320*r**38)
            +2*(-1+r**2)**2*(-1962-191543*r**2+7439317*r**4-20940141*r**6+244247935*r**8
            +1576285740*r**10-3887349336*r**12+22806301244*r**14+56929793228*r**16
            -404622961290*r**18+2126147283802*r**20-4480774553974*r**22+4076142193686*r**24
            -1917308847508*r**26+557389459200*r**28-90552576276*r**30+16309377478*r**32
            +153907753*r**34+251898921*r**36+17396155*r**38+797571*r**40)+Q2**2*(
            -135201-9936400*r**2+254408600*r**4-1186241992*r**6+3461335733*r**8
            +9564943696*r**10-70658869416*r**12+145611085744*r**14-206084366930*r**16
            -943452349520*r**18+3643998412712*r**20-8821298494368*r**22+14045524045762*r**24
            -12294834139664*r**26+6120089548616*r**28-1770381529008*r**30+386534229059*r**32
            -20908869856*r**34+8272802336*r**36+603048296*r**38+47311801*r**40)-2*Q2*(
            -18639-1622533*r**2+53420974*r**4-237605420*r**6+1262298689*r**8+4866304169*r**10
            -27251283464*r**12+95608777648*r**14-155142584830*r**16+540351722318*r**18
            -1205232098428*r**20+5346242761080*r**22-13336159542518*r**24+14439524124370*r**26
            -8147724489128*r**28+2758227554480*r**30-568886913811*r**32+98530551271*r**34
            -2566762370*r**36+1643942996*r**38+120198293*r**40+7104853*r**42))-497664000*logq2**5*r**20*(315*Q2**9*r**2
            -5*Q2**8*(16+327*r**2+603*r**4)+10*Q2**7*(8+343*r**2+1291*r**4+1215*r**6)
            -2*Q2**6*(-840+935*r**2+9957*r**4+20750*r**6+13356*r**8)+Q2**5*(-5495
            -6175*r**2+4284*r**4+50334*r**6+70227*r**8+33327*r**10)+Q2**4*(5285
            +12480*r**2+18940*r**4-11482*r**6-63375*r**8-64376*r**10-18900*r**12)
            +Q2**3*(3150-18530*r**2-15055*r**4+2278*r**6+7198*r**8+31904*r**10
            +26519*r**12-6300*r**14)+(-1+r**2)**2*(-2355+7980*r**2-18884*r**4+5476*r**6
            +7954*r**8-23686*r**10+4034*r**12+1958*r**14+2403*r**16)+Q2**2*(-10850
            +29350*r**2-17985*r**4-5817*r**6-3796*r**8-17508*r**10+6107*r**12-2181*r**14
            +17640*r**16)+Q2*(8585-30055*r**2+60079*r**4+23453*r**6-52105*r**8
            +17587*r**10+49997*r**12-9037*r**14+2884*r**16-10908*r**18))*sqrtq2
            -276480*logq2**3*r**12*(62595*Q2**17*r**2+Q2**16*(960-822645*r**2-880443*r**4)
            +6*Q2**15*(-1600+795650*r**2+1687878*r**4+911283*r**6)-2*Q2**14*(-21960
            +8021340*r**2+25017445*r**4+27067227*r**6+9674100*r**8)+Q2**13*(-95265
            +34401750*r**2+137334570*r**4+216616186*r**6+161006691*r**8+41260590*r**10)
            -Q2**12*(-26325+49270185*r**2+223955665*r**4+428701424*r**6+467460017*r**8
            +276789429*r**10+47873385*r**12)+Q2**11*(325260+48984435*r**2+207606939*r**4
            +356374811*r**6+375399076*r**8+383002811*r**10+228030321*r**12+6236559*r**14)
            +Q2**10*(-703320-36561495*r**2-73106134*r**4+166335362*r**6+855349355*r**8
            +1118035565*r**10+468789420*r**12+72841092*r**14+71803611*r**16)-Q2**9*(
            -604635-22973160*r**2+56324345*r**4+671459967*r**6+2344097905*r**8+4072404615*r**10
            +3680249915*r**12+1493161625*r**14+391385142*r**16+110372625*r**18)+Q2**8*(
            -355995-10024875*r**2+85493760*r**4+715968928*r**6+2331210378*r**8+4740453840*r**10
            +6071066350*r**12+4409320300*r**14+1286859813*r**16+399007143*r**18+55730070*r**20)
            +2*Q2**7*(414600-1796445*r**2-24740835*r**4-303727426*r**6-669860708*r**8
            -1091594416*r**10-1490952920*r**12-1659833150*r**14-915742996*r**16+152145417*r**18
            -65923821*r**20+19465380*r**22)-2*Q2**6*(789900-5659095*r**2-6753963*r**4
            -333424289*r**6-503563669*r**8-288168424*r**10+370099406*r**12+897167898*r**14
            +521711836*r**16+552970531*r**18+778106481*r**20+43535691*r**22+38571057*r**24)
            +Q2**5*(1248165-8662410*r**2+2358464*r**4-601747268*r**6-862820055*r**8
            -841891480*r**10+369278580*r**12+2333718324*r**14+3347556219*r**16+1781758570*r**18
            +1657959580*r**20+1212089840*r**22+115314087*r**24+42951384*r**26)+(
            -1+r**2)**4*(27255-35100*r**2+474347*r**4+2754216*r**6-43940973*r**8
            +330443770*r**10-290669335*r**12-227122344*r**14+848653*r**16+65195816*r**18
            +78529125*r**20-26127040*r**22+18425897*r**24+174906*r**26+300807*r**28)
            +Q2**4*(7695+1541145*r**2-803265*r**4+266221296*r**6+162955955*r**8
            +991870235*r**10+32941185*r**12-674227600*r**14-851354067*r**16-1240503305*r**18
            +291257945*r**20-1123953680*r**22-67022335*r**24-65374779*r**26+2395575*r**28)
            +Q2**3*(-763740+2509875*r**2-7085705*r**4+2048511*r**6+355383556*r**8
            -1674020095*r**10+1087993175*r**12+1169934425*r**14+452175388*r**16-82357547*r**18
            -36789155*r**20-1879174975*r**22+1131520380*r**24-538483849*r**26+33947541*r**28
            -16837785*r**30)-Q2*(-1+r**2)**2*(203295-513555*r**2+2980892*r**4-2700022*r**6
            -199265197*r**8+1358348647*r**10-807543300*r**12-1120097164*r**14-508545731*r**16
            -162490101*r**18+257389556*r**20+566296730*r**22-248557103*r**24+137262753*r**26
            -1261452*r**28+2731752*r**30)+Q2**2*(597600-2363895*r**2+8676210*r**4
            -42095974*r**6-353924917*r**8+2430713111*r**10-2656571300*r**12-148492300*r**14
            -421589367*r**16-578121641*r**18-427590382*r**20-659504310*r**22+2055852365*r**24
            -1067544759*r**26+418938208*r**28-18545304*r**30+10046655*r**32))*sqrtq2
            -192*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(10299*Q2**21*r**2
            -9*Q2**20*(-2960+28059*r**2+16219*r**4)+6*Q2**19*(-48200+302490*r**2
            +588269*r**4+144360*r**6)-2*Q2**18*(-663080+3114982*r**2+12485664*r**4
            +9888703*r**6+1357125*r**8)+3*Q2**17*(-1048905+4024088*r**2+26786120*r**4
            +33675356*r**6+18015393*r**8+1423830*r**10)-Q2**16*(-3266625+16853007*r**2
            +126194603*r**4+33852340*r**6+14631429*r**8+53039631*r**10+559251*r**12)
            -Q2**15*(-2011520-30174860*r**2-74288217*r**4+1117207984*r**6+2404082336*r**8
            +1094463786*r**10+100066717*r**12+10811586*r**14)+3*Q2**14*(-3400000
            -21724190*r**2+10254891*r**4+1269232671*r**6+3961035900*r**8+3947706908*r**10
            +1194750435*r**12+124128911*r**14+6278490*r**16)-3*Q2**13*(-3454940-31547529*r**2
            +22426687*r**4+1891199361*r**6+7809837701*r**8+12017129277*r**10+7936858933*r**12
            +1430099547*r**14+127950819*r**16+2158800*r**18)+Q2**12*(2365220-62504977*r**2
            +171589350*r**4+4188811036*r**6+16820931410*r**8+23335477074*r**10+27626698330*r**12
            +13509957164*r**14-1723104774*r**16-163476937*r**18-20657520*r**20)+3*Q2**11*(
            -4830800-7423746*r**2-156434197*r**4-591523868*r**6+2906122578*r**8
            +28081437382*r**10+49789556084*r**12+27554590706*r**14+10860301718*r**16
            +3738874084*r**18+260699881*r**20+10151778*r**22)-Q2**10*(-10467600-76892736*r**2
            -571709675*r**4-1335050869*r**6+19899141678*r**8+183462119344*r**10+477196516574*r**12
            +505612423002*r**14+205145314468*r**16+69046431968*r**18+11266868877*r**20
            +621641163*r**22+7511166*r**24)+Q2**9*(3769350-62146905*r**2-234167913*r**4
            -225650391*r**6+9034683605*r**8+130440448632*r**10+452198322010*r**12
            +764745192758*r**14+561659499924*r**16+98879964555*r**18+37427416927*r**20
            -2067999855*r**22-219285183*r**24-20554170*r**26)+3*Q2**8*(-3338790+5959831*r**2
            -13971548*r**4-905283192*r**6-2251537378*r**8-10431215221*r**10-5250069552*r**12
            +4686151408*r**14-46508182450*r**16+11799525317*r**18+68066609724*r**20
            +11064047080*r**22+4440982522*r**24+235118169*r**26+7335600*r**28)-Q2**7*(
            -4282080-17754312*r**2+35261605*r**4-3090399664*r**6-14374096788*r**8
            -22796947742*r**10+160404392981*r**12+794769279198*r**14+1378010275024*r**16
            +810244423916*r**18+666208430463*r**20+299280564652*r**22+58011815108*r**24
            +9221440506*r**26+376434663*r**28+3323430*r**30)+Q2**6*(2384800-34878674*r**2
            +65896791*r**4-163205057*r**6-10624669696*r**8-17610125544*r**10+21664234033*r**12
            +455437362521*r**14+1387553325450*r**16+1870852045078*r**18+455570797337*r**20
            +635302402737*r**22+41612038108*r**24+23536287812*r**26-2069537217*r**28
            -144020393*r**30-9096486*r**32)+3*Q2**5*(-1021940+9328574*r**2+30782211*r**4
            -511670107*r**6+763095773*r**8-8565791833*r**10+670248015*r**12-79713478095*r**14
            +5967878161*r**16-259766160881*r**18-287083696471*r**20+279490313759*r**22
            -82090810009*r**24+65015842661*r**26+3649031173*r**28+2078933259*r**30
            +87294367*r**32+2367783*r**34)-Q2**4*(-776100+6257340*r**2+136371999*r**4
            -723702468*r**6+331362030*r**8-27940793444*r**10-32739433210*r**12-478286239044*r**14
            +91758483046*r**16+753907985540*r**18-346750060932*r**20+76728056980*r**22
            +1070403461306*r**24+14634580212*r**26+147581929530*r**28+14333513076*r**30
            +2828202390*r**32+95663664*r**34+1058085*r**36)-Q2**3*(-456640+7665866*r**2
            -26401533*r**4-192643940*r**6+1157112938*r**8-883832994*r**10+16125469130*r**12
            +265533408958*r**14-20716803846*r**16+146477708714*r**18-917975696792*r**20
            +998495945502*r**22-804386223922*r**24+26892035242*r**26-157261910202*r**28
            +3681272026*r**30-4883862898*r**32+500067972*r**34+24795269*r**36+1311150*r**38)
            +(-1+r**2)**2*(-11815+303708*r**2+4845802*r**4+3617332*r**6+477001157*r**8
            -118560714*r**10+3721039246*r**12+25923427374*r**14-113294630176*r**16
            +734374889094*r**18-1210262942678*r**20+271047673934*r**22+471990817496*r**24
            -331770164894*r**26+119484303066*r**28-15250247542*r**30+4298699487*r**32
            +130675078*r**34+46905988*r**36+1295558*r**38+23499*r**40)+3*Q2**2*(
            -128320+2387592*r**2+12821215*r**4-81000881*r**6+1039831916*r**8-3445695052*r**10
            +4974719652*r**12-10475861052*r**14-31665237484*r**16+51968179100*r**18
            +70226581234*r**20-415661089630*r**22+731328149684*r**24-600059322164*r**26
            +280741368052*r**28-66174241932*r**30+17472654636*r**32-45431972*r**34
            +312176279*r**36+10766807*r**38+292320*r**40)-Q2*(-109725+2484255*r**2
            +23964347*r**4-67297751*r**6+2150789184*r**8-5178983904*r**10+15163881864*r**12
            -13348086096*r**14+12806974678*r**16+615707436638*r**18-612347723898*r**20
            -390265087622*r**22-1197497629024*r**24+2607096681072*r**26-1731346742928*r**28
            +626489400408*r**30-112208553393*r**32+25444684523*r**34+256215751*r**36
            +342768981*r**38+10542744*r**40+229896*r**42))*sqrtq2))/(-470292480000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-48988800000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-340200000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-157500*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6+5443200000*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            +11340000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*sqrtq2+235146240000*logq2**5*r**22*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((
            -104509440000*logq2**6*(-Q2+(-1+r)**2)*r**24*(3+20*r**4-56*r**6+9*r**8)*(
            -Q2+(1+r)**2)+8294400*logq2**4*(-Q2+(-1+r)**2)*r**16*(-Q2+(1+r)**2)*(
            -13260*Q2**12*r**2+60*Q2**11*(40+2238*r**2+1959*r**4)-6*Q2**10*(4300+99468*r**2
            +166571*r**4+70764*r**6)+20*Q2**9*(5320+75526*r**2+178311*r**4+146971*r**6
            +38799*r**8)-5*Q2**8*(41775+454008*r**2+1346469*r**4+1599112*r**6+837648*r**8
            +145368*r**10)+10*Q2**7*(16140+179682*r**2+635805*r**4+1009580*r**6
            +801145*r**8+286020*r**10+46008*r**12)-10*Q2**6*(-9765+25368*r**2+51105*r**4
            +338080*r**6+549977*r**8+440226*r**10+137529*r**12+85806*r**14)+2*Q2**5*(
            -145950-355872*r**2-2787054*r**4-3031231*r**6-1202400*r**8+2226030*r**10
            +2835008*r**12+1194921*r**14+786024*r**16)-5*Q2**4*(-37320-119136*r**2
            -1110951*r**4-1531468*r**6-1043807*r**8+418104*r**10+2344655*r**12+1523788*r**14
            +656919*r**16+209736*r**18)-20*Q2**3*(-1500+23193*r**2+22344*r**4+233727*r**6
            +106571*r**8-104556*r**10-499797*r**12-497963*r**14-5175*r**16-110697*r**18
            +23673*r**20)+10*Q2**2*(-9765+53544*r**2-343110*r**4+644296*r**6-142215*r**8
            -217770*r**10-185387*r**12-573450*r**14-242136*r**16+874090*r**18-122715*r**20
            +113418*r**22)+(-1+r**2)**2*(-7925+64002*r**2-644137*r**4+2092860*r**6
            -501548*r**8-14416*r**10+1553052*r**12-405848*r**14+305105*r**16+1974638*r**18
            -7619*r**20+127836*r**22)-10*Q2*(-4770+34320*r**2-287841*r**4+805951*r**6
            -521110*r**8-364818*r**10+955666*r**12+1102928*r**14-243846*r**16-406190*r**18
            +759863*r**20-80031*r**22+64278*r**24))+1152*logq2**2*r**8*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(-556584*Q2**18*r**2+24*Q2**17*(-6440+323208*r**2
            +306463*r**4)-8*Q2**16*(-206850+5519389*r**2+11628335*r**4+5174919*r**6)
            +16*Q2**15*(-453390+8198464*r**2+29667243*r**4+28688323*r**6+7989399*r**8)
            -Q2**14*(-15560475+202083880*r**2+1220893040*r**4+1833745864*r**6+1181704395*r**8
            +225561240*r**10)+2*Q2**13*(-5645325+43616511*r**2+717343940*r**4+1230354128*r**6
            +1303767993*r**8+779996385*r**10+94366656*r**12)+Q2**12*(-21123795+215895094*r**2
            +268889069*r**4+4014555896*r**6+6997825091*r**8+2134796386*r**10-510499101*r**12
            +59589024*r**14)-4*Q2**11*(-14212275+86070211*r**2+743035225*r**4+4686585867*r**6
            +11081489235*r**8+9824682745*r**10+3123228847*r**12+360722385*r**14+78294696*r**16)
            +Q2**10*(-39352005+41037548*r**2+3285943206*r**4+23975557532*r**6+82036551836*r**8
            +111640348140*r**10+68855674586*r**12+16275034772*r**14+2141869801*r**16
            +285317208*r**18)-2*Q2**9*(15644475-159295005*r**2+299102910*r**4+1564699086*r**6
            +23439363700*r**8+50040687620*r**10+51591022530*r**12+24569424530*r**14
            +2959354561*r**16+549580505*r**18+16391760*r**20)-Q2**8*(-72689925+241774542*r**2
            +1376541385*r**4+23642841412*r**6+53046035202*r**8+80273670480*r**10
            +65852812518*r**12+5296665100*r**14-1699708733*r**16+5042504322*r**18
            -160900335*r**20+132289872*r**22)+8*Q2**7*(-4477935-12549833*r**2+113135397*r**4
            +2869845901*r**6+12111514456*r**8+27782911496*r**10+40552191738*r**12
            +27367406188*r**14+7124939001*r**16+1485846481*r**18+625020601*r**20
            +805847*r**22+13167702*r**24)-Q2**6*(22941975-222773024*r**2+320246860*r**4
            +1186948608*r**6+42075249355*r**8+123826787000*r**10+253894842256*r**12
            +302901668880*r**14+128639342541*r**16+31928011680*r**18+5192478500*r**20
            +3260490288*r**22+390413905*r**24+33194376*r**26)+2*Q2**5*(17956365-41277559*r**2
            +323114312*r**4-5311848084*r**6-7966543787*r**8-13823328875*r**10-38085421224*r**12
            +36373118112*r**14+58882418407*r**16+19450066291*r**18+33943885680*r**20
            +8402339828*r**22+2995570871*r**24+427633647*r**26+3519216*r**28)+Q2**4*(
            -12569025-42558630*r**2-532283765*r**4+5857073536*r**6+20006350895*r**8
            +34234549530*r**10+191812969715*r**12+100524001040*r**14-70382940747*r**16
            -93491962450*r**18-82418789815*r**20-95990523760*r**22-24050384675*r**24
            -5151956514*r**26-571345095*r**28+1409760*r**30)-4*Q2**3*(1243725-12088901*r**2
            +33945405*r**4-197600789*r**6+1481269421*r**8+1734068835*r**10+12345396741*r**12
            +16114316675*r**14-14472290177*r**16-38680880487*r**18+1084023295*r**20
            -28955989079*r**22-2626870105*r**24-2641517559*r**26+73361791*r**28+12920745*r**30
            +2530464*r**32)+(-1+r**2)**2*(246015+536676*r**2+32866994*r**4-76476220*r**6
            +175415270*r**8+9083955020*r**10-45076434838*r**12+107812661588*r**14
            +2554205940*r**16-117106438140*r**18+3423157590*r**20+86477254348*r**22
            -27968873558*r**24+12315091780*r**26+668521870*r**28+322313500*r**30
            +20632189*r**32+563976*r**34)+Q2**2*(5835585-16402172*r**2+385462518*r**4
            -2053395604*r**6+1536932986*r**8+27486858996*r**10-116893034098*r**12
            +168733564812*r**14-98504943492*r**16-29664224772*r**18-184808077822*r**20
            +263810299812*r**22-154780905578*r**24+66730605596*r**26+491409786*r**28
            +2847158116*r**30+251116083*r**32+9739248*r**34)-2*Q2*(987525-952091*r**2
            +95622530*r**4-441681714*r**6+600269490*r**8+14843714010*r**10-78143641962*r**12
            +165889979990*r**14-93319820228*r**16+36498450420*r**18-1688578270*r**20
            -108839318678*r**22+176852299230*r**24-73189265802*r**26+24791391090*r**28
            +519434610*r**30+787021231*r**32+60572375*r**34+1916244*r**36))-16*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**22+Q2**21*(9168+5492*r**2)
            -Q2**20*(149367+1710440*r**2+145885*r**4)+2*Q2**19*(166081+11225142*r**2
            +11373357*r**4+513816*r**6)-4*Q2**18*(-500241+29074056*r**2+68728671*r**4
            +32028984*r**6+949307*r**8)+2*Q2**17*(-5615008+146448803*r**2+643844310*r**4
            +678188618*r**6+190108966*r**8+4125635*r**10)-4*Q2**16*(-3973359+74266084*r**2
            +679947566*r**4+1166558084*r**6+813909434*r**8+142704876*r**10+2477669*r**12)
            +2*Q2**15*(11775989-110636094*r**2+664396723*r**4+951187330*r**6+1749762163*r**8
            +1506240170*r**10+59782461*r**12+1513106*r**14)+2*Q2**14*(-55171233+425567014*r**2
            +2711053775*r**4+12958211190*r**6+21658743637*r**8+9739250642*r**10+1595151489*r**12
            +544099234*r**14+4360652*r**16)-2*Q2**13*(-64251489+244237704*r**2+5532279198*r**4
            +32275758294*r**6+86358159924*r**8+82047028890*r**10+28156092330*r**12
            +5697080754*r**14+880213701*r**16+5410358*r**18)+Q2**12*(32404320-689625728*r**2
            +6029515422*r**4+40568180232*r**6+219931592136*r**8+336188308392*r**10
            +225093896652*r**12+50076188856*r**14+10603021032*r**16+512577624*r**18
            -2528058*r**20)+2*Q2**11*(-115033373+399321098*r**2+2210312267*r**4+31587831686*r**6
            +31061512558*r**8+34431825288*r**10-6092006098*r**12-19785079664*r**14
            +9780730671*r**16+148443454*r**18+792861927*r**20+7594938*r**22)-2*Q2**10*(
            -93871869-301375562*r**2+3319994183*r**4+57918106482*r**6+221297158884*r**8
            +548728816820*r**10+745806838042*r**12+376195573260*r**14+111602538743*r**16
            +34133271638*r**18+4291667039*r**20+952597698*r**22+5111938*r**24)+2*Q2**9*(35349973
            -660880954*r**2+1254992504*r**4+13592393802*r**6+188409941901*r**8+595751483472*r**10
            +1400248406784*r**12+1275737968812*r**14+420777203271*r**16+112212418766*r**18
            +17786796808*r**20+3853561546*r**22+74351511*r**24-2393252*r**26)+2*Q2**8*(
            -108253049+118145044*r**2-1124814378*r**4+38306461532*r**6+18754759225*r**8
            +173212341792*r**10-500295246472*r**12-989355332216*r**14-692859876855*r**16
            -17789612956*r**18-28297635746*r**20+5682638556*r**22-1939300841*r**24
            +618754856*r**26+5264308*r**28)-2*Q2**7*(-54052263-448577294*r**2-1520978173*r**4
            +28731627586*r**6+112888864569*r**8+706645991774*r**10+929096410339*r**12
            +1001121957078*r**14+418146169379*r**16+16355794270*r**18+193861735857*r**20
            +135446846*r**22+5076541451*r**24-433805614*r**26+430061097*r**28+2026538*r**30)
            +2*Q2**6*(26086756-338891526*r**2+444452537*r**4-9932112558*r**6+69997798893*r**8
            +300770174994*r**10+915081187041*r**12+1489407656154*r**14+1687384602261*r**16
            +547655973486*r**18-13794033501*r**20+77006155926*r**22+1117169999*r**24
            -1921129978*r**26+1260136771*r**28-59789634*r**30-1335221*r**32)+2*Q2**5*(
            -41065221-30301762*r**2-2100878558*r**4+19379453494*r**6-37887938426*r**8
            +262142876010*r**10-288763677838*r**12+154465718158*r**14-604942387500*r**16
            -650739335506*r**18-222381517226*r**20-50316474078*r**22-61839285638*r**24
            -28061823154*r**26-913977578*r**28-2037242598*r**30+205606193*r**32+1540828*r**34)
            +Q2**4*(27030983+281559096*r**2+2329355103*r**4-8747645416*r**6+40739366524*r**8
            -535300669288*r**10+403110641524*r**12-1808455964520*r**14-1432781657230*r**16
            +955373106632*r**18+122065779642*r**20+994249714184*r**22+578840269196*r**24
            +246283782728*r**26+66968062644*r**28+8072207688*r**30+1963310271*r**32
            -157780704*r**34-693057*r**36)-4*Q2**3*(-2393664+28989864*r**2-155289084*r**4
            +2427128335*r**6-6125332244*r**8-451871134*r**10+21267853224*r**12-132493087338*r**14
            -254737602684*r**16+394463082666*r**18-13968192200*r**20+181366227780*r**22
            +40316224628*r**24+110206678118*r**26+21963685960*r**28+2782514298*r**30
            +999139932*r**32-155130906*r**34+9843156*r**36+123293*r**38)+2*(-1
            +r**2)**2*(-190141-1529518*r**2-33679497*r**4+9807032*r**6-1746945342*r**8
            +6647955444*r**10-39233655776*r**12-41613662324*r**14+844981789254*r**16
            -3200025798184*r**18+4808873592694*r**20-3353175039444*r**22+1172325161764*r**24
            -289357902804*r**26+26173110744*r**28-10693057756*r**30-1369313137*r**32
            -113407818*r**34-30256357*r**36+935532*r**38+5634*r**40)+2*Q2**2*(-5256619
            -1096858*r**2-569910819*r**4+3574594202*r**6-23996575640*r**8+106537748288*r**10
            -268025666192*r**12+237211890976*r**14+208084980498*r**16-175106578276*r**18
            +1047462497634*r**20-2262696717692*r**22+2130463827880*r**24-852248583952*r**26
            +143057076472*r**28-47330360656*r**30-10657058383*r**32-95706162*r**34
            -538547623*r**36+25490194*r**38+192728*r**40)-2*Q2*(-1647815-6079975*r**2
            -224696078*r**4+905703860*r**6-11449882667*r**8+57888034035*r**10-231966314240*r**12
            +211288930984*r**14+1134859600730*r**16-3216199321134*r**18-86321246700*r**20
            +6808527240080*r**22-7559948172934*r**24+3468174980510*r**26-972610147056*r**28
            +129588947480*r**30-38974080115*r**32-6566340347*r**34-280835350*r**36
            -221131268*r**38+8084625*r**40+53375*r**42))+248832000*logq2**5*r**20*(
            -420*Q2**9*r**2+60*Q2**8*(8+51*r**2+37*r**4)-40*Q2**7*(96+281*r**2+328*r**4
            +45*r**6)+4*Q2**6*(3360+6676*r**2+8487*r**4+1690*r**6-2877*r**8)+Q2**5*(
            -24675-44164*r**2-44222*r**4-19828*r**6+50433*r**8+32928*r**10)+Q2**4*(21315
            +47095*r**2+28212*r**4+23434*r**6-49925*r**8-104449*r**10-27090*r**12)
            -2*Q2**3*(-105+17105*r**2+3224*r**4+7017*r**6-23847*r**8-36323*r**10
            -32108*r**12+9345*r**14)+(-1+r**2)**2*(-2985+7299*r**2+5207*r**4-35113*r**6
            +43049*r**8+48649*r**10-24515*r**12+9277*r**14+9612*r**16)+2*Q2**2*(
            -8085+16460*r**2+1611*r**4-17045*r**6+6832*r**8+7890*r**10-25141*r**12
            +1203*r**14+26355*r**16)+Q2*(12225-33014*r**2+4784*r**4+97176*r**6
            -51266*r**8-200968*r**10-101904*r**12+68368*r**14+641*r**16-37962*r**18))*sqrtq2
            +138240*logq2**3*r**12*(-126720*Q2**17*r**2+12*Q2**16*(-64+148560*r**2+138255*r**4)
            -4*Q2**15*(-9402+2776908*r**2+5100805*r**4+2401605*r**6)+8*Q2**14*(-42285
            +4951722*r**2+13565140*r**4+12643185*r**6+4002255*r**8)-Q2**13*(-1363635
            +86687004*r**2+319732814*r**4+437695680*r**6+280496045*r**8+66584340*r**10)
            +Q2**12*(-2802555+111962901*r**2+542290348*r**4+945654486*r**6+904945125*r**8
            +465384085*r**10+86140890*r**12)-2*Q2**11*(-1092252+29218287*r**2+219760557*r**4
            +405974987*r**6+486509332*r**8+451858283*r**10+223847415*r**12+30432915*r**14)
            +2*Q2**10*(1385538-29861319*r**2-68113660*r**4-387181820*r**6-737442725*r**8
            -445060159*r**10+52256838*r**12+99728830*r**14+2599965*r**16)+Q2**9*(
            -8500965+136135098*r**2+715457180*r**4+2772737440*r**6+5644372370*r**8
            +6002352080*r**10+3224455148*r**12+684729560*r**14+22868715*r**16+33361470*r**18)
            -Q2**8*(-7365105+96724917*r**2+686589312*r**4+2903638200*r**6+6505159010*r**8
            +8811795550*r**10+7201188432*r**12+3278624872*r**14+814095615*r**16+77257485*r**18
            +41483520*r**20)+4*Q2**7*(269940-682623*r**2+38800926*r**4+259603572*r**6
            +498137280*r**8+958477090*r**10+1311563782*r**12+1116769876*r**14+548184932*r**16
            +250108425*r**18+28823820*r**20+10983420*r**22)-4*Q2**6*(1881726-14621547*r**2
            -58707772*r**4-128619222*r**6-667206707*r**8-751627606*r**10-190050502*r**12
            +697344318*r**14+912065228*r**16+595598293*r**18+375456966*r**20+49347500*r**22
            +10823805*r**24)+Q2**5*(5889849-43983528*r**2-211838870*r**4-668278800*r**6
            -2924363345*r**8-3824050776*r**10-2187239636*r**12+1501306400*r**14+4609291255*r**16
            +3553121880*r**18+2570294762*r**20+1192988944*r**22+184693665*r**24+22120200*r**26)
            +(-1+r**2)**4*(52467-214959*r**2-513578*r**4+24544170*r**6-126468135*r**8
            +333630851*r**10+143760988*r**12-186943764*r**14-290848075*r**16+152935495*r**18
            +307080582*r**20-41295254*r**22+44394367*r**24+2264805*r**26+500040*r**28)
            +Q2**4*(-638505+6880251*r**2+44455100*r**4+448931430*r**6+397599665*r**8
            +1914277805*r**10+7020098*r**12-2100059420*r**14-3651324935*r**16-3341122955*r**18
            +201357400*r**20-1839597674*r**22+74905695*r**24-69432445*r**26+8060490*r**28)
            -Q2*(-1+r**2)**2*(435207-2268252*r**2-4712327*r**4+151262062*r**6-772834785*r**8
            +1742771556*r**10+291253569*r**12-141006026*r**14+67038701*r**16-528832500*r**18
            +306950227*r**20+1870194058*r**22-383056147*r**24+289189612*r**26+12642035*r**28
            +4013010*r**30)-2*Q2**3*(960120-5602773*r**2-11544763*r**4+233427435*r**6
            -847334440*r**8+1409551585*r**10-428587659*r**12-648258219*r**14-404094200*r**16
            -558440195*r**18-617977625*r**20+2218890357*r**22-815882968*r**24+459359415*r**26
            +5504735*r**28+10029195*r**30)+2*Q2**2*(709710-4630407*r**2-5798076*r**4
            +192173588*r**6-1015157385*r**8+2272016695*r**10-1191508706*r**12+317702*r**14
            +757734969*r**16+1316552935*r**18-15793960*r**20-1505521512*r**22+2545158449*r**24
            -831291607*r**26+372854150*r**28+8703630*r**30+6519825*r**32))*sqrtq2
            -96*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(41196*Q2**21*r**2
            -12*Q2**20*(-1480+57537*r**2+57537*r**4)+120*Q2**19*(-1538+36356*r**2
            +93839*r**4+39453*r**6)-4*Q2**18*(-197020+3429590*r**2+17022939*r**4
            +17758976*r**6+4374255*r**8)+Q2**17*(-1611705+21307800*r**2+196865022*r**4
            +326801204*r**6+226422315*r**8+36585180*r**10)-Q2**16*(-825285+8328699*r**2
            +243045288*r**4+271652546*r**6+393855835*r**8+353632323*r**10+35295714*r**12)
            -2*Q2**15*(-1691530+8632397*r**2+47034651*r**4+1203624515*r**6+2322591946*r**8
            +888276297*r**10-27952759*r**12+9161007*r**14)+6*Q2**14*(-1276570+306365*r**2
            +107405990*r**4+1468114024*r**6+4369816345*r**8+4133678157*r**10+1278770820*r**12
            +132717130*r**14+15579195*r**16)-6*Q2**13*(-694360-9541905*r**2+108142642*r**4
            +1891948324*r**6+8996254464*r**8+13405058556*r**10+8681955634*r**12+1980123832*r**14
            +229100148*r**16+14985465*r**18)+Q2**12*(7231640-45106750*r**2+147589494*r**4
            -510307928*r**6+31590484676*r**8+63259793076*r**10+72748902136*r**12
            +42509817224*r**14+5135819268*r**16+692981210*r**18-25514190*r**20)+2*Q2**11*(
            -6692790-43045977*r**2-138804633*r**4+9040529951*r**6+31325757150*r**8
            +94929285204*r**10+132949671332*r**12+57641585244*r**14+10260629376*r**16
            +4505870285*r**18+355067277*r**20+63349533*r**22)-2*Q2**10*(-2475330
            -80127723*r**2-427329540*r**4+8482224308*r**6+62173944523*r**8+237632761038*r**10
            +504894152264*r**12+446597123224*r**14+157735353072*r**16+33855112253*r**18
            +6979631884*r**20+627808500*r**22+42879447*r**24)+2*Q2**9*(4015635-17649645*r**2
            -80633610*r**4-1824953034*r**6+29923651135*r**8+140347883043*r**10+544580901140*r**12
            +778778866780*r**14+486715657641*r**16+108009326625*r**18+22472141078*r**20
            +2820445950*r**22+299041125*r**24-17911335*r**26)+2*Q2**8*(-5095155-64812390*r**2
            -726733239*r**4+7729275950*r**6+19926490149*r**8+145558773576*r**10+76967287949*r**12
            -135228948996*r**14-279692483433*r**16-138804933646*r**18+24195819291*r**20
            -3024656826*r**22+968352551*r**24+82666044*r**26+42145695*r**28)-2*Q2**7*(
            -1141230-61180425*r**2-771079923*r**4+3106696853*r**6+26175882046*r**8
            +242266876761*r**10+592831687421*r**12+912351757243*r**14+868180549830*r**16
            +280334574881*r**18+70627874791*r**20+55988355171*r**22-628241398*r**24
            +1023832399*r**26+176923695*r**28+16904205*r**30)+2*Q2**6*(1923590-152827*r**2
            +31246698*r**4-2840959408*r**6+8847417085*r**8+65995782819*r**10+378992755352*r**12
            +759043973518*r**14+1225994189751*r**16+848962846475*r**18+178485168418*r**20
            +17273411172*r**22+24761709059*r**24+567468397*r**26+703397820*r**28
            +117341918*r**30-10364637*r**32)+2*Q2**5*(-1687020-30111117*r**2-526241814*r**4
            +3031195536*r**6-5399320116*r**8+87944018802*r**10-73099714*r**12+85799140020*r**14
            -12540830160*r**16-548859502468*r**18-205049783706*r**20-196227938040*r**22
            -67969411444*r**24-38817508986*r**26-8582403726*r**28-1238044236*r**30
            -53687964*r**32+12470553*r**34)+2*Q2**4*(309480+16643565*r**2+303501675*r**4
            -468666468*r**6+6072438630*r**8-72665356764*r**10-49742477450*r**12-222911612740*r**14
            -809622560514*r**16+56447378230*r**18+316674193628*r**20+117897252180*r**22
            +397604133970*r**24+157953921812*r**26+45568320090*r**28+9012406356*r**30
            +894533730*r**32+1524645*r**34-2924055*r**36)-2*Q2**3*(-289910-474605*r**2
            -31915293*r**4+714305651*r**6-771979178*r**8-2462298942*r**10-13502542778*r**12
            -21154868422*r**14-399967899894*r**16+182040594376*r**18+323036215364*r**20
            +30667931616*r**22+367504684738*r**24+62106880670*r**26+100384759962*r**28
            +4651250438*r**30+1576907092*r**32-89419323*r**34-26686727*r**36+1965165*r**38)
            +(-1+r**2)**2*(-11815-403479*r**2-12116849*r**4+7431355*r**6-1021262296*r**8
            +3713843244*r**10-19357856828*r**12-79702366908*r**14+643446898310*r**16
            -1875974607162*r**18+1346326900378*r**20+947285878418*r**22-1500221460412*r**24
            +547694052940*r**26-160473203388*r**28-1314878428*r**30-6495045111*r**32
            -596417831*r**34-67757105*r**36-1871029*r**38+93996*r**40)+2*Q2**2*(
            -209010-3774075*r**2-100503306*r**4+495159340*r**6-4934409087*r**8+23742388308*r**10
            -47797118772*r**12-65442601284*r**14+435289265808*r**16-512251145506*r**18
            +201626183424*r**20+843810468444*r**22-1273773051514*r**24+942040248564*r**26
            -363615254652*r**28+28925356068*r**30-22402113222*r**32-2276793771*r**34
            -420155462*r**36-21995880*r**38+1575585*r**40)+Q2*(113115+2926986*r**2
            +81610158*r**4-276256040*r**6+5678145215*r**8-28132582398*r**10+96147156696*r**12
            +166092974016*r**14-1702057063770*r**16+4055392372820*r**18-2870556455516*r**20
            +1790627790576*r**22-4370925867706*r**24+5072448079060*r**26-2208592193160*r**28
            +617619359616*r**30-27933564609*r**32+28296357282*r**34+2726470750*r**36
            +402827000*r**38+15322683*r**40-882774*r**42))*sqrtq2)*math.log(mu0))/(-156764160000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-16329600000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-113400000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-52500*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6+1814400000*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            +3780000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*sqrtq2+78382080000*logq2**5*r**22*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+FLAGcf*((
            -28304640000*logq2**5*r**18*(-3-4*r**2+20*r**4-28*r**6+3*r**8)+2246400*logq2**3*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(-795+6057*r**2+2265*Q2**10*r**2
            +62201*r**4-540963*r**6+687258*r**8+728234*r**10+339426*r**12+49434*r**14
            -147727*r**16+329277*r**18-14379*r**20+13977*r**22-20*Q2**9*(-4+1017*r**2
            +1005*r**4)+Q2**8*(280+72517*r**2+151792*r**4+73077*r**6)-2*Q2**7*(600
            +64888*r**2+219461*r**4+224516*r**6+64203*r**8)+Q2**6*(770+101681*r**2
            +559676*r**4+957932*r**6+613686*r**8+75831*r**10)+Q2**5*(-455+17548*r**2
            -136541*r**4-617220*r**6-660225*r**8-255476*r**10+96873*r**12)-Q2**4*(
            -3045+87340*r**2+468405*r**4+501068*r**6+825753*r**8+560388*r**10+284575*r**12
            +186060*r**14)+2*Q2**3*(-1715+22814*r**2+238659*r**4+554490*r**6+862077*r**8
            +1111922*r**10+508885*r**12+190734*r**14+38694*r**16)+2*Q2**2*(-250
            +5798*r**2+2476*r**4-431343*r**6-245360*r**8-955997*r**10-828760*r**12
            -43193*r**14-87874*r**16+25023*r**18)+Q2*(2205-19836*r**2-191971*r**4
            +802700*r**6-945454*r**8-373224*r**10+1500326*r**12+363196*r**14-631655*r**16
            +52604*r**18-54891*r**20))+312*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1
            +r)**2)**2*(-11815-17342*r**2+20598*Q2**16*r**2-1539738*r**4-1828220*r**6
            -93296530*r**8+531809700*r**10-1202798314*r**12-12016064876*r**14+34941377640*r**16
            -16859928440*r**18-10427104030*r**20+13402061004*r**22-3848051134*r**24
            +1002915580*r**26-360030*r**28+15413020*r**30+576527*r**32+46998*r**34
            -12*Q2**15*(-1480+23619*r**2+19179*r**4)+4*Q2**14*(-32820+315810*r**2
            +775091*r**4+250170*r**6)-4*Q2**13*(-89680+561415*r**2+3441914*r**4
            +3172239*r**6+501840*r**8)+3*Q2**12*(-102835+108210*r**2+8242288*r**4
            +14188924*r**6+7455783*r**8+347210*r**10)+Q2**11*(-501830+4084716*r**2
            -5212386*r**4-3865176*r**6-7029506*r**8-4035196*r**10+3308706*r**12)
            -2*Q2**10*(-682770+1489843*r**2+22024696*r**4+119695125*r**6+221267970*r**8
            +106897065*r**10+24392896*r**12+3266703*r**14)+2*Q2**9*(-367345-3071840*r**2
            +26710386*r**4+227220060*r**6+714133400*r**8+705569180*r**10+204029050*r**12
            +35732936*r**14+1173645*r**16)+Q2**8*(-1049565+10126620*r**2-78738*r**4
            -171444948*r**6-1341551320*r**8-2311353340*r**10-1458873670*r**12-92048748*r**14
            -9710163*r**16+5670720*r**18)-4*Q2**7*(-406065+252615*r**2+7631982*r**4
            +81058936*r**6+189015752*r**8+480461830*r**10+282469470*r**12+143391072*r**14
            +131845761*r**16+16615587*r**18+1761540*r**20)+4*Q2**6*(-86460-2028669*r**2
            +1555743*r**4+74640153*r**6+482523418*r**8+2086011688*r**10+3349274064*r**12
            +1600218868*r**14+600107578*r**16+136941693*r**18+14561673*r**20+206811*r**22)
            +4*Q2**5*(-201465+1468989*r**2+1303132*r**4+13924205*r**6-125757445*r**8
            -1264814850*r**10-4711887796*r**12-4758378986*r**14-842818895*r**16-375154195*r**18
            +18838800*r**20+882517*r**22+946389*r**24)-Q2**4*(-642845-567190*r**2
            -8788364*r**4+119119700*r**6+481332275*r**8+3568163190*r**10-1523155600*r**12
            -13344747272*r**14-6577893895*r**16+5528768150*r**18+405581180*r**20
            +405698740*r**22+29345361*r**24+2648970*r**26)+2*Q2**3*(-18015-1180230*r**2
            -3200553*r**4-5407748*r**6-36754535*r**8+2081584130*r**10+4548956715*r**12
            +5193822776*r**14+943425851*r**16+2957420990*r**18+3054240885*r**20+424070540*r**22
            +85143627*r**24+6359622*r**26+15945*r**28)+2*Q2**2*(-80690+490665*r**2
            -3006468*r**4+17883911*r**6+95819042*r**8-120874895*r**10-1518601440*r**12
            -4189196169*r**14-9293444622*r**16+968976371*r**18-4244198580*r**20+292174125*r**22
            -168527138*r**24+35301811*r**26+1076312*r**28+351765*r**30)-2*Q2*(-38835
            +44444*r**2-3174082*r**4+2322168*r**6-63994442*r**8+565501168*r**10
            +36509186*r**12-748140236*r**14+1938362164*r**16-8068634516*r**18+7204485794*r**20
            -4164681904*r**22+1469846818*r**24-20195832*r**26+35804958*r**28+1423748*r**30
            +159399*r**32))+134784000*logq2**4*r**14*(340-1741*r**2+105*Q2**7*r**2
            +5955*r**4-5175*r**6+3561*r**8+12591*r**10-4573*r**12+841*r**14+801*r**16
            -5*Q2**6*(16+111*r**2+159*r**4)+5*Q2**5*(96+279*r**2+724*r**4+471*r**6)
            -Q2**4*(1200+2331*r**2+6259*r**4+9055*r**6+3399*r**8)+Q2**3*(1075+2834*r**2
            +6055*r**4+10016*r**6+11036*r**8+1956*r**10)+Q2**2*(270-2591*r**2-1978*r**4
            -3537*r**6-9223*r**8-5456*r**10+1011*r**12)-Q2*(885-2989*r**2+1628*r**4
            +3750*r**6-2139*r**8-6015*r**10+746*r**12+2034*r**14))*sqrtq2+37440*logq2**2*r**6*(9795*Q2**15*r**2
            -Q2**14*(176+119205*r**2+119733*r**4)+Q2**13*(-5296+630809*r**2+1282762*r**4
            +620217*r**6)-Q2**12*(-44624+1797899*r**2+5730699*r**4+5747777*r**6
            +1717833*r**8)+Q2**11*(-132011+2812426*r**2+13177088*r**4+19596512*r**6
            +13402543*r**8+2501682*r**10)-Q2**10*(-152094+1884891*r**2+14751739*r**4
            +23319644*r**6+25012874*r**8+15393573*r**10+948213*r**12)-Q2**9*(-61377
            +955590*r**2-2004191*r**4+27221400*r**6+53930425*r**8+19942298*r**10
            -1495185*r**12+2960784*r**14)+Q2**8*(-359208+2674127*r**2+14091751*r**4
            +115507551*r**6+287499375*r**8+281944837*r**10+101796957*r**12+19281861*r**14
            +5174541*r**16)-Q2**7*(-326202+1356937*r**2+15023772*r**4+128088876*r**6
            +436981944*r**8+647506918*r**10+448970212*r**12+106281012*r**14+23560626*r**16
            +2453409*r**18)+Q2**6*(51972-882067*r**2+5420949*r**4+26850376*r**6
            +214276264*r**8+487479138*r**10+538578698*r**12+269907144*r**14-17715324*r**16
            +7811169*r**18-2140239*r**20)+Q2**5*(-292438+1411877*r**2-1564652*r**4
            +61556533*r**6+137230708*r**8+156015498*r**10+175809288*r**12+42910898*r**14
            +72541858*r**16+127163633*r**18+6907236*r**20+3415641*r**22)-Q2**4*(
            -174424+508005*r**2-2190467*r**4+50135675*r**6+210274875*r**8+405579898*r**10
            +706477090*r**12+733179534*r**14+284543150*r**16+198691425*r**18+91612001*r**20
            +8095255*r**22+1339983*r**24)+Q2**3*(22129-237236*r**2+263412*r**4+1316932*r**6
            +76669625*r**8+231440812*r**10+264869952*r**12+610487536*r**14+552435251*r**16
            -6456100*r**18+147596684*r**20-7996116*r**22+3168227*r**24-515508*r**26)
            +(-1+r**2)**2*(-4656+9857*r**2-360589*r**4+1247426*r**6+7361182*r**8
            -110253713*r**10+191149981*r**12+55415668*r**14-108222692*r**16+14298391*r**18
            +43828469*r**20-8037238*r**22+4174646*r**24+77241*r**26+36027*r**28)
            +Q2**2*(-69826+307411*r**2-2666629*r**4+16719828*r**6+12513002*r**8
            -241673693*r**10+315050803*r**12+82535368*r**14-242061806*r**16-230761519*r**18
            +260549769*r**20-105534364*r**22+44073286*r**24-402247*r**26+700617*r**28)
            -Q2*(-30789+123784*r**2-1811563*r**4+9633038*r**6+18179307*r**8-295876664*r**10
            +442052917*r**12+58380406*r**14+155617849*r**16-52517144*r**18-146799465*r**20
            +215994074*r**22-63390943*r**24+23026888*r**26+35487*r**28+262818*r**30))*sqrtq2
            +(1625*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(-291+525*Q2**7-20147*r**2-5111*r**4
            +211609*r**6+130409*r**8-10375*r**10-1219*r**12+45*r**14-375*Q2**6*(1
            +r**2)-5*Q2**5*(75-172*r**2+75*r**4)+Q2**4*(-291+869*r**2-139*r**4
            +45*r**6)+Q2**3*(-291+128*r**2+2840*r**4-544*r**6+45*r**8)+Q2**2*(
            -291-2315*r**2+9816*r**4+3768*r**6-859*r**8+45*r**10)+Q2*(-291-7580*r**2
            +15313*r**4+43104*r**6+1313*r**8-1084*r**10+45*r**12))-546*(Q2-(
            -1+r)**2)**2*(Q2-(1+r)**2)**2*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**2*(375*Q2**11-1050*Q2**10*(1+r**2)+Q2**9*(-75+2636*r**2-75*r**4)
            +Q2**8*(2019-4273*r**2-5641*r**4+2475*r**6)-6*Q2**7*(122-611*r**2-3199*r**4
            -817*r**6+225*r**8)-4*Q2**6*(222-1391*r**2+9786*r**4+10698*r**6-2075*r**8
            +450*r**10)+2*Q2**5*(18-1019*r**2+28135*r**4+77994*r**6+34708*r**8
            -5291*r**10+675*r**12)+6*Q2**4*(5-791*r**2+3709*r**4-10219*r**6-14477*r**8
            +4515*r**10-521*r**12+75*r**14)+Q2**3*(261-3562*r**2-66630*r**4-26970*r**6
            +109988*r**8+83514*r**10-128082*r**12+1226*r**14-225*r**16)-2*Q2**2*(
            -81+53*r**2+22820*r**4+69696*r**6+139532*r**8+221348*r**10+99744*r**12
            -9148*r**14-1879*r**16+75*r**18)-3*Q2*(19-662*r**2+3229*r**4+59504*r**6
            +5830*r**8+59556*r**10+27322*r**12+78336*r**14-16489*r**16-670*r**18
            +25*r**20)+3*(-27+641*r**2+3833*r**4-38555*r**6+4522*r**8-164262*r**10
            -142766*r**12-158558*r**14+66705*r**16-2747*r**18-811*r**20+25*r**22))
            +325*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(21
            +37695*Q2**13+81479*r**2-1584410*r**4-14507670*r**6-82841935*r**8-255824893*r**10
            -460434400*r**12-1068299008*r**14-361893349*r**16+58874825*r**18+14340762*r**20
            +293686*r**22-42817*r**24+909*r**26-95691*Q2**12*(1+r**2)-6*Q2**11*(2458
            -41935*r**2+2458*r**4)+6*Q2**10*(20677-36566*r**2-60482*r**4+28649*r**6)
            -Q2**9*(-51093+388582*r**2+1885604*r**4+276886*r**6+4755*r**8)+Q2**8*(
            -80445+788749*r**2+2948334*r**4+2390142*r**6+1102213*r**8-156885*r**10)
            -4*Q2**7*(15414-241967*r**2-1034942*r**4+602597*r**6-1322108*r**8-82211*r**10
            +4632*r**12)+4*Q2**6*(-2205-200162*r**2+605612*r**4+3121748*r**6+4660100*r**8
            +195992*r**10-295106*r**12+21399*r**14)+Q2**5*(21057-1052948*r**2-3524496*r**4
            +6693768*r**6+25597478*r**8+12429480*r**10-7130400*r**12-573236*r**14
            +30297*r**16)+Q2**4*(36147+126647*r**2-8436724*r**4-4697096*r**6+54517930*r**8
            +74607994*r**10-16624424*r**12-5695156*r**14+484391*r**16-21645*r**18)
            -2*Q2**3*(-4770-34853*r**2+3342806*r**4+23536190*r**6+31970104*r**8
            +1598142*r**10+56702896*r**12+19694990*r**14-2068534*r**16-255821*r**18
            +8730*r**20)-2*Q2**2*(6069-34214*r**2-1213662*r**4+22232499*r**6+117743552*r**8
            +164919060*r**10+202917204*r**12+122870000*r**14+11530119*r**16-1226034*r**18
            -2426*r**20+153*r**22)+Q2*(-6117+202778*r**2+1417412*r**4-24058658*r**6
            -194508899*r**8-146410808*r**10-174487352*r**12-481304024*r**14-81326867*r**16
            +15112174*r**18-400060*r**20-151606*r**22+3627*r**24)))*sqrtq2)/(-78382080000*logq2**5*r**20
            -5443200000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-18900000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4+32659200000*logq2**4*r**16*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+453600000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+315000*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +((-2177280000*logq2**5*r**18*(-3-4*r**2+20*r**4-28*r**6+3*r**8)+172800*logq2**3*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(-795+6057*r**2+2265*Q2**10*r**2
            +62201*r**4-540963*r**6+687258*r**8+728234*r**10+339426*r**12+49434*r**14
            -147727*r**16+329277*r**18-14379*r**20+13977*r**22-20*Q2**9*(-4+1017*r**2
            +1005*r**4)+Q2**8*(280+72517*r**2+151792*r**4+73077*r**6)-2*Q2**7*(600
            +64888*r**2+219461*r**4+224516*r**6+64203*r**8)+Q2**6*(770+101681*r**2
            +559676*r**4+957932*r**6+613686*r**8+75831*r**10)+Q2**5*(-455+17548*r**2
            -136541*r**4-617220*r**6-660225*r**8-255476*r**10+96873*r**12)-Q2**4*(
            -3045+87340*r**2+468405*r**4+501068*r**6+825753*r**8+560388*r**10+284575*r**12
            +186060*r**14)+2*Q2**3*(-1715+22814*r**2+238659*r**4+554490*r**6+862077*r**8
            +1111922*r**10+508885*r**12+190734*r**14+38694*r**16)+2*Q2**2*(-250
            +5798*r**2+2476*r**4-431343*r**6-245360*r**8-955997*r**10-828760*r**12
            -43193*r**14-87874*r**16+25023*r**18)+Q2*(2205-19836*r**2-191971*r**4
            +802700*r**6-945454*r**8-373224*r**10+1500326*r**12+363196*r**14-631655*r**16
            +52604*r**18-54891*r**20))+24*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1
            +r)**2)**2*(-11815-17342*r**2+20598*Q2**16*r**2-1539738*r**4-1828220*r**6
            -93296530*r**8+531809700*r**10-1202798314*r**12-12016064876*r**14+34941377640*r**16
            -16859928440*r**18-10427104030*r**20+13402061004*r**22-3848051134*r**24
            +1002915580*r**26-360030*r**28+15413020*r**30+576527*r**32+46998*r**34
            -12*Q2**15*(-1480+23619*r**2+19179*r**4)+4*Q2**14*(-32820+315810*r**2
            +775091*r**4+250170*r**6)-4*Q2**13*(-89680+561415*r**2+3441914*r**4
            +3172239*r**6+501840*r**8)+3*Q2**12*(-102835+108210*r**2+8242288*r**4
            +14188924*r**6+7455783*r**8+347210*r**10)+Q2**11*(-501830+4084716*r**2
            -5212386*r**4-3865176*r**6-7029506*r**8-4035196*r**10+3308706*r**12)
            -2*Q2**10*(-682770+1489843*r**2+22024696*r**4+119695125*r**6+221267970*r**8
            +106897065*r**10+24392896*r**12+3266703*r**14)+2*Q2**9*(-367345-3071840*r**2
            +26710386*r**4+227220060*r**6+714133400*r**8+705569180*r**10+204029050*r**12
            +35732936*r**14+1173645*r**16)+Q2**8*(-1049565+10126620*r**2-78738*r**4
            -171444948*r**6-1341551320*r**8-2311353340*r**10-1458873670*r**12-92048748*r**14
            -9710163*r**16+5670720*r**18)-4*Q2**7*(-406065+252615*r**2+7631982*r**4
            +81058936*r**6+189015752*r**8+480461830*r**10+282469470*r**12+143391072*r**14
            +131845761*r**16+16615587*r**18+1761540*r**20)+4*Q2**6*(-86460-2028669*r**2
            +1555743*r**4+74640153*r**6+482523418*r**8+2086011688*r**10+3349274064*r**12
            +1600218868*r**14+600107578*r**16+136941693*r**18+14561673*r**20+206811*r**22)
            +4*Q2**5*(-201465+1468989*r**2+1303132*r**4+13924205*r**6-125757445*r**8
            -1264814850*r**10-4711887796*r**12-4758378986*r**14-842818895*r**16-375154195*r**18
            +18838800*r**20+882517*r**22+946389*r**24)-Q2**4*(-642845-567190*r**2
            -8788364*r**4+119119700*r**6+481332275*r**8+3568163190*r**10-1523155600*r**12
            -13344747272*r**14-6577893895*r**16+5528768150*r**18+405581180*r**20
            +405698740*r**22+29345361*r**24+2648970*r**26)+2*Q2**3*(-18015-1180230*r**2
            -3200553*r**4-5407748*r**6-36754535*r**8+2081584130*r**10+4548956715*r**12
            +5193822776*r**14+943425851*r**16+2957420990*r**18+3054240885*r**20+424070540*r**22
            +85143627*r**24+6359622*r**26+15945*r**28)+2*Q2**2*(-80690+490665*r**2
            -3006468*r**4+17883911*r**6+95819042*r**8-120874895*r**10-1518601440*r**12
            -4189196169*r**14-9293444622*r**16+968976371*r**18-4244198580*r**20+292174125*r**22
            -168527138*r**24+35301811*r**26+1076312*r**28+351765*r**30)-2*Q2*(-38835
            +44444*r**2-3174082*r**4+2322168*r**6-63994442*r**8+565501168*r**10
            +36509186*r**12-748140236*r**14+1938362164*r**16-8068634516*r**18+7204485794*r**20
            -4164681904*r**22+1469846818*r**24-20195832*r**26+35804958*r**28+1423748*r**30
            +159399*r**32))+10368000*logq2**4*r**14*(340-1741*r**2+105*Q2**7*r**2+5955*r**4
            -5175*r**6+3561*r**8+12591*r**10-4573*r**12+841*r**14+801*r**16-5*Q2**6*(16
            +111*r**2+159*r**4)+5*Q2**5*(96+279*r**2+724*r**4+471*r**6)-Q2**4*(1200
            +2331*r**2+6259*r**4+9055*r**6+3399*r**8)+Q2**3*(1075+2834*r**2+6055*r**4
            +10016*r**6+11036*r**8+1956*r**10)+Q2**2*(270-2591*r**2-1978*r**4-3537*r**6
            -9223*r**8-5456*r**10+1011*r**12)-Q2*(885-2989*r**2+1628*r**4+3750*r**6
            -2139*r**8-6015*r**10+746*r**12+2034*r**14))*sqrtq2+2880*logq2**2*r**6*(9795*Q2**15*r**2
            -Q2**14*(176+119205*r**2+119733*r**4)+Q2**13*(-5296+630809*r**2+1282762*r**4
            +620217*r**6)-Q2**12*(-44624+1797899*r**2+5730699*r**4+5747777*r**6
            +1717833*r**8)+Q2**11*(-132011+2812426*r**2+13177088*r**4+19596512*r**6
            +13402543*r**8+2501682*r**10)-Q2**10*(-152094+1884891*r**2+14751739*r**4
            +23319644*r**6+25012874*r**8+15393573*r**10+948213*r**12)-Q2**9*(-61377
            +955590*r**2-2004191*r**4+27221400*r**6+53930425*r**8+19942298*r**10
            -1495185*r**12+2960784*r**14)+Q2**8*(-359208+2674127*r**2+14091751*r**4
            +115507551*r**6+287499375*r**8+281944837*r**10+101796957*r**12+19281861*r**14
            +5174541*r**16)-Q2**7*(-326202+1356937*r**2+15023772*r**4+128088876*r**6
            +436981944*r**8+647506918*r**10+448970212*r**12+106281012*r**14+23560626*r**16
            +2453409*r**18)+Q2**6*(51972-882067*r**2+5420949*r**4+26850376*r**6
            +214276264*r**8+487479138*r**10+538578698*r**12+269907144*r**14-17715324*r**16
            +7811169*r**18-2140239*r**20)+Q2**5*(-292438+1411877*r**2-1564652*r**4
            +61556533*r**6+137230708*r**8+156015498*r**10+175809288*r**12+42910898*r**14
            +72541858*r**16+127163633*r**18+6907236*r**20+3415641*r**22)-Q2**4*(
            -174424+508005*r**2-2190467*r**4+50135675*r**6+210274875*r**8+405579898*r**10
            +706477090*r**12+733179534*r**14+284543150*r**16+198691425*r**18+91612001*r**20
            +8095255*r**22+1339983*r**24)+Q2**3*(22129-237236*r**2+263412*r**4+1316932*r**6
            +76669625*r**8+231440812*r**10+264869952*r**12+610487536*r**14+552435251*r**16
            -6456100*r**18+147596684*r**20-7996116*r**22+3168227*r**24-515508*r**26)
            +(-1+r**2)**2*(-4656+9857*r**2-360589*r**4+1247426*r**6+7361182*r**8
            -110253713*r**10+191149981*r**12+55415668*r**14-108222692*r**16+14298391*r**18
            +43828469*r**20-8037238*r**22+4174646*r**24+77241*r**26+36027*r**28)
            +Q2**2*(-69826+307411*r**2-2666629*r**4+16719828*r**6+12513002*r**8
            -241673693*r**10+315050803*r**12+82535368*r**14-242061806*r**16-230761519*r**18
            +260549769*r**20-105534364*r**22+44073286*r**24-402247*r**26+700617*r**28)
            -Q2*(-30789+123784*r**2-1811563*r**4+9633038*r**6+18179307*r**8-295876664*r**10
            +442052917*r**12+58380406*r**14+155617849*r**16-52517144*r**18-146799465*r**20
            +215994074*r**22-63390943*r**24+23026888*r**26+35487*r**28+262818*r**30))*sqrtq2
            +(125*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(-291+525*Q2**7-20147*r**2-5111*r**4
            +211609*r**6+130409*r**8-10375*r**10-1219*r**12+45*r**14-375*Q2**6*(1
            +r**2)-5*Q2**5*(75-172*r**2+75*r**4)+Q2**4*(-291+869*r**2-139*r**4
            +45*r**6)+Q2**3*(-291+128*r**2+2840*r**4-544*r**6+45*r**8)+Q2**2*(
            -291-2315*r**2+9816*r**4+3768*r**6-859*r**8+45*r**10)+Q2*(-291-7580*r**2
            +15313*r**4+43104*r**6+1313*r**8-1084*r**10+45*r**12))-42*(Q2-(-1
            +r)**2)**2*(Q2-(1+r)**2)**2*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**2*(375*Q2**11-1050*Q2**10*(1+r**2)+Q2**9*(-75+2636*r**2-75*r**4)
            +Q2**8*(2019-4273*r**2-5641*r**4+2475*r**6)-6*Q2**7*(122-611*r**2-3199*r**4
            -817*r**6+225*r**8)-4*Q2**6*(222-1391*r**2+9786*r**4+10698*r**6-2075*r**8
            +450*r**10)+2*Q2**5*(18-1019*r**2+28135*r**4+77994*r**6+34708*r**8
            -5291*r**10+675*r**12)+6*Q2**4*(5-791*r**2+3709*r**4-10219*r**6-14477*r**8
            +4515*r**10-521*r**12+75*r**14)+Q2**3*(261-3562*r**2-66630*r**4-26970*r**6
            +109988*r**8+83514*r**10-128082*r**12+1226*r**14-225*r**16)-2*Q2**2*(
            -81+53*r**2+22820*r**4+69696*r**6+139532*r**8+221348*r**10+99744*r**12
            -9148*r**14-1879*r**16+75*r**18)-3*Q2*(19-662*r**2+3229*r**4+59504*r**6
            +5830*r**8+59556*r**10+27322*r**12+78336*r**14-16489*r**16-670*r**18
            +25*r**20)+3*(-27+641*r**2+3833*r**4-38555*r**6+4522*r**8-164262*r**10
            -142766*r**12-158558*r**14+66705*r**16-2747*r**18-811*r**20+25*r**22))
            +25*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(21+37695*Q2**13
            +81479*r**2-1584410*r**4-14507670*r**6-82841935*r**8-255824893*r**10
            -460434400*r**12-1068299008*r**14-361893349*r**16+58874825*r**18+14340762*r**20
            +293686*r**22-42817*r**24+909*r**26-95691*Q2**12*(1+r**2)-6*Q2**11*(2458
            -41935*r**2+2458*r**4)+6*Q2**10*(20677-36566*r**2-60482*r**4+28649*r**6)
            -Q2**9*(-51093+388582*r**2+1885604*r**4+276886*r**6+4755*r**8)+Q2**8*(
            -80445+788749*r**2+2948334*r**4+2390142*r**6+1102213*r**8-156885*r**10)
            -4*Q2**7*(15414-241967*r**2-1034942*r**4+602597*r**6-1322108*r**8-82211*r**10
            +4632*r**12)+4*Q2**6*(-2205-200162*r**2+605612*r**4+3121748*r**6+4660100*r**8
            +195992*r**10-295106*r**12+21399*r**14)+Q2**5*(21057-1052948*r**2-3524496*r**4
            +6693768*r**6+25597478*r**8+12429480*r**10-7130400*r**12-573236*r**14
            +30297*r**16)+Q2**4*(36147+126647*r**2-8436724*r**4-4697096*r**6+54517930*r**8
            +74607994*r**10-16624424*r**12-5695156*r**14+484391*r**16-21645*r**18)
            -2*Q2**3*(-4770-34853*r**2+3342806*r**4+23536190*r**6+31970104*r**8
            +1598142*r**10+56702896*r**12+19694990*r**14-2068534*r**16-255821*r**18
            +8730*r**20)-2*Q2**2*(6069-34214*r**2-1213662*r**4+22232499*r**6+117743552*r**8
            +164919060*r**10+202917204*r**12+122870000*r**14+11530119*r**16-1226034*r**18
            -2426*r**20+153*r**22)+Q2*(-6117+202778*r**2+1417412*r**4-24058658*r**6
            -194508899*r**8-146410808*r**10-174487352*r**12-481304024*r**14-81326867*r**16
            +15112174*r**18-400060*r**20-151606*r**22+3627*r**24)))*sqrtq2)*math.log(mumuG))/(
            -8709120000*logq2**5*r**20-604800000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -2100000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+3628800000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+50400000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+35000*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2))
            +((104509440000*logq2**6*(-Q2+(-1+r)**2)*r**24*(3+20*r**4-56*r**6+9*r**8)*(
            -Q2+(1+r)**2)-8294400*logq2**4*(-Q2+(-1+r)**2)*r**16*(-Q2+(1+r)**2)*(
            -13260*Q2**12*r**2+60*Q2**11*(40+2238*r**2+1959*r**4)-6*Q2**10*(4300+99468*r**2
            +166571*r**4+70764*r**6)+20*Q2**9*(5320+75526*r**2+178311*r**4+146971*r**6
            +38799*r**8)-5*Q2**8*(41775+454008*r**2+1346469*r**4+1599112*r**6+837648*r**8
            +145368*r**10)+10*Q2**7*(16140+179682*r**2+635805*r**4+1009580*r**6
            +801145*r**8+286020*r**10+46008*r**12)-10*Q2**6*(-9765+25368*r**2+51105*r**4
            +338080*r**6+549977*r**8+440226*r**10+137529*r**12+85806*r**14)+2*Q2**5*(
            -145950-355872*r**2-2787054*r**4-3031231*r**6-1202400*r**8+2226030*r**10
            +2835008*r**12+1194921*r**14+786024*r**16)-5*Q2**4*(-37320-119136*r**2
            -1110951*r**4-1531468*r**6-1043807*r**8+418104*r**10+2344655*r**12+1523788*r**14
            +656919*r**16+209736*r**18)-20*Q2**3*(-1500+23193*r**2+22344*r**4+233727*r**6
            +106571*r**8-104556*r**10-499797*r**12-497963*r**14-5175*r**16-110697*r**18
            +23673*r**20)+10*Q2**2*(-9765+53544*r**2-343110*r**4+644296*r**6-142215*r**8
            -217770*r**10-185387*r**12-573450*r**14-242136*r**16+874090*r**18-122715*r**20
            +113418*r**22)+(-1+r**2)**2*(-7925+64002*r**2-644137*r**4+2092860*r**6
            -501548*r**8-14416*r**10+1553052*r**12-405848*r**14+305105*r**16+1974638*r**18
            -7619*r**20+127836*r**22)-10*Q2*(-4770+34320*r**2-287841*r**4+805951*r**6
            -521110*r**8-364818*r**10+955666*r**12+1102928*r**14-243846*r**16-406190*r**18
            +759863*r**20-80031*r**22+64278*r**24))-1152*logq2**2*r**8*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(-556584*Q2**18*r**2+24*Q2**17*(-6440+323208*r**2
            +306463*r**4)-8*Q2**16*(-206850+5519389*r**2+11628335*r**4+5174919*r**6)
            +16*Q2**15*(-453390+8198464*r**2+29667243*r**4+28688323*r**6+7989399*r**8)
            -Q2**14*(-15560475+202083880*r**2+1220893040*r**4+1833745864*r**6+1181704395*r**8
            +225561240*r**10)+2*Q2**13*(-5645325+43616511*r**2+717343940*r**4+1230354128*r**6
            +1303767993*r**8+779996385*r**10+94366656*r**12)+Q2**12*(-21123795+215895094*r**2
            +268889069*r**4+4014555896*r**6+6997825091*r**8+2134796386*r**10-510499101*r**12
            +59589024*r**14)-4*Q2**11*(-14212275+86070211*r**2+743035225*r**4+4686585867*r**6
            +11081489235*r**8+9824682745*r**10+3123228847*r**12+360722385*r**14+78294696*r**16)
            +Q2**10*(-39352005+41037548*r**2+3285943206*r**4+23975557532*r**6+82036551836*r**8
            +111640348140*r**10+68855674586*r**12+16275034772*r**14+2141869801*r**16
            +285317208*r**18)-2*Q2**9*(15644475-159295005*r**2+299102910*r**4+1564699086*r**6
            +23439363700*r**8+50040687620*r**10+51591022530*r**12+24569424530*r**14
            +2959354561*r**16+549580505*r**18+16391760*r**20)-Q2**8*(-72689925+241774542*r**2
            +1376541385*r**4+23642841412*r**6+53046035202*r**8+80273670480*r**10
            +65852812518*r**12+5296665100*r**14-1699708733*r**16+5042504322*r**18
            -160900335*r**20+132289872*r**22)+8*Q2**7*(-4477935-12549833*r**2+113135397*r**4
            +2869845901*r**6+12111514456*r**8+27782911496*r**10+40552191738*r**12
            +27367406188*r**14+7124939001*r**16+1485846481*r**18+625020601*r**20
            +805847*r**22+13167702*r**24)-Q2**6*(22941975-222773024*r**2+320246860*r**4
            +1186948608*r**6+42075249355*r**8+123826787000*r**10+253894842256*r**12
            +302901668880*r**14+128639342541*r**16+31928011680*r**18+5192478500*r**20
            +3260490288*r**22+390413905*r**24+33194376*r**26)+2*Q2**5*(17956365-41277559*r**2
            +323114312*r**4-5311848084*r**6-7966543787*r**8-13823328875*r**10-38085421224*r**12
            +36373118112*r**14+58882418407*r**16+19450066291*r**18+33943885680*r**20
            +8402339828*r**22+2995570871*r**24+427633647*r**26+3519216*r**28)+Q2**4*(
            -12569025-42558630*r**2-532283765*r**4+5857073536*r**6+20006350895*r**8
            +34234549530*r**10+191812969715*r**12+100524001040*r**14-70382940747*r**16
            -93491962450*r**18-82418789815*r**20-95990523760*r**22-24050384675*r**24
            -5151956514*r**26-571345095*r**28+1409760*r**30)-4*Q2**3*(1243725-12088901*r**2
            +33945405*r**4-197600789*r**6+1481269421*r**8+1734068835*r**10+12345396741*r**12
            +16114316675*r**14-14472290177*r**16-38680880487*r**18+1084023295*r**20
            -28955989079*r**22-2626870105*r**24-2641517559*r**26+73361791*r**28+12920745*r**30
            +2530464*r**32)+(-1+r**2)**2*(246015+536676*r**2+32866994*r**4-76476220*r**6
            +175415270*r**8+9083955020*r**10-45076434838*r**12+107812661588*r**14
            +2554205940*r**16-117106438140*r**18+3423157590*r**20+86477254348*r**22
            -27968873558*r**24+12315091780*r**26+668521870*r**28+322313500*r**30
            +20632189*r**32+563976*r**34)+Q2**2*(5835585-16402172*r**2+385462518*r**4
            -2053395604*r**6+1536932986*r**8+27486858996*r**10-116893034098*r**12
            +168733564812*r**14-98504943492*r**16-29664224772*r**18-184808077822*r**20
            +263810299812*r**22-154780905578*r**24+66730605596*r**26+491409786*r**28
            +2847158116*r**30+251116083*r**32+9739248*r**34)-2*Q2*(987525-952091*r**2
            +95622530*r**4-441681714*r**6+600269490*r**8+14843714010*r**10-78143641962*r**12
            +165889979990*r**14-93319820228*r**16+36498450420*r**18-1688578270*r**20
            -108839318678*r**22+176852299230*r**24-73189265802*r**26+24791391090*r**28
            +519434610*r**30+787021231*r**32+60572375*r**34+1916244*r**36))+16*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**22+Q2**21*(9168+5492*r**2)
            -Q2**20*(149367+1710440*r**2+145885*r**4)+2*Q2**19*(166081+11225142*r**2
            +11373357*r**4+513816*r**6)-4*Q2**18*(-500241+29074056*r**2+68728671*r**4
            +32028984*r**6+949307*r**8)+2*Q2**17*(-5615008+146448803*r**2+643844310*r**4
            +678188618*r**6+190108966*r**8+4125635*r**10)-4*Q2**16*(-3973359+74266084*r**2
            +679947566*r**4+1166558084*r**6+813909434*r**8+142704876*r**10+2477669*r**12)
            +2*Q2**15*(11775989-110636094*r**2+664396723*r**4+951187330*r**6+1749762163*r**8
            +1506240170*r**10+59782461*r**12+1513106*r**14)+2*Q2**14*(-55171233+425567014*r**2
            +2711053775*r**4+12958211190*r**6+21658743637*r**8+9739250642*r**10+1595151489*r**12
            +544099234*r**14+4360652*r**16)-2*Q2**13*(-64251489+244237704*r**2+5532279198*r**4
            +32275758294*r**6+86358159924*r**8+82047028890*r**10+28156092330*r**12
            +5697080754*r**14+880213701*r**16+5410358*r**18)+Q2**12*(32404320-689625728*r**2
            +6029515422*r**4+40568180232*r**6+219931592136*r**8+336188308392*r**10
            +225093896652*r**12+50076188856*r**14+10603021032*r**16+512577624*r**18
            -2528058*r**20)+2*Q2**11*(-115033373+399321098*r**2+2210312267*r**4+31587831686*r**6
            +31061512558*r**8+34431825288*r**10-6092006098*r**12-19785079664*r**14
            +9780730671*r**16+148443454*r**18+792861927*r**20+7594938*r**22)-2*Q2**10*(
            -93871869-301375562*r**2+3319994183*r**4+57918106482*r**6+221297158884*r**8
            +548728816820*r**10+745806838042*r**12+376195573260*r**14+111602538743*r**16
            +34133271638*r**18+4291667039*r**20+952597698*r**22+5111938*r**24)+2*Q2**9*(35349973
            -660880954*r**2+1254992504*r**4+13592393802*r**6+188409941901*r**8+595751483472*r**10
            +1400248406784*r**12+1275737968812*r**14+420777203271*r**16+112212418766*r**18
            +17786796808*r**20+3853561546*r**22+74351511*r**24-2393252*r**26)+2*Q2**8*(
            -108253049+118145044*r**2-1124814378*r**4+38306461532*r**6+18754759225*r**8
            +173212341792*r**10-500295246472*r**12-989355332216*r**14-692859876855*r**16
            -17789612956*r**18-28297635746*r**20+5682638556*r**22-1939300841*r**24
            +618754856*r**26+5264308*r**28)-2*Q2**7*(-54052263-448577294*r**2-1520978173*r**4
            +28731627586*r**6+112888864569*r**8+706645991774*r**10+929096410339*r**12
            +1001121957078*r**14+418146169379*r**16+16355794270*r**18+193861735857*r**20
            +135446846*r**22+5076541451*r**24-433805614*r**26+430061097*r**28+2026538*r**30)
            +2*Q2**6*(26086756-338891526*r**2+444452537*r**4-9932112558*r**6+69997798893*r**8
            +300770174994*r**10+915081187041*r**12+1489407656154*r**14+1687384602261*r**16
            +547655973486*r**18-13794033501*r**20+77006155926*r**22+1117169999*r**24
            -1921129978*r**26+1260136771*r**28-59789634*r**30-1335221*r**32)+2*Q2**5*(
            -41065221-30301762*r**2-2100878558*r**4+19379453494*r**6-37887938426*r**8
            +262142876010*r**10-288763677838*r**12+154465718158*r**14-604942387500*r**16
            -650739335506*r**18-222381517226*r**20-50316474078*r**22-61839285638*r**24
            -28061823154*r**26-913977578*r**28-2037242598*r**30+205606193*r**32+1540828*r**34)
            +Q2**4*(27030983+281559096*r**2+2329355103*r**4-8747645416*r**6+40739366524*r**8
            -535300669288*r**10+403110641524*r**12-1808455964520*r**14-1432781657230*r**16
            +955373106632*r**18+122065779642*r**20+994249714184*r**22+578840269196*r**24
            +246283782728*r**26+66968062644*r**28+8072207688*r**30+1963310271*r**32
            -157780704*r**34-693057*r**36)-4*Q2**3*(-2393664+28989864*r**2-155289084*r**4
            +2427128335*r**6-6125332244*r**8-451871134*r**10+21267853224*r**12-132493087338*r**14
            -254737602684*r**16+394463082666*r**18-13968192200*r**20+181366227780*r**22
            +40316224628*r**24+110206678118*r**26+21963685960*r**28+2782514298*r**30
            +999139932*r**32-155130906*r**34+9843156*r**36+123293*r**38)+2*(-1
            +r**2)**2*(-190141-1529518*r**2-33679497*r**4+9807032*r**6-1746945342*r**8
            +6647955444*r**10-39233655776*r**12-41613662324*r**14+844981789254*r**16
            -3200025798184*r**18+4808873592694*r**20-3353175039444*r**22+1172325161764*r**24
            -289357902804*r**26+26173110744*r**28-10693057756*r**30-1369313137*r**32
            -113407818*r**34-30256357*r**36+935532*r**38+5634*r**40)+2*Q2**2*(-5256619
            -1096858*r**2-569910819*r**4+3574594202*r**6-23996575640*r**8+106537748288*r**10
            -268025666192*r**12+237211890976*r**14+208084980498*r**16-175106578276*r**18
            +1047462497634*r**20-2262696717692*r**22+2130463827880*r**24-852248583952*r**26
            +143057076472*r**28-47330360656*r**30-10657058383*r**32-95706162*r**34
            -538547623*r**36+25490194*r**38+192728*r**40)-2*Q2*(-1647815-6079975*r**2
            -224696078*r**4+905703860*r**6-11449882667*r**8+57888034035*r**10-231966314240*r**12
            +211288930984*r**14+1134859600730*r**16-3216199321134*r**18-86321246700*r**20
            +6808527240080*r**22-7559948172934*r**24+3468174980510*r**26-972610147056*r**28
            +129588947480*r**30-38974080115*r**32-6566340347*r**34-280835350*r**36
            -221131268*r**38+8084625*r**40+53375*r**42))+248832000*logq2**5*r**20*(420*Q2**9*r**2
            -60*Q2**8*(8+51*r**2+37*r**4)+40*Q2**7*(96+281*r**2+328*r**4+45*r**6)
            +4*Q2**6*(-3360-6676*r**2-8487*r**4-1690*r**6+2877*r**8)+Q2**5*(24675
            +44164*r**2+44222*r**4+19828*r**6-50433*r**8-32928*r**10)+Q2**4*(-21315
            -47095*r**2-28212*r**4-23434*r**6+49925*r**8+104449*r**10+27090*r**12)
            +2*Q2**3*(-105+17105*r**2+3224*r**4+7017*r**6-23847*r**8-36323*r**10
            -32108*r**12+9345*r**14)-(-1+r**2)**2*(-2985+7299*r**2+5207*r**4-35113*r**6
            +43049*r**8+48649*r**10-24515*r**12+9277*r**14+9612*r**16)-2*Q2**2*(
            -8085+16460*r**2+1611*r**4-17045*r**6+6832*r**8+7890*r**10-25141*r**12
            +1203*r**14+26355*r**16)+Q2*(-12225+33014*r**2-4784*r**4-97176*r**6
            +51266*r**8+200968*r**10+101904*r**12-68368*r**14-641*r**16+37962*r**18))*sqrtq2
            -138240*logq2**3*r**12*(-126720*Q2**17*r**2+12*Q2**16*(-64+148560*r**2+138255*r**4)
            -4*Q2**15*(-9402+2776908*r**2+5100805*r**4+2401605*r**6)+8*Q2**14*(-42285
            +4951722*r**2+13565140*r**4+12643185*r**6+4002255*r**8)-Q2**13*(-1363635
            +86687004*r**2+319732814*r**4+437695680*r**6+280496045*r**8+66584340*r**10)
            +Q2**12*(-2802555+111962901*r**2+542290348*r**4+945654486*r**6+904945125*r**8
            +465384085*r**10+86140890*r**12)-2*Q2**11*(-1092252+29218287*r**2+219760557*r**4
            +405974987*r**6+486509332*r**8+451858283*r**10+223847415*r**12+30432915*r**14)
            +2*Q2**10*(1385538-29861319*r**2-68113660*r**4-387181820*r**6-737442725*r**8
            -445060159*r**10+52256838*r**12+99728830*r**14+2599965*r**16)+Q2**9*(
            -8500965+136135098*r**2+715457180*r**4+2772737440*r**6+5644372370*r**8
            +6002352080*r**10+3224455148*r**12+684729560*r**14+22868715*r**16+33361470*r**18)
            -Q2**8*(-7365105+96724917*r**2+686589312*r**4+2903638200*r**6+6505159010*r**8
            +8811795550*r**10+7201188432*r**12+3278624872*r**14+814095615*r**16+77257485*r**18
            +41483520*r**20)+4*Q2**7*(269940-682623*r**2+38800926*r**4+259603572*r**6
            +498137280*r**8+958477090*r**10+1311563782*r**12+1116769876*r**14+548184932*r**16
            +250108425*r**18+28823820*r**20+10983420*r**22)-4*Q2**6*(1881726-14621547*r**2
            -58707772*r**4-128619222*r**6-667206707*r**8-751627606*r**10-190050502*r**12
            +697344318*r**14+912065228*r**16+595598293*r**18+375456966*r**20+49347500*r**22
            +10823805*r**24)+Q2**5*(5889849-43983528*r**2-211838870*r**4-668278800*r**6
            -2924363345*r**8-3824050776*r**10-2187239636*r**12+1501306400*r**14+4609291255*r**16
            +3553121880*r**18+2570294762*r**20+1192988944*r**22+184693665*r**24+22120200*r**26)
            +(-1+r**2)**4*(52467-214959*r**2-513578*r**4+24544170*r**6-126468135*r**8
            +333630851*r**10+143760988*r**12-186943764*r**14-290848075*r**16+152935495*r**18
            +307080582*r**20-41295254*r**22+44394367*r**24+2264805*r**26+500040*r**28)
            +Q2**4*(-638505+6880251*r**2+44455100*r**4+448931430*r**6+397599665*r**8
            +1914277805*r**10+7020098*r**12-2100059420*r**14-3651324935*r**16-3341122955*r**18
            +201357400*r**20-1839597674*r**22+74905695*r**24-69432445*r**26+8060490*r**28)
            -Q2*(-1+r**2)**2*(435207-2268252*r**2-4712327*r**4+151262062*r**6-772834785*r**8
            +1742771556*r**10+291253569*r**12-141006026*r**14+67038701*r**16-528832500*r**18
            +306950227*r**20+1870194058*r**22-383056147*r**24+289189612*r**26+12642035*r**28
            +4013010*r**30)-2*Q2**3*(960120-5602773*r**2-11544763*r**4+233427435*r**6
            -847334440*r**8+1409551585*r**10-428587659*r**12-648258219*r**14-404094200*r**16
            -558440195*r**18-617977625*r**20+2218890357*r**22-815882968*r**24+459359415*r**26
            +5504735*r**28+10029195*r**30)+2*Q2**2*(709710-4630407*r**2-5798076*r**4
            +192173588*r**6-1015157385*r**8+2272016695*r**10-1191508706*r**12+317702*r**14
            +757734969*r**16+1316552935*r**18-15793960*r**20-1505521512*r**22+2545158449*r**24
            -831291607*r**26+372854150*r**28+8703630*r**30+6519825*r**32))*sqrtq2
            +96*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(41196*Q2**21*r**2
            -12*Q2**20*(-1480+57537*r**2+57537*r**4)+120*Q2**19*(-1538+36356*r**2
            +93839*r**4+39453*r**6)-4*Q2**18*(-197020+3429590*r**2+17022939*r**4
            +17758976*r**6+4374255*r**8)+Q2**17*(-1611705+21307800*r**2+196865022*r**4
            +326801204*r**6+226422315*r**8+36585180*r**10)-Q2**16*(-825285+8328699*r**2
            +243045288*r**4+271652546*r**6+393855835*r**8+353632323*r**10+35295714*r**12)
            -2*Q2**15*(-1691530+8632397*r**2+47034651*r**4+1203624515*r**6+2322591946*r**8
            +888276297*r**10-27952759*r**12+9161007*r**14)+6*Q2**14*(-1276570+306365*r**2
            +107405990*r**4+1468114024*r**6+4369816345*r**8+4133678157*r**10+1278770820*r**12
            +132717130*r**14+15579195*r**16)-6*Q2**13*(-694360-9541905*r**2+108142642*r**4
            +1891948324*r**6+8996254464*r**8+13405058556*r**10+8681955634*r**12+1980123832*r**14
            +229100148*r**16+14985465*r**18)+Q2**12*(7231640-45106750*r**2+147589494*r**4
            -510307928*r**6+31590484676*r**8+63259793076*r**10+72748902136*r**12
            +42509817224*r**14+5135819268*r**16+692981210*r**18-25514190*r**20)+2*Q2**11*(
            -6692790-43045977*r**2-138804633*r**4+9040529951*r**6+31325757150*r**8
            +94929285204*r**10+132949671332*r**12+57641585244*r**14+10260629376*r**16
            +4505870285*r**18+355067277*r**20+63349533*r**22)-2*Q2**10*(-2475330
            -80127723*r**2-427329540*r**4+8482224308*r**6+62173944523*r**8+237632761038*r**10
            +504894152264*r**12+446597123224*r**14+157735353072*r**16+33855112253*r**18
            +6979631884*r**20+627808500*r**22+42879447*r**24)+2*Q2**9*(4015635-17649645*r**2
            -80633610*r**4-1824953034*r**6+29923651135*r**8+140347883043*r**10+544580901140*r**12
            +778778866780*r**14+486715657641*r**16+108009326625*r**18+22472141078*r**20
            +2820445950*r**22+299041125*r**24-17911335*r**26)+2*Q2**8*(-5095155-64812390*r**2
            -726733239*r**4+7729275950*r**6+19926490149*r**8+145558773576*r**10+76967287949*r**12
            -135228948996*r**14-279692483433*r**16-138804933646*r**18+24195819291*r**20
            -3024656826*r**22+968352551*r**24+82666044*r**26+42145695*r**28)-2*Q2**7*(
            -1141230-61180425*r**2-771079923*r**4+3106696853*r**6+26175882046*r**8
            +242266876761*r**10+592831687421*r**12+912351757243*r**14+868180549830*r**16
            +280334574881*r**18+70627874791*r**20+55988355171*r**22-628241398*r**24
            +1023832399*r**26+176923695*r**28+16904205*r**30)+2*Q2**6*(1923590-152827*r**2
            +31246698*r**4-2840959408*r**6+8847417085*r**8+65995782819*r**10+378992755352*r**12
            +759043973518*r**14+1225994189751*r**16+848962846475*r**18+178485168418*r**20
            +17273411172*r**22+24761709059*r**24+567468397*r**26+703397820*r**28
            +117341918*r**30-10364637*r**32)+2*Q2**5*(-1687020-30111117*r**2-526241814*r**4
            +3031195536*r**6-5399320116*r**8+87944018802*r**10-73099714*r**12+85799140020*r**14
            -12540830160*r**16-548859502468*r**18-205049783706*r**20-196227938040*r**22
            -67969411444*r**24-38817508986*r**26-8582403726*r**28-1238044236*r**30
            -53687964*r**32+12470553*r**34)+2*Q2**4*(309480+16643565*r**2+303501675*r**4
            -468666468*r**6+6072438630*r**8-72665356764*r**10-49742477450*r**12-222911612740*r**14
            -809622560514*r**16+56447378230*r**18+316674193628*r**20+117897252180*r**22
            +397604133970*r**24+157953921812*r**26+45568320090*r**28+9012406356*r**30
            +894533730*r**32+1524645*r**34-2924055*r**36)-2*Q2**3*(-289910-474605*r**2
            -31915293*r**4+714305651*r**6-771979178*r**8-2462298942*r**10-13502542778*r**12
            -21154868422*r**14-399967899894*r**16+182040594376*r**18+323036215364*r**20
            +30667931616*r**22+367504684738*r**24+62106880670*r**26+100384759962*r**28
            +4651250438*r**30+1576907092*r**32-89419323*r**34-26686727*r**36+1965165*r**38)
            +(-1+r**2)**2*(-11815-403479*r**2-12116849*r**4+7431355*r**6-1021262296*r**8
            +3713843244*r**10-19357856828*r**12-79702366908*r**14+643446898310*r**16
            -1875974607162*r**18+1346326900378*r**20+947285878418*r**22-1500221460412*r**24
            +547694052940*r**26-160473203388*r**28-1314878428*r**30-6495045111*r**32
            -596417831*r**34-67757105*r**36-1871029*r**38+93996*r**40)+2*Q2**2*(
            -209010-3774075*r**2-100503306*r**4+495159340*r**6-4934409087*r**8+23742388308*r**10
            -47797118772*r**12-65442601284*r**14+435289265808*r**16-512251145506*r**18
            +201626183424*r**20+843810468444*r**22-1273773051514*r**24+942040248564*r**26
            -363615254652*r**28+28925356068*r**30-22402113222*r**32-2276793771*r**34
            -420155462*r**36-21995880*r**38+1575585*r**40)+Q2*(113115+2926986*r**2
            +81610158*r**4-276256040*r**6+5678145215*r**8-28132582398*r**10+96147156696*r**12
            +166092974016*r**14-1702057063770*r**16+4055392372820*r**18-2870556455516*r**20
            +1790627790576*r**22-4370925867706*r**24+5072448079060*r**26-2208592193160*r**28
            +617619359616*r**30-27933564609*r**32+28296357282*r**34+2726470750*r**36
            +402827000*r**38+15322683*r**40-882774*r**42))*sqrtq2)*math.log(r))/(-156764160000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-16329600000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-113400000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-52500*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6+1814400000*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            +3780000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*sqrtq2+78382080000*logq2**5*r**22*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((217728000*logq2**5*r**18*(
            -200+145*r**2+1012*r**4+882*r**6+540*r**8+81*r**10)-17280*logq2**3*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(-22488+30273*r**2+24780*Q2**10*r**2
            +213966*r**4-6059043*r**6+20618248*r**8-84888030*r**10-155288556*r**12
            -91460606*r**14-8633472*r**16+14613837*r**18+649678*r**20+266193*r**22
            -240*Q2**9*(16+1091*r**2+1139*r**4)+12*Q2**8*(2996+97727*r**2+205026*r**4
            +103719*r**6)-8*Q2**7*(3342+346131*r**2+1096141*r**4+1126495*r**6+341583*r**8)
            +Q2**6*(-99624+2681577*r**2+13708292*r**4+23117986*r**6+14573036*r**8
            +2099769*r**10)+Q2**5*(74928+383862*r**2-5702834*r**4-21936812*r**6
            -24011804*r**8-7592338*r**10+2037462*r**12)+Q2**4*(165480-2521005*r**2
            -7996898*r**4+2608769*r**6+10198692*r**8+3975713*r**10-5285810*r**12
            -4563405*r**14)+4*Q2**3*(-43428+285039*r**2+2369635*r**4+6526057*r**6
            +9467869*r**8+10220157*r**10+5774721*r**12+2355147*r**14+454083*r**16)
            +Q2**2*(-33624+646563*r**2-433480*r**4-31103444*r**6-61896968*r**8-93890510*r**10
            -70831032*r**12-19894164*r**14-5885600*r**16+1322499*r**18)-2*Q2*(-41832
            +264021*r**2+1241905*r**4-4120864*r**6+17467592*r**8+20567770*r**10
            +2496234*r**12+4998520*r**14+8632504*r**16-466967*r**18+621117*r**20))
            +12*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(-2712+287439*r**2
            -238104*Q2**16*r**2+4900184*r**4+10162132*r**6+497223864*r**8-388793812*r**10
            +4903653544*r**12+41543999724*r**14-90886900584*r**16+195164676522*r**18
            +131529237480*r**20-58690729940*r**22+3872425160*r**24-4173200148*r**26
            -165013736*r**28-48408556*r**30-2352768*r**32+36207*r**34+16*Q2**15*(
            -4352+151701*r**2+138645*r**4)-16*Q2**14*(-25686+517545*r**2+1283702*r**4
            +466173*r**6)+32*Q2**13*(-25797+332281*r**2+2114081*r**4+2060996*r**6
            +306981*r**8)+Q2**12*(202856+1708351*r**2-85903156*r**4-156555506*r**6
            -87507260*r**8+2814687*r**10)-4*Q2**11*(-422464+3694859*r**2+6484463*r**4
            +45325634*r**6+33362354*r**8+5843407*r**10+5880699*r**12)+2*Q2**10*(
            -1174024+549571*r**2+85334662*r**4+639309361*r**6+1198799972*r**8+551615169*r**10
            +110882710*r**12+11183571*r**14)+4*Q2**9*(-6088+5556545*r**2-22252209*r**4
            -410919631*r**6-1613997185*r**8-1575770833*r**10-359844895*r**12-55137889*r**14
            +1688409*r**16)-Q2**8*(-2538008+13910839*r**2+102818064*r**4+54873344*r**6
            -5713077616*r**8-11571455758*r**10-6174435776*r**12+313981504*r**14+61814104*r**16
            +27276759*r**18)+8*Q2**7*(-224864-1718169*r**2+3960199*r**4+192721124*r**6
            +431493580*r**8+688585378*r**10+284038266*r**12+335685764*r**14+286466684*r**16
            +30896815*r**18+1861047*r**20)+4*Q2**6*(-144128+4646441*r**2+34104206*r**4
            -184985647*r**6-2463547672*r**8-9829372794*r**10-15030106684*r**12-7774343194*r**14
            -3006567672*r**16-418407567*r**18-29882146*r**20+1917801*r**22)-8*Q2**5*(
            -157924+225359*r**2+5353541*r**4+73320413*r**6-346886749*r**8-3215115490*r**10
            -11369824342*r**12-11127769486*r**14-2332004022*r**16-931884349*r**18
            +74252225*r**20+6546721*r**22+1523943*r**24)+Q2**4*(-379624-8053535*r**2
            -104498132*r**4+562203742*r**6+3902777140*r**8+15754990063*r**10-21767453480*r**12
            -101722298076*r**14-45148837984*r**16+24545508815*r**18+4260298556*r**20
            +1508646750*r**22+69858388*r**24+3208257*r**26)+4*Q2**3*(-53376+1149193*r**2
            +15158493*r**4+23832418*r**6-53435502*r**8-3272701413*r**10-8224444801*r**12
            -4639433876*r**14+7543003244*r**16-3659209521*r**18-6213214101*r**20
            -1402511342*r**22-142526622*r**24-5563667*r**26+558873*r**28)+2*Q2**2*(77528
            +164963*r**2+10249582*r**4-102552843*r**6-539164740*r**8+329288495*r**10
            +16689289154*r**12+61834524761*r**14+75216986816*r**16+30390588585*r**18
            +31671019986*r**20-269147777*r**22+361278572*r**24-151529083*r**26-2091330*r**28
            -755469*r**30)+4*Q2*(-5336-270731*r**2-5784093*r**4+5361281*r**6-173740249*r**8
            +949921405*r**10+3432897851*r**12+4839043361*r**14+8277673463*r**16+4466252503*r**18
            +21138736753*r**20-8336448469*r**22+2365991757*r**24+166280631*r**26
            +67419121*r**28+1825203*r**30+45549*r**32))-518400*logq2**4*r**14*(5664
            -16995*r**2+630*Q2**7*r**2+419633*r**4-943589*r**6-2284593*r**8-1779977*r**10
            -687613*r**12+46329*r**14+75141*r**16-10*Q2**6*(128+525*r**2+909*r**4)
            +10*Q2**5*(1104+1797*r**2+4936*r**4+4005*r**6)-2*Q2**4*(22368+24197*r**2
            +52141*r**4+93661*r**6+47637*r**8)+Q2**3*(42624+152665*r**2+312044*r**4
            +508466*r**6+476524*r**8+134361*r**10)-Q2**2*(-16864+146753*r**2+325069*r**4
            +597974*r**6+769814*r**8+429213*r**10+26289*r**12)-Q2*(30176-111367*r**2
            +155052*r**4+414267*r**6+187464*r**8-20629*r**10+86508*r**12+119529*r**14))*sqrtq2
            +(-50*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(-291+525*Q2**7-20147*r**2-5111*r**4
            +211609*r**6+130409*r**8-10375*r**10-1219*r**12+45*r**14-375*Q2**6*(1
            +r**2)-5*Q2**5*(75-172*r**2+75*r**4)+Q2**4*(-291+869*r**2-139*r**4
            +45*r**6)+Q2**3*(-291+128*r**2+2840*r**4-544*r**6+45*r**8)+Q2**2*(
            -291-2315*r**2+9816*r**4+3768*r**6-859*r**8+45*r**10)+Q2*(-291-7580*r**2
            +15313*r**4+43104*r**6+1313*r**8-1084*r**10+45*r**12))+21*(Q2-(-1
            +r)**2)**2*(Q2-(1+r)**2)**2*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**2*(1008*Q2**11-2832*Q2**10*(1+r**2)+Q2**9*(-195+7066*r**2-195*r**4)
            +Q2**8*(5613-12089*r**2-15545*r**4+6765*r**6)-6*Q2**7*(410-2077*r**2
            -11198*r**4-2557*r**6+650*r**8)-2*Q2**6*(1050-6209*r**2+75495*r**4
            +79791*r**6-9821*r**8+2358*r**10)+2*Q2**5*(195-3643*r**2+88487*r**4
            +266202*r**6+106271*r**8-15163*r**10+1947*r**12)+6*Q2**4*(-35-1656*r**2
            +14696*r**4-39677*r**6-60729*r**8+19260*r**10-436*r**12+145*r**14)
            -2*Q2**3*(-306+4243*r**2+97806*r**4+49353*r**6-142976*r**8-143031*r**10
            +199758*r**12-365*r**14+270*r**16)-2*Q2**2*(-270+841*r**2+67489*r**4
            +161415*r**6+277873*r**8+567001*r**10+232599*r**12-26831*r**14-4139*r**16
            +150*r**18)-3*Q2*(41-1564*r**2+8801*r**4+157264*r**6-22330*r**8+217752*r**10
            -16282*r**12+244944*r**14-50639*r**16-2396*r**18+89*r**20)+3*(-81
            +1891*r**2+12595*r**4-110353*r**6+41402*r**8-505662*r**10-188014*r**12
            -501622*r**14+190551*r**16-9829*r**18-2309*r**20+71*r**22))-20*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(67455*Q2**13
            -172299*Q2**12*(1+r**2)+Q2**11*(-25797+449416*r**2-25797*r**4)+6*Q2**10*(39318
            -72643*r**2-113647*r**4+52986*r**6)-2*Q2**9*(-33096+273899*r**2+1321525*r**4
            +179987*r**6+13860*r**8)+2*Q2**8*(-72540+683243*r**2+2254266*r**4+1765422*r**6
            +959741*r**8-140670*r**10)+Q2**7*(-92214+1377002*r**2+6007838*r**4-4311896*r**6
            +7864034*r**8+325946*r**10-10242*r**12)+2*Q2**6*(-5010-549097*r**2+2386339*r**4
            +11084794*r**6+15974830*r**8+1272439*r**10-967309*r**12+72522*r**14)
            +Q2**5*(32523-1627274*r**2-4585140*r**4+11724390*r**6+38866462*r**8
            +21012798*r**10-10479756*r**12-806546*r**14+42183*r**16)-Q2**4*(-52593
            +170437*r**2+13400182*r**4+6991814*r**6-85316320*r**8-121678096*r**10
            +24919046*r**12+11003830*r**14-716819*r**16+33255*r**18)-Q2**3*(-17835
            -126214*r**2+12419569*r**4+76695436*r**6+102370382*r**8+16662372*r**10
            +177402758*r**12+67053196*r**14-5330531*r**16-807238*r**18+27465*r**20)
            -12*Q2**2*(1246-21931*r**2-78365*r**4+6984169*r**6+30876111*r**8+41293406*r**10
            +52004442*r**12+33637163*r**14+3645949*r**16-426473*r**18-5779*r**20
            +182*r**22)+2*Q2*(-5349+172084*r**2+1217611*r**4-25400926*r**6-160379833*r**8
            -96607978*r**10-115599310*r**12-373870930*r**14-74572099*r**16+11875358*r**18
            +26347*r**20-121064*r**22+2889*r**24)+2*(-723+62701*r**2-518515*r**4
            -12782349*r**6-85988645*r**8-201910037*r**10-303792548*r**12-806410364*r**14
            -311255519*r**16+42605365*r**18+13434855*r**20+73817*r**22-45401*r**24
            +963*r**26)))*sqrtq2+288*logq2**2*r**6*(-50*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(
            -148-61251*r**2+1260*Q2**7*r**2-358607*r**4-1170425*r**6-3836109*r**8
            -4333081*r**10-1749213*r**12-66867*r**14+49221*r**16-60*Q2**6*(16+147*r**2
            +195*r**4)+15*Q2**5*(216+1371*r**2+3238*r**4+1803*r**6)+12*Q2**4*(396
            +1801*r**2+4097*r**4+3821*r**6+2553*r**8)-4*Q2**3*(2557+1264*r**2-18764*r**4
            -38619*r**6-17817*r**8+4626*r**10)-Q2**2*(2108+60055*r**2+280711*r**4
            +584270*r**6+581802*r**8+281679*r**10+62919*r**12)-Q2*(-5452+72755*r**2
            +183580*r**4+408317*r**6+546668*r**8+473529*r**10+226644*r**12+15039*r**14))
            -3*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(-13272+881781*r**2+63990*Q2**13*r**2
            -10548805*r**4-31598660*r**6+97933356*r**8-2605231*r**10+4202198063*r**12
            +6539776160*r**14+6471840920*r**16+3736225463*r**18+774956153*r**20-340764444*r**22
            +12814420*r**24+13944515*r**26-688419*r**28-6*Q2**12*(-2688+108893*r**2
            +100829*r**4)+2*Q2**11*(-76048+1375085*r**2+2826532*r**4+1222989*r**6)
            -12*Q2**10*(-24304+478812*r**2+1840205*r**4+1801545*r**6+451192*r**8)
            +5*Q2**9*(26488+854481*r**2+6975496*r**4+11157458*r**6+7078480*r**8
            +842721*r**10)+5*Q2**8*(-142968+1045437*r**2+145637*r**4+1768010*r**6
            +1213586*r**8-543307*r**10+1369533*r**12)-2*Q2**7*(-89712+3487392*r**2
            +22478831*r**4+110354420*r**6+182383870*r**8+97388768*r**10+23041727*r**12
            +7314396*r**14)+2*Q2**6*(317296-3533430*r**2+8275511*r**4+167408627*r**6
            +515133400*r**8+512517556*r**10+144151375*r**12+17008691*r**14+977622*r**16)
            +2*Q2**5*(-116088+3451794*r**2-945355*r**4-104352840*r**6-638211441*r**8
            -1140119328*r**10-701935561*r**12-72128080*r**14-4936075*r**16+6118374*r**18)
            -10*Q2**4*(32424-757392*r**2+518863*r**4+18308167*r**6+8911397*r**8
            -103702495*r**10-127098871*r**12-10942891*r**14+32475439*r**16+657355*r**18
            +521508*r**20)-10*Q2**3*(-10304+433245*r**2-2616259*r**4-25473427*r**6
            -83132444*r**8-60930070*r**10+41270254*r**12+13947074*r**14-85722524*r**16
            -46746647*r**18-4196131*r**20+509313*r**22)+2*Q2**2*(47824-1873454*r**2
            +5997343*r**4+73963855*r**6+189163390*r**8+372976052*r**10+985645078*r**12
            +1194755854*r**14+815599100*r**16-16958910*r**18+19304979*r**20-11627669*r**22
            +1352958*r**24)+Q2*(-16296+847065*r**2-10693786*r**4+29608838*r**6
            +236995990*r**8+1511846047*r**10+1733135980*r**12+3084499732*r**14+2848768084*r**16
            +979760935*r**18+522388174*r**20-185944570*r**22-20195746*r**24+1175553*r**26)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(62705664000*logq2**6*r**24
            +6531840000*logq2**4*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+45360000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4+21000*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6-31352832000*logq2**5*r**20*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2-725760000*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2-1512000*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*sqrtq2)+((18144000*logq2**4*r**14*(-132+235*r**2+753*r**4+537*r**6
            +87*r**8)-1440*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(-2086
            -70565*r**2-22320*Q2**9*r**2-228515*r**4-395120*r**6+2803540*r**8-53507918*r**10
            -56937050*r**12-12004400*r**14+7806130*r**16+621395*r**18+26589*r**20
            +56*Q2**8*(44+3477*r**2+3609*r**4)-16*Q2**7*(-798+42243*r**2+86828*r**4
            +40647*r**6)+Q2**6*(-42238+751596*r**2+2975344*r**4+3051956*r**6+655662*r**8)
            +Q2**5*(2716+211665*r**2-1687476*r**4-3981786*r**6-2189280*r**8+466641*r**10)
            +Q2**4*(67830-749225*r**2-1069561*r**4+1795052*r**6+1979494*r**8-199355*r**10
            -1213275*r**12)+2*Q2**3*(-19292+23509*r**2+911935*r**4+5126263*r**6
            +7925438*r**8+4365695*r**10+994279*r**12+196413*r**14)+2*Q2**2*(-10969
            +174669*r**2-311014*r**4-6813186*r**6-16090455*r**8-16604561*r**10-5347814*r**12
            -1143906*r**14+200916*r**16)-Q2*(-19068+36331*r**2+441290*r**4+4038384*r**6
            +13612558*r**8+5649818*r**10+4320534*r**12+9165520*r**14-209074*r**16
            +259707*r**18))+(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(11493+53280*Q2**15
            +677899*r**2-4092243*r**4+71681827*r**6+28019969*r**8+810332719*r**10
            +3810429257*r**12-7604966329*r**14+38506896911*r**16-7645588543*r**18
            -433638617*r**20-737295031*r**22+57191947*r**24-6330363*r**26-214301*r**28
            +3405*r**30-192240*Q2**14*(1+r**2)+64*Q2**13*(1065+10838*r**2+1065*r**4)
            +3*Q2**12*(89061-147673*r**2-342025*r**4+153845*r**6)-2*Q2**11*(-176787
            +1185332*r**2+6860846*r**4+481268*r**6+175245*r**8)+Q2**10*(-1236672
            +4813524*r**2+71651732*r**4+64463012*r**6+6192444*r**8-626280*r**10)
            +10*Q2**9*(14277+345104*r**2-9758229*r**4-28292464*r**6-8238237*r**8
            -484336*r**10+60573*r**12)+3*Q2**8*(376805-3634813*r**2+1655105*r**4
            +140719415*r**6+160151215*r**8-6288215*r**10-2461013*r**12+166685*r**14)
            -4*Q2**7*(42609+2275068*r**2-21677550*r**4-17881260*r**6-42035590*r**8
            +22639884*r**10-35113422*r**12-2410860*r**14+144705*r**16)-24*Q2**6*(27277
            -1040372*r**2+3305864*r**4+31951452*r**6+120300605*r**8+96825117*r**10
            +33620308*r**12+5731304*r**14-108798*r**16+7355*r**18)+4*Q2**5*(9681
            -293112*r**2-3555441*r**4+49093584*r**6+467575768*r**8+1438011256*r**10
            +246660808*r**12+156652224*r**14-280281*r**16-1364592*r**18+61305*r**20)
            +5*Q2**4*(42009-3659125*r**2+17643423*r**4+70601973*r**6+298399090*r**8
            -759105514*r**10-1372437898*r**12+483852178*r**14+64573653*r**16+25616319*r**18
            -140725*r**20+9177*r**22)-2*Q2**3*(-27375-3698316*r**2+14502150*r**4
            -130008540*r**6+296084335*r**8+957075000*r**10+924158452*r**12-1067850600*r**14
            +864077935*r**16+124920660*r**18+41470470*r**20-502716*r**22+22545*r**24)
            -4*Q2**2*(12918-843679*r**2+7171025*r**4+28044125*r**6-84593165*r**8
            -1653373586*r**10-4753153082*r**12-3026503010*r**14-2268378560*r**16
            -43078535*r**18+16061993*r**20+5739461*r**22-146665*r**24+3960*r**26)
            +2*Q2*(-12363-1448832*r**2+8030339*r**4-95388208*r**6+391417425*r**8
            +1384430896*r**10+3207384679*r**12-3532053408*r**14+8807398591*r**16
            -1646854880*r**18+442591017*r**20-31105072*r**22+16623419*r**24+25392*r**26
            +1005*r**28))-86400*logq2**3*r**10*(-1442+7134*r**2-720*Q2**6*r**2+84890*r**4
            -404018*r**6-657838*r**8-299046*r**10+918*r**12+26202*r**14+80*Q2**5*(7
            +33*r**2+54*r**4)-16*Q2**4*(322+409*r**2+1314*r**4+1053*r**6)+Q2**3*(3878
            +38179*r**2+101957*r**4+114753*r**6+40377*r**8)-2*Q2**2*(-2009+16516*r**2
            +57826*r**4+98304*r**6+67143*r**8+8844*r**10)-Q2*(1862-4943*r**2+69723*r**4
            +66722*r**6+14292*r**8+23901*r**10+35643*r**12))*sqrtq2+24*logq2*r**2*(100*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(56+4847*r**2+780*Q2**6*r**2+24230*r**4+51033*r**6
            +163068*r**8+114537*r**10+5526*r**12-3777*r**14-5*Q2**5*(28+411*r**2
            +495*r**4)-Q2**4*(224+1649*r**2+1962*r**4+2097*r**6)+Q2**3*(616+577*r**2
            -6791*r**4-7659*r**6+1893*r**8)+4*Q2**2*(14+1245*r**2+4527*r**4+7209*r**6
            +4695*r**8+1182*r**10)+2*Q2*(-182+3190*r**2+6033*r**4+3405*r**6+8655*r**8
            +8385*r**10+474*r**12))+(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(23808*Q2**12*r**2
            -12*Q2**11*(-3360+42563*r**2+32483*r**4)+4*Q2**10*(-27720+470487*r**2
            +1102006*r**4+415047*r**6)-5*Q2**9*(1890+406857*r**2+2111863*r**4+2060923*r**6
            +426987*r**8)-30*Q2**8*(-8085+42661*r**2-55994*r**4-23298*r**6-96153*r**8
            +50613*r**10)+12*Q2**7*(-7350+149757*r**2+1258450*r**4+7333545*r**6
            +6318315*r**8+1111810*r**10+430497*r**12)-12*Q2**6*(18270-278516*r**2
            +670179*r**4+14723320*r**6+30755120*r**8+12854780*r**10+1066639*r**12
            +104384*r**14)-6*Q2**5*(-14910+329181*r**2+28873*r**4-13459339*r**6
            -90294915*r**8-95341715*r**10-11347299*r**12-745927*r**14+679251*r**16)
            +20*Q2**4*(5985-196197*r**2+303507*r**4+5624700*r**6-4274967*r**8-29765534*r**10
            -11817351*r**12+8898972*r**14+259482*r**16+92763*r**18)+20*Q2**3*(-1890
            +72924*r**2-403011*r**4-3467559*r**6-15563289*r**8-23676893*r**10-4673465*r**12
            -9959265*r**14-10031277*r**16-855927*r**18+89892*r**20)-12*Q2**2*(3150
            -162459*r**2+763575*r**4+7227065*r**6-6404040*r**8-68509610*r**10-96500522*r**12
            -23194050*r**14-19905590*r**16+2547765*r**18-600765*r**20+77881*r**22)
            +Q2*(5670-275661*r**2+3437969*r**4-29547675*r**6-1129035*r**8+75360490*r**10
            -125457138*r**12-457701498*r**14+365526100*r**16-264631965*r**18+75671265*r**20
            +8409749*r**22-452271*r**24)+2*(2835-226731*r**2+2845132*r**4+10898194*r**6
            -29904705*r**8+14253035*r**10-607774648*r**12+508788636*r**14+123963497*r**16
            -391301845*r**18+22217580*r**20-2080046*r**22-2592443*r**24+127509*r**26)))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(
            -2612736000*logq2**5*r**20-181440000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -630000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+1088640000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+15120000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+10500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +((129600*logq2**3*r**10*(1+r**2)*(-8+33*r**2+9*r**4)+12*logq2*(-Q2
            +(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-1344*Q2**8*r**2+64*Q2**7*(-5+153*r**2
            +138*r**4)-Q2**6*(-600+12027*r**2+31390*r**4+10827*r**6)+Q2**5*(320
            -9226*r**2+22818*r**4+25378*r**6-9546*r**8)+4*Q2**3*r**2*(3101-8205*r**2
            -92396*r**4-79396*r**6-8105*r**8+441*r**10)+Q2**4*(-1000+11735*r**2
            +2000*r**4-42734*r**6-15720*r**8+19095*r**10)+Q2**2*(520-9357*r**2
            +36058*r**4+508161*r**6+918396*r**8+446561*r**10+68618*r**12-9837*r**14)
            -6*Q2*r**2*(823-4995*r**2-49853*r**4-10695*r**6+705*r**8-55813*r**10
            -2635*r**12+63*r**14)+3*(-40+987*r**2+5244*r**4+4136*r**6+24708*r**8
            +529770*r**10+274868*r**12-92664*r**14-13356*r**16+747*r**18))+(Q2
            -(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*(69+120*Q2**7+439*r**2+2841*r**4-6469*r**6+38051*r**8-9423*r**10
            -1073*r**12+45*r**14-225*Q2**6*(1+r**2)-8*Q2**5*(15-62*r**2+15*r**4)
            +3*Q2**4*(13+87*r**2-249*r**4+125*r**6)-4*Q2**3*(-126+445*r**2+2836*r**4
            +193*r**6)+Q2**2*(-171+1157*r**2+15410*r**4+13442*r**6+1853*r**8-195*r**10)
            +4*Q2*(-54+393*r**2+2366*r**4-3538*r**6+2756*r**8+117*r**10))*sqrtq2
            -720*logq2**2*r**6*(-16*Q2**4*(4+15*r**2+27*r**4)+Q2**3*(-64+2261*r**2
            +4458*r**4+2133*r**6)-Q2**2*(-176+1681*r**2+6451*r**4+6483*r**6+1377*r**8)
            -3*Q2*(-32+367*r**2+846*r**4+14*r**6+206*r**8+639*r**10)+3*(-48
            +187*r**2+473*r**4-6852*r**6-6052*r**8-479*r**10+531*r**12))*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(2073600*logq2**4*r**16
            +86400*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+100*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-691200*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-4800*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((720*logq2**2*r**6*(-4+21*r**2+9*r**4)+(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(21
            +120*Q2**7+431*r**2+2289*r**4-3941*r**6+26419*r**8-5607*r**10-937*r**12
            +45*r**14-225*Q2**6*(1+r**2)-8*Q2**5*(15-58*r**2+15*r**4)-4*Q2**3*(
            -84+275*r**2+1754*r**4+107*r**6)+3*Q2**4*(37-17*r**2-281*r**4+125*r**6)
            +Q2**2*(-99+1093*r**2+10210*r**4+8818*r**6+1717*r**8-195*r**10)+4*Q2*(
            -36+327*r**2+1534*r**4-2282*r**6+1954*r**8+63*r**10))-24*logq2*r**2*(
            -10-11*r**2-36*Q2**4*r**2+14*r**4-1326*r**6-416*r**8+189*r**10+2*Q2**3*(
            -5+132*r**2+117*r**4)-Q2**2*(-10+191*r**2+524*r**4+171*r**6)-2*Q2*(
            -5+93*r**2+2*r**4-68*r**6+108*r**8))*sqrtq2)*nlo.X1Q2(3,'SM',Q2,r))/(
            -25920*logq2**3*r**12-540*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+6480*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+15*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((12*logq2*r**4+(3-5*Q2**3-5*r**2
            +19*r**4-5*r**6+5*Q2**2*(1+r**2)+Q2*(5-8*r**2+5*r**4))*sqrtq2)*nlo.X1Q2(4,'SM',Q2,r))/(288*logq2**2*r**8
            +2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-48*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((272160000*logq2**4*r**16*(9
            +28*r**2+34*r**4+28*r**6+9*r**8)+7200*logq2**2*(-Q2+(-1+r)**2)*r**8*(
            -Q2+(1+r)**2)*(755*Q2**10-6460*Q2**9*(1+r**2)+19*Q2**8*(1397+2670*r**2
            +1397*r**4)-2*Q2**7*(22697+75917*r**2+75917*r**4+22697*r**6)+Q2**6*(18389
            +192140*r**2+288058*r**4+192140*r**6+18389*r**8)+Q2**5*(33782-72026*r**2
            -3024*r**4-3024*r**6-72026*r**8+33782*r**10)-Q2**4*(39655+164510*r**2
            +1238017*r**4+2141020*r**6+1238017*r**8+164510*r**10+39655*r**12)+2*Q2**3*(3721
            +115075*r**2+794925*r**4+2094619*r**6+2094619*r**8+794925*r**10+115075*r**12
            +3721*r**14)+4*Q2**2*(2651-3949*r**2+57848*r**4-355357*r**6-683806*r**8
            -355357*r**10+57848*r**12-3949*r**14+2651*r**16)-18*Q2*(453+4355*r**2
            +39700*r**4-68700*r**6-202608*r**8-202608*r**10-68700*r**12+39700*r**14
            +4355*r**16+453*r**18)+12*(179+1333*r**2+22836*r**4+74334*r**6+510837*r**8
            +822162*r**10+510837*r**12+74334*r**14+22836*r**16+1333*r**18+179*r**20))
            +(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(6866*Q2**16-23436*Q2**15*(1
            +r**2)+8*Q2**14*(865+8596*r**2+865*r**4)+8*Q2**13*(5380-11099*r**2
            -11099*r**4+5380*r**6)+Q2**12*(10045-259012*r**2-2562366*r**4-259012*r**6
            +10045*r**8)-4*Q2**11*(34147-324527*r**2-3988562*r**4-3988562*r**6-324527*r**8
            +34147*r**10)+2*Q2**10*(35759-646722*r**2-15796615*r**4-38576020*r**6
            -15796615*r**8-646722*r**10+35759*r**12)+8*Q2**9*(13745-127492*r**2
            +2119265*r**4+19072200*r**6+19072200*r**8+2119265*r**10-127492*r**12
            +13745*r**14)+Q2**8*(-91205+2043184*r**2+31186064*r**4-92196960*r**6
            -136611350*r**8-92196960*r**10+31186064*r**12+2043184*r**14-91205*r**16)
            -4*Q2**7*(8785+21669*r**2+14208392*r**4+33962024*r**6+101173570*r**8
            +101173570*r**10+33962024*r**12+14208392*r**14+21669*r**16+8785*r**18)
            +4*Q2**6*(10807-257354*r**2+4036831*r**4+57257856*r**6+179616146*r**8
            +416911988*r**10+179616146*r**12+57257856*r**14+4036831*r**16-257354*r**18
            +10807*r**20)-8*Q2**5*(266-53737*r**2-4403625*r**4+12575730*r**6+21507400*r**8
            +309675766*r**10+309675766*r**12+21507400*r**14+12575730*r**16-4403625*r**18
            -53737*r**20+266*r**22)-Q2**4*(2005+87332*r**2+26936590*r**4+29645300*r**6
            +614859675*r**8-231352920*r**10+1158640836*r**12-231352920*r**14+614859675*r**16
            +29645300*r**18+26936590*r**20+87332*r**22+2005*r**24)+4*Q2**3*(135
            -9223*r**2-887018*r**4+22918230*r**6+168130475*r**8+734118485*r**10
            +2173168916*r**12+2173168916*r**14+734118485*r**16+168130475*r**18+22918230*r**20
            -887018*r**22-9223*r**24+135*r**26)-2*Q2**2*(1265-69094*r**2-3667317*r**4
            +24306396*r**6-83158055*r**8+480299590*r**10+308598123*r**12+3065234184*r**14
            +308598123*r**16+480299590*r**18-83158055*r**20+24306396*r**22-3667317*r**24
            -69094*r**26+1265*r**28)+24*Q2*(31-1758*r**2-54453*r**4-686878*r**6
            -12831908*r**8+1292719*r**10-99093084*r**12+519615331*r**14+519615331*r**16
            -99093084*r**18+1292719*r**20-12831908*r**22-686878*r**24-54453*r**26
            -1758*r**28+31*r**30)+3*(57-3672*r**2+19060*r**4+3841960*r**6+9425060*r**8
            +68973464*r**10+826635276*r**12-1542120*r**14+7983061830*r**16-1542120*r**18
            +826635276*r**20+68973464*r**22+9425060*r**24+3841960*r**26+19060*r**28
            -3672*r**30+57*r**32))+432000*logq2**3*r**12*(867+35*Q2**7+3267*r**2
            +42957*r**4+88989*r**6+88989*r**8+42957*r**10+3267*r**12+867*r**14
            -505*Q2**6*(1+r**2)+5*Q2**5*(445+904*r**2+445*r**4)-Q2**4*(5293+15125*r**2
            +15125*r**4+5293*r**6)-3*Q2*(1+r**2)**2*(1111-2778*r**2-446*r**4-2778*r**6
            +1111*r**8)+Q2**3*(4157+17952*r**2+28010*r**4+17952*r**6+4157*r**8)
            +Q2**2*(1847-3657*r**2-14318*r**4-14318*r**6-3657*r**8+1847*r**10))*sqrtq2
            +120*logq2*r**4*(25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(105*Q2**7-555*Q2**6*(1
            +r**2)+15*Q2**5*(19+52*r**2+19*r**4)-Q2**4*(751+5687*r**2+5687*r**4
            +751*r**6)+Q2**3*(1139+8352*r**2+14006*r**4+8352*r**6+1139*r**8)+Q2**2*(719
            +3879*r**2+4474*r**4+4474*r**6+3879*r**8+719*r**10)+Q2*(-681+2244*r**2
            +38061*r**4+66912*r**6+38061*r**8+2244*r**10-681*r**12)+3*(-87+1849*r**2
            +34455*r**4+109943*r**6+109943*r**8+34455*r**10+1849*r**12-87*r**14))
            +2*(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(971+40*Q2**9-18517*r**2-136600*r**4+561592*r**6+1104554*r**8
            +1104554*r**10+561592*r**12-136600*r**14-18517*r**16+971*r**18-889*Q2**8*(1
            +r**2)+23*Q2**7*(169+418*r**2+169*r**4)-Q2**6*(4347+16967*r**2+16967*r**4
            +4347*r**6)-2*Q2**5*(1113+3489*r**2+13232*r**4+3489*r**6+1113*r**8)
            +2*Q2**4*(2240+11225*r**2+82043*r**4+82043*r**6+11225*r**8+2240*r**10)
            +Q2**3*(1659-18836*r**2-355219*r**4-699528*r**6-355219*r**8-18836*r**10
            +1659*r**12)+Q2**2*(-2567+13091*r**2+205549*r**4+793607*r**6+793607*r**8
            +205549*r**10+13091*r**12-2567*r**14)-8*Q2*(126-2129*r**2-34216*r**4
            -21131*r**6-11300*r**8-21131*r**10-34216*r**12-2129*r**14+126*r**16)))*sqrtq2)*nlopw.X1Q2MuG(0,Q2,r))/(
            -4354560000*logq2**5*r**20-302400000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -1050000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+1814400000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+25200000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+17500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +((1512000*logq2**3*r**12*(1+r**2)*(29+50*r**2+29*r**4)+60*logq2*(-Q2
            +(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(1873-640*Q2**9-8851*r**2+85460*r**4
            +1289996*r**6+6796322*r**8+6796322*r**10+1289996*r**12+85460*r**14-8851*r**16
            +1873*r**18+8848*Q2**8*(1+r**2)-32*Q2**7*(617+1454*r**2+617*r**4)+Q2**6*(8169
            +72819*r**2+72819*r**4+8169*r**6)+2*Q2**5*(6881-28372*r**2-46826*r**4
            -28372*r**6+6881*r**8)-Q2**4*(13825+65585*r**2+481262*r**4+481262*r**6
            +65585*r**8+13825*r**10)+4*Q2**3*(903+32098*r**2+185817*r**4+339964*r**6
            +185817*r**8+32098*r**10+903*r**12)+Q2**2*(1879+11233*r**2+272487*r**4
            -159599*r**6-159599*r**8+272487*r**10+11233*r**12+1879*r**14)-2*Q2*(1967
            +21792*r**2+88088*r**4-781552*r**6-1382190*r**8-781552*r**10+88088*r**12
            +21792*r**14+1967*r**16))+3600*logq2**2*r**8*(71-160*Q2**6+6084*r**2
            +70785*r**4+118280*r**6+70785*r**8+6084*r**10+71*r**12+960*Q2**5*(1
            +r**2)-288*Q2**4*(13+24*r**2+13*r**4)+Q2**3*(3221+9879*r**2+9879*r**4
            +3221*r**6)+3*Q2**2*(607-396*r**2-982*r**4-396*r**6+607*r**8)-3*Q2*(723
            -2099*r**2-6184*r**4-6184*r**6-2099*r**8+723*r**10))*sqrtq2+(-500*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4-2708*r**6-1133*r**8
            -34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1
            -19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4-26*r**6+r**8)+Q2*(1
            -31*r**2-390*r**4-390*r**6-31*r**8+r**10))+7*(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8
            -444*r**2-9976*r**4+31692*r**6-28170*r**8+31692*r**10-9976*r**12-444*r**14
            +13*r**16-24*Q2**7*(1+r**2)+Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61
            -193*r**2-193*r**4+61*r**6)+Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6
            -165*r**8)+4*Q2**3*(13-355*r**2-6138*r**4-6138*r**6-355*r**8+13*r**10)
            +Q2**2*(59-406*r**2+10313*r**4+35188*r**6+10313*r**8-406*r**10+59*r**12)
            -2*Q2*(27-595*r**2-7237*r**4+6605*r**6+6605*r**8-7237*r**10-595*r**12
            +27*r**14)))*sqrtq2)*nlopw.X1Q2MuG(1,Q2,r))/(36288000*logq2**4*r**16+1512000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+1750*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-12096000*logq2**3*r**12*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2-84000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((97200*logq2**2*r**8*(1+r**2)**2+3*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**2-1080*logq2*r**4*(1+r**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*sqrtq2)*nlopw.X1Q2MuG(2,Q2,r))/(-86400*logq2**3*r**12-1800*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+21600*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+50*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((360*logq2*r**4*(1+r**2)+2*(-3-8*Q2**4+42*r**2+282*r**4+42*r**6
            -3*r**8+7*Q2**3*(1+r**2)+Q2**2*(7-2*r**2+7*r**4)-3*Q2*(1-11*r**2
            -11*r**4+r**6))*sqrtq2)*nlopw.X1Q2MuG(3,Q2,r))/(720*logq2**2*r**8+5*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+nlopw.X1Q2MuG(4,Q2,r)/(-12*logq2*r**4
            +(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))
            +rhoLS*((flagPERP*(209018880000*logq2**6*(-Q2+(-1+r)**2)*r**24*(3+20*r**4
            -56*r**6+9*r**8)*(-Q2+(1+r)**2)-16588800*logq2**4*(-Q2+(-1+r)**2)*r**16*(
            -Q2+(1+r)**2)*(-13260*Q2**12*r**2+60*Q2**11*(40+2238*r**2+1959*r**4)
            -6*Q2**10*(4300+99468*r**2+166571*r**4+70764*r**6)+20*Q2**9*(5320+75526*r**2
            +178311*r**4+146971*r**6+38799*r**8)-5*Q2**8*(41775+454008*r**2+1346469*r**4
            +1599112*r**6+837648*r**8+145368*r**10)+10*Q2**7*(16140+179682*r**2
            +635805*r**4+1009580*r**6+801145*r**8+286020*r**10+46008*r**12)-10*Q2**6*(
            -9765+25368*r**2+51105*r**4+338080*r**6+549977*r**8+440226*r**10+137529*r**12
            +85806*r**14)+2*Q2**5*(-145950-355872*r**2-2787054*r**4-3031231*r**6
            -1202400*r**8+2226030*r**10+2835008*r**12+1194921*r**14+786024*r**16)
            -5*Q2**4*(-37320-119136*r**2-1110951*r**4-1531468*r**6-1043807*r**8
            +418104*r**10+2344655*r**12+1523788*r**14+656919*r**16+209736*r**18)
            -20*Q2**3*(-1500+23193*r**2+22344*r**4+233727*r**6+106571*r**8-104556*r**10
            -499797*r**12-497963*r**14-5175*r**16-110697*r**18+23673*r**20)+10*Q2**2*(
            -9765+53544*r**2-343110*r**4+644296*r**6-142215*r**8-217770*r**10-185387*r**12
            -573450*r**14-242136*r**16+874090*r**18-122715*r**20+113418*r**22)+(
            -1+r**2)**2*(-7925+64002*r**2-644137*r**4+2092860*r**6-501548*r**8-14416*r**10
            +1553052*r**12-405848*r**14+305105*r**16+1974638*r**18-7619*r**20+127836*r**22)
            -10*Q2*(-4770+34320*r**2-287841*r**4+805951*r**6-521110*r**8-364818*r**10
            +955666*r**12+1102928*r**14-243846*r**16-406190*r**18+759863*r**20-80031*r**22
            +64278*r**24))-2304*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -556584*Q2**18*r**2+24*Q2**17*(-6440+323208*r**2+306463*r**4)-8*Q2**16*(
            -206850+5519389*r**2+11628335*r**4+5174919*r**6)+16*Q2**15*(-453390
            +8198464*r**2+29667243*r**4+28688323*r**6+7989399*r**8)-Q2**14*(-15560475
            +202083880*r**2+1220893040*r**4+1833745864*r**6+1181704395*r**8+225561240*r**10)
            +2*Q2**13*(-5645325+43616511*r**2+717343940*r**4+1230354128*r**6+1303767993*r**8
            +779996385*r**10+94366656*r**12)+Q2**12*(-21123795+215895094*r**2+268889069*r**4
            +4014555896*r**6+6997825091*r**8+2134796386*r**10-510499101*r**12+59589024*r**14)
            -4*Q2**11*(-14212275+86070211*r**2+743035225*r**4+4686585867*r**6+11081489235*r**8
            +9824682745*r**10+3123228847*r**12+360722385*r**14+78294696*r**16)+Q2**10*(
            -39352005+41037548*r**2+3285943206*r**4+23975557532*r**6+82036551836*r**8
            +111640348140*r**10+68855674586*r**12+16275034772*r**14+2141869801*r**16
            +285317208*r**18)-2*Q2**9*(15644475-159295005*r**2+299102910*r**4+1564699086*r**6
            +23439363700*r**8+50040687620*r**10+51591022530*r**12+24569424530*r**14
            +2959354561*r**16+549580505*r**18+16391760*r**20)-Q2**8*(-72689925+241774542*r**2
            +1376541385*r**4+23642841412*r**6+53046035202*r**8+80273670480*r**10
            +65852812518*r**12+5296665100*r**14-1699708733*r**16+5042504322*r**18
            -160900335*r**20+132289872*r**22)+8*Q2**7*(-4477935-12549833*r**2+113135397*r**4
            +2869845901*r**6+12111514456*r**8+27782911496*r**10+40552191738*r**12
            +27367406188*r**14+7124939001*r**16+1485846481*r**18+625020601*r**20
            +805847*r**22+13167702*r**24)-Q2**6*(22941975-222773024*r**2+320246860*r**4
            +1186948608*r**6+42075249355*r**8+123826787000*r**10+253894842256*r**12
            +302901668880*r**14+128639342541*r**16+31928011680*r**18+5192478500*r**20
            +3260490288*r**22+390413905*r**24+33194376*r**26)+2*Q2**5*(17956365-41277559*r**2
            +323114312*r**4-5311848084*r**6-7966543787*r**8-13823328875*r**10-38085421224*r**12
            +36373118112*r**14+58882418407*r**16+19450066291*r**18+33943885680*r**20
            +8402339828*r**22+2995570871*r**24+427633647*r**26+3519216*r**28)+Q2**4*(
            -12569025-42558630*r**2-532283765*r**4+5857073536*r**6+20006350895*r**8
            +34234549530*r**10+191812969715*r**12+100524001040*r**14-70382940747*r**16
            -93491962450*r**18-82418789815*r**20-95990523760*r**22-24050384675*r**24
            -5151956514*r**26-571345095*r**28+1409760*r**30)-4*Q2**3*(1243725-12088901*r**2
            +33945405*r**4-197600789*r**6+1481269421*r**8+1734068835*r**10+12345396741*r**12
            +16114316675*r**14-14472290177*r**16-38680880487*r**18+1084023295*r**20
            -28955989079*r**22-2626870105*r**24-2641517559*r**26+73361791*r**28+12920745*r**30
            +2530464*r**32)+(-1+r**2)**2*(246015+536676*r**2+32866994*r**4-76476220*r**6
            +175415270*r**8+9083955020*r**10-45076434838*r**12+107812661588*r**14
            +2554205940*r**16-117106438140*r**18+3423157590*r**20+86477254348*r**22
            -27968873558*r**24+12315091780*r**26+668521870*r**28+322313500*r**30
            +20632189*r**32+563976*r**34)+Q2**2*(5835585-16402172*r**2+385462518*r**4
            -2053395604*r**6+1536932986*r**8+27486858996*r**10-116893034098*r**12
            +168733564812*r**14-98504943492*r**16-29664224772*r**18-184808077822*r**20
            +263810299812*r**22-154780905578*r**24+66730605596*r**26+491409786*r**28
            +2847158116*r**30+251116083*r**32+9739248*r**34)-2*Q2*(987525-952091*r**2
            +95622530*r**4-441681714*r**6+600269490*r**8+14843714010*r**10-78143641962*r**12
            +165889979990*r**14-93319820228*r**16+36498450420*r**18-1688578270*r**20
            -108839318678*r**22+176852299230*r**24-73189265802*r**26+24791391090*r**28
            +519434610*r**30+787021231*r**32+60572375*r**34+1916244*r**36))+32*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**22+Q2**21*(9168+5492*r**2)
            -Q2**20*(149367+1710440*r**2+145885*r**4)+2*Q2**19*(166081+11225142*r**2
            +11373357*r**4+513816*r**6)-4*Q2**18*(-500241+29074056*r**2+68728671*r**4
            +32028984*r**6+949307*r**8)+2*Q2**17*(-5615008+146448803*r**2+643844310*r**4
            +678188618*r**6+190108966*r**8+4125635*r**10)-4*Q2**16*(-3973359+74266084*r**2
            +679947566*r**4+1166558084*r**6+813909434*r**8+142704876*r**10+2477669*r**12)
            +2*Q2**15*(11775989-110636094*r**2+664396723*r**4+951187330*r**6+1749762163*r**8
            +1506240170*r**10+59782461*r**12+1513106*r**14)+2*Q2**14*(-55171233+425567014*r**2
            +2711053775*r**4+12958211190*r**6+21658743637*r**8+9739250642*r**10+1595151489*r**12
            +544099234*r**14+4360652*r**16)-2*Q2**13*(-64251489+244237704*r**2+5532279198*r**4
            +32275758294*r**6+86358159924*r**8+82047028890*r**10+28156092330*r**12
            +5697080754*r**14+880213701*r**16+5410358*r**18)+Q2**12*(32404320-689625728*r**2
            +6029515422*r**4+40568180232*r**6+219931592136*r**8+336188308392*r**10
            +225093896652*r**12+50076188856*r**14+10603021032*r**16+512577624*r**18
            -2528058*r**20)+2*Q2**11*(-115033373+399321098*r**2+2210312267*r**4+31587831686*r**6
            +31061512558*r**8+34431825288*r**10-6092006098*r**12-19785079664*r**14
            +9780730671*r**16+148443454*r**18+792861927*r**20+7594938*r**22)-2*Q2**10*(
            -93871869-301375562*r**2+3319994183*r**4+57918106482*r**6+221297158884*r**8
            +548728816820*r**10+745806838042*r**12+376195573260*r**14+111602538743*r**16
            +34133271638*r**18+4291667039*r**20+952597698*r**22+5111938*r**24)+2*Q2**9*(35349973
            -660880954*r**2+1254992504*r**4+13592393802*r**6+188409941901*r**8+595751483472*r**10
            +1400248406784*r**12+1275737968812*r**14+420777203271*r**16+112212418766*r**18
            +17786796808*r**20+3853561546*r**22+74351511*r**24-2393252*r**26)+2*Q2**8*(
            -108253049+118145044*r**2-1124814378*r**4+38306461532*r**6+18754759225*r**8
            +173212341792*r**10-500295246472*r**12-989355332216*r**14-692859876855*r**16
            -17789612956*r**18-28297635746*r**20+5682638556*r**22-1939300841*r**24
            +618754856*r**26+5264308*r**28)-2*Q2**7*(-54052263-448577294*r**2-1520978173*r**4
            +28731627586*r**6+112888864569*r**8+706645991774*r**10+929096410339*r**12
            +1001121957078*r**14+418146169379*r**16+16355794270*r**18+193861735857*r**20
            +135446846*r**22+5076541451*r**24-433805614*r**26+430061097*r**28+2026538*r**30)
            +2*Q2**6*(26086756-338891526*r**2+444452537*r**4-9932112558*r**6+69997798893*r**8
            +300770174994*r**10+915081187041*r**12+1489407656154*r**14+1687384602261*r**16
            +547655973486*r**18-13794033501*r**20+77006155926*r**22+1117169999*r**24
            -1921129978*r**26+1260136771*r**28-59789634*r**30-1335221*r**32)+2*Q2**5*(
            -41065221-30301762*r**2-2100878558*r**4+19379453494*r**6-37887938426*r**8
            +262142876010*r**10-288763677838*r**12+154465718158*r**14-604942387500*r**16
            -650739335506*r**18-222381517226*r**20-50316474078*r**22-61839285638*r**24
            -28061823154*r**26-913977578*r**28-2037242598*r**30+205606193*r**32+1540828*r**34)
            +Q2**4*(27030983+281559096*r**2+2329355103*r**4-8747645416*r**6+40739366524*r**8
            -535300669288*r**10+403110641524*r**12-1808455964520*r**14-1432781657230*r**16
            +955373106632*r**18+122065779642*r**20+994249714184*r**22+578840269196*r**24
            +246283782728*r**26+66968062644*r**28+8072207688*r**30+1963310271*r**32
            -157780704*r**34-693057*r**36)-4*Q2**3*(-2393664+28989864*r**2-155289084*r**4
            +2427128335*r**6-6125332244*r**8-451871134*r**10+21267853224*r**12-132493087338*r**14
            -254737602684*r**16+394463082666*r**18-13968192200*r**20+181366227780*r**22
            +40316224628*r**24+110206678118*r**26+21963685960*r**28+2782514298*r**30
            +999139932*r**32-155130906*r**34+9843156*r**36+123293*r**38)+2*(-1
            +r**2)**2*(-190141-1529518*r**2-33679497*r**4+9807032*r**6-1746945342*r**8
            +6647955444*r**10-39233655776*r**12-41613662324*r**14+844981789254*r**16
            -3200025798184*r**18+4808873592694*r**20-3353175039444*r**22+1172325161764*r**24
            -289357902804*r**26+26173110744*r**28-10693057756*r**30-1369313137*r**32
            -113407818*r**34-30256357*r**36+935532*r**38+5634*r**40)+2*Q2**2*(-5256619
            -1096858*r**2-569910819*r**4+3574594202*r**6-23996575640*r**8+106537748288*r**10
            -268025666192*r**12+237211890976*r**14+208084980498*r**16-175106578276*r**18
            +1047462497634*r**20-2262696717692*r**22+2130463827880*r**24-852248583952*r**26
            +143057076472*r**28-47330360656*r**30-10657058383*r**32-95706162*r**34
            -538547623*r**36+25490194*r**38+192728*r**40)-2*Q2*(-1647815-6079975*r**2
            -224696078*r**4+905703860*r**6-11449882667*r**8+57888034035*r**10-231966314240*r**12
            +211288930984*r**14+1134859600730*r**16-3216199321134*r**18-86321246700*r**20
            +6808527240080*r**22-7559948172934*r**24+3468174980510*r**26-972610147056*r**28
            +129588947480*r**30-38974080115*r**32-6566340347*r**34-280835350*r**36
            -221131268*r**38+8084625*r**40+53375*r**42))+497664000*logq2**5*r**20*(420*Q2**9*r**2
            -60*Q2**8*(8+51*r**2+37*r**4)+40*Q2**7*(96+281*r**2+328*r**4+45*r**6)
            +4*Q2**6*(-3360-6676*r**2-8487*r**4-1690*r**6+2877*r**8)+Q2**5*(24675
            +44164*r**2+44222*r**4+19828*r**6-50433*r**8-32928*r**10)+Q2**4*(-21315
            -47095*r**2-28212*r**4-23434*r**6+49925*r**8+104449*r**10+27090*r**12)
            +2*Q2**3*(-105+17105*r**2+3224*r**4+7017*r**6-23847*r**8-36323*r**10
            -32108*r**12+9345*r**14)-(-1+r**2)**2*(-2985+7299*r**2+5207*r**4-35113*r**6
            +43049*r**8+48649*r**10-24515*r**12+9277*r**14+9612*r**16)-2*Q2**2*(
            -8085+16460*r**2+1611*r**4-17045*r**6+6832*r**8+7890*r**10-25141*r**12
            +1203*r**14+26355*r**16)+Q2*(-12225+33014*r**2-4784*r**4-97176*r**6
            +51266*r**8+200968*r**10+101904*r**12-68368*r**14-641*r**16+37962*r**18))*sqrtq2
            -276480*logq2**3*r**12*(-126720*Q2**17*r**2+12*Q2**16*(-64+148560*r**2+138255*r**4)
            -4*Q2**15*(-9402+2776908*r**2+5100805*r**4+2401605*r**6)+8*Q2**14*(-42285
            +4951722*r**2+13565140*r**4+12643185*r**6+4002255*r**8)-Q2**13*(-1363635
            +86687004*r**2+319732814*r**4+437695680*r**6+280496045*r**8+66584340*r**10)
            +Q2**12*(-2802555+111962901*r**2+542290348*r**4+945654486*r**6+904945125*r**8
            +465384085*r**10+86140890*r**12)-2*Q2**11*(-1092252+29218287*r**2+219760557*r**4
            +405974987*r**6+486509332*r**8+451858283*r**10+223847415*r**12+30432915*r**14)
            +2*Q2**10*(1385538-29861319*r**2-68113660*r**4-387181820*r**6-737442725*r**8
            -445060159*r**10+52256838*r**12+99728830*r**14+2599965*r**16)+Q2**9*(
            -8500965+136135098*r**2+715457180*r**4+2772737440*r**6+5644372370*r**8
            +6002352080*r**10+3224455148*r**12+684729560*r**14+22868715*r**16+33361470*r**18)
            -Q2**8*(-7365105+96724917*r**2+686589312*r**4+2903638200*r**6+6505159010*r**8
            +8811795550*r**10+7201188432*r**12+3278624872*r**14+814095615*r**16+77257485*r**18
            +41483520*r**20)+4*Q2**7*(269940-682623*r**2+38800926*r**4+259603572*r**6
            +498137280*r**8+958477090*r**10+1311563782*r**12+1116769876*r**14+548184932*r**16
            +250108425*r**18+28823820*r**20+10983420*r**22)-4*Q2**6*(1881726-14621547*r**2
            -58707772*r**4-128619222*r**6-667206707*r**8-751627606*r**10-190050502*r**12
            +697344318*r**14+912065228*r**16+595598293*r**18+375456966*r**20+49347500*r**22
            +10823805*r**24)+Q2**5*(5889849-43983528*r**2-211838870*r**4-668278800*r**6
            -2924363345*r**8-3824050776*r**10-2187239636*r**12+1501306400*r**14+4609291255*r**16
            +3553121880*r**18+2570294762*r**20+1192988944*r**22+184693665*r**24+22120200*r**26)
            +(-1+r**2)**4*(52467-214959*r**2-513578*r**4+24544170*r**6-126468135*r**8
            +333630851*r**10+143760988*r**12-186943764*r**14-290848075*r**16+152935495*r**18
            +307080582*r**20-41295254*r**22+44394367*r**24+2264805*r**26+500040*r**28)
            +Q2**4*(-638505+6880251*r**2+44455100*r**4+448931430*r**6+397599665*r**8
            +1914277805*r**10+7020098*r**12-2100059420*r**14-3651324935*r**16-3341122955*r**18
            +201357400*r**20-1839597674*r**22+74905695*r**24-69432445*r**26+8060490*r**28)
            -Q2*(-1+r**2)**2*(435207-2268252*r**2-4712327*r**4+151262062*r**6-772834785*r**8
            +1742771556*r**10+291253569*r**12-141006026*r**14+67038701*r**16-528832500*r**18
            +306950227*r**20+1870194058*r**22-383056147*r**24+289189612*r**26+12642035*r**28
            +4013010*r**30)-2*Q2**3*(960120-5602773*r**2-11544763*r**4+233427435*r**6
            -847334440*r**8+1409551585*r**10-428587659*r**12-648258219*r**14-404094200*r**16
            -558440195*r**18-617977625*r**20+2218890357*r**22-815882968*r**24+459359415*r**26
            +5504735*r**28+10029195*r**30)+2*Q2**2*(709710-4630407*r**2-5798076*r**4
            +192173588*r**6-1015157385*r**8+2272016695*r**10-1191508706*r**12+317702*r**14
            +757734969*r**16+1316552935*r**18-15793960*r**20-1505521512*r**22+2545158449*r**24
            -831291607*r**26+372854150*r**28+8703630*r**30+6519825*r**32))*sqrtq2
            +192*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(41196*Q2**21*r**2
            -12*Q2**20*(-1480+57537*r**2+57537*r**4)+120*Q2**19*(-1538+36356*r**2
            +93839*r**4+39453*r**6)-4*Q2**18*(-197020+3429590*r**2+17022939*r**4
            +17758976*r**6+4374255*r**8)+Q2**17*(-1611705+21307800*r**2+196865022*r**4
            +326801204*r**6+226422315*r**8+36585180*r**10)-Q2**16*(-825285+8328699*r**2
            +243045288*r**4+271652546*r**6+393855835*r**8+353632323*r**10+35295714*r**12)
            -2*Q2**15*(-1691530+8632397*r**2+47034651*r**4+1203624515*r**6+2322591946*r**8
            +888276297*r**10-27952759*r**12+9161007*r**14)+6*Q2**14*(-1276570+306365*r**2
            +107405990*r**4+1468114024*r**6+4369816345*r**8+4133678157*r**10+1278770820*r**12
            +132717130*r**14+15579195*r**16)-6*Q2**13*(-694360-9541905*r**2+108142642*r**4
            +1891948324*r**6+8996254464*r**8+13405058556*r**10+8681955634*r**12+1980123832*r**14
            +229100148*r**16+14985465*r**18)+Q2**12*(7231640-45106750*r**2+147589494*r**4
            -510307928*r**6+31590484676*r**8+63259793076*r**10+72748902136*r**12
            +42509817224*r**14+5135819268*r**16+692981210*r**18-25514190*r**20)+2*Q2**11*(
            -6692790-43045977*r**2-138804633*r**4+9040529951*r**6+31325757150*r**8
            +94929285204*r**10+132949671332*r**12+57641585244*r**14+10260629376*r**16
            +4505870285*r**18+355067277*r**20+63349533*r**22)-2*Q2**10*(-2475330
            -80127723*r**2-427329540*r**4+8482224308*r**6+62173944523*r**8+237632761038*r**10
            +504894152264*r**12+446597123224*r**14+157735353072*r**16+33855112253*r**18
            +6979631884*r**20+627808500*r**22+42879447*r**24)+2*Q2**9*(4015635-17649645*r**2
            -80633610*r**4-1824953034*r**6+29923651135*r**8+140347883043*r**10+544580901140*r**12
            +778778866780*r**14+486715657641*r**16+108009326625*r**18+22472141078*r**20
            +2820445950*r**22+299041125*r**24-17911335*r**26)+2*Q2**8*(-5095155-64812390*r**2
            -726733239*r**4+7729275950*r**6+19926490149*r**8+145558773576*r**10+76967287949*r**12
            -135228948996*r**14-279692483433*r**16-138804933646*r**18+24195819291*r**20
            -3024656826*r**22+968352551*r**24+82666044*r**26+42145695*r**28)-2*Q2**7*(
            -1141230-61180425*r**2-771079923*r**4+3106696853*r**6+26175882046*r**8
            +242266876761*r**10+592831687421*r**12+912351757243*r**14+868180549830*r**16
            +280334574881*r**18+70627874791*r**20+55988355171*r**22-628241398*r**24
            +1023832399*r**26+176923695*r**28+16904205*r**30)+2*Q2**6*(1923590-152827*r**2
            +31246698*r**4-2840959408*r**6+8847417085*r**8+65995782819*r**10+378992755352*r**12
            +759043973518*r**14+1225994189751*r**16+848962846475*r**18+178485168418*r**20
            +17273411172*r**22+24761709059*r**24+567468397*r**26+703397820*r**28
            +117341918*r**30-10364637*r**32)+2*Q2**5*(-1687020-30111117*r**2-526241814*r**4
            +3031195536*r**6-5399320116*r**8+87944018802*r**10-73099714*r**12+85799140020*r**14
            -12540830160*r**16-548859502468*r**18-205049783706*r**20-196227938040*r**22
            -67969411444*r**24-38817508986*r**26-8582403726*r**28-1238044236*r**30
            -53687964*r**32+12470553*r**34)+2*Q2**4*(309480+16643565*r**2+303501675*r**4
            -468666468*r**6+6072438630*r**8-72665356764*r**10-49742477450*r**12-222911612740*r**14
            -809622560514*r**16+56447378230*r**18+316674193628*r**20+117897252180*r**22
            +397604133970*r**24+157953921812*r**26+45568320090*r**28+9012406356*r**30
            +894533730*r**32+1524645*r**34-2924055*r**36)-2*Q2**3*(-289910-474605*r**2
            -31915293*r**4+714305651*r**6-771979178*r**8-2462298942*r**10-13502542778*r**12
            -21154868422*r**14-399967899894*r**16+182040594376*r**18+323036215364*r**20
            +30667931616*r**22+367504684738*r**24+62106880670*r**26+100384759962*r**28
            +4651250438*r**30+1576907092*r**32-89419323*r**34-26686727*r**36+1965165*r**38)
            +(-1+r**2)**2*(-11815-403479*r**2-12116849*r**4+7431355*r**6-1021262296*r**8
            +3713843244*r**10-19357856828*r**12-79702366908*r**14+643446898310*r**16
            -1875974607162*r**18+1346326900378*r**20+947285878418*r**22-1500221460412*r**24
            +547694052940*r**26-160473203388*r**28-1314878428*r**30-6495045111*r**32
            -596417831*r**34-67757105*r**36-1871029*r**38+93996*r**40)+2*Q2**2*(
            -209010-3774075*r**2-100503306*r**4+495159340*r**6-4934409087*r**8+23742388308*r**10
            -47797118772*r**12-65442601284*r**14+435289265808*r**16-512251145506*r**18
            +201626183424*r**20+843810468444*r**22-1273773051514*r**24+942040248564*r**26
            -363615254652*r**28+28925356068*r**30-22402113222*r**32-2276793771*r**34
            -420155462*r**36-21995880*r**38+1575585*r**40)+Q2*(113115+2926986*r**2
            +81610158*r**4-276256040*r**6+5678145215*r**8-28132582398*r**10+96147156696*r**12
            +166092974016*r**14-1702057063770*r**16+4055392372820*r**18-2870556455516*r**20
            +1790627790576*r**22-4370925867706*r**24+5072448079060*r**26-2208592193160*r**28
            +617619359616*r**30-27933564609*r**32+28296357282*r**34+2726470750*r**36
            +402827000*r**38+15322683*r**40-882774*r**42))*sqrtq2))/(-470292480000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-48988800000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-340200000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-157500*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6+5443200000*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            +11340000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*sqrtq2+235146240000*logq2**5*r**22*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(flagPERP*muWC**2*(
            -52254720000*logq2**6*(-Q2+(-1+r)**2)*r**24*(21+20*r**2-60*r**4+28*r**6
            +3*r**8)*(-Q2+(1+r)**2)+4147200*logq2**4*(-Q2+(-1+r)**2)*r**16*(-Q2
            +(1+r)**2)*(31740*Q2**12*r**2-120*Q2**11*(52+2304*r**2+2859*r**4)+6*Q2**10*(9900
            +171044*r**2+422713*r**4+265452*r**6)-10*Q2**9*(23184+213007*r**2+751100*r**4
            +975189*r**6+401112*r**8)+5*Q2**8*(92055+542802*r**2+2248359*r**4+4406066*r**6
            +3938904*r**8+1087038*r**10)-10*Q2**7*(46398+230163*r**2+853485*r**4
            +2130245*r**6+2979205*r**8+2037672*r**10+230472*r**12)+5*Q2**6*(32130
            +387429*r**2+711826*r**4+1029816*r**6+1495886*r**8+2200653*r**10+1092546*r**12
            -874314*r**14)+Q2**5*(105000-2292033*r**2-3864936*r**4+1730371*r**6
            +16809960*r**8+29644845*r**10+17716972*r**12+10426689*r**14+7660476*r**16)
            -5*Q2**4*(23532-394404*r**2-960705*r**4-853556*r**6+1228187*r**8+6771030*r**10
            +9078433*r**12+4015100*r**14+2469177*r**16+818046*r**18)-10*Q2**3*(-4770
            +61416*r**2-3428*r**4+935055*r**6+178810*r**8-770599*r**10-2137284*r**12
            -2240599*r**14+30168*r**16-657873*r**18+108384*r**20)+(-1+r**2)**2*(
            -3375-5306*r**2-1205229*r**4+6032210*r**6-4530386*r**8-2923902*r**10
            -1661326*r**12-2351966*r**14+2336745*r**16+1901216*r**18-62493*r**20
            +205812*r**22)+5*Q2**2*(-4914-34467*r**2-970920*r**4+3060140*r**6-1389810*r**8
            -1111140*r**10-958594*r**12-867510*r**14+58860*r**16+2526335*r**18-652446*r**20
            +495666*r**22)-5*Q2*(-2928-20817*r**2-826290*r**4+3607249*r**6-4312744*r**8
            -967602*r**10+1644232*r**12-1180630*r**14-1592604*r**16+164659*r**18
            +1790810*r**20-357675*r**22+239940*r**24))+576*logq2**2*r**8*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(881112*Q2**18*r**2-48*Q2**17*(-5220+260567*r**2
            +242332*r**4)+8*Q2**16*(-336970+8894607*r**2+19096105*r**4+8082207*r**6)
            -8*Q2**15*(-1480540+26960479*r**2+96672508*r**4+95896183*r**6+23870574*r**8)
            +Q2**14*(-26451075+386543200*r**2+1954677440*r**4+2995905932*r**6+1961391975*r**8
            +289061820*r**10)-2*Q2**13*(-13548825+222137303*r**2+1227941380*r**4
            +1731677664*r**6+1812406229*r**8+1111180125*r**10+35224308*r**12)-Q2**12*(
            -4956195-408992658*r**2-878847963*r**4+7508327928*r**6+17057833023*r**8
            +8399904298*r**10+1062403047*r**12+541678872*r**14)+4*Q2**11*(-11388855
            -103779632*r**2+317933775*r**4+7147042926*r**6+20919174555*r**8+22602908600*r**10
            +8691561161*r**12+1675420530*r**14+233748588*r**16)-Q2**10*(-47861165
            -330682016*r**2+1510698438*r**4+36301020556*r**6+136088737968*r**8+221404757220*r**10
            +165915736978*r**12+41407140196*r**14+7688641253*r**16+386357004*r**18)
            +2*Q2**9*(-7817425+2404525*r**2+564237210*r**4+10970550018*r**6+39553501960*r**8
            +74459612960*r**10+91754332530*r**12+49554975670*r**14-3369450607*r**16
            +180734875*r**18-347936820*r**20)+Q2**8*(-6689925-257148174*r**2-2013550255*r**4
            -10310373844*r**6+22392560406*r**8+170702122920*r**10+317945183394*r**12
            +197343933940*r**14+114652604271*r**16+68623886166*r**18+7616078925*r**20
            +1050406896*r**22)-8*Q2**7*(-1242835-14870379*r**2-283348179*r**4-1220319907*r**6
            +4677259268*r**8+37016732668*r**10+100814110274*r**12+123175077044*r**14
            +59633686893*r**16+29775748343*r**18+7705992873*r**20+882904951*r**22
            +43353306*r**24)+Q2**6*(-13813505+87580688*r**2-880750820*r**4-2841536076*r**6
            +5251714415*r**8+143952374020*r**10+466101881328*r**12+994413689240*r**14
            +893536032573*r**16+146687249640*r**18+138952712660*r**20-7544671756*r**22
            +536637365*r**24-415034172*r**26)+2*Q2**5*(7746855-23013293*r**2-19406016*r**4
            -3526999548*r**6-1960728169*r**8-55761423525*r**10-4715413668*r**12-11654029536*r**14
            -170795187611*r**16-54804670583*r**18+188877545760*r**20+7075908476*r**22
            +24391973117*r**24+1613718249*r**26+235889892*r**28)-Q2**4*(5686575+57802250*r**2
            -5482765*r**4-5997612032*r**6-7891921805*r**8-157401230310*r**10-65022273185*r**12
            +257445336360*r**14+456454561389*r**16+76208725630*r**18+359173796905*r**20
            +373926240160*r**22+62301990705*r**24+28649746718*r**26+2146582725*r**28
            +127570680*r**30)-4*Q2**3*(1166775-10464792*r**2+40343965*r**4+52703582*r**6
            +482259187*r**8+17620213380*r**10+10995173157*r**12+11846225290*r**14
            -50392469599*r**16-103969139664*r**18+61938410095*r**20-105860472638*r**22
            +3526849945*r**24-10854538908*r**26+769310927*r**28-45403050*r**30+19512348*r**32)
            +(-1+r**2)**2*(318305+3282512*r**2+53582878*r**4+41083360*r**6+875472190*r**8
            +6965133640*r**10-38506621906*r**12+250530796256*r**14-266820273720*r**16
            -121158357080*r**18+96817547530*r**20+79786806176*r**22-48300770446*r**24
            +23162798360*r**26-549377110*r**28+736650400*r**30+29634343*r**32+2694312*r**34)
            +Q2**2*(5641815+6042776*r**2+372278666*r**4-1338799828*r**6+1701921242*r**8
            -4598627308*r**10-59206051606*r**12+141277898124*r**14-29889909744*r**16
            -148134513084*r**18-224158466354*r**20+620960986084*r**22-463422569546*r**24
            +206222372572*r**26-23535214658*r**28+10510735972*r**30+369530121*r**32
            +72744756*r**34)-2*Q2*(1106095+5797633*r**2+116152310*r**4-254094858*r**6
            +1299592530*r**8+1083855510*r**10-34911385894*r**12+225642867830*r**14
            -241979463416*r**16+25918580240*r**18-105506777530*r**20-74345225486*r**22
            +278866032510*r**24-168016089894*r**26+62059249230*r**28-5019993950*r**30
            +2284229497*r**32+84974975*r**34+11392668*r**36))-8*r**2*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**22*r**2+2*Q2**21*(4527-9848*r**2+57*r**4)
            +Q2**20*(-131472+202661*r**2+1063606*r**4-53319*r**6)+2*Q2**19*(421539
            +487631*r**2-11284137*r**4-5873199*r**6+180830*r**8)+Q2**18*(-3118767
            -15540804*r**2+142763490*r**4+244543128*r**6+57748669*r**8-1127640*r**10)
            +Q2**17*(7224003+62492280*r**2-441692045*r**4-1388455828*r**6-1076476847*r**8
            -142209604*r**10+1743033*r**12)+Q2**16*(-10413588-97668346*r**2+815041396*r**4
            +3293108280*r**6+3852467880*r**8+2023777578*r**10+122280432*r**12-449016*r**14)
            +Q2**15*(8083176-44826134*r**2-1135816004*r**4-2716524738*r**6+4079215624*r**8
            +4049840366*r**10+386181660*r**12+248270746*r**14-3254424*r**16)+2*Q2**14*(
            -383742+215557997*r**2+793310251*r**4-1131459921*r**6-24407375653*r**8
            -45456424991*r**10-22824668547*r**12-4558205359*r**14-404759093*r**16
            +2805810*r**18)+2*Q2**13*(-1496112-342466219*r**2-962817420*r**4+2979879996*r**6
            +53643600504*r**8+150724470810*r**10+151168910976*r**12+48447282036*r**14
            +7848250008*r**16+358259169*r**18-984340*r**20)-2*Q2**12*(1221792-157574066*r**2
            -538074255*r**4+2721193149*r**6+48373076556*r**8+176141374644*r**10+275535823362*r**12
            +186273197742*r**14+22554217332*r**16+1709466582*r**18-234439491*r**20
            +2601261*r**22)+2*Q2**11*(4751370+208777127*r**2+381681824*r**4+4340100035*r**6
            +12708080604*r**8-16946091158*r**10-156606209176*r**12-84284303598*r**14
            -63857914670*r**16-73359983329*r**18-11632461144*r**20-774176325*r**22
            +3638232*r**24)-2*Q2**10*(3752073+318829277*r**2+824043827*r**4+7200507735*r**6
            +444272078*r**8-191907669802*r**10-1008012726030*r**12-1648140944702*r**14
            -921879288343*r**16-443687213475*r**18-129287236373*r**20-15278351577*r**22
            -492477648*r**24+734032*r**26)-2*Q2**9*(526383-64238313*r**2-675686509*r**4
            -4187466654*r**6-4469296521*r**8+107204002209*r**10+1009647173595*r**12
            +2606883620364*r**14+2892464229357*r**16+898650786729*r**18+431631867705*r**20
            +39712692274*r**22+1525932621*r**24-323980033*r**26+2372985*r**28)+2*Q2**8*(2635812
            +180658719*r**2-672288995*r**4+2732817656*r**6+18611382846*r**8+2022748729*r**10
            +235700578031*r**12+578641045698*r**14+1531227611032*r**16+1297735543169*r**18
            -635489814837*r**20-40296381356*r**22-97358267482*r**24-12796835033*r**26
            -663988279*r**28+2299890*r**30)+Q2**7*(-2364216-303937586*r**2+1096110740*r**4
            -7766954190*r**6-75676779320*r**8-104054202874*r**10-36168487764*r**12
            +2398269703258*r**14+6821795868944*r**16+4390972417962*r**18+3774042983788*r**20
            +3314245046678*r**22+760678076328*r**24+216510146562*r**26+21652959444*r**28
            +533141598*r**30-474312*r**32)-2*Q2**6*(666966-2205982*r**2-204524305*r**4
            +620895375*r**6-16937169777*r**8-72632036253*r**10-112150943529*r**12
            +426555155319*r**14+3170686448475*r**16+6897627347415*r**18+1729705615125*r**20
            +3172699523925*r**22+515244268053*r**24+260567958545*r**26+10910160037*r**28
            -440751963*r**30-192077269*r**32+953043*r**34)+2*Q2**5*(856701+55721383*r**2
            -779067577*r**4+2963587080*r**6+6555794820*r**8-26615018744*r**10+146136708620*r**12
            -254845747248*r**14+746901505606*r**16+798038040326*r**18+6586836025074*r**20
            -4507809087032*r**22+2542494042932*r**24-1040545626944*r**26+606029084*r**28
            -48822684576*r**30-5567552891*r**32-240309877*r**34+674463*r**36)+Q2**4*(
            -425328-50847257*r**2+960278004*r**4-2709404943*r**6-10736579696*r**8
            +22841398100*r**10-521395517256*r**12+329843162836*r**14-3478764558496*r**16
            +4366099432842*r**18+5492586610064*r**20-11954158323442*r**22+14435567418576*r**24
            -2489157861804*r**26+1924649935464*r**28+174177529764*r**30+61432232880*r**32
            +5847856359*r**34+135698268*r**36-162935*r**38)-2*Q2**3*(130629+3502098*r**2
            -62824545*r**4+487828716*r**6-181178078*r**8+1320457844*r**10-53097976068*r**12
            +52128465444*r**14-1471202932218*r**16+1426248688488*r**18+813220414370*r**20
            +729108677052*r**22-812921053248*r**24+1056207483788*r**26+577297239628*r**28
            +17965254252*r**30+49208708493*r**32-80744826*r**34-190157961*r**36-32140088*r**38
            +124230*r**40)+2*(-1+r**2)**2*(3270+255858*r**2-12908701*r**4+23673736*r**6
            -403810881*r**8-3209458014*r**10+8694900708*r**12-51088387332*r**14-108754209488*r**16
            +956032198568*r**18-4610254072398*r**20+9070915454188*r**22-7911295335958*r**24
            +3586289799768*r**26-1025435066268*r**28+159645330708*r**30-30746648382*r**32
            -712950634*r**34-457634141*r**36-39079044*r**38-1017441*r**40+1878*r**42)
            +Q2**2*(216297+13127766*r**2-402286580*r**4+1501548566*r**6-2740912121*r**8
            -30714276184*r**10+169971276120*r**12-356225213664*r**14+394129729298*r**16
            +2119399568284*r**18-7651469740624*r**20+18099691813980*r**22-27744560828282*r**24
            +23663463335456*r**26-11378630339480*r**28+3171348788112*r**30-699327809259*r**32
            +25073274526*r**34-14122365820*r**36-1484641058*r**38-60659101*r**40
            +153768*r**42)+Q2*(-61149-4329426*r**2+178172107*r**4-629487600*r**6
            +3405530533*r**8+23546013282*r**10-125645425083*r**12+451838664640*r**14
            -690524849650*r**16+1632651625836*r**18-4282596656962*r**20+22731650897120*r**22
            -54344263132902*r**24+56571398500900*r**26-30769924587846*r**28+10148913388224*r**30
            -2027207192737*r**32+360870688006*r**34-3510692025*r**36+5738334352*r**38
            +568125105*r**40+18193626*r**42-38351*r**44))+124416000*logq2**5*r**20*(1470*Q2**9*r**2
            -30*Q2**8*(16+269*r**2+469*r**4)+20*Q2**7*(80+963*r**2+3193*r**4+2835*r**6)
            -4*Q2**6*(-560+5108*r**2+27941*r**4+51485*r**6+31164*r**8)+Q2**5*(-14175
            -4178*r**2+66926*r**4+274664*r**6+350721*r**8+155526*r**10)+Q2**4*(15295
            +29975*r**2+28974*r**4-114182*r**6-336625*r**8-325213*r**10-88200*r**12)
            +2*Q2**3*(5845-28990*r**2-20683*r**4+12156*r**6+38939*r**8+88206*r**10
            +68411*r**12-14700*r**14)+(-1+r**2)**2*(-8845+29033*r**2-61211*r**4
            +6549*r**6+40863*r**8-62737*r**10+5275*r**12+9619*r**14+11214*r**16)
            +2*Q2**2*(-19425+49690*r**2-28073*r**4-10430*r**6-4411*r**8-26830*r**10
            -1387*r**12-5334*r**14+41160*r**16)+Q2*(31525-106148*r**2+199688*r**4
            +103312*r**6-183422*r**8-12076*r**10+133552*r**12-5864*r**14+11297*r**16
            -50904*r**18))*sqrtq2+69120*logq2**3*r**12*(248850*Q2**17*r**2-6*Q2**16*(
            -544+545175*r**2+583995*r**4)+4*Q2**15*(-10686+4750989*r**2+10086065*r**4
            +5442615*r**6)-4*Q2**14*(-60030+15975642*r**2+49888335*r**4+53970295*r**6
            +19260180*r**8)+Q2**13*(-652065+137056232*r**2+547782922*r**4+862762500*r**6
            +642089015*r**8+164276280*r**10)-Q2**12*(-650565+196619453*r**2+891214784*r**4
            +1687800558*r**6+1843211095*r**8+1101621305*r**10+190750770*r**12)+2*Q2**11*(419184
            +98623011*r**2+409398136*r**4+649943801*r**6+645504116*r**8+705770289*r**10
            +448761980*r**12+12950595*r**14)+2*Q2**10*(-1525374-75692498*r**2-136738925*r**4
            +499653690*r**6+2106554875*r**8+2625943102*r**10+1096770121*r**12+160272890*r**14
            +141423975*r**16)-Q2**9*(-3372735-99945286*r**2+243828180*r**4+3201083840*r**6
            +10951477410*r**8+18469757600*r**10+16288456764*r**12+6458617720*r**14
            +1602225165*r**16+435173310*r**18)+Q2**8*(-2254095-46370889*r**2+356084176*r**4
            +3278834680*r**6+10940769670*r**8+21768852350*r**10+27149514556*r**12
            +19323504656*r**14+5498283825*r**16+1612280595*r**18+219686940*r**20)
            +4*Q2**7*(841080-3401136*r**2-54562433*r**4-613688566*r**6-1454692080*r**8
            -2417468120*r**10-3244154146*r**12-3597584208*r**14-1992952696*r**16
            +328454160*r**18-124376685*r**20+38183310*r**22)-4*Q2**6*(1469382-12173214*r**2
            -21497474*r**4-590280919*r**6-807510859*r**8-140892102*r**10+1503996916*r**12
            +2572476136*r**14+1436387456*r**16+1244084116*r**18+1663907262*r**20
            +102253055*r**22+75614805*r**24)+Q2**5*(4684653-38081076*r**2-15714470*r**4
            -2115516820*r**6-2446466765*r**8-1058003732*r**10+5530939388*r**12+14713549400*r**14
            +18029233235*r**16+9169373860*r**18+7435900874*r**20+5192174748*r**22
            +504533485*r**24+168017220*r**26)+(-1+r**2)**4*(108339-188653*r**2+1409964*r**4
            +17362110*r**6-188625955*r**8+1212689517*r**10-920977454*r**12-819389068*r**14
            -94120515*r**16+268297885*r**18+364123944*r**20-100855218*r**22+76217779*r**24
            +1337955*r**26+1169370*r**28)+Q2**4*(47895+7231657*r**2-1765680*r**4
            +1026133970*r**6+105676005*r**8+2597160275*r**10-1168252514*r**12-4961085780*r**14
            -6701340015*r**16-7684713585*r**18+753959380*r**20-4928369918*r**22-335039565*r**24
            -262182155*r**26+9564030*r**28)-Q2*(-1+r**2)**2*(803979-2373214*r**2
            +8449241*r**4+35695824*r**6-880989625*r**8+4930757362*r**10-2399337467*r**12
            -3742023792*r**14-1732784623*r**16-763199690*r**18+917471659*r**20+2589475056*r**22
            -990761699*r**24+566533174*r**26+125815*r**28+10638000*r**30)-2*Q2**3*(1488420
            -5329891*r**2+7851024*r**4+68121715*r**6-866768520*r**8+2876152905*r**10
            -1666672828*r**12-1973284713*r**14-696618140*r**16-143756585*r**18-532052760*r**20
            +4194676569*r**22-2348086336*r**24+1108233475*r**26-56877820*r**28+32923485*r**30)
            +2*Q2**2*(1173870-5104614*r**2+12598783*r**4-16136514*r**6-857224605*r**8
            +4478585890*r**10-4353126997*r**12-414788266*r**14-522832757*r**16-423067410*r**18
            -697510195*r**20-1867844454*r**22+4539966633*r**24-2175430954*r**26+858214665*r**28
            -28591790*r**30+19598715*r**32))*sqrtq2+48*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(20598*Q2**21*r**2-6*Q2**20*(-14800+110817*r**2+48657*r**4)
            +12*Q2**19*(-81020+429860*r**2+786457*r**4+144360*r**6)-4*Q2**18*(-1129140
            +4698553*r**2+17983292*r**4+13251612*r**6+1357125*r**8)+Q2**17*(-10975155
            +40805244*r**2+239075718*r**4+267166828*r**6+140780445*r**8+8542980*r**10)
            +Q2**16*(12241215-72156519*r**2-391550736*r**4+173169526*r**6+240743147*r**8
            -107524827*r**10-1118502*r**12)-4*Q2**15*(-1165755-36799237*r**2-76247941*r**4
            +1147665975*r**6+2443518349*r**8+1125179473*r**10+97841799*r**12+5405793*r**14)
            +6*Q2**14*(-5523430-47296645*r**2-24119282*r**4+2394134421*r**6+7600109356*r**8
            +7578246829*r**10+2255947690*r**12+201903163*r**14+6278490*r**16)-12*Q2**13*(
            -3107760-29347138*r**2-6665627*r**4+1740322188*r**6+7322957831*r**8
            +11290684494*r**10+7452772375*r**12+1292795448*r**14+93830373*r**16+1079400*r**18)
            +Q2**12*(2229240-179511782*r**2+674020676*r**4+15820018380*r**6+60438769828*r**8
            +77227590488*r**10+93808149564*r**12+47111816980*r**14-7506684604*r**16
            -750261330*r**18-41315040*r**20)+4*Q2**11*(-11146005-31552419*r**2-575312853*r**4
            -2133015385*r**6+9159358092*r**8+87677333118*r**10+155353444136*r**12
            +86797134654*r**14+32886162969*r**16+10730621741*r**18+676990509*r**20
            +15227667*r**22)-2*Q2**10*(-18459870-129086889*r**2-1369636110*r**4-3883224661*r**6
            +37998501814*r**8+368288521014*r**10+960447800072*r**12+1020102784462*r**14
            +414047266746*r**16+134611791779*r**18+21199918102*r**20+976796535*r**22
            +7511166*r**24)-2*Q2**9*(-3523065+81257310*r**2+521730784*r**4+905666976*r**6
            -16688220869*r**8-259395491746*r**10-889089585360*r**12-1501335074144*r**14
            -1115069510419*r**16-197446468854*r**18-69870072736*r**20+4200081120*r**22
            +500959329*r**24+20554170*r**26)+2*Q2**8*(-14937585+17626212*r**2-171858972*r**4
            -5855811242*r**6-13869420993*r**8-63385840242*r**10+16612151224*r**12
            +180945486372*r**14-135765159363*r**16+110982032992*r**18+410591038788*r**20
            +69684476118*r**22+25489535653*r**24+1274710398*r**26+22006800*r**28)
            -4*Q2**7*(-3711465-10474983*r**2-16585311*r**4-3335685479*r**6-14586263971*r**8
            -24822762891*r**10+189495832471*r**12+934101876593*r**14+1594291209753*r**16
            +942342337579*r**18+692365728599*r**20+301626210435*r**22+58044089491*r**24
            +8811586919*r**26+308055825*r**28+1661715*r**30)+2*Q2**6*(2846010-48063629*r**2
            +73807366*r**4-437568519*r**6-20836737376*r**8-38220210749*r**10+62850072438*r**12
            +1095169406201*r**14+3234942689404*r**16+4244337067713*r**18+1096248229682*r**20
            +1270170663907*r**22+91705333008*r**24+44171379785*r**26-3904589422*r**28
            -318659733*r**30-9096486*r**32)+2*Q2**5*(-4444620+46913529*r**2+196475118*r**4
            -3157634592*r**6+4284558882*r**8-55107687144*r**10+27684987718*r**12
            -421683885480*r**14-16178868510*r**16-1685102837414*r**18-1909353319158*r**20
            +1724069831280*r**22-415439457242*r**24+380884320672*r**26+25334593602*r**28
            +11900568792*r**30+493904418*r**32+7103349*r**34)-2*Q2**4*(-1242720+14476290*r**2
            +255485487*r**4-1487436678*r**6+986660562*r**8-64504876242*r**10-38296698010*r**12
            -817663336382*r**14+334167797586*r**16+1872366492266*r**18-378607428116*r**20
            +199316660910*r**22+2271882595718*r**24+106309914682*r**26+291615743322*r**28
            +29987555478*r**30+5440765110*r**32+166532652*r**34+1058085*r**36)-4*Q2**3*(
            -311685+5689717*r**2-14874022*r**4-212397297*r**6+969486898*r**8+1596860872*r**10
            +11218336602*r**12+241251137732*r**14-48318975248*r**16+28951515474*r**18
            -1132476228514*r**20+899608770850*r**22-820548509538*r**24-9370007248*r**26
            -159001225522*r**28+1871859252*r**30-4503490619*r**32+458546753*r**34
            +28039968*r**36+655575*r**38)+(-1+r**2)**2*(-35445+1146853*r**2+20191623*r**4
            +9580655*r**6+1930424622*r**8-1633150128*r**10+18856083096*r**12+112978880216*r**14
            -592131066690*r**16+3073241166034*r**18-4482985442386*r**20+587730286974*r**22
            +2073376545124*r**24-1288465233960*r**26+451772078016*r**28-50395865664*r**30
            +16494013327*r**32+634389537*r**34+178938995*r**36+4942203*r**38+46998*r**40)
            +2*Q2**2*(-560910+12382053*r**2+90285306*r**4-533912437*r**6+6161778684*r**8
            -21754745316*r**10+34349697060*r**12-35796382404*r**14-283245399600*r**16
            +345030574462*r**18+587246697672*r**20-2860127322054*r**22+4546581750340*r**24
            -3589763502564*r**26+1616151735324*r**28-355106787156*r**30+99547657566*r**32
            +762812133*r**34+1773833726*r**36+64291155*r**38+876960*r**40)-Q2*(
            -325785+9011520*r**2+103727334*r**4-309894052*r**6+8688424663*r**8-24975593328*r**10
            +76998773208*r**12-12741385872*r**14-317796809874*r**16+2697275410816*r**18
            -1955733162796*r**20-1127394809784*r**22-5918491573658*r**24+10976288004704*r**26
            -6789817463496*r**28+2366866090416*r**30-392328447861*r**32+96607749696*r**34
            +1878119222*r**36+1304184892*r**38+41190243*r**40+459792*r**42))*sqrtq2))/(
            -470292480000*logq2**6*r**26*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-48988800000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -340200000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**4-157500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**6+5443200000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+11340000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2+235146240000*logq2**5*r**22*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(flagPERP*muWC*(-418037760000*logq2**6*(-Q2+(-1+r)**2)*r**24*(21
            +20*r**2-60*r**4+28*r**6+3*r**8)*(-Q2+(1+r)**2)+33177600*logq2**4*(
            -Q2+(-1+r)**2)*r**16*(-Q2+(1+r)**2)*(31740*Q2**12*r**2-120*Q2**11*(52
            +2304*r**2+2859*r**4)+6*Q2**10*(9900+171044*r**2+422713*r**4+265452*r**6)
            -10*Q2**9*(23184+213007*r**2+751100*r**4+975189*r**6+401112*r**8)+5*Q2**8*(92055
            +542802*r**2+2248359*r**4+4406066*r**6+3938904*r**8+1087038*r**10)-10*Q2**7*(46398
            +230163*r**2+853485*r**4+2130245*r**6+2979205*r**8+2037672*r**10+230472*r**12)
            +5*Q2**6*(32130+387429*r**2+711826*r**4+1029816*r**6+1495886*r**8+2200653*r**10
            +1092546*r**12-874314*r**14)+Q2**5*(105000-2292033*r**2-3864936*r**4
            +1730371*r**6+16809960*r**8+29644845*r**10+17716972*r**12+10426689*r**14
            +7660476*r**16)-5*Q2**4*(23532-394404*r**2-960705*r**4-853556*r**6+1228187*r**8
            +6771030*r**10+9078433*r**12+4015100*r**14+2469177*r**16+818046*r**18)
            -10*Q2**3*(-4770+61416*r**2-3428*r**4+935055*r**6+178810*r**8-770599*r**10
            -2137284*r**12-2240599*r**14+30168*r**16-657873*r**18+108384*r**20)
            +(-1+r**2)**2*(-3375-5306*r**2-1205229*r**4+6032210*r**6-4530386*r**8
            -2923902*r**10-1661326*r**12-2351966*r**14+2336745*r**16+1901216*r**18
            -62493*r**20+205812*r**22)+5*Q2**2*(-4914-34467*r**2-970920*r**4+3060140*r**6
            -1389810*r**8-1111140*r**10-958594*r**12-867510*r**14+58860*r**16+2526335*r**18
            -652446*r**20+495666*r**22)-5*Q2*(-2928-20817*r**2-826290*r**4+3607249*r**6
            -4312744*r**8-967602*r**10+1644232*r**12-1180630*r**14-1592604*r**16
            +164659*r**18+1790810*r**20-357675*r**22+239940*r**24))+4608*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(881112*Q2**18*r**2-48*Q2**17*(-5220+260567*r**2
            +242332*r**4)+8*Q2**16*(-336970+8894607*r**2+19096105*r**4+8082207*r**6)
            -8*Q2**15*(-1480540+26960479*r**2+96672508*r**4+95896183*r**6+23870574*r**8)
            +Q2**14*(-26451075+386543200*r**2+1954677440*r**4+2995905932*r**6+1961391975*r**8
            +289061820*r**10)-2*Q2**13*(-13548825+222137303*r**2+1227941380*r**4
            +1731677664*r**6+1812406229*r**8+1111180125*r**10+35224308*r**12)-Q2**12*(
            -4956195-408992658*r**2-878847963*r**4+7508327928*r**6+17057833023*r**8
            +8399904298*r**10+1062403047*r**12+541678872*r**14)+4*Q2**11*(-11388855
            -103779632*r**2+317933775*r**4+7147042926*r**6+20919174555*r**8+22602908600*r**10
            +8691561161*r**12+1675420530*r**14+233748588*r**16)-Q2**10*(-47861165
            -330682016*r**2+1510698438*r**4+36301020556*r**6+136088737968*r**8+221404757220*r**10
            +165915736978*r**12+41407140196*r**14+7688641253*r**16+386357004*r**18)
            +2*Q2**9*(-7817425+2404525*r**2+564237210*r**4+10970550018*r**6+39553501960*r**8
            +74459612960*r**10+91754332530*r**12+49554975670*r**14-3369450607*r**16
            +180734875*r**18-347936820*r**20)+Q2**8*(-6689925-257148174*r**2-2013550255*r**4
            -10310373844*r**6+22392560406*r**8+170702122920*r**10+317945183394*r**12
            +197343933940*r**14+114652604271*r**16+68623886166*r**18+7616078925*r**20
            +1050406896*r**22)-8*Q2**7*(-1242835-14870379*r**2-283348179*r**4-1220319907*r**6
            +4677259268*r**8+37016732668*r**10+100814110274*r**12+123175077044*r**14
            +59633686893*r**16+29775748343*r**18+7705992873*r**20+882904951*r**22
            +43353306*r**24)+Q2**6*(-13813505+87580688*r**2-880750820*r**4-2841536076*r**6
            +5251714415*r**8+143952374020*r**10+466101881328*r**12+994413689240*r**14
            +893536032573*r**16+146687249640*r**18+138952712660*r**20-7544671756*r**22
            +536637365*r**24-415034172*r**26)+2*Q2**5*(7746855-23013293*r**2-19406016*r**4
            -3526999548*r**6-1960728169*r**8-55761423525*r**10-4715413668*r**12-11654029536*r**14
            -170795187611*r**16-54804670583*r**18+188877545760*r**20+7075908476*r**22
            +24391973117*r**24+1613718249*r**26+235889892*r**28)-Q2**4*(5686575+57802250*r**2
            -5482765*r**4-5997612032*r**6-7891921805*r**8-157401230310*r**10-65022273185*r**12
            +257445336360*r**14+456454561389*r**16+76208725630*r**18+359173796905*r**20
            +373926240160*r**22+62301990705*r**24+28649746718*r**26+2146582725*r**28
            +127570680*r**30)-4*Q2**3*(1166775-10464792*r**2+40343965*r**4+52703582*r**6
            +482259187*r**8+17620213380*r**10+10995173157*r**12+11846225290*r**14
            -50392469599*r**16-103969139664*r**18+61938410095*r**20-105860472638*r**22
            +3526849945*r**24-10854538908*r**26+769310927*r**28-45403050*r**30+19512348*r**32)
            +(-1+r**2)**2*(318305+3282512*r**2+53582878*r**4+41083360*r**6+875472190*r**8
            +6965133640*r**10-38506621906*r**12+250530796256*r**14-266820273720*r**16
            -121158357080*r**18+96817547530*r**20+79786806176*r**22-48300770446*r**24
            +23162798360*r**26-549377110*r**28+736650400*r**30+29634343*r**32+2694312*r**34)
            +Q2**2*(5641815+6042776*r**2+372278666*r**4-1338799828*r**6+1701921242*r**8
            -4598627308*r**10-59206051606*r**12+141277898124*r**14-29889909744*r**16
            -148134513084*r**18-224158466354*r**20+620960986084*r**22-463422569546*r**24
            +206222372572*r**26-23535214658*r**28+10510735972*r**30+369530121*r**32
            +72744756*r**34)-2*Q2*(1106095+5797633*r**2+116152310*r**4-254094858*r**6
            +1299592530*r**8+1083855510*r**10-34911385894*r**12+225642867830*r**14
            -241979463416*r**16+25918580240*r**18-105506777530*r**20-74345225486*r**22
            +278866032510*r**24-168016089894*r**26+62059249230*r**28-5019993950*r**30
            +2284229497*r**32+84974975*r**34+11392668*r**36))-64*r**2*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**22*r**2+2*Q2**21*(4527-9848*r**2+57*r**4)
            +Q2**20*(-131472+202661*r**2+1063606*r**4-53319*r**6)+2*Q2**19*(421539
            +487631*r**2-11284137*r**4-5873199*r**6+180830*r**8)+Q2**18*(-3118767
            -15540804*r**2+142763490*r**4+244543128*r**6+57748669*r**8-1127640*r**10)
            +Q2**17*(7224003+62492280*r**2-441692045*r**4-1388455828*r**6-1076476847*r**8
            -142209604*r**10+1743033*r**12)+Q2**16*(-10413588-97668346*r**2+815041396*r**4
            +3293108280*r**6+3852467880*r**8+2023777578*r**10+122280432*r**12-449016*r**14)
            +Q2**15*(8083176-44826134*r**2-1135816004*r**4-2716524738*r**6+4079215624*r**8
            +4049840366*r**10+386181660*r**12+248270746*r**14-3254424*r**16)+2*Q2**14*(
            -383742+215557997*r**2+793310251*r**4-1131459921*r**6-24407375653*r**8
            -45456424991*r**10-22824668547*r**12-4558205359*r**14-404759093*r**16
            +2805810*r**18)+2*Q2**13*(-1496112-342466219*r**2-962817420*r**4+2979879996*r**6
            +53643600504*r**8+150724470810*r**10+151168910976*r**12+48447282036*r**14
            +7848250008*r**16+358259169*r**18-984340*r**20)-2*Q2**12*(1221792-157574066*r**2
            -538074255*r**4+2721193149*r**6+48373076556*r**8+176141374644*r**10+275535823362*r**12
            +186273197742*r**14+22554217332*r**16+1709466582*r**18-234439491*r**20
            +2601261*r**22)+2*Q2**11*(4751370+208777127*r**2+381681824*r**4+4340100035*r**6
            +12708080604*r**8-16946091158*r**10-156606209176*r**12-84284303598*r**14
            -63857914670*r**16-73359983329*r**18-11632461144*r**20-774176325*r**22
            +3638232*r**24)-2*Q2**10*(3752073+318829277*r**2+824043827*r**4+7200507735*r**6
            +444272078*r**8-191907669802*r**10-1008012726030*r**12-1648140944702*r**14
            -921879288343*r**16-443687213475*r**18-129287236373*r**20-15278351577*r**22
            -492477648*r**24+734032*r**26)-2*Q2**9*(526383-64238313*r**2-675686509*r**4
            -4187466654*r**6-4469296521*r**8+107204002209*r**10+1009647173595*r**12
            +2606883620364*r**14+2892464229357*r**16+898650786729*r**18+431631867705*r**20
            +39712692274*r**22+1525932621*r**24-323980033*r**26+2372985*r**28)+2*Q2**8*(2635812
            +180658719*r**2-672288995*r**4+2732817656*r**6+18611382846*r**8+2022748729*r**10
            +235700578031*r**12+578641045698*r**14+1531227611032*r**16+1297735543169*r**18
            -635489814837*r**20-40296381356*r**22-97358267482*r**24-12796835033*r**26
            -663988279*r**28+2299890*r**30)+Q2**7*(-2364216-303937586*r**2+1096110740*r**4
            -7766954190*r**6-75676779320*r**8-104054202874*r**10-36168487764*r**12
            +2398269703258*r**14+6821795868944*r**16+4390972417962*r**18+3774042983788*r**20
            +3314245046678*r**22+760678076328*r**24+216510146562*r**26+21652959444*r**28
            +533141598*r**30-474312*r**32)-2*Q2**6*(666966-2205982*r**2-204524305*r**4
            +620895375*r**6-16937169777*r**8-72632036253*r**10-112150943529*r**12
            +426555155319*r**14+3170686448475*r**16+6897627347415*r**18+1729705615125*r**20
            +3172699523925*r**22+515244268053*r**24+260567958545*r**26+10910160037*r**28
            -440751963*r**30-192077269*r**32+953043*r**34)+2*Q2**5*(856701+55721383*r**2
            -779067577*r**4+2963587080*r**6+6555794820*r**8-26615018744*r**10+146136708620*r**12
            -254845747248*r**14+746901505606*r**16+798038040326*r**18+6586836025074*r**20
            -4507809087032*r**22+2542494042932*r**24-1040545626944*r**26+606029084*r**28
            -48822684576*r**30-5567552891*r**32-240309877*r**34+674463*r**36)+Q2**4*(
            -425328-50847257*r**2+960278004*r**4-2709404943*r**6-10736579696*r**8
            +22841398100*r**10-521395517256*r**12+329843162836*r**14-3478764558496*r**16
            +4366099432842*r**18+5492586610064*r**20-11954158323442*r**22+14435567418576*r**24
            -2489157861804*r**26+1924649935464*r**28+174177529764*r**30+61432232880*r**32
            +5847856359*r**34+135698268*r**36-162935*r**38)-2*Q2**3*(130629+3502098*r**2
            -62824545*r**4+487828716*r**6-181178078*r**8+1320457844*r**10-53097976068*r**12
            +52128465444*r**14-1471202932218*r**16+1426248688488*r**18+813220414370*r**20
            +729108677052*r**22-812921053248*r**24+1056207483788*r**26+577297239628*r**28
            +17965254252*r**30+49208708493*r**32-80744826*r**34-190157961*r**36-32140088*r**38
            +124230*r**40)+2*(-1+r**2)**2*(3270+255858*r**2-12908701*r**4+23673736*r**6
            -403810881*r**8-3209458014*r**10+8694900708*r**12-51088387332*r**14-108754209488*r**16
            +956032198568*r**18-4610254072398*r**20+9070915454188*r**22-7911295335958*r**24
            +3586289799768*r**26-1025435066268*r**28+159645330708*r**30-30746648382*r**32
            -712950634*r**34-457634141*r**36-39079044*r**38-1017441*r**40+1878*r**42)
            +Q2**2*(216297+13127766*r**2-402286580*r**4+1501548566*r**6-2740912121*r**8
            -30714276184*r**10+169971276120*r**12-356225213664*r**14+394129729298*r**16
            +2119399568284*r**18-7651469740624*r**20+18099691813980*r**22-27744560828282*r**24
            +23663463335456*r**26-11378630339480*r**28+3171348788112*r**30-699327809259*r**32
            +25073274526*r**34-14122365820*r**36-1484641058*r**38-60659101*r**40
            +153768*r**42)+Q2*(-61149-4329426*r**2+178172107*r**4-629487600*r**6
            +3405530533*r**8+23546013282*r**10-125645425083*r**12+451838664640*r**14
            -690524849650*r**16+1632651625836*r**18-4282596656962*r**20+22731650897120*r**22
            -54344263132902*r**24+56571398500900*r**26-30769924587846*r**28+10148913388224*r**30
            -2027207192737*r**32+360870688006*r**34-3510692025*r**36+5738334352*r**38
            +568125105*r**40+18193626*r**42-38351*r**44))+995328000*logq2**5*r**20*(1470*Q2**9*r**2
            -30*Q2**8*(16+269*r**2+469*r**4)+20*Q2**7*(80+963*r**2+3193*r**4+2835*r**6)
            -4*Q2**6*(-560+5108*r**2+27941*r**4+51485*r**6+31164*r**8)+Q2**5*(-14175
            -4178*r**2+66926*r**4+274664*r**6+350721*r**8+155526*r**10)+Q2**4*(15295
            +29975*r**2+28974*r**4-114182*r**6-336625*r**8-325213*r**10-88200*r**12)
            +2*Q2**3*(5845-28990*r**2-20683*r**4+12156*r**6+38939*r**8+88206*r**10
            +68411*r**12-14700*r**14)+(-1+r**2)**2*(-8845+29033*r**2-61211*r**4
            +6549*r**6+40863*r**8-62737*r**10+5275*r**12+9619*r**14+11214*r**16)
            +2*Q2**2*(-19425+49690*r**2-28073*r**4-10430*r**6-4411*r**8-26830*r**10
            -1387*r**12-5334*r**14+41160*r**16)+Q2*(31525-106148*r**2+199688*r**4
            +103312*r**6-183422*r**8-12076*r**10+133552*r**12-5864*r**14+11297*r**16
            -50904*r**18))*sqrtq2+552960*logq2**3*r**12*(248850*Q2**17*r**2-6*Q2**16*(
            -544+545175*r**2+583995*r**4)+4*Q2**15*(-10686+4750989*r**2+10086065*r**4
            +5442615*r**6)-4*Q2**14*(-60030+15975642*r**2+49888335*r**4+53970295*r**6
            +19260180*r**8)+Q2**13*(-652065+137056232*r**2+547782922*r**4+862762500*r**6
            +642089015*r**8+164276280*r**10)-Q2**12*(-650565+196619453*r**2+891214784*r**4
            +1687800558*r**6+1843211095*r**8+1101621305*r**10+190750770*r**12)+2*Q2**11*(419184
            +98623011*r**2+409398136*r**4+649943801*r**6+645504116*r**8+705770289*r**10
            +448761980*r**12+12950595*r**14)+2*Q2**10*(-1525374-75692498*r**2-136738925*r**4
            +499653690*r**6+2106554875*r**8+2625943102*r**10+1096770121*r**12+160272890*r**14
            +141423975*r**16)-Q2**9*(-3372735-99945286*r**2+243828180*r**4+3201083840*r**6
            +10951477410*r**8+18469757600*r**10+16288456764*r**12+6458617720*r**14
            +1602225165*r**16+435173310*r**18)+Q2**8*(-2254095-46370889*r**2+356084176*r**4
            +3278834680*r**6+10940769670*r**8+21768852350*r**10+27149514556*r**12
            +19323504656*r**14+5498283825*r**16+1612280595*r**18+219686940*r**20)
            +4*Q2**7*(841080-3401136*r**2-54562433*r**4-613688566*r**6-1454692080*r**8
            -2417468120*r**10-3244154146*r**12-3597584208*r**14-1992952696*r**16
            +328454160*r**18-124376685*r**20+38183310*r**22)-4*Q2**6*(1469382-12173214*r**2
            -21497474*r**4-590280919*r**6-807510859*r**8-140892102*r**10+1503996916*r**12
            +2572476136*r**14+1436387456*r**16+1244084116*r**18+1663907262*r**20
            +102253055*r**22+75614805*r**24)+Q2**5*(4684653-38081076*r**2-15714470*r**4
            -2115516820*r**6-2446466765*r**8-1058003732*r**10+5530939388*r**12+14713549400*r**14
            +18029233235*r**16+9169373860*r**18+7435900874*r**20+5192174748*r**22
            +504533485*r**24+168017220*r**26)+(-1+r**2)**4*(108339-188653*r**2+1409964*r**4
            +17362110*r**6-188625955*r**8+1212689517*r**10-920977454*r**12-819389068*r**14
            -94120515*r**16+268297885*r**18+364123944*r**20-100855218*r**22+76217779*r**24
            +1337955*r**26+1169370*r**28)+Q2**4*(47895+7231657*r**2-1765680*r**4
            +1026133970*r**6+105676005*r**8+2597160275*r**10-1168252514*r**12-4961085780*r**14
            -6701340015*r**16-7684713585*r**18+753959380*r**20-4928369918*r**22-335039565*r**24
            -262182155*r**26+9564030*r**28)-Q2*(-1+r**2)**2*(803979-2373214*r**2
            +8449241*r**4+35695824*r**6-880989625*r**8+4930757362*r**10-2399337467*r**12
            -3742023792*r**14-1732784623*r**16-763199690*r**18+917471659*r**20+2589475056*r**22
            -990761699*r**24+566533174*r**26+125815*r**28+10638000*r**30)-2*Q2**3*(1488420
            -5329891*r**2+7851024*r**4+68121715*r**6-866768520*r**8+2876152905*r**10
            -1666672828*r**12-1973284713*r**14-696618140*r**16-143756585*r**18-532052760*r**20
            +4194676569*r**22-2348086336*r**24+1108233475*r**26-56877820*r**28+32923485*r**30)
            +2*Q2**2*(1173870-5104614*r**2+12598783*r**4-16136514*r**6-857224605*r**8
            +4478585890*r**10-4353126997*r**12-414788266*r**14-522832757*r**16-423067410*r**18
            -697510195*r**20-1867844454*r**22+4539966633*r**24-2175430954*r**26+858214665*r**28
            -28591790*r**30+19598715*r**32))*sqrtq2+384*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(20598*Q2**21*r**2-6*Q2**20*(-14800+110817*r**2+48657*r**4)
            +12*Q2**19*(-81020+429860*r**2+786457*r**4+144360*r**6)-4*Q2**18*(-1129140
            +4698553*r**2+17983292*r**4+13251612*r**6+1357125*r**8)+Q2**17*(-10975155
            +40805244*r**2+239075718*r**4+267166828*r**6+140780445*r**8+8542980*r**10)
            +Q2**16*(12241215-72156519*r**2-391550736*r**4+173169526*r**6+240743147*r**8
            -107524827*r**10-1118502*r**12)-4*Q2**15*(-1165755-36799237*r**2-76247941*r**4
            +1147665975*r**6+2443518349*r**8+1125179473*r**10+97841799*r**12+5405793*r**14)
            +6*Q2**14*(-5523430-47296645*r**2-24119282*r**4+2394134421*r**6+7600109356*r**8
            +7578246829*r**10+2255947690*r**12+201903163*r**14+6278490*r**16)-12*Q2**13*(
            -3107760-29347138*r**2-6665627*r**4+1740322188*r**6+7322957831*r**8
            +11290684494*r**10+7452772375*r**12+1292795448*r**14+93830373*r**16+1079400*r**18)
            +Q2**12*(2229240-179511782*r**2+674020676*r**4+15820018380*r**6+60438769828*r**8
            +77227590488*r**10+93808149564*r**12+47111816980*r**14-7506684604*r**16
            -750261330*r**18-41315040*r**20)+4*Q2**11*(-11146005-31552419*r**2-575312853*r**4
            -2133015385*r**6+9159358092*r**8+87677333118*r**10+155353444136*r**12
            +86797134654*r**14+32886162969*r**16+10730621741*r**18+676990509*r**20
            +15227667*r**22)-2*Q2**10*(-18459870-129086889*r**2-1369636110*r**4-3883224661*r**6
            +37998501814*r**8+368288521014*r**10+960447800072*r**12+1020102784462*r**14
            +414047266746*r**16+134611791779*r**18+21199918102*r**20+976796535*r**22
            +7511166*r**24)-2*Q2**9*(-3523065+81257310*r**2+521730784*r**4+905666976*r**6
            -16688220869*r**8-259395491746*r**10-889089585360*r**12-1501335074144*r**14
            -1115069510419*r**16-197446468854*r**18-69870072736*r**20+4200081120*r**22
            +500959329*r**24+20554170*r**26)+2*Q2**8*(-14937585+17626212*r**2-171858972*r**4
            -5855811242*r**6-13869420993*r**8-63385840242*r**10+16612151224*r**12
            +180945486372*r**14-135765159363*r**16+110982032992*r**18+410591038788*r**20
            +69684476118*r**22+25489535653*r**24+1274710398*r**26+22006800*r**28)
            -4*Q2**7*(-3711465-10474983*r**2-16585311*r**4-3335685479*r**6-14586263971*r**8
            -24822762891*r**10+189495832471*r**12+934101876593*r**14+1594291209753*r**16
            +942342337579*r**18+692365728599*r**20+301626210435*r**22+58044089491*r**24
            +8811586919*r**26+308055825*r**28+1661715*r**30)+2*Q2**6*(2846010-48063629*r**2
            +73807366*r**4-437568519*r**6-20836737376*r**8-38220210749*r**10+62850072438*r**12
            +1095169406201*r**14+3234942689404*r**16+4244337067713*r**18+1096248229682*r**20
            +1270170663907*r**22+91705333008*r**24+44171379785*r**26-3904589422*r**28
            -318659733*r**30-9096486*r**32)+2*Q2**5*(-4444620+46913529*r**2+196475118*r**4
            -3157634592*r**6+4284558882*r**8-55107687144*r**10+27684987718*r**12
            -421683885480*r**14-16178868510*r**16-1685102837414*r**18-1909353319158*r**20
            +1724069831280*r**22-415439457242*r**24+380884320672*r**26+25334593602*r**28
            +11900568792*r**30+493904418*r**32+7103349*r**34)-2*Q2**4*(-1242720+14476290*r**2
            +255485487*r**4-1487436678*r**6+986660562*r**8-64504876242*r**10-38296698010*r**12
            -817663336382*r**14+334167797586*r**16+1872366492266*r**18-378607428116*r**20
            +199316660910*r**22+2271882595718*r**24+106309914682*r**26+291615743322*r**28
            +29987555478*r**30+5440765110*r**32+166532652*r**34+1058085*r**36)-4*Q2**3*(
            -311685+5689717*r**2-14874022*r**4-212397297*r**6+969486898*r**8+1596860872*r**10
            +11218336602*r**12+241251137732*r**14-48318975248*r**16+28951515474*r**18
            -1132476228514*r**20+899608770850*r**22-820548509538*r**24-9370007248*r**26
            -159001225522*r**28+1871859252*r**30-4503490619*r**32+458546753*r**34
            +28039968*r**36+655575*r**38)+(-1+r**2)**2*(-35445+1146853*r**2+20191623*r**4
            +9580655*r**6+1930424622*r**8-1633150128*r**10+18856083096*r**12+112978880216*r**14
            -592131066690*r**16+3073241166034*r**18-4482985442386*r**20+587730286974*r**22
            +2073376545124*r**24-1288465233960*r**26+451772078016*r**28-50395865664*r**30
            +16494013327*r**32+634389537*r**34+178938995*r**36+4942203*r**38+46998*r**40)
            +2*Q2**2*(-560910+12382053*r**2+90285306*r**4-533912437*r**6+6161778684*r**8
            -21754745316*r**10+34349697060*r**12-35796382404*r**14-283245399600*r**16
            +345030574462*r**18+587246697672*r**20-2860127322054*r**22+4546581750340*r**24
            -3589763502564*r**26+1616151735324*r**28-355106787156*r**30+99547657566*r**32
            +762812133*r**34+1773833726*r**36+64291155*r**38+876960*r**40)-Q2*(
            -325785+9011520*r**2+103727334*r**4-309894052*r**6+8688424663*r**8-24975593328*r**10
            +76998773208*r**12-12741385872*r**14-317796809874*r**16+2697275410816*r**18
            -1955733162796*r**20-1127394809784*r**22-5918491573658*r**24+10976288004704*r**26
            -6789817463496*r**28+2366866090416*r**30-392328447861*r**32+96607749696*r**34
            +1878119222*r**36+1304184892*r**38+41190243*r**40+459792*r**42))*sqrtq2))/(
            -1410877440000*logq2**6*r**26*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-146966400000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -1020600000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4-472500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**6+16329600000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+34020000*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2+705438720000*logq2**5*r**22*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(flagPERP*(104509440000*logq2**6*(-Q2+(-1+r)**2)*r**24*(3
            +20*r**4-56*r**6+9*r**8)*(-Q2+(1+r)**2)-8294400*logq2**4*(-Q2+(-1
            +r)**2)*r**16*(-Q2+(1+r)**2)*(-13260*Q2**12*r**2+60*Q2**11*(40+2238*r**2
            +1959*r**4)-6*Q2**10*(4300+99468*r**2+166571*r**4+70764*r**6)+20*Q2**9*(5320
            +75526*r**2+178311*r**4+146971*r**6+38799*r**8)-5*Q2**8*(41775+454008*r**2
            +1346469*r**4+1599112*r**6+837648*r**8+145368*r**10)+10*Q2**7*(16140
            +179682*r**2+635805*r**4+1009580*r**6+801145*r**8+286020*r**10+46008*r**12)
            -10*Q2**6*(-9765+25368*r**2+51105*r**4+338080*r**6+549977*r**8+440226*r**10
            +137529*r**12+85806*r**14)+2*Q2**5*(-145950-355872*r**2-2787054*r**4
            -3031231*r**6-1202400*r**8+2226030*r**10+2835008*r**12+1194921*r**14
            +786024*r**16)-5*Q2**4*(-37320-119136*r**2-1110951*r**4-1531468*r**6
            -1043807*r**8+418104*r**10+2344655*r**12+1523788*r**14+656919*r**16
            +209736*r**18)-20*Q2**3*(-1500+23193*r**2+22344*r**4+233727*r**6+106571*r**8
            -104556*r**10-499797*r**12-497963*r**14-5175*r**16-110697*r**18+23673*r**20)
            +10*Q2**2*(-9765+53544*r**2-343110*r**4+644296*r**6-142215*r**8-217770*r**10
            -185387*r**12-573450*r**14-242136*r**16+874090*r**18-122715*r**20+113418*r**22)
            +(-1+r**2)**2*(-7925+64002*r**2-644137*r**4+2092860*r**6-501548*r**8
            -14416*r**10+1553052*r**12-405848*r**14+305105*r**16+1974638*r**18-7619*r**20
            +127836*r**22)-10*Q2*(-4770+34320*r**2-287841*r**4+805951*r**6-521110*r**8
            -364818*r**10+955666*r**12+1102928*r**14-243846*r**16-406190*r**18+759863*r**20
            -80031*r**22+64278*r**24))-1152*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-556584*Q2**18*r**2+24*Q2**17*(-6440+323208*r**2+306463*r**4)
            -8*Q2**16*(-206850+5519389*r**2+11628335*r**4+5174919*r**6)+16*Q2**15*(
            -453390+8198464*r**2+29667243*r**4+28688323*r**6+7989399*r**8)-Q2**14*(
            -15560475+202083880*r**2+1220893040*r**4+1833745864*r**6+1181704395*r**8
            +225561240*r**10)+2*Q2**13*(-5645325+43616511*r**2+717343940*r**4+1230354128*r**6
            +1303767993*r**8+779996385*r**10+94366656*r**12)+Q2**12*(-21123795+215895094*r**2
            +268889069*r**4+4014555896*r**6+6997825091*r**8+2134796386*r**10-510499101*r**12
            +59589024*r**14)-4*Q2**11*(-14212275+86070211*r**2+743035225*r**4+4686585867*r**6
            +11081489235*r**8+9824682745*r**10+3123228847*r**12+360722385*r**14+78294696*r**16)
            +Q2**10*(-39352005+41037548*r**2+3285943206*r**4+23975557532*r**6+82036551836*r**8
            +111640348140*r**10+68855674586*r**12+16275034772*r**14+2141869801*r**16
            +285317208*r**18)-2*Q2**9*(15644475-159295005*r**2+299102910*r**4+1564699086*r**6
            +23439363700*r**8+50040687620*r**10+51591022530*r**12+24569424530*r**14
            +2959354561*r**16+549580505*r**18+16391760*r**20)-Q2**8*(-72689925+241774542*r**2
            +1376541385*r**4+23642841412*r**6+53046035202*r**8+80273670480*r**10
            +65852812518*r**12+5296665100*r**14-1699708733*r**16+5042504322*r**18
            -160900335*r**20+132289872*r**22)+8*Q2**7*(-4477935-12549833*r**2+113135397*r**4
            +2869845901*r**6+12111514456*r**8+27782911496*r**10+40552191738*r**12
            +27367406188*r**14+7124939001*r**16+1485846481*r**18+625020601*r**20
            +805847*r**22+13167702*r**24)-Q2**6*(22941975-222773024*r**2+320246860*r**4
            +1186948608*r**6+42075249355*r**8+123826787000*r**10+253894842256*r**12
            +302901668880*r**14+128639342541*r**16+31928011680*r**18+5192478500*r**20
            +3260490288*r**22+390413905*r**24+33194376*r**26)+2*Q2**5*(17956365-41277559*r**2
            +323114312*r**4-5311848084*r**6-7966543787*r**8-13823328875*r**10-38085421224*r**12
            +36373118112*r**14+58882418407*r**16+19450066291*r**18+33943885680*r**20
            +8402339828*r**22+2995570871*r**24+427633647*r**26+3519216*r**28)+Q2**4*(
            -12569025-42558630*r**2-532283765*r**4+5857073536*r**6+20006350895*r**8
            +34234549530*r**10+191812969715*r**12+100524001040*r**14-70382940747*r**16
            -93491962450*r**18-82418789815*r**20-95990523760*r**22-24050384675*r**24
            -5151956514*r**26-571345095*r**28+1409760*r**30)-4*Q2**3*(1243725-12088901*r**2
            +33945405*r**4-197600789*r**6+1481269421*r**8+1734068835*r**10+12345396741*r**12
            +16114316675*r**14-14472290177*r**16-38680880487*r**18+1084023295*r**20
            -28955989079*r**22-2626870105*r**24-2641517559*r**26+73361791*r**28+12920745*r**30
            +2530464*r**32)+(-1+r**2)**2*(246015+536676*r**2+32866994*r**4-76476220*r**6
            +175415270*r**8+9083955020*r**10-45076434838*r**12+107812661588*r**14
            +2554205940*r**16-117106438140*r**18+3423157590*r**20+86477254348*r**22
            -27968873558*r**24+12315091780*r**26+668521870*r**28+322313500*r**30
            +20632189*r**32+563976*r**34)+Q2**2*(5835585-16402172*r**2+385462518*r**4
            -2053395604*r**6+1536932986*r**8+27486858996*r**10-116893034098*r**12
            +168733564812*r**14-98504943492*r**16-29664224772*r**18-184808077822*r**20
            +263810299812*r**22-154780905578*r**24+66730605596*r**26+491409786*r**28
            +2847158116*r**30+251116083*r**32+9739248*r**34)-2*Q2*(987525-952091*r**2
            +95622530*r**4-441681714*r**6+600269490*r**8+14843714010*r**10-78143641962*r**12
            +165889979990*r**14-93319820228*r**16+36498450420*r**18-1688578270*r**20
            -108839318678*r**22+176852299230*r**24-73189265802*r**26+24791391090*r**28
            +519434610*r**30+787021231*r**32+60572375*r**34+1916244*r**36))+16*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**22+Q2**21*(9168+5492*r**2)
            -Q2**20*(149367+1710440*r**2+145885*r**4)+2*Q2**19*(166081+11225142*r**2
            +11373357*r**4+513816*r**6)-4*Q2**18*(-500241+29074056*r**2+68728671*r**4
            +32028984*r**6+949307*r**8)+2*Q2**17*(-5615008+146448803*r**2+643844310*r**4
            +678188618*r**6+190108966*r**8+4125635*r**10)-4*Q2**16*(-3973359+74266084*r**2
            +679947566*r**4+1166558084*r**6+813909434*r**8+142704876*r**10+2477669*r**12)
            +2*Q2**15*(11775989-110636094*r**2+664396723*r**4+951187330*r**6+1749762163*r**8
            +1506240170*r**10+59782461*r**12+1513106*r**14)+2*Q2**14*(-55171233+425567014*r**2
            +2711053775*r**4+12958211190*r**6+21658743637*r**8+9739250642*r**10+1595151489*r**12
            +544099234*r**14+4360652*r**16)-2*Q2**13*(-64251489+244237704*r**2+5532279198*r**4
            +32275758294*r**6+86358159924*r**8+82047028890*r**10+28156092330*r**12
            +5697080754*r**14+880213701*r**16+5410358*r**18)+Q2**12*(32404320-689625728*r**2
            +6029515422*r**4+40568180232*r**6+219931592136*r**8+336188308392*r**10
            +225093896652*r**12+50076188856*r**14+10603021032*r**16+512577624*r**18
            -2528058*r**20)+2*Q2**11*(-115033373+399321098*r**2+2210312267*r**4+31587831686*r**6
            +31061512558*r**8+34431825288*r**10-6092006098*r**12-19785079664*r**14
            +9780730671*r**16+148443454*r**18+792861927*r**20+7594938*r**22)-2*Q2**10*(
            -93871869-301375562*r**2+3319994183*r**4+57918106482*r**6+221297158884*r**8
            +548728816820*r**10+745806838042*r**12+376195573260*r**14+111602538743*r**16
            +34133271638*r**18+4291667039*r**20+952597698*r**22+5111938*r**24)+2*Q2**9*(35349973
            -660880954*r**2+1254992504*r**4+13592393802*r**6+188409941901*r**8+595751483472*r**10
            +1400248406784*r**12+1275737968812*r**14+420777203271*r**16+112212418766*r**18
            +17786796808*r**20+3853561546*r**22+74351511*r**24-2393252*r**26)+2*Q2**8*(
            -108253049+118145044*r**2-1124814378*r**4+38306461532*r**6+18754759225*r**8
            +173212341792*r**10-500295246472*r**12-989355332216*r**14-692859876855*r**16
            -17789612956*r**18-28297635746*r**20+5682638556*r**22-1939300841*r**24
            +618754856*r**26+5264308*r**28)-2*Q2**7*(-54052263-448577294*r**2-1520978173*r**4
            +28731627586*r**6+112888864569*r**8+706645991774*r**10+929096410339*r**12
            +1001121957078*r**14+418146169379*r**16+16355794270*r**18+193861735857*r**20
            +135446846*r**22+5076541451*r**24-433805614*r**26+430061097*r**28+2026538*r**30)
            +2*Q2**6*(26086756-338891526*r**2+444452537*r**4-9932112558*r**6+69997798893*r**8
            +300770174994*r**10+915081187041*r**12+1489407656154*r**14+1687384602261*r**16
            +547655973486*r**18-13794033501*r**20+77006155926*r**22+1117169999*r**24
            -1921129978*r**26+1260136771*r**28-59789634*r**30-1335221*r**32)+2*Q2**5*(
            -41065221-30301762*r**2-2100878558*r**4+19379453494*r**6-37887938426*r**8
            +262142876010*r**10-288763677838*r**12+154465718158*r**14-604942387500*r**16
            -650739335506*r**18-222381517226*r**20-50316474078*r**22-61839285638*r**24
            -28061823154*r**26-913977578*r**28-2037242598*r**30+205606193*r**32+1540828*r**34)
            +Q2**4*(27030983+281559096*r**2+2329355103*r**4-8747645416*r**6+40739366524*r**8
            -535300669288*r**10+403110641524*r**12-1808455964520*r**14-1432781657230*r**16
            +955373106632*r**18+122065779642*r**20+994249714184*r**22+578840269196*r**24
            +246283782728*r**26+66968062644*r**28+8072207688*r**30+1963310271*r**32
            -157780704*r**34-693057*r**36)-4*Q2**3*(-2393664+28989864*r**2-155289084*r**4
            +2427128335*r**6-6125332244*r**8-451871134*r**10+21267853224*r**12-132493087338*r**14
            -254737602684*r**16+394463082666*r**18-13968192200*r**20+181366227780*r**22
            +40316224628*r**24+110206678118*r**26+21963685960*r**28+2782514298*r**30
            +999139932*r**32-155130906*r**34+9843156*r**36+123293*r**38)+2*(-1
            +r**2)**2*(-190141-1529518*r**2-33679497*r**4+9807032*r**6-1746945342*r**8
            +6647955444*r**10-39233655776*r**12-41613662324*r**14+844981789254*r**16
            -3200025798184*r**18+4808873592694*r**20-3353175039444*r**22+1172325161764*r**24
            -289357902804*r**26+26173110744*r**28-10693057756*r**30-1369313137*r**32
            -113407818*r**34-30256357*r**36+935532*r**38+5634*r**40)+2*Q2**2*(-5256619
            -1096858*r**2-569910819*r**4+3574594202*r**6-23996575640*r**8+106537748288*r**10
            -268025666192*r**12+237211890976*r**14+208084980498*r**16-175106578276*r**18
            +1047462497634*r**20-2262696717692*r**22+2130463827880*r**24-852248583952*r**26
            +143057076472*r**28-47330360656*r**30-10657058383*r**32-95706162*r**34
            -538547623*r**36+25490194*r**38+192728*r**40)-2*Q2*(-1647815-6079975*r**2
            -224696078*r**4+905703860*r**6-11449882667*r**8+57888034035*r**10-231966314240*r**12
            +211288930984*r**14+1134859600730*r**16-3216199321134*r**18-86321246700*r**20
            +6808527240080*r**22-7559948172934*r**24+3468174980510*r**26-972610147056*r**28
            +129588947480*r**30-38974080115*r**32-6566340347*r**34-280835350*r**36
            -221131268*r**38+8084625*r**40+53375*r**42))+248832000*logq2**5*r**20*(420*Q2**9*r**2
            -60*Q2**8*(8+51*r**2+37*r**4)+40*Q2**7*(96+281*r**2+328*r**4+45*r**6)
            +4*Q2**6*(-3360-6676*r**2-8487*r**4-1690*r**6+2877*r**8)+Q2**5*(24675
            +44164*r**2+44222*r**4+19828*r**6-50433*r**8-32928*r**10)+Q2**4*(-21315
            -47095*r**2-28212*r**4-23434*r**6+49925*r**8+104449*r**10+27090*r**12)
            +2*Q2**3*(-105+17105*r**2+3224*r**4+7017*r**6-23847*r**8-36323*r**10
            -32108*r**12+9345*r**14)-(-1+r**2)**2*(-2985+7299*r**2+5207*r**4-35113*r**6
            +43049*r**8+48649*r**10-24515*r**12+9277*r**14+9612*r**16)-2*Q2**2*(
            -8085+16460*r**2+1611*r**4-17045*r**6+6832*r**8+7890*r**10-25141*r**12
            +1203*r**14+26355*r**16)+Q2*(-12225+33014*r**2-4784*r**4-97176*r**6
            +51266*r**8+200968*r**10+101904*r**12-68368*r**14-641*r**16+37962*r**18))*sqrtq2
            -138240*logq2**3*r**12*(-126720*Q2**17*r**2+12*Q2**16*(-64+148560*r**2+138255*r**4)
            -4*Q2**15*(-9402+2776908*r**2+5100805*r**4+2401605*r**6)+8*Q2**14*(-42285
            +4951722*r**2+13565140*r**4+12643185*r**6+4002255*r**8)-Q2**13*(-1363635
            +86687004*r**2+319732814*r**4+437695680*r**6+280496045*r**8+66584340*r**10)
            +Q2**12*(-2802555+111962901*r**2+542290348*r**4+945654486*r**6+904945125*r**8
            +465384085*r**10+86140890*r**12)-2*Q2**11*(-1092252+29218287*r**2+219760557*r**4
            +405974987*r**6+486509332*r**8+451858283*r**10+223847415*r**12+30432915*r**14)
            +2*Q2**10*(1385538-29861319*r**2-68113660*r**4-387181820*r**6-737442725*r**8
            -445060159*r**10+52256838*r**12+99728830*r**14+2599965*r**16)+Q2**9*(
            -8500965+136135098*r**2+715457180*r**4+2772737440*r**6+5644372370*r**8
            +6002352080*r**10+3224455148*r**12+684729560*r**14+22868715*r**16+33361470*r**18)
            -Q2**8*(-7365105+96724917*r**2+686589312*r**4+2903638200*r**6+6505159010*r**8
            +8811795550*r**10+7201188432*r**12+3278624872*r**14+814095615*r**16+77257485*r**18
            +41483520*r**20)+4*Q2**7*(269940-682623*r**2+38800926*r**4+259603572*r**6
            +498137280*r**8+958477090*r**10+1311563782*r**12+1116769876*r**14+548184932*r**16
            +250108425*r**18+28823820*r**20+10983420*r**22)-4*Q2**6*(1881726-14621547*r**2
            -58707772*r**4-128619222*r**6-667206707*r**8-751627606*r**10-190050502*r**12
            +697344318*r**14+912065228*r**16+595598293*r**18+375456966*r**20+49347500*r**22
            +10823805*r**24)+Q2**5*(5889849-43983528*r**2-211838870*r**4-668278800*r**6
            -2924363345*r**8-3824050776*r**10-2187239636*r**12+1501306400*r**14+4609291255*r**16
            +3553121880*r**18+2570294762*r**20+1192988944*r**22+184693665*r**24+22120200*r**26)
            +(-1+r**2)**4*(52467-214959*r**2-513578*r**4+24544170*r**6-126468135*r**8
            +333630851*r**10+143760988*r**12-186943764*r**14-290848075*r**16+152935495*r**18
            +307080582*r**20-41295254*r**22+44394367*r**24+2264805*r**26+500040*r**28)
            +Q2**4*(-638505+6880251*r**2+44455100*r**4+448931430*r**6+397599665*r**8
            +1914277805*r**10+7020098*r**12-2100059420*r**14-3651324935*r**16-3341122955*r**18
            +201357400*r**20-1839597674*r**22+74905695*r**24-69432445*r**26+8060490*r**28)
            -Q2*(-1+r**2)**2*(435207-2268252*r**2-4712327*r**4+151262062*r**6-772834785*r**8
            +1742771556*r**10+291253569*r**12-141006026*r**14+67038701*r**16-528832500*r**18
            +306950227*r**20+1870194058*r**22-383056147*r**24+289189612*r**26+12642035*r**28
            +4013010*r**30)-2*Q2**3*(960120-5602773*r**2-11544763*r**4+233427435*r**6
            -847334440*r**8+1409551585*r**10-428587659*r**12-648258219*r**14-404094200*r**16
            -558440195*r**18-617977625*r**20+2218890357*r**22-815882968*r**24+459359415*r**26
            +5504735*r**28+10029195*r**30)+2*Q2**2*(709710-4630407*r**2-5798076*r**4
            +192173588*r**6-1015157385*r**8+2272016695*r**10-1191508706*r**12+317702*r**14
            +757734969*r**16+1316552935*r**18-15793960*r**20-1505521512*r**22+2545158449*r**24
            -831291607*r**26+372854150*r**28+8703630*r**30+6519825*r**32))*sqrtq2
            +96*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(41196*Q2**21*r**2
            -12*Q2**20*(-1480+57537*r**2+57537*r**4)+120*Q2**19*(-1538+36356*r**2
            +93839*r**4+39453*r**6)-4*Q2**18*(-197020+3429590*r**2+17022939*r**4
            +17758976*r**6+4374255*r**8)+Q2**17*(-1611705+21307800*r**2+196865022*r**4
            +326801204*r**6+226422315*r**8+36585180*r**10)-Q2**16*(-825285+8328699*r**2
            +243045288*r**4+271652546*r**6+393855835*r**8+353632323*r**10+35295714*r**12)
            -2*Q2**15*(-1691530+8632397*r**2+47034651*r**4+1203624515*r**6+2322591946*r**8
            +888276297*r**10-27952759*r**12+9161007*r**14)+6*Q2**14*(-1276570+306365*r**2
            +107405990*r**4+1468114024*r**6+4369816345*r**8+4133678157*r**10+1278770820*r**12
            +132717130*r**14+15579195*r**16)-6*Q2**13*(-694360-9541905*r**2+108142642*r**4
            +1891948324*r**6+8996254464*r**8+13405058556*r**10+8681955634*r**12+1980123832*r**14
            +229100148*r**16+14985465*r**18)+Q2**12*(7231640-45106750*r**2+147589494*r**4
            -510307928*r**6+31590484676*r**8+63259793076*r**10+72748902136*r**12
            +42509817224*r**14+5135819268*r**16+692981210*r**18-25514190*r**20)+2*Q2**11*(
            -6692790-43045977*r**2-138804633*r**4+9040529951*r**6+31325757150*r**8
            +94929285204*r**10+132949671332*r**12+57641585244*r**14+10260629376*r**16
            +4505870285*r**18+355067277*r**20+63349533*r**22)-2*Q2**10*(-2475330
            -80127723*r**2-427329540*r**4+8482224308*r**6+62173944523*r**8+237632761038*r**10
            +504894152264*r**12+446597123224*r**14+157735353072*r**16+33855112253*r**18
            +6979631884*r**20+627808500*r**22+42879447*r**24)+2*Q2**9*(4015635-17649645*r**2
            -80633610*r**4-1824953034*r**6+29923651135*r**8+140347883043*r**10+544580901140*r**12
            +778778866780*r**14+486715657641*r**16+108009326625*r**18+22472141078*r**20
            +2820445950*r**22+299041125*r**24-17911335*r**26)+2*Q2**8*(-5095155-64812390*r**2
            -726733239*r**4+7729275950*r**6+19926490149*r**8+145558773576*r**10+76967287949*r**12
            -135228948996*r**14-279692483433*r**16-138804933646*r**18+24195819291*r**20
            -3024656826*r**22+968352551*r**24+82666044*r**26+42145695*r**28)-2*Q2**7*(
            -1141230-61180425*r**2-771079923*r**4+3106696853*r**6+26175882046*r**8
            +242266876761*r**10+592831687421*r**12+912351757243*r**14+868180549830*r**16
            +280334574881*r**18+70627874791*r**20+55988355171*r**22-628241398*r**24
            +1023832399*r**26+176923695*r**28+16904205*r**30)+2*Q2**6*(1923590-152827*r**2
            +31246698*r**4-2840959408*r**6+8847417085*r**8+65995782819*r**10+378992755352*r**12
            +759043973518*r**14+1225994189751*r**16+848962846475*r**18+178485168418*r**20
            +17273411172*r**22+24761709059*r**24+567468397*r**26+703397820*r**28
            +117341918*r**30-10364637*r**32)+2*Q2**5*(-1687020-30111117*r**2-526241814*r**4
            +3031195536*r**6-5399320116*r**8+87944018802*r**10-73099714*r**12+85799140020*r**14
            -12540830160*r**16-548859502468*r**18-205049783706*r**20-196227938040*r**22
            -67969411444*r**24-38817508986*r**26-8582403726*r**28-1238044236*r**30
            -53687964*r**32+12470553*r**34)+2*Q2**4*(309480+16643565*r**2+303501675*r**4
            -468666468*r**6+6072438630*r**8-72665356764*r**10-49742477450*r**12-222911612740*r**14
            -809622560514*r**16+56447378230*r**18+316674193628*r**20+117897252180*r**22
            +397604133970*r**24+157953921812*r**26+45568320090*r**28+9012406356*r**30
            +894533730*r**32+1524645*r**34-2924055*r**36)-2*Q2**3*(-289910-474605*r**2
            -31915293*r**4+714305651*r**6-771979178*r**8-2462298942*r**10-13502542778*r**12
            -21154868422*r**14-399967899894*r**16+182040594376*r**18+323036215364*r**20
            +30667931616*r**22+367504684738*r**24+62106880670*r**26+100384759962*r**28
            +4651250438*r**30+1576907092*r**32-89419323*r**34-26686727*r**36+1965165*r**38)
            +(-1+r**2)**2*(-11815-403479*r**2-12116849*r**4+7431355*r**6-1021262296*r**8
            +3713843244*r**10-19357856828*r**12-79702366908*r**14+643446898310*r**16
            -1875974607162*r**18+1346326900378*r**20+947285878418*r**22-1500221460412*r**24
            +547694052940*r**26-160473203388*r**28-1314878428*r**30-6495045111*r**32
            -596417831*r**34-67757105*r**36-1871029*r**38+93996*r**40)+2*Q2**2*(
            -209010-3774075*r**2-100503306*r**4+495159340*r**6-4934409087*r**8+23742388308*r**10
            -47797118772*r**12-65442601284*r**14+435289265808*r**16-512251145506*r**18
            +201626183424*r**20+843810468444*r**22-1273773051514*r**24+942040248564*r**26
            -363615254652*r**28+28925356068*r**30-22402113222*r**32-2276793771*r**34
            -420155462*r**36-21995880*r**38+1575585*r**40)+Q2*(113115+2926986*r**2
            +81610158*r**4-276256040*r**6+5678145215*r**8-28132582398*r**10+96147156696*r**12
            +166092974016*r**14-1702057063770*r**16+4055392372820*r**18-2870556455516*r**20
            +1790627790576*r**22-4370925867706*r**24+5072448079060*r**26-2208592193160*r**28
            +617619359616*r**30-27933564609*r**32+28296357282*r**34+2726470750*r**36
            +402827000*r**38+15322683*r**40-882774*r**42))*sqrtq2)*math.log(mu0))/(-156764160000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-16329600000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-113400000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-52500*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6+1814400000*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            +3780000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*sqrtq2+78382080000*logq2**5*r**22*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+FLAGcs*flagPERP*((28304640000*logq2**5*r**18*(
            -3-4*r**2+20*r**4-28*r**6+3*r**8)-2246400*logq2**3*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(-795+6057*r**2+2265*Q2**10*r**2+62201*r**4-540963*r**6
            +687258*r**8+728234*r**10+339426*r**12+49434*r**14-147727*r**16+329277*r**18
            -14379*r**20+13977*r**22-20*Q2**9*(-4+1017*r**2+1005*r**4)+Q2**8*(280
            +72517*r**2+151792*r**4+73077*r**6)-2*Q2**7*(600+64888*r**2+219461*r**4
            +224516*r**6+64203*r**8)+Q2**6*(770+101681*r**2+559676*r**4+957932*r**6
            +613686*r**8+75831*r**10)+Q2**5*(-455+17548*r**2-136541*r**4-617220*r**6
            -660225*r**8-255476*r**10+96873*r**12)-Q2**4*(-3045+87340*r**2+468405*r**4
            +501068*r**6+825753*r**8+560388*r**10+284575*r**12+186060*r**14)+2*Q2**3*(
            -1715+22814*r**2+238659*r**4+554490*r**6+862077*r**8+1111922*r**10
            +508885*r**12+190734*r**14+38694*r**16)+2*Q2**2*(-250+5798*r**2+2476*r**4
            -431343*r**6-245360*r**8-955997*r**10-828760*r**12-43193*r**14-87874*r**16
            +25023*r**18)+Q2*(2205-19836*r**2-191971*r**4+802700*r**6-945454*r**8
            -373224*r**10+1500326*r**12+363196*r**14-631655*r**16+52604*r**18-54891*r**20))
            -312*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(-11815-17342*r**2
            +20598*Q2**16*r**2-1539738*r**4-1828220*r**6-93296530*r**8+531809700*r**10
            -1202798314*r**12-12016064876*r**14+34941377640*r**16-16859928440*r**18
            -10427104030*r**20+13402061004*r**22-3848051134*r**24+1002915580*r**26
            -360030*r**28+15413020*r**30+576527*r**32+46998*r**34-12*Q2**15*(-1480
            +23619*r**2+19179*r**4)+4*Q2**14*(-32820+315810*r**2+775091*r**4+250170*r**6)
            -4*Q2**13*(-89680+561415*r**2+3441914*r**4+3172239*r**6+501840*r**8)
            +3*Q2**12*(-102835+108210*r**2+8242288*r**4+14188924*r**6+7455783*r**8
            +347210*r**10)+Q2**11*(-501830+4084716*r**2-5212386*r**4-3865176*r**6
            -7029506*r**8-4035196*r**10+3308706*r**12)-2*Q2**10*(-682770+1489843*r**2
            +22024696*r**4+119695125*r**6+221267970*r**8+106897065*r**10+24392896*r**12
            +3266703*r**14)+2*Q2**9*(-367345-3071840*r**2+26710386*r**4+227220060*r**6
            +714133400*r**8+705569180*r**10+204029050*r**12+35732936*r**14+1173645*r**16)
            +Q2**8*(-1049565+10126620*r**2-78738*r**4-171444948*r**6-1341551320*r**8
            -2311353340*r**10-1458873670*r**12-92048748*r**14-9710163*r**16+5670720*r**18)
            -4*Q2**7*(-406065+252615*r**2+7631982*r**4+81058936*r**6+189015752*r**8
            +480461830*r**10+282469470*r**12+143391072*r**14+131845761*r**16+16615587*r**18
            +1761540*r**20)+4*Q2**6*(-86460-2028669*r**2+1555743*r**4+74640153*r**6
            +482523418*r**8+2086011688*r**10+3349274064*r**12+1600218868*r**14+600107578*r**16
            +136941693*r**18+14561673*r**20+206811*r**22)+4*Q2**5*(-201465+1468989*r**2
            +1303132*r**4+13924205*r**6-125757445*r**8-1264814850*r**10-4711887796*r**12
            -4758378986*r**14-842818895*r**16-375154195*r**18+18838800*r**20+882517*r**22
            +946389*r**24)-Q2**4*(-642845-567190*r**2-8788364*r**4+119119700*r**6
            +481332275*r**8+3568163190*r**10-1523155600*r**12-13344747272*r**14-6577893895*r**16
            +5528768150*r**18+405581180*r**20+405698740*r**22+29345361*r**24+2648970*r**26)
            +2*Q2**3*(-18015-1180230*r**2-3200553*r**4-5407748*r**6-36754535*r**8
            +2081584130*r**10+4548956715*r**12+5193822776*r**14+943425851*r**16+2957420990*r**18
            +3054240885*r**20+424070540*r**22+85143627*r**24+6359622*r**26+15945*r**28)
            +2*Q2**2*(-80690+490665*r**2-3006468*r**4+17883911*r**6+95819042*r**8
            -120874895*r**10-1518601440*r**12-4189196169*r**14-9293444622*r**16+968976371*r**18
            -4244198580*r**20+292174125*r**22-168527138*r**24+35301811*r**26+1076312*r**28
            +351765*r**30)-2*Q2*(-38835+44444*r**2-3174082*r**4+2322168*r**6-63994442*r**8
            +565501168*r**10+36509186*r**12-748140236*r**14+1938362164*r**16-8068634516*r**18
            +7204485794*r**20-4164681904*r**22+1469846818*r**24-20195832*r**26+35804958*r**28
            +1423748*r**30+159399*r**32))-134784000*logq2**4*r**14*(340-1741*r**2
            +105*Q2**7*r**2+5955*r**4-5175*r**6+3561*r**8+12591*r**10-4573*r**12
            +841*r**14+801*r**16-5*Q2**6*(16+111*r**2+159*r**4)+5*Q2**5*(96+279*r**2
            +724*r**4+471*r**6)-Q2**4*(1200+2331*r**2+6259*r**4+9055*r**6+3399*r**8)
            +Q2**3*(1075+2834*r**2+6055*r**4+10016*r**6+11036*r**8+1956*r**10)
            +Q2**2*(270-2591*r**2-1978*r**4-3537*r**6-9223*r**8-5456*r**10+1011*r**12)
            -Q2*(885-2989*r**2+1628*r**4+3750*r**6-2139*r**8-6015*r**10+746*r**12
            +2034*r**14))*sqrtq2-37440*logq2**2*r**6*(9795*Q2**15*r**2-Q2**14*(176+119205*r**2
            +119733*r**4)+Q2**13*(-5296+630809*r**2+1282762*r**4+620217*r**6)-Q2**12*(
            -44624+1797899*r**2+5730699*r**4+5747777*r**6+1717833*r**8)+Q2**11*(
            -132011+2812426*r**2+13177088*r**4+19596512*r**6+13402543*r**8+2501682*r**10)
            -Q2**10*(-152094+1884891*r**2+14751739*r**4+23319644*r**6+25012874*r**8
            +15393573*r**10+948213*r**12)-Q2**9*(-61377+955590*r**2-2004191*r**4
            +27221400*r**6+53930425*r**8+19942298*r**10-1495185*r**12+2960784*r**14)
            +Q2**8*(-359208+2674127*r**2+14091751*r**4+115507551*r**6+287499375*r**8
            +281944837*r**10+101796957*r**12+19281861*r**14+5174541*r**16)-Q2**7*(
            -326202+1356937*r**2+15023772*r**4+128088876*r**6+436981944*r**8+647506918*r**10
            +448970212*r**12+106281012*r**14+23560626*r**16+2453409*r**18)+Q2**6*(51972
            -882067*r**2+5420949*r**4+26850376*r**6+214276264*r**8+487479138*r**10
            +538578698*r**12+269907144*r**14-17715324*r**16+7811169*r**18-2140239*r**20)
            +Q2**5*(-292438+1411877*r**2-1564652*r**4+61556533*r**6+137230708*r**8
            +156015498*r**10+175809288*r**12+42910898*r**14+72541858*r**16+127163633*r**18
            +6907236*r**20+3415641*r**22)-Q2**4*(-174424+508005*r**2-2190467*r**4
            +50135675*r**6+210274875*r**8+405579898*r**10+706477090*r**12+733179534*r**14
            +284543150*r**16+198691425*r**18+91612001*r**20+8095255*r**22+1339983*r**24)
            +Q2**3*(22129-237236*r**2+263412*r**4+1316932*r**6+76669625*r**8+231440812*r**10
            +264869952*r**12+610487536*r**14+552435251*r**16-6456100*r**18+147596684*r**20
            -7996116*r**22+3168227*r**24-515508*r**26)+(-1+r**2)**2*(-4656+9857*r**2
            -360589*r**4+1247426*r**6+7361182*r**8-110253713*r**10+191149981*r**12
            +55415668*r**14-108222692*r**16+14298391*r**18+43828469*r**20-8037238*r**22
            +4174646*r**24+77241*r**26+36027*r**28)+Q2**2*(-69826+307411*r**2-2666629*r**4
            +16719828*r**6+12513002*r**8-241673693*r**10+315050803*r**12+82535368*r**14
            -242061806*r**16-230761519*r**18+260549769*r**20-105534364*r**22+44073286*r**24
            -402247*r**26+700617*r**28)-Q2*(-30789+123784*r**2-1811563*r**4+9633038*r**6
            +18179307*r**8-295876664*r**10+442052917*r**12+58380406*r**14+155617849*r**16
            -52517144*r**18-146799465*r**20+215994074*r**22-63390943*r**24+23026888*r**26
            +35487*r**28+262818*r**30))*sqrtq2+(-1625*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(
            -291+525*Q2**7-20147*r**2-5111*r**4+211609*r**6+130409*r**8-10375*r**10
            -1219*r**12+45*r**14-375*Q2**6*(1+r**2)-5*Q2**5*(75-172*r**2+75*r**4)
            +Q2**4*(-291+869*r**2-139*r**4+45*r**6)+Q2**3*(-291+128*r**2+2840*r**4
            -544*r**6+45*r**8)+Q2**2*(-291-2315*r**2+9816*r**4+3768*r**6-859*r**8
            +45*r**10)+Q2*(-291-7580*r**2+15313*r**4+43104*r**6+1313*r**8-1084*r**10
            +45*r**12))+546*(Q2-(-1+r)**2)**2*(Q2-(1+r)**2)**2*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))**2*(375*Q2**11-1050*Q2**10*(1+r**2)+Q2**9*(
            -75+2636*r**2-75*r**4)+Q2**8*(2019-4273*r**2-5641*r**4+2475*r**6)
            -6*Q2**7*(122-611*r**2-3199*r**4-817*r**6+225*r**8)-4*Q2**6*(222-1391*r**2
            +9786*r**4+10698*r**6-2075*r**8+450*r**10)+2*Q2**5*(18-1019*r**2+28135*r**4
            +77994*r**6+34708*r**8-5291*r**10+675*r**12)+6*Q2**4*(5-791*r**2+3709*r**4
            -10219*r**6-14477*r**8+4515*r**10-521*r**12+75*r**14)+Q2**3*(261-3562*r**2
            -66630*r**4-26970*r**6+109988*r**8+83514*r**10-128082*r**12+1226*r**14
            -225*r**16)-2*Q2**2*(-81+53*r**2+22820*r**4+69696*r**6+139532*r**8
            +221348*r**10+99744*r**12-9148*r**14-1879*r**16+75*r**18)-3*Q2*(19
            -662*r**2+3229*r**4+59504*r**6+5830*r**8+59556*r**10+27322*r**12+78336*r**14
            -16489*r**16-670*r**18+25*r**20)+3*(-27+641*r**2+3833*r**4-38555*r**6
            +4522*r**8-164262*r**10-142766*r**12-158558*r**14+66705*r**16-2747*r**18
            -811*r**20+25*r**22))-325*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(21+37695*Q2**13+81479*r**2-1584410*r**4-14507670*r**6
            -82841935*r**8-255824893*r**10-460434400*r**12-1068299008*r**14-361893349*r**16
            +58874825*r**18+14340762*r**20+293686*r**22-42817*r**24+909*r**26-95691*Q2**12*(1
            +r**2)-6*Q2**11*(2458-41935*r**2+2458*r**4)+6*Q2**10*(20677-36566*r**2
            -60482*r**4+28649*r**6)-Q2**9*(-51093+388582*r**2+1885604*r**4+276886*r**6
            +4755*r**8)+Q2**8*(-80445+788749*r**2+2948334*r**4+2390142*r**6+1102213*r**8
            -156885*r**10)-4*Q2**7*(15414-241967*r**2-1034942*r**4+602597*r**6-1322108*r**8
            -82211*r**10+4632*r**12)+4*Q2**6*(-2205-200162*r**2+605612*r**4+3121748*r**6
            +4660100*r**8+195992*r**10-295106*r**12+21399*r**14)+Q2**5*(21057-1052948*r**2
            -3524496*r**4+6693768*r**6+25597478*r**8+12429480*r**10-7130400*r**12
            -573236*r**14+30297*r**16)+Q2**4*(36147+126647*r**2-8436724*r**4-4697096*r**6
            +54517930*r**8+74607994*r**10-16624424*r**12-5695156*r**14+484391*r**16
            -21645*r**18)-2*Q2**3*(-4770-34853*r**2+3342806*r**4+23536190*r**6+31970104*r**8
            +1598142*r**10+56702896*r**12+19694990*r**14-2068534*r**16-255821*r**18
            +8730*r**20)-2*Q2**2*(6069-34214*r**2-1213662*r**4+22232499*r**6+117743552*r**8
            +164919060*r**10+202917204*r**12+122870000*r**14+11530119*r**16-1226034*r**18
            -2426*r**20+153*r**22)+Q2*(-6117+202778*r**2+1417412*r**4-24058658*r**6
            -194508899*r**8-146410808*r**10-174487352*r**12-481304024*r**14-81326867*r**16
            +15112174*r**18-400060*r**20-151606*r**22+3627*r**24)))*sqrtq2)/(-39191040000*logq2**5*r**20
            -2721600000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-9450000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4+16329600000*logq2**4*r**16*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+226800000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+157500*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +((2177280000*logq2**5*r**18*(-3-4*r**2+20*r**4-28*r**6+3*r**8)-172800*logq2**3*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(-795+6057*r**2+2265*Q2**10*r**2
            +62201*r**4-540963*r**6+687258*r**8+728234*r**10+339426*r**12+49434*r**14
            -147727*r**16+329277*r**18-14379*r**20+13977*r**22-20*Q2**9*(-4+1017*r**2
            +1005*r**4)+Q2**8*(280+72517*r**2+151792*r**4+73077*r**6)-2*Q2**7*(600
            +64888*r**2+219461*r**4+224516*r**6+64203*r**8)+Q2**6*(770+101681*r**2
            +559676*r**4+957932*r**6+613686*r**8+75831*r**10)+Q2**5*(-455+17548*r**2
            -136541*r**4-617220*r**6-660225*r**8-255476*r**10+96873*r**12)-Q2**4*(
            -3045+87340*r**2+468405*r**4+501068*r**6+825753*r**8+560388*r**10+284575*r**12
            +186060*r**14)+2*Q2**3*(-1715+22814*r**2+238659*r**4+554490*r**6+862077*r**8
            +1111922*r**10+508885*r**12+190734*r**14+38694*r**16)+2*Q2**2*(-250
            +5798*r**2+2476*r**4-431343*r**6-245360*r**8-955997*r**10-828760*r**12
            -43193*r**14-87874*r**16+25023*r**18)+Q2*(2205-19836*r**2-191971*r**4
            +802700*r**6-945454*r**8-373224*r**10+1500326*r**12+363196*r**14-631655*r**16
            +52604*r**18-54891*r**20))-24*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1
            +r)**2)**2*(-11815-17342*r**2+20598*Q2**16*r**2-1539738*r**4-1828220*r**6
            -93296530*r**8+531809700*r**10-1202798314*r**12-12016064876*r**14+34941377640*r**16
            -16859928440*r**18-10427104030*r**20+13402061004*r**22-3848051134*r**24
            +1002915580*r**26-360030*r**28+15413020*r**30+576527*r**32+46998*r**34
            -12*Q2**15*(-1480+23619*r**2+19179*r**4)+4*Q2**14*(-32820+315810*r**2
            +775091*r**4+250170*r**6)-4*Q2**13*(-89680+561415*r**2+3441914*r**4
            +3172239*r**6+501840*r**8)+3*Q2**12*(-102835+108210*r**2+8242288*r**4
            +14188924*r**6+7455783*r**8+347210*r**10)+Q2**11*(-501830+4084716*r**2
            -5212386*r**4-3865176*r**6-7029506*r**8-4035196*r**10+3308706*r**12)
            -2*Q2**10*(-682770+1489843*r**2+22024696*r**4+119695125*r**6+221267970*r**8
            +106897065*r**10+24392896*r**12+3266703*r**14)+2*Q2**9*(-367345-3071840*r**2
            +26710386*r**4+227220060*r**6+714133400*r**8+705569180*r**10+204029050*r**12
            +35732936*r**14+1173645*r**16)+Q2**8*(-1049565+10126620*r**2-78738*r**4
            -171444948*r**6-1341551320*r**8-2311353340*r**10-1458873670*r**12-92048748*r**14
            -9710163*r**16+5670720*r**18)-4*Q2**7*(-406065+252615*r**2+7631982*r**4
            +81058936*r**6+189015752*r**8+480461830*r**10+282469470*r**12+143391072*r**14
            +131845761*r**16+16615587*r**18+1761540*r**20)+4*Q2**6*(-86460-2028669*r**2
            +1555743*r**4+74640153*r**6+482523418*r**8+2086011688*r**10+3349274064*r**12
            +1600218868*r**14+600107578*r**16+136941693*r**18+14561673*r**20+206811*r**22)
            +4*Q2**5*(-201465+1468989*r**2+1303132*r**4+13924205*r**6-125757445*r**8
            -1264814850*r**10-4711887796*r**12-4758378986*r**14-842818895*r**16-375154195*r**18
            +18838800*r**20+882517*r**22+946389*r**24)-Q2**4*(-642845-567190*r**2
            -8788364*r**4+119119700*r**6+481332275*r**8+3568163190*r**10-1523155600*r**12
            -13344747272*r**14-6577893895*r**16+5528768150*r**18+405581180*r**20
            +405698740*r**22+29345361*r**24+2648970*r**26)+2*Q2**3*(-18015-1180230*r**2
            -3200553*r**4-5407748*r**6-36754535*r**8+2081584130*r**10+4548956715*r**12
            +5193822776*r**14+943425851*r**16+2957420990*r**18+3054240885*r**20+424070540*r**22
            +85143627*r**24+6359622*r**26+15945*r**28)+2*Q2**2*(-80690+490665*r**2
            -3006468*r**4+17883911*r**6+95819042*r**8-120874895*r**10-1518601440*r**12
            -4189196169*r**14-9293444622*r**16+968976371*r**18-4244198580*r**20+292174125*r**22
            -168527138*r**24+35301811*r**26+1076312*r**28+351765*r**30)-2*Q2*(-38835
            +44444*r**2-3174082*r**4+2322168*r**6-63994442*r**8+565501168*r**10
            +36509186*r**12-748140236*r**14+1938362164*r**16-8068634516*r**18+7204485794*r**20
            -4164681904*r**22+1469846818*r**24-20195832*r**26+35804958*r**28+1423748*r**30
            +159399*r**32))-10368000*logq2**4*r**14*(340-1741*r**2+105*Q2**7*r**2+5955*r**4
            -5175*r**6+3561*r**8+12591*r**10-4573*r**12+841*r**14+801*r**16-5*Q2**6*(16
            +111*r**2+159*r**4)+5*Q2**5*(96+279*r**2+724*r**4+471*r**6)-Q2**4*(1200
            +2331*r**2+6259*r**4+9055*r**6+3399*r**8)+Q2**3*(1075+2834*r**2+6055*r**4
            +10016*r**6+11036*r**8+1956*r**10)+Q2**2*(270-2591*r**2-1978*r**4-3537*r**6
            -9223*r**8-5456*r**10+1011*r**12)-Q2*(885-2989*r**2+1628*r**4+3750*r**6
            -2139*r**8-6015*r**10+746*r**12+2034*r**14))*sqrtq2-2880*logq2**2*r**6*(9795*Q2**15*r**2
            -Q2**14*(176+119205*r**2+119733*r**4)+Q2**13*(-5296+630809*r**2+1282762*r**4
            +620217*r**6)-Q2**12*(-44624+1797899*r**2+5730699*r**4+5747777*r**6
            +1717833*r**8)+Q2**11*(-132011+2812426*r**2+13177088*r**4+19596512*r**6
            +13402543*r**8+2501682*r**10)-Q2**10*(-152094+1884891*r**2+14751739*r**4
            +23319644*r**6+25012874*r**8+15393573*r**10+948213*r**12)-Q2**9*(-61377
            +955590*r**2-2004191*r**4+27221400*r**6+53930425*r**8+19942298*r**10
            -1495185*r**12+2960784*r**14)+Q2**8*(-359208+2674127*r**2+14091751*r**4
            +115507551*r**6+287499375*r**8+281944837*r**10+101796957*r**12+19281861*r**14
            +5174541*r**16)-Q2**7*(-326202+1356937*r**2+15023772*r**4+128088876*r**6
            +436981944*r**8+647506918*r**10+448970212*r**12+106281012*r**14+23560626*r**16
            +2453409*r**18)+Q2**6*(51972-882067*r**2+5420949*r**4+26850376*r**6
            +214276264*r**8+487479138*r**10+538578698*r**12+269907144*r**14-17715324*r**16
            +7811169*r**18-2140239*r**20)+Q2**5*(-292438+1411877*r**2-1564652*r**4
            +61556533*r**6+137230708*r**8+156015498*r**10+175809288*r**12+42910898*r**14
            +72541858*r**16+127163633*r**18+6907236*r**20+3415641*r**22)-Q2**4*(
            -174424+508005*r**2-2190467*r**4+50135675*r**6+210274875*r**8+405579898*r**10
            +706477090*r**12+733179534*r**14+284543150*r**16+198691425*r**18+91612001*r**20
            +8095255*r**22+1339983*r**24)+Q2**3*(22129-237236*r**2+263412*r**4+1316932*r**6
            +76669625*r**8+231440812*r**10+264869952*r**12+610487536*r**14+552435251*r**16
            -6456100*r**18+147596684*r**20-7996116*r**22+3168227*r**24-515508*r**26)
            +(-1+r**2)**2*(-4656+9857*r**2-360589*r**4+1247426*r**6+7361182*r**8
            -110253713*r**10+191149981*r**12+55415668*r**14-108222692*r**16+14298391*r**18
            +43828469*r**20-8037238*r**22+4174646*r**24+77241*r**26+36027*r**28)
            +Q2**2*(-69826+307411*r**2-2666629*r**4+16719828*r**6+12513002*r**8
            -241673693*r**10+315050803*r**12+82535368*r**14-242061806*r**16-230761519*r**18
            +260549769*r**20-105534364*r**22+44073286*r**24-402247*r**26+700617*r**28)
            -Q2*(-30789+123784*r**2-1811563*r**4+9633038*r**6+18179307*r**8-295876664*r**10
            +442052917*r**12+58380406*r**14+155617849*r**16-52517144*r**18-146799465*r**20
            +215994074*r**22-63390943*r**24+23026888*r**26+35487*r**28+262818*r**30))*sqrtq2
            +(-125*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(-291+525*Q2**7-20147*r**2-5111*r**4
            +211609*r**6+130409*r**8-10375*r**10-1219*r**12+45*r**14-375*Q2**6*(1
            +r**2)-5*Q2**5*(75-172*r**2+75*r**4)+Q2**4*(-291+869*r**2-139*r**4
            +45*r**6)+Q2**3*(-291+128*r**2+2840*r**4-544*r**6+45*r**8)+Q2**2*(
            -291-2315*r**2+9816*r**4+3768*r**6-859*r**8+45*r**10)+Q2*(-291-7580*r**2
            +15313*r**4+43104*r**6+1313*r**8-1084*r**10+45*r**12))+42*(Q2-(-1
            +r)**2)**2*(Q2-(1+r)**2)**2*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**2*(375*Q2**11-1050*Q2**10*(1+r**2)+Q2**9*(-75+2636*r**2-75*r**4)
            +Q2**8*(2019-4273*r**2-5641*r**4+2475*r**6)-6*Q2**7*(122-611*r**2-3199*r**4
            -817*r**6+225*r**8)-4*Q2**6*(222-1391*r**2+9786*r**4+10698*r**6-2075*r**8
            +450*r**10)+2*Q2**5*(18-1019*r**2+28135*r**4+77994*r**6+34708*r**8
            -5291*r**10+675*r**12)+6*Q2**4*(5-791*r**2+3709*r**4-10219*r**6-14477*r**8
            +4515*r**10-521*r**12+75*r**14)+Q2**3*(261-3562*r**2-66630*r**4-26970*r**6
            +109988*r**8+83514*r**10-128082*r**12+1226*r**14-225*r**16)-2*Q2**2*(
            -81+53*r**2+22820*r**4+69696*r**6+139532*r**8+221348*r**10+99744*r**12
            -9148*r**14-1879*r**16+75*r**18)-3*Q2*(19-662*r**2+3229*r**4+59504*r**6
            +5830*r**8+59556*r**10+27322*r**12+78336*r**14-16489*r**16-670*r**18
            +25*r**20)+3*(-27+641*r**2+3833*r**4-38555*r**6+4522*r**8-164262*r**10
            -142766*r**12-158558*r**14+66705*r**16-2747*r**18-811*r**20+25*r**22))
            -25*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(21+37695*Q2**13
            +81479*r**2-1584410*r**4-14507670*r**6-82841935*r**8-255824893*r**10
            -460434400*r**12-1068299008*r**14-361893349*r**16+58874825*r**18+14340762*r**20
            +293686*r**22-42817*r**24+909*r**26-95691*Q2**12*(1+r**2)-6*Q2**11*(2458
            -41935*r**2+2458*r**4)+6*Q2**10*(20677-36566*r**2-60482*r**4+28649*r**6)
            -Q2**9*(-51093+388582*r**2+1885604*r**4+276886*r**6+4755*r**8)+Q2**8*(
            -80445+788749*r**2+2948334*r**4+2390142*r**6+1102213*r**8-156885*r**10)
            -4*Q2**7*(15414-241967*r**2-1034942*r**4+602597*r**6-1322108*r**8-82211*r**10
            +4632*r**12)+4*Q2**6*(-2205-200162*r**2+605612*r**4+3121748*r**6+4660100*r**8
            +195992*r**10-295106*r**12+21399*r**14)+Q2**5*(21057-1052948*r**2-3524496*r**4
            +6693768*r**6+25597478*r**8+12429480*r**10-7130400*r**12-573236*r**14
            +30297*r**16)+Q2**4*(36147+126647*r**2-8436724*r**4-4697096*r**6+54517930*r**8
            +74607994*r**10-16624424*r**12-5695156*r**14+484391*r**16-21645*r**18)
            -2*Q2**3*(-4770-34853*r**2+3342806*r**4+23536190*r**6+31970104*r**8
            +1598142*r**10+56702896*r**12+19694990*r**14-2068534*r**16-255821*r**18
            +8730*r**20)-2*Q2**2*(6069-34214*r**2-1213662*r**4+22232499*r**6+117743552*r**8
            +164919060*r**10+202917204*r**12+122870000*r**14+11530119*r**16-1226034*r**18
            -2426*r**20+153*r**22)+Q2*(-6117+202778*r**2+1417412*r**4-24058658*r**6
            -194508899*r**8-146410808*r**10-174487352*r**12-481304024*r**14-81326867*r**16
            +15112174*r**18-400060*r**20-151606*r**22+3627*r**24)))*sqrtq2)*math.log(murhoLS))/(
            -4354560000*logq2**5*r**20-302400000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -1050000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+1814400000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+25200000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+17500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2))
            +(flagPERP*(-104509440000*logq2**6*(-Q2+(-1+r)**2)*r**24*(3+20*r**4-56*r**6
            +9*r**8)*(-Q2+(1+r)**2)+8294400*logq2**4*(-Q2+(-1+r)**2)*r**16*(-Q2
            +(1+r)**2)*(-13260*Q2**12*r**2+60*Q2**11*(40+2238*r**2+1959*r**4)-6*Q2**10*(4300
            +99468*r**2+166571*r**4+70764*r**6)+20*Q2**9*(5320+75526*r**2+178311*r**4
            +146971*r**6+38799*r**8)-5*Q2**8*(41775+454008*r**2+1346469*r**4+1599112*r**6
            +837648*r**8+145368*r**10)+10*Q2**7*(16140+179682*r**2+635805*r**4+1009580*r**6
            +801145*r**8+286020*r**10+46008*r**12)-10*Q2**6*(-9765+25368*r**2+51105*r**4
            +338080*r**6+549977*r**8+440226*r**10+137529*r**12+85806*r**14)+2*Q2**5*(
            -145950-355872*r**2-2787054*r**4-3031231*r**6-1202400*r**8+2226030*r**10
            +2835008*r**12+1194921*r**14+786024*r**16)-5*Q2**4*(-37320-119136*r**2
            -1110951*r**4-1531468*r**6-1043807*r**8+418104*r**10+2344655*r**12+1523788*r**14
            +656919*r**16+209736*r**18)-20*Q2**3*(-1500+23193*r**2+22344*r**4+233727*r**6
            +106571*r**8-104556*r**10-499797*r**12-497963*r**14-5175*r**16-110697*r**18
            +23673*r**20)+10*Q2**2*(-9765+53544*r**2-343110*r**4+644296*r**6-142215*r**8
            -217770*r**10-185387*r**12-573450*r**14-242136*r**16+874090*r**18-122715*r**20
            +113418*r**22)+(-1+r**2)**2*(-7925+64002*r**2-644137*r**4+2092860*r**6
            -501548*r**8-14416*r**10+1553052*r**12-405848*r**14+305105*r**16+1974638*r**18
            -7619*r**20+127836*r**22)-10*Q2*(-4770+34320*r**2-287841*r**4+805951*r**6
            -521110*r**8-364818*r**10+955666*r**12+1102928*r**14-243846*r**16-406190*r**18
            +759863*r**20-80031*r**22+64278*r**24))+1152*logq2**2*r**8*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(-556584*Q2**18*r**2+24*Q2**17*(-6440+323208*r**2
            +306463*r**4)-8*Q2**16*(-206850+5519389*r**2+11628335*r**4+5174919*r**6)
            +16*Q2**15*(-453390+8198464*r**2+29667243*r**4+28688323*r**6+7989399*r**8)
            -Q2**14*(-15560475+202083880*r**2+1220893040*r**4+1833745864*r**6+1181704395*r**8
            +225561240*r**10)+2*Q2**13*(-5645325+43616511*r**2+717343940*r**4+1230354128*r**6
            +1303767993*r**8+779996385*r**10+94366656*r**12)+Q2**12*(-21123795+215895094*r**2
            +268889069*r**4+4014555896*r**6+6997825091*r**8+2134796386*r**10-510499101*r**12
            +59589024*r**14)-4*Q2**11*(-14212275+86070211*r**2+743035225*r**4+4686585867*r**6
            +11081489235*r**8+9824682745*r**10+3123228847*r**12+360722385*r**14+78294696*r**16)
            +Q2**10*(-39352005+41037548*r**2+3285943206*r**4+23975557532*r**6+82036551836*r**8
            +111640348140*r**10+68855674586*r**12+16275034772*r**14+2141869801*r**16
            +285317208*r**18)-2*Q2**9*(15644475-159295005*r**2+299102910*r**4+1564699086*r**6
            +23439363700*r**8+50040687620*r**10+51591022530*r**12+24569424530*r**14
            +2959354561*r**16+549580505*r**18+16391760*r**20)-Q2**8*(-72689925+241774542*r**2
            +1376541385*r**4+23642841412*r**6+53046035202*r**8+80273670480*r**10
            +65852812518*r**12+5296665100*r**14-1699708733*r**16+5042504322*r**18
            -160900335*r**20+132289872*r**22)+8*Q2**7*(-4477935-12549833*r**2+113135397*r**4
            +2869845901*r**6+12111514456*r**8+27782911496*r**10+40552191738*r**12
            +27367406188*r**14+7124939001*r**16+1485846481*r**18+625020601*r**20
            +805847*r**22+13167702*r**24)-Q2**6*(22941975-222773024*r**2+320246860*r**4
            +1186948608*r**6+42075249355*r**8+123826787000*r**10+253894842256*r**12
            +302901668880*r**14+128639342541*r**16+31928011680*r**18+5192478500*r**20
            +3260490288*r**22+390413905*r**24+33194376*r**26)+2*Q2**5*(17956365-41277559*r**2
            +323114312*r**4-5311848084*r**6-7966543787*r**8-13823328875*r**10-38085421224*r**12
            +36373118112*r**14+58882418407*r**16+19450066291*r**18+33943885680*r**20
            +8402339828*r**22+2995570871*r**24+427633647*r**26+3519216*r**28)+Q2**4*(
            -12569025-42558630*r**2-532283765*r**4+5857073536*r**6+20006350895*r**8
            +34234549530*r**10+191812969715*r**12+100524001040*r**14-70382940747*r**16
            -93491962450*r**18-82418789815*r**20-95990523760*r**22-24050384675*r**24
            -5151956514*r**26-571345095*r**28+1409760*r**30)-4*Q2**3*(1243725-12088901*r**2
            +33945405*r**4-197600789*r**6+1481269421*r**8+1734068835*r**10+12345396741*r**12
            +16114316675*r**14-14472290177*r**16-38680880487*r**18+1084023295*r**20
            -28955989079*r**22-2626870105*r**24-2641517559*r**26+73361791*r**28+12920745*r**30
            +2530464*r**32)+(-1+r**2)**2*(246015+536676*r**2+32866994*r**4-76476220*r**6
            +175415270*r**8+9083955020*r**10-45076434838*r**12+107812661588*r**14
            +2554205940*r**16-117106438140*r**18+3423157590*r**20+86477254348*r**22
            -27968873558*r**24+12315091780*r**26+668521870*r**28+322313500*r**30
            +20632189*r**32+563976*r**34)+Q2**2*(5835585-16402172*r**2+385462518*r**4
            -2053395604*r**6+1536932986*r**8+27486858996*r**10-116893034098*r**12
            +168733564812*r**14-98504943492*r**16-29664224772*r**18-184808077822*r**20
            +263810299812*r**22-154780905578*r**24+66730605596*r**26+491409786*r**28
            +2847158116*r**30+251116083*r**32+9739248*r**34)-2*Q2*(987525-952091*r**2
            +95622530*r**4-441681714*r**6+600269490*r**8+14843714010*r**10-78143641962*r**12
            +165889979990*r**14-93319820228*r**16+36498450420*r**18-1688578270*r**20
            -108839318678*r**22+176852299230*r**24-73189265802*r**26+24791391090*r**28
            +519434610*r**30+787021231*r**32+60572375*r**34+1916244*r**36))-16*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**22+Q2**21*(9168+5492*r**2)
            -Q2**20*(149367+1710440*r**2+145885*r**4)+2*Q2**19*(166081+11225142*r**2
            +11373357*r**4+513816*r**6)-4*Q2**18*(-500241+29074056*r**2+68728671*r**4
            +32028984*r**6+949307*r**8)+2*Q2**17*(-5615008+146448803*r**2+643844310*r**4
            +678188618*r**6+190108966*r**8+4125635*r**10)-4*Q2**16*(-3973359+74266084*r**2
            +679947566*r**4+1166558084*r**6+813909434*r**8+142704876*r**10+2477669*r**12)
            +2*Q2**15*(11775989-110636094*r**2+664396723*r**4+951187330*r**6+1749762163*r**8
            +1506240170*r**10+59782461*r**12+1513106*r**14)+2*Q2**14*(-55171233+425567014*r**2
            +2711053775*r**4+12958211190*r**6+21658743637*r**8+9739250642*r**10+1595151489*r**12
            +544099234*r**14+4360652*r**16)-2*Q2**13*(-64251489+244237704*r**2+5532279198*r**4
            +32275758294*r**6+86358159924*r**8+82047028890*r**10+28156092330*r**12
            +5697080754*r**14+880213701*r**16+5410358*r**18)+Q2**12*(32404320-689625728*r**2
            +6029515422*r**4+40568180232*r**6+219931592136*r**8+336188308392*r**10
            +225093896652*r**12+50076188856*r**14+10603021032*r**16+512577624*r**18
            -2528058*r**20)+2*Q2**11*(-115033373+399321098*r**2+2210312267*r**4+31587831686*r**6
            +31061512558*r**8+34431825288*r**10-6092006098*r**12-19785079664*r**14
            +9780730671*r**16+148443454*r**18+792861927*r**20+7594938*r**22)-2*Q2**10*(
            -93871869-301375562*r**2+3319994183*r**4+57918106482*r**6+221297158884*r**8
            +548728816820*r**10+745806838042*r**12+376195573260*r**14+111602538743*r**16
            +34133271638*r**18+4291667039*r**20+952597698*r**22+5111938*r**24)+2*Q2**9*(35349973
            -660880954*r**2+1254992504*r**4+13592393802*r**6+188409941901*r**8+595751483472*r**10
            +1400248406784*r**12+1275737968812*r**14+420777203271*r**16+112212418766*r**18
            +17786796808*r**20+3853561546*r**22+74351511*r**24-2393252*r**26)+2*Q2**8*(
            -108253049+118145044*r**2-1124814378*r**4+38306461532*r**6+18754759225*r**8
            +173212341792*r**10-500295246472*r**12-989355332216*r**14-692859876855*r**16
            -17789612956*r**18-28297635746*r**20+5682638556*r**22-1939300841*r**24
            +618754856*r**26+5264308*r**28)-2*Q2**7*(-54052263-448577294*r**2-1520978173*r**4
            +28731627586*r**6+112888864569*r**8+706645991774*r**10+929096410339*r**12
            +1001121957078*r**14+418146169379*r**16+16355794270*r**18+193861735857*r**20
            +135446846*r**22+5076541451*r**24-433805614*r**26+430061097*r**28+2026538*r**30)
            +2*Q2**6*(26086756-338891526*r**2+444452537*r**4-9932112558*r**6+69997798893*r**8
            +300770174994*r**10+915081187041*r**12+1489407656154*r**14+1687384602261*r**16
            +547655973486*r**18-13794033501*r**20+77006155926*r**22+1117169999*r**24
            -1921129978*r**26+1260136771*r**28-59789634*r**30-1335221*r**32)+2*Q2**5*(
            -41065221-30301762*r**2-2100878558*r**4+19379453494*r**6-37887938426*r**8
            +262142876010*r**10-288763677838*r**12+154465718158*r**14-604942387500*r**16
            -650739335506*r**18-222381517226*r**20-50316474078*r**22-61839285638*r**24
            -28061823154*r**26-913977578*r**28-2037242598*r**30+205606193*r**32+1540828*r**34)
            +Q2**4*(27030983+281559096*r**2+2329355103*r**4-8747645416*r**6+40739366524*r**8
            -535300669288*r**10+403110641524*r**12-1808455964520*r**14-1432781657230*r**16
            +955373106632*r**18+122065779642*r**20+994249714184*r**22+578840269196*r**24
            +246283782728*r**26+66968062644*r**28+8072207688*r**30+1963310271*r**32
            -157780704*r**34-693057*r**36)-4*Q2**3*(-2393664+28989864*r**2-155289084*r**4
            +2427128335*r**6-6125332244*r**8-451871134*r**10+21267853224*r**12-132493087338*r**14
            -254737602684*r**16+394463082666*r**18-13968192200*r**20+181366227780*r**22
            +40316224628*r**24+110206678118*r**26+21963685960*r**28+2782514298*r**30
            +999139932*r**32-155130906*r**34+9843156*r**36+123293*r**38)+2*(-1
            +r**2)**2*(-190141-1529518*r**2-33679497*r**4+9807032*r**6-1746945342*r**8
            +6647955444*r**10-39233655776*r**12-41613662324*r**14+844981789254*r**16
            -3200025798184*r**18+4808873592694*r**20-3353175039444*r**22+1172325161764*r**24
            -289357902804*r**26+26173110744*r**28-10693057756*r**30-1369313137*r**32
            -113407818*r**34-30256357*r**36+935532*r**38+5634*r**40)+2*Q2**2*(-5256619
            -1096858*r**2-569910819*r**4+3574594202*r**6-23996575640*r**8+106537748288*r**10
            -268025666192*r**12+237211890976*r**14+208084980498*r**16-175106578276*r**18
            +1047462497634*r**20-2262696717692*r**22+2130463827880*r**24-852248583952*r**26
            +143057076472*r**28-47330360656*r**30-10657058383*r**32-95706162*r**34
            -538547623*r**36+25490194*r**38+192728*r**40)-2*Q2*(-1647815-6079975*r**2
            -224696078*r**4+905703860*r**6-11449882667*r**8+57888034035*r**10-231966314240*r**12
            +211288930984*r**14+1134859600730*r**16-3216199321134*r**18-86321246700*r**20
            +6808527240080*r**22-7559948172934*r**24+3468174980510*r**26-972610147056*r**28
            +129588947480*r**30-38974080115*r**32-6566340347*r**34-280835350*r**36
            -221131268*r**38+8084625*r**40+53375*r**42))+248832000*logq2**5*r**20*(
            -420*Q2**9*r**2+60*Q2**8*(8+51*r**2+37*r**4)-40*Q2**7*(96+281*r**2+328*r**4
            +45*r**6)+4*Q2**6*(3360+6676*r**2+8487*r**4+1690*r**6-2877*r**8)+Q2**5*(
            -24675-44164*r**2-44222*r**4-19828*r**6+50433*r**8+32928*r**10)+Q2**4*(21315
            +47095*r**2+28212*r**4+23434*r**6-49925*r**8-104449*r**10-27090*r**12)
            -2*Q2**3*(-105+17105*r**2+3224*r**4+7017*r**6-23847*r**8-36323*r**10
            -32108*r**12+9345*r**14)+(-1+r**2)**2*(-2985+7299*r**2+5207*r**4-35113*r**6
            +43049*r**8+48649*r**10-24515*r**12+9277*r**14+9612*r**16)+2*Q2**2*(
            -8085+16460*r**2+1611*r**4-17045*r**6+6832*r**8+7890*r**10-25141*r**12
            +1203*r**14+26355*r**16)+Q2*(12225-33014*r**2+4784*r**4+97176*r**6
            -51266*r**8-200968*r**10-101904*r**12+68368*r**14+641*r**16-37962*r**18))*sqrtq2
            +138240*logq2**3*r**12*(-126720*Q2**17*r**2+12*Q2**16*(-64+148560*r**2+138255*r**4)
            -4*Q2**15*(-9402+2776908*r**2+5100805*r**4+2401605*r**6)+8*Q2**14*(-42285
            +4951722*r**2+13565140*r**4+12643185*r**6+4002255*r**8)-Q2**13*(-1363635
            +86687004*r**2+319732814*r**4+437695680*r**6+280496045*r**8+66584340*r**10)
            +Q2**12*(-2802555+111962901*r**2+542290348*r**4+945654486*r**6+904945125*r**8
            +465384085*r**10+86140890*r**12)-2*Q2**11*(-1092252+29218287*r**2+219760557*r**4
            +405974987*r**6+486509332*r**8+451858283*r**10+223847415*r**12+30432915*r**14)
            +2*Q2**10*(1385538-29861319*r**2-68113660*r**4-387181820*r**6-737442725*r**8
            -445060159*r**10+52256838*r**12+99728830*r**14+2599965*r**16)+Q2**9*(
            -8500965+136135098*r**2+715457180*r**4+2772737440*r**6+5644372370*r**8
            +6002352080*r**10+3224455148*r**12+684729560*r**14+22868715*r**16+33361470*r**18)
            -Q2**8*(-7365105+96724917*r**2+686589312*r**4+2903638200*r**6+6505159010*r**8
            +8811795550*r**10+7201188432*r**12+3278624872*r**14+814095615*r**16+77257485*r**18
            +41483520*r**20)+4*Q2**7*(269940-682623*r**2+38800926*r**4+259603572*r**6
            +498137280*r**8+958477090*r**10+1311563782*r**12+1116769876*r**14+548184932*r**16
            +250108425*r**18+28823820*r**20+10983420*r**22)-4*Q2**6*(1881726-14621547*r**2
            -58707772*r**4-128619222*r**6-667206707*r**8-751627606*r**10-190050502*r**12
            +697344318*r**14+912065228*r**16+595598293*r**18+375456966*r**20+49347500*r**22
            +10823805*r**24)+Q2**5*(5889849-43983528*r**2-211838870*r**4-668278800*r**6
            -2924363345*r**8-3824050776*r**10-2187239636*r**12+1501306400*r**14+4609291255*r**16
            +3553121880*r**18+2570294762*r**20+1192988944*r**22+184693665*r**24+22120200*r**26)
            +(-1+r**2)**4*(52467-214959*r**2-513578*r**4+24544170*r**6-126468135*r**8
            +333630851*r**10+143760988*r**12-186943764*r**14-290848075*r**16+152935495*r**18
            +307080582*r**20-41295254*r**22+44394367*r**24+2264805*r**26+500040*r**28)
            +Q2**4*(-638505+6880251*r**2+44455100*r**4+448931430*r**6+397599665*r**8
            +1914277805*r**10+7020098*r**12-2100059420*r**14-3651324935*r**16-3341122955*r**18
            +201357400*r**20-1839597674*r**22+74905695*r**24-69432445*r**26+8060490*r**28)
            -Q2*(-1+r**2)**2*(435207-2268252*r**2-4712327*r**4+151262062*r**6-772834785*r**8
            +1742771556*r**10+291253569*r**12-141006026*r**14+67038701*r**16-528832500*r**18
            +306950227*r**20+1870194058*r**22-383056147*r**24+289189612*r**26+12642035*r**28
            +4013010*r**30)-2*Q2**3*(960120-5602773*r**2-11544763*r**4+233427435*r**6
            -847334440*r**8+1409551585*r**10-428587659*r**12-648258219*r**14-404094200*r**16
            -558440195*r**18-617977625*r**20+2218890357*r**22-815882968*r**24+459359415*r**26
            +5504735*r**28+10029195*r**30)+2*Q2**2*(709710-4630407*r**2-5798076*r**4
            +192173588*r**6-1015157385*r**8+2272016695*r**10-1191508706*r**12+317702*r**14
            +757734969*r**16+1316552935*r**18-15793960*r**20-1505521512*r**22+2545158449*r**24
            -831291607*r**26+372854150*r**28+8703630*r**30+6519825*r**32))*sqrtq2
            -96*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(41196*Q2**21*r**2
            -12*Q2**20*(-1480+57537*r**2+57537*r**4)+120*Q2**19*(-1538+36356*r**2
            +93839*r**4+39453*r**6)-4*Q2**18*(-197020+3429590*r**2+17022939*r**4
            +17758976*r**6+4374255*r**8)+Q2**17*(-1611705+21307800*r**2+196865022*r**4
            +326801204*r**6+226422315*r**8+36585180*r**10)-Q2**16*(-825285+8328699*r**2
            +243045288*r**4+271652546*r**6+393855835*r**8+353632323*r**10+35295714*r**12)
            -2*Q2**15*(-1691530+8632397*r**2+47034651*r**4+1203624515*r**6+2322591946*r**8
            +888276297*r**10-27952759*r**12+9161007*r**14)+6*Q2**14*(-1276570+306365*r**2
            +107405990*r**4+1468114024*r**6+4369816345*r**8+4133678157*r**10+1278770820*r**12
            +132717130*r**14+15579195*r**16)-6*Q2**13*(-694360-9541905*r**2+108142642*r**4
            +1891948324*r**6+8996254464*r**8+13405058556*r**10+8681955634*r**12+1980123832*r**14
            +229100148*r**16+14985465*r**18)+Q2**12*(7231640-45106750*r**2+147589494*r**4
            -510307928*r**6+31590484676*r**8+63259793076*r**10+72748902136*r**12
            +42509817224*r**14+5135819268*r**16+692981210*r**18-25514190*r**20)+2*Q2**11*(
            -6692790-43045977*r**2-138804633*r**4+9040529951*r**6+31325757150*r**8
            +94929285204*r**10+132949671332*r**12+57641585244*r**14+10260629376*r**16
            +4505870285*r**18+355067277*r**20+63349533*r**22)-2*Q2**10*(-2475330
            -80127723*r**2-427329540*r**4+8482224308*r**6+62173944523*r**8+237632761038*r**10
            +504894152264*r**12+446597123224*r**14+157735353072*r**16+33855112253*r**18
            +6979631884*r**20+627808500*r**22+42879447*r**24)+2*Q2**9*(4015635-17649645*r**2
            -80633610*r**4-1824953034*r**6+29923651135*r**8+140347883043*r**10+544580901140*r**12
            +778778866780*r**14+486715657641*r**16+108009326625*r**18+22472141078*r**20
            +2820445950*r**22+299041125*r**24-17911335*r**26)+2*Q2**8*(-5095155-64812390*r**2
            -726733239*r**4+7729275950*r**6+19926490149*r**8+145558773576*r**10+76967287949*r**12
            -135228948996*r**14-279692483433*r**16-138804933646*r**18+24195819291*r**20
            -3024656826*r**22+968352551*r**24+82666044*r**26+42145695*r**28)-2*Q2**7*(
            -1141230-61180425*r**2-771079923*r**4+3106696853*r**6+26175882046*r**8
            +242266876761*r**10+592831687421*r**12+912351757243*r**14+868180549830*r**16
            +280334574881*r**18+70627874791*r**20+55988355171*r**22-628241398*r**24
            +1023832399*r**26+176923695*r**28+16904205*r**30)+2*Q2**6*(1923590-152827*r**2
            +31246698*r**4-2840959408*r**6+8847417085*r**8+65995782819*r**10+378992755352*r**12
            +759043973518*r**14+1225994189751*r**16+848962846475*r**18+178485168418*r**20
            +17273411172*r**22+24761709059*r**24+567468397*r**26+703397820*r**28
            +117341918*r**30-10364637*r**32)+2*Q2**5*(-1687020-30111117*r**2-526241814*r**4
            +3031195536*r**6-5399320116*r**8+87944018802*r**10-73099714*r**12+85799140020*r**14
            -12540830160*r**16-548859502468*r**18-205049783706*r**20-196227938040*r**22
            -67969411444*r**24-38817508986*r**26-8582403726*r**28-1238044236*r**30
            -53687964*r**32+12470553*r**34)+2*Q2**4*(309480+16643565*r**2+303501675*r**4
            -468666468*r**6+6072438630*r**8-72665356764*r**10-49742477450*r**12-222911612740*r**14
            -809622560514*r**16+56447378230*r**18+316674193628*r**20+117897252180*r**22
            +397604133970*r**24+157953921812*r**26+45568320090*r**28+9012406356*r**30
            +894533730*r**32+1524645*r**34-2924055*r**36)-2*Q2**3*(-289910-474605*r**2
            -31915293*r**4+714305651*r**6-771979178*r**8-2462298942*r**10-13502542778*r**12
            -21154868422*r**14-399967899894*r**16+182040594376*r**18+323036215364*r**20
            +30667931616*r**22+367504684738*r**24+62106880670*r**26+100384759962*r**28
            +4651250438*r**30+1576907092*r**32-89419323*r**34-26686727*r**36+1965165*r**38)
            +(-1+r**2)**2*(-11815-403479*r**2-12116849*r**4+7431355*r**6-1021262296*r**8
            +3713843244*r**10-19357856828*r**12-79702366908*r**14+643446898310*r**16
            -1875974607162*r**18+1346326900378*r**20+947285878418*r**22-1500221460412*r**24
            +547694052940*r**26-160473203388*r**28-1314878428*r**30-6495045111*r**32
            -596417831*r**34-67757105*r**36-1871029*r**38+93996*r**40)+2*Q2**2*(
            -209010-3774075*r**2-100503306*r**4+495159340*r**6-4934409087*r**8+23742388308*r**10
            -47797118772*r**12-65442601284*r**14+435289265808*r**16-512251145506*r**18
            +201626183424*r**20+843810468444*r**22-1273773051514*r**24+942040248564*r**26
            -363615254652*r**28+28925356068*r**30-22402113222*r**32-2276793771*r**34
            -420155462*r**36-21995880*r**38+1575585*r**40)+Q2*(113115+2926986*r**2
            +81610158*r**4-276256040*r**6+5678145215*r**8-28132582398*r**10+96147156696*r**12
            +166092974016*r**14-1702057063770*r**16+4055392372820*r**18-2870556455516*r**20
            +1790627790576*r**22-4370925867706*r**24+5072448079060*r**26-2208592193160*r**28
            +617619359616*r**30-27933564609*r**32+28296357282*r**34+2726470750*r**36
            +402827000*r**38+15322683*r**40-882774*r**42))*sqrtq2)*math.log(r))/(-156764160000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-16329600000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-113400000*logq2**2*(-Q2
            +(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-52500*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6+1814400000*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            +3780000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*sqrtq2+78382080000*logq2**5*r**22*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(flagPERP*(
            -217728000*logq2**5*r**18*(-200+145*r**2+1012*r**4+882*r**6+540*r**8+81*r**10)
            +17280*logq2**3*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(-22488+30273*r**2
            +24780*Q2**10*r**2+213966*r**4-6059043*r**6+20618248*r**8-84888030*r**10
            -155288556*r**12-91460606*r**14-8633472*r**16+14613837*r**18+649678*r**20
            +266193*r**22-240*Q2**9*(16+1091*r**2+1139*r**4)+12*Q2**8*(2996+97727*r**2
            +205026*r**4+103719*r**6)-8*Q2**7*(3342+346131*r**2+1096141*r**4+1126495*r**6
            +341583*r**8)+Q2**6*(-99624+2681577*r**2+13708292*r**4+23117986*r**6
            +14573036*r**8+2099769*r**10)+Q2**5*(74928+383862*r**2-5702834*r**4
            -21936812*r**6-24011804*r**8-7592338*r**10+2037462*r**12)+Q2**4*(165480
            -2521005*r**2-7996898*r**4+2608769*r**6+10198692*r**8+3975713*r**10
            -5285810*r**12-4563405*r**14)+4*Q2**3*(-43428+285039*r**2+2369635*r**4
            +6526057*r**6+9467869*r**8+10220157*r**10+5774721*r**12+2355147*r**14
            +454083*r**16)+Q2**2*(-33624+646563*r**2-433480*r**4-31103444*r**6-61896968*r**8
            -93890510*r**10-70831032*r**12-19894164*r**14-5885600*r**16+1322499*r**18)
            -2*Q2*(-41832+264021*r**2+1241905*r**4-4120864*r**6+17467592*r**8+20567770*r**10
            +2496234*r**12+4998520*r**14+8632504*r**16-466967*r**18+621117*r**20))
            -12*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(-2712+287439*r**2
            -238104*Q2**16*r**2+4900184*r**4+10162132*r**6+497223864*r**8-388793812*r**10
            +4903653544*r**12+41543999724*r**14-90886900584*r**16+195164676522*r**18
            +131529237480*r**20-58690729940*r**22+3872425160*r**24-4173200148*r**26
            -165013736*r**28-48408556*r**30-2352768*r**32+36207*r**34+16*Q2**15*(
            -4352+151701*r**2+138645*r**4)-16*Q2**14*(-25686+517545*r**2+1283702*r**4
            +466173*r**6)+32*Q2**13*(-25797+332281*r**2+2114081*r**4+2060996*r**6
            +306981*r**8)+Q2**12*(202856+1708351*r**2-85903156*r**4-156555506*r**6
            -87507260*r**8+2814687*r**10)-4*Q2**11*(-422464+3694859*r**2+6484463*r**4
            +45325634*r**6+33362354*r**8+5843407*r**10+5880699*r**12)+2*Q2**10*(
            -1174024+549571*r**2+85334662*r**4+639309361*r**6+1198799972*r**8+551615169*r**10
            +110882710*r**12+11183571*r**14)+4*Q2**9*(-6088+5556545*r**2-22252209*r**4
            -410919631*r**6-1613997185*r**8-1575770833*r**10-359844895*r**12-55137889*r**14
            +1688409*r**16)-Q2**8*(-2538008+13910839*r**2+102818064*r**4+54873344*r**6
            -5713077616*r**8-11571455758*r**10-6174435776*r**12+313981504*r**14+61814104*r**16
            +27276759*r**18)+8*Q2**7*(-224864-1718169*r**2+3960199*r**4+192721124*r**6
            +431493580*r**8+688585378*r**10+284038266*r**12+335685764*r**14+286466684*r**16
            +30896815*r**18+1861047*r**20)+4*Q2**6*(-144128+4646441*r**2+34104206*r**4
            -184985647*r**6-2463547672*r**8-9829372794*r**10-15030106684*r**12-7774343194*r**14
            -3006567672*r**16-418407567*r**18-29882146*r**20+1917801*r**22)-8*Q2**5*(
            -157924+225359*r**2+5353541*r**4+73320413*r**6-346886749*r**8-3215115490*r**10
            -11369824342*r**12-11127769486*r**14-2332004022*r**16-931884349*r**18
            +74252225*r**20+6546721*r**22+1523943*r**24)+Q2**4*(-379624-8053535*r**2
            -104498132*r**4+562203742*r**6+3902777140*r**8+15754990063*r**10-21767453480*r**12
            -101722298076*r**14-45148837984*r**16+24545508815*r**18+4260298556*r**20
            +1508646750*r**22+69858388*r**24+3208257*r**26)+4*Q2**3*(-53376+1149193*r**2
            +15158493*r**4+23832418*r**6-53435502*r**8-3272701413*r**10-8224444801*r**12
            -4639433876*r**14+7543003244*r**16-3659209521*r**18-6213214101*r**20
            -1402511342*r**22-142526622*r**24-5563667*r**26+558873*r**28)+2*Q2**2*(77528
            +164963*r**2+10249582*r**4-102552843*r**6-539164740*r**8+329288495*r**10
            +16689289154*r**12+61834524761*r**14+75216986816*r**16+30390588585*r**18
            +31671019986*r**20-269147777*r**22+361278572*r**24-151529083*r**26-2091330*r**28
            -755469*r**30)+4*Q2*(-5336-270731*r**2-5784093*r**4+5361281*r**6-173740249*r**8
            +949921405*r**10+3432897851*r**12+4839043361*r**14+8277673463*r**16+4466252503*r**18
            +21138736753*r**20-8336448469*r**22+2365991757*r**24+166280631*r**26
            +67419121*r**28+1825203*r**30+45549*r**32))+518400*logq2**4*r**14*(5664
            -16995*r**2+630*Q2**7*r**2+419633*r**4-943589*r**6-2284593*r**8-1779977*r**10
            -687613*r**12+46329*r**14+75141*r**16-10*Q2**6*(128+525*r**2+909*r**4)
            +10*Q2**5*(1104+1797*r**2+4936*r**4+4005*r**6)-2*Q2**4*(22368+24197*r**2
            +52141*r**4+93661*r**6+47637*r**8)+Q2**3*(42624+152665*r**2+312044*r**4
            +508466*r**6+476524*r**8+134361*r**10)-Q2**2*(-16864+146753*r**2+325069*r**4
            +597974*r**6+769814*r**8+429213*r**10+26289*r**12)-Q2*(30176-111367*r**2
            +155052*r**4+414267*r**6+187464*r**8-20629*r**10+86508*r**12+119529*r**14))*sqrtq2
            +(50*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(-291+525*Q2**7-20147*r**2-5111*r**4
            +211609*r**6+130409*r**8-10375*r**10-1219*r**12+45*r**14-375*Q2**6*(1
            +r**2)-5*Q2**5*(75-172*r**2+75*r**4)+Q2**4*(-291+869*r**2-139*r**4
            +45*r**6)+Q2**3*(-291+128*r**2+2840*r**4-544*r**6+45*r**8)+Q2**2*(
            -291-2315*r**2+9816*r**4+3768*r**6-859*r**8+45*r**10)+Q2*(-291-7580*r**2
            +15313*r**4+43104*r**6+1313*r**8-1084*r**10+45*r**12))-21*(Q2-(-1
            +r)**2)**2*(Q2-(1+r)**2)**2*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**2*(1008*Q2**11-2832*Q2**10*(1+r**2)+Q2**9*(-195+7066*r**2-195*r**4)
            +Q2**8*(5613-12089*r**2-15545*r**4+6765*r**6)-6*Q2**7*(410-2077*r**2
            -11198*r**4-2557*r**6+650*r**8)-2*Q2**6*(1050-6209*r**2+75495*r**4
            +79791*r**6-9821*r**8+2358*r**10)+2*Q2**5*(195-3643*r**2+88487*r**4
            +266202*r**6+106271*r**8-15163*r**10+1947*r**12)+6*Q2**4*(-35-1656*r**2
            +14696*r**4-39677*r**6-60729*r**8+19260*r**10-436*r**12+145*r**14)
            -2*Q2**3*(-306+4243*r**2+97806*r**4+49353*r**6-142976*r**8-143031*r**10
            +199758*r**12-365*r**14+270*r**16)-2*Q2**2*(-270+841*r**2+67489*r**4
            +161415*r**6+277873*r**8+567001*r**10+232599*r**12-26831*r**14-4139*r**16
            +150*r**18)-3*Q2*(41-1564*r**2+8801*r**4+157264*r**6-22330*r**8+217752*r**10
            -16282*r**12+244944*r**14-50639*r**16-2396*r**18+89*r**20)+3*(-81
            +1891*r**2+12595*r**4-110353*r**6+41402*r**8-505662*r**10-188014*r**12
            -501622*r**14+190551*r**16-9829*r**18-2309*r**20+71*r**22))+20*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(67455*Q2**13
            -172299*Q2**12*(1+r**2)+Q2**11*(-25797+449416*r**2-25797*r**4)+6*Q2**10*(39318
            -72643*r**2-113647*r**4+52986*r**6)-2*Q2**9*(-33096+273899*r**2+1321525*r**4
            +179987*r**6+13860*r**8)+2*Q2**8*(-72540+683243*r**2+2254266*r**4+1765422*r**6
            +959741*r**8-140670*r**10)+Q2**7*(-92214+1377002*r**2+6007838*r**4-4311896*r**6
            +7864034*r**8+325946*r**10-10242*r**12)+2*Q2**6*(-5010-549097*r**2+2386339*r**4
            +11084794*r**6+15974830*r**8+1272439*r**10-967309*r**12+72522*r**14)
            +Q2**5*(32523-1627274*r**2-4585140*r**4+11724390*r**6+38866462*r**8
            +21012798*r**10-10479756*r**12-806546*r**14+42183*r**16)-Q2**4*(-52593
            +170437*r**2+13400182*r**4+6991814*r**6-85316320*r**8-121678096*r**10
            +24919046*r**12+11003830*r**14-716819*r**16+33255*r**18)-Q2**3*(-17835
            -126214*r**2+12419569*r**4+76695436*r**6+102370382*r**8+16662372*r**10
            +177402758*r**12+67053196*r**14-5330531*r**16-807238*r**18+27465*r**20)
            -12*Q2**2*(1246-21931*r**2-78365*r**4+6984169*r**6+30876111*r**8+41293406*r**10
            +52004442*r**12+33637163*r**14+3645949*r**16-426473*r**18-5779*r**20
            +182*r**22)+2*Q2*(-5349+172084*r**2+1217611*r**4-25400926*r**6-160379833*r**8
            -96607978*r**10-115599310*r**12-373870930*r**14-74572099*r**16+11875358*r**18
            +26347*r**20-121064*r**22+2889*r**24)+2*(-723+62701*r**2-518515*r**4
            -12782349*r**6-85988645*r**8-201910037*r**10-303792548*r**12-806410364*r**14
            -311255519*r**16+42605365*r**18+13434855*r**20+73817*r**22-45401*r**24
            +963*r**26)))*sqrtq2+288*logq2**2*r**6*(50*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(
            -148-61251*r**2+1260*Q2**7*r**2-358607*r**4-1170425*r**6-3836109*r**8
            -4333081*r**10-1749213*r**12-66867*r**14+49221*r**16-60*Q2**6*(16+147*r**2
            +195*r**4)+15*Q2**5*(216+1371*r**2+3238*r**4+1803*r**6)+12*Q2**4*(396
            +1801*r**2+4097*r**4+3821*r**6+2553*r**8)-4*Q2**3*(2557+1264*r**2-18764*r**4
            -38619*r**6-17817*r**8+4626*r**10)-Q2**2*(2108+60055*r**2+280711*r**4
            +584270*r**6+581802*r**8+281679*r**10+62919*r**12)-Q2*(-5452+72755*r**2
            +183580*r**4+408317*r**6+546668*r**8+473529*r**10+226644*r**12+15039*r**14))
            +3*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(-13272+881781*r**2+63990*Q2**13*r**2
            -10548805*r**4-31598660*r**6+97933356*r**8-2605231*r**10+4202198063*r**12
            +6539776160*r**14+6471840920*r**16+3736225463*r**18+774956153*r**20-340764444*r**22
            +12814420*r**24+13944515*r**26-688419*r**28-6*Q2**12*(-2688+108893*r**2
            +100829*r**4)+2*Q2**11*(-76048+1375085*r**2+2826532*r**4+1222989*r**6)
            -12*Q2**10*(-24304+478812*r**2+1840205*r**4+1801545*r**6+451192*r**8)
            +5*Q2**9*(26488+854481*r**2+6975496*r**4+11157458*r**6+7078480*r**8
            +842721*r**10)+5*Q2**8*(-142968+1045437*r**2+145637*r**4+1768010*r**6
            +1213586*r**8-543307*r**10+1369533*r**12)-2*Q2**7*(-89712+3487392*r**2
            +22478831*r**4+110354420*r**6+182383870*r**8+97388768*r**10+23041727*r**12
            +7314396*r**14)+2*Q2**6*(317296-3533430*r**2+8275511*r**4+167408627*r**6
            +515133400*r**8+512517556*r**10+144151375*r**12+17008691*r**14+977622*r**16)
            +2*Q2**5*(-116088+3451794*r**2-945355*r**4-104352840*r**6-638211441*r**8
            -1140119328*r**10-701935561*r**12-72128080*r**14-4936075*r**16+6118374*r**18)
            -10*Q2**4*(32424-757392*r**2+518863*r**4+18308167*r**6+8911397*r**8
            -103702495*r**10-127098871*r**12-10942891*r**14+32475439*r**16+657355*r**18
            +521508*r**20)-10*Q2**3*(-10304+433245*r**2-2616259*r**4-25473427*r**6
            -83132444*r**8-60930070*r**10+41270254*r**12+13947074*r**14-85722524*r**16
            -46746647*r**18-4196131*r**20+509313*r**22)+2*Q2**2*(47824-1873454*r**2
            +5997343*r**4+73963855*r**6+189163390*r**8+372976052*r**10+985645078*r**12
            +1194755854*r**14+815599100*r**16-16958910*r**18+19304979*r**20-11627669*r**22
            +1352958*r**24)+Q2*(-16296+847065*r**2-10693786*r**4+29608838*r**6
            +236995990*r**8+1511846047*r**10+1733135980*r**12+3084499732*r**14+2848768084*r**16
            +979760935*r**18+522388174*r**20-185944570*r**22-20195746*r**24+1175553*r**26)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(62705664000*logq2**6*r**24
            +6531840000*logq2**4*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+45360000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4+21000*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6-31352832000*logq2**5*r**20*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2-725760000*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2-1512000*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*sqrtq2)+(flagPERP*(-18144000*logq2**4*r**14*(-132+235*r**2+753*r**4
            +537*r**6+87*r**8)+1440*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(
            -2086-70565*r**2-22320*Q2**9*r**2-228515*r**4-395120*r**6+2803540*r**8
            -53507918*r**10-56937050*r**12-12004400*r**14+7806130*r**16+621395*r**18
            +26589*r**20+56*Q2**8*(44+3477*r**2+3609*r**4)-16*Q2**7*(-798+42243*r**2
            +86828*r**4+40647*r**6)+Q2**6*(-42238+751596*r**2+2975344*r**4+3051956*r**6
            +655662*r**8)+Q2**5*(2716+211665*r**2-1687476*r**4-3981786*r**6-2189280*r**8
            +466641*r**10)+Q2**4*(67830-749225*r**2-1069561*r**4+1795052*r**6+1979494*r**8
            -199355*r**10-1213275*r**12)+2*Q2**3*(-19292+23509*r**2+911935*r**4
            +5126263*r**6+7925438*r**8+4365695*r**10+994279*r**12+196413*r**14)
            +2*Q2**2*(-10969+174669*r**2-311014*r**4-6813186*r**6-16090455*r**8
            -16604561*r**10-5347814*r**12-1143906*r**14+200916*r**16)-Q2*(-19068
            +36331*r**2+441290*r**4+4038384*r**6+13612558*r**8+5649818*r**10+4320534*r**12
            +9165520*r**14-209074*r**16+259707*r**18))-(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(11493+53280*Q2**15+677899*r**2-4092243*r**4+71681827*r**6
            +28019969*r**8+810332719*r**10+3810429257*r**12-7604966329*r**14+38506896911*r**16
            -7645588543*r**18-433638617*r**20-737295031*r**22+57191947*r**24-6330363*r**26
            -214301*r**28+3405*r**30-192240*Q2**14*(1+r**2)+64*Q2**13*(1065+10838*r**2
            +1065*r**4)+3*Q2**12*(89061-147673*r**2-342025*r**4+153845*r**6)-2*Q2**11*(
            -176787+1185332*r**2+6860846*r**4+481268*r**6+175245*r**8)+Q2**10*(
            -1236672+4813524*r**2+71651732*r**4+64463012*r**6+6192444*r**8-626280*r**10)
            +10*Q2**9*(14277+345104*r**2-9758229*r**4-28292464*r**6-8238237*r**8
            -484336*r**10+60573*r**12)+3*Q2**8*(376805-3634813*r**2+1655105*r**4
            +140719415*r**6+160151215*r**8-6288215*r**10-2461013*r**12+166685*r**14)
            -4*Q2**7*(42609+2275068*r**2-21677550*r**4-17881260*r**6-42035590*r**8
            +22639884*r**10-35113422*r**12-2410860*r**14+144705*r**16)-24*Q2**6*(27277
            -1040372*r**2+3305864*r**4+31951452*r**6+120300605*r**8+96825117*r**10
            +33620308*r**12+5731304*r**14-108798*r**16+7355*r**18)+4*Q2**5*(9681
            -293112*r**2-3555441*r**4+49093584*r**6+467575768*r**8+1438011256*r**10
            +246660808*r**12+156652224*r**14-280281*r**16-1364592*r**18+61305*r**20)
            +5*Q2**4*(42009-3659125*r**2+17643423*r**4+70601973*r**6+298399090*r**8
            -759105514*r**10-1372437898*r**12+483852178*r**14+64573653*r**16+25616319*r**18
            -140725*r**20+9177*r**22)-2*Q2**3*(-27375-3698316*r**2+14502150*r**4
            -130008540*r**6+296084335*r**8+957075000*r**10+924158452*r**12-1067850600*r**14
            +864077935*r**16+124920660*r**18+41470470*r**20-502716*r**22+22545*r**24)
            -4*Q2**2*(12918-843679*r**2+7171025*r**4+28044125*r**6-84593165*r**8
            -1653373586*r**10-4753153082*r**12-3026503010*r**14-2268378560*r**16
            -43078535*r**18+16061993*r**20+5739461*r**22-146665*r**24+3960*r**26)
            +2*Q2*(-12363-1448832*r**2+8030339*r**4-95388208*r**6+391417425*r**8
            +1384430896*r**10+3207384679*r**12-3532053408*r**14+8807398591*r**16
            -1646854880*r**18+442591017*r**20-31105072*r**22+16623419*r**24+25392*r**26
            +1005*r**28))+86400*logq2**3*r**10*(-1442+7134*r**2-720*Q2**6*r**2+84890*r**4
            -404018*r**6-657838*r**8-299046*r**10+918*r**12+26202*r**14+80*Q2**5*(7
            +33*r**2+54*r**4)-16*Q2**4*(322+409*r**2+1314*r**4+1053*r**6)+Q2**3*(3878
            +38179*r**2+101957*r**4+114753*r**6+40377*r**8)-2*Q2**2*(-2009+16516*r**2
            +57826*r**4+98304*r**6+67143*r**8+8844*r**10)-Q2*(1862-4943*r**2+69723*r**4
            +66722*r**6+14292*r**8+23901*r**10+35643*r**12))*sqrtq2+24*logq2*r**2*(
            -100*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2*(56+4847*r**2+780*Q2**6*r**2+24230*r**4
            +51033*r**6+163068*r**8+114537*r**10+5526*r**12-3777*r**14-5*Q2**5*(28
            +411*r**2+495*r**4)-Q2**4*(224+1649*r**2+1962*r**4+2097*r**6)+Q2**3*(616
            +577*r**2-6791*r**4-7659*r**6+1893*r**8)+4*Q2**2*(14+1245*r**2+4527*r**4
            +7209*r**6+4695*r**8+1182*r**10)+2*Q2*(-182+3190*r**2+6033*r**4+3405*r**6
            +8655*r**8+8385*r**10+474*r**12))-(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(23808*Q2**12*r**2
            -12*Q2**11*(-3360+42563*r**2+32483*r**4)+4*Q2**10*(-27720+470487*r**2
            +1102006*r**4+415047*r**6)-5*Q2**9*(1890+406857*r**2+2111863*r**4+2060923*r**6
            +426987*r**8)-30*Q2**8*(-8085+42661*r**2-55994*r**4-23298*r**6-96153*r**8
            +50613*r**10)+12*Q2**7*(-7350+149757*r**2+1258450*r**4+7333545*r**6
            +6318315*r**8+1111810*r**10+430497*r**12)-12*Q2**6*(18270-278516*r**2
            +670179*r**4+14723320*r**6+30755120*r**8+12854780*r**10+1066639*r**12
            +104384*r**14)-6*Q2**5*(-14910+329181*r**2+28873*r**4-13459339*r**6
            -90294915*r**8-95341715*r**10-11347299*r**12-745927*r**14+679251*r**16)
            +20*Q2**4*(5985-196197*r**2+303507*r**4+5624700*r**6-4274967*r**8-29765534*r**10
            -11817351*r**12+8898972*r**14+259482*r**16+92763*r**18)+20*Q2**3*(-1890
            +72924*r**2-403011*r**4-3467559*r**6-15563289*r**8-23676893*r**10-4673465*r**12
            -9959265*r**14-10031277*r**16-855927*r**18+89892*r**20)-12*Q2**2*(3150
            -162459*r**2+763575*r**4+7227065*r**6-6404040*r**8-68509610*r**10-96500522*r**12
            -23194050*r**14-19905590*r**16+2547765*r**18-600765*r**20+77881*r**22)
            +Q2*(5670-275661*r**2+3437969*r**4-29547675*r**6-1129035*r**8+75360490*r**10
            -125457138*r**12-457701498*r**14+365526100*r**16-264631965*r**18+75671265*r**20
            +8409749*r**22-452271*r**24)+2*(2835-226731*r**2+2845132*r**4+10898194*r**6
            -29904705*r**8+14253035*r**10-607774648*r**12+508788636*r**14+123963497*r**16
            -391301845*r**18+22217580*r**20-2080046*r**22-2592443*r**24+127509*r**26)))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(
            -2612736000*logq2**5*r**20-181440000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -630000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+1088640000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+15120000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+10500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +(flagPERP*(-129600*logq2**3*r**10*(1+r**2)*(-8+33*r**2+9*r**4)-12*logq2*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-1344*Q2**8*r**2+64*Q2**7*(-5+153*r**2
            +138*r**4)-Q2**6*(-600+12027*r**2+31390*r**4+10827*r**6)+Q2**5*(320
            -9226*r**2+22818*r**4+25378*r**6-9546*r**8)+4*Q2**3*r**2*(3101-8205*r**2
            -92396*r**4-79396*r**6-8105*r**8+441*r**10)+Q2**4*(-1000+11735*r**2
            +2000*r**4-42734*r**6-15720*r**8+19095*r**10)+Q2**2*(520-9357*r**2
            +36058*r**4+508161*r**6+918396*r**8+446561*r**10+68618*r**12-9837*r**14)
            -6*Q2*r**2*(823-4995*r**2-49853*r**4-10695*r**6+705*r**8-55813*r**10
            -2635*r**12+63*r**14)+3*(-40+987*r**2+5244*r**4+4136*r**6+24708*r**8
            +529770*r**10+274868*r**12-92664*r**14-13356*r**16+747*r**18))+(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*(69+120*Q2**7+439*r**2+2841*r**4-6469*r**6+38051*r**8-9423*r**10
            -1073*r**12+45*r**14-225*Q2**6*(1+r**2)-8*Q2**5*(15-62*r**2+15*r**4)
            +3*Q2**4*(13+87*r**2-249*r**4+125*r**6)-4*Q2**3*(-126+445*r**2+2836*r**4
            +193*r**6)+Q2**2*(-171+1157*r**2+15410*r**4+13442*r**6+1853*r**8-195*r**10)
            +4*Q2*(-54+393*r**2+2366*r**4-3538*r**6+2756*r**8+117*r**10))*sqrtq2
            +720*logq2**2*r**6*(-16*Q2**4*(4+15*r**2+27*r**4)+Q2**3*(-64+2261*r**2
            +4458*r**4+2133*r**6)-Q2**2*(-176+1681*r**2+6451*r**4+6483*r**6+1377*r**8)
            -3*Q2*(-32+367*r**2+846*r**4+14*r**6+206*r**8+639*r**10)+3*(-48
            +187*r**2+473*r**4-6852*r**6-6052*r**8-479*r**10+531*r**12))*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(2073600*logq2**4*r**16
            +86400*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+100*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-691200*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-4800*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +(flagPERP*(-720*logq2**2*r**6*(-4+21*r**2+9*r**4)-(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(21+120*Q2**7+431*r**2+2289*r**4-3941*r**6+26419*r**8
            -5607*r**10-937*r**12+45*r**14-225*Q2**6*(1+r**2)-8*Q2**5*(15-58*r**2
            +15*r**4)-4*Q2**3*(-84+275*r**2+1754*r**4+107*r**6)+3*Q2**4*(37-17*r**2
            -281*r**4+125*r**6)+Q2**2*(-99+1093*r**2+10210*r**4+8818*r**6+1717*r**8
            -195*r**10)+4*Q2*(-36+327*r**2+1534*r**4-2282*r**6+1954*r**8+63*r**10))
            +24*logq2*r**2*(-10-11*r**2-36*Q2**4*r**2+14*r**4-1326*r**6-416*r**8
            +189*r**10+2*Q2**3*(-5+132*r**2+117*r**4)-Q2**2*(-10+191*r**2+524*r**4
            +171*r**6)-2*Q2*(-5+93*r**2+2*r**4-68*r**6+108*r**8))*sqrtq2)*nlo.X1Q2(3,'SM',Q2,r))/(
            -25920*logq2**3*r**12-540*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+6480*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+15*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(flagPERP*(-12*logq2*r**4+(-3+5*Q2**3
            +5*r**2-19*r**4+5*r**6-5*Q2**2*(1+r**2)+Q2*(-5+8*r**2-5*r**4))*sqrtq2)*nlo.X1Q2(4,'SM',Q2,r))/(288*logq2**2*r**8
            +2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-48*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(flagPERP*(-272160000*logq2**4*r**16*(9
            +28*r**2+34*r**4+28*r**6+9*r**8)-7200*logq2**2*(-Q2+(-1+r)**2)*r**8*(
            -Q2+(1+r)**2)*(755*Q2**10-6460*Q2**9*(1+r**2)+19*Q2**8*(1397+2670*r**2
            +1397*r**4)-2*Q2**7*(22697+75917*r**2+75917*r**4+22697*r**6)+Q2**6*(18389
            +192140*r**2+288058*r**4+192140*r**6+18389*r**8)+Q2**5*(33782-72026*r**2
            -3024*r**4-3024*r**6-72026*r**8+33782*r**10)-Q2**4*(39655+164510*r**2
            +1238017*r**4+2141020*r**6+1238017*r**8+164510*r**10+39655*r**12)+2*Q2**3*(3721
            +115075*r**2+794925*r**4+2094619*r**6+2094619*r**8+794925*r**10+115075*r**12
            +3721*r**14)+4*Q2**2*(2651-3949*r**2+57848*r**4-355357*r**6-683806*r**8
            -355357*r**10+57848*r**12-3949*r**14+2651*r**16)-18*Q2*(453+4355*r**2
            +39700*r**4-68700*r**6-202608*r**8-202608*r**10-68700*r**12+39700*r**14
            +4355*r**16+453*r**18)+12*(179+1333*r**2+22836*r**4+74334*r**6+510837*r**8
            +822162*r**10+510837*r**12+74334*r**14+22836*r**16+1333*r**18+179*r**20))
            -(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(6866*Q2**16-23436*Q2**15*(1
            +r**2)+8*Q2**14*(865+8596*r**2+865*r**4)+8*Q2**13*(5380-11099*r**2
            -11099*r**4+5380*r**6)+Q2**12*(10045-259012*r**2-2562366*r**4-259012*r**6
            +10045*r**8)-4*Q2**11*(34147-324527*r**2-3988562*r**4-3988562*r**6-324527*r**8
            +34147*r**10)+2*Q2**10*(35759-646722*r**2-15796615*r**4-38576020*r**6
            -15796615*r**8-646722*r**10+35759*r**12)+8*Q2**9*(13745-127492*r**2
            +2119265*r**4+19072200*r**6+19072200*r**8+2119265*r**10-127492*r**12
            +13745*r**14)+Q2**8*(-91205+2043184*r**2+31186064*r**4-92196960*r**6
            -136611350*r**8-92196960*r**10+31186064*r**12+2043184*r**14-91205*r**16)
            -4*Q2**7*(8785+21669*r**2+14208392*r**4+33962024*r**6+101173570*r**8
            +101173570*r**10+33962024*r**12+14208392*r**14+21669*r**16+8785*r**18)
            +4*Q2**6*(10807-257354*r**2+4036831*r**4+57257856*r**6+179616146*r**8
            +416911988*r**10+179616146*r**12+57257856*r**14+4036831*r**16-257354*r**18
            +10807*r**20)-8*Q2**5*(266-53737*r**2-4403625*r**4+12575730*r**6+21507400*r**8
            +309675766*r**10+309675766*r**12+21507400*r**14+12575730*r**16-4403625*r**18
            -53737*r**20+266*r**22)-Q2**4*(2005+87332*r**2+26936590*r**4+29645300*r**6
            +614859675*r**8-231352920*r**10+1158640836*r**12-231352920*r**14+614859675*r**16
            +29645300*r**18+26936590*r**20+87332*r**22+2005*r**24)+4*Q2**3*(135
            -9223*r**2-887018*r**4+22918230*r**6+168130475*r**8+734118485*r**10
            +2173168916*r**12+2173168916*r**14+734118485*r**16+168130475*r**18+22918230*r**20
            -887018*r**22-9223*r**24+135*r**26)-2*Q2**2*(1265-69094*r**2-3667317*r**4
            +24306396*r**6-83158055*r**8+480299590*r**10+308598123*r**12+3065234184*r**14
            +308598123*r**16+480299590*r**18-83158055*r**20+24306396*r**22-3667317*r**24
            -69094*r**26+1265*r**28)+24*Q2*(31-1758*r**2-54453*r**4-686878*r**6
            -12831908*r**8+1292719*r**10-99093084*r**12+519615331*r**14+519615331*r**16
            -99093084*r**18+1292719*r**20-12831908*r**22-686878*r**24-54453*r**26
            -1758*r**28+31*r**30)+3*(57-3672*r**2+19060*r**4+3841960*r**6+9425060*r**8
            +68973464*r**10+826635276*r**12-1542120*r**14+7983061830*r**16-1542120*r**18
            +826635276*r**20+68973464*r**22+9425060*r**24+3841960*r**26+19060*r**28
            -3672*r**30+57*r**32))-432000*logq2**3*r**12*(867+35*Q2**7+3267*r**2
            +42957*r**4+88989*r**6+88989*r**8+42957*r**10+3267*r**12+867*r**14
            -505*Q2**6*(1+r**2)+5*Q2**5*(445+904*r**2+445*r**4)-Q2**4*(5293+15125*r**2
            +15125*r**4+5293*r**6)-3*Q2*(1+r**2)**2*(1111-2778*r**2-446*r**4-2778*r**6
            +1111*r**8)+Q2**3*(4157+17952*r**2+28010*r**4+17952*r**6+4157*r**8)
            +Q2**2*(1847-3657*r**2-14318*r**4-14318*r**6-3657*r**8+1847*r**10))*sqrtq2
            +120*logq2*r**4*(-25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(105*Q2**7-555*Q2**6*(1
            +r**2)+15*Q2**5*(19+52*r**2+19*r**4)-Q2**4*(751+5687*r**2+5687*r**4
            +751*r**6)+Q2**3*(1139+8352*r**2+14006*r**4+8352*r**6+1139*r**8)+Q2**2*(719
            +3879*r**2+4474*r**4+4474*r**6+3879*r**8+719*r**10)+Q2*(-681+2244*r**2
            +38061*r**4+66912*r**6+38061*r**8+2244*r**10-681*r**12)+3*(-87+1849*r**2
            +34455*r**4+109943*r**6+109943*r**8+34455*r**10+1849*r**12-87*r**14))
            -2*(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(971+40*Q2**9-18517*r**2-136600*r**4+561592*r**6+1104554*r**8
            +1104554*r**10+561592*r**12-136600*r**14-18517*r**16+971*r**18-889*Q2**8*(1
            +r**2)+23*Q2**7*(169+418*r**2+169*r**4)-Q2**6*(4347+16967*r**2+16967*r**4
            +4347*r**6)-2*Q2**5*(1113+3489*r**2+13232*r**4+3489*r**6+1113*r**8)
            +2*Q2**4*(2240+11225*r**2+82043*r**4+82043*r**6+11225*r**8+2240*r**10)
            +Q2**3*(1659-18836*r**2-355219*r**4-699528*r**6-355219*r**8-18836*r**10
            +1659*r**12)+Q2**2*(-2567+13091*r**2+205549*r**4+793607*r**6+793607*r**8
            +205549*r**10+13091*r**12-2567*r**14)-8*Q2*(126-2129*r**2-34216*r**4
            -21131*r**6-11300*r**8-21131*r**10-34216*r**12-2129*r**14+126*r**16)))*sqrtq2)*nlopw.X1Q2MuG(0,Q2,r))/(
            -4354560000*logq2**5*r**20-302400000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -1050000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+1814400000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+25200000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+17500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +(flagPERP*(-1512000*logq2**3*r**12*(1+r**2)*(29+50*r**2+29*r**4)-60*logq2*(
            -Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(1873-640*Q2**9-8851*r**2+85460*r**4
            +1289996*r**6+6796322*r**8+6796322*r**10+1289996*r**12+85460*r**14-8851*r**16
            +1873*r**18+8848*Q2**8*(1+r**2)-32*Q2**7*(617+1454*r**2+617*r**4)+Q2**6*(8169
            +72819*r**2+72819*r**4+8169*r**6)+2*Q2**5*(6881-28372*r**2-46826*r**4
            -28372*r**6+6881*r**8)-Q2**4*(13825+65585*r**2+481262*r**4+481262*r**6
            +65585*r**8+13825*r**10)+4*Q2**3*(903+32098*r**2+185817*r**4+339964*r**6
            +185817*r**8+32098*r**10+903*r**12)+Q2**2*(1879+11233*r**2+272487*r**4
            -159599*r**6-159599*r**8+272487*r**10+11233*r**12+1879*r**14)-2*Q2*(1967
            +21792*r**2+88088*r**4-781552*r**6-1382190*r**8-781552*r**10+88088*r**12
            +21792*r**14+1967*r**16))-3600*logq2**2*r**8*(71-160*Q2**6+6084*r**2
            +70785*r**4+118280*r**6+70785*r**8+6084*r**10+71*r**12+960*Q2**5*(1
            +r**2)-288*Q2**4*(13+24*r**2+13*r**4)+Q2**3*(3221+9879*r**2+9879*r**4
            +3221*r**6)+3*Q2**2*(607-396*r**2-982*r**4-396*r**6+607*r**8)-3*Q2*(723
            -2099*r**2-6184*r**4-6184*r**6-2099*r**8+723*r**10))*sqrtq2+(500*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4-2708*r**6-1133*r**8
            -34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1
            -19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4-26*r**6+r**8)+Q2*(1
            -31*r**2-390*r**4-390*r**6-31*r**8+r**10))-7*(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8
            -444*r**2-9976*r**4+31692*r**6-28170*r**8+31692*r**10-9976*r**12-444*r**14
            +13*r**16-24*Q2**7*(1+r**2)+Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61
            -193*r**2-193*r**4+61*r**6)+Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6
            -165*r**8)+4*Q2**3*(13-355*r**2-6138*r**4-6138*r**6-355*r**8+13*r**10)
            +Q2**2*(59-406*r**2+10313*r**4+35188*r**6+10313*r**8-406*r**10+59*r**12)
            -2*Q2*(27-595*r**2-7237*r**4+6605*r**6+6605*r**8-7237*r**10-595*r**12
            +27*r**14)))*sqrtq2)*nlopw.X1Q2MuG(1,Q2,r))/(36288000*logq2**4*r**16+1512000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+1750*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-12096000*logq2**3*r**12*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2-84000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(flagPERP*(-97200*logq2**2*r**8*(1+r**2)**2
            -3*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2+1080*logq2*r**4*(1+r**2)*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2)*nlopw.X1Q2MuG(2,Q2,r))/(-86400*logq2**3*r**12
            -1800*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+21600*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+50*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(flagPERP*(-360*logq2*r**4*(1+r**2)+2*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*nlopw.X1Q2MuG(3,Q2,r))/(720*logq2**2*r**8
            +5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)-(flagPERP*nlopw.X1Q2MuG(4,Q2,r))/(
            -12*logq2*r**4+(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2))+rhoD*((flagPERP*(-497664000*logq2**5*(-Q2+(-1+r)**2)*r**20*(
            -Q2+(1+r)**2)*(-420*Q2**9*r**2+60*Q2**8*(8+51*r**2+37*r**4)-40*Q2**7*(96
            +281*r**2+328*r**4+45*r**6)+4*Q2**6*(3360+6676*r**2+8487*r**4+1690*r**6
            -2877*r**8)+Q2**5*(-24675-44164*r**2-44222*r**4-19828*r**6+50433*r**8
            +32928*r**10)+Q2**4*(21315+47095*r**2+28212*r**4+23434*r**6-49925*r**8
            -104449*r**10-27090*r**12)-2*Q2**3*(-105+17105*r**2+3224*r**4+7017*r**6
            -23847*r**8-36323*r**10-32108*r**12+9345*r**14)+(-1+r**2)**2*(-2985
            +7299*r**2+5207*r**4-35113*r**6+43049*r**8+48649*r**10-24515*r**12
            +9277*r**14+9612*r**16)+2*Q2**2*(-8085+16460*r**2+1611*r**4-17045*r**6
            +6832*r**8+7890*r**10-25141*r**12+1203*r**14+26355*r**16)+Q2*(12225
            -33014*r**2+4784*r**4+97176*r**6-51266*r**8-200968*r**10-101904*r**12
            +68368*r**14+641*r**16-37962*r**18))-276480*logq2**3*r**12*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(-126720*Q2**15*r**2+12*Q2**14*(-64+127440*r**2
            +117135*r**4)-4*Q2**13*(-9018+1980972*r**2+3696715*r**4+1667115*r**6)
            +4*Q2**12*(-66342+5576832*r**2+16188333*r**4+14879200*r**6+4318875*r**8)
            -Q2**11*(-796827+34607052*r**2+146708482*r**4+204136788*r**6+125461505*r**8
            +25364880*r**10)+Q2**10*(-943533+21504387*r**2+159785972*r**4+291646482*r**6
            +282753307*r**8+138765515*r**10+18135630*r**12)+Q2**9*(-499389+18885840*r**2
            -242845*r**4+36241810*r**6+39677325*r**8-82100264*r**10-59160795*r**12
            +770310*r**14)-Q2**8*(-2715831+46341189*r**2+214774995*r**4+695944635*r**6
            +1182293495*r**8+839871579*r**10+201366349*r**12+19817565*r**14+11395080*r**16)
            +2*Q2**7*(-1284957+14499882*r**2+115869363*r**4+447842420*r**6+960472625*r**8
            +1041617518*r**10+498631117*r**12+102685048*r**14+10572420*r**16+4900500*r**18)
            -2*Q2**6*(245277-3953817*r**2+22867773*r**4+168027617*r**6+433359805*r**8
            +816102877*r**10+668138603*r**12+208201883*r**14+93969722*r**16+9169200*r**18
            +5243220*r**20)+2*Q2**5*(1334283-11017962*r**2-45810702*r**4-93187212*r**6
            -387157432*r**8-150485872*r**10+278775898*r**12+333818448*r**14+188193213*r**16
            +207498298*r**18+28051380*r**20+6579900*r**22)-2*Q2**4*(849609-5431365*r**2
            -34778900*r**4-97580870*r**6-493896470*r**8-545379488*r**10-105973710*r**12
            +481472390*r**14+434402575*r**16+370381925*r**18+198940034*r**20+30749680*r**22
            +3244590*r**24)+Q2**3*(-177153+1716552*r**2-6116820*r**4-113672180*r**6
            -65266565*r**8-728230504*r**10+32992736*r**12+747750120*r**14+1347126965*r**16
            +4123240*r**18+690510932*r**20-41720788*r**22+18933425*r**24-4017960*r**26)
            +(-1+r**2)**2*(52467-214959*r**2-513578*r**4+24544170*r**6-126468135*r**8
            +333630851*r**10+143760988*r**12-186943764*r**14-290848075*r**16+152935495*r**18
            +307080582*r**20-41295254*r**22+44394367*r**24+2264805*r**26+500040*r**28)
            +Q2**2*(706407-4302117*r**2-10478558*r**4+142444560*r**6-627305085*r**8
            +1016948831*r**10-401677846*r**12-242493064*r**14-730602595*r**16-672524215*r**18
            +1375783262*r**20-535514312*r**22+310701497*r**24+8919485*r**26+6513750*r**28)
            +Q2*(-330273+1943268*r**2+3255253*r**4-103200878*r**6+568986855*r**8
            -1328446124*r**10+663530109*r**12+54640474*r**14-1022622379*r**16+253007340*r**18
            +613081927*r**20-1338623402*r**22+389254373*r**24-195871268*r**26-7112345*r**28
            -3012930*r**30))+192*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(41196*Q2**21*r**2
            -12*Q2**20*(-1480+57537*r**2+57537*r**4)+120*Q2**19*(-1538+36356*r**2
            +93839*r**4+39453*r**6)-4*Q2**18*(-197020+3429590*r**2+17022939*r**4
            +17758976*r**6+4374255*r**8)+Q2**17*(-1611705+21307800*r**2+196865022*r**4
            +326801204*r**6+226422315*r**8+36585180*r**10)-Q2**16*(-825285+8328699*r**2
            +243045288*r**4+271652546*r**6+393855835*r**8+353632323*r**10+35295714*r**12)
            -2*Q2**15*(-1691530+8632397*r**2+47034651*r**4+1203624515*r**6+2322591946*r**8
            +888276297*r**10-27952759*r**12+9161007*r**14)+6*Q2**14*(-1276570+306365*r**2
            +107405990*r**4+1468114024*r**6+4369816345*r**8+4133678157*r**10+1278770820*r**12
            +132717130*r**14+15579195*r**16)-6*Q2**13*(-694360-9541905*r**2+108142642*r**4
            +1891948324*r**6+8996254464*r**8+13405058556*r**10+8681955634*r**12+1980123832*r**14
            +229100148*r**16+14985465*r**18)+Q2**12*(7231640-45106750*r**2+147589494*r**4
            -510307928*r**6+31590484676*r**8+63259793076*r**10+72748902136*r**12
            +42509817224*r**14+5135819268*r**16+692981210*r**18-25514190*r**20)+2*Q2**11*(
            -6692790-43045977*r**2-138804633*r**4+9040529951*r**6+31325757150*r**8
            +94929285204*r**10+132949671332*r**12+57641585244*r**14+10260629376*r**16
            +4505870285*r**18+355067277*r**20+63349533*r**22)-2*Q2**10*(-2475330
            -80127723*r**2-427329540*r**4+8482224308*r**6+62173944523*r**8+237632761038*r**10
            +504894152264*r**12+446597123224*r**14+157735353072*r**16+33855112253*r**18
            +6979631884*r**20+627808500*r**22+42879447*r**24)+2*Q2**9*(4015635-17649645*r**2
            -80633610*r**4-1824953034*r**6+29923651135*r**8+140347883043*r**10+544580901140*r**12
            +778778866780*r**14+486715657641*r**16+108009326625*r**18+22472141078*r**20
            +2820445950*r**22+299041125*r**24-17911335*r**26)+2*Q2**8*(-5095155-64812390*r**2
            -726733239*r**4+7729275950*r**6+19926490149*r**8+145558773576*r**10+76967287949*r**12
            -135228948996*r**14-279692483433*r**16-138804933646*r**18+24195819291*r**20
            -3024656826*r**22+968352551*r**24+82666044*r**26+42145695*r**28)-2*Q2**7*(
            -1141230-61180425*r**2-771079923*r**4+3106696853*r**6+26175882046*r**8
            +242266876761*r**10+592831687421*r**12+912351757243*r**14+868180549830*r**16
            +280334574881*r**18+70627874791*r**20+55988355171*r**22-628241398*r**24
            +1023832399*r**26+176923695*r**28+16904205*r**30)+2*Q2**6*(1923590-152827*r**2
            +31246698*r**4-2840959408*r**6+8847417085*r**8+65995782819*r**10+378992755352*r**12
            +759043973518*r**14+1225994189751*r**16+848962846475*r**18+178485168418*r**20
            +17273411172*r**22+24761709059*r**24+567468397*r**26+703397820*r**28
            +117341918*r**30-10364637*r**32)+2*Q2**5*(-1687020-30111117*r**2-526241814*r**4
            +3031195536*r**6-5399320116*r**8+87944018802*r**10-73099714*r**12+85799140020*r**14
            -12540830160*r**16-548859502468*r**18-205049783706*r**20-196227938040*r**22
            -67969411444*r**24-38817508986*r**26-8582403726*r**28-1238044236*r**30
            -53687964*r**32+12470553*r**34)+2*Q2**4*(309480+16643565*r**2+303501675*r**4
            -468666468*r**6+6072438630*r**8-72665356764*r**10-49742477450*r**12-222911612740*r**14
            -809622560514*r**16+56447378230*r**18+316674193628*r**20+117897252180*r**22
            +397604133970*r**24+157953921812*r**26+45568320090*r**28+9012406356*r**30
            +894533730*r**32+1524645*r**34-2924055*r**36)-2*Q2**3*(-289910-474605*r**2
            -31915293*r**4+714305651*r**6-771979178*r**8-2462298942*r**10-13502542778*r**12
            -21154868422*r**14-399967899894*r**16+182040594376*r**18+323036215364*r**20
            +30667931616*r**22+367504684738*r**24+62106880670*r**26+100384759962*r**28
            +4651250438*r**30+1576907092*r**32-89419323*r**34-26686727*r**36+1965165*r**38)
            +(-1+r**2)**2*(-11815-403479*r**2-12116849*r**4+7431355*r**6-1021262296*r**8
            +3713843244*r**10-19357856828*r**12-79702366908*r**14+643446898310*r**16
            -1875974607162*r**18+1346326900378*r**20+947285878418*r**22-1500221460412*r**24
            +547694052940*r**26-160473203388*r**28-1314878428*r**30-6495045111*r**32
            -596417831*r**34-67757105*r**36-1871029*r**38+93996*r**40)+2*Q2**2*(
            -209010-3774075*r**2-100503306*r**4+495159340*r**6-4934409087*r**8+23742388308*r**10
            -47797118772*r**12-65442601284*r**14+435289265808*r**16-512251145506*r**18
            +201626183424*r**20+843810468444*r**22-1273773051514*r**24+942040248564*r**26
            -363615254652*r**28+28925356068*r**30-22402113222*r**32-2276793771*r**34
            -420155462*r**36-21995880*r**38+1575585*r**40)+Q2*(113115+2926986*r**2
            +81610158*r**4-276256040*r**6+5678145215*r**8-28132582398*r**10+96147156696*r**12
            +166092974016*r**14-1702057063770*r**16+4055392372820*r**18-2870556455516*r**20
            +1790627790576*r**22-4370925867706*r**24+5072448079060*r**26-2208592193160*r**28
            +617619359616*r**30-27933564609*r**32+28296357282*r**34+2726470750*r**36
            +402827000*r**38+15322683*r**40-882774*r**42))+209018880000*logq2**6*r**24*(3
            +20*r**4-56*r**6+9*r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            -16588800*logq2**4*r**16*(-13260*Q2**14*r**2+60*Q2**13*(40+2680*r**2+2401*r**4)
            -6*Q2**12*(5100+147238*r**2+246091*r**4+112154*r**6)+4*Q2**11*(40100
            +721304*r**2+1652517*r**4+1421660*r**6+435672*r**8)-Q2**10*(447475+6049088*r**2
            +16717435*r**4+20029380*r**6+11769298*r**8+2703384*r**10)+10*Q2**9*(68555
            +805237*r**2+2501440*r**4+3686911*r**6+3084241*r**8+1407782*r**10+268974*r**12)
            -5*Q2**8*(86805+1204482*r**2+3844386*r**4+6617882*r**6+7328747*r**8
            +5298296*r**10+2150082*r**12+501012*r**14)+2*Q2**7*(-162900+537168*r**2
            -559419*r**4+448879*r**6+4767120*r**8+10594610*r**10+9988123*r**12+4398291*r**14
            +1874124*r**16)+Q2**6*(868050+2153988*r**2+18220419*r**4+28318100*r**6
            +22904339*r**8-2968560*r**10-30037967*r**12-26248396*r**14-10867545*r**16
            -5050836*r**18)+2*Q2**5*(-317550-1078182*r**2-8595135*r**4-13362360*r**6
            -11869077*r**8-483356*r**10+15992313*r**12+22072780*r**14+12186475*r**16
            +5063118*r**18+1597974*r**20)+(-1+r**2)**4*(-7925+64002*r**2-644137*r**4
            +2092860*r**6-501548*r**8-14416*r**10+1553052*r**12-405848*r**14+305105*r**16
            +1974638*r**18-7619*r**20+127836*r**22)+5*Q2**4*(5790+325128*r**2+588075*r**4
            +2765862*r**6+1529776*r**8-1393670*r**10-5670238*r**12-6381562*r**14
            -4463374*r**16+401518*r**18-1179069*r**20+206484*r**22)-10*Q2**3*(-27300
            +174264*r**2-918057*r**4+1832787*r**6-194026*r**8-1252730*r**10-218876*r**12
            +379404*r**14-893110*r**16-338902*r**18+2742397*r**20-414711*r**22+338460*r**24)
            -2*Q2*(-1+r**2)**2*(-31775+227677*r**2-2019340*r**4+5478478*r**6-1014238*r**8
            -2340054*r**10+6316966*r**12+6661844*r**14-1319973*r**16+248793*r**18
            +5766334*r**20-279938*r**22+449226*r**24)+Q2**2*(-200975+1401592*r**2
            -10450116*r**4+27647936*r**6-17373755*r**8-7527460*r**10+13976676*r**12
            +33441052*r**14+27045263*r**16-4193020*r**18-17708640*r**20+28043732*r**22
            -4073861*r**24+2547576*r**26))*sqrtq2+2304*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(556584*Q2**18*r**2-24*Q2**17*(-6440+323208*r**2+306463*r**4)
            +8*Q2**16*(-206850+5519389*r**2+11628335*r**4+5174919*r**6)-16*Q2**15*(
            -453390+8198464*r**2+29667243*r**4+28688323*r**6+7989399*r**8)+Q2**14*(
            -15560475+202083880*r**2+1220893040*r**4+1833745864*r**6+1181704395*r**8
            +225561240*r**10)-2*Q2**13*(-5645325+43616511*r**2+717343940*r**4+1230354128*r**6
            +1303767993*r**8+779996385*r**10+94366656*r**12)-Q2**12*(-21123795+215895094*r**2
            +268889069*r**4+4014555896*r**6+6997825091*r**8+2134796386*r**10-510499101*r**12
            +59589024*r**14)+4*Q2**11*(-14212275+86070211*r**2+743035225*r**4+4686585867*r**6
            +11081489235*r**8+9824682745*r**10+3123228847*r**12+360722385*r**14+78294696*r**16)
            -Q2**10*(-39352005+41037548*r**2+3285943206*r**4+23975557532*r**6+82036551836*r**8
            +111640348140*r**10+68855674586*r**12+16275034772*r**14+2141869801*r**16
            +285317208*r**18)+2*Q2**9*(15644475-159295005*r**2+299102910*r**4+1564699086*r**6
            +23439363700*r**8+50040687620*r**10+51591022530*r**12+24569424530*r**14
            +2959354561*r**16+549580505*r**18+16391760*r**20)+Q2**8*(-72689925+241774542*r**2
            +1376541385*r**4+23642841412*r**6+53046035202*r**8+80273670480*r**10
            +65852812518*r**12+5296665100*r**14-1699708733*r**16+5042504322*r**18
            -160900335*r**20+132289872*r**22)-8*Q2**7*(-4477935-12549833*r**2+113135397*r**4
            +2869845901*r**6+12111514456*r**8+27782911496*r**10+40552191738*r**12
            +27367406188*r**14+7124939001*r**16+1485846481*r**18+625020601*r**20
            +805847*r**22+13167702*r**24)+Q2**6*(22941975-222773024*r**2+320246860*r**4
            +1186948608*r**6+42075249355*r**8+123826787000*r**10+253894842256*r**12
            +302901668880*r**14+128639342541*r**16+31928011680*r**18+5192478500*r**20
            +3260490288*r**22+390413905*r**24+33194376*r**26)-2*Q2**5*(17956365-41277559*r**2
            +323114312*r**4-5311848084*r**6-7966543787*r**8-13823328875*r**10-38085421224*r**12
            +36373118112*r**14+58882418407*r**16+19450066291*r**18+33943885680*r**20
            +8402339828*r**22+2995570871*r**24+427633647*r**26+3519216*r**28)+Q2**4*(12569025
            +42558630*r**2+532283765*r**4-5857073536*r**6-20006350895*r**8-34234549530*r**10
            -191812969715*r**12-100524001040*r**14+70382940747*r**16+93491962450*r**18
            +82418789815*r**20+95990523760*r**22+24050384675*r**24+5151956514*r**26
            +571345095*r**28-1409760*r**30)+4*Q2**3*(1243725-12088901*r**2+33945405*r**4
            -197600789*r**6+1481269421*r**8+1734068835*r**10+12345396741*r**12+16114316675*r**14
            -14472290177*r**16-38680880487*r**18+1084023295*r**20-28955989079*r**22
            -2626870105*r**24-2641517559*r**26+73361791*r**28+12920745*r**30+2530464*r**32)
            -(-1+r**2)**2*(246015+536676*r**2+32866994*r**4-76476220*r**6+175415270*r**8
            +9083955020*r**10-45076434838*r**12+107812661588*r**14+2554205940*r**16
            -117106438140*r**18+3423157590*r**20+86477254348*r**22-27968873558*r**24
            +12315091780*r**26+668521870*r**28+322313500*r**30+20632189*r**32+563976*r**34)
            -Q2**2*(5835585-16402172*r**2+385462518*r**4-2053395604*r**6+1536932986*r**8
            +27486858996*r**10-116893034098*r**12+168733564812*r**14-98504943492*r**16
            -29664224772*r**18-184808077822*r**20+263810299812*r**22-154780905578*r**24
            +66730605596*r**26+491409786*r**28+2847158116*r**30+251116083*r**32+9739248*r**34)
            +2*Q2*(987525-952091*r**2+95622530*r**4-441681714*r**6+600269490*r**8
            +14843714010*r**10-78143641962*r**12+165889979990*r**14-93319820228*r**16
            +36498450420*r**18-1688578270*r**20-108839318678*r**22+176852299230*r**24
            -73189265802*r**26+24791391090*r**28+519434610*r**30+787021231*r**32
            +60572375*r**34+1916244*r**36))*sqrtq2+32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(658*Q2**22+Q2**21*(9168+5492*r**2)-Q2**20*(149367+1710440*r**2
            +145885*r**4)+2*Q2**19*(166081+11225142*r**2+11373357*r**4+513816*r**6)
            -4*Q2**18*(-500241+29074056*r**2+68728671*r**4+32028984*r**6+949307*r**8)
            +2*Q2**17*(-5615008+146448803*r**2+643844310*r**4+678188618*r**6+190108966*r**8
            +4125635*r**10)-4*Q2**16*(-3973359+74266084*r**2+679947566*r**4+1166558084*r**6
            +813909434*r**8+142704876*r**10+2477669*r**12)+2*Q2**15*(11775989-110636094*r**2
            +664396723*r**4+951187330*r**6+1749762163*r**8+1506240170*r**10+59782461*r**12
            +1513106*r**14)+2*Q2**14*(-55171233+425567014*r**2+2711053775*r**4+12958211190*r**6
            +21658743637*r**8+9739250642*r**10+1595151489*r**12+544099234*r**14+4360652*r**16)
            -2*Q2**13*(-64251489+244237704*r**2+5532279198*r**4+32275758294*r**6
            +86358159924*r**8+82047028890*r**10+28156092330*r**12+5697080754*r**14
            +880213701*r**16+5410358*r**18)+Q2**12*(32404320-689625728*r**2+6029515422*r**4
            +40568180232*r**6+219931592136*r**8+336188308392*r**10+225093896652*r**12
            +50076188856*r**14+10603021032*r**16+512577624*r**18-2528058*r**20)+2*Q2**11*(
            -115033373+399321098*r**2+2210312267*r**4+31587831686*r**6+31061512558*r**8
            +34431825288*r**10-6092006098*r**12-19785079664*r**14+9780730671*r**16
            +148443454*r**18+792861927*r**20+7594938*r**22)-2*Q2**10*(-93871869-301375562*r**2
            +3319994183*r**4+57918106482*r**6+221297158884*r**8+548728816820*r**10
            +745806838042*r**12+376195573260*r**14+111602538743*r**16+34133271638*r**18
            +4291667039*r**20+952597698*r**22+5111938*r**24)+2*Q2**9*(35349973-660880954*r**2
            +1254992504*r**4+13592393802*r**6+188409941901*r**8+595751483472*r**10
            +1400248406784*r**12+1275737968812*r**14+420777203271*r**16+112212418766*r**18
            +17786796808*r**20+3853561546*r**22+74351511*r**24-2393252*r**26)+2*Q2**8*(
            -108253049+118145044*r**2-1124814378*r**4+38306461532*r**6+18754759225*r**8
            +173212341792*r**10-500295246472*r**12-989355332216*r**14-692859876855*r**16
            -17789612956*r**18-28297635746*r**20+5682638556*r**22-1939300841*r**24
            +618754856*r**26+5264308*r**28)-2*Q2**7*(-54052263-448577294*r**2-1520978173*r**4
            +28731627586*r**6+112888864569*r**8+706645991774*r**10+929096410339*r**12
            +1001121957078*r**14+418146169379*r**16+16355794270*r**18+193861735857*r**20
            +135446846*r**22+5076541451*r**24-433805614*r**26+430061097*r**28+2026538*r**30)
            +2*Q2**6*(26086756-338891526*r**2+444452537*r**4-9932112558*r**6+69997798893*r**8
            +300770174994*r**10+915081187041*r**12+1489407656154*r**14+1687384602261*r**16
            +547655973486*r**18-13794033501*r**20+77006155926*r**22+1117169999*r**24
            -1921129978*r**26+1260136771*r**28-59789634*r**30-1335221*r**32)+2*Q2**5*(
            -41065221-30301762*r**2-2100878558*r**4+19379453494*r**6-37887938426*r**8
            +262142876010*r**10-288763677838*r**12+154465718158*r**14-604942387500*r**16
            -650739335506*r**18-222381517226*r**20-50316474078*r**22-61839285638*r**24
            -28061823154*r**26-913977578*r**28-2037242598*r**30+205606193*r**32+1540828*r**34)
            +Q2**4*(27030983+281559096*r**2+2329355103*r**4-8747645416*r**6+40739366524*r**8
            -535300669288*r**10+403110641524*r**12-1808455964520*r**14-1432781657230*r**16
            +955373106632*r**18+122065779642*r**20+994249714184*r**22+578840269196*r**24
            +246283782728*r**26+66968062644*r**28+8072207688*r**30+1963310271*r**32
            -157780704*r**34-693057*r**36)-4*Q2**3*(-2393664+28989864*r**2-155289084*r**4
            +2427128335*r**6-6125332244*r**8-451871134*r**10+21267853224*r**12-132493087338*r**14
            -254737602684*r**16+394463082666*r**18-13968192200*r**20+181366227780*r**22
            +40316224628*r**24+110206678118*r**26+21963685960*r**28+2782514298*r**30
            +999139932*r**32-155130906*r**34+9843156*r**36+123293*r**38)+2*(-1
            +r**2)**2*(-190141-1529518*r**2-33679497*r**4+9807032*r**6-1746945342*r**8
            +6647955444*r**10-39233655776*r**12-41613662324*r**14+844981789254*r**16
            -3200025798184*r**18+4808873592694*r**20-3353175039444*r**22+1172325161764*r**24
            -289357902804*r**26+26173110744*r**28-10693057756*r**30-1369313137*r**32
            -113407818*r**34-30256357*r**36+935532*r**38+5634*r**40)+2*Q2**2*(-5256619
            -1096858*r**2-569910819*r**4+3574594202*r**6-23996575640*r**8+106537748288*r**10
            -268025666192*r**12+237211890976*r**14+208084980498*r**16-175106578276*r**18
            +1047462497634*r**20-2262696717692*r**22+2130463827880*r**24-852248583952*r**26
            +143057076472*r**28-47330360656*r**30-10657058383*r**32-95706162*r**34
            -538547623*r**36+25490194*r**38+192728*r**40)-2*Q2*(-1647815-6079975*r**2
            -224696078*r**4+905703860*r**6-11449882667*r**8+57888034035*r**10-231966314240*r**12
            +211288930984*r**14+1134859600730*r**16-3216199321134*r**18-86321246700*r**20
            +6808527240080*r**22-7559948172934*r**24+3468174980510*r**26-972610147056*r**28
            +129588947480*r**30-38974080115*r**32-6566340347*r**34-280835350*r**36
            -221131268*r**38+8084625*r**40+53375*r**42))*sqrtq2))/(235146240000*logq2**5*(
            -Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +5443200000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+11340000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-470292480000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-48988800000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-340200000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -157500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*sqrtq2)
            +(flagPERP*muWC*(995328000*logq2**5*(-Q2+(-1+r)**2)*r**20*(-Q2+(1+r)**2)*(1470*Q2**9*r**2
            -30*Q2**8*(16+269*r**2+469*r**4)+20*Q2**7*(80+963*r**2+3193*r**4+2835*r**6)
            -4*Q2**6*(-560+5108*r**2+27941*r**4+51485*r**6+31164*r**8)+Q2**5*(-14175
            -4178*r**2+66926*r**4+274664*r**6+350721*r**8+155526*r**10)+Q2**4*(15295
            +29975*r**2+28974*r**4-114182*r**6-336625*r**8-325213*r**10-88200*r**12)
            +2*Q2**3*(5845-28990*r**2-20683*r**4+12156*r**6+38939*r**8+88206*r**10
            +68411*r**12-14700*r**14)+(-1+r**2)**2*(-8845+29033*r**2-61211*r**4
            +6549*r**6+40863*r**8-62737*r**10+5275*r**12+9619*r**14+11214*r**16)
            +2*Q2**2*(-19425+49690*r**2-28073*r**4-10430*r**6-4411*r**8-26830*r**10
            -1387*r**12-5334*r**14+41160*r**16)+Q2*(31525-106148*r**2+199688*r**4
            +103312*r**6-183422*r**8-12076*r**10+133552*r**12-5864*r**14+11297*r**16
            -50904*r**18))+552960*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(248850*Q2**15*r**2
            -6*Q2**14*(-544+462225*r**2+501045*r**4)+2*Q2**13*(-18108+6607467*r**2
            +14641360*r**4+7754535*r**6)-2*Q2**12*(-82212+17382627*r**2+58550863*r**4
            +64768395*r**6+21508155*r**8)+Q2**11*(-287001+54567206*r**2+241232326*r**4
            +399326904*r**6+298718235*r**8+62734590*r**10)-Q2**10*(87861+52964941*r**2
            +252208926*r**4+476583506*r**6+546076361*r**8+335211485*r**10+22265280*r**12)
            +Q2**9*(949647+35999210*r**2+76637625*r**4-129126720*r**6-495608255*r**8
            -215660138*r**10+9321375*r**12-81363960*r**14)+Q2**8*(-1063593-24698063*r**2
            +98162725*r**4+919459785*r**6+2808758075*r**8+3548991687*r**10+1678781387*r**12
            +467141535*r**14+142385310*r**16)-2*Q2**7*(-147951-7161029*r**2+51243854*r**4
            +459718030*r**6+1667162250*r**8+3200343864*r**10+2888972006*r**12+925552514*r**14
            +277610385*r**16+34519365*r**18)+Q2**6*(-598698+5435908*r**2+33257618*r**4
            +536550872*r**6+1365247320*r**8+3447892572*r**10+5402694988*r**12+3406836128*r**14
            -201251398*r**16+181390680*r**18-60775830*r**20)+2*Q2**5*(935511-8830189*r**2
            -5013379*r**4-307499349*r**6-208615924*r**8+303941046*r**10+517725796*r**12
            -37684934*r**14+535156701*r**16+1041898711*r**18+80433135*r**20+50110155*r**22)
            -2*Q2**4*(768393-5240420*r**2-4414260*r**4-317800610*r**6-420089575*r**8
            +154539954*r**10+1300738730*r**12+2209539910*r**14+1071717045*r**16+1329422210*r**18
            +770746538*r**20+94890700*r**22+20621385*r**24)-Q2**3*(259941-1209454*r**2
            +4260770*r**4+214051780*r**6+297644815*r**8+823152338*r**10-307369092*r**12
            -2210825800*r**14-2647700685*r**16+302983910*r**18-1971641054*r**20+132659396*r**22
            -82059495*r**24+14688630*r**26)+(-1+r**2)**2*(108339-188653*r**2+1409964*r**4
            +17362110*r**6-188625955*r**8+1212689517*r**10-920977454*r**12-819389068*r**14
            -94120515*r**16+268297885*r**18+364123944*r**20-100855218*r**22+76217779*r**24
            +1337955*r**26+1169370*r**28)+Q2**2*(1064799-4423729*r**2+5801634*r**4
            -38916150*r**6-495522415*r**8+1709402957*r**10-1056680512*r**12-399491188*r**14
            -1077535135*r**16-204223975*r**18+2458511994*r**20-1484766934*r**22+766933679*r**24
            -20144565*r**26+21429540*r**28)+Q2*(-587301+2212586*r**2-6006619*r**4
            +1848324*r**6+538461935*r**8-2882630238*r**10+2982761593*r**12+261290748*r**14
            -94234543*r**16+1111554430*r**18+347371999*r**20-2062937604*r**22+941486821*r**24
            -411421706*r**26+4888835*r**28-8299260*r**30))+384*logq2*r**4*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*(20598*Q2**21*r**2-6*Q2**20*(-14800+110817*r**2
            +48657*r**4)+12*Q2**19*(-81020+429860*r**2+786457*r**4+144360*r**6)
            -4*Q2**18*(-1129140+4698553*r**2+17983292*r**4+13251612*r**6+1357125*r**8)
            +Q2**17*(-10975155+40805244*r**2+239075718*r**4+267166828*r**6+140780445*r**8
            +8542980*r**10)+Q2**16*(12241215-72156519*r**2-391550736*r**4+173169526*r**6
            +240743147*r**8-107524827*r**10-1118502*r**12)-4*Q2**15*(-1165755-36799237*r**2
            -76247941*r**4+1147665975*r**6+2443518349*r**8+1125179473*r**10+97841799*r**12
            +5405793*r**14)+6*Q2**14*(-5523430-47296645*r**2-24119282*r**4+2394134421*r**6
            +7600109356*r**8+7578246829*r**10+2255947690*r**12+201903163*r**14+6278490*r**16)
            -12*Q2**13*(-3107760-29347138*r**2-6665627*r**4+1740322188*r**6+7322957831*r**8
            +11290684494*r**10+7452772375*r**12+1292795448*r**14+93830373*r**16+1079400*r**18)
            +Q2**12*(2229240-179511782*r**2+674020676*r**4+15820018380*r**6+60438769828*r**8
            +77227590488*r**10+93808149564*r**12+47111816980*r**14-7506684604*r**16
            -750261330*r**18-41315040*r**20)+4*Q2**11*(-11146005-31552419*r**2-575312853*r**4
            -2133015385*r**6+9159358092*r**8+87677333118*r**10+155353444136*r**12
            +86797134654*r**14+32886162969*r**16+10730621741*r**18+676990509*r**20
            +15227667*r**22)-2*Q2**10*(-18459870-129086889*r**2-1369636110*r**4-3883224661*r**6
            +37998501814*r**8+368288521014*r**10+960447800072*r**12+1020102784462*r**14
            +414047266746*r**16+134611791779*r**18+21199918102*r**20+976796535*r**22
            +7511166*r**24)-2*Q2**9*(-3523065+81257310*r**2+521730784*r**4+905666976*r**6
            -16688220869*r**8-259395491746*r**10-889089585360*r**12-1501335074144*r**14
            -1115069510419*r**16-197446468854*r**18-69870072736*r**20+4200081120*r**22
            +500959329*r**24+20554170*r**26)+2*Q2**8*(-14937585+17626212*r**2-171858972*r**4
            -5855811242*r**6-13869420993*r**8-63385840242*r**10+16612151224*r**12
            +180945486372*r**14-135765159363*r**16+110982032992*r**18+410591038788*r**20
            +69684476118*r**22+25489535653*r**24+1274710398*r**26+22006800*r**28)
            -4*Q2**7*(-3711465-10474983*r**2-16585311*r**4-3335685479*r**6-14586263971*r**8
            -24822762891*r**10+189495832471*r**12+934101876593*r**14+1594291209753*r**16
            +942342337579*r**18+692365728599*r**20+301626210435*r**22+58044089491*r**24
            +8811586919*r**26+308055825*r**28+1661715*r**30)+2*Q2**6*(2846010-48063629*r**2
            +73807366*r**4-437568519*r**6-20836737376*r**8-38220210749*r**10+62850072438*r**12
            +1095169406201*r**14+3234942689404*r**16+4244337067713*r**18+1096248229682*r**20
            +1270170663907*r**22+91705333008*r**24+44171379785*r**26-3904589422*r**28
            -318659733*r**30-9096486*r**32)+2*Q2**5*(-4444620+46913529*r**2+196475118*r**4
            -3157634592*r**6+4284558882*r**8-55107687144*r**10+27684987718*r**12
            -421683885480*r**14-16178868510*r**16-1685102837414*r**18-1909353319158*r**20
            +1724069831280*r**22-415439457242*r**24+380884320672*r**26+25334593602*r**28
            +11900568792*r**30+493904418*r**32+7103349*r**34)-2*Q2**4*(-1242720+14476290*r**2
            +255485487*r**4-1487436678*r**6+986660562*r**8-64504876242*r**10-38296698010*r**12
            -817663336382*r**14+334167797586*r**16+1872366492266*r**18-378607428116*r**20
            +199316660910*r**22+2271882595718*r**24+106309914682*r**26+291615743322*r**28
            +29987555478*r**30+5440765110*r**32+166532652*r**34+1058085*r**36)-4*Q2**3*(
            -311685+5689717*r**2-14874022*r**4-212397297*r**6+969486898*r**8+1596860872*r**10
            +11218336602*r**12+241251137732*r**14-48318975248*r**16+28951515474*r**18
            -1132476228514*r**20+899608770850*r**22-820548509538*r**24-9370007248*r**26
            -159001225522*r**28+1871859252*r**30-4503490619*r**32+458546753*r**34
            +28039968*r**36+655575*r**38)+(-1+r**2)**2*(-35445+1146853*r**2+20191623*r**4
            +9580655*r**6+1930424622*r**8-1633150128*r**10+18856083096*r**12+112978880216*r**14
            -592131066690*r**16+3073241166034*r**18-4482985442386*r**20+587730286974*r**22
            +2073376545124*r**24-1288465233960*r**26+451772078016*r**28-50395865664*r**30
            +16494013327*r**32+634389537*r**34+178938995*r**36+4942203*r**38+46998*r**40)
            +2*Q2**2*(-560910+12382053*r**2+90285306*r**4-533912437*r**6+6161778684*r**8
            -21754745316*r**10+34349697060*r**12-35796382404*r**14-283245399600*r**16
            +345030574462*r**18+587246697672*r**20-2860127322054*r**22+4546581750340*r**24
            -3589763502564*r**26+1616151735324*r**28-355106787156*r**30+99547657566*r**32
            +762812133*r**34+1773833726*r**36+64291155*r**38+876960*r**40)-Q2*(
            -325785+9011520*r**2+103727334*r**4-309894052*r**6+8688424663*r**8-24975593328*r**10
            +76998773208*r**12-12741385872*r**14-317796809874*r**16+2697275410816*r**18
            -1955733162796*r**20-1127394809784*r**22-5918491573658*r**24+10976288004704*r**26
            -6789817463496*r**28+2366866090416*r**30-392328447861*r**32+96607749696*r**34
            +1878119222*r**36+1304184892*r**38+41190243*r**40+459792*r**42))-418037760000*logq2**6*r**24*(21
            +20*r**2-60*r**4+28*r**6+3*r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            +33177600*logq2**4*r**16*(31740*Q2**14*r**2-120*Q2**13*(52+2833*r**2+3388*r**4)
            +6*Q2**12*(11980+270574*r**2+618653*r**4+385102*r**6)-2*Q2**11*(178440
            +2282699*r**2+7216222*r**4+8800095*r**6+3769812*r**8)+Q2**10*(983355
            +8345294*r**2+31067085*r**4+54102530*r**6+46571394*r**8+15050142*r**10)
            -10*Q2**9*(161637+1031659*r**2+3992916*r**4+8470666*r**6+10526009*r**8
            +7236579*r**10+1718622*r**12)+5*Q2**8*(309777+1852365*r**2+6301228*r**4
            +13416886*r**6+19308817*r**8+19883457*r**10+11929950*r**12+1134612*r**14)
            +Q2**7*(-680280-7861293*r**2-19253056*r**4-22220429*r**6-4169060*r**8
            +10584385*r**10-6558348*r**12-7522911*r**14+14098896*r**16)-Q2**6*(167010
            -7961931*r**2-16962953*r**4-8504875*r**6+42481197*r**8+125571275*r**10
            +149180169*r**12+80656587*r**14+34314345*r**16+23782752*r**18)+Q2**5*(388020
            -6824913*r**2-12692680*r**4-20324950*r**6+11442492*r**8+85453456*r**10
            +155104712*r**12+157978910*r**14+69065160*r**16+34556697*r**18+14757096*r**20)
            +5*Q2**4*(-47526+633585*r**2-590603*r**4+6113198*r**6+1091056*r**8-6939396*r**10
            -9354686*r**12-11008306*r**14-12300274*r**16+120723*r**18-3683487*r**20
            +111156*r**22)+(-1+r**2)**4*(-3375-5306*r**2-1205229*r**4+6032210*r**6
            -4530386*r**8-2923902*r**10-1661326*r**12-2351966*r**14+2336745*r**16
            +1901216*r**18-62493*r**20+205812*r**22)-5*Q2**3*(-22296+42333*r**2
            -3099124*r**4+9792343*r**6-4361540*r**8-6355830*r**10-3329788*r**12
            -2306098*r**14+1538260*r**16-582567*r**18+8447184*r**20-2420517*r**22
            +1448040*r**24)-Q2*(-1+r**2)**2*(-21390-121447*r**2-6552520*r**4+27690207*r**6
            -18560072*r**8-19746586*r**10-949296*r**12-13929734*r**14-7993462*r**16
            +9299217*r**18+12631496*r**20-1501737*r**22+1611324*r**24)+Q2**2*(-57225
            -359201*r**2-14203562*r**4+61084517*r**6-67260035*r**8-16991280*r**10
            +5791772*r**12+2375494*r**14-18176559*r**16-11698165*r**18-10204770*r**20
            +38197829*r**22-9870357*r**24+5083542*r**26))*sqrtq2+4608*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(881112*Q2**18*r**2-48*Q2**17*(-5220+260567*r**2
            +242332*r**4)+8*Q2**16*(-336970+8894607*r**2+19096105*r**4+8082207*r**6)
            -8*Q2**15*(-1480540+26960479*r**2+96672508*r**4+95896183*r**6+23870574*r**8)
            +Q2**14*(-26451075+386543200*r**2+1954677440*r**4+2995905932*r**6+1961391975*r**8
            +289061820*r**10)-2*Q2**13*(-13548825+222137303*r**2+1227941380*r**4
            +1731677664*r**6+1812406229*r**8+1111180125*r**10+35224308*r**12)-Q2**12*(
            -4956195-408992658*r**2-878847963*r**4+7508327928*r**6+17057833023*r**8
            +8399904298*r**10+1062403047*r**12+541678872*r**14)+4*Q2**11*(-11388855
            -103779632*r**2+317933775*r**4+7147042926*r**6+20919174555*r**8+22602908600*r**10
            +8691561161*r**12+1675420530*r**14+233748588*r**16)-Q2**10*(-47861165
            -330682016*r**2+1510698438*r**4+36301020556*r**6+136088737968*r**8+221404757220*r**10
            +165915736978*r**12+41407140196*r**14+7688641253*r**16+386357004*r**18)
            +2*Q2**9*(-7817425+2404525*r**2+564237210*r**4+10970550018*r**6+39553501960*r**8
            +74459612960*r**10+91754332530*r**12+49554975670*r**14-3369450607*r**16
            +180734875*r**18-347936820*r**20)+Q2**8*(-6689925-257148174*r**2-2013550255*r**4
            -10310373844*r**6+22392560406*r**8+170702122920*r**10+317945183394*r**12
            +197343933940*r**14+114652604271*r**16+68623886166*r**18+7616078925*r**20
            +1050406896*r**22)-8*Q2**7*(-1242835-14870379*r**2-283348179*r**4-1220319907*r**6
            +4677259268*r**8+37016732668*r**10+100814110274*r**12+123175077044*r**14
            +59633686893*r**16+29775748343*r**18+7705992873*r**20+882904951*r**22
            +43353306*r**24)+Q2**6*(-13813505+87580688*r**2-880750820*r**4-2841536076*r**6
            +5251714415*r**8+143952374020*r**10+466101881328*r**12+994413689240*r**14
            +893536032573*r**16+146687249640*r**18+138952712660*r**20-7544671756*r**22
            +536637365*r**24-415034172*r**26)+2*Q2**5*(7746855-23013293*r**2-19406016*r**4
            -3526999548*r**6-1960728169*r**8-55761423525*r**10-4715413668*r**12-11654029536*r**14
            -170795187611*r**16-54804670583*r**18+188877545760*r**20+7075908476*r**22
            +24391973117*r**24+1613718249*r**26+235889892*r**28)-Q2**4*(5686575+57802250*r**2
            -5482765*r**4-5997612032*r**6-7891921805*r**8-157401230310*r**10-65022273185*r**12
            +257445336360*r**14+456454561389*r**16+76208725630*r**18+359173796905*r**20
            +373926240160*r**22+62301990705*r**24+28649746718*r**26+2146582725*r**28
            +127570680*r**30)-4*Q2**3*(1166775-10464792*r**2+40343965*r**4+52703582*r**6
            +482259187*r**8+17620213380*r**10+10995173157*r**12+11846225290*r**14
            -50392469599*r**16-103969139664*r**18+61938410095*r**20-105860472638*r**22
            +3526849945*r**24-10854538908*r**26+769310927*r**28-45403050*r**30+19512348*r**32)
            +(-1+r**2)**2*(318305+3282512*r**2+53582878*r**4+41083360*r**6+875472190*r**8
            +6965133640*r**10-38506621906*r**12+250530796256*r**14-266820273720*r**16
            -121158357080*r**18+96817547530*r**20+79786806176*r**22-48300770446*r**24
            +23162798360*r**26-549377110*r**28+736650400*r**30+29634343*r**32+2694312*r**34)
            +Q2**2*(5641815+6042776*r**2+372278666*r**4-1338799828*r**6+1701921242*r**8
            -4598627308*r**10-59206051606*r**12+141277898124*r**14-29889909744*r**16
            -148134513084*r**18-224158466354*r**20+620960986084*r**22-463422569546*r**24
            +206222372572*r**26-23535214658*r**28+10510735972*r**30+369530121*r**32
            +72744756*r**34)-2*Q2*(1106095+5797633*r**2+116152310*r**4-254094858*r**6
            +1299592530*r**8+1083855510*r**10-34911385894*r**12+225642867830*r**14
            -241979463416*r**16+25918580240*r**18-105506777530*r**20-74345225486*r**22
            +278866032510*r**24-168016089894*r**26+62059249230*r**28-5019993950*r**30
            +2284229497*r**32+84974975*r**34+11392668*r**36))*sqrtq2-64*r**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**22*r**2+2*Q2**21*(4527-9848*r**2
            +57*r**4)+Q2**20*(-131472+202661*r**2+1063606*r**4-53319*r**6)+2*Q2**19*(421539
            +487631*r**2-11284137*r**4-5873199*r**6+180830*r**8)+Q2**18*(-3118767
            -15540804*r**2+142763490*r**4+244543128*r**6+57748669*r**8-1127640*r**10)
            +Q2**17*(7224003+62492280*r**2-441692045*r**4-1388455828*r**6-1076476847*r**8
            -142209604*r**10+1743033*r**12)+Q2**16*(-10413588-97668346*r**2+815041396*r**4
            +3293108280*r**6+3852467880*r**8+2023777578*r**10+122280432*r**12-449016*r**14)
            +Q2**15*(8083176-44826134*r**2-1135816004*r**4-2716524738*r**6+4079215624*r**8
            +4049840366*r**10+386181660*r**12+248270746*r**14-3254424*r**16)+2*Q2**14*(
            -383742+215557997*r**2+793310251*r**4-1131459921*r**6-24407375653*r**8
            -45456424991*r**10-22824668547*r**12-4558205359*r**14-404759093*r**16
            +2805810*r**18)+2*Q2**13*(-1496112-342466219*r**2-962817420*r**4+2979879996*r**6
            +53643600504*r**8+150724470810*r**10+151168910976*r**12+48447282036*r**14
            +7848250008*r**16+358259169*r**18-984340*r**20)-2*Q2**12*(1221792-157574066*r**2
            -538074255*r**4+2721193149*r**6+48373076556*r**8+176141374644*r**10+275535823362*r**12
            +186273197742*r**14+22554217332*r**16+1709466582*r**18-234439491*r**20
            +2601261*r**22)+2*Q2**11*(4751370+208777127*r**2+381681824*r**4+4340100035*r**6
            +12708080604*r**8-16946091158*r**10-156606209176*r**12-84284303598*r**14
            -63857914670*r**16-73359983329*r**18-11632461144*r**20-774176325*r**22
            +3638232*r**24)-2*Q2**10*(3752073+318829277*r**2+824043827*r**4+7200507735*r**6
            +444272078*r**8-191907669802*r**10-1008012726030*r**12-1648140944702*r**14
            -921879288343*r**16-443687213475*r**18-129287236373*r**20-15278351577*r**22
            -492477648*r**24+734032*r**26)-2*Q2**9*(526383-64238313*r**2-675686509*r**4
            -4187466654*r**6-4469296521*r**8+107204002209*r**10+1009647173595*r**12
            +2606883620364*r**14+2892464229357*r**16+898650786729*r**18+431631867705*r**20
            +39712692274*r**22+1525932621*r**24-323980033*r**26+2372985*r**28)+2*Q2**8*(2635812
            +180658719*r**2-672288995*r**4+2732817656*r**6+18611382846*r**8+2022748729*r**10
            +235700578031*r**12+578641045698*r**14+1531227611032*r**16+1297735543169*r**18
            -635489814837*r**20-40296381356*r**22-97358267482*r**24-12796835033*r**26
            -663988279*r**28+2299890*r**30)+Q2**7*(-2364216-303937586*r**2+1096110740*r**4
            -7766954190*r**6-75676779320*r**8-104054202874*r**10-36168487764*r**12
            +2398269703258*r**14+6821795868944*r**16+4390972417962*r**18+3774042983788*r**20
            +3314245046678*r**22+760678076328*r**24+216510146562*r**26+21652959444*r**28
            +533141598*r**30-474312*r**32)-2*Q2**6*(666966-2205982*r**2-204524305*r**4
            +620895375*r**6-16937169777*r**8-72632036253*r**10-112150943529*r**12
            +426555155319*r**14+3170686448475*r**16+6897627347415*r**18+1729705615125*r**20
            +3172699523925*r**22+515244268053*r**24+260567958545*r**26+10910160037*r**28
            -440751963*r**30-192077269*r**32+953043*r**34)+2*Q2**5*(856701+55721383*r**2
            -779067577*r**4+2963587080*r**6+6555794820*r**8-26615018744*r**10+146136708620*r**12
            -254845747248*r**14+746901505606*r**16+798038040326*r**18+6586836025074*r**20
            -4507809087032*r**22+2542494042932*r**24-1040545626944*r**26+606029084*r**28
            -48822684576*r**30-5567552891*r**32-240309877*r**34+674463*r**36)+Q2**4*(
            -425328-50847257*r**2+960278004*r**4-2709404943*r**6-10736579696*r**8
            +22841398100*r**10-521395517256*r**12+329843162836*r**14-3478764558496*r**16
            +4366099432842*r**18+5492586610064*r**20-11954158323442*r**22+14435567418576*r**24
            -2489157861804*r**26+1924649935464*r**28+174177529764*r**30+61432232880*r**32
            +5847856359*r**34+135698268*r**36-162935*r**38)-2*Q2**3*(130629+3502098*r**2
            -62824545*r**4+487828716*r**6-181178078*r**8+1320457844*r**10-53097976068*r**12
            +52128465444*r**14-1471202932218*r**16+1426248688488*r**18+813220414370*r**20
            +729108677052*r**22-812921053248*r**24+1056207483788*r**26+577297239628*r**28
            +17965254252*r**30+49208708493*r**32-80744826*r**34-190157961*r**36-32140088*r**38
            +124230*r**40)+2*(-1+r**2)**2*(3270+255858*r**2-12908701*r**4+23673736*r**6
            -403810881*r**8-3209458014*r**10+8694900708*r**12-51088387332*r**14-108754209488*r**16
            +956032198568*r**18-4610254072398*r**20+9070915454188*r**22-7911295335958*r**24
            +3586289799768*r**26-1025435066268*r**28+159645330708*r**30-30746648382*r**32
            -712950634*r**34-457634141*r**36-39079044*r**38-1017441*r**40+1878*r**42)
            +Q2**2*(216297+13127766*r**2-402286580*r**4+1501548566*r**6-2740912121*r**8
            -30714276184*r**10+169971276120*r**12-356225213664*r**14+394129729298*r**16
            +2119399568284*r**18-7651469740624*r**20+18099691813980*r**22-27744560828282*r**24
            +23663463335456*r**26-11378630339480*r**28+3171348788112*r**30-699327809259*r**32
            +25073274526*r**34-14122365820*r**36-1484641058*r**38-60659101*r**40
            +153768*r**42)+Q2*(-61149-4329426*r**2+178172107*r**4-629487600*r**6
            +3405530533*r**8+23546013282*r**10-125645425083*r**12+451838664640*r**14
            -690524849650*r**16+1632651625836*r**18-4282596656962*r**20+22731650897120*r**22
            -54344263132902*r**24+56571398500900*r**26-30769924587846*r**28+10148913388224*r**30
            -2027207192737*r**32+360870688006*r**34-3510692025*r**36+5738334352*r**38
            +568125105*r**40+18193626*r**42-38351*r**44))*sqrtq2))/(705438720000*logq2**5*(
            -Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +16329600000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+34020000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-1410877440000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-146966400000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-1020600000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -472500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*sqrtq2)
            +(flagPERP*muWC**2*(248832000*logq2**5*(-Q2+(-1+r)**2)*r**20*(-Q2+(1
            +r)**2)*(1470*Q2**9*r**2-30*Q2**8*(16+269*r**2+469*r**4)+20*Q2**7*(80
            +963*r**2+3193*r**4+2835*r**6)-4*Q2**6*(-560+5108*r**2+27941*r**4+51485*r**6
            +31164*r**8)+Q2**5*(-14175-4178*r**2+66926*r**4+274664*r**6+350721*r**8
            +155526*r**10)+Q2**4*(15295+29975*r**2+28974*r**4-114182*r**6-336625*r**8
            -325213*r**10-88200*r**12)+2*Q2**3*(5845-28990*r**2-20683*r**4+12156*r**6
            +38939*r**8+88206*r**10+68411*r**12-14700*r**14)+(-1+r**2)**2*(-8845
            +29033*r**2-61211*r**4+6549*r**6+40863*r**8-62737*r**10+5275*r**12
            +9619*r**14+11214*r**16)+2*Q2**2*(-19425+49690*r**2-28073*r**4-10430*r**6
            -4411*r**8-26830*r**10-1387*r**12-5334*r**14+41160*r**16)+Q2*(31525
            -106148*r**2+199688*r**4+103312*r**6-183422*r**8-12076*r**10+133552*r**12
            -5864*r**14+11297*r**16-50904*r**18))+138240*logq2**3*r**12*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(248850*Q2**15*r**2-6*Q2**14*(-544+462225*r**2
            +501045*r**4)+2*Q2**13*(-18108+6607467*r**2+14641360*r**4+7754535*r**6)
            -2*Q2**12*(-82212+17382627*r**2+58550863*r**4+64768395*r**6+21508155*r**8)
            +Q2**11*(-287001+54567206*r**2+241232326*r**4+399326904*r**6+298718235*r**8
            +62734590*r**10)-Q2**10*(87861+52964941*r**2+252208926*r**4+476583506*r**6
            +546076361*r**8+335211485*r**10+22265280*r**12)+Q2**9*(949647+35999210*r**2
            +76637625*r**4-129126720*r**6-495608255*r**8-215660138*r**10+9321375*r**12
            -81363960*r**14)+Q2**8*(-1063593-24698063*r**2+98162725*r**4+919459785*r**6
            +2808758075*r**8+3548991687*r**10+1678781387*r**12+467141535*r**14+142385310*r**16)
            -2*Q2**7*(-147951-7161029*r**2+51243854*r**4+459718030*r**6+1667162250*r**8
            +3200343864*r**10+2888972006*r**12+925552514*r**14+277610385*r**16+34519365*r**18)
            +Q2**6*(-598698+5435908*r**2+33257618*r**4+536550872*r**6+1365247320*r**8
            +3447892572*r**10+5402694988*r**12+3406836128*r**14-201251398*r**16+181390680*r**18
            -60775830*r**20)+2*Q2**5*(935511-8830189*r**2-5013379*r**4-307499349*r**6
            -208615924*r**8+303941046*r**10+517725796*r**12-37684934*r**14+535156701*r**16
            +1041898711*r**18+80433135*r**20+50110155*r**22)-2*Q2**4*(768393-5240420*r**2
            -4414260*r**4-317800610*r**6-420089575*r**8+154539954*r**10+1300738730*r**12
            +2209539910*r**14+1071717045*r**16+1329422210*r**18+770746538*r**20+94890700*r**22
            +20621385*r**24)-Q2**3*(259941-1209454*r**2+4260770*r**4+214051780*r**6
            +297644815*r**8+823152338*r**10-307369092*r**12-2210825800*r**14-2647700685*r**16
            +302983910*r**18-1971641054*r**20+132659396*r**22-82059495*r**24+14688630*r**26)
            +(-1+r**2)**2*(108339-188653*r**2+1409964*r**4+17362110*r**6-188625955*r**8
            +1212689517*r**10-920977454*r**12-819389068*r**14-94120515*r**16+268297885*r**18
            +364123944*r**20-100855218*r**22+76217779*r**24+1337955*r**26+1169370*r**28)
            +Q2**2*(1064799-4423729*r**2+5801634*r**4-38916150*r**6-495522415*r**8
            +1709402957*r**10-1056680512*r**12-399491188*r**14-1077535135*r**16-204223975*r**18
            +2458511994*r**20-1484766934*r**22+766933679*r**24-20144565*r**26+21429540*r**28)
            +Q2*(-587301+2212586*r**2-6006619*r**4+1848324*r**6+538461935*r**8
            -2882630238*r**10+2982761593*r**12+261290748*r**14-94234543*r**16+1111554430*r**18
            +347371999*r**20-2062937604*r**22+941486821*r**24-411421706*r**26+4888835*r**28
            -8299260*r**30))+96*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(20598*Q2**21*r**2
            -6*Q2**20*(-14800+110817*r**2+48657*r**4)+12*Q2**19*(-81020+429860*r**2
            +786457*r**4+144360*r**6)-4*Q2**18*(-1129140+4698553*r**2+17983292*r**4
            +13251612*r**6+1357125*r**8)+Q2**17*(-10975155+40805244*r**2+239075718*r**4
            +267166828*r**6+140780445*r**8+8542980*r**10)+Q2**16*(12241215-72156519*r**2
            -391550736*r**4+173169526*r**6+240743147*r**8-107524827*r**10-1118502*r**12)
            -4*Q2**15*(-1165755-36799237*r**2-76247941*r**4+1147665975*r**6+2443518349*r**8
            +1125179473*r**10+97841799*r**12+5405793*r**14)+6*Q2**14*(-5523430-47296645*r**2
            -24119282*r**4+2394134421*r**6+7600109356*r**8+7578246829*r**10+2255947690*r**12
            +201903163*r**14+6278490*r**16)-12*Q2**13*(-3107760-29347138*r**2-6665627*r**4
            +1740322188*r**6+7322957831*r**8+11290684494*r**10+7452772375*r**12+1292795448*r**14
            +93830373*r**16+1079400*r**18)+Q2**12*(2229240-179511782*r**2+674020676*r**4
            +15820018380*r**6+60438769828*r**8+77227590488*r**10+93808149564*r**12
            +47111816980*r**14-7506684604*r**16-750261330*r**18-41315040*r**20)+4*Q2**11*(
            -11146005-31552419*r**2-575312853*r**4-2133015385*r**6+9159358092*r**8
            +87677333118*r**10+155353444136*r**12+86797134654*r**14+32886162969*r**16
            +10730621741*r**18+676990509*r**20+15227667*r**22)-2*Q2**10*(-18459870
            -129086889*r**2-1369636110*r**4-3883224661*r**6+37998501814*r**8+368288521014*r**10
            +960447800072*r**12+1020102784462*r**14+414047266746*r**16+134611791779*r**18
            +21199918102*r**20+976796535*r**22+7511166*r**24)-2*Q2**9*(-3523065+81257310*r**2
            +521730784*r**4+905666976*r**6-16688220869*r**8-259395491746*r**10-889089585360*r**12
            -1501335074144*r**14-1115069510419*r**16-197446468854*r**18-69870072736*r**20
            +4200081120*r**22+500959329*r**24+20554170*r**26)+2*Q2**8*(-14937585
            +17626212*r**2-171858972*r**4-5855811242*r**6-13869420993*r**8-63385840242*r**10
            +16612151224*r**12+180945486372*r**14-135765159363*r**16+110982032992*r**18
            +410591038788*r**20+69684476118*r**22+25489535653*r**24+1274710398*r**26
            +22006800*r**28)-4*Q2**7*(-3711465-10474983*r**2-16585311*r**4-3335685479*r**6
            -14586263971*r**8-24822762891*r**10+189495832471*r**12+934101876593*r**14
            +1594291209753*r**16+942342337579*r**18+692365728599*r**20+301626210435*r**22
            +58044089491*r**24+8811586919*r**26+308055825*r**28+1661715*r**30)+2*Q2**6*(2846010
            -48063629*r**2+73807366*r**4-437568519*r**6-20836737376*r**8-38220210749*r**10
            +62850072438*r**12+1095169406201*r**14+3234942689404*r**16+4244337067713*r**18
            +1096248229682*r**20+1270170663907*r**22+91705333008*r**24+44171379785*r**26
            -3904589422*r**28-318659733*r**30-9096486*r**32)+2*Q2**5*(-4444620+46913529*r**2
            +196475118*r**4-3157634592*r**6+4284558882*r**8-55107687144*r**10+27684987718*r**12
            -421683885480*r**14-16178868510*r**16-1685102837414*r**18-1909353319158*r**20
            +1724069831280*r**22-415439457242*r**24+380884320672*r**26+25334593602*r**28
            +11900568792*r**30+493904418*r**32+7103349*r**34)-2*Q2**4*(-1242720+14476290*r**2
            +255485487*r**4-1487436678*r**6+986660562*r**8-64504876242*r**10-38296698010*r**12
            -817663336382*r**14+334167797586*r**16+1872366492266*r**18-378607428116*r**20
            +199316660910*r**22+2271882595718*r**24+106309914682*r**26+291615743322*r**28
            +29987555478*r**30+5440765110*r**32+166532652*r**34+1058085*r**36)-4*Q2**3*(
            -311685+5689717*r**2-14874022*r**4-212397297*r**6+969486898*r**8+1596860872*r**10
            +11218336602*r**12+241251137732*r**14-48318975248*r**16+28951515474*r**18
            -1132476228514*r**20+899608770850*r**22-820548509538*r**24-9370007248*r**26
            -159001225522*r**28+1871859252*r**30-4503490619*r**32+458546753*r**34
            +28039968*r**36+655575*r**38)+(-1+r**2)**2*(-35445+1146853*r**2+20191623*r**4
            +9580655*r**6+1930424622*r**8-1633150128*r**10+18856083096*r**12+112978880216*r**14
            -592131066690*r**16+3073241166034*r**18-4482985442386*r**20+587730286974*r**22
            +2073376545124*r**24-1288465233960*r**26+451772078016*r**28-50395865664*r**30
            +16494013327*r**32+634389537*r**34+178938995*r**36+4942203*r**38+46998*r**40)
            +2*Q2**2*(-560910+12382053*r**2+90285306*r**4-533912437*r**6+6161778684*r**8
            -21754745316*r**10+34349697060*r**12-35796382404*r**14-283245399600*r**16
            +345030574462*r**18+587246697672*r**20-2860127322054*r**22+4546581750340*r**24
            -3589763502564*r**26+1616151735324*r**28-355106787156*r**30+99547657566*r**32
            +762812133*r**34+1773833726*r**36+64291155*r**38+876960*r**40)-Q2*(
            -325785+9011520*r**2+103727334*r**4-309894052*r**6+8688424663*r**8-24975593328*r**10
            +76998773208*r**12-12741385872*r**14-317796809874*r**16+2697275410816*r**18
            -1955733162796*r**20-1127394809784*r**22-5918491573658*r**24+10976288004704*r**26
            -6789817463496*r**28+2366866090416*r**30-392328447861*r**32+96607749696*r**34
            +1878119222*r**36+1304184892*r**38+41190243*r**40+459792*r**42))-104509440000*logq2**6*r**24*(21
            +20*r**2-60*r**4+28*r**6+3*r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            +8294400*logq2**4*r**16*(31740*Q2**14*r**2-120*Q2**13*(52+2833*r**2+3388*r**4)
            +6*Q2**12*(11980+270574*r**2+618653*r**4+385102*r**6)-2*Q2**11*(178440
            +2282699*r**2+7216222*r**4+8800095*r**6+3769812*r**8)+Q2**10*(983355
            +8345294*r**2+31067085*r**4+54102530*r**6+46571394*r**8+15050142*r**10)
            -10*Q2**9*(161637+1031659*r**2+3992916*r**4+8470666*r**6+10526009*r**8
            +7236579*r**10+1718622*r**12)+5*Q2**8*(309777+1852365*r**2+6301228*r**4
            +13416886*r**6+19308817*r**8+19883457*r**10+11929950*r**12+1134612*r**14)
            +Q2**7*(-680280-7861293*r**2-19253056*r**4-22220429*r**6-4169060*r**8
            +10584385*r**10-6558348*r**12-7522911*r**14+14098896*r**16)-Q2**6*(167010
            -7961931*r**2-16962953*r**4-8504875*r**6+42481197*r**8+125571275*r**10
            +149180169*r**12+80656587*r**14+34314345*r**16+23782752*r**18)+Q2**5*(388020
            -6824913*r**2-12692680*r**4-20324950*r**6+11442492*r**8+85453456*r**10
            +155104712*r**12+157978910*r**14+69065160*r**16+34556697*r**18+14757096*r**20)
            +5*Q2**4*(-47526+633585*r**2-590603*r**4+6113198*r**6+1091056*r**8-6939396*r**10
            -9354686*r**12-11008306*r**14-12300274*r**16+120723*r**18-3683487*r**20
            +111156*r**22)+(-1+r**2)**4*(-3375-5306*r**2-1205229*r**4+6032210*r**6
            -4530386*r**8-2923902*r**10-1661326*r**12-2351966*r**14+2336745*r**16
            +1901216*r**18-62493*r**20+205812*r**22)-5*Q2**3*(-22296+42333*r**2
            -3099124*r**4+9792343*r**6-4361540*r**8-6355830*r**10-3329788*r**12
            -2306098*r**14+1538260*r**16-582567*r**18+8447184*r**20-2420517*r**22
            +1448040*r**24)-Q2*(-1+r**2)**2*(-21390-121447*r**2-6552520*r**4+27690207*r**6
            -18560072*r**8-19746586*r**10-949296*r**12-13929734*r**14-7993462*r**16
            +9299217*r**18+12631496*r**20-1501737*r**22+1611324*r**24)+Q2**2*(-57225
            -359201*r**2-14203562*r**4+61084517*r**6-67260035*r**8-16991280*r**10
            +5791772*r**12+2375494*r**14-18176559*r**16-11698165*r**18-10204770*r**20
            +38197829*r**22-9870357*r**24+5083542*r**26))*sqrtq2+1152*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(881112*Q2**18*r**2-48*Q2**17*(-5220+260567*r**2
            +242332*r**4)+8*Q2**16*(-336970+8894607*r**2+19096105*r**4+8082207*r**6)
            -8*Q2**15*(-1480540+26960479*r**2+96672508*r**4+95896183*r**6+23870574*r**8)
            +Q2**14*(-26451075+386543200*r**2+1954677440*r**4+2995905932*r**6+1961391975*r**8
            +289061820*r**10)-2*Q2**13*(-13548825+222137303*r**2+1227941380*r**4
            +1731677664*r**6+1812406229*r**8+1111180125*r**10+35224308*r**12)-Q2**12*(
            -4956195-408992658*r**2-878847963*r**4+7508327928*r**6+17057833023*r**8
            +8399904298*r**10+1062403047*r**12+541678872*r**14)+4*Q2**11*(-11388855
            -103779632*r**2+317933775*r**4+7147042926*r**6+20919174555*r**8+22602908600*r**10
            +8691561161*r**12+1675420530*r**14+233748588*r**16)-Q2**10*(-47861165
            -330682016*r**2+1510698438*r**4+36301020556*r**6+136088737968*r**8+221404757220*r**10
            +165915736978*r**12+41407140196*r**14+7688641253*r**16+386357004*r**18)
            +2*Q2**9*(-7817425+2404525*r**2+564237210*r**4+10970550018*r**6+39553501960*r**8
            +74459612960*r**10+91754332530*r**12+49554975670*r**14-3369450607*r**16
            +180734875*r**18-347936820*r**20)+Q2**8*(-6689925-257148174*r**2-2013550255*r**4
            -10310373844*r**6+22392560406*r**8+170702122920*r**10+317945183394*r**12
            +197343933940*r**14+114652604271*r**16+68623886166*r**18+7616078925*r**20
            +1050406896*r**22)-8*Q2**7*(-1242835-14870379*r**2-283348179*r**4-1220319907*r**6
            +4677259268*r**8+37016732668*r**10+100814110274*r**12+123175077044*r**14
            +59633686893*r**16+29775748343*r**18+7705992873*r**20+882904951*r**22
            +43353306*r**24)+Q2**6*(-13813505+87580688*r**2-880750820*r**4-2841536076*r**6
            +5251714415*r**8+143952374020*r**10+466101881328*r**12+994413689240*r**14
            +893536032573*r**16+146687249640*r**18+138952712660*r**20-7544671756*r**22
            +536637365*r**24-415034172*r**26)+2*Q2**5*(7746855-23013293*r**2-19406016*r**4
            -3526999548*r**6-1960728169*r**8-55761423525*r**10-4715413668*r**12-11654029536*r**14
            -170795187611*r**16-54804670583*r**18+188877545760*r**20+7075908476*r**22
            +24391973117*r**24+1613718249*r**26+235889892*r**28)-Q2**4*(5686575+57802250*r**2
            -5482765*r**4-5997612032*r**6-7891921805*r**8-157401230310*r**10-65022273185*r**12
            +257445336360*r**14+456454561389*r**16+76208725630*r**18+359173796905*r**20
            +373926240160*r**22+62301990705*r**24+28649746718*r**26+2146582725*r**28
            +127570680*r**30)-4*Q2**3*(1166775-10464792*r**2+40343965*r**4+52703582*r**6
            +482259187*r**8+17620213380*r**10+10995173157*r**12+11846225290*r**14
            -50392469599*r**16-103969139664*r**18+61938410095*r**20-105860472638*r**22
            +3526849945*r**24-10854538908*r**26+769310927*r**28-45403050*r**30+19512348*r**32)
            +(-1+r**2)**2*(318305+3282512*r**2+53582878*r**4+41083360*r**6+875472190*r**8
            +6965133640*r**10-38506621906*r**12+250530796256*r**14-266820273720*r**16
            -121158357080*r**18+96817547530*r**20+79786806176*r**22-48300770446*r**24
            +23162798360*r**26-549377110*r**28+736650400*r**30+29634343*r**32+2694312*r**34)
            +Q2**2*(5641815+6042776*r**2+372278666*r**4-1338799828*r**6+1701921242*r**8
            -4598627308*r**10-59206051606*r**12+141277898124*r**14-29889909744*r**16
            -148134513084*r**18-224158466354*r**20+620960986084*r**22-463422569546*r**24
            +206222372572*r**26-23535214658*r**28+10510735972*r**30+369530121*r**32
            +72744756*r**34)-2*Q2*(1106095+5797633*r**2+116152310*r**4-254094858*r**6
            +1299592530*r**8+1083855510*r**10-34911385894*r**12+225642867830*r**14
            -241979463416*r**16+25918580240*r**18-105506777530*r**20-74345225486*r**22
            +278866032510*r**24-168016089894*r**26+62059249230*r**28-5019993950*r**30
            +2284229497*r**32+84974975*r**34+11392668*r**36))*sqrtq2-16*r**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**22*r**2+2*Q2**21*(4527-9848*r**2
            +57*r**4)+Q2**20*(-131472+202661*r**2+1063606*r**4-53319*r**6)+2*Q2**19*(421539
            +487631*r**2-11284137*r**4-5873199*r**6+180830*r**8)+Q2**18*(-3118767
            -15540804*r**2+142763490*r**4+244543128*r**6+57748669*r**8-1127640*r**10)
            +Q2**17*(7224003+62492280*r**2-441692045*r**4-1388455828*r**6-1076476847*r**8
            -142209604*r**10+1743033*r**12)+Q2**16*(-10413588-97668346*r**2+815041396*r**4
            +3293108280*r**6+3852467880*r**8+2023777578*r**10+122280432*r**12-449016*r**14)
            +Q2**15*(8083176-44826134*r**2-1135816004*r**4-2716524738*r**6+4079215624*r**8
            +4049840366*r**10+386181660*r**12+248270746*r**14-3254424*r**16)+2*Q2**14*(
            -383742+215557997*r**2+793310251*r**4-1131459921*r**6-24407375653*r**8
            -45456424991*r**10-22824668547*r**12-4558205359*r**14-404759093*r**16
            +2805810*r**18)+2*Q2**13*(-1496112-342466219*r**2-962817420*r**4+2979879996*r**6
            +53643600504*r**8+150724470810*r**10+151168910976*r**12+48447282036*r**14
            +7848250008*r**16+358259169*r**18-984340*r**20)-2*Q2**12*(1221792-157574066*r**2
            -538074255*r**4+2721193149*r**6+48373076556*r**8+176141374644*r**10+275535823362*r**12
            +186273197742*r**14+22554217332*r**16+1709466582*r**18-234439491*r**20
            +2601261*r**22)+2*Q2**11*(4751370+208777127*r**2+381681824*r**4+4340100035*r**6
            +12708080604*r**8-16946091158*r**10-156606209176*r**12-84284303598*r**14
            -63857914670*r**16-73359983329*r**18-11632461144*r**20-774176325*r**22
            +3638232*r**24)-2*Q2**10*(3752073+318829277*r**2+824043827*r**4+7200507735*r**6
            +444272078*r**8-191907669802*r**10-1008012726030*r**12-1648140944702*r**14
            -921879288343*r**16-443687213475*r**18-129287236373*r**20-15278351577*r**22
            -492477648*r**24+734032*r**26)-2*Q2**9*(526383-64238313*r**2-675686509*r**4
            -4187466654*r**6-4469296521*r**8+107204002209*r**10+1009647173595*r**12
            +2606883620364*r**14+2892464229357*r**16+898650786729*r**18+431631867705*r**20
            +39712692274*r**22+1525932621*r**24-323980033*r**26+2372985*r**28)+2*Q2**8*(2635812
            +180658719*r**2-672288995*r**4+2732817656*r**6+18611382846*r**8+2022748729*r**10
            +235700578031*r**12+578641045698*r**14+1531227611032*r**16+1297735543169*r**18
            -635489814837*r**20-40296381356*r**22-97358267482*r**24-12796835033*r**26
            -663988279*r**28+2299890*r**30)+Q2**7*(-2364216-303937586*r**2+1096110740*r**4
            -7766954190*r**6-75676779320*r**8-104054202874*r**10-36168487764*r**12
            +2398269703258*r**14+6821795868944*r**16+4390972417962*r**18+3774042983788*r**20
            +3314245046678*r**22+760678076328*r**24+216510146562*r**26+21652959444*r**28
            +533141598*r**30-474312*r**32)-2*Q2**6*(666966-2205982*r**2-204524305*r**4
            +620895375*r**6-16937169777*r**8-72632036253*r**10-112150943529*r**12
            +426555155319*r**14+3170686448475*r**16+6897627347415*r**18+1729705615125*r**20
            +3172699523925*r**22+515244268053*r**24+260567958545*r**26+10910160037*r**28
            -440751963*r**30-192077269*r**32+953043*r**34)+2*Q2**5*(856701+55721383*r**2
            -779067577*r**4+2963587080*r**6+6555794820*r**8-26615018744*r**10+146136708620*r**12
            -254845747248*r**14+746901505606*r**16+798038040326*r**18+6586836025074*r**20
            -4507809087032*r**22+2542494042932*r**24-1040545626944*r**26+606029084*r**28
            -48822684576*r**30-5567552891*r**32-240309877*r**34+674463*r**36)+Q2**4*(
            -425328-50847257*r**2+960278004*r**4-2709404943*r**6-10736579696*r**8
            +22841398100*r**10-521395517256*r**12+329843162836*r**14-3478764558496*r**16
            +4366099432842*r**18+5492586610064*r**20-11954158323442*r**22+14435567418576*r**24
            -2489157861804*r**26+1924649935464*r**28+174177529764*r**30+61432232880*r**32
            +5847856359*r**34+135698268*r**36-162935*r**38)-2*Q2**3*(130629+3502098*r**2
            -62824545*r**4+487828716*r**6-181178078*r**8+1320457844*r**10-53097976068*r**12
            +52128465444*r**14-1471202932218*r**16+1426248688488*r**18+813220414370*r**20
            +729108677052*r**22-812921053248*r**24+1056207483788*r**26+577297239628*r**28
            +17965254252*r**30+49208708493*r**32-80744826*r**34-190157961*r**36-32140088*r**38
            +124230*r**40)+2*(-1+r**2)**2*(3270+255858*r**2-12908701*r**4+23673736*r**6
            -403810881*r**8-3209458014*r**10+8694900708*r**12-51088387332*r**14-108754209488*r**16
            +956032198568*r**18-4610254072398*r**20+9070915454188*r**22-7911295335958*r**24
            +3586289799768*r**26-1025435066268*r**28+159645330708*r**30-30746648382*r**32
            -712950634*r**34-457634141*r**36-39079044*r**38-1017441*r**40+1878*r**42)
            +Q2**2*(216297+13127766*r**2-402286580*r**4+1501548566*r**6-2740912121*r**8
            -30714276184*r**10+169971276120*r**12-356225213664*r**14+394129729298*r**16
            +2119399568284*r**18-7651469740624*r**20+18099691813980*r**22-27744560828282*r**24
            +23663463335456*r**26-11378630339480*r**28+3171348788112*r**30-699327809259*r**32
            +25073274526*r**34-14122365820*r**36-1484641058*r**38-60659101*r**40
            +153768*r**42)+Q2*(-61149-4329426*r**2+178172107*r**4-629487600*r**6
            +3405530533*r**8+23546013282*r**10-125645425083*r**12+451838664640*r**14
            -690524849650*r**16+1632651625836*r**18-4282596656962*r**20+22731650897120*r**22
            -54344263132902*r**24+56571398500900*r**26-30769924587846*r**28+10148913388224*r**30
            -2027207192737*r**32+360870688006*r**34-3510692025*r**36+5738334352*r**38
            +568125105*r**40+18193626*r**42-38351*r**44))*sqrtq2))/(470292480000*logq2**5*(
            -Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +10886400000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+22680000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-940584960000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-97977600000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-680400000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -315000*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*sqrtq2)
            +(muWC**2*(-124416000*logq2**5*r**18*(210*Q2**11*(3+35*r**4)-30*Q2**10*(139
            +403*r**2+2395*r**4+2835*r**6)+10*Q2**9*(-93+6460*r**2+37362*r**4+68840*r**6
            +43155*r**8)-2*Q2**8*(-43137-1353*r**2+466970*r**4+1274250*r**6+1396755*r**8
            +630315*r**10)+Q2**7*(-333657-695205*r**2+617972*r**4+4108870*r**6+7682355*r**8
            +6215295*r**10+2307690*r**12)-Q2**6*(-577017-1815828*r**2-1368477*r**4
            +1136792*r**6+7530745*r**8+12057360*r**10+7952805*r**12+2619540*r**14)
            +Q2**5*(-390789-1771329*r**2-2300965*r**4-3588411*r**6+219159*r**8+5265185*r**10
            +9402645*r**12+5088195*r**14+1512630*r**16)+(-1+r**2)**4*(-50811-59170*r**2
            -78100*r**4-1168700*r**6+966090*r**8+1815876*r**10-624940*r**12+144820*r**14
            +147985*r**16+56070*r**18)+Q2**4*(-277515+127260*r**2+551864*r**4+1992016*r**6
            +1758510*r**8+1439540*r**10+173560*r**12-1927800*r**14+50925*r**16+264600*r**18)
            +Q2**3*(798831+941529*r**2+704004*r**4+5474320*r**6+2718706*r**8-9523494*r**10
            -4247596*r**12+890120*r**14-1417065*r**16-2331915*r**18-1224720*r**20)
            -Q2*(-1+r**2)**2*(-296283-345483*r**2-356510*r**4-5931470*r**6-342320*r**8
            +11074148*r**10+6242258*r**12-2673130*r**14+657075*r**16+798015*r**18
            +366660*r**20)+Q2**2*(-701163-370290*r**2-132073*r**4-9611910*r**6-766170*r**8
            +8973728*r**10+13079130*r**12+10410528*r**14-4762795*r**16+41970*r**18
            +1248255*r**20+976710*r**22))-69120*logq2**3*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(90*Q2**17*(2833+13825*r**4)-6*Q2**16*(553779+590423*r**2
            +2381651*r**4+2919975*r**6)+4*Q2**15*(4802751+9975813*r**2+24319926*r**4
            +43911329*r**6+27213075*r**8)-4*Q2**14*(16013610+48807513*r**2+110965161*r**4
            +216529977*r**6+232910395*r**8+96300900*r**10)+Q2**13*(133604595+536464833*r**2
            +1283476274*r**4+2590166818*r**6+3505735707*r**8+2721985805*r**10+821381400*r**12)
            -Q2**12*(174344445+891482862*r**2+2195053265*r**4+4474402322*r**6+6672309603*r**8
            +6862668238*r**10+4487390135*r**12+953753850*r**14)+2*Q2**11*(63033921
            +443775771*r**2+903305841*r**4+1286613868*r**6+1500804158*r**8+1165903415*r**10
            +1572659733*r**12+1573756334*r**14+64752975*r**16)+2*Q2**10*(-6880401
            -234726204*r**2+171557917*r**4+3093556597*r**6+8290024575*r**8+13792720873*r**10
            +14307208315*r**12+7247183275*r**14+1267991306*r**16+707119875*r**18)
            -Q2**9*(68647095-57819879*r**2+2306931152*r**4+15943508094*r**6+44104255460*r**8
            +76345361820*r**10+91361517386*r**12+73237928802*r**14+32951341909*r**16
            +7898797515*r**18+2175866550*r**20)+Q2**8*(84418785+103635234*r**2+2670724257*r**4
            +16911203704*r**6+53309686786*r**8+95987397520*r**10+121498388474*r**12
            +114872019532*r**14+73721083469*r**16+25043600286*r**18+7045902165*r**20
            +1098434700*r**22)+4*Q2**7*(-18767430-52199394*r**2-734223105*r**4-2704214669*r**6
            -10139170156*r**8-15930723636*r**10-14308579034*r**12-10311787120*r**14
            -8376575184*r**16-2635049086*r**18+2497101279*r**20-332359095*r**22+190916550*r**24)
            -4*Q2**6*(-15049647-81086295*r**2-924629406*r**4-1608397082*r**6-7856113417*r**8
            -10726446979*r**10-317814426*r**12+19298405890*r**14+27175249033*r**16
            +17132710433*r**18+11390182792*r**20+8908053192*r**22+679536767*r**24
            +378074025*r**26)+Q2**5*(-24550083-277914465*r**2-2678215590*r**4-4578043346*r**6
            -24365651425*r**8-52324499663*r**10-45831958424*r**12+16727806652*r**14
            +108147336803*r**16+127064927465*r**18+74200896586*r**20+40508501174*r**22
            +26834815713*r**24+2605665703*r**26+840086100*r**28)+(-1+r**2)**4*(-637119
            -2692980*r**2-107766829*r**4+234433374*r**6-2159055831*r**8-1783465252*r**10
            +8132972955*r**12-1275212762*r**14-3178311733*r**16+700150212*r**18+4347007921*r**20
            +1689109050*r**22-105235509*r**24+385532884*r**26+12044769*r**28+5846850*r**30)
            +Q2**4*(-16061715+101958798*r**2-379151879*r**4+3591455502*r**6-623588635*r**8
            +22959030690*r**10+41561977289*r**12+35116868458*r**14+15206678031*r**16
            -14702078910*r**18-7852446525*r**20-14006468462*r**22-14537415329*r**24
            -1780835058*r**26-1062782405*r**28+47820150*r**30)+2*Q2**3*(14606685
            +4515279*r**2+1186623397*r**4-2367522036*r**6+13863072416*r**8+8843306325*r**10
            +3650138367*r**12+16637803606*r**14+838701192*r**16-6143224807*r**18
            +1071253475*r**20-33641882496*r**22-13569863028*r**24+5351881219*r**26
            -5521455559*r**28+148903390*r**30-164617425*r**32)-Q2*(-1+r**2)**2*(
            -5269869-14992179*r**2-721133539*r**4+1601606015*r**6-12697168497*r**8
            -10866683383*r**10+25424271673*r**12+2016466123*r**14+15227385945*r**16
            +4546384199*r**18-5309863817*r**20+24327598381*r**22+10945259541*r**24
            -2251117085*r**26+2838479923*r**28+43346569*r**30+53190000*r**32)+2*Q2**2*(
            -8895465-9298656*r**2-957711495*r**4+2673042649*r**6-15645330999*r**8
            -2547954159*r**10+13885187437*r**12-15154586035*r**14+22842142547*r**16
            +32408520613*r**18+12506484123*r**20-28367892901*r**22+20096329155*r**24
            +16078445379*r**26-6900060289*r**28+4231197951*r**30-69853430*r**32+97993575*r**34))
            -48*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(102990*Q2**23*(1+r**4)
            -6*Q2**22*(250975+129615*r**2+214351*r**4+277615*r**6)+6*Q2**21*(1646615
            +1736600*r**2-1141014*r**4+3823540*r**6+1947335*r**8)-2*Q2**20*(18899085
            +30364065*r**2-77875078*r**4-45784454*r**6+79921989*r**8+22962705*r**10)
            +Q2**19*(90583365+198784575*r**2-1075702342*r**4-2052365826*r**6-919050211*r**8
            +538147875*r**10+105661500*r**12)+Q2**18*(-130414245-384224610*r**2+4565476427*r**4
            +12392177214*r**6+15028746725*r**8+7627142086*r**10-635757075*r**12-118164810*r**14)
            -Q2**17*(-75207015-378950325*r**2+13605980135*r**4+46150104725*r**6+77563654531*r**8
            +84676747293*r**10+38886392737*r**12+1737385851*r**14+54215940*r**16)
            +Q2**16*(97168005+69795150*r**2+28807057876*r**4+123911235500*r**6+251267030090*r**8
            +359650653908*r**10+323922260860*r**12+117060991036*r**14+8532203745*r**16
            +398993910*r**18)-4*Q2**15*(59591970+203597265*r**2+10132429775*r**4
            +59535219310*r**6+142109797822*r**8+229515603654*r**10+256386998498*r**12
            +186663312110*r**14+48946523260*r**16+3730648317*r**18+137397315*r**20)
            +4*Q2**14*(37195320+331906875*r**2+7208077054*r**4+72869690417*r**6+194423836992*r**8
            +334882621288*r**10+344017158788*r**12+284260315716*r**14+204357116272*r**16
            +25443780557*r**18+2108325750*r**20+27826875*r**22)+4*Q2**13*(32218230
            -312707055*r**2+3278960761*r**4-34823145093*r**6-56952818495*r**8-16507535744*r**10
            +336029336760*r**12+796925322712*r**14+538270991794*r**16+96457539855*r**18
            +69505893343*r**20+3603961725*r**22+163234935*r**24)-4*Q2**12*(72207330
            -147508335*r**2+13612937936*r**4+45683665020*r**6+301104688958*r**8+960411623823*r**10
            +2333980627392*r**12+4197046452440*r**14+4496386659270*r**16+2304700044111*r**18
            +636679251104*r**20+163841395276*r**22+8160516234*r**24+222698385*r**26)
            +2*Q2**11*(74484735+243577425*r**2+25911284958*r**4+189445855490*r**6
            +1081357300445*r**8+3560584575747*r**10+7974086979100*r**12+14828149949132*r**14
            +19275539081505*r**16+15730751366095*r**18+5780101131182*r**20+1631761511330*r**22
            +248829102483*r**24+10530252525*r**26+124617480*r**28)+2*Q2**10*(51303705
            -729199770*r**2-3843347523*r**4-126371296894*r**6-718444134359*r**8-2981112783274*r**10
            -4810580073843*r**12-7711324300822*r**14-11590861514341*r**16-12699497517486*r**18
            -8912846316889*r**20+104258081302*r**22-448380573533*r**24+102726928146*r**26
            +5931410511*r**28+278019870*r**30)-2*Q2**9*(91558515-737355075*r**2+14202987453*r**4
            +2683661179*r**6-32458706161*r**8-1665637530223*r**10+2163753671577*r**12
            +13343576719375*r**14+23811252907761*r**16+26612197330431*r**18+18793158395407*r**20
            +9672637249177*r**22+8719728345101*r**24+1182899408499*r**26+361345995099*r**28
            +14995516125*r**30+339456000*r**32)+2*Q2**8*(37199655-204254490*r**2
            +12930631648*r**4+59739735976*r**6+227375466680*r**8-1471329247488*r**10
            +4932064841080*r**12+26655811169528*r**14+54983153719326*r**16+72370491773980*r**18
            +64599418302224*r**20+37137971931000*r**22+19216132278304*r**24+9423417150128*r**26
            +1525127744280*r**28+256211087144*r**30+8729650275*r**32+97785870*r**34)
            +2*Q2**7*(20065185-337754010*r**2-2265745529*r**4-43851694540*r**6-267407020384*r**8
            +837795447224*r**10-3851188124004*r**12-20605145960308*r**14-44985021837310*r**16
            -62373100416564*r**18-65590423300102*r**20-43092461648308*r**22-8014732653480*r**24
            -12006885219160*r**26-861195771172*r**28-568054891532*r**30+30512370277*r**32
            +2227082862*r**34+109864455*r**36)-2*Q2**6*(28244295-412257975*r**2+3167065187*r**4
            -21856364315*r**6-420529214180*r**8-836302904664*r**10-2590042804500*r**12
            -8929213391672*r**14-22557468752430*r**16-10122184847310*r**18+1370973923578*r**20
            -2991266734710*r**22+6894207426348*r**24+37478193467200*r**26-3310317115140*r**28
            +6364691569856*r**30+310064086175*r**32+167659768477*r**34+6049115835*r**36
            +121806345*r**38)+2*Q2**5*(9598875-148942110*r**2+2037629884*r**4-10639584718*r**6
            -389625479019*r**8-1388583002948*r**10-486591633596*r**12-4301025243724*r**14
            -24773923623222*r**16-10130399577536*r**18+16618393049516*r**20+43536161066712*r**22
            +23792991928726*r**24+12880640142788*r**26+44737378648044*r**28-1021579991188*r**30
            +5426467214619*r**32+417360914014*r**34+103560430952*r**36+3165616086*r**38
            +39541845*r**40)+(-1+r**2)**4*(57765-1617990*r**2-6165578*r**4-431607756*r**6
            -14767827259*r**8+34119582198*r**10-327677918280*r**12+1470115084224*r**14
            -9024413350102*r**16+13461905694612*r**18+13297141683796*r**20-37763580593080*r**22
            +19244776039986*r**24+5487191038972*r**26-5156635951272*r**28+2421315019104*r**30
            -247276980015*r**32+92007697618*r**34+3809798886*r**36+908307044*r**38
            +20812137*r**40+234990*r**42)+2*Q2**4*(3034005-62168925*r**2-56241734*r**4
            -214979742*r**6+65259199273*r**8+676928209351*r**10-1858053542824*r**12
            +5171882732408*r**14+15027395767802*r**16+8501117974182*r**18+18793969576508*r**20
            +10480371959948*r**22-14376623989014*r**24-4004059389178*r**26-2368602101608*r**28
            -10828862201864*r**30-1471467301199*r**32-767347923785*r**34-166248497382*r**36
            -5217296222*r**38+24094125*r**40+12205875*r**42)+Q2**3*(-8198475+180214935*r**2
            -761871382*r**4+13162240206*r**6+339736018145*r**8-646518862209*r**10
            +5471004439900*r**12-14363670940664*r**14+43589578591242*r**16+14485900968030*r**18
            +5723709185932*r**20+28275065084820*r**22+8139257967114*r**24-59750693767802*r**26
            -52989187140720*r**28+59899554564488*r**30-43086810510655*r**32+9768706591467*r**34
            -3062176040646*r**36+25502854670*r**38-53177109611*r**40-1660849125*r**42
            -32949660*r**44)-Q2*(-1+r**2)**2*(684825-17991675*r**2+6583784*r**4
            -3281519032*r**6-107137155873*r**8+224417852591*r**10-1880331140460*r**12
            +6886400002728*r**14-41864118230894*r**16+40932763014874*r**18+58037044971432*r**20
            -30491260360360*r**22-99478035613418*r**24+74732484215334*r**26+36689065357696*r**28
            -35284079111112*r**30+17011169401125*r**32-2336875402159*r**34+728880172592*r**36
            +22327916928*r**38+8512462139*r**40+213439995*r**42+2768940*r**44)+Q2**2*(3379035
            -84132330*r**2+310899043*r**4-10143942050*r**6-294929237119*r**8+721973248062*r**10
            -4651541905087*r**12+16037888152182*r**14-82247293182130*r**16+79087865117132*r**18
            +24879248368894*r**20+6522502300316*r**22+37291682545026*r**24-147761028992180*r**26
            +57641862080418*r**28+127329648232636*r**30-109519483139001*r**32+49442547356830*r**34
            -9158526655025*r**36+2291087890694*r**38+20232719373*r**40+31591514102*r**42
            +878418669*r**44+13602510*r**46))-52254720000*logq2**6*(-Q2+(-1+r)**2)*r**22*(
            -81-231*r**2-620*r**4+1536*r**6-163*r**8+15*r**10)*(-Q2+(1+r)**2)*sqrtq2
            -4147200*logq2**4*r**14*(60*Q2**14*(413+2645*r**4)-120*Q2**13*(2393+3156*r**2
            +13712*r**4+16940*r**6)+6*Q2**12*(242906+632040*r**2+1644025*r**4+2954901*r**6
            +1925510*r**8)-2*Q2**11*(2119236+8167956*r**2+19841435*r**4+37194556*r**6
            +41289501*r**8+18849060*r**10)+Q2**10*(7776501+39199953*r**2+102449561*r**4
            +195933321*r**6+258041108*r**8+212341566*r**10+75250710*r**12)-10*Q2**9*(963687
            +5686470*r**2+16469485*r**4+32896302*r**6+45673435*r**8+46111550*r**10
            +31162305*r**12+8593110*r**14)+5*Q2**8*(1890225+10501017*r**2+34174290*r**4
            +67666510*r**6+82804525*r**8+79454569*r**10+70096128*r**12+43109172*r**14
            +5673060*r**16)+Q2**7*(-9733752-36735000*r**2-151526835*r**4-266479252*r**6
            -123188075*r**8+244104568*r**10+367542115*r**12+159075540*r**14+52811523*r**16
            +70494480*r**18)+Q2**6*(9792054+28547994*r**2+164597985*r**4+311232029*r**6
            +165376849*r**8-468600051*r**10-1243370261*r**12-1196807745*r**14-555537291*r**16
            -228782331*r**18-118913760*r**20)+Q2**5*(-5189052-22423776*r**2-130724967*r**4
            -307858792*r**6-477606586*r**8-262667904*r**10+462527764*r**12+1159593968*r**14
            +1039453958*r**16+415841424*r**18+175004163*r**20+73785480*r**22)+5*Q2**4*(
            -574602+2341410*r**2-3187035*r**4+6360745*r**6+59527490*r**8+64308430*r**10
            +34859556*r**12+12955372*r**14-29922940*r**16-22358800*r**18-4171881*r**20
            -11123925*r**22+555780*r**24)+(-1+r**2)**4*(-260799-108723*r**2-9877967*r**4
            -8679915*r**6-5080288*r**8-11043788*r**10+72182352*r**12+22777472*r**14
            -20587445*r**16+35390703*r**18+9742127*r**20+701211*r**22+1029060*r**24)
            -5*Q2**3*(-1419312+1204608*r**2-28895673*r**4-34256284*r**6-11723591*r**8
            -83345696*r**10+4078122*r**12+74121488*r**14+10832678*r**16+16399480*r**18
            +91085007*r**20+37327404*r**22-4024431*r**24+7240200*r**26)-Q2*(-1
            +r**2)**2*(-1831818+258096*r**2-58120075*r**4-58048954*r**6-41579811*r**8
            -200934032*r**10+297495098*r**12+561002328*r**14+34598344*r**16-105304204*r**18
            +193295985*r**20+60754466*r**22-170043*r**24+8056620*r**26)+Q2**2*(-5211159
            +5996085*r**2-137670290*r**4-59362994*r**6-21103075*r**8-505177697*r**10
            +248511570*r**12+865628780*r**14+865865923*r**16+55365315*r**18-426612094*r**20
            +331840470*r**22+161628935*r**24-26173479*r**26+25417710*r**28))*sqrtq2
            -2880*logq2**2*r**6*(24*Q2**22*(9921+36713*r**4)-48*Q2**21*(82757+74934*r**2
            +259939*r**4+315758*r**6)+8*Q2**20*(3719163+6827128*r**2+13223613*r**4
            +24594773*r**6+14559009*r**8)-8*Q2**19*(16476558+45702062*r**2+83584197*r**4
            +155375620*r**6+169855165*r**8+65363910*r**10)+Q2**18*(380261961+1417871075*r**2
            +2889733036*r**4+5228950668*r**6+6795591751*r**8+5331797257*r**10+1488274980*r**12)
            -2*Q2**17*(365675925+1741324660*r**2+3914478455*r**4+7322298656*r**6
            +9410990135*r**8+9150306264*r**10+6298027733*r**12+1321373004*r**14)
            +Q2**16*(887775465+5445206917*r**2+11403111539*r**4+20806293619*r**6
            +19598908935*r**8+7326108835*r**10+12242902901*r**12+16015355909*r**14
            +2303002536*r**16)+4*Q2**15*(-119199660-1193562596*r**2-211234451*r**4
            +3657378488*r**6+17424880461*r**8+42192332484*r**10+46843261531*r**12
            +19255559528*r**14-167088697*r**16+332951568*r**18)-4*Q2**14*(105359127
            -99948007*r**2+8019023583*r**4+33075532159*r**6+87735716435*r**8+178500070395*r**10
            +237571699897*r**12+187056186569*r**14+69725474070*r**16+9199507180*r**18
            +1701387840*r**20)+4*Q2**13*(273809298+1170938020*r**2+17012074623*r**4
            +70988855096*r**6+177727809006*r**8+356086329720*r**10+523691473748*r**12
            +532752287664*r**14+347195924208*r**16+107312036228*r**18+16717777181*r**20
            +2138946840*r**22)-4*Q2**12*(227667531+1548210755*r**2+17465080288*r**4
            +83333472708*r**6+184262433918*r**8+320248381826*r**10+464303123340*r**12
            +527699226684*r**14+477464429339*r**16+293063231331*r**18+56741412220*r**20
            +12147353608*r**22+691474212*r**24)-4*Q2**11*(-27047124-948713844*r**2
            -7447655365*r**4-59393050752*r**6-64902870811*r**8+108832590248*r**10
            +428451551390*r**12+700228943240*r**14+662347830230*r**16+330316431716*r**18
            +86693061607*r**20+85793204184*r**22+3547961625*r**24+1560818376*r**26)
            +2*Q2**10*(245187423-392160171*r**2+7988234294*r**4-58632010210*r**6
            +133213856401*r**8+1269057711915*r**10+3414425854024*r**12+5614743641388*r**14
            +6336230686065*r**16+4950700206235*r**18+2578047857798*r**20+968698239670*r**22
            +388096154175*r**24+31877150565*r**26+4835925276*r**28)-4*Q2**9*(118675023
            +195816192*r**2+8801119352*r**4-11986845328*r**6+113771805895*r**8+801174587796*r**10
            +2188352400600*r**12+3677621722356*r**14+4483557983717*r**16+4092744675480*r**18
            +2651567440472*r**20+1158760256104*r**22+489357480805*r**24+144476741940*r**26
            +14003753400*r**28+1211635860*r**30)+2*Q2**8*(73646679+707534395*r**2
            +16227247679*r**4+15022203719*r**6+252262267547*r**8+1219794081815*r**10
            +3369220290323*r**12+4864233067547*r**14+4827547632389*r**16+4042762579529*r**18
            +3015647193077*r**20+1114175154413*r**22-314106758095*r**24+330098279141*r**26
            -27735287751*r**28+5900907953*r**30-1033591080*r**32)+4*Q2**7*(16468908
            -399772300*r**2-5875928441*r**4-30113718760*r**6-135286462149*r**8-339590741628*r**10
            -1158155060473*r**12-1267284734424*r**14-201135722661*r**16+1460533720268*r**18
            +2138767554909*r**20+1548766960776*r**22+1293890660393*r**24+1268152678572*r**26
            +80153977877*r**28+117638216632*r**30+4836399253*r**32+1144055568*r**34)
            +(-1+r**2)**6*(-13647-2988845*r**2-89318198*r**4-282731302*r**6-4504594786*r**8
            +20197346438*r**10-133049882326*r**12+69195338674*r**14+416213747056*r**16
            -408778122948*r**18-149138234890*r**20+285888417422*r**22+26697743746*r**24
            -22814033366*r**26+24005997934*r**28-287212826*r**30+822859199*r**32
            +27948353*r**34+2694312*r**36)-4*Q2**6*(20178417-271971875*r**2-2892158669*r**4
            -33210528787*r**6-84238627713*r**8-132740297485*r**10-881238176259*r**12
            -1103156269971*r**14-744084671887*r**16+482034799245*r**18+2094637545243*r**20
            +2568982976927*r**22+1706691460509*r**24+1107502085433*r**26+1149363901863*r**28
            +95082324295*r**30+95605490882*r**32+4966836266*r**34+670658766*r**36)
            -2*Q2*(-1+r**2)**4*(-24459-15659168*r**2-422907429*r**4-1263381536*r**6
            -19012618780*r**8+73001603852*r**10-468213377836*r**12+14954459044*r**14
            +1200380638694*r**16-76863826868*r**18-931929387022*r**20-140576549244*r**22
            +950923140404*r**24+144530527300*r**26-112661018444*r**28+110959432204*r**30
            -3586989427*r**32+4269879556*r**34+139037867*r**36+16781292*r**38)+4*Q2**5*(7570878
            -47843740*r**2+371020005*r**4-16041705248*r**6+15704876114*r**8-74378808608*r**10
            -253680785174*r**12-294228742304*r**14-522215196362*r**16-485113810904*r**18
            -589498823516*r**20-179158033184*r**22-51232711898*r**24+258488814208*r**26
            +304481825382*r**28+261421253536*r**30+50290397588*r**32+20542657812*r**34
            +1837404967*r**36+50000448*r**38)+4*Q2**4*(-722109-84215191*r**2-2091257796*r**4
            +1239823696*r**6-74812612290*r**8+175986709036*r**10-708984375808*r**12
            -454082693640*r**14-115456216662*r**16-643878092770*r**18-395185494480*r**20
            +309721080624*r**22+227745185768*r**24+1711231601916*r**26+676653347600*r**28
            -443678757992*r**30+402309067275*r**32-52918994607*r**34+21748442500*r**36
            +125202160*r**38+178732770*r**40)+Q2**2*(-1+r**2)**2*(250113-139783859*r**2
            -3370036367*r**4-8064626691*r**6-134437795352*r**8+496248784556*r**10
            -2923857536428*r**12+35506951228*r**14+4327054736446*r**16+1177969875374*r**18
            +55006605726*r**20-1626378967522*r**22-1614745127220*r**24+5005866357356*r**26
            +1492092313348*r**28-1185501112292*r**30+884230976009*r**32-59160732691*r**34
            +37461320089*r**36+1075576205*r**38+180051972*r**40)-4*Q2**3*(305784
            -81720920*r**2-1770885841*r**4-1791664440*r**6-64774150839*r**8+256037427348*r**10
            -1252852541548*r**12+498568402440*r**14+853390334348*r**16-419873739288*r**18
            +866711411370*r**20+718373661656*r**22+265333051638*r**24-1812164210016*r**26
            +1379776745268*r**28+1152418410520*r**30-898406493708*r**32+481396690288*r**34
            -56527699617*r**36+21373592384*r**38+413303753*r**40+129129420*r**42))*sqrtq2
            +8*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(552*Q2**25-2*Q2**24*(5307
            +871*r**2)+2*Q2**23*(-15921-12252*r**2+9917*r**4)+Q2**22*(4217505+639251*r**2
            +4841335*r**4-416099*r**6)+4*Q2**21*(-12099402-3441706*r**2-8432131*r**4
            -15637830*r**6+800881*r**8)+Q2**20*(264717453+100915593*r**2-382709834*r**4
            +454651734*r**6+370105641*r**8-12883907*r**10)+Q2**19*(-843702159-346001108*r**2
            +5025491777*r**4+3809406192*r**6-2517321657*r**8-1199798444*r**10+30052183*r**12)
            -2*Q2**18*(-803079984-332542501*r**2+12594277376*r**4+22408316259*r**6
            +11380183240*r**8-3001265399*r**10-996043188*r**12+18469533*r**14)+Q2**17*(
            -1503221115-1171006476*r**2+74293197722*r**4+194529364276*r**6+224348508968*r**8
            +111171173980*r**10+974408358*r**12-230614980*r**14+1794771*r**16)+2*Q2**16*(
            -280398024+1703543168*r**2-72547930075*r**4-260695180279*r**6-427196923425*r**8
            -429821244593*r**10-195301062437*r**12-21852768425*r**14-3134719815*r**16
            +36019617*r**18)-8*Q2**15*(-432268701+1034306940*r**2-23716417978*r**4
            -126129730964*r**6-257698796919*r**8-343725195024*r**10-293890928629*r**12
            -105459120668*r**14-14358896240*r**16-1618724172*r**18+13626979*r**20)
            +2*Q2**14*(-1848050457+4410641673*r**2-66416452063*r**4-698549550657*r**6
            -1687181706870*r**8-2542530610194*r**10-2619634138602*r**12-1870565126142*r**14
            -417252484713*r**16-58931387967*r**18-4361807967*r**20+17580839*r**22)
            +4*Q2**13*(-46517163+1610295672*r**2-16671903012*r**4+267734671424*r**6
            +700125499815*r**8+1007047839248*r**10+679201012012*r**12+348906625728*r**14
            +363767654279*r**16-147726326120*r**18-11957466968*r**20-2195574176*r**22
            +24152461*r**24)+2*Q2**12*(2150326695-15009959029*r**2+156479125462*r**4
            +133986765174*r**6+684225675105*r**8+2662006158005*r**10+7190298495852*r**12
            +11258646623404*r**14+8250586018841*r**16+3142537705029*r**18+1429431488110*r**20
            +139104269070*r**22+11173132815*r**24-68896597*r**26)+2*Q2**11*(-1906892829
            +15026335428*r**2-180769690013*r**4-802505807072*r**6-2848742435209*r**8
            -8364558146428*r**10-18527144040233*r**12-30321830276992*r**14-31845989417967*r**16
            -16430808598388*r**18-6295021786351*r**20-1604987317152*r**22-146653596843*r**24
            -6947329620*r**26+19036277*r**28)+4*Q2**10*(-87739953+1407264368*r**2
            +19375570493*r**4+400110392698*r**6+1205247478141*r**8+4025487220026*r**10
            +7697753708771*r**12+13892129020812*r**14+17781560593385*r**16+15755915840788*r**18
            +3206522778291*r**20+2000174631922*r**22+44335299243*r**24+4132634114*r**26
            -2098261331*r**28+20372392*r**30)+Q2**9*(3016151886-39227755400*r**2
            +287608650396*r**4-640533583048*r**6-1179824218844*r**8-8607770783912*r**10
            +6564016805388*r**12+26092204338200*r**14+30423809848240*r**16+26414319744168*r**18
            +2443318746548*r**20+37363351682792*r**22+4116655382812*r**24+3267705213576*r**26
            +254270956964*r**28+19135699656*r**30-95776062*r**32)+2*Q2**8*(-985595241
            +15752528067*r**2-168883671142*r**4-2589997694*r**6+169095109910*r**8
            +3938379894246*r**10-15511741525574*r**12-51022774165726*r**14-85014273566532*r**16
            -85761070612700*r**18-65867470123954*r**20-28880472373626*r**22-27483465071654*r**24
            -5165526033814*r**26-1618309378850*r**28-118440964266*r**30-4973260227*r**32
            +12875337*r**34)+2*Q2**7*(-121874415+1098617020*r**2+33999750223*r**4
            +157934385136*r**6-166472337552*r**8-3083238961520*r**10+13965935690168*r**12
            +44159349573168*r**14+82548091451242*r**16+107694443714792*r**18+81311802692190*r**20
            +28673435098576*r**22+29220611576984*r**24+5901190717584*r**26+3228749635040*r**28
            +191929782800*r**30+14208861821*r**32-1813328580*r**34+14932923*r**36)
            -Q2**6*(-1012105017+20096935549*r**2-157000154623*r**4+701955580483*r**6
            +1607263603620*r**8+1228052500700*r**10+13072721009436*r**12+36354609944548*r**14
            +61911136585514*r**16+23028869241726*r**18+56092509378726*r**20+64801397925506*r**22
            -166290673696092*r**24+55008550143868*r**26-36529726920612*r**28+549152940356*r**30
            -1577240851001*r**32-101707138643*r**34-7406303775*r**36+31232531*r**38)
            +4*Q2**5*(-123846693+3112200186*r**2-34393979645*r**4+177981225486*r**6
            +591491337228*r**8+739117862536*r**10-433270542328*r**12+6899979825880*r**14
            +16664087207766*r**16-5908237645012*r**18-22925704305386*r**20-31677018562172*r**22
            +36074199717800*r**24-69548877987800*r**26+13550981411120*r**28-9132423288264*r**30
            -393521324361*r**32-310301809110*r**34-19742589777*r**36-856756386*r**38
            +2360932*r**40)+2*(-1+r**2)**4*(-713952+27780360*r**2-347059039*r**4
            +4869023785*r**6+11187636069*r**8-130095279279*r**10+872775613692*r**12
            -3504129849948*r**14+15595827468220*r**16-34416000482332*r**18+21819053999334*r**20
            +19120143213694*r**22-33229895366962*r**24+17303684239230*r**26-5621065043268*r**28
            +878091771252*r**30-189079040004*r**32-1074918676*r**34-3082172735*r**36
            -145270719*r**38-5081355*r**40+12633*r**42)+Q2**4*(-40485699+163845529*r**2
            +15526754078*r**4-164451219330*r**6-757705129059*r**8-698528460031*r**10
            +8133424879448*r**12-38465880240936*r**14-46324288698982*r**16-8053116369230*r**18
            -50779644641980*r**20-67817771714940*r**22+217385222773538*r**24-185228571117846*r**26
            +120920188081912*r**28-11694463786376*r**30+6604294547145*r**32+1293315495445*r**34
            +176477646158*r**36+13864067502*r**38-277379039*r**40+3232693*r**42)
            +Q2**3*(148761633-4092956820*r**2+40616212625*r**4-276476741040*r**6
            -366777352525*r**8+2181456625668*r**10-13377257695261*r**12+37542139690176*r**14
            -91162253666390*r**16-17976006442440*r**18+28950276342538*r**20-170198831929632*r**22
            +237590488803462*r**24+42279627131400*r**26-160612157964570*r**28+128830473489088*r**30
            -40959916435323*r**32+11159174533148*r**34-814146443595*r**36+262255630160*r**38
            +12616776823*r**40+1024554036*r**42-3963161*r**44)-Q2*(-1+r**2)**2*(
            -15826797+566876850*r**2-7032125705*r**4+80026236360*r**6+140470479861*r**8
            -1529768515530*r**10+8893444011513*r**12-26641684352656*r**14+107768469897470*r**16
            -149016152967228*r**18-88594866345978*r**20+214634130173696*r**22+85120587582858*r**24
            -311020332025220*r**26+199832579011698*r**28-74508128770416*r**30+13999105113919*r**32
            -2967364080278*r**34+43877266515*r**36-53326560456*r**38-2626419279*r**40
            -111288978*r**42+307781*r**44)+2*Q2**2*(-35714850+1173611559*r**2-14209733526*r**4
            +131901417539*r**6+104987476438*r**8-1701102620075*r**10+9115691114046*r**12
            -24455119375947*r**14+90431727048860*r**16-112973508820154*r**18+24392148235460*r**20
            -94076079107602*r**22+146467011253372*r**24+110882386246826*r**26-335263882960356*r**28
            +245305622403930*r**30-100596891125370*r**32+22968899616451*r**34-4676014807438*r**36
            +221150020447*r**38-89276363090*r**40-4482094383*r**42-248825850*r**44
            +783713*r**46))*sqrtq2))/(705438720000*logq2**5*(-Q2+(-1+r)**2)*r**22*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+16329600000*logq2**3*(-Q2
            +(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+34020000*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-1410877440000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-146966400000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-1020600000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -472500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*sqrtq2)
            +(muWC*(-995328000*logq2**5*r**18*(210*Q2**11*(3+35*r**4)-30*Q2**10*(139
            +403*r**2+2395*r**4+2835*r**6)+10*Q2**9*(-93+6460*r**2+37362*r**4+68840*r**6
            +43155*r**8)-2*Q2**8*(-43137-1353*r**2+466970*r**4+1274250*r**6+1396755*r**8
            +630315*r**10)+Q2**7*(-333657-695205*r**2+617972*r**4+4108870*r**6+7682355*r**8
            +6215295*r**10+2307690*r**12)-Q2**6*(-577017-1815828*r**2-1368477*r**4
            +1136792*r**6+7530745*r**8+12057360*r**10+7952805*r**12+2619540*r**14)
            +Q2**5*(-390789-1771329*r**2-2300965*r**4-3588411*r**6+219159*r**8+5265185*r**10
            +9402645*r**12+5088195*r**14+1512630*r**16)+(-1+r**2)**4*(-50811-59170*r**2
            -78100*r**4-1168700*r**6+966090*r**8+1815876*r**10-624940*r**12+144820*r**14
            +147985*r**16+56070*r**18)+Q2**4*(-277515+127260*r**2+551864*r**4+1992016*r**6
            +1758510*r**8+1439540*r**10+173560*r**12-1927800*r**14+50925*r**16+264600*r**18)
            +Q2**3*(798831+941529*r**2+704004*r**4+5474320*r**6+2718706*r**8-9523494*r**10
            -4247596*r**12+890120*r**14-1417065*r**16-2331915*r**18-1224720*r**20)
            -Q2*(-1+r**2)**2*(-296283-345483*r**2-356510*r**4-5931470*r**6-342320*r**8
            +11074148*r**10+6242258*r**12-2673130*r**14+657075*r**16+798015*r**18
            +366660*r**20)+Q2**2*(-701163-370290*r**2-132073*r**4-9611910*r**6-766170*r**8
            +8973728*r**10+13079130*r**12+10410528*r**14-4762795*r**16+41970*r**18
            +1248255*r**20+976710*r**22))-552960*logq2**3*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(90*Q2**17*(2833+13825*r**4)-6*Q2**16*(553779+590423*r**2
            +2381651*r**4+2919975*r**6)+4*Q2**15*(4802751+9975813*r**2+24319926*r**4
            +43911329*r**6+27213075*r**8)-4*Q2**14*(16013610+48807513*r**2+110965161*r**4
            +216529977*r**6+232910395*r**8+96300900*r**10)+Q2**13*(133604595+536464833*r**2
            +1283476274*r**4+2590166818*r**6+3505735707*r**8+2721985805*r**10+821381400*r**12)
            -Q2**12*(174344445+891482862*r**2+2195053265*r**4+4474402322*r**6+6672309603*r**8
            +6862668238*r**10+4487390135*r**12+953753850*r**14)+2*Q2**11*(63033921
            +443775771*r**2+903305841*r**4+1286613868*r**6+1500804158*r**8+1165903415*r**10
            +1572659733*r**12+1573756334*r**14+64752975*r**16)+2*Q2**10*(-6880401
            -234726204*r**2+171557917*r**4+3093556597*r**6+8290024575*r**8+13792720873*r**10
            +14307208315*r**12+7247183275*r**14+1267991306*r**16+707119875*r**18)
            -Q2**9*(68647095-57819879*r**2+2306931152*r**4+15943508094*r**6+44104255460*r**8
            +76345361820*r**10+91361517386*r**12+73237928802*r**14+32951341909*r**16
            +7898797515*r**18+2175866550*r**20)+Q2**8*(84418785+103635234*r**2+2670724257*r**4
            +16911203704*r**6+53309686786*r**8+95987397520*r**10+121498388474*r**12
            +114872019532*r**14+73721083469*r**16+25043600286*r**18+7045902165*r**20
            +1098434700*r**22)+4*Q2**7*(-18767430-52199394*r**2-734223105*r**4-2704214669*r**6
            -10139170156*r**8-15930723636*r**10-14308579034*r**12-10311787120*r**14
            -8376575184*r**16-2635049086*r**18+2497101279*r**20-332359095*r**22+190916550*r**24)
            -4*Q2**6*(-15049647-81086295*r**2-924629406*r**4-1608397082*r**6-7856113417*r**8
            -10726446979*r**10-317814426*r**12+19298405890*r**14+27175249033*r**16
            +17132710433*r**18+11390182792*r**20+8908053192*r**22+679536767*r**24
            +378074025*r**26)+Q2**5*(-24550083-277914465*r**2-2678215590*r**4-4578043346*r**6
            -24365651425*r**8-52324499663*r**10-45831958424*r**12+16727806652*r**14
            +108147336803*r**16+127064927465*r**18+74200896586*r**20+40508501174*r**22
            +26834815713*r**24+2605665703*r**26+840086100*r**28)+(-1+r**2)**4*(-637119
            -2692980*r**2-107766829*r**4+234433374*r**6-2159055831*r**8-1783465252*r**10
            +8132972955*r**12-1275212762*r**14-3178311733*r**16+700150212*r**18+4347007921*r**20
            +1689109050*r**22-105235509*r**24+385532884*r**26+12044769*r**28+5846850*r**30)
            +Q2**4*(-16061715+101958798*r**2-379151879*r**4+3591455502*r**6-623588635*r**8
            +22959030690*r**10+41561977289*r**12+35116868458*r**14+15206678031*r**16
            -14702078910*r**18-7852446525*r**20-14006468462*r**22-14537415329*r**24
            -1780835058*r**26-1062782405*r**28+47820150*r**30)+2*Q2**3*(14606685
            +4515279*r**2+1186623397*r**4-2367522036*r**6+13863072416*r**8+8843306325*r**10
            +3650138367*r**12+16637803606*r**14+838701192*r**16-6143224807*r**18
            +1071253475*r**20-33641882496*r**22-13569863028*r**24+5351881219*r**26
            -5521455559*r**28+148903390*r**30-164617425*r**32)-Q2*(-1+r**2)**2*(
            -5269869-14992179*r**2-721133539*r**4+1601606015*r**6-12697168497*r**8
            -10866683383*r**10+25424271673*r**12+2016466123*r**14+15227385945*r**16
            +4546384199*r**18-5309863817*r**20+24327598381*r**22+10945259541*r**24
            -2251117085*r**26+2838479923*r**28+43346569*r**30+53190000*r**32)+2*Q2**2*(
            -8895465-9298656*r**2-957711495*r**4+2673042649*r**6-15645330999*r**8
            -2547954159*r**10+13885187437*r**12-15154586035*r**14+22842142547*r**16
            +32408520613*r**18+12506484123*r**20-28367892901*r**22+20096329155*r**24
            +16078445379*r**26-6900060289*r**28+4231197951*r**30-69853430*r**32+97993575*r**34))
            -384*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(102990*Q2**23*(1
            +r**4)-6*Q2**22*(250975+129615*r**2+214351*r**4+277615*r**6)+6*Q2**21*(1646615
            +1736600*r**2-1141014*r**4+3823540*r**6+1947335*r**8)-2*Q2**20*(18899085
            +30364065*r**2-77875078*r**4-45784454*r**6+79921989*r**8+22962705*r**10)
            +Q2**19*(90583365+198784575*r**2-1075702342*r**4-2052365826*r**6-919050211*r**8
            +538147875*r**10+105661500*r**12)+Q2**18*(-130414245-384224610*r**2+4565476427*r**4
            +12392177214*r**6+15028746725*r**8+7627142086*r**10-635757075*r**12-118164810*r**14)
            -Q2**17*(-75207015-378950325*r**2+13605980135*r**4+46150104725*r**6+77563654531*r**8
            +84676747293*r**10+38886392737*r**12+1737385851*r**14+54215940*r**16)
            +Q2**16*(97168005+69795150*r**2+28807057876*r**4+123911235500*r**6+251267030090*r**8
            +359650653908*r**10+323922260860*r**12+117060991036*r**14+8532203745*r**16
            +398993910*r**18)-4*Q2**15*(59591970+203597265*r**2+10132429775*r**4
            +59535219310*r**6+142109797822*r**8+229515603654*r**10+256386998498*r**12
            +186663312110*r**14+48946523260*r**16+3730648317*r**18+137397315*r**20)
            +4*Q2**14*(37195320+331906875*r**2+7208077054*r**4+72869690417*r**6+194423836992*r**8
            +334882621288*r**10+344017158788*r**12+284260315716*r**14+204357116272*r**16
            +25443780557*r**18+2108325750*r**20+27826875*r**22)+4*Q2**13*(32218230
            -312707055*r**2+3278960761*r**4-34823145093*r**6-56952818495*r**8-16507535744*r**10
            +336029336760*r**12+796925322712*r**14+538270991794*r**16+96457539855*r**18
            +69505893343*r**20+3603961725*r**22+163234935*r**24)-4*Q2**12*(72207330
            -147508335*r**2+13612937936*r**4+45683665020*r**6+301104688958*r**8+960411623823*r**10
            +2333980627392*r**12+4197046452440*r**14+4496386659270*r**16+2304700044111*r**18
            +636679251104*r**20+163841395276*r**22+8160516234*r**24+222698385*r**26)
            +2*Q2**11*(74484735+243577425*r**2+25911284958*r**4+189445855490*r**6
            +1081357300445*r**8+3560584575747*r**10+7974086979100*r**12+14828149949132*r**14
            +19275539081505*r**16+15730751366095*r**18+5780101131182*r**20+1631761511330*r**22
            +248829102483*r**24+10530252525*r**26+124617480*r**28)+2*Q2**10*(51303705
            -729199770*r**2-3843347523*r**4-126371296894*r**6-718444134359*r**8-2981112783274*r**10
            -4810580073843*r**12-7711324300822*r**14-11590861514341*r**16-12699497517486*r**18
            -8912846316889*r**20+104258081302*r**22-448380573533*r**24+102726928146*r**26
            +5931410511*r**28+278019870*r**30)-2*Q2**9*(91558515-737355075*r**2+14202987453*r**4
            +2683661179*r**6-32458706161*r**8-1665637530223*r**10+2163753671577*r**12
            +13343576719375*r**14+23811252907761*r**16+26612197330431*r**18+18793158395407*r**20
            +9672637249177*r**22+8719728345101*r**24+1182899408499*r**26+361345995099*r**28
            +14995516125*r**30+339456000*r**32)+2*Q2**8*(37199655-204254490*r**2
            +12930631648*r**4+59739735976*r**6+227375466680*r**8-1471329247488*r**10
            +4932064841080*r**12+26655811169528*r**14+54983153719326*r**16+72370491773980*r**18
            +64599418302224*r**20+37137971931000*r**22+19216132278304*r**24+9423417150128*r**26
            +1525127744280*r**28+256211087144*r**30+8729650275*r**32+97785870*r**34)
            +2*Q2**7*(20065185-337754010*r**2-2265745529*r**4-43851694540*r**6-267407020384*r**8
            +837795447224*r**10-3851188124004*r**12-20605145960308*r**14-44985021837310*r**16
            -62373100416564*r**18-65590423300102*r**20-43092461648308*r**22-8014732653480*r**24
            -12006885219160*r**26-861195771172*r**28-568054891532*r**30+30512370277*r**32
            +2227082862*r**34+109864455*r**36)-2*Q2**6*(28244295-412257975*r**2+3167065187*r**4
            -21856364315*r**6-420529214180*r**8-836302904664*r**10-2590042804500*r**12
            -8929213391672*r**14-22557468752430*r**16-10122184847310*r**18+1370973923578*r**20
            -2991266734710*r**22+6894207426348*r**24+37478193467200*r**26-3310317115140*r**28
            +6364691569856*r**30+310064086175*r**32+167659768477*r**34+6049115835*r**36
            +121806345*r**38)+2*Q2**5*(9598875-148942110*r**2+2037629884*r**4-10639584718*r**6
            -389625479019*r**8-1388583002948*r**10-486591633596*r**12-4301025243724*r**14
            -24773923623222*r**16-10130399577536*r**18+16618393049516*r**20+43536161066712*r**22
            +23792991928726*r**24+12880640142788*r**26+44737378648044*r**28-1021579991188*r**30
            +5426467214619*r**32+417360914014*r**34+103560430952*r**36+3165616086*r**38
            +39541845*r**40)+(-1+r**2)**4*(57765-1617990*r**2-6165578*r**4-431607756*r**6
            -14767827259*r**8+34119582198*r**10-327677918280*r**12+1470115084224*r**14
            -9024413350102*r**16+13461905694612*r**18+13297141683796*r**20-37763580593080*r**22
            +19244776039986*r**24+5487191038972*r**26-5156635951272*r**28+2421315019104*r**30
            -247276980015*r**32+92007697618*r**34+3809798886*r**36+908307044*r**38
            +20812137*r**40+234990*r**42)+2*Q2**4*(3034005-62168925*r**2-56241734*r**4
            -214979742*r**6+65259199273*r**8+676928209351*r**10-1858053542824*r**12
            +5171882732408*r**14+15027395767802*r**16+8501117974182*r**18+18793969576508*r**20
            +10480371959948*r**22-14376623989014*r**24-4004059389178*r**26-2368602101608*r**28
            -10828862201864*r**30-1471467301199*r**32-767347923785*r**34-166248497382*r**36
            -5217296222*r**38+24094125*r**40+12205875*r**42)+Q2**3*(-8198475+180214935*r**2
            -761871382*r**4+13162240206*r**6+339736018145*r**8-646518862209*r**10
            +5471004439900*r**12-14363670940664*r**14+43589578591242*r**16+14485900968030*r**18
            +5723709185932*r**20+28275065084820*r**22+8139257967114*r**24-59750693767802*r**26
            -52989187140720*r**28+59899554564488*r**30-43086810510655*r**32+9768706591467*r**34
            -3062176040646*r**36+25502854670*r**38-53177109611*r**40-1660849125*r**42
            -32949660*r**44)-Q2*(-1+r**2)**2*(684825-17991675*r**2+6583784*r**4
            -3281519032*r**6-107137155873*r**8+224417852591*r**10-1880331140460*r**12
            +6886400002728*r**14-41864118230894*r**16+40932763014874*r**18+58037044971432*r**20
            -30491260360360*r**22-99478035613418*r**24+74732484215334*r**26+36689065357696*r**28
            -35284079111112*r**30+17011169401125*r**32-2336875402159*r**34+728880172592*r**36
            +22327916928*r**38+8512462139*r**40+213439995*r**42+2768940*r**44)+Q2**2*(3379035
            -84132330*r**2+310899043*r**4-10143942050*r**6-294929237119*r**8+721973248062*r**10
            -4651541905087*r**12+16037888152182*r**14-82247293182130*r**16+79087865117132*r**18
            +24879248368894*r**20+6522502300316*r**22+37291682545026*r**24-147761028992180*r**26
            +57641862080418*r**28+127329648232636*r**30-109519483139001*r**32+49442547356830*r**34
            -9158526655025*r**36+2291087890694*r**38+20232719373*r**40+31591514102*r**42
            +878418669*r**44+13602510*r**46))-418037760000*logq2**6*(-Q2+(-1+r)**2)*r**22*(
            -81-231*r**2-620*r**4+1536*r**6-163*r**8+15*r**10)*(-Q2+(1+r)**2)*sqrtq2
            -33177600*logq2**4*r**14*(60*Q2**14*(413+2645*r**4)-120*Q2**13*(2393+3156*r**2
            +13712*r**4+16940*r**6)+6*Q2**12*(242906+632040*r**2+1644025*r**4+2954901*r**6
            +1925510*r**8)-2*Q2**11*(2119236+8167956*r**2+19841435*r**4+37194556*r**6
            +41289501*r**8+18849060*r**10)+Q2**10*(7776501+39199953*r**2+102449561*r**4
            +195933321*r**6+258041108*r**8+212341566*r**10+75250710*r**12)-10*Q2**9*(963687
            +5686470*r**2+16469485*r**4+32896302*r**6+45673435*r**8+46111550*r**10
            +31162305*r**12+8593110*r**14)+5*Q2**8*(1890225+10501017*r**2+34174290*r**4
            +67666510*r**6+82804525*r**8+79454569*r**10+70096128*r**12+43109172*r**14
            +5673060*r**16)+Q2**7*(-9733752-36735000*r**2-151526835*r**4-266479252*r**6
            -123188075*r**8+244104568*r**10+367542115*r**12+159075540*r**14+52811523*r**16
            +70494480*r**18)+Q2**6*(9792054+28547994*r**2+164597985*r**4+311232029*r**6
            +165376849*r**8-468600051*r**10-1243370261*r**12-1196807745*r**14-555537291*r**16
            -228782331*r**18-118913760*r**20)+Q2**5*(-5189052-22423776*r**2-130724967*r**4
            -307858792*r**6-477606586*r**8-262667904*r**10+462527764*r**12+1159593968*r**14
            +1039453958*r**16+415841424*r**18+175004163*r**20+73785480*r**22)+5*Q2**4*(
            -574602+2341410*r**2-3187035*r**4+6360745*r**6+59527490*r**8+64308430*r**10
            +34859556*r**12+12955372*r**14-29922940*r**16-22358800*r**18-4171881*r**20
            -11123925*r**22+555780*r**24)+(-1+r**2)**4*(-260799-108723*r**2-9877967*r**4
            -8679915*r**6-5080288*r**8-11043788*r**10+72182352*r**12+22777472*r**14
            -20587445*r**16+35390703*r**18+9742127*r**20+701211*r**22+1029060*r**24)
            -5*Q2**3*(-1419312+1204608*r**2-28895673*r**4-34256284*r**6-11723591*r**8
            -83345696*r**10+4078122*r**12+74121488*r**14+10832678*r**16+16399480*r**18
            +91085007*r**20+37327404*r**22-4024431*r**24+7240200*r**26)-Q2*(-1
            +r**2)**2*(-1831818+258096*r**2-58120075*r**4-58048954*r**6-41579811*r**8
            -200934032*r**10+297495098*r**12+561002328*r**14+34598344*r**16-105304204*r**18
            +193295985*r**20+60754466*r**22-170043*r**24+8056620*r**26)+Q2**2*(-5211159
            +5996085*r**2-137670290*r**4-59362994*r**6-21103075*r**8-505177697*r**10
            +248511570*r**12+865628780*r**14+865865923*r**16+55365315*r**18-426612094*r**20
            +331840470*r**22+161628935*r**24-26173479*r**26+25417710*r**28))*sqrtq2
            -23040*logq2**2*r**6*(24*Q2**22*(9921+36713*r**4)-48*Q2**21*(82757+74934*r**2
            +259939*r**4+315758*r**6)+8*Q2**20*(3719163+6827128*r**2+13223613*r**4
            +24594773*r**6+14559009*r**8)-8*Q2**19*(16476558+45702062*r**2+83584197*r**4
            +155375620*r**6+169855165*r**8+65363910*r**10)+Q2**18*(380261961+1417871075*r**2
            +2889733036*r**4+5228950668*r**6+6795591751*r**8+5331797257*r**10+1488274980*r**12)
            -2*Q2**17*(365675925+1741324660*r**2+3914478455*r**4+7322298656*r**6
            +9410990135*r**8+9150306264*r**10+6298027733*r**12+1321373004*r**14)
            +Q2**16*(887775465+5445206917*r**2+11403111539*r**4+20806293619*r**6
            +19598908935*r**8+7326108835*r**10+12242902901*r**12+16015355909*r**14
            +2303002536*r**16)+4*Q2**15*(-119199660-1193562596*r**2-211234451*r**4
            +3657378488*r**6+17424880461*r**8+42192332484*r**10+46843261531*r**12
            +19255559528*r**14-167088697*r**16+332951568*r**18)-4*Q2**14*(105359127
            -99948007*r**2+8019023583*r**4+33075532159*r**6+87735716435*r**8+178500070395*r**10
            +237571699897*r**12+187056186569*r**14+69725474070*r**16+9199507180*r**18
            +1701387840*r**20)+4*Q2**13*(273809298+1170938020*r**2+17012074623*r**4
            +70988855096*r**6+177727809006*r**8+356086329720*r**10+523691473748*r**12
            +532752287664*r**14+347195924208*r**16+107312036228*r**18+16717777181*r**20
            +2138946840*r**22)-4*Q2**12*(227667531+1548210755*r**2+17465080288*r**4
            +83333472708*r**6+184262433918*r**8+320248381826*r**10+464303123340*r**12
            +527699226684*r**14+477464429339*r**16+293063231331*r**18+56741412220*r**20
            +12147353608*r**22+691474212*r**24)-4*Q2**11*(-27047124-948713844*r**2
            -7447655365*r**4-59393050752*r**6-64902870811*r**8+108832590248*r**10
            +428451551390*r**12+700228943240*r**14+662347830230*r**16+330316431716*r**18
            +86693061607*r**20+85793204184*r**22+3547961625*r**24+1560818376*r**26)
            +2*Q2**10*(245187423-392160171*r**2+7988234294*r**4-58632010210*r**6
            +133213856401*r**8+1269057711915*r**10+3414425854024*r**12+5614743641388*r**14
            +6336230686065*r**16+4950700206235*r**18+2578047857798*r**20+968698239670*r**22
            +388096154175*r**24+31877150565*r**26+4835925276*r**28)-4*Q2**9*(118675023
            +195816192*r**2+8801119352*r**4-11986845328*r**6+113771805895*r**8+801174587796*r**10
            +2188352400600*r**12+3677621722356*r**14+4483557983717*r**16+4092744675480*r**18
            +2651567440472*r**20+1158760256104*r**22+489357480805*r**24+144476741940*r**26
            +14003753400*r**28+1211635860*r**30)+2*Q2**8*(73646679+707534395*r**2
            +16227247679*r**4+15022203719*r**6+252262267547*r**8+1219794081815*r**10
            +3369220290323*r**12+4864233067547*r**14+4827547632389*r**16+4042762579529*r**18
            +3015647193077*r**20+1114175154413*r**22-314106758095*r**24+330098279141*r**26
            -27735287751*r**28+5900907953*r**30-1033591080*r**32)+4*Q2**7*(16468908
            -399772300*r**2-5875928441*r**4-30113718760*r**6-135286462149*r**8-339590741628*r**10
            -1158155060473*r**12-1267284734424*r**14-201135722661*r**16+1460533720268*r**18
            +2138767554909*r**20+1548766960776*r**22+1293890660393*r**24+1268152678572*r**26
            +80153977877*r**28+117638216632*r**30+4836399253*r**32+1144055568*r**34)
            +(-1+r**2)**6*(-13647-2988845*r**2-89318198*r**4-282731302*r**6-4504594786*r**8
            +20197346438*r**10-133049882326*r**12+69195338674*r**14+416213747056*r**16
            -408778122948*r**18-149138234890*r**20+285888417422*r**22+26697743746*r**24
            -22814033366*r**26+24005997934*r**28-287212826*r**30+822859199*r**32
            +27948353*r**34+2694312*r**36)-4*Q2**6*(20178417-271971875*r**2-2892158669*r**4
            -33210528787*r**6-84238627713*r**8-132740297485*r**10-881238176259*r**12
            -1103156269971*r**14-744084671887*r**16+482034799245*r**18+2094637545243*r**20
            +2568982976927*r**22+1706691460509*r**24+1107502085433*r**26+1149363901863*r**28
            +95082324295*r**30+95605490882*r**32+4966836266*r**34+670658766*r**36)
            -2*Q2*(-1+r**2)**4*(-24459-15659168*r**2-422907429*r**4-1263381536*r**6
            -19012618780*r**8+73001603852*r**10-468213377836*r**12+14954459044*r**14
            +1200380638694*r**16-76863826868*r**18-931929387022*r**20-140576549244*r**22
            +950923140404*r**24+144530527300*r**26-112661018444*r**28+110959432204*r**30
            -3586989427*r**32+4269879556*r**34+139037867*r**36+16781292*r**38)+4*Q2**5*(7570878
            -47843740*r**2+371020005*r**4-16041705248*r**6+15704876114*r**8-74378808608*r**10
            -253680785174*r**12-294228742304*r**14-522215196362*r**16-485113810904*r**18
            -589498823516*r**20-179158033184*r**22-51232711898*r**24+258488814208*r**26
            +304481825382*r**28+261421253536*r**30+50290397588*r**32+20542657812*r**34
            +1837404967*r**36+50000448*r**38)+4*Q2**4*(-722109-84215191*r**2-2091257796*r**4
            +1239823696*r**6-74812612290*r**8+175986709036*r**10-708984375808*r**12
            -454082693640*r**14-115456216662*r**16-643878092770*r**18-395185494480*r**20
            +309721080624*r**22+227745185768*r**24+1711231601916*r**26+676653347600*r**28
            -443678757992*r**30+402309067275*r**32-52918994607*r**34+21748442500*r**36
            +125202160*r**38+178732770*r**40)+Q2**2*(-1+r**2)**2*(250113-139783859*r**2
            -3370036367*r**4-8064626691*r**6-134437795352*r**8+496248784556*r**10
            -2923857536428*r**12+35506951228*r**14+4327054736446*r**16+1177969875374*r**18
            +55006605726*r**20-1626378967522*r**22-1614745127220*r**24+5005866357356*r**26
            +1492092313348*r**28-1185501112292*r**30+884230976009*r**32-59160732691*r**34
            +37461320089*r**36+1075576205*r**38+180051972*r**40)-4*Q2**3*(305784
            -81720920*r**2-1770885841*r**4-1791664440*r**6-64774150839*r**8+256037427348*r**10
            -1252852541548*r**12+498568402440*r**14+853390334348*r**16-419873739288*r**18
            +866711411370*r**20+718373661656*r**22+265333051638*r**24-1812164210016*r**26
            +1379776745268*r**28+1152418410520*r**30-898406493708*r**32+481396690288*r**34
            -56527699617*r**36+21373592384*r**38+413303753*r**40+129129420*r**42))*sqrtq2
            +64*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(552*Q2**25-2*Q2**24*(5307
            +871*r**2)+2*Q2**23*(-15921-12252*r**2+9917*r**4)+Q2**22*(4217505+639251*r**2
            +4841335*r**4-416099*r**6)+4*Q2**21*(-12099402-3441706*r**2-8432131*r**4
            -15637830*r**6+800881*r**8)+Q2**20*(264717453+100915593*r**2-382709834*r**4
            +454651734*r**6+370105641*r**8-12883907*r**10)+Q2**19*(-843702159-346001108*r**2
            +5025491777*r**4+3809406192*r**6-2517321657*r**8-1199798444*r**10+30052183*r**12)
            -2*Q2**18*(-803079984-332542501*r**2+12594277376*r**4+22408316259*r**6
            +11380183240*r**8-3001265399*r**10-996043188*r**12+18469533*r**14)+Q2**17*(
            -1503221115-1171006476*r**2+74293197722*r**4+194529364276*r**6+224348508968*r**8
            +111171173980*r**10+974408358*r**12-230614980*r**14+1794771*r**16)+2*Q2**16*(
            -280398024+1703543168*r**2-72547930075*r**4-260695180279*r**6-427196923425*r**8
            -429821244593*r**10-195301062437*r**12-21852768425*r**14-3134719815*r**16
            +36019617*r**18)-8*Q2**15*(-432268701+1034306940*r**2-23716417978*r**4
            -126129730964*r**6-257698796919*r**8-343725195024*r**10-293890928629*r**12
            -105459120668*r**14-14358896240*r**16-1618724172*r**18+13626979*r**20)
            +2*Q2**14*(-1848050457+4410641673*r**2-66416452063*r**4-698549550657*r**6
            -1687181706870*r**8-2542530610194*r**10-2619634138602*r**12-1870565126142*r**14
            -417252484713*r**16-58931387967*r**18-4361807967*r**20+17580839*r**22)
            +4*Q2**13*(-46517163+1610295672*r**2-16671903012*r**4+267734671424*r**6
            +700125499815*r**8+1007047839248*r**10+679201012012*r**12+348906625728*r**14
            +363767654279*r**16-147726326120*r**18-11957466968*r**20-2195574176*r**22
            +24152461*r**24)+2*Q2**12*(2150326695-15009959029*r**2+156479125462*r**4
            +133986765174*r**6+684225675105*r**8+2662006158005*r**10+7190298495852*r**12
            +11258646623404*r**14+8250586018841*r**16+3142537705029*r**18+1429431488110*r**20
            +139104269070*r**22+11173132815*r**24-68896597*r**26)+2*Q2**11*(-1906892829
            +15026335428*r**2-180769690013*r**4-802505807072*r**6-2848742435209*r**8
            -8364558146428*r**10-18527144040233*r**12-30321830276992*r**14-31845989417967*r**16
            -16430808598388*r**18-6295021786351*r**20-1604987317152*r**22-146653596843*r**24
            -6947329620*r**26+19036277*r**28)+4*Q2**10*(-87739953+1407264368*r**2
            +19375570493*r**4+400110392698*r**6+1205247478141*r**8+4025487220026*r**10
            +7697753708771*r**12+13892129020812*r**14+17781560593385*r**16+15755915840788*r**18
            +3206522778291*r**20+2000174631922*r**22+44335299243*r**24+4132634114*r**26
            -2098261331*r**28+20372392*r**30)+Q2**9*(3016151886-39227755400*r**2
            +287608650396*r**4-640533583048*r**6-1179824218844*r**8-8607770783912*r**10
            +6564016805388*r**12+26092204338200*r**14+30423809848240*r**16+26414319744168*r**18
            +2443318746548*r**20+37363351682792*r**22+4116655382812*r**24+3267705213576*r**26
            +254270956964*r**28+19135699656*r**30-95776062*r**32)+2*Q2**8*(-985595241
            +15752528067*r**2-168883671142*r**4-2589997694*r**6+169095109910*r**8
            +3938379894246*r**10-15511741525574*r**12-51022774165726*r**14-85014273566532*r**16
            -85761070612700*r**18-65867470123954*r**20-28880472373626*r**22-27483465071654*r**24
            -5165526033814*r**26-1618309378850*r**28-118440964266*r**30-4973260227*r**32
            +12875337*r**34)+2*Q2**7*(-121874415+1098617020*r**2+33999750223*r**4
            +157934385136*r**6-166472337552*r**8-3083238961520*r**10+13965935690168*r**12
            +44159349573168*r**14+82548091451242*r**16+107694443714792*r**18+81311802692190*r**20
            +28673435098576*r**22+29220611576984*r**24+5901190717584*r**26+3228749635040*r**28
            +191929782800*r**30+14208861821*r**32-1813328580*r**34+14932923*r**36)
            -Q2**6*(-1012105017+20096935549*r**2-157000154623*r**4+701955580483*r**6
            +1607263603620*r**8+1228052500700*r**10+13072721009436*r**12+36354609944548*r**14
            +61911136585514*r**16+23028869241726*r**18+56092509378726*r**20+64801397925506*r**22
            -166290673696092*r**24+55008550143868*r**26-36529726920612*r**28+549152940356*r**30
            -1577240851001*r**32-101707138643*r**34-7406303775*r**36+31232531*r**38)
            +4*Q2**5*(-123846693+3112200186*r**2-34393979645*r**4+177981225486*r**6
            +591491337228*r**8+739117862536*r**10-433270542328*r**12+6899979825880*r**14
            +16664087207766*r**16-5908237645012*r**18-22925704305386*r**20-31677018562172*r**22
            +36074199717800*r**24-69548877987800*r**26+13550981411120*r**28-9132423288264*r**30
            -393521324361*r**32-310301809110*r**34-19742589777*r**36-856756386*r**38
            +2360932*r**40)+2*(-1+r**2)**4*(-713952+27780360*r**2-347059039*r**4
            +4869023785*r**6+11187636069*r**8-130095279279*r**10+872775613692*r**12
            -3504129849948*r**14+15595827468220*r**16-34416000482332*r**18+21819053999334*r**20
            +19120143213694*r**22-33229895366962*r**24+17303684239230*r**26-5621065043268*r**28
            +878091771252*r**30-189079040004*r**32-1074918676*r**34-3082172735*r**36
            -145270719*r**38-5081355*r**40+12633*r**42)+Q2**4*(-40485699+163845529*r**2
            +15526754078*r**4-164451219330*r**6-757705129059*r**8-698528460031*r**10
            +8133424879448*r**12-38465880240936*r**14-46324288698982*r**16-8053116369230*r**18
            -50779644641980*r**20-67817771714940*r**22+217385222773538*r**24-185228571117846*r**26
            +120920188081912*r**28-11694463786376*r**30+6604294547145*r**32+1293315495445*r**34
            +176477646158*r**36+13864067502*r**38-277379039*r**40+3232693*r**42)
            +Q2**3*(148761633-4092956820*r**2+40616212625*r**4-276476741040*r**6
            -366777352525*r**8+2181456625668*r**10-13377257695261*r**12+37542139690176*r**14
            -91162253666390*r**16-17976006442440*r**18+28950276342538*r**20-170198831929632*r**22
            +237590488803462*r**24+42279627131400*r**26-160612157964570*r**28+128830473489088*r**30
            -40959916435323*r**32+11159174533148*r**34-814146443595*r**36+262255630160*r**38
            +12616776823*r**40+1024554036*r**42-3963161*r**44)-Q2*(-1+r**2)**2*(
            -15826797+566876850*r**2-7032125705*r**4+80026236360*r**6+140470479861*r**8
            -1529768515530*r**10+8893444011513*r**12-26641684352656*r**14+107768469897470*r**16
            -149016152967228*r**18-88594866345978*r**20+214634130173696*r**22+85120587582858*r**24
            -311020332025220*r**26+199832579011698*r**28-74508128770416*r**30+13999105113919*r**32
            -2967364080278*r**34+43877266515*r**36-53326560456*r**38-2626419279*r**40
            -111288978*r**42+307781*r**44)+2*Q2**2*(-35714850+1173611559*r**2-14209733526*r**4
            +131901417539*r**6+104987476438*r**8-1701102620075*r**10+9115691114046*r**12
            -24455119375947*r**14+90431727048860*r**16-112973508820154*r**18+24392148235460*r**20
            -94076079107602*r**22+146467011253372*r**24+110882386246826*r**26-335263882960356*r**28
            +245305622403930*r**30-100596891125370*r**32+22968899616451*r**34-4676014807438*r**36
            +221150020447*r**38-89276363090*r**40-4482094383*r**42-248825850*r**44
            +783713*r**46))*sqrtq2))/(2116316160000*logq2**5*(-Q2+(-1+r)**2)*r**22*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+48988800000*logq2**3*(-Q2
            +(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+102060000*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-4232632320000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-440899200000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-3061800000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -1417500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**6*sqrtq2)+(497664000*logq2**5*r**18*(-420*Q2**11*(2+5*r**4)+60*Q2**10*(194
            +212*r**2+437*r**4+255*r**6)-20*Q2**9*(3426+6972*r**2+10615*r**4+7838*r**6
            +1665*r**8)+4*Q2**8*(57618+160047*r**2+258485*r**4+216315*r**6+65865*r**8
            -7110*r**10)+Q2**7*(-484056-1617165*r**2-2871524*r**4-2651950*r**6-1135140*r**8
            +207315*r**10+270720*r**12)+Q2**6*(629496+2372769*r**2+4533691*r**4
            +4300204*r**6+2021070*r**8-205175*r**10-1179465*r**12-522270*r**14)
            +Q2**5*(-429912-1862847*r**2-3721990*r**4-3191853*r**6-1259418*r**8
            +1041695*r**10+1296990*r**12+1096725*r**14+342090*r**16)+(-1+r**2)**4*(
            -17088-18795*r**2-21135*r**4+136265*r**6-740695*r**8-253957*r**10+192475*r**12
            +57355*r**14+133675*r**16+48060*r**18)+Q2**4*(-17640+450135*r**2+1035007*r**4
            +479273*r**6-631395*r**8-1250735*r**10-1400695*r**12+7695*r**14+620235*r**16
            +315000*r**18)+Q2**3*(312768+309357*r**2+302872*r**4-31970*r**6+2660268*r**8
            +3728068*r**10-1049848*r**12-755070*r**14-845060*r**16-1784865*r**18
            -810360*r**20)-Q2*(-1+r**2)**2*(-108384-110799*r**2-102640*r**4+469850*r**6
            -2947570*r**8-3793436*r**10+466414*r**12+997990*r**14+274890*r**16+697035*r**18
            +285930*r**20)+Q2**2*(-274704-109305*r**2-64759*r**4+780600*r**6-5129310*r**8
            -4646176*r**10-2277180*r**12+1320354*r**14+1305350*r**16-428415*r**18
            +1090875*r**20+691230*r**22))+276480*logq2**3*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(-180*Q2**17*(687+3520*r**4)+12*Q2**16*(145209+134648*r**2
            +655656*r**4+691275*r**6)-4*Q2**15*(2677302+4920501*r**2+13552617*r**4
            +22398253*r**6+12008025*r**8)+8*Q2**14*(4642020+12845148*r**2+31082511*r**4
            +58031107*r**6+54932145*r**8+20011275*r**10)-Q2**13*(76851180+295637991*r**2
            +728962248*r**4+1451259386*r**6+1758838824*r**8+1194796055*r**10+332921700*r**12)
            +Q2**12*(84960540+487160349*r**2+1203391395*r**4+2618752084*r**6+3616206066*r**8
            +3337328181*r**10+1904259415*r**12+430704450*r**14)-2*Q2**11*(2743272
            +188425437*r**2+250795212*r**4+670144431*r**6+1011099911*r**8+1079701735*r**10
            +1275535046*r**12+824294433*r**14+152164575*r**16)+2*Q2**10*(-65107548
            -70638837*r**2-1093190739*r**4-2742499879*r**6-4624436750*r**8-5933256326*r**10
            -4008370495*r**12-768518955*r**14+200104408*r**16+12999825*r**18)+Q2**9*(186062580
            +641523807*r**2+4838376204*r**4+14455085438*r**6+26574484030*r**8+38171849000*r**10
            +36000291782*r**12+19225071674*r**14+4817795078*r**16+597953505*r**18
            +166807350*r**20)-Q2**8*(83641140+627279993*r**2+3673314039*r**4+15065763348*r**6
            +28912437972*r**8+46430742650*r**10+55954169518*r**12+42927138204*r**14
            +18399002968*r**16+4738914237*r**18+738669915*r**20+207417600*r**22)
            +4*Q2**7*(-17943750+53530788*r**2-333611085*r**4+1164222978*r**6+1036149702*r**8
            +903784212*r**10+4828121398*r**12+8684823340*r**14+7004306008*r**16+2663099912*r**18
            +1339752627*r**20+198619530*r**22+54917100*r**24)-4*Q2**6*(-31067316
            -26620905*r**2-1260854973*r**4-1163004961*r**6-5773062756*r**8-14454501347*r**10
            -13604880658*r**12-4087020790*r**14+4970617074*r**16+5157154919*r**18
            +1908180331*r**20+1955638851*r**22+262723346*r**24+54119025*r**26)+Q2**5*(
            -63520884-158174265*r**2-3845275920*r**4-4824559478*r**6-23584022100*r**8
            -65453440259*r**10-65456189472*r**12-30838250444*r**14+10797549404*r**16
            +30122146345*r**18+19401760488*r**20+5669591042*r**22+6198036364*r**24
            +856909779*r**26+110601000*r**28)+(-1+r**2)**4*(-408312-125055*r**2
            -52121757*r**4+124875502*r**6-716725158*r**8-348339321*r**10+2358533045*r**12
            +574331404*r**14-6376937484*r**16-5380078609*r**18+4541769133*r**20+2216311710*r**22
            -92084822*r**24+231490057*r**26+13969467*r**28+2500200*r**30)+Q2**4*(
            -6739740+104075259*r**2+248412933*r**4+2611315556*r**6+4395789210*r**8
            +20964708245*r**10+14090687807*r**12-4942192246*r**14-18539298272*r**16
            -20298674795*r**18-4354671005*r**20-232711616*r**22-2589936062*r**24
            +325781691*r**26-223569415*r**28+40302450*r**30)-Q2*(-1+r**2)**2*(-3841272
            +3125103*r**2-400921782*r**4+988014115*r**6-4705680386*r**8-2687278929*r**10
            +13019115714*r**12-3861985701*r**14-19303641530*r**16-24858789163*r**18
            -16673146146*r**20+22201393633*r**22+12762568858*r**24-1299918835*r**26
            +1494577174*r**28+82024097*r**30+20065050*r**32)-2*Q2**3*(-13088160+31275633*r**2
            -810935256*r**4+1680241283*r**6-5536756173*r**8-3960046435*r**10+2129658454*r**12
            -8858976693*r**14-6450062031*r**16-2850606509*r**18-1924988420*r**20
            +18645784513*r**22+12449110149*r**24-2097497377*r**26+2334043782*r**28
            +81577265*r**30+50145975*r**32)+2*Q2**2*(-7358940+16505187*r**2-622064115*r**4
            +1804537377*r**6-6657829462*r**8-323197992*r**10+12757021111*r**12-11635443245*r**14
            -14431261744*r**16-7142730756*r**18-1966505141*r**20-21398365993*r**22
            +12629088210*r**24+15055527092*r**26-3301369807*r**28+1893501173*r**30
            +73027920*r**32+32599125*r**34))-192*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(205980*Q2**23*r**2-60*Q2**22*(-1184+39539*r**2+64403*r**4)+12*Q2**21*(
            -66010+384665*r**2+3695392*r**4+2565185*r**6)-4*Q2**20*(-1072795-14016985*r**2
            +30048273*r**4+82088225*r**6+34570230*r**8)+Q2**19*(-16259015-459430624*r**2
            -489420362*r**4+611399268*r**6+1279317721*r**8+381567900*r**10)+Q2**18*(50346775
            +1801153481*r**2+4552801352*r**4+5096076530*r**6+716941367*r**8-2707001939*r**10
            -629815470*r**12)+Q2**17*(-125636995-4577970394*r**2-16361346657*r**4
            -34185543994*r**6-42529848669*r**8-17123461382*r**10+2094751961*r**12
            +444272970*r**14)+Q2**16*(224175635+7809365011*r**2+36324646565*r**4
            +99974128845*r**6+202599264105*r**8+197200450525*r**10+71288223931*r**12
            +4276886555*r**14+474117420*r**16)-2*Q2**15*(112752950+3684349402*r**2
            +25752260173*r**4+79016347492*r**6+233092435851*r**8+345746446566*r**10
            +255229223487*r**12+75180939848*r**14+7333269947*r**16+737962860*r**18)
            +2*Q2**14*(-10760090-1124273264*r**2+15496671303*r**4+19912261043*r**6
            +203418671719*r**8+482954308527*r**10+550352756969*r**12+349433867053*r**14
            +80760081363*r**16+9335927281*r**18+619466400*r**20)+2*Q2**13*(212514850
            +9604495826*r**2+24605545417*r**4+233697297520*r**6+453679804464*r**8
            +446703045772*r**10+345711736162*r**12+27182590944*r**14-123650290370*r**16
            -10162724238*r**18-4289425979*r**20+219536640*r**22)-2*Q2**12*(283961990
            +13908960364*r**2+74031198307*r**4+584754092799*r**6+1848717652088*r**8
            +3124808784564*r**10+4097845080966*r**12+3474660039134*r**14+1583651768778*r**16
            +372430678624*r**18+91134548887*r**20+3816947459*r**22+911678040*r**24)
            +2*Q2**11*(90983295+6206547906*r**2+78914092893*r**4+569615400240*r**6
            +2742809560320*r**8+5288058804880*r**10+8265967023254*r**12+9042684714672*r**14
            +6308667139195*r**16+2528866847610*r**18+642628095325*r**20+119451472096*r**22
            +7383540918*r**24+655985460*r**26)+2*Q2**10*(192044385+8718596961*r**2
            -16333816305*r**4+140384960001*r**6-1470147860228*r**8-2328890180048*r**10
            -4488792514256*r**12-6817216024770*r**14-6896067267011*r**16-4415511376363*r**18
            -1444516748893*r**20-408591500719*r**22-54253428650*r**24-4837798134*r**26
            +175444590*r**28)-2*Q2**9*(267943485+15674082036*r**2+57128926488*r**4
            +968994735438*r**6+1179544359247*r**8+5008115702564*r**10+9749320559730*r**12
            +11132156908862*r**14+8343980582787*r**16+2537364664220*r**18+107065206684*r**20
            +308087299642*r**22-33516927887*r**24+16400244428*r**26-732456294*r**28
            +595534650*r**30)+2*Q2**8*(100462325+8163786479*r**2+70099745838*r**4
            +914309030690*r**6+2420386789419*r**8+7886670029317*r**10+19887473263544*r**12
            +28623891172128*r**14+31288703086975*r**16+20612304044273*r**18+7125861584574*r**20
            +1644161088082*r**22+869124458069*r**24+105782448795*r**26+31317956188*r**28
            +1588709804*r**30+327947340*r**32)+2*Q2**7*(79973330+3476457124*r**2
            -27910345903*r**4-4813851036*r**6-1709005164273*r**8-1396912949054*r**10
            -12999780005819*r**12-18126611546808*r**14-26841404556161*r**16-28047969119666*r**18
            -14857716194733*r**20-5257322417084*r**22-1137151326659*r**24-854473166418*r**26
            -108924395561*r**28-17576159408*r**30-2167266781*r**32+81478110*r**34)
            -2*Q2**6*(110655490+7320664226*r**2+10687192529*r**4+670030621775*r**6
            -926162679525*r**8+7093581933855*r**10-1161506151381*r**12+10171475571551*r**14
            +11609573936535*r**16-3791598682725*r**18-13245179986075*r**20-4311810606651*r**22
            -5517264068439*r**24-1653069836395*r**26-1160801742495*r**28-134070550515*r**30
            -10517626589*r**32-1654549361*r**34+191148990*r**36)+2*Q2**5*(44526470
            +3718402904*r**2+17482408263*r**4+525051721474*r**6-583635850216*r**8
            +8079234870264*r**10+166376158736*r**12+19562170599672*r**14+30849573522556*r**16
            +13418503624712*r**18-2742066012018*r**20-16256271303284*r**22+122861606312*r**24
            -5729655008664*r**26-1757694210536*r**28-1025597078216*r**30-114418714306*r**32
            -7136494272*r**34-542489341*r**36+81767490*r**38)+(-1+r**2)**4*(288635
            +31651299*r**2+111271033*r**4+7614797437*r**6-43628593504*r**8+388530892020*r**10
            -1579155924692*r**12+4161970681836*r**14-1560125734366*r**16-13257018016878*r**18
            +19628329796710*r**20-599093098738*r**22-6696813817396*r**24+1753856929396*r**26
            -934456148532*r**28+31634420780*r**30-44082832869*r**32-3316042973*r**34
            -266794967*r**36-10914211*r**38+469980*r**40)+2*Q2**4*(7344020+201681862*r**2
            -8499180259*r**4-57914087239*r**6-72471232020*r**8-1916232653488*r**10
            +45191035536*r**12-6407528085816*r**14-14149451477816*r**16+8025160669492*r**18
            +2762811336666*r**20+1284095345242*r**22+14491115933584*r**24-403906403376*r**26
            +525766748776*r**28+864923452752*r**30+167790295860*r**32+26316539366*r**34
            +500529681*r**36-318862123*r**38+12909300*r**40)+Q2**3*(-31307375-2375082196*r**2
            +3914474888*r**4-307603445700*r**6+1378713462367*r**8-7305891514164*r**10
            +15939838687208*r**12-26120977252704*r**14+5725243573170*r**16-16545846818376*r**18
            -2635796724808*r**20-12341711143848*r**22+34568176886694*r**24+22996488679160*r**26
            -12226936657224*r**28+10943838471808*r**30-1271315280819*r**32+871946193372*r**34
            +65171801120*r**36+7264364108*r**38+935570539*r**40-55577220*r**42)-Q2*(
            -1+r**2)**2*(3182875+314783476*r**2+572687324*r**4+64673752542*r**6-361227941195*r**8
            +2793557226118*r**10-9682124302768*r**12+21909567108248*r**14-4854905883266*r**16
            -44619376781680*r**18+23883287007016*r**20+54279686955588*r**22-3834252765318*r**24
            -34213158940444*r**26+10059925712720*r**28-5421764065736*r**30+349190098999*r**32
            -296058258004*r**34-22877575332*r**36-2019721970*r**38-111393023*r**40
            +5353830*r**42)+Q2**2*(14455775+1266088589*r**2-412625118*r**4+217995780164*r**6
            -1256783044359*r**8+8161841385043*r**10-25880881053966*r**12+54390652473544*r**14
            -32839166259042*r**16-25623157560118*r**18+14937874699996*r**20+6499117182224*r**22
            +63564386271386*r**24+11387512733742*r**26-68831208209812*r**28+27191083344504*r**30
            -12608200661581*r**32+1566594951993*r**34-748497467614*r**36-58144882836*r**38
            -5619477443*r**40-480698641*r**42+25053570*r**44))+209018880000*logq2**6*(
            -Q2+(-1+r)**2)*r**22*(-18-33*r**2-512*r**6+326*r**8+45*r**10)*(-Q2
            +(1+r)**2)*sqrtq2-16588800*logq2**4*r**14*(60*Q2**14*(279+1105*r**4)-60*Q2**13*(3672
            +3553*r**2+13184*r**4+12005*r**6)+6*Q2**12*(216522+397980*r**2+879960*r**4
            +1217787*r**6+560770*r**8)-4*Q2**11*(1102446+2916746*r**2+5719010*r**4
            +8812611*r**6+7107446*r**8+2178360*r**10)+Q2**10*(9157662+31630681*r**2
            +62692292*r**4+102204667*r**6+105754956*r**8+59741062*r**10+13516920*r**12)
            -10*Q2**9*(1094562+4964351*r**2+10058191*r**4+17452471*r**6+21517777*r**8
            +16715812*r**10+7286906*r**12+1344870*r**14)+5*Q2**8*(848286+7976115*r**2
            +14049744*r**4+23414022*r**6+37373222*r**8+43518791*r**10+30172424*r**12
            +11132460*r**14+2505060*r**16)-2*Q2**7*(-4062528+871560*r**2-21574260*r**4
            -81039648*r**6-85527785*r**8-9022188*r**10+65773250*r**12+55704100*r**14
            +20210067*r**16+9370620*r**18)+Q2**6*(-14591232-27280062*r**2-133532310*r**4
            -457180677*r**6-613653302*r**8-410556677*r**10-43933182*r**12+175267025*r**14
            +126444838*r**16+42740703*r**18+25254180*r**20)-4*Q2**5*(-2316114-6108162*r**2
            -26309109*r**4-108119484*r**6-142044207*r**8-97719918*r**10-8627437*r**12
            +50020851*r**14+51490781*r**16+26325998*r**18+8398326*r**20+3994935*r**22)
            -(-1+r**2)**4*(-124182+38701*r**2-2905026*r**4-5822095*r**6+17877786*r**8
            -12939494*r**10-34948534*r**12-35828334*r**14-2135360*r**16+29175209*r**18
            +10200296*r**20+483853*r**22+639180*r**24)-5*Q2**4*(-47736+2085258*r**2
            +1605498*r**4+25878921*r**6+28210614*r**8+5127676*r**10-21667370*r**12
            -42615694*r**14-25419898*r**16+12335474*r**18+5326264*r**20-2334627*r**22
            +1032420*r**24)+10*Q2**3*(-443556+573828*r**2-5282568*r**4-7874790*r**6
            +3305379*r**8-8687332*r**10-25552238*r**12-8823620*r**14+309336*r**16
            +3445412*r**18+32018534*r**20+14428426*r**22-621111*r**24+1692300*r**26)
            +2*Q2*(-1+r**2)**2*(-490842+405289*r**2-9300155*r**4-18555946*r**6+43857706*r**8
            -21569338*r**10-123343548*r**12-86672018*r**14-37179244*r**16+1269159*r**18
            +74591295*r**20+29403124*r**22+186388*r**24+2246130*r**26)+Q2**2*(3116862
            -5335435*r**2+49360670*r**4+60307542*r**6-189839810*r**8+138555941*r**10
            +391966600*r**12+302326440*r**14+7248446*r**16+5992315*r**18+178447522*r**20
            -223400190*r**22-137130410*r**24+11729387*r**26-12737880*r**28))*sqrtq2
            -11520*logq2**2*r**6*(24*Q2**22*(3349+23191*r**4)-24*Q2**21*(53244+44743*r**2
            +341916*r**4+399227*r**6)+8*Q2**20*(1141149+1938186*r**2+7548212*r**4
            +16204279*r**6+9269913*r**8)-16*Q2**19*(2388885+6200913*r**2+17996211*r**4
            +50023581*r**6+56128111*r**8+21236550*r**10)+Q2**18*(101371470+364376283*r**2
            +901939072*r**4+2925542404*r**6+4649993790*r**8+3571477829*r**10+1015255920*r**12)
            -2*Q2**17*(82990902+407489793*r**2+760476111*r**4+3079183744*r**6+6264453850*r**8
            +7013600283*r**10+4421219185*r**12+1015456548*r**14)+Q2**16*(124190814
            +1005250443*r**2-605927720*r**4+2360522459*r**6+10298899070*r**8+16041244481*r**10
            +19251003124*r**12+13358293273*r**14+2601432552*r**16)-8*Q2**15*(-13923204
            +17067252*r**2-1326430584*r**4-3838939006*r**6-6767174377*r**8-9484461898*r**10
            -7323319706*r**12-1336413278*r**14+1173902791*r**16+201367542*r**18)
            -4*Q2**14*(103924230+461839629*r**2+7069874398*r**4+27366106409*r**6
            +59883223146*r**8+98763664597*r**10+109101848210*r**12+73060945527*r**14
            +23648196448*r**16+1543875638*r**18+228768000*r**20)+8*Q2**13*(57789630
            +419259117*r**2+4658560473*r**4+23718707868*r**6+56853504860*r**8+104349367974*r**10
            +135528667572*r**12+121877950124*r**14+71681709642*r**16+22550628165*r**18
            +2862642671*r**20+387843480*r**22)-4*Q2**12*(23683686+620296833*r**2
            +3611063482*r**4+40919767270*r**6+92193166686*r**8+179874903864*r**10
            +265111420114*r**12+294461639190*r**14+254899956900*r**16+147431354047*r**18
            +43699855812*r**20+6461175500*r**22+755762904*r**24)+8*Q2**11*(-47911032
            -49186644*r**2-4425685472*r**4-1065658986*r**6-27485965883*r**8-74882465534*r**10
            -119893306538*r**12-125655979244*r**14-54665507600*r**16+23525424088*r**18
            +31950565618*r**20+8563522870*r**22+1805629995*r**24+127080954*r**26)
            +2*Q2**10*(253996626+1312179765*r**2+33707301004*r**4+95238282770*r**6
            +427663211674*r**8+1163066078355*r**10+2054655272808*r**12+2692243477820*r**14
            +2390087581998*r**16+1296820261587*r**18+363936348356*r**20+45528311954*r**22
            +20336551846*r**24-914446299*r**26+415924392*r**28)-4*Q2**9*(53227170
            +606841911*r**2+11226466297*r**4+53749728060*r**6+192995001626*r**8+638839813211*r**10
            +1177493558137*r**12+1736360711760*r**14+1959293099406*r**16+1535468746357*r**18
            +760731867411*r**20+240863926404*r**22+51248323574*r**24+21509118457*r**26
            +1008721467*r**28+317060400*r**30)+2*Q2**8*(-68409870+370756077*r**2
            -4927320492*r**4+52277135275*r**6-23716493510*r**8+484718620897*r**10
            +603587147548*r**12+798961328119*r**14+1644965959510*r**16+2446918974415*r**18
            +2142079382380*r**20+1047901209577*r**22+485282217070*r**24+118153207363*r**26
            +47382852420*r**28+3008049301*r**30+389783280*r**32)-8*Q2**7*(-29325612
            -62877084*r**2-5258584192*r**4+1025350222*r**6-92975388251*r**8-58991019510*r**10
            -320840189982*r**12-679437130574*r**14-608420561685*r**16-172017573438*r**18
            +277687239076*r**20+360796497330*r**22+156326837523*r**24+139280009422*r**26
            +36450984058*r**28+11461534670*r**30+843615305*r**32+33073602*r**34)
            -(-1+r**2)**6*(-111342-741639*r**2-60673944*r**4+127536874*r**6-3205168148*r**8
            +10217397442*r**10-29897017976*r**12-34740746198*r**14+193737188248*r**16
            -72930182964*r**18-319823878848*r**20+102654417774*r**22+101050018628*r**24
            -12171250498*r**26+11478112712*r**28+912649598*r**30+379158566*r**32
            +18007739*r**34+563976*r**36)+4*Q2**6*(-30822564-164742393*r**2-7952057988*r**4
            -4434808571*r**6-172196926538*r**8-139610466201*r**10-711416820346*r**12
            -1548839731179*r**14-1322256660234*r**16-640612627195*r**18+78477760518*r**20
            +575142317655*r**22+625539626354*r**24+119576944437*r**26+207757054018*r**28
            +61372155407*r**30+14701608134*r**32+1218148568*r**34+665718*r**36)+2*Q2*(
            -1+r**2)**4*(-716598-3444273*r**2-329128663*r**4+786724362*r**6-15396679070*r**8
            +43317800554*r**10-119537325386*r**12-133596075410*r**14+510084437102*r**16
            +63178550776*r**18-761468840424*r**20-725967628694*r**22+450004194774*r**24
            +371967238550*r**26-49120397302*r**28+47231589818*r**30+3477277328*r**32
            +1752942649*r**34+88115711*r**36+3044196*r**38)+8*Q2**5*(288354+39848442*r**2
            +719080673*r**4+2786827981*r**6+19234991160*r**8+37162801596*r**10+89812810270*r**12
            +266974341088*r**14-9628381328*r**16-167954937416*r**18-184968019052*r**20
            -85038377078*r**22+46680345184*r**24-96146507132*r**26+6044083818*r**28
            -1240741208*r**30-12002660394*r**32-532023730*r**34-136376381*r**36+12765153*r**38)
            -Q2**2*(-1+r**2)**2*(-7982526-21753423*r**2-3041778600*r**4+8989145879*r**6
            -127546337928*r**8+351340078348*r**10-919868411216*r**12-525259552124*r**14
            +2215611585292*r**16-3021863722*r**18-2026920891872*r**20-3055562194614*r**22
            -2964636195272*r**24+2293142877804*r**26+2334014554448*r**28-440159404156*r**30
            +323173862978*r**32+17236702721*r**34+13564741000*r**36+717803927*r**38
            +28453056*r**40)-4*Q2**4*(-9049440+16655433*r**2-2001397914*r**4+7755443082*r**6
            -61540954616*r**8+144871110442*r**10-311546954302*r**12-76582807342*r**14
            -203354864778*r**16-313968015972*r**18-273272118754*r**20-209950647090*r**22
            -56476766874*r**24+944867546150*r**26+527696521862*r**28-107341383098*r**30
            +148760610034*r**32-150875445*r**34+7327833396*r**36+344338576*r**38
            +29056650*r**40)+8*Q2**3*(-3002190-597906*r**2-923521234*r**4+3595029044*r**6
            -35720498475*r**8+106536716170*r**10-263249552734*r**12+56937186560*r**14
            +275846417250*r**16-181239122300*r**18-186552654138*r**20-113016227784*r**22
            -73679287688*r**24-624761140692*r**26+190539776150*r**28+496808887936*r**30
            -147119686436*r**32+73971576462*r**34+385633748*r**36+3413198100*r**38
            +183818947*r**40+9291210*r**42))*sqrtq2-32*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(3778*Q2**24*r**2+4*Q2**23*r**2*(11287+8598*r**2)-Q2**22*(123588
            +413273*r**2+8224490*r**4+1082761*r**6)+2*Q2**21*(777780-1722671*r**2
            +35004111*r**4+61875367*r**6+4542089*r**8)-Q2**20*(8503812-50984735*r**2
            +37764972*r**4+998164362*r**6+822398880*r**8+41372937*r**10)+2*Q2**19*(12728700
            -132562980*r**2-901178985*r**4+661081624*r**6+2942873210*r**8+1528445976*r**10
            +59110819*r**12)-2*Q2**18*(20316375-390311495*r**2-5091659678*r**4-6752046868*r**6
            +2275474247*r**8+8898882953*r**10+3314281240*r**12+109225494*r**14)+2*Q2**17*(7051536
            -708323153*r**2-14007579757*r**4-37493231467*r**6-41038508505*r**8-10868617423*r**10
            +12663463569*r**12+3504373331*r**14+122012037*r**16)+2*Q2**16*(38494035
            +732229265*r**2+21951008029*r**4+94715217408*r**6+188835172483*r**8+217395120444*r**10
            +96215255535*r**12+2577658284*r**14+1338261158*r**16-53118081*r**18)
            -4*Q2**15*(39250008+71665742*r**2+7794217857*r**4+70677943062*r**6+202496491933*r**8
            +383041239508*r**10+367031014753*r**12+145277957822*r**14+21470798447*r**16
            +4922384882*r**18+25153778*r**20)+2*Q2**14*(45441000-816525219*r**2-12436044120*r**4
            +108385242663*r**6+412173831462*r**8+1246305572796*r**10+1832857463502*r**12
            +1377181637232*r**14+429613472658*r**16+75122051295*r**18+12785084122*r**20
            +63447009*r**22)+4*Q2**13*(28748700+686758973*r**2+24034153640*r**4+30975280223*r**6
            +127757706961*r**8-118250027566*r**10-621436689468*r**12-800142266474*r**14
            -548090978314*r**16-100580856087*r**18-27634371188*r**20-1655382637*r**22
            +25532453*r**24)-2*Q2**12*(121122144+987001847*r**2+59579510354*r**4
            +328581634676*r**6+1610139222480*r**8+3458459706537*r**10+4168823558020*r**12
            +3995339392664*r**14+2196434429208*r**16+652009755025*r**18+354610677802*r**20
            +4424577508*r**22+10337037048*r**24+155770303*r**26)+4*Q2**11*(31386420
            -24559472*r**2+12474316946*r**4+231307151582*r**6+1136128711943*r**8
            +3708963216136*r**10+5775236989637*r**12+7460750155044*r**14+6365849224198*r**16
            +3238493271344*r**18+1124563674216*r**20+332870316638*r**22+23791326351*r**24
            +6335493112*r**26+55828017*r**28)+4*Q2**10*(25266267+443632186*r**2+18236167659*r**4
            -112307566516*r**6-271989447142*r**8-3097084550801*r**10-4537396749964*r**12
            -7678862302469*r**14-8839903586509*r**16-6300058585284*r**18-2535476092761*r**20
            -950596601722*r**22-186064896856*r**24-26447349461*r**26-1061240534*r**28
            +12847427*r**30)-4*Q2**9*(45685800+466338089*r**2+34804641940*r**4+116404688299*r**6
            +1191854347847*r**8+118709868125*r**10+3502410977810*r**12+4025263342807*r**14
            +2010102954021*r**16-509914552573*r**18-1200084113112*r**20+104176122297*r**22
            -277066973463*r**24+58483784119*r**26-20206127790*r**28+3677339461*r**30
            +47407203*r**32)+2*Q2**8*(39726450+344718077*r**2+42712113172*r**4+438538634254*r**6
            +2906321078682*r**8+4824455448068*r**10+17806946600368*r**12+33675596208210*r**14
            +39267779761754*r**16+32171722170394*r**18+13825339006356*r**20+3057582704978*r**22
            +2435068568422*r**24+62427172812*r**26+255826761064*r**28-17605497714*r**30
            +6522313972*r**32+50908761*r**34)+4*Q2**7*(10277928+115128287*r**2+5227842067*r**4
            -117369026250*r**6-184849413995*r**8-2474644963156*r**10-2788862795793*r**12
            -14950140579806*r**14-17491810825927*r**16-22452425330610*r**18-15145909592039*r**20
            -5837044372294*r**22-838765131585*r**24-976243826204*r**26-146870744475*r**28
            -43250233938*r**30-7133338485*r**32-279457021*r**34+7701696*r**36)+Q2**6*(
            -64416060-736571321*r**2-69458013030*r**4-96882874365*r**6-3561727951484*r**8
            +8751658749288*r**10-35558045124644*r**12+28721849799560*r**14-30289660300020*r**16
            +2702536567246*r**18+39453719823264*r**20+16658196219366*r**22+17169910415500*r**24
            +3631541898320*r**26+4697755838980*r**28+1583850727888*r**30-93534793696*r**32
            +63661889075*r**34-4797845530*r**36-64188737*r**38)+2*Q2**5*(13031604
            +187776613*r**2+21130475625*r**4+128301705435*r**6+1419372501261*r**8
            -3341617091804*r**10+24943724123140*r**12-19153623069060*r**14+48964439232260*r**16
            +27602674452886*r**18+10591370307470*r**20-25017965984374*r**22+3347659515310*r**24
            -10057584155820*r**26-2060258445260*r**28-2224904735604*r**30-866671094304*r**32
            +38698070925*r**34-20649046575*r**36+1505212563*r**38+13409709*r**40)
            +2*(-1+r**2)**4*(34659+722705*r**2+108983873*r**4+445530300*r**6+9028694702*r**8
            -81778006377*r**10+719397325476*r**12-3534479482064*r**14+11133706665250*r**16
            -17252093878806*r**18+5099830356782*r**20+15755349941032*r**22-14782890559416*r**24
            +5272665813550*r**26-1816517236044*r**28+165812414256*r**30-48893902237*r**32
            -12250845643*r**34-246027975*r**36-143926852*r**38+3984930*r**40+37899*r**42)
            +Q2**4*(3741300-18170649*r**2-1319927280*r**4-131272748878*r**6-162212251456*r**8
            +318254849331*r**10-16906210214352*r**12+31896247205464*r**14-73695371695432*r**16
            +5169426760542*r**18+26395731106736*r**20-34671131354196*r**22+77501996828912*r**24
            -10810216527602*r**26+6456922405584*r**28+2428167270360*r**30+957929963444*r**32
            +500092838779*r**34+10929006912*r**36+557737330*r**38-133022352*r**40
            +4437503*r**42)-2*Q2*(-1+r**2)**2*(396000+6633677*r**2+1014664621*r**4
            +2618079884*r**6+80642612988*r**8-660176777173*r**10+5000723732403*r**12
            -20258873122584*r**14+51013630879448*r**16-51618054103094*r**18-20941822100006*r**20
            +54846589719744*r**22+27996019632016*r**24-54818136264098*r**26+23148297139774*r**28
            -9487436899944*r**30+1077889587720*r**32-275563172039*r**34-89814530359*r**36
            +192673332*r**38-1338610252*r**40+42513831*r**42+434111*r**44)-2*Q2**3*(4148100
            +40950092*r**2+6211485451*r**4-11378765932*r**6+459907618232*r**8-2470254740392*r**10
            +10864373155817*r**12-22255082860112*r**14+25730924729616*r**16+829256522104*r**18
            +6654082618966*r**20+21138875931672*r**22-47437051581960*r**24-4591264598736*r**26
            +12701496713146*r**28-12155515642256*r**30+2203719740012*r**32-672497603748*r**34
            -255656757073*r**36+18162185268*r**38-7778581168*r**40+335315032*r**42
            +4577869*r**44)+2*Q2**2*(1860921+23456625*r**2+3775736972*r**4+1392908336*r**6
            +289222186475*r**8-2212685382853*r**10+13962686641812*r**12-48178138257620*r**14
            +102955593845170*r**16-97569848198270*r**18+21973992031888*r**20-32766019650616*r**22
            +84976954684078*r**24+22832780411694*r**26-83961339510560*r**28+44970935625024*r**30
            -19405243397179*r**32+2888589426941*r**34-477006048892*r**36-258265158520*r**38
            +10359667895*r**40-5038909017*r**42+180225004*r**44+2044692*r**46))*sqrtq2)/(705438720000*logq2**5*(
            -Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +16329600000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+34020000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-1410877440000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-146966400000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-1020600000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -472500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*sqrtq2)
            +(flagPERP*(-248832000*logq2**5*(-Q2+(-1+r)**2)*r**20*(-Q2+(1+r)**2)*(
            -420*Q2**9*r**2+60*Q2**8*(8+51*r**2+37*r**4)-40*Q2**7*(96+281*r**2+328*r**4
            +45*r**6)+4*Q2**6*(3360+6676*r**2+8487*r**4+1690*r**6-2877*r**8)+Q2**5*(
            -24675-44164*r**2-44222*r**4-19828*r**6+50433*r**8+32928*r**10)+Q2**4*(21315
            +47095*r**2+28212*r**4+23434*r**6-49925*r**8-104449*r**10-27090*r**12)
            -2*Q2**3*(-105+17105*r**2+3224*r**4+7017*r**6-23847*r**8-36323*r**10
            -32108*r**12+9345*r**14)+(-1+r**2)**2*(-2985+7299*r**2+5207*r**4-35113*r**6
            +43049*r**8+48649*r**10-24515*r**12+9277*r**14+9612*r**16)+2*Q2**2*(
            -8085+16460*r**2+1611*r**4-17045*r**6+6832*r**8+7890*r**10-25141*r**12
            +1203*r**14+26355*r**16)+Q2*(12225-33014*r**2+4784*r**4+97176*r**6
            -51266*r**8-200968*r**10-101904*r**12+68368*r**14+641*r**16-37962*r**18))
            -138240*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-126720*Q2**15*r**2
            +12*Q2**14*(-64+127440*r**2+117135*r**4)-4*Q2**13*(-9018+1980972*r**2
            +3696715*r**4+1667115*r**6)+4*Q2**12*(-66342+5576832*r**2+16188333*r**4
            +14879200*r**6+4318875*r**8)-Q2**11*(-796827+34607052*r**2+146708482*r**4
            +204136788*r**6+125461505*r**8+25364880*r**10)+Q2**10*(-943533+21504387*r**2
            +159785972*r**4+291646482*r**6+282753307*r**8+138765515*r**10+18135630*r**12)
            +Q2**9*(-499389+18885840*r**2-242845*r**4+36241810*r**6+39677325*r**8
            -82100264*r**10-59160795*r**12+770310*r**14)-Q2**8*(-2715831+46341189*r**2
            +214774995*r**4+695944635*r**6+1182293495*r**8+839871579*r**10+201366349*r**12
            +19817565*r**14+11395080*r**16)+2*Q2**7*(-1284957+14499882*r**2+115869363*r**4
            +447842420*r**6+960472625*r**8+1041617518*r**10+498631117*r**12+102685048*r**14
            +10572420*r**16+4900500*r**18)-2*Q2**6*(245277-3953817*r**2+22867773*r**4
            +168027617*r**6+433359805*r**8+816102877*r**10+668138603*r**12+208201883*r**14
            +93969722*r**16+9169200*r**18+5243220*r**20)+2*Q2**5*(1334283-11017962*r**2
            -45810702*r**4-93187212*r**6-387157432*r**8-150485872*r**10+278775898*r**12
            +333818448*r**14+188193213*r**16+207498298*r**18+28051380*r**20+6579900*r**22)
            -2*Q2**4*(849609-5431365*r**2-34778900*r**4-97580870*r**6-493896470*r**8
            -545379488*r**10-105973710*r**12+481472390*r**14+434402575*r**16+370381925*r**18
            +198940034*r**20+30749680*r**22+3244590*r**24)+Q2**3*(-177153+1716552*r**2
            -6116820*r**4-113672180*r**6-65266565*r**8-728230504*r**10+32992736*r**12
            +747750120*r**14+1347126965*r**16+4123240*r**18+690510932*r**20-41720788*r**22
            +18933425*r**24-4017960*r**26)+(-1+r**2)**2*(52467-214959*r**2-513578*r**4
            +24544170*r**6-126468135*r**8+333630851*r**10+143760988*r**12-186943764*r**14
            -290848075*r**16+152935495*r**18+307080582*r**20-41295254*r**22+44394367*r**24
            +2264805*r**26+500040*r**28)+Q2**2*(706407-4302117*r**2-10478558*r**4
            +142444560*r**6-627305085*r**8+1016948831*r**10-401677846*r**12-242493064*r**14
            -730602595*r**16-672524215*r**18+1375783262*r**20-535514312*r**22+310701497*r**24
            +8919485*r**26+6513750*r**28)+Q2*(-330273+1943268*r**2+3255253*r**4
            -103200878*r**6+568986855*r**8-1328446124*r**10+663530109*r**12+54640474*r**14
            -1022622379*r**16+253007340*r**18+613081927*r**20-1338623402*r**22+389254373*r**24
            -195871268*r**26-7112345*r**28-3012930*r**30))+96*logq2*r**4*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*(41196*Q2**21*r**2-12*Q2**20*(-1480+57537*r**2
            +57537*r**4)+120*Q2**19*(-1538+36356*r**2+93839*r**4+39453*r**6)-4*Q2**18*(
            -197020+3429590*r**2+17022939*r**4+17758976*r**6+4374255*r**8)+Q2**17*(
            -1611705+21307800*r**2+196865022*r**4+326801204*r**6+226422315*r**8
            +36585180*r**10)-Q2**16*(-825285+8328699*r**2+243045288*r**4+271652546*r**6
            +393855835*r**8+353632323*r**10+35295714*r**12)-2*Q2**15*(-1691530+8632397*r**2
            +47034651*r**4+1203624515*r**6+2322591946*r**8+888276297*r**10-27952759*r**12
            +9161007*r**14)+6*Q2**14*(-1276570+306365*r**2+107405990*r**4+1468114024*r**6
            +4369816345*r**8+4133678157*r**10+1278770820*r**12+132717130*r**14+15579195*r**16)
            -6*Q2**13*(-694360-9541905*r**2+108142642*r**4+1891948324*r**6+8996254464*r**8
            +13405058556*r**10+8681955634*r**12+1980123832*r**14+229100148*r**16
            +14985465*r**18)+Q2**12*(7231640-45106750*r**2+147589494*r**4-510307928*r**6
            +31590484676*r**8+63259793076*r**10+72748902136*r**12+42509817224*r**14
            +5135819268*r**16+692981210*r**18-25514190*r**20)+2*Q2**11*(-6692790
            -43045977*r**2-138804633*r**4+9040529951*r**6+31325757150*r**8+94929285204*r**10
            +132949671332*r**12+57641585244*r**14+10260629376*r**16+4505870285*r**18
            +355067277*r**20+63349533*r**22)-2*Q2**10*(-2475330-80127723*r**2-427329540*r**4
            +8482224308*r**6+62173944523*r**8+237632761038*r**10+504894152264*r**12
            +446597123224*r**14+157735353072*r**16+33855112253*r**18+6979631884*r**20
            +627808500*r**22+42879447*r**24)+2*Q2**9*(4015635-17649645*r**2-80633610*r**4
            -1824953034*r**6+29923651135*r**8+140347883043*r**10+544580901140*r**12
            +778778866780*r**14+486715657641*r**16+108009326625*r**18+22472141078*r**20
            +2820445950*r**22+299041125*r**24-17911335*r**26)+2*Q2**8*(-5095155-64812390*r**2
            -726733239*r**4+7729275950*r**6+19926490149*r**8+145558773576*r**10+76967287949*r**12
            -135228948996*r**14-279692483433*r**16-138804933646*r**18+24195819291*r**20
            -3024656826*r**22+968352551*r**24+82666044*r**26+42145695*r**28)-2*Q2**7*(
            -1141230-61180425*r**2-771079923*r**4+3106696853*r**6+26175882046*r**8
            +242266876761*r**10+592831687421*r**12+912351757243*r**14+868180549830*r**16
            +280334574881*r**18+70627874791*r**20+55988355171*r**22-628241398*r**24
            +1023832399*r**26+176923695*r**28+16904205*r**30)+2*Q2**6*(1923590-152827*r**2
            +31246698*r**4-2840959408*r**6+8847417085*r**8+65995782819*r**10+378992755352*r**12
            +759043973518*r**14+1225994189751*r**16+848962846475*r**18+178485168418*r**20
            +17273411172*r**22+24761709059*r**24+567468397*r**26+703397820*r**28
            +117341918*r**30-10364637*r**32)+2*Q2**5*(-1687020-30111117*r**2-526241814*r**4
            +3031195536*r**6-5399320116*r**8+87944018802*r**10-73099714*r**12+85799140020*r**14
            -12540830160*r**16-548859502468*r**18-205049783706*r**20-196227938040*r**22
            -67969411444*r**24-38817508986*r**26-8582403726*r**28-1238044236*r**30
            -53687964*r**32+12470553*r**34)+2*Q2**4*(309480+16643565*r**2+303501675*r**4
            -468666468*r**6+6072438630*r**8-72665356764*r**10-49742477450*r**12-222911612740*r**14
            -809622560514*r**16+56447378230*r**18+316674193628*r**20+117897252180*r**22
            +397604133970*r**24+157953921812*r**26+45568320090*r**28+9012406356*r**30
            +894533730*r**32+1524645*r**34-2924055*r**36)-2*Q2**3*(-289910-474605*r**2
            -31915293*r**4+714305651*r**6-771979178*r**8-2462298942*r**10-13502542778*r**12
            -21154868422*r**14-399967899894*r**16+182040594376*r**18+323036215364*r**20
            +30667931616*r**22+367504684738*r**24+62106880670*r**26+100384759962*r**28
            +4651250438*r**30+1576907092*r**32-89419323*r**34-26686727*r**36+1965165*r**38)
            +(-1+r**2)**2*(-11815-403479*r**2-12116849*r**4+7431355*r**6-1021262296*r**8
            +3713843244*r**10-19357856828*r**12-79702366908*r**14+643446898310*r**16
            -1875974607162*r**18+1346326900378*r**20+947285878418*r**22-1500221460412*r**24
            +547694052940*r**26-160473203388*r**28-1314878428*r**30-6495045111*r**32
            -596417831*r**34-67757105*r**36-1871029*r**38+93996*r**40)+2*Q2**2*(
            -209010-3774075*r**2-100503306*r**4+495159340*r**6-4934409087*r**8+23742388308*r**10
            -47797118772*r**12-65442601284*r**14+435289265808*r**16-512251145506*r**18
            +201626183424*r**20+843810468444*r**22-1273773051514*r**24+942040248564*r**26
            -363615254652*r**28+28925356068*r**30-22402113222*r**32-2276793771*r**34
            -420155462*r**36-21995880*r**38+1575585*r**40)+Q2*(113115+2926986*r**2
            +81610158*r**4-276256040*r**6+5678145215*r**8-28132582398*r**10+96147156696*r**12
            +166092974016*r**14-1702057063770*r**16+4055392372820*r**18-2870556455516*r**20
            +1790627790576*r**22-4370925867706*r**24+5072448079060*r**26-2208592193160*r**28
            +617619359616*r**30-27933564609*r**32+28296357282*r**34+2726470750*r**36
            +402827000*r**38+15322683*r**40-882774*r**42))+104509440000*logq2**6*r**24*(3
            +20*r**4-56*r**6+9*r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            -8294400*logq2**4*r**16*(-13260*Q2**14*r**2+60*Q2**13*(40+2680*r**2+2401*r**4)
            -6*Q2**12*(5100+147238*r**2+246091*r**4+112154*r**6)+4*Q2**11*(40100
            +721304*r**2+1652517*r**4+1421660*r**6+435672*r**8)-Q2**10*(447475+6049088*r**2
            +16717435*r**4+20029380*r**6+11769298*r**8+2703384*r**10)+10*Q2**9*(68555
            +805237*r**2+2501440*r**4+3686911*r**6+3084241*r**8+1407782*r**10+268974*r**12)
            -5*Q2**8*(86805+1204482*r**2+3844386*r**4+6617882*r**6+7328747*r**8
            +5298296*r**10+2150082*r**12+501012*r**14)+2*Q2**7*(-162900+537168*r**2
            -559419*r**4+448879*r**6+4767120*r**8+10594610*r**10+9988123*r**12+4398291*r**14
            +1874124*r**16)+Q2**6*(868050+2153988*r**2+18220419*r**4+28318100*r**6
            +22904339*r**8-2968560*r**10-30037967*r**12-26248396*r**14-10867545*r**16
            -5050836*r**18)+2*Q2**5*(-317550-1078182*r**2-8595135*r**4-13362360*r**6
            -11869077*r**8-483356*r**10+15992313*r**12+22072780*r**14+12186475*r**16
            +5063118*r**18+1597974*r**20)+(-1+r**2)**4*(-7925+64002*r**2-644137*r**4
            +2092860*r**6-501548*r**8-14416*r**10+1553052*r**12-405848*r**14+305105*r**16
            +1974638*r**18-7619*r**20+127836*r**22)+5*Q2**4*(5790+325128*r**2+588075*r**4
            +2765862*r**6+1529776*r**8-1393670*r**10-5670238*r**12-6381562*r**14
            -4463374*r**16+401518*r**18-1179069*r**20+206484*r**22)-10*Q2**3*(-27300
            +174264*r**2-918057*r**4+1832787*r**6-194026*r**8-1252730*r**10-218876*r**12
            +379404*r**14-893110*r**16-338902*r**18+2742397*r**20-414711*r**22+338460*r**24)
            -2*Q2*(-1+r**2)**2*(-31775+227677*r**2-2019340*r**4+5478478*r**6-1014238*r**8
            -2340054*r**10+6316966*r**12+6661844*r**14-1319973*r**16+248793*r**18
            +5766334*r**20-279938*r**22+449226*r**24)+Q2**2*(-200975+1401592*r**2
            -10450116*r**4+27647936*r**6-17373755*r**8-7527460*r**10+13976676*r**12
            +33441052*r**14+27045263*r**16-4193020*r**18-17708640*r**20+28043732*r**22
            -4073861*r**24+2547576*r**26))*sqrtq2+1152*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(556584*Q2**18*r**2-24*Q2**17*(-6440+323208*r**2+306463*r**4)
            +8*Q2**16*(-206850+5519389*r**2+11628335*r**4+5174919*r**6)-16*Q2**15*(
            -453390+8198464*r**2+29667243*r**4+28688323*r**6+7989399*r**8)+Q2**14*(
            -15560475+202083880*r**2+1220893040*r**4+1833745864*r**6+1181704395*r**8
            +225561240*r**10)-2*Q2**13*(-5645325+43616511*r**2+717343940*r**4+1230354128*r**6
            +1303767993*r**8+779996385*r**10+94366656*r**12)-Q2**12*(-21123795+215895094*r**2
            +268889069*r**4+4014555896*r**6+6997825091*r**8+2134796386*r**10-510499101*r**12
            +59589024*r**14)+4*Q2**11*(-14212275+86070211*r**2+743035225*r**4+4686585867*r**6
            +11081489235*r**8+9824682745*r**10+3123228847*r**12+360722385*r**14+78294696*r**16)
            -Q2**10*(-39352005+41037548*r**2+3285943206*r**4+23975557532*r**6+82036551836*r**8
            +111640348140*r**10+68855674586*r**12+16275034772*r**14+2141869801*r**16
            +285317208*r**18)+2*Q2**9*(15644475-159295005*r**2+299102910*r**4+1564699086*r**6
            +23439363700*r**8+50040687620*r**10+51591022530*r**12+24569424530*r**14
            +2959354561*r**16+549580505*r**18+16391760*r**20)+Q2**8*(-72689925+241774542*r**2
            +1376541385*r**4+23642841412*r**6+53046035202*r**8+80273670480*r**10
            +65852812518*r**12+5296665100*r**14-1699708733*r**16+5042504322*r**18
            -160900335*r**20+132289872*r**22)-8*Q2**7*(-4477935-12549833*r**2+113135397*r**4
            +2869845901*r**6+12111514456*r**8+27782911496*r**10+40552191738*r**12
            +27367406188*r**14+7124939001*r**16+1485846481*r**18+625020601*r**20
            +805847*r**22+13167702*r**24)+Q2**6*(22941975-222773024*r**2+320246860*r**4
            +1186948608*r**6+42075249355*r**8+123826787000*r**10+253894842256*r**12
            +302901668880*r**14+128639342541*r**16+31928011680*r**18+5192478500*r**20
            +3260490288*r**22+390413905*r**24+33194376*r**26)-2*Q2**5*(17956365-41277559*r**2
            +323114312*r**4-5311848084*r**6-7966543787*r**8-13823328875*r**10-38085421224*r**12
            +36373118112*r**14+58882418407*r**16+19450066291*r**18+33943885680*r**20
            +8402339828*r**22+2995570871*r**24+427633647*r**26+3519216*r**28)+Q2**4*(12569025
            +42558630*r**2+532283765*r**4-5857073536*r**6-20006350895*r**8-34234549530*r**10
            -191812969715*r**12-100524001040*r**14+70382940747*r**16+93491962450*r**18
            +82418789815*r**20+95990523760*r**22+24050384675*r**24+5151956514*r**26
            +571345095*r**28-1409760*r**30)+4*Q2**3*(1243725-12088901*r**2+33945405*r**4
            -197600789*r**6+1481269421*r**8+1734068835*r**10+12345396741*r**12+16114316675*r**14
            -14472290177*r**16-38680880487*r**18+1084023295*r**20-28955989079*r**22
            -2626870105*r**24-2641517559*r**26+73361791*r**28+12920745*r**30+2530464*r**32)
            -(-1+r**2)**2*(246015+536676*r**2+32866994*r**4-76476220*r**6+175415270*r**8
            +9083955020*r**10-45076434838*r**12+107812661588*r**14+2554205940*r**16
            -117106438140*r**18+3423157590*r**20+86477254348*r**22-27968873558*r**24
            +12315091780*r**26+668521870*r**28+322313500*r**30+20632189*r**32+563976*r**34)
            -Q2**2*(5835585-16402172*r**2+385462518*r**4-2053395604*r**6+1536932986*r**8
            +27486858996*r**10-116893034098*r**12+168733564812*r**14-98504943492*r**16
            -29664224772*r**18-184808077822*r**20+263810299812*r**22-154780905578*r**24
            +66730605596*r**26+491409786*r**28+2847158116*r**30+251116083*r**32+9739248*r**34)
            +2*Q2*(987525-952091*r**2+95622530*r**4-441681714*r**6+600269490*r**8
            +14843714010*r**10-78143641962*r**12+165889979990*r**14-93319820228*r**16
            +36498450420*r**18-1688578270*r**20-108839318678*r**22+176852299230*r**24
            -73189265802*r**26+24791391090*r**28+519434610*r**30+787021231*r**32
            +60572375*r**34+1916244*r**36))*sqrtq2+16*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(658*Q2**22+Q2**21*(9168+5492*r**2)-Q2**20*(149367+1710440*r**2
            +145885*r**4)+2*Q2**19*(166081+11225142*r**2+11373357*r**4+513816*r**6)
            -4*Q2**18*(-500241+29074056*r**2+68728671*r**4+32028984*r**6+949307*r**8)
            +2*Q2**17*(-5615008+146448803*r**2+643844310*r**4+678188618*r**6+190108966*r**8
            +4125635*r**10)-4*Q2**16*(-3973359+74266084*r**2+679947566*r**4+1166558084*r**6
            +813909434*r**8+142704876*r**10+2477669*r**12)+2*Q2**15*(11775989-110636094*r**2
            +664396723*r**4+951187330*r**6+1749762163*r**8+1506240170*r**10+59782461*r**12
            +1513106*r**14)+2*Q2**14*(-55171233+425567014*r**2+2711053775*r**4+12958211190*r**6
            +21658743637*r**8+9739250642*r**10+1595151489*r**12+544099234*r**14+4360652*r**16)
            -2*Q2**13*(-64251489+244237704*r**2+5532279198*r**4+32275758294*r**6
            +86358159924*r**8+82047028890*r**10+28156092330*r**12+5697080754*r**14
            +880213701*r**16+5410358*r**18)+Q2**12*(32404320-689625728*r**2+6029515422*r**4
            +40568180232*r**6+219931592136*r**8+336188308392*r**10+225093896652*r**12
            +50076188856*r**14+10603021032*r**16+512577624*r**18-2528058*r**20)+2*Q2**11*(
            -115033373+399321098*r**2+2210312267*r**4+31587831686*r**6+31061512558*r**8
            +34431825288*r**10-6092006098*r**12-19785079664*r**14+9780730671*r**16
            +148443454*r**18+792861927*r**20+7594938*r**22)-2*Q2**10*(-93871869-301375562*r**2
            +3319994183*r**4+57918106482*r**6+221297158884*r**8+548728816820*r**10
            +745806838042*r**12+376195573260*r**14+111602538743*r**16+34133271638*r**18
            +4291667039*r**20+952597698*r**22+5111938*r**24)+2*Q2**9*(35349973-660880954*r**2
            +1254992504*r**4+13592393802*r**6+188409941901*r**8+595751483472*r**10
            +1400248406784*r**12+1275737968812*r**14+420777203271*r**16+112212418766*r**18
            +17786796808*r**20+3853561546*r**22+74351511*r**24-2393252*r**26)+2*Q2**8*(
            -108253049+118145044*r**2-1124814378*r**4+38306461532*r**6+18754759225*r**8
            +173212341792*r**10-500295246472*r**12-989355332216*r**14-692859876855*r**16
            -17789612956*r**18-28297635746*r**20+5682638556*r**22-1939300841*r**24
            +618754856*r**26+5264308*r**28)-2*Q2**7*(-54052263-448577294*r**2-1520978173*r**4
            +28731627586*r**6+112888864569*r**8+706645991774*r**10+929096410339*r**12
            +1001121957078*r**14+418146169379*r**16+16355794270*r**18+193861735857*r**20
            +135446846*r**22+5076541451*r**24-433805614*r**26+430061097*r**28+2026538*r**30)
            +2*Q2**6*(26086756-338891526*r**2+444452537*r**4-9932112558*r**6+69997798893*r**8
            +300770174994*r**10+915081187041*r**12+1489407656154*r**14+1687384602261*r**16
            +547655973486*r**18-13794033501*r**20+77006155926*r**22+1117169999*r**24
            -1921129978*r**26+1260136771*r**28-59789634*r**30-1335221*r**32)+2*Q2**5*(
            -41065221-30301762*r**2-2100878558*r**4+19379453494*r**6-37887938426*r**8
            +262142876010*r**10-288763677838*r**12+154465718158*r**14-604942387500*r**16
            -650739335506*r**18-222381517226*r**20-50316474078*r**22-61839285638*r**24
            -28061823154*r**26-913977578*r**28-2037242598*r**30+205606193*r**32+1540828*r**34)
            +Q2**4*(27030983+281559096*r**2+2329355103*r**4-8747645416*r**6+40739366524*r**8
            -535300669288*r**10+403110641524*r**12-1808455964520*r**14-1432781657230*r**16
            +955373106632*r**18+122065779642*r**20+994249714184*r**22+578840269196*r**24
            +246283782728*r**26+66968062644*r**28+8072207688*r**30+1963310271*r**32
            -157780704*r**34-693057*r**36)-4*Q2**3*(-2393664+28989864*r**2-155289084*r**4
            +2427128335*r**6-6125332244*r**8-451871134*r**10+21267853224*r**12-132493087338*r**14
            -254737602684*r**16+394463082666*r**18-13968192200*r**20+181366227780*r**22
            +40316224628*r**24+110206678118*r**26+21963685960*r**28+2782514298*r**30
            +999139932*r**32-155130906*r**34+9843156*r**36+123293*r**38)+2*(-1
            +r**2)**2*(-190141-1529518*r**2-33679497*r**4+9807032*r**6-1746945342*r**8
            +6647955444*r**10-39233655776*r**12-41613662324*r**14+844981789254*r**16
            -3200025798184*r**18+4808873592694*r**20-3353175039444*r**22+1172325161764*r**24
            -289357902804*r**26+26173110744*r**28-10693057756*r**30-1369313137*r**32
            -113407818*r**34-30256357*r**36+935532*r**38+5634*r**40)+2*Q2**2*(-5256619
            -1096858*r**2-569910819*r**4+3574594202*r**6-23996575640*r**8+106537748288*r**10
            -268025666192*r**12+237211890976*r**14+208084980498*r**16-175106578276*r**18
            +1047462497634*r**20-2262696717692*r**22+2130463827880*r**24-852248583952*r**26
            +143057076472*r**28-47330360656*r**30-10657058383*r**32-95706162*r**34
            -538547623*r**36+25490194*r**38+192728*r**40)-2*Q2*(-1647815-6079975*r**2
            -224696078*r**4+905703860*r**6-11449882667*r**8+57888034035*r**10-231966314240*r**12
            +211288930984*r**14+1134859600730*r**16-3216199321134*r**18-86321246700*r**20
            +6808527240080*r**22-7559948172934*r**24+3468174980510*r**26-972610147056*r**28
            +129588947480*r**30-38974080115*r**32-6566340347*r**34-280835350*r**36
            -221131268*r**38+8084625*r**40+53375*r**42))*sqrtq2)*math.log(mu0))/(78382080000*logq2**5*(
            -Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +1814400000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+3780000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-156764160000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-16329600000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-113400000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -52500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*sqrtq2)
            +((248832000*logq2**5*r**18*(-420*Q2**11*(2+5*r**4)+60*Q2**10*(194+212*r**2
            +437*r**4+255*r**6)-20*Q2**9*(3426+6972*r**2+10615*r**4+7838*r**6+1665*r**8)
            +4*Q2**8*(57618+160047*r**2+258485*r**4+216315*r**6+65865*r**8-7110*r**10)
            +Q2**7*(-484056-1617165*r**2-2871524*r**4-2651950*r**6-1135140*r**8
            +207315*r**10+270720*r**12)+Q2**6*(629496+2372769*r**2+4533691*r**4
            +4300204*r**6+2021070*r**8-205175*r**10-1179465*r**12-522270*r**14)
            +Q2**5*(-429912-1862847*r**2-3721990*r**4-3191853*r**6-1259418*r**8
            +1041695*r**10+1296990*r**12+1096725*r**14+342090*r**16)+(-1+r**2)**4*(
            -17088-18795*r**2-21135*r**4+136265*r**6-740695*r**8-253957*r**10+192475*r**12
            +57355*r**14+133675*r**16+48060*r**18)+Q2**4*(-17640+450135*r**2+1035007*r**4
            +479273*r**6-631395*r**8-1250735*r**10-1400695*r**12+7695*r**14+620235*r**16
            +315000*r**18)+Q2**3*(312768+309357*r**2+302872*r**4-31970*r**6+2660268*r**8
            +3728068*r**10-1049848*r**12-755070*r**14-845060*r**16-1784865*r**18
            -810360*r**20)-Q2*(-1+r**2)**2*(-108384-110799*r**2-102640*r**4+469850*r**6
            -2947570*r**8-3793436*r**10+466414*r**12+997990*r**14+274890*r**16+697035*r**18
            +285930*r**20)+Q2**2*(-274704-109305*r**2-64759*r**4+780600*r**6-5129310*r**8
            -4646176*r**10-2277180*r**12+1320354*r**14+1305350*r**16-428415*r**18
            +1090875*r**20+691230*r**22))+138240*logq2**3*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(-180*Q2**17*(687+3520*r**4)+12*Q2**16*(145209+134648*r**2
            +655656*r**4+691275*r**6)-4*Q2**15*(2677302+4920501*r**2+13552617*r**4
            +22398253*r**6+12008025*r**8)+8*Q2**14*(4642020+12845148*r**2+31082511*r**4
            +58031107*r**6+54932145*r**8+20011275*r**10)-Q2**13*(76851180+295637991*r**2
            +728962248*r**4+1451259386*r**6+1758838824*r**8+1194796055*r**10+332921700*r**12)
            +Q2**12*(84960540+487160349*r**2+1203391395*r**4+2618752084*r**6+3616206066*r**8
            +3337328181*r**10+1904259415*r**12+430704450*r**14)-2*Q2**11*(2743272
            +188425437*r**2+250795212*r**4+670144431*r**6+1011099911*r**8+1079701735*r**10
            +1275535046*r**12+824294433*r**14+152164575*r**16)+2*Q2**10*(-65107548
            -70638837*r**2-1093190739*r**4-2742499879*r**6-4624436750*r**8-5933256326*r**10
            -4008370495*r**12-768518955*r**14+200104408*r**16+12999825*r**18)+Q2**9*(186062580
            +641523807*r**2+4838376204*r**4+14455085438*r**6+26574484030*r**8+38171849000*r**10
            +36000291782*r**12+19225071674*r**14+4817795078*r**16+597953505*r**18
            +166807350*r**20)-Q2**8*(83641140+627279993*r**2+3673314039*r**4+15065763348*r**6
            +28912437972*r**8+46430742650*r**10+55954169518*r**12+42927138204*r**14
            +18399002968*r**16+4738914237*r**18+738669915*r**20+207417600*r**22)
            +4*Q2**7*(-17943750+53530788*r**2-333611085*r**4+1164222978*r**6+1036149702*r**8
            +903784212*r**10+4828121398*r**12+8684823340*r**14+7004306008*r**16+2663099912*r**18
            +1339752627*r**20+198619530*r**22+54917100*r**24)-4*Q2**6*(-31067316
            -26620905*r**2-1260854973*r**4-1163004961*r**6-5773062756*r**8-14454501347*r**10
            -13604880658*r**12-4087020790*r**14+4970617074*r**16+5157154919*r**18
            +1908180331*r**20+1955638851*r**22+262723346*r**24+54119025*r**26)+Q2**5*(
            -63520884-158174265*r**2-3845275920*r**4-4824559478*r**6-23584022100*r**8
            -65453440259*r**10-65456189472*r**12-30838250444*r**14+10797549404*r**16
            +30122146345*r**18+19401760488*r**20+5669591042*r**22+6198036364*r**24
            +856909779*r**26+110601000*r**28)+(-1+r**2)**4*(-408312-125055*r**2
            -52121757*r**4+124875502*r**6-716725158*r**8-348339321*r**10+2358533045*r**12
            +574331404*r**14-6376937484*r**16-5380078609*r**18+4541769133*r**20+2216311710*r**22
            -92084822*r**24+231490057*r**26+13969467*r**28+2500200*r**30)+Q2**4*(
            -6739740+104075259*r**2+248412933*r**4+2611315556*r**6+4395789210*r**8
            +20964708245*r**10+14090687807*r**12-4942192246*r**14-18539298272*r**16
            -20298674795*r**18-4354671005*r**20-232711616*r**22-2589936062*r**24
            +325781691*r**26-223569415*r**28+40302450*r**30)-Q2*(-1+r**2)**2*(-3841272
            +3125103*r**2-400921782*r**4+988014115*r**6-4705680386*r**8-2687278929*r**10
            +13019115714*r**12-3861985701*r**14-19303641530*r**16-24858789163*r**18
            -16673146146*r**20+22201393633*r**22+12762568858*r**24-1299918835*r**26
            +1494577174*r**28+82024097*r**30+20065050*r**32)-2*Q2**3*(-13088160+31275633*r**2
            -810935256*r**4+1680241283*r**6-5536756173*r**8-3960046435*r**10+2129658454*r**12
            -8858976693*r**14-6450062031*r**16-2850606509*r**18-1924988420*r**20
            +18645784513*r**22+12449110149*r**24-2097497377*r**26+2334043782*r**28
            +81577265*r**30+50145975*r**32)+2*Q2**2*(-7358940+16505187*r**2-622064115*r**4
            +1804537377*r**6-6657829462*r**8-323197992*r**10+12757021111*r**12-11635443245*r**14
            -14431261744*r**16-7142730756*r**18-1966505141*r**20-21398365993*r**22
            +12629088210*r**24+15055527092*r**26-3301369807*r**28+1893501173*r**30
            +73027920*r**32+32599125*r**34))-96*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(205980*Q2**23*r**2-60*Q2**22*(-1184+39539*r**2+64403*r**4)+12*Q2**21*(
            -66010+384665*r**2+3695392*r**4+2565185*r**6)-4*Q2**20*(-1072795-14016985*r**2
            +30048273*r**4+82088225*r**6+34570230*r**8)+Q2**19*(-16259015-459430624*r**2
            -489420362*r**4+611399268*r**6+1279317721*r**8+381567900*r**10)+Q2**18*(50346775
            +1801153481*r**2+4552801352*r**4+5096076530*r**6+716941367*r**8-2707001939*r**10
            -629815470*r**12)+Q2**17*(-125636995-4577970394*r**2-16361346657*r**4
            -34185543994*r**6-42529848669*r**8-17123461382*r**10+2094751961*r**12
            +444272970*r**14)+Q2**16*(224175635+7809365011*r**2+36324646565*r**4
            +99974128845*r**6+202599264105*r**8+197200450525*r**10+71288223931*r**12
            +4276886555*r**14+474117420*r**16)-2*Q2**15*(112752950+3684349402*r**2
            +25752260173*r**4+79016347492*r**6+233092435851*r**8+345746446566*r**10
            +255229223487*r**12+75180939848*r**14+7333269947*r**16+737962860*r**18)
            +2*Q2**14*(-10760090-1124273264*r**2+15496671303*r**4+19912261043*r**6
            +203418671719*r**8+482954308527*r**10+550352756969*r**12+349433867053*r**14
            +80760081363*r**16+9335927281*r**18+619466400*r**20)+2*Q2**13*(212514850
            +9604495826*r**2+24605545417*r**4+233697297520*r**6+453679804464*r**8
            +446703045772*r**10+345711736162*r**12+27182590944*r**14-123650290370*r**16
            -10162724238*r**18-4289425979*r**20+219536640*r**22)-2*Q2**12*(283961990
            +13908960364*r**2+74031198307*r**4+584754092799*r**6+1848717652088*r**8
            +3124808784564*r**10+4097845080966*r**12+3474660039134*r**14+1583651768778*r**16
            +372430678624*r**18+91134548887*r**20+3816947459*r**22+911678040*r**24)
            +2*Q2**11*(90983295+6206547906*r**2+78914092893*r**4+569615400240*r**6
            +2742809560320*r**8+5288058804880*r**10+8265967023254*r**12+9042684714672*r**14
            +6308667139195*r**16+2528866847610*r**18+642628095325*r**20+119451472096*r**22
            +7383540918*r**24+655985460*r**26)+2*Q2**10*(192044385+8718596961*r**2
            -16333816305*r**4+140384960001*r**6-1470147860228*r**8-2328890180048*r**10
            -4488792514256*r**12-6817216024770*r**14-6896067267011*r**16-4415511376363*r**18
            -1444516748893*r**20-408591500719*r**22-54253428650*r**24-4837798134*r**26
            +175444590*r**28)-2*Q2**9*(267943485+15674082036*r**2+57128926488*r**4
            +968994735438*r**6+1179544359247*r**8+5008115702564*r**10+9749320559730*r**12
            +11132156908862*r**14+8343980582787*r**16+2537364664220*r**18+107065206684*r**20
            +308087299642*r**22-33516927887*r**24+16400244428*r**26-732456294*r**28
            +595534650*r**30)+2*Q2**8*(100462325+8163786479*r**2+70099745838*r**4
            +914309030690*r**6+2420386789419*r**8+7886670029317*r**10+19887473263544*r**12
            +28623891172128*r**14+31288703086975*r**16+20612304044273*r**18+7125861584574*r**20
            +1644161088082*r**22+869124458069*r**24+105782448795*r**26+31317956188*r**28
            +1588709804*r**30+327947340*r**32)+2*Q2**7*(79973330+3476457124*r**2
            -27910345903*r**4-4813851036*r**6-1709005164273*r**8-1396912949054*r**10
            -12999780005819*r**12-18126611546808*r**14-26841404556161*r**16-28047969119666*r**18
            -14857716194733*r**20-5257322417084*r**22-1137151326659*r**24-854473166418*r**26
            -108924395561*r**28-17576159408*r**30-2167266781*r**32+81478110*r**34)
            -2*Q2**6*(110655490+7320664226*r**2+10687192529*r**4+670030621775*r**6
            -926162679525*r**8+7093581933855*r**10-1161506151381*r**12+10171475571551*r**14
            +11609573936535*r**16-3791598682725*r**18-13245179986075*r**20-4311810606651*r**22
            -5517264068439*r**24-1653069836395*r**26-1160801742495*r**28-134070550515*r**30
            -10517626589*r**32-1654549361*r**34+191148990*r**36)+2*Q2**5*(44526470
            +3718402904*r**2+17482408263*r**4+525051721474*r**6-583635850216*r**8
            +8079234870264*r**10+166376158736*r**12+19562170599672*r**14+30849573522556*r**16
            +13418503624712*r**18-2742066012018*r**20-16256271303284*r**22+122861606312*r**24
            -5729655008664*r**26-1757694210536*r**28-1025597078216*r**30-114418714306*r**32
            -7136494272*r**34-542489341*r**36+81767490*r**38)+(-1+r**2)**4*(288635
            +31651299*r**2+111271033*r**4+7614797437*r**6-43628593504*r**8+388530892020*r**10
            -1579155924692*r**12+4161970681836*r**14-1560125734366*r**16-13257018016878*r**18
            +19628329796710*r**20-599093098738*r**22-6696813817396*r**24+1753856929396*r**26
            -934456148532*r**28+31634420780*r**30-44082832869*r**32-3316042973*r**34
            -266794967*r**36-10914211*r**38+469980*r**40)+2*Q2**4*(7344020+201681862*r**2
            -8499180259*r**4-57914087239*r**6-72471232020*r**8-1916232653488*r**10
            +45191035536*r**12-6407528085816*r**14-14149451477816*r**16+8025160669492*r**18
            +2762811336666*r**20+1284095345242*r**22+14491115933584*r**24-403906403376*r**26
            +525766748776*r**28+864923452752*r**30+167790295860*r**32+26316539366*r**34
            +500529681*r**36-318862123*r**38+12909300*r**40)+Q2**3*(-31307375-2375082196*r**2
            +3914474888*r**4-307603445700*r**6+1378713462367*r**8-7305891514164*r**10
            +15939838687208*r**12-26120977252704*r**14+5725243573170*r**16-16545846818376*r**18
            -2635796724808*r**20-12341711143848*r**22+34568176886694*r**24+22996488679160*r**26
            -12226936657224*r**28+10943838471808*r**30-1271315280819*r**32+871946193372*r**34
            +65171801120*r**36+7264364108*r**38+935570539*r**40-55577220*r**42)-Q2*(
            -1+r**2)**2*(3182875+314783476*r**2+572687324*r**4+64673752542*r**6-361227941195*r**8
            +2793557226118*r**10-9682124302768*r**12+21909567108248*r**14-4854905883266*r**16
            -44619376781680*r**18+23883287007016*r**20+54279686955588*r**22-3834252765318*r**24
            -34213158940444*r**26+10059925712720*r**28-5421764065736*r**30+349190098999*r**32
            -296058258004*r**34-22877575332*r**36-2019721970*r**38-111393023*r**40
            +5353830*r**42)+Q2**2*(14455775+1266088589*r**2-412625118*r**4+217995780164*r**6
            -1256783044359*r**8+8161841385043*r**10-25880881053966*r**12+54390652473544*r**14
            -32839166259042*r**16-25623157560118*r**18+14937874699996*r**20+6499117182224*r**22
            +63564386271386*r**24+11387512733742*r**26-68831208209812*r**28+27191083344504*r**30
            -12608200661581*r**32+1566594951993*r**34-748497467614*r**36-58144882836*r**38
            -5619477443*r**40-480698641*r**42+25053570*r**44))+104509440000*logq2**6*(
            -Q2+(-1+r)**2)*r**22*(-18-33*r**2-512*r**6+326*r**8+45*r**10)*(-Q2
            +(1+r)**2)*sqrtq2-8294400*logq2**4*r**14*(60*Q2**14*(279+1105*r**4)-60*Q2**13*(3672
            +3553*r**2+13184*r**4+12005*r**6)+6*Q2**12*(216522+397980*r**2+879960*r**4
            +1217787*r**6+560770*r**8)-4*Q2**11*(1102446+2916746*r**2+5719010*r**4
            +8812611*r**6+7107446*r**8+2178360*r**10)+Q2**10*(9157662+31630681*r**2
            +62692292*r**4+102204667*r**6+105754956*r**8+59741062*r**10+13516920*r**12)
            -10*Q2**9*(1094562+4964351*r**2+10058191*r**4+17452471*r**6+21517777*r**8
            +16715812*r**10+7286906*r**12+1344870*r**14)+5*Q2**8*(848286+7976115*r**2
            +14049744*r**4+23414022*r**6+37373222*r**8+43518791*r**10+30172424*r**12
            +11132460*r**14+2505060*r**16)-2*Q2**7*(-4062528+871560*r**2-21574260*r**4
            -81039648*r**6-85527785*r**8-9022188*r**10+65773250*r**12+55704100*r**14
            +20210067*r**16+9370620*r**18)+Q2**6*(-14591232-27280062*r**2-133532310*r**4
            -457180677*r**6-613653302*r**8-410556677*r**10-43933182*r**12+175267025*r**14
            +126444838*r**16+42740703*r**18+25254180*r**20)-4*Q2**5*(-2316114-6108162*r**2
            -26309109*r**4-108119484*r**6-142044207*r**8-97719918*r**10-8627437*r**12
            +50020851*r**14+51490781*r**16+26325998*r**18+8398326*r**20+3994935*r**22)
            -(-1+r**2)**4*(-124182+38701*r**2-2905026*r**4-5822095*r**6+17877786*r**8
            -12939494*r**10-34948534*r**12-35828334*r**14-2135360*r**16+29175209*r**18
            +10200296*r**20+483853*r**22+639180*r**24)-5*Q2**4*(-47736+2085258*r**2
            +1605498*r**4+25878921*r**6+28210614*r**8+5127676*r**10-21667370*r**12
            -42615694*r**14-25419898*r**16+12335474*r**18+5326264*r**20-2334627*r**22
            +1032420*r**24)+10*Q2**3*(-443556+573828*r**2-5282568*r**4-7874790*r**6
            +3305379*r**8-8687332*r**10-25552238*r**12-8823620*r**14+309336*r**16
            +3445412*r**18+32018534*r**20+14428426*r**22-621111*r**24+1692300*r**26)
            +2*Q2*(-1+r**2)**2*(-490842+405289*r**2-9300155*r**4-18555946*r**6+43857706*r**8
            -21569338*r**10-123343548*r**12-86672018*r**14-37179244*r**16+1269159*r**18
            +74591295*r**20+29403124*r**22+186388*r**24+2246130*r**26)+Q2**2*(3116862
            -5335435*r**2+49360670*r**4+60307542*r**6-189839810*r**8+138555941*r**10
            +391966600*r**12+302326440*r**14+7248446*r**16+5992315*r**18+178447522*r**20
            -223400190*r**22-137130410*r**24+11729387*r**26-12737880*r**28))*sqrtq2
            -5760*logq2**2*r**6*(24*Q2**22*(3349+23191*r**4)-24*Q2**21*(53244+44743*r**2
            +341916*r**4+399227*r**6)+8*Q2**20*(1141149+1938186*r**2+7548212*r**4
            +16204279*r**6+9269913*r**8)-16*Q2**19*(2388885+6200913*r**2+17996211*r**4
            +50023581*r**6+56128111*r**8+21236550*r**10)+Q2**18*(101371470+364376283*r**2
            +901939072*r**4+2925542404*r**6+4649993790*r**8+3571477829*r**10+1015255920*r**12)
            -2*Q2**17*(82990902+407489793*r**2+760476111*r**4+3079183744*r**6+6264453850*r**8
            +7013600283*r**10+4421219185*r**12+1015456548*r**14)+Q2**16*(124190814
            +1005250443*r**2-605927720*r**4+2360522459*r**6+10298899070*r**8+16041244481*r**10
            +19251003124*r**12+13358293273*r**14+2601432552*r**16)-8*Q2**15*(-13923204
            +17067252*r**2-1326430584*r**4-3838939006*r**6-6767174377*r**8-9484461898*r**10
            -7323319706*r**12-1336413278*r**14+1173902791*r**16+201367542*r**18)
            -4*Q2**14*(103924230+461839629*r**2+7069874398*r**4+27366106409*r**6
            +59883223146*r**8+98763664597*r**10+109101848210*r**12+73060945527*r**14
            +23648196448*r**16+1543875638*r**18+228768000*r**20)+8*Q2**13*(57789630
            +419259117*r**2+4658560473*r**4+23718707868*r**6+56853504860*r**8+104349367974*r**10
            +135528667572*r**12+121877950124*r**14+71681709642*r**16+22550628165*r**18
            +2862642671*r**20+387843480*r**22)-4*Q2**12*(23683686+620296833*r**2
            +3611063482*r**4+40919767270*r**6+92193166686*r**8+179874903864*r**10
            +265111420114*r**12+294461639190*r**14+254899956900*r**16+147431354047*r**18
            +43699855812*r**20+6461175500*r**22+755762904*r**24)+8*Q2**11*(-47911032
            -49186644*r**2-4425685472*r**4-1065658986*r**6-27485965883*r**8-74882465534*r**10
            -119893306538*r**12-125655979244*r**14-54665507600*r**16+23525424088*r**18
            +31950565618*r**20+8563522870*r**22+1805629995*r**24+127080954*r**26)
            +2*Q2**10*(253996626+1312179765*r**2+33707301004*r**4+95238282770*r**6
            +427663211674*r**8+1163066078355*r**10+2054655272808*r**12+2692243477820*r**14
            +2390087581998*r**16+1296820261587*r**18+363936348356*r**20+45528311954*r**22
            +20336551846*r**24-914446299*r**26+415924392*r**28)-4*Q2**9*(53227170
            +606841911*r**2+11226466297*r**4+53749728060*r**6+192995001626*r**8+638839813211*r**10
            +1177493558137*r**12+1736360711760*r**14+1959293099406*r**16+1535468746357*r**18
            +760731867411*r**20+240863926404*r**22+51248323574*r**24+21509118457*r**26
            +1008721467*r**28+317060400*r**30)+2*Q2**8*(-68409870+370756077*r**2
            -4927320492*r**4+52277135275*r**6-23716493510*r**8+484718620897*r**10
            +603587147548*r**12+798961328119*r**14+1644965959510*r**16+2446918974415*r**18
            +2142079382380*r**20+1047901209577*r**22+485282217070*r**24+118153207363*r**26
            +47382852420*r**28+3008049301*r**30+389783280*r**32)-8*Q2**7*(-29325612
            -62877084*r**2-5258584192*r**4+1025350222*r**6-92975388251*r**8-58991019510*r**10
            -320840189982*r**12-679437130574*r**14-608420561685*r**16-172017573438*r**18
            +277687239076*r**20+360796497330*r**22+156326837523*r**24+139280009422*r**26
            +36450984058*r**28+11461534670*r**30+843615305*r**32+33073602*r**34)
            -(-1+r**2)**6*(-111342-741639*r**2-60673944*r**4+127536874*r**6-3205168148*r**8
            +10217397442*r**10-29897017976*r**12-34740746198*r**14+193737188248*r**16
            -72930182964*r**18-319823878848*r**20+102654417774*r**22+101050018628*r**24
            -12171250498*r**26+11478112712*r**28+912649598*r**30+379158566*r**32
            +18007739*r**34+563976*r**36)+4*Q2**6*(-30822564-164742393*r**2-7952057988*r**4
            -4434808571*r**6-172196926538*r**8-139610466201*r**10-711416820346*r**12
            -1548839731179*r**14-1322256660234*r**16-640612627195*r**18+78477760518*r**20
            +575142317655*r**22+625539626354*r**24+119576944437*r**26+207757054018*r**28
            +61372155407*r**30+14701608134*r**32+1218148568*r**34+665718*r**36)+2*Q2*(
            -1+r**2)**4*(-716598-3444273*r**2-329128663*r**4+786724362*r**6-15396679070*r**8
            +43317800554*r**10-119537325386*r**12-133596075410*r**14+510084437102*r**16
            +63178550776*r**18-761468840424*r**20-725967628694*r**22+450004194774*r**24
            +371967238550*r**26-49120397302*r**28+47231589818*r**30+3477277328*r**32
            +1752942649*r**34+88115711*r**36+3044196*r**38)+8*Q2**5*(288354+39848442*r**2
            +719080673*r**4+2786827981*r**6+19234991160*r**8+37162801596*r**10+89812810270*r**12
            +266974341088*r**14-9628381328*r**16-167954937416*r**18-184968019052*r**20
            -85038377078*r**22+46680345184*r**24-96146507132*r**26+6044083818*r**28
            -1240741208*r**30-12002660394*r**32-532023730*r**34-136376381*r**36+12765153*r**38)
            -Q2**2*(-1+r**2)**2*(-7982526-21753423*r**2-3041778600*r**4+8989145879*r**6
            -127546337928*r**8+351340078348*r**10-919868411216*r**12-525259552124*r**14
            +2215611585292*r**16-3021863722*r**18-2026920891872*r**20-3055562194614*r**22
            -2964636195272*r**24+2293142877804*r**26+2334014554448*r**28-440159404156*r**30
            +323173862978*r**32+17236702721*r**34+13564741000*r**36+717803927*r**38
            +28453056*r**40)-4*Q2**4*(-9049440+16655433*r**2-2001397914*r**4+7755443082*r**6
            -61540954616*r**8+144871110442*r**10-311546954302*r**12-76582807342*r**14
            -203354864778*r**16-313968015972*r**18-273272118754*r**20-209950647090*r**22
            -56476766874*r**24+944867546150*r**26+527696521862*r**28-107341383098*r**30
            +148760610034*r**32-150875445*r**34+7327833396*r**36+344338576*r**38
            +29056650*r**40)+8*Q2**3*(-3002190-597906*r**2-923521234*r**4+3595029044*r**6
            -35720498475*r**8+106536716170*r**10-263249552734*r**12+56937186560*r**14
            +275846417250*r**16-181239122300*r**18-186552654138*r**20-113016227784*r**22
            -73679287688*r**24-624761140692*r**26+190539776150*r**28+496808887936*r**30
            -147119686436*r**32+73971576462*r**34+385633748*r**36+3413198100*r**38
            +183818947*r**40+9291210*r**42))*sqrtq2-16*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(3778*Q2**24*r**2+4*Q2**23*r**2*(11287+8598*r**2)-Q2**22*(123588
            +413273*r**2+8224490*r**4+1082761*r**6)+2*Q2**21*(777780-1722671*r**2
            +35004111*r**4+61875367*r**6+4542089*r**8)-Q2**20*(8503812-50984735*r**2
            +37764972*r**4+998164362*r**6+822398880*r**8+41372937*r**10)+2*Q2**19*(12728700
            -132562980*r**2-901178985*r**4+661081624*r**6+2942873210*r**8+1528445976*r**10
            +59110819*r**12)-2*Q2**18*(20316375-390311495*r**2-5091659678*r**4-6752046868*r**6
            +2275474247*r**8+8898882953*r**10+3314281240*r**12+109225494*r**14)+2*Q2**17*(7051536
            -708323153*r**2-14007579757*r**4-37493231467*r**6-41038508505*r**8-10868617423*r**10
            +12663463569*r**12+3504373331*r**14+122012037*r**16)+2*Q2**16*(38494035
            +732229265*r**2+21951008029*r**4+94715217408*r**6+188835172483*r**8+217395120444*r**10
            +96215255535*r**12+2577658284*r**14+1338261158*r**16-53118081*r**18)
            -4*Q2**15*(39250008+71665742*r**2+7794217857*r**4+70677943062*r**6+202496491933*r**8
            +383041239508*r**10+367031014753*r**12+145277957822*r**14+21470798447*r**16
            +4922384882*r**18+25153778*r**20)+2*Q2**14*(45441000-816525219*r**2-12436044120*r**4
            +108385242663*r**6+412173831462*r**8+1246305572796*r**10+1832857463502*r**12
            +1377181637232*r**14+429613472658*r**16+75122051295*r**18+12785084122*r**20
            +63447009*r**22)+4*Q2**13*(28748700+686758973*r**2+24034153640*r**4+30975280223*r**6
            +127757706961*r**8-118250027566*r**10-621436689468*r**12-800142266474*r**14
            -548090978314*r**16-100580856087*r**18-27634371188*r**20-1655382637*r**22
            +25532453*r**24)-2*Q2**12*(121122144+987001847*r**2+59579510354*r**4
            +328581634676*r**6+1610139222480*r**8+3458459706537*r**10+4168823558020*r**12
            +3995339392664*r**14+2196434429208*r**16+652009755025*r**18+354610677802*r**20
            +4424577508*r**22+10337037048*r**24+155770303*r**26)+4*Q2**11*(31386420
            -24559472*r**2+12474316946*r**4+231307151582*r**6+1136128711943*r**8
            +3708963216136*r**10+5775236989637*r**12+7460750155044*r**14+6365849224198*r**16
            +3238493271344*r**18+1124563674216*r**20+332870316638*r**22+23791326351*r**24
            +6335493112*r**26+55828017*r**28)+4*Q2**10*(25266267+443632186*r**2+18236167659*r**4
            -112307566516*r**6-271989447142*r**8-3097084550801*r**10-4537396749964*r**12
            -7678862302469*r**14-8839903586509*r**16-6300058585284*r**18-2535476092761*r**20
            -950596601722*r**22-186064896856*r**24-26447349461*r**26-1061240534*r**28
            +12847427*r**30)-4*Q2**9*(45685800+466338089*r**2+34804641940*r**4+116404688299*r**6
            +1191854347847*r**8+118709868125*r**10+3502410977810*r**12+4025263342807*r**14
            +2010102954021*r**16-509914552573*r**18-1200084113112*r**20+104176122297*r**22
            -277066973463*r**24+58483784119*r**26-20206127790*r**28+3677339461*r**30
            +47407203*r**32)+2*Q2**8*(39726450+344718077*r**2+42712113172*r**4+438538634254*r**6
            +2906321078682*r**8+4824455448068*r**10+17806946600368*r**12+33675596208210*r**14
            +39267779761754*r**16+32171722170394*r**18+13825339006356*r**20+3057582704978*r**22
            +2435068568422*r**24+62427172812*r**26+255826761064*r**28-17605497714*r**30
            +6522313972*r**32+50908761*r**34)+4*Q2**7*(10277928+115128287*r**2+5227842067*r**4
            -117369026250*r**6-184849413995*r**8-2474644963156*r**10-2788862795793*r**12
            -14950140579806*r**14-17491810825927*r**16-22452425330610*r**18-15145909592039*r**20
            -5837044372294*r**22-838765131585*r**24-976243826204*r**26-146870744475*r**28
            -43250233938*r**30-7133338485*r**32-279457021*r**34+7701696*r**36)+Q2**6*(
            -64416060-736571321*r**2-69458013030*r**4-96882874365*r**6-3561727951484*r**8
            +8751658749288*r**10-35558045124644*r**12+28721849799560*r**14-30289660300020*r**16
            +2702536567246*r**18+39453719823264*r**20+16658196219366*r**22+17169910415500*r**24
            +3631541898320*r**26+4697755838980*r**28+1583850727888*r**30-93534793696*r**32
            +63661889075*r**34-4797845530*r**36-64188737*r**38)+2*Q2**5*(13031604
            +187776613*r**2+21130475625*r**4+128301705435*r**6+1419372501261*r**8
            -3341617091804*r**10+24943724123140*r**12-19153623069060*r**14+48964439232260*r**16
            +27602674452886*r**18+10591370307470*r**20-25017965984374*r**22+3347659515310*r**24
            -10057584155820*r**26-2060258445260*r**28-2224904735604*r**30-866671094304*r**32
            +38698070925*r**34-20649046575*r**36+1505212563*r**38+13409709*r**40)
            +2*(-1+r**2)**4*(34659+722705*r**2+108983873*r**4+445530300*r**6+9028694702*r**8
            -81778006377*r**10+719397325476*r**12-3534479482064*r**14+11133706665250*r**16
            -17252093878806*r**18+5099830356782*r**20+15755349941032*r**22-14782890559416*r**24
            +5272665813550*r**26-1816517236044*r**28+165812414256*r**30-48893902237*r**32
            -12250845643*r**34-246027975*r**36-143926852*r**38+3984930*r**40+37899*r**42)
            +Q2**4*(3741300-18170649*r**2-1319927280*r**4-131272748878*r**6-162212251456*r**8
            +318254849331*r**10-16906210214352*r**12+31896247205464*r**14-73695371695432*r**16
            +5169426760542*r**18+26395731106736*r**20-34671131354196*r**22+77501996828912*r**24
            -10810216527602*r**26+6456922405584*r**28+2428167270360*r**30+957929963444*r**32
            +500092838779*r**34+10929006912*r**36+557737330*r**38-133022352*r**40
            +4437503*r**42)-2*Q2*(-1+r**2)**2*(396000+6633677*r**2+1014664621*r**4
            +2618079884*r**6+80642612988*r**8-660176777173*r**10+5000723732403*r**12
            -20258873122584*r**14+51013630879448*r**16-51618054103094*r**18-20941822100006*r**20
            +54846589719744*r**22+27996019632016*r**24-54818136264098*r**26+23148297139774*r**28
            -9487436899944*r**30+1077889587720*r**32-275563172039*r**34-89814530359*r**36
            +192673332*r**38-1338610252*r**40+42513831*r**42+434111*r**44)-2*Q2**3*(4148100
            +40950092*r**2+6211485451*r**4-11378765932*r**6+459907618232*r**8-2470254740392*r**10
            +10864373155817*r**12-22255082860112*r**14+25730924729616*r**16+829256522104*r**18
            +6654082618966*r**20+21138875931672*r**22-47437051581960*r**24-4591264598736*r**26
            +12701496713146*r**28-12155515642256*r**30+2203719740012*r**32-672497603748*r**34
            -255656757073*r**36+18162185268*r**38-7778581168*r**40+335315032*r**42
            +4577869*r**44)+2*Q2**2*(1860921+23456625*r**2+3775736972*r**4+1392908336*r**6
            +289222186475*r**8-2212685382853*r**10+13962686641812*r**12-48178138257620*r**14
            +102955593845170*r**16-97569848198270*r**18+21973992031888*r**20-32766019650616*r**22
            +84976954684078*r**24+22832780411694*r**26-83961339510560*r**28+44970935625024*r**30
            -19405243397179*r**32+2888589426941*r**34-477006048892*r**36-258265158520*r**38
            +10359667895*r**40-5038909017*r**42+180225004*r**44+2044692*r**46))*sqrtq2)*math.log(mu0))/(235146240000*logq2**5*(
            -Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +5443200000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+11340000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-470292480000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-48988800000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-340200000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -157500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*sqrtq2)
            +FLAGcD*flagPERP*((-2592000*logq2**4*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(340
            -1741*r**2+105*Q2**7*r**2+5955*r**4-5175*r**6+3561*r**8+12591*r**10
            -4573*r**12+841*r**14+801*r**16-5*Q2**6*(16+111*r**2+159*r**4)+5*Q2**5*(96
            +279*r**2+724*r**4+471*r**6)-Q2**4*(1200+2331*r**2+6259*r**4+9055*r**6
            +3399*r**8)+Q2**3*(1075+2834*r**2+6055*r**4+10016*r**6+11036*r**8+1956*r**10)
            +Q2**2*(270-2591*r**2-1978*r**4-3537*r**6-9223*r**8-5456*r**10+1011*r**12)
            -Q2*(885-2989*r**2+1628*r**4+3750*r**6-2139*r**8-6015*r**10+746*r**12
            +2034*r**14))-720*logq2**2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -4656+9857*r**2+9795*Q2**13*r**2-360589*r**4+1247426*r**6+7361182*r**8
            -110253713*r**10+191149981*r**12+55415668*r**14-108222692*r**16+14298391*r**18
            +43828469*r**20-8037238*r**22+4174646*r**24+77241*r**26+36027*r**28
            -Q2**12*(176+99615*r**2+100143*r**4)+Q2**11*(-5648+421432*r**2+902836*r**4
            +410136*r**6)-2*Q2**10*(-16752+433534*r**2+1590537*r**4+1611252*r**6
            +398709*r**8)+5*Q2**9*(-11871+142514*r**2+1005296*r**4+1552692*r**6
            +1056027*r**8+99342*r**10)+5*Q2**8*(-24+71123*r**2-372041*r**4-2468*r**6
            -278440*r**8-442443*r**10+168525*r**12)-2*Q2**7*(-60246+537940*r**2
            +2273487*r**4+14694780*r**6+25759600*r**8+12425514*r**10+2765355*r**12
            +886122*r**14)+2*Q2**6*(-59052+203748*r**2+2708799*r**4+21785399*r**6
            +64454790*r**8+64322268*r**10+18579313*r**12+4286709*r**14+393714*r**16)
            +Q2**5*(-30498+538711*r**2-1098862*r**4-8740592*r**6-94734134*r**8-181196498*r**10
            -110016034*r**12+744928*r**14-2852712*r**16+893691*r**18)-5*Q2**4*(-21816
            +101869*r**2+36771*r**4+5194326*r**6+7971754*r**8-4244340*r**10-9474900*r**12
            +2307154*r**14+8546022*r**16+621087*r**18+228057*r**20)+10*Q2**3*(-4378
            +1164*r**2-74427*r**4+1524972*r**6+8392172*r**8+11921018*r**10+15535886*r**12
            +7500786*r**14+7836870*r**16+2814850*r**18+305589*r**20+24138*r**22)
            +2*Q2**2*(-11108+77610*r**2-109354*r**4+2494245*r**6-11916315*r**8-37141854*r**10
            -61205670*r**12-93691512*r**14-2752980*r**16-28238020*r**18+4228152*r**20
            -337925*r**22+141531*r**24)-3*Q2*(-7159+23476*r**2-315922*r**4+1964468*r**6
            +4565555*r**8-22863892*r**10+43126788*r**12-35799496*r**14-27648481*r**16
            +25613020*r**18-8809874*r**20+4904436*r**22+63493*r**24+63588*r**26))
            -(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**17*r**2+6*Q2**16*(-503
            +1857*r**2+348*r**4)-Q2**15*(-26898+102167*r**2+795672*r**4+48371*r**6)
            +Q2**14*(-98640-56049*r**2+7994969*r**4+6700457*r**6+211055*r**8)-Q2**13*(
            -177975-1898941*r**2+27560140*r**4+63311870*r**6+22428463*r**8+399935*r**10)
            +2*Q2**12*(-57195-2309884*r**2+17136106*r**4+101613869*r**6+95944414*r**8
            +14856441*r**10+111733*r**12)+Q2**11*(-137556+373945*r**2+19063926*r**4
            -223999621*r**6-431226616*r**8-214206393*r**10+13775206*r**12+451941*r**14)
            -Q2**10*(-294096-13637297*r**2+90239625*r**4+147158379*r**6+237617085*r**8
            +126892013*r**10+149456939*r**12+90174137*r**14+864127*r**16)+Q2**9*(
            -82995-18238327*r**2+48326482*r**4+551909576*r**6+1906001960*r**8+3380058850*r**10
            +1563679558*r**12+632089712*r**14+84181011*r**16+257565*r**18)+2*Q2**8*(
            -126225-1009991*r**2+46086545*r**4-193715485*r**6-853227627*r**8-3255304445*r**10
            -3266464121*r**12-698363155*r**14-250698540*r**16+20066388*r**18+349360*r**20)
            -Q2**7*(-270930-22679187*r**2+132341324*r**4+45799181*r**6+1014675076*r**8
            -843528166*r**10-3741360624*r**12-2052704686*r**14+1341959486*r**16+200656521*r**18
            +125143764*r**20+760881*r**22)+Q2**6*(-14784-14394991*r**2+11307799*r**4
            +195247027*r**6+1774319317*r**8+7423701738*r**10+17856696358*r**12+11717789766*r**14
            +7166277802*r**16+2527824517*r**18+562002755*r**20+57687687*r**22+36929*r**24)
            +Q2**5*(-139311-6909393*r**2+94005896*r**4-225483814*r**6+422091965*r**8
            -4834215971*r**10-21741140296*r**12-43522669716*r**14-12347107893*r**16
            -8634004135*r**18-44297888*r**20-276307526*r**22+46636615*r**24+403867*r**26)
            -2*Q2**4*(-42255-5827438*r**2+34822088*r**4-116753271*r**6+605172420*r**8
            +534178775*r**10+2627004171*r**12-11002393566*r**14-17819750663*r**16
            +6074554120*r**18-930477570*r**20+950406917*r**22+35981378*r**24+28343359*r**26
            +123935*r**28)+Q2**3*(3600-2982709*r**2-596050*r**4-46349435*r**6-106353308*r**8
            +1201901155*r**10+13462806858*r**12+14229490325*r**14+3687037960*r**16
            -6454737479*r**18+18543504930*r**20+3071947751*r**22+885610500*r**24
            +125097625*r**26+10537062*r**28-6785*r**30)+Q2**2*(-23040-2142577*r**2
            +24290137*r**4-132014257*r**6+694056873*r**8-696848773*r**10-872984739*r**12
            -4977016789*r**14-35888913091*r**16+7774277309*r**18-20252527269*r**20
            +2796606109*r**22-2790985173*r**24+437225273*r**26-48682257*r**28+11649257*r**30
            +65007*r**32)+Q2*(9483+1473529*r**2-12345038*r**4+104663644*r**6-278087326*r**8
            +723773040*r**10-4072964318*r**12+4203800668*r**14-17674051888*r**16
            +59843857002*r**18-65906419354*r**20+39123878324*r**22-11142159922*r**24
            +974218744*r**26-446730426*r**28+7287956*r**30-6977035*r**32-27083*r**34)
            +2*(-654-131806*r**2+1042713*r**4-11829543*r**6+9308985*r**8-75573153*r**10
            +468182403*r**12-2736829079*r**14-10699576611*r**16+52263253755*r**18
            -64276935707*r**20+35970149187*r**22-9421707981*r**24+1788128901*r**26
            -61350615*r**28+49334139*r**30-137659*r**32+590847*r**34+1878*r**36))
            +544320000*logq2**5*r**18*(-3-4*r**2+20*r**4-28*r**6+3*r**8)*sqrtq2-43200*logq2**3*r**10*(2265*Q2**12*r**2
            -10*Q2**11*(-8+2487*r**2+2463*r**4)+2*Q2**10*(60+57651*r**2+114071*r**4
            +57771*r**6)-10*Q2**9*(168+29587*r**2+86688*r**4+87891*r**6+29466*r**8)
            +10*Q2**8*(345+43559*r**2+170411*r**4+257585*r**6+177420*r**8+40572*r**10)
            -5*Q2**7*(639+62946*r**2+327965*r**4+670680*r**6+694545*r**8+365346*r**10
            +36639*r**12)-5*Q2**6*(-945+4277*r**2-25333*r**4-189343*r**6-197327*r**8
            -215481*r**10-98931*r**12+60795*r**14)+Q2**5*(-9975+232676*r**2+1416716*r**4
            +2721336*r**6+4815470*r**8+5443880*r**10+2655296*r**12+873516*r**14
            +546381*r**16)-5*Q2**4*(-1881+33246*r**2+266324*r**4+737376*r**6+1289802*r**8
            +1843588*r**10+1626060*r**12+612432*r**14+201183*r**16+58158*r**18)
            +5*Q2**3*(-45+2092*r**2+31513*r**4+543628*r**6+348974*r**8+863344*r**10
            +1386718*r**12+884156*r**14+44967*r**16+106140*r**18-15519*r**20)+(
            -1+r**2)**2*(-795+6057*r**2+62201*r**4-540963*r**6+687258*r**8+728234*r**10
            +339426*r**12+49434*r**14-147727*r**16+329277*r**18-14379*r**20+13977*r**22)
            +5*Q2**2*(-1141+10783*r**2+93415*r**4-524683*r**6+442474*r**8+314470*r**10
            -47806*r**12-472190*r**14-254261*r**16+360507*r**18-57129*r**20+34761*r**22)
            -5*Q2*(-759+6954*r**2+57322*r**4-424866*r**6+607083*r**8+102120*r**10
            +166800*r**12+757680*r**14-67773*r**16-263202*r**18+284310*r**20-32638*r**22
            +16569*r**24))*sqrtq2-6*logq2*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -11815-17342*r**2+20598*Q2**16*r**2-1539738*r**4-1828220*r**6-93296530*r**8
            +531809700*r**10-1202798314*r**12-12016064876*r**14+34941377640*r**16
            -16859928440*r**18-10427104030*r**20+13402061004*r**22-3848051134*r**24
            +1002915580*r**26-360030*r**28+15413020*r**30+576527*r**32+46998*r**34
            -12*Q2**15*(-1480+23619*r**2+19179*r**4)+4*Q2**14*(-32820+315810*r**2
            +775091*r**4+250170*r**6)-4*Q2**13*(-89680+561415*r**2+3441914*r**4
            +3172239*r**6+501840*r**8)+3*Q2**12*(-102835+108210*r**2+8242288*r**4
            +14188924*r**6+7455783*r**8+347210*r**10)+Q2**11*(-501830+4084716*r**2
            -5212386*r**4-3865176*r**6-7029506*r**8-4035196*r**10+3308706*r**12)
            -2*Q2**10*(-682770+1489843*r**2+22024696*r**4+119695125*r**6+221267970*r**8
            +106897065*r**10+24392896*r**12+3266703*r**14)+2*Q2**9*(-367345-3071840*r**2
            +26710386*r**4+227220060*r**6+714133400*r**8+705569180*r**10+204029050*r**12
            +35732936*r**14+1173645*r**16)+Q2**8*(-1049565+10126620*r**2-78738*r**4
            -171444948*r**6-1341551320*r**8-2311353340*r**10-1458873670*r**12-92048748*r**14
            -9710163*r**16+5670720*r**18)-4*Q2**7*(-406065+252615*r**2+7631982*r**4
            +81058936*r**6+189015752*r**8+480461830*r**10+282469470*r**12+143391072*r**14
            +131845761*r**16+16615587*r**18+1761540*r**20)+4*Q2**6*(-86460-2028669*r**2
            +1555743*r**4+74640153*r**6+482523418*r**8+2086011688*r**10+3349274064*r**12
            +1600218868*r**14+600107578*r**16+136941693*r**18+14561673*r**20+206811*r**22)
            +4*Q2**5*(-201465+1468989*r**2+1303132*r**4+13924205*r**6-125757445*r**8
            -1264814850*r**10-4711887796*r**12-4758378986*r**14-842818895*r**16-375154195*r**18
            +18838800*r**20+882517*r**22+946389*r**24)-Q2**4*(-642845-567190*r**2
            -8788364*r**4+119119700*r**6+481332275*r**8+3568163190*r**10-1523155600*r**12
            -13344747272*r**14-6577893895*r**16+5528768150*r**18+405581180*r**20
            +405698740*r**22+29345361*r**24+2648970*r**26)+2*Q2**3*(-18015-1180230*r**2
            -3200553*r**4-5407748*r**6-36754535*r**8+2081584130*r**10+4548956715*r**12
            +5193822776*r**14+943425851*r**16+2957420990*r**18+3054240885*r**20+424070540*r**22
            +85143627*r**24+6359622*r**26+15945*r**28)+2*Q2**2*(-80690+490665*r**2
            -3006468*r**4+17883911*r**6+95819042*r**8-120874895*r**10-1518601440*r**12
            -4189196169*r**14-9293444622*r**16+968976371*r**18-4244198580*r**20+292174125*r**22
            -168527138*r**24+35301811*r**26+1076312*r**28+351765*r**30)-2*Q2*(-38835
            +44444*r**2-3174082*r**4+2322168*r**6-63994442*r**8+565501168*r**10
            +36509186*r**12-748140236*r**14+1938362164*r**16-8068634516*r**18+7204485794*r**20
            -4164681904*r**22+1469846818*r**24-20195832*r**26+35804958*r**28+1423748*r**30
            +159399*r**32))*sqrtq2)/(907200000*logq2**4*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +12600000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+8750*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5-2177280000*logq2**5*r**20*sqrtq2-151200000*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2-525000*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*sqrtq2)+((5184000*logq2**4*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(340-1741*r**2+105*Q2**7*r**2+5955*r**4-5175*r**6+3561*r**8
            +12591*r**10-4573*r**12+841*r**14+801*r**16-5*Q2**6*(16+111*r**2+159*r**4)
            +5*Q2**5*(96+279*r**2+724*r**4+471*r**6)-Q2**4*(1200+2331*r**2+6259*r**4
            +9055*r**6+3399*r**8)+Q2**3*(1075+2834*r**2+6055*r**4+10016*r**6+11036*r**8
            +1956*r**10)+Q2**2*(270-2591*r**2-1978*r**4-3537*r**6-9223*r**8-5456*r**10
            +1011*r**12)-Q2*(885-2989*r**2+1628*r**4+3750*r**6-2139*r**8-6015*r**10
            +746*r**12+2034*r**14))+1440*logq2**2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-4656+9857*r**2+9795*Q2**13*r**2-360589*r**4+1247426*r**6
            +7361182*r**8-110253713*r**10+191149981*r**12+55415668*r**14-108222692*r**16
            +14298391*r**18+43828469*r**20-8037238*r**22+4174646*r**24+77241*r**26
            +36027*r**28-Q2**12*(176+99615*r**2+100143*r**4)+Q2**11*(-5648+421432*r**2
            +902836*r**4+410136*r**6)-2*Q2**10*(-16752+433534*r**2+1590537*r**4
            +1611252*r**6+398709*r**8)+5*Q2**9*(-11871+142514*r**2+1005296*r**4
            +1552692*r**6+1056027*r**8+99342*r**10)+5*Q2**8*(-24+71123*r**2-372041*r**4
            -2468*r**6-278440*r**8-442443*r**10+168525*r**12)-2*Q2**7*(-60246+537940*r**2
            +2273487*r**4+14694780*r**6+25759600*r**8+12425514*r**10+2765355*r**12
            +886122*r**14)+2*Q2**6*(-59052+203748*r**2+2708799*r**4+21785399*r**6
            +64454790*r**8+64322268*r**10+18579313*r**12+4286709*r**14+393714*r**16)
            +Q2**5*(-30498+538711*r**2-1098862*r**4-8740592*r**6-94734134*r**8-181196498*r**10
            -110016034*r**12+744928*r**14-2852712*r**16+893691*r**18)-5*Q2**4*(-21816
            +101869*r**2+36771*r**4+5194326*r**6+7971754*r**8-4244340*r**10-9474900*r**12
            +2307154*r**14+8546022*r**16+621087*r**18+228057*r**20)+10*Q2**3*(-4378
            +1164*r**2-74427*r**4+1524972*r**6+8392172*r**8+11921018*r**10+15535886*r**12
            +7500786*r**14+7836870*r**16+2814850*r**18+305589*r**20+24138*r**22)
            +2*Q2**2*(-11108+77610*r**2-109354*r**4+2494245*r**6-11916315*r**8-37141854*r**10
            -61205670*r**12-93691512*r**14-2752980*r**16-28238020*r**18+4228152*r**20
            -337925*r**22+141531*r**24)-3*Q2*(-7159+23476*r**2-315922*r**4+1964468*r**6
            +4565555*r**8-22863892*r**10+43126788*r**12-35799496*r**14-27648481*r**16
            +25613020*r**18-8809874*r**20+4904436*r**22+63493*r**24+63588*r**26))
            +2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**17*r**2+6*Q2**16*(-503
            +1857*r**2+348*r**4)-Q2**15*(-26898+102167*r**2+795672*r**4+48371*r**6)
            +Q2**14*(-98640-56049*r**2+7994969*r**4+6700457*r**6+211055*r**8)-Q2**13*(
            -177975-1898941*r**2+27560140*r**4+63311870*r**6+22428463*r**8+399935*r**10)
            +2*Q2**12*(-57195-2309884*r**2+17136106*r**4+101613869*r**6+95944414*r**8
            +14856441*r**10+111733*r**12)+Q2**11*(-137556+373945*r**2+19063926*r**4
            -223999621*r**6-431226616*r**8-214206393*r**10+13775206*r**12+451941*r**14)
            -Q2**10*(-294096-13637297*r**2+90239625*r**4+147158379*r**6+237617085*r**8
            +126892013*r**10+149456939*r**12+90174137*r**14+864127*r**16)+Q2**9*(
            -82995-18238327*r**2+48326482*r**4+551909576*r**6+1906001960*r**8+3380058850*r**10
            +1563679558*r**12+632089712*r**14+84181011*r**16+257565*r**18)+2*Q2**8*(
            -126225-1009991*r**2+46086545*r**4-193715485*r**6-853227627*r**8-3255304445*r**10
            -3266464121*r**12-698363155*r**14-250698540*r**16+20066388*r**18+349360*r**20)
            -Q2**7*(-270930-22679187*r**2+132341324*r**4+45799181*r**6+1014675076*r**8
            -843528166*r**10-3741360624*r**12-2052704686*r**14+1341959486*r**16+200656521*r**18
            +125143764*r**20+760881*r**22)+Q2**6*(-14784-14394991*r**2+11307799*r**4
            +195247027*r**6+1774319317*r**8+7423701738*r**10+17856696358*r**12+11717789766*r**14
            +7166277802*r**16+2527824517*r**18+562002755*r**20+57687687*r**22+36929*r**24)
            +Q2**5*(-139311-6909393*r**2+94005896*r**4-225483814*r**6+422091965*r**8
            -4834215971*r**10-21741140296*r**12-43522669716*r**14-12347107893*r**16
            -8634004135*r**18-44297888*r**20-276307526*r**22+46636615*r**24+403867*r**26)
            -2*Q2**4*(-42255-5827438*r**2+34822088*r**4-116753271*r**6+605172420*r**8
            +534178775*r**10+2627004171*r**12-11002393566*r**14-17819750663*r**16
            +6074554120*r**18-930477570*r**20+950406917*r**22+35981378*r**24+28343359*r**26
            +123935*r**28)+Q2**3*(3600-2982709*r**2-596050*r**4-46349435*r**6-106353308*r**8
            +1201901155*r**10+13462806858*r**12+14229490325*r**14+3687037960*r**16
            -6454737479*r**18+18543504930*r**20+3071947751*r**22+885610500*r**24
            +125097625*r**26+10537062*r**28-6785*r**30)+Q2**2*(-23040-2142577*r**2
            +24290137*r**4-132014257*r**6+694056873*r**8-696848773*r**10-872984739*r**12
            -4977016789*r**14-35888913091*r**16+7774277309*r**18-20252527269*r**20
            +2796606109*r**22-2790985173*r**24+437225273*r**26-48682257*r**28+11649257*r**30
            +65007*r**32)+Q2*(9483+1473529*r**2-12345038*r**4+104663644*r**6-278087326*r**8
            +723773040*r**10-4072964318*r**12+4203800668*r**14-17674051888*r**16
            +59843857002*r**18-65906419354*r**20+39123878324*r**22-11142159922*r**24
            +974218744*r**26-446730426*r**28+7287956*r**30-6977035*r**32-27083*r**34)
            +2*(-654-131806*r**2+1042713*r**4-11829543*r**6+9308985*r**8-75573153*r**10
            +468182403*r**12-2736829079*r**14-10699576611*r**16+52263253755*r**18
            -64276935707*r**20+35970149187*r**22-9421707981*r**24+1788128901*r**26
            -61350615*r**28+49334139*r**30-137659*r**32+590847*r**34+1878*r**36))
            -1088640000*logq2**5*r**18*(-3-4*r**2+20*r**4-28*r**6+3*r**8)*sqrtq2
            +86400*logq2**3*r**10*(2265*Q2**12*r**2-10*Q2**11*(-8+2487*r**2+2463*r**4)
            +2*Q2**10*(60+57651*r**2+114071*r**4+57771*r**6)-10*Q2**9*(168+29587*r**2
            +86688*r**4+87891*r**6+29466*r**8)+10*Q2**8*(345+43559*r**2+170411*r**4
            +257585*r**6+177420*r**8+40572*r**10)-5*Q2**7*(639+62946*r**2+327965*r**4
            +670680*r**6+694545*r**8+365346*r**10+36639*r**12)-5*Q2**6*(-945+4277*r**2
            -25333*r**4-189343*r**6-197327*r**8-215481*r**10-98931*r**12+60795*r**14)
            +Q2**5*(-9975+232676*r**2+1416716*r**4+2721336*r**6+4815470*r**8+5443880*r**10
            +2655296*r**12+873516*r**14+546381*r**16)-5*Q2**4*(-1881+33246*r**2
            +266324*r**4+737376*r**6+1289802*r**8+1843588*r**10+1626060*r**12+612432*r**14
            +201183*r**16+58158*r**18)+5*Q2**3*(-45+2092*r**2+31513*r**4+543628*r**6
            +348974*r**8+863344*r**10+1386718*r**12+884156*r**14+44967*r**16+106140*r**18
            -15519*r**20)+(-1+r**2)**2*(-795+6057*r**2+62201*r**4-540963*r**6+687258*r**8
            +728234*r**10+339426*r**12+49434*r**14-147727*r**16+329277*r**18-14379*r**20
            +13977*r**22)+5*Q2**2*(-1141+10783*r**2+93415*r**4-524683*r**6+442474*r**8
            +314470*r**10-47806*r**12-472190*r**14-254261*r**16+360507*r**18-57129*r**20
            +34761*r**22)-5*Q2*(-759+6954*r**2+57322*r**4-424866*r**6+607083*r**8
            +102120*r**10+166800*r**12+757680*r**14-67773*r**16-263202*r**18+284310*r**20
            -32638*r**22+16569*r**24))*sqrtq2+12*logq2*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-11815-17342*r**2+20598*Q2**16*r**2-1539738*r**4-1828220*r**6
            -93296530*r**8+531809700*r**10-1202798314*r**12-12016064876*r**14+34941377640*r**16
            -16859928440*r**18-10427104030*r**20+13402061004*r**22-3848051134*r**24
            +1002915580*r**26-360030*r**28+15413020*r**30+576527*r**32+46998*r**34
            -12*Q2**15*(-1480+23619*r**2+19179*r**4)+4*Q2**14*(-32820+315810*r**2
            +775091*r**4+250170*r**6)-4*Q2**13*(-89680+561415*r**2+3441914*r**4
            +3172239*r**6+501840*r**8)+3*Q2**12*(-102835+108210*r**2+8242288*r**4
            +14188924*r**6+7455783*r**8+347210*r**10)+Q2**11*(-501830+4084716*r**2
            -5212386*r**4-3865176*r**6-7029506*r**8-4035196*r**10+3308706*r**12)
            -2*Q2**10*(-682770+1489843*r**2+22024696*r**4+119695125*r**6+221267970*r**8
            +106897065*r**10+24392896*r**12+3266703*r**14)+2*Q2**9*(-367345-3071840*r**2
            +26710386*r**4+227220060*r**6+714133400*r**8+705569180*r**10+204029050*r**12
            +35732936*r**14+1173645*r**16)+Q2**8*(-1049565+10126620*r**2-78738*r**4
            -171444948*r**6-1341551320*r**8-2311353340*r**10-1458873670*r**12-92048748*r**14
            -9710163*r**16+5670720*r**18)-4*Q2**7*(-406065+252615*r**2+7631982*r**4
            +81058936*r**6+189015752*r**8+480461830*r**10+282469470*r**12+143391072*r**14
            +131845761*r**16+16615587*r**18+1761540*r**20)+4*Q2**6*(-86460-2028669*r**2
            +1555743*r**4+74640153*r**6+482523418*r**8+2086011688*r**10+3349274064*r**12
            +1600218868*r**14+600107578*r**16+136941693*r**18+14561673*r**20+206811*r**22)
            +4*Q2**5*(-201465+1468989*r**2+1303132*r**4+13924205*r**6-125757445*r**8
            -1264814850*r**10-4711887796*r**12-4758378986*r**14-842818895*r**16-375154195*r**18
            +18838800*r**20+882517*r**22+946389*r**24)-Q2**4*(-642845-567190*r**2
            -8788364*r**4+119119700*r**6+481332275*r**8+3568163190*r**10-1523155600*r**12
            -13344747272*r**14-6577893895*r**16+5528768150*r**18+405581180*r**20
            +405698740*r**22+29345361*r**24+2648970*r**26)+2*Q2**3*(-18015-1180230*r**2
            -3200553*r**4-5407748*r**6-36754535*r**8+2081584130*r**10+4548956715*r**12
            +5193822776*r**14+943425851*r**16+2957420990*r**18+3054240885*r**20+424070540*r**22
            +85143627*r**24+6359622*r**26+15945*r**28)+2*Q2**2*(-80690+490665*r**2
            -3006468*r**4+17883911*r**6+95819042*r**8-120874895*r**10-1518601440*r**12
            -4189196169*r**14-9293444622*r**16+968976371*r**18-4244198580*r**20+292174125*r**22
            -168527138*r**24+35301811*r**26+1076312*r**28+351765*r**30)-2*Q2*(-38835
            +44444*r**2-3174082*r**4+2322168*r**6-63994442*r**8+565501168*r**10
            +36509186*r**12-748140236*r**14+1938362164*r**16-8068634516*r**18+7204485794*r**20
            -4164681904*r**22+1469846818*r**24-20195832*r**26+35804958*r**28+1423748*r**30
            +159399*r**32))*sqrtq2)*math.log(murhoD))/(489888000*logq2**4*r**16*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))+6804000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+4725*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5-1175731200*logq2**5*r**20*sqrtq2-81648000*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2-283500*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*sqrtq2))+FLAGcD*((2592000*logq2**4*r**12*(105*Q2**9*(1+5*r**4)
            -5*Q2**8*(249+361*r**2+1101*r**4+1005*r**6)+10*Q2**7*(597+1621*r**2
            +3496*r**4+4343*r**6+2025*r**8)-2*Q2**6*(7812+29149*r**2+64765*r**4
            +93125*r**6+69133*r**8+22260*r**10)+Q2**5*(22974+106027*r**2+250778*r**4
            +470915*r**6+412871*r**8+222906*r**10+55545*r**12)-Q2**4*(15540+92822*r**2
            +231869*r**4+588590*r**6+701120*r**8+419048*r**10+170935*r**12+31500*r**14)
            +2*Q2**3*(-1575+11024*r**2+40642*r**4+140278*r**6+184250*r**8+213791*r**10
            +81491*r**12+6005*r**14-5250*r**16)+(-1+r**2)**2*(1821+1633*r**2+608*r**4
            +116088*r**6-193788*r**8-187194*r**10+70224*r**12-1996*r**14+12199*r**16
            +4005*r**18)+Q2**2*(13020+15118*r**2-11915*r**4+119156*r**6-143159*r**8
            -108758*r**10-29109*r**12-13188*r**14+70635*r**16+29400*r**18)+Q2*(
            -8331-4469*r**2+12109*r**4-306011*r**6+264845*r**8+760417*r**10+146475*r**12
            -137073*r**14+34282*r**16-38464*r**18-18180*r**20))+720*logq2**2*(-Q2
            +(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(9795*Q2**15*(1+5*r**4)-Q2**14*(120261
            +121493*r**2+521937*r**4+598665*r**6)+Q2**13*(604329+1271816*r**2+3448100*r**4
            +5662978*r**6+3101085*r**8)-Q2**12*(1583961+5382217*r**2+14984690*r**4
            +28081086*r**6+25269377*r**8+8589165*r**10)+Q2**11*(2105649+11648083*r**2
            +36582862*r**4+85246604*r**6+92230079*r**8+57617593*r**10+12508410*r**12)
            -Q2**10*(491931+12207009*r**2+35377311*r**4+134400931*r**6+171469901*r**8
            +105720395*r**10+60971217*r**12+4741065*r**14)-Q2**9*(2776653-630711*r**2
            +40542531*r**4-18250145*r**6-76727145*r**8+99740803*r**10+137775089*r**12
            +9194301*r**14+14803920*r**16)+Q2**8*(4096917+13919013*r**2+148377380*r**4
            +308632144*r**6+276891690*r**8+613334922*r**10+965758108*r**12+553194480*r**14
            +104109969*r**16+25872705*r**18)-Q2**7*(1474803+15840426*r**2+133162825*r**4
            +526474548*r**6+441833406*r**8+535880328*r**10+1378107826*r**12+1544646700*r**14
            +552418143*r**16+112180446*r**18+12267045*r**20)-Q2**6*(1984323-5804169*r**2
            +37730299*r**4-375497397*r**6+59872778*r**8+1109296634*r**10+899482146*r**12
            -562848086*r**14-848754237*r**16+108366543*r**18-25743789*r**20+10701195*r**22)
            +Q2**5*(2538327+2759198*r**2+163842602*r**4-105799688*r**6+754730047*r**8
            +3936007492*r**10+6253024212*r**12+5020022232*r**14+1457563277*r**16
            +277470622*r**18+679323650*r**20+45080784*r**22+17078205*r**24)-Q2**4*(816711
            +4176143*r**2+106088382*r**4+37433530*r**6+675121145*r**8+5072470653*r**10
            +10494698764*r**12+12060215356*r**14+7391704305*r**16+1851552905*r**18
            +608344086*r**20+492090218*r**22+42539887*r**24+6699915*r**26)+Q2**3*(
            -449121+2478871*r**2-15046580*r**4+146543328*r**6-217727825*r**8+2390168207*r**10
            +6033710428*r**12+8865032760*r**14+8622117469*r**16+3173450165*r**18
            -114834436*r**20+529359176*r**22-28759755*r**24+12234053*r**26-2577540*r**28)
            +(-1+r**2)**2*(22059-8871*r**2+4419683*r**4-20995819*r**6+139149983*r**8
            +108523417*r**10-822294713*r**12+958091149*r**14-873751727*r**16-1787782061*r**18
            +714996889*r**20+332955959*r**22-45911707*r**24+21722171*r**26+603453*r**28
            +180135*r**30)+Q2**2*(491139-1071907*r**2+52895515*r**4-206636041*r**6
            +887443983*r**8+331547957*r**10-575705201*r**12+1159538095*r**14-467647463*r**16
            -3196260881*r**18+1744035569*r**20+1843553133*r**22-528696235*r**24+221511679*r**26
            +1577573*r**28+3503085*r**30)-Q2*(170451-340323*r**2+26200363*r**4
            -129435949*r**6+685390901*r**8+206205825*r**10-1660142489*r**12+533888479*r**14
            -2084679017*r**16-716426537*r**18-4677079583*r**20+1411398297*r**22+1553436983*r**24
            -348894709*r**26+117080461*r**28+1592757*r**30+1314090*r**32))+(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(552*Q2**20+Q2**19*(1230-86*r**2)+8*Q2**18*(993
            +5225*r**2+2309*r**4)-Q2**17*(793689+350881*r**2+3840383*r**4+361615*r**6)
            +Q2**16*(6432021+485746*r**2+21116616*r**4+38837094*r**6+2083563*r**8)
            -2*Q2**15*(11471247-3133150*r**2-25946401*r**4+101248489*r**6+84688408*r**8
            +2973871*r**10)+Q2**14*(40359885-25706302*r**2-675511331*r**4-240427744*r**6
            +819403091*r**8+369434110*r**10+8820563*r**12)-2*Q2**13*(9542901+2669295*r**2
            -1085865336*r**4-1900280100*r**6-466447889*r**8+803851653*r**10+146175660*r**12
            +1926168*r**14)-Q2**12*(59715123-229084978*r**2+3370785104*r**4+12061520622*r**6
            +13661765622*r**8+4700526258*r**10-1023582864*r**12+443437586*r**14+8895575*r**16)
            +2*Q2**11*(59958951-268593854*r**2+1107903779*r**4+11402737423*r**6+22250625111*r**8
            +21253490637*r**10+7314514917*r**12+1008667129*r**14+657468074*r**16
            +7744633*r**18)-Q2**10*(58479135-343542210*r**2-1563244539*r**4+28898194668*r**6
            +83780882714*r**8+119396855352*r**10+86936703870*r**12+20253826772*r**14
            +5147480295*r**16+1012294602*r**18+4642781*r**20)-2*Q2**9*(40320930-289047506*r**2
            +3077122489*r**4-7457575429*r**6-38957895394*r**8-82778419030*r**10-77053270204*r**12
            -39150651796*r**14+935601416*r**16-2231515984*r**18+284894555*r**20+6165809*r**22)
            +Q2**8*(131865747-1224415370*r**2+8366116250*r**4+22850768770*r**6+14448039489*r**8
            -64268195484*r**10-79801386780*r**12+13590947148*r**14+34024103325*r**16
            +42359779974*r**18-138163070*r**20+1608087890*r**22+15087631*r**24)-2*Q2**7*(23013981
            -298988206*r**2+2129722329*r**4+24289171323*r**6+44661674978*r**8+47234796729*r**10
            +36834968682*r**12+99832766070*r**14+112780665993*r**16+70234457628*r**18
            +22785681581*r**20+1785794655*r**22+443650152*r**24+1609065*r**26)+Q2**6*(
            -50293017+573373078*r**2-4626548429*r**4+31899242456*r**6+36006884167*r**8
            +122998331518*r**10-10829320837*r**12+138039439968*r**14+312641956557*r**16
            +104398998674*r**18+120087044929*r**20-4550430776*r**22+3888809861*r**24
            -428397478*r**26-6511471*r**28)+2*Q2**5*(29194197-444109285*r**2+4525970488*r**4
            -275635120*r**6+18388466093*r**8-60188517893*r**10+167931853520*r**12
            +190859318848*r**14+102048773903*r**16-113442017999*r**18+106822746176*r**20
            -18953374040*r**22+21874725359*r**24-911000263*r**26+391781176*r**28
            +2932040*r**30)-Q2**4*(16040505-330507126*r**2+4716323316*r**4+11233089714*r**6
            +15112005104*r**8-109573193430*r**10+588173222796*r**12+1020409892898*r**14
            +1022875599762*r**16+793357092462*r**18-158390301780*r**20+246316285446*r**22
            +12506888136*r**24+28602910174*r**26+237801684*r**28+303592230*r**30
            +1130109*r**32)+2*Q2**3*(-4614882+74166205*r**2-641187947*r**4+4894880565*r**6
            -13870779821*r**8+15069143875*r**10+131583868765*r**12+374509317573*r**14
            +620236955535*r**16+357597187597*r**18+244037521191*r**20+44917866615*r**22
            -6716860655*r**24+18960340425*r**26-1947071001*r**28+487848591*r**30
            -44487185*r**32-543446*r**34)+2*(-1+r**2)**2*(156654-4170412*r**2+84909051*r**4
            -230578818*r**6+358432710*r**8-5882078502*r**10+74768865726*r**12-231116744978*r**14
            +245764096194*r**16+10125137730*r**18-301537274708*r**20+192462278634*r**22
            -40827260622*r**24+11311878366*r**26-1463840190*r**28+470139306*r**30
            -9537448*r**32+2698674*r**34+12633*r**36)+Q2**2*(8644899-184657634*r**2
            +2643449645*r**4-7304295692*r**6+26751377328*r**8-128117752164*r**10
            +487154478120*r**12-363509890492*r**14+372778090654*r**16-540957326056*r**18
            -236996217094*r**20+896363366812*r**22-445606313176*r**24+180868302468*r**26
            -43091242272*r**28+13124189484*r**30-673003673*r**32+121417898*r**34
            +820945*r**36)-Q2*(2682531-67137509*r**2+1183056495*r**4-3779339229*r**6
            +10174715552*r**8-75459588888*r**10+590033884272*r**12-1177510543480*r**14
            +327748803822*r**16+838933914054*r**18-299472890442*r**20-1671324890442*r**22
            +1404998019000*r**24-419673325232*r**26+125884294536*r**28-23421714576*r**30
            +6145926679*r**32-221450265*r**34+42311139*r**36+231983*r**38))+544320000*logq2**5*r**16*(9
            +33*r**2+124*r**4-512*r**6+163*r**8+15*r**10)*sqrtq2+43200*logq2**3*r**8*(2265*Q2**12*(1
            +5*r**4)-10*Q2**11*(2439+2383*r**2+10431*r**4+12315*r**6)+2*Q2**10*(57951
            +108258*r**2+244605*r**4+469607*r**6+288855*r**8)-10*Q2**9*(29970+83928*r**2
            +146473*r**4+295842*r**6+354501*r**8+147330*r**10)+10*Q2**8*(41607+170403*r**2
            +278381*r**4+438443*r**6+778226*r**8+693972*r**10+202860*r**12)-5*Q2**7*(38556
            +357489*r**2+504564*r**4+81617*r**6+473328*r**8+1688379*r**10+1329480*r**12
            +183195*r**14)-5*Q2**6*(57960-124467*r**2+295925*r**4+2741021*r**6+5136449*r**8
            +4066963*r**10+490035*r**12-165669*r**14+303975*r**16)+Q2**5*(516456
            +573363*r**2+6551210*r**4+31603502*r**6+74308470*r**8+90473156*r**10
            +56145758*r**12+15840170*r**14+4559562*r**16+2731905*r**18)-5*Q2**4*(52515
            +155709*r**2+1212342*r**4+6057464*r**6+18583638*r**8+30158754*r**10
            +25695316*r**12+11271144*r**14+2845431*r**16+897153*r**18+290790*r**20)
            -5*Q2**3*(15654-103659*r**2+43130*r**4-1514209*r**6-9251464*r**8-16383518*r**10
            -20394136*r**12-15196618*r**14-1758062*r**16+32217*r**18-420306*r**20
            +77595*r**22)+(-1+r**2)**2*(11592-18345*r**2+695733*r**4-81745*r**6
            +3122037*r**8-1180470*r**10-14149954*r**12-15771798*r**14+390*r**16
            +4605983*r**18+1554573*r**20-25881*r**22+69885*r**24)+5*Q2**2*(31338
            -69451*r**2+887491*r**4+908653*r**6-272311*r**8+1288894*r**10-641462*r**12
            -3234082*r**14-4073984*r**16+4774573*r**18+1844691*r**20-206955*r**22
            +173805*r**24)-5*Q2*(14292-36669*r**2+633636*r**4+13564*r**6+1113684*r**8
            +2288967*r**10-11520768*r**12-8298456*r**14-2304012*r**16-3015687*r**18
            +2866908*r**20+1350204*r**22-122908*r**24+82845*r**26))*sqrtq2+6*logq2*(
            -250*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(111+105*Q2**7-4517*r**2-91999*r**4
            -164085*r**6+1160315*r**8+1928089*r**10+482547*r**12+59769*r**14+1530*r**16
            -5*Q2**6*(-81+31*r**2+240*r**4)+15*Q2**5*(-29-16*r**2+59*r**4+60*r**6)
            -Q2**4*(-321+243*r**2+50107*r**4+69411*r**6+9180*r**8)+Q2**3*(-729
            -1592*r**2+81550*r**4+220582*r**6+137739*r**8+14130*r**10)+Q2**2*(-309
            -1389*r**2-6978*r**4-105212*r**6-125831*r**8-9611*r**10+3210*r**12)
            +Q2*(531-5304*r**2-92255*r**4+33430*r**6+433925*r**8+246424*r**10
            -45401*r**12-9390*r**14))+21*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(12*Q2**10*(16+205*r**4)
            -60*Q2**9*(12+12*r**2+211*r**4+275*r**6)+5*Q2**8*(135+270*r**2+4314*r**4
            +11146*r**6+7335*r**8)-60*Q2**7*(-8+24*r**2+157*r**4+1047*r**6+1313*r**8
            +335*r**10)-30*Q2**6*(30-60*r**2+1447*r**4-433*r**6-2349*r**8-1871*r**10
            +1260*r**12)-60*Q2**3*r**4*(911-1449*r**2-3631*r**4-8165*r**6-7971*r**8
            -5223*r**10-2237*r**12+405*r**14)+4*Q2**5*(-36+540*r**2+28785*r**4
            +42905*r**6+47430*r**8+26514*r**10-8755*r**12+13545*r**14)-30*Q2**4*(
            -19+186*r**2+2071*r**4+5553*r**6+13432*r**8+25138*r**10+17181*r**12
            +1723*r**14+175*r**16)+120*Q2*r**4*(116-1379*r**2-13454*r**4-26131*r**6
            -17070*r**8+5559*r**10+4294*r**12-3241*r**14-574*r**16+40*r**18)-3*(
            -1+r**2)**2*(-9+252*r**2+1793*r**4-41806*r**6-222100*r**8-331426*r**10
            +64268*r**12+55502*r**14-35299*r**16-10330*r**18+755*r**20)+10*Q2**2*(
            -18+324*r**2+3303*r**4-12811*r**6+4917*r**8-22143*r**10-69061*r**12
            +4839*r**14+41457*r**16-3457*r**18+810*r**20))-5*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(30*Q2**15*(1408+21355*r**4)-2*Q2**14*(96000+94432*r**2+1841499*r**4
            +2340195*r**6)+2*Q2**13*(104790+289648*r**2+3915889*r**4+9514666*r**6
            +5723805*r**8)-2*Q2**12*(-133320+288212*r**2+3327327*r**4+13894203*r**6
            +15357559*r**8+3207495*r**10)-Q2**11*(609120+109589*r**2+10179979*r**4
            -5890972*r**6+7743536*r**8-6924137*r**10+16303365*r**12)+Q2**10*(-40920
            +1633551*r**2+30535728*r**4+65571913*r**6+235481588*r**8+272338493*r**10
            +42702732*r**12+22088835*r**14)+Q2**9*(641100-1712547*r**2+31855101*r**4
            +21155575*r**6-292239145*r**8-760113305*r**10-578560777*r**12-81091979*r**14
            +9040905*r**16)-Q2**8*(42360+3220167*r**2+163398546*r**4+343826564*r**6
            +457158230*r**8+205758050*r**10+11525982*r**12+39997316*r**14-36530286*r**16
            +27976095*r**18)+2*Q2**7*(-254640+2882199*r**2+59353974*r**4+212515616*r**6
            +792221208*r**8+1247452960*r**10+1272164694*r**12+879465024*r**14+591679136*r**16
            +53346393*r**18+2437740*r**20)+2*Q2**6*(27720+789339*r**2+49458789*r**4
            -137890762*r**6-928880024*r**8-2512926912*r**10-3883645666*r**12-2844620746*r**14
            -654115832*r**16-302888899*r**18-64932987*r**20+7687740*r**22)-2*Q2**5*(
            -155010+3179651*r**2+75489978*r**4+9011143*r**6+1178158688*r**8+1814989088*r**10
            +143656338*r**12-3265427532*r**14-2615233912*r**16-196798587*r**18+465594828*r**20
            +20256957*r**22+3747810*r**24)+2*Q2**4*(-34800+429893*r**2+13092911*r**4
            +254473345*r**6+3066154535*r**8+5518907760*r**10+6022535174*r**12+6239930638*r**14
            +7188662350*r**16+3828621065*r**18+247777115*r**20+414022033*r**22+54467051*r**24
            -1103070*r**26)+Q2**3*(-102720+2946871*r**2+35076693*r**4-430516868*r**6
            -1622270680*r**8-2407501785*r**10-3972479207*r**12-2896383656*r**14-1879468064*r**16
            -11455837155*r**18-12282676545*r**20-2245358164*r**22+56844088*r**24
            -12757243*r**26+1697235*r**28)-(-1+r**2)**2*(6840-262821*r**2+694140*r**4
            +53693853*r**6+340327528*r**8+1056435675*r**10+19830812092*r**12+41828023405*r**14
            +31273693864*r**16+1060482649*r**18-2366456780*r**20+2425860079*r**22
            +553946680*r**24+35499633*r**26-2265452*r**28+132615*r**30)-Q2**2*(-29640
            +759349*r**2+18796244*r**4+90389751*r**6+2573379748*r**8-4264509115*r**10
            -16074629528*r**12-38907744713*r**14-43242750992*r**16-9250682441*r**18
            +9496395540*r**20+4191654029*r**22-988650956*r**24+236074191*r**26+30677168*r**28
            +247365*r**30)+Q2*(18180-712839*r**2+5167701*r**4+197422827*r**6+1553553159*r**8
            -2371820983*r**10+36772678093*r**12+121033122043*r**14+172424472631*r**16
            +58661293507*r**18-8400275609*r**20-4648158839*r**22+8076387181*r**24
            +934073467*r**26+119024759*r**28+5960337*r**30+290385*r**32)))*sqrtq2)/(2721600000*logq2**4*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+37800000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +26250*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-6531840000*logq2**5*r**20*sqrtq2
            -453600000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-1575000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+((-5184000*logq2**4*r**12*(105*Q2**9*(1
            +5*r**4)-5*Q2**8*(249+361*r**2+1101*r**4+1005*r**6)+10*Q2**7*(597+1621*r**2
            +3496*r**4+4343*r**6+2025*r**8)-2*Q2**6*(7812+29149*r**2+64765*r**4
            +93125*r**6+69133*r**8+22260*r**10)+Q2**5*(22974+106027*r**2+250778*r**4
            +470915*r**6+412871*r**8+222906*r**10+55545*r**12)-Q2**4*(15540+92822*r**2
            +231869*r**4+588590*r**6+701120*r**8+419048*r**10+170935*r**12+31500*r**14)
            +2*Q2**3*(-1575+11024*r**2+40642*r**4+140278*r**6+184250*r**8+213791*r**10
            +81491*r**12+6005*r**14-5250*r**16)+(-1+r**2)**2*(1821+1633*r**2+608*r**4
            +116088*r**6-193788*r**8-187194*r**10+70224*r**12-1996*r**14+12199*r**16
            +4005*r**18)+Q2**2*(13020+15118*r**2-11915*r**4+119156*r**6-143159*r**8
            -108758*r**10-29109*r**12-13188*r**14+70635*r**16+29400*r**18)+Q2*(
            -8331-4469*r**2+12109*r**4-306011*r**6+264845*r**8+760417*r**10+146475*r**12
            -137073*r**14+34282*r**16-38464*r**18-18180*r**20))-1440*logq2**2*(-Q2
            +(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(9795*Q2**15*(1+5*r**4)-Q2**14*(120261
            +121493*r**2+521937*r**4+598665*r**6)+Q2**13*(604329+1271816*r**2+3448100*r**4
            +5662978*r**6+3101085*r**8)-Q2**12*(1583961+5382217*r**2+14984690*r**4
            +28081086*r**6+25269377*r**8+8589165*r**10)+Q2**11*(2105649+11648083*r**2
            +36582862*r**4+85246604*r**6+92230079*r**8+57617593*r**10+12508410*r**12)
            -Q2**10*(491931+12207009*r**2+35377311*r**4+134400931*r**6+171469901*r**8
            +105720395*r**10+60971217*r**12+4741065*r**14)-Q2**9*(2776653-630711*r**2
            +40542531*r**4-18250145*r**6-76727145*r**8+99740803*r**10+137775089*r**12
            +9194301*r**14+14803920*r**16)+Q2**8*(4096917+13919013*r**2+148377380*r**4
            +308632144*r**6+276891690*r**8+613334922*r**10+965758108*r**12+553194480*r**14
            +104109969*r**16+25872705*r**18)-Q2**7*(1474803+15840426*r**2+133162825*r**4
            +526474548*r**6+441833406*r**8+535880328*r**10+1378107826*r**12+1544646700*r**14
            +552418143*r**16+112180446*r**18+12267045*r**20)-Q2**6*(1984323-5804169*r**2
            +37730299*r**4-375497397*r**6+59872778*r**8+1109296634*r**10+899482146*r**12
            -562848086*r**14-848754237*r**16+108366543*r**18-25743789*r**20+10701195*r**22)
            +Q2**5*(2538327+2759198*r**2+163842602*r**4-105799688*r**6+754730047*r**8
            +3936007492*r**10+6253024212*r**12+5020022232*r**14+1457563277*r**16
            +277470622*r**18+679323650*r**20+45080784*r**22+17078205*r**24)-Q2**4*(816711
            +4176143*r**2+106088382*r**4+37433530*r**6+675121145*r**8+5072470653*r**10
            +10494698764*r**12+12060215356*r**14+7391704305*r**16+1851552905*r**18
            +608344086*r**20+492090218*r**22+42539887*r**24+6699915*r**26)+Q2**3*(
            -449121+2478871*r**2-15046580*r**4+146543328*r**6-217727825*r**8+2390168207*r**10
            +6033710428*r**12+8865032760*r**14+8622117469*r**16+3173450165*r**18
            -114834436*r**20+529359176*r**22-28759755*r**24+12234053*r**26-2577540*r**28)
            +(-1+r**2)**2*(22059-8871*r**2+4419683*r**4-20995819*r**6+139149983*r**8
            +108523417*r**10-822294713*r**12+958091149*r**14-873751727*r**16-1787782061*r**18
            +714996889*r**20+332955959*r**22-45911707*r**24+21722171*r**26+603453*r**28
            +180135*r**30)+Q2**2*(491139-1071907*r**2+52895515*r**4-206636041*r**6
            +887443983*r**8+331547957*r**10-575705201*r**12+1159538095*r**14-467647463*r**16
            -3196260881*r**18+1744035569*r**20+1843553133*r**22-528696235*r**24+221511679*r**26
            +1577573*r**28+3503085*r**30)-Q2*(170451-340323*r**2+26200363*r**4
            -129435949*r**6+685390901*r**8+206205825*r**10-1660142489*r**12+533888479*r**14
            -2084679017*r**16-716426537*r**18-4677079583*r**20+1411398297*r**22+1553436983*r**24
            -348894709*r**26+117080461*r**28+1592757*r**30+1314090*r**32))-2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(552*Q2**20+Q2**19*(1230-86*r**2)+8*Q2**18*(993
            +5225*r**2+2309*r**4)-Q2**17*(793689+350881*r**2+3840383*r**4+361615*r**6)
            +Q2**16*(6432021+485746*r**2+21116616*r**4+38837094*r**6+2083563*r**8)
            -2*Q2**15*(11471247-3133150*r**2-25946401*r**4+101248489*r**6+84688408*r**8
            +2973871*r**10)+Q2**14*(40359885-25706302*r**2-675511331*r**4-240427744*r**6
            +819403091*r**8+369434110*r**10+8820563*r**12)-2*Q2**13*(9542901+2669295*r**2
            -1085865336*r**4-1900280100*r**6-466447889*r**8+803851653*r**10+146175660*r**12
            +1926168*r**14)-Q2**12*(59715123-229084978*r**2+3370785104*r**4+12061520622*r**6
            +13661765622*r**8+4700526258*r**10-1023582864*r**12+443437586*r**14+8895575*r**16)
            +2*Q2**11*(59958951-268593854*r**2+1107903779*r**4+11402737423*r**6+22250625111*r**8
            +21253490637*r**10+7314514917*r**12+1008667129*r**14+657468074*r**16
            +7744633*r**18)-Q2**10*(58479135-343542210*r**2-1563244539*r**4+28898194668*r**6
            +83780882714*r**8+119396855352*r**10+86936703870*r**12+20253826772*r**14
            +5147480295*r**16+1012294602*r**18+4642781*r**20)-2*Q2**9*(40320930-289047506*r**2
            +3077122489*r**4-7457575429*r**6-38957895394*r**8-82778419030*r**10-77053270204*r**12
            -39150651796*r**14+935601416*r**16-2231515984*r**18+284894555*r**20+6165809*r**22)
            +Q2**8*(131865747-1224415370*r**2+8366116250*r**4+22850768770*r**6+14448039489*r**8
            -64268195484*r**10-79801386780*r**12+13590947148*r**14+34024103325*r**16
            +42359779974*r**18-138163070*r**20+1608087890*r**22+15087631*r**24)-2*Q2**7*(23013981
            -298988206*r**2+2129722329*r**4+24289171323*r**6+44661674978*r**8+47234796729*r**10
            +36834968682*r**12+99832766070*r**14+112780665993*r**16+70234457628*r**18
            +22785681581*r**20+1785794655*r**22+443650152*r**24+1609065*r**26)+Q2**6*(
            -50293017+573373078*r**2-4626548429*r**4+31899242456*r**6+36006884167*r**8
            +122998331518*r**10-10829320837*r**12+138039439968*r**14+312641956557*r**16
            +104398998674*r**18+120087044929*r**20-4550430776*r**22+3888809861*r**24
            -428397478*r**26-6511471*r**28)+2*Q2**5*(29194197-444109285*r**2+4525970488*r**4
            -275635120*r**6+18388466093*r**8-60188517893*r**10+167931853520*r**12
            +190859318848*r**14+102048773903*r**16-113442017999*r**18+106822746176*r**20
            -18953374040*r**22+21874725359*r**24-911000263*r**26+391781176*r**28
            +2932040*r**30)-Q2**4*(16040505-330507126*r**2+4716323316*r**4+11233089714*r**6
            +15112005104*r**8-109573193430*r**10+588173222796*r**12+1020409892898*r**14
            +1022875599762*r**16+793357092462*r**18-158390301780*r**20+246316285446*r**22
            +12506888136*r**24+28602910174*r**26+237801684*r**28+303592230*r**30
            +1130109*r**32)+2*Q2**3*(-4614882+74166205*r**2-641187947*r**4+4894880565*r**6
            -13870779821*r**8+15069143875*r**10+131583868765*r**12+374509317573*r**14
            +620236955535*r**16+357597187597*r**18+244037521191*r**20+44917866615*r**22
            -6716860655*r**24+18960340425*r**26-1947071001*r**28+487848591*r**30
            -44487185*r**32-543446*r**34)+2*(-1+r**2)**2*(156654-4170412*r**2+84909051*r**4
            -230578818*r**6+358432710*r**8-5882078502*r**10+74768865726*r**12-231116744978*r**14
            +245764096194*r**16+10125137730*r**18-301537274708*r**20+192462278634*r**22
            -40827260622*r**24+11311878366*r**26-1463840190*r**28+470139306*r**30
            -9537448*r**32+2698674*r**34+12633*r**36)+Q2**2*(8644899-184657634*r**2
            +2643449645*r**4-7304295692*r**6+26751377328*r**8-128117752164*r**10
            +487154478120*r**12-363509890492*r**14+372778090654*r**16-540957326056*r**18
            -236996217094*r**20+896363366812*r**22-445606313176*r**24+180868302468*r**26
            -43091242272*r**28+13124189484*r**30-673003673*r**32+121417898*r**34
            +820945*r**36)-Q2*(2682531-67137509*r**2+1183056495*r**4-3779339229*r**6
            +10174715552*r**8-75459588888*r**10+590033884272*r**12-1177510543480*r**14
            +327748803822*r**16+838933914054*r**18-299472890442*r**20-1671324890442*r**22
            +1404998019000*r**24-419673325232*r**26+125884294536*r**28-23421714576*r**30
            +6145926679*r**32-221450265*r**34+42311139*r**36+231983*r**38))-1088640000*logq2**5*r**16*(9
            +33*r**2+124*r**4-512*r**6+163*r**8+15*r**10)*sqrtq2-86400*logq2**3*r**8*(2265*Q2**12*(1
            +5*r**4)-10*Q2**11*(2439+2383*r**2+10431*r**4+12315*r**6)+2*Q2**10*(57951
            +108258*r**2+244605*r**4+469607*r**6+288855*r**8)-10*Q2**9*(29970+83928*r**2
            +146473*r**4+295842*r**6+354501*r**8+147330*r**10)+10*Q2**8*(41607+170403*r**2
            +278381*r**4+438443*r**6+778226*r**8+693972*r**10+202860*r**12)-5*Q2**7*(38556
            +357489*r**2+504564*r**4+81617*r**6+473328*r**8+1688379*r**10+1329480*r**12
            +183195*r**14)-5*Q2**6*(57960-124467*r**2+295925*r**4+2741021*r**6+5136449*r**8
            +4066963*r**10+490035*r**12-165669*r**14+303975*r**16)+Q2**5*(516456
            +573363*r**2+6551210*r**4+31603502*r**6+74308470*r**8+90473156*r**10
            +56145758*r**12+15840170*r**14+4559562*r**16+2731905*r**18)-5*Q2**4*(52515
            +155709*r**2+1212342*r**4+6057464*r**6+18583638*r**8+30158754*r**10
            +25695316*r**12+11271144*r**14+2845431*r**16+897153*r**18+290790*r**20)
            -5*Q2**3*(15654-103659*r**2+43130*r**4-1514209*r**6-9251464*r**8-16383518*r**10
            -20394136*r**12-15196618*r**14-1758062*r**16+32217*r**18-420306*r**20
            +77595*r**22)+(-1+r**2)**2*(11592-18345*r**2+695733*r**4-81745*r**6
            +3122037*r**8-1180470*r**10-14149954*r**12-15771798*r**14+390*r**16
            +4605983*r**18+1554573*r**20-25881*r**22+69885*r**24)+5*Q2**2*(31338
            -69451*r**2+887491*r**4+908653*r**6-272311*r**8+1288894*r**10-641462*r**12
            -3234082*r**14-4073984*r**16+4774573*r**18+1844691*r**20-206955*r**22
            +173805*r**24)-5*Q2*(14292-36669*r**2+633636*r**4+13564*r**6+1113684*r**8
            +2288967*r**10-11520768*r**12-8298456*r**14-2304012*r**16-3015687*r**18
            +2866908*r**20+1350204*r**22-122908*r**24+82845*r**26))*sqrtq2+logq2*(3000*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*(111+105*Q2**7-4517*r**2-91999*r**4-164085*r**6
            +1160315*r**8+1928089*r**10+482547*r**12+59769*r**14+1530*r**16-5*Q2**6*(
            -81+31*r**2+240*r**4)+15*Q2**5*(-29-16*r**2+59*r**4+60*r**6)-Q2**4*(
            -321+243*r**2+50107*r**4+69411*r**6+9180*r**8)+Q2**3*(-729-1592*r**2
            +81550*r**4+220582*r**6+137739*r**8+14130*r**10)+Q2**2*(-309-1389*r**2
            -6978*r**4-105212*r**6-125831*r**8-9611*r**10+3210*r**12)+Q2*(531
            -5304*r**2-92255*r**4+33430*r**6+433925*r**8+246424*r**10-45401*r**12
            -9390*r**14))-252*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))**2*(12*Q2**10*(16+205*r**4)-60*Q2**9*(12
            +12*r**2+211*r**4+275*r**6)+5*Q2**8*(135+270*r**2+4314*r**4+11146*r**6
            +7335*r**8)-60*Q2**7*(-8+24*r**2+157*r**4+1047*r**6+1313*r**8+335*r**10)
            -30*Q2**6*(30-60*r**2+1447*r**4-433*r**6-2349*r**8-1871*r**10+1260*r**12)
            -60*Q2**3*r**4*(911-1449*r**2-3631*r**4-8165*r**6-7971*r**8-5223*r**10
            -2237*r**12+405*r**14)+4*Q2**5*(-36+540*r**2+28785*r**4+42905*r**6
            +47430*r**8+26514*r**10-8755*r**12+13545*r**14)-30*Q2**4*(-19+186*r**2
            +2071*r**4+5553*r**6+13432*r**8+25138*r**10+17181*r**12+1723*r**14
            +175*r**16)+120*Q2*r**4*(116-1379*r**2-13454*r**4-26131*r**6-17070*r**8
            +5559*r**10+4294*r**12-3241*r**14-574*r**16+40*r**18)-3*(-1+r**2)**2*(
            -9+252*r**2+1793*r**4-41806*r**6-222100*r**8-331426*r**10+64268*r**12
            +55502*r**14-35299*r**16-10330*r**18+755*r**20)+10*Q2**2*(-18+324*r**2
            +3303*r**4-12811*r**6+4917*r**8-22143*r**10-69061*r**12+4839*r**14
            +41457*r**16-3457*r**18+810*r**20))+60*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(30*Q2**15*(1408
            +21355*r**4)-2*Q2**14*(96000+94432*r**2+1841499*r**4+2340195*r**6)+2*Q2**13*(104790
            +289648*r**2+3915889*r**4+9514666*r**6+5723805*r**8)-2*Q2**12*(-133320
            +288212*r**2+3327327*r**4+13894203*r**6+15357559*r**8+3207495*r**10)
            -Q2**11*(609120+109589*r**2+10179979*r**4-5890972*r**6+7743536*r**8
            -6924137*r**10+16303365*r**12)+Q2**10*(-40920+1633551*r**2+30535728*r**4
            +65571913*r**6+235481588*r**8+272338493*r**10+42702732*r**12+22088835*r**14)
            +Q2**9*(641100-1712547*r**2+31855101*r**4+21155575*r**6-292239145*r**8
            -760113305*r**10-578560777*r**12-81091979*r**14+9040905*r**16)-Q2**8*(42360
            +3220167*r**2+163398546*r**4+343826564*r**6+457158230*r**8+205758050*r**10
            +11525982*r**12+39997316*r**14-36530286*r**16+27976095*r**18)+2*Q2**7*(
            -254640+2882199*r**2+59353974*r**4+212515616*r**6+792221208*r**8+1247452960*r**10
            +1272164694*r**12+879465024*r**14+591679136*r**16+53346393*r**18+2437740*r**20)
            +2*Q2**6*(27720+789339*r**2+49458789*r**4-137890762*r**6-928880024*r**8
            -2512926912*r**10-3883645666*r**12-2844620746*r**14-654115832*r**16-302888899*r**18
            -64932987*r**20+7687740*r**22)-2*Q2**5*(-155010+3179651*r**2+75489978*r**4
            +9011143*r**6+1178158688*r**8+1814989088*r**10+143656338*r**12-3265427532*r**14
            -2615233912*r**16-196798587*r**18+465594828*r**20+20256957*r**22+3747810*r**24)
            +2*Q2**4*(-34800+429893*r**2+13092911*r**4+254473345*r**6+3066154535*r**8
            +5518907760*r**10+6022535174*r**12+6239930638*r**14+7188662350*r**16
            +3828621065*r**18+247777115*r**20+414022033*r**22+54467051*r**24-1103070*r**26)
            +Q2**3*(-102720+2946871*r**2+35076693*r**4-430516868*r**6-1622270680*r**8
            -2407501785*r**10-3972479207*r**12-2896383656*r**14-1879468064*r**16
            -11455837155*r**18-12282676545*r**20-2245358164*r**22+56844088*r**24
            -12757243*r**26+1697235*r**28)-(-1+r**2)**2*(6840-262821*r**2+694140*r**4
            +53693853*r**6+340327528*r**8+1056435675*r**10+19830812092*r**12+41828023405*r**14
            +31273693864*r**16+1060482649*r**18-2366456780*r**20+2425860079*r**22
            +553946680*r**24+35499633*r**26-2265452*r**28+132615*r**30)-Q2**2*(-29640
            +759349*r**2+18796244*r**4+90389751*r**6+2573379748*r**8-4264509115*r**10
            -16074629528*r**12-38907744713*r**14-43242750992*r**16-9250682441*r**18
            +9496395540*r**20+4191654029*r**22-988650956*r**24+236074191*r**26+30677168*r**28
            +247365*r**30)+Q2*(18180-712839*r**2+5167701*r**4+197422827*r**6+1553553159*r**8
            -2371820983*r**10+36772678093*r**12+121033122043*r**14+172424472631*r**16
            +58661293507*r**18-8400275609*r**20-4648158839*r**22+8076387181*r**24
            +934073467*r**26+119024759*r**28+5960337*r**30+290385*r**32)))*sqrtq2)*math.log(murhoD))/(1469664000*logq2**4*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+20412000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +14175*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-3527193600*logq2**5*r**20*sqrtq2
            -244944000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-850500*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2))+(flagPERP*(248832000*logq2**5*(-Q2+(
            -1+r)**2)*r**20*(-Q2+(1+r)**2)*(-420*Q2**9*r**2+60*Q2**8*(8+51*r**2+37*r**4)
            -40*Q2**7*(96+281*r**2+328*r**4+45*r**6)+4*Q2**6*(3360+6676*r**2+8487*r**4
            +1690*r**6-2877*r**8)+Q2**5*(-24675-44164*r**2-44222*r**4-19828*r**6
            +50433*r**8+32928*r**10)+Q2**4*(21315+47095*r**2+28212*r**4+23434*r**6
            -49925*r**8-104449*r**10-27090*r**12)-2*Q2**3*(-105+17105*r**2+3224*r**4
            +7017*r**6-23847*r**8-36323*r**10-32108*r**12+9345*r**14)+(-1+r**2)**2*(
            -2985+7299*r**2+5207*r**4-35113*r**6+43049*r**8+48649*r**10-24515*r**12
            +9277*r**14+9612*r**16)+2*Q2**2*(-8085+16460*r**2+1611*r**4-17045*r**6
            +6832*r**8+7890*r**10-25141*r**12+1203*r**14+26355*r**16)+Q2*(12225
            -33014*r**2+4784*r**4+97176*r**6-51266*r**8-200968*r**10-101904*r**12
            +68368*r**14+641*r**16-37962*r**18))+138240*logq2**3*r**12*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(-126720*Q2**15*r**2+12*Q2**14*(-64+127440*r**2
            +117135*r**4)-4*Q2**13*(-9018+1980972*r**2+3696715*r**4+1667115*r**6)
            +4*Q2**12*(-66342+5576832*r**2+16188333*r**4+14879200*r**6+4318875*r**8)
            -Q2**11*(-796827+34607052*r**2+146708482*r**4+204136788*r**6+125461505*r**8
            +25364880*r**10)+Q2**10*(-943533+21504387*r**2+159785972*r**4+291646482*r**6
            +282753307*r**8+138765515*r**10+18135630*r**12)+Q2**9*(-499389+18885840*r**2
            -242845*r**4+36241810*r**6+39677325*r**8-82100264*r**10-59160795*r**12
            +770310*r**14)-Q2**8*(-2715831+46341189*r**2+214774995*r**4+695944635*r**6
            +1182293495*r**8+839871579*r**10+201366349*r**12+19817565*r**14+11395080*r**16)
            +2*Q2**7*(-1284957+14499882*r**2+115869363*r**4+447842420*r**6+960472625*r**8
            +1041617518*r**10+498631117*r**12+102685048*r**14+10572420*r**16+4900500*r**18)
            -2*Q2**6*(245277-3953817*r**2+22867773*r**4+168027617*r**6+433359805*r**8
            +816102877*r**10+668138603*r**12+208201883*r**14+93969722*r**16+9169200*r**18
            +5243220*r**20)+2*Q2**5*(1334283-11017962*r**2-45810702*r**4-93187212*r**6
            -387157432*r**8-150485872*r**10+278775898*r**12+333818448*r**14+188193213*r**16
            +207498298*r**18+28051380*r**20+6579900*r**22)-2*Q2**4*(849609-5431365*r**2
            -34778900*r**4-97580870*r**6-493896470*r**8-545379488*r**10-105973710*r**12
            +481472390*r**14+434402575*r**16+370381925*r**18+198940034*r**20+30749680*r**22
            +3244590*r**24)+Q2**3*(-177153+1716552*r**2-6116820*r**4-113672180*r**6
            -65266565*r**8-728230504*r**10+32992736*r**12+747750120*r**14+1347126965*r**16
            +4123240*r**18+690510932*r**20-41720788*r**22+18933425*r**24-4017960*r**26)
            +(-1+r**2)**2*(52467-214959*r**2-513578*r**4+24544170*r**6-126468135*r**8
            +333630851*r**10+143760988*r**12-186943764*r**14-290848075*r**16+152935495*r**18
            +307080582*r**20-41295254*r**22+44394367*r**24+2264805*r**26+500040*r**28)
            +Q2**2*(706407-4302117*r**2-10478558*r**4+142444560*r**6-627305085*r**8
            +1016948831*r**10-401677846*r**12-242493064*r**14-730602595*r**16-672524215*r**18
            +1375783262*r**20-535514312*r**22+310701497*r**24+8919485*r**26+6513750*r**28)
            +Q2*(-330273+1943268*r**2+3255253*r**4-103200878*r**6+568986855*r**8
            -1328446124*r**10+663530109*r**12+54640474*r**14-1022622379*r**16+253007340*r**18
            +613081927*r**20-1338623402*r**22+389254373*r**24-195871268*r**26-7112345*r**28
            -3012930*r**30))-96*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(41196*Q2**21*r**2
            -12*Q2**20*(-1480+57537*r**2+57537*r**4)+120*Q2**19*(-1538+36356*r**2
            +93839*r**4+39453*r**6)-4*Q2**18*(-197020+3429590*r**2+17022939*r**4
            +17758976*r**6+4374255*r**8)+Q2**17*(-1611705+21307800*r**2+196865022*r**4
            +326801204*r**6+226422315*r**8+36585180*r**10)-Q2**16*(-825285+8328699*r**2
            +243045288*r**4+271652546*r**6+393855835*r**8+353632323*r**10+35295714*r**12)
            -2*Q2**15*(-1691530+8632397*r**2+47034651*r**4+1203624515*r**6+2322591946*r**8
            +888276297*r**10-27952759*r**12+9161007*r**14)+6*Q2**14*(-1276570+306365*r**2
            +107405990*r**4+1468114024*r**6+4369816345*r**8+4133678157*r**10+1278770820*r**12
            +132717130*r**14+15579195*r**16)-6*Q2**13*(-694360-9541905*r**2+108142642*r**4
            +1891948324*r**6+8996254464*r**8+13405058556*r**10+8681955634*r**12+1980123832*r**14
            +229100148*r**16+14985465*r**18)+Q2**12*(7231640-45106750*r**2+147589494*r**4
            -510307928*r**6+31590484676*r**8+63259793076*r**10+72748902136*r**12
            +42509817224*r**14+5135819268*r**16+692981210*r**18-25514190*r**20)+2*Q2**11*(
            -6692790-43045977*r**2-138804633*r**4+9040529951*r**6+31325757150*r**8
            +94929285204*r**10+132949671332*r**12+57641585244*r**14+10260629376*r**16
            +4505870285*r**18+355067277*r**20+63349533*r**22)-2*Q2**10*(-2475330
            -80127723*r**2-427329540*r**4+8482224308*r**6+62173944523*r**8+237632761038*r**10
            +504894152264*r**12+446597123224*r**14+157735353072*r**16+33855112253*r**18
            +6979631884*r**20+627808500*r**22+42879447*r**24)+2*Q2**9*(4015635-17649645*r**2
            -80633610*r**4-1824953034*r**6+29923651135*r**8+140347883043*r**10+544580901140*r**12
            +778778866780*r**14+486715657641*r**16+108009326625*r**18+22472141078*r**20
            +2820445950*r**22+299041125*r**24-17911335*r**26)+2*Q2**8*(-5095155-64812390*r**2
            -726733239*r**4+7729275950*r**6+19926490149*r**8+145558773576*r**10+76967287949*r**12
            -135228948996*r**14-279692483433*r**16-138804933646*r**18+24195819291*r**20
            -3024656826*r**22+968352551*r**24+82666044*r**26+42145695*r**28)-2*Q2**7*(
            -1141230-61180425*r**2-771079923*r**4+3106696853*r**6+26175882046*r**8
            +242266876761*r**10+592831687421*r**12+912351757243*r**14+868180549830*r**16
            +280334574881*r**18+70627874791*r**20+55988355171*r**22-628241398*r**24
            +1023832399*r**26+176923695*r**28+16904205*r**30)+2*Q2**6*(1923590-152827*r**2
            +31246698*r**4-2840959408*r**6+8847417085*r**8+65995782819*r**10+378992755352*r**12
            +759043973518*r**14+1225994189751*r**16+848962846475*r**18+178485168418*r**20
            +17273411172*r**22+24761709059*r**24+567468397*r**26+703397820*r**28
            +117341918*r**30-10364637*r**32)+2*Q2**5*(-1687020-30111117*r**2-526241814*r**4
            +3031195536*r**6-5399320116*r**8+87944018802*r**10-73099714*r**12+85799140020*r**14
            -12540830160*r**16-548859502468*r**18-205049783706*r**20-196227938040*r**22
            -67969411444*r**24-38817508986*r**26-8582403726*r**28-1238044236*r**30
            -53687964*r**32+12470553*r**34)+2*Q2**4*(309480+16643565*r**2+303501675*r**4
            -468666468*r**6+6072438630*r**8-72665356764*r**10-49742477450*r**12-222911612740*r**14
            -809622560514*r**16+56447378230*r**18+316674193628*r**20+117897252180*r**22
            +397604133970*r**24+157953921812*r**26+45568320090*r**28+9012406356*r**30
            +894533730*r**32+1524645*r**34-2924055*r**36)-2*Q2**3*(-289910-474605*r**2
            -31915293*r**4+714305651*r**6-771979178*r**8-2462298942*r**10-13502542778*r**12
            -21154868422*r**14-399967899894*r**16+182040594376*r**18+323036215364*r**20
            +30667931616*r**22+367504684738*r**24+62106880670*r**26+100384759962*r**28
            +4651250438*r**30+1576907092*r**32-89419323*r**34-26686727*r**36+1965165*r**38)
            +(-1+r**2)**2*(-11815-403479*r**2-12116849*r**4+7431355*r**6-1021262296*r**8
            +3713843244*r**10-19357856828*r**12-79702366908*r**14+643446898310*r**16
            -1875974607162*r**18+1346326900378*r**20+947285878418*r**22-1500221460412*r**24
            +547694052940*r**26-160473203388*r**28-1314878428*r**30-6495045111*r**32
            -596417831*r**34-67757105*r**36-1871029*r**38+93996*r**40)+2*Q2**2*(
            -209010-3774075*r**2-100503306*r**4+495159340*r**6-4934409087*r**8+23742388308*r**10
            -47797118772*r**12-65442601284*r**14+435289265808*r**16-512251145506*r**18
            +201626183424*r**20+843810468444*r**22-1273773051514*r**24+942040248564*r**26
            -363615254652*r**28+28925356068*r**30-22402113222*r**32-2276793771*r**34
            -420155462*r**36-21995880*r**38+1575585*r**40)+Q2*(113115+2926986*r**2
            +81610158*r**4-276256040*r**6+5678145215*r**8-28132582398*r**10+96147156696*r**12
            +166092974016*r**14-1702057063770*r**16+4055392372820*r**18-2870556455516*r**20
            +1790627790576*r**22-4370925867706*r**24+5072448079060*r**26-2208592193160*r**28
            +617619359616*r**30-27933564609*r**32+28296357282*r**34+2726470750*r**36
            +402827000*r**38+15322683*r**40-882774*r**42))-104509440000*logq2**6*r**24*(3
            +20*r**4-56*r**6+9*r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            +8294400*logq2**4*r**16*(-13260*Q2**14*r**2+60*Q2**13*(40+2680*r**2+2401*r**4)
            -6*Q2**12*(5100+147238*r**2+246091*r**4+112154*r**6)+4*Q2**11*(40100
            +721304*r**2+1652517*r**4+1421660*r**6+435672*r**8)-Q2**10*(447475+6049088*r**2
            +16717435*r**4+20029380*r**6+11769298*r**8+2703384*r**10)+10*Q2**9*(68555
            +805237*r**2+2501440*r**4+3686911*r**6+3084241*r**8+1407782*r**10+268974*r**12)
            -5*Q2**8*(86805+1204482*r**2+3844386*r**4+6617882*r**6+7328747*r**8
            +5298296*r**10+2150082*r**12+501012*r**14)+2*Q2**7*(-162900+537168*r**2
            -559419*r**4+448879*r**6+4767120*r**8+10594610*r**10+9988123*r**12+4398291*r**14
            +1874124*r**16)+Q2**6*(868050+2153988*r**2+18220419*r**4+28318100*r**6
            +22904339*r**8-2968560*r**10-30037967*r**12-26248396*r**14-10867545*r**16
            -5050836*r**18)+2*Q2**5*(-317550-1078182*r**2-8595135*r**4-13362360*r**6
            -11869077*r**8-483356*r**10+15992313*r**12+22072780*r**14+12186475*r**16
            +5063118*r**18+1597974*r**20)+(-1+r**2)**4*(-7925+64002*r**2-644137*r**4
            +2092860*r**6-501548*r**8-14416*r**10+1553052*r**12-405848*r**14+305105*r**16
            +1974638*r**18-7619*r**20+127836*r**22)+5*Q2**4*(5790+325128*r**2+588075*r**4
            +2765862*r**6+1529776*r**8-1393670*r**10-5670238*r**12-6381562*r**14
            -4463374*r**16+401518*r**18-1179069*r**20+206484*r**22)-10*Q2**3*(-27300
            +174264*r**2-918057*r**4+1832787*r**6-194026*r**8-1252730*r**10-218876*r**12
            +379404*r**14-893110*r**16-338902*r**18+2742397*r**20-414711*r**22+338460*r**24)
            -2*Q2*(-1+r**2)**2*(-31775+227677*r**2-2019340*r**4+5478478*r**6-1014238*r**8
            -2340054*r**10+6316966*r**12+6661844*r**14-1319973*r**16+248793*r**18
            +5766334*r**20-279938*r**22+449226*r**24)+Q2**2*(-200975+1401592*r**2
            -10450116*r**4+27647936*r**6-17373755*r**8-7527460*r**10+13976676*r**12
            +33441052*r**14+27045263*r**16-4193020*r**18-17708640*r**20+28043732*r**22
            -4073861*r**24+2547576*r**26))*sqrtq2-1152*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(556584*Q2**18*r**2-24*Q2**17*(-6440+323208*r**2+306463*r**4)
            +8*Q2**16*(-206850+5519389*r**2+11628335*r**4+5174919*r**6)-16*Q2**15*(
            -453390+8198464*r**2+29667243*r**4+28688323*r**6+7989399*r**8)+Q2**14*(
            -15560475+202083880*r**2+1220893040*r**4+1833745864*r**6+1181704395*r**8
            +225561240*r**10)-2*Q2**13*(-5645325+43616511*r**2+717343940*r**4+1230354128*r**6
            +1303767993*r**8+779996385*r**10+94366656*r**12)-Q2**12*(-21123795+215895094*r**2
            +268889069*r**4+4014555896*r**6+6997825091*r**8+2134796386*r**10-510499101*r**12
            +59589024*r**14)+4*Q2**11*(-14212275+86070211*r**2+743035225*r**4+4686585867*r**6
            +11081489235*r**8+9824682745*r**10+3123228847*r**12+360722385*r**14+78294696*r**16)
            -Q2**10*(-39352005+41037548*r**2+3285943206*r**4+23975557532*r**6+82036551836*r**8
            +111640348140*r**10+68855674586*r**12+16275034772*r**14+2141869801*r**16
            +285317208*r**18)+2*Q2**9*(15644475-159295005*r**2+299102910*r**4+1564699086*r**6
            +23439363700*r**8+50040687620*r**10+51591022530*r**12+24569424530*r**14
            +2959354561*r**16+549580505*r**18+16391760*r**20)+Q2**8*(-72689925+241774542*r**2
            +1376541385*r**4+23642841412*r**6+53046035202*r**8+80273670480*r**10
            +65852812518*r**12+5296665100*r**14-1699708733*r**16+5042504322*r**18
            -160900335*r**20+132289872*r**22)-8*Q2**7*(-4477935-12549833*r**2+113135397*r**4
            +2869845901*r**6+12111514456*r**8+27782911496*r**10+40552191738*r**12
            +27367406188*r**14+7124939001*r**16+1485846481*r**18+625020601*r**20
            +805847*r**22+13167702*r**24)+Q2**6*(22941975-222773024*r**2+320246860*r**4
            +1186948608*r**6+42075249355*r**8+123826787000*r**10+253894842256*r**12
            +302901668880*r**14+128639342541*r**16+31928011680*r**18+5192478500*r**20
            +3260490288*r**22+390413905*r**24+33194376*r**26)-2*Q2**5*(17956365-41277559*r**2
            +323114312*r**4-5311848084*r**6-7966543787*r**8-13823328875*r**10-38085421224*r**12
            +36373118112*r**14+58882418407*r**16+19450066291*r**18+33943885680*r**20
            +8402339828*r**22+2995570871*r**24+427633647*r**26+3519216*r**28)+Q2**4*(12569025
            +42558630*r**2+532283765*r**4-5857073536*r**6-20006350895*r**8-34234549530*r**10
            -191812969715*r**12-100524001040*r**14+70382940747*r**16+93491962450*r**18
            +82418789815*r**20+95990523760*r**22+24050384675*r**24+5151956514*r**26
            +571345095*r**28-1409760*r**30)+4*Q2**3*(1243725-12088901*r**2+33945405*r**4
            -197600789*r**6+1481269421*r**8+1734068835*r**10+12345396741*r**12+16114316675*r**14
            -14472290177*r**16-38680880487*r**18+1084023295*r**20-28955989079*r**22
            -2626870105*r**24-2641517559*r**26+73361791*r**28+12920745*r**30+2530464*r**32)
            -(-1+r**2)**2*(246015+536676*r**2+32866994*r**4-76476220*r**6+175415270*r**8
            +9083955020*r**10-45076434838*r**12+107812661588*r**14+2554205940*r**16
            -117106438140*r**18+3423157590*r**20+86477254348*r**22-27968873558*r**24
            +12315091780*r**26+668521870*r**28+322313500*r**30+20632189*r**32+563976*r**34)
            -Q2**2*(5835585-16402172*r**2+385462518*r**4-2053395604*r**6+1536932986*r**8
            +27486858996*r**10-116893034098*r**12+168733564812*r**14-98504943492*r**16
            -29664224772*r**18-184808077822*r**20+263810299812*r**22-154780905578*r**24
            +66730605596*r**26+491409786*r**28+2847158116*r**30+251116083*r**32+9739248*r**34)
            +2*Q2*(987525-952091*r**2+95622530*r**4-441681714*r**6+600269490*r**8
            +14843714010*r**10-78143641962*r**12+165889979990*r**14-93319820228*r**16
            +36498450420*r**18-1688578270*r**20-108839318678*r**22+176852299230*r**24
            -73189265802*r**26+24791391090*r**28+519434610*r**30+787021231*r**32
            +60572375*r**34+1916244*r**36))*sqrtq2-16*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(658*Q2**22+Q2**21*(9168+5492*r**2)-Q2**20*(149367+1710440*r**2
            +145885*r**4)+2*Q2**19*(166081+11225142*r**2+11373357*r**4+513816*r**6)
            -4*Q2**18*(-500241+29074056*r**2+68728671*r**4+32028984*r**6+949307*r**8)
            +2*Q2**17*(-5615008+146448803*r**2+643844310*r**4+678188618*r**6+190108966*r**8
            +4125635*r**10)-4*Q2**16*(-3973359+74266084*r**2+679947566*r**4+1166558084*r**6
            +813909434*r**8+142704876*r**10+2477669*r**12)+2*Q2**15*(11775989-110636094*r**2
            +664396723*r**4+951187330*r**6+1749762163*r**8+1506240170*r**10+59782461*r**12
            +1513106*r**14)+2*Q2**14*(-55171233+425567014*r**2+2711053775*r**4+12958211190*r**6
            +21658743637*r**8+9739250642*r**10+1595151489*r**12+544099234*r**14+4360652*r**16)
            -2*Q2**13*(-64251489+244237704*r**2+5532279198*r**4+32275758294*r**6
            +86358159924*r**8+82047028890*r**10+28156092330*r**12+5697080754*r**14
            +880213701*r**16+5410358*r**18)+Q2**12*(32404320-689625728*r**2+6029515422*r**4
            +40568180232*r**6+219931592136*r**8+336188308392*r**10+225093896652*r**12
            +50076188856*r**14+10603021032*r**16+512577624*r**18-2528058*r**20)+2*Q2**11*(
            -115033373+399321098*r**2+2210312267*r**4+31587831686*r**6+31061512558*r**8
            +34431825288*r**10-6092006098*r**12-19785079664*r**14+9780730671*r**16
            +148443454*r**18+792861927*r**20+7594938*r**22)-2*Q2**10*(-93871869-301375562*r**2
            +3319994183*r**4+57918106482*r**6+221297158884*r**8+548728816820*r**10
            +745806838042*r**12+376195573260*r**14+111602538743*r**16+34133271638*r**18
            +4291667039*r**20+952597698*r**22+5111938*r**24)+2*Q2**9*(35349973-660880954*r**2
            +1254992504*r**4+13592393802*r**6+188409941901*r**8+595751483472*r**10
            +1400248406784*r**12+1275737968812*r**14+420777203271*r**16+112212418766*r**18
            +17786796808*r**20+3853561546*r**22+74351511*r**24-2393252*r**26)+2*Q2**8*(
            -108253049+118145044*r**2-1124814378*r**4+38306461532*r**6+18754759225*r**8
            +173212341792*r**10-500295246472*r**12-989355332216*r**14-692859876855*r**16
            -17789612956*r**18-28297635746*r**20+5682638556*r**22-1939300841*r**24
            +618754856*r**26+5264308*r**28)-2*Q2**7*(-54052263-448577294*r**2-1520978173*r**4
            +28731627586*r**6+112888864569*r**8+706645991774*r**10+929096410339*r**12
            +1001121957078*r**14+418146169379*r**16+16355794270*r**18+193861735857*r**20
            +135446846*r**22+5076541451*r**24-433805614*r**26+430061097*r**28+2026538*r**30)
            +2*Q2**6*(26086756-338891526*r**2+444452537*r**4-9932112558*r**6+69997798893*r**8
            +300770174994*r**10+915081187041*r**12+1489407656154*r**14+1687384602261*r**16
            +547655973486*r**18-13794033501*r**20+77006155926*r**22+1117169999*r**24
            -1921129978*r**26+1260136771*r**28-59789634*r**30-1335221*r**32)+2*Q2**5*(
            -41065221-30301762*r**2-2100878558*r**4+19379453494*r**6-37887938426*r**8
            +262142876010*r**10-288763677838*r**12+154465718158*r**14-604942387500*r**16
            -650739335506*r**18-222381517226*r**20-50316474078*r**22-61839285638*r**24
            -28061823154*r**26-913977578*r**28-2037242598*r**30+205606193*r**32+1540828*r**34)
            +Q2**4*(27030983+281559096*r**2+2329355103*r**4-8747645416*r**6+40739366524*r**8
            -535300669288*r**10+403110641524*r**12-1808455964520*r**14-1432781657230*r**16
            +955373106632*r**18+122065779642*r**20+994249714184*r**22+578840269196*r**24
            +246283782728*r**26+66968062644*r**28+8072207688*r**30+1963310271*r**32
            -157780704*r**34-693057*r**36)-4*Q2**3*(-2393664+28989864*r**2-155289084*r**4
            +2427128335*r**6-6125332244*r**8-451871134*r**10+21267853224*r**12-132493087338*r**14
            -254737602684*r**16+394463082666*r**18-13968192200*r**20+181366227780*r**22
            +40316224628*r**24+110206678118*r**26+21963685960*r**28+2782514298*r**30
            +999139932*r**32-155130906*r**34+9843156*r**36+123293*r**38)+2*(-1
            +r**2)**2*(-190141-1529518*r**2-33679497*r**4+9807032*r**6-1746945342*r**8
            +6647955444*r**10-39233655776*r**12-41613662324*r**14+844981789254*r**16
            -3200025798184*r**18+4808873592694*r**20-3353175039444*r**22+1172325161764*r**24
            -289357902804*r**26+26173110744*r**28-10693057756*r**30-1369313137*r**32
            -113407818*r**34-30256357*r**36+935532*r**38+5634*r**40)+2*Q2**2*(-5256619
            -1096858*r**2-569910819*r**4+3574594202*r**6-23996575640*r**8+106537748288*r**10
            -268025666192*r**12+237211890976*r**14+208084980498*r**16-175106578276*r**18
            +1047462497634*r**20-2262696717692*r**22+2130463827880*r**24-852248583952*r**26
            +143057076472*r**28-47330360656*r**30-10657058383*r**32-95706162*r**34
            -538547623*r**36+25490194*r**38+192728*r**40)-2*Q2*(-1647815-6079975*r**2
            -224696078*r**4+905703860*r**6-11449882667*r**8+57888034035*r**10-231966314240*r**12
            +211288930984*r**14+1134859600730*r**16-3216199321134*r**18-86321246700*r**20
            +6808527240080*r**22-7559948172934*r**24+3468174980510*r**26-972610147056*r**28
            +129588947480*r**30-38974080115*r**32-6566340347*r**34-280835350*r**36
            -221131268*r**38+8084625*r**40+53375*r**42))*sqrtq2)*math.log(r))/(78382080000*logq2**5*(
            -Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +1814400000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+3780000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-156764160000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-16329600000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-113400000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -52500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*sqrtq2)
            +((-248832000*logq2**5*r**18*(-420*Q2**11*(2+5*r**4)+60*Q2**10*(194+212*r**2
            +437*r**4+255*r**6)-20*Q2**9*(3426+6972*r**2+10615*r**4+7838*r**6+1665*r**8)
            +4*Q2**8*(57618+160047*r**2+258485*r**4+216315*r**6+65865*r**8-7110*r**10)
            +Q2**7*(-484056-1617165*r**2-2871524*r**4-2651950*r**6-1135140*r**8
            +207315*r**10+270720*r**12)+Q2**6*(629496+2372769*r**2+4533691*r**4
            +4300204*r**6+2021070*r**8-205175*r**10-1179465*r**12-522270*r**14)
            +Q2**5*(-429912-1862847*r**2-3721990*r**4-3191853*r**6-1259418*r**8
            +1041695*r**10+1296990*r**12+1096725*r**14+342090*r**16)+(-1+r**2)**4*(
            -17088-18795*r**2-21135*r**4+136265*r**6-740695*r**8-253957*r**10+192475*r**12
            +57355*r**14+133675*r**16+48060*r**18)+Q2**4*(-17640+450135*r**2+1035007*r**4
            +479273*r**6-631395*r**8-1250735*r**10-1400695*r**12+7695*r**14+620235*r**16
            +315000*r**18)+Q2**3*(312768+309357*r**2+302872*r**4-31970*r**6+2660268*r**8
            +3728068*r**10-1049848*r**12-755070*r**14-845060*r**16-1784865*r**18
            -810360*r**20)-Q2*(-1+r**2)**2*(-108384-110799*r**2-102640*r**4+469850*r**6
            -2947570*r**8-3793436*r**10+466414*r**12+997990*r**14+274890*r**16+697035*r**18
            +285930*r**20)+Q2**2*(-274704-109305*r**2-64759*r**4+780600*r**6-5129310*r**8
            -4646176*r**10-2277180*r**12+1320354*r**14+1305350*r**16-428415*r**18
            +1090875*r**20+691230*r**22))-138240*logq2**3*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(-180*Q2**17*(687+3520*r**4)+12*Q2**16*(145209+134648*r**2
            +655656*r**4+691275*r**6)-4*Q2**15*(2677302+4920501*r**2+13552617*r**4
            +22398253*r**6+12008025*r**8)+8*Q2**14*(4642020+12845148*r**2+31082511*r**4
            +58031107*r**6+54932145*r**8+20011275*r**10)-Q2**13*(76851180+295637991*r**2
            +728962248*r**4+1451259386*r**6+1758838824*r**8+1194796055*r**10+332921700*r**12)
            +Q2**12*(84960540+487160349*r**2+1203391395*r**4+2618752084*r**6+3616206066*r**8
            +3337328181*r**10+1904259415*r**12+430704450*r**14)-2*Q2**11*(2743272
            +188425437*r**2+250795212*r**4+670144431*r**6+1011099911*r**8+1079701735*r**10
            +1275535046*r**12+824294433*r**14+152164575*r**16)+2*Q2**10*(-65107548
            -70638837*r**2-1093190739*r**4-2742499879*r**6-4624436750*r**8-5933256326*r**10
            -4008370495*r**12-768518955*r**14+200104408*r**16+12999825*r**18)+Q2**9*(186062580
            +641523807*r**2+4838376204*r**4+14455085438*r**6+26574484030*r**8+38171849000*r**10
            +36000291782*r**12+19225071674*r**14+4817795078*r**16+597953505*r**18
            +166807350*r**20)-Q2**8*(83641140+627279993*r**2+3673314039*r**4+15065763348*r**6
            +28912437972*r**8+46430742650*r**10+55954169518*r**12+42927138204*r**14
            +18399002968*r**16+4738914237*r**18+738669915*r**20+207417600*r**22)
            +4*Q2**7*(-17943750+53530788*r**2-333611085*r**4+1164222978*r**6+1036149702*r**8
            +903784212*r**10+4828121398*r**12+8684823340*r**14+7004306008*r**16+2663099912*r**18
            +1339752627*r**20+198619530*r**22+54917100*r**24)-4*Q2**6*(-31067316
            -26620905*r**2-1260854973*r**4-1163004961*r**6-5773062756*r**8-14454501347*r**10
            -13604880658*r**12-4087020790*r**14+4970617074*r**16+5157154919*r**18
            +1908180331*r**20+1955638851*r**22+262723346*r**24+54119025*r**26)+Q2**5*(
            -63520884-158174265*r**2-3845275920*r**4-4824559478*r**6-23584022100*r**8
            -65453440259*r**10-65456189472*r**12-30838250444*r**14+10797549404*r**16
            +30122146345*r**18+19401760488*r**20+5669591042*r**22+6198036364*r**24
            +856909779*r**26+110601000*r**28)+(-1+r**2)**4*(-408312-125055*r**2
            -52121757*r**4+124875502*r**6-716725158*r**8-348339321*r**10+2358533045*r**12
            +574331404*r**14-6376937484*r**16-5380078609*r**18+4541769133*r**20+2216311710*r**22
            -92084822*r**24+231490057*r**26+13969467*r**28+2500200*r**30)+Q2**4*(
            -6739740+104075259*r**2+248412933*r**4+2611315556*r**6+4395789210*r**8
            +20964708245*r**10+14090687807*r**12-4942192246*r**14-18539298272*r**16
            -20298674795*r**18-4354671005*r**20-232711616*r**22-2589936062*r**24
            +325781691*r**26-223569415*r**28+40302450*r**30)-Q2*(-1+r**2)**2*(-3841272
            +3125103*r**2-400921782*r**4+988014115*r**6-4705680386*r**8-2687278929*r**10
            +13019115714*r**12-3861985701*r**14-19303641530*r**16-24858789163*r**18
            -16673146146*r**20+22201393633*r**22+12762568858*r**24-1299918835*r**26
            +1494577174*r**28+82024097*r**30+20065050*r**32)-2*Q2**3*(-13088160+31275633*r**2
            -810935256*r**4+1680241283*r**6-5536756173*r**8-3960046435*r**10+2129658454*r**12
            -8858976693*r**14-6450062031*r**16-2850606509*r**18-1924988420*r**20
            +18645784513*r**22+12449110149*r**24-2097497377*r**26+2334043782*r**28
            +81577265*r**30+50145975*r**32)+2*Q2**2*(-7358940+16505187*r**2-622064115*r**4
            +1804537377*r**6-6657829462*r**8-323197992*r**10+12757021111*r**12-11635443245*r**14
            -14431261744*r**16-7142730756*r**18-1966505141*r**20-21398365993*r**22
            +12629088210*r**24+15055527092*r**26-3301369807*r**28+1893501173*r**30
            +73027920*r**32+32599125*r**34))+96*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(205980*Q2**23*r**2-60*Q2**22*(-1184+39539*r**2+64403*r**4)+12*Q2**21*(
            -66010+384665*r**2+3695392*r**4+2565185*r**6)-4*Q2**20*(-1072795-14016985*r**2
            +30048273*r**4+82088225*r**6+34570230*r**8)+Q2**19*(-16259015-459430624*r**2
            -489420362*r**4+611399268*r**6+1279317721*r**8+381567900*r**10)+Q2**18*(50346775
            +1801153481*r**2+4552801352*r**4+5096076530*r**6+716941367*r**8-2707001939*r**10
            -629815470*r**12)+Q2**17*(-125636995-4577970394*r**2-16361346657*r**4
            -34185543994*r**6-42529848669*r**8-17123461382*r**10+2094751961*r**12
            +444272970*r**14)+Q2**16*(224175635+7809365011*r**2+36324646565*r**4
            +99974128845*r**6+202599264105*r**8+197200450525*r**10+71288223931*r**12
            +4276886555*r**14+474117420*r**16)-2*Q2**15*(112752950+3684349402*r**2
            +25752260173*r**4+79016347492*r**6+233092435851*r**8+345746446566*r**10
            +255229223487*r**12+75180939848*r**14+7333269947*r**16+737962860*r**18)
            +2*Q2**14*(-10760090-1124273264*r**2+15496671303*r**4+19912261043*r**6
            +203418671719*r**8+482954308527*r**10+550352756969*r**12+349433867053*r**14
            +80760081363*r**16+9335927281*r**18+619466400*r**20)+2*Q2**13*(212514850
            +9604495826*r**2+24605545417*r**4+233697297520*r**6+453679804464*r**8
            +446703045772*r**10+345711736162*r**12+27182590944*r**14-123650290370*r**16
            -10162724238*r**18-4289425979*r**20+219536640*r**22)-2*Q2**12*(283961990
            +13908960364*r**2+74031198307*r**4+584754092799*r**6+1848717652088*r**8
            +3124808784564*r**10+4097845080966*r**12+3474660039134*r**14+1583651768778*r**16
            +372430678624*r**18+91134548887*r**20+3816947459*r**22+911678040*r**24)
            +2*Q2**11*(90983295+6206547906*r**2+78914092893*r**4+569615400240*r**6
            +2742809560320*r**8+5288058804880*r**10+8265967023254*r**12+9042684714672*r**14
            +6308667139195*r**16+2528866847610*r**18+642628095325*r**20+119451472096*r**22
            +7383540918*r**24+655985460*r**26)+2*Q2**10*(192044385+8718596961*r**2
            -16333816305*r**4+140384960001*r**6-1470147860228*r**8-2328890180048*r**10
            -4488792514256*r**12-6817216024770*r**14-6896067267011*r**16-4415511376363*r**18
            -1444516748893*r**20-408591500719*r**22-54253428650*r**24-4837798134*r**26
            +175444590*r**28)-2*Q2**9*(267943485+15674082036*r**2+57128926488*r**4
            +968994735438*r**6+1179544359247*r**8+5008115702564*r**10+9749320559730*r**12
            +11132156908862*r**14+8343980582787*r**16+2537364664220*r**18+107065206684*r**20
            +308087299642*r**22-33516927887*r**24+16400244428*r**26-732456294*r**28
            +595534650*r**30)+2*Q2**8*(100462325+8163786479*r**2+70099745838*r**4
            +914309030690*r**6+2420386789419*r**8+7886670029317*r**10+19887473263544*r**12
            +28623891172128*r**14+31288703086975*r**16+20612304044273*r**18+7125861584574*r**20
            +1644161088082*r**22+869124458069*r**24+105782448795*r**26+31317956188*r**28
            +1588709804*r**30+327947340*r**32)+2*Q2**7*(79973330+3476457124*r**2
            -27910345903*r**4-4813851036*r**6-1709005164273*r**8-1396912949054*r**10
            -12999780005819*r**12-18126611546808*r**14-26841404556161*r**16-28047969119666*r**18
            -14857716194733*r**20-5257322417084*r**22-1137151326659*r**24-854473166418*r**26
            -108924395561*r**28-17576159408*r**30-2167266781*r**32+81478110*r**34)
            -2*Q2**6*(110655490+7320664226*r**2+10687192529*r**4+670030621775*r**6
            -926162679525*r**8+7093581933855*r**10-1161506151381*r**12+10171475571551*r**14
            +11609573936535*r**16-3791598682725*r**18-13245179986075*r**20-4311810606651*r**22
            -5517264068439*r**24-1653069836395*r**26-1160801742495*r**28-134070550515*r**30
            -10517626589*r**32-1654549361*r**34+191148990*r**36)+2*Q2**5*(44526470
            +3718402904*r**2+17482408263*r**4+525051721474*r**6-583635850216*r**8
            +8079234870264*r**10+166376158736*r**12+19562170599672*r**14+30849573522556*r**16
            +13418503624712*r**18-2742066012018*r**20-16256271303284*r**22+122861606312*r**24
            -5729655008664*r**26-1757694210536*r**28-1025597078216*r**30-114418714306*r**32
            -7136494272*r**34-542489341*r**36+81767490*r**38)+(-1+r**2)**4*(288635
            +31651299*r**2+111271033*r**4+7614797437*r**6-43628593504*r**8+388530892020*r**10
            -1579155924692*r**12+4161970681836*r**14-1560125734366*r**16-13257018016878*r**18
            +19628329796710*r**20-599093098738*r**22-6696813817396*r**24+1753856929396*r**26
            -934456148532*r**28+31634420780*r**30-44082832869*r**32-3316042973*r**34
            -266794967*r**36-10914211*r**38+469980*r**40)+2*Q2**4*(7344020+201681862*r**2
            -8499180259*r**4-57914087239*r**6-72471232020*r**8-1916232653488*r**10
            +45191035536*r**12-6407528085816*r**14-14149451477816*r**16+8025160669492*r**18
            +2762811336666*r**20+1284095345242*r**22+14491115933584*r**24-403906403376*r**26
            +525766748776*r**28+864923452752*r**30+167790295860*r**32+26316539366*r**34
            +500529681*r**36-318862123*r**38+12909300*r**40)+Q2**3*(-31307375-2375082196*r**2
            +3914474888*r**4-307603445700*r**6+1378713462367*r**8-7305891514164*r**10
            +15939838687208*r**12-26120977252704*r**14+5725243573170*r**16-16545846818376*r**18
            -2635796724808*r**20-12341711143848*r**22+34568176886694*r**24+22996488679160*r**26
            -12226936657224*r**28+10943838471808*r**30-1271315280819*r**32+871946193372*r**34
            +65171801120*r**36+7264364108*r**38+935570539*r**40-55577220*r**42)-Q2*(
            -1+r**2)**2*(3182875+314783476*r**2+572687324*r**4+64673752542*r**6-361227941195*r**8
            +2793557226118*r**10-9682124302768*r**12+21909567108248*r**14-4854905883266*r**16
            -44619376781680*r**18+23883287007016*r**20+54279686955588*r**22-3834252765318*r**24
            -34213158940444*r**26+10059925712720*r**28-5421764065736*r**30+349190098999*r**32
            -296058258004*r**34-22877575332*r**36-2019721970*r**38-111393023*r**40
            +5353830*r**42)+Q2**2*(14455775+1266088589*r**2-412625118*r**4+217995780164*r**6
            -1256783044359*r**8+8161841385043*r**10-25880881053966*r**12+54390652473544*r**14
            -32839166259042*r**16-25623157560118*r**18+14937874699996*r**20+6499117182224*r**22
            +63564386271386*r**24+11387512733742*r**26-68831208209812*r**28+27191083344504*r**30
            -12608200661581*r**32+1566594951993*r**34-748497467614*r**36-58144882836*r**38
            -5619477443*r**40-480698641*r**42+25053570*r**44))-104509440000*logq2**6*(
            -Q2+(-1+r)**2)*r**22*(-18-33*r**2-512*r**6+326*r**8+45*r**10)*(-Q2
            +(1+r)**2)*sqrtq2+8294400*logq2**4*r**14*(60*Q2**14*(279+1105*r**4)-60*Q2**13*(3672
            +3553*r**2+13184*r**4+12005*r**6)+6*Q2**12*(216522+397980*r**2+879960*r**4
            +1217787*r**6+560770*r**8)-4*Q2**11*(1102446+2916746*r**2+5719010*r**4
            +8812611*r**6+7107446*r**8+2178360*r**10)+Q2**10*(9157662+31630681*r**2
            +62692292*r**4+102204667*r**6+105754956*r**8+59741062*r**10+13516920*r**12)
            -10*Q2**9*(1094562+4964351*r**2+10058191*r**4+17452471*r**6+21517777*r**8
            +16715812*r**10+7286906*r**12+1344870*r**14)+5*Q2**8*(848286+7976115*r**2
            +14049744*r**4+23414022*r**6+37373222*r**8+43518791*r**10+30172424*r**12
            +11132460*r**14+2505060*r**16)-2*Q2**7*(-4062528+871560*r**2-21574260*r**4
            -81039648*r**6-85527785*r**8-9022188*r**10+65773250*r**12+55704100*r**14
            +20210067*r**16+9370620*r**18)+Q2**6*(-14591232-27280062*r**2-133532310*r**4
            -457180677*r**6-613653302*r**8-410556677*r**10-43933182*r**12+175267025*r**14
            +126444838*r**16+42740703*r**18+25254180*r**20)-4*Q2**5*(-2316114-6108162*r**2
            -26309109*r**4-108119484*r**6-142044207*r**8-97719918*r**10-8627437*r**12
            +50020851*r**14+51490781*r**16+26325998*r**18+8398326*r**20+3994935*r**22)
            -(-1+r**2)**4*(-124182+38701*r**2-2905026*r**4-5822095*r**6+17877786*r**8
            -12939494*r**10-34948534*r**12-35828334*r**14-2135360*r**16+29175209*r**18
            +10200296*r**20+483853*r**22+639180*r**24)-5*Q2**4*(-47736+2085258*r**2
            +1605498*r**4+25878921*r**6+28210614*r**8+5127676*r**10-21667370*r**12
            -42615694*r**14-25419898*r**16+12335474*r**18+5326264*r**20-2334627*r**22
            +1032420*r**24)+10*Q2**3*(-443556+573828*r**2-5282568*r**4-7874790*r**6
            +3305379*r**8-8687332*r**10-25552238*r**12-8823620*r**14+309336*r**16
            +3445412*r**18+32018534*r**20+14428426*r**22-621111*r**24+1692300*r**26)
            +2*Q2*(-1+r**2)**2*(-490842+405289*r**2-9300155*r**4-18555946*r**6+43857706*r**8
            -21569338*r**10-123343548*r**12-86672018*r**14-37179244*r**16+1269159*r**18
            +74591295*r**20+29403124*r**22+186388*r**24+2246130*r**26)+Q2**2*(3116862
            -5335435*r**2+49360670*r**4+60307542*r**6-189839810*r**8+138555941*r**10
            +391966600*r**12+302326440*r**14+7248446*r**16+5992315*r**18+178447522*r**20
            -223400190*r**22-137130410*r**24+11729387*r**26-12737880*r**28))*sqrtq2
            +5760*logq2**2*r**6*(24*Q2**22*(3349+23191*r**4)-24*Q2**21*(53244+44743*r**2
            +341916*r**4+399227*r**6)+8*Q2**20*(1141149+1938186*r**2+7548212*r**4
            +16204279*r**6+9269913*r**8)-16*Q2**19*(2388885+6200913*r**2+17996211*r**4
            +50023581*r**6+56128111*r**8+21236550*r**10)+Q2**18*(101371470+364376283*r**2
            +901939072*r**4+2925542404*r**6+4649993790*r**8+3571477829*r**10+1015255920*r**12)
            -2*Q2**17*(82990902+407489793*r**2+760476111*r**4+3079183744*r**6+6264453850*r**8
            +7013600283*r**10+4421219185*r**12+1015456548*r**14)+Q2**16*(124190814
            +1005250443*r**2-605927720*r**4+2360522459*r**6+10298899070*r**8+16041244481*r**10
            +19251003124*r**12+13358293273*r**14+2601432552*r**16)-8*Q2**15*(-13923204
            +17067252*r**2-1326430584*r**4-3838939006*r**6-6767174377*r**8-9484461898*r**10
            -7323319706*r**12-1336413278*r**14+1173902791*r**16+201367542*r**18)
            -4*Q2**14*(103924230+461839629*r**2+7069874398*r**4+27366106409*r**6
            +59883223146*r**8+98763664597*r**10+109101848210*r**12+73060945527*r**14
            +23648196448*r**16+1543875638*r**18+228768000*r**20)+8*Q2**13*(57789630
            +419259117*r**2+4658560473*r**4+23718707868*r**6+56853504860*r**8+104349367974*r**10
            +135528667572*r**12+121877950124*r**14+71681709642*r**16+22550628165*r**18
            +2862642671*r**20+387843480*r**22)-4*Q2**12*(23683686+620296833*r**2
            +3611063482*r**4+40919767270*r**6+92193166686*r**8+179874903864*r**10
            +265111420114*r**12+294461639190*r**14+254899956900*r**16+147431354047*r**18
            +43699855812*r**20+6461175500*r**22+755762904*r**24)+8*Q2**11*(-47911032
            -49186644*r**2-4425685472*r**4-1065658986*r**6-27485965883*r**8-74882465534*r**10
            -119893306538*r**12-125655979244*r**14-54665507600*r**16+23525424088*r**18
            +31950565618*r**20+8563522870*r**22+1805629995*r**24+127080954*r**26)
            +2*Q2**10*(253996626+1312179765*r**2+33707301004*r**4+95238282770*r**6
            +427663211674*r**8+1163066078355*r**10+2054655272808*r**12+2692243477820*r**14
            +2390087581998*r**16+1296820261587*r**18+363936348356*r**20+45528311954*r**22
            +20336551846*r**24-914446299*r**26+415924392*r**28)-4*Q2**9*(53227170
            +606841911*r**2+11226466297*r**4+53749728060*r**6+192995001626*r**8+638839813211*r**10
            +1177493558137*r**12+1736360711760*r**14+1959293099406*r**16+1535468746357*r**18
            +760731867411*r**20+240863926404*r**22+51248323574*r**24+21509118457*r**26
            +1008721467*r**28+317060400*r**30)+2*Q2**8*(-68409870+370756077*r**2
            -4927320492*r**4+52277135275*r**6-23716493510*r**8+484718620897*r**10
            +603587147548*r**12+798961328119*r**14+1644965959510*r**16+2446918974415*r**18
            +2142079382380*r**20+1047901209577*r**22+485282217070*r**24+118153207363*r**26
            +47382852420*r**28+3008049301*r**30+389783280*r**32)-8*Q2**7*(-29325612
            -62877084*r**2-5258584192*r**4+1025350222*r**6-92975388251*r**8-58991019510*r**10
            -320840189982*r**12-679437130574*r**14-608420561685*r**16-172017573438*r**18
            +277687239076*r**20+360796497330*r**22+156326837523*r**24+139280009422*r**26
            +36450984058*r**28+11461534670*r**30+843615305*r**32+33073602*r**34)
            -(-1+r**2)**6*(-111342-741639*r**2-60673944*r**4+127536874*r**6-3205168148*r**8
            +10217397442*r**10-29897017976*r**12-34740746198*r**14+193737188248*r**16
            -72930182964*r**18-319823878848*r**20+102654417774*r**22+101050018628*r**24
            -12171250498*r**26+11478112712*r**28+912649598*r**30+379158566*r**32
            +18007739*r**34+563976*r**36)+4*Q2**6*(-30822564-164742393*r**2-7952057988*r**4
            -4434808571*r**6-172196926538*r**8-139610466201*r**10-711416820346*r**12
            -1548839731179*r**14-1322256660234*r**16-640612627195*r**18+78477760518*r**20
            +575142317655*r**22+625539626354*r**24+119576944437*r**26+207757054018*r**28
            +61372155407*r**30+14701608134*r**32+1218148568*r**34+665718*r**36)+2*Q2*(
            -1+r**2)**4*(-716598-3444273*r**2-329128663*r**4+786724362*r**6-15396679070*r**8
            +43317800554*r**10-119537325386*r**12-133596075410*r**14+510084437102*r**16
            +63178550776*r**18-761468840424*r**20-725967628694*r**22+450004194774*r**24
            +371967238550*r**26-49120397302*r**28+47231589818*r**30+3477277328*r**32
            +1752942649*r**34+88115711*r**36+3044196*r**38)+8*Q2**5*(288354+39848442*r**2
            +719080673*r**4+2786827981*r**6+19234991160*r**8+37162801596*r**10+89812810270*r**12
            +266974341088*r**14-9628381328*r**16-167954937416*r**18-184968019052*r**20
            -85038377078*r**22+46680345184*r**24-96146507132*r**26+6044083818*r**28
            -1240741208*r**30-12002660394*r**32-532023730*r**34-136376381*r**36+12765153*r**38)
            -Q2**2*(-1+r**2)**2*(-7982526-21753423*r**2-3041778600*r**4+8989145879*r**6
            -127546337928*r**8+351340078348*r**10-919868411216*r**12-525259552124*r**14
            +2215611585292*r**16-3021863722*r**18-2026920891872*r**20-3055562194614*r**22
            -2964636195272*r**24+2293142877804*r**26+2334014554448*r**28-440159404156*r**30
            +323173862978*r**32+17236702721*r**34+13564741000*r**36+717803927*r**38
            +28453056*r**40)-4*Q2**4*(-9049440+16655433*r**2-2001397914*r**4+7755443082*r**6
            -61540954616*r**8+144871110442*r**10-311546954302*r**12-76582807342*r**14
            -203354864778*r**16-313968015972*r**18-273272118754*r**20-209950647090*r**22
            -56476766874*r**24+944867546150*r**26+527696521862*r**28-107341383098*r**30
            +148760610034*r**32-150875445*r**34+7327833396*r**36+344338576*r**38
            +29056650*r**40)+8*Q2**3*(-3002190-597906*r**2-923521234*r**4+3595029044*r**6
            -35720498475*r**8+106536716170*r**10-263249552734*r**12+56937186560*r**14
            +275846417250*r**16-181239122300*r**18-186552654138*r**20-113016227784*r**22
            -73679287688*r**24-624761140692*r**26+190539776150*r**28+496808887936*r**30
            -147119686436*r**32+73971576462*r**34+385633748*r**36+3413198100*r**38
            +183818947*r**40+9291210*r**42))*sqrtq2+16*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(3778*Q2**24*r**2+4*Q2**23*r**2*(11287+8598*r**2)-Q2**22*(123588
            +413273*r**2+8224490*r**4+1082761*r**6)+2*Q2**21*(777780-1722671*r**2
            +35004111*r**4+61875367*r**6+4542089*r**8)-Q2**20*(8503812-50984735*r**2
            +37764972*r**4+998164362*r**6+822398880*r**8+41372937*r**10)+2*Q2**19*(12728700
            -132562980*r**2-901178985*r**4+661081624*r**6+2942873210*r**8+1528445976*r**10
            +59110819*r**12)-2*Q2**18*(20316375-390311495*r**2-5091659678*r**4-6752046868*r**6
            +2275474247*r**8+8898882953*r**10+3314281240*r**12+109225494*r**14)+2*Q2**17*(7051536
            -708323153*r**2-14007579757*r**4-37493231467*r**6-41038508505*r**8-10868617423*r**10
            +12663463569*r**12+3504373331*r**14+122012037*r**16)+2*Q2**16*(38494035
            +732229265*r**2+21951008029*r**4+94715217408*r**6+188835172483*r**8+217395120444*r**10
            +96215255535*r**12+2577658284*r**14+1338261158*r**16-53118081*r**18)
            -4*Q2**15*(39250008+71665742*r**2+7794217857*r**4+70677943062*r**6+202496491933*r**8
            +383041239508*r**10+367031014753*r**12+145277957822*r**14+21470798447*r**16
            +4922384882*r**18+25153778*r**20)+2*Q2**14*(45441000-816525219*r**2-12436044120*r**4
            +108385242663*r**6+412173831462*r**8+1246305572796*r**10+1832857463502*r**12
            +1377181637232*r**14+429613472658*r**16+75122051295*r**18+12785084122*r**20
            +63447009*r**22)+4*Q2**13*(28748700+686758973*r**2+24034153640*r**4+30975280223*r**6
            +127757706961*r**8-118250027566*r**10-621436689468*r**12-800142266474*r**14
            -548090978314*r**16-100580856087*r**18-27634371188*r**20-1655382637*r**22
            +25532453*r**24)-2*Q2**12*(121122144+987001847*r**2+59579510354*r**4
            +328581634676*r**6+1610139222480*r**8+3458459706537*r**10+4168823558020*r**12
            +3995339392664*r**14+2196434429208*r**16+652009755025*r**18+354610677802*r**20
            +4424577508*r**22+10337037048*r**24+155770303*r**26)+4*Q2**11*(31386420
            -24559472*r**2+12474316946*r**4+231307151582*r**6+1136128711943*r**8
            +3708963216136*r**10+5775236989637*r**12+7460750155044*r**14+6365849224198*r**16
            +3238493271344*r**18+1124563674216*r**20+332870316638*r**22+23791326351*r**24
            +6335493112*r**26+55828017*r**28)+4*Q2**10*(25266267+443632186*r**2+18236167659*r**4
            -112307566516*r**6-271989447142*r**8-3097084550801*r**10-4537396749964*r**12
            -7678862302469*r**14-8839903586509*r**16-6300058585284*r**18-2535476092761*r**20
            -950596601722*r**22-186064896856*r**24-26447349461*r**26-1061240534*r**28
            +12847427*r**30)-4*Q2**9*(45685800+466338089*r**2+34804641940*r**4+116404688299*r**6
            +1191854347847*r**8+118709868125*r**10+3502410977810*r**12+4025263342807*r**14
            +2010102954021*r**16-509914552573*r**18-1200084113112*r**20+104176122297*r**22
            -277066973463*r**24+58483784119*r**26-20206127790*r**28+3677339461*r**30
            +47407203*r**32)+2*Q2**8*(39726450+344718077*r**2+42712113172*r**4+438538634254*r**6
            +2906321078682*r**8+4824455448068*r**10+17806946600368*r**12+33675596208210*r**14
            +39267779761754*r**16+32171722170394*r**18+13825339006356*r**20+3057582704978*r**22
            +2435068568422*r**24+62427172812*r**26+255826761064*r**28-17605497714*r**30
            +6522313972*r**32+50908761*r**34)+4*Q2**7*(10277928+115128287*r**2+5227842067*r**4
            -117369026250*r**6-184849413995*r**8-2474644963156*r**10-2788862795793*r**12
            -14950140579806*r**14-17491810825927*r**16-22452425330610*r**18-15145909592039*r**20
            -5837044372294*r**22-838765131585*r**24-976243826204*r**26-146870744475*r**28
            -43250233938*r**30-7133338485*r**32-279457021*r**34+7701696*r**36)+Q2**6*(
            -64416060-736571321*r**2-69458013030*r**4-96882874365*r**6-3561727951484*r**8
            +8751658749288*r**10-35558045124644*r**12+28721849799560*r**14-30289660300020*r**16
            +2702536567246*r**18+39453719823264*r**20+16658196219366*r**22+17169910415500*r**24
            +3631541898320*r**26+4697755838980*r**28+1583850727888*r**30-93534793696*r**32
            +63661889075*r**34-4797845530*r**36-64188737*r**38)+2*Q2**5*(13031604
            +187776613*r**2+21130475625*r**4+128301705435*r**6+1419372501261*r**8
            -3341617091804*r**10+24943724123140*r**12-19153623069060*r**14+48964439232260*r**16
            +27602674452886*r**18+10591370307470*r**20-25017965984374*r**22+3347659515310*r**24
            -10057584155820*r**26-2060258445260*r**28-2224904735604*r**30-866671094304*r**32
            +38698070925*r**34-20649046575*r**36+1505212563*r**38+13409709*r**40)
            +2*(-1+r**2)**4*(34659+722705*r**2+108983873*r**4+445530300*r**6+9028694702*r**8
            -81778006377*r**10+719397325476*r**12-3534479482064*r**14+11133706665250*r**16
            -17252093878806*r**18+5099830356782*r**20+15755349941032*r**22-14782890559416*r**24
            +5272665813550*r**26-1816517236044*r**28+165812414256*r**30-48893902237*r**32
            -12250845643*r**34-246027975*r**36-143926852*r**38+3984930*r**40+37899*r**42)
            +Q2**4*(3741300-18170649*r**2-1319927280*r**4-131272748878*r**6-162212251456*r**8
            +318254849331*r**10-16906210214352*r**12+31896247205464*r**14-73695371695432*r**16
            +5169426760542*r**18+26395731106736*r**20-34671131354196*r**22+77501996828912*r**24
            -10810216527602*r**26+6456922405584*r**28+2428167270360*r**30+957929963444*r**32
            +500092838779*r**34+10929006912*r**36+557737330*r**38-133022352*r**40
            +4437503*r**42)-2*Q2*(-1+r**2)**2*(396000+6633677*r**2+1014664621*r**4
            +2618079884*r**6+80642612988*r**8-660176777173*r**10+5000723732403*r**12
            -20258873122584*r**14+51013630879448*r**16-51618054103094*r**18-20941822100006*r**20
            +54846589719744*r**22+27996019632016*r**24-54818136264098*r**26+23148297139774*r**28
            -9487436899944*r**30+1077889587720*r**32-275563172039*r**34-89814530359*r**36
            +192673332*r**38-1338610252*r**40+42513831*r**42+434111*r**44)-2*Q2**3*(4148100
            +40950092*r**2+6211485451*r**4-11378765932*r**6+459907618232*r**8-2470254740392*r**10
            +10864373155817*r**12-22255082860112*r**14+25730924729616*r**16+829256522104*r**18
            +6654082618966*r**20+21138875931672*r**22-47437051581960*r**24-4591264598736*r**26
            +12701496713146*r**28-12155515642256*r**30+2203719740012*r**32-672497603748*r**34
            -255656757073*r**36+18162185268*r**38-7778581168*r**40+335315032*r**42
            +4577869*r**44)+2*Q2**2*(1860921+23456625*r**2+3775736972*r**4+1392908336*r**6
            +289222186475*r**8-2212685382853*r**10+13962686641812*r**12-48178138257620*r**14
            +102955593845170*r**16-97569848198270*r**18+21973992031888*r**20-32766019650616*r**22
            +84976954684078*r**24+22832780411694*r**26-83961339510560*r**28+44970935625024*r**30
            -19405243397179*r**32+2888589426941*r**34-477006048892*r**36-258265158520*r**38
            +10359667895*r**40-5038909017*r**42+180225004*r**44+2044692*r**46))*sqrtq2)*math.log(r))/(235146240000*logq2**5*(
            -Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +5443200000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+11340000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-470292480000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-48988800000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-340200000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -157500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*sqrtq2)
            +(flagPERP*(518400*logq2**4*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(5664
            -16995*r**2+630*Q2**7*r**2+419633*r**4-943589*r**6-2284593*r**8-1779977*r**10
            -687613*r**12+46329*r**14+75141*r**16-10*Q2**6*(128+525*r**2+909*r**4)
            +10*Q2**5*(1104+1797*r**2+4936*r**4+4005*r**6)-2*Q2**4*(22368+24197*r**2
            +52141*r**4+93661*r**6+47637*r**8)+Q2**3*(42624+152665*r**2+312044*r**4
            +508466*r**6+476524*r**8+134361*r**10)-Q2**2*(-16864+146753*r**2+325069*r**4
            +597974*r**6+769814*r**8+429213*r**10+26289*r**12)-Q2*(30176-111367*r**2
            +155052*r**4+414267*r**6+187464*r**8-20629*r**10+86508*r**12+119529*r**14))
            +288*logq2**2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-47216-313607*r**2
            +254970*Q2**13*r**2-6960065*r**4-10221580*r**6-12784132*r**8-1487557843*r**10
            +2402280539*r**12-7723283920*r**14-11173560640*r**16-2644997261*r**18
            +1856898709*r**20+114589468*r**22+83926260*r**24+4035495*r**26+395793*r**28
            -6*Q2**12*(-64+421179*r**2+420987*r**4)+36*Q2**11*(-5508+283160*r**2
            +599047*r**4+272144*r**6)-12*Q2**10*(-69712+1495011*r**2+5975640*r**4
            +5967460*r**6+1381551*r**8)+5*Q2**9*(-188656+1594553*r**2+21011528*r**4
            +36414114*r**6+21675960*r**8+979353*r**10)+15*Q2**8*(-51248+1033987*r**2
            -1947973*r**4-5306490*r**6-6410634*r**8-2596597*r**10+1572243*r**12)
            -6*Q2**7*(-402912+2742642*r**2+18566581*r**4+96604370*r**6+158147170*r**8
            +83267418*r**10+20689877*r**12+5235546*r**14)+2*Q2**6*(-599312-3701090*r**2
            +61350883*r**4+546061231*r**6+1481797900*r**8+1461603568*r**10+477798675*r**12
            +96968823*r**14+2227266*r**16)+6*Q2**5*(-196288+2388144*r**2+622995*r**4
            -48592540*r**6-415624591*r**8-784918728*r**10-459092111*r**12-15299580*r**14
            -8486125*r**16+3195024*r**18)-30*Q2**4*(-49696-26182*r**2+1559423*r**4
            +20782477*r**6+13805527*r**8-86447785*r**10-109950561*r**12-7778681*r**14
            +34420989*r**16+3688675*r**18+486198*r**20)+10*Q2**3*(-29368-681310*r**2
            -852943*r**4+30623766*r**6+152182332*r**8+252337680*r**10+171428918*r**12
            +89570528*r**14+157100372*r**16+67698366*r**18+8592753*r**20+68346*r**22)
            +6*Q2**2*(-59376+216296*r**2+1992743*r**4+19794455*r**6-124428660*r**8
            -782215248*r**10-1372469722*r**12-1307337746*r**14-515836600*r**16-309448960*r**18
            +29109579*r**20+867731*r**22+669108*r**24)-3*Q2*(-79504-369515*r**2
            -4035114*r**4+24655462*r**6+131242510*r**8+27103803*r**10+1285275820*r**12
            +547672468*r**14+385601916*r**16+797139515*r**18-199250274*r**20+97176870*r**22
            +6750246*r**24+715797*r**26))+(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(2457
            +20598*Q2**19-45183*r**2-9537843*r**4-1361707*r**6-508302120*r**8-2472736248*r**10
            +2418346656*r**12-44685301296*r**14-176773390542*r**16+641431807858*r**18
            -1386894518430*r**20+480694330722*r**22-78393450704*r**24+26824149120*r**26
            +2448339624*r**28+229743096*r**30+80981805*r**32+105093*r**34-42871*r**36
            +513*r**38-90906*Q2**18*(1+r**2)+18*Q2**17*(3915+22676*r**2+3915*r**4)
            +2*Q2**16*(45297-130187*r**2-293195*r**4+99633*r**6)-Q2**15*(-374043
            +2532356*r**2+16013554*r**4+1404164*r**6+190053*r**8)+Q2**14*(-1575699
            +5722769*r**2+118581998*r**4+108327950*r**6+7428385*r**8-548259*r**10)
            +Q2**13*(1309143+5197800*r**2-289803763*r**4-703899648*r**6-259405219*r**8
            -9122712*r**10+723303*r**12)+Q2**12*(848145-23607359*r**2+217186539*r**4
            +1658674843*r**6+1682637059*r**8+180760147*r**10-6133879*r**12+555225*r**14)
            -Q2**11*(1464357+6852340*r**2-263818368*r**4+1043289420*r**6+2239240438*r**8
            +1292301260*r**10-345072640*r**12-21666700*r**14+1227813*r**16)+Q2**10*(
            -92379+75594649*r**2-545390420*r**4-2030711324*r**6-5939772334*r**8
            -4409688750*r**10-1942006108*r**12-787355284*r**14-8359943*r**16+52869*r**18)
            +Q2**9*(761079-54901368*r**2+8405999*r**4+3328260800*r**6+17196681610*r**8
            +33783208816*r**10+13473181482*r**12+4620148544*r**14+334795615*r**16
            -14859320*r**18+838599*r**20)-Q2**8*(302943+55395087*r**2-667587161*r**4
            +552790279*r**6+9367556002*r**8+58549961522*r**10+60388875266*r**12+5987434674*r**14
            +2279954879*r**16-627351553*r**18-13053417*r**20+304263*r**22)+Q2**7*(164625
            +83435284*r**2-357177978*r**4-1031986876*r**6-11504040193*r**8+11007717736*r**10
            +44054626836*r**12+23685986152*r**14-15011687681*r**16-2227296188*r**18
            -772942714*r**20+1117204*r**22-234735*r**24)+Q2**6*(-3993-4952653*r**2
            -425024946*r**4+189595902*r**6+14963029781*r**8+72554989489*r**10+163778624500*r**12
            +111184896564*r**14+73038754721*r**16+19808660261*r**18+3466991518*r**20
            +16183982*r**22-4979005*r**24+143703*r**26)-Q2**5*(265371+41204360*r**2
            -423584067*r**4+470868480*r**6-2617382457*r**8+50473954232*r**10+204193468097*r**12
            +402011659392*r**14+113278270801*r**16+91626683320*r**18-966270761*r**20
            +1445372416*r**22-418602995*r**24-2916728*r**26+9579*r**28)+Q2**4*(144147
            +19704099*r**2+71114853*r**4+668784725*r**6-10439588745*r**8-20412475097*r**10
            -43641283583*r**12+274326633809*r**14+413348569065*r**16-113130954535*r**18
            +5166088703*r**20-16463343601*r**22-797839667*r**24-184153315*r**26-1046565*r**28
            +2187*r**30)+Q2**3*(59331+3780068*r**2-187120948*r**4+106587852*r**6
            -898711604*r**8+7826818564*r**10+82615201460*r**12+63357385036*r**14
            -135166400414*r**16-162882978612*r**18+127428812084*r**20+40784866436*r**22
            +6990763212*r**24+1188843852*r**26-53628084*r**28-608924*r**30+7491*r**32)
            -Q2**2*(51615+5315843*r**2-34073144*r**4+330955792*r**6-4363126984*r**8
            +489276848*r**10+21610588352*r**12+225146943208*r**14+564114653366*r**16
            +149519559158*r**18+365153425704*r**20-11342048768*r**22+23140560496*r**24
            -4158772488*r**26+262998096*r**28-50996472*r**30-757757*r**32+10335*r**34)
            +Q2*(2631+1314992*r**2+26233243*r**4+106836352*r**6-17543568*r**8+4086157376*r**10
            -35990284952*r**12-67996295936*r**14-136701978890*r**16+327283019616*r**18
            -785879444330*r**20+319806881408*r**22-70286638552*r**24+2322999744*r**26
            -2890964048*r**28-204074752*r**30-8508373*r**32-113680*r**34+1719*r**36))
            -217728000*logq2**5*r**18*(-200+145*r**2+1012*r**4+882*r**6+540*r**8
            +81*r**10)*sqrtq2+17280*logq2**3*r**10*(24780*Q2**12*r**2-120*Q2**11*(32
            +2595*r**2+2691*r**4)+48*Q2**10*(909+36018*r**2+72524*r**4+37836*r**6)
            -80*Q2**9*(1281+68007*r**2+197359*r**4+201712*r**6+68691*r**8)+15*Q2**8*(
            -680+624931*r**2+2462364*r**4+3745126*r**6+2535556*r**8+587315*r**10)
            -20*Q2**7*(-12372+374781*r**2+2087017*r**4+4491606*r**6+4643586*r**8
            +2224229*r**10+244737*r**12)-160*Q2**6*(525+3486*r**2-68041*r**4-351694*r**6
            -525883*r**8-395348*r**10-101234*r**12+40866*r**14)+12*Q2**5*(-35812
            +507101*r**2+2009893*r**4+2227767*r**6+2201295*r**8+2585523*r**10+1577451*r**12
            +1454313*r**14+1081717*r**16)-10*Q2**4*(-47928+413829*r**2+2446028*r**4
            +8618742*r**6+19286412*r**8+26520762*r**10+20182860*r**12+7494918*r**14
            +2451844*r**16+687357*r**18)-20*Q2**3*(1140+13317*r**2-205727*r**4-3980144*r**6
            -7310360*r**8-13084066*r**10-15182986*r**12-8777840*r**14-2018428*r**16
            -792403*r**18+103545*r**20)+120*Q2**2*(-1862+13607*r**2+37312*r**4-393040*r**6
            +615680*r**8+550445*r**10-66496*r**12-280035*r**14+74686*r**16+337296*r**18
            -60536*r**20+33943*r**22)+(-1+r**2)**2*(-22488+30273*r**2+213966*r**4
            -6059043*r**6+20618248*r**8-84888030*r**10-155288556*r**12-91460606*r**14
            -8633472*r**16+14613837*r**18+649678*r**20+266193*r**22)-20*Q2*(-6432
            +35547*r**2+91627*r**4-1218573*r**6+4151043*r**8-8275806*r**10-26134830*r**12
            -22617534*r**14-9896238*r**16-675309*r**18+2545107*r**20-79333*r**22
            +88731*r**24))*sqrtq2-12*logq2*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -2712+287439*r**2-238104*Q2**16*r**2+4900184*r**4+10162132*r**6+497223864*r**8
            -388793812*r**10+4903653544*r**12+41543999724*r**14-90886900584*r**16
            +195164676522*r**18+131529237480*r**20-58690729940*r**22+3872425160*r**24
            -4173200148*r**26-165013736*r**28-48408556*r**30-2352768*r**32+36207*r**34
            +16*Q2**15*(-4352+151701*r**2+138645*r**4)-16*Q2**14*(-25686+517545*r**2
            +1283702*r**4+466173*r**6)+32*Q2**13*(-25797+332281*r**2+2114081*r**4
            +2060996*r**6+306981*r**8)+Q2**12*(202856+1708351*r**2-85903156*r**4
            -156555506*r**6-87507260*r**8+2814687*r**10)-4*Q2**11*(-422464+3694859*r**2
            +6484463*r**4+45325634*r**6+33362354*r**8+5843407*r**10+5880699*r**12)
            +2*Q2**10*(-1174024+549571*r**2+85334662*r**4+639309361*r**6+1198799972*r**8
            +551615169*r**10+110882710*r**12+11183571*r**14)+4*Q2**9*(-6088+5556545*r**2
            -22252209*r**4-410919631*r**6-1613997185*r**8-1575770833*r**10-359844895*r**12
            -55137889*r**14+1688409*r**16)-Q2**8*(-2538008+13910839*r**2+102818064*r**4
            +54873344*r**6-5713077616*r**8-11571455758*r**10-6174435776*r**12+313981504*r**14
            +61814104*r**16+27276759*r**18)+8*Q2**7*(-224864-1718169*r**2+3960199*r**4
            +192721124*r**6+431493580*r**8+688585378*r**10+284038266*r**12+335685764*r**14
            +286466684*r**16+30896815*r**18+1861047*r**20)+4*Q2**6*(-144128+4646441*r**2
            +34104206*r**4-184985647*r**6-2463547672*r**8-9829372794*r**10-15030106684*r**12
            -7774343194*r**14-3006567672*r**16-418407567*r**18-29882146*r**20+1917801*r**22)
            -8*Q2**5*(-157924+225359*r**2+5353541*r**4+73320413*r**6-346886749*r**8
            -3215115490*r**10-11369824342*r**12-11127769486*r**14-2332004022*r**16
            -931884349*r**18+74252225*r**20+6546721*r**22+1523943*r**24)+Q2**4*(
            -379624-8053535*r**2-104498132*r**4+562203742*r**6+3902777140*r**8+15754990063*r**10
            -21767453480*r**12-101722298076*r**14-45148837984*r**16+24545508815*r**18
            +4260298556*r**20+1508646750*r**22+69858388*r**24+3208257*r**26)+4*Q2**3*(
            -53376+1149193*r**2+15158493*r**4+23832418*r**6-53435502*r**8-3272701413*r**10
            -8224444801*r**12-4639433876*r**14+7543003244*r**16-3659209521*r**18
            -6213214101*r**20-1402511342*r**22-142526622*r**24-5563667*r**26+558873*r**28)
            +2*Q2**2*(77528+164963*r**2+10249582*r**4-102552843*r**6-539164740*r**8
            +329288495*r**10+16689289154*r**12+61834524761*r**14+75216986816*r**16
            +30390588585*r**18+31671019986*r**20-269147777*r**22+361278572*r**24
            -151529083*r**26-2091330*r**28-755469*r**30)+4*Q2*(-5336-270731*r**2
            -5784093*r**4+5361281*r**6-173740249*r**8+949921405*r**10+3432897851*r**12
            +4839043361*r**14+8277673463*r**16+4466252503*r**18+21138736753*r**20
            -8336448469*r**22+2365991757*r**24+166280631*r**26+67419121*r**28+1825203*r**30
            +45549*r**32))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(-31352832000*logq2**5*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-725760000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            -1512000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5+62705664000*logq2**6*r**24*sqrtq2
            +6531840000*logq2**4*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+45360000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2+21000*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*sqrtq2)
            +((-518400*logq2**4*r**12*(210*Q2**9*(2+5*r**4)-10*Q2**8*(786+1010*r**2
            +2061*r**4+1725*r**6)+20*Q2**7*(2472+6092*r**2+10079*r**4+11189*r**6
            +4905*r**8)-4*Q2**6*(43512+147242*r**2+264114*r**4+331281*r**6+244453*r**8
            +76860*r**10)+Q2**5*(322308+1350816*r**2+2684769*r**4+3789270*r**6+3618476*r**8
            +2186202*r**10+579915*r**12)-Q2**4*(259980+1323884*r**2+2880179*r**4
            +4497973*r**6+5168142*r**8+4333866*r**10+2368495*r**12+565425*r**14)
            +2*Q2**3*(-13860+172948*r**2+614096*r**4+1103904*r**6+1449595*r**8+1651526*r**10
            +977872*r**12+274010*r**14+27825*r**16)+(-1+r**2)**2*(25992+55344*r**2
            +664923*r**4+3156809*r**6+4955557*r**8+5256375*r**10+2339713*r**12-125821*r**14
            +181023*r**16+96885*r**18)+2*Q2**2*(98700+82228*r**2-14263*r**4+599438*r**6
            +810340*r**8+853055*r**10-101875*r**12-242668*r**14+471270*r**16+211575*r**18)
            -Q2*(125952+63416*r**2+1126687*r**4+7867802*r**6+15922196*r**8+20380202*r**10
            +16370518*r**12+4583462*r**14-898548*r**16+520878*r**18+364635*r**20))
            -288*logq2**2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(90*Q2**15*(687+3520*r**4)
            -6*Q2**14*(124455+124343*r**2+546456*r**4+630480*r**6)+6*Q2**13*(567105
            +1150522*r**2+3018451*r**4+5427984*r**6+3109320*r**8)-6*Q2**12*(1260975
            +4168683*r**2+10001003*r**4+21347567*r**6+22146476*r**8+7864980*r**10)
            +Q2**11*(7415580+46001272*r**2+108578467*r**4+274883254*r**6+386289468*r**8
            +277883754*r**10+57377745*r**12)-Q2**10*(-2045280+39766508*r**2+36264499*r**4
            +210424909*r**6+386442374*r**8+402707574*r**10+271791171*r**12+2209005*r**14)
            -Q2**9*(13035840+7331084*r**2+301261993*r**4+620443200*r**6+956547715*r**8
            +1338787400*r**10+762416319*r**12+56218428*r**14+88978365*r**16)+Q2**8*(11843340
            +58227536*r**2+669033683*r**4+2133684617*r**6+4011447665*r**8+6432439235*r**10
            +6366660281*r**12+2893731843*r**14+495644367*r**16+107809785*r**18)-2*Q2**7*(
            -54975+29905952*r**2+234021367*r**4+1391101978*r**6+3085737364*r**8
            +5593892950*r**10+7123742662*r**12+5006811242*r**14+1507617363*r**16
            +278297094*r**18+11884995*r**20)+2*Q2**6*(-3988005+6847303*r**2-142936597*r**4
            +758685741*r**6+1376534262*r**8+2919322326*r**10+5683572768*r**12+6255671408*r**14
            +2836658251*r**16-301714713*r**18+59072721*r**20-29216745*r**22)+2*Q2**5*(2836875
            +12144058*r**2+353846074*r**4+237057124*r**6+3238328799*r**8+8683027164*r**10
            +10064650794*r**12+6386675944*r**14+1768112659*r**16+1183579474*r**18
            +1924605804*r**20+152657196*r**22+29019555*r**24)-2*Q2**4*(225465+11526929*r**2
            +193206148*r**4+713230210*r**6+4981773305*r**8+14604908475*r**10+21711848322*r**12
            +23469256634*r**14+17653416625*r**16+8274060145*r**18+2941277810*r**20
            +1361391324*r**22+142018293*r**24+6840315*r**26)+Q2**3*(-1470720+5629832*r**2
            -84920789*r**4+1041102654*r**6+1418990140*r**8+10871126690*r**10+20777483631*r**12
            +27205797188*r**14+28532753992*r**16+13805491140*r**18+7037419105*r**20
            +4776705662*r**22-175488324*r**24+43662354*r**26-11456955*r**28)+(-1
            +r**2)**2*(20640+357172*r**2+15127855*r**4+29715199*r**6+748259144*r**8
            -633916180*r**10+7235019191*r**12+30874593455*r**14+20231739272*r**16
            -2570582188*r**18+960905245*r**20+2521271437*r**22+250444240*r**24+116256204*r**26
            +4817469*r**28+451845*r**30)+Q2**2*(894900+2399752*r**2+198748477*r**4
            -353051117*r**6+5438494634*r**8-2558627110*r**10-13823787769*r**12-15636714679*r**14
            -27331026736*r**16-24293487628*r**18+9307943515*r**20+10229682517*r**22
            -2176716398*r**24+1143231978*r**26+57275169*r**28+10260495*r**30)-Q2*(221820
            +1738628*r**2+90854173*r**4-50911064*r**6+3682686267*r**8-4760061424*r**10
            +10039986089*r**12+77363921564*r**14+104244146783*r**16+52657711316*r**18
            -13874171817*r**20-394721072*r**22+9887178913*r**24-370499944*r**26+586820067*r**28
            +29609196*r**30+3410505*r**32))-(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(20598*Q2**21
            -18*Q2**20*(4971+7339*r**2)+12*Q2**19*(12528+43015*r**2+22740*r**4)
            -4*Q2**18*(-14283+146974*r**2+260506*r**4+8145*r**6)-3*Q2**17*(958127
            +767862*r**2+5860156*r**4+377338*r**6+172705*r**8)+Q2**16*(15215511
            +11407853*r**2+108870186*r**4+154575102*r**6+12261235*r**8+31113*r**10)
            +2*Q2**15*(-18678159-9208626*r**2-78680676*r**4-392718530*r**6-263687393*r**8
            -14896640*r**10+814884*r**12)-6*Q2**14*(-6799212-3383105*r**2+65818145*r**4
            -185404110*r**6-416824442*r**8-138946697*r**10-4180015*r**12+239940*r**14)
            -6*Q2**13*(-1747559+12469802*r**2-359445699*r**4-343334154*r**6+256910171*r**8
            +626228570*r**10+35975407*r**12-3646082*r**14+269160*r**16)+2*Q2**12*(
            -43495776+105987329*r**2-2376674635*r**4-6052272891*r**6-7467190339*r**8
            -4197042013*r**10+306584619*r**12-736874653*r**14-30288349*r**16+1531860*r**18)
            +6*Q2**11*(15572479-39216994*r**2+951218174*r**4+4528806562*r**6+8426680080*r**8
            +10891621946*r**10+5590899982*r**12+1189243646*r**14+406921729*r**16
            +4700520*r**18-82492*r**20)-2*Q2**10*(-656496+45712861*r**2+558942567*r**4
            +17239147380*r**6+36947174748*r**8+70053940026*r**10+70745461230*r**12
            +20418903060*r**14+5584754196*r**16+426854361*r**18-17091349*r**20+964296*r**22)
            +2*Q2**9*(-46533726+268666400*r**2-4144991305*r**4+8809929920*r**6+9146990563*r**8
            +47393718556*r**10+76520663510*r**12+67872797380*r**14-4647640760*r**16
            +2518055828*r**18-930386861*r**20-21901460*r**22+606195*r**24)+6*Q2**8*(12932491
            -85516448*r**2+2127384209*r**4+2780645887*r**6+18360818162*r**8+27831577717*r**10
            +31820938678*r**12+29943087778*r**14+6353591627*r**16+12737396062*r**18
            +834996809*r**20+393781487*r**22+1472648*r**24+51485*r**26)-2*Q2**7*(
            -2495811+30334054*r**2+2391952728*r**4+19055513862*r**6+76292446257*r**8
            +231435960612*r**10+359458283916*r**12+439022207964*r**14+292571304735*r**16
            +120534078462*r**18+34487767320*r**20+4523531454*r**22+197591667*r**24
            -7072744*r**26+265860*r**28)+2*Q2**6*(-23313924+247262097*r**2-3551037033*r**4
            +16240644050*r**6+4146651310*r**8+259916121391*r**10+400314622577*r**12
            +679945055800*r**14+618107545744*r**16+118806338015*r**18+115324227625*r**20
            -6435467654*r**22+2705411750*r**24-551304127*r**26-6690385*r**28+82524*r**30)
            -6*Q2**5*(-4284672+54924982*r**2-1518265589*r**4+1989564010*r**6-26321584405*r**8
            +41291502386*r**10-64863798921*r**12-9702424298*r**14+86557572671*r**16
            +143511853194*r**18-98737769871*r**20+6824500614*r**22-10476330271*r**24
            -107749554*r**26-132025267*r**28-883526*r**30+1077*r**32)-2*Q2**4*(-1198047
            +18782430*r**2+1191640425*r**4+3938011125*r**6+66952064089*r**8+41951131557*r**10
            +733159215705*r**12+939315872565*r**14+885479852955*r**16+789847975257*r**18
            -82683073533*r**20+339380739015*r**22+45607780395*r**24+16373583095*r**26
            +1631134779*r**28+11467023*r**30-475200*r**32+11565*r**34)+2*Q2**3*(
            -3797841+67612948*r**2-1119711062*r**4+7328959842*r**6-7322219598*r**8
            +110273745174*r**10+166690562582*r**12+408344951746*r**14+572352876736*r**16
            +199871644046*r**18+454944209650*r**20+317225826262*r**22+17463494894*r**24
            +45494003282*r**26-4822525198*r**28+852558342*r**30-88977167*r**32-1255178*r**34
            +14940*r**36)+(-1+r**2)**2*(-70353+3361137*r**2-3381621*r**4+565473101*r**6
            +4281210600*r**8-19872491328*r**10+184160281680*r**12-566270532120*r**14
            +1865614985598*r**16+742058085418*r**18-1108760903970*r**20+666220766154*r**22
            -88445257712*r**24+37853824296*r**26+3962655144*r**28+337848576*r**30
            +87039579*r**32+176253*r**34-46945*r**36+513*r**38)-6*Q2**2*(-433406
            +7795369*r**2-292700749*r**4+1268012930*r**6-12733703072*r**8+38247318000*r**10
            -166068035424*r**12+239391580880*r**14+178083496396*r**16+507845767954*r**18
            +125807760518*r**20-364814488644*r**22+174661811712*r**24-55410294872*r**26
            +6028953608*r**28-2399707312*r**30-24654126*r**32-12130643*r**34-175329*r**36
            +2210*r**38)+Q2*(-90135-4140958*r**2-352263114*r**4+383569326*r**6
            -35272544735*r**8+140814523344*r**10-886235742456*r**12+2217838939696*r**14
            -3225525871854*r**16-5694920961180*r**18-697476478140*r**20+3575883902076*r**22
            -2774211460470*r**24+692688756800*r**26-196289326200*r**28-59483712*r**30
            -4046224987*r**32-377647062*r**34-9523722*r**36-29210*r**38+693*r**40))
            -217728000*logq2**5*r**16*(231+938*r**2+1808*r**4+2150*r**6+2277*r**8
            +504*r**10)*sqrtq2-17280*logq2**3*r**8*(30*Q2**12*(279+1105*r**4)-420*Q2**11*(243
            +259*r**2+921*r**4+1005*r**6)+12*Q2**10*(47178+95343*r**2+204576*r**4
            +344312*r**6+195795*r**8)-20*Q2**9*(80109+239880*r**2+481587*r**4+876178*r**6
            +903748*r**8+351030*r**10)+15*Q2**8*(151035+647998*r**2+1443760*r**4
            +2742138*r**6+3664125*r**8+2649224*r**10+738860*r**12)-20*Q2**7*(46719
            +481440*r**2+1187304*r**4+2441119*r**6+3943173*r**8+4048782*r**10+2100248*r**12
            +300735*r**14)-20*Q2**6*(84357-130872*r**2+296046*r**4+1162540*r**6
            +764038*r**8-545258*r**10-1582708*r**12-434182*r**14+408135*r**16)+12*Q2**5*(217209
            +371714*r**2+4756148*r**4+15721471*r**6+25750690*r**8+27259049*r**10
            +18471864*r**12+6635653*r**14+2182481*r**16+1325785*r**18)-10*Q2**4*(108612
            +595770*r**2+6374841*r**4+23084516*r**6+43055064*r**8+55945464*r**10
            +53339556*r**12+34740288*r**14+13414644*r**16+3020794*r**18+831915*r**20)
            -20*Q2**3*(24930-160959*r**2-273465*r**4-3583814*r**6-9955874*r**8-14326208*r**10
            -18161344*r**12-14869798*r**14-5228408*r**16-2332105*r**18-819967*r**20
            +127620*r**22)+60*Q2**2*(11751-8695*r**2+605698*r**4+100520*r**6-1264182*r**8
            -855442*r**10-1688906*r**12-3178692*r**14-2419751*r**16+1985321*r**18
            +1171472*r**20-77124*r**22+82430*r**24)+(-1+r**2)**2*(41481+151428*r**2
            +5642187*r**4+676260*r**6+67435518*r**8+299440504*r**10+389445558*r**12
            +202708848*r**14-3740435*r**16+13210932*r**18+19840815*r**20+1230364*r**22
            +324540*r**24)-20*Q2*(14130+10758*r**2+1248813*r**4-682187*r**6+4898601*r**8
            +37865241*r**10+66691422*r**12+64227870*r**14+25585656*r**16-5893092*r**18
            +1656213*r**20+3529389*r**22+21101*r**24+107685*r**26))*sqrtq2+logq2*(1200*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*(216+105*Q2**7-5322*r**2-111984*r**4-82010*r**6
            +1662425*r**8+2532819*r**10+675257*r**12+45979*r**14-1200*r**16-5*Q2**6*(
            -81+31*r**2+240*r**4)+15*Q2**5*(-29-16*r**2+59*r**4+60*r**6)-Q2**4*(
            -321+243*r**2+50107*r**4+69411*r**6+9180*r**8)+Q2**3*(-624-1662*r**2
            +61810*r**4+163882*r**6+104839*r**8+11400*r**10)+Q2**2*(-414-1424*r**2
            +12832*r**4-28772*r**6-36231*r**8+26019*r**10+5940*r**12)+Q2*(426
            -5234*r**2-72620*r**4+90200*r**6+486565*r**8+305854*r**10-12501*r**12
            -6660*r**14))-252*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))**2*(48*Q2**10*(4+41*r**4)-48*Q2**9*(15
            +15*r**2+241*r**4+305*r**6)+Q2**8*(675+1350*r**2+20667*r**4+53440*r**6
            +34920*r**8)-24*Q2**7*(-20+60*r**2+443*r**4+2501*r**6+3145*r**8+895*r**10)
            -12*Q2**6*(75-150*r**2+3356*r**4-1298*r**6-6369*r**8-4276*r**10+2910*r**12)
            -24*Q2**3*r**4*(2293-3645*r**2-11327*r**4-21391*r**6-22491*r**8-16137*r**10
            -5635*r**12+1005*r**14)+8*Q2**5*(-18+270*r**2+14538*r**4+21131*r**6
            +23238*r**8+11628*r**10-4438*r**12+6723*r**14)-6*Q2**4*(-95+930*r**2
            +11077*r**4+26540*r**6+70585*r**8+139978*r**10+94025*r**12+7732*r**14
            +1060*r**16)+24*Q2*r**4*(608-7379*r**2-78584*r**4-141118*r**6-82626*r**8
            +34206*r**10+24448*r**12-18922*r**14-2998*r**16+205*r**18)-3*(-1+r**2)**2*(
            -9+252*r**2+2032*r**4-46052*r**6-261254*r**8-334484*r**10+79984*r**12
            +67924*r**14-42497*r**16-11000*r**18+784*r**20)+4*Q2**2*(-45+810*r**2
            +8748*r**4-35234*r**6+19518*r**8-68982*r**10-189638*r**12+25302*r**14
            +110571*r**16-9200*r**18+2070*r**20))+24*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(30*Q2**15*(3456
            +39445*r**4)-6*Q2**14*(73200+78688*r**2+1280487*r**4+1572495*r**6)+2*Q2**13*(197820
            +643086*r**2+8337915*r**4+20131384*r**6+12163965*r**8)-6*Q2**12*(-117900
            +192168*r**2+2049159*r**4+9118211*r**6+10343387*r**8+2352995*r**10)
            +Q2**11*(-1219545-146733*r**2-24850959*r**4+9092945*r**6+3019964*r**8
            +12249668*r**10-36392820*r**12)+Q2**10*(-369135+3672222*r**2+63003180*r**4
            +134107090*r**6+442717435*r**8+470273440*r**10+67653368*r**12+49296480*r**14)
            +Q2**9*(1309725-4001619*r**2+75948984*r**4+28203080*r**6-696908385*r**8
            -1625037805*r**10-1167529824*r**12-140073256*r**14+21836940*r**16)+Q2**8*(197595
            -7303494*r**2-322522185*r**4-562583276*r**6-380518515*r**8+144626810*r**10
            +164563161*r**12+57619180*r**14+101744264*r**16-62071860*r**18)+2*Q2**7*(
            -505125+5725983*r**2+87205884*r**4+305814281*r**6+990806067*r**8+1193009815*r**10
            +1475010703*r**12+1654052049*r**14+1196590496*r**16+87651472*r**18+2581095*r**20)
            +2*Q2**6*(-43155+2489358*r**2+114924819*r**4-282215755*r**6-1449575204*r**8
            -3262607418*r**10-5448832282*r**12-4121365236*r**14-905303425*r**16-629480024*r**18
            -138410993*r**20+18810195*r**22)-2*Q2**5*(-286065+5846997*r**2+116236365*r**4
            -29902280*r**6+2645776575*r**8+5351320340*r**10+1700020850*r**12-6452482300*r**14
            -6183830845*r**16-374861625*r**18+1005047185*r**20+31035668*r**22+6096255*r**24)
            +2*Q2**4*(-12825-299814*r**2-2601606*r**4+552405595*r**6+5935070055*r**8
            +12142144435*r**10+16239010638*r**12+20833434442*r**14+20492332615*r**16
            +7415492520*r**18+12783240*r**20+822663851*r**22+113601339*r**24-5008485*r**26)
            +Q2**3*(-181485+5292447*r**2+59451705*r**4-730697867*r**6-1561291690*r**8
            -5438870970*r**10-17667352314*r**12-20463099970*r**14-19771511101*r**16
            -39505652865*r**18-30415490895*r**20-4896904883*r**22+243654740*r**24
            -23682532*r**26+3937680*r**28)-(-1+r**2)**2*(7425-264672*r**2-631944*r**4
            +48141784*r**6+679419297*r**8+6747904360*r**10+51613335724*r**12+88847737408*r**14
            +48344815867*r**16-9524590544*r**18-5344575680*r**20+6358196248*r**22
            +1416170211*r**24+62734024*r**26-6681828*r**28+202320*r**30)+Q2**2*(22725
            -394458*r**2-19036464*r**4-333142546*r**6-4731464387*r**8+11329414500*r**10
            +39243193476*r**12+81531760008*r**14+87418180647*r**16+11815193334*r**18
            -29467233480*r**20-9569789418*r**22+2537100631*r**24-442878976*r**26
            -70191372*r**28+1185780*r**30)+Q2*(30105-1195983*r**2+3443796*r**4
            +316230240*r**6+2335217069*r**8+3531551293*r**10+105777782356*r**12+286097476768*r**14
            +318643199155*r**16+69389855347*r**18-47538591716*r**20-5035000928*r**22
            +20864483311*r**24+2391149855*r**26+181089084*r**28+11081568*r**30-121320*r**32)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(
            -23514624000*logq2**5*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-544320000*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3-1134000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5
            +47029248000*logq2**6*r**24*sqrtq2+4898880000*logq2**4*r**16*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2*sqrtq2+34020000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            +15750*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*sqrtq2)+(flagPERP*(86400*logq2**3*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(-1442+7134*r**2-720*Q2**6*r**2
            +84890*r**4-404018*r**6-657838*r**8-299046*r**10+918*r**12+26202*r**14
            +80*Q2**5*(7+33*r**2+54*r**4)-16*Q2**4*(322+409*r**2+1314*r**4+1053*r**6)
            +Q2**3*(3878+38179*r**2+101957*r**4+114753*r**6+40377*r**8)-2*Q2**2*(
            -2009+16516*r**2+57826*r**4+98304*r**6+67143*r**8+8844*r**10)-Q2*(1862
            -4943*r**2+69723*r**4+66722*r**6+14292*r**8+23901*r**10+35643*r**12))
            +24*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(-101808*Q2**12*r**2
            +112*Q2**11*(-235+7788*r**2+7083*r**4)-32*Q2**10*(-3290+64939*r**2+164807*r**4
            +58359*r**6)+5*Q2**9*(-22190+222497*r**2+2320343*r**4+2296843*r**6+193347*r**8)
            +10*Q2**8*(-9135+163233*r**2-720222*r**4-1417474*r**6-877659*r**8+228249*r**10)
            -4*Q2**7*(-68250+246021*r**2+3084900*r**4+18420635*r**6+15563945*r**8
            +2880180*r**10+844641*r**12)+4*Q2**6*(-37590-454398*r**2+5093337*r**4
            +45300410*r**6+86340760*r**8+39146690*r**10+7131117*r**12+188202*r**14)
            +2*Q2**5*(-53130+526743*r**2+754419*r**4-18016617*r**6-192068745*r**8
            -200917545*r**10-7679297*r**12-4115181*r**14+770553*r**16)-20*Q2**4*(
            -9135-47187*r**2+539247*r**4+5701500*r**6-2653947*r**8-25664174*r**10
            -10768931*r**12+8782852*r**14+1008462*r**16+77553*r**18)+20*Q2**3*(-3570
            -26649*r**2-259614*r**4+437919*r**6+11230809*r**8+31457783*r**10+16570635*r**12
            +7067945*r**14+4640257*r**16+573402*r**18+28203*r**20)+4*Q2**2*(-8750
            -41502*r**2+1121175*r**4+7467970*r**6-75715320*r**8-378526980*r**10
            -578662466*r**12-287322900*r**14-122658570*r**16+8108370*r**18+1160955*r**20
            +68418*r**22)-Q2*(-41930-19061*r**2-3554431*r**4+2529925*r**6+169628365*r**8
            +522616090*r**10+462227662*r**12+188564902*r**14+945678100*r**16-90172965*r**18
            +37538865*r**20+2366549*r**22+397929*r**24)+2*(-5635+23581*r**2-761732*r**4
            -5251094*r**6-9261095*r**8-124733085*r**10+108127848*r**12-1593100436*r**14
            -959820297*r**16+281437795*r**18+59019420*r**20+6831146*r**22-327757*r**24
            +61341*r**26))-18144000*logq2**4*r**14*(-132+235*r**2+753*r**4+537*r**6
            +87*r**8)*sqrtq2+1440*logq2**2*r**6*(-22320*Q2**11*r**2+8*Q2**10*(308+29919*r**2
            +30843*r**4)-80*Q2**9*(-98+13657*r**2+26728*r**4+13461*r**6)+10*Q2**8*(
            -6531+226762*r**2+692076*r**4+692166*r**6+215847*r**8)-5*Q2**7*(-19992
            +381695*r**2+1833212*r**4+2916826*r**6+1938612*r**8+299007*r**10)-5*Q2**6*(
            -4032+68383*r**2-662395*r**4-2197288*r**6-2369744*r**8-997311*r**10
            +298179*r**12)+Q2**5*(-171528+1616041*r**2+3353352*r**4+8406375*r**6
            +12388600*r**8+6034527*r**10+1691256*r**12+3286017*r**14)-5*Q2**4*(-24612
            +110483*r**2+773417*r**4+6918843*r**6+17413577*r**8+16947389*r**10+6194119*r**12
            +964677*r**14+319419*r**16)+5*Q2**3*(4872-113389*r**2+359068*r**4+6222044*r**6
            +15034340*r**8+22482482*r**10+16773124*r**12+4389692*r**14+1036788*r**16
            -134109*r**18)+(-1+r**2)**2*(-2086-70565*r**2-228515*r**4-395120*r**6
            +2803540*r**8-53507918*r**10-56937050*r**12-12004400*r**14+7806130*r**16
            +621395*r**18+26589*r**20)+5*Q2**2*(-12432+71435*r**2-123183*r**4-693750*r**6
            +6511046*r**8+508632*r**10-2690928*r**12+172406*r**14+4000170*r**16
            -473763*r**18+189567*r**20)-5*Q2*(-4648-14167*r**2-49720*r**4+388973*r**6
            +2158784*r**8-23789134*r**10-42851296*r**12-26341726*r**14-4523224*r**16
            +5339685*r**18+113496*r**20+62577*r**22))*sqrtq2+(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(-252*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(-3+5*Q2**3
            +5*r**2-19*r**4+5*r**6-5*Q2**2*(1+r**2)+Q2*(-5+8*r**2-5*r**4))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**3+300*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(-115+200*Q2**6-4126*r**2+5499*r**4+16524*r**6-2201*r**8
            -486*r**10+25*r**12-150*Q2**5*(1+r**2)-6*Q2**4*(25-54*r**2+25*r**4)
            +Q2**3*(-115+309*r**2-111*r**4+25*r**6)+Q2**2*(-115-6*r**2+886*r**4
            -286*r**6+25*r**8)+Q2*(-115-1111*r**2+3466*r**4+666*r**6-411*r**8
            +25*r**10))+5*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(519+106368*Q2**12+148978*r**2
            -4355210*r**4-24654366*r**6-108019519*r**8-235022020*r**10-941645676*r**12
            -863776228*r**14+108485801*r**16+31887954*r**18+2573686*r**20-175742*r**22
            +4623*r**24-277896*Q2**11*(1+r**2)-8*Q2**10*(4479-91666*r**2+4479*r**4)
            +Q2**9*(365397-618385*r**2-1095889*r**4+524565*r**6)-3*Q2**8*(-63085
            +430316*r**2+2402130*r**4+280236*r**6+11955*r**8)-6*Q2**7*(49398-547333*r**2
            -2558841*r**4-2427681*r**6-657433*r**8+89226*r**10)-6*Q2**6*(46522-241527*r**2
            -2535242*r**4+832310*r**6-2751022*r**8-64631*r**10+518*r**12)+6*Q2**5*(11133
            -466166*r**2-2062990*r**4-1474713*r**6+3860227*r**8-3348834*r**10-827386*r**12
            +58089*r**14)+2*Q2**4*(86469-908955*r**2-9548664*r**4+22830555*r**6
            +81844082*r**8+21835107*r**10-9867120*r**12-272883*r**14+17505*r**16)
            -2*Q2**3*(-28290+191331*r**2+5569971*r**4+27883653*r**6+28438603*r**8
            +35798803*r**10+48342933*r**12-5978685*r**14-1498689*r**16+64530*r**18)
            -6*Q2**2*(6870-128157*r**2-441202*r**4+17509512*r**6+67670800*r**8+58934266*r**10
            +72682440*r**12+15281320*r**14-670134*r**16-91437*r**18+3802*r**20)
            +Q2*(-27387+800389*r**2+592821*r**4-60039771*r**6-278740498*r**8+37997982*r**10
            -501811218*r**12-250631746*r**14+37212621*r**16-1936227*r**18-711395*r**20
            +20829*r**22)))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(1088640000*logq2**4*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+15120000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +10500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-2612736000*logq2**5*r**20*sqrtq2
            -181440000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-630000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+((-43200*logq2**3*r**8*(-480*Q2**8*(2+5*r**4)
            +40*Q2**7*(213+262*r**2+501*r**4+480*r**6)-64*Q2**6*(693+1573*r**2
            +2359*r**4+2781*r**6+1365*r**8)+Q2**5*(101262+315639*r**2+505388*r**4
            +676170*r**6+626694*r**8+235935*r**10)-Q2**4*(90930+334451*r**2+551531*r**4
            +799778*r**6+1113412*r**8+939675*r**10+308175*r**12)+2*Q2**3*(-3150
            +51997*r**2+138424*r**4+226273*r**6+363050*r**8+356399*r**10+180060*r**12
            +41475*r**14)+(-1+r**2)**2*(7398+21041*r**2+486885*r**4+1920961*r**6
            +2605841*r**8+1393483*r**10-87465*r**12+54531*r**14+61965*r**16)+Q2**2*(65100
            -20466*r**2+94786*r**4+806438*r**6+871178*r**8+212426*r**10-382122*r**12
            +292290*r**14+215250*r**16)-Q2*(39738-19231*r**2+946756*r**4+4840976*r**6
            +8924832*r**8+8305234*r**10+2977548*r**12-486744*r**14+112086*r**16
            +217365*r**18))+12*logq2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(96*Q2**14*(544
            +2665*r**4)-8*Q2**13*(39807+28292*r**2+217755*r**4+293970*r**6)+16*Q2**12*(45474
            +62931*r**2+221709*r**4+816365*r**6+504765*r**8)-Q2**11*(617226+2096929*r**2
            -38396*r**4+22280166*r**6+38792690*r**8+12128985*r**10)+Q2**10*(-293166
            +2723019*r**2-20123161*r**4-7764606*r**6+29785004*r**8+54768835*r**10
            +3097515*r**12)+Q2**9*(962202-874675*r**2+77839440*r**4+160722295*r**6
            +257637250*r**8+194450667*r**10-9882700*r**12+15432945*r**14)-Q2**8*(586938
            +4055583*r**2+144258675*r**4+452104935*r**6+912621655*r**8+1320971413*r**10
            +779063473*r**12+99031845*r**14+21353355*r**16)+2*Q2**7*(-44034+2820099*r**2
            +48371556*r**4+313993110*r**6+752075160*r**8+1291836526*r**10+1219162924*r**12
            +449314966*r**14+74176410*r**16+3649635*r**18)+2*Q2**6*(151626-86241*r**2
            +38363139*r**4-222014394*r**6-437362010*r**8-1160045694*r**10-1587527526*r**12
            -938029506*r**14+101755996*r**16-17495685*r**18+4215735*r**20)-2*Q2**5*(124434
            +1837179*r**2+88535844*r**4+11520729*r**6+961781904*r**8+1571848344*r**10
            +1276891544*r**12+375322624*r**14-85043146*r**16+605588429*r**18+48476460*r**20
            +5739015*r**22)+2*Q2**4*(70662+610625*r**2+50820885*r**4+195436665*r**6
            +1638055475*r**8+2968116696*r**10+3648913600*r**12+5291934920*r**14+3624517010*r**16
            +798186175*r**18+397059267*r**20+37407975*r**22+2694045*r**24)+Q2**3*(6894
            +932619*r**2+16714140*r**4-336862430*r**6-353775870*r**8-1756982163*r**10
            -2833285128*r**12-4782688100*r**14-5039507710*r**16-4222764955*r**18
            -2273719956*r**20+74039234*r**22+6826510*r**24+830115*r**26)-(-1+r**2)**2*(8466
            -104857*r**2+4851571*r**4+16902610*r**6+161192920*r**8-383465687*r**10
            +7718379369*r**12+15438437148*r**14+64272730*r**16-1455722055*r**18+1381820821*r**20
            +288472338*r**22+38861756*r**24-1473865*r**26+270735*r**28)-Q2**2*(77766
            +199769*r**2+52849181*r**4-94582890*r**6+1841018160*r**8-3136935337*r**10
            -5481562913*r**12-9222243932*r**14-12962315170*r**16+741484855*r**18
            +5513164571*r**20-866987706*r**22+321554476*r**24+18917785*r**26+2657385*r**28)
            +Q2*(45474-345639*r**2+27608176*r**4+8302179*r**6+1043983710*r**8-3282048363*r**10
            +14661390668*r**12+45602522583*r**14+38099197022*r**16-2931233845*r**18
            -5993433576*r**20+5317028521*r**22+357653666*r**24+178246599*r**26+470060*r**28
            +1428765*r**30))-18144000*logq2**4*r**12*(186+693*r**2+1211*r**4+1335*r**6
            +423*r**8)*sqrtq2+720*logq2**2*r**4*(480*Q2**11*(22+115*r**4)-16*Q2**10*(8628
            +9167*r**2+34971*r**4+39240*r**6)+80*Q2**9*(6741+13643*r**2+33869*r**4
            +56729*r**6+33810*r**8)-5*Q2**8*(178434+553905*r**2+1366138*r**4+2657472*r**6
            +2687964*r**8+1061415*r**10)+10*Q2**7*(43884+330966*r**2+864317*r**4
            +2039408*r**6+2578498*r**8+1729314*r**10+357885*r**12)+10*Q2**6*(61992
            -172200*r**2+198592*r**4-395785*r**6-1279132*r**8-1433162*r**10-710892*r**12
            +363195*r**14)-2*Q2**5*(506772+390978*r**2+13367449*r**4+29722020*r**6
            +39240285*r**8+38355082*r**10+20007723*r**12+3270624*r**14+3921435*r**16)
            +10*Q2**4*(41742+225771*r**2+3200972*r**4+8047679*r**6+11084616*r**8
            +16422017*r**10+17914040*r**12+9338593*r**14+1317078*r**16+379620*r**18)
            +10*Q2**3*(19332-159630*r**2-213557*r**4-2686996*r**6-5035892*r**8-8618108*r**10
            -11855378*r**12-8303812*r**14-4421744*r**16-1179678*r**18+157095*r**20)
            -(-1+r**2)**2*(15858+61813*r**2+2699894*r**4-1824355*r**6+87141416*r**8
            +279304046*r**10+203954072*r**12-3252994*r**14-6580570*r**16+18612509*r**18
            +1613746*r**20+72165*r**22)-10*Q2**2*(26544-24444*r**2+1857668*r**4
            -2095953*r**6-3411012*r**8-3093784*r**10-10487700*r**12-11582946*r**14
            +3767300*r**16+5762028*r**18-337056*r**20+225435*r**22)+10*Q2*(10572
            +14330*r**2+1202597*r**4-2289280*r**6+16184963*r**8+72528128*r**10+98149814*r**12
            +50281964*r**14-6837034*r**16-3168442*r**18+6318501*r**20+254292*r**22
            +76635*r**24))*sqrtq2+(252*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**3*(5*Q2**5-Q2**4*(7+15*r**2)
            +2*Q2**3*(4+2*r**2+5*r**4)+(-1+r**2)**2*(17+r**2-11*r**4+5*r**6)
            +2*Q2**2*(7-6*r**2-4*r**4+5*r**6)-Q2*(37+20*r**2+8*r**4-32*r**6
            +15*r**8))-5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(118368*Q2**14-144*Q2**13*(2511
            +3803*r**2)+16*Q2**12*(21333+74330*r**2+43833*r**4)+Q2**11*(346965-1379861*r**2
            -1898657*r**4+367833*r**6)-Q2**10*(1169835+999944*r**2+5534286*r**4
            -1524544*r**6+1317327*r**8)+Q2**9*(-325083+4329653*r**2+22754680*r**4
            +30957388*r**6+3108635*r**8+164439*r**10)+3*Q2**8*(1157087-2118238*r**2
            -8437489*r**4-8727132*r**6-6648027*r**8-2544694*r**10+380413*r**12)
            -6*Q2**7*(393093-572153*r**2-1516277*r**4-7232623*r**6+966293*r**8+8639551*r**10
            -21085*r**12+51601*r**14)-2*Q2**6*(957471-5816724*r**2-8909442*r**4
            -9130428*r**6-48140918*r**8+6857076*r**10-22409394*r**12-4272852*r**14
            +325083*r**16)+2*Q2**5*(1180749-5335383*r**2+61840392*r**4+51488388*r**6
            -110150612*r**8-209983568*r**10-40599288*r**12+22285812*r**14-833529*r**16
            +89727*r**18)+2*Q2**4*(-152955-4234734*r**2-110129295*r**4-124115796*r**6
            -195008960*r**8-376420404*r**10-148469336*r**12+62312460*r**14-24039309*r**16
            -2669430*r**18+126159*r**20)+Q2**3*(-260727+4848271*r**2+21725067*r**4
            +193300149*r**6+681115494*r**8+222073946*r**10+674502146*r**12+892924878*r**14
            +104590161*r**16-2324649*r**18+1171891*r**20-55107*r**22)+Q2**2*(228105
            +3563792*r**2+99103490*r**4-392865768*r**6-413748173*r**8-1057652048*r**10
            -406280052*r**12+759843712*r**14+324166063*r**16-118256832*r**18+12406898*r**20
            +1721960*r**22-58347*r**24)+(-1+r**2)**2*(102537-1994696*r**2+24377488*r**4
            +187096596*r**6+1252743257*r**8+193943024*r**10-249357024*r**12-452012296*r**14
            +195095219*r**16+35390808*r**18+2647504*r**20-211340*r**22+6123*r**24)
            +Q2*(-273423+1624793*r**2-70347312*r**4-123275452*r**6-2963286875*r**8
            -3363568839*r**10+187222624*r**12+1500207544*r**14+821134179*r**16-697362365*r**18
            -36052528*r**20-7073532*r**22-264697*r**24+7083*r**26)))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(816480000*logq2**4*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+11340000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +7875*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-1959552000*logq2**5*r**20*sqrtq2
            -136080000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-472500*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+((-((Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(120*Q2**9-3*Q2**8*(83
            +155*r**2)+Q2**7*(282+604*r**2+450*r**4)+Q2**6*(480-266*r**2-692*r**4
            +390*r**6)-6*Q2**5*(654+355*r**2+2249*r**4+53*r**6+145*r**8)+4*Q2**4*(1680
            +439*r**2+4230*r**4+10305*r**6+895*r**8+45*r**10)+2*Q2**3*(-1263+242*r**2
            -9397*r**4-4722*r**6-12775*r**8-2248*r**10+195*r**12)-6*Q2**2*(662
            -1893*r**2+2656*r**4-5041*r**6-3990*r**8+4597*r**10+24*r**12+25*r**14)
            +(-1+r**2)**2*(-1251+8491*r**2-52611*r**4-24181*r**6+28379*r**8-10995*r**10
            -1157*r**12+45*r**14)+Q2*(4320-22334*r**2+97590*r**4+124782*r**6+54682*r**8
            -82818*r**10+34026*r**12+2962*r**14-90*r**16)))-720*logq2**2*r**4*(-16*Q2**6*(21
            +28*r**2+60*r**4+45*r**6)+Q2**5*(1146+2404*r**2+4513*r**4+7350*r**6
            +4095*r**8)-Q2**4*(1170+2418*r**2+4699*r**4+11625*r**6+15855*r**8+7425*r**10)
            +2*Q2**3*(-30+386*r**2+1564*r**4+4048*r**6+5345*r**8+4020*r**10+1575*r**12)
            +3*(-1+r**2)**2*(18+162*r**2+4357*r**4+12887*r**6+9462*r**8-826*r**10
            -5*r**12+585*r**14)+2*Q2**2*(390-644*r**2+3161*r**4+8010*r**6+2453*r**8
            -4205*r**10+1680*r**12+2475*r**14)-3*Q2*(138-200*r**2+9379*r**4+33374*r**6
            +45019*r**8+20636*r**10-3191*r**12-530*r**14+1935*r**16))-129600*logq2**3*r**8*(1
            +r**2)*(15+29*r**2+30*r**4)*sqrtq2+12*logq2*(-192*Q2**10*(3+10*r**4)
            +80*Q2**9*(33+26*r**2+129*r**4+180*r**6)-5*Q2**8*(777+1120*r**2+3271*r**4
            +9602*r**6+6930*r**8)+60*Q2**7*(6+127*r**2+203*r**4+851*r**6+1171*r**8
            +370*r**10)+20*Q2**6*(213-517*r**2+1617*r**4+273*r**6-2050*r**8-2388*r**10
            +1620*r**12)-4*Q2**5*(762-985*r**2+46760*r**4+83860*r**6+140330*r**8
            +112547*r**10-860*r**12+12690*r**14)+30*Q2**4*(-33+434*r**2+7857*r**4
            +13040*r**6+23705*r**8+59826*r**10+45889*r**12+3776*r**14+170*r**16)
            +20*Q2**3*(78-625*r**2-507*r**4-4713*r**6-25267*r**8-45633*r**10-50361*r**12
            -41911*r**14-8487*r**16+1170*r**18)-20*Q2**2*(3+151*r**2+6955*r**4
            -15541*r**6-2987*r**8-26345*r**10-89743*r**12+3241*r**14+44428*r**16
            -442*r**18+360*r**20)+3*(-1+r**2)**2*(33-514*r**2-6006*r**4+10812*r**6
            -563770*r**8-1061448*r**10-2916*r**12+147476*r**14-108567*r**16-14310*r**18
            +810*r**20)-60*Q2*(6-109*r**2-1314*r**4+4756*r**6-55304*r**8-155364*r**10
            -126500*r**12+10210*r**14+23010*r**16-17375*r**18-1786*r**20+90*r**22))*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(
            -518400*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-3600*logq2*r**4*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+1555200*logq2**4*r**16*sqrtq2+64800*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2+75*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +(flagPERP*((Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(69+120*Q2**7+439*r**2+2841*r**4-6469*r**6
            +38051*r**8-9423*r**10-1073*r**12+45*r**14-225*Q2**6*(1+r**2)-8*Q2**5*(15
            -62*r**2+15*r**4)+3*Q2**4*(13+87*r**2-249*r**4+125*r**6)-4*Q2**3*(
            -126+445*r**2+2836*r**4+193*r**6)+Q2**2*(-171+1157*r**2+15410*r**4
            +13442*r**6+1853*r**8-195*r**10)+4*Q2*(-54+393*r**2+2366*r**4-3538*r**6
            +2756*r**8+117*r**10))+720*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(
            -16*Q2**4*(4+15*r**2+27*r**4)+Q2**3*(-64+2261*r**2+4458*r**4+2133*r**6)
            -Q2**2*(-176+1681*r**2+6451*r**4+6483*r**6+1377*r**8)-3*Q2*(-32+367*r**2
            +846*r**4+14*r**6+206*r**8+639*r**10)+3*(-48+187*r**2+473*r**4-6852*r**6
            -6052*r**8-479*r**10+531*r**12))-129600*logq2**3*r**10*(1+r**2)*(-8+33*r**2
            +9*r**4)*sqrtq2+logq2*(-12*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(-633
            -168*Q2**4+382*r**2-6098*r**4-3458*r**6+1287*r**8+1497*Q2**3*(1+r**2)
            -Q2**2*(1203+3062*r**2+1203*r**4)+Q2*(-1173+223*r**2+943*r**4-1413*r**6))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))+240*r**2*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4*(2+21*r**2+27*r**4)-7*Q2**3*(2+23*r**2+48*r**4+27*r**6)
            +Q2**2*(-14-143*r**2+79*r**4+147*r**6-189*r**8)+3*Q2*(2-61*r**2+34*r**4
            -66*r**6-136*r**8+27*r**10)+3*(2-67*r**2-255*r**4-60*r**6-630*r**8
            -217*r**10+27*r**12)))*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(-691200*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-4800*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+2073600*logq2**4*r**16*sqrtq2
            +86400*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+100*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**4*sqrtq2)+((48*logq2*(24*Q2**6*(2+5*r**4)-Q2**5*(168
            +133*r**2+540*r**4+795*r**6)-2*Q2**3*r**2*(73+268*r**2+570*r**4+590*r**6
            +375*r**8)+Q2**4*(180+159*r**2+645*r**4+1825*r**6+1575*r**8)-(-1
            +r**2)**2*(12+37*r**2+2117*r**4+3922*r**6-558*r**8-415*r**10+405*r**12)
            -2*Q2**2*(60-167*r**2+799*r**4+538*r**6-700*r**8-135*r**10+525*r**12)
            +Q2*(72-201*r**2+4924*r**4+10719*r**6+7964*r**8-1103*r**10-1600*r**12
            +1305*r**14))-2880*logq2**2*r**4*(12+19*r**2+15*r**4)*sqrtq2+4*(120*Q2**9
            -3*Q2**8*(87+155*r**2)+Q2**7*(258+596*r**2+450*r**4)+Q2**6*(420-514*r**2
            -808*r**4+390*r**6)-6*Q2**5*(441+230*r**2+1306*r**4-98*r**6+145*r**8)
            +2*Q2**4*(1905+622*r**2+6030*r**4+13410*r**6+955*r**8+90*r**10)+2*Q2**3*(
            -477-362*r**2-6203*r**4-3468*r**6-8555*r**8-1802*r**10+195*r**12)
            -6*Q2**2*(378-1147*r**2+1784*r**4-3549*r**6-2410*r**8+3143*r**10-64*r**12
            +25*r**14)+(-1+r**2)**2*(-549+3179*r**2-33609*r**4-12869*r**6+18541*r**8
            -6915*r**10-943*r**12+45*r**14)+Q2*(2070-9916*r**2+66480*r**4+75468*r**6
            +27908*r**8-53892*r**10+22224*r**12+2228*r**14-90*r**16))*sqrtq2)*nlo.X1Q2(3,'SM',Q2,r))/(19440*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+45*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-77760*logq2**3*r**12*sqrtq2
            -1620*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(flagPERP*(24*logq2*(
            -Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(-10-11*r**2-36*Q2**4*r**2+14*r**4
            -1326*r**6-416*r**8+189*r**10+2*Q2**3*(-5+132*r**2+117*r**4)-Q2**2*(
            -10+191*r**2+524*r**4+171*r**6)-2*Q2*(-5+93*r**2+2*r**4-68*r**6
            +108*r**8))-720*logq2**2*r**6*(-4+21*r**2+9*r**4)*sqrtq2+(5*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(-15+24*Q2**4-22*r**2-22*r**4-70*r**6+9*r**8
            -21*Q2**3*(1+r**2)+Q2**2*(-21+38*r**2-21*r**4)+Q2*(-15+29*r**2-43*r**4
            +9*r**6))-6*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(-3+5*Q2**3+5*r**2-19*r**4
            +5*r**6-5*Q2**2*(1+r**2)+Q2*(-5+8*r**2-5*r**4))*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8)))*sqrtq2)*nlo.X1Q2(3,'SM',Q2,r))/(6480*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+15*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-25920*logq2**3*r**12*sqrtq2
            -540*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+(flagPERP*((Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(-3+5*Q2**3+5*r**2-19*r**4+5*r**6-5*Q2**2*(1
            +r**2)+Q2*(-5+8*r**2-5*r**4))-12*logq2*r**4*sqrtq2)*nlo.X1Q2(4,'SM',Q2,r))/(
            -48*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+288*logq2**2*r**8*sqrtq2+2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2)+((-2*(5*Q2**5-Q2**4*(7+15*r**2)+2*Q2**3*(4
            +2*r**2+5*r**4)+(-1+r**2)**2*(17+r**2-11*r**4+5*r**6)+2*Q2**2*(7
            -6*r**2-4*r**4+5*r**6)-Q2*(37+20*r**2+8*r**4-32*r**6+15*r**8))-24*logq2*sqrtq2)*nlo.X1Q2(4,'SM',Q2,r))/(
            -72*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+432*logq2**2*r**8*sqrtq2+3*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2)+((272160000*logq2**4*r**16*(9+28*r**2
            +34*r**4+28*r**6+9*r**8)+7200*logq2**2*(-Q2+(-1+r)**2)*r**8*(-Q2+(1
            +r)**2)*(755*Q2**10-6460*Q2**9*(1+r**2)+19*Q2**8*(1397+2670*r**2+1397*r**4)
            -2*Q2**7*(22697+75917*r**2+75917*r**4+22697*r**6)+Q2**6*(18389+192140*r**2
            +288058*r**4+192140*r**6+18389*r**8)+Q2**5*(33782-72026*r**2-3024*r**4
            -3024*r**6-72026*r**8+33782*r**10)-Q2**4*(39655+164510*r**2+1238017*r**4
            +2141020*r**6+1238017*r**8+164510*r**10+39655*r**12)+2*Q2**3*(3721+115075*r**2
            +794925*r**4+2094619*r**6+2094619*r**8+794925*r**10+115075*r**12+3721*r**14)
            +4*Q2**2*(2651-3949*r**2+57848*r**4-355357*r**6-683806*r**8-355357*r**10
            +57848*r**12-3949*r**14+2651*r**16)-18*Q2*(453+4355*r**2+39700*r**4
            -68700*r**6-202608*r**8-202608*r**10-68700*r**12+39700*r**14+4355*r**16
            +453*r**18)+12*(179+1333*r**2+22836*r**4+74334*r**6+510837*r**8+822162*r**10
            +510837*r**12+74334*r**14+22836*r**16+1333*r**18+179*r**20))+(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(6866*Q2**16-23436*Q2**15*(1+r**2)+8*Q2**14*(865
            +8596*r**2+865*r**4)+8*Q2**13*(5380-11099*r**2-11099*r**4+5380*r**6)
            +Q2**12*(10045-259012*r**2-2562366*r**4-259012*r**6+10045*r**8)-4*Q2**11*(34147
            -324527*r**2-3988562*r**4-3988562*r**6-324527*r**8+34147*r**10)+2*Q2**10*(35759
            -646722*r**2-15796615*r**4-38576020*r**6-15796615*r**8-646722*r**10
            +35759*r**12)+8*Q2**9*(13745-127492*r**2+2119265*r**4+19072200*r**6
            +19072200*r**8+2119265*r**10-127492*r**12+13745*r**14)+Q2**8*(-91205
            +2043184*r**2+31186064*r**4-92196960*r**6-136611350*r**8-92196960*r**10
            +31186064*r**12+2043184*r**14-91205*r**16)-4*Q2**7*(8785+21669*r**2
            +14208392*r**4+33962024*r**6+101173570*r**8+101173570*r**10+33962024*r**12
            +14208392*r**14+21669*r**16+8785*r**18)+4*Q2**6*(10807-257354*r**2+4036831*r**4
            +57257856*r**6+179616146*r**8+416911988*r**10+179616146*r**12+57257856*r**14
            +4036831*r**16-257354*r**18+10807*r**20)-8*Q2**5*(266-53737*r**2-4403625*r**4
            +12575730*r**6+21507400*r**8+309675766*r**10+309675766*r**12+21507400*r**14
            +12575730*r**16-4403625*r**18-53737*r**20+266*r**22)-Q2**4*(2005+87332*r**2
            +26936590*r**4+29645300*r**6+614859675*r**8-231352920*r**10+1158640836*r**12
            -231352920*r**14+614859675*r**16+29645300*r**18+26936590*r**20+87332*r**22
            +2005*r**24)+4*Q2**3*(135-9223*r**2-887018*r**4+22918230*r**6+168130475*r**8
            +734118485*r**10+2173168916*r**12+2173168916*r**14+734118485*r**16+168130475*r**18
            +22918230*r**20-887018*r**22-9223*r**24+135*r**26)-2*Q2**2*(1265-69094*r**2
            -3667317*r**4+24306396*r**6-83158055*r**8+480299590*r**10+308598123*r**12
            +3065234184*r**14+308598123*r**16+480299590*r**18-83158055*r**20+24306396*r**22
            -3667317*r**24-69094*r**26+1265*r**28)+24*Q2*(31-1758*r**2-54453*r**4
            -686878*r**6-12831908*r**8+1292719*r**10-99093084*r**12+519615331*r**14
            +519615331*r**16-99093084*r**18+1292719*r**20-12831908*r**22-686878*r**24
            -54453*r**26-1758*r**28+31*r**30)+3*(57-3672*r**2+19060*r**4+3841960*r**6
            +9425060*r**8+68973464*r**10+826635276*r**12-1542120*r**14+7983061830*r**16
            -1542120*r**18+826635276*r**20+68973464*r**22+9425060*r**24+3841960*r**26
            +19060*r**28-3672*r**30+57*r**32))+432000*logq2**3*r**12*(867+35*Q2**7
            +3267*r**2+42957*r**4+88989*r**6+88989*r**8+42957*r**10+3267*r**12
            +867*r**14-505*Q2**6*(1+r**2)+5*Q2**5*(445+904*r**2+445*r**4)-Q2**4*(5293
            +15125*r**2+15125*r**4+5293*r**6)-3*Q2*(1+r**2)**2*(1111-2778*r**2
            -446*r**4-2778*r**6+1111*r**8)+Q2**3*(4157+17952*r**2+28010*r**4+17952*r**6
            +4157*r**8)+Q2**2*(1847-3657*r**2-14318*r**4-14318*r**6-3657*r**8+1847*r**10))*sqrtq2
            +120*logq2*r**4*(25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(105*Q2**7-555*Q2**6*(1
            +r**2)+15*Q2**5*(19+52*r**2+19*r**4)-Q2**4*(751+5687*r**2+5687*r**4
            +751*r**6)+Q2**3*(1139+8352*r**2+14006*r**4+8352*r**6+1139*r**8)+Q2**2*(719
            +3879*r**2+4474*r**4+4474*r**6+3879*r**8+719*r**10)+Q2*(-681+2244*r**2
            +38061*r**4+66912*r**6+38061*r**8+2244*r**10-681*r**12)+3*(-87+1849*r**2
            +34455*r**4+109943*r**6+109943*r**8+34455*r**10+1849*r**12-87*r**14))
            +2*(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(971+40*Q2**9-18517*r**2-136600*r**4+561592*r**6+1104554*r**8
            +1104554*r**10+561592*r**12-136600*r**14-18517*r**16+971*r**18-889*Q2**8*(1
            +r**2)+23*Q2**7*(169+418*r**2+169*r**4)-Q2**6*(4347+16967*r**2+16967*r**4
            +4347*r**6)-2*Q2**5*(1113+3489*r**2+13232*r**4+3489*r**6+1113*r**8)
            +2*Q2**4*(2240+11225*r**2+82043*r**4+82043*r**6+11225*r**8+2240*r**10)
            +Q2**3*(1659-18836*r**2-355219*r**4-699528*r**6-355219*r**8-18836*r**10
            +1659*r**12)+Q2**2*(-2567+13091*r**2+205549*r**4+793607*r**6+793607*r**8
            +205549*r**10+13091*r**12-2567*r**14)-8*Q2*(126-2129*r**2-34216*r**4
            -21131*r**6-11300*r**8-21131*r**10-34216*r**12-2129*r**14+126*r**16)))*sqrtq2)*nlopw.X1Q2RhoD(0,Q2,r))/(
            -4354560000*logq2**5*r**20-302400000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -1050000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+1814400000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+25200000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+17500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +((1512000*logq2**3*r**12*(1+r**2)*(29+50*r**2+29*r**4)+60*logq2*(-Q2
            +(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(1873-640*Q2**9-8851*r**2+85460*r**4
            +1289996*r**6+6796322*r**8+6796322*r**10+1289996*r**12+85460*r**14-8851*r**16
            +1873*r**18+8848*Q2**8*(1+r**2)-32*Q2**7*(617+1454*r**2+617*r**4)+Q2**6*(8169
            +72819*r**2+72819*r**4+8169*r**6)+2*Q2**5*(6881-28372*r**2-46826*r**4
            -28372*r**6+6881*r**8)-Q2**4*(13825+65585*r**2+481262*r**4+481262*r**6
            +65585*r**8+13825*r**10)+4*Q2**3*(903+32098*r**2+185817*r**4+339964*r**6
            +185817*r**8+32098*r**10+903*r**12)+Q2**2*(1879+11233*r**2+272487*r**4
            -159599*r**6-159599*r**8+272487*r**10+11233*r**12+1879*r**14)-2*Q2*(1967
            +21792*r**2+88088*r**4-781552*r**6-1382190*r**8-781552*r**10+88088*r**12
            +21792*r**14+1967*r**16))+3600*logq2**2*r**8*(71-160*Q2**6+6084*r**2
            +70785*r**4+118280*r**6+70785*r**8+6084*r**10+71*r**12+960*Q2**5*(1
            +r**2)-288*Q2**4*(13+24*r**2+13*r**4)+Q2**3*(3221+9879*r**2+9879*r**4
            +3221*r**6)+3*Q2**2*(607-396*r**2-982*r**4-396*r**6+607*r**8)-3*Q2*(723
            -2099*r**2-6184*r**4-6184*r**6-2099*r**8+723*r**10))*sqrtq2+(-500*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4-2708*r**6-1133*r**8
            -34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1
            -19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4-26*r**6+r**8)+Q2*(1
            -31*r**2-390*r**4-390*r**6-31*r**8+r**10))+7*(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8
            -444*r**2-9976*r**4+31692*r**6-28170*r**8+31692*r**10-9976*r**12-444*r**14
            +13*r**16-24*Q2**7*(1+r**2)+Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61
            -193*r**2-193*r**4+61*r**6)+Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6
            -165*r**8)+4*Q2**3*(13-355*r**2-6138*r**4-6138*r**6-355*r**8+13*r**10)
            +Q2**2*(59-406*r**2+10313*r**4+35188*r**6+10313*r**8-406*r**10+59*r**12)
            -2*Q2*(27-595*r**2-7237*r**4+6605*r**6+6605*r**8-7237*r**10-595*r**12
            +27*r**14)))*sqrtq2)*nlopw.X1Q2RhoD(1,Q2,r))/(36288000*logq2**4*r**16+1512000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+1750*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-12096000*logq2**3*r**12*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2-84000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((97200*logq2**2*r**8*(1+r**2)**2+3*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**2-1080*logq2*r**4*(1+r**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*sqrtq2)*nlopw.X1Q2RhoD(2,Q2,r))/(-86400*logq2**3*r**12-1800*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+21600*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+50*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((360*logq2*r**4*(1+r**2)+2*(-3-8*Q2**4+42*r**2+282*r**4+42*r**6
            -3*r**8+7*Q2**3*(1+r**2)+Q2**2*(7-2*r**2+7*r**4)-3*Q2*(1-11*r**2
            -11*r**4+r**6))*sqrtq2)*nlopw.X1Q2RhoD(3,Q2,r))/(720*logq2**2*r**8+5*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+nlopw.X1Q2RhoD(4,Q2,r)/(-12*logq2*r**4
            +(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)))
        if( flagDEBUG == 1):
            print("Q2moment n. 4 NLO pw = api*",resNLO*par.mbkin**8)
        res += api*resNLO

    if(kwargs.get('flag_includeNNLO', 1) == 1):
        resNNLO = 0
        resNNLO +=((flagPERP*muWC**5*(-995328000*logq2**5*(-Q2+(-1+r)**2)*r**20*(-Q2+(1+r)**2)*(1470*Q2**9*r**2
            -30*Q2**8*(16+269*r**2+469*r**4)+20*Q2**7*(80+963*r**2+3193*r**4+2835*r**6)
            -4*Q2**6*(-560+5108*r**2+27941*r**4+51485*r**6+31164*r**8)+Q2**5*(-14175
            -4178*r**2+66926*r**4+274664*r**6+350721*r**8+155526*r**10)+Q2**4*(15295
            +29975*r**2+28974*r**4-114182*r**6-336625*r**8-325213*r**10-88200*r**12)
            +2*Q2**3*(5845-28990*r**2-20683*r**4+12156*r**6+38939*r**8+88206*r**10
            +68411*r**12-14700*r**14)+(-1+r**2)**2*(-8845+29033*r**2-61211*r**4
            +6549*r**6+40863*r**8-62737*r**10+5275*r**12+9619*r**14+11214*r**16)
            +2*Q2**2*(-19425+49690*r**2-28073*r**4-10430*r**6-4411*r**8-26830*r**10
            -1387*r**12-5334*r**14+41160*r**16)+Q2*(31525-106148*r**2+199688*r**4
            +103312*r**6-183422*r**8-12076*r**10+133552*r**12-5864*r**14+11297*r**16
            -50904*r**18))-552960*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(248850*Q2**15*r**2
            -6*Q2**14*(-544+462225*r**2+501045*r**4)+2*Q2**13*(-18108+6607467*r**2
            +14641360*r**4+7754535*r**6)-2*Q2**12*(-82212+17382627*r**2+58550863*r**4
            +64768395*r**6+21508155*r**8)+Q2**11*(-287001+54567206*r**2+241232326*r**4
            +399326904*r**6+298718235*r**8+62734590*r**10)-Q2**10*(87861+52964941*r**2
            +252208926*r**4+476583506*r**6+546076361*r**8+335211485*r**10+22265280*r**12)
            +Q2**9*(949647+35999210*r**2+76637625*r**4-129126720*r**6-495608255*r**8
            -215660138*r**10+9321375*r**12-81363960*r**14)+Q2**8*(-1063593-24698063*r**2
            +98162725*r**4+919459785*r**6+2808758075*r**8+3548991687*r**10+1678781387*r**12
            +467141535*r**14+142385310*r**16)-2*Q2**7*(-147951-7161029*r**2+51243854*r**4
            +459718030*r**6+1667162250*r**8+3200343864*r**10+2888972006*r**12+925552514*r**14
            +277610385*r**16+34519365*r**18)+Q2**6*(-598698+5435908*r**2+33257618*r**4
            +536550872*r**6+1365247320*r**8+3447892572*r**10+5402694988*r**12+3406836128*r**14
            -201251398*r**16+181390680*r**18-60775830*r**20)+2*Q2**5*(935511-8830189*r**2
            -5013379*r**4-307499349*r**6-208615924*r**8+303941046*r**10+517725796*r**12
            -37684934*r**14+535156701*r**16+1041898711*r**18+80433135*r**20+50110155*r**22)
            -2*Q2**4*(768393-5240420*r**2-4414260*r**4-317800610*r**6-420089575*r**8
            +154539954*r**10+1300738730*r**12+2209539910*r**14+1071717045*r**16+1329422210*r**18
            +770746538*r**20+94890700*r**22+20621385*r**24)-Q2**3*(259941-1209454*r**2
            +4260770*r**4+214051780*r**6+297644815*r**8+823152338*r**10-307369092*r**12
            -2210825800*r**14-2647700685*r**16+302983910*r**18-1971641054*r**20+132659396*r**22
            -82059495*r**24+14688630*r**26)+(-1+r**2)**2*(108339-188653*r**2+1409964*r**4
            +17362110*r**6-188625955*r**8+1212689517*r**10-920977454*r**12-819389068*r**14
            -94120515*r**16+268297885*r**18+364123944*r**20-100855218*r**22+76217779*r**24
            +1337955*r**26+1169370*r**28)+Q2**2*(1064799-4423729*r**2+5801634*r**4
            -38916150*r**6-495522415*r**8+1709402957*r**10-1056680512*r**12-399491188*r**14
            -1077535135*r**16-204223975*r**18+2458511994*r**20-1484766934*r**22+766933679*r**24
            -20144565*r**26+21429540*r**28)+Q2*(-587301+2212586*r**2-6006619*r**4
            +1848324*r**6+538461935*r**8-2882630238*r**10+2982761593*r**12+261290748*r**14
            -94234543*r**16+1111554430*r**18+347371999*r**20-2062937604*r**22+941486821*r**24
            -411421706*r**26+4888835*r**28-8299260*r**30))-384*logq2*r**4*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*(20598*Q2**21*r**2-6*Q2**20*(-14800+110817*r**2
            +48657*r**4)+12*Q2**19*(-81020+429860*r**2+786457*r**4+144360*r**6)
            -4*Q2**18*(-1129140+4698553*r**2+17983292*r**4+13251612*r**6+1357125*r**8)
            +Q2**17*(-10975155+40805244*r**2+239075718*r**4+267166828*r**6+140780445*r**8
            +8542980*r**10)+Q2**16*(12241215-72156519*r**2-391550736*r**4+173169526*r**6
            +240743147*r**8-107524827*r**10-1118502*r**12)-4*Q2**15*(-1165755-36799237*r**2
            -76247941*r**4+1147665975*r**6+2443518349*r**8+1125179473*r**10+97841799*r**12
            +5405793*r**14)+6*Q2**14*(-5523430-47296645*r**2-24119282*r**4+2394134421*r**6
            +7600109356*r**8+7578246829*r**10+2255947690*r**12+201903163*r**14+6278490*r**16)
            -12*Q2**13*(-3107760-29347138*r**2-6665627*r**4+1740322188*r**6+7322957831*r**8
            +11290684494*r**10+7452772375*r**12+1292795448*r**14+93830373*r**16+1079400*r**18)
            +Q2**12*(2229240-179511782*r**2+674020676*r**4+15820018380*r**6+60438769828*r**8
            +77227590488*r**10+93808149564*r**12+47111816980*r**14-7506684604*r**16
            -750261330*r**18-41315040*r**20)+4*Q2**11*(-11146005-31552419*r**2-575312853*r**4
            -2133015385*r**6+9159358092*r**8+87677333118*r**10+155353444136*r**12
            +86797134654*r**14+32886162969*r**16+10730621741*r**18+676990509*r**20
            +15227667*r**22)-2*Q2**10*(-18459870-129086889*r**2-1369636110*r**4-3883224661*r**6
            +37998501814*r**8+368288521014*r**10+960447800072*r**12+1020102784462*r**14
            +414047266746*r**16+134611791779*r**18+21199918102*r**20+976796535*r**22
            +7511166*r**24)-2*Q2**9*(-3523065+81257310*r**2+521730784*r**4+905666976*r**6
            -16688220869*r**8-259395491746*r**10-889089585360*r**12-1501335074144*r**14
            -1115069510419*r**16-197446468854*r**18-69870072736*r**20+4200081120*r**22
            +500959329*r**24+20554170*r**26)+2*Q2**8*(-14937585+17626212*r**2-171858972*r**4
            -5855811242*r**6-13869420993*r**8-63385840242*r**10+16612151224*r**12
            +180945486372*r**14-135765159363*r**16+110982032992*r**18+410591038788*r**20
            +69684476118*r**22+25489535653*r**24+1274710398*r**26+22006800*r**28)
            -4*Q2**7*(-3711465-10474983*r**2-16585311*r**4-3335685479*r**6-14586263971*r**8
            -24822762891*r**10+189495832471*r**12+934101876593*r**14+1594291209753*r**16
            +942342337579*r**18+692365728599*r**20+301626210435*r**22+58044089491*r**24
            +8811586919*r**26+308055825*r**28+1661715*r**30)+2*Q2**6*(2846010-48063629*r**2
            +73807366*r**4-437568519*r**6-20836737376*r**8-38220210749*r**10+62850072438*r**12
            +1095169406201*r**14+3234942689404*r**16+4244337067713*r**18+1096248229682*r**20
            +1270170663907*r**22+91705333008*r**24+44171379785*r**26-3904589422*r**28
            -318659733*r**30-9096486*r**32)+2*Q2**5*(-4444620+46913529*r**2+196475118*r**4
            -3157634592*r**6+4284558882*r**8-55107687144*r**10+27684987718*r**12
            -421683885480*r**14-16178868510*r**16-1685102837414*r**18-1909353319158*r**20
            +1724069831280*r**22-415439457242*r**24+380884320672*r**26+25334593602*r**28
            +11900568792*r**30+493904418*r**32+7103349*r**34)-2*Q2**4*(-1242720+14476290*r**2
            +255485487*r**4-1487436678*r**6+986660562*r**8-64504876242*r**10-38296698010*r**12
            -817663336382*r**14+334167797586*r**16+1872366492266*r**18-378607428116*r**20
            +199316660910*r**22+2271882595718*r**24+106309914682*r**26+291615743322*r**28
            +29987555478*r**30+5440765110*r**32+166532652*r**34+1058085*r**36)-4*Q2**3*(
            -311685+5689717*r**2-14874022*r**4-212397297*r**6+969486898*r**8+1596860872*r**10
            +11218336602*r**12+241251137732*r**14-48318975248*r**16+28951515474*r**18
            -1132476228514*r**20+899608770850*r**22-820548509538*r**24-9370007248*r**26
            -159001225522*r**28+1871859252*r**30-4503490619*r**32+458546753*r**34
            +28039968*r**36+655575*r**38)+(-1+r**2)**2*(-35445+1146853*r**2+20191623*r**4
            +9580655*r**6+1930424622*r**8-1633150128*r**10+18856083096*r**12+112978880216*r**14
            -592131066690*r**16+3073241166034*r**18-4482985442386*r**20+587730286974*r**22
            +2073376545124*r**24-1288465233960*r**26+451772078016*r**28-50395865664*r**30
            +16494013327*r**32+634389537*r**34+178938995*r**36+4942203*r**38+46998*r**40)
            +2*Q2**2*(-560910+12382053*r**2+90285306*r**4-533912437*r**6+6161778684*r**8
            -21754745316*r**10+34349697060*r**12-35796382404*r**14-283245399600*r**16
            +345030574462*r**18+587246697672*r**20-2860127322054*r**22+4546581750340*r**24
            -3589763502564*r**26+1616151735324*r**28-355106787156*r**30+99547657566*r**32
            +762812133*r**34+1773833726*r**36+64291155*r**38+876960*r**40)-Q2*(
            -325785+9011520*r**2+103727334*r**4-309894052*r**6+8688424663*r**8-24975593328*r**10
            +76998773208*r**12-12741385872*r**14-317796809874*r**16+2697275410816*r**18
            -1955733162796*r**20-1127394809784*r**22-5918491573658*r**24+10976288004704*r**26
            -6789817463496*r**28+2366866090416*r**30-392328447861*r**32+96607749696*r**34
            +1878119222*r**36+1304184892*r**38+41190243*r**40+459792*r**42))+418037760000*logq2**6*r**24*(21
            +20*r**2-60*r**4+28*r**6+3*r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            -33177600*logq2**4*r**16*(31740*Q2**14*r**2-120*Q2**13*(52+2833*r**2+3388*r**4)
            +6*Q2**12*(11980+270574*r**2+618653*r**4+385102*r**6)-2*Q2**11*(178440
            +2282699*r**2+7216222*r**4+8800095*r**6+3769812*r**8)+Q2**10*(983355
            +8345294*r**2+31067085*r**4+54102530*r**6+46571394*r**8+15050142*r**10)
            -10*Q2**9*(161637+1031659*r**2+3992916*r**4+8470666*r**6+10526009*r**8
            +7236579*r**10+1718622*r**12)+5*Q2**8*(309777+1852365*r**2+6301228*r**4
            +13416886*r**6+19308817*r**8+19883457*r**10+11929950*r**12+1134612*r**14)
            +Q2**7*(-680280-7861293*r**2-19253056*r**4-22220429*r**6-4169060*r**8
            +10584385*r**10-6558348*r**12-7522911*r**14+14098896*r**16)-Q2**6*(167010
            -7961931*r**2-16962953*r**4-8504875*r**6+42481197*r**8+125571275*r**10
            +149180169*r**12+80656587*r**14+34314345*r**16+23782752*r**18)+Q2**5*(388020
            -6824913*r**2-12692680*r**4-20324950*r**6+11442492*r**8+85453456*r**10
            +155104712*r**12+157978910*r**14+69065160*r**16+34556697*r**18+14757096*r**20)
            +5*Q2**4*(-47526+633585*r**2-590603*r**4+6113198*r**6+1091056*r**8-6939396*r**10
            -9354686*r**12-11008306*r**14-12300274*r**16+120723*r**18-3683487*r**20
            +111156*r**22)+(-1+r**2)**4*(-3375-5306*r**2-1205229*r**4+6032210*r**6
            -4530386*r**8-2923902*r**10-1661326*r**12-2351966*r**14+2336745*r**16
            +1901216*r**18-62493*r**20+205812*r**22)-5*Q2**3*(-22296+42333*r**2
            -3099124*r**4+9792343*r**6-4361540*r**8-6355830*r**10-3329788*r**12
            -2306098*r**14+1538260*r**16-582567*r**18+8447184*r**20-2420517*r**22
            +1448040*r**24)-Q2*(-1+r**2)**2*(-21390-121447*r**2-6552520*r**4+27690207*r**6
            -18560072*r**8-19746586*r**10-949296*r**12-13929734*r**14-7993462*r**16
            +9299217*r**18+12631496*r**20-1501737*r**22+1611324*r**24)+Q2**2*(-57225
            -359201*r**2-14203562*r**4+61084517*r**6-67260035*r**8-16991280*r**10
            +5791772*r**12+2375494*r**14-18176559*r**16-11698165*r**18-10204770*r**20
            +38197829*r**22-9870357*r**24+5083542*r**26))*sqrtq2-4608*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(881112*Q2**18*r**2-48*Q2**17*(-5220+260567*r**2
            +242332*r**4)+8*Q2**16*(-336970+8894607*r**2+19096105*r**4+8082207*r**6)
            -8*Q2**15*(-1480540+26960479*r**2+96672508*r**4+95896183*r**6+23870574*r**8)
            +Q2**14*(-26451075+386543200*r**2+1954677440*r**4+2995905932*r**6+1961391975*r**8
            +289061820*r**10)-2*Q2**13*(-13548825+222137303*r**2+1227941380*r**4
            +1731677664*r**6+1812406229*r**8+1111180125*r**10+35224308*r**12)-Q2**12*(
            -4956195-408992658*r**2-878847963*r**4+7508327928*r**6+17057833023*r**8
            +8399904298*r**10+1062403047*r**12+541678872*r**14)+4*Q2**11*(-11388855
            -103779632*r**2+317933775*r**4+7147042926*r**6+20919174555*r**8+22602908600*r**10
            +8691561161*r**12+1675420530*r**14+233748588*r**16)-Q2**10*(-47861165
            -330682016*r**2+1510698438*r**4+36301020556*r**6+136088737968*r**8+221404757220*r**10
            +165915736978*r**12+41407140196*r**14+7688641253*r**16+386357004*r**18)
            +2*Q2**9*(-7817425+2404525*r**2+564237210*r**4+10970550018*r**6+39553501960*r**8
            +74459612960*r**10+91754332530*r**12+49554975670*r**14-3369450607*r**16
            +180734875*r**18-347936820*r**20)+Q2**8*(-6689925-257148174*r**2-2013550255*r**4
            -10310373844*r**6+22392560406*r**8+170702122920*r**10+317945183394*r**12
            +197343933940*r**14+114652604271*r**16+68623886166*r**18+7616078925*r**20
            +1050406896*r**22)-8*Q2**7*(-1242835-14870379*r**2-283348179*r**4-1220319907*r**6
            +4677259268*r**8+37016732668*r**10+100814110274*r**12+123175077044*r**14
            +59633686893*r**16+29775748343*r**18+7705992873*r**20+882904951*r**22
            +43353306*r**24)+Q2**6*(-13813505+87580688*r**2-880750820*r**4-2841536076*r**6
            +5251714415*r**8+143952374020*r**10+466101881328*r**12+994413689240*r**14
            +893536032573*r**16+146687249640*r**18+138952712660*r**20-7544671756*r**22
            +536637365*r**24-415034172*r**26)+2*Q2**5*(7746855-23013293*r**2-19406016*r**4
            -3526999548*r**6-1960728169*r**8-55761423525*r**10-4715413668*r**12-11654029536*r**14
            -170795187611*r**16-54804670583*r**18+188877545760*r**20+7075908476*r**22
            +24391973117*r**24+1613718249*r**26+235889892*r**28)-Q2**4*(5686575+57802250*r**2
            -5482765*r**4-5997612032*r**6-7891921805*r**8-157401230310*r**10-65022273185*r**12
            +257445336360*r**14+456454561389*r**16+76208725630*r**18+359173796905*r**20
            +373926240160*r**22+62301990705*r**24+28649746718*r**26+2146582725*r**28
            +127570680*r**30)-4*Q2**3*(1166775-10464792*r**2+40343965*r**4+52703582*r**6
            +482259187*r**8+17620213380*r**10+10995173157*r**12+11846225290*r**14
            -50392469599*r**16-103969139664*r**18+61938410095*r**20-105860472638*r**22
            +3526849945*r**24-10854538908*r**26+769310927*r**28-45403050*r**30+19512348*r**32)
            +(-1+r**2)**2*(318305+3282512*r**2+53582878*r**4+41083360*r**6+875472190*r**8
            +6965133640*r**10-38506621906*r**12+250530796256*r**14-266820273720*r**16
            -121158357080*r**18+96817547530*r**20+79786806176*r**22-48300770446*r**24
            +23162798360*r**26-549377110*r**28+736650400*r**30+29634343*r**32+2694312*r**34)
            +Q2**2*(5641815+6042776*r**2+372278666*r**4-1338799828*r**6+1701921242*r**8
            -4598627308*r**10-59206051606*r**12+141277898124*r**14-29889909744*r**16
            -148134513084*r**18-224158466354*r**20+620960986084*r**22-463422569546*r**24
            +206222372572*r**26-23535214658*r**28+10510735972*r**30+369530121*r**32
            +72744756*r**34)-2*Q2*(1106095+5797633*r**2+116152310*r**4-254094858*r**6
            +1299592530*r**8+1083855510*r**10-34911385894*r**12+225642867830*r**14
            -241979463416*r**16+25918580240*r**18-105506777530*r**20-74345225486*r**22
            +278866032510*r**24-168016089894*r**26+62059249230*r**28-5019993950*r**30
            +2284229497*r**32+84974975*r**34+11392668*r**36))*sqrtq2+64*r**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**22*r**2+2*Q2**21*(4527-9848*r**2
            +57*r**4)+Q2**20*(-131472+202661*r**2+1063606*r**4-53319*r**6)+2*Q2**19*(421539
            +487631*r**2-11284137*r**4-5873199*r**6+180830*r**8)+Q2**18*(-3118767
            -15540804*r**2+142763490*r**4+244543128*r**6+57748669*r**8-1127640*r**10)
            +Q2**17*(7224003+62492280*r**2-441692045*r**4-1388455828*r**6-1076476847*r**8
            -142209604*r**10+1743033*r**12)+Q2**16*(-10413588-97668346*r**2+815041396*r**4
            +3293108280*r**6+3852467880*r**8+2023777578*r**10+122280432*r**12-449016*r**14)
            +Q2**15*(8083176-44826134*r**2-1135816004*r**4-2716524738*r**6+4079215624*r**8
            +4049840366*r**10+386181660*r**12+248270746*r**14-3254424*r**16)+2*Q2**14*(
            -383742+215557997*r**2+793310251*r**4-1131459921*r**6-24407375653*r**8
            -45456424991*r**10-22824668547*r**12-4558205359*r**14-404759093*r**16
            +2805810*r**18)+2*Q2**13*(-1496112-342466219*r**2-962817420*r**4+2979879996*r**6
            +53643600504*r**8+150724470810*r**10+151168910976*r**12+48447282036*r**14
            +7848250008*r**16+358259169*r**18-984340*r**20)-2*Q2**12*(1221792-157574066*r**2
            -538074255*r**4+2721193149*r**6+48373076556*r**8+176141374644*r**10+275535823362*r**12
            +186273197742*r**14+22554217332*r**16+1709466582*r**18-234439491*r**20
            +2601261*r**22)+2*Q2**11*(4751370+208777127*r**2+381681824*r**4+4340100035*r**6
            +12708080604*r**8-16946091158*r**10-156606209176*r**12-84284303598*r**14
            -63857914670*r**16-73359983329*r**18-11632461144*r**20-774176325*r**22
            +3638232*r**24)-2*Q2**10*(3752073+318829277*r**2+824043827*r**4+7200507735*r**6
            +444272078*r**8-191907669802*r**10-1008012726030*r**12-1648140944702*r**14
            -921879288343*r**16-443687213475*r**18-129287236373*r**20-15278351577*r**22
            -492477648*r**24+734032*r**26)-2*Q2**9*(526383-64238313*r**2-675686509*r**4
            -4187466654*r**6-4469296521*r**8+107204002209*r**10+1009647173595*r**12
            +2606883620364*r**14+2892464229357*r**16+898650786729*r**18+431631867705*r**20
            +39712692274*r**22+1525932621*r**24-323980033*r**26+2372985*r**28)+2*Q2**8*(2635812
            +180658719*r**2-672288995*r**4+2732817656*r**6+18611382846*r**8+2022748729*r**10
            +235700578031*r**12+578641045698*r**14+1531227611032*r**16+1297735543169*r**18
            -635489814837*r**20-40296381356*r**22-97358267482*r**24-12796835033*r**26
            -663988279*r**28+2299890*r**30)+Q2**7*(-2364216-303937586*r**2+1096110740*r**4
            -7766954190*r**6-75676779320*r**8-104054202874*r**10-36168487764*r**12
            +2398269703258*r**14+6821795868944*r**16+4390972417962*r**18+3774042983788*r**20
            +3314245046678*r**22+760678076328*r**24+216510146562*r**26+21652959444*r**28
            +533141598*r**30-474312*r**32)-2*Q2**6*(666966-2205982*r**2-204524305*r**4
            +620895375*r**6-16937169777*r**8-72632036253*r**10-112150943529*r**12
            +426555155319*r**14+3170686448475*r**16+6897627347415*r**18+1729705615125*r**20
            +3172699523925*r**22+515244268053*r**24+260567958545*r**26+10910160037*r**28
            -440751963*r**30-192077269*r**32+953043*r**34)+2*Q2**5*(856701+55721383*r**2
            -779067577*r**4+2963587080*r**6+6555794820*r**8-26615018744*r**10+146136708620*r**12
            -254845747248*r**14+746901505606*r**16+798038040326*r**18+6586836025074*r**20
            -4507809087032*r**22+2542494042932*r**24-1040545626944*r**26+606029084*r**28
            -48822684576*r**30-5567552891*r**32-240309877*r**34+674463*r**36)+Q2**4*(
            -425328-50847257*r**2+960278004*r**4-2709404943*r**6-10736579696*r**8
            +22841398100*r**10-521395517256*r**12+329843162836*r**14-3478764558496*r**16
            +4366099432842*r**18+5492586610064*r**20-11954158323442*r**22+14435567418576*r**24
            -2489157861804*r**26+1924649935464*r**28+174177529764*r**30+61432232880*r**32
            +5847856359*r**34+135698268*r**36-162935*r**38)-2*Q2**3*(130629+3502098*r**2
            -62824545*r**4+487828716*r**6-181178078*r**8+1320457844*r**10-53097976068*r**12
            +52128465444*r**14-1471202932218*r**16+1426248688488*r**18+813220414370*r**20
            +729108677052*r**22-812921053248*r**24+1056207483788*r**26+577297239628*r**28
            +17965254252*r**30+49208708493*r**32-80744826*r**34-190157961*r**36-32140088*r**38
            +124230*r**40)+2*(-1+r**2)**2*(3270+255858*r**2-12908701*r**4+23673736*r**6
            -403810881*r**8-3209458014*r**10+8694900708*r**12-51088387332*r**14-108754209488*r**16
            +956032198568*r**18-4610254072398*r**20+9070915454188*r**22-7911295335958*r**24
            +3586289799768*r**26-1025435066268*r**28+159645330708*r**30-30746648382*r**32
            -712950634*r**34-457634141*r**36-39079044*r**38-1017441*r**40+1878*r**42)
            +Q2**2*(216297+13127766*r**2-402286580*r**4+1501548566*r**6-2740912121*r**8
            -30714276184*r**10+169971276120*r**12-356225213664*r**14+394129729298*r**16
            +2119399568284*r**18-7651469740624*r**20+18099691813980*r**22-27744560828282*r**24
            +23663463335456*r**26-11378630339480*r**28+3171348788112*r**30-699327809259*r**32
            +25073274526*r**34-14122365820*r**36-1484641058*r**38-60659101*r**40
            +153768*r**42)+Q2*(-61149-4329426*r**2+178172107*r**4-629487600*r**6
            +3405530533*r**8+23546013282*r**10-125645425083*r**12+451838664640*r**14
            -690524849650*r**16+1632651625836*r**18-4282596656962*r**20+22731650897120*r**22
            -54344263132902*r**24+56571398500900*r**26-30769924587846*r**28+10148913388224*r**30
            -2027207192737*r**32+360870688006*r**34-3510692025*r**36+5738334352*r**38
            +568125105*r**40+18193626*r**42-38351*r**44))*sqrtq2))/(2116316160000*logq2**5*(
            -Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +48988800000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+102060000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-4232632320000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-440899200000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-3061800000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -1417500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**6*sqrtq2)+(flagPERP*muWC**4*(-7962624000*logq2**5*(-Q2+(-1+r)**2)*r**20*(
            -Q2+(1+r)**2)*(1470*Q2**9*r**2-30*Q2**8*(16+269*r**2+469*r**4)+20*Q2**7*(80
            +963*r**2+3193*r**4+2835*r**6)-4*Q2**6*(-560+5108*r**2+27941*r**4+51485*r**6
            +31164*r**8)+Q2**5*(-14175-4178*r**2+66926*r**4+274664*r**6+350721*r**8
            +155526*r**10)+Q2**4*(15295+29975*r**2+28974*r**4-114182*r**6-336625*r**8
            -325213*r**10-88200*r**12)+2*Q2**3*(5845-28990*r**2-20683*r**4+12156*r**6
            +38939*r**8+88206*r**10+68411*r**12-14700*r**14)+(-1+r**2)**2*(-8845
            +29033*r**2-61211*r**4+6549*r**6+40863*r**8-62737*r**10+5275*r**12
            +9619*r**14+11214*r**16)+2*Q2**2*(-19425+49690*r**2-28073*r**4-10430*r**6
            -4411*r**8-26830*r**10-1387*r**12-5334*r**14+41160*r**16)+Q2*(31525
            -106148*r**2+199688*r**4+103312*r**6-183422*r**8-12076*r**10+133552*r**12
            -5864*r**14+11297*r**16-50904*r**18))-4423680*logq2**3*r**12*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(248850*Q2**15*r**2-6*Q2**14*(-544+462225*r**2
            +501045*r**4)+2*Q2**13*(-18108+6607467*r**2+14641360*r**4+7754535*r**6)
            -2*Q2**12*(-82212+17382627*r**2+58550863*r**4+64768395*r**6+21508155*r**8)
            +Q2**11*(-287001+54567206*r**2+241232326*r**4+399326904*r**6+298718235*r**8
            +62734590*r**10)-Q2**10*(87861+52964941*r**2+252208926*r**4+476583506*r**6
            +546076361*r**8+335211485*r**10+22265280*r**12)+Q2**9*(949647+35999210*r**2
            +76637625*r**4-129126720*r**6-495608255*r**8-215660138*r**10+9321375*r**12
            -81363960*r**14)+Q2**8*(-1063593-24698063*r**2+98162725*r**4+919459785*r**6
            +2808758075*r**8+3548991687*r**10+1678781387*r**12+467141535*r**14+142385310*r**16)
            -2*Q2**7*(-147951-7161029*r**2+51243854*r**4+459718030*r**6+1667162250*r**8
            +3200343864*r**10+2888972006*r**12+925552514*r**14+277610385*r**16+34519365*r**18)
            +Q2**6*(-598698+5435908*r**2+33257618*r**4+536550872*r**6+1365247320*r**8
            +3447892572*r**10+5402694988*r**12+3406836128*r**14-201251398*r**16+181390680*r**18
            -60775830*r**20)+2*Q2**5*(935511-8830189*r**2-5013379*r**4-307499349*r**6
            -208615924*r**8+303941046*r**10+517725796*r**12-37684934*r**14+535156701*r**16
            +1041898711*r**18+80433135*r**20+50110155*r**22)-2*Q2**4*(768393-5240420*r**2
            -4414260*r**4-317800610*r**6-420089575*r**8+154539954*r**10+1300738730*r**12
            +2209539910*r**14+1071717045*r**16+1329422210*r**18+770746538*r**20+94890700*r**22
            +20621385*r**24)-Q2**3*(259941-1209454*r**2+4260770*r**4+214051780*r**6
            +297644815*r**8+823152338*r**10-307369092*r**12-2210825800*r**14-2647700685*r**16
            +302983910*r**18-1971641054*r**20+132659396*r**22-82059495*r**24+14688630*r**26)
            +(-1+r**2)**2*(108339-188653*r**2+1409964*r**4+17362110*r**6-188625955*r**8
            +1212689517*r**10-920977454*r**12-819389068*r**14-94120515*r**16+268297885*r**18
            +364123944*r**20-100855218*r**22+76217779*r**24+1337955*r**26+1169370*r**28)
            +Q2**2*(1064799-4423729*r**2+5801634*r**4-38916150*r**6-495522415*r**8
            +1709402957*r**10-1056680512*r**12-399491188*r**14-1077535135*r**16-204223975*r**18
            +2458511994*r**20-1484766934*r**22+766933679*r**24-20144565*r**26+21429540*r**28)
            +Q2*(-587301+2212586*r**2-6006619*r**4+1848324*r**6+538461935*r**8
            -2882630238*r**10+2982761593*r**12+261290748*r**14-94234543*r**16+1111554430*r**18
            +347371999*r**20-2062937604*r**22+941486821*r**24-411421706*r**26+4888835*r**28
            -8299260*r**30))-3072*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(20598*Q2**21*r**2
            -6*Q2**20*(-14800+110817*r**2+48657*r**4)+12*Q2**19*(-81020+429860*r**2
            +786457*r**4+144360*r**6)-4*Q2**18*(-1129140+4698553*r**2+17983292*r**4
            +13251612*r**6+1357125*r**8)+Q2**17*(-10975155+40805244*r**2+239075718*r**4
            +267166828*r**6+140780445*r**8+8542980*r**10)+Q2**16*(12241215-72156519*r**2
            -391550736*r**4+173169526*r**6+240743147*r**8-107524827*r**10-1118502*r**12)
            -4*Q2**15*(-1165755-36799237*r**2-76247941*r**4+1147665975*r**6+2443518349*r**8
            +1125179473*r**10+97841799*r**12+5405793*r**14)+6*Q2**14*(-5523430-47296645*r**2
            -24119282*r**4+2394134421*r**6+7600109356*r**8+7578246829*r**10+2255947690*r**12
            +201903163*r**14+6278490*r**16)-12*Q2**13*(-3107760-29347138*r**2-6665627*r**4
            +1740322188*r**6+7322957831*r**8+11290684494*r**10+7452772375*r**12+1292795448*r**14
            +93830373*r**16+1079400*r**18)+Q2**12*(2229240-179511782*r**2+674020676*r**4
            +15820018380*r**6+60438769828*r**8+77227590488*r**10+93808149564*r**12
            +47111816980*r**14-7506684604*r**16-750261330*r**18-41315040*r**20)+4*Q2**11*(
            -11146005-31552419*r**2-575312853*r**4-2133015385*r**6+9159358092*r**8
            +87677333118*r**10+155353444136*r**12+86797134654*r**14+32886162969*r**16
            +10730621741*r**18+676990509*r**20+15227667*r**22)-2*Q2**10*(-18459870
            -129086889*r**2-1369636110*r**4-3883224661*r**6+37998501814*r**8+368288521014*r**10
            +960447800072*r**12+1020102784462*r**14+414047266746*r**16+134611791779*r**18
            +21199918102*r**20+976796535*r**22+7511166*r**24)-2*Q2**9*(-3523065+81257310*r**2
            +521730784*r**4+905666976*r**6-16688220869*r**8-259395491746*r**10-889089585360*r**12
            -1501335074144*r**14-1115069510419*r**16-197446468854*r**18-69870072736*r**20
            +4200081120*r**22+500959329*r**24+20554170*r**26)+2*Q2**8*(-14937585
            +17626212*r**2-171858972*r**4-5855811242*r**6-13869420993*r**8-63385840242*r**10
            +16612151224*r**12+180945486372*r**14-135765159363*r**16+110982032992*r**18
            +410591038788*r**20+69684476118*r**22+25489535653*r**24+1274710398*r**26
            +22006800*r**28)-4*Q2**7*(-3711465-10474983*r**2-16585311*r**4-3335685479*r**6
            -14586263971*r**8-24822762891*r**10+189495832471*r**12+934101876593*r**14
            +1594291209753*r**16+942342337579*r**18+692365728599*r**20+301626210435*r**22
            +58044089491*r**24+8811586919*r**26+308055825*r**28+1661715*r**30)+2*Q2**6*(2846010
            -48063629*r**2+73807366*r**4-437568519*r**6-20836737376*r**8-38220210749*r**10
            +62850072438*r**12+1095169406201*r**14+3234942689404*r**16+4244337067713*r**18
            +1096248229682*r**20+1270170663907*r**22+91705333008*r**24+44171379785*r**26
            -3904589422*r**28-318659733*r**30-9096486*r**32)+2*Q2**5*(-4444620+46913529*r**2
            +196475118*r**4-3157634592*r**6+4284558882*r**8-55107687144*r**10+27684987718*r**12
            -421683885480*r**14-16178868510*r**16-1685102837414*r**18-1909353319158*r**20
            +1724069831280*r**22-415439457242*r**24+380884320672*r**26+25334593602*r**28
            +11900568792*r**30+493904418*r**32+7103349*r**34)-2*Q2**4*(-1242720+14476290*r**2
            +255485487*r**4-1487436678*r**6+986660562*r**8-64504876242*r**10-38296698010*r**12
            -817663336382*r**14+334167797586*r**16+1872366492266*r**18-378607428116*r**20
            +199316660910*r**22+2271882595718*r**24+106309914682*r**26+291615743322*r**28
            +29987555478*r**30+5440765110*r**32+166532652*r**34+1058085*r**36)-4*Q2**3*(
            -311685+5689717*r**2-14874022*r**4-212397297*r**6+969486898*r**8+1596860872*r**10
            +11218336602*r**12+241251137732*r**14-48318975248*r**16+28951515474*r**18
            -1132476228514*r**20+899608770850*r**22-820548509538*r**24-9370007248*r**26
            -159001225522*r**28+1871859252*r**30-4503490619*r**32+458546753*r**34
            +28039968*r**36+655575*r**38)+(-1+r**2)**2*(-35445+1146853*r**2+20191623*r**4
            +9580655*r**6+1930424622*r**8-1633150128*r**10+18856083096*r**12+112978880216*r**14
            -592131066690*r**16+3073241166034*r**18-4482985442386*r**20+587730286974*r**22
            +2073376545124*r**24-1288465233960*r**26+451772078016*r**28-50395865664*r**30
            +16494013327*r**32+634389537*r**34+178938995*r**36+4942203*r**38+46998*r**40)
            +2*Q2**2*(-560910+12382053*r**2+90285306*r**4-533912437*r**6+6161778684*r**8
            -21754745316*r**10+34349697060*r**12-35796382404*r**14-283245399600*r**16
            +345030574462*r**18+587246697672*r**20-2860127322054*r**22+4546581750340*r**24
            -3589763502564*r**26+1616151735324*r**28-355106787156*r**30+99547657566*r**32
            +762812133*r**34+1773833726*r**36+64291155*r**38+876960*r**40)-Q2*(
            -325785+9011520*r**2+103727334*r**4-309894052*r**6+8688424663*r**8-24975593328*r**10
            +76998773208*r**12-12741385872*r**14-317796809874*r**16+2697275410816*r**18
            -1955733162796*r**20-1127394809784*r**22-5918491573658*r**24+10976288004704*r**26
            -6789817463496*r**28+2366866090416*r**30-392328447861*r**32+96607749696*r**34
            +1878119222*r**36+1304184892*r**38+41190243*r**40+459792*r**42))+3344302080000*logq2**6*r**24*(21
            +20*r**2-60*r**4+28*r**6+3*r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            -265420800*logq2**4*r**16*(31740*Q2**14*r**2-120*Q2**13*(52+2833*r**2+3388*r**4)
            +6*Q2**12*(11980+270574*r**2+618653*r**4+385102*r**6)-2*Q2**11*(178440
            +2282699*r**2+7216222*r**4+8800095*r**6+3769812*r**8)+Q2**10*(983355
            +8345294*r**2+31067085*r**4+54102530*r**6+46571394*r**8+15050142*r**10)
            -10*Q2**9*(161637+1031659*r**2+3992916*r**4+8470666*r**6+10526009*r**8
            +7236579*r**10+1718622*r**12)+5*Q2**8*(309777+1852365*r**2+6301228*r**4
            +13416886*r**6+19308817*r**8+19883457*r**10+11929950*r**12+1134612*r**14)
            +Q2**7*(-680280-7861293*r**2-19253056*r**4-22220429*r**6-4169060*r**8
            +10584385*r**10-6558348*r**12-7522911*r**14+14098896*r**16)-Q2**6*(167010
            -7961931*r**2-16962953*r**4-8504875*r**6+42481197*r**8+125571275*r**10
            +149180169*r**12+80656587*r**14+34314345*r**16+23782752*r**18)+Q2**5*(388020
            -6824913*r**2-12692680*r**4-20324950*r**6+11442492*r**8+85453456*r**10
            +155104712*r**12+157978910*r**14+69065160*r**16+34556697*r**18+14757096*r**20)
            +5*Q2**4*(-47526+633585*r**2-590603*r**4+6113198*r**6+1091056*r**8-6939396*r**10
            -9354686*r**12-11008306*r**14-12300274*r**16+120723*r**18-3683487*r**20
            +111156*r**22)+(-1+r**2)**4*(-3375-5306*r**2-1205229*r**4+6032210*r**6
            -4530386*r**8-2923902*r**10-1661326*r**12-2351966*r**14+2336745*r**16
            +1901216*r**18-62493*r**20+205812*r**22)-5*Q2**3*(-22296+42333*r**2
            -3099124*r**4+9792343*r**6-4361540*r**8-6355830*r**10-3329788*r**12
            -2306098*r**14+1538260*r**16-582567*r**18+8447184*r**20-2420517*r**22
            +1448040*r**24)-Q2*(-1+r**2)**2*(-21390-121447*r**2-6552520*r**4+27690207*r**6
            -18560072*r**8-19746586*r**10-949296*r**12-13929734*r**14-7993462*r**16
            +9299217*r**18+12631496*r**20-1501737*r**22+1611324*r**24)+Q2**2*(-57225
            -359201*r**2-14203562*r**4+61084517*r**6-67260035*r**8-16991280*r**10
            +5791772*r**12+2375494*r**14-18176559*r**16-11698165*r**18-10204770*r**20
            +38197829*r**22-9870357*r**24+5083542*r**26))*sqrtq2-36864*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(881112*Q2**18*r**2-48*Q2**17*(-5220+260567*r**2
            +242332*r**4)+8*Q2**16*(-336970+8894607*r**2+19096105*r**4+8082207*r**6)
            -8*Q2**15*(-1480540+26960479*r**2+96672508*r**4+95896183*r**6+23870574*r**8)
            +Q2**14*(-26451075+386543200*r**2+1954677440*r**4+2995905932*r**6+1961391975*r**8
            +289061820*r**10)-2*Q2**13*(-13548825+222137303*r**2+1227941380*r**4
            +1731677664*r**6+1812406229*r**8+1111180125*r**10+35224308*r**12)-Q2**12*(
            -4956195-408992658*r**2-878847963*r**4+7508327928*r**6+17057833023*r**8
            +8399904298*r**10+1062403047*r**12+541678872*r**14)+4*Q2**11*(-11388855
            -103779632*r**2+317933775*r**4+7147042926*r**6+20919174555*r**8+22602908600*r**10
            +8691561161*r**12+1675420530*r**14+233748588*r**16)-Q2**10*(-47861165
            -330682016*r**2+1510698438*r**4+36301020556*r**6+136088737968*r**8+221404757220*r**10
            +165915736978*r**12+41407140196*r**14+7688641253*r**16+386357004*r**18)
            +2*Q2**9*(-7817425+2404525*r**2+564237210*r**4+10970550018*r**6+39553501960*r**8
            +74459612960*r**10+91754332530*r**12+49554975670*r**14-3369450607*r**16
            +180734875*r**18-347936820*r**20)+Q2**8*(-6689925-257148174*r**2-2013550255*r**4
            -10310373844*r**6+22392560406*r**8+170702122920*r**10+317945183394*r**12
            +197343933940*r**14+114652604271*r**16+68623886166*r**18+7616078925*r**20
            +1050406896*r**22)-8*Q2**7*(-1242835-14870379*r**2-283348179*r**4-1220319907*r**6
            +4677259268*r**8+37016732668*r**10+100814110274*r**12+123175077044*r**14
            +59633686893*r**16+29775748343*r**18+7705992873*r**20+882904951*r**22
            +43353306*r**24)+Q2**6*(-13813505+87580688*r**2-880750820*r**4-2841536076*r**6
            +5251714415*r**8+143952374020*r**10+466101881328*r**12+994413689240*r**14
            +893536032573*r**16+146687249640*r**18+138952712660*r**20-7544671756*r**22
            +536637365*r**24-415034172*r**26)+2*Q2**5*(7746855-23013293*r**2-19406016*r**4
            -3526999548*r**6-1960728169*r**8-55761423525*r**10-4715413668*r**12-11654029536*r**14
            -170795187611*r**16-54804670583*r**18+188877545760*r**20+7075908476*r**22
            +24391973117*r**24+1613718249*r**26+235889892*r**28)-Q2**4*(5686575+57802250*r**2
            -5482765*r**4-5997612032*r**6-7891921805*r**8-157401230310*r**10-65022273185*r**12
            +257445336360*r**14+456454561389*r**16+76208725630*r**18+359173796905*r**20
            +373926240160*r**22+62301990705*r**24+28649746718*r**26+2146582725*r**28
            +127570680*r**30)-4*Q2**3*(1166775-10464792*r**2+40343965*r**4+52703582*r**6
            +482259187*r**8+17620213380*r**10+10995173157*r**12+11846225290*r**14
            -50392469599*r**16-103969139664*r**18+61938410095*r**20-105860472638*r**22
            +3526849945*r**24-10854538908*r**26+769310927*r**28-45403050*r**30+19512348*r**32)
            +(-1+r**2)**2*(318305+3282512*r**2+53582878*r**4+41083360*r**6+875472190*r**8
            +6965133640*r**10-38506621906*r**12+250530796256*r**14-266820273720*r**16
            -121158357080*r**18+96817547530*r**20+79786806176*r**22-48300770446*r**24
            +23162798360*r**26-549377110*r**28+736650400*r**30+29634343*r**32+2694312*r**34)
            +Q2**2*(5641815+6042776*r**2+372278666*r**4-1338799828*r**6+1701921242*r**8
            -4598627308*r**10-59206051606*r**12+141277898124*r**14-29889909744*r**16
            -148134513084*r**18-224158466354*r**20+620960986084*r**22-463422569546*r**24
            +206222372572*r**26-23535214658*r**28+10510735972*r**30+369530121*r**32
            +72744756*r**34)-2*Q2*(1106095+5797633*r**2+116152310*r**4-254094858*r**6
            +1299592530*r**8+1083855510*r**10-34911385894*r**12+225642867830*r**14
            -241979463416*r**16+25918580240*r**18-105506777530*r**20-74345225486*r**22
            +278866032510*r**24-168016089894*r**26+62059249230*r**28-5019993950*r**30
            +2284229497*r**32+84974975*r**34+11392668*r**36))*sqrtq2+512*r**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**22*r**2+2*Q2**21*(4527-9848*r**2
            +57*r**4)+Q2**20*(-131472+202661*r**2+1063606*r**4-53319*r**6)+2*Q2**19*(421539
            +487631*r**2-11284137*r**4-5873199*r**6+180830*r**8)+Q2**18*(-3118767
            -15540804*r**2+142763490*r**4+244543128*r**6+57748669*r**8-1127640*r**10)
            +Q2**17*(7224003+62492280*r**2-441692045*r**4-1388455828*r**6-1076476847*r**8
            -142209604*r**10+1743033*r**12)+Q2**16*(-10413588-97668346*r**2+815041396*r**4
            +3293108280*r**6+3852467880*r**8+2023777578*r**10+122280432*r**12-449016*r**14)
            +Q2**15*(8083176-44826134*r**2-1135816004*r**4-2716524738*r**6+4079215624*r**8
            +4049840366*r**10+386181660*r**12+248270746*r**14-3254424*r**16)+2*Q2**14*(
            -383742+215557997*r**2+793310251*r**4-1131459921*r**6-24407375653*r**8
            -45456424991*r**10-22824668547*r**12-4558205359*r**14-404759093*r**16
            +2805810*r**18)+2*Q2**13*(-1496112-342466219*r**2-962817420*r**4+2979879996*r**6
            +53643600504*r**8+150724470810*r**10+151168910976*r**12+48447282036*r**14
            +7848250008*r**16+358259169*r**18-984340*r**20)-2*Q2**12*(1221792-157574066*r**2
            -538074255*r**4+2721193149*r**6+48373076556*r**8+176141374644*r**10+275535823362*r**12
            +186273197742*r**14+22554217332*r**16+1709466582*r**18-234439491*r**20
            +2601261*r**22)+2*Q2**11*(4751370+208777127*r**2+381681824*r**4+4340100035*r**6
            +12708080604*r**8-16946091158*r**10-156606209176*r**12-84284303598*r**14
            -63857914670*r**16-73359983329*r**18-11632461144*r**20-774176325*r**22
            +3638232*r**24)-2*Q2**10*(3752073+318829277*r**2+824043827*r**4+7200507735*r**6
            +444272078*r**8-191907669802*r**10-1008012726030*r**12-1648140944702*r**14
            -921879288343*r**16-443687213475*r**18-129287236373*r**20-15278351577*r**22
            -492477648*r**24+734032*r**26)-2*Q2**9*(526383-64238313*r**2-675686509*r**4
            -4187466654*r**6-4469296521*r**8+107204002209*r**10+1009647173595*r**12
            +2606883620364*r**14+2892464229357*r**16+898650786729*r**18+431631867705*r**20
            +39712692274*r**22+1525932621*r**24-323980033*r**26+2372985*r**28)+2*Q2**8*(2635812
            +180658719*r**2-672288995*r**4+2732817656*r**6+18611382846*r**8+2022748729*r**10
            +235700578031*r**12+578641045698*r**14+1531227611032*r**16+1297735543169*r**18
            -635489814837*r**20-40296381356*r**22-97358267482*r**24-12796835033*r**26
            -663988279*r**28+2299890*r**30)+Q2**7*(-2364216-303937586*r**2+1096110740*r**4
            -7766954190*r**6-75676779320*r**8-104054202874*r**10-36168487764*r**12
            +2398269703258*r**14+6821795868944*r**16+4390972417962*r**18+3774042983788*r**20
            +3314245046678*r**22+760678076328*r**24+216510146562*r**26+21652959444*r**28
            +533141598*r**30-474312*r**32)-2*Q2**6*(666966-2205982*r**2-204524305*r**4
            +620895375*r**6-16937169777*r**8-72632036253*r**10-112150943529*r**12
            +426555155319*r**14+3170686448475*r**16+6897627347415*r**18+1729705615125*r**20
            +3172699523925*r**22+515244268053*r**24+260567958545*r**26+10910160037*r**28
            -440751963*r**30-192077269*r**32+953043*r**34)+2*Q2**5*(856701+55721383*r**2
            -779067577*r**4+2963587080*r**6+6555794820*r**8-26615018744*r**10+146136708620*r**12
            -254845747248*r**14+746901505606*r**16+798038040326*r**18+6586836025074*r**20
            -4507809087032*r**22+2542494042932*r**24-1040545626944*r**26+606029084*r**28
            -48822684576*r**30-5567552891*r**32-240309877*r**34+674463*r**36)+Q2**4*(
            -425328-50847257*r**2+960278004*r**4-2709404943*r**6-10736579696*r**8
            +22841398100*r**10-521395517256*r**12+329843162836*r**14-3478764558496*r**16
            +4366099432842*r**18+5492586610064*r**20-11954158323442*r**22+14435567418576*r**24
            -2489157861804*r**26+1924649935464*r**28+174177529764*r**30+61432232880*r**32
            +5847856359*r**34+135698268*r**36-162935*r**38)-2*Q2**3*(130629+3502098*r**2
            -62824545*r**4+487828716*r**6-181178078*r**8+1320457844*r**10-53097976068*r**12
            +52128465444*r**14-1471202932218*r**16+1426248688488*r**18+813220414370*r**20
            +729108677052*r**22-812921053248*r**24+1056207483788*r**26+577297239628*r**28
            +17965254252*r**30+49208708493*r**32-80744826*r**34-190157961*r**36-32140088*r**38
            +124230*r**40)+2*(-1+r**2)**2*(3270+255858*r**2-12908701*r**4+23673736*r**6
            -403810881*r**8-3209458014*r**10+8694900708*r**12-51088387332*r**14-108754209488*r**16
            +956032198568*r**18-4610254072398*r**20+9070915454188*r**22-7911295335958*r**24
            +3586289799768*r**26-1025435066268*r**28+159645330708*r**30-30746648382*r**32
            -712950634*r**34-457634141*r**36-39079044*r**38-1017441*r**40+1878*r**42)
            +Q2**2*(216297+13127766*r**2-402286580*r**4+1501548566*r**6-2740912121*r**8
            -30714276184*r**10+169971276120*r**12-356225213664*r**14+394129729298*r**16
            +2119399568284*r**18-7651469740624*r**20+18099691813980*r**22-27744560828282*r**24
            +23663463335456*r**26-11378630339480*r**28+3171348788112*r**30-699327809259*r**32
            +25073274526*r**34-14122365820*r**36-1484641058*r**38-60659101*r**40
            +153768*r**42)+Q2*(-61149-4329426*r**2+178172107*r**4-629487600*r**6
            +3405530533*r**8+23546013282*r**10-125645425083*r**12+451838664640*r**14
            -690524849650*r**16+1632651625836*r**18-4282596656962*r**20+22731650897120*r**22
            -54344263132902*r**24+56571398500900*r**26-30769924587846*r**28+10148913388224*r**30
            -2027207192737*r**32+360870688006*r**34-3510692025*r**36+5738334352*r**38
            +568125105*r**40+18193626*r**42-38351*r**44))*sqrtq2))/(6348948480000*logq2**5*(
            -Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +146966400000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+306180000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-12697896960000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-1322697600000*logq2**4*(-Q2+(
            -1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-9185400000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -4252500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**6*sqrtq2)+(muWC**5*(995328000*logq2**5*r**18*(210*Q2**11*(3+35*r**4)
            -30*Q2**10*(139+403*r**2+2395*r**4+2835*r**6)+10*Q2**9*(-93+6460*r**2
            +37362*r**4+68840*r**6+43155*r**8)-2*Q2**8*(-43137-1353*r**2+466970*r**4
            +1274250*r**6+1396755*r**8+630315*r**10)+Q2**7*(-333657-695205*r**2
            +617972*r**4+4108870*r**6+7682355*r**8+6215295*r**10+2307690*r**12)
            -Q2**6*(-577017-1815828*r**2-1368477*r**4+1136792*r**6+7530745*r**8
            +12057360*r**10+7952805*r**12+2619540*r**14)+Q2**5*(-390789-1771329*r**2
            -2300965*r**4-3588411*r**6+219159*r**8+5265185*r**10+9402645*r**12+5088195*r**14
            +1512630*r**16)+(-1+r**2)**4*(-50811-59170*r**2-78100*r**4-1168700*r**6
            +966090*r**8+1815876*r**10-624940*r**12+144820*r**14+147985*r**16+56070*r**18)
            +Q2**4*(-277515+127260*r**2+551864*r**4+1992016*r**6+1758510*r**8+1439540*r**10
            +173560*r**12-1927800*r**14+50925*r**16+264600*r**18)+Q2**3*(798831
            +941529*r**2+704004*r**4+5474320*r**6+2718706*r**8-9523494*r**10-4247596*r**12
            +890120*r**14-1417065*r**16-2331915*r**18-1224720*r**20)-Q2*(-1+r**2)**2*(
            -296283-345483*r**2-356510*r**4-5931470*r**6-342320*r**8+11074148*r**10
            +6242258*r**12-2673130*r**14+657075*r**16+798015*r**18+366660*r**20)
            +Q2**2*(-701163-370290*r**2-132073*r**4-9611910*r**6-766170*r**8+8973728*r**10
            +13079130*r**12+10410528*r**14-4762795*r**16+41970*r**18+1248255*r**20
            +976710*r**22))+552960*logq2**3*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(90*Q2**17*(2833
            +13825*r**4)-6*Q2**16*(553779+590423*r**2+2381651*r**4+2919975*r**6)
            +4*Q2**15*(4802751+9975813*r**2+24319926*r**4+43911329*r**6+27213075*r**8)
            -4*Q2**14*(16013610+48807513*r**2+110965161*r**4+216529977*r**6+232910395*r**8
            +96300900*r**10)+Q2**13*(133604595+536464833*r**2+1283476274*r**4+2590166818*r**6
            +3505735707*r**8+2721985805*r**10+821381400*r**12)-Q2**12*(174344445
            +891482862*r**2+2195053265*r**4+4474402322*r**6+6672309603*r**8+6862668238*r**10
            +4487390135*r**12+953753850*r**14)+2*Q2**11*(63033921+443775771*r**2
            +903305841*r**4+1286613868*r**6+1500804158*r**8+1165903415*r**10+1572659733*r**12
            +1573756334*r**14+64752975*r**16)+2*Q2**10*(-6880401-234726204*r**2+171557917*r**4
            +3093556597*r**6+8290024575*r**8+13792720873*r**10+14307208315*r**12
            +7247183275*r**14+1267991306*r**16+707119875*r**18)-Q2**9*(68647095-57819879*r**2
            +2306931152*r**4+15943508094*r**6+44104255460*r**8+76345361820*r**10
            +91361517386*r**12+73237928802*r**14+32951341909*r**16+7898797515*r**18
            +2175866550*r**20)+Q2**8*(84418785+103635234*r**2+2670724257*r**4+16911203704*r**6
            +53309686786*r**8+95987397520*r**10+121498388474*r**12+114872019532*r**14
            +73721083469*r**16+25043600286*r**18+7045902165*r**20+1098434700*r**22)
            +4*Q2**7*(-18767430-52199394*r**2-734223105*r**4-2704214669*r**6-10139170156*r**8
            -15930723636*r**10-14308579034*r**12-10311787120*r**14-8376575184*r**16
            -2635049086*r**18+2497101279*r**20-332359095*r**22+190916550*r**24)-4*Q2**6*(
            -15049647-81086295*r**2-924629406*r**4-1608397082*r**6-7856113417*r**8
            -10726446979*r**10-317814426*r**12+19298405890*r**14+27175249033*r**16
            +17132710433*r**18+11390182792*r**20+8908053192*r**22+679536767*r**24
            +378074025*r**26)+Q2**5*(-24550083-277914465*r**2-2678215590*r**4-4578043346*r**6
            -24365651425*r**8-52324499663*r**10-45831958424*r**12+16727806652*r**14
            +108147336803*r**16+127064927465*r**18+74200896586*r**20+40508501174*r**22
            +26834815713*r**24+2605665703*r**26+840086100*r**28)+(-1+r**2)**4*(-637119
            -2692980*r**2-107766829*r**4+234433374*r**6-2159055831*r**8-1783465252*r**10
            +8132972955*r**12-1275212762*r**14-3178311733*r**16+700150212*r**18+4347007921*r**20
            +1689109050*r**22-105235509*r**24+385532884*r**26+12044769*r**28+5846850*r**30)
            +Q2**4*(-16061715+101958798*r**2-379151879*r**4+3591455502*r**6-623588635*r**8
            +22959030690*r**10+41561977289*r**12+35116868458*r**14+15206678031*r**16
            -14702078910*r**18-7852446525*r**20-14006468462*r**22-14537415329*r**24
            -1780835058*r**26-1062782405*r**28+47820150*r**30)+2*Q2**3*(14606685
            +4515279*r**2+1186623397*r**4-2367522036*r**6+13863072416*r**8+8843306325*r**10
            +3650138367*r**12+16637803606*r**14+838701192*r**16-6143224807*r**18
            +1071253475*r**20-33641882496*r**22-13569863028*r**24+5351881219*r**26
            -5521455559*r**28+148903390*r**30-164617425*r**32)-Q2*(-1+r**2)**2*(
            -5269869-14992179*r**2-721133539*r**4+1601606015*r**6-12697168497*r**8
            -10866683383*r**10+25424271673*r**12+2016466123*r**14+15227385945*r**16
            +4546384199*r**18-5309863817*r**20+24327598381*r**22+10945259541*r**24
            -2251117085*r**26+2838479923*r**28+43346569*r**30+53190000*r**32)+2*Q2**2*(
            -8895465-9298656*r**2-957711495*r**4+2673042649*r**6-15645330999*r**8
            -2547954159*r**10+13885187437*r**12-15154586035*r**14+22842142547*r**16
            +32408520613*r**18+12506484123*r**20-28367892901*r**22+20096329155*r**24
            +16078445379*r**26-6900060289*r**28+4231197951*r**30-69853430*r**32+97993575*r**34))
            +384*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(102990*Q2**23*(1
            +r**4)-6*Q2**22*(250975+129615*r**2+214351*r**4+277615*r**6)+6*Q2**21*(1646615
            +1736600*r**2-1141014*r**4+3823540*r**6+1947335*r**8)-2*Q2**20*(18899085
            +30364065*r**2-77875078*r**4-45784454*r**6+79921989*r**8+22962705*r**10)
            +Q2**19*(90583365+198784575*r**2-1075702342*r**4-2052365826*r**6-919050211*r**8
            +538147875*r**10+105661500*r**12)+Q2**18*(-130414245-384224610*r**2+4565476427*r**4
            +12392177214*r**6+15028746725*r**8+7627142086*r**10-635757075*r**12-118164810*r**14)
            -Q2**17*(-75207015-378950325*r**2+13605980135*r**4+46150104725*r**6+77563654531*r**8
            +84676747293*r**10+38886392737*r**12+1737385851*r**14+54215940*r**16)
            +Q2**16*(97168005+69795150*r**2+28807057876*r**4+123911235500*r**6+251267030090*r**8
            +359650653908*r**10+323922260860*r**12+117060991036*r**14+8532203745*r**16
            +398993910*r**18)-4*Q2**15*(59591970+203597265*r**2+10132429775*r**4
            +59535219310*r**6+142109797822*r**8+229515603654*r**10+256386998498*r**12
            +186663312110*r**14+48946523260*r**16+3730648317*r**18+137397315*r**20)
            +4*Q2**14*(37195320+331906875*r**2+7208077054*r**4+72869690417*r**6+194423836992*r**8
            +334882621288*r**10+344017158788*r**12+284260315716*r**14+204357116272*r**16
            +25443780557*r**18+2108325750*r**20+27826875*r**22)+4*Q2**13*(32218230
            -312707055*r**2+3278960761*r**4-34823145093*r**6-56952818495*r**8-16507535744*r**10
            +336029336760*r**12+796925322712*r**14+538270991794*r**16+96457539855*r**18
            +69505893343*r**20+3603961725*r**22+163234935*r**24)-4*Q2**12*(72207330
            -147508335*r**2+13612937936*r**4+45683665020*r**6+301104688958*r**8+960411623823*r**10
            +2333980627392*r**12+4197046452440*r**14+4496386659270*r**16+2304700044111*r**18
            +636679251104*r**20+163841395276*r**22+8160516234*r**24+222698385*r**26)
            +2*Q2**11*(74484735+243577425*r**2+25911284958*r**4+189445855490*r**6
            +1081357300445*r**8+3560584575747*r**10+7974086979100*r**12+14828149949132*r**14
            +19275539081505*r**16+15730751366095*r**18+5780101131182*r**20+1631761511330*r**22
            +248829102483*r**24+10530252525*r**26+124617480*r**28)+2*Q2**10*(51303705
            -729199770*r**2-3843347523*r**4-126371296894*r**6-718444134359*r**8-2981112783274*r**10
            -4810580073843*r**12-7711324300822*r**14-11590861514341*r**16-12699497517486*r**18
            -8912846316889*r**20+104258081302*r**22-448380573533*r**24+102726928146*r**26
            +5931410511*r**28+278019870*r**30)-2*Q2**9*(91558515-737355075*r**2+14202987453*r**4
            +2683661179*r**6-32458706161*r**8-1665637530223*r**10+2163753671577*r**12
            +13343576719375*r**14+23811252907761*r**16+26612197330431*r**18+18793158395407*r**20
            +9672637249177*r**22+8719728345101*r**24+1182899408499*r**26+361345995099*r**28
            +14995516125*r**30+339456000*r**32)+2*Q2**8*(37199655-204254490*r**2
            +12930631648*r**4+59739735976*r**6+227375466680*r**8-1471329247488*r**10
            +4932064841080*r**12+26655811169528*r**14+54983153719326*r**16+72370491773980*r**18
            +64599418302224*r**20+37137971931000*r**22+19216132278304*r**24+9423417150128*r**26
            +1525127744280*r**28+256211087144*r**30+8729650275*r**32+97785870*r**34)
            +2*Q2**7*(20065185-337754010*r**2-2265745529*r**4-43851694540*r**6-267407020384*r**8
            +837795447224*r**10-3851188124004*r**12-20605145960308*r**14-44985021837310*r**16
            -62373100416564*r**18-65590423300102*r**20-43092461648308*r**22-8014732653480*r**24
            -12006885219160*r**26-861195771172*r**28-568054891532*r**30+30512370277*r**32
            +2227082862*r**34+109864455*r**36)-2*Q2**6*(28244295-412257975*r**2+3167065187*r**4
            -21856364315*r**6-420529214180*r**8-836302904664*r**10-2590042804500*r**12
            -8929213391672*r**14-22557468752430*r**16-10122184847310*r**18+1370973923578*r**20
            -2991266734710*r**22+6894207426348*r**24+37478193467200*r**26-3310317115140*r**28
            +6364691569856*r**30+310064086175*r**32+167659768477*r**34+6049115835*r**36
            +121806345*r**38)+2*Q2**5*(9598875-148942110*r**2+2037629884*r**4-10639584718*r**6
            -389625479019*r**8-1388583002948*r**10-486591633596*r**12-4301025243724*r**14
            -24773923623222*r**16-10130399577536*r**18+16618393049516*r**20+43536161066712*r**22
            +23792991928726*r**24+12880640142788*r**26+44737378648044*r**28-1021579991188*r**30
            +5426467214619*r**32+417360914014*r**34+103560430952*r**36+3165616086*r**38
            +39541845*r**40)+(-1+r**2)**4*(57765-1617990*r**2-6165578*r**4-431607756*r**6
            -14767827259*r**8+34119582198*r**10-327677918280*r**12+1470115084224*r**14
            -9024413350102*r**16+13461905694612*r**18+13297141683796*r**20-37763580593080*r**22
            +19244776039986*r**24+5487191038972*r**26-5156635951272*r**28+2421315019104*r**30
            -247276980015*r**32+92007697618*r**34+3809798886*r**36+908307044*r**38
            +20812137*r**40+234990*r**42)+2*Q2**4*(3034005-62168925*r**2-56241734*r**4
            -214979742*r**6+65259199273*r**8+676928209351*r**10-1858053542824*r**12
            +5171882732408*r**14+15027395767802*r**16+8501117974182*r**18+18793969576508*r**20
            +10480371959948*r**22-14376623989014*r**24-4004059389178*r**26-2368602101608*r**28
            -10828862201864*r**30-1471467301199*r**32-767347923785*r**34-166248497382*r**36
            -5217296222*r**38+24094125*r**40+12205875*r**42)+Q2**3*(-8198475+180214935*r**2
            -761871382*r**4+13162240206*r**6+339736018145*r**8-646518862209*r**10
            +5471004439900*r**12-14363670940664*r**14+43589578591242*r**16+14485900968030*r**18
            +5723709185932*r**20+28275065084820*r**22+8139257967114*r**24-59750693767802*r**26
            -52989187140720*r**28+59899554564488*r**30-43086810510655*r**32+9768706591467*r**34
            -3062176040646*r**36+25502854670*r**38-53177109611*r**40-1660849125*r**42
            -32949660*r**44)-Q2*(-1+r**2)**2*(684825-17991675*r**2+6583784*r**4
            -3281519032*r**6-107137155873*r**8+224417852591*r**10-1880331140460*r**12
            +6886400002728*r**14-41864118230894*r**16+40932763014874*r**18+58037044971432*r**20
            -30491260360360*r**22-99478035613418*r**24+74732484215334*r**26+36689065357696*r**28
            -35284079111112*r**30+17011169401125*r**32-2336875402159*r**34+728880172592*r**36
            +22327916928*r**38+8512462139*r**40+213439995*r**42+2768940*r**44)+Q2**2*(3379035
            -84132330*r**2+310899043*r**4-10143942050*r**6-294929237119*r**8+721973248062*r**10
            -4651541905087*r**12+16037888152182*r**14-82247293182130*r**16+79087865117132*r**18
            +24879248368894*r**20+6522502300316*r**22+37291682545026*r**24-147761028992180*r**26
            +57641862080418*r**28+127329648232636*r**30-109519483139001*r**32+49442547356830*r**34
            -9158526655025*r**36+2291087890694*r**38+20232719373*r**40+31591514102*r**42
            +878418669*r**44+13602510*r**46))+418037760000*logq2**6*(-Q2+(-1+r)**2)*r**22*(
            -81-231*r**2-620*r**4+1536*r**6-163*r**8+15*r**10)*(-Q2+(1+r)**2)*sqrtq2
            +33177600*logq2**4*r**14*(60*Q2**14*(413+2645*r**4)-120*Q2**13*(2393+3156*r**2
            +13712*r**4+16940*r**6)+6*Q2**12*(242906+632040*r**2+1644025*r**4+2954901*r**6
            +1925510*r**8)-2*Q2**11*(2119236+8167956*r**2+19841435*r**4+37194556*r**6
            +41289501*r**8+18849060*r**10)+Q2**10*(7776501+39199953*r**2+102449561*r**4
            +195933321*r**6+258041108*r**8+212341566*r**10+75250710*r**12)-10*Q2**9*(963687
            +5686470*r**2+16469485*r**4+32896302*r**6+45673435*r**8+46111550*r**10
            +31162305*r**12+8593110*r**14)+5*Q2**8*(1890225+10501017*r**2+34174290*r**4
            +67666510*r**6+82804525*r**8+79454569*r**10+70096128*r**12+43109172*r**14
            +5673060*r**16)+Q2**7*(-9733752-36735000*r**2-151526835*r**4-266479252*r**6
            -123188075*r**8+244104568*r**10+367542115*r**12+159075540*r**14+52811523*r**16
            +70494480*r**18)+Q2**6*(9792054+28547994*r**2+164597985*r**4+311232029*r**6
            +165376849*r**8-468600051*r**10-1243370261*r**12-1196807745*r**14-555537291*r**16
            -228782331*r**18-118913760*r**20)+Q2**5*(-5189052-22423776*r**2-130724967*r**4
            -307858792*r**6-477606586*r**8-262667904*r**10+462527764*r**12+1159593968*r**14
            +1039453958*r**16+415841424*r**18+175004163*r**20+73785480*r**22)+5*Q2**4*(
            -574602+2341410*r**2-3187035*r**4+6360745*r**6+59527490*r**8+64308430*r**10
            +34859556*r**12+12955372*r**14-29922940*r**16-22358800*r**18-4171881*r**20
            -11123925*r**22+555780*r**24)+(-1+r**2)**4*(-260799-108723*r**2-9877967*r**4
            -8679915*r**6-5080288*r**8-11043788*r**10+72182352*r**12+22777472*r**14
            -20587445*r**16+35390703*r**18+9742127*r**20+701211*r**22+1029060*r**24)
            -5*Q2**3*(-1419312+1204608*r**2-28895673*r**4-34256284*r**6-11723591*r**8
            -83345696*r**10+4078122*r**12+74121488*r**14+10832678*r**16+16399480*r**18
            +91085007*r**20+37327404*r**22-4024431*r**24+7240200*r**26)-Q2*(-1
            +r**2)**2*(-1831818+258096*r**2-58120075*r**4-58048954*r**6-41579811*r**8
            -200934032*r**10+297495098*r**12+561002328*r**14+34598344*r**16-105304204*r**18
            +193295985*r**20+60754466*r**22-170043*r**24+8056620*r**26)+Q2**2*(-5211159
            +5996085*r**2-137670290*r**4-59362994*r**6-21103075*r**8-505177697*r**10
            +248511570*r**12+865628780*r**14+865865923*r**16+55365315*r**18-426612094*r**20
            +331840470*r**22+161628935*r**24-26173479*r**26+25417710*r**28))*sqrtq2
            +23040*logq2**2*r**6*(24*Q2**22*(9921+36713*r**4)-48*Q2**21*(82757+74934*r**2
            +259939*r**4+315758*r**6)+8*Q2**20*(3719163+6827128*r**2+13223613*r**4
            +24594773*r**6+14559009*r**8)-8*Q2**19*(16476558+45702062*r**2+83584197*r**4
            +155375620*r**6+169855165*r**8+65363910*r**10)+Q2**18*(380261961+1417871075*r**2
            +2889733036*r**4+5228950668*r**6+6795591751*r**8+5331797257*r**10+1488274980*r**12)
            -2*Q2**17*(365675925+1741324660*r**2+3914478455*r**4+7322298656*r**6
            +9410990135*r**8+9150306264*r**10+6298027733*r**12+1321373004*r**14)
            +Q2**16*(887775465+5445206917*r**2+11403111539*r**4+20806293619*r**6
            +19598908935*r**8+7326108835*r**10+12242902901*r**12+16015355909*r**14
            +2303002536*r**16)+4*Q2**15*(-119199660-1193562596*r**2-211234451*r**4
            +3657378488*r**6+17424880461*r**8+42192332484*r**10+46843261531*r**12
            +19255559528*r**14-167088697*r**16+332951568*r**18)-4*Q2**14*(105359127
            -99948007*r**2+8019023583*r**4+33075532159*r**6+87735716435*r**8+178500070395*r**10
            +237571699897*r**12+187056186569*r**14+69725474070*r**16+9199507180*r**18
            +1701387840*r**20)+4*Q2**13*(273809298+1170938020*r**2+17012074623*r**4
            +70988855096*r**6+177727809006*r**8+356086329720*r**10+523691473748*r**12
            +532752287664*r**14+347195924208*r**16+107312036228*r**18+16717777181*r**20
            +2138946840*r**22)-4*Q2**12*(227667531+1548210755*r**2+17465080288*r**4
            +83333472708*r**6+184262433918*r**8+320248381826*r**10+464303123340*r**12
            +527699226684*r**14+477464429339*r**16+293063231331*r**18+56741412220*r**20
            +12147353608*r**22+691474212*r**24)-4*Q2**11*(-27047124-948713844*r**2
            -7447655365*r**4-59393050752*r**6-64902870811*r**8+108832590248*r**10
            +428451551390*r**12+700228943240*r**14+662347830230*r**16+330316431716*r**18
            +86693061607*r**20+85793204184*r**22+3547961625*r**24+1560818376*r**26)
            +2*Q2**10*(245187423-392160171*r**2+7988234294*r**4-58632010210*r**6
            +133213856401*r**8+1269057711915*r**10+3414425854024*r**12+5614743641388*r**14
            +6336230686065*r**16+4950700206235*r**18+2578047857798*r**20+968698239670*r**22
            +388096154175*r**24+31877150565*r**26+4835925276*r**28)-4*Q2**9*(118675023
            +195816192*r**2+8801119352*r**4-11986845328*r**6+113771805895*r**8+801174587796*r**10
            +2188352400600*r**12+3677621722356*r**14+4483557983717*r**16+4092744675480*r**18
            +2651567440472*r**20+1158760256104*r**22+489357480805*r**24+144476741940*r**26
            +14003753400*r**28+1211635860*r**30)+2*Q2**8*(73646679+707534395*r**2
            +16227247679*r**4+15022203719*r**6+252262267547*r**8+1219794081815*r**10
            +3369220290323*r**12+4864233067547*r**14+4827547632389*r**16+4042762579529*r**18
            +3015647193077*r**20+1114175154413*r**22-314106758095*r**24+330098279141*r**26
            -27735287751*r**28+5900907953*r**30-1033591080*r**32)+4*Q2**7*(16468908
            -399772300*r**2-5875928441*r**4-30113718760*r**6-135286462149*r**8-339590741628*r**10
            -1158155060473*r**12-1267284734424*r**14-201135722661*r**16+1460533720268*r**18
            +2138767554909*r**20+1548766960776*r**22+1293890660393*r**24+1268152678572*r**26
            +80153977877*r**28+117638216632*r**30+4836399253*r**32+1144055568*r**34)
            +(-1+r**2)**6*(-13647-2988845*r**2-89318198*r**4-282731302*r**6-4504594786*r**8
            +20197346438*r**10-133049882326*r**12+69195338674*r**14+416213747056*r**16
            -408778122948*r**18-149138234890*r**20+285888417422*r**22+26697743746*r**24
            -22814033366*r**26+24005997934*r**28-287212826*r**30+822859199*r**32
            +27948353*r**34+2694312*r**36)-4*Q2**6*(20178417-271971875*r**2-2892158669*r**4
            -33210528787*r**6-84238627713*r**8-132740297485*r**10-881238176259*r**12
            -1103156269971*r**14-744084671887*r**16+482034799245*r**18+2094637545243*r**20
            +2568982976927*r**22+1706691460509*r**24+1107502085433*r**26+1149363901863*r**28
            +95082324295*r**30+95605490882*r**32+4966836266*r**34+670658766*r**36)
            -2*Q2*(-1+r**2)**4*(-24459-15659168*r**2-422907429*r**4-1263381536*r**6
            -19012618780*r**8+73001603852*r**10-468213377836*r**12+14954459044*r**14
            +1200380638694*r**16-76863826868*r**18-931929387022*r**20-140576549244*r**22
            +950923140404*r**24+144530527300*r**26-112661018444*r**28+110959432204*r**30
            -3586989427*r**32+4269879556*r**34+139037867*r**36+16781292*r**38)+4*Q2**5*(7570878
            -47843740*r**2+371020005*r**4-16041705248*r**6+15704876114*r**8-74378808608*r**10
            -253680785174*r**12-294228742304*r**14-522215196362*r**16-485113810904*r**18
            -589498823516*r**20-179158033184*r**22-51232711898*r**24+258488814208*r**26
            +304481825382*r**28+261421253536*r**30+50290397588*r**32+20542657812*r**34
            +1837404967*r**36+50000448*r**38)+4*Q2**4*(-722109-84215191*r**2-2091257796*r**4
            +1239823696*r**6-74812612290*r**8+175986709036*r**10-708984375808*r**12
            -454082693640*r**14-115456216662*r**16-643878092770*r**18-395185494480*r**20
            +309721080624*r**22+227745185768*r**24+1711231601916*r**26+676653347600*r**28
            -443678757992*r**30+402309067275*r**32-52918994607*r**34+21748442500*r**36
            +125202160*r**38+178732770*r**40)+Q2**2*(-1+r**2)**2*(250113-139783859*r**2
            -3370036367*r**4-8064626691*r**6-134437795352*r**8+496248784556*r**10
            -2923857536428*r**12+35506951228*r**14+4327054736446*r**16+1177969875374*r**18
            +55006605726*r**20-1626378967522*r**22-1614745127220*r**24+5005866357356*r**26
            +1492092313348*r**28-1185501112292*r**30+884230976009*r**32-59160732691*r**34
            +37461320089*r**36+1075576205*r**38+180051972*r**40)-4*Q2**3*(305784
            -81720920*r**2-1770885841*r**4-1791664440*r**6-64774150839*r**8+256037427348*r**10
            -1252852541548*r**12+498568402440*r**14+853390334348*r**16-419873739288*r**18
            +866711411370*r**20+718373661656*r**22+265333051638*r**24-1812164210016*r**26
            +1379776745268*r**28+1152418410520*r**30-898406493708*r**32+481396690288*r**34
            -56527699617*r**36+21373592384*r**38+413303753*r**40+129129420*r**42))*sqrtq2
            -64*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(552*Q2**25-2*Q2**24*(5307
            +871*r**2)+2*Q2**23*(-15921-12252*r**2+9917*r**4)+Q2**22*(4217505+639251*r**2
            +4841335*r**4-416099*r**6)+4*Q2**21*(-12099402-3441706*r**2-8432131*r**4
            -15637830*r**6+800881*r**8)+Q2**20*(264717453+100915593*r**2-382709834*r**4
            +454651734*r**6+370105641*r**8-12883907*r**10)+Q2**19*(-843702159-346001108*r**2
            +5025491777*r**4+3809406192*r**6-2517321657*r**8-1199798444*r**10+30052183*r**12)
            -2*Q2**18*(-803079984-332542501*r**2+12594277376*r**4+22408316259*r**6
            +11380183240*r**8-3001265399*r**10-996043188*r**12+18469533*r**14)+Q2**17*(
            -1503221115-1171006476*r**2+74293197722*r**4+194529364276*r**6+224348508968*r**8
            +111171173980*r**10+974408358*r**12-230614980*r**14+1794771*r**16)+2*Q2**16*(
            -280398024+1703543168*r**2-72547930075*r**4-260695180279*r**6-427196923425*r**8
            -429821244593*r**10-195301062437*r**12-21852768425*r**14-3134719815*r**16
            +36019617*r**18)-8*Q2**15*(-432268701+1034306940*r**2-23716417978*r**4
            -126129730964*r**6-257698796919*r**8-343725195024*r**10-293890928629*r**12
            -105459120668*r**14-14358896240*r**16-1618724172*r**18+13626979*r**20)
            +2*Q2**14*(-1848050457+4410641673*r**2-66416452063*r**4-698549550657*r**6
            -1687181706870*r**8-2542530610194*r**10-2619634138602*r**12-1870565126142*r**14
            -417252484713*r**16-58931387967*r**18-4361807967*r**20+17580839*r**22)
            +4*Q2**13*(-46517163+1610295672*r**2-16671903012*r**4+267734671424*r**6
            +700125499815*r**8+1007047839248*r**10+679201012012*r**12+348906625728*r**14
            +363767654279*r**16-147726326120*r**18-11957466968*r**20-2195574176*r**22
            +24152461*r**24)+2*Q2**12*(2150326695-15009959029*r**2+156479125462*r**4
            +133986765174*r**6+684225675105*r**8+2662006158005*r**10+7190298495852*r**12
            +11258646623404*r**14+8250586018841*r**16+3142537705029*r**18+1429431488110*r**20
            +139104269070*r**22+11173132815*r**24-68896597*r**26)+2*Q2**11*(-1906892829
            +15026335428*r**2-180769690013*r**4-802505807072*r**6-2848742435209*r**8
            -8364558146428*r**10-18527144040233*r**12-30321830276992*r**14-31845989417967*r**16
            -16430808598388*r**18-6295021786351*r**20-1604987317152*r**22-146653596843*r**24
            -6947329620*r**26+19036277*r**28)+4*Q2**10*(-87739953+1407264368*r**2
            +19375570493*r**4+400110392698*r**6+1205247478141*r**8+4025487220026*r**10
            +7697753708771*r**12+13892129020812*r**14+17781560593385*r**16+15755915840788*r**18
            +3206522778291*r**20+2000174631922*r**22+44335299243*r**24+4132634114*r**26
            -2098261331*r**28+20372392*r**30)+Q2**9*(3016151886-39227755400*r**2
            +287608650396*r**4-640533583048*r**6-1179824218844*r**8-8607770783912*r**10
            +6564016805388*r**12+26092204338200*r**14+30423809848240*r**16+26414319744168*r**18
            +2443318746548*r**20+37363351682792*r**22+4116655382812*r**24+3267705213576*r**26
            +254270956964*r**28+19135699656*r**30-95776062*r**32)+2*Q2**8*(-985595241
            +15752528067*r**2-168883671142*r**4-2589997694*r**6+169095109910*r**8
            +3938379894246*r**10-15511741525574*r**12-51022774165726*r**14-85014273566532*r**16
            -85761070612700*r**18-65867470123954*r**20-28880472373626*r**22-27483465071654*r**24
            -5165526033814*r**26-1618309378850*r**28-118440964266*r**30-4973260227*r**32
            +12875337*r**34)+2*Q2**7*(-121874415+1098617020*r**2+33999750223*r**4
            +157934385136*r**6-166472337552*r**8-3083238961520*r**10+13965935690168*r**12
            +44159349573168*r**14+82548091451242*r**16+107694443714792*r**18+81311802692190*r**20
            +28673435098576*r**22+29220611576984*r**24+5901190717584*r**26+3228749635040*r**28
            +191929782800*r**30+14208861821*r**32-1813328580*r**34+14932923*r**36)
            -Q2**6*(-1012105017+20096935549*r**2-157000154623*r**4+701955580483*r**6
            +1607263603620*r**8+1228052500700*r**10+13072721009436*r**12+36354609944548*r**14
            +61911136585514*r**16+23028869241726*r**18+56092509378726*r**20+64801397925506*r**22
            -166290673696092*r**24+55008550143868*r**26-36529726920612*r**28+549152940356*r**30
            -1577240851001*r**32-101707138643*r**34-7406303775*r**36+31232531*r**38)
            +4*Q2**5*(-123846693+3112200186*r**2-34393979645*r**4+177981225486*r**6
            +591491337228*r**8+739117862536*r**10-433270542328*r**12+6899979825880*r**14
            +16664087207766*r**16-5908237645012*r**18-22925704305386*r**20-31677018562172*r**22
            +36074199717800*r**24-69548877987800*r**26+13550981411120*r**28-9132423288264*r**30
            -393521324361*r**32-310301809110*r**34-19742589777*r**36-856756386*r**38
            +2360932*r**40)+2*(-1+r**2)**4*(-713952+27780360*r**2-347059039*r**4
            +4869023785*r**6+11187636069*r**8-130095279279*r**10+872775613692*r**12
            -3504129849948*r**14+15595827468220*r**16-34416000482332*r**18+21819053999334*r**20
            +19120143213694*r**22-33229895366962*r**24+17303684239230*r**26-5621065043268*r**28
            +878091771252*r**30-189079040004*r**32-1074918676*r**34-3082172735*r**36
            -145270719*r**38-5081355*r**40+12633*r**42)+Q2**4*(-40485699+163845529*r**2
            +15526754078*r**4-164451219330*r**6-757705129059*r**8-698528460031*r**10
            +8133424879448*r**12-38465880240936*r**14-46324288698982*r**16-8053116369230*r**18
            -50779644641980*r**20-67817771714940*r**22+217385222773538*r**24-185228571117846*r**26
            +120920188081912*r**28-11694463786376*r**30+6604294547145*r**32+1293315495445*r**34
            +176477646158*r**36+13864067502*r**38-277379039*r**40+3232693*r**42)
            +Q2**3*(148761633-4092956820*r**2+40616212625*r**4-276476741040*r**6
            -366777352525*r**8+2181456625668*r**10-13377257695261*r**12+37542139690176*r**14
            -91162253666390*r**16-17976006442440*r**18+28950276342538*r**20-170198831929632*r**22
            +237590488803462*r**24+42279627131400*r**26-160612157964570*r**28+128830473489088*r**30
            -40959916435323*r**32+11159174533148*r**34-814146443595*r**36+262255630160*r**38
            +12616776823*r**40+1024554036*r**42-3963161*r**44)-Q2*(-1+r**2)**2*(
            -15826797+566876850*r**2-7032125705*r**4+80026236360*r**6+140470479861*r**8
            -1529768515530*r**10+8893444011513*r**12-26641684352656*r**14+107768469897470*r**16
            -149016152967228*r**18-88594866345978*r**20+214634130173696*r**22+85120587582858*r**24
            -311020332025220*r**26+199832579011698*r**28-74508128770416*r**30+13999105113919*r**32
            -2967364080278*r**34+43877266515*r**36-53326560456*r**38-2626419279*r**40
            -111288978*r**42+307781*r**44)+2*Q2**2*(-35714850+1173611559*r**2-14209733526*r**4
            +131901417539*r**6+104987476438*r**8-1701102620075*r**10+9115691114046*r**12
            -24455119375947*r**14+90431727048860*r**16-112973508820154*r**18+24392148235460*r**20
            -94076079107602*r**22+146467011253372*r**24+110882386246826*r**26-335263882960356*r**28
            +245305622403930*r**30-100596891125370*r**32+22968899616451*r**34-4676014807438*r**36
            +221150020447*r**38-89276363090*r**40-4482094383*r**42-248825850*r**44
            +783713*r**46))*sqrtq2))/(6348948480000*logq2**5*(-Q2+(-1+r)**2)*r**22*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+146966400000*logq2**3*(-Q2
            +(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+306180000*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-12697896960000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-1322697600000*logq2**4*(-Q2+(
            -1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-9185400000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -4252500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**6*sqrtq2)+(16*(Q2-(-1+r)**2)**6*r**6*(1-Q2+r**2)*(Q2-(1
            +r)**2)**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(-238556*Q2**23
            +8*Q2**22*(70011+36731*r**2)+8*Q2**21*(-1944750-4903224*r**2+2738135*r**4)
            +Q2**20*(234166051+3483520121*r**2+600833801*r**4-194199709*r**6)+2*Q2**19*(
            -686535645-19403135348*r**2-24532197510*r**4-2084439588*r**6+413319895*r**8)
            +Q2**18*(4171924374+188082403290*r**2+492358423364*r**4+290397221004*r**6
            +16230568710*r**8-2114595526*r**10)+Q2**17*(-6602021742-461515253756*r**2
            -2112853130246*r**4-2508458287464*r**6-922512838946*r**8-37837855436*r**10
            +3370059638*r**12)+Q2**16*(2539415655+431233846505*r**2+4382917255959*r**4
            +8422107069009*r**6+6499185829409*r**8+1616036579679*r**10+50140804785*r**12
            -3031993225*r**14)+8*Q2**15*(1269361662+77926919823*r**2-318037056917*r**4
            -1173770386626*r**6-1630124179890*r**8-1055588138021*r**10-144865403457*r**12
            -2974448292*r**14+88283062*r**16)+8*Q2**14*(-2379972085-280223357344*r**2
            -999063128350*r**4-1916365495097*r**6-2405375087836*r**8-219809410711*r**10
            +310814028868*r**12-129223653985*r**14-3421285189*r**16+142414785*r**18)
            +8*Q2**13*(978030333+254608645605*r**2+2362598540586*r**4+6819527173683*r**6
            +15178117958471*r**8+12318797029833*r**10+3829710098421*r**12+1055572901573*r**14
            +359475445236*r**16+3788006010*r**18+23046633*r**20)-2*Q2**12*(-8073676299
            -604665685845*r**2+6044808000651*r**4+18667145773161*r**6+85948740516522*r**8
            +104378539626142*r**10+60018442839942*r**12+18342804035082*r**14+7197315919801*r**16
            +794771627391*r**18-22875179145*r**20+1596529701*r**22)+4*Q2**11*(-5983853135
            -1049648914782*r**2-2983379568288*r**4-14893460939004*r**6-3386310940885*r**8
            -2662382373556*r**10-11897348432688*r**12+3748311074504*r**14+5745340420415*r**16
            +3392635638226*r**18-414524670528*r**20-26919041292*r**22+906981205*r**24)
            +4*Q2**10*(1302912489+686153281333*r**2+6515211598998*r**4+28006054602456*r**6
            +75659789033875*r**8+125351504075313*r**10+205906091148432*r**12+113008401365332*r**14
            +12980288407683*r**16-7430929045365*r**18-2257369692614*r**20+675688912788*r**22
            +14508184353*r**24-161500721*r**26)-4*Q2**9*(-3900429495-404242427148*r**2
            +3469636565735*r**4+4305575899530*r**6+80881106111571*r**8+91706180974706*r**10
            +366727806740181*r**12+315740382120300*r**14+114901206015191*r**16+407904525936*r**18
            -9177221800839*r**20+601951174250*r**22+151999610445*r**24-11630827638*r**26
            +509798795*r**28)+2*Q2**8*(-7740470613-1741274092775*r**2-3389897879009*r**4
            -52430613388095*r**6+23382125935627*r**8-323878184121095*r**10+518421201365007*r**12
            +769670045147473*r**14+517609501142593*r**16+157749891379467*r**18-9211157667395*r**20
            -3280705652093*r**22+7869828006345*r**24-667132856669*r**26-38384004395*r**28
            +884172587*r**30)-4*Q2**7*(-459995607-361799952874*r**2-3296581277898*r**4
            -21545491143084*r**6-49134816616264*r**8-270122872324014*r**10+33417459760770*r**12
            +365065577724992*r**14+493087142015838*r**16+333991133100762*r**18+87352875094490*r**20
            +2423050164516*r**22+6474004743576*r**24+3538159884926*r**26-268078931538*r**28
            -5143780344*r**30+2686313*r**32)-8*Q2**6*(-776499780-118481141223*r**2
            +818782723246*r**4-2830111152285*r**6+29082989459754*r**8-2354560443347*r**10
            +134202444689988*r**12-235436203971879*r**14-293625541649444*r**16-330450630480039*r**18
            -163343453630154*r**20-23661782490227*r**22-1918689335262*r**24-3785107965621*r**26
            +178154754520*r**28-3624434889*r**30-3718502628*r**32+103285270*r**34)
            +8*Q2**5*(-557601313-153372055925*r**2-16220042135*r**4-8299848136411*r**6
            +16707099114895*r**8-146087700373535*r**10+376397770547535*r**12-417249899658395*r**14
            +88655150617549*r**16-286204057030585*r**18-89969276266871*r**20-48765846130025*r**22
            +17613763257165*r**24-3597716564045*r**26-3104673215315*r**28+1294660249439*r**30
            -50003384840*r**32-3442825190*r**34+61581202*r**36)+Q2**4*(534300615
            +355968413981*r**2+1901352669885*r**4+27576752496447*r**6-3101165164468*r**8
            +839530565044212*r**10-3164865493628700*r**12+4825177800428860*r**14-5312679820791918*r**16
            +1451907193373526*r**18+2554410312475526*r**20-132225630794958*r**22+147405116391900*r**24
            -186077879737340*r**26+40112574824532*r**28+13214175444972*r**30-5782687807873*r**32
            +179566118805*r**34+4748208261*r**36-13242265*r**38)-2*Q2**3*(-418455747
            -77885244960*r**2+620235899642*r**4-5144790364236*r**6+36251765485941*r**8
            -78548118762976*r**10-55378921719144*r**12+608560347852960*r**14-1882933520909126*r**16
            +2071797941727168*r**18+117829004396796*r**20+1742388425108168*r**22+183813618783954*r**24
            +54956440812960*r**26-12947823074984*r**28+10219141420224*r**30-2741920628439*r**32
            +332067126944*r**34-1718810598*r**36-2759233500*r**38+59148953*r**40)
            +3*(-1+r**2)**2*(-4229183-1704423495*r**2+1282566234*r**4-209311950310*r**6
            +756826967541*r**8-11123432889651*r**10+88544624107288*r**12-441989934495432*r**14
            +1352891786245410*r**16-2234363828578638*r**18+1716831517428636*r**20
            -374649111133764*r**22-18075143505838*r**24-66528871119390*r**26-36881701034472*r**28
            -1269711096712*r**30-364529197731*r**32-356469927339*r**34+33634371290*r**36
            -297916806*r**38-37294215*r**40+466577*r**42)+2*Q2**2*(-258981061-75387916639*r**2
            +239993690978*r**4-6805585990150*r**6+31665366990767*r**8-239852289375343*r**10
            +1104814683818848*r**12-2904838044542624*r**14+3800727708880510*r**16
            -1397470528313446*r**18+490584532626260*r**20-560211631327420*r**22-586716841092386*r**24
            -146610088823870*r**26-200792158715984*r**28+16913846530928*r**30+1997972977127*r**32
            -6488702758843*r**34+957609406010*r**36-12633256462*r**38-1970020909*r**40
            +31793709*r**42)-6*Q2*(-21560795-7557498626*r**2+19761771549*r**4-815691430392*r**6
            +3993220057227*r**8-38941501209974*r**10+258667912905739*r**12-1048815822941552*r**14
            +2528750948928786*r**16-3083503658937316*r**18+1410122452815842*r**20
            +74792932438304*r**22+188687739206422*r**24-232817679772796*r**26-43047002724874*r**28
            -71171947362832*r**30+1217233907129*r**32+393053285766*r**34-1158391814223*r**36
            +126594560088*r**38-1230340241*r**40-180048046*r**42+2484815*r**44))
            -16*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))**2*(238556*Q2**23-8*Q2**22*(70011+36731*r**2)
            -8*Q2**21*(-1944750-4903224*r**2+2738135*r**4)+Q2**20*(-234166051-3483520121*r**2
            -600833801*r**4+194199709*r**6)+Q2**19*(1373071290+38806270696*r**2+49064395020*r**4
            +4168879176*r**6-826639790*r**8)+2*Q2**18*(-2085962187-94041201645*r**2
            -246179211682*r**4-145198610502*r**6-8115284355*r**8+1057297763*r**10)
            +Q2**17*(6602021742+461515253756*r**2+2112853130246*r**4+2508458287464*r**6
            +922512838946*r**8+37837855436*r**10-3370059638*r**12)+Q2**16*(-2539415655
            -431233846505*r**2-4382917255959*r**4-8422107069009*r**6-6499185829409*r**8
            -1616036579679*r**10-50140804785*r**12+3031993225*r**14)-8*Q2**15*(1269361662
            +77926919823*r**2-318037056917*r**4-1173770386626*r**6-1630124179890*r**8
            -1055588138021*r**10-144865403457*r**12-2974448292*r**14+88283062*r**16)
            -8*Q2**14*(-2379972085-280223357344*r**2-999063128350*r**4-1916365495097*r**6
            -2405375087836*r**8-219809410711*r**10+310814028868*r**12-129223653985*r**14
            -3421285189*r**16+142414785*r**18)-8*Q2**13*(978030333+254608645605*r**2
            +2362598540586*r**4+6819527173683*r**6+15178117958471*r**8+12318797029833*r**10
            +3829710098421*r**12+1055572901573*r**14+359475445236*r**16+3788006010*r**18
            +23046633*r**20)+2*Q2**12*(-8073676299-604665685845*r**2+6044808000651*r**4
            +18667145773161*r**6+85948740516522*r**8+104378539626142*r**10+60018442839942*r**12
            +18342804035082*r**14+7197315919801*r**16+794771627391*r**18-22875179145*r**20
            +1596529701*r**22)-4*Q2**11*(-5983853135-1049648914782*r**2-2983379568288*r**4
            -14893460939004*r**6-3386310940885*r**8-2662382373556*r**10-11897348432688*r**12
            +3748311074504*r**14+5745340420415*r**16+3392635638226*r**18-414524670528*r**20
            -26919041292*r**22+906981205*r**24)+4*Q2**10*(-1302912489-686153281333*r**2
            -6515211598998*r**4-28006054602456*r**6-75659789033875*r**8-125351504075313*r**10
            -205906091148432*r**12-113008401365332*r**14-12980288407683*r**16+7430929045365*r**18
            +2257369692614*r**20-675688912788*r**22-14508184353*r**24+161500721*r**26)
            +4*Q2**9*(-3900429495-404242427148*r**2+3469636565735*r**4+4305575899530*r**6
            +80881106111571*r**8+91706180974706*r**10+366727806740181*r**12+315740382120300*r**14
            +114901206015191*r**16+407904525936*r**18-9177221800839*r**20+601951174250*r**22
            +151999610445*r**24-11630827638*r**26+509798795*r**28)-2*Q2**8*(-7740470613
            -1741274092775*r**2-3389897879009*r**4-52430613388095*r**6+23382125935627*r**8
            -323878184121095*r**10+518421201365007*r**12+769670045147473*r**14+517609501142593*r**16
            +157749891379467*r**18-9211157667395*r**20-3280705652093*r**22+7869828006345*r**24
            -667132856669*r**26-38384004395*r**28+884172587*r**30)+4*Q2**7*(-459995607
            -361799952874*r**2-3296581277898*r**4-21545491143084*r**6-49134816616264*r**8
            -270122872324014*r**10+33417459760770*r**12+365065577724992*r**14+493087142015838*r**16
            +333991133100762*r**18+87352875094490*r**20+2423050164516*r**22+6474004743576*r**24
            +3538159884926*r**26-268078931538*r**28-5143780344*r**30+2686313*r**32)
            +8*Q2**6*(-776499780-118481141223*r**2+818782723246*r**4-2830111152285*r**6
            +29082989459754*r**8-2354560443347*r**10+134202444689988*r**12-235436203971879*r**14
            -293625541649444*r**16-330450630480039*r**18-163343453630154*r**20-23661782490227*r**22
            -1918689335262*r**24-3785107965621*r**26+178154754520*r**28-3624434889*r**30
            -3718502628*r**32+103285270*r**34)-8*Q2**5*(-557601313-153372055925*r**2
            -16220042135*r**4-8299848136411*r**6+16707099114895*r**8-146087700373535*r**10
            +376397770547535*r**12-417249899658395*r**14+88655150617549*r**16-286204057030585*r**18
            -89969276266871*r**20-48765846130025*r**22+17613763257165*r**24-3597716564045*r**26
            -3104673215315*r**28+1294660249439*r**30-50003384840*r**32-3442825190*r**34
            +61581202*r**36)+Q2**4*(-534300615-355968413981*r**2-1901352669885*r**4
            -27576752496447*r**6+3101165164468*r**8-839530565044212*r**10+3164865493628700*r**12
            -4825177800428860*r**14+5312679820791918*r**16-1451907193373526*r**18
            -2554410312475526*r**20+132225630794958*r**22-147405116391900*r**24+186077879737340*r**26
            -40112574824532*r**28-13214175444972*r**30+5782687807873*r**32-179566118805*r**34
            -4748208261*r**36+13242265*r**38)+2*Q2**3*(-418455747-77885244960*r**2
            +620235899642*r**4-5144790364236*r**6+36251765485941*r**8-78548118762976*r**10
            -55378921719144*r**12+608560347852960*r**14-1882933520909126*r**16+2071797941727168*r**18
            +117829004396796*r**20+1742388425108168*r**22+183813618783954*r**24+54956440812960*r**26
            -12947823074984*r**28+10219141420224*r**30-2741920628439*r**32+332067126944*r**34
            -1718810598*r**36-2759233500*r**38+59148953*r**40)-3*(-1+r**2)**2*(-4229183
            -1704423495*r**2+1282566234*r**4-209311950310*r**6+756826967541*r**8
            -11123432889651*r**10+88544624107288*r**12-441989934495432*r**14+1352891786245410*r**16
            -2234363828578638*r**18+1716831517428636*r**20-374649111133764*r**22-18075143505838*r**24
            -66528871119390*r**26-36881701034472*r**28-1269711096712*r**30-364529197731*r**32
            -356469927339*r**34+33634371290*r**36-297916806*r**38-37294215*r**40
            +466577*r**42)-2*Q2**2*(-258981061-75387916639*r**2+239993690978*r**4
            -6805585990150*r**6+31665366990767*r**8-239852289375343*r**10+1104814683818848*r**12
            -2904838044542624*r**14+3800727708880510*r**16-1397470528313446*r**18
            +490584532626260*r**20-560211631327420*r**22-586716841092386*r**24-146610088823870*r**26
            -200792158715984*r**28+16913846530928*r**30+1997972977127*r**32-6488702758843*r**34
            +957609406010*r**36-12633256462*r**38-1970020909*r**40+31793709*r**42)
            +6*Q2*(-21560795-7557498626*r**2+19761771549*r**4-815691430392*r**6
            +3993220057227*r**8-38941501209974*r**10+258667912905739*r**12-1048815822941552*r**14
            +2528750948928786*r**16-3083503658937316*r**18+1410122452815842*r**20
            +74792932438304*r**22+188687739206422*r**24-232817679772796*r**26-43047002724874*r**28
            -71171947362832*r**30+1217233907129*r**32+393053285766*r**34-1158391814223*r**36
            +126594560088*r**38-1230340241*r**40-180048046*r**42+2484815*r**44))*sqrtq2
            +logq2**8*(-20316635136000000*r**38*(1+r**2)**2*(1-Q2+r**2)*(2593-15525*r**2
            +10851*r**4+4129*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-20316635136000000*(Q2
            -(-1+r)**2)**2*r**38*(1+r**2)**2*(2593-15525*r**2+10851*r**4+4129*r**6)*(Q2
            -(1+r)**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**7*(
            -32248627200000*r**32*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(
            -73990*Q2**9*(1+r**2)+10*Q2**8*(70819+125288*r**2+54469*r**4)-20*Q2**7*(142695
            +355286*r**2+236126*r**4+23535*r**6)+Q2**6*(6274352+19463486*r**2+16705222*r**4
            -3079550*r**6-5204598*r**8)+2*Q2**5*(-3914071-14882469*r**2-11831084*r**4
            +10193304*r**6+18767169*r**8+7711179*r**10)+Q2**4*(4439400+24546361*r**2
            +10686293*r**4-55008834*r**6-79333190*r**8-47561659*r**10-11034555*r**12)
            +Q2**3*(1479800-5767909*r**2+5943744*r**4+36714279*r**6+69329256*r**8
            +57839061*r**10-4203344*r**12-16235975*r**14)+6*(-1+r**2)**2*(-94073
            -210972*r**2+1869870*r**4-2608240*r**6-10129698*r**8+5484600*r**10+6147514*r**12
            +1837012*r**14+1144627*r**16)+Q2**2*(-4143440-6041819*r**2+6417931*r**4
            -7110039*r**6-52650489*r**8+18559587*r**10+18404093*r**12+43513871*r**14
            +36380225*r**16)-3*Q2*(-854056-1209535*r**2+8877546*r**4-5767110*r**6
            -57744266*r**8-10152596*r**10+56619438*r**12+22160062*r**14+6863898*r**16
            +8731739*r**18))-32248627200000*r**32*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(73990*Q2**10*(1+r**2)-20*Q2**9*(39109+70043*r**2+30934*r**4)
            +10*Q2**8*(356209+906679*r**2+652009*r**4+101539*r**6)+Q2**7*(-9128252
            -29423106*r**2-28533462*r**4-2113670*r**6+4733898*r**8)-14*Q2**6*(-1007321
            -3964484*r**2-4273634*r**4+482924*r**6+3272749*r**8+1473354*r**10)+Q2**5*(
            -12267542-62139441*r**2-64113399*r**4+51733274*r**6+137254136*r**8+100518355*r**10
            +26456913*r**12)+10*Q2**4*(295960+3475367*r**2+2928891*r**4-8103682*r**6
            -20367128*r**8-18473391*r**10-5439287*r**12+520142*r**14)+2*Q2**3*(2811620
            +876855*r**2-3121048*r**4+24884031*r**6+79347012*r**8+54304365*r**10
            +17615812*r**12-31976595*r**14-26308100*r**16)+6*(-1+r**2)**2*(-94073
            -305045*r**2+1658898*r**4-738370*r**6-12737938*r**8-4645098*r**10+11632114*r**12
            +7984526*r**14+2981639*r**16+1144627*r**18)+2*Q2**2*(-3352804-6906932*r**2
            +13504375*r**4-8996719*r**6-116496663*r**8-32274345*r**10+103410997*r**12
            +64199075*r**14+50242895*r**16+31287721*r**18)-3*Q2*(-1042202-2109243*r**2
            +12063493*r**4-10007468*r**6-69598072*r**8-21625350*r**10+16564074*r**12
            +68832668*r**14+36260194*r**16+14691153*r**18+11020993*r**20))*sqrtq2)
            +logq2**6*(-179159040000*r**28*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1183840*Q2**13*(1+r**2)-60*Q2**12*(100509+157418*r**2+56909*r**4)
            +30*Q2**11*(-413264-211073*r**2+244206*r**4+42015*r**6)-4*Q2**10*(-42037524
            -66729251*r**2+15953307*r**4+60810735*r**6+21556741*r**8)+60*Q2**9*(
            -9047082-17444086*r**2+8839204*r**4+46134071*r**6+38993564*r**8+10095701*r**10)
            -30*Q2**8*(-27242298-64680255*r**2+46994005*r**4+325834142*r**6+435696658*r**8
            +248496221*r**10+54201743*r**12)+5*Q2**7*(-70947276-367698791*r**2-139936206*r**4
            +2175911407*r**6+5012955792*r**8+4683399099*r**10+2112854706*r**12+423315301*r**14)
            -30*Q2**6*(26607336-13986693*r**2-323996442*r**4-532661929*r**6+169629010*r**8
            +1054901505*r**10+823410938*r**12+238516621*r**14+39990342*r**16)+3*Q2**5*(491421396
            +286740109*r**2-6522485108*r**4-18172020010*r**6-11687747824*r**8+14235649416*r**10
            +24361276604*r**12+11603076802*r**14+1259697220*r**16-51284029*r**18)
            +20*Q2**4*(-43833359-34455292*r**2+884395149*r**4+2604865130*r**6+843794173*r**8
            -5099756370*r**10-8143327309*r**12-5567084462*r**14-1819351422*r**16
            -165630422*r**18+38517992*r**20)-15*Q2**3*(11318652-7931199*r**2+194684522*r**4
            +558726693*r**6-1332483644*r**8-6237222190*r**10-10601435304*r**12-8088491174*r**14
            -1104922528*r**16+972638637*r**18+90586654*r**20+60027585*r**22)+18*(
            -1+r**2)**2*(2885662-2938943*r**2-104984619*r**4+53867035*r**6+445925951*r**8
            -969194042*r**10-2016255206*r**12+162465762*r**14+1482887140*r**16+1474102649*r**18
            +817252305*r**20+93258499*r**22+5796607*r**24)+30*Q2**2*(17614664-9808613*r**2
            -297405702*r**4-453911427*r**6-1308172*r**8-277624970*r**10-1064152572*r**12
            -752482126*r**14+842815144*r**16+3153396511*r**18+2192019106*r**20+235793185*r**22
            +27726972*r**24)-45*Q2*(6235380-9639285*r**2-163847284*r**4+9952616*r**6
            +621275472*r**8-954862801*r**10-2963818904*r**12-205336912*r**14+2205688196*r**16
            +1204193857*r**18+1323838220*r**20+1101489768*r**22+126683960*r**24+10257797*r**26))
            -179159040000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1183840*Q2**13*(1
            +r**2)-60*Q2**12*(100509+157418*r**2+56909*r**4)+30*Q2**11*(-413264
            -211073*r**2+244206*r**4+42015*r**6)-4*Q2**10*(-42037524-66729251*r**2
            +15953307*r**4+60810735*r**6+21556741*r**8)+60*Q2**9*(-9047082-17444086*r**2
            +8839204*r**4+46134071*r**6+38993564*r**8+10095701*r**10)-30*Q2**8*(
            -27242298-64680255*r**2+46994005*r**4+325834142*r**6+435696658*r**8
            +248496221*r**10+54201743*r**12)+5*Q2**7*(-70947276-367698791*r**2-139936206*r**4
            +2175911407*r**6+5012955792*r**8+4683399099*r**10+2112854706*r**12+423315301*r**14)
            -30*Q2**6*(26607336-13986693*r**2-323996442*r**4-532661929*r**6+169629010*r**8
            +1054901505*r**10+823410938*r**12+238516621*r**14+39990342*r**16)+3*Q2**5*(491421396
            +286740109*r**2-6522485108*r**4-18172020010*r**6-11687747824*r**8+14235649416*r**10
            +24361276604*r**12+11603076802*r**14+1259697220*r**16-51284029*r**18)
            +20*Q2**4*(-43833359-34455292*r**2+884395149*r**4+2604865130*r**6+843794173*r**8
            -5099756370*r**10-8143327309*r**12-5567084462*r**14-1819351422*r**16
            -165630422*r**18+38517992*r**20)-15*Q2**3*(11318652-7931199*r**2+194684522*r**4
            +558726693*r**6-1332483644*r**8-6237222190*r**10-10601435304*r**12-8088491174*r**14
            -1104922528*r**16+972638637*r**18+90586654*r**20+60027585*r**22)+18*(
            -1+r**2)**2*(2885662-2938943*r**2-104984619*r**4+53867035*r**6+445925951*r**8
            -969194042*r**10-2016255206*r**12+162465762*r**14+1482887140*r**16+1474102649*r**18
            +817252305*r**20+93258499*r**22+5796607*r**24)+30*Q2**2*(17614664-9808613*r**2
            -297405702*r**4-453911427*r**6-1308172*r**8-277624970*r**10-1064152572*r**12
            -752482126*r**14+842815144*r**16+3153396511*r**18+2192019106*r**20+235793185*r**22
            +27726972*r**24)-45*Q2*(6235380-9639285*r**2-163847284*r**4+9952616*r**6
            +621275472*r**8-954862801*r**10-2963818904*r**12-205336912*r**14+2205688196*r**16
            +1204193857*r**18+1323838220*r**20+1101489768*r**22+126683960*r**24+10257797*r**26))*sqrtq2)
            +logq2**5*(995328000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(4735360*Q2**17
            +160*Q2**16*(298567+363967*r**2)-10*Q2**15*(131081687+184892990*r**2
            +61639655*r**4)+6*Q2**14*(1637077323+3454141441*r**2+2131036609*r**4
            +311421707*r**6)-6*Q2**13*(6445913727+19262073956*r**2+19495333720*r**4
            +6948572544*r**6+367954573*r**8)+6*Q2**12*(14810516763+61162736848*r**2
            +90748487256*r**4+58334313614*r**6+14577603117*r**8+462189762*r**10)
            -4*Q2**11*(26920726338+166849318308*r**2+347444302170*r**4+336316871050*r**6
            +160851911265*r**8+37135454052*r**10+3824914197*r**12)+Q2**10*(7890109638
            +552546324939*r**2+1824855346968*r**4+2628692687465*r**6+2013946147250*r**8
            +850272595317*r**10+230195965656*r**12+46451831487*r**14)-Q2**9*(-186919135224
            -260302213083*r**2+548025237633*r**4+2379709009369*r**6+3982895020105*r**8
            +3447685177531*r**10+1469121599127*r**12+348719180583*r**14+73447114359*r**16)
            +2*Q2**8*(-135784888613-540277145169*r**2-866867869230*r**4+109653779894*r**6
            +3377429111178*r**8+6065310560142*r**10+4698125025986*r**12+1673330419950*r**14
            +252660911079*r**16+34839121663*r**18)-2*Q2**7*(-52693519957-468118069252*r**2
            -1140939524919*r**4-646298147936*r**6+4145486763862*r**8+11795793505320*r**10
            +13602014745058*r**12+7983513816976*r**14+2411207247879*r**16+280729841372*r**18
            +22006989437*r**20)+2*Q2**6*(68932829647-45905910788*r**2-199258628045*r**4
            -542449101580*r**6+111228099470*r**8+6353612656070*r**10+15097364151410*r**12
            +14103282271130*r**14+6196663230755*r**16+1583773256110*r**18+188141066923*r**20
            +8804309458*r**22)+6*Q2**5*(-32235862911-66338398353*r**2-236940501441*r**4
            +169550483615*r**6+2578739760720*r**8+3736801232340*r**10-1103916772860*r**12
            -6058515468420*r**14-4478498976225*r**16-1002408161955*r**18-58257525939*r**20
            -20510909307*r**22+860936896*r**24)-6*Q2**4*(-11925761973-49892548716*r**2
            -210523783484*r**4+294173494858*r**6+3207875687875*r**8+4740184995366*r**10
            -2057159785488*r**12-11408107675812*r**14-12122063375031*r**16-5832410252880*r**18
            -1031364849348*r**20+95746538474*r**22+67957241*r**24+3176654918*r**26)
            +36*Q2**3*(889424433-2910755841*r**2+406187030*r**4+38529861066*r**6
            +135165141432*r**8+31739527249*r**10-755595358653*r**12-1981662800400*r**14
            -2297929462887*r**16-1062211607499*r**18-101672495532*r**20-17122670906*r**22
            +26416566270*r**24+2212405371*r**26+458429267*r**28)+54*(-1+r**2)**2*(
            -38490913-11325375*r**2-1594319055*r**4+5015757995*r**6+22210207645*r**8
            -22928133601*r**10-41647007565*r**12+103559656285*r**14+192648859625*r**16
            +57956942015*r**18-211925973689*r**20-222957095035*r**22-47401071205*r**24
            -5854456095*r**26-444622635*r**28+2815603*r**30)-9*Q2**2*(4537602678
            -4117013687*r**2+74071061236*r**4-54000200741*r**6-828778240738*r**8
            -796818348739*r**10-58256486116*r**12-712032667857*r**14-1835425793598*r**16
            -482641914549*r**18+4585274842124*r**20+4887056192753*r**22+1016299378346*r**24
            +171232405039*r**26+15499581412*r**28+684434437*r**30)+27*Q2*(562860244
            -622062431*r**2+15596223085*r**4-44765532595*r**6-193371979355*r**8+180754114733*r**10
            +220717704513*r**12-1032380227895*r**14-717791308335*r**16+358249620035*r**18
            +8408051127*r**20+898939701767*r**22+1349508453535*r**24+299073644655*r**26
            +40744624795*r**28+3622150371*r**30+20009751*r**32))-995328000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(4735360*Q2**18+480*Q2**17*(89657+111457*r**2)
            -10*Q2**16*(135858759+195493534*r**2+67463127*r**4)+8*Q2**15*(1391660101
            +2985574427*r**2+1906443263*r**4+310615849*r**6)-180*Q2**14*(269433035
            +811776424*r**2+836017059*r**4+313034362*r**6+22645876*r**8)+6*Q2**13*(21256430490
            +86870724531*r**2+129505894932*r**4+84778219878*r**6+21894130234*r**8
            +830144335*r**10)-2*Q2**12*(98273002965+561618397449*r**2+1150622276652*r**4
            +1119882144710*r**6+540439572723*r**8+119390286741*r**10+9036397680*r**12)
            +3*Q2**11*(38524338330+442542167841*r**2+1294009942960*r**4+1787912460115*r**6
            +1334207092170*r**8+547407352195*r**10+131345812884*r**12+20583829425*r**14)
            -2*Q2**10*(-89514512793+150067110747*r**2+1462713454770*r**4+3416628521901*r**6
            +4312766927410*r**8+3155951960049*r**10+1274795080050*r**12+312683488863*r**14
            +59949472923*r**16)+5*Q2**9*(-91697782490-305555127729*r**2-289202542782*r**4
            +629408361358*r**6+2623492450366*r**8+3912240263584*r**10+2862611365726*r**12
            +1032900323922*r**14+185497623420*r**16+28625071537*r**18)-12*Q2**8*(
            -31413068095-190696683839*r**2-424680756553*r**4-233918706212*r**6+1272094942489*r**8
            +3539755529440*r**10+4060908388531*r**12+2392494877152*r**14+722866429818*r**16
            +94704979019*r**18+9474351850*r**20)+2*Q2**7*(16239309690-566717499997*r**2
            -1808316222216*r**4-2329686774435*r**6+3610416715396*r**8+22294892925252*r**10
            +40495172401788*r**12+35688810833164*r**14+16591384295610*r**16+4275710345361*r**18
            +490877897732*r**20+30811298895*r**22)-4*Q2**6*(82820209190+111021056959*r**2
            +232828482745*r**4-625179590235*r**6-4083720142135*r**8-2372781470740*r**10
            +12381363563030*r**12+23688096413900*r**14+16867721215280*r**16+5393830486365*r**18
            +973343450425*r**20+129239052151*r**22+3110749385*r**24)-12*Q2**5*(-22080812442
            -74233404990*r**2-256901341639*r**4+113391738516*r**6+2978082966105*r**8
            +5527862994213*r**10+287862336996*r**12-9285269958546*r**14-11329538909838*r**16
            -5656658695530*r**18-1046015268621*r**20+8489051614*r**22-9791007585*r**24
            +2018795907*r**26)+30*Q2**4*(-1317843075-15856569147*r**2-51595842004*r**4
            +62965775554*r**6+862608006265*r**8+1627699569347*r**10-370109388408*r**12
            -5071048852740*r**14-7463549565633*r**16-4865548654581*r**18-1494762015084*r**20
            -207670867262*r**22+50862778667*r**24+3303808877*r**26+1185446104*r**28)
            -9*Q2**3*(8095300410-12202339319*r**2+64052785992*r**4+101743991643*r**6
            -133998230746*r**8-129199674015*r**10-2953679811732*r**12-11661065304069*r**14
            -18953794846746*r**16-13923206196093*r**18-70261570000*r**20+4411875527001*r**22
            +1053474959802*r**24+285748291603*r**26+26182919964*r**28+2518151505*r**30)
            -54*(-1+r**2)**2*(-38490913-49816288*r**2-1605644430*r**4+3421438940*r**6
            +27225965640*r**8-717925956*r**10-64575141166*r**12+61912648720*r**14
            +296208515910*r**16+250605801640*r**18-153969031674*r**20-434883068724*r**22
            -270358166240*r**24-53255527300*r**26-6299078730*r**28-441807032*r**30
            +2815603*r**32)+18*Q2**2*(3113091705-722799151*r**2+58371358402*r**4
            -57112868645*r**6-731447189772*r**8-541667122639*r**10-96460860658*r**12
            -1933714918829*r**14-2350416193230*r**16-621659424021*r**18+2063928540478*r**20
            +6084575070089*r**22+4975940465852*r**24+1042376358675*r**26+154482930418*r**28
            +13525233481*r**30+372231845*r**32)-27*Q2*(639842070-190515089*r**2
            +18194479090*r**4-45555450970*r**6-259306257150*r**8+112047717170*r**10
            +348632884682*r**12-1139513599010*r**14-1637936615210*r**16+88020553600*r**18
            +637039667350*r**20+389644164178*r**22+1875273864950*r**24+1916600915630*r**26
            +412091832750*r**28+54291565610*r**30+4542667804*r**32+14378545*r**34))*sqrtq2)
            +logq2**4*(16588800*r**20*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(
            -135175680*Q2**20+960*Q2**19*(4002769+2801023*r**2)-24*Q2**18*(1580884075
            +2512386634*r**2+924048607*r**4)+2*Q2**17*(98241452280+250418322639*r**2
            +201608536886*r**4+51584467167*r**6)-8*Q2**16*(74923350555+275534273811*r**2
            +352220696943*r**4+191113886921*r**6+37872217938*r**8)+2*Q2**15*(525012626280
            +2838420795003*r**2+5191806426400*r**4+4426637287104*r**6+1812572326596*r**8
            +294028926609*r**10)-Q2**14*(697323057120+8154226782255*r**2+21169095416535*r**4
            +25785016927366*r**6+16870225157978*r**8+5594553491475*r**10+774208246455*r**12)
            +Q2**13*(-1132683226200+3439168404333*r**2+17587711620894*r**4+30708974283239*r**6
            +32709243431716*r**8+19965864374287*r**10+5857671239598*r**12+738975771189*r**14)
            +Q2**12*(3124579057920+9692848672551*r**2+22254511831059*r**4+39770585242967*r**6
            +25589189062071*r**8-8003349748379*r**10-14192988445007*r**12-4736705477571*r**14
            -623161362267*r**16)+2*Q2**11*(-1257354390240-10015612553988*r**2-39205032175974*r**4
            -102878327541821*r**6-138001667386348*r**8-87356026316675*r**10-21750042213806*r**12
            +1320606496577*r**14+1820096110392*r**16+253150997211*r**18)+Q2**10*(
            -904414880400+14441419230717*r**2+74243986134975*r**4+296624719818260*r**6
            +591029013203188*r**8+589370577483622*r**10+306989370617634*r**12+87294631052260*r**14
            +12433816576468*r**16-2083810474971*r**18-142111470489*r**20)-Q2**9*(
            -3393283706520-3721732256895*r**2-28430827097970*r**4+84259065697843*r**6
            +492720970215804*r**8+846294661503670*r**10+756023957370600*r**12+379345960314330*r**14
            +119395697512748*r**16+28392911486969*r**18+724503924570*r**20+462796193955*r**22)
            +Q2**8*(-2235759109200-16713466108893*r**2-128637580917859*r**4-285546554346703*r**6
            -106186155853877*r**8+620544067122406*r**10+1438681957200458*r**12+1429844941066474*r**14
            +708000844907422*r**16+184051684031783*r**18+36280980277801*r**20+3279098884277*r**22
            +714758484951*r**24)-2*Q2**7*(244318880760-6787373311407*r**2-47129821807308*r**4
            -186850399737282*r**6-246115741015964*r**8+176895519103111*r**10+1168372421334064*r**12
            +1851614351433568*r**14+1437140639240560*r**16+592628927395411*r**18+120594455676556*r**20
            +15171360748210*r**22+2001287824612*r**24+151702691109*r**26)+Q2**6*(1504863965280
            -1323384557709*r**2+30904740463903*r**4-132976576226662*r**6-263824463978586*r**8
            +172038822524025*r**10+1643282151436401*r**12+3970636619235708*r**14+4584538751124516*r**16
            +2702716246698693*r**18+926757738969585*r**20+176342996283818*r**22+16678905980374*r**24
            +2943436932111*r**26-240241715457*r**28)+3*Q2**5*(-240119961720-2070744747359*r**2
            -29002423921050*r**4-22441761716973*r**6-28696320961084*r**8+110580318420549*r**10
            +477756026409906*r**12+105914369830455*r**14-966873261879792*r**16-1105685020538973*r**18
            -400309606965862*r**20-59580143920407*r**22-17314314360540*r**24-1919970811145*r**26
            -280507548978*r**28+116065520973*r**30)-3*Q2**4*(28353770880-1602715222135*r**2
            -13594322408855*r**4-28700108906403*r**6-38304189737519*r**8+245262709341485*r**10
            +906307046291565*r**12+664505603606385*r**14-1069694169294459*r**16-2327040004261557*r**18
            -1664580746262005*r**20-442380049103545*r**22+10993497789795*r**24-980419821313*r**26
            -43398343649*r**28+309832014315*r**30+40839267015*r**32)-18*Q2**3*(-11958112400
            +37773081318*r**2-580127068106*r**4+3147137216877*r**6-3548604955052*r**8
            -24953565287349*r**10-33637508253158*r**12+39695916200661*r**14+263608842944896*r**16
            +465517788458759*r**18+366838973603658*r**20+138546697572527*r**22+38145048214116*r**24
            -5126491509223*r**26-879565392282*r**28-221617978609*r**30-69360217512*r**32
            +3017000879*r**34)+27*(-1+r**2)**2*(-5281160-3248572293*r**2-32610205801*r**4
            +27222710504*r**6-577231725380*r**8+1865541402180*r**10+6984456818064*r**12
            -5657993327672*r**14-21795959167492*r**16+17145475193810*r**18+61596076307270*r**20
            -5578491447624*r**22-56555523254028*r**24-19415055188828*r**26-3561737750680*r**28
            -421406088040*r**30-30726964772*r**32-155389749*r**34+133531691*r**36)
            +9*Q2**2*(-9276278440-101064594377*r**2-1878046357383*r**4+4087125143640*r**6
            -17264146277136*r**8+12943392538964*r**10+116591086317540*r**12+76684000868488*r**14
            +41337771213984*r**16+141927243184522*r**18+134494219714142*r**20-329398075161624*r**22
            -541285402077552*r**24-165590216042988*r**26-39010263938636*r**28-5065207561416*r**30
            -647486988664*r**32-70428896553*r**34+7530393489*r**36)-27*Q2*(-433953320
            -19170491849*r**2-221409722582*r**4+563988657489*r**6-3382912400868*r**8
            +9530619038800*r**10+23336328549732*r**12-20135816919944*r**14-5686328908452*r**16
            +23594863514054*r**18+15481041287960*r**20+101258099252658*r**22-15226016734316*r**24
            -163612775507288*r**26-56799551072004*r**28-11196430119440*r**30-1391776370916*r**32
            -132787788533*r**34-5427955874*r**36+944044693*r**38))-16588800*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(135175680*Q2**20-960*Q2**19*(4002769
            +2801023*r**2)+24*Q2**18*(1580884075+2512386634*r**2+924048607*r**4)
            -2*Q2**17*(98241452280+250418322639*r**2+201608536886*r**4+51584467167*r**6)
            +8*Q2**16*(74923350555+275534273811*r**2+352220696943*r**4+191113886921*r**6
            +37872217938*r**8)-2*Q2**15*(525012626280+2838420795003*r**2+5191806426400*r**4
            +4426637287104*r**6+1812572326596*r**8+294028926609*r**10)+Q2**14*(697323057120
            +8154226782255*r**2+21169095416535*r**4+25785016927366*r**6+16870225157978*r**8
            +5594553491475*r**10+774208246455*r**12)-Q2**13*(-1132683226200+3439168404333*r**2
            +17587711620894*r**4+30708974283239*r**6+32709243431716*r**8+19965864374287*r**10
            +5857671239598*r**12+738975771189*r**14)+Q2**12*(-3124579057920-9692848672551*r**2
            -22254511831059*r**4-39770585242967*r**6-25589189062071*r**8+8003349748379*r**10
            +14192988445007*r**12+4736705477571*r**14+623161362267*r**16)+Q2**11*(2514708780480
            +20031225107976*r**2+78410064351948*r**4+205756655083642*r**6+276003334772696*r**8
            +174712052633350*r**10+43500084427612*r**12-2641212993154*r**14-3640192220784*r**16
            -506301994422*r**18)+Q2**10*(904414880400-14441419230717*r**2-74243986134975*r**4
            -296624719818260*r**6-591029013203188*r**8-589370577483622*r**10-306989370617634*r**12
            -87294631052260*r**14-12433816576468*r**16+2083810474971*r**18+142111470489*r**20)
            +Q2**9*(-3393283706520-3721732256895*r**2-28430827097970*r**4+84259065697843*r**6
            +492720970215804*r**8+846294661503670*r**10+756023957370600*r**12+379345960314330*r**14
            +119395697512748*r**16+28392911486969*r**18+724503924570*r**20+462796193955*r**22)
            -Q2**8*(-2235759109200-16713466108893*r**2-128637580917859*r**4-285546554346703*r**6
            -106186155853877*r**8+620544067122406*r**10+1438681957200458*r**12+1429844941066474*r**14
            +708000844907422*r**16+184051684031783*r**18+36280980277801*r**20+3279098884277*r**22
            +714758484951*r**24)+2*Q2**7*(244318880760-6787373311407*r**2-47129821807308*r**4
            -186850399737282*r**6-246115741015964*r**8+176895519103111*r**10+1168372421334064*r**12
            +1851614351433568*r**14+1437140639240560*r**16+592628927395411*r**18+120594455676556*r**20
            +15171360748210*r**22+2001287824612*r**24+151702691109*r**26)+Q2**6*(
            -1504863965280+1323384557709*r**2-30904740463903*r**4+132976576226662*r**6
            +263824463978586*r**8-172038822524025*r**10-1643282151436401*r**12-3970636619235708*r**14
            -4584538751124516*r**16-2702716246698693*r**18-926757738969585*r**20-176342996283818*r**22
            -16678905980374*r**24-2943436932111*r**26+240241715457*r**28)+3*Q2**5*(240119961720
            +2070744747359*r**2+29002423921050*r**4+22441761716973*r**6+28696320961084*r**8
            -110580318420549*r**10-477756026409906*r**12-105914369830455*r**14+966873261879792*r**16
            +1105685020538973*r**18+400309606965862*r**20+59580143920407*r**22+17314314360540*r**24
            +1919970811145*r**26+280507548978*r**28-116065520973*r**30)+3*Q2**4*(28353770880
            -1602715222135*r**2-13594322408855*r**4-28700108906403*r**6-38304189737519*r**8
            +245262709341485*r**10+906307046291565*r**12+664505603606385*r**14-1069694169294459*r**16
            -2327040004261557*r**18-1664580746262005*r**20-442380049103545*r**22+10993497789795*r**24
            -980419821313*r**26-43398343649*r**28+309832014315*r**30+40839267015*r**32)
            +18*Q2**3*(-11958112400+37773081318*r**2-580127068106*r**4+3147137216877*r**6
            -3548604955052*r**8-24953565287349*r**10-33637508253158*r**12+39695916200661*r**14
            +263608842944896*r**16+465517788458759*r**18+366838973603658*r**20+138546697572527*r**22
            +38145048214116*r**24-5126491509223*r**26-879565392282*r**28-221617978609*r**30
            -69360217512*r**32+3017000879*r**34)-27*(-1+r**2)**2*(-5281160-3248572293*r**2
            -32610205801*r**4+27222710504*r**6-577231725380*r**8+1865541402180*r**10
            +6984456818064*r**12-5657993327672*r**14-21795959167492*r**16+17145475193810*r**18
            +61596076307270*r**20-5578491447624*r**22-56555523254028*r**24-19415055188828*r**26
            -3561737750680*r**28-421406088040*r**30-30726964772*r**32-155389749*r**34
            +133531691*r**36)-9*Q2**2*(-9276278440-101064594377*r**2-1878046357383*r**4
            +4087125143640*r**6-17264146277136*r**8+12943392538964*r**10+116591086317540*r**12
            +76684000868488*r**14+41337771213984*r**16+141927243184522*r**18+134494219714142*r**20
            -329398075161624*r**22-541285402077552*r**24-165590216042988*r**26-39010263938636*r**28
            -5065207561416*r**30-647486988664*r**32-70428896553*r**34+7530393489*r**36)
            +27*Q2*(-433953320-19170491849*r**2-221409722582*r**4+563988657489*r**6
            -3382912400868*r**8+9530619038800*r**10+23336328549732*r**12-20135816919944*r**14
            -5686328908452*r**16+23594863514054*r**18+15481041287960*r**20+101258099252658*r**22
            -15226016734316*r**24-163612775507288*r**26-56799551072004*r**28-11196430119440*r**30
            -1391776370916*r**32-132787788533*r**34-5427955874*r**36+944044693*r**38))*sqrtq2)
            +logq2**3*(-276480*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(2904088320*Q2**23
            -64*Q2**22*(731963847+652870055*r**2)+Q2**21*(337089674646+613924901996*r**2
            +271518227670*r**4)-6*Q2**20*(230751613353+670132421269*r**2+606062821103*r**4
            +172946284035*r**6)+20*Q2**19*(169481316096+750495920351*r**2+1067474405448*r**4
            +627899940915*r**6+127571850314*r**8)-10*Q2**18*(428752603530+3328939538041*r**2
            +6802785490614*r**4+6305131753944*r**6+2733925845280*r**8+417332954127*r**10)
            +12*Q2**17*(-39518773044+3116678197795*r**2+9093174268870*r**4+11768600143860*r**6
            +8628588560805*r**8+3152956013791*r**10+382941375935*r**12)-Q2**16*(-11212151972166
            -8826892530181*r**2+364699762200*r**4-22280841764235*r**6+17268661772670*r**8
            +61198959177549*r**10+31153678561224*r**12+3433907705435*r**14)+Q2**15*(
            -16613451955368-98443791673279*r**2-365903609562843*r**4-968227990946955*r**6
            -1184562568994895*r**8-628938488130993*r**10-109418705712069*r**12+10476808299227*r**14
            +1451540893815*r**16)+15*Q2**14*(271639107336+9360843366881*r**2+45360418164948*r**4
            +168089587735568*r**6+294094168943068*r**8+253747979935662*r**10+108416184940092*r**12
            +19982881443072*r**14+545803354380*r**16+87809224289*r**18)-5*Q2**13*(
            -3506250384156+9552391718279*r**2+58322290058181*r**4+534805005230532*r**6
            +1427659065948876*r**8+1784347164593598*r**10+1204585744943106*r**12+425613163782684*r**14
            +70961414670864*r**16+4257413347035*r**18+900543471737*r**20)+Q2**12*(
            -22103372678868-118192261104725*r**2-783815466231570*r**4-580392234745065*r**6
            +2619566971937640*r**8+6403062898717578*r**10+7624349018900580*r**12+5121339915295170*r**14
            +1761087299738220*r**16+300887233918155*r**18+35829968707822*r**20+4626745260135*r**22)
            +3*Q2**11*(1018561000392+60547383189527*r**2+444371305258135*r**4+1752928959792105*r**6
            +3525468028778865*r**8+5244822543976338*r**10+4267102316584178*r**12+1018462867656510*r**14
            -558735071914410*r**16-401488295510505*r**18-86858022960073*r**20-14253371971943*r**22
            +143781264945*r**24)-Q2**10*(-14946804104112+72307207168129*r**2+462017236669488*r**4
            +6133477391186430*r**6+18508076205060400*r**8+42779135561149887*r**10
            +58864331291691456*r**12+41468126128020212*r**14+14276467420099440*r**16
            +1606789013542095*r**18-786538592571632*r**20-189371929835826*r**22-23800003034352*r**24
            +5311121742385*r**26)+5*Q2**9*(-2469722547168-15441728936923*r**2-169060000433289*r**4
            +280485963535062*r**6+1094387414830394*r**8+6331859210977467*r**10+15451499958083937*r**12
            +17299333682801380*r**14+10213510237303932*r**16+3574658781330123*r**18
            +830498039742281*r**20-7965209156154*r**22+1979797790442*r**24+2762497972565*r**26
            +759207838623*r**28)+15*Q2**8*(-36250636596+7365564282643*r**2+69258228426682*r**4
            +281120781410001*r**6+1153615741677624*r**8+1357766956796143*r**10-1765673421649370*r**12
            -6262679052386235*r**14-7408233890839156*r**16-4556063556173511*r**18
            -1623887560645114*r**20-419371730482829*r**22-56869420734096*r**24-14056312279611*r**26
            -2430592974950*r**28+82425695735*r**30)+Q2**7*(5881422862152-36857416289965*r**2
            -219438134011305*r**4-5125416551975205*r**6-19755561029832585*r**8-49736859068009517*r**10
            -26571833578945785*r**12+93893271852771475*r**14+227141128307205615*r**16
            +236171593833535185*r**18+129558654142419613*r**20+37544200044323385*r**22
            +6552034856149965*r**24+1144772373302025*r**26+215321575694085*r**28+24251689301337*r**30
            -2917006500475*r**32)+Q2**6*(-2693865416184-28067742413939*r**2-381818735233140*r**4
            +1546879053744540*r**6-409367836374780*r**8+28385842707983844*r**10+22578307737775644*r**12
            -79585488887428300*r**14-248334546906781020*r**16-362174550751507410*r**18
            -281635888463275036*r**20-126220722647783676*r**22-32307552276514740*r**24
            -4162318880717820*r**26-853053244107660*r**28-60309199175124*r**30+4059144302596*r**32
            +823095002205*r**34)+3*Q2**5*(-192680280966+10373242347017*r**2+105006863028909*r**4
            +552121430654480*r**6+4523719420897120*r**8-800538176968704*r**10-2227030391825472*r**12
            -4539391354585224*r**14-3949666735527300*r**16+42815155701058930*r**18
            +74317669609705066*r**20+39812482608943968*r**22+10051591495275136*r**24
            +3047778465509240*r**26+526661412655800*r**28+156126592807704*r**30-20177997262038*r**32
            -5655619849971*r**34+287728776305*r**36)-15*Q2**4*(-57558952342+530063360583*r**2
            +3445472649324*r**4+115486746678267*r**6+498925162791968*r**8+295920005181336*r**10
            -568847757953024*r**12-5368120029496928*r**14-12005231815427244*r**16
            -3109339613724194*r**18+18842120686121064*r**20+23394880320103374*r**22
            +8870918548225104*r**24+98132186815072*r**26-32214188048256*r**28+38182608003992*r**30
            +7233272037842*r**32-4332705757725*r**34-616171566420*r**36+43935678207*r**38)
            +45*Q2**3*(-4185403608-84764155577*r**2-1118113308293*r**4+8368114397213*r**6
            -30985547665679*r**8+177995348938552*r**10-373702044398776*r**12-970808509799664*r**14
            -681356254247056*r**16+2580316822747598*r**18+9185725079505318*r**20+11194797603190978*r**22
            +7043382182421082*r**24+2886775843207328*r**26+121056587169776*r**28-19237211898920*r**30
            -3376632205200*r**32-4502211097325*r**34-454989252185*r**36+26950658105*r**38
            +390076333*r**40)+54*(-1+r**2)**2*(-91290407+1412719785*r**2+20811125620*r**4
            +581612097400*r**6+2394721696945*r**8-10249777099087*r**10+62712586331960*r**12
            -148207625311960*r**14-478982019146550*r**16+866177409093290*r**18+1194166360378528*r**20
            -2200566433024840*r**22-1619003468936190*r**24+1705292573571650*r**26
            +948023676037960*r**28+257461121361208*r**30+39935407984285*r**32+4041464919405*r**34
            +494766427500*r**36-20849906320*r**38-4094490867*r**40+157060685*r**42)
            +9*Q2**2*(-7084416172+359666157255*r**2+3742888676340*r**4+29340073184050*r**6
            +289780760279240*r**8-1024762670358217*r**10+2681658205340240*r**12-1379805227063480*r**14
            -9818984715830760*r**16-6830466198737330*r**18-7991158054939752*r**20
            -8902734781214660*r**22+14334151244221440*r**24+33989365897324870*r**26
            +12977015556263440*r**28+4239433639028968*r**30+674469618094580*r**32
            +96748252080075*r**34+31014215864340*r**36-352847080350*r**38-394516902952*r**40
            +16185628835*r**42)-27*Q2*(-1345837248+32432380947*r**2+328697865805*r**4
            +6318880626670*r**6+30287521685510*r**8-169370785381233*r**10+651861550640477*r**12
            -1201735999228840*r**14-2720962607943560*r**16+2122599895246870*r**18
            +4411785965105562*r**20+926353864455012*r**22-10133430915035660*r**24
            -6212393665612890*r**26+10176323674313730*r**28+5328953539075192*r**30
            +1513959558188632*r**32+232849872257495*r**34+25181957262905*r**36+5405946471390*r**38
            -134850597898*r**40-57700400693*r**42+2287261825*r**44))+276480*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(2904088320*Q2**24-64*Q2**23*(777340227
            +698246435*r**2)+Q2**22*(383935360854+702554271724*r**2+313301911190*r**4)
            -4*Q2**21*(430399838691+1242952276064*r**2+1130455014071*r**4+327298982970*r**6)
            +2*Q2**20*(2387068001019+10207611307376*r**2+14503329781596*r**4+8616026724564*r**6
            +1794557355245*r**8)-10*Q2**19*(767715235722+5168894010935*r**2+10438726142212*r**4
            +9695880446670*r**6+4244869427738*r**8+672476654755*r**10)+2*Q2**18*(1906650379386
            +37488529894625*r**2+105217670756495*r**4+136151187085950*r**6+96966819360950*r**8
            +34674030079781*r**10+4384313026245*r**12)-Q2**17*(-11686377248694+28099020566831*r**2
            +146882929362180*r**4+228060451188525*r**6+262034926228650*r**8+202577494072701*r**10
            +73584447237936*r**12+8029204216655*r**14)+2*Q2**16*(-13912801963767-59241418087813*r**2
            -187182901165412*r**4-495072066474495*r**6-594787374493230*r**8-275235433590387*r**10
            -8533033986648*r**12+22532197282943*r**14+2442724299625*r**16)+Q2**15*(20688038565408
            +255469894131862*r**2+1144753673710342*r**4+3855475416543318*r**6+6564203094087870*r**8
            +5619720756160818*r**10+2364599967944442*r**12+398685119058922*r**14-3741298877342*r**16
            -134402529480*r**18)-10*Q2**14*(-1345666531074+19224919570465*r**2+111243037326834*r**4
            +587577511466040*r**6+1407105167992392*r**8+1713936805614894*r**10+1145539119785184*r**12
            +405405181466088*r**14+66273734531610*r**16+3079125541521*r**18+581985572302*r**20)
            +2*Q2**13*(-19817312299824-43980777217055*r**2-222221028674635*r**4+1192622120849250*r**6
            +6215943663917340*r**8+11231547025714974*r**10+11284506783292050*r**12
            +6636167229462060*r**14+2121980096002980*r**16+338490687003825*r**18+30809876400841*r**20
            +4564731309410*r**22)-2*Q2**12*(-12579527840022-160968891676087*r**2-1117560821555350*r**4
            -3311497290176475*r**6-4268614674572010*r**8-3355918880636898*r**10+613052483932812*r**12
            +4845150165613110*r**14+4279316215388310*r**16+1633219710093945*r**18
            +298645635753098*r**20+41608414941893*r**22+2097700732650*r**24)-2*Q2**11*(
            -5945560551468+128502519868943*r**2+988386651006237*r**4+6362689093168575*r**6
            +17171633585386655*r**8+34545003639707748*r**10+43700052936686502*r**12
            +28662410840371138*r**14+7827825403662870*r**16-636940544366325*r**18
            -1125788773991683*r**20-246353057315937*r**22-33064387577673*r**24+2871232768610*r**26)
            +2*Q2**10*(-13647708419976-9924120810299*r**2-155487779164414*r**4+3998962222765614*r**6
            +15056745335199400*r**8+46473253910548811*r**10+89450483321630514*r**12
            +93414562916859284*r**14+53406072367319656*r**16+16878275170146075*r**18
            +2486370309840934*r**20-507868284094114*r**22-101636471958984*r**24-2338195714571*r**26
            +4553580467750*r**28)-10*Q2**9*(-1180485318690-20004072166010*r**2-196138207325129*r**4
            -365968190564115*r**6-1042986923333708*r**8+1676472877709716*r**10+13540189717004757*r**12
            +25769435399022011*r**14+24868772796311390*r**16+13728179843577294*r**18
            +4638409751503873*r**20+1040324011017307*r**22+82311425418288*r**24+23455616300920*r**26
            +5406742368019*r**28+255965375709*r**30)+2*Q2**8*(3212591205546-73398560490335*r**2
            -684397512325590*r**4-5190550849762725*r**6-20638304438073480*r**8-43703799772558011*r**10
            -10226618303073690*r**12+107159279481652775*r**14+216102411227793240*r**16
            +207818027769362595*r**18+111128960447349494*r**20+34096544705621265*r**22
            +6847826062201920*r**24+1104329184253815*r**26+231312577256250*r**28+29737099244781*r**30
            -2076695968250*r**32)+2*Q2**7*(-4287644139168+1454125506937*r**2-62761592465935*r**4
            +3445866869865525*r**6+12235804872716505*r**8+48939131402912973*r**10
            +49443500192365473*r**12-73453463580626995*r**14-284684473533379055*r**16
            -412743636446124105*r**18-323683068219614917*r**20-146661788417263337*r**22
            -38201893588494045*r**24-5929563055084905*r**26-1106573596551885*r**28
            -149941232085273*r**30-8637769249133*r**32+1870050751340*r**34)+2*Q2**6*(1057912286643
            +30940667435587*r**2+362453533366903*r**4+245651986726020*r**6+6216823522660800*r**8
            -15189044701257588*r**10-28822620810617952*r**12+21694503542948492*r**14
            +158035517793813710*r**16+369477282380732610*r**18+433381724021948822*r**20
            +263647029468945308*r**22+94341524705061912*r**24+22806603276880140*r**26
            +3297678181396440*r**28+690871110852948*r**30-2141968456793*r**32-10924549427357*r**34
            +20045663355*r**36)-6*Q2**5*(-240237521338+6415439434483*r**2+66303734311273*r**4
            +617281013537362*r**6+3785233332755720*r**8+2601390634917548*r**10-2935903679279648*r**12
            -16803510946947668*r**14-34257608583624372*r**16+11659395448455330*r**18
            +105671714370684658*r**20+115552276909582952*r**22+47109333422672312*r**24
            +6795015447429868*r**26+1706684468961880*r**28+436850522741732*r**30+86057477867438*r**32
            -23748572950317*r**34-4224374452883*r**36+253703583670*r**38)+30*Q2**4*(
            -35057581583+109105970755*r**2+310598042514*r**4+72018281259615*r**6
            +260727633236599*r**8+664415607394480*r**10-697016942984008*r**12-4424696658424472*r**14
            -9708710303832670*r**16-3686810480454322*r**18+21644978155456412*r**20
            +37910696907898686*r**22+26697972707795862*r**24+8814689132331080*r**26
            +214543880138072*r**28-25871607870512*r**30+17642991713117*r**32-5303033505929*r**34
            -3156922540350*r**36-245691956949*r**38+22552953603*r**40)+18*Q2**3*(6921300934
            +402206976590*r**2+4878637997845*r**4-3454966130275*r**6+201433963310785*r**8
            -879905838361291*r**10+1830095841320680*r**12+2671373771964360*r**14-779080447798580*r**16
            -8162634520620020*r**18-33410683783102166*r**20-55402674097348070*r**22
            -38428373841919430*r**24-7830712115408590*r**26-1031073297811040*r**28
            +1865168381337344*r**30+393769419307590*r**32+68071234296350*r**34+27900108805945*r**36
            +893672945025*r**38-265610287571*r**40+7117623585*r**42)-54*(-1+r**2)**2*(
            -91290407+1321429378*r**2+22223845405*r**4+602423223020*r**6+2976333794345*r**8
            -7855055402142*r**10+52462809232873*r**12-85495038980000*r**14-627189644458510*r**16
            +387195389946740*r**18+2060343769471818*r**20-1006400072646312*r**22-3819569901961030*r**24
            +86289104635460*r**26+2653316249609610*r**28+1205484797399168*r**30+297396529345493*r**32
            +43976872903690*r**34+4536231346905*r**36+473916521180*r**38-24944397187*r**40
            -3937430182*r**42+157060685*r**44)-18*Q2**2*(-5560963958+224939441962*r**2
            +2544324215505*r**4+26019801870200*r**6+204991699259910*r**8-621547133111338*r**10
            +1806240093451727*r**12-1151677509704880*r**14-9680838883362460*r**16
            -5140825614413740*r**18-793133179180198*r**20-7057415621394688*r**22-12484438141050100*r**24
            +14843168072353820*r**26+38747676238264750*r**28+16601654906258992*r**30
            +4727890965844722*r**32+734883743473570*r**34+101654169866565*r**36+23439604099080*r**38
            -575957888498*r**40-275716238098*r**42+11523707155*r**44)+27*Q2*(-1528418062
            +34277144897*r**2+396919038038*r**4+7730383624365*r**6+39111019567710*r**8
            -167998480486877*r**10+653704489713402*r**12-1117639598738297*r**14-4162406971553740*r**16
            +2753504931452170*r**18+4500044906443228*r**20-2107303659816638*r**22
            -1254485535596612*r**24-10860358423810170*r**26-4199199871382220*r**28
            +15638689899102798*r**30+7788986779863482*r**32+2110072971070213*r**34
            +322726318666350*r**36+36650068050465*r**38+6335839372038*r**40-217558726393*r**42
            -64230363342*r**44+2601383195*r**46))*sqrtq2)+logq2**2*(23040*r**12*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(-1902679552*Q2**26
            +32*Q2**25*(922027087+866771815*r**2)-4*Q2**24*(49727843179+99911318422*r**2
            +45351072811*r**4)+Q2**23*(741673964464+2510190158670*r**2+2396112110220*r**4
            +697968027886*r**6)-4*Q2**22*(386686341554+2186137462241*r**2+3347569093659*r**4
            +2080461602843*r**6+432981830639*r**8)+4*Q2**21*(307311802726+4261933565935*r**2
            +9540719448268*r**4+9489304388845*r**6+4543635708052*r**8+701192588650*r**10)
            -2*Q2**20*(-1077615116612+6094252225479*r**2+20917314765081*r**4+27919876456786*r**6
            +26217678111312*r**8+12227552417907*r**10+1318665772903*r**12)+Q2**19*(
            -6950215227836-24522964913303*r**2-74935225584414*r**4-185958704177705*r**6
            -143717529044240*r**8-9840137027661*r**10+15069551290402*r**12+261387718981*r**14)
            +2*Q2**18*(3018567351572+37569220036415*r**2+167019080902040*r**4+536158571416523*r**6
            +723449524835360*r**8+419382459241877*r**10+90115578988880*r**12+5900331322145*r**14
            +1616705773988*r**16)-Q2**17*(-4199360307564+70690075612869*r**2+427234476005076*r**4
            +2195867557957462*r**6+4319508173988456*r**8+3974592737433576*r**10+1785433043391124*r**12
            +347476380310386*r**14+39030848494572*r**16+4513001168091*r**18)+2*Q2**16*(
            -6768721364598-14206588160535*r**2-41156747022909*r**4+773284663194340*r**6
            +2644839131155204*r**8+3510918114115530*r**10+2575089483651910*r**12+1008231447950356*r**14
            +177076129017690*r**16+22753345514949*r**18+514346878335*r**20)+4*Q2**15*(2041373194716
            +34355801063478*r**2+231953932483707*r**4+598054282334807*r**6+682172366342339*r**8
            +954087528462677*r**10+499952258390189*r**12-261906211018813*r**14-263697428498983*r**16
            -55005020871291*r**18-6654811623456*r**20+1162744161366*r**22)-4*Q2**14*(
            -1795932262076+29304129483972*r**2+250107065456511*r**4+1674338498166340*r**6
            +4504018416215130*r**8+10126195170260016*r**10+12343359838326898*r**12
            +7128507244580544*r**14+1714686242654280*r**16+55003526668780*r**18-15262813160001*r**20
            +1784696875932*r**22+1455975093226*r**24)+4*Q2**13*(-3239442546304-7631120408515*r**2
            -34370744836365*r**4+1354401072661949*r**6+5159327752075700*r**8+18214648752912939*r**10
            +32583065984764790*r**12+28926411206580230*r**14+13099381907362356*r**16
            +2833100764484915*r**18+238197571902791*r**20+34228006621725*r**22+9772308020840*r**24
            +81663273989*r**26)+4*Q2**12*(853214408276+33991577204429*r**2+302477015460686*r**4
            +548809127893292*r**6+1084807253400191*r**8-8684322473828761*r**10-32843510383236979*r**12
            -44387790607047856*r**14-31577683276437802*r**16-12225022017043861*r**18
            -2439063114520684*r**20-349353802209196*r**22-82107597475369*r**24-11068314686863*r**26
            +1232722151921*r**28)-2*Q2**11*(-3238210988092+42418762422765*r**2+443926686230964*r**4
            +4204015523177885*r**6+16611344260167606*r**8+38084298033852411*r**10
            +30035938705076330*r**12+8404642648027071*r**14-16348585483297560*r**16
            -26344322449145701*r**18-14755269816512928*r**20-3735391196736525*r**22
            -884391354614146*r**24-131901921446115*r**26-4177704954654*r**28+1706457668945*r**30)
            -4*Q2**10*(1386000604444+8268054308647*r**2+60675453769653*r**4-1552165556511437*r**6
            -6692570743731134*r**8-37076341241832537*r**10-73324752197710373*r**12
            -116036146552630493*r**14-114789880343138208*r**16-54045440390206811*r**18
            -7244172453179621*r**20+4367697823740393*r**22+1658088912065818*r**24
            +391091981247853*r**26-13108168030059*r**28-9010596782879*r**30+375192114664*r**32)
            +2*Q2**9*(-178140829868+36142242114781*r**2+357724656354778*r**4+626584247500480*r**6
            +4329687325592380*r**8-42610271215770782*r**10-107943310889601626*r**12
            -288564769675943828*r**14-465906841445831120*r**16-364415613800152760*r**18
            -150042224206304282*r**20-34184829031317416*r**22+2376377499492412*r**24
            +1292834616801190*r**26+222166927248730*r**28-114460610083268*r**30-18605320024124*r**32
            +1429448398483*r**34)-4*Q2**8*(-610734053911+6345315815325*r**2+78337348780425*r**4
            +1315506170568506*r**6+6803830375258815*r**8+13695011167363956*r**10+41910787367712685*r**12
            +2386315702428750*r**14-168005386142099691*r**16-256761841668414670*r**18
            -179895519179943549*r**20-76534198136375370*r**22-24303798433266635*r**24
            -3825487318660596*r**26-1043398043207505*r**28-254819516819326*r**30-28678916565810*r**32
            -30167767695*r**34+138365003096*r**36)-2*Q2**7*(437611180768+8984284982047*r**2
            +61391484258108*r**4-1532763184373519*r**6-6506654609324282*r**8-61571104750719858*r**10
            -164458632039482602*r**12-271843627726816618*r**14+77636673086449734*r**16
            +673035265840306132*r**18+932534720144127262*r**20+675231423807226368*r**22
            +261836791867483202*r**24+60349436781211154*r**26+12110465569849842*r**28
            +3061960028931418*r**30+763451488883602*r**32-14434404391827*r**34-11157354483554*r**36
            +519027662623*r**38)+4*Q2**6*(-97213237034+4410165723265*r**2+42045079198318*r**4
            +141827029640995*r**6+1442791486936717*r**8-16420476377901884*r**10-9356284293134800*r**12
            -108607891630487908*r**14+11344602386304380*r**16+380142414185597518*r**18
            +709058119521102100*r**20+722961204709376890*r**22+426814154125437242*r**24
            +142966486711412180*r**26+23115414010631888*r**28+4787928240624748*r**30
            +609017300583670*r**32+143707143838873*r**34-10947453222530*r**36-2867089879973*r**38
            +151018735345*r**40)+12*Q2**5*(28899692262-172851764094*r**2-4120066467801*r**4
            -129151980013366*r**6-705972712908012*r**8-1927598241576447*r**10-18107049235243904*r**12
            +19577216560980816*r**14+8214188542140756*r**16-35084416473810788*r**18
            -71045889417851394*r**20-138318157165764468*r**22-106493302486894344*r**24
            -39801407199798774*r**26-14602613592514968*r**28-2444311001994544*r**30
            -1173061309445946*r**32+18604705449354*r**34+45985319868659*r**36+1268871713418*r**38
            -349501059852*r**40+9792623437*r**42)-6*Q2**4*(5848768836+572337700593*r**2
            +1761909588809*r**4-103853840954830*r**6-428966702593750*r**8-7474371808348319*r**10
            -19425493724260307*r**12+24289728363214504*r**14+30269376271903240*r**16
            +100895724611513650*r**18+240483747016756666*r**20-51417868859170692*r**22
            -392196785534827356*r**24-218375101217441190*r**26-5377309607629750*r**28
            +5001109252035656*r**30-318912495296092*r**32-1279027171028611*r**34+16436107781405*r**36
            +104107907338850*r**38+827393854786*r**40-942141089627*r**42+32615943529*r**44)
            +9*Q2**3*(-4764947004+168592129665*r**2+1338403128790*r**4+10924177778019*r**6
            +90896215096860*r**8-1704122031289229*r**10+4679347534242330*r**12-11883619985172015*r**14
            +24934213884905304*r**16+46742039834202330*r**18+29791358464190316*r**20
            -190209218138761010*r**22-421433244065927640*r**24-381555659976664266*r**26
            -225874458845233340*r**28-35212465306279854*r**30-1517010392980380*r**32
            -282763981705035*r**34+255888328980894*r**36+19093731587775*r**38+11522657614396*r**40
            -57370290105*r**42-102004492350*r**44+3729805549*r**46)+54*(-1+r**2)**2*(
            -1366310+490000763*r**2-1526606237*r**4-104294983765*r**6-864973569999*r**8
            -17724514069815*r**10+4939031835833*r**12+188493990786153*r**14-1632039697860195*r**16
            +4914985885393966*r**18+3074123572235230*r**20-20928525263294002*r**22
            +5380505629236538*r**24+27621628256676850*r**26-9022360613704654*r**28
            -8827592269995150*r**30-3596403424028172*r**32-806903048345337*r**34-81792808644305*r**36
            -14656857936969*r**38-1603421948955*r**40+271622562453*r**42+7154740133*r**44
            -1274989835*r**46+28275781*r**48)+18*Q2**2*(927723588+1922869727*r**2
            -244663207462*r**4-8919097932229*r**6-47870499014212*r**8-275422971941047*r**10
            -2464214955606598*r**12+12768476600958693*r**14-30224591421556764*r**16
            +11112216833675238*r**18+65689435944856628*r**20+47755549708827422*r**22
            +34888375947818408*r**24-44579983434004894*r**26-131787265621696252*r**28
            -52319234367838342*r**30-22972359547260708*r**32-4817446033879797*r**34
            -316573901506254*r**36-357521820713737*r**38-37378598456452*r**40+7802443105157*r**42
            +239954182658*r**44-52054877359*r**46+1323074588*r**48)-27*Q2*(62459452
            +5539671975*r**2-38656315376*r**4-1870380031490*r**6-10161669452064*r**8
            -169078521974924*r**10-166949436264720*r**12+3738756616067994*r**14-17399424247564740*r**16
            +32744545575485731*r**18+34166726922229856*r**20-77010989736232340*r**22
            -59147791398313376*r**24+83297900667161760*r**26+107255449325792416*r**28
            -62165362210314444*r**30-49521759713978060*r**32-20592750220558851*r**34
            -4503484942601840*r**36-335739349456394*r**38-127459217543744*r**40-18594593304980*r**42
            +3039681423984*r**44+100853593810*r**46-18013371564*r**48+426591929*r**50))
            -23040*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1902679552*Q2**26
            -32*Q2**25*(922027087+866771815*r**2)+4*Q2**24*(49727843179+99911318422*r**2
            +45351072811*r**4)-2*Q2**23*(370836982232+1255095079335*r**2+1198056055110*r**4
            +348984013943*r**6)+4*Q2**22*(386686341554+2186137462241*r**2+3347569093659*r**4
            +2080461602843*r**6+432981830639*r**8)-4*Q2**21*(307311802726+4261933565935*r**2
            +9540719448268*r**4+9489304388845*r**6+4543635708052*r**8+701192588650*r**10)
            +2*Q2**20*(-1077615116612+6094252225479*r**2+20917314765081*r**4+27919876456786*r**6
            +26217678111312*r**8+12227552417907*r**10+1318665772903*r**12)+Q2**19*(6950215227836
            +24522964913303*r**2+74935225584414*r**4+185958704177705*r**6+143717529044240*r**8
            +9840137027661*r**10-15069551290402*r**12-261387718981*r**14)-2*Q2**18*(3018567351572
            +37569220036415*r**2+167019080902040*r**4+536158571416523*r**6+723449524835360*r**8
            +419382459241877*r**10+90115578988880*r**12+5900331322145*r**14+1616705773988*r**16)
            +Q2**17*(-4199360307564+70690075612869*r**2+427234476005076*r**4+2195867557957462*r**6
            +4319508173988456*r**8+3974592737433576*r**10+1785433043391124*r**12+347476380310386*r**14
            +39030848494572*r**16+4513001168091*r**18)-2*Q2**16*(-6768721364598-14206588160535*r**2
            -41156747022909*r**4+773284663194340*r**6+2644839131155204*r**8+3510918114115530*r**10
            +2575089483651910*r**12+1008231447950356*r**14+177076129017690*r**16+22753345514949*r**18
            +514346878335*r**20)-4*Q2**15*(2041373194716+34355801063478*r**2+231953932483707*r**4
            +598054282334807*r**6+682172366342339*r**8+954087528462677*r**10+499952258390189*r**12
            -261906211018813*r**14-263697428498983*r**16-55005020871291*r**18-6654811623456*r**20
            +1162744161366*r**22)+4*Q2**14*(-1795932262076+29304129483972*r**2+250107065456511*r**4
            +1674338498166340*r**6+4504018416215130*r**8+10126195170260016*r**10+12343359838326898*r**12
            +7128507244580544*r**14+1714686242654280*r**16+55003526668780*r**18-15262813160001*r**20
            +1784696875932*r**22+1455975093226*r**24)-4*Q2**13*(-3239442546304-7631120408515*r**2
            -34370744836365*r**4+1354401072661949*r**6+5159327752075700*r**8+18214648752912939*r**10
            +32583065984764790*r**12+28926411206580230*r**14+13099381907362356*r**16
            +2833100764484915*r**18+238197571902791*r**20+34228006621725*r**22+9772308020840*r**24
            +81663273989*r**26)-4*Q2**12*(853214408276+33991577204429*r**2+302477015460686*r**4
            +548809127893292*r**6+1084807253400191*r**8-8684322473828761*r**10-32843510383236979*r**12
            -44387790607047856*r**14-31577683276437802*r**16-12225022017043861*r**18
            -2439063114520684*r**20-349353802209196*r**22-82107597475369*r**24-11068314686863*r**26
            +1232722151921*r**28)+2*Q2**11*(-3238210988092+42418762422765*r**2+443926686230964*r**4
            +4204015523177885*r**6+16611344260167606*r**8+38084298033852411*r**10
            +30035938705076330*r**12+8404642648027071*r**14-16348585483297560*r**16
            -26344322449145701*r**18-14755269816512928*r**20-3735391196736525*r**22
            -884391354614146*r**24-131901921446115*r**26-4177704954654*r**28+1706457668945*r**30)
            +4*Q2**10*(1386000604444+8268054308647*r**2+60675453769653*r**4-1552165556511437*r**6
            -6692570743731134*r**8-37076341241832537*r**10-73324752197710373*r**12
            -116036146552630493*r**14-114789880343138208*r**16-54045440390206811*r**18
            -7244172453179621*r**20+4367697823740393*r**22+1658088912065818*r**24
            +391091981247853*r**26-13108168030059*r**28-9010596782879*r**30+375192114664*r**32)
            +Q2**9*(356281659736-72284484229562*r**2-715449312709556*r**4-1253168495000960*r**6
            -8659374651184760*r**8+85220542431541564*r**10+215886621779203252*r**12
            +577129539351887656*r**14+931813682891662240*r**16+728831227600305520*r**18
            +300084448412608564*r**20+68369658062634832*r**22-4752754998984824*r**24
            -2585669233602380*r**26-444333854497460*r**28+228921220166536*r**30+37210640048248*r**32
            -2858896796966*r**34)+4*Q2**8*(-610734053911+6345315815325*r**2+78337348780425*r**4
            +1315506170568506*r**6+6803830375258815*r**8+13695011167363956*r**10+41910787367712685*r**12
            +2386315702428750*r**14-168005386142099691*r**16-256761841668414670*r**18
            -179895519179943549*r**20-76534198136375370*r**22-24303798433266635*r**24
            -3825487318660596*r**26-1043398043207505*r**28-254819516819326*r**30-28678916565810*r**32
            -30167767695*r**34+138365003096*r**36)+2*Q2**7*(437611180768+8984284982047*r**2
            +61391484258108*r**4-1532763184373519*r**6-6506654609324282*r**8-61571104750719858*r**10
            -164458632039482602*r**12-271843627726816618*r**14+77636673086449734*r**16
            +673035265840306132*r**18+932534720144127262*r**20+675231423807226368*r**22
            +261836791867483202*r**24+60349436781211154*r**26+12110465569849842*r**28
            +3061960028931418*r**30+763451488883602*r**32-14434404391827*r**34-11157354483554*r**36
            +519027662623*r**38)-4*Q2**6*(-97213237034+4410165723265*r**2+42045079198318*r**4
            +141827029640995*r**6+1442791486936717*r**8-16420476377901884*r**10-9356284293134800*r**12
            -108607891630487908*r**14+11344602386304380*r**16+380142414185597518*r**18
            +709058119521102100*r**20+722961204709376890*r**22+426814154125437242*r**24
            +142966486711412180*r**26+23115414010631888*r**28+4787928240624748*r**30
            +609017300583670*r**32+143707143838873*r**34-10947453222530*r**36-2867089879973*r**38
            +151018735345*r**40)-12*Q2**5*(28899692262-172851764094*r**2-4120066467801*r**4
            -129151980013366*r**6-705972712908012*r**8-1927598241576447*r**10-18107049235243904*r**12
            +19577216560980816*r**14+8214188542140756*r**16-35084416473810788*r**18
            -71045889417851394*r**20-138318157165764468*r**22-106493302486894344*r**24
            -39801407199798774*r**26-14602613592514968*r**28-2444311001994544*r**30
            -1173061309445946*r**32+18604705449354*r**34+45985319868659*r**36+1268871713418*r**38
            -349501059852*r**40+9792623437*r**42)+6*Q2**4*(5848768836+572337700593*r**2
            +1761909588809*r**4-103853840954830*r**6-428966702593750*r**8-7474371808348319*r**10
            -19425493724260307*r**12+24289728363214504*r**14+30269376271903240*r**16
            +100895724611513650*r**18+240483747016756666*r**20-51417868859170692*r**22
            -392196785534827356*r**24-218375101217441190*r**26-5377309607629750*r**28
            +5001109252035656*r**30-318912495296092*r**32-1279027171028611*r**34+16436107781405*r**36
            +104107907338850*r**38+827393854786*r**40-942141089627*r**42+32615943529*r**44)
            -9*Q2**3*(-4764947004+168592129665*r**2+1338403128790*r**4+10924177778019*r**6
            +90896215096860*r**8-1704122031289229*r**10+4679347534242330*r**12-11883619985172015*r**14
            +24934213884905304*r**16+46742039834202330*r**18+29791358464190316*r**20
            -190209218138761010*r**22-421433244065927640*r**24-381555659976664266*r**26
            -225874458845233340*r**28-35212465306279854*r**30-1517010392980380*r**32
            -282763981705035*r**34+255888328980894*r**36+19093731587775*r**38+11522657614396*r**40
            -57370290105*r**42-102004492350*r**44+3729805549*r**46)-54*(-1+r**2)**2*(
            -1366310+490000763*r**2-1526606237*r**4-104294983765*r**6-864973569999*r**8
            -17724514069815*r**10+4939031835833*r**12+188493990786153*r**14-1632039697860195*r**16
            +4914985885393966*r**18+3074123572235230*r**20-20928525263294002*r**22
            +5380505629236538*r**24+27621628256676850*r**26-9022360613704654*r**28
            -8827592269995150*r**30-3596403424028172*r**32-806903048345337*r**34-81792808644305*r**36
            -14656857936969*r**38-1603421948955*r**40+271622562453*r**42+7154740133*r**44
            -1274989835*r**46+28275781*r**48)-18*Q2**2*(927723588+1922869727*r**2
            -244663207462*r**4-8919097932229*r**6-47870499014212*r**8-275422971941047*r**10
            -2464214955606598*r**12+12768476600958693*r**14-30224591421556764*r**16
            +11112216833675238*r**18+65689435944856628*r**20+47755549708827422*r**22
            +34888375947818408*r**24-44579983434004894*r**26-131787265621696252*r**28
            -52319234367838342*r**30-22972359547260708*r**32-4817446033879797*r**34
            -316573901506254*r**36-357521820713737*r**38-37378598456452*r**40+7802443105157*r**42
            +239954182658*r**44-52054877359*r**46+1323074588*r**48)+27*Q2*(62459452
            +5539671975*r**2-38656315376*r**4-1870380031490*r**6-10161669452064*r**8
            -169078521974924*r**10-166949436264720*r**12+3738756616067994*r**14-17399424247564740*r**16
            +32744545575485731*r**18+34166726922229856*r**20-77010989736232340*r**22
            -59147791398313376*r**24+83297900667161760*r**26+107255449325792416*r**28
            -62165362210314444*r**30-49521759713978060*r**32-20592750220558851*r**34
            -4503484942601840*r**36-335739349456394*r**38-127459217543744*r**40-18594593304980*r**42
            +3039681423984*r**44+100853593810*r**46-18013371564*r**48+426591929*r**50))*sqrtq2)
            +logq2*(-384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(170551440*Q2**25-6*Q2**24*(427752045
            +538605149*r**2)+24*Q2**23*(679562370+1929814511*r**2+1039930941*r**4)
            -4*Q2**22*(13829890455+68771662368*r**2+81727629553*r**4+26288565048*r**6)
            +2*Q2**21*(48336087690+423150777819*r**2+817296914501*r**4+607575952081*r**6
            +130422042189*r**8)-2*Q2**20*(13676615235+609507786108*r**2+1671643527058*r**4
            +2150189772628*r**6+1264928489453*r**8+176920007778*r**10)+Q2**19*(-244306846170
            -349046903499*r**2-1654904702905*r**4-2200451391070*r**6+2753581076780*r**8
            +2476939044885*r**10+108367255251*r**12)+6*Q2**18*(81058211955+746416449354*r**2
            +3884403312424*r**4+10050944348705*r**6+8746272926515*r**8+2328342361060*r**10
            +160971703714*r**12+73679819649*r**14)-3*Q2**17*(66820752990+2254645359409*r**2
            +15558460653819*r**4+63456992670579*r**6+91753233106665*r**8+57575133269675*r**10
            +14899077323409*r**12+2029571839049*r**14+208151566149*r**16)+Q2**16*(
            -591784353270+948898457238*r**2+19268492778172*r**4+245389729475892*r**6
            +546244200096648*r**8+545853779933800*r**10+283363815108108*r**12+63935495271252*r**14
            +7610215295542*r**16-89364754422*r**18)+4*Q2**15*(236834787870+2454427472721*r**2
            +19062926923166*r**4+11996597264026*r**6-33253630276479*r**8-50839701885154*r**10
            -84578166201389*r**12-57764426890614*r**14-11582012196139*r**16-799964705579*r**18
            +240490766211*r**20)-4*Q2**14*(47401352280+3034090084716*r**2+34666765088815*r**4
            +157378295475385*r**6+371328567370565*r**8+740753435794435*r**10+615513130536919*r**12
            +169378393596785*r**14+1281130827115*r**16+826062891385*r**18+855451532690*r**20
            +183561117966*r**22)+4*Q2**13*(-210334923180+188700378486*r**2+12182644155641*r**4
            +210481908142540*r**6+668941544291440*r**8+2007190961260040*r**10+2640764868186214*r**12
            +1572355073679064*r**14+419521005838880*r**16+60458678987890*r**18+13097207913985*r**20
            +1739485764316*r**22-94791436884*r**24)+4*Q2**12*(207985937895+2740583326572*r**2
            +30925855025117*r**4-41498827736753*r**6-149336506623465*r**8-1782002715876310*r**10
            -3757967570727842*r**12-3380138441600502*r**14-1613501941499227*r**16
            -403331205528680*r**18-80853216226875*r**20-14859092647753*r**22-1137776286803*r**24
            +213928343442*r**26)-2*Q2**11*(-33199336890+4646417920821*r**2+84166901715689*r**4
            +421001690543474*r**6+1836216105663166*r**8+2589726845850875*r**10+851906255521889*r**12
            +714086642132716*r**14-625456229697934*r**16-1224676699340941*r**18-536588689198085*r**20
            -153475637333614*r**22-6116669080966*r**24+1138228926349*r**26+101912835051*r**28)
            -4*Q2**10*(148911394005+214673248614*r**2-8422044519751*r**4-263191997041606*r**6
            -1103999487813466*r**8-4491505996449611*r**10-7418192800774984*r**12-12255659216405869*r**14
            -10241003121626819*r**16-3458243680715644*r**18+66070610956901*r**20+261296908307284*r**22
            +64696783276664*r**24-9539863795951*r**26-1691763047046*r**28+115864058799*r**30)
            +2*Q2**9*(153308437290+2997859172463*r**2+50051209533555*r**4-131752531695855*r**6
            +130956979223715*r**8-7228626564204725*r**10-11643830824334413*r**12-35418489559951875*r**14
            -47133257860861625*r**16-27179144372858875*r**18-7444421833066215*r**20
            +417164516989387*r**22+339353275251785*r**24+28188700492065*r**26-17460376140255*r**28
            -1900170057465*r**30+176231592963*r**32)+2*Q2**8*(63691197615-1612434399033*r**2
            -46485329244798*r**4-272701568064630*r**6-2116842008800020*r**8-1370998252104500*r**10
            -11997977963741642*r**12+8916590393912318*r**14+46604606706946870*r**16
            +45411548942309830*r**18+22921078159653710*r**20+6304750901901478*r**22
            +172698156184468*r**24+281308796214260*r**26+137084499375930*r**28-532414506990*r**30
            -1084393773093*r**32+32605623027*r**34)-4*Q2**7*(46609049430+166767094533*r**2
            -2136496965602*r**4-145437316047282*r**6-664629883988895*r**8-3576760770330220*r**10
            -10841553428319913*r**12-10481219820435838*r**14+16189230602018137*r**16
            +34919877040353410*r**18+34468547556985775*r**20+16681336817784562*r**22
            +3760304143339427*r**24+588373434714572*r**26+280324086988725*r**28+89112485373630*r**30
            -3795421602867*r**32-897409644647*r**34+44012644263*r**36)+4*Q2**6*(9118822995
            +366951040692*r**2+8913225080308*r**4-31518554340607*r**6+248631262767177*r**8
            -2658566050888725*r**10-14474219948307*r**12-14310899195564553*r**14+12959031471227207*r**16
            +41739682209160963*r**18+57260807542226445*r**20+42452412153000473*r**22
            +16673223934782427*r**24+2259021942424857*r**26+663294106626783*r**28
            +130167837128085*r**30+15991665183042*r**32-1217963326907*r**34-187687038157*r**36
            +11130611802*r**38)+2*Q2**5*(20012712390-269784910563*r**2-11797233486643*r**4
            -81046831255693*r**6-934829368633553*r**8+261307923474492*r**10-19170692321994492*r**12
            +37459908532412508*r**14-17793426574775552*r**16-31219810061664002*r**18
            -43857062553624202*r**20-67128892095996422*r**22-22189056123369062*r**24
            -7809355511763172*r**26+1056783879207828*r**28-1211761533780372*r**30
            -66211197520398*r**32+97299658797197*r**34-1135639973083*r**36-599107038773*r**38
            +19168893567*r**40)-2*Q2**4*(11849881635+41730221772*r**2-1191757405840*r**4
            -64919137260910*r**6-277541172597775*r**8-2210704795003590*r**10-10738890445211088*r**12
            +32457953619794280*r**14-20754030668383130*r**16+28888407412375240*r**18
            +63608488730704000*r**20-76506059555991668*r**22-68597032673768390*r**24
            -1857920372883260*r**26+2002173574927920*r**28+1578226573672680*r**30
            -792846288245913*r**32-81217817311300*r**34+75164260794800*r**36-584898406510*r**38
            -395929832475*r**40+12440889522*r**42)+3*Q2**3*(98124210+45285524703*r**2
            +1374924100593*r**4-7016940665210*r**6+101550752010480*r**8-981655973177965*r**10
            +2696633472666773*r**12-3789735285482712*r**14+3760263090383580*r**16
            +15951744892876670*r**18+3876702567863250*r**20-71764924570006172*r**22
            -69799240739123112*r**24-63050388887770530*r**26-11007295879371230*r**28
            -323310836933720*r**30-344361663419262*r**32+25242020374563*r**34+12378387508285*r**36
            +1243162645830*r**38-38790093400*r**40+6126877583*r**42+11966793*r**44)
            +18*(-1+r**2)**2*(8107155-10803917*r**2-2743732101*r**4-74298583737*r**6
            -428295274925*r**8-5086593874905*r**10-14619785128557*r**12+248659092625739*r**14
            -1480300769339002*r**16+4296557747772150*r**18-3161956049994890*r**20
            -6723585640981602*r**22+11105226922529214*r**24-2171680260837322*r**26
            -1393796459007650*r**28-919205799377250*r**30-288366120550457*r**32-19234804747241*r**34
            -5895609357777*r**36-1462215868325*r**38+161548608015*r**40+2298173283*r**42
            -503129361*r**44+9973463*r**46)+6*Q2**2*(612961155-8070191222*r**2-390666017722*r**4
            -2604129548677*r**6-43227793379975*r**8+78125422977210*r**10-1867288936784022*r**12
            +9459027179362013*r**14-23271513775734362*r**16+19960172787953740*r**18
            +16365486448111780*r**20+4250571616576438*r**22-320140131986342*r**24
            -24435212615104612*r**26-11959813497246180*r**28-6374202273305310*r**30
            -2338828336214297*r**32+195189512995658*r**34-129952501085482*r**36-39472394507585*r**38
            +6921370395165*r**40+61986339978*r**42-31274822982*r**44+728655633*r**46)
            -9*Q2*(142413930-871430597*r**2-60153357483*r**4-922134941383*r**6-7277390558997*r**8
            -25107319521275*r**10-344551365683397*r**12+3498890682322687*r**14-14985660772245593*r**16
            +31374527427716798*r**18-10926274924076830*r**20-35638971227969302*r**22
            +15900134373525262*r**24+31066504313159002*r**26-7908015748374362*r**28
            -9300380637114610*r**30-5061045943747192*r**32-1852267448602153*r**34
            -12921693079943*r**36-42123258776307*r**38-17337320447465*r**40+2130529756113*r**42
            +32029496687*r**44-8122838333*r**46+171974743*r**48))+384*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1364411520*Q2**30-96*Q2**29*(240524685
            +295951237*r**2)+6*Q2**28*(28162276515+76704226102*r**2+41356867347*r**4)
            -8*Q2**27*(85686679170+398238563697*r**2+467609255380*r**4+151737963237*r**6)
            +4*Q2**26*(394376426910+3006239245476*r**2+5743316454263*r**4+4166073578938*r**6
            +907937567241*r**8)-2*Q2**25*(753162579990+12368952154359*r**2+34608313272332*r**4
            +41714137769470*r**6+22125755427622*r**8+3247154809299*r**10)+2*Q2**24*(
            -1044826196850+7980939903105*r**2+34841086955205*r**4+63039050358678*r**6
            +73088821639178*r**8+33250926275125*r**10+2566345283055*r**12)+Q2**23*(8473190129550
            +51207797247615*r**2+209214831248920*r**4+515705614540877*r**6+372901032197374*r**8
            +4323097763197*r**10-29770228455340*r**12+4444688330415*r**14)-2*Q2**22*(4503255383475
            +73204826009235*r**2+426502061563900*r**4+1521111215510321*r**6+2165807851142900*r**8
            +1307977700126025*r**10+310581876060296*r**12+44867974057355*r**14+7424879365485*r**16)
            +Q2**21*(-4460425929450+124748422659855*r**2+1107418798574410*r**4+6592761255486774*r**6
            +14093871187160038*r**8+13884547630722240*r**10+6726128156575158*r**12
            +1477662045621914*r**14+201161189351300*r**16+8953042740705*r**18)+2*Q2**20*(10700515459800
            +53333365829595*r**2+151581460096205*r**4-2462985888942440*r**6-9503731234013304*r**8
            -13678580077848538*r**10-11053905476722118*r**12-4661739803406864*r**14
            -847244227784320*r**16-79316704040825*r**18+7259242530345*r**20)-Q2**19*(16998632596350
            +344378603080695*r**2+2903542997786540*r**4+8503850011839919*r**6+9428278083548764*r**8
            +14172440670005270*r**10+4659269896669624*r**12-8887826212521410*r**14
            -5401331400036586*r**16-595616353930781*r**18+47147713564300*r**20+26873050497795*r**22)
            +2*Q2**18*(-5631763876425+120040971917835*r**2+1689225724479550*r**4+12860104478044011*r**6
            +37810547475786847*r**8+93281929747200846*r**10+119564006158506732*r**12
            +69937559987267782*r**14+17150064784339821*r**16+2425954865396247*r**18
            +622256250867046*r**20+116918561063295*r**22+2880228399885*r**24)+Q2**17*(29350423695150
            +177189847627515*r**2+441982132821450*r**4-22761889592990292*r**6-103365925182268060*r**8
            -387320847560863705*r**10-726775597250478524*r**12-670834640721307600*r**14
            -317907932169001114*r**16-77126963655196535*r**18-13777743257708110*r**20
            -2198772218300892*r**22-210787176047160*r**24+24026187946965*r**26)-2*Q2**16*(6034333957425
            +209033642292480*r**2+2465548905655155*r**4+5156249226330768*r**6+314575526054991*r**8
            -120612722923229160*r**10-424568647599897563*r**12-569968226742058064*r**14
            -419237979136286289*r**16-174455110325282288*r**18-40170696730367795*r**20
            -7241011476918944*r**22-579492422822127*r**24+10183041181560*r**26+10770328211355*r**28)
            -2*Q2**15*(8508279548250-92856001133835*r**2-2123347861020800*r**4-21593597940302325*r**6
            -85030601127291386*r**8-220373393457546687*r**10-186661708888468644*r**12
            -167633936969369617*r**14-62512760406675450*r**16+90500790827149383*r**18
            +82206561897967736*r**20+24407720091687833*r**22+4053664652657274*r**24
            -474155735574045*r**26-120577612744820*r**28+3663905749965*r**30)+4*Q2**14*(5068968095025
            +49070664622305*r**2+280102219235540*r**4-8692823825932001*r**6-46922165867584186*r**8
            -267942119784766435*r**10-600646003511617472*r**12-1186887493744802365*r**14
            -1439185462517229604*r**16-869472551154515429*r**18-236317848333678460*r**20
            -15579820038106747*r**22+2441205038854690*r**24-266209683752761*r**26
            -460902024806776*r**28-52877255978375*r**30+5132854042155*r**32)+2*Q2**13*(
            -196094070450-134855903376285*r**2-2237285295952070*r**4-4667307819562414*r**6
            -4790170332100438*r**8+372494456622122346*r**10+1261837777082585354*r**12
            +3896136754859861834*r**14+6957749129398419414*r**16+6316043810410315208*r**18
            +3036952732057501934*r**20+745947187379083974*r**22+90712577771612174*r**24
            +15745310233454006*r**26+5202963058598862*r**28+366737332092446*r**30
            -18017379886300*r**32-2833008639435*r**34)-2*Q2**12*(5927256262575-26442393751080*r**2
            -1203988998607675*r**4-19301982031900344*r**6-94013514757004140*r**8-231462886865203320*r**10
            -293658353273703972*r**12+1308263373777758600*r**14+6097239283722020106*r**16
            +8465442792438900840*r**18+6225227289734432510*r**20+2647470116665800216*r**22
            +617365444425937140*r**24+117223025668744568*r**26+29798478745788060*r**28
            +6777534130494360*r**30-331828573058369*r**32-98014752816320*r**34+4794137890245*r**36)
            +2*Q2**11*(2977659013050+57785416969605*r**2+621529028595100*r**4-12096645952198903*r**6
            -70694372887199136*r**8-643507967532258500*r**10-1797829365378109048*r**12
            -4511189121887665364*r**14-3526379150870548988*r**16-1430418090536351866*r**18
            +567262780363078960*r**20+1939227586946230654*r**22+1464230140110353072*r**24
            +459750530423637196*r**26+137788368497413912*r**28+21808995648633020*r**30
            +2051904159773874*r**32-390265869076883*r**34-49798574207980*r**36+3566523551505*r**38)
            +4*Q2**10*(708458674725-22503156394305*r**2-516234238853155*r**4-1844657705504255*r**6
            -5819799123658682*r**8+204914234098252916*r**10+634349594221004548*r**12
            +3684843951400950604*r**14+6247784235127127550*r**16+9298452044648012098*r**18
            +9817609501261441126*r**20+5147472286218980526*r**22+992486640464201248*r**24
            -356952061218167420*r**26-180697235077417356*r**28-59003458312804772*r**30
            -770410250176139*r**32+2322200237462663*r**34+35150932164805*r**36-16982108647895*r**38
            +420336688770*r**40)-4*Q2**9*(893548019700+399767211390*r**2-139493749395915*r**4
            -4634162549091429*r**6-23235132105911089*r**8-73630369716260385*r**10
            -249181143480846852*r**12+1653123783715791940*r**14+3440658627865270524*r**16
            +9435780688027081044*r**18+17300028644629419670*r**20+14510435296235406674*r**22
            +6584230794001228290*r**24+1689621674461606894*r**26+8507208514214124*r**28
            -37556964038438460*r**30-10539838677382552*r**32+3908636623373910*r**34
            +2606263888624461*r**36-47078025123829*r**38-22408933104425*r**40+898004091915*r**42)
            +2*Q2**8*(170228582100+16935575062305*r**2+273481225938695*r**4-3889230875660834*r**6
            -23244668665132288*r**8-389966987283979999*r**10-1193614978845208499*r**12
            -3614513170193608344*r**14-7398025679994144776*r**16-2824735156920765262*r**18
            +25537949395275169414*r**20+41181002530712015828*r**22+31800928213438487728*r**24
            +14941033560816668314*r**26+4453100037115193338*r**28+919873548260585384*r**30
            +250049142915273876*r**32+90975870795372941*r**34+7844142049588771*r**36
            +263698678329662*r**38-71889984907024*r**40-4168060260635*r**42+311552311305*r**44)
            +Q2**7*(984569386950-15032749777605*r**2-443505467137400*r**4-3211562531590327*r**6
            -6701846560024930*r**8+380976587270580285*r**10+948986189891885252*r**12
            +12007068588248138615*r**14+17915253923538940076*r**16+36447153838089388030*r**18
            -21710651442964510400*r**20-105613602650752314166*r**22-134700165274588058740*r**24
            -101381819864783980726*r**26-44914211157208810920*r**28-10601187449039536130*r**30
            -2495532036506147954*r**32-526193109850621865*r**34-198437425164323368*r**36
            -15803178170721955*r**38+5327795827917270*r**40+63681267940073*r**42-33400304387260*r**44
            +945966567195*r**46)+2*Q2**6*(-205921907775-1446794295615*r**2+14579820861940*r**4
            +2145469293380307*r**6+8667937795580384*r**8+63891348752599415*r**10+241584441440547816*r**12
            -2381851387790946467*r**14+2689536033626463149*r**16-17123118023347961862*r**18
            +4228072681742151640*r**20+50034351738367679982*r**22+76677867776200509816*r**24
            +78011481512706786366*r**26+47575191703927388032*r**28+18797079084040139850*r**30
            +3522786463811993723*r**32+999097769922385909*r**34+117603072910517268*r**36
            +12725866037981711*r**38+3664376368730120*r**40-1333666215623781*r**42
            -4347110533448*r**44+7739213371785*r**46-230173160265*r**48)-3*Q2**5*(32246412390
            -1590319297545*r**2-32286894336790*r**4+371957344465230*r**6+2826078003621486*r**8
            +71964736096300052*r**10+195600487968389118*r**12+1117009228896049674*r**14
            +4654898580404633520*r**16-8521345693705239213*r**18-899721492201629916*r**20
            +8697752829579851276*r**22+8039538200794082748*r**24+32384932614279489120*r**26
            +27253659603091124348*r**28+8706953767501215636*r**30+2805940314153353574*r**32
            +451546469417369517*r**34+416748194354579730*r**36+55916948126496774*r**38
            -27424000722507082*r**40-2343644105794548*r**42+290831548506726*r**44
            +10866664443650*r**46-1497486589020*r**48+30000529545*r**50)+6*Q2**4*(17614671210
            -213338745383*r**2-6849944879115*r**4-78561666289504*r**6+273228375266716*r**8
            +11118754218639870*r**10+31305651328770374*r**12+671333222777498760*r**14
            +245682176314438446*r**16-968733126164390469*r**18-2061846134017132505*r**20
            -4508096948448155616*r**22-9508671164893950040*r**24+9897519832530173236*r**26
            +23884230182593360836*r**28+16460245663805795120*r**30+2822834533844634534*r**32
            -60844593953480865*r**34-5374499411214669*r**36+60784076180970496*r**38
            +19353601737322620*r**40-7759437227641426*r**42-1524399832432490*r**44
            +184158712820616*r**46+4725014060546*r**48-871921551315*r**50+19278640017*r**52)
            -9*Q2**3*(1522263510+35952274243*r**2+219063216428*r**4-41499302704733*r**6
            -80842684936876*r**8-2430058780134838*r**10-2800176591298824*r**12+97686488344377426*r**14
            -573269478929942398*r**16+1954656853842502929*r**18-4125443555955059068*r**20
            -35344541144001399*r**22+2871188516867656056*r**24+8782695956622596892*r**26
            +15100402196473483344*r**28+10778248557692282732*r**30+7620620439434080186*r**32
            +1245306165464085621*r**34-122371643491928908*r**36+45236985542713029*r**38
            -34263039754445708*r**40-7164506088009094*r**42+477499504941496*r**44
            -175220921776478*r**46+17614154022574*r**48+294653500247*r**50-74562272612*r**52
            +1731714223*r**54)-54*(-1+r**2)**2*(8107155-116196932*r**2-3478853920*r**4
            -38338816128*r**6+834970810585*r**8+8801963367700*r**10+105821729694100*r**12
            +1035287465335100*r**14-2579086501109425*r**16-1670080035417640*r**18
            +74185064926795900*r**20-273021098651091180*r**22-4532574010621275*r**24
            +863763320881367080*r**26-400977225077558840*r**28-863378234012236200*r**30
            +245641259380749385*r**32+292870838981392300*r**34+146609597910810840*r**36
            +43851959570830760*r**38+5562808846016875*r**40+754233631851780*r**42
            +197849801635300*r**44-4575704794580*r**46-3756342171115*r**48+184933192320*r**50
            +7761720972*r**52-632784380*r**54+9973463*r**56)-18*Q2**2*(531889605
            -16395987207*r**2-335494796330*r**4+4345478868217*r**6+46537715905805*r**8
            +1140480794598190*r**10+2935142056811060*r**12+31838551705487110*r**14
            +91386668239282585*r**16-907529039125415245*r**18+2966201361317077890*r**20
            -3388161880685616645*r**22-3011575980139309215*r**24+2441060372752586740*r**26
            -2452904036232382920*r**28-1307643147712796060*r**30+5437606620331927695*r**32
            +3269218702263016335*r**34+1682729093945150650*r**36+515792963643725855*r**38
            +26500556502661415*r**40+20310266206782590*r**42+7470532014255060*r**44
            -514352762218570*r**46-126661394227245*r**48+8612157922085*r**50+372517054382*r**52
            -36269174835*r**54+628921003*r**56)+27*Q2*(142413930-2787668927*r**2
            -65156748666*r**4-35869589724*r**6+12240799408092*r**8+187788968865305*r**10
            +943830279904340*r**12+12148612876568560*r**14-21900495292674850*r**16
            -137469439845079075*r**18+1050883433596512130*r**20-2668442084391889740*r**22
            +283779963321134920*r**24+3804164940052426965*r**26-969115076025637320*r**28
            -330851024597835520*r**30-4400231379497437050*r**32+1464469610196932915*r**34
            +1691791488191350570*r**36+912642986744241740*r**38+298262887635878780*r**40
            +28542050853145595*r**42+5199889372648500*r**44+2454569145625360*r**46
            -58479794364430*r**48-49343044884625*r**50+2621567520782*r**52+121801554396*r**54
            -10438297696*r**56+171974743*r**58))*sqrtq2))/(40320000*r**4*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2
            +40320000*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))**2*sqrtq2+logq2**8*(3900793946112000000*r**36*(1
            +r**2)**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+3900793946112000000*r**36*(1
            +r**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2*(-5806080000*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4
            -Q2**3*(1+r**2)-2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4
            +r**6)+4*(1-9*r**2-44*r**4-9*r**6+r**8))-5806080000*(-Q2+(-1+r)**2)**3*r**8*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4-Q2**3*(1+r**2)
            -2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4+r**6)+4*(1-9*r**2
            -44*r**4-9*r**6+r**8))*sqrtq2)+logq2**7*(-86684309913600000*r**32*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))-86684309913600000*r**32*(1+r**2)*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))*sqrtq2)+logq2**3*(-1393459200000*(-Q2+(-1
            +r)**2)**3*r**16*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8
            +68*Q2**7*(1+r**2)-Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2
            +683*r**4+169*r**6)+2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)
            +6*Q2**3*(31+230*r**2+159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(
            -131+1184*r**2+6523*r**4+8368*r**6+6523*r**8+1184*r**10-131*r**12)
            -9*Q2*(13+5*r**2-1493*r**4-5245*r**6-5245*r**8-1493*r**10+5*r**12
            +13*r**14)+36*(4-67*r**2-28*r**4+2331*r**6+5600*r**8+2331*r**10-28*r**12
            -67*r**14+4*r**16))-1393459200000*(-Q2+(-1+r)**2)**3*r**16*(1-Q2+r**2)*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)
            -Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2+683*r**4+169*r**6)
            +2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)+6*Q2**3*(31+230*r**2
            +159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4
            +8368*r**6+6523*r**8+1184*r**10-131*r**12)-9*Q2*(13+5*r**2-1493*r**4
            -5245*r**6-5245*r**8-1493*r**10+5*r**12+13*r**14)+36*(4-67*r**2-28*r**4
            +2331*r**6+5600*r**8+2331*r**10-28*r**12-67*r**14+4*r**16))*sqrtq2)
            +logq2**2*(348364800000*(-Q2+(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8-4*Q2**7*(1+r**2)-Q2**6*(57
            +50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4+5*r**6)+Q2**4*(85-226*r**2
            -1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1-54*r**2-143*r**4-143*r**6
            -54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4+3168*r**6+2871*r**8
            +468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4-2833*r**6-2833*r**8
            -565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4+4368*r**6+11718*r**8
            +4368*r**10-56*r**12-96*r**14+5*r**16))+348364800000*(-Q2+(-1+r)**2)**3*r**12*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8-4*Q2**7*(1+r**2)
            -Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4+5*r**6)+Q2**4*(85
            -226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1-54*r**2-143*r**4
            -143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4+3168*r**6+2871*r**8
            +468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4-2833*r**6-2833*r**8
            -565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4+4368*r**6+11718*r**8
            +4368*r**10-56*r**12-96*r**14+5*r**16))*sqrtq2)+logq2**5*(-120394874880000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219+310*r**2
            +219*r**4)-Q2**5*(977+2179*r**2+2179*r**4+977*r**6)+Q2**4*(590-2090*r**2
            -6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4-2073*r**6
            +10*r**8+243*r**10)+Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6+41127*r**8
            +8076*r**10-879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6+67125*r**8
            +31341*r**10+3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4+12789*r**6
            +25830*r**8+12789*r**10+28*r**12-573*r**14+41*r**16))-120394874880000*r**24*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219
            +310*r**2+219*r**4)-Q2**5*(977+2179*r**2+2179*r**4+977*r**6)+Q2**4*(590
            -2090*r**2-6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4
            -2073*r**6+10*r**8+243*r**10)+Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6
            +41127*r**8+8076*r**10-879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6
            +67125*r**8+31341*r**10+3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4
            +12789*r**6+25830*r**8+12789*r**10+28*r**12-573*r**14+41*r**16))*sqrtq2)
            +logq2**4*(25082265600000*r**20*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(32*Q2**8
            +104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)-24*Q2**5*(13+31*r**2
            +31*r**4+13*r**6)+Q2**4*(415-1180*r**2-4598*r**4-1180*r**6+415*r**8)
            +4*Q2**3*(102+155*r**2-677*r**4-677*r**6+155*r**8+102*r**10)+Q2**2*(
            -389+3526*r**2+18377*r**4+25852*r**6+18377*r**8+3526*r**10-389*r**12)
            -12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8-1133*r**10-55*r**12
            +18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6+53690*r**8+24556*r**10
            -168*r**12-892*r**14+59*r**16))+25082265600000*r**20*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)
            -24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415-1180*r**2-4598*r**4
            -1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4-677*r**6+155*r**8
            +102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6+18377*r**8
            +3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8
            -1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6
            +53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))*sqrtq2)+logq2**6*(481579499520000*r**28*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(16*Q2**8+332*Q2**7*(1
            +r**2)+Q2**6*(153+370*r**2+153*r**4)-Q2**5*(2011+4817*r**2+4817*r**4
            +2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4-2410*r**6+295*r**8)+6*Q2**3*(559
            -310*r**2-4869*r**4-4869*r**6-310*r**8+559*r**10)-3*Q2**2*(479-4496*r**2
            -22867*r**4-35272*r**6-22867*r**8-4496*r**10+479*r**12)-9*Q2*(187
            -865*r**2-5807*r**4-10315*r**6-10315*r**8-5807*r**10-865*r**12+187*r**14)
            +9*(109-1432*r**2+392*r**4+26376*r**6+49910*r**8+26376*r**10+392*r**12
            -1432*r**14+109*r**16))+481579499520000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(16*Q2**8+332*Q2**7*(1+r**2)+Q2**6*(153+370*r**2+153*r**4)
            -Q2**5*(2011+4817*r**2+4817*r**4+2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4
            -2410*r**6+295*r**8)+6*Q2**3*(559-310*r**2-4869*r**4-4869*r**6-310*r**8
            +559*r**10)-3*Q2**2*(479-4496*r**2-22867*r**4-35272*r**6-22867*r**8
            -4496*r**10+479*r**12)-9*Q2*(187-865*r**2-5807*r**4-10315*r**6-10315*r**8
            -5807*r**10-865*r**12+187*r**14)+9*(109-1432*r**2+392*r**4+26376*r**6
            +49910*r**8+26376*r**10+392*r**12-1432*r**14+109*r**16))*sqrtq2))+(muWC**4*(16*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))**2*(63204*Q2**25-16*Q2**24*(88152+11911*r**2)
            +4*Q2**23*(-377181-1504218*r**2+502577*r**4)+Q2**22*(513006717+139182901*r**2
            +913009619*r**4-44956309*r**6)+4*Q2**21*(-1510963281-573426887*r**2-2457205469*r**4
            -2954400609*r**6+88010852*r**8)+Q2**20*(33336451455+15803724621*r**2
            -5822922814*r**4+123106593318*r**6+69887880207*r**8-1425719011*r**10)
            +4*Q2**19*(-26655887688-13615480816*r**2+113348259991*r**4+13589302476*r**6
            -165304605822*r**8-56733873148*r**10+834227291*r**12)+Q2**18*(203151363051
            +109519510051*r**2-2702401628297*r**4-4209729414369*r**6-1173907672675*r**8
            +1690314412949*r**10+382539776673*r**12-4106084727*r**14)+4*Q2**17*(-47330549277
            -47541853695*r**2+2148189859102*r**4+5457198845045*r**6+6292229340976*r**8
            +2945280824399*r**10-237213803550*r**12-19559505909*r**14+45515709*r**16)
            +Q2**16*(-74559984759+481356212147*r**2-17613992059396*r**4-63506309562580*r**6
            -109793143804014*r**8-117115267886258*r**10-54577414318988*r**12-6569676644636*r**14
            -1087196048331*r**16+8071148463*r**18)-8*Q2**15*(-55566165045+136692748446*r**2
            -2991501416081*r**4-16094515860640*r**6-35028966898470*r**8-50202223220340*r**10
            -44524922731226*r**12-16485658855456*r**14-2498087938933*r**16-287461620474*r**18
            +1525358507*r**20)+2*Q2**14*(-237269273151+576129337929*r**2-8745846052901*r**4
            -91326384562413*r**6-233349830241942*r**8-377552427230550*r**10-410449749625434*r**12
            -297361078551258*r**14-70904789488131*r**16-11023187225163*r**18-784593462441*r**20
            +1960757407*r**22)+8*Q2**13*(-2765292423+99482127033*r**2-970287155379*r**4
            +17936866285091*r**6+49612170272550*r**8+76313571014402*r**10+56734083307678*r**12
            +35490634982574*r**14+32011618738601*r**16-9346086514355*r**18-693544293971*r**20
            -192417628889*r**22+1356744976*r**24)+Q2**12*(548735292822-3802384610206*r**2
            +39703431180412*r**4+27255551824500*r**6+144919354599690*r**8+664249568041694*r**10
            +2045164576480296*r**12+3311691315603832*r**14+2418198720048314*r**16
            +941478626979534*r**18+432448588145020*r**20+45399193266804*r**22+3964934498694*r**24
            -15474931054*r**26)+8*Q2**11*(-60903291438+476910918204*r**2-5797720699477*r**4
            -24909830522356*r**6-88369231226816*r**8-271844965652576*r**10-653517311296819*r**12
            -1114276459052408*r**14-1185642333389142*r**16-612985418225428*r**18-239171270767907*r**20
            -62000495439156*r**22-6197350448172*r**24-311247408552*r**26+535919611*r**28)
            +2*Q2**10*(-22404614325+361869709619*r**2+5031785928155*r**4+101276942682979*r**6
            +304727495873683*r**8+1048471515152187*r**10+2209926459830075*r**12+4105255789284195*r**14
            +5290076809660529*r**16+4672239562617961*r**18+957402691662033*r**20+604723338982633*r**22
            +17203027147185*r**24+2297402177705*r**26-723819350759*r**28+4567570897*r**30)
            -4*Q2**9*(-96400965147+1251549199030*r**2-9205954552128*r**4+21288779165990*r**6
            +41602702742332*r**8+287324970007366*r**10-108063555612024*r**12-684471675765274*r**14
            -921158517232634*r**16-881533938301950*r**18-109076016738544*r**20-1389100446632782*r**22
            -155712285846260*r**24-122900096593278*r**26-10065036940504*r**28-840231834942*r**30
            +2686826829*r**32)+2*Q2**8*(-126093402807+2012150984091*r**2-21635885268776*r**4
            +2033370641888*r**6+34062113589400*r**8+532715219287008*r**10-1792829633888032*r**12
            -6270691452691304*r**14-10969225182646206*r**16-11713674560870530*r**18
            -9263843215704296*r**20-4269520230795888*r**22-4066822314304144*r**24
            -771712334349992*r**26-243231166686160*r**28-19187038112520*r**30-880089491091*r**32
            +1445794479*r**34)+4*Q2**7*(-7745779797+68781854662*r**2+2170376565469*r**4
            +9826921769824*r**6-14572214764908*r**8-207648715370504*r**10+838035616376708*r**12
            +2712730010872992*r**14+5255109019775314*r**16+6963709596171188*r**18
            +5562639231943830*r**20+1894800842128288*r**22+2130309775596788*r**24
            +424931303140248*r**26+239080659898580*r**28+13913225070176*r**30+1327845780347*r**32
            -155718735114*r**34+838214709*r**36)-Q2**6*(-129329503281+2562605706263*r**2
            -20134120673399*r**4+92189179763345*r**6+198312149373564*r**8+128142882569980*r**10
            +1683984381877332*r**12+4440758773695764*r**14+8340454818066226*r**16
            +2648720321615874*r**18+6681724519090638*r**20+9674220333754462*r**22
            -24355685617547796*r**24+8158811015194028*r**26-5447570278888380*r**28
            +81591059331268*r**30-236707051055977*r**32-15574551300289*r**34-1292658254319*r**36
            +3508330297*r**38)+4*Q2**5*(-15836218905+397311395061*r**2-4406703113077*r**4
            +23335940657163*r**6+74431367220960*r**8+89024396152004*r**10-30919922400812*r**12
            +830191176888332*r**14+2306381600069178*r**16-998885834563082*r**18-2969511540463102*r**20
            -4491686950487014*r**22+5589215057755852*r**24-10059710615934220*r**26
            +2064879357959764*r**28-1352731675881348*r**30-57641951597385*r**32-45974560915107*r**34
            -3076743165621*r**36-150185503917*r**38+265553276*r**40)+(-1+r**2)**4*(
            -182579499+7097754219*r**2-88738753966*r**4+1252918829278*r**6+2687441034585*r**8
            -33777946256985*r**10+220298234556888*r**12-906124066803192*r**14+3898810752518506*r**16
            -8541642347545930*r**18+4659352359956364*r**20+6705334520810932*r**22
            -10199314481732518*r**24+5263386175251654*r**26-1687390230495720*r**28
            +267395818397448*r**30-55595936970879*r**32-286775396449*r**34-905006207438*r**36
            -44068347810*r**38-1771897203*r**40+2837715*r**42)+Q2**4*(-5156217477
            +20278710977*r**2+1994104371826*r**4-21565687788618*r**6-96374733155025*r**8
            -83816444794019*r**10+976731548065528*r**12-4741389407356440*r**14-6538858954619018*r**16
            +616426877104898*r**18-6557455913346068*r**20-9395248522452348*r**22+31490150714146102*r**24
            -27885483704578110*r**26+17529608685718904*r**28-1898784624188824*r**30
            +958809079505679*r**32+192631455256637*r**34+24819538877746*r**36+2271096116598*r**38
            -46365211237*r**40+362008289*r**42)-4*Q2*(-1+r**2)**2*(-505873089+18100771689*r**2
            -224769609799*r**4+2577039621192*r**6+4169924814171*r**8-49563829283649*r**10
            +281110134878733*r**12-867524239584536*r**14+3351731676981094*r**16-4622405304486798*r**18
            -3258670022152614*r**20+7117588689927832*r**22+3765470358048822*r**24
            -11681784038433514*r**26+7508009555543658*r**28-2783729916679944*r**30
            +529917113868731*r**32-109621387051915*r**34+1706888171853*r**36-1964074366656*r**38
            -99021241329*r**40-4844584485*r**42+8640553*r**44)-4*Q2**3*(-4752825324
            +130588083000*r**2-1298124709987*r**4+8923634327940*r**6+10736536916450*r**8
            -71144650054236*r**10+420316473863597*r**12-1212343968175632*r**14+2736964929333040*r**16
            +758038448165760*r**18-1457643210161558*r**20+5860286056832664*r**22-7966785683191332*r**24
            -1539137534325000*r**26+5897240835520530*r**28-4761511856376080*r**30
            +1528153029898956*r**32-417060323968792*r**34+30903756893145*r**36-9866481983740*r**38
            -462141348302*r**40-44439340092*r**42+111184993*r**44)+Q2**2*(-9131106993
            +299717919687*r**2-3633429707565*r**4+34006419597083*r**6+23071727607013*r**8
            -438493148192099*r**10+2313746458031217*r**12-6375595461596679*r**14+22561333968275030*r**16
            -28104126067250234*r**18+4041345234740990*r**20-21803948321578738*r**22
            +35532097565254282*r**24+36644903718317882*r**26-99512183402567646*r**28
            +72981001010774514*r**30-29958657600478773*r**32+6908899186835683*r**34
            -1389545149558561*r**36+67031070207367*r**38-26463591384287*r**40-1334173123143*r**42
            -86473627971*r**44+175971941*r**46))+16*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(63204*Q2**25
            -16*Q2**24*(88152+11911*r**2)+4*Q2**23*(-377181-1504218*r**2+502577*r**4)
            +Q2**22*(513006717+139182901*r**2+913009619*r**4-44956309*r**6)+4*Q2**21*(
            -1510963281-573426887*r**2-2457205469*r**4-2954400609*r**6+88010852*r**8)
            +Q2**20*(33336451455+15803724621*r**2-5822922814*r**4+123106593318*r**6
            +69887880207*r**8-1425719011*r**10)+4*Q2**19*(-26655887688-13615480816*r**2
            +113348259991*r**4+13589302476*r**6-165304605822*r**8-56733873148*r**10
            +834227291*r**12)+Q2**18*(203151363051+109519510051*r**2-2702401628297*r**4
            -4209729414369*r**6-1173907672675*r**8+1690314412949*r**10+382539776673*r**12
            -4106084727*r**14)+4*Q2**17*(-47330549277-47541853695*r**2+2148189859102*r**4
            +5457198845045*r**6+6292229340976*r**8+2945280824399*r**10-237213803550*r**12
            -19559505909*r**14+45515709*r**16)+Q2**16*(-74559984759+481356212147*r**2
            -17613992059396*r**4-63506309562580*r**6-109793143804014*r**8-117115267886258*r**10
            -54577414318988*r**12-6569676644636*r**14-1087196048331*r**16+8071148463*r**18)
            -8*Q2**15*(-55566165045+136692748446*r**2-2991501416081*r**4-16094515860640*r**6
            -35028966898470*r**8-50202223220340*r**10-44524922731226*r**12-16485658855456*r**14
            -2498087938933*r**16-287461620474*r**18+1525358507*r**20)+2*Q2**14*(-237269273151
            +576129337929*r**2-8745846052901*r**4-91326384562413*r**6-233349830241942*r**8
            -377552427230550*r**10-410449749625434*r**12-297361078551258*r**14-70904789488131*r**16
            -11023187225163*r**18-784593462441*r**20+1960757407*r**22)+8*Q2**13*(
            -2765292423+99482127033*r**2-970287155379*r**4+17936866285091*r**6+49612170272550*r**8
            +76313571014402*r**10+56734083307678*r**12+35490634982574*r**14+32011618738601*r**16
            -9346086514355*r**18-693544293971*r**20-192417628889*r**22+1356744976*r**24)
            +Q2**12*(548735292822-3802384610206*r**2+39703431180412*r**4+27255551824500*r**6
            +144919354599690*r**8+664249568041694*r**10+2045164576480296*r**12+3311691315603832*r**14
            +2418198720048314*r**16+941478626979534*r**18+432448588145020*r**20+45399193266804*r**22
            +3964934498694*r**24-15474931054*r**26)+8*Q2**11*(-60903291438+476910918204*r**2
            -5797720699477*r**4-24909830522356*r**6-88369231226816*r**8-271844965652576*r**10
            -653517311296819*r**12-1114276459052408*r**14-1185642333389142*r**16-612985418225428*r**18
            -239171270767907*r**20-62000495439156*r**22-6197350448172*r**24-311247408552*r**26
            +535919611*r**28)+2*Q2**10*(-22404614325+361869709619*r**2+5031785928155*r**4
            +101276942682979*r**6+304727495873683*r**8+1048471515152187*r**10+2209926459830075*r**12
            +4105255789284195*r**14+5290076809660529*r**16+4672239562617961*r**18
            +957402691662033*r**20+604723338982633*r**22+17203027147185*r**24+2297402177705*r**26
            -723819350759*r**28+4567570897*r**30)-4*Q2**9*(-96400965147+1251549199030*r**2
            -9205954552128*r**4+21288779165990*r**6+41602702742332*r**8+287324970007366*r**10
            -108063555612024*r**12-684471675765274*r**14-921158517232634*r**16-881533938301950*r**18
            -109076016738544*r**20-1389100446632782*r**22-155712285846260*r**24-122900096593278*r**26
            -10065036940504*r**28-840231834942*r**30+2686826829*r**32)+2*Q2**8*(-126093402807
            +2012150984091*r**2-21635885268776*r**4+2033370641888*r**6+34062113589400*r**8
            +532715219287008*r**10-1792829633888032*r**12-6270691452691304*r**14-10969225182646206*r**16
            -11713674560870530*r**18-9263843215704296*r**20-4269520230795888*r**22
            -4066822314304144*r**24-771712334349992*r**26-243231166686160*r**28-19187038112520*r**30
            -880089491091*r**32+1445794479*r**34)+4*Q2**7*(-7745779797+68781854662*r**2
            +2170376565469*r**4+9826921769824*r**6-14572214764908*r**8-207648715370504*r**10
            +838035616376708*r**12+2712730010872992*r**14+5255109019775314*r**16+6963709596171188*r**18
            +5562639231943830*r**20+1894800842128288*r**22+2130309775596788*r**24
            +424931303140248*r**26+239080659898580*r**28+13913225070176*r**30+1327845780347*r**32
            -155718735114*r**34+838214709*r**36)-Q2**6*(-129329503281+2562605706263*r**2
            -20134120673399*r**4+92189179763345*r**6+198312149373564*r**8+128142882569980*r**10
            +1683984381877332*r**12+4440758773695764*r**14+8340454818066226*r**16
            +2648720321615874*r**18+6681724519090638*r**20+9674220333754462*r**22
            -24355685617547796*r**24+8158811015194028*r**26-5447570278888380*r**28
            +81591059331268*r**30-236707051055977*r**32-15574551300289*r**34-1292658254319*r**36
            +3508330297*r**38)+4*Q2**5*(-15836218905+397311395061*r**2-4406703113077*r**4
            +23335940657163*r**6+74431367220960*r**8+89024396152004*r**10-30919922400812*r**12
            +830191176888332*r**14+2306381600069178*r**16-998885834563082*r**18-2969511540463102*r**20
            -4491686950487014*r**22+5589215057755852*r**24-10059710615934220*r**26
            +2064879357959764*r**28-1352731675881348*r**30-57641951597385*r**32-45974560915107*r**34
            -3076743165621*r**36-150185503917*r**38+265553276*r**40)+(-1+r**2)**4*(
            -182579499+7097754219*r**2-88738753966*r**4+1252918829278*r**6+2687441034585*r**8
            -33777946256985*r**10+220298234556888*r**12-906124066803192*r**14+3898810752518506*r**16
            -8541642347545930*r**18+4659352359956364*r**20+6705334520810932*r**22
            -10199314481732518*r**24+5263386175251654*r**26-1687390230495720*r**28
            +267395818397448*r**30-55595936970879*r**32-286775396449*r**34-905006207438*r**36
            -44068347810*r**38-1771897203*r**40+2837715*r**42)+Q2**4*(-5156217477
            +20278710977*r**2+1994104371826*r**4-21565687788618*r**6-96374733155025*r**8
            -83816444794019*r**10+976731548065528*r**12-4741389407356440*r**14-6538858954619018*r**16
            +616426877104898*r**18-6557455913346068*r**20-9395248522452348*r**22+31490150714146102*r**24
            -27885483704578110*r**26+17529608685718904*r**28-1898784624188824*r**30
            +958809079505679*r**32+192631455256637*r**34+24819538877746*r**36+2271096116598*r**38
            -46365211237*r**40+362008289*r**42)-4*Q2*(-1+r**2)**2*(-505873089+18100771689*r**2
            -224769609799*r**4+2577039621192*r**6+4169924814171*r**8-49563829283649*r**10
            +281110134878733*r**12-867524239584536*r**14+3351731676981094*r**16-4622405304486798*r**18
            -3258670022152614*r**20+7117588689927832*r**22+3765470358048822*r**24
            -11681784038433514*r**26+7508009555543658*r**28-2783729916679944*r**30
            +529917113868731*r**32-109621387051915*r**34+1706888171853*r**36-1964074366656*r**38
            -99021241329*r**40-4844584485*r**42+8640553*r**44)-4*Q2**3*(-4752825324
            +130588083000*r**2-1298124709987*r**4+8923634327940*r**6+10736536916450*r**8
            -71144650054236*r**10+420316473863597*r**12-1212343968175632*r**14+2736964929333040*r**16
            +758038448165760*r**18-1457643210161558*r**20+5860286056832664*r**22-7966785683191332*r**24
            -1539137534325000*r**26+5897240835520530*r**28-4761511856376080*r**30
            +1528153029898956*r**32-417060323968792*r**34+30903756893145*r**36-9866481983740*r**38
            -462141348302*r**40-44439340092*r**42+111184993*r**44)+Q2**2*(-9131106993
            +299717919687*r**2-3633429707565*r**4+34006419597083*r**6+23071727607013*r**8
            -438493148192099*r**10+2313746458031217*r**12-6375595461596679*r**14+22561333968275030*r**16
            -28104126067250234*r**18+4041345234740990*r**20-21803948321578738*r**22
            +35532097565254282*r**24+36644903718317882*r**26-99512183402567646*r**28
            +72981001010774514*r**30-29958657600478773*r**32+6908899186835683*r**34
            -1389545149558561*r**36+67031070207367*r**38-26463591384287*r**40-1334173123143*r**42
            -86473627971*r**44+175971941*r**46))*sqrtq2+logq2**8*(-6772211712000000*r**32*(1
            +r**2)**2*(1-Q2+r**2)*(-5184-14784*r**2-37979*r**4+101949*r**6-14077*r**8
            +1203*r**10)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-6772211712000000*(Q2
            -(-1+r)**2)**2*r**32*(1+r**2)**2*(-5184-14784*r**2-37979*r**4+101949*r**6
            -14077*r**8+1203*r**10)*(Q2-(1+r)**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2**7*(-10749542400000*r**28*(1+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(630*Q2**11*(96+96*r**2+1255*r**4+1255*r**6)-90*Q2**10*(4448
            +17344*r**2+94801*r**4+183560*r**6+101655*r**8)+30*Q2**9*(-2976+203744*r**2
            +1432679*r**4+3574639*r**6+3896095*r**8+1547415*r**10)-2*Q2**8*(-4286304
            -4684992*r**2+44239432*r**4+173877579*r**6+267685595*r**8+210327045*r**10
            +67803885*r**12)+6*Q2**7*(-5574384-17370336*r**2-3022505*r**4+80279501*r**6
            +196938464*r**8+230682340*r**10+146623515*r**12+41373585*r**14)-3*Q2**6*(
            -19299168-80039904*r**2-109393339*r**4+5539909*r**6+301502334*r**8+656409518*r**10
            +660406045*r**12+361543665*r**14+93929220*r**16)+Q2**5*(-39076128-213864000*r**2
            -409510685*r**4-543537030*r**6-265367065*r**8+608686450*r**10+1481026953*r**12
            +1423007690*r**14+669935805*r**16+162715770*r**18)+6*(-1+r**2)**4*(-794832
            -1961968*r**2-3868957*r**4-26365640*r**6-9991990*r**8+76688772*r**10
            +18326398*r**12-9312868*r**14+5163550*r**16+3407320*r**18+1005255*r**20)
            +12*Q2**4*(-2265480-1240680*r**2+7357929*r**4+24688772*r**6+26139778*r**8
            +28886146*r**10+5687995*r**12-14260860*r**14-14330900*r**16+3195990*r**18
            +2371950*r**20)-3*Q2*(-1+r**2)**2*(-9372192-21641280*r**2-34980475*r**4
            -265981022*r**6-323829470*r**8+558407922*r**10+820780340*r**12+83984690*r**14
            -72985418*r**16+50442630*r**18+38747535*r**20+13147380*r**22)-6*Q2**3*(
            -12944592-28039296*r**2-23968017*r**4-103626010*r**6-186771640*r**8
            +195709200*r**10+322869252*r**12+22415446*r**14+12279412*r**16+63151500*r**18
            +60103905*r**20+21957480*r**22)+Q2**2*(-67347936-105357984*r**2-77867477*r**4
            -1180349979*r**6-1675356586*r**8+1550031976*r**10+2833441974*r**12+3417150062*r**14
            +344482624*r**16-475825944*r**18+134489855*r**20+217767165*r**22+105066090*r**24))
            +10749542400000*r**28*(1+r**2)*(630*Q2**14*(96+96*r**2+1255*r**4+1255*r**6)
            -180*Q2**13*(3232+10688*r**2+61586*r**4+118135*r**6+64005*r**8)+30*Q2**12*(43104
            +409952*r**2+2531129*r**4+6217711*r**6+6594805*r**8+2541375*r**10)-2*Q2**11*(
            -3789504+7091328*r**2+133172887*r**4+434861019*r**6+646150175*r**8+489214545*r**10
            +151556310*r**12)+6*Q2**10*(-9838608-23121792*r**2+61110055*r**4+370536992*r**6
            +751789208*r**8+821630530*r**10+499898595*r**12+133913520*r**14)-5*Q2**9*(
            -36808704-138435648*r**2-87463005*r**4+531483221*r**6+1686853296*r**8
            +2581530790*r**10+2314180491*r**12+1214443401*r**14+295951590*r**16)
            +10*Q2**8*(-32168016-148827168*r**2-237117645*r**4-12204932*r**6+704162158*r**8
            +1681647443*r**10+2181200837*r**12+1725615324*r**14+818994438*r**16+188841105*r**18)
            -30*Q2**7*(-9906048-55028736*r**2-115911930*r**4-130389355*r**6-12143414*r**8
            +271751149*r**10+586407002*r**12+705776211*r**14+522173070*r**16+230285691*r**18
            +51776280*r**20)-6*(-1+r**2)**6*(-794832-2756800*r**2-5830925*r**4-30234597*r**6
            -36357630*r**8+66696782*r**10+95015170*r**12+9013530*r**14-4149318*r**16
            +8570870*r**18+4412575*r**20+1005255*r**22)+2*Q2**6*(-7950528-303754464*r**2
            -940032051*r**4-1548063842*r**6-1422478845*r**8-1385276263*r**10+403285141*r**12
            +3634979049*r**14+4719848813*r**16+3366894615*r**18+1288506510*r**20
            +276399945*r**22)+3*Q2*(-1+r**2)**4*(-14141184-45964608*r**2-92452361*r**4
            -486402973*r**6-778438734*r**8+496549284*r**10+1735949798*r**12+1382326046*r**14
            +114687488*r**16-37321876*r**18+139832275*r**20+76359855*r**22+19178910*r**24)
            +2*Q2**5*(-171415872-383658048*r**2-351938355*r**4-1248541192*r**6-2788941478*r**8
            +1629439958*r**10+6706375452*r**12+5613684790*r**14+970498618*r**16+294427162*r**18
            +704456295*r**20+679817250*r**22+211487580*r**24)-10*Q2**2*(-1+r**2)**2*(
            -16600464-44471904*r**2-73226597*r**4-444063287*r**6-735183070*r**8
            +252873468*r**10+1086123088*r**12+1489904708*r**14+1230679338*r**16+110648470*r**18
            -65063395*r**20+117056987*r**22+79368252*r**24+24148710*r**26)-30*Q2**4*(
            -16344960-39151776*r**2-47447205*r**4-229651854*r**6-439008686*r**8
            +56183591*r**10+526443482*r**12+776086796*r**14+653452444*r**16+86147714*r**18
            +20743067*r**20+100982610*r**22+78703554*r**24+25944615*r**26)+10*Q2**3*(
            -36883008-64445568*r**2-58471047*r**4-648571546*r**6-806839767*r**8
            +1038216778*r**10+923741984*r**12+424622376*r**14+1078397266*r**16+1894446080*r**18
            +227888217*r**20-246182654*r**22+101306709*r**24+131903142*r**26+57130110*r**28))*sqrtq2)
            +logq2**6*(-59719680000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-10080*Q2**15*(96+96*r**2+1255*r**4+1255*r**6)+180*Q2**14*(119584
            +306752*r**2+1488045*r**4+2759754*r**6+1458877*r**8)-30*Q2**13*(5624448
            +22453376*r**2+83096735*r**4+192343306*r**6+199619767*r**8+73544268*r**10)
            +4*Q2**12*(174646944+947752704*r**2+3341306057*r**4+8366760486*r**6+12139412950*r**8
            +8933331006*r**10+2584324197*r**12)-2*Q2**11*(902722176+6188510592*r**2
            +22698389999*r**4+58095421232*r**6+100694827984*r**8+107233345864*r**10
            +62283732597*r**12+15062395068*r**14)+2*Q2**10*(1624734288+12993823632*r**2
            +50643861541*r**4+131411958997*r**6+245532371490*r**8+321890251994*r**10
            +274234595255*r**12+133631261709*r**14+27826501374*r**16)-5*Q2**9*(932610240
            +7458084096*r**2+29919051653*r**4+78230495814*r**6+147811192771*r**8
            +208591277720*r**10+219290146167*r**12+159398339326*r**14+67596838761*r**16
            +11871642636*r**18)+10*Q2**8*(627006096+4004569392*r**2+15478229798*r**4
            +39207633455*r**6+64557052702*r**8+74298026271*r**10+72661974176*r**12
            +67560726193*r**14+48039566098*r**16+17685318081*r**18+1588141674*r**20)
            +2*Q2**7*(-3942470016-19110685056*r**2-75395112863*r**4-193563669974*r**6
            -211363442265*r**8+97646557200*r**10+564455885691*r**12+711250446522*r**14
            +458589545621*r**16+182938055060*r**18+72693339936*r**20+25877042352*r**22)
            -2*Q2**6*(-3655422432-17384175264*r**2-87622340863*r**4-269986399284*r**6
            -358868906288*r**8+19083036560*r**10+955164670272*r**12+1864911840076*r**14
            +1854690127766*r**16+1108881452712*r**18+461727540007*r**20+161756167296*r**22
            +40607662914*r**24)+2*Q2**5*(-1460005056-11475273984*r**2-72349912127*r**4
            -251892586034*r**6-484836611050*r**8-576081694074*r**10-168018176744*r**12
            +808818637130*r**14+1651669093518*r**16+1564250056210*r**18+856341407447*r**20
            +333829858040*r**22+110103909612*r**24+24000708312*r**26)+18*(-1+r**2)**4*(
            -6728688-39186064*r**2-522533349*r**4-1260781411*r**6-1771526703*r**8
            -4640957781*r**10+1794176788*r**12+15325338750*r**14+7461716186*r**16
            -721743678*r**18+2777005659*r**20+2724343141*r**22+692051589*r**24+116804515*r**26
            +35937846*r**28)+10*Q2**4*(-242360352+450577632*r**2+193798109*r**4+1708288232*r**6
            +31567221957*r**8+85546756572*r**10+89984935980*r**12+45786057120*r**14
            +1842573654*r**16-33749845512*r**18-35432321007*r**20-14171838056*r**22
            -8220314267*r**24-3460458324*r**26+328567302*r**28)-9*Q2*(-1+r**2)**2*(
            -101562432-406238848*r**2-5989296497*r**4-15192510400*r**6-19675072976*r**8
            -63845569196*r**10-46442544477*r**12+154441062412*r**14+228253151904*r**16
            +59901669592*r**18-12177084531*r**20+32188964520*r**22+30496631280*r**24
            +8052300116*r**26+1347112129*r**28+571656204*r**30)-30*Q2**3*(-145303296
            -212003072*r**2-4118058434*r**4-12142159418*r**6-10277920033*r**8-17227628836*r**10
            -28412093907*r**12+11263770008*r**14+35643584842*r**16+11492789424*r**18
            +15955592500*r**20+33174192534*r**22+23891874743*r**24+6597810420*r**26
            +1219356545*r**28+810261900*r**30)+6*Q2**2*(-472630224-934499984*r**2
            -19605732942*r**4-41651307191*r**6-26043983810*r**8-153408578058*r**10
            -209989644494*r**12+197169149379*r**14+594096005682*r**16+547446110580*r**18
            +89165963198*r**20-95761346865*r**22+54687366938*r**24+87702386534*r**26
            +25839218430*r**28+3271579109*r**30+2757950118*r**32))+59719680000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(10080*Q2**15*(96+96*r**2+1255*r**4
            +1255*r**6)-180*Q2**14*(119584+306752*r**2+1488045*r**4+2759754*r**6
            +1458877*r**8)+30*Q2**13*(5624448+22453376*r**2+83096735*r**4+192343306*r**6
            +199619767*r**8+73544268*r**10)-4*Q2**12*(174646944+947752704*r**2+3341306057*r**4
            +8366760486*r**6+12139412950*r**8+8933331006*r**10+2584324197*r**12)
            +2*Q2**11*(902722176+6188510592*r**2+22698389999*r**4+58095421232*r**6
            +100694827984*r**8+107233345864*r**10+62283732597*r**12+15062395068*r**14)
            -2*Q2**10*(1624734288+12993823632*r**2+50643861541*r**4+131411958997*r**6
            +245532371490*r**8+321890251994*r**10+274234595255*r**12+133631261709*r**14
            +27826501374*r**16)+5*Q2**9*(932610240+7458084096*r**2+29919051653*r**4
            +78230495814*r**6+147811192771*r**8+208591277720*r**10+219290146167*r**12
            +159398339326*r**14+67596838761*r**16+11871642636*r**18)-10*Q2**8*(627006096
            +4004569392*r**2+15478229798*r**4+39207633455*r**6+64557052702*r**8+74298026271*r**10
            +72661974176*r**12+67560726193*r**14+48039566098*r**16+17685318081*r**18
            +1588141674*r**20)-2*Q2**7*(-3942470016-19110685056*r**2-75395112863*r**4
            -193563669974*r**6-211363442265*r**8+97646557200*r**10+564455885691*r**12
            +711250446522*r**14+458589545621*r**16+182938055060*r**18+72693339936*r**20
            +25877042352*r**22)+2*Q2**6*(-3655422432-17384175264*r**2-87622340863*r**4
            -269986399284*r**6-358868906288*r**8+19083036560*r**10+955164670272*r**12
            +1864911840076*r**14+1854690127766*r**16+1108881452712*r**18+461727540007*r**20
            +161756167296*r**22+40607662914*r**24)-2*Q2**5*(-1460005056-11475273984*r**2
            -72349912127*r**4-251892586034*r**6-484836611050*r**8-576081694074*r**10
            -168018176744*r**12+808818637130*r**14+1651669093518*r**16+1564250056210*r**18
            +856341407447*r**20+333829858040*r**22+110103909612*r**24+24000708312*r**26)
            -18*(-1+r**2)**4*(-6728688-39186064*r**2-522533349*r**4-1260781411*r**6
            -1771526703*r**8-4640957781*r**10+1794176788*r**12+15325338750*r**14
            +7461716186*r**16-721743678*r**18+2777005659*r**20+2724343141*r**22+692051589*r**24
            +116804515*r**26+35937846*r**28)-10*Q2**4*(-242360352+450577632*r**2
            +193798109*r**4+1708288232*r**6+31567221957*r**8+85546756572*r**10+89984935980*r**12
            +45786057120*r**14+1842573654*r**16-33749845512*r**18-35432321007*r**20
            -14171838056*r**22-8220314267*r**24-3460458324*r**26+328567302*r**28)
            +9*Q2*(-1+r**2)**2*(-101562432-406238848*r**2-5989296497*r**4-15192510400*r**6
            -19675072976*r**8-63845569196*r**10-46442544477*r**12+154441062412*r**14
            +228253151904*r**16+59901669592*r**18-12177084531*r**20+32188964520*r**22
            +30496631280*r**24+8052300116*r**26+1347112129*r**28+571656204*r**30)
            +30*Q2**3*(-145303296-212003072*r**2-4118058434*r**4-12142159418*r**6
            -10277920033*r**8-17227628836*r**10-28412093907*r**12+11263770008*r**14
            +35643584842*r**16+11492789424*r**18+15955592500*r**20+33174192534*r**22
            +23891874743*r**24+6597810420*r**26+1219356545*r**28+810261900*r**30)
            -6*Q2**2*(-472630224-934499984*r**2-19605732942*r**4-41651307191*r**6
            -26043983810*r**8-153408578058*r**10-209989644494*r**12+197169149379*r**14
            +594096005682*r**16+547446110580*r**18+89165963198*r**20-95761346865*r**22
            +54687366938*r**24+87702386534*r**26+25839218430*r**28+3271579109*r**30
            +2757950118*r**32))*sqrtq2)+logq2**5*(-995328000*r**20*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(13440*Q2**19*(96+1255*r**4)-480*Q2**18*(181088+214880*r**2
            +1557399*r**4+1636399*r**6)+10*Q2**17*(110739744+266572352*r**2+951942069*r**4
            +1772283802*r**6+982671237*r**8)-2*Q2**16*(3452504352+12367139680*r**2
            +35407485989*r**4+77111706191*r**6+81926308847*r**8+31401481605*r**10)
            +4*Q2**15*(6548561376+30796723296*r**2+87132180542*r**4+195251073610*r**6
            +279920970229*r**8+208674902916*r**10+61157103195*r**12)-2*Q2**14*(32883840000
            +189324465856*r**2+575595027205*r**4+1322263924522*r**6+2193186772588*r**8
            +2297968583986*r**10+1316300604815*r**12+306922688100*r**14)+2*Q2**13*(56469521040
            +378738799984*r**2+1261935711089*r**4+3030585779228*r**6+5431626165525*r**8
            +6866658087956*r**10+5670800410909*r**12+2628035353820*r**14+481656856905*r**16)
            -Q2**12*(132983940960+994209283392*r**2+3542637894051*r**4+8689173501526*r**6
            +15694465891033*r**8+21063607263464*r**10+21486300489957*r**12+15418387029762*r**14
            +6056689836135*r**16+731757557160*r**18)+Q2**11*(103235965632+828551628288*r**2
            +2820830833797*r**4+5433213307925*r**6+5623680303125*r**8+29061825145*r**10
            -5864914858617*r**12-2147515948629*r**14+3499443206379*r**16+1702927938087*r**18
            -404057901420*r**20)+Q2**10*(-40369678272-390799654464*r**2-488677007859*r**4
            +5222598720236*r**6+26978587909396*r**8+70571474315552*r**10+119156598126098*r**12
            +127861207844792*r**14+80660492928204*r**16+27751375536480*r**18+6466155753153*r**20
            +1700180920860*r**22)-Q2**9*(24853545120-39558486624*r**2+1678448765295*r**4
            +16037801232607*r**6+63146226860818*r**8+155624854537036*r**10+270267797109026*r**12
            +336760235444030*r**14+290986419163772*r**16+160670052051108*r**18+52493566514751*r**20
            +11205645953715*r**22+1798041732450*r**24)+2*Q2**8*(36957325680+71491557632*r**2
            +1479447615117*r**4+9594272184614*r**6+35818234868965*r**8+88054528047918*r**10
            +150942561161094*r**12+194144388402382*r**14+192826157668554*r**16+139255952137290*r**18
            +64898858789093*r**20+18236495570532*r**22+3734112743065*r**24+227711178720*r**26)
            +2*Q2**7*(-43834483200-150342231488*r**2-2081816345059*r**4-8614871477319*r**6
            -29028384727937*r**8-65863785696371*r**10-82447753412686*r**12-55375695339792*r**14
            -23128473867644*r**16-14577256902112*r**18-4453371254401*r**20+9252670955447*r**22
            +6461776801277*r**24+309589488755*r**26+472802927730*r**28)-4*Q2**6*(
            -13768204512-100358626176*r**2-1174301039140*r**4-3881757436459*r**6
            -13527187761418*r**8-30824311201809*r**10-26998096173657*r**12+24693236295894*r**14
            +101780968085592*r**16+135053470859286*r**18+102129362044482*r**20+59447951363689*r**22
            +32398841551042*r**24+11442567251803*r**26+1287576476523*r**28+288526547820*r**30)
            +2*Q2**5*(-2179952784-151217444912*r**2-1397300915498*r**4-5695272033031*r**6
            -23553526585105*r**8-63057812621296*r**10-97459727964374*r**12-70311500923593*r**14
            +63726927688005*r**16+235323996757824*r**18+292300526830754*r**20+204184901300951*r**22
            +105345963536161*r**24+50942216294656*r**26+16913832908446*r**28+2005126922201*r**30
            +230834681595*r**32)+18*(-1+r**2)**4*(-4509648-315160864*r**2-4876976859*r**4
            -11424338817*r**6-138486461461*r**8-310652580547*r**10+8962326115*r**12
            +341157126173*r**14+661736605229*r**16+602883365647*r**18+128042354443*r**20
            +497818037897*r**22+602246971621*r**24+189697177963*r**26+43802766189*r**28
            +23185617627*r**30+1752086227*r**32+145609065*r**34)+Q2**4*(-22164777120
            +69480753088*r**2-561646686295*r**4+3856795105426*r**6+9440939611819*r**8
            +27480067740328*r**10+111613957433309*r**12+186658779259450*r**14+138637935689583*r**16
            +38022416944272*r**18-38691875613541*r**20-71117023266842*r**22-63118662154255*r**24
            -47026467704584*r**26-20655365171041*r**28-3071185958642*r**30-1032595226155*r**32
            +125955205200*r**34)-9*Q2*(-1+r**2)**2*(-142410336-4158153824*r**2-66335551431*r**4
            -105012352407*r**6-1594194793991*r**8-3800332769171*r**10-1809288996459*r**12
            -993764441259*r**14+5587845055069*r**16+18084426408777*r**18+11721348380995*r**20
            +282619009435*r**22+5128499459931*r**24+6924137803303*r**26+2012825540439*r**28
            +440054456487*r**30+335222107823*r**32+23988617859*r**34+2982884760*r**36)
            -3*Q2**3*(-6175905600-28318893056*r**2-751313321811*r**4-223442460187*r**6
            -9498315525915*r**8-25447572492919*r**10-15832582612379*r**12-22849457434903*r**14
            -31607177879351*r**16+1530807052605*r**18+9154856567483*r**20+20110617419391*r**22
            +61924372010239*r**24+52081670145003*r**26+11949772952935*r**28+3618007045811*r**30
            +3908308905619*r**32+158491415375*r**34+76691283660*r**36)+3*Q2**2*(-2344407360
            -29397512384*r**2-539427669857*r**4-170631673052*r**6-10200546776996*r**8
            -19745821011728*r**10-3573057200336*r**12-24189709037360*r**14-12547979608436*r**16
            +91140617636032*r**18+141678719192246*r**20+57256452305864*r**22-30637668192364*r**24
            +9246051606128*r**26+40345369576904*r**28+10816930473392*r**30+1115162729156*r**32
            +2862632452256*r**34+161276442035*r**36+37692211860*r**38))+995328000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(13440*Q2**20*(96+1255*r**4)-480*Q2**19*(183776
            +217568*r**2+1592539*r**4+1671539*r**6)+10*Q2**18*(119431968+285578816*r**2
            +1037011461*r**4+1925586106*r**6+1061218389*r**8)-4*Q2**17*(2003101536
            +7126850080*r**2+20750029047*r**4+45366417773*r**6+47850542021*r**8+18157418895*r**10)
            +2*Q2**16*(16549627104+77413090624*r**2+222038986753*r**4+503021339400*r**6
            +718879955496*r**8+530677596284*r**10+153715687995*r**12)-2*Q2**15*(45980962752
            +264015035200*r**2+811452834881*r**4+1887030432826*r**6+3143530860266*r**8
            +3275160330276*r**10+1855964617037*r**12+429236894490*r**14)+10*Q2**14*(17870672208
            +120189421168*r**2+405371040830*r**4+985688946191*r**6+1789415372527*r**8
            +2271562688906*r**10+1857013919942*r**12+850251729347*r**14+157715909001*r**16)
            -Q2**13*(245922983040+1864625925440*r**2+6823986916197*r**4+17274216482160*r**6
            +32618889780539*r**8+45660175770426*r**10+46561217487687*r**12+32016058559220*r**14
            +12276074257585*r**16+1695071270970*r**18)+2*Q2**12*(118109953296+977872426320*r**2
            +3678839005620*r**4+8832512351751*r**6+15003659847842*r**8+18393567489821*r**10
            +18342496447402*r**12+17378585785545*r**14+12487260036138*r**16+4245687665691*r**18
            +163849827870*r**20)+2*Q2**11*(-71802821952-661293624192*r**2-2069029734972*r**4
            -1515722710743*r**6+7960847149173*r**8+32459366093641*r**10+62496225579785*r**12
            +67936819326019*r**14+39654282835227*r**16+11274502196007*r**18+2583642858243*r**20
            +1052119411140*r**22)-2*Q2**10*(-7758066576-235363909680*r**2+399486051486*r**4
            +10385861472492*r**6+47673706745225*r**8+126587458380992*r**10+229997934775338*r**12
            +291889020707460*r**14+249754059968384*r**16+134540960257896*r**18+43355548902192*r**20
            +9685991313864*r**22+1749111326655*r**24)+5*Q2**9*(19753639296+25655634752*r**2
            +919557101781*r**4+7380958873426*r**6+30164099566271*r**8+78976027498738*r**10
            +145555554793650*r**12+199063361871564*r**14+202679793988982*r**16+146033675097892*r**18
            +68592267228809*r**20+20034440721906*r**22+4094382634459*r**24+450692817978*r**26)
            +4*Q2**8*(-40395904440-129395557400*r**2-1816377758904*r**4-9844295638525*r**6
            -37220445890758*r**8-94868274306627*r**10-160722421310849*r**12-200231322451634*r**14
            -205049509969290*r**16-173329683353978*r**18-104304091090392*r**20-36941341702089*r**22
            -7754415756160*r**24-1826117216515*r**26+122545874505*r**28)-2*Q2**7*(
            -71370892224-394893967040*r**2-4580760654827*r**4-18460202695296*r**6
            -64697631728092*r**8-156540792827926*r**10-202307731456371*r**12-88436976160690*r**14
            +125057766963748*r**16+232401210948816*r**18+185228095932451*r**20+123695202428424*r**22
            +80512130858808*r**24+29656500793638*r**26+3357545369531*r**28+1049856023370*r**30)
            +2*Q2**6*(-29716361808-379471106288*r**2-3946620246130*r**4-15807388984229*r**6
            -58371416980859*r**8-151760810547750*r**10-213104542715306*r**12-74921220679119*r**14
            +316675336450977*r**16+708992874647580*r**18+766666192638290*r**20+527339528117293*r**22
            +289039549365623*r**24+138625033900346*r**26+42374120365098*r**28+5157332970887*r**30
            +807887777235*r**32)-Q2**5*(17804871552-376275548480*r**2-2535390034525*r**4
            -18041941002484*r**6-67938536848091*r**8-200702746153130*r**10-432649038604649*r**12
            -522201237035384*r**14-151807082160759*r**16+560079431947386*r**18+1093940922790697*r**20
            +1064087879530252*r**22+682180391828479*r**24+359602827366218*r**26+156367463577245*r**28
            +40909105619936*r**30+5504518433747*r**32+335714157990*r**34)-18*(-1
            +r**2)**4*(-4509648-319670512*r**2-5192137723*r**4-16301315676*r**6-149910800278*r**8
            -449139042008*r**10-301690254432*r**12+350119452288*r**14+1002893731402*r**16
            +1264619970876*r**18+730925720090*r**20+625860392340*r**22+1100065009518*r**24
            +791944149584*r**26+233499944152*r**28+66988383816*r**30+24937703854*r**32
            +1897695292*r**34+145609065*r**36)-10*Q2**4*(-4069249392-3764070320*r**2
            -274610589864*r**4+262482103857*r**6-1519721186050*r**8-3942171012661*r**10
            +9159627733650*r**12+22972436438805*r**14+23047518131098*r**16+18125277379167*r**18
            +2679511103318*r**20-4947704662221*r**22+5153743060962*r**24+4609988057617*r**26
            -3183251401682*r**28-1287252999225*r**30+762114553206*r**32-43116577483*r**34
            +35602905618*r**36)+9*Q2*(-1+r**2)**2*(-151429632-4912847296*r**2-78996034813*r**4
            -175318995764*r**6-1940236667770*r**8-5484735556046*r**10-4626059714134*r**12
            -2777893650926*r**14+4570849971806*r**16+22913406026570*r**18+28973799246528*r**20
            +13693200779746*r**22+4880424969906*r**24+11018679808470*r**26+9470274107510*r**28
            +2703434523350*r**30+773643798634*r**32+398864834158*r**34+29893238813*r**36
            +3274102890*r**38)+6*Q2**3*(-4260156480-31946155520*r**2-659529942362*r**4
            -572693727525*r**6-9961152381549*r**8-27345854515281*r**10-22426606152817*r**12
            -31435874542321*r**14-33502307461345*r**16+30532123404643*r**18+76182191406167*r**20
            +43260963146369*r**22+25698660618633*r**24+61626046880685*r**26+52188406337421*r**28
            +13192355236069*r**30+4320739340293*r**32+3464716386625*r**34+198229570535*r**36
            +57191747760*r**38)-6*Q2**2*(-1385819184-21680959600*r**2-371655072299*r**4
            -319778776508*r**6-7361347685936*r**8-16048617194756*r**10-5363666484194*r**12
            -15644661945116*r**14-9719716911206*r**16+48168776799868*r**18+88120179341904*r**20
            +91854108733388*r**22+37736306789834*r**24-15271171453804*r**26+14735284682162*r**28
            +30588961793516*r**30+8167954704206*r**32+1679295878756*r**34+1947296082443*r**36
            +126518599456*r**38+23320433070*r**40))*sqrtq2)+logq2**4*(16588800*r**16*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-7680*Q2**22*(13216
            +97357*r**4)+960*Q2**21*(2226144+2616800*r**2+13979553*r**4+15999219*r**6)
            -24*Q2**20*(798482976+1819108416*r**2+5338278089*r**4+9982312510*r**6
            +5785686741*r**8)+10*Q2**19*(9871492608+32918713344*r**2+83158389643*r**4
            +175879740374*r**6+188461394379*r**8+72719243520*r**10)-20*Q2**18*(16269196032
            +71427494400*r**2+185518448943*r**4+405960010383*r**6+578017575569*r**8
            +427109300193*r**10+120683140272*r**12)+20*Q2**17*(35649936000+197058933888*r**2
            +559956454260*r**4+1263368405586*r**6+2087853965161*r**8+2168755265936*r**10
            +1210558392969*r**12+255398810436*r**14)-5*Q2**16*(204602051808+1424282913504*r**2
            +4447908664777*r**4+10325182840059*r**6+18281687786382*r**8+22834491951414*r**10
            +18834717129449*r**12+8459631633879*r**14+1218999979464*r**16)+Q2**15*(845931315456
            +8137646666496*r**2+26034633162489*r**4+56130258373530*r**6+91763614948771*r**8
            +105904783742436*r**10+104303852912571*r**12+87817675607794*r**14+36100723757025*r**16
            +870959885256*r**18)+10*Q2**14*(-9877261824-464532932352*r**2-699262774278*r**4
            +2355137406489*r**6+12457510087534*r**8+32989563342161*r**10+48973310699862*r**12
            +36480775954363*r**14+11281124681258*r**16+1890506064603*r**18+1016230964760*r**20)
            -5*Q2**13*(140468257536+323003416320*r**2+6872832490699*r**4+42236613685048*r**6
            +136230772482186*r**8+309208009544740*r**10+493659813943544*r**12+511213782733416*r**14
            +310852018959902*r**16+99645476140292*r**18+19270653316389*r**20+3371049842376*r**22)
            +20*Q2**12*(48340561824+305420763936*r**2+3532833908640*r**4+19861275864699*r**6
            +65713065446901*r**8+153365170404990*r**10+263361165926703*r**12+324378225702424*r**14
            +268820456374347*r**16+133676729557110*r**18+35160992790141*r**20+5976777915753*r**22
            +448346015460*r**24)+5*Q2**11*(-130099209984-1306795385088*r**2-14510591055459*r**4
            -81318452924442*r**6-274636946178159*r**8-624998403584484*r**10-1052083325860122*r**12
            -1356792512221904*r**14-1362249357577978*r**16-976481226491028*r**18-385332627496947*r**20
            -57451178365158*r**22-9433461721479*r**24+1578407175144*r**26)-2*Q2**10*(
            -58989305088-2126961796608*r**2-20615429604922*r**4-116589518797175*r**6
            -323434421814468*r**8-281823517535457*r**10+550438901320348*r**12+2199727627817142*r**14
            +3411840037174760*r**16+2717099777839818*r**18+1208261635525062*r**20
            +585579960203297*r**22+289022260370908*r**24+30707311630455*r**26+8033513947032*r**28)
            +5*Q2**9*(58791253248-274473843456*r**2-263467225551*r**4-13118338843620*r**6
            +33782833781960*r**8+547769507316852*r**10+2091960818219265*r**12+4664052628966000*r**14
            +7044955875116712*r**16+7319949742323672*r**18+5054556965194963*r**20
            +2312740842133308*r**22+804270858017520*r**24+208858923539924*r**26+21432795534939*r**28
            +1720592769240*r**30)+10*Q2**8*(-39796810272-104289307680*r**2-2851393840833*r**4
            -131253675639*r**6-53548341058730*r**8-398310301204066*r**10-1435001645514519*r**12
            -3240722858152585*r**14-5100208854986540*r**16-5901181294000452*r**18
            -4928561610386719*r**20-2840858672747945*r**22-1158338772612546*r**24
            -361760458008170*r**26-59408236882969*r**28-6341007276903*r**30+297632886408*r**32)
            +5*Q2**7*(41728902912+468601318656*r**2+8071308478063*r**4+12505352136846*r**6
            +158104978619505*r**8+684837047524044*r**10+2223456446394835*r**12+4630675530116322*r**14
            +6220117804645677*r**16+6447457880709552*r**18+5664594090533085*r**20
            +3416546411968226*r**22+897366911840739*r**24+140045992839372*r**26+125611069725153*r**28
            -46193743876306*r**30-1565851688577*r**32-1301103599304*r**34)+10*Q2**6*(3010636800
            -210699737856*r**2-3078821033130*r**4-15103716550953*r**6-104315575870978*r**8
            -281064544097373*r**10-808605164715834*r**12-1421691060568085*r**14-689083741398786*r**16
            +1606224396719367*r**18+3443326208322906*r**20+3310143439547541*r**22
            +2524180666016202*r**24+1941932206666873*r**26+896762370804066*r**28+161826905214057*r**30
            +57088835143994*r**32+3994626037533*r**34+301885961256*r**36)+Q2**5*(
            -103719585024+842721206016*r**2+8970008477739*r**4+160071615737520*r**6
            +738388736155526*r**8+2015283208810324*r**10+7130407210782714*r**12+16229326928602816*r**14
            +17733217549265510*r**16-367720262735076*r**18-33148520208417336*r**20
            -54088067855286216*r**22-46486050768942174*r**24-29329820581201460*r**26
            -18091695421074346*r**28-7986681334478064*r**30-1587607845315214*r**32
            -323366292528956*r**34-26997217353795*r**36+341255879496*r**38)+9*(-1
            +r**2)**4*(-62676576+737653280*r**2+15406001847*r**4+355005450289*r**6
            +1820241321484*r**8+1278882237624*r**10+51150133982280*r**12+67805429157964*r**14
            -172094564554172*r**16-180150717793512*r**18+118657908985374*r**20+92854702869750*r**22
            -143392118493844*r**24-164277603481048*r**26-44544968191728*r**28-12255182778516*r**30
            -10897936675060*r**32-1439963757592*r**34-222088641069*r**36-14028369119*r**38
            +285352344*r**40)-20*Q2**4*(-2325379296-12381166368*r**2-327527688424*r**4
            +3156108859139*r**6-1737133148691*r**8+41157143737766*r**10+132928776720401*r**12
            +367031783503386*r**14+814321267472519*r**16+949147936251074*r**18+531124143780681*r**20
            -53744662415588*r**22-336639181401095*r**24-409490131525830*r**26-418627989932165*r**28
            -221479924482626*r**30-63237435267195*r**32-27374022637442*r**34+169660374547*r**36
            -199486570743*r**38+46616755950*r**40)-45*Q2*(-1+r**2)**2*(-101135616
            +1572294912*r**2+26109313085*r**4+436698908982*r**6+2492356043071*r**8
            +504431028604*r**10+56659232557936*r**12+98639090212972*r**14-85101845844264*r**16
            -178998663362876*r**18-102496892153214*r**20-36608302743048*r**22-1254805934274*r**24
            -132864372143668*r**26-180162725976136*r**28-47351826692620*r**30-9378257340160*r**32
            -14958648541908*r**34-1739306739175*r**36-379064897934*r**38-25731507029*r**40
            +250812360*r**42)+15*Q2**3*(399764736-34515114240*r**2-563711472621*r**4
            -1821240275814*r**6-29640972145301*r**8+16379629837868*r**10-242194400632440*r**12
            -602772975018788*r**14-335246835824824*r**16-491351248728876*r**18-616546023596330*r**20
            -250934435688304*r**22+160640481355974*r**24+1181724657307580*r**26+1292439969439600*r**28
            +223617293885412*r**30+59965921987568*r**32+157284893984860*r**34+4679782525983*r**36
            +6807242452502*r**38+365136761239*r**40+24910794216*r**42)-30*Q2**2*(427107072
            -9755947008*r**2-138014001844*r**4-1370198520769*r**6-9888007599062*r**8
            +9026343862453*r**10-172599278480352*r**12-257233049977056*r**14+152518499134672*r**16
            +85856165354776*r**18+200968715805824*r**20+826505113939734*r**22+580897741802932*r**24
            -233783402895862*r**26+18693958226984*r**28+521479628924280*r**30+125774259246720*r**32
            -15745988841520*r**34+60298326284084*r**36+4351352721427*r**38+1944289697746*r**40
            +133995400281*r**42+1290274488*r**44))-16588800*r**16*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(7680*Q2**22*(13216+97357*r**4)-960*Q2**21*(2226144
            +2616800*r**2+13979553*r**4+15999219*r**6)+24*Q2**20*(798482976+1819108416*r**2
            +5338278089*r**4+9982312510*r**6+5785686741*r**8)-10*Q2**19*(9871492608
            +32918713344*r**2+83158389643*r**4+175879740374*r**6+188461394379*r**8
            +72719243520*r**10)+20*Q2**18*(16269196032+71427494400*r**2+185518448943*r**4
            +405960010383*r**6+578017575569*r**8+427109300193*r**10+120683140272*r**12)
            -20*Q2**17*(35649936000+197058933888*r**2+559956454260*r**4+1263368405586*r**6
            +2087853965161*r**8+2168755265936*r**10+1210558392969*r**12+255398810436*r**14)
            +5*Q2**16*(204602051808+1424282913504*r**2+4447908664777*r**4+10325182840059*r**6
            +18281687786382*r**8+22834491951414*r**10+18834717129449*r**12+8459631633879*r**14
            +1218999979464*r**16)-Q2**15*(845931315456+8137646666496*r**2+26034633162489*r**4
            +56130258373530*r**6+91763614948771*r**8+105904783742436*r**10+104303852912571*r**12
            +87817675607794*r**14+36100723757025*r**16+870959885256*r**18)-10*Q2**14*(
            -9877261824-464532932352*r**2-699262774278*r**4+2355137406489*r**6+12457510087534*r**8
            +32989563342161*r**10+48973310699862*r**12+36480775954363*r**14+11281124681258*r**16
            +1890506064603*r**18+1016230964760*r**20)+5*Q2**13*(140468257536+323003416320*r**2
            +6872832490699*r**4+42236613685048*r**6+136230772482186*r**8+309208009544740*r**10
            +493659813943544*r**12+511213782733416*r**14+310852018959902*r**16+99645476140292*r**18
            +19270653316389*r**20+3371049842376*r**22)-20*Q2**12*(48340561824+305420763936*r**2
            +3532833908640*r**4+19861275864699*r**6+65713065446901*r**8+153365170404990*r**10
            +263361165926703*r**12+324378225702424*r**14+268820456374347*r**16+133676729557110*r**18
            +35160992790141*r**20+5976777915753*r**22+448346015460*r**24)+5*Q2**11*(130099209984
            +1306795385088*r**2+14510591055459*r**4+81318452924442*r**6+274636946178159*r**8
            +624998403584484*r**10+1052083325860122*r**12+1356792512221904*r**14+1362249357577978*r**16
            +976481226491028*r**18+385332627496947*r**20+57451178365158*r**22+9433461721479*r**24
            -1578407175144*r**26)+2*Q2**10*(-58989305088-2126961796608*r**2-20615429604922*r**4
            -116589518797175*r**6-323434421814468*r**8-281823517535457*r**10+550438901320348*r**12
            +2199727627817142*r**14+3411840037174760*r**16+2717099777839818*r**18
            +1208261635525062*r**20+585579960203297*r**22+289022260370908*r**24+30707311630455*r**26
            +8033513947032*r**28)-5*Q2**9*(58791253248-274473843456*r**2-263467225551*r**4
            -13118338843620*r**6+33782833781960*r**8+547769507316852*r**10+2091960818219265*r**12
            +4664052628966000*r**14+7044955875116712*r**16+7319949742323672*r**18
            +5054556965194963*r**20+2312740842133308*r**22+804270858017520*r**24+208858923539924*r**26
            +21432795534939*r**28+1720592769240*r**30)+10*Q2**8*(39796810272+104289307680*r**2
            +2851393840833*r**4+131253675639*r**6+53548341058730*r**8+398310301204066*r**10
            +1435001645514519*r**12+3240722858152585*r**14+5100208854986540*r**16
            +5901181294000452*r**18+4928561610386719*r**20+2840858672747945*r**22
            +1158338772612546*r**24+361760458008170*r**26+59408236882969*r**28+6341007276903*r**30
            -297632886408*r**32)+5*Q2**7*(-41728902912-468601318656*r**2-8071308478063*r**4
            -12505352136846*r**6-158104978619505*r**8-684837047524044*r**10-2223456446394835*r**12
            -4630675530116322*r**14-6220117804645677*r**16-6447457880709552*r**18
            -5664594090533085*r**20-3416546411968226*r**22-897366911840739*r**24-140045992839372*r**26
            -125611069725153*r**28+46193743876306*r**30+1565851688577*r**32+1301103599304*r**34)
            -10*Q2**6*(3010636800-210699737856*r**2-3078821033130*r**4-15103716550953*r**6
            -104315575870978*r**8-281064544097373*r**10-808605164715834*r**12-1421691060568085*r**14
            -689083741398786*r**16+1606224396719367*r**18+3443326208322906*r**20+3310143439547541*r**22
            +2524180666016202*r**24+1941932206666873*r**26+896762370804066*r**28+161826905214057*r**30
            +57088835143994*r**32+3994626037533*r**34+301885961256*r**36)+Q2**5*(103719585024
            -842721206016*r**2-8970008477739*r**4-160071615737520*r**6-738388736155526*r**8
            -2015283208810324*r**10-7130407210782714*r**12-16229326928602816*r**14
            -17733217549265510*r**16+367720262735076*r**18+33148520208417336*r**20
            +54088067855286216*r**22+46486050768942174*r**24+29329820581201460*r**26
            +18091695421074346*r**28+7986681334478064*r**30+1587607845315214*r**32
            +323366292528956*r**34+26997217353795*r**36-341255879496*r**38)-9*(-1
            +r**2)**4*(-62676576+737653280*r**2+15406001847*r**4+355005450289*r**6
            +1820241321484*r**8+1278882237624*r**10+51150133982280*r**12+67805429157964*r**14
            -172094564554172*r**16-180150717793512*r**18+118657908985374*r**20+92854702869750*r**22
            -143392118493844*r**24-164277603481048*r**26-44544968191728*r**28-12255182778516*r**30
            -10897936675060*r**32-1439963757592*r**34-222088641069*r**36-14028369119*r**38
            +285352344*r**40)+20*Q2**4*(-2325379296-12381166368*r**2-327527688424*r**4
            +3156108859139*r**6-1737133148691*r**8+41157143737766*r**10+132928776720401*r**12
            +367031783503386*r**14+814321267472519*r**16+949147936251074*r**18+531124143780681*r**20
            -53744662415588*r**22-336639181401095*r**24-409490131525830*r**26-418627989932165*r**28
            -221479924482626*r**30-63237435267195*r**32-27374022637442*r**34+169660374547*r**36
            -199486570743*r**38+46616755950*r**40)+45*Q2*(-1+r**2)**2*(-101135616
            +1572294912*r**2+26109313085*r**4+436698908982*r**6+2492356043071*r**8
            +504431028604*r**10+56659232557936*r**12+98639090212972*r**14-85101845844264*r**16
            -178998663362876*r**18-102496892153214*r**20-36608302743048*r**22-1254805934274*r**24
            -132864372143668*r**26-180162725976136*r**28-47351826692620*r**30-9378257340160*r**32
            -14958648541908*r**34-1739306739175*r**36-379064897934*r**38-25731507029*r**40
            +250812360*r**42)-15*Q2**3*(399764736-34515114240*r**2-563711472621*r**4
            -1821240275814*r**6-29640972145301*r**8+16379629837868*r**10-242194400632440*r**12
            -602772975018788*r**14-335246835824824*r**16-491351248728876*r**18-616546023596330*r**20
            -250934435688304*r**22+160640481355974*r**24+1181724657307580*r**26+1292439969439600*r**28
            +223617293885412*r**30+59965921987568*r**32+157284893984860*r**34+4679782525983*r**36
            +6807242452502*r**38+365136761239*r**40+24910794216*r**42)+30*Q2**2*(427107072
            -9755947008*r**2-138014001844*r**4-1370198520769*r**6-9888007599062*r**8
            +9026343862453*r**10-172599278480352*r**12-257233049977056*r**14+152518499134672*r**16
            +85856165354776*r**18+200968715805824*r**20+826505113939734*r**22+580897741802932*r**24
            -233783402895862*r**26+18693958226984*r**28+521479628924280*r**30+125774259246720*r**32
            -15745988841520*r**34+60298326284084*r**36+4351352721427*r**38+1944289697746*r**40
            +133995400281*r**42+1290274488*r**44))*sqrtq2)+logq2**3*(276480*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(-11520*Q2**25*(90656+517973*r**4)+192*Q2**24*(89926752
            +94617184*r**2+456600631*r**4+534092535*r**6)-2*Q2**23*(65037894048+134544147264*r**2
            +365181908745*r**4+684243006514*r**6+396753564105*r**8)+2*Q2**22*(290665278432
            +905479696032*r**2+2110850796969*r**4+4481360164093*r**6+4797627383391*r**8
            +1792697717835*r**10)-2*Q2**21*(839848282848+3599708699328*r**2+8601518808775*r**4
            +18608637937958*r**6+26737895986482*r**8+19542465681294*r**10+5078430211995*r**12)
            +2*Q2**20*(1584377521632+9179479999776*r**2+23982581652542*r**4+52209889539677*r**6
            +85755301163602*r**8+89295694934020*r**10+49269625028496*r**12+8667859229055*r**14)
            -4*Q2**19*(888795546984+7497272468328*r**2+20883742281227*r**4+44837109790615*r**6
            +74400979441215*r**8+88026912082804*r**10+76220119587818*r**12+35728721163627*r**14
            +3016875727170*r**16)+Q2**18*(1112285719584+27122390189952*r**2+56793752735445*r**4
            +56744484631912*r**6-37452798875505*r**8-311281027789426*r**10-339575215134013*r**12
            -20270451220520*r**14+51867763856337*r**16-17720019449910*r**18)+Q2**17*(3343505792544
            +150610379424*r**2+117056752019103*r**4+643389017057651*r**6+1864098541064227*r**8
            +4040718751429839*r**10+5589958218439149*r**12+4142076264775773*r**14
            +1392383811899781*r**16+242134414582497*r**18+55028700316620*r**20)-2*Q2**16*(2917076926608
            +18129764660928*r**2+194477264726985*r**4+982982812217733*r**6+2850931783446022*r**8
            +6221925081666102*r**10+9873674675010478*r**12+10101749857695170*r**14
            +5853762906949038*r**16+1630752007407782*r**18+270669623880549*r**20+26117986870845*r**22)
            +4*Q2**15*(867134670336+12219829104288*r**2+126506733524111*r**4+746318251117356*r**6
            +2312671380436701*r**8+5168681401342776*r**10+8819449072492006*r**12+10790267028303416*r**14
            +8815827326011026*r**16+4049321200247576*r**18+770845443140075*r**20+113262809294508*r**22
            -2508200022735*r**24)+4*Q2**14*(369752141376-6679635506208*r**2-67067013164422*r**4
            -611348562226835*r**6-1917035335263330*r**8-3716829108950421*r**10-5388117219765882*r**12
            -5660968631441898*r**14-5298848361448710*r**16-4285763396920210*r**18
            -1358706645248264*r**20+280482155925637*r**22+30639866914528*r**24+18493514243055*r**26)
            -4*Q2**13*(1017555548544+1546970371872*r**2+39144379032880*r**4-110660445824283*r**6
            +248719214168725*r**8+3949763749586301*r**10+14020169948605963*r**12+30278924403267360*r**14
            +41044952862369528*r**16+32327932809371880*r**18+14630958154985204*r**20
            +5201716271792267*r**22+1619449211545075*r**24+172311500313867*r**26+16133240302065*r**28)
            +4*Q2**12*(646981543296+5637234167136*r**2+99004416217322*r**4+375257179685839*r**6
            +2872647102064638*r**8+14388173308800734*r**10+44020913091530804*r**12
            +93636138544793793*r**14+141606632370670756*r**16+144086710160358012*r**18
            +91185804610655026*r**20+35072735505371081*r**22+9991616366534782*r**24
            +1691620629045654*r**26+161459401476048*r**28-1498938234345*r**30)+8*Q2**11*(38534302728
            -2536260909912*r**2-40332323430905*r**4-283718669299682*r**6-1945407151036348*r**8
            -9173132035533864*r**10-28603277983004428*r**12-62390170089202790*r**14
            -101406350411339493*r**16-121533915110842892*r**18-100677892556281321*r**20
            -50710370348287962*r**22-14517284107442750*r**24-3544138621101172*r**26
            -81360642361978*r**28-6251212644366*r**30+6558514222095*r**32)+2*Q2**10*(
            -804468194208+5431287369216*r**2+55424202831307*r**4+957913512212552*r**6
            +5333250967195857*r**8+23983431451478718*r**10+69092868450952455*r**12
            +119405829657791768*r**14+146899946386880013*r**16+146607885093268238*r**18
            +137856726445995097*r**20+99608534959815960*r**22+13944007366322827*r**24
            -20136666355212678*r**26-3437602286500843*r**28-2669421234896120*r**30
            -219696913112649*r**32-17092220484870*r**34)+2*Q2**9*(493818433632-221177693856*r**2
            +29142806150121*r**4-446374293025535*r**6-1153009194876015*r**8-7953856457517867*r**10
            -1731433180852539*r**12+112897994522575429*r**14+412428754042564445*r**16
            +800987022667477385*r**18+1012814306952565523*r**20+851266094250871691*r**22
            +501712603649391979*r**24+245426408870782055*r**26+90935052389936255*r**28
            +16294336814221487*r**30+2616315928275079*r**32+198513276826971*r**34
            -2882955392640*r**36)+4*Q2**8*(12896540496-1817459544192*r**2-30534195739365*r**4
            -62124259822847*r**6-824472955837930*r**8+1800433435439984*r**10-13486019742989648*r**12
            -114961432248893950*r**14-376123580830332078*r**16-745121614521334100*r**18
            -1024468227392406766*r**20-1002565032053577888*r**22-689035262484380790*r**24
            -355809366399419928*r**26-148379759727870080*r**28-37780669514475114*r**30
            -6956270590791522*r**32-242950848533220*r**34-14550890990397*r**36+4711081471335*r**38)
            +2*Q2**7*(-208536085728+3821725848192*r**2+43885827593619*r**4+437915178216858*r**6
            +2712843110074231*r**8-475612351262672*r**10+40473456208812588*r**12+200130129900945496*r**14
            +602767532782297452*r**16+1147786469238761584*r**18+1541611490726334618*r**20
            +1613567184512468508*r**22+1194392209487082786*r**24+520693409161823312*r**26
            +200141038294753724*r**28+105070102503234072*r**30-1282300646577988*r**32
            +2331986051259024*r**34-950998781464597*r**36-72292904651814*r**38-3884389943265*r**40)
            -2*Q2**6*(-107952079392+1164188320608*r**2+8665363441705*r**4+387910495615263*r**6
            +2743725959336847*r**8+9742490504571281*r**10+58513898146378552*r**12
            +134788302148835380*r**14+334673453260287432*r**16+457438008263204468*r**18
            +105489122636518178*r**20-389906386080582838*r**22-527672939819908050*r**24
            -575475904520797698*r**26-696807347813771792*r**28-411678031470361516*r**30
            -84174420204509392*r**32-48545739119668860*r**34-5659253656248947*r**36
            -840882616479473*r**38-56805893220501*r**40+1171310078745*r**42)+2*Q2**5*(5661912672
            -845594043264*r**2-9418198004173*r**4+154540637200052*r**6+1696380185814672*r**8
            +14286981906430828*r**10+41409745591050725*r**12+81409435913012188*r**14
            +304592101595652988*r**16+558360686913039628*r**18+260106710536668938*r**20
            -621731560307947692*r**22-1407172583502842452*r**24-1387868850228803532*r**26
            -1018281840019688122*r**28-811132513368695948*r**30-450372697125943660*r**32
            -110703563498046268*r**34-34312324817715133*r**36-5295092582851928*r**38
            -214608589677740*r**40-9831636031984*r**42+1564593509205*r**44)+18*(
            -1+r**2)**4*(13583088-814315904*r**2-5947626621*r**4+180124393015*r**6
            +3435915143620*r**8+26155215290408*r**10+49100430339511*r**12+46188275830659*r**14
            +3002812367031640*r**16+43244690065640*r**18-12909002995351602*r**20+203830386337366*r**22
            +13986428193684224*r**24-2329597439208360*r**26-9258410316903890*r**28
            -1485372067064122*r**30-37237168686024*r**32-699681212359816*r**34-102786569614385*r**36
            -24273397667245*r**38-3356032872772*r**40-66062761824*r**42+2083197179*r**44
            +271936215*r**46)-2*Q2**4*(28553440608-846122943264*r**2-6988107578726*r**4
            -31018178428325*r**6+117455185564270*r**8+6746607485149808*r**10-4690124484709264*r**12
            +46788875391958129*r**14+196817223861205160*r**16+405193876237910240*r**18
            +573752569001821228*r**20+543094527420331326*r**22+163630002224290644*r**24
            -212262354907960480*r**26-268191934763956040*r**28-312684759857946062*r**30
            -224397343054677304*r**32-91747063460736896*r**34-47931952651404470*r**36
            -3026207207890345*r**38-1415425348968082*r**40+93442644022256*r**42+9114456961224*r**44
            +373226944365*r**46)-9*Q2*(-1+r**2)**2*(143595744-11073690848*r**2-75420929695*r**4
            +3137020410487*r**6+47498942681490*r**8+312566031625894*r**10+842970434995937*r**12
            -313250360124925*r**14+32761733307942212*r**16+23362292141354520*r**18
            -94691782478332446*r**20-77910529938802498*r**22+52444691072615020*r**24
            +71878638595916692*r**26-46207119235277750*r**28-90988956631329266*r**30
            -14612758127120048*r**32+2047505799447640*r**34-9305496050631843*r**36
            -1056319250686645*r**38-373356326054926*r**40-54337999849418*r**42-1624750099915*r**44
            -14815510673*r**46+6046255260*r**48)-12*Q2**3*(-1849408392+29923694264*r**2
            +173906788925*r**4+13569308073719*r**6+118398779019295*r**8+228356161439588*r**10
            +3995022022630814*r**12-6005792352949105*r**14+24066535106617924*r**16
            +59220483323044760*r**18+34990209878541038*r**20+48108964314463574*r**22
            +46828366665262690*r**24+8670023042796464*r**26-79073769980799200*r**28
            -117117049951019522*r**30-13968175223078396*r**32+1385442971549360*r**34
            -22164213928630451*r**36+754229866307315*r**38-1407819902823337*r**40
            -122625003252756*r**42-15888762306870*r**44-1053744440781*r**46+24481279080*r**48)
            +3*Q2**2*(-332183712-56581945472*r**2-386307880689*r**4+33171409960072*r**6
            +371715755326909*r**8+1775118565974258*r**10+7961135168833453*r**12-16810008295265704*r**14
            +193884665302546047*r**16+151776334521534254*r**18-318990534622735242*r**20
            -210457278082413552*r**22-188630956760586654*r**24-206649314478503148*r**26
            +220905430078986234*r**28+29890470055732848*r**30-474999476220126242*r**32
            -88115137685856324*r**34+67327595792221867*r**36-73690470994446616*r**38
            -2588114482095567*r**40-3377439012065062*r**42-479198423761879*r**44-23837706326088*r**46
            -1059129120781*r**48+74934596790*r**50))+276480*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(11520*Q2**26*(90656+517973*r**4)-192*Q2**25*(95366112
            +100056544*r**2+487679011*r**4+565170915*r**6)+10*Q2**24*(14734172448
            +30452073024*r**2+83619763797*r**4+155869910090*r**6+89605289493*r**8)
            -4*Q2**23*(177851586240+552530868672*r**2+1305288426489*r**4+2765392539676*r**6
            +2939311977005*r**8+1094725640970*r**10)+4*Q2**22*(565256780640+2397926836896*r**2
            +5808924650888*r**4+12600424449510*r**6+18008441766983*r**8+13066395391260*r**10
            +3435563964915*r**12)-2*Q2**21*(2424225804480+13619036981952*r**2+36183809160645*r**4
            +79420046286410*r**6+131101835088042*r**8+135576056601796*r**10+73890520921785*r**12
            +13746289441050*r**14)+2*Q2**20*(3361968615600+25758402458064*r**2+74929546214772*r**4
            +165866690773449*r**6+286767149585709*r**8+351104820263230*r**10+291005559138152*r**12
            +129394926584805*r**14+14701610683395*r**16)+5*Q2**19*(-933493581504-12133332450240*r**2
            -34063562346733*r**4-63925578583856*r**6-87899911610363*r**8-67686107661330*r**10
            -63482582309695*r**12-85504982357052*r**14-41370030283905*r**16+1130503308246*r**18)
            -2*Q2**18*(1115610036480-14042032765056*r**2+16570304546853*r**4+264925389845147*r**6
            +922403427653910*r**8+2194726289047385*r**10+3120407230681294*r**12+2250960965565153*r**14
            +680393249631982*r**16+103993335088035*r**18+36374359883265*r**20)+Q2**17*(9177659645760
            +39753645493824*r**2+506161891852497*r**4+2726411393512220*r**6+8209351125013922*r**8
            +18348667455826270*r**10+29378026319889944*r**12+29935534198605262*r**14
            +17241985890573630*r**16+4896022241297842*r**18+838502362660215*r**20
            +107264674058310*r**22)-2*Q2**16*(4651346267280+45486499796112*r**2+465620496436135*r**4
            +2670096579179430*r**6+8459257356537157*r**8+19410219667797676*r**10+33734497901660592*r**12
            +41555958589312480*r**14+33587167416666260*r**16+15583157314851972*r**18
            +3443112517568481*r**20+523313229340410*r**22+21101586825375*r**24)+4*Q2**15*(497382528960
            +19766599280832*r**2+205793575792821*r**4+1484173546868302*r**6+4976024966817387*r**8
            +11198181890729898*r**10+19376247693600664*r**12+25270684732237320*r**14
            +24904942715763152*r**16+17150911923178812*r**18+6178873288635915*r**20
            +603626096508946*r**22+80114742357245*r**24-21001714265790*r**26)+40*Q2**14*(138730768992
            -476291299296*r**2-3460226963775*r**4-78907602121554*r**6-227966468332144*r**8
            -168410069462745*r**10+491522361988966*r**12+1922983855205958*r**14+3008513586947892*r**16
            +2274332105100296*r**18+898648811281673*r**20+412349178246964*r**22+193057123438524*r**24
            +22144488147145*r**26+3462675454512*r**28)-8*Q2**13*(832268545920+4100880043776*r**2
            +69847882811037*r**4+151870556447218*r**6+1505352935204540*r**8+9293328136277880*r**10
            +30995423394861534*r**12+68967616448333558*r**14+106465254818153822*r**16
            +108729797916049710*r**18+69072347787506055*r**20+27452704966074276*r**22
            +8406390924936062*r**24+1741690670452298*r**26+174952071045990*r**28+7317151033860*r**30)
            +4*Q2**12*(569912937840+11356737530256*r**2+185306297246268*r**4+1041698934502525*r**6
            +7138718583823173*r**8+35607084481933100*r**10+115615642366340394*r**12
            +262437391814730177*r**14+438055471738143535*r**16+528761172752714552*r**18
            +436628299883575680*r**20+227679280812602031*r**22+74098920086791363*r**24
            +18771514237782780*r**26+2015801315245658*r**28+172462888530435*r**30
            -14615966678535*r**32)+2*Q2**11*(958605405120-15422193797952*r**2-226898540194575*r**4
            -2254117483134900*r**6-14249754248539977*r**8-68457588197759566*r**10
            -220198508525105623*r**12-483379621946620640*r**14-802086028389049145*r**16
            -1038368947181997778*r**18-1026703957114491949*r**20-705161586578093092*r**22
            -274854625189245675*r**24-52109024558963010*r**26-11064394767351757*r**28
            +2318973814870744*r**30+220926119423565*r**32+43326277373250*r**34)-4*Q2**10*(649143313920
            -2423998434432*r**2-15856342025201*r**4-729856004034697*r**6-3722086837142212*r**8
            -18635269438096221*r**10-47403866541641856*r**12-37800351793084397*r**14
            +73061488998946332*r**16+253739595593664567*r**18+364174847706651094*r**20
            +306900416422530317*r**22+194080030661626596*r**24+125809533929835953*r**26
            +57254660515824888*r**28+11200680167809225*r**30+2752717038141924*r**32
            +217651205212245*r**34+7104632546115*r**36)-10*Q2**9*(-93605070528-781511965632*r**2
            -17998003986999*r**4+58596593445944*r**6-9912484754862*r**8+2541546504654770*r**10
            -3457349969521778*r**12-68217885167902158*r**14-255514782045160806*r**16
            -540731801150542006*r**18-772547556880971288*r**20-773842093062118598*r**22
            -546209844573805050*r**24-291751549063802778*r**26-126624196143291694*r**28
            -36558145646621594*r**30-6564638784815922*r**32-660146180433698*r**34
            -44946420683025*r**36+2461023667062*r**38)+2*Q2**8*(234329166720-7430851855584*r**2
            -108589138160733*r**4-623232089341282*r**6-4486037541395785*r**8+2427533310466780*r**10
            -63844628823911916*r**12-457025033884712692*r**14-1584937558940749508*r**16
            -3390276859942093940*r**18-5080791174553816350*r**20-5667633703404437816*r**22
            -4577592798563000142*r**24-2610382666929424748*r**26-1208519290549333740*r**28
            -477390960987924460*r**30-88191579563955284*r**32-16730428929908508*r**34
            +435995302417363*r**36+52613285613690*r**38+13306552885935*r**40)-8*Q2**7*(79122041280
            -1194344520768*r**2-14093229220879*r**4-217427875356435*r**6-1473621061906984*r**8
            -2994930315845710*r**10-24627935500982117*r**12-93847972064648366*r**14
            -284392778985882595*r**16-551998002571065876*r**18-698721770650403595*r**20
            -691318072289555072*r**22-570071613544910811*r**24-284902428532027100*r**26
            -6006774910701311*r**28+26616722668093430*r**30-4903345413036673*r**32
            +11874013428746956*r**34+1069566596613630*r**36+466043575648971*r**38
            +33245796953895*r**40+678269966130*r**42)-4*Q2**6*(-51145083360+105321098976*r**2
            +205676879070*r**4+275558248128510*r**6+2414008320383391*r**8+13386599185169478*r**10
            +54833067121000279*r**12+137355818104113060*r**14+387026928502387900*r**16
            +675236074218265764*r**18+411516920718195792*r**20-453074411876006176*r**22
            -1162375954701666670*r**24-1245508847284754640*r**26-1145282546177128806*r**28
            -959808946326414628*r**30-473112574400407284*r**32-121711861411112260*r**34
            -44258658796816470*r**36-5897614427790174*r**38-556148549688857*r**40
            -32733109586870*r**42+1367951793975*r**44)+2*Q2**5*(34215353280-1686055073856*r**2
            -17251899626163*r**4+114104260767554*r**6+1968376008578994*r**8+22729969577395308*r**10
            +51006603012772289*r**12+169608056896021042*r**14+582818761369870336*r**16
            +1268146664746602856*r**18+1392219966451529794*r**20+181469677649052572*r**22
            -1865274141586499500*r**24-3007303788639606464*r**26-2674342625012447694*r**28
            -2142099113246330132*r**30-1485902553549316912*r**32-652823324084726824*r**34
            -192947840967165871*r**36-42633624608457406*r**38-6925126521497750*r**40
            -130997581687468*r**42+847414438445*r**44+1937820453570*r**46)+18*(-1
            +r**2)**4*(13583088-800732816*r**2-6761942525*r**4+174176766394*r**6+3616039536635*r**8
            +29591130434028*r**10+75255645629919*r**12+95288706170170*r**14+3049000642862299*r**16
            +3046057057097280*r**18-12865758305285962*r**20-12705172609014236*r**22
            +14190258580021590*r**24+11656830754475864*r**26-11588007756112250*r**28
            -10743782383968012*r**30-1522609235750146*r**32-736918381045840*r**34
            -802467781974201*r**36-127059967281630*r**38-27629430540017*r**40-3422095634596*r**42
            -63979564645*r**44+2355133394*r**46+271936215*r**48)-10*Q2**4*(7929978192
            -199422333648*r**2-1775534251108*r**4-23884426889873*r**6-124791133395965*r**8
            +1098785140415310*r**10-4382729827068868*r**12+15626701004988699*r**14
            +19841377722691149*r**16+49337640032169368*r**18+153801037193697048*r**20
            +165638662107074222*r**22+85150865930609166*r**24-20130498188089724*r**26
            -1202333957424264*r**28+24365121016843006*r**30-90654610314830598*r**32
            -64891412868942072*r**34-1338746508071732*r**36-11096707811427741*r**38
            +801057372016319*r**40-117246537085858*r**42+39577934964940*r**44+3162030110055*r**46
            +45267853977*r**48)-9*Q2*(-1+r**2)**2*(170761920-12613059264*r**2-95105443993*r**4
            +3444010141498*r**6+56775400553915*r**8+398991993099750*r**10+1155988296426461*r**12
            +478005335755102*r**14+38367555439236953*r**16+44291641912962770*r**18
            -91314850353880410*r**20-120472150282922524*r**22-24126310014871698*r**24
            +64126082788052828*r**26+44445944871033050*r**28-107792373611536420*r**30
            -118251521461372654*r**32-16786410211776188*r**34-4739312878345757*r**36
            -11398578242915070*r**38-1544867191046905*r**40-462949115271394*r**42
            -62406398253223*r**44-1779480050522*r**46-5690605915*r**48+6590127690*r**50)
            -3*Q2**3*(-7729817280+55715198016*r**2+429014052067*r**4+88144269410648*r**6
            +899588103698965*r**8+3162138327809790*r**10+24854647905115061*r**12-24853089616538868*r**14
            +266127636317221323*r**16+484924408240184990*r**18+57852238183607950*r**20
            +121939418689604896*r**22+191118367158318402*r**24+15344244353733468*r**26
            -60709557673024710*r**28-754872809671542040*r**30-999340376916517914*r**32
            -138446066691972468*r**34-15787488036102497*r**36-159330407243739160*r**38
            -5202474628159655*r**40-9499218636369434*r**42-1033253486000383*r**44
            -91607733316692*r**46-5176181767585*r**48+172859713110*r**50)+6*Q2**2*(49301760
            -45498388096*r**2-301139841463*r**4+21307733908235*r**6+264167804039722*r**8
            +1404474910660685*r**10+5266132839042314*r**12-6954374360952483*r**14
            +139884135198422170*r**16+109118862660057907*r**18-246589050230249405*r**20
            -62470915613749026*r**22-29183164713668748*r**24-364022045851718670*r**26
            -199151500231502628*r**28+235353830720073930*r**30-40817449231805596*r**32
            -371131208819453578*r**34-52413669611787985*r**36+26221830373924647*r**38
            -49488613551241310*r**40-3528693644719631*r**42-2327776332597478*r**44
            -328173037784375*r**46-14832026958398*r**48-532459293785*r**50+46536681285*r**52))*sqrtq2)
            +logq2**2*(-4608*r**8*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1536*Q2**28*(1587360
            +7039373*r**4)-96*Q2**27*(425605600+385551840*r**2+1633289259*r**4+1921749059*r**6)
            +4*Q2**26*(75785623200+142772536640*r**2+318796687401*r**4+624993078610*r**6
            +346892985801*r**8)-2*Q2**25*(650400351360+1929159760000*r**2+3745877166119*r**4
            +7925246518298*r**6+8703921390143*r**8+2975102667084*r**10)+4*Q2**24*(872433804000
            +3722840674560*r**2+7576503724265*r**4+15542068908220*r**6+22740861028252*r**8
            +17041988894760*r**10+3844110429375*r**12)-2*Q2**23*(2847301257600+17651304525440*r**2
            +37338537974275*r**4+73367555597280*r**6+116378694718076*r**8+128826227931496*r**10
            +77894409902605*r**12+10696150250820*r**14)+2*Q2**22*(2078218599600+24457683710000*r**2
            +36927000644215*r**4+41533571935345*r**6+21808323811764*r**8-3315645645206*r**10
            +86962785602289*r**12+82956647129305*r**14+814325915160*r**16)+Q2**21*(3624431284800
            -23436805009920*r**2+157083331381015*r**4+804051151286050*r**6+2041298233791673*r**8
            +3792396302934560*r**10+3649520680368245*r**12+1279782873213098*r**14
            +127488265739715*r**16+52926433957980*r**18)-2*Q2**20*(6084862758000+23693005541520*r**2
            +359307190706690*r**4+1700853896541105*r**6+4337334026694276*r**8+8573830990359353*r**10
            +11297193717569130*r**12+8054931785741343*r**14+2430390835932596*r**16
            +364520850513015*r**18+46406357987580*r**20)+2*Q2**19*(5227397352000+53835052206720*r**2
            +609501619662105*r**4+3574295478664690*r**6+9941269267162059*r**8+20750558841888600*r**10
            +31906160912471635*r**12+31918805990239170*r**14+17557372930493745*r**16
            +3819842346667084*r**18+520668668893920*r**20+18924730350000*r**22)+Q2**18*(3125453239200
            -88637688490080*r**2-884111637133280*r**4-8551160630527210*r**6-25842551736831292*r**8
            -54085192489183592*r**10-85466557321045480*r**12-98458911682817164*r**14
            -81523681777633400*r**16-35156294402411272*r**18-2720719555623832*r**20
            -298440284224410*r**22+96554969829780*r**24)-Q2**17*(14141679652800+550566419200*r**2
            +428213079527605*r**4-3610531230591230*r**6-7508119117814313*r**8+3999663661925672*r**10
            +47157369693117242*r**12+121423921468769208*r**14+126272294275108838*r**16
            +49445512207986812*r**18+18766924056817297*r**20+11566153629468262*r**22
            +1212487064204675*r**24+157872670942140*r**26)+2*Q2**16*(4813076060400
            +38972607812240*r**2+796666191460375*r**4+3165426435676225*r**6+19889857571637709*r**8
            +86657900297358975*r**10+234682412703239680*r**12+465362060808129798*r**14
            +610863092960253330*r**16+462601410822758218*r**18+187660677451171775*r**20
            +55534426080571705*r**22+11070970108447409*r**24+957040168531495*r**26
            +22404152521770*r**28)+4*Q2**15*(918622444800-21475846623360*r**2-342009954739575*r**4
            -3293751316633700*r**6-19981406671725158*r**8-90584428718716184*r**10
            -254026291876051645*r**12-527943079699119628*r**14-801225670934137136*r**16
            -806886062377656976*r**18-477847979029249693*r**20-149406906888055060*r**22
            -36540291646963194*r**24-3063171617280168*r**26-186575699940255*r**28
            +29286519050580*r**30)-4*Q2**14*(2349075402000-9364632312560*r**2-9185360411565*r**4
            -2528856041462645*r**6-16133462353774712*r**8-94541990390220090*r**10
            -282302669574545705*r**12-590977343374721115*r**14-949595224703597440*r**16
            -1119157853786740108*r**18-904248004205382575*r**20-396336866010504915*r**22
            -58513830827317880*r**24-11006854678763450*r**26+3217476301595013*r**28
            +293593651211315*r**30+32544115920000*r**32)+2*Q2**13*(1984038312000+10580178997760*r**2
            +464492617909555*r**4-167518729419630*r**6-1136754150052731*r**8-85208177921914736*r**10
            -208800639557064105*r**12-115569853785429314*r**14+354183681036321225*r**16
            +1062649712191973836*r**18+1181923754351893601*r**20+685715213225648110*r**22
            +512927279263284951*r**24+316504530401683080*r**26+63204110976950389*r**28
            +12944030851232674*r**30+875771328335995*r**32+1958714356860*r**34)+4*Q2**12*(654095134800
            -12437559234000*r**2-189052484333500*r**4-1636466188712485*r**6-11322779460514558*r**8
            -23474317464061853*r**10-188831426817159448*r**12-941200254216831289*r**14
            -2638862607053874014*r**16-4974629041263398497*r**18-6304096967694966352*r**20
            -5018457967519905287*r**22-2538229095310987354*r**24-1029361538272867279*r**26
            -275606545794736808*r**28-47713982389131803*r**30-3122327205719258*r**32
            -143510044621155*r**34+20480451819660*r**36)+4*Q2**11*(-843346324800+8532329205120*r**2
            +15366372635905*r**4+1545511066967550*r**6+12128116984447917*r**8+64319741761078360*r**10
            +369128509004924515*r**12+1563263332654438026*r**14+4418204076716443405*r**16
            +8811632804545275532*r**18+12765642847053436365*r**20+12786274123818542530*r**22
            +8072710743238253047*r**24+3198624337620653760*r**26+1077776392830087841*r**28
            +132997723366894710*r**30+20476689580923375*r**32-2246317756088708*r**34
            -186646426882290*r**36-12132562505760*r**38)-4*Q2**10*(-189151196400-477107354640*r**2
            -72622104951015*r**4+623127301510595*r**6+7467103789735233*r**8+68292770818355844*r**10
            +288204868678550620*r**12+1148589545203287132*r**14+3222383806972564584*r**16
            +6102965582375477548*r**18+9031861052950035294*r**20+10489472441832485130*r**22
            +8615140146261428554*r**24+3675052800810604668*r**26+494149128969691884*r**28
            +210496800304386572*r**30-116027037315397920*r**32-17949200381304156*r**34
            -3643070270777407*r**36-217370286705525*r**38+3876826994205*r**40)+4*Q2**9*(207852060000
            -5153461333440*r**2-46624046057410*r**4-35239117418330*r**6+1839700031747917*r**8
            +37849636350785630*r**10+72826178853261800*r**12+396606880169098190*r**14
            +465598163755367440*r**16-2047476044238060742*r**18-7266886935664497640*r**20
            -11927713145691369950*r**22-12084043819566564130*r**24-8703900887621751850*r**26
            -6114075991290026192*r**28-3270351935824844150*r**30-765824962209182960*r**32
            -201804575357776450*r**34-28864694144505710*r**36-1251876969048608*r**38
            -43488385887915*r**40+6968899972500*r**42)-4*Q2**8*(167577332400-3259029345680*r**2
            +50736177830*r**4-312901499904285*r**6-3478047435154227*r**8-1690807622994047*r**10
            -37897366244312025*r**12+260372212849362348*r**14-907783360515227500*r**16
            -7512399135372882268*r**18-20835268000542335768*r**20-35094460258985395630*r**22
            -40728804089825434946*r**24-32933003168064225210*r**26-20145861036081004438*r**28
            -10613252703457010868*r**30-3722281840261729980*r**32-956412479240780972*r**34
            -92127607250465030*r**36-12154823462876717*r**38+864657304561133*r**40
            +72052628979665*r**42+1479722986215*r**44)-2*Q2**7*(-51317385600-293727766400*r**2
            -26057948784145*r**4+712005680921000*r**6+9877933156891856*r**8+41186391896681256*r**10
            +106443969384833801*r**12-430792822414309548*r**14+2846056620075930552*r**16
            +13950671764605806144*r**18+36880169616762985294*r**20+63566025226859032304*r**22
            +79141783041423326296*r**24+70023540638765940656*r**26+38888626811423900394*r**28
            +18858438150765614344*r**30+11124946139405954664*r**32+1166213226051460032*r**34
            +732997133393659507*r**36-66845456166689144*r**38-10642315267929544*r**40
            -1874789350758744*r**42-110493464585635*r**44+3325422870660*r**46)+2*Q2**6*(59698316400
            -2420829503760*r**2-10356972695785*r**4+374603036347925*r**6+3943248699625724*r**8
            +40887291852155890*r**10+198530228415614485*r**12+592549633143477481*r**14
            +3757260168628558360*r**16+7166469856692990808*r**18+15927910958368741510*r**20
            +17397533411041757130*r**22+6508051009066686792*r**24+2388129254610062700*r**26
            -4290184091863546678*r**28-24975566181517828390*r**30-19703038316578387600*r**32
            -2493246026465351512*r**34-3899323345885985005*r**36-491290822601534239*r**38
            -122854568790506660*r**40-16831851104279630*r**42-402812574206351*r**44
            -5941681268355*r**46+1978141958760*r**48)+Q2**5*(-81972331200+2262781775360*r**2
            -3338731147885*r**4+85387792404730*r**6+3014796421833773*r**8-56746958061597376*r**10
            -449511353782504235*r**12-2236595961362326614*r**14-4170908991495791853*r**16
            -6526118937542253684*r**18-30402731224060699762*r**20-35076721040583480460*r**22
            +19821359359786789522*r**24+88731187171312463024*r**26+94472062194896999834*r**28
            +64371376787146096612*r**30+75924700704519476310*r**32+56482386565385666088*r**34
            +12852208726143012591*r**36+6258631652816105042*r**38+1411363903479155441*r**40
            +114534345826692400*r**42+13143974348053889*r**44-555632405169742*r**46
            -56654477477465*r**48+244794255660*r**50)+18*(-1+r**2)**4*(-10334160
            +170491280*r**2-732861469*r**4+162034662721*r**6+1352729120631*r**8-60304631497299*r**10
            -350609253022869*r**12-1201658331738749*r**14-610815805028259*r**16-10015108129421049*r**18
            -189330520152510004*r**20+247751594667119626*r**22+690655635639999686*r**24
            -698547420529026174*r**26-514897293662299514*r**28+614701663369870406*r**30
            +157018638024523786*r**32-71378039159387874*r**34+50485305308872491*r**36
            +7981755567280901*r**38+1883599553243571*r**40+533828498588001*r**42+29865292604031*r**44
            +834804650471*r**46-95671299719*r**48-8068344389*r**50+203743926*r**52)
            -2*Q2**4*(-6765474000-59754735920*r**2-2263681852930*r**4+163583324272885*r**6
            +1693741529610696*r**8-8375394524467315*r**10-68638542030862730*r**12
            -512380894695670345*r**14+806961166735010880*r**16-3990974889596419809*r**18
            -14943911181725753960*r**20-20302288299766414990*r**22-21431257908460058960*r**24
            -18145821464158566750*r**26+5166569678492408876*r**28+15291587304917003470*r**30
            +9929954130781979600*r**32+9231028042501733550*r**34+6989558700294761070*r**36
            +3960574119855617641*r**38+290387121743376200*r**40+263404013113589665*r**42
            +1076697492749310*r**44-914701049568085*r**46-186239133019904*r**48-12880523905645*r**50
            +410620657500*r**52)-9*Q2*(-1+r**2)**2*(-199752000+4751893120*r**2-13650394019*r**4
            +1601460133452*r**6+21066235198802*r**8-853359845710128*r**10-4875435259801668*r**12
            -13528177355250568*r**14-29795479122034458*r**16-27623053746520608*r**18
            -2106283815299696063*r**20+575351349558371972*r**22+6757545329231572212*r**24
            +855088226550970912*r**26-7540857975542987488*r**28-1377020442969405168*r**30
            +6432381585638978892*r**32+1186025699368427712*r**34-953404565814771633*r**36
            +704417184749459092*r**38+61516473835827162*r**40+27897063175849872*r**42
            +7904464712080932*r**44+502080419967352*r**46+29571049662702*r**48-1443169216928*r**50
            -154293432813*r**52+3178579356*r**54)+6*Q2**3*(1618549440-87587722880*r**2
            -104750745273*r**4+23900111329190*r**6+67705935546833*r**8+2806012945578728*r**10
            +20254752197764925*r**12+14957630364481054*r**14+493506068924358575*r**16
            -1304941992838298412*r**18+2802701837522696218*r**20+6243488287747283340*r**22
            +3657738545703847514*r**24+4326829672759230560*r**26+2064045685852642538*r**28
            -5686464335605300372*r**30-10415586220129165970*r**32+78513968451352664*r**34
            +1316092158790426395*r**36-3287539833103255922*r**38+481314971078246853*r**40
            -243249163673715880*r**42-21173582212444471*r**44-4170338154600970*r**46
            -628873852185037*r**48-7961276636492*r**50+210062728340*r**52+31214008512*r**54)
            +6*Q2**2*(-1132453200+38429729840*r**2-79605029896*r**4-154636409011*r**6
            +74163833084538*r**8-3347068849162332*r**10-18061686709970532*r**12-30517107953997182*r**14
            -196114006225856012*r**16+556228928050333348*r**18-6431266492851114772*r**20
            -490312877894489797*r**22+11504792735741768438*r**24+5634686337878814408*r**26
            +1220351584339216728*r**28-9580919867435842692*r**30-5977129133438723192*r**32
            +15866209644382094488*r**34+3396527766866112208*r**36-4831292390117127277*r**38
            +2972507459509446278*r**40-86456831619768172*r**42+124216561096702668*r**44
            +30473823735298338*r**46+2408646742720788*r**48+258360172120468*r**50
            -4251500518772*r**52-746262872891*r**54+8399893194*r**56))-4608*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(1536*Q2**28*(1587360+7039373*r**4)-96*Q2**27*(425605600
            +385551840*r**2+1633289259*r**4+1921749059*r**6)+4*Q2**26*(75785623200
            +142772536640*r**2+318796687401*r**4+624993078610*r**6+346892985801*r**8)
            -2*Q2**25*(650400351360+1929159760000*r**2+3745877166119*r**4+7925246518298*r**6
            +8703921390143*r**8+2975102667084*r**10)+4*Q2**24*(872433804000+3722840674560*r**2
            +7576503724265*r**4+15542068908220*r**6+22740861028252*r**8+17041988894760*r**10
            +3844110429375*r**12)-2*Q2**23*(2847301257600+17651304525440*r**2+37338537974275*r**4
            +73367555597280*r**6+116378694718076*r**8+128826227931496*r**10+77894409902605*r**12
            +10696150250820*r**14)+2*Q2**22*(2078218599600+24457683710000*r**2+36927000644215*r**4
            +41533571935345*r**6+21808323811764*r**8-3315645645206*r**10+86962785602289*r**12
            +82956647129305*r**14+814325915160*r**16)+Q2**21*(3624431284800-23436805009920*r**2
            +157083331381015*r**4+804051151286050*r**6+2041298233791673*r**8+3792396302934560*r**10
            +3649520680368245*r**12+1279782873213098*r**14+127488265739715*r**16+52926433957980*r**18)
            -2*Q2**20*(6084862758000+23693005541520*r**2+359307190706690*r**4+1700853896541105*r**6
            +4337334026694276*r**8+8573830990359353*r**10+11297193717569130*r**12
            +8054931785741343*r**14+2430390835932596*r**16+364520850513015*r**18+46406357987580*r**20)
            +2*Q2**19*(5227397352000+53835052206720*r**2+609501619662105*r**4+3574295478664690*r**6
            +9941269267162059*r**8+20750558841888600*r**10+31906160912471635*r**12
            +31918805990239170*r**14+17557372930493745*r**16+3819842346667084*r**18
            +520668668893920*r**20+18924730350000*r**22)+Q2**18*(3125453239200-88637688490080*r**2
            -884111637133280*r**4-8551160630527210*r**6-25842551736831292*r**8-54085192489183592*r**10
            -85466557321045480*r**12-98458911682817164*r**14-81523681777633400*r**16
            -35156294402411272*r**18-2720719555623832*r**20-298440284224410*r**22
            +96554969829780*r**24)-Q2**17*(14141679652800+550566419200*r**2+428213079527605*r**4
            -3610531230591230*r**6-7508119117814313*r**8+3999663661925672*r**10+47157369693117242*r**12
            +121423921468769208*r**14+126272294275108838*r**16+49445512207986812*r**18
            +18766924056817297*r**20+11566153629468262*r**22+1212487064204675*r**24
            +157872670942140*r**26)+2*Q2**16*(4813076060400+38972607812240*r**2+796666191460375*r**4
            +3165426435676225*r**6+19889857571637709*r**8+86657900297358975*r**10
            +234682412703239680*r**12+465362060808129798*r**14+610863092960253330*r**16
            +462601410822758218*r**18+187660677451171775*r**20+55534426080571705*r**22
            +11070970108447409*r**24+957040168531495*r**26+22404152521770*r**28)+4*Q2**15*(918622444800
            -21475846623360*r**2-342009954739575*r**4-3293751316633700*r**6-19981406671725158*r**8
            -90584428718716184*r**10-254026291876051645*r**12-527943079699119628*r**14
            -801225670934137136*r**16-806886062377656976*r**18-477847979029249693*r**20
            -149406906888055060*r**22-36540291646963194*r**24-3063171617280168*r**26
            -186575699940255*r**28+29286519050580*r**30)-4*Q2**14*(2349075402000-9364632312560*r**2
            -9185360411565*r**4-2528856041462645*r**6-16133462353774712*r**8-94541990390220090*r**10
            -282302669574545705*r**12-590977343374721115*r**14-949595224703597440*r**16
            -1119157853786740108*r**18-904248004205382575*r**20-396336866010504915*r**22
            -58513830827317880*r**24-11006854678763450*r**26+3217476301595013*r**28
            +293593651211315*r**30+32544115920000*r**32)+2*Q2**13*(1984038312000+10580178997760*r**2
            +464492617909555*r**4-167518729419630*r**6-1136754150052731*r**8-85208177921914736*r**10
            -208800639557064105*r**12-115569853785429314*r**14+354183681036321225*r**16
            +1062649712191973836*r**18+1181923754351893601*r**20+685715213225648110*r**22
            +512927279263284951*r**24+316504530401683080*r**26+63204110976950389*r**28
            +12944030851232674*r**30+875771328335995*r**32+1958714356860*r**34)+4*Q2**12*(654095134800
            -12437559234000*r**2-189052484333500*r**4-1636466188712485*r**6-11322779460514558*r**8
            -23474317464061853*r**10-188831426817159448*r**12-941200254216831289*r**14
            -2638862607053874014*r**16-4974629041263398497*r**18-6304096967694966352*r**20
            -5018457967519905287*r**22-2538229095310987354*r**24-1029361538272867279*r**26
            -275606545794736808*r**28-47713982389131803*r**30-3122327205719258*r**32
            -143510044621155*r**34+20480451819660*r**36)+4*Q2**11*(-843346324800+8532329205120*r**2
            +15366372635905*r**4+1545511066967550*r**6+12128116984447917*r**8+64319741761078360*r**10
            +369128509004924515*r**12+1563263332654438026*r**14+4418204076716443405*r**16
            +8811632804545275532*r**18+12765642847053436365*r**20+12786274123818542530*r**22
            +8072710743238253047*r**24+3198624337620653760*r**26+1077776392830087841*r**28
            +132997723366894710*r**30+20476689580923375*r**32-2246317756088708*r**34
            -186646426882290*r**36-12132562505760*r**38)-4*Q2**10*(-189151196400-477107354640*r**2
            -72622104951015*r**4+623127301510595*r**6+7467103789735233*r**8+68292770818355844*r**10
            +288204868678550620*r**12+1148589545203287132*r**14+3222383806972564584*r**16
            +6102965582375477548*r**18+9031861052950035294*r**20+10489472441832485130*r**22
            +8615140146261428554*r**24+3675052800810604668*r**26+494149128969691884*r**28
            +210496800304386572*r**30-116027037315397920*r**32-17949200381304156*r**34
            -3643070270777407*r**36-217370286705525*r**38+3876826994205*r**40)+4*Q2**9*(207852060000
            -5153461333440*r**2-46624046057410*r**4-35239117418330*r**6+1839700031747917*r**8
            +37849636350785630*r**10+72826178853261800*r**12+396606880169098190*r**14
            +465598163755367440*r**16-2047476044238060742*r**18-7266886935664497640*r**20
            -11927713145691369950*r**22-12084043819566564130*r**24-8703900887621751850*r**26
            -6114075991290026192*r**28-3270351935824844150*r**30-765824962209182960*r**32
            -201804575357776450*r**34-28864694144505710*r**36-1251876969048608*r**38
            -43488385887915*r**40+6968899972500*r**42)-4*Q2**8*(167577332400-3259029345680*r**2
            +50736177830*r**4-312901499904285*r**6-3478047435154227*r**8-1690807622994047*r**10
            -37897366244312025*r**12+260372212849362348*r**14-907783360515227500*r**16
            -7512399135372882268*r**18-20835268000542335768*r**20-35094460258985395630*r**22
            -40728804089825434946*r**24-32933003168064225210*r**26-20145861036081004438*r**28
            -10613252703457010868*r**30-3722281840261729980*r**32-956412479240780972*r**34
            -92127607250465030*r**36-12154823462876717*r**38+864657304561133*r**40
            +72052628979665*r**42+1479722986215*r**44)-2*Q2**7*(-51317385600-293727766400*r**2
            -26057948784145*r**4+712005680921000*r**6+9877933156891856*r**8+41186391896681256*r**10
            +106443969384833801*r**12-430792822414309548*r**14+2846056620075930552*r**16
            +13950671764605806144*r**18+36880169616762985294*r**20+63566025226859032304*r**22
            +79141783041423326296*r**24+70023540638765940656*r**26+38888626811423900394*r**28
            +18858438150765614344*r**30+11124946139405954664*r**32+1166213226051460032*r**34
            +732997133393659507*r**36-66845456166689144*r**38-10642315267929544*r**40
            -1874789350758744*r**42-110493464585635*r**44+3325422870660*r**46)+2*Q2**6*(59698316400
            -2420829503760*r**2-10356972695785*r**4+374603036347925*r**6+3943248699625724*r**8
            +40887291852155890*r**10+198530228415614485*r**12+592549633143477481*r**14
            +3757260168628558360*r**16+7166469856692990808*r**18+15927910958368741510*r**20
            +17397533411041757130*r**22+6508051009066686792*r**24+2388129254610062700*r**26
            -4290184091863546678*r**28-24975566181517828390*r**30-19703038316578387600*r**32
            -2493246026465351512*r**34-3899323345885985005*r**36-491290822601534239*r**38
            -122854568790506660*r**40-16831851104279630*r**42-402812574206351*r**44
            -5941681268355*r**46+1978141958760*r**48)+Q2**5*(-81972331200+2262781775360*r**2
            -3338731147885*r**4+85387792404730*r**6+3014796421833773*r**8-56746958061597376*r**10
            -449511353782504235*r**12-2236595961362326614*r**14-4170908991495791853*r**16
            -6526118937542253684*r**18-30402731224060699762*r**20-35076721040583480460*r**22
            +19821359359786789522*r**24+88731187171312463024*r**26+94472062194896999834*r**28
            +64371376787146096612*r**30+75924700704519476310*r**32+56482386565385666088*r**34
            +12852208726143012591*r**36+6258631652816105042*r**38+1411363903479155441*r**40
            +114534345826692400*r**42+13143974348053889*r**44-555632405169742*r**46
            -56654477477465*r**48+244794255660*r**50)+18*(-1+r**2)**4*(-10334160
            +170491280*r**2-732861469*r**4+162034662721*r**6+1352729120631*r**8-60304631497299*r**10
            -350609253022869*r**12-1201658331738749*r**14-610815805028259*r**16-10015108129421049*r**18
            -189330520152510004*r**20+247751594667119626*r**22+690655635639999686*r**24
            -698547420529026174*r**26-514897293662299514*r**28+614701663369870406*r**30
            +157018638024523786*r**32-71378039159387874*r**34+50485305308872491*r**36
            +7981755567280901*r**38+1883599553243571*r**40+533828498588001*r**42+29865292604031*r**44
            +834804650471*r**46-95671299719*r**48-8068344389*r**50+203743926*r**52)
            -2*Q2**4*(-6765474000-59754735920*r**2-2263681852930*r**4+163583324272885*r**6
            +1693741529610696*r**8-8375394524467315*r**10-68638542030862730*r**12
            -512380894695670345*r**14+806961166735010880*r**16-3990974889596419809*r**18
            -14943911181725753960*r**20-20302288299766414990*r**22-21431257908460058960*r**24
            -18145821464158566750*r**26+5166569678492408876*r**28+15291587304917003470*r**30
            +9929954130781979600*r**32+9231028042501733550*r**34+6989558700294761070*r**36
            +3960574119855617641*r**38+290387121743376200*r**40+263404013113589665*r**42
            +1076697492749310*r**44-914701049568085*r**46-186239133019904*r**48-12880523905645*r**50
            +410620657500*r**52)-9*Q2*(-1+r**2)**2*(-199752000+4751893120*r**2-13650394019*r**4
            +1601460133452*r**6+21066235198802*r**8-853359845710128*r**10-4875435259801668*r**12
            -13528177355250568*r**14-29795479122034458*r**16-27623053746520608*r**18
            -2106283815299696063*r**20+575351349558371972*r**22+6757545329231572212*r**24
            +855088226550970912*r**26-7540857975542987488*r**28-1377020442969405168*r**30
            +6432381585638978892*r**32+1186025699368427712*r**34-953404565814771633*r**36
            +704417184749459092*r**38+61516473835827162*r**40+27897063175849872*r**42
            +7904464712080932*r**44+502080419967352*r**46+29571049662702*r**48-1443169216928*r**50
            -154293432813*r**52+3178579356*r**54)+6*Q2**3*(1618549440-87587722880*r**2
            -104750745273*r**4+23900111329190*r**6+67705935546833*r**8+2806012945578728*r**10
            +20254752197764925*r**12+14957630364481054*r**14+493506068924358575*r**16
            -1304941992838298412*r**18+2802701837522696218*r**20+6243488287747283340*r**22
            +3657738545703847514*r**24+4326829672759230560*r**26+2064045685852642538*r**28
            -5686464335605300372*r**30-10415586220129165970*r**32+78513968451352664*r**34
            +1316092158790426395*r**36-3287539833103255922*r**38+481314971078246853*r**40
            -243249163673715880*r**42-21173582212444471*r**44-4170338154600970*r**46
            -628873852185037*r**48-7961276636492*r**50+210062728340*r**52+31214008512*r**54)
            +6*Q2**2*(-1132453200+38429729840*r**2-79605029896*r**4-154636409011*r**6
            +74163833084538*r**8-3347068849162332*r**10-18061686709970532*r**12-30517107953997182*r**14
            -196114006225856012*r**16+556228928050333348*r**18-6431266492851114772*r**20
            -490312877894489797*r**22+11504792735741768438*r**24+5634686337878814408*r**26
            +1220351584339216728*r**28-9580919867435842692*r**30-5977129133438723192*r**32
            +15866209644382094488*r**34+3396527766866112208*r**36-4831292390117127277*r**38
            +2972507459509446278*r**40-86456831619768172*r**42+124216561096702668*r**44
            +30473823735298338*r**46+2408646742720788*r**48+258360172120468*r**50
            -4251500518772*r**52-746262872891*r**54+8399893194*r**56))*sqrtq2)+logq2*(
            -384*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*(164784*Q2**27*(160+241*r**4)-6*Q2**26*(68094560
            +37026400*r**2+113936759*r**4+112839815*r**6)+12*Q2**25*(236953440+265460160*r**2
            +162812445*r**4+995513828*r**6+419384103*r**8)-2*Q2**24*(5771092320+10062185760*r**2
            -10616298091*r**4+14152914085*r**6+43080343119*r**8+10537063455*r**10)
            +Q2**23*(29308406400+72634152960*r**2-230828522510*r**4-353854514910*r**6
            +59268112578*r**8+322546576422*r**10+52070156340*r**12)-2*Q2**22*(22203020880
            +79739683680*r**2-592180028316*r**4-1609217084377*r**6-1813393350002*r**8
            -675402582320*r**10+284622215364*r**12+32135329215*r**14)-Q2**21*(-25494938880
            -195366922560*r**2+4032900428947*r**4+14381227513537*r**6+25207570807444*r**8
            +27625944654418*r**10+11727444932719*r**12+210157312593*r**14+21638356110*r**16)
            +2*Q2**20*(21154403760-18872879520*r**2+4826104775924*r**4+21732647220147*r**6
            +46755778305903*r**8+72097674903272*r**10+64907245190652*r**12+22299291693533*r**14
            +1702664092281*r**16+110325577680*r**18)-2*Q2**19*(51728973120+163891906560*r**2
            +7787829940074*r**4+46121784798160*r**6+112129040438449*r**8+201696668912695*r**10
            +252760436543360*r**12+179845697844494*r**14+45078459193445*r**16+3692676314799*r**18
            +165028842180*r**20)+2*Q2**18*(32208442800+330813319680*r**2+6856118410395*r**4
            +62992750336945*r**6+155803774225119*r**8+285736162585041*r**10+397398627699685*r**12
            +420771090991095*r**14+260175033175185*r**16+35607875109319*r**18+2728313822856*r**20
            +34402393320*r**22)+Q2**17*(69606867840-644368061760*r**2+2836556456277*r**4
            -73369912544001*r**6-40766111100616*r**8+247251991156290*r**10+873690060031632*r**12
            +1268909484171620*r**14+453725024760474*r**16-38859906399186*r**18+100788983497835*r**20
            +6487237634637*r**22+449504724030*r**24)-2*Q2**16*(74845017360-82070815680*r**2
            +12604623632241*r**4+40218344786101*r**6+391548858697727*r**8+1548774121858079*r**10
            +3687637757284852*r**12+6124303684622024*r**14+5870781438058676*r**16
            +2605022188625272*r**18+669877426153739*r**20+166094461361267*r**22+9200829640269*r**24
            +311561547705*r**26)+4*Q2**15*(16341526080+139549904640*r**2+7423677969167*r**4
            +51773719544331*r**6+400076787604849*r**8+1793791458182811*r**10+4556131516130596*r**12
            +8400304143956806*r**14+10488798321029862*r**16+7686067816506802*r**18
            +2622908710156951*r**20+619499632175471*r**22+79072546141449*r**24+3280884114723*r**26
            +28245332550*r**28)+4*Q2**14*(21062726640-248793446880*r**2-1611804696512*r**4
            -40853462717505*r**6-345385168463832*r**8-2263381650913710*r**10-6241257458126850*r**12
            -12085287975869053*r**14-16759730386171620*r**16-16193948882322768*r**18
            -9203322761145280*r**20-1748675639915255*r**22-380986844877732*r**24+18803773136510*r**26
            +2043997059618*r**28+135345234885*r**30)-2*Q2**13*(59293497600-324998422080*r**2
            +10526185325355*r**4-4180286066895*r**6-11347062774884*r**8-2873568302957966*r**10
            -7376801638251635*r**12-10640243724163405*r**14-7398520144661890*r**16
            -128478053085356*r**18-1526356821606379*r**20+589154501143175*r**22+4680174466685480*r**24
            +719400675208650*r**26+232989976533891*r**28+10684274516709*r**30+283940905230*r**32)
            +4*Q2**12*(5913458160+68409531360*r**2+5862704259728*r**4+19125039510001*r**6
            +324697888717681*r**8+404558326860020*r**10+3435765043014928*r**12+15386652419352001*r**14
            +40933279109544309*r**16+71793522856545784*r**18+74699478978565000*r**20
            +42480338989736747*r**22+18099285135860707*r**24+6122943076533676*r**26
            +895723777167896*r**28+96832181072995*r**30+2804262944583*r**32+6025048200*r**34)
            +4*Q2**11*(14694381120-210487983360*r**2-986368192808*r**4-14864097349518*r**6
            -384643895736581*r**8-1951307283785387*r**10-9147994800207186*r**12-33426361004690588*r**14
            -84514640545034607*r**16-156101402512953069*r**18-199126184746301488*r**20
            -157305194855854094*r**22-69076400513137515*r**24-26359009365242093*r**26
            -4590889447934426*r**28-637283510087352*r**30+13396199280879*r**32+1822014724053*r**34
            +91062298260*r**36)+2*Q2**10*(-23922325440+253350643680*r**2-5419797253071*r**4
            +22876932517777*r**6+370284092928658*r**8+3930459480152302*r**10+14350411270682822*r**12
            +55890580358504794*r**14+134390509163186986*r**16+245800687090257254*r**18
            +354019272103366168*r**20+368992246359925228*r**22+219060781009749926*r**24
            +39898709172794938*r**26+23608207374871210*r**28-3028601574734938*r**30
            -243175820997538*r**32-161189818754542*r**34-6115299094329*r**36-125913410685*r**38)
            +2*Q2**9*(-929017920+87742290240*r**2+4408947632031*r**4-27491056300285*r**6
            +171674376544026*r**8-1486987590243030*r**10-2961681014593870*r**12-24750207942139966*r**14
            -10169411963236710*r**16+93460659399603194*r**18+208006403678071760*r**20
            +254497927064665080*r**22+181248004440788654*r**24+153058217622245150*r**26
            +144630816793059294*r**28+26364665658247310*r**30+11149636912107390*r**32
            +1176244743122046*r**34+101107811824385*r**36+1887469790901*r**38-15668971680*r**40)
            +2*Q2**8*(10450704000-202073769120*r**2-273601120455*r**4+13341084779445*r**6
            -430523265971281*r**8-448481286441549*r**10-551211788628480*r**12+20083909581468280*r**14
            -59561019540613560*r**16-354789303151873344*r**18-774520988939642726*r**20
            -1061290207116074070*r**22-999941992881340770*r**24-642897506202310850*r**26
            -386065701959553144*r**28-186945358683940656*r**30-46665269694665200*r**32
            -7565836603156680*r**34-862149439641435*r**36+14660947342169*r**38+1723759015131*r**40
            +62488864695*r**42)+2*Q2**7*(-4664364480+80301841920*r**2-1435307808639*r**4
            +13275031342177*r**6+257271630282317*r**8+825217775458055*r**10+733708706388046*r**12
            -15612559782204764*r**14+69015847547647948*r**16+309293836757728868*r**18
            +704096560151896630*r**20+1056615029441109694*r**22+1119238940601955070*r**24
            +724151823718287898*r**26+299087873879130928*r**28+260853863440416020*r**30
            +30349263525911084*r**32+24651140549194628*r**34-815747715647423*r**36
            +34154532784937*r**38-51218277580675*r**40-1615049429769*r**42-25539172470*r**44)
            -2*Q2**6*(1118831760-37187477280*r**2-821364948484*r**4+21214298009951*r**6
            -50099972726518*r**8+948572896225404*r**10+5739915595349312*r**12+9498266535181095*r**14
            +61032265897720224*r**16+124910608891478248*r**18+296079959229245776*r**20
            +210620335088912198*r**22+127435217064449156*r**24+220617182448264544*r**26
            -217531345318982472*r**28-468305918123786354*r**30+57720115133767968*r**32
            -112435155793682376*r**34-5762209743195724*r**36-4362171594002533*r**38
            -386715705739486*r**40-23198391952348*r**42-192465607416*r**44+7832537355*r**46)
            +Q2**5*(3329752320-90590523840*r**2-89088113687*r**4+18033587679939*r**6
            -290026809740724*r**8+2074624525565334*r**10+14796023994345969*r**12+37746458739931823*r**14
            +37014439780338474*r**16+118381410273615000*r**18+628144018421567186*r**20
            +229852249754233366*r**22-739398857268655344*r**24-1390455548080359628*r**26
            -381396950210133558*r**28-694594396959951354*r**30-1393718143308320804*r**32
            -36210513347569608*r**34-187382955862374747*r**36-30189122686929113*r**38
            -4992018685908236*r**40-552819152943066*r**42+4696274483941*r**44+710387104587*r**46
            +20425465770*r**48)+6*(-1+r**2)**4*(924240-38827200*r**2-277355057*r**4
            +14062765195*r**6-331984202673*r**8+7438914544239*r**10+18871360804635*r**12
            -32721482594677*r**14+463921150548835*r**16-1739548655574193*r**18+17564431749793134*r**20
            -33442696864204330*r**22-26307734583580402*r**24+82726395560355550*r**26
            -31243968755648258*r**28-26428576925403186*r**30+16495839976458430*r**32
            -6218279192391562*r**34+233444651394115*r**36-187531054771713*r**38-38353996316061*r**40
            -3218311410285*r**42-326786785177*r**44+6519370055*r**46+335643087*r**48
            +5663259*r**50)-2*Q2**4*(396619920-10135695840*r**2+151491709524*r**4
            -2445297986915*r**6-51121555145831*r**8+431453087268400*r**10+1847023241845820*r**12
            +8490878179521959*r**14-26247595513144645*r**16+102930509349610784*r**18
            +269275956222371960*r**20+176944330291371890*r**22+232253877153142314*r**24
            +226596607863290160*r**26-359904096800600856*r**28-111531282727087970*r**30
            +43170292640242870*r**32-200150306713768976*r**34-55649662394929100*r**36
            -7107301761168191*r**38-7602027433278515*r**40-72715280782240*r**42-43556156124196*r**44
            +5956626864875*r**46+179919364719*r**48+2399608080*r**50)-3*Q2*(-1+r**2)**2*(20065920
            -806729280*r**2-4360005979*r**4+307305783121*r**6-5775662801091*r**8
            +105365047015803*r**10+322978303671725*r**12-709430510322689*r**14+6626931081768651*r**16
            -17265206663397731*r**18+159581574824660288*r**20-151774077950463110*r**22
            -391230289820487534*r**24+235107959351671646*r**26+533358199716833914*r**28
            -395092738466913682*r**30-224453312731860570*r**32+197940297293808426*r**34
            -86783000253381979*r**36+7787556448392229*r**38-3080688158286687*r**40
            -499908056648905*r**42-57300985476599*r**44-6307373860189*r**46+72381547679*r**48
            +5970480233*r**50+122136390*r**52)-2*Q2**3*(161102400-6347450880*r**2
            -84922484170*r**4+4365762839580*r**6-27131773373739*r**8+308191782708419*r**10
            +2114852546989260*r**12-4230427232234070*r**14+37924474869063765*r**16
            -109136939251304769*r**18+238653685325399904*r**20+249725435321424320*r**22
            +31666620026466330*r**24+266123728591371750*r**26-92171523639775984*r**28
            -641166504761678676*r**30-25937617749023070*r**32+301308277003474230*r**34
            -327438347004761490*r**36+85557802479394356*r**38-27429166966880911*r**40
            +202724989019415*r**42-580465256879820*r**44-48971825264230*r**46-2040273529239*r**48
            +294065739*r**50+971321580*r**52)+2*Q2**2*(122852400-4809190080*r**2
            -24101303431*r**4+2067845244507*r**6-29005015064873*r**8+421083534057065*r**10
            +1396338587085021*r**12-4378670310165233*r**14+28778510318871597*r**16
            -81420859193776293*r**18+473696791366315440*r**20-324332190580253344*r**22
            -508855810273414938*r**24-177762973482546758*r**26+145286649145774442*r**28
            +1222260205020270990*r**30-877093378960591094*r**32-766505016646580778*r**34
            +809026445058302697*r**36-375404106333389013*r**38+61953149160299315*r**40
            -15694235360976339*r**42-1387163585495543*r**44-303323397773293*r**46
            -34794889714263*r**48-91827899585*r**50+26067037086*r**52+743624298*r**54))
            +384*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1318272*Q2**32*(160+241*r**4)
            -96*Q2**31*(38166880+22632800*r**2+63173527*r**4+62625055*r**6)+6*Q2**30*(4812673440
            +5894484800*r**2+4869446505*r**4+19435771042*r**6+8402742873*r**8)-4*Q2**29*(33681360480
            +64676182560*r**2-22219015819*r**4+111682897849*r**6+238977925539*r**8
            +60921256095*r**10)+2*Q2**28*(201757173600+555234271680*r**2-903577009295*r**4
            -1339882421208*r**6+1204790078124*r**8+2140530442212*r**10+362951382735*r**12)
            -2*Q2**27*(383259556800+1515739179840*r**2-5737936145037*r**4-17466310301934*r**6
            -16422763860642*r**8-1706006767660*r**10+5261085297783*r**12+622505329506*r**14)
            +2*Q2**26*(377926996560+2581349763600*r**2-23083338254547*r**4-93094562260609*r**6
            -155902376473978*r**8-147314499294038*r**10-49569230837105*r**12+4149157031643*r**14
            +291121437570*r**16)+Q2**25*(240600117120-4179840651840*r**2+130840585667709*r**4
            +650292337941092*r**6+1409331264475291*r**8+2024968462690822*r**10+1661492025116623*r**12
            +524524746756368*r**14+31872054144177*r**16+2595388320222*r**18)-2*Q2**24*(935864773200
            +1687847338800*r**2+129967207434885*r**4+809405806325895*r**6+2057562569221236*r**8
            +3645116829626129*r**10+4379328595559478*r**12+2887271377688025*r**14
            +719325571306160*r**16+59449920735735*r**18+3264856504425*r**20)+2*Q2**23*(1117114224000
            +7568194627200*r**2+162829540022980*r**4+1394679074185375*r**6+3922342045566263*r**8
            +7668184233795315*r**10+11293504304934199*r**12+11209718696429609*r**14
            +5957073416605265*r**16+1013273392766205*r**18+81626619737565*r**20+2564354764200*r**22)
            +2*Q2**22*(73453929600-10411182751200*r**2-66888676998445*r**4-1394699698409855*r**6
            -3716084421269563*r**8-6069072894784752*r**10-8306990814033978*r**12-10325100826019838*r**14
            -11355767656778834*r**16-5323855085569000*r**18-78680949328025*r**20-4464310487835*r**22
            +2481644760765*r**24)-6*Q2**21*(558781262400-1747450275200*r**2+58059998199215*r**4
            -827905735875*r**6+1016252192784018*r**8+5950819664660312*r**10+15258912620692040*r**12
            +24958444845780750*r**14+21836823818933006*r**16+8035564696953724*r**18
            +2183254989026705*r**20+822239261176525*r**22+52939446997800*r**24+2493869566500*r**26)
            +2*Q2**20*(1642760894400+6589951303200*r**2+364638601277345*r**4+2325666707219635*r**6
            +16399628354467650*r**8+75891725704053387*r**10+197852400264396333*r**12
            +364962735599664222*r**14+446635884285245796*r**16+312420783556790166*r**18
            +108767660534730795*r**20+27389464595066735*r**22+4340420558778730*r**24
            +226270974021855*r**26+5138395736535*r**28)+2*Q2**19*(349979102400-15963550353600*r**2
            -239858404618715*r**4-3417780250478865*r**6-25226298971656881*r**8-142245835585717329*r**10
            -410550148126761438*r**12-831742829204563164*r**14-1211982834476427426*r**16
            -1166442993581209482*r**18-641108302262492919*r**20-167445171217892753*r**22
            -34889827755202605*r**24-2012544313672005*r**26-41182717811280*r**28+4060773928350*r**30)
            +2*Q2**18*(-1951305282000+12717254564400*r**2-151056933680595*r**4+1740841775561580*r**6
            +15355935236586528*r**8+146544207608909080*r**10+473072827594998309*r**12
            +990206091415418484*r**14+1533284342509121544*r**16+1739012108471599056*r**18
            +1369729668713939439*r**20+551135850790512564*r**22+54153255430729824*r**24
            +6042235988029320*r**26-3855705233637185*r**28-242775463867380*r**30-9550706945400*r**32)
            +Q2**17*(2412876028800+5761769486400*r**2+776482590661155*r**4+2337109130260510*r**6
            +21070758774833179*r**8-72400668979091914*r**10-226380905842505641*r**12
            +54514475560503366*r**14+1222581511524342543*r**16+2969949024429119022*r**18
            +3044998295526099321*r**20+1499508073408637562*r**22+962896702537301569*r**24
            +480294774787530562*r**26+88259210368247885*r**28+13783641833050850*r**30
            +561063307738965*r**32+8492327829210*r**34)+2*Q2**16*(703495938000-16258939760400*r**2
            -201642393555405*r**4-2475761495011010*r**6-29843772152837734*r**8-136469113380792346*r**10
            -602002216038202120*r**12-2403326364495128006*r**14-6371653799541778446*r**16
            -12043884962563879782*r**18-15201518702580415722*r**20-11590411363273880190*r**22
            -5260759711360202546*r**24-1975390769813804758*r**26-434399078983989472*r**28
            -63351387049474810*r**30-2744108345820650*r**32-11625150064410*r**34+4917834666975*r**36)
            +4*Q2**15*(-661597084800+6465940099200*r**2-72080550205800*r**4+844028954736315*r**6
            +12038404534233555*r**8+112449381720321731*r**10+532112363253630999*r**12
            +2260131254430677283*r**14+6241249136136065195*r**16+12571441342641258555*r**18
            +18392359768802294487*r**20+18140995115877902073*r**22+10866896259273182265*r**24
            +3773150126259758985*r**26+1136883843180498293*r**28+113980015596130785*r**30
            +11376653267986185*r**32-1993433350395655*r**34-112872378044475*r**36
            -3374028640440*r**38)+2*Q2**14*(343295541600+2614946044800*r**2+231945663112825*r**4
            -434215984512680*r**6-2350339666411*r**8-141570893444124264*r**10-758575922543597468*r**12
            -4262496164083519768*r**14-12367863862856553412*r**16-25044746255304463656*r**18
            -38939494100296006386*r**20-44817969001039165592*r**22-35319246258950791778*r**24
            -14770573145054876152*r**26-2100611033092932588*r**28-375172476510469544*r**30
            +238194343320591452*r**32+38510995583213960*r**34+5479866601128705*r**36
            +169080032465280*r**38+1071778941525*r**40)+4*Q2**13*(284654508000-5881778061600*r**2
            -26751255546260*r**4-185546997213580*r**6-9111102333574451*r**8-10511945663574975*r**10
            +8442004765763502*r**12+838479211696480152*r**14+1723742320174237034*r**16
            -55951541458752956*r**18-5806675261933762426*r**20-12802168129056951752*r**22
            -13702071914000385052*r**24-9478856087498257346*r**26-7734934113203363958*r**28
            -4115453878194702216*r**30-1122302961821410218*r**32-231261599601856588*r**34
            -28125128638165610*r**36-622156759985020*r**38+17936889064815*r**40+1704007086825*r**42)
            -6*Q2**12*(156259826400-2134451792000*r**2+30290016730295*r**4-286291579217050*r**6
            -5089304450253584*r**8-35182782934883686*r**10-155978233209348899*r**12
            -435632953598258648*r**14-2811346752979088784*r**16-12492398377844413992*r**18
            -33497703115146742794*r**20-60532811441492877452*r**22-74375245148219155344*r**24
            -59288000050390225940*r**26-32107925734839305910*r**28-15054627977407595576*r**30
            -4110928079483810000*r**32-970901657625216264*r**34-75615464539311357*r**36
            -6581214677654730*r**38+834628382836000*r**40+38711117230890*r**42+812310248745*r**44)
            -2*Q2**11*(36441652800-2929741857600*r**2-66470653469495*r**4+856540519301780*r**6
            -187137394423056*r**8+87478992941487966*r**10+553234126968499395*r**12
            +3036308235661372662*r**14+13448566412443743504*r**16+52995033923574707400*r**18
            +144503119679868704346*r**20+278499206081712524080*r**22+393121054335300047936*r**24
            +388450557249512213508*r**26+244806776932374361974*r**28+101890504618080246228*r**30
            +41057993604760546320*r**32+4919067857756231592*r**34+1026222805171855053*r**36
            -134090474468514228*r**38-21827651736851600*r**40-2185664088226450*r**42
            -44143536692265*r**44+382636218150*r**46)+2*Q2**10*(206375502000-4973253421200*r**2
            +8216619056335*r**4+224381000071575*r**6-8571141301217970*r**8+45226323959367282*r**10
            +410449132626147993*r**12+2756836250545214775*r**14+8477709366759774354*r**16
            +34836580435779515544*r**18+89928758438352494742*r**20+155654491816559989438*r**22
            +220918332781507364652*r**24+253326959938113392172*r**26+202676588577873652050*r**28
            +69851765397468710166*r**30-3909398142862920396*r**32+2118328841847293928*r**34
            -5491790633593867221*r**36-1225467123475872309*r**38-233153057382012890*r**40
            -27458949313338510*r**42-76312316635515*r**44+28774629474195*r**46+1201818802410*r**48)
            +Q2**9*(-144005385600+2452787304000*r**2-51357267860685*r**4+796239358156800*r**6
            +8245293176869473*r**8-18806033551307038*r**10-166657531546680051*r**12
            -2221772269946034444*r**14-3747167754338389641*r**16-29382744213796918614*r**18
            -9963918522165804162*r**20+180631584605204471376*r**22+509206362627015473418*r**24
            +752298719068089860772*r**26+731133979713476966714*r**28+552537961654094320728*r**30
            +423552046445509154766*r**32+226636374309616595076*r**34+69553889415948594399*r**36
            +16427379970159999632*r**38+3417738945328024197*r**40+187224904946970234*r**42
            +14246177833106985*r**44-1640682770932780*r**46-59009065812405*r**48-761545335150*r**50)
            -2*Q2**8*(37879950000-1404304686000*r**2-5648558384505*r**4+419084641037755*r**6
            -2438117325200048*r**8+26523543639332285*r**10+215245547866765406*r**12
            +156088000639193721*r**14-179277391528337772*r**16-10577005672839376281*r**18
            +35984016673143884613*r**20+217779981162663173934*r**22+555758313483719143024*r**24
            +892501684226559448354*r**26+986592109743227027636*r**28+760777458617394755474*r**30
            +481133354166062374344*r**32+293935337618202047454*r**34+97390212328340964273*r**36
            +36384252882132414663*r**38+3507215894765741088*r**40+658358691123518641*r**42
            -35680580884731794*r**44-7778232635643835*r**46-409254878211820*r**48
            -2612061659685*r**50+237568419075*r**52)+2*Q2**7*(34041210240-1046573577600*r**2
            +5098381015164*r**4+81860583655435*r**6-2852797520405293*r**8+37951484353399463*r**10
            +208098163936305707*r**12+554648177300230345*r**14+1123967725709217105*r**16
            -1853065495629055515*r**18+47314197971849892117*r**20+168822797168443165350*r**22
            +419108746254035411998*r**24+677030789089958154566*r**26+820760353943580937454*r**28
            +715980772936115742482*r**30+318037555141034573314*r**32+128799315293010625482*r**34
            +135196058300609264838*r**36-6328521619649830041*r**38+9800275407359089983*r**40
            -1260359307255857981*r**42-336408548980745833*r**44-51447540883375819*r**46
            -6929919944388355*r**48+60812425330465*r**50+7398213390585*r**52+199263664344*r**54)
            -2*Q2**6*(2693280960-15166692000*r**2+2412031655559*r**4-112987648806225*r**6
            -60464631284571*r**8+14682842330315096*r**10+32883336557180970*r**12+793095018499024098*r**14
            +4040398762831912682*r**16+12354700307050578096*r**18+39167865819191515797*r**20
            +79575789620827930845*r**22+199731807094332359523*r**24+191422041695701535184*r**26
            +28296720698596960508*r**28-34619968191548863092*r**30-42794555441486524500*r**32
            -322802368285672196512*r**34-301752465659223201279*r**36-35608114822827915495*r**38
            -60363099262479763941*r**40-11997075616726232040*r**42-2285805270644218182*r**44
            -487335381435900622*r**46-18442441658962038*r**48-940049274598320*r**50
            +125301414409475*r**52+3223838750139*r**54+13118469885*r**56)-2*Q2**5*(6131987520
            -255902937600*r**2+613557801425*r**4+82501377774191*r**6-1039098752157506*r**8
            +8478535767484428*r**10+33559910257596932*r**12-741642915285632594*r**14
            -3578742865613605358*r**16-12505340557900149708*r**18-8262484554120691179*r**20
            -62017912387491589711*r**22-193895311502055631828*r**24-186908966523294281408*r**26
            +34838852711796033456*r**28+306170650927793867204*r**30+406005288860338995076*r**32
            +260293608500902899208*r**34+338846683167909550347*r**36+290511509841871317825*r**38
            +85758992334650585942*r**40+32626527801595315628*r**42+12628325477874946444*r**44
            +1129401003932534382*r**46+186010585856051594*r**48-976229459204540*r**50
            -1428591448907825*r**52-35266208323905*r**54+463234944096*r**56+37467427464*r**58)
            -18*(-1+r**2)**4*(924240-50842320*r**2+127580623*r**4+21761900616*r**6
            -480664481572*r**8+10266390561924*r**10-43495446234307*r**12-1045780743246652*r**14
            -1947879455998812*r**16-6371748332662292*r**18-6628888642707437*r**20
            -123568288434240972*r**22-1306703745964299272*r**24+2162657631176323288*r**26
            +5116282323917595713*r**28-5261152877609242392*r**30-4891476902179346792*r**32
            +4906219857799002248*r**34+1642704654022300973*r**36-800871344927523792*r**38
            +407887183524077708*r**40+92870184683027828*r**42+15184037118513063*r**44
            +7165412345449108*r**46+693857086279348*r**48+38068575153948*r**50+289501755313*r**52
            -448399681260*r**54+1544377952*r**56+262020720*r**58+5663259*r**60)+2*Q2**4*(2376792960
            -94083389280*r**2+597576331667*r**4+8410958237863*r**6-407865119356318*r**8
            +9385585366858431*r**10+4330465621984347*r**12-172208318975602446*r**14
            -358591107588730244*r**16-4008429163218636070*r**18+15162070425219243511*r**20
            -70167774975902743843*r**22-75572746023758079866*r**24-81399867181321430419*r**26
            -122603127814560674385*r**28-81796225272023056884*r**30-15655032380462594328*r**32
            -19794632176583732996*r**34+87217970392418568041*r**36+117330948576793102705*r**38
            -9327684539321599474*r**40+60436499768402166697*r**42-3611851334492335711*r**44
            +3420210969027407586*r**46+92084971826059740*r**48-27377111764819734*r**50
            -3337493381249843*r**52-778455230978773*r**54+8233910580298*r**56+680407456203*r**58
            +14380220565*r**60)+9*Q2*(-1+r**2)**2*(20065920-1074980160*r**2+4152670181*r**4
            +456385619064*r**6-9300571406036*r**8+148526388633810*r**10-469285330458339*r**12
            -16863050754761794*r**14-30424159326474384*r**16-58393528163545124*r**18
            -315994959958806399*r**20-855484507167123204*r**22-16388177631239698884*r**24
            +14196570052250289446*r**26+45404435208446732281*r**28-1689473999767342454*r**30
            -42801205392189870144*r**32-30890455343528861144*r**34+51639540656510477951*r**36
            +18582686276347155136*r**38-13206298184160399644*r**40+6525160560363560446*r**42
            +798010958289852711*r**44+211540451524354226*r**46+113673103113977936*r**48
            +10915937057847676*r**50+987611891010011*r**52+18101652855180*r**54-7999913444428*r**56
            -21835467318*r**58+4337401091*r**60+122136390*r**62)+6*Q2**3*(60772800
            -4403175360*r**2-8036406275*r**4+4951969791181*r**6-43957211248187*r**8
            -511564100459999*r**10+2123246285267928*r**12-88715272948414892*r**14
            -312553077847576258*r**16+82977967518993790*r**18-5116797195217854213*r**20
            +13959293508044503083*r**22-56267239863327377697*r**24-35577789541139775173*r**26
            +17346271050043892410*r**28-12955533395929701738*r**30-46202549621205407372*r**32
            -16828799307896492332*r**34+158806636175139665107*r**36+27715678913306155875*r**38
            -59718464473142569293*r**40+54080125238157971463*r**42-7923003131902615052*r**44
            +3095743893530419432*r**46+544160683159178670*r**48+69644693590318222*r**50
            +18189920115991253*r**52+550188754434373*r**54+9144218381961*r**56-2522737175683*r**58
            -42138127654*r**60+360639630*r**62)-6*Q2**2*(113610000-6075546480*r**2
            +28064366179*r**4+2841168958598*r**6-50045250718020*r**8+482811098433324*r**10
            -816707874402705*r**12-77651123112718374*r**14-123876072174836556*r**16
            +1163634441904824*r**18-2192725455040497801*r**20+3193512238904444534*r**22
            -62244142408855022036*r**24+45974548061766470244*r**26+84813324896557303779*r**28
            -35353941567851246886*r**30+44047265491428570564*r**32+3356094426077059104*r**34
            -162550509563549531751*r**36+131777060293594309794*r**38+87248451053305780724*r**40
            -79003599612145880396*r**42+34093116794794199709*r**44-736388261079067746*r**46
            +922016448779903004*r**48+494524642500587544*r**50+45766625051665869*r**52
            +7499314500186210*r**54+197256717772836*r**56-33815878562756*r**58-601744260655*r**60
            +12695773614*r**62+686991708*r**64))*sqrtq2)))/(51030000*r**4*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2
            +51030000*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))**2*sqrtq2+logq2**8*(4936942338048000000*r**36*(1
            +r**2)**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+4936942338048000000*r**36*(1
            +r**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2*(-7348320000*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4
            -Q2**3*(1+r**2)-2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4
            +r**6)+4*(1-9*r**2-44*r**4-9*r**6+r**8))-7348320000*(-Q2+(-1+r)**2)**3*r**8*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4-Q2**3*(1+r**2)
            -2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4+r**6)+4*(1-9*r**2
            -44*r**4-9*r**6+r**8))*sqrtq2)+logq2**7*(-109709829734400000*r**32*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**4+19*Q2**3*(1+r**2)
            -2*Q2**2*(13+22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2
            -13*r**2-38*r**4-13*r**6+2*r**8))-109709829734400000*r**32*(1+r**2)*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(4*Q2**4+19*Q2**3*(1
            +r**2)-2*Q2**2*(13+22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)
            +12*(2-13*r**2-38*r**4-13*r**6+2*r**8))*sqrtq2)+logq2**3*(-1763596800000*(
            -Q2+(-1+r)**2)**3*r**16*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8
            +68*Q2**7*(1+r**2)-Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2
            +683*r**4+169*r**6)+2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)
            +6*Q2**3*(31+230*r**2+159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(
            -131+1184*r**2+6523*r**4+8368*r**6+6523*r**8+1184*r**10-131*r**12)
            -9*Q2*(13+5*r**2-1493*r**4-5245*r**6-5245*r**8-1493*r**10+5*r**12
            +13*r**14)+36*(4-67*r**2-28*r**4+2331*r**6+5600*r**8+2331*r**10-28*r**12
            -67*r**14+4*r**16))-1763596800000*(-Q2+(-1+r)**2)**3*r**16*(1-Q2+r**2)*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)
            -Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2+683*r**4+169*r**6)
            +2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)+6*Q2**3*(31+230*r**2
            +159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4
            +8368*r**6+6523*r**8+1184*r**10-131*r**12)-9*Q2*(13+5*r**2-1493*r**4
            -5245*r**6-5245*r**8-1493*r**10+5*r**12+13*r**14)+36*(4-67*r**2-28*r**4
            +2331*r**6+5600*r**8+2331*r**10-28*r**12-67*r**14+4*r**16))*sqrtq2)
            +logq2**2*(440899200000*(-Q2+(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8-4*Q2**7*(1+r**2)-Q2**6*(57
            +50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4+5*r**6)+Q2**4*(85-226*r**2
            -1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1-54*r**2-143*r**4-143*r**6
            -54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4+3168*r**6+2871*r**8
            +468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4-2833*r**6-2833*r**8
            -565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4+4368*r**6+11718*r**8
            +4368*r**10-56*r**12-96*r**14+5*r**16))+440899200000*(-Q2+(-1+r)**2)**3*r**12*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8-4*Q2**7*(1+r**2)
            -Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4+5*r**6)+Q2**4*(85
            -226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1-54*r**2-143*r**4
            -143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4+3168*r**6+2871*r**8
            +468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4-2833*r**6-2833*r**8
            -565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4+4368*r**6+11718*r**8
            +4368*r**10-56*r**12-96*r**14+5*r**16))*sqrtq2)+logq2**5*(-152374763520000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219+310*r**2
            +219*r**4)-Q2**5*(977+2179*r**2+2179*r**4+977*r**6)+Q2**4*(590-2090*r**2
            -6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4-2073*r**6
            +10*r**8+243*r**10)+Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6+41127*r**8
            +8076*r**10-879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6+67125*r**8
            +31341*r**10+3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4+12789*r**6
            +25830*r**8+12789*r**10+28*r**12-573*r**14+41*r**16))-152374763520000*r**24*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219
            +310*r**2+219*r**4)-Q2**5*(977+2179*r**2+2179*r**4+977*r**6)+Q2**4*(590
            -2090*r**2-6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4
            -2073*r**6+10*r**8+243*r**10)+Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6
            +41127*r**8+8076*r**10-879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6
            +67125*r**8+31341*r**10+3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4
            +12789*r**6+25830*r**8+12789*r**10+28*r**12-573*r**14+41*r**16))*sqrtq2)
            +logq2**4*(31744742400000*r**20*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(32*Q2**8
            +104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)-24*Q2**5*(13+31*r**2
            +31*r**4+13*r**6)+Q2**4*(415-1180*r**2-4598*r**4-1180*r**6+415*r**8)
            +4*Q2**3*(102+155*r**2-677*r**4-677*r**6+155*r**8+102*r**10)+Q2**2*(
            -389+3526*r**2+18377*r**4+25852*r**6+18377*r**8+3526*r**10-389*r**12)
            -12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8-1133*r**10-55*r**12
            +18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6+53690*r**8+24556*r**10
            -168*r**12-892*r**14+59*r**16))+31744742400000*r**20*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)
            -24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415-1180*r**2-4598*r**4
            -1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4-677*r**6+155*r**8
            +102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6+18377*r**8
            +3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8
            -1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6
            +53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))*sqrtq2)+logq2**6*(609499054080000*r**28*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(16*Q2**8+332*Q2**7*(1
            +r**2)+Q2**6*(153+370*r**2+153*r**4)-Q2**5*(2011+4817*r**2+4817*r**4
            +2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4-2410*r**6+295*r**8)+6*Q2**3*(559
            -310*r**2-4869*r**4-4869*r**6-310*r**8+559*r**10)-3*Q2**2*(479-4496*r**2
            -22867*r**4-35272*r**6-22867*r**8-4496*r**10+479*r**12)-9*Q2*(187
            -865*r**2-5807*r**4-10315*r**6-10315*r**8-5807*r**10-865*r**12+187*r**14)
            +9*(109-1432*r**2+392*r**4+26376*r**6+49910*r**8+26376*r**10+392*r**12
            -1432*r**14+109*r**16))+609499054080000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(16*Q2**8+332*Q2**7*(1+r**2)+Q2**6*(153+370*r**2+153*r**4)
            -Q2**5*(2011+4817*r**2+4817*r**4+2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4
            -2410*r**6+295*r**8)+6*Q2**3*(559-310*r**2-4869*r**4-4869*r**6-310*r**8
            +559*r**10)-3*Q2**2*(479-4496*r**2-22867*r**4-35272*r**6-22867*r**8
            -4496*r**10+479*r**12)-9*Q2*(187-865*r**2-5807*r**4-10315*r**6-10315*r**8
            -5807*r**10-865*r**12+187*r**14)+9*(109-1432*r**2+392*r**4+26376*r**6
            +49910*r**8+26376*r**10+392*r**12-1432*r**14+109*r**16))*sqrtq2))+((4*(Q2
            -(-1+r)**2)**4*r**4*(1-Q2+r**2)*(Q2-(1+r)**2)**4*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(-92*Q2**18-60*Q2**17*(1+r**2)+4*Q2**16*(
            -1499-3228*r**2+1519*r**4)+Q2**15*(72623+1046341*r**2+160589*r**4-34969*r**6)
            +Q2**14*(-299825-8852676*r**2-10808350*r**4-776500*r**6+94735*r**8)
            +Q2**13*(576101+29535579*r**2+82368756*r**4+43289452*r**6+1877655*r**8
            -135799*r**10)+Q2**12*(-381315-38482536*r**2-239240429*r**4-277504064*r**6
            -79598981*r**8-2114840*r**10+76245*r**12)+Q2**11*(-493297-20511955*r**2
            +237317447*r**4+530987613*r**6+387002253*r**8+41680119*r**10-50819*r**12
            +56927*r**14)+Q2**10*(1074711+122446116*r**2+261376636*r**4+280696044*r**6
            +60797850*r**8-63891428*r**10+87830460*r**12+2723028*r**14-101673*r**16)
            -Q2**9*(341275+112792173*r**2+851014790*r**4+2103692810*r**6+3429691340*r**8
            +1396512740*r**10+436523258*r**12+153045270*r**14+1716825*r**16+9295*r**18)
            +Q2**8*(-889251-54890208*r**2+590459833*r**4+1670586336*r**6+6297176130*r**8
            +4841499376*r**10+1065281922*r**12+528837568*r**14+37227201*r**16-2320560*r**18
            +120549*r**20)+Q2**7*(994085+168225927*r**2+357891963*r**4+1950721473*r**6
            -778030638*r**8+777200710*r**10+1046459542*r**12+511955778*r**14-340834967*r**16
            +105058067*r**18+3712335*r**20-89635*r**22)-Q2**6*(70043+76673404*r**2
            +764189182*r**4+3289645276*r**6+8434570341*r**8+17554642744*r**10+19515767172*r**12
            +5395152088*r**14+193046501*r**16-158583284*r**18+89263870*r**20+875276*r**22
            +10907*r**24)+Q2**5*(-508441-63392055*r**2+323302736*r**4-37241456*r**6
            +8386679415*r**8+12693116089*r**10+39203740728*r**12+16900419912*r**14
            +1763653493*r**16-848638885*r**18+178260472*r**20-9932888*r**22-1674323*r**24
            +48803*r**26)+Q2**4*(316975+76375224*r**2+131177365*r**4+2445366560*r**6
            -714459345*r**8+20178975160*r**10-29566065683*r**12-14255612160*r**14
            -701297035*r**16+975854760*r**18+224047815*r**20-417821216*r**22+41907245*r**24
            +1300200*r**26-21065*r**28)+Q2**3*(9117-14144121*r**2-170056239*r**4
            -1061850213*r**6-3845099135*r**8-26031776957*r**10+12379537797*r**12
            -4354598937*r**14+11620863591*r**16+3295991205*r**18+152368323*r**20
            +570114849*r**22+193648251*r**24-13345903*r**26+7655*r**28-5283*r**30)
            +Q2**2*(-84335-15657956*r**2+57506816*r**4-600798684*r**6+3037842044*r**8
            -3267499140*r**10+12997085632*r**12-6908662492*r**14-18283866522*r**16
            -18885157708*r**18-2821795840*r**20-279101876*r**22-403896324*r**24+108011956*r**26
            -5478336*r**28-391060*r**30+7825*r**32)-3*Q2*(-11737-3122007*r**2+2026122*r**4
            -191370746*r**6+336016054*r**8-4793498550*r**10+15426377970*r**12-23365152962*r**14
            +7896633092*r**16+2428061692*r**18-53763714*r**20+2180654706*r**22+134272058*r**24
            -35892346*r**26+40213254*r**28-1384374*r**30-59419*r**32+907*r**34)
            +3*(-1631-528384*r**2-60287*r**4-41405248*r**6+39342620*r**8-1532131152*r**10
            +8274408172*r**12-29995134624*r**14+52589566534*r**16-43249613040*r**18
            +13813606422*r**20-1374664192*r**22+1391081884*r**24+82272976*r**26-6254580*r**28
            +9760736*r**30-237471*r**32-8848*r**34+113*r**36))-4*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**4*(736*Q2**22-164*Q2**21*(1+r**2)-8*Q2**20*(
            -5863-12830*r**2+6209*r**4)+20*Q2**19*(-31155-425321*r**2-66795*r**4
            +16107*r**6)+Q2**18*(2865445+78570100*r**2+94911790*r**4+6983140*r**6
            -959675*r**8)+2*Q2**17*(-3090527-146667235*r**2-398849530*r**4-210439090*r**6
            -9181315*r**8+743353*r**10)+Q2**16*(4784571+456317406*r**2+2671394545*r**4
            +3089930340*r**6+881714845*r**8+22144926*r**10-810729*r**12)-4*Q2**15*(
            -1497871-28555120*r**2+881680183*r**4+1965172890*r**6+1340268435*r**8
            +150861544*r**10-764215*r**12+262898*r**14)+20*Q2**14*(-777440-72542542*r**2
            -92556030*r**4+99985982*r**6+243169743*r**8+115760126*r**10-50476392*r**12
            -2025190*r**14+93439*r**16)-20*Q2**13*(-310787-83141990*r**2-589236664*r**4
            -1353719658*r**6-2135860308*r**8-949127860*r**10-325781616*r**12-111635934*r**14
            -1456929*r**16+3010*r**18)-4*Q2**12*(-3717974-161712590*r**2+3072315480*r**4
            +11567244990*r**6+35914992495*r**8+33297080804*r**10+10276258125*r**12
            +2963189550*r**14+181465215*r**16-9331010*r**18+535171*r**20)+4*Q2**11*(
            -4577651-704045446*r**2-817140815*r**4+199576200*r**6+35195915610*r**8
            +60171084836*r**10+34993132166*r**12+6025344060*r**14+1921351425*r**16
            -488043590*r**18-16519711*r**20+407524*r**22)+2*Q2**10*(-453063+710194160*r**2
            +8757214614*r**4+35911777560*r**6+62067170885*r**8+45037217288*r**10
            +42152523300*r**12+13582344856*r**14+8079031035*r**16+769342920*r**18
            +982978502*r**20+4140240*r**22+318279*r**24)-20*Q2**9*(-711370-80244697*r**2
            +609463880*r**4+3127531220*r**6+21145306736*r**8+39234036757*r**10+66187424212*r**12
            +33881513380*r**14+9461408242*r**16+1516769741*r**18+477432212*r**20
            -18798472*r**22-2452840*r**24+71399*r**26)+10*Q2**8*(-689969-193942990*r**2
            -424346443*r**4-2381844544*r**6+29984342153*r**8+63840564102*r**10+247458855871*r**12
            +211406379568*r**14+56616655057*r**16+14544085038*r**18+1130956499*r**20
            +974323856*r**22-141045673*r**24-2995558*r**26+34105*r**28)+4*Q2**7*(
            -1046331-6986640*r**2+2807960255*r**4+15990252690*r**6+46982782425*r**8
            +153500580376*r**10-188817996105*r**12-275486365090*r**14-90227215265*r**16
            +32352779520*r**18-8891096539*r**20+1129268990*r**22+25783395*r**24+99348440*r**26
            -3890235*r**28+134514*r**30)-4*Q2**6*(-1173194-240196814*r**2+1251959810*r**4
            +5397166830*r**6+103684435335*r**8+261962637994*r**10+766724823704*r**12
            +1062373628990*r**14+1154903353125*r**16+408055557590*r**18+48795009914*r**20
            -8104054886*r**22-352771815*r**24+1997881230*r**26-111293140*r**28-5272454*r**30
            +90181*r**32)-4*Q2**5*(58454+83498785*r**2+614729268*r**4+5070769690*r**6
            -36966938670*r**8-3750177844*r**10-1012961279940*r**12-1126798664758*r**14
            -2738316873530*r**16-1452661624970*r**18-256778954884*r**20+27021416430*r**22
            +200219702*r**24+1335602940*r**26-1080609260*r**28+69513774*r**30+391900*r**32
            +10913*r**34)+20*Q2**4*(-64150-10201334*r**2+170253080*r**4+868557006*r**6
            +6742984043*r**8+30911507896*r**10-24296863191*r**12+240878254290*r**14
            -436852355289*r**16-224241654616*r**18-32699137687*r**20+11810540434*r**22
            -102549015*r**24-4461509120*r**26-256539277*r**28+103644366*r**30-1921509*r**32
            -314730*r**34+5603*r**36)-60*Q2**3*(-7298-2356125*r**2+14112094*r**4
            +25594681*r**6+1948299344*r**8+3742305372*r**10+42030495588*r**12+106763697016*r**14
            -38359259308*r**16+4704403122*r**18-20489197320*r**20-15646171846*r**22
            -2286272464*r**24-2296093892*r**26-1105706196*r**28-139231104*r**30+38480558*r**32
            -1103021*r**34-37606*r**36+405*r**38)-3*Q2**2*(-37707-1803140*r**2+174530430*r**4
            +898532540*r**6-1342331595*r**8+40098187648*r**10-472408852040*r**12
            +732358578880*r**14-1851832881590*r**16+755144441880*r**18+1949622466788*r**20
            +2451613456600*r**22+468178935250*r**24+141108574560*r**26+24588920600*r**28
            -5614189792*r**30+58556705*r**32-15667060*r**34+3126990*r**36-230260*r**38
            +4313*r**40)+18*Q2*(-5053-1223623*r**2+20533810*r**4+54414010*r**6
            +1186756135*r**8+4984570817*r**10+14488694192*r**12+155239831440*r**14
            -668805592610*r**16+1075475371290*r**18-157435300988*r**20-367116721868*r**22
            +63624780190*r**24-108715887310*r**26-12536987360*r**28+1272858112*r**30
            -1583713473*r**32-178447315*r**34+26348410*r**36-248190*r**38-31013*r**40
            +397*r**42)-9*(-1631-505550*r**2+7490403*r**4+9129700*r**6+632078815*r**8
            +1809481114*r**10+26605651205*r**12-2408722672*r**14-283783738150*r**16
            +1922665264580*r**18-3895904772306*r**20+3104449405560*r**22-619758474002*r**24
            -126814542300*r**26-98860868230*r**28-28486145456*r**30+690302965*r**32
            -744356342*r**34-120458625*r**36+13915460*r**38-124221*r**40-10430*r**42
            +113*r**44))*sqrtq2+logq2**6*(-2351462400000*(-Q2+(-1+r)**2)*(-1+r)*r**28*(1
            +r)*(1+r**2)*(1-Q2+r**2)*(-1+4*r**2+r**4)*(-Q2+(1+r)**2)-2351462400000*r**28*(1
            -4*r**2-2*r**4+4*r**6+r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**5*(-3732480000*r**22*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-70*Q2**7*(1
            +r**2)+10*Q2**6*(53+76*r**2+23*r**4)+10*Q2**5*(-157-305*r**2-125*r**4
            +23*r**6)+Q2**4*(2266+5806*r**2+2778*r**4-2702*r**6-1716*r**8)+4*Q2**3*(
            -326-1372*r**2-554*r**4+1744*r**6+1663*r**8+411*r**10)+2*Q2**2*(-337
            +595*r**2+664*r**4-3032*r**6-4453*r**8-853*r**10+612*r**12)-3*Q2*(
            -452-645*r**2+498*r**4+735*r**6-1068*r**8-1047*r**10+1022*r**12+957*r**14)
            +3*(-178-291*r**2+985*r**4-989*r**6-4321*r**8+1587*r**10+2175*r**12
            +589*r**14+443*r**16))-3732480000*r**22*(70*Q2**10*(1+r**2)-20*Q2**9*(37
            +59*r**2+22*r**4)+10*Q2**8*(337+727*r**2+457*r**4+67*r**6)+2*Q2**7*(
            -4318-11503*r**2-9669*r**4-1549*r**6+823*r**8)-14*Q2**6*(-953-3016*r**2
            -2962*r**4-268*r**6+1149*r**8+518*r**10)+2*Q2**5*(-5803-22498*r**2
            -23907*r**4+4218*r**6+24989*r**8+18326*r**10+4543*r**12)-5*Q2**4*(-560
            -4445*r**2-5058*r**4+4211*r**6+14272*r**8+13389*r**10+4522*r**12+21*r**14)
            +3*(-1+r**2)**3*(178+647*r**2-47*r**4-43*r**6+5267*r**8+8001*r**10
            +4239*r**12+1475*r**14+443*r**16)-2*Q2**3*(-2660-2170*r**2+699*r**4
            -8606*r**6-23613*r**8-20598*r**10-9419*r**12+5950*r**14+5985*r**16)
            +2*Q2**2*(-3172-5437*r**2+1801*r**4-2747*r**6-25745*r**8-9615*r**10
            +16467*r**12+10887*r**14+10649*r**16+6912*r**18)-6*Q2*(-493-711*r**2
            +1717*r**4-720*r**6-7466*r**8-3532*r**10+304*r**12+5396*r**14+3003*r**16
            +1359*r**18+1143*r**20))*sqrtq2)+logq2**4*(-10368000*r**18*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1120*Q2**11-40*Q2**10*(463+343*r**2)
            +20*Q2**9*(5598+9401*r**2+3579*r**4)-16*Q2**8*(21419+57837*r**2+47750*r**4
            +12476*r**6)+4*Q2**7*(135368+544057*r**2+709339*r**4+391017*r**6+78047*r**8)
            -Q2**6*(272832+2291461*r**2+4400212*r**4+3800814*r**6+1567540*r**8+266133*r**10)
            +2*Q2**5*(-220528+6795*r**2+480911*r**4+1039682*r**6+1140282*r**8+361111*r**10
            +74123*r**12)+Q2**4*(756560+2200635*r**2+5369086*r**4+5468913*r**6-1950140*r**8
            -3762451*r**10-661490*r**12-127225*r**14)+12*Q2**3*(-23848-145619*r**2
            -506372*r**4-699975*r**6+339684*r**8+1039559*r**10+509668*r**12+81095*r**14
            +5208*r**16)+3*Q2**2*(-70584+97119*r**2+176040*r**4+877892*r**6-1061288*r**8
            -5155610*r**10-3159048*r**12+140156*r**14-42016*r**16+32539*r**18)-18*Q2*(
            -11924-8467*r**2-169481*r**4-118784*r**6+250860*r**8-65590*r**10-448558*r**12
            +140416*r**14+390024*r**16+34505*r**18+6999*r**20)+9*(-5856-4915*r**2
            -171594*r**4-14467*r**6+228240*r**8-520586*r**10-393676*r**12+95334*r**14
            +330832*r**16+417725*r**18+34582*r**20+4381*r**22))-10368000*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1120*Q2**11-40*Q2**10*(463+343*r**2)
            +20*Q2**9*(5598+9401*r**2+3579*r**4)-16*Q2**8*(21419+57837*r**2+47750*r**4
            +12476*r**6)+4*Q2**7*(135368+544057*r**2+709339*r**4+391017*r**6+78047*r**8)
            -Q2**6*(272832+2291461*r**2+4400212*r**4+3800814*r**6+1567540*r**8+266133*r**10)
            +2*Q2**5*(-220528+6795*r**2+480911*r**4+1039682*r**6+1140282*r**8+361111*r**10
            +74123*r**12)+Q2**4*(756560+2200635*r**2+5369086*r**4+5468913*r**6-1950140*r**8
            -3762451*r**10-661490*r**12-127225*r**14)+12*Q2**3*(-23848-145619*r**2
            -506372*r**4-699975*r**6+339684*r**8+1039559*r**10+509668*r**12+81095*r**14
            +5208*r**16)+3*Q2**2*(-70584+97119*r**2+176040*r**4+877892*r**6-1061288*r**8
            -5155610*r**10-3159048*r**12+140156*r**14-42016*r**16+32539*r**18)-18*Q2*(
            -11924-8467*r**2-169481*r**4-118784*r**6+250860*r**8-65590*r**10-448558*r**12
            +140416*r**14+390024*r**16+34505*r**18+6999*r**20)+9*(-5856-4915*r**2
            -171594*r**4-14467*r**6+228240*r**8-520586*r**10-393676*r**12+95334*r**14
            +330832*r**16+417725*r**18+34582*r**20+4381*r**22))*sqrtq2)+logq2**3*(
            -691200*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(6040*Q2**14-40*Q2**13*(1717
            +1594*r**2)+6*Q2**12*(56105+105627*r**2+47066*r**4)-4*Q2**11*(218475
            +672236*r**2+615914*r**4+166353*r**6)+4*Q2**10*(277725+1486603*r**2
            +2160818*r**4+1233470*r**6+213954*r**8)-30*Q2**9*(2091+203128*r**2+406142*r**4
            +373524*r**6+159933*r**8+17658*r**10)+10*Q2**8*(-179709-127157*r**2
            -729770*r**4-1318228*r**6-406781*r**8+81919*r**10+8730*r**12)+Q2**7*(2134140
            +10896361*r**2+49318958*r**4+108457305*r**6+93813080*r**8+30766055*r**10
            +2215166*r**12+14103*r**14)-3*Q2**6*(75900+3683359*r**2+18606971*r**4
            +63097297*r**6+84376685*r**8+48168485*r**10+11650609*r**12+359211*r**14
            +43947*r**16)+Q2**5*(-1426600+1054561*r**2-10443884*r**4+86498170*r**6
            +222991528*r**8+205266820*r**10+79196236*r**12+14503246*r**14+154480*r**16
            +417443*r**18)-5*Q2**4*(-216038-1284133*r**2-13610857*r**4-21608978*r**6
            -16436874*r**8+7836032*r**10+22070188*r**12+7263066*r**14+1535816*r**16
            +403917*r**18+69205*r**20)-15*Q2**3*(1232+306323*r**2+2630070*r**4+9309725*r**6
            +15167456*r**8+5812862*r**10-16901308*r**12-16774294*r**14-4963312*r**16
            -654129*r**18-157626*r**20+2201*r**22)+3*Q2**2*(-106840+24359*r**2-4344493*r**4
            +16724055*r**6+16613515*r**8+4616870*r**10-94138698*r**12-138715514*r**14
            -37514770*r**16-9244205*r**18+1108055*r**20-26301*r**22+59967*r**24)
            -9*Q2*(-16650-118219*r**2-2159316*r**4+469828*r**6-11255590*r**8-1175335*r**10
            +9829088*r**12-23727088*r**14-5724286*r**16+27575015*r**18+4956660*r**20
            +1226156*r**22+110254*r**24+9483*r**26)+9*(-2450-36197*r**2-559757*r**4
            +12580*r**6-6265906*r**8-2125205*r**10+7941439*r**12+3066584*r**14-20073990*r**16
            -4372743*r**18+19012105*r**20+2888708*r**22+471498*r**24+41985*r**26
            +1349*r**28))+691200*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(6040*Q2**15
            -40*Q2**14*(1868+1745*r**2)+Q2**13*(405310+766202*r**2+346156*r**4)
            -2*Q2**12*(605265+1829668*r**2+1689907*r**4+473904*r**6)+4*Q2**11*(496200
            +2377314*r**2+3448968*r**4+2015737*r**6+380307*r**8)-2*Q2**10*(586815
            +6575576*r**2+13386972*r**4+12391436*r**6+5293843*r**8+692778*r**10)
            +20*Q2**9*(-86718+244250*r**2+549020*r**4+510385*r**6+596795*r**8+307346*r**10
            +30852*r**12)+Q2**8*(3931230+13965021*r**2+57888228*r**4+128937285*r**6
            +111063170*r**8+34014675*r**10+1308676*r**12-73197*r**14)-2*Q2**7*(1180920
            +12040289*r**2+58018116*r**4+173534077*r**6+227700220*r**8+134542295*r**10
            +33966524*r**12+1653451*r**14+72972*r**16)+2*Q2**6*(-599450+6166169*r**2
            +28213553*r**4+165805487*r**6+332706737*r**8+301451165*r**10+129326759*r**12
            +25266353*r**14+681977*r**16+274642*r**18)-2*Q2**5*(-1253395-3396352*r**2
            -38721804*r**4-15995302*r**6+113652664*r**8+233719254*r**10+197406998*r**12
            +65007406*r**14+11168403*r**16+1295754*r**18+381734*r**20)+10*Q2**4*(
            -109867-1209570*r**2-11392600*r**4-31574505*r**6-41774110*r**8-13019714*r**10
            +40305072*r**12+39828068*r**14+11844409*r**16+1951060*r**18+473000*r**20
            +31301*r**22)+6*Q2**3*(-50340+781067*r**2+5168736*r**4+38211515*r**6
            +69499710*r**8+54759230*r**10-74790464*r**12-153546762*r**14-73101400*r**16
            -18665705*r**18-1475360*r**20-401713*r**22+35486*r**24)-6*Q2**2*(-78395
            -218569*r**2-5399041*r**4+6894523*r**6-214600*r**8+8852190*r**10-30017282*r**12
            -152017738*r**14-96701571*r**16+17983035*r**18+3366915*r**20+2380111*r**22
            +182214*r**24+44208*r**26)+18*Q2*(-9550-85533*r**2-1418646*r**4-838454*r**6
            -8525834*r**8-7278065*r**10+8297596*r**12-5415708*r**14-24762682*r**16
            +8738993*r**18+25771890*r**20+4535762*r**22+903954*r**24+80861*r**26
            +5416*r**28)-9*(-2450-38647*r**2-595954*r**4-547177*r**6-6253326*r**8
            -8391111*r**10+5816234*r**12+11008023*r**14-17007406*r**16-24446733*r**18
            +14639362*r**20+21900813*r**22+3360206*r**24+513483*r**26+43334*r**28
            +1349*r**30))*sqrtq2)+logq2**2*(2880*r**10*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-104480*Q2**17+8*Q2**16*(150101+135817*r**2)-8*Q2**15*(709791
            +1424108*r**2+609837*r**4)+8*Q2**14*(1670155+6164498*r**2+5665821*r**4
            +1497790*r**6)-8*Q2**13*(1570775+13279952*r**2+19627106*r**4+11807174*r**6
            +2052205*r**8)+Q2**12*(-10951320+87823939*r**2+170092020*r**4+162375498*r**6
            +97625268*r**8+9276675*r**10)+4*Q2**11*(9892734+24693229*r**2+97819623*r**4
            +176570458*r**6+72594868*r**8-2378739*r**10+1841403*r**12)-2*Q2**10*(14469828
            +157336027*r**2+716700482*r**4+1881190105*r**6+1698206280*r**8+514798421*r**10
            +50180850*r**12+9261111*r**14)+4*Q2**9*(-4846770+63361633*r**2+350439261*r**4
            +1673827605*r**6+2375510525*r**8+1352556375*r**10+271078323*r**12+32232891*r**14
            +3352365*r**16)+Q2**8*(42913400+92962057*r**2+691377336*r**4-3114119876*r**6
            -7327078400*r**8-6371797290*r**10-2654978408*r**12-290389124*r**14-88671816*r**16
            +2729705*r**18)-8*Q2**7*(1878665+40114391*r**2+317972780*r**4+853863832*r**6
            +1861043472*r**8+2719556390*r**10+1492747966*r**12+266907120*r**14+15127487*r**16
            -4971133*r**18+1747270*r**20)+4*Q2**6*(-4119774+46067315*r**2+372895044*r**4
            +2848468779*r**6+8332675944*r**8+17957269110*r**10+16113018636*r**12
            +5851481694*r**14+603032454*r**16-23073081*r**18+4677472*r**20+2456967*r**22)
            +8*Q2**5*(1935887+8467725*r**2+106568217*r**4-511036475*r**6-1198700610*r**8
            -7844229138*r**10-11704337214*r**12-6396000186*r**14-1468763325*r**16
            -7450835*r**18-13472499*r**20-8600451*r**22+229304*r**24)+Q2**4*(-1225160
            -129316891*r**2-1370532012*r**4-4735543390*r**6-29611067900*r**8-17453038725*r**10
            +25962685992*r**12+35736518844*r**14+12054143520*r**16+2269446875*r**18
            +565030660*r**20+529648674*r**22+55416868*r**24-6068155*r**26)+12*Q2**3*(
            -289850+3480307*r**2+28949801*r**4+407821914*r**6+2161639620*r**8+4346643205*r**10
            +2935005991*r**12-1521190932*r**14-4694349898*r**16-2459787075*r**18
            -449400505*r**20-148392198*r**22-26994944*r**24-109941*r**26+174505*r**28)
            +6*Q2**2*(229020+2918719*r**2+45159970*r**4-109686807*r**6+502957768*r**8
            -4526104505*r**10-1116035738*r**12+4310241465*r**14+14975348124*r**16
            +11119907829*r**18+4091115470*r**20+16192019*r**22+102589440*r**24-17811067*r**26
            -3931222*r**28+189515*r**30)-36*Q2*(518+420867*r**2+5163363*r**4+25195443*r**6
            +286607943*r**8-372775221*r**10+820620947*r**12+27232299*r**14+475970739*r**16
            +1089967489*r**18-1711459887*r**20-451164495*r**22-176564787*r**24-14409807*r**26
            -4452807*r**28-379535*r**30+26931*r**32)+9*(-5568+332527*r**2+3686336*r**4
            +36352440*r**6+329849160*r**8-686961996*r**10+3464268304*r**12+268700232*r**14
            -8182983880*r**16+4018542330*r**18+8304862496*r**20-5770391864*r**22
            -1430620872*r**24-319818060*r**26-30912240*r**28-4639432*r**30-281592*r**32
            +21679*r**34))-2880*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17
            -8*Q2**16*(150101+135817*r**2)+8*Q2**15*(709791+1424108*r**2+609837*r**4)
            -8*Q2**14*(1670155+6164498*r**2+5665821*r**4+1497790*r**6)+8*Q2**13*(1570775
            +13279952*r**2+19627106*r**4+11807174*r**6+2052205*r**8)-Q2**12*(-10951320
            +87823939*r**2+170092020*r**4+162375498*r**6+97625268*r**8+9276675*r**10)
            -4*Q2**11*(9892734+24693229*r**2+97819623*r**4+176570458*r**6+72594868*r**8
            -2378739*r**10+1841403*r**12)+2*Q2**10*(14469828+157336027*r**2+716700482*r**4
            +1881190105*r**6+1698206280*r**8+514798421*r**10+50180850*r**12+9261111*r**14)
            -4*Q2**9*(-4846770+63361633*r**2+350439261*r**4+1673827605*r**6+2375510525*r**8
            +1352556375*r**10+271078323*r**12+32232891*r**14+3352365*r**16)+Q2**8*(
            -42913400-92962057*r**2-691377336*r**4+3114119876*r**6+7327078400*r**8
            +6371797290*r**10+2654978408*r**12+290389124*r**14+88671816*r**16-2729705*r**18)
            +8*Q2**7*(1878665+40114391*r**2+317972780*r**4+853863832*r**6+1861043472*r**8
            +2719556390*r**10+1492747966*r**12+266907120*r**14+15127487*r**16-4971133*r**18
            +1747270*r**20)-4*Q2**6*(-4119774+46067315*r**2+372895044*r**4+2848468779*r**6
            +8332675944*r**8+17957269110*r**10+16113018636*r**12+5851481694*r**14
            +603032454*r**16-23073081*r**18+4677472*r**20+2456967*r**22)-8*Q2**5*(1935887
            +8467725*r**2+106568217*r**4-511036475*r**6-1198700610*r**8-7844229138*r**10
            -11704337214*r**12-6396000186*r**14-1468763325*r**16-7450835*r**18-13472499*r**20
            -8600451*r**22+229304*r**24)+Q2**4*(1225160+129316891*r**2+1370532012*r**4
            +4735543390*r**6+29611067900*r**8+17453038725*r**10-25962685992*r**12
            -35736518844*r**14-12054143520*r**16-2269446875*r**18-565030660*r**20
            -529648674*r**22-55416868*r**24+6068155*r**26)-12*Q2**3*(-289850+3480307*r**2
            +28949801*r**4+407821914*r**6+2161639620*r**8+4346643205*r**10+2935005991*r**12
            -1521190932*r**14-4694349898*r**16-2459787075*r**18-449400505*r**20-148392198*r**22
            -26994944*r**24-109941*r**26+174505*r**28)-6*Q2**2*(229020+2918719*r**2
            +45159970*r**4-109686807*r**6+502957768*r**8-4526104505*r**10-1116035738*r**12
            +4310241465*r**14+14975348124*r**16+11119907829*r**18+4091115470*r**20
            +16192019*r**22+102589440*r**24-17811067*r**26-3931222*r**28+189515*r**30)
            +36*Q2*(518+420867*r**2+5163363*r**4+25195443*r**6+286607943*r**8-372775221*r**10
            +820620947*r**12+27232299*r**14+475970739*r**16+1089967489*r**18-1711459887*r**20
            -451164495*r**22-176564787*r**24-14409807*r**26-4452807*r**28-379535*r**30
            +26931*r**32)-9*(-5568+332527*r**2+3686336*r**4+36352440*r**6+329849160*r**8
            -686961996*r**10+3464268304*r**12+268700232*r**14-8182983880*r**16+4018542330*r**18
            +8304862496*r**20-5770391864*r**22-1430620872*r**24-319818060*r**26-30912240*r**28
            -4639432*r**30-281592*r**32+21679*r**34))*sqrtq2)+logq2*(-96*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(54928*Q2**20-10*Q2**19*(66179+80571*r**2)
            +10*Q2**18*(315743+932826*r**2+454635*r**4)-10*Q2**17*(713027+4156451*r**2
            +4810467*r**4+1276291*r**6)+10*Q2**16*(491705+8279349*r**2+16884235*r**4
            +11757431*r**6+1673240*r**8)+2*Q2**15*(5923559-13876615*r**2-57271710*r**4
            -97945590*r**6-59156055*r**8+291279*r**10)-10*Q2**14*(2857988+19669647*r**2
            +75147541*r**4+120967604*r**6+44188566*r**8+6569403*r**10+3179247*r**12)
            +5*Q2**13*(2563602+71427359*r**2+416413088*r**4+1214635191*r**6+1097862886*r**8
            +332390965*r**10+60642984*r**12+6433205*r**14)+5*Q2**12*(5847972-19839849*r**2
            -287234445*r**4-2048826147*r**6-3137405283*r**8-1861102247*r**10-397686891*r**12
            -57953133*r**14+2841111*r**16)-10*Q2**11*(4072315+38356662*r**2+224264136*r**4
            -228097682*r**6-915369848*r**8-907956088*r**10-505111764*r**12-54829074*r**14
            -926967*r**16+4707430*r**18)+4*Q2**10*(307307+110393910*r**2+1170745425*r**4
            +4434888910*r**6+10006163165*r**8+15640213853*r**10+7814017520*r**12
            +1470662320*r**14+319685970*r**16+57863495*r**18+4510077*r**20)+5*Q2**9*(6524726
            +1654389*r**2-332977536*r**4-5253633789*r**6-16668936056*r**8-42558233486*r**10
            -38209590004*r**12-12439153626*r**14-2195790494*r**16-368681911*r**18
            -46755564*r**20+5179239*r**22)-5*Q2**8*(3840512+64911899*r**2+635093811*r**4
            -1309794993*r**6-4893941093*r**8-44191072906*r**10-64772250554*r**12
            -34209666554*r**14-6195004898*r**16-1286268433*r**18-197781337*r**20
            -9929301*r**22+4790695*r**24)-10*Q2**7*(878591-18460977*r**2-352827146*r**4
            -1980677810*r**6-9160838453*r**8-8905623285*r**10-7245547460*r**12-10083900548*r**14
            -4237010291*r**16-1165420083*r**18+269462462*r**20-41127194*r**22-13654759*r**24
            +418313*r**26)+10*Q2**6*(1259540+5803877*r**2-23532033*r**4-2109246552*r**6
            -9544382366*r**8-39759741061*r**10-79333297209*r**12-119098406816*r**14
            -69660249688*r**16-13983361421*r**18-381884731*r**20+264511880*r**22
            -105316878*r**24-14437827*r**26+1260165*r**28)+Q2**5*(-1429522-97736715*r**2
            -1617715640*r**4+2098864585*r**6-12171448290*r**8+280893888657*r**10
            +536428413960*r**12+1691496856965*r**14+1549238069610*r**16+526380826495*r**18
            +33108765192*r**20-5161804645*r**22+1307981450*r**24+484828155*r**26
            +10974120*r**28-2662377*r**30)-5*Q2**4*(677892-4948297*r**2-184875493*r**4
            -1835799047*r**6-12492555863*r**8-16769631217*r**10-130117787973*r**12
            +74508298201*r**14+214049147049*r**16+70032535581*r**18+9559984153*r**20
            -2592019133*r**22+2902206467*r**24+1216863773*r**26-43586543*r**28-12728853*r**30
            +616103*r**32)+30*Q2**3*(45654+417273*r**2+1417388*r**4-178221314*r**6
            -723747334*r**8-7139162596*r**10-26796182328*r**12-21945512406*r**14
            +1342738458*r**16+13720059258*r**18+16969717740*r**20+4420500082*r**22
            +1463384198*r**24+558599956*r**26+119452576*r**28-8390298*r**30-1005552*r**32
            +49245*r**34)+30*Q2**2*(9169-294388*r**2-7241173*r**4-11605536*r**6
            -384866858*r**8+2461427062*r**10-2492912204*r**12+21798649780*r**14-6278370596*r**16
            -25153597574*r**18-44294454506*r**20-30409099688*r**22-2275208286*r**24
            -1149771430*r**26-28432468*r**28+45300500*r**30+897755*r**32-277846*r**34
            +8287*r**36)-45*Q2*(6040-39833*r**2-1765902*r**4-25702367*r**6-191633484*r**8
            -669629844*r**10-6819671780*r**12+18100809572*r**14-23382970028*r**16
            -6747069582*r**18-9857533632*r**20+19868199534*r**22+4639058012*r**24
            +4640825532*r**26+322380516*r**28+82312436*r**30+43411204*r**32-781057*r**34
            -211762*r**36+6425*r**38)+9*(5222-10355*r**2-1056335*r**4-31511255*r**6
            -153685765*r**8-2010898828*r**10-6861747660*r**12+35126704580*r**14-161489742960*r**16
            +164166435670*r**18+133768147902*r**20-304538439490*r**22+98584777970*r**24
            +29670853060*r**26+12154764580*r**28+1458374292*r**30+101088130*r**32
            +57261285*r**34-1105095*r**36-220735*r**38+5787*r**40))+96*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(54928*Q2**21-2*Q2**20*(358359+430319*r**2)
            +20*Q2**19*(190961+539788*r**2+267603*r**4)-20*Q2**18*(514385+2702510*r**2
            +3098964*r**4+865463*r**6)+10*Q2**17*(1204732+13148827*r**2+25851153*r**4
            +17844189*r**6+2949531*r**8)-2*Q2**16*(-3465034+57731885*r**2+183089630*r**4
            +241153920*r**6+126309410*r**8+8074921*r**10)-2*Q2**15*(20213499+90395179*r**2
            +304589380*r**4+449620720*r**6+63841185*r**8-26017761*r**10+16187514*r**12)
            +5*Q2**14*(8279578+116482629*r**2+606047464*r**4+1606865481*r**6+1428175226*r**8
            +433906903*r**10+80140284*r**12+12791699*r**14)-10*Q2**13*(-1642185+46915405*r**2
            +387537446*r**4+1839937213*r**6+2724951680*r**8+1645678049*r**10+395360420*r**12
            +62514661*r**14+1796047*r**16)-5*Q2**12*(13992602+62721447*r**2+141453978*r**4
            -2792255956*r**6-7016971126*r**8-6814419706*r**10-3269012666*r**12-565298172*r**14
            -56965956*r**16+12255971*r**18)+2*Q2**11*(20976189+432932705*r**2+3654594840*r**4
            +8850610090*r**6+14294988680*r**8+22163798026*r**10+8562695780*r**12
            +141620450*r**14+360591735*r**16+134629305*r**18+32557304*r**20)+Q2**10*(31394402
            -434532923*r**2-6789445020*r**4-48690706285*r**6-141108888580*r**8-315376675502*r**10
            -284864875512*r**12-99334487490*r**14-18140345630*r**16-3353607415*r**18
            -483272108*r**20+7855887*r**22)-10*Q2**9*(5182619+36545507*r**2+151885332*r**4
            -3448203159*r**6-13408255469*r**8-51709121224*r**10-72770037022*r**12
            -42429205092*r**14-10414974509*r**16-1925370419*r**18-306609406*r**20
            -25752813*r**22+4984967*r**24)+5*Q2**8*(2083330+105674365*r**2+1405660002*r**4
            +3286654438*r**6+12117940820*r**8-31273767429*r**10-94472228540*r**12
            -78814116012*r**14-31930650870*r**16-5150433165*r**18-2022974694*r**20
            -125456250*r**22+22170912*r**24+3954069*r**26)+10*Q2**7*(2138131-11778509*r**2
            -394820156*r**4-4442751508*r**6-20685898629*r**8-57826202799*r**10-95484467954*r**12
            -136427854824*r**14-83981160527*r**16-19385791795*r**18-1277842352*r**20
            +492847148*r**22-160098831*r**24-27674273*r**26+1678478*r**28)+Q2**6*(
            -14024922-168370885*r**2-1440434080*r**4+23426650435*r**6+104364840890*r**8
            +773935122927*r**10+1727358796660*r**12+3675813897215*r**14+3436824634650*r**16
            +1362816937585*r**18+176761226712*r**20-3988076135*r**22-283968570*r**24
            +1682375205*r**26+142750740*r**28-15264027*r**30)-2*Q2**5*(979969-61953861*r**2
            -1319914910*r**4-4348923145*r**6-36267681510*r**8+92437142141*r**10+83366681376*r**12
            +1300233380965*r**14+2155490330910*r**16+1212890787005*r**18+303644756226*r**20
            +7493432441*r**22+5328604570*r**24+3938564235*r**26+138934780*r**28-27666261*r**30
            +209069*r**32)+5*Q2**4*(951816-1766767*r**2-181319462*r**4-3090002424*r**6
            -18670838914*r**8-72097162656*r**10-307664513158*r**12-187282564208*r**14
            +296613875998*r**16+366402038178*r**18+181410826174*r**20+33490965512*r**22
            +9090492522*r**24+7470669976*r**26+1889992686*r**28-106657184*r**30-18146062*r**32
            +911573*r**34)-30*Q2**3*(36485+757315*r**2+9075834*r**4-165198390*r**6
            -517101790*r**8-10324336992*r**10-31442432720*r**12-70540344514*r**14
            -14324403352*r**16+40216395290*r**18+74984231504*r**20+51799317510*r**22
            +8159092566*r**24+3171755584*r**26+706485000*r**28+65761778*r**30-10293605*r**32
            -678461*r**34+40958*r**36)-15*Q2**2*(36458-689937*r**2-20368828*r**4
            -114800519*r**6-1367845240*r**8+2144230876*r**10-20521985624*r**12+92913903868*r**14
            -39108351716*r**16-83105145086*r**18-168468705056*r**20-89802509786*r**22
            -51451441912*r**24+7072517164*r**26-1389266248*r**28+280673372*r**30
            +222630122*r**32-1103353*r**34-1174404*r**36+35849*r**38)+18*Q2*(17711
            -89660*r**2-5042505*r**4-84426300*r**6-620182510*r**8-3158607734*r**10
            -22154127890*r**12+45766196770*r**14-93950272620*r**16+6758118810*r**18
            +25372565916*r**20-127242554990*r**22+110560532850*r**24+38035135390*r**26
            +18485397410*r**28+1740919526*r**30+364853165*r**32+135206010*r**34-3034595*r**36
            -623710*r**38+18956*r**40)-9*(5222-5133*r**2-1066690*r**4-32567590*r**6
            -185197020*r**8-2164584593*r**10-8872646488*r**12+28264956920*r**14-126363038380*r**16
            +2676692710*r**18+297934583572*r**20-170770291588*r**22-205953661520*r**24
            +128255631030*r**26+41825617640*r**28+13613138872*r**30+1559462422*r**32
            +158349415*r**34+56156190*r**36-1325830*r**38-214948*r**40+5787*r**42))*sqrtq2))*z3)/(
            -210000*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))
            -210000*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2+logq2**6*(9405849600000*r**26*(1
            +r**2)*(-1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -9405849600000*r**26*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**3*(7257600000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))+7257600000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))*sqrtq2)+logq2*(25200000*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)
            -Q2**2*(5+2*r**2+5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))+25200000*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)-Q2**2*(5+2*r**2
            +5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))*sqrtq2)+logq2**2*(-151200000*(
            -Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(16*Q2**4+Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1
            +9*r**2+9*r**4+r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))-151200000*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(16*Q2**4
            +Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1+9*r**2+9*r**4
            +r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))*sqrtq2)+logq2**4*(-21772800000*(
            -Q2+(-1+r)**2)*r**18*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))
            -21772800000*(-Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))*sqrtq2)
            +logq2**5*(104509440000*(-Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41
            +74*r**2+41*r**4)-18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2
            -222*r**4-82*r**6+13*r**8))+104509440000*(-Q2+(-1+r)**2)*r**22*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2
            +41*r**4)-18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4
            -82*r**6+13*r**8))*sqrtq2))+((muWC**2*(-272160000*logq2**4*Q2*r**16*(9+28*r**2
            +34*r**4+28*r**6+9*r**8)-7200*logq2**2*Q2*(Q2-(-1+r)**2)*r**8*(Q2-(1
            +r)**2)*(755*Q2**10-6460*Q2**9*(1+r**2)+19*Q2**8*(1397+2670*r**2+1397*r**4)
            -2*Q2**7*(22697+75917*r**2+75917*r**4+22697*r**6)+Q2**6*(18389+192140*r**2
            +288058*r**4+192140*r**6+18389*r**8)+Q2**5*(33782-72026*r**2-3024*r**4
            -3024*r**6-72026*r**8+33782*r**10)-Q2**4*(39655+164510*r**2+1238017*r**4
            +2141020*r**6+1238017*r**8+164510*r**10+39655*r**12)+2*Q2**3*(3721+115075*r**2
            +794925*r**4+2094619*r**6+2094619*r**8+794925*r**10+115075*r**12+3721*r**14)
            +4*Q2**2*(2651-3949*r**2+57848*r**4-355357*r**6-683806*r**8-355357*r**10
            +57848*r**12-3949*r**14+2651*r**16)-18*Q2*(453+4355*r**2+39700*r**4
            -68700*r**6-202608*r**8-202608*r**10-68700*r**12+39700*r**14+4355*r**16
            +453*r**18)+12*(179+1333*r**2+22836*r**4+74334*r**6+510837*r**8+822162*r**10
            +510837*r**12+74334*r**14+22836*r**16+1333*r**18+179*r**20))-Q2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(6866*Q2**16-23436*Q2**15*(1+r**2)+8*Q2**14*(865
            +8596*r**2+865*r**4)+8*Q2**13*(5380-11099*r**2-11099*r**4+5380*r**6)
            +Q2**12*(10045-259012*r**2-2562366*r**4-259012*r**6+10045*r**8)-4*Q2**11*(34147
            -324527*r**2-3988562*r**4-3988562*r**6-324527*r**8+34147*r**10)+2*Q2**10*(35759
            -646722*r**2-15796615*r**4-38576020*r**6-15796615*r**8-646722*r**10
            +35759*r**12)+8*Q2**9*(13745-127492*r**2+2119265*r**4+19072200*r**6
            +19072200*r**8+2119265*r**10-127492*r**12+13745*r**14)+Q2**8*(-91205
            +2043184*r**2+31186064*r**4-92196960*r**6-136611350*r**8-92196960*r**10
            +31186064*r**12+2043184*r**14-91205*r**16)-4*Q2**7*(8785+21669*r**2
            +14208392*r**4+33962024*r**6+101173570*r**8+101173570*r**10+33962024*r**12
            +14208392*r**14+21669*r**16+8785*r**18)+4*Q2**6*(10807-257354*r**2+4036831*r**4
            +57257856*r**6+179616146*r**8+416911988*r**10+179616146*r**12+57257856*r**14
            +4036831*r**16-257354*r**18+10807*r**20)-8*Q2**5*(266-53737*r**2-4403625*r**4
            +12575730*r**6+21507400*r**8+309675766*r**10+309675766*r**12+21507400*r**14
            +12575730*r**16-4403625*r**18-53737*r**20+266*r**22)-Q2**4*(2005+87332*r**2
            +26936590*r**4+29645300*r**6+614859675*r**8-231352920*r**10+1158640836*r**12
            -231352920*r**14+614859675*r**16+29645300*r**18+26936590*r**20+87332*r**22
            +2005*r**24)+4*Q2**3*(135-9223*r**2-887018*r**4+22918230*r**6+168130475*r**8
            +734118485*r**10+2173168916*r**12+2173168916*r**14+734118485*r**16+168130475*r**18
            +22918230*r**20-887018*r**22-9223*r**24+135*r**26)-2*Q2**2*(1265-69094*r**2
            -3667317*r**4+24306396*r**6-83158055*r**8+480299590*r**10+308598123*r**12
            +3065234184*r**14+308598123*r**16+480299590*r**18-83158055*r**20+24306396*r**22
            -3667317*r**24-69094*r**26+1265*r**28)+24*Q2*(31-1758*r**2-54453*r**4
            -686878*r**6-12831908*r**8+1292719*r**10-99093084*r**12+519615331*r**14
            +519615331*r**16-99093084*r**18+1292719*r**20-12831908*r**22-686878*r**24
            -54453*r**26-1758*r**28+31*r**30)+3*(57-3672*r**2+19060*r**4+3841960*r**6
            +9425060*r**8+68973464*r**10+826635276*r**12-1542120*r**14+7983061830*r**16
            -1542120*r**18+826635276*r**20+68973464*r**22+9425060*r**24+3841960*r**26
            +19060*r**28-3672*r**30+57*r**32))-432000*logq2**3*Q2*r**12*(867+35*Q2**7
            +3267*r**2+42957*r**4+88989*r**6+88989*r**8+42957*r**10+3267*r**12
            +867*r**14-505*Q2**6*(1+r**2)+5*Q2**5*(445+904*r**2+445*r**4)-Q2**4*(5293
            +15125*r**2+15125*r**4+5293*r**6)-3*Q2*(1+r**2)**2*(1111-2778*r**2
            -446*r**4-2778*r**6+1111*r**8)+Q2**3*(4157+17952*r**2+28010*r**4+17952*r**6
            +4157*r**8)+Q2**2*(1847-3657*r**2-14318*r**4-14318*r**6-3657*r**8+1847*r**10))*sqrtq2
            +120*logq2*Q2*r**4*(-25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(105*Q2**7-555*Q2**6*(1
            +r**2)+15*Q2**5*(19+52*r**2+19*r**4)-Q2**4*(751+5687*r**2+5687*r**4
            +751*r**6)+Q2**3*(1139+8352*r**2+14006*r**4+8352*r**6+1139*r**8)+Q2**2*(719
            +3879*r**2+4474*r**4+4474*r**6+3879*r**8+719*r**10)+Q2*(-681+2244*r**2
            +38061*r**4+66912*r**6+38061*r**8+2244*r**10-681*r**12)+3*(-87+1849*r**2
            +34455*r**4+109943*r**6+109943*r**8+34455*r**10+1849*r**12-87*r**14))
            -2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(971+40*Q2**9-18517*r**2-136600*r**4+561592*r**6+1104554*r**8
            +1104554*r**10+561592*r**12-136600*r**14-18517*r**16+971*r**18-889*Q2**8*(1
            +r**2)+23*Q2**7*(169+418*r**2+169*r**4)-Q2**6*(4347+16967*r**2+16967*r**4
            +4347*r**6)-2*Q2**5*(1113+3489*r**2+13232*r**4+3489*r**6+1113*r**8)
            +2*Q2**4*(2240+11225*r**2+82043*r**4+82043*r**6+11225*r**8+2240*r**10)
            +Q2**3*(1659-18836*r**2-355219*r**4-699528*r**6-355219*r**8-18836*r**10
            +1659*r**12)+Q2**2*(-2567+13091*r**2+205549*r**4+793607*r**6+793607*r**8
            +205549*r**10+13091*r**12-2567*r**14)-8*Q2*(126-2129*r**2-34216*r**4
            -21131*r**6-11300*r**8-21131*r**10-34216*r**12-2129*r**14+126*r**16)))*sqrtq2))/(
            -3265920000*logq2**5*r**20-226800000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -787500*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+1360800000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+18900000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+13125*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +(muWC*(-2177280000*logq2**4*Q2*r**16*(9+28*r**2+34*r**4+28*r**6+9*r**8)
            -57600*logq2**2*Q2*(Q2-(-1+r)**2)*r**8*(Q2-(1+r)**2)*(755*Q2**10-6460*Q2**9*(1
            +r**2)+19*Q2**8*(1397+2670*r**2+1397*r**4)-2*Q2**7*(22697+75917*r**2
            +75917*r**4+22697*r**6)+Q2**6*(18389+192140*r**2+288058*r**4+192140*r**6
            +18389*r**8)+Q2**5*(33782-72026*r**2-3024*r**4-3024*r**6-72026*r**8
            +33782*r**10)-Q2**4*(39655+164510*r**2+1238017*r**4+2141020*r**6+1238017*r**8
            +164510*r**10+39655*r**12)+2*Q2**3*(3721+115075*r**2+794925*r**4+2094619*r**6
            +2094619*r**8+794925*r**10+115075*r**12+3721*r**14)+4*Q2**2*(2651-3949*r**2
            +57848*r**4-355357*r**6-683806*r**8-355357*r**10+57848*r**12-3949*r**14
            +2651*r**16)-18*Q2*(453+4355*r**2+39700*r**4-68700*r**6-202608*r**8
            -202608*r**10-68700*r**12+39700*r**14+4355*r**16+453*r**18)+12*(179
            +1333*r**2+22836*r**4+74334*r**6+510837*r**8+822162*r**10+510837*r**12
            +74334*r**14+22836*r**16+1333*r**18+179*r**20))-8*Q2*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(6866*Q2**16-23436*Q2**15*(1+r**2)+8*Q2**14*(865+8596*r**2
            +865*r**4)+8*Q2**13*(5380-11099*r**2-11099*r**4+5380*r**6)+Q2**12*(10045
            -259012*r**2-2562366*r**4-259012*r**6+10045*r**8)-4*Q2**11*(34147-324527*r**2
            -3988562*r**4-3988562*r**6-324527*r**8+34147*r**10)+2*Q2**10*(35759
            -646722*r**2-15796615*r**4-38576020*r**6-15796615*r**8-646722*r**10
            +35759*r**12)+8*Q2**9*(13745-127492*r**2+2119265*r**4+19072200*r**6
            +19072200*r**8+2119265*r**10-127492*r**12+13745*r**14)+Q2**8*(-91205
            +2043184*r**2+31186064*r**4-92196960*r**6-136611350*r**8-92196960*r**10
            +31186064*r**12+2043184*r**14-91205*r**16)-4*Q2**7*(8785+21669*r**2
            +14208392*r**4+33962024*r**6+101173570*r**8+101173570*r**10+33962024*r**12
            +14208392*r**14+21669*r**16+8785*r**18)+4*Q2**6*(10807-257354*r**2+4036831*r**4
            +57257856*r**6+179616146*r**8+416911988*r**10+179616146*r**12+57257856*r**14
            +4036831*r**16-257354*r**18+10807*r**20)-8*Q2**5*(266-53737*r**2-4403625*r**4
            +12575730*r**6+21507400*r**8+309675766*r**10+309675766*r**12+21507400*r**14
            +12575730*r**16-4403625*r**18-53737*r**20+266*r**22)-Q2**4*(2005+87332*r**2
            +26936590*r**4+29645300*r**6+614859675*r**8-231352920*r**10+1158640836*r**12
            -231352920*r**14+614859675*r**16+29645300*r**18+26936590*r**20+87332*r**22
            +2005*r**24)+4*Q2**3*(135-9223*r**2-887018*r**4+22918230*r**6+168130475*r**8
            +734118485*r**10+2173168916*r**12+2173168916*r**14+734118485*r**16+168130475*r**18
            +22918230*r**20-887018*r**22-9223*r**24+135*r**26)-2*Q2**2*(1265-69094*r**2
            -3667317*r**4+24306396*r**6-83158055*r**8+480299590*r**10+308598123*r**12
            +3065234184*r**14+308598123*r**16+480299590*r**18-83158055*r**20+24306396*r**22
            -3667317*r**24-69094*r**26+1265*r**28)+24*Q2*(31-1758*r**2-54453*r**4
            -686878*r**6-12831908*r**8+1292719*r**10-99093084*r**12+519615331*r**14
            +519615331*r**16-99093084*r**18+1292719*r**20-12831908*r**22-686878*r**24
            -54453*r**26-1758*r**28+31*r**30)+3*(57-3672*r**2+19060*r**4+3841960*r**6
            +9425060*r**8+68973464*r**10+826635276*r**12-1542120*r**14+7983061830*r**16
            -1542120*r**18+826635276*r**20+68973464*r**22+9425060*r**24+3841960*r**26
            +19060*r**28-3672*r**30+57*r**32))-3456000*logq2**3*Q2*r**12*(867+35*Q2**7
            +3267*r**2+42957*r**4+88989*r**6+88989*r**8+42957*r**10+3267*r**12
            +867*r**14-505*Q2**6*(1+r**2)+5*Q2**5*(445+904*r**2+445*r**4)-Q2**4*(5293
            +15125*r**2+15125*r**4+5293*r**6)-3*Q2*(1+r**2)**2*(1111-2778*r**2
            -446*r**4-2778*r**6+1111*r**8)+Q2**3*(4157+17952*r**2+28010*r**4+17952*r**6
            +4157*r**8)+Q2**2*(1847-3657*r**2-14318*r**4-14318*r**6-3657*r**8+1847*r**10))*sqrtq2
            +960*logq2*Q2*r**4*(-25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(105*Q2**7-555*Q2**6*(1
            +r**2)+15*Q2**5*(19+52*r**2+19*r**4)-Q2**4*(751+5687*r**2+5687*r**4
            +751*r**6)+Q2**3*(1139+8352*r**2+14006*r**4+8352*r**6+1139*r**8)+Q2**2*(719
            +3879*r**2+4474*r**4+4474*r**6+3879*r**8+719*r**10)+Q2*(-681+2244*r**2
            +38061*r**4+66912*r**6+38061*r**8+2244*r**10-681*r**12)+3*(-87+1849*r**2
            +34455*r**4+109943*r**6+109943*r**8+34455*r**10+1849*r**12-87*r**14))
            -2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(971+40*Q2**9-18517*r**2-136600*r**4+561592*r**6+1104554*r**8
            +1104554*r**10+561592*r**12-136600*r**14-18517*r**16+971*r**18-889*Q2**8*(1
            +r**2)+23*Q2**7*(169+418*r**2+169*r**4)-Q2**6*(4347+16967*r**2+16967*r**4
            +4347*r**6)-2*Q2**5*(1113+3489*r**2+13232*r**4+3489*r**6+1113*r**8)
            +2*Q2**4*(2240+11225*r**2+82043*r**4+82043*r**6+11225*r**8+2240*r**10)
            +Q2**3*(1659-18836*r**2-355219*r**4-699528*r**6-355219*r**8-18836*r**10
            +1659*r**12)+Q2**2*(-2567+13091*r**2+205549*r**4+793607*r**6+793607*r**8
            +205549*r**10+13091*r**12-2567*r**14)-8*Q2*(126-2129*r**2-34216*r**4
            -21131*r**6-11300*r**8-21131*r**10-34216*r**12-2129*r**14+126*r**16)))*sqrtq2))/(
            -9797760000*logq2**5*r**20-680400000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -2362500*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+4082400000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+56700000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+39375*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2))*nlo.X1Q2_DerivativeQ2(0,Q2,r)
            +((muWC**2*(-3024000*logq2**3*Q2*r**12*(1+r**2)*(29+50*r**2+29*r**4)+120*logq2*Q2*(Q2
            -(-1+r)**2)*r**4*(Q2-(1+r)**2)*(-1873+640*Q2**9+8851*r**2-85460*r**4
            -1289996*r**6-6796322*r**8-6796322*r**10-1289996*r**12-85460*r**14+8851*r**16
            -1873*r**18-8848*Q2**8*(1+r**2)+32*Q2**7*(617+1454*r**2+617*r**4)-3*Q2**6*(2723
            +24273*r**2+24273*r**4+2723*r**6)+Q2**5*(-13762+56744*r**2+93652*r**4
            +56744*r**6-13762*r**8)+Q2**4*(13825+65585*r**2+481262*r**4+481262*r**6
            +65585*r**8+13825*r**10)-4*Q2**3*(903+32098*r**2+185817*r**4+339964*r**6
            +185817*r**8+32098*r**10+903*r**12)-Q2**2*(1879+11233*r**2+272487*r**4
            -159599*r**6-159599*r**8+272487*r**10+11233*r**12+1879*r**14)+2*Q2*(1967
            +21792*r**2+88088*r**4-781552*r**6-1382190*r**8-781552*r**10+88088*r**12
            +21792*r**14+1967*r**16))+7200*logq2**2*Q2*r**8*(-71+160*Q2**6-6084*r**2
            -70785*r**4-118280*r**6-70785*r**8-6084*r**10-71*r**12-960*Q2**5*(1
            +r**2)+288*Q2**4*(13+24*r**2+13*r**4)-Q2**3*(3221+9879*r**2+9879*r**4
            +3221*r**6)-3*Q2**2*(607-396*r**2-982*r**4-396*r**6+607*r**8)+3*Q2*(723
            -2099*r**2-6184*r**4-6184*r**6-2099*r**8+723*r**10))*sqrtq2+2*Q2*(500*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4-2708*r**6-1133*r**8
            -34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1
            -19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4-26*r**6+r**8)+Q2*(1
            -31*r**2-390*r**4-390*r**6-31*r**8+r**10))-7*(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8
            -444*r**2-9976*r**4+31692*r**6-28170*r**8+31692*r**10-9976*r**12-444*r**14
            +13*r**16-24*Q2**7*(1+r**2)+Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61
            -193*r**2-193*r**4+61*r**6)+Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6
            -165*r**8)+4*Q2**3*(13-355*r**2-6138*r**4-6138*r**6-355*r**8+13*r**10)
            +Q2**2*(59-406*r**2+10313*r**4+35188*r**6+10313*r**8-406*r**10+59*r**12)
            -2*Q2*(27-595*r**2-7237*r**4+6605*r**6+6605*r**8-7237*r**10-595*r**12
            +27*r**14)))*sqrtq2))/(54432000*logq2**4*r**16+2268000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+2625*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-18144000*logq2**3*r**12*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2-126000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(muWC*(-24192000*logq2**3*Q2*r**12*(1+r**2)*(29
            +50*r**2+29*r**4)+960*logq2*Q2*(Q2-(-1+r)**2)*r**4*(Q2-(1+r)**2)*(
            -1873+640*Q2**9+8851*r**2-85460*r**4-1289996*r**6-6796322*r**8-6796322*r**10
            -1289996*r**12-85460*r**14+8851*r**16-1873*r**18-8848*Q2**8*(1+r**2)
            +32*Q2**7*(617+1454*r**2+617*r**4)-3*Q2**6*(2723+24273*r**2+24273*r**4
            +2723*r**6)+Q2**5*(-13762+56744*r**2+93652*r**4+56744*r**6-13762*r**8)
            +Q2**4*(13825+65585*r**2+481262*r**4+481262*r**6+65585*r**8+13825*r**10)
            -4*Q2**3*(903+32098*r**2+185817*r**4+339964*r**6+185817*r**8+32098*r**10
            +903*r**12)-Q2**2*(1879+11233*r**2+272487*r**4-159599*r**6-159599*r**8
            +272487*r**10+11233*r**12+1879*r**14)+2*Q2*(1967+21792*r**2+88088*r**4
            -781552*r**6-1382190*r**8-781552*r**10+88088*r**12+21792*r**14+1967*r**16))
            +57600*logq2**2*Q2*r**8*(-71+160*Q2**6-6084*r**2-70785*r**4-118280*r**6
            -70785*r**8-6084*r**10-71*r**12-960*Q2**5*(1+r**2)+288*Q2**4*(13+24*r**2
            +13*r**4)-Q2**3*(3221+9879*r**2+9879*r**4+3221*r**6)-3*Q2**2*(607-396*r**2
            -982*r**4-396*r**6+607*r**8)+3*Q2*(723-2099*r**2-6184*r**4-6184*r**6
            -2099*r**8+723*r**10))*sqrtq2+16*Q2*(500*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1
            +8*Q2**6-34*r**2-1133*r**4-2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1
            +r**2)+Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1
            -26*r**2-118*r**4-26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6
            -31*r**8+r**10))-7*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6
            -28170*r**8+31692*r**10-9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)
            +Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)
            +Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2
            -6138*r**4-6138*r**6-355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4
            +35188*r**6+10313*r**8-406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4
            +6605*r**6+6605*r**8-7237*r**10-595*r**12+27*r**14)))*sqrtq2))/(163296000*logq2**4*r**16
            +6804000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+7875*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-54432000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-378000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2))*nlo.X1Q2_DerivativeQ2(1,Q2,r)
            +((muWC**2*(-64800*logq2**2*Q2*r**8*(1+r**2)**2-2*Q2*(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2+720*logq2*Q2*r**4*(1
            +r**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(
            -43200*logq2**3*r**12-900*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+10800*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+25*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(muWC*(-518400*logq2**2*Q2*r**8*(1+r**2)**2
            -16*Q2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2+5760*logq2*Q2*r**4*(1+r**2)*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2))/(-129600*logq2**3*r**12-2700*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+32400*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+75*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2))*nlo.X1Q2_DerivativeQ2(2,Q2,r)
            +((muWC**2*(-1440*logq2*Q2*r**4*(1+r**2)+8*Q2*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2))/(2160*logq2**2*r**8+15*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2-360*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))*sqrtq2)+(muWC*(-11520*logq2*Q2*r**4*(1+r**2)+64*Q2*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(6480*logq2**2*r**8
            +45*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-1080*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))*nlo.X1Q2_DerivativeQ2(3,Q2,r)+((
            -4*muWC**2*Q2)/(-36*logq2*r**4+3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2)-(32*muWC*Q2)/(-108*logq2*r**4+9*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))*nlo.X1Q2_DerivativeQ2(4,Q2,r)
            +(pi2*(-4*(Q2-(-1+r)**2)**4*r**4*(1-Q2+r**2)*(Q2-(1+r)**2)**4*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(-92*Q2**18-60*Q2**17*(1
            +r**2)+4*Q2**16*(-1499-3228*r**2+1519*r**4)+Q2**15*(72623+1046341*r**2
            +160589*r**4-34969*r**6)+Q2**14*(-299825-8852676*r**2-10808350*r**4
            -776500*r**6+94735*r**8)+Q2**13*(576101+29535579*r**2+82368756*r**4
            +43289452*r**6+1877655*r**8-135799*r**10)+Q2**12*(-381315-38482536*r**2
            -239240429*r**4-277504064*r**6-79598981*r**8-2114840*r**10+76245*r**12)
            +Q2**11*(-493297-20511955*r**2+237317447*r**4+530987613*r**6+387002253*r**8
            +41680119*r**10-50819*r**12+56927*r**14)+Q2**10*(1074711+122446116*r**2
            +261376636*r**4+280696044*r**6+60797850*r**8-63891428*r**10+87830460*r**12
            +2723028*r**14-101673*r**16)-Q2**9*(341275+112792173*r**2+851014790*r**4
            +2103692810*r**6+3429691340*r**8+1396512740*r**10+436523258*r**12+153045270*r**14
            +1716825*r**16+9295*r**18)+Q2**8*(-889251-54890208*r**2+590459833*r**4
            +1670586336*r**6+6297176130*r**8+4841499376*r**10+1065281922*r**12+528837568*r**14
            +37227201*r**16-2320560*r**18+120549*r**20)+Q2**7*(994085+168225927*r**2
            +357891963*r**4+1950721473*r**6-778030638*r**8+777200710*r**10+1046459542*r**12
            +511955778*r**14-340834967*r**16+105058067*r**18+3712335*r**20-89635*r**22)
            -Q2**6*(70043+76673404*r**2+764189182*r**4+3289645276*r**6+8434570341*r**8
            +17554642744*r**10+19515767172*r**12+5395152088*r**14+193046501*r**16
            -158583284*r**18+89263870*r**20+875276*r**22+10907*r**24)+Q2**5*(-508441
            -63392055*r**2+323302736*r**4-37241456*r**6+8386679415*r**8+12693116089*r**10
            +39203740728*r**12+16900419912*r**14+1763653493*r**16-848638885*r**18
            +178260472*r**20-9932888*r**22-1674323*r**24+48803*r**26)+Q2**4*(316975
            +76375224*r**2+131177365*r**4+2445366560*r**6-714459345*r**8+20178975160*r**10
            -29566065683*r**12-14255612160*r**14-701297035*r**16+975854760*r**18
            +224047815*r**20-417821216*r**22+41907245*r**24+1300200*r**26-21065*r**28)
            +Q2**3*(9117-14144121*r**2-170056239*r**4-1061850213*r**6-3845099135*r**8
            -26031776957*r**10+12379537797*r**12-4354598937*r**14+11620863591*r**16
            +3295991205*r**18+152368323*r**20+570114849*r**22+193648251*r**24-13345903*r**26
            +7655*r**28-5283*r**30)+Q2**2*(-84335-15657956*r**2+57506816*r**4-600798684*r**6
            +3037842044*r**8-3267499140*r**10+12997085632*r**12-6908662492*r**14
            -18283866522*r**16-18885157708*r**18-2821795840*r**20-279101876*r**22
            -403896324*r**24+108011956*r**26-5478336*r**28-391060*r**30+7825*r**32)
            -3*Q2*(-11737-3122007*r**2+2026122*r**4-191370746*r**6+336016054*r**8
            -4793498550*r**10+15426377970*r**12-23365152962*r**14+7896633092*r**16
            +2428061692*r**18-53763714*r**20+2180654706*r**22+134272058*r**24-35892346*r**26
            +40213254*r**28-1384374*r**30-59419*r**32+907*r**34)+3*(-1631-528384*r**2
            -60287*r**4-41405248*r**6+39342620*r**8-1532131152*r**10+8274408172*r**12
            -29995134624*r**14+52589566534*r**16-43249613040*r**18+13813606422*r**20
            -1374664192*r**22+1391081884*r**24+82272976*r**26-6254580*r**28+9760736*r**30
            -237471*r**32-8848*r**34+113*r**36))*(3+math.log(4))+4*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**4*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*(92*Q2**18+60*Q2**17*(1+r**2)+Q2**16*(5996+12912*r**2-6076*r**4)
            +Q2**15*(-72623-1046341*r**2-160589*r**4+34969*r**6)+Q2**14*(299825
            +8852676*r**2+10808350*r**4+776500*r**6-94735*r**8)+Q2**13*(-576101
            -29535579*r**2-82368756*r**4-43289452*r**6-1877655*r**8+135799*r**10)
            +Q2**12*(381315+38482536*r**2+239240429*r**4+277504064*r**6+79598981*r**8
            +2114840*r**10-76245*r**12)-Q2**11*(-493297-20511955*r**2+237317447*r**4
            +530987613*r**6+387002253*r**8+41680119*r**10-50819*r**12+56927*r**14)
            +Q2**10*(-1074711-122446116*r**2-261376636*r**4-280696044*r**6-60797850*r**8
            +63891428*r**10-87830460*r**12-2723028*r**14+101673*r**16)+Q2**9*(341275
            +112792173*r**2+851014790*r**4+2103692810*r**6+3429691340*r**8+1396512740*r**10
            +436523258*r**12+153045270*r**14+1716825*r**16+9295*r**18)-Q2**8*(-889251
            -54890208*r**2+590459833*r**4+1670586336*r**6+6297176130*r**8+4841499376*r**10
            +1065281922*r**12+528837568*r**14+37227201*r**16-2320560*r**18+120549*r**20)
            +Q2**7*(-994085-168225927*r**2-357891963*r**4-1950721473*r**6+778030638*r**8
            -777200710*r**10-1046459542*r**12-511955778*r**14+340834967*r**16-105058067*r**18
            -3712335*r**20+89635*r**22)+Q2**6*(70043+76673404*r**2+764189182*r**4
            +3289645276*r**6+8434570341*r**8+17554642744*r**10+19515767172*r**12
            +5395152088*r**14+193046501*r**16-158583284*r**18+89263870*r**20+875276*r**22
            +10907*r**24)-Q2**5*(-508441-63392055*r**2+323302736*r**4-37241456*r**6
            +8386679415*r**8+12693116089*r**10+39203740728*r**12+16900419912*r**14
            +1763653493*r**16-848638885*r**18+178260472*r**20-9932888*r**22-1674323*r**24
            +48803*r**26)+Q2**4*(-316975-76375224*r**2-131177365*r**4-2445366560*r**6
            +714459345*r**8-20178975160*r**10+29566065683*r**12+14255612160*r**14
            +701297035*r**16-975854760*r**18-224047815*r**20+417821216*r**22-41907245*r**24
            -1300200*r**26+21065*r**28)+Q2**3*(-9117+14144121*r**2+170056239*r**4
            +1061850213*r**6+3845099135*r**8+26031776957*r**10-12379537797*r**12
            +4354598937*r**14-11620863591*r**16-3295991205*r**18-152368323*r**20
            -570114849*r**22-193648251*r**24+13345903*r**26-7655*r**28+5283*r**30)
            +Q2**2*(84335+15657956*r**2-57506816*r**4+600798684*r**6-3037842044*r**8
            +3267499140*r**10-12997085632*r**12+6908662492*r**14+18283866522*r**16
            +18885157708*r**18+2821795840*r**20+279101876*r**22+403896324*r**24-108011956*r**26
            +5478336*r**28+391060*r**30-7825*r**32)+3*Q2*(-11737-3122007*r**2+2026122*r**4
            -191370746*r**6+336016054*r**8-4793498550*r**10+15426377970*r**12-23365152962*r**14
            +7896633092*r**16+2428061692*r**18-53763714*r**20+2180654706*r**22+134272058*r**24
            -35892346*r**26+40213254*r**28-1384374*r**30-59419*r**32+907*r**34)
            -3*(-1631-528384*r**2-60287*r**4-41405248*r**6+39342620*r**8-1532131152*r**10
            +8274408172*r**12-29995134624*r**14+52589566534*r**16-43249613040*r**18
            +13813606422*r**20-1374664192*r**22+1391081884*r**24+82272976*r**26-6254580*r**28
            +9760736*r**30-237471*r**32-8848*r**34+113*r**36))*sqrtq2*(3+math.log(4))
            +logq2**6*(2351462400000*(-Q2+(-1+r)**2)*(-1+r)*r**28*(1+r)*(1+r**2)*(1
            -Q2+r**2)*(-1+4*r**2+r**4)*(-Q2+(1+r)**2)*(3+math.log(4))+2351462400000*(
            -Q2+(-1+r)**2)*(-1+r)*r**28*(1+r)*(1+r**2)*(-1+4*r**2+r**4)*(-Q2
            +(1+r)**2)*sqrtq2*(3+math.log(4)))+logq2**5*(3732480000*r**22*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(-70*Q2**7*(1+r**2)+10*Q2**6*(53+76*r**2
            +23*r**4)+10*Q2**5*(-157-305*r**2-125*r**4+23*r**6)+Q2**4*(2266+5806*r**2
            +2778*r**4-2702*r**6-1716*r**8)+4*Q2**3*(-326-1372*r**2-554*r**4+1744*r**6
            +1663*r**8+411*r**10)+2*Q2**2*(-337+595*r**2+664*r**4-3032*r**6-4453*r**8
            -853*r**10+612*r**12)-3*Q2*(-452-645*r**2+498*r**4+735*r**6-1068*r**8
            -1047*r**10+1022*r**12+957*r**14)+3*(-178-291*r**2+985*r**4-989*r**6
            -4321*r**8+1587*r**10+2175*r**12+589*r**14+443*r**16))*(3+math.log(4))
            +3732480000*(-Q2+(-1+r)**2)*r**22*(1-Q2+r**2)*(-Q2+(1+r)**2)*(-70*Q2**7*(1
            +r**2)+10*Q2**6*(53+76*r**2+23*r**4)+10*Q2**5*(-157-305*r**2-125*r**4
            +23*r**6)+Q2**4*(2266+5806*r**2+2778*r**4-2702*r**6-1716*r**8)+4*Q2**3*(
            -326-1372*r**2-554*r**4+1744*r**6+1663*r**8+411*r**10)+2*Q2**2*(-337
            +595*r**2+664*r**4-3032*r**6-4453*r**8-853*r**10+612*r**12)-3*Q2*(
            -452-645*r**2+498*r**4+735*r**6-1068*r**8-1047*r**10+1022*r**12+957*r**14)
            +3*(-178-291*r**2+985*r**4-989*r**6-4321*r**8+1587*r**10+2175*r**12
            +589*r**14+443*r**16))*sqrtq2*(3+math.log(4)))+logq2**4*(10368000*r**18*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1120*Q2**11-40*Q2**10*(463
            +343*r**2)+20*Q2**9*(5598+9401*r**2+3579*r**4)-16*Q2**8*(21419+57837*r**2
            +47750*r**4+12476*r**6)+4*Q2**7*(135368+544057*r**2+709339*r**4+391017*r**6
            +78047*r**8)-Q2**6*(272832+2291461*r**2+4400212*r**4+3800814*r**6+1567540*r**8
            +266133*r**10)+2*Q2**5*(-220528+6795*r**2+480911*r**4+1039682*r**6+1140282*r**8
            +361111*r**10+74123*r**12)+Q2**4*(756560+2200635*r**2+5369086*r**4+5468913*r**6
            -1950140*r**8-3762451*r**10-661490*r**12-127225*r**14)+12*Q2**3*(-23848
            -145619*r**2-506372*r**4-699975*r**6+339684*r**8+1039559*r**10+509668*r**12
            +81095*r**14+5208*r**16)+3*Q2**2*(-70584+97119*r**2+176040*r**4+877892*r**6
            -1061288*r**8-5155610*r**10-3159048*r**12+140156*r**14-42016*r**16+32539*r**18)
            -18*Q2*(-11924-8467*r**2-169481*r**4-118784*r**6+250860*r**8-65590*r**10
            -448558*r**12+140416*r**14+390024*r**16+34505*r**18+6999*r**20)+9*(
            -5856-4915*r**2-171594*r**4-14467*r**6+228240*r**8-520586*r**10-393676*r**12
            +95334*r**14+330832*r**16+417725*r**18+34582*r**20+4381*r**22))*(3+math.log(4))
            +10368000*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1120*Q2**11-40*Q2**10*(463
            +343*r**2)+20*Q2**9*(5598+9401*r**2+3579*r**4)-16*Q2**8*(21419+57837*r**2
            +47750*r**4+12476*r**6)+4*Q2**7*(135368+544057*r**2+709339*r**4+391017*r**6
            +78047*r**8)-Q2**6*(272832+2291461*r**2+4400212*r**4+3800814*r**6+1567540*r**8
            +266133*r**10)+2*Q2**5*(-220528+6795*r**2+480911*r**4+1039682*r**6+1140282*r**8
            +361111*r**10+74123*r**12)+Q2**4*(756560+2200635*r**2+5369086*r**4+5468913*r**6
            -1950140*r**8-3762451*r**10-661490*r**12-127225*r**14)+12*Q2**3*(-23848
            -145619*r**2-506372*r**4-699975*r**6+339684*r**8+1039559*r**10+509668*r**12
            +81095*r**14+5208*r**16)+3*Q2**2*(-70584+97119*r**2+176040*r**4+877892*r**6
            -1061288*r**8-5155610*r**10-3159048*r**12+140156*r**14-42016*r**16+32539*r**18)
            -18*Q2*(-11924-8467*r**2-169481*r**4-118784*r**6+250860*r**8-65590*r**10
            -448558*r**12+140416*r**14+390024*r**16+34505*r**18+6999*r**20)+9*(
            -5856-4915*r**2-171594*r**4-14467*r**6+228240*r**8-520586*r**10-393676*r**12
            +95334*r**14+330832*r**16+417725*r**18+34582*r**20+4381*r**22))*sqrtq2*(3
            +math.log(4)))+logq2**3*(691200*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(6040*Q2**14
            -40*Q2**13*(1717+1594*r**2)+6*Q2**12*(56105+105627*r**2+47066*r**4)
            -4*Q2**11*(218475+672236*r**2+615914*r**4+166353*r**6)+4*Q2**10*(277725
            +1486603*r**2+2160818*r**4+1233470*r**6+213954*r**8)-30*Q2**9*(2091
            +203128*r**2+406142*r**4+373524*r**6+159933*r**8+17658*r**10)+10*Q2**8*(
            -179709-127157*r**2-729770*r**4-1318228*r**6-406781*r**8+81919*r**10
            +8730*r**12)+Q2**7*(2134140+10896361*r**2+49318958*r**4+108457305*r**6
            +93813080*r**8+30766055*r**10+2215166*r**12+14103*r**14)-3*Q2**6*(75900
            +3683359*r**2+18606971*r**4+63097297*r**6+84376685*r**8+48168485*r**10
            +11650609*r**12+359211*r**14+43947*r**16)+Q2**5*(-1426600+1054561*r**2
            -10443884*r**4+86498170*r**6+222991528*r**8+205266820*r**10+79196236*r**12
            +14503246*r**14+154480*r**16+417443*r**18)-5*Q2**4*(-216038-1284133*r**2
            -13610857*r**4-21608978*r**6-16436874*r**8+7836032*r**10+22070188*r**12
            +7263066*r**14+1535816*r**16+403917*r**18+69205*r**20)-15*Q2**3*(1232
            +306323*r**2+2630070*r**4+9309725*r**6+15167456*r**8+5812862*r**10-16901308*r**12
            -16774294*r**14-4963312*r**16-654129*r**18-157626*r**20+2201*r**22)
            +3*Q2**2*(-106840+24359*r**2-4344493*r**4+16724055*r**6+16613515*r**8
            +4616870*r**10-94138698*r**12-138715514*r**14-37514770*r**16-9244205*r**18
            +1108055*r**20-26301*r**22+59967*r**24)-9*Q2*(-16650-118219*r**2-2159316*r**4
            +469828*r**6-11255590*r**8-1175335*r**10+9829088*r**12-23727088*r**14
            -5724286*r**16+27575015*r**18+4956660*r**20+1226156*r**22+110254*r**24
            +9483*r**26)+9*(-2450-36197*r**2-559757*r**4+12580*r**6-6265906*r**8
            -2125205*r**10+7941439*r**12+3066584*r**14-20073990*r**16-4372743*r**18
            +19012105*r**20+2888708*r**22+471498*r**24+41985*r**26+1349*r**28))*(3
            +math.log(4))-691200*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(6040*Q2**15
            -40*Q2**14*(1868+1745*r**2)+Q2**13*(405310+766202*r**2+346156*r**4)
            -2*Q2**12*(605265+1829668*r**2+1689907*r**4+473904*r**6)+4*Q2**11*(496200
            +2377314*r**2+3448968*r**4+2015737*r**6+380307*r**8)-2*Q2**10*(586815
            +6575576*r**2+13386972*r**4+12391436*r**6+5293843*r**8+692778*r**10)
            +20*Q2**9*(-86718+244250*r**2+549020*r**4+510385*r**6+596795*r**8+307346*r**10
            +30852*r**12)+Q2**8*(3931230+13965021*r**2+57888228*r**4+128937285*r**6
            +111063170*r**8+34014675*r**10+1308676*r**12-73197*r**14)-2*Q2**7*(1180920
            +12040289*r**2+58018116*r**4+173534077*r**6+227700220*r**8+134542295*r**10
            +33966524*r**12+1653451*r**14+72972*r**16)+2*Q2**6*(-599450+6166169*r**2
            +28213553*r**4+165805487*r**6+332706737*r**8+301451165*r**10+129326759*r**12
            +25266353*r**14+681977*r**16+274642*r**18)-2*Q2**5*(-1253395-3396352*r**2
            -38721804*r**4-15995302*r**6+113652664*r**8+233719254*r**10+197406998*r**12
            +65007406*r**14+11168403*r**16+1295754*r**18+381734*r**20)+10*Q2**4*(
            -109867-1209570*r**2-11392600*r**4-31574505*r**6-41774110*r**8-13019714*r**10
            +40305072*r**12+39828068*r**14+11844409*r**16+1951060*r**18+473000*r**20
            +31301*r**22)+6*Q2**3*(-50340+781067*r**2+5168736*r**4+38211515*r**6
            +69499710*r**8+54759230*r**10-74790464*r**12-153546762*r**14-73101400*r**16
            -18665705*r**18-1475360*r**20-401713*r**22+35486*r**24)-6*Q2**2*(-78395
            -218569*r**2-5399041*r**4+6894523*r**6-214600*r**8+8852190*r**10-30017282*r**12
            -152017738*r**14-96701571*r**16+17983035*r**18+3366915*r**20+2380111*r**22
            +182214*r**24+44208*r**26)+18*Q2*(-9550-85533*r**2-1418646*r**4-838454*r**6
            -8525834*r**8-7278065*r**10+8297596*r**12-5415708*r**14-24762682*r**16
            +8738993*r**18+25771890*r**20+4535762*r**22+903954*r**24+80861*r**26
            +5416*r**28)-9*(-2450-38647*r**2-595954*r**4-547177*r**6-6253326*r**8
            -8391111*r**10+5816234*r**12+11008023*r**14-17007406*r**16-24446733*r**18
            +14639362*r**20+21900813*r**22+3360206*r**24+513483*r**26+43334*r**28
            +1349*r**30))*sqrtq2*(3+math.log(4)))+logq2**2*(-2880*r**10*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-104480*Q2**17+8*Q2**16*(150101+135817*r**2)
            -8*Q2**15*(709791+1424108*r**2+609837*r**4)+8*Q2**14*(1670155+6164498*r**2
            +5665821*r**4+1497790*r**6)-8*Q2**13*(1570775+13279952*r**2+19627106*r**4
            +11807174*r**6+2052205*r**8)+Q2**12*(-10951320+87823939*r**2+170092020*r**4
            +162375498*r**6+97625268*r**8+9276675*r**10)+4*Q2**11*(9892734+24693229*r**2
            +97819623*r**4+176570458*r**6+72594868*r**8-2378739*r**10+1841403*r**12)
            -2*Q2**10*(14469828+157336027*r**2+716700482*r**4+1881190105*r**6+1698206280*r**8
            +514798421*r**10+50180850*r**12+9261111*r**14)+4*Q2**9*(-4846770+63361633*r**2
            +350439261*r**4+1673827605*r**6+2375510525*r**8+1352556375*r**10+271078323*r**12
            +32232891*r**14+3352365*r**16)+Q2**8*(42913400+92962057*r**2+691377336*r**4
            -3114119876*r**6-7327078400*r**8-6371797290*r**10-2654978408*r**12-290389124*r**14
            -88671816*r**16+2729705*r**18)-8*Q2**7*(1878665+40114391*r**2+317972780*r**4
            +853863832*r**6+1861043472*r**8+2719556390*r**10+1492747966*r**12+266907120*r**14
            +15127487*r**16-4971133*r**18+1747270*r**20)+4*Q2**6*(-4119774+46067315*r**2
            +372895044*r**4+2848468779*r**6+8332675944*r**8+17957269110*r**10+16113018636*r**12
            +5851481694*r**14+603032454*r**16-23073081*r**18+4677472*r**20+2456967*r**22)
            +8*Q2**5*(1935887+8467725*r**2+106568217*r**4-511036475*r**6-1198700610*r**8
            -7844229138*r**10-11704337214*r**12-6396000186*r**14-1468763325*r**16
            -7450835*r**18-13472499*r**20-8600451*r**22+229304*r**24)+Q2**4*(-1225160
            -129316891*r**2-1370532012*r**4-4735543390*r**6-29611067900*r**8-17453038725*r**10
            +25962685992*r**12+35736518844*r**14+12054143520*r**16+2269446875*r**18
            +565030660*r**20+529648674*r**22+55416868*r**24-6068155*r**26)+12*Q2**3*(
            -289850+3480307*r**2+28949801*r**4+407821914*r**6+2161639620*r**8+4346643205*r**10
            +2935005991*r**12-1521190932*r**14-4694349898*r**16-2459787075*r**18
            -449400505*r**20-148392198*r**22-26994944*r**24-109941*r**26+174505*r**28)
            +6*Q2**2*(229020+2918719*r**2+45159970*r**4-109686807*r**6+502957768*r**8
            -4526104505*r**10-1116035738*r**12+4310241465*r**14+14975348124*r**16
            +11119907829*r**18+4091115470*r**20+16192019*r**22+102589440*r**24-17811067*r**26
            -3931222*r**28+189515*r**30)-36*Q2*(518+420867*r**2+5163363*r**4+25195443*r**6
            +286607943*r**8-372775221*r**10+820620947*r**12+27232299*r**14+475970739*r**16
            +1089967489*r**18-1711459887*r**20-451164495*r**22-176564787*r**24-14409807*r**26
            -4452807*r**28-379535*r**30+26931*r**32)+9*(-5568+332527*r**2+3686336*r**4
            +36352440*r**6+329849160*r**8-686961996*r**10+3464268304*r**12+268700232*r**14
            -8182983880*r**16+4018542330*r**18+8304862496*r**20-5770391864*r**22
            -1430620872*r**24-319818060*r**26-30912240*r**28-4639432*r**30-281592*r**32
            +21679*r**34))*(3+math.log(4))+2880*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17
            -8*Q2**16*(150101+135817*r**2)+8*Q2**15*(709791+1424108*r**2+609837*r**4)
            -8*Q2**14*(1670155+6164498*r**2+5665821*r**4+1497790*r**6)+8*Q2**13*(1570775
            +13279952*r**2+19627106*r**4+11807174*r**6+2052205*r**8)-Q2**12*(-10951320
            +87823939*r**2+170092020*r**4+162375498*r**6+97625268*r**8+9276675*r**10)
            -4*Q2**11*(9892734+24693229*r**2+97819623*r**4+176570458*r**6+72594868*r**8
            -2378739*r**10+1841403*r**12)+2*Q2**10*(14469828+157336027*r**2+716700482*r**4
            +1881190105*r**6+1698206280*r**8+514798421*r**10+50180850*r**12+9261111*r**14)
            -4*Q2**9*(-4846770+63361633*r**2+350439261*r**4+1673827605*r**6+2375510525*r**8
            +1352556375*r**10+271078323*r**12+32232891*r**14+3352365*r**16)+Q2**8*(
            -42913400-92962057*r**2-691377336*r**4+3114119876*r**6+7327078400*r**8
            +6371797290*r**10+2654978408*r**12+290389124*r**14+88671816*r**16-2729705*r**18)
            +8*Q2**7*(1878665+40114391*r**2+317972780*r**4+853863832*r**6+1861043472*r**8
            +2719556390*r**10+1492747966*r**12+266907120*r**14+15127487*r**16-4971133*r**18
            +1747270*r**20)-4*Q2**6*(-4119774+46067315*r**2+372895044*r**4+2848468779*r**6
            +8332675944*r**8+17957269110*r**10+16113018636*r**12+5851481694*r**14
            +603032454*r**16-23073081*r**18+4677472*r**20+2456967*r**22)-8*Q2**5*(1935887
            +8467725*r**2+106568217*r**4-511036475*r**6-1198700610*r**8-7844229138*r**10
            -11704337214*r**12-6396000186*r**14-1468763325*r**16-7450835*r**18-13472499*r**20
            -8600451*r**22+229304*r**24)+Q2**4*(1225160+129316891*r**2+1370532012*r**4
            +4735543390*r**6+29611067900*r**8+17453038725*r**10-25962685992*r**12
            -35736518844*r**14-12054143520*r**16-2269446875*r**18-565030660*r**20
            -529648674*r**22-55416868*r**24+6068155*r**26)-12*Q2**3*(-289850+3480307*r**2
            +28949801*r**4+407821914*r**6+2161639620*r**8+4346643205*r**10+2935005991*r**12
            -1521190932*r**14-4694349898*r**16-2459787075*r**18-449400505*r**20-148392198*r**22
            -26994944*r**24-109941*r**26+174505*r**28)-6*Q2**2*(229020+2918719*r**2
            +45159970*r**4-109686807*r**6+502957768*r**8-4526104505*r**10-1116035738*r**12
            +4310241465*r**14+14975348124*r**16+11119907829*r**18+4091115470*r**20
            +16192019*r**22+102589440*r**24-17811067*r**26-3931222*r**28+189515*r**30)
            +36*Q2*(518+420867*r**2+5163363*r**4+25195443*r**6+286607943*r**8-372775221*r**10
            +820620947*r**12+27232299*r**14+475970739*r**16+1089967489*r**18-1711459887*r**20
            -451164495*r**22-176564787*r**24-14409807*r**26-4452807*r**28-379535*r**30
            +26931*r**32)-9*(-5568+332527*r**2+3686336*r**4+36352440*r**6+329849160*r**8
            -686961996*r**10+3464268304*r**12+268700232*r**14-8182983880*r**16+4018542330*r**18
            +8304862496*r**20-5770391864*r**22-1430620872*r**24-319818060*r**26-30912240*r**28
            -4639432*r**30-281592*r**32+21679*r**34))*sqrtq2*(3+math.log(4)))+logq2*(96*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(54928*Q2**20-10*Q2**19*(66179+80571*r**2)
            +10*Q2**18*(315743+932826*r**2+454635*r**4)-10*Q2**17*(713027+4156451*r**2
            +4810467*r**4+1276291*r**6)+10*Q2**16*(491705+8279349*r**2+16884235*r**4
            +11757431*r**6+1673240*r**8)+2*Q2**15*(5923559-13876615*r**2-57271710*r**4
            -97945590*r**6-59156055*r**8+291279*r**10)-10*Q2**14*(2857988+19669647*r**2
            +75147541*r**4+120967604*r**6+44188566*r**8+6569403*r**10+3179247*r**12)
            +5*Q2**13*(2563602+71427359*r**2+416413088*r**4+1214635191*r**6+1097862886*r**8
            +332390965*r**10+60642984*r**12+6433205*r**14)+5*Q2**12*(5847972-19839849*r**2
            -287234445*r**4-2048826147*r**6-3137405283*r**8-1861102247*r**10-397686891*r**12
            -57953133*r**14+2841111*r**16)-10*Q2**11*(4072315+38356662*r**2+224264136*r**4
            -228097682*r**6-915369848*r**8-907956088*r**10-505111764*r**12-54829074*r**14
            -926967*r**16+4707430*r**18)+4*Q2**10*(307307+110393910*r**2+1170745425*r**4
            +4434888910*r**6+10006163165*r**8+15640213853*r**10+7814017520*r**12
            +1470662320*r**14+319685970*r**16+57863495*r**18+4510077*r**20)+5*Q2**9*(6524726
            +1654389*r**2-332977536*r**4-5253633789*r**6-16668936056*r**8-42558233486*r**10
            -38209590004*r**12-12439153626*r**14-2195790494*r**16-368681911*r**18
            -46755564*r**20+5179239*r**22)-5*Q2**8*(3840512+64911899*r**2+635093811*r**4
            -1309794993*r**6-4893941093*r**8-44191072906*r**10-64772250554*r**12
            -34209666554*r**14-6195004898*r**16-1286268433*r**18-197781337*r**20
            -9929301*r**22+4790695*r**24)-10*Q2**7*(878591-18460977*r**2-352827146*r**4
            -1980677810*r**6-9160838453*r**8-8905623285*r**10-7245547460*r**12-10083900548*r**14
            -4237010291*r**16-1165420083*r**18+269462462*r**20-41127194*r**22-13654759*r**24
            +418313*r**26)+10*Q2**6*(1259540+5803877*r**2-23532033*r**4-2109246552*r**6
            -9544382366*r**8-39759741061*r**10-79333297209*r**12-119098406816*r**14
            -69660249688*r**16-13983361421*r**18-381884731*r**20+264511880*r**22
            -105316878*r**24-14437827*r**26+1260165*r**28)+Q2**5*(-1429522-97736715*r**2
            -1617715640*r**4+2098864585*r**6-12171448290*r**8+280893888657*r**10
            +536428413960*r**12+1691496856965*r**14+1549238069610*r**16+526380826495*r**18
            +33108765192*r**20-5161804645*r**22+1307981450*r**24+484828155*r**26
            +10974120*r**28-2662377*r**30)-5*Q2**4*(677892-4948297*r**2-184875493*r**4
            -1835799047*r**6-12492555863*r**8-16769631217*r**10-130117787973*r**12
            +74508298201*r**14+214049147049*r**16+70032535581*r**18+9559984153*r**20
            -2592019133*r**22+2902206467*r**24+1216863773*r**26-43586543*r**28-12728853*r**30
            +616103*r**32)+30*Q2**3*(45654+417273*r**2+1417388*r**4-178221314*r**6
            -723747334*r**8-7139162596*r**10-26796182328*r**12-21945512406*r**14
            +1342738458*r**16+13720059258*r**18+16969717740*r**20+4420500082*r**22
            +1463384198*r**24+558599956*r**26+119452576*r**28-8390298*r**30-1005552*r**32
            +49245*r**34)+30*Q2**2*(9169-294388*r**2-7241173*r**4-11605536*r**6
            -384866858*r**8+2461427062*r**10-2492912204*r**12+21798649780*r**14-6278370596*r**16
            -25153597574*r**18-44294454506*r**20-30409099688*r**22-2275208286*r**24
            -1149771430*r**26-28432468*r**28+45300500*r**30+897755*r**32-277846*r**34
            +8287*r**36)-45*Q2*(6040-39833*r**2-1765902*r**4-25702367*r**6-191633484*r**8
            -669629844*r**10-6819671780*r**12+18100809572*r**14-23382970028*r**16
            -6747069582*r**18-9857533632*r**20+19868199534*r**22+4639058012*r**24
            +4640825532*r**26+322380516*r**28+82312436*r**30+43411204*r**32-781057*r**34
            -211762*r**36+6425*r**38)+9*(5222-10355*r**2-1056335*r**4-31511255*r**6
            -153685765*r**8-2010898828*r**10-6861747660*r**12+35126704580*r**14-161489742960*r**16
            +164166435670*r**18+133768147902*r**20-304538439490*r**22+98584777970*r**24
            +29670853060*r**26+12154764580*r**28+1458374292*r**30+101088130*r**32
            +57261285*r**34-1105095*r**36-220735*r**38+5787*r**40))*(3+math.log(4))
            -96*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(54928*Q2**21-2*Q2**20*(358359
            +430319*r**2)+20*Q2**19*(190961+539788*r**2+267603*r**4)-20*Q2**18*(514385
            +2702510*r**2+3098964*r**4+865463*r**6)+10*Q2**17*(1204732+13148827*r**2
            +25851153*r**4+17844189*r**6+2949531*r**8)-2*Q2**16*(-3465034+57731885*r**2
            +183089630*r**4+241153920*r**6+126309410*r**8+8074921*r**10)-2*Q2**15*(20213499
            +90395179*r**2+304589380*r**4+449620720*r**6+63841185*r**8-26017761*r**10
            +16187514*r**12)+5*Q2**14*(8279578+116482629*r**2+606047464*r**4+1606865481*r**6
            +1428175226*r**8+433906903*r**10+80140284*r**12+12791699*r**14)-10*Q2**13*(
            -1642185+46915405*r**2+387537446*r**4+1839937213*r**6+2724951680*r**8
            +1645678049*r**10+395360420*r**12+62514661*r**14+1796047*r**16)-5*Q2**12*(13992602
            +62721447*r**2+141453978*r**4-2792255956*r**6-7016971126*r**8-6814419706*r**10
            -3269012666*r**12-565298172*r**14-56965956*r**16+12255971*r**18)+2*Q2**11*(20976189
            +432932705*r**2+3654594840*r**4+8850610090*r**6+14294988680*r**8+22163798026*r**10
            +8562695780*r**12+141620450*r**14+360591735*r**16+134629305*r**18+32557304*r**20)
            +Q2**10*(31394402-434532923*r**2-6789445020*r**4-48690706285*r**6-141108888580*r**8
            -315376675502*r**10-284864875512*r**12-99334487490*r**14-18140345630*r**16
            -3353607415*r**18-483272108*r**20+7855887*r**22)-10*Q2**9*(5182619+36545507*r**2
            +151885332*r**4-3448203159*r**6-13408255469*r**8-51709121224*r**10-72770037022*r**12
            -42429205092*r**14-10414974509*r**16-1925370419*r**18-306609406*r**20
            -25752813*r**22+4984967*r**24)+5*Q2**8*(2083330+105674365*r**2+1405660002*r**4
            +3286654438*r**6+12117940820*r**8-31273767429*r**10-94472228540*r**12
            -78814116012*r**14-31930650870*r**16-5150433165*r**18-2022974694*r**20
            -125456250*r**22+22170912*r**24+3954069*r**26)+10*Q2**7*(2138131-11778509*r**2
            -394820156*r**4-4442751508*r**6-20685898629*r**8-57826202799*r**10-95484467954*r**12
            -136427854824*r**14-83981160527*r**16-19385791795*r**18-1277842352*r**20
            +492847148*r**22-160098831*r**24-27674273*r**26+1678478*r**28)+Q2**6*(
            -14024922-168370885*r**2-1440434080*r**4+23426650435*r**6+104364840890*r**8
            +773935122927*r**10+1727358796660*r**12+3675813897215*r**14+3436824634650*r**16
            +1362816937585*r**18+176761226712*r**20-3988076135*r**22-283968570*r**24
            +1682375205*r**26+142750740*r**28-15264027*r**30)-2*Q2**5*(979969-61953861*r**2
            -1319914910*r**4-4348923145*r**6-36267681510*r**8+92437142141*r**10+83366681376*r**12
            +1300233380965*r**14+2155490330910*r**16+1212890787005*r**18+303644756226*r**20
            +7493432441*r**22+5328604570*r**24+3938564235*r**26+138934780*r**28-27666261*r**30
            +209069*r**32)+5*Q2**4*(951816-1766767*r**2-181319462*r**4-3090002424*r**6
            -18670838914*r**8-72097162656*r**10-307664513158*r**12-187282564208*r**14
            +296613875998*r**16+366402038178*r**18+181410826174*r**20+33490965512*r**22
            +9090492522*r**24+7470669976*r**26+1889992686*r**28-106657184*r**30-18146062*r**32
            +911573*r**34)-30*Q2**3*(36485+757315*r**2+9075834*r**4-165198390*r**6
            -517101790*r**8-10324336992*r**10-31442432720*r**12-70540344514*r**14
            -14324403352*r**16+40216395290*r**18+74984231504*r**20+51799317510*r**22
            +8159092566*r**24+3171755584*r**26+706485000*r**28+65761778*r**30-10293605*r**32
            -678461*r**34+40958*r**36)-15*Q2**2*(36458-689937*r**2-20368828*r**4
            -114800519*r**6-1367845240*r**8+2144230876*r**10-20521985624*r**12+92913903868*r**14
            -39108351716*r**16-83105145086*r**18-168468705056*r**20-89802509786*r**22
            -51451441912*r**24+7072517164*r**26-1389266248*r**28+280673372*r**30
            +222630122*r**32-1103353*r**34-1174404*r**36+35849*r**38)+18*Q2*(17711
            -89660*r**2-5042505*r**4-84426300*r**6-620182510*r**8-3158607734*r**10
            -22154127890*r**12+45766196770*r**14-93950272620*r**16+6758118810*r**18
            +25372565916*r**20-127242554990*r**22+110560532850*r**24+38035135390*r**26
            +18485397410*r**28+1740919526*r**30+364853165*r**32+135206010*r**34-3034595*r**36
            -623710*r**38+18956*r**40)-9*(5222-5133*r**2-1066690*r**4-32567590*r**6
            -185197020*r**8-2164584593*r**10-8872646488*r**12+28264956920*r**14-126363038380*r**16
            +2676692710*r**18+297934583572*r**20-170770291588*r**22-205953661520*r**24
            +128255631030*r**26+41825617640*r**28+13613138872*r**30+1559462422*r**32
            +158349415*r**34+56156190*r**36-1325830*r**38-214948*r**40+5787*r**42))*sqrtq2*(3
            +math.log(4)))))/(-630000*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))
            -630000*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2+logq2**6*(28217548800000*r**26*(1
            +r**2)*(-1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -28217548800000*r**26*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**3*(21772800000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))+21772800000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))*sqrtq2)+logq2*(75600000*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)
            -Q2**2*(5+2*r**2+5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))+75600000*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)-Q2**2*(5+2*r**2
            +5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))*sqrtq2)+logq2**2*(-453600000*(
            -Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(16*Q2**4+Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1
            +9*r**2+9*r**4+r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))-453600000*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(16*Q2**4
            +Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1+9*r**2+9*r**4
            +r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))*sqrtq2)+logq2**4*(-65318400000*(
            -Q2+(-1+r)**2)*r**18*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))
            -65318400000*(-Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))*sqrtq2)
            +logq2**5*(313528320000*(-Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41
            +74*r**2+41*r**4)-18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2
            -222*r**4-82*r**6+13*r**8))+313528320000*(-Q2+(-1+r)**2)*r**22*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2
            +41*r**4)-18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4
            -82*r**6+13*r**8))*sqrtq2))+((16*(Q2-(-1+r)**2)**6*r**6*(1-Q2+r**2)*(Q2
            -(1+r)**2)**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(92*Q2**23
            -24*Q2**22*(9+529*r**2)+8*Q2**21*(750-34744*r**2+35337*r**4)+Q2**20*(
            -90307+28097151*r**2+5955527*r**4-2546731*r**6)+2*Q2**19*(264765-159011084*r**2
            -264134074*r**4-26128476*r**6+6387465*r**8)+Q2**18*(-1608918+1557992374*r**2
            +5433091772*r**4+3759583828*r**6+255396410*r**8-40580778*r**10)+2*Q2**17*(1273047
            -1909743410*r**2-11568168845*r**4-15873520140*r**6-7130528527*r**8-389369962*r**10
            +43147797*r**12)+Q2**16*(-979335+3337463151*r**2+42882233625*r**4+88606711287*r**6
            +88927306911*r**8+32081718249*r**10+1544260287*r**12-124606239*r**14)
            +8*Q2**15*(-489534+784398217*r**2+547333293*r**4+4268342466*r**6-3932352830*r**8
            -15220602723*r**10-5298823143*r**12-247530764*r**14+15025578*r**16)-8*Q2**14*(
            -917845+2604089472*r**2+21631670482*r**4+92025669519*r**6+154012368996*r**8
            +66681694321*r**10-5228966652*r**12-3172730793*r**14-196033397*r**16
            +9626105*r**18)+8*Q2**13*(-377181+2330767331*r**2+37210402078*r**4+195929154261*r**6
            +529782763985*r**8+486647500591*r**10+172394041779*r**12+13797776147*r**14
            +1497913012*r**16-102502170*r**18+5761479*r**20)-2*Q2**12*(3113643-5705019203*r**2
            +34804664485*r**4+312216580799*r**6+2380901355926*r**8+3173368868146*r**10
            +2212557743258*r**12+755684077958*r**14+100415613799*r**16+17141527049*r**18
            -406766919*r**20+27794403*r**22)+4*Q2**11*(2307695-9727607474*r**2-104716598704*r**4
            -639520007716*r**6-756113421387*r**8-1357220705516*r**10-1232502274800*r**12
            +132036342840*r**14+246527242849*r**16+59705806046*r**18+6001503152*r**20
            -352056276*r**22+16704779*r**24)-4*Q2**10*(502473-6262317139*r**2-138822820874*r**4
            -1047744750696*r**6-3307915682893*r**8-6915049502423*r**10-10256130135696*r**12
            -5309958448300*r**14-562630389245*r**16+198356950323*r**18+66391991546*r**20
            +755097556*r**22-319638111*r**24+9701559*r**26)-4*Q2**9*(1504215-3950175764*r**2
            +18858199961*r**4+250554114310*r**6+2740013707261*r**8+5166097208606*r**10
            +15813888752635*r**12+12664257741364*r**14+4990516593257*r**16+267134492176*r**18
            -111582023129*r**20-36112990618*r**22+1406660611*r**24+43146374*r**26
            +1240965*r**28)+2*Q2**8*(2985141-16504742209*r**2-213396642607*r**4-1715921187705*r**6
            -1621840198155*r**8-13752153467521*r**10+9039751865025*r**12+7432322587095*r**14
            +7564941362591*r**16+6326915926845*r**18+527910766419*r**20+325019958677*r**22
            +56576793591*r**24+2276791237*r**26-292836005*r**28+9389901*r**30)-4*Q2**7*(177399
            -3365864358*r**2-93340065990*r**4-870705038484*r**6-2880476025304*r**8
            -13086822600194*r**10-11366360089074*r**12-16069095917728*r**14-10858436354078*r**16
            +2001476814390*r**18+3806612877494*r**20+609423826012*r**22+289492790472*r**24
            +49897234866*r**26+721852098*r**28-69291240*r**30+807159*r**32)-8*Q2**6*(299460
            -1160185409*r**2+241909794*r**4+16383178101*r**6+845947629974*r**8+1369181230123*r**10
            +7601624582876*r**12+3674114185343*r**14+9719327057908*r**16+710539898639*r**18
            -2593113253414*r**20-1296367810757*r**22-235117131970*r**24-72206249219*r**26
            -4485127128*r**28-171035439*r**30-37259660*r**32+1223178*r**34)+8*Q2**5*(215041
            -1474000803*r**2-21649024529*r**4-215947336941*r**6-63672213223*r**8
            -4635407744329*r**10+7480611572313*r**12-17290512370509*r**14+12718465238651*r**16
            -3393180451775*r**18+1670764907247*r**20-1323159609967*r**22+313162398123*r**24
            -136427726123*r**26-21090850037*r**28+12403824681*r**30+25399872*r**32
            -45081770*r**34+962878*r**36)+Q2**4*(-206055+3368056763*r**2+95418592723*r**4
            +989445018969*r**6+2508904148532*r**8+31263438125292*r**10-48461647584036*r**12
            +217626013002532*r**14-207850719151186*r**16+86616720325626*r**18+29016589691866*r**20
            -39382888544482*r**22+8354215671972*r**24-4896397090980*r**26+972016452972*r**28
            +163997865972*r**30-71162004895*r**32-344314877*r**34+98907147*r**36
            -1107855*r**38)-2*Q2**3*(161379-772360448*r**2-945171034*r**4-30506384372*r**6
            +700982073515*r**8-147129009696*r**10+2942014197096*r**12+25028519309408*r**14
            -70636386305402*r**16+71961953600000*r**18-29556895207356*r**20+31941155609272*r**22
            -8464754106514*r**24+3728325724000*r**26-582535542360*r**28+120476034624*r**30
            -6114676745*r**32-2726570560*r**34+154317574*r**36-28058980*r**38+718599*r**40)
            +3*(-1+r**2)**2*(1631-16542161*r**2-387153498*r**4-5242192586*r**6-4850601365*r**8
            -335415024261*r**10+1861044487400*r**12-11263574626936*r**14+38527223282718*r**16
            -81067563244770*r**18+90471547886692*r**20-49088937684444*r**22+14952834323566*r**24
            -4807353871378*r**26-295717218840*r**28-165975875000*r**30-24132821693*r**32
            -7772639757*r**34+169150246*r**36+7643350*r**38-566937*r**40+8023*r**42)
            +2*Q2**2*(99877-736383161*r**2-10442751650*r**4-132183010154*r**6+225405416945*r**8
            -5947677894505*r**10+24172857827808*r**12-82180335504928*r**14+134392569399554*r**16
            -100276930547018*r**18+20669690011500*r**20-11187365256036*r**22+5059231299106*r**24
            -10662344128946*r**26-1656659619824*r**28-429534693168*r**30-167786685383*r**32
            -91147446653*r**34+5646495046*r**36+219733022*r**38-25630579*r**40+469147*r**42)
            -6*Q2*(8315-73705550*r**2-1358505037*r**4-17139905960*r**6+18290991541*r**8
            -1005807228954*r**10+5658669411269*r**12-26932946143248*r**14+76614098227630*r**16
            -126448759467708*r**18+100714300688062*r**20-21721027204832*r**22-11534560744214*r**24
            +7763521037020*r**26-4783833594582*r**28-586397858672*r**30-192070995993*r**32
            -33803380630*r**34-20079276065*r**36+723439624*r**38+30183249*r**40-2575394*r**42
            +40129*r**44))+16*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(92*Q2**23-24*Q2**22*(9
            +529*r**2)+8*Q2**21*(750-34744*r**2+35337*r**4)+Q2**20*(-90307+28097151*r**2
            +5955527*r**4-2546731*r**6)+2*Q2**19*(264765-159011084*r**2-264134074*r**4
            -26128476*r**6+6387465*r**8)+Q2**18*(-1608918+1557992374*r**2+5433091772*r**4
            +3759583828*r**6+255396410*r**8-40580778*r**10)+2*Q2**17*(1273047-1909743410*r**2
            -11568168845*r**4-15873520140*r**6-7130528527*r**8-389369962*r**10+43147797*r**12)
            +Q2**16*(-979335+3337463151*r**2+42882233625*r**4+88606711287*r**6+88927306911*r**8
            +32081718249*r**10+1544260287*r**12-124606239*r**14)+8*Q2**15*(-489534
            +784398217*r**2+547333293*r**4+4268342466*r**6-3932352830*r**8-15220602723*r**10
            -5298823143*r**12-247530764*r**14+15025578*r**16)-8*Q2**14*(-917845+2604089472*r**2
            +21631670482*r**4+92025669519*r**6+154012368996*r**8+66681694321*r**10
            -5228966652*r**12-3172730793*r**14-196033397*r**16+9626105*r**18)+8*Q2**13*(
            -377181+2330767331*r**2+37210402078*r**4+195929154261*r**6+529782763985*r**8
            +486647500591*r**10+172394041779*r**12+13797776147*r**14+1497913012*r**16
            -102502170*r**18+5761479*r**20)-2*Q2**12*(3113643-5705019203*r**2+34804664485*r**4
            +312216580799*r**6+2380901355926*r**8+3173368868146*r**10+2212557743258*r**12
            +755684077958*r**14+100415613799*r**16+17141527049*r**18-406766919*r**20
            +27794403*r**22)+4*Q2**11*(2307695-9727607474*r**2-104716598704*r**4
            -639520007716*r**6-756113421387*r**8-1357220705516*r**10-1232502274800*r**12
            +132036342840*r**14+246527242849*r**16+59705806046*r**18+6001503152*r**20
            -352056276*r**22+16704779*r**24)-4*Q2**10*(502473-6262317139*r**2-138822820874*r**4
            -1047744750696*r**6-3307915682893*r**8-6915049502423*r**10-10256130135696*r**12
            -5309958448300*r**14-562630389245*r**16+198356950323*r**18+66391991546*r**20
            +755097556*r**22-319638111*r**24+9701559*r**26)-4*Q2**9*(1504215-3950175764*r**2
            +18858199961*r**4+250554114310*r**6+2740013707261*r**8+5166097208606*r**10
            +15813888752635*r**12+12664257741364*r**14+4990516593257*r**16+267134492176*r**18
            -111582023129*r**20-36112990618*r**22+1406660611*r**24+43146374*r**26
            +1240965*r**28)+2*Q2**8*(2985141-16504742209*r**2-213396642607*r**4-1715921187705*r**6
            -1621840198155*r**8-13752153467521*r**10+9039751865025*r**12+7432322587095*r**14
            +7564941362591*r**16+6326915926845*r**18+527910766419*r**20+325019958677*r**22
            +56576793591*r**24+2276791237*r**26-292836005*r**28+9389901*r**30)-4*Q2**7*(177399
            -3365864358*r**2-93340065990*r**4-870705038484*r**6-2880476025304*r**8
            -13086822600194*r**10-11366360089074*r**12-16069095917728*r**14-10858436354078*r**16
            +2001476814390*r**18+3806612877494*r**20+609423826012*r**22+289492790472*r**24
            +49897234866*r**26+721852098*r**28-69291240*r**30+807159*r**32)-8*Q2**6*(299460
            -1160185409*r**2+241909794*r**4+16383178101*r**6+845947629974*r**8+1369181230123*r**10
            +7601624582876*r**12+3674114185343*r**14+9719327057908*r**16+710539898639*r**18
            -2593113253414*r**20-1296367810757*r**22-235117131970*r**24-72206249219*r**26
            -4485127128*r**28-171035439*r**30-37259660*r**32+1223178*r**34)+8*Q2**5*(215041
            -1474000803*r**2-21649024529*r**4-215947336941*r**6-63672213223*r**8
            -4635407744329*r**10+7480611572313*r**12-17290512370509*r**14+12718465238651*r**16
            -3393180451775*r**18+1670764907247*r**20-1323159609967*r**22+313162398123*r**24
            -136427726123*r**26-21090850037*r**28+12403824681*r**30+25399872*r**32
            -45081770*r**34+962878*r**36)+Q2**4*(-206055+3368056763*r**2+95418592723*r**4
            +989445018969*r**6+2508904148532*r**8+31263438125292*r**10-48461647584036*r**12
            +217626013002532*r**14-207850719151186*r**16+86616720325626*r**18+29016589691866*r**20
            -39382888544482*r**22+8354215671972*r**24-4896397090980*r**26+972016452972*r**28
            +163997865972*r**30-71162004895*r**32-344314877*r**34+98907147*r**36
            -1107855*r**38)-2*Q2**3*(161379-772360448*r**2-945171034*r**4-30506384372*r**6
            +700982073515*r**8-147129009696*r**10+2942014197096*r**12+25028519309408*r**14
            -70636386305402*r**16+71961953600000*r**18-29556895207356*r**20+31941155609272*r**22
            -8464754106514*r**24+3728325724000*r**26-582535542360*r**28+120476034624*r**30
            -6114676745*r**32-2726570560*r**34+154317574*r**36-28058980*r**38+718599*r**40)
            +3*(-1+r**2)**2*(1631-16542161*r**2-387153498*r**4-5242192586*r**6-4850601365*r**8
            -335415024261*r**10+1861044487400*r**12-11263574626936*r**14+38527223282718*r**16
            -81067563244770*r**18+90471547886692*r**20-49088937684444*r**22+14952834323566*r**24
            -4807353871378*r**26-295717218840*r**28-165975875000*r**30-24132821693*r**32
            -7772639757*r**34+169150246*r**36+7643350*r**38-566937*r**40+8023*r**42)
            +2*Q2**2*(99877-736383161*r**2-10442751650*r**4-132183010154*r**6+225405416945*r**8
            -5947677894505*r**10+24172857827808*r**12-82180335504928*r**14+134392569399554*r**16
            -100276930547018*r**18+20669690011500*r**20-11187365256036*r**22+5059231299106*r**24
            -10662344128946*r**26-1656659619824*r**28-429534693168*r**30-167786685383*r**32
            -91147446653*r**34+5646495046*r**36+219733022*r**38-25630579*r**40+469147*r**42)
            -6*Q2*(8315-73705550*r**2-1358505037*r**4-17139905960*r**6+18290991541*r**8
            -1005807228954*r**10+5658669411269*r**12-26932946143248*r**14+76614098227630*r**16
            -126448759467708*r**18+100714300688062*r**20-21721027204832*r**22-11534560744214*r**24
            +7763521037020*r**26-4783833594582*r**28-586397858672*r**30-192070995993*r**32
            -33803380630*r**34-20079276065*r**36+723439624*r**38+30183249*r**40-2575394*r**42
            +40129*r**44))*sqrtq2+logq2**8*(-20316635136000000*r**38*(1+r**2)**2*(1
            -Q2+r**2)*(-1-115*r**2+141*r**4+71*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3-20316635136000000*(Q2-(-1+r)**2)**2*r**38*(1+r**2)**2*(-1-115*r**2
            +141*r**4+71*r**6)*(Q2-(1+r)**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**7*(-32248627200000*r**32*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(5110*Q2**9*(1+r**2)-10*Q2**8*(4891+6872*r**2+1981*r**4)+20*Q2**7*(9855
            +17414*r**2+8294*r**4+735*r**6)-2*Q2**6*(216664+445647*r**2+267651*r**4
            +44849*r**6+1029*r**8)+2*Q2**5*(270319+620621*r**2+439028*r**4+82720*r**6
            +28623*r**8+34629*r**10)-Q2**4*(306600+828889*r**2+713397*r**4+256766*r**6
            +125914*r**8+147749*r**10+66885*r**12)+Q2**3*(-102200-10939*r**2+98224*r**4
            +80937*r**6+350840*r**8+289067*r**10-281344*r**12-293545*r**14)+6*(
            -1+r**2)**2*(6497+9228*r**2+11426*r**4-45792*r**6-70670*r**8+93368*r**10
            +84982*r**12+44444*r**14+27797*r**16)+Q2**2*(286160+327931*r**2+217141*r**4
            -59881*r**6-559079*r**8+242173*r**10+443459*r**12+904561*r**14+697375*r**16)
            -3*Q2*(58984+33375*r**2+18838*r**4-175482*r**6-501654*r**8+279476*r**10
            +899410*r**12+317442*r**14+169542*r**16+190309*r**18))+32248627200000*r**32*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(5110*Q2**10*(1+r**2)-20*Q2**9*(2701
            +3947*r**2+1246*r**4)+10*Q2**8*(24601+46591*r**2+25441*r**4+3451*r**6)
            -2*Q2**7*(315214+718337*r**2+524731*r**4+135139*r**6+8379*r**8)+14*Q2**6*(69569
            +183276*r**2+164618*r**4+56460*r**6+10643*r**8+5094*r**10)-Q2**5*(847238
            +2610769*r**2+2832695*r**4+1300262*r**6+348600*r**8+274253*r**10+136143*r**12)
            -10*Q2**4*(-20440-112455*r**2-164051*r**4-105110*r**6-73352*r**8-56273*r**10
            +6671*r**12+22666*r**14)+2*Q2**3*(194180+220535*r**2+64928*r**4-119521*r**6
            -495428*r**8-198867*r**10+217868*r**12+739725*r**14+495460*r**16)-6*(
            -1+r**2)**2*(6497+15725*r**2+20654*r**4-34366*r**6-116462*r**8+22698*r**10
            +178350*r**12+129426*r**14+72241*r**16+27797*r**18)-2*Q2**2*(231556
            +357108*r**2+300793*r**4-184593*r**6-1061961*r**8+260761*r**10+1691931*r**12
            +1150173*r**14+1055281*r**16+634151*r**18)+3*Q2*(71978+84827*r**2+51147*r**4
            -275476*r**6-612456*r**8+155654*r**10+834038*r**12+1152548*r**14+534766*r**16
            +337551*r**18+245903*r**20))*sqrtq2)+logq2**6*(-179159040000*r**28*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-81760*Q2**13*(1+r**2)
            +60*Q2**12*(26293+44826*r**2+18533*r**4)-30*Q2**11*(386032+939167*r**2
            +747118*r**4+193983*r**6)+4*Q2**10*(11301228+35542685*r**2+40858691*r**4
            +20303871*r**6+3676333*r**8)-60*Q2**9*(1713030+6646266*r**2+9864404*r**4
            +6946007*r**6+2285340*r**8+270501*r**10)-30*Q2**8*(-4289430-20870913*r**2
            -37818637*r**4-33348958*r**6-14770466*r**8-2617789*r**10+40873*r**12)
            +5*Q2**7*(-9088788-86363225*r**2-192280034*r**4-189702847*r**6-95319760*r**8
            -16080539*r**10+8298270*r**12+3756299*r**14)-30*Q2**6*(3697176+6525253*r**2
            +10031098*r**4+17933785*r**6+15760782*r**8+7319711*r**10+3030118*r**12
            +1206499*r**14+383642*r**16)+3*Q2**5*(59542092+203463475*r**2+459326004*r**4
            +691811754*r**6+546735312*r**8+206612952*r**10+60566020*r**12+20279614*r**14
            -5821636*r**16-1820003*r**18)+20*Q2**4*(-4495945-20830932*r**2-51998837*r**4
            -82855370*r**6-74872229*r**8-36479870*r**10-18346763*r**12-17826290*r**14
            -9307202*r**16-388810*r**18+804568*r**20)-15*Q2**3*(1848676-3026753*r**2
            -2706554*r**4+856811*r**6-7285156*r**8-22713970*r**10-49337368*r**12
            -33431770*r**14+18091808*r**16+19301107*r**18+2415154*r**20+2041135*r**22)
            +18*(-1+r**2)**2*(249234+564063*r**2+3448675*r**4+8525525*r**6+5393369*r**8
            -14593030*r**10-18712554*r**12+4866366*r**14+23224380*r**16+32947111*r**18
            +19306951*r**20+2218221*r**22+299289*r**24)+30*Q2**2*(1883512+2309413*r**2
            +12671142*r**4+26318515*r**6+22041724*r**8+140266*r**10-20314532*r**12
            -12385010*r**14+26906200*r**16+64326849*r**18+39555678*r**20+4621423*r**22
            +1268820*r**24)-45*Q2*(591788+578165*r**2+5055220*r**4+8986968*r**6
            +2289424*r**8-19514415*r**10-24779048*r**12+20219408*r**14+38106012*r**16
            +20176511*r**18+30383412*r**20+23227928*r**22+2543272*r**24+515515*r**26))
            +179159040000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(81760*Q2**13*(1
            +r**2)-60*Q2**12*(26293+44826*r**2+18533*r**4)+30*Q2**11*(386032+939167*r**2
            +747118*r**4+193983*r**6)-4*Q2**10*(11301228+35542685*r**2+40858691*r**4
            +20303871*r**6+3676333*r**8)+60*Q2**9*(1713030+6646266*r**2+9864404*r**4
            +6946007*r**6+2285340*r**8+270501*r**10)+30*Q2**8*(-4289430-20870913*r**2
            -37818637*r**4-33348958*r**6-14770466*r**8-2617789*r**10+40873*r**12)
            +5*Q2**7*(9088788+86363225*r**2+192280034*r**4+189702847*r**6+95319760*r**8
            +16080539*r**10-8298270*r**12-3756299*r**14)+30*Q2**6*(3697176+6525253*r**2
            +10031098*r**4+17933785*r**6+15760782*r**8+7319711*r**10+3030118*r**12
            +1206499*r**14+383642*r**16)+3*Q2**5*(-59542092-203463475*r**2-459326004*r**4
            -691811754*r**6-546735312*r**8-206612952*r**10-60566020*r**12-20279614*r**14
            +5821636*r**16+1820003*r**18)-20*Q2**4*(-4495945-20830932*r**2-51998837*r**4
            -82855370*r**6-74872229*r**8-36479870*r**10-18346763*r**12-17826290*r**14
            -9307202*r**16-388810*r**18+804568*r**20)+15*Q2**3*(1848676-3026753*r**2
            -2706554*r**4+856811*r**6-7285156*r**8-22713970*r**10-49337368*r**12
            -33431770*r**14+18091808*r**16+19301107*r**18+2415154*r**20+2041135*r**22)
            -18*(-1+r**2)**2*(249234+564063*r**2+3448675*r**4+8525525*r**6+5393369*r**8
            -14593030*r**10-18712554*r**12+4866366*r**14+23224380*r**16+32947111*r**18
            +19306951*r**20+2218221*r**22+299289*r**24)-30*Q2**2*(1883512+2309413*r**2
            +12671142*r**4+26318515*r**6+22041724*r**8+140266*r**10-20314532*r**12
            -12385010*r**14+26906200*r**16+64326849*r**18+39555678*r**20+4621423*r**22
            +1268820*r**24)+45*Q2*(591788+578165*r**2+5055220*r**4+8986968*r**6
            +2289424*r**8-19514415*r**10-24779048*r**12+20219408*r**14+38106012*r**16
            +20176511*r**18+30383412*r**20+23227928*r**22+2543272*r**24+515515*r**26))*sqrtq2)
            +logq2**5*(-995328000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(327040*Q2**17
            -160*Q2**16*(95489+83849*r**2)+10*Q2**15*(17094385+28541266*r**2+11704033*r**4)
            -2*Q2**14*(471158679+1166271461*r**2+935747877*r**4+242409687*r**6)+2*Q2**13*(1517963931
            +5118987460*r**2+6208104952*r**4+3203409936*r**6+585482433*r**8)-2*Q2**12*(2916810279
            +13300960952*r**2+22103772920*r**4+17442052886*r**6+6601749825*r**8+929873682*r**10)
            +4*Q2**11*(1397216238+9905883644*r**2+21494608314*r**4+22843998806*r**6
            +13617685679*r**8+4385544300*r**10+577295079*r**12)-Q2**10*(-1417979382
            +22315340965*r**2+61863266584*r**4+70668002023*r**6+59224813598*r**8
            +40197703675*r**10+16411299288*r**12+2874739089*r**14)+Q2**9*(-11067520584
            -30550443781*r**2-102547578817*r**4-238685033657*r**6-248358940265*r**8
            -99226835099*r**10+4772778089*r**12+14666295033*r**14+3637666473*r**16)
            +2*Q2**8*(6219459763+36094865335*r**2+147830910546*r**4+372041235878*r**6
            +479766786154*r**8+305934106398*r**10+79167373730*r**12-6945997154*r**14
            -8485075377*r**16-1840794041*r**18)+2*Q2**7*(-1278007427-26826164236*r**2
            -124983588065*r**4-393502159648*r**6-627219266790*r**8-496023835208*r**10
            -173033870866*r**12+8334395760*r**14+27842857057*r**16+8516928340*r**18
            +1285851979*r**20)-2*Q2**6*(3719125817+1834585276*r**2+31722505381*r**4
            -20858674236*r**6-162892474014*r**8-163070906358*r**10-36873215778*r**12
            +41489576886*r**14+40929779109*r**16+20525803786*r**18+4811236205*r**20
            +598124006*r**22)+6*Q2**5*(1287071881+6090566015*r**2+48652858223*r**4
            +109665407791*r**6+136295373096*r**8+124494608436*r**10+76881392676*r**12
            +30628624476*r**14+5659339671*r**16-4282757779*r**18-897548675*r**20
            +470097301*r**22+31446248*r**24)+6*Q2**4*(-332103843-4302446012*r**2
            -33000454884*r**4-90186367674*r**6-129770909275*r**8-129899043774*r**10
            -87670488816*r**12-42744829692*r**14-34117315857*r**16-22074069960*r**18
            -1128915868*r**20+2754167718*r**22-208476609*r**24+89878546*r**26)-108*Q2**3*(14607661
            -33957845*r**2+117860162*r**4-878985934*r**6-925447392*r**8+148870133*r**10
            -620918445*r**12-2849065424*r**14-3746552187*r**16-1225106631*r**18+202783456*r**20
            +20892190*r**22+314143662*r**24+12450471*r**26+7498123*r**28)+54*(-1
            +r**2)**2*(1082583+11201401*r**2+149934473*r**4+140073283*r**6+757013701*r**8
            +1815456903*r**10+715090203*r**12-2126759931*r**14-3658688591*r**16-997644217*r**18
            +5065359215*r**20+4972775021*r**22+1041404083*r**24+223189433*r**26+18652141*r**28
            +372299*r**30)+9*Q2**2*(162890458+517272039*r**2+9275886780*r**4+4804440277*r**6
            +20873477010*r**8+53040793683*r**10+31538192692*r**12-19340049375*r**14
            -38585104914*r**16+10413953285*r**18+99278286660*r**20+84106580319*r**22
            +17119554470*r**24+6646329537*r**26+521765580*r**28+59395499*r**30)-27*Q2*(17652364
            +101520767*r**2+1551300147*r**4-41594477*r**6+4692968667*r**8+10445863987*r**10
            -2395630817*r**12-16648866089*r**14-1751863121*r**16+9023490461*r**18
            +1765057449*r**20+23548032793*r**22+27662322017*r**24+5348842673*r**26
            +1564648197*r**28+138086525*r**30+6264457*r**32))+995328000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(327040*Q2**18-480*Q2**17*(32511+28631*r**2)
            +10*Q2**16*(18622209+31410674*r**2+13045617*r**4)-8*Q2**15*(139157651
            +348612429*r**2+284243593*r**4+75232463*r**6)+60*Q2**14*(66304087+225213920*r**2
            +277004143*r**4+146052250*r**6+27596404*r**8)-2*Q2**13*(4434774210+19937912343*r**2
            +33430865332*r**4+26853567774*r**6+10390642194*r**8+1515356115*r**10)
            +2*Q2**12*(5711242755+36029538519*r**2+78393950500*r**4+85233823418*r**6
            +51279174069*r**8+16302712107*r**10+2084463840*r**12)-3*Q2**11*(1390295190
            +22509246831*r**2+62488411472*r**4+82674143501*r**6+68357183846*r**8
            +37403541197*r**10+12087552268*r**12+1727973135*r**14)+2*Q2**10*(-6242749983
            -4826541099*r**2-9184485634*r**4-53076882525*r**6-59233062322*r**8+97841087*r**10
            +30690890526*r**12+16976166705*r**14+3256202781*r**16)-5*Q2**9*(-4701288022
            -22761539007*r**2-85751968738*r**4-217063016846*r**6-289315509246*r**8
            -191890797632*r**10-50557760894*r**12+6666213486*r**14+7054822452*r**16
            +1463850911*r**18)+12*Q2**8*(-1249577865-11523414889*r**2-51484893991*r**4
            -152229051012*r**6-246504548137*r**8-213620787960*r**10-93022558499*r**12
            -10647830136*r**14+7212321598*r**16+3140466293*r**18+521107670*r**20)
            -2*Q2**7*(2441118390-26269586387*r**2-120087246920*r**4-539344421949*r**6
            -1183613900452*r**8-1286314008356*r**10-705930921852*r**12-123209898220*r**14
            +77107031926*r**16+56885589183*r**18+14614016524*r**20+1883975985*r**22)
            +4*Q2**6*(3790170730+11912704569*r**2+89757832663*r**4+169930027259*r**6
            +112567485519*r**8+23760222468*r**10+15350027946*r**12+48251117268*r**14
            +49698687504*r**16+24303654779*r**18+11322196983*r**20+3409826057*r**22
            +346231375*r**24)+12*Q2**5*(-809587862-5840041954*r**2-43871939561*r**4
            -124252316844*r**6-187865845081*r**8-195344512653*r**10-144523244964*r**12
            -75127423422*r**14-35202640002*r**16-11725325926*r**18+2025695293*r**20
            +1590809546*r**22-355010079*r**24+29216149*r**26)-30*Q2**4*(-13833189
            -1049158213*r**2-7036283596*r**4-27801713874*r**6-47323066001*r**8-51398058131*r**10
            -45749212920*r**12-36339699228*r**14-28860016983*r**16-15648661035*r**18
            -3910576724*r**20+400262254*r**22+1640055405*r**24+21102083*r**26+44968952*r**28)
            +9*Q2**3*(338182390+285069831*r**2+10282714584*r**4-4329068987*r**6-779722902*r**8
            +43721866575*r**10+25873612948*r**12-60979855803*r**14-117732516246*r**16
            -49245952531*r**18+87010408560*r**20+86790688071*r**22+21139984694*r**24
            +10565459133*r**26+761148708*r**28+149372975*r**30)-54*(-1+r**2)**2*(1082583
            +12283984*r**2+161135874*r**4+290007756*r**6+897086984*r**8+2572470604*r**10
            +2530547106*r**12-1411669728*r**14-5785448522*r**16-4656332808*r**18
            +4067714998*r**20+10038134236*r**22+6014179104*r**24+1264593516*r**26
            +241841574*r**28+19024440*r**30+372299*r**32)-18*Q2**2*(107923775+492362399*r**2
            +7223529630*r**4+6977771813*r**6+19878411644*r**8+52625931327*r**10+38696046962*r**12
            -18874227475*r**14-31590371826*r**16-550340123*r**18+57493706146*r**20
            +127014482679*r**22+92106550420*r**24+19906206013*r**26+5931019854*r**28
            +497710327*r**30+39094435*r**32)+27*Q2*(19817530+137245601*r**2+1910049422*r**4
            +1212517146*r**6+5904977406*r**8+16021838222*r**10+3732613366*r**12-22527463774*r**14
            -15780886262*r**16+15657573408*r**18+17592466026*r**20+13001914990*r**22
            +43532781322*r**24+39237477266*r**26+8140845586*r**28+2075249622*r**30
            +180166068*r**32+7009055*r**34))*sqrtq2)+logq2**4*(16588800*r**20*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-15434240*Q2**20+320*Q2**19*(905653
            +743275*r**2)-8*Q2**18*(290918343+490741426*r**2+199496427*r**4)+2*Q2**17*(5229685576
            +13814654033*r**2+11597485386*r**4+3097821889*r**6)-8*Q2**16*(3523742269
            +13498915373*r**2+17648817525*r**4+9783432223*r**6+1939898266*r**8)+2*Q2**15*(21366403032
            +124399922853*r**2+227565947840*r**4+195741189376*r**6+82561914460*r**8
            +13345203663*r**10)-3*Q2**14*(6129932640+101160879675*r**2+245157822283*r**4
            +284216471966*r**6+197392266162*r**8+75242858255*r**10+11310865035*r**12)
            +Q2**13*(-58399112808+22432842099*r**2+49551162594*r**4-178965778567*r**6
            +28287820636*r**8+341175486801*r**10+209941543314*r**12+36455878443*r**14)
            +Q2**12*(119117263104+555769666617*r**2+2299255336485*r**4+5760786730969*r**6
            +6558666874737*r**8+3201553570715*r**10+371797342551*r**12-161002313421*r**14
            -37017925389*r**16)+2*Q2**11*(-34946722592-437787506364*r**2-2265101497602*r**4
            -7287249351003*r**6-11320193849036*r**8-8906611466469*r**10-3486378531018*r**12
            -478915439433*r**14+65323058016*r**16+15313373677*r**18)+Q2**10*(-58524657392
            +444162278947*r**2+2856382241481*r**4+15340702350284*r**6+32400392697900*r**8
            +34426703158650*r**10+21187502163854*r**12+7526360954044*r**14+1177485911628*r**16
            -66119686565*r**18-11208392543*r**20)-Q2**9*(-119176209960-404886469025*r**2
            -3001134490398*r**4-1587128602531*r**6+4060152570628*r**8+4846612699850*r**10
            +6646544788600*r**12+8718290681862*r**14+5503309631764*r**16+1481067291303*r**18
            +61771643350*r**20+10692093165*r**22)+Q2**8*(-53848239152-811531381699*r**2
            -6959478619365*r**4-23437950195521*r**6-54520192491347*r**8-91818995803686*r**10
            -85188464432026*r**12-34327095274634*r**14+756605858514*r**16+5534181189433*r**18
            +1851481267055*r**20+152125102971*r**22+18335660737*r**24)-2*Q2**7*(16741861832
            -228901841009*r**2-2025492787332*r**4-12500685807854*r**6-35818860858068*r**8
            -72963443140311*r**10-85575520498992*r**12-49033681666656*r**14-7969059355440*r**16
            +5476642479757*r**18+3380041981508*r**20+809605492350*r**22+69741881612*r**24
            +5601991403*r**26)+Q2**6*(47526865824+120471607533*r**2+1888480679033*r**4
            -5146093255546*r**6-10621873999702*r**8-47998313805561*r**10-94034429572137*r**12
            -66321314593980*r**14-7678295511492*r**16+15336860519451*r**18+12426302513847*r**20
            +4447188220534*r**22+821274287482*r**24+84259716913*r**26+648135801*r**28)
            +3*Q2**5*(-4670719816-108865310529*r**2-1309985539334*r**4-3767828881683*r**6
            -17942267418180*r**8-28154305287013*r**10-19259680807634*r**12-11395251596535*r**14
            -8482651789008*r**16-2907478036355*r**18+1174065478278*r**20+271364814743*r**22
            -345211146276*r**24-69937934679*r**26-12816657710*r**28+1681023731*r**30)
            -3*Q2**4*(2316752000-55575003625*r**2-575069406817*r**4-3531505878989*r**6
            -15375923269913*r**8-28374468728045*r**10-25500220598565*r**12-16951851854721*r**14
            -11065312670157*r**16-8051758685099*r**18-4647862396595*r**20+503330084905*r**22
            +1178011262213*r**24-160622564479*r**26+15352935737*r**28+772195365*r**30
            +1424626785*r**32)+18*Q2**3*(337714928+617992806*r**2+22984069934*r**4
            -149286550059*r**6-69806921348*r**8-1058943819965*r**10-585903346286*r**12
            +494513108989*r**14-898552013912*r**16-2463988677569*r**18-2064116640654*r**20
            -1074707755481*r**22-416310195300*r**24+246313501121*r**26+689588942*r**28
            +12995267591*r**30+1615942736*r**32+44733527*r**34)+27*(-1+r**2)**2*(1902408
            -109331867*r**2-1456093759*r**4-8942545832*r**6-65163587420*r**8-2384014404*r**10
            -167569279504*r**12-513943269768*r**14-234236040604*r**16+850471383790*r**18
            +1199727272234*r**20-512576199416*r**22-1260167629012*r**24-368313381796*r**26
            -116483502120*r**28-16656918488*r**30-1423710588*r**32-56143211*r**34
            +4289357*r**36)+9*Q2**2*(-145147288-5408868439*r**2-76253404769*r**4
            -126003465720*r**6-1837596850672*r**8+145279347212*r**10-1979211424260*r**12
            -6010365763240*r**14-897083482272*r**16+3691366761494*r**18+891252155890*r**20
            -7841031654088*r**22-8895744275088*r**24-2363805732596*r**26-1317546303572*r**28
            -165733415064*r**30-33185398088*r**32-2974770903*r**34+102091463*r**36)
            -27*Q2*(3411944-770159127*r**2-9425935898*r**4-32469896993*r**6-313698978076*r**8
            +271674868528*r**10-600785412964*r**12-1379286859896*r**14+607469664804*r**16
            +872049744378*r**18+372106347912*r**20+1489395109934*r**22-1462680892564*r**24
            -3404338680104*r**26-869157602428*r**28-358723190384*r**30-51887205468*r**32
            -6199884267*r**34-404381582*r**36+22732251*r**38))-16588800*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(15434240*Q2**20-320*Q2**19*(905653+743275*r**2)
            +8*Q2**18*(290918343+490741426*r**2+199496427*r**4)-2*Q2**17*(5229685576
            +13814654033*r**2+11597485386*r**4+3097821889*r**6)+8*Q2**16*(3523742269
            +13498915373*r**2+17648817525*r**4+9783432223*r**6+1939898266*r**8)-2*Q2**15*(21366403032
            +124399922853*r**2+227565947840*r**4+195741189376*r**6+82561914460*r**8
            +13345203663*r**10)+3*Q2**14*(6129932640+101160879675*r**2+245157822283*r**4
            +284216471966*r**6+197392266162*r**8+75242858255*r**10+11310865035*r**12)
            -Q2**13*(-58399112808+22432842099*r**2+49551162594*r**4-178965778567*r**6
            +28287820636*r**8+341175486801*r**10+209941543314*r**12+36455878443*r**14)
            +Q2**12*(-119117263104-555769666617*r**2-2299255336485*r**4-5760786730969*r**6
            -6558666874737*r**8-3201553570715*r**10-371797342551*r**12+161002313421*r**14
            +37017925389*r**16)+2*Q2**11*(34946722592+437787506364*r**2+2265101497602*r**4
            +7287249351003*r**6+11320193849036*r**8+8906611466469*r**10+3486378531018*r**12
            +478915439433*r**14-65323058016*r**16-15313373677*r**18)+Q2**10*(58524657392
            -444162278947*r**2-2856382241481*r**4-15340702350284*r**6-32400392697900*r**8
            -34426703158650*r**10-21187502163854*r**12-7526360954044*r**14-1177485911628*r**16
            +66119686565*r**18+11208392543*r**20)+Q2**9*(-119176209960-404886469025*r**2
            -3001134490398*r**4-1587128602531*r**6+4060152570628*r**8+4846612699850*r**10
            +6646544788600*r**12+8718290681862*r**14+5503309631764*r**16+1481067291303*r**18
            +61771643350*r**20+10692093165*r**22)+Q2**8*(53848239152+811531381699*r**2
            +6959478619365*r**4+23437950195521*r**6+54520192491347*r**8+91818995803686*r**10
            +85188464432026*r**12+34327095274634*r**14-756605858514*r**16-5534181189433*r**18
            -1851481267055*r**20-152125102971*r**22-18335660737*r**24)+2*Q2**7*(16741861832
            -228901841009*r**2-2025492787332*r**4-12500685807854*r**6-35818860858068*r**8
            -72963443140311*r**10-85575520498992*r**12-49033681666656*r**14-7969059355440*r**16
            +5476642479757*r**18+3380041981508*r**20+809605492350*r**22+69741881612*r**24
            +5601991403*r**26)-Q2**6*(47526865824+120471607533*r**2+1888480679033*r**4
            -5146093255546*r**6-10621873999702*r**8-47998313805561*r**10-94034429572137*r**12
            -66321314593980*r**14-7678295511492*r**16+15336860519451*r**18+12426302513847*r**20
            +4447188220534*r**22+821274287482*r**24+84259716913*r**26+648135801*r**28)
            +3*Q2**5*(4670719816+108865310529*r**2+1309985539334*r**4+3767828881683*r**6
            +17942267418180*r**8+28154305287013*r**10+19259680807634*r**12+11395251596535*r**14
            +8482651789008*r**16+2907478036355*r**18-1174065478278*r**20-271364814743*r**22
            +345211146276*r**24+69937934679*r**26+12816657710*r**28-1681023731*r**30)
            +3*Q2**4*(2316752000-55575003625*r**2-575069406817*r**4-3531505878989*r**6
            -15375923269913*r**8-28374468728045*r**10-25500220598565*r**12-16951851854721*r**14
            -11065312670157*r**16-8051758685099*r**18-4647862396595*r**20+503330084905*r**22
            +1178011262213*r**24-160622564479*r**26+15352935737*r**28+772195365*r**30
            +1424626785*r**32)-18*Q2**3*(337714928+617992806*r**2+22984069934*r**4
            -149286550059*r**6-69806921348*r**8-1058943819965*r**10-585903346286*r**12
            +494513108989*r**14-898552013912*r**16-2463988677569*r**18-2064116640654*r**20
            -1074707755481*r**22-416310195300*r**24+246313501121*r**26+689588942*r**28
            +12995267591*r**30+1615942736*r**32+44733527*r**34)-27*(-1+r**2)**2*(1902408
            -109331867*r**2-1456093759*r**4-8942545832*r**6-65163587420*r**8-2384014404*r**10
            -167569279504*r**12-513943269768*r**14-234236040604*r**16+850471383790*r**18
            +1199727272234*r**20-512576199416*r**22-1260167629012*r**24-368313381796*r**26
            -116483502120*r**28-16656918488*r**30-1423710588*r**32-56143211*r**34
            +4289357*r**36)-9*Q2**2*(-145147288-5408868439*r**2-76253404769*r**4
            -126003465720*r**6-1837596850672*r**8+145279347212*r**10-1979211424260*r**12
            -6010365763240*r**14-897083482272*r**16+3691366761494*r**18+891252155890*r**20
            -7841031654088*r**22-8895744275088*r**24-2363805732596*r**26-1317546303572*r**28
            -165733415064*r**30-33185398088*r**32-2974770903*r**34+102091463*r**36)
            +27*Q2*(3411944-770159127*r**2-9425935898*r**4-32469896993*r**6-313698978076*r**8
            +271674868528*r**10-600785412964*r**12-1379286859896*r**14+607469664804*r**16
            +872049744378*r**18+372106347912*r**20+1489395109934*r**22-1462680892564*r**24
            -3404338680104*r**26-869157602428*r**28-358723190384*r**30-51887205468*r**32
            -6199884267*r**34-404381582*r**36+22732251*r**38))*sqrtq2)+logq2**3*(
            -276480*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(128129280*Q2**23-64*Q2**22*(30517857
            +26688769*r**2)+2*Q2**21*(6566682813+11964328154*r**2+5191617821*r**4)
            -6*Q2**20*(8291270063+24680654835*r**2+22184203801*r**4+6255606741*r**6)
            +20*Q2**19*(5484150336+25757073049*r**2+36590152016*r**4+21649233813*r**6
            +4437901342*r**8)-10*Q2**18*(11403207654+102884521031*r**2+206878013530*r**4
            +193355283576*r**6+88757914400*r**8+14453232545*r**10)+12*Q2**17*(-5281003564
            +72999106597*r**2+188794024030*r**4+229506943420*r**6+203600368075*r**8
            +96229629401*r**10+14369988797*r**12)+Q2**16*(365747337546+982614274763*r**2
            +4035032909672*r**4+9471758673285*r**6+7107191233230*r**8+582449048861*r**10
            -914111456232*r**12-169207072213*r**14)+Q2**15*(-421318312728-3753078183425*r**2
            -18342084592821*r**4-52948699217301*r**6-66529715916705*r**8-37216247891983*r**10
            -7443795606315*r**12+397467596869*r**14+144893984569*r**16)-15*Q2**14*(1602353224
            -271047472159*r**2-1688538396716*r**4-7151598854416*r**6-12623682234148*r**8
            -10967248960306*r**10-4834772000196*r**12-882712473184*r**14+599528652*r**16
            +4423032513*r**18)-5*Q2**13*(-111157622148-29564481671*r**2+521797261515*r**4
            +16381985923260*r**6+43613769831156*r**8+52648620490114*r**10+37917472384542*r**12
            +15668030144484*r**14+2900651979600*r**16+90702352485*r**18+15201201751*r**20)
            +Q2**12*(-499218391308-5289752687371*r**2-39309426737230*r**4-83232282158775*r**6
            -131189135601000*r**8-203828901076682*r**10-114579963465444*r**12+38435488896510*r**14
            +53448609497460*r**16+14418283641045*r**18+1211814198002*r**20+162210039929*r**22)
            -3*Q2**11*(25957405448-1793243250921*r**2-16903852363769*r**4-87770927110455*r**6
            -253644563127455*r**8-528376472394798*r**10-588264181099054*r**12-311906019660866*r**14
            -56341530871690*r**16+11282164788695*r**18+4747468642023*r**20+532790935609*r**22
            +26646525921*r**24)-Q2**10*(-428272108752+260015654015*r**2+9318734530576*r**4
            +234452187214626*r**6+890438874429200*r**8+2615354799141857*r**10+4026609287029440*r**12
            +3230696052613324*r**14+1370282964642704*r**16+241118510334705*r**18-23087360158672*r**20
            -8965066962350*r**22-1007752177104*r**24+69924158831*r**26)+5*Q2**9*(
            -45857126688-772320407717*r**2-7446707950663*r**4-3941521268502*r**6
            -4504229693402*r**8+215366149661253*r**10+571426773562095*r**12+629537275676060*r**14
            +424055457596356*r**16+192390732057525*r**18+47723298844807*r**20+1424939835386*r**22
            +195601358454*r**24+119714731*r**26+21060568849*r**28)-15*Q2**8*(6121109932
            -201979546573*r**2-2475313644070*r**4-15852745068367*r**6-74477521678184*r**8
            -161636577213233*r**10-233088402141114*r**12-274593833985051*r**14-169840711570900*r**16
            -8732342458599*r**18+42330319327078*r**20+20240609618835*r**22+2951460765584*r**24
            +481105491173*r**26+38190754810*r**28+1787932759*r**30)+Q2**7*(147236712312
            +46563962989*r**2-4800708143495*r**4-205486405707195*r**6-1031300574378375*r**8
            -3875253434527507*r**10-7823211868097079*r**12-11689492518338035*r**14
            -10281750642848895*r**16-3817147731307665*r**18+450919269454163*r**20
            +904864531807271*r**22+326118034227075*r**24+49873323745335*r**26+6311125929835*r**28
            +548585352327*r**30-32459011061*r**32)+Q2**6*(-34177573704-1364009510797*r**2
            -14807201559948*r**4+15842179281540*r**6-37896021593220*r**8+1609338327009404*r**10
            +3038031670155492*r**12+6570755539686508*r**14+8419319034553180*r**16
            +3844918659725490*r**18-574145403592676*r**20-1495068135476388*r**22-772934316822732*r**24
            -189502102114020*r**26-29164443804020*r**28-2516071989324*r**30-187179688132*r**32
            +22770753347*r**34)+3*Q2**5*(-10004082186+239532094615*r**2+3623415761363*r**4
            +32628064488688*r**6+221635108277280*r**8+374170871425216*r**10+1520013124936320*r**12
            +1621049329281032*r**14+317108184680292*r**16+189683206937870*r**18+311088405909206*r**20
            -15469954390880*r**22-5511028114048*r**24+52493275858632*r**26+15512361365000*r**28
            +4469315330664*r**30-78122145530*r**32-53095249197*r**34+1208275663*r**36)
            -15*Q2**4*(-1301932922-2368471223*r**2+105726646308*r**4+4617363743541*r**6
            +26125257130720*r**8+101188199076392*r**10+328902058174976*r**12+421401194236704*r**14
            +189299783395852*r**16+89951992097666*r**18+129016026136632*r**20+71186145488082*r**22
            -31079522303952*r**24-34762900641952*r**26+1699362201088*r**28+313578436648*r**30
            +373170039390*r**32-73447012435*r**34-14157313116*r**36+586471601*r**38)
            +45*Q2**3*(-16810600-3771484967*r**2-39158149515*r**4+121805930979*r**6
            -599209923969*r**8+12246947397000*r**10+6664791285880*r**12+35873183933104*r**14
            -4746133256624*r**16-16521852977102*r**18+54982084512378*r**20+75103012818686*r**22
            +58635562748742*r**24+30751925052576*r**26-5152103836464*r**28+1413392812904*r**30
            -499340032624*r**32-89740199731*r**34-17322507831*r**36-1280175865*r**38
            +51663043*r**40)+54*(-1+r**2)**2*(-2074497-11441249*r**2+656250140*r**4
            +23047283000*r**6+151508659095*r**8+602660482663*r**10+3831379742536*r**12
            -4130449108520*r**14+7455453986150*r**16+31905899196390*r**18-4978712796032*r**20
            -63352660079064*r**22-10827896478130*r**24+45015031627950*r**26+14719737957560*r**28
            +7180167823688*r**30+1465617164891*r**32+179825144635*r**34+21553932900*r**36
            -60129920*r**38-106140197*r**40+2196011*r**42)+9*Q2**2*(-311778932+6940406201*r**2
            +130123226860*r**4+1674391200270*r**6+12788292833400*r**8+4728134212553*r**10
            +203014449833776*r**12-114815662272200*r**14+129716341460520*r**16+345504451252530*r**18
            -133927178285912*r**20-96217131007804*r**22+397883814232320*r**24+514412676046650*r**26
            +141634640464240*r**28+133942594991768*r**30+18533883690476*r**32+5498832558645*r**34
            +1014631130060*r**36+31873684830*r**38-4490051352*r**40+113371101*r**42)
            -27*Q2*(-36961088+243562381*r**2+11830342099*r**4+278456845970*r**6
            +1671979940250*r**8+3067882420817*r**10+35932390584611*r**12-61093414461016*r**14
            +63905775916040*r**16+131208707614250*r**18-39908408667098*r**20-82697929785444*r**22
            -177732130930996*r**24+3772230570010*r**26+239866750426750*r**28+64895586222472*r**30
            +41661594863656*r**32+7815843933769*r**34+1237285914855*r**36+205283481250*r**38
            +2334500522*r**40-1136809579*r**42+26075519*r**44))+276480*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(128129280*Q2**24-64*Q2**23*(32519877
            +28690789*r**2)+2*Q2**22*(7543254237+13794940186*r**2+6045658429*r**4)
            -4*Q2**21*(15720246501+46286487736*r**2+41854278689*r**4+11979219022*r**6)
            +2*Q2**20*(79715313549+356486505184*r**2+506496096068*r**4+301811769756*r**6
            +63145833643*r**8)-10*Q2**19*(22371508326+165366967801*r**2+331572463660*r**4
            +309834055234*r**6+140932184710*r**8+23329035229*r**10)+Q2**18*(50660033772
            +2018866566014*r**2+5363153633970*r**4+6756416292100*r**6+5264336396660*r**8
            +2186867022262*r**10+316972191014*r**12)+Q2**17*(429119380314+169997038367*r**2
            +893515342148*r**4+4452147063885*r**6+1909903495290*r**8-3015510920851*r**10
            -2241306874608*r**12-341646937777*r**14)+2*Q2**16*(-393532825137-2550719897867*r**2
            -11679865888628*r**4-33227745400129*r**6-41554332911610*r**8-22452944087037*r**10
            -3556066599472*r**12+740393062657*r**14+157050528391*r**16)+Q2**15*(397283014368
            +8240108578538*r**2+47423238726986*r**4+178564766626362*r**6+308833648646226*r**8
            +268254698213278*r**10+117181623501238*r**12+20287015107206*r**14-551354511218*r**16
            -211239472264*r**18)-10*Q2**14*(-57982340910+389385437567*r**2+3200277434070*r**4
            +21451198838328*r**6+51469806548424*r**8+61710707036738*r**10+42661767633024*r**12
            +16410241782312*r**14+2773495406598*r**16+37817334495*r**18+966052106*r**20)
            +2*Q2**13*(-527503251024-2996681603233*r**2-18424131419005*r**4+643316882550*r**6
            +84394821585540*r**8+138741525264834*r**10+169125250453918*r**12+153181500770820*r**14
            +73146010058940*r**16+14687527650735*r**18+870665984591*r**20+119108024342*r**22)
            +2*Q2**12*(210673087482+5584350415721*r**2+47655368257954*r**4+192927245113685*r**6
            +487677553571070*r**8+960073726931038*r**10+1041600703919644*r**12+505931266775766*r**14
            +38570247110550*r**16-50856693752295*r**18-14936251882558*r**20-1486198522379*r**22
            -121074808846*r**24)+2*Q2**11*(253072162548-2780936595217*r**2-32705010687323*r**4
            -274238262818649*r**6-957342672571465*r**8-2480708952854308*r**10-3688265623755498*r**12
            -2965603327446542*r**14-1237512808120186*r**16-188148304291845*r**18+35588130225413*r**20
            +12402922847623*r**22+1343032280847*r**24+5007709466*r**26)+2*Q2**10*(
            -328778871096-2014929246661*r**2-13827394784362*r**4+112031657701346*r**6
            +551184956588408*r**8+2291312210938661*r**10+4749548976990886*r**12+5202495859011532*r**14
            +3360628152618904*r**16+1286677567632517*r**18+228323822200034*r**20-12463863972046*r**22
            -4497406173592*r**24-468614722309*r**26+87613501538*r**28)-10*Q2**9*(
            -13746898446-712058087062*r**2-7822484645295*r**4-29473232212133*r**6
            -115939157998228*r**8-137023905835924*r**10+43763858400003*r**12+188591273641501*r**14
            +272035299279858*r**16+295124581139042*r**18+183552494441783*r**20+54935033768349*r**22
            +5237461745296*r**24+819518773352*r**26+67876274005*r**28+13212183563*r**30)
            -2*Q2**8*(-119526680646+1445656293313*r**2+22480053001570*r**4+240203643196875*r**6
            +1193127287788320*r**8+3708482458949381*r**10+6872043279206142*r**12+9652363030115255*r**14
            +8474134413094080*r**16+3247871770875075*r**18-477444461240674*r**20-921714232997983*r**22
            -336999544996680*r**24-50680908798345*r**26-7050284809790*r**28-574132832931*r**30
            +2820009838*r**32)+2*Q2**7*(-90707143008-778905093049*r**2-5026528689721*r**4
            +113064646566115*r**6+599445479246175*r**8+3257946167957643*r**10+7368248486390039*r**12
            +13041729963060811*r**14+15195281097870055*r**16+8971908516941025*r**18
            +1396041529130413*r**20-1425425968368911*r**22-1001958441428539*r**24
            -282746730043215*r**26-42674446739595*r**28-4687891635743*r**30-351653014699*r**32
            +27614882204*r**34)+2*Q2**6*(2082663573+1058391684173*r**2+13520729177417*r**4
            +48424607872236*r**6+343479583571760*r**8-224464845570268*r**10-43665311177968*r**12
            -2372819610999452*r**14-7019375010099406*r**16-5847594036732530*r**18
            -1168754019202598*r**20+1011401837948212*r**22+1125734683978488*r**24
            +559958123256324*r**26+132601815006520*r**28+22544230892668*r**30+1234442620433*r**32
            +2561593597*r**34-9572963179*r**36)-6*Q2**5*(-8256873398+108842828157*r**2
            +2195790543759*r**4+29669149483878*r**6+192444729209784*r**8+550873487542228*r**10
            +1769347143618208*r**12+2624034212700436*r**14+1442328215470292*r**16
            +478275676053246*r**18+572925871765118*r**20+325774589479368*r**22-88189297012344*r**24
            -63416127732588*r**26+38251224114536*r**28+10774784439452*r**30+3128521691042*r**32
            -249226228451*r**34-61336769557*r**36+2070316834*r**38)+30*Q2**4*(-676182361
            -7492429523*r**2-7058136730*r**4+2544254091393*r**6+14472495551177*r**8
            +82027149199056*r**10+225042315554504*r**12+428961402105496*r**14+298231288931342*r**16
            +114843108281106*r**18+191957135885716*r**20+212755605040386*r**22+108006655715178*r**24
            +13206676105912*r**26-24259924975128*r**28+3126559538224*r**30-405635810917*r**32
            +15251213881*r**34-69785924522*r**36-8705684555*r**38+370730365*r**40)
            -18*Q2**3*(113862966-12940942018*r**2-172385699635*r**4-630576146475*r**6
            -7587656399175*r**8+26755276576301*r**10-54227878209688*r**12+163752769183560*r**14
            +12959455960940*r**16-225922191210580*r**18+163114167981146*r**20+373321308831562*r**22
            +135404531802410*r**24-33737618520030*r**26-6817767191840*r**28-76318075054784*r**30
            -6981809894538*r**32-4222116860210*r**34-774972333935*r**36-62443551655*r**38
            -826256379*r**40+72472057*r**42)-54*(-1+r**2)**2*(-2074497-13515746*r**2
            +644808891*r**4+23703533140*r**6+174555942095*r**8+754169141758*r**10
            +4434040225199*r**12-299069365984*r**14+3325004877630*r**16+39361353182540*r**18
            +26927186400358*r**20-68331372875096*r**22-74180556557194*r**24+34187135149820*r**26
            +59734769585510*r**28+21899905781248*r**30+8645784988579*r**32+1645442309526*r**34
            +201379077535*r**36+21493802980*r**38-166270117*r**40-103944186*r**42
            +2196011*r**44)-18*Q2**2*(-211331098+3679657206*r**2+86277329679*r**4
            +1319942482520*r**6+9739311927210*r**8+13360037154202*r**10+157769877900081*r**12
            -47540727910736*r**14+103309003468220*r**16+434423457777900*r**18+45926023482662*r**20
            -239119049325024*r**22-115764854784236*r**24+461806590994500*r**26+687823783895570*r**28
            +235131997061712*r**30+138730631636606*r**32+23740124025214*r**34+5112660716635*r**36
            +831177629320*r**38+17193567522*r**40-3893554494*r**42+95798829*r**44)
            +27*Q2*(-41110082+192016783*r**2+13428020762*r**4+333733871011*r**6
            +2162577472690*r**8+5385243256013*r**10+44555407878038*r**12-47542120098263*r**14
            +41907825346476*r**16+220843567761430*r**18-31369815458172*r**20-165585009033762*r**22
            -38632638948508*r**24-167323571350694*r**26+71362537443820*r**28+350273783722258*r**30
            +110207220036278*r**32+58334956074507*r**34+11308171465666*r**36+1715883693935*r**38
            +250754086858*r**40+1506383913*r**42-1331798498*r**44+30467541*r**46))*sqrtq2)
            +logq2**2*(4608*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(
            -243716608*Q2**26+32*Q2**25*(115076989+115288069*r**2)-4*Q2**24*(5970036385
            +13042742146*r**2+6081034465*r**4)+Q2**23*(84332156560+314333444026*r**2
            +312979566276*r**4+92466061210*r**6)-4*Q2**22*(40287049910+254284460251*r**2
            +404197880033*r**4+262322541641*r**6+56496110285*r**8)+4*Q2**21*(23302248850
            +424176084869*r**2+939875801684*r**4+991607495999*r**6+537725777884*r**8
            +94110118270*r**10)-2*Q2**20*(-144815651660+189204450237*r**2+163098436395*r**4
            -126806151770*r**6+1445900215440*r**8+1352588354817*r**10+222091808245*r**12)
            +Q2**19*(-716671132340-4447032141389*r**2-21346365384570*r**4-52797800082275*r**6
            -45008545281200*r**8-10207155820575*r**10+1802187839686*r**12+364651532215*r**14)
            +2*Q2**18*(223628472380+4486797039173*r**2+27629652211208*r**4+98444840009945*r**6
            +135866584452800*r**8+81095445869495*r**10+17684462490608*r**12+96620553323*r**14
            -59462660020*r**16)-Q2**17*(-647203845060+4940453840359*r**2+48544051038972*r**4
            +322622066743474*r**6+652595492558200*r**8+614158150750200*r**10+289790324192764*r**12
            +55386032427622*r**14+2287711010244*r**16+247389695865*r**18)+2*Q2**16*(
            -657203063010-4185647529677*r**2-23844143107607*r**4+48025571484748*r**6
            +220557456533228*r**8+296275081951822*r**10+272283541470898*r**12+140649404343068*r**14
            +28137995569198*r**16+2125881305703*r**18+228966407805*r**20)-4*Q2**15*(
            -110190015060-4226683262354*r**2-40324907111105*r**4-153305184971365*r**6
            -360211565176345*r**8-654074764876063*r**10-520220924253943*r**12-117643300655305*r**14
            +30287945950085*r**16+11821425031105*r**18+1392485730336*r**20+43637808030*r**22)
            -4*Q2**14*(-246253741940+1928539413676*r**2+31840740229245*r**4+288712795408300*r**6
            +992663166603550*r**8+2514857878048800*r**10+3138113708372134*r**12+1855006597931920*r**14
            +451946306718600*r**16+4559702089300*r**18-8513041004435*r**20-1066762152924*r**22
            +91036358590*r**24)+4*Q2**13*(-272873172160-2570452705361*r**2-17291778183751*r**4
            +149515714074455*r**6+786370657809100*r**8+3422826835825865*r**10+6218109195166946*r**12
            +5544485498900146*r**14+2607687447658940*r**16+563107808468225*r**18+21986397494005*r**20
            +35967701399*r**22+76218106664*r**24+113019066215*r**26)-4*Q2**12*(12271347460
            -3917439905119*r**2-50701616191402*r**4-202067019106564*r**6-662870537041885*r**8
            +261978553370675*r**10+2891165173130009*r**12+3968228504406032*r**14+3424043548602494*r**16
            +1864494840433175*r**18+488899746511940*r**20+55871065326596*r**22+11271187176923*r**24
            +1119536165221*r**26+1871549485*r**28)-2*Q2**11*(-366863309620+2013489823647*r**2
            +54344676586812*r**4+758457542569007*r**6+3766171078035842*r**8+11611244759990601*r**10
            +21060565287803198*r**12+30719547788602133*r**14+23355700680404088*r**16
            +5835346110401753*r**18-1510018183169344*r**20-920741888051103*r**22-185880645363238*r**24
            -25195506144993*r**26-1859974565658*r**28+137295661115*r**30)+4*Q2**10*(
            -84768781780-1940193394621*r**2-17916037502655*r**4+171415683378095*r**6
            +1187929044712810*r**8+8108544343153427*r**10+20910318601872959*r**12
            +42874621649179855*r**14+48910339580413280*r**16+27851471289831065*r**18
            +6643201795418479*r**20-419022121478083*r**22-380682291841630*r**24-79811465664655*r**26
            -2337743076015*r**28+208450543589*r**30+22594320680*r**32)+2*Q2**9*(-100155884420
            +3601532396143*r**2+58242567996430*r**4+302216286698800*r**6+1314276487020500*r**8
            -5316841004600650*r**10-17846115092031118*r**12-70767969787891660*r**14
            -120323078151787600*r**16-98992319507021800*r**18-46339094311422670*r**20
            -11234019756764968*r**22+22025856253460*r**24+152796418785250*r**26+47466809572750*r**28
            -10696398084860*r**30-1677129150932*r**32+62503078945*r**34)-4*Q2**8*(
            -54629838565+47224846751*r**2+7989447761211*r**4+228502698804350*r**6
            +1430145126126525*r**8+5209499863383660*r**10+17377762201649479*r**12
            +21507689423453434*r**14+11389684248907455*r**16+7172013166277750*r**18
            -2146750448266295*r**20-9244124260742766*r**22-5431071785933921*r**24
            -1032349950863340*r**26-235220549591475*r**28-23100709986250*r**30-3865067681014*r**32
            -387400811349*r**34+20482472360*r**36)-2*Q2**7*(3714634720+1490555570117*r**2
            +16677138385636*r**4-148383898367333*r**6-1299153123619790*r**8-14093036360052150*r**10
            -48822274209612382*r**12-128547831173661086*r**14-188831432410613902*r**16
            -220999831299639380*r**18-143455871929936230*r**20-20320817171629072*r**22
            +23738936953234214*r**24+13764815099569238*r**26+3031523072805750*r**28
            +540835327236910*r**30+73880288453462*r**32+1047137968111*r**34-463975881878*r**36
            +13966915045*r**38)+4*Q2**6*(-15613667870+357782461499*r**2+6802612563674*r**4
            +59025338305889*r**6+277477964678839*r**8-2227121606151812*r**10-4132770454760224*r**12
            -40595362733977724*r**14-57673823913759164*r**16-90886802040706614*r**18
            -82904030454728916*r**20-18060625157799474*r**22+17662182255292126*r**24
            +15199615105039436*r**26+4944336546122336*r**28+964391336524948*r**30
            +116312334201074*r**32+22110256245299*r**34-148471785286*r**36-262667562311*r**38
            +8741864275*r**40)+12*Q2**5*(1660647250+26488505798*r**2-181135292155*r**4
            -20681215912650*r**6-145566542861300*r**8-780523901812853*r**10-4274066476535744*r**12
            -2397153867373520*r**14-16840483524604100*r**16-10652970923709100*r**18
            +4875834304906074*r**20-229939257726636*r**22-1099601089232120*r**24-593832895292050*r**26
            -1138710873953800*r**28-359711771298064*r**30-146071015476238*r**32-4894040719330*r**34
            +787238680425*r**36+67805348950*r**38+874255468*r**40+60255695*r**42)
            -6*Q2**4*(-1235700660+79608890539*r**2+861937638075*r**4-9640744592250*r**6
            -108824737983650*r**8-1622896478144325*r**10-5980472485386681*r**12-15296198347001160*r**14
            -47367226355437800*r**16-37023756454865850*r**18+5183687941270510*r**20
            -7058966032401516*r**22-13572369405140820*r**24+5821297772420350*r**26
            +7188866095629150*r**28+497038198125720*r**30+102344715496044*r**32-177970449772305*r**34
            -2281810948425*r**36+8076368435350*r**38+290530350630*r**40-57945892761*r**42
            +1555011835*r**44)+27*Q2**3*(-183468220+3536606313*r**2+76236511478*r**4
            +1176722123115*r**6+3844100558300*r**8-70105255344405*r**10+45093881700858*r**12
            -1898010235383447*r**14-580218414924200*r**16-1637196004406550*r**18+2837950763718060*r**20
            -1431640850495202*r**22-6325815616881752*r**24-5277875547958490*r**26
            -3688864687778300*r**28+83539064510850*r**30-354939126854172*r**32+34547681327933*r**34
            +3921431863870*r**36+1079147987175*r**38+834854169340*r**40+29001124703*r**42
            -4275210462*r**44+80503205*r**46)+54*(-1+r**2)**2*(-1387122+64130233*r**2
            +635249113*r**4-9790823527*r**6-213478936077*r**8-3521351841837*r**10
            -10889980329957*r**12-43087332320477*r**14-262077235343017*r**16+692628861636058*r**18
            -1078927784133382*r**20-1999318658660902*r**22+2842011836240878*r**24
            +2174889260832838*r**26-2118950037949962*r**28-488919998902362*r**30-430967795476132*r**32
            -128668816673027*r**34-18346944091267*r**36-3257603252067*r**38-276968685297*r**40
            +22529527383*r**42+1381647263*r**44-87618777*r**46+1161423*r**48)+18*Q2**2*(7907020
            +2647842597*r**2+1960650126*r**4-1374274527063*r**6-10485674264460*r**8
            -92542356218925*r**10-509449546480498*r**12+590011586345271*r**14-7484117599660788*r**16
            +6955518804478210*r**18-2139681865522020*r**20-4746502087195638*r**22
            +1640310674651256*r**24-7435759562798058*r**26-8823897117018420*r**28
            -1036049329397890*r**30-3870511497053868*r**32-451315480385079*r**34-174297672647018*r**36
            -57748314123075*r**38-5499889290060*r**40+167440762407*r**42+23360125926*r**44
            -2092929573*r**46+52749620*r**48)-27*Q2*(-15028684+953648637*r**2+6205092272*r**4
            -235784224758*r**6-2675463849568*r**8-37379180096388*r**10-111842983601648*r**12
            -80241651023938*r**14-2732601224941068*r**16+6989108025982097*r**18-6893269452983008*r**20
            -9204344041657628*r**22+6423952653990432*r**24+11017811092902752*r**26
            +3092204703920992*r**28-10358421904146308*r**30-1803048444309348*r**32
            -2576439074622513*r**34-618274924930768*r**36-98806112796878*r**38-26023804701888*r**40
            -2712270839388*r**42+184463241872*r**44+14929106342*r**46-1080547268*r**48
            +18415651*r**50))-4608*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(243716608*Q2**26
            -32*Q2**25*(115076989+115288069*r**2)+4*Q2**24*(5970036385+13042742146*r**2
            +6081034465*r**4)-2*Q2**23*(42166078280+157166722013*r**2+156489783138*r**4
            +46233030605*r**6)+4*Q2**22*(40287049910+254284460251*r**2+404197880033*r**4
            +262322541641*r**6+56496110285*r**8)-4*Q2**21*(23302248850+424176084869*r**2
            +939875801684*r**4+991607495999*r**6+537725777884*r**8+94110118270*r**10)
            +Q2**20*(-289631303320+378408900474*r**2+326196872790*r**4-253612303540*r**6
            +2891800430880*r**8+2705176709634*r**10+444183616490*r**12)+Q2**19*(716671132340
            +4447032141389*r**2+21346365384570*r**4+52797800082275*r**6+45008545281200*r**8
            +10207155820575*r**10-1802187839686*r**12-364651532215*r**14)+2*Q2**18*(
            -223628472380-4486797039173*r**2-27629652211208*r**4-98444840009945*r**6
            -135866584452800*r**8-81095445869495*r**10-17684462490608*r**12-96620553323*r**14
            +59462660020*r**16)+Q2**17*(-647203845060+4940453840359*r**2+48544051038972*r**4
            +322622066743474*r**6+652595492558200*r**8+614158150750200*r**10+289790324192764*r**12
            +55386032427622*r**14+2287711010244*r**16+247389695865*r**18)-2*Q2**16*(
            -657203063010-4185647529677*r**2-23844143107607*r**4+48025571484748*r**6
            +220557456533228*r**8+296275081951822*r**10+272283541470898*r**12+140649404343068*r**14
            +28137995569198*r**16+2125881305703*r**18+228966407805*r**20)+4*Q2**15*(
            -110190015060-4226683262354*r**2-40324907111105*r**4-153305184971365*r**6
            -360211565176345*r**8-654074764876063*r**10-520220924253943*r**12-117643300655305*r**14
            +30287945950085*r**16+11821425031105*r**18+1392485730336*r**20+43637808030*r**22)
            +4*Q2**14*(-246253741940+1928539413676*r**2+31840740229245*r**4+288712795408300*r**6
            +992663166603550*r**8+2514857878048800*r**10+3138113708372134*r**12+1855006597931920*r**14
            +451946306718600*r**16+4559702089300*r**18-8513041004435*r**20-1066762152924*r**22
            +91036358590*r**24)-4*Q2**13*(-272873172160-2570452705361*r**2-17291778183751*r**4
            +149515714074455*r**6+786370657809100*r**8+3422826835825865*r**10+6218109195166946*r**12
            +5544485498900146*r**14+2607687447658940*r**16+563107808468225*r**18+21986397494005*r**20
            +35967701399*r**22+76218106664*r**24+113019066215*r**26)+4*Q2**12*(12271347460
            -3917439905119*r**2-50701616191402*r**4-202067019106564*r**6-662870537041885*r**8
            +261978553370675*r**10+2891165173130009*r**12+3968228504406032*r**14+3424043548602494*r**16
            +1864494840433175*r**18+488899746511940*r**20+55871065326596*r**22+11271187176923*r**24
            +1119536165221*r**26+1871549485*r**28)+2*Q2**11*(-366863309620+2013489823647*r**2
            +54344676586812*r**4+758457542569007*r**6+3766171078035842*r**8+11611244759990601*r**10
            +21060565287803198*r**12+30719547788602133*r**14+23355700680404088*r**16
            +5835346110401753*r**18-1510018183169344*r**20-920741888051103*r**22-185880645363238*r**24
            -25195506144993*r**26-1859974565658*r**28+137295661115*r**30)-4*Q2**10*(
            -84768781780-1940193394621*r**2-17916037502655*r**4+171415683378095*r**6
            +1187929044712810*r**8+8108544343153427*r**10+20910318601872959*r**12
            +42874621649179855*r**14+48910339580413280*r**16+27851471289831065*r**18
            +6643201795418479*r**20-419022121478083*r**22-380682291841630*r**24-79811465664655*r**26
            -2337743076015*r**28+208450543589*r**30+22594320680*r**32)-2*Q2**9*(-100155884420
            +3601532396143*r**2+58242567996430*r**4+302216286698800*r**6+1314276487020500*r**8
            -5316841004600650*r**10-17846115092031118*r**12-70767969787891660*r**14
            -120323078151787600*r**16-98992319507021800*r**18-46339094311422670*r**20
            -11234019756764968*r**22+22025856253460*r**24+152796418785250*r**26+47466809572750*r**28
            -10696398084860*r**30-1677129150932*r**32+62503078945*r**34)+4*Q2**8*(
            -54629838565+47224846751*r**2+7989447761211*r**4+228502698804350*r**6
            +1430145126126525*r**8+5209499863383660*r**10+17377762201649479*r**12
            +21507689423453434*r**14+11389684248907455*r**16+7172013166277750*r**18
            -2146750448266295*r**20-9244124260742766*r**22-5431071785933921*r**24
            -1032349950863340*r**26-235220549591475*r**28-23100709986250*r**30-3865067681014*r**32
            -387400811349*r**34+20482472360*r**36)+2*Q2**7*(3714634720+1490555570117*r**2
            +16677138385636*r**4-148383898367333*r**6-1299153123619790*r**8-14093036360052150*r**10
            -48822274209612382*r**12-128547831173661086*r**14-188831432410613902*r**16
            -220999831299639380*r**18-143455871929936230*r**20-20320817171629072*r**22
            +23738936953234214*r**24+13764815099569238*r**26+3031523072805750*r**28
            +540835327236910*r**30+73880288453462*r**32+1047137968111*r**34-463975881878*r**36
            +13966915045*r**38)-4*Q2**6*(-15613667870+357782461499*r**2+6802612563674*r**4
            +59025338305889*r**6+277477964678839*r**8-2227121606151812*r**10-4132770454760224*r**12
            -40595362733977724*r**14-57673823913759164*r**16-90886802040706614*r**18
            -82904030454728916*r**20-18060625157799474*r**22+17662182255292126*r**24
            +15199615105039436*r**26+4944336546122336*r**28+964391336524948*r**30
            +116312334201074*r**32+22110256245299*r**34-148471785286*r**36-262667562311*r**38
            +8741864275*r**40)-12*Q2**5*(1660647250+26488505798*r**2-181135292155*r**4
            -20681215912650*r**6-145566542861300*r**8-780523901812853*r**10-4274066476535744*r**12
            -2397153867373520*r**14-16840483524604100*r**16-10652970923709100*r**18
            +4875834304906074*r**20-229939257726636*r**22-1099601089232120*r**24-593832895292050*r**26
            -1138710873953800*r**28-359711771298064*r**30-146071015476238*r**32-4894040719330*r**34
            +787238680425*r**36+67805348950*r**38+874255468*r**40+60255695*r**42)
            +6*Q2**4*(-1235700660+79608890539*r**2+861937638075*r**4-9640744592250*r**6
            -108824737983650*r**8-1622896478144325*r**10-5980472485386681*r**12-15296198347001160*r**14
            -47367226355437800*r**16-37023756454865850*r**18+5183687941270510*r**20
            -7058966032401516*r**22-13572369405140820*r**24+5821297772420350*r**26
            +7188866095629150*r**28+497038198125720*r**30+102344715496044*r**32-177970449772305*r**34
            -2281810948425*r**36+8076368435350*r**38+290530350630*r**40-57945892761*r**42
            +1555011835*r**44)-27*Q2**3*(-183468220+3536606313*r**2+76236511478*r**4
            +1176722123115*r**6+3844100558300*r**8-70105255344405*r**10+45093881700858*r**12
            -1898010235383447*r**14-580218414924200*r**16-1637196004406550*r**18+2837950763718060*r**20
            -1431640850495202*r**22-6325815616881752*r**24-5277875547958490*r**26
            -3688864687778300*r**28+83539064510850*r**30-354939126854172*r**32+34547681327933*r**34
            +3921431863870*r**36+1079147987175*r**38+834854169340*r**40+29001124703*r**42
            -4275210462*r**44+80503205*r**46)-54*(-1+r**2)**2*(-1387122+64130233*r**2
            +635249113*r**4-9790823527*r**6-213478936077*r**8-3521351841837*r**10
            -10889980329957*r**12-43087332320477*r**14-262077235343017*r**16+692628861636058*r**18
            -1078927784133382*r**20-1999318658660902*r**22+2842011836240878*r**24
            +2174889260832838*r**26-2118950037949962*r**28-488919998902362*r**30-430967795476132*r**32
            -128668816673027*r**34-18346944091267*r**36-3257603252067*r**38-276968685297*r**40
            +22529527383*r**42+1381647263*r**44-87618777*r**46+1161423*r**48)-18*Q2**2*(7907020
            +2647842597*r**2+1960650126*r**4-1374274527063*r**6-10485674264460*r**8
            -92542356218925*r**10-509449546480498*r**12+590011586345271*r**14-7484117599660788*r**16
            +6955518804478210*r**18-2139681865522020*r**20-4746502087195638*r**22
            +1640310674651256*r**24-7435759562798058*r**26-8823897117018420*r**28
            -1036049329397890*r**30-3870511497053868*r**32-451315480385079*r**34-174297672647018*r**36
            -57748314123075*r**38-5499889290060*r**40+167440762407*r**42+23360125926*r**44
            -2092929573*r**46+52749620*r**48)+27*Q2*(-15028684+953648637*r**2+6205092272*r**4
            -235784224758*r**6-2675463849568*r**8-37379180096388*r**10-111842983601648*r**12
            -80241651023938*r**14-2732601224941068*r**16+6989108025982097*r**18-6893269452983008*r**20
            -9204344041657628*r**22+6423952653990432*r**24+11017811092902752*r**26
            +3092204703920992*r**28-10358421904146308*r**30-1803048444309348*r**32
            -2576439074622513*r**34-618274924930768*r**36-98806112796878*r**38-26023804701888*r**40
            -2712270839388*r**42+184463241872*r**44+14929106342*r**46-1080547268*r**48
            +18415651*r**50))*sqrtq2)+logq2*(-384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(1263344*Q2**25
            -2*Q2**24*(9505601+16253297*r**2)+8*Q2**23*(15101386+59362675*r**2+37886425*r**4)
            -4*Q2**22*(102443633+705374568*r**2+983885279*r**4+378198296*r**6)+2*Q2**21*(358045094
            +4151185445*r**2+8686663627*r**4+8182354319*r**6+2304010067*r**8)-2*Q2**20*(101308261
            +4613261932*r**2+6581685414*r**4+15833049524*r**6+19102216867*r**8+4423698718*r**10)
            +Q2**19*(-1809680342-15810197589*r**2-154042199015*r**4-284773015970*r**6
            -79758739740*r**8+47207348363*r**10+10020853741*r**12)+2*Q2**18*(1801293599
            +34199240090*r**2+309263501280*r**4+930020406245*r**6+880433743775*r**8
            +257159772684*r**10-5391542830*r**12-2126153275*r**14)-Q2**17*(1484905622
            +80095330637*r**2+914861919791*r**4+4598073466439*r**6+6985402374245*r**8
            +4632590406047*r**10+1181300598317*r**12+63896134661*r**14+4233260129*r**16)
            +2*Q2**16*(-2191793901-14127553395*r**2-41908812638*r**4+2013380631814*r**6
            +4644643472652*r**8+5060268203644*r**10+3232159414810*r**12+807153934422*r**14
            +62483853469*r**16+2599787667*r**18)+4*Q2**15*(1754331762+44561064399*r**2
            +577829452858*r**4+1441607702198*r**6+3251079048119*r**8+4734699237970*r**10
            +1095443257589*r**12-1105849215322*r**14-388952628317*r**16-34182206181*r**18
            +701483421*r**20)-4*Q2**14*(351121128+39160057236*r**2+759713205545*r**4
            +4840749866735*r**6+16066272452755*r**8+35149348767477*r**10+30878836143569*r**12
            +9775820087095*r**14+29019070845*r**16-262826165105*r**18-23229462162*r**20
            +2042179746*r**22)+4*Q2**13*(-1558036468-16472962710*r**2+23349936655*r**4
            +4465772487620*r**6+20153097042240*r**8+71310776766968*r**10+96553373423210*r**12
            +60370199423880*r**14+16354496829440*r**16+966809090990*r**18+5877952167*r**20
            +368384820*r**22+929665700*r**24)+4*Q2**12*(1540636577+54460305692*r**2
            +918735506611*r**4+1533554371649*r**6+3877481589305*r**8-41294158915322*r**10
            -93355196200702*r**12-89485812546346*r**14-53097741174749*r**16-15305135900560*r**18
            -1702504364533*r**20-321717800423*r**22-20132151949*r**24+603951854*r**26)
            -2*Q2**11*(-245921014+54594203435*r**2+1703755850823*r**4+14689240225006*r**6
            +79372969975778*r**8+174933145687749*r**10+271350177920575*r**12+344767976062292*r**14
            +142228980736734*r**16-25632912696083*r**18-23595168966859*r**20-4879099463730*r**22
            -734903246522*r**24-24305020429*r**26+775711253*r**28)-4*Q2**10*(1103047363
            +21255376626*r**2+103285888807*r**4-6001302531578*r**6-39917813234934*r**8
            -192023832381893*r**10-422237581810736*r**12-761357806909227*r**14-639171627518117*r**16
            -223554582170156*r**18-6904986869205*r**20+9854889918556*r**22+2546101965352*r**24
            +88728472527*r**26-13525233394*r**28+597147769*r**30)+2*Q2**9*(1135618054
            +59608211953*r**2+1359901476765*r**4+1756573806895*r**6+8889427139005*r**8
            -228601933011499*r**10-508798533376643*r**12-1720591468410365*r**14-2141146193521255*r**16
            -1269054916410725*r**18-385849084088489*r**20-7945246815883*r**22+6401229435415*r**24
            +2573940230335*r**26-278872543185*r**28-40330121351*r**30+1230339373*r**32)
            +2*Q2**8*(471786649-10596137855*r**2-757851385010*r**4-10533124160090*r**6
            -79591158047660*r**8-168327601833324*r**10-728586561546310*r**12-284251962348590*r**14
            +273540254342010*r**16+257868593019530*r**18+436881984551266*r**20+281848129383210*r**22
            +41006748208940*r**24+15184516910380*r**26+1381954421590*r**28+234003437854*r**30
            +6036298285*r**32+78356725*r**34)-4*Q2**7*(345252218+10285920603*r**2
            +107818500794*r**4-3513156831934*r**6-27202415532105*r**8-174017507323748*r**10
            -603872917588223*r**12-1137251476373874*r**14-1306309108871201*r**16-1358425629995410*r**18
            -420039065733543*r**20+217043384491582*r**22+174651494126821*r**24+38725031850564*r**26
            +10113176658515*r**28+1551704662898*r**30+26329044363*r**32-8755616041*r**34
            +283146521*r**36)+4*Q2**6*(67546837+6411051700*r**2+206849252276*r**4
            +380556806647*r**6+4965241055791*r**8-82380861035667*r**10-101940700706485*r**12
            -936214741780831*r**14-789110811084287*r**16-1465831683011291*r**18-769638173209157*r**20
            +157423789797295*r**22+330650944120589*r**24+119005276608623*r**26+27580454362569*r**28
            +3753865668787*r**30+672246423790*r**32-1761097909*r**34-4018206083*r**36
            +72716806*r**38)+2*Q2**5*(148242314+1020620963*r**2-132649081389*r**4
            -3662008929779*r**6-31471818810607*r**8-72716988386620*r**10-744748397322308*r**12
            +450563233714084*r**14-2438207104288416*r**16+236583743125122*r**18+833326088784650*r**20
            -297192900975098*r**22+98450796976934*r**24-164886826091036*r**26+1264845673132*r**28
            -25602220546156*r**30-264426651682*r**32+855090424371*r**34+16028204731*r**36
            -5178019147*r**38+160903937*r**40)-2*Q2**4*(87776901+3417559452*r**2
            +42472111480*r**4-1838798130810*r**6-13324284782625*r**8-114693814231834*r**10
            -525793036874448*r**12-254482216939080*r**14-3438168422324470*r**16+156456990655080*r**18
            +1317224677497456*r**20-1625366098953468*r**22+32479082024070*r**24+600768032566620*r**26
            +1757259822640*r**28+45489052103736*r**30-17343369786303*r**32-1411627507220*r**34
            +1052467583160*r**36+23577969030*r**38-4961747509*r**40+105608142*r**42)
            +3*Q2**3*(726846+591836865*r**2+27243635855*r**4+75488016570*r**6+1572663567520*r**8
            -24643111914739*r**10+32262000099755*r**12-356261288451880*r**14-130879332670460*r**16
            +282867441051330*r**18+532565011676846*r**20-1129240918546660*r**22-387544314724280*r**24
            -693807585788190*r**26+87178908145630*r**28-83783690921384*r**30+8235759633070*r**32
            -794818580995*r**34-41618826045*r**36+162991211770*r**38+4144758056*r**40
            -256908655*r**42+493175*r**44)+18*(-1+r**2)**2*(60053+2667653*r**2+28840317*r**4
            -2719164255*r**6-19754713675*r**8-258650056527*r**10-1064699810267*r**12
            +2262904086877*r**14-38217295867830*r**16+126964269331450*r**18-217848214320262*r**20
            +2612282833458*r**22+309186681479442*r**24-200819979631430*r**26+29116086071250*r**28
            -28569017139982*r**30-6971484417727*r**32-1144057134783*r**34-272561439255*r**36
            -37533440275*r**38+1336333593*r**40+115538133*r**42-5798103*r**44+92145*r**46)
            +6*Q2**2*(4540453+81614238*r**2-3083168206*r**4-155902117139*r**6-1262324540545*r**8
            -3634235641922*r**10-57981415329282*r**12+182176592882779*r**14-810401332712534*r**16
            +1105737698182660*r**18-544198657273652*r**20-82725324785382*r**22-165470039533226*r**24
            -360230314237164*r**26+68150414797940*r**28-251908034560242*r**30-22442937423967*r**32
            -10095533797186*r**34-4221718974014*r**36-773033160055*r**38+39930130363*r**40
            +2813837518*r**42-314324786*r**44+6393351*r**46)-9*Q2*(1054918+35547045*r**2
            +19015979*r**4-40993525337*r**6-266976118731*r**8-2267724642917*r**10
            -13452438837755*r**12+55631637895329*r**14-398486455098967*r**16+1105317010355714*r**18
            -1408653966726882*r**20-40677484005930*r**22+1020443457960114*r**24+153075495040998*r**26
            -569880264500006*r**28+106145770439218*r**30-166256742154680*r**32-33122816896631*r**34
            -5860168309497*r**36-1947315601581*r**38-375188708087*r**40+15737295695*r**42
            +1334560209*r**44-90390947*r**46+1552729*r**48))+384*r**8*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**5*(10106752*Q2**30-32*Q2**29*(5344993+8718841*r**2)
            +2*Q2**28*(625828367+2296095822*r**2+1456165055*r**4)-8*Q2**27*(634716142
            +3980903295*r**2+5463712508*r**4+2079510379*r**6)+4*Q2**26*(2921306866
            +29253281044*r**2+62277561809*r**4+54549264622*r**6+14807748223*r**8)
            -2*Q2**25*(5578982074+107000895609*r**2+272164812292*r**4+417642396978*r**6
            +323864644026*r**8+68436178765*r**10)+2*Q2**24*(-7739453310+3789011055*r**2
            -375876204285*r**4-641077358006*r**6+356860828582*r**8+577659777115*r**10
            +98923689705*r**12)+Q2**23*(62764371330+879421552305*r**2+7448717901160*r**4
            +21570248056915*r**6+19391567234706*r**8+4068403316851*r**10-1023074174580*r**12
            -139160331375*r**14)-2*Q2**22*(33357447285+926217655725*r**2+9114330613620*r**4
            +39662907739919*r**6+60142600356684*r**8+38200511999703*r**10+8537109639496*r**12
            +181055147925*r**14+27008538795*r**16)+Q2**21*(-33040192070+953324961345*r**2
            +14959297187990*r**4+132398361114314*r**6+301463475685082*r**8+311435375074336*r**10
            +161502082181290*r**12+33468500748070*r**14+2381922679980*r**16+191479981615*r**18)
            -2*Q2**20*(-79263077480-1258191020645*r**2-11626984787435*r**4+13218083880072*r**6
            +95942543568792*r**8+146745601206646*r**10+168221433838938*r**12+98900233833024*r**14
            +20493146719024*r**16+1726761855415*r**18+35763516865*r**20)-Q2**19*(125915797010
            +4927936941945*r**2+71310456040820*r**4+328649881711217*r**6+870259259025156*r**8
            +1762795526913162*r**10+1439589848209544*r**12+269370714174210*r**14-115579703430918*r**16
            -32267642395379*r**18-2615168226540*r**20+179833919645*r**22)+2*Q2**18*(
            -41716769455+874563423045*r**2+27434145305330*r**4+314721465997525*r**6
            +1258751390372873*r**8+3625649822752882*r**10+4876326440100404*r**12+2995986457349210*r**14
            +727352921057515*r**16+22972164545113*r**18-4162309036342*r**20-96578154335*r**22
            +108516380075*r**24)+Q2**17*(217410545890+4623053125525*r**2+44832202545750*r**4
            -322024380689868*r**6-2267882294619188*r**8-11178656033699383*r**10-22243564918141252*r**12
            -21184140760137648*r**14-10435194052306102*r**16-2312117271485913*r**18
            -193509285556946*r**20-23933672931972*r**22-2334469432760*r**24+4305634555*r**26)
            -2*Q2**16*(44698770055+3015378688320*r**2+59297420340085*r**4+288542981979888*r**6
            +901836559550169*r**8-910050699723032*r**10-7094871369946541*r**12-10194496011110256*r**14
            -8977429705431015*r**16-4672598517159568*r**18-1109909177933493*r**20
            -150261580462880*r**22-21591620140985*r**24-1286091334200*r**26+72967203565*r**28)
            +2*Q2**15*(-63024292950+160127766885*r**2+30179260050880*r**4+561806612724523*r**6
            +3191732293008118*r**8+11091342386384273*r**10+20375834355676604*r**12
            +32333248157226287*r**14+25990545383451958*r**16+6558373874499671*r**18
            -1553594912141704*r**20-847013083057863*r**22-177930322818294*r**24-12960360709869*r**26
            +146918231020*r**28+16465717965*r**30)+4*Q2**14*(37547911815+1199724693855*r**2
            +15662645512220*r**4-131584063945663*r**6-1257961886308854*r**8-9127716441813661*r**10
            -25863092177099152*r**12-58651923451256835*r**14-72977105442100732*r**16
            -45140720617839451*r**18-12325858517130036*r**20-473861914012837*r**22
            +262000459148750*r**24+65290932620217*r**26-3212813941624*r**28-740169016185*r**30
            +26044631805*r**32)+Q2**13*(-2905097340-3287432474790*r**2-95917271487540*r**4
            -628488638655140*r**6-2285818032575124*r**8+14735915330142252*r**10+71708609189464876*r**12
            +279410449323906540*r**14+513915105475109460*r**16+470837176475021104*r**18
            +235749617555377380*r**20+57824033804120436*r**22+4313073405593380*r**24
            +292211251964820*r**26+26436598924836*r**28+29202481740356*r**30+1872514555800*r**32
            -62326687050*r**34)-2*Q2**12*(43905601945+567419686200*r**2-10277536997165*r**4
            -505294987639976*r**6-3554890972108436*r**8-14201560413671080*r**10-35370996574135964*r**12
            -17992242890098472*r**14+84898069620015110*r**16+132350609991052376*r**18
            +123013512277331314*r**20+75735427301468744*r**22+23292340510518988*r**24
            +4063599500375848*r**26+898417782993764*r**28+141843854803208*r**30+6538431801641*r**32
            -549210095760*r**34+21272361715*r**36)+2*Q2**11*(22056733430+1193192078795*r**2
            +22629787526980*r**4-158665984063593*r**6-2011683168285024*r**8-22630976715047804*r**10
            -85127354523364808*r**12-261897688682937708*r**14-417709516914490916*r**16
            -574879363246338342*r**18-453797042444004400*r**20-133319450966400638*r**22
            +23464141296240592*r**24+20005290252019188*r**26+5817602694497320*r**28
            +896031798625668*r**30+114478727765310*r**32-2673107634845*r**34-843798644980*r**36
            +24288392015*r**38)+4*Q2**10*(5247842035-144272657655*r**2-8898377012165*r**4
            -110969315253241*r**6-473662328588646*r**8+4361566697371116*r**10+23842434030317788*r**12
            +155029243447719924*r**14+344009211701970738*r**16+670302450840191534*r**18
            +779465900427506730*r**20+468233798490348706*r**22+127301663219554528*r**24
            -3577363073418660*r**26-7265750938768788*r**28-2332892489592796*r**30
            -118153177715709*r**32+10879526223873*r**34+2084601973203*r**36-8222083905*r**38
            +1736090590*r**40)-4*Q2**9*(6618874220+184646592690*r**2+541508422755*r**4
            -116972134265907*r**6-895473612951911*r**8-4840643877108151*r**10-15081322019145052*r**12
            +28416576091952060*r**14+88492804916883172*r**16+417587667388372876*r**18
            +784518210875773562*r**20+673603495912607294*r**22+347818708102379950*r**24
            +100349290358374562*r**26+5203722766318516*r**28-25480460851076*r**30
            -528530578916072*r**32+89583957413210*r**34+43488760318923*r**36+953993044669*r**38
            -238139745455*r**40+6306186365*r**42)+2*Q2**8*(1260952460+244966521935*r**2
            +7214956862705*r**4-26689182899390*r**6-659096396276032*r**8-13088100024982225*r**10
            -57700546826086053*r**12-234815908844257320*r**14-606967076532539000*r**16
            -881308019592512658*r**18-522414976478087062*r**20-341090199042238804*r**22
            +16920486698674320*r**24+293935346700346310*r**26+189010883298026902*r**28
            +47306984241381144*r**30+12216104882052492*r**32+1915283972448995*r**34
            +179767919442805*r**36+35940738421538*r**38-97165034992*r**40-166044260245*r**42
            +2809306175*r**44)+Q2**7*(7293106570+52883558325*r**2-5352707647880*r**4
            -167558076623913*r**6-621617895458958*r**8+7790628917921203*r**10+50747597220243868*r**12
            +512029121246273481*r**14+1268473667211318516*r**16+3579862737437785058*r**18
            +4344080457243075648*r**20+4899195576957873142*r**22+3280037180458777108*r**24
            +372426184664898582*r**26-754135543864986392*r**28-438690715972284670*r**30
            -118972517892767358*r**32-22440164377025319*r**34-4582271282131800*r**36
            -304501555676733*r**38+39184666660474*r**40+2165322759623*r**42-272228013540*r**44
            +6900524965*r**46)-2*Q2**6*(1525347465+71833616385*r**2+919513180900*r**4
            -48374554968877*r**6-368828587457536*r**8-3494634615639465*r**10-9737939648129288*r**12
            +49522254296374717*r**14-16732317349728107*r**16+946985581208555770*r**18
            +787062359322719032*r**20+1492079717588514926*r**22+1736680072653465336*r**24
            +483162069925880190*r**26-309407064131311712*r**28-367453000440712054*r**30
            -133944092490707053*r**32-36812599314581323*r**34-4504944545257276*r**36
            -836770476648817*r**38-107215055800728*r**40+18198363116155*r**42+766791658120*r**44
            -97547628055*r**46+1835981295*r**48)-3*Q2**5*(238862314-10327955495*r**2
            -625877686410*r**4-2860043266382*r**6+75940784330898*r**8+2320906752059916*r**10
            +10726039394297058*r**12+67212302984789174*r**14+243644848617285600*r**16
            +165057847640294941*r**18+945183930721094044*r**20+525457864759626996*r**22
            -398047058549583932*r**24+44358252160720992*r**26+4453468214649924*r**28
            -42903995811858708*r**30+41341536688136714*r**32+10791718939701507*r**34
            +10708937291794894*r**36+1283353016704762*r**38-222836442506550*r**40
            -14963840935148*r**42+470059809786*r**44+55752755646*r**46-8721222900*r**48
            +242580359*r**50)+6*Q2**4*(130479046+2818448327*r**2-50337797245*r**4
            -4348507555312*r**6-4195145606956*r**8+255099823910162*r**10+2225510402266714*r**12
            +26585923885512840*r**14+56847544407344658*r**16+200016094548738709*r**18
            +394663205158149617*r**20+312164009332689344*r**22-147372056918009800*r**24
            +155359158820663148*r**26+214397957771412284*r**28+28139464652983792*r**30
            -64332584879600886*r**32+5214569728201185*r**34-2746998463019147*r**36
            +2019981730427504*r**38+441217217205812*r**40-134545171756126*r**42-26083071698230*r**44
            +1515440243528*r**46+111637050334*r**48-9432078429*r**50+165395127*r**52)
            -9*Q2**3*(11276026+942722541*r**2+19861779700*r**4-767759252995*r**6
            -5538807178804*r**8-102360321245162*r**10-94690516345528*r**12+1729667316149230*r**14
            -8584512882487890*r**16+78504952737182271*r**18-97274706656502692*r**20
            +149007390543483607*r**22-98859304974321080*r**24+4642437202351140*r**26
            +126074159944069936*r**28+77388129034093588*r**30+97495339808211062*r**32
            -34635653966995365*r**34+8104649723064620*r**36-1725552006522469*r**38
            -893507675349332*r**40-126502167296538*r**42-26825206734200*r**44-6124265329250*r**46
            +232581804066*r**48+21861860697*r**50-1162507644*r**52+16020465*r**54)
            -54*(-1+r**2)**2*(60053+1886964*r**2-12324896*r**4-3388680624*r**6+12190780191*r**8
            +288681587116*r**10+4724557484556*r**12+46207094777796*r**14+75540828730041*r**16
            +497725749760536*r**18+2028273044190756*r**20-6780516518013764*r**22+10589780813804851*r**24
            +17336480964533976*r**26-28075521269018504*r**28-12362489826806744*r**30
            +14891631666502191*r**32+2950248212406756*r**34+3273645250987816*r**36
            +1280497561832136*r**38+215544357343741*r**40+41374248525116*r**42+6307021303356*r**44
            +58646605396*r**46-66758898109*r**48+450581328*r**50+180961812*r**52
            -6995988*r**54+92145*r**56)-18*Q2**2*(3939923-7535145*r**2-5124373478*r**4
            -100612818393*r**6+1398038761131*r**8+37715015176018*r**10+184245180088364*r**12
            +1730731828617114*r**14+5164886111747103*r**16-8424547255660899*r**18
            +99340967461247118*r**20-149598097674320891*r**22+95357981359315959*r**24
            +92540693968638348*r**26-104650954944470264*r**28+36802672071820508*r**30
            +116895104672984889*r**32+4522883327891169*r**34+50732451778373718*r**36
            +10154394037971201*r**38+2442597241560193*r**40+922084877398914*r**42
            +175773612296844*r**44+2627512046698*r**46-1364856557419*r**48+30751703115*r**50
            +5147036994*r**52-344350733*r**54+5471901*r**56)+27*Q2*(1054918+21352687*r**2
            -586054758*r**4-45749592772*r**6+278812858420*r**8+6141344214839*r**10
            +53142969642284*r**12+541393305789584*r**14+629885488500754*r**16+1519254413038099*r**18
            +26053119541117214*r**20-83987418976313556*r**22+106817262659172744*r**24
            +50639231573867579*r**26-99346705492554296*r**28-9126084811289856*r**30
            -67555813925564406*r**32+86105647633733469*r**34+5488670950561334*r**36
            +21333733518245844*r**38+7347492468499124*r**40+1245309397201909*r**42
            +327345836830284*r**44+65591759486064*r**46+1248938415454*r**48-741232446239*r**50
            +7825456082*r**52+2376538052*r**54-111313584*r**56+1552729*r**58))*sqrtq2))*math.log(mu0)**2)/(840000*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2+840000*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2+logq2**8*(81266540544000000*r**36*(1
            +r**2)**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+81266540544000000*r**36*(1
            +r**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2*(-120960000*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4
            -Q2**3*(1+r**2)-2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4
            +r**6)+4*(1-9*r**2-44*r**4-9*r**6+r**8))-120960000*(-Q2+(-1+r)**2)**3*r**8*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4-Q2**3*(1+r**2)
            -2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4+r**6)+4*(1-9*r**2
            -44*r**4-9*r**6+r**8))*sqrtq2)+logq2**7*(-1805923123200000*r**32*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))-1805923123200000*r**32*(1+r**2)*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))*sqrtq2)+logq2**3*(-29030400000*(-Q2+(-1+r)**2)**3*r**16*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)
            -Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2+683*r**4+169*r**6)
            +2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)+6*Q2**3*(31+230*r**2
            +159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4
            +8368*r**6+6523*r**8+1184*r**10-131*r**12)-9*Q2*(13+5*r**2-1493*r**4
            -5245*r**6-5245*r**8-1493*r**10+5*r**12+13*r**14)+36*(4-67*r**2-28*r**4
            +2331*r**6+5600*r**8+2331*r**10-28*r**12-67*r**14+4*r**16))-29030400000*(
            -Q2+(-1+r)**2)**3*r**16*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)-Q2**6*(333+410*r**2+333*r**4)
            -Q2**5*(169+683*r**2+683*r**4+169*r**6)+2*Q2**4*(275-725*r**2-3408*r**4
            -725*r**6+275*r**8)+6*Q2**3*(31+230*r**2+159*r**4+159*r**6+230*r**8
            +31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4+8368*r**6+6523*r**8+1184*r**10
            -131*r**12)-9*Q2*(13+5*r**2-1493*r**4-5245*r**6-5245*r**8-1493*r**10
            +5*r**12+13*r**14)+36*(4-67*r**2-28*r**4+2331*r**6+5600*r**8+2331*r**10
            -28*r**12-67*r**14+4*r**16))*sqrtq2)+logq2**2*(7257600000*(-Q2+(-1
            +r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8
            -4*Q2**7*(1+r**2)-Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4
            +5*r**6)+Q2**4*(85-226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1
            -54*r**2-143*r**4-143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4
            +3168*r**6+2871*r**8+468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4
            -2833*r**6-2833*r**8-565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4
            +4368*r**6+11718*r**8+4368*r**10-56*r**12-96*r**14+5*r**16))+7257600000*(
            -Q2+(-1+r)**2)**3*r**12*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8
            -4*Q2**7*(1+r**2)-Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4
            +5*r**6)+Q2**4*(85-226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1
            -54*r**2-143*r**4-143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4
            +3168*r**6+2871*r**8+468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4
            -2833*r**6-2833*r**8-565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4
            +4368*r**6+11718*r**8+4368*r**10-56*r**12-96*r**14+5*r**16))*sqrtq2)
            +logq2**5*(-2508226560000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1
            +r**2)-Q2**6*(219+310*r**2+219*r**4)-Q2**5*(977+2179*r**2+2179*r**4
            +977*r**6)+Q2**4*(590-2090*r**2-6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243
            +10*r**2-2073*r**4-2073*r**6+10*r**8+243*r**10)+Q2**2*(-879+8076*r**2
            +41127*r**4+61272*r**6+41127*r**8+8076*r**10-879*r**12)+Q2*(-741+3075*r**2
            +31341*r**4+67125*r**6+67125*r**8+31341*r**10+3075*r**12-741*r**14)
            +12*(41-573*r**2+28*r**4+12789*r**6+25830*r**8+12789*r**10+28*r**12
            -573*r**14+41*r**16))-2508226560000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)-Q2**5*(977
            +2179*r**2+2179*r**4+977*r**6)+Q2**4*(590-2090*r**2-6768*r**4-2090*r**6
            +590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4-2073*r**6+10*r**8+243*r**10)
            +Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6+41127*r**8+8076*r**10
            -879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6+67125*r**8+31341*r**10
            +3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4+12789*r**6+25830*r**8
            +12789*r**10+28*r**12-573*r**14+41*r**16))*sqrtq2)+logq2**4*(522547200000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219
            +310*r**2+219*r**4)-24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415
            -1180*r**2-4598*r**4-1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4
            -677*r**6+155*r**8+102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6
            +18377*r**8+3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6
            -3030*r**8-1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4
            +24556*r**6+53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))+522547200000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2
            +219*r**4)-24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415-1180*r**2
            -4598*r**4-1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4-677*r**6
            +155*r**8+102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6+18377*r**8
            +3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8
            -1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6
            +53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))*sqrtq2)+logq2**6*(10032906240000*r**28*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(16*Q2**8+332*Q2**7*(1
            +r**2)+Q2**6*(153+370*r**2+153*r**4)-Q2**5*(2011+4817*r**2+4817*r**4
            +2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4-2410*r**6+295*r**8)+6*Q2**3*(559
            -310*r**2-4869*r**4-4869*r**6-310*r**8+559*r**10)-3*Q2**2*(479-4496*r**2
            -22867*r**4-35272*r**6-22867*r**8-4496*r**10+479*r**12)-9*Q2*(187
            -865*r**2-5807*r**4-10315*r**6-10315*r**8-5807*r**10-865*r**12+187*r**14)
            +9*(109-1432*r**2+392*r**4+26376*r**6+49910*r**8+26376*r**10+392*r**12
            -1432*r**14+109*r**16))+10032906240000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(16*Q2**8+332*Q2**7*(1+r**2)+Q2**6*(153+370*r**2+153*r**4)
            -Q2**5*(2011+4817*r**2+4817*r**4+2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4
            -2410*r**6+295*r**8)+6*Q2**3*(559-310*r**2-4869*r**4-4869*r**6-310*r**8
            +559*r**10)-3*Q2**2*(479-4496*r**2-22867*r**4-35272*r**6-22867*r**8
            -4496*r**10+479*r**12)-9*Q2*(187-865*r**2-5807*r**4-10315*r**6-10315*r**8
            -5807*r**10-865*r**12+187*r**14)+9*(109-1432*r**2+392*r**4+26376*r**6
            +49910*r**8+26376*r**10+392*r**12-1432*r**14+109*r**16))*sqrtq2))+((
            -4*(Q2-(-1+r)**2)**4*r**4*(1-Q2+r**2)*(Q2-(1+r)**2)**4*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(-92*Q2**18-60*Q2**17*(1+r**2)+4*Q2**16*(
            -1499-3228*r**2+1519*r**4)+Q2**15*(72623+1046341*r**2+160589*r**4-34969*r**6)
            +Q2**14*(-299825-8852676*r**2-10808350*r**4-776500*r**6+94735*r**8)
            +Q2**13*(576101+29535579*r**2+82368756*r**4+43289452*r**6+1877655*r**8
            -135799*r**10)+Q2**12*(-381315-38482536*r**2-239240429*r**4-277504064*r**6
            -79598981*r**8-2114840*r**10+76245*r**12)+Q2**11*(-493297-20511955*r**2
            +237317447*r**4+530987613*r**6+387002253*r**8+41680119*r**10-50819*r**12
            +56927*r**14)+Q2**10*(1074711+122446116*r**2+261376636*r**4+280696044*r**6
            +60797850*r**8-63891428*r**10+87830460*r**12+2723028*r**14-101673*r**16)
            -Q2**9*(341275+112792173*r**2+851014790*r**4+2103692810*r**6+3429691340*r**8
            +1396512740*r**10+436523258*r**12+153045270*r**14+1716825*r**16+9295*r**18)
            +Q2**8*(-889251-54890208*r**2+590459833*r**4+1670586336*r**6+6297176130*r**8
            +4841499376*r**10+1065281922*r**12+528837568*r**14+37227201*r**16-2320560*r**18
            +120549*r**20)+Q2**7*(994085+168225927*r**2+357891963*r**4+1950721473*r**6
            -778030638*r**8+777200710*r**10+1046459542*r**12+511955778*r**14-340834967*r**16
            +105058067*r**18+3712335*r**20-89635*r**22)-Q2**6*(70043+76673404*r**2
            +764189182*r**4+3289645276*r**6+8434570341*r**8+17554642744*r**10+19515767172*r**12
            +5395152088*r**14+193046501*r**16-158583284*r**18+89263870*r**20+875276*r**22
            +10907*r**24)+Q2**5*(-508441-63392055*r**2+323302736*r**4-37241456*r**6
            +8386679415*r**8+12693116089*r**10+39203740728*r**12+16900419912*r**14
            +1763653493*r**16-848638885*r**18+178260472*r**20-9932888*r**22-1674323*r**24
            +48803*r**26)+Q2**4*(316975+76375224*r**2+131177365*r**4+2445366560*r**6
            -714459345*r**8+20178975160*r**10-29566065683*r**12-14255612160*r**14
            -701297035*r**16+975854760*r**18+224047815*r**20-417821216*r**22+41907245*r**24
            +1300200*r**26-21065*r**28)+Q2**3*(9117-14144121*r**2-170056239*r**4
            -1061850213*r**6-3845099135*r**8-26031776957*r**10+12379537797*r**12
            -4354598937*r**14+11620863591*r**16+3295991205*r**18+152368323*r**20
            +570114849*r**22+193648251*r**24-13345903*r**26+7655*r**28-5283*r**30)
            +Q2**2*(-84335-15657956*r**2+57506816*r**4-600798684*r**6+3037842044*r**8
            -3267499140*r**10+12997085632*r**12-6908662492*r**14-18283866522*r**16
            -18885157708*r**18-2821795840*r**20-279101876*r**22-403896324*r**24+108011956*r**26
            -5478336*r**28-391060*r**30+7825*r**32)-3*Q2*(-11737-3122007*r**2+2026122*r**4
            -191370746*r**6+336016054*r**8-4793498550*r**10+15426377970*r**12-23365152962*r**14
            +7896633092*r**16+2428061692*r**18-53763714*r**20+2180654706*r**22+134272058*r**24
            -35892346*r**26+40213254*r**28-1384374*r**30-59419*r**32+907*r**34)
            +3*(-1631-528384*r**2-60287*r**4-41405248*r**6+39342620*r**8-1532131152*r**10
            +8274408172*r**12-29995134624*r**14+52589566534*r**16-43249613040*r**18
            +13813606422*r**20-1374664192*r**22+1391081884*r**24+82272976*r**26-6254580*r**28
            +9760736*r**30-237471*r**32-8848*r**34+113*r**36))+4*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**4*(736*Q2**22-164*Q2**21*(1+r**2)-8*Q2**20*(
            -5863-12830*r**2+6209*r**4)+20*Q2**19*(-31155-425321*r**2-66795*r**4
            +16107*r**6)+Q2**18*(2865445+78570100*r**2+94911790*r**4+6983140*r**6
            -959675*r**8)+2*Q2**17*(-3090527-146667235*r**2-398849530*r**4-210439090*r**6
            -9181315*r**8+743353*r**10)+Q2**16*(4784571+456317406*r**2+2671394545*r**4
            +3089930340*r**6+881714845*r**8+22144926*r**10-810729*r**12)-4*Q2**15*(
            -1497871-28555120*r**2+881680183*r**4+1965172890*r**6+1340268435*r**8
            +150861544*r**10-764215*r**12+262898*r**14)+20*Q2**14*(-777440-72542542*r**2
            -92556030*r**4+99985982*r**6+243169743*r**8+115760126*r**10-50476392*r**12
            -2025190*r**14+93439*r**16)-20*Q2**13*(-310787-83141990*r**2-589236664*r**4
            -1353719658*r**6-2135860308*r**8-949127860*r**10-325781616*r**12-111635934*r**14
            -1456929*r**16+3010*r**18)-4*Q2**12*(-3717974-161712590*r**2+3072315480*r**4
            +11567244990*r**6+35914992495*r**8+33297080804*r**10+10276258125*r**12
            +2963189550*r**14+181465215*r**16-9331010*r**18+535171*r**20)+4*Q2**11*(
            -4577651-704045446*r**2-817140815*r**4+199576200*r**6+35195915610*r**8
            +60171084836*r**10+34993132166*r**12+6025344060*r**14+1921351425*r**16
            -488043590*r**18-16519711*r**20+407524*r**22)+2*Q2**10*(-453063+710194160*r**2
            +8757214614*r**4+35911777560*r**6+62067170885*r**8+45037217288*r**10
            +42152523300*r**12+13582344856*r**14+8079031035*r**16+769342920*r**18
            +982978502*r**20+4140240*r**22+318279*r**24)-20*Q2**9*(-711370-80244697*r**2
            +609463880*r**4+3127531220*r**6+21145306736*r**8+39234036757*r**10+66187424212*r**12
            +33881513380*r**14+9461408242*r**16+1516769741*r**18+477432212*r**20
            -18798472*r**22-2452840*r**24+71399*r**26)+10*Q2**8*(-689969-193942990*r**2
            -424346443*r**4-2381844544*r**6+29984342153*r**8+63840564102*r**10+247458855871*r**12
            +211406379568*r**14+56616655057*r**16+14544085038*r**18+1130956499*r**20
            +974323856*r**22-141045673*r**24-2995558*r**26+34105*r**28)+4*Q2**7*(
            -1046331-6986640*r**2+2807960255*r**4+15990252690*r**6+46982782425*r**8
            +153500580376*r**10-188817996105*r**12-275486365090*r**14-90227215265*r**16
            +32352779520*r**18-8891096539*r**20+1129268990*r**22+25783395*r**24+99348440*r**26
            -3890235*r**28+134514*r**30)-4*Q2**6*(-1173194-240196814*r**2+1251959810*r**4
            +5397166830*r**6+103684435335*r**8+261962637994*r**10+766724823704*r**12
            +1062373628990*r**14+1154903353125*r**16+408055557590*r**18+48795009914*r**20
            -8104054886*r**22-352771815*r**24+1997881230*r**26-111293140*r**28-5272454*r**30
            +90181*r**32)-4*Q2**5*(58454+83498785*r**2+614729268*r**4+5070769690*r**6
            -36966938670*r**8-3750177844*r**10-1012961279940*r**12-1126798664758*r**14
            -2738316873530*r**16-1452661624970*r**18-256778954884*r**20+27021416430*r**22
            +200219702*r**24+1335602940*r**26-1080609260*r**28+69513774*r**30+391900*r**32
            +10913*r**34)+20*Q2**4*(-64150-10201334*r**2+170253080*r**4+868557006*r**6
            +6742984043*r**8+30911507896*r**10-24296863191*r**12+240878254290*r**14
            -436852355289*r**16-224241654616*r**18-32699137687*r**20+11810540434*r**22
            -102549015*r**24-4461509120*r**26-256539277*r**28+103644366*r**30-1921509*r**32
            -314730*r**34+5603*r**36)-60*Q2**3*(-7298-2356125*r**2+14112094*r**4
            +25594681*r**6+1948299344*r**8+3742305372*r**10+42030495588*r**12+106763697016*r**14
            -38359259308*r**16+4704403122*r**18-20489197320*r**20-15646171846*r**22
            -2286272464*r**24-2296093892*r**26-1105706196*r**28-139231104*r**30+38480558*r**32
            -1103021*r**34-37606*r**36+405*r**38)-3*Q2**2*(-37707-1803140*r**2+174530430*r**4
            +898532540*r**6-1342331595*r**8+40098187648*r**10-472408852040*r**12
            +732358578880*r**14-1851832881590*r**16+755144441880*r**18+1949622466788*r**20
            +2451613456600*r**22+468178935250*r**24+141108574560*r**26+24588920600*r**28
            -5614189792*r**30+58556705*r**32-15667060*r**34+3126990*r**36-230260*r**38
            +4313*r**40)+18*Q2*(-5053-1223623*r**2+20533810*r**4+54414010*r**6
            +1186756135*r**8+4984570817*r**10+14488694192*r**12+155239831440*r**14
            -668805592610*r**16+1075475371290*r**18-157435300988*r**20-367116721868*r**22
            +63624780190*r**24-108715887310*r**26-12536987360*r**28+1272858112*r**30
            -1583713473*r**32-178447315*r**34+26348410*r**36-248190*r**38-31013*r**40
            +397*r**42)-9*(-1631-505550*r**2+7490403*r**4+9129700*r**6+632078815*r**8
            +1809481114*r**10+26605651205*r**12-2408722672*r**14-283783738150*r**16
            +1922665264580*r**18-3895904772306*r**20+3104449405560*r**22-619758474002*r**24
            -126814542300*r**26-98860868230*r**28-28486145456*r**30+690302965*r**32
            -744356342*r**34-120458625*r**36+13915460*r**38-124221*r**40-10430*r**42
            +113*r**44))*sqrtq2+logq2**6*(2351462400000*(-Q2+(-1+r)**2)*(-1+r)*r**28*(1
            +r)*(1+r**2)*(1-Q2+r**2)*(-1+4*r**2+r**4)*(-Q2+(1+r)**2)+2351462400000*r**28*(1
            -4*r**2-2*r**4+4*r**6+r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**5*(3732480000*r**22*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-70*Q2**7*(1
            +r**2)+10*Q2**6*(53+76*r**2+23*r**4)+10*Q2**5*(-157-305*r**2-125*r**4
            +23*r**6)+Q2**4*(2266+5806*r**2+2778*r**4-2702*r**6-1716*r**8)+4*Q2**3*(
            -326-1372*r**2-554*r**4+1744*r**6+1663*r**8+411*r**10)+2*Q2**2*(-337
            +595*r**2+664*r**4-3032*r**6-4453*r**8-853*r**10+612*r**12)-3*Q2*(
            -452-645*r**2+498*r**4+735*r**6-1068*r**8-1047*r**10+1022*r**12+957*r**14)
            +3*(-178-291*r**2+985*r**4-989*r**6-4321*r**8+1587*r**10+2175*r**12
            +589*r**14+443*r**16))+3732480000*r**22*(70*Q2**10*(1+r**2)-20*Q2**9*(37
            +59*r**2+22*r**4)+10*Q2**8*(337+727*r**2+457*r**4+67*r**6)+2*Q2**7*(
            -4318-11503*r**2-9669*r**4-1549*r**6+823*r**8)-14*Q2**6*(-953-3016*r**2
            -2962*r**4-268*r**6+1149*r**8+518*r**10)+2*Q2**5*(-5803-22498*r**2
            -23907*r**4+4218*r**6+24989*r**8+18326*r**10+4543*r**12)-5*Q2**4*(-560
            -4445*r**2-5058*r**4+4211*r**6+14272*r**8+13389*r**10+4522*r**12+21*r**14)
            +3*(-1+r**2)**3*(178+647*r**2-47*r**4-43*r**6+5267*r**8+8001*r**10
            +4239*r**12+1475*r**14+443*r**16)-2*Q2**3*(-2660-2170*r**2+699*r**4
            -8606*r**6-23613*r**8-20598*r**10-9419*r**12+5950*r**14+5985*r**16)
            +2*Q2**2*(-3172-5437*r**2+1801*r**4-2747*r**6-25745*r**8-9615*r**10
            +16467*r**12+10887*r**14+10649*r**16+6912*r**18)-6*Q2*(-493-711*r**2
            +1717*r**4-720*r**6-7466*r**8-3532*r**10+304*r**12+5396*r**14+3003*r**16
            +1359*r**18+1143*r**20))*sqrtq2)+logq2**4*(10368000*r**18*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1120*Q2**11-40*Q2**10*(463+343*r**2)
            +20*Q2**9*(5598+9401*r**2+3579*r**4)-16*Q2**8*(21419+57837*r**2+47750*r**4
            +12476*r**6)+4*Q2**7*(135368+544057*r**2+709339*r**4+391017*r**6+78047*r**8)
            -Q2**6*(272832+2291461*r**2+4400212*r**4+3800814*r**6+1567540*r**8+266133*r**10)
            +2*Q2**5*(-220528+6795*r**2+480911*r**4+1039682*r**6+1140282*r**8+361111*r**10
            +74123*r**12)+Q2**4*(756560+2200635*r**2+5369086*r**4+5468913*r**6-1950140*r**8
            -3762451*r**10-661490*r**12-127225*r**14)+12*Q2**3*(-23848-145619*r**2
            -506372*r**4-699975*r**6+339684*r**8+1039559*r**10+509668*r**12+81095*r**14
            +5208*r**16)+3*Q2**2*(-70584+97119*r**2+176040*r**4+877892*r**6-1061288*r**8
            -5155610*r**10-3159048*r**12+140156*r**14-42016*r**16+32539*r**18)-18*Q2*(
            -11924-8467*r**2-169481*r**4-118784*r**6+250860*r**8-65590*r**10-448558*r**12
            +140416*r**14+390024*r**16+34505*r**18+6999*r**20)+9*(-5856-4915*r**2
            -171594*r**4-14467*r**6+228240*r**8-520586*r**10-393676*r**12+95334*r**14
            +330832*r**16+417725*r**18+34582*r**20+4381*r**22))+10368000*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1120*Q2**11-40*Q2**10*(463+343*r**2)
            +20*Q2**9*(5598+9401*r**2+3579*r**4)-16*Q2**8*(21419+57837*r**2+47750*r**4
            +12476*r**6)+4*Q2**7*(135368+544057*r**2+709339*r**4+391017*r**6+78047*r**8)
            -Q2**6*(272832+2291461*r**2+4400212*r**4+3800814*r**6+1567540*r**8+266133*r**10)
            +2*Q2**5*(-220528+6795*r**2+480911*r**4+1039682*r**6+1140282*r**8+361111*r**10
            +74123*r**12)+Q2**4*(756560+2200635*r**2+5369086*r**4+5468913*r**6-1950140*r**8
            -3762451*r**10-661490*r**12-127225*r**14)+12*Q2**3*(-23848-145619*r**2
            -506372*r**4-699975*r**6+339684*r**8+1039559*r**10+509668*r**12+81095*r**14
            +5208*r**16)+3*Q2**2*(-70584+97119*r**2+176040*r**4+877892*r**6-1061288*r**8
            -5155610*r**10-3159048*r**12+140156*r**14-42016*r**16+32539*r**18)-18*Q2*(
            -11924-8467*r**2-169481*r**4-118784*r**6+250860*r**8-65590*r**10-448558*r**12
            +140416*r**14+390024*r**16+34505*r**18+6999*r**20)+9*(-5856-4915*r**2
            -171594*r**4-14467*r**6+228240*r**8-520586*r**10-393676*r**12+95334*r**14
            +330832*r**16+417725*r**18+34582*r**20+4381*r**22))*sqrtq2)+logq2**3*(691200*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(6040*Q2**14-40*Q2**13*(1717+1594*r**2)
            +6*Q2**12*(56105+105627*r**2+47066*r**4)-4*Q2**11*(218475+672236*r**2
            +615914*r**4+166353*r**6)+4*Q2**10*(277725+1486603*r**2+2160818*r**4
            +1233470*r**6+213954*r**8)-30*Q2**9*(2091+203128*r**2+406142*r**4+373524*r**6
            +159933*r**8+17658*r**10)+10*Q2**8*(-179709-127157*r**2-729770*r**4
            -1318228*r**6-406781*r**8+81919*r**10+8730*r**12)+Q2**7*(2134140+10896361*r**2
            +49318958*r**4+108457305*r**6+93813080*r**8+30766055*r**10+2215166*r**12
            +14103*r**14)-3*Q2**6*(75900+3683359*r**2+18606971*r**4+63097297*r**6
            +84376685*r**8+48168485*r**10+11650609*r**12+359211*r**14+43947*r**16)
            +Q2**5*(-1426600+1054561*r**2-10443884*r**4+86498170*r**6+222991528*r**8
            +205266820*r**10+79196236*r**12+14503246*r**14+154480*r**16+417443*r**18)
            -5*Q2**4*(-216038-1284133*r**2-13610857*r**4-21608978*r**6-16436874*r**8
            +7836032*r**10+22070188*r**12+7263066*r**14+1535816*r**16+403917*r**18
            +69205*r**20)-15*Q2**3*(1232+306323*r**2+2630070*r**4+9309725*r**6+15167456*r**8
            +5812862*r**10-16901308*r**12-16774294*r**14-4963312*r**16-654129*r**18
            -157626*r**20+2201*r**22)+3*Q2**2*(-106840+24359*r**2-4344493*r**4+16724055*r**6
            +16613515*r**8+4616870*r**10-94138698*r**12-138715514*r**14-37514770*r**16
            -9244205*r**18+1108055*r**20-26301*r**22+59967*r**24)-9*Q2*(-16650
            -118219*r**2-2159316*r**4+469828*r**6-11255590*r**8-1175335*r**10+9829088*r**12
            -23727088*r**14-5724286*r**16+27575015*r**18+4956660*r**20+1226156*r**22
            +110254*r**24+9483*r**26)+9*(-2450-36197*r**2-559757*r**4+12580*r**6
            -6265906*r**8-2125205*r**10+7941439*r**12+3066584*r**14-20073990*r**16
            -4372743*r**18+19012105*r**20+2888708*r**22+471498*r**24+41985*r**26
            +1349*r**28))-691200*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(6040*Q2**15
            -40*Q2**14*(1868+1745*r**2)+Q2**13*(405310+766202*r**2+346156*r**4)
            -2*Q2**12*(605265+1829668*r**2+1689907*r**4+473904*r**6)+4*Q2**11*(496200
            +2377314*r**2+3448968*r**4+2015737*r**6+380307*r**8)-2*Q2**10*(586815
            +6575576*r**2+13386972*r**4+12391436*r**6+5293843*r**8+692778*r**10)
            +20*Q2**9*(-86718+244250*r**2+549020*r**4+510385*r**6+596795*r**8+307346*r**10
            +30852*r**12)+Q2**8*(3931230+13965021*r**2+57888228*r**4+128937285*r**6
            +111063170*r**8+34014675*r**10+1308676*r**12-73197*r**14)-2*Q2**7*(1180920
            +12040289*r**2+58018116*r**4+173534077*r**6+227700220*r**8+134542295*r**10
            +33966524*r**12+1653451*r**14+72972*r**16)+2*Q2**6*(-599450+6166169*r**2
            +28213553*r**4+165805487*r**6+332706737*r**8+301451165*r**10+129326759*r**12
            +25266353*r**14+681977*r**16+274642*r**18)-2*Q2**5*(-1253395-3396352*r**2
            -38721804*r**4-15995302*r**6+113652664*r**8+233719254*r**10+197406998*r**12
            +65007406*r**14+11168403*r**16+1295754*r**18+381734*r**20)+10*Q2**4*(
            -109867-1209570*r**2-11392600*r**4-31574505*r**6-41774110*r**8-13019714*r**10
            +40305072*r**12+39828068*r**14+11844409*r**16+1951060*r**18+473000*r**20
            +31301*r**22)+6*Q2**3*(-50340+781067*r**2+5168736*r**4+38211515*r**6
            +69499710*r**8+54759230*r**10-74790464*r**12-153546762*r**14-73101400*r**16
            -18665705*r**18-1475360*r**20-401713*r**22+35486*r**24)-6*Q2**2*(-78395
            -218569*r**2-5399041*r**4+6894523*r**6-214600*r**8+8852190*r**10-30017282*r**12
            -152017738*r**14-96701571*r**16+17983035*r**18+3366915*r**20+2380111*r**22
            +182214*r**24+44208*r**26)+18*Q2*(-9550-85533*r**2-1418646*r**4-838454*r**6
            -8525834*r**8-7278065*r**10+8297596*r**12-5415708*r**14-24762682*r**16
            +8738993*r**18+25771890*r**20+4535762*r**22+903954*r**24+80861*r**26
            +5416*r**28)-9*(-2450-38647*r**2-595954*r**4-547177*r**6-6253326*r**8
            -8391111*r**10+5816234*r**12+11008023*r**14-17007406*r**16-24446733*r**18
            +14639362*r**20+21900813*r**22+3360206*r**24+513483*r**26+43334*r**28
            +1349*r**30))*sqrtq2)+logq2**2*(-2880*r**10*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-104480*Q2**17+8*Q2**16*(150101+135817*r**2)-8*Q2**15*(709791
            +1424108*r**2+609837*r**4)+8*Q2**14*(1670155+6164498*r**2+5665821*r**4
            +1497790*r**6)-8*Q2**13*(1570775+13279952*r**2+19627106*r**4+11807174*r**6
            +2052205*r**8)+Q2**12*(-10951320+87823939*r**2+170092020*r**4+162375498*r**6
            +97625268*r**8+9276675*r**10)+4*Q2**11*(9892734+24693229*r**2+97819623*r**4
            +176570458*r**6+72594868*r**8-2378739*r**10+1841403*r**12)-2*Q2**10*(14469828
            +157336027*r**2+716700482*r**4+1881190105*r**6+1698206280*r**8+514798421*r**10
            +50180850*r**12+9261111*r**14)+4*Q2**9*(-4846770+63361633*r**2+350439261*r**4
            +1673827605*r**6+2375510525*r**8+1352556375*r**10+271078323*r**12+32232891*r**14
            +3352365*r**16)+Q2**8*(42913400+92962057*r**2+691377336*r**4-3114119876*r**6
            -7327078400*r**8-6371797290*r**10-2654978408*r**12-290389124*r**14-88671816*r**16
            +2729705*r**18)-8*Q2**7*(1878665+40114391*r**2+317972780*r**4+853863832*r**6
            +1861043472*r**8+2719556390*r**10+1492747966*r**12+266907120*r**14+15127487*r**16
            -4971133*r**18+1747270*r**20)+4*Q2**6*(-4119774+46067315*r**2+372895044*r**4
            +2848468779*r**6+8332675944*r**8+17957269110*r**10+16113018636*r**12
            +5851481694*r**14+603032454*r**16-23073081*r**18+4677472*r**20+2456967*r**22)
            +8*Q2**5*(1935887+8467725*r**2+106568217*r**4-511036475*r**6-1198700610*r**8
            -7844229138*r**10-11704337214*r**12-6396000186*r**14-1468763325*r**16
            -7450835*r**18-13472499*r**20-8600451*r**22+229304*r**24)+Q2**4*(-1225160
            -129316891*r**2-1370532012*r**4-4735543390*r**6-29611067900*r**8-17453038725*r**10
            +25962685992*r**12+35736518844*r**14+12054143520*r**16+2269446875*r**18
            +565030660*r**20+529648674*r**22+55416868*r**24-6068155*r**26)+12*Q2**3*(
            -289850+3480307*r**2+28949801*r**4+407821914*r**6+2161639620*r**8+4346643205*r**10
            +2935005991*r**12-1521190932*r**14-4694349898*r**16-2459787075*r**18
            -449400505*r**20-148392198*r**22-26994944*r**24-109941*r**26+174505*r**28)
            +6*Q2**2*(229020+2918719*r**2+45159970*r**4-109686807*r**6+502957768*r**8
            -4526104505*r**10-1116035738*r**12+4310241465*r**14+14975348124*r**16
            +11119907829*r**18+4091115470*r**20+16192019*r**22+102589440*r**24-17811067*r**26
            -3931222*r**28+189515*r**30)-36*Q2*(518+420867*r**2+5163363*r**4+25195443*r**6
            +286607943*r**8-372775221*r**10+820620947*r**12+27232299*r**14+475970739*r**16
            +1089967489*r**18-1711459887*r**20-451164495*r**22-176564787*r**24-14409807*r**26
            -4452807*r**28-379535*r**30+26931*r**32)+9*(-5568+332527*r**2+3686336*r**4
            +36352440*r**6+329849160*r**8-686961996*r**10+3464268304*r**12+268700232*r**14
            -8182983880*r**16+4018542330*r**18+8304862496*r**20-5770391864*r**22
            -1430620872*r**24-319818060*r**26-30912240*r**28-4639432*r**30-281592*r**32
            +21679*r**34))+2880*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17
            -8*Q2**16*(150101+135817*r**2)+8*Q2**15*(709791+1424108*r**2+609837*r**4)
            -8*Q2**14*(1670155+6164498*r**2+5665821*r**4+1497790*r**6)+8*Q2**13*(1570775
            +13279952*r**2+19627106*r**4+11807174*r**6+2052205*r**8)-Q2**12*(-10951320
            +87823939*r**2+170092020*r**4+162375498*r**6+97625268*r**8+9276675*r**10)
            -4*Q2**11*(9892734+24693229*r**2+97819623*r**4+176570458*r**6+72594868*r**8
            -2378739*r**10+1841403*r**12)+2*Q2**10*(14469828+157336027*r**2+716700482*r**4
            +1881190105*r**6+1698206280*r**8+514798421*r**10+50180850*r**12+9261111*r**14)
            -4*Q2**9*(-4846770+63361633*r**2+350439261*r**4+1673827605*r**6+2375510525*r**8
            +1352556375*r**10+271078323*r**12+32232891*r**14+3352365*r**16)+Q2**8*(
            -42913400-92962057*r**2-691377336*r**4+3114119876*r**6+7327078400*r**8
            +6371797290*r**10+2654978408*r**12+290389124*r**14+88671816*r**16-2729705*r**18)
            +8*Q2**7*(1878665+40114391*r**2+317972780*r**4+853863832*r**6+1861043472*r**8
            +2719556390*r**10+1492747966*r**12+266907120*r**14+15127487*r**16-4971133*r**18
            +1747270*r**20)-4*Q2**6*(-4119774+46067315*r**2+372895044*r**4+2848468779*r**6
            +8332675944*r**8+17957269110*r**10+16113018636*r**12+5851481694*r**14
            +603032454*r**16-23073081*r**18+4677472*r**20+2456967*r**22)-8*Q2**5*(1935887
            +8467725*r**2+106568217*r**4-511036475*r**6-1198700610*r**8-7844229138*r**10
            -11704337214*r**12-6396000186*r**14-1468763325*r**16-7450835*r**18-13472499*r**20
            -8600451*r**22+229304*r**24)+Q2**4*(1225160+129316891*r**2+1370532012*r**4
            +4735543390*r**6+29611067900*r**8+17453038725*r**10-25962685992*r**12
            -35736518844*r**14-12054143520*r**16-2269446875*r**18-565030660*r**20
            -529648674*r**22-55416868*r**24+6068155*r**26)-12*Q2**3*(-289850+3480307*r**2
            +28949801*r**4+407821914*r**6+2161639620*r**8+4346643205*r**10+2935005991*r**12
            -1521190932*r**14-4694349898*r**16-2459787075*r**18-449400505*r**20-148392198*r**22
            -26994944*r**24-109941*r**26+174505*r**28)-6*Q2**2*(229020+2918719*r**2
            +45159970*r**4-109686807*r**6+502957768*r**8-4526104505*r**10-1116035738*r**12
            +4310241465*r**14+14975348124*r**16+11119907829*r**18+4091115470*r**20
            +16192019*r**22+102589440*r**24-17811067*r**26-3931222*r**28+189515*r**30)
            +36*Q2*(518+420867*r**2+5163363*r**4+25195443*r**6+286607943*r**8-372775221*r**10
            +820620947*r**12+27232299*r**14+475970739*r**16+1089967489*r**18-1711459887*r**20
            -451164495*r**22-176564787*r**24-14409807*r**26-4452807*r**28-379535*r**30
            +26931*r**32)-9*(-5568+332527*r**2+3686336*r**4+36352440*r**6+329849160*r**8
            -686961996*r**10+3464268304*r**12+268700232*r**14-8182983880*r**16+4018542330*r**18
            +8304862496*r**20-5770391864*r**22-1430620872*r**24-319818060*r**26-30912240*r**28
            -4639432*r**30-281592*r**32+21679*r**34))*sqrtq2)+logq2*(96*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(54928*Q2**20-10*Q2**19*(66179+80571*r**2)
            +10*Q2**18*(315743+932826*r**2+454635*r**4)-10*Q2**17*(713027+4156451*r**2
            +4810467*r**4+1276291*r**6)+10*Q2**16*(491705+8279349*r**2+16884235*r**4
            +11757431*r**6+1673240*r**8)+2*Q2**15*(5923559-13876615*r**2-57271710*r**4
            -97945590*r**6-59156055*r**8+291279*r**10)-10*Q2**14*(2857988+19669647*r**2
            +75147541*r**4+120967604*r**6+44188566*r**8+6569403*r**10+3179247*r**12)
            +5*Q2**13*(2563602+71427359*r**2+416413088*r**4+1214635191*r**6+1097862886*r**8
            +332390965*r**10+60642984*r**12+6433205*r**14)+5*Q2**12*(5847972-19839849*r**2
            -287234445*r**4-2048826147*r**6-3137405283*r**8-1861102247*r**10-397686891*r**12
            -57953133*r**14+2841111*r**16)-10*Q2**11*(4072315+38356662*r**2+224264136*r**4
            -228097682*r**6-915369848*r**8-907956088*r**10-505111764*r**12-54829074*r**14
            -926967*r**16+4707430*r**18)+4*Q2**10*(307307+110393910*r**2+1170745425*r**4
            +4434888910*r**6+10006163165*r**8+15640213853*r**10+7814017520*r**12
            +1470662320*r**14+319685970*r**16+57863495*r**18+4510077*r**20)+5*Q2**9*(6524726
            +1654389*r**2-332977536*r**4-5253633789*r**6-16668936056*r**8-42558233486*r**10
            -38209590004*r**12-12439153626*r**14-2195790494*r**16-368681911*r**18
            -46755564*r**20+5179239*r**22)-5*Q2**8*(3840512+64911899*r**2+635093811*r**4
            -1309794993*r**6-4893941093*r**8-44191072906*r**10-64772250554*r**12
            -34209666554*r**14-6195004898*r**16-1286268433*r**18-197781337*r**20
            -9929301*r**22+4790695*r**24)-10*Q2**7*(878591-18460977*r**2-352827146*r**4
            -1980677810*r**6-9160838453*r**8-8905623285*r**10-7245547460*r**12-10083900548*r**14
            -4237010291*r**16-1165420083*r**18+269462462*r**20-41127194*r**22-13654759*r**24
            +418313*r**26)+10*Q2**6*(1259540+5803877*r**2-23532033*r**4-2109246552*r**6
            -9544382366*r**8-39759741061*r**10-79333297209*r**12-119098406816*r**14
            -69660249688*r**16-13983361421*r**18-381884731*r**20+264511880*r**22
            -105316878*r**24-14437827*r**26+1260165*r**28)+Q2**5*(-1429522-97736715*r**2
            -1617715640*r**4+2098864585*r**6-12171448290*r**8+280893888657*r**10
            +536428413960*r**12+1691496856965*r**14+1549238069610*r**16+526380826495*r**18
            +33108765192*r**20-5161804645*r**22+1307981450*r**24+484828155*r**26
            +10974120*r**28-2662377*r**30)-5*Q2**4*(677892-4948297*r**2-184875493*r**4
            -1835799047*r**6-12492555863*r**8-16769631217*r**10-130117787973*r**12
            +74508298201*r**14+214049147049*r**16+70032535581*r**18+9559984153*r**20
            -2592019133*r**22+2902206467*r**24+1216863773*r**26-43586543*r**28-12728853*r**30
            +616103*r**32)+30*Q2**3*(45654+417273*r**2+1417388*r**4-178221314*r**6
            -723747334*r**8-7139162596*r**10-26796182328*r**12-21945512406*r**14
            +1342738458*r**16+13720059258*r**18+16969717740*r**20+4420500082*r**22
            +1463384198*r**24+558599956*r**26+119452576*r**28-8390298*r**30-1005552*r**32
            +49245*r**34)+30*Q2**2*(9169-294388*r**2-7241173*r**4-11605536*r**6
            -384866858*r**8+2461427062*r**10-2492912204*r**12+21798649780*r**14-6278370596*r**16
            -25153597574*r**18-44294454506*r**20-30409099688*r**22-2275208286*r**24
            -1149771430*r**26-28432468*r**28+45300500*r**30+897755*r**32-277846*r**34
            +8287*r**36)-45*Q2*(6040-39833*r**2-1765902*r**4-25702367*r**6-191633484*r**8
            -669629844*r**10-6819671780*r**12+18100809572*r**14-23382970028*r**16
            -6747069582*r**18-9857533632*r**20+19868199534*r**22+4639058012*r**24
            +4640825532*r**26+322380516*r**28+82312436*r**30+43411204*r**32-781057*r**34
            -211762*r**36+6425*r**38)+9*(5222-10355*r**2-1056335*r**4-31511255*r**6
            -153685765*r**8-2010898828*r**10-6861747660*r**12+35126704580*r**14-161489742960*r**16
            +164166435670*r**18+133768147902*r**20-304538439490*r**22+98584777970*r**24
            +29670853060*r**26+12154764580*r**28+1458374292*r**30+101088130*r**32
            +57261285*r**34-1105095*r**36-220735*r**38+5787*r**40))-96*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(54928*Q2**21-2*Q2**20*(358359+430319*r**2)
            +20*Q2**19*(190961+539788*r**2+267603*r**4)-20*Q2**18*(514385+2702510*r**2
            +3098964*r**4+865463*r**6)+10*Q2**17*(1204732+13148827*r**2+25851153*r**4
            +17844189*r**6+2949531*r**8)-2*Q2**16*(-3465034+57731885*r**2+183089630*r**4
            +241153920*r**6+126309410*r**8+8074921*r**10)-2*Q2**15*(20213499+90395179*r**2
            +304589380*r**4+449620720*r**6+63841185*r**8-26017761*r**10+16187514*r**12)
            +5*Q2**14*(8279578+116482629*r**2+606047464*r**4+1606865481*r**6+1428175226*r**8
            +433906903*r**10+80140284*r**12+12791699*r**14)-10*Q2**13*(-1642185+46915405*r**2
            +387537446*r**4+1839937213*r**6+2724951680*r**8+1645678049*r**10+395360420*r**12
            +62514661*r**14+1796047*r**16)-5*Q2**12*(13992602+62721447*r**2+141453978*r**4
            -2792255956*r**6-7016971126*r**8-6814419706*r**10-3269012666*r**12-565298172*r**14
            -56965956*r**16+12255971*r**18)+2*Q2**11*(20976189+432932705*r**2+3654594840*r**4
            +8850610090*r**6+14294988680*r**8+22163798026*r**10+8562695780*r**12
            +141620450*r**14+360591735*r**16+134629305*r**18+32557304*r**20)+Q2**10*(31394402
            -434532923*r**2-6789445020*r**4-48690706285*r**6-141108888580*r**8-315376675502*r**10
            -284864875512*r**12-99334487490*r**14-18140345630*r**16-3353607415*r**18
            -483272108*r**20+7855887*r**22)-10*Q2**9*(5182619+36545507*r**2+151885332*r**4
            -3448203159*r**6-13408255469*r**8-51709121224*r**10-72770037022*r**12
            -42429205092*r**14-10414974509*r**16-1925370419*r**18-306609406*r**20
            -25752813*r**22+4984967*r**24)+5*Q2**8*(2083330+105674365*r**2+1405660002*r**4
            +3286654438*r**6+12117940820*r**8-31273767429*r**10-94472228540*r**12
            -78814116012*r**14-31930650870*r**16-5150433165*r**18-2022974694*r**20
            -125456250*r**22+22170912*r**24+3954069*r**26)+10*Q2**7*(2138131-11778509*r**2
            -394820156*r**4-4442751508*r**6-20685898629*r**8-57826202799*r**10-95484467954*r**12
            -136427854824*r**14-83981160527*r**16-19385791795*r**18-1277842352*r**20
            +492847148*r**22-160098831*r**24-27674273*r**26+1678478*r**28)+Q2**6*(
            -14024922-168370885*r**2-1440434080*r**4+23426650435*r**6+104364840890*r**8
            +773935122927*r**10+1727358796660*r**12+3675813897215*r**14+3436824634650*r**16
            +1362816937585*r**18+176761226712*r**20-3988076135*r**22-283968570*r**24
            +1682375205*r**26+142750740*r**28-15264027*r**30)-2*Q2**5*(979969-61953861*r**2
            -1319914910*r**4-4348923145*r**6-36267681510*r**8+92437142141*r**10+83366681376*r**12
            +1300233380965*r**14+2155490330910*r**16+1212890787005*r**18+303644756226*r**20
            +7493432441*r**22+5328604570*r**24+3938564235*r**26+138934780*r**28-27666261*r**30
            +209069*r**32)+5*Q2**4*(951816-1766767*r**2-181319462*r**4-3090002424*r**6
            -18670838914*r**8-72097162656*r**10-307664513158*r**12-187282564208*r**14
            +296613875998*r**16+366402038178*r**18+181410826174*r**20+33490965512*r**22
            +9090492522*r**24+7470669976*r**26+1889992686*r**28-106657184*r**30-18146062*r**32
            +911573*r**34)-30*Q2**3*(36485+757315*r**2+9075834*r**4-165198390*r**6
            -517101790*r**8-10324336992*r**10-31442432720*r**12-70540344514*r**14
            -14324403352*r**16+40216395290*r**18+74984231504*r**20+51799317510*r**22
            +8159092566*r**24+3171755584*r**26+706485000*r**28+65761778*r**30-10293605*r**32
            -678461*r**34+40958*r**36)-15*Q2**2*(36458-689937*r**2-20368828*r**4
            -114800519*r**6-1367845240*r**8+2144230876*r**10-20521985624*r**12+92913903868*r**14
            -39108351716*r**16-83105145086*r**18-168468705056*r**20-89802509786*r**22
            -51451441912*r**24+7072517164*r**26-1389266248*r**28+280673372*r**30
            +222630122*r**32-1103353*r**34-1174404*r**36+35849*r**38)+18*Q2*(17711
            -89660*r**2-5042505*r**4-84426300*r**6-620182510*r**8-3158607734*r**10
            -22154127890*r**12+45766196770*r**14-93950272620*r**16+6758118810*r**18
            +25372565916*r**20-127242554990*r**22+110560532850*r**24+38035135390*r**26
            +18485397410*r**28+1740919526*r**30+364853165*r**32+135206010*r**34-3034595*r**36
            -623710*r**38+18956*r**40)-9*(5222-5133*r**2-1066690*r**4-32567590*r**6
            -185197020*r**8-2164584593*r**10-8872646488*r**12+28264956920*r**14-126363038380*r**16
            +2676692710*r**18+297934583572*r**20-170770291588*r**22-205953661520*r**24
            +128255631030*r**26+41825617640*r**28+13613138872*r**30+1559462422*r**32
            +158349415*r**34+56156190*r**36-1325830*r**38-214948*r**40+5787*r**42))*sqrtq2))*math.log(mus))/(
            -6300*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))
            -6300*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2+logq2**6*(282175488000*r**26*(1
            +r**2)*(-1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -282175488000*r**26*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**3*(217728000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))+217728000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))*sqrtq2)+logq2*(756000*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)
            -Q2**2*(5+2*r**2+5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))+756000*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)-Q2**2*(5+2*r**2
            +5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))*sqrtq2)+logq2**2*(-4536000*(
            -Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(16*Q2**4+Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1
            +9*r**2+9*r**4+r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))-4536000*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(16*Q2**4
            +Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1+9*r**2+9*r**4
            +r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))*sqrtq2)+logq2**4*(-653184000*(
            -Q2+(-1+r)**2)*r**18*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))
            -653184000*(-Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))*sqrtq2)
            +logq2**5*(3135283200*(-Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2
            +41*r**4)-18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4
            -82*r**6+13*r**8))+3135283200*(-Q2+(-1+r)**2)*r**22*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2+41*r**4)
            -18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4-82*r**6
            +13*r**8))*sqrtq2))+math.log(mu0)*((16*(Q2-(-1+r)**2)**6*r**6*(1-Q2+r**2)*(Q2
            -(1+r)**2)**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(-28612*Q2**23
            +Q2**22*(67176-32664*r**2)+8*Q2**21*(-233250-785800*r**2+524817*r**4)
            +Q2**20*(28085477+576695775*r**2+105454991*r**4-37440667*r**6)+2*Q2**19*(
            -82341915-3225732716*r**2-4418918794*r**4-395355708*r**6+84905745*r**8)
            +Q2**18*(500373498+31358097814*r**2+89399326748*r**4+55724315284*r**6
            +3358800650*r**8-477033162*r**10)+2*Q2**17*(-395917617-38463683282*r**2
            -191337201797*r**4-238708612908*r**6-94765192519*r**8-4409877034*r**10
            +438471693*r**12)+3*Q2**16*(101524395+23543666597*r**2+255411237147*r**4
            +501955091181*r**6+424320450749*r**8+123443494275*r**10+4817467789*r**12
            -347483973*r**14)+8*Q2**15*(152245074+13741944409*r**2-35852854755*r**4
            -120187155438*r**6-220129729790*r**8-210946770387*r**10-46273718871*r**12
            -1698843452*r**14+91864026*r**16)-8*Q2**14*(285449795+48246799968*r**2
            +238649593522*r**4+730488884127*r**6+1124694570180*r**8+386696463505*r**10
            -66145700124*r**12-1355133513*r**14-640511501*r**16+34573865*r**18)+8*Q2**13*(117303291
            +43646205971*r**2+489104768902*r**4+1889529101973*r**6+4711220670689*r**8
            +4129530047503*r**10+1397695724163*r**12+203266037939*r**14+51947171116*r**16
            -90984330*r**18+33906351*r**20)-2*Q2**12*(-968342973-104570587043*r**2
            +925423064509*r**4+3962764495343*r**6+23336954898374*r**8+29862631629874*r**10
            +19264413356426*r**12+6316544576486*r**14+1420148340703*r**16+189489099113*r**18
            -4986507279*r**20+344811987*r**22)+4*Q2**11*(-717693145-180576843122*r**2
            -929177411296*r**4-5268729440932*r**6-4493875872867*r**8-7649666958380*r**10
            -8103419448912*r**12+1169956396536*r**14+2031530781289*r**16+736195290590*r**18
            -18190550080*r**20-5184669204*r**22+200823779*r**24)-4*Q2**10*(-156269103
            -117521363011*r**2-1544198630906*r**4-9071877350760*r**6-27084517803253*r**8
            -52615275371495*r**10-80476043046384*r**12-42446635382668*r**14-4620318133637*r**16
            +1977234743043*r**18+633755325002*r**20-78372117836*r**22-3495342903*r**24
            +72064743*r**26)-4*Q2**9*(-467810865-70644274196*r**2+525139880321*r**4
            +1877583920230*r**6+24656702632885*r**8+39070939415870*r**10+130094197905379*r**12
            +106874441841844*r**14+40953594353681*r**16+1491474361360*r**18-1721999890145*r**20
            -121448857978*r**22+26138564011*r**24-1186332058*r**26+68902845*r**28)
            +2*Q2**8*(-928378851-301544311489*r**2-1565317526263*r**4-15658244172585*r**6
            -5899854314307*r**8-113738693634721*r**10+112044333373593*r**12+134026467381447*r**14
            +103985863902743*r**16+53394408185853*r**18+1725147141819*r**20+1353794402885*r**22
            +1265613658191*r**24-69115660379*r**26-6264013085*r**28+158562909*r**30)
            -4*Q2**7*(-55171089-62311980294*r**2-905995995942*r**4-7328093572980*r**6
            -21541095078520*r**8-103588756322210*r**10-57265686709074*r**12-42178367222080*r**14
            +1564261241074*r**16+51555275401878*r**18+31202729994134*r**20+3584667947836*r**22
            +2352323520936*r**24+701016086610*r**26-28815119454*r**28-1001601096*r**30
            +4683951*r**32)-8*Q2**6*(-93132060-20718447041*r**2+101213135778*r**4
            -256910520219*r**6+8114202753350*r**8+7102051353355*r**10+57400650887708*r**12
            -8898959832193*r**14+16626295084612*r**16-36486742386817*r**18-33925919025190*r**20
            -9883588236245*r**22-1503024819058*r**24-851548443203*r**26-2467469208*r**28
            -1365315855*r**30-654817532*r**32+19204218*r**34)+8*Q2**5*(-66877751
            -26669458563*r**2-118817096849*r**4-2178193745325*r**6+1694960654297*r**8
            -42842466946249*r**10+86300139365913*r**12-144228096594669*r**14+79458137927147*r**16
            -53235219270815*r**18-1961043018417*r**20-13091369975407*r**22+3839335640043*r**24
            -1175280829163*r**26-492656606837*r**28+224916352137*r**30-5964313848*r**32
            -663394730*r**34+12710686*r**36)+Q2**4*(64083105+61612250267*r**2+746968340923*r**4
            +8704855399977*r**6+13161938000340*r**8+271165314256620*r**10-647719099367556*r**12
            +1763275409075812*r**14-1770003803229538*r**16+644624215478970*r**18+468288266928010*r**20
            -228680203363714*r**22+63073305795012*r**24-49130591224740*r**26+10140411389580*r**28
            +2497471321140*r**30-1089656709847*r**32+20052354403*r**34+1113168051*r**36
            -7594815*r**38)-2*Q2**3*(-50188869-13671892448*r**2+70579951094*r**4
            -792405790676*r**6+8206567484099*r**8-10378455486240*r**10+9120483086760*r**12
            +209333089152608*r**14-610973395262666*r**16+641172536301632*r**18-145138582574172*r**20
            +384989284388344*r**22-23254682984098*r**24+26827219827040*r**26-4723783133976*r**28
            +1897134761280*r**30-367568542481*r**32+25803641696*r**34+623110102*r**36
            -488112580*r**38+11095551*r**40)+3*(-1+r**2)**2*(-507241-297249761*r**2
            -1932936042*r**4-53831832746*r**6+66169470019*r**8-3167483414805*r**10
            +20848080623912*r**12-114719999250424*r**14+373007490315918*r**16-710150962766082*r**18
            +697754359444996*r**20-310643344850460*r**22+78493645150174*r**24-34062706149298*r**26
            -6096252241368*r**28-1050687282488*r**30-174722493797*r**32-85444602333*r**34
            +5016943126*r**36+4898806*r**38-7610337*r**40+100231*r**42)+2*Q2**2*(
            -31061747-13173003017*r**2-27074694578*r**4-1543795517834*r**6+5080290284153*r**8
            -61365797634937*r**10+265267930453920*r**12-797967518791264*r**14+1189068608305874*r**16
            -711704859338282*r**18+171413494393740*r**20-128734072132836*r**22-44286736516238*r**24
            -75433068633746*r**26-33441436220720*r**28-254340604656*r**30-661738452095*r**32
            -1283664116045*r**34+147320801206*r**36-355625026*r**38-378707275*r**40
            +6411403*r**42)-6*Q2*(-2585965-1319945774*r**2-4920411301*r**4-192032976968*r**6
            +585966171709*r**8-10179883341210*r**10+62101919098685*r**12-273330930371856*r**14
            +722037002155294*r**16-1058681128694652*r**18+715609091784910*r**20-108100319161376*r**22
            -39227428376966*r**24+13490730449116*r**26-31070520208998*r**28-11849114138480*r**30
            -888064295457*r**32-134473734646*r**34-249712681817*r**36+19351363816*r**38
            +12770745*r**40-35868578*r**42+519769*r**44))-16*r**6*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(28612*Q2**23
            +24*Q2**22*(-2799+1361*r**2)-8*Q2**21*(-233250-785800*r**2+524817*r**4)
            +Q2**20*(-28085477-576695775*r**2-105454991*r**4+37440667*r**6)+Q2**19*(164683830
            +6451465432*r**2+8837837588*r**4+790711416*r**6-169811490*r**8)+Q2**18*(
            -500373498-31358097814*r**2-89399326748*r**4-55724315284*r**6-3358800650*r**8
            +477033162*r**10)+Q2**17*(791835234+76927366564*r**2+382674403594*r**4
            +477417225816*r**6+189530385038*r**8+8819754068*r**10-876943386*r**12)
            +3*Q2**16*(-101524395-23543666597*r**2-255411237147*r**4-501955091181*r**6
            -424320450749*r**8-123443494275*r**10-4817467789*r**12+347483973*r**14)
            -8*Q2**15*(152245074+13741944409*r**2-35852854755*r**4-120187155438*r**6
            -220129729790*r**8-210946770387*r**10-46273718871*r**12-1698843452*r**14
            +91864026*r**16)+8*Q2**14*(285449795+48246799968*r**2+238649593522*r**4
            +730488884127*r**6+1124694570180*r**8+386696463505*r**10-66145700124*r**12
            -1355133513*r**14-640511501*r**16+34573865*r**18)-8*Q2**13*(117303291
            +43646205971*r**2+489104768902*r**4+1889529101973*r**6+4711220670689*r**8
            +4129530047503*r**10+1397695724163*r**12+203266037939*r**14+51947171116*r**16
            -90984330*r**18+33906351*r**20)+2*Q2**12*(-968342973-104570587043*r**2
            +925423064509*r**4+3962764495343*r**6+23336954898374*r**8+29862631629874*r**10
            +19264413356426*r**12+6316544576486*r**14+1420148340703*r**16+189489099113*r**18
            -4986507279*r**20+344811987*r**22)-4*Q2**11*(-717693145-180576843122*r**2
            -929177411296*r**4-5268729440932*r**6-4493875872867*r**8-7649666958380*r**10
            -8103419448912*r**12+1169956396536*r**14+2031530781289*r**16+736195290590*r**18
            -18190550080*r**20-5184669204*r**22+200823779*r**24)+4*Q2**10*(-156269103
            -117521363011*r**2-1544198630906*r**4-9071877350760*r**6-27084517803253*r**8
            -52615275371495*r**10-80476043046384*r**12-42446635382668*r**14-4620318133637*r**16
            +1977234743043*r**18+633755325002*r**20-78372117836*r**22-3495342903*r**24
            +72064743*r**26)+4*Q2**9*(-467810865-70644274196*r**2+525139880321*r**4
            +1877583920230*r**6+24656702632885*r**8+39070939415870*r**10+130094197905379*r**12
            +106874441841844*r**14+40953594353681*r**16+1491474361360*r**18-1721999890145*r**20
            -121448857978*r**22+26138564011*r**24-1186332058*r**26+68902845*r**28)
            -2*Q2**8*(-928378851-301544311489*r**2-1565317526263*r**4-15658244172585*r**6
            -5899854314307*r**8-113738693634721*r**10+112044333373593*r**12+134026467381447*r**14
            +103985863902743*r**16+53394408185853*r**18+1725147141819*r**20+1353794402885*r**22
            +1265613658191*r**24-69115660379*r**26-6264013085*r**28+158562909*r**30)
            +4*Q2**7*(-55171089-62311980294*r**2-905995995942*r**4-7328093572980*r**6
            -21541095078520*r**8-103588756322210*r**10-57265686709074*r**12-42178367222080*r**14
            +1564261241074*r**16+51555275401878*r**18+31202729994134*r**20+3584667947836*r**22
            +2352323520936*r**24+701016086610*r**26-28815119454*r**28-1001601096*r**30
            +4683951*r**32)+8*Q2**6*(-93132060-20718447041*r**2+101213135778*r**4
            -256910520219*r**6+8114202753350*r**8+7102051353355*r**10+57400650887708*r**12
            -8898959832193*r**14+16626295084612*r**16-36486742386817*r**18-33925919025190*r**20
            -9883588236245*r**22-1503024819058*r**24-851548443203*r**26-2467469208*r**28
            -1365315855*r**30-654817532*r**32+19204218*r**34)-8*Q2**5*(-66877751
            -26669458563*r**2-118817096849*r**4-2178193745325*r**6+1694960654297*r**8
            -42842466946249*r**10+86300139365913*r**12-144228096594669*r**14+79458137927147*r**16
            -53235219270815*r**18-1961043018417*r**20-13091369975407*r**22+3839335640043*r**24
            -1175280829163*r**26-492656606837*r**28+224916352137*r**30-5964313848*r**32
            -663394730*r**34+12710686*r**36)+Q2**4*(-64083105-61612250267*r**2-746968340923*r**4
            -8704855399977*r**6-13161938000340*r**8-271165314256620*r**10+647719099367556*r**12
            -1763275409075812*r**14+1770003803229538*r**16-644624215478970*r**18-468288266928010*r**20
            +228680203363714*r**22-63073305795012*r**24+49130591224740*r**26-10140411389580*r**28
            -2497471321140*r**30+1089656709847*r**32-20052354403*r**34-1113168051*r**36
            +7594815*r**38)+2*Q2**3*(-50188869-13671892448*r**2+70579951094*r**4
            -792405790676*r**6+8206567484099*r**8-10378455486240*r**10+9120483086760*r**12
            +209333089152608*r**14-610973395262666*r**16+641172536301632*r**18-145138582574172*r**20
            +384989284388344*r**22-23254682984098*r**24+26827219827040*r**26-4723783133976*r**28
            +1897134761280*r**30-367568542481*r**32+25803641696*r**34+623110102*r**36
            -488112580*r**38+11095551*r**40)+2*Q2**2*(31061747+13173003017*r**2+27074694578*r**4
            +1543795517834*r**6-5080290284153*r**8+61365797634937*r**10-265267930453920*r**12
            +797967518791264*r**14-1189068608305874*r**16+711704859338282*r**18-171413494393740*r**20
            +128734072132836*r**22+44286736516238*r**24+75433068633746*r**26+33441436220720*r**28
            +254340604656*r**30+661738452095*r**32+1283664116045*r**34-147320801206*r**36
            +355625026*r**38+378707275*r**40-6411403*r**42)-3*(-1+r**2)**2*(-507241
            -297249761*r**2-1932936042*r**4-53831832746*r**6+66169470019*r**8-3167483414805*r**10
            +20848080623912*r**12-114719999250424*r**14+373007490315918*r**16-710150962766082*r**18
            +697754359444996*r**20-310643344850460*r**22+78493645150174*r**24-34062706149298*r**26
            -6096252241368*r**28-1050687282488*r**30-174722493797*r**32-85444602333*r**34
            +5016943126*r**36+4898806*r**38-7610337*r**40+100231*r**42)+6*Q2*(-2585965
            -1319945774*r**2-4920411301*r**4-192032976968*r**6+585966171709*r**8
            -10179883341210*r**10+62101919098685*r**12-273330930371856*r**14+722037002155294*r**16
            -1058681128694652*r**18+715609091784910*r**20-108100319161376*r**22-39227428376966*r**24
            +13490730449116*r**26-31070520208998*r**28-11849114138480*r**30-888064295457*r**32
            -134473734646*r**34-249712681817*r**36+19351363816*r**38+12770745*r**40
            -35868578*r**42+519769*r**44))*sqrtq2+logq2**8*(-20316635136000000*r**38*(1
            +r**2)**2*(1-Q2+r**2)*(311-2515*r**2+2085*r**4+887*r**6)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3-20316635136000000*(Q2-(-1+r)**2)**2*r**38*(1
            +r**2)**2*(311-2515*r**2+2085*r**4+887*r**6)*(Q2-(1+r)**2)**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**7*(-32248627200000*r**32*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(18550*Q2**9*(1+r**2)-50*Q2**8*(3551
            +4360*r**2+809*r**4)+100*Q2**7*(7155+10126*r**2+3190*r**4+219*r**6)
            -2*Q2**6*(786520+1217655*r**2+425307*r**4+429929*r**6+323085*r**8)+2*Q2**5*(981295
            +1533485*r**2+925772*r**4+1690216*r**6+2444439*r**8+1127805*r**10)-Q2**4*(1113000
            +1478305*r**2+2546205*r**4+8097902*r**6+10359754*r**8+6600845*r**10
            +1707405*r**12)+Q2**3*(-371000-762835*r**2+1255360*r**4+4916673*r**6
            +10352984*r**8+8617571*r**10-2031280*r**12-3565345*r**14)+6*(-1+r**2)**2*(23585
            +24060*r**2+289826*r**4-565392*r**6-1617422*r**8+1173128*r**10+1208758*r**12
            +464012*r**14+289685*r**16)+Q2**2*(1038800+1032595*r**2+1955005*r**4
            -1190737*r**6-9441695*r**8+3571621*r**10+4638971*r**12+10191385*r**14
            +8202775*r**16)-3*Q2*(214120+32535*r**2+1184902*r**4-1650762*r**6-9753318*r**8
            +269492*r**10+11762722*r**12+4417170*r**14+1752534*r**16+2092525*r**18))
            +32248627200000*r**32*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(18550*Q2**10*(1
            +r**2)-100*Q2**9*(1961+2551*r**2+590*r**4)+50*Q2**8*(17861+28163*r**2
            +11549*r**4+1247*r**6)-2*Q2**7*(1144270+2081705*r**2+1091107*r**4+600379*r**6
            +334035*r**8)+14*Q2**6*(252545+505380*r**2+366962*r**4+363636*r**6+456779*r**8
            +207270*r**10)-Q2**5*(3075590+6507865*r**2+7464719*r**4+13329878*r**6
            +18629064*r**8+13745333*r**10+3963015*r**12)+10*Q2**4*(74200+182847*r**2
            +527987*r**4+1556078*r**6+2881064*r**8+2557817*r**10+627697*r**12-185794*r**14)
            +2*Q2**3*(704900+1083215*r**2+731240*r**4-3681385*r**6-12355676*r**8
            -7699467*r**10-973660*r**12+7894005*r**14+5884060*r**16)-6*(-1+r**2)**2*(23585
            +47645*r**2+313886*r**4-275566*r**6-2182814*r**8-444294*r**10+2381886*r**12
            +1672770*r**14+753697*r**16+289685*r**18)-2*Q2**2*(840580+1084500*r**2
            +3271153*r**4-2094009*r**6-19946193*r**8-2530799*r**10+21749379*r**12
            +14040933*r**14+11825881*r**16+7240175*r**18)+3*Q2*(261290+200435*r**2
            +1748019*r**4-2707828*r**6-11797704*r**8-1798666*r**10+6522374*r**12
            +14619140*r**14+7310542*r**16+3614343*r**18+2671895*r**20))*sqrtq2)+logq2**6*(
            -179159040000*r**28*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(
            -296800*Q2**13*(1+r**2)+60*Q2**12*(129637+222714*r**2+93077*r**4)-30*Q2**11*(2133808
            +5094359*r**2+4002334*r**4+1041783*r**6)+4*Q2**10*(66121164+199963109*r**2
            +218564243*r**4+102158151*r**6+17210509*r**8)-60*Q2**9*(10348998+37997850*r**2
            +52158788*r**4+31857743*r**6+7575804*r**8+227997*r**10)-30*Q2**8*(-26473782
            -120530793*r**2-198369757*r**4-140223310*r**6-26551394*r**8+16193435*r**10
            +6834265*r**12)+5*Q2**7*(-57708372-510961409*r**2-1054793858*r**4-758306119*r**6
            +97246448*r**8+484681357*r**10+302594814*r**12+71925203*r**14)-30*Q2**6*(23199960
            +33509581*r**2+14603050*r**4+31791889*r**6+105757662*r**8+168222551*r**10
            +116825590*r**12+35615083*r**14+6950090*r**16)+Q2**5*(1143919908+3399188673*r**2
            +5049215676*r**4+4548916782*r**6+4573646928*r**8+8556303528*r**10+9898271148*r**12
            +4575751626*r**14+366866772*r**16-48240177*r**18)+20*Q2**4*(-29612761
            -116626980*r**2-172719701*r**4-129318650*r**6-301119557*r**8-819149150*r**10
            -1092661739*r**12-775500578*r**14-272226770*r**16-22308538*r**18+9042136*r**20)
            -15*Q2**3*(11358244-17302889*r**2+9148294*r**4+72799763*r**6-201906532*r**8
            -883648930*r**10-1559852824*r**12-1167383146*r**14-37182304*r**16+222847435*r**18
            +24087730*r**20+18340375*r**22)+18*(-1+r**2)**2*(1697202+2685591*r**2
            +5802019*r**4+52584365*r**6+83519273*r**8-197018038*r**10-347012778*r**12
            +46087374*r**14+306281340*r**16+357682207*r**18+203918791*r**20+23350917*r**22
            +2322537*r**24)+30*Q2**2*(12314488+11266861*r**2+32095734*r**4+86652667*r**6
            +118797676*r**8-33118694*r**10-239483300*r**12-158658434*r**14+248050456*r**16
            +731942793*r**18+480947982*r**20+53712823*r**22+10230948*r**24)-45*Q2*(3954668
            +1944125*r**2+7290004*r**4+49716312*r**6+88163632*r**8-221829639*r**10
            -495374504*r**12+84067280*r**14+474792156*r**16+255826199*r**18+325510932*r**20
            +259762520*r**22+29183752*r**24+4033843*r**26))+179159040000*r**28*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(296800*Q2**13*(1+r**2)-60*Q2**12*(129637
            +222714*r**2+93077*r**4)+30*Q2**11*(2133808+5094359*r**2+4002334*r**4
            +1041783*r**6)-4*Q2**10*(66121164+199963109*r**2+218564243*r**4+102158151*r**6
            +17210509*r**8)+60*Q2**9*(10348998+37997850*r**2+52158788*r**4+31857743*r**6
            +7575804*r**8+227997*r**10)+30*Q2**8*(-26473782-120530793*r**2-198369757*r**4
            -140223310*r**6-26551394*r**8+16193435*r**10+6834265*r**12)-5*Q2**7*(
            -57708372-510961409*r**2-1054793858*r**4-758306119*r**6+97246448*r**8
            +484681357*r**10+302594814*r**12+71925203*r**14)+30*Q2**6*(23199960+33509581*r**2
            +14603050*r**4+31791889*r**6+105757662*r**8+168222551*r**10+116825590*r**12
            +35615083*r**14+6950090*r**16)+3*Q2**5*(-381306636-1133062891*r**2-1683071892*r**4
            -1516305594*r**6-1524548976*r**8-2852101176*r**10-3299423716*r**12-1525250542*r**14
            -122288924*r**16+16080059*r**18)-20*Q2**4*(-29612761-116626980*r**2-172719701*r**4
            -129318650*r**6-301119557*r**8-819149150*r**10-1092661739*r**12-775500578*r**14
            -272226770*r**16-22308538*r**18+9042136*r**20)+15*Q2**3*(11358244-17302889*r**2
            +9148294*r**4+72799763*r**6-201906532*r**8-883648930*r**10-1559852824*r**12
            -1167383146*r**14-37182304*r**16+222847435*r**18+24087730*r**20+18340375*r**22)
            -18*(-1+r**2)**2*(1697202+2685591*r**2+5802019*r**4+52584365*r**6+83519273*r**8
            -197018038*r**10-347012778*r**12+46087374*r**14+306281340*r**16+357682207*r**18
            +203918791*r**20+23350917*r**22+2322537*r**24)-30*Q2**2*(12314488+11266861*r**2
            +32095734*r**4+86652667*r**6+118797676*r**8-33118694*r**10-239483300*r**12
            -158658434*r**14+248050456*r**16+731942793*r**18+480947982*r**20+53712823*r**22
            +10230948*r**24)+45*Q2*(3954668+1944125*r**2+7290004*r**4+49716312*r**6
            +88163632*r**8-221829639*r**10-495374504*r**12+84067280*r**14+474792156*r**16
            +255826199*r**18+325510932*r**20+259762520*r**22+29183752*r**24+4033843*r**26))*sqrtq2)
            +logq2**5*(-995328000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1187200*Q2**17
            -160*Q2**16*(551777+496937*r**2)+10*Q2**15*(108251473+176595346*r**2
            +70686913*r**4)-2*Q2**14*(3142069815+7558686533*r**2+5830236165*r**4
            +1422263031*r**6)+Q2**13*(21103811190+69355582184*r**2+81282103664*r**4
            +39664232448*r**6+6588983298*r**8)-2*Q2**12*(21163297095+94173312848*r**2
            +152511463352*r**4+115487062214*r**6+40965340449*r**8+5187637386*r**10)
            +4*Q2**11*(10825513710+73820099516*r**2+158399589174*r**4+164324369126*r**6
            +93120576119*r**8+28199661948*r**10+3582326787*r**12)-Q2**10*(-6689965110
            +187855487101*r**2+556538941096*r**4+702141284143*r**6+565372226558*r**8
            +320693519683*r**10+116658805992*r**12+21182756457*r**14)+Q2**9*(-82538266440
            -196640112493*r**2-486570669865*r**4-997791480641*r**6-854380554545*r**8
            -114833451635*r**10+205019956817*r**12+121703326785*r**14+28594164849*r**16)
            -2*Q2**8*(-50134314835-260725320391*r**2-903605677986*r**4-1994494806182*r**6
            -2177147630362*r**8-911013215550*r**10+146003959534*r**12+241666120034*r**14
            +76622818113*r**16+14185664873*r**18)+2*Q2**7*(-13326940835-201898109404*r**2
            -813742756721*r**4-2202558554272*r**6-2879217938502*r**8-1237679779688*r**10
            +725863881806*r**12+1019125465584*r**14+444480146593*r**16+80219686468*r**18
            +9624917947*r**20)-2*Q2**6*(28482962585+4299677284*r**2+146890182421*r**4
            -178761921876*r**6-865544734014*r**8-104814230838*r**10+1643173277502*r**12
            +1944793056726*r**14+977009103909*r**16+304027442146*r**18+48922734557*r**20
            +4302322718*r**22)+6*Q2**5*(10879625065+40964850887*r**2+291486706967*r**4
            +571166335351*r**6+420917582736*r**8+215923626996*r**10+549621820836*r**12
            +904557914076*r**14+577007783991*r**16+99199801061*r**18+2264568661*r**20
            +5039808589*r**22+64661504*r**24)+6*Q2**4*(-3247513155-29307803636*r**2
            -203788666980*r**4-450833167962*r**6-308938673275*r**8-122658381270*r**10
            -724164014448*r**12-1622703327420*r**14-1663257987441*r**16-830800439280*r**18
            -131939425180*r**20+26546965254*r**22-1116838305*r**24+872681098*r**26)
            -108*Q2**3*(115012045-301657373*r**2+652602142*r**4-3176678686*r**6+503040024*r**8
            +2094387885*r**10-34083533769*r**12-95976753104*r**14-113683993323*r**16
            -49815353343*r**18-3040941980*r**20-583680658*r**22+2769853062*r**24
            +157179759*r**26+59112519*r**28)+54*(-1+r**2)**2*(10539255+61834921*r**2
            +1003721753*r**4+143942563*r**6+1375456741*r**8+12595548087*r**10+8941033323*r**12
            -24114252891*r**14-43252572911*r**16-12456085417*r**18+53196440351*r**20
            +54042784781*r**22+11404230163*r**24+1918892873*r**26+154916701*r**28
            +1665707*r**30)+9*Q2**2*(1432782490+2289316431*r**2+59099291244*r**4
            +19340068333*r**6+11525150898*r**8+189029141307*r**10+163100492548*r**12
            -191258558343*r**14-432198496146*r**16-2688575491*r**18+1095289983636*r**20
            +1050232832871*r**22+216401250374*r**24+56763387513*r**26+4707177468*r**28
            +404066867*r**30)-27*Q2*(163948300+471995063*r**2+10275279627*r**4-5686755797*r**6
            +1732371987*r**8+78430985419*r**10+14002879255*r**12-215823164849*r**14
            -97039289081*r**16+92412494021*r**18+10551811377*r**20+236775012961*r**22
            +313957714697*r**24+65360103353*r**26+13415916717*r**28+1187214629*r**30
            +36250321*r**32))+995328000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1187200*Q2**18
            -480*Q2**17*(186399+168119*r**2)+50*Q2**16*(23415981+38674954*r**2+15727581*r**4)
            -8*Q2**15*(920831795+2245730157*r**2+1766661865*r**4+443924399*r**6)
            +60*Q2**14*(456465847+1512618248*r**2+1800999151*r**4+902820514*r**6
            +157225156*r**8)-2*Q2**13*(31715202690+139403009535*r**2+227830306276*r**4
            +175960230270*r**6+64091948322*r**8+8482129035*r**10)+2*Q2**12*(42814324515
            +262976808975*r**2+563483954548*r**4+596647263818*r**6+342693554901*r**8
            +102552301731*r**10+12352290960*r**12)-3*Q2**11*(12204029910+175479313335*r**2
            +495139231952*r**4+664345705781*r**6+531717335846*r**8+268658157317*r**10
            +81262253644*r**12+11837354535*r**14)+2*Q2**10*(-44614115775-7737295251*r**2
            +128911879166*r**4+130444372299*r**6+206566478078*r**8+385616147303*r**10
            +321186141246*r**12+129772444617*r**14+24888460653*r**16)-5*Q2**9*(-36561379222
            -160125803943*r**2-498084427666*r**4-1094670352574*r**6-1241293459182*r**8
            -558248087456*r**10+76438884850*r**12+162011104734*r**14+60708625572*r**16
            +11393098919*r**18)+12*Q2**8*(-10576875945-85459624105*r**2-329678959183*r**4
            -850109839740*r**6-1175143395841*r**8-720973437600*r**10-6524229035*r**12
            +234465924192*r**14+127128180790*r**16+28504694909*r**18+3968430470*r**20)
            -2*Q2**7*(15156021750-210925372955*r**2-868750683704*r**4-3195063232869*r**6
            -5947321226788*r**8-4221711949028*r**10+1131357379620*r**12+3689782404116*r**14
            +2440614716086*r**16+828727275207*r**18+138767338972*r**20+13927240665*r**22)
            +4*Q2**6*(30560918890+77838596265*r**2+512824990303*r**4+840813633299*r**6
            +109223046159*r**8-161294041932*r**10+1593612254586*r**12+3150820038228*r**14
            +2326412756304*r**16+789317974619*r**18+179871941343*r**20+34172241521*r**22
            +2248153615*r**24)+12*Q2**5*(-7063569110-40576139794*r**2-268120112417*r**4
            -656743105140*r**6-650511295681*r**8-379749795501*r**10-744854731140*r**12
            -1538441531166*r**14-1572411842754*r**16-753504012166*r**18-116701897451*r**20
            +9621294002*r**22-3110654199*r**24+404009797*r**26)-30*Q2**4*(-235459269
            -7597029901*r**2-44269926412*r**4-142360410258*r**6-150143424161*r**8
            -78779614523*r**10-292065200712*r**12-814889779548*r**14-1066454638935*r**16
            -678146957379*r**18-203495364020*r**20-23179742354*r**22+15057496413*r**24
            +517015691*r**26+387341288*r**28)+9*Q2**3*(2812927030+49572495*r**2+63310628472*r**4
            -10948850195*r**6-20558513046*r**8+220198276215*r**10-220769258060*r**12
            -1751982000819*r**14-2948127453270*r**16-1964680735483*r**18+461014439760*r**20
            +1006737361215*r**22+242635319222*r**24+91887781365*r**26+7302684804*r**28
            +1113417095*r**30)-54*(-1+r**2)**2*(10539255+72374176*r**2+1065556674*r**4
            +1147664316*r**6+1519399304*r**8+13971004828*r**10+21536581410*r**12
            -15173219568*r**14-67366825802*r**16-55708658328*r**18+40740354934*r**20
            +107239225132*r**22+65447014944*r**24+13323123036*r**26+2073809574*r**28
            +156582408*r**30+1665707*r**32)-18*Q2**2*(962313695+2569042055*r**2+46107223278*r**4
            +30689546093*r**6+18031167596*r**8+217923624231*r**10+197069135810*r**12
            -337813780171*r**14-457287460866*r**16-78824794787*r**18+562128421138*r**20
            +1427923927695*r**22+1104253613668*r**24+234622473973*r**26+50859157566*r**28
            +4336444111*r**30+256408915*r**32)+27*Q2*(185026810+717456185*r**2+12528457022*r**4
            +985191786*r**6+228202926*r**8+100140511742*r**10+62684652454*r**12-260621828494*r**14
            -285028521542*r**16+95242819968*r**18+172676381946*r**20+117714461662*r**22
            +463762929562*r**24+445624252706*r**26+94218742306*r**28+17824581702*r**30
            +1526635524*r**32+39581735*r**34))*sqrtq2)+logq2**4*(16588800*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-99791360*Q2**20+320*Q2**19*(6352981
            +5036731*r**2)-8*Q2**18*(2148758103+3568170994*r**2+1414921371*r**4)
            +2*Q2**17*(40211551816+105112458329*r**2+87190836570*r**4+23012997577*r**6)
            -8*Q2**16*(28159455469+106473082997*r**2+138226999257*r**4+76119993487*r**6
            +15090619198*r**8)+2*Q2**15*(179374498392+1017718811085*r**2+1861656278240*r**4
            +1596535120192*r**6+666749003164*r**8+107900224839*r**10)-3*Q2**14*(61445090400
            +877615205715*r**2+2184110893723*r**4+2582651437614*r**6+1751475413426*r**8
            +633627727655*r**10+92533306875*r**12)+Q2**13*(-453384609768+540714204171*r**2
            +2413469543730*r**4+2781234848129*r**6+4143836903740*r**8+4277522403609*r**10
            +1847787456546*r**12+286918811139*r**14)+Q2**12*(1024125675264+4182159202881*r**2
            +15124371758901*r**4+35943265437457*r**6+38518947520881*r**8+16301944897619*r**10
            +274735174503*r**12-1446886786245*r**14-275820498477*r**16)+2*Q2**11*(
            -342026396192-3584803108956*r**2-17008342723818*r**4-51881837305467*r**6
            -77933030846708*r**8-58727370564549*r**10-21469618877922*r**12-2423525730345*r**14
            +574630419144*r**16+113534359981*r**18)+Q2**10*(-426208942832+4159242527995*r**2
            +24474874697001*r**4+118986498272204*r**6+246979292076012*r**8+257712754551978*r**10
            +151805867559950*r**12+51270785207164*r**14+7871960491020*r**16-611108085869*r**18
            -77831125439*r**20)-Q2**9*(-1057231049640-2639262046505*r**2-19665985240638*r**4
            +1715663188181*r**6+82033929173284*r**8+129421320083930*r**10+128120601175000*r**12
            +93339524672022*r**14+44269510724596*r**16+11457686165919*r**18+421779979030*r**20
            +114174534885*r**22)+Q2**8*(-563420850992-6419136477211*r**2-53256021412581*r**4
            -161334898429913*r**6-307197610471235*r**8-419820704085462*r**10-284207406532954*r**12
            -10791238070138*r**14+90473342006322*r**16+52325421777985*r**18+14419277980079*r**20
            +1221120615939*r**22+186170562001*r**24)-2*Q2**7*(120166096712-2063556468857*r**2
            -16682174954964*r**4-90264549461102*r**6-223342280575364*r**8-372192733579167*r**10
            -319279386008496*r**12-38697276968544*r**14+132351045181200*r**16+101869336529461*r**18
            +32956688904212*r**20+6220575483390*r**22+620587378940*r**24+48744175379*r**26)
            +Q2**6*(440121381024+488696057877*r**2+13962953819465*r**4-43998778371754*r**6
            -89517110122006*r**8-238050678771681*r**10-306983082494553*r**12+126565171551012*r**14
            +517964642664252*r**16+412556174953203*r**18+180146332908327*r**20+45518402453446*r**22
            +6467501091898*r**24+813899584537*r**26-25816273047*r**28)+3*Q2**5*(-54506825416
            -840208286025*r**2-10608745072214*r**4-23072985702795*r**6-100334396842596*r**8
            -138453406790797*r**10-45647233450370*r**12-48575565172815*r**14-163757668818576*r**16
            -150606693226907*r**18-42509301326250*r**20-5805414746065*r**22-3975761346756*r**24
            -611723188239*r**26-103397833982*r**28+23234613803*r**30)+3*Q2**4*(-15963029120
            +495496266865*r**2+4762374652177*r**4+22561211917541*r**6+87656405679929*r**8
            +123207713818805*r**10+27035253626805*r**12+10404962725401*r**14+190242238265613*r**16
            +327399225513347*r**18+228195651370115*r**20+51262622868575*r**22-7699048590053*r**24
            +986496707671*r**26-77563030601*r**28-41973061725*r**30-12671781345*r**32)
            -18*Q2**3*(-3281743088+1273803306*r**2-194829952358*r**4+1189699274187*r**6
            -56257500340*r**8+2670204262589*r**10-942366257386*r**12+2174836277795*r**14
            +37014863233856*r**16+70100246882465*r**18+55901418705126*r**20+22705523326649*r**22
            +6901235380284*r**24-1954865516993*r**26-111045900950*r**28-97176092327*r**30
            -17184413144*r**32+126710329*r**34)+27*(-1+r**2)**2*(9622728-986444339*r**2
            -11837498863*r**4-44940449576*r**6-422115910940*r**8+214766359836*r**10
            -52116191248*r**12-3464094139656*r**14-3923686860892*r**16+6682005928030*r**18
            +13990756216394*r**20-3447015387512*r**22-13701901205524*r**24-4356773765188*r**26
            -1063253436840*r**28-141315781208*r**30-11432937276*r**32-321960707*r**34
            +39442781*r**36)+9*Q2**2*(-1915235608-41523065167*r**2-640691633441*r**4
            -181320404760*r**6-12023917822576*r**8+2363408245388*r**10+3544767109500*r**12
            -23080475990728*r**14+202536964704*r**16+37239901059302*r**18+21220947280498*r**20
            -82510410019624*r**22-114057018164496*r**24-32962515083828*r**26-11870702859476*r**28
            -1512503841528*r**30-258104880584*r**32-24648292335*r**34+1469834759*r**36)
            -27*Q2*(-34536856-6495659343*r**2-77887303226*r**4-106419565817*r**6
            -2105788284028*r**8+2629128682288*r**10-394897174276*r**12-9900858217272*r**14
            +2584618029636*r**16+7585414505034*r**18+3897217137192*r**20+20393614331006*r**22
            -9751836648628*r**24-38336895806696*r**26-11621429729884*r**28-3302182688624*r**30
            -449854854012*r**32-49662962499*r**34-2844729998*r**36+237876003*r**38))
            -16588800*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(99791360*Q2**20
            -320*Q2**19*(6352981+5036731*r**2)+8*Q2**18*(2148758103+3568170994*r**2
            +1414921371*r**4)-2*Q2**17*(40211551816+105112458329*r**2+87190836570*r**4
            +23012997577*r**6)+8*Q2**16*(28159455469+106473082997*r**2+138226999257*r**4
            +76119993487*r**6+15090619198*r**8)-2*Q2**15*(179374498392+1017718811085*r**2
            +1861656278240*r**4+1596535120192*r**6+666749003164*r**8+107900224839*r**10)
            +3*Q2**14*(61445090400+877615205715*r**2+2184110893723*r**4+2582651437614*r**6
            +1751475413426*r**8+633627727655*r**10+92533306875*r**12)-Q2**13*(-453384609768
            +540714204171*r**2+2413469543730*r**4+2781234848129*r**6+4143836903740*r**8
            +4277522403609*r**10+1847787456546*r**12+286918811139*r**14)+Q2**12*(
            -1024125675264-4182159202881*r**2-15124371758901*r**4-35943265437457*r**6
            -38518947520881*r**8-16301944897619*r**10-274735174503*r**12+1446886786245*r**14
            +275820498477*r**16)+2*Q2**11*(342026396192+3584803108956*r**2+17008342723818*r**4
            +51881837305467*r**6+77933030846708*r**8+58727370564549*r**10+21469618877922*r**12
            +2423525730345*r**14-574630419144*r**16-113534359981*r**18)+Q2**10*(426208942832
            -4159242527995*r**2-24474874697001*r**4-118986498272204*r**6-246979292076012*r**8
            -257712754551978*r**10-151805867559950*r**12-51270785207164*r**14-7871960491020*r**16
            +611108085869*r**18+77831125439*r**20)+Q2**9*(-1057231049640-2639262046505*r**2
            -19665985240638*r**4+1715663188181*r**6+82033929173284*r**8+129421320083930*r**10
            +128120601175000*r**12+93339524672022*r**14+44269510724596*r**16+11457686165919*r**18
            +421779979030*r**20+114174534885*r**22)+Q2**8*(563420850992+6419136477211*r**2
            +53256021412581*r**4+161334898429913*r**6+307197610471235*r**8+419820704085462*r**10
            +284207406532954*r**12+10791238070138*r**14-90473342006322*r**16-52325421777985*r**18
            -14419277980079*r**20-1221120615939*r**22-186170562001*r**24)+2*Q2**7*(120166096712
            -2063556468857*r**2-16682174954964*r**4-90264549461102*r**6-223342280575364*r**8
            -372192733579167*r**10-319279386008496*r**12-38697276968544*r**14+132351045181200*r**16
            +101869336529461*r**18+32956688904212*r**20+6220575483390*r**22+620587378940*r**24
            +48744175379*r**26)+Q2**6*(-440121381024-488696057877*r**2-13962953819465*r**4
            +43998778371754*r**6+89517110122006*r**8+238050678771681*r**10+306983082494553*r**12
            -126565171551012*r**14-517964642664252*r**16-412556174953203*r**18-180146332908327*r**20
            -45518402453446*r**22-6467501091898*r**24-813899584537*r**26+25816273047*r**28)
            +3*Q2**5*(54506825416+840208286025*r**2+10608745072214*r**4+23072985702795*r**6
            +100334396842596*r**8+138453406790797*r**10+45647233450370*r**12+48575565172815*r**14
            +163757668818576*r**16+150606693226907*r**18+42509301326250*r**20+5805414746065*r**22
            +3975761346756*r**24+611723188239*r**26+103397833982*r**28-23234613803*r**30)
            +3*Q2**4*(15963029120-495496266865*r**2-4762374652177*r**4-22561211917541*r**6
            -87656405679929*r**8-123207713818805*r**10-27035253626805*r**12-10404962725401*r**14
            -190242238265613*r**16-327399225513347*r**18-228195651370115*r**20-51262622868575*r**22
            +7699048590053*r**24-986496707671*r**26+77563030601*r**28+41973061725*r**30
            +12671781345*r**32)+18*Q2**3*(-3281743088+1273803306*r**2-194829952358*r**4
            +1189699274187*r**6-56257500340*r**8+2670204262589*r**10-942366257386*r**12
            +2174836277795*r**14+37014863233856*r**16+70100246882465*r**18+55901418705126*r**20
            +22705523326649*r**22+6901235380284*r**24-1954865516993*r**26-111045900950*r**28
            -97176092327*r**30-17184413144*r**32+126710329*r**34)-27*(-1+r**2)**2*(9622728
            -986444339*r**2-11837498863*r**4-44940449576*r**6-422115910940*r**8+214766359836*r**10
            -52116191248*r**12-3464094139656*r**14-3923686860892*r**16+6682005928030*r**18
            +13990756216394*r**20-3447015387512*r**22-13701901205524*r**24-4356773765188*r**26
            -1063253436840*r**28-141315781208*r**30-11432937276*r**32-321960707*r**34
            +39442781*r**36)-9*Q2**2*(-1915235608-41523065167*r**2-640691633441*r**4
            -181320404760*r**6-12023917822576*r**8+2363408245388*r**10+3544767109500*r**12
            -23080475990728*r**14+202536964704*r**16+37239901059302*r**18+21220947280498*r**20
            -82510410019624*r**22-114057018164496*r**24-32962515083828*r**26-11870702859476*r**28
            -1512503841528*r**30-258104880584*r**32-24648292335*r**34+1469834759*r**36)
            +27*Q2*(-34536856-6495659343*r**2-77887303226*r**4-106419565817*r**6
            -2105788284028*r**8+2629128682288*r**10-394897174276*r**12-9900858217272*r**14
            +2584618029636*r**16+7585414505034*r**18+3897217137192*r**20+20393614331006*r**22
            -9751836648628*r**24-38336895806696*r**26-11621429729884*r**28-3302182688624*r**30
            -449854854012*r**32-49662962499*r**34-2844729998*r**36+237876003*r**38))*sqrtq2)
            +logq2**3*(-276480*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1045858560*Q2**23
            -64*Q2**22*(254016225+223699969*r**2)+2*Q2**21*(56005604925+102025901786*r**2
            +44583994781*r**4)-6*Q2**20*(72903502895+214968696291*r**2+193677814393*r**4
            +54863816901*r**6)+20*Q2**19*(50277538560+230583958153*r**2+327726757688*r**4
            +193455184533*r**6+39517244518*r**8)-10*Q2**18*(113858372454+961454946335*r**2
            +1946576344666*r**4+1812871800552*r**6+812611505120*r**8+128925674393*r**10)
            +12*Q2**17*(-33323190700+774265870117*r**2+2128451004010*r**4+2674629636460*r**6
            +2151670997395*r**8+904065620105*r**10+124279967177*r**12)+Q2**16*(3342009784650
            +6380139382067*r**2+21732226868312*r**4+53836971400125*r**6+36249787224750*r**8
            -4324046996395*r**10-8734741821048*r**12-1332200258413*r**14)+Q2**15*(
            -4300986237720-32267117426921*r**2-143638086318573*r**4-403902426087741*r**6
            -503595077629785*r**8-277595750849575*r**10-53524758611571*r**12+3423474943597*r**14
            +959096929009*r**16)-15*Q2**14*(-24497541560-2605026712183*r**2-14647758949388*r**4
            -59106797369968*r**6-104014196262340*r**8-90151540327714*r**10-39321754202724*r**12
            -7202227604992*r**14-63363121428*r**16+13156278537*r**18)-5*Q2**13*(-1027739570052
            +1006022375905*r**2+9932559743859*r**4+153668888201628*r**6+409582223068500*r**8
            +501865490835346*r**10+351620467806126*r**12+136492181269380*r**14+24313256513136*r**16
            +1009000860525*r**18+191923571359*r**20)+Q2**12*(-5391284421900-42970119294691*r**2
            -307790490388510*r**4-520016754796335*r**6-388377934409640*r**8-318747740749850*r**10
            +311942026969596*r**12+832337074199790*r**14+503344802837940*r**16+114528393831165*r**18
            +10912017267170*r**20+1439987477249*r**22)-3*Q2**11*(15805454600-17065950023889*r**2
            -145450669639889*r**4-687583936918575*r**6-1799074330179815*r**8-3491573951053470*r**10
            -3695481725683006*r**12-1807602571025426*r**14-235893772142650*r**16+109878333543215*r**18
            +36220066384335*r**20+4614618347521*r**22+126264883161*r**24)-Q2**10*(
            -4135151516880+10226181290711*r**2+106667587747408*r**4+2013723070736466*r**6
            +7063971134142800*r**8+19334740618398185*r**10+28913870068536384*r**12
            +22495715825517292*r**14+9137309275587344*r**16+1497355781130585*r**18
            -220573659809680*r**20-71490793221374*r**22-8342819974032*r**24+1025435841191*r**26)
            +5*Q2**9*(-548841634080-6052341299309*r**2-60817885318159*r**4+12952741916346*r**6
            +109227810981814*r**8+1934923836257421*r**10+4969327799467383*r**12+5508417205056380*r**14
            +3534839819742244*r**16+1474494882094077*r**18+358895628909391*r**20+6718366465610*r**22
            +1297218001542*r**24+337725085411*r**26+206300351881*r**28)+15*Q2**8*(
            -37458396076+1988809800565*r**2+21809919741238*r**4+119858164103431*r**6
            +542712584773640*r**8+1038013007514425*r**10+1042511337665514*r**12+717789615170931*r**14
            +12665791895956*r**16-508801508564385*r**18-426599279869174*r**20-160408424074731*r**22
            -22867967222768*r**24-4311631273997*r**26-502692304810*r**28+408233201*r**30)
            +Q2**7*(1512273012600-4246026770891*r**2-52684772223215*r**4-1734394010074515*r**6
            -7976407320902415*r**8-26983284649338955*r**10-45463490588787999*r**12
            -51630368245965835*r**14-27774050927006535*r**16+8216752024467975*r**18
            +18242272453366235*r**20+9464606062062431*r**22+2559508033928235*r**24
            +408846768933135*r**26+60334066849075*r**28+5919850497855*r**30-531110575181*r**32)
            +Q2**6*(-513157917000-10786258327573*r**2-126502582844268*r**4+274248504279300*r**6
            -254472500498340*r**8+12149091441692540*r**10+19150993884915588*r**12
            +25750813160599468*r**14+15136653666298300*r**16-23441709555059550*r**18
            -37463722032720260*r**20-23470161368401572*r**22-8113616127897132*r**24
            -1530611264456100*r**26-261487253850260*r**28-20937931757580*r**30-514897455268*r**32
            +223325559707*r**34)+3*Q2**5*(-77501953290+2558473470223*r**2+32368164001739*r**4
            +243460528217968*r**6+1748128311737760*r**8+1921686804835840*r**10+7931639355772992*r**12
            +8194769665111496*r**14+1229468848048932*r**16+6247993725510590*r**18
            +10747132457199110*r**20+4774414589736352*r**22+1196748981635456*r**24
            +655190535769032*r**26+147981920664200*r**28+43171022393640*r**30-2883730403642*r**32
            -976647189141*r**34+41629520743*r**36)-15*Q2**4*(-14049742970+51895701409*r**2
            +991012981044*r**4+39011167806669*r**6+201874444041952*r**8+582212104483496*r**10
            +1705645673093120*r**12+1619250144258912*r**14-443239272699764*r**16+106062719772530*r**18
            +2995397150443608*r**20+3238820302506498*r**22+914692723520304*r**24-175638347008864*r**26
            +5240548933504*r**28+6351383899816*r**30+2896567992798*r**32-925062419035*r**34
            -151590837516*r**36+8526152489*r**38)+45*Q2**3*(-601426792-30697273055*r**2
            -347764960947*r**4+1678450455771*r**6-7014729921945*r**8+87814654896648*r**10
            -9629678814344*r**12+75146804238448*r**14-108753316817648*r**16+225682290775810*r**18
            +1417572430744170*r**20+1771309656106478*r**22+1175882041132950*r**24
            +518208844265568*r**26-13034182999920*r**28+5280642508904*r**30-3106910865904*r**32
            -1033678336651*r**34-149005715391*r**36-3620490145*r**38+326417995*r**40)
            +54*(-1+r**2)**2*(-22335105+110632111*r**2+6081091820*r**4+195352310600*r**6
            +1109882339175*r**8+2001833000935*r**10+28329795596296*r**12-40375920857960*r**14
            -18208763993050*r**16+277884059886150*r**18+118842056821600*r**20-610421200080504*r**22
            -255987443822290*r**24+451021452461550*r**26+195118669671800*r**28+70166063596040*r**30
            +12782714369051*r**32+1463638996555*r**34+176695950900*r**36-2868614000*r**38
            -1072437845*r**40+31016171*r**42)+9*Q2**2*(-2547082100+81343111841*r**2
            +1158969834220*r**4+12616611087870*r**6+104376265031160*r**8-99523831516495*r**10
            +1422866573387056*r**12-788013636995720*r**14-498040937359320*r**16+1031206969326210*r**18
            -1697871715040600*r**20-1605584075853724*r**22+3896392812641280*r**24
            +6923611234915530*r**26+2347840743199600*r**28+1240170872543960*r**30
            +182324321479916*r**32+41481915310845*r**34+9260220713420*r**36+128965278030*r**38
            -72371231640*r**40+2586818661*r**42)-27*Q2*(-363694400+5271872629*r**2
            +103954937899*r**4+2273835284450*r**6+12719205044490*r**8-4109462514535*r**10
            +273463946529179*r**12-476351319465496*r**14+12883140019400*r**16+967121034763130*r**18
            +322942247423830*r**20-333280291173636*r**22-2195682649972756*r**24-737675604032150*r**26
            +2536251634372270*r**28+1000472894366920*r**30+409576856378344*r**32+70593697536529*r**34
            +9750219470175*r**36+1767529002610*r**38-3855321190*r**40-13175845891*r**42
            +419818199*r**44))+276480*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1045858560*Q2**24
            -64*Q2**23*(270357765+240041509*r**2)+2*Q2**22*(64134124125+117312819994*r**2
            +51742393789*r**4)-4*Q2**21*(137358056805+401468797792*r**2+363821669873*r**4
            +104587722742*r**6)+2*Q2**20*(721485894285+3169456179088*r**2+4503207108932*r**4
            +2680176739212*r**6+559763895883*r**8)-10*Q2**19*(214413449574+1523177939761*r**2
            +3063197776348*r**4+2855235684994*r**6+1278556363222*r**8+207960163429*r**10)
            +Q2**18*(738705436140+20044323629294*r**2+54621724958130*r**4+69690037089700*r**6
            +52074885025460*r**8+20264159236390*r**10+2780616350054*r**12)-Q2**17*(
            -3741888073050+2511172770937*r**2+13100375621212*r**4+3799996285515*r**6
            +21665820381510*r**8+40992886406395*r**10+21074888868432*r**12+2823559864537*r**14)
            +2*Q2**16*(-3821498011185-20994633296819*r**2-85875226284476*r**4-239735812178089*r**6
            -296840918127330*r**8-154760745538965*r**10-20232984897064*r**12+6745208511529*r**14
            +1145648593711*r**16)+2*Q2**15*(2334224680560+37821752173693*r**2+197810793993157*r**4
            +717071236477917*r**6+1233855223826313*r**8+1066731966697535*r**10+460473411251003*r**12
            +79067348871427*r**14-1716062525593*r**16-578220553532*r**18)-10*Q2**14*(
            -477123472686+4447297568567*r**2+30845458364286*r**4+187466278579848*r**6
            +449472601982712*r**8+542181350302754*r**10+370020175698720*r**12+138032063346264*r**14
            +23055014346198*r**16+579810694599*r**18+76227367874*r**20)+2*Q2**13*(
            -5264991136080-21539352632713*r**2-126548789894845*r**4+148995242465550*r**6
            +1213938810970500*r**8+2119245414384690*r**10+2289685910088478*r**12+1636450159788660*r**14
            +653685995875260*r**16+120569840349735*r**18+8458319713295*r**20+1199802667022*r**22)
            +2*Q2**12*(2671934029050+49779626894129*r**2+393556309301434*r**4+1445279527970285*r**6
            +3152808839872710*r**8+5590923764159950*r**10+5546625445414636*r**12+2139264305953446*r**14
            -314000280304890*r**16-473754098649375*r**18-117050305125670*r**20-13097929893491*r**22
            -909391063366*r**24)-2*Q2**11*(-2091283940340+30688307499289*r**2+297108723369371*r**4
            +2256413445205929*r**6+7261972967718985*r**8+17603342731049020*r**10+25237518549372906*r**12
            +19502484357821294*r**14+7633899152545786*r**16+937701048464445*r**18
            -329434429796165*r**20-96997423708471*r**22-11282734833039*r**24+323320595854*r**26)
            +2*Q2**10*(-3439679843640-12085338361357*r**2-93597828776338*r**4+1092577184032802*r**6
            +4811916629894168*r**8+18036665466914045*r**10+36547624842135742*r**12
            +39475835959667788*r**14+24653612099907928*r**16+9003569733594157*r**18
            +1535630132933930*r**20-129236310351502*r**22-36673761593848*r**24-2814379352893*r**26
            +1028468800298*r**28)-10*Q2**9*(-218233222926-6283806167542*r**2-66149992920591*r**4
            -203719817856053*r**6-752978600711380*r**8-534943687652020*r**10+1888358811364131*r**12
            +4162188079505485*r**14+4502629824555378*r**16+3267869613764738*r**18
            +1556594175305495*r**20+423419633799597*r**22+38309743067728*r**24+7284918454472*r**26
            +1026051175861*r**28+102537826139*r**30)-2*Q2**8*(-1037074476870+16758148919113*r**2
            +204832857675130*r**4+1929707633872275*r**6+8957484277029240*r**8+25347084266829965*r**10
            +38335677883243542*r**12+39017441269256255*r**14+19365441016504920*r**16
            -7829393887247205*r**18-16136642139934810*r**20-9134860810610503*r**22
            -2654326951695360*r**24-408270373192305*r**26-66274460265590*r**28-6727055785995*r**30
            +268617036598*r**32)+2*Q2**7*(-1012715464800-4026252284641*r**2-34785891925081*r**4
            +1030663643288515*r**6+4728164415239295*r**8+23554391705966955*r**10+45798884561521271*r**12
            +61422335997676651*r**14+47270536419635335*r**16-1942205326260495*r**18
            -31961373255277235*r**20-25588519941915119*r**22-10068865111943899*r**24
            -2249483033658735*r**26-365334044816235*r**28-43595924552255*r**30-2951818688971*r**32
            +377218067444*r**34)+2*Q2**6*(140326028565+9487418327621*r**2+117196666588529*r**4
            +291317831609436*r**6+2612304465716160*r**8-3064779263343340*r**10-3752583629644576*r**12
            -10158749025090284*r**14-18599530141375486*r**16+13524518532646510*r**18
            +46573414479688570*r**20+37628563585165444*r**22+17587012220602536*r**24
            +5804899499830164*r**26+1118022140149480*r**28+205969126394380*r**30+6400819000961*r**32
            -1319184835931*r**34-49218498739*r**36)-6*Q2**5*(-73875334070+1370225011989*r**2
            +19940851188591*r**4+235442265626526*r**6+1500480530082744*r**8+3290437819495540*r**10
            +9190777263037216*r**12+12111329871089524*r**14+3604021074830804*r**16
            +4003888086211086*r**18+15986055967463870*r**20+15857824279733976*r**22
            +5272313594486664*r**24+486873891180084*r**26+414687600550376*r**28+111454931278460*r**30
            +27385065976994*r**32-4242844843979*r**34-846485927989*r**36+42130141594*r**38)
            +30*Q2**4*(-7927011673-27122930363*r**2-193100194*r**4+22518766077513*r**6
            +109920711041393*r**8+523765256607696*r**10+1129484370566792*r**12+1775168115033688*r**14
            +424875460553102*r**16+169935159700098*r**18+3677088581224324*r**20+5774073210634770*r**22
            +3840579574712826*r**24+1146840454654072*r**26-104750173537560*r**28+13716930180016*r**30
            -36390352549*r**32-564764718095*r**34-761835201362*r**36-76963077731*r**38
            +4752703237*r**40)+18*Q2**3*(230025930+118918305538*r**2+1525640502115*r**4
            +2981591806875*r**6+65528831181015*r**8-251761728195005*r**10+515970846487768*r**12
            -557799632058120*r**14-165004187231660*r**16+223281049767700*r**18-4957072661320250*r**20
            -8774997255053482*r**22-5419782836777930*r**24-773421596038530*r**26-89016281564320*r**28
            +639469287499520*r**30+85727831632458*r**32+31092430661810*r**34+7586820486815*r**36
            +446048152855*r**38-27950435445*r**40+477364343*r**42)-54*(-1+r**2)**2*(
            -22335105+88297006*r**2+6191723931*r**4+201433402420*r**6+1305234649775*r**8
            +3111715340110*r**10+30331628597231*r**12-12046125261664*r**14-58584684851010*r**16
            +259675295893100*r**18+396726116707750*r**20-491579143258904*r**22-866408643902794*r**24
            +195034008639260*r**26+646140122133350*r**28+265284733267840*r**30+82948777965091*r**32
            +14246353365606*r**34+1640334947455*r**36+173827336900*r**38-3941051845*r**40
            -1041421674*r**42+31016171*r**44)-18*Q2**2*(-1819082650+47305823814*r**2
            +776088879879*r**4+10298543387720*r**6+77575245626250*r**8-3737977014470*r**10
            +1071867290729049*r**12-397100511002576*r**14-623702577148420*r**16+1717264568128140*r**18
            +151080998278550*r**20-2151648332207616*r**22-2148119606565356*r**24+4303488617730180*r**26
            +8440103440615970*r**28+3294715149422160*r**30+1325612881579454*r**32
            +217793664700174*r**34+39996397217395*r**36+7345886499640*r**38+22514041410*r**40
            -54655975326*r**42+1923136629*r**44)+27*Q2*(-408364610+5218782871*r**2
            +120901795514*r**4+2744391740491*r**6+16443557948530*r**8+8564583796325*r**10
            +320226507881846*r**12-392954731035551*r**14-281722432807764*r**16+1527855508811110*r**18
            +379793628299460*r**20-1150780551424914*r**22-361568914825756*r**24-2228207973953654*r**26
            -127247327807060*r**28+3798624882167170*r**30+1545188264442806*r**32+572299101623859*r**34
            +100408181660386*r**36+13732505434295*r**38+2126395163530*r**40-18416611359*r**42
            -15024968066*r**44+481850541*r**46))*sqrtq2)+logq2**2*(4608*r**12*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(-2476139008*Q2**26+32*Q2**25*(1183587709
            +1151015749*r**2)-4*Q2**24*(62558642065+131346276706*r**2+60487429585*r**4)
            +Q2**23*(907627367440+3227893143946*r**2+3150987572196*r**4+924860442730*r**6)
            -4*Q2**22*(453342393590+2706109956691*r**2+4223767178273*r**4+2685018145121*r**6
            +569066099165*r**8)+4*Q2**21*(313250613970+4889439937949*r**2+10893204831524*r**4
            +11141028125879*r**6+5674123879804*r**8+935700576670*r**10)-2*Q2**20*(
            -1439008700300+4739212401957*r**2+13641843907515*r**4+16349503768150*r**6
            +23798757373680*r**8+14759811067497*r**10+2003126072005*r**12)+Q2**19*(
            -8108126425460-38961668187029*r**2-160922352214650*r**4-398398276344875*r**6
            -330589070654000*r**8-61090596359895*r**10+18920159352646*r**12+2127465292735*r**14)
            +2*Q2**18*(3048526170620+47135772401933*r**2+251012905892168*r**4+858407746037105*r**6
            +1174635568412000*r**8+693529657049135*r**10+150420881520368*r**12+4121234241683*r**14
            +665434356140*r**16)-Q2**17*(-6054925847940+69791092944319*r**2+522643065161532*r**4
            +3080858486031394*r**6+6157326102452920*r**8+5739450778219320*r**10+2653263031372924*r**12
            +510908384595382*r**14+36159230101764*r**16+4088514807585*r**18)+2*Q2**16*(
            -7676453267970-31256995152917*r**2-153794456708327*r**4+730969463622508*r**6
            +2803941254968268*r**8+3740976009804862*r**10+3040548377235058*r**12+1374192970225148*r**14
            +259892178222958*r**16+25354974142143*r**18+1549514206605*r**20)+4*Q2**15*(1840124148180
            +43771459545794*r**2+359144745012545*r**4+1192246794650005*r**6+2360223116630425*r**8
            +4112072608870063*r**10+3112607782508983*r**12+475122326968345*r**14-324342773370245*r**16
            -97357682466625*r**18-11575214791776*r**20+473878576290*r**22)-4*Q2**14*(
            -2424705375860+28286558189836*r**2+324431615533965*r**4+2579669121225100*r**6
            +8105211607495150*r**8+19750446022152720*r**10+24466792537851574*r**12
            +14360401178449600*r**14+3485242501834200*r**16+58165873408900*r**18-55255968456755*r**20
            -4668383763564*r**22+1379603188510*r**24)+4*Q2**13*(-3449051155840-18528245985881*r**2
            -114291776234071*r**4+1633241142168935*r**6+7391671617675100*r**8+29585427590147345*r**10
            +53437472491409666*r**12+47571064620799666*r**14+22065375074746460*r**16
            +4767514277050025*r**18+263982610567525*r**20+21076559039879*r**22+6373409906744*r**24
            +659776845695*r**26)+4*Q2**12*(454317142460+41880287291479*r**2+458172960490762*r**4
            +1425365862770884*r**6+4239294504581005*r**8-6712165146543995*r**10-35641136890480169*r**12
            -48497099858373392*r**14-37744757083131614*r**16-17520982781768495*r**18
            -4126618063666820*r**20-514671477332036*r**22-110923328413163*r**24-12794799512701*r**26
            +741980944835*r**28)-2*Q2**11*(-3955556515060+36746241928887*r**2+564132432000732*r**4
            +6658192673755847*r**6+30460253943134402*r**8+85900055373309441*r**10
            +131986940482713758*r**12+170918428390508813*r**14+116074476203310648*r**16
            +15420240627556193*r**18-17151602158511584*r**20-7248120555120663*r**22
            -1542747493148518*r**24-216451112868153*r**26-12586933778298*r**28+1782079649315*r**30)
            -4*Q2**10*(1303086304660+15515382618181*r**2+133709305329615*r**4-1872089153886935*r**6
            -10494276630544090*r**8-66381328292638907*r**10-157586498157098399*r**12
            -302184106390516615*r**14-333998014943471840*r**16-183285032388513185*r**18
            -40272448142922079*r**20+4926151019319403*r**22+3066106782265390*r**24
            +669340156690615*r**26+4619329962735*r**28-6622338418349*r**30+106964409400*r**32)
            +2*Q2**9*(-649216134980+41487478233223*r**2+532577317201390*r**4+2013313350462400*r**6
            +9734572101946100*r**8-54690984803034490*r**10-162169973507871598*r**12
            -557981518306932220*r**14-933622273151494000*r**16-756582380737849000*r**18
            -341628614922996910*r**20-81485145375392248*r**22+1568695241434100*r**24
            +1613385242348050*r**26+391717947530350*r**28-127559754862220*r**30-20402394366452*r**32
            +1209427631305*r**34)-4*Q2**8*(-667440297685+4126134067271*r**2+90911839697931*r**4
            +2035797432253070*r**6+11869375397717325*r**8+36470526412487580*r**10
            +119355990823144759*r**12+117531046608703114*r**14-41030628305774865*r**16
            -117943189988672650*r**18-121339756757649575*r**20-96583122503031486*r**22
            -44138732890245041*r**24-7905427201317660*r**26-1906040425839075*r**28
            -280137478041370*r**30-38356394309494*r**32-2109174335229*r**34+194958387080*r**36)
            -2*Q2**7*(287033349280+13525696775597*r**2+127459921683316*r**4-1735951228779773*r**6
            -10981116374116430*r**8-113623330266541110*r**10-363825548521407262*r**12
            -859612948692023966*r**14-971741092739742862*r**16-782099593549059140*r**18
            -205281335096352390*r**20+302287748779403648*r**22+287863161091725734*r**24
            +111106610803603478*r**26+23749443628388790*r**28+4786938221308270*r**30
            +864505957409942*r**32-3155089774409*r**34-9311119766918*r**36+392036076205*r**38)
            +4*Q2**6*(-143575248350+4621555401779*r**2+62364744174314*r**4+405083113176569*r**6
            +2377769291587159*r**8-22037687468246132*r**10-28012460557406704*r**12
            -285351176240685164*r**14-304339372204912844*r**16-258584101096639734*r**18
            -14830893685999236*r**20+343605664013136846*r**22+355719823790924686*r**24
            +169254615208493756*r**26+40786833273637616*r**28+8125843825553668*r**30
            +999288061373954*r**32+207002627772539*r**34-7480310773606*r**36-3166800669791*r**38
            +139315348675*r**40)+12*Q2**5*(26594020690+37499653478*r**2-3491216714875*r**4
            -190410140445570*r**6-1216322842980740*r**8-5388444893775053*r**10-34113848834559104*r**12
            -993210207050000*r**14-85875187358829380*r**16-78898111192903660*r**18
            -17030507000682726*r**20-85628617995567516*r**22-70905822683259800*r**24
            -27487631294524930*r**26-15054553093573960*r**28-3432603340564624*r**30
            -1504015339637518*r**32-15062022184450*r**34+32304219614505*r**36+1140075986110*r**38
            -208511677412*r**40+6299656535*r**42)-6*Q2**4*(-3100647540+778824558979*r**2
            +5726741518155*r**4-115391312771850*r**6-849029603631650*r**8-13318734059650605*r**10
            -44127556653325641*r**12-67733154840479880*r**14-237169576910865000*r**16
            -138257748432419850*r**18+174694615919071630*r**20-69466583795820876*r**22
            -312527460278585940*r**24-101813205050930450*r**26+35517008494617150*r**28
            +5733640267914840*r**30+357777741619884*r**32-1740823436355225*r**34-2287099080825*r**36
            +107103513929350*r**38+2072758928550*r**40-887527586721*r**42+28291193515*r**44)
            +27*Q2**3*(-1959190780+53372678673*r**2+683627699638*r**4+8572275606675*r**6
            +39231486868700*r**8-724912646707165*r**10+1194988287868218*r**12-12660123819923487*r**14
            +1939383664351960*r**16+669937659190650*r**18+21374728634073900*r**20
            -46408542248002642*r**22-119845103623170392*r**24-106079713611725930*r**26
            -65843685625707900*r**28-6710167109639310*r**30-2224084526110812*r**32
            +128946283874693*r**34+73202633260030*r**36+9707086304175*r**38+6848953993980*r**40
            +144849419063*r**42-43817196702*r**44+1192984765*r**46)+54*(-1+r**2)**2*(
            -8319762+645053953*r**2+2497005433*r**4-116470416367*r**6-1679846351997*r**8
            -29818128341877*r**10-55758997841637*r**12-117538806139157*r**14-2410112861387257*r**16
            +6736682636356138*r**18-3947363757956422*r**20-23558606855624182*r**22
            +18620731408937998*r**24+28589596307628598*r**26-16940317830284682*r**28
            -8024357353750602*r**30-4520055492909412*r**32-1186704674036507*r**34
            -148918531028707*r**36-26523128354187*r**38-2473021106337*r**40+287306361903*r**42
            +11821725983*r**44-1250740017*r**46+23519103*r**48)+18*Q2**2*(608675980
            +15463319277*r**2-138687115794*r**4-12858367434303*r**6-85795991081100*r**8
            -667478232152565*r**10-4252868668367218*r**12+10974266347368351*r**14
            -58831110507534228*r**16+44317883144853970*r**18+28529325129710940*r**20
            +3519108123157242*r**22+30137950930377336*r**24-67328324812677498*r**26
            -128024988291339060*r**28-37511339087703730*r**30-34904214086566188*r**32
            -5374826077502799*r**34-1133810787518858*r**36-529786121677515*r**38-52487046727500*r**40
            +5663919781887*r**42+272468210406*r**44-43053947613*r**46+1091890580*r**48)
            -27*Q2*(-43002124+8526503877*r**2+9904204592*r**4-2413622735718*r**6
            -20638865504608*r**8-304886735021028*r**10-705462560553008*r**12+1847951269073582*r**14
            -25362972035433228*r**16+57697005623163257*r**18-16357327691316448*r**20
            -96659321749732988*r**22-1416436810254048*r**24+110282081172096992*r**26
            +82124718313334752*r**28-93830490951811748*r**30-39944033505305508*r**32
            -26468420624250393*r**34-6084344826318928*r**36-738082102462718*r**38
            -218210883764928*r**40-25982421146748*r**42+2850036429392*r**44+142101703382*r**46
            -16821546308*r**48+359650651*r**50))-4608*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(2476139008*Q2**26-32*Q2**25*(1183587709+1151015749*r**2)+4*Q2**24*(62558642065
            +131346276706*r**2+60487429585*r**4)-2*Q2**23*(453813683720+1613946571973*r**2
            +1575493786098*r**4+462430221365*r**6)+4*Q2**22*(453342393590+2706109956691*r**2
            +4223767178273*r**4+2685018145121*r**6+569066099165*r**8)-4*Q2**21*(313250613970
            +4889439937949*r**2+10893204831524*r**4+11141028125879*r**6+5674123879804*r**8
            +935700576670*r**10)+Q2**20*(-2878017400600+9478424803914*r**2+27283687815030*r**4
            +32699007536300*r**6+47597514747360*r**8+29519622134994*r**10+4006252144010*r**12)
            +Q2**19*(8108126425460+38961668187029*r**2+160922352214650*r**4+398398276344875*r**6
            +330589070654000*r**8+61090596359895*r**10-18920159352646*r**12-2127465292735*r**14)
            -2*Q2**18*(3048526170620+47135772401933*r**2+251012905892168*r**4+858407746037105*r**6
            +1174635568412000*r**8+693529657049135*r**10+150420881520368*r**12+4121234241683*r**14
            +665434356140*r**16)+Q2**17*(-6054925847940+69791092944319*r**2+522643065161532*r**4
            +3080858486031394*r**6+6157326102452920*r**8+5739450778219320*r**10+2653263031372924*r**12
            +510908384595382*r**14+36159230101764*r**16+4088514807585*r**18)-2*Q2**16*(
            -7676453267970-31256995152917*r**2-153794456708327*r**4+730969463622508*r**6
            +2803941254968268*r**8+3740976009804862*r**10+3040548377235058*r**12+1374192970225148*r**14
            +259892178222958*r**16+25354974142143*r**18+1549514206605*r**20)-4*Q2**15*(1840124148180
            +43771459545794*r**2+359144745012545*r**4+1192246794650005*r**6+2360223116630425*r**8
            +4112072608870063*r**10+3112607782508983*r**12+475122326968345*r**14-324342773370245*r**16
            -97357682466625*r**18-11575214791776*r**20+473878576290*r**22)+4*Q2**14*(
            -2424705375860+28286558189836*r**2+324431615533965*r**4+2579669121225100*r**6
            +8105211607495150*r**8+19750446022152720*r**10+24466792537851574*r**12
            +14360401178449600*r**14+3485242501834200*r**16+58165873408900*r**18-55255968456755*r**20
            -4668383763564*r**22+1379603188510*r**24)-4*Q2**13*(-3449051155840-18528245985881*r**2
            -114291776234071*r**4+1633241142168935*r**6+7391671617675100*r**8+29585427590147345*r**10
            +53437472491409666*r**12+47571064620799666*r**14+22065375074746460*r**16
            +4767514277050025*r**18+263982610567525*r**20+21076559039879*r**22+6373409906744*r**24
            +659776845695*r**26)-4*Q2**12*(454317142460+41880287291479*r**2+458172960490762*r**4
            +1425365862770884*r**6+4239294504581005*r**8-6712165146543995*r**10-35641136890480169*r**12
            -48497099858373392*r**14-37744757083131614*r**16-17520982781768495*r**18
            -4126618063666820*r**20-514671477332036*r**22-110923328413163*r**24-12794799512701*r**26
            +741980944835*r**28)+2*Q2**11*(-3955556515060+36746241928887*r**2+564132432000732*r**4
            +6658192673755847*r**6+30460253943134402*r**8+85900055373309441*r**10
            +131986940482713758*r**12+170918428390508813*r**14+116074476203310648*r**16
            +15420240627556193*r**18-17151602158511584*r**20-7248120555120663*r**22
            -1542747493148518*r**24-216451112868153*r**26-12586933778298*r**28+1782079649315*r**30)
            +4*Q2**10*(1303086304660+15515382618181*r**2+133709305329615*r**4-1872089153886935*r**6
            -10494276630544090*r**8-66381328292638907*r**10-157586498157098399*r**12
            -302184106390516615*r**14-333998014943471840*r**16-183285032388513185*r**18
            -40272448142922079*r**20+4926151019319403*r**22+3066106782265390*r**24
            +669340156690615*r**26+4619329962735*r**28-6622338418349*r**30+106964409400*r**32)
            -2*Q2**9*(-649216134980+41487478233223*r**2+532577317201390*r**4+2013313350462400*r**6
            +9734572101946100*r**8-54690984803034490*r**10-162169973507871598*r**12
            -557981518306932220*r**14-933622273151494000*r**16-756582380737849000*r**18
            -341628614922996910*r**20-81485145375392248*r**22+1568695241434100*r**24
            +1613385242348050*r**26+391717947530350*r**28-127559754862220*r**30-20402394366452*r**32
            +1209427631305*r**34)+4*Q2**8*(-667440297685+4126134067271*r**2+90911839697931*r**4
            +2035797432253070*r**6+11869375397717325*r**8+36470526412487580*r**10
            +119355990823144759*r**12+117531046608703114*r**14-41030628305774865*r**16
            -117943189988672650*r**18-121339756757649575*r**20-96583122503031486*r**22
            -44138732890245041*r**24-7905427201317660*r**26-1906040425839075*r**28
            -280137478041370*r**30-38356394309494*r**32-2109174335229*r**34+194958387080*r**36)
            +2*Q2**7*(287033349280+13525696775597*r**2+127459921683316*r**4-1735951228779773*r**6
            -10981116374116430*r**8-113623330266541110*r**10-363825548521407262*r**12
            -859612948692023966*r**14-971741092739742862*r**16-782099593549059140*r**18
            -205281335096352390*r**20+302287748779403648*r**22+287863161091725734*r**24
            +111106610803603478*r**26+23749443628388790*r**28+4786938221308270*r**30
            +864505957409942*r**32-3155089774409*r**34-9311119766918*r**36+392036076205*r**38)
            -4*Q2**6*(-143575248350+4621555401779*r**2+62364744174314*r**4+405083113176569*r**6
            +2377769291587159*r**8-22037687468246132*r**10-28012460557406704*r**12
            -285351176240685164*r**14-304339372204912844*r**16-258584101096639734*r**18
            -14830893685999236*r**20+343605664013136846*r**22+355719823790924686*r**24
            +169254615208493756*r**26+40786833273637616*r**28+8125843825553668*r**30
            +999288061373954*r**32+207002627772539*r**34-7480310773606*r**36-3166800669791*r**38
            +139315348675*r**40)-12*Q2**5*(26594020690+37499653478*r**2-3491216714875*r**4
            -190410140445570*r**6-1216322842980740*r**8-5388444893775053*r**10-34113848834559104*r**12
            -993210207050000*r**14-85875187358829380*r**16-78898111192903660*r**18
            -17030507000682726*r**20-85628617995567516*r**22-70905822683259800*r**24
            -27487631294524930*r**26-15054553093573960*r**28-3432603340564624*r**30
            -1504015339637518*r**32-15062022184450*r**34+32304219614505*r**36+1140075986110*r**38
            -208511677412*r**40+6299656535*r**42)+6*Q2**4*(-3100647540+778824558979*r**2
            +5726741518155*r**4-115391312771850*r**6-849029603631650*r**8-13318734059650605*r**10
            -44127556653325641*r**12-67733154840479880*r**14-237169576910865000*r**16
            -138257748432419850*r**18+174694615919071630*r**20-69466583795820876*r**22
            -312527460278585940*r**24-101813205050930450*r**26+35517008494617150*r**28
            +5733640267914840*r**30+357777741619884*r**32-1740823436355225*r**34-2287099080825*r**36
            +107103513929350*r**38+2072758928550*r**40-887527586721*r**42+28291193515*r**44)
            -27*Q2**3*(-1959190780+53372678673*r**2+683627699638*r**4+8572275606675*r**6
            +39231486868700*r**8-724912646707165*r**10+1194988287868218*r**12-12660123819923487*r**14
            +1939383664351960*r**16+669937659190650*r**18+21374728634073900*r**20
            -46408542248002642*r**22-119845103623170392*r**24-106079713611725930*r**26
            -65843685625707900*r**28-6710167109639310*r**30-2224084526110812*r**32
            +128946283874693*r**34+73202633260030*r**36+9707086304175*r**38+6848953993980*r**40
            +144849419063*r**42-43817196702*r**44+1192984765*r**46)-54*(-1+r**2)**2*(
            -8319762+645053953*r**2+2497005433*r**4-116470416367*r**6-1679846351997*r**8
            -29818128341877*r**10-55758997841637*r**12-117538806139157*r**14-2410112861387257*r**16
            +6736682636356138*r**18-3947363757956422*r**20-23558606855624182*r**22
            +18620731408937998*r**24+28589596307628598*r**26-16940317830284682*r**28
            -8024357353750602*r**30-4520055492909412*r**32-1186704674036507*r**34
            -148918531028707*r**36-26523128354187*r**38-2473021106337*r**40+287306361903*r**42
            +11821725983*r**44-1250740017*r**46+23519103*r**48)-18*Q2**2*(608675980
            +15463319277*r**2-138687115794*r**4-12858367434303*r**6-85795991081100*r**8
            -667478232152565*r**10-4252868668367218*r**12+10974266347368351*r**14
            -58831110507534228*r**16+44317883144853970*r**18+28529325129710940*r**20
            +3519108123157242*r**22+30137950930377336*r**24-67328324812677498*r**26
            -128024988291339060*r**28-37511339087703730*r**30-34904214086566188*r**32
            -5374826077502799*r**34-1133810787518858*r**36-529786121677515*r**38-52487046727500*r**40
            +5663919781887*r**42+272468210406*r**44-43053947613*r**46+1091890580*r**48)
            +27*Q2*(-43002124+8526503877*r**2+9904204592*r**4-2413622735718*r**6
            -20638865504608*r**8-304886735021028*r**10-705462560553008*r**12+1847951269073582*r**14
            -25362972035433228*r**16+57697005623163257*r**18-16357327691316448*r**20
            -96659321749732988*r**22-1416436810254048*r**24+110282081172096992*r**26
            +82124718313334752*r**28-93830490951811748*r**30-39944033505305508*r**32
            -26468420624250393*r**34-6084344826318928*r**36-738082102462718*r**38
            -218210883764928*r**40-25982421146748*r**42+2850036429392*r**44+142101703382*r**46
            -16821546308*r**48+359650651*r**50))*sqrtq2)+logq2*(-384*r**8*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*(27628784*Q2**25-302*Q2**24*(1376711+1886615*r**2)+8*Q2**23*(330260746
            +1026801067*r**2+585145777*r**4)-4*Q2**22*(2240397713+12198339360*r**2
            +15282320231*r**4+5248824968*r**6)+2*Q2**21*(7830290534+74036296301*r**2
            +146607451891*r**4+118295662343*r**6+28348595243*r**8)-2*Q2**20*(2215567621
            +99269297764*r**2+239494126686*r**4+347814985676*r**6+257439143179*r**8
            +45462038350*r**10)+Q2**19*(-39576922262-127916859645*r**2-1033283437535*r**4
            -1805393880050*r**6-94460135820*r**8+557009219363*r**10+67304623285*r**12)
            +2*Q2**18*(39393507839+457802761778*r**2+3090989084808*r**4+8698478258405*r**6
            +7953276689855*r**8+2240179749684*r**10+29827430378*r**12+15496486853*r**14)
            -Q2**17*(32474240342+1257600660725*r**2+10632744597479*r**4+48044406431807*r**6
            +71286707120525*r**8+46077584384087*r**10+11829318210005*r**12+1087784819309*r**14
            +99042277337*r**16)+2*Q2**16*(-47933579661-18353075139*r**2+949388954866*r**4
            +25837225670998*r**6+58393002506268*r**8+60612274158124*r**10+34731662532106*r**12
            +8256833638086*r**14+801517859053*r**16+8578704243*r**18)+4*Q2**15*(38366472882
            +539980597383*r**2+5444547513202*r**4+9244053856982*r**6+13488199639703*r**8
            +19349324829874*r**10-4408183456267*r**12-13016567910298*r**14-3512376963293*r**16
            -282089843997*r**18+33130441605*r**20)-4*Q2**14*(7678866408+581562044340*r**2
            +8330133208505*r**4+45328355110175*r**6+132017674276915*r**8+280084492245957*r**10
            +241755124596305*r**12+73426754471335*r**14+312936559005*r**16-1317654434465*r**18
            -20985535842*r**20+33419530050*r**22)+4*Q2**13*(-34073580148-65878019046*r**2
            +1612539407839*r**4+49784317728980*r**6+190388543859600*r**8+629774870447288*r**10
            +843315462082346*r**12+517670994099816*r**14+139453620347360*r**16+12594931913150*r**18
            +1629839338647*r**20+214239560004*r**22-6549090316*r**24)+4*Q2**12*(33693052097
            +628322588660*r**2+8731898480539*r**4+3212789914457*r**6+2704450321745*r**8
            -440300364358202*r**10-962375839598350*r**12-895390534498714*r**14-483442884924077*r**16
            -131814835661080*r**18-19053950359693*r**20-3549384511055*r**22-247482549301*r**24
            +29362934942*r**26)-2*Q2**11*(-5378185654+861594465539*r**2+19465039219119*r**4
            +130647045530302*r**6+652423547909522*r**8+1260096746417229*r**10+1568402985790711*r**12
            +1947815862206516*r**14+691279699707198*r**16-287773241090027*r**18-192815464438579*r**20
            -45059123680866*r**22-4712563678346*r**24+7714162667*r**26+16621814237*r**28)
            -4*Q2**10*(24123166243+140907800682*r**2-470229695777*r**4-64503107831882*r**6
            -350142637822998*r**8-1584388118789117*r**10-3183945285378872*r**12-5604414015166923*r**14
            -4699158056481413*r**16-1628478586834532*r**18-29203711527981*r**20+85069351233292*r**22
            +21635372381128*r**24-685190726457*r**26-279422837578*r**28+17360445625*r**30)
            +2*Q2**9*(24835473094+687498103225*r**2+13446502260885*r**4-6596317319225*r**6
            +63954800593765*r**8-2115779452053379*r**10-4166718146073515*r**12-13607636132060165*r**14
            -17306765759557855*r**16-10165370096475725*r**18-2990760133308929*r**20
            +8022444923645*r**22+75954650511055*r**24+17330910167095*r**26-3635559986505*r**28
            -449516272031*r**30+28143751045*r**32)+2*Q2**8*(10317768889-253935106847*r**2
            -9762182010962*r**4-90121315834010*r**6-687842960635340*r**8-1075738372773804*r**10
            -5396108235169318*r**12-446084413530158*r**14+7162950465936090*r**16+6932795377167050*r**18
            +5154636292346626*r**20+2290413647029482*r**22+242382477834572*r**24+116274735402220*r**26
            +24185290406710*r**28+1197931510174*r**30-99739947347*r**32+4401410773*r**34)
            -4*Q2**7*(7550515898+75861093555*r**2+321192643826*r**4-36706415126782*r**6
            -227907005434185*r**8-1375592644039988*r**10-4581932868363695*r**12-7416563542026066*r**14
            -5074634486060033*r**16-3070396243634770*r**18+1938924701984697*r**20
            +3206815212722110*r**22+1401410112020389*r**24+280788795765972*r**26+88784992075715*r**28
            +19247890280978*r**30-321020360085*r**32-156754908289*r**34+6898524353*r**36)
            +4*Q2**6*(1477219957+79375129708*r**2+2203936191788*r**4-1792049979881*r**6
            +57134877199759*r**8-768999719063907*r**10-551931379318453*r**12-6798881565759823*r**14
            -2677507241312159*r**16-2817907382931899*r**18+2833271480595883*r**20
            +6029630575667647*r**22+3818955561433517*r**24+917906330127551*r**26+229784257592841*r**28
            +36142323876067*r**30+5579353589998*r**32-158119935757*r**34-44587418411*r**36
            +1750599574*r**38)+2*Q2**5*(3241994954-27410852389*r**2-2155389871701*r**4
            -29652853690091*r**6-283918252250119*r**8-360562667558812*r**10-6358544270560676*r**12
            +7002495603999556*r**14-15329942565648384*r**16-2532607618259886*r**18
            -854033173242598*r**20-9794967595096586*r**22-2176170008367274*r**24-1842774805500284*r**26
            +135774647463244*r**28-286031694390604*r**30-9506154193474*r**32+16487318749419*r**34
            -52067525741*r**36-101048148739*r**38+3207366185*r**40)-2*Q2**4*(1919642661
            +23536182420*r**2+83800547920*r**4-17845245650850*r**6-105775497699225*r**8
            -888742095833674*r**10-4148015532435120*r**12+2587088911838040*r**14-21087900080299990*r**16
            +4369337931160440*r**18+14870433490296576*r**20-18107203268084460*r**22
            -8194898085538890*r**24+3015590907258780*r**26+253788270429520*r**28+438075153442776*r**30
            -190343497917375*r**32-17528601337820*r**34+14851593196560*r**36+55879191390*r**38
            -75089340589*r**40+2087990910*r**42)+3*Q2**3*(15895806+8719816137*r**2
            +314799309287*r**4-448802174070*r**6+20878716455440*r**8-252778070567179*r**10
            +503157487385507*r**12-2385133811780968*r**14-247518630087740*r**16+3473037473837010*r**18
            +3347241638620766*r**20-14851146552816388*r**22-10608421412850968*r**24
            -11437805642845710*r**26-872609120562290*r**28-491623682298344*r**30+2428805540782*r**32
            -1209545760283*r**34+1285793086395*r**36+1031339878090*r**38+17635751576*r**40
            -638914663*r**42+4121807*r**44)+18*(-1+r**2)**2*(1313333+13078805*r**2
            -179140467*r**4-23740982943*r**6-158874932875*r**8-2016576556287*r**10
            -7529994636875*r**12+42553991563453*r**14-386881236229878*r**16+1209479708897050*r**18
            -1561528899093862*r**20-806311201153230*r**22+3023709807283218*r**24-1348795882629158*r**26
            -12933510142350*r**28-266345697756622*r**30-72810833839135*r**32-8521402338927*r**34
            -2190370872903*r**36-380983813075*r**38+26924180313*r**40+903971685*r**42
            -92683527*r**44+1714257*r**46)+6*Q2**2*(99297733-544256730*r**2-64308520054*r**4
            -1159145326067*r**6-12087297133345*r**8-10080823213322*r**10-540766653137850*r**12
            +2137378532983771*r**14-7213248284385302*r**16+8403104761793620*r**18
            -940082906315972*r**20+72191698272090*r**22-932091028901354*r**24-4925707919633532*r**26
            -1091530123587580*r**28-2137303947777522*r**30-406505593910335*r**32-30667778991514*r**34
            -38641012912262*r**36-8988401012695*r**38+1060042589083*r**40+22749590950*r**42
            -5512526474*r**44+123414663*r**46)-9*Q2*(23070598+85512717*r**2-7237263133*r**4
            -333757118369*r**6-2328831814179*r**8-15302301857357*r**10-114643693495283*r**12
            +727172555376297*r**14-3979142168872639*r**16+9793609736409746*r**18-8935605024347442*r**20
            -4568187174317178*r**22+7447374637766082*r**24+4616858878208406*r**26
            -4040528229880214*r**28-561969412032062*r**30-1514820393993288*r**32-404774007639023*r**34
            -33203527283169*r**36-15649360376469*r**38-4140354877487*r**40+344899302407*r**42
            +11110734777*r**44-1478977979*r**46+29364241*r**48))+384*r**8*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**5*(221030272*Q2**30-32*Q2**29*(116892673+155390425*r**2)
            +Q2**28*(27373188574+80940195612*r**2+45995695678*r**4)-8*Q2**27*(13880966062
            +70077518823*r**2+86544699788*r**4+29737950547*r**6)+4*Q2**26*(63887711026
            +524697671548*r**2+1036904052401*r**4+802740493174*r**6+190702361167*r**8)
            -2*Q2**25*(122009912314+2086729710705*r**2+5691743972500*r**4+7343924164818*r**6
            +4447646384874*r**8+765560847541*r**10)+2*Q2**24*(-169258478910+994280345175*r**2
            +2222725008435*r**4+4232162282746*r**6+10844218725094*r**8+7174846294915*r**10
            +847027205625*r**12)+Q2**23*(1372629512130+10994519626665*r**2+65728410662440*r**4
            +179338994373163*r**6+150155877307602*r**8+22484327445499*r**10-9153996212340*r**12
            -208697153415*r**14)-2*Q2**22*(729512868885+13931143621365*r**2+101230888579620*r**4
            +399662755585703*r**6+588855552905964*r**8+365763857062863*r**10+83971137601720*r**12
            +6451912976445*r**14+1051743845835*r**16)+Q2**21*(-722574635270+20366770298265*r**2
            +215860885070630*r**4+1518988952026970*r**6+3346701609704234*r**8+3374977513546816*r**10
            +1692332625323482*r**12+360930419141206*r**14+37400647890780*r**16+2125848089335*r**18)
            +2*Q2**20*(1733449042280+13298067145325*r**2+81245756648555*r**4-371869507866072*r**6
            -1677435518950728*r**8-2461028808157078*r**10-2256670201805130*r**12-1102579891565040*r**14
            -213980191293184*r**16-18997381306015*r**18+692757485615*r**20)-Q2**19*(2753723734610
            +68616605639025*r**2+739145688152180*r**4+2811331971745913*r**6+5847149820473412*r**8
            +11242972687029882*r**10+8337865661880200*r**12+369281385207570*r**14
            -1282842258913542*r**16-246822595693403*r**18-8360892364140*r**20+4249588101125*r**22)
            +2*Q2**18*(-912327610255+19367299591485*r**2+354178442026130*r**4+3267710085200989*r**6
            +11407002777767561*r**8+30949548956465026*r**10+40906273039686452*r**12
            +24702838158165578*r**14+6018106138102219*r**16+419992934725201*r**18
            +53463855054122*r**20+13745136149545*r**22+937098038315*r**24)+Q2**17*(4754674112290
            +46570862791885*r**2+295886060240550*r**4-4515335499978636*r**6-24852239215360388*r**8
            -107590998815526463*r**10-208727510190461668*r**12-196183993531225008*r**14
            -95108859483838678*r**16-21889303083702513*r**18-2725508266821506*r**20
            -397461369473220*r**22-38319106161800*r**24+2954903833315*r**26)-2*Q2**16*(977542666855
            +41779949610240*r**2+620868482834005*r**4+2186405438077680*r**6+4905519147147033*r**8
            -19628586236823512*r**10-90096125347468973*r**12-124566137976593712*r**14
            -99605685401620551*r**16-46504563383351440*r**18-10891698642678933*r**20
            -1694494474211936*r**22-187237580768633*r**24-5698393928760*r**26+1707989275885*r**28)
            +2*Q2**15*(-1378313884950+12194451256125*r**2+421965016247680*r**4+5666865170505283*r**6
            +27600909062509942*r**8+86748907059766121*r**10+132743028434698940*r**12
            +194954405926145735*r**14+147896534068588918*r**16+24352109210536799*r**18
            -18415433530216648*r**20-7549478249065215*r**22-1454901412322550*r**24
            -12089647989669*r**26+15505741461100*r**28-358204372395*r**30)+4*Q2**14*(821156506215
            +12462396134775*r**2+118707928477580*r**4-1770843128918647*r**6-12514538245436598*r**8
            -81955704473174821*r**10-212871502107977920*r**12-461362992140580795*r**14
            -569460079916132668*r**16-349713330838554067*r**18-95357021569349796*r**20
            -4458436168915405*r**22+1711869011479310*r**24+319886768914593*r**26-73578378969928*r**28
            -10446692348385*r**30+766869628125*r**32)+2*Q2**13*(-31766607870-25326064060635*r**2
            -531821390027850*r**4-2265452904732706*r**6-6752677017625914*r**8+85215874924710150*r**10
            +347471599841115494*r**12+1229382331237032486*r**14+2235759939960411066*r**16
            +2041215342277192184*r**18+1006728123233588706*r**20+247055885471399754*r**22
            +22707359745430466*r**24+2709756576564954*r**26+706201686436866*r**28
            +123550803310642*r**30+2854426304700*r**32-513868579965*r**34)-2*Q2**12*(960196425145
            -164175741720*r**2-202377286457165*r**4-5082254627228552*r**6-30656937229358516*r**8
            -104887623603196360*r**10-226726327562534972*r**12+62531224232210488*r**14
            +1202170532372558054*r**16+1747235161553652056*r**18+1423493365287610834*r**20
            +731780959896180008*r**22+201037475385040108*r**24+36234409692324040*r**26
            +8484683421940484*r**28+1592511392196008*r**30-5202244436695*r**32-14923764296640*r**34
            +699784073395*r**36)+2*Q2**11*(482371170230+13490511073715*r**2+197969772638980*r**4
            -2332335069450225*r**6-19482983552239968*r**8-200658052699593884*r**10
            -678795532950635720*r**12-1963893071046523404*r**14-2684630024141232548*r**16
            -3277113834009218166*r**18-2379886616315485360*r**20-482889827846265902*r**22
            +305298790880132560*r**24+164065432028928852*r**26+48209990501684008*r**28
            +7496932654337508*r**30+868204496972286*r**32-62046632242037*r**34-10630312962100*r**36
            +566268276935*r**38)+4*Q2**10*(114768023635-3524454127575*r**2-111014493019685*r**4
            -823976361112681*r**6-3266444830529334*r**8+48542562437632620*r**10+206078682813310300*r**12
            +1286302878763967700*r**14+2618940638268223698*r**16+4752158707878589166*r**18
            +5404651909473760554*r**20+3155110442485151650*r**22+808139043182652640*r**24
            -62861882794523940*r**26-61261246934246292*r**28-19790001645395644*r**30
            -731667769446525*r**32+342069898413345*r**34+15539522428083*r**36-2116524587985*r**38
            +60658861870*r**40)-4*Q2**9*(144751901420+1045301312850*r**2-14098501804605*r**4
            -1196747425562643*r**6-7667936824478567*r**8-35108891731313911*r**10-111797596931982940*r**12
            +355075391283457820*r**14+897416008337229988*r**16+3405035433336346252*r**18
            +6344920852079573882*r**20+5405938461492557150*r**22+2680553250850020910*r**24
            +747743555367721058*r**26+29122093051234612*r**28-4720202923841636*r**30
            -4138501588501160*r**32+960407369368250*r**34+552720488103147*r**36-595824614147*r**38
            -4019549678255*r**40+143608080125*r**42)+2*Q2**8*(27576482060+3388536054455*r**2
            +72308584381985*r**4-618601769957006*r**6-6393392856573184*r**8-118218985679997001*r**10
            -457049379167338389*r**12-1708322949564580776*r**14-4178453779322160824*r**16
            -5101017136106725506*r**18+296702339272455434*r**20+3184056289281080588*r**22
            +3971656083289827792*r**24+3409443385545557846*r**26+1563441209200321654*r**28
            +367554381570134040*r**30+96440178148340556*r**32+21437466318627179*r**34
            +1927331433843109*r**36+226145506957586*r**38-9296381124208*r**40-1404711859885*r**42
            +53177084495*r**44)+Q2**7*(159497069770-1548882606195*r**2-83004480603080*r**4
            -1296170293263921*r**6-4172575473279438*r**8+88531982003788603*r**10+389675389374603676*r**12
            +4228475491911989361*r**14+9031856609785471860*r**16+23767481343021561938*r**18
            +20795504802150691008*r**20+13553606100306373798*r**22+1266014995113903508*r**24
            -10360620434285661402*r**26-9550420678078028312*r**28-3661129289099286190*r**30
            -946588409575601214*r**32-185313538681342959*r**34-48943388335118232*r**36
            -3571666882323813*r**38+861571997669434*r**40+19456426773935*r**42-5544684260580*r**44
            +152668038445*r**46)-2*Q2**6*(33358685865+564217194345*r**2+3183509544340*r**4
            -522862715349685*r**6-3048194940746272*r**8-26656243117050225*r**10-82032872610559832*r**12
            +557900007391672165*r**14-418479091286474123*r**16+7200156780535477258*r**18
            +3731800330101340312*r**20+1947453228671272478*r**22+16508307210505272*r**24
            -6911348171852318994*r**26-7474950997221557120*r**28-4276725141665290534*r**30
            -1152733927427607565*r**32-320583994594328899*r**34-38662684366570828*r**36
            -6068784206800921*r**38-1025756351754168*r**40+260948474095699*r**42+4668741818872*r**44
            -1470792196495*r**46+37994279055*r**48)-3*Q2**5*(5223814954-249789272975*r**2
            -7317443400570*r**4+29950690714498*r**6+754682923450722*r**8+21306846034087884*r**10
            +81754617170413650*r**12+499036107713078630*r**14+1882919430539296080*r**16
            -148968411826789451*r**18+4991293121449127740*r**20+3897147769661278740*r**22
            -1167244400883189020*r**24+4190995360107671712*r**26+3349516593490744356*r**28
            +830870128875979596*r**30+565496550501110570*r**32+113339519381882955*r**34
            +108646681076683294*r**36+13749112055098378*r**38-4548895783482918*r**40
            -366729168474860*r**42+38024032073130*r**44+1626839285166*r**46-229790461380*r**48
            +4969839119*r**50)+6*Q2**4*(2853520006-10820591425*r**2-1107496561405*r**4
            -33054589116448*r**6+10698384786308*r**8+2733458260067282*r**10+15830793399053770*r**12
            +225397791715421880*r**14+336779383196098722*r**16+961265287303288333*r**18
            +1878377839816366337*r**20+1134646105746422240*r**22-1955598971060694760*r**24
            +2046151849329644972*r**26+4071432492833123228*r**28+2160339456852434512*r**30
            -2756216230323990*r**32+20718351528983625*r**34-15481110146526443*r**36
            +18318519391906688*r**38+4742730999936932*r**40-1672932482079070*r**42
            -326774818115590*r**44+30649680326072*r**46+1179040102318*r**48-157295670069*r**50
            +3244995975*r**52)-9*Q2**3*(246601786+9474676293*r**2+133922339572*r**4
            -9207260786587*r**6-39756863413108*r**8-848944782641114*r**10-852713142132664*r**12
            +21254536211084254*r**14-116280014360053842*r**16+662191030037833287*r**18
            -1028368387913481764*r**20+799867410563529871*r**22-183193835306734136*r**24
            +1096716194362991748*r**26+2522957024625489712*r**28+1732815070185723316*r**30
            +1456039334940758966*r**32-34973857040144061*r**34+28808357854915628*r**36
            -3792856071363853*r**38-9002948097308564*r**40-1556931794409354*r**42
            -86509030271096*r**44-54432529006322*r**46+3404496748962*r**48+153940104465*r**50
            -15372015612*r**52+297764217*r**54)-54*(-1+r**2)**2*(1313333-3994524*r**2
            -491004896*r**4-22966507776*r**6+167675431551*r**8+2632002188236*r**10
            +38410361408076*r**12+375701136310116*r**14+92988195451161*r**16+2482400732113896*r**18
            +19998450662941476*r**20-69907802445949364*r**22+56599078026082771*r**24
            +198959589997483416*r**26-200448281100884744*r**28-172068397212646424*r**30
            +110341918960484751*r**32+51658230172121076*r**34+35556833021096296*r**36
            +12261535905459096*r**38+1842046362780061*r**40+315324592280156*r**42
            +58180015031676*r**44-241815118604*r**46-818639563549*r**48+24997229568*r**50
            +1923717780*r**52-114968868*r**54+1714257*r**56)-18*Q2**2*(86164403-2041298913*r**2
            -68592757958*r**4-12765026145*r**6+13223610710571*r**8+342705760907938*r**10
            +1352500437479084*r**12+13225540076993034*r**14+39025416402272703*r**16
            -156202923202937259*r**18+898069510835153838*r**20-1220790411599488691*r**22
            +147167464233559479*r**24+797291504657497068*r**26-864094706561765624*r**28
            +39062732512415228*r**30+1294367656031589849*r**32+423318488278552089*r**34
            +479124692309130678*r**36+117739265210543241*r**38+16416076579600513*r**40
            +7454664471558354*r**42+1860186739633164*r**44-48580678762022*r**46-22821191207179*r**48
            +1216816679955*r**50+73232513442*r**52-6283982933*r**54+106272093*r**56)
            +27*Q2*(23070598-224911721*r**2-11113290102*r**4-251283432388*r**6+2998347023428*r**8
            +56058250813439*r**10+401973887146124*r**12+4404222666114704*r**14+727147642760434*r**16
            -8574684831909221*r**18+268834870570989614*r**20-778875244828820436*r**22
            +611110355570035704*r**24+737478419187662819*r**26-654416738218203896*r**28
            -89623020327987456*r**30-901507576440180726*r**32+643398861404964309*r**34
            +236053668008986694*r**36+226496699053238484*r**38+76047717031004324*r**40
            +10203518912561869*r**42+2401146080705964*r**44+653498746383984*r**46
            -395269406786*r**48-10021188440519*r**50+362116029890*r**52+27688153796*r**54
            -1874427168*r**56+29364241*r**58))*sqrtq2))/(5040000*r**4*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2
            +5040000*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))**2*sqrtq2+logq2**8*(487599243264000000*r**36*(1
            +r**2)**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+487599243264000000*r**36*(1
            +r**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2*(-725760000*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4
            -Q2**3*(1+r**2)-2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4
            +r**6)+4*(1-9*r**2-44*r**4-9*r**6+r**8))-725760000*(-Q2+(-1+r)**2)**3*r**8*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4-Q2**3*(1+r**2)
            -2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4+r**6)+4*(1-9*r**2
            -44*r**4-9*r**6+r**8))*sqrtq2)+logq2**7*(-10835538739200000*r**32*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))-10835538739200000*r**32*(1+r**2)*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))*sqrtq2)+logq2**3*(-174182400000*(-Q2+(-1
            +r)**2)**3*r**16*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8
            +68*Q2**7*(1+r**2)-Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2
            +683*r**4+169*r**6)+2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)
            +6*Q2**3*(31+230*r**2+159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(
            -131+1184*r**2+6523*r**4+8368*r**6+6523*r**8+1184*r**10-131*r**12)
            -9*Q2*(13+5*r**2-1493*r**4-5245*r**6-5245*r**8-1493*r**10+5*r**12
            +13*r**14)+36*(4-67*r**2-28*r**4+2331*r**6+5600*r**8+2331*r**10-28*r**12
            -67*r**14+4*r**16))-174182400000*(-Q2+(-1+r)**2)**3*r**16*(1-Q2+r**2)*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)
            -Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2+683*r**4+169*r**6)
            +2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)+6*Q2**3*(31+230*r**2
            +159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4
            +8368*r**6+6523*r**8+1184*r**10-131*r**12)-9*Q2*(13+5*r**2-1493*r**4
            -5245*r**6-5245*r**8-1493*r**10+5*r**12+13*r**14)+36*(4-67*r**2-28*r**4
            +2331*r**6+5600*r**8+2331*r**10-28*r**12-67*r**14+4*r**16))*sqrtq2)
            +logq2**2*(43545600000*(-Q2+(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8-4*Q2**7*(1+r**2)-Q2**6*(57
            +50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4+5*r**6)+Q2**4*(85-226*r**2
            -1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1-54*r**2-143*r**4-143*r**6
            -54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4+3168*r**6+2871*r**8
            +468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4-2833*r**6-2833*r**8
            -565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4+4368*r**6+11718*r**8
            +4368*r**10-56*r**12-96*r**14+5*r**16))+43545600000*(-Q2+(-1+r)**2)**3*r**12*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8-4*Q2**7*(1+r**2)
            -Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4+5*r**6)+Q2**4*(85
            -226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1-54*r**2-143*r**4
            -143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4+3168*r**6+2871*r**8
            +468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4-2833*r**6-2833*r**8
            -565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4+4368*r**6+11718*r**8
            +4368*r**10-56*r**12-96*r**14+5*r**16))*sqrtq2)+logq2**5*(-15049359360000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219+310*r**2
            +219*r**4)-Q2**5*(977+2179*r**2+2179*r**4+977*r**6)+Q2**4*(590-2090*r**2
            -6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4-2073*r**6
            +10*r**8+243*r**10)+Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6+41127*r**8
            +8076*r**10-879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6+67125*r**8
            +31341*r**10+3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4+12789*r**6
            +25830*r**8+12789*r**10+28*r**12-573*r**14+41*r**16))-15049359360000*r**24*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219
            +310*r**2+219*r**4)-Q2**5*(977+2179*r**2+2179*r**4+977*r**6)+Q2**4*(590
            -2090*r**2-6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4
            -2073*r**6+10*r**8+243*r**10)+Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6
            +41127*r**8+8076*r**10-879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6
            +67125*r**8+31341*r**10+3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4
            +12789*r**6+25830*r**8+12789*r**10+28*r**12-573*r**14+41*r**16))*sqrtq2)
            +logq2**4*(3135283200000*r**20*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(32*Q2**8
            +104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)-24*Q2**5*(13+31*r**2
            +31*r**4+13*r**6)+Q2**4*(415-1180*r**2-4598*r**4-1180*r**6+415*r**8)
            +4*Q2**3*(102+155*r**2-677*r**4-677*r**6+155*r**8+102*r**10)+Q2**2*(
            -389+3526*r**2+18377*r**4+25852*r**6+18377*r**8+3526*r**10-389*r**12)
            -12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8-1133*r**10-55*r**12
            +18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6+53690*r**8+24556*r**10
            -168*r**12-892*r**14+59*r**16))+3135283200000*r**20*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)
            -24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415-1180*r**2-4598*r**4
            -1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4-677*r**6+155*r**8
            +102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6+18377*r**8
            +3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8
            -1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6
            +53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))*sqrtq2)+logq2**6*(60197437440000*r**28*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(16*Q2**8+332*Q2**7*(1
            +r**2)+Q2**6*(153+370*r**2+153*r**4)-Q2**5*(2011+4817*r**2+4817*r**4
            +2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4-2410*r**6+295*r**8)+6*Q2**3*(559
            -310*r**2-4869*r**4-4869*r**6-310*r**8+559*r**10)-3*Q2**2*(479-4496*r**2
            -22867*r**4-35272*r**6-22867*r**8-4496*r**10+479*r**12)-9*Q2*(187
            -865*r**2-5807*r**4-10315*r**6-10315*r**8-5807*r**10-865*r**12+187*r**14)
            +9*(109-1432*r**2+392*r**4+26376*r**6+49910*r**8+26376*r**10+392*r**12
            -1432*r**14+109*r**16))+60197437440000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(16*Q2**8+332*Q2**7*(1+r**2)+Q2**6*(153+370*r**2+153*r**4)
            -Q2**5*(2011+4817*r**2+4817*r**4+2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4
            -2410*r**6+295*r**8)+6*Q2**3*(559-310*r**2-4869*r**4-4869*r**6-310*r**8
            +559*r**10)-3*Q2**2*(479-4496*r**2-22867*r**4-35272*r**6-22867*r**8
            -4496*r**10+479*r**12)-9*Q2*(187-865*r**2-5807*r**4-10315*r**6-10315*r**8
            -5807*r**10-865*r**12+187*r**14)+9*(109-1432*r**2+392*r**4+26376*r**6
            +49910*r**8+26376*r**10+392*r**12-1432*r**14+109*r**16))*sqrtq2))+((
            -4*(Q2-(-1+r)**2)**4*r**4*(1-Q2+r**2)*(Q2-(1+r)**2)**4*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(-92*Q2**18-60*Q2**17*(1+r**2)+4*Q2**16*(
            -1499-3228*r**2+1519*r**4)+Q2**15*(72623+1046341*r**2+160589*r**4-34969*r**6)
            +Q2**14*(-299825-8852676*r**2-10808350*r**4-776500*r**6+94735*r**8)
            +Q2**13*(576101+29535579*r**2+82368756*r**4+43289452*r**6+1877655*r**8
            -135799*r**10)+Q2**12*(-381315-38482536*r**2-239240429*r**4-277504064*r**6
            -79598981*r**8-2114840*r**10+76245*r**12)+Q2**11*(-493297-20511955*r**2
            +237317447*r**4+530987613*r**6+387002253*r**8+41680119*r**10-50819*r**12
            +56927*r**14)+Q2**10*(1074711+122446116*r**2+261376636*r**4+280696044*r**6
            +60797850*r**8-63891428*r**10+87830460*r**12+2723028*r**14-101673*r**16)
            -Q2**9*(341275+112792173*r**2+851014790*r**4+2103692810*r**6+3429691340*r**8
            +1396512740*r**10+436523258*r**12+153045270*r**14+1716825*r**16+9295*r**18)
            +Q2**8*(-889251-54890208*r**2+590459833*r**4+1670586336*r**6+6297176130*r**8
            +4841499376*r**10+1065281922*r**12+528837568*r**14+37227201*r**16-2320560*r**18
            +120549*r**20)+Q2**7*(994085+168225927*r**2+357891963*r**4+1950721473*r**6
            -778030638*r**8+777200710*r**10+1046459542*r**12+511955778*r**14-340834967*r**16
            +105058067*r**18+3712335*r**20-89635*r**22)-Q2**6*(70043+76673404*r**2
            +764189182*r**4+3289645276*r**6+8434570341*r**8+17554642744*r**10+19515767172*r**12
            +5395152088*r**14+193046501*r**16-158583284*r**18+89263870*r**20+875276*r**22
            +10907*r**24)+Q2**5*(-508441-63392055*r**2+323302736*r**4-37241456*r**6
            +8386679415*r**8+12693116089*r**10+39203740728*r**12+16900419912*r**14
            +1763653493*r**16-848638885*r**18+178260472*r**20-9932888*r**22-1674323*r**24
            +48803*r**26)+Q2**4*(316975+76375224*r**2+131177365*r**4+2445366560*r**6
            -714459345*r**8+20178975160*r**10-29566065683*r**12-14255612160*r**14
            -701297035*r**16+975854760*r**18+224047815*r**20-417821216*r**22+41907245*r**24
            +1300200*r**26-21065*r**28)+Q2**3*(9117-14144121*r**2-170056239*r**4
            -1061850213*r**6-3845099135*r**8-26031776957*r**10+12379537797*r**12
            -4354598937*r**14+11620863591*r**16+3295991205*r**18+152368323*r**20
            +570114849*r**22+193648251*r**24-13345903*r**26+7655*r**28-5283*r**30)
            +Q2**2*(-84335-15657956*r**2+57506816*r**4-600798684*r**6+3037842044*r**8
            -3267499140*r**10+12997085632*r**12-6908662492*r**14-18283866522*r**16
            -18885157708*r**18-2821795840*r**20-279101876*r**22-403896324*r**24+108011956*r**26
            -5478336*r**28-391060*r**30+7825*r**32)-3*Q2*(-11737-3122007*r**2+2026122*r**4
            -191370746*r**6+336016054*r**8-4793498550*r**10+15426377970*r**12-23365152962*r**14
            +7896633092*r**16+2428061692*r**18-53763714*r**20+2180654706*r**22+134272058*r**24
            -35892346*r**26+40213254*r**28-1384374*r**30-59419*r**32+907*r**34)
            +3*(-1631-528384*r**2-60287*r**4-41405248*r**6+39342620*r**8-1532131152*r**10
            +8274408172*r**12-29995134624*r**14+52589566534*r**16-43249613040*r**18
            +13813606422*r**20-1374664192*r**22+1391081884*r**24+82272976*r**26-6254580*r**28
            +9760736*r**30-237471*r**32-8848*r**34+113*r**36))+4*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**4*(736*Q2**22-164*Q2**21*(1+r**2)-8*Q2**20*(
            -5863-12830*r**2+6209*r**4)+20*Q2**19*(-31155-425321*r**2-66795*r**4
            +16107*r**6)+Q2**18*(2865445+78570100*r**2+94911790*r**4+6983140*r**6
            -959675*r**8)+2*Q2**17*(-3090527-146667235*r**2-398849530*r**4-210439090*r**6
            -9181315*r**8+743353*r**10)+Q2**16*(4784571+456317406*r**2+2671394545*r**4
            +3089930340*r**6+881714845*r**8+22144926*r**10-810729*r**12)-4*Q2**15*(
            -1497871-28555120*r**2+881680183*r**4+1965172890*r**6+1340268435*r**8
            +150861544*r**10-764215*r**12+262898*r**14)+20*Q2**14*(-777440-72542542*r**2
            -92556030*r**4+99985982*r**6+243169743*r**8+115760126*r**10-50476392*r**12
            -2025190*r**14+93439*r**16)-20*Q2**13*(-310787-83141990*r**2-589236664*r**4
            -1353719658*r**6-2135860308*r**8-949127860*r**10-325781616*r**12-111635934*r**14
            -1456929*r**16+3010*r**18)-4*Q2**12*(-3717974-161712590*r**2+3072315480*r**4
            +11567244990*r**6+35914992495*r**8+33297080804*r**10+10276258125*r**12
            +2963189550*r**14+181465215*r**16-9331010*r**18+535171*r**20)+4*Q2**11*(
            -4577651-704045446*r**2-817140815*r**4+199576200*r**6+35195915610*r**8
            +60171084836*r**10+34993132166*r**12+6025344060*r**14+1921351425*r**16
            -488043590*r**18-16519711*r**20+407524*r**22)+2*Q2**10*(-453063+710194160*r**2
            +8757214614*r**4+35911777560*r**6+62067170885*r**8+45037217288*r**10
            +42152523300*r**12+13582344856*r**14+8079031035*r**16+769342920*r**18
            +982978502*r**20+4140240*r**22+318279*r**24)-20*Q2**9*(-711370-80244697*r**2
            +609463880*r**4+3127531220*r**6+21145306736*r**8+39234036757*r**10+66187424212*r**12
            +33881513380*r**14+9461408242*r**16+1516769741*r**18+477432212*r**20
            -18798472*r**22-2452840*r**24+71399*r**26)+10*Q2**8*(-689969-193942990*r**2
            -424346443*r**4-2381844544*r**6+29984342153*r**8+63840564102*r**10+247458855871*r**12
            +211406379568*r**14+56616655057*r**16+14544085038*r**18+1130956499*r**20
            +974323856*r**22-141045673*r**24-2995558*r**26+34105*r**28)+4*Q2**7*(
            -1046331-6986640*r**2+2807960255*r**4+15990252690*r**6+46982782425*r**8
            +153500580376*r**10-188817996105*r**12-275486365090*r**14-90227215265*r**16
            +32352779520*r**18-8891096539*r**20+1129268990*r**22+25783395*r**24+99348440*r**26
            -3890235*r**28+134514*r**30)-4*Q2**6*(-1173194-240196814*r**2+1251959810*r**4
            +5397166830*r**6+103684435335*r**8+261962637994*r**10+766724823704*r**12
            +1062373628990*r**14+1154903353125*r**16+408055557590*r**18+48795009914*r**20
            -8104054886*r**22-352771815*r**24+1997881230*r**26-111293140*r**28-5272454*r**30
            +90181*r**32)-4*Q2**5*(58454+83498785*r**2+614729268*r**4+5070769690*r**6
            -36966938670*r**8-3750177844*r**10-1012961279940*r**12-1126798664758*r**14
            -2738316873530*r**16-1452661624970*r**18-256778954884*r**20+27021416430*r**22
            +200219702*r**24+1335602940*r**26-1080609260*r**28+69513774*r**30+391900*r**32
            +10913*r**34)+20*Q2**4*(-64150-10201334*r**2+170253080*r**4+868557006*r**6
            +6742984043*r**8+30911507896*r**10-24296863191*r**12+240878254290*r**14
            -436852355289*r**16-224241654616*r**18-32699137687*r**20+11810540434*r**22
            -102549015*r**24-4461509120*r**26-256539277*r**28+103644366*r**30-1921509*r**32
            -314730*r**34+5603*r**36)-60*Q2**3*(-7298-2356125*r**2+14112094*r**4
            +25594681*r**6+1948299344*r**8+3742305372*r**10+42030495588*r**12+106763697016*r**14
            -38359259308*r**16+4704403122*r**18-20489197320*r**20-15646171846*r**22
            -2286272464*r**24-2296093892*r**26-1105706196*r**28-139231104*r**30+38480558*r**32
            -1103021*r**34-37606*r**36+405*r**38)-3*Q2**2*(-37707-1803140*r**2+174530430*r**4
            +898532540*r**6-1342331595*r**8+40098187648*r**10-472408852040*r**12
            +732358578880*r**14-1851832881590*r**16+755144441880*r**18+1949622466788*r**20
            +2451613456600*r**22+468178935250*r**24+141108574560*r**26+24588920600*r**28
            -5614189792*r**30+58556705*r**32-15667060*r**34+3126990*r**36-230260*r**38
            +4313*r**40)+18*Q2*(-5053-1223623*r**2+20533810*r**4+54414010*r**6
            +1186756135*r**8+4984570817*r**10+14488694192*r**12+155239831440*r**14
            -668805592610*r**16+1075475371290*r**18-157435300988*r**20-367116721868*r**22
            +63624780190*r**24-108715887310*r**26-12536987360*r**28+1272858112*r**30
            -1583713473*r**32-178447315*r**34+26348410*r**36-248190*r**38-31013*r**40
            +397*r**42)-9*(-1631-505550*r**2+7490403*r**4+9129700*r**6+632078815*r**8
            +1809481114*r**10+26605651205*r**12-2408722672*r**14-283783738150*r**16
            +1922665264580*r**18-3895904772306*r**20+3104449405560*r**22-619758474002*r**24
            -126814542300*r**26-98860868230*r**28-28486145456*r**30+690302965*r**32
            -744356342*r**34-120458625*r**36+13915460*r**38-124221*r**40-10430*r**42
            +113*r**44))*sqrtq2+logq2**6*(2351462400000*(-Q2+(-1+r)**2)*(-1+r)*r**28*(1
            +r)*(1+r**2)*(1-Q2+r**2)*(-1+4*r**2+r**4)*(-Q2+(1+r)**2)+2351462400000*r**28*(1
            -4*r**2-2*r**4+4*r**6+r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**5*(3732480000*r**22*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-70*Q2**7*(1
            +r**2)+10*Q2**6*(53+76*r**2+23*r**4)+10*Q2**5*(-157-305*r**2-125*r**4
            +23*r**6)+Q2**4*(2266+5806*r**2+2778*r**4-2702*r**6-1716*r**8)+4*Q2**3*(
            -326-1372*r**2-554*r**4+1744*r**6+1663*r**8+411*r**10)+2*Q2**2*(-337
            +595*r**2+664*r**4-3032*r**6-4453*r**8-853*r**10+612*r**12)-3*Q2*(
            -452-645*r**2+498*r**4+735*r**6-1068*r**8-1047*r**10+1022*r**12+957*r**14)
            +3*(-178-291*r**2+985*r**4-989*r**6-4321*r**8+1587*r**10+2175*r**12
            +589*r**14+443*r**16))+3732480000*r**22*(70*Q2**10*(1+r**2)-20*Q2**9*(37
            +59*r**2+22*r**4)+10*Q2**8*(337+727*r**2+457*r**4+67*r**6)+2*Q2**7*(
            -4318-11503*r**2-9669*r**4-1549*r**6+823*r**8)-14*Q2**6*(-953-3016*r**2
            -2962*r**4-268*r**6+1149*r**8+518*r**10)+2*Q2**5*(-5803-22498*r**2
            -23907*r**4+4218*r**6+24989*r**8+18326*r**10+4543*r**12)-5*Q2**4*(-560
            -4445*r**2-5058*r**4+4211*r**6+14272*r**8+13389*r**10+4522*r**12+21*r**14)
            +3*(-1+r**2)**3*(178+647*r**2-47*r**4-43*r**6+5267*r**8+8001*r**10
            +4239*r**12+1475*r**14+443*r**16)-2*Q2**3*(-2660-2170*r**2+699*r**4
            -8606*r**6-23613*r**8-20598*r**10-9419*r**12+5950*r**14+5985*r**16)
            +2*Q2**2*(-3172-5437*r**2+1801*r**4-2747*r**6-25745*r**8-9615*r**10
            +16467*r**12+10887*r**14+10649*r**16+6912*r**18)-6*Q2*(-493-711*r**2
            +1717*r**4-720*r**6-7466*r**8-3532*r**10+304*r**12+5396*r**14+3003*r**16
            +1359*r**18+1143*r**20))*sqrtq2)+logq2**4*(10368000*r**18*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1120*Q2**11-40*Q2**10*(463+343*r**2)
            +20*Q2**9*(5598+9401*r**2+3579*r**4)-16*Q2**8*(21419+57837*r**2+47750*r**4
            +12476*r**6)+4*Q2**7*(135368+544057*r**2+709339*r**4+391017*r**6+78047*r**8)
            -Q2**6*(272832+2291461*r**2+4400212*r**4+3800814*r**6+1567540*r**8+266133*r**10)
            +2*Q2**5*(-220528+6795*r**2+480911*r**4+1039682*r**6+1140282*r**8+361111*r**10
            +74123*r**12)+Q2**4*(756560+2200635*r**2+5369086*r**4+5468913*r**6-1950140*r**8
            -3762451*r**10-661490*r**12-127225*r**14)+12*Q2**3*(-23848-145619*r**2
            -506372*r**4-699975*r**6+339684*r**8+1039559*r**10+509668*r**12+81095*r**14
            +5208*r**16)+3*Q2**2*(-70584+97119*r**2+176040*r**4+877892*r**6-1061288*r**8
            -5155610*r**10-3159048*r**12+140156*r**14-42016*r**16+32539*r**18)-18*Q2*(
            -11924-8467*r**2-169481*r**4-118784*r**6+250860*r**8-65590*r**10-448558*r**12
            +140416*r**14+390024*r**16+34505*r**18+6999*r**20)+9*(-5856-4915*r**2
            -171594*r**4-14467*r**6+228240*r**8-520586*r**10-393676*r**12+95334*r**14
            +330832*r**16+417725*r**18+34582*r**20+4381*r**22))+10368000*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1120*Q2**11-40*Q2**10*(463+343*r**2)
            +20*Q2**9*(5598+9401*r**2+3579*r**4)-16*Q2**8*(21419+57837*r**2+47750*r**4
            +12476*r**6)+4*Q2**7*(135368+544057*r**2+709339*r**4+391017*r**6+78047*r**8)
            -Q2**6*(272832+2291461*r**2+4400212*r**4+3800814*r**6+1567540*r**8+266133*r**10)
            +2*Q2**5*(-220528+6795*r**2+480911*r**4+1039682*r**6+1140282*r**8+361111*r**10
            +74123*r**12)+Q2**4*(756560+2200635*r**2+5369086*r**4+5468913*r**6-1950140*r**8
            -3762451*r**10-661490*r**12-127225*r**14)+12*Q2**3*(-23848-145619*r**2
            -506372*r**4-699975*r**6+339684*r**8+1039559*r**10+509668*r**12+81095*r**14
            +5208*r**16)+3*Q2**2*(-70584+97119*r**2+176040*r**4+877892*r**6-1061288*r**8
            -5155610*r**10-3159048*r**12+140156*r**14-42016*r**16+32539*r**18)-18*Q2*(
            -11924-8467*r**2-169481*r**4-118784*r**6+250860*r**8-65590*r**10-448558*r**12
            +140416*r**14+390024*r**16+34505*r**18+6999*r**20)+9*(-5856-4915*r**2
            -171594*r**4-14467*r**6+228240*r**8-520586*r**10-393676*r**12+95334*r**14
            +330832*r**16+417725*r**18+34582*r**20+4381*r**22))*sqrtq2)+logq2**3*(691200*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(6040*Q2**14-40*Q2**13*(1717+1594*r**2)
            +6*Q2**12*(56105+105627*r**2+47066*r**4)-4*Q2**11*(218475+672236*r**2
            +615914*r**4+166353*r**6)+4*Q2**10*(277725+1486603*r**2+2160818*r**4
            +1233470*r**6+213954*r**8)-30*Q2**9*(2091+203128*r**2+406142*r**4+373524*r**6
            +159933*r**8+17658*r**10)+10*Q2**8*(-179709-127157*r**2-729770*r**4
            -1318228*r**6-406781*r**8+81919*r**10+8730*r**12)+Q2**7*(2134140+10896361*r**2
            +49318958*r**4+108457305*r**6+93813080*r**8+30766055*r**10+2215166*r**12
            +14103*r**14)-3*Q2**6*(75900+3683359*r**2+18606971*r**4+63097297*r**6
            +84376685*r**8+48168485*r**10+11650609*r**12+359211*r**14+43947*r**16)
            +Q2**5*(-1426600+1054561*r**2-10443884*r**4+86498170*r**6+222991528*r**8
            +205266820*r**10+79196236*r**12+14503246*r**14+154480*r**16+417443*r**18)
            -5*Q2**4*(-216038-1284133*r**2-13610857*r**4-21608978*r**6-16436874*r**8
            +7836032*r**10+22070188*r**12+7263066*r**14+1535816*r**16+403917*r**18
            +69205*r**20)-15*Q2**3*(1232+306323*r**2+2630070*r**4+9309725*r**6+15167456*r**8
            +5812862*r**10-16901308*r**12-16774294*r**14-4963312*r**16-654129*r**18
            -157626*r**20+2201*r**22)+3*Q2**2*(-106840+24359*r**2-4344493*r**4+16724055*r**6
            +16613515*r**8+4616870*r**10-94138698*r**12-138715514*r**14-37514770*r**16
            -9244205*r**18+1108055*r**20-26301*r**22+59967*r**24)-9*Q2*(-16650
            -118219*r**2-2159316*r**4+469828*r**6-11255590*r**8-1175335*r**10+9829088*r**12
            -23727088*r**14-5724286*r**16+27575015*r**18+4956660*r**20+1226156*r**22
            +110254*r**24+9483*r**26)+9*(-2450-36197*r**2-559757*r**4+12580*r**6
            -6265906*r**8-2125205*r**10+7941439*r**12+3066584*r**14-20073990*r**16
            -4372743*r**18+19012105*r**20+2888708*r**22+471498*r**24+41985*r**26
            +1349*r**28))-691200*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(6040*Q2**15
            -40*Q2**14*(1868+1745*r**2)+Q2**13*(405310+766202*r**2+346156*r**4)
            -2*Q2**12*(605265+1829668*r**2+1689907*r**4+473904*r**6)+4*Q2**11*(496200
            +2377314*r**2+3448968*r**4+2015737*r**6+380307*r**8)-2*Q2**10*(586815
            +6575576*r**2+13386972*r**4+12391436*r**6+5293843*r**8+692778*r**10)
            +20*Q2**9*(-86718+244250*r**2+549020*r**4+510385*r**6+596795*r**8+307346*r**10
            +30852*r**12)+Q2**8*(3931230+13965021*r**2+57888228*r**4+128937285*r**6
            +111063170*r**8+34014675*r**10+1308676*r**12-73197*r**14)-2*Q2**7*(1180920
            +12040289*r**2+58018116*r**4+173534077*r**6+227700220*r**8+134542295*r**10
            +33966524*r**12+1653451*r**14+72972*r**16)+2*Q2**6*(-599450+6166169*r**2
            +28213553*r**4+165805487*r**6+332706737*r**8+301451165*r**10+129326759*r**12
            +25266353*r**14+681977*r**16+274642*r**18)-2*Q2**5*(-1253395-3396352*r**2
            -38721804*r**4-15995302*r**6+113652664*r**8+233719254*r**10+197406998*r**12
            +65007406*r**14+11168403*r**16+1295754*r**18+381734*r**20)+10*Q2**4*(
            -109867-1209570*r**2-11392600*r**4-31574505*r**6-41774110*r**8-13019714*r**10
            +40305072*r**12+39828068*r**14+11844409*r**16+1951060*r**18+473000*r**20
            +31301*r**22)+6*Q2**3*(-50340+781067*r**2+5168736*r**4+38211515*r**6
            +69499710*r**8+54759230*r**10-74790464*r**12-153546762*r**14-73101400*r**16
            -18665705*r**18-1475360*r**20-401713*r**22+35486*r**24)-6*Q2**2*(-78395
            -218569*r**2-5399041*r**4+6894523*r**6-214600*r**8+8852190*r**10-30017282*r**12
            -152017738*r**14-96701571*r**16+17983035*r**18+3366915*r**20+2380111*r**22
            +182214*r**24+44208*r**26)+18*Q2*(-9550-85533*r**2-1418646*r**4-838454*r**6
            -8525834*r**8-7278065*r**10+8297596*r**12-5415708*r**14-24762682*r**16
            +8738993*r**18+25771890*r**20+4535762*r**22+903954*r**24+80861*r**26
            +5416*r**28)-9*(-2450-38647*r**2-595954*r**4-547177*r**6-6253326*r**8
            -8391111*r**10+5816234*r**12+11008023*r**14-17007406*r**16-24446733*r**18
            +14639362*r**20+21900813*r**22+3360206*r**24+513483*r**26+43334*r**28
            +1349*r**30))*sqrtq2)+logq2**2*(-2880*r**10*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-104480*Q2**17+8*Q2**16*(150101+135817*r**2)-8*Q2**15*(709791
            +1424108*r**2+609837*r**4)+8*Q2**14*(1670155+6164498*r**2+5665821*r**4
            +1497790*r**6)-8*Q2**13*(1570775+13279952*r**2+19627106*r**4+11807174*r**6
            +2052205*r**8)+Q2**12*(-10951320+87823939*r**2+170092020*r**4+162375498*r**6
            +97625268*r**8+9276675*r**10)+4*Q2**11*(9892734+24693229*r**2+97819623*r**4
            +176570458*r**6+72594868*r**8-2378739*r**10+1841403*r**12)-2*Q2**10*(14469828
            +157336027*r**2+716700482*r**4+1881190105*r**6+1698206280*r**8+514798421*r**10
            +50180850*r**12+9261111*r**14)+4*Q2**9*(-4846770+63361633*r**2+350439261*r**4
            +1673827605*r**6+2375510525*r**8+1352556375*r**10+271078323*r**12+32232891*r**14
            +3352365*r**16)+Q2**8*(42913400+92962057*r**2+691377336*r**4-3114119876*r**6
            -7327078400*r**8-6371797290*r**10-2654978408*r**12-290389124*r**14-88671816*r**16
            +2729705*r**18)-8*Q2**7*(1878665+40114391*r**2+317972780*r**4+853863832*r**6
            +1861043472*r**8+2719556390*r**10+1492747966*r**12+266907120*r**14+15127487*r**16
            -4971133*r**18+1747270*r**20)+4*Q2**6*(-4119774+46067315*r**2+372895044*r**4
            +2848468779*r**6+8332675944*r**8+17957269110*r**10+16113018636*r**12
            +5851481694*r**14+603032454*r**16-23073081*r**18+4677472*r**20+2456967*r**22)
            +8*Q2**5*(1935887+8467725*r**2+106568217*r**4-511036475*r**6-1198700610*r**8
            -7844229138*r**10-11704337214*r**12-6396000186*r**14-1468763325*r**16
            -7450835*r**18-13472499*r**20-8600451*r**22+229304*r**24)+Q2**4*(-1225160
            -129316891*r**2-1370532012*r**4-4735543390*r**6-29611067900*r**8-17453038725*r**10
            +25962685992*r**12+35736518844*r**14+12054143520*r**16+2269446875*r**18
            +565030660*r**20+529648674*r**22+55416868*r**24-6068155*r**26)+12*Q2**3*(
            -289850+3480307*r**2+28949801*r**4+407821914*r**6+2161639620*r**8+4346643205*r**10
            +2935005991*r**12-1521190932*r**14-4694349898*r**16-2459787075*r**18
            -449400505*r**20-148392198*r**22-26994944*r**24-109941*r**26+174505*r**28)
            +6*Q2**2*(229020+2918719*r**2+45159970*r**4-109686807*r**6+502957768*r**8
            -4526104505*r**10-1116035738*r**12+4310241465*r**14+14975348124*r**16
            +11119907829*r**18+4091115470*r**20+16192019*r**22+102589440*r**24-17811067*r**26
            -3931222*r**28+189515*r**30)-36*Q2*(518+420867*r**2+5163363*r**4+25195443*r**6
            +286607943*r**8-372775221*r**10+820620947*r**12+27232299*r**14+475970739*r**16
            +1089967489*r**18-1711459887*r**20-451164495*r**22-176564787*r**24-14409807*r**26
            -4452807*r**28-379535*r**30+26931*r**32)+9*(-5568+332527*r**2+3686336*r**4
            +36352440*r**6+329849160*r**8-686961996*r**10+3464268304*r**12+268700232*r**14
            -8182983880*r**16+4018542330*r**18+8304862496*r**20-5770391864*r**22
            -1430620872*r**24-319818060*r**26-30912240*r**28-4639432*r**30-281592*r**32
            +21679*r**34))+2880*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17
            -8*Q2**16*(150101+135817*r**2)+8*Q2**15*(709791+1424108*r**2+609837*r**4)
            -8*Q2**14*(1670155+6164498*r**2+5665821*r**4+1497790*r**6)+8*Q2**13*(1570775
            +13279952*r**2+19627106*r**4+11807174*r**6+2052205*r**8)-Q2**12*(-10951320
            +87823939*r**2+170092020*r**4+162375498*r**6+97625268*r**8+9276675*r**10)
            -4*Q2**11*(9892734+24693229*r**2+97819623*r**4+176570458*r**6+72594868*r**8
            -2378739*r**10+1841403*r**12)+2*Q2**10*(14469828+157336027*r**2+716700482*r**4
            +1881190105*r**6+1698206280*r**8+514798421*r**10+50180850*r**12+9261111*r**14)
            -4*Q2**9*(-4846770+63361633*r**2+350439261*r**4+1673827605*r**6+2375510525*r**8
            +1352556375*r**10+271078323*r**12+32232891*r**14+3352365*r**16)+Q2**8*(
            -42913400-92962057*r**2-691377336*r**4+3114119876*r**6+7327078400*r**8
            +6371797290*r**10+2654978408*r**12+290389124*r**14+88671816*r**16-2729705*r**18)
            +8*Q2**7*(1878665+40114391*r**2+317972780*r**4+853863832*r**6+1861043472*r**8
            +2719556390*r**10+1492747966*r**12+266907120*r**14+15127487*r**16-4971133*r**18
            +1747270*r**20)-4*Q2**6*(-4119774+46067315*r**2+372895044*r**4+2848468779*r**6
            +8332675944*r**8+17957269110*r**10+16113018636*r**12+5851481694*r**14
            +603032454*r**16-23073081*r**18+4677472*r**20+2456967*r**22)-8*Q2**5*(1935887
            +8467725*r**2+106568217*r**4-511036475*r**6-1198700610*r**8-7844229138*r**10
            -11704337214*r**12-6396000186*r**14-1468763325*r**16-7450835*r**18-13472499*r**20
            -8600451*r**22+229304*r**24)+Q2**4*(1225160+129316891*r**2+1370532012*r**4
            +4735543390*r**6+29611067900*r**8+17453038725*r**10-25962685992*r**12
            -35736518844*r**14-12054143520*r**16-2269446875*r**18-565030660*r**20
            -529648674*r**22-55416868*r**24+6068155*r**26)-12*Q2**3*(-289850+3480307*r**2
            +28949801*r**4+407821914*r**6+2161639620*r**8+4346643205*r**10+2935005991*r**12
            -1521190932*r**14-4694349898*r**16-2459787075*r**18-449400505*r**20-148392198*r**22
            -26994944*r**24-109941*r**26+174505*r**28)-6*Q2**2*(229020+2918719*r**2
            +45159970*r**4-109686807*r**6+502957768*r**8-4526104505*r**10-1116035738*r**12
            +4310241465*r**14+14975348124*r**16+11119907829*r**18+4091115470*r**20
            +16192019*r**22+102589440*r**24-17811067*r**26-3931222*r**28+189515*r**30)
            +36*Q2*(518+420867*r**2+5163363*r**4+25195443*r**6+286607943*r**8-372775221*r**10
            +820620947*r**12+27232299*r**14+475970739*r**16+1089967489*r**18-1711459887*r**20
            -451164495*r**22-176564787*r**24-14409807*r**26-4452807*r**28-379535*r**30
            +26931*r**32)-9*(-5568+332527*r**2+3686336*r**4+36352440*r**6+329849160*r**8
            -686961996*r**10+3464268304*r**12+268700232*r**14-8182983880*r**16+4018542330*r**18
            +8304862496*r**20-5770391864*r**22-1430620872*r**24-319818060*r**26-30912240*r**28
            -4639432*r**30-281592*r**32+21679*r**34))*sqrtq2)+logq2*(96*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(54928*Q2**20-10*Q2**19*(66179+80571*r**2)
            +10*Q2**18*(315743+932826*r**2+454635*r**4)-10*Q2**17*(713027+4156451*r**2
            +4810467*r**4+1276291*r**6)+10*Q2**16*(491705+8279349*r**2+16884235*r**4
            +11757431*r**6+1673240*r**8)+2*Q2**15*(5923559-13876615*r**2-57271710*r**4
            -97945590*r**6-59156055*r**8+291279*r**10)-10*Q2**14*(2857988+19669647*r**2
            +75147541*r**4+120967604*r**6+44188566*r**8+6569403*r**10+3179247*r**12)
            +5*Q2**13*(2563602+71427359*r**2+416413088*r**4+1214635191*r**6+1097862886*r**8
            +332390965*r**10+60642984*r**12+6433205*r**14)+5*Q2**12*(5847972-19839849*r**2
            -287234445*r**4-2048826147*r**6-3137405283*r**8-1861102247*r**10-397686891*r**12
            -57953133*r**14+2841111*r**16)-10*Q2**11*(4072315+38356662*r**2+224264136*r**4
            -228097682*r**6-915369848*r**8-907956088*r**10-505111764*r**12-54829074*r**14
            -926967*r**16+4707430*r**18)+4*Q2**10*(307307+110393910*r**2+1170745425*r**4
            +4434888910*r**6+10006163165*r**8+15640213853*r**10+7814017520*r**12
            +1470662320*r**14+319685970*r**16+57863495*r**18+4510077*r**20)+5*Q2**9*(6524726
            +1654389*r**2-332977536*r**4-5253633789*r**6-16668936056*r**8-42558233486*r**10
            -38209590004*r**12-12439153626*r**14-2195790494*r**16-368681911*r**18
            -46755564*r**20+5179239*r**22)-5*Q2**8*(3840512+64911899*r**2+635093811*r**4
            -1309794993*r**6-4893941093*r**8-44191072906*r**10-64772250554*r**12
            -34209666554*r**14-6195004898*r**16-1286268433*r**18-197781337*r**20
            -9929301*r**22+4790695*r**24)-10*Q2**7*(878591-18460977*r**2-352827146*r**4
            -1980677810*r**6-9160838453*r**8-8905623285*r**10-7245547460*r**12-10083900548*r**14
            -4237010291*r**16-1165420083*r**18+269462462*r**20-41127194*r**22-13654759*r**24
            +418313*r**26)+10*Q2**6*(1259540+5803877*r**2-23532033*r**4-2109246552*r**6
            -9544382366*r**8-39759741061*r**10-79333297209*r**12-119098406816*r**14
            -69660249688*r**16-13983361421*r**18-381884731*r**20+264511880*r**22
            -105316878*r**24-14437827*r**26+1260165*r**28)+Q2**5*(-1429522-97736715*r**2
            -1617715640*r**4+2098864585*r**6-12171448290*r**8+280893888657*r**10
            +536428413960*r**12+1691496856965*r**14+1549238069610*r**16+526380826495*r**18
            +33108765192*r**20-5161804645*r**22+1307981450*r**24+484828155*r**26
            +10974120*r**28-2662377*r**30)-5*Q2**4*(677892-4948297*r**2-184875493*r**4
            -1835799047*r**6-12492555863*r**8-16769631217*r**10-130117787973*r**12
            +74508298201*r**14+214049147049*r**16+70032535581*r**18+9559984153*r**20
            -2592019133*r**22+2902206467*r**24+1216863773*r**26-43586543*r**28-12728853*r**30
            +616103*r**32)+30*Q2**3*(45654+417273*r**2+1417388*r**4-178221314*r**6
            -723747334*r**8-7139162596*r**10-26796182328*r**12-21945512406*r**14
            +1342738458*r**16+13720059258*r**18+16969717740*r**20+4420500082*r**22
            +1463384198*r**24+558599956*r**26+119452576*r**28-8390298*r**30-1005552*r**32
            +49245*r**34)+30*Q2**2*(9169-294388*r**2-7241173*r**4-11605536*r**6
            -384866858*r**8+2461427062*r**10-2492912204*r**12+21798649780*r**14-6278370596*r**16
            -25153597574*r**18-44294454506*r**20-30409099688*r**22-2275208286*r**24
            -1149771430*r**26-28432468*r**28+45300500*r**30+897755*r**32-277846*r**34
            +8287*r**36)-45*Q2*(6040-39833*r**2-1765902*r**4-25702367*r**6-191633484*r**8
            -669629844*r**10-6819671780*r**12+18100809572*r**14-23382970028*r**16
            -6747069582*r**18-9857533632*r**20+19868199534*r**22+4639058012*r**24
            +4640825532*r**26+322380516*r**28+82312436*r**30+43411204*r**32-781057*r**34
            -211762*r**36+6425*r**38)+9*(5222-10355*r**2-1056335*r**4-31511255*r**6
            -153685765*r**8-2010898828*r**10-6861747660*r**12+35126704580*r**14-161489742960*r**16
            +164166435670*r**18+133768147902*r**20-304538439490*r**22+98584777970*r**24
            +29670853060*r**26+12154764580*r**28+1458374292*r**30+101088130*r**32
            +57261285*r**34-1105095*r**36-220735*r**38+5787*r**40))-96*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(54928*Q2**21-2*Q2**20*(358359+430319*r**2)
            +20*Q2**19*(190961+539788*r**2+267603*r**4)-20*Q2**18*(514385+2702510*r**2
            +3098964*r**4+865463*r**6)+10*Q2**17*(1204732+13148827*r**2+25851153*r**4
            +17844189*r**6+2949531*r**8)-2*Q2**16*(-3465034+57731885*r**2+183089630*r**4
            +241153920*r**6+126309410*r**8+8074921*r**10)-2*Q2**15*(20213499+90395179*r**2
            +304589380*r**4+449620720*r**6+63841185*r**8-26017761*r**10+16187514*r**12)
            +5*Q2**14*(8279578+116482629*r**2+606047464*r**4+1606865481*r**6+1428175226*r**8
            +433906903*r**10+80140284*r**12+12791699*r**14)-10*Q2**13*(-1642185+46915405*r**2
            +387537446*r**4+1839937213*r**6+2724951680*r**8+1645678049*r**10+395360420*r**12
            +62514661*r**14+1796047*r**16)-5*Q2**12*(13992602+62721447*r**2+141453978*r**4
            -2792255956*r**6-7016971126*r**8-6814419706*r**10-3269012666*r**12-565298172*r**14
            -56965956*r**16+12255971*r**18)+2*Q2**11*(20976189+432932705*r**2+3654594840*r**4
            +8850610090*r**6+14294988680*r**8+22163798026*r**10+8562695780*r**12
            +141620450*r**14+360591735*r**16+134629305*r**18+32557304*r**20)+Q2**10*(31394402
            -434532923*r**2-6789445020*r**4-48690706285*r**6-141108888580*r**8-315376675502*r**10
            -284864875512*r**12-99334487490*r**14-18140345630*r**16-3353607415*r**18
            -483272108*r**20+7855887*r**22)-10*Q2**9*(5182619+36545507*r**2+151885332*r**4
            -3448203159*r**6-13408255469*r**8-51709121224*r**10-72770037022*r**12
            -42429205092*r**14-10414974509*r**16-1925370419*r**18-306609406*r**20
            -25752813*r**22+4984967*r**24)+5*Q2**8*(2083330+105674365*r**2+1405660002*r**4
            +3286654438*r**6+12117940820*r**8-31273767429*r**10-94472228540*r**12
            -78814116012*r**14-31930650870*r**16-5150433165*r**18-2022974694*r**20
            -125456250*r**22+22170912*r**24+3954069*r**26)+10*Q2**7*(2138131-11778509*r**2
            -394820156*r**4-4442751508*r**6-20685898629*r**8-57826202799*r**10-95484467954*r**12
            -136427854824*r**14-83981160527*r**16-19385791795*r**18-1277842352*r**20
            +492847148*r**22-160098831*r**24-27674273*r**26+1678478*r**28)+Q2**6*(
            -14024922-168370885*r**2-1440434080*r**4+23426650435*r**6+104364840890*r**8
            +773935122927*r**10+1727358796660*r**12+3675813897215*r**14+3436824634650*r**16
            +1362816937585*r**18+176761226712*r**20-3988076135*r**22-283968570*r**24
            +1682375205*r**26+142750740*r**28-15264027*r**30)-2*Q2**5*(979969-61953861*r**2
            -1319914910*r**4-4348923145*r**6-36267681510*r**8+92437142141*r**10+83366681376*r**12
            +1300233380965*r**14+2155490330910*r**16+1212890787005*r**18+303644756226*r**20
            +7493432441*r**22+5328604570*r**24+3938564235*r**26+138934780*r**28-27666261*r**30
            +209069*r**32)+5*Q2**4*(951816-1766767*r**2-181319462*r**4-3090002424*r**6
            -18670838914*r**8-72097162656*r**10-307664513158*r**12-187282564208*r**14
            +296613875998*r**16+366402038178*r**18+181410826174*r**20+33490965512*r**22
            +9090492522*r**24+7470669976*r**26+1889992686*r**28-106657184*r**30-18146062*r**32
            +911573*r**34)-30*Q2**3*(36485+757315*r**2+9075834*r**4-165198390*r**6
            -517101790*r**8-10324336992*r**10-31442432720*r**12-70540344514*r**14
            -14324403352*r**16+40216395290*r**18+74984231504*r**20+51799317510*r**22
            +8159092566*r**24+3171755584*r**26+706485000*r**28+65761778*r**30-10293605*r**32
            -678461*r**34+40958*r**36)-15*Q2**2*(36458-689937*r**2-20368828*r**4
            -114800519*r**6-1367845240*r**8+2144230876*r**10-20521985624*r**12+92913903868*r**14
            -39108351716*r**16-83105145086*r**18-168468705056*r**20-89802509786*r**22
            -51451441912*r**24+7072517164*r**26-1389266248*r**28+280673372*r**30
            +222630122*r**32-1103353*r**34-1174404*r**36+35849*r**38)+18*Q2*(17711
            -89660*r**2-5042505*r**4-84426300*r**6-620182510*r**8-3158607734*r**10
            -22154127890*r**12+45766196770*r**14-93950272620*r**16+6758118810*r**18
            +25372565916*r**20-127242554990*r**22+110560532850*r**24+38035135390*r**26
            +18485397410*r**28+1740919526*r**30+364853165*r**32+135206010*r**34-3034595*r**36
            -623710*r**38+18956*r**40)-9*(5222-5133*r**2-1066690*r**4-32567590*r**6
            -185197020*r**8-2164584593*r**10-8872646488*r**12+28264956920*r**14-126363038380*r**16
            +2676692710*r**18+297934583572*r**20-170770291588*r**22-205953661520*r**24
            +128255631030*r**26+41825617640*r**28+13613138872*r**30+1559462422*r**32
            +158349415*r**34+56156190*r**36-1325830*r**38-214948*r**40+5787*r**42))*sqrtq2))*math.log(mus))/(
            -4200*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))
            -4200*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2+logq2**6*(188116992000*r**26*(1
            +r**2)*(-1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -188116992000*r**26*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**3*(145152000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))+145152000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))*sqrtq2)+logq2*(504000*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)
            -Q2**2*(5+2*r**2+5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))+504000*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)-Q2**2*(5+2*r**2
            +5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))*sqrtq2)+logq2**2*(-3024000*(
            -Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(16*Q2**4+Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1
            +9*r**2+9*r**4+r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))-3024000*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(16*Q2**4
            +Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1+9*r**2+9*r**4
            +r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))*sqrtq2)+logq2**4*(-435456000*(
            -Q2+(-1+r)**2)*r**18*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))
            -435456000*(-Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))*sqrtq2)
            +logq2**5*(2090188800*(-Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2
            +41*r**4)-18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4
            -82*r**6+13*r**8))+2090188800*(-Q2+(-1+r)**2)*r**22*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2+41*r**4)
            -18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4-82*r**6
            +13*r**8))*sqrtq2)))+((-16*(Q2-(-1+r)**2)**6*r**6*(1-Q2+r**2)*(Q2
            -(1+r)**2)**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(-47012*Q2**23
            +24*Q2**22*(4599+439*r**2)+8*Q2**21*(-383250-1104200*r**2+676617*r**4)
            +Q2**20*(46146877+797334375*r**2+141699991*r**4-48140867*r**6)+2*Q2**19*(
            -135294915-4450587916*r**2-5864590394*r**4-512175708*r**6+106100745*r**8)
            +Q2**18*(822157098+43203965414*r**2+118198444348*r**4+71804343284*r**6
            +4183646650*r**8-572573562*r**10)+2*Q2**17*(-650527017-53000194882*r**2
            -253275666397*r**4-308752783308*r**6-118414699919*r**8-5221737434*r**10
            +496960293*r**12)+3*Q2**16*(166813395+32724710397*r**2+343849239747*r**4
            +668519685381*r**6+541675288149*r**8+147200388075*r**10+5255988389*r**12
            -357014173*r**14)+8*Q2**15*(250151874+18423297809*r**2-61076378955*r**4
            -216948218238*r**6-338418699790*r**8-266860217787*r**10-48708285471*r**12
            -1522415452*r**14+74095626*r**16)-8*Q2**14*(469018795+65434313568*r**2
            +279775756322*r**4+726904889127*r**6+1057356399780*r**8+294685748105*r**10
            -81389566524*r**12+13708636287*r**14-58846501*r**16+7968865*r**18)+8*Q2**13*(192739491
            +59320229371*r**2+609118281302*r**4+2091470084973*r**6+5007746412889*r**8
            +4277711892503*r**10+1409321673963*r**12+261500413339*r**14+77002887116*r**16
            +366089670*r**18+26266551*r**20)-2*Q2**12*(-1591071573-141517567243*r**2
            +1331056762709*r**4+4881279761143*r**6+26026449601174*r**8+32668701024674*r**10
            +20244947156026*r**12+6486495644086*r**14+1806871494503*r**16+222314730913*r**18
            -6072633879*r**20+421587387*r**22)+4*Q2**11*(-1179232145-245000657122*r**2
            -986509462496*r**4-5364384224132*r**6-3518934494667*r**8-5638319819980*r**10
            -7002103618512*r**12+1241220129336*r**14+2068717513889*r**16+898294878190*r**18
            -59696866880*r**20-6669446004*r**22+242946379*r**24)-4*Q2**10*(-256763703
            -159792727211*r**2-1816058232106*r**4-9504428664360*r**6-27473980085453*r**8
            -50919274965295*r**10-79489837379184*r**12-42425925537068*r**14-4695098710237*r**16
            +2221986555243*r**18+698093502202*r**20-131295565036*r**22-4083579903*r**24
            +68586543*r**26)-4*Q2**9*(-768653865-95122561396*r**2+759794601721*r**4
            +1798054770230*r**6+26372434905485*r**8+37655366843470*r**10+132340647989579*r**12
            +110360573447444*r**14+41599024828681*r**16+1086708482960*r**18-2241964595545*r**20
            -16461355178*r**22+35471027411*r**24-2146522058*r**26+105877845*r**28)
            +2*Q2**8*(-1525407051-407817900089*r**2-1476379836863*r**4-16868823903585*r**6
            -1464200852907*r**8-116071901092121*r**10+136951116102993*r**12+180777493516047*r**14
            +131237483339743*r**16+55136778575253*r**18+158915800419*r**20+572374173085*r**22
            +1775331093591*r**24-123868005379*r**26-8722524085*r**28+210878709*r**30)
            -4*Q2**7*(-90650889-84496974294*r**2-1005855223542*r**4-7555336999380*r**6
            -20598955188920*r**8-102895449438610*r**10-36158982004674*r**12+11974861693120*r**14
            +57007365989474*r**16+73839576898278*r**18+31672840949734*r**20+2775437439836*r**22
            +2375133048936*r**24+890256342210*r**26-50501599854*r**28-1282021896*r**30
            +3572151*r**32)-8*Q2**6*(-153024060-27888957241*r**2+163456306578*r**4
            -500155626819*r**6+8958479689750*r**8+4687381455155*r**10+55261249147708*r**12
            -32906403916793*r**14-21698671296988*r**16-62926279425017*r**18-42189877017590*r**20
            -9578036982445*r**22-1266089247458*r**24-1023271609003*r**26+18481463592*r**28
            -1363455255*r**30-878479132*r**32+25109418*r**34)+8*Q2**5*(-109885951
            -35997014763*r**2-84726125449*r**4-2460711017925*r**6+3076990974097*r**8
            -46453253774849*r**10+102886500988113*r**12-147929662507269*r**14+65483477123347*r**16
            -69592445387815*r**18-11570549147817*r**20-14662588217207*r**22+4675722132243*r**24
            -1227857017363*r**26-695747394637*r**28+303716198337*r**30-9831093048*r**32
            -853200730*r**34+15850286*r**36)+Q2**4*(105294105+83347545667*r**2+736698497123*r**4
            +9199711354977*r**6+8830091487540*r**8+284367702503820*r**10-810744753721956*r**12
            +1777236101900612*r**14-1837212612019538*r**16+614336098158570*r**18+616348172503610*r**20
            -174521642240114*r**22+60715675963812*r**24-55374738244740*r**26+11622718452780*r**28
            +3240724232340*r**30-1415901644447*r**32+34351334603*r**34+1314993051*r**36
            -6799815*r**38)-2*Q2**3*(-82464669-18369703648*r**2+119571373894*r**4
            -1136201850676*r**6+9835853312299*r**8-16147372983840*r**10+82470240360*r**12
            +215041512147808*r**14-639739730572666*r**16+682223888967232*r**18-87886808853372*r**20
            +466155453362744*r**22+4622025397102*r**24+24946727059040*r**26-4763594290776*r**28
            +2482292431680*r**30-567349814281*r**32+55657062496*r**34+239768102*r**36
            -653404580*r**38+14447751*r**40)+3*(-1+r**2)**2*(-833441-400643161*r**2
            -1202972442*r**4-61289069146*r**6+131984066219*r**8-3471034023405*r**10
            +24584585153512*r**12-130150345479224*r**14+413627994425118*r**16-748778208413682*r**18
            +681442118912996*r**20-259189955116860*r**22+52707419796974*r**24-31306515038498*r**26
            -8435132799768*r**28-876944512888*r**30-163224011197*r**32-100029858933*r**34
            +7313959526*r**36-30366394*r**38-9538137*r**40+122831*r**42)+2*Q2**2*(
            -51037147-17738481217*r**2+8328013022*r**4-1848705509434*r**6+7134865173553*r**8
            -70008038687537*r**10+310336938498720*r**12-886070863463264*r**14+1260496854769474*r**16
            -654958411038682*r**18+175210343485740*r**20-153332912311236*r**22-97428170315038*r**24
            -69247686566146*r**26-46098589363120*r**28+1740604185744*r**30-235058181895*r**32
            -1631303327845*r**34+211363961606*r**36-1680696626*r**38-487586675*r**40
            +8078003*r**42)-6*Q2*(-4248965-1777814974*r**2-1191490301*r**4-226461647368*r**6
            +861601431509*r**8-11517454193610*r**10+72655250640085*r**12-309611407629456*r**14
            +790453438728494*r**16-1088205299825052*r**18+659116732086110*r**20-66929222937376*r**22
            -5967831150166*r**24-16990421806084*r**26-26556320492598*r**28-16336845341680*r**30
            -481478920857*r**32-49236549446*r**34-305561254417*r**36+27855343016*r**38
            -130611855*r**40-45439378*r**42+644369*r**44))+16*r**6*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(47012*Q2**23
            -24*Q2**22*(4599+439*r**2)+Q2**21*(3066000+8833600*r**2-5412936*r**4)
            +Q2**20*(-46146877-797334375*r**2-141699991*r**4+48140867*r**6)+Q2**19*(270589830
            +8901175832*r**2+11729180788*r**4+1024351416*r**6-212201490*r**8)+2*Q2**18*(
            -411078549-21601982707*r**2-59099222174*r**4-35902171642*r**6-2091823325*r**8
            +286286781*r**10)+2*Q2**17*(650527017+53000194882*r**2+253275666397*r**4
            +308752783308*r**6+118414699919*r**8+5221737434*r**10-496960293*r**12)
            +3*Q2**16*(-166813395-32724710397*r**2-343849239747*r**4-668519685381*r**6
            -541675288149*r**8-147200388075*r**10-5255988389*r**12+357014173*r**14)
            -8*Q2**15*(250151874+18423297809*r**2-61076378955*r**4-216948218238*r**6
            -338418699790*r**8-266860217787*r**10-48708285471*r**12-1522415452*r**14
            +74095626*r**16)+8*Q2**14*(469018795+65434313568*r**2+279775756322*r**4
            +726904889127*r**6+1057356399780*r**8+294685748105*r**10-81389566524*r**12
            +13708636287*r**14-58846501*r**16+7968865*r**18)-8*Q2**13*(192739491
            +59320229371*r**2+609118281302*r**4+2091470084973*r**6+5007746412889*r**8
            +4277711892503*r**10+1409321673963*r**12+261500413339*r**14+77002887116*r**16
            +366089670*r**18+26266551*r**20)+2*Q2**12*(-1591071573-141517567243*r**2
            +1331056762709*r**4+4881279761143*r**6+26026449601174*r**8+32668701024674*r**10
            +20244947156026*r**12+6486495644086*r**14+1806871494503*r**16+222314730913*r**18
            -6072633879*r**20+421587387*r**22)-4*Q2**11*(-1179232145-245000657122*r**2
            -986509462496*r**4-5364384224132*r**6-3518934494667*r**8-5638319819980*r**10
            -7002103618512*r**12+1241220129336*r**14+2068717513889*r**16+898294878190*r**18
            -59696866880*r**20-6669446004*r**22+242946379*r**24)+4*Q2**10*(-256763703
            -159792727211*r**2-1816058232106*r**4-9504428664360*r**6-27473980085453*r**8
            -50919274965295*r**10-79489837379184*r**12-42425925537068*r**14-4695098710237*r**16
            +2221986555243*r**18+698093502202*r**20-131295565036*r**22-4083579903*r**24
            +68586543*r**26)+4*Q2**9*(-768653865-95122561396*r**2+759794601721*r**4
            +1798054770230*r**6+26372434905485*r**8+37655366843470*r**10+132340647989579*r**12
            +110360573447444*r**14+41599024828681*r**16+1086708482960*r**18-2241964595545*r**20
            -16461355178*r**22+35471027411*r**24-2146522058*r**26+105877845*r**28)
            -2*Q2**8*(-1525407051-407817900089*r**2-1476379836863*r**4-16868823903585*r**6
            -1464200852907*r**8-116071901092121*r**10+136951116102993*r**12+180777493516047*r**14
            +131237483339743*r**16+55136778575253*r**18+158915800419*r**20+572374173085*r**22
            +1775331093591*r**24-123868005379*r**26-8722524085*r**28+210878709*r**30)
            +4*Q2**7*(-90650889-84496974294*r**2-1005855223542*r**4-7555336999380*r**6
            -20598955188920*r**8-102895449438610*r**10-36158982004674*r**12+11974861693120*r**14
            +57007365989474*r**16+73839576898278*r**18+31672840949734*r**20+2775437439836*r**22
            +2375133048936*r**24+890256342210*r**26-50501599854*r**28-1282021896*r**30
            +3572151*r**32)+8*Q2**6*(-153024060-27888957241*r**2+163456306578*r**4
            -500155626819*r**6+8958479689750*r**8+4687381455155*r**10+55261249147708*r**12
            -32906403916793*r**14-21698671296988*r**16-62926279425017*r**18-42189877017590*r**20
            -9578036982445*r**22-1266089247458*r**24-1023271609003*r**26+18481463592*r**28
            -1363455255*r**30-878479132*r**32+25109418*r**34)-8*Q2**5*(-109885951
            -35997014763*r**2-84726125449*r**4-2460711017925*r**6+3076990974097*r**8
            -46453253774849*r**10+102886500988113*r**12-147929662507269*r**14+65483477123347*r**16
            -69592445387815*r**18-11570549147817*r**20-14662588217207*r**22+4675722132243*r**24
            -1227857017363*r**26-695747394637*r**28+303716198337*r**30-9831093048*r**32
            -853200730*r**34+15850286*r**36)+Q2**4*(-105294105-83347545667*r**2-736698497123*r**4
            -9199711354977*r**6-8830091487540*r**8-284367702503820*r**10+810744753721956*r**12
            -1777236101900612*r**14+1837212612019538*r**16-614336098158570*r**18-616348172503610*r**20
            +174521642240114*r**22-60715675963812*r**24+55374738244740*r**26-11622718452780*r**28
            -3240724232340*r**30+1415901644447*r**32-34351334603*r**34-1314993051*r**36
            +6799815*r**38)+2*Q2**3*(-82464669-18369703648*r**2+119571373894*r**4
            -1136201850676*r**6+9835853312299*r**8-16147372983840*r**10+82470240360*r**12
            +215041512147808*r**14-639739730572666*r**16+682223888967232*r**18-87886808853372*r**20
            +466155453362744*r**22+4622025397102*r**24+24946727059040*r**26-4763594290776*r**28
            +2482292431680*r**30-567349814281*r**32+55657062496*r**34+239768102*r**36
            -653404580*r**38+14447751*r**40)-3*(-1+r**2)**2*(-833441-400643161*r**2
            -1202972442*r**4-61289069146*r**6+131984066219*r**8-3471034023405*r**10
            +24584585153512*r**12-130150345479224*r**14+413627994425118*r**16-748778208413682*r**18
            +681442118912996*r**20-259189955116860*r**22+52707419796974*r**24-31306515038498*r**26
            -8435132799768*r**28-876944512888*r**30-163224011197*r**32-100029858933*r**34
            +7313959526*r**36-30366394*r**38-9538137*r**40+122831*r**42)-2*Q2**2*(
            -51037147-17738481217*r**2+8328013022*r**4-1848705509434*r**6+7134865173553*r**8
            -70008038687537*r**10+310336938498720*r**12-886070863463264*r**14+1260496854769474*r**16
            -654958411038682*r**18+175210343485740*r**20-153332912311236*r**22-97428170315038*r**24
            -69247686566146*r**26-46098589363120*r**28+1740604185744*r**30-235058181895*r**32
            -1631303327845*r**34+211363961606*r**36-1680696626*r**38-487586675*r**40
            +8078003*r**42)+6*Q2*(-4248965-1777814974*r**2-1191490301*r**4-226461647368*r**6
            +861601431509*r**8-11517454193610*r**10+72655250640085*r**12-309611407629456*r**14
            +790453438728494*r**16-1088205299825052*r**18+659116732086110*r**20-66929222937376*r**22
            -5967831150166*r**24-16990421806084*r**26-26556320492598*r**28-16336845341680*r**30
            -481478920857*r**32-49236549446*r**34-305561254417*r**36+27855343016*r**38
            -130611855*r**40-45439378*r**42+644369*r**44))*sqrtq2+logq2**8*(20316635136000000*r**38*(1
            +r**2)**2*(1-Q2+r**2)*(511-3515*r**2+2685*r**4+1087*r**6)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3+20316635136000000*(Q2-(-1+r)**2)**2*r**38*(1
            +r**2)**2*(511-3515*r**2+2685*r**4+1087*r**6)*(Q2-(1+r)**2)**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**7*(32248627200000*r**32*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(4550*Q2**9*(1+r**2)+50*Q2**8*(
            -871-200*r**2+671*r**4)-100*Q2**7*(-1755+994*r**2+3130*r**4+381*r**6)
            -2*Q2**6*(192920-254145*r**2-650493*r**4+474529*r**6+520485*r**8)+2*Q2**5*(240695
            -617915*r**2-695828*r**4+2335016*r**6+3833439*r**8+1661205*r**10)-Q2**4*(273000
            -1752295*r**2+564405*r**4+11887102*r**6+16223354*r**8+9998245*r**10
            +2442405*r**12)+Q2**3*(-91000-1186235*r**2+1549760*r**4+7593273*r**6
            +15084184*r**8+12570571*r**10-1893680*r**12-4328345*r**14)+6*(-1+r**2)**2*(5785
            -7140*r**2+414226*r**4-690192*r**6-2277022*r**8+1440328*r**10+1540358*r**12
            +532012*r**14+331885*r**16)+Q2**2*(254800+35195*r**2+2091605*r**4-1636937*r**6
            -12557095*r**8+4596221*r**10+5323171*r**12+12043985*r**14+9847775*r**16)
            -3*Q2*(52520-114465*r**2+1833302*r**4-1805562*r**6-13352118*r**8-963308*r**10
            +14626322*r**12+5594370*r**14+2000934*r**16+2449925*r**18))-32248627200000*r**32*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(4550*Q2**10*(1+r**2)+100*Q2**9*(
            -481-191*r**2+290*r**4)-50*Q2**8*(-4381+917*r**2+6731*r**4+1433*r**6)
            -2*Q2**7*(280670-216095*r**2-856693*r**4+298979*r**6+501435*r**8)+14*Q2**6*(61945
            -97020*r**2-228638*r**4+308436*r**6+689779*r**8+311670*r**10)-Q2**5*(754390
            -2506735*r**2-2063081*r**4+15165478*r**6+28560264*r**8+20987533*r**10
            +5764815*r**12)-10*Q2**4*(-18200+266553*r**2-36187*r**4-2004478*r**6
            -4319464*r**8-3879217*r**10-1054697*r**12+188594*r**14)+2*Q2**3*(172900
            +656215*r**2+864040*r**4-5389985*r**6-17617276*r**8-11529267*r**10-2676860*r**12
            +9133005*r**14+7088060*r**16)-6*(-1+r**2)**2*(5785-1355*r**2+407086*r**4
            -275966*r**6-2967214*r**8-836694*r**10+2980686*r**12+2072370*r**14+863897*r**16
            +331885*r**18)-2*Q2**2*(206180-26700*r**2+3813353*r**4-2481009*r**6
            -27125193*r**8-5425399*r**10+26899179*r**12+17075133*r**14+13947281*r**16
            +8598775*r**18)+3*Q2*(64090-99365*r**2+2587419*r**4-3023828*r**6-16122504*r**8
            -3707066*r**10+6428374*r**12+18003940*r**14+9211742*r**16+4187343*r**18
            +3113695*r**20))*sqrtq2)+logq2**6*(179159040000*r**28*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-72800*Q2**13*(1+r**2)+60*Q2**12*(79037
            +137514*r**2+58477*r**4)-30*Q2**11*(1535408+3577759*r**2+2764334*r**4
            +721983*r**6)+4*Q2**10*(50893164+147061309*r**2+150661243*r**4+64369551*r**6
            +9561509*r**8)+60*Q2**9*(-8245398-28485450*r**2-35383588*r**4-16992343*r**6
            -863004*r**8+985803*r**10)-30*Q2**8*(-21557382-91416993*r**2-133053557*r**4
            -60870110*r**6+30885806*r**8+39476035*r**10+10914065*r**12)+5*Q2**7*(
            -48302772-398143609*r**2-751692658*r**4-282245519*r**6+636308848*r**8
            +869211557*r**10+450688014*r**12+98179003*r**14)-30*Q2**6*(19201560+21790181*r**2
            -26554150*r**4-38225911*r**6+93012462*r**8+236977951*r**10+174872390*r**12
            +51892883*r**14+9383290*r**16)+3*Q2**5*(321726636+822940691*r**2+434459892*r**4
            -1002934806*r**6-261867024*r**8+3603949176*r**10+5064248516*r**12+2379804542*r**14
            +228158524*r**16-17033059*r**18)+20*Q2**4*(-25628561-85266180*r**2-20198701*r**4
            +205179350*r**6-114374557*r**8-1149751150*r**10-1685694739*r**12-1172296978*r**14
            -396219970*r**16-34344938*r**18+10675736*r**20)-15*Q2**3*(9207044-12969889*r**2
            +28459094*r**4+114144763*r**6-291953732*r**8-1323734930*r**10-2290356824*r**12
            -1731601946*r**14-151236704*r**16+265755635*r**18+27076130*r**20+19601375*r**22)
            +18*(-1+r**2)**2*(1511202+1540191*r**2-7857781*r**4+42791365*r**6+108831073*r**8
            -247346438*r**10-470719578*r**12+50574174*r**14+381821340*r**16+416682407*r**18
            +234930191*r**20+26865117*r**22+2277537*r**24)+30*Q2**2*(10588088+6747461*r**2
            -11335866*r**4+8975267*r**6+82724876*r**8-54586294*r**10-287738500*r**12
            -196011634*r**14+268615256*r**16+868198593*r**18+584084382*r**20+64209023*r**22
            +10281348*r**24)-45*Q2*(3465868+263125*r**2-13494796*r**4+35810712*r**6
            +131955632*r**8-263029839*r**10-681670504*r**12+35360080*r**14+581340156*r**16
            +315019999*r**18+377199732*r**20+306119320*r**22+34724552*r**24+3977243*r**26))
            -179159040000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(72800*Q2**13*(1
            +r**2)-60*Q2**12*(79037+137514*r**2+58477*r**4)+30*Q2**11*(1535408+3577759*r**2
            +2764334*r**4+721983*r**6)-4*Q2**10*(50893164+147061309*r**2+150661243*r**4
            +64369551*r**6+9561509*r**8)-60*Q2**9*(-8245398-28485450*r**2-35383588*r**4
            -16992343*r**6-863004*r**8+985803*r**10)+30*Q2**8*(-21557382-91416993*r**2
            -133053557*r**4-60870110*r**6+30885806*r**8+39476035*r**10+10914065*r**12)
            -5*Q2**7*(-48302772-398143609*r**2-751692658*r**4-282245519*r**6+636308848*r**8
            +869211557*r**10+450688014*r**12+98179003*r**14)+30*Q2**6*(19201560+21790181*r**2
            -26554150*r**4-38225911*r**6+93012462*r**8+236977951*r**10+174872390*r**12
            +51892883*r**14+9383290*r**16)+3*Q2**5*(-321726636-822940691*r**2-434459892*r**4
            +1002934806*r**6+261867024*r**8-3603949176*r**10-5064248516*r**12-2379804542*r**14
            -228158524*r**16+17033059*r**18)-20*Q2**4*(-25628561-85266180*r**2-20198701*r**4
            +205179350*r**6-114374557*r**8-1149751150*r**10-1685694739*r**12-1172296978*r**14
            -396219970*r**16-34344938*r**18+10675736*r**20)+15*Q2**3*(9207044-12969889*r**2
            +28459094*r**4+114144763*r**6-291953732*r**8-1323734930*r**10-2290356824*r**12
            -1731601946*r**14-151236704*r**16+265755635*r**18+27076130*r**20+19601375*r**22)
            -18*(-1+r**2)**2*(1511202+1540191*r**2-7857781*r**4+42791365*r**6+108831073*r**8
            -247346438*r**10-470719578*r**12+50574174*r**14+381821340*r**16+416682407*r**18
            +234930191*r**20+26865117*r**22+2277537*r**24)-30*Q2**2*(10588088+6747461*r**2
            -11335866*r**4+8975267*r**6+82724876*r**8-54586294*r**10-287738500*r**12
            -196011634*r**14+268615256*r**16+868198593*r**18+584084382*r**20+64209023*r**22
            +10281348*r**24)+45*Q2*(3465868+263125*r**2-13494796*r**4+35810712*r**6
            +131955632*r**8-263029839*r**10-681670504*r**12+35360080*r**14+581340156*r**16
            +315019999*r**18+377199732*r**20+306119320*r**22+34724552*r**24+3977243*r**26))*sqrtq2)
            +logq2**5*(995328000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(291200*Q2**17
            -160*Q2**16*(418777+387937*r**2)+10*Q2**15*(90380873+144159746*r**2+56301113*r**4)
            -2*Q2**14*(2748841215+6448037533*r**2+4792150365*r**4+1098116031*r**6)
            +2*Q2**13*(9553908195+30744180692*r**2+34983504632*r**4+16198785024*r**6
            +2423414649*r**8)-2*Q2**12*(19802052495+86502858448*r**2+137264616952*r**4
            +100409093014*r**6+33536714649*r**8+3776131386*r**10)+4*Q2**11*(10604688510
            +70417610716*r**2+149899728774*r**4+152771001526*r**6+83201510719*r**8
            +23883240348*r**10+2932775787*r**12)-Q2**10*(-3772178310+193706746901*r**2
            +595180200296*r**4+787907596343*r**6+622785215758*r**8+320136711083*r**10
            +107485396392*r**12+20044727457*r**14)+Q2**9*(-78775320840-166694383493*r**2
            -277285428065*r**4-426199763641*r**6-144354869545*r**8+310860108965*r**10
            +309620415817*r**12+124444998585*r**14+28276191849*r**16)-2*Q2**8*(-50371704635
            -243149394191*r**2-728657962386*r**4-1378924222582*r**6-1135776684362*r**8
            +52284361650*r**10+634620228734*r**12+358342071634*r**14+82103830713*r**16
            +13846675873*r**18)+2*Q2**7*(-15272321035-193928702204*r**2-697049372521*r**4
            -1609794464672*r**6-1538442894102*r**8+474239281112*r**10+2048832439006*r**12
            +1616272988784*r**14+583500391193*r**16+87796024868*r**18+9209934947*r**20)
            -2*Q2**6*(27686696785-2206281916*r**2+79874595821*r**4-186218052276*r**6
            -591190465614*r**8+647382019962*r**10+2858319988302*r**12+2956000857126*r**14
            +1384263568509*r**16+391689518546*r**18+55463703157*r**20+3999708718*r**22)
            +6*Q2**5*(11245173665+36099849487*r**2+230210118367*r**4+379218418751*r**6
            +1202597136*r**8-273125426604*r**10+508600303236*r**12+1318055668476*r**14
            +910382747391*r**16+182874950461*r**18+8186172461*r**20+5841708389*r**22
            -52522496*r**24)+6*Q2**4*(-3617846955-26102935636*r**2-166036333380*r**4
            -281141773962*r**6+148257941725*r**8+451971066330*r**10-738458750448*r**12
            -2425678054620*r**14-2534931630441*r**16-1240962119280*r**18-208997793980*r**20
            +29376823254*r**22-771399705*r**24+969015098*r**26)-108*Q2**3*(113852645
            -320462773*r**2+470608942*r**4-759619886*r**6+5460168024*r**8+2660799685*r**10
            -52338195969*r**12-141860282704*r**14-166167739923*r**16-74902814343*r**18
            -5964584380*r**20-1054413058*r**22+2930795862*r**24+193277559*r**26+58565519*r**28)
            +54*(-1+r**2)**2*(11717055+44420321*r**2+880991953*r**4-468373237*r**6
            -1559121859*r**8+11386703487*r**10+10960037523*r**12-28565772291*r**14
            -52019384311*r**16-15261685217*r**18+61142250151*r**20+62983590181*r**22
            +13330874363*r**24+2002515073*r**26+158490101*r**28+842707*r**30)+9*Q2**2*(1514073290
            +1130156631*r**2+49627314444*r**4+7367996933*r**6-85943604702*r**8+41507380707*r**10
            +107172562148*r**12-214166497743*r**14-509639033346*r**16-56607197291*r**18
            +1284044648436*r**20+1286834833071*r**22+266209911574*r**24+59015896113*r**26
            +5041379868*r**28+359491867*r**30)-27*Q2*(178198700+258721663*r**2+8936645427*r**4
            -9043495597*r**6-20719902213*r**8+75210968819*r**10+34797817055*r**12
            -267630209449*r**14-149092194481*r**16+105092475421*r**18+8314414377*r**20
            +267114041561*r**22+372051218497*r**24+79510173553*r**26+13979384517*r**28
            +1238952829*r**30+27557321*r**32))-995328000*r**24*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(291200*Q2**18-480*Q2**17*(140199+129919*r**2)+50*Q2**16*(19416261
            +31413434*r**2+12501621*r**4)-8*Q2**15*(800186395+1905185157*r**2+1448613665*r**4
            +344905399*r**6)+60*Q2**14*(410091647+1331368648*r**2+1540789751*r**4
            +736301714*r**6+117384356*r**8)-2*Q2**13*(29355960690+126800947335*r**2
            +202992302276*r**4+151591382670*r**6+52158914322*r**8+6199546035*r**10)
            +2*Q2**12*(41011429515+247140132375*r**2+523566932948*r**4+543215713018*r**6
            +300348829101*r**8+85079326731*r**10+9641682960*r**12)-3*Q2**11*(12882191910
            +172598647935*r**2+492149852752*r**4+666196839181*r**6+522225088246*r**8
            +249491905117*r**10+71583153644*r**12+10591943535*r**14)+2*Q2**10*(-41273749575
            +11620092549*r**2+255800759566*r**4+478444016499*r**6+633168971278*r**8
            +626891017903*r**10+368621261646*r**12+125987561217*r**14+24160459653*r**16)
            -5*Q2**9*(-35903746022-146353698543*r**2-380259147266*r**4-692266727374*r**6
            -568421600382*r**8+54214792544*r**10+377944196450*r**12+230149911534*r**14
            +63385770372*r**16+11193908719*r**18)+12*Q2**8*(-10940670945-81241633505*r**2
            -278142788183*r**4-619562774940*r**6-675523966841*r**8-101542173600*r**10
            +455956171565*r**12+434872548192*r**14+170657715590*r**16+30624421909*r**18
            +3842768470*r**20)-2*Q2**7*(12414375750-211407305155*r**2-811103478904*r**4
            -2493061889469*r**6-3739427824388*r**8-416821593028*r**10+5381391708420*r**12
            +6621106284916*r**14+3584036948486*r**16+1062985934607*r**18+152469662972*r**20
            +13209643665*r**22)+4*Q2**6*(30711108890+66889981665*r**2+384149334503*r**4
            +515655899899*r**6-386900363241*r**8-381592362732*r**10+2515751458986*r**12
            +4884243925428*r**14+3535706333904*r**16+1162288969219*r**18+235855869543*r**20
            +38494268521*r**22+1921070615*r**24)+12*Q2**5*(-7431510310-36723979394*r**2
            -216173150617*r**4-445285155540*r**6-116081537081*r**8+361946947899*r**10
            -486966813540*r**12-2126167013166*r**14-2381685023154*r**16-1167109908566*r**18
            -200029458451*r**20+7674471202*r**22-3280292799*r**24+510768797*r**26)
            -30*Q2**4*(-313699869-7097822501*r**2-36733661612*r**4-92170253058*r**6
            -6920161561*r**8+129624680477*r**10-245715042312*r**12-1143524378748*r**14
            -1590325800735*r**16-1024828881579*r**18-311464486420*r**20-39720081154*r**22
            +16271949813*r**24+735322291*r**26+404638888*r**28)+9*Q2**3*(2880305030
            -1349164905*r**2+51429068472*r**4+3899865605*r**6-29537027046*r**8+138958993215*r**10
            -488956193260*r**12-2544548241819*r**14-4205975304870*r**16-2949453848483*r**18
            +313635863760*r**20+1202606863815*r**22+288726505222*r**24+96504777165*r**26
            +8063496804*r**28+1062278095*r**30)-54*(-1+r**2)**2*(11717055+56137376*r**2
            +925412274*r**4+412618716*r**6-2027495096*r**8+9827581628*r**10+22346741010*r**12
            -17605734768*r**14-80585156602*r**16-67281069528*r**18+45880564934*r**20
            +124125840332*r**22+76314464544*r**24+15333389436*r**26+2161005174*r**28
            +159332808*r**30+842707*r**32)-18*Q2**2*(1024334695+1710197455*r**2+38783703678*r**4
            +14932412293*r**6-70367657204*r**8+90598341231*r**10+126536697010*r**12
            -454942281971*r**14-585541057266*r**16-125484402187*r**18+626190347138*r**20
            +1686110803095*r**22+1334599200068*r**24+281878164173*r**26+52997714766*r**28
            +4558865111*r**30+221081915*r**32)+27*Q2*(201632810+478892785*r**2+10803103822*r**4
            -4478723814*r**6-29246164674*r**8+82564214542*r**10+83263803254*r**12
            -311030680094*r**14-384578008342*r**16+76422903168*r**18+192699362346*r**20
            +126303265262*r**22+536177148362*r**24+528210105106*r**26+112458226706*r**28
            +18591092502*r**30+1580119524*r**32+29242735*r**34))*sqrtq2)+logq2**4*(
            -16588800*r**20*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(
            -84943360*Q2**20+320*Q2**19*(5793581+4466531*r**2)-8*Q2**18*(2036790303
            +3343869794*r**2+1301410371*r**4)+2*Q2**17*(39192158216+101723885329*r**2
            +83686732170*r**4+21903544577*r**6)-8*Q2**16*(28140344069+105521208397*r**2
            +136368979857*r**4+74773620887*r**6+14821925198*r**8)+2*Q2**15*(184668087192
            +1031837574885*r**2+1887442294240*r**4+1615723587392*r**6+670669810364*r**8
            +108614077839*r**10)-3*Q2**14*(69222914400+920454182715*r**2+2323827705923*r**4
            +2776331476414*r**6+1859523867426*r**8+653492844655*r**10+93816307875*r**12)
            +Q2**13*(-444727372968+767204152371*r**2+3678084116130*r**4+5422589755129*r**6
            +6599971285340*r**8+5248129619409*r**10+1953276553746*r**12+283954412139*r**14)
            +Q2**12*(1068757380864+4016643133881*r**2+13074421330701*r**4+29583999976457*r**6
            +29772623083881*r**8+10464651061819*r**10-1417831324497*r**12-1546490722845*r**14
            -263078865477*r**16)+2*Q2**11*(-381181640992-3636529164156*r**2-16310869835418*r**4
            -47859168024867*r**6-70015463482708*r**8-50874379237149*r**10-17443656890322*r**12
            -1540893890145*r**14+607261111944*r**16+107908886981*r**18)+Q2**10*(-399883979632
            +4539144908195*r**2+25492941634401*r**4+116642222077804*r**6+239315436585612*r**8
            +246615029964378*r**10+140712356744350*r**12+45665705316764*r**14+6901473467820*r**16
            -662613160069*r**18-70410426439*r**20)-Q2**9*(-1122322817640-2263193265505*r**2
            -16943044373838*r**4+10751833726381*r**6+113101458081284*r**8+186254184337930*r**10
            +175110095135000*r**12+108131499102822*r**14+44421882931796*r**16+11212637786919*r**18
            +376392413030*r**20+132129261885*r**22)+Q2**8*(-646577551792-6373296617411*r**2
            -51738900696381*r**4-144928188000913*r**6-226342482283435*r**8-222497028634662*r**10
            -35116303759754*r**12+154616614047062*r**14+143401552124322*r**16+57373680249785*r**18
            +14173151236279*r**20+1223703557739*r**22+210926221001*r**24)-2*Q2**7*(111533621512
            -2209225271857*r**2-16982007341364*r**4-84157378927102*r**6-183713060331364*r**8
            -239581566467367*r**10-90235638056496*r**12+182978068714656*r**14+255299960557200*r**16
            +138268205928461*r**18+36666001162612*r**20+6059905605390*r**22+659867834140*r**24
            +51207024379*r**26)+Q2**6*(477680286624+190842263277*r**2+13245153435265*r**4
            -45773093310554*r**6-92364833084006*r**8-146554859541081*r**10-27802923195153*r**12
            +538562468292612*r**14+881219192354652*r**16+594287391754203*r**18+230764460054127*r**20
            +51750939562646*r**22+6403116635498*r**24+901562185937*r**26-45252862047*r**28)
            +3*Q2**5*(-65253575816-820951735425*r**2-10689535515814*r**4-18640606172595*r**6
            -73247410947396*r**8-84045234060197*r**10+22334091321230*r**12-21875598025815*r**14
            -223880837788176*r**16-230447990365507*r**18-75049630575450*r**20-10806250648265*r**22
            -4736935125156*r**24-644462818839*r**26-103939885582*r**28+29370302803*r**30)
            -3*Q2**4*(14351125120-527406133865*r**2-4863828819977*r**4-18993290215741*r**6
            -65492781554929*r**8-58136844849805*r**10+83915537070195*r**12+68096511953199*r**14
            -254016367986213*r**16-492280201082347*r**18-347952862779115*r**20-85926737945575*r**22
            +6617517864253*r**24-799359523871*r**26+49186569601*r**28+64415380725*r**30
            +13471008345*r**32)-18*Q2**3*(-3645394288+5172076506*r**2-201699791158*r**4
            +1186819571187*r**6-441657419540*r**8-967003447211*r**10-4471891666586*r**12
            +6018686528395*r**14+55714830081856*r**16+101691681027865*r**18+80596393990326*r**20
            +31550577422449*r**22+9139952507484*r**24-1945058311993*r**26-177208402150*r**28
            -92921516527*r**30-19853297944*r**32+430521329*r**34)+27*(-1+r**2)**2*(6113928
            -1056531739*r**2-11955836663*r**4-28263385576*r**6-359926074940*r**8
            +361373554236*r**10+755681955952*r**12-3058168109256*r**14-5208827008892*r**16
            +6605664146030*r**18+16744949343994*r**20-3037238454712*r**22-15971844887924*r**24
            -5240953521188*r**26-1145626740840*r**28-146369344408*r**30-11460054876*r**32
            -242220907*r**34+42657781*r**36)+9*Q2**2*(-2387998808-40427214167*r**2
            -659916959641*r**4+336991395240*r**6-10345637582576*r**8+3116495058988*r**10
            +15694270873500*r**12-7404958677128*r**14+4828997668704*r**16+42073109189302*r**18
            +30055386172898*r**20-94913016155624*r**22-140947967358096*r**24-41772589831828*r**26
            -12704767079476*r**28-1629517334328*r**30-253478984584*r**32-25181286135*r**34
            +1879303759*r**36)-27*Q2*(-73303256-6705305943*r**2-79442046826*r**4
            -10281879217*r**6-1852619920028*r**8+2914852653488*r**10+2370862154524*r**12
            -9190239620472*r**14+1158198412836*r**16+7967243063034*r**18+4474249333992*r**20
            +25709259128206*r**22-8529510321428*r**24-45297514217896*r**26-14548181397884*r**28
            -3573278090224*r**30-471646208412*r**32-49703017899*r**34-2600013598*r**36
            +272997003*r**38))+16588800*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(84943360*Q2**20
            -320*Q2**19*(5793581+4466531*r**2)+8*Q2**18*(2036790303+3343869794*r**2
            +1301410371*r**4)-2*Q2**17*(39192158216+101723885329*r**2+83686732170*r**4
            +21903544577*r**6)+8*Q2**16*(28140344069+105521208397*r**2+136368979857*r**4
            +74773620887*r**6+14821925198*r**8)-2*Q2**15*(184668087192+1031837574885*r**2
            +1887442294240*r**4+1615723587392*r**6+670669810364*r**8+108614077839*r**10)
            +3*Q2**14*(69222914400+920454182715*r**2+2323827705923*r**4+2776331476414*r**6
            +1859523867426*r**8+653492844655*r**10+93816307875*r**12)-Q2**13*(-444727372968
            +767204152371*r**2+3678084116130*r**4+5422589755129*r**6+6599971285340*r**8
            +5248129619409*r**10+1953276553746*r**12+283954412139*r**14)+Q2**12*(
            -1068757380864-4016643133881*r**2-13074421330701*r**4-29583999976457*r**6
            -29772623083881*r**8-10464651061819*r**10+1417831324497*r**12+1546490722845*r**14
            +263078865477*r**16)+2*Q2**11*(381181640992+3636529164156*r**2+16310869835418*r**4
            +47859168024867*r**6+70015463482708*r**8+50874379237149*r**10+17443656890322*r**12
            +1540893890145*r**14-607261111944*r**16-107908886981*r**18)+Q2**10*(399883979632
            -4539144908195*r**2-25492941634401*r**4-116642222077804*r**6-239315436585612*r**8
            -246615029964378*r**10-140712356744350*r**12-45665705316764*r**14-6901473467820*r**16
            +662613160069*r**18+70410426439*r**20)+Q2**9*(-1122322817640-2263193265505*r**2
            -16943044373838*r**4+10751833726381*r**6+113101458081284*r**8+186254184337930*r**10
            +175110095135000*r**12+108131499102822*r**14+44421882931796*r**16+11212637786919*r**18
            +376392413030*r**20+132129261885*r**22)+Q2**8*(646577551792+6373296617411*r**2
            +51738900696381*r**4+144928188000913*r**6+226342482283435*r**8+222497028634662*r**10
            +35116303759754*r**12-154616614047062*r**14-143401552124322*r**16-57373680249785*r**18
            -14173151236279*r**20-1223703557739*r**22-210926221001*r**24)+2*Q2**7*(111533621512
            -2209225271857*r**2-16982007341364*r**4-84157378927102*r**6-183713060331364*r**8
            -239581566467367*r**10-90235638056496*r**12+182978068714656*r**14+255299960557200*r**16
            +138268205928461*r**18+36666001162612*r**20+6059905605390*r**22+659867834140*r**24
            +51207024379*r**26)+Q2**6*(-477680286624-190842263277*r**2-13245153435265*r**4
            +45773093310554*r**6+92364833084006*r**8+146554859541081*r**10+27802923195153*r**12
            -538562468292612*r**14-881219192354652*r**16-594287391754203*r**18-230764460054127*r**20
            -51750939562646*r**22-6403116635498*r**24-901562185937*r**26+45252862047*r**28)
            +3*Q2**5*(65253575816+820951735425*r**2+10689535515814*r**4+18640606172595*r**6
            +73247410947396*r**8+84045234060197*r**10-22334091321230*r**12+21875598025815*r**14
            +223880837788176*r**16+230447990365507*r**18+75049630575450*r**20+10806250648265*r**22
            +4736935125156*r**24+644462818839*r**26+103939885582*r**28-29370302803*r**30)
            +3*Q2**4*(14351125120-527406133865*r**2-4863828819977*r**4-18993290215741*r**6
            -65492781554929*r**8-58136844849805*r**10+83915537070195*r**12+68096511953199*r**14
            -254016367986213*r**16-492280201082347*r**18-347952862779115*r**20-85926737945575*r**22
            +6617517864253*r**24-799359523871*r**26+49186569601*r**28+64415380725*r**30
            +13471008345*r**32)+18*Q2**3*(-3645394288+5172076506*r**2-201699791158*r**4
            +1186819571187*r**6-441657419540*r**8-967003447211*r**10-4471891666586*r**12
            +6018686528395*r**14+55714830081856*r**16+101691681027865*r**18+80596393990326*r**20
            +31550577422449*r**22+9139952507484*r**24-1945058311993*r**26-177208402150*r**28
            -92921516527*r**30-19853297944*r**32+430521329*r**34)-27*(-1+r**2)**2*(6113928
            -1056531739*r**2-11955836663*r**4-28263385576*r**6-359926074940*r**8
            +361373554236*r**10+755681955952*r**12-3058168109256*r**14-5208827008892*r**16
            +6605664146030*r**18+16744949343994*r**20-3037238454712*r**22-15971844887924*r**24
            -5240953521188*r**26-1145626740840*r**28-146369344408*r**30-11460054876*r**32
            -242220907*r**34+42657781*r**36)-9*Q2**2*(-2387998808-40427214167*r**2
            -659916959641*r**4+336991395240*r**6-10345637582576*r**8+3116495058988*r**10
            +15694270873500*r**12-7404958677128*r**14+4828997668704*r**16+42073109189302*r**18
            +30055386172898*r**20-94913016155624*r**22-140947967358096*r**24-41772589831828*r**26
            -12704767079476*r**28-1629517334328*r**30-253478984584*r**32-25181286135*r**34
            +1879303759*r**36)+27*Q2*(-73303256-6705305943*r**2-79442046826*r**4
            -10281879217*r**6-1852619920028*r**8+2914852653488*r**10+2370862154524*r**12
            -9190239620472*r**14+1158198412836*r**16+7967243063034*r**18+4474249333992*r**20
            +25709259128206*r**22-8529510321428*r**24-45297514217896*r**26-14548181397884*r**28
            -3573278090224*r**30-471646208412*r**32-49703017899*r**34-2600013598*r**36
            +272997003*r**38))*sqrtq2)+logq2**3*(276480*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1058914560*Q2**23-64*Q2**22*(260206425+230088569*r**2)+2*Q2**21*(58182496725
            +105982814986*r**2+46496880181*r**4)-6*Q2**20*(77024720695+225955190091*r**2
            +203837177393*r**4+57885110301*r**6)+20*Q2**19*(54292796160+245961621953*r**2
            +349673805688*r**4+206158202733*r**6+42033880118*r**8)-10*Q2**18*(128048160054
            +1048212800935*r**2+2129367715466*r**4+1979661475752*r**6+876905041120*r**8
            +137264115793*r**10)+12*Q2**17*(-27727681100+893559297917*r**2+2515973770010*r**4
            +3200381416460*r**6+2479487958395*r**8+988221472705*r**10+130123262977*r**12)
            +Q2**16*(3602844320250+5451753917467*r**2+15119037897112*r**4+40083304951125*r**6
            +23329572402750*r**8-9956422787795*r**10-9626183934648*r**12-1318748020613*r**14)
            +Q2**15*(-4884334034520-33673068498721*r**2-141695396397573*r**4-391559374269141*r**6
            -485637303520785*r**8-264972407723375*r**10-49746949057371*r**12+3576286334597*r**14
            +833670629609*r**16)+15*Q2**14*(47893383160+2878786545983*r**2+15362148777388*r**4
            +60294262281968*r**6+105910583967140*r**8+91664736970514*r**10+39725251507524*r**12
            +7290332820992*r**14+106096256628*r**16+779760063*r**18)-5*Q2**13*(-1114560004452
            +1785043209305*r**2+13542704980059*r**4+167846318180028*r**6+447621134930100*r**8
            +552446385452546*r**10+381890492088126*r**12+143481485415780*r**14+25007952861936*r**16
            +1186669851525*r**18+236007557159*r**20)+Q2**12*(-6267483350700-43378958038091*r**2
            -303599315774510*r**4-428580076129335*r**6+26126862078360*r**8+503749731264950*r**10
            +1082212707027996*r**12+1161398618417790*r**14+550840681745940*r**16+114015619350165*r**18
            +11675342460370*r**20+1529208265849*r**22)+3*Q2**11*(104479052600+18771281695689*r**2
            +151858099564489*r**4+678440689291575*r**6+1654822182944815*r**8+3030484403652270*r**10
            +3061856820912206*r**12+1376476811613826*r**14+101198803596650*r**16-122179910492215*r**18
            -35116817010135*r**20-4835490361721*r**22-71777532561*r**24)-Q2**10*(
            -4579649728080+15333426468511*r**2+126804083987408*r**4+2100309636892866*r**6
            +7026642067502800*r**8+18339068032356385*r**10+26845528859947584*r**12
            +20395494762577292*r**14+7993137211916944*r**16+1226764996461585*r**18
            -243065683972880*r**20-71346754050574*r**22-8518871734032*r**24+1317625540591*r**26)
            +5*Q2**9*(-662938574880-5973205272709*r**2-61597961627159*r**4+40842968915946*r**6
            +200300944855814*r**8+2067835835610021*r**10+5218803417630783*r**12+5804416577876380*r**14
            +3624116408439044*r**16+1433973895030677*r**18+344544054082391*r**20+3783474793210*r**22
            +1129448179542*r**24+548864500811*r**26+230009318081*r**28)+15*Q2**8*(
            -30241792076+2222648940365*r**2+23068484373638*r**4+115492147524431*r**6
            +509416290948040*r**8+878088487018225*r**10+527028027657114*r**12-209458696245669*r**14
            -831258910719244*r**16-871597902440985*r**18-481744562159174*r**20-159457669920531*r**22
            -22401685779568*r**24-4601780079397*r**26-626307518810*r**28+9631866601*r**30)
            +Q2**7*(1721915215800-7141662178291*r**2-61637190452215*r**4-1791135555163515*r**6
            -7804622196059415*r**8-24463696670103155*r**10-34728566227666599*r**12
            -25369821599734835*r**14+6382660180068465*r**16+32513889250128975*r**18
            +27417769818716035*r**20+10860022869337831*r**22+2528513526161235*r**24
            +415028699322135*r**26+66506517890075*r**28+6879830234055*r**30-701291444581*r**32)
            +Q2**6*(-663463451400-10707375720173*r**2-131546451411468*r**4+366731933763300*r**6
            -223942298462340*r**8+11694160297878940*r**10+15920110200697188*r**12
            +8938756008942668*r**14-17601840760113700*r**16-57423564622685550*r**18
            -58072222850261860*r**20-30686221734915972*r**22-9323736249097932*r**24
            -1539761388308100*r**26-279149763830260*r**28-21445364887980*r**30+101115115132*r**32
            +249130909507*r**34)+3*Q2**5*(-75915304890+2961117177623*r**2+34487811594739*r**4
            +232448623709168*r**6+1732484076953760*r**8+1249787013885440*r**10+5280563717078592*r**12
            +5201901345903496*r**14+409784440905732*r**16+9213842045264590*r**18+15924828513578710*r**20
            +7845370216609952*r**22+1974703343107456*r**24+802679143229832*r**26+162955607024200*r**28
            +47820865496040*r**30-4299876635242*r**32-1322656716141*r**34+61669216943*r**36)
            -15*Q2**4*(-16328288170+96311670809*r**2+1082047345044*r**4+40310389034469*r**6
            +197405721155552*r**8+439708350171496*r**10+1125350505502720*r**12+520842990882912*r**14
            -1670598231863764*r**16-278610143555870*r**18+4226286768845208*r**20+4912382144890098*r**22
            +1644052536656304*r**24-111397056647264*r**26+2712773504*r**28+8760635565416*r**30
            +2840898825198*r**32-1136652588035*r**34-175623647916*r**36+10930152289*r**38)
            +45*Q2**3*(-894180392-31026673255*r**2-369394907547*r**4+2119831651971*r**6
            -8407238091345*r**8+81444169455048*r**10-49095515241544*r**12-57667407188752*r**14
            -153132157422448*r**16+450044118106610*r**18+2030560364690970*r**20+2505156398148478*r**22
            +1619015294514150*r**24+688863041033568*r**26+4635188593680*r**28+1502272606504*r**30
            -2550290555504*r**32-1231644944051*r**34-155542174791*r**36+530554855*r**38
            +271943795*r**40)+54*(-1+r**2)**2*(-25933305+237379511*r**2+6602151820*r**4
            +202232590600*r**6+1045815296175*r**8+234152210735*r**10+26874471242696*r**12
            -44972991697960*r**14-67019043543050*r**16+292076452560150*r**18+218322783586400*r**20
            -675374127634104*r**22-362171940372290*r**24+508012800071550*r**26+243620717327800*r**28
            +78143945104840*r**30+13445897472451*r**32+1479336701555*r**34+179369610900*r**36
            -4365526000*r**38-1212448045*r**40+39447571*r**42)+9*Q2**2*(-2580217300
            +97531113241*r**2+1232941006220*r**4+12128511705870*r**6+105674021999160*r**8
            -185635997796695*r**10+1296691635905456*r**12-706188144091720*r**14-1460907187543320*r**16
            -55205971547790*r**18-2090633024603800*r**20-2129626099547324*r**22+4343616824417280*r**24
            +8684307050929530*r**26+3109448028143600*r**28+1345895081076760*r**30
            +203674322706316*r**32+39909034333845*r**34+9976942765420*r**36+49953240030*r**38
            -95224410840*r**40+3640016061*r**42)-27*Q2*(-406331200+7355492429*r**2
            +109793308499*r**4+2302788586450*r**6+12307521986490*r**8-22073426076335*r**10
            +264689540166979*r**12-468579534999896*r**14-299570193716600*r**16+915366410217130*r**18
            +725581442885030*r**20-127447597060836*r**22-2680839767543156*r**24-1219088424466150*r**26
            +2923284631838270*r**28+1302233524202120*r**30+457403876735144*r**32+75651343973129*r**34
            +9657386963175*r**36+1846062640610*r**38-17981543990*r**40-15734698091*r**42
            +552240799*r**44))-276480*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1058914560*Q2**24
            -64*Q2**23*(276751965+246634109*r**2)+2*Q2**22*(66509102325+121672254794*r**2
            +53859714389*r**4)-4*Q2**21*(144628329405+421015440992*r**2+381995613673*r**4
            +110076105542*r**6)+2*Q2**20*(774002123685+3368555951888*r**2+4786115159332*r**4
            +2846748890412*r**6+593994132083*r**8)-10*Q2**19*(236633752374+1648721637161*r**2
            +3320638570748*r**4+3091325492594*r**6+1373289206822*r**8+221331876029*r**10)
            +Q2**18*(947749427340+22485321184894*r**2+61967490404130*r**4+79494868909700*r**6
            +58319520669460*r**8+22000349241590*r**10+2934120313654*r**12)-Q2**17*(
            -3935576493450+4938225484337*r**2+25795358918012*r**4+28512957286515*r**6
            +44828860095510*r**8+51568935960995*r**10+23046320762832*r**12+2880227176337*r**14)
            +2*Q2**16*(-4243589177385-21363833368219*r**2-81133094106076*r**4-223380858558689*r**6
            -274525090437330*r**8-139172778669165*r**10-15082171167464*r**12+7260609144929*r**14
            +1076209325111*r**16)+Q2**15*(5602734781920+81739200722986*r**2+405800696557114*r**4
            +1437668704896234*r**6+2465855437297026*r**8+2125580765801870*r**10+910598129393606*r**12
            +155525655037654*r**14-2818513114786*r**16-821974228664*r**18)-10*Q2**14*(
            -485439927486+5282541498367*r**2+34132755475086*r**4+197407775679048*r**6
            +473117836838712*r**8+572586174132754*r**10+388030228761120*r**12+142264119200664*r**14
            +23598620047398*r**16+753648950799*r**18+119173418674*r**20)+2*Q2**13*(
            -5920141686480-20013271006913*r**2-113480287413845*r**4+239182519835550*r**6
            +1551732063814500*r**8+2752043666589090*r**10+2876948547365678*r**12+1894129252968660*r**14
            +696643936567260*r**16+122494366458735*r**18+9394364751895*r**20+1354623025822*r**22)
            -2*Q2**12*(-3290460254250-52980143237929*r**2-401276286253034*r**4-1383750729889285*r**6
            -2683459881442710*r**8-4280788308806750*r**10-3799804012221836*r**12-942909554697846*r**14
            +704321444686890*r**16+515698016286375*r**18+115520706420470*r**20+13855510905691*r**22
            +872270431766*r**24)-2*Q2**11*(-2133106285140+35980354356689*r**2+319346113883971*r**4
            +2295603001730529*r**6+7013215342105985*r**8+16197493896073820*r**10+22561276266820506*r**12
            +16855247830077694*r**14+6213082028774186*r**16+581910837887445*r**18
            -357477933239965*r**20-95601838083071*r**22-11620337708439*r**24+551146471454*r**26)
            +2*Q2**10*(-3947171301240-9556124811557*r**2-82926148839938*r**4+1215664282730002*r**6
            +5064228214337368*r**8+17852444638954645*r**10+35639306990228942*r**12
            +38131553255953388*r**14+23254607008344728*r**16+8194885841765957*r**18
            +1353209791450330*r**20-147747532028702*r**22-37109192443448*r**24-2228461844693*r**26
            +1233836065498*r**28)-10*Q2**9*(-286106599326-6652045334342*r**2-68388310010391*r**4
            -183615717642253*r**6-643552479536180*r**8-183064340294420*r**10+2852777585134731*r**12
            +5825798042122085*r**14+5961154859236578*r**16+3836442005396338*r**18
            +1611875817795295*r**20+413350269318597*r**22+36058990155728*r**24+7741826459272*r**26
            +1328898187661*r**28+100556859139*r**30)-2*Q2**8*(-1087771048470+20013884701313*r**2
            +220502095081130*r**4+1934772516817275*r**6+8589124386573240*r**8+22638134169798565*r**10
            +27902656973898342*r**12+15066680785453255*r**14-10996712142271080*r**16
            -29028370723766205*r**18-23858953393859210*r**20-10239028175266703*r**22
            -2628201930831360*r**24-410040343603305*r**26-72463915931590*r**28-8064982508595*r**30
            +422884721798*r**32)+2*Q2**7*(-1192689333600-2643814378841*r**2-31383799390481*r**4
            +1109752339689515*r**6+4685907726380295*r**8+21981239582020755*r**10+37556186549233471*r**12
            +34518571918172051*r**14+692660329776335*r**16-48160057026441495*r**18
            -59001940959553435*r**20-34482007211484919*r**22-11356136322298499*r**24
            -2241651806895735*r**26-380342490521235*r**28-47415856506055*r**30-3038711837171*r**32
            +475211177044*r**34)+2*Q2**6*(217858768365+10127095352221*r**2+122858630957929*r**4
            +231080194387836*r**6+2527331297780160*r**8-3860428478880140*r**10-5886289673670176*r**12
            -4626581085964684*r**14+4946219036944114*r**16+51333465759296510*r**18
            +81635136506841770*r**20+56147277617503844*r**22+22967034006668136*r**24
            +6635767533547764*r**26+1153888986605480*r**28+222028862603180*r**30+4222309933561*r**32
            -2159108086531*r**34-32061629339*r**36)-6*Q2**5*(-78778372870+1683380113389*r**2
            +21429582748791*r**4+234244190238126*r**6+1475980653220344*r**8+2590406420848340*r**10
            +6078551629238816*r**12+6543340008698324*r**14-1370652686254796*r**16
            +4115287884195486*r**18+23135052201534670*r**20+24166054727319576*r**22
            +9020168121499464*r**24+1110198601550484*r**26+482824157060776*r**28+127289825173660*r**30
            +28862741493394*r**32-5652898145779*r**34-1069552869389*r**36+58159989194*r**38)
            +30*Q2**4*(-9505414673-6548318563*r**2+35087146606*r**4+23875965667713*r**6
            +106247197957993*r**8+440723289846096*r**10+708886154974792*r**12+736595637409688*r**14
            -804575856624098*r**16-299538010549902*r**18+5019678859681124*r**20+8327069054090370*r**22
            +5706740282544426*r**24+1799622301554872*r**26-48744389046360*r**28+6635083079216*r**30
            +1975331362051*r**32-995344297495*r**34-889451380162*r**36-81550915531*r**38
            +5872991837*r**40)+18*Q2**3*(945342330+128567690738*r**2+1617524455115*r**4
            +1688163991875*r**6+68555527098015*r**8-275410327307605*r**10+567474182418968*r**12
            -86186765970120*r**14-203454682243660*r**16-769882887484300*r**18-7246827719295850*r**20
            -12404104956872282*r**22-8138620819447930*r**24-1427542313404530*r**26
            -179021559996320*r**28+657603887537920*r**30+104457206225658*r**32+29409355915810*r**34
            +8456439179815*r**36+412505669855*r**38-49618452045*r**40+1140148543*r**42)
            -54*(-1+r**2)**2*(-25933305+211446206*r**2+6839531331*r**4+208834742420*r**6
            +1248047886775*r**8+1279967506910*r**10+27108623453431*r**12-18098520455264*r**14
            -111992035241010*r**16+225057409017100*r**18+510399236146550*r**20-457051344047704*r**22
            -1037546068006394*r**24+145840859699260*r**26+751633517399350*r**28+321764662432640*r**30
            +91589842577291*r**32+14925234174006*r**34+1658706312455*r**36+175004084900*r**38
            -5577974045*r**40-1173000474*r**42+39447571*r**44)-18*Q2**2*(-1899605450
            +58508686614*r**2+829926022479*r**4+10134909235720*r**6+77362549832250*r**8
            -73091127013270*r**10+952562129304849*r**12-407617556592976*r**14-1532902956392420*r**16
            +614993035780140*r**18+15452666251750*r**20-2301300957666816*r**22-2914264288879756*r**24
            +4685329300974180*r**26+10281804487293970*r**28+4181021840913360*r**30
            +1460890516994254*r**32+235268694479774*r**34+39429068994395*r**36+7782541963640*r**38
            -49607901390*r**40-69394244526*r**42+2648369229*r**44)+27*Q2*(-458197810
            +7527653471*r**2+129351719914*r**4+2791113227891*r**6+15906215106530*r**8
            -13076395671875*r**10+297520078325446*r**12-400865558778151*r**14-668546906525364*r**16
            +1378079312397110*r**18+775249522948260*r**20-1041752638669314*r**22-394489167639356*r**24
            -2785963085645254*r**26-564957439003060*r**28+4423348777081970*r**30+1961194850118406*r**32
            +638518194431259*r**34+106641918296786*r**36+13735913511295*r**38+2201857526330*r**40
            -37518606759*r**42-17765143666*r**44+631135941*r**46))*sqrtq2)+logq2**2*(
            -4608*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(-2806174208*Q2**26
            +32*Q2**25*(1348460309+1294408349*r**2)-4*Q2**24*(71836605065+148276897106*r**2
            +67910096585*r**4)+2*Q2**23*(526845067720+1837528262173*r**2+1778362451298*r**4
            +520465316365*r**6)-4*Q2**22*(535502891590+3127322668091*r**2+4844572280473*r**4
            +3052690754521*r**6+642481282165*r**8)+4*Q2**21*(392769499970+5827390570549*r**2
            +13008689733124*r**4+13152418820479*r**6+6534511125404*r**8+1050321034670*r**10)
            -2*Q2**20*(-1614860416300+6761517605757*r**2+21376675516515*r**4+27235994666150*r**6
            +31467444301680*r**8+17229468891297*r**10+2145064383005*r**12)+Q2**19*(
            -9597002517460-41084182955629*r**2-154747699636650*r**4-383361207809875*r**6
            -312106756174000*r**8-48196144820895*r**10+21743141569046*r**12+1632326129735*r**14)
            +2*Q2**18*(3838180334620+54183669636133*r**2+269806440815368*r**4+902827198048105*r**6
            +1229621708092000*r**8+721596171214135*r**10+156029145843568*r**12+6220462965883*r**14
            +1380879896140*r**16)-Q2**17*(-6604954115940+88767558286919*r**2+606837834346332*r**4
            +3394264098622994*r**6+6744512410908920*r**8+6257435462995320*r**10+2863257036282524*r**12
            +553428839250182*r**14+47355181211364*r**16+5411020914585*r**18)+2*Q2**16*(
            -9192960329970-29860013908717*r**2-130622865390127*r**4+948376919261708*r**6
            +3455653858543468*r**8+4600396294563662*r**10+3581162825804258*r**12+1530304403128348*r**14
            +281702970492158*r**16+30588782102343*r**18+1372575613605*r**20)+4*Q2**15*(2441129808180
            +50014715625394*r**2+382057276751545*r**4+1170808120593005*r**6+2033283050937425*r**8
            +3409548778062263*r**10+2454827461805183*r**12+182944221467345*r**14-375778012097245*r**16
            -99104567869625*r**18-11848148302176*r**20+989854150290*r**22)-4*Q2**14*(
            -2709768347860+36348152472236*r**2+368134244812965*r**4+2748927276685100*r**6
            +8207974162145150*r**8+19519463575608720*r**10+24066719102663174*r**12
            +14059679169041600*r**14+3403532187154200*r**16+71763526508900*r**18-47200570601755*r**20
            -2244738961164*r**22+1787949470510*r**24)+4*Q2**13*(-4242822803840-17252148395281*r**2
            -99218140349471*r**4+1907294703029935*r**6+8081769646015100*r**8+30966501510862345*r**10
            +55752581538478066*r**12+49586851849388066*r**14+22820155948398460*r**16
            +4932186257805025*r**18+319212347630525*r**20+34110300374479*r**22+9986993012344*r**24
            +506563250695*r**26)+4*Q2**12*(800704554460+48488919298079*r**2+491125957957562*r**4
            +1305509881528484*r**6+3572416892196005*r**8-9606420143144995*r**10-43485535326492769*r**12
            -58999464637762192*r**14-44235295449471214*r**16-19154226705469495*r**18
            -4261677682206820*r**20-557118470886436*r**22-123935134681363*r**24-15201388974101*r**26
            +1216559841835*r**28)-2*Q2**11*(-4595462495060+49685629602687*r**2+645245296769532*r**4
            +7028432381093647*r**6+30667705553697202*r**8+81517671231230841*r**10
            +109104444044022958*r**12+123998081106303013*r**14+71703862259785848*r**16
            -4180090567213607*r**18-20331198831337184*r**20-7174255633936863*r**22
            -1577670584209718*r**24-225784695130353*r**26-11149402275498*r**28+2210740690315*r**30)
            -4*Q2**10*(1694895740660+15511517703581*r**2+127678587654615*r**4-2186047578251935*r**6
            -11115495610382090*r**8-67329901049636707*r**10-151507469531464999*r**12
            -276596102125361615*r**14-298082841463951840*r**16-158503378513820185*r**18
            -32201497534504679*r**20+5912968603955603*r**22+3079052517395390*r**24
            +688680866015615*r**26-4209895520265*r**28-9728754762949*r**30+287352481400*r**32)
            +2*Q2**9*(-553898930980+49434324041423*r**2+574355858411390*r**4+1759760408062400*r**6
            +9245769723126100*r**8-62312462399416490*r**10-174333642957164798*r**12
            -552864126459784220*r**14-915464058692054000*r**16-734415499660529000*r**18
            -323394044660686910*r**20-76226830216315448*r**22+2441728715670100*r**24
            +1858535017938050*r**26+399231095460350*r**28-153884877234220*r**30-24781931143252*r**32
            +1654194402305*r**34)-4*Q2**8*(-811892704685+6476187542671*r**2+107837393057331*r**4
            +2166064417719070*r**6+12137848368692325*r**8+33206907293627580*r**10
            +107026143305871359*r**12+83342664929126714*r**14-123882103100153865*r**16
            -227861243480142650*r**18-186647438996846575*r**20-110771290789607886*r**22
            -44571434208598441*r**24-7683877103769660*r**26-1921260506784075*r**28
            -339906630487370*r**30-43018371025094*r**32-1488464519829*r**34+214455947080*r**36)
            -2*Q2**7*(448360165280+14529616659397*r**2+123725009205716*r**4-2080076646861973*r**6
            -11349700314654430*r**8-114174452138719110*r**10-347052730242102062*r**12
            -753801224116936366*r**14-633866254780389662*r**16-163981062609839140*r**18
            +385543517783357610*r**20+593732442291902848*r**22+349274863578153334*r**24
            +111726102971032678*r**26+23434245538070790*r**28+5075499728150270*r**30
            +1035956521536742*r**32-10385305147009*r**34-12821660652118*r**36+567773227205*r**38)
            +4*Q2**6*(-155278010350+5724562116379*r**2+67345210421914*r**4+363001863477169*r**6
            +2476794729929759*r**8-24683903530334932*r**10-24846502513096304*r**12
            -260641630390442764*r**14-205874658032398444*r**16+35152773655092666*r**18
            +391690328854334364*r**20+649618620298737246*r**22+490153908899757086*r**24
            +199134047414248156*r**26+41559335408220016*r**28+8383344222640868*r**30
            +1042416204173554*r**32+225887002575139*r**34-11425474718006*r**36-3834800777191*r**38
            +182814053675*r**40)+12*Q2**5*(34938122690-71847301322*r**2-4771551747875*r**4
            -206059302291570*r**6-1248793375952740*r**8-4851926824353253*r**10-34064517814040704*r**12
            +10407429750278000*r**14-55249055171993380*r**16-74932182542891660*r**18
            -52163536116627126*r**20-138160971559049916*r**22-109845643353731800*r**24
            -41742783728498930*r**26-18781741872221960*r**28-3780508776414224*r**30
            -1714327073698718*r**32+41616417550*r**34+48609116273505*r**36+1514767644110*r**38
            -343624982212*r**40+9947061535*r**42)-6*Q2**4*(1153244460+867823577579*r**2
            +4993976887155*r**4-139382131601850*r**6-835507158341650*r**8-13529117905729605*r**10
            -41797636133095041*r**12-33478338579959880*r**14-148286671623945000*r**16
            -39240630434609850*r**18+258221332150361630*r**20-77613828646359276*r**22
            -440394861555989940*r**24-194843667264280450*r**26+21727716789027150*r**28
            +6835417498578840*r**30+68762078705484*r**32-1939607033958225*r**34+7723802804175*r**36
            +133744621419350*r**38+1915088786550*r**40-1153333508121*r**42+38229186515*r**44)
            +27*Q2**3*(-2267306780+69096708873*r**2+729856920838*r**4+8044688535675*r**6
            +44547275208700*r**8-827778229122165*r**10+1718021036621418*r**12-11077704971557287*r**14
            +6065484594599960*r**16+9301602671380650*r**18+20541576611709900*r**20
            -68324163216053442*r**22-163254870825751192*r**24-146115267986683930*r**26
            -88622850593407900*r**28-11336173144577310*r**30-1838235943839612*r**32
            +36510442652893*r**34+99429077366030*r**36+10380379349175*r**38+6955612701980*r**40
            +90203915263*r**42-49845731502*r**44+1537159765*r**46)+54*(-1+r**2)**2*(
            -6578562+727820153*r**2+876323633*r**4-140385042167*r**6-1662300811797*r**8
            -30850926841677*r**10-36097026181437*r**12+24881164033043*r**14-2606661437339057*r**16
            +7486307553765338*r**18-1010649955379222*r**20-28300962709126982*r**22
            +16040566342487198*r**24+35605572621713798*r**26-16933244179303482*r**28
            -10603039085745402*r**30-5192352125574212*r**32-1285359307674307*r**34
            -150262091090507*r**36-26812973079987*r**38-2634319930137*r**40+354434978103*r**42
            +12303574183*r**44-1595435817*r**46+32439303*r**48)+18*Q2**2*(950631980
            +11877475077*r**2-235472267394*r**4-14027126818503*r**6-86993857517100*r**8
            -621797594159565*r**10-4364011174024418*r**12+14895378357779751*r**14
            -58177925372893428*r**16+37216775125435970*r**18+57147996009890940*r**20
            +29532352524864042*r**22+40805954399447736*r**24-72245094913174698*r**26
            -164033647448199060*r**28-55832934355741730*r**30-37374510080381388*r**32
            -6480971679021399*r**34-970443644160058*r**36-572293713334515*r**38-57808634443500*r**40
            +8375138391687*r**42+326127898806*r**44-59549565813*r**46+1511886580*r**48)
            -27*Q2*(5416276+9089083677*r**2-15008982608*r**4-2744249028918*r**6
            -20159338675808*r**8-308556511980228*r**10-586790893932208*r**12+3409007367672382*r**14
            -27558685036000428*r**16+58815589582603057*r**18+7961686686456352*r**20
            -111094788468524188*r**22-34524937150177248*r**24+124162703384557792*r**26
            +118104079242467552*r**28-100703917734658948*r**30-55943811530904708*r**32
            -30140463274576593*r**34-6797915626866128*r**36-705250252987918*r**38
            -224493295144128*r**40-28668474081948*r**42+3711685642192*r**44+156314150182*r**46
            -21948297508*r**48+492770051*r**50))+4608*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(2806174208*Q2**26-32*Q2**25*(1348460309+1294408349*r**2)+4*Q2**24*(71836605065
            +148276897106*r**2+67910096585*r**4)-2*Q2**23*(526845067720+1837528262173*r**2
            +1778362451298*r**4+520465316365*r**6)+4*Q2**22*(535502891590+3127322668091*r**2
            +4844572280473*r**4+3052690754521*r**6+642481282165*r**8)-4*Q2**21*(392769499970
            +5827390570549*r**2+13008689733124*r**4+13152418820479*r**6+6534511125404*r**8
            +1050321034670*r**10)+2*Q2**20*(-1614860416300+6761517605757*r**2+21376675516515*r**4
            +27235994666150*r**6+31467444301680*r**8+17229468891297*r**10+2145064383005*r**12)
            +Q2**19*(9597002517460+41084182955629*r**2+154747699636650*r**4+383361207809875*r**6
            +312106756174000*r**8+48196144820895*r**10-21743141569046*r**12-1632326129735*r**14)
            -2*Q2**18*(3838180334620+54183669636133*r**2+269806440815368*r**4+902827198048105*r**6
            +1229621708092000*r**8+721596171214135*r**10+156029145843568*r**12+6220462965883*r**14
            +1380879896140*r**16)+Q2**17*(-6604954115940+88767558286919*r**2+606837834346332*r**4
            +3394264098622994*r**6+6744512410908920*r**8+6257435462995320*r**10+2863257036282524*r**12
            +553428839250182*r**14+47355181211364*r**16+5411020914585*r**18)-2*Q2**16*(
            -9192960329970-29860013908717*r**2-130622865390127*r**4+948376919261708*r**6
            +3455653858543468*r**8+4600396294563662*r**10+3581162825804258*r**12+1530304403128348*r**14
            +281702970492158*r**16+30588782102343*r**18+1372575613605*r**20)-4*Q2**15*(2441129808180
            +50014715625394*r**2+382057276751545*r**4+1170808120593005*r**6+2033283050937425*r**8
            +3409548778062263*r**10+2454827461805183*r**12+182944221467345*r**14-375778012097245*r**16
            -99104567869625*r**18-11848148302176*r**20+989854150290*r**22)+4*Q2**14*(
            -2709768347860+36348152472236*r**2+368134244812965*r**4+2748927276685100*r**6
            +8207974162145150*r**8+19519463575608720*r**10+24066719102663174*r**12
            +14059679169041600*r**14+3403532187154200*r**16+71763526508900*r**18-47200570601755*r**20
            -2244738961164*r**22+1787949470510*r**24)-4*Q2**13*(-4242822803840-17252148395281*r**2
            -99218140349471*r**4+1907294703029935*r**6+8081769646015100*r**8+30966501510862345*r**10
            +55752581538478066*r**12+49586851849388066*r**14+22820155948398460*r**16
            +4932186257805025*r**18+319212347630525*r**20+34110300374479*r**22+9986993012344*r**24
            +506563250695*r**26)-4*Q2**12*(800704554460+48488919298079*r**2+491125957957562*r**4
            +1305509881528484*r**6+3572416892196005*r**8-9606420143144995*r**10-43485535326492769*r**12
            -58999464637762192*r**14-44235295449471214*r**16-19154226705469495*r**18
            -4261677682206820*r**20-557118470886436*r**22-123935134681363*r**24-15201388974101*r**26
            +1216559841835*r**28)+2*Q2**11*(-4595462495060+49685629602687*r**2+645245296769532*r**4
            +7028432381093647*r**6+30667705553697202*r**8+81517671231230841*r**10
            +109104444044022958*r**12+123998081106303013*r**14+71703862259785848*r**16
            -4180090567213607*r**18-20331198831337184*r**20-7174255633936863*r**22
            -1577670584209718*r**24-225784695130353*r**26-11149402275498*r**28+2210740690315*r**30)
            +4*Q2**10*(1694895740660+15511517703581*r**2+127678587654615*r**4-2186047578251935*r**6
            -11115495610382090*r**8-67329901049636707*r**10-151507469531464999*r**12
            -276596102125361615*r**14-298082841463951840*r**16-158503378513820185*r**18
            -32201497534504679*r**20+5912968603955603*r**22+3079052517395390*r**24
            +688680866015615*r**26-4209895520265*r**28-9728754762949*r**30+287352481400*r**32)
            -2*Q2**9*(-553898930980+49434324041423*r**2+574355858411390*r**4+1759760408062400*r**6
            +9245769723126100*r**8-62312462399416490*r**10-174333642957164798*r**12
            -552864126459784220*r**14-915464058692054000*r**16-734415499660529000*r**18
            -323394044660686910*r**20-76226830216315448*r**22+2441728715670100*r**24
            +1858535017938050*r**26+399231095460350*r**28-153884877234220*r**30-24781931143252*r**32
            +1654194402305*r**34)+4*Q2**8*(-811892704685+6476187542671*r**2+107837393057331*r**4
            +2166064417719070*r**6+12137848368692325*r**8+33206907293627580*r**10
            +107026143305871359*r**12+83342664929126714*r**14-123882103100153865*r**16
            -227861243480142650*r**18-186647438996846575*r**20-110771290789607886*r**22
            -44571434208598441*r**24-7683877103769660*r**26-1921260506784075*r**28
            -339906630487370*r**30-43018371025094*r**32-1488464519829*r**34+214455947080*r**36)
            +2*Q2**7*(448360165280+14529616659397*r**2+123725009205716*r**4-2080076646861973*r**6
            -11349700314654430*r**8-114174452138719110*r**10-347052730242102062*r**12
            -753801224116936366*r**14-633866254780389662*r**16-163981062609839140*r**18
            +385543517783357610*r**20+593732442291902848*r**22+349274863578153334*r**24
            +111726102971032678*r**26+23434245538070790*r**28+5075499728150270*r**30
            +1035956521536742*r**32-10385305147009*r**34-12821660652118*r**36+567773227205*r**38)
            -4*Q2**6*(-155278010350+5724562116379*r**2+67345210421914*r**4+363001863477169*r**6
            +2476794729929759*r**8-24683903530334932*r**10-24846502513096304*r**12
            -260641630390442764*r**14-205874658032398444*r**16+35152773655092666*r**18
            +391690328854334364*r**20+649618620298737246*r**22+490153908899757086*r**24
            +199134047414248156*r**26+41559335408220016*r**28+8383344222640868*r**30
            +1042416204173554*r**32+225887002575139*r**34-11425474718006*r**36-3834800777191*r**38
            +182814053675*r**40)-12*Q2**5*(34938122690-71847301322*r**2-4771551747875*r**4
            -206059302291570*r**6-1248793375952740*r**8-4851926824353253*r**10-34064517814040704*r**12
            +10407429750278000*r**14-55249055171993380*r**16-74932182542891660*r**18
            -52163536116627126*r**20-138160971559049916*r**22-109845643353731800*r**24
            -41742783728498930*r**26-18781741872221960*r**28-3780508776414224*r**30
            -1714327073698718*r**32+41616417550*r**34+48609116273505*r**36+1514767644110*r**38
            -343624982212*r**40+9947061535*r**42)+6*Q2**4*(1153244460+867823577579*r**2
            +4993976887155*r**4-139382131601850*r**6-835507158341650*r**8-13529117905729605*r**10
            -41797636133095041*r**12-33478338579959880*r**14-148286671623945000*r**16
            -39240630434609850*r**18+258221332150361630*r**20-77613828646359276*r**22
            -440394861555989940*r**24-194843667264280450*r**26+21727716789027150*r**28
            +6835417498578840*r**30+68762078705484*r**32-1939607033958225*r**34+7723802804175*r**36
            +133744621419350*r**38+1915088786550*r**40-1153333508121*r**42+38229186515*r**44)
            -27*Q2**3*(-2267306780+69096708873*r**2+729856920838*r**4+8044688535675*r**6
            +44547275208700*r**8-827778229122165*r**10+1718021036621418*r**12-11077704971557287*r**14
            +6065484594599960*r**16+9301602671380650*r**18+20541576611709900*r**20
            -68324163216053442*r**22-163254870825751192*r**24-146115267986683930*r**26
            -88622850593407900*r**28-11336173144577310*r**30-1838235943839612*r**32
            +36510442652893*r**34+99429077366030*r**36+10380379349175*r**38+6955612701980*r**40
            +90203915263*r**42-49845731502*r**44+1537159765*r**46)-54*(-1+r**2)**2*(
            -6578562+727820153*r**2+876323633*r**4-140385042167*r**6-1662300811797*r**8
            -30850926841677*r**10-36097026181437*r**12+24881164033043*r**14-2606661437339057*r**16
            +7486307553765338*r**18-1010649955379222*r**20-28300962709126982*r**22
            +16040566342487198*r**24+35605572621713798*r**26-16933244179303482*r**28
            -10603039085745402*r**30-5192352125574212*r**32-1285359307674307*r**34
            -150262091090507*r**36-26812973079987*r**38-2634319930137*r**40+354434978103*r**42
            +12303574183*r**44-1595435817*r**46+32439303*r**48)-18*Q2**2*(950631980
            +11877475077*r**2-235472267394*r**4-14027126818503*r**6-86993857517100*r**8
            -621797594159565*r**10-4364011174024418*r**12+14895378357779751*r**14
            -58177925372893428*r**16+37216775125435970*r**18+57147996009890940*r**20
            +29532352524864042*r**22+40805954399447736*r**24-72245094913174698*r**26
            -164033647448199060*r**28-55832934355741730*r**30-37374510080381388*r**32
            -6480971679021399*r**34-970443644160058*r**36-572293713334515*r**38-57808634443500*r**40
            +8375138391687*r**42+326127898806*r**44-59549565813*r**46+1511886580*r**48)
            +27*Q2*(5416276+9089083677*r**2-15008982608*r**4-2744249028918*r**6
            -20159338675808*r**8-308556511980228*r**10-586790893932208*r**12+3409007367672382*r**14
            -27558685036000428*r**16+58815589582603057*r**18+7961686686456352*r**20
            -111094788468524188*r**22-34524937150177248*r**24+124162703384557792*r**26
            +118104079242467552*r**28-100703917734658948*r**30-55943811530904708*r**32
            -30140463274576593*r**34-6797915626866128*r**36-705250252987918*r**38
            -224493295144128*r**40-28668474081948*r**42+3711685642192*r**44+156314150182*r**46
            -21948297508*r**48+492770051*r**50))*sqrtq2)+logq2*(384*r**8*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*(38614384*Q2**25-2*Q2**24*(290540761+381965065*r**2)+8*Q2**23*(461577146
            +1372819667*r**2+761982377*r**4)-4*Q2**22*(3131211913+16308272160*r**2
            +19928864431*r**4+6642704968*r**6)+2*Q2**21*(10943726134+99633044101*r**2
            +194954876891*r**4+151422200143*r**6+34565845843*r**8)-2*Q2**20*(3096509021
            +138368484164*r**2+356635595886*r**4+486467392876*r**6+323032502579*r**8
            +51777053150*r**10)+Q2**19*(-55313273062-128816721045*r**2-908484594535*r**4
            -1508973662050*r**6+246361044180*r**8+669454631563*r**10+59240543885*r**12)
            +2*Q2**18*(55056930439+573294198178*r**2+3477748379208*r**4+9487390489405*r**6
            +8523688438855*r**8+2354851579284*r**10+75570234778*r**12+35876244253*r**14)
            -Q2**17*(45386463142+1644332958925*r**2+12710393023279*r**4+55103853892807*r**6
            +80944066447525*r**8+51730788857887*r**10+13320799980205*r**12+1449299391109*r**14
            +139905096337*r**16)+2*Q2**16*(-66992657061+40999496661*r**2+1754818080866*r**4
            +31937652389798*r**6+71707018007868*r**8+73233044395724*r**10+40295541662906*r**12
            +9385110856086*r**14+990638254853*r**16+917514843*r**18)+4*Q2**15*(53621531682
            +655022655183*r**2+5959852773602*r**4+7809064665382*r**6+5638398545503*r**8
            +7732855191074*r**10-12666321084467*r**12-15630846397898*r**14-3763634603893*r**16
            -287501878197*r**18+50383466205*r**20)-4*Q2**14*(10732093608+749763665940*r**2
            +9742313499505*r**4+49467763371175*r**6+134204191301915*r**8+279388380713757*r**10
            +238447560613705*r**12+70430010756335*r**14+363584830005*r**16-825519709465*r**18
            +82368797358*r**20+44129305650*r**22)+4*Q2**13*(-47621723348-24557841846*r**2
            +2506420232039*r**4+58598197244980*r**6+208673037603600*r**8+666946441802488*r**10
            +887759646845146*r**12+539432372600616*r**14+144856533019360*r**16+15642241747150*r**18
            +2622200292447*r**20+346711335204*r**22-15318003116*r**24)+4*Q2**12*(47089891897
            +749100107860*r**2+9598365206339*r**4-2464730498543*r**6-15048153059255*r**8
            -509232711089002*r**10-1097507043355550*r**12-1007932248685514*r**14-520220913467077*r**16
            -137691793941080*r**18-22460793897893*r**20-4161072352855*r**22-301667711501*r**24
            +44743072942*r**26)-2*Q2**11*(-7516629254+1127952357739*r**2+23123341672119*r**4
            +138880978903502*r**6+663357584337922*r**8+1172718427241829*r**10+1190723714584511*r**12
            +1439773262650516*r**14+411309702097998*r**16-339629002545427*r**18-195357227889179*r**20
            -48837385731666*r**22-3981113964346*r**24+134456686867*r**26+23152299637*r**28)
            -4*Q2**10*(33714882443+122641209882*r**2-1283092897177*r**4-74843350828282*r**6
            -369453065373798*r**8-1614605961882517*r**10-3062343173086072*r**12-5299430667137523*r**14
            -4439462154498013*r**16-1528191395281732*r**18-12880085555781*r**20+88975452728492*r**22
            +22429451790728*r**24-1559810479857*r**26-386771408378*r**28+25249639025*r**30)
            +2*Q2**9*(34710412694+819556039025*r**2+15056088747885*r**4-19542341002225*r**6
            +59465385848765*r**8-2295694178047979*r**10-4227113054575315*r**12-13509143583331165*r**14
            -17418111346634855*r**16-10173477159290725*r**18-2930551644657529*r**20
            +52902958685845*r**22+91468641124055*r**24+15286639524095*r**26-4516174181505*r**28
            -529061915431*r**30+39617754845*r**32)+2*Q2**8*(14420261489-359995297447*r**2
            -12081536826562*r**4-93792991416010*r**6-719889165183340*r**8-905906120803404*r**10
            -5124895534729718*r**12+699954009829442*r**14+10281839764494090*r**16
            +9985990758365050*r**18+6195125581335026*r**20+2312751334781082*r**22
            +188669933736172*r**24+113013669646220*r**26+32417049048710*r**28+775300793774*r**30
            -192548933947*r**32+6767904173*r**34)-4*Q2**7*(10552709098+71832083355*r**2
            -18215106974*r**4-42098992224782*r**6-234356962285185*r**8-1365218089463188*r**10
            -4425788371597495*r**12-6362364000355266*r**14-1704202896775033*r**16
            +1818010525223230*r**18+5261330487472497*r**20+4128738809455310*r**22
            +1404042186632189*r**24+262599793233972*r**26+93725166876715*r**28+23532688386178*r**30
            -654344946285*r**32-211118532089*r**34+9803447353*r**36)+4*Q2**6*(2064583757
            +96984356108*r**2+2548225955788*r**4-4824341160481*r**6+68052086449559*r**8
            -837935663125707*r**10-386668541491853*r**12-6365755315924823*r**14-398272603467559*r**16
            +2767513357606301*r**18+8469871396752083*r**20+9020376818482247*r**22
            +4554847729752517*r**24+896504522766151*r**26+235515055519041*r**28+39973921697867*r**30
            +5705612022398*r**32-248421598757*r**34-52387901011*r**36+2483430374*r**38)
            +2*Q2**5*(4531058554-49715441789*r**2-2841406937901*r**4-29876541622291*r**6
            -304071043325519*r**8-221896059700412*r**10-6609677243590276*r**12+9132896691326756*r**14
            -12711939889373184*r**16-5307076309959486*r**18-5569169150370998*r**20
            -14445390408448186*r**22-4034337020394074*r**24-2171100947677084*r**26
            +214555764753644*r**28-336949518855404*r**30-14139847597874*r**32+22535340915219*r**34
            -165103991941*r**36-138429964139*r**38+4411212385*r**40)-2*Q2**4*(2682920061
            +21151045620*r**2-76686188080*r**4-19810675496850*r**6-105262155654225*r**8
            -870680391745274*r**10-4111445775343920*r**12+5485488063782040*r**14-17064422150333990*r**16
            +6323997496000440*r**18+17586819741278976*r**20-21307375353637260*r**22
            -13495669710448890*r**24+1892986924014780*r**26+404089331149520*r**28
            +484572166993176*r**30-222692425583175*r**32-21438056685820*r**34+18884102620560*r**36
            -27346238610*r**38-97280789189*r**40+2867380110*r**42)+3*Q2**3*(22216206
            +11218324737*r**2+375520451887*r**4-1108806128070*r**6+26080853079440*r**8
            -287657804265779*r**10+656801052644107*r**12-2093625036963368*r**14+253745339364260*r**16
            +4231719571283010*r**18+2774653265709166*r**20-18498305928642788*r**22
            -15315673384673368*r**24-15128931007447710*r**26-1856960459576290*r**28
            -379620017675944*r**30-37356317671618*r**32+2018669216317*r**34+2300679415395*r**36
            +860437172090*r**38+7903893976*r**40+249081937*r**42+4232407*r**44)+18*(
            -1+r**2)**2*(1835533+7898605*r**2-436107867*r**4-24987170343*r**6-159399837875*r**8
            -1983583518087*r**10-6910807273075*r**12+57883620948053*r**14-437754508510278*r**16
            +1330962815007050*r**18-1447888262436662*r**20-1324937824238430*r**22
            +3368673039538818*r**24-1187188387693558*r**26-167079089272350*r**28-290040720099422*r**30
            -83493566439335*r**32-8125756734327*r**34-2196564828303*r**36-431589638075*r**38
            +37101930513*r**40+891223485*r**42-121710927*r**44+2326857*r**46)+6*Q2**2*(138779933
            -1294833930*r**2-89163174854*r**4-1103928015067*r**6-13334131496345*r**8
            +1827052599878*r**10-588989430883050*r**12+2563689373059971*r**14-7670952123059302*r**16
            +8125489198365620*r**18+1200046467899228*r**20+532376210218890*r**22-686530347168154*r**24
            -6207128236709532*r**26-2117695290967580*r**28-2213817848276322*r**30
            -548801577934535*r**32+740679557686*r**34-41692587282262*r**36-10746479841695*r**38
            +1524369577283*r**40+22899365750*r**42-7392105274*r**44+168723663*r**46)
            -9*Q2*(32243798-39166683*r**2-11870110133*r**4-337399071769*r**6-2449849283979*r**8
            -13522054029157*r**10-119047569854683*r**12+904049954883297*r**14-4475224004660039*r**16
            +10389894158706946*r**18-7472516178286242*r**20-7228229370097578*r**22
            +6998363336252082*r**24+6743664469356006*r**26-3715441153943014*r**28
            -1446693910806862*r**30-1630661432711688*r**32-492417564044023*r**34-24628092052569*r**36
            -15693771388269*r**38-4854364415287*r**40+482203965007*r**42+11382993777*r**44
            -1952865379*r**46+39986441*r**48))-384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(308915072*Q2**30-32*Q2**29*(163370873+209083025*r**2)+2*Q2**28*(19128580087
            +54326731806*r**2+30112912039*r**4)-8*Q2**27*(19400236862+94046354223*r**2
            +113400498988*r**4+37952287547*r**6)+4*Q2**26*(89290379426+706936808348*r**2
            +1374636690601*r**4+1032424741574*r**6+235994132567*r**8)-2*Q2**25*(170522799914
            +2858342592105*r**2+7895145523700*r**4+9853507230018*r**6+5611739947674*r**8
            +902282739341*r**10)+2*Q2**24*(-236558072910+1598649158175*r**2+5501555505435*r**4
            +10100990587946*r**6+15853204365494*r**8+8775829415915*r**10+881909768625*r**12)
            +Q2**23*(1918406654130+13476743581665*r**2+69577104990440*r**4+183587903412563*r**6
            +147035713940802*r**8+16175299803299*r**10-9761772272340*r**12+358441089585*r**14)
            -2*Q2**22*(1019577627885+18019797148365*r**2+118984019407620*r**4+451298801771503*r**6
            +656388311559564*r**8+403481575599063*r**10+93798260163320*r**12+9588885887445*r**14
            +1575678350835*r**16)+Q2**21*(-1009880653270+28354338077265*r**2+276165905488630*r**4
            +1807266107583370*r**6+3932904621756634*r**8+3928892568689216*r**10+1943314423363082*r**12
            +419351994788006*r**14+48902382342780*r**16+2498267046335*r**18)+2*Q2**20*(2422693194280
            +15324737352325*r**2+73866370033555*r**4-538718935342872*r**6-2247902710424328*r**8
            -3267965484335078*r**10-2827766584935930*r**12-1297801221283440*r**14
            -245350108246784*r**16-22247090687015*r**18+1306466338615*r**20)-Q2**19*(3848643708610
            +86919495986025*r**2+844889913748180*r**4+2925521889022513*r**6+5148137750424612*r**8
            +9450250725728682*r**10+6344854298998600*r**12-750269917730430*r**14-1507421965161942*r**16
            -239726330195203*r**18-485999920140*r**20+6011918348125*r**22)+2*Q2**18*(
            -1275082127255+27123282166485*r**2+438633162768130*r**4+3737890873427189*r**6
            +12245242059764161*r**8+32168577404391026*r**10+42094775559362452*r**12
            +25163619662473978*r**14+6143048313426419*r**16+568090501097801*r**18
            +107860298530522*r**20+22847180904545*r**22+980337535315*r**24)+Q2**17*(6645200598290
            +52581168614885*r**2+256530850130550*r**4-5731097540392236*r**6-29058622198687588*r**8
            -118977676273790663*r**10-228024683134243268*r**12-212930618891804208*r**14
            -102398707173738278*r**16-24016177636564713*r**18-3463711390561906*r**20
            -526609950048420*r**22-50634686537800*r**24+4785912458315*r**26)+2*Q2**16*(
            -1366227623855-52850118954240*r**2-712711191369005*r**4-2109955019418480*r**6
            -3457761573946833*r**8+27370392280108312*r**10+110997162581259973*r**12
            +151531761730644912*r**14+117026530391070351*r**16+52224798647348240*r**18
            +12153407244065133*r**20+2003210355408736*r**22+196331386186033*r**24
            +2820439856760*r**26-2412849242885*r**28)+2*Q2**15*(-1926351214950+19036726567125*r**2
            +535150555959680*r**4+6401919884429483*r**6+28896865625798342*r**8+85506379140450721*r**10
            +113768955449925340*r**12+155009842081841935*r**14+110261531561362118*r**16
            +6725224078586599*r**18-22168834303309448*r**20-8034351969819015*r**22
            -1474624816570950*r**24+45335579401731*r**26+24490315513100*r**28-665370589395*r**30)
            +4*Q2**14*(1147660087215+14258382707775*r**2+114574238433580*r**4-2221106838858047*r**6
            -14051117025979398*r**8-87556941425316221*r**10-216612420409661120*r**12
            -456439860184797795*r**14-560458974197842268*r**16-342558199738766267*r**18
            -93319500210296196*r**20-4876957082277605*r**22+1471032232977310*r**24
            +192964704935193*r**26-103594596798728*r**28-13283896247385*r**30+1117034251125*r**32)
            +2*Q2**13*(-44397465870-32960129365635*r**2-624706847129850*r**4-2109652497279506*r**6
            -5253871304350314*r**8+101687482200033750*r**10+385488629987357494*r**12
            +1299439092328823286*r**14+2348674998305221866*r**16+2140191289849046584*r**18
            +1046684018538967506*r**20+256936606634357754*r**22+26127463897817266*r**24
            +3675845334374154*r**26+1082662683764466*r**28+127777058075042*r**30-51925995300*r**32
            -679738066965*r**34)-2*Q2**12*(1341984268145-3113099397720*r**2-277710822808165*r**4
            -5734226242343752*r**6-32047413375120916*r**8-99417492125972360*r**10
            -191465108107642972*r**12+191978978058541688*r**14+1530061426048067254*r**16
            +2178852892980130456*r**18+1698970021757178434*r**20+810713587786104808*r**22
            +210252993442023308*r**24+38570217648008840*r**26+9298063458298084*r**28
            +1879508604591208*r**30-41258481960095*r**32-21525697544640*r**34+1031824938395*r**36)
            +2*Q2**11*(674168852230+15963849282715*r**2+208585115850980*r**4-2998797261890025*r**6
            -21608073336540768*r**8-212952873376215484*r**10-677401612426320520*r**12
            -1881580570471615404*r**14-2272688888608508548*r**16-2448323193281012166*r**18
            -1595880520242413360*r**20-116955169611194302*r**22+379020208127911760*r**24
            +166587758055747252*r**26+49256491408082408*r**28+7703000532288708*r**30
            +838345358947086*r**32-87539905698637*r**34-13062867070100*r**36+799472753935*r**38)
            +4*Q2**10*(160401432635-5010518620575*r**2-135984697986685*r**4-783990053330081*r**6
            -2938636806592134*r**8+57100574261246220*r**10+215695742732287100*r**12
            +1315186221197954100*r**14+2535471638050328898*r**16+4369549993870474366*r**18
            +4883601568441601754*r**20+2784728031552463250*r**22+676305649719465440*r**24
            -84330834648551940*r**26-63226914284776692*r**28-20496498026996444*r**30
            -597775824443925*r**32+501965627957145*r**34+14826485840283*r**36-3402259958985*r**38
            +89981831870*r**40)-4*Q2**9*(202307329420+774535526850*r**2-25653717595605*r**4
            -1360365200757243*r**6-7984017025646767*r**8-32841644530341311*r**10-106247139740022140*r**12
            +435164910122229820*r**14+1016208214608179588*r**16+3445370288652561452*r**18
            +6388040077830912682*r**20+5416666044057885550*r**22+2616605655885118910*r**24
            +713228967593880658*r**26+21280281716241812*r**28-7551776113204036*r**30
            -4082236357888360*r**32+1113219726774250*r**34+681128265878547*r**36-5754300458347*r**38
            -5345212195255*r**40+202014719125*r**42)+2*Q2**8*(38541286060+4284337859455*r**2
            +81455248632985*r**4-872575629995806*r**6-7095976985955584*r**8-126691829241212801*r**10
            -454193582652385389*r**12-1601611776405033576*r**14-3753825043937740024*r**16
            -3878793298719029106*r**18+3102985819584149434*r**20+6891127061455996588*r**22
            +6376854948305773392*r**24+4072741574851380646*r**26+1595638163943962054*r**28
            +360719590121284440*r**30+95632240274936556*r**32+25271444086047379*r**34
            +2234032423373309*r**36+187662497293186*r**38-14637485101808*r**40-1452585074885*r**42
            +72426385495*r**44)+Q2**7*(222915387770-2785215567195*r**2-108197470835080*r**4
            -1268399559892521*r**6-3670777548268638*r**8+104962672073016803*r**10
            +379452575338649276*r**12+4311386163975814761*r**14+8332212266271317460*r**16
            +20713299175949011138*r**18+12044947525790870208*r**20-2521603000230686602*r**22
            -14391842339404161292*r**24-18724275551279297802*r**26-11755647215481249112*r**28
            -3756178543846000190*r**30-943333404204731214*r**32-188945026872653559*r**34
            -56645719418543832*r**36-4283675933678013*r**38+1205205016093034*r**40
            +20794260439735*r**42-7655568368580*r**44+213773893445*r**46)-2*Q2**6*(46622576865
            +557664381345*r**2+567461956340*r**4-608045333279885*r**6-3109364997853472*r**8
            -25840673331429225*r**10-84621810181422232*r**12+659293093925010365*r**14
            -596924578740172723*r**16+6964590718383145658*r**18+2123838860207665112*r**20
            -4315358377621421522*r**22-8683762710982107528*r**24-13667865244742200194*r**26
            -10609555689491816320*r**28-5115033065263782134*r**30-1203631223667075365*r**32
            -336937098091305899*r**34-40307278726766828*r**36-5676696679283921*r**38
            -1131108016549368*r**40+333275476707899*r**42+3749875708472*r**44-1903651865495*r**46
            +52606460055*r**48)-3*Q2**5*(7300878554-354595309975*r**2-8765983782570*r**4
            +63073597827698*r**6+846944145271122*r**8+23024458584312684*r**10+79213113732192450*r**12
            +474796411057759030*r**14+1841390052232720080*r**16-1070241887030017651*r**18
            +3379896052910178140*r**20+3704975262817556340*r**22+97415202573539780*r**24
            +6596092126767172512*r**26+5427189852282935556*r**28+1566984295252687596*r**30
            +712684172442186970*r**32+130271035284247155*r**34+123051184363406894*r**36
            +15932364670433978*r**38-6283193114787318*r**40-521599664395660*r**42
            +59505883856730*r**44+2367163573566*r**46-330116905380*r**48+6869021719*r**50)
            +6*Q2**4*(3988120406-31741079225*r**2-1549373792405*r**4-31967773238048*r**6
            +38447318731108*r**8+3167727644886082*r**10+14593621098690170*r**12+233366694932549880*r**14
            +262797582529855122*r**16+560723927374372133*r**18+1076542227622742137*r**20
            +280310075078652640*r**22-2442509639221582760*r**24+2549774782724215372*r**26
            +5548704486978468028*r**28+3373645876682255312*r**30+318187020638944410*r**32
            +7553331907274625*r**34-11409086599425043*r**36+19671914720111488*r**38
            +5503228343065732*r**40-2046958255138670*r**42-400825128165590*r**44+42264826644472*r**46
            +1358315149118*r**48-208605414669*r**50+4449908175*r**52)-9*Q2**3*(344654186
            +10686523293*r**2+118265977172*r**4-11129007973187*r**6-36901945533908*r**8
            -867792564885514*r**10-912392773084664*r**12+25904816889385454*r**14-146125726773941442*r**16
            +683602571191673487*r**18-1185215243500604164*r**20+553979188755166871*r**22
            +197797139293789064*r**24+1761027602980034148*r**26+3472401378903188912*r**28
            +2431065877654672916*r**30+1879911821758984966*r**32+116820108286388139*r**34
            +6219743478990028*r**36+2483984042000347*r**38-10165886463774964*r**40
            -1898570951799354*r**42-6200175347896*r**44-57842188173922*r**46+4372422966162*r**48
            +140802310665*r**50-19178883612*r**52+404096817*r**54)-54*(-1+r**2)**2*(1835533
            -15963324*r**2-737027296*r**4-20369054976*r**6+211656114951*r**8+2834227574636*r**10
            +38795252650476*r**12+379490715048516*r**14-227600164667439*r**16+1542334734640296*r**18
            +22363507910223876*r**20-79728285393810964*r**22+38969505308618171*r**24
            +236745008355609816*r**26-185303523075014344*r**28-217942051506184024*r**30
            +104830235968928151*r**32+69248352098683476*r**34+41429980991750696*r**36
            +13526460927905496*r**38+1915834139601461*r**40+305500519602556*r**42
            +63022550834076*r**44-687575596204*r**46-997052340149*r**48+38409504768*r**50
            +2222164980*r**52-151960068*r**54+2326857*r**56)-18*Q2**2*(120424603
            -3283316313*r**2-85895435158*r**4+483872918055*r**6+14502169093971*r**8
            +368402086613138*r**10+1276349338276684*r**12+12836628132200634*r**14
            +37587377222520903*r**16-211881007941275859*r**18+962860589923039038*r**20
            -1235840963452104091*r**22-238849079115009921*r**24+833006835634544268*r**26
            -880951801863335224*r**28-121036730849433572*r**30+1519575692801314449*r**32
            +666036620977876689*r**34+525058910542447878*r**36+140625856374664641*r**38
            +14457016170270713*r**40+7503558172101954*r**42+2144824884622764*r**44
            -92217528376822*r**46-30283472553779*r**48+1825470632955*r**50+93330455442*r**52
            -8496633133*r**54+145455093*r**56)+27*Q2*(32243798-473020321*r**2-15141410502*r**4
            -179362861988*r**6+3479754017828*r**8+60401509180039*r**10+387447322887724*r**12
            +4450038477900304*r**14-1976260674007966*r**16-21570747613234621*r**18
            +306709424954721214*r**20-845944770232150836*r**22+458491079266997304*r**24
            +945857457806297419*r**26-566418678204266296*r**28-100039535586713856*r**30
            -1127878150130253126*r**32+614905871019444909*r**34+356520314030614294*r**36
            +261497846957484084*r**38+86873909684929924*r**40+10354643511274469*r**42
            +2264706824319564*r**44+734228947321584*r**46-6907355131186*r**48-12586284911119*r**50
            +549898087090*r**52+33127557796*r**54-2491303968*r**56+39986441*r**58))*sqrtq2))/(5040000*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2+5040000*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2+logq2**8*(487599243264000000*r**36*(1
            +r**2)**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+487599243264000000*r**36*(1
            +r**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2*(-725760000*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4
            -Q2**3*(1+r**2)-2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4
            +r**6)+4*(1-9*r**2-44*r**4-9*r**6+r**8))-725760000*(-Q2+(-1+r)**2)**3*r**8*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4-Q2**3*(1+r**2)
            -2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4+r**6)+4*(1-9*r**2
            -44*r**4-9*r**6+r**8))*sqrtq2)+logq2**7*(-10835538739200000*r**32*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))-10835538739200000*r**32*(1+r**2)*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))*sqrtq2)+logq2**3*(-174182400000*(-Q2+(-1
            +r)**2)**3*r**16*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8
            +68*Q2**7*(1+r**2)-Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2
            +683*r**4+169*r**6)+2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)
            +6*Q2**3*(31+230*r**2+159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(
            -131+1184*r**2+6523*r**4+8368*r**6+6523*r**8+1184*r**10-131*r**12)
            -9*Q2*(13+5*r**2-1493*r**4-5245*r**6-5245*r**8-1493*r**10+5*r**12
            +13*r**14)+36*(4-67*r**2-28*r**4+2331*r**6+5600*r**8+2331*r**10-28*r**12
            -67*r**14+4*r**16))-174182400000*(-Q2+(-1+r)**2)**3*r**16*(1-Q2+r**2)*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)
            -Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2+683*r**4+169*r**6)
            +2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)+6*Q2**3*(31+230*r**2
            +159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4
            +8368*r**6+6523*r**8+1184*r**10-131*r**12)-9*Q2*(13+5*r**2-1493*r**4
            -5245*r**6-5245*r**8-1493*r**10+5*r**12+13*r**14)+36*(4-67*r**2-28*r**4
            +2331*r**6+5600*r**8+2331*r**10-28*r**12-67*r**14+4*r**16))*sqrtq2)
            +logq2**2*(43545600000*(-Q2+(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8-4*Q2**7*(1+r**2)-Q2**6*(57
            +50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4+5*r**6)+Q2**4*(85-226*r**2
            -1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1-54*r**2-143*r**4-143*r**6
            -54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4+3168*r**6+2871*r**8
            +468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4-2833*r**6-2833*r**8
            -565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4+4368*r**6+11718*r**8
            +4368*r**10-56*r**12-96*r**14+5*r**16))+43545600000*(-Q2+(-1+r)**2)**3*r**12*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8-4*Q2**7*(1+r**2)
            -Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4+5*r**6)+Q2**4*(85
            -226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1-54*r**2-143*r**4
            -143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4+3168*r**6+2871*r**8
            +468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4-2833*r**6-2833*r**8
            -565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4+4368*r**6+11718*r**8
            +4368*r**10-56*r**12-96*r**14+5*r**16))*sqrtq2)+logq2**5*(-15049359360000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219+310*r**2
            +219*r**4)-Q2**5*(977+2179*r**2+2179*r**4+977*r**6)+Q2**4*(590-2090*r**2
            -6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4-2073*r**6
            +10*r**8+243*r**10)+Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6+41127*r**8
            +8076*r**10-879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6+67125*r**8
            +31341*r**10+3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4+12789*r**6
            +25830*r**8+12789*r**10+28*r**12-573*r**14+41*r**16))-15049359360000*r**24*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219
            +310*r**2+219*r**4)-Q2**5*(977+2179*r**2+2179*r**4+977*r**6)+Q2**4*(590
            -2090*r**2-6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4
            -2073*r**6+10*r**8+243*r**10)+Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6
            +41127*r**8+8076*r**10-879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6
            +67125*r**8+31341*r**10+3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4
            +12789*r**6+25830*r**8+12789*r**10+28*r**12-573*r**14+41*r**16))*sqrtq2)
            +logq2**4*(3135283200000*r**20*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(32*Q2**8
            +104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)-24*Q2**5*(13+31*r**2
            +31*r**4+13*r**6)+Q2**4*(415-1180*r**2-4598*r**4-1180*r**6+415*r**8)
            +4*Q2**3*(102+155*r**2-677*r**4-677*r**6+155*r**8+102*r**10)+Q2**2*(
            -389+3526*r**2+18377*r**4+25852*r**6+18377*r**8+3526*r**10-389*r**12)
            -12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8-1133*r**10-55*r**12
            +18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6+53690*r**8+24556*r**10
            -168*r**12-892*r**14+59*r**16))+3135283200000*r**20*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)
            -24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415-1180*r**2-4598*r**4
            -1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4-677*r**6+155*r**8
            +102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6+18377*r**8
            +3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8
            -1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6
            +53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))*sqrtq2)+logq2**6*(60197437440000*r**28*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(16*Q2**8+332*Q2**7*(1
            +r**2)+Q2**6*(153+370*r**2+153*r**4)-Q2**5*(2011+4817*r**2+4817*r**4
            +2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4-2410*r**6+295*r**8)+6*Q2**3*(559
            -310*r**2-4869*r**4-4869*r**6-310*r**8+559*r**10)-3*Q2**2*(479-4496*r**2
            -22867*r**4-35272*r**6-22867*r**8-4496*r**10+479*r**12)-9*Q2*(187
            -865*r**2-5807*r**4-10315*r**6-10315*r**8-5807*r**10-865*r**12+187*r**14)
            +9*(109-1432*r**2+392*r**4+26376*r**6+49910*r**8+26376*r**10+392*r**12
            -1432*r**14+109*r**16))+60197437440000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(16*Q2**8+332*Q2**7*(1+r**2)+Q2**6*(153+370*r**2+153*r**4)
            -Q2**5*(2011+4817*r**2+4817*r**4+2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4
            -2410*r**6+295*r**8)+6*Q2**3*(559-310*r**2-4869*r**4-4869*r**6-310*r**8
            +559*r**10)-3*Q2**2*(479-4496*r**2-22867*r**4-35272*r**6-22867*r**8
            -4496*r**10+479*r**12)-9*Q2*(187-865*r**2-5807*r**4-10315*r**6-10315*r**8
            -5807*r**10-865*r**12+187*r**14)+9*(109-1432*r**2+392*r**4+26376*r**6
            +49910*r**8+26376*r**10+392*r**12-1432*r**14+109*r**16))*sqrtq2))+((
            -64*(Q2-(-1+r)**2)**6*r**6*(1-Q2+r**2)*(Q2-(1+r)**2)**6*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))**2*(-92*Q2**23-8*Q2**22*(-27+38*r**2)
            +8*Q2**21*(-750-3106*r**2+2263*r**4)+Q2**20*(90307+2319874*r**2+436923*r**4
            -161844*r**6)+Q2**19*(-529530-26009832*r**2-37070252*r**4-3394248*r**6
            +753070*r**8)+2*Q2**18*(804459+63306788*r**2+188187114*r**4+120199736*r**6
            +7468795*r**8-1094236*r**10)+2*Q2**17*(-1273047-155283640*r**2-804603205*r**4
            -1026210060*r**6-420279873*r**8-20452188*r**10+2102453*r**12)+Q2**16*(979335
            +282514774*r**2+3168603525*r**4+6294518088*r**6+5538973789*r**8+1707939726*r**10
            +71196063*r**12-5340836*r**14)+16*Q2**15*(244767+28532654*r**2-54283484*r**4
            -163058133*r**6-389968210*r**8-462703826*r**10-116732166*r**12-4697443*r**14
            +266761*r**16)-8*Q2**14*(917845+198022028*r**2+1115518368*r**4+3815736256*r**6
            +6066462404*r**8+2299181454*r**10-297268748*r**12-53739982*r**14-5138553*r**16
            +262520*r**18)+8*Q2**13*(377181+178750844*r**2+2175503797*r**4+9215490714*r**6
            +23618686740*r**8+21048759634*r**10+7243636896*r**12+878211378*r**14
            +192911563*r**16-1890330*r**18+200271*r**20)-2*Q2**12*(-3113643-430141322*r**2
            +3562869865*r**4+17792957876*r**6+113212008074*r**8+146838647604*r**10
            +97296852842*r**12+32371998392*r**14+6198167001*r**16+885197126*r**18
            -22605531*r**20+1557972*r**22)+4*Q2**11*(-2307695-740857676*r**2-4661796046*r**4
            -27144868984*r**6-26426906213*r**8-46075096384*r**10-45618241500*r**12
            +5872679560*r**14+10465649351*r**16+3332010604*r**18+33883898*r**20-22402224*r**22
            +915421*r**24)+4*Q2**10*(502473+481093236*r**2+7200219626*r**4+45908902704*r**6
            +139858269507*r**8+279293727152*r**10+422202267804*r**12+221140404900*r**14
            +23832415055*r**16-9539621952*r**18-3101427654*r**20+244180556*r**22
            +16381989*r**24-386116*r**26)-4*Q2**9*(-1504215-292081736*r**2+2007918339*r**4
            +10025540440*r**6+123103343389*r**8+207881276544*r**10+670612292215*r**12
            +545834341336*r**14+211299808443*r**16+9022448224*r**18-7357400471*r**20
            -957898032*r**22+107217439*r**24-3203224*r**26+244285*r**28)+2*Q2**8*(
            -2985141-1241205866*r**2-8428309643*r**4-77801818920*r**6-44474313145*r**8
            -585158516654*r**10+506379154425*r**12+553175035580*r**14+457141408009*r**16
            +272696342730*r**18+13838827031*r**20+9472601248*r**22+5012144709*r**24
            -190302162*r**26-25006245*r**28+663724*r**30)-4*Q2**7*(-177399-255791192*r**2
            -4409269560*r**4-37462936116*r**6-115112855796*r**8-541673301656*r**10
            -363667583376*r**12-387497595972*r**14-163668677522*r**16+199458937560*r**18
            +161057364456*r**20+21177917188*r**22+12180999228*r**24+3064677784*r**26
            -82873248*r**28-4347660*r**30+27841*r**32)-16*Q2**6*(-149730-42843733*r**2
            +167131378*r**4-292134588*r**6+19822546813*r**8+22236406101*r**10+152795820112*r**12
            +14024659891*r**14+102681380421*r**16-54050046482*r**18-75543916718*r**20
            -26211956334*r**22-4281253865*r**24-1951492603*r**26-38885636*r**28-3558393*r**30
            -1358695*r**32+40861*r**34)+8*Q2**5*(-215041-109997722*r**2-724485546*r**4
            -10469249834*r**6+4545065698*r**8-211948170746*r**10+398079448962*r**12
            -739717004566*r**14+457151359924*r**16-226576404850*r**18+19565693378*r**20
            -63315078758*r**22+17404612902*r**24-5958322902*r**26-1936549938*r**28
            +927241894*r**30-19081147*r**32-2866980*r**34+56472*r**36)+Q2**4*(206055
            +253540362*r**2+3922285927*r**4+43804250556*r**6+81975972268*r**8+1371405694008*r**10
            -2868327265764*r**12+9140462483568*r**14-9010492510414*r**16+3451279402524*r**18
            +1980169912034*r**20-1358877850168*r**22+335812997628*r**24-236538144520*r**26
            +48221034828*r**28+10704353328*r**30-4664275905*r**32+60127402*r**34
            +5172303*r**36-42020*r**38)-2*Q2**3*(-161379-56649452*r**2+215781534*r**4
            -3061703828*r**6+37693450085*r**8-36176820704*r**10+75510941304*r**12
            +1072586340992*r**14-3093007425798*r**16+3212223861800*r**18-933350978844*r**20
            +1753621947128*r**22-207506898286*r**24+145552672000*r**26-24479664040*r**28
            +8067530976*r**30-1295305655*r**32+41879460*r**34+4433326*r**36-2030020*r**38
            +47401*r**40)+3*(-1+r**2)**2*(-1631-1227764*r**2-12329502*r**4-257264464*r**6
            +140675965*r**8-15556618764*r**10+97004481400*r**12-549681996064*r**14
            +1816866095682*r**16-3578998706280*r**18+3684688242508*r**20-1777385998656*r**22
            +488731506434*r**24-185951249272*r**26-24503220360*r**28-6010751200*r**30
            -945646307*r**32-399824868*r**34+19011554*r**36+134800*r**38-33663*r**40
            +452*r**42)+2*Q2**2*(-99877-54461164*r**2-250725550*r**4-7095698296*r**6
            +20092803255*r**8-292831584420*r**10+1241936826392*r**12-3883052232872*r**14
            +5971712508646*r**16-3882651021232*r**18+881012339500*r**20-594259178264*r**22
            -65976996906*r**24-412048807104*r**26-134950156776*r**28-7506941432*r**30
            -4768818817*r**32-5608431172*r**34+568828754*r**36+2254128*r**38-1635021*r**40
            +28228*r**42)-6*Q2*(-8315-5455800*r**2-37182913*r**4-893478740*r**6
            +2197724959*r**8-48875149396*r**10+290743160581*r**12-1311166908352*r**14
            +3548589699970*r**16-5422470035792*r**18+3902198155238*r**20-690610007368*r**22
            -307379628786*r**24+164724041880*r**26-175814942918*r**28-47806844128*r**30
            -5885326007*r**32-964530520*r**34-1127514485*r**36+74434876*r**38+510851*r**40
            -157156*r**42+2321*r**44))+64*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(92*Q2**23+8*Q2**22*(
            -27+38*r**2)-8*Q2**21*(-750-3106*r**2+2263*r**4)+Q2**20*(-90307-2319874*r**2
            -436923*r**4+161844*r**6)+Q2**19*(529530+26009832*r**2+37070252*r**4
            +3394248*r**6-753070*r**8)+2*Q2**18*(-804459-63306788*r**2-188187114*r**4
            -120199736*r**6-7468795*r**8+1094236*r**10)+Q2**17*(2546094+310567280*r**2
            +1609206410*r**4+2052420120*r**6+840559746*r**8+40904376*r**10-4204906*r**12)
            +Q2**16*(-979335-282514774*r**2-3168603525*r**4-6294518088*r**6-5538973789*r**8
            -1707939726*r**10-71196063*r**12+5340836*r**14)-16*Q2**15*(244767+28532654*r**2
            -54283484*r**4-163058133*r**6-389968210*r**8-462703826*r**10-116732166*r**12
            -4697443*r**14+266761*r**16)+8*Q2**14*(917845+198022028*r**2+1115518368*r**4
            +3815736256*r**6+6066462404*r**8+2299181454*r**10-297268748*r**12-53739982*r**14
            -5138553*r**16+262520*r**18)-8*Q2**13*(377181+178750844*r**2+2175503797*r**4
            +9215490714*r**6+23618686740*r**8+21048759634*r**10+7243636896*r**12
            +878211378*r**14+192911563*r**16-1890330*r**18+200271*r**20)+2*Q2**12*(
            -3113643-430141322*r**2+3562869865*r**4+17792957876*r**6+113212008074*r**8
            +146838647604*r**10+97296852842*r**12+32371998392*r**14+6198167001*r**16
            +885197126*r**18-22605531*r**20+1557972*r**22)-4*Q2**11*(-2307695-740857676*r**2
            -4661796046*r**4-27144868984*r**6-26426906213*r**8-46075096384*r**10
            -45618241500*r**12+5872679560*r**14+10465649351*r**16+3332010604*r**18
            +33883898*r**20-22402224*r**22+915421*r**24)+4*Q2**10*(-502473-481093236*r**2
            -7200219626*r**4-45908902704*r**6-139858269507*r**8-279293727152*r**10
            -422202267804*r**12-221140404900*r**14-23832415055*r**16+9539621952*r**18
            +3101427654*r**20-244180556*r**22-16381989*r**24+386116*r**26)+4*Q2**9*(
            -1504215-292081736*r**2+2007918339*r**4+10025540440*r**6+123103343389*r**8
            +207881276544*r**10+670612292215*r**12+545834341336*r**14+211299808443*r**16
            +9022448224*r**18-7357400471*r**20-957898032*r**22+107217439*r**24-3203224*r**26
            +244285*r**28)-2*Q2**8*(-2985141-1241205866*r**2-8428309643*r**4-77801818920*r**6
            -44474313145*r**8-585158516654*r**10+506379154425*r**12+553175035580*r**14
            +457141408009*r**16+272696342730*r**18+13838827031*r**20+9472601248*r**22
            +5012144709*r**24-190302162*r**26-25006245*r**28+663724*r**30)+4*Q2**7*(
            -177399-255791192*r**2-4409269560*r**4-37462936116*r**6-115112855796*r**8
            -541673301656*r**10-363667583376*r**12-387497595972*r**14-163668677522*r**16
            +199458937560*r**18+161057364456*r**20+21177917188*r**22+12180999228*r**24
            +3064677784*r**26-82873248*r**28-4347660*r**30+27841*r**32)+16*Q2**6*(
            -149730-42843733*r**2+167131378*r**4-292134588*r**6+19822546813*r**8
            +22236406101*r**10+152795820112*r**12+14024659891*r**14+102681380421*r**16
            -54050046482*r**18-75543916718*r**20-26211956334*r**22-4281253865*r**24
            -1951492603*r**26-38885636*r**28-3558393*r**30-1358695*r**32+40861*r**34)
            -8*Q2**5*(-215041-109997722*r**2-724485546*r**4-10469249834*r**6+4545065698*r**8
            -211948170746*r**10+398079448962*r**12-739717004566*r**14+457151359924*r**16
            -226576404850*r**18+19565693378*r**20-63315078758*r**22+17404612902*r**24
            -5958322902*r**26-1936549938*r**28+927241894*r**30-19081147*r**32-2866980*r**34
            +56472*r**36)+Q2**4*(-206055-253540362*r**2-3922285927*r**4-43804250556*r**6
            -81975972268*r**8-1371405694008*r**10+2868327265764*r**12-9140462483568*r**14
            +9010492510414*r**16-3451279402524*r**18-1980169912034*r**20+1358877850168*r**22
            -335812997628*r**24+236538144520*r**26-48221034828*r**28-10704353328*r**30
            +4664275905*r**32-60127402*r**34-5172303*r**36+42020*r**38)+2*Q2**3*(
            -161379-56649452*r**2+215781534*r**4-3061703828*r**6+37693450085*r**8
            -36176820704*r**10+75510941304*r**12+1072586340992*r**14-3093007425798*r**16
            +3212223861800*r**18-933350978844*r**20+1753621947128*r**22-207506898286*r**24
            +145552672000*r**26-24479664040*r**28+8067530976*r**30-1295305655*r**32
            +41879460*r**34+4433326*r**36-2030020*r**38+47401*r**40)-3*(-1+r**2)**2*(
            -1631-1227764*r**2-12329502*r**4-257264464*r**6+140675965*r**8-15556618764*r**10
            +97004481400*r**12-549681996064*r**14+1816866095682*r**16-3578998706280*r**18
            +3684688242508*r**20-1777385998656*r**22+488731506434*r**24-185951249272*r**26
            -24503220360*r**28-6010751200*r**30-945646307*r**32-399824868*r**34+19011554*r**36
            +134800*r**38-33663*r**40+452*r**42)-2*Q2**2*(-99877-54461164*r**2-250725550*r**4
            -7095698296*r**6+20092803255*r**8-292831584420*r**10+1241936826392*r**12
            -3883052232872*r**14+5971712508646*r**16-3882651021232*r**18+881012339500*r**20
            -594259178264*r**22-65976996906*r**24-412048807104*r**26-134950156776*r**28
            -7506941432*r**30-4768818817*r**32-5608431172*r**34+568828754*r**36+2254128*r**38
            -1635021*r**40+28228*r**42)+6*Q2*(-8315-5455800*r**2-37182913*r**4
            -893478740*r**6+2197724959*r**8-48875149396*r**10+290743160581*r**12
            -1311166908352*r**14+3548589699970*r**16-5422470035792*r**18+3902198155238*r**20
            -690610007368*r**22-307379628786*r**24+164724041880*r**26-175814942918*r**28
            -47806844128*r**30-5885326007*r**32-964530520*r**34-1127514485*r**36
            +74434876*r**38+510851*r**40-157156*r**42+2321*r**44))*sqrtq2+logq2**8*(81266540544000000*r**38*(1
            +r**2)**2*(1-Q2+r**2)*(1-10*r**2+9*r**4+4*r**6)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3+81266540544000000*(Q2-(-1+r)**2)**2*r**38*(1+r**2)**2*(1
            -10*r**2+9*r**4+4*r**6)*(Q2-(1+r)**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*sqrtq2)+logq2**7*(128994508800000*r**32*(1+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(140*Q2**9*(1+r**2)-20*Q2**8*(67+89*r**2+22*r**4)
            +20*Q2**7*(270+436*r**2+181*r**4+15*r**6)-2*Q2**6*(5936+10903*r**2
            +5549*r**4+2101*r**6+1071*r**8)+2*Q2**5*(7406+14654*r**2+9847*r**4
            +6805*r**6+8427*r**8+4221*r**10)-Q2**4*(8400+17711*r**2+19403*r**4
            +30434*r**6+35786*r**8+23851*r**10+6615*r**12)+Q2**3*(-2800-2661*r**2
            +5626*r**4+17313*r**6+39260*r**8+32633*r**10-11006*r**12-16205*r**14)
            +12*(-1+r**2)**2*(89+111*r**2+562*r**4-1279*r**6-3190*r**8+2641*r**10
            +2634*r**12+1103*r**14+689*r**16)+Q2**2*(7840+8469*r**2+9759*r**4-4819*r**6
            -39521*r**8+15427*r**10+22041*r**12+47339*r**14+37625*r**16)-3*Q2*(1616
            +625*r**2+4162*r**4-8118*r**6-39646*r**8+5224*r**10+52390*r**12+19358*r**14
            +8358*r**16+9791*r**18))-128994508800000*r**32*(1+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(140*Q2**10*(1+r**2)-20*Q2**9*(74+103*r**2+29*r**4)
            +20*Q2**8*(337+592*r**2+292*r**4+37*r**6)-2*Q2**7*(8636+17963*r**2
            +11719*r**4+4061*r**6+1221*r**8)+14*Q2**6*(1906+4499*r**2+3757*r**4
            +2065*r**6+1657*r**8+756*r**10)-Q2**5*(23212+61831*r**2+68405*r**4
            +63738*r**6+66250*r**8+49147*r**10+15057*r**12)+10*Q2**4*(560+2345*r**2
            +4274*r**4+6715*r**6+10548*r**8+9227*r**10+1946*r**12-959*r**14)+2*Q2**3*(5320
            +6965*r**2+3397*r**4-13879*r**6-48047*r**8-28233*r**10+207*r**12+37275*r**14
            +26915*r**16)-12*(-1+r**2)**2*(89+200*r**2+673*r**4-717*r**6-4469*r**8
            -549*r**10+5275*r**12+3737*r**14+1792*r**16+689*r**18)-2*Q2**2*(6344
            +9092*r**2+15357*r**4-9707*r**6-81639*r**8-4211*r**10+97319*r**12+63727*r**14
            +55019*r**16+33499*r**18)+3*Q2*(1972+1973*r**2+6503*r**4-13124*r**6
            -48044*r**8-3454*r**10+34262*r**12+65652*r**14+32184*r**16+17049*r**18
            +12547*r**20))*sqrtq2)+logq2**6*(716636160000*r**28*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-2240*Q2**13*(1+r**2)+960*Q2**12*(52
            +89*r**2+37*r**4)-30*Q2**11*(12968+31233*r**2+24682*r**4+6417*r**6)
            +4*Q2**10*(391572+1205415*r**2+1348784*r**4+649179*r**6+113342*r**8)
            -60*Q2**9*(60420+227384*r**2+323646*r**4+211993*r**6+60260*r**8+4949*r**10)
            -30*Q2**8*(-153120-717987*r**2-1235588*r**4-976242*r**6-316284*r**8
            +12189*r**10+22952*r**12)+5*Q2**7*(-329712-3010875*r**2-6433016*r**4
            -5424803*r**6-1164040*r**8+1332739*r**10+1117080*r**12+293251*r**14)
            -30*Q2**6*(133224+210847*r**2+203602*r**4+382565*r**6+590318*r**8+663089*r**10
            +428582*r**12+135051*r**14+28658*r**16)+3*Q2**5*(2170608+6862425*r**2
            +12635396*r**4+15704446*r**6+13476388*r**8+12524748*r**10+11715380*r**12
            +5295786*r**14+308836*r**16-80797*r**18)+40*Q2**4*(-83290-352309*r**2
            -686119*r**4-855065*r**6-1073523*r**8-1620940*r**10-1926581*r**12-1404705*r**14
            -516799*r**16-39445*r**18+21016*r**20)-15*Q2**3*(65824-103547*r**2-12196*r**4
            +251039*r**6-772544*r**8-3238530*r**10-5860432*r**12-4331630*r**14+159792*r**16
            +1027693*r**18+116196*r**20+91615*r**22)+18*(-1+r**2)**2*(9416+17537*r**2
            +72550*r**4+304225*r**6+356556*r**8-870170*r**10-1423996*r**12+226134*r**14
            +1361120*r**16+1680089*r**18+965974*r**20+110729*r**22+12236*r**24)
            +30*Q2**2*(69488+72687*r**2+301758*r**4+692035*r**6+730526*r**8-105966*r**10
            -1097768*r**12-710590*r**14+1228200*r**16+3389951*r**18+2185322*r**20
            +247227*r**22+53130*r**24)-45*Q2*(22112+15335*r**2+102380*r**4+302032*r**6
            +323476*r**8-1027685*r**10-2002752*r**12+588792*r**14+2142688*r**16
            +1148989*r**18+1535188*r**20+1209272*r**22+134828*r**24+21185*r**26))
            -716636160000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(2240*Q2**13*(1
            +r**2)-960*Q2**12*(52+89*r**2+37*r**4)+30*Q2**11*(12968+31233*r**2
            +24682*r**4+6417*r**6)-4*Q2**10*(391572+1205415*r**2+1348784*r**4+649179*r**6
            +113342*r**8)+60*Q2**9*(60420+227384*r**2+323646*r**4+211993*r**6+60260*r**8
            +4949*r**10)+30*Q2**8*(-153120-717987*r**2-1235588*r**4-976242*r**6
            -316284*r**8+12189*r**10+22952*r**12)-5*Q2**7*(-329712-3010875*r**2
            -6433016*r**4-5424803*r**6-1164040*r**8+1332739*r**10+1117080*r**12
            +293251*r**14)+30*Q2**6*(133224+210847*r**2+203602*r**4+382565*r**6
            +590318*r**8+663089*r**10+428582*r**12+135051*r**14+28658*r**16)+3*Q2**5*(
            -2170608-6862425*r**2-12635396*r**4-15704446*r**6-13476388*r**8-12524748*r**10
            -11715380*r**12-5295786*r**14-308836*r**16+80797*r**18)-40*Q2**4*(-83290
            -352309*r**2-686119*r**4-855065*r**6-1073523*r**8-1620940*r**10-1926581*r**12
            -1404705*r**14-516799*r**16-39445*r**18+21016*r**20)+15*Q2**3*(65824
            -103547*r**2-12196*r**4+251039*r**6-772544*r**8-3238530*r**10-5860432*r**12
            -4331630*r**14+159792*r**16+1027693*r**18+116196*r**20+91615*r**22)
            -18*(-1+r**2)**2*(9416+17537*r**2+72550*r**4+304225*r**6+356556*r**8
            -870170*r**10-1423996*r**12+226134*r**14+1361120*r**16+1680089*r**18
            +965974*r**20+110729*r**22+12236*r**24)-30*Q2**2*(69488+72687*r**2+301758*r**4
            +692035*r**6+730526*r**8-105966*r**10-1097768*r**12-710590*r**14+1228200*r**16
            +3389951*r**18+2185322*r**20+247227*r**22+53130*r**24)+45*Q2*(22112
            +15335*r**2+102380*r**4+302032*r**6+323476*r**8-1027685*r**10-2002752*r**12
            +588792*r**14+2142688*r**16+1148989*r**18+1535188*r**20+1209272*r**22
            +134828*r**24+21185*r**26))*sqrtq2)+logq2**5*(3981312000*r**24*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**4*(8960*Q2**17-320*Q2**16*(1643+1463*r**2)
            +20*Q2**15*(309595+510142*r**2+206371*r**4)-4*Q2**14*(8791773+21405007*r**2
            +16791399*r**4+4206069*r**6)+4*Q2**13*(29025297+96401795*r**2+114602324*r**4
            +57275907*r**6+9929121*r**8)-2*Q2**12*(114443946+514256423*r**2+841579880*r**4
            +648221114*r**6+236382150*r**8+31393143*r**10)+2*Q2**11*(114134424+790047712*r**2
            +1702677147*r**4+1783318988*r**6+1031483542*r**8+320499300*r**10+41341767*r**12)
            -Q2**10*(-43885668+960281185*r**2+2778892666*r**4+3391199627*r**6+2766726552*r**8
            +1672004275*r**10+636025962*r**12+113853561*r**14)+Q2**9*(-441548016
            -1116967819*r**2-3182788483*r**4-6968169543*r**6-6650238735*r**8-1917297501*r**10
            +743659811*r**12+625375167*r**14+149913327*r**16)-4*Q2**8*(-130190281
            -706205720*r**2-2624217627*r**4-6147810686*r**6-7283237873*r**8-3865039776*r**10
            -376882085*r**12+448551898*r**14+191045874*r**16+37467092*r**18)+4*Q2**7*(
            -31691249-538124757*r**2-2299935730*r**4-6654305176*r**6-9575466380*r**8
            -5875707346*r**10-159641692*r**12+1728704920*r**14+942091409*r**16+197166055*r**18
            +25707898*r**20)-2*Q2**6*(150816358+42555849*r**2+972731544*r**4-907945439*r**6
            -5358257936*r**8-2876932292*r**10+4792505128*r**12+6995439664*r**14+3826524466*r**16
            +1311815139*r**18+234535720*r**20+23345719*r**22)+6*Q2**5*(55531894+228435035*r**2
            +1708053527*r**4+3569663259*r**6+3492958329*r**8+2640144864*r**10+2989737624*r**12
            +3429826824*r**14+1972133754*r**16+257359829*r**18-6556175*r**20+23763949*r**22
            +699927*r**24)+6*Q2**4*(-15766482-162576563*r**2-1178392216*r**4-2873955976*r**6
            -3025888850*r**8-2419598451*r**10-3727388784*r**12-5963194608*r**14-5961521718*r**16
            -3056011665*r**18-448383832*r**20+129495832*r**22-6887366*r**24+4246679*r**26)
            -18*Q2**3*(3615684-9077130*r**2+23777753*r**4-144213396*r**6-76451598*r**8
            +54917902*r**10-725687805*r**12-2146126656*r**14-2576755128*r**16-1090259814*r**18
            -40667961*r**20-9487340*r**22+83565378*r**24+4240674*r**26+1857437*r**28)
            +108*(-1+r**2)**2*(25621+188012*r**2+2804026*r**4+1323621*r**6+8128987*r**8
            +34673986*r**10+20155536*r**12-55899997*r**14-99052917*r**16-28090504*r**18
            +126220530*r**20+126882827*r**22+26713221*r**24+4867546*r**26+397892*r**28
            +5613*r**30)+9*Q2**2*(7210492+15515711*r**2+337162070*r**4+137830473*r**6
            +362078440*r**8+1441690567*r**10+1022800058*r**12-925147575*r**14-2011048836*r**16
            +153088565*r**18+5119692490*r**20+4736742931*r**22+972734880*r**24+288662213*r**26
            +23480870*r**28+2242651*r**30)-27*Q2*(809736+3119233*r**2+57665453*r**4
            -19216123*r**6+78601433*r**8+418473413*r**10+8489017*r**12-963531111*r**14
            -344103179*r**16+442020339*r**18+61890951*r**20+1139183807*r**22+1455167083*r**24
            +296566727*r**26+68128403*r**28+6023075*r**30+215743*r**32))-3981312000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(8960*Q2**18-960*Q2**17*(557+497*r**2)
            +20*Q2**16*(335883+559838*r**2+229779*r**4)-16*Q2**15*(2584937+6375923*r**2
            +5093491*r**4+1309481*r**6)+60*Q2**14*(2521138+8439905*r**2+10186582*r**4
            +5218225*r**6+942346*r**8)-2*Q2**13*(172494540+765110607*r**2+1263588118*r**4
            +991977576*r**6+370792206*r**8+51251385*r**10)+2*Q2**12*(228578370+1418748081*r**2
            +3058513450*r**4+3273119982*r**6+1916086806*r**8+588274593*r**10+72734910*r**12)
            -3*Q2**11*(61461060+922881819*r**2+2588114128*r**4+3454397299*r**6+2798777204*r**8
            +1458656653*r**10+453236032*r**12+65512365*r**14)+2*Q2**10*(-242716842
            -100286151*r**2+278192684*r**4-399038625*r**6-246156278*r**8+1260716663*r**10
            +1525845024*r**12+687627345*r**14+131883444*r**16)-5*Q2**9*(-192461828
            -876667743*r**2-2959325362*r**4-6948440154*r**6-8550271954*r**8-4805539068*r**10
            -536233206*r**12+632648514*r**14+307894398*r**16+59956339*r**18)+12*Q2**8*(
            -53960510-458173586*r**2-1876786359*r**4-5142111163*r**6-7668838313*r**8
            -5674661665*r**10-1467187851*r**12+600124911*r**14+527229727*r**16+141893007*r**18
            +21058330*r**20)-2*Q2**7*(87433860-1097076163*r**2-4703389430*r**4-18816427251*r**6
            -37817801048*r**8-33779279744*r**10-7278192948*r**12+10133566120*r**14
            +9168117124*r**16+3590330067*r**18+680283626*r**20+74761515*r**22)+4*Q2**6*(158706020
            +439338656*r**2+3069723987*r**4+5386887941*r**6+2106335806*r**8-157377818*r**10
            +5442392854*r**12+11038712632*r**14+8369182696*r**16+2955209546*r**18
            +763341167*r**20+164586643*r**22+12722750*r**24)+12*Q2**5*(-35649188
            -223271746*r**2-1557440389*r**4-4075836381*r**6-5044255219*r**8-4276350822*r**10
            -4678635636*r**12-6191379528*r**14-5681741148*r**16-2642752624*r**18
            -349593743*r**20+56144029*r**22-15675621*r**24+1773376*r**26)-30*Q2**4*(
            -983886-41114887*r**2-253927104*r**4-896997676*r**6-1225839924*r**8
            -1056146719*r**10-1664810130*r**12-3225792672*r**14-3930996342*r**16
            -2457662565*r**18-725279876*r**20-69470004*r**22+74660920*r**24+2016267*r**26
            +1963798*r**28)+9*Q2**3*(14441860+4592819*r**2+366563316*r**4-103040813*r**6
            -79251548*r**8+1398623175*r**10-318739748*r**12-6668776497*r**14-11456812404*r**16
            -7180941319*r**18+2857836940*r**20+4636432329*r**22+1120890956*r**24
            +464274317*r**26+35677092*r**28+5957525*r**30)-108*(-1+r**2)**2*(25621
            +213633*r**2+2992038*r**4+4127647*r**6+9452608*r**8+42802973*r**10+54829522*r**12
            -35744461*r**14-154952914*r**16-127143421*r**18+98130026*r**20+253103357*r**22
            +153596048*r**24+31580767*r**26+5265438*r**28+403505*r**30+5613*r**32)
            -18*Q2**2*(4819850+16041951*r**2+262837070*r**4+208672087*r**6+367856606*r**8
            +1529594623*r**10+1244978838*r**12-1396470425*r**14-1984252974*r**16
            -265949627*r**18+2729226954*r**20+6636993421*r**22+5037489530*r**24+1075548637*r**26
            +258264146*r**28+21896373*r**30+1444940*r**32)+27*Q2*(912220+4476049*r**2
            +70599178*r**4+22063654*r**6+92528394*r**8+576033378*r**10+262708634*r**12
            -1201190426*r**14-1176023838*r**16+554378492*r**18+837305774*r**20+586479810*r**22
            +2191023278*r**24+2065029534*r**26+434199214*r**28+90460978*r**30+7785482*r**32
            +238195*r**34))*sqrtq2)+logq2**4*(-66355200*r**20*(1-Q2+r**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**4*(-565760*Q2**20+640*Q2**19*(17411+14000*r**2)
            -32*Q2**18*(2884608+4819831*r**2+1930287*r**4)+2*Q2**17*(212594224+557961767*r**2
            +464978014*r**4+123297511*r**6)-4*Q2**16*(293446112+1114994254*r**2+1451380425*r**4
            +801261304*r**6+158859293*r**8)+2*Q2**15*(917837568+5256865347*r**2+9616216660*r**4
            +8255822824*r**6+3460500640*r**8+559768137*r**10)-Q2**14*(887770080+13314468975*r**2
            +32827802976*r**4+38553309602*r**6+26362290364*r**8+9715749735*r**10
            +1433905020*r**12)+Q2**13*(-2388206592+2114336901*r**2+8651166006*r**4
            +6300149367*r**6+13971025764*r**8+19270891199*r**10+9296986686*r**12
            +1503555357*r**14)+Q2**12*(5195676096+22295006583*r**2+85125480540*r**4
            +206911606181*r**6+227724013338*r**8+102995493385*r**10+6676105424*r**12
            -7227200229*r**14-1476050886*r**16)+2*Q2**11*(-1660047008-18510552636*r**2
            -90746557773*r**4-282683987122*r**6-430437413689*r**8-330207814606*r**10
            -124297220107*r**12-15357769142*r**14+2891745609*r**16+608757898*r**18)
            +Q2**10*(-2301418208+20485419853*r**2+124318358694*r**4+626986159416*r**6
            +1310100448400*r**8+1376645316050*r**10+825033887996*r**12+284405248656*r**14
            +44007293072*r**16-3023242535*r**18-428366882*r**20)-Q2**9*(-5304695040
            -14911577975*r**2-110865286752*r**4-19066970219*r**6+330983070172*r**8
            +497946697150*r**10+521676313900*r**12+440303645238*r**14+230098173236*r**16
            +60434843497*r**18+2337424900*r**20+539018085*r**22)+Q2**8*(-2676784448
            -33575058301*r**2-282076605410*r**4-891129641329*r**6-1850554227828*r**8
            -2798064015514*r**10-2252169857724*r**12-568796406666*r**14+307193005136*r**16
            +256883895767*r**18+75863142670*r**20+6351998779*r**22+892921588*r**24)
            -2*Q2**7*(652616768-10296268391*r**2-85957159818*r**4-489053728796*r**6
            -1286050346982*r**8-2349460302139*r**10-2372710500208*r**12-888510977344*r**14
            +308314794440*r**16+417770881443*r**18+160154417242*r**20+32896739900*r**22
            +3110497438*r**24+246243647*r**26)+Q2**6*(2175905376+3468328467*r**2
            +74948151292*r**4-223661775954*r**6-457409973748*r**8-1523389016739*r**10
            -2464037902488*r**12-617568854220*r**14+1572021799992*r**16+1585552609149*r**18
            +781398683628*r**20+217760639966*r**22+33884426268*r**24+3967397587*r**26
            -74226576*r**28)+3*Q2**5*(-250585984-4435760071*r**2-55003514366*r**4
            -133907560017*r**6-606516424220*r**8-889720153987*r**10-448417300466*r**12
            -335739820965*r**14-666585329592*r**16-536985007445*r**18-120561486578*r**20
            -14739153043*r**22-18348244524*r**24-3084599521*r**26-536850590*r**28
            +101999369*r**30)-3*Q2**4*(88136000-2481822375*r**2-24489632408*r**4
            -128563152761*r**6-525227927262*r**8-843358754455*r**10-484640490060*r**12
            -297465313329*r**14-793211620218*r**16-1194245026301*r**18-817396409280*r**20
            -159570179155*r**22+43450830062*r**24-5717934021*r**26+491911588*r**28
            +149061885*r**30+63522090*r**32)+18*Q2**3*(15965472+5446194*r**2+993449991*r**4
            -6205274466*r**6-901330477*r**8-25178869010*r**10-6029694589*r**12+584659486*r**14
            -134835327913*r**16-267204914406*r**18-214624522971*r**20-90847479894*r**22
            -29006243175*r**24+10211983354*r**26+373329233*r**28+519310234*r**30
            +81231389*r**32+281548*r**34)+27*(-1+r**2)**2*(60992-4920533*r**2-61286916*r**4
            -285746368*r**6-2391244080*r**8+664245204*r**10-2774771296*r**12-19300104832*r**14
            -16453273296*r**16+35038694210*r**18+64333392216*r**20-19223086784*r**22
            -64329607888*r**24-19951493804*r**26-5282506880*r**28-720358912*r**30
            -59462512*r**32-1923989*r**34+195468*r**36)+9*Q2**2*(-8510112-219661961*r**2
            -3277357106*r**4-2550603780*r**6-67825492528*r**8+9975633288*r**10-19188477240*r**12
            -168788587460*r**14-13282328928*r**16+178979907406*r**18+83148209060*r**20
            -391306559212*r**22-510713038512*r**24-144377711504*r**26-59241847128*r**28
            -7515004236*r**30-1358631712*r**32-126724797*r**34+6386462*r**36)-27*Q2*(
            -59744-33181873*r**2-400844952*r**4-852195257*r**6-11752205524*r**8
            +12807931872*r**10-10627729036*r**12-53769147304*r**14+17881967196*r**16
            +38324096422*r**18+18509807188*r**20+89743779566*r**22-54578754236*r**24
            -178100665896*r**26-51458398372*r**28-16358754816*r**30-2275463532*r**32
            -258537133*r**34-15574668*r**36+1130099*r**38))+66355200*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(565760*Q2**20-640*Q2**19*(17411+14000*r**2)
            +32*Q2**18*(2884608+4819831*r**2+1930287*r**4)-2*Q2**17*(212594224+557961767*r**2
            +464978014*r**4+123297511*r**6)+4*Q2**16*(293446112+1114994254*r**2+1451380425*r**4
            +801261304*r**6+158859293*r**8)-2*Q2**15*(917837568+5256865347*r**2+9616216660*r**4
            +8255822824*r**6+3460500640*r**8+559768137*r**10)+Q2**14*(887770080+13314468975*r**2
            +32827802976*r**4+38553309602*r**6+26362290364*r**8+9715749735*r**10
            +1433905020*r**12)-Q2**13*(-2388206592+2114336901*r**2+8651166006*r**4
            +6300149367*r**6+13971025764*r**8+19270891199*r**10+9296986686*r**12
            +1503555357*r**14)+Q2**12*(-5195676096-22295006583*r**2-85125480540*r**4
            -206911606181*r**6-227724013338*r**8-102995493385*r**10-6676105424*r**12
            +7227200229*r**14+1476050886*r**16)+Q2**11*(3320094016+37021105272*r**2
            +181493115546*r**4+565367974244*r**6+860874827378*r**8+660415629212*r**10
            +248594440214*r**12+30715538284*r**14-5783491218*r**16-1217515796*r**18)
            +Q2**10*(2301418208-20485419853*r**2-124318358694*r**4-626986159416*r**6
            -1310100448400*r**8-1376645316050*r**10-825033887996*r**12-284405248656*r**14
            -44007293072*r**16+3023242535*r**18+428366882*r**20)+Q2**9*(-5304695040
            -14911577975*r**2-110865286752*r**4-19066970219*r**6+330983070172*r**8
            +497946697150*r**10+521676313900*r**12+440303645238*r**14+230098173236*r**16
            +60434843497*r**18+2337424900*r**20+539018085*r**22)+Q2**8*(2676784448
            +33575058301*r**2+282076605410*r**4+891129641329*r**6+1850554227828*r**8
            +2798064015514*r**10+2252169857724*r**12+568796406666*r**14-307193005136*r**16
            -256883895767*r**18-75863142670*r**20-6351998779*r**22-892921588*r**24)
            +2*Q2**7*(652616768-10296268391*r**2-85957159818*r**4-489053728796*r**6
            -1286050346982*r**8-2349460302139*r**10-2372710500208*r**12-888510977344*r**14
            +308314794440*r**16+417770881443*r**18+160154417242*r**20+32896739900*r**22
            +3110497438*r**24+246243647*r**26)+Q2**6*(-2175905376-3468328467*r**2
            -74948151292*r**4+223661775954*r**6+457409973748*r**8+1523389016739*r**10
            +2464037902488*r**12+617568854220*r**14-1572021799992*r**16-1585552609149*r**18
            -781398683628*r**20-217760639966*r**22-33884426268*r**24-3967397587*r**26
            +74226576*r**28)+3*Q2**5*(250585984+4435760071*r**2+55003514366*r**4
            +133907560017*r**6+606516424220*r**8+889720153987*r**10+448417300466*r**12
            +335739820965*r**14+666585329592*r**16+536985007445*r**18+120561486578*r**20
            +14739153043*r**22+18348244524*r**24+3084599521*r**26+536850590*r**28
            -101999369*r**30)+3*Q2**4*(88136000-2481822375*r**2-24489632408*r**4
            -128563152761*r**6-525227927262*r**8-843358754455*r**10-484640490060*r**12
            -297465313329*r**14-793211620218*r**16-1194245026301*r**18-817396409280*r**20
            -159570179155*r**22+43450830062*r**24-5717934021*r**26+491911588*r**28
            +149061885*r**30+63522090*r**32)-18*Q2**3*(15965472+5446194*r**2+993449991*r**4
            -6205274466*r**6-901330477*r**8-25178869010*r**10-6029694589*r**12+584659486*r**14
            -134835327913*r**16-267204914406*r**18-214624522971*r**20-90847479894*r**22
            -29006243175*r**24+10211983354*r**26+373329233*r**28+519310234*r**30
            +81231389*r**32+281548*r**34)-27*(-1+r**2)**2*(60992-4920533*r**2-61286916*r**4
            -285746368*r**6-2391244080*r**8+664245204*r**10-2774771296*r**12-19300104832*r**14
            -16453273296*r**16+35038694210*r**18+64333392216*r**20-19223086784*r**22
            -64329607888*r**24-19951493804*r**26-5282506880*r**28-720358912*r**30
            -59462512*r**32-1923989*r**34+195468*r**36)-9*Q2**2*(-8510112-219661961*r**2
            -3277357106*r**4-2550603780*r**6-67825492528*r**8+9975633288*r**10-19188477240*r**12
            -168788587460*r**14-13282328928*r**16+178979907406*r**18+83148209060*r**20
            -391306559212*r**22-510713038512*r**24-144377711504*r**26-59241847128*r**28
            -7515004236*r**30-1358631712*r**32-126724797*r**34+6386462*r**36)+27*Q2*(
            -59744-33181873*r**2-400844952*r**4-852195257*r**6-11752205524*r**8
            +12807931872*r**10-10627729036*r**12-53769147304*r**14+17881967196*r**16
            +38324096422*r**18+18509807188*r**20+89743779566*r**22-54578754236*r**24
            -178100665896*r**26-51458398372*r**28-16358754816*r**30-2275463532*r**32
            -258537133*r**34-15574668*r**36+1130099*r**38))*sqrtq2)+logq2**3*(1105920*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(5406720*Q2**23-128*Q2**22*(651909+572653*r**2)
            +4*Q2**21*(142474881+259561298*r**2+113140177*r**4)-12*Q2**20*(183467131
            +542790970*r**2+488627587*r**4+138193092*r**6)+20*Q2**19*(249419064+1153303376*r**2
            +1638897209*r**4+968212962*r**6+198020033*r**8)-10*Q2**18*(549038796
            +4738718869*r**2+9571955620*r**4+8925166374*r**6+4033108600*r**8+645647405*r**10)
            +6*Q2**17*(-381797072+7325898756*r**2+19769530815*r**4+24602159660*r**6
            +20381457350*r**8+8895759248*r**10+1258366731*r**12)+Q2**16*(16597985604
            +36106920487*r**2+133682678678*r**4+323022931965*r**6+228840182520*r**8
            -5066580211*r**10-42730905018*r**12-6980230937*r**14)+Q2**15*(-20593199472
            -163700919475*r**2-754135348029*r**4-2141909072499*r**6-2678541423045*r**8
            -1484930416717*r**10-290482058835*r**12+17357042531*r**14+5383987381*r**16)
            -15*Q2**14*(-55088624-12719477141*r**2-74076546884*r**4-304167998684*r**6
            -535863779052*r**8-464849939194*r**10-203550381804*r**12-37238567716*r**14
            -197588052*r**16+111709487*r**18)-5*Q2**13*(-5083757352+2825546771*r**2
            +40544392335*r**4+756423527940*r**6+2015359742244*r**8+2457134679886*r**10
            +1737551059158*r**12+689237215116*r**14+124478709300*r**16+4704624015*r**18
            +862987499*r**20)+Q2**12*(-25364302392-222535730429*r**2-1616063746270*r**4
            -2991779055225*r**6-3307334835000*r**8-4209029878118*r**10-762338685756*r**12
            +3315340913490*r**14+2474399765040*r**16+598091117955*r**18+54467910298*r**20
            +7223443271*r**22)-3*Q2**11*(455076752-83600404579*r**2-737699212681*r**4
            -3609500881545*r**6-9817210196795*r**8-19614178290402*r**10-21210877833446*r**12
            -10750637488934*r**14-1646027491810*r**16+534160912805*r**18+192065102927*r**20
            +23349997391*r**22+826483629*r**24)-Q2**10*(-20159766048+37434220885*r**2
            +493158190024*r**4+10219812832674*r**6+36907197545800*r**8+103787321911943*r**10
            +157002776498160*r**12+123673684156076*r**14+51135894028496*r**16+8637277593795*r**18
            -1079119299128*r**20-372794252750*r**22-42906610296*r**24+4435327969*r**26)
            +5*Q2**9*(-2504968512-31767850183*r**2-314342395387*r**4-18968453898*r**6
            +286663001702*r**8+9665839565847*r**10+25108801076355*r**12+27772383219940*r**14
            +18133959632644*r**16+7805233694775*r**18+1913722999643*r**20+44086599014*r**22
            +7276255446*r**24+1104672569*r**26+1001007901*r**28)-15*Q2**8*(217459768
            -9633726627*r**2-109693092630*r**4-637791374833*r**6-2929811872916*r**8
            -5901917172967*r**10-7027207849586*r**12-6611991460749*r**14-2681255156000*r**16
            +1525716948999*r**18+2050978317222*r**20+838406889565*r**22+120548982716*r**24
            +21557253827*r**26+2235110690*r**28+26457441*r**30)-Q2**7*(-7226749488
            +13141269289*r**2+246656684255*r**4+8857462451805*r**6+42076143073875*r**8
            +148346039046793*r**10+270056096789871*r**12+350288507814965*r**14+250506739769355*r**16
            +32500232420835*r**18-66577351671787*r**20-44970484696529*r**22-13426821698175*r**24
            -2110252710165*r**26-295111762915*r**28-27857617473*r**30+2238817489*r**32)
            +Q2**6*(-2206906896-56422882703*r**2-643236880452*r**4+1141775331960*r**6
            -1419989430780*r**8+64686330584696*r**10+109757133734508*r**12+186218683155392*r**14
            +180291967968820*r**16-16783884321990*r**18-131258666907724*r**20-99878153387112*r**22
            -38508305498868*r**24-7943577816480*r**26-1307177397980*r**28-107479213776*r**30
            -4590754868*r**32+1083184253*r**34)+3*Q2**5*(-408572964+12077606585*r**2
            +162015487937*r**4+1302149017712*r**6+9153315788720*r**8+12090974898184*r**10
            +49526194587480*r**12+51955866224168*r**14+8943651407808*r**16+23350593621130*r**18
            +39929183873194*r**20+15349979123680*r**22+3822219461248*r**24+2955389657968*r**26
            +724336340000*r**28+210439404936*r**30-10630851020*r**32-4014435003*r**34
            +154718237*r**36)-15*Q2**4*(-66114628+132646873*r**2+4879414242*r**4
            +199156933209*r**6+1065277782080*r**8+3473967907808*r**10+10681881759424*r**12
            +11837512502696*r**14+1494996395848*r**16+1744495174234*r**18+11786551184868*r**20
            +11682557324418*r**22+2503768930752*r**24-1113864139448*r**26+43526361712*r**28
            +25613953952*r**30+15258808060*r**32-4162324315*r**34-715058934*r**36
            +36957149*r**38)+45*Q2**3*(-2225200-158860833*r**2-1744245535*r**4+7374107521*r**6
            -32219726881*r**8+477109863200*r**10+72148405520*r**12+802975312696*r**14
            -428895347176*r**16+480140643302*r**18+5483565677322*r**20+6951410648914*r**22
            +4751134142558*r**24+2170154152024*r**26-122643016136*r**28+39212357296*r**30
            -17906770576*r**32-4770251069*r**34-755815219*r**36-31720635*r**38+1868907*r**40)
            +108*(-1+r**2)**2*(-52589+91712*r**2+15028805*r**4+498069125*r**6+2989589140*r**8
            +7952091331*r**10+76030504132*r**12-98022561740*r**14+28211855050*r**16
            +701665589180*r**18+155341209366*r**20-1488995333818*r**22-502103303060*r**24
            +1086228126650*r**26+432968623220*r**28+170362562756*r**30+32260730267*r**32
            +3787236620*r**34+456002925*r**36-5150915*r**38-2575864*r**40+67707*r**42)
            +9*Q2**2*(-13163368+373496099*r**2+5807067640*r**4+67224115730*r**6+539604685600*r**8
            -251495273853*r**10+7801774277024*r**12-4357811485800*r**14+389919174480*r**16
            +8737618068470*r**18-7625930915888*r**20-6738432665396*r**22+18907783987680*r**24
            +30604152210350*r**26+9868147961760*r**28+6131588377432*r**30+883443076824*r**32
            +220925934855*r**34+46009224440*r**36+916549170*r**38-306112448*r**40
            +10209199*r**42)-27*Q2*(-1762112+21000619*r**2+523339101*r**4+11753167030*r**6
            +67521648250*r**8+34266123983*r**10+1451482907889*r**12-2505080891784*r**14
            +1035379549960*r**16+5197474147750*r**18+434228781898*r**20-2373701792556*r**22
            -9932365442804*r**24-2350182166010*r**26+12010244796250*r**28+4275652706328*r**30
            +1984998850344*r**32+352002072431*r**34+51070077145*r**36+8962507750*r**38
            +23696778*r**40-60694421*r**42+1776181*r**44))-1105920*r**16*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**4*(5406720*Q2**24-128*Q2**23*(694149+614893*r**2)
            +4*Q2**22*(163335969+298747282*r**2+131465073*r**4)-4*Q2**21*(692876274
            +2030409089*r**2+1838584236*r**4+527719453*r**6)+4*Q2**20*(1797496713
            +7945291183*r**2+11288741716*r**4+6721526847*r**6+1404679441*r**8)-10*Q2**19*(1047876924
            +7544163749*r**2+15156356790*r**4+14139386716*r**6+6365574590*r**8+1041687471*r**10)
            +2*Q2**18*(1599802764+48416484593*r**2+130861964890*r**4+166292088950*r**6
            +125935746920*r**8+50081057769*r**10+7003337218*r**12)-Q2**17*(-18888768036
            +5557689617*r**2+28889898748*r**4-56792789115*r**6+41061519540*r**8+180729879799*r**10
            +103655660892*r**12+14530431323*r**14)+2*Q2**16*(-18595592538-108202912783*r**2
            -461962473597*r**4-1299307341571*r**6-1615202268765*r**8-854352009513*r**10
            -121342286803*r**12+33534089243*r**14+6182109159*r**16)+2*Q2**15*(10709764416
            +187543138031*r**2+1014492235382*r**4+3729282200394*r**6+6429203590662*r**8
            +5568110463836*r**10+2414334101306*r**12+415851766022*r**14-9888604566*r**16
            -3529814843*r**18)-10*Q2**14*(-2459245740+20574622033*r**2+150466232205*r**4
            +945578582322*r**6+2267727537726*r**8+2729637917312*r**10+1871376011076*r**12
            +705802031838*r**14+118393588302*r**16+2481129855*r**18+263929519*r**20)
            +2*Q2**13*(-25391544576-116913391667*r**2-699607025370*r**4+496530273075*r**6
            +5275790757960*r**8+9076721116266*r**10+10105545004732*r**12+7724641142430*r**14
            +3271489693560*r**16+622003892265*r**18+41152983934*r**20+5769190383*r**22)
            +2*Q2**12*(11999536068+249350623279*r**2+2025848557371*r**4+7718172723065*r**6
            +17875372240305*r**8+33179449792162*r**10+34302001032106*r**12+14849455119534*r**14
            -425829101550*r**16-2337486810705*r**18-614377168517*r**20-65870672871*r**22
            -4851447079*r**24)-2*Q2**11*(-10762498152+143435102183*r**2+1478528520902*r**4
            +11630706557676*r**6+38593665390410*r**8+96040743686767*r**10+139738972434852*r**12
            +109779115061608*r**14+44162944485364*r**16+5986438665405*r**18-1628898673162*r**20
            -509519776852*r**22-57718026678*r**24+977938541*r**26)+2*Q2**10*(-16342304304
            -70782398039*r**2-520559783013*r**4+5309064376604*r**6+24280162693492*r**8
            +94511858643489*r**10+193167051895939*r**12+209769188376968*r**14+132739688173896*r**16
            +49399670048083*r**18+8563386646441*r**20-615740278404*r**22-189659792908*r**24
            -16473959741*r**26+4720183737*r**28)-20*Q2**9*(-463147302-15793499644*r**2
            -168797380865*r**4-561671243446*r**6-2130435267736*r**8-1938312237838*r**10
            +3423254273361*r**12+8261302478512*r**14+9465644346146*r**16+7629086043604*r**18
            +3967972911521*r**20+1118257566838*r**22+103252450652*r**24+18263172374*r**26
            +2202753135*r**28+270095056*r**30)-2*Q2**8*(-5244323004+77192636087*r**2
            +1018279486555*r**4+10034864731875*r**6+47795095895055*r**8+140410987367519*r**10
            +231996486064083*r**12+277438248734995*r**14+194952719510295*r**16+24916652762925*r**18
            -60113890332551*r**20-44155631399167*r**22-13905579891195*r**24-2120923129155*r**26
            -325998615335*r**28-30890569719*r**30+920977937*r**32)+2*Q2**7*(-4716828192
            -25254181451*r**2-191719463454*r**4+5122947234010*r**6+24756808047450*r**8
            +127554256352682*r**10+264079634785586*r**12+403281643880114*r**14+390543607776570*r**16
            +133111543934100*r**18-82667893079338*r**20-105712994877714*r**22-48452805946786*r**24
            -11740326112410*r**26-1856270935530*r**28-215224297082*r**30-15104777426*r**32
            +1661000871*r**34)+2*Q2**6*(490594002+47431304677*r**2+592853113483*r**4
            +1703954300814*r**6+13869080732490*r**8-13496708229682*r**10-12932440278382*r**12
            -70054109108698*r**14-169839848450394*r**16-46728151391720*r**18+133915051424648*r**20
            +138593378832938*r**22+74926558634862*r**24+27659026144626*r**26+5711882117230*r**28
            +1022987413282*r**30+40088707792*r**32-4267867197*r**34-309514771*r**36)
            -6*Q2**5*(-369573052+6166133993*r**2+99245082866*r**4+1229974585847*r**6
            +7890926858416*r**8+19307065112972*r**10+57513289141392*r**12+80334811662564*r**14
            +34187249805608*r**16+20508360450054*r**18+61106266709332*r**20+56845974809482*r**22
            +15845521619344*r**24+604144210988*r**26+1948678903264*r**28+531422757348*r**30
            +138051297108*r**32-17728453799*r**34-3717505718*r**36+169751991*r**38)
            +30*Q2**4*(-36395114-205025127*r**2-110337745*r**4+113079335007*r**6
            +583887767323*r**8+2985287639744*r**10+7186147441896*r**12+12464160100104*r**14
            +6022911428508*r**16+2339956749994*r**18+14990871695534*r**20+22161670228014*r**22
            +14219864341422*r**24+3950183623688*r**26-719133413072*r**28+93388693776*r**30
            -6423774858*r**32-1607134731*r**34-3572414453*r**36-386631845*r**38+21281935*r**40)
            +72*Q2**3*(-254671+147365783*r**2+1915324935*r**4+4884350725*r**6+82979097800*r**8
            -309493244431*r**10+631935366678*r**12-1091678759610*r**14-185060081640*r**16
            +1060173948480*r**18-4680557814876*r**20-8614164287072*r**22-4950617496210*r**24
            -500286157820*r**26-46175964710*r**28+818592708954*r**30+97114392903*r**32
            +41788880385*r**34+9204944485*r**36+606778555*r**38-19606726*r**40+108083*r**42)
            -108*(-1+r**2)**2*(-52589+39123*r**2+15120517*r**4+513097930*r**6+3487658265*r**8
            +10941680471*r**10+83982595463*r**12-21992057608*r**14-69810706690*r**16
            +729877444230*r**18+857006798546*r**20-1333654124452*r**22-1991098636878*r**24
            +584124823590*r**26+1519196749870*r**28+603331185976*r**30+202623293023*r**32
            +36047966887*r**34+4243239545*r**36+450852010*r**38-7726779*r**40-2508157*r**42
            +67707*r**44)-18*Q2**2*(-9224852+211667294*r**2+3875290521*r**4+54145342230*r**6
            +404696873040*r**8+195453891848*r**10+5952363863419*r**12-2035639942064*r**14
            -430876830720*r**16+12359979843100*r**18+1207186749138*r**20-10742734479476*r**22
            -8813872503064*r**24+21230694850000*r**26+38251517280430*r**28+14413347229088*r**30
            +6485014002644*r**32+1080187614486*r**34+210072695365*r**36+36906648430*r**38
            +340763528*r**40-238993256*r**42+7768871*r**44)+27*Q2*(-1972468+20026067*r**2
            +603510888*r**4+14148919039*r**6+87308734060*r**8+111671700937*r**10
            +1738212674312*r**12-2022123898587*r**14-268551411176*r**16+8421730967070*r**18
            +752590473872*r**20-6331521664138*r**22-1781152939592*r**24-9876790013006*r**26
            +693698897680*r**28+17848511274442*r**30+6758668468572*r**32+2775514278143*r**34
            +503641189384*r**36+71512904315*r**38+10841120092*r**40-36723563*r**42
            -69763352*r**44+2047009*r**46))*sqrtq2)+logq2**2*(-18432*r**12*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(-11873792*Q2**26+64*Q2**25*(2826793
            +2775253*r**2)-256*Q2**24*(4641785+9869186*r**2+4563065*r**4)+2*Q2**23*(2137291720
            +7713101387*r**2+7577015262*r**4+2228642395*r**6)-4*Q2**22*(2106546340
            +12789002049*r**2+20074938242*r**4+12845067409*r**6+2736375340*r**8)
            +4*Q2**21*(1385087900+22559163081*r**2+50179642266*r**4+51792972201*r**6
            +26886424316*r**8+4518236480*r**10)-2*Q2**20*(-6949879840+18416358363*r**2
            +47081349480*r**4+51416883770*r**6+100186920060*r**8+69220649283*r**10
            +9993087380*r**12)+Q2**19*(-37615860160-196347770311*r**2-857272242180*r**4
            -2121590271475*r**6-1779093998800*r**8-358139557425*r**10+89794192364*r**12
            +12614964035*r**14)+2*Q2**18*(13430635120+223657674727*r**2+1249118503192*r**4
            +4333219646305*r**6+5947493829700*r**8+3525156672505*r**10+766062313792*r**12
            +14959339327*r**14+1248668020*r**16)-Q2**17*(-29831557440+304688000341*r**2
            +2461183216128*r**4+15074907013226*r**6+30249740879800*r**8+28287759847800*r**10
            +13168315616936*r**12+2529212052478*r**14+153633537456*r**16+17195956635*r**18)
            +2*Q2**16*(-35281935240-167126036423*r**2-872820591368*r**4+3133395976652*r**6
            +12584230499172*r**8+16820942397778*r**10+14160847814252*r**12+6673472227332*r**14
            +1286014358452*r**16+115837804197*r**18+8618711820*r**20)+8*Q2**15*(3860744220
            +104314380673*r**2+899770282885*r**4+3138028139880*r**6+6653001186765*r**8
            +11797068458856*r**10+9124966336791*r**12+1690021613910*r**14-764944808145*r**16
            -250828868885*r**18-29720883732*r**20+434565390*r**22)-8*Q2**14*(-5872637780
            +61171639562*r**2+777157685190*r**4+6455626350850*r**6+20948093456975*r**8
            +51791355671475*r**10+64335511020283*r**12+37862840557415*r**14+9202760778825*r**16
            +130404348475*r**18-156377422345*r**20-15912636513*r**22+2959992580*r**24)
            +4*Q2**13*(-15503942840-100455854439*r**2-641982237424*r**4+7657183715920*r**6
            +36359704639650*r**8+149810878163135*r**10+271145742752104*r**12+241519120936404*r**14
            +112584794036060*r**16+24320491919275*r**18+1203754776120*r**20+69382723676*r**22
            +21996499786*r**24+3911140285*r**26)+4*Q2**12*(1292794960+197646621081*r**2
            +2284197536448*r**4+7795209227136*r**6+24146284812240*r**8-25990017831075*r**10
            -161321457401316*r**12-220042670909568*r**14-176473368516456*r**16-86193763787325*r**18
            -21074258284560*r**20-2549039146704*r**22-537402623352*r**24-59181660329*r**26
            +2393783860*r**28)-2*Q2**11*(-18618814880+151288053453*r**2+2686824361788*r**4
            +33530729416093*r**6+158004272056508*r**8+460976947592949*r**10+758343884706952*r**12
            +1035604349086517*r**14+742057247394312*r**16+141054362960647*r**18-79477823636356*r**20
            -37979532204297*r**22-7926917989412*r**24-1098425163657*r**26-70011796992*r**28
            +7953262135*r**30)+4*Q2**10*(-5572706720-80821261679*r**2-715091574720*r**4
            +8777520267655*r**6+52732559049690*r**8+342796497407423*r**10+839601667652866*r**12
            +1653171713168145*r**14+1850872620644720*r**16+1031406856478935*r**18
            +234763873723596*r**20-22598929981567*r**22-15929187863870*r**24-3426210597095*r**26
            -51420412110*r**28+24864691111*r**30+1908820*r**32)+2*Q2**9*(-3676718080
            +191453671757*r**2+2644370235320*r**4+11271757037450*r**6+52215674569500*r**8
            -261230237672850*r**10-806940573883032*r**12-2922012325291590*r**14-4918887556014900*r**16
            -4009227473848200*r**18-1835823876193080*r**20-440697098411682*r**22+5464793355540*r**24
            +7643339197250*r**26+2016914711000*r**28-582793265890*r**30-92690468668*r**32
            +4920788555*r**34)-4*Q2**8*(-3028599560+14207563799*r**2+421047580464*r**4
            +10199419666150*r**6+60987676979100*r**8+200064478063590*r**10+659855469249596*r**12
            +718089238062766*r**14+43052079150420*r**16-273655980006500*r**18-429592113673580*r**20
            -459068554023534*r**22-228548310447004*r**24-41860674527910*r**26-9880127487900*r**28
            -1273827251750*r**30-185325615436*r**32-12908836851*r**34+954986140*r**36)
            -2*Q2**7*(995020280+67335231483*r**2+675428096914*r**4-7974982317817*r**6
            -56051088174460*r**8-590080274753100*r**10-1946902996862468*r**12-4805056900073964*r**14
            -6108211569403948*r**16-5988958955509870*r**18-2900115221665520*r**20
            +671240396559722*r**22+1308974990168236*r**24+576760484187412*r**26+124671804646500*r**28
            +24037729816340*r**30+3971317040388*r**32+5973376939*r**34-37616395522*r**36
            +1497252455*r**38)+4*Q2**6*(-711521380+20652429201*r**2+309382118526*r**4
            +2240215920561*r**6+12077339352986*r**8-106579108913038*r**10-155709404134226*r**12
            -1562777895945726*r**14-1890238943424786*r**16-2257070529030836*r**18
            -1337036568216134*r**20+841291432412524*r**22+1436101787245674*r**24+788939338781614*r**26
            +210037471372714*r**28+41524120256702*r**30+5070973002126*r**32+1019616795651*r**34
            -26734053264*r**36-14423648989*r**38+590800100*r**40)+12*Q2**5*(112652500
            +534172352*r**2-14215715470*r**4-943223380975*r**6-6234389978450*r**8
            -29727464297297*r**10-177829170790456*r**12-40503078029480*r**14-542175708385400*r**16
            -423217910102400*r**18+20175236058876*r**20-283186810548414*r**22-248628278043380*r**24
            -98988622897450*r**26-66858727970200*r**28-16799997949136*r**30-7181665926412*r**32
            -125253578920*r**34+117722948450*r**36+4776741925*r**38-667287818*r**40
            +21507555*r**42)-6*Q2**4*(-29331840+3780573661*r**2+32097585800*r**4
            -526649872750*r**6-4463934680100*r**8-68716435787675*r**10-237051350848244*r**12
            -458931096434840*r**14-1510702633107200*r**16-1026942362714150*r**18+651021977924240*r**20
            -336557151613284*r**22-1231491440200680*r**24-241979583510350*r**26+227716859684600*r**28
            +26448347998280*r**30+2759073234656*r**32-8450766644695*r**34-42935342200*r**36
            +475271119650*r**38+11284232620*r**40-3798818039*r**42+116552540*r**44)
            +9*Q2**3*(-27747840+687763761*r**2+10251895516*r**4+138846717405*r**6
            +563571762600*r**8-10370431643285*r**10+13809121911876*r**12-212525984917209*r**14
            -8056974830400*r**16-69779734735350*r**18+341725845115320*r**20-521386683937694*r**22
            -1469004564650544*r**24-1285289980603530*r**26-817032538592600*r**28-61838961232050*r**30
            -38338506758784*r**32+2874150146901*r**34+899967172140*r**36+145413702225*r**38
            +106023313480*r**40+2771304591*r**42-628597164*r**44+15440635*r**46)
            +54*(-1+r**2)**2*(-48728+3103167*r**2+18027662*r**4-532506323*r**6-8803572648*r**8
            -152102152263*r**10-351343078018*r**12-1053534835373*r**14-11943575305708*r**16
            +32763832346342*r**18-29659939950468*r**20-108004714181198*r**22+104978800122272*r**24
            +127161929170562*r**26-88252742982388*r**28-33802300641738*r**30-21458536439968*r**32
            -5875026911573*r**34-771453712458*r**36-137243076783*r**38-12380459928*r**40
            +1288358517*r**42+60078262*r**44-5446073*r**46+94852*r**48)+18*Q2**2*(2110480
            +91650503*r**2-422395576*r**4-63348727087*r**6-443141982040*r**8-3618011519575*r**10
            -21805931653652*r**12+45006274485279*r**14-308436227409612*r**16+252828345918790*r**18
            +59902166437520*r**20-62285272374262*r**22+123908796178544*r**24-335431492723342*r**26
            -555207479651080*r**28-138593697412610*r**30-174137437345032*r**32-24565986690621*r**34
            -6411532488632*r**36-2627573461675*r**38-256878656440*r**40+21097628693*r**42
            +1252816124*r**44-173120077*r**46+4385380*r**48)-27*Q2*(-374016+42665463*r**2
            +128789328*r**4-11546354642*r**6-108980124832*r**8-1576579259012*r**10
            -4042042719752*r**12+4787098387538*r**14-125294389583832*r**16+297038792538003*r**18
            -160558027323392*r**20-458699057562772*r**22+95224587979168*r**24+531370369560848*r**26
            +316234367502608*r**28-467400010500092*r**30-158459195729552*r**32-126476850246387*r**34
            -29477969791632*r**36-3945922150522*r**38-1117046088512*r**40-127001144012*r**42
            +12173724728*r**44+696069258*r**46-71724632*r**48+1460649*r**50))+18432*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(11873792*Q2**26-64*Q2**25*(2826793+2775253*r**2)
            +256*Q2**24*(4641785+9869186*r**2+4563065*r**4)-2*Q2**23*(2137291720
            +7713101387*r**2+7577015262*r**4+2228642395*r**6)+4*Q2**22*(2106546340
            +12789002049*r**2+20074938242*r**4+12845067409*r**6+2736375340*r**8)
            -4*Q2**21*(1385087900+22559163081*r**2+50179642266*r**4+51792972201*r**6
            +26886424316*r**8+4518236480*r**10)+2*Q2**20*(-6949879840+18416358363*r**2
            +47081349480*r**4+51416883770*r**6+100186920060*r**8+69220649283*r**10
            +9993087380*r**12)+Q2**19*(37615860160+196347770311*r**2+857272242180*r**4
            +2121590271475*r**6+1779093998800*r**8+358139557425*r**10-89794192364*r**12
            -12614964035*r**14)-2*Q2**18*(13430635120+223657674727*r**2+1249118503192*r**4
            +4333219646305*r**6+5947493829700*r**8+3525156672505*r**10+766062313792*r**12
            +14959339327*r**14+1248668020*r**16)+Q2**17*(-29831557440+304688000341*r**2
            +2461183216128*r**4+15074907013226*r**6+30249740879800*r**8+28287759847800*r**10
            +13168315616936*r**12+2529212052478*r**14+153633537456*r**16+17195956635*r**18)
            -2*Q2**16*(-35281935240-167126036423*r**2-872820591368*r**4+3133395976652*r**6
            +12584230499172*r**8+16820942397778*r**10+14160847814252*r**12+6673472227332*r**14
            +1286014358452*r**16+115837804197*r**18+8618711820*r**20)-8*Q2**15*(3860744220
            +104314380673*r**2+899770282885*r**4+3138028139880*r**6+6653001186765*r**8
            +11797068458856*r**10+9124966336791*r**12+1690021613910*r**14-764944808145*r**16
            -250828868885*r**18-29720883732*r**20+434565390*r**22)+8*Q2**14*(-5872637780
            +61171639562*r**2+777157685190*r**4+6455626350850*r**6+20948093456975*r**8
            +51791355671475*r**10+64335511020283*r**12+37862840557415*r**14+9202760778825*r**16
            +130404348475*r**18-156377422345*r**20-15912636513*r**22+2959992580*r**24)
            -4*Q2**13*(-15503942840-100455854439*r**2-641982237424*r**4+7657183715920*r**6
            +36359704639650*r**8+149810878163135*r**10+271145742752104*r**12+241519120936404*r**14
            +112584794036060*r**16+24320491919275*r**18+1203754776120*r**20+69382723676*r**22
            +21996499786*r**24+3911140285*r**26)-4*Q2**12*(1292794960+197646621081*r**2
            +2284197536448*r**4+7795209227136*r**6+24146284812240*r**8-25990017831075*r**10
            -161321457401316*r**12-220042670909568*r**14-176473368516456*r**16-86193763787325*r**18
            -21074258284560*r**20-2549039146704*r**22-537402623352*r**24-59181660329*r**26
            +2393783860*r**28)+2*Q2**11*(-18618814880+151288053453*r**2+2686824361788*r**4
            +33530729416093*r**6+158004272056508*r**8+460976947592949*r**10+758343884706952*r**12
            +1035604349086517*r**14+742057247394312*r**16+141054362960647*r**18-79477823636356*r**20
            -37979532204297*r**22-7926917989412*r**24-1098425163657*r**26-70011796992*r**28
            +7953262135*r**30)-4*Q2**10*(-5572706720-80821261679*r**2-715091574720*r**4
            +8777520267655*r**6+52732559049690*r**8+342796497407423*r**10+839601667652866*r**12
            +1653171713168145*r**14+1850872620644720*r**16+1031406856478935*r**18
            +234763873723596*r**20-22598929981567*r**22-15929187863870*r**24-3426210597095*r**26
            -51420412110*r**28+24864691111*r**30+1908820*r**32)-2*Q2**9*(-3676718080
            +191453671757*r**2+2644370235320*r**4+11271757037450*r**6+52215674569500*r**8
            -261230237672850*r**10-806940573883032*r**12-2922012325291590*r**14-4918887556014900*r**16
            -4009227473848200*r**18-1835823876193080*r**20-440697098411682*r**22+5464793355540*r**24
            +7643339197250*r**26+2016914711000*r**28-582793265890*r**30-92690468668*r**32
            +4920788555*r**34)+4*Q2**8*(-3028599560+14207563799*r**2+421047580464*r**4
            +10199419666150*r**6+60987676979100*r**8+200064478063590*r**10+659855469249596*r**12
            +718089238062766*r**14+43052079150420*r**16-273655980006500*r**18-429592113673580*r**20
            -459068554023534*r**22-228548310447004*r**24-41860674527910*r**26-9880127487900*r**28
            -1273827251750*r**30-185325615436*r**32-12908836851*r**34+954986140*r**36)
            +2*Q2**7*(995020280+67335231483*r**2+675428096914*r**4-7974982317817*r**6
            -56051088174460*r**8-590080274753100*r**10-1946902996862468*r**12-4805056900073964*r**14
            -6108211569403948*r**16-5988958955509870*r**18-2900115221665520*r**20
            +671240396559722*r**22+1308974990168236*r**24+576760484187412*r**26+124671804646500*r**28
            +24037729816340*r**30+3971317040388*r**32+5973376939*r**34-37616395522*r**36
            +1497252455*r**38)-4*Q2**6*(-711521380+20652429201*r**2+309382118526*r**4
            +2240215920561*r**6+12077339352986*r**8-106579108913038*r**10-155709404134226*r**12
            -1562777895945726*r**14-1890238943424786*r**16-2257070529030836*r**18
            -1337036568216134*r**20+841291432412524*r**22+1436101787245674*r**24+788939338781614*r**26
            +210037471372714*r**28+41524120256702*r**30+5070973002126*r**32+1019616795651*r**34
            -26734053264*r**36-14423648989*r**38+590800100*r**40)-12*Q2**5*(112652500
            +534172352*r**2-14215715470*r**4-943223380975*r**6-6234389978450*r**8
            -29727464297297*r**10-177829170790456*r**12-40503078029480*r**14-542175708385400*r**16
            -423217910102400*r**18+20175236058876*r**20-283186810548414*r**22-248628278043380*r**24
            -98988622897450*r**26-66858727970200*r**28-16799997949136*r**30-7181665926412*r**32
            -125253578920*r**34+117722948450*r**36+4776741925*r**38-667287818*r**40
            +21507555*r**42)+6*Q2**4*(-29331840+3780573661*r**2+32097585800*r**4
            -526649872750*r**6-4463934680100*r**8-68716435787675*r**10-237051350848244*r**12
            -458931096434840*r**14-1510702633107200*r**16-1026942362714150*r**18+651021977924240*r**20
            -336557151613284*r**22-1231491440200680*r**24-241979583510350*r**26+227716859684600*r**28
            +26448347998280*r**30+2759073234656*r**32-8450766644695*r**34-42935342200*r**36
            +475271119650*r**38+11284232620*r**40-3798818039*r**42+116552540*r**44)
            -9*Q2**3*(-27747840+687763761*r**2+10251895516*r**4+138846717405*r**6
            +563571762600*r**8-10370431643285*r**10+13809121911876*r**12-212525984917209*r**14
            -8056974830400*r**16-69779734735350*r**18+341725845115320*r**20-521386683937694*r**22
            -1469004564650544*r**24-1285289980603530*r**26-817032538592600*r**28-61838961232050*r**30
            -38338506758784*r**32+2874150146901*r**34+899967172140*r**36+145413702225*r**38
            +106023313480*r**40+2771304591*r**42-628597164*r**44+15440635*r**46)
            -54*(-1+r**2)**2*(-48728+3103167*r**2+18027662*r**4-532506323*r**6-8803572648*r**8
            -152102152263*r**10-351343078018*r**12-1053534835373*r**14-11943575305708*r**16
            +32763832346342*r**18-29659939950468*r**20-108004714181198*r**22+104978800122272*r**24
            +127161929170562*r**26-88252742982388*r**28-33802300641738*r**30-21458536439968*r**32
            -5875026911573*r**34-771453712458*r**36-137243076783*r**38-12380459928*r**40
            +1288358517*r**42+60078262*r**44-5446073*r**46+94852*r**48)-18*Q2**2*(2110480
            +91650503*r**2-422395576*r**4-63348727087*r**6-443141982040*r**8-3618011519575*r**10
            -21805931653652*r**12+45006274485279*r**14-308436227409612*r**16+252828345918790*r**18
            +59902166437520*r**20-62285272374262*r**22+123908796178544*r**24-335431492723342*r**26
            -555207479651080*r**28-138593697412610*r**30-174137437345032*r**32-24565986690621*r**34
            -6411532488632*r**36-2627573461675*r**38-256878656440*r**40+21097628693*r**42
            +1252816124*r**44-173120077*r**46+4385380*r**48)+27*Q2*(-374016+42665463*r**2
            +128789328*r**4-11546354642*r**6-108980124832*r**8-1576579259012*r**10
            -4042042719752*r**12+4787098387538*r**14-125294389583832*r**16+297038792538003*r**18
            -160558027323392*r**20-458699057562772*r**22+95224587979168*r**24+531370369560848*r**26
            +316234367502608*r**28-467400010500092*r**30-158459195729552*r**32-126476850246387*r**34
            -29477969791632*r**36-3945922150522*r**38-1117046088512*r**40-127001144012*r**42
            +12173724728*r**44+696069258*r**46-71724632*r**48+1460649*r**50))*sqrtq2)
            +logq2*(1536*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(109856*Q2**25-4*Q2**24*(413287+591439*r**2)
            +8*Q2**23*(1313164+4275625*r**2+2499625*r**4)-4*Q2**22*(8908142+50796507*r**2
            +65195971*r**4+23018054*r**6)+2*Q2**21*(31134356+306282455*r**2+613753823*r**4
            +513465481*r**6+128381933*r**8)-2*Q2**20*(8809414+395860843*r**2+884348711*r**4
            +1381858351*r**6+1137557783*r**8+217211482*r**10)+Q2**19*(-157363508
            -663445011*r**2-5768430985*r**4-10321687030*r**6-1548170510*r**8+2552626037*r**10
            +375535159*r**12)+Q2**18*(313268452+4052972470*r**2+29800701090*r**4
            +85719536260*r**6+79311267700*r**8+22624479282*r**10+27192310*r**12+35109700*r**14)
            -Q2**17*(129122228+5351536163*r**2+48940332209*r**4+228354349961*r**6
            +341357178755*r**8+222468373553*r**10+56988992483*r**12+4545227339*r**14
            +389213021*r**16)+4*Q2**16*(-95295387-139760040*r**2+1224371419*r**4
            +57831957743*r**6+131435321049*r**8+138288843403*r**10+81825923045*r**12
            +19753928889*r**14+1794247978*r**16+34211229*r**18)+4*Q2**15*(152550588
            +2455888401*r**2+26760108767*r**4+52593085552*r**6+94577246306*r**8+136776688880*r**10
            +2632335586*r**12-59693084428*r**14-17514993058*r**16-1452446269*r**18
            +119087979*r**20)-8*Q2**14*(15266136+1253859582*r**2+19504911290*r**4
            +111628664570*r**6+340408064185*r**8+730465308874*r**10+634695638453*r**12
            +195858898390*r**14+736460515*r**16-4193944260*r**18-214795219*r**20
            +70435452*r**22)-8*Q2**13*(67740716+235582095*r**2-2814271660*r**4-115989738065*r**6
            -467472057505*r**8-1582442149716*r**10-2127268677470*r**12-1314382744510*r**14
            -354788769030*r**16-28077558755*r**18-2706730654*r**20-352653265*r**22
            +3467675*r**24)+4*Q2**12*(133968398+2898228983*r**2+42793493639*r**4
            +34327680001*r**6+69100256945*r**8-2079612594028*r**10-4593608194598*r**12
            -4314730284154*r**14-2403958114276*r**16-668323153565*r**18-88681658617*r**20
            -16590782527*r**22-1121054051*r**24+105269546*r**26)-2*Q2**11*(-21384436
            +3662039165*r**2+90043485727*r**4+654936745694*r**6+3364155188722*r**8
            +6833785657951*r**10+9339177875825*r**12+11719277129908*r**14+4468030459816*r**16
            -1338120119917*r**18-996370391591*r**20-222974259170*r**22-26811334678*r**24
            -352591871*r**26+66334247*r**28)-4*Q2**10*(95917162+790502199*r**2+69916193*r**4
            -303909704422*r**6-1763817361616*r**8-8158377615357*r**10-16959888240589*r**12
            -30134787016898*r**14-25279568323758*r**16-8792445134419*r**18-202688900945*r**20
            +430964691894*r**22+110223412148*r**24-858291527*r**26-1122658531*r**28
            +65970706*r**30)+2*Q2**9*(98749396+3171477247*r**2+65045824485*r**4+5763368605*r**6
            +347010428995*r**8-10462136406701*r**10-21514495705807*r**12-71178329159135*r**14
            -89794349662745*r**16-52919512469275*r**18-15763459291961*r**20-97299274817*r**22
            +347519927585*r**24+96600266665*r**26-16206221565*r**28-2094721949*r**30
            +111024577*r**32)+4*Q2**8*(20512463-496951285*r**2-21828557020*r**4-229001741830*r**6
            -1741602783670*r**8-3064553548688*r**10-14472603624820*r**12-2937440821430*r**14
            +13820862847120*r**16+13323291993110*r**18+11811315534892*r**20+5930007090670*r**22
            +714430837430*r**24+307851743560*r**26+50227588580*r**28+3774470798*r**30
            -115933855*r**32+7795175*r**34)-4*Q2**7*(30021932+407595597*r**2+2724688831*r**4
            -174467873716*r**6-1167027505770*r**8-7196695333402*r**10-24348118978852*r**12
            -41894855569376*r**14-36875215008774*r**16-31140615995340*r**18-197430939482*r**20
            +13845159753468*r**22+7290854310554*r**24+1518808605586*r**26+447112437860*r**28
            +86971017752*r**30-639022038*r**32-647961209*r**34+26927579*r**36)+4*Q2**6*(5873638
            +358841875*r**2+10411894699*r**4+63350378*r**6+263745508834*r**8-3791577251808*r**10
            -3386785249090*r**12-36753081689644*r**14-21008603389738*r**16-31985587101834*r**18
            -2710965987068*r**20+22136127922880*r**22+17609894381686*r**24+4847085445352*r**26
            +1179033504306*r**28+176367308188*r**30+28667863660*r**32-543700241*r**34
            -208052767*r**36+6846694*r**38)+2*Q2**5*(12890636-73643863*r**2-9100050611*r**4
            -153748746721*r**6-1416288237293*r**8-2307652600180*r**10-32339167456292*r**12
            +29869307067916*r**14-87956532073084*r**16-4592701805722*r**18+10163920485150*r**20
            -36603989693502*r**22-5575836646934*r**24-8580316410964*r**26+463020222268*r**28
            -1331956191844*r**30-35151596968*r**32+67128883129*r**34+79110269*r**36
            -410447753*r**38+12974363*r**40)-2*Q2**4*(7632774+129975723*r**2+933802895*r**4
            -86853202565*r**6-552504876125*r**8-4684837550866*r**10-21717575718252*r**12
            +4492403210580*r**14-122301403378280*r**16+16699559844170*r**18+69032206619594*r**20
            -84391150401982*r**22-26254890462070*r**24+19185105610880*r**26+856037183860*r**28
            +2137549116564*r**30-891124406022*r**32-79179559405*r**34+64855469215*r**36
            +548949595*r**38-322319941*r**40+8459658*r**42)+3*Q2**3*(63204+37672935*r**2
            +1451407445*r**4-292186570*r**6+92622110230*r**8-1208461609461*r**10
            +2144476906545*r**12-13325945483320*r**14-2842555687040*r**16+15737612634670*r**18
            +19207977710954*r**20-66047326688540*r**22-40664617133420*r**24-48133260681810*r**26
            -1494375384630*r**28-2907634701816*r**30+135942467980*r**32-16303821205*r**34
            +3551748545*r**36+5901182230*r**38+122011494*r**40-6079545*r**42+21125*r**44)
            +36*(-1+r**2)**2*(2611+42086*r**2-68346*r**4-59894535*r**6-412923475*r**8
            -5302623474*r**10-20568778954*r**12+87064744999*r**14-928676143810*r**16
            +2961451199900*r**18-4242565307044*r**20-1296167605254*r**22+7339730948154*r**24
            -3762896724260*r**26+205164347500*r**28-656893644434*r**30-173058874849*r**32
            -22804196546*r**34-5694493410*r**36-913732675*r**38+54344841*r**40+2373846*r**42
            -196386*r**44+3515*r**46)+6*Q2**2*(394822-508663*r**2-257916669*r**4
            -6208331386*r**6-59090784830*r**8-89406298553*r**10-2667052606143*r**12
            +9811060328846*r**14-36150596356116*r**16+44626489698090*r**18-11528436895698*r**20
            -1050094199668*r**22-5615623096524*r**24-21683660577986*r**26-2505009630190*r**28
            -10894678005108*r**30-1676247309458*r**32-257061519939*r**34-191798573761*r**36
            -41366375570*r**38+4082125162*r**40+118023307*r**42-22886339*r**44+502374*r**46)
            -9*Q2*(91732+831755*r**2-23337079*r**4-1727032063*r**6-11754304269*r**8
            -85216402683*r**10-583455140945*r**12+3239221368071*r**14-19187361857183*r**16
            +49160523464286*r**18-51073660873718*r**20-15549281603270*r**22+40179876886286*r**24
            +17455258080602*r**26-22051849166994*r**28-185199662818*r**30-7530702999770*r**32
            -1836594226969*r**34-199509954403*r**36-81369457419*r**38-19351662513*r**40
            +1370849105*r**42+57024691*r**44-6234453*r**46+120021*r**48))-1536*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(878848*Q2**30-64*Q2**29*(232391+321467*r**2)
            +4*Q2**28*(27209929+83920314*r**2+48865585*r**4)-8*Q2**27*(55192708+290708655*r**2
            +367528642*r**4+129429271*r**6)+4*Q2**26*(254026684+2168048881*r**2+4353922566*r**4
            +3469158153*r**6+852884152*r**8)-2*Q2**25*(485128876+8477187741*r**2
            +22816250258*r**4+30472511672*r**6+19557347474*r**8+3563600635*r**10)
            +2*Q2**24*(-672995940+3305629695*r**2+1415733660*r**4+3855257506*r**6
            +40957668068*r**8+32407611135*r**10+4303500420*r**12)+Q2**23*(5457771420
            +49570814445*r**2+330408528840*r**4+920890070285*r**6+791731117244*r**8
            +136657285899*r**10-45793590920*r**12-2844502125*r**14)-2*Q2**22*(2900647590
            +59887472775*r**2+472227998630*r**4+1921558896381*r**6+2857674799516*r**8
            +1788134450697*r**10+406895831654*r**12+23882365075*r**14+3854181330*r**16)
            +Q2**21*(-2873060180+81323788905*r**2+937392697510*r**4+7018041898286*r**6
            +15614118841318*r**8+15861448206964*r**10+8036450289010*r**12+1698799904330*r**14
            +159151645270*r**16+9918014635*r**18)+2*Q2**20*(6892441520+62980199855*r**2
            +446023394190*r**4-1419760929778*r**6-6968789270958*r**8-10317195238704*r**10
            -9983686738762*r**12-5137620835326*r**14-1017266097426*r**16-88873980335*r**18
            +1706253740*r**20)-Q2**19*(10949199740+300658259805*r**2+3522020176680*r**4
            +14288484223783*r**6+32620114594544*r**8+64112720072938*r**10+49602642827056*r**12
            +5392783387790*r**14-5985506946332*r**16-1307525383671*r**18-67950277960*r**20
            +16671883355*r**22)+2*Q2**18*(-3627545170+76835885205*r**2+1582957724920*r**4
            +15562252688575*r**6+56813804192602*r**8+157417849114318*r**10+209370385627496*r**12
            +127232672724490*r**14+30957112207210*r**16+1728515014237*r**18+109885266592*r**20
            +43382393335*r**22+4746721550*r**24)+Q2**17*(18905264860+223930889725*r**2
            +1663033386750*r**4-19749776489232*r**6-116403340313962*r**8-525082946499267*r**10
            -1027321314004748*r**12-969894538758752*r**14-472767708897648*r**16-107415691274737*r**18
            -11907694834354*r**20-1669885229328*r**22-161413207490*r**24+9715904695*r**26)
            -4*Q2**16*(1943424785+91648955340*r**2+1474536643895*r**4+5812222492656*r**6
            +15018059643753*r**8-39120342815284*r**10-202239604670217*r**12-282608312090972*r**14
            -232396569356505*r**16-112242248440816*r**18-26408807356391*r**20-3934397200260*r**22
            -473507204545*r**24-19298897400*r**26+3355722905*r**28)-2*Q2**15*(5480373300
            -42308840865*r**2-1846977188120*r**4-27237018831877*r**6-139738619309132*r**8
            -455667766519577*r**10-750169801357496*r**12-1139174069862013*r**14-886923752918692*r**16
            -181458884708579*r**18+84282083699096*r**20+37817595756337*r**22+7516489514556*r**24
            +240925303581*r**26-52916249480*r**28+913752465*r**30)+4*Q2**14*(3265035810
            +59342625645*r**2+631080594030*r**4-7827792820337*r**6-60418093078196*r**8
            -409494627534639*r**10-1097112790200398*r**12-2418188831532665*r**14-2993831967804768*r**16
            -1843597051265249*r**18-502965347802014*r**20-21924042840963*r**22+9662327576500*r**24
            +2059403109283*r**26-290201715426*r**28-45617479315*r**30+2908967070*r**32)
            +2*Q2**13*(-126308580-108248933355*r**2-2482054911730*r**4-12282052849830*r**6
            -39814929255338*r**8+392787857270274*r**10+1691934723458862*r**12+6185929991601130*r**14
            +11294663959610670*r**16+10324607570166348*r**18+5119553987119210*r**20
            +1256129460309582*r**22+107668738410210*r**24+11119446696190*r**26+2511496838682*r**28
            +630396779822*r**30+23873468350*r**32-2162376225*r**34)-4*Q2**12*(1908939215
            +4141754775*r**2-410296438355*r**4-12224821656862*r**6-77681260215182*r**8
            -281620707896210*r**10-645069669630718*r**12-37734867954314*r**14+2622592319363620*r**16
            +3881308883736712*r**18+3280168632000568*r**20+1783375120577278*r**22
            +509255838909206*r**24+90741156142426*r**26+20835214323718*r**28+3702468882346*r**30
            +42320877317*r**32-28634411495*r**34+1307863955*r**36)+2*Q2**11*(1917976820
            +62598306455*r**2+998196059520*r**4-10082239921607*r**6-94888307971776*r**8
            -1006992887484396*r**10-3539713102409392*r**12-10483692754628092*r**14
            -15259036457204184*r**16-19636688881471358*r**18-14824845018119600*r**20
            -3649067445292362*r**22+1361638268842208*r**24+846690875223812*r**26+247850637824880*r**28
            +38407928473732*r**30+4614430646340*r**32-244156950705*r**34-47827829520*r**36
            +2226622985*r**38)+8*Q2**10*(228167045-6875639985*r**2-250409429855*r**4
            -2207729724592*r**6-9014298449927*r**8+113152461985892*r**10+521761802503956*r**12
            +3304992942749338*r**14+6949491389056956*r**16+12968257533107858*r**18
            +14881970995801810*r**20+8790333273411722*r**22+2308801854930336*r**24
            -130437126149420*r**26-156488736616356*r**28-50441761193602*r**30-2112847595633*r**32
            +643051925351*r**34+41572341661*r**36-3519562610*r**38+112530455*r**40)
            -8*Q2**9*(287777140+3141684780*r**2-18810282315*r**4-2863007420109*r**6
            -19478825793707*r**8-94942457853887*r**10-299739893128124*r**12+800578457224970*r**14
            +2152954806265664*r**16+8804781756310412*r**18+16456419043639394*r**20
            +14061342577776528*r**22+7079692890245150*r**24+2000728476805094*r**26
            +87989507280092*r**28-7904731448362*r**30-10864529689364*r**32+2264281293520*r**34
            +1240411094601*r**36+6441324253*r**38-8413490835*r**40+283479505*r**42)
            +2*Q2**8*(109648040+14872572815*r**2+348262078920*r**4-2434829808510*r**6
            -31121642185368*r**8-589466894588925*r**10-2389315510904872*r**12-9228208841638080*r**14
            -23078686858728600*r**16-30355418329960442*r**18-7151230893296888*r**20
            +5095568644984404*r**22+13232097701069480*r**24+15701984181815590*r**26
            +8043145943374248*r**28+1935526471261456*r**30+504796360328208*r**32+99772133057355*r**34
            +9087730963920*r**36+1297098425562*r**38-31866793008*r**40-7167850505*r**42
            +217311200*r**44)+Q2**7*(634183180-4235752575*r**2-354242976120*r**4
            -6836947289687*r**6-23287214784692*r**8+410186049023947*r**10+2061239394406232*r**12
            +21766373135593819*r**14+49209088511335384*r**16+133253748606404842*r**18
            +135427533237420752*r**20+120408101641280858*r**22+55116875568500792*r**24
            -28042946039971082*r**26-42907869210016208*r**28-18773828033984330*r**30
            -4940235092558692*r**32-953920850039131*r**34-231044277815000*r**36-16395945295667*r**38
            +3422449748476*r**40+97189665327*r**42-22337021960*r**44+605781535*r**46)
            +2*Q2**6*(-132638910-2958938115*r**2-24687801350*r**4+2459265925423*r**6
            +15686451858164*r**8+141362016351535*r**10+419231535186962*r**12-2591516254710083*r**14
            +1626583470060018*r**16-38230825976646430*r**18-24419465649417068*r**20
            -29551177783413674*r**22-27047758140807864*r**24+15058440174389790*r**26
            +29218027111045588*r**28+19676728787105146*r**30+5846093938360022*r**32
            +1619030718820977*r**34+196271618345074*r**36+32823313987883*r**38+5016000579172*r**40
            -1134968268445*r**42-27163891430*r**44+6318961945*r**46-152604330*r**48)
            -3*Q2**5*(20770636-976196255*r**2-33622718090*r**4+53346671782*r**6+3644726544102*r**8
            +105650346701584*r**10+433681311021642*r**12+2674264204286426*r**14+9935569847040150*r**16
            +2079110968328809*r**18+30989970714738556*r**20+20893179225173404*r**22
            -9998525338228868*r**24+14374806166381608*r**26+11006776065153076*r**28
            +2046261457717908*r**30+2489166226282136*r**32+537839934479043*r**34+521229175109806*r**36
            +64844149734238*r**38-18317650371650*r**40-1430110538552*r**42+131470470114*r**44
            +6178887154*r**46-885917850*r**48+19999091*r**50)+6*Q2**4*(11346004+8474473*r**2
            -4398852130*r**4-175527315438*r**6-30272035994*r**8+12890979042188*r**10
            +86285994363386*r**12+1149251532818910*r**14+1983325805169342*r**16+6247851023234341*r**18
            +12268073068081108*r**20+8557166895800756*r**22-8676495434921700*r**24
            +9096334395624352*r**26+16627373209982516*r**28+7491781963821308*r**30
            -1008945011289264*r**32+148705928145315*r**34-93249813317978*r**36+91214839435546*r**38
            +22344974379038*r**40-7554099724524*r**42-1472473352270*r**44+123638897222*r**46
            +5585267966*r**48-660241521*r**50+13167048*r**52)-9*Q2**3*(980524+45591809*r**2
            +746030600*r**4-41999068805*r**6-215914268496*r**8-4363178917738*r**10
            -4256269592272*r**12+96289683372370*r**14-513134455592660*r**16+3382558140892179*r**18
            -4870023483537208*r**20+4927973450726593*r**22-2134809714552320*r**24
            +3653390136645060*r**26+10198112676199264*r**28+6861228331988012*r**30
            +6269975027520388*r**32-652558679215785*r**34+220044705253080*r**36-39206124681331*r**38
            -43286457131568*r**40-7050294248762*r**42-699441661200*r**44-272936363550*r**46
            +14732190884*r**48+842484853*r**50-68265256*r**52+1221335*r**54)-108*(
            -1+r**2)**2*(2611+8143*r**2-897452*r**4-63833313*r**6+368507617*r**8
            +6540828342*r**10+99430601872*r**12+972516502502*r**14+738901744067*r**16
            +7921197918257*r**18+48414691668772*r**20-166834935135343*r**22+174710088002537*r**24
            +459576213735412*r**26-545467219078848*r**28-377014512781228*r**30+295888985261617*r**32
            +107271113608897*r**34+83495598902492*r**36+29971108117457*r**38+4682663113467*r**40
            +836379988342*r**42+144007047472*r**44+60969702*r**46-1855426983*r**48
            +44314911*r**50+4547244*r**52-242081*r**54+3515*r**56)-18*Q2**2*(342602
            -6782805*r**2-303633672*r**4-1605544807*r**6+64910773294*r**8+1705293995382*r**10
            +7280262195336*r**12+70088243146586*r**14+207713800594922*r**16-641012826998051*r**18
            +4476660514468032*r**20-6311642360662409*r**22+1962746393364366*r**24
            +4041879597532052*r**26-4448253827381936*r**28+699593297982892*r**30+6043587886216686*r**32
            +1452610413137781*r**34+2353092877397432*r**36+542300747228599*r**38+91571445433082*r**40
            +38674857915286*r**42+8806390850856*r**44-117795589798*r**46-95735071906*r**48
            +4451393635*r**50+319136656*r**52-25872167*r**54+432074*r**56)+27*Q2*(91732
            -402537*r**2-45398742*r**4-1531646728*r**6+14124530530*r**8+278510479611*r**10
            +2138631212916*r**12+22796678427616*r**14+12164977037696*r**16-4385559776149*r**18
            +1282809951628486*r**20-3848796235488744*r**22+3655827213387206*r**24
            +3195275475049871*r**26-3681122832950504*r**28-434506217442944*r**30-3993838984867644*r**32
            +3439334326480981*r**34+856125070969366*r**36+1071203208594856*r**38+362531939593326*r**40
            +52674998835041*r**42+12928788740916*r**44+3153459775136*r**46+18121987496*r**48
            -44244562711*r**50+1304092218*r**52+127352648*r**54-7850966*r**56+120021*r**58))*sqrtq2))*math.log(mu0))/(70000*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2+70000*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2+logq2**8*(6772211712000000*r**36*(1
            +r**2)**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+6772211712000000*r**36*(1
            +r**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2*(-10080000*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4
            -Q2**3*(1+r**2)-2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4
            +r**6)+4*(1-9*r**2-44*r**4-9*r**6+r**8))-10080000*(-Q2+(-1+r)**2)**3*r**8*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4-Q2**3*(1+r**2)
            -2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4+r**6)+4*(1-9*r**2
            -44*r**4-9*r**6+r**8))*sqrtq2)+logq2**7*(-150493593600000*r**32*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))-150493593600000*r**32*(1+r**2)*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))*sqrtq2)+logq2**3*(-2419200000*(-Q2+(-1+r)**2)**3*r**16*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)
            -Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2+683*r**4+169*r**6)
            +2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)+6*Q2**3*(31+230*r**2
            +159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4
            +8368*r**6+6523*r**8+1184*r**10-131*r**12)-9*Q2*(13+5*r**2-1493*r**4
            -5245*r**6-5245*r**8-1493*r**10+5*r**12+13*r**14)+36*(4-67*r**2-28*r**4
            +2331*r**6+5600*r**8+2331*r**10-28*r**12-67*r**14+4*r**16))-2419200000*(
            -Q2+(-1+r)**2)**3*r**16*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)-Q2**6*(333+410*r**2+333*r**4)
            -Q2**5*(169+683*r**2+683*r**4+169*r**6)+2*Q2**4*(275-725*r**2-3408*r**4
            -725*r**6+275*r**8)+6*Q2**3*(31+230*r**2+159*r**4+159*r**6+230*r**8
            +31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4+8368*r**6+6523*r**8+1184*r**10
            -131*r**12)-9*Q2*(13+5*r**2-1493*r**4-5245*r**6-5245*r**8-1493*r**10
            +5*r**12+13*r**14)+36*(4-67*r**2-28*r**4+2331*r**6+5600*r**8+2331*r**10
            -28*r**12-67*r**14+4*r**16))*sqrtq2)+logq2**2*(604800000*(-Q2+(-1+r)**2)**3*r**12*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8
            -4*Q2**7*(1+r**2)-Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4
            +5*r**6)+Q2**4*(85-226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1
            -54*r**2-143*r**4-143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4
            +3168*r**6+2871*r**8+468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4
            -2833*r**6-2833*r**8-565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4
            +4368*r**6+11718*r**8+4368*r**10-56*r**12-96*r**14+5*r**16))+604800000*(
            -Q2+(-1+r)**2)**3*r**12*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8
            -4*Q2**7*(1+r**2)-Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4
            +5*r**6)+Q2**4*(85-226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1
            -54*r**2-143*r**4-143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4
            +3168*r**6+2871*r**8+468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4
            -2833*r**6-2833*r**8-565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4
            +4368*r**6+11718*r**8+4368*r**10-56*r**12-96*r**14+5*r**16))*sqrtq2)
            +logq2**5*(-209018880000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1
            +r**2)-Q2**6*(219+310*r**2+219*r**4)-Q2**5*(977+2179*r**2+2179*r**4
            +977*r**6)+Q2**4*(590-2090*r**2-6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243
            +10*r**2-2073*r**4-2073*r**6+10*r**8+243*r**10)+Q2**2*(-879+8076*r**2
            +41127*r**4+61272*r**6+41127*r**8+8076*r**10-879*r**12)+Q2*(-741+3075*r**2
            +31341*r**4+67125*r**6+67125*r**8+31341*r**10+3075*r**12-741*r**14)
            +12*(41-573*r**2+28*r**4+12789*r**6+25830*r**8+12789*r**10+28*r**12
            -573*r**14+41*r**16))-209018880000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)-Q2**5*(977
            +2179*r**2+2179*r**4+977*r**6)+Q2**4*(590-2090*r**2-6768*r**4-2090*r**6
            +590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4-2073*r**6+10*r**8+243*r**10)
            +Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6+41127*r**8+8076*r**10
            -879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6+67125*r**8+31341*r**10
            +3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4+12789*r**6+25830*r**8
            +12789*r**10+28*r**12-573*r**14+41*r**16))*sqrtq2)+logq2**4*(43545600000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219
            +310*r**2+219*r**4)-24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415
            -1180*r**2-4598*r**4-1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4
            -677*r**6+155*r**8+102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6
            +18377*r**8+3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6
            -3030*r**8-1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4
            +24556*r**6+53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))+43545600000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2
            +219*r**4)-24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415-1180*r**2
            -4598*r**4-1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4-677*r**6
            +155*r**8+102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6+18377*r**8
            +3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8
            -1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6
            +53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))*sqrtq2)+logq2**6*(836075520000*r**28*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(16*Q2**8+332*Q2**7*(1
            +r**2)+Q2**6*(153+370*r**2+153*r**4)-Q2**5*(2011+4817*r**2+4817*r**4
            +2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4-2410*r**6+295*r**8)+6*Q2**3*(559
            -310*r**2-4869*r**4-4869*r**6-310*r**8+559*r**10)-3*Q2**2*(479-4496*r**2
            -22867*r**4-35272*r**6-22867*r**8-4496*r**10+479*r**12)-9*Q2*(187
            -865*r**2-5807*r**4-10315*r**6-10315*r**8-5807*r**10-865*r**12+187*r**14)
            +9*(109-1432*r**2+392*r**4+26376*r**6+49910*r**8+26376*r**10+392*r**12
            -1432*r**14+109*r**16))+836075520000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(16*Q2**8+332*Q2**7*(1+r**2)+Q2**6*(153+370*r**2+153*r**4)
            -Q2**5*(2011+4817*r**2+4817*r**4+2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4
            -2410*r**6+295*r**8)+6*Q2**3*(559-310*r**2-4869*r**4-4869*r**6-310*r**8
            +559*r**10)-3*Q2**2*(479-4496*r**2-22867*r**4-35272*r**6-22867*r**8
            -4496*r**10+479*r**12)-9*Q2*(187-865*r**2-5807*r**4-10315*r**6-10315*r**8
            -5807*r**10-865*r**12+187*r**14)+9*(109-1432*r**2+392*r**4+26376*r**6
            +49910*r**8+26376*r**10+392*r**12-1432*r**14+109*r**16))*sqrtq2))+((4*(Q2
            -(-1+r)**2)**4*r**4*(1-Q2+r**2)*(Q2-(1+r)**2)**4*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(-92*Q2**18-60*Q2**17*(1+r**2)+4*Q2**16*(
            -1499-3228*r**2+1519*r**4)+Q2**15*(72623+1046341*r**2+160589*r**4-34969*r**6)
            +Q2**14*(-299825-8852676*r**2-10808350*r**4-776500*r**6+94735*r**8)
            +Q2**13*(576101+29535579*r**2+82368756*r**4+43289452*r**6+1877655*r**8
            -135799*r**10)+Q2**12*(-381315-38482536*r**2-239240429*r**4-277504064*r**6
            -79598981*r**8-2114840*r**10+76245*r**12)+Q2**11*(-493297-20511955*r**2
            +237317447*r**4+530987613*r**6+387002253*r**8+41680119*r**10-50819*r**12
            +56927*r**14)+Q2**10*(1074711+122446116*r**2+261376636*r**4+280696044*r**6
            +60797850*r**8-63891428*r**10+87830460*r**12+2723028*r**14-101673*r**16)
            -Q2**9*(341275+112792173*r**2+851014790*r**4+2103692810*r**6+3429691340*r**8
            +1396512740*r**10+436523258*r**12+153045270*r**14+1716825*r**16+9295*r**18)
            +Q2**8*(-889251-54890208*r**2+590459833*r**4+1670586336*r**6+6297176130*r**8
            +4841499376*r**10+1065281922*r**12+528837568*r**14+37227201*r**16-2320560*r**18
            +120549*r**20)+Q2**7*(994085+168225927*r**2+357891963*r**4+1950721473*r**6
            -778030638*r**8+777200710*r**10+1046459542*r**12+511955778*r**14-340834967*r**16
            +105058067*r**18+3712335*r**20-89635*r**22)-Q2**6*(70043+76673404*r**2
            +764189182*r**4+3289645276*r**6+8434570341*r**8+17554642744*r**10+19515767172*r**12
            +5395152088*r**14+193046501*r**16-158583284*r**18+89263870*r**20+875276*r**22
            +10907*r**24)+Q2**5*(-508441-63392055*r**2+323302736*r**4-37241456*r**6
            +8386679415*r**8+12693116089*r**10+39203740728*r**12+16900419912*r**14
            +1763653493*r**16-848638885*r**18+178260472*r**20-9932888*r**22-1674323*r**24
            +48803*r**26)+Q2**4*(316975+76375224*r**2+131177365*r**4+2445366560*r**6
            -714459345*r**8+20178975160*r**10-29566065683*r**12-14255612160*r**14
            -701297035*r**16+975854760*r**18+224047815*r**20-417821216*r**22+41907245*r**24
            +1300200*r**26-21065*r**28)+Q2**3*(9117-14144121*r**2-170056239*r**4
            -1061850213*r**6-3845099135*r**8-26031776957*r**10+12379537797*r**12
            -4354598937*r**14+11620863591*r**16+3295991205*r**18+152368323*r**20
            +570114849*r**22+193648251*r**24-13345903*r**26+7655*r**28-5283*r**30)
            +Q2**2*(-84335-15657956*r**2+57506816*r**4-600798684*r**6+3037842044*r**8
            -3267499140*r**10+12997085632*r**12-6908662492*r**14-18283866522*r**16
            -18885157708*r**18-2821795840*r**20-279101876*r**22-403896324*r**24+108011956*r**26
            -5478336*r**28-391060*r**30+7825*r**32)-3*Q2*(-11737-3122007*r**2+2026122*r**4
            -191370746*r**6+336016054*r**8-4793498550*r**10+15426377970*r**12-23365152962*r**14
            +7896633092*r**16+2428061692*r**18-53763714*r**20+2180654706*r**22+134272058*r**24
            -35892346*r**26+40213254*r**28-1384374*r**30-59419*r**32+907*r**34)
            +3*(-1631-528384*r**2-60287*r**4-41405248*r**6+39342620*r**8-1532131152*r**10
            +8274408172*r**12-29995134624*r**14+52589566534*r**16-43249613040*r**18
            +13813606422*r**20-1374664192*r**22+1391081884*r**24+82272976*r**26-6254580*r**28
            +9760736*r**30-237471*r**32-8848*r**34+113*r**36))-4*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**4*(736*Q2**22-164*Q2**21*(1+r**2)-8*Q2**20*(
            -5863-12830*r**2+6209*r**4)+20*Q2**19*(-31155-425321*r**2-66795*r**4
            +16107*r**6)+Q2**18*(2865445+78570100*r**2+94911790*r**4+6983140*r**6
            -959675*r**8)+2*Q2**17*(-3090527-146667235*r**2-398849530*r**4-210439090*r**6
            -9181315*r**8+743353*r**10)+Q2**16*(4784571+456317406*r**2+2671394545*r**4
            +3089930340*r**6+881714845*r**8+22144926*r**10-810729*r**12)-4*Q2**15*(
            -1497871-28555120*r**2+881680183*r**4+1965172890*r**6+1340268435*r**8
            +150861544*r**10-764215*r**12+262898*r**14)+20*Q2**14*(-777440-72542542*r**2
            -92556030*r**4+99985982*r**6+243169743*r**8+115760126*r**10-50476392*r**12
            -2025190*r**14+93439*r**16)-20*Q2**13*(-310787-83141990*r**2-589236664*r**4
            -1353719658*r**6-2135860308*r**8-949127860*r**10-325781616*r**12-111635934*r**14
            -1456929*r**16+3010*r**18)-4*Q2**12*(-3717974-161712590*r**2+3072315480*r**4
            +11567244990*r**6+35914992495*r**8+33297080804*r**10+10276258125*r**12
            +2963189550*r**14+181465215*r**16-9331010*r**18+535171*r**20)+4*Q2**11*(
            -4577651-704045446*r**2-817140815*r**4+199576200*r**6+35195915610*r**8
            +60171084836*r**10+34993132166*r**12+6025344060*r**14+1921351425*r**16
            -488043590*r**18-16519711*r**20+407524*r**22)+2*Q2**10*(-453063+710194160*r**2
            +8757214614*r**4+35911777560*r**6+62067170885*r**8+45037217288*r**10
            +42152523300*r**12+13582344856*r**14+8079031035*r**16+769342920*r**18
            +982978502*r**20+4140240*r**22+318279*r**24)-20*Q2**9*(-711370-80244697*r**2
            +609463880*r**4+3127531220*r**6+21145306736*r**8+39234036757*r**10+66187424212*r**12
            +33881513380*r**14+9461408242*r**16+1516769741*r**18+477432212*r**20
            -18798472*r**22-2452840*r**24+71399*r**26)+10*Q2**8*(-689969-193942990*r**2
            -424346443*r**4-2381844544*r**6+29984342153*r**8+63840564102*r**10+247458855871*r**12
            +211406379568*r**14+56616655057*r**16+14544085038*r**18+1130956499*r**20
            +974323856*r**22-141045673*r**24-2995558*r**26+34105*r**28)+4*Q2**7*(
            -1046331-6986640*r**2+2807960255*r**4+15990252690*r**6+46982782425*r**8
            +153500580376*r**10-188817996105*r**12-275486365090*r**14-90227215265*r**16
            +32352779520*r**18-8891096539*r**20+1129268990*r**22+25783395*r**24+99348440*r**26
            -3890235*r**28+134514*r**30)-4*Q2**6*(-1173194-240196814*r**2+1251959810*r**4
            +5397166830*r**6+103684435335*r**8+261962637994*r**10+766724823704*r**12
            +1062373628990*r**14+1154903353125*r**16+408055557590*r**18+48795009914*r**20
            -8104054886*r**22-352771815*r**24+1997881230*r**26-111293140*r**28-5272454*r**30
            +90181*r**32)-4*Q2**5*(58454+83498785*r**2+614729268*r**4+5070769690*r**6
            -36966938670*r**8-3750177844*r**10-1012961279940*r**12-1126798664758*r**14
            -2738316873530*r**16-1452661624970*r**18-256778954884*r**20+27021416430*r**22
            +200219702*r**24+1335602940*r**26-1080609260*r**28+69513774*r**30+391900*r**32
            +10913*r**34)+20*Q2**4*(-64150-10201334*r**2+170253080*r**4+868557006*r**6
            +6742984043*r**8+30911507896*r**10-24296863191*r**12+240878254290*r**14
            -436852355289*r**16-224241654616*r**18-32699137687*r**20+11810540434*r**22
            -102549015*r**24-4461509120*r**26-256539277*r**28+103644366*r**30-1921509*r**32
            -314730*r**34+5603*r**36)-60*Q2**3*(-7298-2356125*r**2+14112094*r**4
            +25594681*r**6+1948299344*r**8+3742305372*r**10+42030495588*r**12+106763697016*r**14
            -38359259308*r**16+4704403122*r**18-20489197320*r**20-15646171846*r**22
            -2286272464*r**24-2296093892*r**26-1105706196*r**28-139231104*r**30+38480558*r**32
            -1103021*r**34-37606*r**36+405*r**38)-3*Q2**2*(-37707-1803140*r**2+174530430*r**4
            +898532540*r**6-1342331595*r**8+40098187648*r**10-472408852040*r**12
            +732358578880*r**14-1851832881590*r**16+755144441880*r**18+1949622466788*r**20
            +2451613456600*r**22+468178935250*r**24+141108574560*r**26+24588920600*r**28
            -5614189792*r**30+58556705*r**32-15667060*r**34+3126990*r**36-230260*r**38
            +4313*r**40)+18*Q2*(-5053-1223623*r**2+20533810*r**4+54414010*r**6
            +1186756135*r**8+4984570817*r**10+14488694192*r**12+155239831440*r**14
            -668805592610*r**16+1075475371290*r**18-157435300988*r**20-367116721868*r**22
            +63624780190*r**24-108715887310*r**26-12536987360*r**28+1272858112*r**30
            -1583713473*r**32-178447315*r**34+26348410*r**36-248190*r**38-31013*r**40
            +397*r**42)-9*(-1631-505550*r**2+7490403*r**4+9129700*r**6+632078815*r**8
            +1809481114*r**10+26605651205*r**12-2408722672*r**14-283783738150*r**16
            +1922665264580*r**18-3895904772306*r**20+3104449405560*r**22-619758474002*r**24
            -126814542300*r**26-98860868230*r**28-28486145456*r**30+690302965*r**32
            -744356342*r**34-120458625*r**36+13915460*r**38-124221*r**40-10430*r**42
            +113*r**44))*sqrtq2+logq2**6*(-2351462400000*(-Q2+(-1+r)**2)*(-1+r)*r**28*(1
            +r)*(1+r**2)*(1-Q2+r**2)*(-1+4*r**2+r**4)*(-Q2+(1+r)**2)-2351462400000*r**28*(1
            -4*r**2-2*r**4+4*r**6+r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**5*(-3732480000*r**22*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-70*Q2**7*(1
            +r**2)+10*Q2**6*(53+76*r**2+23*r**4)+10*Q2**5*(-157-305*r**2-125*r**4
            +23*r**6)+Q2**4*(2266+5806*r**2+2778*r**4-2702*r**6-1716*r**8)+4*Q2**3*(
            -326-1372*r**2-554*r**4+1744*r**6+1663*r**8+411*r**10)+2*Q2**2*(-337
            +595*r**2+664*r**4-3032*r**6-4453*r**8-853*r**10+612*r**12)-3*Q2*(
            -452-645*r**2+498*r**4+735*r**6-1068*r**8-1047*r**10+1022*r**12+957*r**14)
            +3*(-178-291*r**2+985*r**4-989*r**6-4321*r**8+1587*r**10+2175*r**12
            +589*r**14+443*r**16))-3732480000*r**22*(70*Q2**10*(1+r**2)-20*Q2**9*(37
            +59*r**2+22*r**4)+10*Q2**8*(337+727*r**2+457*r**4+67*r**6)+2*Q2**7*(
            -4318-11503*r**2-9669*r**4-1549*r**6+823*r**8)-14*Q2**6*(-953-3016*r**2
            -2962*r**4-268*r**6+1149*r**8+518*r**10)+2*Q2**5*(-5803-22498*r**2
            -23907*r**4+4218*r**6+24989*r**8+18326*r**10+4543*r**12)-5*Q2**4*(-560
            -4445*r**2-5058*r**4+4211*r**6+14272*r**8+13389*r**10+4522*r**12+21*r**14)
            +3*(-1+r**2)**3*(178+647*r**2-47*r**4-43*r**6+5267*r**8+8001*r**10
            +4239*r**12+1475*r**14+443*r**16)-2*Q2**3*(-2660-2170*r**2+699*r**4
            -8606*r**6-23613*r**8-20598*r**10-9419*r**12+5950*r**14+5985*r**16)
            +2*Q2**2*(-3172-5437*r**2+1801*r**4-2747*r**6-25745*r**8-9615*r**10
            +16467*r**12+10887*r**14+10649*r**16+6912*r**18)-6*Q2*(-493-711*r**2
            +1717*r**4-720*r**6-7466*r**8-3532*r**10+304*r**12+5396*r**14+3003*r**16
            +1359*r**18+1143*r**20))*sqrtq2)+logq2**4*(-10368000*r**18*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1120*Q2**11-40*Q2**10*(463+343*r**2)
            +20*Q2**9*(5598+9401*r**2+3579*r**4)-16*Q2**8*(21419+57837*r**2+47750*r**4
            +12476*r**6)+4*Q2**7*(135368+544057*r**2+709339*r**4+391017*r**6+78047*r**8)
            -Q2**6*(272832+2291461*r**2+4400212*r**4+3800814*r**6+1567540*r**8+266133*r**10)
            +2*Q2**5*(-220528+6795*r**2+480911*r**4+1039682*r**6+1140282*r**8+361111*r**10
            +74123*r**12)+Q2**4*(756560+2200635*r**2+5369086*r**4+5468913*r**6-1950140*r**8
            -3762451*r**10-661490*r**12-127225*r**14)+12*Q2**3*(-23848-145619*r**2
            -506372*r**4-699975*r**6+339684*r**8+1039559*r**10+509668*r**12+81095*r**14
            +5208*r**16)+3*Q2**2*(-70584+97119*r**2+176040*r**4+877892*r**6-1061288*r**8
            -5155610*r**10-3159048*r**12+140156*r**14-42016*r**16+32539*r**18)-18*Q2*(
            -11924-8467*r**2-169481*r**4-118784*r**6+250860*r**8-65590*r**10-448558*r**12
            +140416*r**14+390024*r**16+34505*r**18+6999*r**20)+9*(-5856-4915*r**2
            -171594*r**4-14467*r**6+228240*r**8-520586*r**10-393676*r**12+95334*r**14
            +330832*r**16+417725*r**18+34582*r**20+4381*r**22))-10368000*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1120*Q2**11-40*Q2**10*(463+343*r**2)
            +20*Q2**9*(5598+9401*r**2+3579*r**4)-16*Q2**8*(21419+57837*r**2+47750*r**4
            +12476*r**6)+4*Q2**7*(135368+544057*r**2+709339*r**4+391017*r**6+78047*r**8)
            -Q2**6*(272832+2291461*r**2+4400212*r**4+3800814*r**6+1567540*r**8+266133*r**10)
            +2*Q2**5*(-220528+6795*r**2+480911*r**4+1039682*r**6+1140282*r**8+361111*r**10
            +74123*r**12)+Q2**4*(756560+2200635*r**2+5369086*r**4+5468913*r**6-1950140*r**8
            -3762451*r**10-661490*r**12-127225*r**14)+12*Q2**3*(-23848-145619*r**2
            -506372*r**4-699975*r**6+339684*r**8+1039559*r**10+509668*r**12+81095*r**14
            +5208*r**16)+3*Q2**2*(-70584+97119*r**2+176040*r**4+877892*r**6-1061288*r**8
            -5155610*r**10-3159048*r**12+140156*r**14-42016*r**16+32539*r**18)-18*Q2*(
            -11924-8467*r**2-169481*r**4-118784*r**6+250860*r**8-65590*r**10-448558*r**12
            +140416*r**14+390024*r**16+34505*r**18+6999*r**20)+9*(-5856-4915*r**2
            -171594*r**4-14467*r**6+228240*r**8-520586*r**10-393676*r**12+95334*r**14
            +330832*r**16+417725*r**18+34582*r**20+4381*r**22))*sqrtq2)+logq2**3*(
            -691200*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(6040*Q2**14-40*Q2**13*(1717
            +1594*r**2)+6*Q2**12*(56105+105627*r**2+47066*r**4)-4*Q2**11*(218475
            +672236*r**2+615914*r**4+166353*r**6)+4*Q2**10*(277725+1486603*r**2
            +2160818*r**4+1233470*r**6+213954*r**8)-30*Q2**9*(2091+203128*r**2+406142*r**4
            +373524*r**6+159933*r**8+17658*r**10)+10*Q2**8*(-179709-127157*r**2
            -729770*r**4-1318228*r**6-406781*r**8+81919*r**10+8730*r**12)+Q2**7*(2134140
            +10896361*r**2+49318958*r**4+108457305*r**6+93813080*r**8+30766055*r**10
            +2215166*r**12+14103*r**14)-3*Q2**6*(75900+3683359*r**2+18606971*r**4
            +63097297*r**6+84376685*r**8+48168485*r**10+11650609*r**12+359211*r**14
            +43947*r**16)+Q2**5*(-1426600+1054561*r**2-10443884*r**4+86498170*r**6
            +222991528*r**8+205266820*r**10+79196236*r**12+14503246*r**14+154480*r**16
            +417443*r**18)-5*Q2**4*(-216038-1284133*r**2-13610857*r**4-21608978*r**6
            -16436874*r**8+7836032*r**10+22070188*r**12+7263066*r**14+1535816*r**16
            +403917*r**18+69205*r**20)-15*Q2**3*(1232+306323*r**2+2630070*r**4+9309725*r**6
            +15167456*r**8+5812862*r**10-16901308*r**12-16774294*r**14-4963312*r**16
            -654129*r**18-157626*r**20+2201*r**22)+3*Q2**2*(-106840+24359*r**2-4344493*r**4
            +16724055*r**6+16613515*r**8+4616870*r**10-94138698*r**12-138715514*r**14
            -37514770*r**16-9244205*r**18+1108055*r**20-26301*r**22+59967*r**24)
            -9*Q2*(-16650-118219*r**2-2159316*r**4+469828*r**6-11255590*r**8-1175335*r**10
            +9829088*r**12-23727088*r**14-5724286*r**16+27575015*r**18+4956660*r**20
            +1226156*r**22+110254*r**24+9483*r**26)+9*(-2450-36197*r**2-559757*r**4
            +12580*r**6-6265906*r**8-2125205*r**10+7941439*r**12+3066584*r**14-20073990*r**16
            -4372743*r**18+19012105*r**20+2888708*r**22+471498*r**24+41985*r**26
            +1349*r**28))+691200*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(6040*Q2**15
            -40*Q2**14*(1868+1745*r**2)+Q2**13*(405310+766202*r**2+346156*r**4)
            -2*Q2**12*(605265+1829668*r**2+1689907*r**4+473904*r**6)+4*Q2**11*(496200
            +2377314*r**2+3448968*r**4+2015737*r**6+380307*r**8)-2*Q2**10*(586815
            +6575576*r**2+13386972*r**4+12391436*r**6+5293843*r**8+692778*r**10)
            +20*Q2**9*(-86718+244250*r**2+549020*r**4+510385*r**6+596795*r**8+307346*r**10
            +30852*r**12)+Q2**8*(3931230+13965021*r**2+57888228*r**4+128937285*r**6
            +111063170*r**8+34014675*r**10+1308676*r**12-73197*r**14)-2*Q2**7*(1180920
            +12040289*r**2+58018116*r**4+173534077*r**6+227700220*r**8+134542295*r**10
            +33966524*r**12+1653451*r**14+72972*r**16)+2*Q2**6*(-599450+6166169*r**2
            +28213553*r**4+165805487*r**6+332706737*r**8+301451165*r**10+129326759*r**12
            +25266353*r**14+681977*r**16+274642*r**18)-2*Q2**5*(-1253395-3396352*r**2
            -38721804*r**4-15995302*r**6+113652664*r**8+233719254*r**10+197406998*r**12
            +65007406*r**14+11168403*r**16+1295754*r**18+381734*r**20)+10*Q2**4*(
            -109867-1209570*r**2-11392600*r**4-31574505*r**6-41774110*r**8-13019714*r**10
            +40305072*r**12+39828068*r**14+11844409*r**16+1951060*r**18+473000*r**20
            +31301*r**22)+6*Q2**3*(-50340+781067*r**2+5168736*r**4+38211515*r**6
            +69499710*r**8+54759230*r**10-74790464*r**12-153546762*r**14-73101400*r**16
            -18665705*r**18-1475360*r**20-401713*r**22+35486*r**24)-6*Q2**2*(-78395
            -218569*r**2-5399041*r**4+6894523*r**6-214600*r**8+8852190*r**10-30017282*r**12
            -152017738*r**14-96701571*r**16+17983035*r**18+3366915*r**20+2380111*r**22
            +182214*r**24+44208*r**26)+18*Q2*(-9550-85533*r**2-1418646*r**4-838454*r**6
            -8525834*r**8-7278065*r**10+8297596*r**12-5415708*r**14-24762682*r**16
            +8738993*r**18+25771890*r**20+4535762*r**22+903954*r**24+80861*r**26
            +5416*r**28)-9*(-2450-38647*r**2-595954*r**4-547177*r**6-6253326*r**8
            -8391111*r**10+5816234*r**12+11008023*r**14-17007406*r**16-24446733*r**18
            +14639362*r**20+21900813*r**22+3360206*r**24+513483*r**26+43334*r**28
            +1349*r**30))*sqrtq2)+logq2**2*(2880*r**10*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(-104480*Q2**17+8*Q2**16*(150101+135817*r**2)-8*Q2**15*(709791
            +1424108*r**2+609837*r**4)+8*Q2**14*(1670155+6164498*r**2+5665821*r**4
            +1497790*r**6)-8*Q2**13*(1570775+13279952*r**2+19627106*r**4+11807174*r**6
            +2052205*r**8)+Q2**12*(-10951320+87823939*r**2+170092020*r**4+162375498*r**6
            +97625268*r**8+9276675*r**10)+4*Q2**11*(9892734+24693229*r**2+97819623*r**4
            +176570458*r**6+72594868*r**8-2378739*r**10+1841403*r**12)-2*Q2**10*(14469828
            +157336027*r**2+716700482*r**4+1881190105*r**6+1698206280*r**8+514798421*r**10
            +50180850*r**12+9261111*r**14)+4*Q2**9*(-4846770+63361633*r**2+350439261*r**4
            +1673827605*r**6+2375510525*r**8+1352556375*r**10+271078323*r**12+32232891*r**14
            +3352365*r**16)+Q2**8*(42913400+92962057*r**2+691377336*r**4-3114119876*r**6
            -7327078400*r**8-6371797290*r**10-2654978408*r**12-290389124*r**14-88671816*r**16
            +2729705*r**18)-8*Q2**7*(1878665+40114391*r**2+317972780*r**4+853863832*r**6
            +1861043472*r**8+2719556390*r**10+1492747966*r**12+266907120*r**14+15127487*r**16
            -4971133*r**18+1747270*r**20)+4*Q2**6*(-4119774+46067315*r**2+372895044*r**4
            +2848468779*r**6+8332675944*r**8+17957269110*r**10+16113018636*r**12
            +5851481694*r**14+603032454*r**16-23073081*r**18+4677472*r**20+2456967*r**22)
            +8*Q2**5*(1935887+8467725*r**2+106568217*r**4-511036475*r**6-1198700610*r**8
            -7844229138*r**10-11704337214*r**12-6396000186*r**14-1468763325*r**16
            -7450835*r**18-13472499*r**20-8600451*r**22+229304*r**24)+Q2**4*(-1225160
            -129316891*r**2-1370532012*r**4-4735543390*r**6-29611067900*r**8-17453038725*r**10
            +25962685992*r**12+35736518844*r**14+12054143520*r**16+2269446875*r**18
            +565030660*r**20+529648674*r**22+55416868*r**24-6068155*r**26)+12*Q2**3*(
            -289850+3480307*r**2+28949801*r**4+407821914*r**6+2161639620*r**8+4346643205*r**10
            +2935005991*r**12-1521190932*r**14-4694349898*r**16-2459787075*r**18
            -449400505*r**20-148392198*r**22-26994944*r**24-109941*r**26+174505*r**28)
            +6*Q2**2*(229020+2918719*r**2+45159970*r**4-109686807*r**6+502957768*r**8
            -4526104505*r**10-1116035738*r**12+4310241465*r**14+14975348124*r**16
            +11119907829*r**18+4091115470*r**20+16192019*r**22+102589440*r**24-17811067*r**26
            -3931222*r**28+189515*r**30)-36*Q2*(518+420867*r**2+5163363*r**4+25195443*r**6
            +286607943*r**8-372775221*r**10+820620947*r**12+27232299*r**14+475970739*r**16
            +1089967489*r**18-1711459887*r**20-451164495*r**22-176564787*r**24-14409807*r**26
            -4452807*r**28-379535*r**30+26931*r**32)+9*(-5568+332527*r**2+3686336*r**4
            +36352440*r**6+329849160*r**8-686961996*r**10+3464268304*r**12+268700232*r**14
            -8182983880*r**16+4018542330*r**18+8304862496*r**20-5770391864*r**22
            -1430620872*r**24-319818060*r**26-30912240*r**28-4639432*r**30-281592*r**32
            +21679*r**34))-2880*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17
            -8*Q2**16*(150101+135817*r**2)+8*Q2**15*(709791+1424108*r**2+609837*r**4)
            -8*Q2**14*(1670155+6164498*r**2+5665821*r**4+1497790*r**6)+8*Q2**13*(1570775
            +13279952*r**2+19627106*r**4+11807174*r**6+2052205*r**8)-Q2**12*(-10951320
            +87823939*r**2+170092020*r**4+162375498*r**6+97625268*r**8+9276675*r**10)
            -4*Q2**11*(9892734+24693229*r**2+97819623*r**4+176570458*r**6+72594868*r**8
            -2378739*r**10+1841403*r**12)+2*Q2**10*(14469828+157336027*r**2+716700482*r**4
            +1881190105*r**6+1698206280*r**8+514798421*r**10+50180850*r**12+9261111*r**14)
            -4*Q2**9*(-4846770+63361633*r**2+350439261*r**4+1673827605*r**6+2375510525*r**8
            +1352556375*r**10+271078323*r**12+32232891*r**14+3352365*r**16)+Q2**8*(
            -42913400-92962057*r**2-691377336*r**4+3114119876*r**6+7327078400*r**8
            +6371797290*r**10+2654978408*r**12+290389124*r**14+88671816*r**16-2729705*r**18)
            +8*Q2**7*(1878665+40114391*r**2+317972780*r**4+853863832*r**6+1861043472*r**8
            +2719556390*r**10+1492747966*r**12+266907120*r**14+15127487*r**16-4971133*r**18
            +1747270*r**20)-4*Q2**6*(-4119774+46067315*r**2+372895044*r**4+2848468779*r**6
            +8332675944*r**8+17957269110*r**10+16113018636*r**12+5851481694*r**14
            +603032454*r**16-23073081*r**18+4677472*r**20+2456967*r**22)-8*Q2**5*(1935887
            +8467725*r**2+106568217*r**4-511036475*r**6-1198700610*r**8-7844229138*r**10
            -11704337214*r**12-6396000186*r**14-1468763325*r**16-7450835*r**18-13472499*r**20
            -8600451*r**22+229304*r**24)+Q2**4*(1225160+129316891*r**2+1370532012*r**4
            +4735543390*r**6+29611067900*r**8+17453038725*r**10-25962685992*r**12
            -35736518844*r**14-12054143520*r**16-2269446875*r**18-565030660*r**20
            -529648674*r**22-55416868*r**24+6068155*r**26)-12*Q2**3*(-289850+3480307*r**2
            +28949801*r**4+407821914*r**6+2161639620*r**8+4346643205*r**10+2935005991*r**12
            -1521190932*r**14-4694349898*r**16-2459787075*r**18-449400505*r**20-148392198*r**22
            -26994944*r**24-109941*r**26+174505*r**28)-6*Q2**2*(229020+2918719*r**2
            +45159970*r**4-109686807*r**6+502957768*r**8-4526104505*r**10-1116035738*r**12
            +4310241465*r**14+14975348124*r**16+11119907829*r**18+4091115470*r**20
            +16192019*r**22+102589440*r**24-17811067*r**26-3931222*r**28+189515*r**30)
            +36*Q2*(518+420867*r**2+5163363*r**4+25195443*r**6+286607943*r**8-372775221*r**10
            +820620947*r**12+27232299*r**14+475970739*r**16+1089967489*r**18-1711459887*r**20
            -451164495*r**22-176564787*r**24-14409807*r**26-4452807*r**28-379535*r**30
            +26931*r**32)-9*(-5568+332527*r**2+3686336*r**4+36352440*r**6+329849160*r**8
            -686961996*r**10+3464268304*r**12+268700232*r**14-8182983880*r**16+4018542330*r**18
            +8304862496*r**20-5770391864*r**22-1430620872*r**24-319818060*r**26-30912240*r**28
            -4639432*r**30-281592*r**32+21679*r**34))*sqrtq2)+logq2*(-96*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(54928*Q2**20-10*Q2**19*(66179+80571*r**2)
            +10*Q2**18*(315743+932826*r**2+454635*r**4)-10*Q2**17*(713027+4156451*r**2
            +4810467*r**4+1276291*r**6)+10*Q2**16*(491705+8279349*r**2+16884235*r**4
            +11757431*r**6+1673240*r**8)+2*Q2**15*(5923559-13876615*r**2-57271710*r**4
            -97945590*r**6-59156055*r**8+291279*r**10)-10*Q2**14*(2857988+19669647*r**2
            +75147541*r**4+120967604*r**6+44188566*r**8+6569403*r**10+3179247*r**12)
            +5*Q2**13*(2563602+71427359*r**2+416413088*r**4+1214635191*r**6+1097862886*r**8
            +332390965*r**10+60642984*r**12+6433205*r**14)+5*Q2**12*(5847972-19839849*r**2
            -287234445*r**4-2048826147*r**6-3137405283*r**8-1861102247*r**10-397686891*r**12
            -57953133*r**14+2841111*r**16)-10*Q2**11*(4072315+38356662*r**2+224264136*r**4
            -228097682*r**6-915369848*r**8-907956088*r**10-505111764*r**12-54829074*r**14
            -926967*r**16+4707430*r**18)+4*Q2**10*(307307+110393910*r**2+1170745425*r**4
            +4434888910*r**6+10006163165*r**8+15640213853*r**10+7814017520*r**12
            +1470662320*r**14+319685970*r**16+57863495*r**18+4510077*r**20)+5*Q2**9*(6524726
            +1654389*r**2-332977536*r**4-5253633789*r**6-16668936056*r**8-42558233486*r**10
            -38209590004*r**12-12439153626*r**14-2195790494*r**16-368681911*r**18
            -46755564*r**20+5179239*r**22)-5*Q2**8*(3840512+64911899*r**2+635093811*r**4
            -1309794993*r**6-4893941093*r**8-44191072906*r**10-64772250554*r**12
            -34209666554*r**14-6195004898*r**16-1286268433*r**18-197781337*r**20
            -9929301*r**22+4790695*r**24)-10*Q2**7*(878591-18460977*r**2-352827146*r**4
            -1980677810*r**6-9160838453*r**8-8905623285*r**10-7245547460*r**12-10083900548*r**14
            -4237010291*r**16-1165420083*r**18+269462462*r**20-41127194*r**22-13654759*r**24
            +418313*r**26)+10*Q2**6*(1259540+5803877*r**2-23532033*r**4-2109246552*r**6
            -9544382366*r**8-39759741061*r**10-79333297209*r**12-119098406816*r**14
            -69660249688*r**16-13983361421*r**18-381884731*r**20+264511880*r**22
            -105316878*r**24-14437827*r**26+1260165*r**28)+Q2**5*(-1429522-97736715*r**2
            -1617715640*r**4+2098864585*r**6-12171448290*r**8+280893888657*r**10
            +536428413960*r**12+1691496856965*r**14+1549238069610*r**16+526380826495*r**18
            +33108765192*r**20-5161804645*r**22+1307981450*r**24+484828155*r**26
            +10974120*r**28-2662377*r**30)-5*Q2**4*(677892-4948297*r**2-184875493*r**4
            -1835799047*r**6-12492555863*r**8-16769631217*r**10-130117787973*r**12
            +74508298201*r**14+214049147049*r**16+70032535581*r**18+9559984153*r**20
            -2592019133*r**22+2902206467*r**24+1216863773*r**26-43586543*r**28-12728853*r**30
            +616103*r**32)+30*Q2**3*(45654+417273*r**2+1417388*r**4-178221314*r**6
            -723747334*r**8-7139162596*r**10-26796182328*r**12-21945512406*r**14
            +1342738458*r**16+13720059258*r**18+16969717740*r**20+4420500082*r**22
            +1463384198*r**24+558599956*r**26+119452576*r**28-8390298*r**30-1005552*r**32
            +49245*r**34)+30*Q2**2*(9169-294388*r**2-7241173*r**4-11605536*r**6
            -384866858*r**8+2461427062*r**10-2492912204*r**12+21798649780*r**14-6278370596*r**16
            -25153597574*r**18-44294454506*r**20-30409099688*r**22-2275208286*r**24
            -1149771430*r**26-28432468*r**28+45300500*r**30+897755*r**32-277846*r**34
            +8287*r**36)-45*Q2*(6040-39833*r**2-1765902*r**4-25702367*r**6-191633484*r**8
            -669629844*r**10-6819671780*r**12+18100809572*r**14-23382970028*r**16
            -6747069582*r**18-9857533632*r**20+19868199534*r**22+4639058012*r**24
            +4640825532*r**26+322380516*r**28+82312436*r**30+43411204*r**32-781057*r**34
            -211762*r**36+6425*r**38)+9*(5222-10355*r**2-1056335*r**4-31511255*r**6
            -153685765*r**8-2010898828*r**10-6861747660*r**12+35126704580*r**14-161489742960*r**16
            +164166435670*r**18+133768147902*r**20-304538439490*r**22+98584777970*r**24
            +29670853060*r**26+12154764580*r**28+1458374292*r**30+101088130*r**32
            +57261285*r**34-1105095*r**36-220735*r**38+5787*r**40))+96*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(54928*Q2**21-2*Q2**20*(358359+430319*r**2)
            +20*Q2**19*(190961+539788*r**2+267603*r**4)-20*Q2**18*(514385+2702510*r**2
            +3098964*r**4+865463*r**6)+10*Q2**17*(1204732+13148827*r**2+25851153*r**4
            +17844189*r**6+2949531*r**8)-2*Q2**16*(-3465034+57731885*r**2+183089630*r**4
            +241153920*r**6+126309410*r**8+8074921*r**10)-2*Q2**15*(20213499+90395179*r**2
            +304589380*r**4+449620720*r**6+63841185*r**8-26017761*r**10+16187514*r**12)
            +5*Q2**14*(8279578+116482629*r**2+606047464*r**4+1606865481*r**6+1428175226*r**8
            +433906903*r**10+80140284*r**12+12791699*r**14)-10*Q2**13*(-1642185+46915405*r**2
            +387537446*r**4+1839937213*r**6+2724951680*r**8+1645678049*r**10+395360420*r**12
            +62514661*r**14+1796047*r**16)-5*Q2**12*(13992602+62721447*r**2+141453978*r**4
            -2792255956*r**6-7016971126*r**8-6814419706*r**10-3269012666*r**12-565298172*r**14
            -56965956*r**16+12255971*r**18)+2*Q2**11*(20976189+432932705*r**2+3654594840*r**4
            +8850610090*r**6+14294988680*r**8+22163798026*r**10+8562695780*r**12
            +141620450*r**14+360591735*r**16+134629305*r**18+32557304*r**20)+Q2**10*(31394402
            -434532923*r**2-6789445020*r**4-48690706285*r**6-141108888580*r**8-315376675502*r**10
            -284864875512*r**12-99334487490*r**14-18140345630*r**16-3353607415*r**18
            -483272108*r**20+7855887*r**22)-10*Q2**9*(5182619+36545507*r**2+151885332*r**4
            -3448203159*r**6-13408255469*r**8-51709121224*r**10-72770037022*r**12
            -42429205092*r**14-10414974509*r**16-1925370419*r**18-306609406*r**20
            -25752813*r**22+4984967*r**24)+5*Q2**8*(2083330+105674365*r**2+1405660002*r**4
            +3286654438*r**6+12117940820*r**8-31273767429*r**10-94472228540*r**12
            -78814116012*r**14-31930650870*r**16-5150433165*r**18-2022974694*r**20
            -125456250*r**22+22170912*r**24+3954069*r**26)+10*Q2**7*(2138131-11778509*r**2
            -394820156*r**4-4442751508*r**6-20685898629*r**8-57826202799*r**10-95484467954*r**12
            -136427854824*r**14-83981160527*r**16-19385791795*r**18-1277842352*r**20
            +492847148*r**22-160098831*r**24-27674273*r**26+1678478*r**28)+Q2**6*(
            -14024922-168370885*r**2-1440434080*r**4+23426650435*r**6+104364840890*r**8
            +773935122927*r**10+1727358796660*r**12+3675813897215*r**14+3436824634650*r**16
            +1362816937585*r**18+176761226712*r**20-3988076135*r**22-283968570*r**24
            +1682375205*r**26+142750740*r**28-15264027*r**30)-2*Q2**5*(979969-61953861*r**2
            -1319914910*r**4-4348923145*r**6-36267681510*r**8+92437142141*r**10+83366681376*r**12
            +1300233380965*r**14+2155490330910*r**16+1212890787005*r**18+303644756226*r**20
            +7493432441*r**22+5328604570*r**24+3938564235*r**26+138934780*r**28-27666261*r**30
            +209069*r**32)+5*Q2**4*(951816-1766767*r**2-181319462*r**4-3090002424*r**6
            -18670838914*r**8-72097162656*r**10-307664513158*r**12-187282564208*r**14
            +296613875998*r**16+366402038178*r**18+181410826174*r**20+33490965512*r**22
            +9090492522*r**24+7470669976*r**26+1889992686*r**28-106657184*r**30-18146062*r**32
            +911573*r**34)-30*Q2**3*(36485+757315*r**2+9075834*r**4-165198390*r**6
            -517101790*r**8-10324336992*r**10-31442432720*r**12-70540344514*r**14
            -14324403352*r**16+40216395290*r**18+74984231504*r**20+51799317510*r**22
            +8159092566*r**24+3171755584*r**26+706485000*r**28+65761778*r**30-10293605*r**32
            -678461*r**34+40958*r**36)-15*Q2**2*(36458-689937*r**2-20368828*r**4
            -114800519*r**6-1367845240*r**8+2144230876*r**10-20521985624*r**12+92913903868*r**14
            -39108351716*r**16-83105145086*r**18-168468705056*r**20-89802509786*r**22
            -51451441912*r**24+7072517164*r**26-1389266248*r**28+280673372*r**30
            +222630122*r**32-1103353*r**34-1174404*r**36+35849*r**38)+18*Q2*(17711
            -89660*r**2-5042505*r**4-84426300*r**6-620182510*r**8-3158607734*r**10
            -22154127890*r**12+45766196770*r**14-93950272620*r**16+6758118810*r**18
            +25372565916*r**20-127242554990*r**22+110560532850*r**24+38035135390*r**26
            +18485397410*r**28+1740919526*r**30+364853165*r**32+135206010*r**34-3034595*r**36
            -623710*r**38+18956*r**40)-9*(5222-5133*r**2-1066690*r**4-32567590*r**6
            -185197020*r**8-2164584593*r**10-8872646488*r**12+28264956920*r**14-126363038380*r**16
            +2676692710*r**18+297934583572*r**20-170770291588*r**22-205953661520*r**24
            +128255631030*r**26+41825617640*r**28+13613138872*r**30+1559462422*r**32
            +158349415*r**34+56156190*r**36-1325830*r**38-214948*r**40+5787*r**42))*sqrtq2))*math.log(mus))/(
            -4200*(-Q2+(-1+r)**2)*r**2*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))
            -4200*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2+logq2**6*(188116992000*r**26*(1
            +r**2)*(-1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -188116992000*r**26*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**3*(145152000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))+145152000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))*sqrtq2)+logq2*(504000*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)
            -Q2**2*(5+2*r**2+5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))+504000*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)-Q2**2*(5+2*r**2
            +5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))*sqrtq2)+logq2**2*(-3024000*(
            -Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(16*Q2**4+Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1
            +9*r**2+9*r**4+r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))-3024000*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(16*Q2**4
            +Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1+9*r**2+9*r**4
            +r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))*sqrtq2)+logq2**4*(-435456000*(
            -Q2+(-1+r)**2)*r**18*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))
            -435456000*(-Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))*sqrtq2)
            +logq2**5*(2090188800*(-Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2
            +41*r**4)-18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4
            -82*r**6+13*r**8))+2090188800*(-Q2+(-1+r)**2)*r**22*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2+41*r**4)
            -18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4-82*r**6
            +13*r**8))*sqrtq2)))*math.log(r)+((16*(Q2-(-1+r)**2)**6*r**6*(1-Q2+r**2)*(Q2
            -(1+r)**2)**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(-4508*Q2**23
            -24*Q2**22*(-441+79*r**2)+8*Q2**21*(-36750-114344*r**2+73287*r**4)+Q2**20*(4425043
            +83256801*r**2+15016777*r**4-5221781*r**6)+2*Q2**19*(-12973485-465224884*r**2
            -625551974*r**4-55333476*r**6+11686215*r**8)+Q2**18*(78836982+4519459274*r**2
            +12632871172*r**4+7779590828*r**6+461607910*r**8-64465878*r**10)+2*Q2**17*(
            -62379303-5543871310*r**2-27052784995*r**4-33384562740*r**6-13042905377*r**8
            -592335062*r**10+57769947*r**12)+3*Q2**16*(15995805+3407748667*r**2+36403578525*r**4
            +71176718979*r**6+58981144987*r**8+16633129533*r**10+624383579*r**12
            -43917963*r**14)+8*Q2**15*(23987166+1954736567*r**2-5758547757*r**4-19921923234*r**6
            -33504595330*r**8-29198964573*r**10-5907464793*r**12-203423764*r**14
            +10583478*r**16)-8*Q2**14*(44974405+6900967872*r**2+31913211182*r**4
            +91129670769*r**6+137177826396*r**8+43679015471*r**10-9039933252*r**12
            +593211657*r**14-50617147*r**16+2974855*r**18)+8*Q2**13*(18481869+6249273181*r**2
            +67213780178*r**4+246414400011*r**6+603914199535*r**8+523692961841*r**10
            +175300529229*r**12+28356369997*r**14+7761842012*r**16+11766330*r**18
            +3851529*r**20)-2*Q2**12*(-152568507-14941764253*r**2+136213089035*r**4
            +541845397249*r**6+3053275031626*r**8+3874886216846*r**10+2457691193158*r**12
            +798171844858*r**14+197096402249*r**16+25347934999*r**18-678298569*r**20
            +46988253*r**22)+4*Q2**11*(-113077055-25833560974*r**2-119049611504*r**4
            -663433703516*r**6-512378076837*r**8-854383920916*r**10-957173317200*r**12
            +149852276040*r**14+255823925999*r**16+100230702946*r**18-4375076048*r**20
            -723250476*r**22+27235429*r**24)+4*Q2**10*(24621177+16830158189*r**2
            +206787721174*r**4+1155882579096*r**6+3405281253443*r**8+6491049400873*r**10
            +10009578718896*r**12+5304780986900*r**14+581325533395*r**16-259544903373*r**18
            -82476535846*r**20+12475764244*r**22+466697361*r**24-8832009*r**26)-4*Q2**9*(
            -73706535-10069747564*r**2+77521880311*r**4+230671826810*r**6+3168946775411*r**8
            +4812204065506*r**10+16375501273685*r**12+13535790642764*r**14+5151874212007*r**16
            +165943022576*r**18-241573199479*r**20-9866114918*r**22+3739776461*r**24
            -196901126*r**26+10484715*r**28)+2*Q2**8*(-146271909-43073139359*r**2
            -191162220257*r**4-2018566120455*r**6-512926832805*r**8-14335455331871*r**10
            +15266447547375*r**12+19120079120745*r**14+14377846221841*r**16+6762508524195*r**18
            +136352931069*r**20+129664901227*r**22+184006152441*r**24-11411295013*r**26
            -907463755*r**28+22468851*r**30)-4*Q2**7*(-8692551-8912112858*r**2-118304872890*r**4
            -927515895084*r**6-2644941052904*r**8-12913495879294*r**10-6089683912974*r**12
            -2530788688928*r**14+3002339833022*r**16+7572552188490*r**18+3924140616394*r**20
            +407116199012*r**22+295195172472*r**24+97207298766*r**26-4699768002*r**28
            -139396440*r**30+529209*r**32)-8*Q2**6*(-14673540-2952812959*r**2+15802702494*r**4
            -44428098549*r**6+1057016864074*r**8+765513755573*r**10+7066774147876*r**12
            -2327746835807*r**14+138085462508*r**16-5899344360911*r**18-4659102751514*r**20
            -1219979997307*r**22-175883239070*r**24-115137040669*r**26+752106072*r**28
            -170570289*r**30-93175060*r**32+2699478*r**34)+8*Q2**5*(-10537009-3805889853*r**2
            -13126281679*r**4-286576655091*r**6+281835366727*r**8-5538104451479*r**10
            +11627201977863*r**12-18215903848659*r**14+9224800037701*r**16-7482486981025*r**18
            -731611625103*r**20-1715964170417*r**22+522259021173*r**24-149571773173*r**26
            -71863546987*r**28+32103786231*r**30-941294928*r**32-92533270*r**34+1747778*r**36)
            +Q2**4*(10096695+8801880613*r**2+92851131773*r**4+1113159007719*r**6
            +1425942520332*r**8+34564035187092*r**10-89218061172636*r**12+221116186208732*r**14
            -224652921348686*r**16+79044690995526*r**18+66031566085766*r**20-25843248263582*r**22
            +7764808214172*r**24-6457433845980*r**26+1342593218772*r**28+349811093772*r**30
            -152723238545*r**32+3230430173*r**34+149363397*r**36-909105*r**38)-2*Q2**3*(
            -7907571-1946813248*r**2+11302684666*r**4-116455399372*r**6+1108303530565*r**8
            -1589358384096*r**10+682510985496*r**12+26455625058208*r**14-77827970132902*r**16
            +82224791766400*r**18-15243951777156*r**20+52232697852872*r**22-1495577011214*r**24
            +3258202532000*r**26-592488331560*r**28+266765452224*r**30-56059994695*r**32
            +4736784640*r**34+58482074*r**36-69381980*r**38+1556649*r**40)+3*(-1
            +r**2)**2*(-79919-42390511*r**2-204662598*r**4-7106501686*r**6+11603047685*r**8
            -411302676411*r**10+2795170619800*r**12-15121161184136*r**14+48682349310018*r**16
            -90724374656670*r**18+86393487753692*r**20-36225590251044*r**22+8506277985266*r**24
            -4118306093678*r**26-880437358440*r**28-122540182600*r**30-21258201043*r**32
            -11418953907*r**34+743404346*r**36-1172950*r**38-1048887*r**40+13673*r**42)
            +2*Q2**2*(-4893973-1877752711*r**2-1592074750*r**4-208410508054*r**6
            +739049139295*r**8-8108238157655*r**10+35440109839008*r**12-104206171672928*r**14
            +152249631015454*r**16-86090318472118*r**18+21618902284500*r**20-17337075300636*r**22
            -8226127150594*r**24-9115998612046*r**26-4820947905424*r**28+69201504432*r**30
            -61116617833*r**32-178057249603*r**34+21657285146*r**36-111534878*r**38
            -52850429*r**40+885797*r**42)-6*Q2*(-407435-188172850*r**2-426274787*r**4
            -25747073560*r**6+87199806491*r**8-1340199942054*r**10+8297002296619*r**12
            -36003065457648*r**14+93718207370930*r**16-133829802250308*r**18+86591210763362*r**20
            -11428253148832*r**22-3219661437514*r**24+143232973220*r**26-3655283665482*r**28
            -1708330659472*r**30-90424652343*r**32-12494084330*r**34-34041419215*r**36
            +2849434424*r**38-5662401*r**40-4968094*r**42+71279*r**44))-16*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7
            +2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2*(4508*Q2**23+24*Q2**22*(-441+79*r**2)+Q2**21*(294000
            +914752*r**2-586296*r**4)+Q2**20*(-4425043-83256801*r**2-15016777*r**4
            +5221781*r**6)+Q2**19*(25946970+930449768*r**2+1251103948*r**4+110666952*r**6
            -23372430*r**8)+2*Q2**18*(-39418491-2259729637*r**2-6316435586*r**4-3889795414*r**6
            -230803955*r**8+32232939*r**10)+2*Q2**17*(62379303+5543871310*r**2+27052784995*r**4
            +33384562740*r**6+13042905377*r**8+592335062*r**10-57769947*r**12)+3*Q2**16*(
            -15995805-3407748667*r**2-36403578525*r**4-71176718979*r**6-58981144987*r**8
            -16633129533*r**10-624383579*r**12+43917963*r**14)-8*Q2**15*(23987166
            +1954736567*r**2-5758547757*r**4-19921923234*r**6-33504595330*r**8-29198964573*r**10
            -5907464793*r**12-203423764*r**14+10583478*r**16)+8*Q2**14*(44974405
            +6900967872*r**2+31913211182*r**4+91129670769*r**6+137177826396*r**8
            +43679015471*r**10-9039933252*r**12+593211657*r**14-50617147*r**16+2974855*r**18)
            -8*Q2**13*(18481869+6249273181*r**2+67213780178*r**4+246414400011*r**6
            +603914199535*r**8+523692961841*r**10+175300529229*r**12+28356369997*r**14
            +7761842012*r**16+11766330*r**18+3851529*r**20)+2*Q2**12*(-152568507
            -14941764253*r**2+136213089035*r**4+541845397249*r**6+3053275031626*r**8
            +3874886216846*r**10+2457691193158*r**12+798171844858*r**14+197096402249*r**16
            +25347934999*r**18-678298569*r**20+46988253*r**22)-4*Q2**11*(-113077055
            -25833560974*r**2-119049611504*r**4-663433703516*r**6-512378076837*r**8
            -854383920916*r**10-957173317200*r**12+149852276040*r**14+255823925999*r**16
            +100230702946*r**18-4375076048*r**20-723250476*r**22+27235429*r**24)
            +4*Q2**10*(-24621177-16830158189*r**2-206787721174*r**4-1155882579096*r**6
            -3405281253443*r**8-6491049400873*r**10-10009578718896*r**12-5304780986900*r**14
            -581325533395*r**16+259544903373*r**18+82476535846*r**20-12475764244*r**22
            -466697361*r**24+8832009*r**26)+4*Q2**9*(-73706535-10069747564*r**2+77521880311*r**4
            +230671826810*r**6+3168946775411*r**8+4812204065506*r**10+16375501273685*r**12
            +13535790642764*r**14+5151874212007*r**16+165943022576*r**18-241573199479*r**20
            -9866114918*r**22+3739776461*r**24-196901126*r**26+10484715*r**28)-2*Q2**8*(
            -146271909-43073139359*r**2-191162220257*r**4-2018566120455*r**6-512926832805*r**8
            -14335455331871*r**10+15266447547375*r**12+19120079120745*r**14+14377846221841*r**16
            +6762508524195*r**18+136352931069*r**20+129664901227*r**22+184006152441*r**24
            -11411295013*r**26-907463755*r**28+22468851*r**30)+4*Q2**7*(-8692551
            -8912112858*r**2-118304872890*r**4-927515895084*r**6-2644941052904*r**8
            -12913495879294*r**10-6089683912974*r**12-2530788688928*r**14+3002339833022*r**16
            +7572552188490*r**18+3924140616394*r**20+407116199012*r**22+295195172472*r**24
            +97207298766*r**26-4699768002*r**28-139396440*r**30+529209*r**32)+8*Q2**6*(
            -14673540-2952812959*r**2+15802702494*r**4-44428098549*r**6+1057016864074*r**8
            +765513755573*r**10+7066774147876*r**12-2327746835807*r**14+138085462508*r**16
            -5899344360911*r**18-4659102751514*r**20-1219979997307*r**22-175883239070*r**24
            -115137040669*r**26+752106072*r**28-170570289*r**30-93175060*r**32+2699478*r**34)
            -8*Q2**5*(-10537009-3805889853*r**2-13126281679*r**4-286576655091*r**6
            +281835366727*r**8-5538104451479*r**10+11627201977863*r**12-18215903848659*r**14
            +9224800037701*r**16-7482486981025*r**18-731611625103*r**20-1715964170417*r**22
            +522259021173*r**24-149571773173*r**26-71863546987*r**28+32103786231*r**30
            -941294928*r**32-92533270*r**34+1747778*r**36)+Q2**4*(-10096695-8801880613*r**2
            -92851131773*r**4-1113159007719*r**6-1425942520332*r**8-34564035187092*r**10
            +89218061172636*r**12-221116186208732*r**14+224652921348686*r**16-79044690995526*r**18
            -66031566085766*r**20+25843248263582*r**22-7764808214172*r**24+6457433845980*r**26
            -1342593218772*r**28-349811093772*r**30+152723238545*r**32-3230430173*r**34
            -149363397*r**36+909105*r**38)+2*Q2**3*(-7907571-1946813248*r**2+11302684666*r**4
            -116455399372*r**6+1108303530565*r**8-1589358384096*r**10+682510985496*r**12
            +26455625058208*r**14-77827970132902*r**16+82224791766400*r**18-15243951777156*r**20
            +52232697852872*r**22-1495577011214*r**24+3258202532000*r**26-592488331560*r**28
            +266765452224*r**30-56059994695*r**32+4736784640*r**34+58482074*r**36
            -69381980*r**38+1556649*r**40)+2*Q2**2*(4893973+1877752711*r**2+1592074750*r**4
            +208410508054*r**6-739049139295*r**8+8108238157655*r**10-35440109839008*r**12
            +104206171672928*r**14-152249631015454*r**16+86090318472118*r**18-21618902284500*r**20
            +17337075300636*r**22+8226127150594*r**24+9115998612046*r**26+4820947905424*r**28
            -69201504432*r**30+61116617833*r**32+178057249603*r**34-21657285146*r**36
            +111534878*r**38+52850429*r**40-885797*r**42)-3*(-1+r**2)**2*(-79919
            -42390511*r**2-204662598*r**4-7106501686*r**6+11603047685*r**8-411302676411*r**10
            +2795170619800*r**12-15121161184136*r**14+48682349310018*r**16-90724374656670*r**18
            +86393487753692*r**20-36225590251044*r**22+8506277985266*r**24-4118306093678*r**26
            -880437358440*r**28-122540182600*r**30-21258201043*r**32-11418953907*r**34
            +743404346*r**36-1172950*r**38-1048887*r**40+13673*r**42)+6*Q2*(-407435
            -188172850*r**2-426274787*r**4-25747073560*r**6+87199806491*r**8-1340199942054*r**10
            +8297002296619*r**12-36003065457648*r**14+93718207370930*r**16-133829802250308*r**18
            +86591210763362*r**20-11428253148832*r**22-3219661437514*r**24+143232973220*r**26
            -3655283665482*r**28-1708330659472*r**30-90424652343*r**32-12494084330*r**34
            -34041419215*r**36+2849434424*r**38-5662401*r**40-4968094*r**42+71279*r**44))*sqrtq2
            +logq2**8*(-20316635136000000*r**38*(1+r**2)**2*(1-Q2+r**2)*(49-365*r**2
            +291*r**4+121*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-20316635136000000*(Q2
            -(-1+r)**2)**2*r**38*(1+r**2)**2*(49-365*r**2+291*r**4+121*r**6)*(Q2
            -(1+r)**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**7*(
            -32248627200000*r**32*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1610*Q2**9*(1
            +r**2)-10*Q2**8*(1541+1672*r**2+131*r**4)+20*Q2**7*(3105+3514*r**2
            +394*r**4-15*r**6)-2*Q2**6*(68264+77697*r**2-1299*r**4+55999*r**6+50379*r**8)
            +2*Q2**5*(85169+82771*r**2+33628*r**4+243920*r**6+375873*r**8+167979*r**10)
            -Q2**4*(96600+21239*r**2+217947*r**4+1204066*r**6+1591814*r**8+997099*r**10
            +250635*r**12)+Q2**3*(-32200-116789*r**2+171824*r**4+750087*r**6+1533640*r**8
            +1277317*r**10-246944*r**12-484295*r**14)+6*(-1+r**2)**2*(2047+1428*r**2
            +42526*r**4-76992*r**6-235570*r**8+160168*r**10+167882*r**12+61444*r**14
            +38347*r**16)+Q2**2*(90160+78581*r**2+251291*r**4-171431*r**6-1337929*r**8
            +498323*r**10+614509*r**12+1367711*r**14+1108625*r**16)-3*Q2*(18584
            -3375*r**2+180938*r**4-214182*r**6-1401354*r**8-28724*r**10+1615310*r**12
            +611742*r**14+231642*r**16+279659*r**18))+32248627200000*r**32*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1610*Q2**10*(1+r**2)-20*Q2**9*(851
            +997*r**2+146*r**4)+10*Q2**8*(7751+10241*r**2+2591*r**4+101*r**6)-2*Q2**7*(99314
            +143887*r**2+37781*r**4+59789*r**6+50229*r**8)+14*Q2**6*(21919+32676*r**2
            +15718*r**4+42660*r**6+68893*r**8+31194*r**10)-Q2**5*(266938+357119*r**2
            +450745*r**4+1759162*r**6+2831400*r**8+2084803*r**10+586593*r**12)+10*Q2**4*(6440
            +105*r**2+41101*r**4+217210*r**6+432952*r**8+386623*r**10+100079*r**12
            -23366*r**14)+2*Q2**3*(61180+113785*r**2+98128*r**4-546671*r**6-1810828*r**8
            -1156317*r**10-207932*r**12+1049475*r**14+796460*r**16)-6*(-1+r**2)**2*(2047
            +3475*r**2+43954*r**4-34466*r**6-312562*r**8-75402*r**10+328050*r**12
            +229326*r**14+99791*r**16+38347*r**18)-2*Q2**2*(72956+79308*r**2+436343*r**4
            -281343*r**6-2856711*r**8-462889*r**10+2979381*r**12+1908723*r**14+1585631*r**16
            +973801*r**18)+3*Q2*(22678+9877*r**2+260997*r**4-354476*r**6-1693656*r**8
            -321446*r**10+810538*r**12+1998748*r**14+1010066*r**16+480801*r**18
            +356353*r**20))*sqrtq2)+logq2**6*(-179159040000*r**28*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-25760*Q2**13*(1+r**2)+60*Q2**12*(13643
            +23526*r**2+9883*r**4)-30*Q2**11*(236432+560017*r**2+437618*r**4+114033*r**6)
            +4*Q2**10*(7494228+22317235*r**2+23882941*r**4+10856721*r**6+1764083*r**8)
            +60*Q2**9*(-1187130-4268166*r**2-5670604*r**4-3229657*r**6-607140*r**8
            +32949*r**10)-30*Q2**8*(-3060330-13592463*r**2-21489587*r**4-13510658*r**6
            -411166*r**8+3202861*r**10+1060823*r**12)+5*Q2**7*(-6737388-58158775*r**2
            -116504734*r**4-70687697*r**6+39445840*r**8+80052011*r**10+45321570*r**12
            +10319749*r**14)-30*Q2**6*(2697576+3595403*r**2-258202*r**4+429335*r**6
            +12574482*r**8+24508561*r**10+17541818*r**12+5275949*r**14+991942*r**16)
            +3*Q2**5*(44647092+125932925*r**2+147173004*r**4+62001654*r**6+100131312*r**8
            +394574952*r**10+501772220*r**12+233918114*r**14+20645764*r**16-2058253*r**18)
            +20*Q2**4*(-3499895-12990732*r**2-13868587*r**4+769130*r**6-28185979*r**8
            -119130370*r**10-166605013*r**12-117025390*r**14-40305502*r**16-3397910*r**18
            +1212968*r**20)-15*Q2**3*(1310876-1943503*r**2+2121146*r**4+11193061*r**6
            -29796956*r**8-132735470*r**10-231963368*r**12-174486470*r**14-10421792*r**16
            +30028157*r**18+3162254*r**20+2356385*r**22)+18*(-1+r**2)**2*(202734
            +277713*r**2+33725*r**4+6077275*r**6+11721319*r**8-27175130*r**10-49639254*r**12
            +5988066*r**14+42109380*r**16+47697161*r**18+27059801*r**20+3096771*r**22
            +288039*r**24)+30*Q2**2*(1451912+1179563*r**2+1813242*r**4+6899165*r**6
            +13023524*r**8-5226634*r**10-32378332*r**12-21723310*r**14+32047400*r**16
            +98390799*r**18+65339778*r**20+7245473*r**22+1281420*r**24)-45*Q2*(469588
            +157915*r**2-140980*r**4+5510568*r**6+13237424*r**8-29814465*r**10-71353048*r**12
            +8042608*r**14+64743012*r**16+34974961*r**18+43305612*r**20+34817128*r**22
            +3928472*r**24+501365*r**26))+179159040000*r**28*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(25760*Q2**13*(1+r**2)-60*Q2**12*(13643+23526*r**2
            +9883*r**4)+30*Q2**11*(236432+560017*r**2+437618*r**4+114033*r**6)-4*Q2**10*(7494228
            +22317235*r**2+23882941*r**4+10856721*r**6+1764083*r**8)-60*Q2**9*(-1187130
            -4268166*r**2-5670604*r**4-3229657*r**6-607140*r**8+32949*r**10)+30*Q2**8*(
            -3060330-13592463*r**2-21489587*r**4-13510658*r**6-411166*r**8+3202861*r**10
            +1060823*r**12)-5*Q2**7*(-6737388-58158775*r**2-116504734*r**4-70687697*r**6
            +39445840*r**8+80052011*r**10+45321570*r**12+10319749*r**14)+30*Q2**6*(2697576
            +3595403*r**2-258202*r**4+429335*r**6+12574482*r**8+24508561*r**10+17541818*r**12
            +5275949*r**14+991942*r**16)+3*Q2**5*(-44647092-125932925*r**2-147173004*r**4
            -62001654*r**6-100131312*r**8-394574952*r**10-501772220*r**12-233918114*r**14
            -20645764*r**16+2058253*r**18)-20*Q2**4*(-3499895-12990732*r**2-13868587*r**4
            +769130*r**6-28185979*r**8-119130370*r**10-166605013*r**12-117025390*r**14
            -40305502*r**16-3397910*r**18+1212968*r**20)+15*Q2**3*(1310876-1943503*r**2
            +2121146*r**4+11193061*r**6-29796956*r**8-132735470*r**10-231963368*r**12
            -174486470*r**14-10421792*r**16+30028157*r**18+3162254*r**20+2356385*r**22)
            -18*(-1+r**2)**2*(202734+277713*r**2+33725*r**4+6077275*r**6+11721319*r**8
            -27175130*r**10-49639254*r**12+5988066*r**14+42109380*r**16+47697161*r**18
            +27059801*r**20+3096771*r**22+288039*r**24)-30*Q2**2*(1451912+1179563*r**2
            +1813242*r**4+6899165*r**6+13023524*r**8-5226634*r**10-32378332*r**12
            -21723310*r**14+32047400*r**16+98390799*r**18+65339778*r**20+7245473*r**22
            +1281420*r**24)+45*Q2*(469588+157915*r**2-140980*r**4+5510568*r**6
            +13237424*r**8-29814465*r**10-71353048*r**12+8042608*r**14+64743012*r**16
            +34974961*r**18+43305612*r**20+34817128*r**22+3928472*r**24+501365*r**26))*sqrtq2)
            +logq2**5*(-995328000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(103040*Q2**17
            -160*Q2**16*(62239+56599*r**2)+10*Q2**15*(12626735+20432366*r**2+8107583*r**4)
            -2*Q2**14*(372851529+888609211*r**2+676226427*r**4+161372937*r**6)+Q2**13*(2536929162
            +8271169720*r**2+9587436304*r**4+4590154272*r**6+735426366*r**8)-2*Q2**12*(2576499129
            +11383347352*r**2+18292061320*r**4+13672560586*r**6+4744593375*r**8+576997182*r**10)
            +4*Q2**11*(1342009938+9055261444*r**2+19369643214*r**4+19955656906*r**6
            +11137919329*r**8+3306438900*r**10+414907329*r**12)-Q2**10*(-688532682
            +23778155915*r**2+71523581384*r**4+92109580073*r**6+73578060898*r**8
            +40058501525*r**10+14117946888*r**12+2590231839*r**14)+Q2**9*(-10126784184
            -23064011531*r**2-50226268367*r**4-95787104407*r**6-70852519015*r**8
            +7196555051*r**10+30922892839*r**12+15351712983*r**14+3558173223*r**16)
            +2*Q2**8*(6278807213+31700883785*r**2+104093981646*r**4+218148589978*r**6
            +219424049654*r**8+65109712098*r**10-42986693570*r**12-36114985054*r**14
            -9855328527*r**16-1756046791*r**18)+2*Q2**7*(-1764352477-24833812436*r**2
            -95810242015*r**4-245311137248*r**6-292025505690*r**8-68044070008*r**10
            +157708268434*r**12+157621276560*r**14+62597918207*r**16+10411012940*r**18
            +1182106229*r**20)-2*Q2**6*(3520059367+208095476*r**2+14968608731*r**4
            -22722706836*r**6-94303906914*r**8+24978156342*r**10+266913461922*r**12
            +294291526986*r**14+142743395259*r**16+42441322886*r**18+6446478355*r**20
            +522470506*r**22)+6*Q2**5*(1378459031+4874315665*r**2+33333711073*r**4
            +61678428641*r**6+31366626696*r**8+2232345036*r**10+66626013276*r**12
            +134003063076*r**14+89003080521*r**16+16636029571*r**18+582852275*r**20
            +670572251*r**22+2150248*r**24)+6*Q2**4*(-424687293-3501229012*r**2-23562371484*r**4
            -47763519174*r**6-15471755525*r**8+13758318126*r**10-91244172816*r**12
            -243488511492*r**14-252035726607*r**16-124614489960*r**18-20393508068*r**20
            +3461632218*r**22-122116959*r**24+113962046*r**26)-108*Q2**3*(14317811
            -38659195*r**2+72361862*r**4-274721234*r**6+313834608*r**8+290473083*r**10
            -5184583995*r**12-14319947824*r**14-16867488837*r**16-7496971881*r**18
            -528127144*r**20-96790910*r**22+354379362*r**24+21474921*r**26+7361373*r**28)
            +54*(-1+r**2)**2*(1377033+6847751*r**2+119252023*r**4-13005667*r**6
            +23369051*r**8+1513245753*r**10+1219841253*r**12-3239639781*r**14-5850391441*r**16
            -1699044167*r**18+7051811665*r**20+7207976371*r**22+1523065133*r**24
            +244094983*r**26+19545491*r**28+166549*r**30)+9*Q2**2*(183213158+227482089*r**2
            +6907892580*r**4+1811422427*r**6-3493711890*r**8+16160353533*r**10+17556210092*r**12
            -25067034225*r**14-57945239214*r**16-3065702165*r**18+146466952860*r**20
            +143257080369*r**22+29571719770*r**24+7209456687*r**26+605316180*r**28
            +48251749*r**30)-27*Q2*(21214964+48202417*r**2+1216641597*r**4-880779427*r**6
            -920099883*r**8+9640859837*r**10+2803103633*r**12-29600627239*r**14-14765089471*r**16
            +12193485811*r**18+1205708199*r**20+31132789943*r**22+42185697967*r**24
            +8886360223*r**26+1705515147*r**28+151021075*r**30+4091207*r**32))+995328000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(103040*Q2**18-480*Q2**17*(20961+19081*r**2)
            +10*Q2**16*(13622559+22333774*r**2+9013167*r**4)-8*Q2**15*(108996301
            +263476179*r**2+204731543*r**4+50477713*r**6)+60*Q2**14*(54710537+179901520*r**2
            +211951793*r**4+104422550*r**6+17636204*r**8)-2*Q2**13*(3844963710+16787396793*r**2
            +27221364332*r**4+20761355874*r**6+7407383694*r**8+944710365*r**10)+2*Q2**12*(5260519005
            +32070369369*r**2+68414695100*r**4+71875935718*r**6+40692992619*r**8
            +11934468357*r**10+1406811840*r**12)-3*Q2**11*(1559835690+21789080481*r**2
            +61741066672*r**4+83136926851*r**6+65984121946*r**8+32611978147*r**10
            +9667777268*r**12+1416620385*r**14)+2*Q2**10*(-5407658433+12805851*r**2
            +22537734466*r**4+33923028525*r**6+47417560978*r**8+60416558737*r**10
            +42549670626*r**12+16029945855*r**14+3074202531*r**16)-5*Q2**9*(-4536879722
            -19318512657*r**2-56295648638*r**4-116462110546*r**6-121097544546*r**8
            -38775077632*r**10+24818567006*r**12+23700915186*r**14+7724108652*r**16
            +1414053361*r**18)+12*Q2**8*(-1340526615-10468917239*r**2-38600851241*r**4
            -94592284812*r**6-121599690887*r**8-58762971960*r**10+22597541651*r**12
            +39453825864*r**14+18094705298*r**16+3670398043*r**18+489692170*r**20)
            -2*Q2**7*(1755706890-26390069437*r**2-105675445720*r**4-363844086099*r**6
            -631640549852*r**8-335091419356*r**10+356577660348*r**12+609621071980*r**14
            +362962590026*r**16+115450254033*r**18+18039597524*r**20+1704576735*r**22)
            +4*Q2**6*(3827718230+9175550919*r**2+57588918713*r**4+88640593909*r**6
            -11463366831*r**8-31314357732*r**10+245884829046*r**12+481607089068*r**14
            +352022081904*r**16+117546403429*r**18+25318179033*r**20+4490332807*r**22
            +264460625*r**24)+12*Q2**5*(-901573162-4877001854*r**2-30885199111*r**4
            -71387829444*r**6-54258405431*r**8-9920326803*r**10-80051265564*r**12
            -222058793922*r**14-237520935102*r**16-115126800026*r**18-18806194957*r**20
            +1104103846*r**22-397419729*r**24+55905899*r**26)-30*Q2**4*(-33393339
            -924356363*r**2-5152217396*r**4-15254174574*r**6-11517250351*r**8+703015619*r**10
            -34161673320*r**12-118498349028*r**14-159827807433*r**16-102319142085*r**18
            -30902857324*r**20-3734822446*r**22+1943668755*r**24+75678733*r**26+49293352*r**28)
            +9*Q2**3*(355026890-64614519*r**2+7312324584*r**4-616890037*r**6-3024351402*r**8
            +23412045825*r**10-41173120852*r**12-259121416053*r**14-432194479146*r**16
            -295439230781*r**18+50165764560*r**20+135758063721*r**22+32662781194*r**24
            +11719708083*r**26+951351708*r**28+136588225*r**30)-54*(-1+r**2)**2*(1377033
            +8224784*r**2+126099774*r**4+106246356*r**6+10363384*r**8+1536614804*r**10
            +2733087006*r**12-2019798528*r**14-9090031222*r**16-7549435608*r**18
            +5352767498*r**20+14259788036*r**22+8731041504*r**24+1767160116*r**26
            +263640474*r**28+19712040*r**30+166549*r**32)-18*Q2**2*(123429025+277651249*r**2
            +5392649730*r**4+3038488363*r**6-2221294556*r**8+20794610577*r**10+21062937262*r**12
            -48156352925*r**14-63653770926*r**16-12215241973*r**18+73509187646*r**20
            +191561201529*r**22+149692947020*r**24+31720128563*r**26+6465659154*r**28
            +553315577*r**30+30262685*r**32)+27*Q2*(23969030+77604751*r**2+1478711122*r**4
            -153461754*r**6-1463614494*r**8+11627763922*r**10+8877401066*r**12-35129676674*r**14
            -40668257962*r**16+10952594208*r**18+22598211126*r**20+15149115890*r**22
            +61636336022*r**24+59883940366*r**26+12700716686*r**28+2266877322*r**30
            +193537068*r**32+4424305*r**34))*sqrtq2)+logq2**4*(16588800*r**20*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-11722240*Q2**20+320*Q2**19*(765803
            +600725*r**2)-8*Q2**18*(262926393+434666126*r**2+171118677*r**4)+Q2**17*(9949674352
            +25935021566*r**2+21442918572*r**4+5640917278*r**6)-8*Q2**16*(3518964419
            +13260946723*r**2+17184312675*r**4+9446839073*r**6+1872724766*r**8)+2*Q2**15*(22689800232
            +127929613803*r**2+234012451840*r**4+200538306176*r**6+83542116260*r**8
            +13523666913*r**10)-3*Q2**14*(8074388640+111870623925*r**2+280087025333*r**4
            +332636481666*r**6+224404379662*r**8+80209137505*r**10+11631615285*r**12)
            +Q2**13*(-56234803608+79055329149*r**2+365704805694*r**4+481372948183*r**6
            +642321416036*r**8+583827290751*r**10+236313817614*r**12+35714778693*r**14)
            +Q2**12*(130275189504+514390649367*r**2+1786767729435*r**4+4170970365719*r**6
            +4372085765487*r**8+1742230111765*r**10-51344282199*r**12-185903297571*r**14
            -33832517139*r**16)+2*Q2**11*(-44735533792-450719020164*r**2-2090733275502*r**4
            -6281582030853*r**6-9340802008036*r**8-6943363634619*r**10-2479888034118*r**12
            -258257479383*r**14+73480731216*r**16+13907005427*r**18)+Q2**10*(-51943416592
            +539137873997*r**2+3110898975831*r**4+14754633301684*r**6+30484428825300*r**8
            +31652272011750*r**10+18414124459954*r**12+6125090981444*r**14+934864155828*r**16
            -78995955115*r**18-9353217793*r**20)-Q2**9*(-135449151960-310869273775*r**2
            -2320399273698*r**4+671914032019*r**6+11827034797628*r**8+19054828763350*r**10
            +18393918278600*r**12+12416284289562*r**14+5541402683564*r**16+1419805196553*r**18
            +50424751850*r**20+15180774915*r**22)+Q2**8*(-74637414352-800071416749*r**2
            -6580198440315*r**4-19336272588271*r**6-34306410444397*r**8-42488076940986*r**10
            -22915688738726*r**12+7024867754666*r**14+13988658388014*r**16+6796245807383*r**18
            +1789949581105*r**20+152770838421*r**22+24524575487*r**24)-2*Q2**7*(14583743032
            -265319041759*r**2-2100450883932*r**4-10973893174354*r**6-25911555797068*r**8
            -39810651362361*r**10-28314583510992*r**12+6385154754144*r**14+22768169488560*r**16
            +14576359829507*r**18+4307370046108*r**20+769438022850*r**22+79561995412*r**24
            +6217703653*r**26)+Q2**6*(56916592224+46008158883*r**2+1709030582983*r**4
            -5589671990246*r**6-11333804740202*r**8-25124358997911*r**10-24239389747287*r**12
            +36678009591420*r**14+83135341911108*r**16+60769664719701*r**18+25080834300297*r**20
            +6005322497834*r**22+805178173382*r**24+106175367263*r**26-4211011449*r**28)
            +3*Q2**5*(-7357407416-104051172879*r**2-1330183150234*r**4-2659733999133*r**6
            -11170520944380*r**8-14552262104363*r**10-2264349614734*r**12-4720259809785*r**14
            -23513444031408*r**16-22867802321005*r**18-6961016834022*r**20-978844160807*r**22
            -535504590876*r**24-78122842329*r**26-12952170610*r**28+3214945981*r**30)
            -3*Q2**4*(1913776000-63552470375*r**2-600432948767*r**4-2639525453539*r**6
            -9835017238663*r**8-12106751485795*r**10+2237477075685*r**12+2673516814929*r**14
            -27008845100307*r**16-49272002577349*r**18-34587165248845*r**20-8162698684345*r**22
            +907628580763*r**24-113838268529*r**26+8258820487*r**28+6382775115*r**30
            +1624433535*r**32)-18*Q2**3*(-428627728+356575494*r**2-24701529634*r**4
            +148566624309*r**6-26543058452*r**8+149641892515*r**10-296478006014*r**12
            +466449453661*r**14+5573543725912*r**16+10361847213919*r**18+8237860461954*r**20
            +3285971279431*r**22+975989477100*r**24-243861699871*r**26-17230214242*r**28
            -11931623641*r**30-2283163936*r**32+31219223*r**34)+27*(-1+r**2)**2*(1025208
            -126853717*r**2-1485678209*r**4-4773279832*r**6-49616128420*r**8+34267784196*r**10
            +34380257296*r**12-412461762168*r**14-555521077604*r**16+831385938290*r**18
            +1888275554134*r**20-410131966216*r**22-1827653549612*r**24-589358320796*r**26
            -137076828120*r**28-17920309288*r**30-1430489988*r**32-36208261*r**34
            +5093107*r**36)+9*Q2**2*(-263338088-5134905689*r**2-81059736319*r**4
            +3574484280*r**6-1418026790672*r**8+333551050612*r**10+1058164516740*r**12
            -2091486434840*r**14+259531693728*r**16+4899668793994*r**18+3099861878990*r**20
            -10941683188088*r**22-15618481573488*r**24-4566324419596*r**26-1526062358572*r**28
            -194986788264*r**30-32028924088*r**32-3108019353*r**34+204458713*r**36)
            -27*Q2*(-6279656-822570777*r**2-9814621798*r**4-8435475343*r**6-250406887076*r**8
            +343105861328*r**10+90654419236*r**12-1201632210696*r**14+250864760604*r**16
            +967506883878*r**18+516364397112*r**20+2818306309234*r**22-1157099310764*r**24
            -5144493282904*r**26-1600845519428*r**28-426497040784*r**30-57335044068*r**32
            -6209898117*r**34-343202482*r**36+31512501*r**38))-16588800*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(11722240*Q2**20-320*Q2**19*(765803+600725*r**2)
            +8*Q2**18*(262926393+434666126*r**2+171118677*r**4)-2*Q2**17*(4974837176
            +12967510783*r**2+10721459286*r**4+2820458639*r**6)+8*Q2**16*(3518964419
            +13260946723*r**2+17184312675*r**4+9446839073*r**6+1872724766*r**8)-2*Q2**15*(22689800232
            +127929613803*r**2+234012451840*r**4+200538306176*r**6+83542116260*r**8
            +13523666913*r**10)+3*Q2**14*(8074388640+111870623925*r**2+280087025333*r**4
            +332636481666*r**6+224404379662*r**8+80209137505*r**10+11631615285*r**12)
            -Q2**13*(-56234803608+79055329149*r**2+365704805694*r**4+481372948183*r**6
            +642321416036*r**8+583827290751*r**10+236313817614*r**12+35714778693*r**14)
            +Q2**12*(-130275189504-514390649367*r**2-1786767729435*r**4-4170970365719*r**6
            -4372085765487*r**8-1742230111765*r**10+51344282199*r**12+185903297571*r**14
            +33832517139*r**16)+2*Q2**11*(44735533792+450719020164*r**2+2090733275502*r**4
            +6281582030853*r**6+9340802008036*r**8+6943363634619*r**10+2479888034118*r**12
            +258257479383*r**14-73480731216*r**16-13907005427*r**18)+Q2**10*(51943416592
            -539137873997*r**2-3110898975831*r**4-14754633301684*r**6-30484428825300*r**8
            -31652272011750*r**10-18414124459954*r**12-6125090981444*r**14-934864155828*r**16
            +78995955115*r**18+9353217793*r**20)+Q2**9*(-135449151960-310869273775*r**2
            -2320399273698*r**4+671914032019*r**6+11827034797628*r**8+19054828763350*r**10
            +18393918278600*r**12+12416284289562*r**14+5541402683564*r**16+1419805196553*r**18
            +50424751850*r**20+15180774915*r**22)+Q2**8*(74637414352+800071416749*r**2
            +6580198440315*r**4+19336272588271*r**6+34306410444397*r**8+42488076940986*r**10
            +22915688738726*r**12-7024867754666*r**14-13988658388014*r**16-6796245807383*r**18
            -1789949581105*r**20-152770838421*r**22-24524575487*r**24)+2*Q2**7*(14583743032
            -265319041759*r**2-2100450883932*r**4-10973893174354*r**6-25911555797068*r**8
            -39810651362361*r**10-28314583510992*r**12+6385154754144*r**14+22768169488560*r**16
            +14576359829507*r**18+4307370046108*r**20+769438022850*r**22+79561995412*r**24
            +6217703653*r**26)+Q2**6*(-56916592224-46008158883*r**2-1709030582983*r**4
            +5589671990246*r**6+11333804740202*r**8+25124358997911*r**10+24239389747287*r**12
            -36678009591420*r**14-83135341911108*r**16-60769664719701*r**18-25080834300297*r**20
            -6005322497834*r**22-805178173382*r**24-106175367263*r**26+4211011449*r**28)
            +3*Q2**5*(7357407416+104051172879*r**2+1330183150234*r**4+2659733999133*r**6
            +11170520944380*r**8+14552262104363*r**10+2264349614734*r**12+4720259809785*r**14
            +23513444031408*r**16+22867802321005*r**18+6961016834022*r**20+978844160807*r**22
            +535504590876*r**24+78122842329*r**26+12952170610*r**28-3214945981*r**30)
            +3*Q2**4*(1913776000-63552470375*r**2-600432948767*r**4-2639525453539*r**6
            -9835017238663*r**8-12106751485795*r**10+2237477075685*r**12+2673516814929*r**14
            -27008845100307*r**16-49272002577349*r**18-34587165248845*r**20-8162698684345*r**22
            +907628580763*r**24-113838268529*r**26+8258820487*r**28+6382775115*r**30
            +1624433535*r**32)+18*Q2**3*(-428627728+356575494*r**2-24701529634*r**4
            +148566624309*r**6-26543058452*r**8+149641892515*r**10-296478006014*r**12
            +466449453661*r**14+5573543725912*r**16+10361847213919*r**18+8237860461954*r**20
            +3285971279431*r**22+975989477100*r**24-243861699871*r**26-17230214242*r**28
            -11931623641*r**30-2283163936*r**32+31219223*r**34)-27*(-1+r**2)**2*(1025208
            -126853717*r**2-1485678209*r**4-4773279832*r**6-49616128420*r**8+34267784196*r**10
            +34380257296*r**12-412461762168*r**14-555521077604*r**16+831385938290*r**18
            +1888275554134*r**20-410131966216*r**22-1827653549612*r**24-589358320796*r**26
            -137076828120*r**28-17920309288*r**30-1430489988*r**32-36208261*r**34
            +5093107*r**36)-9*Q2**2*(-263338088-5134905689*r**2-81059736319*r**4
            +3574484280*r**6-1418026790672*r**8+333551050612*r**10+1058164516740*r**12
            -2091486434840*r**14+259531693728*r**16+4899668793994*r**18+3099861878990*r**20
            -10941683188088*r**22-15618481573488*r**24-4566324419596*r**26-1526062358572*r**28
            -194986788264*r**30-32028924088*r**32-3108019353*r**34+204458713*r**36)
            +27*Q2*(-6279656-822570777*r**2-9814621798*r**4-8435475343*r**6-250406887076*r**8
            +343105861328*r**10+90654419236*r**12-1201632210696*r**14+250864760604*r**16
            +967506883878*r**18+516364397112*r**20+2818306309234*r**22-1157099310764*r**24
            -5144493282904*r**26-1600845519428*r**28-426497040784*r**30-57335044068*r**32
            -6209898117*r**34-343202482*r**36+31512501*r**38))*sqrtq2)+logq2**3*(
            -276480*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(131393280*Q2**23-64*Q2**22*(32065407
            +28285919*r**2)+2*Q2**21*(7110905763+12953556454*r**2+5669839171*r**4)
            -6*Q2**20*(9321574513+27427278285*r**2+24724044551*r**4+7010930091*r**6)
            +20*Q2**19*(6487964736+29601488999*r**2+42076914016*r**4+24824988363*r**6
            +5067060242*r**8)-10*Q2**18*(14950654554+124573984681*r**2+252575856230*r**4
            +235052702376*r**6+104831298400*r**8+16537842895*r**10)+12*Q2**17*(-3882126164
            +102822463547*r**2+285674715530*r**4+360944888420*r**6+285554608325*r**8
            +117268592551*r**10+15830812747*r**12)+Q2**16*(430955971446+750517908613*r**2
            +2381735666872*r**4+6033342061035*r**6+3877137527730*r**8-825644898989*r**10
            -1136971984632*r**12-165844012763*r**14)+Q2**15*(-567155261928-4104565951375*r**2
            -17856412112571*r**4-49862936262651*r**6-62040272389455*r**8-34060412110433*r**10
            -6499343217765*r**12+435670444619*r**14+113537409719*r**16)-15*Q2**14*(
            -4246607176-339487430609*r**2-1867135853716*r**4-7448465082416*r**6-13097779160348*r**8
            -11345548121006*r**10-4935646326396*r**12-904738777184*r**14-10083755148*r**16
            +939022863*r**18)-5*Q2**13*(-132862730748+165190726679*r**2+1424333570565*r**4
            +19926343417860*r**6+53123497796556*r**8+65293844144414*r**10+45484978455042*r**12
            +17415356181084*r**14+3074326066800*r**16+135119600235*r**18+26222198201*r**20)
            +Q2**12*(-718268123508-5391962373221*r**2-38261633083730*r**4-60373112492025*r**6
            -27562936479000*r**8+1795466927018*r**10+77987706549156*r**12+120700874951010*r**14
            +65322579224460*r**16+14290090020795*r**18+1402645496302*r**20+184515237079*r**22)
            +3*Q2**11*(4113721352+2219576168871*r**2+18505709844919*r**4+85485115203705*r**6
            +217581526318705*r**8+413104085544498*r**10+429857954906354*r**12+204124579807966*r**14
            +22667788735190*r**16-14357559025945*r**18-4471656298473*r**20-588008939159*r**22
            -13024688271*r**24)-Q2**10*(-539396661552+1536826948465*r**2+14352858590576*r**4
            +256098828753726*r**6+881106607769200*r**8+2366436652631407*r**10+3509523984882240*r**12
            +2705640786878324*r**14+1084239948725104*r**16+173470814167455*r**18-28710366199472*r**20
            -8929057169650*r**22-1051765117104*r**24+142971583681*r**26)+5*Q2**9*(
            -74381361888-752536401067*r**2-7641727027913*r**4+3031035481398*r**6
            +18264053775098*r**8+248594149499403*r**10+633795678102945*r**12+703537118881060*r**14
            +446374604770556*r**16+182260485291675*r**18+44135405138057*r**20+691216917286*r**22
            +153658902954*r**24+52904568581*r**26+26987810399*r**28)+15*Q2**8*(-4316958932
            +260439331523*r**2+2789954802170*r**4+14761240923617*r**6+66153448221784*r**8
            +121655447089183*r**10+104217574639014*r**12+42781756130901*r**14-41140464082900*r**16
            -81966756010551*r**18-56116639899578*r**20-20002921080285*r**22-2834890404784*r**24
            -553642692523*r**26-69094558310*r**28+517975591*r**30)+Q2**7*(199647263112
            -677344888861*r**2-7038812700745*r**4-219671791979445*r**6-988354293167625*r**8
            -3245356439718557*r**10-5139480777816729*r**12-5124355856780285*r**14
            -1742572866080145*r**16+2257136575107585*r**18+2744793610791613*r**20
            +1253718733626121*r**22+318369407285325*r**24+51418806342585*r**26+7854238690085*r**28
            +788580286377*r**30-75004228411*r**32)+Q2**6*(-71753957304-1344288858947*r**2
            -16068168701748*r**4+38963036652540*r**6-30263471084220*r**8+1495605541056004*r**10
            +2230310749100892*r**12+2367741251772308*r**14+234695427950180*r**16-4650545107181010*r**18
            -5726270607978076*r**20-3299083227104988*r**22-1075464347122932*r**24
            -191789633077020*r**26-33580071299020*r**28-2642930271924*r**30-33176545532*r**32
            +29222090797*r**34)+3*Q2**5*(-9607420086+340193021465*r**2+4153327659613*r**4
            +29875088361488*r**6+217724049581280*r**8+206195923687616*r**10+857244215262720*r**12
            +872832249479032*r**14+112187082894492*r**16+931145286876370*r**18+1605512420004106*r**20
            +752268952327520*r**22+188977562253952*r**24+89365427723832*r**26+19255782955000*r**28
            +5631776106264*r**30-432158703430*r**32-139597630947*r**34+6218199713*r**36)
            -15*Q2**4*(-1871569222+8735521127*r**2+128485237308*r**4+4942169050491*r**6
            +25008076409120*r**8+65562260498392*r**10+183828266277376*r**12+146799405892704*r**14
            -117539956395148*r**16-6216223734434*r**18+436738430737032*r**20+489576606083982*r**22
            +151260430980048*r**24-18702578051552*r**26+389903161088*r**28+915891353048*r**30
            +359252747490*r**32-126344554685*r**34-20165515716*r**36+1187471551*r**38)
            +45*Q2**3*(-89999000-3853835017*r**2-44565636165*r**4+232151230029*r**6
            -947336966319*r**8+10654326036600*r**10-3201667820920*r**12+2669631076304*r**14
            -15840843407824*r**16+39568603855598*r**18+208229067999078*r**20+258564698329186*r**22
            +169418876094042*r**24+73415474244576*r**26-734760938064*r**28+468800337304*r**30
            -360184955024*r**32-139231851581*r**34-18956622681*r**36-242414615*r**38
            +38044493*r**40)+54*(-1+r**2)**2*(-2974047+20245601*r**2+786515140*r**4
            +24767353000*r**6+135491898345*r**8+160740285113*r**10+3467548654136*r**12
            -5279716818520*r**14-4747115901350*r**16+35453997364890*r**18+19891468895168*r**20
            -79590891967464*r**22-37374020615630*r**24+59262868530450*r**26+26845249871560*r**28
            +9174638200888*r**30+1631412940741*r**32+183749570885*r**34+22222347900*r**36
            -434357920*r**38-141142747*r**40+4303861*r**42)+9*Q2**2*(-320062732+10987406551*r**2
            +148616019860*r**4+1552366354770*r**6+13112732075400*r**8-16799907357497*r**10
            +171470715463376*r**12-94359289046200*r**14-111000221085480*r**16+73901216034030*r**18
            -232117505676712*r**20-227227636931204*r**22+509689817176320*r**24+954586630050150*r**26
            +332036461700240*r**28+160373647124968*r**30+23871383997076*r**32+5105612314395*r**34
            +1193811643060*r**36+12120675330*r**38-10203346152*r**40+376670451*r**42)
            -27*Q2*(-47620288+764467331*r**2+13289934749*r**4+285695171470*r**6
            +1569059175750*r**8-1423108469633*r**10+33738788994061*r**12-59150468344616*r**14
            -14207557517960*r**16+118270051477750*r**18+60751390198202*r**20-31239756257244*r**22
            -299021410323596*r**24-116580974538490*r**26+336624999793250*r**28+140335743681272*r**30
            +53618349952856*r**32+9080255542919*r**34+1214077788105*r**36+224916890750*r**38
            -1197055178*r**40-1776522629*r**42+59181169*r**44))+276480*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(131393280*Q2**24-64*Q2**23*(34118427
            +30338939*r**2)+2*Q2**22*(8136998787+14884798886*r**2+6574988579*r**4)
            -4*Q2**21*(17537814651+51173148536*r**2+46397764639*r**4+13351314722*r**6)
            +2*Q2**20*(92844370899+406261448384*r**2+577223108668*r**4+343454807556*r**6
            +71703392693*r**8)-10*Q2**19*(27926584026+196752892151*r**2+395932662260*r**4
            +368856507134*r**6+164615395610*r**8+26671963379*r**10)+2*Q2**18*(51460515786
            +1314557977457*r**2+3599797497735*r**4+4603812123550*r**6+3412747653830*r**8
            +1310457261781*r**10+177674090957*r**12)-Q2**17*(-477541485414+436766139983*r**2
            +2280230482052*r**4+1726093186365*r**6+3880856433210*r**8+5659523309501*r**10
            +2734164848208*r**12+355813765727*r**14)+2*Q2**16*(-499055616687-2643019915717*r**2
            -10494332844028*r**4-29139006995279*r**6-35975375989110*r**8-18555952369587*r**10
            -2268363167072*r**12+869243221007*r**14+139690711241*r**16)+2*Q2**15*(315427184784
            +4882016336219*r**2+24984007934843*r**4+89723162305731*r**6+154184948028663*r**8
            +133141953157489*r**10+57297225112069*r**12+9817377215453*r**14-198975763559*r**16
            -63811376332*r**18)-10*Q2**14*(-60061454610+598196420017*r**2+4022101711770*r**4
            +23936573113128*r**6+57381115262424*r**8+69311912994238*r**10+47164280898624*r**12
            +17468255745912*r**14+2909396831898*r**16+81276898545*r**18+11702564806*r**20)
            +2*Q2**13*(-691290888624-2615161196783*r**2-15157005798755*r**4+23190136225050*r**6
            +168843134796540*r**8+296941088315934*r**10+315940909773218*r**12+217601274065820*r**14
            +83885495231940*r**16+15168659177985*r**18+1104677244241*r**20+157813114042*r**22)
            -2*Q2**12*(-365304643782-6384479501671*r**2-49585362495854*r**4-177545045593435*r**6
            -370340313963570*r**8-632539863092738*r**10-604895345621444*r**12-206842578961866*r**14
            +59010043984950*r**16+61342673161545*r**18+14553852206258*r**20+1675593775429*r**22
            +111794650946*r**24)-2*Q2**11*(-263527748748+4103948309567*r**2+38264358315973*r**4
            +284035651949799*r**6+895153266168215*r**8+2129246744110508*r**10+3019205053117398*r**12
            +2303794195510642*r**14+882308527177286*r**16+99200751647595*r**18-42599006086363*r**20
            -12054026441273*r**22-1427432999697*r**24+51948759434*r**26)+2*Q2**10*(
            -455651735496-1382625859211*r**2-11159474800262*r**4+142803432375646*r**6
            +614262852699208*r**8+2245257003948811*r**10+4522469514014186*r**12+4866425183082932*r**14
            +3010876879728104*r**16+1084506594675467*r**18+182718736829134*r**20-17091669391346*r**22
            -4606263885992*r**24-322135345259*r**26+138955317838*r**28)-10*Q2**9*(
            -30715242546-804117878762*r**2-8382063917745*r**4-24447207158683*r**6
            -88582627704428*r**8-49054068996524*r**10+284868551842653*r**12+604493764295651*r**14
            +636666557950158*r**16+437267679046942*r**18+197372905064233*r**20+52417692648099*r**22
            +4674773517296*r**24+933745774552*r**26+143588026955*r**28+12716941813*r**30)
            -2*Q2**8*(-132200823546+2259590238863*r**2+26397362353070*r**4+241469863933125*r**6
            +1101037315174320*r**8+3031244934691531*r**10+4263788051869842*r**12+3664672909164505*r**14
            +883596123400080*r**16-2051872438254675*r**18-2408022274721774*r**20-1197756074162033*r**22
            -330468289780680*r**24-51123401401095*r**26-8597648726290*r**28-908614513581*r**30
            +41386931138*r**32)+2*Q2**7*(-135700610208-433295616599*r**2-4176005556071*r**4
            +132836820666365*r**6+588881307031425*r**8+2864658136971093*r**10+5307573983318089*r**12
            +6315788943184661*r**14+3550812075405305*r**16-2582554408104225*r**18
            -5364100396938637*r**20-3648797785761361*r**22-1323776244017189*r**24
            -280788923352465*r**26-46426558165845*r**28-5642874624193*r**30-373376301749*r**32
            +52113159604*r**34)+2*Q2**6*(21465848523+1218310940323*r**2+14936220269767*r**4
            +33365198566836*r**6+322236291587760*r**8-423377149454468*r**10-577091822184368*r**12
            -989777626218052*r**14-1132937715519506*r**16+3604642769929970*r**18+7596676487585702*r**20
            +5641080346032812*r**22+2470740130494888*r**24+767675131685724*r**26+141568526620520*r**28
            +26559164944868*r**30+689815353583*r**32-207419219053*r**34-5283745829*r**36)
            -6*Q2**5*(-9482633098+187131603507*r**2+2567973433809*r**4+29369630636778*r**6
            +186319759994184*r**8+375865637880428*r**10+991290735168608*r**12+1232036747102636*r**14
            +198659775198892*r**16+506125625549346*r**18+2360174930282818*r**20+2402832201375768*r**22
            +848774334740856*r**24+92415049860012*r**26+55285363242136*r**28+14733507913252*r**30
            +3497940570142*r**32-601739553901*r**34-117103504907*r**36+6077778734*r**38)
            +30*Q2**4*(-1070783111-2348776573*r**2+1761924970*r**4+2883553988943*r**6
            +13554117280327*r**8+61266657508656*r**10+119892761656504*r**12+169318282699496*r**14
            -9131540362958*r**16-2525184281394*r**18+527604705499916*r**20+851004565904286*r**22
            +574546832673078*r**24+176402137831112*r**26-10258478852328*r**28+1356097763024*r**30
            +97294617733*r**32-92393680969*r**34-101689969222*r**36-9852644005*r**38
            +650802515*r**40)+18*Q2**3*(64966134+15353288318*r**2+195356687885*r**4
            +307219192725*r**6+8344330378425*r**8-32667426354451*r**10+67103712192488*r**12
            -45849552661560*r**14-22572079713940*r**16-22368793102420*r**18-735552932475046*r**20
            -1280598234286262*r**22-815114027469910*r**24-129792560821470*r**26-15683552416160*r**28
            +80851725064384*r**30+11664153542838*r**32+3801348173710*r**34+992377007185*r**36
            +54057930905*r**38-4590747771*r**40+93223993*r**42)-54*(-1+r**2)**2*(
            -2974047+17271554*r**2+806760741*r**4+25553868140*r**6+160259251345*r**8
            +296232183458*r**10+3628288939249*r**12-1812168164384*r**14-10026832719870*r**16
            +30706881463540*r**18+55345466260058*r**20-59699423072296*r**22-116964912583094*r**24
            +21888847914820*r**26+86108118402010*r**28+36019888072448*r**30+10806051141629*r**32
            +1815162511626*r**34+205971918785*r**36+21787989980*r**38-575500667*r**40
            -136838886*r**42+4303861*r**44)-18*Q2**2*(-231461798+6480372906*r**2
            +99736615329*r**4+1279033944520*r**6+9686137978710*r**8-3978250345498*r**10
            +127943587544031*r**12-50169989308336*r**14-123991091342780*r**16+158855574690900*r**18
            +12018940475962*r**20-276532205689824*r**22-307301025362836*r**24+557266761805500*r**26
            +1148249045565070*r**28+456708669934512*r**30+172550040490306*r**32+28108881470114*r**34
            +4970828660885*r**36+940341495320*r**38-836918178*r**40-7578121794*r**42
            +277106979*r**44)+27*Q2*(-53568382+769234433*r**2+15540501862*r**4+345414242861*r**6
            +2028241762190*r**8-25001611037*r**10+38878800488938*r**12-49519827033913*r**14
            -54798293082924*r**16+183399518657930*r**18+67494158204028*r**20-138328030844862*r**22
            -46862702151908*r**24-306762349273594*r**26-38064990355180*r**28+506454757450958*r**30
            +214208866455178*r**32+74889729276357*r**34+12866605624766*r**36+1716735713185*r**38
            +269619677558*r**40-3269114937*r**42-2016842398*r**44+67788891*r**46))*sqrtq2)
            +logq2**2*(4608*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(
            -326225408*Q2**26+416*Q2**25*(12022703+11625863*r**2)-4*Q2**24*(8289527135
            +17275397246*r**2+7936701215*r**4)+2*Q2**23*(60423924280+213062144563*r**2
            +207206949438*r**4+60741804355*r**6)-4*Q2**22*(60827174410+359587638101*r**2
            +559399155583*r**4+354240693991*r**6+74849906035*r**8)+4*Q2**21*(43181970350
            +658663743019*r**2+1468747027084*r**4+1494455169649*r**6+752822589284*r**8
            +122765232770*r**10)-2*Q2**20*(-188778580660+694780751187*r**2+2096806338645*r**4
            +2594816572730*r**6+3363071947440*r**8+1970002810767*r**10+257576385995*r**12)
            +Q2**19*(-1088890155340-4977660833539*r**2-19802702240070*r**4-49038532948525*r**6
            -40387966661200*r**8-6983542935825*r**10+2507933393786*r**12+240866741465*r**14)
            +2*Q2**18*(421042013380+6248771347723*r**2+32328035942008*r**4+109549703012695*r**6
            +149613119372800*r**8+88112074410745*r**10+19086528571408*r**12+621427734373*r**14
            +119398724980*r**16)-Q2**17*(-784710912060+9684570176009*r**2+69592743335172*r**4
            +400973469891374*r**6+799392069672200*r**8+743654321944200*r**10+342288825420164*r**12
            +66016146091322*r**14+5086698787644*r**16+578016222615*r**18)+2*Q2**16*(
            -1036329828510-3836402218627*r**2-18051245278057*r**4+102377435394548*r**6
            +383485607427028*r**8+511130153141522*r**10+407437153613198*r**12+179677262568868*r**14
            +33590693636498*r**16+3434333295753*r**18+184731759555*r**20)+4*Q2**15*(260441430060
            +5787497282254*r**2+46053040045855*r**4+147945516457115*r**6+278476548753095*r**8
            +478443807174113*r**10+355775844077993*r**12+44598774280055*r**14-43146755631835*r**16
            -12258146381855*r**18-1460719107936*r**20+85356085470*r**22)-4*Q2**14*(
            -317519484940+3943937984276*r**2+42766397548995*r**4+331027334273300*r**6
            +1018353805266050*r**8+2457112266412800*r**10+3038095349575034*r**12+1779826095579920*r**14
            +431518728048600*r**16+7959115364300*r**18-6499191540685*r**20-460850952324*r**22
            +193122929090*r**24)+4*Q2**13*(-471316084160-2251428307711*r**2-13523369212601*r**4
            +218029104289705*r**6+958895164894100*r**8+3768095316004615*r**10+6796886456934046*r**12
            +6048432306047246*r**14+2796382666071940*r**16+604275803656975*r**18+35793831759755*r**20
            +3294403035049*r**22+979613883064*r**24+74715667465*r**26)+4*Q2**12*(74325505540
            +5569597906769*r**2+58939865558102*r**4+172103023795964*r**6+496151133945635*r**8
            -985542302520925*r**10-4852264782133159*r**12-6593819699253232*r**14-5046678140187394*r**16
            -2272805821358425*r**18-522664651146940*r**20-66482813715196*r**22-14524138743973*r**24
            -1721183530571*r**26+116773174765*r**28)-2*Q2**11*(-526839804620+5248336742097*r**2
            +74622892779012*r**4+851017469403457*r**6+3818033980676542*r**8+10515648724470951*r**10
            +15339941178130498*r**12+18989460967550683*r**14+12263047194522888*r**16
            +935263311709303*r**18-2304917351375744*r**20-902275657755153*r**22-194611418128538*r**24
            -27528901710543*r**26-1500591689958*r**28+244460921365*r**30)-4*Q2**10*(182721140780
            +1939227165971*r**2+16408358083905*r**4-249905289469345*r**6-1343233789672310*r**8
            -8345687532402877*r**10-19390561445464609*r**12-36477620582891105*r**14
            -39931546210533280*r**16-21656057821157815*r**18-4625464143314129*r**20
            +665726517637133*r**22+383918725624130*r**24+84646642995905*r**26+130436705265*r**28
            -985054629739*r**30+22502697320*r**32)+2*Q2**9*(-76326583420+5588243848193*r**2
            +68687203298930*r**4+238828051098800*r**6+1192075892315500*r**8-7222210403696150*r**10
            -20887032454354418*r**12-69488621826104660*r**14-115783524536927600*r**16
            -93450599237691800*r**18-41780451745845170*r**20-9919440966995768*r**22
            +240284224812460*r**24+214083862682750*r**26+49345096555250*r**28-17277678677860*r**30
            -2772013345132*r**32+173694771695*r**34)-4*Q2**8*(-90742940315+634738215601*r**2
            +12220836101061*r**4+261069445170850*r**6+1497263368870275*r**8+4393595083668660*r**10
            +14295300322331129*r**12+12960594003559334*r**14-9323184449687295*r**16
            -20307500206589750*r**18-18473671008065545*r**20-12791166332386866*r**22
            -5539247115522271*r**24-976962426476340*r**26-239025569827725*r**28-38042998097750*r**30
            -5030561859914*r**32-232223357499*r**34+25356862360*r**36)-2*Q2**7*(44046338720
            +1741535541067*r**2+15743410266236*r**4-234415252887883*r**6-1391299108754290*r**8
            -14230816828096650*r**10-44629069639786082*r**12-102094900029889186*r**14
            -104362722920775602*r**16-66470198564834380*r**18+4250341289991270*r**20
            +52540356206495728*r**22+39091862574841114*r**24+13919688141426538*r**26
            +2952723550226250*r**28+612975703947410*r**30+116742929485162*r**32-760415875039*r**34
            -1341611103178*r**36+57901202795*r**38)+4*Q2**6*(-18539358370+633534140149*r**2
            +8047729125574*r**4+48505025881039*r**6+302234324264489*r**8-2888675621674012*r**10
            -3341280943682624*r**12-34417976271417124*r**14-33057645370630564*r**16
            -17452583352773514*r**18+18726275180354484*r**20+58442613913600626*r**22
            +51270703532500226*r**24+22669473156478036*r**26+5137462079767936*r**28
            +1028766435796748*r**30+127094369900974*r**32+26831349945949*r**34-1134762771386*r**36
            -429667589161*r**38+19616540525*r**40)+12*Q2**5*(3746672750-848232902*r**2
            -501219050405*r**4-24593506374150*r**6-153684176104300*r**8-646394384457403*r**10
            -4261733721406144*r**12+453006121958480*r**14-9183950477895100*r**16-9661488761206100*r**18
            -3907422974080026*r**20-13363027648597236*r**22-10834556256850120*r**24
            -4157621003785550*r**26-2070508068615800*r**28-446688130260464*r**30-198648948991538*r**32
            -1118131068830*r**34+4863462845175*r**36+161478263450*r**38-32904070732*r**40
            +972106945*r**42)-6*Q2**4*(-172227660+101858645189*r**2+678746480325*r**4
            -15638449299750*r**6-105444126661150*r**8-1675492439664075*r**10-5397992355329031*r**12
            -6732494281871160*r**14-25146500033707800*r**16-12269476955413350*r**18
            +26065366999093010*r**20-9095777245036116*r**22-45539219724491820*r**24
            -17436317780917150*r**26+3741543169231650*r**28+772482505791720*r**30
            +30090799767444*r**32-227666349173055*r**34+220914522825*r**36+14736645307850*r**38
            +251112815130*r**40-124397373111*r**42+4039510085*r**44)+27*Q2**3*(-260497220
            +7467613863*r**2+87793816778*r**4+1044825355365*r**6+5173047643300*r**8
            -95821650948155*r**10+175852068889158*r**12-1502405523291897*r**14+451306817637800*r**16
            +520720248640950*r**18+2629662758127060*r**20-6910546092507902*r**22-17178257417526952*r**24
            -15286764141697990*r**26-9383655929703300*r**28-1072962444223650*r**30
            -258476981286372*r**32+11438721022483*r**34+10478042890370*r**36+1247471248425*r**38
            +861518846340*r**40+15339748753*r**42-5782344162*r**44+166546955*r**46)
            +54*(-1+r**2)**2*(-951822+84821783*r**2+230078663*r**4-15769479977*r**6
            -209092551027*r**8-3779551466787*r**10-5974487414907*r**12-7482339777427*r**14
            -311214379330967*r**16+880035090988358*r**18-344749333489082*r**20-3184907622036602*r**22
            +2196970569628178*r**24+3928883339354138*r**26-2117181625204662*r**28
            -1133590431901062*r**30-599041953642332*r**32-153332475082477*r**34-18682834106717*r**36
            -3330064433517*r**38-317293391247*r**40+39311681433*r**42+1502109313*r**44
            -173792727*r**46+3391473*r**48)+18*Q2**2*(93396020+1751381547*r**2-22235637774*r**4
            -1666464373113*r**6-10785140873460*r**8-81122196720675*r**10-537235172894798*r**12
            +1570289588948121*r**14-7320821316000588*r**16+5180241799623710*r**18
            +5014985854522980*r**20+1756809013231062*r**22+4307311541918856*r**24
            -8664952087922358*r**26-17826061906233420*r**28-5616448146407390*r**30
            -4488085495507668*r**32-727851880764729*r**34-133455886807318*r**36-68375212037325*r**38
            -6830286219060*r**40+845245414857*r**42+36775048026*r**44-6216834123*r**46
            +157748620*r**48)-27*Q2*(-2924084+1094293587*r**2-23204528*r**4-318440798058*r**6
            -2555582142368*r**8-38296624336188*r**10-82175066946448*r**12+310022373625762*r**14
            -3281529475082868*r**16+7268754015842047*r**18-813515858539808*r**20-12813210721355428*r**22
            -1853172430990368*r**24+14487966646017952*r**26+12087044936204192*r**28
            -12076778599858108*r**30-5802992950709148*r**32-3494449737204063*r**34
            -796667625067568*r**36-90598150428178*r**38-27594407546688*r**40-3383784073188*r**42
            +399875545072*r**44+18482218042*r**46-2362235068*r**48+51695501*r**50))
            -4608*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(326225408*Q2**26-416*Q2**25*(12022703
            +11625863*r**2)+4*Q2**24*(8289527135+17275397246*r**2+7936701215*r**4)
            -2*Q2**23*(60423924280+213062144563*r**2+207206949438*r**4+60741804355*r**6)
            +4*Q2**22*(60827174410+359587638101*r**2+559399155583*r**4+354240693991*r**6
            +74849906035*r**8)-4*Q2**21*(43181970350+658663743019*r**2+1468747027084*r**4
            +1494455169649*r**6+752822589284*r**8+122765232770*r**10)+2*Q2**20*(-188778580660
            +694780751187*r**2+2096806338645*r**4+2594816572730*r**6+3363071947440*r**8
            +1970002810767*r**10+257576385995*r**12)+Q2**19*(1088890155340+4977660833539*r**2
            +19802702240070*r**4+49038532948525*r**6+40387966661200*r**8+6983542935825*r**10
            -2507933393786*r**12-240866741465*r**14)-2*Q2**18*(421042013380+6248771347723*r**2
            +32328035942008*r**4+109549703012695*r**6+149613119372800*r**8+88112074410745*r**10
            +19086528571408*r**12+621427734373*r**14+119398724980*r**16)+Q2**17*(
            -784710912060+9684570176009*r**2+69592743335172*r**4+400973469891374*r**6
            +799392069672200*r**8+743654321944200*r**10+342288825420164*r**12+66016146091322*r**14
            +5086698787644*r**16+578016222615*r**18)-2*Q2**16*(-1036329828510-3836402218627*r**2
            -18051245278057*r**4+102377435394548*r**6+383485607427028*r**8+511130153141522*r**10
            +407437153613198*r**12+179677262568868*r**14+33590693636498*r**16+3434333295753*r**18
            +184731759555*r**20)-4*Q2**15*(260441430060+5787497282254*r**2+46053040045855*r**4
            +147945516457115*r**6+278476548753095*r**8+478443807174113*r**10+355775844077993*r**12
            +44598774280055*r**14-43146755631835*r**16-12258146381855*r**18-1460719107936*r**20
            +85356085470*r**22)+4*Q2**14*(-317519484940+3943937984276*r**2+42766397548995*r**4
            +331027334273300*r**6+1018353805266050*r**8+2457112266412800*r**10+3038095349575034*r**12
            +1779826095579920*r**14+431518728048600*r**16+7959115364300*r**18-6499191540685*r**20
            -460850952324*r**22+193122929090*r**24)-4*Q2**13*(-471316084160-2251428307711*r**2
            -13523369212601*r**4+218029104289705*r**6+958895164894100*r**8+3768095316004615*r**10
            +6796886456934046*r**12+6048432306047246*r**14+2796382666071940*r**16
            +604275803656975*r**18+35793831759755*r**20+3294403035049*r**22+979613883064*r**24
            +74715667465*r**26)-4*Q2**12*(74325505540+5569597906769*r**2+58939865558102*r**4
            +172103023795964*r**6+496151133945635*r**8-985542302520925*r**10-4852264782133159*r**12
            -6593819699253232*r**14-5046678140187394*r**16-2272805821358425*r**18
            -522664651146940*r**20-66482813715196*r**22-14524138743973*r**24-1721183530571*r**26
            +116773174765*r**28)+2*Q2**11*(-526839804620+5248336742097*r**2+74622892779012*r**4
            +851017469403457*r**6+3818033980676542*r**8+10515648724470951*r**10+15339941178130498*r**12
            +18989460967550683*r**14+12263047194522888*r**16+935263311709303*r**18
            -2304917351375744*r**20-902275657755153*r**22-194611418128538*r**24-27528901710543*r**26
            -1500591689958*r**28+244460921365*r**30)+4*Q2**10*(182721140780+1939227165971*r**2
            +16408358083905*r**4-249905289469345*r**6-1343233789672310*r**8-8345687532402877*r**10
            -19390561445464609*r**12-36477620582891105*r**14-39931546210533280*r**16
            -21656057821157815*r**18-4625464143314129*r**20+665726517637133*r**22
            +383918725624130*r**24+84646642995905*r**26+130436705265*r**28-985054629739*r**30
            +22502697320*r**32)-2*Q2**9*(-76326583420+5588243848193*r**2+68687203298930*r**4
            +238828051098800*r**6+1192075892315500*r**8-7222210403696150*r**10-20887032454354418*r**12
            -69488621826104660*r**14-115783524536927600*r**16-93450599237691800*r**18
            -41780451745845170*r**20-9919440966995768*r**22+240284224812460*r**24
            +214083862682750*r**26+49345096555250*r**28-17277678677860*r**30-2772013345132*r**32
            +173694771695*r**34)+4*Q2**8*(-90742940315+634738215601*r**2+12220836101061*r**4
            +261069445170850*r**6+1497263368870275*r**8+4393595083668660*r**10+14295300322331129*r**12
            +12960594003559334*r**14-9323184449687295*r**16-20307500206589750*r**18
            -18473671008065545*r**20-12791166332386866*r**22-5539247115522271*r**24
            -976962426476340*r**26-239025569827725*r**28-38042998097750*r**30-5030561859914*r**32
            -232223357499*r**34+25356862360*r**36)+2*Q2**7*(44046338720+1741535541067*r**2
            +15743410266236*r**4-234415252887883*r**6-1391299108754290*r**8-14230816828096650*r**10
            -44629069639786082*r**12-102094900029889186*r**14-104362722920775602*r**16
            -66470198564834380*r**18+4250341289991270*r**20+52540356206495728*r**22
            +39091862574841114*r**24+13919688141426538*r**26+2952723550226250*r**28
            +612975703947410*r**30+116742929485162*r**32-760415875039*r**34-1341611103178*r**36
            +57901202795*r**38)-4*Q2**6*(-18539358370+633534140149*r**2+8047729125574*r**4
            +48505025881039*r**6+302234324264489*r**8-2888675621674012*r**10-3341280943682624*r**12
            -34417976271417124*r**14-33057645370630564*r**16-17452583352773514*r**18
            +18726275180354484*r**20+58442613913600626*r**22+51270703532500226*r**24
            +22669473156478036*r**26+5137462079767936*r**28+1028766435796748*r**30
            +127094369900974*r**32+26831349945949*r**34-1134762771386*r**36-429667589161*r**38
            +19616540525*r**40)-12*Q2**5*(3746672750-848232902*r**2-501219050405*r**4
            -24593506374150*r**6-153684176104300*r**8-646394384457403*r**10-4261733721406144*r**12
            +453006121958480*r**14-9183950477895100*r**16-9661488761206100*r**18-3907422974080026*r**20
            -13363027648597236*r**22-10834556256850120*r**24-4157621003785550*r**26
            -2070508068615800*r**28-446688130260464*r**30-198648948991538*r**32-1118131068830*r**34
            +4863462845175*r**36+161478263450*r**38-32904070732*r**40+972106945*r**42)
            +6*Q2**4*(-172227660+101858645189*r**2+678746480325*r**4-15638449299750*r**6
            -105444126661150*r**8-1675492439664075*r**10-5397992355329031*r**12-6732494281871160*r**14
            -25146500033707800*r**16-12269476955413350*r**18+26065366999093010*r**20
            -9095777245036116*r**22-45539219724491820*r**24-17436317780917150*r**26
            +3741543169231650*r**28+772482505791720*r**30+30090799767444*r**32-227666349173055*r**34
            +220914522825*r**36+14736645307850*r**38+251112815130*r**40-124397373111*r**42
            +4039510085*r**44)-27*Q2**3*(-260497220+7467613863*r**2+87793816778*r**4
            +1044825355365*r**6+5173047643300*r**8-95821650948155*r**10+175852068889158*r**12
            -1502405523291897*r**14+451306817637800*r**16+520720248640950*r**18+2629662758127060*r**20
            -6910546092507902*r**22-17178257417526952*r**24-15286764141697990*r**26
            -9383655929703300*r**28-1072962444223650*r**30-258476981286372*r**32+11438721022483*r**34
            +10478042890370*r**36+1247471248425*r**38+861518846340*r**40+15339748753*r**42
            -5782344162*r**44+166546955*r**46)-54*(-1+r**2)**2*(-951822+84821783*r**2
            +230078663*r**4-15769479977*r**6-209092551027*r**8-3779551466787*r**10
            -5974487414907*r**12-7482339777427*r**14-311214379330967*r**16+880035090988358*r**18
            -344749333489082*r**20-3184907622036602*r**22+2196970569628178*r**24+3928883339354138*r**26
            -2117181625204662*r**28-1133590431901062*r**30-599041953642332*r**32-153332475082477*r**34
            -18682834106717*r**36-3330064433517*r**38-317293391247*r**40+39311681433*r**42
            +1502109313*r**44-173792727*r**46+3391473*r**48)-18*Q2**2*(93396020+1751381547*r**2
            -22235637774*r**4-1666464373113*r**6-10785140873460*r**8-81122196720675*r**10
            -537235172894798*r**12+1570289588948121*r**14-7320821316000588*r**16+5180241799623710*r**18
            +5014985854522980*r**20+1756809013231062*r**22+4307311541918856*r**24
            -8664952087922358*r**26-17826061906233420*r**28-5616448146407390*r**30
            -4488085495507668*r**32-727851880764729*r**34-133455886807318*r**36-68375212037325*r**38
            -6830286219060*r**40+845245414857*r**42+36775048026*r**44-6216834123*r**46
            +157748620*r**48)+27*Q2*(-2924084+1094293587*r**2-23204528*r**4-318440798058*r**6
            -2555582142368*r**8-38296624336188*r**10-82175066946448*r**12+310022373625762*r**14
            -3281529475082868*r**16+7268754015842047*r**18-813515858539808*r**20-12813210721355428*r**22
            -1853172430990368*r**24+14487966646017952*r**26+12087044936204192*r**28
            -12076778599858108*r**30-5802992950709148*r**32-3494449737204063*r**34
            -796667625067568*r**36-90598150428178*r**38-27594407546688*r**40-3383784073188*r**42
            +399875545072*r**44+18482218042*r**46-2362235068*r**48+51695501*r**50))*sqrtq2)
            +logq2*(-384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(4009744*Q2**25-2*Q2**24*(30169951+40524847*r**2)
            +8*Q2**23*(47930486+145867325*r**2+82095575*r**4)-4*Q2**22*(325147183
            +1732857768*r**2+2145521329*r**4+726668296*r**6)+Q2**21*(2272807988+21100744790*r**2
            +41547039754*r**4+32927977538*r**6+7716645434*r**8)-2*Q2**20*(321543611
            +14388058532*r**2+35867052714*r**4+50496151324*r**6+35500556717*r**8
            +6002452418*r**10)+Q2**19*(-5743768042-16035162939*r**2-122842488265*r**4
            -210667961470*r**6+5446555260*r**8+75318701413*r**10+8004833891*r**12)
            +2*Q2**18*(5717149249+63072099190*r**2+405953324880*r**4+1127248463995*r**6
            +1023036681025*r**8+285827730084*r**10+6044158270*r**12+2968786075*r**14)
            -Q2**17*(4712961322+176778405187*r**2+1434274026241*r**4+6362935331689*r**6
            +9399742205995*r**8+6045891524497*r**10+1554171040867*r**12+154274777611*r**14
            +14448964879*r**16)+2*Q2**16*(-6956563251+710589555*r**2+159448468862*r**4
            +3538487311514*r**6+7973147348052*r**8+8215460763044*r**10+4623129197510*r**12
            +1089223238922*r**14+109763952419*r**16+684490317*r**18)+4*Q2**15*(5568096462
            +73321578849*r**2+706655767958*r**4+1082860404298*r**6+1288628774569*r**8
            +1830581828270*r**10-969091149461*r**12-1759418837222*r**14-451767038467*r**16
            -35535214731*r**18+5014739571*r**20)-4*Q2**14*(1114427928+81210462636*r**2
            +1112758278295*r**4+5875601931985*r**6+16612901709005*r**8+34975320884427*r**10
            +30051945147919*r**12+9026634158345*r**14+41681138595*r**16-139792483855*r**18
            +2609121138*r**20+4719623646*r**22)+4*Q2**13*(-4945072268-6142918410*r**2
            +246820142705*r**4+6669242366620*r**6+24724220478240*r**8+80603669605768*r**10
            +107664419613910*r**12+65810544049080*r**14+17705224997440*r**16+1728636549490*r**18
            +253968190617*r**20+33486328620*r**22-1262562500*r**24)+4*Q2**12*(4889846527
            +84654685492*r**2+1135352188061*r**4+114174268399*r**6-560669255945*r**8
            -58527245598022*r**10-127137997140002*r**12-117621241093046*r**14-62292248310499*r**16
            -16774375470560*r**18-2554215249083*r**20-474639760873*r**22-33678442499*r**24
            +4448986354*r**26)-2*Q2**11*(-780531914+121183676485*r**2+2618331464073*r**4
            +16747723568306*r**6+82106479082878*r**8+153088565893899*r**10+176930360119025*r**12
            +217757326173292*r**14+72236481334434*r**16-38596853059933*r**18-24230609829509*r**20
            -5823664976430*r**22-552040818022*r**24+7380610621*r**26+2408332603*r**28)
            -4*Q2**10*(3500976413+16688728926*r**2-99929911543*r**4-8586363280678*r**6
            -44745420122634*r**8-199578293155243*r**10-391837053737536*r**12-685111969901877*r**14
            -574247652022267*r**16-198482784281956*r**18-2824080376155*r**20+10831415292356*r**22
            +2744621817752*r**24-129926465823*r**26-40362376094*r**28+2569446119*r**30)
            +2*Q2**9*(3604352954+92622695903*r**2+1762298098515*r**4-1479932113855*r**6
            +7767073452755*r**8-273580614510149*r**10-523897260502093*r**12-1695968331228115*r**14
            -2168982590290505*r**16-1271081682114475*r**18-370796961925639*r**20+3274881624667*r**22
            +10279727088665*r**24+2062872569585*r**26-499026091935*r**28-60216532201*r**30
            +4098840323*r**32)+2*Q2**8*(1497409799-37111185505*r**2-1337690088910*r**4
            -11451043055590*r**6-87602709184660*r**8-125869538840724*r**10-660783386436410*r**12
            +2257643491310*r**14+1053262578981510*r**16+1021167438319030*r**18+697004306798366*r**20
            +287432551321110*r**22+27578612184340*r**24+14369250471380*r**26+3439894082090*r**28
            +128345758754*r**30-17165948365*r**32+669980075*r**34)-4*Q2**7*(1095800518
            +9278668053*r**2+22966563094*r**4-4861301106434*r**6-28814904744855*r**8
            -171423868679548*r**10-564836793396673*r**12-873701590956174*r**14-463701211549951*r**16
            -136323937780910*r**18+410562380638407*r**20+447524283674882*r**22+175309512779771*r**24
            +34177781217564*r**26+11348220358765*r**28+2622904189198*r**30-57002102187*r**32
            -22346521991*r**34+1009377271*r**36)+4*Q2**6*(214387787+10813358300*r**2
            +292921693276*r**4-377515988503*r**6+7694543368241*r**8-99614847051117*r**10
            -60624991249835*r**12-827933179322081*r**14-219302151623137*r**16-69476497876741*r**18
            +639511805829893*r**20+905110350500945*r**22+514623986200339*r**24+113654824768273*r**26
            +29013153844119*r**28+4711765124237*r**30+703811031890*r**32-24336513659*r**34
            -5968326733*r**36+255924506*r**38)+2*Q2**5*(470508214-4555526387*r**2
            -304153347939*r**4-3717930912829*r**6-36510016579457*r**8-38050336422020*r**10
            -807531640579708*r**12+983163505545884*r**14-1783706435219616*r**16-457033429799778*r**18
            -345457905497450*r**20-1459798604312998*r**22-366090956029766*r**24-246968361635236*r**26
            +20960124995732*r**28-38331676662356*r**30-1422850002782*r**32+2367095965821*r**34
            -12230911819*r**36-14523472997*r**38+461865487*r**40)-2*Q2**4*(278596251
            +2821275252*r**2+2350427480*r**4-2330155592310*r**6-13195949271375*r**8
            -110178388209734*r**10-516650597601648*r**12+470117571046920*r**14-2432298939832970*r**16
            +645121881865080*r**18+1996321240243056*r**20-2425409120341668*r**22-1292713824203430*r**24
            +320117036755620*r**26+39332525002640*r**28+57113305491336*r**30-25430601702753*r**32
            -2388991344220*r**34+2060594939160*r**36+2771611530*r**38-10509609659*r**40
            +300455442*r**42)+3*Q2**3*(2306946+1216464015*r**2+42423921505*r**4-89512971930*r**6
            +2873197723520*r**8-33363045339389*r**10+70672891414405*r**12-283384094747480*r**14
            -5563340307460*r**16+472537965412830*r**18+389417918448946*r**20-2041030762503260*r**22
            -1564357307679880*r**24-1616588926938690*r**26-158908926607870*r**28-55782774765784*r**30
            -1710521170030*r**32+12235163155*r**34+212102756205*r**36+120265535270*r**38
            +1711793656*r**40-34909505*r**42+520825*r**44)+18*(-1+r**2)**2*(190603
            +1372603*r**2-35401533*r**4-3030711105*r**6-19885939925*r**8-250401796977*r**10
            -909902969317*r**12+6095311433027*r**14-50935613937930*r**16+157335045858950*r**18
            -189438055155962*r**20-127044372937842*r**22+395427489543342*r**24-160418105897530*r**26
            -9420308711250*r**28-34492772725682*r**30-9642167567777*r**32-1045145733633*r**34
            -274109928105*r**36-50184896525*r**38+3880771143*r**40+112351083*r**42
            -13054953*r**44+245295*r**46)+6*Q2**2*(14411003-106030062*r**2-9296831906*r**4
            -142097789389*r**6-1574033131295*r**8-657266688622*r**10-70037109765582*r**12
            +288754302901829*r**14-924827292381034*r**16+1036333807325660*r**18-9166313719852*r**20
            +32320803201318*r**22-104079869099926*r**24-680585393506164*r**26-188390877047060*r**28
            -271036509684942*r**30-58016933430017*r**32-2243419159886*r**34-4984612566514*r**36
            -1212552867305*r**38+156011877413*r**40+2851281218*r**42-784219486*r**44
            +17720601*r**46)-9*Q2*(3348218+4377195*r**2-1139195771*r**4-41904013687*r**6
            -297230486181*r**8-1822662685867*r**10-14553407927605*r**12+99850987772079*r**14
            -522506914045817*r**16+1254388115930014*r**18-1042881755211582*r**20-705688032951030*r**22
            +908190632581614*r**24+684776892827898*r**26-488608495515706*r**28-115035354254482*r**30
            -195217001834280*r**32-55033705997881*r**34-3716309501847*r**36-1958418354531*r**38
            -553691092537*r**40+50063461345*r**42+1402624959*r**44-208862797*r**46
            +4208279*r**48))+384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(32077952*Q2**30
            -32*Q2**29*(16964543+22141991*r**2)+2*Q2**28*(1986324817+5760254322*r**2
            +3234931105*r**4)-8*Q2**27*(2014533842+9973112145*r**2+12177662308*r**4
            +4133094629*r**6)+4*Q2**26*(9271973966+74813065244*r**2+146710721359*r**4
            +111970326722*r**6+26130691073*r**8)-2*Q2**25*(17707203974+299904115959*r**2
            +823015200092*r**4+1045038163278*r**6+614888034726*r**8+102616651715*r**10)
            +2*Q2**24*(-24564351810+154881214305*r**2+443831419965*r**4+826129718294*r**6
            +1609107238682*r**8+977905557365*r**10+107644330455*r**12)+Q2**23*(199208656830
            +1499977541055*r**2+8410891483160*r**4+22632475316765*r**6+18611526393006*r**8
            +2491146406301*r**10-1175018189580*r**12+2624229375*r**14)-2*Q2**22*(105873637035
            +1948381037475*r**2+13552613320620*r**4+52571919286369*r**6+77025790020084*r**8
            +47629941633753*r**10+10993890279896*r**12+965298375675*r**14+157992165045*r**16)
            +Q2**21*(-104866696570+2950216906095*r**2+30035552292490*r**4+204467650003414*r**6
            +448014228698182*r**8+449914138859936*r**10+224247531691190*r**12+48073894659770*r**14
            +5257356292980*r**16+284584720865*r**18)+2*Q2**20*(251574115480+1764858572395*r**2
            +9782138133685*r**4-54930440749272*r**6-238559341437192*r**8-348479770251146*r**10
            -310995529621638*r**12-147705566262624*r**14-28335625957424*r**16-2539189200665*r**18
            +117663696385*r**20)-Q2**19*(399645790510+9503659528695*r**2+97746512439820*r**4
            +357197361030367*r**6+695506241512956*r**8+1314615036587862*r**10+941337007489144*r**12
            -10517111560290*r**14-171724629993018*r**16-30493576020829*r**18-646445115540*r**20
            +620416481395*r**22)+2*Q2**18*(-132405398705+2813559066795*r**2+48547825490830*r**4
            +432266663054075*r**6+1468311210872023*r**8+3930406934734382*r**10+5173452070019404*r**12
            +3111181833426310*r**14+758588464888565*r**16+59996556138263*r**18+9436801832758*r**20
            +2178933034415*r**22+119326254325*r**24)+Q2**17*(690042167390+6125629581275*r**2
            +34993400018250*r**4-625964890793268*r**6-3319478040450988*r**8-14025325398265433*r**10
            -27067858154086652*r**12-25370797100282448*r**14-12257655974781002*r**16
            -2843835909701463*r**18-378060066492046*r**20-56220818075772*r**22-5413364526760*r**24
            +462057790805*r**26)-2*Q2**16*(141870009305+5782921024320*r**2+82258097473835*r**4
            +269430377315088*r**6+539897166250119*r**8-2845502210544232*r**10-12320130678394291*r**12
            -16935901949623056*r**14-13332640952793465*r**16-6102657333158768*r**18
            -1425336328280043*r**20-227440550762080*r**22-23865071495335*r**24-566602816200*r**26
            +249182195315*r**28)+2*Q2**15*(-200033625450+1870696594635*r**2+58475644978880*r**4
            +745570291205573*r**6+3515721433830218*r**8+10780710406555423*r**10+15632316109483204*r**12
            +22347107196150337*r**14+16581794756645258*r**16+2151652591512121*r**18
            -2491945105414904*r**20-968231513246313*r**22-182861173880394*r**24+1395946137981*r**26
            +2393061744020*r**28-60325836285*r**30)+4*Q2**14*(119173807065+1648721337105*r**2
            +14629223001220*r**4-244149991430513*r**6-1642106581444554*r**8-10528025679849011*r**10
            -26798321752519952*r**12-57421140462311085*r**14-70726829012528132*r**16
            -43351937842892501*r**18-11816478177366636*r**20-578492142353387*r**22
            +201791264523250*r**24+33560416625367*r**26-10716868398824*r**28-1449469990935*r**30
            +113585787555*r**32)+2*Q2**13*(-4610263170-3552232563645*r**2-71180000019270*r**4
            -275294217464270*r**6-768207587968662*r**8+11485859483902026*r**10+45358562131292938*r**12
            +157219414934900970*r**14+285186317323757430*r**16+260162575130474152*r**18
            +127863782604033390*r**20+31382197192799718*r**22+3011562740893390*r**24
            +387627815434710*r**26+107333548794318*r**28+15657804561278*r**30+209669202900*r**32
            -72630715275*r**34)-2*Q2**12*(139352562695-169811227800*r**2-29110921084915*r**4
            -668287891418776*r**6-3902510008549036*r**8-12834027544365080*r**10-26555691710412964*r**12
            +14369695566484328*r**14+166870793038892410*r**16+240255042847671976*r**18
            +191882676394723214*r**20+95468584273949944*r**22+25596220024764788*r**24
            +4647551489297048*r**26+1101762792083164*r**28+213593157902008*r**30-2475627579209*r**32
            -2199693407760*r**34+104282577965*r**36)+2*Q2**11*(70006153930+1811526631045*r**2
            +25283623329980*r**4-325281532173543*r**6-2542955614360224*r**8-25704681884203204*r**10
            -84778874392286008*r**12-241319563539210708*r**14-314724233031309916*r**16
            -367681703064286842*r**18-257795518425736400*r**20-41835786407632738*r**22
            +41894495608185392*r**24+20635871758723788*r**26+6079227921096920*r**28
            +947548768113468*r**30+107013943259010*r**32-9046425998995*r**34-1451937171980*r**36
            +82589511265*r**38)+4*Q2**10*(16656194285-515788780905*r**2-15140928253915*r**4
            -100972738307591*r**6-391710322604346*r**8+6501069653274516*r**10+26246699010061988*r**12
            +162250079056216524*r**14+323141961647497038*r**16+574650272338162834*r**18
            +649203315169467030*r**20+375638195757176606*r**22+94343314853757728*r**24
            -8944601036925660*r**26-7757167776401388*r**28-2509516584992996*r**30
            -84680191465059*r**32+50853458609823*r**34+1906342826253*r**36-329655926655*r**38
            +9066833090*r**40)-4*Q2**9*(21007731220+116955146190*r**2-2347295524995*r**4
            -157876578064557*r**6-974493663243961*r**8-4273832076865001*r**10-13693707721154852*r**12
            +48438955801645060*r**14+118190856484620572*r**16+427671381217426676*r**18
            +795298017313608262*r**20+676285391553939394*r**22+331831809361154450*r**24
            +91720643414914462*r**26+3243269932570316*r**28-733373758191676*r**30
            -514464271262872*r**32+127787046764710*r**34+75590704762773*r**36-335625916381*r**38
            -569555374705*r**40+20907846115*r**42)+2*Q2**8*(4002153460+468916973185*r**2
            +9501622925455*r**4-90182647909090*r**6-834742428621632*r**8-15206310915286175*r**10
            -56986597697347803*r**12-208138115554370520*r**14-500809892686433800*r**16
            -575752060245588558*r**18+179155893599836438*r**20+585677494001490196*r**22
            +618220202952660720*r**24+459759894026802010*r**26+197060121983937002*r**28
            +45598286379168744*r**30+12014120413701492*r**32+2873778414304045*r**34
            +256443166825355*r**36+26319986005438*r**38-1432441029392*r**40-178012563995*r**42
            +7621631425*r**44)+Q2**7*(23147686070-256199681925*r**2-11650955205880*r**4
            -160615393281063*r**6-496168414206258*r**8+11898301435228253*r**10+48191893711255268*r**12
            +532756789262229831*r**14+1093562581332779916*r**16+2816317195669647358*r**18
            +2156441138153120448*r**20+880393301823608042*r**22-634427153170739092*r**24
            -1718487594583510518*r**26-1305442178215791592*r**28-462453029658963170*r**30
            -118158766550049858*r**32-23348036424852969*r**34-6507854052988200*r**36
            -482503818515283*r**38+125092921266374*r**40+2499781176073*r**42-799949040540*r**44
            +22176988715*r**46)-2*Q2**6*(4841320215+70195413135*r**2+265501283900*r**4
            -69670209451427*r**6-384121101734336*r**8-3290742169234215*r**10-10385174040844888*r**12
            +74870525929709267*r**14-61343689213152757*r**16+888094065670472870*r**18
            +385071991849300232*r**20-73623183984658574*r**22-438387681894687864*r**24
            -1205967198296590110*r**26-1093058237198876512*r**28-577029981340334954*r**30
            -146668416550574003*r**32-40900875188825573*r**34-4916093135306276*r**36
            -738748594769567*r**38-133552971999528*r**40+36280113769205*r**42+537075130520*r**44
            -205762545305*r**46+5489026545*r**48)-3*Q2**5*(758128214-36529464745*r**2
            -988012781910*r**4+5420683511918*r**6+99006089785998*r**8+2750309889616116*r**10
            +10090663534741758*r**12+61152378820959274*r**14+233262504040641600*r**16
            -65260521160512109*r**18+542334663586356644*r**20+477414738048696396*r**22
            -81882157685401732*r**24+645632443825596192*r**26+523871782912697724*r**28
            +141124545782318292*r**30+78138442173405814*r**32+15024597915292557*r**34
            +14310063113475794*r**36+1829166170538662*r**38-656410775332650*r**40
            -53681464915348*r**42+5840522755686*r**44+240833827746*r**46-33802833900*r**48
            +717376009*r**50)+6*Q2**4*(414129146-2411673623*r**2-160807104995*r**4
            -4076803585712*r**6+2742087879244*r**8+363667170114862*r**10+1916217327175814*r**12
            +28578149689794840*r**14+38352094240783758*r**16+99880754566509659*r**18
            +194204302109743567*r**20+98580001665746944*r**22-269099723958231800*r**24
            +281264892169305748*r**26+583715956307748484*r**28+331466069610438992*r**30
            +15903224337716214*r**32+1923314822773935*r**34-1728992576243797*r**36
            +2358330562478704*r**38+631341552988012*r**40-228051615021026*r**42-44595649210730*r**44
            +4419226823128*r**46+156455812034*r**48-22259514579*r**50+466623177*r**52)
            -9*Q2**3*(35789126+1245684291*r**2+15947689100*r**4-1248196049645*r**6
            -4825077709004*r**8-107072266806262*r**10-109610424083528*r**12+2892237485724530*r**14
            -16045940985959790*r**16+83857838025642321*r**18-136486420553283292*r**20
            +87535335091392857*r**22-3611561324190280*r**24+170720289356611740*r**26
            +363435248513494736*r**28+251950830901330988*r**30+203463461512767562*r**32
            +3312837364637685*r**34+2457496129083220*r**36-156341978181419*r**38-1184242266965932*r**40
            -211911956644038*r**42-6747993003400*r**44-6976680121150*r**46+474563358366*r**48
            +18577412247*r**50-2114224644*r**52+42603615*r**54)-54*(-1+r**2)**2*(190603
            -1105236*r**2-73830496*r**4-2739317424*r**6+23185951041*r**8+339237933716*r**10
            +4820780295156*r**12+47154489462396*r**14-4606261299609*r**16+262709250392136*r**18
            +2619537356011356*r**20-9235637254979164*r**22+6182387634438701*r**24
            +26782835554065576*r**26-24289331762550904*r**28-23830903400191144*r**30
            +13513710918613041*r**32+7347778694047356*r**34+4741932243651416*r**36
            +1596728817443736*r**38+233991301549091*r**40+38918230355716*r**42+7517655253956*r**44
            -52793514004*r**46-111362092259*r**48+3803650128*r**50+255573612*r**52
            -16243788*r**54+245295*r**56)-18*Q2**2*(12504973-318039495*r**2-9450042778*r**4
            +23546667657*r**6+1717678356981*r**8+44139096602318*r**10+165207405287764*r**12
            +1633503842419014*r**14+4805376316809153*r**16-22344068440245549*r**18
            +115538737233218418*r**20-153360735637474741*r**22-1146154477826391*r**24
            +101469526712900148*r**26-108865228769862664*r**28-3222193768641692*r**30
            +173197113865416039*r**32+65202416502722319*r**34+62216006336703018*r**36
            +15876041829001551*r**38+1952832139227743*r**40+934308302534814*r**42
            +246933148544244*r**44-8281700357002*r**46-3230426894069*r**48+182915191365*r**50
            +10171522494*r**52-897513283*r**54+15267651*r**56)+27*Q2*(3348218-40674463*r**2
            -1593084858*r**4-27769450172*r**6+399164607020*r**8+7227158806489*r**10
            +49511328577684*r**12+552847258735984*r**14-45966590691346*r**16-1729761282293251*r**18
            +35521758137050114*r**20-100754800327146156*r**22+68662443583413144*r**24
            +102733991228526229*r**26-77347190489069896*r**28-11730213625971456*r**30
            -124148457348082506*r**32+78982400037353619*r**34+35605332455968234*r**36
            +30084020494307244*r**38+10054040631980524*r**40+1283090546880059*r**42
            +293236022733684*r**44+85774309720464*r**46-379083015646*r**48-1382506563889*r**50
            +54770970382*r**52+3736389052*r**54-265532784*r**56+4208279*r**58))*sqrtq2))*math.log(r)**2)/(840000*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2+840000*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2+logq2**8*(81266540544000000*r**36*(1
            +r**2)**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+81266540544000000*r**36*(1
            +r**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2*(-120960000*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4
            -Q2**3*(1+r**2)-2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4
            +r**6)+4*(1-9*r**2-44*r**4-9*r**6+r**8))-120960000*(-Q2+(-1+r)**2)**3*r**8*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4-Q2**3*(1+r**2)
            -2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4+r**6)+4*(1-9*r**2
            -44*r**4-9*r**6+r**8))*sqrtq2)+logq2**7*(-1805923123200000*r**32*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))-1805923123200000*r**32*(1+r**2)*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))*sqrtq2)+logq2**3*(-29030400000*(-Q2+(-1+r)**2)**3*r**16*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)
            -Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2+683*r**4+169*r**6)
            +2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)+6*Q2**3*(31+230*r**2
            +159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4
            +8368*r**6+6523*r**8+1184*r**10-131*r**12)-9*Q2*(13+5*r**2-1493*r**4
            -5245*r**6-5245*r**8-1493*r**10+5*r**12+13*r**14)+36*(4-67*r**2-28*r**4
            +2331*r**6+5600*r**8+2331*r**10-28*r**12-67*r**14+4*r**16))-29030400000*(
            -Q2+(-1+r)**2)**3*r**16*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)-Q2**6*(333+410*r**2+333*r**4)
            -Q2**5*(169+683*r**2+683*r**4+169*r**6)+2*Q2**4*(275-725*r**2-3408*r**4
            -725*r**6+275*r**8)+6*Q2**3*(31+230*r**2+159*r**4+159*r**6+230*r**8
            +31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4+8368*r**6+6523*r**8+1184*r**10
            -131*r**12)-9*Q2*(13+5*r**2-1493*r**4-5245*r**6-5245*r**8-1493*r**10
            +5*r**12+13*r**14)+36*(4-67*r**2-28*r**4+2331*r**6+5600*r**8+2331*r**10
            -28*r**12-67*r**14+4*r**16))*sqrtq2)+logq2**2*(7257600000*(-Q2+(-1
            +r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8
            -4*Q2**7*(1+r**2)-Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4
            +5*r**6)+Q2**4*(85-226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1
            -54*r**2-143*r**4-143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4
            +3168*r**6+2871*r**8+468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4
            -2833*r**6-2833*r**8-565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4
            +4368*r**6+11718*r**8+4368*r**10-56*r**12-96*r**14+5*r**16))+7257600000*(
            -Q2+(-1+r)**2)**3*r**12*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8
            -4*Q2**7*(1+r**2)-Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4
            +5*r**6)+Q2**4*(85-226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1
            -54*r**2-143*r**4-143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4
            +3168*r**6+2871*r**8+468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4
            -2833*r**6-2833*r**8-565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4
            +4368*r**6+11718*r**8+4368*r**10-56*r**12-96*r**14+5*r**16))*sqrtq2)
            +logq2**5*(-2508226560000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1
            +r**2)-Q2**6*(219+310*r**2+219*r**4)-Q2**5*(977+2179*r**2+2179*r**4
            +977*r**6)+Q2**4*(590-2090*r**2-6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243
            +10*r**2-2073*r**4-2073*r**6+10*r**8+243*r**10)+Q2**2*(-879+8076*r**2
            +41127*r**4+61272*r**6+41127*r**8+8076*r**10-879*r**12)+Q2*(-741+3075*r**2
            +31341*r**4+67125*r**6+67125*r**8+31341*r**10+3075*r**12-741*r**14)
            +12*(41-573*r**2+28*r**4+12789*r**6+25830*r**8+12789*r**10+28*r**12
            -573*r**14+41*r**16))-2508226560000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)-Q2**5*(977
            +2179*r**2+2179*r**4+977*r**6)+Q2**4*(590-2090*r**2-6768*r**4-2090*r**6
            +590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4-2073*r**6+10*r**8+243*r**10)
            +Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6+41127*r**8+8076*r**10
            -879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6+67125*r**8+31341*r**10
            +3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4+12789*r**6+25830*r**8
            +12789*r**10+28*r**12-573*r**14+41*r**16))*sqrtq2)+logq2**4*(522547200000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219
            +310*r**2+219*r**4)-24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415
            -1180*r**2-4598*r**4-1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4
            -677*r**6+155*r**8+102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6
            +18377*r**8+3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6
            -3030*r**8-1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4
            +24556*r**6+53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))+522547200000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2
            +219*r**4)-24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415-1180*r**2
            -4598*r**4-1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4-677*r**6
            +155*r**8+102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6+18377*r**8
            +3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8
            -1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6
            +53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))*sqrtq2)+logq2**6*(10032906240000*r**28*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(16*Q2**8+332*Q2**7*(1
            +r**2)+Q2**6*(153+370*r**2+153*r**4)-Q2**5*(2011+4817*r**2+4817*r**4
            +2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4-2410*r**6+295*r**8)+6*Q2**3*(559
            -310*r**2-4869*r**4-4869*r**6-310*r**8+559*r**10)-3*Q2**2*(479-4496*r**2
            -22867*r**4-35272*r**6-22867*r**8-4496*r**10+479*r**12)-9*Q2*(187
            -865*r**2-5807*r**4-10315*r**6-10315*r**8-5807*r**10-865*r**12+187*r**14)
            +9*(109-1432*r**2+392*r**4+26376*r**6+49910*r**8+26376*r**10+392*r**12
            -1432*r**14+109*r**16))+10032906240000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(16*Q2**8+332*Q2**7*(1+r**2)+Q2**6*(153+370*r**2+153*r**4)
            -Q2**5*(2011+4817*r**2+4817*r**4+2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4
            -2410*r**6+295*r**8)+6*Q2**3*(559-310*r**2-4869*r**4-4869*r**6-310*r**8
            +559*r**10)-3*Q2**2*(479-4496*r**2-22867*r**4-35272*r**6-22867*r**8
            -4496*r**10+479*r**12)-9*Q2*(187-865*r**2-5807*r**4-10315*r**6-10315*r**8
            -5807*r**10-865*r**12+187*r**14)+9*(109-1432*r**2+392*r**4+26376*r**6
            +49910*r**8+26376*r**10+392*r**12-1432*r**14+109*r**16))*sqrtq2))+nlo.X1Q2_Derivativer(4,Q2,r)*((4*r)/(
            -36*logq2*r**4+3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2)-(2*muWC**2*r)/(-36*logq2*r**4+3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)-(16*muWC*r)/(-108*logq2*r**4
            +9*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)
            +(2*r*math.log(mu0))/(-12*logq2*r**4+(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2)-(2*r*math.log(r))/(-12*logq2*r**4+(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+nlo.X1Q2_Derivativer(3,Q2,r)*((1440*logq2*r**5*(1
            +r**2)-8*r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)/(2160*logq2**2*r**8
            +15*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-360*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(muWC**2*(-720*logq2*r**5*(1
            +r**2)+4*r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(2160*logq2**2*r**8
            +15*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-360*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(muWC*(-5760*logq2*r**5*(1
            +r**2)+32*r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(6480*logq2**2*r**8
            +45*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-1080*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((720*logq2*r**5*(1+r**2)
            -4*r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2
            -11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*math.log(mu0))/(720*logq2**2*r**8
            +5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((-720*logq2*r**5*(1+r**2)
            +4*r*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2
            -11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*math.log(r))/(720*logq2**2*r**8
            +5*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))+nlo.X1Q2_Derivativer(2,Q2,r)*((64800*logq2**2*r**9*(1
            +r**2)**2+2*(-Q2+(-1+r)**2)*r*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))**2-720*logq2*r**5*(1+r**2)*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)/(-43200*logq2**3*r**12-900*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+10800*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+25*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +(muWC**2*(-32400*logq2**2*r**9*(1+r**2)**2-(-Q2+(-1+r)**2)*r*(-Q2+(1
            +r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2+360*logq2*r**5*(1
            +r**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2))/(
            -43200*logq2**3*r**12-900*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+10800*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+25*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(muWC*(-259200*logq2**2*r**9*(1+r**2)**2
            -8*(-Q2+(-1+r)**2)*r*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2+2880*logq2*r**5*(1+r**2)*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2))/(-129600*logq2**3*r**12-2700*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+32400*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+75*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((97200*logq2**2*r**9*(1+r**2)**2+3*(-Q2+(-1+r)**2)*r*(-Q2+(1+r)**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2-1080*logq2*r**5*(1+r**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*math.log(mu0))/(-43200*logq2**3*r**12
            -900*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+10800*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+25*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((-97200*logq2**2*r**9*(1+r**2)**2-3*(
            -Q2+(-1+r)**2)*r*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2+1080*logq2*r**5*(1+r**2)*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2)*math.log(r))/(-43200*logq2**3*r**12-900*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+10800*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+25*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2))
            +flagPERP*muWC**3*((pi2*(-10368000*logq2**4*(-Q2+(-1+r)**2)*r**14*(-Q2
            +(1+r)**2)*(340-1741*r**2+105*Q2**7*r**2+5955*r**4-5175*r**6+3561*r**8
            +12591*r**10-4573*r**12+841*r**14+801*r**16-5*Q2**6*(16+111*r**2+159*r**4)
            +5*Q2**5*(96+279*r**2+724*r**4+471*r**6)-Q2**4*(1200+2331*r**2+6259*r**4
            +9055*r**6+3399*r**8)+Q2**3*(1075+2834*r**2+6055*r**4+10016*r**6+11036*r**8
            +1956*r**10)+Q2**2*(270-2591*r**2-1978*r**4-3537*r**6-9223*r**8-5456*r**10
            +1011*r**12)-Q2*(885-2989*r**2+1628*r**4+3750*r**6-2139*r**8-6015*r**10
            +746*r**12+2034*r**14))-2880*logq2**2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-4656+9857*r**2+9795*Q2**13*r**2-360589*r**4+1247426*r**6
            +7361182*r**8-110253713*r**10+191149981*r**12+55415668*r**14-108222692*r**16
            +14298391*r**18+43828469*r**20-8037238*r**22+4174646*r**24+77241*r**26
            +36027*r**28-Q2**12*(176+99615*r**2+100143*r**4)+Q2**11*(-5648+421432*r**2
            +902836*r**4+410136*r**6)-2*Q2**10*(-16752+433534*r**2+1590537*r**4
            +1611252*r**6+398709*r**8)+5*Q2**9*(-11871+142514*r**2+1005296*r**4
            +1552692*r**6+1056027*r**8+99342*r**10)+5*Q2**8*(-24+71123*r**2-372041*r**4
            -2468*r**6-278440*r**8-442443*r**10+168525*r**12)-2*Q2**7*(-60246+537940*r**2
            +2273487*r**4+14694780*r**6+25759600*r**8+12425514*r**10+2765355*r**12
            +886122*r**14)+2*Q2**6*(-59052+203748*r**2+2708799*r**4+21785399*r**6
            +64454790*r**8+64322268*r**10+18579313*r**12+4286709*r**14+393714*r**16)
            +Q2**5*(-30498+538711*r**2-1098862*r**4-8740592*r**6-94734134*r**8-181196498*r**10
            -110016034*r**12+744928*r**14-2852712*r**16+893691*r**18)-5*Q2**4*(-21816
            +101869*r**2+36771*r**4+5194326*r**6+7971754*r**8-4244340*r**10-9474900*r**12
            +2307154*r**14+8546022*r**16+621087*r**18+228057*r**20)+10*Q2**3*(-4378
            +1164*r**2-74427*r**4+1524972*r**6+8392172*r**8+11921018*r**10+15535886*r**12
            +7500786*r**14+7836870*r**16+2814850*r**18+305589*r**20+24138*r**22)
            +2*Q2**2*(-11108+77610*r**2-109354*r**4+2494245*r**6-11916315*r**8-37141854*r**10
            -61205670*r**12-93691512*r**14-2752980*r**16-28238020*r**18+4228152*r**20
            -337925*r**22+141531*r**24)-3*Q2*(-7159+23476*r**2-315922*r**4+1964468*r**6
            +4565555*r**8-22863892*r**10+43126788*r**12-35799496*r**14-27648481*r**16
            +25613020*r**18-8809874*r**20+4904436*r**22+63493*r**24+63588*r**26))
            -4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**17*r**2+6*Q2**16*(-503
            +1857*r**2+348*r**4)-Q2**15*(-26898+102167*r**2+795672*r**4+48371*r**6)
            +Q2**14*(-98640-56049*r**2+7994969*r**4+6700457*r**6+211055*r**8)-Q2**13*(
            -177975-1898941*r**2+27560140*r**4+63311870*r**6+22428463*r**8+399935*r**10)
            +2*Q2**12*(-57195-2309884*r**2+17136106*r**4+101613869*r**6+95944414*r**8
            +14856441*r**10+111733*r**12)+Q2**11*(-137556+373945*r**2+19063926*r**4
            -223999621*r**6-431226616*r**8-214206393*r**10+13775206*r**12+451941*r**14)
            -Q2**10*(-294096-13637297*r**2+90239625*r**4+147158379*r**6+237617085*r**8
            +126892013*r**10+149456939*r**12+90174137*r**14+864127*r**16)+Q2**9*(
            -82995-18238327*r**2+48326482*r**4+551909576*r**6+1906001960*r**8+3380058850*r**10
            +1563679558*r**12+632089712*r**14+84181011*r**16+257565*r**18)+2*Q2**8*(
            -126225-1009991*r**2+46086545*r**4-193715485*r**6-853227627*r**8-3255304445*r**10
            -3266464121*r**12-698363155*r**14-250698540*r**16+20066388*r**18+349360*r**20)
            -Q2**7*(-270930-22679187*r**2+132341324*r**4+45799181*r**6+1014675076*r**8
            -843528166*r**10-3741360624*r**12-2052704686*r**14+1341959486*r**16+200656521*r**18
            +125143764*r**20+760881*r**22)+Q2**6*(-14784-14394991*r**2+11307799*r**4
            +195247027*r**6+1774319317*r**8+7423701738*r**10+17856696358*r**12+11717789766*r**14
            +7166277802*r**16+2527824517*r**18+562002755*r**20+57687687*r**22+36929*r**24)
            +Q2**5*(-139311-6909393*r**2+94005896*r**4-225483814*r**6+422091965*r**8
            -4834215971*r**10-21741140296*r**12-43522669716*r**14-12347107893*r**16
            -8634004135*r**18-44297888*r**20-276307526*r**22+46636615*r**24+403867*r**26)
            -2*Q2**4*(-42255-5827438*r**2+34822088*r**4-116753271*r**6+605172420*r**8
            +534178775*r**10+2627004171*r**12-11002393566*r**14-17819750663*r**16
            +6074554120*r**18-930477570*r**20+950406917*r**22+35981378*r**24+28343359*r**26
            +123935*r**28)+Q2**3*(3600-2982709*r**2-596050*r**4-46349435*r**6-106353308*r**8
            +1201901155*r**10+13462806858*r**12+14229490325*r**14+3687037960*r**16
            -6454737479*r**18+18543504930*r**20+3071947751*r**22+885610500*r**24
            +125097625*r**26+10537062*r**28-6785*r**30)+Q2**2*(-23040-2142577*r**2
            +24290137*r**4-132014257*r**6+694056873*r**8-696848773*r**10-872984739*r**12
            -4977016789*r**14-35888913091*r**16+7774277309*r**18-20252527269*r**20
            +2796606109*r**22-2790985173*r**24+437225273*r**26-48682257*r**28+11649257*r**30
            +65007*r**32)+Q2*(9483+1473529*r**2-12345038*r**4+104663644*r**6-278087326*r**8
            +723773040*r**10-4072964318*r**12+4203800668*r**14-17674051888*r**16
            +59843857002*r**18-65906419354*r**20+39123878324*r**22-11142159922*r**24
            +974218744*r**26-446730426*r**28+7287956*r**30-6977035*r**32-27083*r**34)
            +2*(-654-131806*r**2+1042713*r**4-11829543*r**6+9308985*r**8-75573153*r**10
            +468182403*r**12-2736829079*r**14-10699576611*r**16+52263253755*r**18
            -64276935707*r**20+35970149187*r**22-9421707981*r**24+1788128901*r**26
            -61350615*r**28+49334139*r**30-137659*r**32+590847*r**34+1878*r**36))
            +2177280000*logq2**5*r**18*(-3-4*r**2+20*r**4-28*r**6+3*r**8)*sqrtq2
            -172800*logq2**3*r**10*(2265*Q2**12*r**2-10*Q2**11*(-8+2487*r**2+2463*r**4)
            +2*Q2**10*(60+57651*r**2+114071*r**4+57771*r**6)-10*Q2**9*(168+29587*r**2
            +86688*r**4+87891*r**6+29466*r**8)+10*Q2**8*(345+43559*r**2+170411*r**4
            +257585*r**6+177420*r**8+40572*r**10)-5*Q2**7*(639+62946*r**2+327965*r**4
            +670680*r**6+694545*r**8+365346*r**10+36639*r**12)-5*Q2**6*(-945+4277*r**2
            -25333*r**4-189343*r**6-197327*r**8-215481*r**10-98931*r**12+60795*r**14)
            +Q2**5*(-9975+232676*r**2+1416716*r**4+2721336*r**6+4815470*r**8+5443880*r**10
            +2655296*r**12+873516*r**14+546381*r**16)-5*Q2**4*(-1881+33246*r**2
            +266324*r**4+737376*r**6+1289802*r**8+1843588*r**10+1626060*r**12+612432*r**14
            +201183*r**16+58158*r**18)+5*Q2**3*(-45+2092*r**2+31513*r**4+543628*r**6
            +348974*r**8+863344*r**10+1386718*r**12+884156*r**14+44967*r**16+106140*r**18
            -15519*r**20)+(-1+r**2)**2*(-795+6057*r**2+62201*r**4-540963*r**6+687258*r**8
            +728234*r**10+339426*r**12+49434*r**14-147727*r**16+329277*r**18-14379*r**20
            +13977*r**22)+5*Q2**2*(-1141+10783*r**2+93415*r**4-524683*r**6+442474*r**8
            +314470*r**10-47806*r**12-472190*r**14-254261*r**16+360507*r**18-57129*r**20
            +34761*r**22)-5*Q2*(-759+6954*r**2+57322*r**4-424866*r**6+607083*r**8
            +102120*r**10+166800*r**12+757680*r**14-67773*r**16-263202*r**18+284310*r**20
            -32638*r**22+16569*r**24))*sqrtq2-24*logq2*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-11815-17342*r**2+20598*Q2**16*r**2-1539738*r**4-1828220*r**6
            -93296530*r**8+531809700*r**10-1202798314*r**12-12016064876*r**14+34941377640*r**16
            -16859928440*r**18-10427104030*r**20+13402061004*r**22-3848051134*r**24
            +1002915580*r**26-360030*r**28+15413020*r**30+576527*r**32+46998*r**34
            -12*Q2**15*(-1480+23619*r**2+19179*r**4)+4*Q2**14*(-32820+315810*r**2
            +775091*r**4+250170*r**6)-4*Q2**13*(-89680+561415*r**2+3441914*r**4
            +3172239*r**6+501840*r**8)+3*Q2**12*(-102835+108210*r**2+8242288*r**4
            +14188924*r**6+7455783*r**8+347210*r**10)+Q2**11*(-501830+4084716*r**2
            -5212386*r**4-3865176*r**6-7029506*r**8-4035196*r**10+3308706*r**12)
            -2*Q2**10*(-682770+1489843*r**2+22024696*r**4+119695125*r**6+221267970*r**8
            +106897065*r**10+24392896*r**12+3266703*r**14)+2*Q2**9*(-367345-3071840*r**2
            +26710386*r**4+227220060*r**6+714133400*r**8+705569180*r**10+204029050*r**12
            +35732936*r**14+1173645*r**16)+Q2**8*(-1049565+10126620*r**2-78738*r**4
            -171444948*r**6-1341551320*r**8-2311353340*r**10-1458873670*r**12-92048748*r**14
            -9710163*r**16+5670720*r**18)-4*Q2**7*(-406065+252615*r**2+7631982*r**4
            +81058936*r**6+189015752*r**8+480461830*r**10+282469470*r**12+143391072*r**14
            +131845761*r**16+16615587*r**18+1761540*r**20)+4*Q2**6*(-86460-2028669*r**2
            +1555743*r**4+74640153*r**6+482523418*r**8+2086011688*r**10+3349274064*r**12
            +1600218868*r**14+600107578*r**16+136941693*r**18+14561673*r**20+206811*r**22)
            +4*Q2**5*(-201465+1468989*r**2+1303132*r**4+13924205*r**6-125757445*r**8
            -1264814850*r**10-4711887796*r**12-4758378986*r**14-842818895*r**16-375154195*r**18
            +18838800*r**20+882517*r**22+946389*r**24)-Q2**4*(-642845-567190*r**2
            -8788364*r**4+119119700*r**6+481332275*r**8+3568163190*r**10-1523155600*r**12
            -13344747272*r**14-6577893895*r**16+5528768150*r**18+405581180*r**20
            +405698740*r**22+29345361*r**24+2648970*r**26)+2*Q2**3*(-18015-1180230*r**2
            -3200553*r**4-5407748*r**6-36754535*r**8+2081584130*r**10+4548956715*r**12
            +5193822776*r**14+943425851*r**16+2957420990*r**18+3054240885*r**20+424070540*r**22
            +85143627*r**24+6359622*r**26+15945*r**28)+2*Q2**2*(-80690+490665*r**2
            -3006468*r**4+17883911*r**6+95819042*r**8-120874895*r**10-1518601440*r**12
            -4189196169*r**14-9293444622*r**16+968976371*r**18-4244198580*r**20+292174125*r**22
            -168527138*r**24+35301811*r**26+1076312*r**28+351765*r**30)-2*Q2*(-38835
            +44444*r**2-3174082*r**4+2322168*r**6-63994442*r**8+565501168*r**10
            +36509186*r**12-748140236*r**14+1938362164*r**16-8068634516*r**18+7204485794*r**20
            -4164681904*r**22+1469846818*r**24-20195832*r**26+35804958*r**28+1423748*r**30
            +159399*r**32))*sqrtq2))/(12247200000*logq2**4*r**16*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+170100000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+118125*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5-29393280000*logq2**5*r**20*sqrtq2-2041200000*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2-7087500*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*sqrtq2)+(248832000*logq2**5*(-Q2+(-1+r)**2)*r**20*(-Q2+(1
            +r)**2)*(17430*Q2**9*r**2-30*Q2**8*(272+4233*r**2+7481*r**4)+20*Q2**7*(3264
            +22735*r**2+68825*r**4+56655*r**6)-4*Q2**6*(57120+262354*r**2+908385*r**4
            +1413715*r**6+746508*r**8)+Q2**5*(357735+1603486*r**2+5904026*r**4+10144720*r**6
            +11876367*r**8+4319742*r**10)-Q2**4*(177135+1424875*r**2+5974758*r**4
            +9283450*r**6+13816975*r**8+13295591*r**10+2719080*r**12)+2*Q2**3*(-63525
            +638930*r**2+1282601*r**4+892656*r**6+4370925*r**8+4748842*r**10+3287287*r**12
            -607740*r**14)+(-1+r**2)**2*(-10995-190821*r**2+2272399*r**4-3380801*r**6
            +2707477*r**8+6261797*r**10-2381047*r**12+559553*r**14+543078*r**16)
            +2*Q2**2*(75705-797750*r**2+1212411*r**4-368452*r**6+686231*r**8+1455822*r**10
            -2803859*r**12-104388*r**14+1707720*r**16)-Q2*(22605-1012136*r**2+5819228*r**4
            -4506132*r**6-2034194*r**8+18547304*r**10+13027020*r**12-6639524*r**14
            +14621*r**16+2283768*r**18))+138240*logq2**3*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(-4279950*Q2**15*r**2+6*Q2**14*(-18208+8559675*r**2
            +7857819*r**4)-2*Q2**13*(-173196+131069169*r**2+244340188*r**4+111790233*r**6)
            +2*Q2**12*(-275124+365949369*r**2+1056445593*r**4+975797473*r**6+291012597*r**8)
            -Q2**11*(-2351697+1129418922*r**2+4806450518*r**4+6913161312*r**6+4151962819*r**8
            +855681786*r**10)+Q2**10*(-4274163+663488337*r**2+5510366566*r**4+12333763866*r**6
            +11950728281*r**8+4903309369*r**10+572306904*r**12)+Q2**9*(-9008679+774897750*r**2
            -881533013*r**4-10329370480*r**6-18391968825*r**8-13455125254*r**10-3080209395*r**12
            +192967272*r**14)+Q2**8*(40023441-1806818289*r**2-5966497653*r**4-84970533*r**6
            +18949132385*r**8+29108704761*r**10+14359588501*r**12+1139132877*r**14
            -661849218*r**16)+2*Q2**7*(-21354327+606778647*r**2+3532153734*r**4+4337602264*r**6
            -7287305354*r**8-22644477322*r**10-22867557658*r**12-5713620736*r**14
            -120062811*r**16+239764131*r**18)-2*Q2**6*(5892147-105735462*r**2+514123917*r**4
            +5239818298*r**6-2212481374*r**8-9902189884*r**10-16807072412*r**12-13552738958*r**14
            +4615557583*r**16+1033609086*r**18+90933939*r**20)+2*Q2**5*(30338913
            -437112867*r**2-2124504081*r**4+5393958819*r**6+4455093004*r**8+20426029954*r**10
            +45123513044*r**12+33108012594*r**14+17047366419*r**16+17046354689*r**18
            +2391690861*r**20+61556571*r**22)-2*Q2**4*(21397599-256088400*r**2-1714477612*r**4
            +3634517060*r**6+8465905985*r**8+30391751462*r**10+80509498470*r**12
            +106781029054*r**14+58678805975*r**16+32295151450*r**18+14176005574*r**20
            +1863415790*r**22+29647593*r**24)+Q2**3*(-3070083+22450602*r**2-153504846*r**4
            -4630366576*r**6+22640916095*r**8+27885781486*r**10+64862524636*r**12
            +162971049072*r**14+175682500267*r**16+17908719830*r**18+43869303922*r**20
            -90236288*r**22+162527449*r**24-90739566*r**26)+(-1+r**2)**2*(1578837
            -13971879*r**2-88085824*r**4+1718164602*r**6-5937703581*r**8-5359390529*r**10
            +40130234858*r**12+7115544828*r**14-23641862069*r**16+5998585127*r**18
            +17177672892*r**20-784465654*r**22+1790205821*r**24+166308417*r**26+11024154*r**28)
            +Q2**2*(18738777-181977807*r**2-988586854*r**4+12716402226*r**6-32574651981*r**8
            -4937939729*r**10+51002522104*r**12+7939032268*r**14-72783597377*r**16
            -76533310913*r**18+86100858802*r**20-23281492222*r**22+13657524661*r**24
            +1429572001*r**26+133066044*r**28)-Q2*(9416403-94690098*r**2-457405127*r**4
            +8415127492*r**6-28629174201*r**8+4475205790*r**10+61911278301*r**12
            +9535882804*r**14+79503423161*r**16+1717738842*r**18-53006833829*r**20
            +74730151372*r**22-13759670227*r**24+7910916922*r**26+810108559*r**28
            +63883836*r**30))-96*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(4346178*Q2**21*r**2
            -6*Q2**20*(-529840+12140307*r**2+10834947*r**4)+12*Q2**19*(-2753020+37376560*r**2
            +87370387*r**4+33845880*r**6)-4*Q2**18*(-35266580+334864297*r**2+1571975340*r**4
            +1527578950*r**6+339473535*r**8)+Q2**17*(-288495195+1781969964*r**2+18406265838*r**4
            +30587442796*r**6+18329941917*r**8+2426543820*r**10)-Q2**16*(-147726015
            -430921809*r**2+24421917588*r**4+54053977714*r**6+56595909581*r**8+26697387795*r**10
            +1293882642*r**12)-4*Q2**15*(-151391935+1111901771*r**2+1040633844*r**4
            +14780667563*r**6+31364377225*r**8+9697214763*r**10-120181198*r**12+941227683*r**14)
            +6*Q2**14*(-228506030+575498635*r**2+9997464088*r**4+68196294155*r**6
            +187162602308*r**8+178901248113*r**10+60552983700*r**12+11061083033*r**14
            +1421472270*r**16)-12*Q2**13*(-62145220-476127957*r**2+6006852430*r**4
            +52450117615*r**6+215511412314*r**8+321268319997*r**10+210072014170*r**12
            +51865683865*r**14+8681307930*r**16+398439240*r**18)+2*Q2**12*(647231780
            -5904055261*r**2+3268181118*r**4+60574166806*r**6+1008552006998*r**8
            +2196559048104*r**10+2391332750242*r**12+1189365933770*r**14+127321623126*r**16
            +18169687637*r**18-3444882480*r**20)+4*Q2**11*(-599004705+675597975*r**2
            +13362634386*r**4+197339715023*r**6+436386531774*r**8+1014214480380*r**10
            +1247432686364*r**12+314661071112*r**14+119297171211*r**16+143535999677*r**18
            +21132119130*r**20+3252059577*r**22)-2*Q2**10*(-443084070-6194778837*r**2
            +19579318440*r**4+449760247537*r**6+2254134111410*r**8+7403698851294*r**10
            +15266562134620*r**12+12986050989842*r**14+4495305540234*r**16+1595081199175*r**18
            +419419709132*r**20+59263283277*r**22+2476283706*r**24)+2*Q2**9*(718798665
            -6891154140*r**2+5268783306*r**4+8393333430*r**6+1160585348447*r**8+4709486868522*r**10
            +19676726459500*r**12+29059754508644*r**14+16787575990575*r**16+3502377109632*r**18
            +1451868398842*r**20+99674237670*r**22+18740493561*r**24-3594625710*r**26)
            +2*Q2**8*(-912032745+591521298*r**2-10315100100*r**4+309681307630*r**6
            +690596603343*r**8+4775267445084*r**10-4609594360424*r**12-26793127322700*r**14
            -30012897964395*r**16-10348935396902*r**18+452133292044*r**20-581917483218*r**22
            +200972125045*r**24+22637109960*r**26+4583661840*r**28)-4*Q2**7*(-102140085
            -2048948163*r**2-4715782116*r**4+85764164453*r**6+450002688637*r**8+4174064855079*r**10
            +5208865393706*r**12-5884263701177*r**14-17902408607883*r**16-14933040110365*r**18
            -2715076829336*r**20+551003752635*r**22-14796196669*r**24+76629795673*r**26
            +12882468306*r**28+514739385*r**30)-2*Q2**6*(-344322610+3193867157*r**2
            -9523868088*r**4+74570415521*r**6-222464850368*r**8-2552859120375*r**10
            -9258092328580*r**12+2801910977797*r**14+28364083588056*r**16+46720236613679*r**18
            +21499149956800*r**20-616567967853*r**22+454370058536*r**24-444634777037*r**26
            +11960566524*r**28-8255926585*r**30+1668851826*r**32)+2*Q2**5*(-301976580
            +367957761*r**2-18571670292*r**4+109877507802*r**6-129557927580*r**8
            +3360010215126*r**10-3480873636164*r**12-5574184033590*r**14+7240655643852*r**16
            +1032859123840*r**18+20905524550212*r**20-13207102480002*r**22-13509515379572*r**24
            +111817800666*r**26-780376684140*r**28+44618106462*r**30+2671667400*r**32
            +1443249999*r**34)+2*Q2**4*(55396920+820950750*r**2+7175052483*r**4-20881993050*r**6
            +241936701954*r**8-3592914951486*r**10+2404019477870*r**12+13286472223102*r**14
            -3762249706830*r**16+55395242717702*r**18+56422800177052*r**20+10514212471410*r**22
            +31991456233622*r**24+16379516373910*r**26+936613229394*r**28+482514814314*r**30
            -3073952130*r**32-3596028732*r**34-249108255*r**36)-4*Q2**3*(-25946945
            +282900223*r**2-2205188805*r**4+14332633895*r**6+15229361032*r**8-404058781374*r**10
            +505307797168*r**12+3231015975470*r**14-2341967202210*r**16+20188999916296*r**18
            +36700157608958*r**20+15027101579700*r**22+8255930941360*r**24+6324230336750*r**26
            +1861835511432*r**28+340403684786*r**30-30684211541*r**32+4672910025*r**34
            -903958385*r**36+127812165*r**38)+(-1+r**2)**2*(-2114885-2918415*r**2
            -506576173*r**4+956438291*r**6-35976132590*r**8+289202352792*r**10-1203324556960*r**12
            -3915395836896*r**14+41016325005862*r**16-79985204048910*r**18-9553289451826*r**20
            +103292828197390*r**22-75262838178764*r**24+11849742128528*r**26-1288867773960*r**28
            -1601029411784*r**30-104826104265*r**32-35503686667*r**34-891538681*r**36
            -24588665*r**38+9916578*r**40)+2*Q2**2*(-37412790+164923953*r**2-5179734144*r**4
            +22887450077*r**6-146550807420*r**8+918600951444*r**10-2191210535460*r**12
            -6071804475564*r**14+27637590786168*r**16-21275597135906*r**18-17933382039828*r**20
            +80827570278486*r**22-64076826927140*r**24+28588200682308*r**26-1596106619628*r**28
            -5239372277916*r**30+60508103646*r**32-225061783527*r**34+1140945572*r**36
            -658344171*r**38+179331840*r**40)+Q2*(20247585-42384948*r**2+3768407118*r**4
            -14823541336*r**6+194235032149*r**8-1526412320400*r**10+5479166139816*r**12
            +11290666069776*r**14-108712458202782*r**16+164236068577048*r**18-19290119855500*r**20
            +121048923781920*r**22-305759283228206*r**24+242859826751072*r**26-50746232473368*r**28
            -682632641040*r**30+7412473492029*r**32+145348138812*r**34+212675728046*r**36
            +3057482296*r**38+346158105*r**40-95838192*r**42))-104509440000*logq2**6*(
            -Q2+(-1+r)**2)*r**24*(-345-588*r**2+3580*r**4-5908*r**6+729*r**8)*(
            -Q2+(1+r)**2)*sqrtq2-8294400*logq2**4*r**16*(168540*Q2**14*r**2-480*Q2**13*(307
            +3370*r**2+2695*r**4)+6*Q2**12*(271980+1292102*r**2+1395593*r**4+386974*r**6)
            +Q2**11*(-8037520-24587254*r**2-21229500*r**4+4693706*r**6+8341272*r**8)
            +Q2**10*(21969815+55849162*r**2+26750549*r**4-84991410*r**6-121656310*r**8
            -44704206*r**10)+10*Q2**9*(-3336685-8811575*r**2-2845502*r**4+22098382*r**6
            +40637797*r**8+32067029*r**10+6948666*r**12)+5*Q2**8*(3866589+18717387*r**2
            +13647648*r**4-20714450*r**6-28711967*r**8-56245205*r**10-52610850*r**12
            +3453300*r**14)-Q2**7*(-22967640+79527009*r**2+168611856*r**4+517645993*r**6
            +1544249820*r**8+2141908235*r**10+1222688164*r**12+279103491*r**14+224069328*r**16)
            +Q2**6*(-54594810+79384653*r**2+241642905*r**4+1259606933*r**6+3571414751*r**8
            +5807511675*r**10+5932877983*r**12+3066576635*r**14+810459963*r**16+350667576*r**18)
            -Q2**5*(-40970820+54836649*r**2+176794608*r**4+1490398290*r**6+3420542220*r**8
            +6133086268*r**10+7907049984*r**12+6582805798*r**14+2778722800*r**16
            +746395395*r**18+220454808*r**20)-(-1+r**2)**4*(-620365+5967378*r**2
            -23053907*r**4+12684714*r**6+87652790*r**8+84653746*r**10+189860106*r**12
            +32296802*r**14-40996769*r**16+123401380*r**18+1145489*r**20+5556636*r**22)
            -5*Q2**4*(516030+9167973*r**2-24444729*r**4-252270462*r**6-212657776*r**8
            -422704960*r**10-859047938*r**12-953038862*r**14-641435798*r**16-60144421*r**18
            -72723117*r**20+7424220*r**22)+5*Q2**3*(-3648792+27808143*r**2-52584588*r**4
            -159790899*r**6+200213132*r**8+45038998*r**10+119963620*r**12+205396146*r**14
            -258561388*r**16-207630469*r**18+344479912*r**20-38321055*r**22+32862840*r**24)
            +Q2*(-1+r**2)**2*(-4725170+42176311*r**2-134871388*r**4-11810171*r**6
            +554393888*r**8+216256842*r**10+1081908784*r**12+1668897566*r**14-76505874*r**16
            -263694033*r**18+732658108*r**20-16900115*r**22+40599252*r**24)+Q2**2*(14202355
            -124436303*r**2+365382198*r**4+89680979*r**6-1401551375*r**8+315925160*r**10
            -827694924*r**12-2991607406*r**14-3159765763*r**16+42603725*r**18+1737544710*r**20
            -1769721973*r**22+172636783*r**24-119966166*r**26))*sqrtq2-1152*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(29181432*Q2**18*r**2-192*Q2**17*(-10815
            +2031948*r**2+2009803*r**4)+8*Q2**16*(-4495050+279314207*r**2+576632965*r**4
            +272539467*r**6)-8*Q2**15*(-26479740+857575699*r**2+2887073928*r**4+2851951003*r**6
            +839248254*r**8)+Q2**14*(-579950175+11250781520*r**2+60272656960*r**4
            +91522656452*r**6+59891615835*r**8+11442536820*r**10)-2*Q2**13*(-317944725
            +3018948363*r**2+38924871460*r**4+75197046664*r**6+78855683289*r**8+41612072985*r**10
            +3779468388*r**12)+Q2**12*(499338735-11649546182*r**2+11888033783*r**4
            -42885588568*r**6-90844463443*r**8+26021749102*r**10+36058012053*r**12
            -9287964552*r**14)+4*Q2**11*(-567957075+6051616688*r**2+26973440075*r**4
            +139045276446*r**6+323904801135*r**8+279925862480*r**10+85506210701*r**12
            +17013955050*r**14+6074935428*r**16)-Q2**10*(-2137723665+12313320904*r**2
            +139462390158*r**4+770273294236*r**6+2679535728328*r**8+3727984068420*r**10
            +2211612833818*r**12+517408140436*r**14+125815073633*r**16+16567839684*r**18)
            +2*Q2**9*(388524675-6219638895*r**2+20521192290*r**4+36292401498*r**6
            +981670427600*r**8+2546026603960*r**10+2529002454810*r**12+989591229550*r**14
            +95515834373*r**16+43991622415*r**18-4045784820*r**20)+Q2**8*(-3157256025
            +20230527906*r**2+46532938565*r**4+862154421356*r**6+847655940246*r**8
            -2848447119240*r**10-6514824777246*r**12-4862917714540*r**14-935413623229*r**16
            +175405057206*r**18-20678191335*r**20+20586734256*r**22)-8*Q2**7*(-251721855
            +744918761*r**2+5301576261*r**4+104217523133*r**6+305884953188*r**8+22863171928*r**10
            -771431020086*r**12-1202327332096*r**14-588446143167*r**16-40575694537*r**18
            +15626021993*r**20+2950587451*r**22+1262442546*r**24)+Q2**6*(735969675
            -8395587472*r**2+26120762540*r**4+5227439724*r**6+1366482497075*r**8
            +1317712037740*r**10-3753786947152*r**12-8759710857720*r**14-9563589693807*r**16
            -1254640885800*r**18+628824851140*r**20-17884673076*r**22+52517686865*r**24
            -4512198132*r**26)+2*Q2**5*(-828957045+4421664167*r**2-18580974256*r**4
            +244961776572*r**6+114905927251*r**8-1143485077025*r**10+134276066892*r**12
            -2062191560976*r**14-1520725313951*r**16-146538847643*r**18-3012496257840*r**20
            -991510128844*r**22-33007649503*r**24-27817333131*r**26+3606639732*r**28)
            +Q2**4*(692618325-2105393730*r**2+26485285585*r**4-304896400448*r**6
            -658004735335*r**8+3059203456110*r**10+970203334445*r**12+10902542753000*r**14
            +23929623195471*r**16+14811606541850*r**18+7790264795795*r**20+7817075072960*r**22
            +1757085536515*r**24+136572455802*r**26+21990748335*r**28-2377984680*r**30)
            -4*Q2**3*(-47174925+455077528*r**2-1440288495*r**4+6183093382*r**6-93834946633*r**8
            +244953180660*r**10+476381906697*r**12+1186907013410*r**14+3865006553101*r**16
            +6214088026176*r**18+1016479622635*r**20+1657107548122*r**22+518905949285*r**24
            +40141255092*r**26+11248566907*r**28-3012775170*r**30+193872228*r**32)
            +(-1+r**2)**2*(-12979995+47775672*r**2-1408986442*r**4+8151891560*r**6
            +9811175870*r**8-620048186800*r**10+2960845599254*r**12-2423784262264*r**14
            -8076437946720*r**16+7071208884960*r**18+2535613188210*r**20-5506402593224*r**22
            +1119531067954*r**24-437224061840*r**26-76853472830*r**28-7608544040*r**30
            -1002153077*r**32+28003752*r**34)+Q2**2*(-279503805+1663451536*r**2-17607336894*r**4
            +120060341132*r**6-127207729478*r**8-2071527069228*r**10+6998861440274*r**12
            -3778263546516*r**14-5208645657864*r**16+3908879856756*r**18+17603280025046*r**20
            -15386632053756*r**22+6419292897814*r**24-2034581871268*r**26-633463412778*r**28
            -35131387388*r**30-16970023179*r**32+847579596*r**34)+2*Q2*(50207325
            -280282093*r**2+4441989970*r**4-30557366622*r**6+18428737230*r**8+1093126432170*r**10
            -4841562006306*r**12+4435767253330*r**14+3284396534336*r**16+2885660554440*r**18
            +335247918610*r**20-8411075865034*r**22+10025706466530*r**24-2859674241306*r**26
            +751435446330*r**28+182587149270*r**30+14005557683*r**32+3514705045*r**34
            -127990908*r**36))*sqrtq2-16*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(117782*Q2**22*r**2
            +2*Q2**21*(-221823+820536*r**2+96251*r**4)-Q2**20*(-5284944+23187525*r**2
            +177338842*r**4+12506213*r**6)+Q2**19*(-27249390+38165518*r**2+2292231954*r**4
            +2088587706*r**6+86048244*r**8)-Q2**18*(-76683285-394024092*r**2+11532748998*r**4
            +24869135040*r**6+10689417279*r**8+287274376*r**10)+Q2**17*(-115063515
            -2056745992*r**2+27852304337*r**4+116022107436*r**6+114304997039*r**8
            +28427103052*r**10+520266491*r**12)-2*Q2**16*(-20622042-1704750591*r**2
            +12302763274*r**4+127764219944*r**6+216102503504*r**8+131111914355*r**10
            +17029347012*r**12+191573492*r**14)+2*Q2**15*(85021272+743503597*r**2
            -16763026470*r**4+95149257443*r**6+265846174784*r**8+293365454495*r**10
            +117448273450*r**12-7917365895*r**14-190780772*r**16)+2*Q2**14*(-154477890
            -6963044157*r**2+52265795819*r**4+155260351153*r**6+393145995435*r**8
            +623096656871*r**10+255852087373*r**12+126747997359*r**14+54952715951*r**16
            +551994934*r**18)-2*Q2**13*(-61060860-9013549857*r**2+31866267708*r**4
            +413109741708*r**6+1520528357472*r**8+3743145718974*r**10+3545459163768*r**12
            +1310012279220*r**14+449482923180*r**16+63032004579*r**18+317829436*r**20)
            +2*Q2**12*(128533860+1423560762*r**2-52164108173*r**4+303760316433*r**6
            +1240117279140*r**8+5545073068116*r**10+8508028127646*r**12+5562197172606*r**14
            +1315007190072*r**16+423584610474*r**18-11125555233*r**20-422834295*r**22)
            +2*Q2**11*(-185095638-15376202569*r**2+99061342216*r**4+89952959839*r**6
            +1052327336500*r**8-351024735310*r**10-2946418876128*r**12-4641831120638*r**14
            -1944546177238*r**16+404460328551*r**18+32209455368*r**20+95382444495*r**22
            +777858120*r**24)-2*Q2**10*(-35653527-13568311029*r**2+29691378179*r**4
            +324543429673*r**6+2340440771094*r**8+7501096791162*r**10+15567958473922*r**12
            +19494408590846*r**14+8433376340457*r**16+4580484772267*r**18+1588819916875*r**20
            +432102327385*r**22+76950558984*r**24+271484720*r**26)+2*Q2**9*(124148115
            +3578041037*r**2-79446626969*r**4+314088013510*r**6+444859060419*r**8
            +7107770629683*r**10+19460384619423*r**12+46291397251524*r**14+40527052853577*r**16
            +11316221788227*r**18+6606980353813*r**20+477157523222*r**22+411400763201*r**24
            -23959936611*r**26-425412859*r**28)+2*Q2**8*(-119316960-14123184727*r**2
            +96203292113*r**4-239515210824*r**6+1805104186450*r**8+42307049207*r**10
            +4651582342827*r**12-30785115565274*r**14-57090488218564*r**16-33759738553593*r**18
            +170852333815*r**20-4007240087572*r**22+933584804082*r**24-141526513255*r**26
            +77811698989*r**28+506541686*r**30)-2*Q2**7*(-12630240-7626635775*r**2
            +17596033922*r**4-55079726405*r**6+1181345742656*r**8+3770234687925*r**10
            +22476266451598*r**12+3064278690791*r**14-39495542079540*r**16-56043690546077*r**18
            -21233945983234*r**20+3580856839857*r**22-735183583640*r**24+499171656103*r**26
            +89902290994*r**28+38237078637*r**30+99711148*r**32)-2*Q2**6*(-48360942
            -3003008846*r**2+48609619839*r**4-221217368479*r**6+862192130823*r**8
            -3238417429755*r**10-9668069045097*r**12-12844653318567*r**14+22053241309947*r**16
            +60450840477177*r**18+59900975617893*r**20+4202751522555*r**22+5474798393085*r**24
            -2668743543673*r**26+608536919045*r**28-187978551221*r**30+17373376623*r**32
            +182824393*r**34)+2*Q2**5*(-33918633-5316954549*r**2+44530322077*r**4
            -294929615632*r**6+1361201029196*r**8-2465279187736*r**10+10371888139596*r**12
            -17721719304152*r**14+8653958142338*r**16+18543375430302*r**18+35465694589342*r**20
            +25895695826528*r**22-38006654655492*r**24+7656230280032*r**26-4523174726228*r**28
            +667715048072*r**30-149279177505*r**32+26888596687*r**34+148452557*r**36)
            +Q2**4*(7426440+3725700097*r**2-17991790404*r**4+207877653843*r**6-677613443552*r**8
            +1691254612892*r**10-23215154137112*r**12+47828932320524*r**14-6533047242912*r**16
            +21177257127670*r**18+150211397446096*r**20+44649873093498*r**22+17363503357504*r**24
            +103809498872380*r**26+718252037176*r**28+4870254806172*r**30-110001851208*r**32
            +71926890801*r**34-16910142636*r**36-46129269*r**38)-2*Q2**3*(-6546645
            -555191574*r**2+9511810281*r**4-70533005052*r**6+447501497326*r**8-1298717441780*r**10
            -198136235956*r**12+8062835294796*r**14-1938511143726*r**16-3544027389264*r**18
            +107088331317942*r**20+51650873367124*r**22+23214536310360*r**24+15524986173908*r**26
            +8666049824780*r**28+5462927402596*r**30-793698879669*r**32+250713743238*r**34
            -38258878455*r**36+3196169208*r**38+26152562*r**40)+2*(-1+r**2)**2*(
            -96138-24787028*r**2+240635575*r**4-3754106166*r**6+12762518407*r**8
            -64264571442*r**10+348004273500*r**12-2060417356900*r**14-581146780072*r**16
            +48616999826364*r**18-155020872746606*r**20+169960807863488*r**22-71876210704350*r**24
            +1010204574992*r**26+3874093373676*r**28-2317054267260*r**30-66978181814*r**32
            -103372884200*r**34+3157013871*r**36-1598353322*r**38+114859071*r**40
            +456354*r**42)+Q2**2*(-7953435-1327943614*r**2+15589802228*r**4-164501798862*r**6
            +843492652643*r**8-3238685993384*r**10+11030485871768*r**12-26709089836160*r**14
            +12529827351850*r**16+47494184530740*r**18-64637339544064*r**20+134230539159444*r**22
            -93878962235714*r**24+197558235136*r**26+72103758016616*r**28-45148244781680*r**30
            +7810732300289*r**32-3143488118854*r**34+350090916876*r**36-75413084374*r**38
            +6624154063*r**40+34938488*r**42)+Q2*(1970829+423083942*r**2-4831114583*r**4
            +61557858752*r**6-299583687821*r**8+1332669591770*r**10-6150956988609*r**12
            +25048166556416*r**14-23805804601486*r**16-150358038171812*r**18+284971521854826*r**20
            +203486498150400*r**22-582690612901130*r**24+309392077570516*r**26+45719886441262*r**28
            -67700484553728*r**30+28212355349809*r**32-2393631883106*r**34+1413430328093*r**36
            -105129869504*r**38+26990195303*r**40-2020606542*r**42-9053597*r**44))*sqrtq2)/(4232632320000*logq2**5*(
            -Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +97977600000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+204120000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-8465264640000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-881798400000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-6123600000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -2835000*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**6*sqrtq2)+((1990656000*logq2**5*(-Q2+(-1+r)**2)*r**20*(-Q2+(1
            +r)**2)*(-420*Q2**9*r**2+60*Q2**8*(8+51*r**2+37*r**4)-40*Q2**7*(96+281*r**2
            +328*r**4+45*r**6)+4*Q2**6*(3360+6676*r**2+8487*r**4+1690*r**6-2877*r**8)
            +Q2**5*(-24675-44164*r**2-44222*r**4-19828*r**6+50433*r**8+32928*r**10)
            +Q2**4*(21315+47095*r**2+28212*r**4+23434*r**6-49925*r**8-104449*r**10
            -27090*r**12)-2*Q2**3*(-105+17105*r**2+3224*r**4+7017*r**6-23847*r**8
            -36323*r**10-32108*r**12+9345*r**14)+(-1+r**2)**2*(-2985+7299*r**2
            +5207*r**4-35113*r**6+43049*r**8+48649*r**10-24515*r**12+9277*r**14
            +9612*r**16)+2*Q2**2*(-8085+16460*r**2+1611*r**4-17045*r**6+6832*r**8
            +7890*r**10-25141*r**12+1203*r**14+26355*r**16)+Q2*(12225-33014*r**2
            +4784*r**4+97176*r**6-51266*r**8-200968*r**10-101904*r**12+68368*r**14
            +641*r**16-37962*r**18))+1105920*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-126720*Q2**15*r**2+12*Q2**14*(-64+127440*r**2+117135*r**4)
            -4*Q2**13*(-9018+1980972*r**2+3696715*r**4+1667115*r**6)+4*Q2**12*(-66342
            +5576832*r**2+16188333*r**4+14879200*r**6+4318875*r**8)-Q2**11*(-796827
            +34607052*r**2+146708482*r**4+204136788*r**6+125461505*r**8+25364880*r**10)
            +Q2**10*(-943533+21504387*r**2+159785972*r**4+291646482*r**6+282753307*r**8
            +138765515*r**10+18135630*r**12)+Q2**9*(-499389+18885840*r**2-242845*r**4
            +36241810*r**6+39677325*r**8-82100264*r**10-59160795*r**12+770310*r**14)
            -Q2**8*(-2715831+46341189*r**2+214774995*r**4+695944635*r**6+1182293495*r**8
            +839871579*r**10+201366349*r**12+19817565*r**14+11395080*r**16)+2*Q2**7*(
            -1284957+14499882*r**2+115869363*r**4+447842420*r**6+960472625*r**8
            +1041617518*r**10+498631117*r**12+102685048*r**14+10572420*r**16+4900500*r**18)
            -2*Q2**6*(245277-3953817*r**2+22867773*r**4+168027617*r**6+433359805*r**8
            +816102877*r**10+668138603*r**12+208201883*r**14+93969722*r**16+9169200*r**18
            +5243220*r**20)+2*Q2**5*(1334283-11017962*r**2-45810702*r**4-93187212*r**6
            -387157432*r**8-150485872*r**10+278775898*r**12+333818448*r**14+188193213*r**16
            +207498298*r**18+28051380*r**20+6579900*r**22)-2*Q2**4*(849609-5431365*r**2
            -34778900*r**4-97580870*r**6-493896470*r**8-545379488*r**10-105973710*r**12
            +481472390*r**14+434402575*r**16+370381925*r**18+198940034*r**20+30749680*r**22
            +3244590*r**24)+Q2**3*(-177153+1716552*r**2-6116820*r**4-113672180*r**6
            -65266565*r**8-728230504*r**10+32992736*r**12+747750120*r**14+1347126965*r**16
            +4123240*r**18+690510932*r**20-41720788*r**22+18933425*r**24-4017960*r**26)
            +(-1+r**2)**2*(52467-214959*r**2-513578*r**4+24544170*r**6-126468135*r**8
            +333630851*r**10+143760988*r**12-186943764*r**14-290848075*r**16+152935495*r**18
            +307080582*r**20-41295254*r**22+44394367*r**24+2264805*r**26+500040*r**28)
            +Q2**2*(706407-4302117*r**2-10478558*r**4+142444560*r**6-627305085*r**8
            +1016948831*r**10-401677846*r**12-242493064*r**14-730602595*r**16-672524215*r**18
            +1375783262*r**20-535514312*r**22+310701497*r**24+8919485*r**26+6513750*r**28)
            +Q2*(-330273+1943268*r**2+3255253*r**4-103200878*r**6+568986855*r**8
            -1328446124*r**10+663530109*r**12+54640474*r**14-1022622379*r**16+253007340*r**18
            +613081927*r**20-1338623402*r**22+389254373*r**24-195871268*r**26-7112345*r**28
            -3012930*r**30))-768*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(41196*Q2**21*r**2
            -12*Q2**20*(-1480+57537*r**2+57537*r**4)+120*Q2**19*(-1538+36356*r**2
            +93839*r**4+39453*r**6)-4*Q2**18*(-197020+3429590*r**2+17022939*r**4
            +17758976*r**6+4374255*r**8)+Q2**17*(-1611705+21307800*r**2+196865022*r**4
            +326801204*r**6+226422315*r**8+36585180*r**10)-Q2**16*(-825285+8328699*r**2
            +243045288*r**4+271652546*r**6+393855835*r**8+353632323*r**10+35295714*r**12)
            -2*Q2**15*(-1691530+8632397*r**2+47034651*r**4+1203624515*r**6+2322591946*r**8
            +888276297*r**10-27952759*r**12+9161007*r**14)+6*Q2**14*(-1276570+306365*r**2
            +107405990*r**4+1468114024*r**6+4369816345*r**8+4133678157*r**10+1278770820*r**12
            +132717130*r**14+15579195*r**16)-6*Q2**13*(-694360-9541905*r**2+108142642*r**4
            +1891948324*r**6+8996254464*r**8+13405058556*r**10+8681955634*r**12+1980123832*r**14
            +229100148*r**16+14985465*r**18)+Q2**12*(7231640-45106750*r**2+147589494*r**4
            -510307928*r**6+31590484676*r**8+63259793076*r**10+72748902136*r**12
            +42509817224*r**14+5135819268*r**16+692981210*r**18-25514190*r**20)+2*Q2**11*(
            -6692790-43045977*r**2-138804633*r**4+9040529951*r**6+31325757150*r**8
            +94929285204*r**10+132949671332*r**12+57641585244*r**14+10260629376*r**16
            +4505870285*r**18+355067277*r**20+63349533*r**22)-2*Q2**10*(-2475330
            -80127723*r**2-427329540*r**4+8482224308*r**6+62173944523*r**8+237632761038*r**10
            +504894152264*r**12+446597123224*r**14+157735353072*r**16+33855112253*r**18
            +6979631884*r**20+627808500*r**22+42879447*r**24)+2*Q2**9*(4015635-17649645*r**2
            -80633610*r**4-1824953034*r**6+29923651135*r**8+140347883043*r**10+544580901140*r**12
            +778778866780*r**14+486715657641*r**16+108009326625*r**18+22472141078*r**20
            +2820445950*r**22+299041125*r**24-17911335*r**26)+2*Q2**8*(-5095155-64812390*r**2
            -726733239*r**4+7729275950*r**6+19926490149*r**8+145558773576*r**10+76967287949*r**12
            -135228948996*r**14-279692483433*r**16-138804933646*r**18+24195819291*r**20
            -3024656826*r**22+968352551*r**24+82666044*r**26+42145695*r**28)-2*Q2**7*(
            -1141230-61180425*r**2-771079923*r**4+3106696853*r**6+26175882046*r**8
            +242266876761*r**10+592831687421*r**12+912351757243*r**14+868180549830*r**16
            +280334574881*r**18+70627874791*r**20+55988355171*r**22-628241398*r**24
            +1023832399*r**26+176923695*r**28+16904205*r**30)+2*Q2**6*(1923590-152827*r**2
            +31246698*r**4-2840959408*r**6+8847417085*r**8+65995782819*r**10+378992755352*r**12
            +759043973518*r**14+1225994189751*r**16+848962846475*r**18+178485168418*r**20
            +17273411172*r**22+24761709059*r**24+567468397*r**26+703397820*r**28
            +117341918*r**30-10364637*r**32)+2*Q2**5*(-1687020-30111117*r**2-526241814*r**4
            +3031195536*r**6-5399320116*r**8+87944018802*r**10-73099714*r**12+85799140020*r**14
            -12540830160*r**16-548859502468*r**18-205049783706*r**20-196227938040*r**22
            -67969411444*r**24-38817508986*r**26-8582403726*r**28-1238044236*r**30
            -53687964*r**32+12470553*r**34)+2*Q2**4*(309480+16643565*r**2+303501675*r**4
            -468666468*r**6+6072438630*r**8-72665356764*r**10-49742477450*r**12-222911612740*r**14
            -809622560514*r**16+56447378230*r**18+316674193628*r**20+117897252180*r**22
            +397604133970*r**24+157953921812*r**26+45568320090*r**28+9012406356*r**30
            +894533730*r**32+1524645*r**34-2924055*r**36)-2*Q2**3*(-289910-474605*r**2
            -31915293*r**4+714305651*r**6-771979178*r**8-2462298942*r**10-13502542778*r**12
            -21154868422*r**14-399967899894*r**16+182040594376*r**18+323036215364*r**20
            +30667931616*r**22+367504684738*r**24+62106880670*r**26+100384759962*r**28
            +4651250438*r**30+1576907092*r**32-89419323*r**34-26686727*r**36+1965165*r**38)
            +(-1+r**2)**2*(-11815-403479*r**2-12116849*r**4+7431355*r**6-1021262296*r**8
            +3713843244*r**10-19357856828*r**12-79702366908*r**14+643446898310*r**16
            -1875974607162*r**18+1346326900378*r**20+947285878418*r**22-1500221460412*r**24
            +547694052940*r**26-160473203388*r**28-1314878428*r**30-6495045111*r**32
            -596417831*r**34-67757105*r**36-1871029*r**38+93996*r**40)+2*Q2**2*(
            -209010-3774075*r**2-100503306*r**4+495159340*r**6-4934409087*r**8+23742388308*r**10
            -47797118772*r**12-65442601284*r**14+435289265808*r**16-512251145506*r**18
            +201626183424*r**20+843810468444*r**22-1273773051514*r**24+942040248564*r**26
            -363615254652*r**28+28925356068*r**30-22402113222*r**32-2276793771*r**34
            -420155462*r**36-21995880*r**38+1575585*r**40)+Q2*(113115+2926986*r**2
            +81610158*r**4-276256040*r**6+5678145215*r**8-28132582398*r**10+96147156696*r**12
            +166092974016*r**14-1702057063770*r**16+4055392372820*r**18-2870556455516*r**20
            +1790627790576*r**22-4370925867706*r**24+5072448079060*r**26-2208592193160*r**28
            +617619359616*r**30-27933564609*r**32+28296357282*r**34+2726470750*r**36
            +402827000*r**38+15322683*r**40-882774*r**42))-836075520000*logq2**6*r**24*(3
            +20*r**4-56*r**6+9*r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2
            +66355200*logq2**4*r**16*(-13260*Q2**14*r**2+60*Q2**13*(40+2680*r**2+2401*r**4)
            -6*Q2**12*(5100+147238*r**2+246091*r**4+112154*r**6)+4*Q2**11*(40100
            +721304*r**2+1652517*r**4+1421660*r**6+435672*r**8)-Q2**10*(447475+6049088*r**2
            +16717435*r**4+20029380*r**6+11769298*r**8+2703384*r**10)+10*Q2**9*(68555
            +805237*r**2+2501440*r**4+3686911*r**6+3084241*r**8+1407782*r**10+268974*r**12)
            -5*Q2**8*(86805+1204482*r**2+3844386*r**4+6617882*r**6+7328747*r**8
            +5298296*r**10+2150082*r**12+501012*r**14)+2*Q2**7*(-162900+537168*r**2
            -559419*r**4+448879*r**6+4767120*r**8+10594610*r**10+9988123*r**12+4398291*r**14
            +1874124*r**16)+Q2**6*(868050+2153988*r**2+18220419*r**4+28318100*r**6
            +22904339*r**8-2968560*r**10-30037967*r**12-26248396*r**14-10867545*r**16
            -5050836*r**18)+2*Q2**5*(-317550-1078182*r**2-8595135*r**4-13362360*r**6
            -11869077*r**8-483356*r**10+15992313*r**12+22072780*r**14+12186475*r**16
            +5063118*r**18+1597974*r**20)+(-1+r**2)**4*(-7925+64002*r**2-644137*r**4
            +2092860*r**6-501548*r**8-14416*r**10+1553052*r**12-405848*r**14+305105*r**16
            +1974638*r**18-7619*r**20+127836*r**22)+5*Q2**4*(5790+325128*r**2+588075*r**4
            +2765862*r**6+1529776*r**8-1393670*r**10-5670238*r**12-6381562*r**14
            -4463374*r**16+401518*r**18-1179069*r**20+206484*r**22)-10*Q2**3*(-27300
            +174264*r**2-918057*r**4+1832787*r**6-194026*r**8-1252730*r**10-218876*r**12
            +379404*r**14-893110*r**16-338902*r**18+2742397*r**20-414711*r**22+338460*r**24)
            -2*Q2*(-1+r**2)**2*(-31775+227677*r**2-2019340*r**4+5478478*r**6-1014238*r**8
            -2340054*r**10+6316966*r**12+6661844*r**14-1319973*r**16+248793*r**18
            +5766334*r**20-279938*r**22+449226*r**24)+Q2**2*(-200975+1401592*r**2
            -10450116*r**4+27647936*r**6-17373755*r**8-7527460*r**10+13976676*r**12
            +33441052*r**14+27045263*r**16-4193020*r**18-17708640*r**20+28043732*r**22
            -4073861*r**24+2547576*r**26))*sqrtq2-9216*logq2**2*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(556584*Q2**18*r**2-24*Q2**17*(-6440+323208*r**2+306463*r**4)
            +8*Q2**16*(-206850+5519389*r**2+11628335*r**4+5174919*r**6)-16*Q2**15*(
            -453390+8198464*r**2+29667243*r**4+28688323*r**6+7989399*r**8)+Q2**14*(
            -15560475+202083880*r**2+1220893040*r**4+1833745864*r**6+1181704395*r**8
            +225561240*r**10)-2*Q2**13*(-5645325+43616511*r**2+717343940*r**4+1230354128*r**6
            +1303767993*r**8+779996385*r**10+94366656*r**12)-Q2**12*(-21123795+215895094*r**2
            +268889069*r**4+4014555896*r**6+6997825091*r**8+2134796386*r**10-510499101*r**12
            +59589024*r**14)+4*Q2**11*(-14212275+86070211*r**2+743035225*r**4+4686585867*r**6
            +11081489235*r**8+9824682745*r**10+3123228847*r**12+360722385*r**14+78294696*r**16)
            -Q2**10*(-39352005+41037548*r**2+3285943206*r**4+23975557532*r**6+82036551836*r**8
            +111640348140*r**10+68855674586*r**12+16275034772*r**14+2141869801*r**16
            +285317208*r**18)+2*Q2**9*(15644475-159295005*r**2+299102910*r**4+1564699086*r**6
            +23439363700*r**8+50040687620*r**10+51591022530*r**12+24569424530*r**14
            +2959354561*r**16+549580505*r**18+16391760*r**20)+Q2**8*(-72689925+241774542*r**2
            +1376541385*r**4+23642841412*r**6+53046035202*r**8+80273670480*r**10
            +65852812518*r**12+5296665100*r**14-1699708733*r**16+5042504322*r**18
            -160900335*r**20+132289872*r**22)-8*Q2**7*(-4477935-12549833*r**2+113135397*r**4
            +2869845901*r**6+12111514456*r**8+27782911496*r**10+40552191738*r**12
            +27367406188*r**14+7124939001*r**16+1485846481*r**18+625020601*r**20
            +805847*r**22+13167702*r**24)+Q2**6*(22941975-222773024*r**2+320246860*r**4
            +1186948608*r**6+42075249355*r**8+123826787000*r**10+253894842256*r**12
            +302901668880*r**14+128639342541*r**16+31928011680*r**18+5192478500*r**20
            +3260490288*r**22+390413905*r**24+33194376*r**26)-2*Q2**5*(17956365-41277559*r**2
            +323114312*r**4-5311848084*r**6-7966543787*r**8-13823328875*r**10-38085421224*r**12
            +36373118112*r**14+58882418407*r**16+19450066291*r**18+33943885680*r**20
            +8402339828*r**22+2995570871*r**24+427633647*r**26+3519216*r**28)+Q2**4*(12569025
            +42558630*r**2+532283765*r**4-5857073536*r**6-20006350895*r**8-34234549530*r**10
            -191812969715*r**12-100524001040*r**14+70382940747*r**16+93491962450*r**18
            +82418789815*r**20+95990523760*r**22+24050384675*r**24+5151956514*r**26
            +571345095*r**28-1409760*r**30)+4*Q2**3*(1243725-12088901*r**2+33945405*r**4
            -197600789*r**6+1481269421*r**8+1734068835*r**10+12345396741*r**12+16114316675*r**14
            -14472290177*r**16-38680880487*r**18+1084023295*r**20-28955989079*r**22
            -2626870105*r**24-2641517559*r**26+73361791*r**28+12920745*r**30+2530464*r**32)
            -(-1+r**2)**2*(246015+536676*r**2+32866994*r**4-76476220*r**6+175415270*r**8
            +9083955020*r**10-45076434838*r**12+107812661588*r**14+2554205940*r**16
            -117106438140*r**18+3423157590*r**20+86477254348*r**22-27968873558*r**24
            +12315091780*r**26+668521870*r**28+322313500*r**30+20632189*r**32+563976*r**34)
            -Q2**2*(5835585-16402172*r**2+385462518*r**4-2053395604*r**6+1536932986*r**8
            +27486858996*r**10-116893034098*r**12+168733564812*r**14-98504943492*r**16
            -29664224772*r**18-184808077822*r**20+263810299812*r**22-154780905578*r**24
            +66730605596*r**26+491409786*r**28+2847158116*r**30+251116083*r**32+9739248*r**34)
            +2*Q2*(987525-952091*r**2+95622530*r**4-441681714*r**6+600269490*r**8
            +14843714010*r**10-78143641962*r**12+165889979990*r**14-93319820228*r**16
            +36498450420*r**18-1688578270*r**20-108839318678*r**22+176852299230*r**24
            -73189265802*r**26+24791391090*r**28+519434610*r**30+787021231*r**32
            +60572375*r**34+1916244*r**36))*sqrtq2-128*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(658*Q2**22+Q2**21*(9168+5492*r**2)-Q2**20*(149367+1710440*r**2
            +145885*r**4)+2*Q2**19*(166081+11225142*r**2+11373357*r**4+513816*r**6)
            -4*Q2**18*(-500241+29074056*r**2+68728671*r**4+32028984*r**6+949307*r**8)
            +2*Q2**17*(-5615008+146448803*r**2+643844310*r**4+678188618*r**6+190108966*r**8
            +4125635*r**10)-4*Q2**16*(-3973359+74266084*r**2+679947566*r**4+1166558084*r**6
            +813909434*r**8+142704876*r**10+2477669*r**12)+2*Q2**15*(11775989-110636094*r**2
            +664396723*r**4+951187330*r**6+1749762163*r**8+1506240170*r**10+59782461*r**12
            +1513106*r**14)+2*Q2**14*(-55171233+425567014*r**2+2711053775*r**4+12958211190*r**6
            +21658743637*r**8+9739250642*r**10+1595151489*r**12+544099234*r**14+4360652*r**16)
            -2*Q2**13*(-64251489+244237704*r**2+5532279198*r**4+32275758294*r**6
            +86358159924*r**8+82047028890*r**10+28156092330*r**12+5697080754*r**14
            +880213701*r**16+5410358*r**18)+Q2**12*(32404320-689625728*r**2+6029515422*r**4
            +40568180232*r**6+219931592136*r**8+336188308392*r**10+225093896652*r**12
            +50076188856*r**14+10603021032*r**16+512577624*r**18-2528058*r**20)+2*Q2**11*(
            -115033373+399321098*r**2+2210312267*r**4+31587831686*r**6+31061512558*r**8
            +34431825288*r**10-6092006098*r**12-19785079664*r**14+9780730671*r**16
            +148443454*r**18+792861927*r**20+7594938*r**22)-2*Q2**10*(-93871869-301375562*r**2
            +3319994183*r**4+57918106482*r**6+221297158884*r**8+548728816820*r**10
            +745806838042*r**12+376195573260*r**14+111602538743*r**16+34133271638*r**18
            +4291667039*r**20+952597698*r**22+5111938*r**24)+2*Q2**9*(35349973-660880954*r**2
            +1254992504*r**4+13592393802*r**6+188409941901*r**8+595751483472*r**10
            +1400248406784*r**12+1275737968812*r**14+420777203271*r**16+112212418766*r**18
            +17786796808*r**20+3853561546*r**22+74351511*r**24-2393252*r**26)+2*Q2**8*(
            -108253049+118145044*r**2-1124814378*r**4+38306461532*r**6+18754759225*r**8
            +173212341792*r**10-500295246472*r**12-989355332216*r**14-692859876855*r**16
            -17789612956*r**18-28297635746*r**20+5682638556*r**22-1939300841*r**24
            +618754856*r**26+5264308*r**28)-2*Q2**7*(-54052263-448577294*r**2-1520978173*r**4
            +28731627586*r**6+112888864569*r**8+706645991774*r**10+929096410339*r**12
            +1001121957078*r**14+418146169379*r**16+16355794270*r**18+193861735857*r**20
            +135446846*r**22+5076541451*r**24-433805614*r**26+430061097*r**28+2026538*r**30)
            +2*Q2**6*(26086756-338891526*r**2+444452537*r**4-9932112558*r**6+69997798893*r**8
            +300770174994*r**10+915081187041*r**12+1489407656154*r**14+1687384602261*r**16
            +547655973486*r**18-13794033501*r**20+77006155926*r**22+1117169999*r**24
            -1921129978*r**26+1260136771*r**28-59789634*r**30-1335221*r**32)+2*Q2**5*(
            -41065221-30301762*r**2-2100878558*r**4+19379453494*r**6-37887938426*r**8
            +262142876010*r**10-288763677838*r**12+154465718158*r**14-604942387500*r**16
            -650739335506*r**18-222381517226*r**20-50316474078*r**22-61839285638*r**24
            -28061823154*r**26-913977578*r**28-2037242598*r**30+205606193*r**32+1540828*r**34)
            +Q2**4*(27030983+281559096*r**2+2329355103*r**4-8747645416*r**6+40739366524*r**8
            -535300669288*r**10+403110641524*r**12-1808455964520*r**14-1432781657230*r**16
            +955373106632*r**18+122065779642*r**20+994249714184*r**22+578840269196*r**24
            +246283782728*r**26+66968062644*r**28+8072207688*r**30+1963310271*r**32
            -157780704*r**34-693057*r**36)-4*Q2**3*(-2393664+28989864*r**2-155289084*r**4
            +2427128335*r**6-6125332244*r**8-451871134*r**10+21267853224*r**12-132493087338*r**14
            -254737602684*r**16+394463082666*r**18-13968192200*r**20+181366227780*r**22
            +40316224628*r**24+110206678118*r**26+21963685960*r**28+2782514298*r**30
            +999139932*r**32-155130906*r**34+9843156*r**36+123293*r**38)+2*(-1
            +r**2)**2*(-190141-1529518*r**2-33679497*r**4+9807032*r**6-1746945342*r**8
            +6647955444*r**10-39233655776*r**12-41613662324*r**14+844981789254*r**16
            -3200025798184*r**18+4808873592694*r**20-3353175039444*r**22+1172325161764*r**24
            -289357902804*r**26+26173110744*r**28-10693057756*r**30-1369313137*r**32
            -113407818*r**34-30256357*r**36+935532*r**38+5634*r**40)+2*Q2**2*(-5256619
            -1096858*r**2-569910819*r**4+3574594202*r**6-23996575640*r**8+106537748288*r**10
            -268025666192*r**12+237211890976*r**14+208084980498*r**16-175106578276*r**18
            +1047462497634*r**20-2262696717692*r**22+2130463827880*r**24-852248583952*r**26
            +143057076472*r**28-47330360656*r**30-10657058383*r**32-95706162*r**34
            -538547623*r**36+25490194*r**38+192728*r**40)-2*Q2*(-1647815-6079975*r**2
            -224696078*r**4+905703860*r**6-11449882667*r**8+57888034035*r**10-231966314240*r**12
            +211288930984*r**14+1134859600730*r**16-3216199321134*r**18-86321246700*r**20
            +6808527240080*r**22-7559948172934*r**24+3468174980510*r**26-972610147056*r**28
            +129588947480*r**30-38974080115*r**32-6566340347*r**34-280835350*r**36
            -221131268*r**38+8084625*r**40+53375*r**42))*sqrtq2)*math.log(mu0))/(705438720000*logq2**5*(
            -Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +16329600000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+34020000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-1410877440000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-146966400000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-1020600000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -472500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*sqrtq2)
            +((10368000*logq2**4*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(340-1741*r**2
            +105*Q2**7*r**2+5955*r**4-5175*r**6+3561*r**8+12591*r**10-4573*r**12
            +841*r**14+801*r**16-5*Q2**6*(16+111*r**2+159*r**4)+5*Q2**5*(96+279*r**2
            +724*r**4+471*r**6)-Q2**4*(1200+2331*r**2+6259*r**4+9055*r**6+3399*r**8)
            +Q2**3*(1075+2834*r**2+6055*r**4+10016*r**6+11036*r**8+1956*r**10)
            +Q2**2*(270-2591*r**2-1978*r**4-3537*r**6-9223*r**8-5456*r**10+1011*r**12)
            -Q2*(885-2989*r**2+1628*r**4+3750*r**6-2139*r**8-6015*r**10+746*r**12
            +2034*r**14))+2880*logq2**2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -4656+9857*r**2+9795*Q2**13*r**2-360589*r**4+1247426*r**6+7361182*r**8
            -110253713*r**10+191149981*r**12+55415668*r**14-108222692*r**16+14298391*r**18
            +43828469*r**20-8037238*r**22+4174646*r**24+77241*r**26+36027*r**28
            -Q2**12*(176+99615*r**2+100143*r**4)+Q2**11*(-5648+421432*r**2+902836*r**4
            +410136*r**6)-2*Q2**10*(-16752+433534*r**2+1590537*r**4+1611252*r**6
            +398709*r**8)+5*Q2**9*(-11871+142514*r**2+1005296*r**4+1552692*r**6
            +1056027*r**8+99342*r**10)+5*Q2**8*(-24+71123*r**2-372041*r**4-2468*r**6
            -278440*r**8-442443*r**10+168525*r**12)-2*Q2**7*(-60246+537940*r**2
            +2273487*r**4+14694780*r**6+25759600*r**8+12425514*r**10+2765355*r**12
            +886122*r**14)+2*Q2**6*(-59052+203748*r**2+2708799*r**4+21785399*r**6
            +64454790*r**8+64322268*r**10+18579313*r**12+4286709*r**14+393714*r**16)
            +Q2**5*(-30498+538711*r**2-1098862*r**4-8740592*r**6-94734134*r**8-181196498*r**10
            -110016034*r**12+744928*r**14-2852712*r**16+893691*r**18)-5*Q2**4*(-21816
            +101869*r**2+36771*r**4+5194326*r**6+7971754*r**8-4244340*r**10-9474900*r**12
            +2307154*r**14+8546022*r**16+621087*r**18+228057*r**20)+10*Q2**3*(-4378
            +1164*r**2-74427*r**4+1524972*r**6+8392172*r**8+11921018*r**10+15535886*r**12
            +7500786*r**14+7836870*r**16+2814850*r**18+305589*r**20+24138*r**22)
            +2*Q2**2*(-11108+77610*r**2-109354*r**4+2494245*r**6-11916315*r**8-37141854*r**10
            -61205670*r**12-93691512*r**14-2752980*r**16-28238020*r**18+4228152*r**20
            -337925*r**22+141531*r**24)-3*Q2*(-7159+23476*r**2-315922*r**4+1964468*r**6
            +4565555*r**8-22863892*r**10+43126788*r**12-35799496*r**14-27648481*r**16
            +25613020*r**18-8809874*r**20+4904436*r**22+63493*r**24+63588*r**26))
            +4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**17*r**2+6*Q2**16*(-503
            +1857*r**2+348*r**4)-Q2**15*(-26898+102167*r**2+795672*r**4+48371*r**6)
            +Q2**14*(-98640-56049*r**2+7994969*r**4+6700457*r**6+211055*r**8)-Q2**13*(
            -177975-1898941*r**2+27560140*r**4+63311870*r**6+22428463*r**8+399935*r**10)
            +2*Q2**12*(-57195-2309884*r**2+17136106*r**4+101613869*r**6+95944414*r**8
            +14856441*r**10+111733*r**12)+Q2**11*(-137556+373945*r**2+19063926*r**4
            -223999621*r**6-431226616*r**8-214206393*r**10+13775206*r**12+451941*r**14)
            -Q2**10*(-294096-13637297*r**2+90239625*r**4+147158379*r**6+237617085*r**8
            +126892013*r**10+149456939*r**12+90174137*r**14+864127*r**16)+Q2**9*(
            -82995-18238327*r**2+48326482*r**4+551909576*r**6+1906001960*r**8+3380058850*r**10
            +1563679558*r**12+632089712*r**14+84181011*r**16+257565*r**18)+2*Q2**8*(
            -126225-1009991*r**2+46086545*r**4-193715485*r**6-853227627*r**8-3255304445*r**10
            -3266464121*r**12-698363155*r**14-250698540*r**16+20066388*r**18+349360*r**20)
            -Q2**7*(-270930-22679187*r**2+132341324*r**4+45799181*r**6+1014675076*r**8
            -843528166*r**10-3741360624*r**12-2052704686*r**14+1341959486*r**16+200656521*r**18
            +125143764*r**20+760881*r**22)+Q2**6*(-14784-14394991*r**2+11307799*r**4
            +195247027*r**6+1774319317*r**8+7423701738*r**10+17856696358*r**12+11717789766*r**14
            +7166277802*r**16+2527824517*r**18+562002755*r**20+57687687*r**22+36929*r**24)
            +Q2**5*(-139311-6909393*r**2+94005896*r**4-225483814*r**6+422091965*r**8
            -4834215971*r**10-21741140296*r**12-43522669716*r**14-12347107893*r**16
            -8634004135*r**18-44297888*r**20-276307526*r**22+46636615*r**24+403867*r**26)
            -2*Q2**4*(-42255-5827438*r**2+34822088*r**4-116753271*r**6+605172420*r**8
            +534178775*r**10+2627004171*r**12-11002393566*r**14-17819750663*r**16
            +6074554120*r**18-930477570*r**20+950406917*r**22+35981378*r**24+28343359*r**26
            +123935*r**28)+Q2**3*(3600-2982709*r**2-596050*r**4-46349435*r**6-106353308*r**8
            +1201901155*r**10+13462806858*r**12+14229490325*r**14+3687037960*r**16
            -6454737479*r**18+18543504930*r**20+3071947751*r**22+885610500*r**24
            +125097625*r**26+10537062*r**28-6785*r**30)+Q2**2*(-23040-2142577*r**2
            +24290137*r**4-132014257*r**6+694056873*r**8-696848773*r**10-872984739*r**12
            -4977016789*r**14-35888913091*r**16+7774277309*r**18-20252527269*r**20
            +2796606109*r**22-2790985173*r**24+437225273*r**26-48682257*r**28+11649257*r**30
            +65007*r**32)+Q2*(9483+1473529*r**2-12345038*r**4+104663644*r**6-278087326*r**8
            +723773040*r**10-4072964318*r**12+4203800668*r**14-17674051888*r**16
            +59843857002*r**18-65906419354*r**20+39123878324*r**22-11142159922*r**24
            +974218744*r**26-446730426*r**28+7287956*r**30-6977035*r**32-27083*r**34)
            +2*(-654-131806*r**2+1042713*r**4-11829543*r**6+9308985*r**8-75573153*r**10
            +468182403*r**12-2736829079*r**14-10699576611*r**16+52263253755*r**18
            -64276935707*r**20+35970149187*r**22-9421707981*r**24+1788128901*r**26
            -61350615*r**28+49334139*r**30-137659*r**32+590847*r**34+1878*r**36))
            -2177280000*logq2**5*r**18*(-3-4*r**2+20*r**4-28*r**6+3*r**8)*sqrtq2
            +172800*logq2**3*r**10*(2265*Q2**12*r**2-10*Q2**11*(-8+2487*r**2+2463*r**4)
            +2*Q2**10*(60+57651*r**2+114071*r**4+57771*r**6)-10*Q2**9*(168+29587*r**2
            +86688*r**4+87891*r**6+29466*r**8)+10*Q2**8*(345+43559*r**2+170411*r**4
            +257585*r**6+177420*r**8+40572*r**10)-5*Q2**7*(639+62946*r**2+327965*r**4
            +670680*r**6+694545*r**8+365346*r**10+36639*r**12)-5*Q2**6*(-945+4277*r**2
            -25333*r**4-189343*r**6-197327*r**8-215481*r**10-98931*r**12+60795*r**14)
            +Q2**5*(-9975+232676*r**2+1416716*r**4+2721336*r**6+4815470*r**8+5443880*r**10
            +2655296*r**12+873516*r**14+546381*r**16)-5*Q2**4*(-1881+33246*r**2
            +266324*r**4+737376*r**6+1289802*r**8+1843588*r**10+1626060*r**12+612432*r**14
            +201183*r**16+58158*r**18)+5*Q2**3*(-45+2092*r**2+31513*r**4+543628*r**6
            +348974*r**8+863344*r**10+1386718*r**12+884156*r**14+44967*r**16+106140*r**18
            -15519*r**20)+(-1+r**2)**2*(-795+6057*r**2+62201*r**4-540963*r**6+687258*r**8
            +728234*r**10+339426*r**12+49434*r**14-147727*r**16+329277*r**18-14379*r**20
            +13977*r**22)+5*Q2**2*(-1141+10783*r**2+93415*r**4-524683*r**6+442474*r**8
            +314470*r**10-47806*r**12-472190*r**14-254261*r**16+360507*r**18-57129*r**20
            +34761*r**22)-5*Q2*(-759+6954*r**2+57322*r**4-424866*r**6+607083*r**8
            +102120*r**10+166800*r**12+757680*r**14-67773*r**16-263202*r**18+284310*r**20
            -32638*r**22+16569*r**24))*sqrtq2+24*logq2*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-11815-17342*r**2+20598*Q2**16*r**2-1539738*r**4-1828220*r**6
            -93296530*r**8+531809700*r**10-1202798314*r**12-12016064876*r**14+34941377640*r**16
            -16859928440*r**18-10427104030*r**20+13402061004*r**22-3848051134*r**24
            +1002915580*r**26-360030*r**28+15413020*r**30+576527*r**32+46998*r**34
            -12*Q2**15*(-1480+23619*r**2+19179*r**4)+4*Q2**14*(-32820+315810*r**2
            +775091*r**4+250170*r**6)-4*Q2**13*(-89680+561415*r**2+3441914*r**4
            +3172239*r**6+501840*r**8)+3*Q2**12*(-102835+108210*r**2+8242288*r**4
            +14188924*r**6+7455783*r**8+347210*r**10)+Q2**11*(-501830+4084716*r**2
            -5212386*r**4-3865176*r**6-7029506*r**8-4035196*r**10+3308706*r**12)
            -2*Q2**10*(-682770+1489843*r**2+22024696*r**4+119695125*r**6+221267970*r**8
            +106897065*r**10+24392896*r**12+3266703*r**14)+2*Q2**9*(-367345-3071840*r**2
            +26710386*r**4+227220060*r**6+714133400*r**8+705569180*r**10+204029050*r**12
            +35732936*r**14+1173645*r**16)+Q2**8*(-1049565+10126620*r**2-78738*r**4
            -171444948*r**6-1341551320*r**8-2311353340*r**10-1458873670*r**12-92048748*r**14
            -9710163*r**16+5670720*r**18)-4*Q2**7*(-406065+252615*r**2+7631982*r**4
            +81058936*r**6+189015752*r**8+480461830*r**10+282469470*r**12+143391072*r**14
            +131845761*r**16+16615587*r**18+1761540*r**20)+4*Q2**6*(-86460-2028669*r**2
            +1555743*r**4+74640153*r**6+482523418*r**8+2086011688*r**10+3349274064*r**12
            +1600218868*r**14+600107578*r**16+136941693*r**18+14561673*r**20+206811*r**22)
            +4*Q2**5*(-201465+1468989*r**2+1303132*r**4+13924205*r**6-125757445*r**8
            -1264814850*r**10-4711887796*r**12-4758378986*r**14-842818895*r**16-375154195*r**18
            +18838800*r**20+882517*r**22+946389*r**24)-Q2**4*(-642845-567190*r**2
            -8788364*r**4+119119700*r**6+481332275*r**8+3568163190*r**10-1523155600*r**12
            -13344747272*r**14-6577893895*r**16+5528768150*r**18+405581180*r**20
            +405698740*r**22+29345361*r**24+2648970*r**26)+2*Q2**3*(-18015-1180230*r**2
            -3200553*r**4-5407748*r**6-36754535*r**8+2081584130*r**10+4548956715*r**12
            +5193822776*r**14+943425851*r**16+2957420990*r**18+3054240885*r**20+424070540*r**22
            +85143627*r**24+6359622*r**26+15945*r**28)+2*Q2**2*(-80690+490665*r**2
            -3006468*r**4+17883911*r**6+95819042*r**8-120874895*r**10-1518601440*r**12
            -4189196169*r**14-9293444622*r**16+968976371*r**18-4244198580*r**20+292174125*r**22
            -168527138*r**24+35301811*r**26+1076312*r**28+351765*r**30)-2*Q2*(-38835
            +44444*r**2-3174082*r**4+2322168*r**6-63994442*r**8+565501168*r**10
            +36509186*r**12-748140236*r**14+1938362164*r**16-8068634516*r**18+7204485794*r**20
            -4164681904*r**22+1469846818*r**24-20195832*r**26+35804958*r**28+1423748*r**30
            +159399*r**32))*sqrtq2)*math.log(mus))/(1469664000*logq2**4*r**16*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+20412000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+14175*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5-3527193600*logq2**5*r**20*sqrtq2-244944000*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2-850500*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*sqrtq2)+((-10368000*logq2**4*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(340-1741*r**2+105*Q2**7*r**2+5955*r**4-5175*r**6+3561*r**8
            +12591*r**10-4573*r**12+841*r**14+801*r**16-5*Q2**6*(16+111*r**2+159*r**4)
            +5*Q2**5*(96+279*r**2+724*r**4+471*r**6)-Q2**4*(1200+2331*r**2+6259*r**4
            +9055*r**6+3399*r**8)+Q2**3*(1075+2834*r**2+6055*r**4+10016*r**6+11036*r**8
            +1956*r**10)+Q2**2*(270-2591*r**2-1978*r**4-3537*r**6-9223*r**8-5456*r**10
            +1011*r**12)-Q2*(885-2989*r**2+1628*r**4+3750*r**6-2139*r**8-6015*r**10
            +746*r**12+2034*r**14))-2880*logq2**2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-4656+9857*r**2+9795*Q2**13*r**2-360589*r**4+1247426*r**6
            +7361182*r**8-110253713*r**10+191149981*r**12+55415668*r**14-108222692*r**16
            +14298391*r**18+43828469*r**20-8037238*r**22+4174646*r**24+77241*r**26
            +36027*r**28-Q2**12*(176+99615*r**2+100143*r**4)+Q2**11*(-5648+421432*r**2
            +902836*r**4+410136*r**6)-2*Q2**10*(-16752+433534*r**2+1590537*r**4
            +1611252*r**6+398709*r**8)+5*Q2**9*(-11871+142514*r**2+1005296*r**4
            +1552692*r**6+1056027*r**8+99342*r**10)+5*Q2**8*(-24+71123*r**2-372041*r**4
            -2468*r**6-278440*r**8-442443*r**10+168525*r**12)-2*Q2**7*(-60246+537940*r**2
            +2273487*r**4+14694780*r**6+25759600*r**8+12425514*r**10+2765355*r**12
            +886122*r**14)+2*Q2**6*(-59052+203748*r**2+2708799*r**4+21785399*r**6
            +64454790*r**8+64322268*r**10+18579313*r**12+4286709*r**14+393714*r**16)
            +Q2**5*(-30498+538711*r**2-1098862*r**4-8740592*r**6-94734134*r**8-181196498*r**10
            -110016034*r**12+744928*r**14-2852712*r**16+893691*r**18)-5*Q2**4*(-21816
            +101869*r**2+36771*r**4+5194326*r**6+7971754*r**8-4244340*r**10-9474900*r**12
            +2307154*r**14+8546022*r**16+621087*r**18+228057*r**20)+10*Q2**3*(-4378
            +1164*r**2-74427*r**4+1524972*r**6+8392172*r**8+11921018*r**10+15535886*r**12
            +7500786*r**14+7836870*r**16+2814850*r**18+305589*r**20+24138*r**22)
            +2*Q2**2*(-11108+77610*r**2-109354*r**4+2494245*r**6-11916315*r**8-37141854*r**10
            -61205670*r**12-93691512*r**14-2752980*r**16-28238020*r**18+4228152*r**20
            -337925*r**22+141531*r**24)-3*Q2*(-7159+23476*r**2-315922*r**4+1964468*r**6
            +4565555*r**8-22863892*r**10+43126788*r**12-35799496*r**14-27648481*r**16
            +25613020*r**18-8809874*r**20+4904436*r**22+63493*r**24+63588*r**26))
            -4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**17*r**2+6*Q2**16*(-503
            +1857*r**2+348*r**4)-Q2**15*(-26898+102167*r**2+795672*r**4+48371*r**6)
            +Q2**14*(-98640-56049*r**2+7994969*r**4+6700457*r**6+211055*r**8)-Q2**13*(
            -177975-1898941*r**2+27560140*r**4+63311870*r**6+22428463*r**8+399935*r**10)
            +2*Q2**12*(-57195-2309884*r**2+17136106*r**4+101613869*r**6+95944414*r**8
            +14856441*r**10+111733*r**12)+Q2**11*(-137556+373945*r**2+19063926*r**4
            -223999621*r**6-431226616*r**8-214206393*r**10+13775206*r**12+451941*r**14)
            -Q2**10*(-294096-13637297*r**2+90239625*r**4+147158379*r**6+237617085*r**8
            +126892013*r**10+149456939*r**12+90174137*r**14+864127*r**16)+Q2**9*(
            -82995-18238327*r**2+48326482*r**4+551909576*r**6+1906001960*r**8+3380058850*r**10
            +1563679558*r**12+632089712*r**14+84181011*r**16+257565*r**18)+2*Q2**8*(
            -126225-1009991*r**2+46086545*r**4-193715485*r**6-853227627*r**8-3255304445*r**10
            -3266464121*r**12-698363155*r**14-250698540*r**16+20066388*r**18+349360*r**20)
            -Q2**7*(-270930-22679187*r**2+132341324*r**4+45799181*r**6+1014675076*r**8
            -843528166*r**10-3741360624*r**12-2052704686*r**14+1341959486*r**16+200656521*r**18
            +125143764*r**20+760881*r**22)+Q2**6*(-14784-14394991*r**2+11307799*r**4
            +195247027*r**6+1774319317*r**8+7423701738*r**10+17856696358*r**12+11717789766*r**14
            +7166277802*r**16+2527824517*r**18+562002755*r**20+57687687*r**22+36929*r**24)
            +Q2**5*(-139311-6909393*r**2+94005896*r**4-225483814*r**6+422091965*r**8
            -4834215971*r**10-21741140296*r**12-43522669716*r**14-12347107893*r**16
            -8634004135*r**18-44297888*r**20-276307526*r**22+46636615*r**24+403867*r**26)
            -2*Q2**4*(-42255-5827438*r**2+34822088*r**4-116753271*r**6+605172420*r**8
            +534178775*r**10+2627004171*r**12-11002393566*r**14-17819750663*r**16
            +6074554120*r**18-930477570*r**20+950406917*r**22+35981378*r**24+28343359*r**26
            +123935*r**28)+Q2**3*(3600-2982709*r**2-596050*r**4-46349435*r**6-106353308*r**8
            +1201901155*r**10+13462806858*r**12+14229490325*r**14+3687037960*r**16
            -6454737479*r**18+18543504930*r**20+3071947751*r**22+885610500*r**24
            +125097625*r**26+10537062*r**28-6785*r**30)+Q2**2*(-23040-2142577*r**2
            +24290137*r**4-132014257*r**6+694056873*r**8-696848773*r**10-872984739*r**12
            -4977016789*r**14-35888913091*r**16+7774277309*r**18-20252527269*r**20
            +2796606109*r**22-2790985173*r**24+437225273*r**26-48682257*r**28+11649257*r**30
            +65007*r**32)+Q2*(9483+1473529*r**2-12345038*r**4+104663644*r**6-278087326*r**8
            +723773040*r**10-4072964318*r**12+4203800668*r**14-17674051888*r**16
            +59843857002*r**18-65906419354*r**20+39123878324*r**22-11142159922*r**24
            +974218744*r**26-446730426*r**28+7287956*r**30-6977035*r**32-27083*r**34)
            +2*(-654-131806*r**2+1042713*r**4-11829543*r**6+9308985*r**8-75573153*r**10
            +468182403*r**12-2736829079*r**14-10699576611*r**16+52263253755*r**18
            -64276935707*r**20+35970149187*r**22-9421707981*r**24+1788128901*r**26
            -61350615*r**28+49334139*r**30-137659*r**32+590847*r**34+1878*r**36))
            +2177280000*logq2**5*r**18*(-3-4*r**2+20*r**4-28*r**6+3*r**8)*sqrtq2
            -172800*logq2**3*r**10*(2265*Q2**12*r**2-10*Q2**11*(-8+2487*r**2+2463*r**4)
            +2*Q2**10*(60+57651*r**2+114071*r**4+57771*r**6)-10*Q2**9*(168+29587*r**2
            +86688*r**4+87891*r**6+29466*r**8)+10*Q2**8*(345+43559*r**2+170411*r**4
            +257585*r**6+177420*r**8+40572*r**10)-5*Q2**7*(639+62946*r**2+327965*r**4
            +670680*r**6+694545*r**8+365346*r**10+36639*r**12)-5*Q2**6*(-945+4277*r**2
            -25333*r**4-189343*r**6-197327*r**8-215481*r**10-98931*r**12+60795*r**14)
            +Q2**5*(-9975+232676*r**2+1416716*r**4+2721336*r**6+4815470*r**8+5443880*r**10
            +2655296*r**12+873516*r**14+546381*r**16)-5*Q2**4*(-1881+33246*r**2
            +266324*r**4+737376*r**6+1289802*r**8+1843588*r**10+1626060*r**12+612432*r**14
            +201183*r**16+58158*r**18)+5*Q2**3*(-45+2092*r**2+31513*r**4+543628*r**6
            +348974*r**8+863344*r**10+1386718*r**12+884156*r**14+44967*r**16+106140*r**18
            -15519*r**20)+(-1+r**2)**2*(-795+6057*r**2+62201*r**4-540963*r**6+687258*r**8
            +728234*r**10+339426*r**12+49434*r**14-147727*r**16+329277*r**18-14379*r**20
            +13977*r**22)+5*Q2**2*(-1141+10783*r**2+93415*r**4-524683*r**6+442474*r**8
            +314470*r**10-47806*r**12-472190*r**14-254261*r**16+360507*r**18-57129*r**20
            +34761*r**22)-5*Q2*(-759+6954*r**2+57322*r**4-424866*r**6+607083*r**8
            +102120*r**10+166800*r**12+757680*r**14-67773*r**16-263202*r**18+284310*r**20
            -32638*r**22+16569*r**24))*sqrtq2-24*logq2*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-11815-17342*r**2+20598*Q2**16*r**2-1539738*r**4-1828220*r**6
            -93296530*r**8+531809700*r**10-1202798314*r**12-12016064876*r**14+34941377640*r**16
            -16859928440*r**18-10427104030*r**20+13402061004*r**22-3848051134*r**24
            +1002915580*r**26-360030*r**28+15413020*r**30+576527*r**32+46998*r**34
            -12*Q2**15*(-1480+23619*r**2+19179*r**4)+4*Q2**14*(-32820+315810*r**2
            +775091*r**4+250170*r**6)-4*Q2**13*(-89680+561415*r**2+3441914*r**4
            +3172239*r**6+501840*r**8)+3*Q2**12*(-102835+108210*r**2+8242288*r**4
            +14188924*r**6+7455783*r**8+347210*r**10)+Q2**11*(-501830+4084716*r**2
            -5212386*r**4-3865176*r**6-7029506*r**8-4035196*r**10+3308706*r**12)
            -2*Q2**10*(-682770+1489843*r**2+22024696*r**4+119695125*r**6+221267970*r**8
            +106897065*r**10+24392896*r**12+3266703*r**14)+2*Q2**9*(-367345-3071840*r**2
            +26710386*r**4+227220060*r**6+714133400*r**8+705569180*r**10+204029050*r**12
            +35732936*r**14+1173645*r**16)+Q2**8*(-1049565+10126620*r**2-78738*r**4
            -171444948*r**6-1341551320*r**8-2311353340*r**10-1458873670*r**12-92048748*r**14
            -9710163*r**16+5670720*r**18)-4*Q2**7*(-406065+252615*r**2+7631982*r**4
            +81058936*r**6+189015752*r**8+480461830*r**10+282469470*r**12+143391072*r**14
            +131845761*r**16+16615587*r**18+1761540*r**20)+4*Q2**6*(-86460-2028669*r**2
            +1555743*r**4+74640153*r**6+482523418*r**8+2086011688*r**10+3349274064*r**12
            +1600218868*r**14+600107578*r**16+136941693*r**18+14561673*r**20+206811*r**22)
            +4*Q2**5*(-201465+1468989*r**2+1303132*r**4+13924205*r**6-125757445*r**8
            -1264814850*r**10-4711887796*r**12-4758378986*r**14-842818895*r**16-375154195*r**18
            +18838800*r**20+882517*r**22+946389*r**24)-Q2**4*(-642845-567190*r**2
            -8788364*r**4+119119700*r**6+481332275*r**8+3568163190*r**10-1523155600*r**12
            -13344747272*r**14-6577893895*r**16+5528768150*r**18+405581180*r**20
            +405698740*r**22+29345361*r**24+2648970*r**26)+2*Q2**3*(-18015-1180230*r**2
            -3200553*r**4-5407748*r**6-36754535*r**8+2081584130*r**10+4548956715*r**12
            +5193822776*r**14+943425851*r**16+2957420990*r**18+3054240885*r**20+424070540*r**22
            +85143627*r**24+6359622*r**26+15945*r**28)+2*Q2**2*(-80690+490665*r**2
            -3006468*r**4+17883911*r**6+95819042*r**8-120874895*r**10-1518601440*r**12
            -4189196169*r**14-9293444622*r**16+968976371*r**18-4244198580*r**20+292174125*r**22
            -168527138*r**24+35301811*r**26+1076312*r**28+351765*r**30)-2*Q2*(-38835
            +44444*r**2-3174082*r**4+2322168*r**6-63994442*r**8+565501168*r**10
            +36509186*r**12-748140236*r**14+1938362164*r**16-8068634516*r**18+7204485794*r**20
            -4164681904*r**22+1469846818*r**24-20195832*r**26+35804958*r**28+1423748*r**30
            +159399*r**32))*sqrtq2)*math.log(2*muWC))/(1360800000*logq2**4*r**16*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))+18900000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+13125*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5-3265920000*logq2**5*r**20*sqrtq2-226800000*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2-787500*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*sqrtq2)+((-497664000*logq2**5*(-Q2+(-1+r)**2)*r**20*(-Q2+(1
            +r)**2)*(-5250*Q2**9*r**2+10*Q2**8*(592+3825*r**2+2865*r**4)-20*Q2**7*(2368
            +7021*r**2+8483*r**4+1485*r**6)+4*Q2**6*(41440+83350*r**2+109871*r**4
            +30265*r**6-30072*r**8)+Q2**5*(-303905-550490*r**2-580454*r**4-311264*r**6
            +535383*r**8+372918*r**10)+Q2**4*(261625+585085*r**2+385330*r**4+349462*r**6
            -515975*r**8-1185679*r**10-312480*r**12)+Q2**3*(3430-426660*r**2-96230*r**4
            -183608*r**6+523242*r**8+822956*r**10+739846*r**12-220080*r**14)+(
            -1+r**2)**2*(-36395+90475*r**2+48159*r**4-406001*r**6+507541*r**8+551781*r**10
            -283319*r**12+109537*r**14+113742*r**16)+2*Q2**2*(-99295+206530*r**2
            +11435*r**4-205744*r**6+78803*r**8+86494*r**10-288091*r**12+15408*r**14
            +310380*r**16)+Q2*(149515-410240*r**2+98036*r**4+1156612*r**6-640190*r**8
            -2329192*r**10-1156412*r**12+790132*r**14+7931*r**16-448272*r**18))
            -276480*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-1519110*Q2**15*r**2
            +54*Q2**14*(-160+339535*r**2+312087*r**4)-2*Q2**13*(-219180+47514165*r**2
            +88668436*r**4+39976101*r**6)+6*Q2**12*(-539740+44594175*r**2+129460423*r**4
            +118980247*r**6+34517883*r**8)-Q2**11*(-9719385+415135010*r**2+1759741382*r**4
            +2447051088*r**6+1504604763*r**8+304079202*r**10)+Q2**10*(-11498715+258220345*r**2
            +1914729518*r**4+3479342298*r**6+3373293953*r**8+1662037793*r**10+217682208*r**12)
            +Q2**9*(-6040095+225469870*r**2+3029819*r**4+513058920*r**6+609880575*r**8
            -911543870*r**10-701854275*r**12+8098704*r**14)-Q2**8*(-32908905+553890865*r**2
            +2583465261*r**4+8502255741*r**6+14573797615*r**8+10459306535*r**10+2557915315*r**12
            +249874011*r**14+134719146*r**16)+2*Q2**7*(-15553935+173027275*r**2+1391627362*r**4
            +5442091048*r**6+11784327482*r**8+12880200950*r**10+6247680570*r**12
            +1293441952*r**14+129987273*r**16+58241727*r**18)-2*Q2**6*(2956635-47587210*r**2
            +275893853*r**4+2017263822*r**6+5309705382*r**8+10038251408*r**10+8277442200*r**12
            +2635940958*r**14+1116694307*r**16+104995062*r**18+63441423*r**20)+2*Q2**5*(16095465
            -131640455*r**2-545248413*r**4-1175225793*r**6-4760475108*r**8-1977541878*r**10
            +3099034012*r**12+3853264762*r**14+2183317307*r**16+2419187677*r**18
            +326452977*r**20+79972407*r**22)-2*Q2**4*(10234695-64616620*r**2-413254604*r**4
            -1216937140*r**6-6091863715*r**8-6870022530*r**10-1842437290*r**12+5156077438*r**14
            +4908219175*r**16+4305515550*r**18+2334151670*r**20+363013670*r**22+39439701*r**24)
            -Q2**3*(2143515-20819570*r**2+73689142*r**4+1357312032*r**6+951426305*r**8
            +9086991610*r**10+38146740*r**12-8027130384*r**14-15263656659*r**16+71451570*r**18
            -8138015850*r**20+509117680*r**22-230217033*r**24+48472902*r**26)+(
            -1+r**2)**2*(630285-2531255*r**2-5675512*r**4+288184794*r**6-1504755557*r**8
            +4112655775*r**10+1483431970*r**12-2332425476*r**14-3392661773*r**16
            +1827711319*r**18+3634959540*r**20-499195990*r**22+530218213*r**24+26539329*r**26
            +6034338*r**28)+Q2**2*(8503185-51323975*r**2-121298662*r**4+1653836922*r**6
            -7442620957*r**8+12458354015*r**10-5254530160*r**12-3016711396*r**14
            -8431147369*r**16-7696055641*r**18+16223169250*r**20-6384368790*r**22
            +3703145333*r**24+99250497*r**26+78677748*r**28)+Q2*(-3971115+23098090*r**2
            +36660063*r**4-1203630268*r**6+6756947057*r**8-16200095462*r**10+8527968395*r**12
            +732450164*r**14-11953240609*r**16+3102849806*r**18+7129852429*r**20
            -15846513460*r**22+4662184923*r**24-2339278098*r**26-81385463*r**28-36376452*r**30))
            +192*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(473754*Q2**21*r**2
            -6*Q2**20*(-32560+1323351*r**2+1332231*r**4)+12*Q2**19*(-169180+4187600*r**2
            +10870599*r**4+4590000*r**6)-4*Q2**18*(-2167220+39623669*r**2+197287232*r**4
            +206581918*r**6+51133935*r**8)+Q2**17*(-17728755+248209788*r**2+2280022542*r**4
            +3784677004*r**6+2641663509*r**8+430479180*r**10)-Q2**16*(-9078135+104688879*r**2
            +2803315780*r**4+2951251666*r**6+4427001157*r**8+4138954179*r**10+422430066*r**12)
            -4*Q2**15*(-9303415+45170005*r**2+280248182*r**4+7252205081*r**6+13974987689*r**8
            +5360373469*r**10-169941472*r**12+49560249*r**14)+6*Q2**14*(-14042270
            -171885*r**2+1244242816*r**4+17473037367*r**6+52115833696*r**8+49286970897*r**10
            +15211696660*r**12+1546250901*r**14+180671850*r**16)-12*Q2**13*(-3818980
            -55051039*r**2+619763538*r**4+11200812771*r**6+53490646914*r**8+79703906553*r**10
            +51607647246*r**12+11743438893*r**14+1340480442*r**16+88833390*r**18)
            +Q2**12*(79548040-470772874*r**2+1758737204*r**4-7058920900*r**6+372240860300*r**8
            +743003199104*r**10+856288181876*r**12+503189795012*r**14+61015565708*r**16
            +8219420938*r**18-264855240*r**20)+4*Q2**11*(-36810345-267557043*r**2
            -938838060*r**4+53884735925*r**6+188395533258*r**8+573008732196*r**10
            +803682803876*r**12+349982874000*r**14+61869034071*r**16+26549221199*r**18
            +2025294528*r**20+364869531*r**22)-2*Q2**10*(-27228630-936834093*r**2
            -5354171240*r**4+100573568773*r**6+744287552734*r**8+2852957414782*r**10
            +6064784594092*r**12+5368043417146*r**14+1896580874674*r**16+402780274879*r**18
            +82421762956*r**20+7267216209*r**22+507042198*r**24)+2*Q2**9*(44171985
            -168759240*r**2-1020998278*r**4-22353802602*r**6+357702667279*r**8+1682689190998*r**10
            +6519663755020*r**12+9317191089988*r**14+5832338402263*r**16+1295798459244*r**18
            +264680931818*r**20+33781269990*r**22+3526104537*r**24-194381850*r**26)
            +2*Q2**8*(-56046705-795881454*r**2-8808828552*r**4+92327199310*r**6+238757685063*r**8
            +1745906733996*r**10+971720023924*r**12-1469918810028*r**14-3213025865859*r**16
            -1625474322662*r**18+292541211936*r**20-32995688274*r**22+10463871133*r**24
            +855993912*r**26+483741540*r**28)-4*Q2**7*(-6276765-359803221*r**2-4678326454*r**4
            +18394895303*r**6+156843125093*r**8+1451575445417*r**10+3586081564016*r**12
            +5613443140853*r**14+5425364233709*r**16+1814105362949*r**18+449924546882*r**20
            +338275776809*r**22-3737174005*r**24+5733140807*r**26+993163332*r**28
            +99763515*r**30)+2*Q2**6*(21159490+19859795*r**2+316974160*r**4-34202671301*r**6
            +106581607036*r**8+788949434167*r**10+4567434668596*r**12+9292822363375*r**14
            +15171766315516*r**16+10690187135257*r**18+2326928656024*r**20+206846792497*r**22
            +305621765500*r**24+3908424925*r**26+8675258852*r**28+1377484069*r**30
            -115279158*r**32)+2*Q2**5*(-18557220-370391319*r**2-6303119916*r**4+36286732482*r**6
            -65085857148*r**8+1051615289478*r**10+22786303060*r**12+1086186663330*r**14
            -202476099396*r**16-6712819901744*r**18-2647448544804*r**20-2307607307754*r**22
            -738527534516*r**24-475020843126*r**26-99548438148*r**28-15429561594*r**30
            -674117352*r**32+142543287*r**34)+2*Q2**4*(3404280+197761170*r**2+3659278611*r**4
            -5583965874*r**6+72545327058*r**8-863360991814*r**10-624091897810*r**12
            -2813848494586*r**14-9866121557662*r**16+312818017574*r**18+3485197629788*r**20
            +1368906479210*r**22+4640173934534*r**24+1818406307486*r**26+550367956818*r**28
            +106828346946*r**30+10950044430*r**32+43090416*r**34-34030575*r**36)
            -4*Q2**3*(-1594505-4823779*r**2-179964247*r**4+4266080549*r**6-4819501108*r**8
            -12293099786*r**10-85922389196*r**12-151211481758*r**14-2427409570766*r**16
            +974717373016*r**18+1723716760462*r**20+85120415044*r**22+2188865822812*r**24
            +336379241530*r**26+600569244452*r**28+26098089854*r**30+9841814831*r**32
            -578037157*r**34-156875663*r**36+11135415*r**38)+(-1+r**2)**2*(-129965
            -4909727*r**2-144593773*r**4+84287587*r**6-12232727558*r**8+43407211656*r**10
            -228322355824*r**12-947143232176*r**14+7582410233734*r**16-22375953676286*r**18
            +16513989132862*r**20+10870970132254*r**22-17817244249804*r**24+6610944060896*r**26
            -1951843574904*r**28-5173416632*r**30-78641325953*r**32-7045324747*r**34
            -821770217*r**36-22692377*r**38+1080954*r**40)+2*Q2**2*(-2299110-47232399*r**2
            -1192681656*r**4+5894004929*r**6-59290121856*r**8+283828084692*r**10
            -569064046116*r**12-758252431500*r**14+5130217215000*r**16-6113792246210*r**18
            +2585401411356*r**20+9759564837054*r**22-15126663765932*r**24+11315075413188*r**26
            -4431679528812*r**28+389042937252*r**30-274113628914*r**32-26286121287*r**34
            -5141089492*r**36-264260247*r**38+18030060*r**40)+Q2*(1244265+36049332*r**2
            +971451950*r**4-3274369432*r**6+68052474653*r**8-333331331064*r**10+1137422634600*r**12
            +1952464729680*r**14-20055660056654*r**16+48430262809576*r**18-34940335198988*r**20
            +21053867946208*r**22-51322609354910*r**24+60321475668304*r**26-26638675826136*r**28
            +7550523826608*r**30-391708541019*r**32+344727275780*r**34+31864392782*r**36
            +4900815032*r**38+184852929*r**40-10133496*r**42))+209018880000*logq2**6*(
            -Q2+(-1+r)**2)*r**24*(39+4*r**2+220*r**4-644*r**6+105*r**8)*(-Q2+(1
            +r)**2)*sqrtq2-16588800*logq2**4*r**16*(-160860*Q2**14*r**2+240*Q2**13*(118
            +8140*r**2+7297*r**4)-6*Q2**12*(60460+1790118*r**2+2997169*r**4+1367630*r**6)
            +2*Q2**11*(952520+17541703*r**2+40307662*r**4+34754759*r**6+10674180*r**8)
            -Q2**10*(5317655+73525938*r**2+204066413*r**4+245290870*r**6+144621194*r**8
            +33333210*r**10)+10*Q2**9*(814885+9778191*r**2+30542454*r**4+45195854*r**6
            +37958739*r**8+17417983*r**10+3333510*r**12)-5*Q2**8*(1034253+14588655*r**2
            +46876664*r**4+80996126*r**6+89735657*r**8+65115543*r**10+26626926*r**12
            +6097716*r**14)+Q2**7*(-3824280+12584901*r**2-14816632*r**4+7447125*r**6
            +105981260*r**8+244312455*r**10+235745916*r**12+105575223*r**14+44270640*r**16)
            +Q2**6*(10234170+26856783*r**2+224255207*r**4+354550439*r**6+304133385*r**8
            +3237945*r**10-326634767*r**12-299833623*r**14-127262931*r**16-59324040*r**18)
            +Q2**5*(-7480740-26718819*r**2-211228024*r**4-336653030*r**6-313294332*r**8
            -53532660*r**10+336988696*r**12+494575646*r**14+278878200*r**16+118641663*r**18
            +37547400*r**20)+(-1+r**2)**4*(-92605+741362*r**2-7713035*r**4+25483618*r**6
            -6724034*r**8-752006*r**10+17683138*r**12-5178230*r**14+4006567*r**16
            +23286044*r**18-100879*r**20+1524060*r**22)+5*Q2**4*(67230+3909945*r**2
            +7351207*r**4+35508562*r**6+20136976*r**8-14151880*r**10-63433330*r**12
            -71484670*r**14-50168598*r**16+5314767*r**18-13910781*r**20+2472252*r**22)
            -5*Q2**3*(-642264+4069035*r**2-22075348*r**4+45871849*r**6-6103092*r**8
            -30917314*r**10-6164396*r**12+7873626*r**14-20064556*r**16-6868745*r**18
            +64668096*r**20-9872931*r**22+8046840*r**24)-Q2*(-1+r**2)**2*(-744290
            +5276459*r**2-48425836*r**4+133949001*r**6-28554672*r**8-58651230*r**10
            +146997504*r**12+151431606*r**14-31733586*r**16+7873187*r**18+135918460*r**20
            -6725423*r**22+10700820*r**24)+Q2**2*(-2358835+16277707*r**2-125190654*r**4
            +338403905*r**6-221801465*r**8-89819000*r**10+165132076*r**12+388221238*r**14
            +308935555*r**16-50939185*r**18-204538590*r**20+330590617*r**22-48598759*r**24
            +30309390*r**26))*sqrtq2+2304*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(6601656*Q2**18*r**2-32*Q2**17*(-58570+2878704*r**2+2726169*r**4)
            +8*Q2**16*(-2496650+65534071*r**2+138148685*r**4+61371531*r**6)-8*Q2**15*(
            -10898620+194498687*r**2+705290224*r**4+681608879*r**6+189514782*r**8)
            +Q2**14*(-186167775+2392461680*r**2+14506471040*r**4+21781530036*r**6
            +14030268555*r**8+2677996260*r**10)-2*Q2**13*(-66809925+512355819*r**2
            +8499488740*r**4+14520537192*r**6+15392596137*r**8+9246676425*r**10+1127231604*r**12)
            -Q2**12*(-254687055+2558490086*r**2+3366073481*r**4+48756848984*r**6
            +84879247619*r**8+26259292914*r**10-5991825669*r**12+664856616*r**14)
            +4*Q2**11*(-169777475+1010411444*r**2+8894679075*r**4+56313353338*r**6
            +133186733775*r**8+118130641820*r**10+37576957813*r**12+4291452030*r**14
            +915254004*r**16)-Q2**10*(-466248145+417619832*r**2+39197902094*r**4
            +287685904988*r**6+984068784824*r**8+1338626402660*r**10+826212100154*r**12
            +195323498708*r**14+25312810129*r**16+3373209972*r**18)+2*Q2**9*(188496275
            -1903906055*r**2+3514745810*r**4+18870116714*r**6+279696780800*r**8+594061553480*r**10
            +613118870810*r**12+293449627390*r**14+35506700389*r**16+6415339895*r**18
            +227791740*r**20)+Q2**8*(-866624825+2816303058*r**2+16501601285*r**4
            +282995841868*r**6+642333491718*r**8+1000135777560*r**10+848887592242*r**12
            +97794069620*r**14-14403151437*r**16+60414508198*r**18-1825161975*r**20
            +1476230448*r**22)-8*Q2**7*(-52997615-158397407*r**2+1346187733*r**4
            +34353916429*r**6+145893843604*r**8+339287386904*r**10+500701818922*r**12
            +342545502352*r**14+91053310129*r**16+18429632479*r**18+7530006649*r**20
            -10226437*r**22+152290818*r**24)+Q2**6*(275291275-2664658256*r**2+3734983660*r**4
            +14466205852*r**6+504766430915*r**8+1503912907580*r**10+3127543698224*r**12
            +3760347674600*r**14+1636733665969*r**16+398621427640*r**18+59162357380*r**20
            +39957314492*r**22+4412691745*r**24+436253724*r**26)-2*Q2**5*(213746085
            -474236951*r**2+3821308368*r**4-63232091036*r**6-96551066083*r**8-176667916575*r**10
            -464402315996*r**12+430366861008*r**14+709061892143*r**16+236637960619*r**18
            +394222601520*r**20+95912191852*r**22+36374405679*r**24+5035460523*r**26
            +67531644*r**28)+Q2**4*(148852725+534290430*r**2+6323104465*r**4-69485766464*r**6
            -239955112055*r**8-439077921170*r**10-2350110863555*r**12-1302337745720*r**14
            +697130193103*r**16+1041496313050*r**18+953971984435*r**20+1119604800000*r**22
            +281887111155*r**24+62015928186*r**26+6830918655*r**28-1047240*r**30)
            +4*Q2**3*(14874525-144602644*r**2+404936455*r**4-2372162746*r**6+17459353289*r**8
            +22852658560*r**10+154072887439*r**12+204953875930*r**14-150525351053*r**16
            -430318185908*r**18+20159084765*r**20-342502373046*r**22-28564304485*r**24
            -32000165176*r**26+972832269*r**28+137366550*r**30+32235276*r**32)-(
            -1+r**2)**2*(2917435+6881944*r**2+391973706*r**4-878907480*r**6+2209911570*r**8
            +106766904960*r**10-530587968502*r**12+1300733033672*r**14-23735265840*r**16
            -1382666353840*r**18+59072137550*r**20+1019093511672*r**22-334099087362*r**24
            +147487624320*r**26+7644978270*r**28+3886166680*r**30+245260261*r**32
            +7080984*r**34)-Q2**2*(69395965-189080608*r**2+4589682622*r**4-24271007916*r**6
            +17912407574*r**8+321733821004*r**10-1380551209522*r**12+2035831420788*r**14
            -1238935538568*r**16-335837196148*r**18-2138177059478*r**20+3118480723868*r**22
            -1847396010342*r**24+801452964484*r**26+1694616074*r**28+34546697884*r**30
            +2952615387*r**32+124756932*r**34)+2*Q2*(11723725-9725669*r**2+1138068530*r**4
            -5188455726*r**6+7208539230*r**8+173919618570*r**10-921798768418*r**12
            +1996616576930*r**14-1162495194992*r**16+426296302040*r**18-22911118990*r**20
            -1272546533882*r**22+2092523965650*r**24-874749980538*r**26+297781652730*r**28
            +5104200070*r**30+9520303219*r**32+716144765*r**34+24282756*r**36))*sqrtq2
            +32*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(7238*Q2**22*r**2+6*Q2**21*(503
            +16808*r**2+10965*r**4)-Q2**20*(35952+1667181*r**2+19691234*r**4+1697301*r**6)
            +2*Q2**19*(92685+1899311*r**2+129348565*r**4+131852077*r**6+5984962*r**8)
            -Q2**18*(521655-21766716*r**2+1342416798*r**4+3189643792*r**6+1492563291*r**8
            +44439096*r**10)+Q2**17*(782745-123213352*r**2+3389059837*r**4+14943310572*r**6
            +15794207611*r**8+4452002060*r**10+97272207*r**12)-2*Q2**16*(140286-85493571*r**2
            +1731027282*r**4+15745628824*r**6+27035198192*r**8+18996263759*r**10
            +3371201140*r**12+59239548*r**14)+2*Q2**15*(-578376+138817501*r**2-1237682982*r**4
            +7470117395*r**6+9812831768*r**8+19382363199*r**10+17603803210*r**12
            +784263033*r**14+19784484*r**16)+2*Q2**14*(1050870-626697213*r**2+4843894975*r**4
            +32066613801*r**6+155644906815*r**8+260380999423*r**10+117250626297*r**12
            +18626830455*r**14+6273806179*r**16+49522014*r**18)-2*Q2**13*(415380
            -723687921*r**2+2767242508*r**4+64781385700*r**6+383991384616*r**8+1029633397990*r**10
            +978306154576*r**12+335090677180*r**14+66547442932*r**16+10325386411*r**18
            +63939956*r**20)+Q2**12*(-1748760+376537668*r**2-7715915586*r**4+69533939218*r**6
            +478776987336*r**8+2611612199592*r**10+3991688065420*r**12+2674450639740*r**14
            +593923951056*r**16+123781337092*r**18+6413881110*r**20-25134174*r**22)
            +2*Q2**11*(1259154-1300841737*r**2+4204893536*r**4+26392978719*r**6+378771553548*r**8
            +381887763874*r**10+440720932608*r**12-42853141710*r**14-228499706798*r**16
            +116746475895*r**18+1594523728*r**20+9038078751*r**22+87501024*r**24)
            -2*Q2**10*(242541-1054595685*r**2-3884094473*r**4+38354871585*r**6+691703935174*r**8
            +2652711568466*r**10+6598292493434*r**12+8979419541038*r**14+4538869885949*r**16
            +1332365134763*r**18+406221332959*r**20+49494773297*r**22+11115067392*r**24
            +60609224*r**26)+2*Q2**9*(-844545+407554493*r**2-7533983445*r**4+13196452542*r**6
            +163041361959*r**8+2253581530779*r**10+7146321630587*r**12+16792889396820*r**14
            +15310873055325*r**16+5063943097187*r**18+1326030773809*r**20+214067547918*r**22
            +44282964445*r**24+1071396261*r**26-26346039*r**28)+2*Q2**8*(811680-1226525791*r**2
            +789015013*r**4-12113274912*r**6+455736739626*r**8+228851976319*r**10
            +2084610772215*r**12-5903028211554*r**14-11699263186676*r**16-8235487076721*r**18
            -218510185053*r**20-318471521852*r**22+63077782602*r**24-22731005423*r**26
            +7030421921*r**28+60871806*r**30)-2*Q2**7*(85920-608511759*r**2-5600277918*r**4
            -18208143349*r**6+342997669400*r**8+1353592966517*r**10+8480679828398*r**12
            +11330563770599*r**14+12500071952324*r**16+5490028644563*r**18+344278588382*r**20
            +2344182454145*r**22+6656096048*r**24+58627869319*r**26-5911681454*r**28
            +4994235725*r**30+24081300*r**32)-2*Q2**6*(328986-298291190*r**2+3809792931*r**4
            -3925301959*r**6+115482190635*r**8-833181152259*r**10-3608946702341*r**12
            -11092796997327*r**14-18347138719473*r**16-21027167252639*r**18-7098578938767*r**20
            +139941038403*r**22-978080642423*r**24+4505484527*r**26+19332057969*r**28
            -14117191085*r**30+612304803*r**32+15069609*r**34)+2*Q2**5*(230739-465552261*r**2
            -673144807*r**4-23661552888*r**6+227512227524*r**8-446132368880*r**10
            +3132222565812*r**12-3407468340768*r**14+1828343344690*r**16-7517142199866*r**18
            -8191792796994*r**20-2893148984792*r**22-356202263868*r**24-807616240040*r**26
            -312080677948*r**28-15708971280*r**30-23874887949*r**32+2329116503*r**34
            +17815473*r**36)+Q2**4*(-50520+304911193*r**2+3562394060*r**4+27045198035*r**6
            -102266379072*r**8+486235698396*r**10-6382209849688*r**12+4599712788140*r**14
            -22050706564864*r**16-17649340908250*r**18+10650603415408*r**20+1187620864922*r**22
            +12029312811680*r**24+6365902208188*r**26+3004132120696*r**28+785063848316*r**30
            +99372019448*r**32+23497811945*r**34-1812680284*r**36-8153749*r**38)
            -2*Q2**3*(44535-54713262*r**2+643671981*r**4-3314730508*r**6+56263561102*r**8
            -140839972644*r**10-9693774676*r**12+464838731196*r**14-3224331010710*r**16
            -6200499601712*r**18+8910360963390*r**20-692684488092*r**22+4273829618200*r**24
            +879529882244*r**26+2633988693708*r**28+499528112692*r**30+73391090055*r**32
            +22708822398*r**34-3530417251*r**36+218778552*r**38+2834802*r**40)+2*(
            -1+r**2)**2*(654-2154464*r**2-20324149*r**4-385947418*r**6+32999395*r**8
            -20906457570*r**10+78855263292*r**12-465328084468*r**14-504469324856*r**16
            +9992995195060*r**18-38042350073414*r**20+57597116766088*r**22-40479089524742*r**24
            +14316229836416*r**26-3561638685780*r**28+335537150772*r**30-130188799646*r**32
            -16026622516*r**34-1407057517*r**36-358789550*r**38+10648683*r**40+65730*r**42)
            +Q2**2*(54105-119413822*r**2-132855212*r**4-12806924238*r**6+81608501503*r**8
            -564333426568*r**10+2528252421624*r**12-6367612946432*r**14+5711124387986*r**16
            +4761544662708*r**18-3839084963424*r**20+24682005117972*r**22-54651208487850*r**24
            +52057336812992*r**26-21315514772600*r**28+3802784105232*r**30-1209669304603*r**32
            -239024936006*r**34-4720186740*r**36-12646598486*r**38+577800155*r**40
            +4471704*r**42)+Q2*(-13407+37386854*r**2+181431189*r**4+5071771792*r**6
            -20093228417*r**8+270716387402*r**10-1372672525613*r**12+5497787987712*r**14
            -5000979833286*r**16-26707875154084*r**18+76650451970466*r**20+725030068000*r**22
            -162405028799090*r**24+182625454146996*r**26-85057172900906*r**28+24226640359040*r**30
            -3358475202027*r**32+968629439838*r**34+150835810873*r**36+7577486032*r**38
            +5219818499*r**40-183805214*r**42-1242649*r**44))*sqrtq2)*math.log(r))/(2116316160000*logq2**5*(
            -Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +48988800000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+102060000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-4232632320000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-440899200000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-3061800000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -1417500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**6*sqrtq2))+muWC**3*((pi2*(10368000*logq2**4*r**12*(105*Q2**9*(1+5*r**4)
            -5*Q2**8*(249+361*r**2+1101*r**4+1005*r**6)+10*Q2**7*(597+1621*r**2
            +3496*r**4+4343*r**6+2025*r**8)-2*Q2**6*(7812+29149*r**2+64765*r**4
            +93125*r**6+69133*r**8+22260*r**10)+Q2**5*(22974+106027*r**2+250778*r**4
            +470915*r**6+412871*r**8+222906*r**10+55545*r**12)-Q2**4*(15540+92822*r**2
            +231869*r**4+588590*r**6+701120*r**8+419048*r**10+170935*r**12+31500*r**14)
            +2*Q2**3*(-1575+11024*r**2+40642*r**4+140278*r**6+184250*r**8+213791*r**10
            +81491*r**12+6005*r**14-5250*r**16)+(-1+r**2)**2*(1821+1633*r**2+608*r**4
            +116088*r**6-193788*r**8-187194*r**10+70224*r**12-1996*r**14+12199*r**16
            +4005*r**18)+Q2**2*(13020+15118*r**2-11915*r**4+119156*r**6-143159*r**8
            -108758*r**10-29109*r**12-13188*r**14+70635*r**16+29400*r**18)+Q2*(
            -8331-4469*r**2+12109*r**4-306011*r**6+264845*r**8+760417*r**10+146475*r**12
            -137073*r**14+34282*r**16-38464*r**18-18180*r**20))+2880*logq2**2*(-Q2
            +(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(9795*Q2**15*(1+5*r**4)-Q2**14*(120261
            +121493*r**2+521937*r**4+598665*r**6)+Q2**13*(604329+1271816*r**2+3448100*r**4
            +5662978*r**6+3101085*r**8)-Q2**12*(1583961+5382217*r**2+14984690*r**4
            +28081086*r**6+25269377*r**8+8589165*r**10)+Q2**11*(2105649+11648083*r**2
            +36582862*r**4+85246604*r**6+92230079*r**8+57617593*r**10+12508410*r**12)
            -Q2**10*(491931+12207009*r**2+35377311*r**4+134400931*r**6+171469901*r**8
            +105720395*r**10+60971217*r**12+4741065*r**14)-Q2**9*(2776653-630711*r**2
            +40542531*r**4-18250145*r**6-76727145*r**8+99740803*r**10+137775089*r**12
            +9194301*r**14+14803920*r**16)+Q2**8*(4096917+13919013*r**2+148377380*r**4
            +308632144*r**6+276891690*r**8+613334922*r**10+965758108*r**12+553194480*r**14
            +104109969*r**16+25872705*r**18)-Q2**7*(1474803+15840426*r**2+133162825*r**4
            +526474548*r**6+441833406*r**8+535880328*r**10+1378107826*r**12+1544646700*r**14
            +552418143*r**16+112180446*r**18+12267045*r**20)-Q2**6*(1984323-5804169*r**2
            +37730299*r**4-375497397*r**6+59872778*r**8+1109296634*r**10+899482146*r**12
            -562848086*r**14-848754237*r**16+108366543*r**18-25743789*r**20+10701195*r**22)
            +Q2**5*(2538327+2759198*r**2+163842602*r**4-105799688*r**6+754730047*r**8
            +3936007492*r**10+6253024212*r**12+5020022232*r**14+1457563277*r**16
            +277470622*r**18+679323650*r**20+45080784*r**22+17078205*r**24)-Q2**4*(816711
            +4176143*r**2+106088382*r**4+37433530*r**6+675121145*r**8+5072470653*r**10
            +10494698764*r**12+12060215356*r**14+7391704305*r**16+1851552905*r**18
            +608344086*r**20+492090218*r**22+42539887*r**24+6699915*r**26)+Q2**3*(
            -449121+2478871*r**2-15046580*r**4+146543328*r**6-217727825*r**8+2390168207*r**10
            +6033710428*r**12+8865032760*r**14+8622117469*r**16+3173450165*r**18
            -114834436*r**20+529359176*r**22-28759755*r**24+12234053*r**26-2577540*r**28)
            +(-1+r**2)**2*(22059-8871*r**2+4419683*r**4-20995819*r**6+139149983*r**8
            +108523417*r**10-822294713*r**12+958091149*r**14-873751727*r**16-1787782061*r**18
            +714996889*r**20+332955959*r**22-45911707*r**24+21722171*r**26+603453*r**28
            +180135*r**30)+Q2**2*(491139-1071907*r**2+52895515*r**4-206636041*r**6
            +887443983*r**8+331547957*r**10-575705201*r**12+1159538095*r**14-467647463*r**16
            -3196260881*r**18+1744035569*r**20+1843553133*r**22-528696235*r**24+221511679*r**26
            +1577573*r**28+3503085*r**30)-Q2*(170451-340323*r**2+26200363*r**4
            -129435949*r**6+685390901*r**8+206205825*r**10-1660142489*r**12+533888479*r**14
            -2084679017*r**16-716426537*r**18-4677079583*r**20+1411398297*r**22+1553436983*r**24
            -348894709*r**26+117080461*r**28+1592757*r**30+1314090*r**32))+4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(552*Q2**20+Q2**19*(1230-86*r**2)+8*Q2**18*(993
            +5225*r**2+2309*r**4)-Q2**17*(793689+350881*r**2+3840383*r**4+361615*r**6)
            +Q2**16*(6432021+485746*r**2+21116616*r**4+38837094*r**6+2083563*r**8)
            -2*Q2**15*(11471247-3133150*r**2-25946401*r**4+101248489*r**6+84688408*r**8
            +2973871*r**10)+Q2**14*(40359885-25706302*r**2-675511331*r**4-240427744*r**6
            +819403091*r**8+369434110*r**10+8820563*r**12)-2*Q2**13*(9542901+2669295*r**2
            -1085865336*r**4-1900280100*r**6-466447889*r**8+803851653*r**10+146175660*r**12
            +1926168*r**14)-Q2**12*(59715123-229084978*r**2+3370785104*r**4+12061520622*r**6
            +13661765622*r**8+4700526258*r**10-1023582864*r**12+443437586*r**14+8895575*r**16)
            +2*Q2**11*(59958951-268593854*r**2+1107903779*r**4+11402737423*r**6+22250625111*r**8
            +21253490637*r**10+7314514917*r**12+1008667129*r**14+657468074*r**16
            +7744633*r**18)-Q2**10*(58479135-343542210*r**2-1563244539*r**4+28898194668*r**6
            +83780882714*r**8+119396855352*r**10+86936703870*r**12+20253826772*r**14
            +5147480295*r**16+1012294602*r**18+4642781*r**20)-2*Q2**9*(40320930-289047506*r**2
            +3077122489*r**4-7457575429*r**6-38957895394*r**8-82778419030*r**10-77053270204*r**12
            -39150651796*r**14+935601416*r**16-2231515984*r**18+284894555*r**20+6165809*r**22)
            +Q2**8*(131865747-1224415370*r**2+8366116250*r**4+22850768770*r**6+14448039489*r**8
            -64268195484*r**10-79801386780*r**12+13590947148*r**14+34024103325*r**16
            +42359779974*r**18-138163070*r**20+1608087890*r**22+15087631*r**24)-2*Q2**7*(23013981
            -298988206*r**2+2129722329*r**4+24289171323*r**6+44661674978*r**8+47234796729*r**10
            +36834968682*r**12+99832766070*r**14+112780665993*r**16+70234457628*r**18
            +22785681581*r**20+1785794655*r**22+443650152*r**24+1609065*r**26)+Q2**6*(
            -50293017+573373078*r**2-4626548429*r**4+31899242456*r**6+36006884167*r**8
            +122998331518*r**10-10829320837*r**12+138039439968*r**14+312641956557*r**16
            +104398998674*r**18+120087044929*r**20-4550430776*r**22+3888809861*r**24
            -428397478*r**26-6511471*r**28)+2*Q2**5*(29194197-444109285*r**2+4525970488*r**4
            -275635120*r**6+18388466093*r**8-60188517893*r**10+167931853520*r**12
            +190859318848*r**14+102048773903*r**16-113442017999*r**18+106822746176*r**20
            -18953374040*r**22+21874725359*r**24-911000263*r**26+391781176*r**28
            +2932040*r**30)-Q2**4*(16040505-330507126*r**2+4716323316*r**4+11233089714*r**6
            +15112005104*r**8-109573193430*r**10+588173222796*r**12+1020409892898*r**14
            +1022875599762*r**16+793357092462*r**18-158390301780*r**20+246316285446*r**22
            +12506888136*r**24+28602910174*r**26+237801684*r**28+303592230*r**30
            +1130109*r**32)+2*Q2**3*(-4614882+74166205*r**2-641187947*r**4+4894880565*r**6
            -13870779821*r**8+15069143875*r**10+131583868765*r**12+374509317573*r**14
            +620236955535*r**16+357597187597*r**18+244037521191*r**20+44917866615*r**22
            -6716860655*r**24+18960340425*r**26-1947071001*r**28+487848591*r**30
            -44487185*r**32-543446*r**34)+2*(-1+r**2)**2*(156654-4170412*r**2+84909051*r**4
            -230578818*r**6+358432710*r**8-5882078502*r**10+74768865726*r**12-231116744978*r**14
            +245764096194*r**16+10125137730*r**18-301537274708*r**20+192462278634*r**22
            -40827260622*r**24+11311878366*r**26-1463840190*r**28+470139306*r**30
            -9537448*r**32+2698674*r**34+12633*r**36)+Q2**2*(8644899-184657634*r**2
            +2643449645*r**4-7304295692*r**6+26751377328*r**8-128117752164*r**10
            +487154478120*r**12-363509890492*r**14+372778090654*r**16-540957326056*r**18
            -236996217094*r**20+896363366812*r**22-445606313176*r**24+180868302468*r**26
            -43091242272*r**28+13124189484*r**30-673003673*r**32+121417898*r**34
            +820945*r**36)-Q2*(2682531-67137509*r**2+1183056495*r**4-3779339229*r**6
            +10174715552*r**8-75459588888*r**10+590033884272*r**12-1177510543480*r**14
            +327748803822*r**16+838933914054*r**18-299472890442*r**20-1671324890442*r**22
            +1404998019000*r**24-419673325232*r**26+125884294536*r**28-23421714576*r**30
            +6145926679*r**32-221450265*r**34+42311139*r**36+231983*r**38))+2177280000*logq2**5*r**16*(9
            +33*r**2+124*r**4-512*r**6+163*r**8+15*r**10)*sqrtq2+172800*logq2**3*r**8*(2265*Q2**12*(1
            +5*r**4)-10*Q2**11*(2439+2383*r**2+10431*r**4+12315*r**6)+2*Q2**10*(57951
            +108258*r**2+244605*r**4+469607*r**6+288855*r**8)-10*Q2**9*(29970+83928*r**2
            +146473*r**4+295842*r**6+354501*r**8+147330*r**10)+10*Q2**8*(41607+170403*r**2
            +278381*r**4+438443*r**6+778226*r**8+693972*r**10+202860*r**12)-5*Q2**7*(38556
            +357489*r**2+504564*r**4+81617*r**6+473328*r**8+1688379*r**10+1329480*r**12
            +183195*r**14)-5*Q2**6*(57960-124467*r**2+295925*r**4+2741021*r**6+5136449*r**8
            +4066963*r**10+490035*r**12-165669*r**14+303975*r**16)+Q2**5*(516456
            +573363*r**2+6551210*r**4+31603502*r**6+74308470*r**8+90473156*r**10
            +56145758*r**12+15840170*r**14+4559562*r**16+2731905*r**18)-5*Q2**4*(52515
            +155709*r**2+1212342*r**4+6057464*r**6+18583638*r**8+30158754*r**10
            +25695316*r**12+11271144*r**14+2845431*r**16+897153*r**18+290790*r**20)
            -5*Q2**3*(15654-103659*r**2+43130*r**4-1514209*r**6-9251464*r**8-16383518*r**10
            -20394136*r**12-15196618*r**14-1758062*r**16+32217*r**18-420306*r**20
            +77595*r**22)+(-1+r**2)**2*(11592-18345*r**2+695733*r**4-81745*r**6
            +3122037*r**8-1180470*r**10-14149954*r**12-15771798*r**14+390*r**16
            +4605983*r**18+1554573*r**20-25881*r**22+69885*r**24)+5*Q2**2*(31338
            -69451*r**2+887491*r**4+908653*r**6-272311*r**8+1288894*r**10-641462*r**12
            -3234082*r**14-4073984*r**16+4774573*r**18+1844691*r**20-206955*r**22
            +173805*r**24)-5*Q2*(14292-36669*r**2+633636*r**4+13564*r**6+1113684*r**8
            +2288967*r**10-11520768*r**12-8298456*r**14-2304012*r**16-3015687*r**18
            +2866908*r**20+1350204*r**22-122908*r**24+82845*r**26))*sqrtq2+24*logq2*(
            -250*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(111+105*Q2**7-4517*r**2-91999*r**4
            -164085*r**6+1160315*r**8+1928089*r**10+482547*r**12+59769*r**14+1530*r**16
            -5*Q2**6*(-81+31*r**2+240*r**4)+15*Q2**5*(-29-16*r**2+59*r**4+60*r**6)
            -Q2**4*(-321+243*r**2+50107*r**4+69411*r**6+9180*r**8)+Q2**3*(-729
            -1592*r**2+81550*r**4+220582*r**6+137739*r**8+14130*r**10)+Q2**2*(-309
            -1389*r**2-6978*r**4-105212*r**6-125831*r**8-9611*r**10+3210*r**12)
            +Q2*(531-5304*r**2-92255*r**4+33430*r**6+433925*r**8+246424*r**10
            -45401*r**12-9390*r**14))+21*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(12*Q2**10*(16+205*r**4)
            -60*Q2**9*(12+12*r**2+211*r**4+275*r**6)+5*Q2**8*(135+270*r**2+4314*r**4
            +11146*r**6+7335*r**8)-60*Q2**7*(-8+24*r**2+157*r**4+1047*r**6+1313*r**8
            +335*r**10)-30*Q2**6*(30-60*r**2+1447*r**4-433*r**6-2349*r**8-1871*r**10
            +1260*r**12)-60*Q2**3*r**4*(911-1449*r**2-3631*r**4-8165*r**6-7971*r**8
            -5223*r**10-2237*r**12+405*r**14)+4*Q2**5*(-36+540*r**2+28785*r**4
            +42905*r**6+47430*r**8+26514*r**10-8755*r**12+13545*r**14)-30*Q2**4*(
            -19+186*r**2+2071*r**4+5553*r**6+13432*r**8+25138*r**10+17181*r**12
            +1723*r**14+175*r**16)+120*Q2*r**4*(116-1379*r**2-13454*r**4-26131*r**6
            -17070*r**8+5559*r**10+4294*r**12-3241*r**14-574*r**16+40*r**18)-3*(
            -1+r**2)**2*(-9+252*r**2+1793*r**4-41806*r**6-222100*r**8-331426*r**10
            +64268*r**12+55502*r**14-35299*r**16-10330*r**18+755*r**20)+10*Q2**2*(
            -18+324*r**2+3303*r**4-12811*r**6+4917*r**8-22143*r**10-69061*r**12
            +4839*r**14+41457*r**16-3457*r**18+810*r**20))-5*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(30*Q2**15*(1408+21355*r**4)-2*Q2**14*(96000+94432*r**2+1841499*r**4
            +2340195*r**6)+2*Q2**13*(104790+289648*r**2+3915889*r**4+9514666*r**6
            +5723805*r**8)-2*Q2**12*(-133320+288212*r**2+3327327*r**4+13894203*r**6
            +15357559*r**8+3207495*r**10)-Q2**11*(609120+109589*r**2+10179979*r**4
            -5890972*r**6+7743536*r**8-6924137*r**10+16303365*r**12)+Q2**10*(-40920
            +1633551*r**2+30535728*r**4+65571913*r**6+235481588*r**8+272338493*r**10
            +42702732*r**12+22088835*r**14)+Q2**9*(641100-1712547*r**2+31855101*r**4
            +21155575*r**6-292239145*r**8-760113305*r**10-578560777*r**12-81091979*r**14
            +9040905*r**16)-Q2**8*(42360+3220167*r**2+163398546*r**4+343826564*r**6
            +457158230*r**8+205758050*r**10+11525982*r**12+39997316*r**14-36530286*r**16
            +27976095*r**18)+2*Q2**7*(-254640+2882199*r**2+59353974*r**4+212515616*r**6
            +792221208*r**8+1247452960*r**10+1272164694*r**12+879465024*r**14+591679136*r**16
            +53346393*r**18+2437740*r**20)+2*Q2**6*(27720+789339*r**2+49458789*r**4
            -137890762*r**6-928880024*r**8-2512926912*r**10-3883645666*r**12-2844620746*r**14
            -654115832*r**16-302888899*r**18-64932987*r**20+7687740*r**22)-2*Q2**5*(
            -155010+3179651*r**2+75489978*r**4+9011143*r**6+1178158688*r**8+1814989088*r**10
            +143656338*r**12-3265427532*r**14-2615233912*r**16-196798587*r**18+465594828*r**20
            +20256957*r**22+3747810*r**24)+2*Q2**4*(-34800+429893*r**2+13092911*r**4
            +254473345*r**6+3066154535*r**8+5518907760*r**10+6022535174*r**12+6239930638*r**14
            +7188662350*r**16+3828621065*r**18+247777115*r**20+414022033*r**22+54467051*r**24
            -1103070*r**26)+Q2**3*(-102720+2946871*r**2+35076693*r**4-430516868*r**6
            -1622270680*r**8-2407501785*r**10-3972479207*r**12-2896383656*r**14-1879468064*r**16
            -11455837155*r**18-12282676545*r**20-2245358164*r**22+56844088*r**24
            -12757243*r**26+1697235*r**28)-(-1+r**2)**2*(6840-262821*r**2+694140*r**4
            +53693853*r**6+340327528*r**8+1056435675*r**10+19830812092*r**12+41828023405*r**14
            +31273693864*r**16+1060482649*r**18-2366456780*r**20+2425860079*r**22
            +553946680*r**24+35499633*r**26-2265452*r**28+132615*r**30)-Q2**2*(-29640
            +759349*r**2+18796244*r**4+90389751*r**6+2573379748*r**8-4264509115*r**10
            -16074629528*r**12-38907744713*r**14-43242750992*r**16-9250682441*r**18
            +9496395540*r**20+4191654029*r**22-988650956*r**24+236074191*r**26+30677168*r**28
            +247365*r**30)+Q2*(18180-712839*r**2+5167701*r**4+197422827*r**6+1553553159*r**8
            -2371820983*r**10+36772678093*r**12+121033122043*r**14+172424472631*r**16
            +58661293507*r**18-8400275609*r**20-4648158839*r**22+8076387181*r**24
            +934073467*r**26+119024759*r**28+5960337*r**30+290385*r**32)))*sqrtq2))/(36741600000*logq2**4*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+510300000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +354375*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-88179840000*logq2**5*r**20*sqrtq2
            -6123600000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-21262500*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+(-32*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(87768*Q2**25
            -2*Q2**24*(8271+81989*r**2)+2*Q2**23*(-747099+4903720*r**2+2242935*r**4)
            -Q2**22*(99754119+137715163*r**2+1115015941*r**4+103196561*r**6)+4*Q2**21*(303374295
            +238353457*r**2+3028354926*r**4+3732252727*r**6+203293523*r**8)-Q2**20*(6226097931
            +3390927413*r**2+42959043570*r**4+147215519478*r**6+90509338119*r**8
            +3416464833*r**10)+Q2**19*(17301459663+6528334356*r**2-5954689941*r**4
            +478600511440*r**6+794884895201*r**8+305789630172*r**10+8653892437*r**12)
            -2*Q2**18*(12120571044+6985454003*r**2-250486846678*r**4+7462765969*r**6
            +977139461608*r**8+1143890525677*r**10+287850744158*r**12+6486733035*r**14)
            +Q2**17*(-489227229+68579142616*r**2-1686456239182*r**4-4408859896192*r**6
            -3401996905308*r**8+1790095915544*r**10+3231995102910*r**12+385008487088*r**14
            +8114973129*r**16)+2*Q2**16*(33106530150-121952394614*r**2+1300358675771*r**4
            +7806879829641*r**6+16500572158121*r**8+17047282916583*r**10+5935376181501*r**12
            +101787186831*r**14+406623657241*r**16+4106159991*r**18)-8*Q2**15*(14064944067
            -55131308362*r**2+138822292149*r**4+3752778795198*r**6+12176110414588*r**8
            +20172562955812*r**10+16818446060434*r**12+5835404420414*r**14+1147430295473*r**16
            +289354038290*r**18+2600199521*r**20)+2*Q2**14*(25085210319-113933722425*r**2
            -1864029678831*r**4+16837182532785*r**6+79636922227302*r**8+175468074320574*r**10
            +205145981659122*r**12+130208003425338*r**14+33780997918035*r**16+7826387649411*r**18
            +1007438005493*r**20+4872100941*r**22)+4*Q2**13*(24678184113-157529145218*r**2
            +2387833309828*r**4-1908159848174*r**6-31145172677191*r**8-96147938910164*r**10
            -133231325879892*r**12-106652832426124*r**14-48606333770753*r**16-2399661222138*r**18
            -2259535803760*r**20+217040486602*r**22+4703472535*r**24)-2*Q2**12*(86840065737
            -674427226265*r**2+5568634320574*r**4+23490568418554*r**6+21884126965551*r**8
            -36675765236583*r**10-42075132966628*r**12+82109423379316*r**14+116340036228039*r**16
            +89147110148153*r**18+54348162372854*r**20+3664683608066*r**22+1778578129809*r**24
            +16073604023*r**26)+2*Q2**11*(37282893885-373804926692*r**2+1816271339285*r**4
            +42830952736808*r**6+92703758128181*r**8+169163011166524*r**10+272896631484317*r**12
            +603339572118000*r**14+781778718921847*r**16+496917335867924*r**18+260693342610879*r**20
            +72414050360168*r**22+8558314458135*r**24+1349857879828*r**26+6631739151*r**28)
            +4*Q2**10*(21524582691-218899594090*r**2+2659764078969*r**4-15104569615580*r**6
            -26639976220937*r**8-107681446499206*r**10-113709239099831*r**12-248278294509004*r**14
            -445395541298375*r**16-450166304336574*r**18-158106958889565*r**20-107192894866316*r**22
            -5042535125651*r**24-3075083653810*r**26+197078787131*r**28+3693753268*r**30)
            -2*Q2**9*(65934231111-850612664272*r**2+9505094444014*r**4+3894624027880*r**6
            +39080616570398*r**8-141071250031984*r**10+114494478176030*r**12+341037259168744*r**14
            +271616738514780*r**16-108123054644464*r**18-279365530065942*r**20+280233109260408*r**22
            -30882620376318*r**24+63058039445680*r**26-732712023414*r**28+1403068047160*r**30
            +10745614269*r**32)+2*Q2**8*(25105296951-423050833499*r**2+5600020015514*r**4
            +26086816726478*r**6+42001718750658*r**8-68126617654178*r**10+269109491088914*r**12
            +1052929638481974*r**14+1565005163172448*r**16+1418594010048536*r**18
            +595236351714750*r**20+132428222295994*r**22+453049249215662*r**24+82146323277714*r**26
            +59762381336726*r**28+2557960325442*r**30+841358861561*r**32+3701531475*r**34)
            +2*Q2**7*(17163720243-239446148128*r**2+2494783138153*r**4-25372465527432*r**6
            +39361328098084*r**8-78075245222272*r**10+103569430640916*r**12-1045886682848888*r**14
            -1823337364273726*r**16-2049523604493552*r**18-1335060565323026*r**20
            -85807523745016*r**22-369317815603068*r**24-7443706620704*r**26-108572150511612*r**28
            +1065045010680*r**30-3013362214557*r**32+174753288368*r**34+2896923537*r**36)
            +Q2**6*(-46644359535+865395917765*r**2-12516907346757*r**4+30428783147415*r**6
            -157482916752028*r**8+507366787012836*r**10-1865803150888900*r**12+1449522128563612*r**14
            +2355290168962830*r**16+3679227028247318*r**18+4038139350124938*r**20
            +2082326356461570*r**22-2564896659302668*r**24+2036333281473940*r**26
            -810065418604852*r**28+230019005102156*r**30-75675878541815*r**32+3979843074733*r**34
            -1022926994765*r**36-7080273793*r**38)+4*Q2**5*(4372657866-100820725079*r**2
            +1856732984826*r**4-2365181913249*r**6+18430600474656*r**8-106275060024908*r**10
            +649775226572572*r**12-556028572082676*r**14-409521235339816*r**16-1078260097429010*r**18
            -1695401980126624*r**20-1496121457867102*r**22-1223309558436956*r**24
            +1121387447103204*r**26-631166339148668*r**28+171073660534428*r**30-38418940848066*r**32
            +12559731561681*r**34-273603371514*r**36+127339349847*r**38+594186588*r**40)
            +2*(-1+r**2)**4*(24051798-744890774*r**2+20051111407*r**4-105561254847*r**6
            +569375111437*r**8-3390172985313*r**10+41053817465460*r**12-213879619286716*r**14
            +594077050681616*r**16-674150277095496*r**18+233284614981226*r**20+63752293894094*r**22
            +386877468900486*r**24-400478265211366*r**26+110718471425556*r**28-29695386396780*r**30
            +4315669777378*r**32-1075620301802*r**34+119818754847*r**36-5740246247*r**38
            +720588069*r**40+3245967*r**42)+Q2**4*(3423792213-51174622197*r**2+111291225006*r**4
            -7725561977750*r**6+37440694021741*r**8-36349812297813*r**10-903481101383496*r**12
            +2026223997804392*r**14+639169825931050*r**16+3447491478420342*r**18+8146189126624516*r**20
            +4848275725383180*r**22+2403520252976098*r**24+5472362703546350*r**26
            -2326571239808232*r**28+734626999055880*r**30-24425213734559*r**32-7012412601121*r**34
            -490070635650*r**36-881998282726*r**38+19602565329*r**40+663229447*r**42)
            -Q2*(-1+r**2)**2*(555766965-16388385214*r**2+395110947541*r**4-2115114593608*r**6
            +11107994703411*r**8-62831441630170*r**10+574218333535035*r**12-2412673900650576*r**14
            +4871895226156274*r**16-2287515137754908*r**18-2420683442855150*r**20
            +1989255632470944*r**22+2097901825701862*r**24+2764903268960476*r**26
            -4512124012721642*r**28+1576310285614800*r**30-461923502436087*r**32+83208156124090*r**34
            -19522259099767*r**36+2449386900264*r**38-128370079945*r**40+15593121822*r**42
            +77323583*r**44)-Q2**3*(6104372193-148017348436*r**2+2633559728941*r**4
            -13853414280928*r**6+72601663900211*r**8-315313211994316*r**10+1299069961892519*r**12
            -2333883809437568*r**14+2174711605764234*r**16+223014232777912*r**18+623356728493570*r**20
            +466885744309824*r**22+454104088066278*r**24-2019599815013784*r**26-2752595377957682*r**28
            +2663000435019136*r**30-1283992798758811*r**32+384939935397084*r**34-98289290927647*r**36
            +16710862529184*r**38-1182768377833*r**40+137115962404*r**42+931163515*r**44)
            +2*Q2**2*(1327217418-37191845301*r**2+795285073420*r**4-4547297516075*r**6
            +23573206547746*r**8-122591097992183*r**10+807233078082876*r**12-2788437621425605*r**14
            +4657762506117668*r**16-2555068722077698*r**18+1305341550258536*r**20
            -2991407641786862*r**22+3194028870772580*r**24+305234696196066*r**26+3560544062066408*r**28
            -5309296241512170*r**30+2320497698520850*r**32-744257017172825*r**34+165125587970764*r**36
            -37166088755831*r**38+5070917865274*r**40-306320761563*r**42+34139681180*r**44
            +191595327*r**46))-32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(87768*Q2**25-2*Q2**24*(8271
            +81989*r**2)+2*Q2**23*(-747099+4903720*r**2+2242935*r**4)-Q2**22*(99754119
            +137715163*r**2+1115015941*r**4+103196561*r**6)+4*Q2**21*(303374295+238353457*r**2
            +3028354926*r**4+3732252727*r**6+203293523*r**8)-Q2**20*(6226097931+3390927413*r**2
            +42959043570*r**4+147215519478*r**6+90509338119*r**8+3416464833*r**10)
            +Q2**19*(17301459663+6528334356*r**2-5954689941*r**4+478600511440*r**6
            +794884895201*r**8+305789630172*r**10+8653892437*r**12)-2*Q2**18*(12120571044
            +6985454003*r**2-250486846678*r**4+7462765969*r**6+977139461608*r**8
            +1143890525677*r**10+287850744158*r**12+6486733035*r**14)+Q2**17*(-489227229
            +68579142616*r**2-1686456239182*r**4-4408859896192*r**6-3401996905308*r**8
            +1790095915544*r**10+3231995102910*r**12+385008487088*r**14+8114973129*r**16)
            +2*Q2**16*(33106530150-121952394614*r**2+1300358675771*r**4+7806879829641*r**6
            +16500572158121*r**8+17047282916583*r**10+5935376181501*r**12+101787186831*r**14
            +406623657241*r**16+4106159991*r**18)-8*Q2**15*(14064944067-55131308362*r**2
            +138822292149*r**4+3752778795198*r**6+12176110414588*r**8+20172562955812*r**10
            +16818446060434*r**12+5835404420414*r**14+1147430295473*r**16+289354038290*r**18
            +2600199521*r**20)+2*Q2**14*(25085210319-113933722425*r**2-1864029678831*r**4
            +16837182532785*r**6+79636922227302*r**8+175468074320574*r**10+205145981659122*r**12
            +130208003425338*r**14+33780997918035*r**16+7826387649411*r**18+1007438005493*r**20
            +4872100941*r**22)+4*Q2**13*(24678184113-157529145218*r**2+2387833309828*r**4
            -1908159848174*r**6-31145172677191*r**8-96147938910164*r**10-133231325879892*r**12
            -106652832426124*r**14-48606333770753*r**16-2399661222138*r**18-2259535803760*r**20
            +217040486602*r**22+4703472535*r**24)-2*Q2**12*(86840065737-674427226265*r**2
            +5568634320574*r**4+23490568418554*r**6+21884126965551*r**8-36675765236583*r**10
            -42075132966628*r**12+82109423379316*r**14+116340036228039*r**16+89147110148153*r**18
            +54348162372854*r**20+3664683608066*r**22+1778578129809*r**24+16073604023*r**26)
            +2*Q2**11*(37282893885-373804926692*r**2+1816271339285*r**4+42830952736808*r**6
            +92703758128181*r**8+169163011166524*r**10+272896631484317*r**12+603339572118000*r**14
            +781778718921847*r**16+496917335867924*r**18+260693342610879*r**20+72414050360168*r**22
            +8558314458135*r**24+1349857879828*r**26+6631739151*r**28)+4*Q2**10*(21524582691
            -218899594090*r**2+2659764078969*r**4-15104569615580*r**6-26639976220937*r**8
            -107681446499206*r**10-113709239099831*r**12-248278294509004*r**14-445395541298375*r**16
            -450166304336574*r**18-158106958889565*r**20-107192894866316*r**22-5042535125651*r**24
            -3075083653810*r**26+197078787131*r**28+3693753268*r**30)-2*Q2**9*(65934231111
            -850612664272*r**2+9505094444014*r**4+3894624027880*r**6+39080616570398*r**8
            -141071250031984*r**10+114494478176030*r**12+341037259168744*r**14+271616738514780*r**16
            -108123054644464*r**18-279365530065942*r**20+280233109260408*r**22-30882620376318*r**24
            +63058039445680*r**26-732712023414*r**28+1403068047160*r**30+10745614269*r**32)
            +2*Q2**8*(25105296951-423050833499*r**2+5600020015514*r**4+26086816726478*r**6
            +42001718750658*r**8-68126617654178*r**10+269109491088914*r**12+1052929638481974*r**14
            +1565005163172448*r**16+1418594010048536*r**18+595236351714750*r**20+132428222295994*r**22
            +453049249215662*r**24+82146323277714*r**26+59762381336726*r**28+2557960325442*r**30
            +841358861561*r**32+3701531475*r**34)+2*Q2**7*(17163720243-239446148128*r**2
            +2494783138153*r**4-25372465527432*r**6+39361328098084*r**8-78075245222272*r**10
            +103569430640916*r**12-1045886682848888*r**14-1823337364273726*r**16-2049523604493552*r**18
            -1335060565323026*r**20-85807523745016*r**22-369317815603068*r**24-7443706620704*r**26
            -108572150511612*r**28+1065045010680*r**30-3013362214557*r**32+174753288368*r**34
            +2896923537*r**36)+Q2**6*(-46644359535+865395917765*r**2-12516907346757*r**4
            +30428783147415*r**6-157482916752028*r**8+507366787012836*r**10-1865803150888900*r**12
            +1449522128563612*r**14+2355290168962830*r**16+3679227028247318*r**18
            +4038139350124938*r**20+2082326356461570*r**22-2564896659302668*r**24
            +2036333281473940*r**26-810065418604852*r**28+230019005102156*r**30-75675878541815*r**32
            +3979843074733*r**34-1022926994765*r**36-7080273793*r**38)+4*Q2**5*(4372657866
            -100820725079*r**2+1856732984826*r**4-2365181913249*r**6+18430600474656*r**8
            -106275060024908*r**10+649775226572572*r**12-556028572082676*r**14-409521235339816*r**16
            -1078260097429010*r**18-1695401980126624*r**20-1496121457867102*r**22
            -1223309558436956*r**24+1121387447103204*r**26-631166339148668*r**28+171073660534428*r**30
            -38418940848066*r**32+12559731561681*r**34-273603371514*r**36+127339349847*r**38
            +594186588*r**40)+2*(-1+r**2)**4*(24051798-744890774*r**2+20051111407*r**4
            -105561254847*r**6+569375111437*r**8-3390172985313*r**10+41053817465460*r**12
            -213879619286716*r**14+594077050681616*r**16-674150277095496*r**18+233284614981226*r**20
            +63752293894094*r**22+386877468900486*r**24-400478265211366*r**26+110718471425556*r**28
            -29695386396780*r**30+4315669777378*r**32-1075620301802*r**34+119818754847*r**36
            -5740246247*r**38+720588069*r**40+3245967*r**42)+Q2**4*(3423792213-51174622197*r**2
            +111291225006*r**4-7725561977750*r**6+37440694021741*r**8-36349812297813*r**10
            -903481101383496*r**12+2026223997804392*r**14+639169825931050*r**16+3447491478420342*r**18
            +8146189126624516*r**20+4848275725383180*r**22+2403520252976098*r**24
            +5472362703546350*r**26-2326571239808232*r**28+734626999055880*r**30-24425213734559*r**32
            -7012412601121*r**34-490070635650*r**36-881998282726*r**38+19602565329*r**40
            +663229447*r**42)-Q2*(-1+r**2)**2*(555766965-16388385214*r**2+395110947541*r**4
            -2115114593608*r**6+11107994703411*r**8-62831441630170*r**10+574218333535035*r**12
            -2412673900650576*r**14+4871895226156274*r**16-2287515137754908*r**18
            -2420683442855150*r**20+1989255632470944*r**22+2097901825701862*r**24
            +2764903268960476*r**26-4512124012721642*r**28+1576310285614800*r**30
            -461923502436087*r**32+83208156124090*r**34-19522259099767*r**36+2449386900264*r**38
            -128370079945*r**40+15593121822*r**42+77323583*r**44)-Q2**3*(6104372193
            -148017348436*r**2+2633559728941*r**4-13853414280928*r**6+72601663900211*r**8
            -315313211994316*r**10+1299069961892519*r**12-2333883809437568*r**14+2174711605764234*r**16
            +223014232777912*r**18+623356728493570*r**20+466885744309824*r**22+454104088066278*r**24
            -2019599815013784*r**26-2752595377957682*r**28+2663000435019136*r**30
            -1283992798758811*r**32+384939935397084*r**34-98289290927647*r**36+16710862529184*r**38
            -1182768377833*r**40+137115962404*r**42+931163515*r**44)+2*Q2**2*(1327217418
            -37191845301*r**2+795285073420*r**4-4547297516075*r**6+23573206547746*r**8
            -122591097992183*r**10+807233078082876*r**12-2788437621425605*r**14+4657762506117668*r**16
            -2555068722077698*r**18+1305341550258536*r**20-2991407641786862*r**22
            +3194028870772580*r**24+305234696196066*r**26+3560544062066408*r**28-5309296241512170*r**30
            +2320497698520850*r**32-744257017172825*r**34+165125587970764*r**36-37166088755831*r**38
            +5070917865274*r**40-306320761563*r**42+34139681180*r**44+191595327*r**46))*sqrtq2
            +logq2**8*(6772211712000000*r**32*(1+r**2)**2*(1-Q2+r**2)*(747+3795*r**2
            +15204*r**4-98128*r**6+40873*r**8+3213*r**10)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3+6772211712000000*(Q2-(-1+r)**2)**2*r**32*(1+r**2)**2*(747+3795*r**2
            +15204*r**4-98128*r**6+40873*r**8+3213*r**10)*(Q2-(1+r)**2)**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**7*(5374771200000*r**28*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-630*Q2**11*(-19-19*r**2
            +65*r**4+65*r**6)-90*Q2**10*(1843+8022*r**2+23730*r**4+21886*r**6+4335*r**8)
            +30*Q2**9*(32547+236079*r**2+892346*r**4+1533918*r**6+1052959*r**8+207855*r**10)
            -2*Q2**8*(1683945+16095702*r**2+66956607*r**4+142670116*r**6+171210491*r**8
            +87942366*r**10+15142005*r**12)+3*Q2**7*(2296305+26961384*r**2+117213203*r**4
            +305562766*r**6+463747579*r**8+390856304*r**10+165599577*r**12+25476210*r**14)
            -3*Q2**6*(2536065+37917159*r**2+168969769*r**4+554250991*r**6+1042156031*r**8
            +1054818309*r**10+687335267*r**12+256669077*r**14+35797860*r**16)+Q2**5*(2825235
            +83695584*r**2+407900232*r**4+1729215598*r**6+3598638638*r**8+4414529934*r**10
            +3485025160*r**12+1773003146*r**14+571957407*r**16+65902410*r**18)+3*(
            -1+r**2)**4*(-68205+68547*r**2-2515986*r**4+50069700*r**6-57989794*r**8
            -298449398*r**10+3511660*r**12+57383188*r**14+6160247*r**16+9414491*r**18
            +1946430*r**20)+3*Q2**4*(830655-8210055*r**2-85237540*r**4-334294108*r**6
            -595041758*r**8-825226394*r**10-758076044*r**12-539760284*r**14-134579945*r**16
            +14836185*r**18+12007800*r**20)-3*Q2*(-1+r**2)**2*(-211125+222996*r**2
            -19868117*r**4+217745732*r**6-25475002*r**8-1502431656*r**10-1153023674*r**12
            +317017624*r**14+222575855*r**16+33747684*r**18+54125583*r**20+11821140*r**22)
            -3*Q2**3*(885195+629622*r**2-77694593*r**4+38336144*r**6+23585902*r**8
            -1208088012*r**10-845426010*r**12+327076560*r**14+50234695*r**16+105515686*r**18
            +146739291*r**20+34854480*r**22)+Q2**2*(174285+2421453*r**2-172659699*r**4
            +999837583*r**6+19345580*r**8-5759373102*r**10-5199470606*r**12-3647279650*r**14
            +1582796733*r**16+687494641*r**18+6658193*r**20+329830659*r**22+87706170*r**24))
            +5374771200000*r**28*(1+r**2)*(630*Q2**14*(-19-19*r**2+65*r**4+65*r**6)
            +180*Q2**13*(1121+4410*r**2+11382*r**4+9578*r**6+1485*r**8)-30*Q2**12*(50331
            +326859*r**2+1176014*r**4+1938834*r**6+1282123*r**8+242775*r**10)+4*Q2**11*(1701675
            +14716356*r**2+60938811*r**4+129012638*r**6+146712703*r**8+74011878*r**10
            +12530115*r**12)-3*Q2**10*(6695895+70439358*r**2+316202141*r**4+795522352*r**6
            +1179548533*r**8+982399658*r**10+408040719*r**12+62125920*r**14)+10*Q2**9*(3935502
            +48648663*r**2+229941831*r**4+670129923*r**6+1201582747*r**8+1287980645*r**10
            +854818629*r**12+310326465*r**14+43376715*r**16)-5*Q2**8*(9936891+146605680*r**2
            +721118076*r**4+2411360502*r**6+4996736882*r**8+6403918566*r**10+5394197620*r**12
            +3029176914*r**14+998602803*r**16+129530610*r**18)+30*Q2**7*(1189908
            +23821956*r**2+125514069*r**4+474953841*r**6+1073270837*r**8+1548867409*r**10
            +1557230011*r**12+1103968919*r**14+536205855*r**16+160474995*r**18+18676440*r**20)
            +3*(-1+r**2)**6*(-68205+342*r**2-2447439*r**4+47553714*r**6-7920094*r**8
            -356439192*r**10-294937738*r**12+60894848*r**14+63543435*r**16+15574738*r**18
            +11360921*r**20+1946430*r**22)-2*Q2**6*(2976210+213703119*r**2+1429614669*r**4
            +5482505397*r**6+12420935092*r**8+20458667222*r**10+22149943494*r**12
            +17450980714*r**14+11037573722*r**16+4303191627*r**18+914238477*r**20
            +46233585*r**22)+2*Q2**5*(-6395850+66861054*r**2+998273073*r**4+2094398091*r**6
            +4548426364*r**8+14960201544*r**10+19005793786*r**12+11308923878*r**14
            +3011163306*r**16+2324257754*r**18-63838731*r**20-831846033*r**22-221782140*r**24)
            -6*Q2*(-1+r**2)**4*(-207870+40551*r**2-13630300*r**4+171630192*r**6
            +55446395*r**8-1194512670*r**10-1707894264*r**12-776090680*r**14+341687788*r**16
            +234518535*r**18+65511140*r**20+49041528*r**22+8830215*r**24)+30*Q2**4*(344940
            -214047*r**2-49779057*r**4+80637510*r**6+26897463*r**8-1041697531*r**10
            -1368627742*r**12-1161150292*r**14-502235682*r**16+350525147*r**18+129730351*r**20
            +82697166*r**22+96077535*r**24+21609855*r**26)+5*Q2**2*(-1+r**2)**2*(
            -467937+913344*r**2-74452080*r**4+628345628*r**6+193658967*r**8-4018491692*r**10
            -5377947352*r**12-4756927680*r**14-2343012707*r**16+1261415744*r**18
            +756149160*r**20+204911140*r**22+208561293*r**24+42322860*r**26)-10*Q2**3*(107370
            +1177740*r**2-93875967*r**4+532738743*r**6-109883257*r**8-3298198247*r**10
            -1865349900*r**12-927938134*r**14-2125722452*r**16-2394552174*r**18+745661405*r**20
            +412683871*r**22+36527139*r**24+188618505*r**26+47991150*r**28))*sqrtq2)
            +logq2**6*(29859840000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(10080*Q2**15*(-19-19*r**2+65*r**4+65*r**6)-180*Q2**14*(12315
            -10058*r**2+195970*r**4+542414*r**6+324071*r**8)+120*Q2**13*(443697
            +768435*r**2+3463702*r**4+11220156*r**6+13374413*r**8+5293221*r**10)
            -4*Q2**12*(93393927+289755840*r**2+777613470*r**4+2123976793*r**6+3375487292*r**8
            +2645183055*r**10+795851271*r**12)+4*Q2**11*(351488034+1490696034*r**2
            +3818113905*r**4+8347254836*r**6+14448745410*r**8+15809652904*r**10+9332664387*r**12
            +2303407962*r**14)-Q2**10*(3172022703+16794189489*r**2+46207787883*r**4
            +93337687357*r**6+156509106489*r**8+197859757491*r**10+163575530057*r**12
            +78307113807*r**14+16569185364*r**16)+10*Q2**9*(408919581+2676117138*r**2
            +8211729210*r**4+18297707672*r**6+33166851736*r**8+43604655132*r**10
            +39755295950*r**12+25174239304*r**14+10054235043*r**16+1844312274*r**18)
            -5*Q2**8*(345338523+3938006967*r**2+15367651320*r**4+49124737496*r**6
            +119355582834*r**8+192242096110*r**10+195383192204*r**12+122455724616*r**14
            +51361117651*r**16+15519463803*r**18+2262493404*r**20)+2*Q2**7*(-1686484332
            -2950839780*r**2+11258105865*r**4+125694357262*r**6+468449366838*r**8
            +1028753087838*r**10+1402524142524*r**12+1143893008530*r**14+523044991302*r**16
            +125809619798*r**18+18377672715*r**20+768561264*r**22)+2*Q2**6*(3236891139
            +12221377779*r**2+6937229010*r**4-114811280564*r**6-601829473150*r**8
            -1785309297432*r**10-3080963566754*r**12-3192409289338*r**14-2094863286219*r**16
            -821049080795*r**18-155647977616*r**20-9678880818*r**22+1489106502*r**24)
            +2*Q2**5*(-2197019502-9218695956*r**2-1682388147*r**4+75549138622*r**6
            +541558483809*r**8+2009415978164*r**10+3971308826386*r**12+4848743004360*r**14
            +3907858571156*r**16+2090981666584*r**18+726857256801*r**20+137966862842*r**22
            +8153759097*r**24-1580465016*r**26)+9*(-1+r**2)**4*(-7095747-2699219*r**2
            +17277284*r**4-858654996*r**6+1064411397*r**8+7968354849*r**10-27537778340*r**12
            -71462829184*r**14-32329100617*r**16+6792803679*r**18+10652476068*r**20
            +6901267604*r**22+1846233095*r**24+142316883*r**26+15986844*r**28)+10*Q2**4*(3885219
            +379429773*r**2-457688115*r**4-4432837561*r**6-72623971104*r**8-252883858218*r**10
            -426340358196*r**12-532291586358*r**14-560668233201*r**16-393457940715*r**18
            -129842224983*r**20-13603490673*r**22-2670370994*r**24-197955096*r**26
            +352572894*r**28)-18*Q2*(-1+r**2)**2*(-27512577-5442296*r**2+118781540*r**4
            -2128874842*r**6-582282229*r**8+24852293956*r**10-41556204396*r**12-215713804254*r**14
            -198484411411*r**16-32079903488*r**18+26718704652*r**20+26178440362*r**22
            +19836302409*r**24+5249319348*r**26+382561212*r**28+53910414*r**30)-30*Q2**3*(
            -69306480-36263472*r**2+185488073*r**4-1117884470*r**6-15549191284*r**8
            -15335846174*r**10-18729785591*r**12-71025366376*r**14-55845038856*r**16
            -7855350308*r**18-708515245*r**20+27722934082*r**22+29608582764*r**24
            +6851730738*r**26+441972059*r**28+130251420*r**30)+3*Q2**2*(-509959401
            +166970865*r**2+2490207525*r**4-22228166129*r**6-50094968681*r**8+250305745437*r**10
            -197585001703*r**12-1782635060685*r**14-2231395603527*r**16-1156903479453*r**18
            +12645744399*r**20+82115519901*r**22+140655660125*r**24+233887528271*r**26
            +67639894899*r**28+4292606305*r**30+894902652*r**32))+29859840000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(10080*Q2**15*(-19-19*r**2+65*r**4+65*r**6)
            -180*Q2**14*(12315-10058*r**2+195970*r**4+542414*r**6+324071*r**8)+120*Q2**13*(443697
            +768435*r**2+3463702*r**4+11220156*r**6+13374413*r**8+5293221*r**10)
            -4*Q2**12*(93393927+289755840*r**2+777613470*r**4+2123976793*r**6+3375487292*r**8
            +2645183055*r**10+795851271*r**12)+4*Q2**11*(351488034+1490696034*r**2
            +3818113905*r**4+8347254836*r**6+14448745410*r**8+15809652904*r**10+9332664387*r**12
            +2303407962*r**14)-Q2**10*(3172022703+16794189489*r**2+46207787883*r**4
            +93337687357*r**6+156509106489*r**8+197859757491*r**10+163575530057*r**12
            +78307113807*r**14+16569185364*r**16)+10*Q2**9*(408919581+2676117138*r**2
            +8211729210*r**4+18297707672*r**6+33166851736*r**8+43604655132*r**10
            +39755295950*r**12+25174239304*r**14+10054235043*r**16+1844312274*r**18)
            -5*Q2**8*(345338523+3938006967*r**2+15367651320*r**4+49124737496*r**6
            +119355582834*r**8+192242096110*r**10+195383192204*r**12+122455724616*r**14
            +51361117651*r**16+15519463803*r**18+2262493404*r**20)+2*Q2**7*(-1686484332
            -2950839780*r**2+11258105865*r**4+125694357262*r**6+468449366838*r**8
            +1028753087838*r**10+1402524142524*r**12+1143893008530*r**14+523044991302*r**16
            +125809619798*r**18+18377672715*r**20+768561264*r**22)+2*Q2**6*(3236891139
            +12221377779*r**2+6937229010*r**4-114811280564*r**6-601829473150*r**8
            -1785309297432*r**10-3080963566754*r**12-3192409289338*r**14-2094863286219*r**16
            -821049080795*r**18-155647977616*r**20-9678880818*r**22+1489106502*r**24)
            +2*Q2**5*(-2197019502-9218695956*r**2-1682388147*r**4+75549138622*r**6
            +541558483809*r**8+2009415978164*r**10+3971308826386*r**12+4848743004360*r**14
            +3907858571156*r**16+2090981666584*r**18+726857256801*r**20+137966862842*r**22
            +8153759097*r**24-1580465016*r**26)+9*(-1+r**2)**4*(-7095747-2699219*r**2
            +17277284*r**4-858654996*r**6+1064411397*r**8+7968354849*r**10-27537778340*r**12
            -71462829184*r**14-32329100617*r**16+6792803679*r**18+10652476068*r**20
            +6901267604*r**22+1846233095*r**24+142316883*r**26+15986844*r**28)+10*Q2**4*(3885219
            +379429773*r**2-457688115*r**4-4432837561*r**6-72623971104*r**8-252883858218*r**10
            -426340358196*r**12-532291586358*r**14-560668233201*r**16-393457940715*r**18
            -129842224983*r**20-13603490673*r**22-2670370994*r**24-197955096*r**26
            +352572894*r**28)-18*Q2*(-1+r**2)**2*(-27512577-5442296*r**2+118781540*r**4
            -2128874842*r**6-582282229*r**8+24852293956*r**10-41556204396*r**12-215713804254*r**14
            -198484411411*r**16-32079903488*r**18+26718704652*r**20+26178440362*r**22
            +19836302409*r**24+5249319348*r**26+382561212*r**28+53910414*r**30)-30*Q2**3*(
            -69306480-36263472*r**2+185488073*r**4-1117884470*r**6-15549191284*r**8
            -15335846174*r**10-18729785591*r**12-71025366376*r**14-55845038856*r**16
            -7855350308*r**18-708515245*r**20+27722934082*r**22+29608582764*r**24
            +6851730738*r**26+441972059*r**28+130251420*r**30)+3*Q2**2*(-509959401
            +166970865*r**2+2490207525*r**4-22228166129*r**6-50094968681*r**8+250305745437*r**10
            -197585001703*r**12-1782635060685*r**14-2231395603527*r**16-1156903479453*r**18
            +12645744399*r**20+82115519901*r**22+140655660125*r**24+233887528271*r**26
            +67639894899*r**28+4292606305*r**30+894902652*r**32))*sqrtq2)+logq2**5*(
            -497664000*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(13440*Q2**19*(-19
            +65*r**4)-480*Q2**18*(47677+30333*r**2+644113*r**4+696977*r**6)+10*Q2**17*(45079455
            +82288062*r**2+463070746*r**4+910734326*r**6+492267771*r**8)-2*Q2**16*(1793132367
            +5153635773*r**2+18379686136*r**4+44234929392*r**6+45948807649*r**8+16708399995*r**10)
            +4*Q2**15*(4041578901+15534293745*r**2+47488273337*r**4+120244336474*r**6
            +174131190233*r**8+123353553297*r**10+33926716725*r**12)-4*Q2**14*(11330715990
            +54671875893*r**2+164308250047*r**4+422209660594*r**6+737416672418*r**8
            +753754278691*r**10+407706338225*r**12+89800595550*r**14)+Q2**13*(77981274735
            +473126998443*r**2+1504614195645*r**4+3950344018331*r**6+7728041930407*r**8
            +9917163734689*r**10+7873078866031*r**12+3467529154505*r**14+623394373230*r**16)
            -Q2**12*(65628829665+594538972512*r**2+2148610760124*r**4+5878364866652*r**6
            +12290375665418*r**8+18198191481176*r**10+18468609605084*r**12+12233073710004*r**14
            +4562016461085*r**16+636443173080*r**18)+2*Q2**11*(-14629048749+133638378708*r**2
            +720490824753*r**4+2064028072853*r**6+4450326633713*r**8+6973722383321*r**10
            +7973209053513*r**12+7136248585595*r**14+4454718660444*r**16+1408725452307*r**18
            +70151619510*r**20)+2*Q2**10*(74142592269+201263824539*r**2+441360977484*r**4
            +1660508409728*r**6+4103817591976*r**8+7655487024024*r**10+11651350330666*r**12
            +11526357502110*r**14+6286260851435*r**16+1892209982205*r**18+712584802218*r**20
            +312676379250*r**22)-Q2**9*(163651894575+807828519681*r**2+3026807032689*r**4
            +11867446192013*r**6+31160541705056*r**8+62759214222262*r**10+96275805765326*r**12
            +103959652523374*r**14+79131360205043*r**16+41334229190441*r**18+14733745179297*r**20
            +4448947748325*r**22+967748973150*r**24)+Q2**8*(43421809785+589921326234*r**2
            +2560889120360*r**4+11166837374378*r**6+36988868835001*r**8+99103152653812*r**10
            +183549985260312*r**12+221317856237140*r**14+173505974197483*r**16+95652256425906*r**18
            +41321095210432*r**20+13460241974978*r**22+3649865273635*r**24+537795457920*r**26)
            +4*Q2**7*(21502949970-23826759309*r**2+133319832392*r**4+344799082381*r**6
            -4007175245591*r**8-24398650706722*r**10-64712692320647*r**12-105173531401236*r**14
            -105365609865094*r**16-61381229282591*r**18-20344718561112*r**20-5269310538873*r**22
            -1406676528213*r**24-266045702290*r**26+43989556695*r**28)-4*Q2**6*(26230083663
            +47169467886*r**2+787434653819*r**4+2974455227010*r**6+1152690066277*r**8
            -18637941715278*r**10-80911636555149*r**12-186232541110932*r**14-248391362422683*r**16
            -201371682918930*r**18-97043727818907*r**20-23865463113074*r**22-2809718739609*r**24
            -426318476974*r**26+46639906221*r**28+119267660580*r**30)+Q2**5*(40561865337
            +195275193129*r**2+2649552690235*r**4+8964793705985*r**6+4844992768155*r**8
            -51304040393491*r**10-342476001249785*r**12-964135636057251*r**14-1509026958965127*r**16
            -1505519929410309*r**18-979594796641455*r**20-410462791978669*r**22-101481143645399*r**24
            -11817782261073*r**26-1023976649171*r**28+135137508239*r**30+287327047050*r**32)
            +Q2**4*(12431963145-105431016372*r**2-255469919148*r**4-1071328542136*r**6
            -1581754355972*r**8+29083604375556*r**10+251607977859724*r**12+615963841410656*r**14
            +876392507518542*r**16+1016877150690084*r**18+898668935490828*r**20+448833293626248*r**22
            +109152888074092*r**24+28753793934044*r**26+6234476541588*r**28-696532934704*r**30
            -213627091775*r**32-15531282000*r**34)+9*(-1+r**2)**4*(22311669+150556808*r**2
            +4257305554*r**4-3756886474*r**6+30410586222*r**8+130474909050*r**10
            +17005939202*r**12+376598709982*r**14+4219929158528*r**16+7052193267426*r**18
            +3666070796678*r**20-1149006947678*r**22-2008100070686*r**24-634088572754*r**26
            -71644811098*r**28-13155383222*r**30-1882313157*r**32+165091950*r**34)
            -9*Q2*(-1+r**2)**2*(242862999+687936437*r**2+32376757862*r**4-21014263590*r**6
            +71587653638*r**8+872138256722*r**10+73652680142*r**12-23356106406*r**14
            +22843900955900*r**16+46974743911844*r**18+35347857413594*r**20+9621075008830*r**22
            -8048345352934*r**24-10838610428050*r**26-3549363657782*r**28-342769733490*r**30
            -77125121459*r**32-14031196697*r**34+1501606440*r**36)-6*Q2**3*(3435784635
            -5796257548*r**2+187264880865*r**4+141532859929*r**6-506865854757*r**8
            +3669213548401*r**10+19563578314955*r**12+17469333268285*r**14+12501303836597*r**16
            +16939645161309*r**18+13855753405633*r**20+13750818965019*r**22-15944537741575*r**24
            -31675263668541*r**26-9652655536327*r**28-384015699569*r**30-343019499076*r**32
            -78221646725*r**34+13064198490*r**36)+6*Q2**2*(1613347935-634111687*r**2
            +146497790216*r**4-107416469872*r**6-169803212338*r**8+3186167767574*r**10
            +2705222443010*r**12-8626682087686*r**14+43988647809404*r**16+121447135144136*r**18
            +103465788567562*r**20+38388256115026*r**22+19035166470754*r**24-4901009026742*r**26
            -27862658121338*r**28-10918752955346*r**30-700395007499*r**32-243419667809*r**34
            -66510593690*r**36+8233350390*r**38))+497664000*r**20*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(13440*Q2**20*(-19+65*r**4)-480*Q2**19*(47145+29801*r**2
            +645933*r**4+698797*r**6)+10*Q2**18*(47367951+86032542*r**2+495444154*r**4
            +975106646*r**6+525722667*r**8)-4*Q2**17*(1009264821+2895236679*r**2
            +10553240088*r**4+25551977376*r**6+26481909067*r**8+9584869425*r**10)
            +2*Q2**16*(9876290169+38015355630*r**2+118509868583*r**4+303103288476*r**6
            +438446117507*r**8+309364314238*r**10+84561833445*r**12)-4*Q2**15*(15372294891
            +74247748539*r**2+227330817129*r**4+589942270405*r**6+1031792199125*r**8
            +1051239022221*r**10+564986608247*r**12+123727312275*r**14)+5*Q2**14*(24660827739
            +147427473195*r**2+476106939881*r**4+1259283132179*r**6+2473309452491*r**8
            +3176369507825*r**10+2503784266739*r**12+1091511377921*r**14+196519351086*r**16)
            -2*Q2**13*(71805052200+572823622845*r**2+2063175977106*r**4+5666661540314*r**6
            +11984380807078*r**8+17921698573136*r**10+18129426102902*r**12+11786840865270*r**14
            +4326469994410*r**16+629918773155*r**18)+Q2**12*(36370732167+927444559593*r**2
            +4184131382142*r**4+12155031772482*r**6+27069393799496*r**8+44436011913236*r**10
            +52613219193286*r**12+44974180486278*r**14+25704527491977*r**16+8015910538779*r**18
            +776746412100*r**20)+2*Q2**11*(88771641018+82254494580*r**2-412768225977*r**4
            -1124010487878*r**6-2410537114590*r**8-3768561993010*r**10-3295581106168*r**12
            -3583100136998*r**14-5304706394604*r**16-3971234130546*r**18-766292269599*r**20
            +242524759740*r**22)-Q2**10*(311937079113+1358641353297*r**2+4312056636735*r**4
            +16071184966437*r**6+42689193708464*r**8+86277823454262*r**10+134889480474706*r**12
            +150315068188926*r**14+114756596912133*r**16+57691170857721*r**18+19943334748143*r**20
            +6499470111261*r**22+1593101731650*r**24)+10*Q2**9*(20707370436+156140174049*r**2
            +639552467273*r**4+2606109059908*r**6+8001685673207*r**8+19302290858113*r**10
            +34258500524790*r**12+42155331452584*r**14+35659698692590*r**16+21611784582139*r**18
            +9738906958017*r**20+3264293490260*r**22+906656199511*r**24+150554443107*r**26)
            -Q2**8*(-42589990095+728650173255*r**2+2617531117026*r**4+12348530165214*r**6
            +64184407191743*r**8+233686624315701*r**10+541503907196712*r**12+825561967102396*r**14
            +816286269894999*r**16+514683147753753*r**18+218352225880786*r**20+75858579340902*r**22
            +22736813361465*r**24+5251843540715*r**26+361837231140*r**28)-4*Q2**7*(47733033633
            +44845658547*r**2+896927726902*r**4+3452574141783*r**6-2509686096933*r**8
            -47043767667591*r**10-170022979582518*r**12-356118764832815*r**14-458930503689013*r**16
            -368118522066615*r**18-178769675662610*r**20-49479492213059*r**22-9485705806695*r**24
            -2099040707477*r**26-175416239374*r**28+163257217275*r**30)+Q2**6*(145482199989
            +488873399325*r**2+5987969177055*r**4+24012353229301*r**6+21353573941303*r**8
            -121245046989495*r**10-740674314331493*r**12-2032712346721575*r**14-3247522573099587*r**16
            -3304572110776761*r**18-2173256439592803*r**20-894099555706593*r**22-208181871056131*r**24
            -24761931127405*r**26-2542690932183*r**28+798767775443*r**30+764397689370*r**32)
            -2*Q2**5*(14064951096+170634037419*r**2+1550148901256*r**4+6342837469178*r**6
            +7695770415056*r**8-37771326000446*r**10-322694009751500*r**12-961287739358846*r**14
            -1674777551270460*r**16-2015712019532760*r**18-1691891830771296*r**20
            -919445441123186*r**22-310548411849080*r**24-71026359920258*r**26-9538117725916*r**28
            -96153103114*r**30+318045823532*r**32+151429164525*r**34)-9*(-1+r**2)**4*(22311669
            +172868477*r**2+4407862362*r**4+500419080*r**6+26653699748*r**8+160885495272*r**10
            +147480848252*r**12+393604649184*r**14+4596527868510*r**16+11272122425954*r**18
            +10718264064104*r**20+2517063849000*r**22-3157107018364*r**24-2642188643440*r**26
            -705733383852*r**28-84800194320*r**30-15037696379*r**32-1717221207*r**34
            +165091950*r**36)-5*Q2**4*(6609334191-25555319703*r**2+152537669934*r**4
            -95520260342*r**6-1138855605330*r**8+9903426261998*r**10+79614610425002*r**12
            +194477563776018*r**14+313472834389756*r**16+398981505835296*r**18+399736121322942*r**20
            +286001428581438*r**22+92463791050178*r**24-10428980000622*r**26-4585532548466*r**28
            +646769881894*r**30-593655404187*r**32-139697650825*r**34+12570781788*r**36)
            +18*Q2*(-1+r**2)**2*(132587334+518366453*r**2+18521598953*r**4-379223251*r**6
            +46377527386*r**8+504811380246*r**10+366128822094*r**12+261679157182*r**14
            +13152141263630*r**16+34403789264048*r**18+38052107372896*r**20+21769988574408*r**22
            +2764357138622*r**24-8326925580022*r**26-7599770911054*r**28-2198043862526*r**30
            -233555606380*r**32-50190991557*r**34-7371043657*r**36+833349195*r**38)
            +6*Q2**3*(5049132570-2994584600*r**2+327966413533*r**4+221381270922*r**6
            -535136207166*r**8+6348515461218*r**10+25938014306366*r**12+28406229495554*r**14
            +73959284914286*r**16+150888084142042*r**18+134261187134504*r**20+65994828485678*r**22
            +16841447694198*r**24-52520810436858*r**26-69190577326206*r**28-20955424191242*r**30
            -1427430206144*r**32-664660813610*r**34-131668041925*r**36+21297548880*r**38)
            -3*Q2**2*(3955284867+2565103813*r**2+385458601019*r**4-177076887943*r**6
            -116460548380*r**8+8156575168040*r**10+6985671882176*r**12-9738488919256*r**14
            +139616728989998*r**16+334662323587994*r**18+342552659060814*r**20+241408401645634*r**22
            +139018931300560*r**24+72905780747968*r**26-35288798760008*r**28-89810780691296*r**30
            -32061143862473*r**32-2495281412423*r**34-762543887873*r**36-167657715331*r**38
            +20971520100*r**40))*sqrtq2)+logq2**4*(-8294400*r**16*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(7680*Q2**22*(4665+59261*r**4)-960*Q2**21*(1009593
            +1044985*r**2+10290285*r**4+10876797*r**6)+24*Q2**20*(421271235+838960774*r**2
            +4097735154*r**4+7861295006*r**6+4201549743*r**8)-80*Q2**19*(726445116
            +2119794724*r**2+7607221387*r**4+18665928462*r**6+19362802375*r**8+6948298140*r**10)
            +20*Q2**18*(10326938616+40338626544*r**2+128707595067*r**4+348248597823*r**6
            +513951195301*r**8+364444315353*r**10+97359514416*r**12)-20*Q2**17*(23089731804
            +119225578332*r**2+381288840255*r**4+1068460856178*r**6+1949007265120*r**8
            +2023521257342*r**10+1082806598541*r**12+222538827708*r**14)+5*Q2**16*(116357165613
            +879668469959*r**2+3076422591869*r**4+8863774801251*r**6+18297097362975*r**8
            +24160370121045*r**10+19364496761199*r**12+8228457040721*r**14+1249829881752*r**16)
            -8*Q2**15*(14710456305+548491126893*r**2+2288804987433*r**4+6956604447357*r**6
            +15300061687441*r**8+22439433180240*r**10+23274560169813*r**12+16065757882843*r**14
            +5618035468992*r**16+442938724011*r**18)-20*Q2**14*(47184387408+3808626612*r**2
            -132526463277*r**4-450058307379*r**6-569709563899*r**8+2253353816575*r**10
            +4981141260915*r**12+2122716667205*r**14-1198888887359*r**16-461924761365*r**18
            +239949551700*r**20)+10*Q2**13*(163948926204+700052564356*r**2+3340445084119*r**4
            +12425740349010*r**6+34797907373538*r**8+84799308886582*r**10+143423197490940*r**12
            +146684829132930*r**14+84205878459026*r**16+25392993755814*r**18+5437658306077*r**20
            +1236864536364*r**22)-10*Q2**12*(92189358846+1008161948658*r**2+5859998381007*r**4
            +26023499020755*r**6+79544050302984*r**8+193363047152208*r**10+355528302566154*r**12
            +450432920271562*r**14+367999446385746*r**16+180975911922126*r**18+50049094312023*r**20
            +9179035915539*r**22+1018546273080*r**24)-20*Q2**11*(36106942482-286821414462*r**2
            -1471290558405*r**4-10933461877305*r**6-41684261713089*r**8-104915771422836*r**10
            -205112272680108*r**12-299721109886612*r**14-311178638155786*r**16-214478474112636*r**18
            -87984783303567*r**20-19680156195507*r**22-3166343516583*r**24+53369633358*r**26)
            +4*Q2**10*(390531358620+549218412344*r**2+11178098964644*r**4+8744300142621*r**6
            -48721654115887*r**8-118905995857200*r**10-230280444946674*r**12-370261470005984*r**14
            -490694487698716*r**16-522917322264918*r**18-326299064352070*r**20-55196313104701*r**22
            +19229191660239*r**24+1293187975886*r**26+2458473838068*r**28)-10*Q2**9*(86861562084
            +687679210476*r**2+8682992472795*r**4+26020973911428*r**6+59136171474176*r**8
            +182892541406268*r**10+444263978767887*r**12+799991033783428*r**14+1006927321066332*r**16
            +868049246253996*r**18+529917786886201*r**20+265634350817844*r**22+136968383938752*r**24
            +46486904752748*r**26+5210982177885*r**28+812443847940*r**30)+10*Q2**8*(
            -26053880229+556424854449*r**2+4645518384960*r**4+24735103180932*r**6
            +69643193393183*r**8+234906771148645*r**10+743347691906232*r**12+1664473475319292*r**14
            +2412918838557593*r**16+2284386782205171*r**18+1485122562911536*r**20
            +758498552148908*r**22+342675260171973*r**24+144450631238615*r**26+38559837868216*r**28
            +4804338407028*r**30+69179013576*r**32)+40*Q2**7*(15662624409-28355630323*r**2
            +642555964538*r**4-2320876153848*r**6-162692622708*r**8-3810582444360*r**10
            -122394649148730*r**12-449229252452912*r**14-865342873213362*r**16-1038615942860520*r**18
            -754893312237206*r**20-319293395093108*r**22-103977022139040*r**24-43443329804520*r**26
            -14209293690762*r**28-493755545508*r**30-373944036019*r**32+89858781579*r**34)
            -20*Q2**6*(15237910296+96448407492*r**2+2523330536523*r**4+700679347683*r**6
            +34886076790943*r**8+112246219885371*r**10-13714368322587*r**12-689128084841939*r**14
            -2174865122951907*r**16-3763923109361955*r**18-3876326209869255*r**20
            -2311400762497707*r**22-692621311103007*r**24-97916361206435*r**26-39114376246293*r**28
            -6921154180677*r**30+9299696134187*r**32+514474610343*r**34+138502744524*r**36)
            +2*Q2**5*(-10709963100+985816744188*r**2+12082674401853*r**4+22009412582562*r**6
            +325786960455626*r**8+1029182783542390*r**10+416698564998882*r**12-5978108829142298*r**14
            -26676213273246502*r**16-56354219723708106*r**18-71434952861006820*r**20
            -58075085048182878*r**22-29655876898561698*r**24-8601548405987582*r**26
            -1168188727219666*r**28-301864207489470*r**30-76700212805542*r**32+61255839122518*r**34
            +6806045847447*r**36+272163458196*r**38)+9*(-1+r**2)**4*(-17614095+1004080919*r**2
            +12456345925*r**4+31414759887*r**6+1133287735032*r**8-180819279128*r**10
            -1255616194552*r**12+31485884956480*r**14+88768239512314*r**16+8716867943294*r**18
            +265964327737354*r**20+662841138346022*r**22+214219872882840*r**24-250190954498064*r**26
            -132073695909184*r**28-14764673929544*r**30-2502431145139*r**32-1053094139245*r**34
            +13184603113*r**36+6713022483*r**38+184383288*r**40)+10*Q2**4*(8739219078
            -62837380258*r**2+371678148587*r**4-4475409071109*r**6-5296640517672*r**8
            -49179764534212*r**10-3869099538168*r**12+945291452878104*r**14+4018665422817344*r**16
            +7646240364248664*r**18+9919859536449590*r**20+10007237307306310*r**22
            +6773113797761076*r**24+2628000347677764*r**26+760473131418928*r**28+170401448868384*r**30
            +11771870182266*r**32-490299673142*r**34-583153154649*r**36-568322356345*r**38
            +43646273460*r**40)-90*Q2*(-1+r**2)**2*(-4150860+864271188*r**2+12219619475*r**4
            -2717980458*r**6+899039034397*r**8-324344596688*r**10-1372645613600*r**12
            +12082064069044*r**14+40473603289728*r**16+50760045445348*r**18+151287663374958*r**20
            +322150143673536*r**22+309519682501962*r**24+34699557241868*r**26-144470320435912*r**28
            -70121826701812*r**30-6822296864524*r**32-1115935010856*r**34-745726015513*r**36
            +24241296042*r**38+5066641777*r**40+245790900*r**42)-60*Q2**3*(641752722
            +3191727378*r**2+157269727473*r**4-519349766427*r**6+5441998720033*r**8
            +349880125268*r**10-5437459610946*r**12+77262414162106*r**14+237049527864506*r**16
            +144070782772506*r**18-38721392639696*r**20+8684162841620*r**22+167724168072744*r**24
            -58906139398906*r**26-340593267870686*r**28-143074335273450*r**30-495164636764*r**32
            -3256439762948*r**34-3612709436673*r**36+440594862647*r**38+1914873031*r**40
            +6084654462*r**42)+60*Q2**2*(98719308+3909724144*r**2+74473080757*r**4
            -209844501912*r**6+4303364735526*r**8-3633326935853*r**10-6354822137334*r**12
            +39815845438722*r**14+76469596843746*r**16+60945403326142*r**18+471712199196856*r**20
            +792792187508898*r**22+544029368007782*r**24+485648555162844*r**26+174468369666338*r**28
            -332512728447210*r**30-199303622158470*r**32-13239320587758*r**34-1147383809053*r**36
            -3258593865506*r**38+192157752524*r**40+17880437137*r**42+2089482372*r**44))
            -8294400*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(7680*Q2**22*(4665
            +59261*r**4)-960*Q2**21*(1009593+1044985*r**2+10290285*r**4+10876797*r**6)
            +24*Q2**20*(421271235+838960774*r**2+4097735154*r**4+7861295006*r**6
            +4201549743*r**8)-80*Q2**19*(726445116+2119794724*r**2+7607221387*r**4
            +18665928462*r**6+19362802375*r**8+6948298140*r**10)+20*Q2**18*(10326938616
            +40338626544*r**2+128707595067*r**4+348248597823*r**6+513951195301*r**8
            +364444315353*r**10+97359514416*r**12)-20*Q2**17*(23089731804+119225578332*r**2
            +381288840255*r**4+1068460856178*r**6+1949007265120*r**8+2023521257342*r**10
            +1082806598541*r**12+222538827708*r**14)+5*Q2**16*(116357165613+879668469959*r**2
            +3076422591869*r**4+8863774801251*r**6+18297097362975*r**8+24160370121045*r**10
            +19364496761199*r**12+8228457040721*r**14+1249829881752*r**16)-8*Q2**15*(14710456305
            +548491126893*r**2+2288804987433*r**4+6956604447357*r**6+15300061687441*r**8
            +22439433180240*r**10+23274560169813*r**12+16065757882843*r**14+5618035468992*r**16
            +442938724011*r**18)-20*Q2**14*(47184387408+3808626612*r**2-132526463277*r**4
            -450058307379*r**6-569709563899*r**8+2253353816575*r**10+4981141260915*r**12
            +2122716667205*r**14-1198888887359*r**16-461924761365*r**18+239949551700*r**20)
            +10*Q2**13*(163948926204+700052564356*r**2+3340445084119*r**4+12425740349010*r**6
            +34797907373538*r**8+84799308886582*r**10+143423197490940*r**12+146684829132930*r**14
            +84205878459026*r**16+25392993755814*r**18+5437658306077*r**20+1236864536364*r**22)
            -10*Q2**12*(92189358846+1008161948658*r**2+5859998381007*r**4+26023499020755*r**6
            +79544050302984*r**8+193363047152208*r**10+355528302566154*r**12+450432920271562*r**14
            +367999446385746*r**16+180975911922126*r**18+50049094312023*r**20+9179035915539*r**22
            +1018546273080*r**24)-20*Q2**11*(36106942482-286821414462*r**2-1471290558405*r**4
            -10933461877305*r**6-41684261713089*r**8-104915771422836*r**10-205112272680108*r**12
            -299721109886612*r**14-311178638155786*r**16-214478474112636*r**18-87984783303567*r**20
            -19680156195507*r**22-3166343516583*r**24+53369633358*r**26)+4*Q2**10*(390531358620
            +549218412344*r**2+11178098964644*r**4+8744300142621*r**6-48721654115887*r**8
            -118905995857200*r**10-230280444946674*r**12-370261470005984*r**14-490694487698716*r**16
            -522917322264918*r**18-326299064352070*r**20-55196313104701*r**22+19229191660239*r**24
            +1293187975886*r**26+2458473838068*r**28)-10*Q2**9*(86861562084+687679210476*r**2
            +8682992472795*r**4+26020973911428*r**6+59136171474176*r**8+182892541406268*r**10
            +444263978767887*r**12+799991033783428*r**14+1006927321066332*r**16+868049246253996*r**18
            +529917786886201*r**20+265634350817844*r**22+136968383938752*r**24+46486904752748*r**26
            +5210982177885*r**28+812443847940*r**30)+10*Q2**8*(-26053880229+556424854449*r**2
            +4645518384960*r**4+24735103180932*r**6+69643193393183*r**8+234906771148645*r**10
            +743347691906232*r**12+1664473475319292*r**14+2412918838557593*r**16+2284386782205171*r**18
            +1485122562911536*r**20+758498552148908*r**22+342675260171973*r**24+144450631238615*r**26
            +38559837868216*r**28+4804338407028*r**30+69179013576*r**32)+40*Q2**7*(15662624409
            -28355630323*r**2+642555964538*r**4-2320876153848*r**6-162692622708*r**8
            -3810582444360*r**10-122394649148730*r**12-449229252452912*r**14-865342873213362*r**16
            -1038615942860520*r**18-754893312237206*r**20-319293395093108*r**22-103977022139040*r**24
            -43443329804520*r**26-14209293690762*r**28-493755545508*r**30-373944036019*r**32
            +89858781579*r**34)-20*Q2**6*(15237910296+96448407492*r**2+2523330536523*r**4
            +700679347683*r**6+34886076790943*r**8+112246219885371*r**10-13714368322587*r**12
            -689128084841939*r**14-2174865122951907*r**16-3763923109361955*r**18-3876326209869255*r**20
            -2311400762497707*r**22-692621311103007*r**24-97916361206435*r**26-39114376246293*r**28
            -6921154180677*r**30+9299696134187*r**32+514474610343*r**34+138502744524*r**36)
            +2*Q2**5*(-10709963100+985816744188*r**2+12082674401853*r**4+22009412582562*r**6
            +325786960455626*r**8+1029182783542390*r**10+416698564998882*r**12-5978108829142298*r**14
            -26676213273246502*r**16-56354219723708106*r**18-71434952861006820*r**20
            -58075085048182878*r**22-29655876898561698*r**24-8601548405987582*r**26
            -1168188727219666*r**28-301864207489470*r**30-76700212805542*r**32+61255839122518*r**34
            +6806045847447*r**36+272163458196*r**38)+9*(-1+r**2)**4*(-17614095+1004080919*r**2
            +12456345925*r**4+31414759887*r**6+1133287735032*r**8-180819279128*r**10
            -1255616194552*r**12+31485884956480*r**14+88768239512314*r**16+8716867943294*r**18
            +265964327737354*r**20+662841138346022*r**22+214219872882840*r**24-250190954498064*r**26
            -132073695909184*r**28-14764673929544*r**30-2502431145139*r**32-1053094139245*r**34
            +13184603113*r**36+6713022483*r**38+184383288*r**40)+10*Q2**4*(8739219078
            -62837380258*r**2+371678148587*r**4-4475409071109*r**6-5296640517672*r**8
            -49179764534212*r**10-3869099538168*r**12+945291452878104*r**14+4018665422817344*r**16
            +7646240364248664*r**18+9919859536449590*r**20+10007237307306310*r**22
            +6773113797761076*r**24+2628000347677764*r**26+760473131418928*r**28+170401448868384*r**30
            +11771870182266*r**32-490299673142*r**34-583153154649*r**36-568322356345*r**38
            +43646273460*r**40)-90*Q2*(-1+r**2)**2*(-4150860+864271188*r**2+12219619475*r**4
            -2717980458*r**6+899039034397*r**8-324344596688*r**10-1372645613600*r**12
            +12082064069044*r**14+40473603289728*r**16+50760045445348*r**18+151287663374958*r**20
            +322150143673536*r**22+309519682501962*r**24+34699557241868*r**26-144470320435912*r**28
            -70121826701812*r**30-6822296864524*r**32-1115935010856*r**34-745726015513*r**36
            +24241296042*r**38+5066641777*r**40+245790900*r**42)-60*Q2**3*(641752722
            +3191727378*r**2+157269727473*r**4-519349766427*r**6+5441998720033*r**8
            +349880125268*r**10-5437459610946*r**12+77262414162106*r**14+237049527864506*r**16
            +144070782772506*r**18-38721392639696*r**20+8684162841620*r**22+167724168072744*r**24
            -58906139398906*r**26-340593267870686*r**28-143074335273450*r**30-495164636764*r**32
            -3256439762948*r**34-3612709436673*r**36+440594862647*r**38+1914873031*r**40
            +6084654462*r**42)+60*Q2**2*(98719308+3909724144*r**2+74473080757*r**4
            -209844501912*r**6+4303364735526*r**8-3633326935853*r**10-6354822137334*r**12
            +39815845438722*r**14+76469596843746*r**16+60945403326142*r**18+471712199196856*r**20
            +792792187508898*r**22+544029368007782*r**24+485648555162844*r**26+174468369666338*r**28
            -332512728447210*r**30-199303622158470*r**32-13239320587758*r**34-1147383809053*r**36
            -3258593865506*r**38+192157752524*r**40+17880437137*r**42+2089482372*r**44))*sqrtq2)
            +logq2**3*(138240*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-11520*Q2**25*(46467
            +506479*r**4)+192*Q2**24*(49685517+46586765*r**2+485378529*r**4+526738785*r**6)
            -2*Q2**23*(38476807443+72386033958*r**2+372290021586*r**4+737499495806*r**6
            +399836921535*r**8)+2*Q2**22*(180986828697+526215573723*r**2+1978948425336*r**4
            +5050739861136*r**6+5317206951719*r**8+1875783630285*r**10)-2*Q2**21*(531940104873
            +2215125070122*r**2+7559862580083*r**4+21543952388192*r**6+32322891638559*r**8
            +22629042570766*r**10+5653128487005*r**12)+2*Q2**20*(941367871197+5790628940487*r**2
            +20351593736061*r**4+62330453515391*r**6+115706451551211*r**8+118821004844849*r**10
            +61167231149579*r**12+10838370998745*r**14)-Q2**19*(1399555084131+18077972442945*r**2
            +69301291454727*r**4+234836152134385*r**6+499496682202465*r**8+638935973327571*r**10
            +503565602012525*r**12+204230575936427*r**14+22073814908280*r**16)+Q2**18*(
            -1817943027381+11273113537254*r**2+43618414749708*r**4+195969520523708*r**6
            +459664915286910*r**8+537602737860164*r**10+504546125896844*r**12+425436394093748*r**14
            +156573542534143*r**16-4382996582970*r**18)+Q2**17*(6027748903899+16460496049221*r**2
            +104721693154842*r**4+323889769590502*r**6+843199073459788*r**8+2276792934778544*r**10
            +3514846319781386*r**12+2545725942594002*r**14+757115663043777*r**16+136446508763443*r**18
            +49692157489620*r**20)-Q2**16*(5914726052391+47341305775854*r**2+307010279105241*r**4
            +1358865159809014*r**6+3952016567357558*r**8+9740427207169748*r**10+16932089157102674*r**12
            +17685687931326116*r**14+10112851890094819*r**16+2902980704331918*r**18
            +525027474558677*r**20+67019803829910*r**22)+4*Q2**15*(-221201155944+11587052243541*r**2
            +71947192136568*r**4+511127845123013*r**6+1765278860787453*r**8+4634245365126708*r**10
            +9013874111446638*r**12+11681521713030388*r**14+9466819272592028*r**16
            +4294054988749103*r**18+956113580568082*r**20+149420756136847*r**22+4792294962135*r**24)
            +4*Q2**14*(2018412129546-882991929405*r**2+32536313604237*r**4-280143028442685*r**6
            -1475580609983920*r**8-4404717899616801*r**10-9291561415857950*r**12-13371705439463442*r**14
            -13670296680800610*r**16-9259355904218315*r**18-3138284226597599*r**20
            -287933112460945*r**22-37073372615688*r**24+14101058618505*r**26)-4*Q2**13*(1803696637104
            +11154855632829*r**2+152318671657698*r**4+333241452607588*r**6+483718875701015*r**8
            +954238950647161*r**10+2773316932639671*r**12+8116040804736092*r**14+12457115799735582*r**16
            +8806158163360915*r**18+3221527706006624*r**20+1798619692996784*r**22
            +919581154081003*r**24+112997273491783*r**26+19230780924855*r**28)+4*Q2**12*(
            -123707823984+13200232663059*r**2+137608401476523*r**4+831670670678428*r**6
            +2804686215352377*r**8+9268474920763514*r**10+24813809631193086*r**12
            +53467292231306217*r**14+84588208572439702*r**16+87210945946086723*r**18
            +54962803985408171*r**20+21858244879333914*r**22+6774243866566753*r**24
            +1415745541258128*r**26+155574391069292*r**28+5521396114305*r**30)+2*Q2**11*(2841661777887
            -9047846440887*r**2+33237021695097*r**4-1475671603019927*r**6-5432174272694409*r**8
            -23596594837223783*r**10-71757420428192963*r**12-159397607629717327*r**14
            -277183427301274303*r**16-349856037334238901*r**18-294675844881720797*r**20
            -155207617163154437*r**22-52930512552963803*r**24-13756137082574157*r**26
            -1221075353131769*r**28-131992137411701*r**30+19231577026020*r**32)+2*Q2**10*(
            -1895694986943-10234884364818*r**2-271327210135674*r**4+233075793725426*r**6
            -1168818767390284*r**8+6599116889459412*r**10+37229185171036282*r**12
            +85354467034925894*r**14+157144035132621674*r**16+235780498650869444*r**18
            +259983560151113018*r**20+183522299607763678*r**22+67845974347445196*r**24
            +13931895759817316*r**26+3908806218514566*r**28-1110632882625686*r**30
            -89379545245931*r**32-21458493185130*r**34)+2*Q2**9*(-267295472703+14525738222715*r**2
            +201743176941444*r**4+1003560007855190*r**6+7217466532063440*r**8+14951518671312098*r**10
            +19878902703191900*r**12+59298291313532606*r**14+141989266812509370*r**16
            +208368764051609440*r**18+192207183258271468*r**20+114644246405459890*r**22
            +73949794709290856*r**24+68391806321413630*r**26+34148984788999220*r**28
            +6372523249799162*r**30+1750761714447245*r**32+153411085000069*r**34+4385773344960*r**36)
            +2*Q2**8*(1002318073947-5897144549358*r**2+11071788860199*r**4-1256020545339236*r**6
            -5273892253105790*r**8-18400772533421902*r**10-36895107253811062*r**12
            -129596423513864894*r**14-379255398926789944*r**16-680030789304110970*r**18
            -781954247148533592*r**20-597701564283977782*r**22-331722623198550114*r**24
            -175867515869564074*r**26-101157767961885930*r**28-38596644633744778*r**30
            -8728643116025923*r**32-710520470090016*r**34-75825657378671*r**36+7012190881890*r**38)
            +2*Q2**7*(-431792757513-2592468916272*r**2-106178165158074*r**4+529239990448616*r**6
            -1470262564224191*r**8+8963659437960988*r**10+3321968037692692*r**12+47386932173660444*r**14
            +338440315818060634*r**16+841495958245670076*r**18+1200255873133920128*r**20
            +1067413965085120332*r**22+569448770377791814*r**24+210706417702215284*r**26
            +102498857745288236*r**28+48051554961741812*r**30+6639633564279823*r**32
            +4095201086636516*r**34-336526100886534*r**36-12159409571396*r**38-5689333853415*r**40)
            +2*Q2**6*(-107046843633+4042100508543*r**2+61265352427062*r**4+274196537498018*r**6
            +4306511371135641*r**8-2536205221105323*r**10+40834130961687792*r**12
            +103092194064979888*r**14-96147291504373178*r**16-692061820082134586*r**18
            -1515252010924637956*r**20-1988364247027081228*r**22-1506595388748351662*r**24
            -543934620167957238*r**26-71052922730813856*r**28-49822718710204032*r**30
            -23391741239581477*r**32+13695376374634187*r**34+838377272943998*r**36
            +506841808244026*r**38+37638505501669*r**40+764418003345*r**42)+2*Q2**5*(159750321237
            -1539756059808*r**2-1730407983729*r**4-451743304723744*r**6-1918237585029619*r**8
            -398815114058568*r**10-47728450569314153*r**12-131756729475763816*r**14
            +36997535757080474*r**16+729004905864813944*r**18+2101421340044682734*r**20
            +3505267426183172344*r**22+3658531440687984914*r**24+2383636038824826184*r**26
            +819652510944423894*r**28+88247543650994888*r**30+34962492602671153*r**32
            +25849301175883336*r**34-7915415868485789*r**36-2111627050764344*r**38
            -199872976169791*r**40-20245319477536*r**42+1095723375795*r**44)+9*(
            -1+r**2)**4*(51908001-214743650*r**2+142792157*r**4-557308468990*r**6
            -434832905245*r**8-3268292614314*r**10-251307983736105*r**12+508902007713402*r**14
            +201904465051690*r**16-7819759299371140*r**18-4640754913417214*r**20+12732886006535940*r**22
            -26653101445455898*r**24-40789096276732580*r**26+7254950130957390*r**28
            +14882046493594116*r**30+2520481072737285*r**32+45168064175462*r**34+183130571765425*r**36
            +14117253093370*r**38-1446093768089*r**40-166034865970*r**42-11171816373*r**44
            +474771330*r**46)-2*Q2**4*(41227302393+254130254685*r**2+13447277399151*r**4
            -183742940771825*r**6+561072406692805*r**8-3217051494294227*r**10-10159431288912525*r**12
            -39886526208884729*r**14+94352807800936810*r**16+605358278108397810*r**18
            +1664809945445657398*r**20+2778678834753689590*r**22+3146974372612017706*r**24
            +2552293065327618170*r**26+1435814746142349590*r**28+545107962349257438*r**30
            +103043274618209405*r**32+10008862982303921*r**34+4658734473028155*r**36
            +1393118427404795*r**38-1033869449586127*r**40+23316758656345*r**42-1653022931049*r**44
            +628601004315*r**46)-9*Q2*(-1+r**2)**2*(576093069-5713172491*r**2-24819731297*r**4
            -4498830759877*r**6-7826431760925*r**8+27838543058639*r**10-1813054245734011*r**12
            +2675181177886873*r**14+4707856453448598*r**16-30834188671602990*r**18
            -53073488232308906*r**20+14284864619791854*r**22-46901558727691162*r**24
            -230278682128506082*r**26-158196248109043030*r**28+72930555987750994*r**30
            +79842718338133289*r**32+11274489401592393*r**34-474631789604997*r**36
            +1259308677390855*r**38+63522885343079*r**40-11029358566141*r**42-1522871291807*r**44
            -117905578267*r**46+4112462340*r**48)+3*Q2**3*(-8480260737+305541433773*r**2
            +4362098396911*r**4+20933529488701*r**6+520739885981225*r**8-2315064031013197*r**10
            +16137249186524913*r**12-3560079870648789*r**14-1269770765245434*r**16
            +137217310833474290*r**18+305677038625347238*r**20+48059488735024498*r**22
            -145394578373105374*r**24+112453826606248246*r**26+53721604646930*r**28
            -432311722068773562*r**30-233440104667645077*r**32+8452124373176721*r**34
            +5588040373835131*r**36-12205180540024255*r**38+1328544506652133*r**40
            -64256798776857*r**42+38301701516781*r**44+2475503075231*r**46+48205870560*r**48)
            +3*Q2**2*(7060714473-119173221078*r**2-829214999736*r**4-37578238516656*r**6
            -145907518056034*r**8+978616118003868*r**10-15661501605522488*r**12+21966181969102264*r**14
            +31142256466603299*r**16-128561069644784154*r**18-230323290947542832*r**20
            -87113138973087168*r**22-366995393141842476*r**24-528429690173073336*r**26
            -815402278871718384*r**28-700320786431750192*r**30+340494729566731487*r**32
            +425178520357324854*r**34+48697521411906024*r**36-13233107788210384*r**38
            +10638566355615918*r**40+28479517017372*r**42-64479002013656*r**44-17483270832456*r**46
            -1478041425419*r**48+30839176890*r**50))+138240*r**12*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(11520*Q2**26*(46467+506479*r**4)-192*Q2**25*(52473537
            +49374785*r**2+515767269*r**4+557127525*r**6)+10*Q2**24*(8649323415+16325634606*r**2
            +84671737962*r**4+166932551590*r**6+90080768979*r**8)-8*Q2**23*(54865909035
            +159269603781*r**2+605906120220*r**4+1540132344632*r**6+1613635842265*r**8
            +568905137955*r**10)+4*Q2**22*(356463466785+1461163736271*r**2+5032513289571*r**4
            +14286820337332*r**6+21345419225707*r**8+14911016576385*r**10+3764456058645*r**12)
            -4*Q2**21*(736653988035+4268847057741*r**2+15063290693133*r**4+45717134241833*r**6
            +84786647788981*r**8+86886469527087*r**10+44724701103675*r**12+8245749742875*r**14)
            +Q2**20*(3282290826525+31541966066313*r**2+121585736807823*r**4+400200246637289*r**6
            +855570492335669*r**8+1107990886119691*r**10+863542074001381*r**12+348241780233075*r**14
            +43750556905770*r**16)-10*Q2**19*(-41838794325+3075064106433*r**2+13099767864738*r**4
            +50010696411282*r**6+119399774962376*r**8+167603539339020*r**10+164704770123694*r**12
            +113323257204270*r**14+38287793337885*r**16+1769081832531*r**18)-2*Q2**18*(3922845965640
            +3502662769674*r**2+24915082433940*r**4+42150917158543*r**6+93782318824585*r**8
            +639762640815735*r**10+1236348728012189*r**12+807871711301705*r**14+87552863207943*r**16
            -7872018593865*r**18+27037577036295*r**20)+2*Q2**17*(5971237478145+34914775364487*r**2
            +214096234154652*r**4+893738311277179*r**6+2559552705203924*r**8+6430209607704040*r**10
            +11361864205831302*r**12+11873130096850752*r**14+6707846747866299*r**16
            +1898271438069569*r**18+355583070405870*r**20+58355980659765*r**22)-Q2**16*(5029921428615
            +99604240802409*r**2+642140353427367*r**4+3710386819406307*r**6+12371997170316384*r**8
            +32229425235034138*r**10+62728012810058974*r**12+81343863940550342*r**14
            +65665816911789047*r**16+30192052549423149*r**18+7252462501162923*r**20
            +1189730302935975*r**22+86188983678450*r**24)+8*Q2**15*(-1119806642745
            +6124421508501*r**2+25498965387936*r**4+431609032851133*r**6+1875993657947193*r**8
            +5402121062765481*r**10+11469840446215648*r**12+17033550631970234*r**14
            +17409318833211513*r**16+11510115082779723*r**18+4194226397957392*r**20
            +696733724582937*r**22+95643211857335*r**24-4654381828185*r**26)+40*Q2**14*(382210876665
            +1229027583297*r**2+18397199333253*r**4+8563473776914*r**6-127200476272559*r**8
            -492605955895356*r**10-1092296238283508*r**12-1454722605058530*r**14-1458488632052847*r**16
            -1412349442165801*r**18-917611242480929*r**20-162759764606176*r**22+59457466900437*r**24
            +9002495949460*r**26+3333183954336*r**28)-8*Q2**13*(839994406560+13079392466496*r**2
            +150540964383525*r**4+658615397471857*r**6+1810823271830490*r**8+5353216373555845*r**10
            +14270682757239959*r**12+32178324984340990*r**14+52580682588455688*r**16
            +54237109954591610*r**18+33495244927387855*r**20+13439196139168661*r**22
            +4746222356822270*r**24+1224161984415457*r**26+143901222742965*r**28+12376088519580*r**30)
            +2*Q2**12*(-3089077425855+35200896119037*r**2+268380246584067*r**4+3414229747329829*r**6
            +12704888044756019*r**8+47742917109455565*r**10+139921989532106163*r**12
            +315959811354715933*r**14+553294428908766141*r**16+693454346371291751*r**18
            +579023344744710585*r**20+308849714892638607*r**22+110195490044765137*r**24
            +30136115898223919*r**26+4363715217786609*r**28+454183711778895*r**30
            -8188784797410*r**32)+4*Q2**11*(2368678382415+2014349850909*r**2+147758192694942*r**4
            -837755187525128*r**6-2869513554162026*r**8-17813942999688802*r**10-66291600218226514*r**12
            -158254747546418092*r**14-296862535031806652*r**16-431409981643191324*r**18
            -452257721183536358*r**20-316702880826319456*r**22-137992052031781718*r**24
            -40309272697677638*r**26-9443009327110246*r**28-121217303958892*r**30
            -11690507569875*r**32+20345035105575*r**34)-4*Q2**10*(814199757120+13328158787238*r**2
            +241652635720968*r**4+520905712132719*r**6+4076604752864149*r**8+4760610274621485*r**10
            -11974699678651897*r**12-31642680446214785*r**14-50254617677519099*r**16
            -92277884865940839*r**18-151778437771855497*r**20-164430806676708403*r**22
            -88709239622959009*r**24-6693031892924441*r**26+8154141405333669*r**28
            +1787174956955141*r**30+1475387071159431*r**32+132124561715565*r**34+12922133265045*r**36)
            -20*Q2**9*(126961354665-2015558729937*r**2-20519712630396*r**4-246132373013587*r**6
            -1349491879302442*r**8-4056975773679744*r**10-7172552862831506*r**12-20877361753058940*r**14
            -58054295705283192*r**16-103038882016822978*r**18-118253019445841450*r**20
            -90455299394770914*r**22-52031666431330086*r**24-31820911690026856*r**26
            -20369855907229878*r**28-7911815267254316*r**30-1685192808027233*r**32
            -261469326953733*r**34-23362251572370*r**36+262641753693*r**38)+2*Q2**8*(1434110831460
            -2302357559139*r**2+111352809468915*r**4-1774188746927653*r**6-5059650234220835*r**8
            -32638324224488680*r**10-58617847824925656*r**12-213878462941336400*r**14
            -847292138258715472*r**16-1900782146476570990*r**18-2662240909586564690*r**20
            -2447069776517631706*r**22-1498872957860319710*r**24-718296556770329472*r**26
            -379524141576738240*r**28-187805967557372520*r**30-53964921314050524*r**32
            -13534364672752455*r**34-449820026582153*r**36-56654056925385*r**38+12701524735305*r**40)
            -8*Q2**7*(81186478470+1766590545582*r**2+42508996625352*r**4-37216321948131*r**6
            +1311883486227804*r**8-2507400523710530*r**10+7137125871508528*r**12+13095823463406688*r**14
            -120493634874023564*r**16-467999523536466324*r**18-889250960576057040*r**20
            -1064008521311530422*r**22-785864531052815952*r**24-331022452061991084*r**26
            -96064549544579344*r**28-50093282854308520*r**30-19520732441400778*r**32
            +740135430929462*r**34-730074428201496*r**36+213881829675489*r**38+13871812231620*r**40
            +1613437964190*r**42)-4*Q2**6*(133398582435-2737404862359*r**2-33518930459667*r**4
            -393602597324412*r**6-3249472746831639*r**8-1084560632044443*r**10-43013188154948311*r**12
            -137841527251215748*r**14+15026316598236882*r**16+758607008725660854*r**18
            +2154367585525727638*r**20+3504441842067445764*r**22+3576745538231708902*r**24
            +2217083023870567542*r**26+717320026921597494*r**28+104561592546006388*r**30
            +54088476276228331*r**32+17772833020415313*r**34-11224584758031987*r**36
            -1728423065976184*r**38-372176644957743*r**40-29324121491275*r**42+165652686225*r**44)
            +4*Q2**5*(100488811815-562937741943*r**2+5088556677807*r**4-318608326739649*r**6
            -904454241530279*r**8-2767052096691207*r**10-29143348486142623*r**12-109685853126981349*r**14
            -203192958873266*r**16+685680359865146114*r**18+2247618095677577038*r**20
            +4192683800490772334*r**22+5155386619741587482*r**24+4297230272420214634*r**26
            +2319551647955799834*r**28+726504008472338110*r**30+113126655435937723*r**32
            +35410328380429205*r**34+11296309890212851*r**36-4316962245922669*r**38
            -1672684738260131*r**40-98400768495491*r**42-10401309516395*r**44+862162190055*r**46)
            +9*(-1+r**2)**4*(51908001-162835649*r**2-71951493*r**4-557165676833*r**6
            -992141374235*r**8-3703125519559*r**10-254576276350419*r**12+257594023977297*r**14
            +710806472765092*r**16-7617854834319450*r**18-12460514212788354*r**20
            +8092131093118726*r**22-13920215438919958*r**24-67442197722188478*r**26
            -33534146145775190*r**28+22136996624551506*r**30+17402527566331401*r**32
            +2565649136912747*r**34+228298635940887*r**36+197247824858795*r**38+12671159325281*r**40
            -1612128634059*r**42-177206682343*r**44-10697045043*r**46+474771330*r**48)
            -5*Q2**4*(11402764515+301467883095*r**2+8097822099681*r**4-55558147655849*r**6
            +463375717957127*r**8-2451430053648487*r**10+4331756398632247*r**12-22154430921508175*r**14
            +21024650177673572*r**16+362214820863818422*r**18+1091473512596830426*r**20
            +1806231205320753494*r**22+2283024535922419694*r**24+2347179271139603298*r**26
            +1595275357550775262*r**28+532982050155378674*r**30+119196431986399691*r**32
            +50292129664111363*r**34+9219863206433909*r**36-4902367163841373*r**38
            +940826295118747*r**40-442775155638027*r**42+31646515200187*r**44+1075533074445*r**46
            +280363924062*r**48)-18*Q2*(-1+r**2)**2*(314000535-2727819537*r**2-14954358165*r**4
            -2540729644064*r**6-5822667847955*r**8+8528088012450*r**10-1015210967044047*r**12
            +935188307362080*r**14+3157915048612126*r**16-16920499219957755*r**18
            -36353504376767570*r**20-12296993539258912*r**22-44688161239922150*r**24
            -125965124117741044*r**26-163147444499291230*r**28-62841321083172640*r**30
            +66392306271195363*r**32+50501730076010345*r**34+6706566564069591*r**36
            +238850530761920*r**38+738140767272265*r**40+34668466270258*r**42-6838712855235*r**44
            -891996665984*r**46-62957237480*r**48+2293616835*r**50)+6*Q2**3*(-7770487605
            +208117197057*r**2+2748427415210*r**4+31436933201134*r**6+343790466762980*r**8
            -1386470131517920*r**10+14741843380517102*r**12-4694506326613070*r**14
            -17986053551248761*r**16+132254304856506505*r**18+336608820203182180*r**20
            +220424833166729452*r**22+134830151751880800*r**24+247744469203108104*r**26
            +463954913541306780*r**28+134031392983811780*r**30-503123278151575063*r**32
            -325083250325896605*r**34-17328678332447086*r**36+3307983811010630*r**38
            -10757601194494020*r**40+617904095428952*r**42+19261952376790*r**44+29130237712234*r**46
            +2000875185605*r**48+8683346835*r**50)+6*Q2**2*(4394496840-66354291246*r**2
            -493420050276*r**4-25886083462857*r**6-90023263245047*r**8+474843163704835*r**10
            -10156279389177631*r**12+12646032500410189*r**14+22870878995764043*r**16
            -105071487190010397*r**18-159488061949644985*r**20-24321736341104986*r**22
            -419871430356840486*r**24-630998591737455762*r**26-288726648391978902*r**28
            -519294977535737830*r**30-516234991052126946*r**32+269616038031643384*r**34
            +322166682502630698*r**36+37956799299137683*r**38-5691860104862675*r**40
            +7015373258524479*r**42+108088354277189*r**44-53133418764247*r**46-11405077638337*r**48
            -912796878685*r**50+21588281955*r**52))*sqrtq2)+logq2**2*(2304*r**8*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-1536*Q2**28*(1009621
            +10222729*r**4)+96*Q2**27*(276242513+267870673*r**2+2659364597*r**4+2844303157*r**6)
            -4*Q2**26*(49566263727+98361673950*r**2+523404094330*r**4+1026118745750*r**6
            +529298965323*r**8)+8*Q2**25*(104983573977+327960936459*r**2+1366074300022*r**4
            +3586589615388*r**6+3646316376421*r**8+1188443112333*r**10)-4*Q2**24*(532643657325
            +2471417022720*r**2+9359827487534*r**4+29639494875775*r**6+44064368532056*r**8
            +29695073838585*r**10+6626033221125*r**12)+4*Q2**23*(717934743870+5559905692830*r**2
            +19613697609011*r**4+74121026388516*r**6+143213227183934*r**8+145479307069904*r**10
            +73614434522425*r**12+10884744569430*r**14)-Q2**22*(42324475665+26322167970795*r**2
            +65206894758521*r**4+349427642996471*r**6+853811770538115*r**8+1083695665305009*r**10
            +926333143373779*r**12+404617839245245*r**14+25071670773360*r**16)-2*Q2**21*(3646766886255
            +765230189490*r**2+68757972207158*r**4+193719281718360*r**6+424246786295632*r**8
            +1015653044481268*r**10+962612563292370*r**12+171238237643432*r**14-38596242207015*r**16
            +28875552043770*r**18)+3*Q2**20*(4076916431415+20248245155095*r**2+174083196620168*r**4
            +850492632424684*r**6+2512990363399582*r**8+5885523451820690*r**10+8084520924741088*r**12
            +5578935071014516*r**14+1664764195969867*r**16+281231349470135*r**18+49989185557560*r**20)
            -2*Q2**19*(2256332010150+49136967891240*r**2+327218726744053*r**4+2600778437446810*r**6
            +9401840049581382*r**8+25429563467078290*r**10+43435687257793120*r**12
            +42974716293872598*r**14+22636910967469540*r**16+5355579618956902*r**18
            +829884133937595*r**20+58738039986000*r**22)+Q2**18*(-12915648117735+52788330074595*r**2
            -57706492693111*r**4+4895456387627479*r**6+23805404238625586*r**8+78015513360752354*r**10
            +159345942464937070*r**12+197698322935943306*r**14+150746568886252289*r**16
            +60897709283183371*r**18+9014665923359321*r**20+1171265687285775*r**22
            -76915563470940*r**24)+2*Q2**17*(10052933064465+29407882042050*r**2+680288773652557*r**4
            +756591065133802*r**6-2133786913978420*r**8-17746680317320254*r**10-47832300587477374*r**12
            -58165103122350376*r**14-50260706372249391*r**16-35298013611684670*r**18
            -7846488983966767*r**20+2796252424437118*r**22+367941720204530*r**24+120854178407610*r**26)
            -Q2**16*(5223769159005+135488837138205*r**2+1794052587910236*r**4+11168975041142500*r**6
            +39519263026257029*r**8+116629117254175857*r**10+263981271602542620*r**12
            +565771656113607520*r**14+809142635954165415*r**16+628324790681088543*r**18
            +266767591879981996*r**20+91624655698126460*r**22+22218909712584119*r**24
            +2339429318203795*r**26+158915772459420*r**28)-16*Q2**15*(930831729540
            -6072518434665*r**2-20633388148464*r**4-904722239352097*r**6-4000841045801056*r**8
            -17584638282539777*r**10-49264580032013938*r**12-111478379913990329*r**14
            -183055622277511586*r**16-189245683600750117*r**18-113439981404580398*r**20
            -39106605599792629*r**22-10378148616232978*r**24-1261281897605241*r**26
            -115510107530400*r**28+5788757197335*r**30)+2*Q2**14*(8031358121475+11176309076985*r**2
            +872728733691067*r**4-2466222276881195*r**6-10008097492446457*r**8-129124811452103195*r**10
            -482383346478963665*r**12-1228349802720319327*r**14-2293488533510572575*r**16
            -2893494069335186893*r**18-2333956611646494775*r**20-1065049657672462265*r**22
            -250927637111116523*r**24-52083162552281905*r**26+1486812026958253*r**28
            +145465619459555*r**30+106573237524000*r**32)-4*Q2**13*(123744802935+26671572982770*r**2
            +507450190098904*r**4+2595294444152324*r**6+15938138840502656*r**8+3508878433748832*r**10
            -89642351694100960*r**12-285594708253089340*r**14-583980232550977794*r**16
            -767836996516557756*r**18-753786097375149320*r**20-501958568231191140*r**22
            -96954591916003672*r**24+47024567022940544*r**26+14159154163338576*r**28
            +5580584459318556*r**30+454632019197475*r**32+22944520630890*r**34)+2*Q2**12*(
            -4916904582015+40823379021945*r**2+134647731529832*r**4+8146588019853972*r**6
            +44571751435520980*r**8+166804766938315504*r**10+374389350944181944*r**12
            +1044610712559348892*r**14+2430122870372571502*r**16+4647381956440328570*r**18
            +6175761557148316528*r**20+4971177870116156428*r**22+2604600535924561316*r**24
            +1203865909048370296*r**26+385843798447615480*r**28+78771488099336388*r**30
            +8465407813783193*r**32+693889031378085*r**34-37497423924360*r**36)+4*Q2**11*(1479889091070
            +1566535904280*r**2+318178767909201*r**4-1869684708551070*r**6-5384742716140746*r**8
            -107904509500141302*r**10-308811263059874810*r**12-1053523410787447382*r**14
            -2701302299698735950*r**16-5323690971282318206*r**18-8087886650832069944*r**20
            -8412518990080064010*r**22-5559415794025407758*r**24-2490811652809858130*r**26
            -898135388605945398*r**28-153088377436970754*r**30-27665050934162520*r**32
            +628138216500654*r**34+15674107487895*r**36+24727276788480*r**38)-2*Q2**10*(
            -802168423395+27776443402425*r**2+526841358526403*r**4+2575790329730429*r**6
            +26950917353861322*r**8-107202916828788712*r**10-131621162648008056*r**12
            -1131487491928421824*r**14-3968689566711594870*r**16-8033679907350388998*r**18
            -13677233955174966850*r**20-17852455176067500822*r**22-15386942067849415380*r**24
            -7710091599337720096*r**26-2651364056082789984*r**28-961637815641762568*r**30
            +17905076517091473*r**32+3323484766500821*r**34+5979675476923607*r**36
            +424413605863905*r**38+10296298431570*r**40)+4*Q2**9*(-798999273825+8536328678880*r**2
            -1731964385789*r**4+2222690156534510*r**6+14104896654575254*r**8+38496130270009720*r**10
            +279274133343357420*r**12+335420979746254124*r**14-10417923066546070*r**16
            +671961488656295356*r**18+1481952124285193330*r**20+1043021083804965800*r**22
            -369435493662907616*r**24-399928468669907380*r**26+1153147020104287916*r**28
            +1002498527811595860*r**30+210859837898558575*r**32+106661009174169556*r**34
            +17822202802979315*r**36+1613777358404074*r**38+137869856321490*r**40
            -7692705160500*r**42)+2*Q2**8*(399332883585+2726414081235*r**2+230950614665992*r**4
            -1877834679804738*r**6-5535139573510727*r**8-174509252050037685*r**10
            -498360610060590870*r**12-1117427388145977384*r**14-1861335287152707942*r**16
            -8140297695899533378*r**18-19590905676419864392*r**20-27696945367117054460*r**22
            -25554374061203766638*r**24-15439457421852476122*r**26-8145703671504321108*r**28
            -6275769870603249096*r**30-3241438476763302555*r**32-1035825759700259985*r**34
            -148915017620914448*r**36-26559225166718162*r**38+619040255932213*r**40
            +12928838917775*r**42+11318049928890*r**44)-4*Q2**7*(-166219751610+4156295210610*r**2
            +55877351034599*r**4+393240597064544*r**6+4437389863177110*r**8-53543679290787636*r**10
            +81947180984619329*r**12-363275530407422142*r**14-322417075504273292*r**16
            -2848870816802338860*r**18-11281924745501616722*r**20-20134843698416591312*r**22
            -21657012667577992188*r**24-14505013053531996088*r**26-6271495498860757110*r**28
            -2979780544485772508*r**30-1765777469214429978*r**32-317734601224882294*r**34
            -315383840375606949*r**36-268641877704640*r**38-1759725493001274*r**40
            +724879938056476*r**42+55747242547525*r**44+188855614410*r**46)+Q2**6*(
            -448602736965+6264557581545*r**2-40842945039661*r**4+2377272589613565*r**6
            +15809171146727821*r**8+34743427151667631*r**10+843847187526962925*r**12
            -1322163144328382653*r**14+5554926141755553070*r**16+9422690938393362282*r**18
            -22229741896089116338*r**20-69878556799342019310*r**22-109659248894651724630*r**24
            -106982471212792655730*r**26-48271620797967534262*r**28-3515970099453498282*r**30
            -5280707652689019785*r**32-5393794878388621987*r**34+2260361819165853615*r**36
            -24798506810065631*r**38+119932987475894329*r**40+16076230080121875*r**42
            +1094793093938681*r**44+109946470860855*r**46-5708630922960*r**48)+2*Q2**5*(2835084765
            +927589194390*r**2+34995600718222*r**4-393969307121584*r**6-2640453263408112*r**8
            -60889311387497372*r**10-107861896836580702*r**12+269869729998590160*r**14
            -4763931430083971931*r**16-7706628904487951934*r**18+10393090865252679276*r**20
            +40176532999860453376*r**22+85044349168254680648*r**24+117783334981823459832*r**26
            +102709788586830643684*r**28+46773345294358177664*r**30+2525849275724804919*r**32
            +344020236992234586*r**34+3005145061218343590*r**36-436812806340796368*r**38
            -200266437300033368*r**40-35131827685390108*r**42-6268898351427366*r**44
            +60066117041968*r**46+2559341270855*r**48+1248578000910*r**50)+9*(-1
            +r**2)**4*(-31560249+1027478251*r**2+8027559110*r**4+77302658390*r**6
            -5509235651460*r**8-64991336955960*r**10+372793362522150*r**12-2982139280691790*r**14
            -18248380303756085*r**16+91543974167454515*r**18-150564533178764920*r**20
            -548605719328154660*r**22+522702010066510960*r**24+428577757892492040*r**26
            -1900250295359184660*r**28-679639781235923740*r**30+722590527614286445*r**32
            +278105222285476385*r**34-12217228391200010*r**36+11656982209650990*r**38
            +2541809007671700*r**40+29693886549360*r**42-27759788170290*r**44-4022268478710*r**46
            -18721163135*r**48+7452983169*r**50+172362204*r**52)+Q2**4*(77664798825
            -2118404949255*r**2-15622754225736*r**4-216790980335180*r**6-407263172527114*r**8
            +56871303853980930*r**10-262907781309749360*r**12+879588276751450604*r**14
            +3227440663829289435*r**16+1374831433466290191*r**18-25025451290006881800*r**20
            -67180262688199226040*r**22-157859788560212481596*r**24-231065107144343436100*r**26
            -206512959441800660064*r**28-147303946115276530280*r**30-84079661239715536945*r**32
            -17659018865327487801*r**34+644592559130571240*r**36-968112383623490364*r**38
            -748084257389114010*r**40+233398996927554850*r**42+4010321238253904*r**44
            +2693192475169980*r**46-221359547118899*r**48-25495416522415*r**50+95976513000*r**52)
            -18*Q2*(-1+r**2)**2*(-115497381+4163653748*r**2+48337094024*r**4-272226661870*r**6
            -21182269019000*r**8-260258780235420*r**10+980948761374810*r**12-4862938445395040*r**14
            -81347769808772045*r**16+271482484956342000*r**18-104084403607046410*r**20
            -1564368421171522270*r**22-252309021509087480*r**24+1839473131980761480*r**26
            -2139929856673069500*r**28-5312089125035091440*r**30-517929338382332655*r**32
            +2229789805242225940*r**34+652666631701953780*r**36-85340358608562250*r**38
            +44007402729366320*r**40+6264013206109140*r**42+58873483166850*r**44-119758943340720*r**46
            -18601207969375*r**48-114638367544*r**50+19531189102*r**52+1392733206*r**54)
            -6*Q2**3*(3806473074-69335489720*r**2+1072702953447*r**4-42187757624434*r**6
            -271776221710126*r**8-719722645788538*r**10-26941327461965980*r**12+160636810178329978*r**14
            -802015244273465224*r**16+324408066388477194*r**18+251308333411268227*r**20
            -3212311729757194740*r**22-5220191209924330492*r**24+963238241651633276*r**26
            +85291273361575424*r**28-414465146281949068*r**30+9268611599523338050*r**32
            +5990416805731303388*r**34-597653938820870019*r**36-747053031889514426*r**38
            +568274830038940362*r**40-77044159172040610*r**42+9984889665654428*r**44
            -2316806875232974*r**46-244373089434316*r**48-12238976247182*r**50-1624110406375*r**52
            +70821317376*r**54)+3*Q2**2*(-720550641+49479585629*r**2+1338245412359*r**4
            -25040933157991*r**6-364217698717230*r**8-4118002256473470*r**10+2829901581364110*r**12
            +56549089177804090*r**14-1566701861976499535*r**16+3816540932992591795*r**18
            +395331830138620865*r**20-13772272992222834505*r**22-8646600867114846400*r**24
            +5181561445860596700*r**26-1270940117715172380*r**28-25045781423258398740*r**30
            -46784021866643043935*r**32-1780949068994281805*r**34+24300677553754845145*r**36
            +6251357047907578295*r**38-2213074626710563030*r**40+835578001710258050*r**42
            +27465596930394030*r**44+4257054308598330*r**46-2396781380271105*r**48
            -394857990781859*r**50-4555271366849*r**52-284392535399*r**54+51959845476*r**56))
            -2304*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1536*Q2**28*(1009621
            +10222729*r**4)-96*Q2**27*(276242513+267870673*r**2+2659364597*r**4+2844303157*r**6)
            +4*Q2**26*(49566263727+98361673950*r**2+523404094330*r**4+1026118745750*r**6
            +529298965323*r**8)-8*Q2**25*(104983573977+327960936459*r**2+1366074300022*r**4
            +3586589615388*r**6+3646316376421*r**8+1188443112333*r**10)+4*Q2**24*(532643657325
            +2471417022720*r**2+9359827487534*r**4+29639494875775*r**6+44064368532056*r**8
            +29695073838585*r**10+6626033221125*r**12)-4*Q2**23*(717934743870+5559905692830*r**2
            +19613697609011*r**4+74121026388516*r**6+143213227183934*r**8+145479307069904*r**10
            +73614434522425*r**12+10884744569430*r**14)+Q2**22*(42324475665+26322167970795*r**2
            +65206894758521*r**4+349427642996471*r**6+853811770538115*r**8+1083695665305009*r**10
            +926333143373779*r**12+404617839245245*r**14+25071670773360*r**16)+2*Q2**21*(3646766886255
            +765230189490*r**2+68757972207158*r**4+193719281718360*r**6+424246786295632*r**8
            +1015653044481268*r**10+962612563292370*r**12+171238237643432*r**14-38596242207015*r**16
            +28875552043770*r**18)-3*Q2**20*(4076916431415+20248245155095*r**2+174083196620168*r**4
            +850492632424684*r**6+2512990363399582*r**8+5885523451820690*r**10+8084520924741088*r**12
            +5578935071014516*r**14+1664764195969867*r**16+281231349470135*r**18+49989185557560*r**20)
            +2*Q2**19*(2256332010150+49136967891240*r**2+327218726744053*r**4+2600778437446810*r**6
            +9401840049581382*r**8+25429563467078290*r**10+43435687257793120*r**12
            +42974716293872598*r**14+22636910967469540*r**16+5355579618956902*r**18
            +829884133937595*r**20+58738039986000*r**22)+Q2**18*(12915648117735-52788330074595*r**2
            +57706492693111*r**4-4895456387627479*r**6-23805404238625586*r**8-78015513360752354*r**10
            -159345942464937070*r**12-197698322935943306*r**14-150746568886252289*r**16
            -60897709283183371*r**18-9014665923359321*r**20-1171265687285775*r**22
            +76915563470940*r**24)-2*Q2**17*(10052933064465+29407882042050*r**2+680288773652557*r**4
            +756591065133802*r**6-2133786913978420*r**8-17746680317320254*r**10-47832300587477374*r**12
            -58165103122350376*r**14-50260706372249391*r**16-35298013611684670*r**18
            -7846488983966767*r**20+2796252424437118*r**22+367941720204530*r**24+120854178407610*r**26)
            +Q2**16*(5223769159005+135488837138205*r**2+1794052587910236*r**4+11168975041142500*r**6
            +39519263026257029*r**8+116629117254175857*r**10+263981271602542620*r**12
            +565771656113607520*r**14+809142635954165415*r**16+628324790681088543*r**18
            +266767591879981996*r**20+91624655698126460*r**22+22218909712584119*r**24
            +2339429318203795*r**26+158915772459420*r**28)+16*Q2**15*(930831729540
            -6072518434665*r**2-20633388148464*r**4-904722239352097*r**6-4000841045801056*r**8
            -17584638282539777*r**10-49264580032013938*r**12-111478379913990329*r**14
            -183055622277511586*r**16-189245683600750117*r**18-113439981404580398*r**20
            -39106605599792629*r**22-10378148616232978*r**24-1261281897605241*r**26
            -115510107530400*r**28+5788757197335*r**30)+2*Q2**14*(-8031358121475-11176309076985*r**2
            -872728733691067*r**4+2466222276881195*r**6+10008097492446457*r**8+129124811452103195*r**10
            +482383346478963665*r**12+1228349802720319327*r**14+2293488533510572575*r**16
            +2893494069335186893*r**18+2333956611646494775*r**20+1065049657672462265*r**22
            +250927637111116523*r**24+52083162552281905*r**26-1486812026958253*r**28
            -145465619459555*r**30-106573237524000*r**32)+4*Q2**13*(123744802935+26671572982770*r**2
            +507450190098904*r**4+2595294444152324*r**6+15938138840502656*r**8+3508878433748832*r**10
            -89642351694100960*r**12-285594708253089340*r**14-583980232550977794*r**16
            -767836996516557756*r**18-753786097375149320*r**20-501958568231191140*r**22
            -96954591916003672*r**24+47024567022940544*r**26+14159154163338576*r**28
            +5580584459318556*r**30+454632019197475*r**32+22944520630890*r**34)+2*Q2**12*(4916904582015
            -40823379021945*r**2-134647731529832*r**4-8146588019853972*r**6-44571751435520980*r**8
            -166804766938315504*r**10-374389350944181944*r**12-1044610712559348892*r**14
            -2430122870372571502*r**16-4647381956440328570*r**18-6175761557148316528*r**20
            -4971177870116156428*r**22-2604600535924561316*r**24-1203865909048370296*r**26
            -385843798447615480*r**28-78771488099336388*r**30-8465407813783193*r**32
            -693889031378085*r**34+37497423924360*r**36)-4*Q2**11*(1479889091070+1566535904280*r**2
            +318178767909201*r**4-1869684708551070*r**6-5384742716140746*r**8-107904509500141302*r**10
            -308811263059874810*r**12-1053523410787447382*r**14-2701302299698735950*r**16
            -5323690971282318206*r**18-8087886650832069944*r**20-8412518990080064010*r**22
            -5559415794025407758*r**24-2490811652809858130*r**26-898135388605945398*r**28
            -153088377436970754*r**30-27665050934162520*r**32+628138216500654*r**34
            +15674107487895*r**36+24727276788480*r**38)+2*Q2**10*(-802168423395+27776443402425*r**2
            +526841358526403*r**4+2575790329730429*r**6+26950917353861322*r**8-107202916828788712*r**10
            -131621162648008056*r**12-1131487491928421824*r**14-3968689566711594870*r**16
            -8033679907350388998*r**18-13677233955174966850*r**20-17852455176067500822*r**22
            -15386942067849415380*r**24-7710091599337720096*r**26-2651364056082789984*r**28
            -961637815641762568*r**30+17905076517091473*r**32+3323484766500821*r**34
            +5979675476923607*r**36+424413605863905*r**38+10296298431570*r**40)+4*Q2**9*(798999273825
            -8536328678880*r**2+1731964385789*r**4-2222690156534510*r**6-14104896654575254*r**8
            -38496130270009720*r**10-279274133343357420*r**12-335420979746254124*r**14
            +10417923066546070*r**16-671961488656295356*r**18-1481952124285193330*r**20
            -1043021083804965800*r**22+369435493662907616*r**24+399928468669907380*r**26
            -1153147020104287916*r**28-1002498527811595860*r**30-210859837898558575*r**32
            -106661009174169556*r**34-17822202802979315*r**36-1613777358404074*r**38
            -137869856321490*r**40+7692705160500*r**42)+2*Q2**8*(-399332883585-2726414081235*r**2
            -230950614665992*r**4+1877834679804738*r**6+5535139573510727*r**8+174509252050037685*r**10
            +498360610060590870*r**12+1117427388145977384*r**14+1861335287152707942*r**16
            +8140297695899533378*r**18+19590905676419864392*r**20+27696945367117054460*r**22
            +25554374061203766638*r**24+15439457421852476122*r**26+8145703671504321108*r**28
            +6275769870603249096*r**30+3241438476763302555*r**32+1035825759700259985*r**34
            +148915017620914448*r**36+26559225166718162*r**38-619040255932213*r**40
            -12928838917775*r**42-11318049928890*r**44)+4*Q2**7*(-166219751610+4156295210610*r**2
            +55877351034599*r**4+393240597064544*r**6+4437389863177110*r**8-53543679290787636*r**10
            +81947180984619329*r**12-363275530407422142*r**14-322417075504273292*r**16
            -2848870816802338860*r**18-11281924745501616722*r**20-20134843698416591312*r**22
            -21657012667577992188*r**24-14505013053531996088*r**26-6271495498860757110*r**28
            -2979780544485772508*r**30-1765777469214429978*r**32-317734601224882294*r**34
            -315383840375606949*r**36-268641877704640*r**38-1759725493001274*r**40
            +724879938056476*r**42+55747242547525*r**44+188855614410*r**46)+Q2**6*(448602736965
            -6264557581545*r**2+40842945039661*r**4-2377272589613565*r**6-15809171146727821*r**8
            -34743427151667631*r**10-843847187526962925*r**12+1322163144328382653*r**14
            -5554926141755553070*r**16-9422690938393362282*r**18+22229741896089116338*r**20
            +69878556799342019310*r**22+109659248894651724630*r**24+106982471212792655730*r**26
            +48271620797967534262*r**28+3515970099453498282*r**30+5280707652689019785*r**32
            +5393794878388621987*r**34-2260361819165853615*r**36+24798506810065631*r**38
            -119932987475894329*r**40-16076230080121875*r**42-1094793093938681*r**44
            -109946470860855*r**46+5708630922960*r**48)-2*Q2**5*(2835084765+927589194390*r**2
            +34995600718222*r**4-393969307121584*r**6-2640453263408112*r**8-60889311387497372*r**10
            -107861896836580702*r**12+269869729998590160*r**14-4763931430083971931*r**16
            -7706628904487951934*r**18+10393090865252679276*r**20+40176532999860453376*r**22
            +85044349168254680648*r**24+117783334981823459832*r**26+102709788586830643684*r**28
            +46773345294358177664*r**30+2525849275724804919*r**32+344020236992234586*r**34
            +3005145061218343590*r**36-436812806340796368*r**38-200266437300033368*r**40
            -35131827685390108*r**42-6268898351427366*r**44+60066117041968*r**46+2559341270855*r**48
            +1248578000910*r**50)+Q2**4*(-77664798825+2118404949255*r**2+15622754225736*r**4
            +216790980335180*r**6+407263172527114*r**8-56871303853980930*r**10+262907781309749360*r**12
            -879588276751450604*r**14-3227440663829289435*r**16-1374831433466290191*r**18
            +25025451290006881800*r**20+67180262688199226040*r**22+157859788560212481596*r**24
            +231065107144343436100*r**26+206512959441800660064*r**28+147303946115276530280*r**30
            +84079661239715536945*r**32+17659018865327487801*r**34-644592559130571240*r**36
            +968112383623490364*r**38+748084257389114010*r**40-233398996927554850*r**42
            -4010321238253904*r**44-2693192475169980*r**46+221359547118899*r**48+25495416522415*r**50
            -95976513000*r**52)-9*(-1+r**2)**4*(-31560249+1027478251*r**2+8027559110*r**4
            +77302658390*r**6-5509235651460*r**8-64991336955960*r**10+372793362522150*r**12
            -2982139280691790*r**14-18248380303756085*r**16+91543974167454515*r**18
            -150564533178764920*r**20-548605719328154660*r**22+522702010066510960*r**24
            +428577757892492040*r**26-1900250295359184660*r**28-679639781235923740*r**30
            +722590527614286445*r**32+278105222285476385*r**34-12217228391200010*r**36
            +11656982209650990*r**38+2541809007671700*r**40+29693886549360*r**42-27759788170290*r**44
            -4022268478710*r**46-18721163135*r**48+7452983169*r**50+172362204*r**52)
            +18*Q2*(-1+r**2)**2*(-115497381+4163653748*r**2+48337094024*r**4-272226661870*r**6
            -21182269019000*r**8-260258780235420*r**10+980948761374810*r**12-4862938445395040*r**14
            -81347769808772045*r**16+271482484956342000*r**18-104084403607046410*r**20
            -1564368421171522270*r**22-252309021509087480*r**24+1839473131980761480*r**26
            -2139929856673069500*r**28-5312089125035091440*r**30-517929338382332655*r**32
            +2229789805242225940*r**34+652666631701953780*r**36-85340358608562250*r**38
            +44007402729366320*r**40+6264013206109140*r**42+58873483166850*r**44-119758943340720*r**46
            -18601207969375*r**48-114638367544*r**50+19531189102*r**52+1392733206*r**54)
            +6*Q2**3*(3806473074-69335489720*r**2+1072702953447*r**4-42187757624434*r**6
            -271776221710126*r**8-719722645788538*r**10-26941327461965980*r**12+160636810178329978*r**14
            -802015244273465224*r**16+324408066388477194*r**18+251308333411268227*r**20
            -3212311729757194740*r**22-5220191209924330492*r**24+963238241651633276*r**26
            +85291273361575424*r**28-414465146281949068*r**30+9268611599523338050*r**32
            +5990416805731303388*r**34-597653938820870019*r**36-747053031889514426*r**38
            +568274830038940362*r**40-77044159172040610*r**42+9984889665654428*r**44
            -2316806875232974*r**46-244373089434316*r**48-12238976247182*r**50-1624110406375*r**52
            +70821317376*r**54)-3*Q2**2*(-720550641+49479585629*r**2+1338245412359*r**4
            -25040933157991*r**6-364217698717230*r**8-4118002256473470*r**10+2829901581364110*r**12
            +56549089177804090*r**14-1566701861976499535*r**16+3816540932992591795*r**18
            +395331830138620865*r**20-13772272992222834505*r**22-8646600867114846400*r**24
            +5181561445860596700*r**26-1270940117715172380*r**28-25045781423258398740*r**30
            -46784021866643043935*r**32-1780949068994281805*r**34+24300677553754845145*r**36
            +6251357047907578295*r**38-2213074626710563030*r**40+835578001710258050*r**42
            +27465596930394030*r**44+4257054308598330*r**46-2396781380271105*r**48
            -394857990781859*r**50-4555271366849*r**52-284392535399*r**54+51959845476*r**56))*sqrtq2)
            +logq2*(-192*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(164784*Q2**27*(147+1343*r**4)-6*Q2**26*(58384725
            +30986965*r**2+556690633*r**4+651545545*r**6)+12*Q2**25*(186534621+201283698*r**2
            +1503417718*r**4+4719110218*r**6+2505180969*r**8)-2*Q2**24*(4042261125
            +7019314831*r**2+14905847776*r**4+143371689576*r**6+203916944707*r**8
            +65432758065*r**10)+4*Q2**23*(4234625325+11840025962*r**2-31942962311*r**4
            +110664120548*r**6+428741871703*r**8+403083491618*r**10+85609498755*r**12)
            -Q2**22*(15622387515+98465402052*r**2-894636363487*r**4-1809455722666*r**6
            +91139666449*r**8+3909013461020*r**10+3602179458027*r**12+485961856290*r**14)
            +2*Q2**21*(-8014756050+56137653719*r**2-1331194898897*r**4-6139835781041*r**6
            -13181794466745*r**8-13451589741459*r**10-2688537556667*r**12+1675252914797*r**14
            +33585339735*r**16)+Q2**20*(68395115565+5065339988*r**2+4777874451668*r**4
            +36270859425312*r**6+121052461668866*r**8+221292701856764*r**10+188166936505564*r**12
            +57635795567824*r**14+4557343666625*r**16+1122914083680*r**18)-2*Q2**19*(38547258750
            +138638162076*r**2+2257528414661*r**4+32546691301961*r**6+144252398615317*r**8
            +365586146793305*r**10+479635920054391*r**12+310894710952751*r**14+79379573467301*r**16
            +9459830536707*r**18+1004210719740*r**20)+Q2**18*(-10988430075+530043333258*r**2
            -2236074655489*r**4+61594413278092*r**6+363000190873122*r**8+1258279918773392*r**10
            +2218952740096198*r**12+2166218963285796*r**14+1099389171321737*r**16
            +197932371164902*r**18+23908944348267*r**20+815823247920*r**22)+2*Q2**17*(64621026540
            -217207584471*r**2+7912541478016*r**4+9452136242968*r**6-11997055919277*r**8
            -314421737943272*r**10-785712222716702*r**12-953915426160462*r**14-850098072303632*r**16
            -355714129312097*r**18+2085992638590*r**20-1807766352906*r**22+1080859136145*r**24)
            -Q2**16*(130239195975+163032781302*r**2+25291077213604*r**4+149447852026552*r**6
            +739479820173215*r**8+2206207035439178*r**10+5052888863700136*r**12+9148294202164616*r**14
            +8771634615424637*r**16+3789665626443730*r**18+1201412474734388*r**20
            +395471014657984*r**22+29323854790941*r**24+3583867304430*r**26)+8*Q2**15*(
            -1672993035+108330238286*r**2+1647841054806*r**4+24586203094199*r**6
            +142768140623922*r**8+741190902786531*r**10+2187784375695013*r**12+4641891997362538*r**14
            +6010410399397113*r**16+4285964731806544*r**18+1559085735884808*r**20
            +420639237295183*r**22+68547729000368*r**24+4792115252015*r**26+137847154125*r**28)
            +2*Q2**14*(69494378625-461898308036*r**2+9672118478739*r**4-34014425880286*r**6
            -126521199506507*r**8-3336007264291340*r**10-12952774379105409*r**12-32736951988184734*r**14
            -51425072249958309*r**16-49290020439153948*r**18-26655010975835775*r**20
            -6842406208794266*r**22-1582571541723441*r**24-71065705594516*r**26-4840082510387*r**28
            +1331763745110*r**30)-4*Q2**13*(26259367050-28101127347*r**2+10025775607311*r**4
            +30230159341407*r**6+369143565679497*r**8-391860886633863*r**10-3850550888253413*r**12
            -13057299287358061*r**14-23559513368862007*r**16-25132324191890057*r**18
            -18134453471110867*r**20-6431073141505587*r**22+139569845722331*r**24
            -8447388229853*r**26+116414240322057*r**28+6261910657377*r**30+805209450345*r**32)
            +2*Q2**12*(-10712425815+386947229444*r**2+10916827202156*r**4+87598476070848*r**6
            +1087177397110628*r**8+3634178704862916*r**10+7267000955838180*r**12+11010938801794128*r**14
            +19728412039083582*r**16+49664646126361372*r**18+65031191348386836*r**20
            +43247948421600000*r**22+24323578211875860*r**24+9709853046463148*r**26
            +1576732142293788*r**28+294694221164400*r**30+14889290710049*r**32+204658614000*r**34)
            +4*Q2**11*(20433448350-202676883268*r**2+3965015080189*r**4-21773400287263*r**6
            -191360671874435*r**8-3165964075232947*r**10-8453369257697063*r**12-23318330446196431*r**14
            -46065667556253847*r**16-87714316159904355*r**18-126569386694386533*r**20
            -109618634250758637*r**22-57142559404331945*r**24-24803793975719033*r**26
            -5267471999773405*r**28-852070946633957*r**30-33711507949211*r**32-1989854428909*r**34
            +466850071980*r**36)-2*Q2**10*(20409484410-58940886099*r**2+14998811308156*r**4
            +366692921479*r**6+718605342970952*r**8-4228976528581376*r**10-5977889853948760*r**12
            -39577881447062840*r**14-78031523048941436*r**16-134561551199619118*r**18
            -236282508708998072*r**20-287733318006717074*r**22-189915721003514344*r**24
            -67939115232244088*r**26-32877140045193944*r**28-992314110584752*r**30
            -540761964085982*r**32+155347023142393*r**34+5571665953260*r**36+715453005555*r**38)
            -4*Q2**9*(3664765125-103094352687*r**2-3098851948492*r**4-7056677552192*r**6
            -544558060908834*r**8-598454549473690*r**10-6390375045914258*r**12+4247449145490622*r**14
            +1969621461784872*r**16-31563210862410536*r**18-42766414944041210*r**20
            -14947154803594578*r**22+24587631047633602*r**24-3234106619951798*r**26
            -24649842723942006*r**28-2968230631924070*r**30-3872276170234077*r**32
            -288365388724057*r**34-79405581445682*r**36-3084436095174*r**38+23350743120*r**40)
            +2*Q2**8*(12311352900-171037798221*r**2+3792558025028*r**4-17400751942144*r**6
            -469753922865444*r**8-4755133425507259*r**10-11902153645822264*r**12-6504491583767608*r**14
            -33480668659260216*r**16-214933982573199546*r**18-416408344636659376*r**20
            -480005845557701784*r**22-337581932635542888*r**24-126099796276200526*r**26
            -104047793982809736*r**28-80826769327223016*r**30-25462218472999116*r**32
            -6601102185173257*r**34-799678221450964*r**36-31466709015624*r**38-1859783065524*r**40
            +332364642585*r**42)-4*Q2**7*(1785527415-6015679002*r**2+2496436550057*r**4
            -8504193210034*r**6+165048077155951*r**8-1882764373132412*r**10+2889933593707025*r**12
            -9314413705148480*r**14+4406911676313134*r**16-83497787851781636*r**18
            -241953644818910446*r**20-333701620653469636*r**22-286076161928225786*r**24
            -132140171477800216*r**26-35035143561965446*r**28-41577568433619632*r**30
            -4572401785149925*r**32-9354905380790546*r**34+62533300532741*r**36-187129237219994*r**38
            +24414903632075*r**40+604752430788*r**42+73629454005*r**44)+Q2**6*(-4128189975
            +119830176748*r**2+2667339610091*r**4-15159470606062*r**6+1083101046516335*r**8
            -1481699089551468*r**10+25703162139659173*r**12-71120285498796690*r**14
            +241395073435197802*r**16+51151873747180280*r**18-652640652125868162*r**20
            -1157737351685161004*r**22-1516904199842652274*r**24-1103839323271409688*r**26
            -42191365219386630*r**28+105094296488332988*r**30-221173778768199843*r**32
            +83830341478371164*r**34-13257584443987097*r**36+6957611671824890*r**38
            +86118145110867*r**40+83758643716676*r**42+2919342872209*r**44-74416920330*r**46)
            +2*Q2**5*(1821784230-36394969421*r**2+788152465639*r**4-2587089210969*r**6
            -249627375240837*r**8-971179430751827*r**10-3678629099713479*r**12+23315819014369281*r**14
            -174753583121630653*r**16-41962838890666114*r**18+338267679819391206*r**20
            +624548130375826118*r**22+1218999579004459678*r**24+1356420153746906938*r**26
            +1016244877135823794*r**28+90891414876827874*r**30-131988985117042740*r**32
            +122903851221392095*r**34-23126729723087741*r**36+147584041080227*r**38
            -2008966868236233*r**40-153915616410103*r**42-9787325648443*r**44-538011833075*r**46
            +55173474555*r**48)+3*(-1+r**2)**4*(1698291-45136922*r**2+1885596250*r**4
            -10326367512*r**6-716766574416*r**8-2762970598040*r**10+21513126100878*r**12
            -99629109091640*r**14-2457513327123037*r**16+13757508694817614*r**18-31242185340599740*r**20
            -10673158449250352*r**22+65979156885760920*r**24-38991061638300992*r**26
            -76633438448728996*r**28+20891416504034000*r**30+26840055160610633*r**32
            -4771128171328670*r**34+1485234156134018*r**36+23472104309064*r**38+35072544407800*r**40
            -4106895251112*r**42-260622585610*r**44-15697619352*r**46-860431391*r**48
            +63118314*r**50)-Q2**4*(611391375-4333040388*r**2+1256096726572*r**4
            -9037310676128*r**6+68395347052274*r**8-1864840929341660*r**10+8721010401432932*r**12
            -19884491588910608*r**14-108690968285017083*r**16+113739616355411384*r**18
            +553708942052078200*r**20+914498261629421632*r**22+2463510205734017292*r**24
            +2700113220692017992*r**26+1684780590785146504*r**28+1579355148072724960*r**30
            +488756289568944617*r**32-130108007693566548*r**34+48866374888314652*r**36
            +16847549035307744*r**38-5576016241145630*r**40+200440219509332*r**42
            -165155833121708*r**44+9611559286192*r**46+154680525219*r**48+27521030880*r**50)
            -6*Q2*(-1+r**2)**2*(9702000-267529663*r**2+7744343470*r**4-31434141025*r**6
            -3691470502705*r**8-4371964326277*r**10+12971547058497*r**12+223478349692465*r**14
            -10104424168828455*r**16+41020075887692630*r**18-54852405362101027*r**20
            -83168318062012698*r**22+103150586016063910*r**24+61025590182324390*r**26
            -188926846109801910*r**28-155429766745914382*r**30+87097787168828242*r**32
            +69940429175703405*r**34-19109303654442440*r**36+5891281999764875*r**38
            -271114385381797*r**40+161362459464687*r**42-22487393838875*r**44-939566860595*r**46
            -95197713515*r**48-5264207892*r**50+337364685*r**52)-2*Q2**3*(207865350
            -7106218724*r**2-90110468523*r**4+1758920615809*r**6-94798371731971*r**8
            +392925009488649*r**10-3800435182762829*r**12+20463454160522587*r**14
            -91725484204154571*r**16+113740451463291519*r**18-48452914160821226*r**20
            -172754658489259734*r**22-167954999409057998*r**24+83829714834446234*r**26
            -218931831107764506*r**28+264568643946242134*r**30+382058092174687216*r**32
            +54119952603974202*r**34-123161021619410991*r**36+65193795161487589*r**38
            -14597584653577311*r**40+3387677463737581*r**42-614632734628393*r**44
            +14353056483519*r**46-4398381915131*r**48-169907493221*r**50+5041222740*r**52)
            +Q2**2*(256572477-7579816402*r**2+110670252735*r**4+66668725816*r**6
            -94499307658074*r**8+176802309165584*r**10-1890133290529454*r**12+17685824278724188*r**14
            -190235896786723489*r**16+594118647939598206*r**18-577800013734877531*r**20
            -683110459335809844*r**22+190152150442217668*r**24+516600746160841296*r**26
            +63080164182275276*r**28-1816338825553945256*r**30-1333919936227276949*r**32
            +897991644036707018*r**34+871494998598038361*r**36-374579512437256624*r**38
            +117329699833342134*r**40-14565133226891744*r**42+4069768304270658*r**44
            -597750533514484*r**46-8086903013159*r**48-2980679271158*r**50-158218339357*r**52
            +8098992108*r**54))+192*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1318272*Q2**32*(147
            +1343*r**4)-96*Q2**31*(32977245+19278365*r**2+312924209*r**4+360351665*r**6)
            +6*Q2**30*(3860324811+4625709846*r**2+32869847458*r**4+94219452590*r**6
            +49856078679*r**8)-4*Q2**29*(24502544325+47099879815*r**2+136694942440*r**4
            +868349666880*r**6+1157947109707*r**8+373910913585*r**10)+Q2**28*(253272760650
            +754201493620*r**2-349392661354*r**4+8631421862296*r**6+25197790683854*r**8
            +21533560115620*r**10+4663393969410*r**12)-4*Q2**27*(89186283711+478731957915*r**2
            -2068458566979*r**4-2348052654879*r**6+9651025915073*r**8+22249452139269*r**10
            +15113192188323*r**12+2181076743519*r**14)+Q2**26*(26305418475+2926550404485*r**2
            -32785802858253*r**4-143620930120587*r**6-230870096077803*r**8-125106450810065*r**10
            +99095492581025*r**12+92687882543655*r**14+6529865938620*r**16)+2*Q2**25*(475136686332
            -738366575913*r**2+37250615900238*r**4+270494052045750*r**6+802354321625698*r**8
            +1307479236113304*r**10+981784711981450*r**12+220660807362650*r**14-6736894640118*r**16
            +5654972956353*r**18)-Q2**24*(1774653181875+4600259284575*r**2+101231819053800*r**4
            +1199800868783850*r**6+4944737339799896*r**8+11717890015199784*r**10+14778803310733698*r**12
            +9101432338288718*r**14+2224744681827165*r**16+265890795975585*r**18+37378104785550*r**20)
            +2*Q2**23*(428699848500+6463900221200*r**2+18516559898735*r**4+793508059785330*r**6
            +4358562557575602*r**8+13924985941731906*r**10+24382274379929884*r**12
            +23363886163171398*r**14+11371805414487466*r**16+2244486420895870*r**18
            +284566659635525*r**20+18148650192600*r**22)+2*Q2**22*(964790596980-7240294888475*r**2
            +92002960827740*r**4-290762002488950*r**6-3245939047575943*r**8-16114573743530056*r**10
            -38577461855570562*r**12-50620888119222274*r**14-39087889746643064*r**16
            -14838315623861989*r**18-1760286112811810*r**20-213375349236320*r**22
            +8871711932595*r**24)-6*Q2**21*(617233500450-116780762300*r**2+77932985081475*r**4
            +394146613871520*r**6+1414462573129311*r**8+2438992506133892*r**10+1979180122104530*r**12
            +2787292261976704*r**14+222273851266724*r**16-3189094577431460*r**18-365055080316597*r**20
            +653308378079840*r**22+58933015046715*r**24+13563739825500*r**26)+2*Q2**20*(765723368970
            +11292772415245*r**2+235716112450750*r**4+2663864302273605*r**6+14555129760093997*r**8
            +63421381638894258*r**10+173674994101067769*r**12+352638960430905234*r**14
            +443340662848063164*r**16+302027264654784729*r**18+108845285138009920*r**20
            +32635482372306841*r**22+6508833768318045*r**24+552683883997240*r**26
            +33684858829305*r**28)+2*Q2**19*(1418186652750-16139497359550*r**2+40983121932775*r**4
            -2260362362107600*r**6-14603042402336618*r**8-113262998365746952*r**10
            -412945994060100729*r**12-1026563985771381414*r**14-1638121496716715790*r**16
            -1570063784224536606*r**18-847358763431757787*r**20-249377120280927884*r**22
            -58057805222088214*r**24-5850015330361820*r**26-427210728175315*r**28
            +16204504234050*r**30)+Q2**18*(-4194557773875+10903997113575*r**2-826847949645465*r**4
            -1010672640616275*r**6-9233087213159831*r**8+162914397527517027*r**10
            +929607289995805923*r**12+2935658072575580313*r**14+5752429789830105639*r**16
            +6970764987832910037*r**18+5202618744128970357*r**20+2131467617040650583*r**22
            +424613063517554931*r**24+71634806363615137*r**26-3688551528741375*r**28
            -336227751378525*r**30-104005757552400*r**32)+2*Q2**17*(441298803960+12626097800325*r**2
            +437615032035375*r**4+3250839874890570*r**6+29440780533920907*r**8+64159298134283534*r**10
            -49443925981840517*r**12-623222462589375102*r**14-1737081064421511033*r**16
            -2357336600519631624*r**18-2074663728052376643*r**20-1171185824599568994*r**22
            -141261644253905679*r**24+102962556806100306*r**26+29807116005116441*r**28
            +8986588641115030*r**30+597761886847365*r**32+28064861178915*r**34)+Q2**16*(2755848282075
            -37012578196125*r**2+24791394153210*r**4-6466783867419900*r**6-61558422913212256*r**8
            -459304795267805052*r**10-1318398077109232120*r**12-3427471040758008308*r**14
            -7105286016757536138*r**16-13736571316737623622*r**18-18814177938514426620*r**20
            -15097966721586523140*r**22-7678743198991585752*r**24-3409502194257169324*r**26
            -883508550503835240*r**28-155589468575007628*r**30-13808517399744665*r**32
            -804440233498485*r**34+46186320698850*r**36)+4*Q2**15*(-640695375180+2702548054320*r**2
            -220899455984805*r**4+371927941147890*r**6-179358296351954*r**8+119045554346956074*r**10
            +451986211552145742*r**12+1857390740773465354*r**14+5057374390346987502*r**16
            +10814871941856159018*r**18+16945161183757754796*r**20+17234318720849503038*r**22
            +10645644856167403386*r**24+4195635208767038494*r**26+1352731961073381762*r**28
            +198130895268476430*r**30+28277328099280438*r**32-995982789303330*r**34
            -63868767472215*r**36-18743740530120*r**38)+2*Q2**14*(-68101369875+10621029681800*r**2
            +351983133496250*r**4+1610868016764450*r**6+34013782720250307*r**8-26318547697748892*r**10
            -202909843508195444*r**12-2989055265423342444*r**14-11211079265535417410*r**16
            -27538870107903756908*r**18-49568093238972608288*r**20-60999433442946022696*r**22
            -48725136351396830526*r**24-22682037685692025620*r**26-6134636541936190764*r**28
            -1419316576679294612*r**30+41045384802928821*r**32+11212752553208596*r**34
            +7098967619031430*r**36+387543490515590*r**38+8409478098075*r**40)+4*Q2**13*(387329473125
            -5981920410175*r**2+33866026126435*r**4-1071746608409680*r**6-16591915055262224*r**8
            -112229932866781757*r**10-375158656464723888*r**12-245499584229860480*r**14
            +1599332541752658074*r**16+5288491145402470378*r**18+10986755492477842582*r**20
            +14637083256279489888*r**22+13829313203472033992*r**24+8147148177802640998*r**26
            +580978553706800920*r**28-1267174458387005952*r**30-563819672723309783*r**32
            -192787669117618651*r**34-27707137570028897*r**36-1969559915455120*r**38
            -105894771167200*r**40+8763848787975*r**42)-6*Q2**12*(128398766265-483906809600*r**2
            +89042377118955*r**4-376855056053970*r**6-256162503661299*r**8-88509820240692138*r**10
            -281471069060447861*r**12-1363691996110931880*r**14-2724077047211341406*r**16
            -7058133752731297000*r**18-15232151165595664602*r**20-26920417917039504236*r**22
            -34939055167343860958*r**24-29198237191009980892*r**26-17556170631526386514*r**28
            -9368492026440489640*r**30-2959132352112089403*r**32-815597243657469992*r**34
            -95350512144269137*r**36-13739738482042482*r**38+520161227364785*r**40
            +23695516539030*r**42+4644015600135*r**44)-4*Q2**11*(79421465025-2935647895175*r**2
            -58198753510490*r**4-135439429658535*r**6-12103843081481561*r**8+41218681386454533*r**10
            +54332209567869990*r**12+2403186998935960953*r**14+5168304793252044138*r**16
            +17527105889219055474*r**18+43663945617066980404*r**20+81487676033810977810*r**22
            +121027251039180341262*r**24+126045756829881380386*r**26+84907110060712154532*r**28
            +42091422901964526186*r**30+18123696914907134085*r**32+3274737098371722165*r**34
            +786247809958193286*r**36-18693828953747435*r**38-339612901020773*r**40
            -1521767833212615*r**42-78640947043370*r**44+678449677725*r**46)+Q2**10*(459755361765
            -8311991168285*r**2+135510476748305*r**4-1944738627861665*r**6-36526008729237961*r**8
            -211630836785152139*r**10-920114501515441857*r**12+3316325889629891889*r**14
            -657246865899451602*r**16+30951795256586846334*r**18+111351934704647371402*r**20
            +206005208476806771350*r**22+348406363350321975886*r**24+464466238167239825258*r**26
            +408804697839764915134*r**28+195149705264011965282*r**30+66507007479733637745*r**32
            +30275113784065338735*r**34-1030719410194837611*r**36-311943370942359077*r**38
            -362039850515993845*r**40-46604981641938863*r**42-2133269157018925*r**44
            -133056948002915*r**46+12939040282860*r**48)+2*Q2**9*(-43494286500-328946495775*r**2
            -79041046055700*r**4+649070224486650*r**6-1499599010197648*r**8+135631837128184308*r**10
            +393950697510616596*r**12+2670703862118439566*r**14+8684806367982593820*r**16
            +9102867824320222029*r**18+2906693563150732392*r**20+38916767013688941924*r**22
            +76019964835515094704*r**24+61871385507381082640*r**26+9989507106638564376*r**28
            -4556552109591938628*r**30+39173144004843201924*r**32+34800028766006502219*r**34
            +11935813126862828460*r**36+4272928721708259138*r**38+1060623932675466528*r**40
            +91081476321506556*r**42+16150801111118036*r**44-610972239841770*r**46
            -26259631522620*r**48-2270170863225*r**50)-Q2**8*(109304992125-3502280577975*r**2
            -15622727601180*r**4-62769611910270*r**6-19063747504198824*r**8+102161257699479248*r**10
            +162433686241873162*r**12+7747673774298838158*r**14+5221591422936619437*r**16
            +32650256986296796545*r**18+47708795319759896202*r**20+231262767766015290228*r**22
            +566794770308609396568*r**24+764232558635087389224*r**26+665665541661446615972*r**28
            +377401450263261238972*r**30+204541670140074536103*r**32+163422864540575564955*r**34
            +73690936576646923416*r**36+39734177150200749162*r**38+5280309393492533328*r**40
            +1586433891377809032*r**42-38090220764178126*r**44+1390699198847318*r**46
            -1309333267985105*r**48-79111551217125*r**50+2406201159450*r**52)+2*Q2**7*(33075276948
            -704241422400*r**2+21886352821467*r**4-303578830407270*r**6-4305709282776638*r**8
            -23164179248087766*r**10-91817763586128512*r**12+1443540139311039062*r**14
            -6230821342827691206*r**16+16904654166364219278*r**18-10504311090392629893*r**20
            +51529180274696734476*r**22+285075377870178658740*r**24+485561868187109490148*r**26
            +528400297533516869304*r**28+353238925918254711340*r**30+115379464206020018504*r**32
            +67532844708554067228*r**34+59751617590724146977*r**36-2466285411712415790*r**38
            +9976319494918745898*r**40-253796365829053038*r**42+111046047082635016*r**44
            -36412675433402274*r**46-5493538706633654*r**48-123910468699402*r**50
            -11919092585655*r**52+1101525779112*r**54)-2*Q2**6*(-978186510+193396807455*r**2
            +9480857512188*r**4-155830154330250*r**6+1291468777404433*r**8-35843447731483764*r**10
            -108635706988002750*r**12-932703646396804022*r**14-4338652667282252622*r**16
            +11101376127278658891*r**18-67022159957174428662*r**20-56005083364582250100*r**22
            +184005984143067733785*r**24+440267049275285526256*r**26+696038950091012024724*r**28
            +715923680399761697460*r**30+403864866426356788030*r**32+19172318340328275237*r**34
            +5904876872498123184*r**36+53250713107719836622*r**38-13849156651772353053*r**40
            -434178140945078460*r**42-1073091766391058806*r**44-247798157304557598*r**46
            -10881195422659170*r**48-3331847072027471*r**50+103450405449450*r**52
            +5692564108368*r**54+94818967155*r**56)-2*Q2**5*(7087036698-249739252472*r**2
            +2121245122909*r**4-12973479320160*r**6-1795319768525235*r**8+15282223280438232*r**10
            +63349744008032546*r**12+1064832356977237824*r**14-1761490798920986224*r**16
            +5162206466711316248*r**18+62440646572099605443*r**20+44268499873446760672*r**22
            -175734638296013835585*r**24-459448408155297421368*r**26-940128035301779276196*r**28
            -1210626723204210265216*r**30-1026699502935939266862*r**32-596222817505909857544*r**34
            -91911265451142167917*r**36+13164624694006302560*r**38-30889645018570624565*r**40
            -2064275925808262616*r**42+3167377336342156002*r**44+402958821466584384*r**46
            +194941286722490276*r**48-2087571322925592*r**50+337380522149357*r**52
            -64053177189856*r**54-5570522676215*r**56+199993820472*r**58)-9*(-1
            +r**2)**4*(1698291-67214705*r**2+2288960808*r**4-30147746614*r**6-781315481967*r**8
            +7467186643941*r**10+135933223715450*r**12-3352005403900*r**14-3178044064138325*r**16
            +54176909961619495*r**18+65799151128046940*r**20-823607557188175850*r**22
            +2124923338613992945*r**24+3448831901790864965*r**26-5122891550171343210*r**28
            -1790079295888506440*r**30+11374295452043265025*r**32+6239309482951466485*r**34
            -4134245401203037680*r**36-2750950539769056170*r**38+26577188245508155*r**40
            -74535604712522025*r**42-30348865246813370*r**44-2160820912812540*r**46
            +39424161993825*r**48+118316013534549*r**50+1068647303980*r**52+29556278282*r**54
            -11328789181*r**56-1680969473*r**58+63118314*r**60)+2*Q2**4*(2161737900
            -56753885495*r**2+2453318679080*r**4-41205660417815*r**6-379823682790429*r**8
            -1234478659036402*r**10+12681878763919551*r**12+244372601246290526*r**14
            -2590982841196750850*r**16+12819435302160652715*r**18-8589727358589111742*r**20
            +13119420068396686131*r**22-114598884000376244279*r**24-319636749229803966100*r**26
            -653178693285589527235*r**28-883674276386162351532*r**30-812635725656539007824*r**32
            -489181963291028470769*r**34-267833078432478808300*r**36-100125654342938089345*r**38
            -25372795393865729307*r**40+13552959834080040526*r**42-8711410305631357879*r**44
            +1894976793657440750*r**46-93134593781880570*r**48+37349930976024413*r**50
            -1564143345306014*r**52-541657137509179*r**54-6231703635185*r**56-1141195540136*r**58
            +80356344795*r**60)+18*Q2*(-1+r**2)**2*(9702000-397052245*r**2+10210341621*r**4
            -106476545739*r**6-4133258687520*r**8+48072776371585*r**10+499479870608585*r**12
            +923090940081975*r**14-14544526602111320*r**16+156550044611421915*r**18
            +522523490054533385*r**20-3253591389549573755*r**22+4845257820334208840*r**24
            +10732729592932732745*r**26-4173133870029758835*r**28-8112483108688318865*r**30
            +12166002761263387520*r**32+30620477703734371545*r**34+12070122468109824575*r**36
            -13414584081254673785*r**38-8126996087622055440*r**40+808275057410992795*r**42
            -328240166227959365*r**44-84756065836514035*r**46-7010782095150360*r**48
            +206574971268385*r**50+581035608134915*r**52+1535516989759*r**54+893323570024*r**56
            -63497320165*r**58-9776185425*r**60+337364685*r**62)+6*Q2**3*(110845350
            -7167034270*r**2-105325034491*r**4+4438876628524*r**6-76292904590130*r**8
            +1493646746236532*r**10+3991753285989873*r**12+34171996450741474*r**14
            +153486713968828470*r**16-1670802559641932874*r**18+14920740150049011257*r**20
            -25812716043361299472*r**22+13885845121888291694*r**24+60520200108432312960*r**26
            +28909386547827644501*r**28-18013711934136631218*r**30+14735609335402672738*r**32
            +72938625484136026734*r**34-19162469235329506065*r**36-92845799444840470084*r**38
            -27407715175034061958*r**40+21051366186426933188*r**42-9207383842100505741*r**44
            +1019458786475906750*r**46-239274486073706814*r**48+31387715144980282*r**50
            +9118407746230803*r**52-2135554000920*r**54+105896980294986*r**56-2031591535224*r**58
            -182300842745*r**60+1667575890*r**62)-3*Q2**2*(239589567-10581253595*r**2
            +162023355257*r**4-418220246613*r**6-102754330769657*r**8+1473861989045517*r**10
            +7202031386424689*r**12+34529485783937067*r**14-231972285048982765*r**16
            +1239276061105886985*r**18+15027358795073081165*r**20-64011452916295616745*r**22
            +74306353788785334355*r**24+100758067815371582465*r**26-51306630075913261995*r**28
            +38271331070277420455*r**30+58762475789144953365*r**32+57592577647742468495*r**34
            +239460549255415392075*r**36+180561035107579774145*r**38-142184565320344318155*r**40
            -116972502168058133465*r**42+30539550235500121235*r**44-8298433415753819295*r**46
            -507530158884836335*r**48-160322502617374077*r**50+4747338035808815*r**52
            +13268814465293373*r**54-73506249388367*r**56+53124425588107*r**58-1712361235097*r**60
            -258705629939*r**62+7467808968*r**64))*sqrtq2))/(17010000*r**4*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2
            +17010000*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))**2*sqrtq2+logq2**8*(1645647446016000000*r**36*(1
            +r**2)**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+1645647446016000000*r**36*(1
            +r**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2*(-2449440000*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4
            -Q2**3*(1+r**2)-2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4
            +r**6)+4*(1-9*r**2-44*r**4-9*r**6+r**8))-2449440000*(-Q2+(-1+r)**2)**3*r**8*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4-Q2**3*(1+r**2)
            -2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4+r**6)+4*(1-9*r**2
            -44*r**4-9*r**6+r**8))*sqrtq2)+logq2**7*(-36569943244800000*r**32*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))-36569943244800000*r**32*(1+r**2)*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))*sqrtq2)+logq2**3*(-587865600000*(-Q2+(-1
            +r)**2)**3*r**16*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8
            +68*Q2**7*(1+r**2)-Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2
            +683*r**4+169*r**6)+2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)
            +6*Q2**3*(31+230*r**2+159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(
            -131+1184*r**2+6523*r**4+8368*r**6+6523*r**8+1184*r**10-131*r**12)
            -9*Q2*(13+5*r**2-1493*r**4-5245*r**6-5245*r**8-1493*r**10+5*r**12
            +13*r**14)+36*(4-67*r**2-28*r**4+2331*r**6+5600*r**8+2331*r**10-28*r**12
            -67*r**14+4*r**16))-587865600000*(-Q2+(-1+r)**2)**3*r**16*(1-Q2+r**2)*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)
            -Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2+683*r**4+169*r**6)
            +2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)+6*Q2**3*(31+230*r**2
            +159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4
            +8368*r**6+6523*r**8+1184*r**10-131*r**12)-9*Q2*(13+5*r**2-1493*r**4
            -5245*r**6-5245*r**8-1493*r**10+5*r**12+13*r**14)+36*(4-67*r**2-28*r**4
            +2331*r**6+5600*r**8+2331*r**10-28*r**12-67*r**14+4*r**16))*sqrtq2)
            +logq2**2*(146966400000*(-Q2+(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8-4*Q2**7*(1+r**2)-Q2**6*(57
            +50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4+5*r**6)+Q2**4*(85-226*r**2
            -1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1-54*r**2-143*r**4-143*r**6
            -54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4+3168*r**6+2871*r**8
            +468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4-2833*r**6-2833*r**8
            -565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4+4368*r**6+11718*r**8
            +4368*r**10-56*r**12-96*r**14+5*r**16))+146966400000*(-Q2+(-1+r)**2)**3*r**12*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8-4*Q2**7*(1+r**2)
            -Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4+5*r**6)+Q2**4*(85
            -226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1-54*r**2-143*r**4
            -143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4+3168*r**6+2871*r**8
            +468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4-2833*r**6-2833*r**8
            -565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4+4368*r**6+11718*r**8
            +4368*r**10-56*r**12-96*r**14+5*r**16))*sqrtq2)+logq2**5*(-50791587840000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219+310*r**2
            +219*r**4)-Q2**5*(977+2179*r**2+2179*r**4+977*r**6)+Q2**4*(590-2090*r**2
            -6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4-2073*r**6
            +10*r**8+243*r**10)+Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6+41127*r**8
            +8076*r**10-879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6+67125*r**8
            +31341*r**10+3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4+12789*r**6
            +25830*r**8+12789*r**10+28*r**12-573*r**14+41*r**16))-50791587840000*r**24*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219
            +310*r**2+219*r**4)-Q2**5*(977+2179*r**2+2179*r**4+977*r**6)+Q2**4*(590
            -2090*r**2-6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4
            -2073*r**6+10*r**8+243*r**10)+Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6
            +41127*r**8+8076*r**10-879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6
            +67125*r**8+31341*r**10+3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4
            +12789*r**6+25830*r**8+12789*r**10+28*r**12-573*r**14+41*r**16))*sqrtq2)
            +logq2**4*(10581580800000*r**20*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(32*Q2**8
            +104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)-24*Q2**5*(13+31*r**2
            +31*r**4+13*r**6)+Q2**4*(415-1180*r**2-4598*r**4-1180*r**6+415*r**8)
            +4*Q2**3*(102+155*r**2-677*r**4-677*r**6+155*r**8+102*r**10)+Q2**2*(
            -389+3526*r**2+18377*r**4+25852*r**6+18377*r**8+3526*r**10-389*r**12)
            -12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8-1133*r**10-55*r**12
            +18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6+53690*r**8+24556*r**10
            -168*r**12-892*r**14+59*r**16))+10581580800000*r**20*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)
            -24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415-1180*r**2-4598*r**4
            -1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4-677*r**6+155*r**8
            +102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6+18377*r**8
            +3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8
            -1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6
            +53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))*sqrtq2)+logq2**6*(203166351360000*r**28*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(16*Q2**8+332*Q2**7*(1
            +r**2)+Q2**6*(153+370*r**2+153*r**4)-Q2**5*(2011+4817*r**2+4817*r**4
            +2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4-2410*r**6+295*r**8)+6*Q2**3*(559
            -310*r**2-4869*r**4-4869*r**6-310*r**8+559*r**10)-3*Q2**2*(479-4496*r**2
            -22867*r**4-35272*r**6-22867*r**8-4496*r**10+479*r**12)-9*Q2*(187
            -865*r**2-5807*r**4-10315*r**6-10315*r**8-5807*r**10-865*r**12+187*r**14)
            +9*(109-1432*r**2+392*r**4+26376*r**6+49910*r**8+26376*r**10+392*r**12
            -1432*r**14+109*r**16))+203166351360000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(16*Q2**8+332*Q2**7*(1+r**2)+Q2**6*(153+370*r**2+153*r**4)
            -Q2**5*(2011+4817*r**2+4817*r**4+2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4
            -2410*r**6+295*r**8)+6*Q2**3*(559-310*r**2-4869*r**4-4869*r**6-310*r**8
            +559*r**10)-3*Q2**2*(479-4496*r**2-22867*r**4-35272*r**6-22867*r**8
            -4496*r**10+479*r**12)-9*Q2*(187-865*r**2-5807*r**4-10315*r**6-10315*r**8
            -5807*r**10-865*r**12+187*r**14)+9*(109-1432*r**2+392*r**4+26376*r**6
            +49910*r**8+26376*r**10+392*r**12-1432*r**14+109*r**16))*sqrtq2))+((
            -1990656000*logq2**5*r**18*(-420*Q2**11*(2+5*r**4)+60*Q2**10*(194+212*r**2
            +437*r**4+255*r**6)-20*Q2**9*(3426+6972*r**2+10615*r**4+7838*r**6+1665*r**8)
            +4*Q2**8*(57618+160047*r**2+258485*r**4+216315*r**6+65865*r**8-7110*r**10)
            +Q2**7*(-484056-1617165*r**2-2871524*r**4-2651950*r**6-1135140*r**8
            +207315*r**10+270720*r**12)+Q2**6*(629496+2372769*r**2+4533691*r**4
            +4300204*r**6+2021070*r**8-205175*r**10-1179465*r**12-522270*r**14)
            +Q2**5*(-429912-1862847*r**2-3721990*r**4-3191853*r**6-1259418*r**8
            +1041695*r**10+1296990*r**12+1096725*r**14+342090*r**16)+(-1+r**2)**4*(
            -17088-18795*r**2-21135*r**4+136265*r**6-740695*r**8-253957*r**10+192475*r**12
            +57355*r**14+133675*r**16+48060*r**18)+Q2**4*(-17640+450135*r**2+1035007*r**4
            +479273*r**6-631395*r**8-1250735*r**10-1400695*r**12+7695*r**14+620235*r**16
            +315000*r**18)+Q2**3*(312768+309357*r**2+302872*r**4-31970*r**6+2660268*r**8
            +3728068*r**10-1049848*r**12-755070*r**14-845060*r**16-1784865*r**18
            -810360*r**20)-Q2*(-1+r**2)**2*(-108384-110799*r**2-102640*r**4+469850*r**6
            -2947570*r**8-3793436*r**10+466414*r**12+997990*r**14+274890*r**16+697035*r**18
            +285930*r**20)+Q2**2*(-274704-109305*r**2-64759*r**4+780600*r**6-5129310*r**8
            -4646176*r**10-2277180*r**12+1320354*r**14+1305350*r**16-428415*r**18
            +1090875*r**20+691230*r**22))-1105920*logq2**3*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(-180*Q2**17*(687+3520*r**4)+12*Q2**16*(145209+134648*r**2
            +655656*r**4+691275*r**6)-4*Q2**15*(2677302+4920501*r**2+13552617*r**4
            +22398253*r**6+12008025*r**8)+8*Q2**14*(4642020+12845148*r**2+31082511*r**4
            +58031107*r**6+54932145*r**8+20011275*r**10)-Q2**13*(76851180+295637991*r**2
            +728962248*r**4+1451259386*r**6+1758838824*r**8+1194796055*r**10+332921700*r**12)
            +Q2**12*(84960540+487160349*r**2+1203391395*r**4+2618752084*r**6+3616206066*r**8
            +3337328181*r**10+1904259415*r**12+430704450*r**14)-2*Q2**11*(2743272
            +188425437*r**2+250795212*r**4+670144431*r**6+1011099911*r**8+1079701735*r**10
            +1275535046*r**12+824294433*r**14+152164575*r**16)+2*Q2**10*(-65107548
            -70638837*r**2-1093190739*r**4-2742499879*r**6-4624436750*r**8-5933256326*r**10
            -4008370495*r**12-768518955*r**14+200104408*r**16+12999825*r**18)+Q2**9*(186062580
            +641523807*r**2+4838376204*r**4+14455085438*r**6+26574484030*r**8+38171849000*r**10
            +36000291782*r**12+19225071674*r**14+4817795078*r**16+597953505*r**18
            +166807350*r**20)-Q2**8*(83641140+627279993*r**2+3673314039*r**4+15065763348*r**6
            +28912437972*r**8+46430742650*r**10+55954169518*r**12+42927138204*r**14
            +18399002968*r**16+4738914237*r**18+738669915*r**20+207417600*r**22)
            +4*Q2**7*(-17943750+53530788*r**2-333611085*r**4+1164222978*r**6+1036149702*r**8
            +903784212*r**10+4828121398*r**12+8684823340*r**14+7004306008*r**16+2663099912*r**18
            +1339752627*r**20+198619530*r**22+54917100*r**24)-4*Q2**6*(-31067316
            -26620905*r**2-1260854973*r**4-1163004961*r**6-5773062756*r**8-14454501347*r**10
            -13604880658*r**12-4087020790*r**14+4970617074*r**16+5157154919*r**18
            +1908180331*r**20+1955638851*r**22+262723346*r**24+54119025*r**26)+Q2**5*(
            -63520884-158174265*r**2-3845275920*r**4-4824559478*r**6-23584022100*r**8
            -65453440259*r**10-65456189472*r**12-30838250444*r**14+10797549404*r**16
            +30122146345*r**18+19401760488*r**20+5669591042*r**22+6198036364*r**24
            +856909779*r**26+110601000*r**28)+(-1+r**2)**4*(-408312-125055*r**2
            -52121757*r**4+124875502*r**6-716725158*r**8-348339321*r**10+2358533045*r**12
            +574331404*r**14-6376937484*r**16-5380078609*r**18+4541769133*r**20+2216311710*r**22
            -92084822*r**24+231490057*r**26+13969467*r**28+2500200*r**30)+Q2**4*(
            -6739740+104075259*r**2+248412933*r**4+2611315556*r**6+4395789210*r**8
            +20964708245*r**10+14090687807*r**12-4942192246*r**14-18539298272*r**16
            -20298674795*r**18-4354671005*r**20-232711616*r**22-2589936062*r**24
            +325781691*r**26-223569415*r**28+40302450*r**30)-Q2*(-1+r**2)**2*(-3841272
            +3125103*r**2-400921782*r**4+988014115*r**6-4705680386*r**8-2687278929*r**10
            +13019115714*r**12-3861985701*r**14-19303641530*r**16-24858789163*r**18
            -16673146146*r**20+22201393633*r**22+12762568858*r**24-1299918835*r**26
            +1494577174*r**28+82024097*r**30+20065050*r**32)-2*Q2**3*(-13088160+31275633*r**2
            -810935256*r**4+1680241283*r**6-5536756173*r**8-3960046435*r**10+2129658454*r**12
            -8858976693*r**14-6450062031*r**16-2850606509*r**18-1924988420*r**20
            +18645784513*r**22+12449110149*r**24-2097497377*r**26+2334043782*r**28
            +81577265*r**30+50145975*r**32)+2*Q2**2*(-7358940+16505187*r**2-622064115*r**4
            +1804537377*r**6-6657829462*r**8-323197992*r**10+12757021111*r**12-11635443245*r**14
            -14431261744*r**16-7142730756*r**18-1966505141*r**20-21398365993*r**22
            +12629088210*r**24+15055527092*r**26-3301369807*r**28+1893501173*r**30
            +73027920*r**32+32599125*r**34))+768*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(205980*Q2**23*r**2-60*Q2**22*(-1184+39539*r**2+64403*r**4)+12*Q2**21*(
            -66010+384665*r**2+3695392*r**4+2565185*r**6)-4*Q2**20*(-1072795-14016985*r**2
            +30048273*r**4+82088225*r**6+34570230*r**8)+Q2**19*(-16259015-459430624*r**2
            -489420362*r**4+611399268*r**6+1279317721*r**8+381567900*r**10)+Q2**18*(50346775
            +1801153481*r**2+4552801352*r**4+5096076530*r**6+716941367*r**8-2707001939*r**10
            -629815470*r**12)+Q2**17*(-125636995-4577970394*r**2-16361346657*r**4
            -34185543994*r**6-42529848669*r**8-17123461382*r**10+2094751961*r**12
            +444272970*r**14)+Q2**16*(224175635+7809365011*r**2+36324646565*r**4
            +99974128845*r**6+202599264105*r**8+197200450525*r**10+71288223931*r**12
            +4276886555*r**14+474117420*r**16)-2*Q2**15*(112752950+3684349402*r**2
            +25752260173*r**4+79016347492*r**6+233092435851*r**8+345746446566*r**10
            +255229223487*r**12+75180939848*r**14+7333269947*r**16+737962860*r**18)
            +2*Q2**14*(-10760090-1124273264*r**2+15496671303*r**4+19912261043*r**6
            +203418671719*r**8+482954308527*r**10+550352756969*r**12+349433867053*r**14
            +80760081363*r**16+9335927281*r**18+619466400*r**20)+2*Q2**13*(212514850
            +9604495826*r**2+24605545417*r**4+233697297520*r**6+453679804464*r**8
            +446703045772*r**10+345711736162*r**12+27182590944*r**14-123650290370*r**16
            -10162724238*r**18-4289425979*r**20+219536640*r**22)-2*Q2**12*(283961990
            +13908960364*r**2+74031198307*r**4+584754092799*r**6+1848717652088*r**8
            +3124808784564*r**10+4097845080966*r**12+3474660039134*r**14+1583651768778*r**16
            +372430678624*r**18+91134548887*r**20+3816947459*r**22+911678040*r**24)
            +2*Q2**11*(90983295+6206547906*r**2+78914092893*r**4+569615400240*r**6
            +2742809560320*r**8+5288058804880*r**10+8265967023254*r**12+9042684714672*r**14
            +6308667139195*r**16+2528866847610*r**18+642628095325*r**20+119451472096*r**22
            +7383540918*r**24+655985460*r**26)+2*Q2**10*(192044385+8718596961*r**2
            -16333816305*r**4+140384960001*r**6-1470147860228*r**8-2328890180048*r**10
            -4488792514256*r**12-6817216024770*r**14-6896067267011*r**16-4415511376363*r**18
            -1444516748893*r**20-408591500719*r**22-54253428650*r**24-4837798134*r**26
            +175444590*r**28)-2*Q2**9*(267943485+15674082036*r**2+57128926488*r**4
            +968994735438*r**6+1179544359247*r**8+5008115702564*r**10+9749320559730*r**12
            +11132156908862*r**14+8343980582787*r**16+2537364664220*r**18+107065206684*r**20
            +308087299642*r**22-33516927887*r**24+16400244428*r**26-732456294*r**28
            +595534650*r**30)+2*Q2**8*(100462325+8163786479*r**2+70099745838*r**4
            +914309030690*r**6+2420386789419*r**8+7886670029317*r**10+19887473263544*r**12
            +28623891172128*r**14+31288703086975*r**16+20612304044273*r**18+7125861584574*r**20
            +1644161088082*r**22+869124458069*r**24+105782448795*r**26+31317956188*r**28
            +1588709804*r**30+327947340*r**32)+2*Q2**7*(79973330+3476457124*r**2
            -27910345903*r**4-4813851036*r**6-1709005164273*r**8-1396912949054*r**10
            -12999780005819*r**12-18126611546808*r**14-26841404556161*r**16-28047969119666*r**18
            -14857716194733*r**20-5257322417084*r**22-1137151326659*r**24-854473166418*r**26
            -108924395561*r**28-17576159408*r**30-2167266781*r**32+81478110*r**34)
            -2*Q2**6*(110655490+7320664226*r**2+10687192529*r**4+670030621775*r**6
            -926162679525*r**8+7093581933855*r**10-1161506151381*r**12+10171475571551*r**14
            +11609573936535*r**16-3791598682725*r**18-13245179986075*r**20-4311810606651*r**22
            -5517264068439*r**24-1653069836395*r**26-1160801742495*r**28-134070550515*r**30
            -10517626589*r**32-1654549361*r**34+191148990*r**36)+2*Q2**5*(44526470
            +3718402904*r**2+17482408263*r**4+525051721474*r**6-583635850216*r**8
            +8079234870264*r**10+166376158736*r**12+19562170599672*r**14+30849573522556*r**16
            +13418503624712*r**18-2742066012018*r**20-16256271303284*r**22+122861606312*r**24
            -5729655008664*r**26-1757694210536*r**28-1025597078216*r**30-114418714306*r**32
            -7136494272*r**34-542489341*r**36+81767490*r**38)+(-1+r**2)**4*(288635
            +31651299*r**2+111271033*r**4+7614797437*r**6-43628593504*r**8+388530892020*r**10
            -1579155924692*r**12+4161970681836*r**14-1560125734366*r**16-13257018016878*r**18
            +19628329796710*r**20-599093098738*r**22-6696813817396*r**24+1753856929396*r**26
            -934456148532*r**28+31634420780*r**30-44082832869*r**32-3316042973*r**34
            -266794967*r**36-10914211*r**38+469980*r**40)+2*Q2**4*(7344020+201681862*r**2
            -8499180259*r**4-57914087239*r**6-72471232020*r**8-1916232653488*r**10
            +45191035536*r**12-6407528085816*r**14-14149451477816*r**16+8025160669492*r**18
            +2762811336666*r**20+1284095345242*r**22+14491115933584*r**24-403906403376*r**26
            +525766748776*r**28+864923452752*r**30+167790295860*r**32+26316539366*r**34
            +500529681*r**36-318862123*r**38+12909300*r**40)+Q2**3*(-31307375-2375082196*r**2
            +3914474888*r**4-307603445700*r**6+1378713462367*r**8-7305891514164*r**10
            +15939838687208*r**12-26120977252704*r**14+5725243573170*r**16-16545846818376*r**18
            -2635796724808*r**20-12341711143848*r**22+34568176886694*r**24+22996488679160*r**26
            -12226936657224*r**28+10943838471808*r**30-1271315280819*r**32+871946193372*r**34
            +65171801120*r**36+7264364108*r**38+935570539*r**40-55577220*r**42)-Q2*(
            -1+r**2)**2*(3182875+314783476*r**2+572687324*r**4+64673752542*r**6-361227941195*r**8
            +2793557226118*r**10-9682124302768*r**12+21909567108248*r**14-4854905883266*r**16
            -44619376781680*r**18+23883287007016*r**20+54279686955588*r**22-3834252765318*r**24
            -34213158940444*r**26+10059925712720*r**28-5421764065736*r**30+349190098999*r**32
            -296058258004*r**34-22877575332*r**36-2019721970*r**38-111393023*r**40
            +5353830*r**42)+Q2**2*(14455775+1266088589*r**2-412625118*r**4+217995780164*r**6
            -1256783044359*r**8+8161841385043*r**10-25880881053966*r**12+54390652473544*r**14
            -32839166259042*r**16-25623157560118*r**18+14937874699996*r**20+6499117182224*r**22
            +63564386271386*r**24+11387512733742*r**26-68831208209812*r**28+27191083344504*r**30
            -12608200661581*r**32+1566594951993*r**34-748497467614*r**36-58144882836*r**38
            -5619477443*r**40-480698641*r**42+25053570*r**44))-836075520000*logq2**6*(
            -Q2+(-1+r)**2)*r**22*(-18-33*r**2-512*r**6+326*r**8+45*r**10)*(-Q2
            +(1+r)**2)*sqrtq2+66355200*logq2**4*r**14*(60*Q2**14*(279+1105*r**4)-60*Q2**13*(3672
            +3553*r**2+13184*r**4+12005*r**6)+6*Q2**12*(216522+397980*r**2+879960*r**4
            +1217787*r**6+560770*r**8)-4*Q2**11*(1102446+2916746*r**2+5719010*r**4
            +8812611*r**6+7107446*r**8+2178360*r**10)+Q2**10*(9157662+31630681*r**2
            +62692292*r**4+102204667*r**6+105754956*r**8+59741062*r**10+13516920*r**12)
            -10*Q2**9*(1094562+4964351*r**2+10058191*r**4+17452471*r**6+21517777*r**8
            +16715812*r**10+7286906*r**12+1344870*r**14)+5*Q2**8*(848286+7976115*r**2
            +14049744*r**4+23414022*r**6+37373222*r**8+43518791*r**10+30172424*r**12
            +11132460*r**14+2505060*r**16)-2*Q2**7*(-4062528+871560*r**2-21574260*r**4
            -81039648*r**6-85527785*r**8-9022188*r**10+65773250*r**12+55704100*r**14
            +20210067*r**16+9370620*r**18)+Q2**6*(-14591232-27280062*r**2-133532310*r**4
            -457180677*r**6-613653302*r**8-410556677*r**10-43933182*r**12+175267025*r**14
            +126444838*r**16+42740703*r**18+25254180*r**20)-4*Q2**5*(-2316114-6108162*r**2
            -26309109*r**4-108119484*r**6-142044207*r**8-97719918*r**10-8627437*r**12
            +50020851*r**14+51490781*r**16+26325998*r**18+8398326*r**20+3994935*r**22)
            -(-1+r**2)**4*(-124182+38701*r**2-2905026*r**4-5822095*r**6+17877786*r**8
            -12939494*r**10-34948534*r**12-35828334*r**14-2135360*r**16+29175209*r**18
            +10200296*r**20+483853*r**22+639180*r**24)-5*Q2**4*(-47736+2085258*r**2
            +1605498*r**4+25878921*r**6+28210614*r**8+5127676*r**10-21667370*r**12
            -42615694*r**14-25419898*r**16+12335474*r**18+5326264*r**20-2334627*r**22
            +1032420*r**24)+10*Q2**3*(-443556+573828*r**2-5282568*r**4-7874790*r**6
            +3305379*r**8-8687332*r**10-25552238*r**12-8823620*r**14+309336*r**16
            +3445412*r**18+32018534*r**20+14428426*r**22-621111*r**24+1692300*r**26)
            +2*Q2*(-1+r**2)**2*(-490842+405289*r**2-9300155*r**4-18555946*r**6+43857706*r**8
            -21569338*r**10-123343548*r**12-86672018*r**14-37179244*r**16+1269159*r**18
            +74591295*r**20+29403124*r**22+186388*r**24+2246130*r**26)+Q2**2*(3116862
            -5335435*r**2+49360670*r**4+60307542*r**6-189839810*r**8+138555941*r**10
            +391966600*r**12+302326440*r**14+7248446*r**16+5992315*r**18+178447522*r**20
            -223400190*r**22-137130410*r**24+11729387*r**26-12737880*r**28))*sqrtq2
            +46080*logq2**2*r**6*(24*Q2**22*(3349+23191*r**4)-24*Q2**21*(53244+44743*r**2
            +341916*r**4+399227*r**6)+8*Q2**20*(1141149+1938186*r**2+7548212*r**4
            +16204279*r**6+9269913*r**8)-16*Q2**19*(2388885+6200913*r**2+17996211*r**4
            +50023581*r**6+56128111*r**8+21236550*r**10)+Q2**18*(101371470+364376283*r**2
            +901939072*r**4+2925542404*r**6+4649993790*r**8+3571477829*r**10+1015255920*r**12)
            -2*Q2**17*(82990902+407489793*r**2+760476111*r**4+3079183744*r**6+6264453850*r**8
            +7013600283*r**10+4421219185*r**12+1015456548*r**14)+Q2**16*(124190814
            +1005250443*r**2-605927720*r**4+2360522459*r**6+10298899070*r**8+16041244481*r**10
            +19251003124*r**12+13358293273*r**14+2601432552*r**16)-8*Q2**15*(-13923204
            +17067252*r**2-1326430584*r**4-3838939006*r**6-6767174377*r**8-9484461898*r**10
            -7323319706*r**12-1336413278*r**14+1173902791*r**16+201367542*r**18)
            -4*Q2**14*(103924230+461839629*r**2+7069874398*r**4+27366106409*r**6
            +59883223146*r**8+98763664597*r**10+109101848210*r**12+73060945527*r**14
            +23648196448*r**16+1543875638*r**18+228768000*r**20)+8*Q2**13*(57789630
            +419259117*r**2+4658560473*r**4+23718707868*r**6+56853504860*r**8+104349367974*r**10
            +135528667572*r**12+121877950124*r**14+71681709642*r**16+22550628165*r**18
            +2862642671*r**20+387843480*r**22)-4*Q2**12*(23683686+620296833*r**2
            +3611063482*r**4+40919767270*r**6+92193166686*r**8+179874903864*r**10
            +265111420114*r**12+294461639190*r**14+254899956900*r**16+147431354047*r**18
            +43699855812*r**20+6461175500*r**22+755762904*r**24)+8*Q2**11*(-47911032
            -49186644*r**2-4425685472*r**4-1065658986*r**6-27485965883*r**8-74882465534*r**10
            -119893306538*r**12-125655979244*r**14-54665507600*r**16+23525424088*r**18
            +31950565618*r**20+8563522870*r**22+1805629995*r**24+127080954*r**26)
            +2*Q2**10*(253996626+1312179765*r**2+33707301004*r**4+95238282770*r**6
            +427663211674*r**8+1163066078355*r**10+2054655272808*r**12+2692243477820*r**14
            +2390087581998*r**16+1296820261587*r**18+363936348356*r**20+45528311954*r**22
            +20336551846*r**24-914446299*r**26+415924392*r**28)-4*Q2**9*(53227170
            +606841911*r**2+11226466297*r**4+53749728060*r**6+192995001626*r**8+638839813211*r**10
            +1177493558137*r**12+1736360711760*r**14+1959293099406*r**16+1535468746357*r**18
            +760731867411*r**20+240863926404*r**22+51248323574*r**24+21509118457*r**26
            +1008721467*r**28+317060400*r**30)+2*Q2**8*(-68409870+370756077*r**2
            -4927320492*r**4+52277135275*r**6-23716493510*r**8+484718620897*r**10
            +603587147548*r**12+798961328119*r**14+1644965959510*r**16+2446918974415*r**18
            +2142079382380*r**20+1047901209577*r**22+485282217070*r**24+118153207363*r**26
            +47382852420*r**28+3008049301*r**30+389783280*r**32)-8*Q2**7*(-29325612
            -62877084*r**2-5258584192*r**4+1025350222*r**6-92975388251*r**8-58991019510*r**10
            -320840189982*r**12-679437130574*r**14-608420561685*r**16-172017573438*r**18
            +277687239076*r**20+360796497330*r**22+156326837523*r**24+139280009422*r**26
            +36450984058*r**28+11461534670*r**30+843615305*r**32+33073602*r**34)
            -(-1+r**2)**6*(-111342-741639*r**2-60673944*r**4+127536874*r**6-3205168148*r**8
            +10217397442*r**10-29897017976*r**12-34740746198*r**14+193737188248*r**16
            -72930182964*r**18-319823878848*r**20+102654417774*r**22+101050018628*r**24
            -12171250498*r**26+11478112712*r**28+912649598*r**30+379158566*r**32
            +18007739*r**34+563976*r**36)+4*Q2**6*(-30822564-164742393*r**2-7952057988*r**4
            -4434808571*r**6-172196926538*r**8-139610466201*r**10-711416820346*r**12
            -1548839731179*r**14-1322256660234*r**16-640612627195*r**18+78477760518*r**20
            +575142317655*r**22+625539626354*r**24+119576944437*r**26+207757054018*r**28
            +61372155407*r**30+14701608134*r**32+1218148568*r**34+665718*r**36)+2*Q2*(
            -1+r**2)**4*(-716598-3444273*r**2-329128663*r**4+786724362*r**6-15396679070*r**8
            +43317800554*r**10-119537325386*r**12-133596075410*r**14+510084437102*r**16
            +63178550776*r**18-761468840424*r**20-725967628694*r**22+450004194774*r**24
            +371967238550*r**26-49120397302*r**28+47231589818*r**30+3477277328*r**32
            +1752942649*r**34+88115711*r**36+3044196*r**38)+8*Q2**5*(288354+39848442*r**2
            +719080673*r**4+2786827981*r**6+19234991160*r**8+37162801596*r**10+89812810270*r**12
            +266974341088*r**14-9628381328*r**16-167954937416*r**18-184968019052*r**20
            -85038377078*r**22+46680345184*r**24-96146507132*r**26+6044083818*r**28
            -1240741208*r**30-12002660394*r**32-532023730*r**34-136376381*r**36+12765153*r**38)
            -Q2**2*(-1+r**2)**2*(-7982526-21753423*r**2-3041778600*r**4+8989145879*r**6
            -127546337928*r**8+351340078348*r**10-919868411216*r**12-525259552124*r**14
            +2215611585292*r**16-3021863722*r**18-2026920891872*r**20-3055562194614*r**22
            -2964636195272*r**24+2293142877804*r**26+2334014554448*r**28-440159404156*r**30
            +323173862978*r**32+17236702721*r**34+13564741000*r**36+717803927*r**38
            +28453056*r**40)-4*Q2**4*(-9049440+16655433*r**2-2001397914*r**4+7755443082*r**6
            -61540954616*r**8+144871110442*r**10-311546954302*r**12-76582807342*r**14
            -203354864778*r**16-313968015972*r**18-273272118754*r**20-209950647090*r**22
            -56476766874*r**24+944867546150*r**26+527696521862*r**28-107341383098*r**30
            +148760610034*r**32-150875445*r**34+7327833396*r**36+344338576*r**38
            +29056650*r**40)+8*Q2**3*(-3002190-597906*r**2-923521234*r**4+3595029044*r**6
            -35720498475*r**8+106536716170*r**10-263249552734*r**12+56937186560*r**14
            +275846417250*r**16-181239122300*r**18-186552654138*r**20-113016227784*r**22
            -73679287688*r**24-624761140692*r**26+190539776150*r**28+496808887936*r**30
            -147119686436*r**32+73971576462*r**34+385633748*r**36+3413198100*r**38
            +183818947*r**40+9291210*r**42))*sqrtq2+128*r**2*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(3778*Q2**24*r**2+4*Q2**23*r**2*(11287+8598*r**2)-Q2**22*(123588
            +413273*r**2+8224490*r**4+1082761*r**6)+2*Q2**21*(777780-1722671*r**2
            +35004111*r**4+61875367*r**6+4542089*r**8)-Q2**20*(8503812-50984735*r**2
            +37764972*r**4+998164362*r**6+822398880*r**8+41372937*r**10)+2*Q2**19*(12728700
            -132562980*r**2-901178985*r**4+661081624*r**6+2942873210*r**8+1528445976*r**10
            +59110819*r**12)-2*Q2**18*(20316375-390311495*r**2-5091659678*r**4-6752046868*r**6
            +2275474247*r**8+8898882953*r**10+3314281240*r**12+109225494*r**14)+2*Q2**17*(7051536
            -708323153*r**2-14007579757*r**4-37493231467*r**6-41038508505*r**8-10868617423*r**10
            +12663463569*r**12+3504373331*r**14+122012037*r**16)+2*Q2**16*(38494035
            +732229265*r**2+21951008029*r**4+94715217408*r**6+188835172483*r**8+217395120444*r**10
            +96215255535*r**12+2577658284*r**14+1338261158*r**16-53118081*r**18)
            -4*Q2**15*(39250008+71665742*r**2+7794217857*r**4+70677943062*r**6+202496491933*r**8
            +383041239508*r**10+367031014753*r**12+145277957822*r**14+21470798447*r**16
            +4922384882*r**18+25153778*r**20)+2*Q2**14*(45441000-816525219*r**2-12436044120*r**4
            +108385242663*r**6+412173831462*r**8+1246305572796*r**10+1832857463502*r**12
            +1377181637232*r**14+429613472658*r**16+75122051295*r**18+12785084122*r**20
            +63447009*r**22)+4*Q2**13*(28748700+686758973*r**2+24034153640*r**4+30975280223*r**6
            +127757706961*r**8-118250027566*r**10-621436689468*r**12-800142266474*r**14
            -548090978314*r**16-100580856087*r**18-27634371188*r**20-1655382637*r**22
            +25532453*r**24)-2*Q2**12*(121122144+987001847*r**2+59579510354*r**4
            +328581634676*r**6+1610139222480*r**8+3458459706537*r**10+4168823558020*r**12
            +3995339392664*r**14+2196434429208*r**16+652009755025*r**18+354610677802*r**20
            +4424577508*r**22+10337037048*r**24+155770303*r**26)+4*Q2**11*(31386420
            -24559472*r**2+12474316946*r**4+231307151582*r**6+1136128711943*r**8
            +3708963216136*r**10+5775236989637*r**12+7460750155044*r**14+6365849224198*r**16
            +3238493271344*r**18+1124563674216*r**20+332870316638*r**22+23791326351*r**24
            +6335493112*r**26+55828017*r**28)+4*Q2**10*(25266267+443632186*r**2+18236167659*r**4
            -112307566516*r**6-271989447142*r**8-3097084550801*r**10-4537396749964*r**12
            -7678862302469*r**14-8839903586509*r**16-6300058585284*r**18-2535476092761*r**20
            -950596601722*r**22-186064896856*r**24-26447349461*r**26-1061240534*r**28
            +12847427*r**30)-4*Q2**9*(45685800+466338089*r**2+34804641940*r**4+116404688299*r**6
            +1191854347847*r**8+118709868125*r**10+3502410977810*r**12+4025263342807*r**14
            +2010102954021*r**16-509914552573*r**18-1200084113112*r**20+104176122297*r**22
            -277066973463*r**24+58483784119*r**26-20206127790*r**28+3677339461*r**30
            +47407203*r**32)+2*Q2**8*(39726450+344718077*r**2+42712113172*r**4+438538634254*r**6
            +2906321078682*r**8+4824455448068*r**10+17806946600368*r**12+33675596208210*r**14
            +39267779761754*r**16+32171722170394*r**18+13825339006356*r**20+3057582704978*r**22
            +2435068568422*r**24+62427172812*r**26+255826761064*r**28-17605497714*r**30
            +6522313972*r**32+50908761*r**34)+4*Q2**7*(10277928+115128287*r**2+5227842067*r**4
            -117369026250*r**6-184849413995*r**8-2474644963156*r**10-2788862795793*r**12
            -14950140579806*r**14-17491810825927*r**16-22452425330610*r**18-15145909592039*r**20
            -5837044372294*r**22-838765131585*r**24-976243826204*r**26-146870744475*r**28
            -43250233938*r**30-7133338485*r**32-279457021*r**34+7701696*r**36)+Q2**6*(
            -64416060-736571321*r**2-69458013030*r**4-96882874365*r**6-3561727951484*r**8
            +8751658749288*r**10-35558045124644*r**12+28721849799560*r**14-30289660300020*r**16
            +2702536567246*r**18+39453719823264*r**20+16658196219366*r**22+17169910415500*r**24
            +3631541898320*r**26+4697755838980*r**28+1583850727888*r**30-93534793696*r**32
            +63661889075*r**34-4797845530*r**36-64188737*r**38)+2*Q2**5*(13031604
            +187776613*r**2+21130475625*r**4+128301705435*r**6+1419372501261*r**8
            -3341617091804*r**10+24943724123140*r**12-19153623069060*r**14+48964439232260*r**16
            +27602674452886*r**18+10591370307470*r**20-25017965984374*r**22+3347659515310*r**24
            -10057584155820*r**26-2060258445260*r**28-2224904735604*r**30-866671094304*r**32
            +38698070925*r**34-20649046575*r**36+1505212563*r**38+13409709*r**40)
            +2*(-1+r**2)**4*(34659+722705*r**2+108983873*r**4+445530300*r**6+9028694702*r**8
            -81778006377*r**10+719397325476*r**12-3534479482064*r**14+11133706665250*r**16
            -17252093878806*r**18+5099830356782*r**20+15755349941032*r**22-14782890559416*r**24
            +5272665813550*r**26-1816517236044*r**28+165812414256*r**30-48893902237*r**32
            -12250845643*r**34-246027975*r**36-143926852*r**38+3984930*r**40+37899*r**42)
            +Q2**4*(3741300-18170649*r**2-1319927280*r**4-131272748878*r**6-162212251456*r**8
            +318254849331*r**10-16906210214352*r**12+31896247205464*r**14-73695371695432*r**16
            +5169426760542*r**18+26395731106736*r**20-34671131354196*r**22+77501996828912*r**24
            -10810216527602*r**26+6456922405584*r**28+2428167270360*r**30+957929963444*r**32
            +500092838779*r**34+10929006912*r**36+557737330*r**38-133022352*r**40
            +4437503*r**42)-2*Q2*(-1+r**2)**2*(396000+6633677*r**2+1014664621*r**4
            +2618079884*r**6+80642612988*r**8-660176777173*r**10+5000723732403*r**12
            -20258873122584*r**14+51013630879448*r**16-51618054103094*r**18-20941822100006*r**20
            +54846589719744*r**22+27996019632016*r**24-54818136264098*r**26+23148297139774*r**28
            -9487436899944*r**30+1077889587720*r**32-275563172039*r**34-89814530359*r**36
            +192673332*r**38-1338610252*r**40+42513831*r**42+434111*r**44)-2*Q2**3*(4148100
            +40950092*r**2+6211485451*r**4-11378765932*r**6+459907618232*r**8-2470254740392*r**10
            +10864373155817*r**12-22255082860112*r**14+25730924729616*r**16+829256522104*r**18
            +6654082618966*r**20+21138875931672*r**22-47437051581960*r**24-4591264598736*r**26
            +12701496713146*r**28-12155515642256*r**30+2203719740012*r**32-672497603748*r**34
            -255656757073*r**36+18162185268*r**38-7778581168*r**40+335315032*r**42
            +4577869*r**44)+2*Q2**2*(1860921+23456625*r**2+3775736972*r**4+1392908336*r**6
            +289222186475*r**8-2212685382853*r**10+13962686641812*r**12-48178138257620*r**14
            +102955593845170*r**16-97569848198270*r**18+21973992031888*r**20-32766019650616*r**22
            +84976954684078*r**24+22832780411694*r**26-83961339510560*r**28+44970935625024*r**30
            -19405243397179*r**32+2888589426941*r**34-477006048892*r**36-258265158520*r**38
            +10359667895*r**40-5038909017*r**42+180225004*r**44+2044692*r**46))*sqrtq2)*math.log(mu0))/(2116316160000*logq2**5*(
            -Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +48988800000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+102060000*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-4232632320000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-440899200000*logq2**4*(-Q2+(-1
            +r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-3061800000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -1417500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**6*sqrtq2)+((-10368000*logq2**4*r**12*(105*Q2**9*(1+5*r**4)-5*Q2**8*(249
            +361*r**2+1101*r**4+1005*r**6)+10*Q2**7*(597+1621*r**2+3496*r**4+4343*r**6
            +2025*r**8)-2*Q2**6*(7812+29149*r**2+64765*r**4+93125*r**6+69133*r**8
            +22260*r**10)+Q2**5*(22974+106027*r**2+250778*r**4+470915*r**6+412871*r**8
            +222906*r**10+55545*r**12)-Q2**4*(15540+92822*r**2+231869*r**4+588590*r**6
            +701120*r**8+419048*r**10+170935*r**12+31500*r**14)+2*Q2**3*(-1575+11024*r**2
            +40642*r**4+140278*r**6+184250*r**8+213791*r**10+81491*r**12+6005*r**14
            -5250*r**16)+(-1+r**2)**2*(1821+1633*r**2+608*r**4+116088*r**6-193788*r**8
            -187194*r**10+70224*r**12-1996*r**14+12199*r**16+4005*r**18)+Q2**2*(13020
            +15118*r**2-11915*r**4+119156*r**6-143159*r**8-108758*r**10-29109*r**12
            -13188*r**14+70635*r**16+29400*r**18)+Q2*(-8331-4469*r**2+12109*r**4
            -306011*r**6+264845*r**8+760417*r**10+146475*r**12-137073*r**14+34282*r**16
            -38464*r**18-18180*r**20))-2880*logq2**2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1
            +r)**2)*(9795*Q2**15*(1+5*r**4)-Q2**14*(120261+121493*r**2+521937*r**4
            +598665*r**6)+Q2**13*(604329+1271816*r**2+3448100*r**4+5662978*r**6
            +3101085*r**8)-Q2**12*(1583961+5382217*r**2+14984690*r**4+28081086*r**6
            +25269377*r**8+8589165*r**10)+Q2**11*(2105649+11648083*r**2+36582862*r**4
            +85246604*r**6+92230079*r**8+57617593*r**10+12508410*r**12)-Q2**10*(491931
            +12207009*r**2+35377311*r**4+134400931*r**6+171469901*r**8+105720395*r**10
            +60971217*r**12+4741065*r**14)-Q2**9*(2776653-630711*r**2+40542531*r**4
            -18250145*r**6-76727145*r**8+99740803*r**10+137775089*r**12+9194301*r**14
            +14803920*r**16)+Q2**8*(4096917+13919013*r**2+148377380*r**4+308632144*r**6
            +276891690*r**8+613334922*r**10+965758108*r**12+553194480*r**14+104109969*r**16
            +25872705*r**18)-Q2**7*(1474803+15840426*r**2+133162825*r**4+526474548*r**6
            +441833406*r**8+535880328*r**10+1378107826*r**12+1544646700*r**14+552418143*r**16
            +112180446*r**18+12267045*r**20)-Q2**6*(1984323-5804169*r**2+37730299*r**4
            -375497397*r**6+59872778*r**8+1109296634*r**10+899482146*r**12-562848086*r**14
            -848754237*r**16+108366543*r**18-25743789*r**20+10701195*r**22)+Q2**5*(2538327
            +2759198*r**2+163842602*r**4-105799688*r**6+754730047*r**8+3936007492*r**10
            +6253024212*r**12+5020022232*r**14+1457563277*r**16+277470622*r**18+679323650*r**20
            +45080784*r**22+17078205*r**24)-Q2**4*(816711+4176143*r**2+106088382*r**4
            +37433530*r**6+675121145*r**8+5072470653*r**10+10494698764*r**12+12060215356*r**14
            +7391704305*r**16+1851552905*r**18+608344086*r**20+492090218*r**22+42539887*r**24
            +6699915*r**26)+Q2**3*(-449121+2478871*r**2-15046580*r**4+146543328*r**6
            -217727825*r**8+2390168207*r**10+6033710428*r**12+8865032760*r**14+8622117469*r**16
            +3173450165*r**18-114834436*r**20+529359176*r**22-28759755*r**24+12234053*r**26
            -2577540*r**28)+(-1+r**2)**2*(22059-8871*r**2+4419683*r**4-20995819*r**6
            +139149983*r**8+108523417*r**10-822294713*r**12+958091149*r**14-873751727*r**16
            -1787782061*r**18+714996889*r**20+332955959*r**22-45911707*r**24+21722171*r**26
            +603453*r**28+180135*r**30)+Q2**2*(491139-1071907*r**2+52895515*r**4
            -206636041*r**6+887443983*r**8+331547957*r**10-575705201*r**12+1159538095*r**14
            -467647463*r**16-3196260881*r**18+1744035569*r**20+1843553133*r**22-528696235*r**24
            +221511679*r**26+1577573*r**28+3503085*r**30)-Q2*(170451-340323*r**2
            +26200363*r**4-129435949*r**6+685390901*r**8+206205825*r**10-1660142489*r**12
            +533888479*r**14-2084679017*r**16-716426537*r**18-4677079583*r**20+1411398297*r**22
            +1553436983*r**24-348894709*r**26+117080461*r**28+1592757*r**30+1314090*r**32))
            -4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(552*Q2**20+Q2**19*(1230-86*r**2)
            +8*Q2**18*(993+5225*r**2+2309*r**4)-Q2**17*(793689+350881*r**2+3840383*r**4
            +361615*r**6)+Q2**16*(6432021+485746*r**2+21116616*r**4+38837094*r**6
            +2083563*r**8)-2*Q2**15*(11471247-3133150*r**2-25946401*r**4+101248489*r**6
            +84688408*r**8+2973871*r**10)+Q2**14*(40359885-25706302*r**2-675511331*r**4
            -240427744*r**6+819403091*r**8+369434110*r**10+8820563*r**12)-2*Q2**13*(9542901
            +2669295*r**2-1085865336*r**4-1900280100*r**6-466447889*r**8+803851653*r**10
            +146175660*r**12+1926168*r**14)-Q2**12*(59715123-229084978*r**2+3370785104*r**4
            +12061520622*r**6+13661765622*r**8+4700526258*r**10-1023582864*r**12
            +443437586*r**14+8895575*r**16)+2*Q2**11*(59958951-268593854*r**2+1107903779*r**4
            +11402737423*r**6+22250625111*r**8+21253490637*r**10+7314514917*r**12
            +1008667129*r**14+657468074*r**16+7744633*r**18)-Q2**10*(58479135-343542210*r**2
            -1563244539*r**4+28898194668*r**6+83780882714*r**8+119396855352*r**10
            +86936703870*r**12+20253826772*r**14+5147480295*r**16+1012294602*r**18
            +4642781*r**20)-2*Q2**9*(40320930-289047506*r**2+3077122489*r**4-7457575429*r**6
            -38957895394*r**8-82778419030*r**10-77053270204*r**12-39150651796*r**14
            +935601416*r**16-2231515984*r**18+284894555*r**20+6165809*r**22)+Q2**8*(131865747
            -1224415370*r**2+8366116250*r**4+22850768770*r**6+14448039489*r**8-64268195484*r**10
            -79801386780*r**12+13590947148*r**14+34024103325*r**16+42359779974*r**18
            -138163070*r**20+1608087890*r**22+15087631*r**24)-2*Q2**7*(23013981-298988206*r**2
            +2129722329*r**4+24289171323*r**6+44661674978*r**8+47234796729*r**10
            +36834968682*r**12+99832766070*r**14+112780665993*r**16+70234457628*r**18
            +22785681581*r**20+1785794655*r**22+443650152*r**24+1609065*r**26)+Q2**6*(
            -50293017+573373078*r**2-4626548429*r**4+31899242456*r**6+36006884167*r**8
            +122998331518*r**10-10829320837*r**12+138039439968*r**14+312641956557*r**16
            +104398998674*r**18+120087044929*r**20-4550430776*r**22+3888809861*r**24
            -428397478*r**26-6511471*r**28)+2*Q2**5*(29194197-444109285*r**2+4525970488*r**4
            -275635120*r**6+18388466093*r**8-60188517893*r**10+167931853520*r**12
            +190859318848*r**14+102048773903*r**16-113442017999*r**18+106822746176*r**20
            -18953374040*r**22+21874725359*r**24-911000263*r**26+391781176*r**28
            +2932040*r**30)-Q2**4*(16040505-330507126*r**2+4716323316*r**4+11233089714*r**6
            +15112005104*r**8-109573193430*r**10+588173222796*r**12+1020409892898*r**14
            +1022875599762*r**16+793357092462*r**18-158390301780*r**20+246316285446*r**22
            +12506888136*r**24+28602910174*r**26+237801684*r**28+303592230*r**30
            +1130109*r**32)+2*Q2**3*(-4614882+74166205*r**2-641187947*r**4+4894880565*r**6
            -13870779821*r**8+15069143875*r**10+131583868765*r**12+374509317573*r**14
            +620236955535*r**16+357597187597*r**18+244037521191*r**20+44917866615*r**22
            -6716860655*r**24+18960340425*r**26-1947071001*r**28+487848591*r**30
            -44487185*r**32-543446*r**34)+2*(-1+r**2)**2*(156654-4170412*r**2+84909051*r**4
            -230578818*r**6+358432710*r**8-5882078502*r**10+74768865726*r**12-231116744978*r**14
            +245764096194*r**16+10125137730*r**18-301537274708*r**20+192462278634*r**22
            -40827260622*r**24+11311878366*r**26-1463840190*r**28+470139306*r**30
            -9537448*r**32+2698674*r**34+12633*r**36)+Q2**2*(8644899-184657634*r**2
            +2643449645*r**4-7304295692*r**6+26751377328*r**8-128117752164*r**10
            +487154478120*r**12-363509890492*r**14+372778090654*r**16-540957326056*r**18
            -236996217094*r**20+896363366812*r**22-445606313176*r**24+180868302468*r**26
            -43091242272*r**28+13124189484*r**30-673003673*r**32+121417898*r**34
            +820945*r**36)-Q2*(2682531-67137509*r**2+1183056495*r**4-3779339229*r**6
            +10174715552*r**8-75459588888*r**10+590033884272*r**12-1177510543480*r**14
            +327748803822*r**16+838933914054*r**18-299472890442*r**20-1671324890442*r**22
            +1404998019000*r**24-419673325232*r**26+125884294536*r**28-23421714576*r**30
            +6145926679*r**32-221450265*r**34+42311139*r**36+231983*r**38))-2177280000*logq2**5*r**16*(9
            +33*r**2+124*r**4-512*r**6+163*r**8+15*r**10)*sqrtq2-172800*logq2**3*r**8*(2265*Q2**12*(1
            +5*r**4)-10*Q2**11*(2439+2383*r**2+10431*r**4+12315*r**6)+2*Q2**10*(57951
            +108258*r**2+244605*r**4+469607*r**6+288855*r**8)-10*Q2**9*(29970+83928*r**2
            +146473*r**4+295842*r**6+354501*r**8+147330*r**10)+10*Q2**8*(41607+170403*r**2
            +278381*r**4+438443*r**6+778226*r**8+693972*r**10+202860*r**12)-5*Q2**7*(38556
            +357489*r**2+504564*r**4+81617*r**6+473328*r**8+1688379*r**10+1329480*r**12
            +183195*r**14)-5*Q2**6*(57960-124467*r**2+295925*r**4+2741021*r**6+5136449*r**8
            +4066963*r**10+490035*r**12-165669*r**14+303975*r**16)+Q2**5*(516456
            +573363*r**2+6551210*r**4+31603502*r**6+74308470*r**8+90473156*r**10
            +56145758*r**12+15840170*r**14+4559562*r**16+2731905*r**18)-5*Q2**4*(52515
            +155709*r**2+1212342*r**4+6057464*r**6+18583638*r**8+30158754*r**10
            +25695316*r**12+11271144*r**14+2845431*r**16+897153*r**18+290790*r**20)
            -5*Q2**3*(15654-103659*r**2+43130*r**4-1514209*r**6-9251464*r**8-16383518*r**10
            -20394136*r**12-15196618*r**14-1758062*r**16+32217*r**18-420306*r**20
            +77595*r**22)+(-1+r**2)**2*(11592-18345*r**2+695733*r**4-81745*r**6
            +3122037*r**8-1180470*r**10-14149954*r**12-15771798*r**14+390*r**16
            +4605983*r**18+1554573*r**20-25881*r**22+69885*r**24)+5*Q2**2*(31338
            -69451*r**2+887491*r**4+908653*r**6-272311*r**8+1288894*r**10-641462*r**12
            -3234082*r**14-4073984*r**16+4774573*r**18+1844691*r**20-206955*r**22
            +173805*r**24)-5*Q2*(14292-36669*r**2+633636*r**4+13564*r**6+1113684*r**8
            +2288967*r**10-11520768*r**12-8298456*r**14-2304012*r**16-3015687*r**18
            +2866908*r**20+1350204*r**22-122908*r**24+82845*r**26))*sqrtq2+24*logq2*(250*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*(111+105*Q2**7-4517*r**2-91999*r**4-164085*r**6
            +1160315*r**8+1928089*r**10+482547*r**12+59769*r**14+1530*r**16-5*Q2**6*(
            -81+31*r**2+240*r**4)+15*Q2**5*(-29-16*r**2+59*r**4+60*r**6)-Q2**4*(
            -321+243*r**2+50107*r**4+69411*r**6+9180*r**8)+Q2**3*(-729-1592*r**2
            +81550*r**4+220582*r**6+137739*r**8+14130*r**10)+Q2**2*(-309-1389*r**2
            -6978*r**4-105212*r**6-125831*r**8-9611*r**10+3210*r**12)+Q2*(531
            -5304*r**2-92255*r**4+33430*r**6+433925*r**8+246424*r**10-45401*r**12
            -9390*r**14))-21*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))**2*(12*Q2**10*(16+205*r**4)-60*Q2**9*(12
            +12*r**2+211*r**4+275*r**6)+5*Q2**8*(135+270*r**2+4314*r**4+11146*r**6
            +7335*r**8)-60*Q2**7*(-8+24*r**2+157*r**4+1047*r**6+1313*r**8+335*r**10)
            -30*Q2**6*(30-60*r**2+1447*r**4-433*r**6-2349*r**8-1871*r**10+1260*r**12)
            -60*Q2**3*r**4*(911-1449*r**2-3631*r**4-8165*r**6-7971*r**8-5223*r**10
            -2237*r**12+405*r**14)+4*Q2**5*(-36+540*r**2+28785*r**4+42905*r**6
            +47430*r**8+26514*r**10-8755*r**12+13545*r**14)-30*Q2**4*(-19+186*r**2
            +2071*r**4+5553*r**6+13432*r**8+25138*r**10+17181*r**12+1723*r**14
            +175*r**16)+120*Q2*r**4*(116-1379*r**2-13454*r**4-26131*r**6-17070*r**8
            +5559*r**10+4294*r**12-3241*r**14-574*r**16+40*r**18)-3*(-1+r**2)**2*(
            -9+252*r**2+1793*r**4-41806*r**6-222100*r**8-331426*r**10+64268*r**12
            +55502*r**14-35299*r**16-10330*r**18+755*r**20)+10*Q2**2*(-18+324*r**2
            +3303*r**4-12811*r**6+4917*r**8-22143*r**10-69061*r**12+4839*r**14
            +41457*r**16-3457*r**18+810*r**20))+5*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(30*Q2**15*(1408
            +21355*r**4)-2*Q2**14*(96000+94432*r**2+1841499*r**4+2340195*r**6)+2*Q2**13*(104790
            +289648*r**2+3915889*r**4+9514666*r**6+5723805*r**8)-2*Q2**12*(-133320
            +288212*r**2+3327327*r**4+13894203*r**6+15357559*r**8+3207495*r**10)
            -Q2**11*(609120+109589*r**2+10179979*r**4-5890972*r**6+7743536*r**8
            -6924137*r**10+16303365*r**12)+Q2**10*(-40920+1633551*r**2+30535728*r**4
            +65571913*r**6+235481588*r**8+272338493*r**10+42702732*r**12+22088835*r**14)
            +Q2**9*(641100-1712547*r**2+31855101*r**4+21155575*r**6-292239145*r**8
            -760113305*r**10-578560777*r**12-81091979*r**14+9040905*r**16)-Q2**8*(42360
            +3220167*r**2+163398546*r**4+343826564*r**6+457158230*r**8+205758050*r**10
            +11525982*r**12+39997316*r**14-36530286*r**16+27976095*r**18)+2*Q2**7*(
            -254640+2882199*r**2+59353974*r**4+212515616*r**6+792221208*r**8+1247452960*r**10
            +1272164694*r**12+879465024*r**14+591679136*r**16+53346393*r**18+2437740*r**20)
            +2*Q2**6*(27720+789339*r**2+49458789*r**4-137890762*r**6-928880024*r**8
            -2512926912*r**10-3883645666*r**12-2844620746*r**14-654115832*r**16-302888899*r**18
            -64932987*r**20+7687740*r**22)-2*Q2**5*(-155010+3179651*r**2+75489978*r**4
            +9011143*r**6+1178158688*r**8+1814989088*r**10+143656338*r**12-3265427532*r**14
            -2615233912*r**16-196798587*r**18+465594828*r**20+20256957*r**22+3747810*r**24)
            +2*Q2**4*(-34800+429893*r**2+13092911*r**4+254473345*r**6+3066154535*r**8
            +5518907760*r**10+6022535174*r**12+6239930638*r**14+7188662350*r**16
            +3828621065*r**18+247777115*r**20+414022033*r**22+54467051*r**24-1103070*r**26)
            +Q2**3*(-102720+2946871*r**2+35076693*r**4-430516868*r**6-1622270680*r**8
            -2407501785*r**10-3972479207*r**12-2896383656*r**14-1879468064*r**16
            -11455837155*r**18-12282676545*r**20-2245358164*r**22+56844088*r**24
            -12757243*r**26+1697235*r**28)-(-1+r**2)**2*(6840-262821*r**2+694140*r**4
            +53693853*r**6+340327528*r**8+1056435675*r**10+19830812092*r**12+41828023405*r**14
            +31273693864*r**16+1060482649*r**18-2366456780*r**20+2425860079*r**22
            +553946680*r**24+35499633*r**26-2265452*r**28+132615*r**30)-Q2**2*(-29640
            +759349*r**2+18796244*r**4+90389751*r**6+2573379748*r**8-4264509115*r**10
            -16074629528*r**12-38907744713*r**14-43242750992*r**16-9250682441*r**18
            +9496395540*r**20+4191654029*r**22-988650956*r**24+236074191*r**26+30677168*r**28
            +247365*r**30)+Q2*(18180-712839*r**2+5167701*r**4+197422827*r**6+1553553159*r**8
            -2371820983*r**10+36772678093*r**12+121033122043*r**14+172424472631*r**16
            +58661293507*r**18-8400275609*r**20-4648158839*r**22+8076387181*r**24
            +934073467*r**26+119024759*r**28+5960337*r**30+290385*r**32)))*sqrtq2)*math.log(mus))/(4408992000*logq2**4*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+61236000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +42525*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-10581580800*logq2**5*r**20*sqrtq2
            -734832000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-2551500*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+((10368000*logq2**4*r**12*(105*Q2**9*(1
            +5*r**4)-5*Q2**8*(249+361*r**2+1101*r**4+1005*r**6)+10*Q2**7*(597+1621*r**2
            +3496*r**4+4343*r**6+2025*r**8)-2*Q2**6*(7812+29149*r**2+64765*r**4
            +93125*r**6+69133*r**8+22260*r**10)+Q2**5*(22974+106027*r**2+250778*r**4
            +470915*r**6+412871*r**8+222906*r**10+55545*r**12)-Q2**4*(15540+92822*r**2
            +231869*r**4+588590*r**6+701120*r**8+419048*r**10+170935*r**12+31500*r**14)
            +2*Q2**3*(-1575+11024*r**2+40642*r**4+140278*r**6+184250*r**8+213791*r**10
            +81491*r**12+6005*r**14-5250*r**16)+(-1+r**2)**2*(1821+1633*r**2+608*r**4
            +116088*r**6-193788*r**8-187194*r**10+70224*r**12-1996*r**14+12199*r**16
            +4005*r**18)+Q2**2*(13020+15118*r**2-11915*r**4+119156*r**6-143159*r**8
            -108758*r**10-29109*r**12-13188*r**14+70635*r**16+29400*r**18)+Q2*(
            -8331-4469*r**2+12109*r**4-306011*r**6+264845*r**8+760417*r**10+146475*r**12
            -137073*r**14+34282*r**16-38464*r**18-18180*r**20))+2880*logq2**2*(-Q2
            +(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(9795*Q2**15*(1+5*r**4)-Q2**14*(120261
            +121493*r**2+521937*r**4+598665*r**6)+Q2**13*(604329+1271816*r**2+3448100*r**4
            +5662978*r**6+3101085*r**8)-Q2**12*(1583961+5382217*r**2+14984690*r**4
            +28081086*r**6+25269377*r**8+8589165*r**10)+Q2**11*(2105649+11648083*r**2
            +36582862*r**4+85246604*r**6+92230079*r**8+57617593*r**10+12508410*r**12)
            -Q2**10*(491931+12207009*r**2+35377311*r**4+134400931*r**6+171469901*r**8
            +105720395*r**10+60971217*r**12+4741065*r**14)-Q2**9*(2776653-630711*r**2
            +40542531*r**4-18250145*r**6-76727145*r**8+99740803*r**10+137775089*r**12
            +9194301*r**14+14803920*r**16)+Q2**8*(4096917+13919013*r**2+148377380*r**4
            +308632144*r**6+276891690*r**8+613334922*r**10+965758108*r**12+553194480*r**14
            +104109969*r**16+25872705*r**18)-Q2**7*(1474803+15840426*r**2+133162825*r**4
            +526474548*r**6+441833406*r**8+535880328*r**10+1378107826*r**12+1544646700*r**14
            +552418143*r**16+112180446*r**18+12267045*r**20)-Q2**6*(1984323-5804169*r**2
            +37730299*r**4-375497397*r**6+59872778*r**8+1109296634*r**10+899482146*r**12
            -562848086*r**14-848754237*r**16+108366543*r**18-25743789*r**20+10701195*r**22)
            +Q2**5*(2538327+2759198*r**2+163842602*r**4-105799688*r**6+754730047*r**8
            +3936007492*r**10+6253024212*r**12+5020022232*r**14+1457563277*r**16
            +277470622*r**18+679323650*r**20+45080784*r**22+17078205*r**24)-Q2**4*(816711
            +4176143*r**2+106088382*r**4+37433530*r**6+675121145*r**8+5072470653*r**10
            +10494698764*r**12+12060215356*r**14+7391704305*r**16+1851552905*r**18
            +608344086*r**20+492090218*r**22+42539887*r**24+6699915*r**26)+Q2**3*(
            -449121+2478871*r**2-15046580*r**4+146543328*r**6-217727825*r**8+2390168207*r**10
            +6033710428*r**12+8865032760*r**14+8622117469*r**16+3173450165*r**18
            -114834436*r**20+529359176*r**22-28759755*r**24+12234053*r**26-2577540*r**28)
            +(-1+r**2)**2*(22059-8871*r**2+4419683*r**4-20995819*r**6+139149983*r**8
            +108523417*r**10-822294713*r**12+958091149*r**14-873751727*r**16-1787782061*r**18
            +714996889*r**20+332955959*r**22-45911707*r**24+21722171*r**26+603453*r**28
            +180135*r**30)+Q2**2*(491139-1071907*r**2+52895515*r**4-206636041*r**6
            +887443983*r**8+331547957*r**10-575705201*r**12+1159538095*r**14-467647463*r**16
            -3196260881*r**18+1744035569*r**20+1843553133*r**22-528696235*r**24+221511679*r**26
            +1577573*r**28+3503085*r**30)-Q2*(170451-340323*r**2+26200363*r**4
            -129435949*r**6+685390901*r**8+206205825*r**10-1660142489*r**12+533888479*r**14
            -2084679017*r**16-716426537*r**18-4677079583*r**20+1411398297*r**22+1553436983*r**24
            -348894709*r**26+117080461*r**28+1592757*r**30+1314090*r**32))+4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(552*Q2**20+Q2**19*(1230-86*r**2)+8*Q2**18*(993
            +5225*r**2+2309*r**4)-Q2**17*(793689+350881*r**2+3840383*r**4+361615*r**6)
            +Q2**16*(6432021+485746*r**2+21116616*r**4+38837094*r**6+2083563*r**8)
            -2*Q2**15*(11471247-3133150*r**2-25946401*r**4+101248489*r**6+84688408*r**8
            +2973871*r**10)+Q2**14*(40359885-25706302*r**2-675511331*r**4-240427744*r**6
            +819403091*r**8+369434110*r**10+8820563*r**12)-2*Q2**13*(9542901+2669295*r**2
            -1085865336*r**4-1900280100*r**6-466447889*r**8+803851653*r**10+146175660*r**12
            +1926168*r**14)-Q2**12*(59715123-229084978*r**2+3370785104*r**4+12061520622*r**6
            +13661765622*r**8+4700526258*r**10-1023582864*r**12+443437586*r**14+8895575*r**16)
            +2*Q2**11*(59958951-268593854*r**2+1107903779*r**4+11402737423*r**6+22250625111*r**8
            +21253490637*r**10+7314514917*r**12+1008667129*r**14+657468074*r**16
            +7744633*r**18)-Q2**10*(58479135-343542210*r**2-1563244539*r**4+28898194668*r**6
            +83780882714*r**8+119396855352*r**10+86936703870*r**12+20253826772*r**14
            +5147480295*r**16+1012294602*r**18+4642781*r**20)-2*Q2**9*(40320930-289047506*r**2
            +3077122489*r**4-7457575429*r**6-38957895394*r**8-82778419030*r**10-77053270204*r**12
            -39150651796*r**14+935601416*r**16-2231515984*r**18+284894555*r**20+6165809*r**22)
            +Q2**8*(131865747-1224415370*r**2+8366116250*r**4+22850768770*r**6+14448039489*r**8
            -64268195484*r**10-79801386780*r**12+13590947148*r**14+34024103325*r**16
            +42359779974*r**18-138163070*r**20+1608087890*r**22+15087631*r**24)-2*Q2**7*(23013981
            -298988206*r**2+2129722329*r**4+24289171323*r**6+44661674978*r**8+47234796729*r**10
            +36834968682*r**12+99832766070*r**14+112780665993*r**16+70234457628*r**18
            +22785681581*r**20+1785794655*r**22+443650152*r**24+1609065*r**26)+Q2**6*(
            -50293017+573373078*r**2-4626548429*r**4+31899242456*r**6+36006884167*r**8
            +122998331518*r**10-10829320837*r**12+138039439968*r**14+312641956557*r**16
            +104398998674*r**18+120087044929*r**20-4550430776*r**22+3888809861*r**24
            -428397478*r**26-6511471*r**28)+2*Q2**5*(29194197-444109285*r**2+4525970488*r**4
            -275635120*r**6+18388466093*r**8-60188517893*r**10+167931853520*r**12
            +190859318848*r**14+102048773903*r**16-113442017999*r**18+106822746176*r**20
            -18953374040*r**22+21874725359*r**24-911000263*r**26+391781176*r**28
            +2932040*r**30)-Q2**4*(16040505-330507126*r**2+4716323316*r**4+11233089714*r**6
            +15112005104*r**8-109573193430*r**10+588173222796*r**12+1020409892898*r**14
            +1022875599762*r**16+793357092462*r**18-158390301780*r**20+246316285446*r**22
            +12506888136*r**24+28602910174*r**26+237801684*r**28+303592230*r**30
            +1130109*r**32)+2*Q2**3*(-4614882+74166205*r**2-641187947*r**4+4894880565*r**6
            -13870779821*r**8+15069143875*r**10+131583868765*r**12+374509317573*r**14
            +620236955535*r**16+357597187597*r**18+244037521191*r**20+44917866615*r**22
            -6716860655*r**24+18960340425*r**26-1947071001*r**28+487848591*r**30
            -44487185*r**32-543446*r**34)+2*(-1+r**2)**2*(156654-4170412*r**2+84909051*r**4
            -230578818*r**6+358432710*r**8-5882078502*r**10+74768865726*r**12-231116744978*r**14
            +245764096194*r**16+10125137730*r**18-301537274708*r**20+192462278634*r**22
            -40827260622*r**24+11311878366*r**26-1463840190*r**28+470139306*r**30
            -9537448*r**32+2698674*r**34+12633*r**36)+Q2**2*(8644899-184657634*r**2
            +2643449645*r**4-7304295692*r**6+26751377328*r**8-128117752164*r**10
            +487154478120*r**12-363509890492*r**14+372778090654*r**16-540957326056*r**18
            -236996217094*r**20+896363366812*r**22-445606313176*r**24+180868302468*r**26
            -43091242272*r**28+13124189484*r**30-673003673*r**32+121417898*r**34
            +820945*r**36)-Q2*(2682531-67137509*r**2+1183056495*r**4-3779339229*r**6
            +10174715552*r**8-75459588888*r**10+590033884272*r**12-1177510543480*r**14
            +327748803822*r**16+838933914054*r**18-299472890442*r**20-1671324890442*r**22
            +1404998019000*r**24-419673325232*r**26+125884294536*r**28-23421714576*r**30
            +6145926679*r**32-221450265*r**34+42311139*r**36+231983*r**38))+2177280000*logq2**5*r**16*(9
            +33*r**2+124*r**4-512*r**6+163*r**8+15*r**10)*sqrtq2+172800*logq2**3*r**8*(2265*Q2**12*(1
            +5*r**4)-10*Q2**11*(2439+2383*r**2+10431*r**4+12315*r**6)+2*Q2**10*(57951
            +108258*r**2+244605*r**4+469607*r**6+288855*r**8)-10*Q2**9*(29970+83928*r**2
            +146473*r**4+295842*r**6+354501*r**8+147330*r**10)+10*Q2**8*(41607+170403*r**2
            +278381*r**4+438443*r**6+778226*r**8+693972*r**10+202860*r**12)-5*Q2**7*(38556
            +357489*r**2+504564*r**4+81617*r**6+473328*r**8+1688379*r**10+1329480*r**12
            +183195*r**14)-5*Q2**6*(57960-124467*r**2+295925*r**4+2741021*r**6+5136449*r**8
            +4066963*r**10+490035*r**12-165669*r**14+303975*r**16)+Q2**5*(516456
            +573363*r**2+6551210*r**4+31603502*r**6+74308470*r**8+90473156*r**10
            +56145758*r**12+15840170*r**14+4559562*r**16+2731905*r**18)-5*Q2**4*(52515
            +155709*r**2+1212342*r**4+6057464*r**6+18583638*r**8+30158754*r**10
            +25695316*r**12+11271144*r**14+2845431*r**16+897153*r**18+290790*r**20)
            -5*Q2**3*(15654-103659*r**2+43130*r**4-1514209*r**6-9251464*r**8-16383518*r**10
            -20394136*r**12-15196618*r**14-1758062*r**16+32217*r**18-420306*r**20
            +77595*r**22)+(-1+r**2)**2*(11592-18345*r**2+695733*r**4-81745*r**6
            +3122037*r**8-1180470*r**10-14149954*r**12-15771798*r**14+390*r**16
            +4605983*r**18+1554573*r**20-25881*r**22+69885*r**24)+5*Q2**2*(31338
            -69451*r**2+887491*r**4+908653*r**6-272311*r**8+1288894*r**10-641462*r**12
            -3234082*r**14-4073984*r**16+4774573*r**18+1844691*r**20-206955*r**22
            +173805*r**24)-5*Q2*(14292-36669*r**2+633636*r**4+13564*r**6+1113684*r**8
            +2288967*r**10-11520768*r**12-8298456*r**14-2304012*r**16-3015687*r**18
            +2866908*r**20+1350204*r**22-122908*r**24+82845*r**26))*sqrtq2+24*logq2*(
            -250*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(111+105*Q2**7-4517*r**2-91999*r**4
            -164085*r**6+1160315*r**8+1928089*r**10+482547*r**12+59769*r**14+1530*r**16
            -5*Q2**6*(-81+31*r**2+240*r**4)+15*Q2**5*(-29-16*r**2+59*r**4+60*r**6)
            -Q2**4*(-321+243*r**2+50107*r**4+69411*r**6+9180*r**8)+Q2**3*(-729
            -1592*r**2+81550*r**4+220582*r**6+137739*r**8+14130*r**10)+Q2**2*(-309
            -1389*r**2-6978*r**4-105212*r**6-125831*r**8-9611*r**10+3210*r**12)
            +Q2*(531-5304*r**2-92255*r**4+33430*r**6+433925*r**8+246424*r**10
            -45401*r**12-9390*r**14))+21*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(12*Q2**10*(16+205*r**4)
            -60*Q2**9*(12+12*r**2+211*r**4+275*r**6)+5*Q2**8*(135+270*r**2+4314*r**4
            +11146*r**6+7335*r**8)-60*Q2**7*(-8+24*r**2+157*r**4+1047*r**6+1313*r**8
            +335*r**10)-30*Q2**6*(30-60*r**2+1447*r**4-433*r**6-2349*r**8-1871*r**10
            +1260*r**12)-60*Q2**3*r**4*(911-1449*r**2-3631*r**4-8165*r**6-7971*r**8
            -5223*r**10-2237*r**12+405*r**14)+4*Q2**5*(-36+540*r**2+28785*r**4
            +42905*r**6+47430*r**8+26514*r**10-8755*r**12+13545*r**14)-30*Q2**4*(
            -19+186*r**2+2071*r**4+5553*r**6+13432*r**8+25138*r**10+17181*r**12
            +1723*r**14+175*r**16)+120*Q2*r**4*(116-1379*r**2-13454*r**4-26131*r**6
            -17070*r**8+5559*r**10+4294*r**12-3241*r**14-574*r**16+40*r**18)-3*(
            -1+r**2)**2*(-9+252*r**2+1793*r**4-41806*r**6-222100*r**8-331426*r**10
            +64268*r**12+55502*r**14-35299*r**16-10330*r**18+755*r**20)+10*Q2**2*(
            -18+324*r**2+3303*r**4-12811*r**6+4917*r**8-22143*r**10-69061*r**12
            +4839*r**14+41457*r**16-3457*r**18+810*r**20))-5*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(30*Q2**15*(1408+21355*r**4)-2*Q2**14*(96000+94432*r**2+1841499*r**4
            +2340195*r**6)+2*Q2**13*(104790+289648*r**2+3915889*r**4+9514666*r**6
            +5723805*r**8)-2*Q2**12*(-133320+288212*r**2+3327327*r**4+13894203*r**6
            +15357559*r**8+3207495*r**10)-Q2**11*(609120+109589*r**2+10179979*r**4
            -5890972*r**6+7743536*r**8-6924137*r**10+16303365*r**12)+Q2**10*(-40920
            +1633551*r**2+30535728*r**4+65571913*r**6+235481588*r**8+272338493*r**10
            +42702732*r**12+22088835*r**14)+Q2**9*(641100-1712547*r**2+31855101*r**4
            +21155575*r**6-292239145*r**8-760113305*r**10-578560777*r**12-81091979*r**14
            +9040905*r**16)-Q2**8*(42360+3220167*r**2+163398546*r**4+343826564*r**6
            +457158230*r**8+205758050*r**10+11525982*r**12+39997316*r**14-36530286*r**16
            +27976095*r**18)+2*Q2**7*(-254640+2882199*r**2+59353974*r**4+212515616*r**6
            +792221208*r**8+1247452960*r**10+1272164694*r**12+879465024*r**14+591679136*r**16
            +53346393*r**18+2437740*r**20)+2*Q2**6*(27720+789339*r**2+49458789*r**4
            -137890762*r**6-928880024*r**8-2512926912*r**10-3883645666*r**12-2844620746*r**14
            -654115832*r**16-302888899*r**18-64932987*r**20+7687740*r**22)-2*Q2**5*(
            -155010+3179651*r**2+75489978*r**4+9011143*r**6+1178158688*r**8+1814989088*r**10
            +143656338*r**12-3265427532*r**14-2615233912*r**16-196798587*r**18+465594828*r**20
            +20256957*r**22+3747810*r**24)+2*Q2**4*(-34800+429893*r**2+13092911*r**4
            +254473345*r**6+3066154535*r**8+5518907760*r**10+6022535174*r**12+6239930638*r**14
            +7188662350*r**16+3828621065*r**18+247777115*r**20+414022033*r**22+54467051*r**24
            -1103070*r**26)+Q2**3*(-102720+2946871*r**2+35076693*r**4-430516868*r**6
            -1622270680*r**8-2407501785*r**10-3972479207*r**12-2896383656*r**14-1879468064*r**16
            -11455837155*r**18-12282676545*r**20-2245358164*r**22+56844088*r**24
            -12757243*r**26+1697235*r**28)-(-1+r**2)**2*(6840-262821*r**2+694140*r**4
            +53693853*r**6+340327528*r**8+1056435675*r**10+19830812092*r**12+41828023405*r**14
            +31273693864*r**16+1060482649*r**18-2366456780*r**20+2425860079*r**22
            +553946680*r**24+35499633*r**26-2265452*r**28+132615*r**30)-Q2**2*(-29640
            +759349*r**2+18796244*r**4+90389751*r**6+2573379748*r**8-4264509115*r**10
            -16074629528*r**12-38907744713*r**14-43242750992*r**16-9250682441*r**18
            +9496395540*r**20+4191654029*r**22-988650956*r**24+236074191*r**26+30677168*r**28
            +247365*r**30)+Q2*(18180-712839*r**2+5167701*r**4+197422827*r**6+1553553159*r**8
            -2371820983*r**10+36772678093*r**12+121033122043*r**14+172424472631*r**16
            +58661293507*r**18-8400275609*r**20-4648158839*r**22+8076387181*r**24
            +934073467*r**26+119024759*r**28+5960337*r**30+290385*r**32)))*sqrtq2)*math.log(2*muWC))/(4082400000*logq2**4*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+56700000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +39375*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-9797760000*logq2**5*r**20*sqrtq2
            -680400000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-2362500*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+((497664000*logq2**5*r**18*(-210*Q2**11*(49
            +125*r**4)+10*Q2**10*(14259+15667*r**2+32775*r**4+19575*r**6)-10*Q2**9*(83937
            +171748*r**2+264802*r**4+200800*r**6+46125*r**8)+2*Q2**8*(1411641+3943101*r**2
            +6438650*r**4+5530410*r**6+1841841*r**8-80595*r**10)+Q2**7*(-5928741
            -19921107*r**2-35723836*r**4-34025710*r**6-15676481*r**8+1305489*r**10
            +2918970*r**12)+Q2**6*(7706601+29221626*r**2+56324891*r**4+55705276*r**6
            +29041891*r**8+796430*r**10-12602079*r**12-5893020*r**14)+Q2**5*(-5257917
            -22937691*r**2-46192853*r**4-42394761*r**6-20577129*r**8+7340251*r**10
            +12890421*r**12+12108033*r**14+3888990*r**16)+(-1+r**2)**4*(-208383
            -229856*r**2-260786*r**4+1346934*r**6-8398844*r**8-2582726*r**10+2107722*r**12
            +694282*r**14+1580227*r**16+568710*r**18)+Q2**4*(-220815+5561850*r**2
            +12945842*r**4+7434242*r**6-5094660*r**8-12310570*r**10-14286418*r**12
            +1002790*r**14+7520835*r**16+3742200*r**18)+Q2**3*(3826683+3776343*r**2
            +3564992*r**4+589864*r**6+31404110*r**8+41665718*r**10-12855640*r**12
            -8980208*r**14-10256545*r**16-21009957*r**18-9549360*r**20)-Q2*(-1
            +r**2)**2*(-1322979-1354757*r**2-1241766*r**4+4286394*r**6-34298720*r**8
            -41761560*r**10+6523698*r**12+11162542*r**14+3341307*r**16+8225301*r**18
            +3378780*r**20)+Q2**2*(-3356619-1338888*r**2-713387*r**4+7214814*r**6
            -59703630*r**8-52243136*r**10-23663886*r**12+16995348*r**14+14525977*r**16
            -4831944*r**18+12836601*r**20+8155230*r**22))+276480*logq2**3*(-Q2+(
            -1+r)**2)*r**10*(-Q2+(1+r)**2)*(-90*Q2**17*(16471+84395*r**4)+6*Q2**16*(3482337
            +3229545*r**2+15723821*r**4+16575765*r**6)-4*Q2**15*(32099283+59022813*r**2
            +162703824*r**4+268675289*r**6+143970885*r**8)+4*Q2**14*(111272130+308109879*r**2
            +747344475*r**4+1394507647*r**6+1318157005*r**8+479830500*r**10)-Q2**13*(920635065
            +3543962409*r**2+8769631094*r**4+17479771882*r**6+21137946857*r**8+14334993005*r**10
            +3991230000*r**12)+Q2**12*(1017147915+5834119776*r**2+14467488173*r**4
            +31630148434*r**6+43587214609*r**8+40048743128*r**10+22832754815*r**12
            +5164739550*r**14)-2*Q2**11*(32702733+2249107407*r**2+2976107931*r**4
            +8164388038*r**6+12335121868*r**8+12894146319*r**10+15106209131*r**12
            +9852617144*r**14+1828362285*r**16)+2*Q2**10*(-778751127-864023604*r**2
            -13272851611*r**4-32996384697*r**6-55344722195*r**8-71477293479*r**10
            -49056201057*r**12-9936575467*r**14+2308496974*r**16+166914135*r**18)
            +Q2**9*(2223571185+7725894993*r**2+58578648920*r**4+174397678954*r**6
            +318763984580*r**8+457927845560*r**10+434820714398*r**12+235252852870*r**14
            +60191623979*r**16+7426783335*r**18+1970102250*r**20)-Q2**8*(997969995
            +7529279832*r**2+44466651777*r**4+182097044416*r**6+345817767006*r**8
            +552129752740*r**10+667449374042*r**12+517179233532*r**14+225565619431*r**16
            +58608113556*r**18+9000838965*r**20+2472844500*r**22)+4*Q2**7*(-214613190
            +633505662*r**2-4014885399*r**4+14213685443*r**6+11534200328*r**8+7036702736*r**10
            +51997687422*r**12+99453386916*r**14+82706571848*r**16+32301108398*r**18
            +15937308261*r**20+2349059205*r**22+662742450*r**24)-4*Q2**6*(-370949229
            -333036867*r**2-15214730034*r**4-13850642188*r**6-70656974133*r**8-179955932467*r**10
            -176284335638*r**12-63946249770*r**14+49714493867*r**16+58581772017*r**18
            +22448769520*r**20+22899338814*r**22+3072179263*r**24+657064845*r**26)
            +Q2**5*(-757538271-1932357303*r**2-46399745838*r**4-57884078654*r**6
            -287198323165*r**8-811573907161*r**10-846546095696*r**12-455544918188*r**14
            +53010048847*r**16+320166422815*r**18+221579686962*r**20+66054517514*r**22
            +72578506061*r**24+10049935697*r**26+1346153580*r**28)+(-1+r**2)**4*(
            -4863843-1989234*r**2-626165747*r**4+1495442498*r**6-8745822999*r**8
            -4397429174*r**10+28985577913*r**12+6407201734*r**14-74608137161*r**16
            -62268881822*r**18+53553923527*r**20+26047037646*r**22-1089231037*r**24
            +2762391238*r**26+164454771*r**28+30171690*r**30)+Q2**4*(-80909955+1246208616*r**2
            +3032125955*r**4+31593665058*r**6+52585985425*r**8+264254468000*r**10
            +200332132023*r**12-17073085510*r**14-173532861241*r**16-200193030120*r**18
            -36032499095*r**20-2705245514*r**22-29827141845*r**24+4247563808*r**26
            -2675928355*r**28+483720750*r**30)-Q2*(-1+r**2)**2*(-45778653+33310743*r**2
            -4816113311*r**4+11866630701*r**6-57512633041*r**8-33347702373*r**10
            +157914606549*r**12-45025751743*r**14-223186720927*r**16-287681769403*r**18
            -191867319565*r**20+261967020343*r**22+149685193829*r**24-15384042999*r**26
            +17830005719*r**28+958278491*r**30+242225640*r**32)-2*Q2**3*(-156188655
            +365120067*r**2-9743968073*r**4+20308975726*r**6-68146551394*r**8-46971277355*r**10
            +26969760761*r**12-107892920364*r**14-78279565282*r**16-32238924387*r**18
            -16606780455*r**20+221532436222*r**22+144844990262*r**24-24558110069*r**26
            +27831202231*r**28+922848640*r**30+605512125*r**32)+2*Q2**2*(-87748695
            +190692288*r**2-7469030751*r**4+21721673747*r**6-81379258973*r**8-3899469431*r**10
            +153785168769*r**12-140128629093*r**14-162943470859*r**16-78135311239*r**18
            -22543588933*r**20-248532558127*r**22+150206912169*r**24+176133876787*r**26
            -39117067613*r**28+22600340609*r**30+833246870*r**32+393662475*r**34))
            -192*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(20598*Q2**23*(-1
            +115*r**4)-6*Q2**22*(-46643-168003*r**2+4545881*r**4+7450745*r**6)+6*Q2**21*(
            -279427-1893200*r**2+8744450*r**4+85616188*r**6+59617105*r**8)-2*Q2**20*(
            -2830101-30697693*r**2-325912574*r**4+698982418*r**6+1909429559*r**8
            +806722815*r**10)+Q2**19*(-11015025-226179145*r**2-5334697722*r**4-5637534394*r**6
            +7077830431*r**8+14911225907*r**10+4473153300*r**12)+Q2**18*(9122637
            +666684500*r**2+20985664503*r**4+52673119470*r**6+59684383255*r**8+9167593908*r**10
            -31568384803*r**12-7439620830*r**14)+Q2**17*(10480833-1586887607*r**2
            -53638427233*r**4-189410269713*r**6-398365462557*r**8-502401112161*r**10
            -204834508087*r**12+24283302481*r**14+5385491580*r**16)+Q2**16*(-38998017
            +2732441920*r**2+92134019958*r**4+420031947470*r**6+1155961653180*r**8
            +2376677817470*r**10+2334979717690*r**12+848933848298*r**14+50616857605*r**16
            +5290415130*r**18)-4*Q2**15*(-10328418+659099921*r**2+21966174426*r**4
            +148306145534*r**6+448192009469*r**8+1351331461704*r**10+2031388682729*r**12
            +1511755903106*r**14+447265219749*r**16+43187892479*r**18+4290379845*r**20)
            +4*Q2**14*(1004700-119558885*r**2-6212251321*r**4+87620675828*r**6+81068996513*r**8
            +1119558365069*r**10+2769251315087*r**12+3217084886375*r**14+2068725114203*r**16
            +481276221128*r**18+55013647426*r**20+3688971525*r**22)+4*Q2**13*(-14884962
            +1346757925*r**2+56309847474*r**4+145808355925*r**6+1427870502495*r**8
            +2854066734448*r**10+2923634715922*r**12+2292492398268*r**14+257480957770*r**16
            -728262193925*r**18-63936007204*r**20-25501720529*r**22+1153984905*r**24)
            -4*Q2**12*(-15324582+1737032453*r**2+82032248415*r**4+431892548919*r**6
            +3490658885286*r**8+11186577287601*r**10+19080023447822*r**12+25004489480046*r**14
            +21086450386458*r**16+9537948176747*r**18+2211473778595*r**20+536686351803*r**22
            +21971286038*r**24+5247369855*r**26)+2*Q2**11*(-2040051+993059145*r**2
            +74019737688*r**4+916074609346*r**6+6730424536565*r**8+32926092786639*r**10
            +64154873676360*r**12+100523876094732*r**14+109518705470679*r**16+75985219999215*r**18
            +30255595348232*r**20+7614682527010*r**22+1417363401303*r**24+85918787721*r**26
            +7747208040*r**28)+2*Q2**10*(-23650689+2513530968*r**2+101514475887*r**4
            -184245631388*r**6+1761427545193*r**8-17438753472518*r**10-28318032163651*r**12
            -55322280008142*r**14-83179326922567*r**16-82978860777148*r**18-52718284722511*r**20
            -17166353328160*r**22-4831020526593*r**24-659015905878*r**26-56709374397*r**28
            +1827315210*r**30)-2*Q2**9*(-21849675+3363562305*r**2+183800444133*r**4
            +671875982171*r**6+11626485062461*r**8+14598327628149*r**10+60516046428053*r**12
            +116241777182511*r**14+132521912359479*r**16+100687052655979*r**18+32269736476015*r**20
            +2371034931513*r**22+3868558950047*r**24-393076738529*r**26+171736330071*r**28
            -9326733123*r**30+6806959800*r**32)+2*Q2**8*(-3195099+1189744300*r**2
            +96250448372*r**4+820258873020*r**6+10940904886050*r**8+29538649593606*r**10
            +95606704645944*r**12+238498359601632*r**14+341927379935280*r**16+375265286577090*r**18
            +249878023242948*r**20+88495653222108*r**22+21063731358486*r**24+10582359819210*r**26
            +1237246926480*r**28+360075081800*r**30+17761728883*r**32+3837582210*r**34)
            +2*Q2**7*(-8793981+1075370374*r**2+40059077019*r**4-323493587452*r**6
            -49015810458*r**8-20620648213972*r**10-17568789531994*r**12-155819693874156*r**14
            -213651064384732*r**16-317008769328328*r**18-334249179998940*r**20-179900476770484*r**22
            -64439682401638*r**24-13954085732556*r**26-10343740813894*r**28-1261523055332*r**30
            -216349672231*r**32-25107793310*r**34+867872865*r**36)-2*Q2**6*(-7539939
            +1418953895*r**2+85330898463*r**4+129783778853*r**6+8034692179910*r**8
            -10732797260022*r**10+84374420572870*r**12-14067039588198*r**14+128709131763432*r**16
            +151925432380240*r**18-31696930184724*r**20-150692484346980*r**22-51493970407478*r**24
            -65526138831738*r**26-18801572547270*r**28-13932442133050*r**30-1566255658645*r**32
            -140085645447*r**34-19636157707*r**36+2171981535*r**38)+2*Q2**5*(-1860159
            +554222818*r**2+43490301986*r**4+207605975702*r**6+6302436862139*r**8
            -6567266695540*r**10+95983817357556*r**12+1828302019524*r**14+243052615265238*r**16
            +388002007645776*r**18+186216281014152*r**20-10896084000816*r**22-182366681773086*r**24
            +2217521822388*r**26-68208802429044*r**28-19895941896388*r**30-12263562280183*r**32
            -1352246825074*r**34-92856795178*r**36-6656063846*r**38+941668035*r**40)
            +(-1+r**2)**4*(-11553+3671764*r**2+368388184*r**4+1377065534*r**6+91285215721*r**8
            -512915601086*r**10+4572493931088*r**12-18612231743272*r**14+50083742579318*r**16
            -20789839657568*r**18-156440837332544*r**20+235241341760452*r**22-10798435153358*r**24
            -78780478489588*r**26+21376067571248*r**28-11323954326792*r**30+416414677051*r**32
            -529762400804*r**34-39228058264*r**36-3276483026*r**38-130767275*r**40
            +5404770*r**42)+2*Q2**4*(-1003125+106188085*r**2+2209193136*r**4-99269342288*r**6
            -704205873093*r**8-981683527655*r**10-22536458888296*r**12+310178098536*r**14
            -81716742231562*r**16-180251834028502*r**18+79689050772744*r**20+13922936257112*r**22
            +2756011204670*r**24+167022700267338*r**26-5553293671192*r**28+6315186728152*r**30
            +10060704111999*r**32+1964313676033*r**34+322881965512*r**36+5187497912*r**38
            -3642661241*r**40+142705725*r**42)+Q2**3*(2003007-410705425*r**2-27507148038*r**4
            +42509690790*r**6-3675029247585*r**8+16297509180663*r**10-86624153332748*r**12
            +189734622231944*r**14-316548605484450*r**16+73817943252430*r**18-201171520985316*r**20
            -40389134294076*r**22-138259530271754*r**24+419786355240630*r**26+265365608983920*r**28
            -147321306456760*r**30+132611121947971*r**32-15974753224797*r**34+10550065845530*r**36
            +746289863110*r**38+92899707531*r**40+11024860403*r**42-633976980*r**44)
            -Q2*(-1+r**2)**2*(-143553+40812989*r**2+3659140264*r**4+7344573748*r**6
            +774766766977*r**8-4254246119077*r**10+32926534749764*r**12-114362006457512*r**14
            +264863361606926*r**16-67504648202086*r**18-532753415458776*r**20+295033382136384*r**22
            +640883354090202*r**24-59408335572946*r**26-401762868202784*r**28+122392345418920*r**30
            -65817944506141*r**32+4452818921401*r**34-3562831875728*r**36-268980815732*r**38
            -24981216139*r**40-1329204121*r**42+61477020*r**44)+Q2**2*(-752307+187518028*r**2
            +14684465891*r**4-2560085862*r**6+2607951950367*r**8-14844007993416*r**10
            +96374977561913*r**12-306387593248110*r**14+656284923766066*r**16-408232151476776*r**18
            -303586913544850*r**20+176342323358308*r**22+83590352857774*r**24+753478610471984*r**26
            +111206919677826*r**28-809888331930524*r**30+330047901423633*r**32-153529284376132*r**34
            +19544258528607*r**36-9039554356542*r**38-674615074653*r**40-70500722632*r**42
            -5701218923*r**44+287040330*r**46))+209018880000*logq2**6*(-Q2+(-1+r)**2)*r**22*(
            -225-429*r**2-124*r**4-5632*r**6+3749*r**8+525*r**10)*(-Q2+(1+r)**2)*sqrtq2
            -16588800*logq2**4*r**14*(60*Q2**14*(3377+13405*r**4)-120*Q2**13*(22208
            +21466*r**2+79867*r**4+72970*r**6)+6*Q2**12*(2617826+4805856*r**2+10637575*r**4
            +14778633*r**6+6838150*r**8)-2*Q2**11*(26647116+70413092*r**2+137986051*r**4
            +213259528*r**6+172915973*r**8+53370900*r**10)+Q2**10*(110628411+381659909*r**2
            +755216979*r**4+1231699169*r**6+1280859364*r**8+729077558*r**10+166666050*r**12)
            -10*Q2**9*(13217241+59882920*r**2+120972855*r**4+209121960*r**6+258426131*r**8
            +202388874*r**10+89248837*r**12+16667550*r**14)+5*Q2**8*(10242783+96208929*r**2
            +167853870*r**4+273874526*r**6+435771587*r**8+512898185*r**10+362089656*r**12
            +136086348*r**14+30488580*r**16)+Q2**7*(97953048-21313512*r**2+536476305*r**4
            +2041351084*r**6+2268312885*r**8+477325768*r**10-1408476057*r**12-1289889660*r**14
            -481602261*r**16-221353200*r**18)+Q2**6*(-175833486-328673502*r**2-1634573181*r**4
            -5631864263*r**6-7753120133*r**8-5525998671*r**10-1055780487*r**12+1822696979*r**14
            +1435730727*r**16+498588297*r**18+296620200*r**20)+Q2**5*(111556068+294785112*r**2
            +1289382777*r**4+5306483752*r**6+7206623102*r**8+5383775112*r**10+1191576732*r**12
            -1846800928*r**14-2247175058*r**16-1203829728*r**18-391218021*r**20-187737000*r**22)
            -(-1+r**2)**4*(-1492671+427187*r**2-35673895*r**4-69272285*r**6+206366260*r**8
            -152306888*r**10-390966524*r**12-411053180*r**14-28887665*r**16+345510565*r**18
            +120271859*r**20+5752937*r**22+7620300*r**24)-5*Q2**4*(-585138+25209150*r**2
            +19785885*r**4+317133631*r**6+375587782*r**8+124571710*r**10-185981920*r**12
            -429627424*r**14-249544048*r**16+155091540*r**18+64045491*r**20-26992239*r**22
            +12361260*r**24)+5*Q2**3*(-10682736+13808400*r**2-129834387*r**4-190216012*r**6
            +81386695*r**8-216160416*r**10-599357194*r**12-198941504*r**14+15212706*r**16
            +97365464*r**18+753615901*r**20+338675628*r**22-14460345*r**24+40234200*r**26)
            +Q2*(-1+r**2)**2*(-11805882+9551572*r**2-228577141*r**4-443440390*r**6
            +1018148475*r**8-542647776*r**10-2804066274*r**12-1912994208*r**14-851493060*r**16
            +23929800*r**18+1763492183*r**20+692308102*r**22+4458499*r**24+53504100*r**26)
            +Q2**2*(37505271-63868199*r**2+606131570*r**4+716220738*r**6-2231704865*r**8
            +1715730083*r**10+4511045678*r**12+3336618620*r**14-59149651*r**16+65378615*r**18
            +2085882646*r**20-2636669454*r**22-1611427315*r**24+139117213*r**26-151546950*r**28))*sqrtq2
            -2304*logq2**2*r**6*(24*Q2**22*(197717+1375345*r**4)-32*Q2**21*(2352483
            +1965668*r**2+15187050*r**4+17756880*r**6)+8*Q2**20*(67098831+113319348*r**2
            +444449511*r**4+960049925*r**6+549707385*r**8)-40*Q2**19*(56089938+144785142*r**2
            +419987001*r**4+1180408316*r**6+1330363649*r**8+503729790*r**10)+5*Q2**18*(1188154599
            +4246654015*r**2+10394235652*r**4+34235597964*r**6+54872462593*r**8+42324815909*r**10
            +12043854060*r**12)-2*Q2**17*(4855301511+23683021110*r**2+42555406615*r**4
            +177059719520*r**6+365545964845*r**8+413045256246*r**10+261918957245*r**12
            +60285710460*r**14)+Q2**16*(7244736099+58005715929*r**2-47273165795*r**4
            +106338333835*r**6+557162134885*r**8+904540021559*r**10+1122885309299*r**12
            +790938564485*r**14+154882095240*r**16)+4*Q2**15*(1633724412-1612953084*r**2
            +161669451077*r**4+473345068320*r**6+842695177665*r**8+1175937674252*r**10
            +904377243051*r**12+170220989712*r**14-138725993245*r**16-24293050080*r**18)
            -20*Q2**14*(1214033937+5511631293*r**2+84743545509*r**4+330269875571*r**6
            +727476100569*r**8+1200665920311*r**10+1322273566907*r**12+882341340549*r**14
            +284757226614*r**16+18423180956*r**18+2577641160*r**20)+20*Q2**13*(1346861142
            +9905583720*r**2+110959284951*r**4+568762115680*r**6+1373621922478*r**8
            +2530362511464*r**10+3281217743956*r**12+2939168620072*r**14+1722870418524*r**16
            +540336300304*r**18+67988706517*r**20+9079870680*r**22)-4*Q2**12*(1361000433
            +36305723935*r**2+212451299060*r**4+2438290498680*r**6+5549315389830*r**8
            +10943489502462*r**10+16128696813480*r**12+17780034998400*r**14+15277924940925*r**16
            +8820193384875*r**18+2613278634268*r**20+383443749520*r**22+44867854980*r**24)
            +4*Q2**11*(-5602527684-6411852564*r**2-530249151835*r**4-155908686840*r**6
            -3352886489425*r**8-8919927601576*r**10-14188350742406*r**12-15017711071960*r**14
            -6773544720430*r**16+2568892569940*r**18+3749702430401*r**20+1023712357296*r**22
            +214524329955*r**24+15955135560*r**26)+2*Q2**10*(14802564309+78744324477*r**2
            +2011000254874*r**4+5776581018110*r**6+25938395789915*r**8+69965837263131*r**10
            +122998861811368*r**12+161336212510396*r**14+144116220215595*r**16+79208003761075*r**18
            +22851266206714*r**20+2991640553222*r**22+1215441741189*r**24-55496206155*r**26
            +22428496740*r**28)-20*Q2**9*(617697873+7220620862*r**2+133762771076*r**4
            +648508529112*r**6+2347063412153*r**8+7698272033834*r**10+14063132121060*r**12
            +20675388044484*r**14+23395807339035*r**16+18473255062770*r**18+9277061518700*r**20
            +2981986618784*r**22+634556688891*r**24+257842416326*r**26+11795744844*r**28
            +3659843940*r**30)+10*Q2**8*(-801762279+4275091035*r**2-58832555707*r**4
            +621876454459*r**6-251146701499*r**8+5867446061975*r**10+6925256797681*r**12
            +8655715061423*r**14+18435203638619*r**16+28317759530857*r**18+25340078115095*r**20
            +12650249123081*r**22+5845965380719*r**24+1408442213093*r**26+570698120307*r**28
            +35348117581*r**30+4753132440*r**32)-4*Q2**7*(-3419652612-7934571660*r**2
            -626434056575*r**4+83162917360*r**6-11146950626615*r**8-6945884107308*r**10
            -39668450522135*r**12-85414000319600*r**14-79722870071535*r**16-28080492261860*r**18
            +28038948550987*r**20+41173909643760*r**22+18518835398515*r**24+16428400771420*r**26
            +4239255192395*r**28+1384306630928*r**30+99519913655*r**32+4550738880*r**34)
            -(-1+r**2)**6*(-6471483-46003907*r**2-3608406950*r**4+7114407390*r**6
            -190404347370*r**8+612806398074*r**10-1867076924934*r**12-1945767940810*r**14
            +11652970665440*r**16-4638728734860*r**18-18698923208074*r**20+6239844648314*r**22
            +5887598824170*r**24-728746562250*r**26+689736535230*r**28+52646463858*r**30
            +22814056027*r**32+1072397215*r**34+35404920*r**36)+4*Q2**6*(-1793122719
            -10067291349*r**2-473433909665*r**4-302301643005*r**6-10338850119945*r**8
            -8210297884011*r**10-43820903024931*r**12-96932833835805*r**14-86807083467495*r**16
            -48057713849205*r**18-4180715597661*r**20+28937700220689*r**22+35442001467525*r**24
            +7022815921215*r**26+12200037689575*r**28+3550338292041*r**30+887933195466*r**32
            +72149967670*r**34+412127610*r**36)+2*Q2*(-1+r**2)**4*(-41669703-216525450*r**2
            -19567936447*r**4+44482493140*r**6-914897373120*r**8+2599637316624*r**10
            -7456989386040*r**12-7709800997424*r**14+31027237967770*r**16+3290337490460*r**18
            -45233229700014*r**20-41951255664920*r**22+27008093309864*r**24+21664418898240*r**26
            -2937621912960*r**28+2840027017968*r**30+198391641285*r**32+105556036382*r**34
            +5233970725*r**36+192223620*r**38)+4*Q2**5*(31366182+4742627616*r**2
            +85706590557*r**4+343967103280*r**6+2319627855810*r**8+4343402555048*r**10
            +11323947371554*r**12+34224823102808*r**14+2547003590630*r**16-15870958355960*r**18
            -17378119221412*r**20-5457204139336*r**22+8149305326998*r**24-10837106768200*r**26
            +714315344430*r**28-56777925368*r**30-1400618422884*r**32-63816561288*r**34
            -16444837385*r**36+1487956920*r**38)-20*Q2**4*(-105543561+174517311*r**2
            -23771873712*r**4+90781768060*r**6-731329073570*r**8+1729469988080*r**10
            -3797069392252*r**12-803042492548*r**14-2361388018002*r**16-3872528490418*r**18
            -3390552884452*r**20-2518005375684*r**22-363564333148*r**24+11359099276664*r**26
            +6138106583836*r**28-1287087210812*r**30+1793437271875*r**32-8952547317*r**34
            +88591037428*r**36+4013318152*r**38+366674070*r**40)-Q2**2*(-1+r**2)**2*(
            -464439723-1419907641*r**2-180754869199*r**4+515624611043*r**6-7575537901640*r**8
            +21066408439044*r**10-56981572306092*r**12-30075954986748*r**14+134793249554326*r**16
            -243662513270*r**18-119122805691874*r**20-179786579924318*r**22-170601783020132*r**24
            +137747213141444*r**26+135985273120260*r**28-26340680310492*r**30+19471793906301*r**32
            +949425583079*r**34+817863118937*r**36+42454472275*r**38+1807524420*r**40)
            +20*Q2**3*(-69923496-32852960*r**2-21933516323*r**4+83541162912*r**6
            -847658566233*r**8+2548851602860*r**10-6450184808124*r**12+1529762746104*r**14
            +6630039557052*r**16-4412718923736*r**18-4101625808378*r**20-2489010485832*r**22
            -1900716832974*r**24-14579490342240*r**26+4758674283956*r**28+11604330640680*r**30
            -3530194494444*r**32+1789971282168*r**34+71262501*r**36+82502564488*r**38
            +4314370559*r**40+236921460*r**42))*sqrtq2+32*r**2*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(552*Q2**25-2*Q2**24*(213+23539*r**2)+Q2**23*(5358
            -502304*r**2-392870*r**4)+Q2**22*(669099+4459243*r**2+94672761*r**4
            +12577033*r**6)-4*Q2**21*(2459235-11341421*r**2+201565512*r**4+358358661*r**6
            +26451653*r**8)+Q2**20*(58232559-628528627*r**2+430168634*r**4+11586302678*r**6
            +9568243627*r**8+483591337*r**10)-Q2**19*(185047371-3222116988*r**2-20832020225*r**4
            +15517775056*r**6+68552721909*r**8+35711553420*r**10+1388607473*r**12)
            +2*Q2**18*(158397804-4742486449*r**2-58926887298*r**4-77928988871*r**6
            +26412840152*r**8+103729774153*r**10+38920329666*r**12+1292236395*r**14)
            +Q2**17*(-156949551+17531106944*r**2+325264378878*r**4+867599200168*r**6
            +958196066916*r**8+262948776656*r**10-293941897358*r**12-83306167128*r**14
            -2926494117*r**16)+2*Q2**16*(-253492950-9638948410*r**2-256447281587*r**4
            -1094322168829*r**6-2196182542873*r**8-2561506649803*r**10-1148999526965*r**12
            -33749550667*r**14-14445103209*r**16+673436589*r**18)+8*Q2**15*(145517943
            +786827378*r**2+46402016183*r**4+405928502682*r**6+1166545594266*r**8
            +2240233875404*r**10+2169488826624*r**12+865845008778*r**14+127347932087*r**16
            +28587035286*r**18+137295689*r**20)-2*Q2**14*(388882803-9270935577*r**2
            -137780520435*r**4+1221240178561*r**6+4599221531222*r**8+14348404144214*r**10
            +21452068665298*r**12+16290492738194*r**14+5124879034271*r**16+885619882699*r**18
            +150719133817*r**20+743783269*r**22)-4*Q2**13*(180802293+9505489858*r**2
            +276228363908*r**4+381729638046*r**6+1714675674121*r**8-934136163436*r**10
            -6846609381908*r**12-9209519182484*r**14-6471332873293*r**16-1213852139462*r**18
            -323124634256*r**20-21073737882*r**22+282236975*r**24)+2*Q2**12*(883797717
            +16768255855*r**2+688967949150*r**4+3833407548674*r**6+19431869672387*r**8
            +42451797845777*r**10+51837742127516*r**12+49553735640708*r**14+26969237025371*r**16
            +7773785024081*r**18+4163907818134*r**20+58723144298*r**22+117535233309*r**24
            +1800347039*r**26)-2*Q2**11*(510477105+2037871372*r**2+292775643225*r**4
            +5342076834456*r**6+27063596615377*r**8+89580217014124*r**10+140730574589513*r**12
            +181684329062160*r**14+154262605256259*r**16+77862539555300*r**18+26618316501819*r**20
            +7898574440152*r**22+559518593595*r**24+147778497316*r**26+1320836131*r**28)
            +4*Q2**10*(-162097839-6904404290*r**2-204493558429*r**4+1265905598816*r**6
            +3130320637561*r**8+37160943921358*r**10+55386473133831*r**12+93788441909564*r**14
            +107204558497099*r**16+75840930206354*r**18+30314893707529*r**20+11165095955616*r**22
            +2256676446571*r**24+305953889026*r**26+13742209581*r**28-133796732*r**30)
            +2*Q2**9*(666415827+17226844520*r**2+785833906630*r**4+2808323412656*r**6
            +28811011764350*r**8+3716759628328*r**10+83570470198406*r**12+94218984281808*r**14
            +46636132490084*r**16-11285713424008*r**18-27050485539310*r**20+2979046699024*r**22
            -6270150050782*r**24+1221827584376*r**26-465438722526*r**28+83068517616*r**30
            +1089884841*r**32)-2*Q2**8*(314201331+7114785613*r**2+483861390834*r**4
            +5166166296878*r**6+35147705919042*r**8+59234177383878*r**10+214563955538522*r**12
            +402701573120934*r**14+469643636379048*r**16+387865783258784*r**18+169900309034022*r**20
            +39919479197562*r**22+29988295826222*r**24+872226702954*r**26+2937281075854*r**28
            -208151285326*r**30+75436546293*r**32+598029795*r**34)+2*Q2**7*(-133729743
            -4460587112*r**2-110840777989*r**4+2691957391384*r**6+4737245688532*r**8
            +59812926993632*r**10+68176820146228*r**12+356825147943592*r**14+414677039132606*r**16
            +535552937885344*r**18+365351747511586*r**20+142768646021864*r**22+21129848063620*r**24
            +24375735910336*r**26+3242584281844*r**28+1083790227800*r**30+158867698105*r**32
            +7537728552*r**34-169907781*r**36)+Q2**6*(468376755+14945516587*r**2
            +763697629289*r**4+1376540367249*r**6+42489618361404*r**8-103297904943476*r**10
            +421679973012388*r**12-339768125933004*r**14+383577510150586*r**16-6182130225350*r**18
            -451550823598658*r**20-197701646013602*r**22-208658100388724*r**24-37275114501444*r**26
            -58239601121932*r**28-17854563857436*r**30+838530064587*r**32-735271267501*r**34
            +53743947969*r**36+739032313*r**38)-4*Q2**5*(49764354+1839303811*r**2
            +116477775424*r**4+796512675877*r**6+8553083403230*r**8-19656698619588*r**10
            +147808686067972*r**12-112903457723964*r**14+300853561219488*r**16+177422681128570*r**18
            +76446140408996*r**20-140010490830442*r**22+22896319181896*r**24-62069726608692*r**26
            -10289751776980*r**28-13644059756684*r**30-4989036689266*r**32+188788858619*r**34
            -120956636948*r**36+8573877005*r**38+78097322*r**40)-2*(-1+r**2)**4*(259254
            +13939450*r**2+1194801119*r**4+6141956237*r**6+106970385757*r**8-974643929829*r**10
            +8519564098260*r**12-41700787961932*r**14+132270162810544*r**16-207007489090616*r**18
            +63521842938538*r**20+186586087958710*r**22-178127509562618*r**24+64623660285026*r**26
            -22195812946764*r**28+2099042359620*r**30-604985073950*r**32-142324793194*r**34
            -3470359057*r**36-1698605627*r**38+45208917*r**40+442155*r**42)-Q2**4*(22262001
            +130316979*r**2-16923933770*r**4-1548174755366*r**6-2240254924903*r**8
            +4101782396483*r**10-200019559561832*r**12+374812530416488*r**14-901050428200414*r**16
            +29745566646022*r**18+267427200803508*r**20-452261571272980*r**22+908383867628634*r**24
            -144049729003874*r**26+82308569941240*r**28+27099318853256*r**30+11183773116365*r**32
            +5993889482023*r**34+123374075654*r**36+9812008266*r**38-1692903123*r**40
            +50017343*r**42)+Q2*(-1+r**2)**2*(5881545+274532258*r**2+22099629729*r**4
            +77970458040*r**6+1902831910559*r**8-15689457521242*r**10+118372482366575*r**12
            -478257818829520*r**14+1215737794064250*r**16-1249279204610652*r**18-485007389488054*r**20
            +1320634741487392*r**22+644627843129086*r**24-1316487202819620*r**26+569402510339902*r**28
            -232890112773296*r**30+27498913156909*r**32-6944804280678*r**34-2069171508795*r**36
            -5723172184*r**38-31473949453*r**40+963806366*r**42+10110883*r**44)+Q2**3*(59651493
            +2016900860*r**2+133826041641*r**4-185650893568*r**6+10768321492639*r**8
            -58184247258044*r**10+256825404716955*r**12-527668562719488*r**14+618310053078514*r**16
            +14324472416728*r**18+171203682615194*r**20+503348495463040*r**22-1153429674230402*r**24
            -93947045122424*r**26+310765296419702*r**28-299685970556928*r**30+57324145439865*r**32
            -17600926914196*r**34-5695768924147*r**36+365780061056*r**38-180613841965*r**40
            +7542657780*r**42+105905695*r**44)-2*Q2**2*(13671498+541788399*r**2+40707784168*r**4
            +47227529221*r**6+3384768578002*r**8-26190841373163*r**10+165160431628240*r**12
            -569308502341589*r**14+1227975139065156*r**16-1177166875692346*r**18+266252238930656*r**20
            -386867259694894*r**22+1022430132228964*r**24+251916779253466*r**26-1008660219915664*r**28
            +554771597063510*r**30-240156779795278*r**32+37244164105467*r**34-6369247642184*r**36
            -2934066427367*r**38+102986228874*r**40-58915351967*r**42+2038546240*r**44
            +23752591*r**46))*sqrtq2)*math.log(r))/(6348948480000*logq2**5*(-Q2+(-1+r)**2)*r**22*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+146966400000*logq2**3*(-Q2
            +(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+306180000*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-12697896960000*logq2**6*r**26*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2-1322697600000*logq2**4*(-Q2+(
            -1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-9185400000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2
            -4252500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**6*sqrtq2))+nlo.X1Q2_Derivativer(1,Q2,r)*((muWC*(-12096000*logq2**3*r**13*(1
            +r**2)*(29+50*r**2+29*r**4)-480*logq2*(-Q2+(-1+r)**2)*r**5*(-Q2+(1
            +r)**2)*(1873-640*Q2**9-8851*r**2+85460*r**4+1289996*r**6+6796322*r**8
            +6796322*r**10+1289996*r**12+85460*r**14-8851*r**16+1873*r**18+8848*Q2**8*(1
            +r**2)-32*Q2**7*(617+1454*r**2+617*r**4)+Q2**6*(8169+72819*r**2+72819*r**4
            +8169*r**6)+2*Q2**5*(6881-28372*r**2-46826*r**4-28372*r**6+6881*r**8)
            -Q2**4*(13825+65585*r**2+481262*r**4+481262*r**6+65585*r**8+13825*r**10)
            +4*Q2**3*(903+32098*r**2+185817*r**4+339964*r**6+185817*r**8+32098*r**10
            +903*r**12)+Q2**2*(1879+11233*r**2+272487*r**4-159599*r**6-159599*r**8
            +272487*r**10+11233*r**12+1879*r**14)-2*Q2*(1967+21792*r**2+88088*r**4
            -781552*r**6-1382190*r**8-781552*r**10+88088*r**12+21792*r**14+1967*r**16))
            -28800*logq2**2*r**9*(71-160*Q2**6+6084*r**2+70785*r**4+118280*r**6+70785*r**8
            +6084*r**10+71*r**12+960*Q2**5*(1+r**2)-288*Q2**4*(13+24*r**2+13*r**4)
            +Q2**3*(3221+9879*r**2+9879*r**4+3221*r**6)+3*Q2**2*(607-396*r**2-982*r**4
            -396*r**6+607*r**8)-3*Q2*(723-2099*r**2-6184*r**4-6184*r**6-2099*r**8
            +723*r**10))*sqrtq2+8*r*(500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1+8*Q2**6
            -34*r**2-1133*r**4-2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1+r**2)
            +Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1
            -26*r**2-118*r**4-26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6
            -31*r**8+r**10))-7*(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6
            -28170*r**8+31692*r**10-9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)
            +Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)
            +Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2
            -6138*r**4-6138*r**6-355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4
            +35188*r**6+10313*r**8-406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4
            +6605*r**6+6605*r**8-7237*r**10-595*r**12+27*r**14)))*sqrtq2))/(163296000*logq2**4*r**16
            +6804000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+7875*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-54432000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-378000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +(3024000*logq2**3*r**13*(1+r**2)*(29+50*r**2+29*r**4)+120*logq2*(-Q2
            +(-1+r)**2)*r**5*(-Q2+(1+r)**2)*(1873-640*Q2**9-8851*r**2+85460*r**4
            +1289996*r**6+6796322*r**8+6796322*r**10+1289996*r**12+85460*r**14-8851*r**16
            +1873*r**18+8848*Q2**8*(1+r**2)-32*Q2**7*(617+1454*r**2+617*r**4)+Q2**6*(8169
            +72819*r**2+72819*r**4+8169*r**6)+2*Q2**5*(6881-28372*r**2-46826*r**4
            -28372*r**6+6881*r**8)-Q2**4*(13825+65585*r**2+481262*r**4+481262*r**6
            +65585*r**8+13825*r**10)+4*Q2**3*(903+32098*r**2+185817*r**4+339964*r**6
            +185817*r**8+32098*r**10+903*r**12)+Q2**2*(1879+11233*r**2+272487*r**4
            -159599*r**6-159599*r**8+272487*r**10+11233*r**12+1879*r**14)-2*Q2*(1967
            +21792*r**2+88088*r**4-781552*r**6-1382190*r**8-781552*r**10+88088*r**12
            +21792*r**14+1967*r**16))+7200*logq2**2*r**9*(71-160*Q2**6+6084*r**2
            +70785*r**4+118280*r**6+70785*r**8+6084*r**10+71*r**12+960*Q2**5*(1
            +r**2)-288*Q2**4*(13+24*r**2+13*r**4)+Q2**3*(3221+9879*r**2+9879*r**4
            +3221*r**6)+3*Q2**2*(607-396*r**2-982*r**4-396*r**6+607*r**8)-3*Q2*(723
            -2099*r**2-6184*r**4-6184*r**6-2099*r**8+723*r**10))*sqrtq2+2*r*(-500*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4-2708*r**6-1133*r**8
            -34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1
            -19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4-26*r**6+r**8)+Q2*(1
            -31*r**2-390*r**4-390*r**6-31*r**8+r**10))+7*(-Q2+(-1+r)**2)*(-Q2
            +(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8
            -444*r**2-9976*r**4+31692*r**6-28170*r**8+31692*r**10-9976*r**12-444*r**14
            +13*r**16-24*Q2**7*(1+r**2)+Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61
            -193*r**2-193*r**4+61*r**6)+Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6
            -165*r**8)+4*Q2**3*(13-355*r**2-6138*r**4-6138*r**6-355*r**8+13*r**10)
            +Q2**2*(59-406*r**2+10313*r**4+35188*r**6+10313*r**8-406*r**10+59*r**12)
            -2*Q2*(27-595*r**2-7237*r**4+6605*r**6+6605*r**8-7237*r**10-595*r**12
            +27*r**14)))*sqrtq2)/(54432000*logq2**4*r**16+2268000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+2625*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-18144000*logq2**3*r**12*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2-126000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(muWC**2*(-1512000*logq2**3*r**13*(1+r**2)*(29
            +50*r**2+29*r**4)-60*logq2*(-Q2+(-1+r)**2)*r**5*(-Q2+(1+r)**2)*(1873
            -640*Q2**9-8851*r**2+85460*r**4+1289996*r**6+6796322*r**8+6796322*r**10
            +1289996*r**12+85460*r**14-8851*r**16+1873*r**18+8848*Q2**8*(1+r**2)
            -32*Q2**7*(617+1454*r**2+617*r**4)+Q2**6*(8169+72819*r**2+72819*r**4
            +8169*r**6)+2*Q2**5*(6881-28372*r**2-46826*r**4-28372*r**6+6881*r**8)
            -Q2**4*(13825+65585*r**2+481262*r**4+481262*r**6+65585*r**8+13825*r**10)
            +4*Q2**3*(903+32098*r**2+185817*r**4+339964*r**6+185817*r**8+32098*r**10
            +903*r**12)+Q2**2*(1879+11233*r**2+272487*r**4-159599*r**6-159599*r**8
            +272487*r**10+11233*r**12+1879*r**14)-2*Q2*(1967+21792*r**2+88088*r**4
            -781552*r**6-1382190*r**8-781552*r**10+88088*r**12+21792*r**14+1967*r**16))
            -3600*logq2**2*r**9*(71-160*Q2**6+6084*r**2+70785*r**4+118280*r**6+70785*r**8
            +6084*r**10+71*r**12+960*Q2**5*(1+r**2)-288*Q2**4*(13+24*r**2+13*r**4)
            +Q2**3*(3221+9879*r**2+9879*r**4+3221*r**6)+3*Q2**2*(607-396*r**2-982*r**4
            -396*r**6+607*r**8)-3*Q2*(723-2099*r**2-6184*r**4-6184*r**6-2099*r**8
            +723*r**10))*sqrtq2+(500*r*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2
            -1133*r**4-2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(
            -6+4*r**2-6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2
            -118*r**4-26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6-31*r**8
            +r**10))-7*(-Q2+(-1+r)**2)*r*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6
            -28170*r**8+31692*r**10-9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)
            +Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)
            +Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2
            -6138*r**4-6138*r**6-355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4
            +35188*r**6+10313*r**8-406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4
            +6605*r**6+6605*r**8-7237*r**10-595*r**12+27*r**14)))*sqrtq2))/(54432000*logq2**4*r**16
            +2268000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+2625*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-18144000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-126000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((1512000*logq2**3*r**13*(1+r**2)*(29+50*r**2+29*r**4)+60*logq2*(-Q2
            +(-1+r)**2)*r**5*(-Q2+(1+r)**2)*(1873-640*Q2**9-8851*r**2+85460*r**4
            +1289996*r**6+6796322*r**8+6796322*r**10+1289996*r**12+85460*r**14-8851*r**16
            +1873*r**18+8848*Q2**8*(1+r**2)-32*Q2**7*(617+1454*r**2+617*r**4)+Q2**6*(8169
            +72819*r**2+72819*r**4+8169*r**6)+2*Q2**5*(6881-28372*r**2-46826*r**4
            -28372*r**6+6881*r**8)-Q2**4*(13825+65585*r**2+481262*r**4+481262*r**6
            +65585*r**8+13825*r**10)+4*Q2**3*(903+32098*r**2+185817*r**4+339964*r**6
            +185817*r**8+32098*r**10+903*r**12)+Q2**2*(1879+11233*r**2+272487*r**4
            -159599*r**6-159599*r**8+272487*r**10+11233*r**12+1879*r**14)-2*Q2*(1967
            +21792*r**2+88088*r**4-781552*r**6-1382190*r**8-781552*r**10+88088*r**12
            +21792*r**14+1967*r**16))+3600*logq2**2*r**9*(71-160*Q2**6+6084*r**2
            +70785*r**4+118280*r**6+70785*r**8+6084*r**10+71*r**12+960*Q2**5*(1
            +r**2)-288*Q2**4*(13+24*r**2+13*r**4)+Q2**3*(3221+9879*r**2+9879*r**4
            +3221*r**6)+3*Q2**2*(607-396*r**2-982*r**4-396*r**6+607*r**8)-3*Q2*(723
            -2099*r**2-6184*r**4-6184*r**6-2099*r**8+723*r**10))*sqrtq2+(-500*r*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4-2708*r**6-1133*r**8
            -34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1
            -19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4-26*r**6+r**8)+Q2*(1
            -31*r**2-390*r**4-390*r**6-31*r**8+r**10))+7*(-Q2+(-1+r)**2)*r*(
            -Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(13
            +8*Q2**8-444*r**2-9976*r**4+31692*r**6-28170*r**8+31692*r**10-9976*r**12
            -444*r**14+13*r**16-24*Q2**7*(1+r**2)+Q2**6*(-11+10*r**2-11*r**4)
            +2*Q2**5*(61-193*r**2-193*r**4+61*r**6)+Q2**4*(-165+1480*r**2+10138*r**4
            +1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2-6138*r**4-6138*r**6-355*r**8
            +13*r**10)+Q2**2*(59-406*r**2+10313*r**4+35188*r**6+10313*r**8-406*r**10
            +59*r**12)-2*Q2*(27-595*r**2-7237*r**4+6605*r**6+6605*r**8-7237*r**10
            -595*r**12+27*r**14)))*sqrtq2)*math.log(mu0))/(18144000*logq2**4*r**16+756000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+875*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-6048000*logq2**3*r**12*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2-42000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((-1512000*logq2**3*r**13*(1+r**2)*(29
            +50*r**2+29*r**4)-60*logq2*(-Q2+(-1+r)**2)*r**5*(-Q2+(1+r)**2)*(1873
            -640*Q2**9-8851*r**2+85460*r**4+1289996*r**6+6796322*r**8+6796322*r**10
            +1289996*r**12+85460*r**14-8851*r**16+1873*r**18+8848*Q2**8*(1+r**2)
            -32*Q2**7*(617+1454*r**2+617*r**4)+Q2**6*(8169+72819*r**2+72819*r**4
            +8169*r**6)+2*Q2**5*(6881-28372*r**2-46826*r**4-28372*r**6+6881*r**8)
            -Q2**4*(13825+65585*r**2+481262*r**4+481262*r**6+65585*r**8+13825*r**10)
            +4*Q2**3*(903+32098*r**2+185817*r**4+339964*r**6+185817*r**8+32098*r**10
            +903*r**12)+Q2**2*(1879+11233*r**2+272487*r**4-159599*r**6-159599*r**8
            +272487*r**10+11233*r**12+1879*r**14)-2*Q2*(1967+21792*r**2+88088*r**4
            -781552*r**6-1382190*r**8-781552*r**10+88088*r**12+21792*r**14+1967*r**16))
            -3600*logq2**2*r**9*(71-160*Q2**6+6084*r**2+70785*r**4+118280*r**6+70785*r**8
            +6084*r**10+71*r**12+960*Q2**5*(1+r**2)-288*Q2**4*(13+24*r**2+13*r**4)
            +Q2**3*(3221+9879*r**2+9879*r**4+3221*r**6)+3*Q2**2*(607-396*r**2-982*r**4
            -396*r**6+607*r**8)-3*Q2*(723-2099*r**2-6184*r**4-6184*r**6-2099*r**8
            +723*r**10))*sqrtq2+(500*r*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2
            -1133*r**4-2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(
            -6+4*r**2-6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2
            -118*r**4-26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6-31*r**8
            +r**10))-7*(-Q2+(-1+r)**2)*r*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6
            -28170*r**8+31692*r**10-9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)
            +Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)
            +Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2
            -6138*r**4-6138*r**6-355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4
            +35188*r**6+10313*r**8-406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4
            +6605*r**6+6605*r**8-7237*r**10-595*r**12+27*r**14)))*sqrtq2)*math.log(r))/(18144000*logq2**4*r**16
            +756000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+875*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-6048000*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-42000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2))
            +nlo.X1Q2_Derivativer(0,Q2,r)*((muWC**2*(-272160000*logq2**4*r**17*(9+28*r**2+34*r**4
            +28*r**6+9*r**8)-7200*logq2**2*(-Q2+(-1+r)**2)*r**9*(-Q2+(1+r)**2)*(755*Q2**10
            -6460*Q2**9*(1+r**2)+19*Q2**8*(1397+2670*r**2+1397*r**4)-2*Q2**7*(22697
            +75917*r**2+75917*r**4+22697*r**6)+Q2**6*(18389+192140*r**2+288058*r**4
            +192140*r**6+18389*r**8)+Q2**5*(33782-72026*r**2-3024*r**4-3024*r**6
            -72026*r**8+33782*r**10)-Q2**4*(39655+164510*r**2+1238017*r**4+2141020*r**6
            +1238017*r**8+164510*r**10+39655*r**12)+2*Q2**3*(3721+115075*r**2+794925*r**4
            +2094619*r**6+2094619*r**8+794925*r**10+115075*r**12+3721*r**14)+4*Q2**2*(2651
            -3949*r**2+57848*r**4-355357*r**6-683806*r**8-355357*r**10+57848*r**12
            -3949*r**14+2651*r**16)-18*Q2*(453+4355*r**2+39700*r**4-68700*r**6
            -202608*r**8-202608*r**10-68700*r**12+39700*r**14+4355*r**16+453*r**18)
            +12*(179+1333*r**2+22836*r**4+74334*r**6+510837*r**8+822162*r**10
            +510837*r**12+74334*r**14+22836*r**16+1333*r**18+179*r**20))-r*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(6866*Q2**16-23436*Q2**15*(1+r**2)+8*Q2**14*(865
            +8596*r**2+865*r**4)+8*Q2**13*(5380-11099*r**2-11099*r**4+5380*r**6)
            +Q2**12*(10045-259012*r**2-2562366*r**4-259012*r**6+10045*r**8)-4*Q2**11*(34147
            -324527*r**2-3988562*r**4-3988562*r**6-324527*r**8+34147*r**10)+2*Q2**10*(35759
            -646722*r**2-15796615*r**4-38576020*r**6-15796615*r**8-646722*r**10
            +35759*r**12)+8*Q2**9*(13745-127492*r**2+2119265*r**4+19072200*r**6
            +19072200*r**8+2119265*r**10-127492*r**12+13745*r**14)+Q2**8*(-91205
            +2043184*r**2+31186064*r**4-92196960*r**6-136611350*r**8-92196960*r**10
            +31186064*r**12+2043184*r**14-91205*r**16)-4*Q2**7*(8785+21669*r**2
            +14208392*r**4+33962024*r**6+101173570*r**8+101173570*r**10+33962024*r**12
            +14208392*r**14+21669*r**16+8785*r**18)+4*Q2**6*(10807-257354*r**2+4036831*r**4
            +57257856*r**6+179616146*r**8+416911988*r**10+179616146*r**12+57257856*r**14
            +4036831*r**16-257354*r**18+10807*r**20)-8*Q2**5*(266-53737*r**2-4403625*r**4
            +12575730*r**6+21507400*r**8+309675766*r**10+309675766*r**12+21507400*r**14
            +12575730*r**16-4403625*r**18-53737*r**20+266*r**22)-Q2**4*(2005+87332*r**2
            +26936590*r**4+29645300*r**6+614859675*r**8-231352920*r**10+1158640836*r**12
            -231352920*r**14+614859675*r**16+29645300*r**18+26936590*r**20+87332*r**22
            +2005*r**24)+4*Q2**3*(135-9223*r**2-887018*r**4+22918230*r**6+168130475*r**8
            +734118485*r**10+2173168916*r**12+2173168916*r**14+734118485*r**16+168130475*r**18
            +22918230*r**20-887018*r**22-9223*r**24+135*r**26)-2*Q2**2*(1265-69094*r**2
            -3667317*r**4+24306396*r**6-83158055*r**8+480299590*r**10+308598123*r**12
            +3065234184*r**14+308598123*r**16+480299590*r**18-83158055*r**20+24306396*r**22
            -3667317*r**24-69094*r**26+1265*r**28)+24*Q2*(31-1758*r**2-54453*r**4
            -686878*r**6-12831908*r**8+1292719*r**10-99093084*r**12+519615331*r**14
            +519615331*r**16-99093084*r**18+1292719*r**20-12831908*r**22-686878*r**24
            -54453*r**26-1758*r**28+31*r**30)+3*(57-3672*r**2+19060*r**4+3841960*r**6
            +9425060*r**8+68973464*r**10+826635276*r**12-1542120*r**14+7983061830*r**16
            -1542120*r**18+826635276*r**20+68973464*r**22+9425060*r**24+3841960*r**26
            +19060*r**28-3672*r**30+57*r**32))-432000*logq2**3*r**13*(867+35*Q2**7
            +3267*r**2+42957*r**4+88989*r**6+88989*r**8+42957*r**10+3267*r**12
            +867*r**14-505*Q2**6*(1+r**2)+5*Q2**5*(445+904*r**2+445*r**4)-Q2**4*(5293
            +15125*r**2+15125*r**4+5293*r**6)-3*Q2*(1+r**2)**2*(1111-2778*r**2
            -446*r**4-2778*r**6+1111*r**8)+Q2**3*(4157+17952*r**2+28010*r**4+17952*r**6
            +4157*r**8)+Q2**2*(1847-3657*r**2-14318*r**4-14318*r**6-3657*r**8+1847*r**10))*sqrtq2
            +120*logq2*r**5*(-25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(105*Q2**7-555*Q2**6*(1
            +r**2)+15*Q2**5*(19+52*r**2+19*r**4)-Q2**4*(751+5687*r**2+5687*r**4
            +751*r**6)+Q2**3*(1139+8352*r**2+14006*r**4+8352*r**6+1139*r**8)+Q2**2*(719
            +3879*r**2+4474*r**4+4474*r**6+3879*r**8+719*r**10)+Q2*(-681+2244*r**2
            +38061*r**4+66912*r**6+38061*r**8+2244*r**10-681*r**12)+3*(-87+1849*r**2
            +34455*r**4+109943*r**6+109943*r**8+34455*r**10+1849*r**12-87*r**14))
            -2*(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(971+40*Q2**9-18517*r**2-136600*r**4+561592*r**6+1104554*r**8
            +1104554*r**10+561592*r**12-136600*r**14-18517*r**16+971*r**18-889*Q2**8*(1
            +r**2)+23*Q2**7*(169+418*r**2+169*r**4)-Q2**6*(4347+16967*r**2+16967*r**4
            +4347*r**6)-2*Q2**5*(1113+3489*r**2+13232*r**4+3489*r**6+1113*r**8)
            +2*Q2**4*(2240+11225*r**2+82043*r**4+82043*r**6+11225*r**8+2240*r**10)
            +Q2**3*(1659-18836*r**2-355219*r**4-699528*r**6-355219*r**8-18836*r**10
            +1659*r**12)+Q2**2*(-2567+13091*r**2+205549*r**4+793607*r**6+793607*r**8
            +205549*r**10+13091*r**12-2567*r**14)-8*Q2*(126-2129*r**2-34216*r**4
            -21131*r**6-11300*r**8-21131*r**10-34216*r**12-2129*r**14+126*r**16)))*sqrtq2))/(
            -6531840000*logq2**5*r**20-453600000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -1575000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+2721600000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+37800000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+26250*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +(muWC*(-1088640000*logq2**4*r**17*(9+28*r**2+34*r**4+28*r**6+9*r**8)
            -28800*logq2**2*(-Q2+(-1+r)**2)*r**9*(-Q2+(1+r)**2)*(755*Q2**10-6460*Q2**9*(1
            +r**2)+19*Q2**8*(1397+2670*r**2+1397*r**4)-2*Q2**7*(22697+75917*r**2
            +75917*r**4+22697*r**6)+Q2**6*(18389+192140*r**2+288058*r**4+192140*r**6
            +18389*r**8)+Q2**5*(33782-72026*r**2-3024*r**4-3024*r**6-72026*r**8
            +33782*r**10)-Q2**4*(39655+164510*r**2+1238017*r**4+2141020*r**6+1238017*r**8
            +164510*r**10+39655*r**12)+2*Q2**3*(3721+115075*r**2+794925*r**4+2094619*r**6
            +2094619*r**8+794925*r**10+115075*r**12+3721*r**14)+4*Q2**2*(2651-3949*r**2
            +57848*r**4-355357*r**6-683806*r**8-355357*r**10+57848*r**12-3949*r**14
            +2651*r**16)-18*Q2*(453+4355*r**2+39700*r**4-68700*r**6-202608*r**8
            -202608*r**10-68700*r**12+39700*r**14+4355*r**16+453*r**18)+12*(179
            +1333*r**2+22836*r**4+74334*r**6+510837*r**8+822162*r**10+510837*r**12
            +74334*r**14+22836*r**16+1333*r**18+179*r**20))-4*r*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(6866*Q2**16-23436*Q2**15*(1+r**2)+8*Q2**14*(865+8596*r**2
            +865*r**4)+8*Q2**13*(5380-11099*r**2-11099*r**4+5380*r**6)+Q2**12*(10045
            -259012*r**2-2562366*r**4-259012*r**6+10045*r**8)-4*Q2**11*(34147-324527*r**2
            -3988562*r**4-3988562*r**6-324527*r**8+34147*r**10)+2*Q2**10*(35759
            -646722*r**2-15796615*r**4-38576020*r**6-15796615*r**8-646722*r**10
            +35759*r**12)+8*Q2**9*(13745-127492*r**2+2119265*r**4+19072200*r**6
            +19072200*r**8+2119265*r**10-127492*r**12+13745*r**14)+Q2**8*(-91205
            +2043184*r**2+31186064*r**4-92196960*r**6-136611350*r**8-92196960*r**10
            +31186064*r**12+2043184*r**14-91205*r**16)-4*Q2**7*(8785+21669*r**2
            +14208392*r**4+33962024*r**6+101173570*r**8+101173570*r**10+33962024*r**12
            +14208392*r**14+21669*r**16+8785*r**18)+4*Q2**6*(10807-257354*r**2+4036831*r**4
            +57257856*r**6+179616146*r**8+416911988*r**10+179616146*r**12+57257856*r**14
            +4036831*r**16-257354*r**18+10807*r**20)-8*Q2**5*(266-53737*r**2-4403625*r**4
            +12575730*r**6+21507400*r**8+309675766*r**10+309675766*r**12+21507400*r**14
            +12575730*r**16-4403625*r**18-53737*r**20+266*r**22)-Q2**4*(2005+87332*r**2
            +26936590*r**4+29645300*r**6+614859675*r**8-231352920*r**10+1158640836*r**12
            -231352920*r**14+614859675*r**16+29645300*r**18+26936590*r**20+87332*r**22
            +2005*r**24)+4*Q2**3*(135-9223*r**2-887018*r**4+22918230*r**6+168130475*r**8
            +734118485*r**10+2173168916*r**12+2173168916*r**14+734118485*r**16+168130475*r**18
            +22918230*r**20-887018*r**22-9223*r**24+135*r**26)-2*Q2**2*(1265-69094*r**2
            -3667317*r**4+24306396*r**6-83158055*r**8+480299590*r**10+308598123*r**12
            +3065234184*r**14+308598123*r**16+480299590*r**18-83158055*r**20+24306396*r**22
            -3667317*r**24-69094*r**26+1265*r**28)+24*Q2*(31-1758*r**2-54453*r**4
            -686878*r**6-12831908*r**8+1292719*r**10-99093084*r**12+519615331*r**14
            +519615331*r**16-99093084*r**18+1292719*r**20-12831908*r**22-686878*r**24
            -54453*r**26-1758*r**28+31*r**30)+3*(57-3672*r**2+19060*r**4+3841960*r**6
            +9425060*r**8+68973464*r**10+826635276*r**12-1542120*r**14+7983061830*r**16
            -1542120*r**18+826635276*r**20+68973464*r**22+9425060*r**24+3841960*r**26
            +19060*r**28-3672*r**30+57*r**32))-1728000*logq2**3*r**13*(867+35*Q2**7
            +3267*r**2+42957*r**4+88989*r**6+88989*r**8+42957*r**10+3267*r**12
            +867*r**14-505*Q2**6*(1+r**2)+5*Q2**5*(445+904*r**2+445*r**4)-Q2**4*(5293
            +15125*r**2+15125*r**4+5293*r**6)-3*Q2*(1+r**2)**2*(1111-2778*r**2
            -446*r**4-2778*r**6+1111*r**8)+Q2**3*(4157+17952*r**2+28010*r**4+17952*r**6
            +4157*r**8)+Q2**2*(1847-3657*r**2-14318*r**4-14318*r**6-3657*r**8+1847*r**10))*sqrtq2
            +480*logq2*r**5*(-25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(105*Q2**7-555*Q2**6*(1
            +r**2)+15*Q2**5*(19+52*r**2+19*r**4)-Q2**4*(751+5687*r**2+5687*r**4
            +751*r**6)+Q2**3*(1139+8352*r**2+14006*r**4+8352*r**6+1139*r**8)+Q2**2*(719
            +3879*r**2+4474*r**4+4474*r**6+3879*r**8+719*r**10)+Q2*(-681+2244*r**2
            +38061*r**4+66912*r**6+38061*r**8+2244*r**10-681*r**12)+3*(-87+1849*r**2
            +34455*r**4+109943*r**6+109943*r**8+34455*r**10+1849*r**12-87*r**14))
            -2*(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(971+40*Q2**9-18517*r**2-136600*r**4+561592*r**6+1104554*r**8
            +1104554*r**10+561592*r**12-136600*r**14-18517*r**16+971*r**18-889*Q2**8*(1
            +r**2)+23*Q2**7*(169+418*r**2+169*r**4)-Q2**6*(4347+16967*r**2+16967*r**4
            +4347*r**6)-2*Q2**5*(1113+3489*r**2+13232*r**4+3489*r**6+1113*r**8)
            +2*Q2**4*(2240+11225*r**2+82043*r**4+82043*r**6+11225*r**8+2240*r**10)
            +Q2**3*(1659-18836*r**2-355219*r**4-699528*r**6-355219*r**8-18836*r**10
            +1659*r**12)+Q2**2*(-2567+13091*r**2+205549*r**4+793607*r**6+793607*r**8
            +205549*r**10+13091*r**12-2567*r**14)-8*Q2*(126-2129*r**2-34216*r**4
            -21131*r**6-11300*r**8-21131*r**10-34216*r**12-2129*r**14+126*r**16)))*sqrtq2))/(
            -9797760000*logq2**5*r**20-680400000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -2362500*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+4082400000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+56700000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+39375*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +(272160000*logq2**4*r**17*(9+28*r**2+34*r**4+28*r**6+9*r**8)+7200*logq2**2*(
            -Q2+(-1+r)**2)*r**9*(-Q2+(1+r)**2)*(755*Q2**10-6460*Q2**9*(1+r**2)
            +19*Q2**8*(1397+2670*r**2+1397*r**4)-2*Q2**7*(22697+75917*r**2+75917*r**4
            +22697*r**6)+Q2**6*(18389+192140*r**2+288058*r**4+192140*r**6+18389*r**8)
            +Q2**5*(33782-72026*r**2-3024*r**4-3024*r**6-72026*r**8+33782*r**10)
            -Q2**4*(39655+164510*r**2+1238017*r**4+2141020*r**6+1238017*r**8+164510*r**10
            +39655*r**12)+2*Q2**3*(3721+115075*r**2+794925*r**4+2094619*r**6+2094619*r**8
            +794925*r**10+115075*r**12+3721*r**14)+4*Q2**2*(2651-3949*r**2+57848*r**4
            -355357*r**6-683806*r**8-355357*r**10+57848*r**12-3949*r**14+2651*r**16)
            -18*Q2*(453+4355*r**2+39700*r**4-68700*r**6-202608*r**8-202608*r**10
            -68700*r**12+39700*r**14+4355*r**16+453*r**18)+12*(179+1333*r**2+22836*r**4
            +74334*r**6+510837*r**8+822162*r**10+510837*r**12+74334*r**14+22836*r**16
            +1333*r**18+179*r**20))+r*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(6866*Q2**16
            -23436*Q2**15*(1+r**2)+8*Q2**14*(865+8596*r**2+865*r**4)+8*Q2**13*(5380
            -11099*r**2-11099*r**4+5380*r**6)+Q2**12*(10045-259012*r**2-2562366*r**4
            -259012*r**6+10045*r**8)-4*Q2**11*(34147-324527*r**2-3988562*r**4-3988562*r**6
            -324527*r**8+34147*r**10)+2*Q2**10*(35759-646722*r**2-15796615*r**4
            -38576020*r**6-15796615*r**8-646722*r**10+35759*r**12)+8*Q2**9*(13745
            -127492*r**2+2119265*r**4+19072200*r**6+19072200*r**8+2119265*r**10
            -127492*r**12+13745*r**14)+Q2**8*(-91205+2043184*r**2+31186064*r**4
            -92196960*r**6-136611350*r**8-92196960*r**10+31186064*r**12+2043184*r**14
            -91205*r**16)-4*Q2**7*(8785+21669*r**2+14208392*r**4+33962024*r**6+101173570*r**8
            +101173570*r**10+33962024*r**12+14208392*r**14+21669*r**16+8785*r**18)
            +4*Q2**6*(10807-257354*r**2+4036831*r**4+57257856*r**6+179616146*r**8
            +416911988*r**10+179616146*r**12+57257856*r**14+4036831*r**16-257354*r**18
            +10807*r**20)-8*Q2**5*(266-53737*r**2-4403625*r**4+12575730*r**6+21507400*r**8
            +309675766*r**10+309675766*r**12+21507400*r**14+12575730*r**16-4403625*r**18
            -53737*r**20+266*r**22)-Q2**4*(2005+87332*r**2+26936590*r**4+29645300*r**6
            +614859675*r**8-231352920*r**10+1158640836*r**12-231352920*r**14+614859675*r**16
            +29645300*r**18+26936590*r**20+87332*r**22+2005*r**24)+4*Q2**3*(135
            -9223*r**2-887018*r**4+22918230*r**6+168130475*r**8+734118485*r**10
            +2173168916*r**12+2173168916*r**14+734118485*r**16+168130475*r**18+22918230*r**20
            -887018*r**22-9223*r**24+135*r**26)-2*Q2**2*(1265-69094*r**2-3667317*r**4
            +24306396*r**6-83158055*r**8+480299590*r**10+308598123*r**12+3065234184*r**14
            +308598123*r**16+480299590*r**18-83158055*r**20+24306396*r**22-3667317*r**24
            -69094*r**26+1265*r**28)+24*Q2*(31-1758*r**2-54453*r**4-686878*r**6
            -12831908*r**8+1292719*r**10-99093084*r**12+519615331*r**14+519615331*r**16
            -99093084*r**18+1292719*r**20-12831908*r**22-686878*r**24-54453*r**26
            -1758*r**28+31*r**30)+3*(57-3672*r**2+19060*r**4+3841960*r**6+9425060*r**8
            +68973464*r**10+826635276*r**12-1542120*r**14+7983061830*r**16-1542120*r**18
            +826635276*r**20+68973464*r**22+9425060*r**24+3841960*r**26+19060*r**28
            -3672*r**30+57*r**32))+432000*logq2**3*r**13*(867+35*Q2**7+3267*r**2
            +42957*r**4+88989*r**6+88989*r**8+42957*r**10+3267*r**12+867*r**14
            -505*Q2**6*(1+r**2)+5*Q2**5*(445+904*r**2+445*r**4)-Q2**4*(5293+15125*r**2
            +15125*r**4+5293*r**6)-3*Q2*(1+r**2)**2*(1111-2778*r**2-446*r**4-2778*r**6
            +1111*r**8)+Q2**3*(4157+17952*r**2+28010*r**4+17952*r**6+4157*r**8)
            +Q2**2*(1847-3657*r**2-14318*r**4-14318*r**6-3657*r**8+1847*r**10))*sqrtq2
            +120*logq2*r**5*(25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(105*Q2**7-555*Q2**6*(1
            +r**2)+15*Q2**5*(19+52*r**2+19*r**4)-Q2**4*(751+5687*r**2+5687*r**4
            +751*r**6)+Q2**3*(1139+8352*r**2+14006*r**4+8352*r**6+1139*r**8)+Q2**2*(719
            +3879*r**2+4474*r**4+4474*r**6+3879*r**8+719*r**10)+Q2*(-681+2244*r**2
            +38061*r**4+66912*r**6+38061*r**8+2244*r**10-681*r**12)+3*(-87+1849*r**2
            +34455*r**4+109943*r**6+109943*r**8+34455*r**10+1849*r**12-87*r**14))
            +2*(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(971+40*Q2**9-18517*r**2-136600*r**4+561592*r**6+1104554*r**8
            +1104554*r**10+561592*r**12-136600*r**14-18517*r**16+971*r**18-889*Q2**8*(1
            +r**2)+23*Q2**7*(169+418*r**2+169*r**4)-Q2**6*(4347+16967*r**2+16967*r**4
            +4347*r**6)-2*Q2**5*(1113+3489*r**2+13232*r**4+3489*r**6+1113*r**8)
            +2*Q2**4*(2240+11225*r**2+82043*r**4+82043*r**6+11225*r**8+2240*r**10)
            +Q2**3*(1659-18836*r**2-355219*r**4-699528*r**6-355219*r**8-18836*r**10
            +1659*r**12)+Q2**2*(-2567+13091*r**2+205549*r**4+793607*r**6+793607*r**8
            +205549*r**10+13091*r**12-2567*r**14)-8*Q2*(126-2129*r**2-34216*r**4
            -21131*r**6-11300*r**8-21131*r**10-34216*r**12-2129*r**14+126*r**16)))*sqrtq2)/(
            -3265920000*logq2**5*r**20-226800000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -787500*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+1360800000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+18900000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+13125*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +((272160000*logq2**4*r**17*(9+28*r**2+34*r**4+28*r**6+9*r**8)+7200*logq2**2*(
            -Q2+(-1+r)**2)*r**9*(-Q2+(1+r)**2)*(755*Q2**10-6460*Q2**9*(1+r**2)
            +19*Q2**8*(1397+2670*r**2+1397*r**4)-2*Q2**7*(22697+75917*r**2+75917*r**4
            +22697*r**6)+Q2**6*(18389+192140*r**2+288058*r**4+192140*r**6+18389*r**8)
            +Q2**5*(33782-72026*r**2-3024*r**4-3024*r**6-72026*r**8+33782*r**10)
            -Q2**4*(39655+164510*r**2+1238017*r**4+2141020*r**6+1238017*r**8+164510*r**10
            +39655*r**12)+2*Q2**3*(3721+115075*r**2+794925*r**4+2094619*r**6+2094619*r**8
            +794925*r**10+115075*r**12+3721*r**14)+4*Q2**2*(2651-3949*r**2+57848*r**4
            -355357*r**6-683806*r**8-355357*r**10+57848*r**12-3949*r**14+2651*r**16)
            -18*Q2*(453+4355*r**2+39700*r**4-68700*r**6-202608*r**8-202608*r**10
            -68700*r**12+39700*r**14+4355*r**16+453*r**18)+12*(179+1333*r**2+22836*r**4
            +74334*r**6+510837*r**8+822162*r**10+510837*r**12+74334*r**14+22836*r**16
            +1333*r**18+179*r**20))+r*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(6866*Q2**16
            -23436*Q2**15*(1+r**2)+8*Q2**14*(865+8596*r**2+865*r**4)+8*Q2**13*(5380
            -11099*r**2-11099*r**4+5380*r**6)+Q2**12*(10045-259012*r**2-2562366*r**4
            -259012*r**6+10045*r**8)-4*Q2**11*(34147-324527*r**2-3988562*r**4-3988562*r**6
            -324527*r**8+34147*r**10)+2*Q2**10*(35759-646722*r**2-15796615*r**4
            -38576020*r**6-15796615*r**8-646722*r**10+35759*r**12)+8*Q2**9*(13745
            -127492*r**2+2119265*r**4+19072200*r**6+19072200*r**8+2119265*r**10
            -127492*r**12+13745*r**14)+Q2**8*(-91205+2043184*r**2+31186064*r**4
            -92196960*r**6-136611350*r**8-92196960*r**10+31186064*r**12+2043184*r**14
            -91205*r**16)-4*Q2**7*(8785+21669*r**2+14208392*r**4+33962024*r**6+101173570*r**8
            +101173570*r**10+33962024*r**12+14208392*r**14+21669*r**16+8785*r**18)
            +4*Q2**6*(10807-257354*r**2+4036831*r**4+57257856*r**6+179616146*r**8
            +416911988*r**10+179616146*r**12+57257856*r**14+4036831*r**16-257354*r**18
            +10807*r**20)-8*Q2**5*(266-53737*r**2-4403625*r**4+12575730*r**6+21507400*r**8
            +309675766*r**10+309675766*r**12+21507400*r**14+12575730*r**16-4403625*r**18
            -53737*r**20+266*r**22)-Q2**4*(2005+87332*r**2+26936590*r**4+29645300*r**6
            +614859675*r**8-231352920*r**10+1158640836*r**12-231352920*r**14+614859675*r**16
            +29645300*r**18+26936590*r**20+87332*r**22+2005*r**24)+4*Q2**3*(135
            -9223*r**2-887018*r**4+22918230*r**6+168130475*r**8+734118485*r**10
            +2173168916*r**12+2173168916*r**14+734118485*r**16+168130475*r**18+22918230*r**20
            -887018*r**22-9223*r**24+135*r**26)-2*Q2**2*(1265-69094*r**2-3667317*r**4
            +24306396*r**6-83158055*r**8+480299590*r**10+308598123*r**12+3065234184*r**14
            +308598123*r**16+480299590*r**18-83158055*r**20+24306396*r**22-3667317*r**24
            -69094*r**26+1265*r**28)+24*Q2*(31-1758*r**2-54453*r**4-686878*r**6
            -12831908*r**8+1292719*r**10-99093084*r**12+519615331*r**14+519615331*r**16
            -99093084*r**18+1292719*r**20-12831908*r**22-686878*r**24-54453*r**26
            -1758*r**28+31*r**30)+3*(57-3672*r**2+19060*r**4+3841960*r**6+9425060*r**8
            +68973464*r**10+826635276*r**12-1542120*r**14+7983061830*r**16-1542120*r**18
            +826635276*r**20+68973464*r**22+9425060*r**24+3841960*r**26+19060*r**28
            -3672*r**30+57*r**32))+432000*logq2**3*r**13*(867+35*Q2**7+3267*r**2
            +42957*r**4+88989*r**6+88989*r**8+42957*r**10+3267*r**12+867*r**14
            -505*Q2**6*(1+r**2)+5*Q2**5*(445+904*r**2+445*r**4)-Q2**4*(5293+15125*r**2
            +15125*r**4+5293*r**6)-3*Q2*(1+r**2)**2*(1111-2778*r**2-446*r**4-2778*r**6
            +1111*r**8)+Q2**3*(4157+17952*r**2+28010*r**4+17952*r**6+4157*r**8)
            +Q2**2*(1847-3657*r**2-14318*r**4-14318*r**6-3657*r**8+1847*r**10))*sqrtq2
            +120*logq2*r**5*(25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(105*Q2**7-555*Q2**6*(1
            +r**2)+15*Q2**5*(19+52*r**2+19*r**4)-Q2**4*(751+5687*r**2+5687*r**4
            +751*r**6)+Q2**3*(1139+8352*r**2+14006*r**4+8352*r**6+1139*r**8)+Q2**2*(719
            +3879*r**2+4474*r**4+4474*r**6+3879*r**8+719*r**10)+Q2*(-681+2244*r**2
            +38061*r**4+66912*r**6+38061*r**8+2244*r**10-681*r**12)+3*(-87+1849*r**2
            +34455*r**4+109943*r**6+109943*r**8+34455*r**10+1849*r**12-87*r**14))
            +2*(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(971+40*Q2**9-18517*r**2-136600*r**4+561592*r**6+1104554*r**8
            +1104554*r**10+561592*r**12-136600*r**14-18517*r**16+971*r**18-889*Q2**8*(1
            +r**2)+23*Q2**7*(169+418*r**2+169*r**4)-Q2**6*(4347+16967*r**2+16967*r**4
            +4347*r**6)-2*Q2**5*(1113+3489*r**2+13232*r**4+3489*r**6+1113*r**8)
            +2*Q2**4*(2240+11225*r**2+82043*r**4+82043*r**6+11225*r**8+2240*r**10)
            +Q2**3*(1659-18836*r**2-355219*r**4-699528*r**6-355219*r**8-18836*r**10
            +1659*r**12)+Q2**2*(-2567+13091*r**2+205549*r**4+793607*r**6+793607*r**8
            +205549*r**10+13091*r**12-2567*r**14)-8*Q2*(126-2129*r**2-34216*r**4
            -21131*r**6-11300*r**8-21131*r**10-34216*r**12-2129*r**14+126*r**16)))*sqrtq2)*math.log(mu0))/(
            -2177280000*logq2**5*r**20-151200000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -525000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+907200000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+12600000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+8750*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +((-272160000*logq2**4*r**17*(9+28*r**2+34*r**4+28*r**6+9*r**8)-7200*logq2**2*(
            -Q2+(-1+r)**2)*r**9*(-Q2+(1+r)**2)*(755*Q2**10-6460*Q2**9*(1+r**2)
            +19*Q2**8*(1397+2670*r**2+1397*r**4)-2*Q2**7*(22697+75917*r**2+75917*r**4
            +22697*r**6)+Q2**6*(18389+192140*r**2+288058*r**4+192140*r**6+18389*r**8)
            +Q2**5*(33782-72026*r**2-3024*r**4-3024*r**6-72026*r**8+33782*r**10)
            -Q2**4*(39655+164510*r**2+1238017*r**4+2141020*r**6+1238017*r**8+164510*r**10
            +39655*r**12)+2*Q2**3*(3721+115075*r**2+794925*r**4+2094619*r**6+2094619*r**8
            +794925*r**10+115075*r**12+3721*r**14)+4*Q2**2*(2651-3949*r**2+57848*r**4
            -355357*r**6-683806*r**8-355357*r**10+57848*r**12-3949*r**14+2651*r**16)
            -18*Q2*(453+4355*r**2+39700*r**4-68700*r**6-202608*r**8-202608*r**10
            -68700*r**12+39700*r**14+4355*r**16+453*r**18)+12*(179+1333*r**2+22836*r**4
            +74334*r**6+510837*r**8+822162*r**10+510837*r**12+74334*r**14+22836*r**16
            +1333*r**18+179*r**20))-r*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(6866*Q2**16
            -23436*Q2**15*(1+r**2)+8*Q2**14*(865+8596*r**2+865*r**4)+8*Q2**13*(5380
            -11099*r**2-11099*r**4+5380*r**6)+Q2**12*(10045-259012*r**2-2562366*r**4
            -259012*r**6+10045*r**8)-4*Q2**11*(34147-324527*r**2-3988562*r**4-3988562*r**6
            -324527*r**8+34147*r**10)+2*Q2**10*(35759-646722*r**2-15796615*r**4
            -38576020*r**6-15796615*r**8-646722*r**10+35759*r**12)+8*Q2**9*(13745
            -127492*r**2+2119265*r**4+19072200*r**6+19072200*r**8+2119265*r**10
            -127492*r**12+13745*r**14)+Q2**8*(-91205+2043184*r**2+31186064*r**4
            -92196960*r**6-136611350*r**8-92196960*r**10+31186064*r**12+2043184*r**14
            -91205*r**16)-4*Q2**7*(8785+21669*r**2+14208392*r**4+33962024*r**6+101173570*r**8
            +101173570*r**10+33962024*r**12+14208392*r**14+21669*r**16+8785*r**18)
            +4*Q2**6*(10807-257354*r**2+4036831*r**4+57257856*r**6+179616146*r**8
            +416911988*r**10+179616146*r**12+57257856*r**14+4036831*r**16-257354*r**18
            +10807*r**20)-8*Q2**5*(266-53737*r**2-4403625*r**4+12575730*r**6+21507400*r**8
            +309675766*r**10+309675766*r**12+21507400*r**14+12575730*r**16-4403625*r**18
            -53737*r**20+266*r**22)-Q2**4*(2005+87332*r**2+26936590*r**4+29645300*r**6
            +614859675*r**8-231352920*r**10+1158640836*r**12-231352920*r**14+614859675*r**16
            +29645300*r**18+26936590*r**20+87332*r**22+2005*r**24)+4*Q2**3*(135
            -9223*r**2-887018*r**4+22918230*r**6+168130475*r**8+734118485*r**10
            +2173168916*r**12+2173168916*r**14+734118485*r**16+168130475*r**18+22918230*r**20
            -887018*r**22-9223*r**24+135*r**26)-2*Q2**2*(1265-69094*r**2-3667317*r**4
            +24306396*r**6-83158055*r**8+480299590*r**10+308598123*r**12+3065234184*r**14
            +308598123*r**16+480299590*r**18-83158055*r**20+24306396*r**22-3667317*r**24
            -69094*r**26+1265*r**28)+24*Q2*(31-1758*r**2-54453*r**4-686878*r**6
            -12831908*r**8+1292719*r**10-99093084*r**12+519615331*r**14+519615331*r**16
            -99093084*r**18+1292719*r**20-12831908*r**22-686878*r**24-54453*r**26
            -1758*r**28+31*r**30)+3*(57-3672*r**2+19060*r**4+3841960*r**6+9425060*r**8
            +68973464*r**10+826635276*r**12-1542120*r**14+7983061830*r**16-1542120*r**18
            +826635276*r**20+68973464*r**22+9425060*r**24+3841960*r**26+19060*r**28
            -3672*r**30+57*r**32))-432000*logq2**3*r**13*(867+35*Q2**7+3267*r**2
            +42957*r**4+88989*r**6+88989*r**8+42957*r**10+3267*r**12+867*r**14
            -505*Q2**6*(1+r**2)+5*Q2**5*(445+904*r**2+445*r**4)-Q2**4*(5293+15125*r**2
            +15125*r**4+5293*r**6)-3*Q2*(1+r**2)**2*(1111-2778*r**2-446*r**4-2778*r**6
            +1111*r**8)+Q2**3*(4157+17952*r**2+28010*r**4+17952*r**6+4157*r**8)
            +Q2**2*(1847-3657*r**2-14318*r**4-14318*r**6-3657*r**8+1847*r**10))*sqrtq2
            +120*logq2*r**5*(-25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(105*Q2**7-555*Q2**6*(1
            +r**2)+15*Q2**5*(19+52*r**2+19*r**4)-Q2**4*(751+5687*r**2+5687*r**4
            +751*r**6)+Q2**3*(1139+8352*r**2+14006*r**4+8352*r**6+1139*r**8)+Q2**2*(719
            +3879*r**2+4474*r**4+4474*r**6+3879*r**8+719*r**10)+Q2*(-681+2244*r**2
            +38061*r**4+66912*r**6+38061*r**8+2244*r**10-681*r**12)+3*(-87+1849*r**2
            +34455*r**4+109943*r**6+109943*r**8+34455*r**10+1849*r**12-87*r**14))
            -2*(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(971+40*Q2**9-18517*r**2-136600*r**4+561592*r**6+1104554*r**8
            +1104554*r**10+561592*r**12-136600*r**14-18517*r**16+971*r**18-889*Q2**8*(1
            +r**2)+23*Q2**7*(169+418*r**2+169*r**4)-Q2**6*(4347+16967*r**2+16967*r**4
            +4347*r**6)-2*Q2**5*(1113+3489*r**2+13232*r**4+3489*r**6+1113*r**8)
            +2*Q2**4*(2240+11225*r**2+82043*r**4+82043*r**6+11225*r**8+2240*r**10)
            +Q2**3*(1659-18836*r**2-355219*r**4-699528*r**6-355219*r**8-18836*r**10
            +1659*r**12)+Q2**2*(-2567+13091*r**2+205549*r**4+793607*r**6+793607*r**8
            +205549*r**10+13091*r**12-2567*r**14)-8*Q2*(126-2129*r**2-34216*r**4
            -21131*r**6-11300*r**8-21131*r**10-34216*r**12-2129*r**14+126*r**16)))*sqrtq2)*math.log(r))/(
            -2177280000*logq2**5*r**20-151200000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -525000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+907200000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+12600000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+8750*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2))
            +muWC*((pi2*(-16*r**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(92*Q2**18+60*Q2**17*(1
            +r**2)+4*Q2**16*(-1519+3228*r**2+1499*r**4)-Q2**15*(-34969+160589*r**2
            +1046341*r**4+72623*r**6)+Q2**14*(-94735+776500*r**2+10808350*r**4+8852676*r**6
            +299825*r**8)-Q2**13*(-135799+1877655*r**2+43289452*r**4+82368756*r**6
            +29535579*r**8+576101*r**10)+Q2**12*(-76245+2114840*r**2+79598981*r**4
            +277504064*r**6+239240429*r**8+38482536*r**10+381315*r**12)+Q2**11*(
            -56927+50819*r**2-41680119*r**4-387002253*r**6-530987613*r**8-237317447*r**10
            +20511955*r**12+493297*r**14)-Q2**10*(-101673+2723028*r**2+87830460*r**4
            -63891428*r**6+60797850*r**8+280696044*r**10+261376636*r**12+122446116*r**14
            +1074711*r**16)+Q2**9*(9295+1716825*r**2+153045270*r**4+436523258*r**6
            +1396512740*r**8+3429691340*r**10+2103692810*r**12+851014790*r**14+112792173*r**16
            +341275*r**18)+Q2**8*(-120549+2320560*r**2-37227201*r**4-528837568*r**6
            -1065281922*r**8-4841499376*r**10-6297176130*r**12-1670586336*r**14-590459833*r**16
            +54890208*r**18+889251*r**20)-Q2**7*(-89635+3712335*r**2+105058067*r**4
            -340834967*r**6+511955778*r**8+1046459542*r**10+777200710*r**12-778030638*r**14
            +1950721473*r**16+357891963*r**18+168225927*r**20+994085*r**22)+Q2**6*(10907
            +875276*r**2+89263870*r**4-158583284*r**6+193046501*r**8+5395152088*r**10
            +19515767172*r**12+17554642744*r**14+8434570341*r**16+3289645276*r**18
            +764189182*r**20+76673404*r**22+70043*r**24)+Q2**5*(-48803+1674323*r**2
            +9932888*r**4-178260472*r**6+848638885*r**8-1763653493*r**10-16900419912*r**12
            -39203740728*r**14-12693116089*r**16-8386679415*r**18+37241456*r**20
            -323302736*r**22+63392055*r**24+508441*r**26)-Q2**4*(-21065+1300200*r**2
            +41907245*r**4-417821216*r**6+224047815*r**8+975854760*r**10-701297035*r**12
            -14255612160*r**14-29566065683*r**16+20178975160*r**18-714459345*r**20
            +2445366560*r**22+131177365*r**24+76375224*r**26+316975*r**28)+Q2**3*(5283
            -7655*r**2+13345903*r**4-193648251*r**6-570114849*r**8-152368323*r**10
            -3295991205*r**12-11620863591*r**14+4354598937*r**16-12379537797*r**18
            +26031776957*r**20+3845099135*r**22+1061850213*r**24+170056239*r**26
            +14144121*r**28-9117*r**30)+Q2**2*(-7825+391060*r**2+5478336*r**4-108011956*r**6
            +403896324*r**8+279101876*r**10+2821795840*r**12+18885157708*r**14+18283866522*r**16
            +6908662492*r**18-12997085632*r**20+3267499140*r**22-3037842044*r**24
            +600798684*r**26-57506816*r**28+15657956*r**30+84335*r**32)-3*Q2*(-907
            +59419*r**2+1384374*r**4-40213254*r**6+35892346*r**8-134272058*r**10
            -2180654706*r**12+53763714*r**14-2428061692*r**16-7896633092*r**18+23365152962*r**20
            -15426377970*r**22+4793498550*r**24-336016054*r**26+191370746*r**28-2026122*r**30
            +3122007*r**32+11737*r**34)+3*(-113+8848*r**2+237471*r**4-9760736*r**6
            +6254580*r**8-82272976*r**10-1391081884*r**12+1374664192*r**14-13813606422*r**16
            +43249613040*r**18-52589566534*r**20+29995134624*r**22-8274408172*r**24
            +1532131152*r**26-39342620*r**28+41405248*r**30+60287*r**32+528384*r**34
            +1631*r**36))-16*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(736*Q2**22
            -164*Q2**21*(1+r**2)+8*Q2**20*(-6209+12830*r**2+5863*r**4)-20*Q2**19*(
            -16107+66795*r**2+425321*r**4+31155*r**6)+5*Q2**18*(-191935+1396628*r**2
            +18982358*r**4+15714020*r**6+573089*r**8)-2*Q2**17*(-743353+9181315*r**2
            +210439090*r**4+398849530*r**6+146667235*r**8+3090527*r**10)+Q2**16*(
            -810729+22144926*r**2+881714845*r**4+3089930340*r**6+2671394545*r**8
            +456317406*r**10+4784571*r**12)+4*Q2**15*(-262898+764215*r**2-150861544*r**4
            -1340268435*r**6-1965172890*r**8-881680183*r**10+28555120*r**12+1497871*r**14)
            -20*Q2**14*(-93439+2025190*r**2+50476392*r**4-115760126*r**6-243169743*r**8
            -99985982*r**10+92556030*r**12+72542542*r**14+777440*r**16)+20*Q2**13*(
            -3010+1456929*r**2+111635934*r**4+325781616*r**6+949127860*r**8+2135860308*r**10
            +1353719658*r**12+589236664*r**14+83141990*r**16+310787*r**18)+4*Q2**12*(
            -535171+9331010*r**2-181465215*r**4-2963189550*r**6-10276258125*r**8
            -33297080804*r**10-35914992495*r**12-11567244990*r**14-3072315480*r**16
            +161712590*r**18+3717974*r**20)-4*Q2**11*(-407524+16519711*r**2+488043590*r**4
            -1921351425*r**6-6025344060*r**8-34993132166*r**10-60171084836*r**12
            -35195915610*r**14-199576200*r**16+817140815*r**18+704045446*r**20+4577651*r**22)
            +2*Q2**10*(318279+4140240*r**2+982978502*r**4+769342920*r**6+8079031035*r**8
            +13582344856*r**10+42152523300*r**12+45037217288*r**14+62067170885*r**16
            +35911777560*r**18+8757214614*r**20+710194160*r**22-453063*r**24)+20*Q2**9*(
            -71399+2452840*r**2+18798472*r**4-477432212*r**6-1516769741*r**8-9461408242*r**10
            -33881513380*r**12-66187424212*r**14-39234036757*r**16-21145306736*r**18
            -3127531220*r**20-609463880*r**22+80244697*r**24+711370*r**26)-10*Q2**8*(
            -34105+2995558*r**2+141045673*r**4-974323856*r**6-1130956499*r**8-14544085038*r**10
            -56616655057*r**12-211406379568*r**14-247458855871*r**16-63840564102*r**18
            -29984342153*r**20+2381844544*r**22+424346443*r**24+193942990*r**26+689969*r**28)
            -4*Q2**7*(-134514+3890235*r**2-99348440*r**4-25783395*r**6-1129268990*r**8
            +8891096539*r**10-32352779520*r**12+90227215265*r**14+275486365090*r**16
            +188817996105*r**18-153500580376*r**20-46982782425*r**22-15990252690*r**24
            -2807960255*r**26+6986640*r**28+1046331*r**30)+4*Q2**6*(-90181+5272454*r**2
            +111293140*r**4-1997881230*r**6+352771815*r**8+8104054886*r**10-48795009914*r**12
            -408055557590*r**14-1154903353125*r**16-1062373628990*r**18-766724823704*r**20
            -261962637994*r**22-103684435335*r**24-5397166830*r**26-1251959810*r**28
            +240196814*r**30+1173194*r**32)-4*Q2**5*(10913+391900*r**2+69513774*r**4
            -1080609260*r**6+1335602940*r**8+200219702*r**10+27021416430*r**12-256778954884*r**14
            -1452661624970*r**16-2738316873530*r**18-1126798664758*r**20-1012961279940*r**22
            -3750177844*r**24-36966938670*r**26+5070769690*r**28+614729268*r**30
            +83498785*r**32+58454*r**34)-20*Q2**4*(-5603+314730*r**2+1921509*r**4
            -103644366*r**6+256539277*r**8+4461509120*r**10+102549015*r**12-11810540434*r**14
            +32699137687*r**16+224241654616*r**18+436852355289*r**20-240878254290*r**22
            +24296863191*r**24-30911507896*r**26-6742984043*r**28-868557006*r**30
            -170253080*r**32+10201334*r**34+64150*r**36)+60*Q2**3*(-405+37606*r**2
            +1103021*r**4-38480558*r**6+139231104*r**8+1105706196*r**10+2296093892*r**12
            +2286272464*r**14+15646171846*r**16+20489197320*r**18-4704403122*r**20
            +38359259308*r**22-106763697016*r**24-42030495588*r**26-3742305372*r**28
            -1948299344*r**30-25594681*r**32-14112094*r**34+2356125*r**36+7298*r**38)
            +3*Q2**2*(-4313+230260*r**2-3126990*r**4+15667060*r**6-58556705*r**8
            +5614189792*r**10-24588920600*r**12-141108574560*r**14-468178935250*r**16
            -2451613456600*r**18-1949622466788*r**20-755144441880*r**22+1851832881590*r**24
            -732358578880*r**26+472408852040*r**28-40098187648*r**30+1342331595*r**32
            -898532540*r**34-174530430*r**36+1803140*r**38+37707*r**40)-18*Q2*(
            -397+31013*r**2+248190*r**4-26348410*r**6+178447315*r**8+1583713473*r**10
            -1272858112*r**12+12536987360*r**14+108715887310*r**16-63624780190*r**18
            +367116721868*r**20+157435300988*r**22-1075475371290*r**24+668805592610*r**26
            -155239831440*r**28-14488694192*r**30-4984570817*r**32-1186756135*r**34
            -54414010*r**36-20533810*r**38+1223623*r**40+5053*r**42)+9*(-113+10430*r**2
            +124221*r**4-13915460*r**6+120458625*r**8+744356342*r**10-690302965*r**12
            +28486145456*r**14+98860868230*r**16+126814542300*r**18+619758474002*r**20
            -3104449405560*r**22+3895904772306*r**24-1922665264580*r**26+283783738150*r**28
            +2408722672*r**30-26605651205*r**32-1809481114*r**34-632078815*r**36
            -9129700*r**38-7490403*r**40+505550*r**42+1631*r**44))*sqrtq2+logq2**6*(
            -9405849600000*(-Q2+(-1+r)**2)*(-1+r)*r**26*(1+r)*(1+r**2)*(1-Q2
            +r**2)*(-1-4*r**2+r**4)*(-Q2+(1+r)**2)-9405849600000*r**26*(1+4*r**2
            -2*r**4-4*r**6+r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**5*(14929920000*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(70*Q2**7*(1+r**2)-10*Q2**6*(23+76*r**2
            +53*r**4)+10*Q2**5*(-23+125*r**2+305*r**4+157*r**6)-2*Q2**4*(-858-1351*r**2
            +1389*r**4+2903*r**6+1133*r**8)+4*Q2**3*(-411-1663*r**2-1744*r**4+554*r**6
            +1372*r**8+326*r**10)+2*Q2**2*(-612+853*r**2+4453*r**4+3032*r**6-664*r**8
            -595*r**10+337*r**12)-3*Q2*(-957-1022*r**2+1047*r**4+1068*r**6-735*r**8
            -498*r**10+645*r**12+452*r**14)+3*(-443-589*r**2-2175*r**4-1587*r**6
            +4321*r**8+989*r**10-985*r**12+291*r**14+178*r**16))-14929920000*r**22*(70*Q2**10*(1
            +r**2)-20*Q2**9*(22+59*r**2+37*r**4)+10*Q2**8*(67+457*r**2+727*r**4
            +337*r**6)-2*Q2**7*(-823+1549*r**2+9669*r**4+11503*r**6+4318*r**8)
            +14*Q2**6*(-518-1149*r**2+268*r**4+2962*r**6+3016*r**8+953*r**10)+Q2**5*(9086
            +36652*r**2+49978*r**4+8436*r**6-47814*r**8-44996*r**10-11606*r**12)
            +5*Q2**4*(-21-4522*r**2-13389*r**4-14272*r**6-4211*r**8+5058*r**10
            +4445*r**12+560*r**14)-3*(-1+r**2)**3*(443+1475*r**2+4239*r**4+8001*r**6
            +5267*r**8-43*r**10-47*r**12+647*r**14+178*r**16)+2*Q2**3*(-5985-5950*r**2
            +9419*r**4+20598*r**6+23613*r**8+8606*r**10-699*r**12+2170*r**14+2660*r**16)
            -2*Q2**2*(-6912-10649*r**2-10887*r**4-16467*r**6+9615*r**8+25745*r**10
            +2747*r**12-1801*r**14+5437*r**16+3172*r**18)+6*Q2*(-1143-1359*r**2
            -3003*r**4-5396*r**6-304*r**8+3532*r**10+7466*r**12+720*r**14-1717*r**16
            +711*r**18+493*r**20))*sqrtq2)+logq2**4*(41472000*r**18*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-1120*Q2**11+40*Q2**10*(343+463*r**2)
            -20*Q2**9*(3579+9401*r**2+5598*r**4)+16*Q2**8*(12476+47750*r**2+57837*r**4
            +21419*r**6)-4*Q2**7*(78047+391017*r**2+709339*r**4+544057*r**6+135368*r**8)
            +Q2**6*(266133+1567540*r**2+3800814*r**4+4400212*r**6+2291461*r**8+272832*r**10)
            +2*Q2**5*(-74123-361111*r**2-1140282*r**4-1039682*r**6-480911*r**8-6795*r**10
            +220528*r**12)+Q2**4*(127225+661490*r**2+3762451*r**4+1950140*r**6-5468913*r**8
            -5369086*r**10-2200635*r**12-756560*r**14)+12*Q2**3*(-5208-81095*r**2
            -509668*r**4-1039559*r**6-339684*r**8+699975*r**10+506372*r**12+145619*r**14
            +23848*r**16)+3*Q2**2*(-32539+42016*r**2-140156*r**4+3159048*r**6+5155610*r**8
            +1061288*r**10-877892*r**12-176040*r**14-97119*r**16+70584*r**18)-18*Q2*(
            -6999-34505*r**2-390024*r**4-140416*r**6+448558*r**8+65590*r**10-250860*r**12
            +118784*r**14+169481*r**16+8467*r**18+11924*r**20)+9*(-4381-34582*r**2
            -417725*r**4-330832*r**6-95334*r**8+393676*r**10+520586*r**12-228240*r**14
            +14467*r**16+171594*r**18+4915*r**20+5856*r**22))-41472000*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1120*Q2**11-40*Q2**10*(343+463*r**2)
            +20*Q2**9*(3579+9401*r**2+5598*r**4)-16*Q2**8*(12476+47750*r**2+57837*r**4
            +21419*r**6)+4*Q2**7*(78047+391017*r**2+709339*r**4+544057*r**6+135368*r**8)
            -Q2**6*(266133+1567540*r**2+3800814*r**4+4400212*r**6+2291461*r**8+272832*r**10)
            +Q2**5*(148246+722222*r**2+2280564*r**4+2079364*r**6+961822*r**8+13590*r**10
            -441056*r**12)+Q2**4*(-127225-661490*r**2-3762451*r**4-1950140*r**6
            +5468913*r**8+5369086*r**10+2200635*r**12+756560*r**14)-12*Q2**3*(-5208
            -81095*r**2-509668*r**4-1039559*r**6-339684*r**8+699975*r**10+506372*r**12
            +145619*r**14+23848*r**16)-3*Q2**2*(-32539+42016*r**2-140156*r**4+3159048*r**6
            +5155610*r**8+1061288*r**10-877892*r**12-176040*r**14-97119*r**16+70584*r**18)
            +18*Q2*(-6999-34505*r**2-390024*r**4-140416*r**6+448558*r**8+65590*r**10
            -250860*r**12+118784*r**14+169481*r**16+8467*r**18+11924*r**20)-9*(
            -4381-34582*r**2-417725*r**4-330832*r**6-95334*r**8+393676*r**10+520586*r**12
            -228240*r**14+14467*r**16+171594*r**18+4915*r**20+5856*r**22))*sqrtq2)
            +logq2**3*(2764800*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-6040*Q2**14
            +40*Q2**13*(1594+1717*r**2)-6*Q2**12*(47066+105627*r**2+56105*r**4)
            +4*Q2**11*(166353+615914*r**2+672236*r**4+218475*r**6)-4*Q2**10*(213954
            +1233470*r**2+2160818*r**4+1486603*r**6+277725*r**8)+30*Q2**9*(17658
            +159933*r**2+373524*r**4+406142*r**6+203128*r**8+2091*r**10)+10*Q2**8*(
            -8730-81919*r**2+406781*r**4+1318228*r**6+729770*r**8+127157*r**10
            +179709*r**12)-Q2**7*(14103+2215166*r**2+30766055*r**4+93813080*r**6
            +108457305*r**8+49318958*r**10+10896361*r**12+2134140*r**14)+3*Q2**6*(43947
            +359211*r**2+11650609*r**4+48168485*r**6+84376685*r**8+63097297*r**10
            +18606971*r**12+3683359*r**14+75900*r**16)+Q2**5*(-417443-154480*r**2
            -14503246*r**4-79196236*r**6-205266820*r**8-222991528*r**10-86498170*r**12
            +10443884*r**14-1054561*r**16+1426600*r**18)-5*Q2**4*(-69205-403917*r**2
            -1535816*r**4-7263066*r**6-22070188*r**8-7836032*r**10+16436874*r**12
            +21608978*r**14+13610857*r**16+1284133*r**18+216038*r**20)+15*Q2**3*(2201
            -157626*r**2-654129*r**4-4963312*r**6-16774294*r**8-16901308*r**10+5812862*r**12
            +15167456*r**14+9309725*r**16+2630070*r**18+306323*r**20+1232*r**22)
            +3*Q2**2*(-59967+26301*r**2-1108055*r**4+9244205*r**6+37514770*r**8
            +138715514*r**10+94138698*r**12-4616870*r**14-16613515*r**16-16724055*r**18
            +4344493*r**20-24359*r**22+106840*r**24)-9*Q2*(-9483-110254*r**2-1226156*r**4
            -4956660*r**6-27575015*r**8+5724286*r**10+23727088*r**12-9829088*r**14
            +1175335*r**16+11255590*r**18-469828*r**20+2159316*r**22+118219*r**24
            +16650*r**26)+9*(-1349-41985*r**2-471498*r**4-2888708*r**6-19012105*r**8
            +4372743*r**10+20073990*r**12-3066584*r**14-7941439*r**16+2125205*r**18
            +6265906*r**20-12580*r**22+559757*r**24+36197*r**26+2450*r**28))+2764800*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(6040*Q2**15-40*Q2**14*(1745+1868*r**2)
            +Q2**13*(346156+766202*r**2+405310*r**4)-2*Q2**12*(473904+1689907*r**2
            +1829668*r**4+605265*r**6)+4*Q2**11*(380307+2015737*r**2+3448968*r**4
            +2377314*r**6+496200*r**8)-2*Q2**10*(692778+5293843*r**2+12391436*r**4
            +13386972*r**6+6575576*r**8+586815*r**10)-20*Q2**9*(-30852-307346*r**2
            -596795*r**4-510385*r**6-549020*r**8-244250*r**10+86718*r**12)+Q2**8*(
            -73197+1308676*r**2+34014675*r**4+111063170*r**6+128937285*r**8+57888228*r**10
            +13965021*r**12+3931230*r**14)-2*Q2**7*(72972+1653451*r**2+33966524*r**4
            +134542295*r**6+227700220*r**8+173534077*r**10+58018116*r**12+12040289*r**14
            +1180920*r**16)+2*Q2**6*(274642+681977*r**2+25266353*r**4+129326759*r**6
            +301451165*r**8+332706737*r**10+165805487*r**12+28213553*r**14+6166169*r**16
            -599450*r**18)+2*Q2**5*(-381734-1295754*r**2-11168403*r**4-65007406*r**6
            -197406998*r**8-233719254*r**10-113652664*r**12+15995302*r**14+38721804*r**16
            +3396352*r**18+1253395*r**20)-10*Q2**4*(-31301-473000*r**2-1951060*r**4
            -11844409*r**6-39828068*r**8-40305072*r**10+13019714*r**12+41774110*r**14
            +31574505*r**16+11392600*r**18+1209570*r**20+109867*r**22)-6*Q2**3*(
            -35486+401713*r**2+1475360*r**4+18665705*r**6+73101400*r**8+153546762*r**10
            +74790464*r**12-54759230*r**14-69499710*r**16-38211515*r**18-5168736*r**20
            -781067*r**22+50340*r**24)+6*Q2**2*(-44208-182214*r**2-2380111*r**4
            -3366915*r**6-17983035*r**8+96701571*r**10+152017738*r**12+30017282*r**14
            -8852190*r**16+214600*r**18-6894523*r**20+5399041*r**22+218569*r**24
            +78395*r**26)-18*Q2*(-5416-80861*r**2-903954*r**4-4535762*r**6-25771890*r**8
            -8738993*r**10+24762682*r**12+5415708*r**14-8297596*r**16+7278065*r**18
            +8525834*r**20+838454*r**22+1418646*r**24+85533*r**26+9550*r**28)+9*(
            -1349-43334*r**2-513483*r**4-3360206*r**6-21900813*r**8-14639362*r**10
            +24446733*r**12+17007406*r**14-11008023*r**16-5816234*r**18+8391111*r**20
            +6253326*r**22+547177*r**24+595954*r**26+38647*r**28+2450*r**30))*sqrtq2)
            +logq2**2*(-11520*r**10*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17
            -8*Q2**16*(135817+150101*r**2)+8*Q2**15*(609837+1424108*r**2+709791*r**4)
            -8*Q2**14*(1497790+5665821*r**2+6164498*r**4+1670155*r**6)+8*Q2**13*(2052205
            +11807174*r**2+19627106*r**4+13279952*r**6+1570775*r**8)+Q2**12*(-9276675
            -97625268*r**2-162375498*r**4-170092020*r**6-87823939*r**8+10951320*r**10)
            -4*Q2**11*(1841403-2378739*r**2+72594868*r**4+176570458*r**6+97819623*r**8
            +24693229*r**10+9892734*r**12)+2*Q2**10*(9261111+50180850*r**2+514798421*r**4
            +1698206280*r**6+1881190105*r**8+716700482*r**10+157336027*r**12+14469828*r**14)
            +4*Q2**9*(-3352365-32232891*r**2-271078323*r**4-1352556375*r**6-2375510525*r**8
            -1673827605*r**10-350439261*r**12-63361633*r**14+4846770*r**16)+Q2**8*(
            -2729705+88671816*r**2+290389124*r**4+2654978408*r**6+6371797290*r**8
            +7327078400*r**10+3114119876*r**12-691377336*r**14-92962057*r**16-42913400*r**18)
            +8*Q2**7*(1747270-4971133*r**2+15127487*r**4+266907120*r**6+1492747966*r**8
            +2719556390*r**10+1861043472*r**12+853863832*r**14+317972780*r**16+40114391*r**18
            +1878665*r**20)+4*Q2**6*(-2456967-4677472*r**2+23073081*r**4-603032454*r**6
            -5851481694*r**8-16113018636*r**10-17957269110*r**12-8332675944*r**14
            -2848468779*r**16-372895044*r**18-46067315*r**20+4119774*r**22)-8*Q2**5*(229304
            -8600451*r**2-13472499*r**4-7450835*r**6-1468763325*r**8-6396000186*r**10
            -11704337214*r**12-7844229138*r**14-1198700610*r**16-511036475*r**18
            +106568217*r**20+8467725*r**22+1935887*r**24)+Q2**4*(6068155-55416868*r**2
            -529648674*r**4-565030660*r**6-2269446875*r**8-12054143520*r**10-35736518844*r**12
            -25962685992*r**14+17453038725*r**16+29611067900*r**18+4735543390*r**20
            +1370532012*r**22+129316891*r**24+1225160*r**26)+12*Q2**3*(-174505+109941*r**2
            +26994944*r**4+148392198*r**6+449400505*r**8+2459787075*r**10+4694349898*r**12
            +1521190932*r**14-2935005991*r**16-4346643205*r**18-2161639620*r**20
            -407821914*r**22-28949801*r**24-3480307*r**26+289850*r**28)-6*Q2**2*(189515
            -3931222*r**2-17811067*r**4+102589440*r**6+16192019*r**8+4091115470*r**10
            +11119907829*r**12+14975348124*r**14+4310241465*r**16-1116035738*r**18
            -4526104505*r**20+502957768*r**22-109686807*r**24+45159970*r**26+2918719*r**28
            +229020*r**30)+36*Q2*(26931-379535*r**2-4452807*r**4-14409807*r**6
            -176564787*r**8-451164495*r**10-1711459887*r**12+1089967489*r**14+475970739*r**16
            +27232299*r**18+820620947*r**20-372775221*r**22+286607943*r**24+25195443*r**26
            +5163363*r**28+420867*r**30+518*r**32)+9*(-21679+281592*r**2+4639432*r**4
            +30912240*r**6+319818060*r**8+1430620872*r**10+5770391864*r**12-8304862496*r**14
            -4018542330*r**16+8182983880*r**18-268700232*r**20-3464268304*r**22+686961996*r**24
            -329849160*r**26-36352440*r**28-3686336*r**30-332527*r**32+5568*r**34))
            -11520*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17-8*Q2**16*(135817
            +150101*r**2)+8*Q2**15*(609837+1424108*r**2+709791*r**4)-8*Q2**14*(1497790
            +5665821*r**2+6164498*r**4+1670155*r**6)+8*Q2**13*(2052205+11807174*r**2
            +19627106*r**4+13279952*r**6+1570775*r**8)+Q2**12*(-9276675-97625268*r**2
            -162375498*r**4-170092020*r**6-87823939*r**8+10951320*r**10)-4*Q2**11*(1841403
            -2378739*r**2+72594868*r**4+176570458*r**6+97819623*r**8+24693229*r**10
            +9892734*r**12)+2*Q2**10*(9261111+50180850*r**2+514798421*r**4+1698206280*r**6
            +1881190105*r**8+716700482*r**10+157336027*r**12+14469828*r**14)+4*Q2**9*(
            -3352365-32232891*r**2-271078323*r**4-1352556375*r**6-2375510525*r**8
            -1673827605*r**10-350439261*r**12-63361633*r**14+4846770*r**16)+Q2**8*(
            -2729705+88671816*r**2+290389124*r**4+2654978408*r**6+6371797290*r**8
            +7327078400*r**10+3114119876*r**12-691377336*r**14-92962057*r**16-42913400*r**18)
            +8*Q2**7*(1747270-4971133*r**2+15127487*r**4+266907120*r**6+1492747966*r**8
            +2719556390*r**10+1861043472*r**12+853863832*r**14+317972780*r**16+40114391*r**18
            +1878665*r**20)+4*Q2**6*(-2456967-4677472*r**2+23073081*r**4-603032454*r**6
            -5851481694*r**8-16113018636*r**10-17957269110*r**12-8332675944*r**14
            -2848468779*r**16-372895044*r**18-46067315*r**20+4119774*r**22)-8*Q2**5*(229304
            -8600451*r**2-13472499*r**4-7450835*r**6-1468763325*r**8-6396000186*r**10
            -11704337214*r**12-7844229138*r**14-1198700610*r**16-511036475*r**18
            +106568217*r**20+8467725*r**22+1935887*r**24)+Q2**4*(6068155-55416868*r**2
            -529648674*r**4-565030660*r**6-2269446875*r**8-12054143520*r**10-35736518844*r**12
            -25962685992*r**14+17453038725*r**16+29611067900*r**18+4735543390*r**20
            +1370532012*r**22+129316891*r**24+1225160*r**26)+12*Q2**3*(-174505+109941*r**2
            +26994944*r**4+148392198*r**6+449400505*r**8+2459787075*r**10+4694349898*r**12
            +1521190932*r**14-2935005991*r**16-4346643205*r**18-2161639620*r**20
            -407821914*r**22-28949801*r**24-3480307*r**26+289850*r**28)-6*Q2**2*(189515
            -3931222*r**2-17811067*r**4+102589440*r**6+16192019*r**8+4091115470*r**10
            +11119907829*r**12+14975348124*r**14+4310241465*r**16-1116035738*r**18
            -4526104505*r**20+502957768*r**22-109686807*r**24+45159970*r**26+2918719*r**28
            +229020*r**30)+36*Q2*(26931-379535*r**2-4452807*r**4-14409807*r**6
            -176564787*r**8-451164495*r**10-1711459887*r**12+1089967489*r**14+475970739*r**16
            +27232299*r**18+820620947*r**20-372775221*r**22+286607943*r**24+25195443*r**26
            +5163363*r**28+420867*r**30+518*r**32)+9*(-21679+281592*r**2+4639432*r**4
            +30912240*r**6+319818060*r**8+1430620872*r**10+5770391864*r**12-8304862496*r**14
            -4018542330*r**16+8182983880*r**18-268700232*r**20-3464268304*r**22+686961996*r**24
            -329849160*r**26-36352440*r**28-3686336*r**30-332527*r**32+5568*r**34))*sqrtq2)
            +logq2*(-384*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(54928*Q2**20
            -10*Q2**19*(80571+66179*r**2)+10*Q2**18*(454635+932826*r**2+315743*r**4)
            -10*Q2**17*(1276291+4810467*r**2+4156451*r**4+713027*r**6)+10*Q2**16*(1673240
            +11757431*r**2+16884235*r**4+8279349*r**6+491705*r**8)+2*Q2**15*(291279
            -59156055*r**2-97945590*r**4-57271710*r**6-13876615*r**8+5923559*r**10)
            -10*Q2**14*(3179247+6569403*r**2+44188566*r**4+120967604*r**6+75147541*r**8
            +19669647*r**10+2857988*r**12)+5*Q2**13*(6433205+60642984*r**2+332390965*r**4
            +1097862886*r**6+1214635191*r**8+416413088*r**10+71427359*r**12+2563602*r**14)
            +5*Q2**12*(2841111-57953133*r**2-397686891*r**4-1861102247*r**6-3137405283*r**8
            -2048826147*r**10-287234445*r**12-19839849*r**14+5847972*r**16)-10*Q2**11*(4707430
            -926967*r**2-54829074*r**4-505111764*r**6-907956088*r**8-915369848*r**10
            -228097682*r**12+224264136*r**14+38356662*r**16+4072315*r**18)+4*Q2**10*(4510077
            +57863495*r**2+319685970*r**4+1470662320*r**6+7814017520*r**8+15640213853*r**10
            +10006163165*r**12+4434888910*r**14+1170745425*r**16+110393910*r**18
            +307307*r**20)+5*Q2**9*(5179239-46755564*r**2-368681911*r**4-2195790494*r**6
            -12439153626*r**8-38209590004*r**10-42558233486*r**12-16668936056*r**14
            -5253633789*r**16-332977536*r**18+1654389*r**20+6524726*r**22)-5*Q2**8*(4790695
            -9929301*r**2-197781337*r**4-1286268433*r**6-6195004898*r**8-34209666554*r**10
            -64772250554*r**12-44191072906*r**14-4893941093*r**16-1309794993*r**18
            +635093811*r**20+64911899*r**22+3840512*r**24)-10*Q2**7*(418313-13654759*r**2
            -41127194*r**4+269462462*r**6-1165420083*r**8-4237010291*r**10-10083900548*r**12
            -7245547460*r**14-8905623285*r**16-9160838453*r**18-1980677810*r**20
            -352827146*r**22-18460977*r**24+878591*r**26)+10*Q2**6*(1260165-14437827*r**2
            -105316878*r**4+264511880*r**6-381884731*r**8-13983361421*r**10-69660249688*r**12
            -119098406816*r**14-79333297209*r**16-39759741061*r**18-9544382366*r**20
            -2109246552*r**22-23532033*r**24+5803877*r**26+1259540*r**28)+Q2**5*(
            -2662377+10974120*r**2+484828155*r**4+1307981450*r**6-5161804645*r**8
            +33108765192*r**10+526380826495*r**12+1549238069610*r**14+1691496856965*r**16
            +536428413960*r**18+280893888657*r**20-12171448290*r**22+2098864585*r**24
            -1617715640*r**26-97736715*r**28-1429522*r**30)-5*Q2**4*(616103-12728853*r**2
            -43586543*r**4+1216863773*r**6+2902206467*r**8-2592019133*r**10+9559984153*r**12
            +70032535581*r**14+214049147049*r**16+74508298201*r**18-130117787973*r**20
            -16769631217*r**22-12492555863*r**24-1835799047*r**26-184875493*r**28
            -4948297*r**30+677892*r**32)+30*Q2**3*(49245-1005552*r**2-8390298*r**4
            +119452576*r**6+558599956*r**8+1463384198*r**10+4420500082*r**12+16969717740*r**14
            +13720059258*r**16+1342738458*r**18-21945512406*r**20-26796182328*r**22
            -7139162596*r**24-723747334*r**26-178221314*r**28+1417388*r**30+417273*r**32
            +45654*r**34)+30*Q2**2*(8287-277846*r**2+897755*r**4+45300500*r**6-28432468*r**8
            -1149771430*r**10-2275208286*r**12-30409099688*r**14-44294454506*r**16
            -25153597574*r**18-6278370596*r**20+21798649780*r**22-2492912204*r**24
            +2461427062*r**26-384866858*r**28-11605536*r**30-7241173*r**32-294388*r**34
            +9169*r**36)-45*Q2*(6425-211762*r**2-781057*r**4+43411204*r**6+82312436*r**8
            +322380516*r**10+4640825532*r**12+4639058012*r**14+19868199534*r**16
            -9857533632*r**18-6747069582*r**20-23382970028*r**22+18100809572*r**24
            -6819671780*r**26-669629844*r**28-191633484*r**30-25702367*r**32-1765902*r**34
            -39833*r**36+6040*r**38)+9*(5787-220735*r**2-1105095*r**4+57261285*r**6
            +101088130*r**8+1458374292*r**10+12154764580*r**12+29670853060*r**14
            +98584777970*r**16-304538439490*r**18+133768147902*r**20+164166435670*r**22
            -161489742960*r**24+35126704580*r**26-6861747660*r**28-2010898828*r**30
            -153685765*r**32-31511255*r**34-1056335*r**36-10355*r**38+5222*r**40))
            +384*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(54928*Q2**21-2*Q2**20*(430319
            +358359*r**2)+20*Q2**19*(267603+539788*r**2+190961*r**4)-20*Q2**18*(865463
            +3098964*r**2+2702510*r**4+514385*r**6)+10*Q2**17*(2949531+17844189*r**2
            +25851153*r**4+13148827*r**6+1204732*r**8)+2*Q2**16*(-8074921-126309410*r**2
            -241153920*r**4-183089630*r**6-57731885*r**8+3465034*r**10)-2*Q2**15*(16187514
            -26017761*r**2+63841185*r**4+449620720*r**6+304589380*r**8+90395179*r**10
            +20213499*r**12)+5*Q2**14*(12791699+80140284*r**2+433906903*r**4+1428175226*r**6
            +1606865481*r**8+606047464*r**10+116482629*r**12+8279578*r**14)+10*Q2**13*(
            -1796047-62514661*r**2-395360420*r**4-1645678049*r**6-2724951680*r**8
            -1839937213*r**10-387537446*r**12-46915405*r**14+1642185*r**16)-5*Q2**12*(12255971
            -56965956*r**2-565298172*r**4-3269012666*r**6-6814419706*r**8-7016971126*r**10
            -2792255956*r**12+141453978*r**14+62721447*r**16+13992602*r**18)+2*Q2**11*(32557304
            +134629305*r**2+360591735*r**4+141620450*r**6+8562695780*r**8+22163798026*r**10
            +14294988680*r**12+8850610090*r**14+3654594840*r**16+432932705*r**18
            +20976189*r**20)+Q2**10*(7855887-483272108*r**2-3353607415*r**4-18140345630*r**6
            -99334487490*r**8-284864875512*r**10-315376675502*r**12-141108888580*r**14
            -48690706285*r**16-6789445020*r**18-434532923*r**20+31394402*r**22)-10*Q2**9*(4984967
            -25752813*r**2-306609406*r**4-1925370419*r**6-10414974509*r**8-42429205092*r**10
            -72770037022*r**12-51709121224*r**14-13408255469*r**16-3448203159*r**18
            +151885332*r**20+36545507*r**22+5182619*r**24)+5*Q2**8*(3954069+22170912*r**2
            -125456250*r**4-2022974694*r**6-5150433165*r**8-31930650870*r**10-78814116012*r**12
            -94472228540*r**14-31273767429*r**16+12117940820*r**18+3286654438*r**20
            +1405660002*r**22+105674365*r**24+2083330*r**26)+10*Q2**7*(1678478-27674273*r**2
            -160098831*r**4+492847148*r**6-1277842352*r**8-19385791795*r**10-83981160527*r**12
            -136427854824*r**14-95484467954*r**16-57826202799*r**18-20685898629*r**20
            -4442751508*r**22-394820156*r**24-11778509*r**26+2138131*r**28)+Q2**6*(
            -15264027+142750740*r**2+1682375205*r**4-283968570*r**6-3988076135*r**8
            +176761226712*r**10+1362816937585*r**12+3436824634650*r**14+3675813897215*r**16
            +1727358796660*r**18+773935122927*r**20+104364840890*r**22+23426650435*r**24
            -1440434080*r**26-168370885*r**28-14024922*r**30)-2*Q2**5*(209069-27666261*r**2
            +138934780*r**4+3938564235*r**6+5328604570*r**8+7493432441*r**10+303644756226*r**12
            +1212890787005*r**14+2155490330910*r**16+1300233380965*r**18+83366681376*r**20
            +92437142141*r**22-36267681510*r**24-4348923145*r**26-1319914910*r**28
            -61953861*r**30+979969*r**32)+5*Q2**4*(911573-18146062*r**2-106657184*r**4
            +1889992686*r**6+7470669976*r**8+9090492522*r**10+33490965512*r**12+181410826174*r**14
            +366402038178*r**16+296613875998*r**18-187282564208*r**20-307664513158*r**22
            -72097162656*r**24-18670838914*r**26-3090002424*r**28-181319462*r**30
            -1766767*r**32+951816*r**34)-30*Q2**3*(40958-678461*r**2-10293605*r**4
            +65761778*r**6+706485000*r**8+3171755584*r**10+8159092566*r**12+51799317510*r**14
            +74984231504*r**16+40216395290*r**18-14324403352*r**20-70540344514*r**22
            -31442432720*r**24-10324336992*r**26-517101790*r**28-165198390*r**30
            +9075834*r**32+757315*r**34+36485*r**36)-15*Q2**2*(35849-1174404*r**2
            -1103353*r**4+222630122*r**6+280673372*r**8-1389266248*r**10+7072517164*r**12
            -51451441912*r**14-89802509786*r**16-168468705056*r**18-83105145086*r**20
            -39108351716*r**22+92913903868*r**24-20521985624*r**26+2144230876*r**28
            -1367845240*r**30-114800519*r**32-20368828*r**34-689937*r**36+36458*r**38)
            +18*Q2*(18956-623710*r**2-3034595*r**4+135206010*r**6+364853165*r**8
            +1740919526*r**10+18485397410*r**12+38035135390*r**14+110560532850*r**16
            -127242554990*r**18+25372565916*r**20+6758118810*r**22-93950272620*r**24
            +45766196770*r**26-22154127890*r**28-3158607734*r**30-620182510*r**32
            -84426300*r**34-5042505*r**36-89660*r**38+17711*r**40)-9*(5787-214948*r**2
            -1325830*r**4+56156190*r**6+158349415*r**8+1559462422*r**10+13613138872*r**12
            +41825617640*r**14+128255631030*r**16-205953661520*r**18-170770291588*r**20
            +297934583572*r**22+2676692710*r**24-126363038380*r**26+28264956920*r**28
            -8872646488*r**30-2164584593*r**32-185197020*r**34-32567590*r**36-1066690*r**38
            -5133*r**40+5222*r**42))*sqrtq2)))/(-157500*(-Q2+(-1+r)**2)*r**2*(1-Q2
            +r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))-157500*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2+logq2**6*(7054387200000*r**26*(1+r**2)*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -7054387200000*r**26*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**3*(5443200000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))+5443200000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))*sqrtq2)+logq2*(18900000*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)
            -Q2**2*(5+2*r**2+5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))+18900000*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)-Q2**2*(5+2*r**2
            +5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))*sqrtq2)+logq2**2*(-113400000*(
            -Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(16*Q2**4+Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1
            +9*r**2+9*r**4+r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))-113400000*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(16*Q2**4
            +Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1+9*r**2+9*r**4
            +r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))*sqrtq2)+logq2**4*(-16329600000*(
            -Q2+(-1+r)**2)*r**18*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))
            -16329600000*(-Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))*sqrtq2)
            +logq2**5*(78382080000*(-Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2
            +41*r**4)-18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4
            -82*r**6+13*r**8))+78382080000*(-Q2+(-1+r)**2)*r**22*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2+41*r**4)
            -18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4-82*r**6
            +13*r**8))*sqrtq2))+(-32*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(16836*Q2**23
            -8*Q2**22*(4941+2861*r**2)+8*Q2**21*(-138897+339784*r**2+185698*r**4)
            -Q2**20*(-9790683+40412335*r**2+274345695*r**4+23774341*r**6)+2*Q2**19*(
            -19393425+131142716*r**2+1804028042*r**4+1601981036*r**6+72704411*r**8)
            -2*Q2**18*(-43709733+466488229*r**2+10058799818*r**4+18924318670*r**6
            +8121671435*r**8+236337181*r**10)+2*Q2**17*(-53517069+941147882*r**2
            +29603112071*r**4+91718578220*r**6+84301857413*r**8+21264720914*r**10
            +431263217*r**12)-Q2**16*(-26160399+1721833031*r**2+88621670793*r**4
            +448444151703*r**6+645871580807*r**8+369067440177*r**10+48610962543*r**12
            +697312289*r**14)-8*Q2**15*(-16258086+125935876*r**2-2601675959*r**4
            -62916932019*r**6-121362503678*r**8-101664468590*r**10-34835652291*r**12
            +3909390841*r**14+54088978*r**16)+8*Q2**14*(-24343575+555554963*r**2
            +19996508151*r**4+10138354148*r**6+27055479953*r**8+141672723972*r**10
            +107965929119*r**12+61716930866*r**14+21939733728*r**16+191297123*r**18)
            -8*Q2**13*(-6990417+456437622*r**2+32743159244*r**4+120221211155*r**6
            +304864435619*r**8+874110734447*r**10+1009845400385*r**12+479002690997*r**14
            +176749121510*r**16+24158910515*r**18+107239035*r**20)+2*Q2**12*(70249491
            -1090389807*r**2+42057582697*r**4+580448240575*r**6+1096434294374*r**8
            +4420100876618*r**10+7484754723634*r**12+5983800103046*r**14+1781370535727*r**16
            +597751388701*r**18-21784357283*r**20-666380637*r**22)+4*Q2**11*(-38542179
            +1528353684*r**2+54738444800*r**4-132144144414*r**6+254731661975*r**8
            +268407019528*r**10+334592778704*r**12-498085868116*r**14-558458026013*r**16
            +376281648932*r**18+68635805088*r**20+75707954738*r**22+592091097*r**24)
            -4*Q2**10*(3182553+653152279*r**2+68702032204*r**4+47636036470*r**6+540981882685*r**8
            +2783793625765*r**10+8209253851660*r**12+12235863408496*r**14+6676362988711*r**16
            +3071727386389*r**18+1160714242792*r**20+355257003706*r**22+58955376259*r**24
            +206867983*r**26)-4*Q2**9*(-33832125+920542426*r**2-9929389483*r**4-184379258054*r**6
            +98362560161*r**8-1807707409552*r**10-8005242421457*r**12-22035793332532*r**14
            -20901484740451*r**16-6119424633086*r**18-3747963217717*r**20-304635973030*r**22
            -303024763073*r**24+21007447316*r**26+317239921*r**28)+2*Q2**8*(-47868957
            +2457308413*r**2+77077290331*r**4-544527712175*r**6+941738700667*r**8
            +1030611609509*r**10+1073768687491*r**12-36496051045367*r**14-60836458760455*r**16
            -34350525457913*r**18+4802922417313*r**20-4461112985053*r**22+1334419644265*r**24
            -159514244585*r**26+124219228225*r**28+754051651*r**30)-4*Q2**7*(1017297
            +296093128*r**2+29201319966*r**4-178479495570*r**6+65218860376*r**8+1086706691524*r**10
            +4549986316714*r**12-15639164476502*r**14-41677209515378*r**16-40496973128000*r**18
            -14561663411822*r**20+4345762042594*r**22-515797222280*r**24+294017313652*r**26
            +86046531558*r**28+29657459910*r**30+71972113*r**32)-8*Q2**6*(-5403258
            +218915324*r**2+620992079*r**4-33527713512*r**6+181452624323*r**8-358954544654*r**10
            -1349823239083*r**12+6798926890534*r**14+21943977959233*r**16+31123506993212*r**18
            +19718612906689*r**20+1194957919588*r**22+1139179114997*r**24-914671893446*r**26
            +246895200155*r**28-71311941282*r**30+7183711361*r**32+69066140*r**34)
            +8*Q2**5*(-2872734+189766762*r**2+5744628312*r**4-93980335529*r**6+172763701141*r**8
            -307578586805*r**10-1605696727499*r**12+214601549263*r**14+7870258089041*r**16
            +16859545498879*r**18+14679498237301*r**20+2464492790669*r**22-16399584026297*r**24
            +2463466861033*r**26-1620243541625*r**28+245438934733*r**30-53071715087*r**32
            +10741239267*r**34+55446775*r**36)+Q2**4*(-727425-213652307*r**2-19858496099*r**4
            +382149022903*r**6-329035744052*r**8+1338170780916*r**10+16219304909220*r**12
            +24381187435964*r**14-5339988445438*r**16-178623260010058*r**18+91237789847878*r**20
            +18347613634466*r**22+31441061047964*r**24+171392429874692*r**26-1574274860268*r**28
            +6658121302956*r**30-101752529129*r**32+93031814821*r**34-26662724507*r**36
            -66690497*r**38)-2*Q2**3*(-3067263+161472196*r**2+1203029162*r**4-40584335840*r**6
            +256753140881*r**8-434358128960*r**10+1568394154776*r**12+6760503877280*r**14
            -17871172228190*r**16-105025582248952*r**18-24208614828708*r**20-9385229563200*r**22
            -4437340828726*r**24+2412808900000*r**26+13309634749016*r**28+6810526456608*r**30
            -1389735393347*r**32+388526672084*r**34-58095607670*r**36+5150768480*r**38
            +39762373*r**40)+3*(-1+r**2)**2*(-20679+1920513*r**2+59150986*r**4-2963490774*r**6
            +9885678237*r**8-48140822267*r**10-462514045128*r**12+2852856216792*r**14
            -10236317153998*r**16+55736988630114*r**18-136886372992740*r**20+143275557787516*r**22
            -54462591618942*r**24-5025168827982*r**26+6404364511736*r**28-2706121138728*r**30
            -25790604075*r**32-97840066211*r**34+3363539754*r**36-1529637462*r**38
            +121488289*r**40+455049*r**42)+2*Q2**2*(-1524939+107640875*r**2+2311998914*r**4
            -81595080310*r**6+304495293965*r**8-889292363809*r**10-4024781855248*r**12
            +14710907203120*r**14-34394719260398*r**16+93937492063822*r**18+10373589839588*r**20
            -50776472791564*r**22-64057349117782*r**24-20043765376274*r**26+51879465706336*r**28
            -38108530283168*r**30+5708243191097*r**32-2378815940377*r**34+265398057482*r**36
            -55389065998*r**38+5276970953*r**40+26293715*r**42)-6*Q2*(-114009+9498210*r**2
            +247404039*r**4-10930092648*r**6+46105769689*r**8-170439103818*r**10
            -937957870623*r**12+5694315922800*r**14-16360677278106*r**16+70226224451748*r**18
            -113507600005882*r**20+12703943994144*r**22+102066006163506*r**24-56060451959044*r**26
            -20265069326238*r**28+20966452153104*r**30-8068256488509*r**32+657945077082*r**34
            -344653342077*r**36+26506559176*r**38-6560914395*r**40+535159278*r**42
            +2262573*r**44))-32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(16836*Q2**23-8*Q2**22*(4941
            +2861*r**2)+8*Q2**21*(-138897+339784*r**2+185698*r**4)-Q2**20*(-9790683
            +40412335*r**2+274345695*r**4+23774341*r**6)+2*Q2**19*(-19393425+131142716*r**2
            +1804028042*r**4+1601981036*r**6+72704411*r**8)-2*Q2**18*(-43709733+466488229*r**2
            +10058799818*r**4+18924318670*r**6+8121671435*r**8+236337181*r**10)+2*Q2**17*(
            -53517069+941147882*r**2+29603112071*r**4+91718578220*r**6+84301857413*r**8
            +21264720914*r**10+431263217*r**12)-Q2**16*(-26160399+1721833031*r**2
            +88621670793*r**4+448444151703*r**6+645871580807*r**8+369067440177*r**10
            +48610962543*r**12+697312289*r**14)-8*Q2**15*(-16258086+125935876*r**2
            -2601675959*r**4-62916932019*r**6-121362503678*r**8-101664468590*r**10
            -34835652291*r**12+3909390841*r**14+54088978*r**16)+8*Q2**14*(-24343575
            +555554963*r**2+19996508151*r**4+10138354148*r**6+27055479953*r**8+141672723972*r**10
            +107965929119*r**12+61716930866*r**14+21939733728*r**16+191297123*r**18)
            -8*Q2**13*(-6990417+456437622*r**2+32743159244*r**4+120221211155*r**6
            +304864435619*r**8+874110734447*r**10+1009845400385*r**12+479002690997*r**14
            +176749121510*r**16+24158910515*r**18+107239035*r**20)+2*Q2**12*(70249491
            -1090389807*r**2+42057582697*r**4+580448240575*r**6+1096434294374*r**8
            +4420100876618*r**10+7484754723634*r**12+5983800103046*r**14+1781370535727*r**16
            +597751388701*r**18-21784357283*r**20-666380637*r**22)+4*Q2**11*(-38542179
            +1528353684*r**2+54738444800*r**4-132144144414*r**6+254731661975*r**8
            +268407019528*r**10+334592778704*r**12-498085868116*r**14-558458026013*r**16
            +376281648932*r**18+68635805088*r**20+75707954738*r**22+592091097*r**24)
            -4*Q2**10*(3182553+653152279*r**2+68702032204*r**4+47636036470*r**6+540981882685*r**8
            +2783793625765*r**10+8209253851660*r**12+12235863408496*r**14+6676362988711*r**16
            +3071727386389*r**18+1160714242792*r**20+355257003706*r**22+58955376259*r**24
            +206867983*r**26)-4*Q2**9*(-33832125+920542426*r**2-9929389483*r**4-184379258054*r**6
            +98362560161*r**8-1807707409552*r**10-8005242421457*r**12-22035793332532*r**14
            -20901484740451*r**16-6119424633086*r**18-3747963217717*r**20-304635973030*r**22
            -303024763073*r**24+21007447316*r**26+317239921*r**28)+2*Q2**8*(-47868957
            +2457308413*r**2+77077290331*r**4-544527712175*r**6+941738700667*r**8
            +1030611609509*r**10+1073768687491*r**12-36496051045367*r**14-60836458760455*r**16
            -34350525457913*r**18+4802922417313*r**20-4461112985053*r**22+1334419644265*r**24
            -159514244585*r**26+124219228225*r**28+754051651*r**30)-4*Q2**7*(1017297
            +296093128*r**2+29201319966*r**4-178479495570*r**6+65218860376*r**8+1086706691524*r**10
            +4549986316714*r**12-15639164476502*r**14-41677209515378*r**16-40496973128000*r**18
            -14561663411822*r**20+4345762042594*r**22-515797222280*r**24+294017313652*r**26
            +86046531558*r**28+29657459910*r**30+71972113*r**32)-8*Q2**6*(-5403258
            +218915324*r**2+620992079*r**4-33527713512*r**6+181452624323*r**8-358954544654*r**10
            -1349823239083*r**12+6798926890534*r**14+21943977959233*r**16+31123506993212*r**18
            +19718612906689*r**20+1194957919588*r**22+1139179114997*r**24-914671893446*r**26
            +246895200155*r**28-71311941282*r**30+7183711361*r**32+69066140*r**34)
            +8*Q2**5*(-2872734+189766762*r**2+5744628312*r**4-93980335529*r**6+172763701141*r**8
            -307578586805*r**10-1605696727499*r**12+214601549263*r**14+7870258089041*r**16
            +16859545498879*r**18+14679498237301*r**20+2464492790669*r**22-16399584026297*r**24
            +2463466861033*r**26-1620243541625*r**28+245438934733*r**30-53071715087*r**32
            +10741239267*r**34+55446775*r**36)+Q2**4*(-727425-213652307*r**2-19858496099*r**4
            +382149022903*r**6-329035744052*r**8+1338170780916*r**10+16219304909220*r**12
            +24381187435964*r**14-5339988445438*r**16-178623260010058*r**18+91237789847878*r**20
            +18347613634466*r**22+31441061047964*r**24+171392429874692*r**26-1574274860268*r**28
            +6658121302956*r**30-101752529129*r**32+93031814821*r**34-26662724507*r**36
            -66690497*r**38)-2*Q2**3*(-3067263+161472196*r**2+1203029162*r**4-40584335840*r**6
            +256753140881*r**8-434358128960*r**10+1568394154776*r**12+6760503877280*r**14
            -17871172228190*r**16-105025582248952*r**18-24208614828708*r**20-9385229563200*r**22
            -4437340828726*r**24+2412808900000*r**26+13309634749016*r**28+6810526456608*r**30
            -1389735393347*r**32+388526672084*r**34-58095607670*r**36+5150768480*r**38
            +39762373*r**40)+3*(-1+r**2)**2*(-20679+1920513*r**2+59150986*r**4-2963490774*r**6
            +9885678237*r**8-48140822267*r**10-462514045128*r**12+2852856216792*r**14
            -10236317153998*r**16+55736988630114*r**18-136886372992740*r**20+143275557787516*r**22
            -54462591618942*r**24-5025168827982*r**26+6404364511736*r**28-2706121138728*r**30
            -25790604075*r**32-97840066211*r**34+3363539754*r**36-1529637462*r**38
            +121488289*r**40+455049*r**42)+2*Q2**2*(-1524939+107640875*r**2+2311998914*r**4
            -81595080310*r**6+304495293965*r**8-889292363809*r**10-4024781855248*r**12
            +14710907203120*r**14-34394719260398*r**16+93937492063822*r**18+10373589839588*r**20
            -50776472791564*r**22-64057349117782*r**24-20043765376274*r**26+51879465706336*r**28
            -38108530283168*r**30+5708243191097*r**32-2378815940377*r**34+265398057482*r**36
            -55389065998*r**38+5276970953*r**40+26293715*r**42)-6*Q2*(-114009+9498210*r**2
            +247404039*r**4-10930092648*r**6+46105769689*r**8-170439103818*r**10
            -937957870623*r**12+5694315922800*r**14-16360677278106*r**16+70226224451748*r**18
            -113507600005882*r**20+12703943994144*r**22+102066006163506*r**24-56060451959044*r**26
            -20265069326238*r**28+20966452153104*r**30-8068256488509*r**32+657945077082*r**34
            -344653342077*r**36+26506559176*r**38-6560914395*r**40+535159278*r**42
            +2262573*r**44))*sqrtq2+logq2**8*(-40633270272000000*r**36*(1+r**2)**2*(1
            -Q2+r**2)*(183+645*r**2-1235*r**4+279*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3-40633270272000000*(Q2-(-1+r)**2)**2*r**36*(1+r**2)**2*(183
            +645*r**2-1235*r**4+279*r**6)*(Q2-(1+r)**2)**2*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*sqrtq2)+logq2**7*(64497254400000*r**32*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(8330*Q2**9*(1+r**2)-10*Q2**8*(4403
            +14296*r**2+9893*r**4)+20*Q2**7*(1785+23122*r**2+45082*r**4+23745*r**6)
            -2*Q2**6*(-119245-1001*r**2+955557*r**4+1386505*r**6+604520*r**8)+2*Q2**5*(
            -312445-920311*r**2-397384*r**4+1676372*r**6+2319155*r**8+853265*r**10)
            +Q2**4*(383565+2195725*r**2+4711306*r**4+3464558*r**6-2467235*r**8-3868895*r**10
            -1057560*r**12)-Q2**3*(-498785+122640*r**2+3589539*r**4+4472216*r**6
            +2592257*r**8+241920*r**10-390675*r**12+455560*r**14)+6*(-1+r**2)**2*(
            -21525-35148*r**2-347062*r**4-246472*r**6+821518*r**8+112208*r**10
            -157474*r**12+55620*r**14+33375*r**16)+Q2**2*(-942935-952665*r**2-523259*r**4
            -1076069*r**6+3645855*r**8+269713*r**10-22205*r**12+1655085*r**14+1279600*r**16)
            +Q2*(576135+342978*r**2+4016310*r**4+8335974*r**6-6480996*r**8-12975666*r**10
            +50466*r**12+2564754*r**14-742395*r**16-848520*r**18))-64497254400000*r**32*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(8330*Q2**10*(1+r**2)-20*Q2**9*(2618
            +7981*r**2+5363*r**4)+10*Q2**8*(7973+64943*r**2+114353*r**4+57383*r**6)
            -2*Q2**7*(-101395+248069*r**2+1637597*r**4+2074775*r**6+841970*r**8)
            +14*Q2**6*(-61670-148651*r**2+79596*r**4+574062*r**6+615740*r**8+208255*r**10)
            +Q2**5*(1008455+4661237*r**2+7346696*r**4+906582*r**6-10458289*r**8
            -10213735*r**10-2764090*r**12)+10*Q2**4*(11522-270193*r**2-1049657*r**4
            -1264808*r**6-358958*r**8+609421*r**10+531713*r**12+60200*r**14)+2*Q2**3*(
            -720860-664405*r**2+1594460*r**4+3492843*r**6+5355164*r**8+1551945*r**10
            -85480*r**12+859985*r**14+867580*r**16)-6*(-1+r**2)**2*(-21525-56673*r**2
            -382210*r**4-593534*r**6+575046*r**8+933726*r**10-45266*r**12-101854*r**14
            +88995*r**16+33375*r**18)-2*Q2**2*(-759535-1119289*r**2-2746117*r**4
            -4967651*r**6+4525391*r**8+8445617*r**10+98521*r**12-465937*r**14+1838540*r**16
            +1064060*r**18)+3*Q2*(-235095-290567*r**2-2049678*r**4-3292420*r**6
            +1316474*r**8+2930954*r**10+5187656*r**12+93812*r**14-1078131*r**16
            +508045*r**18+349590*r**20))*sqrtq2)+logq2**6*(358318080000*r**28*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-133280*Q2**13*(1+r**2)
            +900*Q2**12*(677+2330*r**2+1653*r**4)-30*Q2**11*(22665+287074*r**2+541993*r**4
            +277584*r**6)+4*Q2**10*(718899+7324761*r**2+20216173*r**4+21153339*r**6
            +7653684*r**8)-60*Q2**9*(411619+2185540*r**2+5219697*r**4+6967164*r**6
            +4747174*r**8+1225786*r**10)+30*Q2**8*(2442265+12502651*r**2+28697246*r**4
            +39912946*r**6+35906531*r**8+17838199*r**10+3207754*r**12)-5*Q2**7*(17150547
            +104053566*r**2+265677517*r**4+351694832*r**6+294048185*r**8+191169982*r**10
            +71776575*r**12+1734444*r**14)-30*Q2**6*(177590-8944523*r**2-44797942*r**4
            -55373751*r**6+17427746*r**8+71603727*r**10+45973718*r**12+16672915*r**14
            +6062504*r**16)+3*Q2**5*(38137531+22918244*r**2-522651758*r**4-1253407844*r**6
            -407808824*r**8+1914702736*r**10+2666511814*r**12+1401745132*r**14+403550741*r**16
            +91781236*r**18)-20*Q2**4*(4675928+4769990*r**2-64700306*r**4-273682274*r**6
            -470469227*r**8-265117790*r**10+243027643*r**12+395452102*r**14+188310187*r**16
            +44478428*r**18+6826727*r**20)-15*Q2**3*(1293673-4454130*r**2-40491403*r**4
            +102829920*r**6+518017770*r**8+686448408*r**10+420715938*r**12+84150756*r**14
            -39360531*r**16-18899782*r**18-5684439*r**20+4415836*r**22)+18*(-1
            +r**2)**2*(461527-1921253*r**2-17311559*r**4-37982463*r**6-73908860*r**8
            +259314*r**10+146796202*r**12+50415222*r**14-27950057*r**16+24963315*r**18
            +23562589*r**20+2342281*r**22+590542*r**24)+30*Q2**2*(2389852-5641559*r**2
            -65689358*r**4-69488681*r**6+10021736*r**8+30560834*r**10+38974628*r**12
            +16025510*r**14+61845140*r**16+126260197*r**18+68420362*r**20+8097715*r**22
            +4015624*r**24)-45*Q2*(925645-3680264*r**2-27600344*r**4-30247060*r**6
            -70217623*r**8-102641500*r**10+103898160*r**12+229791912*r**14+32548103*r**16
            -56124976*r**18+29771816*r**20+33834220*r**22+2927683*r**24+1321108*r**26))
            -358318080000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(133280*Q2**13*(1
            +r**2)-900*Q2**12*(677+2330*r**2+1653*r**4)+30*Q2**11*(22665+287074*r**2
            +541993*r**4+277584*r**6)-4*Q2**10*(718899+7324761*r**2+20216173*r**4
            +21153339*r**6+7653684*r**8)+60*Q2**9*(411619+2185540*r**2+5219697*r**4
            +6967164*r**6+4747174*r**8+1225786*r**10)-30*Q2**8*(2442265+12502651*r**2
            +28697246*r**4+39912946*r**6+35906531*r**8+17838199*r**10+3207754*r**12)
            +5*Q2**7*(17150547+104053566*r**2+265677517*r**4+351694832*r**6+294048185*r**8
            +191169982*r**10+71776575*r**12+1734444*r**14)+30*Q2**6*(177590-8944523*r**2
            -44797942*r**4-55373751*r**6+17427746*r**8+71603727*r**10+45973718*r**12
            +16672915*r**14+6062504*r**16)-3*Q2**5*(38137531+22918244*r**2-522651758*r**4
            -1253407844*r**6-407808824*r**8+1914702736*r**10+2666511814*r**12+1401745132*r**14
            +403550741*r**16+91781236*r**18)+20*Q2**4*(4675928+4769990*r**2-64700306*r**4
            -273682274*r**6-470469227*r**8-265117790*r**10+243027643*r**12+395452102*r**14
            +188310187*r**16+44478428*r**18+6826727*r**20)+15*Q2**3*(1293673-4454130*r**2
            -40491403*r**4+102829920*r**6+518017770*r**8+686448408*r**10+420715938*r**12
            +84150756*r**14-39360531*r**16-18899782*r**18-5684439*r**20+4415836*r**22)
            -18*(-1+r**2)**2*(461527-1921253*r**2-17311559*r**4-37982463*r**6-73908860*r**8
            +259314*r**10+146796202*r**12+50415222*r**14-27950057*r**16+24963315*r**18
            +23562589*r**20+2342281*r**22+590542*r**24)-30*Q2**2*(2389852-5641559*r**2
            -65689358*r**4-69488681*r**6+10021736*r**8+30560834*r**10+38974628*r**12
            +16025510*r**14+61845140*r**16+126260197*r**18+68420362*r**20+8097715*r**22
            +4015624*r**24)+45*Q2*(925645-3680264*r**2-27600344*r**4-30247060*r**6
            -70217623*r**8-102641500*r**10+103898160*r**12+229791912*r**14+32548103*r**16
            -56124976*r**18+29771816*r**20+33834220*r**22+2927683*r**24+1321108*r**26))*sqrtq2)
            +logq2**5*(-1990656000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(-533120*Q2**17
            +160*Q2**16*(2263+24223*r**2)+Q2**15*(28540810+28430260*r**2-3345110*r**4)
            -6*Q2**14*(32841213+90288215*r**2+68156439*r**4+11771325*r**6)+6*Q2**13*(118374827
            +515426112*r**2+754385896*r**4+423840956*r**6+79664105*r**8)-6*Q2**12*(283618158
            +1639909707*r**2+3491112002*r**4+3439604456*r**6+1566151984*r**8+298947885*r**10)
            +4*Q2**11*(706307523+4714354092*r**2+13135419351*r**4+19063572614*r**6
            +14433991926*r**8+5550602604*r**10+1098591630*r**12)-Q2**10*(3067240233
            +20235139368*r**2+74948214147*r**4+160696342462*r**6+186639633007*r**8
            +110814446184*r**10+33982711869*r**12+6778311690*r**14)+Q2**9*(1634258481
            +9582738945*r**2+78743987793*r**4+268774090445*r**6+451843939535*r**8
            +402270903551*r**10+174530564055*r**12+34474451283*r**14+5368299000*r**16)
            +2*Q2**8*(523139863-1170867297*r**2-62612941506*r**4-264079526926*r**6
            -524885720610*r**8-596322853062*r**10-380242724602*r**12-115931605566*r**14
            -12237713241*r**16+430176595*r**18)+2*Q2**7*(-1921622597+3049563172*r**2
            +91307449377*r**4+403269397616*r**6+886383261134*r**8+1139631052248*r**10
            +902676196922*r**12+399258555872*r**14+70878372111*r**16+3409221124*r**18
            -3321936035*r**20)+2*Q2**6*(2684872738-188070653*r**2-34465229954*r**4
            -291073293541*r**6-837896189014*r**8-1005834524158*r**10-582234853258*r**12
            -163675207234*r**14+88386900884*r**16+107064831691*r**18+11749868284*r**20
            +3136564135*r**22)-6*Q2**5*(694878144+3029320019*r**2+24908864491*r**4
            -16954523589*r**6-239474590839*r**8-321886703004*r**10+82876522716*r**12
            +503943626316*r**14+449602712496*r**16+235240581801*r**18+86395210537*r**20
            +8214534617*r**22+253177815*r**24)-6*Q2**4*(-144332362-3624044095*r**2
            -27252902886*r**4+685164220*r**6+251390166160*r**8+654415025649*r**10
            +636434696700*r**12-85207495248*r**14-668952302250*r**16-542242673765*r**18
            -225090868742*r**20-59206968060*r**22-6240421996*r**24+282668675*r**26)
            +36*Q2**3*(42431467-165040173*r**2+227520526*r**4-1644859594*r**6+3688458900*r**8
            +67971903581*r**10+146054833761*r**12+129435478128*r**14+52095997083*r**16
            -2447977255*r**18-17944255848*r**20-9571846438*r**22+1168879846*r**24
            -14330889*r**26+44112505*r**28)+54*(-1+r**2)**2*(-1638997-19908451*r**2
            -181490423*r**4+1286285587*r**6+5782451469*r**8+4277620319*r**10-2564915433*r**12
            -7293005039*r**14-3344512859*r**16+1849597227*r**18-4098888457*r**20
            -5083524891*r**22-1036862813*r**24-370302503*r**26-39112471*r**28+191735*r**30)
            -9*Q2**2*(170882957+586257028*r**2+10076653063*r**4-35298892806*r**6
            -159044254759*r**8-73988242324*r**10+81586199299*r**12+45958476114*r**14
            -3938850873*r**16+83424716668*r**18+233704686917*r**20+146630486798*r**22
            +21230477523*r**24+20804557204*r**26+1952683441*r**28+55715750*r**30)
            +27*Q2*(22122351+156204379*r**2+1785571027*r**4-11350983737*r**6-37878331273*r**8
            -14287955169*r**10-9915341233*r**12-5161582149*r**14+79647117049*r**16
            +53844046641*r**18-30989927575*r**20+16418571189*r**22+35821055597*r**24
            +4667747413*r**26+3525994357*r**28+398689993*r**30+1129140*r**32))-1990656000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(533120*Q2**18-2400*Q2**17*(373+1837*r**2)
            +10*Q2**16*(-2817873-2419250*r**2+722079*r**4)+8*Q2**15*(28198511+74837545*r**2
            +54252973*r**4+8410355*r**6)-60*Q2**14*(15121604+63855554*r**2+91283055*r**4
            +50376872*r**6+9143543*r**8)+6*Q2**13*(401992985+2273710646*r**2+4760924010*r**4
            +4617831308*r**6+2069657045*r**8+378611990*r**10)-2*Q2**12*(2263469520
            +15199291779*r**2+41663903829*r**4+58919294602*r**6+43885253172*r**8
            +16696504815*r**10+3094026915*r**12)+3*Q2**11*(1964156775+13972595276*r**2
            +48782435973*r**4+96497436774*r**6+106876630389*r**8+63584274768*r**10
            +20193162935*r**12+3724226070*r**14)-2*Q2**10*(2350749357+16442559273*r**2
            +86963670654*r**4+252209323527*r**6+399589957502*r**8+349862491371*r**10
            +159663861054*r**12+37617737421*r**14+6073305345*r**16)+5*Q2**9*(117595751
            +2711746404*r**2+42710521950*r**4+175135426418*r**6+354077894240*r**8
            +409352109842*r**10+267457383362*r**12+88173645294*r**14+12863635353*r**16
            +901589162*r**18)+12*Q2**8*(407460410-616215101*r**2-25848543030*r**4
            -121660311008*r**6-279224751445*r**8-376806604320*r**10-313206962431*r**12
            -149238814340*r**14-33174615153*r**16-2536126295*r**18+625352105*r**20)
            +Q2**7*(-9212990670+2632022456*r**2+257644485006*r**4+1571300281068*r**6
            +4255097695528*r**8+6063697675080*r**10+5249084204856*r**12+2931219920056*r**14
            +763500054198*r**16-65554476912*r**18-23325166390*r**20-12917000340*r**22)
            +4*Q2**6*(2384753585+5792381071*r**2+20036646433*r**4-188201047131*r**6
            -923696627536*r**8-1404695411092*r**10-669719904634*r**12+382960409228*r**14
            +636759915569*r**16+450586738989*r**18+189000165793*r**20+19765018135*r**22
            +1948048790*r**24)+12*Q2**5*(-419605253-3674121129*r**2-27595543698*r**4
            -3634588341*r**6+253909640294*r**8+607888159746*r**10+437722438494*r**12
            -336013822140*r**14-811249320531*r**16-613542984031*r**18-273363330540*r**20
            -76908356607*r**22-7354067214*r**24+14745430*r**26)-30*Q2**4*(22051288
            -951723499*r**2-5902364765*r**4-7287379246*r**6+54841216756*r**8+262727322659*r**10
            +433435744983*r**12+265568014044*r**14-88316763000*r**16-245176567909*r**18
            -174999815519*r**20-68345783086*r**22-11686822196*r**24-1208747731*r**26
            +109468741*r**28)+9*Q2**3*(340608825+95822204*r**2+10326574475*r**4-40968249078*r**6
            -150869857535*r**8+212653207600*r**10+937693148667*r**12+1147919723670*r**14
            +722187049971*r**16+282016795980*r**18+152135754505*r**20+36566077654*r**22
            -12381388845*r**24+25422753032*r**26+2071809905*r**28+232165770*r**30)
            +54*(-1+r**2)**2*(-1638997-21547448*r**2-201398874*r**4+1104795164*r**6
            +7068737056*r**8+10060071788*r**10+1712704886*r**12-9857920472*r**14
            -10637517898*r**16-1494915632*r**18-2249291230*r**20-9182413348*r**22
            -6120387704*r**24-1407165316*r**26-409414974*r**28-38920736*r**30+191735*r**32)
            -18*Q2**2*(118625005+612876561*r**2+8009811586*r**4-29637595477*r**6
            -153989070692*r**8-137948181295*r**10-11074033362*r**12+56029964483*r**14
            +140480488194*r**16+120509002859*r**18+112079810430*r**20+214795443641*r**22
            +137662065556*r**24+28019138483*r**26+16667611858*r**28+1602234585*r**30
            +29551585*r**32)+27*Q2*(25400345+211587644*r**2+2228400442*r**4-12824128674*r**6
            -55286094754*r**8-40164292378*r**10-13527887198*r**12-19305815674*r**14
            +57132371328*r**16+130999927878*r**18+45139310606*r**20-24499054886*r**22
            +42177029762*r**24+47249006546*r**26+8864482326*r**28+4508456002*r**30
            +478811015*r**32+745670*r**34))*sqrtq2)+logq2**4*(-33177600*r**20*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(4518400*Q2**20-320*Q2**19*(484283
            +494165*r**2)+8*Q2**18*(202268379+416241266*r**2+203680407*r**4)-2*Q2**17*(4262429513
            +13288326490*r**2+13394037721*r**4+4344833864*r**6)+8*Q2**16*(3286215902
            +14149575103*r**2+21877792793*r**4+14510540773*r**6+3514583981*r**8)
            -2*Q2**15*(24362830791+142790225436*r**2+308524491968*r**4+314561249120*r**6
            +152121355725*r**8+28553289048*r**10)+3*Q2**14*(16183420475+141699215495*r**2
            +420306191794*r**4+601357980526*r**6+449282739547*r**8+162720297395*r**10
            +22126183520*r**12)-Q2**13*(6964510851+307587603234*r**2+1366596143001*r**4
            +2627936742460*r**6+2797413523201*r**8+1635612874290*r**10+418303381899*r**12
            +17598307608*r**14)+Q2**12*(-44590145427-64618207515*r**2+177268406553*r**4
            +413815696909*r**6+652906602191*r**8+891419733967*r**10+504274701771*r**12
            -4308606369*r**14-73769561856*r**16)+2*Q2**11*(29455195411+174008150424*r**2
            +853317774345*r**4+2813963078658*r**6+5215178307301*r**8+5156091233812*r**10
            +2816975905563*r**12+1022738215242*r**14+251194574844*r**16+60134936608*r**18)
            -Q2**10*(44112846209+322249649459*r**2+2488401138060*r**4+9903635955196*r**6
            +24744431659790*r**8+35500028434282*r**10+27882566282348*r**12+12887271337036*r**14
            +4307928012009*r**16+716987470235*r**18+61410247952*r**20)+Q2**9*(32875007205
            +175908678230*r**2+1364822713311*r**4+6470145592564*r**6+27724169972758*r**8
            +61738516030040*r**10+70745199849050*r**12+42616302319396*r**14+14598821065429*r**16
            +4080532873218*r**18+561541235735*r**20-43112535720*r**22)+Q2**8*(-14908954769
            -114380281891*r**2+370711065809*r**4-1510438260065*r**6-30136810032818*r**8
            -100427676907718*r**10-156734213618854*r**12-129630655257962*r**14-55689940066685*r**16
            -11903421800903*r**18-1242660360091*r**20-153960361861*r**22+83830854448*r**24)
            +2*Q2**7*(-10013564909+31073100860*r**2-689606244290*r**4+1573647410388*r**6
            +22706173693429*r**8+80704495911440*r**10+147932169558944*r**12+154674257634896*r**14
            +89545456249697*r**16+25661944716604*r**18+3767687732562*r**20-816939939476*r**22
            -138155470393*r**24-20165786552*r**26)+Q2**6*(36899642583+77580132807*r**2
            +1837252234438*r**4-2963025307654*r**6-31857385762023*r**8-143350962734547*r**10
            -302895431708988*r**12-339875802817188*r**14-225967364501223*r**16-60785573957631*r**18
            +17063867086614*r**20+4363244316266*r**22+2435127808375*r**24+430327635147*r**26
            -15251234976*r**28)+3*Q2**5*(-6040694187-63131169922*r**2-592932312049*r**4
            -1718637275196*r**6-6220431074735*r**8+16469497032490*r**10+66487424754843*r**12
            +51269626172304*r**14-28173543374385*r**16-68770274292990*r**18-63088382279027*r**20
            -35580788019356*r**22-6470738552565*r**24-548965818154*r**26-81246890935*r**28
            +9406737864*r**30)-3*Q2**4*(1573710815-46999784445*r**2-251439981769*r**4
            -2982362039561*r**6-10810145546917*r**8+9898928501695*r**10+85076091368835*r**12
            +128187181726243*r**14+37429103261517*r**16-94507760250311*r**18-126021730558155*r**20
            -81358581900395*r**22-32079462235399*r**24-6075779873531*r**26-184573880047*r**28
            +2732465745*r**30+3779895680*r**32)-18*Q2**3*(-478741241+716091896*r**2
            -22808501177*r**4+181700706550*r**6+51076781217*r**8-715712318236*r**10
            -6956874529561*r**12-22677400999814*r**14-29137471665985*r**16-17341779088864*r**18
            -3598621593155*r**20+4365865717514*r**22+4660758907619*r**24+412691299860*r**26
            +123796946197*r**28-12629661818*r**30-5292857674*r**32+131986672*r**34)
            +27*(-1+r**2)**2*(1255651-185563037*r**2-1860632516*r**4-15193194408*r**6
            -40949732440*r**8+736451718852*r**10+1471214973716*r**12-1252341907592*r**14
            -2224101762506*r**16+1239949685730*r**18+1471888184668*r**20-1248818331896*r**22
            -1344918800368*r**24-206718340764*r**26-173225005540*r**28-35076718296*r**30
            -1777166033*r**32-48471149*r**34+7407928*r**36)+9*Q2**2*(-365733831-4977863025*r**2
            -70314720184*r**4-184291491848*r**6-1555265048236*r**8+7465214697652*r**10
            +18489258479504*r**12+1994688500776*r**14-8977751294322*r**16-905376547878*r**18
            -5127451251936*r**20-23696794455608*r**22-17232755976700*r**24-1285078131212*r**26
            -3854060229136*r**28-765614134760*r**30-48490851871*r**32-6468256017*r**34
            +441508632*r**36)-27*Q2*(-12776227-1001410098*r**2-10026878589*r**4
            -56160075652*r**6-212133691024*r**8+2791154302556*r**10+4500839836904*r**12
            -2833108108108*r**14-3728324776574*r**16-898143658408*r**18-719532328906*r**20
            +2440664162236*r**22-2364895534792*r**24-4398795795196*r**26-148260907312*r**28
            -691835036548*r**30-164065148167*r**32-8640938886*r**34-585667953*r**36
            +54830744*r**38))-33177600*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(4518400*Q2**20
            -320*Q2**19*(484283+494165*r**2)+8*Q2**18*(202268379+416241266*r**2+203680407*r**4)
            -2*Q2**17*(4262429513+13288326490*r**2+13394037721*r**4+4344833864*r**6)
            +8*Q2**16*(3286215902+14149575103*r**2+21877792793*r**4+14510540773*r**6
            +3514583981*r**8)-2*Q2**15*(24362830791+142790225436*r**2+308524491968*r**4
            +314561249120*r**6+152121355725*r**8+28553289048*r**10)+3*Q2**14*(16183420475
            +141699215495*r**2+420306191794*r**4+601357980526*r**6+449282739547*r**8
            +162720297395*r**10+22126183520*r**12)-Q2**13*(6964510851+307587603234*r**2
            +1366596143001*r**4+2627936742460*r**6+2797413523201*r**8+1635612874290*r**10
            +418303381899*r**12+17598307608*r**14)+Q2**12*(-44590145427-64618207515*r**2
            +177268406553*r**4+413815696909*r**6+652906602191*r**8+891419733967*r**10
            +504274701771*r**12-4308606369*r**14-73769561856*r**16)+2*Q2**11*(29455195411
            +174008150424*r**2+853317774345*r**4+2813963078658*r**6+5215178307301*r**8
            +5156091233812*r**10+2816975905563*r**12+1022738215242*r**14+251194574844*r**16
            +60134936608*r**18)-Q2**10*(44112846209+322249649459*r**2+2488401138060*r**4
            +9903635955196*r**6+24744431659790*r**8+35500028434282*r**10+27882566282348*r**12
            +12887271337036*r**14+4307928012009*r**16+716987470235*r**18+61410247952*r**20)
            +Q2**9*(32875007205+175908678230*r**2+1364822713311*r**4+6470145592564*r**6
            +27724169972758*r**8+61738516030040*r**10+70745199849050*r**12+42616302319396*r**14
            +14598821065429*r**16+4080532873218*r**18+561541235735*r**20-43112535720*r**22)
            +Q2**8*(-14908954769-114380281891*r**2+370711065809*r**4-1510438260065*r**6
            -30136810032818*r**8-100427676907718*r**10-156734213618854*r**12-129630655257962*r**14
            -55689940066685*r**16-11903421800903*r**18-1242660360091*r**20-153960361861*r**22
            +83830854448*r**24)+2*Q2**7*(-10013564909+31073100860*r**2-689606244290*r**4
            +1573647410388*r**6+22706173693429*r**8+80704495911440*r**10+147932169558944*r**12
            +154674257634896*r**14+89545456249697*r**16+25661944716604*r**18+3767687732562*r**20
            -816939939476*r**22-138155470393*r**24-20165786552*r**26)+Q2**6*(36899642583
            +77580132807*r**2+1837252234438*r**4-2963025307654*r**6-31857385762023*r**8
            -143350962734547*r**10-302895431708988*r**12-339875802817188*r**14-225967364501223*r**16
            -60785573957631*r**18+17063867086614*r**20+4363244316266*r**22+2435127808375*r**24
            +430327635147*r**26-15251234976*r**28)+3*Q2**5*(-6040694187-63131169922*r**2
            -592932312049*r**4-1718637275196*r**6-6220431074735*r**8+16469497032490*r**10
            +66487424754843*r**12+51269626172304*r**14-28173543374385*r**16-68770274292990*r**18
            -63088382279027*r**20-35580788019356*r**22-6470738552565*r**24-548965818154*r**26
            -81246890935*r**28+9406737864*r**30)-3*Q2**4*(1573710815-46999784445*r**2
            -251439981769*r**4-2982362039561*r**6-10810145546917*r**8+9898928501695*r**10
            +85076091368835*r**12+128187181726243*r**14+37429103261517*r**16-94507760250311*r**18
            -126021730558155*r**20-81358581900395*r**22-32079462235399*r**24-6075779873531*r**26
            -184573880047*r**28+2732465745*r**30+3779895680*r**32)-18*Q2**3*(-478741241
            +716091896*r**2-22808501177*r**4+181700706550*r**6+51076781217*r**8-715712318236*r**10
            -6956874529561*r**12-22677400999814*r**14-29137471665985*r**16-17341779088864*r**18
            -3598621593155*r**20+4365865717514*r**22+4660758907619*r**24+412691299860*r**26
            +123796946197*r**28-12629661818*r**30-5292857674*r**32+131986672*r**34)
            +27*(-1+r**2)**2*(1255651-185563037*r**2-1860632516*r**4-15193194408*r**6
            -40949732440*r**8+736451718852*r**10+1471214973716*r**12-1252341907592*r**14
            -2224101762506*r**16+1239949685730*r**18+1471888184668*r**20-1248818331896*r**22
            -1344918800368*r**24-206718340764*r**26-173225005540*r**28-35076718296*r**30
            -1777166033*r**32-48471149*r**34+7407928*r**36)+9*Q2**2*(-365733831-4977863025*r**2
            -70314720184*r**4-184291491848*r**6-1555265048236*r**8+7465214697652*r**10
            +18489258479504*r**12+1994688500776*r**14-8977751294322*r**16-905376547878*r**18
            -5127451251936*r**20-23696794455608*r**22-17232755976700*r**24-1285078131212*r**26
            -3854060229136*r**28-765614134760*r**30-48490851871*r**32-6468256017*r**34
            +441508632*r**36)-27*Q2*(-12776227-1001410098*r**2-10026878589*r**4
            -56160075652*r**6-212133691024*r**8+2791154302556*r**10+4500839836904*r**12
            -2833108108108*r**14-3728324776574*r**16-898143658408*r**18-719532328906*r**20
            +2440664162236*r**22-2364895534792*r**24-4398795795196*r**26-148260907312*r**28
            -691835036548*r**30-164065148167*r**32-8640938886*r**34-585667953*r**36
            +54830744*r**38))*sqrtq2)+logq2**3*(552960*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(-184961280*Q2**23+192*Q2**22*(15005227+14944715*r**2)-2*Q2**21*(9914187549
            +20348549594*r**2+10155753405*r**4)+6*Q2**20*(13066111429+42622862457*r**2
            +43379687139*r**4+14072542255*r**6)-20*Q2**19*(9581885862+45934778997*r**2
            +73366474936*r**4+48382079721*r**6+10953124992*r**8)+10*Q2**18*(28085282265
            +200974919840*r**2+454440891240*r**4+469082442714*r**6+221529771359*r**8
            +33439264038*r**10)-12*Q2**17*(15019596553+209553499065*r**2+629376076275*r**4
            +888746053900*r**6+684006887850*r**8+241704380373*r**10+14792872180*r**12)
            +Q2**16*(-148564564563+964128964152*r**2+3130209957995*r**4+3075953607570*r**6
            +3838561846275*r**8+4027654017512*r**10+997932130317*r**12-374919367050*r**14)
            +Q2**15*(454470189519+2244077164307*r**2+13635128217459*r**4+47073269467815*r**6
            +70406888815065*r**8+47329736014269*r**10+15314262681837*r**12+3670344817769*r**14
            +873468359640*r**16)-15*Q2**14*(30433381687+279059596692*r**2+2002405782336*r**4
            +8615008578084*r**6+17686566077410*r**8+18037185899140*r**10+9332338938672*r**12
            +2575456202316*r**14+490449025911*r**16+39089101432*r**18)+5*Q2**13*(37488292191
            +591672992685*r**2+4596174373680*r**4+30545113398660*r**6+89030029848366*r**8
            +127357032090386*r**10+96138561983700*r**12+37122248534940*r**14+7263810105651*r**16
            +1141909928481*r**18-82289252292*r**20)+Q2**12*(130542786879-424165248290*r**2
            +5907070116675*r**4-50155744829940*r**6-306498434702190*r**8-634860632042364*r**10
            -682648146682470*r**12-384679010529240*r**14-90361576609425*r**16+1602956694750*r**18
            +648364753699*r**20+1013901828300*r**22)-3*Q2**11*(113259906791+302549930751*r**2
            +8378103464625*r**4+29613847009745*r**6+59978203254650*r**8+96677422117394*r**10
            +106185657636414*r**12+69260556106910*r**14+51233384754215*r**16+32503718339375*r**18
            +13231428668241*r**20+2065026303441*r**22+173464305080*r**24)+Q2**10*(315090106599
            +1453394243952*r**2+19911132720194*r**4+125271556267440*r**6+542353951999065*r**8
            +1487542377969616*r**10+2643600951598188*r**12+2672771018329536*r**14
            +1623419399999785*r**16+755788423995600*r**18+225078466409874*r**20+38204230938512*r**22
            +6287610942039*r**24-358979331600*r**26)+5*Q2**9*(-8449022409-443158653859*r**2
            -1926443666502*r**4-14048567401674*r**6-76174451529871*r**8-282514310719293*r**10
            -790100058797796*r**12-1191422286329468*r**14-936682170759735*r**16-441205493289933*r**18
            -172638059991286*r**20-42253550986554*r**22-1366183230897*r**24-322375553107*r**26
            +117643382496*r**28)-15*Q2**8*(13996363441-133269559530*r**2-439141915725*r**4
            -1684122170672*r**6+2282118471637*r**8-28968146628662*r**10-257578108778465*r**12
            -631728634056620*r**14-707969736109901*r**16-397286637039062*r**18-124841149587335*r**20
            -29053930429880*r**22-6105674860985*r**24+977930879862*r**26+193801174197*r**28
            +12159931540*r**30)-Q2**7*(-185705922189+117678064575*r**2+1465989281075*r**4
            +10292852388495*r**6-220208247202005*r**8+526989554417119*r**10+5525204084580315*r**12
            +15948485623753095*r**14+23057339130501945*r**16+17745005243574645*r**18
            +6952079785711329*r**20+1555606176760885*r**22-34664883363855*r**24-47282127673875*r**26
            -12373266100975*r**28-3410209791819*r**30+161832189240*r**32)+Q2**6*(
            -5134408923-1443765833948*r**2-6956015917620*r**4-15248588644140*r**6
            -233924388159900*r**8+865895557213548*r**10+5320133692433508*r**12+16674350324095940*r**14
            +28027319044202910*r**16+26889644057492100*r**18+13200604369811348*r**20
            +1673697028132668*r**22+174897642904260*r**24-270231886347420*r**26-116032123253700*r**28
            -2805177492948*r**30-952291917803*r**32+156007050120*r**34)-9*Q2**5*(8622088589
            -128827646023*r**2-965957305086*r**4-4865648750920*r**6-30589104348200*r**8
            -38230466473064*r**10-49425432431232*r**12+746945944369376*r**14+1622009305756290*r**16
            +959899243012970*r**18-207191735618164*r**20-1102520359185512*r**22-1095279582481984*r**24
            -288143927988480*r**26-39927570297120*r**28-9642481772336*r**30+112459811417*r**32
            +99511590469*r**34+2993909010*r**36)-15*Q2**4*(-2562904681+7159505484*r**2
            +228673575707*r**4+2496756869730*r**6+12451358827352*r**8+89881229572224*r**10
            +196811855676256*r**12-371333669624112*r**14-1320006271971458*r**16-857913976458200*r**18
            +620325694324750*r**20+1334336261444596*r**22+1301073104734368*r**24+786562714702336*r**26
            +215479544681304*r**28+18744705542432*r**30+1257032157939*r**32-48227871988*r**34
            -55471128033*r**36+1721623994*r**38)+45*Q2**3*(126523637-7301814495*r**2
            -21619248065*r**4+150940625419*r**6-689637745872*r**8+15154393057688*r**10
            -5631222772880*r**12-113910600221280*r**14-387905088891670*r**16-668375636756718*r**18
            -544675286597994*r**20-202196939795970*r**22+58168477105520*r**24+163762993277328*r**26
            +46647492566152*r**28+17526178776056*r**30+1093814813145*r**32-434062614875*r**34
            -7808707277*r**36-3202207137*r**38+344549288*r**40)+54*(-1+r**2)**2*(
            -8777579+52860565*r**2+1998039600*r**4+25026645900*r**6+217973212405*r**8
            +1033437011301*r**10-1502401729800*r**12-47710692219000*r**14-19102945427950*r**16
            +132982280739410*r**18+5706100981496*r**20-144750692719840*r**22+22837427099450*r**24
            +77705543423450*r**26+875001204840*r**28+7128981634296*r**30+3257677473945*r**32
            +290957956825*r**34+21177588600*r**36+151595220*r**38-191222639*r**40
            +2229505*r**42)-9*Q2**2*(1258381349-22446350360*r**2-173793672050*r**4
            -1033597079540*r**6-12930970752515*r**8-13209406347476*r**10-139231477571880*r**12
            +769554606523760*r**14+1240738513529930*r**16-106110373029120*r**18-428267124444956*r**20
            -308145271015640*r**22-1509388184703870*r**24-1251320777041240*r**26+147554266807160*r**28
            -351419196175056*r**30-111537289616015*r**32-10304337032840*r**34-2136008691650*r**36
            -33814034900*r**38+13276329889*r**40+264387020*r**42)-27*Q2*(-145789591
            +1765846019*r**2+23998306470*r**4+226549792910*r**6+2149561405025*r**8
            +6252920749039*r**10+692525062104*r**12-336574132971720*r**14-163456496323630*r**16
            +586242681766550*r**18+313530883181204*r**20-282774109722876*r**22-498802743242710*r**24
            +193105432529030*r**26+476573496726200*r**28-67574339458536*r**30+52482830509989*r**32
            +27317693897575*r**34+2441309659190*r**36+271915800350*r**38+5730703509*r**40
            -2482015861*r**42+14389760*r**44))+552960*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(184961280*Q2**24-192*Q2**23*(15968567+15908055*r**2)+Q2**22*(22709378682
            +46447488052*r**2+23180892090*r**4)-4*Q2**21*(24556260918+79065662257*r**2
            +80321682208*r**4+26186690085*r**6)+2*Q2**20*(135017192907+626414711628*r**2
            +991672398148*r**4+656177485392*r**6+151748876685*r**8)-10*Q2**19*(47249053989
            +312008249558*r**2+693043399106*r**4+712579552028*r**6+340200180785*r**8
            +55345514022*r**10)+2*Q2**18*(230543990643+2402622004915*r**2+7053335513050*r**4
            +9950092993170*r**6+7557102397465*r**8+2725071459223*r**10+255953553270*r**12)
            +Q2**17*(-31670594073-3659006111568*r**2-13197364862075*r**4-21293419169670*r**6
            -22711597147275*r**8-15136189236188*r**10-4075899160953*r**12+197404900890*r**14)
            -2*Q2**16*(301517377041+714256382359*r**2+4770394647656*r**4+20433552951125*r**6
            +31746186680610*r**8+19731760075241*r**10+5144338267004*r**12+1523666027251*r**14
            +624193863345*r**16)+2*Q2**15*(455485457412+3442220652103*r**2+22957646058403*r**4
            +94966763178267*r**6+191389324722015*r**8+194147206658217*r**10+101314541388093*r**12
            +28808225267173*r**14+5950274283037*r**16+729902440560*r**18)-10*Q2**14*(64394218626
            +760075963911*r**2+5720285255382*r**4+31198678239960*r**6+83967376907424*r**8
            +117264144010018*r**10+89123568248568*r**12+36422816978952*r**14+8230762895166*r**16
            +1365262155255*r**18+17489026002*r**20)+2*Q2**13*(28449337038+1784985836335*r**2
            +10016083357575*r**4+112931091845820*r**6+452187075468660*r**8+858397970868062*r**10
            +900063058526450*r**12+525491531561220*r**14+156145934906190*r**16+20212821737955*r**18
            +2324869313623*r**20-712674044880*r**22)+2*Q2**12*(235161253626+307013665421*r**2
            +15308607631130*r**4+22296433157985*r**6-88359784884090*r**8-325663400196186*r**10
            -499475902907796*r**12-429772744445490*r**14-160670216438010*r**16+4376267551725*r**18
            +20972803726586*r**20+3928672746161*r**22+767147371770*r**24)-2*Q2**11*(327434913486
            +1350411878289*r**2+22976546453161*r**4+119623703845275*r**6+405565051396125*r**8
            +978754627042874*r**10+1626095095429806*r**12+1599554829779754*r**14+992450611291580*r**16
            +503499866638185*r**18+181141953716361*r**20+42046797926779*r**22+6501541383801*r**24
            +80706791820*r**26)+2*Q2**10*(178667609322+1992138809923*r**2+15498372648328*r**4
            +107712762998002*r**6+524248882957930*r**8+1721233941782573*r**10+4040821811778392*r**12
            +5636741700787532*r**14+4489800636063998*r**16+2292617645222525*r**18
            +922028595180952*r**20+237275226140578*r**22+25661379017518*r**24+3770254687987*r**26
            -473598122040*r**28)+10*Q2**9*(16770033957-425708177429*r**2-1843514033768*r**4
            -10513688790096*r**6-41688331758317*r**8-222796601067575*r**10-922674347926242*r**12
            -1938354123648562*r**14-2126006832709453*r**16-1284873787583427*r**18
            -494183501021612*r**20-151026701133740*r**22-30968379400203*r**24+622616927791*r**26
            +188335675990*r**28+77061588558*r**30)+2*Q2**8*(-197825686902+953388002955*r**2
            +5026080704950*r**4+21070906842225*r**6-114589095858240*r**8+463639988386247*r**10
            +4911698957843610*r**12+14644043383139685*r**14+21576407341499880*r**16
            +17161925420404545*r**18+7391998292553642*r**20+1932016188509555*r**22
            +246364597999560*r**24+14817016021485*r**26-14974623455930*r**28-3249813188937*r**30
            -10283391930*r**32)-2*Q2**7*(-95420165556-755896845781*r**2-2686174285985*r**4
            -1744873487285*r**6-221919891486705*r**8+586338432214331*r**10+5686163665715471*r**12
            +19074020016214675*r**14+33516571899228975*r**16+33845994215784345*r**18
            +18948844699548661*r**20+5090691495302441*r**22+847919468150645*r**24
            -176089448692575*r**26-87843758514275*r**28-9294326692871*r**30-2100334760191*r**32
            +158919619680*r**34)+2*Q2**6*(36232194189-1304174528539*r**2-8546698748671*r**4
            -32997721660020*r**6-262237457968920*r**8+143948485398036*r**10+2870600178882984*r**12
            +14358498757926916*r**14+29649876560052730*r**16+31778028144405870*r**18
            +19112761403369986*r**20+2475809082637204*r**22-4004460785650464*r**24
            -1344314797669740*r**26-372806071137600*r**28-102809818348836*r**30-1372665553999*r**32
            +49659723269*r**34+91476115605*r**36)-6*Q2**5*(19340394586-198207099861*r**2
            -2213861365931*r**4-14989301258334*r**6-84310526717060*r**8-327932430162456*r**10
            -623513487547084*r**12+1974614941967496*r**14+6853448555117144*r**16+6017647764299390*r**18
            -421752974719666*r**20-5300408795817004*r**22-6549382674337164*r**24-4041542052461536*r**26
            -1030806109131660*r**28-121216841960264*r**30-17437613336226*r**32+438526782799*r**34
            +292436069301*r**36+186803530*r**38)-30*Q2**4*(-1091666885-8654421341*r**2
            +85487668498*r**4+1589126160847*r**6+6439601229733*r**8+73897883786320*r**10
            +134899708464920*r**12-258126807305848*r**14-1427527604135290*r**16-2091523579349906*r**18
            -935807070963716*r**20+674035568190718*r**22+1404957398747762*r**24+1289462399634344*r**26
            +570992368541048*r**28+143401393275952*r**30+11641591069903*r**32-46691779337*r**34
            -63562560926*r**36-31678062725*r**38+1377635929*r**40)+18*Q2**3*(945499767
            -29161402325*r**2-159199492425*r**4-193495096385*r**6-7812228177390*r**8
            +29557185105802*r**10-45807813073920*r**12+85922745776480*r**14-634169966017410*r**16
            -2693757000635530*r**18-3246760870609258*r**20-2021253201492730*r**22
            -1114765249078060*r**24-70831712563500*r**26+599803348012280*r**28-15275419732008*r**30
            -9218660835005*r**32-3502788020745*r**34-2172682651205*r**36-44434303485*r**38
            -505979678*r**40+993566730*r**42)+54*(-1+r**2)**2*(-8777579+44082986*r**2
            +2050900165*r**4+27024685500*r**6+242999858305*r**8+1251410223706*r**10
            -468964718499*r**12-49213093948800*r**14-66813637646950*r**16+113879335311460*r**18
            +138688381720906*r**20-139044591738344*r**22-121913265620390*r**24+100542970522900*r**26
            +78580544628290*r**28+8003982839136*r**30+10386659108241*r**32+3548635430770*r**34
            +312135545425*r**36+21329183820*r**38-39627419*r**40-188993134*r**42
            +2229505*r**44)-18*Q2**2*(847875061-13242753534*r**2-134117470910*r**4
            -943520065160*r**6-10206626023565*r**8-22449569673554*r**10-77259229552834*r**12
            +820022763933520*r**14+1250331304512290*r**16-312049952399420*r**18-737485073508844*r**20
            +55954966854016*r**22-160562612995690*r**24-1670012629666100*r**26-1266743500206340*r**28
            -570955496144*r**30-310202488660519*r**32-101897354170790*r**34-9882137351030*r**36
            -1492785063800*r**38-18864907769*r**40+10493382246*r**42+110608870*r**44)
            -27*Q2*(-163344749+1760887874*r**2+29531234271*r**4+292714953910*r**6
            +2715947118345*r**8+9647516618846*r**10+242840731149*r**12-423226511405814*r**14
            -350398554734850*r**16+669741144195540*r**18+341050753097206*r**20-15604454428516*r**22
            -145487025924334*r**24-531137317704260*r**26+406281612170010*r**28+575168202563796*r**30
            -35342078128161*r**32+81609693694026*r**34+35152881854555*r**36+3210734209230*r**38
            +319012854901*r**40+4321227654*r**42-2858989399*r**44+18848770*r**46))*sqrtq2)
            +logq2**2*(9216*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(
            -681943552*Q2**26+32*Q2**25*(312188101+331842301*r**2)-4*Q2**24*(16425404305
            +35881510114*r**2+18123000145*r**4)+Q2**23*(250693046890+866266761444*r**2
            +904171597194*r**4+278136255760*r**6)-4*Q2**22*(147565101725+752119106369*r**2
            +1216250486817*r**4+801108299699*r**6+155567064950*r**8)+4*Q2**21*(198471385630
            +1582857454396*r**2+3481272234871*r**4+3576518434276*r**6+1653827953501*r**8
            +166353447250*r**10)+2*Q2**20*(-126901811845-3573489744393*r**2-9269633374320*r**4
            -11523481302550*r**6-9330155757435*r**8-3164162097093*r**10+163876062860*r**12)
            -Q2**19*(1168794026945-26692864774*r**2+9231980841495*r**4+47171672298800*r**6
            +50324072338475*r**8+15380596890810*r**10+4498436876501*r**12+2078063316980*r**14)
            +2*Q2**18*(1139426904620+6810826204787*r**2+40096246215152*r**4+154688883608015*r**6
            +244513585628000*r**8+169651821737105*r**10+52160768814152*r**12+11338857891437*r**14
            +1207327795580*r**16)+Q2**17*(-1406770536225-21225013198596*r**2-130265003869878*r**4
            -657898142887036*r**6-1431168552717240*r**8-1494488038384440*r**10-752519763916066*r**12
            -168397001664828*r**14-28344183721791*r**16+306598416900*r**18)+2*Q2**16*(
            -606673816755+5906626021407*r**2+32999589922542*r**4+306898845165052*r**6
            +932192937344242*r**8+1343456077915518*r**10+1033847749174732*r**12+362984705968492*r**14
            +34244721052377*r**16+2395929576267*r**18-1832378965890*r**20)+4*Q2**15*(726312555810
            +1997408554656*r**2+20630645423775*r**4+30297417623195*r**6+12203636598905*r**8
            +70856467124567*r**10+29916155379407*r**12-19603556976775*r**14+57744274296245*r**16
            +43194012108705*r**18+7959722029506*r**20+804115084500*r**22)+4*Q2**14*(
            -401596854430-5159766912084*r**2-40157481546765*r**4-240475707679300*r**6
            -950836306829400*r**8-2647610706663360*r**10-3801679359578806*r**12-2711422406683920*r**14
            -1119628982266350*r**16-382905067338700*r**18-72774698299725*r**20-10318490686284*r**22
            +232872612980*r**24)+4*Q2**13*(-305602587265+4469297060216*r**2+26553542054631*r**4
            +249832266083525*r**6+1279863102264425*r**8+5012995028868060*r**10+10186702064898674*r**12
            +10460581528807874*r**14+5586053166930705*r**16+1760627935804700*r**18
            +450056064858695*r**20+28420045567881*r**22+2330497813991*r**24-891713205760*r**26)
            +4*Q2**12*(574514972675-1177288938589*r**2-4212943349227*r**4-71145004963204*r**6
            -358895165054020*r**8-3513611245662415*r**10-11450565003130846*r**12-16903703033933968*r**14
            -12689346966881641*r**16-4667436377365915*r**18-845508629422195*r**20
            -141974228697724*r**22+37844852068298*r**24+7071638704631*r**26+457219763900*r**28)
            +2*Q2**11*(-394348752035-4750580006598*r**2-18141777624903*r**4-144038987145818*r**6
            -1543935657657513*r**8-2357748037080864*r**10+3094826739477343*r**12+12110599853640648*r**14
            +14443605860363763*r**16+6098007937665058*r**18-1257197502714369*r**20
            -1666167478439298*r**22-514762947680903*r**24-100900276658268*r**26-15274778403063*r**28
            +583390072180*r**30)+4*Q2**10*(-240132700600+3712258874381*r**2+16766899144785*r**4
            +84237403737065*r**6+873173971105490*r**8+3901359962267253*r**10+10875674043890591*r**12
            +21146755209955265*r**14+26660850701960160*r**16+20408944602682535*r**18
            +12698282658137951*r**20+5672242124862363*r**22+1453434685301210*r**24
            +389206111063415*r**26+14206264500465*r**28+873424315931*r**30-433583248660*r**32)
            +2*Q2**9*(504728472265-3490603164788*r**2-31972952881100*r**4-146499557200850*r**6
            -733687659248750*r**8-5390581435553420*r**10-22315878618857912*r**12-63172492808789870*r**14
            -123117187280076200*r**16-126785117235436400*r**18-75174711058663100*r**20
            -38256994535516462*r**22-13163059065168890*r**24-1405253880533900*r**26
            -385375029852800*r**28+30341899296430*r**30+7788036900487*r**32+184982118460*r**34)
            +4*Q2**8*(-12729148040-1208669915619*r**2+3231603904566*r**4+92853881160730*r**6
            +163146170434275*r**8+666236416504860*r**10+817502005264049*r**12+13558757250750654*r**14
            +65576504738468775*r**16+110299419732507850*r**18+81629074926460305*r**20
            +31858952505345654*r**22+11703390777275849*r**24+3855166249518180*r**26
            -96432972072525*r**28-81029185028750*r**30-16520986114059*r**32-2791019364519*r**34
            +137285071765*r**36)-2*Q2**7*(207827774125-3853115165702*r**2-15960656698761*r**4
            +126066915518038*r**6+195167350961710*r**8-15054027234570*r**10-9847911177999658*r**12
            +21746662030342886*r**14+178182543496913472*r**16+397561001110791610*r**18
            +422534716535243260*r**20+220666125665784882*r**22+62372682241466786*r**24
            +4932382214366882*r**26-230924287636470*r**28-406120733390990*r**30-345685108203197*r**32
            -12762454549836*r**34+277616437933*r**36+194642317600*r**38)-4*Q2**6*(
            -49830806275+549941732159*r**2+6863959385894*r**4+26927532789989*r**6
            +140759332281854*r**8+242412433396988*r**10+3710483724988816*r**12-24519162781549244*r**14
            -104043404141116814*r**16-246936637023837454*r**18-331349968026262396*r**20
            -235704022420348234*r**22-71131429734385844*r**24-19788716766255764*r**26
            +1520471567587696*r**28+2899312993543028*r**30+89613306860009*r**32+82711079209319*r**34
            -1302992239786*r**36-1070529509971*r**38+678536030*r**40)+12*Q2**5*(4356333015
            -172881017828*r**2+241868077790*r**4+24117625609545*r**6+83916295812350*r**8
            +285576326264818*r**10+1537188426639984*r**12-1285067546906440*r**14-4385528462400770*r**16
            -34937342346216600*r**18-53742872718549084*r**20-37822490849051814*r**22
            +4321418282026260*r**24+36680846965640380*r**26+12556895746511600*r**28
            +1900659784216704*r**30+968925596451763*r**32+40385928822140*r**34-5120337922530*r**36
            -1272481344475*r**38-149304807578*r**40+8653810770*r**42)-6*Q2**4*(11709826795
            -281417606849*r**2-1049131432410*r**4+24752105604550*r**6+77831197791175*r**8
            +687471648129735*r**10+3235970302279596*r**12+15755362727981400*r**14
            +22170127824105150*r**16-65704157289472850*r**18-104452388604175700*r**20
            +21317348020642356*r**22+88973228916279310*r**24+110019378603738550*r**26
            +116115188072251800*r**28+46090393440299640*r**30+5632296909857271*r**32
            +676857420774195*r**34+81044260006750*r**36-21576106978250*r**38-1575342889845*r**40
            +43228913251*r**42+6508874380*r**44)-9*Q2**3*(-1251518135+11954737434*r**2
            +345773796379*r**4+3217472883340*r**6+3226203273075*r**8-152282519583290*r**10
            -93919607159631*r**12-6856343907237996*r**14+10218819206387370*r**16+57383414952454900*r**18
            +108731042915210430*r**20+110699046167603464*r**22+51697614753818614*r**24
            +1120448457339900*r**26-28839313342343150*r**28-13805714413048200*r**30
            -10140929287668771*r**32-1783380886641006*r**34+202075093216855*r**36
            -9517446311700*r**38+4958477546695*r**40+68872676254*r**42-47756053491*r**44
            +539020660*r**46)+54*(-1+r**2)**2*(10835647-361727633*r**2-1173230433*r**4
            +63157525647*r**6+145355046687*r**8+3941069908437*r**10+22597282902557*r**12
            +34592905863557*r**14-358748097714788*r**16-2928176472716298*r**18+2835087302712182*r**20
            +6840661434944502*r**22-7371478282243698*r**24-3918212498398518*r**26
            +5515708041422522*r**28+117224111488362*r**30+76561374177607*r**32+255176168349707*r**34
            +41817344428187*r**36+3261267205227*r**38+308997639747*r**40-20147040783*r**42
            -3097045383*r**44+29400097*r**46+4266862*r**48)+18*Q2**2*(493614100-18771544957*r**2
            +15551343974*r**4+3418106758943*r**6+4622263385780*r**8+55623850773845*r**10
            +586312326760438*r**12-256721860210671*r**14+4987507889635668*r**16-23360600374991090*r**18
            -26296231883294260*r**20+4670648609204678*r**22+11092522985383544*r**24
            +32971611878721338*r**26+32837775100597340*r**28-13093854542503790*r**30
            +7845493122172908*r**32+4343218854705279*r**34+335135997910798*r**36+136316080903595*r**38
            +8395468356980*r**40-132073105567*r**42-122105684626*r**44-6959101747*r**46
            +422207500*r**48)-27*Q2*(159465819-5528922692*r**2-4676755882*r**4+922357440208*r**6
            +755340812548*r**8+33695380443328*r**10+210707943065218*r**12+71726521274928*r**14
            -1145810473903257*r**16-20990670095974692*r**18+8860466201977948*r**20
            +38171926958209248*r**22+171010533815008*r**24-42824036601616352*r**26
            -7957640339641212*r**28+37401549863945248*r**30-5327368879664007*r**32
            +205031155626228*r**34+2153010133993518*r**36+289251375753808*r**38+36085940937628*r**40
            +3651846296608*r**42-168574647782*r**44-40476710992*r**46-323184827*r**48
            +81964404*r**50))-9216*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(681943552*Q2**26
            -32*Q2**25*(312188101+331842301*r**2)+4*Q2**24*(16425404305+35881510114*r**2
            +18123000145*r**4)-2*Q2**23*(125346523445+433133380722*r**2+452085798597*r**4
            +139068127880*r**6)+4*Q2**22*(147565101725+752119106369*r**2+1216250486817*r**4
            +801108299699*r**6+155567064950*r**8)-4*Q2**21*(198471385630+1582857454396*r**2
            +3481272234871*r**4+3576518434276*r**6+1653827953501*r**8+166353447250*r**10)
            +Q2**20*(253803623690+7146979488786*r**2+18539266748640*r**4+23046962605100*r**6
            +18660311514870*r**8+6328324194186*r**10-327752125720*r**12)+Q2**19*(1168794026945
            -26692864774*r**2+9231980841495*r**4+47171672298800*r**6+50324072338475*r**8
            +15380596890810*r**10+4498436876501*r**12+2078063316980*r**14)-2*Q2**18*(1139426904620
            +6810826204787*r**2+40096246215152*r**4+154688883608015*r**6+244513585628000*r**8
            +169651821737105*r**10+52160768814152*r**12+11338857891437*r**14+1207327795580*r**16)
            +Q2**17*(1406770536225+21225013198596*r**2+130265003869878*r**4+657898142887036*r**6
            +1431168552717240*r**8+1494488038384440*r**10+752519763916066*r**12+168397001664828*r**14
            +28344183721791*r**16-306598416900*r**18)+2*Q2**16*(606673816755-5906626021407*r**2
            -32999589922542*r**4-306898845165052*r**6-932192937344242*r**8-1343456077915518*r**10
            -1033847749174732*r**12-362984705968492*r**14-34244721052377*r**16-2395929576267*r**18
            +1832378965890*r**20)-4*Q2**15*(726312555810+1997408554656*r**2+20630645423775*r**4
            +30297417623195*r**6+12203636598905*r**8+70856467124567*r**10+29916155379407*r**12
            -19603556976775*r**14+57744274296245*r**16+43194012108705*r**18+7959722029506*r**20
            +804115084500*r**22)+4*Q2**14*(401596854430+5159766912084*r**2+40157481546765*r**4
            +240475707679300*r**6+950836306829400*r**8+2647610706663360*r**10+3801679359578806*r**12
            +2711422406683920*r**14+1119628982266350*r**16+382905067338700*r**18+72774698299725*r**20
            +10318490686284*r**22-232872612980*r**24)+4*Q2**13*(305602587265-4469297060216*r**2
            -26553542054631*r**4-249832266083525*r**6-1279863102264425*r**8-5012995028868060*r**10
            -10186702064898674*r**12-10460581528807874*r**14-5586053166930705*r**16
            -1760627935804700*r**18-450056064858695*r**20-28420045567881*r**22-2330497813991*r**24
            +891713205760*r**26)-4*Q2**12*(574514972675-1177288938589*r**2-4212943349227*r**4
            -71145004963204*r**6-358895165054020*r**8-3513611245662415*r**10-11450565003130846*r**12
            -16903703033933968*r**14-12689346966881641*r**16-4667436377365915*r**18
            -845508629422195*r**20-141974228697724*r**22+37844852068298*r**24+7071638704631*r**26
            +457219763900*r**28)+2*Q2**11*(394348752035+4750580006598*r**2+18141777624903*r**4
            +144038987145818*r**6+1543935657657513*r**8+2357748037080864*r**10-3094826739477343*r**12
            -12110599853640648*r**14-14443605860363763*r**16-6098007937665058*r**18
            +1257197502714369*r**20+1666167478439298*r**22+514762947680903*r**24+100900276658268*r**26
            +15274778403063*r**28-583390072180*r**30)+4*Q2**10*(240132700600-3712258874381*r**2
            -16766899144785*r**4-84237403737065*r**6-873173971105490*r**8-3901359962267253*r**10
            -10875674043890591*r**12-21146755209955265*r**14-26660850701960160*r**16
            -20408944602682535*r**18-12698282658137951*r**20-5672242124862363*r**22
            -1453434685301210*r**24-389206111063415*r**26-14206264500465*r**28-873424315931*r**30
            +433583248660*r**32)+2*Q2**9*(-504728472265+3490603164788*r**2+31972952881100*r**4
            +146499557200850*r**6+733687659248750*r**8+5390581435553420*r**10+22315878618857912*r**12
            +63172492808789870*r**14+123117187280076200*r**16+126785117235436400*r**18
            +75174711058663100*r**20+38256994535516462*r**22+13163059065168890*r**24
            +1405253880533900*r**26+385375029852800*r**28-30341899296430*r**30-7788036900487*r**32
            -184982118460*r**34)-4*Q2**8*(-12729148040-1208669915619*r**2+3231603904566*r**4
            +92853881160730*r**6+163146170434275*r**8+666236416504860*r**10+817502005264049*r**12
            +13558757250750654*r**14+65576504738468775*r**16+110299419732507850*r**18
            +81629074926460305*r**20+31858952505345654*r**22+11703390777275849*r**24
            +3855166249518180*r**26-96432972072525*r**28-81029185028750*r**30-16520986114059*r**32
            -2791019364519*r**34+137285071765*r**36)+2*Q2**7*(207827774125-3853115165702*r**2
            -15960656698761*r**4+126066915518038*r**6+195167350961710*r**8-15054027234570*r**10
            -9847911177999658*r**12+21746662030342886*r**14+178182543496913472*r**16
            +397561001110791610*r**18+422534716535243260*r**20+220666125665784882*r**22
            +62372682241466786*r**24+4932382214366882*r**26-230924287636470*r**28
            -406120733390990*r**30-345685108203197*r**32-12762454549836*r**34+277616437933*r**36
            +194642317600*r**38)+4*Q2**6*(-49830806275+549941732159*r**2+6863959385894*r**4
            +26927532789989*r**6+140759332281854*r**8+242412433396988*r**10+3710483724988816*r**12
            -24519162781549244*r**14-104043404141116814*r**16-246936637023837454*r**18
            -331349968026262396*r**20-235704022420348234*r**22-71131429734385844*r**24
            -19788716766255764*r**26+1520471567587696*r**28+2899312993543028*r**30
            +89613306860009*r**32+82711079209319*r**34-1302992239786*r**36-1070529509971*r**38
            +678536030*r**40)-12*Q2**5*(4356333015-172881017828*r**2+241868077790*r**4
            +24117625609545*r**6+83916295812350*r**8+285576326264818*r**10+1537188426639984*r**12
            -1285067546906440*r**14-4385528462400770*r**16-34937342346216600*r**18
            -53742872718549084*r**20-37822490849051814*r**22+4321418282026260*r**24
            +36680846965640380*r**26+12556895746511600*r**28+1900659784216704*r**30
            +968925596451763*r**32+40385928822140*r**34-5120337922530*r**36-1272481344475*r**38
            -149304807578*r**40+8653810770*r**42)+6*Q2**4*(11709826795-281417606849*r**2
            -1049131432410*r**4+24752105604550*r**6+77831197791175*r**8+687471648129735*r**10
            +3235970302279596*r**12+15755362727981400*r**14+22170127824105150*r**16
            -65704157289472850*r**18-104452388604175700*r**20+21317348020642356*r**22
            +88973228916279310*r**24+110019378603738550*r**26+116115188072251800*r**28
            +46090393440299640*r**30+5632296909857271*r**32+676857420774195*r**34
            +81044260006750*r**36-21576106978250*r**38-1575342889845*r**40+43228913251*r**42
            +6508874380*r**44)+9*Q2**3*(-1251518135+11954737434*r**2+345773796379*r**4
            +3217472883340*r**6+3226203273075*r**8-152282519583290*r**10-93919607159631*r**12
            -6856343907237996*r**14+10218819206387370*r**16+57383414952454900*r**18
            +108731042915210430*r**20+110699046167603464*r**22+51697614753818614*r**24
            +1120448457339900*r**26-28839313342343150*r**28-13805714413048200*r**30
            -10140929287668771*r**32-1783380886641006*r**34+202075093216855*r**36
            -9517446311700*r**38+4958477546695*r**40+68872676254*r**42-47756053491*r**44
            +539020660*r**46)-54*(-1+r**2)**2*(10835647-361727633*r**2-1173230433*r**4
            +63157525647*r**6+145355046687*r**8+3941069908437*r**10+22597282902557*r**12
            +34592905863557*r**14-358748097714788*r**16-2928176472716298*r**18+2835087302712182*r**20
            +6840661434944502*r**22-7371478282243698*r**24-3918212498398518*r**26
            +5515708041422522*r**28+117224111488362*r**30+76561374177607*r**32+255176168349707*r**34
            +41817344428187*r**36+3261267205227*r**38+308997639747*r**40-20147040783*r**42
            -3097045383*r**44+29400097*r**46+4266862*r**48)-18*Q2**2*(493614100-18771544957*r**2
            +15551343974*r**4+3418106758943*r**6+4622263385780*r**8+55623850773845*r**10
            +586312326760438*r**12-256721860210671*r**14+4987507889635668*r**16-23360600374991090*r**18
            -26296231883294260*r**20+4670648609204678*r**22+11092522985383544*r**24
            +32971611878721338*r**26+32837775100597340*r**28-13093854542503790*r**30
            +7845493122172908*r**32+4343218854705279*r**34+335135997910798*r**36+136316080903595*r**38
            +8395468356980*r**40-132073105567*r**42-122105684626*r**44-6959101747*r**46
            +422207500*r**48)+27*Q2*(159465819-5528922692*r**2-4676755882*r**4+922357440208*r**6
            +755340812548*r**8+33695380443328*r**10+210707943065218*r**12+71726521274928*r**14
            -1145810473903257*r**16-20990670095974692*r**18+8860466201977948*r**20
            +38171926958209248*r**22+171010533815008*r**24-42824036601616352*r**26
            -7957640339641212*r**28+37401549863945248*r**30-5327368879664007*r**32
            +205031155626228*r**34+2153010133993518*r**36+289251375753808*r**38+36085940937628*r**40
            +3651846296608*r**42-168574647782*r**44-40476710992*r**46-323184827*r**48
            +81964404*r**50))*sqrtq2)+logq2*(-768*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(13567216*Q2**25
            -2*Q2**24*(119830801+106628449*r**2)+8*Q2**23*(218364977+447750827*r**2
            +176713994*r**4)-4*Q2**22*(1723826824+6006195399*r**2+5515195968*r**4
            +1263521617*r**6)+2*Q2**21*(7715836651+42341615815*r**2+62702724851*r**4
            +35451857965*r**6+4875845926*r**8)-2*Q2**20*(7932110990+80518947371*r**2
            +158369296044*r**4+138686787774*r**6+56276779076*r**8+2959933829*r**10)
            +Q2**19*(-9446796427+110978212707*r**2+161986493620*r**4-87114172530*r**6
            -35673944735*r**8+7267287363*r**10-16466924758*r**12)+2*Q2**18*(24942891013
            +96459638218*r**2+568974329556*r**4+1880092313215*r**6+2080020254245*r**8
            +817934359848*r**10+160279636498*r**12+20627444671*r**14)-Q2**17*(50632210201
            +544755553261*r**2+3199494640597*r**4+12527121268183*r**6+19889957983885*r**8
            +13813833601471*r**10+3735837130471*r**12+567829772917*r**14+25057414678*r**16)
            +Q2**16*(-18178945818+475157963610*r**2+3395358113292*r**4+19047172146580*r**6
            +40368687369432*r**8+41637326202552*r**10+20029054232620*r**12+2804546104932*r**14
            +237682845690*r**16-39037080858*r**18)+4*Q2**15*(21245293125+26096573667*r**2
            +64974424643*r**4-2216026140122*r**6-5651197554923*r**8-6084604170574*r**10
            -5277569626313*r**12-1136976434282*r**14+766379479058*r**16+136312067847*r**18
            +19417154418*r**20)-4*Q2**14*(13489253058+160653703902*r**2+1296663173215*r**4
            +4453128694365*r**6+15890585116775*r**8+41628954762897*r**10+44018433755013*r**12
            +20633268693875*r**14+8194344085215*r**16+2138504866105*r**18+219988972788*r**20
            +6483511272*r**22)+4*Q2**13*(-10475404556+153544675524*r**2+1560221694263*r**4
            +8857794492990*r**6+34543692787040*r**8+115236482474216*r**10+179487109343466*r**12
            +129336808935992*r**14+46330339467920*r**16+14134205752020*r**18+1470112375679*r**20
            +70140963354*r**22-14848400372*r**24)+4*Q2**12*(18950044126-27018079829*r**2
            -491920601263*r**4-5966263719917*r**6-19315990323320*r**8-108303049176301*r**10
            -250238280192986*r**12-270907663149902*r**14-137724250318138*r**16-30182205590735*r**18
            -8043933060359*r**20+860590828091*r**22+133072773652*r**24+17135326273*r**26)
            -2*Q2**11*(8572342429+193382570155*r**2+1738111765494*r**4+425522071710*r**6
            +32758970798029*r**8+39382360633941*r**10-30847924162050*r**12-105727218049484*r**14
            -120251909503305*r**16+6879220320141*r**18+45089327687314*r**20+11416680884670*r**22
            +4416182021679*r**24+321130631875*r**26+640272394*r**28)+4*Q2**10*(-9575837945
            +116581681962*r**2+1240323612953*r**4+3172938216888*r**6+25986086196212*r**8
            +119633836150349*r**10+343847448713988*r**12+645913320507077*r**14+604475307374987*r**16
            +324344296236888*r**18+162219280345373*r**20+47229210273302*r**22+13360843218378*r**24
            +1183816367873*r**26+35071670262*r**28-11133646307*r**30)+2*Q2**9*(14374440389
            -64048994719*r**2-957067047945*r**4-7363492620745*r**6-15327737492785*r**8
            -148296134928899*r**10-653322219954241*r**12-1980675588447565*r**14-2934422727884255*r**16
            -1883136943884805*r**18-763674328349419*r**20-353983779306371*r**22-33630853395355*r**24
            -17338596652345*r**26+1321466576085*r**28+129568280249*r**30+12911296646*r**32)
            +2*Q2**8*(2566308053-110131409107*r**2-770757627874*r**4+9310752857270*r**6
            -2636439516820*r**8-27902392603188*r**10-44879204337558*r**12+1170494157677954*r**14
            +3591532277672010*r**16+3651642212056410*r**18+1267071615627602*r**20
            +182841432271962*r**22+176641095799764*r**24-28974841511500*r**26-1580889457690*r**28
            -2506260178642*r**30-122256260767*r**32+4154747321*r**34)-4*Q2**7*(3534555649
            -58073396481*r**2-509196149877*r**4+3555668645842*r**6+2984716521315*r**8
            -26875342333484*r**10-181781765606139*r**12+441720395852542*r**14+2324705099024473*r**16
            +3513786334898990*r**18+2368648709498911*r**20+562752885470446*r**22-41317899334863*r**24
            -739687578932*r**26-7437253940265*r**28-5299129665086*r**30-514762245486*r**32
            -12017225037*r**34+3623557882*r**36)+4*Q2**6*(953990678-7358729995*r**2
            -134558733677*r**4-908546192530*r**6+1480183575203*r**8-2842719003063*r**10
            -125692938962945*r**12+585782592657517*r**14+2389505728050815*r**16+4613518718558507*r**18
            +4566689772868037*r**20+1738472609503265*r**22+308751777244657*r**24+45105211384075*r**26
            -71162787922083*r**28+7963518031823*r**30-3798619088425*r**32+263092422028*r**34
            +15891153740*r**36+820888373*r**38)+2*Q2**5*(1398430825-41248599491*r**2
            -217649629869*r**4+7525232196651*r**6+5655412221694*r**8+11841902447284*r**10
            +315518104537676*r**12-101513144332156*r**14-881618638719786*r**16-4787391442329994*r**18
            -4741774031536742*r**20-3070893421018414*r**22+3214076626076544*r**24
            +2148222270664004*r**26+13646711894876*r**28+185311658023012*r**30-8544562147271*r**32
            +1786617456981*r**34-741926878869*r**36-27452937701*r**38+1476404746*r**40)
            -2*Q2**4*(950272446-24422951181*r**2-172597370690*r**4+4431519051760*r**6
            +4234419017860*r**8+36895151988801*r**10+306614346454104*r**12+930796929988560*r**14
            +773604999190940*r**16-5216918924557450*r**18-2023831861066924*r**20+3389819016862784*r**22
            +1421800614063800*r**24+5482269949778090*r**26+3445306683458520*r**28
            +297530906793936*r**30+83020880043894*r**32+8281278632455*r**34-1056595380290*r**36
            -243291465680*r**38-6300175884*r**40+935530149*r**42)+3*Q2**3*(11421967
            +898007897*r**2-14926492456*r**4-388804304310*r**6+1224690152955*r**8
            +12392018335397*r**10-14172398382098*r**12+447169058078744*r**14-833547283454450*r**16
            -3604514079963790*r**18-4178098282492568*r**20-2414424482993668*r**22
            -394881089489186*r**24+467059747810130*r**26+525790723791940*r**28+611416233907352*r**30
            +162814851568867*r**32-22476754702411*r**34+5056024172880*r**36-836331946230*r**38
            +49538002727*r**40+2371626377*r**42+17103934*r**44)+18*(-1+r**2)**2*(727633
            -32568903*r**2-171749595*r**4+12348331737*r**6-20213166675*r**8+354815977593*r**10
            +2074697494097*r**12-5535881202975*r**14+5195433500722*r**16-252826893787150*r**18
            +492125044977498*r**20+66675045475602*r**22-723509672161230*r**24+448235369652762*r**26
            -626646792550*r**28-19672665192182*r**30+18265430013117*r**32+2279238203765*r**34
            +390672076737*r**36+25610875125*r**38+1895428833*r**40-395210163*r**42
            -10748715*r**44+644917*r**46)+6*Q2**2*(52386119-2067639146*r**2-6243732602*r**4
            +589331022427*r**6-829141511575*r**8+3954495570394*r**10+65944522519814*r**12
            -136214031374847*r**14+442930393662862*r**16-1687692478569660*r**18-647663008039356*r**20
            +536383434452374*r**22+732764239097818*r**24+2483054959492092*r**26-1002769590953580*r**28
            +94141600232554*r**30+384061212677019*r**32-6918058689562*r**34+17642392488022*r**36
            -361352825185*r**38+214995667789*r**40-29122785686*r**42-1034602682*r**44
            +47054597*r**46)-9*Q2*(12523857-527670075*r**2-1779253703*r**4+170481912455*r**6
            -394041111343*r**8+3108603189227*r**10+21845723615135*r**12-67604247648623*r**14
            +112599900533240*r**16-1614708720896318*r**18+1940159203274602*r**20+1550882151237270*r**22
            -1525317700107838*r**24-2829083573801850*r**26+2981430822938062*r**28
            -259585558115438*r**30-235320428784895*r**32+174432427010857*r**34+9969653510285*r**36
            +4778166027827*r**38+148546630877*r**40+41515758815*r**42-6267425693*r**44
            -208144755*r**46+11198022*r**48))+768*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(108537728*Q2**30-32*Q2**29*(66275033+59673857*r**2)+2*Q2**28*(8785141279
            +17833452942*r**2+7254274543*r**4)-8*Q2**27*(10153822931+34543327116*r**2
            +31901755239*r**4+7687837358*r**6)+4*Q2**26*(56121594959+293408263190*r**2
            +440397596209*r**4+249995986076*r**6+37923065714*r**8)-2*Q2**25*(170480189429
            +1455020138346*r**2+3072993258002*r**4+2792837172692*r**6+1095900314865*r**8
            +89768950586*r**10)+Q2**24*(94154870130+3711414944070*r**2+9956339470028*r**4
            +10433771620724*r**6+6790155557606*r**8+1887610760430*r**10-92838477180*r**12)
            +Q2**23*(689864176185+321428419980*r**2+3362492418683*r**4+26189978385554*r**6
            +32932679637227*r**8+12656808021416*r**10+3148778433705*r**12+670318768770*r**14)
            -2*Q2**22*(645650354955+4849736248605*r**2+24725877657336*r**4+95748381247727*r**6
            +154885005782636*r**8+108483651047111*r**10+31978175221092*r**12+5720524012245*r**14
            +431659537365*r**16)+Q2**21*(473288602295+15442701327900*r**2+98475730036438*r**4
            +473765922505050*r**6+1013108290839104*r**8+1042651771411754*r**10+507891174632922*r**12
            +100199082002086*r**14+12227238822105*r**16-130359749830*r**18)+2*Q2**20*(749492026735
            -3159774410495*r**2-34937602013696*r**4-276272521618032*r**6-783650967600330*r**8
            -1061430570399062*r**10-783075257233992*r**12-250312231066968*r**14-12986266753877*r**16
            +1668112912525*r**18+818606825320*r**20)-Q2**19*(2184355398085+13602136395540*r**2
            +66987974515237*r**4-3500602805574*r**6-295835114077806*r**8+93108226643592*r**10
            +276373029089658*r**12+88958284015812*r**14+306473602719801*r**16+157250858004724*r**18
            +23143754476785*r**20+1573674998290*r**22)+2*Q2**18*(71347716715+11978335052745*r**2
            +98970539707754*r**4+491473892671857*r**6+1689755065344011*r**8+5149190471597066*r**10
            +7936361897859764*r**12+5842986425007170*r**14+2342421917949257*r**16
            +786180040667901*r**18+126473863405778*r**20+10746688158045*r**22-300136806095*r**24)
            +Q2**17*(2236634040995-11769899079880*r**2-161379652599492*r**4-1420243871738754*r**6
            -6102952299012657*r**8-23319303387195158*r**10-47942289770510000*r**12
            -50276040809140196*r**14-27067902625248767*r**16-8005702512888132*r**18
            -1857210280494732*r**20-79218718623834*r**22+4998286792205*r**24+2291092883810*r**26)
            +2*Q2**16*(-879596705645-5675021766600*r**2-18181292449031*r**4+330872166269280*r**6
            +1742834145827477*r**8+10360754896671888*r**10+30055536436465991*r**12
            +43218060395229488*r**14+33239912340038189*r**16+12210492159720408*r**18
            +1913068955037287*r**20+118349268047376*r**22-110538202715477*r**24-13170898740480*r**26
            -590296571495*r**28)+2*Q2**15*(-361608120555+10982843672940*r**2+96241251356379*r**4
            +298343274808778*r**6+1425777730469185*r**8+2823586775248568*r**10-22194047875489*r**12
            -1709893143916618*r**14-3823141767342073*r**16-1254870933208900*r**18
            +5121035436454889*r**20+3055237440367798*r**22+988965252936707*r**24+147261937129728*r**26
            +9022640324925*r**28-582005188950*r**30)+4*Q2**14*(431103531165-2649059315265*r**2
            -36748080835208*r**4-299896046858879*r**6-1558542384547826*r**8-8130135857179181*r**10
            -25952773448541284*r**12-63305791712136947*r**14-88356226041906236*r**16
            -65348070928901339*r**18-31240045738115456*r**20-12872321032662149*r**22
            -2744146316415158*r**24-595753652912279*r**26-13065567912116*r**28+1590309966615*r**30
            +409453677735*r**32)+2*Q2**13*(-217957138365-4329310553220*r**2-10555979436366*r**4
            +473008187399042*r**6+2101566975005786*r**8+15399373538332994*r**10+65061139834026698*r**12
            +225064979061335138*r**14+440748982697038328*r**16+453503269054293434*r**18
            +252607271255902118*r**20+90805862553731558*r**22+27341498895820166*r**24
            +2589002989257542*r**26+271103747663966*r**28-99413195794122*r**30-8655167952795*r**32
            -77743792830*r**34)-2*Q2**12*(400264534835-7383602499840*r**2-56445793812439*r**4
            +158092615743912*r**6+292183144357636*r**8+3110653755141832*r**10+15400498056031468*r**12
            +139445042033242408*r**14+442830280961645266*r**16+649722879186782424*r**18
            +490789308005081830*r**20+185666382265054264*r**22+39232314835118020*r**24
            +5978559777350200*r**26-1724345262282164*r**28-701063861428104*r**30-92384522239693*r**32
            -4041098723160*r**34+445783019705*r**36)+2*Q2**11*(290761951495-2280171787700*r**2
            -32879133894901*r**4-192219036380610*r**6-711300869093148*r**8-5553692378072536*r**10
            -37363416800915884*r**12-64119213278246704*r**14+15683408484488018*r**16
            +164422592626896720*r**18+205400450986344330*r**20+57779335211839964*r**22
            -56258372033923852*r**24-38395907835706312*r**26-17761001626535836*r**28
            -2844310130053728*r**30-774710831169969*r**32+160250356868*r**34+2208719682355*r**36
            +252874734070*r**38)+4*Q2**10*(32842917230-1521510924945*r**2-3605541275533*r**4
            +198890830213089*r**6+456842282585475*r**8+2765238168409284*r**10+19588891621199212*r**12
            +81260413130160220*r**14+204717912895448416*r**16+373286418808025250*r**18
            +468332945097280426*r**20+362099351494010094*r**22+248971332714890962*r**24
            +127332762403693396*r**26+30187087072798300*r**28+11242263176180460*r**30
            +634275494810634*r**32+89173709301591*r**34-25800850342501*r**36-1704812071575*r**38
            +47766968915*r**40)-4*Q2**9*(71196538045-1452510674895*r**2-8978192181347*r**4
            +125322970712459*r**6+331993351718746*r**8+2208917349073624*r**10+7823869502615196*r**12
            +50748199570961972*r**14+168428581599504866*r**16+485909042114564334*r**18
            +972402792361135262*r**20+1002041145876334778*r**22+581327484121786572*r**24
            +308704298150487716*r**26+131205366679956764*r**28+15493427301525924*r**30
            +4231965851952841*r**32-97043339376647*r**34-141880410255091*r**36-14831209232669*r**38
            -487280166030*r**40+70417679980*r**42)+2*Q2**8*(25772039695-4227693965*r**2
            -7145111338736*r**4-84535170926638*r**6+302649708051941*r**8+5103580143524107*r**10
            +4625234455304652*r**12+17226541406073624*r**14-21503266148516362*r**16
            +534117757665356694*r**18+2254580953050792144*r**20+3556152121495667596*r**22
            +2621573376046401930*r**24+1045534725660271038*r**26+337571813137797704*r**28
            +121121099022756696*r**30+7977551420651307*r**32-6157161372177833*r**34
            -620846175753088*r**36-281709299019214*r**38+6111196590433*r**40+859234949335*r**42
            +18191724940*r**44)+Q2**7*(72383829485-2367926848740*r**2-3110983048657*r**4
            +422565735415546*r**6-140179203615397*r**8-5070920991873560*r**10+60579311785233*r**12
            +16394280739827330*r**14+289084693681175250*r**16-1208353752654971928*r**18
            -5684408327206689242*r**20-11478752808043408620*r**22-11860629673950789594*r**24
            -6038423803026747968*r**26-1985148153802408878*r**28-264119812541032716*r**30
            +89279215763881521*r**32-5970483836063844*r**34+17010793362804667*r**36
            +970454179758578*r**38+133551744592783*r**40-27386686915144*r**42-1567712549235*r**44
            +74499733130*r**46)-2*Q2**6*(18034902735-482576259375*r**2-2572835311304*r**4
            +80265638234355*r**6+121635797649608*r**8+2582441733779975*r**10+6154903599975924*r**12
            +15159964413655453*r**14+99473309684160563*r**16-676292835241162086*r**18
            -2335005128368593152*r**20-5636259473905980114*r**22-7399965243495818952*r**24
            -5184518971969553826*r**26-938126579894018792*r**28-124784032017925686*r**30
            -17233285276860619*r**32+122897728291393861*r**34+5290829562216168*r**36
            +2969927999945135*r**38+162061968684128*r**40-63855664561941*r**42-4125756363308*r**44
            -92505486135*r**46+16801217385*r**48)-3*Q2**5*(2084142031-111980459780*r**2
            +743435068974*r**4+29702739435818*r**6-169057158612460*r**8-2586906034127142*r**10
            -4245827376413558*r**12-24318717494178914*r**14-100070556968488437*r**16
            -84161287397375510*r**18+146316860641809484*r**20+1840533253334385444*r**22
            +2327934680655183008*r**24+1284434676324646628*r**26-236375622222475500*r**28
            -2001655919306017220*r**30-1061803191284414219*r**32-153562275169668720*r**34
            -59678160441148442*r**36-8568979165418030*r**38+571591507472076*r**40
            +57068363120738*r**42+40354305062402*r**44-1259376104442*r**46-116079287375*r**48
            +2246903146*r**50)+6*Q2**4*(1441390151-57790456021*r**2+48599665838*r**4
            +14807192323384*r**6-55441085694854*r**8-403723814344478*r**10-886648209194332*r**12
            -12308166567818752*r**14-42049761693476011*r**16-208836951138943639*r**18
            +19466440401287402*r**20+953294701715935568*r**22+1243003939643817628*r**24
            +143813153153135404*r**26-554223196366385384*r**28-938598140489359648*r**30
            -1007876206491259327*r**32-563286302520038227*r**34-113469010848686686*r**36
            -6254976849454024*r**38-2714515932989878*r**40+335866255114258*r**42+37705222560388*r**44
            +5173769970784*r**46-519754668349*r**48-29984286049*r**50+1377054854*r**52)
            -9*Q2**3*(136660537-4482041724*r**2-39111349103*r**4+1132677385314*r**6
            +2518624883342*r**8+157013402469000*r**10-217283714380938*r**12-1165523654063124*r**14
            +4704059623687219*r**16-73011180221423188*r**18+203181503972967875*r**20
            +256145562953563382*r**22+688627550455251636*r**24+843604595392788784*r**26
            +582707950113287812*r**28+398334803380641480*r**30-356685485439765553*r**32
            -79224847163026084*r**34-32751037911687481*r**36-28348075938748178*r**38
            +4153571771899230*r**40+40709252309832*r**42+66285079460646*r**44+8250712881164*r**46
            -1511373779163*r**48-41415839372*r**50+110082501*r**52+129084154*r**54)
            -54*(-1+r**2)**2*(727633-42028132*r**2+173061780*r**4+18019933632*r**6
            -158684540701*r**8-697059603596*r**10-1686307865476*r**12-68804752267556*r**14
            -184950446304611*r**16+48807490386904*r**18+3789026764608104*r**20+20487288324835124*r**22
            -27507562108614001*r**24-47204603608452376*r**26+58460000751274744*r**28
            +29343447867820184*r**30-38595431207819821*r**32-4593415135262836*r**34
            +579123752722724*r**36-1968759292839896*r**38-545804611604711*r**40-56348261221916*r**42
            -5765052637876*r**44-104152538036*r**46+44805475199*r**48+8124371136*r**50
            -325127904*r**52-19132636*r**54+644917*r**56)-18*Q2**2*(45109789-2463186421*r**2
            +16917857890*r**4+825218290675*r**6-7618413108811*r**8-69232957221478*r**10
            +59971780651916*r**12-1660314026617454*r**14-7707469125203903*r**16+9512074802825769*r**18
            -31701230676178698*r**20+339377799795610681*r**22+32576537239568281*r**24
            -215258941573217668*r**26+81416565087307784*r**28-36088404753127828*r**30
            -526693953568670729*r**32+103519453430585581*r**34-14447202994248978*r**36
            -62374603647925131*r**38-7230734700140033*r**40-2060906192099894*r**42
            -270150377783764*r**44-5793101803678*r**46+379455244139*r**48+722723642623*r**50
            -17303708678*r**52-1575057409*r**54+40605427*r**56)+27*Q2*(12523857
            -696301280*r**2+3895294916*r**4+254988734658*r**6-2447075599751*r**8
            -11443311293954*r**10+8730626508656*r**12-716080622058324*r**14-1820594943580659*r**16
            +3008699589787876*r**18+17374396427510996*r**20+169987261222086726*r**22
            -191281890387125739*r**24-175496643760455094*r**26+56351355038873856*r**28
            +146400691413361416*r**30+222299251502011811*r**32-304857442001655624*r**34
            -1608335631749844*r**36+20003563356240686*r**38-18788664133466789*r**40
            -4432492561245774*r**42-549317234680944*r**44-78429313645684*r**46-1510671450689*r**48
            +340475070724*r**50+148975474236*r**52-4767489910*r**54-358878377*r**56
            +11198022*r**58))*sqrtq2))/(1890000*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2+1890000*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2
            +logq2**8*(182849716224000000*r**36*(1+r**2)**2*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3+182849716224000000*r**36*(1+r**2)**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2*(-272160000*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4
            -Q2**3*(1+r**2)-2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4
            +r**6)+4*(1-9*r**2-44*r**4-9*r**6+r**8))-272160000*(-Q2+(-1+r)**2)**3*r**8*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4-Q2**3*(1+r**2)
            -2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4+r**6)+4*(1-9*r**2
            -44*r**4-9*r**6+r**8))*sqrtq2)+logq2**7*(-4063327027200000*r**32*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))-4063327027200000*r**32*(1+r**2)*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))*sqrtq2)+logq2**3*(-65318400000*(-Q2+(-1+r)**2)**3*r**16*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)
            -Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2+683*r**4+169*r**6)
            +2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)+6*Q2**3*(31+230*r**2
            +159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4
            +8368*r**6+6523*r**8+1184*r**10-131*r**12)-9*Q2*(13+5*r**2-1493*r**4
            -5245*r**6-5245*r**8-1493*r**10+5*r**12+13*r**14)+36*(4-67*r**2-28*r**4
            +2331*r**6+5600*r**8+2331*r**10-28*r**12-67*r**14+4*r**16))-65318400000*(
            -Q2+(-1+r)**2)**3*r**16*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)-Q2**6*(333+410*r**2+333*r**4)
            -Q2**5*(169+683*r**2+683*r**4+169*r**6)+2*Q2**4*(275-725*r**2-3408*r**4
            -725*r**6+275*r**8)+6*Q2**3*(31+230*r**2+159*r**4+159*r**6+230*r**8
            +31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4+8368*r**6+6523*r**8+1184*r**10
            -131*r**12)-9*Q2*(13+5*r**2-1493*r**4-5245*r**6-5245*r**8-1493*r**10
            +5*r**12+13*r**14)+36*(4-67*r**2-28*r**4+2331*r**6+5600*r**8+2331*r**10
            -28*r**12-67*r**14+4*r**16))*sqrtq2)+logq2**2*(16329600000*(-Q2+(-1
            +r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8
            -4*Q2**7*(1+r**2)-Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4
            +5*r**6)+Q2**4*(85-226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1
            -54*r**2-143*r**4-143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4
            +3168*r**6+2871*r**8+468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4
            -2833*r**6-2833*r**8-565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4
            +4368*r**6+11718*r**8+4368*r**10-56*r**12-96*r**14+5*r**16))+16329600000*(
            -Q2+(-1+r)**2)**3*r**12*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8
            -4*Q2**7*(1+r**2)-Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4
            +5*r**6)+Q2**4*(85-226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1
            -54*r**2-143*r**4-143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4
            +3168*r**6+2871*r**8+468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4
            -2833*r**6-2833*r**8-565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4
            +4368*r**6+11718*r**8+4368*r**10-56*r**12-96*r**14+5*r**16))*sqrtq2)
            +logq2**5*(-5643509760000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1
            +r**2)-Q2**6*(219+310*r**2+219*r**4)-Q2**5*(977+2179*r**2+2179*r**4
            +977*r**6)+Q2**4*(590-2090*r**2-6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243
            +10*r**2-2073*r**4-2073*r**6+10*r**8+243*r**10)+Q2**2*(-879+8076*r**2
            +41127*r**4+61272*r**6+41127*r**8+8076*r**10-879*r**12)+Q2*(-741+3075*r**2
            +31341*r**4+67125*r**6+67125*r**8+31341*r**10+3075*r**12-741*r**14)
            +12*(41-573*r**2+28*r**4+12789*r**6+25830*r**8+12789*r**10+28*r**12
            -573*r**14+41*r**16))-5643509760000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)-Q2**5*(977
            +2179*r**2+2179*r**4+977*r**6)+Q2**4*(590-2090*r**2-6768*r**4-2090*r**6
            +590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4-2073*r**6+10*r**8+243*r**10)
            +Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6+41127*r**8+8076*r**10
            -879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6+67125*r**8+31341*r**10
            +3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4+12789*r**6+25830*r**8
            +12789*r**10+28*r**12-573*r**14+41*r**16))*sqrtq2)+logq2**4*(1175731200000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219
            +310*r**2+219*r**4)-24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415
            -1180*r**2-4598*r**4-1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4
            -677*r**6+155*r**8+102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6
            +18377*r**8+3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6
            -3030*r**8-1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4
            +24556*r**6+53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))+1175731200000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2
            +219*r**4)-24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415-1180*r**2
            -4598*r**4-1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4-677*r**6
            +155*r**8+102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6+18377*r**8
            +3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8
            -1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6
            +53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))*sqrtq2)+logq2**6*(22574039040000*r**28*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(16*Q2**8+332*Q2**7*(1
            +r**2)+Q2**6*(153+370*r**2+153*r**4)-Q2**5*(2011+4817*r**2+4817*r**4
            +2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4-2410*r**6+295*r**8)+6*Q2**3*(559
            -310*r**2-4869*r**4-4869*r**6-310*r**8+559*r**10)-3*Q2**2*(479-4496*r**2
            -22867*r**4-35272*r**6-22867*r**8-4496*r**10+479*r**12)-9*Q2*(187
            -865*r**2-5807*r**4-10315*r**6-10315*r**8-5807*r**10-865*r**12+187*r**14)
            +9*(109-1432*r**2+392*r**4+26376*r**6+49910*r**8+26376*r**10+392*r**12
            -1432*r**14+109*r**16))+22574039040000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(16*Q2**8+332*Q2**7*(1+r**2)+Q2**6*(153+370*r**2+153*r**4)
            -Q2**5*(2011+4817*r**2+4817*r**4+2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4
            -2410*r**6+295*r**8)+6*Q2**3*(559-310*r**2-4869*r**4-4869*r**6-310*r**8
            +559*r**10)-3*Q2**2*(479-4496*r**2-22867*r**4-35272*r**6-22867*r**8
            -4496*r**10+479*r**12)-9*Q2*(187-865*r**2-5807*r**4-10315*r**6-10315*r**8
            -5807*r**10-865*r**12+187*r**14)+9*(109-1432*r**2+392*r**4+26376*r**6
            +49910*r**8+26376*r**10+392*r**12-1432*r**14+109*r**16))*sqrtq2))+((
            -512*(Q2-(-1+r)**2)**6*r**6*(1-Q2+r**2)*(Q2-(1+r)**2)**6*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))**2*(520*Q2**22+12112*Q2**21*(1+r**2)
            -Q2**20*(226505+2264418*r**2+226505*r**4)+32*Q2**19*(47368+939919*r**2
            +939919*r**4+47368*r**6)-2*Q2**18*(2785037+84443344*r**2+179647574*r**4
            +84443344*r**6+2785037*r**8)+4*Q2**17*(3098369+124434575*r**2+431690036*r**4
            +431690036*r**6+124434575*r**8+3098369*r**10)-Q2**16*(16190437+731531166*r**2
            +3947035095*r**4+5895367804*r**6+3947035095*r**8+731531166*r**10+16190437*r**12)
            +8*Q2**15*(1109242+11688985*r**2+367378989*r**4+410253004*r**6+410253004*r**8
            +367378989*r**10+11688985*r**12+1109242*r**14)+8*Q2**14*(729109+194161212*r**2
            +752702872*r**4+3476415142*r**6+6352723434*r**8+3476415142*r**10+752702872*r**12
            +194161212*r**14+729109*r**16)-8*Q2**13*(1194216+306786847*r**2+2091773677*r**4
            +9194584111*r**6+23078885821*r**8+23078885821*r**10+9194584111*r**12
            +2091773677*r**14+306786847*r**16+1194216*r**18)+Q2**12*(-6036498+751383100*r**2
            +14162284678*r**4+58808066720*r**6+220182028124*r**8+307325076712*r**10
            +220182028124*r**12+58808066720*r**14+14162284678*r**16+751383100*r**18
            -6036498*r**20)+8*Q2**11*(2652858+261877577*r**2+252765285*r**4+4511836286*r**6
            +5212708360*r**8+20973386930*r**10+20973386930*r**12+5212708360*r**14
            +4511836286*r**16+252765285*r**18+261877577*r**20+2652858*r**22)-4*Q2**10*(3591107
            +633658688*r**2+3328295894*r**4+23904055964*r**6+84855293693*r**8+257131355012*r**10
            +410570049812*r**12+257131355012*r**14+84855293693*r**16+23904055964*r**18
            +3328295894*r**20+633658688*r**22+3591107*r**24)-8*Q2**9*(655759-21721648*r**2
            -1379932703*r**4-5896955395*r**6-34032315442*r**8-115854274013*r**10
            -294468483022*r**12-294468483022*r**14-115854274013*r**16-34032315442*r**18
            -5896955395*r**20-1379932703*r**22-21721648*r**24+655759*r**26)+2*Q2**8*(6492839
            +843090458*r**2-2441758087*r**4+7085599700*r**6-12577814621*r**8+83376174806*r**10
            -361275601891*r**12-564352182728*r**14-361275601891*r**16+83376174806*r**18
            -12577814621*r**20+7085599700*r**22-2441758087*r**24+843090458*r**26
            +6492839*r**28)-8*Q2**7*(617314+146221725*r**2-83197839*r**4+1345149664*r**6
            +5410324636*r**8+77814653767*r**10+74233928011*r**12+141456739522*r**14
            +141456739522*r**16+74233928011*r**18+77814653767*r**20+5410324636*r**22
            +1345149664*r**24-83197839*r**26+146221725*r**28+617314*r**30)-16*Q2**6*(222890
            +9729602*r**2-224366250*r**4+380092619*r**6-2221226510*r**8-16722560029*r**10
            -11915541758*r**12-35128100480*r**14-61622456968*r**16-35128100480*r**18
            -11915541758*r**20-16722560029*r**22-2221226510*r**24+380092619*r**26
            -224366250*r**28+9729602*r**30+222890*r**32)+8*Q2**5*(502946+68953917*r**2
            -683702383*r**4-408261553*r**6-11115181219*r**8-26262596473*r**10-38220723187*r**12
            -28826250605*r**14+59146362557*r**16+59146362557*r**18-28826250605*r**20
            -38220723187*r**22-26262596473*r**24-11115181219*r**26-408261553*r**28
            -683702383*r**30+68953917*r**32+502946*r**34)+Q2**4*(-905701-211716538*r**2
            +2613590867*r**4+10970020928*r**6+84202554492*r**8+328309699560*r**10
            +694498629388*r**12+1381721718208*r**14-1348388950262*r**16+1985130078116*r**18
            -1348388950262*r**20+1381721718208*r**22+694498629388*r**24+328309699560*r**26
            +84202554492*r**28+10970020928*r**30+2613590867*r**32-211716538*r**34
            -905701*r**36)-8*Q2**3*(79922+6658369*r**2-103659811*r**4+577759978*r**6
            +789540152*r**8+11968491768*r**10+39373851520*r**12+59656374536*r**14
            -240301075292*r**16+220130922858*r**18+220130922858*r**20-240301075292*r**22
            +59656374536*r**24+39373851520*r**26+11968491768*r**28+789540152*r**30
            +577759978*r**32-103659811*r**34+6658369*r**36+79922*r**38)+3*(-1+r**2)**2*(4893
            +840104*r**2-26928774*r**4-108119736*r**6-1175615959*r**8-9485606592*r**10
            +22274390808*r**12-241075071488*r**14+1004456013498*r**16-2806453793328*r**18
            +4010933053148*r**20-2806453793328*r**22+1004456013498*r**24-241075071488*r**26
            +22274390808*r**28-9485606592*r**30-1175615959*r**32-108119736*r**34
            -26928774*r**36+840104*r**38+4893*r**40)+2*Q2**2*(250507+34361200*r**2
            -718612142*r**4-424830776*r**6-15589997393*r**8-68731480376*r**10+97800377432*r**12
            -897971708392*r**14+1416033754310*r**16-379198403864*r**18-1478198621012*r**20
            -379198403864*r**22+1416033754310*r**24-897971708392*r**26+97800377432*r**28
            -68731480376*r**30-15589997393*r**32-424830776*r**34-718612142*r**36
            +34361200*r**38+250507*r**40)-12*Q2*(11577+1815765*r**2-49202370*r**4
            -78057410*r**6-1444485615*r**8-8842691451*r**10+24813154248*r**12-191096633400*r**14
            +661499533410*r**16-1298047945990*r**18+787117141236*r**20+787117141236*r**22
            -1298047945990*r**24+661499533410*r**26-191096633400*r**28+24813154248*r**30
            -8842691451*r**32-1444485615*r**34-78057410*r**36-49202370*r**38+1815765*r**40
            +11577*r**42))-512*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(520*Q2**22+12112*Q2**21*(1
            +r**2)-Q2**20*(226505+2264418*r**2+226505*r**4)+32*Q2**19*(47368+939919*r**2
            +939919*r**4+47368*r**6)-2*Q2**18*(2785037+84443344*r**2+179647574*r**4
            +84443344*r**6+2785037*r**8)+4*Q2**17*(3098369+124434575*r**2+431690036*r**4
            +431690036*r**6+124434575*r**8+3098369*r**10)-Q2**16*(16190437+731531166*r**2
            +3947035095*r**4+5895367804*r**6+3947035095*r**8+731531166*r**10+16190437*r**12)
            +8*Q2**15*(1109242+11688985*r**2+367378989*r**4+410253004*r**6+410253004*r**8
            +367378989*r**10+11688985*r**12+1109242*r**14)+8*Q2**14*(729109+194161212*r**2
            +752702872*r**4+3476415142*r**6+6352723434*r**8+3476415142*r**10+752702872*r**12
            +194161212*r**14+729109*r**16)-8*Q2**13*(1194216+306786847*r**2+2091773677*r**4
            +9194584111*r**6+23078885821*r**8+23078885821*r**10+9194584111*r**12
            +2091773677*r**14+306786847*r**16+1194216*r**18)+Q2**12*(-6036498+751383100*r**2
            +14162284678*r**4+58808066720*r**6+220182028124*r**8+307325076712*r**10
            +220182028124*r**12+58808066720*r**14+14162284678*r**16+751383100*r**18
            -6036498*r**20)+8*Q2**11*(2652858+261877577*r**2+252765285*r**4+4511836286*r**6
            +5212708360*r**8+20973386930*r**10+20973386930*r**12+5212708360*r**14
            +4511836286*r**16+252765285*r**18+261877577*r**20+2652858*r**22)-4*Q2**10*(3591107
            +633658688*r**2+3328295894*r**4+23904055964*r**6+84855293693*r**8+257131355012*r**10
            +410570049812*r**12+257131355012*r**14+84855293693*r**16+23904055964*r**18
            +3328295894*r**20+633658688*r**22+3591107*r**24)-8*Q2**9*(655759-21721648*r**2
            -1379932703*r**4-5896955395*r**6-34032315442*r**8-115854274013*r**10
            -294468483022*r**12-294468483022*r**14-115854274013*r**16-34032315442*r**18
            -5896955395*r**20-1379932703*r**22-21721648*r**24+655759*r**26)+2*Q2**8*(6492839
            +843090458*r**2-2441758087*r**4+7085599700*r**6-12577814621*r**8+83376174806*r**10
            -361275601891*r**12-564352182728*r**14-361275601891*r**16+83376174806*r**18
            -12577814621*r**20+7085599700*r**22-2441758087*r**24+843090458*r**26
            +6492839*r**28)-8*Q2**7*(617314+146221725*r**2-83197839*r**4+1345149664*r**6
            +5410324636*r**8+77814653767*r**10+74233928011*r**12+141456739522*r**14
            +141456739522*r**16+74233928011*r**18+77814653767*r**20+5410324636*r**22
            +1345149664*r**24-83197839*r**26+146221725*r**28+617314*r**30)-16*Q2**6*(222890
            +9729602*r**2-224366250*r**4+380092619*r**6-2221226510*r**8-16722560029*r**10
            -11915541758*r**12-35128100480*r**14-61622456968*r**16-35128100480*r**18
            -11915541758*r**20-16722560029*r**22-2221226510*r**24+380092619*r**26
            -224366250*r**28+9729602*r**30+222890*r**32)+8*Q2**5*(502946+68953917*r**2
            -683702383*r**4-408261553*r**6-11115181219*r**8-26262596473*r**10-38220723187*r**12
            -28826250605*r**14+59146362557*r**16+59146362557*r**18-28826250605*r**20
            -38220723187*r**22-26262596473*r**24-11115181219*r**26-408261553*r**28
            -683702383*r**30+68953917*r**32+502946*r**34)+Q2**4*(-905701-211716538*r**2
            +2613590867*r**4+10970020928*r**6+84202554492*r**8+328309699560*r**10
            +694498629388*r**12+1381721718208*r**14-1348388950262*r**16+1985130078116*r**18
            -1348388950262*r**20+1381721718208*r**22+694498629388*r**24+328309699560*r**26
            +84202554492*r**28+10970020928*r**30+2613590867*r**32-211716538*r**34
            -905701*r**36)-8*Q2**3*(79922+6658369*r**2-103659811*r**4+577759978*r**6
            +789540152*r**8+11968491768*r**10+39373851520*r**12+59656374536*r**14
            -240301075292*r**16+220130922858*r**18+220130922858*r**20-240301075292*r**22
            +59656374536*r**24+39373851520*r**26+11968491768*r**28+789540152*r**30
            +577759978*r**32-103659811*r**34+6658369*r**36+79922*r**38)+3*(-1+r**2)**2*(4893
            +840104*r**2-26928774*r**4-108119736*r**6-1175615959*r**8-9485606592*r**10
            +22274390808*r**12-241075071488*r**14+1004456013498*r**16-2806453793328*r**18
            +4010933053148*r**20-2806453793328*r**22+1004456013498*r**24-241075071488*r**26
            +22274390808*r**28-9485606592*r**30-1175615959*r**32-108119736*r**34
            -26928774*r**36+840104*r**38+4893*r**40)+2*Q2**2*(250507+34361200*r**2
            -718612142*r**4-424830776*r**6-15589997393*r**8-68731480376*r**10+97800377432*r**12
            -897971708392*r**14+1416033754310*r**16-379198403864*r**18-1478198621012*r**20
            -379198403864*r**22+1416033754310*r**24-897971708392*r**26+97800377432*r**28
            -68731480376*r**30-15589997393*r**32-424830776*r**34-718612142*r**36
            +34361200*r**38+250507*r**40)-12*Q2*(11577+1815765*r**2-49202370*r**4
            -78057410*r**6-1444485615*r**8-8842691451*r**10+24813154248*r**12-191096633400*r**14
            +661499533410*r**16-1298047945990*r**18+787117141236*r**20+787117141236*r**22
            -1298047945990*r**24+661499533410*r**26-191096633400*r**28+24813154248*r**30
            -8842691451*r**32-1444485615*r**34-78057410*r**36-49202370*r**38+1815765*r**40
            +11577*r**42))*sqrtq2+logq2**8*(-650132324352000000*r**38*(-3+r**2)*(1
            +r**2)**2*(1-Q2+r**2)*(-1+3*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3
            -650132324352000000*(Q2-(-1+r)**2)**2*r**38*(-3+r**2)*(1+r**2)**2*(-1
            +3*r**2)*(Q2-(1+r)**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**7*(2063912140800000*r**32*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(-70*Q2**9*(1+r**2)+370*Q2**8*(1+r**2)**2-10*Q2**7*(30+181*r**2
            +181*r**4+30*r**6)-2*Q2**6*(959+622*r**2-450*r**4+622*r**6+959*r**8)
            +Q2**5*(5488+10957*r**2+6019*r**4+6019*r**6+10957*r**8+5488*r**10)
            -Q2**4*(4515+14264*r**2+10217*r**4+40*r**6+10217*r**8+14264*r**10+4515*r**12)
            +Q2**3*(-3115+51*r**2+429*r**4-2237*r**6-2237*r**8+429*r**10+51*r**12
            -3115*r**14)+6*(-1+r**2)**2*(267+423*r**2-682*r**4-31*r**6+3406*r**8
            -31*r**10-682*r**12+423*r**14+267*r**16)+Q2**2*(8785+11601*r**2+1606*r**4
            -2165*r**6+12426*r**8-2165*r**10+1606*r**12+11601*r**14+8785*r**16)
            -3*Q2*(2109+1765*r**2-4088*r**4-2476*r**6+16130*r**8+16130*r**10-2476*r**12
            -4088*r**14+1765*r**16+2109*r**18))+2063912140800000*r**32*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(70*Q2**10*(1+r**2)-440*Q2**9*(1+r**2)**2
            +10*Q2**8*(67+292*r**2+292*r**4+67*r**6)+2*Q2**7*(809-433*r**2-2260*r**4
            -433*r**6+809*r**8)-7*Q2**6*(1058+2017*r**2+909*r**4+909*r**6+2017*r**8
            +1058*r**10)+Q2**5*(10003+30709*r**2+27193*r**4+12078*r**6+27193*r**8
            +30709*r**10+10003*r**12)-10*Q2**4*(140+1883*r**2+2491*r**4+802*r**6
            +802*r**8+2491*r**10+1883*r**12+140*r**14)-Q2**3*(11900+14665*r**2
            +1126*r**4-357*r**6+16900*r**8-357*r**10+1126*r**12+14665*r**14+11900*r**16)
            +6*(-1+r**2)**2*(267+690*r**2-259*r**4-713*r**6+3375*r**8+3375*r**10
            -713*r**12-259*r**14+690*r**16+267*r**18)+Q2**2*(15112+25681*r**2+943*r**4
            -7987*r**6+58651*r**8+58651*r**10-7987*r**12+943*r**14+25681*r**16
            +15112*r**18)-3*Q2*(2643+3652*r**2-4845*r**4-3052*r**6+19226*r**8
            +18512*r**10+19226*r**12-3052*r**14-4845*r**16+3652*r**18+2643*r**20))*sqrtq2)
            +logq2**6*(11466178560000*r**28*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1120*Q2**13*(1+r**2)-20160*Q2**12*(1+r**2)**2+60*Q2**11*(2109
            +6607*r**2+6607*r**4+2109*r**6)-15*Q2**8*(1+r**2)**2*(40336+194357*r**2
            +316506*r**4+194357*r**6+40336*r**8)-2*Q2**10*(196248+851619*r**2+1309846*r**4
            +851619*r**6+196248*r**8)+60*Q2**9*(10922+61823*r**2+130971*r**4+130971*r**6
            +61823*r**8+10922*r**10)+5*Q2**7*(107370+491433*r**2+1346369*r**4+2211676*r**6
            +2211676*r**8+1346369*r**10+491433*r**12+107370*r**14)-15*Q2**6*(75124
            +185927*r**2+259840*r**4+235545*r**6+180184*r**8+235545*r**10+259840*r**12
            +185927*r**14+75124*r**16)+6*Q2**5*(291137+935851*r**2+2025509*r**4
            +2823491*r**6+2188532*r**8+2188532*r**10+2823491*r**12+2025509*r**14
            +935851*r**16+291137*r**18)-20*Q2**4*(49706+246614*r**2+761773*r**4
            +1396663*r**6+1127437*r**8+584110*r**10+1127437*r**12+1396663*r**14
            +761773*r**16+246614*r**18+49706*r**20)-15*Q2**3*(38242-26871*r**2-19225*r**4
            -23904*r**6+27462*r**8+281832*r**10+281832*r**12+27462*r**14-23904*r**16
            -19225*r**18-26871*r**20+38242*r**22)+9*(-1+r**2)**2*(13136+40445*r**2
            +345746*r**4+500085*r**6-149680*r**8+136398*r**10+1050140*r**12+136398*r**14
            -149680*r**16+500085*r**18+345746*r**20+40445*r**22+13136*r**24)+15*Q2**2*(76124
            +123827*r**2+896264*r**4+1724543*r**6+901204*r**8-113042*r**10-161840*r**12
            -113042*r**14+901204*r**16+1724543*r**18+896264*r**20+123827*r**22+76124*r**24)
            -90*Q2*(6827+10856*r**2+115751*r**4+133189*r**6-125432*r**8-40235*r**10
            +463524*r**12+463524*r**14-40235*r**16-125432*r**18+133189*r**20+115751*r**22
            +10856*r**24+6827*r**26))+11466178560000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1120*Q2**13*(1+r**2)-20160*Q2**12*(1+r**2)**2+60*Q2**11*(2109
            +6607*r**2+6607*r**4+2109*r**6)-15*Q2**8*(1+r**2)**2*(40336+194357*r**2
            +316506*r**4+194357*r**6+40336*r**8)-2*Q2**10*(196248+851619*r**2+1309846*r**4
            +851619*r**6+196248*r**8)+60*Q2**9*(10922+61823*r**2+130971*r**4+130971*r**6
            +61823*r**8+10922*r**10)+5*Q2**7*(107370+491433*r**2+1346369*r**4+2211676*r**6
            +2211676*r**8+1346369*r**10+491433*r**12+107370*r**14)-15*Q2**6*(75124
            +185927*r**2+259840*r**4+235545*r**6+180184*r**8+235545*r**10+259840*r**12
            +185927*r**14+75124*r**16)+6*Q2**5*(291137+935851*r**2+2025509*r**4
            +2823491*r**6+2188532*r**8+2188532*r**10+2823491*r**12+2025509*r**14
            +935851*r**16+291137*r**18)-20*Q2**4*(49706+246614*r**2+761773*r**4
            +1396663*r**6+1127437*r**8+584110*r**10+1127437*r**12+1396663*r**14
            +761773*r**16+246614*r**18+49706*r**20)-15*Q2**3*(38242-26871*r**2-19225*r**4
            -23904*r**6+27462*r**8+281832*r**10+281832*r**12+27462*r**14-23904*r**16
            -19225*r**18-26871*r**20+38242*r**22)+9*(-1+r**2)**2*(13136+40445*r**2
            +345746*r**4+500085*r**6-149680*r**8+136398*r**10+1050140*r**12+136398*r**14
            -149680*r**16+500085*r**18+345746*r**20+40445*r**22+13136*r**24)+15*Q2**2*(76124
            +123827*r**2+896264*r**4+1724543*r**6+901204*r**8-113042*r**10-161840*r**12
            -113042*r**14+901204*r**16+1724543*r**18+896264*r**20+123827*r**22+76124*r**24)
            -90*Q2*(6827+10856*r**2+115751*r**4+133189*r**6-125432*r**8-40235*r**10
            +463524*r**12+463524*r**14-40235*r**16-125432*r**18+133189*r**20+115751*r**22
            +10856*r**24+6827*r**26))*sqrtq2)+logq2**5*(63700992000*r**24*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**4*(-4480*Q2**17+243680*Q2**16*(1+r**2)-10*Q2**15*(250267
            +508150*r**2+250267*r**4)+6*Q2**14*(2057907+6357881*r**2+6357881*r**4
            +2057907*r**6)-6*Q2**13*(6000833+25368627*r**2+38749028*r**4+25368627*r**6
            +6000833*r**8)+12*Q2**12*(5579121+30512817*r**2+63202286*r**4+63202286*r**6
            +30512817*r**8+5579121*r**10)-Q2**11*(81290418+541492491*r**2+1388210262*r**4
            +1852181498*r**6+1388210262*r**8+541492491*r**10+81290418*r**12)+Q2**10*(64195887
            +447325143*r**2+1179026469*r**4+1690054021*r**6+1690054021*r**8+1179026469*r**10
            +447325143*r**12+64195887*r**14)+Q2**9*(-30081309-110532957*r**2+265084878*r**4
            +1886492461*r**6+3091086910*r**8+1886492461*r**10+265084878*r**12-110532957*r**14
            -30081309*r**16)-Q2**8*(6655154+120133101*r**2+1379548569*r**4+5718886231*r**6
            +11141611329*r**8+11141611329*r**10+5718886231*r**12+1379548569*r**14
            +120133101*r**16+6655154*r**18)+Q2**7*(48184786+121337077*r**2+1121752326*r**4
            +4472518316*r**6+10129155272*r**8+13336715262*r**10+10129155272*r**12
            +4472518316*r**14+1121752326*r**16+121337077*r**18+48184786*r**20)-Q2**6*(75249404
            +181153613*r**2+1429549061*r**4+2548891924*r**6+2729967136*r**8+3313272382*r**10
            +3313272382*r**12+2729967136*r**14+2548891924*r**16+1429549061*r**18
            +181153613*r**20+75249404*r**22)+3*Q2**5*(18364212+117595573*r**2+947722874*r**4
            +1862757441*r**6+2048859396*r**8+1764491946*r**10+1416932316*r**12+1764491946*r**14
            +2048859396*r**16+1862757441*r**18+947722874*r**20+117595573*r**22+18364212*r**24)
            -3*Q2**4*(1755836+103373993*r**2+770736963*r**4+2181976351*r**6+3872117845*r**8
            +4473948678*r**10+3071474334*r**12+3071474334*r**14+4473948678*r**16
            +3872117845*r**18+2181976351*r**20+770736963*r**22+103373993*r**24+1755836*r**26)
            -18*Q2**3*(1279061-2060991*r**2+20915891*r**4-91781876*r**6-135529359*r**8
            -27911777*r**10+62092167*r**12+108912168*r**14+62092167*r**16-27911777*r**18
            -135529359*r**20-91781876*r**22+20915891*r**24-2060991*r**26+1279061*r**28)
            +54*(-1+r**2)**2*(13843+362158*r**2+4031324*r**4+7446779*r**6+37474773*r**8
            +46762432*r**10-34506*r**12-11384803*r**14-11384803*r**16-34506*r**18
            +46762432*r**20+37474773*r**22+7446779*r**24+4031324*r**26+362158*r**28
            +13843*r**30)+9*Q2**2*(2032763+13938316*r**2+189651538*r**4+160563003*r**6
            +897602741*r**8+1542535562*r**10+503916568*r**12-389056491*r**14-389056491*r**16
            +503916568*r**18+1542535562*r**20+897602741*r**22+160563003*r**24+189651538*r**26
            +13938316*r**28+2032763*r**30)-27*Q2*(221379+3180388*r**2+35955376*r**4
            +24942664*r**6+238706636*r**8+210504000*r**10-186914992*r**12+100634388*r**14
            +500292322*r**16+100634388*r**18-186914992*r**20+210504000*r**22+238706636*r**24
            +24942664*r**26+35955376*r**28+3180388*r**30+221379*r**32))+63700992000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(4480*Q2**18-248160*Q2**17*(1+r**2)
            +170*Q2**16*(16155+32758*r**2+16155*r**4)-64*Q2**15*(232033+714554*r**2
            +714554*r**4+232033*r**6)+30*Q2**14*(1611748+6756883*r**2+10292958*r**4
            +6756883*r**6+1611748*r**8)-6*Q2**13*(17159075+92395094*r**2+190522227*r**4
            +190522227*r**6+92395094*r**8+17159075*r**10)+Q2**12*(148239870+974595747*r**2
            +2512791498*r**4+3369036362*r**6+2512791498*r**8+974595747*r**10+148239870*r**12)
            -3*Q2**11*(48495435+356702684*r**2+1036243074*r**4+1643481927*r**6+1643481927*r**8
            +1036243074*r**10+356702684*r**12+48495435*r**14)+Q2**10*(94277196+622053987*r**2
            +1361266734*r**4+982588029*r**6+289021132*r**8+982588029*r**10+1361266734*r**12
            +622053987*r**14+94277196*r**16)-5*Q2**9*(4685231+4096233*r**2-306820098*r**4
            -1574092714*r**6-3223838140*r**8-3223838140*r**10-1574092714*r**12-306820098*r**14
            +4096233*r**16+4685231*r**18)-12*Q2**8*(4569995+20677111*r**2+218452833*r**4
            +964246093*r**6+2249137736*r**8+2968328160*r**10+2249137736*r**12+964246093*r**14
            +218452833*r**16+20677111*r**18+4569995*r**20)+2*Q2**7*(61717095+175337738*r**2
            +1336319232*r**4+4071581283*r**6+8665820362*r**8+13389571458*r**10+13389571458*r**12
            +8665820362*r**14+4071581283*r**16+1336319232*r**18+175337738*r**20+61717095*r**22)
            -4*Q2**6*(32585510+152297434*r**2+1113467824*r**4+2391678327*r**6+2856359312*r**8
            +2834178839*r**10+2719335428*r**12+2834178839*r**14+2856359312*r**16
            +2391678327*r**18+1113467824*r**20+152297434*r**22+32585510*r**24)+6*Q2**5*(10060024
            +119666889*r**2+918027705*r**4+2496228333*r**6+3891867341*r**8+4143650010*r**10
            +3126449298*r**12+3126449298*r**14+4143650010*r**16+3891867341*r**18
            +2496228333*r**20+918027705*r**22+119666889*r**24+10060024*r**26)+54*(
            -1+r**4)**2*(13843+348315*r**2+3683009*r**4+3763770*r**6+33711003*r**8
            +13051429*r**10-13085935*r**12+1701132*r**14-13085935*r**16+13051429*r**18
            +33711003*r**20+3763770*r**22+3683009*r**24+348315*r**26+13843*r**28)
            +15*Q2**4*(1183706-23499155*r**2-149723122*r**4-700680914*r**6-1373454070*r**8
            -1702707437*r**10-1434574002*r**12-1097895132*r**14-1434574002*r**16
            -1702707437*r**18-1373454070*r**20-700680914*r**22-149723122*r**24-23499155*r**26
            +1183706*r**28)-9*Q2**3*(4590885+12374456*r**2+227361338*r**4+18831033*r**6
            +442980271*r**8+1215653290*r**10+572277348*r**12-47047821*r**14-47047821*r**16
            +572277348*r**18+1215653290*r**20+442980271*r**22+18831033*r**24+227361338*r**26
            +12374456*r**28+4590885*r**30)+9*Q2**2*(2696900+25512243*r**2+311455982*r**4
            +425042533*r**6+1774285652*r**8+3071650303*r**10+1485707154*r**12+416763241*r**14
            +722763984*r**16+416763241*r**18+1485707154*r**20+3071650303*r**22+1774285652*r**24
            +425042533*r**26+311455982*r**28+25512243*r**30+2696900*r**32)-27*Q2*(249065
            +4070711*r**2+45777466*r**4+60390618*r**6+316874378*r**8+407729966*r**10
            -88580186*r**12-15387322*r**14+623627304*r**16+623627304*r**18-15387322*r**20
            -88580186*r**22+407729966*r**24+316874378*r**26+60390618*r**28+45777466*r**30
            +4070711*r**32+249065*r**34))*sqrtq2)+logq2**4*(-530841600*r**20*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(565760*Q2**20-10060160*Q2**19*(1
            +r**2)+256*Q2**18*(298956+606911*r**2+298956*r**4)-16*Q2**17*(20615543
            +64431961*r**2+64431961*r**4+20615543*r**6)+4*Q2**16*(220754432+961344127*r**2
            +1473617534*r**4+961344127*r**6+220754432*r**8)-8*Q2**15*(185231682+1087520991*r**2
            +2273180035*r**4+2273180035*r**6+1087520991*r**8+185231682*r**10)+3*Q2**14*(469046080
            +3860082295*r**2+10045058012*r**4+13254398282*r**6+10045058012*r**8+3860082295*r**10
            +469046080*r**12)-8*Q2**13*(37800531+824472966*r**2+1869103674*r**4+1486616341*r**6
            +1486616341*r**8+1869103674*r**10+824472966*r**12+37800531*r**14)-Q2**12*(1029110976
            +4867369047*r**2+42857185626*r**4+153978380089*r**6+229686883052*r**8
            +153978380089*r**10+42857185626*r**12+4867369047*r**14+1029110976*r**16)
            +2*Q2**11*(759621488+6370788573*r**2+51903934629*r**4+203053696791*r**6
            +387520792871*r**8+387520792871*r**10+203053696791*r**12+51903934629*r**14
            +6370788573*r**16+759621488*r**18)-Q2**10*(1166340832+11543024761*r**2
            +105512398884*r**4+469758876716*r**6+1090468564252*r**8+1426701450998*r**10
            +1090468564252*r**12+469758876716*r**14+105512398884*r**16+11543024761*r**18
            +1166340832*r**20)+2*Q2**9*(256975500+3397473455*r**2+24828780939*r**4
            +98917578484*r**6+221711146384*r**8+292861391510*r**10+292861391510*r**12
            +221711146384*r**14+98917578484*r**16+24828780939*r**18+3397473455*r**20
            +256975500*r**22)+Q2**8*(241952288-3500527817*r**2+4547034226*r**4+97147445051*r**6
            +571640694536*r**8+1591265868110*r**10+2224504544332*r**12+1591265868110*r**14
            +571640694536*r**16+97147445051*r**18+4547034226*r**20-3500527817*r**22
            +241952288*r**24)-4*Q2**7*(191672996+76070557*r**2+8478020405*r**4+28443332907*r**6
            +165606121979*r**8+496777525900*r**10+857824558456*r**12+857824558456*r**14
            +496777525900*r**16+165606121979*r**18+28443332907*r**20+8478020405*r**22
            +76070557*r**24+191672996*r**26)+Q2**6*(597348864+4930981659*r**2+55573139276*r**4
            +85617067102*r**6+451818768012*r**8+716659394949*r**10+921327539304*r**12
            +1159428865668*r**14+921327539304*r**16+716659394949*r**18+451818768012*r**20
            +85617067102*r**22+55573139276*r**24+4930981659*r**26+597348864*r**28)
            -12*Q2**5*(3332334+497087087*r**2+4866320891*r**4+18868056894*r**6+84345280666*r**8
            +103944564301*r**10+51307516617*r**12+29242761210*r**14+29242761210*r**16
            +51307516617*r**18+103944564301*r**20+84345280666*r**22+18868056894*r**24
            +4866320891*r**26+497087087*r**28+3332334*r**30)-3*Q2**4*(72031360-827033205*r**2
            -8668888862*r**4-87847859887*r**6-368742067532*r**8-681835524805*r**10
            -765679908450*r**12-708715966231*r**14-653882044776*r**16-708715966231*r**18
            -765679908450*r**20-681835524805*r**22-368742067532*r**24-87847859887*r**26
            -8668888862*r**28-827033205*r**30+72031360*r**32)+18*Q2**3*(6273568+53935553*r**2
            +591111385*r**4-3786313061*r**6-1876574181*r**8-41647307911*r**10-35510936503*r**12
            +2546831683*r**14+7228419467*r**16+7228419467*r**18+2546831683*r**20
            -35510936503*r**22-41647307911*r**24-1876574181*r**26-3786313061*r**28
            +591111385*r**30+53935553*r**32+6273568*r**34)+27*(-1+r**2)**2*(131168
            -3518785*r**2-58920160*r**4-619287648*r**6-3635040800*r**8-2267898684*r**10
            -18930734240*r**12-27418625440*r**14+9249529664*r**16+36565529850*r**18
            +9249529664*r**20-27418625440*r**22-18930734240*r**24-2267898684*r**26
            -3635040800*r**28-619287648*r**30-58920160*r**32-3518785*r**34+131168*r**36)
            +9*Q2**2*(279072-170798511*r**2-2065063292*r**4-9104963680*r**6-72451056548*r**8
            -18625115524*r**10-191123751020*r**12-292303003552*r**14-27944990868*r**16
            +109906527846*r**18-27944990868*r**20-292303003552*r**22-191123751020*r**24
            -18625115524*r**26-72451056548*r**28-9104963680*r**30-2065063292*r**32
            -170798511*r**34+279072*r**36)-54*Q2*(302492-12148353*r**2-157242645*r**4
            -1189049452*r**6-7190405992*r**8+1768383224*r**10-29189468896*r**12-26791867480*r**14
            +17742034576*r**16-5783737474*r**18-5783737474*r**20+17742034576*r**22
            -26791867480*r**24-29189468896*r**26+1768383224*r**28-7190405992*r**30
            -1189049452*r**32-157242645*r**34-12148353*r**36+302492*r**38))-530841600*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(565760*Q2**20-10060160*Q2**19*(1+r**2)
            +256*Q2**18*(298956+606911*r**2+298956*r**4)-16*Q2**17*(20615543+64431961*r**2
            +64431961*r**4+20615543*r**6)+4*Q2**16*(220754432+961344127*r**2+1473617534*r**4
            +961344127*r**6+220754432*r**8)-8*Q2**15*(185231682+1087520991*r**2+2273180035*r**4
            +2273180035*r**6+1087520991*r**8+185231682*r**10)+3*Q2**14*(469046080
            +3860082295*r**2+10045058012*r**4+13254398282*r**6+10045058012*r**8+3860082295*r**10
            +469046080*r**12)-8*Q2**13*(37800531+824472966*r**2+1869103674*r**4+1486616341*r**6
            +1486616341*r**8+1869103674*r**10+824472966*r**12+37800531*r**14)-Q2**12*(1029110976
            +4867369047*r**2+42857185626*r**4+153978380089*r**6+229686883052*r**8
            +153978380089*r**10+42857185626*r**12+4867369047*r**14+1029110976*r**16)
            +2*Q2**11*(759621488+6370788573*r**2+51903934629*r**4+203053696791*r**6
            +387520792871*r**8+387520792871*r**10+203053696791*r**12+51903934629*r**14
            +6370788573*r**16+759621488*r**18)-Q2**10*(1166340832+11543024761*r**2
            +105512398884*r**4+469758876716*r**6+1090468564252*r**8+1426701450998*r**10
            +1090468564252*r**12+469758876716*r**14+105512398884*r**16+11543024761*r**18
            +1166340832*r**20)+2*Q2**9*(256975500+3397473455*r**2+24828780939*r**4
            +98917578484*r**6+221711146384*r**8+292861391510*r**10+292861391510*r**12
            +221711146384*r**14+98917578484*r**16+24828780939*r**18+3397473455*r**20
            +256975500*r**22)+Q2**8*(241952288-3500527817*r**2+4547034226*r**4+97147445051*r**6
            +571640694536*r**8+1591265868110*r**10+2224504544332*r**12+1591265868110*r**14
            +571640694536*r**16+97147445051*r**18+4547034226*r**20-3500527817*r**22
            +241952288*r**24)-4*Q2**7*(191672996+76070557*r**2+8478020405*r**4+28443332907*r**6
            +165606121979*r**8+496777525900*r**10+857824558456*r**12+857824558456*r**14
            +496777525900*r**16+165606121979*r**18+28443332907*r**20+8478020405*r**22
            +76070557*r**24+191672996*r**26)+Q2**6*(597348864+4930981659*r**2+55573139276*r**4
            +85617067102*r**6+451818768012*r**8+716659394949*r**10+921327539304*r**12
            +1159428865668*r**14+921327539304*r**16+716659394949*r**18+451818768012*r**20
            +85617067102*r**22+55573139276*r**24+4930981659*r**26+597348864*r**28)
            -12*Q2**5*(3332334+497087087*r**2+4866320891*r**4+18868056894*r**6+84345280666*r**8
            +103944564301*r**10+51307516617*r**12+29242761210*r**14+29242761210*r**16
            +51307516617*r**18+103944564301*r**20+84345280666*r**22+18868056894*r**24
            +4866320891*r**26+497087087*r**28+3332334*r**30)-3*Q2**4*(72031360-827033205*r**2
            -8668888862*r**4-87847859887*r**6-368742067532*r**8-681835524805*r**10
            -765679908450*r**12-708715966231*r**14-653882044776*r**16-708715966231*r**18
            -765679908450*r**20-681835524805*r**22-368742067532*r**24-87847859887*r**26
            -8668888862*r**28-827033205*r**30+72031360*r**32)+18*Q2**3*(6273568+53935553*r**2
            +591111385*r**4-3786313061*r**6-1876574181*r**8-41647307911*r**10-35510936503*r**12
            +2546831683*r**14+7228419467*r**16+7228419467*r**18+2546831683*r**20
            -35510936503*r**22-41647307911*r**24-1876574181*r**26-3786313061*r**28
            +591111385*r**30+53935553*r**32+6273568*r**34)+27*(-1+r**2)**2*(131168
            -3518785*r**2-58920160*r**4-619287648*r**6-3635040800*r**8-2267898684*r**10
            -18930734240*r**12-27418625440*r**14+9249529664*r**16+36565529850*r**18
            +9249529664*r**20-27418625440*r**22-18930734240*r**24-2267898684*r**26
            -3635040800*r**28-619287648*r**30-58920160*r**32-3518785*r**34+131168*r**36)
            +9*Q2**2*(279072-170798511*r**2-2065063292*r**4-9104963680*r**6-72451056548*r**8
            -18625115524*r**10-191123751020*r**12-292303003552*r**14-27944990868*r**16
            +109906527846*r**18-27944990868*r**20-292303003552*r**22-191123751020*r**24
            -18625115524*r**26-72451056548*r**28-9104963680*r**30-2065063292*r**32
            -170798511*r**34+279072*r**36)-54*Q2*(302492-12148353*r**2-157242645*r**4
            -1189049452*r**6-7190405992*r**8+1768383224*r**10-29189468896*r**12-26791867480*r**14
            +17742034576*r**16-5783737474*r**18-5783737474*r**20+17742034576*r**22
            -26791867480*r**24-29189468896*r**26+1768383224*r**28-7190405992*r**30
            -1189049452*r**32-157242645*r**34-12148353*r**36+302492*r**38))*sqrtq2)
            +logq2**3*(-17694720*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(2703360*Q2**23
            -39170112*Q2**22*(1+r**2)+Q2**21*(255121794+522749188*r**2+255121794*r**4)
            -6*Q2**20*(160962937+520735083*r**2+520735083*r**4+160962937*r**6)+10*Q2**19*(227473884
            +1072234917*r**2+1665153938*r**4+1072234917*r**6+227473884*r**8)-10*Q2**18*(319618881
            +2221036475*r**2+4716067788*r**4+4716067788*r**6+2221036475*r**8+319618881*r**10)
            +3*Q2**17*(604561306+8284430871*r**2+20588972310*r**4+25480198450*r**6
            +20588972310*r**8+8284430871*r**10+604561306*r**12)+Q2**16*(2128996359
            -2319678597*r**2+31615842049*r**4+136656921165*r**6+136656921165*r**8
            +31615842049*r**10-2319678597*r**12+2128996359*r**14)-Q2**15*(5307892587
            +37248431048*r**2+267059749368*r**4+915994194192*r**6+1356847689450*r**8
            +915994194192*r**10+267059749368*r**12+37248431048*r**14+5307892587*r**16)
            +15*Q2**14*(276279787+3749355906*r**2+30027961089*r**4+128840758503*r**6
            +254718611707*r**8+254718611707*r**10+128840758503*r**12+30027961089*r**14
            +3749355906*r**16+276279787*r**18)+5*Q2**13*(44508669-6704779155*r**2
            -61883237727*r**4-377342189136*r**6-958327462974*r**8-1266804898682*r**10
            -958327462974*r**12-377342189136*r**14-61883237727*r**16-6704779155*r**18
            +44508669*r**20)-Q2**12*(3315309507+4285582867*r**2+84966897915*r**4
            -104640869205*r**6-84486277230*r**8+1092766253298*r**10+1092766253298*r**12
            -84486277230*r**14-104640869205*r**16+84966897915*r**18+4285582867*r**20
            +3315309507*r**22)+3*Q2**11*(990687203+7885122246*r**2+115134848238*r**4
            +638590467470*r**6+2862876554285*r**8+7674335812172*r**10+10718006960964*r**12
            +7674335812172*r**14+2862876554285*r**16+638590467470*r**18+115134848238*r**20
            +7885122246*r**22+990687203*r**24)-Q2**10*(745883307+25226275068*r**2
            +309052138733*r**4+2278933724637*r**6+12342883124550*r**8+39600934628563*r**10
            +71332862877942*r**12+71332862877942*r**14+39600934628563*r**16+12342883124550*r**18
            +2278933724637*r**20+309052138733*r**22+25226275068*r**24+745883307*r**26)
            +5*Q2**9*(-206948151+3905720137*r**2+32499266463*r**4+261468645030*r**6
            +1395408476509*r**8+4993609591911*r**10+11068937189691*r**12+14384107190612*r**14
            +11068937189691*r**16+4993609591911*r**18+1395408476509*r**20+261468645030*r**22
            +32499266463*r**24+3905720137*r**26-206948151*r**28)+15*Q2**8*(86824045
            -315025605*r**2-2713371231*r**4-32980776425*r**6+22065287821*r**8+335777916667*r**10
            +1162196744041*r**12+2194726075567*r**14+2194726075567*r**16+1162196744041*r**18
            +335777916667*r**20+22065287821*r**22-32980776425*r**24-2713371231*r**26
            -315025605*r**28+86824045*r**30)-Q2**7*(468600417+11885990532*r**2+65340678460*r**4
            -72443532540*r**6+2997629259300*r**8+11715887878748*r**10+44849625073668*r**12
            +98178045901980*r**14+128063305194870*r**16+98178045901980*r**18+44849625073668*r**20
            +11715887878748*r**22+2997629259300*r**24-72443532540*r**26+65340678460*r**28
            +11885990532*r**30+468600417*r**32)+Q2**6*(-288710721+13751786438*r**2
            +115942456749*r**4+490777894935*r**6+3785886741945*r**8+3771318026331*r**10
            +20040024108237*r**12+34100436311791*r**14+47907474104295*r**16+47907474104295*r**18
            +34100436311791*r**20+20040024108237*r**22+3771318026331*r**24+3785886741945*r**26
            +490777894935*r**28+115942456749*r**30+13751786438*r**32-288710721*r**34)
            +9*Q2**5*(39218457-363980317*r**2-8344261007*r**4-98185170268*r**6-549313729500*r**8
            -1300226433572*r**10-4479711135628*r**12-2963992528548*r**14+668937633758*r**16
            +864304773250*r**18+668937633758*r**20-2963992528548*r**22-4479711135628*r**24
            -1300226433572*r**26-549313729500*r**28-98185170268*r**30-8344261007*r**32
            -363980317*r**34+39218457*r**36)-15*Q2**4*(5675701+231726813*r**2-547946423*r**4
            -38215930959*r**6-228997251584*r**8-1329509523216*r**10-3993634943080*r**12
            -4625477490552*r**14-3301606465774*r**16-4192969130926*r**18-4192969130926*r**20
            -3301606465774*r**22-4625477490552*r**24-3993634943080*r**26-1329509523216*r**28
            -228997251584*r**30-38215930959*r**32-547946423*r**34+231726813*r**36
            +5675701*r**38)-45*Q2**3*(1198121-54743880*r**2-431251694*r**4-471856568*r**6
            -2817658779*r**8+182768509328*r**10+164628941176*r**12+659968590960*r**14
            +274403718002*r**16+48345815808*r**18+253260515052*r**20+48345815808*r**22
            +274403718002*r**24+659968590960*r**26+164628941176*r**28+182768509328*r**30
            -2817658779*r**32-471856568*r**34-431251694*r**36-54743880*r**38+1198121*r**40)
            +54*(-1+r**2)**2*(16607+1175762*r**2-9818205*r**4-429266325*r**6-3630259570*r**8
            -25628899233*r**10-90583747668*r**12+52051853340*r**14-516314650550*r**16
            -559741662440*r**18+839466058282*r**20+839466058282*r**22-559741662440*r**24
            -516314650550*r**26+52051853340*r**28-90583747668*r**30-25628899233*r**32
            -3630259570*r**34-429266325*r**36-9818205*r**38+1175762*r**40+16607*r**42)
            +9*Q2**2*(4604777-23995178*r**2-1585900895*r**4-26396839955*r**6-179559135290*r**8
            -511635272963*r**10-3687017630928*r**12+1135686575000*r**14-5785908720670*r**16
            -8051880371940*r**18+800489488042*r**20+800489488042*r**22-8051880371940*r**24
            -5785908720670*r**26+1135686575000*r**28-3687017630928*r**30-511635272963*r**32
            -179559135290*r**34-26396839955*r**36-1585900895*r**38-23995178*r**40
            +4604777*r**42)-27*Q2*(384733+8992246*r**2-173012697*r**4-4662626120*r**6
            -32259682205*r**8-170010425602*r**10-694597635759*r**12+944736823008*r**14
            -2979354630590*r**16-2277342985460*r**18+2037310615558*r**20+1475581165776*r**22
            +2037310615558*r**24-2277342985460*r**26-2979354630590*r**28+944736823008*r**30
            -694597635759*r**32-170010425602*r**34-32259682205*r**36-4662626120*r**38
            -173012697*r**40+8992246*r**42+384733*r**44))+17694720*r**16*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**4*(2703360*Q2**24-41873472*Q2**23*(1+r**2)
            +Q2**22*(294291906+601089412*r**2+294291906*r**4)-8*Q2**21*(152612427
            +487785185*r**2+487785185*r**4+152612427*r**6)+2*Q2**20*(1620258231+7406268645*r**2
            +11450180188*r**4+7406268645*r**6+1620258231*r**8)-10*Q2**19*(547092765
            +3520745276*r**2+7453456643*r**4+7453456643*r**6+3520745276*r**8+547092765*r**10)
            +Q2**18*(5009872728+50259846173*r**2+131137959560*r**4+170761951110*r**6
            +131137959560*r**8+50259846173*r**10+5009872728*r**12)+Q2**17*(315312441
            -28986655128*r**2-55004367494*r**4-1550591115*r**6-1550591115*r**8-55004367494*r**10
            -28986655128*r**12+315312441*r**14)-2*Q2**16*(3718444473+18528874405*r**2
            +148177956410*r**4+542133478703*r**6+815080765890*r**8+542133478703*r**10
            +148177956410*r**12+18528874405*r**14+3718444473*r**16)+Q2**15*(9452089392
            +98796662225*r**2+754727596751*r**4+3115665321105*r**6+6093621059247*r**8
            +6093621059247*r**10+3115665321105*r**12+754727596751*r**14+98796662225*r**16
            +9452089392*r**18)-10*Q2**14*(392165346+9390843117*r**2+81607594356*r**4
            +426974173956*r**6+1054502786802*r**8+1397558284462*r**10+1054502786802*r**12
            +426974173956*r**14+81607594356*r**16+9390843117*r**18+392165346*r**20)
            +Q2**13*(-3537852852+29015769563*r**2+257973186495*r**4+2300768003520*r**6
            +6762834537780*r**8+10032895554982*r**10+10032895554982*r**12+6762834537780*r**14
            +2300768003520*r**16+257973186495*r**18+29015769563*r**20-3537852852*r**22)
            +4*Q2**12*(1571842779+7814064778*r**2+108664256374*r**4+474024357780*r**6
            +2099875629105*r**8+6007821853146*r**10+8584888347372*r**12+6007821853146*r**14
            +2099875629105*r**16+474024357780*r**18+108664256374*r**20+7814064778*r**22
            +1571842779*r**24)-Q2**11*(3717944916+51853703415*r**2+678112050185*r**4
            +4540109671761*r**6+22847284189815*r**8+71212571727934*r**10+126509891197350*r**12
            +126509891197350*r**14+71212571727934*r**16+22847284189815*r**18+4540109671761*r**20
            +678112050185*r**22+51853703415*r**24+3717944916*r**26)+4*Q2**10*(-72214362
            +11375189765*r**2+124193686529*r**4+973832272130*r**6+5399714807933*r**8
            +19227966428167*r**10+41569620863740*r**12+53646565427236*r**14+41569620863740*r**16
            +19227966428167*r**18+5399714807933*r**20+973832272130*r**22+124193686529*r**24
            +11375189765*r**26-72214362*r**28)+5*Q2**9*(467420286-4643848801*r**2
            -44545100293*r**4-392910240768*r**6-1590681258076*r**8-5381684318419*r**10
            -12575956549479*r**12-18868866153602*r**14-18868866153602*r**16-12575956549479*r**18
            -5381684318419*r**20-1590681258076*r**22-392910240768*r**24-44545100293*r**26
            -4643848801*r**28+467420286*r**30)-4*Q2**8*(442740273+2115741783*r**2
            +4978681480*r**4-151963936845*r**6+708474232560*r**8+4270883986517*r**10
            +16829811246072*r**12+37132972049025*r**14+48476271865470*r**16+37132972049025*r**18
            +16829811246072*r**20+4270883986517*r**22+708474232560*r**24-151963936845*r**26
            +4978681480*r**28+2115741783*r**30+442740273*r**32)+Q2**7*(179889696
            +26106377387*r**2+193169125741*r**4+483675040855*r**6+6711072468705*r**8
            +18484835164379*r**10+76605537060653*r**12+177128107287439*r**14+274148825201145*r**16
            +274148825201145*r**18+177128107287439*r**20+76605537060653*r**22+18484835164379*r**24
            +6711072468705*r**26+483675040855*r**28+193169125741*r**30+26106377387*r**32
            +179889696*r**34)+2*Q2**6*(320838417-8369449285*r**2-102396296125*r**4
            -745193442048*r**6-4610244101190*r**8-9629621335212*r**10-32064371177610*r**12
            -40408196588480*r**14-37993735856132*r**16-44018102624670*r**18-37993735856132*r**20
            -40408196588480*r**22-32064371177610*r**24-9629621335212*r**26-4610244101190*r**28
            -745193442048*r**30-102396296125*r**32-8369449285*r**34+320838417*r**36)
            +3*Q2**5*(-146033876-184348485*r**2+28864456087*r**4+510667948620*r**6
            +3087482957224*r**8+12196168105296*r**10+37307987423000*r**12+45458498445288*r**14
            +23393197013240*r**16+16365118433606*r**18+16365118433606*r**20+23393197013240*r**22
            +45458498445288*r**24+37307987423000*r**26+12196168105296*r**28+3087482957224*r**30
            +510667948620*r**32+28864456087*r**34-184348485*r**36-146033876*r**38)
            -54*(-1+r**4)**2*(16607+1159155*r**2-10977360*r**4-418288965*r**6-3211970605*r**8
            -22416928628*r**10-68166819040*r**12+120218672380*r**14-636533322930*r**16
            +76791660490*r**18+762674397792*r**20+76791660490*r**22-636533322930*r**24
            +120218672380*r**26-68166819040*r**28-22416928628*r**30-3211970605*r**32
            -418288965*r**34-10977360*r**36+1159155*r**38+16607*r**40)+30*Q2**4*(1040669
            +200817077*r**2+488767736*r**4-18674153839*r**6-129380103103*r**8-1053406151392*r**10
            -2908515644912*r**12-5299509103256*r**14-4375147555166*r**16-3819806522062*r**18
            -4572859903504*r**20-3819806522062*r**22-4375147555166*r**24-5299509103256*r**26
            -2908515644912*r**28-1053406151392*r**30-129380103103*r**32-18674153839*r**34
            +488767736*r**36+200817077*r**38+1040669*r**40)+9*Q2**3*(10595382-291723973*r**2
            -4015878765*r**4-30912381265*r**6-196006712025*r**8+388118979782*r**10
            -1950030378408*r**12+5258674235680*r**14-1114047175860*r**16-6438132702890*r**18
            +2308521142342*r**20+2308521142342*r**22-6438132702890*r**24-1114047175860*r**26
            +5258674235680*r**28-1950030378408*r**30+388118979782*r**32-196006712025*r**34
            -30912381265*r**36-4015878765*r**38-291723973*r**40+10595382*r**42)-9*Q2**2*(5758976
            +7586337*r**2-2128934164*r**4-41970619210*r**6-302735021860*r**8-1201225685059*r**10
            -6282445811168*r**12+282879413096*r**14-13588286037440*r**16-20669818048990*r**18
            -1139459037224*r**20+6027722473412*r**22-1139459037224*r**24-20669818048990*r**26
            -13588286037440*r**28+282879413096*r**30-6282445811168*r**32-1201225685059*r**34
            -302735021860*r**36-41970619210*r**38-2128934164*r**40+7586337*r**42
            +5758976*r**44)+27*Q2*(417947+11662075*r**2-188326695*r**4-5652547123*r**6
            -42485398575*r**8-239865400643*r**10-950520478905*r**12+665320086135*r**14
            -3456622017378*r**16-4206818632050*r**18+2645237095322*r**20+714476339890*r**22
            +714476339890*r**24+2645237095322*r**26-4206818632050*r**28-3456622017378*r**30
            +665320086135*r**32-950520478905*r**34-239865400643*r**36-42485398575*r**38
            -5652547123*r**40-188326695*r**42+11662075*r**44+417947*r**46))*sqrtq2)
            +logq2**2*(294912*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(
            -5936896*Q2**26+90491936*Q2**25*(1+r**2)-64*Q2**24*(9407875+19912102*r**2
            +9407875*r**4)+4*Q2**23*(564409465+1933660563*r**2+1933660563*r**4+564409465*r**6)
            -2*Q2**22*(2512194040+12990583399*r**2+20256681822*r**4+12990583399*r**6
            +2512194040*r**8)+4*Q2**21*(1462401040+12431298823*r**2+25638277333*r**4
            +25638277333*r**6+12431298823*r**8+1462401040*r**10)+Q2**20*(92866960
            -41054776113*r**2-70399526100*r**4-48823191590*r**6-70399526100*r**8
            -41054776113*r**10+92866960*r**12)-Q2**19*(11183463950+39942747863*r**2
            +328600062495*r**4+1001296719500*r**6+1001296719500*r**8+328600062495*r**10
            +39942747863*r**12+11183463950*r**14)+Q2**18*(15149819860+152813497567*r**2
            +1092646386232*r**4+4031500723345*r**6+6068789619400*r**8+4031500723345*r**10
            +1092646386232*r**12+152813497567*r**14+15149819860*r**16)-2*Q2**17*(1536542565
            +85786858854*r**2+713740530162*r**4+3638700221834*r**6+7478223173025*r**8
            +7478223173025*r**10+3638700221834*r**12+713740530162*r**14+85786858854*r**16
            +1536542565*r**18)+Q2**16*(-13899218880+34927866807*r**2+407584843632*r**4
            +5126777626832*r**6+13672834903232*r**8+17408953667538*r**10+13672834903232*r**12
            +5126777626832*r**14+407584843632*r**16+34927866807*r**18-13899218880*r**20)
            +2*Q2**15*(7943590800+70223209896*r**2+694657673985*r**4+2417520658075*r**6
            +8735831347885*r**8+21022670642767*r**10+21022670642767*r**12+8735831347885*r**14
            +2417520658075*r**16+694657673985*r**18+70223209896*r**20+7943590800*r**22)
            -4*Q2**14*(436875100+45970811217*r**2+512293632960*r**4+3563028985825*r**6
            +16025019449400*r**8+45668302269870*r**10+65121039887128*r**12+45668302269870*r**14
            +16025019449400*r**16+3563028985825*r**18+512293632960*r**20+45970811217*r**22
            +436875100*r**24)+2*Q2**13*(-5169129620+36339641206*r**2+457114647921*r**4
            +6228033020965*r**6+35287132496050*r**8+135074079046140*r**10+260695523460634*r**12
            +260695523460634*r**14+135074079046140*r**16+35287132496050*r**18+6228033020965*r**20
            +457114647921*r**22+36339641206*r**24-5169129620*r**26)+2*Q2**12*(4383602560
            +32023138081*r**2+240401855818*r**4-1009562683154*r**6-7353612940310*r**8
            -63099782983625*r**10-172241324935316*r**12-227938726899788*r**14-172241324935316*r**16
            -63099782983625*r**18-7353612940310*r**20-1009562683154*r**22+240401855818*r**24
            +32023138081*r**26+4383602560*r**28)-2*Q2**11*(33185930+53675604399*r**2
            +416906334294*r**4+2749900241669*r**6+23067957105849*r**8+82298109261192*r**10
            +231866817245891*r**12+445132998510696*r**14+445132998510696*r**16+231866817245891*r**18
            +82298109261192*r**20+23067957105849*r**22+2749900241669*r**24+416906334294*r**26
            +53675604399*r**28+33185930*r**30)+Q2**10*(-4692350920+54367994942*r**2
            +543009864240*r**4+6370884548090*r**6+55313707421840*r**8+300268628263086*r**10
            +1141287115662032*r**12+2738873031581210*r**14+3720202152232560*r**16
            +2738873031581210*r**18+1141287115662032*r**20+300268628263086*r**22+55313707421840*r**24
            +6370884548090*r**26+543009864240*r**28+54367994942*r**30-4692350920*r**32)
            +2*Q2**9*(1527607450+8073015406*r**2-123210404855*r**4-2396470118075*r**6
            -14968745373650*r**8-96709485382490*r**10-423863077959581*r**12-1247767571856305*r**14
            -2240623179153500*r**16-2240623179153500*r**18-1247767571856305*r**20
            -423863077959581*r**22-96709485382490*r**24-14968745373650*r**26-2396470118075*r**28
            -123210404855*r**30+8073015406*r**32+1527607450*r**34)+Q2**8*(319444960
            -40045027158*r**2-64631549388*r**4+2385319167040*r**6+9326237273100*r**8
            +54309672235080*r**10+26348768685668*r**12+36036454283328*r**14+363748468100220*r**16
            +607775049238300*r**18+363748468100220*r**20+36036454283328*r**22+26348768685668*r**24
            +54309672235080*r**26+9326237273100*r**28+2385319167040*r**30-64631549388*r**32
            -40045027158*r**34+319444960*r**36)+2*Q2**7*(-734816890+10015160246*r**2
            +146015775513*r**4+481411729031*r**6+1076037934355*r**8-4271128521975*r**10
            +162730414237459*r**12+538203839761537*r**14+1382646110422239*r**16+2235058426158485*r**18
            +2235058426158485*r**20+1382646110422239*r**22+538203839761537*r**24+162730414237459*r**26
            -4271128521975*r**28+1076037934355*r**30+481411729031*r**32+146015775513*r**34
            +10015160246*r**36-734816890*r**38)+2*Q2**6*(313421600+1914948941*r**2
            -101691699274*r**4-1381460491699*r**6-5631924466984*r**8-14938290522868*r**10
            -138041349316616*r**12-88141177709876*r**14-592618241670776*r**16-1033288061796466*r**18
            -1269279706191964*r**20-1033288061796466*r**22-592618241670776*r**24-88141177709876*r**26
            -138041349316616*r**28-14938290522868*r**30-5631924466984*r**32-1381460491699*r**34
            -101691699274*r**36+1914948941*r**38+313421600*r**40)+6*Q2**5*(31842420
            -1539135748*r**2-3155462165*r**4+287457661455*r**6+2190514577860*r**8
            +14937861341588*r**10+57985059388824*r**12+66415943298640*r**14+270560500458920*r**16
            +21643548977040*r**18-177367787748834*r**20-177367787748834*r**22+21643548977040*r**24
            +270560500458920*r**26+66415943298640*r**28+57985059388824*r**30+14937861341588*r**32
            +2190514577860*r**34+287457661455*r**36-3155462165*r**38-1539135748*r**40
            +31842420*r**42)-3*Q2**4*(81767600-1193912149*r**2-28276976640*r**4+11734132850*r**6
            +2145975705200*r**8+27167457498015*r**10+109388113557696*r**12+460851142560120*r**14
            +1087104054210000*r**16+606834863616950*r**18+392071361395280*r**20+899127408090156*r**22
            +392071361395280*r**24+606834863616950*r**26+1087104054210000*r**28+460851142560120*r**30
            +109388113557696*r**32+27167457498015*r**34+2145975705200*r**36+11734132850*r**38
            -28276976640*r**40-1193912149*r**42+81767600*r**44)+9*Q2**3*(4793090
            +71774853*r**2-3058935757*r**4-54847672450*r**6-79287385650*r**8+1254545789255*r**10
            +5432124864273*r**12+90581086701618*r**14+38743239992460*r**16+80396763810650*r**18
            +18227403813270*r**20+132199450054388*r**22+132199450054388*r**24+18227403813270*r**26
            +80396763810650*r**28+38743239992460*r**30+90581086701618*r**32+5432124864273*r**34
            +1254545789255*r**36-79287385650*r**38-54847672450*r**40-3058935757*r**42
            +71774853*r**44+4793090*r**46)+27*(-1+r**2)**2*(83552-1447843*r**2-50441298*r**4
            +54213807*r**6+9154483452*r**8+131446182267*r**10+744582511222*r**12
            +3901934238817*r**14+8012603786672*r**16-17771333998158*r**18+88394216002012*r**20
            +13157597111142*r**22-156582101451288*r**24+13157597111142*r**26+88394216002012*r**28
            -17771333998158*r**30+8012603786672*r**32+3901934238817*r**34+744582511222*r**36
            +131446182267*r**38+9154483452*r**40+54213807*r**42-50441298*r**44-1447843*r**46
            +83552*r**48)+9*Q2**2*(3416180-114939197*r**2-1048352216*r**4+29291929093*r**6
            +296609879560*r**8+2953696785625*r**10+13650980955848*r**12+23606292661839*r**14
            +226494647624268*r**16-206135647023010*r**18+207865351413520*r**20+286546664098738*r**22
            +41603119099504*r**24+286546664098738*r**26+207865351413520*r**28-206135647023010*r**30
            +226494647624268*r**32+23606292661839*r**34+13650980955848*r**36+2953696785625*r**38
            +296609879560*r**40+29291929093*r**42-1048352216*r**44-114939197*r**46
            +3416180*r**48)-54*Q2*(294231-6546448*r**2-138133943*r**4+1046471957*r**6
            +25102181627*r**8+308154584807*r**10+1411459381217*r**12+5661279716997*r**14
            +17297723055822*r**16-49616196894933*r**18+118356653970962*r**20+41021966469162*r**22
            -97888740551458*r**24-97888740551458*r**26+41021966469162*r**28+118356653970962*r**30
            -49616196894933*r**32+17297723055822*r**34+5661279716997*r**36+1411459381217*r**38
            +308154584807*r**40+25102181627*r**42+1046471957*r**44-138133943*r**46
            -6546448*r**48+294231*r**50))-294912*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(5936896*Q2**26-90491936*Q2**25*(1+r**2)+64*Q2**24*(9407875
            +19912102*r**2+9407875*r**4)-4*Q2**23*(564409465+1933660563*r**2+1933660563*r**4
            +564409465*r**6)+Q2**22*(5024388080+25981166798*r**2+40513363644*r**4
            +25981166798*r**6+5024388080*r**8)-4*Q2**21*(1462401040+12431298823*r**2
            +25638277333*r**4+25638277333*r**6+12431298823*r**8+1462401040*r**10)
            +Q2**20*(-92866960+41054776113*r**2+70399526100*r**4+48823191590*r**6
            +70399526100*r**8+41054776113*r**10-92866960*r**12)+Q2**19*(11183463950
            +39942747863*r**2+328600062495*r**4+1001296719500*r**6+1001296719500*r**8
            +328600062495*r**10+39942747863*r**12+11183463950*r**14)-Q2**18*(15149819860
            +152813497567*r**2+1092646386232*r**4+4031500723345*r**6+6068789619400*r**8
            +4031500723345*r**10+1092646386232*r**12+152813497567*r**14+15149819860*r**16)
            +2*Q2**17*(1536542565+85786858854*r**2+713740530162*r**4+3638700221834*r**6
            +7478223173025*r**8+7478223173025*r**10+3638700221834*r**12+713740530162*r**14
            +85786858854*r**16+1536542565*r**18)+Q2**16*(13899218880-34927866807*r**2
            -407584843632*r**4-5126777626832*r**6-13672834903232*r**8-17408953667538*r**10
            -13672834903232*r**12-5126777626832*r**14-407584843632*r**16-34927866807*r**18
            +13899218880*r**20)-2*Q2**15*(7943590800+70223209896*r**2+694657673985*r**4
            +2417520658075*r**6+8735831347885*r**8+21022670642767*r**10+21022670642767*r**12
            +8735831347885*r**14+2417520658075*r**16+694657673985*r**18+70223209896*r**20
            +7943590800*r**22)+4*Q2**14*(436875100+45970811217*r**2+512293632960*r**4
            +3563028985825*r**6+16025019449400*r**8+45668302269870*r**10+65121039887128*r**12
            +45668302269870*r**14+16025019449400*r**16+3563028985825*r**18+512293632960*r**20
            +45970811217*r**22+436875100*r**24)+2*Q2**13*(5169129620-36339641206*r**2
            -457114647921*r**4-6228033020965*r**6-35287132496050*r**8-135074079046140*r**10
            -260695523460634*r**12-260695523460634*r**14-135074079046140*r**16-35287132496050*r**18
            -6228033020965*r**20-457114647921*r**22-36339641206*r**24+5169129620*r**26)
            +2*Q2**12*(-4383602560-32023138081*r**2-240401855818*r**4+1009562683154*r**6
            +7353612940310*r**8+63099782983625*r**10+172241324935316*r**12+227938726899788*r**14
            +172241324935316*r**16+63099782983625*r**18+7353612940310*r**20+1009562683154*r**22
            -240401855818*r**24-32023138081*r**26-4383602560*r**28)+2*Q2**11*(33185930
            +53675604399*r**2+416906334294*r**4+2749900241669*r**6+23067957105849*r**8
            +82298109261192*r**10+231866817245891*r**12+445132998510696*r**14+445132998510696*r**16
            +231866817245891*r**18+82298109261192*r**20+23067957105849*r**22+2749900241669*r**24
            +416906334294*r**26+53675604399*r**28+33185930*r**30)+2*Q2**10*(2346175460
            -27183997471*r**2-271504932120*r**4-3185442274045*r**6-27656853710920*r**8
            -150134314131543*r**10-570643557831016*r**12-1369436515790605*r**14-1860101076116280*r**16
            -1369436515790605*r**18-570643557831016*r**20-150134314131543*r**22-27656853710920*r**24
            -3185442274045*r**26-271504932120*r**28-27183997471*r**30+2346175460*r**32)
            +2*Q2**9*(-1527607450-8073015406*r**2+123210404855*r**4+2396470118075*r**6
            +14968745373650*r**8+96709485382490*r**10+423863077959581*r**12+1247767571856305*r**14
            +2240623179153500*r**16+2240623179153500*r**18+1247767571856305*r**20
            +423863077959581*r**22+96709485382490*r**24+14968745373650*r**26+2396470118075*r**28
            +123210404855*r**30-8073015406*r**32-1527607450*r**34)-2*Q2**8*(159722480
            -20022513579*r**2-32315774694*r**4+1192659583520*r**6+4663118636550*r**8
            +27154836117540*r**10+13174384342834*r**12+18018227141664*r**14+181874234050110*r**16
            +303887524619150*r**18+181874234050110*r**20+18018227141664*r**22+13174384342834*r**24
            +27154836117540*r**26+4663118636550*r**28+1192659583520*r**30-32315774694*r**32
            -20022513579*r**34+159722480*r**36)+2*Q2**7*(734816890-10015160246*r**2
            -146015775513*r**4-481411729031*r**6-1076037934355*r**8+4271128521975*r**10
            -162730414237459*r**12-538203839761537*r**14-1382646110422239*r**16-2235058426158485*r**18
            -2235058426158485*r**20-1382646110422239*r**22-538203839761537*r**24-162730414237459*r**26
            +4271128521975*r**28-1076037934355*r**30-481411729031*r**32-146015775513*r**34
            -10015160246*r**36+734816890*r**38)+2*Q2**6*(-313421600-1914948941*r**2
            +101691699274*r**4+1381460491699*r**6+5631924466984*r**8+14938290522868*r**10
            +138041349316616*r**12+88141177709876*r**14+592618241670776*r**16+1033288061796466*r**18
            +1269279706191964*r**20+1033288061796466*r**22+592618241670776*r**24+88141177709876*r**26
            +138041349316616*r**28+14938290522868*r**30+5631924466984*r**32+1381460491699*r**34
            +101691699274*r**36-1914948941*r**38-313421600*r**40)-6*Q2**5*(31842420
            -1539135748*r**2-3155462165*r**4+287457661455*r**6+2190514577860*r**8
            +14937861341588*r**10+57985059388824*r**12+66415943298640*r**14+270560500458920*r**16
            +21643548977040*r**18-177367787748834*r**20-177367787748834*r**22+21643548977040*r**24
            +270560500458920*r**26+66415943298640*r**28+57985059388824*r**30+14937861341588*r**32
            +2190514577860*r**34+287457661455*r**36-3155462165*r**38-1539135748*r**40
            +31842420*r**42)+3*Q2**4*(81767600-1193912149*r**2-28276976640*r**4+11734132850*r**6
            +2145975705200*r**8+27167457498015*r**10+109388113557696*r**12+460851142560120*r**14
            +1087104054210000*r**16+606834863616950*r**18+392071361395280*r**20+899127408090156*r**22
            +392071361395280*r**24+606834863616950*r**26+1087104054210000*r**28+460851142560120*r**30
            +109388113557696*r**32+27167457498015*r**34+2145975705200*r**36+11734132850*r**38
            -28276976640*r**40-1193912149*r**42+81767600*r**44)-9*Q2**3*(4793090
            +71774853*r**2-3058935757*r**4-54847672450*r**6-79287385650*r**8+1254545789255*r**10
            +5432124864273*r**12+90581086701618*r**14+38743239992460*r**16+80396763810650*r**18
            +18227403813270*r**20+132199450054388*r**22+132199450054388*r**24+18227403813270*r**26
            +80396763810650*r**28+38743239992460*r**30+90581086701618*r**32+5432124864273*r**34
            +1254545789255*r**36-79287385650*r**38-54847672450*r**40-3058935757*r**42
            +71774853*r**44+4793090*r**46)-27*(-1+r**2)**2*(83552-1447843*r**2-50441298*r**4
            +54213807*r**6+9154483452*r**8+131446182267*r**10+744582511222*r**12
            +3901934238817*r**14+8012603786672*r**16-17771333998158*r**18+88394216002012*r**20
            +13157597111142*r**22-156582101451288*r**24+13157597111142*r**26+88394216002012*r**28
            -17771333998158*r**30+8012603786672*r**32+3901934238817*r**34+744582511222*r**36
            +131446182267*r**38+9154483452*r**40+54213807*r**42-50441298*r**44-1447843*r**46
            +83552*r**48)-9*Q2**2*(3416180-114939197*r**2-1048352216*r**4+29291929093*r**6
            +296609879560*r**8+2953696785625*r**10+13650980955848*r**12+23606292661839*r**14
            +226494647624268*r**16-206135647023010*r**18+207865351413520*r**20+286546664098738*r**22
            +41603119099504*r**24+286546664098738*r**26+207865351413520*r**28-206135647023010*r**30
            +226494647624268*r**32+23606292661839*r**34+13650980955848*r**36+2953696785625*r**38
            +296609879560*r**40+29291929093*r**42-1048352216*r**44-114939197*r**46
            +3416180*r**48)+54*Q2*(294231-6546448*r**2-138133943*r**4+1046471957*r**6
            +25102181627*r**8+308154584807*r**10+1411459381217*r**12+5661279716997*r**14
            +17297723055822*r**16-49616196894933*r**18+118356653970962*r**20+41021966469162*r**22
            -97888740551458*r**24-97888740551458*r**26+41021966469162*r**28+118356653970962*r**30
            -49616196894933*r**32+17297723055822*r**34+5661279716997*r**36+1411459381217*r**38
            +308154584807*r**40+25102181627*r**42+1046471957*r**44-138133943*r**46
            -6546448*r**48+294231*r**50))*sqrtq2)+logq2*(-24576*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(54928*Q2**25
            -968654*Q2**24*(1+r**2)+16*Q2**23*(441871+1024561*r**2+441871*r**4)
            -2*Q2**22*(14013332+54831483*r**2+54831483*r**4+14013332*r**6)+Q2**21*(63345386
            +375963554*r**2+577025968*r**4+375963554*r**6+63345386*r**8)-Q2**20*(67308514
            +640656985*r**2+984448233*r**4+984448233*r**6+640656985*r**8+67308514*r**10)
            -Q2**19*(32315059-126416571*r**2+2341638845*r**4+5599041750*r**6+2341638845*r**8
            -126416571*r**10+32315059*r**12)+Q2**18*(196731656+1706405381*r**2+14501550171*r**4
            +42442673840*r**6+42442673840*r**8+14501550171*r**10+1706405381*r**12
            +196731656*r**14)-Q2**17*(206917669+3343276876*r**2+28668575326*r**4
            +114913112104*r**6+172710534370*r**8+114913112104*r**10+28668575326*r**12
            +3343276876*r**14+206917669*r**16)+Q2**16*(-64983894+2016681864*r**2
            +20790793818*r**4+138519895894*r**6+269885591166*r**8+269885591166*r**10
            +138519895894*r**12+20790793818*r**14+2016681864*r**16-64983894*r**18)
            +2*Q2**15*(170586738+970268280*r**2+9214848931*r**4+5501208626*r**6+59531199215*r**8
            +142014548404*r**10+59531199215*r**12+5501208626*r**14+9214848931*r**16
            +970268280*r**18+170586738*r**20)-4*Q2**14*(57653256+1032570141*r**2
            +13224373435*r**4+68856023850*r**6+291134462750*r**8+697740246984*r**10
            +697740246984*r**12+291134462750*r**14+68856023850*r**16+13224373435*r**18
            +1032570141*r**20+57653256*r**22)+2*Q2**13*(-76620292+1010406288*r**2
            +20381606923*r**4+189672062340*r**6+925000865380*r**8+2978900660812*r**10
            +4338146258922*r**12+2978900660812*r**14+925000865380*r**16+189672062340*r**18
            +20381606923*r**20+1010406288*r**22-76620292*r**24)+2*Q2**12*(152413058
            +705041987*r**2+2117930437*r**4-89031308827*r**6-435580421785*r**8-2332848533108*r**10
            -4601956616002*r**12-4601956616002*r**14-2332848533108*r**16-435580421785*r**18
            -89031308827*r**20+2117930437*r**22+705041987*r**24+152413058*r**26)
            -2*Q2**11*(40577317+1209580633*r**2+16700551206*r**4+60666122628*r**6
            +548198193052*r**8+1356724724463*r**10+3520697244537*r**12+5611433758504*r**14
            +3520697244537*r**16+1356724724463*r**18+548198193052*r**20+60666122628*r**22
            +16700551206*r**24+1209580633*r**26+40577317*r**28)+2*Q2**10*(-73663312
            +573679365*r**2+13751454331*r**4+121860027396*r**6+923755283260*r**8
            +4205311059841*r**10+13612819655775*r**12+27610470963184*r**14+27610470963184*r**16
            +13612819655775*r**18+4205311059841*r**20+923755283260*r**22+121860027396*r**24
            +13751454331*r**26+573679365*r**28-73663312*r**30)+2*Q2**9*(60558233
            +136488578*r**2-2364141555*r**4-85827890350*r**6-461297482870*r**8-2958778203458*r**10
            -11068952922973*r**12-30832150405810*r**14-44258461182950*r**16-30832150405810*r**18
            -11068952922973*r**20-2958778203458*r**22-461297482870*r**24-85827890350*r**26
            -2364141555*r**28+136488578*r**30+60558233*r**32)+2*Q2**8*(6265103-393924787*r**2
            -6000789412*r**4+27792089060*r**6+5428682030*r**8+331946644482*r**10
            -1020596697348*r**12+3413225910212*r**14+12466539123060*r**16+12466539123060*r**18
            +3413225910212*r**20-1020596697348*r**22+331946644482*r**24+5428682030*r**26
            +27792089060*r**28-6000789412*r**30-393924787*r**32+6265103*r**34)+2*Q2**7*(
            -27392222+260333772*r**2+6381379797*r**4+11403800638*r**6+47985731925*r**8
            +319762656772*r**10+5755941058623*r**12+12557490473698*r**14+22353006084277*r**16
            +29972058081440*r**18+22353006084277*r**20+12557490473698*r**22+5755941058623*r**24
            +319762656772*r**26+47985731925*r**28+11403800638*r**30+6381379797*r**32
            +260333772*r**34-27392222*r**36)+2*Q2**6*(8857828-6915263*r**2-1622897251*r**4
            -32002270568*r**6-63304013492*r**8-252699972048*r**10-3315946413352*r**12
            -2736210667324*r**14-10844596378892*r**16-16999068897638*r**18-16999068897638*r**20
            -10844596378892*r**22-2736210667324*r**24-3315946413352*r**26-252699972048*r**28
            -63304013492*r**30-32002270568*r**32-1622897251*r**34-6915263*r**36+8857828*r**38)
            +2*Q2**5*(4639243-110066225*r**2-1784707239*r**4+31113936171*r**6+154613151355*r**8
            +912995497384*r**10+3803646597140*r**12+3107894933744*r**14+12790690270074*r**16
            -8316477626770*r**18-6678509569754*r**20-8316477626770*r**22+12790690270074*r**24
            +3107894933744*r**26+3803646597140*r**28+912995497384*r**30+154613151355*r**32
            +31113936171*r**34-1784707239*r**36-110066225*r**38+4639243*r**40)-Q2**4*(7410354
            -128680491*r**2-3013940695*r**4+23180404025*r**6+244111583165*r**8+2077950650094*r**10
            +8252174345484*r**12+24789733107180*r**14+56274613870600*r**16-11459777742650*r**18
            +28260174912934*r**20+28260174912934*r**22-11459777742650*r**24+56274613870600*r**26
            +24789733107180*r**28+8252174345484*r**30+2077950650094*r**32+244111583165*r**34
            +23180404025*r**36-3013940695*r**38-128680491*r**40+7410354*r**42)+3*Q2**3*(176887
            +1335797*r**2-94091293*r**4-3631692630*r**6+4626080655*r**8+147471900497*r**10
            +347359208707*r**12+5385714139832*r**14+1048971745990*r**16-3548974552390*r**18
            +2016207370702*r**20+14417599154492*r**22+2016207370702*r**24-3548974552390*r**26
            +1048971745990*r**28+5385714139832*r**30+347359208707*r**32+147471900497*r**34
            +4626080655*r**36-3631692630*r**38-94091293*r**40+1335797*r**42+176887*r**44)
            +18*(-1+r**2)**2*(2611-93888*r**2-2501328*r**4+47432661*r**6+407674425*r**8
            +5632553856*r**10+26760652592*r**12+66231548847*r**14+419943421006*r**16
            -1746620138800*r**18+5378971673616*r**20-3890098625598*r**22-3890098625598*r**24
            +5378971673616*r**26-1746620138800*r**28+419943421006*r**30+66231548847*r**32
            +26760652592*r**34+5632553856*r**36+407674425*r**38+47432661*r**40-2501328*r**42
            -93888*r**44+2611*r**46)+3*Q2**2*(341512-10869517*r**2-199399267*r**4
            +5139744632*r**6+24359394280*r**8+210833941217*r**10+1162680717103*r**12
            -187912687272*r**14+16029394144352*r**16-23398479700530*r**18+16401143190162*r**20
            +9740481583328*r**22+9740481583328*r**24+16401143190162*r**26-23398479700530*r**28
            +16029394144352*r**30-187912687272*r**32+1162680717103*r**34+210833941217*r**36
            +24359394280*r**38+5139744632*r**40-199399267*r**42-10869517*r**44+341512*r**46)
            -9*Q2*(43821-1469736*r**2-31693292*r**4+700752284*r**6+4051212746*r**8
            +49206863516*r**10+218737505924*r**12+196712600968*r**14+3415538296259*r**16
            -12581028195584*r**18+25667258262376*r**20-6174140072856*r**22-17413630612852*r**24
            -6174140072856*r**26+25667258262376*r**28-12581028195584*r**30+3415538296259*r**32
            +196712600968*r**34+218737505924*r**36+49206863516*r**38+4051212746*r**40
            +700752284*r**42-31693292*r**44-1469736*r**46+43821*r**48))+24576*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(439424*Q2**30-8573152*Q2**29*(1+r**2)
            +2*Q2**28*(35544649+80541138*r**2+35544649*r**4)-16*Q2**27*(20607067
            +77892741*r**2+77892741*r**4+20607067*r**6)+Q2**26*(917476508+5202948494*r**2
            +8210764516*r**4+5202948494*r**6+917476508*r**8)-2*Q2**25*(709057163
            +6091789506*r**2+12136324271*r**4+12136324271*r**6+6091789506*r**8+709057163*r**10)
            +Q2**24*(473746560+12212747385*r**2+12342121064*r**4-4784127778*r**6
            +12342121064*r**8+12212747385*r**10+473746560*r**12)+Q2**23*(2670823185
            +13711617420*r**2+142738323614*r**4+453826997909*r**6+453826997909*r**8
            +142738323614*r**10+13711617420*r**12+2670823185*r**14)-Q2**22*(5195321340
            +61856438595*r**2+491689391046*r**4+1913645899597*r**6+2909141612956*r**8
            +1913645899597*r**10+491689391046*r**12+61856438595*r**14+5195321340*r**16)
            +Q2**21*(2070707135+76853348505*r**2+703437317494*r**4+3814337145294*r**6
            +7910562740372*r**8+7910562740372*r**10+3814337145294*r**12+703437317494*r**14
            +76853348505*r**16+2070707135*r**18)+Q2**20*(5873388320-5821572715*r**2
            -194816500036*r**4-3051406403928*r**6-8159305532364*r**8-10096359740506*r**10
            -8159305532364*r**12-3051406403928*r**14-194816500036*r**16-5821572715*r**18
            +5873388320*r**20)-Q2**19*(8934737845+99947028270*r**2+945232681006*r**4
            +3156091068933*r**6+11383661376726*r**8+29948650370004*r**10+29948650370004*r**12
            +11383661376726*r**14+3156091068933*r**16+945232681006*r**18+99947028270*r**20
            +8934737845*r**22)+Q2**18*(993236780+114061378185*r**2+1537431060214*r**4
            +11123894357529*r**6+49232280466324*r**8+147736731098590*r**10+214027565386132*r**12
            +147736731098590*r**14+49232280466324*r**16+11123894357529*r**18+1537431060214*r**20
            +114061378185*r**22+993236780*r**24)+Q2**17*(8769705455-7830359935*r**2
            -675135958956*r**4-11637312711192*r**6-64950970049121*r**8-260142074233391*r**10
            -509673868212188*r**12-509673868212188*r**14-260142074233391*r**16-64950970049121*r**18
            -11637312711192*r**20-675135958956*r**22-7830359935*r**24+8769705455*r**26)
            -2*Q2**16*(3666403685+47526465480*r**2+414095693843*r**4-756205233972*r**6
            -9193293368111*r**8-80105306720544*r**10-220554113611241*r**12-289758041566760*r**14
            -220554113611241*r**16-80105306720544*r**18-9193293368111*r**20-756205233972*r**22
            +414095693843*r**24+47526465480*r**26+3666403685*r**28)+2*Q2**15*(-1258609875
            +43155600240*r**2+682768254582*r**4+4943596714001*r**6+29209956014983*r**8
            +97780445041070*r**10+251662591372796*r**12+511345846096811*r**14+511345846096811*r**16
            +251662591372796*r**18+97780445041070*r**20+29209956014983*r**22+4943596714001*r**24
            +682768254582*r**26+43155600240*r**28-1258609875*r**30)+2*Q2**14*(3459465660
            -1656804615*r**2-290101297558*r**4-5742573697429*r**6-41818022881828*r**8
            -242099663170399*r**10-869284546627354*r**12-2182898020888837*r**14-3018507430441936*r**16
            -2182898020888837*r**18-869284546627354*r**20-242099663170399*r**22-41818022881828*r**24
            -5742573697429*r**26-290101297558*r**28-1656804615*r**30+3459465660*r**32)
            +2*Q2**13*(-1034164965-26093721855*r**2-225359414778*r**4+2008537106942*r**6
            +19024933775162*r**8+191718409982798*r**10+875316874530002*r**12+2945395857139274*r**14
            +5471656104199868*r**16+5471656104199868*r**18+2945395857139274*r**20
            +875316874530002*r**22+191718409982798*r**24+19024933775162*r**26+2008537106942*r**28
            -225359414778*r**30-26093721855*r**32-1034164965*r**34)-2*Q2**12*(1506986615
            -20981774655*r**2-366474007477*r**4-1632966149964*r**6-7063431076712*r**8
            +15209210557660*r**10+108879672404560*r**12+1050338867405644*r**14+2980767817062358*r**16
            +3981135233305542*r**18+2980767817062358*r**20+1050338867405644*r**22
            +108879672404560*r**24+15209210557660*r**26-7063431076712*r**28-1632966149964*r**30
            -366474007477*r**32-20981774655*r**34+1506986615*r**36)+2*Q2**11*(1209060235
            -849762170*r**2-149262323158*r**4-2576530079493*r**6-14060202772164*r**8
            -101738136053548*r**10-619864767428980*r**12-2055848594686948*r**14-4986668809384414*r**16
            -8639734144999440*r**18-8639734144999440*r**20-4986668809384414*r**22
            -2055848594686948*r**24-619864767428980*r**26-101738136053548*r**28-14060202772164*r**30
            -2576530079493*r**32-149262323158*r**34-849762170*r**36+1209060235*r**38)
            +4*Q2**10*(93943745-5391610320*r**2-46142387464*r**4+821659963758*r**6
            +5223924264189*r**8+53307536837094*r**10+334179331983352*r**12+1576632876196810*r**14
            +5083522936160386*r**16+11127911325178674*r**18+14767093861589152*r**20
            +11127911325178674*r**22+5083522936160386*r**24+1576632876196810*r**26
            +334179331983352*r**28+53307536837094*r**30+5223924264189*r**32+821659963758*r**34
            -46142387464*r**36-5391610320*r**38+93943745*r**40)-2*Q2**9*(554826980
            -7485295995*r**2-133068336997*r**4+244682938999*r**6+6005313896633*r**8
            +67419833220716*r**10+325461217840056*r**12+1810108029452512*r**14+6250294669142776*r**16
            +17013159109607802*r**18+30080845447308118*r**20+30080845447308118*r**22
            +17013159109607802*r**24+6250294669142776*r**26+1810108029452512*r**28
            +325461217840056*r**30+67419833220716*r**32+6005313896633*r**34+244682938999*r**36
            -133068336997*r**38-7485295995*r**40+554826980*r**42)+Q2**8*(254966540
            +1236759305*r**2-70562537476*r**4-1541350533866*r**6+688071957244*r**8
            +49859077697957*r**10+167640550295916*r**12+733761736930344*r**14-1592608741842104*r**16
            -2275002673420974*r**18+1681999736287560*r**20+5130698904863108*r**22
            +1681999736287560*r**24-2275002673420974*r**26-1592608741842104*r**28
            +733761736930344*r**30+167640550295916*r**32+49859077697957*r**34+688071957244*r**36
            -1541350533866*r**38-70562537476*r**40+1236759305*r**42+254966540*r**44)
            +Q2**7*(257374565-6819810780*r**2-67735950826*r**4+1689711305593*r**6
            +7989204349589*r**8+30886124210326*r**10+52865484481788*r**12+209624231648145*r**14
            +5875855652725290*r**16+12647320766702736*r**18+30755251638163876*r**20
            +44502916453759698*r**22+44502916453759698*r**24+30755251638163876*r**26
            +12647320766702736*r**28+5875855652725290*r**30+209624231648145*r**32
            +52865484481788*r**34+30886124210326*r**36+7989204349589*r**38+1689711305593*r**40
            -67735950826*r**42-6819810780*r**44+257374565*r**46)-Q2**6*(145773660
            -2703426945*r**2-54127275634*r**4+440200963881*r**6+6813517841788*r**8
            +69490051440685*r**10+239365857486102*r**12+941345441043419*r**14+4563885491977300*r**16
            +2836216089108054*r**18+16661192658084188*r**20+17061051493383162*r**22
            +17524460567200680*r**24+17061051493383162*r**26+16661192658084188*r**28
            +2836216089108054*r**30+4563885491977300*r**32+941345441043419*r**34+239365857486102*r**36
            +69490051440685*r**38+6813517841788*r**40+440200963881*r**42-54127275634*r**44
            -2703426945*r**46+145773660*r**48)-3*Q2**5*(5412343-315340055*r**2+1031849142*r**4
            +156981953966*r**6-427353981952*r**8-15625374624744*r**10-97554742491338*r**12
            -585919343773922*r**14-1805670219049245*r**16-3419343148022819*r**18-8237931274888724*r**20
            -945902788444836*r**22+1988611549402184*r**24+1988611549402184*r**26-945902788444836*r**28
            -8237931274888724*r**30-3419343148022819*r**32-1805670219049245*r**34
            -585919343773922*r**36-97554742491338*r**38-15625374624744*r**40-427353981952*r**42
            +156981953966*r**44+1031849142*r**46-315340055*r**48+5412343*r**50)-54*(
            -1+r**4)**2*(2611-133053*r**2-1299277*r**4+92539448*r**6-112480402*r**8
            -4386153122*r**10-86696902802*r**12-756840756392*r**14-2344406929667*r**16
            -11876203277267*r**18+1332694288253*r**20+77840920357488*r**22-508020350180412*r**24
            +856477749849188*r**26-508020350180412*r**28+77840920357488*r**30+1332694288253*r**32
            -11876203277267*r**34-2344406929667*r**36-756840756392*r**38-86696902802*r**40
            -4386153122*r**42-112480402*r**44+92539448*r**46-1299277*r**48-133053*r**50
            +2611*r**52)+3*Q2**4*(10590484-338813741*r**2-3607406312*r**4+130604170064*r**6
            +384842125028*r**8-1921569749842*r**10-49453227442412*r**12-423328852910192*r**14
            -1430489476221056*r**16-6149717443283747*r**18-8568644416690412*r**20
            -4902521013385952*r**22-3396872968724152*r**24-9906307215715516*r**26
            -3396872968724152*r**28-4902521013385952*r**30-8568644416690412*r**32
            -6149717443283747*r**34-1430489476221056*r**36-423328852910192*r**38-49453227442412*r**40
            -1921569749842*r**42+384842125028*r**44+130604170064*r**46-3607406312*r**48
            -338813741*r**50+10590484*r**52)-9*Q2**3*(615097-15605586*r**2-423285434*r**4
            +3859764009*r**6+88100984714*r**8+1305168753348*r**10+1489314291108*r**12
            -1584922636662*r**14-16238266875641*r**16-817853094803926*r**18+1004531651549858*r**20
            -2057777538829897*r**22+777000962830668*r**24-392765449551656*r**26-392765449551656*r**28
            +777000962830668*r**30-2057777538829897*r**32+1004531651549858*r**34-817853094803926*r**36
            -16238266875641*r**38-1584922636662*r**40+1489314291108*r**42+1305168753348*r**44
            +88100984714*r**46+3859764009*r**48-423285434*r**50-15605586*r**52+615097*r**54)
            -9*Q2**2*(289292-13706609*r**2-45992470*r**4+8384372615*r**6-24700802396*r**8
            -915788744498*r**10-6264753812924*r**12-53282867581714*r**14-184841526583348*r**16
            -357161128510791*r**18-2304095011239498*r**20+3665334636741521*r**22-5421525512647804*r**24
            -2148997893660188*r**26+3026275227757624*r**28-2148997893660188*r**30
            -5421525512647804*r**32+3665334636741521*r**34-2304095011239498*r**36
            -357161128510791*r**38-184841526583348*r**40-53282867581714*r**42-6264753812924*r**44
            -915788744498*r**46-24700802396*r**48+8384372615*r**50-45992470*r**52
            -13706609*r**54+289292*r**56)+27*Q2*(43821-2060297*r**2-16902496*r**4
            +1299502380*r**6-1562692643*r**8-85699263377*r**10-1017773552332*r**12
            -9238104726012*r**14-30607405490667*r**16-107769792008657*r**18-228932092263652*r**20
            +933754376754648*r**22-2581418815380867*r**24+494256736968143*r**26+1029413539072008*r**28
            +1029413539072008*r**30+494256736968143*r**32-2581418815380867*r**34+933754376754648*r**36
            -228932092263652*r**38-107769792008657*r**40-30607405490667*r**42-9238104726012*r**44
            -1017773552332*r**46-85699263377*r**48-1562692643*r**50+1299502380*r**52
            -16902496*r**54-2060297*r**56+43821*r**58))*sqrtq2))*math.log(mu0))/(630000*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2+630000*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2+logq2**8*(60949905408000000*r**36*(1
            +r**2)**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+60949905408000000*r**36*(1
            +r**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2*(-90720000*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4
            -Q2**3*(1+r**2)-2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4
            +r**6)+4*(1-9*r**2-44*r**4-9*r**6+r**8))-90720000*(-Q2+(-1+r)**2)**3*r**8*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4-Q2**3*(1+r**2)
            -2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4+r**6)+4*(1-9*r**2
            -44*r**4-9*r**6+r**8))*sqrtq2)+logq2**7*(-1354442342400000*r**32*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))-1354442342400000*r**32*(1+r**2)*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))*sqrtq2)+logq2**3*(-21772800000*(-Q2+(-1+r)**2)**3*r**16*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)
            -Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2+683*r**4+169*r**6)
            +2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)+6*Q2**3*(31+230*r**2
            +159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4
            +8368*r**6+6523*r**8+1184*r**10-131*r**12)-9*Q2*(13+5*r**2-1493*r**4
            -5245*r**6-5245*r**8-1493*r**10+5*r**12+13*r**14)+36*(4-67*r**2-28*r**4
            +2331*r**6+5600*r**8+2331*r**10-28*r**12-67*r**14+4*r**16))-21772800000*(
            -Q2+(-1+r)**2)**3*r**16*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)-Q2**6*(333+410*r**2+333*r**4)
            -Q2**5*(169+683*r**2+683*r**4+169*r**6)+2*Q2**4*(275-725*r**2-3408*r**4
            -725*r**6+275*r**8)+6*Q2**3*(31+230*r**2+159*r**4+159*r**6+230*r**8
            +31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4+8368*r**6+6523*r**8+1184*r**10
            -131*r**12)-9*Q2*(13+5*r**2-1493*r**4-5245*r**6-5245*r**8-1493*r**10
            +5*r**12+13*r**14)+36*(4-67*r**2-28*r**4+2331*r**6+5600*r**8+2331*r**10
            -28*r**12-67*r**14+4*r**16))*sqrtq2)+logq2**2*(5443200000*(-Q2+(-1
            +r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8
            -4*Q2**7*(1+r**2)-Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4
            +5*r**6)+Q2**4*(85-226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1
            -54*r**2-143*r**4-143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4
            +3168*r**6+2871*r**8+468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4
            -2833*r**6-2833*r**8-565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4
            +4368*r**6+11718*r**8+4368*r**10-56*r**12-96*r**14+5*r**16))+5443200000*(
            -Q2+(-1+r)**2)**3*r**12*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8
            -4*Q2**7*(1+r**2)-Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4
            +5*r**6)+Q2**4*(85-226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1
            -54*r**2-143*r**4-143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4
            +3168*r**6+2871*r**8+468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4
            -2833*r**6-2833*r**8-565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4
            +4368*r**6+11718*r**8+4368*r**10-56*r**12-96*r**14+5*r**16))*sqrtq2)
            +logq2**5*(-1881169920000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1
            +r**2)-Q2**6*(219+310*r**2+219*r**4)-Q2**5*(977+2179*r**2+2179*r**4
            +977*r**6)+Q2**4*(590-2090*r**2-6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243
            +10*r**2-2073*r**4-2073*r**6+10*r**8+243*r**10)+Q2**2*(-879+8076*r**2
            +41127*r**4+61272*r**6+41127*r**8+8076*r**10-879*r**12)+Q2*(-741+3075*r**2
            +31341*r**4+67125*r**6+67125*r**8+31341*r**10+3075*r**12-741*r**14)
            +12*(41-573*r**2+28*r**4+12789*r**6+25830*r**8+12789*r**10+28*r**12
            -573*r**14+41*r**16))-1881169920000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)-Q2**5*(977
            +2179*r**2+2179*r**4+977*r**6)+Q2**4*(590-2090*r**2-6768*r**4-2090*r**6
            +590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4-2073*r**6+10*r**8+243*r**10)
            +Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6+41127*r**8+8076*r**10
            -879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6+67125*r**8+31341*r**10
            +3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4+12789*r**6+25830*r**8
            +12789*r**10+28*r**12-573*r**14+41*r**16))*sqrtq2)+logq2**4*(391910400000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219
            +310*r**2+219*r**4)-24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415
            -1180*r**2-4598*r**4-1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4
            -677*r**6+155*r**8+102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6
            +18377*r**8+3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6
            -3030*r**8-1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4
            +24556*r**6+53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))+391910400000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2
            +219*r**4)-24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415-1180*r**2
            -4598*r**4-1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4-677*r**6
            +155*r**8+102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6+18377*r**8
            +3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8
            -1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6
            +53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))*sqrtq2)+logq2**6*(7524679680000*r**28*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(16*Q2**8+332*Q2**7*(1
            +r**2)+Q2**6*(153+370*r**2+153*r**4)-Q2**5*(2011+4817*r**2+4817*r**4
            +2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4-2410*r**6+295*r**8)+6*Q2**3*(559
            -310*r**2-4869*r**4-4869*r**6-310*r**8+559*r**10)-3*Q2**2*(479-4496*r**2
            -22867*r**4-35272*r**6-22867*r**8-4496*r**10+479*r**12)-9*Q2*(187
            -865*r**2-5807*r**4-10315*r**6-10315*r**8-5807*r**10-865*r**12+187*r**14)
            +9*(109-1432*r**2+392*r**4+26376*r**6+49910*r**8+26376*r**10+392*r**12
            -1432*r**14+109*r**16))+7524679680000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(16*Q2**8+332*Q2**7*(1+r**2)+Q2**6*(153+370*r**2+153*r**4)
            -Q2**5*(2011+4817*r**2+4817*r**4+2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4
            -2410*r**6+295*r**8)+6*Q2**3*(559-310*r**2-4869*r**4-4869*r**6-310*r**8
            +559*r**10)-3*Q2**2*(479-4496*r**2-22867*r**4-35272*r**6-22867*r**8
            -4496*r**10+479*r**12)-9*Q2*(187-865*r**2-5807*r**4-10315*r**6-10315*r**8
            -5807*r**10-865*r**12+187*r**14)+9*(109-1432*r**2+392*r**4+26376*r**6
            +49910*r**8+26376*r**10+392*r**12-1432*r**14+109*r**16))*sqrtq2))+((16*r**2*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(92*Q2**18+60*Q2**17*(1+r**2)+4*Q2**16*(
            -1519+3228*r**2+1499*r**4)-Q2**15*(-34969+160589*r**2+1046341*r**4
            +72623*r**6)+Q2**14*(-94735+776500*r**2+10808350*r**4+8852676*r**6+299825*r**8)
            -Q2**13*(-135799+1877655*r**2+43289452*r**4+82368756*r**6+29535579*r**8
            +576101*r**10)+Q2**12*(-76245+2114840*r**2+79598981*r**4+277504064*r**6
            +239240429*r**8+38482536*r**10+381315*r**12)+Q2**11*(-56927+50819*r**2
            -41680119*r**4-387002253*r**6-530987613*r**8-237317447*r**10+20511955*r**12
            +493297*r**14)-Q2**10*(-101673+2723028*r**2+87830460*r**4-63891428*r**6
            +60797850*r**8+280696044*r**10+261376636*r**12+122446116*r**14+1074711*r**16)
            +Q2**9*(9295+1716825*r**2+153045270*r**4+436523258*r**6+1396512740*r**8
            +3429691340*r**10+2103692810*r**12+851014790*r**14+112792173*r**16+341275*r**18)
            +Q2**8*(-120549+2320560*r**2-37227201*r**4-528837568*r**6-1065281922*r**8
            -4841499376*r**10-6297176130*r**12-1670586336*r**14-590459833*r**16+54890208*r**18
            +889251*r**20)-Q2**7*(-89635+3712335*r**2+105058067*r**4-340834967*r**6
            +511955778*r**8+1046459542*r**10+777200710*r**12-778030638*r**14+1950721473*r**16
            +357891963*r**18+168225927*r**20+994085*r**22)+Q2**6*(10907+875276*r**2
            +89263870*r**4-158583284*r**6+193046501*r**8+5395152088*r**10+19515767172*r**12
            +17554642744*r**14+8434570341*r**16+3289645276*r**18+764189182*r**20
            +76673404*r**22+70043*r**24)+Q2**5*(-48803+1674323*r**2+9932888*r**4
            -178260472*r**6+848638885*r**8-1763653493*r**10-16900419912*r**12-39203740728*r**14
            -12693116089*r**16-8386679415*r**18+37241456*r**20-323302736*r**22+63392055*r**24
            +508441*r**26)-Q2**4*(-21065+1300200*r**2+41907245*r**4-417821216*r**6
            +224047815*r**8+975854760*r**10-701297035*r**12-14255612160*r**14-29566065683*r**16
            +20178975160*r**18-714459345*r**20+2445366560*r**22+131177365*r**24+76375224*r**26
            +316975*r**28)+Q2**3*(5283-7655*r**2+13345903*r**4-193648251*r**6-570114849*r**8
            -152368323*r**10-3295991205*r**12-11620863591*r**14+4354598937*r**16
            -12379537797*r**18+26031776957*r**20+3845099135*r**22+1061850213*r**24
            +170056239*r**26+14144121*r**28-9117*r**30)+Q2**2*(-7825+391060*r**2
            +5478336*r**4-108011956*r**6+403896324*r**8+279101876*r**10+2821795840*r**12
            +18885157708*r**14+18283866522*r**16+6908662492*r**18-12997085632*r**20
            +3267499140*r**22-3037842044*r**24+600798684*r**26-57506816*r**28+15657956*r**30
            +84335*r**32)-3*Q2*(-907+59419*r**2+1384374*r**4-40213254*r**6+35892346*r**8
            -134272058*r**10-2180654706*r**12+53763714*r**14-2428061692*r**16-7896633092*r**18
            +23365152962*r**20-15426377970*r**22+4793498550*r**24-336016054*r**26
            +191370746*r**28-2026122*r**30+3122007*r**32+11737*r**34)+3*(-113+8848*r**2
            +237471*r**4-9760736*r**6+6254580*r**8-82272976*r**10-1391081884*r**12
            +1374664192*r**14-13813606422*r**16+43249613040*r**18-52589566534*r**20
            +29995134624*r**22-8274408172*r**24+1532131152*r**26-39342620*r**28+41405248*r**30
            +60287*r**32+528384*r**34+1631*r**36))+16*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(736*Q2**22-164*Q2**21*(1+r**2)+8*Q2**20*(-6209+12830*r**2
            +5863*r**4)-20*Q2**19*(-16107+66795*r**2+425321*r**4+31155*r**6)+5*Q2**18*(
            -191935+1396628*r**2+18982358*r**4+15714020*r**6+573089*r**8)-2*Q2**17*(
            -743353+9181315*r**2+210439090*r**4+398849530*r**6+146667235*r**8+3090527*r**10)
            +Q2**16*(-810729+22144926*r**2+881714845*r**4+3089930340*r**6+2671394545*r**8
            +456317406*r**10+4784571*r**12)+4*Q2**15*(-262898+764215*r**2-150861544*r**4
            -1340268435*r**6-1965172890*r**8-881680183*r**10+28555120*r**12+1497871*r**14)
            -20*Q2**14*(-93439+2025190*r**2+50476392*r**4-115760126*r**6-243169743*r**8
            -99985982*r**10+92556030*r**12+72542542*r**14+777440*r**16)+20*Q2**13*(
            -3010+1456929*r**2+111635934*r**4+325781616*r**6+949127860*r**8+2135860308*r**10
            +1353719658*r**12+589236664*r**14+83141990*r**16+310787*r**18)+4*Q2**12*(
            -535171+9331010*r**2-181465215*r**4-2963189550*r**6-10276258125*r**8
            -33297080804*r**10-35914992495*r**12-11567244990*r**14-3072315480*r**16
            +161712590*r**18+3717974*r**20)-4*Q2**11*(-407524+16519711*r**2+488043590*r**4
            -1921351425*r**6-6025344060*r**8-34993132166*r**10-60171084836*r**12
            -35195915610*r**14-199576200*r**16+817140815*r**18+704045446*r**20+4577651*r**22)
            +2*Q2**10*(318279+4140240*r**2+982978502*r**4+769342920*r**6+8079031035*r**8
            +13582344856*r**10+42152523300*r**12+45037217288*r**14+62067170885*r**16
            +35911777560*r**18+8757214614*r**20+710194160*r**22-453063*r**24)+20*Q2**9*(
            -71399+2452840*r**2+18798472*r**4-477432212*r**6-1516769741*r**8-9461408242*r**10
            -33881513380*r**12-66187424212*r**14-39234036757*r**16-21145306736*r**18
            -3127531220*r**20-609463880*r**22+80244697*r**24+711370*r**26)-10*Q2**8*(
            -34105+2995558*r**2+141045673*r**4-974323856*r**6-1130956499*r**8-14544085038*r**10
            -56616655057*r**12-211406379568*r**14-247458855871*r**16-63840564102*r**18
            -29984342153*r**20+2381844544*r**22+424346443*r**24+193942990*r**26+689969*r**28)
            -4*Q2**7*(-134514+3890235*r**2-99348440*r**4-25783395*r**6-1129268990*r**8
            +8891096539*r**10-32352779520*r**12+90227215265*r**14+275486365090*r**16
            +188817996105*r**18-153500580376*r**20-46982782425*r**22-15990252690*r**24
            -2807960255*r**26+6986640*r**28+1046331*r**30)+4*Q2**6*(-90181+5272454*r**2
            +111293140*r**4-1997881230*r**6+352771815*r**8+8104054886*r**10-48795009914*r**12
            -408055557590*r**14-1154903353125*r**16-1062373628990*r**18-766724823704*r**20
            -261962637994*r**22-103684435335*r**24-5397166830*r**26-1251959810*r**28
            +240196814*r**30+1173194*r**32)-4*Q2**5*(10913+391900*r**2+69513774*r**4
            -1080609260*r**6+1335602940*r**8+200219702*r**10+27021416430*r**12-256778954884*r**14
            -1452661624970*r**16-2738316873530*r**18-1126798664758*r**20-1012961279940*r**22
            -3750177844*r**24-36966938670*r**26+5070769690*r**28+614729268*r**30
            +83498785*r**32+58454*r**34)-20*Q2**4*(-5603+314730*r**2+1921509*r**4
            -103644366*r**6+256539277*r**8+4461509120*r**10+102549015*r**12-11810540434*r**14
            +32699137687*r**16+224241654616*r**18+436852355289*r**20-240878254290*r**22
            +24296863191*r**24-30911507896*r**26-6742984043*r**28-868557006*r**30
            -170253080*r**32+10201334*r**34+64150*r**36)+60*Q2**3*(-405+37606*r**2
            +1103021*r**4-38480558*r**6+139231104*r**8+1105706196*r**10+2296093892*r**12
            +2286272464*r**14+15646171846*r**16+20489197320*r**18-4704403122*r**20
            +38359259308*r**22-106763697016*r**24-42030495588*r**26-3742305372*r**28
            -1948299344*r**30-25594681*r**32-14112094*r**34+2356125*r**36+7298*r**38)
            +3*Q2**2*(-4313+230260*r**2-3126990*r**4+15667060*r**6-58556705*r**8
            +5614189792*r**10-24588920600*r**12-141108574560*r**14-468178935250*r**16
            -2451613456600*r**18-1949622466788*r**20-755144441880*r**22+1851832881590*r**24
            -732358578880*r**26+472408852040*r**28-40098187648*r**30+1342331595*r**32
            -898532540*r**34-174530430*r**36+1803140*r**38+37707*r**40)-18*Q2*(
            -397+31013*r**2+248190*r**4-26348410*r**6+178447315*r**8+1583713473*r**10
            -1272858112*r**12+12536987360*r**14+108715887310*r**16-63624780190*r**18
            +367116721868*r**20+157435300988*r**22-1075475371290*r**24+668805592610*r**26
            -155239831440*r**28-14488694192*r**30-4984570817*r**32-1186756135*r**34
            -54414010*r**36-20533810*r**38+1223623*r**40+5053*r**42)+9*(-113+10430*r**2
            +124221*r**4-13915460*r**6+120458625*r**8+744356342*r**10-690302965*r**12
            +28486145456*r**14+98860868230*r**16+126814542300*r**18+619758474002*r**20
            -3104449405560*r**22+3895904772306*r**24-1922665264580*r**26+283783738150*r**28
            +2408722672*r**30-26605651205*r**32-1809481114*r**34-632078815*r**36
            -9129700*r**38-7490403*r**40+505550*r**42+1631*r**44))*sqrtq2+logq2**6*(9405849600000*(
            -Q2+(-1+r)**2)*(-1+r)*r**26*(1+r)*(1+r**2)*(1-Q2+r**2)*(-1-4*r**2
            +r**4)*(-Q2+(1+r)**2)+9405849600000*r**26*(1+4*r**2-2*r**4-4*r**6
            +r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**5*(-14929920000*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(70*Q2**7*(1+r**2)-10*Q2**6*(23+76*r**2
            +53*r**4)+10*Q2**5*(-23+125*r**2+305*r**4+157*r**6)-2*Q2**4*(-858-1351*r**2
            +1389*r**4+2903*r**6+1133*r**8)+4*Q2**3*(-411-1663*r**2-1744*r**4+554*r**6
            +1372*r**8+326*r**10)+2*Q2**2*(-612+853*r**2+4453*r**4+3032*r**6-664*r**8
            -595*r**10+337*r**12)-3*Q2*(-957-1022*r**2+1047*r**4+1068*r**6-735*r**8
            -498*r**10+645*r**12+452*r**14)+3*(-443-589*r**2-2175*r**4-1587*r**6
            +4321*r**8+989*r**10-985*r**12+291*r**14+178*r**16))+14929920000*r**22*(70*Q2**10*(1
            +r**2)-20*Q2**9*(22+59*r**2+37*r**4)+10*Q2**8*(67+457*r**2+727*r**4
            +337*r**6)-2*Q2**7*(-823+1549*r**2+9669*r**4+11503*r**6+4318*r**8)
            +14*Q2**6*(-518-1149*r**2+268*r**4+2962*r**6+3016*r**8+953*r**10)+Q2**5*(9086
            +36652*r**2+49978*r**4+8436*r**6-47814*r**8-44996*r**10-11606*r**12)
            +5*Q2**4*(-21-4522*r**2-13389*r**4-14272*r**6-4211*r**8+5058*r**10
            +4445*r**12+560*r**14)-3*(-1+r**2)**3*(443+1475*r**2+4239*r**4+8001*r**6
            +5267*r**8-43*r**10-47*r**12+647*r**14+178*r**16)+2*Q2**3*(-5985-5950*r**2
            +9419*r**4+20598*r**6+23613*r**8+8606*r**10-699*r**12+2170*r**14+2660*r**16)
            -2*Q2**2*(-6912-10649*r**2-10887*r**4-16467*r**6+9615*r**8+25745*r**10
            +2747*r**12-1801*r**14+5437*r**16+3172*r**18)+6*Q2*(-1143-1359*r**2
            -3003*r**4-5396*r**6-304*r**8+3532*r**10+7466*r**12+720*r**14-1717*r**16
            +711*r**18+493*r**20))*sqrtq2)+logq2**4*(-41472000*r**18*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-1120*Q2**11+40*Q2**10*(343+463*r**2)
            -20*Q2**9*(3579+9401*r**2+5598*r**4)+16*Q2**8*(12476+47750*r**2+57837*r**4
            +21419*r**6)-4*Q2**7*(78047+391017*r**2+709339*r**4+544057*r**6+135368*r**8)
            +Q2**6*(266133+1567540*r**2+3800814*r**4+4400212*r**6+2291461*r**8+272832*r**10)
            +2*Q2**5*(-74123-361111*r**2-1140282*r**4-1039682*r**6-480911*r**8-6795*r**10
            +220528*r**12)+Q2**4*(127225+661490*r**2+3762451*r**4+1950140*r**6-5468913*r**8
            -5369086*r**10-2200635*r**12-756560*r**14)+12*Q2**3*(-5208-81095*r**2
            -509668*r**4-1039559*r**6-339684*r**8+699975*r**10+506372*r**12+145619*r**14
            +23848*r**16)+3*Q2**2*(-32539+42016*r**2-140156*r**4+3159048*r**6+5155610*r**8
            +1061288*r**10-877892*r**12-176040*r**14-97119*r**16+70584*r**18)-18*Q2*(
            -6999-34505*r**2-390024*r**4-140416*r**6+448558*r**8+65590*r**10-250860*r**12
            +118784*r**14+169481*r**16+8467*r**18+11924*r**20)+9*(-4381-34582*r**2
            -417725*r**4-330832*r**6-95334*r**8+393676*r**10+520586*r**12-228240*r**14
            +14467*r**16+171594*r**18+4915*r**20+5856*r**22))+41472000*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1120*Q2**11-40*Q2**10*(343+463*r**2)
            +20*Q2**9*(3579+9401*r**2+5598*r**4)-16*Q2**8*(12476+47750*r**2+57837*r**4
            +21419*r**6)+4*Q2**7*(78047+391017*r**2+709339*r**4+544057*r**6+135368*r**8)
            -Q2**6*(266133+1567540*r**2+3800814*r**4+4400212*r**6+2291461*r**8+272832*r**10)
            +Q2**5*(148246+722222*r**2+2280564*r**4+2079364*r**6+961822*r**8+13590*r**10
            -441056*r**12)+Q2**4*(-127225-661490*r**2-3762451*r**4-1950140*r**6
            +5468913*r**8+5369086*r**10+2200635*r**12+756560*r**14)-12*Q2**3*(-5208
            -81095*r**2-509668*r**4-1039559*r**6-339684*r**8+699975*r**10+506372*r**12
            +145619*r**14+23848*r**16)-3*Q2**2*(-32539+42016*r**2-140156*r**4+3159048*r**6
            +5155610*r**8+1061288*r**10-877892*r**12-176040*r**14-97119*r**16+70584*r**18)
            +18*Q2*(-6999-34505*r**2-390024*r**4-140416*r**6+448558*r**8+65590*r**10
            -250860*r**12+118784*r**14+169481*r**16+8467*r**18+11924*r**20)-9*(
            -4381-34582*r**2-417725*r**4-330832*r**6-95334*r**8+393676*r**10+520586*r**12
            -228240*r**14+14467*r**16+171594*r**18+4915*r**20+5856*r**22))*sqrtq2)
            +logq2**3*(-2764800*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-6040*Q2**14
            +40*Q2**13*(1594+1717*r**2)-6*Q2**12*(47066+105627*r**2+56105*r**4)
            +4*Q2**11*(166353+615914*r**2+672236*r**4+218475*r**6)-4*Q2**10*(213954
            +1233470*r**2+2160818*r**4+1486603*r**6+277725*r**8)+30*Q2**9*(17658
            +159933*r**2+373524*r**4+406142*r**6+203128*r**8+2091*r**10)+10*Q2**8*(
            -8730-81919*r**2+406781*r**4+1318228*r**6+729770*r**8+127157*r**10
            +179709*r**12)-Q2**7*(14103+2215166*r**2+30766055*r**4+93813080*r**6
            +108457305*r**8+49318958*r**10+10896361*r**12+2134140*r**14)+3*Q2**6*(43947
            +359211*r**2+11650609*r**4+48168485*r**6+84376685*r**8+63097297*r**10
            +18606971*r**12+3683359*r**14+75900*r**16)+Q2**5*(-417443-154480*r**2
            -14503246*r**4-79196236*r**6-205266820*r**8-222991528*r**10-86498170*r**12
            +10443884*r**14-1054561*r**16+1426600*r**18)-5*Q2**4*(-69205-403917*r**2
            -1535816*r**4-7263066*r**6-22070188*r**8-7836032*r**10+16436874*r**12
            +21608978*r**14+13610857*r**16+1284133*r**18+216038*r**20)+15*Q2**3*(2201
            -157626*r**2-654129*r**4-4963312*r**6-16774294*r**8-16901308*r**10+5812862*r**12
            +15167456*r**14+9309725*r**16+2630070*r**18+306323*r**20+1232*r**22)
            +3*Q2**2*(-59967+26301*r**2-1108055*r**4+9244205*r**6+37514770*r**8
            +138715514*r**10+94138698*r**12-4616870*r**14-16613515*r**16-16724055*r**18
            +4344493*r**20-24359*r**22+106840*r**24)-9*Q2*(-9483-110254*r**2-1226156*r**4
            -4956660*r**6-27575015*r**8+5724286*r**10+23727088*r**12-9829088*r**14
            +1175335*r**16+11255590*r**18-469828*r**20+2159316*r**22+118219*r**24
            +16650*r**26)+9*(-1349-41985*r**2-471498*r**4-2888708*r**6-19012105*r**8
            +4372743*r**10+20073990*r**12-3066584*r**14-7941439*r**16+2125205*r**18
            +6265906*r**20-12580*r**22+559757*r**24+36197*r**26+2450*r**28))-2764800*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(6040*Q2**15-40*Q2**14*(1745+1868*r**2)
            +Q2**13*(346156+766202*r**2+405310*r**4)-2*Q2**12*(473904+1689907*r**2
            +1829668*r**4+605265*r**6)+4*Q2**11*(380307+2015737*r**2+3448968*r**4
            +2377314*r**6+496200*r**8)-2*Q2**10*(692778+5293843*r**2+12391436*r**4
            +13386972*r**6+6575576*r**8+586815*r**10)-20*Q2**9*(-30852-307346*r**2
            -596795*r**4-510385*r**6-549020*r**8-244250*r**10+86718*r**12)+Q2**8*(
            -73197+1308676*r**2+34014675*r**4+111063170*r**6+128937285*r**8+57888228*r**10
            +13965021*r**12+3931230*r**14)-2*Q2**7*(72972+1653451*r**2+33966524*r**4
            +134542295*r**6+227700220*r**8+173534077*r**10+58018116*r**12+12040289*r**14
            +1180920*r**16)+2*Q2**6*(274642+681977*r**2+25266353*r**4+129326759*r**6
            +301451165*r**8+332706737*r**10+165805487*r**12+28213553*r**14+6166169*r**16
            -599450*r**18)+2*Q2**5*(-381734-1295754*r**2-11168403*r**4-65007406*r**6
            -197406998*r**8-233719254*r**10-113652664*r**12+15995302*r**14+38721804*r**16
            +3396352*r**18+1253395*r**20)-10*Q2**4*(-31301-473000*r**2-1951060*r**4
            -11844409*r**6-39828068*r**8-40305072*r**10+13019714*r**12+41774110*r**14
            +31574505*r**16+11392600*r**18+1209570*r**20+109867*r**22)-6*Q2**3*(
            -35486+401713*r**2+1475360*r**4+18665705*r**6+73101400*r**8+153546762*r**10
            +74790464*r**12-54759230*r**14-69499710*r**16-38211515*r**18-5168736*r**20
            -781067*r**22+50340*r**24)+6*Q2**2*(-44208-182214*r**2-2380111*r**4
            -3366915*r**6-17983035*r**8+96701571*r**10+152017738*r**12+30017282*r**14
            -8852190*r**16+214600*r**18-6894523*r**20+5399041*r**22+218569*r**24
            +78395*r**26)-18*Q2*(-5416-80861*r**2-903954*r**4-4535762*r**6-25771890*r**8
            -8738993*r**10+24762682*r**12+5415708*r**14-8297596*r**16+7278065*r**18
            +8525834*r**20+838454*r**22+1418646*r**24+85533*r**26+9550*r**28)+9*(
            -1349-43334*r**2-513483*r**4-3360206*r**6-21900813*r**8-14639362*r**10
            +24446733*r**12+17007406*r**14-11008023*r**16-5816234*r**18+8391111*r**20
            +6253326*r**22+547177*r**24+595954*r**26+38647*r**28+2450*r**30))*sqrtq2)
            +logq2**2*(11520*r**10*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17
            -8*Q2**16*(135817+150101*r**2)+8*Q2**15*(609837+1424108*r**2+709791*r**4)
            -8*Q2**14*(1497790+5665821*r**2+6164498*r**4+1670155*r**6)+8*Q2**13*(2052205
            +11807174*r**2+19627106*r**4+13279952*r**6+1570775*r**8)+Q2**12*(-9276675
            -97625268*r**2-162375498*r**4-170092020*r**6-87823939*r**8+10951320*r**10)
            -4*Q2**11*(1841403-2378739*r**2+72594868*r**4+176570458*r**6+97819623*r**8
            +24693229*r**10+9892734*r**12)+2*Q2**10*(9261111+50180850*r**2+514798421*r**4
            +1698206280*r**6+1881190105*r**8+716700482*r**10+157336027*r**12+14469828*r**14)
            +4*Q2**9*(-3352365-32232891*r**2-271078323*r**4-1352556375*r**6-2375510525*r**8
            -1673827605*r**10-350439261*r**12-63361633*r**14+4846770*r**16)+Q2**8*(
            -2729705+88671816*r**2+290389124*r**4+2654978408*r**6+6371797290*r**8
            +7327078400*r**10+3114119876*r**12-691377336*r**14-92962057*r**16-42913400*r**18)
            +8*Q2**7*(1747270-4971133*r**2+15127487*r**4+266907120*r**6+1492747966*r**8
            +2719556390*r**10+1861043472*r**12+853863832*r**14+317972780*r**16+40114391*r**18
            +1878665*r**20)+4*Q2**6*(-2456967-4677472*r**2+23073081*r**4-603032454*r**6
            -5851481694*r**8-16113018636*r**10-17957269110*r**12-8332675944*r**14
            -2848468779*r**16-372895044*r**18-46067315*r**20+4119774*r**22)-8*Q2**5*(229304
            -8600451*r**2-13472499*r**4-7450835*r**6-1468763325*r**8-6396000186*r**10
            -11704337214*r**12-7844229138*r**14-1198700610*r**16-511036475*r**18
            +106568217*r**20+8467725*r**22+1935887*r**24)+Q2**4*(6068155-55416868*r**2
            -529648674*r**4-565030660*r**6-2269446875*r**8-12054143520*r**10-35736518844*r**12
            -25962685992*r**14+17453038725*r**16+29611067900*r**18+4735543390*r**20
            +1370532012*r**22+129316891*r**24+1225160*r**26)+12*Q2**3*(-174505+109941*r**2
            +26994944*r**4+148392198*r**6+449400505*r**8+2459787075*r**10+4694349898*r**12
            +1521190932*r**14-2935005991*r**16-4346643205*r**18-2161639620*r**20
            -407821914*r**22-28949801*r**24-3480307*r**26+289850*r**28)-6*Q2**2*(189515
            -3931222*r**2-17811067*r**4+102589440*r**6+16192019*r**8+4091115470*r**10
            +11119907829*r**12+14975348124*r**14+4310241465*r**16-1116035738*r**18
            -4526104505*r**20+502957768*r**22-109686807*r**24+45159970*r**26+2918719*r**28
            +229020*r**30)+36*Q2*(26931-379535*r**2-4452807*r**4-14409807*r**6
            -176564787*r**8-451164495*r**10-1711459887*r**12+1089967489*r**14+475970739*r**16
            +27232299*r**18+820620947*r**20-372775221*r**22+286607943*r**24+25195443*r**26
            +5163363*r**28+420867*r**30+518*r**32)+9*(-21679+281592*r**2+4639432*r**4
            +30912240*r**6+319818060*r**8+1430620872*r**10+5770391864*r**12-8304862496*r**14
            -4018542330*r**16+8182983880*r**18-268700232*r**20-3464268304*r**22+686961996*r**24
            -329849160*r**26-36352440*r**28-3686336*r**30-332527*r**32+5568*r**34))
            +11520*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17-8*Q2**16*(135817
            +150101*r**2)+8*Q2**15*(609837+1424108*r**2+709791*r**4)-8*Q2**14*(1497790
            +5665821*r**2+6164498*r**4+1670155*r**6)+8*Q2**13*(2052205+11807174*r**2
            +19627106*r**4+13279952*r**6+1570775*r**8)+Q2**12*(-9276675-97625268*r**2
            -162375498*r**4-170092020*r**6-87823939*r**8+10951320*r**10)-4*Q2**11*(1841403
            -2378739*r**2+72594868*r**4+176570458*r**6+97819623*r**8+24693229*r**10
            +9892734*r**12)+2*Q2**10*(9261111+50180850*r**2+514798421*r**4+1698206280*r**6
            +1881190105*r**8+716700482*r**10+157336027*r**12+14469828*r**14)+4*Q2**9*(
            -3352365-32232891*r**2-271078323*r**4-1352556375*r**6-2375510525*r**8
            -1673827605*r**10-350439261*r**12-63361633*r**14+4846770*r**16)+Q2**8*(
            -2729705+88671816*r**2+290389124*r**4+2654978408*r**6+6371797290*r**8
            +7327078400*r**10+3114119876*r**12-691377336*r**14-92962057*r**16-42913400*r**18)
            +8*Q2**7*(1747270-4971133*r**2+15127487*r**4+266907120*r**6+1492747966*r**8
            +2719556390*r**10+1861043472*r**12+853863832*r**14+317972780*r**16+40114391*r**18
            +1878665*r**20)+4*Q2**6*(-2456967-4677472*r**2+23073081*r**4-603032454*r**6
            -5851481694*r**8-16113018636*r**10-17957269110*r**12-8332675944*r**14
            -2848468779*r**16-372895044*r**18-46067315*r**20+4119774*r**22)-8*Q2**5*(229304
            -8600451*r**2-13472499*r**4-7450835*r**6-1468763325*r**8-6396000186*r**10
            -11704337214*r**12-7844229138*r**14-1198700610*r**16-511036475*r**18
            +106568217*r**20+8467725*r**22+1935887*r**24)+Q2**4*(6068155-55416868*r**2
            -529648674*r**4-565030660*r**6-2269446875*r**8-12054143520*r**10-35736518844*r**12
            -25962685992*r**14+17453038725*r**16+29611067900*r**18+4735543390*r**20
            +1370532012*r**22+129316891*r**24+1225160*r**26)+12*Q2**3*(-174505+109941*r**2
            +26994944*r**4+148392198*r**6+449400505*r**8+2459787075*r**10+4694349898*r**12
            +1521190932*r**14-2935005991*r**16-4346643205*r**18-2161639620*r**20
            -407821914*r**22-28949801*r**24-3480307*r**26+289850*r**28)-6*Q2**2*(189515
            -3931222*r**2-17811067*r**4+102589440*r**6+16192019*r**8+4091115470*r**10
            +11119907829*r**12+14975348124*r**14+4310241465*r**16-1116035738*r**18
            -4526104505*r**20+502957768*r**22-109686807*r**24+45159970*r**26+2918719*r**28
            +229020*r**30)+36*Q2*(26931-379535*r**2-4452807*r**4-14409807*r**6
            -176564787*r**8-451164495*r**10-1711459887*r**12+1089967489*r**14+475970739*r**16
            +27232299*r**18+820620947*r**20-372775221*r**22+286607943*r**24+25195443*r**26
            +5163363*r**28+420867*r**30+518*r**32)+9*(-21679+281592*r**2+4639432*r**4
            +30912240*r**6+319818060*r**8+1430620872*r**10+5770391864*r**12-8304862496*r**14
            -4018542330*r**16+8182983880*r**18-268700232*r**20-3464268304*r**22+686961996*r**24
            -329849160*r**26-36352440*r**28-3686336*r**30-332527*r**32+5568*r**34))*sqrtq2)
            +logq2*(384*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(54928*Q2**20-10*Q2**19*(80571
            +66179*r**2)+10*Q2**18*(454635+932826*r**2+315743*r**4)-10*Q2**17*(1276291
            +4810467*r**2+4156451*r**4+713027*r**6)+10*Q2**16*(1673240+11757431*r**2
            +16884235*r**4+8279349*r**6+491705*r**8)+2*Q2**15*(291279-59156055*r**2
            -97945590*r**4-57271710*r**6-13876615*r**8+5923559*r**10)-10*Q2**14*(3179247
            +6569403*r**2+44188566*r**4+120967604*r**6+75147541*r**8+19669647*r**10
            +2857988*r**12)+5*Q2**13*(6433205+60642984*r**2+332390965*r**4+1097862886*r**6
            +1214635191*r**8+416413088*r**10+71427359*r**12+2563602*r**14)+5*Q2**12*(2841111
            -57953133*r**2-397686891*r**4-1861102247*r**6-3137405283*r**8-2048826147*r**10
            -287234445*r**12-19839849*r**14+5847972*r**16)-10*Q2**11*(4707430-926967*r**2
            -54829074*r**4-505111764*r**6-907956088*r**8-915369848*r**10-228097682*r**12
            +224264136*r**14+38356662*r**16+4072315*r**18)+4*Q2**10*(4510077+57863495*r**2
            +319685970*r**4+1470662320*r**6+7814017520*r**8+15640213853*r**10+10006163165*r**12
            +4434888910*r**14+1170745425*r**16+110393910*r**18+307307*r**20)+5*Q2**9*(5179239
            -46755564*r**2-368681911*r**4-2195790494*r**6-12439153626*r**8-38209590004*r**10
            -42558233486*r**12-16668936056*r**14-5253633789*r**16-332977536*r**18
            +1654389*r**20+6524726*r**22)-5*Q2**8*(4790695-9929301*r**2-197781337*r**4
            -1286268433*r**6-6195004898*r**8-34209666554*r**10-64772250554*r**12
            -44191072906*r**14-4893941093*r**16-1309794993*r**18+635093811*r**20
            +64911899*r**22+3840512*r**24)-10*Q2**7*(418313-13654759*r**2-41127194*r**4
            +269462462*r**6-1165420083*r**8-4237010291*r**10-10083900548*r**12-7245547460*r**14
            -8905623285*r**16-9160838453*r**18-1980677810*r**20-352827146*r**22-18460977*r**24
            +878591*r**26)+10*Q2**6*(1260165-14437827*r**2-105316878*r**4+264511880*r**6
            -381884731*r**8-13983361421*r**10-69660249688*r**12-119098406816*r**14
            -79333297209*r**16-39759741061*r**18-9544382366*r**20-2109246552*r**22
            -23532033*r**24+5803877*r**26+1259540*r**28)+Q2**5*(-2662377+10974120*r**2
            +484828155*r**4+1307981450*r**6-5161804645*r**8+33108765192*r**10+526380826495*r**12
            +1549238069610*r**14+1691496856965*r**16+536428413960*r**18+280893888657*r**20
            -12171448290*r**22+2098864585*r**24-1617715640*r**26-97736715*r**28-1429522*r**30)
            -5*Q2**4*(616103-12728853*r**2-43586543*r**4+1216863773*r**6+2902206467*r**8
            -2592019133*r**10+9559984153*r**12+70032535581*r**14+214049147049*r**16
            +74508298201*r**18-130117787973*r**20-16769631217*r**22-12492555863*r**24
            -1835799047*r**26-184875493*r**28-4948297*r**30+677892*r**32)+30*Q2**3*(49245
            -1005552*r**2-8390298*r**4+119452576*r**6+558599956*r**8+1463384198*r**10
            +4420500082*r**12+16969717740*r**14+13720059258*r**16+1342738458*r**18
            -21945512406*r**20-26796182328*r**22-7139162596*r**24-723747334*r**26
            -178221314*r**28+1417388*r**30+417273*r**32+45654*r**34)+30*Q2**2*(8287
            -277846*r**2+897755*r**4+45300500*r**6-28432468*r**8-1149771430*r**10
            -2275208286*r**12-30409099688*r**14-44294454506*r**16-25153597574*r**18
            -6278370596*r**20+21798649780*r**22-2492912204*r**24+2461427062*r**26
            -384866858*r**28-11605536*r**30-7241173*r**32-294388*r**34+9169*r**36)
            -45*Q2*(6425-211762*r**2-781057*r**4+43411204*r**6+82312436*r**8+322380516*r**10
            +4640825532*r**12+4639058012*r**14+19868199534*r**16-9857533632*r**18
            -6747069582*r**20-23382970028*r**22+18100809572*r**24-6819671780*r**26
            -669629844*r**28-191633484*r**30-25702367*r**32-1765902*r**34-39833*r**36
            +6040*r**38)+9*(5787-220735*r**2-1105095*r**4+57261285*r**6+101088130*r**8
            +1458374292*r**10+12154764580*r**12+29670853060*r**14+98584777970*r**16
            -304538439490*r**18+133768147902*r**20+164166435670*r**22-161489742960*r**24
            +35126704580*r**26-6861747660*r**28-2010898828*r**30-153685765*r**32
            -31511255*r**34-1056335*r**36-10355*r**38+5222*r**40))-384*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(54928*Q2**21-2*Q2**20*(430319+358359*r**2)
            +20*Q2**19*(267603+539788*r**2+190961*r**4)-20*Q2**18*(865463+3098964*r**2
            +2702510*r**4+514385*r**6)+10*Q2**17*(2949531+17844189*r**2+25851153*r**4
            +13148827*r**6+1204732*r**8)+2*Q2**16*(-8074921-126309410*r**2-241153920*r**4
            -183089630*r**6-57731885*r**8+3465034*r**10)-2*Q2**15*(16187514-26017761*r**2
            +63841185*r**4+449620720*r**6+304589380*r**8+90395179*r**10+20213499*r**12)
            +5*Q2**14*(12791699+80140284*r**2+433906903*r**4+1428175226*r**6+1606865481*r**8
            +606047464*r**10+116482629*r**12+8279578*r**14)+10*Q2**13*(-1796047-62514661*r**2
            -395360420*r**4-1645678049*r**6-2724951680*r**8-1839937213*r**10-387537446*r**12
            -46915405*r**14+1642185*r**16)-5*Q2**12*(12255971-56965956*r**2-565298172*r**4
            -3269012666*r**6-6814419706*r**8-7016971126*r**10-2792255956*r**12+141453978*r**14
            +62721447*r**16+13992602*r**18)+2*Q2**11*(32557304+134629305*r**2+360591735*r**4
            +141620450*r**6+8562695780*r**8+22163798026*r**10+14294988680*r**12+8850610090*r**14
            +3654594840*r**16+432932705*r**18+20976189*r**20)+Q2**10*(7855887-483272108*r**2
            -3353607415*r**4-18140345630*r**6-99334487490*r**8-284864875512*r**10
            -315376675502*r**12-141108888580*r**14-48690706285*r**16-6789445020*r**18
            -434532923*r**20+31394402*r**22)-10*Q2**9*(4984967-25752813*r**2-306609406*r**4
            -1925370419*r**6-10414974509*r**8-42429205092*r**10-72770037022*r**12
            -51709121224*r**14-13408255469*r**16-3448203159*r**18+151885332*r**20
            +36545507*r**22+5182619*r**24)+5*Q2**8*(3954069+22170912*r**2-125456250*r**4
            -2022974694*r**6-5150433165*r**8-31930650870*r**10-78814116012*r**12
            -94472228540*r**14-31273767429*r**16+12117940820*r**18+3286654438*r**20
            +1405660002*r**22+105674365*r**24+2083330*r**26)+10*Q2**7*(1678478-27674273*r**2
            -160098831*r**4+492847148*r**6-1277842352*r**8-19385791795*r**10-83981160527*r**12
            -136427854824*r**14-95484467954*r**16-57826202799*r**18-20685898629*r**20
            -4442751508*r**22-394820156*r**24-11778509*r**26+2138131*r**28)+Q2**6*(
            -15264027+142750740*r**2+1682375205*r**4-283968570*r**6-3988076135*r**8
            +176761226712*r**10+1362816937585*r**12+3436824634650*r**14+3675813897215*r**16
            +1727358796660*r**18+773935122927*r**20+104364840890*r**22+23426650435*r**24
            -1440434080*r**26-168370885*r**28-14024922*r**30)-2*Q2**5*(209069-27666261*r**2
            +138934780*r**4+3938564235*r**6+5328604570*r**8+7493432441*r**10+303644756226*r**12
            +1212890787005*r**14+2155490330910*r**16+1300233380965*r**18+83366681376*r**20
            +92437142141*r**22-36267681510*r**24-4348923145*r**26-1319914910*r**28
            -61953861*r**30+979969*r**32)+5*Q2**4*(911573-18146062*r**2-106657184*r**4
            +1889992686*r**6+7470669976*r**8+9090492522*r**10+33490965512*r**12+181410826174*r**14
            +366402038178*r**16+296613875998*r**18-187282564208*r**20-307664513158*r**22
            -72097162656*r**24-18670838914*r**26-3090002424*r**28-181319462*r**30
            -1766767*r**32+951816*r**34)-30*Q2**3*(40958-678461*r**2-10293605*r**4
            +65761778*r**6+706485000*r**8+3171755584*r**10+8159092566*r**12+51799317510*r**14
            +74984231504*r**16+40216395290*r**18-14324403352*r**20-70540344514*r**22
            -31442432720*r**24-10324336992*r**26-517101790*r**28-165198390*r**30
            +9075834*r**32+757315*r**34+36485*r**36)-15*Q2**2*(35849-1174404*r**2
            -1103353*r**4+222630122*r**6+280673372*r**8-1389266248*r**10+7072517164*r**12
            -51451441912*r**14-89802509786*r**16-168468705056*r**18-83105145086*r**20
            -39108351716*r**22+92913903868*r**24-20521985624*r**26+2144230876*r**28
            -1367845240*r**30-114800519*r**32-20368828*r**34-689937*r**36+36458*r**38)
            +18*Q2*(18956-623710*r**2-3034595*r**4+135206010*r**6+364853165*r**8
            +1740919526*r**10+18485397410*r**12+38035135390*r**14+110560532850*r**16
            -127242554990*r**18+25372565916*r**20+6758118810*r**22-93950272620*r**24
            +45766196770*r**26-22154127890*r**28-3158607734*r**30-620182510*r**32
            -84426300*r**34-5042505*r**36-89660*r**38+17711*r**40)-9*(5787-214948*r**2
            -1325830*r**4+56156190*r**6+158349415*r**8+1559462422*r**10+13613138872*r**12
            +41825617640*r**14+128255631030*r**16-205953661520*r**18-170770291588*r**20
            +297934583572*r**22+2676692710*r**24-126363038380*r**26+28264956920*r**28
            -8872646488*r**30-2164584593*r**32-185197020*r**34-32567590*r**36-1066690*r**38
            -5133*r**40+5222*r**42))*sqrtq2))*math.log(mus))/(-18900*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-18900*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2+logq2**6*(846526464000*r**26*(1+r**2)*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -846526464000*r**26*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**3*(653184000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))+653184000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))*sqrtq2)+logq2*(2268000*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)
            -Q2**2*(5+2*r**2+5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))+2268000*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)-Q2**2*(5+2*r**2
            +5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))*sqrtq2)+logq2**2*(-13608000*(
            -Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(16*Q2**4+Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1
            +9*r**2+9*r**4+r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))-13608000*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(16*Q2**4
            +Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1+9*r**2+9*r**4
            +r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))*sqrtq2)+logq2**4*(-1959552000*(
            -Q2+(-1+r)**2)*r**18*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))
            -1959552000*(-Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))*sqrtq2)
            +logq2**5*(9405849600*(-Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2
            +41*r**4)-18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4
            -82*r**6+13*r**8))+9405849600*(-Q2+(-1+r)**2)*r**22*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2+41*r**4)
            -18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4-82*r**6
            +13*r**8))*sqrtq2))+((-16*r**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(92*Q2**18
            +60*Q2**17*(1+r**2)+4*Q2**16*(-1519+3228*r**2+1499*r**4)-Q2**15*(-34969
            +160589*r**2+1046341*r**4+72623*r**6)+Q2**14*(-94735+776500*r**2+10808350*r**4
            +8852676*r**6+299825*r**8)-Q2**13*(-135799+1877655*r**2+43289452*r**4
            +82368756*r**6+29535579*r**8+576101*r**10)+Q2**12*(-76245+2114840*r**2
            +79598981*r**4+277504064*r**6+239240429*r**8+38482536*r**10+381315*r**12)
            +Q2**11*(-56927+50819*r**2-41680119*r**4-387002253*r**6-530987613*r**8
            -237317447*r**10+20511955*r**12+493297*r**14)-Q2**10*(-101673+2723028*r**2
            +87830460*r**4-63891428*r**6+60797850*r**8+280696044*r**10+261376636*r**12
            +122446116*r**14+1074711*r**16)+Q2**9*(9295+1716825*r**2+153045270*r**4
            +436523258*r**6+1396512740*r**8+3429691340*r**10+2103692810*r**12+851014790*r**14
            +112792173*r**16+341275*r**18)+Q2**8*(-120549+2320560*r**2-37227201*r**4
            -528837568*r**6-1065281922*r**8-4841499376*r**10-6297176130*r**12-1670586336*r**14
            -590459833*r**16+54890208*r**18+889251*r**20)-Q2**7*(-89635+3712335*r**2
            +105058067*r**4-340834967*r**6+511955778*r**8+1046459542*r**10+777200710*r**12
            -778030638*r**14+1950721473*r**16+357891963*r**18+168225927*r**20+994085*r**22)
            +Q2**6*(10907+875276*r**2+89263870*r**4-158583284*r**6+193046501*r**8
            +5395152088*r**10+19515767172*r**12+17554642744*r**14+8434570341*r**16
            +3289645276*r**18+764189182*r**20+76673404*r**22+70043*r**24)+Q2**5*(
            -48803+1674323*r**2+9932888*r**4-178260472*r**6+848638885*r**8-1763653493*r**10
            -16900419912*r**12-39203740728*r**14-12693116089*r**16-8386679415*r**18
            +37241456*r**20-323302736*r**22+63392055*r**24+508441*r**26)-Q2**4*(
            -21065+1300200*r**2+41907245*r**4-417821216*r**6+224047815*r**8+975854760*r**10
            -701297035*r**12-14255612160*r**14-29566065683*r**16+20178975160*r**18
            -714459345*r**20+2445366560*r**22+131177365*r**24+76375224*r**26+316975*r**28)
            +Q2**3*(5283-7655*r**2+13345903*r**4-193648251*r**6-570114849*r**8-152368323*r**10
            -3295991205*r**12-11620863591*r**14+4354598937*r**16-12379537797*r**18
            +26031776957*r**20+3845099135*r**22+1061850213*r**24+170056239*r**26
            +14144121*r**28-9117*r**30)+Q2**2*(-7825+391060*r**2+5478336*r**4-108011956*r**6
            +403896324*r**8+279101876*r**10+2821795840*r**12+18885157708*r**14+18283866522*r**16
            +6908662492*r**18-12997085632*r**20+3267499140*r**22-3037842044*r**24
            +600798684*r**26-57506816*r**28+15657956*r**30+84335*r**32)-3*Q2*(-907
            +59419*r**2+1384374*r**4-40213254*r**6+35892346*r**8-134272058*r**10
            -2180654706*r**12+53763714*r**14-2428061692*r**16-7896633092*r**18+23365152962*r**20
            -15426377970*r**22+4793498550*r**24-336016054*r**26+191370746*r**28-2026122*r**30
            +3122007*r**32+11737*r**34)+3*(-113+8848*r**2+237471*r**4-9760736*r**6
            +6254580*r**8-82272976*r**10-1391081884*r**12+1374664192*r**14-13813606422*r**16
            +43249613040*r**18-52589566534*r**20+29995134624*r**22-8274408172*r**24
            +1532131152*r**26-39342620*r**28+41405248*r**30+60287*r**32+528384*r**34
            +1631*r**36))-16*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(736*Q2**22
            -164*Q2**21*(1+r**2)+8*Q2**20*(-6209+12830*r**2+5863*r**4)-20*Q2**19*(
            -16107+66795*r**2+425321*r**4+31155*r**6)+5*Q2**18*(-191935+1396628*r**2
            +18982358*r**4+15714020*r**6+573089*r**8)-2*Q2**17*(-743353+9181315*r**2
            +210439090*r**4+398849530*r**6+146667235*r**8+3090527*r**10)+Q2**16*(
            -810729+22144926*r**2+881714845*r**4+3089930340*r**6+2671394545*r**8
            +456317406*r**10+4784571*r**12)+4*Q2**15*(-262898+764215*r**2-150861544*r**4
            -1340268435*r**6-1965172890*r**8-881680183*r**10+28555120*r**12+1497871*r**14)
            -20*Q2**14*(-93439+2025190*r**2+50476392*r**4-115760126*r**6-243169743*r**8
            -99985982*r**10+92556030*r**12+72542542*r**14+777440*r**16)+20*Q2**13*(
            -3010+1456929*r**2+111635934*r**4+325781616*r**6+949127860*r**8+2135860308*r**10
            +1353719658*r**12+589236664*r**14+83141990*r**16+310787*r**18)+4*Q2**12*(
            -535171+9331010*r**2-181465215*r**4-2963189550*r**6-10276258125*r**8
            -33297080804*r**10-35914992495*r**12-11567244990*r**14-3072315480*r**16
            +161712590*r**18+3717974*r**20)-4*Q2**11*(-407524+16519711*r**2+488043590*r**4
            -1921351425*r**6-6025344060*r**8-34993132166*r**10-60171084836*r**12
            -35195915610*r**14-199576200*r**16+817140815*r**18+704045446*r**20+4577651*r**22)
            +2*Q2**10*(318279+4140240*r**2+982978502*r**4+769342920*r**6+8079031035*r**8
            +13582344856*r**10+42152523300*r**12+45037217288*r**14+62067170885*r**16
            +35911777560*r**18+8757214614*r**20+710194160*r**22-453063*r**24)+20*Q2**9*(
            -71399+2452840*r**2+18798472*r**4-477432212*r**6-1516769741*r**8-9461408242*r**10
            -33881513380*r**12-66187424212*r**14-39234036757*r**16-21145306736*r**18
            -3127531220*r**20-609463880*r**22+80244697*r**24+711370*r**26)-10*Q2**8*(
            -34105+2995558*r**2+141045673*r**4-974323856*r**6-1130956499*r**8-14544085038*r**10
            -56616655057*r**12-211406379568*r**14-247458855871*r**16-63840564102*r**18
            -29984342153*r**20+2381844544*r**22+424346443*r**24+193942990*r**26+689969*r**28)
            -4*Q2**7*(-134514+3890235*r**2-99348440*r**4-25783395*r**6-1129268990*r**8
            +8891096539*r**10-32352779520*r**12+90227215265*r**14+275486365090*r**16
            +188817996105*r**18-153500580376*r**20-46982782425*r**22-15990252690*r**24
            -2807960255*r**26+6986640*r**28+1046331*r**30)+4*Q2**6*(-90181+5272454*r**2
            +111293140*r**4-1997881230*r**6+352771815*r**8+8104054886*r**10-48795009914*r**12
            -408055557590*r**14-1154903353125*r**16-1062373628990*r**18-766724823704*r**20
            -261962637994*r**22-103684435335*r**24-5397166830*r**26-1251959810*r**28
            +240196814*r**30+1173194*r**32)-4*Q2**5*(10913+391900*r**2+69513774*r**4
            -1080609260*r**6+1335602940*r**8+200219702*r**10+27021416430*r**12-256778954884*r**14
            -1452661624970*r**16-2738316873530*r**18-1126798664758*r**20-1012961279940*r**22
            -3750177844*r**24-36966938670*r**26+5070769690*r**28+614729268*r**30
            +83498785*r**32+58454*r**34)-20*Q2**4*(-5603+314730*r**2+1921509*r**4
            -103644366*r**6+256539277*r**8+4461509120*r**10+102549015*r**12-11810540434*r**14
            +32699137687*r**16+224241654616*r**18+436852355289*r**20-240878254290*r**22
            +24296863191*r**24-30911507896*r**26-6742984043*r**28-868557006*r**30
            -170253080*r**32+10201334*r**34+64150*r**36)+60*Q2**3*(-405+37606*r**2
            +1103021*r**4-38480558*r**6+139231104*r**8+1105706196*r**10+2296093892*r**12
            +2286272464*r**14+15646171846*r**16+20489197320*r**18-4704403122*r**20
            +38359259308*r**22-106763697016*r**24-42030495588*r**26-3742305372*r**28
            -1948299344*r**30-25594681*r**32-14112094*r**34+2356125*r**36+7298*r**38)
            +3*Q2**2*(-4313+230260*r**2-3126990*r**4+15667060*r**6-58556705*r**8
            +5614189792*r**10-24588920600*r**12-141108574560*r**14-468178935250*r**16
            -2451613456600*r**18-1949622466788*r**20-755144441880*r**22+1851832881590*r**24
            -732358578880*r**26+472408852040*r**28-40098187648*r**30+1342331595*r**32
            -898532540*r**34-174530430*r**36+1803140*r**38+37707*r**40)-18*Q2*(
            -397+31013*r**2+248190*r**4-26348410*r**6+178447315*r**8+1583713473*r**10
            -1272858112*r**12+12536987360*r**14+108715887310*r**16-63624780190*r**18
            +367116721868*r**20+157435300988*r**22-1075475371290*r**24+668805592610*r**26
            -155239831440*r**28-14488694192*r**30-4984570817*r**32-1186756135*r**34
            -54414010*r**36-20533810*r**38+1223623*r**40+5053*r**42)+9*(-113+10430*r**2
            +124221*r**4-13915460*r**6+120458625*r**8+744356342*r**10-690302965*r**12
            +28486145456*r**14+98860868230*r**16+126814542300*r**18+619758474002*r**20
            -3104449405560*r**22+3895904772306*r**24-1922665264580*r**26+283783738150*r**28
            +2408722672*r**30-26605651205*r**32-1809481114*r**34-632078815*r**36
            -9129700*r**38-7490403*r**40+505550*r**42+1631*r**44))*sqrtq2+logq2**6*(
            -9405849600000*(-Q2+(-1+r)**2)*(-1+r)*r**26*(1+r)*(1+r**2)*(1-Q2
            +r**2)*(-1-4*r**2+r**4)*(-Q2+(1+r)**2)-9405849600000*r**26*(1+4*r**2
            -2*r**4-4*r**6+r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**5*(14929920000*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(70*Q2**7*(1+r**2)-10*Q2**6*(23+76*r**2
            +53*r**4)+10*Q2**5*(-23+125*r**2+305*r**4+157*r**6)-2*Q2**4*(-858-1351*r**2
            +1389*r**4+2903*r**6+1133*r**8)+4*Q2**3*(-411-1663*r**2-1744*r**4+554*r**6
            +1372*r**8+326*r**10)+2*Q2**2*(-612+853*r**2+4453*r**4+3032*r**6-664*r**8
            -595*r**10+337*r**12)-3*Q2*(-957-1022*r**2+1047*r**4+1068*r**6-735*r**8
            -498*r**10+645*r**12+452*r**14)+3*(-443-589*r**2-2175*r**4-1587*r**6
            +4321*r**8+989*r**10-985*r**12+291*r**14+178*r**16))-14929920000*r**22*(70*Q2**10*(1
            +r**2)-20*Q2**9*(22+59*r**2+37*r**4)+10*Q2**8*(67+457*r**2+727*r**4
            +337*r**6)-2*Q2**7*(-823+1549*r**2+9669*r**4+11503*r**6+4318*r**8)
            +14*Q2**6*(-518-1149*r**2+268*r**4+2962*r**6+3016*r**8+953*r**10)+Q2**5*(9086
            +36652*r**2+49978*r**4+8436*r**6-47814*r**8-44996*r**10-11606*r**12)
            +5*Q2**4*(-21-4522*r**2-13389*r**4-14272*r**6-4211*r**8+5058*r**10
            +4445*r**12+560*r**14)-3*(-1+r**2)**3*(443+1475*r**2+4239*r**4+8001*r**6
            +5267*r**8-43*r**10-47*r**12+647*r**14+178*r**16)+2*Q2**3*(-5985-5950*r**2
            +9419*r**4+20598*r**6+23613*r**8+8606*r**10-699*r**12+2170*r**14+2660*r**16)
            -2*Q2**2*(-6912-10649*r**2-10887*r**4-16467*r**6+9615*r**8+25745*r**10
            +2747*r**12-1801*r**14+5437*r**16+3172*r**18)+6*Q2*(-1143-1359*r**2
            -3003*r**4-5396*r**6-304*r**8+3532*r**10+7466*r**12+720*r**14-1717*r**16
            +711*r**18+493*r**20))*sqrtq2)+logq2**4*(41472000*r**18*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-1120*Q2**11+40*Q2**10*(343+463*r**2)
            -20*Q2**9*(3579+9401*r**2+5598*r**4)+16*Q2**8*(12476+47750*r**2+57837*r**4
            +21419*r**6)-4*Q2**7*(78047+391017*r**2+709339*r**4+544057*r**6+135368*r**8)
            +Q2**6*(266133+1567540*r**2+3800814*r**4+4400212*r**6+2291461*r**8+272832*r**10)
            +2*Q2**5*(-74123-361111*r**2-1140282*r**4-1039682*r**6-480911*r**8-6795*r**10
            +220528*r**12)+Q2**4*(127225+661490*r**2+3762451*r**4+1950140*r**6-5468913*r**8
            -5369086*r**10-2200635*r**12-756560*r**14)+12*Q2**3*(-5208-81095*r**2
            -509668*r**4-1039559*r**6-339684*r**8+699975*r**10+506372*r**12+145619*r**14
            +23848*r**16)+3*Q2**2*(-32539+42016*r**2-140156*r**4+3159048*r**6+5155610*r**8
            +1061288*r**10-877892*r**12-176040*r**14-97119*r**16+70584*r**18)-18*Q2*(
            -6999-34505*r**2-390024*r**4-140416*r**6+448558*r**8+65590*r**10-250860*r**12
            +118784*r**14+169481*r**16+8467*r**18+11924*r**20)+9*(-4381-34582*r**2
            -417725*r**4-330832*r**6-95334*r**8+393676*r**10+520586*r**12-228240*r**14
            +14467*r**16+171594*r**18+4915*r**20+5856*r**22))-41472000*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1120*Q2**11-40*Q2**10*(343+463*r**2)
            +20*Q2**9*(3579+9401*r**2+5598*r**4)-16*Q2**8*(12476+47750*r**2+57837*r**4
            +21419*r**6)+4*Q2**7*(78047+391017*r**2+709339*r**4+544057*r**6+135368*r**8)
            -Q2**6*(266133+1567540*r**2+3800814*r**4+4400212*r**6+2291461*r**8+272832*r**10)
            +Q2**5*(148246+722222*r**2+2280564*r**4+2079364*r**6+961822*r**8+13590*r**10
            -441056*r**12)+Q2**4*(-127225-661490*r**2-3762451*r**4-1950140*r**6
            +5468913*r**8+5369086*r**10+2200635*r**12+756560*r**14)-12*Q2**3*(-5208
            -81095*r**2-509668*r**4-1039559*r**6-339684*r**8+699975*r**10+506372*r**12
            +145619*r**14+23848*r**16)-3*Q2**2*(-32539+42016*r**2-140156*r**4+3159048*r**6
            +5155610*r**8+1061288*r**10-877892*r**12-176040*r**14-97119*r**16+70584*r**18)
            +18*Q2*(-6999-34505*r**2-390024*r**4-140416*r**6+448558*r**8+65590*r**10
            -250860*r**12+118784*r**14+169481*r**16+8467*r**18+11924*r**20)-9*(
            -4381-34582*r**2-417725*r**4-330832*r**6-95334*r**8+393676*r**10+520586*r**12
            -228240*r**14+14467*r**16+171594*r**18+4915*r**20+5856*r**22))*sqrtq2)
            +logq2**3*(2764800*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-6040*Q2**14
            +40*Q2**13*(1594+1717*r**2)-6*Q2**12*(47066+105627*r**2+56105*r**4)
            +4*Q2**11*(166353+615914*r**2+672236*r**4+218475*r**6)-4*Q2**10*(213954
            +1233470*r**2+2160818*r**4+1486603*r**6+277725*r**8)+30*Q2**9*(17658
            +159933*r**2+373524*r**4+406142*r**6+203128*r**8+2091*r**10)+10*Q2**8*(
            -8730-81919*r**2+406781*r**4+1318228*r**6+729770*r**8+127157*r**10
            +179709*r**12)-Q2**7*(14103+2215166*r**2+30766055*r**4+93813080*r**6
            +108457305*r**8+49318958*r**10+10896361*r**12+2134140*r**14)+3*Q2**6*(43947
            +359211*r**2+11650609*r**4+48168485*r**6+84376685*r**8+63097297*r**10
            +18606971*r**12+3683359*r**14+75900*r**16)+Q2**5*(-417443-154480*r**2
            -14503246*r**4-79196236*r**6-205266820*r**8-222991528*r**10-86498170*r**12
            +10443884*r**14-1054561*r**16+1426600*r**18)-5*Q2**4*(-69205-403917*r**2
            -1535816*r**4-7263066*r**6-22070188*r**8-7836032*r**10+16436874*r**12
            +21608978*r**14+13610857*r**16+1284133*r**18+216038*r**20)+15*Q2**3*(2201
            -157626*r**2-654129*r**4-4963312*r**6-16774294*r**8-16901308*r**10+5812862*r**12
            +15167456*r**14+9309725*r**16+2630070*r**18+306323*r**20+1232*r**22)
            +3*Q2**2*(-59967+26301*r**2-1108055*r**4+9244205*r**6+37514770*r**8
            +138715514*r**10+94138698*r**12-4616870*r**14-16613515*r**16-16724055*r**18
            +4344493*r**20-24359*r**22+106840*r**24)-9*Q2*(-9483-110254*r**2-1226156*r**4
            -4956660*r**6-27575015*r**8+5724286*r**10+23727088*r**12-9829088*r**14
            +1175335*r**16+11255590*r**18-469828*r**20+2159316*r**22+118219*r**24
            +16650*r**26)+9*(-1349-41985*r**2-471498*r**4-2888708*r**6-19012105*r**8
            +4372743*r**10+20073990*r**12-3066584*r**14-7941439*r**16+2125205*r**18
            +6265906*r**20-12580*r**22+559757*r**24+36197*r**26+2450*r**28))+2764800*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(6040*Q2**15-40*Q2**14*(1745+1868*r**2)
            +Q2**13*(346156+766202*r**2+405310*r**4)-2*Q2**12*(473904+1689907*r**2
            +1829668*r**4+605265*r**6)+4*Q2**11*(380307+2015737*r**2+3448968*r**4
            +2377314*r**6+496200*r**8)-2*Q2**10*(692778+5293843*r**2+12391436*r**4
            +13386972*r**6+6575576*r**8+586815*r**10)-20*Q2**9*(-30852-307346*r**2
            -596795*r**4-510385*r**6-549020*r**8-244250*r**10+86718*r**12)+Q2**8*(
            -73197+1308676*r**2+34014675*r**4+111063170*r**6+128937285*r**8+57888228*r**10
            +13965021*r**12+3931230*r**14)-2*Q2**7*(72972+1653451*r**2+33966524*r**4
            +134542295*r**6+227700220*r**8+173534077*r**10+58018116*r**12+12040289*r**14
            +1180920*r**16)+2*Q2**6*(274642+681977*r**2+25266353*r**4+129326759*r**6
            +301451165*r**8+332706737*r**10+165805487*r**12+28213553*r**14+6166169*r**16
            -599450*r**18)+2*Q2**5*(-381734-1295754*r**2-11168403*r**4-65007406*r**6
            -197406998*r**8-233719254*r**10-113652664*r**12+15995302*r**14+38721804*r**16
            +3396352*r**18+1253395*r**20)-10*Q2**4*(-31301-473000*r**2-1951060*r**4
            -11844409*r**6-39828068*r**8-40305072*r**10+13019714*r**12+41774110*r**14
            +31574505*r**16+11392600*r**18+1209570*r**20+109867*r**22)-6*Q2**3*(
            -35486+401713*r**2+1475360*r**4+18665705*r**6+73101400*r**8+153546762*r**10
            +74790464*r**12-54759230*r**14-69499710*r**16-38211515*r**18-5168736*r**20
            -781067*r**22+50340*r**24)+6*Q2**2*(-44208-182214*r**2-2380111*r**4
            -3366915*r**6-17983035*r**8+96701571*r**10+152017738*r**12+30017282*r**14
            -8852190*r**16+214600*r**18-6894523*r**20+5399041*r**22+218569*r**24
            +78395*r**26)-18*Q2*(-5416-80861*r**2-903954*r**4-4535762*r**6-25771890*r**8
            -8738993*r**10+24762682*r**12+5415708*r**14-8297596*r**16+7278065*r**18
            +8525834*r**20+838454*r**22+1418646*r**24+85533*r**26+9550*r**28)+9*(
            -1349-43334*r**2-513483*r**4-3360206*r**6-21900813*r**8-14639362*r**10
            +24446733*r**12+17007406*r**14-11008023*r**16-5816234*r**18+8391111*r**20
            +6253326*r**22+547177*r**24+595954*r**26+38647*r**28+2450*r**30))*sqrtq2)
            +logq2**2*(-11520*r**10*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17
            -8*Q2**16*(135817+150101*r**2)+8*Q2**15*(609837+1424108*r**2+709791*r**4)
            -8*Q2**14*(1497790+5665821*r**2+6164498*r**4+1670155*r**6)+8*Q2**13*(2052205
            +11807174*r**2+19627106*r**4+13279952*r**6+1570775*r**8)+Q2**12*(-9276675
            -97625268*r**2-162375498*r**4-170092020*r**6-87823939*r**8+10951320*r**10)
            -4*Q2**11*(1841403-2378739*r**2+72594868*r**4+176570458*r**6+97819623*r**8
            +24693229*r**10+9892734*r**12)+2*Q2**10*(9261111+50180850*r**2+514798421*r**4
            +1698206280*r**6+1881190105*r**8+716700482*r**10+157336027*r**12+14469828*r**14)
            +4*Q2**9*(-3352365-32232891*r**2-271078323*r**4-1352556375*r**6-2375510525*r**8
            -1673827605*r**10-350439261*r**12-63361633*r**14+4846770*r**16)+Q2**8*(
            -2729705+88671816*r**2+290389124*r**4+2654978408*r**6+6371797290*r**8
            +7327078400*r**10+3114119876*r**12-691377336*r**14-92962057*r**16-42913400*r**18)
            +8*Q2**7*(1747270-4971133*r**2+15127487*r**4+266907120*r**6+1492747966*r**8
            +2719556390*r**10+1861043472*r**12+853863832*r**14+317972780*r**16+40114391*r**18
            +1878665*r**20)+4*Q2**6*(-2456967-4677472*r**2+23073081*r**4-603032454*r**6
            -5851481694*r**8-16113018636*r**10-17957269110*r**12-8332675944*r**14
            -2848468779*r**16-372895044*r**18-46067315*r**20+4119774*r**22)-8*Q2**5*(229304
            -8600451*r**2-13472499*r**4-7450835*r**6-1468763325*r**8-6396000186*r**10
            -11704337214*r**12-7844229138*r**14-1198700610*r**16-511036475*r**18
            +106568217*r**20+8467725*r**22+1935887*r**24)+Q2**4*(6068155-55416868*r**2
            -529648674*r**4-565030660*r**6-2269446875*r**8-12054143520*r**10-35736518844*r**12
            -25962685992*r**14+17453038725*r**16+29611067900*r**18+4735543390*r**20
            +1370532012*r**22+129316891*r**24+1225160*r**26)+12*Q2**3*(-174505+109941*r**2
            +26994944*r**4+148392198*r**6+449400505*r**8+2459787075*r**10+4694349898*r**12
            +1521190932*r**14-2935005991*r**16-4346643205*r**18-2161639620*r**20
            -407821914*r**22-28949801*r**24-3480307*r**26+289850*r**28)-6*Q2**2*(189515
            -3931222*r**2-17811067*r**4+102589440*r**6+16192019*r**8+4091115470*r**10
            +11119907829*r**12+14975348124*r**14+4310241465*r**16-1116035738*r**18
            -4526104505*r**20+502957768*r**22-109686807*r**24+45159970*r**26+2918719*r**28
            +229020*r**30)+36*Q2*(26931-379535*r**2-4452807*r**4-14409807*r**6
            -176564787*r**8-451164495*r**10-1711459887*r**12+1089967489*r**14+475970739*r**16
            +27232299*r**18+820620947*r**20-372775221*r**22+286607943*r**24+25195443*r**26
            +5163363*r**28+420867*r**30+518*r**32)+9*(-21679+281592*r**2+4639432*r**4
            +30912240*r**6+319818060*r**8+1430620872*r**10+5770391864*r**12-8304862496*r**14
            -4018542330*r**16+8182983880*r**18-268700232*r**20-3464268304*r**22+686961996*r**24
            -329849160*r**26-36352440*r**28-3686336*r**30-332527*r**32+5568*r**34))
            -11520*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17-8*Q2**16*(135817
            +150101*r**2)+8*Q2**15*(609837+1424108*r**2+709791*r**4)-8*Q2**14*(1497790
            +5665821*r**2+6164498*r**4+1670155*r**6)+8*Q2**13*(2052205+11807174*r**2
            +19627106*r**4+13279952*r**6+1570775*r**8)+Q2**12*(-9276675-97625268*r**2
            -162375498*r**4-170092020*r**6-87823939*r**8+10951320*r**10)-4*Q2**11*(1841403
            -2378739*r**2+72594868*r**4+176570458*r**6+97819623*r**8+24693229*r**10
            +9892734*r**12)+2*Q2**10*(9261111+50180850*r**2+514798421*r**4+1698206280*r**6
            +1881190105*r**8+716700482*r**10+157336027*r**12+14469828*r**14)+4*Q2**9*(
            -3352365-32232891*r**2-271078323*r**4-1352556375*r**6-2375510525*r**8
            -1673827605*r**10-350439261*r**12-63361633*r**14+4846770*r**16)+Q2**8*(
            -2729705+88671816*r**2+290389124*r**4+2654978408*r**6+6371797290*r**8
            +7327078400*r**10+3114119876*r**12-691377336*r**14-92962057*r**16-42913400*r**18)
            +8*Q2**7*(1747270-4971133*r**2+15127487*r**4+266907120*r**6+1492747966*r**8
            +2719556390*r**10+1861043472*r**12+853863832*r**14+317972780*r**16+40114391*r**18
            +1878665*r**20)+4*Q2**6*(-2456967-4677472*r**2+23073081*r**4-603032454*r**6
            -5851481694*r**8-16113018636*r**10-17957269110*r**12-8332675944*r**14
            -2848468779*r**16-372895044*r**18-46067315*r**20+4119774*r**22)-8*Q2**5*(229304
            -8600451*r**2-13472499*r**4-7450835*r**6-1468763325*r**8-6396000186*r**10
            -11704337214*r**12-7844229138*r**14-1198700610*r**16-511036475*r**18
            +106568217*r**20+8467725*r**22+1935887*r**24)+Q2**4*(6068155-55416868*r**2
            -529648674*r**4-565030660*r**6-2269446875*r**8-12054143520*r**10-35736518844*r**12
            -25962685992*r**14+17453038725*r**16+29611067900*r**18+4735543390*r**20
            +1370532012*r**22+129316891*r**24+1225160*r**26)+12*Q2**3*(-174505+109941*r**2
            +26994944*r**4+148392198*r**6+449400505*r**8+2459787075*r**10+4694349898*r**12
            +1521190932*r**14-2935005991*r**16-4346643205*r**18-2161639620*r**20
            -407821914*r**22-28949801*r**24-3480307*r**26+289850*r**28)-6*Q2**2*(189515
            -3931222*r**2-17811067*r**4+102589440*r**6+16192019*r**8+4091115470*r**10
            +11119907829*r**12+14975348124*r**14+4310241465*r**16-1116035738*r**18
            -4526104505*r**20+502957768*r**22-109686807*r**24+45159970*r**26+2918719*r**28
            +229020*r**30)+36*Q2*(26931-379535*r**2-4452807*r**4-14409807*r**6
            -176564787*r**8-451164495*r**10-1711459887*r**12+1089967489*r**14+475970739*r**16
            +27232299*r**18+820620947*r**20-372775221*r**22+286607943*r**24+25195443*r**26
            +5163363*r**28+420867*r**30+518*r**32)+9*(-21679+281592*r**2+4639432*r**4
            +30912240*r**6+319818060*r**8+1430620872*r**10+5770391864*r**12-8304862496*r**14
            -4018542330*r**16+8182983880*r**18-268700232*r**20-3464268304*r**22+686961996*r**24
            -329849160*r**26-36352440*r**28-3686336*r**30-332527*r**32+5568*r**34))*sqrtq2)
            +logq2*(-384*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(54928*Q2**20
            -10*Q2**19*(80571+66179*r**2)+10*Q2**18*(454635+932826*r**2+315743*r**4)
            -10*Q2**17*(1276291+4810467*r**2+4156451*r**4+713027*r**6)+10*Q2**16*(1673240
            +11757431*r**2+16884235*r**4+8279349*r**6+491705*r**8)+2*Q2**15*(291279
            -59156055*r**2-97945590*r**4-57271710*r**6-13876615*r**8+5923559*r**10)
            -10*Q2**14*(3179247+6569403*r**2+44188566*r**4+120967604*r**6+75147541*r**8
            +19669647*r**10+2857988*r**12)+5*Q2**13*(6433205+60642984*r**2+332390965*r**4
            +1097862886*r**6+1214635191*r**8+416413088*r**10+71427359*r**12+2563602*r**14)
            +5*Q2**12*(2841111-57953133*r**2-397686891*r**4-1861102247*r**6-3137405283*r**8
            -2048826147*r**10-287234445*r**12-19839849*r**14+5847972*r**16)-10*Q2**11*(4707430
            -926967*r**2-54829074*r**4-505111764*r**6-907956088*r**8-915369848*r**10
            -228097682*r**12+224264136*r**14+38356662*r**16+4072315*r**18)+4*Q2**10*(4510077
            +57863495*r**2+319685970*r**4+1470662320*r**6+7814017520*r**8+15640213853*r**10
            +10006163165*r**12+4434888910*r**14+1170745425*r**16+110393910*r**18
            +307307*r**20)+5*Q2**9*(5179239-46755564*r**2-368681911*r**4-2195790494*r**6
            -12439153626*r**8-38209590004*r**10-42558233486*r**12-16668936056*r**14
            -5253633789*r**16-332977536*r**18+1654389*r**20+6524726*r**22)-5*Q2**8*(4790695
            -9929301*r**2-197781337*r**4-1286268433*r**6-6195004898*r**8-34209666554*r**10
            -64772250554*r**12-44191072906*r**14-4893941093*r**16-1309794993*r**18
            +635093811*r**20+64911899*r**22+3840512*r**24)-10*Q2**7*(418313-13654759*r**2
            -41127194*r**4+269462462*r**6-1165420083*r**8-4237010291*r**10-10083900548*r**12
            -7245547460*r**14-8905623285*r**16-9160838453*r**18-1980677810*r**20
            -352827146*r**22-18460977*r**24+878591*r**26)+10*Q2**6*(1260165-14437827*r**2
            -105316878*r**4+264511880*r**6-381884731*r**8-13983361421*r**10-69660249688*r**12
            -119098406816*r**14-79333297209*r**16-39759741061*r**18-9544382366*r**20
            -2109246552*r**22-23532033*r**24+5803877*r**26+1259540*r**28)+Q2**5*(
            -2662377+10974120*r**2+484828155*r**4+1307981450*r**6-5161804645*r**8
            +33108765192*r**10+526380826495*r**12+1549238069610*r**14+1691496856965*r**16
            +536428413960*r**18+280893888657*r**20-12171448290*r**22+2098864585*r**24
            -1617715640*r**26-97736715*r**28-1429522*r**30)-5*Q2**4*(616103-12728853*r**2
            -43586543*r**4+1216863773*r**6+2902206467*r**8-2592019133*r**10+9559984153*r**12
            +70032535581*r**14+214049147049*r**16+74508298201*r**18-130117787973*r**20
            -16769631217*r**22-12492555863*r**24-1835799047*r**26-184875493*r**28
            -4948297*r**30+677892*r**32)+30*Q2**3*(49245-1005552*r**2-8390298*r**4
            +119452576*r**6+558599956*r**8+1463384198*r**10+4420500082*r**12+16969717740*r**14
            +13720059258*r**16+1342738458*r**18-21945512406*r**20-26796182328*r**22
            -7139162596*r**24-723747334*r**26-178221314*r**28+1417388*r**30+417273*r**32
            +45654*r**34)+30*Q2**2*(8287-277846*r**2+897755*r**4+45300500*r**6-28432468*r**8
            -1149771430*r**10-2275208286*r**12-30409099688*r**14-44294454506*r**16
            -25153597574*r**18-6278370596*r**20+21798649780*r**22-2492912204*r**24
            +2461427062*r**26-384866858*r**28-11605536*r**30-7241173*r**32-294388*r**34
            +9169*r**36)-45*Q2*(6425-211762*r**2-781057*r**4+43411204*r**6+82312436*r**8
            +322380516*r**10+4640825532*r**12+4639058012*r**14+19868199534*r**16
            -9857533632*r**18-6747069582*r**20-23382970028*r**22+18100809572*r**24
            -6819671780*r**26-669629844*r**28-191633484*r**30-25702367*r**32-1765902*r**34
            -39833*r**36+6040*r**38)+9*(5787-220735*r**2-1105095*r**4+57261285*r**6
            +101088130*r**8+1458374292*r**10+12154764580*r**12+29670853060*r**14
            +98584777970*r**16-304538439490*r**18+133768147902*r**20+164166435670*r**22
            -161489742960*r**24+35126704580*r**26-6861747660*r**28-2010898828*r**30
            -153685765*r**32-31511255*r**34-1056335*r**36-10355*r**38+5222*r**40))
            +384*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(54928*Q2**21-2*Q2**20*(430319
            +358359*r**2)+20*Q2**19*(267603+539788*r**2+190961*r**4)-20*Q2**18*(865463
            +3098964*r**2+2702510*r**4+514385*r**6)+10*Q2**17*(2949531+17844189*r**2
            +25851153*r**4+13148827*r**6+1204732*r**8)+2*Q2**16*(-8074921-126309410*r**2
            -241153920*r**4-183089630*r**6-57731885*r**8+3465034*r**10)-2*Q2**15*(16187514
            -26017761*r**2+63841185*r**4+449620720*r**6+304589380*r**8+90395179*r**10
            +20213499*r**12)+5*Q2**14*(12791699+80140284*r**2+433906903*r**4+1428175226*r**6
            +1606865481*r**8+606047464*r**10+116482629*r**12+8279578*r**14)+10*Q2**13*(
            -1796047-62514661*r**2-395360420*r**4-1645678049*r**6-2724951680*r**8
            -1839937213*r**10-387537446*r**12-46915405*r**14+1642185*r**16)-5*Q2**12*(12255971
            -56965956*r**2-565298172*r**4-3269012666*r**6-6814419706*r**8-7016971126*r**10
            -2792255956*r**12+141453978*r**14+62721447*r**16+13992602*r**18)+2*Q2**11*(32557304
            +134629305*r**2+360591735*r**4+141620450*r**6+8562695780*r**8+22163798026*r**10
            +14294988680*r**12+8850610090*r**14+3654594840*r**16+432932705*r**18
            +20976189*r**20)+Q2**10*(7855887-483272108*r**2-3353607415*r**4-18140345630*r**6
            -99334487490*r**8-284864875512*r**10-315376675502*r**12-141108888580*r**14
            -48690706285*r**16-6789445020*r**18-434532923*r**20+31394402*r**22)-10*Q2**9*(4984967
            -25752813*r**2-306609406*r**4-1925370419*r**6-10414974509*r**8-42429205092*r**10
            -72770037022*r**12-51709121224*r**14-13408255469*r**16-3448203159*r**18
            +151885332*r**20+36545507*r**22+5182619*r**24)+5*Q2**8*(3954069+22170912*r**2
            -125456250*r**4-2022974694*r**6-5150433165*r**8-31930650870*r**10-78814116012*r**12
            -94472228540*r**14-31273767429*r**16+12117940820*r**18+3286654438*r**20
            +1405660002*r**22+105674365*r**24+2083330*r**26)+10*Q2**7*(1678478-27674273*r**2
            -160098831*r**4+492847148*r**6-1277842352*r**8-19385791795*r**10-83981160527*r**12
            -136427854824*r**14-95484467954*r**16-57826202799*r**18-20685898629*r**20
            -4442751508*r**22-394820156*r**24-11778509*r**26+2138131*r**28)+Q2**6*(
            -15264027+142750740*r**2+1682375205*r**4-283968570*r**6-3988076135*r**8
            +176761226712*r**10+1362816937585*r**12+3436824634650*r**14+3675813897215*r**16
            +1727358796660*r**18+773935122927*r**20+104364840890*r**22+23426650435*r**24
            -1440434080*r**26-168370885*r**28-14024922*r**30)-2*Q2**5*(209069-27666261*r**2
            +138934780*r**4+3938564235*r**6+5328604570*r**8+7493432441*r**10+303644756226*r**12
            +1212890787005*r**14+2155490330910*r**16+1300233380965*r**18+83366681376*r**20
            +92437142141*r**22-36267681510*r**24-4348923145*r**26-1319914910*r**28
            -61953861*r**30+979969*r**32)+5*Q2**4*(911573-18146062*r**2-106657184*r**4
            +1889992686*r**6+7470669976*r**8+9090492522*r**10+33490965512*r**12+181410826174*r**14
            +366402038178*r**16+296613875998*r**18-187282564208*r**20-307664513158*r**22
            -72097162656*r**24-18670838914*r**26-3090002424*r**28-181319462*r**30
            -1766767*r**32+951816*r**34)-30*Q2**3*(40958-678461*r**2-10293605*r**4
            +65761778*r**6+706485000*r**8+3171755584*r**10+8159092566*r**12+51799317510*r**14
            +74984231504*r**16+40216395290*r**18-14324403352*r**20-70540344514*r**22
            -31442432720*r**24-10324336992*r**26-517101790*r**28-165198390*r**30
            +9075834*r**32+757315*r**34+36485*r**36)-15*Q2**2*(35849-1174404*r**2
            -1103353*r**4+222630122*r**6+280673372*r**8-1389266248*r**10+7072517164*r**12
            -51451441912*r**14-89802509786*r**16-168468705056*r**18-83105145086*r**20
            -39108351716*r**22+92913903868*r**24-20521985624*r**26+2144230876*r**28
            -1367845240*r**30-114800519*r**32-20368828*r**34-689937*r**36+36458*r**38)
            +18*Q2*(18956-623710*r**2-3034595*r**4+135206010*r**6+364853165*r**8
            +1740919526*r**10+18485397410*r**12+38035135390*r**14+110560532850*r**16
            -127242554990*r**18+25372565916*r**20+6758118810*r**22-93950272620*r**24
            +45766196770*r**26-22154127890*r**28-3158607734*r**30-620182510*r**32
            -84426300*r**34-5042505*r**36-89660*r**38+17711*r**40)-9*(5787-214948*r**2
            -1325830*r**4+56156190*r**6+158349415*r**8+1559462422*r**10+13613138872*r**12
            +41825617640*r**14+128255631030*r**16-205953661520*r**18-170770291588*r**20
            +297934583572*r**22+2676692710*r**24-126363038380*r**26+28264956920*r**28
            -8872646488*r**30-2164584593*r**32-185197020*r**34-32567590*r**36-1066690*r**38
            -5133*r**40+5222*r**42))*sqrtq2))*math.log(2*muWC))/(-17500*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-17500*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2+logq2**6*(783820800000*r**26*(1+r**2)*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -783820800000*r**26*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**3*(604800000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))+604800000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))*sqrtq2)+logq2*(2100000*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)
            -Q2**2*(5+2*r**2+5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))+2100000*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)-Q2**2*(5+2*r**2
            +5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))*sqrtq2)+logq2**2*(-12600000*(
            -Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(16*Q2**4+Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1
            +9*r**2+9*r**4+r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))-12600000*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(16*Q2**4
            +Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1+9*r**2+9*r**4
            +r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))*sqrtq2)+logq2**4*(-1814400000*(
            -Q2+(-1+r)**2)*r**18*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))
            -1814400000*(-Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))*sqrtq2)
            +logq2**5*(8709120000*(-Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2
            +41*r**4)-18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4
            -82*r**6+13*r**8))+8709120000*(-Q2+(-1+r)**2)*r**22*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2+41*r**4)
            -18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4-82*r**6
            +13*r**8))*sqrtq2))+((128*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(-92*Q2**23
            +24*Q2**22*(9+269*r**2)+8*Q2**21*(759+16576*r**2+17418*r**4)-Q2**20*(53501
            +2536835*r**2+26069823*r**4+2627753*r**6)+2*Q2**19*(105975+8510556*r**2
            +173236090*r**4+174340172*r**6+8829891*r**8)-2*Q2**18*(238851+31358329*r**2
            +973120058*r**4+2083773094*r**6+983705459*r**8+32615985*r**10)+2*Q2**17*(292443
            +70301554*r**2+2868182263*r**4+10010340012*r**6+10050868541*r**8+2913747242*r**10
            +73087809*r**12)-3*Q2**16*(47651+62569145*r**2+2807340195*r**4+15201366193*r**6
            +22748648245*r**8+15345950367*r**10+2880219445*r**12+64435303*r**14)
            +8*Q2**15*(-88842+14193044*r**2+128094987*r**4+4128980631*r**6+4331591198*r**8
            +4439230734*r**10+4282430247*r**12+163674587*r**14+13800438*r**16)+8*Q2**14*(133025
            +5840983*r**2+2254615695*r**4+9108653796*r**6+42177035281*r**8+76569372060*r**10
            +41734901679*r**12+8826803650*r**14+2243996976*r**16+7831463*r**18)-8*Q2**13*(38199
            +12045222*r**2+3556163584*r**4+24810112247*r**6+110276879583*r**8+276205720627*r**10
            +275464001141*r**12+109325304417*r**14+24501216562*r**16+3603072047*r**18
            +13953411*r**20)+Q2**12*(-767754-61576710*r**2+8688340882*r**4+166080184598*r**6
            +703997289964*r**8+2632378999492*r**10+3659840226596*r**12+2615289390460*r**14
            +696511647982*r**16+165891079154*r**18+9386067002*r**20-66210690*r**22)
            +4*Q2**11*(210613+56244708*r**2+6077530264*r**4+6876864778*r**6+108470004527*r**8
            +125461319304*r**10+508867865472*r**12+513418022012*r**14+129979707531*r**16
            +107805796948*r**18+5779706584*r**20+5962942778*r**22+61360897*r**24)
            -4*Q2**10*(-17391+40152099*r**2+7339287020*r**4+40261241614*r**6+288072430629*r**8
            +1017889621433*r**10+3085679809372*r**12+4931771626080*r**14+3094056262175*r**16
            +1016316212905*r**18+284685915000*r**20+38580252722*r**22+7392547435*r**24
            +42590811*r**26)+4*Q2**9*(-184875-10937266*r**2+474657235*r**4+32593447358*r**6
            +144126753007*r**8+818799400000*r**10+2777275423937*r**12+7049812934500*r**14
            +7056011342107*r**16+2787580439174*r**18+808196909245*r**20+141924575230*r**22
            +31945111265*r**24+643710988*r**26-14234001*r**28)+2*Q2**8*(261579+65621513*r**2
            +9843323771*r**4-26752509867*r**6+81120095251*r**8-158764932159*r**10
            +1009225949619*r**12-4199049125507*r**14-6538471062063*r**16-4210773309045*r**18
            +988848060385*r**20-128755508145*r**22+78974297745*r**24-28856408597*r**26
            +9585717553*r**28+74928927*r**30)-4*Q2**7*(-5559+13413432*r**2+3400888998*r**4
            -1050546858*r**6+32397639576*r**8+125801638724*r**10+1869902245186*r**12
            +1893035779746*r**14+3672177272270*r**16+3665727893104*r**18+1887147795786*r**20
            +1871018224826*r**22+134558490712*r**24+31147374804*r**26-2496044274*r**28
            +3398396430*r**30+14638137*r**32)-8*Q2**6*(29526+4231052*r**2+233519751*r**4
            -5280045336*r**6+8263607027*r**8-52124758382*r**10-399813684427*r**12
            -327292792154*r**14-975272096711*r**16-1670563799140*r**18-963111631943*r**20
            -296670010892*r**22-413414790187*r**24-49088051558*r**26+7905997323*r**28
            -5073574146*r**30+197657897*r**32+5049900*r**34)+8*Q2**5*(15698+5086322*r**2
            +808113108*r**4-7810429365*r**6-5914592575*r**8-133645055569*r**10-310969225215*r**12
            -466504769453*r**14-393962537907*r**16+627970220099*r**18+639883046665*r**20
            -364422836823*r**22-375716870133*r**24-333205091819*r**26-126472023029*r**28
            -6311724999*r**30-8033973739*r**32+780809223*r**34+5820311*r**36)+Q2**4*(3975
            -9859287*r**2-2469103555*r**4+29731865731*r**6+135356515692*r**8+1017842189220*r**10
            +3908495659620*r**12+8322195403500*r**14+16851453424114*r**16-15440367875266*r**18
            +23670120350790*r**20-16516711447094*r**22+16650464082620*r**24+7518855280884*r**26
            +4005728335956*r**28+988771421340*r**30+134114530911*r**32+31311741185*r**34
            -2431921979*r**36-10662357*r**38)-2*Q2**3*(16761+3009796*r**2+317685002*r**4
            -4826403824*r**6+26733572585*r**8+40823715648*r**10+574288549080*r**12
            +1880542409120*r**14+3002889519634*r**16-11128620769144*r**18+10852543165788*r**20
            +10771541060512*r**22-11678283290566*r**24+2892048092704*r**26+1844754808728*r**28
            +545643017376*r**30+46044356437*r**32+26013498644*r**34-4730713814*r**36
            +296112656*r**38+3674877*r**40)+3*(-1+r**2)**2*(113+49077*r**2+9904922*r**4
            -311660206*r**6-1370363115*r**8-14049899095*r**10-112958565256*r**12
            +255598286904*r**14-2879119902302*r**16+11924541035210*r**18-33420178571268*r**20
            +48049635435116*r**22-33870581748174*r**24+12256574682522*r**26-2970052589000*r**28
            +285975212344*r**30-115345032147*r**32-13778318527*r**34-1334723014*r**36
            -319495470*r**38+9564281*r**40+57085*r**42)+2*Q2**2*(8333+2461687*r**2
            +405709042*r**4-8303129902*r**6-6836165371*r**8-184946567365*r**10-814803040560*r**12
            +1110318763472*r**14-10744733590366*r**16+16726697882726*r**18-4673375047260*r**20
            -17719399206684*r**22-4266648604870*r**24+17349546284038*r**26-11216177224064*r**28
            +1398949569408*r**30-867988969775*r**32-176807094269*r**34-6622519270*r**36
            -8446332166*r**38+389507009*r**40+2906207*r**42)-6*Q2*(623+229994*r**2
            +42861447*r**4-1138336984*r**6-2152620703*r**8-34241468834*r**10-210191667951*r**12
            +573077045936*r**14-4563748203018*r**16+15723583040564*r**18-30986852717626*r**20
            +19096666870784*r**22+18608349591170*r**24-31300771559412*r**26+16218070984706*r**28
            -4767721587888*r**30+648282359659*r**32-218912449086*r**34-33289478461*r**36
            -2045521192*r**38-1162212275*r**40+41289014*r**42+269533*r**44))-128*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7
            +2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2*(92*Q2**23-24*Q2**22*(9+269*r**2)-8*Q2**21*(759+16576*r**2
            +17418*r**4)+Q2**20*(53501+2536835*r**2+26069823*r**4+2627753*r**6)
            -2*Q2**19*(105975+8510556*r**2+173236090*r**4+174340172*r**6+8829891*r**8)
            +2*Q2**18*(238851+31358329*r**2+973120058*r**4+2083773094*r**6+983705459*r**8
            +32615985*r**10)-2*Q2**17*(292443+70301554*r**2+2868182263*r**4+10010340012*r**6
            +10050868541*r**8+2913747242*r**10+73087809*r**12)+3*Q2**16*(47651+62569145*r**2
            +2807340195*r**4+15201366193*r**6+22748648245*r**8+15345950367*r**10
            +2880219445*r**12+64435303*r**14)-8*Q2**15*(-88842+14193044*r**2+128094987*r**4
            +4128980631*r**6+4331591198*r**8+4439230734*r**10+4282430247*r**12+163674587*r**14
            +13800438*r**16)-8*Q2**14*(133025+5840983*r**2+2254615695*r**4+9108653796*r**6
            +42177035281*r**8+76569372060*r**10+41734901679*r**12+8826803650*r**14
            +2243996976*r**16+7831463*r**18)+8*Q2**13*(38199+12045222*r**2+3556163584*r**4
            +24810112247*r**6+110276879583*r**8+276205720627*r**10+275464001141*r**12
            +109325304417*r**14+24501216562*r**16+3603072047*r**18+13953411*r**20)
            +2*Q2**12*(383877+30788355*r**2-4344170441*r**4-83040092299*r**6-351998644982*r**8
            -1316189499746*r**10-1829920113298*r**12-1307644695230*r**14-348255823991*r**16
            -82945539577*r**18-4693033501*r**20+33105345*r**22)-4*Q2**11*(210613
            +56244708*r**2+6077530264*r**4+6876864778*r**6+108470004527*r**8+125461319304*r**10
            +508867865472*r**12+513418022012*r**14+129979707531*r**16+107805796948*r**18
            +5779706584*r**20+5962942778*r**22+61360897*r**24)+4*Q2**10*(-17391+40152099*r**2
            +7339287020*r**4+40261241614*r**6+288072430629*r**8+1017889621433*r**10
            +3085679809372*r**12+4931771626080*r**14+3094056262175*r**16+1016316212905*r**18
            +284685915000*r**20+38580252722*r**22+7392547435*r**24+42590811*r**26)
            +4*Q2**9*(184875+10937266*r**2-474657235*r**4-32593447358*r**6-144126753007*r**8
            -818799400000*r**10-2777275423937*r**12-7049812934500*r**14-7056011342107*r**16
            -2787580439174*r**18-808196909245*r**20-141924575230*r**22-31945111265*r**24
            -643710988*r**26+14234001*r**28)-2*Q2**8*(261579+65621513*r**2+9843323771*r**4
            -26752509867*r**6+81120095251*r**8-158764932159*r**10+1009225949619*r**12
            -4199049125507*r**14-6538471062063*r**16-4210773309045*r**18+988848060385*r**20
            -128755508145*r**22+78974297745*r**24-28856408597*r**26+9585717553*r**28
            +74928927*r**30)+4*Q2**7*(-5559+13413432*r**2+3400888998*r**4-1050546858*r**6
            +32397639576*r**8+125801638724*r**10+1869902245186*r**12+1893035779746*r**14
            +3672177272270*r**16+3665727893104*r**18+1887147795786*r**20+1871018224826*r**22
            +134558490712*r**24+31147374804*r**26-2496044274*r**28+3398396430*r**30
            +14638137*r**32)+8*Q2**6*(29526+4231052*r**2+233519751*r**4-5280045336*r**6
            +8263607027*r**8-52124758382*r**10-399813684427*r**12-327292792154*r**14
            -975272096711*r**16-1670563799140*r**18-963111631943*r**20-296670010892*r**22
            -413414790187*r**24-49088051558*r**26+7905997323*r**28-5073574146*r**30
            +197657897*r**32+5049900*r**34)-8*Q2**5*(15698+5086322*r**2+808113108*r**4
            -7810429365*r**6-5914592575*r**8-133645055569*r**10-310969225215*r**12
            -466504769453*r**14-393962537907*r**16+627970220099*r**18+639883046665*r**20
            -364422836823*r**22-375716870133*r**24-333205091819*r**26-126472023029*r**28
            -6311724999*r**30-8033973739*r**32+780809223*r**34+5820311*r**36)+Q2**4*(
            -3975+9859287*r**2+2469103555*r**4-29731865731*r**6-135356515692*r**8
            -1017842189220*r**10-3908495659620*r**12-8322195403500*r**14-16851453424114*r**16
            +15440367875266*r**18-23670120350790*r**20+16516711447094*r**22-16650464082620*r**24
            -7518855280884*r**26-4005728335956*r**28-988771421340*r**30-134114530911*r**32
            -31311741185*r**34+2431921979*r**36+10662357*r**38)+2*Q2**3*(16761+3009796*r**2
            +317685002*r**4-4826403824*r**6+26733572585*r**8+40823715648*r**10+574288549080*r**12
            +1880542409120*r**14+3002889519634*r**16-11128620769144*r**18+10852543165788*r**20
            +10771541060512*r**22-11678283290566*r**24+2892048092704*r**26+1844754808728*r**28
            +545643017376*r**30+46044356437*r**32+26013498644*r**34-4730713814*r**36
            +296112656*r**38+3674877*r**40)-3*(-1+r**2)**2*(113+49077*r**2+9904922*r**4
            -311660206*r**6-1370363115*r**8-14049899095*r**10-112958565256*r**12
            +255598286904*r**14-2879119902302*r**16+11924541035210*r**18-33420178571268*r**20
            +48049635435116*r**22-33870581748174*r**24+12256574682522*r**26-2970052589000*r**28
            +285975212344*r**30-115345032147*r**32-13778318527*r**34-1334723014*r**36
            -319495470*r**38+9564281*r**40+57085*r**42)-2*Q2**2*(8333+2461687*r**2
            +405709042*r**4-8303129902*r**6-6836165371*r**8-184946567365*r**10-814803040560*r**12
            +1110318763472*r**14-10744733590366*r**16+16726697882726*r**18-4673375047260*r**20
            -17719399206684*r**22-4266648604870*r**24+17349546284038*r**26-11216177224064*r**28
            +1398949569408*r**30-867988969775*r**32-176807094269*r**34-6622519270*r**36
            -8446332166*r**38+389507009*r**40+2906207*r**42)+6*Q2*(623+229994*r**2
            +42861447*r**4-1138336984*r**6-2152620703*r**8-34241468834*r**10-210191667951*r**12
            +573077045936*r**14-4563748203018*r**16+15723583040564*r**18-30986852717626*r**20
            +19096666870784*r**22+18608349591170*r**24-31300771559412*r**26+16218070984706*r**28
            -4767721587888*r**30+648282359659*r**32-218912449086*r**34-33289478461*r**36
            -2045521192*r**38-1162212275*r**40+41289014*r**42+269533*r**44))*sqrtq2
            +logq2**8*(162533081088000000*r**36*(1+r**2)**2*(1-Q2+r**2)*(-1+33*r**2
            -115*r**4+35*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+162533081088000000*(Q2
            -(-1+r)**2)**2*r**36*(1+r**2)**2*(-1+33*r**2-115*r**4+35*r**6)*(Q2-(1
            +r)**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**7*(-257989017600000*r**32*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-1750*Q2**9*(1+r**2)+50*Q2**8*(185
            +376*r**2+191*r**4)-100*Q2**7*(75+466*r**2+490*r**4+99*r**6)-2*Q2**6*(24003
            +15151*r**2-16179*r**4+7569*r**6+20048*r**8)+2*Q2**5*(68523+138429*r**2
            +75452*r**4+64120*r**6+120727*r**8+62153*r**10)-Q2**4*(112035+359323*r**2
            +274526*r**4+19906*r**6+235299*r**8+326183*r**10+104160*r**12)-Q2**3*(78575
            -1912*r**2-30061*r**4+30032*r**6+40305*r**8-11768*r**10+893*r**12+73360*r**14)
            +6*(-1+r**2)**2*(6619+10492*r**2-14710*r**4+592*r**6+78446*r**8-1368*r**10
            -15746*r**12+9996*r**14+6319*r**16)+Q2**2*(219065+287687*r**2+41965*r**4
            -46837*r**6+282647*r**8-54191*r**10+39227*r**12+273437*r**14+206920*r**16)
            -3*Q2*(52403+43602*r**2-92226*r**4-45106*r**6+380956*r**8+369126*r**10
            -60198*r**12-94870*r**14+41625*r**16+49808*r**18))-257989017600000*r**32*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1750*Q2**10*(1+r**2)-100*Q2**9*(110
            +223*r**2+113*r**4)+50*Q2**8*(335+1493*r**2+1547*r**4+389*r**6)+2*Q2**7*(20253
            -11899*r**2-63979*r**4-21881*r**6+15098*r**8)-14*Q2**6*(13218+25369*r**2
            +10632*r**4+7930*r**6+21192*r**8+11743*r**10)+Q2**5*(249081+773227*r**2
            +702288*r**4+299050*r**6+604993*r**8+691943*r**10+228466*r**12)-10*Q2**4*(3346
            +47327*r**2+66391*r**4+26440*r**6+21490*r**8+57325*r**10+42945*r**12
            +3080*r**14)-2*Q2**3*(148820+182175*r**2+4996*r**4-23433*r**6+176492*r**8
            -12827*r**10+14176*r**12+173845*r**14+140140*r**16)+6*(-1+r**2)**2*(6619
            +17111*r**2-4218*r**4-14118*r**6+79038*r**8+77078*r**10-17114*r**12
            -5750*r**14+16315*r**16+6319*r**18)+2*Q2**2*(188137+318779*r**2+26487*r**4
            -70095*r**6+689339*r**8+667917*r**10-97779*r**12+14027*r**14+302616*r**16
            +178172*r**18)-3*Q2*(65641+90513*r**2-106774*r**4-56324*r**6+460954*r**8
            +434746*r**10+439800*r**12-74828*r**14-112083*r**16+86149*r**18+62446*r**20))*sqrtq2)
            +logq2**6*(-1433272320000*r**28*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(28000*Q2**13*(1+r**2)-60*Q2**12*(8237+16554*r**2+8317*r**4)
            +30*Q2**11*(102831+323326*r**2+324719*r**4+104224*r**6)-4*Q2**10*(2393221
            +10408371*r**2+16057667*r**4+10483937*r**6+2431116*r**8)+60*Q2**9*(268197
            +1517316*r**2+3217631*r**4+3227180*r**6+1531314*r**8+272646*r**10)-30*Q2**8*(504431
            +3416761*r**2+9233858*r**4+12657478*r**6+9273253*r**8+3445917*r**10
            +508614*r**12)+5*Q2**7*(2708149+12534858*r**2+34235507*r**4+55775536*r**6
            +55460527*r**8+33828362*r**10+12358481*r**12+2623908*r**14)-30*Q2**6*(913654
            +2312513*r**2+3408314*r**4+3170317*r**6+2098482*r**8+2476451*r**10+2912294*r**12
            +2172527*r**14+881496*r**16)+3*Q2**5*(13969811+45450196*r**2+101497202*r**4
            +144351692*r**6+108808776*r**8+96117456*r**10+122931366*r**12+90981372*r**14
            +43370237*r**16+13676676*r**18)-20*Q2**4*(1184776+5978918*r**2+18902518*r**4
            +35503894*r**6+30023653*r**8+15671650*r**10+26124763*r**12+31847422*r**14
            +17519947*r**16+5761932*r**18+1173023*r**20)-15*Q2**3*(924113-629962*r**2
            -246859*r**4-1143968*r**6-2162006*r**8+3111448*r**10+4563538*r**12+208852*r**14
            -366971*r**16-364846*r**18-623239*r**20+907052*r**22)+18*(-1+r**2)**2*(157407
            +502911*r**2+4304009*r**4+6296021*r**6-1418460*r**8+1659210*r**10+11983146*r**12
            +1385134*r**14-1669601*r**16+5952055*r**18+4080653*r**20+479613*r**22
            +156702*r**24)+30*Q2**2*(913740+1538405*r**2+11270850*r**4+21375795*r**6
            +10917272*r**8-1543270*r**10-2183356*r**12-1463842*r**14+10634084*r**16
            +20306129*r**18+10538010*r**20+1463327*r**22+904856*r**24)-45*Q2*(327413
            +548792*r**2+5787832*r**4+6651516*r**6-5724767*r**8-1398540*r**10+22005616*r**12
            +21317672*r**14-2137281*r**16-5801776*r**18+6323544*r**20+5452124*r**22
            +512683*r**24+325252*r**26))-1433272320000*r**28*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(28000*Q2**13*(1+r**2)-60*Q2**12*(8237+16554*r**2
            +8317*r**4)+30*Q2**11*(102831+323326*r**2+324719*r**4+104224*r**6)-4*Q2**10*(2393221
            +10408371*r**2+16057667*r**4+10483937*r**6+2431116*r**8)+60*Q2**9*(268197
            +1517316*r**2+3217631*r**4+3227180*r**6+1531314*r**8+272646*r**10)-30*Q2**8*(504431
            +3416761*r**2+9233858*r**4+12657478*r**6+9273253*r**8+3445917*r**10
            +508614*r**12)+5*Q2**7*(2708149+12534858*r**2+34235507*r**4+55775536*r**6
            +55460527*r**8+33828362*r**10+12358481*r**12+2623908*r**14)-30*Q2**6*(913654
            +2312513*r**2+3408314*r**4+3170317*r**6+2098482*r**8+2476451*r**10+2912294*r**12
            +2172527*r**14+881496*r**16)+3*Q2**5*(13969811+45450196*r**2+101497202*r**4
            +144351692*r**6+108808776*r**8+96117456*r**10+122931366*r**12+90981372*r**14
            +43370237*r**16+13676676*r**18)-20*Q2**4*(1184776+5978918*r**2+18902518*r**4
            +35503894*r**6+30023653*r**8+15671650*r**10+26124763*r**12+31847422*r**14
            +17519947*r**16+5761932*r**18+1173023*r**20)-15*Q2**3*(924113-629962*r**2
            -246859*r**4-1143968*r**6-2162006*r**8+3111448*r**10+4563538*r**12+208852*r**14
            -366971*r**16-364846*r**18-623239*r**20+907052*r**22)+18*(-1+r**2)**2*(157407
            +502911*r**2+4304009*r**4+6296021*r**6-1418460*r**8+1659210*r**10+11983146*r**12
            +1385134*r**14-1669601*r**16+5952055*r**18+4080653*r**20+479613*r**22
            +156702*r**24)+30*Q2**2*(913740+1538405*r**2+11270850*r**4+21375795*r**6
            +10917272*r**8-1543270*r**10-2183356*r**12-1463842*r**14+10634084*r**16
            +20306129*r**18+10538010*r**20+1463327*r**22+904856*r**24)-45*Q2*(327413
            +548792*r**2+5787832*r**4+6651516*r**6-5724767*r**8-1398540*r**10+22005616*r**12
            +21317672*r**14-2137281*r**16-5801776*r**18+6323544*r**20+5452124*r**22
            +512683*r**24+325252*r**26))*sqrtq2)+logq2**5*(-7962624000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(-112000*Q2**17+160*Q2**16*(37097+37217*r**2)
            -10*Q2**15*(6078337+12357778*r**2+6095761*r**4)+Q2**14*(299580078+925915722*r**2
            +926641354*r**4+300270894*r**6)-2*Q2**13*(436415361+1844707800*r**2+2818217752*r**4
            +1846209196*r**6+437049963*r**8)+2*Q2**12*(810450954+4430988777*r**2
            +9176519030*r**4+9177363416*r**6+4432197920*r**8+810199647*r**10)-4*Q2**11*(490990263
            +3270537054*r**2+8378856899*r**4+11170855826*r**6+8371760874*r**8+3265967390*r**10
            +488846634*r**12)+Q2**10*(1546391433+10781670480*r**2+28299419299*r**4
            +40274231558*r**6+40132464943*r**8+28103428960*r**10+10706547133*r**12
            +1526112354*r**14)+Q2**9*(-723541281-2639082609*r**2+6885039367*r**4
            +47404286867*r**6+77736214265*r**8+48133777649*r**10+7408463281*r**12
            -2503062323*r**14-703136688*r**16)-2*Q2**8*(78166903+1469002275*r**2
            +17137962586*r**4+71069716118*r**6+138515823834*r**8+138906190678*r**10
            +71704487690*r**12+17429321406*r**14+1529476843*r**16+78674899*r**18)
            +2*Q2**7*(576142517+1493926616*r**2+14156129135*r**4+56655957408*r**6
            +128164706050*r**8+168600178448*r**10+128253738486*r**12+56634040240*r**14
            +14044494833*r**16+1495891960*r**18+568490531*r**20)-2*Q2**6*(901479778
            +2206548199*r**2+17592899114*r**4+32622975411*r**6+37815644634*r**8+45835002138*r**10
            +43520249838*r**12+34131376974*r**14+30549422436*r**16+16819510799*r**18
            +2141313560*r**20+899011519*r**22)+6*Q2**5*(219784624+1415156375*r**2
            +11402282507*r**4+22771465039*r**6+26253187569*r**8+23241392124*r**10
            +16798080204*r**12+18728658084*r**14+22487737824*r**16+21393349709*r**18
            +11066291545*r**20+1386821869*r**22+222198287*r**24)-6*Q2**4*(20588362
            +1238760723*r**2+9234694266*r**4+26569008056*r**6+48516222540*r**8+58045752351*r**10
            +40872565644*r**12+36929165688*r**14+50814236898*r**16+44179431065*r**18
            +25335259242*r**20+9060081888*r**22+1224463576*r**24+22921701*r**26)
            -108*Q2**3*(5113509-8063475*r**2+84468278*r**4-369481166*r**6-556735648*r**8
            -237084413*r**10-14050065*r**12+206231024*r**14+157095357*r**16-108815049*r**18
            -517331796*r**20-355042210*r**22+82753598*r**24-8337991*r**26+5110447*r**28)
            +54*(-1+r**2)**2*(328117+8709659*r**2+97169887*r**4+188355917*r**6+944098579*r**8
            +1162027417*r**10-14856143*r**12-317069329*r**14-295492869*r**16+9266877*r**18
            +1116254145*r**20+884721659*r**22+175661117*r**24+96138127*r**26+8604719*r**28
            +338121*r**30)+9*Q2**2*(48563437+336190596*r**2+4562899455*r**4+4102555378*r**6
            +22725475785*r**8+37964626812*r**10+11824404523*r**12-9724558470*r**14
            -9451895481*r**16+11814357980*r**18+36283244685*r**20+21055122006*r**22
            +3793651715*r**24+4504277028*r**26+328723785*r**28+49192766*r**30)-27*Q2*(5269631
            +76588003*r**2+865746363*r**4+669374287*r**6+6019426783*r**8+5203791143*r**10
            -4497146793*r**12+2478625219*r**14+11746751201*r**16+2156190089*r**18
            -4381985119*r**20+5035995917*r**22+5616697893*r**24+581840237*r**26+856235853*r**28
            +75262945*r**30+5384348*r**32))-7962624000*r**24*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**3*(112000*Q2**18-480*Q2**17*(12599+12639*r**2)+10*Q2**16*(6671889
            +13546802*r**2+6691233*r**4)-8*Q2**15*(45045431+138784609*r**2+138897093*r**4
            +45153563*r**6)+60*Q2**14*(19540180+81915190*r**2+124816543*r**4+81988844*r**6
            +19572847*r**8)-2*Q2**13*(1246866315+6712111938*r**2+13839444582*r**4
            +13841790364*r**6+6715457079*r**8+1247249610*r**10)+Q2**12*(3584862960
            +23565027678*r**2+60730443210*r**4+81391188196*r**6+60706166168*r**8
            +23548664694*r**10+3575785830*r**12)-3*Q2**11*(1170117495+8609259916*r**2
            +24965665037*r**4+39491027486*r**6+39434310581*r**8+24884780672*r**10
            +8575267743*r**12+1160499630*r**14)+2*Q2**10*(1134966357+7483572261*r**2
            +16098025206*r**4+10584681995*r**6+1335241118*r**8+10051058127*r**10
            +15700756406*r**12+7367860905*r**14+1114624521*r**16)-5*Q2**9*(113441495
            +84923868*r**2-7704376386*r**4-39285751694*r**6-80434429760*r**8-80736474654*r**10
            -39790243262*r**12-7952808754*r**14+29449065*r**16+109157378*r**18)-12*Q2**8*(109051570
            +506849299*r**2+5460515666*r**4+24143939352*r**6+56291707667*r**8+74337032160*r**10
            +56477402809*r**12+24294641556*r**14+5500548847*r**16+517340617*r**18
            +107860905*r**20)+Q2**7*(2955244590+8553234664*r**2+66485909730*r**4
            +206870123908*r**6+445272616184*r**8+685199773272*r**10+680748333544*r**12
            +438038311400*r**14+202455915018*r**16+64719795184*r**18+8411392102*r**20
            +2935004100*r**22)-4*Q2**6*(780416825+3676748551*r**2+27003147417*r**4
            +59265134821*r**6+74599091376*r**8+76687411572*r**10+69874746294*r**12
            +66918800532*r**14+66072006441*r**16+55774491181*r**18+26079849497*r**20
            +3600395343*r**22+782803190*r**24)+12*Q2**5*(120186493+1436850861*r**2
            +11026066574*r**4+30371377801*r**6+48770437574*r**8+53770166022*r**10
            +40456018986*r**12+36227951988*r**14+46015316403*r**16+44030259299*r**18
            +28897450248*r**20+10756597651*r**22+1416741866*r**24+122559994*r**26)
            +30*Q2**4*(14290960-280898327*r**2-1790605197*r**4-8490872662*r**6-17021294452*r**8
            -22165898865*r**10-19834243833*r**12-14817914580*r**14-16983137232*r**16
            -19390467769*r**18-15765332527*r**20-8157220182*r**22-1758996140*r**24
            -279493823*r**26+13813269*r**28)-9*Q2**3*(109925545+300791004*r**2+5479757091*r**4
            +682400722*r**6+11610874017*r**8+28438786080*r**10+8810790787*r**12-7418386962*r**14
            -5091978909*r**16+12393721676*r**18+28769482545*r**20+10586633934*r**22
            +526188371*r**24+5397264312*r**26+289993257*r**28+110518130*r**30)+54*(
            -1+r**2)**2*(328117+9037776*r**2+105879546*r**4+285525804*r**6+1132454496*r**8
            +2106125996*r**10+1147171274*r**12-331925472*r**14-612562198*r**16-286225992*r**18
            +1125521022*r**20+2000975804*r**22+1060382776*r**24+271799244*r**26+104742846*r**28
            +8942840*r**30+338121*r**32)+18*Q2**2*(32186165+307259021*r**2+3748164570*r**4
            +5336788847*r**6+22443155756*r**8+38150738013*r**10+18148795478*r**12
            +4767860855*r**14+8031899826*r**16+4415516383*r**18+17475823654*r**20
            +36223177221*r**22+20849433700*r**24+5021724727*r**26+3700854186*r**28
            +301852693*r**30+32672905*r**32)-27*Q2*(5925865+97964484*r**2+1102491738*r**4
            +1540572254*r**6+8017914334*r**8+10147590278*r**10-2082980446*r**12-269180826*r**14
            +14872955712*r**16+14469307862*r**18-621339986*r**20-2023028710*r**22
            +9697637698*r**24+7457613234*r**26+1422055254*r**28+1090032418*r**30
            +96504247*r**32+6060590*r**34))*sqrtq2)+logq2**4*(132710400*r**20*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(6863360*Q2**20-320*Q2**19*(380107
            +380053*r**2)+8*Q2**18*(115366659+234175330*r**2+115358943*r**4)-2*Q2**17*(1984639393
            +6202988778*r**2+6202411121*r**4+1984189096*r**6)+8*Q2**16*(1325870062
            +5774796625*r**2+8850995301*r**4+5772824135*r**6+1324622149*r**8)-2*Q2**15*(8887551471
            +52181403532*r**2+109016699344*r**4+108983711600*r**6+52130413749*r**8
            +8864652792*r**10)+3*Q2**14*(5622137955+46221661955*r**2+120000453874*r**4
            +158084379190*r**6+119842112083*r**8+46106792655*r**10+5589663840*r**12)
            -Q2**13*(3643672971+78621959250*r**2+174580916625*r**4+130434496828*r**6
            +129508394201*r**8+173110879842*r**10+78016954995*r**12+3585564792*r**14)
            -Q2**12*(12285623547+58906448247*r**2+522749060007*r**4+1876927030247*r**6
            +2799974218809*r**8+1879536888373*r**10+524535979653*r**12+59236008909*r**14
            +12126173184*r**16)+2*Q2**11*(9087330491+76612616340*r**2+627260374749*r**4
            +2456774171430*r**6+4689514471089*r**8+4689837351272*r**10+2456757707895*r**12
            +626334579990*r**14+76190832600*r**16+8919681632*r**18)-Q2**10*(13958986489
            +138773822503*r**2+1271001221724*r**4+5665131920044*r**6+13141090325102*r**8
            +17175906034914*r**10+13123942048476*r**12+5648827901564*r**14+1261058451921*r**16
            +136616785231*r**18+13864465168*r**20)+Q2**9*(6077638365+81766300750*r**2
            +597115984431*r**4+2373260022580*r**6+5247107641062*r**8+6793725926440*r**10
            +6744509074970*r**12+5165729868676*r**14+2328841030925*r**16+582276038202*r**18
            +79659019015*r**20+6492870840*r**22)+Q2**8*(3027205751-41993419095*r**2
            +53333776993*r**4+1191010632971*r**6+7124329385022*r**8+19922229677906*r**10
            +27939510045850*r**12+20081808794574*r**14+7263963975371*r**16+1247802892757*r**18
            +62150014293*r**20-41777134505*r**22+2487643952*r**24)-2*Q2**7*(4612466149
            +2022095644*r**2+202669140330*r**4+701186551060*r**6+4156541274491*r**8
            +12537405198480*r**10+21696166131360*r**12+21733008142704*r**14+12585716457159*r**16
            +4172693028716*r**18+713175842438*r**20+201973327788*r**22+1097349353*r**24
            +4556989528*r**26)+Q2**6*(7071003423+59610092915*r**2+666555749030*r**4
            +1058567490770*r**6+5674915851873*r**8+9508568823393*r**10+12872203220100*r**12
            +15973132871724*r**14+12451831268145*r**16+9057391835541*r**18+5407586601334*r**20
            +1018533230530*r**22+663288669391*r**24+57682510935*r**26+7355980896*r**28)
            -3*Q2**5*(129273587+23862890434*r**2+233747100921*r**4+909472599804*r**6
            +4073577651479*r**8+5152040732694*r**10+2861967283309*r**12+1704268382928*r**14
            +1270152702345*r**16+2122854173758*r**18+4717298222795*r**20+3913138542492*r**22
            +883504833261*r**24+233987354986*r**26+23763897423*r**28+213685784*r**30)
            +3*Q2**4*(-868372455+9812186865*r**2+104168548649*r**4+1053238632725*r**6
            +4430312464013*r**8+8355346873045*r**10+9786944958445*r**12+9328996472617*r**14
            +8165455185915*r**16+8112084221379*r**18+8633404947915*r**20+7856671952815*r**22
            +4314086689759*r**24+1036334710135*r**26+104533937183*r**28+10083947795*r**30
            -856316800*r**32)+18*Q2**3*(73763761+660571060*r**2+7072063741*r**4-45104944226*r**6
            -22567926197*r**8-510961280568*r**10-470356508515*r**12-92912896230*r**14
            -71216137123*r**16-6758800636*r**18+11342728943*r**20-408483610990*r**22
            -481581656383*r**24-20591890576*r**26-45421358217*r**28+7127685814*r**30
            +627735270*r**32+77101072*r**34)+9*Q2**2*(5396209-2052247101*r**2-24757630024*r**4
            -109844631624*r**6-873582999676*r**8-267551760028*r**10-2427939758208*r**12
            -3569649073304*r**14-291167695954*r**16+1343044374802*r**18-312207586896*r**20
            -3429258456056*r**22-2232737493420*r**24-219735952220*r**26-861021277376*r**28
            -106668005160*r**30-24876886135*r**32-2044102877*r**34+985048*r**36)
            +27*(-1+r**2)**2*(1590091-41826721*r**2-707177508*r**4-7456719592*r**6
            -44032356120*r**8-31635682988*r**10-238518529292*r**12-326974620616*r**14
            +124765321606*r**16+438404649290*r**18+104568655228*r**20-326993875128*r**22
            -223129820144*r**24-26481748236*r**26-43309540420*r**28-7348066456*r**30
            -707633609*r**32-42575857*r**34+1556472*r**36)-27*Q2*(7435413-290336890*r**2
            -3774023757*r**4-28646143620*r**6-173925220816*r**8+27807439036*r**10
            -735350345560*r**12-636893187884*r**14+452387053810*r**16-135924538392*r**18
            -136900556586*r**20+418676731740*r**22-639451726536*r**24-686718456860*r**26
            +43869817232*r**28-171303901988*r**30-28056498415*r**32-3781597198*r**34
            -292608705*r**36+7065976*r**38))+132710400*r**20*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(6863360*Q2**20-320*Q2**19*(380107+380053*r**2)+8*Q2**18*(115366659
            +234175330*r**2+115358943*r**4)-2*Q2**17*(1984639393+6202988778*r**2
            +6202411121*r**4+1984189096*r**6)+8*Q2**16*(1325870062+5774796625*r**2
            +8850995301*r**4+5772824135*r**6+1324622149*r**8)-2*Q2**15*(8887551471
            +52181403532*r**2+109016699344*r**4+108983711600*r**6+52130413749*r**8
            +8864652792*r**10)+3*Q2**14*(5622137955+46221661955*r**2+120000453874*r**4
            +158084379190*r**6+119842112083*r**8+46106792655*r**10+5589663840*r**12)
            -Q2**13*(3643672971+78621959250*r**2+174580916625*r**4+130434496828*r**6
            +129508394201*r**8+173110879842*r**10+78016954995*r**12+3585564792*r**14)
            -Q2**12*(12285623547+58906448247*r**2+522749060007*r**4+1876927030247*r**6
            +2799974218809*r**8+1879536888373*r**10+524535979653*r**12+59236008909*r**14
            +12126173184*r**16)+2*Q2**11*(9087330491+76612616340*r**2+627260374749*r**4
            +2456774171430*r**6+4689514471089*r**8+4689837351272*r**10+2456757707895*r**12
            +626334579990*r**14+76190832600*r**16+8919681632*r**18)-Q2**10*(13958986489
            +138773822503*r**2+1271001221724*r**4+5665131920044*r**6+13141090325102*r**8
            +17175906034914*r**10+13123942048476*r**12+5648827901564*r**14+1261058451921*r**16
            +136616785231*r**18+13864465168*r**20)+Q2**9*(6077638365+81766300750*r**2
            +597115984431*r**4+2373260022580*r**6+5247107641062*r**8+6793725926440*r**10
            +6744509074970*r**12+5165729868676*r**14+2328841030925*r**16+582276038202*r**18
            +79659019015*r**20+6492870840*r**22)+Q2**8*(3027205751-41993419095*r**2
            +53333776993*r**4+1191010632971*r**6+7124329385022*r**8+19922229677906*r**10
            +27939510045850*r**12+20081808794574*r**14+7263963975371*r**16+1247802892757*r**18
            +62150014293*r**20-41777134505*r**22+2487643952*r**24)-2*Q2**7*(4612466149
            +2022095644*r**2+202669140330*r**4+701186551060*r**6+4156541274491*r**8
            +12537405198480*r**10+21696166131360*r**12+21733008142704*r**14+12585716457159*r**16
            +4172693028716*r**18+713175842438*r**20+201973327788*r**22+1097349353*r**24
            +4556989528*r**26)+Q2**6*(7071003423+59610092915*r**2+666555749030*r**4
            +1058567490770*r**6+5674915851873*r**8+9508568823393*r**10+12872203220100*r**12
            +15973132871724*r**14+12451831268145*r**16+9057391835541*r**18+5407586601334*r**20
            +1018533230530*r**22+663288669391*r**24+57682510935*r**26+7355980896*r**28)
            -3*Q2**5*(129273587+23862890434*r**2+233747100921*r**4+909472599804*r**6
            +4073577651479*r**8+5152040732694*r**10+2861967283309*r**12+1704268382928*r**14
            +1270152702345*r**16+2122854173758*r**18+4717298222795*r**20+3913138542492*r**22
            +883504833261*r**24+233987354986*r**26+23763897423*r**28+213685784*r**30)
            +3*Q2**4*(-868372455+9812186865*r**2+104168548649*r**4+1053238632725*r**6
            +4430312464013*r**8+8355346873045*r**10+9786944958445*r**12+9328996472617*r**14
            +8165455185915*r**16+8112084221379*r**18+8633404947915*r**20+7856671952815*r**22
            +4314086689759*r**24+1036334710135*r**26+104533937183*r**28+10083947795*r**30
            -856316800*r**32)+18*Q2**3*(73763761+660571060*r**2+7072063741*r**4-45104944226*r**6
            -22567926197*r**8-510961280568*r**10-470356508515*r**12-92912896230*r**14
            -71216137123*r**16-6758800636*r**18+11342728943*r**20-408483610990*r**22
            -481581656383*r**24-20591890576*r**26-45421358217*r**28+7127685814*r**30
            +627735270*r**32+77101072*r**34)+9*Q2**2*(5396209-2052247101*r**2-24757630024*r**4
            -109844631624*r**6-873582999676*r**8-267551760028*r**10-2427939758208*r**12
            -3569649073304*r**14-291167695954*r**16+1343044374802*r**18-312207586896*r**20
            -3429258456056*r**22-2232737493420*r**24-219735952220*r**26-861021277376*r**28
            -106668005160*r**30-24876886135*r**32-2044102877*r**34+985048*r**36)
            +27*(-1+r**2)**2*(1590091-41826721*r**2-707177508*r**4-7456719592*r**6
            -44032356120*r**8-31635682988*r**10-238518529292*r**12-326974620616*r**14
            +124765321606*r**16+438404649290*r**18+104568655228*r**20-326993875128*r**22
            -223129820144*r**24-26481748236*r**26-43309540420*r**28-7348066456*r**30
            -707633609*r**32-42575857*r**34+1556472*r**36)-27*Q2*(7435413-290336890*r**2
            -3774023757*r**4-28646143620*r**6-173925220816*r**8+27807439036*r**10
            -735350345560*r**12-636893187884*r**14+452387053810*r**16-135924538392*r**18
            -136900556586*r**20+418676731740*r**22-639451726536*r**24-686718456860*r**26
            +43869817232*r**28-171303901988*r**30-28056498415*r**32-3781597198*r**34
            -292608705*r**36+7065976*r**38))*sqrtq2)+logq2**3*(2211840*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(64815360*Q2**23-64*Q2**22*(14656849
            +14657841*r**2)+2*Q2**21*(3051897101+6253205690*r**2+3050577069*r**4)
            -6*Q2**20*(3848004021+12446845177*r**2+12442709523*r**4+3842504399*r**6)
            +20*Q2**19*(2717103430+12803303913*r**2+19872112016*r**4+12789930685*r**6
            +2709610320*r**8)-10*Q2**18*(7629160937+52983407720*r**2+112351678536*r**4
            +112271670058*r**6+52871086127*r**8+7599904206*r**10)+12*Q2**17*(3598151357
            +49285805963*r**2+121894749055*r**4+150252431800*r**6+121596220030*r**8
            +49110118087*r**10+3599390288*r**12)+Q2**16*(51028651427-51215075760*r**2
            +786942088133*r**4+3344367182070*r**6+3348534440205*r**8+791846154032*r**10
            -51030359005*r**12+49791739938*r**14)-Q2**15*(126762290591+894726402107*r**2
            +6428323032603*r**4+22046977376239*r**6+32654133417345*r**8+22045575919701*r**10
            +6419147434437*r**12+886932589793*r**14+124472683104*r**16)+15*Q2**14*(6561034695
            +89770876068*r**2+720230540056*r**4+3090160717548*r**6+6105680697754*r**8
            +6103764742444*r**10+3086240879512*r**12+717099116996*r**14+88615742575*r**16
            +6513735680*r**18)+5*Q2**13*(1288627985-160026354765*r**2-1481724223704*r**4
            -9021266018532*r**6-22848508989966*r**8-30150413095282*r**10-22809664552068*r**12
            -8985325389372*r**14-1467146979267*r**16-157019595553*r**18+634105884*r**20)
            -Q2**12*(80013532111+106670614774*r**2+2036641677555*r**4-2273901466380*r**6
            -382362932430*r**8+30077743479444*r**10+30338877439226*r**12+44853328920*r**14
            -2054197467585*r**16+2060161423030*r**18+100809795091*r**20+75186433524*r**22)
            +3*Q2**11*(23504056119+190347293975*r**2+2757720110841*r**4+15387679104025*r**6
            +69382512145570*r**8+186339688289186*r**10+260400291586990*r**12+186489507229134*r**14
            +69430298039015*r**16+15371887457415*r**18+2731199208089*r**20+180716275545*r**22
            +23175070336*r**24)-Q2**10*(16440250871+606310860432*r**2+7416531133738*r**4
            +54806869512104*r**6+297582148912545*r**8+956143291403864*r**10+1722489814385308*r**12
            +1722330415113552*r**14+955400794015721*r**16+296415840322400*r**18+54261476560506*r**20
            +7316568848392*r**22+579894375743*r**24+20123690424*r**26)-5*Q2**9*(5085300455
            -92681586211*r**2-780821244222*r**4-6289921939082*r**6-33561561310351*r**8
            -120049235141181*r**10-265208109609100*r**12-343738575710588*r**14-264407114461767*r**16
            -119182070209101*r**18-33034437766846*r**20-6135796345722*r**22-783882776657*r**24
            -93341603155*r**26+4396270920*r**28)+15*Q2**8*(2037658913-6942538450*r**2
            -63670165517*r**4-793870041416*r**6+524813136933*r**8+8334396411458*r**10
            +29706703826367*r**12+56893049326684*r**14+57309667370691*r**16+30470138407026*r**18
            +8858292602489*r**20+696048376832*r**22-769708551305*r**24-71413732706*r**26
            -8729810219*r**28+2047694060*r**30)-Q2**7*(10395505661+290063671449*r**2
            +1599038538245*r**4-1707735129015*r**6+71788129684365*r**8+288158393126329*r**10
            +1122268488594781*r**12+2477758787775825*r**14+3244302880212255*r**16
            +2487575834878675*r**18+1130065623573639*r**20+293779248986131*r**22+72802027847415*r**24
            -2022352506405*r**26+1523414191895*r**28+270785595731*r**30+12294621024*r**32)
            +Q2**6*(-7058084053+326962811660*r**2+2785156127628*r**4+11866982028340*r**6
            +90907032425940*r**8+96562233237948*r**10+517040880430260*r**12+921452975570692*r**14
            +1319688653841210*r**16+1313471850635140*r**18+902470757241268*r**20+497114997018780*r**22
            +92786288351012*r**24+90708630796500*r**26+11316252331020*r**28+2807838304812*r**30
            +329648461475*r**32-6177529632*r**34)+3*Q2**5*(2723530423-24476535189*r**2
            -593706061346*r**4-7092581474808*r**6-39625456955800*r**8-94353746254488*r**10
            -326428973572576*r**12-228762240189824*r**14+22275029348678*r**16+47400702075230*r**18
            +52261931666292*r**20-198443120459416*r**22-309283823571744*r**24-90256804262432*r**26
            -39472367350080*r**28-7014272736752*r**30-611385030469*r**32-28219801361*r**34
            +2815795662*r**36)-15*Q2**4*(124196825+5681607564*r**2-12092763307*r**4
            -916903997178*r**6-5507980296344*r**8-31882039376384*r**10-96168445085728*r**12
            -114658258838928*r**14-87606364390494*r**16-106785707234232*r**18-98707894825582*r**20
            -73101760382756*r**22-105519424006368*r**24-92945762795968*r**26-31195709785624*r**28
            -5473590423584*r**30-923678449155*r**32-13605885972*r**34+5339363665*r**36
            +147609550*r**38)-45*Q2**3*(28482533-1293097895*r**2-10382722953*r**4
            -12314390669*r**6-64840709144*r**8+4367552374360*r**10+4039441446192*r**12
            +16692517166880*r**14+8801355498954*r**16+4829533289602*r**18+9143192030982*r**20
            +2282108716046*r**22+6363795029024*r**24+15175175125904*r**26+3753765406088*r**28
            +4354591796664*r**30-74586351543*r**32-9117651651*r**34-10458190389*r**36
            -1315500121*r**38+27291136*r**40)+54*(-1+r**2)**2*(356411+28918339*r**2
            -228152360*r**4-10315760100*r**6-87204718205*r**8-618409497109*r**10
            -2213899351576*r**12+1006734241880*r**14-12676508351250*r**16-12902877415810*r**18
            +20471950036536*r**20+19649781764944*r**22-13504761861930*r**24-12147500215450*r**26
            +1272229834360*r**28-2166733322264*r**30-606255177641*r**32-86805894465*r**34
            -10336793200*r**36-238242220*r**38+27584551*r**40+416559*r**42)+9*Q2**2*(105248661
            -461618376*r**2-37666561290*r**4-637107769180*r**6-4301554842075*r**8
            -12385996557244*r**10-89017044184936*r**12+23448441375280*r**14-147665288376150*r**16
            -195481248985440*r**18+21831957831476*r**20+21175554260824*r**22-187813064222190*r**24
            -134047478045160*r**26+26847350335480*r**28-87857548454864*r**30-11848685719711*r**32
            -4315908031800*r**34-631083662010*r**36-38431477340*r**38-656824279*r**40
            +110680324*r**42)-27*Q2*(8571479+228608165*r**2-4081673614*r**4-112295695070*r**6
            -773768210385*r**8-4105538446631*r**10-16909478360000*r**12+21164880603016*r**14
            -73439676121490*r**16-52249167548870*r**18+51321240361244*r**20+34384784508060*r**22
            +46882258796086*r**24-54397458528310*r**26-69942244465480*r**28+22634824829864*r**30
            -16626471226405*r**32-3990430396639*r**34-772173957630*r**36-112047793390*r**38
            -4181496581*r**40+205395805*r**42+9446776*r**44))-2211840*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(64815360*Q2**24-64*Q2**23*(15669589
            +15670581*r**2)+2*Q2**22*(3520916269+7191275770*r**2+3519627981*r**4)
            -4*Q2**21*(7297954582+23322819161*r**2+23315955664*r**4+7289045133*r**6)
            +Q2**20*(77430092726+353835173448*r**2+546779568520*r**4+353509897232*r**6
            +77247232794*r**8)-10*Q2**19*(13063367797+84024222406*r**2+177702510394*r**4
            +177595755460*r**6+83870168137*r**8+13019124846*r**10)+2*Q2**18*(59734712827
            +598777679063*r**2+1558043925610*r**4+2024631333770*r**6+1555291101105*r**8
            +597015660187*r**10+59595862758*r**12)+Q2**17*(7850835143-685822563600*r**2
            -1267224572083*r**4+78601011810*r**6+86350618245*r**8-1256629903372*r**10
            -683544459505*r**12+6599056482*r**14)-2*Q2**16*(88895471009+447269988887*r**2
            +3582025022488*r**4+13089143323221*r**6+19673517519810*r**8+13092978256969*r**10
            +3579981614732*r**12+442846985363*r**14+87132211521*r**16)+2*Q2**15*(112588905508
            +1184025916859*r**2+9063253767775*r**4+37413855586031*r**6+73143160629947*r**8
            +73128090236853*r**10+37379168273409*r**12+9031283389585*r**14+1170320705761*r**16
            +111089359152*r**18)-10*Q2**14*(9197238050+224511043527*r**2+1955864236038*r**4
            +10226219895672*r**6+25218016617936*r**8+33389374707938*r**10+25189840708968*r**12
            +10197672689448*r**14+1942145778990*r**16+221204015159*r**18+9453550578*r**20)
            +Q2**13*(-86456672036+687018019126*r**2+6172111214790*r**4+54788852677560*r**6
            +159731237974920*r**8+234916866946796*r**10+234461510797524*r**12+158930096378280*r**14
            +54316559310780*r**16+6060671451070*r**18+681117653254*r**20-78356962944*r**22)
            +2*Q2**12*(75262850234+378863014405*r**2+5208236312426*r**4+22962888761625*r**6
            +102745636018950*r**8+294357222707286*r**10+420808747839820*r**12+294926126227774*r**14
            +103140774989190*r**16+23060813163845*r**18+5177284421194*r**20+359072527625*r**22
            +72355822266*r**24)-2*Q2**11*(43476209614+623932455357*r**2+8130366674093*r**4
            +54621533578351*r**6+275946361330665*r**8+861654946354066*r**10+1531354877006918*r**12
            +1531499905780962*r**14+861580104910084*r**16+275411198405845*r**18+54285368278509*r**20
            +8026157649647*r**22+595784206693*r**24+44824450716*r**26)+2*Q2**10*(
            -4493125702+543079521179*r**2+5963474107640*r**4+46836505170626*r**6
            +260098412488202*r**8+926985808011157*r**10+2002336826917336*r**12+2581756554025900*r**14
            +1999883390719054*r**16+923863492691813*r**18+257924752858568*r**20+46128513568754*r**22
            +5907938553710*r**24+533363040971*r**26-928832088*r**28)+10*Q2**9*(5599138597
            -54211950553*r**2-532256663492*r**4-4726176653776*r**6-19138521919317*r**8
            -64303803608579*r**10-148068616635590*r**12-219133768669818*r**14-218108344030141*r**16
            -146089384724895*r**18-62820815084240*r**20-18541044491036*r**22-4614402388147*r**24
            -545732788965*r**26-57567381446*r**28+5269676550*r**30)-2*Q2**8*(20480194678
            +108245239197*r**2+269923989370*r**4-7285419116505*r**6+33876138058560*r**8
            +210523268176097*r**10+846442496081078*r**12+1888377542535795*r**14+2478671815336440*r**16
            +1902136460772215*r**18+859996044358182*r**20+218547181837973*r**22+35848562615160*r**24
            -7319593383285*r**26+160630524010*r**28+85276926673*r**30+21505015962*r**32)
            +2*Q2**7*(1668710804+313710994385*r**2+2337129168661*r**4+5879142718785*r**6
            +80493713490645*r**8+228254378024321*r**10+963733881075685*r**12+2260740125970649*r**14
            +3520875160914645*r**16+3522675282863035*r**18+2260056107846791*r**20
            +960479934789275*r**22+229683782592279*r**24+80744153068755*r**26+5408657008255*r**28
            +2301019046219*r**30+306364339115*r**32+3058545696*r**34)+2*Q2**6*(7614337661
            -196667166587*r**2-2446618561663*r**4-17964941290196*r**6-110825192660840*r**8
            -235265252213676*r**10-796445017192968*r**12-1062390288285212*r**14-1087158270682934*r**16
            -1245479199125330*r**18-1029578406438766*r**20-997457557819148*r**22-758876378042512*r**24
            -227132665967404*r**26-110220992588880*r**28-17583454423044*r**30-2485820928847*r**32
            -204065167963*r**34+7312458309*r**36)-6*Q2**5*(1672257274+3327516527*r**2
            -339323206535*r**4-6135403761022*r**6-37128969956164*r**8-146694700046104*r**10
            -450812472627852*r**12-564241253978520*r**14-322259516396808*r**16-232126402373626*r**18
            -196938420193194*r**20-255844995353452*r**22-517662032031500*r**24-432134720907008*r**26
            -142853860270316*r**28-36927296102376*r**30-6122025006498*r**32-353817130845*r**34
            +646406313*r**36+1776921706*r**38)+30*Q2**4*(19374613+4842549037*r**2
            +12368506558*r**4-446026794239*r**6-3115181083045*r**8-25246338397904*r**10
            -70084404400344*r**12-130452127712648*r**14-114334344863142*r**16-104440335746766*r**18
            -116461589076380*r**20-89327990678238*r**22-98856284738098*r**24-121995356090024*r**26
            -67701384399928*r**28-24866537799600*r**30-3086754909055*r**32-454965690087*r**34
            +11554024430*r**36+4716736789*r**38+32868071*r**40)+18*Q2**3*(123830663
            -3392347593*r**2-48022832765*r**4-375296668645*r**6-2343665170570*r**8
            +4563780884418*r**10-23491037541088*r**12+63554117220320*r**14-10097962523490*r**16
            -63663402521330*r**18+45847792217198*r**20+39151028997982*r**22-72291772748420*r**24
            -13176313635260*r**26+60746026497720*r**28-23657881220552*r**30+4775670752947*r**32
            -2367214023885*r**34-364481436105*r**36-48649964945*r**38-3548934602*r**40
            +123568002*r**42)-54*(-1+r**2)**2*(356411+29274750*r**2-199234021*r**4
            -10543912460*r**6-97520478305*r**8-705614215314*r**10-2832308848685*r**12
            -1207165109696*r**14-11669774109370*r**16-25579385767060*r**18+7569072620726*r**20
            +40121731801480*r**22+6145019903014*r**24-25652262077380*r**26-10875270381090*r**28
            -894503487904*r**30-2772988499905*r**32-693061072106*r**34-97142687665*r**36
            -10575035420*r**38-210657669*r**40+28001110*r**42+416559*r**44)-18*Q2**2*(65481549
            +164727390*r**2-25186600254*r**4-505830707840*r**6-3629983621205*r**8
            -14502083369606*r**10-76065737911090*r**12-1036980500304*r**14-172267937682670*r**16
            -249947020004100*r**18-9842785035116*r**20+73080932808240*r**22-12995366786554*r**24
            -242526458926140*r**26-158513430553060*r**28+3447138185104*r**30-74792823926895*r**32
            -14067942470714*r**34-3631756783350*r**36-502829259760*r**38-25816395681*r**40
            +35021730*r**42+69510326*r**44)+27*Q2*(9284301+293590678*r**2-4424330703*r**4
            -136038442766*r**6-1019666606185*r**8-5787938298614*r**10-23143586957757*r**12
            +13887649138862*r**14-86082547891646*r**16-98775096613220*r**18+66274465846186*r**20
            +17312033421428*r**22+16602292593582*r**24+61508410814484*r**26-100214766187130*r**28
            -81024806048484*r**30+16007236205953*r**32-22698959345938*r**34-5648564718091*r**36
            -1016962851590*r**38-135894738389*r**40-4562090302*r**42+268345447*r**44
            +10279894*r**46))*sqrtq2)+logq2**2*(-36864*r**12*(1-Q2+r**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**5*(-140835328*Q2**26+32*Q2**25*(67151989+67044589*r**2)
            -4*Q2**24*(3575510665+7561594066*r**2+3566234185*r**4)+2*Q2**23*(26801478845
            +91801363698*r**2+91697798573*r**4+26726497400*r**6)-4*Q2**22*(29779252565
            +154048637741*r**2+239976156353*r**4+153780937231*r**6+29735525990*r**8)
            +4*Q2**21*(34524522670+294049235524*r**2+605261702519*r**4+604741231484*r**6
            +293661418589*r**8+34700030530*r**10)+2*Q2**20*(1824095075-480309024237*r**2
            -806450878560*r**4-531445844590*r**6-806120155155*r**8-482545787337*r**10
            +235144940*r**12)-Q2**19*(265927438985+972740859794*r**2+7950873757575*r**4
            +24123532840400*r**6+24106306610675*r**8+7917274762770*r**10+948013374869*r**12
            +260958754340*r**14)+2*Q2**18*(178220610620+1823265827183*r**2+13083715313168*r**4
            +48237676109315*r**6+72550544734400*r**8+48155911420085*r**10+13017788960168*r**12
            +1798522484633*r**14+177849567500*r**16)-Q2**17*(67141512585+4061789469444*r**2
            +34046943174502*r**4+173607640623484*r**6+356364788881320*r**8+356018780762920*r**10
            +173090582585074*r**12+33838571601852*r**14+4022886898279*r**16+76504184460*r**18)
            +Q2**16*(-331811867190+785930723766*r**2+9563928324476*r**4+121481548714936*r**6
            +322741893191876*r**8+409220685173324*r**10+321630911641816*r**12+120868588487576*r**14
            +9550320333986*r**16+824298990926*r**18-318416182500*r**20)+4*Q2**15*(92743211730
            +844043186304*r**2+8344626514835*r**4+29267424090535*r**6+106290866702125*r**8
            +255560949316723*r**10+255784666867243*r**12+106464676503085*r**14+29117441267185*r**16
            +8221329429125*r**18+811462238354*r**20+92318061300*r**22)-4*Q2**14*(8443270990
            +1091181245196*r**2+12254770201765*r**4+85444707394300*r**6+385009018359000*r**8
            +1097542864523920*r**10+1564905324467014*r**12+1097194166709600*r**14
            +384086654012350*r**16+84666404882500*r**18+12076534044645*r**20+1062991497796*r**22
            +11910317260*r**24)-4*Q2**13*(61263487465-418007778944*r**2-5420207068379*r**4
            -74460247566265*r**6-422622230048825*r**8-1617115044185420*r**10-3118267345384666*r**12
            -3116770736292266*r**14-1613983578950105*r**16-419995099810900*r**18-73366128447275*r**20
            -5410007595629*r**22-429695206519*r**24+58060697200*r**26)+4*Q2**12*(50230336235
            +396310604279*r**2+2949881301157*r**4-11902517230076*r**6-87568057191020*r**8
            -749031176184995*r**10-2034443207392094*r**12-2682752898900512*r**14-2027673907043729*r**16
            -742726120820495*r**18-84908967221795*r**20-11515472291636*r**22+2720057282482*r**24
            +351234496939*r**26+50871293660*r**28)-2*Q2**11*(-1346842885+1281026848062*r**2
            +10052419934367*r**4+66172221255362*r**6+553261645934457*r**8+1991052605632736*r**10
            +5662805269875233*r**12+10905045033974328*r**14+10917793700677733*r**16
            +5679216096094838*r**18+1997066542979001*r**20+552593712487562*r**22+64146407263367*r**24
            +9600187699212*r**26+1223517567207*r**28+3995992220*r**30)+4*Q2**10*(
            -27252165160+310675887929*r**2+3213913058025*r**4+38322010835165*r**6
            +331946973206690*r**8+1806545857501697*r**10+6888077447014279*r**12+16557146458860725*r**14
            +22500788780792960*r**16+16561178210813035*r**18+6878117837100359*r**20
            +1796868905793527*r**22+328776149631850*r**24+36655515166715*r**26+3227905597065*r**28
            +326188645079*r**30-26195058340*r**32)+2*Q2**9*(34438744945+215650053628*r**2
            -2825424104660*r**4-57552848573450*r**6-360475637845550*r**8-2325392816550940*r**10
            -10199005446825328*r**12-30037594575862870*r**14-53885790705070600*r**16
            -53865747371981200*r**18-29972008683787060*r**20-10111895523783478*r**22
            -2282920261197850*r**24-356805877073500*r**26-56247518121800*r**28-3165942422570*r**30
            +154018140703*r**32+36185992780*r**34)+4*Q2**8*(2014157560-237166613871*r**2
            -411099179906*r**4+14013069240010*r**6+55881323233875*r**8+326965783898220*r**10
            +155929105522241*r**12+145277884267086*r**14+1855952397405335*r**16+3097060027972450*r**18
            +1768233434629425*r**20+45276817302086*r**22+96443374527641*r**24+309539937816180*r**26
            +57299788493475*r**28+14963249929570*r**30-303161529531*r**32-228519895571*r**34
            +1194407725*r**36)+2*Q2**7*(-16756919605+222811141478*r**2+3468227535449*r**4
            +12411134317378*r**6+27267717958730*r**8-104083074978990*r**10+3908627402536162*r**12
            +13223950666709026*r**14+34640730117696232*r**16+56595526492202190*r**18
            +56731994882499740*r**20+34872880839930502*r**22+13445950777152326*r**24
            +3989394033095542*r**26-105262693888290*r**28+23981990721830*r**30+9833254406333*r**32
            +3485704049924*r**34+245383445323*r**36-16828971280*r**38)+4*Q2**6*(3543565675
            +26319387829*r**2-1200574571566*r**4-16671947774401*r**6-67798734317806*r**8
            -180546988259852*r**10-1660358702472304*r**12-1207091293547284*r**14-7783589325593474*r**16
            -13929521522985594*r**18-17263962587005236*r**20-13868141115316254*r**22
            -7603742470911884*r**24-1181241861769724*r**26-1672325982020944*r**28
            -166028405963972*r**30-68078220795521*r**32-16367119651891*r**34-1245202722526*r**36
            +17464353719*r**38+3819573010*r**40)+12*Q2**5*(363872015-17794062452*r**2
            -39739004270*r**4+3367967454165*r**6+26210656741310*r**8+180305894769362*r**10
            +697560239845136*r**12+815627263476920*r**14+3318001767676910*r**16+454421691076840*r**18
            -1865751685168596*r**20-1952748307406286*r**22+239892944474420*r**24+3093595344572860*r**26
            +739988119797040*r**28+695574057563296*r**30+176571745751947*r**32+26448527599180*r**34
            +3527737746690*r**36-31463870815*r**38-17922894202*r**40+340388530*r**42)
            -6*Q2**4*(931521235-12997916181*r**2-338535368970*r**4+7604056750*r**6
            +25701653952975*r**8+327003407964195*r**10+1314102441006924*r**12+5524704824568120*r**14
            +13114195109047950*r**16+7747170674470150*r**18+5344193343130380*r**20
            +10830265121334564*r**22+4287222755586910*r**24+6786932773414350*r**26
            +12600834124085400*r**28+5358939629418840*r**30+1301007760091199*r**32
            +327061409206575*r**34+25684096235950*r**36+260763688350*r**38-335659896525*r**40
            -14771940881*r**42+959941740*r**44)+27*Q2**3*(36623845+604341498*r**2
            -24198258537*r**4-439314673140*r**6-637665550425*r**8+9905234093510*r**10
            +43919178120293*r**12+722719450701588*r**14+333075950114370*r**16+757069935323700*r**18
            +345997002380950*r**20+1274644436448008*r**22+1167173705275358*r**24+149984990617980*r**26
            +600015785424250*r**28+289315415288440*r**30+716736599371113*r**32+40841835170418*r**34
            +10550694226115*r**36-660878026900*r**38-436143444245*r**40-24702632162*r**42
            +495578673*r**44+39885300*r**46)+54*(-1+r**2)**2*(958023-15650637*r**2
            -607704817*r**4+314922603*r**6+110660295543*r**8+1578803410833*r**10
            +8941707934973*r**12+47316484033993*r**14+99512728603388*r**16-200362599317922*r**18
            +1060695223769238*r**20+122811283763278*r**22-1866084392083202*r**24+181602944601218*r**26
            +1046047023011258*r**28-217004132564942*r**30+97133988319823*r**32+46111111014943*r**34
            +8836680276363*r**36+1582518179703*r**38+109766073723*r**40+770138813*r**42
            -597192167*r**44-17787947*r**46+993918*r**48)+18*Q2**2*(38894180-1296792273*r**2
            -12848525034*r**4+337947056067*r**6+3585926493300*r**8+35656899385785*r**10
            +162994935753382*r**12+288806239949661*r**14+2730287251460292*r**16-2382019787935930*r**18
            +2674427512746540*r**20+3463143819687342*r**22+445897411848696*r**24+3308493747176322*r**26
            +2351290862561340*r**28-2438122224179030*r**30+2714669845818012*r**32
            +263669951890011*r**34+164367483998462*r**36+35215958237535*r**38+3565307886900*r**40
            +357346946037*r**42-12096300834*r**44-1361341143*r**46+39284380*r**48)
            -27*Q2*(13457491-288595748*r**2-6701491498*r**4+45922407872*r**6+1218334982772*r**8
            +14822832127632*r**10+67585891051042*r**12+275309280418592*r**14+848650919931087*r**16
            -2301578560828788*r**18+5715486524520412*r**20+1789157585874112*r**22
            -4768062657532288*r**24-4533117044770368*r**26+2041231724113732*r**28
            +5559524318717312*r**30-2387170370753983*r**32+841269271682292*r**34+263936145922862*r**36
            +67156691965312*r**38+14809768955532*r**40+1202507083952*r**42+51883785402*r**44
            -6505863328*r**46-317042403*r**48+13880996*r**50))+36864*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(140835328*Q2**26-32*Q2**25*(67151989
            +67044589*r**2)+4*Q2**24*(3575510665+7561594066*r**2+3566234185*r**4)
            -2*Q2**23*(26801478845+91801363698*r**2+91697798573*r**4+26726497400*r**6)
            +4*Q2**22*(29779252565+154048637741*r**2+239976156353*r**4+153780937231*r**6
            +29735525990*r**8)-4*Q2**21*(34524522670+294049235524*r**2+605261702519*r**4
            +604741231484*r**6+293661418589*r**8+34700030530*r**10)+2*Q2**20*(-1824095075
            +480309024237*r**2+806450878560*r**4+531445844590*r**6+806120155155*r**8
            +482545787337*r**10-235144940*r**12)+Q2**19*(265927438985+972740859794*r**2
            +7950873757575*r**4+24123532840400*r**6+24106306610675*r**8+7917274762770*r**10
            +948013374869*r**12+260958754340*r**14)-2*Q2**18*(178220610620+1823265827183*r**2
            +13083715313168*r**4+48237676109315*r**6+72550544734400*r**8+48155911420085*r**10
            +13017788960168*r**12+1798522484633*r**14+177849567500*r**16)+Q2**17*(67141512585
            +4061789469444*r**2+34046943174502*r**4+173607640623484*r**6+356364788881320*r**8
            +356018780762920*r**10+173090582585074*r**12+33838571601852*r**14+4022886898279*r**16
            +76504184460*r**18)+2*Q2**16*(165905933595-392965361883*r**2-4781964162238*r**4
            -60740774357468*r**6-161370946595938*r**8-204610342586662*r**10-160815455820908*r**12
            -60434294243788*r**14-4775160166993*r**16-412149495463*r**18+159208091250*r**20)
            -4*Q2**15*(92743211730+844043186304*r**2+8344626514835*r**4+29267424090535*r**6
            +106290866702125*r**8+255560949316723*r**10+255784666867243*r**12+106464676503085*r**14
            +29117441267185*r**16+8221329429125*r**18+811462238354*r**20+92318061300*r**22)
            +4*Q2**14*(8443270990+1091181245196*r**2+12254770201765*r**4+85444707394300*r**6
            +385009018359000*r**8+1097542864523920*r**10+1564905324467014*r**12+1097194166709600*r**14
            +384086654012350*r**16+84666404882500*r**18+12076534044645*r**20+1062991497796*r**22
            +11910317260*r**24)+4*Q2**13*(61263487465-418007778944*r**2-5420207068379*r**4
            -74460247566265*r**6-422622230048825*r**8-1617115044185420*r**10-3118267345384666*r**12
            -3116770736292266*r**14-1613983578950105*r**16-419995099810900*r**18-73366128447275*r**20
            -5410007595629*r**22-429695206519*r**24+58060697200*r**26)-4*Q2**12*(50230336235
            +396310604279*r**2+2949881301157*r**4-11902517230076*r**6-87568057191020*r**8
            -749031176184995*r**10-2034443207392094*r**12-2682752898900512*r**14-2027673907043729*r**16
            -742726120820495*r**18-84908967221795*r**20-11515472291636*r**22+2720057282482*r**24
            +351234496939*r**26+50871293660*r**28)+2*Q2**11*(-1346842885+1281026848062*r**2
            +10052419934367*r**4+66172221255362*r**6+553261645934457*r**8+1991052605632736*r**10
            +5662805269875233*r**12+10905045033974328*r**14+10917793700677733*r**16
            +5679216096094838*r**18+1997066542979001*r**20+552593712487562*r**22+64146407263367*r**24
            +9600187699212*r**26+1223517567207*r**28+3995992220*r**30)+4*Q2**10*(27252165160
            -310675887929*r**2-3213913058025*r**4-38322010835165*r**6-331946973206690*r**8
            -1806545857501697*r**10-6888077447014279*r**12-16557146458860725*r**14
            -22500788780792960*r**16-16561178210813035*r**18-6878117837100359*r**20
            -1796868905793527*r**22-328776149631850*r**24-36655515166715*r**26-3227905597065*r**28
            -326188645079*r**30+26195058340*r**32)+2*Q2**9*(-34438744945-215650053628*r**2
            +2825424104660*r**4+57552848573450*r**6+360475637845550*r**8+2325392816550940*r**10
            +10199005446825328*r**12+30037594575862870*r**14+53885790705070600*r**16
            +53865747371981200*r**18+29972008683787060*r**20+10111895523783478*r**22
            +2282920261197850*r**24+356805877073500*r**26+56247518121800*r**28+3165942422570*r**30
            -154018140703*r**32-36185992780*r**34)-4*Q2**8*(2014157560-237166613871*r**2
            -411099179906*r**4+14013069240010*r**6+55881323233875*r**8+326965783898220*r**10
            +155929105522241*r**12+145277884267086*r**14+1855952397405335*r**16+3097060027972450*r**18
            +1768233434629425*r**20+45276817302086*r**22+96443374527641*r**24+309539937816180*r**26
            +57299788493475*r**28+14963249929570*r**30-303161529531*r**32-228519895571*r**34
            +1194407725*r**36)+2*Q2**7*(16756919605-222811141478*r**2-3468227535449*r**4
            -12411134317378*r**6-27267717958730*r**8+104083074978990*r**10-3908627402536162*r**12
            -13223950666709026*r**14-34640730117696232*r**16-56595526492202190*r**18
            -56731994882499740*r**20-34872880839930502*r**22-13445950777152326*r**24
            -3989394033095542*r**26+105262693888290*r**28-23981990721830*r**30-9833254406333*r**32
            -3485704049924*r**34-245383445323*r**36+16828971280*r**38)+4*Q2**6*(-3543565675
            -26319387829*r**2+1200574571566*r**4+16671947774401*r**6+67798734317806*r**8
            +180546988259852*r**10+1660358702472304*r**12+1207091293547284*r**14+7783589325593474*r**16
            +13929521522985594*r**18+17263962587005236*r**20+13868141115316254*r**22
            +7603742470911884*r**24+1181241861769724*r**26+1672325982020944*r**28
            +166028405963972*r**30+68078220795521*r**32+16367119651891*r**34+1245202722526*r**36
            -17464353719*r**38-3819573010*r**40)-12*Q2**5*(363872015-17794062452*r**2
            -39739004270*r**4+3367967454165*r**6+26210656741310*r**8+180305894769362*r**10
            +697560239845136*r**12+815627263476920*r**14+3318001767676910*r**16+454421691076840*r**18
            -1865751685168596*r**20-1952748307406286*r**22+239892944474420*r**24+3093595344572860*r**26
            +739988119797040*r**28+695574057563296*r**30+176571745751947*r**32+26448527599180*r**34
            +3527737746690*r**36-31463870815*r**38-17922894202*r**40+340388530*r**42)
            +6*Q2**4*(931521235-12997916181*r**2-338535368970*r**4+7604056750*r**6
            +25701653952975*r**8+327003407964195*r**10+1314102441006924*r**12+5524704824568120*r**14
            +13114195109047950*r**16+7747170674470150*r**18+5344193343130380*r**20
            +10830265121334564*r**22+4287222755586910*r**24+6786932773414350*r**26
            +12600834124085400*r**28+5358939629418840*r**30+1301007760091199*r**32
            +327061409206575*r**34+25684096235950*r**36+260763688350*r**38-335659896525*r**40
            -14771940881*r**42+959941740*r**44)-27*Q2**3*(36623845+604341498*r**2
            -24198258537*r**4-439314673140*r**6-637665550425*r**8+9905234093510*r**10
            +43919178120293*r**12+722719450701588*r**14+333075950114370*r**16+757069935323700*r**18
            +345997002380950*r**20+1274644436448008*r**22+1167173705275358*r**24+149984990617980*r**26
            +600015785424250*r**28+289315415288440*r**30+716736599371113*r**32+40841835170418*r**34
            +10550694226115*r**36-660878026900*r**38-436143444245*r**40-24702632162*r**42
            +495578673*r**44+39885300*r**46)-54*(-1+r**2)**2*(958023-15650637*r**2
            -607704817*r**4+314922603*r**6+110660295543*r**8+1578803410833*r**10
            +8941707934973*r**12+47316484033993*r**14+99512728603388*r**16-200362599317922*r**18
            +1060695223769238*r**20+122811283763278*r**22-1866084392083202*r**24+181602944601218*r**26
            +1046047023011258*r**28-217004132564942*r**30+97133988319823*r**32+46111111014943*r**34
            +8836680276363*r**36+1582518179703*r**38+109766073723*r**40+770138813*r**42
            -597192167*r**44-17787947*r**46+993918*r**48)-18*Q2**2*(38894180-1296792273*r**2
            -12848525034*r**4+337947056067*r**6+3585926493300*r**8+35656899385785*r**10
            +162994935753382*r**12+288806239949661*r**14+2730287251460292*r**16-2382019787935930*r**18
            +2674427512746540*r**20+3463143819687342*r**22+445897411848696*r**24+3308493747176322*r**26
            +2351290862561340*r**28-2438122224179030*r**30+2714669845818012*r**32
            +263669951890011*r**34+164367483998462*r**36+35215958237535*r**38+3565307886900*r**40
            +357346946037*r**42-12096300834*r**44-1361341143*r**46+39284380*r**48)
            +27*Q2*(13457491-288595748*r**2-6701491498*r**4+45922407872*r**6+1218334982772*r**8
            +14822832127632*r**10+67585891051042*r**12+275309280418592*r**14+848650919931087*r**16
            -2301578560828788*r**18+5715486524520412*r**20+1789157585874112*r**22
            -4768062657532288*r**24-4533117044770368*r**26+2041231724113732*r**28
            +5559524318717312*r**30-2387170370753983*r**32+841269271682292*r**34+263936145922862*r**36
            +67156691965312*r**38+14809768955532*r**40+1202507083952*r**42+51883785402*r**44
            -6505863328*r**46-317042403*r**48+13880996*r**50))*sqrtq2)+logq2*(3072*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7
            +2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(1263344*Q2**25-2*Q2**24*(11138417+11210561*r**2)+8*Q2**23*(20325625
            +47448835*r**2+20553226*r**4)-4*Q2**22*(161190584+634745075*r**2+637428132*r**4
            +163705913*r**6)+2*Q2**21*(729058379+4345929959*r**2+6682574491*r**4
            +4383578909*r**6+744577454*r**8)-2*Q2**20*(776127094+7359917023*r**2
            +11120116760*r**4+11227671450*r**6+7492387888*r**8+803297461*r**10)-Q2**19*(735241019
            -2471770643*r**2+57903438180*r**4+135859103090*r**6+56823326495*r**8
            -3038497011*r**10+696879662*r**12)+2*Q2**18*(2258881085+20248150550*r**2
            +173445242904*r**4+506460027335*r**6+505367524925*r**8+172084805580*r**10
            +19899407390*r**12+2282462759*r**14)-Q2**17*(4761709961+78431072165*r**2
            +680588398973*r**4+2729648668127*r**6+4096766028245*r**8+2722617453191*r**10
            +677657565695*r**12+78304983533*r**14+4901462942*r**16)+Q2**16*(-1483001562
            +46509160778*r**2+487696279452*r**4+3268838710148*r**6+6351046485608*r**8
            +6344114032968*r**10+3263473234268*r**12+490924760372*r**14+47806839018*r**16
            -1369022682*r**18)+4*Q2**15*(1960775733+11670279531*r**2+111834475375*r**4
            +79085895950*r**6+755665078721*r**8+1762256929042*r**10+753623396051*r**12
            +73189449470*r**14+108001660870*r**16+11068009071*r**18+1970765562*r**20)
            -4*Q2**14*(1330129266+24264911718*r**2+314924288815*r**4+1652291331045*r**6
            +7002210824575*r**8+16762303747529*r**10+16749246485277*r**12+6976294520875*r**14
            +1631847531095*r**16+310324060985*r**18+23940675276*r**20+1368412008*r**22)
            +4*Q2**13*(-875598940+11462516580*r**2+239617478307*r**4+2260828198910*r**6
            +11072995821200*r**8+35638001037240*r**10+51835534183250*r**12+35560950072968*r**14
            +11008587915840*r**16+2231995350500*r**18+240109878955*r**20+11918274570*r**22
            -851702788*r**24)+4*Q2**12*(1752056006+8731429655*r**2+28473604453*r**4
            -1051341488233*r**6-5197580270020*r**8-27810292254581*r**10-54660770821090*r**12
            -54547823373238*r**14-27649520663642*r**16-5138202044515*r**18-1039988103859*r**20
            +21082831615*r**22+7856616248*r**24+1761972497*r**26)-2*Q2**11*(941203181
            +28396222571*r**2+397155980374*r**4+1474878253326*r**6+13169465450501*r**8
            +32820672194389*r**10+85896583856934*r**12+137214623201876*r**14+86385130224919*r**16
            +32998284982989*r**18+13102086451106*r**20+1414817276206*r**22+382521716679*r**24
            +27698145731*r**26+984547826*r**28)+4*Q2**10*(-844513777+6347409526*r**2
            +160644353205*r**4+1466290725800*r**6+11104593906596*r**8+50545350847953*r**10
            +163855271827064*r**12+332624131068125*r**14+332850568298355*r**16+163961846430764*r**18
            +50312643502625*r**20+10988511261366*r**22+1410619113770*r**24+160953135965*r**26
            +6792819426*r**28-836001163*r**30)+2*Q2**9*(1396027573+3673454089*r**2
            -52336326345*r**4-2049648015185*r**6-11148709541945*r**8-71235079451803*r**10
            -265955912594609*r**12-739931074425365*r**14-1061646340455415*r**16-740464072483085*r**18
            -265352895608843*r**20-70111103253019*r**22-11048692515155*r**24-1995139249985*r**26
            -64787329755*r**28+2615436193*r**30+1404022894*r**32)+2*Q2**8*(138530005
            -8990149955*r**2-141905792306*r**4+625851344230*r**6+146593697500*r**8
            +8235282188060*r**10-24606009175110*r**12+76714975400146*r**14+283930962047450*r**16
            +283602492460650*r**18+76187229728290*r**20-25850384238550*r**22+7117558207716*r**24
            +290519391460*r**26+685368515350*r**28-132422171810*r**30-8923893935*r**32
            +129850009*r**34)+4*Q2**7*(-314182049+2852187145*r**2+74909934633*r**4
            +158269598182*r**6+600529657105*r**8+3746206868604*r**10+69084453076535*r**12
            +155299503668042*r**14+284848101938763*r**16+384106730821570*r**18+285088230957749*r**20
            +155960883392730*r**22+69852015187307*r**24+3889024654148*r**26+543578998845*r**28
            +109882722166*r**30+74879518810*r**32+3103860213*r**34-313695698*r**36)
            +4*Q2**6*(102629782-43980743*r**2-19023258697*r**4-384658538978*r**6
            -778806151013*r**8-3061053654207*r**10-39684347923417*r**12-36513988849483*r**14
            -145088887760777*r**16-232171826352437*r**18-231915930474347*r**20-141531329735927*r**22
            -35000159257063*r**24-40617671149357*r**26-2687719944267*r**28-814234208153*r**30
            -368865790913*r**32-21196215832*r**34-171029288*r**36+103357117*r**38)
            +2*Q2**5*(105322601-2454680323*r**2-42267791405*r**4+716494357275*r**6
            +3733884099542*r**8+22166481059540*r**10+90893612744908*r**12+76231109120740*r**14
            +316267401541910*r**16-176343348975722*r**18-136708549788454*r**20-185723119583982*r**22
            +293886553100400*r**24+63937472973220*r**26+92543183196508*r**28+21218558897924*r**30
            +3811479587897*r**32+747852907765*r**34-39402888405*r**36-2530066453*r**38
            +104896514*r**40)-2*Q2**4*(85027302-1433208649*r**2-35751161190*r**4
            +258002301180*r**6+2948886274720*r**8+25097152439457*r**10+98793607078056*r**12
            +296725291982560*r**14+680908386363420*r**16-111013474787250*r**18+355122959382972*r**20
            +325540167700296*r**22-147290630736000*r**24+655177976797370*r**26+282984801526440*r**28
            +98843243360352*r**30+24845099280686*r**32+2926772287755*r**34+287991997530*r**36
            -35364854660*r**38-1532240208*r**40+85107861*r**42)+3*Q2**3*(4244735
            +27619145*r**2-2209531744*r**4-86306109590*r**6+105951504075*r**8+3523184537045*r**10
            +8535546625030*r**12+128697121032856*r**14+30097078598830*r**16-66719762434350*r**18
            +71925236755960*r**20+364258176586940*r**22+51251918761406*r**24-88968799744590*r**26
            +22669002056500*r**28+127799595481880*r**30+7568403182675*r**32+3713724280421*r**34
            +85015252600*r**36-83860603350*r**38-2561796745*r**40+19566585*r**42
            +4213686*r**44)+18*(-1+r**2)**2*(59601-2108175*r**2-59968131*r**4+1087495113*r**6
            +10037215325*r**8+135212262321*r**10+640277434185*r**12+1642970835329*r**14
            +10197117215858*r**16-41148155435550*r**18+128287282692106*r**20-95087183175630*r**22
            -90769233898926*r**24+128527116983498*r**26-42526298861750*r**28+10333008465546*r**30
            +1512909025405*r**32+639159725389*r**34+135016327353*r**36+9786810725*r**38
            +1144614801*r**40-58747035*r**42-2227411*r**44+60053*r**46)+6*Q2**2*(3871599
            -121036310*r**2-2393540078*r**4+59355300643*r**6+301103125505*r**8+2545265166454*r**10
            +13795126312490*r**12-1543472327143*r**14+192735299234718*r**16-275650930569460*r**18
            +203220819867324*r**20+115657975591270*r**22+114584856440202*r**24+186113071410868*r**26
            -279393678589220*r**28+194641248925594*r**30-4386506447645*r**32+14193282493962*r**34
            +2470467915538*r**36+298546903175*r**38+61400849029*r**40-2268517930*r**42
            -126681318*r**44+3900733*r**46)-9*Q2*(998593-32904227*r**2-762000303*r**4
            +16131531503*r**6+100799153593*r**8+1181186779443*r**10+5206822966023*r**12
            +5159320205257*r**14+82552124303808*r**16-297521054200142*r**18+614388762917338*r**20
            -158813389704282*r**22-415682078200878*r**24-134879150769642*r**26+608698754066718*r**28
            -304926098805502*r**30+84453328289153*r**32+3836715425697*r**34+5271719523973*r**36
            +1172063485243*r**38+97834193253*r**40+16836264583*r**42-737474773*r**44
            -34650267*r**46+1005838*r**48))-3072*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(10106752*Q2**30-32*Q2**29*(6161401+6197473*r**2)+2*Q2**28*(817496255
            +1863704142*r**2+825861647*r**4)-8*Q2**27*(948067531+3604572572*r**2
            +3619007391*r**4+961542862*r**6)+4*Q2**26*(5278400191+30069269722*r**2
            +47575923905*r**4+30306495280*r**6+5377845706*r**8)-2*Q2**25*(16333762453
            +140382480330*r**2+278723867178*r**4+280254774748*r**6+142344883737*r**8
            +16774807474*r**10)+2*Q2**24*(5510545905+138548053015*r**2+123060524566*r**4
            -86753674862*r**6+131711300283*r**8+143531124555*r**10+6021456690*r**12)
            +Q2**23*(61264065225+332117698380*r**2+3457264904947*r**4+10907448766650*r**6
            +10870603404619*r**8+3406476295096*r**10+316667698305*r**12+61370870730*r**14)
            -2*Q2**22*(59724183555+726592398585*r**2+5851137079744*r**4+22775162202483*r**6
            +34572035562204*r**8+22705570564235*r**10+5811507038412*r**12+721833995505*r**14
            +60893532285*r**16)+Q2**21*(47834876455+1786971691860*r**2+16590387741622*r**4
            +90289182496858*r**6+187083930493216*r**8+186922490708666*r**10+90102705709274*r**12
            +16580970517766*r**14+1804542525225*r**16+51133501330*r**18)+2*Q2**20*(67412115575
            -53610325675*r**2-2180948415664*r**4-35640770198544*r**6-95056184472714*r**8
            -117121633505182*r**10-95059330431000*r**12-35782629709752*r**14-2300901067357*r**16
            -79992223615*r**18+67034439080*r**20)-Q2**19*(205622057045+2359354216260*r**2
            +22650103016653*r**4+76869084185634*r**6+278805629556114*r**8+728732665694504*r**10
            +727731218686602*r**12+276702933391668*r**14+75175236068009*r**16+22156863216164*r**18
            +2307214226745*r**20+208959108410*r**22)+2*Q2**18*(11702643875+1323226314445*r**2
            +18177190505186*r**4+132746244458485*r**6+590162654719267*r**8+1770536865661538*r**10
            +2562388272035204*r**12+1766745630943450*r**14+586596169185905*r**16+131135828349217*r**18
            +18026899118858*r**20+1329956625345*r**22+13732613945*r**24)+Q2**17*(201317887795
            -126350736560*r**2-15557520112068*r**4-275604489449906*r**6-1548188908414593*r**8
            -6206960543151886*r**10-12148439710289616*r**12-12135686972373604*r**14
            -6186476394310063*r**16-1537791366262268*r**18-273216694866540*r**20-16006486964394*r**22
            -217980167555*r**24+201020298490*r**26)-2*Q2**16*(84469388605+1126245401160*r**2
            +9983765679319*r**4-16605346209344*r**6-214330497827733*r**8-1893926184973072*r**10
            -5206194501722535*r**12-6819364878831984*r**14-5188793540500829*r**16
            -1883818331076632*r**18-213400252968663*r**20-17766673522032*r**22+9479083109557*r**24
            +1085284324800*r**26+86050263655*r**28)+2*Q2**15*(-28670805915+990811535500*r**2
            +16099311973011*r**4+118744938157266*r**6+703463312963361*r**8+2365497684851144*r**10
            +6128036618606855*r**12+12460475318859598*r**14+12472023125544983*r**16
            +6134772557870972*r**18+2352943320582257*r**20+694559161543150*r**22+114971047566403*r**24
            +15820510411408*r**26+1001523029205*r**28-27466450350*r**30)+4*Q2**14*(39762764805
            -5695635885*r**2-3331134481552*r**4-68276274049251*r**6-500612090689426*r**8
            -2903103353477977*r**10-10441602166323516*r**12-26230551906164983*r**14
            -36267094693894684*r**16-26219391910444959*r**18-10412709968019832*r**20
            -2877189773284081*r**22-494133380679222*r**24-66659565819451*r**26-3460547120476*r**28
            -28861588245*r**30+39881070015*r**32)+2*Q2**13*(-23990611725-611717563020*r**2
            -5429757228494*r**4+46322585579970*r**6+451767966814842*r**8+4584141318825218*r**10
            +20958201382905258*r**12+70489721094815682*r**14+130824866762937560*r**16
            +130755171209072778*r**18+70339216765883622*r**20+20817519837988838*r**22
            +4518883803210534*r**24+449104382037510*r**26+47425888529342*r**28-4944198669162*r**30
            -588078997995*r**32-24756804870*r**34)-2*Q2**12*(34507474435-470552925480*r**2
            -8615094991831*r**4-40626173661112*r**6-173589246022876*r**8+353342013605416*r**10
            +2567034547424524*r**12+24813469678285832*r**14+70161044327148754*r**16
            +93389156942200616*r**18+69898973141119046*r**20+24560894048603800*r**22
            +2436806040434980*r**24+337670395997720*r**26-162569965112276*r**28-35931329523560*r**30
            -8418708497693*r**32-488817973440*r**34+34258739545*r**36)+2*Q2**11*(27851423255
            -8231521540*r**2-3454829388509*r**4-61687426217706*r**6-338475205921692*r**8
            -2446947769817144*r**10-14889366048429612*r**12-49708973358725648*r**14
            -121509724716401294*r**16-211273649960351920*r**18-211497572683627590*r**20
            -121739757102889556*r**22-49751928775361292*r**24-14883724020917096*r**26
            -2380241161902044*r**28-326819417610432*r**30-58504410945633*r**32-3635372471852*r**34
            -32760983125*r**36+28058457230*r**38)+4*Q2**10*(2108035030-122969970825*r**2
            -1103852116197*r**4+18920360482473*r**6+124704722615523*r**8+1282913365998260*r**10
            +8030132304353100*r**12+37946533787993580*r**14+122663717435165200*r**16
            +268921783858951618*r**18+357015504383300442*r**20+268982915374328750*r**22
            +122421895468938738*r**24+37694772316553508*r**26+7972218668005564*r**28
            +1236590824972188*r**30+123735142220850*r**32+19519907591279*r**34-982566274301*r**36
            -121968325215*r**38+2026482835*r**40)-4*Q2**9*(6365890565-83195239355*r**2
            -1571027664743*r**4+2294156379111*r**6+71299704972566*r**8+808756672495528*r**10
            +3919692480027484*r**12+21760505410105108*r**14+75176108968582514*r**16
            +204477647290118134*r**18+360916507454870774*r**20+360754549238940722*r**22
            +203956235038712548*r**24+74409574998358564*r**26+21320848759236284*r**28
            +3877782328120868*r**30+797701762643729*r**32+73644167765437*r**34+3754284143961*r**36
            -1539043965009*r**38-88469723010*r**40+6370146620*r**42)+2*Q2**8*(2963351975
            +15080477735*r**2-820044929824*r**4-18303791358070*r**6+6723358539277*r**8
            +579139043538383*r**10+2015726292918012*r**12+8839314800408376*r**14-19272289675823450*r**16
            -30616523027580802*r**18+8158002510370992*r**20+43033032997482716*r**22
            +6152579433892250*r**24-33411151267990170*r**26-21234448579027352*r**28
            +8271584977366392*r**30+1997407620976227*r**32+640673150181563*r**34+11769784133840*r**36
            -17226337106198*r**38-892483770967*r**40+10362102635*r**42+3004774460*r**44)
            +Q2**7*(5871460285-153121038180*r**2-1632351988153*r**4+38834906242114*r**6
            +195300949646907*r**8+779778636464952*r**10+1286929068519465*r**12+5014706532701130*r**14
            +141495781939140530*r**16+314561831087881768*r**18+779944314900901206*r**20
            +1146359281562823076*r**22+1148446040392918054*r**24+781878825697732128*r**26
            +318806609236228418*r**28+144518757382977732*r**30+4616428199236353*r**32
            +1319885697742684*r**34+659113530701683*r**36+189231914765082*r**38+40414217667375*r**40
            -1499697868664*r**42-157493793915*r**44+5859897970*r**46)-2*Q2**6*(1676223015
            -30276824995*r**2-644932977056*r**4+4920776553511*r**6+82288972425432*r**8
            +831920179650635*r**10+2880613261634204*r**12+11377910810005913*r**14
            +55021112384924939*r**16+38226132687289106*r**18+215607335358361552*r**20
            +238515203285047350*r**22+253794881897371224*r**24+236046675952061414*r**26
            +207974119246478632*r**28+35212423380058306*r**30+55658853340996093*r**32
            +10789179859854337*r**34+2885334977687536*r**36+829802768360115*r**38
            +82068064386992*r**40+5708324656223*r**42-636447069668*r**44-32408359275*r**46
            +1682964465*r**48)-3*Q2**5*(120400319-7066529100*r**2+21062757966*r**4
            +3660157636266*r**6-9482143087244*r**8-366337504337334*r**10-2352230082868790*r**12
            -14134086767007746*r**14-43420742836693701*r**16-82800173662253038*r**18
            -201390921429212916*r**20-33090033216637020*r**22+35701193352354912*r**24
            +41403379168368772*r**26-21740804388457452*r**28-189653365254634628*r**30
            -77457868176531515*r**32-43128438365649000*r**34-13940865767297530*r**36
            -2328606302601006*r**38-383597053744980*r**40-10717801675950*r**42+3601952359618*r**44
            +32007081318*r**46-7044131135*r**48+119510914*r**50)+6*Q2**4*(121061247
            -3809216169*r**2-44185250978*r**4+1509174309176*r**6+4988357050586*r**8
            -21188708132806*r**10-597241216024588*r**12-5086713211563328*r**14-17186233832388179*r**16
            -73730784221296419*r**18-104428449184631286*r**20-64896784259780528*r**22
            -48148835595416548*r**24-121393801255559044*r**26-38327922283885384*r**28
            -54558572007292576*r**30-98814554939316823*r**32-71793902519760383*r**34
            -16795964711321454*r**36-5119790751007944*r**38-587252867807126*r**40
            -25230183922198*r**42+4479360830612*r**44+1561815961376*r**46-41079489589*r**48
            -3961162453*r**50+121412806*r**52)-9*Q2**3*(14230665-355499724*r**2-10093161447*r**4
            +87794705130*r**6+2131471928974*r**8+30922505805736*r**10+37451738773542*r**12
            -32223451447556*r**14-421102605582205*r**16-19515531203414596*r**18+23349789810563931*r**20
            -51506023366008658*r**22+15156769070591284*r**24-14173592560628240*r**26
            -12747927832324956*r**28+16743068234933416*r**30-48157219822875713*r**32
            +24892993915132204*r**34-19735531981063425*r**36-240489842945946*r**38
            -61289546671394*r**40+36041941141352*r**42+31418288991574*r**44+2100149043740*r**46
            +102243072149*r**48-10080568604*r**50-380593299*r**52+14272066*r**54)
            -54*(-1+r**2)**2*(59601-2882988*r**2-38998764*r**4+2088326808*r**6+2603245091*r**8
            -106216985084*r**10-2318173225764*r**12-22381776799444*r**14-95043787170179*r**16
            -422049214544064*r**18-623704600556024*r**20+1559171926128636*r**22-8396581149294609*r**24
            -1731960452231864*r**26+16650231393971896*r**28-2150255815490184*r**30
            -8335991700665069*r**32+1696224950500756*r**34-606164146939164*r**36-411024259444464*r**38
            -93071906485479*r**40-22449845056524*r**42-2295885002964*r**44-109456914404*r**46
            +1491277791*r**48+2142400920*r**50-36276416*r**52-3008100*r**54+60053*r**56)
            -18*Q2**2*(3275589-153416057*r**2-652399350*r**4+97569201615*r**6-259098222019*r**8
            -10771280685902*r**10-76600236480036*r**12-639638879483286*r**14-2208303016953527*r**16
            -4400366497950099*r**18-27878811226040562*r**20+42770424977401629*r**22
            -66184346335622271*r**24-24987477407113012*r**26+36399588209599336*r**28
            -25966551378807492*r**30-63128223435030801*r**32+44059268400161329*r**34
            -27973095530313402*r**36-4007543118437799*r**38-2210908123101417*r**40
            -637449851256606*r**42-74796290259076*r**44-11117946562502*r**46-302802420669*r**48
            +98129281659*r**50-465396254*r**52-158269221*r**54+3300203*r**56)+27*Q2*(998593
            -46362744*r**2-432856924*r**4+30249146834*r**6-24679141079*r**8-2024221892426*r**10
            -24830216260656*r**12-221032317142356*r**14-735333354769571*r**16-2640605971477396*r**18
            -5669375953848876*r**20+21807771812003414*r**22-61811586617213211*r**24
            +12994014555685794*r**26+24758007514021824*r**28+24265934637658504*r**30
            +10820266494142259*r**32-61190955187625616*r**34+22745452669128204*r**36
            -5683742986246306*r**38-2521494694301141*r**40-721060690192166*r**42-221943592483216*r**44
            -24353932434676*r**46-2078498612881*r**48-39911658404*r**50+30828454268*r**52
            -385519302*r**54-48206585*r**56+1005838*r**58))*sqrtq2))*math.log(r))/(1890000*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2+1890000*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2+logq2**8*(182849716224000000*r**36*(1
            +r**2)**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+182849716224000000*r**36*(1
            +r**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2*(-272160000*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4
            -Q2**3*(1+r**2)-2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4
            +r**6)+4*(1-9*r**2-44*r**4-9*r**6+r**8))-272160000*(-Q2+(-1+r)**2)**3*r**8*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4-Q2**3*(1+r**2)
            -2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4+r**6)+4*(1-9*r**2
            -44*r**4-9*r**6+r**8))*sqrtq2)+logq2**7*(-4063327027200000*r**32*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))-4063327027200000*r**32*(1+r**2)*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))*sqrtq2)+logq2**3*(-65318400000*(-Q2+(-1+r)**2)**3*r**16*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)
            -Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2+683*r**4+169*r**6)
            +2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)+6*Q2**3*(31+230*r**2
            +159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4
            +8368*r**6+6523*r**8+1184*r**10-131*r**12)-9*Q2*(13+5*r**2-1493*r**4
            -5245*r**6-5245*r**8-1493*r**10+5*r**12+13*r**14)+36*(4-67*r**2-28*r**4
            +2331*r**6+5600*r**8+2331*r**10-28*r**12-67*r**14+4*r**16))-65318400000*(
            -Q2+(-1+r)**2)**3*r**16*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)-Q2**6*(333+410*r**2+333*r**4)
            -Q2**5*(169+683*r**2+683*r**4+169*r**6)+2*Q2**4*(275-725*r**2-3408*r**4
            -725*r**6+275*r**8)+6*Q2**3*(31+230*r**2+159*r**4+159*r**6+230*r**8
            +31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4+8368*r**6+6523*r**8+1184*r**10
            -131*r**12)-9*Q2*(13+5*r**2-1493*r**4-5245*r**6-5245*r**8-1493*r**10
            +5*r**12+13*r**14)+36*(4-67*r**2-28*r**4+2331*r**6+5600*r**8+2331*r**10
            -28*r**12-67*r**14+4*r**16))*sqrtq2)+logq2**2*(16329600000*(-Q2+(-1
            +r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8
            -4*Q2**7*(1+r**2)-Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4
            +5*r**6)+Q2**4*(85-226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1
            -54*r**2-143*r**4-143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4
            +3168*r**6+2871*r**8+468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4
            -2833*r**6-2833*r**8-565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4
            +4368*r**6+11718*r**8+4368*r**10-56*r**12-96*r**14+5*r**16))+16329600000*(
            -Q2+(-1+r)**2)**3*r**12*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8
            -4*Q2**7*(1+r**2)-Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4
            +5*r**6)+Q2**4*(85-226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1
            -54*r**2-143*r**4-143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4
            +3168*r**6+2871*r**8+468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4
            -2833*r**6-2833*r**8-565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4
            +4368*r**6+11718*r**8+4368*r**10-56*r**12-96*r**14+5*r**16))*sqrtq2)
            +logq2**5*(-5643509760000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1
            +r**2)-Q2**6*(219+310*r**2+219*r**4)-Q2**5*(977+2179*r**2+2179*r**4
            +977*r**6)+Q2**4*(590-2090*r**2-6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243
            +10*r**2-2073*r**4-2073*r**6+10*r**8+243*r**10)+Q2**2*(-879+8076*r**2
            +41127*r**4+61272*r**6+41127*r**8+8076*r**10-879*r**12)+Q2*(-741+3075*r**2
            +31341*r**4+67125*r**6+67125*r**8+31341*r**10+3075*r**12-741*r**14)
            +12*(41-573*r**2+28*r**4+12789*r**6+25830*r**8+12789*r**10+28*r**12
            -573*r**14+41*r**16))-5643509760000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)-Q2**5*(977
            +2179*r**2+2179*r**4+977*r**6)+Q2**4*(590-2090*r**2-6768*r**4-2090*r**6
            +590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4-2073*r**6+10*r**8+243*r**10)
            +Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6+41127*r**8+8076*r**10
            -879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6+67125*r**8+31341*r**10
            +3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4+12789*r**6+25830*r**8
            +12789*r**10+28*r**12-573*r**14+41*r**16))*sqrtq2)+logq2**4*(1175731200000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219
            +310*r**2+219*r**4)-24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415
            -1180*r**2-4598*r**4-1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4
            -677*r**6+155*r**8+102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6
            +18377*r**8+3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6
            -3030*r**8-1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4
            +24556*r**6+53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))+1175731200000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2
            +219*r**4)-24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415-1180*r**2
            -4598*r**4-1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4-677*r**6
            +155*r**8+102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6+18377*r**8
            +3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8
            -1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6
            +53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))*sqrtq2)+logq2**6*(22574039040000*r**28*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(16*Q2**8+332*Q2**7*(1
            +r**2)+Q2**6*(153+370*r**2+153*r**4)-Q2**5*(2011+4817*r**2+4817*r**4
            +2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4-2410*r**6+295*r**8)+6*Q2**3*(559
            -310*r**2-4869*r**4-4869*r**6-310*r**8+559*r**10)-3*Q2**2*(479-4496*r**2
            -22867*r**4-35272*r**6-22867*r**8-4496*r**10+479*r**12)-9*Q2*(187
            -865*r**2-5807*r**4-10315*r**6-10315*r**8-5807*r**10-865*r**12+187*r**14)
            +9*(109-1432*r**2+392*r**4+26376*r**6+49910*r**8+26376*r**10+392*r**12
            -1432*r**14+109*r**16))+22574039040000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(16*Q2**8+332*Q2**7*(1+r**2)+Q2**6*(153+370*r**2+153*r**4)
            -Q2**5*(2011+4817*r**2+4817*r**4+2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4
            -2410*r**6+295*r**8)+6*Q2**3*(559-310*r**2-4869*r**4-4869*r**6-310*r**8
            +559*r**10)-3*Q2**2*(479-4496*r**2-22867*r**4-35272*r**6-22867*r**8
            -4496*r**10+479*r**12)-9*Q2*(187-865*r**2-5807*r**4-10315*r**6-10315*r**8
            -5807*r**10-865*r**12+187*r**14)+9*(109-1432*r**2+392*r**4+26376*r**6
            +49910*r**8+26376*r**10+392*r**12-1432*r**14+109*r**16))*sqrtq2)))+muWC**2*((pi2*(
            -4*r**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(92*Q2**18+60*Q2**17*(1+r**2)+4*Q2**16*(
            -1519+3228*r**2+1499*r**4)-Q2**15*(-34969+160589*r**2+1046341*r**4
            +72623*r**6)+Q2**14*(-94735+776500*r**2+10808350*r**4+8852676*r**6+299825*r**8)
            -Q2**13*(-135799+1877655*r**2+43289452*r**4+82368756*r**6+29535579*r**8
            +576101*r**10)+Q2**12*(-76245+2114840*r**2+79598981*r**4+277504064*r**6
            +239240429*r**8+38482536*r**10+381315*r**12)+Q2**11*(-56927+50819*r**2
            -41680119*r**4-387002253*r**6-530987613*r**8-237317447*r**10+20511955*r**12
            +493297*r**14)-Q2**10*(-101673+2723028*r**2+87830460*r**4-63891428*r**6
            +60797850*r**8+280696044*r**10+261376636*r**12+122446116*r**14+1074711*r**16)
            +Q2**9*(9295+1716825*r**2+153045270*r**4+436523258*r**6+1396512740*r**8
            +3429691340*r**10+2103692810*r**12+851014790*r**14+112792173*r**16+341275*r**18)
            +Q2**8*(-120549+2320560*r**2-37227201*r**4-528837568*r**6-1065281922*r**8
            -4841499376*r**10-6297176130*r**12-1670586336*r**14-590459833*r**16+54890208*r**18
            +889251*r**20)-Q2**7*(-89635+3712335*r**2+105058067*r**4-340834967*r**6
            +511955778*r**8+1046459542*r**10+777200710*r**12-778030638*r**14+1950721473*r**16
            +357891963*r**18+168225927*r**20+994085*r**22)+Q2**6*(10907+875276*r**2
            +89263870*r**4-158583284*r**6+193046501*r**8+5395152088*r**10+19515767172*r**12
            +17554642744*r**14+8434570341*r**16+3289645276*r**18+764189182*r**20
            +76673404*r**22+70043*r**24)+Q2**5*(-48803+1674323*r**2+9932888*r**4
            -178260472*r**6+848638885*r**8-1763653493*r**10-16900419912*r**12-39203740728*r**14
            -12693116089*r**16-8386679415*r**18+37241456*r**20-323302736*r**22+63392055*r**24
            +508441*r**26)-Q2**4*(-21065+1300200*r**2+41907245*r**4-417821216*r**6
            +224047815*r**8+975854760*r**10-701297035*r**12-14255612160*r**14-29566065683*r**16
            +20178975160*r**18-714459345*r**20+2445366560*r**22+131177365*r**24+76375224*r**26
            +316975*r**28)+Q2**3*(5283-7655*r**2+13345903*r**4-193648251*r**6-570114849*r**8
            -152368323*r**10-3295991205*r**12-11620863591*r**14+4354598937*r**16
            -12379537797*r**18+26031776957*r**20+3845099135*r**22+1061850213*r**24
            +170056239*r**26+14144121*r**28-9117*r**30)+Q2**2*(-7825+391060*r**2
            +5478336*r**4-108011956*r**6+403896324*r**8+279101876*r**10+2821795840*r**12
            +18885157708*r**14+18283866522*r**16+6908662492*r**18-12997085632*r**20
            +3267499140*r**22-3037842044*r**24+600798684*r**26-57506816*r**28+15657956*r**30
            +84335*r**32)-3*Q2*(-907+59419*r**2+1384374*r**4-40213254*r**6+35892346*r**8
            -134272058*r**10-2180654706*r**12+53763714*r**14-2428061692*r**16-7896633092*r**18
            +23365152962*r**20-15426377970*r**22+4793498550*r**24-336016054*r**26
            +191370746*r**28-2026122*r**30+3122007*r**32+11737*r**34)+3*(-113+8848*r**2
            +237471*r**4-9760736*r**6+6254580*r**8-82272976*r**10-1391081884*r**12
            +1374664192*r**14-13813606422*r**16+43249613040*r**18-52589566534*r**20
            +29995134624*r**22-8274408172*r**24+1532131152*r**26-39342620*r**28+41405248*r**30
            +60287*r**32+528384*r**34+1631*r**36))-4*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(736*Q2**22-164*Q2**21*(1+r**2)+8*Q2**20*(-6209+12830*r**2
            +5863*r**4)-20*Q2**19*(-16107+66795*r**2+425321*r**4+31155*r**6)+5*Q2**18*(
            -191935+1396628*r**2+18982358*r**4+15714020*r**6+573089*r**8)-2*Q2**17*(
            -743353+9181315*r**2+210439090*r**4+398849530*r**6+146667235*r**8+3090527*r**10)
            +Q2**16*(-810729+22144926*r**2+881714845*r**4+3089930340*r**6+2671394545*r**8
            +456317406*r**10+4784571*r**12)+4*Q2**15*(-262898+764215*r**2-150861544*r**4
            -1340268435*r**6-1965172890*r**8-881680183*r**10+28555120*r**12+1497871*r**14)
            -20*Q2**14*(-93439+2025190*r**2+50476392*r**4-115760126*r**6-243169743*r**8
            -99985982*r**10+92556030*r**12+72542542*r**14+777440*r**16)+20*Q2**13*(
            -3010+1456929*r**2+111635934*r**4+325781616*r**6+949127860*r**8+2135860308*r**10
            +1353719658*r**12+589236664*r**14+83141990*r**16+310787*r**18)+4*Q2**12*(
            -535171+9331010*r**2-181465215*r**4-2963189550*r**6-10276258125*r**8
            -33297080804*r**10-35914992495*r**12-11567244990*r**14-3072315480*r**16
            +161712590*r**18+3717974*r**20)-4*Q2**11*(-407524+16519711*r**2+488043590*r**4
            -1921351425*r**6-6025344060*r**8-34993132166*r**10-60171084836*r**12
            -35195915610*r**14-199576200*r**16+817140815*r**18+704045446*r**20+4577651*r**22)
            +2*Q2**10*(318279+4140240*r**2+982978502*r**4+769342920*r**6+8079031035*r**8
            +13582344856*r**10+42152523300*r**12+45037217288*r**14+62067170885*r**16
            +35911777560*r**18+8757214614*r**20+710194160*r**22-453063*r**24)+20*Q2**9*(
            -71399+2452840*r**2+18798472*r**4-477432212*r**6-1516769741*r**8-9461408242*r**10
            -33881513380*r**12-66187424212*r**14-39234036757*r**16-21145306736*r**18
            -3127531220*r**20-609463880*r**22+80244697*r**24+711370*r**26)-10*Q2**8*(
            -34105+2995558*r**2+141045673*r**4-974323856*r**6-1130956499*r**8-14544085038*r**10
            -56616655057*r**12-211406379568*r**14-247458855871*r**16-63840564102*r**18
            -29984342153*r**20+2381844544*r**22+424346443*r**24+193942990*r**26+689969*r**28)
            -4*Q2**7*(-134514+3890235*r**2-99348440*r**4-25783395*r**6-1129268990*r**8
            +8891096539*r**10-32352779520*r**12+90227215265*r**14+275486365090*r**16
            +188817996105*r**18-153500580376*r**20-46982782425*r**22-15990252690*r**24
            -2807960255*r**26+6986640*r**28+1046331*r**30)+4*Q2**6*(-90181+5272454*r**2
            +111293140*r**4-1997881230*r**6+352771815*r**8+8104054886*r**10-48795009914*r**12
            -408055557590*r**14-1154903353125*r**16-1062373628990*r**18-766724823704*r**20
            -261962637994*r**22-103684435335*r**24-5397166830*r**26-1251959810*r**28
            +240196814*r**30+1173194*r**32)-4*Q2**5*(10913+391900*r**2+69513774*r**4
            -1080609260*r**6+1335602940*r**8+200219702*r**10+27021416430*r**12-256778954884*r**14
            -1452661624970*r**16-2738316873530*r**18-1126798664758*r**20-1012961279940*r**22
            -3750177844*r**24-36966938670*r**26+5070769690*r**28+614729268*r**30
            +83498785*r**32+58454*r**34)-20*Q2**4*(-5603+314730*r**2+1921509*r**4
            -103644366*r**6+256539277*r**8+4461509120*r**10+102549015*r**12-11810540434*r**14
            +32699137687*r**16+224241654616*r**18+436852355289*r**20-240878254290*r**22
            +24296863191*r**24-30911507896*r**26-6742984043*r**28-868557006*r**30
            -170253080*r**32+10201334*r**34+64150*r**36)+60*Q2**3*(-405+37606*r**2
            +1103021*r**4-38480558*r**6+139231104*r**8+1105706196*r**10+2296093892*r**12
            +2286272464*r**14+15646171846*r**16+20489197320*r**18-4704403122*r**20
            +38359259308*r**22-106763697016*r**24-42030495588*r**26-3742305372*r**28
            -1948299344*r**30-25594681*r**32-14112094*r**34+2356125*r**36+7298*r**38)
            +3*Q2**2*(-4313+230260*r**2-3126990*r**4+15667060*r**6-58556705*r**8
            +5614189792*r**10-24588920600*r**12-141108574560*r**14-468178935250*r**16
            -2451613456600*r**18-1949622466788*r**20-755144441880*r**22+1851832881590*r**24
            -732358578880*r**26+472408852040*r**28-40098187648*r**30+1342331595*r**32
            -898532540*r**34-174530430*r**36+1803140*r**38+37707*r**40)-18*Q2*(
            -397+31013*r**2+248190*r**4-26348410*r**6+178447315*r**8+1583713473*r**10
            -1272858112*r**12+12536987360*r**14+108715887310*r**16-63624780190*r**18
            +367116721868*r**20+157435300988*r**22-1075475371290*r**24+668805592610*r**26
            -155239831440*r**28-14488694192*r**30-4984570817*r**32-1186756135*r**34
            -54414010*r**36-20533810*r**38+1223623*r**40+5053*r**42)+9*(-113+10430*r**2
            +124221*r**4-13915460*r**6+120458625*r**8+744356342*r**10-690302965*r**12
            +28486145456*r**14+98860868230*r**16+126814542300*r**18+619758474002*r**20
            -3104449405560*r**22+3895904772306*r**24-1922665264580*r**26+283783738150*r**28
            +2408722672*r**30-26605651205*r**32-1809481114*r**34-632078815*r**36
            -9129700*r**38-7490403*r**40+505550*r**42+1631*r**44))*sqrtq2+logq2**6*(
            -2351462400000*(-Q2+(-1+r)**2)*(-1+r)*r**26*(1+r)*(1+r**2)*(1-Q2
            +r**2)*(-1-4*r**2+r**4)*(-Q2+(1+r)**2)-2351462400000*r**26*(1+4*r**2
            -2*r**4-4*r**6+r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**5*(3732480000*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(70*Q2**7*(1+r**2)-10*Q2**6*(23+76*r**2
            +53*r**4)+10*Q2**5*(-23+125*r**2+305*r**4+157*r**6)-2*Q2**4*(-858-1351*r**2
            +1389*r**4+2903*r**6+1133*r**8)+4*Q2**3*(-411-1663*r**2-1744*r**4+554*r**6
            +1372*r**8+326*r**10)+2*Q2**2*(-612+853*r**2+4453*r**4+3032*r**6-664*r**8
            -595*r**10+337*r**12)-3*Q2*(-957-1022*r**2+1047*r**4+1068*r**6-735*r**8
            -498*r**10+645*r**12+452*r**14)+3*(-443-589*r**2-2175*r**4-1587*r**6
            +4321*r**8+989*r**10-985*r**12+291*r**14+178*r**16))-3732480000*r**22*(70*Q2**10*(1
            +r**2)-20*Q2**9*(22+59*r**2+37*r**4)+10*Q2**8*(67+457*r**2+727*r**4
            +337*r**6)-2*Q2**7*(-823+1549*r**2+9669*r**4+11503*r**6+4318*r**8)
            +14*Q2**6*(-518-1149*r**2+268*r**4+2962*r**6+3016*r**8+953*r**10)+Q2**5*(9086
            +36652*r**2+49978*r**4+8436*r**6-47814*r**8-44996*r**10-11606*r**12)
            +5*Q2**4*(-21-4522*r**2-13389*r**4-14272*r**6-4211*r**8+5058*r**10
            +4445*r**12+560*r**14)-3*(-1+r**2)**3*(443+1475*r**2+4239*r**4+8001*r**6
            +5267*r**8-43*r**10-47*r**12+647*r**14+178*r**16)+2*Q2**3*(-5985-5950*r**2
            +9419*r**4+20598*r**6+23613*r**8+8606*r**10-699*r**12+2170*r**14+2660*r**16)
            -2*Q2**2*(-6912-10649*r**2-10887*r**4-16467*r**6+9615*r**8+25745*r**10
            +2747*r**12-1801*r**14+5437*r**16+3172*r**18)+6*Q2*(-1143-1359*r**2
            -3003*r**4-5396*r**6-304*r**8+3532*r**10+7466*r**12+720*r**14-1717*r**16
            +711*r**18+493*r**20))*sqrtq2)+logq2**4*(10368000*r**18*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-1120*Q2**11+40*Q2**10*(343+463*r**2)
            -20*Q2**9*(3579+9401*r**2+5598*r**4)+16*Q2**8*(12476+47750*r**2+57837*r**4
            +21419*r**6)-4*Q2**7*(78047+391017*r**2+709339*r**4+544057*r**6+135368*r**8)
            +Q2**6*(266133+1567540*r**2+3800814*r**4+4400212*r**6+2291461*r**8+272832*r**10)
            +2*Q2**5*(-74123-361111*r**2-1140282*r**4-1039682*r**6-480911*r**8-6795*r**10
            +220528*r**12)+Q2**4*(127225+661490*r**2+3762451*r**4+1950140*r**6-5468913*r**8
            -5369086*r**10-2200635*r**12-756560*r**14)+12*Q2**3*(-5208-81095*r**2
            -509668*r**4-1039559*r**6-339684*r**8+699975*r**10+506372*r**12+145619*r**14
            +23848*r**16)+3*Q2**2*(-32539+42016*r**2-140156*r**4+3159048*r**6+5155610*r**8
            +1061288*r**10-877892*r**12-176040*r**14-97119*r**16+70584*r**18)-18*Q2*(
            -6999-34505*r**2-390024*r**4-140416*r**6+448558*r**8+65590*r**10-250860*r**12
            +118784*r**14+169481*r**16+8467*r**18+11924*r**20)+9*(-4381-34582*r**2
            -417725*r**4-330832*r**6-95334*r**8+393676*r**10+520586*r**12-228240*r**14
            +14467*r**16+171594*r**18+4915*r**20+5856*r**22))-10368000*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1120*Q2**11-40*Q2**10*(343+463*r**2)
            +20*Q2**9*(3579+9401*r**2+5598*r**4)-16*Q2**8*(12476+47750*r**2+57837*r**4
            +21419*r**6)+4*Q2**7*(78047+391017*r**2+709339*r**4+544057*r**6+135368*r**8)
            -Q2**6*(266133+1567540*r**2+3800814*r**4+4400212*r**6+2291461*r**8+272832*r**10)
            +Q2**5*(148246+722222*r**2+2280564*r**4+2079364*r**6+961822*r**8+13590*r**10
            -441056*r**12)+Q2**4*(-127225-661490*r**2-3762451*r**4-1950140*r**6
            +5468913*r**8+5369086*r**10+2200635*r**12+756560*r**14)-12*Q2**3*(-5208
            -81095*r**2-509668*r**4-1039559*r**6-339684*r**8+699975*r**10+506372*r**12
            +145619*r**14+23848*r**16)-3*Q2**2*(-32539+42016*r**2-140156*r**4+3159048*r**6
            +5155610*r**8+1061288*r**10-877892*r**12-176040*r**14-97119*r**16+70584*r**18)
            +18*Q2*(-6999-34505*r**2-390024*r**4-140416*r**6+448558*r**8+65590*r**10
            -250860*r**12+118784*r**14+169481*r**16+8467*r**18+11924*r**20)-9*(
            -4381-34582*r**2-417725*r**4-330832*r**6-95334*r**8+393676*r**10+520586*r**12
            -228240*r**14+14467*r**16+171594*r**18+4915*r**20+5856*r**22))*sqrtq2)
            +logq2**3*(691200*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-6040*Q2**14
            +40*Q2**13*(1594+1717*r**2)-6*Q2**12*(47066+105627*r**2+56105*r**4)
            +4*Q2**11*(166353+615914*r**2+672236*r**4+218475*r**6)-4*Q2**10*(213954
            +1233470*r**2+2160818*r**4+1486603*r**6+277725*r**8)+30*Q2**9*(17658
            +159933*r**2+373524*r**4+406142*r**6+203128*r**8+2091*r**10)+10*Q2**8*(
            -8730-81919*r**2+406781*r**4+1318228*r**6+729770*r**8+127157*r**10
            +179709*r**12)-Q2**7*(14103+2215166*r**2+30766055*r**4+93813080*r**6
            +108457305*r**8+49318958*r**10+10896361*r**12+2134140*r**14)+3*Q2**6*(43947
            +359211*r**2+11650609*r**4+48168485*r**6+84376685*r**8+63097297*r**10
            +18606971*r**12+3683359*r**14+75900*r**16)+Q2**5*(-417443-154480*r**2
            -14503246*r**4-79196236*r**6-205266820*r**8-222991528*r**10-86498170*r**12
            +10443884*r**14-1054561*r**16+1426600*r**18)-5*Q2**4*(-69205-403917*r**2
            -1535816*r**4-7263066*r**6-22070188*r**8-7836032*r**10+16436874*r**12
            +21608978*r**14+13610857*r**16+1284133*r**18+216038*r**20)+15*Q2**3*(2201
            -157626*r**2-654129*r**4-4963312*r**6-16774294*r**8-16901308*r**10+5812862*r**12
            +15167456*r**14+9309725*r**16+2630070*r**18+306323*r**20+1232*r**22)
            +3*Q2**2*(-59967+26301*r**2-1108055*r**4+9244205*r**6+37514770*r**8
            +138715514*r**10+94138698*r**12-4616870*r**14-16613515*r**16-16724055*r**18
            +4344493*r**20-24359*r**22+106840*r**24)-9*Q2*(-9483-110254*r**2-1226156*r**4
            -4956660*r**6-27575015*r**8+5724286*r**10+23727088*r**12-9829088*r**14
            +1175335*r**16+11255590*r**18-469828*r**20+2159316*r**22+118219*r**24
            +16650*r**26)+9*(-1349-41985*r**2-471498*r**4-2888708*r**6-19012105*r**8
            +4372743*r**10+20073990*r**12-3066584*r**14-7941439*r**16+2125205*r**18
            +6265906*r**20-12580*r**22+559757*r**24+36197*r**26+2450*r**28))+691200*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(6040*Q2**15-40*Q2**14*(1745+1868*r**2)
            +Q2**13*(346156+766202*r**2+405310*r**4)-2*Q2**12*(473904+1689907*r**2
            +1829668*r**4+605265*r**6)+4*Q2**11*(380307+2015737*r**2+3448968*r**4
            +2377314*r**6+496200*r**8)-2*Q2**10*(692778+5293843*r**2+12391436*r**4
            +13386972*r**6+6575576*r**8+586815*r**10)-20*Q2**9*(-30852-307346*r**2
            -596795*r**4-510385*r**6-549020*r**8-244250*r**10+86718*r**12)+Q2**8*(
            -73197+1308676*r**2+34014675*r**4+111063170*r**6+128937285*r**8+57888228*r**10
            +13965021*r**12+3931230*r**14)-2*Q2**7*(72972+1653451*r**2+33966524*r**4
            +134542295*r**6+227700220*r**8+173534077*r**10+58018116*r**12+12040289*r**14
            +1180920*r**16)+2*Q2**6*(274642+681977*r**2+25266353*r**4+129326759*r**6
            +301451165*r**8+332706737*r**10+165805487*r**12+28213553*r**14+6166169*r**16
            -599450*r**18)+2*Q2**5*(-381734-1295754*r**2-11168403*r**4-65007406*r**6
            -197406998*r**8-233719254*r**10-113652664*r**12+15995302*r**14+38721804*r**16
            +3396352*r**18+1253395*r**20)-10*Q2**4*(-31301-473000*r**2-1951060*r**4
            -11844409*r**6-39828068*r**8-40305072*r**10+13019714*r**12+41774110*r**14
            +31574505*r**16+11392600*r**18+1209570*r**20+109867*r**22)-6*Q2**3*(
            -35486+401713*r**2+1475360*r**4+18665705*r**6+73101400*r**8+153546762*r**10
            +74790464*r**12-54759230*r**14-69499710*r**16-38211515*r**18-5168736*r**20
            -781067*r**22+50340*r**24)+6*Q2**2*(-44208-182214*r**2-2380111*r**4
            -3366915*r**6-17983035*r**8+96701571*r**10+152017738*r**12+30017282*r**14
            -8852190*r**16+214600*r**18-6894523*r**20+5399041*r**22+218569*r**24
            +78395*r**26)-18*Q2*(-5416-80861*r**2-903954*r**4-4535762*r**6-25771890*r**8
            -8738993*r**10+24762682*r**12+5415708*r**14-8297596*r**16+7278065*r**18
            +8525834*r**20+838454*r**22+1418646*r**24+85533*r**26+9550*r**28)+9*(
            -1349-43334*r**2-513483*r**4-3360206*r**6-21900813*r**8-14639362*r**10
            +24446733*r**12+17007406*r**14-11008023*r**16-5816234*r**18+8391111*r**20
            +6253326*r**22+547177*r**24+595954*r**26+38647*r**28+2450*r**30))*sqrtq2)
            +logq2**2*(-2880*r**10*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17
            -8*Q2**16*(135817+150101*r**2)+8*Q2**15*(609837+1424108*r**2+709791*r**4)
            -8*Q2**14*(1497790+5665821*r**2+6164498*r**4+1670155*r**6)+8*Q2**13*(2052205
            +11807174*r**2+19627106*r**4+13279952*r**6+1570775*r**8)+Q2**12*(-9276675
            -97625268*r**2-162375498*r**4-170092020*r**6-87823939*r**8+10951320*r**10)
            -4*Q2**11*(1841403-2378739*r**2+72594868*r**4+176570458*r**6+97819623*r**8
            +24693229*r**10+9892734*r**12)+2*Q2**10*(9261111+50180850*r**2+514798421*r**4
            +1698206280*r**6+1881190105*r**8+716700482*r**10+157336027*r**12+14469828*r**14)
            +4*Q2**9*(-3352365-32232891*r**2-271078323*r**4-1352556375*r**6-2375510525*r**8
            -1673827605*r**10-350439261*r**12-63361633*r**14+4846770*r**16)+Q2**8*(
            -2729705+88671816*r**2+290389124*r**4+2654978408*r**6+6371797290*r**8
            +7327078400*r**10+3114119876*r**12-691377336*r**14-92962057*r**16-42913400*r**18)
            +8*Q2**7*(1747270-4971133*r**2+15127487*r**4+266907120*r**6+1492747966*r**8
            +2719556390*r**10+1861043472*r**12+853863832*r**14+317972780*r**16+40114391*r**18
            +1878665*r**20)+4*Q2**6*(-2456967-4677472*r**2+23073081*r**4-603032454*r**6
            -5851481694*r**8-16113018636*r**10-17957269110*r**12-8332675944*r**14
            -2848468779*r**16-372895044*r**18-46067315*r**20+4119774*r**22)-8*Q2**5*(229304
            -8600451*r**2-13472499*r**4-7450835*r**6-1468763325*r**8-6396000186*r**10
            -11704337214*r**12-7844229138*r**14-1198700610*r**16-511036475*r**18
            +106568217*r**20+8467725*r**22+1935887*r**24)+Q2**4*(6068155-55416868*r**2
            -529648674*r**4-565030660*r**6-2269446875*r**8-12054143520*r**10-35736518844*r**12
            -25962685992*r**14+17453038725*r**16+29611067900*r**18+4735543390*r**20
            +1370532012*r**22+129316891*r**24+1225160*r**26)+12*Q2**3*(-174505+109941*r**2
            +26994944*r**4+148392198*r**6+449400505*r**8+2459787075*r**10+4694349898*r**12
            +1521190932*r**14-2935005991*r**16-4346643205*r**18-2161639620*r**20
            -407821914*r**22-28949801*r**24-3480307*r**26+289850*r**28)-6*Q2**2*(189515
            -3931222*r**2-17811067*r**4+102589440*r**6+16192019*r**8+4091115470*r**10
            +11119907829*r**12+14975348124*r**14+4310241465*r**16-1116035738*r**18
            -4526104505*r**20+502957768*r**22-109686807*r**24+45159970*r**26+2918719*r**28
            +229020*r**30)+36*Q2*(26931-379535*r**2-4452807*r**4-14409807*r**6
            -176564787*r**8-451164495*r**10-1711459887*r**12+1089967489*r**14+475970739*r**16
            +27232299*r**18+820620947*r**20-372775221*r**22+286607943*r**24+25195443*r**26
            +5163363*r**28+420867*r**30+518*r**32)+9*(-21679+281592*r**2+4639432*r**4
            +30912240*r**6+319818060*r**8+1430620872*r**10+5770391864*r**12-8304862496*r**14
            -4018542330*r**16+8182983880*r**18-268700232*r**20-3464268304*r**22+686961996*r**24
            -329849160*r**26-36352440*r**28-3686336*r**30-332527*r**32+5568*r**34))
            -2880*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17-8*Q2**16*(135817
            +150101*r**2)+8*Q2**15*(609837+1424108*r**2+709791*r**4)-8*Q2**14*(1497790
            +5665821*r**2+6164498*r**4+1670155*r**6)+8*Q2**13*(2052205+11807174*r**2
            +19627106*r**4+13279952*r**6+1570775*r**8)+Q2**12*(-9276675-97625268*r**2
            -162375498*r**4-170092020*r**6-87823939*r**8+10951320*r**10)-4*Q2**11*(1841403
            -2378739*r**2+72594868*r**4+176570458*r**6+97819623*r**8+24693229*r**10
            +9892734*r**12)+2*Q2**10*(9261111+50180850*r**2+514798421*r**4+1698206280*r**6
            +1881190105*r**8+716700482*r**10+157336027*r**12+14469828*r**14)+4*Q2**9*(
            -3352365-32232891*r**2-271078323*r**4-1352556375*r**6-2375510525*r**8
            -1673827605*r**10-350439261*r**12-63361633*r**14+4846770*r**16)+Q2**8*(
            -2729705+88671816*r**2+290389124*r**4+2654978408*r**6+6371797290*r**8
            +7327078400*r**10+3114119876*r**12-691377336*r**14-92962057*r**16-42913400*r**18)
            +8*Q2**7*(1747270-4971133*r**2+15127487*r**4+266907120*r**6+1492747966*r**8
            +2719556390*r**10+1861043472*r**12+853863832*r**14+317972780*r**16+40114391*r**18
            +1878665*r**20)+4*Q2**6*(-2456967-4677472*r**2+23073081*r**4-603032454*r**6
            -5851481694*r**8-16113018636*r**10-17957269110*r**12-8332675944*r**14
            -2848468779*r**16-372895044*r**18-46067315*r**20+4119774*r**22)-8*Q2**5*(229304
            -8600451*r**2-13472499*r**4-7450835*r**6-1468763325*r**8-6396000186*r**10
            -11704337214*r**12-7844229138*r**14-1198700610*r**16-511036475*r**18
            +106568217*r**20+8467725*r**22+1935887*r**24)+Q2**4*(6068155-55416868*r**2
            -529648674*r**4-565030660*r**6-2269446875*r**8-12054143520*r**10-35736518844*r**12
            -25962685992*r**14+17453038725*r**16+29611067900*r**18+4735543390*r**20
            +1370532012*r**22+129316891*r**24+1225160*r**26)+12*Q2**3*(-174505+109941*r**2
            +26994944*r**4+148392198*r**6+449400505*r**8+2459787075*r**10+4694349898*r**12
            +1521190932*r**14-2935005991*r**16-4346643205*r**18-2161639620*r**20
            -407821914*r**22-28949801*r**24-3480307*r**26+289850*r**28)-6*Q2**2*(189515
            -3931222*r**2-17811067*r**4+102589440*r**6+16192019*r**8+4091115470*r**10
            +11119907829*r**12+14975348124*r**14+4310241465*r**16-1116035738*r**18
            -4526104505*r**20+502957768*r**22-109686807*r**24+45159970*r**26+2918719*r**28
            +229020*r**30)+36*Q2*(26931-379535*r**2-4452807*r**4-14409807*r**6
            -176564787*r**8-451164495*r**10-1711459887*r**12+1089967489*r**14+475970739*r**16
            +27232299*r**18+820620947*r**20-372775221*r**22+286607943*r**24+25195443*r**26
            +5163363*r**28+420867*r**30+518*r**32)+9*(-21679+281592*r**2+4639432*r**4
            +30912240*r**6+319818060*r**8+1430620872*r**10+5770391864*r**12-8304862496*r**14
            -4018542330*r**16+8182983880*r**18-268700232*r**20-3464268304*r**22+686961996*r**24
            -329849160*r**26-36352440*r**28-3686336*r**30-332527*r**32+5568*r**34))*sqrtq2)
            +logq2*(-96*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(54928*Q2**20-10*Q2**19*(80571
            +66179*r**2)+10*Q2**18*(454635+932826*r**2+315743*r**4)-10*Q2**17*(1276291
            +4810467*r**2+4156451*r**4+713027*r**6)+10*Q2**16*(1673240+11757431*r**2
            +16884235*r**4+8279349*r**6+491705*r**8)+2*Q2**15*(291279-59156055*r**2
            -97945590*r**4-57271710*r**6-13876615*r**8+5923559*r**10)-10*Q2**14*(3179247
            +6569403*r**2+44188566*r**4+120967604*r**6+75147541*r**8+19669647*r**10
            +2857988*r**12)+5*Q2**13*(6433205+60642984*r**2+332390965*r**4+1097862886*r**6
            +1214635191*r**8+416413088*r**10+71427359*r**12+2563602*r**14)+5*Q2**12*(2841111
            -57953133*r**2-397686891*r**4-1861102247*r**6-3137405283*r**8-2048826147*r**10
            -287234445*r**12-19839849*r**14+5847972*r**16)-10*Q2**11*(4707430-926967*r**2
            -54829074*r**4-505111764*r**6-907956088*r**8-915369848*r**10-228097682*r**12
            +224264136*r**14+38356662*r**16+4072315*r**18)+4*Q2**10*(4510077+57863495*r**2
            +319685970*r**4+1470662320*r**6+7814017520*r**8+15640213853*r**10+10006163165*r**12
            +4434888910*r**14+1170745425*r**16+110393910*r**18+307307*r**20)+5*Q2**9*(5179239
            -46755564*r**2-368681911*r**4-2195790494*r**6-12439153626*r**8-38209590004*r**10
            -42558233486*r**12-16668936056*r**14-5253633789*r**16-332977536*r**18
            +1654389*r**20+6524726*r**22)-5*Q2**8*(4790695-9929301*r**2-197781337*r**4
            -1286268433*r**6-6195004898*r**8-34209666554*r**10-64772250554*r**12
            -44191072906*r**14-4893941093*r**16-1309794993*r**18+635093811*r**20
            +64911899*r**22+3840512*r**24)-10*Q2**7*(418313-13654759*r**2-41127194*r**4
            +269462462*r**6-1165420083*r**8-4237010291*r**10-10083900548*r**12-7245547460*r**14
            -8905623285*r**16-9160838453*r**18-1980677810*r**20-352827146*r**22-18460977*r**24
            +878591*r**26)+10*Q2**6*(1260165-14437827*r**2-105316878*r**4+264511880*r**6
            -381884731*r**8-13983361421*r**10-69660249688*r**12-119098406816*r**14
            -79333297209*r**16-39759741061*r**18-9544382366*r**20-2109246552*r**22
            -23532033*r**24+5803877*r**26+1259540*r**28)+Q2**5*(-2662377+10974120*r**2
            +484828155*r**4+1307981450*r**6-5161804645*r**8+33108765192*r**10+526380826495*r**12
            +1549238069610*r**14+1691496856965*r**16+536428413960*r**18+280893888657*r**20
            -12171448290*r**22+2098864585*r**24-1617715640*r**26-97736715*r**28-1429522*r**30)
            -5*Q2**4*(616103-12728853*r**2-43586543*r**4+1216863773*r**6+2902206467*r**8
            -2592019133*r**10+9559984153*r**12+70032535581*r**14+214049147049*r**16
            +74508298201*r**18-130117787973*r**20-16769631217*r**22-12492555863*r**24
            -1835799047*r**26-184875493*r**28-4948297*r**30+677892*r**32)+30*Q2**3*(49245
            -1005552*r**2-8390298*r**4+119452576*r**6+558599956*r**8+1463384198*r**10
            +4420500082*r**12+16969717740*r**14+13720059258*r**16+1342738458*r**18
            -21945512406*r**20-26796182328*r**22-7139162596*r**24-723747334*r**26
            -178221314*r**28+1417388*r**30+417273*r**32+45654*r**34)+30*Q2**2*(8287
            -277846*r**2+897755*r**4+45300500*r**6-28432468*r**8-1149771430*r**10
            -2275208286*r**12-30409099688*r**14-44294454506*r**16-25153597574*r**18
            -6278370596*r**20+21798649780*r**22-2492912204*r**24+2461427062*r**26
            -384866858*r**28-11605536*r**30-7241173*r**32-294388*r**34+9169*r**36)
            -45*Q2*(6425-211762*r**2-781057*r**4+43411204*r**6+82312436*r**8+322380516*r**10
            +4640825532*r**12+4639058012*r**14+19868199534*r**16-9857533632*r**18
            -6747069582*r**20-23382970028*r**22+18100809572*r**24-6819671780*r**26
            -669629844*r**28-191633484*r**30-25702367*r**32-1765902*r**34-39833*r**36
            +6040*r**38)+9*(5787-220735*r**2-1105095*r**4+57261285*r**6+101088130*r**8
            +1458374292*r**10+12154764580*r**12+29670853060*r**14+98584777970*r**16
            -304538439490*r**18+133768147902*r**20+164166435670*r**22-161489742960*r**24
            +35126704580*r**26-6861747660*r**28-2010898828*r**30-153685765*r**32
            -31511255*r**34-1056335*r**36-10355*r**38+5222*r**40))+96*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(54928*Q2**21-2*Q2**20*(430319+358359*r**2)
            +20*Q2**19*(267603+539788*r**2+190961*r**4)-20*Q2**18*(865463+3098964*r**2
            +2702510*r**4+514385*r**6)+10*Q2**17*(2949531+17844189*r**2+25851153*r**4
            +13148827*r**6+1204732*r**8)+2*Q2**16*(-8074921-126309410*r**2-241153920*r**4
            -183089630*r**6-57731885*r**8+3465034*r**10)-2*Q2**15*(16187514-26017761*r**2
            +63841185*r**4+449620720*r**6+304589380*r**8+90395179*r**10+20213499*r**12)
            +5*Q2**14*(12791699+80140284*r**2+433906903*r**4+1428175226*r**6+1606865481*r**8
            +606047464*r**10+116482629*r**12+8279578*r**14)+10*Q2**13*(-1796047-62514661*r**2
            -395360420*r**4-1645678049*r**6-2724951680*r**8-1839937213*r**10-387537446*r**12
            -46915405*r**14+1642185*r**16)-5*Q2**12*(12255971-56965956*r**2-565298172*r**4
            -3269012666*r**6-6814419706*r**8-7016971126*r**10-2792255956*r**12+141453978*r**14
            +62721447*r**16+13992602*r**18)+2*Q2**11*(32557304+134629305*r**2+360591735*r**4
            +141620450*r**6+8562695780*r**8+22163798026*r**10+14294988680*r**12+8850610090*r**14
            +3654594840*r**16+432932705*r**18+20976189*r**20)+Q2**10*(7855887-483272108*r**2
            -3353607415*r**4-18140345630*r**6-99334487490*r**8-284864875512*r**10
            -315376675502*r**12-141108888580*r**14-48690706285*r**16-6789445020*r**18
            -434532923*r**20+31394402*r**22)-10*Q2**9*(4984967-25752813*r**2-306609406*r**4
            -1925370419*r**6-10414974509*r**8-42429205092*r**10-72770037022*r**12
            -51709121224*r**14-13408255469*r**16-3448203159*r**18+151885332*r**20
            +36545507*r**22+5182619*r**24)+5*Q2**8*(3954069+22170912*r**2-125456250*r**4
            -2022974694*r**6-5150433165*r**8-31930650870*r**10-78814116012*r**12
            -94472228540*r**14-31273767429*r**16+12117940820*r**18+3286654438*r**20
            +1405660002*r**22+105674365*r**24+2083330*r**26)+10*Q2**7*(1678478-27674273*r**2
            -160098831*r**4+492847148*r**6-1277842352*r**8-19385791795*r**10-83981160527*r**12
            -136427854824*r**14-95484467954*r**16-57826202799*r**18-20685898629*r**20
            -4442751508*r**22-394820156*r**24-11778509*r**26+2138131*r**28)+Q2**6*(
            -15264027+142750740*r**2+1682375205*r**4-283968570*r**6-3988076135*r**8
            +176761226712*r**10+1362816937585*r**12+3436824634650*r**14+3675813897215*r**16
            +1727358796660*r**18+773935122927*r**20+104364840890*r**22+23426650435*r**24
            -1440434080*r**26-168370885*r**28-14024922*r**30)-2*Q2**5*(209069-27666261*r**2
            +138934780*r**4+3938564235*r**6+5328604570*r**8+7493432441*r**10+303644756226*r**12
            +1212890787005*r**14+2155490330910*r**16+1300233380965*r**18+83366681376*r**20
            +92437142141*r**22-36267681510*r**24-4348923145*r**26-1319914910*r**28
            -61953861*r**30+979969*r**32)+5*Q2**4*(911573-18146062*r**2-106657184*r**4
            +1889992686*r**6+7470669976*r**8+9090492522*r**10+33490965512*r**12+181410826174*r**14
            +366402038178*r**16+296613875998*r**18-187282564208*r**20-307664513158*r**22
            -72097162656*r**24-18670838914*r**26-3090002424*r**28-181319462*r**30
            -1766767*r**32+951816*r**34)-30*Q2**3*(40958-678461*r**2-10293605*r**4
            +65761778*r**6+706485000*r**8+3171755584*r**10+8159092566*r**12+51799317510*r**14
            +74984231504*r**16+40216395290*r**18-14324403352*r**20-70540344514*r**22
            -31442432720*r**24-10324336992*r**26-517101790*r**28-165198390*r**30
            +9075834*r**32+757315*r**34+36485*r**36)-15*Q2**2*(35849-1174404*r**2
            -1103353*r**4+222630122*r**6+280673372*r**8-1389266248*r**10+7072517164*r**12
            -51451441912*r**14-89802509786*r**16-168468705056*r**18-83105145086*r**20
            -39108351716*r**22+92913903868*r**24-20521985624*r**26+2144230876*r**28
            -1367845240*r**30-114800519*r**32-20368828*r**34-689937*r**36+36458*r**38)
            +18*Q2*(18956-623710*r**2-3034595*r**4+135206010*r**6+364853165*r**8
            +1740919526*r**10+18485397410*r**12+38035135390*r**14+110560532850*r**16
            -127242554990*r**18+25372565916*r**20+6758118810*r**22-93950272620*r**24
            +45766196770*r**26-22154127890*r**28-3158607734*r**30-620182510*r**32
            -84426300*r**34-5042505*r**36-89660*r**38+17711*r**40)-9*(5787-214948*r**2
            -1325830*r**4+56156190*r**6+158349415*r**8+1559462422*r**10+13613138872*r**12
            +41825617640*r**14+128255631030*r**16-205953661520*r**18-170770291588*r**20
            +297934583572*r**22+2676692710*r**24-126363038380*r**26+28264956920*r**28
            -8872646488*r**30-2164584593*r**32-185197020*r**34-32567590*r**36-1066690*r**38
            -5133*r**40+5222*r**42))*sqrtq2)))/(-105000*(-Q2+(-1+r)**2)*r**2*(1-Q2
            +r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))-105000*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2+logq2**6*(4702924800000*r**26*(1+r**2)*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -4702924800000*r**26*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**3*(3628800000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))+3628800000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))*sqrtq2)+logq2*(12600000*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)
            -Q2**2*(5+2*r**2+5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))+12600000*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)-Q2**2*(5+2*r**2
            +5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))*sqrtq2)+logq2**2*(-75600000*(
            -Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(16*Q2**4+Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1
            +9*r**2+9*r**4+r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))-75600000*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(16*Q2**4
            +Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1+9*r**2+9*r**4
            +r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))*sqrtq2)+logq2**4*(-10886400000*(
            -Q2+(-1+r)**2)*r**18*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))
            -10886400000*(-Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))*sqrtq2)
            +logq2**5*(52254720000*(-Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2
            +41*r**4)-18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4
            -82*r**6+13*r**8))+52254720000*(-Q2+(-1+r)**2)*r**22*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2+41*r**4)
            -18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4-82*r**6
            +13*r**8))*sqrtq2))+(-16*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(38180*Q2**23
            -40*Q2**22*(577+1305*r**2)+8*Q2**21*(-507497+963480*r**2+420258*r**4)
            -Q2**20*(-36070819+124246079*r**2+776598359*r**4+53785765*r**6)+2*Q2**19*(
            -78611305+439436508*r**2+5529821562*r**4+4505083148*r**6+164445411*r**8)
            -2*Q2**18*(-208612445+1748355429*r**2+33002907066*r**4+57685942798*r**6
            +22682599635*r**8+534373149*r**10)+2*Q2**17*(-353045125+4229064874*r**2
            +105651445663*r**4+294031637388*r**6+254034272125*r**8+58654778866*r**10
            +974479641*r**12)-Q2**16*(-724654519+12166638711*r**2+373559956689*r**4
            +1498387746839*r**6+1947225375183*r**8+1070493379233*r**10+128356528583*r**12
            +1572135489*r**14)-8*Q2**15*(42793162-1029236652*r**2-34218644487*r**4
            -225139263683*r**6-299114749998*r**8-210133223454*r**10-76543616339*r**12
            +13180494633*r**14+123291186*r**16)+8*Q2**14*(-4575615+229450339*r**2
            +28717399231*r**4-5730741244*r**6+412561739737*r**8+1137273000436*r**10
            +733573098167*r**12+255997001506*r**14+63990508864*r**16+433401523*r**18)
            -8*Q2**13*(14671575+499922502*r**2+82736285508*r**4+346585089827*r**6
            +1605878816643*r**8+4568561959839*r**10+5110386121889*r**12+2131378177989*r**14
            +601291581054*r**16+67460984595*r**18+242513667*r**20)+2*Q2**12*(309593115
            -4669413567*r**2+187459805361*r**4+1858155350239*r**6+6504585978102*r**8
            +21787616178666*r**10+33885759236482*r**12+26277114944454*r**14+5712658416471*r**16
            +1547973948045*r**18-81027214203*r**20-1509475773*r**22)+4*Q2**11*(-177619819
            +5380150932*r**2+92934796752*r**4-622712064478*r**6-743261653025*r**8
            -103336436408*r**10+7278914413296*r**12+6031496911468*r**14+2734233121387*r**16
            +4261512269028*r**18+715379588400*r**20+224988326706*r**22+1339704977*r**24)
            -4*Q2**10*(-44431631+3199574391*r**2+152823683436*r**4-249670719626*r**6
            +148801569045*r**8+9267440400357*r**10+46789710759628*r**12+82187728732944*r**14
            +51829294053423*r**16+24570318017749*r**18+8218142710536*r**20+1551383944218*r**22
            +167862767371*r**24+467085999*r**26)-4*Q2**9*(-84327605+1882314618*r**2
            -30243834483*r**4-226756427654*r**6+838735035657*r**8-5474687760816*r**10
            -44655583670201*r**12-117272856100212*r**14-131465490829515*r**16-41260472214110*r**18
            -23119957188621*r**20-2018306422950*r**22-792453381833*r**24+69384887028*r**26
            +718678521*r**28)+2*Q2**8*(-160029845+7196247053*r**2+163630804787*r**4
            -1548805624815*r**6+419008248419*r**8-429430537771*r**10-31402348792197*r**12
            -123632017453399*r**14-178527484213807*r**16-126569608319241*r**18+84251527419113*r**20
            -1578053287261*r**22+12205977914145*r**24+775391467751*r**26+372079463465*r**28
            +1706317923*r**30)-4*Q2**7*(-1968215+1047797544*r**2+62783803518*r**4
            -675819011954*r**6-1398198022248*r**8-770440873500*r**10-10084641729206*r**12
            -46819031021430*r**14-38241494099970*r**16-7740420717728*r**18+26951015054898*r**20
            +79544597376450*r**22+14161561547896*r**24+5315051691348*r**26+695704006470*r**28
            +85632667366*r**30+162513801*r**32)-8*Q2**6*(-18934378+700876476*r**2
            +2309341335*r**4-52415735752*r**6+800738186427*r**8+436141826754*r**10
            +3863746128125*r**12+29482184385750*r**14+46719101080089*r**16+19836259566428*r**18
            +25801922860185*r**20-37761526464924*r**22-4635517302115*r**24-6605966005302*r**26
            +478576519635*r**28-164413322866*r**30+22658740473*r**32+156372060*r**34)
            +8*Q2**5*(-11733742+675557162*r**2+12955896992*r**4-280991313305*r**6
            +509918840741*r**8+37819113755*r**10-5318912013819*r**12+7607136188543*r**14
            +9209742499745*r**16+56732937402799*r**18-34203197712715*r**20+97920033625469*r**22
            -77507490464457*r**24+30419938008473*r**26-3365274966025*r**28+1716081433117*r**30
            -5412965647*r**32+32429433587*r**34+125454127*r**36)-Q2**4*(-4237735
            +1016884131*r**2+43458934779*r**4-1253367339415*r**6+1646883646740*r**8
            +2236819170252*r**10-62875531840580*r**12-10403036427324*r**14-195702793320114*r**16
            +563011717660202*r**18+255370949543946*r**20-1152703677527778*r**22+1090528828389316*r**24
            -651091605332292*r**26+170847057599436*r**28-1785859218988*r**30+5527220859777*r**32
            +299136830379*r**34+78886905971*r**36+150723297*r**38)-2*Q2**3*(-10877735
            +520054116*r**2+1900240314*r**4-78054255296*r**6+618880122537*r**8-1644957658176*r**10
            +6637451636312*r**12-4592565656160*r**14+3738842319954*r**16-410143771394744*r**18
            +100710335785788*r**20-406675639602432*r**22+367977931987898*r**24-128301602778720*r**26
            +14643817185432*r**28+16355955288352*r**30-6935399210571*r**32+1051640309748*r**34
            -127776753638*r**36+15910099200*r**38+89989821*r**40)+3*(-1+r**2)**2*(
            -90287+7427553*r**2+93838650*r**4-7668569174*r**6+64322805333*r**8+19898055717*r**10
            -162908395400*r**12+8096461945560*r**14+2489220515682*r**16+46766433530146*r**18
            -48394879559364*r**20-159444850050948*r**22+311477258788530*r**24-218528450672142*r**26
            +75144437187384*r**28-16174701481000*r**30+1743878650509*r**32-197094818115*r**34
            +35846364634*r**36-1408193238*r**38+366010809*r**40+1029161*r**42)+2*Q2**2*(
            -6004755+383561131*r**2+4086955762*r**4-216452089910*r**6+1186153643077*r**8
            -1124357191457*r**10-6850523858000*r**12+42478262001776*r**14-20787738961918*r**16
            +186657443415566*r**18+84062225395588*r**20-224648358615884*r**22+388245892329562*r**24
            -764924304471634*r**26+558805022407712*r**28-216600313147360*r**30+44935392129169*r**32
            -6642673595225*r**34+1315207403962*r**36-70450089230*r**38+15996496609*r**40
            +59485459*r**42)-6*Q2*(-475889+35517154*r**2+401835263*r**4-28816015560*r**6
            +213224288721*r**8-206861382762*r**10-1103475852599*r**12+16132264536688*r**14
            -11491479109130*r**16+117911708936612*r**18-195301833758410*r**20+142662426199648*r**22
            -305069959364702*r**24+549524445930940*r**26-457141135267662*r**28+192373933924112*r**30
            -48786061104565*r**32+6902085726938*r**34-884851321125*r**36+152530153704*r**38
            -7676730051*r**40+1616854862*r**42+5117813*r**44))-16*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**2*(38180*Q2**23-40*Q2**22*(577+1305*r**2)+8*Q2**21*(-507497+963480*r**2
            +420258*r**4)-Q2**20*(-36070819+124246079*r**2+776598359*r**4+53785765*r**6)
            +2*Q2**19*(-78611305+439436508*r**2+5529821562*r**4+4505083148*r**6+164445411*r**8)
            -2*Q2**18*(-208612445+1748355429*r**2+33002907066*r**4+57685942798*r**6
            +22682599635*r**8+534373149*r**10)+2*Q2**17*(-353045125+4229064874*r**2
            +105651445663*r**4+294031637388*r**6+254034272125*r**8+58654778866*r**10
            +974479641*r**12)-Q2**16*(-724654519+12166638711*r**2+373559956689*r**4
            +1498387746839*r**6+1947225375183*r**8+1070493379233*r**10+128356528583*r**12
            +1572135489*r**14)-8*Q2**15*(42793162-1029236652*r**2-34218644487*r**4
            -225139263683*r**6-299114749998*r**8-210133223454*r**10-76543616339*r**12
            +13180494633*r**14+123291186*r**16)+8*Q2**14*(-4575615+229450339*r**2
            +28717399231*r**4-5730741244*r**6+412561739737*r**8+1137273000436*r**10
            +733573098167*r**12+255997001506*r**14+63990508864*r**16+433401523*r**18)
            -8*Q2**13*(14671575+499922502*r**2+82736285508*r**4+346585089827*r**6
            +1605878816643*r**8+4568561959839*r**10+5110386121889*r**12+2131378177989*r**14
            +601291581054*r**16+67460984595*r**18+242513667*r**20)+2*Q2**12*(309593115
            -4669413567*r**2+187459805361*r**4+1858155350239*r**6+6504585978102*r**8
            +21787616178666*r**10+33885759236482*r**12+26277114944454*r**14+5712658416471*r**16
            +1547973948045*r**18-81027214203*r**20-1509475773*r**22)+4*Q2**11*(-177619819
            +5380150932*r**2+92934796752*r**4-622712064478*r**6-743261653025*r**8
            -103336436408*r**10+7278914413296*r**12+6031496911468*r**14+2734233121387*r**16
            +4261512269028*r**18+715379588400*r**20+224988326706*r**22+1339704977*r**24)
            -4*Q2**10*(-44431631+3199574391*r**2+152823683436*r**4-249670719626*r**6
            +148801569045*r**8+9267440400357*r**10+46789710759628*r**12+82187728732944*r**14
            +51829294053423*r**16+24570318017749*r**18+8218142710536*r**20+1551383944218*r**22
            +167862767371*r**24+467085999*r**26)-4*Q2**9*(-84327605+1882314618*r**2
            -30243834483*r**4-226756427654*r**6+838735035657*r**8-5474687760816*r**10
            -44655583670201*r**12-117272856100212*r**14-131465490829515*r**16-41260472214110*r**18
            -23119957188621*r**20-2018306422950*r**22-792453381833*r**24+69384887028*r**26
            +718678521*r**28)+2*Q2**8*(-160029845+7196247053*r**2+163630804787*r**4
            -1548805624815*r**6+419008248419*r**8-429430537771*r**10-31402348792197*r**12
            -123632017453399*r**14-178527484213807*r**16-126569608319241*r**18+84251527419113*r**20
            -1578053287261*r**22+12205977914145*r**24+775391467751*r**26+372079463465*r**28
            +1706317923*r**30)-4*Q2**7*(-1968215+1047797544*r**2+62783803518*r**4
            -675819011954*r**6-1398198022248*r**8-770440873500*r**10-10084641729206*r**12
            -46819031021430*r**14-38241494099970*r**16-7740420717728*r**18+26951015054898*r**20
            +79544597376450*r**22+14161561547896*r**24+5315051691348*r**26+695704006470*r**28
            +85632667366*r**30+162513801*r**32)-8*Q2**6*(-18934378+700876476*r**2
            +2309341335*r**4-52415735752*r**6+800738186427*r**8+436141826754*r**10
            +3863746128125*r**12+29482184385750*r**14+46719101080089*r**16+19836259566428*r**18
            +25801922860185*r**20-37761526464924*r**22-4635517302115*r**24-6605966005302*r**26
            +478576519635*r**28-164413322866*r**30+22658740473*r**32+156372060*r**34)
            +8*Q2**5*(-11733742+675557162*r**2+12955896992*r**4-280991313305*r**6
            +509918840741*r**8+37819113755*r**10-5318912013819*r**12+7607136188543*r**14
            +9209742499745*r**16+56732937402799*r**18-34203197712715*r**20+97920033625469*r**22
            -77507490464457*r**24+30419938008473*r**26-3365274966025*r**28+1716081433117*r**30
            -5412965647*r**32+32429433587*r**34+125454127*r**36)-Q2**4*(-4237735
            +1016884131*r**2+43458934779*r**4-1253367339415*r**6+1646883646740*r**8
            +2236819170252*r**10-62875531840580*r**12-10403036427324*r**14-195702793320114*r**16
            +563011717660202*r**18+255370949543946*r**20-1152703677527778*r**22+1090528828389316*r**24
            -651091605332292*r**26+170847057599436*r**28-1785859218988*r**30+5527220859777*r**32
            +299136830379*r**34+78886905971*r**36+150723297*r**38)-2*Q2**3*(-10877735
            +520054116*r**2+1900240314*r**4-78054255296*r**6+618880122537*r**8-1644957658176*r**10
            +6637451636312*r**12-4592565656160*r**14+3738842319954*r**16-410143771394744*r**18
            +100710335785788*r**20-406675639602432*r**22+367977931987898*r**24-128301602778720*r**26
            +14643817185432*r**28+16355955288352*r**30-6935399210571*r**32+1051640309748*r**34
            -127776753638*r**36+15910099200*r**38+89989821*r**40)+3*(-1+r**2)**2*(
            -90287+7427553*r**2+93838650*r**4-7668569174*r**6+64322805333*r**8+19898055717*r**10
            -162908395400*r**12+8096461945560*r**14+2489220515682*r**16+46766433530146*r**18
            -48394879559364*r**20-159444850050948*r**22+311477258788530*r**24-218528450672142*r**26
            +75144437187384*r**28-16174701481000*r**30+1743878650509*r**32-197094818115*r**34
            +35846364634*r**36-1408193238*r**38+366010809*r**40+1029161*r**42)+2*Q2**2*(
            -6004755+383561131*r**2+4086955762*r**4-216452089910*r**6+1186153643077*r**8
            -1124357191457*r**10-6850523858000*r**12+42478262001776*r**14-20787738961918*r**16
            +186657443415566*r**18+84062225395588*r**20-224648358615884*r**22+388245892329562*r**24
            -764924304471634*r**26+558805022407712*r**28-216600313147360*r**30+44935392129169*r**32
            -6642673595225*r**34+1315207403962*r**36-70450089230*r**38+15996496609*r**40
            +59485459*r**42)-6*Q2*(-475889+35517154*r**2+401835263*r**4-28816015560*r**6
            +213224288721*r**8-206861382762*r**10-1103475852599*r**12+16132264536688*r**14
            -11491479109130*r**16+117911708936612*r**18-195301833758410*r**20+142662426199648*r**22
            -305069959364702*r**24+549524445930940*r**26-457141135267662*r**28+192373933924112*r**30
            -48786061104565*r**32+6902085726938*r**34-884851321125*r**36+152530153704*r**38
            -7676730051*r**40+1616854862*r**42+5117813*r**44))*sqrtq2+logq2**8*(-20316635136000000*r**36*(1
            +r**2)**2*(1-Q2+r**2)*(799+2229*r**2-3435*r**4+631*r**6)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3-20316635136000000*(Q2-(-1+r)**2)**2*r**36*(1
            +r**2)**2*(799+2229*r**2-3435*r**4+631*r**6)*(Q2-(1+r)**2)**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**7*(32248627200000*r**32*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-7910*Q2**9*(1+r**2)+10*Q2**8*(341
            +3592*r**2+3251*r**4)+20*Q2**7*(225+9146*r**2+10946*r**4+2025*r**6)
            -2*Q2**6*(-282261-243361*r**2+768701*r**4+806017*r**6+230104*r**8)+2*Q2**5*(
            -910581-2282967*r**2-1362960*r**4+1499948*r**6+2000451*r**8+509929*r**10)
            +Q2**4*(1251285+5874181*r**2+11523626*r**4+9327294*r**6-1831547*r**8
            -4422919*r**10-780360*r**12)-Q2**3*(-2720585-1218656*r**2+9787803*r**4
            +12136680*r**6+6379113*r**8+1080816*r**10-955531*r**12+491960*r**14)
            +6*(-1+r**2)**2*(-198493-319036*r**2-1248358*r**4-1063992*r**6+2253630*r**8
            +502048*r**10-420594*r**12+77268*r**14+41207*r**16)+Q2**2*(-5911535
            -7047329*r**2-3571811*r**4-3756717*r**6+11318631*r**8+945369*r**10-1213909*r**12
            +2017781*r**14+1386560*r**16)-3*Q2*(-1462421-1172118*r**2-4755778*r**4
            -11171730*r**6+3423116*r**8+12561686*r**10+904698*r**12-2051862*r**14
            +385105*r**16+328744*r**18))+32248627200000*r**32*(1+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(7910*Q2**10*(1+r**2)-20*Q2**9*(566+2587*r**2
            +2021*r**4)-10*Q2**8*(109+14359*r**2+15049*r**4+799*r**6)+2*Q2**7*(
            -280011-149651*r**2+969621*r**4+935727*r**6+250354*r**8)-14*Q2**6*(
            -170406-401227*r**2-119660*r**4+439238*r**6+433796*r**8+105719*r**10)
            +Q2**5*(-3072447-12261277*r**2-18815480*r**4-9053318*r**6+8832345*r**8
            +9443679*r**10+1800218*r**12)-10*Q2**4*(146930-590681*r**2-2718561*r**4
            -3298760*r**6-1387486*r**8+517365*r**10+615881*r**12+28840*r**14)-2*Q2**3*(
            -4316060-5493285*r**2+2498668*r**4+9083883*r**6+14917212*r**8+4202649*r**10
            -544312*r**12+777105*r**14+939260*r**16)+6*(-1+r**2)**2*(-198493-517529*r**2
            -1567394*r**4-2312350*r**6+1189638*r**8+2755678*r**10+81454*r**12-343326*r**14
            +118475*r**16+41207*r**18)+2*Q2**2*(-5149399-8237609*r**2-12443237*r**4
            -20421859*r**6+8915631*r**8+24974529*r**10+1222777*r**12-2675857*r**14
            +2279828*r**16+1186396*r**18)-3*Q2*(-1859407-2478639*r**2-7545454*r**4
            -13700132*r**6-1482102*r**8+5846394*r**10+15124264*r**12+1693844*r**14
            -2734603*r**16+703557*r**18+411158*r**20))*sqrtq2)+logq2**6*(179159040000*r**28*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(126560*Q2**13*(1+r**2)
            -60*Q2**12*(74509+156778*r**2+82269*r**4)+30*Q2**11*(969855+3285582*r**2
            +3724319*r**4+1408592*r**6)-4*Q2**10*(17661317+90184839*r**2+169512459*r**4
            +139695605*r**6+42398892*r**8)+60*Q2**9*(464437+6982924*r**2+24663079*r**4
            +36214100*r**6+24357370*r**8+6287862*r**10)-30*Q2**8*(-5888177-15168635*r**2
            +11742002*r**4+84651406*r**6+118106549*r**8+69926121*r**10+15448518*r**12)
            +5*Q2**7*(-59749051-284733630*r**2-528514293*r**4-306076080*r**6+329709167*r**8
            +582352962*r**10+294264809*r**12+44167380*r**14)+30*Q2**6*(1750938+27258427*r**2
            +119447174*r**4+166580151*r**6+44298094*r**8-68466463*r**10-51708006*r**12
            -3215667*r**14+5906040*r**16)-3*Q2**5*(-95557027-78071204*r**2+1320799006*r**4
            +3218926820*r**6+2051772408*r**8-1468826512*r**10-2418106294*r**12-757774124*r**14
            +163839955*r**16+108493068*r**18)+20*Q2**4*(-14881976-8142262*r**2+200535474*r**4
            +727887842*r**6+1181856163*r**8+805262670*r**10-155508115*r**12-462227462*r**14
            -152916483*r**16+9675940*r**18+8447249*r**20)-15*Q2**3*(-8029407-23030866*r**2
            -195886371*r**4+139772512*r**6+1368057146*r**8+1838992344*r**10+1086639058*r**12
            +232057892*r**14-94905243*r**16-28918310*r**18+3166737*r**20+168348*r**22)
            +18*(-1+r**2)**2*(-555841-16304149*r**2-143252319*r**4-263710559*r**6
            -293400220*r**8-25563054*r**10+435400826*r**12+193423670*r**14-92738561*r**16
            +11118275*r**18+35209125*r**20+2310953*r**22+7454*r**24)-30*Q2**2*(1392036
            +37791559*r**2+363190942*r**4+505273705*r**6+121833400*r**8-136418338*r**10
            -198108036*r**12-36230630*r**14-23143828*r**16-147053685*r**18-88230330*r**20
            -6096947*r**22+936152*r**24)+45*Q2*(664283+22082504*r**2+187972536*r**4
            +232319060*r**6+268138111*r**8+438748124*r**10-128024368*r**12-657181928*r**14
            -179078287*r**16+140370864*r**18-19652872*r**20-50057836*r**22-3575883*r**24
            +162732*r**26))+179159040000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(126560*Q2**13*(1
            +r**2)-60*Q2**12*(74509+156778*r**2+82269*r**4)+30*Q2**11*(969855+3285582*r**2
            +3724319*r**4+1408592*r**6)-4*Q2**10*(17661317+90184839*r**2+169512459*r**4
            +139695605*r**6+42398892*r**8)+60*Q2**9*(464437+6982924*r**2+24663079*r**4
            +36214100*r**6+24357370*r**8+6287862*r**10)-30*Q2**8*(-5888177-15168635*r**2
            +11742002*r**4+84651406*r**6+118106549*r**8+69926121*r**10+15448518*r**12)
            +5*Q2**7*(-59749051-284733630*r**2-528514293*r**4-306076080*r**6+329709167*r**8
            +582352962*r**10+294264809*r**12+44167380*r**14)+30*Q2**6*(1750938+27258427*r**2
            +119447174*r**4+166580151*r**6+44298094*r**8-68466463*r**10-51708006*r**12
            -3215667*r**14+5906040*r**16)-3*Q2**5*(-95557027-78071204*r**2+1320799006*r**4
            +3218926820*r**6+2051772408*r**8-1468826512*r**10-2418106294*r**12-757774124*r**14
            +163839955*r**16+108493068*r**18)+20*Q2**4*(-14881976-8142262*r**2+200535474*r**4
            +727887842*r**6+1181856163*r**8+805262670*r**10-155508115*r**12-462227462*r**14
            -152916483*r**16+9675940*r**18+8447249*r**20)-15*Q2**3*(-8029407-23030866*r**2
            -195886371*r**4+139772512*r**6+1368057146*r**8+1838992344*r**10+1086639058*r**12
            +232057892*r**14-94905243*r**16-28918310*r**18+3166737*r**20+168348*r**22)
            +18*(-1+r**2)**2*(-555841-16304149*r**2-143252319*r**4-263710559*r**6
            -293400220*r**8-25563054*r**10+435400826*r**12+193423670*r**14-92738561*r**16
            +11118275*r**18+35209125*r**20+2310953*r**22+7454*r**24)-30*Q2**2*(1392036
            +37791559*r**2+363190942*r**4+505273705*r**6+121833400*r**8-136418338*r**10
            -198108036*r**12-36230630*r**14-23143828*r**16-147053685*r**18-88230330*r**20
            -6096947*r**22+936152*r**24)+45*Q2*(664283+22082504*r**2+187972536*r**4
            +232319060*r**6+268138111*r**8+438748124*r**10-128024368*r**12-657181928*r**14
            -179078287*r**16+140370864*r**18-19652872*r**20-50057836*r**22-3575883*r**24
            +162732*r**26))*sqrtq2)+logq2**5*(-995328000*r**24*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(506240*Q2**17-800*Q2**16*(87485+89813*r**2)+10*Q2**15*(68225801
            +157224866*r**2+89650457*r**4)-6*Q2**14*(500206181+1851849871*r**2+2210835023*r**4
            +858475557*r**6)+6*Q2**13*(1294739779+6802682928*r**2+12653064936*r**4
            +9997791820*r**6+2863569873*r**8)-6*Q2**12*(2271057246+15319970355*r**2
            +38647397298*r**4+46816591720*r**6+27060264656*r**8+5838599877*r**10)
            +4*Q2**11*(4640222451+33811619880*r**2+101756657271*r**4+164231866654*r**6
            +146749607166*r**8+65174211816*r**10+9914174022*r**12)-Q2**10*(22184391921
            +132662300952*r**2+382997338395*r**4+679896417182*r**6+800515989287*r**8
            +580928279736*r**10+195727370085*r**12+7813866282*r**14)+Q2**9*(23064323097
            +99899066217*r**2+207117892041*r**4+93801264949*r**6-277460215145*r**8
            -343346501993*r**10-145244826273*r**12-84083013909*r**14-46786610616*r**16)
            +2*Q2**8*(-8625955249-48123413553*r**2-182931779466*r**4-192922723910*r**6
            +409314175062*r**8+1172337603666*r**10+1102255556782*r**12+520077237594*r**14
            +164216793495*r**16+34148537387*r**18)-2*Q2**7*(-2516416691-52610286140*r**2
            -359903284233*r**4-977433836560*r**6-1128292426846*r**8+7820727192*r**10
            +1256606384150*r**12+1174906975232*r**14+502094708025*r**16+135060108004*r**18
            +14373884923*r**20)-2*Q2**6*(-2863956146+26363801965*r**2+190779885034*r**4
            +890685069821*r**6+2149941836774*r**8+2118620574878*r**10+472598675018*r**12
            -488716274446*r**14-310436781844*r**16-74585261531*r**18-16931962916*r**20
            +12743895313*r**22)+6*Q2**5*(-1400791648-4274369571*r**2-60577735875*r**4
            +18897361749*r**6+583308316479*r**8+905343690924*r**10+221801411364*r**12
            -490890269436*r**14-302710214736*r**16+47353101079*r**18+62462899887*r**20
            +13791526215*r**22+6310421409*r**24)-6*Q2**4*(-808234394-7057049039*r**2
            -76129374062*r**4+10869592452*r**6+700959019080*r**8+1691802152793*r**10
            +1694411491308*r**12+276472558464*r**14-837008960394*r**16-547555854565*r**18
            -32743082734*r**20+41166543596*r**22+8767886988*r**24+2423118507*r**26)
            -36*Q2**3*(24428741+575195517*r**2+4535098794*r**4+3974602330*r**6-5430916188*r**8
            -175768499757*r**10-395325493329*r**12-342722377008*r**14-129500976315*r**16
            +7962796471*r**18+26205647616*r**20+7784075862*r**22-767648686*r**24
            -513502215*r**26+134320167*r**28)+54*(-1+r**2)**2*(-1737469+54837429*r**2
            +785578977*r**4+8530982827*r**6+39915692149*r**8+36980902535*r**10-11212235873*r**12
            -36298509479*r**14-19058917939*r**16+8062057107*r**18+408058207*r**20
            -7526466931*r**22-1612162373*r**24-38797263*r**26-29009631*r**28+6255727*r**30)
            +9*Q2**2*(-69623669+1478014300*r**2+12871291633*r**4+172864421030*r**6
            +816572170751*r**8+704058461780*r**10-130341871755*r**12-312517287186*r**14
            -95267647935*r**16-21902158492*r**18-249282454813*r**20-222776418670*r**22
            -22658694347*r**24+2254636780*r**26-1684500809*r**28+746877402*r**30)
            -27*Q2*(-16737927+387222045*r**2+4351437733*r**4+54674148177*r**6+235251808993*r**8
            +159039457337*r**10+31627135881*r**12+60283024829*r**14-190783220529*r**16
            -212166443081*r**18+57843088767*r**20+18631297043*r**22-56531785637*r**24
            -10868328973*r**26+282663763*r**28-364761377*r**30+92216956*r**32))+995328000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(506240*Q2**18-480*Q2**17*(146863+150743*r**2)
            +10*Q2**16*(75224601+171408706*r**2+96835497*r**4)-8*Q2**15*(460436887
            +1670700737*r**2+1966720421*r**4+755919739*r**6)+180*Q2**14*(59831532
            +305157966*r**2+557191661*r**4+435570080*r**6+124068181*r**8)-6*Q2**13*(3565797025
            +23417393062*r**2+58103145162*r**4+69467448476*r**6+39921626349*r**8
            +8702169750*r**10)+2*Q2**12*(16093616640+120396322563*r**2+365415417501*r**4
            +584855700362*r**6+515129783460*r**8+229045017231*r**10+37344147675*r**12)
            -3*Q2**11*(13581760575+95489890092*r**2+308423482333*r**4+581283504294*r**6
            +681480628189*r**8+476207851888*r**10+165360304479*r**12+15823520790*r**14)
            +2*Q2**10*(22624357509+127372879545*r**2+361388765694*r**4+578347510263*r**6
            +601476095662*r**8+519048883515*r**10+315705411774*r**12+59729111229*r**14
            -19486372167*r**16)+5*Q2**9*(-8063246719-43842043284*r**2-134576103438*r**4
            -137352920962*r**6+200457460064*r**8+593096384894*r**10+538620488366*r**12
            +253896463074*r**14+91860642303*r**16+23016737078*r**18)-12*Q2**8*(-1857061990
            -18226609157*r**2-98493079542*r**4-225548056656*r**6-151983495949*r**8
            +264912084320*r**10+588533257433*r**12+466206628268*r**14+197731456519*r**16
            +55570906481*r**18+8087070385*r**20)+2*Q2**7*(347539455-81490504796*r**2
            -603293455407*r**4-2228022190614*r**6-4255668100180*r**8-3239092274532*r**10
            +791828436324*r**12+2920229633828*r**14+1987438465101*r**16+711740077560*r**18
            +166365955843*r**20+1629989610*r**22)+4*Q2**6*(-3533165545+5338368553*r**2
            +17705239687*r**4+569078520051*r**6+2395275928016*r**8+3492296742212*r**10
            +1628311741994*r**12-744394203868*r**14-853641850249*r**16-121481370069*r**18
            +47935737607*r**20+18593255521*r**22+15837579770*r**24)-12*Q2**5*(-1104513021
            -6366105129*r**2-70490739754*r**4-15405390837*r**6+651582348654*r**8
            +1590227080098*r**10+1410778296798*r**12+3691850196*r**14-815304722283*r**16
            -401456484111*r**18+38536459116*r**20+58710484849*r**22+14434917306*r**24
            +4366769958*r**26)+30*Q2**4*(-190961368-2263291307*r**2-22079403173*r**4
            -17821479118*r**6+148882821732*r**8+689474434083*r**10+1151633320815*r**12
            +805443662364*r**14+43293891192*r**16-286468318757*r**18-147506564599*r**20
            -7656198862*r**22+10908064540*r**24+2854403757*r**26+323439501*r**28)
            +9*Q2**3*(28091295+3876511332*r**2+33312468877*r**4+206903225526*r**6
            +810746915319*r**8-20739202000*r**10-2414717844099*r**12-3264708768534*r**14
            -1984161061227*r**16-508054877868*r**18-112608678465*r**20-86817524758*r**22
            +5407014357*r**24-2869966824*r**26-3201229001*r**28+1284158070*r**30)
            -54*(-1+r**2)**2*(-1737469+53099960*r**2+840416406*r**4+9316561804*r**6
            +48446674976*r**8+76896594684*r**10+25768666662*r**12-47510745352*r**14
            -55357427418*r**16-10996860832*r**18+8470115314*r**20-7118408724*r**22
            -9138629304*r**24-1650959636*r**26-67806894*r**28-22753904*r**30+6255727*r**32)
            -18*Q2**2*(-59918725+1285028383*r**2+13701809566*r**4+174879078597*r**6
            +847596009380*r**8+998874502271*r**10+334298998834*r**12-131005042227*r**14
            -490067298354*r**16-376834567835*r**18-48827673502*r**20-208082491177*r**22
            -207515234964*r**24-26504522243*r**26+709063630*r**28-1015953769*r**30
            +511764135*r**32)+27*Q2*(-20212865+487108852*r**2+6086993078*r**4+73054910514*r**6
            +337204568114*r**8+325652268458*r**10+100149895630*r**12+138123890314*r**14
            -45848465408*r**16-383186896598*r**18-223873302206*r**20+75913333334*r**22
            -10202829202*r**24-76081993506*r**26-13712820166*r**28-31142162*r**30
            -355586591*r**32+104728410*r**34))*sqrtq2)+logq2**4*(-16588800*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(91845120*Q2**20-2880*Q2**19*(558811
            +657557*r**2)+24*Q2**18*(504737761+1181401398*r**2+668346709*r**4)-2*Q2**17*(26064569121
            +91601605514*r**2+103669313457*r**4+37623783624*r**6)+8*Q2**16*(17728578414
            +83957067347*r**2+143272320585*r**4+104602080777*r**6+26700285861*r**8)
            -2*Q2**15*(126021425007+761776485660*r**2+1738956621984*r**4+1922554515520*r**6
            +1006345235877*r**8+178426233048*r**10)+Q2**14*(290377115145+2162913070485*r**2
            +6009254291654*r**4+8631566225002*r**6+6973172188041*r**8+2722451600505*r**10
            +248432055840*r**12)+Q2**13*(-209974278987-1816287578706*r**2-4936099144369*r**4
            -6169135147804*r**6-5453054422937*r**8-3998674876386*r**10-1070544627411*r**12
            +271494203112*r**14)-Q2**12*(-96554279781-717562706949*r**2+1511425933279*r**4
            +15893349865315*r**6+33135153719913*r**8+28445583021041*r**10+11040100009725*r**12
            +2966695854993*r**14+803189028096*r**16)+2*Q2**11*(-15155710053+41728295136*r**2
            +4436301052777*r**4+24752654890442*r**6+58899054801461*r**8+71635776871564*r**10
            +45030886102907*r**12+14351769093378*r**14+2902274403876*r**16+323366540448*r**18)
            +Q2**10*(-39794282073-370212956835*r**2-11837177354572*r**4-62183221308796*r**6
            -168198886269246*r**8-263007870143050*r**10-235208961392620*r**12-110712831189836*r**14
            -24970568687649*r**16-3998391439563*r**18+172828668528*r**20)+Q2**9*(131763820125
            +723295407510*r**2+10959359998967*r**4+43915351593236*r**6+109511754977958*r**8
            +176376532389240*r**10+187464377817130*r**12+118874142044292*r**14+24770463835981*r**16
            -6707992105182*r**18-879787102545*r**20-735403180200*r**22)+Q2**8*(-132397769193
            -1068800368019*r**2-9029903920135*r**4-33130773521537*r**6-74114556170146*r**8
            -49983185231014*r**10+90996336501034*r**12+189563862217814*r**14+162001962219083*r**16
            +97515580668169*r**18+34256123729005*r**20+3979789260891*r**22+479378839728*r**24)
            +2*Q2**7*(7452463707+443556965068*r**2+2759386493950*r**4+21726788559172*r**6
            +81859768847293*r**8+144360023523280*r**10+80847979537696*r**12-98555902133168*r**14
            -181969857597959*r**16-131593794928532*r**18-57930927508206*r**20-12653610869508*r**22
            -1537911246561*r**24+43546432968*r**26)-Q2**6*(-80401625151+278592044697*r**2
            +243548839498*r**4+30652623836006*r**6+140125092661743*r**8+412135553644179*r**10
            +656153486374812*r**12+428688429155940*r**14+18891094246287*r**16-115296769983009*r**18
            -95165910387078*r**20-37339278090634*r**22+4562053786177*r**24-338504830923*r**26
            +289403799456*r**28)+3*Q2**5*(-22820345139-73666361490*r**2-959690308009*r**4
            -1993140714396*r**6-15228629722647*r**8+32191208235898*r**10+168529777561155*r**12
            +163177754430672*r**14-3761671000905*r**16-54932351373294*r**18+5872417323237*r**20
            +14472836708740*r**22+5345702670867*r**24+5754883708806*r**26+396983057921*r**28
            +46536880584*r**30)+3*Q2**4*(4091460345+110831039805*r**2+646404459793*r**4
            +5861692215929*r**6+30559138518717*r**8-21075830281375*r**10-221349385351355*r**12
            -338440013739411*r**14-145967456313093*r**16+125601605626311*r**18+152309355330915*r**20
            +34518934186235*r**22-8874945207857*r**24-5011069999461*r**26-2656099680953*r**28
            -303917532385*r**30+3782067840*r**32)-18*Q2**3*(-851627537+10344107664*r**2
            +17806373959*r**4+415343871438*r**6+1428173871169*r**8-3926752034340*r**10
            -21764342625689*r**12-63092600355726*r**14-80056383244241*r**16-44613820601368*r**18
            -5624460576579*r**20+6849855483026*r**22+4995103999875*r**24+572791924028*r**26
            -517528217451*r**28+94459797806*r**30-8780269026*r**32+2113722992*r**34)
            +27*(-1+r**2)**2*(-20189333-121508541*r**2+3407863772*r**4+54869093272*r**6
            +532643634280*r**8+3659300451524*r**10+10128546128628*r**12-101615821896*r**14
            -11520975205946*r**16-1742684252510*r**18+4616161230076*r**20-86231466808*r**22
            -2167032480624*r**24-458693415324*r**26-44886110020*r**28-31944762392*r**30
            +3772288471*r**32+477051123*r**34+6672248*r**36)+9*Q2**2*(-1384961967
            +4688127327*r**2+18582141352*r**4+474277519416*r**6+3563362516628*r**8
            +29781796018164*r**10+90198870948912*r**12+46839163128552*r**14-25332429912770*r**16
            -21931811809606*r**18-6950872349952*r**20-21935244405880*r**22-28739322888060*r**24
            -3698568956108*r**26+1056854827728*r**28-1072857534120*r**30+298405495641*r**32
            +14246692031*r**34+1787802712*r**36)-27*Q2*(-151492459-106973362*r**2
            +10507291643*r**4+151306804572*r**6+1447524054896*r**8+11041210819452*r**10
            +28582089133736*r**12+1374013345556*r**14-16560301089486*r**16-4030154718728*r**18
            -6286266519002*r**20+2312873327964*r**22+2004684251384*r**24-6811798841244*r**26
            -1794781994032*r**28+105567241884*r**30-200099708463*r**32+30896270042*r**34
            +2798759783*r**36+106835864*r**38))-16588800*r**20*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(91845120*Q2**20-2880*Q2**19*(558811+657557*r**2)+24*Q2**18*(504737761
            +1181401398*r**2+668346709*r**4)-2*Q2**17*(26064569121+91601605514*r**2
            +103669313457*r**4+37623783624*r**6)+8*Q2**16*(17728578414+83957067347*r**2
            +143272320585*r**4+104602080777*r**6+26700285861*r**8)-2*Q2**15*(126021425007
            +761776485660*r**2+1738956621984*r**4+1922554515520*r**6+1006345235877*r**8
            +178426233048*r**10)+Q2**14*(290377115145+2162913070485*r**2+6009254291654*r**4
            +8631566225002*r**6+6973172188041*r**8+2722451600505*r**10+248432055840*r**12)
            +Q2**13*(-209974278987-1816287578706*r**2-4936099144369*r**4-6169135147804*r**6
            -5453054422937*r**8-3998674876386*r**10-1070544627411*r**12+271494203112*r**14)
            -Q2**12*(-96554279781-717562706949*r**2+1511425933279*r**4+15893349865315*r**6
            +33135153719913*r**8+28445583021041*r**10+11040100009725*r**12+2966695854993*r**14
            +803189028096*r**16)+2*Q2**11*(-15155710053+41728295136*r**2+4436301052777*r**4
            +24752654890442*r**6+58899054801461*r**8+71635776871564*r**10+45030886102907*r**12
            +14351769093378*r**14+2902274403876*r**16+323366540448*r**18)+Q2**10*(
            -39794282073-370212956835*r**2-11837177354572*r**4-62183221308796*r**6
            -168198886269246*r**8-263007870143050*r**10-235208961392620*r**12-110712831189836*r**14
            -24970568687649*r**16-3998391439563*r**18+172828668528*r**20)+Q2**9*(131763820125
            +723295407510*r**2+10959359998967*r**4+43915351593236*r**6+109511754977958*r**8
            +176376532389240*r**10+187464377817130*r**12+118874142044292*r**14+24770463835981*r**16
            -6707992105182*r**18-879787102545*r**20-735403180200*r**22)+Q2**8*(-132397769193
            -1068800368019*r**2-9029903920135*r**4-33130773521537*r**6-74114556170146*r**8
            -49983185231014*r**10+90996336501034*r**12+189563862217814*r**14+162001962219083*r**16
            +97515580668169*r**18+34256123729005*r**20+3979789260891*r**22+479378839728*r**24)
            +2*Q2**7*(7452463707+443556965068*r**2+2759386493950*r**4+21726788559172*r**6
            +81859768847293*r**8+144360023523280*r**10+80847979537696*r**12-98555902133168*r**14
            -181969857597959*r**16-131593794928532*r**18-57930927508206*r**20-12653610869508*r**22
            -1537911246561*r**24+43546432968*r**26)-Q2**6*(-80401625151+278592044697*r**2
            +243548839498*r**4+30652623836006*r**6+140125092661743*r**8+412135553644179*r**10
            +656153486374812*r**12+428688429155940*r**14+18891094246287*r**16-115296769983009*r**18
            -95165910387078*r**20-37339278090634*r**22+4562053786177*r**24-338504830923*r**26
            +289403799456*r**28)+3*Q2**5*(-22820345139-73666361490*r**2-959690308009*r**4
            -1993140714396*r**6-15228629722647*r**8+32191208235898*r**10+168529777561155*r**12
            +163177754430672*r**14-3761671000905*r**16-54932351373294*r**18+5872417323237*r**20
            +14472836708740*r**22+5345702670867*r**24+5754883708806*r**26+396983057921*r**28
            +46536880584*r**30)+3*Q2**4*(4091460345+110831039805*r**2+646404459793*r**4
            +5861692215929*r**6+30559138518717*r**8-21075830281375*r**10-221349385351355*r**12
            -338440013739411*r**14-145967456313093*r**16+125601605626311*r**18+152309355330915*r**20
            +34518934186235*r**22-8874945207857*r**24-5011069999461*r**26-2656099680953*r**28
            -303917532385*r**30+3782067840*r**32)-18*Q2**3*(-851627537+10344107664*r**2
            +17806373959*r**4+415343871438*r**6+1428173871169*r**8-3926752034340*r**10
            -21764342625689*r**12-63092600355726*r**14-80056383244241*r**16-44613820601368*r**18
            -5624460576579*r**20+6849855483026*r**22+4995103999875*r**24+572791924028*r**26
            -517528217451*r**28+94459797806*r**30-8780269026*r**32+2113722992*r**34)
            +27*(-1+r**2)**2*(-20189333-121508541*r**2+3407863772*r**4+54869093272*r**6
            +532643634280*r**8+3659300451524*r**10+10128546128628*r**12-101615821896*r**14
            -11520975205946*r**16-1742684252510*r**18+4616161230076*r**20-86231466808*r**22
            -2167032480624*r**24-458693415324*r**26-44886110020*r**28-31944762392*r**30
            +3772288471*r**32+477051123*r**34+6672248*r**36)+9*Q2**2*(-1384961967
            +4688127327*r**2+18582141352*r**4+474277519416*r**6+3563362516628*r**8
            +29781796018164*r**10+90198870948912*r**12+46839163128552*r**14-25332429912770*r**16
            -21931811809606*r**18-6950872349952*r**20-21935244405880*r**22-28739322888060*r**24
            -3698568956108*r**26+1056854827728*r**28-1072857534120*r**30+298405495641*r**32
            +14246692031*r**34+1787802712*r**36)-27*Q2*(-151492459-106973362*r**2
            +10507291643*r**4+151306804572*r**6+1447524054896*r**8+11041210819452*r**10
            +28582089133736*r**12+1374013345556*r**14-16560301089486*r**16-4030154718728*r**18
            -6286266519002*r**20+2312873327964*r**22+2004684251384*r**24-6811798841244*r**26
            -1794781994032*r**28+105567241884*r**30-200099708463*r**32+30896270042*r**34
            +2798759783*r**36+106835864*r**38))*sqrtq2)+logq2**3*(276480*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(-1100079360*Q2**23+64*Q2**22*(243899561
            +263904393*r**2)-2*Q2**21*(50077645029+109763804266*r**2+57966178437*r**4)
            +6*Q2**20*(62891650509+214653200129*r**2+229705958875*r**4+76060196007*r**6)
            -20*Q2**19*(45336055958+219361004277*r**2+361163940168*r**4+246890693705*r**6
            +54065654496*r**8)+10*Q2**18*(140633650113+928328377360*r**2+2060878241256*r**4
            +2166629697930*r**6+1050882788983*r**8+136664429958*r**10)-12*Q2**17*(110684807273
            +988331751709*r**2+2516033612595*r**4+3246279166740*r**6+2562548144530*r**8
            +938283100633*r**10+5358750684*r**12)-Q2**16*(-567590122997-7082808993288*r**2
            -4178300272611*r**4+30429631740750*r**6+41289020584965*r**8+12174137952168*r**10
            +2955418962667*r**12+2805415191594*r**14)+Q2**15*(255172887399+2922788280859*r**2
            +70217150729595*r**4+303859759917327*r**6+512469963584145*r**8+388355245883829*r**10
            +132198168420069*r**12+28335031551745*r**14+4237370153352*r**16)-15*Q2**14*(45483690383
            +626520570132*r**2+9216994049424*r**4+45186536727732*r**6+98351709485058*r**8
            +107991360160852*r**10+59190585204704*r**12+14830973801148*r**14+2560845686015*r**16
            +80408665896*r**18)+5*Q2**13*(167313671159+1822635074325*r**2+25841350283616*r**4
            +152589290220516*r**6+403843175085150*r**8+569516728211298*r**10+450551040196884*r**12
            +171504098830908*r**14+19281426865515*r**16+2445053080937*r**18-781717512756*r**20)
            +Q2**12*(-575228001321-7450140237538*r**2-63584598418245*r**4-399948041323620*r**6
            -908732976800670*r**8-850400733632124*r**10-484169707467222*r**12-183641548001400*r**14
            +236667800016135*r**16+213077057251230*r**18+29688381024539*r**20+4981380738012*r**22)
            -3*Q2**11*(115058400831-2170293403001*r**2-6421752176407*r**4+5931667554825*r**6
            +429658462905210*r**8+1862520490780674*r**10+3349133626713806*r**12+2954055677603502*r**14
            +1461855297724575*r**16+540852579808695*r**18+120199579311241*r**20+14283460338569*r**22
            +257017400808*r**24)+Q2**10*(1094421394879-2112096783696*r**2-3007460164350*r**4
            +157763131385152*r**6+2494648925940945*r**8+10606042110793536*r**10+23088346601082476*r**12
            +27400218011863200*r**14+17558521630271793*r**16+6447929245169200*r**18
            +1760554221364434*r**20+136523628405024*r**22+15753060713215*r**24-3110897791008*r**26)
            +5*Q2**9*(-132350844081-1006806849659*r**2-5370505373190*r**4-39083000008218*r**6
            -425300854694855*r**8-1660002077730405*r**10-4043185693073844*r**12-6050935587597148*r**14
            -5165851005153423*r**16-2147035964734581*r**18-368321631944342*r**20-75245998529802*r**22
            +36675341742279*r**24+3390300925525*r**26+514165613328*r**28)+15*Q2**8*(
            -22352023961+508845687530*r**2+3566417482869*r**4+19510387721856*r**6
            +102774348206819*r**8+293306684690518*r**10+548548263542889*r**12+551790733403164*r**14
            +168225865025301*r**16-327120386026858*r**18-574305731227777*r**20-330413139539736*r**22
            -70622830382559*r**24-15456030646870*r**26-1523312486749*r**28+4976361084*r**30)
            +Q2**7*(598256646229-3231763321383*r**2-37222715198715*r**4-289415285695095*r**6
            -1242497445381555*r**8-6071557305056199*r**10-15230393722657507*r**12
            -16568723559071535*r**14+1491098199886095*r**16+21290683172859155*r**18
            +25620909941502471*r**20+17059772102325843*r**22+5570893272645495*r**24
            +1204747442347995*r**26+53827833441495*r**28+7548901915219*r**30-1158382036008*r**32)
            +Q2**6*(-134103917523-2276618662492*r**2-2210207866404*r**4+121992391892100*r**6
            +484740697396980*r**8+6122515681986588*r**10+20253686787912372*r**12+41463845208462964*r**14
            +44013622944239550*r**16+17003691330873780*r**18-4621152260160572*r**20
            -12298358502749748*r**22-8170093919260236*r**24-407219883621900*r**26
            -349532980671060*r**28+72876558319932*r**30+5128675197293*r**32+539746868376*r**34)
            +3*Q2**5*(-65503271807+1167610848573*r**2+6997639527930*r**4+8807224872024*r**6
            +123101239697400*r**8-28238208623048*r**10+329626610839232*r**12-5091173880061920*r**14
            -12829910434457014*r**16-7618247984395630*r**18-257521313732388*r**20
            -1075140066297288*r**22-599824155079680*r**24-21770767650624*r**26-911871412897120*r**28
            -108456997741232*r**30-20174955996867*r**32-1966487866055*r**34+33078125514*r**36)
            -15*Q2**4*(-8997555729+92645965404*r**2+915313689747*r**4+3629851881922*r**6
            +26239741982104*r**8+193394291933568*r**10+625471789983968*r**12-701044996346928*r**14
            -3421497250274514*r**16-2671217599216056*r**18+932497731427646*r**20+2045331898803252*r**22
            +727081423388960*r**24+40526132089472*r**26-48725633418600*r**28-96967334536160*r**30
            -21853375854549*r**32-676295050404*r**34-114084376905*r**36+10915083802*r**38)
            +45*Q2**3*(11479805-9779627015*r**2+44023923335*r**4+826726872659*r**6
            +1087573624128*r**8+26721444419288*r**10+14049325357936*r**12-427633026722912*r**14
            -1204527253457158*r**16-1935888840414910*r**18-1545064577743386*r**20
            -376455427086002*r**22+158096376098704*r**24+182843030471184*r**26+71105046895816*r**28
            -25609750537672*r**30+5716631399681*r**32-1645215125027*r**34+192202157915*r**36
            +12923757191*r**38+877456440*r**40)+54*(-1+r**2)**2*(-31823459+691026093*r**2
            +4880524480*r**4-58759100100*r**6-469301403315*r**8-5519853212179*r**10
            -42017016366472*r**12-187935872811640*r**14-285507674563550*r**16+361515997523970*r**18
            +353507144104216*r**20-303405304897792*r**22-119389674925910*r**24+137169825940650*r**26
            +24195105579880*r**28-4331358946184*r**30+4191448042753*r**32-150641235055*r**34
            -75564547000*r**36-3181273660*r**38-374670519*r**40+16234793*r**42)+9*Q2**2*(
            -3481203629+75432011128*r**2+224433709650*r**4-3116531919420*r**6-164919977685*r**8
            -70042486286684*r**10-405627012702232*r**12-2519568259799920*r**14-5610759123128410*r**16
            -1902492033762240*r**18+1499249198892956*r**20+1424461150178808*r**22
            +1600058230949390*r**24+2164974270457080*r**26+276841421065160*r**28-286635533319344*r**30
            +229437832971943*r**32-45075165524120*r**34-4103119246750*r**36-621083560860*r**38
            -67581977049*r**40+1069372228*r**42)-27*Q2*(-472779151+10145955371*r**2
            +42151770502*r**4-588478601250*r**6-1758360989495*r**8-27832486621001*r**10
            -222689567506744*r**12-1116352152736648*r**14-1663676618478750*r**16+1319588104478310*r**18
            +1674170511752084*r**20-204019774476444*r**22-926741258210118*r**24-263071414782250*r**26
            +744869018321240*r**28+173455740927064*r**30-73176479530739*r**32+45873725128047*r**34
            -3406611550250*r**36-874535206930*r**38-50451638371*r**40-6972957069*r**42
            +231332592*r**44))+276480*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1100079360*Q2**24
            -64*Q2**23*(261088301+281093133*r**2)+2*Q2**22*(57882430981+126013530794*r**2
            +66411119013*r**4)-4*Q2**21*(119376298278+401900524841*r**2+428423929664*r**4
            +143073383229*r**6)+2*Q2**20*(642035511107+3026244594684*r**2+4944716878692*r**4
            +3386205401696*r**6+768837132981*r**8)-10*Q2**19*(231305762029+1457722497830*r**2
            +3221928130146*r**4+3382738965676*r**6+1652795485385*r**8+244795738950*r**10)
            +2*Q2**18*(1367277094203+11274800647619*r**2+30042234768650*r**4+40615214696370*r**6
            +31462851301745*r**8+11567434698503*r**10+715474653894*r**12)+Q2**17*(
            -1895807810273-20271007701072*r**2-46230684644259*r**4-38718121611270*r**6
            -28416907150275*r**8-29835836989788*r**10-8368283253137*r**12+2741110183386*r**14)
            -2*Q2**16*(-156208617799-2363805417713*r**2+29478020731848*r**4+165055545692733*r**6
            +292094307954930*r**8+220909202210481*r**10+73663862667452*r**12+17047932853003*r**14
            +3521392672473*r**16)+2*Q2**15*(468714121572+6287884860119*r**2+105697424875907*r**4
            +525937480781451*r**6+1145802682888671*r**8+1260347805940377*r**10+704206096187229*r**12
            +191498903494517*r**14+35492543497661*r**16+2721750070896*r**18)+10*Q2**14*(
            -151882371154-1919323927935*r**2-27685947071142*r**4-157899941275992*r**6
            -417228956861760*r**8-594272968574514*r**10-476048438146776*r**12-196784387924232*r**14
            -35728442663502*r**16-5184408068335*r**18+270245757534*r**20)+2*Q2**13*(705898178558
            +8699941982479*r**2+100952262603975*r**4+646050621922140*r**6+1845447651664500*r**8
            +2858600125057182*r**10+2792254274754066*r**12+1646958621570180*r**14
            +358629914232990*r**16-52222328759485*r**18-10685851591817*r**20-4444984150896*r**22)
            +2*Q2**12*(-115026399414-7268124223931*r**2-45149997592502*r**4-222868818538695*r**6
            -9852814704330*r**8+1914213880954614*r**10+4356415219521036*r**12+4097177888670942*r**14
            +2219296072594230*r**16+1036151298346725*r**18+301682088104746*r**20+38760071389129*r**22
            +2876216470218*r**24)+2*Q2**11*(-719798298686+4138900895103*r**2+14391798451287*r**4
            -78146438760203*r**6-1900709658660525*r**8-8741289485925594*r**10-19361654476782958*r**12
            -23154892962407562*r**14-15403127278128012*r**16-6228026438884505*r**18
            -1871855349362121*r**20-269986373677227*r**22-29687246965673*r**24+1169922794292*r**26)
            +Q2**10*(1756175615284+4016358859478*r**2+21732969917904*r**4+350170671261892*r**6
            +4778916330800372*r**8+21400701425386506*r**10+53910317177245232*r**12
            +80743242550931416*r**14+70787994667902108*r**16+34741630699113898*r**18
            +10050091626255344*r**20+2273307842418468*r**22-31100019593156*r**24-4309341705418*r**26
            -5681725857648*r**28)+10*Q2**9*(-32647386099-1332847378165*r**2-8538282335728*r**4
            -51492334273488*r**6-386353449661765*r**8-1482611493248407*r**10-3674416280716458*r**12
            -5874746740440242*r**14-5860732093913237*r**16-3165762905903715*r**18
            -396220201497796*r**20+273835894072532*r**22+86648917180077*r**24+43216867304207*r**26
            +4237201999550*r**28+249618265038*r**30)+2*Q2**8*(-466768502822+5264584137459*r**2
            +49175831377350*r**4+317783681882985*r**6+1538384242155840*r**8+6006386399258127*r**10
            +13929108973079306*r**12+16536904256631165*r**14+4654575388270440*r**16
            -11837050493941255*r**18-19571150850160998*r**20-15315277581919269*r**22
            -5793216410739960*r**24-1247965178894715*r**26-154258990222890*r**28-15161971900097*r**30
            +616513726134*r**32)-2*Q2**7*(-366180281876+178444006331*r**2+19122135326847*r**4
            +224315196392955*r**6+1008326714236815*r**8+6718285216212171*r**10+20777818907813039*r**12
            +36631481245096003*r**14+29545624151712495*r**16-2889045020935735*r**18
            -25766372687261099*r**20-27489520273289031*r**22-15400379647115787*r**24
            -3591430299307695*r**26-804054128230275*r**28+5749911481609*r**30-630922340959*r**32
            +849064452192*r**34)+2*Q2**6*(31202948949-2956777562867*r**2-12739872556343*r**4
            +46680254704812*r**6+118714685098440*r**8+3345985502626356*r**10+12693661318690632*r**12
            +38495526818280548*r**14+61983599728036778*r**16+41936029114150110*r**18
            +6577551505955186*r**20-6847045282009228*r**22-9334489978385472*r**24
            -4256000749965132*r**26+989430687199200*r**28+24357285436284*r**30+69265050753913*r**32
            +5783942831917*r**34+220256245917*r**36)+6*Q2**5*(-55245525226+782668701893*r**2
            +6370909412619*r**4+16977061904782*r**6+131553587239972*r**8+530917245371096*r**10
            +1714373676068012*r**12-4133386125478664*r**14-17514285282945752*r**16
            -16902123207466462*r**18-1606640320494894*r**20+4446999056993292*r**22
            +980221447783916*r**24-209482131141472*r**26-588635173820372*r**28-752582541659576*r**30
            -118949416505422*r**32-12761459557471*r**34-1251915812533*r**36+43826772262*r**38)
            -30*Q2**4*(-4481558157+27154764315*r**2+570015712578*r**4+3512673094823*r**6
            +16566157368205*r**8+149899183586768*r**10+430507028995672*r**12-679236143265848*r**14
            -3868062003496458*r**16-5950190685367650*r**18-3186956800509284*r**20
            +924231674486446*r**22+1623351225244162*r**24+658068323445992*r**26+102557819679160*r**28
            -111261109783888*r**30-50835408095833*r**32-13732658140017*r**34-106886476782*r**36
            -32199010765*r**38+6773726561*r**40)+18*Q2**3*(1769301327-62136373589*r**2
            -26606114025*r**4+3735142949695*r**6+4868211230810*r**8+104543788251882*r**10
            +304740430794176*r**12+225824876487520*r**14-1275021138885970*r**16-6899794217799050*r**18
            -9452008144842218*r**20-5516030587162874*r**22-1345926742942940*r**24
            -230138618803820*r**26+496449482884920*r**28+257056007555032*r**30-164451714330949*r**32
            +32716123448695*r**34-1580972794405*r**36+823356568195*r**38+68294022602*r**40
            +1658954986*r**42)+54*(-1+r**2)**2*(-31823459+659202634*r**2+5571550573*r**4
            -53878575620*r**6-528060503415*r**8-5989154615494*r**10-47536869578651*r**12
            -229952889178112*r**14-473443547375190*r**16+76008322960420*r**18+715023141628186*r**20
            +50101839206424*r**22-422794979823702*r**24+17780151014740*r**26+161364931520530*r**28
            +19863746633696*r**30-139910903431*r**32+4040806807698*r**34-226205782055*r**36
            -78745820660*r**38-3555944179*r**40-358435726*r**42+16234793*r**44)+18*Q2**2*(
            -2449770541+51194336806*r**2+213160516142*r**4-2328767006760*r**6-4278267432795*r**8
            -76852433063686*r**10-571869100754574*r**12-3137125865356048*r**14-6560678619182290*r**16
            -1777243421727860*r**18+2309634350193484*r**20+1155825512821216*r**22
            +122147803248922*r**24+1487909128529860*r**26+2338211373242980*r**28+255286555263504*r**30
            -138363569469809*r**32+160991921415982*r**34-29699059710810*r**36-3673904214200*r**38
            -420010226511*r**40-43715738014*r**42+881685002*r**44)-27*Q2*(-536426069
            +11182522242*r**2+59231023543*r**4-681985076682*r**6-3040644948015*r**8
            -38870866621794*r**10-313415276818603*r**12-1557885106825142*r**14-2683334661828882*r**16
            +1145102433678420*r**18+1683693565215846*r**20+172343546111132*r**22+551095125261218*r**24
            -1044724931203012*r**26-257270838915670*r**28+1087221270917716*r**30+174377804426327*r**32
            -53032546936182*r**34+51301445509523*r**36-4286533586610*r**38-1064140185699*r**40
            -62255991098*r**42-7555904687*r**44+263802178*r**46))*sqrtq2)+logq2**2*(4608*r**12*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(-2848358912*Q2**26
            +352*Q2**25*(120313351+124314991*r**2)-4*Q2**24*(69707899625+151021294994*r**2
            +73015123625*r**4)+2*Q2**23*(531096513805+1817868730242*r**2+1865010945117*r**4
            +540923302120*r**6)-4*Q2**22*(636484802005+3107100827569*r**2+4918928507817*r**4
            +3176754507859*r**6+568416217030*r**8)+4*Q2**21*(953400376430+6466225040396*r**2
            +13207758024431*r**4+13150626979796*r**6+6023639062661*r**8+501986602370*r**10)
            +2*Q2**20*(-1476110239805-15360145965513*r**2-28897257388560*r**4-25718745355670*r**6
            -22194661971555*r**8-8215245718053*r**10+1148618253100*r**12)-Q2**19*(706228111225
            -9792880410854*r**2+74656734391215*r**4+345388638175600*r**6+394172089009075*r**8
            +148188629548890*r**10+33930078985021*r**12+8561786101300*r**14)+2*Q2**18*(2277280886380
            +15929760477907*r**2+184774375277872*r**4+781763553988255*r**6+1277137173239200*r**8
            +908662080443665*r**10+265526430832072*r**12+49744486720957*r**14+3943062050620*r**16)
            +Q2**17*(-4541402971545-60437897986596*r**2-590313267833478*r**4-3034831459901276*r**6
            -6517869557003160*r**8-6868307459079960*r**10-3427270815650066*r**12-641408218131228*r**14
            -90937907160231*r**16+4165205658180*r**18)+Q2**16*(-302911054710+49705119540414*r**2
            +450508867059324*r**4+2894704680892984*r**6+7145628733907524*r**8+9279586799214396*r**10
            +7060866406114264*r**12+2164364745971224*r**14-98247386823966*r**16-33745316333226*r**18
            -15386038208100*r**20)+4*Q2**15*(1423612226130-2944134710304*r**2-16703618460945*r**4
            -95573951076965*r**6+642349808814745*r**8+2905708908287767*r**10+3525560114537167*r**12
            +1862989166590105*r**14+946632193918885*r**16+313236027990945*r**18+40719625039026*r**20
            +2422732180020*r**22)+4*Q2**14*(-1406645029550-6024092159364*r**2-45297158947845*r**4
            -565972319366900*r**6-4546255258527000*r**8-15837586626059040*r**10-25273215185443526*r**12
            -19503362767968240*r**14-7817778991621950*r**16-2408601972861500*r**18
            -335435923570245*r**20-33848124338364*r**22+1849550622100*r**24)-4*Q2**13*(91412884985
            -10617497895976*r**2-60496662095991*r**4-681753661538245*r**6-5890000797766225*r**8
            -25219297881628380*r**10-52577179842049714*r**12-56798914243978114*r**14
            -30882967172429385*r**16-8185006404258700*r**18-1821804752982775*r**20
            +27630804245559*r**22+8410695158849*r**24+3495744331040*r**26)+4*Q2**12*(1303044435595
            -8723042457389*r**2-70150544165027*r**4-459876959715764*r**6-3420775744730900*r**8
            -17919691170109535*r**10-44303889121146446*r**12-59647943671632368*r**14
            -44307233698389281*r**16-12023162577321035*r**18+1604294950491925*r**20
            +753104934803476*r**22+356973769649098*r**24+37087820369671*r**26+978163075420*r**28)
            +2*Q2**11*(-1637924921035-830634724998*r**2+93957599356017*r**4+668774503517222*r**6
            +1433598137009007*r**8+2884954917346656*r**10-23317304877876457*r**12
            -95410648443054072*r**14-129325810115779077*r**16-97620456536376862*r**18
            -64567255781626329*r**20-23844025707632898*r**22-5219212980089983*r**24
            -520344991390428*r**26-45662179187343*r**28+3296694612020*r**30)-4*Q2**10*(427537187480
            -9597635734621*r**2-25636480930665*r**4+236957030578295*r**6+66219709300670*r**8
            -6500924345877573*r**10-59554297877374471*r**12-195057833456042785*r**14
            -319300698979785120*r**16-273486622301948695*r**18-139831943545616071*r**20
            -56048824191913083*r**22-9632510261614090*r**24-1803404776954855*r**26
            +63329286587895*r**28+8382327524549*r**30+1444477633940*r**32)-2*Q2**9*(
            -1488076724225+16986501045748*r**2+130116386936860*r**4+76145246715250*r**6
            +825361988585950*r**8+11973869310040780*r**10+109899829569599752*r**12
            +388497378173607310*r**14+804021380104719400*r**16+926210307218714800*r**18
            +546352650683974060*r**20+181779542342943502*r**22+58300456668011530*r**24
            -3826675597483700*r**26-733844731446800*r**28-380689298458190*r**30-37072307938127*r**32
            +113864253700*r**34)+4*Q2**8*(-138717205960-680008445859*r**2+28084879584726*r**4
            +334690111997450*r**6+1622241676438875*r**8+6995390150053980*r**10+30823665801737689*r**12
            +80418108760449294*r**14+161799259415073855*r**16+214640273973670250*r**18
            +126476145050288025*r**20-41557782407642106*r**22-65819613203976911*r**24
            -18969811556112540*r**26-7855936824842325*r**28-1406587351397470*r**30
            -80508995148099*r**32-6632515881159*r**34+606449966285*r**36)-2*Q2**7*(549644758085
            -11294707872502*r**2-30637038485361*r**4+685036851711158*r**6+3335965716262670*r**8
            +16120724242310070*r**10+51281133586055542*r**12+178173238883896486*r**14
            +305040866049278352*r**16+154770502142375450*r**18-201435067774304500*r**20
            -496101728312835918*r**22-540708811369878014*r**24-248567769017787038*r**26
            -75706092547807830*r**28-7858406703550030*r**30-1583941000608997*r**32
            +60068925325764*r**34+8617351587653*r**36+464680208960*r**38)-4*Q2**6*(
            -160609409675+2666930900959*r**2+16405071425734*r**4-58144872282731*r**6
            -305474867566706*r**8-4609043545031492*r**10-18054359748036784*r**12-137515055784193084*r**14
            -334065427498324894*r**16-472417155169294094*r**18-320829134767892156*r**20
            -58210647103443434*r**22+143322233321110316*r**24+170923537181066156*r**26
            +25326631086391856*r**28+18515002907612788*r**30-1282502379580991*r**32
            -126895889110841*r**34-39426077888906*r**36-4364201896931*r**38+85301844910*r**40)
            +12*Q2**5*(10279647455-390118206948*r**2+921912219750*r**4+59163015732025*r**6
            +163358312898030*r**8-145524560364222*r**10+1525280238061744*r**12-9124485160043400*r**14
            -13646331440584050*r**16-86144726725333080*r**18-124402319831710284*r**20
            -60603947283760134*r**22-46922449353993100*r**24-5969634952179300*r**26
            +15957472268494320*r**28-18516419570739136*r**30-1959685983839397*r**32
            -686880082450500*r**34-122492188389050*r**36-3884085628395*r**38-199356592938*r**40
            +28685960610*r**42)-6*Q2**4*(35067012275-953641880929*r**2-817817196490*r**4
            +99909550128550*r**6+163380171177775*r**8+589104346775815*r**10+7814368073907916*r**12
            +38147721134111320*r**14+87631616345227150*r**16-120779989785061650*r**18
            -312891487158301620*r**20+9966561615468276*r**22+231420788986664030*r**24
            +54333052079866550*r**26+12448523952128600*r**28+23593763254515320*r**30
            -19123192785890209*r**32-7141547660088685*r**34-397468679287250*r**36
            -100993151167850*r**38+1021031418835*r**40+525665345571*r**42+8237126700*r**44)
            -9*Q2**3*(-4148279615+96077700474*r**2+321008655219*r**4-6132085030580*r**6
            -10094096909925*r**8-408755233562970*r**10-752180902798791*r**12-9797425766586156*r**14
            +22251316459196250*r**16+191067336137067700*r**18+334245432952335150*r**20
            +355874911274548104*r**22+142047523003651654*r**24-42778934867594820*r**26
            -39804645820086750*r**28-22310598285340680*r**30+7347336442153269*r**32
            -4801449568557966*r**34+1589596988984335*r**36-83604270882900*r**38-7603052654385*r**40
            -1070772674306*r**42-166061290251*r**44+4187957940*r**46)+54*(-1+r**2)**2*(30957287
            -1295980513*r**2+4749696247*r**4+265142848527*r**6-1157039874393*r**8
            -8518915886523*r**10-47064143075323*r**12-612633578756763*r**14-3134530859549508*r**16
            -9306638815422378*r**18-4921816860442778*r**20+27291999936546422*r**22
            -1539161759198818*r**24-19682537072967638*r**26+6782095545183242*r**28
            +3989946248946602*r**30-1233917372981073*r**32+350459463464187*r**34+36852956154067*r**36
            -11487016213653*r**38-442556640213*r**40-98574903263*r**42-3649911103*r**44
            +411730177*r**46+2277182*r**48)+18*Q2**2*(1409987860-54106204157*r**2
            +161880757174*r**4+8700114072463*r**6-19161035068460*r**8-184661628557195*r**10
            +396626320996038*r**12-3032112162926271*r**14-9526852102341612*r**16-58873249064105330*r**18
            -107772677983658900*r**20-29359436347692122*r**22+34164335464133944*r**24
            +49987850667652858*r**26+63701575318834300*r**28+7330171684083570*r**30
            -22234901811273492*r**32+13087251940708479*r**34-1967778118464482*r**36
            -184887590420645*r**38-37085200708460*r**40-7676787888767*r**42-268434685826*r**44
            -1690044227*r**46+1006813260*r**48)-27*Q2*(462727939-18423017892*r**2
            +69709150598*r**4+3096087309168*r**6-12881204086972*r**8-63248639234272*r**10
            -51464029479982*r**12-3166705673618992*r**14-16476673794678897*r**16-57531923225858212*r**18
            -35603852433760452*r**20+103922708316758048*r**22+59742142899849888*r**24
            -63513908005276192*r**26-67614047766381532*r**28+48433074478346848*r**30
            +25336668720919793*r**32-14206785782467692*r**34+4483312653589278*r**36
            +59412675263088*r**38-118319754665572*r**40-6031906670592*r**42-1650998201302*r**44
            -59047965232*r**46+4383104253*r**48+106344884*r**50))-4608*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(2848358912*Q2**26-352*Q2**25*(120313351
            +124314991*r**2)+4*Q2**24*(69707899625+151021294994*r**2+73015123625*r**4)
            -2*Q2**23*(531096513805+1817868730242*r**2+1865010945117*r**4+540923302120*r**6)
            +4*Q2**22*(636484802005+3107100827569*r**2+4918928507817*r**4+3176754507859*r**6
            +568416217030*r**8)-4*Q2**21*(953400376430+6466225040396*r**2+13207758024431*r**4
            +13150626979796*r**6+6023639062661*r**8+501986602370*r**10)+Q2**20*(2952220479610
            +30720291931026*r**2+57794514777120*r**4+51437490711340*r**6+44389323943110*r**8
            +16430491436106*r**10-2297236506200*r**12)+Q2**19*(706228111225-9792880410854*r**2
            +74656734391215*r**4+345388638175600*r**6+394172089009075*r**8+148188629548890*r**10
            +33930078985021*r**12+8561786101300*r**14)-2*Q2**18*(2277280886380+15929760477907*r**2
            +184774375277872*r**4+781763553988255*r**6+1277137173239200*r**8+908662080443665*r**10
            +265526430832072*r**12+49744486720957*r**14+3943062050620*r**16)+Q2**17*(4541402971545
            +60437897986596*r**2+590313267833478*r**4+3034831459901276*r**6+6517869557003160*r**8
            +6868307459079960*r**10+3427270815650066*r**12+641408218131228*r**14+90937907160231*r**16
            -4165205658180*r**18)+2*Q2**16*(151455527355-24852559770207*r**2-225254433529662*r**4
            -1447352340446492*r**6-3572814366953762*r**8-4639793399607198*r**10-3530433203057132*r**12
            -1082182372985612*r**14+49123693411983*r**16+16872658166613*r**18+7693019104050*r**20)
            -4*Q2**15*(1423612226130-2944134710304*r**2-16703618460945*r**4-95573951076965*r**6
            +642349808814745*r**8+2905708908287767*r**10+3525560114537167*r**12+1862989166590105*r**14
            +946632193918885*r**16+313236027990945*r**18+40719625039026*r**20+2422732180020*r**22)
            +4*Q2**14*(1406645029550+6024092159364*r**2+45297158947845*r**4+565972319366900*r**6
            +4546255258527000*r**8+15837586626059040*r**10+25273215185443526*r**12
            +19503362767968240*r**14+7817778991621950*r**16+2408601972861500*r**18
            +335435923570245*r**20+33848124338364*r**22-1849550622100*r**24)+4*Q2**13*(91412884985
            -10617497895976*r**2-60496662095991*r**4-681753661538245*r**6-5890000797766225*r**8
            -25219297881628380*r**10-52577179842049714*r**12-56798914243978114*r**14
            -30882967172429385*r**16-8185006404258700*r**18-1821804752982775*r**20
            +27630804245559*r**22+8410695158849*r**24+3495744331040*r**26)-4*Q2**12*(1303044435595
            -8723042457389*r**2-70150544165027*r**4-459876959715764*r**6-3420775744730900*r**8
            -17919691170109535*r**10-44303889121146446*r**12-59647943671632368*r**14
            -44307233698389281*r**16-12023162577321035*r**18+1604294950491925*r**20
            +753104934803476*r**22+356973769649098*r**24+37087820369671*r**26+978163075420*r**28)
            -2*Q2**11*(-1637924921035-830634724998*r**2+93957599356017*r**4+668774503517222*r**6
            +1433598137009007*r**8+2884954917346656*r**10-23317304877876457*r**12
            -95410648443054072*r**14-129325810115779077*r**16-97620456536376862*r**18
            -64567255781626329*r**20-23844025707632898*r**22-5219212980089983*r**24
            -520344991390428*r**26-45662179187343*r**28+3296694612020*r**30)+4*Q2**10*(427537187480
            -9597635734621*r**2-25636480930665*r**4+236957030578295*r**6+66219709300670*r**8
            -6500924345877573*r**10-59554297877374471*r**12-195057833456042785*r**14
            -319300698979785120*r**16-273486622301948695*r**18-139831943545616071*r**20
            -56048824191913083*r**22-9632510261614090*r**24-1803404776954855*r**26
            +63329286587895*r**28+8382327524549*r**30+1444477633940*r**32)+2*Q2**9*(
            -1488076724225+16986501045748*r**2+130116386936860*r**4+76145246715250*r**6
            +825361988585950*r**8+11973869310040780*r**10+109899829569599752*r**12
            +388497378173607310*r**14+804021380104719400*r**16+926210307218714800*r**18
            +546352650683974060*r**20+181779542342943502*r**22+58300456668011530*r**24
            -3826675597483700*r**26-733844731446800*r**28-380689298458190*r**30-37072307938127*r**32
            +113864253700*r**34)-4*Q2**8*(-138717205960-680008445859*r**2+28084879584726*r**4
            +334690111997450*r**6+1622241676438875*r**8+6995390150053980*r**10+30823665801737689*r**12
            +80418108760449294*r**14+161799259415073855*r**16+214640273973670250*r**18
            +126476145050288025*r**20-41557782407642106*r**22-65819613203976911*r**24
            -18969811556112540*r**26-7855936824842325*r**28-1406587351397470*r**30
            -80508995148099*r**32-6632515881159*r**34+606449966285*r**36)+2*Q2**7*(549644758085
            -11294707872502*r**2-30637038485361*r**4+685036851711158*r**6+3335965716262670*r**8
            +16120724242310070*r**10+51281133586055542*r**12+178173238883896486*r**14
            +305040866049278352*r**16+154770502142375450*r**18-201435067774304500*r**20
            -496101728312835918*r**22-540708811369878014*r**24-248567769017787038*r**26
            -75706092547807830*r**28-7858406703550030*r**30-1583941000608997*r**32
            +60068925325764*r**34+8617351587653*r**36+464680208960*r**38)+4*Q2**6*(
            -160609409675+2666930900959*r**2+16405071425734*r**4-58144872282731*r**6
            -305474867566706*r**8-4609043545031492*r**10-18054359748036784*r**12-137515055784193084*r**14
            -334065427498324894*r**16-472417155169294094*r**18-320829134767892156*r**20
            -58210647103443434*r**22+143322233321110316*r**24+170923537181066156*r**26
            +25326631086391856*r**28+18515002907612788*r**30-1282502379580991*r**32
            -126895889110841*r**34-39426077888906*r**36-4364201896931*r**38+85301844910*r**40)
            -12*Q2**5*(10279647455-390118206948*r**2+921912219750*r**4+59163015732025*r**6
            +163358312898030*r**8-145524560364222*r**10+1525280238061744*r**12-9124485160043400*r**14
            -13646331440584050*r**16-86144726725333080*r**18-124402319831710284*r**20
            -60603947283760134*r**22-46922449353993100*r**24-5969634952179300*r**26
            +15957472268494320*r**28-18516419570739136*r**30-1959685983839397*r**32
            -686880082450500*r**34-122492188389050*r**36-3884085628395*r**38-199356592938*r**40
            +28685960610*r**42)+6*Q2**4*(35067012275-953641880929*r**2-817817196490*r**4
            +99909550128550*r**6+163380171177775*r**8+589104346775815*r**10+7814368073907916*r**12
            +38147721134111320*r**14+87631616345227150*r**16-120779989785061650*r**18
            -312891487158301620*r**20+9966561615468276*r**22+231420788986664030*r**24
            +54333052079866550*r**26+12448523952128600*r**28+23593763254515320*r**30
            -19123192785890209*r**32-7141547660088685*r**34-397468679287250*r**36
            -100993151167850*r**38+1021031418835*r**40+525665345571*r**42+8237126700*r**44)
            +9*Q2**3*(-4148279615+96077700474*r**2+321008655219*r**4-6132085030580*r**6
            -10094096909925*r**8-408755233562970*r**10-752180902798791*r**12-9797425766586156*r**14
            +22251316459196250*r**16+191067336137067700*r**18+334245432952335150*r**20
            +355874911274548104*r**22+142047523003651654*r**24-42778934867594820*r**26
            -39804645820086750*r**28-22310598285340680*r**30+7347336442153269*r**32
            -4801449568557966*r**34+1589596988984335*r**36-83604270882900*r**38-7603052654385*r**40
            -1070772674306*r**42-166061290251*r**44+4187957940*r**46)-54*(-1+r**2)**2*(30957287
            -1295980513*r**2+4749696247*r**4+265142848527*r**6-1157039874393*r**8
            -8518915886523*r**10-47064143075323*r**12-612633578756763*r**14-3134530859549508*r**16
            -9306638815422378*r**18-4921816860442778*r**20+27291999936546422*r**22
            -1539161759198818*r**24-19682537072967638*r**26+6782095545183242*r**28
            +3989946248946602*r**30-1233917372981073*r**32+350459463464187*r**34+36852956154067*r**36
            -11487016213653*r**38-442556640213*r**40-98574903263*r**42-3649911103*r**44
            +411730177*r**46+2277182*r**48)-18*Q2**2*(1409987860-54106204157*r**2
            +161880757174*r**4+8700114072463*r**6-19161035068460*r**8-184661628557195*r**10
            +396626320996038*r**12-3032112162926271*r**14-9526852102341612*r**16-58873249064105330*r**18
            -107772677983658900*r**20-29359436347692122*r**22+34164335464133944*r**24
            +49987850667652858*r**26+63701575318834300*r**28+7330171684083570*r**30
            -22234901811273492*r**32+13087251940708479*r**34-1967778118464482*r**36
            -184887590420645*r**38-37085200708460*r**40-7676787888767*r**42-268434685826*r**44
            -1690044227*r**46+1006813260*r**48)+27*Q2*(462727939-18423017892*r**2
            +69709150598*r**4+3096087309168*r**6-12881204086972*r**8-63248639234272*r**10
            -51464029479982*r**12-3166705673618992*r**14-16476673794678897*r**16-57531923225858212*r**18
            -35603852433760452*r**20+103922708316758048*r**22+59742142899849888*r**24
            -63513908005276192*r**26-67614047766381532*r**28+48433074478346848*r**30
            +25336668720919793*r**32-14206785782467692*r**34+4483312653589278*r**36
            +59412675263088*r**38-118319754665572*r**40-6031906670592*r**42-1650998201302*r**44
            -59047965232*r**46+4383104253*r**48+106344884*r**50))*sqrtq2)+logq2*(
            -384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*(37735536*Q2**25-6*Q2**24*(120156723+98052643*r**2)
            +24*Q2**23*(233657123+446296753*r**2+161260958*r**4)-4*Q2**22*(5955488616
            +18960741991*r**2+16347573240*r**4+3427520457*r**6)+Q2**21*(59831019654
            +280659078398*r**2+378969827830*r**4+206009726442*r**6+26027690892*r**8)
            -2*Q2**20*(41711328942+285861169883*r**2+446724346036*r**4+352174916086*r**6
            +152904823308*r**8+7237968909*r**10)-Q2**19*(-31843177917-506299285467*r**2
            +46283425660*r**4+1702074939010*r**6+896468820055*r**8+68008276293*r**10
            +47377560918*r**12)+6*Q2**18*(15218883967+63414139862*r**2+885544120612*r**4
            +2983444836365*r**6+3224670629535*r**8+1168785356512*r**10+182660545582*r**12
            +18896957197*r**14)-3*Q2**17*(46084518763+527331460023*r**2+4521047408335*r**4
            +17711929459221*r**6+27474115488055*r**8+18635717348173*r**10+4458020953573*r**12
            +573796448975*r**14+21617609746*r**16)+2*Q2**16*(-6914572533+875916344549*r**2
            +8173020758310*r**4+38905035356586*r**6+72944511766076*r**8+72184816997292*r**10
            +33532526028054*r**12+2966167033970*r**14+194593464501*r**16-56424235509*r**18)
            +4*Q2**15*(52283596749-123820075349*r**2-1939004702653*r**4-10996117415418*r**6
            -7227242197979*r**8+11062829730050*r**10+5127669300471*r**12+5068792481782*r**14
            +4828226093882*r**16+549298384431*r**18+53699729778*r**20)-4*Q2**14*(41702072562
            +242015992382*r**2+1536873374455*r**4+10176481595125*r**6+87762913392815*r**8
            +258210324694633*r**10+286474794588733*r**12+132205478998235*r**14+44432256418855*r**16
            +8924045782465*r**18+711047480292*r**20+16591580712*r**22)+4*Q2**13*(
            -18987775692+353125485988*r**2+3584436714583*r**4+25217133141550*r**6
            +165179166863360*r**8+582190408321672*r**10+920704717209322*r**12+672927242800472*r**14
            +212511157551280*r**16+55997678538580*r**18+3470648226143*r**20+71734690698*r**22
            -42299869812*r**24)+4*Q2**12*(46518740094-170487603221*r**2-2848901224975*r**4
            -22650327015837*r**6-125340589156640*r**8-528448203970309*r**10-1045123712581914*r**12
            -1113236002652270*r**14-533073423978058*r**16-47991943331295*r**18-10163552988071*r**20
            +6873437928779*r**22+595052072940*r**24+47346160233*r**26)-2*Q2**11*(23705163813
            +310923373891*r**2+22658874470*r**4-25226589558226*r**6-52242300875771*r**8
            -50324032715203*r**10+677131355500574*r**12+1579072803489940*r**14+1160425417138031*r**16
            +944705036523701*r**18+525242746230658*r**20+104383519497806*r**22+19180109566775*r**24
            +1025144199579*r**26+37259274*r**28)-4*Q2**10*(25069001361-339050405346*r**2
            -2355045373417*r**4+6474178735208*r**6-5741644186676*r**8-305302172359405*r**10
            -1961643872543164*r**12-4851075035444093*r**14-5407555543090003*r**16
            -2976489678871024*r**18-1390417335913277*r**20-319989466216966*r**22-62512612838362*r**24
            -2147614133137*r**26+33666809394*r**28+31345267947*r**30)+2*Q2**9*(39396726861
            -362618052519*r**2-3678514114065*r**4-2927910449985*r**6+318289727255*r**8
            -374114831225771*r**10-3525252829064361*r**12-11225160889643365*r**14
            -18026676084631655*r**16-13409318983379805*r**18-4434451364951491*r**20
            -2023395153157931*r**22-28451812780995*r**24-30199049014065*r**26+10295185759005*r**28
            +615106580721*r**30+35530846566*r**32)+2*Q2**8*(6293657661-219585131979*r**2
            -504324229074*r**4+28672897152390*r**6+74912147203820*r**8+153617110406284*r**10
            +1403170472716954*r**12+5008303437701234*r**14+9587279755975930*r**16
            +9808928666014090*r**18+1384084818305474*r**20-3462762227241206*r**22
            -493016110081196*r**24-491054885933580*r**26-59891239544010*r**28-9780498432834*r**30
            -336141071799*r**32+12040442241*r**34)-4*Q2**7*(9587534601-179694866489*r**2
            -1019574947445*r**4+16459901907282*r**6+60864570186915*r**8+145283371594004*r**10
            +522578622597989*r**12+2191001495649790*r**14+3132964703853353*r**16+870876684044030*r**18
            -1492874628567041*r**20-4753904484688786*r**22-3306919632654415*r**24
            -929312428145332*r**26-162090181518345*r**28-30891309617214*r**30-597749297414*r**32
            +27646575195*r**34+10123194522*r**36)+4*Q2**6*(2565752646-38322345643*r**2
            -316025119325*r**4+1546503918078*r**6+23515469350923*r**8+140945585587809*r**10
            +350967201680103*r**12+3113064574346245*r**14+6344334293287367*r**16+6517584272709507*r**18
            +2696990653007629*r**20-199210467859687*r**22-4279865455808535*r**24-435104481363693*r**26
            -602439365947563*r**28+44867731432791*r**30-6647392476673*r**32+1709929730740*r**34
            +70703100948*r**36+2232456333*r**38)+2*Q2**5*(4056288753-122029753883*r**2
            -409079056981*r**4+21751815657059*r**6+11115539347902*r**8-112086119039724*r**10
            +720042601750188*r**12-1121891644167964*r**14-1538317354175354*r**16-12556240196182682*r**18
            -6426943683124630*r**20-5766801181976222*r**22-5659742866009184*r**24
            +7327933735466916*r**26-3952064140714692*r**28+35078401077060*r**30-187939855771583*r**32
            -15520424954371*r**34-2406238810621*r**36-57283036653*r**38+4167858666*r**40)
            -2*Q2**4*(2734805214-82366676541*r**2-266166673930*r**4+15757140172760*r**6
            +1830981959660*r**8-10872188364471*r**10+934486054239864*r**12+2110115565384240*r**14
            +4896529000920700*r**16-11792337258361610*r**18-13359581600490716*r**20
            +14768869311199024*r**22+4117376138128360*r**24-5829116604235430*r**26
            +6519091177710840*r**28-2133215537635536*r**30-424128214337226*r**32-52407944321545*r**34
            -12268612667530*r**36-327775425640*r**38+3949225884*r**40+2605843629*r**42)
            +3*Q2**3*(28334439+688448129*r**2-11896890616*r**4-12857796390*r**6+2577141310195*r**8
            +23781553048749*r**10+10328710145454*r**12+564090853036504*r**14-1452772289295170*r**16
            -11968874601019710*r**18-11669643711261816*r**20-11611597242197156*r**22
            +1927290693255054*r**24+2592070891528610*r**26+506518599645060*r**28-511863093865896*r**30
            +544991286237659*r**32-183499550196931*r**34+19986851779200*r**36-1507469293670*r**38
            +259365846399*r**40+8599850289*r**42+42631614*r**44)+18*(-1+r**2)**2*(2154905
            -105449007*r**2+229219677*r**4+35347654017*r**6-247829806475*r**8-655590883695*r**10
            -1416588899927*r**12-50095450208663*r**14-141695277412158*r**16-420190133078750*r**18
            +43177114822730*r**20+1813819158928098*r**22-1636222313158398*r**24-148450483999478*r**26
            +680946464455050*r**28-250272385912870*r**30+53823935920613*r**32-523539571923*r**34
            -499038844263*r**36-47756531075*r**38-10290976695*r**40-746436027*r**42
            -10179443*r**44+1793757*r**46)+6*Q2**2*(153911151-6409252194*r**2+965162910*r**4
            +1558882862307*r**6-6063862804415*r**8-13749182894734*r**10+95880275097326*r**12
            -432284106168935*r**14-350199853476258*r**16-3477878786292780*r**18-3433464399294604*r**20
            +334894495931686*r**22+1227267391085770*r**24+2776328039041132*r**26+3629121809398180*r**28
            -4129964963686694*r**30+1854042064118051*r**32-326869408019250*r**34+20823839344782*r**36
            -7598951380985*r**38-345367962619*r**40-83036510494*r**42-1924792370*r**44
            +131783037*r**46)-9*Q2*(36915769-1689680387*r**2+3126018065*r**4+473409205167*r**6
            -2918241852983*r**8-3393232005261*r**10+18266676245383*r**12-332525949953815*r**14
            -638324359870168*r**16-3104953272746638*r**18+1339948450376794*r**20+4397162887122598*r**22
            +1991130215521330*r**24-6696544766654698*r**26-741810907955938*r**28+5336547089260994*r**30
            -2676022237413047*r**32+696766017945025*r**34-49503619763643*r**36-1267255563653*r**38
            -1094836380171*r**40-125377978297*r**42-14199115605*r**44-284092283*r**46
            +31215462*r**48))+384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(301884288*Q2**30
            -96*Q2**29*(65974539+54922499*r**2)+6*Q2**28*(9279378781+17655264682*r**2
            +6631140301*r**4)-8*Q2**27*(34289355579+108014847436*r**2+94039096047*r**4
            +20919655518*r**6)+4*Q2**26*(207192017703+960955285822*r**2+1337535946841*r**4
            +726329563860*r**6+101997398994*r**8)-2*Q2**25*(754441027485+5051032428154*r**2
            +9249363887602*r**4+7829991954020*r**6+3069562204521*r**8+233816721306*r**10)
            +2*Q2**24*(635014283985+7324902815635*r**2+13319108623286*r**4+8570784378714*r**6
            +5774968388283*r**8+2169707659335*r**10-148608645390*r**12)+Q2**23*(834345645345
            -4759265375380*r**2+28992996528931*r**4+162215236274770*r**6+189322201166915*r**8
            +68369486652616*r**10+11881528532865*r**12+1866383479170*r**14)-2*Q2**22*(1619244361395
            +12012162435725*r**2+101586223482920*r**4+420788640559647*r**6+672150079138796*r**8
            +457839769784375*r**10+121322562718132*r**12+17986477905285*r**14+1161588957165*r**16)
            +Q2**21*(2102108904015+47943281717900*r**2+402576322526534*r**4+1938089066102442*r**6
            +3964254509234304*r**8+3978929568597466*r**10+1861251630126378*r**12+307818943300246*r**14
            +32938486927425*r**16-481854011430*r**18)+2*Q2**20*(1521956641815-16458355680095*r**2
            -189252679301536*r**4-1157459336150448*r**6-2684905210684442*r**8-3205493022185974*r**10
            -2298095444777448*r**12-640859588523608*r**14+32474786661203*r**16+10550584093005*r**18
            +2294181831720*r**20)-Q2**19*(5949547223565+16995207149140*r**2-21066602055107*r**4
            -633939653670598*r**6+722967392169634*r**8+7801772629408648*r**10+9946477808149418*r**12
            +4811539585830148*r**14+2447265625862497*r**16+738675052410164*r**18+79141276973865*r**20
            +4259309979090*r**22)+2*Q2**18*(741142084755+26826799799625*r**2+202819246847818*r**4
            +1234690323309105*r**6+7686526577688435*r**8+27584048206515754*r**10+43914895183856052*r**12
            +32535835148504994*r**14+12019764499893505*r**16+3467598168984285*r**18
            +434506149389938*r**20+29177247530685*r**22-913365465495*r**24)+Q2**17*(5133970763355
            -39461320228920*r**2-496293100569060*r**4-4259279451776434*r**6-26154213153597017*r**8
            -108435656863513174*r**10-221570945376106480*r**12-232581608389489412*r**14
            -121010957994123607*r**16-30288726828335092*r**18-5948362949026860*r**20
            +59173968906486*r**22+36160370910165*r**24+6395616995010*r**26)-2*Q2**16*(2398501246965
            +6033157388040*r**2-74637675224097*r**4-1559106526475936*r**6-9895040771233277*r**8
            -48477717372442640*r**10-116252226675144447*r**12-152768555967965744*r**14
            -113526119586084341*r**16-32659463600584728*r**18+443256906250497*r**20
            +1269329053652016*r**22+568905447498237*r**24+46191636604800*r**26+1583241788895*r**28)
            +2*Q2**15*(-738983658915+25880550132620*r**2+149885391108099*r**4-278535816143478*r**6
            -1330212379935287*r**8-2093852736958376*r**10+34171570236032199*r**12
            +133153813613662902*r**14+162127633663702495*r**16+105033352998291996*r**18
            +70622830636202337*r**20+23952474606045302*r**22+5253019851777627*r**24
            +497152958225888*r**26+21448603136565*r**28-1669161172950*r**30)+4*Q2**14*(1123915546485
            -10029714879665*r**2-101106385583032*r**4-331994870037103*r**6-2119720494849986*r**8
            -20838030742586749*r**10-124044208725585364*r**12-382881466937752643*r**14
            -587626440165082972*r**16-459632133583628779*r**18-208387142265735824*r**20
            -77884263099025429*r**22-12949404111579622*r**24-2061551210981063*r**26
            +53959177398524*r**28+10053806882535*r**30+1135538749935*r**32)+2*Q2**13*(
            -663726625605-4872307548820*r**2+54303707676098*r**4+1150922469916050*r**6
            +5549217008191850*r**8+46296899012704850*r**10+301009035720791514*r**12
            +1136776623542532914*r**14+2251498732751684600*r**16+2395668574559750250*r**18
            +1316467494519719894*r**20+397167712794911894*r**22+101521053208207350*r**24
            -205934282509450*r**26-1059299836683250*r**28-483445415370842*r**30-28568243129235*r**32
            -183212534430*r**34)-2*Q2**12*(1028297886315-19825559103920*r**2-93678813329615*r**4
            +1124525908072872*r**6+5483881143998436*r**8+28771746709171784*r**10+159272435998784268*r**12
            +721061148796237992*r**14+1664262737482954466*r**16+2186269992429592824*r**18
            +1571137631838421974*r**20+327346197450893624*r**22-98859312681437148*r**24
            -62055136231310280*r**26-22898869959302164*r**28-4300280737441800*r**30
            -265911769959253*r**32-6192791774280*r**34+1253560066305*r**36)+2*Q2**11*(793760840415
            -9735043076020*r**2-89328711635213*r**4+176778928218366*r**6+3187253050306052*r**8
            +18576318850555432*r**10+22735443367359220*r**12-15962265472554736*r**14
            -660044706981450206*r**16-2016653131334369840*r**18-2568303324263277574*r**20
            -2080101445584032228*r**22-1519836431902323308*r**24-540343527665782984*r**26
            -161188448860665596*r**28-17219876460050592*r**30-2617920287563801*r**32
            +121508338593028*r**34+11439457803675*r**36+694835380470*r**38)+4*Q2**10*(84414157710
            -3522430171625*r**2+2974808166907*r**4+512390699566361*r**6+403491050639899*r**8
            -6250627868617724*r**10+5239974583804428*r**12+162835283967558940*r**14
            +1133899658049587968*r**16+3321245789130722034*r**18+5188538851612953370*r**20
            +4373249654699695966*r**22+2391319083092997282*r**24+1114560923908941652*r**26
            +195493326230347132*r**28+48924062539815404*r**30-1085010794788214*r**32
            -389479423046369*r**34-106581561965341*r**36-4669058269695*r**38+137422604715*r**40)
            -4*Q2**9*(196331822805-4595120677295*r**2-15334354091443*r**4+519427572933483*r**6
            +1231324344576306*r**8+2153648997343736*r**10+17346288906968316*r**12
            +141600092718569748*r**14+912679272784922962*r**16+2945584037019885774*r**18
            +5780918653098221918*r**20+6440540236331040538*r**22+3536852102885996028*r**24
            +1171644462581102532*r**26+450204322703811004*r**28-45335298885851964*r**30
            -16197541485307839*r**32-5007771891307783*r**34-950104235344227*r**36
            -30978087196509*r**38-123218910870*r**40+196210529580*r**42)+2*Q2**8*(73796171415
            -897136258205*r**2-16823936411152*r**4-171758834830*r**6+1652886664279165*r**8
            +21862444721842331*r**10+75524662894981836*r**12+290770307651351960*r**14
            +961057481396396230*r**16+2797886684439941110*r**18+5266272858047479696*r**20
            +6341289665779151948*r**22+3232763220917983546*r**24-2295402532069902370*r**26
            -2459397512053248440*r**28-975249353186739240*r**30-289664197775560109*r**32
            -84020439423474169*r**34-4942237244469280*r**36-787087943083310*r**38
            +52622506603673*r**40+3278211580455*r**42+48127033740*r**44)+Q2**7*(202288875765
            -6870310258180*r**2+4606091553335*r**4+1174505377248186*r**6-1969968560197837*r**8
            -36178910778748792*r**10-119700424594162007*r**12-597493269782981246*r**14
            -1693322454919087070*r**16-6835493149650502488*r**18-11162585950106568586*r**20
            -9005645232923925100*r**22-1247268079845335338*r**24+9206430798709111552*r**26
            +14494942602275903362*r**28+6140896910500559348*r**30+2935258465124931161*r**32
            +256781534107780604*r**34+80529456410694627*r**36-1110238043709262*r**38
            -591959822686585*r**40-91249018845224*r**42-3298366880955*r**44+209242670730*r**46)
            +2*Q2**6*(-50997537495+1624627494015*r**2+1738758611032*r**4-280759656508899*r**6
            +302654428506392*r**8-1364545115267191*r**10+10248418316051388*r**12+162925763772120883*r**14
            +492737888791353509*r**16+3517385596697514246*r**18+7038459332239595680*r**20
            +10394686634395284978*r**22+7761014708244543816*r**24+3976188191229477954*r**26
            -2017872765210022328*r**28-4759715984237927082*r**30+135672203241374195*r**32
            -544990031533357109*r**34+40142420179119336*r**36+11920711746901025*r**38
            +1605071585185088*r**40+405328625784549*r**42+4491153561628*r**44-174694052025*r**46
            -46507167585*r**48)-3*Q2**5*(6064588071-302774899860*r**2+2001849186014*r**4
            +70260078855162*r**6-466832283982092*r**8-7083429863956150*r**10-2614864249763622*r**12
            +3015411127058766*r**14-166876274609881149*r**16+37442101134272106*r**18
            +131983191754491948*r**20+4254118461170331716*r**22+5577649112567143968*r**24
            +821335350781025220*r**26+2262349391965397684*r**28+468099354549166236*r**30
            -1548286646285830851*r**32+952141771008111360*r**34+223149467944834134*r**36
            +37816267458170082*r**38+13737964441412204*r**40+537380877556242*r**42
            +76965147066642*r**44-6233777087242*r**46-320758751655*r**48+6418605066*r**50)
            +6*Q2**4*(4176945999-182534987541*r**2+712440737342*r**4+41897014055928*r**6
            -267030151010294*r**8-1642004771068222*r**10+390838032053028*r**12-16862055665810048*r**14
            -109087864602526707*r**16-442637100270981879*r**18-285533814539335302*r**20
            +2347061290861131728*r**22+4003614228728192892*r**24+1173775592529608428*r**26
            -2053883078228990824*r**28-483636354309541152*r**30-197263148785178567*r**32
            -217831576440428883*r**34+44706576817700178*r**36+128059894907865336*r**38
            +5708632651637978*r**40+2134868862626418*r**42+63653532605572*r**44-11504415345952*r**46
            -1456880153589*r**48-53330756801*r**50+3842954934*r**52)-9*Q2**3*(397492129
            -16448012732*r**2+28032224585*r**4+3830500572130*r**6-27142173641090*r**8
            +213658974663304*r**10-1178228596776634*r**12-7437711928399316*r**14+1650571173374955*r**16
            -122019785008824340*r**18+278949387127132779*r**20+1114493856515258806*r**22
            +1992115273860024404*r**24+2611252846206565680*r**26+1364362584120585060*r**28
            +385354543736670024*r**30-18388962193502169*r**32-703785685837103716*r**34
            +345922157938194255*r**36-110848118059881490*r**38+18770003385346254*r**40
            -415981520307384*r**42-397589168509066*r**44-10853677412020*r**46-7577782002515*r**48
            +12071934260*r**50+5327547613*r**52+354786234*r**54)-54*(-1+r**2)**2*(2154905
            -133462772*r**2+1367327028*r**4+43523561232*r**6-720744554821*r**8-1274732766476*r**10
            +30051079748764*r**12+65430349746204*r**14+736598127069829*r**16+6993423548688584*r**18
            +26236807492710504*r**20+62585965263063364*r**22+17293477748575879*r**24
            -174112381525418136*r**26-17551149212453576*r**28+160105613717979544*r**30
            -31117491706426581*r**32-46919401210260516*r**34+12221985052839364*r**36
            -1815515575891816*r**38-838934540005471*r**40+119816887153124*r**42+12242789731564*r**44
            +1313970760204*r**46+167717317879*r**48+318345744*r**50-807829024*r**52
            -33498284*r**54+1793757*r**56)-18*Q2**2*(132362101-7473666261*r**2+66378580898*r**4
            +2046871636115*r**6-24740920708851*r**8-143633504295238*r**10+1084611492439116*r**12
            +1184177807553266*r**14-4398696585954823*r**16+76541152712997929*r**18
            +201216650662437622*r**20+798138747150556281*r**22+706402945289648721*r**24
            -294922636125976388*r**26-375674605264091256*r**28+413884240092631852*r**30
            -693052038265200129*r**32-565583670227901939*r**34+500092903533779502*r**36
            -187663294708043371*r**38+11215190339205127*r**40+4576840016102506*r**42
            +371534459117036*r**44+189215069192002*r**46+8364852489299*r**48+1110840542911*r**50
            -67005909638*r**52-3637369857*r**54+113845467*r**56)+27*Q2*(36915769
            -2186824624*r**2+21672724260*r**4+623519398706*r**6-9569245202911*r**8
            -19365922541314*r**10+372931298027056*r**12+128807545377036*r**14+2551797259381781*r**16
            +46420824677082356*r**18+154374436656768116*r**20+416914276377783766*r**22
            +27623043171500381*r**24-764880193184899734*r**26+77671054397399936*r**28
            -196670956871294904*r**30+779192151347536731*r**32-122787087596142584*r**34
            -454430056843669044*r**36+185583438063135166*r**38-34729551791795629*r**40
            -6729740264393614*r**42+1653433448101456*r**44+106339784006636*r**46+29541223219991*r**48
            +2273731204212*r**50+94283580060*r**52-14025351174*r**54-704243345*r**56
            +31215462*r**58))*sqrtq2))/(5670000*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2+5670000*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2
            +logq2**8*(548549148672000000*r**36*(1+r**2)**2*(1-Q2+r**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**3+548549148672000000*r**36*(1+r**2)**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2*(-816480000*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4
            -Q2**3*(1+r**2)-2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4
            +r**6)+4*(1-9*r**2-44*r**4-9*r**6+r**8))-816480000*(-Q2+(-1+r)**2)**3*r**8*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4-Q2**3*(1+r**2)
            -2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4+r**6)+4*(1-9*r**2
            -44*r**4-9*r**6+r**8))*sqrtq2)+logq2**7*(-12189981081600000*r**32*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))-12189981081600000*r**32*(1+r**2)*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))*sqrtq2)+logq2**3*(-195955200000*(-Q2+(-1
            +r)**2)**3*r**16*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8
            +68*Q2**7*(1+r**2)-Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2
            +683*r**4+169*r**6)+2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)
            +6*Q2**3*(31+230*r**2+159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(
            -131+1184*r**2+6523*r**4+8368*r**6+6523*r**8+1184*r**10-131*r**12)
            -9*Q2*(13+5*r**2-1493*r**4-5245*r**6-5245*r**8-1493*r**10+5*r**12
            +13*r**14)+36*(4-67*r**2-28*r**4+2331*r**6+5600*r**8+2331*r**10-28*r**12
            -67*r**14+4*r**16))-195955200000*(-Q2+(-1+r)**2)**3*r**16*(1-Q2+r**2)*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)
            -Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2+683*r**4+169*r**6)
            +2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)+6*Q2**3*(31+230*r**2
            +159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4
            +8368*r**6+6523*r**8+1184*r**10-131*r**12)-9*Q2*(13+5*r**2-1493*r**4
            -5245*r**6-5245*r**8-1493*r**10+5*r**12+13*r**14)+36*(4-67*r**2-28*r**4
            +2331*r**6+5600*r**8+2331*r**10-28*r**12-67*r**14+4*r**16))*sqrtq2)
            +logq2**2*(48988800000*(-Q2+(-1+r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1
            +r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8-4*Q2**7*(1+r**2)-Q2**6*(57
            +50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4+5*r**6)+Q2**4*(85-226*r**2
            -1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1-54*r**2-143*r**4-143*r**6
            -54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4+3168*r**6+2871*r**8
            +468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4-2833*r**6-2833*r**8
            -565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4+4368*r**6+11718*r**8
            +4368*r**10-56*r**12-96*r**14+5*r**16))+48988800000*(-Q2+(-1+r)**2)**3*r**12*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8-4*Q2**7*(1+r**2)
            -Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4+5*r**6)+Q2**4*(85
            -226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1-54*r**2-143*r**4
            -143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4+3168*r**6+2871*r**8
            +468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4-2833*r**6-2833*r**8
            -565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4+4368*r**6+11718*r**8
            +4368*r**10-56*r**12-96*r**14+5*r**16))*sqrtq2)+logq2**5*(-16930529280000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219+310*r**2
            +219*r**4)-Q2**5*(977+2179*r**2+2179*r**4+977*r**6)+Q2**4*(590-2090*r**2
            -6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4-2073*r**6
            +10*r**8+243*r**10)+Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6+41127*r**8
            +8076*r**10-879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6+67125*r**8
            +31341*r**10+3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4+12789*r**6
            +25830*r**8+12789*r**10+28*r**12-573*r**14+41*r**16))-16930529280000*r**24*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219
            +310*r**2+219*r**4)-Q2**5*(977+2179*r**2+2179*r**4+977*r**6)+Q2**4*(590
            -2090*r**2-6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4
            -2073*r**6+10*r**8+243*r**10)+Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6
            +41127*r**8+8076*r**10-879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6
            +67125*r**8+31341*r**10+3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4
            +12789*r**6+25830*r**8+12789*r**10+28*r**12-573*r**14+41*r**16))*sqrtq2)
            +logq2**4*(3527193600000*r**20*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(32*Q2**8
            +104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)-24*Q2**5*(13+31*r**2
            +31*r**4+13*r**6)+Q2**4*(415-1180*r**2-4598*r**4-1180*r**6+415*r**8)
            +4*Q2**3*(102+155*r**2-677*r**4-677*r**6+155*r**8+102*r**10)+Q2**2*(
            -389+3526*r**2+18377*r**4+25852*r**6+18377*r**8+3526*r**10-389*r**12)
            -12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8-1133*r**10-55*r**12
            +18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6+53690*r**8+24556*r**10
            -168*r**12-892*r**14+59*r**16))+3527193600000*r**20*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)
            -24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415-1180*r**2-4598*r**4
            -1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4-677*r**6+155*r**8
            +102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6+18377*r**8
            +3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8
            -1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6
            +53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))*sqrtq2)+logq2**6*(67722117120000*r**28*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(16*Q2**8+332*Q2**7*(1
            +r**2)+Q2**6*(153+370*r**2+153*r**4)-Q2**5*(2011+4817*r**2+4817*r**4
            +2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4-2410*r**6+295*r**8)+6*Q2**3*(559
            -310*r**2-4869*r**4-4869*r**6-310*r**8+559*r**10)-3*Q2**2*(479-4496*r**2
            -22867*r**4-35272*r**6-22867*r**8-4496*r**10+479*r**12)-9*Q2*(187
            -865*r**2-5807*r**4-10315*r**6-10315*r**8-5807*r**10-865*r**12+187*r**14)
            +9*(109-1432*r**2+392*r**4+26376*r**6+49910*r**8+26376*r**10+392*r**12
            -1432*r**14+109*r**16))+67722117120000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(16*Q2**8+332*Q2**7*(1+r**2)+Q2**6*(153+370*r**2+153*r**4)
            -Q2**5*(2011+4817*r**2+4817*r**4+2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4
            -2410*r**6+295*r**8)+6*Q2**3*(559-310*r**2-4869*r**4-4869*r**6-310*r**8
            +559*r**10)-3*Q2**2*(479-4496*r**2-22867*r**4-35272*r**6-22867*r**8
            -4496*r**10+479*r**12)-9*Q2*(187-865*r**2-5807*r**4-10315*r**6-10315*r**8
            -5807*r**10-865*r**12+187*r**14)+9*(109-1432*r**2+392*r**4+26376*r**6
            +49910*r**8+26376*r**10+392*r**12-1432*r**14+109*r**16))*sqrtq2))+((
            -64*(Q2-(-1+r)**2)**6*r**6*(1-Q2+r**2)*(Q2-(1+r)**2)**6*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))**2*(520*Q2**22+12112*Q2**21*(1+r**2)
            -Q2**20*(226505+2264418*r**2+226505*r**4)+32*Q2**19*(47368+939919*r**2
            +939919*r**4+47368*r**6)-2*Q2**18*(2785037+84443344*r**2+179647574*r**4
            +84443344*r**6+2785037*r**8)+4*Q2**17*(3098369+124434575*r**2+431690036*r**4
            +431690036*r**6+124434575*r**8+3098369*r**10)-Q2**16*(16190437+731531166*r**2
            +3947035095*r**4+5895367804*r**6+3947035095*r**8+731531166*r**10+16190437*r**12)
            +8*Q2**15*(1109242+11688985*r**2+367378989*r**4+410253004*r**6+410253004*r**8
            +367378989*r**10+11688985*r**12+1109242*r**14)+8*Q2**14*(729109+194161212*r**2
            +752702872*r**4+3476415142*r**6+6352723434*r**8+3476415142*r**10+752702872*r**12
            +194161212*r**14+729109*r**16)-8*Q2**13*(1194216+306786847*r**2+2091773677*r**4
            +9194584111*r**6+23078885821*r**8+23078885821*r**10+9194584111*r**12
            +2091773677*r**14+306786847*r**16+1194216*r**18)+Q2**12*(-6036498+751383100*r**2
            +14162284678*r**4+58808066720*r**6+220182028124*r**8+307325076712*r**10
            +220182028124*r**12+58808066720*r**14+14162284678*r**16+751383100*r**18
            -6036498*r**20)+8*Q2**11*(2652858+261877577*r**2+252765285*r**4+4511836286*r**6
            +5212708360*r**8+20973386930*r**10+20973386930*r**12+5212708360*r**14
            +4511836286*r**16+252765285*r**18+261877577*r**20+2652858*r**22)-4*Q2**10*(3591107
            +633658688*r**2+3328295894*r**4+23904055964*r**6+84855293693*r**8+257131355012*r**10
            +410570049812*r**12+257131355012*r**14+84855293693*r**16+23904055964*r**18
            +3328295894*r**20+633658688*r**22+3591107*r**24)-8*Q2**9*(655759-21721648*r**2
            -1379932703*r**4-5896955395*r**6-34032315442*r**8-115854274013*r**10
            -294468483022*r**12-294468483022*r**14-115854274013*r**16-34032315442*r**18
            -5896955395*r**20-1379932703*r**22-21721648*r**24+655759*r**26)+2*Q2**8*(6492839
            +843090458*r**2-2441758087*r**4+7085599700*r**6-12577814621*r**8+83376174806*r**10
            -361275601891*r**12-564352182728*r**14-361275601891*r**16+83376174806*r**18
            -12577814621*r**20+7085599700*r**22-2441758087*r**24+843090458*r**26
            +6492839*r**28)-8*Q2**7*(617314+146221725*r**2-83197839*r**4+1345149664*r**6
            +5410324636*r**8+77814653767*r**10+74233928011*r**12+141456739522*r**14
            +141456739522*r**16+74233928011*r**18+77814653767*r**20+5410324636*r**22
            +1345149664*r**24-83197839*r**26+146221725*r**28+617314*r**30)-16*Q2**6*(222890
            +9729602*r**2-224366250*r**4+380092619*r**6-2221226510*r**8-16722560029*r**10
            -11915541758*r**12-35128100480*r**14-61622456968*r**16-35128100480*r**18
            -11915541758*r**20-16722560029*r**22-2221226510*r**24+380092619*r**26
            -224366250*r**28+9729602*r**30+222890*r**32)+8*Q2**5*(502946+68953917*r**2
            -683702383*r**4-408261553*r**6-11115181219*r**8-26262596473*r**10-38220723187*r**12
            -28826250605*r**14+59146362557*r**16+59146362557*r**18-28826250605*r**20
            -38220723187*r**22-26262596473*r**24-11115181219*r**26-408261553*r**28
            -683702383*r**30+68953917*r**32+502946*r**34)+Q2**4*(-905701-211716538*r**2
            +2613590867*r**4+10970020928*r**6+84202554492*r**8+328309699560*r**10
            +694498629388*r**12+1381721718208*r**14-1348388950262*r**16+1985130078116*r**18
            -1348388950262*r**20+1381721718208*r**22+694498629388*r**24+328309699560*r**26
            +84202554492*r**28+10970020928*r**30+2613590867*r**32-211716538*r**34
            -905701*r**36)-8*Q2**3*(79922+6658369*r**2-103659811*r**4+577759978*r**6
            +789540152*r**8+11968491768*r**10+39373851520*r**12+59656374536*r**14
            -240301075292*r**16+220130922858*r**18+220130922858*r**20-240301075292*r**22
            +59656374536*r**24+39373851520*r**26+11968491768*r**28+789540152*r**30
            +577759978*r**32-103659811*r**34+6658369*r**36+79922*r**38)+3*(-1+r**2)**2*(4893
            +840104*r**2-26928774*r**4-108119736*r**6-1175615959*r**8-9485606592*r**10
            +22274390808*r**12-241075071488*r**14+1004456013498*r**16-2806453793328*r**18
            +4010933053148*r**20-2806453793328*r**22+1004456013498*r**24-241075071488*r**26
            +22274390808*r**28-9485606592*r**30-1175615959*r**32-108119736*r**34
            -26928774*r**36+840104*r**38+4893*r**40)+2*Q2**2*(250507+34361200*r**2
            -718612142*r**4-424830776*r**6-15589997393*r**8-68731480376*r**10+97800377432*r**12
            -897971708392*r**14+1416033754310*r**16-379198403864*r**18-1478198621012*r**20
            -379198403864*r**22+1416033754310*r**24-897971708392*r**26+97800377432*r**28
            -68731480376*r**30-15589997393*r**32-424830776*r**34-718612142*r**36
            +34361200*r**38+250507*r**40)-12*Q2*(11577+1815765*r**2-49202370*r**4
            -78057410*r**6-1444485615*r**8-8842691451*r**10+24813154248*r**12-191096633400*r**14
            +661499533410*r**16-1298047945990*r**18+787117141236*r**20+787117141236*r**22
            -1298047945990*r**24+661499533410*r**26-191096633400*r**28+24813154248*r**30
            -8842691451*r**32-1444485615*r**34-78057410*r**36-49202370*r**38+1815765*r**40
            +11577*r**42))-64*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(520*Q2**22+12112*Q2**21*(1
            +r**2)-Q2**20*(226505+2264418*r**2+226505*r**4)+32*Q2**19*(47368+939919*r**2
            +939919*r**4+47368*r**6)-2*Q2**18*(2785037+84443344*r**2+179647574*r**4
            +84443344*r**6+2785037*r**8)+4*Q2**17*(3098369+124434575*r**2+431690036*r**4
            +431690036*r**6+124434575*r**8+3098369*r**10)-Q2**16*(16190437+731531166*r**2
            +3947035095*r**4+5895367804*r**6+3947035095*r**8+731531166*r**10+16190437*r**12)
            +8*Q2**15*(1109242+11688985*r**2+367378989*r**4+410253004*r**6+410253004*r**8
            +367378989*r**10+11688985*r**12+1109242*r**14)+8*Q2**14*(729109+194161212*r**2
            +752702872*r**4+3476415142*r**6+6352723434*r**8+3476415142*r**10+752702872*r**12
            +194161212*r**14+729109*r**16)-8*Q2**13*(1194216+306786847*r**2+2091773677*r**4
            +9194584111*r**6+23078885821*r**8+23078885821*r**10+9194584111*r**12
            +2091773677*r**14+306786847*r**16+1194216*r**18)+Q2**12*(-6036498+751383100*r**2
            +14162284678*r**4+58808066720*r**6+220182028124*r**8+307325076712*r**10
            +220182028124*r**12+58808066720*r**14+14162284678*r**16+751383100*r**18
            -6036498*r**20)+8*Q2**11*(2652858+261877577*r**2+252765285*r**4+4511836286*r**6
            +5212708360*r**8+20973386930*r**10+20973386930*r**12+5212708360*r**14
            +4511836286*r**16+252765285*r**18+261877577*r**20+2652858*r**22)-4*Q2**10*(3591107
            +633658688*r**2+3328295894*r**4+23904055964*r**6+84855293693*r**8+257131355012*r**10
            +410570049812*r**12+257131355012*r**14+84855293693*r**16+23904055964*r**18
            +3328295894*r**20+633658688*r**22+3591107*r**24)-8*Q2**9*(655759-21721648*r**2
            -1379932703*r**4-5896955395*r**6-34032315442*r**8-115854274013*r**10
            -294468483022*r**12-294468483022*r**14-115854274013*r**16-34032315442*r**18
            -5896955395*r**20-1379932703*r**22-21721648*r**24+655759*r**26)+2*Q2**8*(6492839
            +843090458*r**2-2441758087*r**4+7085599700*r**6-12577814621*r**8+83376174806*r**10
            -361275601891*r**12-564352182728*r**14-361275601891*r**16+83376174806*r**18
            -12577814621*r**20+7085599700*r**22-2441758087*r**24+843090458*r**26
            +6492839*r**28)-8*Q2**7*(617314+146221725*r**2-83197839*r**4+1345149664*r**6
            +5410324636*r**8+77814653767*r**10+74233928011*r**12+141456739522*r**14
            +141456739522*r**16+74233928011*r**18+77814653767*r**20+5410324636*r**22
            +1345149664*r**24-83197839*r**26+146221725*r**28+617314*r**30)-16*Q2**6*(222890
            +9729602*r**2-224366250*r**4+380092619*r**6-2221226510*r**8-16722560029*r**10
            -11915541758*r**12-35128100480*r**14-61622456968*r**16-35128100480*r**18
            -11915541758*r**20-16722560029*r**22-2221226510*r**24+380092619*r**26
            -224366250*r**28+9729602*r**30+222890*r**32)+8*Q2**5*(502946+68953917*r**2
            -683702383*r**4-408261553*r**6-11115181219*r**8-26262596473*r**10-38220723187*r**12
            -28826250605*r**14+59146362557*r**16+59146362557*r**18-28826250605*r**20
            -38220723187*r**22-26262596473*r**24-11115181219*r**26-408261553*r**28
            -683702383*r**30+68953917*r**32+502946*r**34)+Q2**4*(-905701-211716538*r**2
            +2613590867*r**4+10970020928*r**6+84202554492*r**8+328309699560*r**10
            +694498629388*r**12+1381721718208*r**14-1348388950262*r**16+1985130078116*r**18
            -1348388950262*r**20+1381721718208*r**22+694498629388*r**24+328309699560*r**26
            +84202554492*r**28+10970020928*r**30+2613590867*r**32-211716538*r**34
            -905701*r**36)-8*Q2**3*(79922+6658369*r**2-103659811*r**4+577759978*r**6
            +789540152*r**8+11968491768*r**10+39373851520*r**12+59656374536*r**14
            -240301075292*r**16+220130922858*r**18+220130922858*r**20-240301075292*r**22
            +59656374536*r**24+39373851520*r**26+11968491768*r**28+789540152*r**30
            +577759978*r**32-103659811*r**34+6658369*r**36+79922*r**38)+3*(-1+r**2)**2*(4893
            +840104*r**2-26928774*r**4-108119736*r**6-1175615959*r**8-9485606592*r**10
            +22274390808*r**12-241075071488*r**14+1004456013498*r**16-2806453793328*r**18
            +4010933053148*r**20-2806453793328*r**22+1004456013498*r**24-241075071488*r**26
            +22274390808*r**28-9485606592*r**30-1175615959*r**32-108119736*r**34
            -26928774*r**36+840104*r**38+4893*r**40)+2*Q2**2*(250507+34361200*r**2
            -718612142*r**4-424830776*r**6-15589997393*r**8-68731480376*r**10+97800377432*r**12
            -897971708392*r**14+1416033754310*r**16-379198403864*r**18-1478198621012*r**20
            -379198403864*r**22+1416033754310*r**24-897971708392*r**26+97800377432*r**28
            -68731480376*r**30-15589997393*r**32-424830776*r**34-718612142*r**36
            +34361200*r**38+250507*r**40)-12*Q2*(11577+1815765*r**2-49202370*r**4
            -78057410*r**6-1444485615*r**8-8842691451*r**10+24813154248*r**12-191096633400*r**14
            +661499533410*r**16-1298047945990*r**18+787117141236*r**20+787117141236*r**22
            -1298047945990*r**24+661499533410*r**26-191096633400*r**28+24813154248*r**30
            -8842691451*r**32-1444485615*r**34-78057410*r**36-49202370*r**38+1815765*r**40
            +11577*r**42))*sqrtq2+logq2**8*(-81266540544000000*r**38*(-3+r**2)*(1+r**2)**2*(1
            -Q2+r**2)*(-1+3*r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3-81266540544000000*(Q2
            -(-1+r)**2)**2*r**38*(-3+r**2)*(1+r**2)**2*(-1+3*r**2)*(Q2-(1+r)**2)**2*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**7*(257989017600000*r**32*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-70*Q2**9*(1+r**2)+370*Q2**8*(1
            +r**2)**2-10*Q2**7*(30+181*r**2+181*r**4+30*r**6)-2*Q2**6*(959+622*r**2
            -450*r**4+622*r**6+959*r**8)+Q2**5*(5488+10957*r**2+6019*r**4+6019*r**6
            +10957*r**8+5488*r**10)-Q2**4*(4515+14264*r**2+10217*r**4+40*r**6+10217*r**8
            +14264*r**10+4515*r**12)+Q2**3*(-3115+51*r**2+429*r**4-2237*r**6-2237*r**8
            +429*r**10+51*r**12-3115*r**14)+6*(-1+r**2)**2*(267+423*r**2-682*r**4
            -31*r**6+3406*r**8-31*r**10-682*r**12+423*r**14+267*r**16)+Q2**2*(8785
            +11601*r**2+1606*r**4-2165*r**6+12426*r**8-2165*r**10+1606*r**12+11601*r**14
            +8785*r**16)-3*Q2*(2109+1765*r**2-4088*r**4-2476*r**6+16130*r**8+16130*r**10
            -2476*r**12-4088*r**14+1765*r**16+2109*r**18))+257989017600000*r**32*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(70*Q2**10*(1+r**2)-440*Q2**9*(1
            +r**2)**2+10*Q2**8*(67+292*r**2+292*r**4+67*r**6)+2*Q2**7*(809-433*r**2
            -2260*r**4-433*r**6+809*r**8)-7*Q2**6*(1058+2017*r**2+909*r**4+909*r**6
            +2017*r**8+1058*r**10)+Q2**5*(10003+30709*r**2+27193*r**4+12078*r**6
            +27193*r**8+30709*r**10+10003*r**12)-10*Q2**4*(140+1883*r**2+2491*r**4
            +802*r**6+802*r**8+2491*r**10+1883*r**12+140*r**14)-Q2**3*(11900+14665*r**2
            +1126*r**4-357*r**6+16900*r**8-357*r**10+1126*r**12+14665*r**14+11900*r**16)
            +6*(-1+r**2)**2*(267+690*r**2-259*r**4-713*r**6+3375*r**8+3375*r**10
            -713*r**12-259*r**14+690*r**16+267*r**18)+Q2**2*(15112+25681*r**2+943*r**4
            -7987*r**6+58651*r**8+58651*r**10-7987*r**12+943*r**14+25681*r**16
            +15112*r**18)-3*Q2*(2643+3652*r**2-4845*r**4-3052*r**6+19226*r**8
            +18512*r**10+19226*r**12-3052*r**14-4845*r**16+3652*r**18+2643*r**20))*sqrtq2)
            +logq2**6*(1433272320000*r**28*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1120*Q2**13*(1+r**2)-20160*Q2**12*(1+r**2)**2+60*Q2**11*(2109
            +6607*r**2+6607*r**4+2109*r**6)-15*Q2**8*(1+r**2)**2*(40336+194357*r**2
            +316506*r**4+194357*r**6+40336*r**8)-2*Q2**10*(196248+851619*r**2+1309846*r**4
            +851619*r**6+196248*r**8)+60*Q2**9*(10922+61823*r**2+130971*r**4+130971*r**6
            +61823*r**8+10922*r**10)+5*Q2**7*(107370+491433*r**2+1346369*r**4+2211676*r**6
            +2211676*r**8+1346369*r**10+491433*r**12+107370*r**14)-15*Q2**6*(75124
            +185927*r**2+259840*r**4+235545*r**6+180184*r**8+235545*r**10+259840*r**12
            +185927*r**14+75124*r**16)+6*Q2**5*(291137+935851*r**2+2025509*r**4
            +2823491*r**6+2188532*r**8+2188532*r**10+2823491*r**12+2025509*r**14
            +935851*r**16+291137*r**18)-20*Q2**4*(49706+246614*r**2+761773*r**4
            +1396663*r**6+1127437*r**8+584110*r**10+1127437*r**12+1396663*r**14
            +761773*r**16+246614*r**18+49706*r**20)-15*Q2**3*(38242-26871*r**2-19225*r**4
            -23904*r**6+27462*r**8+281832*r**10+281832*r**12+27462*r**14-23904*r**16
            -19225*r**18-26871*r**20+38242*r**22)+9*(-1+r**2)**2*(13136+40445*r**2
            +345746*r**4+500085*r**6-149680*r**8+136398*r**10+1050140*r**12+136398*r**14
            -149680*r**16+500085*r**18+345746*r**20+40445*r**22+13136*r**24)+15*Q2**2*(76124
            +123827*r**2+896264*r**4+1724543*r**6+901204*r**8-113042*r**10-161840*r**12
            -113042*r**14+901204*r**16+1724543*r**18+896264*r**20+123827*r**22+76124*r**24)
            -90*Q2*(6827+10856*r**2+115751*r**4+133189*r**6-125432*r**8-40235*r**10
            +463524*r**12+463524*r**14-40235*r**16-125432*r**18+133189*r**20+115751*r**22
            +10856*r**24+6827*r**26))+1433272320000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1120*Q2**13*(1+r**2)-20160*Q2**12*(1+r**2)**2+60*Q2**11*(2109
            +6607*r**2+6607*r**4+2109*r**6)-15*Q2**8*(1+r**2)**2*(40336+194357*r**2
            +316506*r**4+194357*r**6+40336*r**8)-2*Q2**10*(196248+851619*r**2+1309846*r**4
            +851619*r**6+196248*r**8)+60*Q2**9*(10922+61823*r**2+130971*r**4+130971*r**6
            +61823*r**8+10922*r**10)+5*Q2**7*(107370+491433*r**2+1346369*r**4+2211676*r**6
            +2211676*r**8+1346369*r**10+491433*r**12+107370*r**14)-15*Q2**6*(75124
            +185927*r**2+259840*r**4+235545*r**6+180184*r**8+235545*r**10+259840*r**12
            +185927*r**14+75124*r**16)+6*Q2**5*(291137+935851*r**2+2025509*r**4
            +2823491*r**6+2188532*r**8+2188532*r**10+2823491*r**12+2025509*r**14
            +935851*r**16+291137*r**18)-20*Q2**4*(49706+246614*r**2+761773*r**4
            +1396663*r**6+1127437*r**8+584110*r**10+1127437*r**12+1396663*r**14
            +761773*r**16+246614*r**18+49706*r**20)-15*Q2**3*(38242-26871*r**2-19225*r**4
            -23904*r**6+27462*r**8+281832*r**10+281832*r**12+27462*r**14-23904*r**16
            -19225*r**18-26871*r**20+38242*r**22)+9*(-1+r**2)**2*(13136+40445*r**2
            +345746*r**4+500085*r**6-149680*r**8+136398*r**10+1050140*r**12+136398*r**14
            -149680*r**16+500085*r**18+345746*r**20+40445*r**22+13136*r**24)+15*Q2**2*(76124
            +123827*r**2+896264*r**4+1724543*r**6+901204*r**8-113042*r**10-161840*r**12
            -113042*r**14+901204*r**16+1724543*r**18+896264*r**20+123827*r**22+76124*r**24)
            -90*Q2*(6827+10856*r**2+115751*r**4+133189*r**6-125432*r**8-40235*r**10
            +463524*r**12+463524*r**14-40235*r**16-125432*r**18+133189*r**20+115751*r**22
            +10856*r**24+6827*r**26))*sqrtq2)+logq2**5*(7962624000*r**24*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**4*(-4480*Q2**17+243680*Q2**16*(1+r**2)-10*Q2**15*(250267
            +508150*r**2+250267*r**4)+6*Q2**14*(2057907+6357881*r**2+6357881*r**4
            +2057907*r**6)-6*Q2**13*(6000833+25368627*r**2+38749028*r**4+25368627*r**6
            +6000833*r**8)+12*Q2**12*(5579121+30512817*r**2+63202286*r**4+63202286*r**6
            +30512817*r**8+5579121*r**10)-Q2**11*(81290418+541492491*r**2+1388210262*r**4
            +1852181498*r**6+1388210262*r**8+541492491*r**10+81290418*r**12)+Q2**10*(64195887
            +447325143*r**2+1179026469*r**4+1690054021*r**6+1690054021*r**8+1179026469*r**10
            +447325143*r**12+64195887*r**14)+Q2**9*(-30081309-110532957*r**2+265084878*r**4
            +1886492461*r**6+3091086910*r**8+1886492461*r**10+265084878*r**12-110532957*r**14
            -30081309*r**16)-Q2**8*(6655154+120133101*r**2+1379548569*r**4+5718886231*r**6
            +11141611329*r**8+11141611329*r**10+5718886231*r**12+1379548569*r**14
            +120133101*r**16+6655154*r**18)+Q2**7*(48184786+121337077*r**2+1121752326*r**4
            +4472518316*r**6+10129155272*r**8+13336715262*r**10+10129155272*r**12
            +4472518316*r**14+1121752326*r**16+121337077*r**18+48184786*r**20)-Q2**6*(75249404
            +181153613*r**2+1429549061*r**4+2548891924*r**6+2729967136*r**8+3313272382*r**10
            +3313272382*r**12+2729967136*r**14+2548891924*r**16+1429549061*r**18
            +181153613*r**20+75249404*r**22)+3*Q2**5*(18364212+117595573*r**2+947722874*r**4
            +1862757441*r**6+2048859396*r**8+1764491946*r**10+1416932316*r**12+1764491946*r**14
            +2048859396*r**16+1862757441*r**18+947722874*r**20+117595573*r**22+18364212*r**24)
            -3*Q2**4*(1755836+103373993*r**2+770736963*r**4+2181976351*r**6+3872117845*r**8
            +4473948678*r**10+3071474334*r**12+3071474334*r**14+4473948678*r**16
            +3872117845*r**18+2181976351*r**20+770736963*r**22+103373993*r**24+1755836*r**26)
            -18*Q2**3*(1279061-2060991*r**2+20915891*r**4-91781876*r**6-135529359*r**8
            -27911777*r**10+62092167*r**12+108912168*r**14+62092167*r**16-27911777*r**18
            -135529359*r**20-91781876*r**22+20915891*r**24-2060991*r**26+1279061*r**28)
            +54*(-1+r**2)**2*(13843+362158*r**2+4031324*r**4+7446779*r**6+37474773*r**8
            +46762432*r**10-34506*r**12-11384803*r**14-11384803*r**16-34506*r**18
            +46762432*r**20+37474773*r**22+7446779*r**24+4031324*r**26+362158*r**28
            +13843*r**30)+9*Q2**2*(2032763+13938316*r**2+189651538*r**4+160563003*r**6
            +897602741*r**8+1542535562*r**10+503916568*r**12-389056491*r**14-389056491*r**16
            +503916568*r**18+1542535562*r**20+897602741*r**22+160563003*r**24+189651538*r**26
            +13938316*r**28+2032763*r**30)-27*Q2*(221379+3180388*r**2+35955376*r**4
            +24942664*r**6+238706636*r**8+210504000*r**10-186914992*r**12+100634388*r**14
            +500292322*r**16+100634388*r**18-186914992*r**20+210504000*r**22+238706636*r**24
            +24942664*r**26+35955376*r**28+3180388*r**30+221379*r**32))+7962624000*r**24*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(4480*Q2**18-248160*Q2**17*(1+r**2)
            +170*Q2**16*(16155+32758*r**2+16155*r**4)-64*Q2**15*(232033+714554*r**2
            +714554*r**4+232033*r**6)+30*Q2**14*(1611748+6756883*r**2+10292958*r**4
            +6756883*r**6+1611748*r**8)-6*Q2**13*(17159075+92395094*r**2+190522227*r**4
            +190522227*r**6+92395094*r**8+17159075*r**10)+Q2**12*(148239870+974595747*r**2
            +2512791498*r**4+3369036362*r**6+2512791498*r**8+974595747*r**10+148239870*r**12)
            -3*Q2**11*(48495435+356702684*r**2+1036243074*r**4+1643481927*r**6+1643481927*r**8
            +1036243074*r**10+356702684*r**12+48495435*r**14)+Q2**10*(94277196+622053987*r**2
            +1361266734*r**4+982588029*r**6+289021132*r**8+982588029*r**10+1361266734*r**12
            +622053987*r**14+94277196*r**16)-5*Q2**9*(4685231+4096233*r**2-306820098*r**4
            -1574092714*r**6-3223838140*r**8-3223838140*r**10-1574092714*r**12-306820098*r**14
            +4096233*r**16+4685231*r**18)-12*Q2**8*(4569995+20677111*r**2+218452833*r**4
            +964246093*r**6+2249137736*r**8+2968328160*r**10+2249137736*r**12+964246093*r**14
            +218452833*r**16+20677111*r**18+4569995*r**20)+2*Q2**7*(61717095+175337738*r**2
            +1336319232*r**4+4071581283*r**6+8665820362*r**8+13389571458*r**10+13389571458*r**12
            +8665820362*r**14+4071581283*r**16+1336319232*r**18+175337738*r**20+61717095*r**22)
            -4*Q2**6*(32585510+152297434*r**2+1113467824*r**4+2391678327*r**6+2856359312*r**8
            +2834178839*r**10+2719335428*r**12+2834178839*r**14+2856359312*r**16
            +2391678327*r**18+1113467824*r**20+152297434*r**22+32585510*r**24)+6*Q2**5*(10060024
            +119666889*r**2+918027705*r**4+2496228333*r**6+3891867341*r**8+4143650010*r**10
            +3126449298*r**12+3126449298*r**14+4143650010*r**16+3891867341*r**18
            +2496228333*r**20+918027705*r**22+119666889*r**24+10060024*r**26)+54*(
            -1+r**4)**2*(13843+348315*r**2+3683009*r**4+3763770*r**6+33711003*r**8
            +13051429*r**10-13085935*r**12+1701132*r**14-13085935*r**16+13051429*r**18
            +33711003*r**20+3763770*r**22+3683009*r**24+348315*r**26+13843*r**28)
            +15*Q2**4*(1183706-23499155*r**2-149723122*r**4-700680914*r**6-1373454070*r**8
            -1702707437*r**10-1434574002*r**12-1097895132*r**14-1434574002*r**16
            -1702707437*r**18-1373454070*r**20-700680914*r**22-149723122*r**24-23499155*r**26
            +1183706*r**28)-9*Q2**3*(4590885+12374456*r**2+227361338*r**4+18831033*r**6
            +442980271*r**8+1215653290*r**10+572277348*r**12-47047821*r**14-47047821*r**16
            +572277348*r**18+1215653290*r**20+442980271*r**22+18831033*r**24+227361338*r**26
            +12374456*r**28+4590885*r**30)+9*Q2**2*(2696900+25512243*r**2+311455982*r**4
            +425042533*r**6+1774285652*r**8+3071650303*r**10+1485707154*r**12+416763241*r**14
            +722763984*r**16+416763241*r**18+1485707154*r**20+3071650303*r**22+1774285652*r**24
            +425042533*r**26+311455982*r**28+25512243*r**30+2696900*r**32)-27*Q2*(249065
            +4070711*r**2+45777466*r**4+60390618*r**6+316874378*r**8+407729966*r**10
            -88580186*r**12-15387322*r**14+623627304*r**16+623627304*r**18-15387322*r**20
            -88580186*r**22+407729966*r**24+316874378*r**26+60390618*r**28+45777466*r**30
            +4070711*r**32+249065*r**34))*sqrtq2)+logq2**4*(-66355200*r**20*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(565760*Q2**20-10060160*Q2**19*(1
            +r**2)+256*Q2**18*(298956+606911*r**2+298956*r**4)-16*Q2**17*(20615543
            +64431961*r**2+64431961*r**4+20615543*r**6)+4*Q2**16*(220754432+961344127*r**2
            +1473617534*r**4+961344127*r**6+220754432*r**8)-8*Q2**15*(185231682+1087520991*r**2
            +2273180035*r**4+2273180035*r**6+1087520991*r**8+185231682*r**10)+3*Q2**14*(469046080
            +3860082295*r**2+10045058012*r**4+13254398282*r**6+10045058012*r**8+3860082295*r**10
            +469046080*r**12)-8*Q2**13*(37800531+824472966*r**2+1869103674*r**4+1486616341*r**6
            +1486616341*r**8+1869103674*r**10+824472966*r**12+37800531*r**14)-Q2**12*(1029110976
            +4867369047*r**2+42857185626*r**4+153978380089*r**6+229686883052*r**8
            +153978380089*r**10+42857185626*r**12+4867369047*r**14+1029110976*r**16)
            +2*Q2**11*(759621488+6370788573*r**2+51903934629*r**4+203053696791*r**6
            +387520792871*r**8+387520792871*r**10+203053696791*r**12+51903934629*r**14
            +6370788573*r**16+759621488*r**18)-Q2**10*(1166340832+11543024761*r**2
            +105512398884*r**4+469758876716*r**6+1090468564252*r**8+1426701450998*r**10
            +1090468564252*r**12+469758876716*r**14+105512398884*r**16+11543024761*r**18
            +1166340832*r**20)+2*Q2**9*(256975500+3397473455*r**2+24828780939*r**4
            +98917578484*r**6+221711146384*r**8+292861391510*r**10+292861391510*r**12
            +221711146384*r**14+98917578484*r**16+24828780939*r**18+3397473455*r**20
            +256975500*r**22)+Q2**8*(241952288-3500527817*r**2+4547034226*r**4+97147445051*r**6
            +571640694536*r**8+1591265868110*r**10+2224504544332*r**12+1591265868110*r**14
            +571640694536*r**16+97147445051*r**18+4547034226*r**20-3500527817*r**22
            +241952288*r**24)-4*Q2**7*(191672996+76070557*r**2+8478020405*r**4+28443332907*r**6
            +165606121979*r**8+496777525900*r**10+857824558456*r**12+857824558456*r**14
            +496777525900*r**16+165606121979*r**18+28443332907*r**20+8478020405*r**22
            +76070557*r**24+191672996*r**26)+Q2**6*(597348864+4930981659*r**2+55573139276*r**4
            +85617067102*r**6+451818768012*r**8+716659394949*r**10+921327539304*r**12
            +1159428865668*r**14+921327539304*r**16+716659394949*r**18+451818768012*r**20
            +85617067102*r**22+55573139276*r**24+4930981659*r**26+597348864*r**28)
            -12*Q2**5*(3332334+497087087*r**2+4866320891*r**4+18868056894*r**6+84345280666*r**8
            +103944564301*r**10+51307516617*r**12+29242761210*r**14+29242761210*r**16
            +51307516617*r**18+103944564301*r**20+84345280666*r**22+18868056894*r**24
            +4866320891*r**26+497087087*r**28+3332334*r**30)-3*Q2**4*(72031360-827033205*r**2
            -8668888862*r**4-87847859887*r**6-368742067532*r**8-681835524805*r**10
            -765679908450*r**12-708715966231*r**14-653882044776*r**16-708715966231*r**18
            -765679908450*r**20-681835524805*r**22-368742067532*r**24-87847859887*r**26
            -8668888862*r**28-827033205*r**30+72031360*r**32)+18*Q2**3*(6273568+53935553*r**2
            +591111385*r**4-3786313061*r**6-1876574181*r**8-41647307911*r**10-35510936503*r**12
            +2546831683*r**14+7228419467*r**16+7228419467*r**18+2546831683*r**20
            -35510936503*r**22-41647307911*r**24-1876574181*r**26-3786313061*r**28
            +591111385*r**30+53935553*r**32+6273568*r**34)+27*(-1+r**2)**2*(131168
            -3518785*r**2-58920160*r**4-619287648*r**6-3635040800*r**8-2267898684*r**10
            -18930734240*r**12-27418625440*r**14+9249529664*r**16+36565529850*r**18
            +9249529664*r**20-27418625440*r**22-18930734240*r**24-2267898684*r**26
            -3635040800*r**28-619287648*r**30-58920160*r**32-3518785*r**34+131168*r**36)
            +9*Q2**2*(279072-170798511*r**2-2065063292*r**4-9104963680*r**6-72451056548*r**8
            -18625115524*r**10-191123751020*r**12-292303003552*r**14-27944990868*r**16
            +109906527846*r**18-27944990868*r**20-292303003552*r**22-191123751020*r**24
            -18625115524*r**26-72451056548*r**28-9104963680*r**30-2065063292*r**32
            -170798511*r**34+279072*r**36)-54*Q2*(302492-12148353*r**2-157242645*r**4
            -1189049452*r**6-7190405992*r**8+1768383224*r**10-29189468896*r**12-26791867480*r**14
            +17742034576*r**16-5783737474*r**18-5783737474*r**20+17742034576*r**22
            -26791867480*r**24-29189468896*r**26+1768383224*r**28-7190405992*r**30
            -1189049452*r**32-157242645*r**34-12148353*r**36+302492*r**38))-66355200*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(565760*Q2**20-10060160*Q2**19*(1+r**2)
            +256*Q2**18*(298956+606911*r**2+298956*r**4)-16*Q2**17*(20615543+64431961*r**2
            +64431961*r**4+20615543*r**6)+4*Q2**16*(220754432+961344127*r**2+1473617534*r**4
            +961344127*r**6+220754432*r**8)-8*Q2**15*(185231682+1087520991*r**2+2273180035*r**4
            +2273180035*r**6+1087520991*r**8+185231682*r**10)+3*Q2**14*(469046080
            +3860082295*r**2+10045058012*r**4+13254398282*r**6+10045058012*r**8+3860082295*r**10
            +469046080*r**12)-8*Q2**13*(37800531+824472966*r**2+1869103674*r**4+1486616341*r**6
            +1486616341*r**8+1869103674*r**10+824472966*r**12+37800531*r**14)-Q2**12*(1029110976
            +4867369047*r**2+42857185626*r**4+153978380089*r**6+229686883052*r**8
            +153978380089*r**10+42857185626*r**12+4867369047*r**14+1029110976*r**16)
            +2*Q2**11*(759621488+6370788573*r**2+51903934629*r**4+203053696791*r**6
            +387520792871*r**8+387520792871*r**10+203053696791*r**12+51903934629*r**14
            +6370788573*r**16+759621488*r**18)-Q2**10*(1166340832+11543024761*r**2
            +105512398884*r**4+469758876716*r**6+1090468564252*r**8+1426701450998*r**10
            +1090468564252*r**12+469758876716*r**14+105512398884*r**16+11543024761*r**18
            +1166340832*r**20)+2*Q2**9*(256975500+3397473455*r**2+24828780939*r**4
            +98917578484*r**6+221711146384*r**8+292861391510*r**10+292861391510*r**12
            +221711146384*r**14+98917578484*r**16+24828780939*r**18+3397473455*r**20
            +256975500*r**22)+Q2**8*(241952288-3500527817*r**2+4547034226*r**4+97147445051*r**6
            +571640694536*r**8+1591265868110*r**10+2224504544332*r**12+1591265868110*r**14
            +571640694536*r**16+97147445051*r**18+4547034226*r**20-3500527817*r**22
            +241952288*r**24)-4*Q2**7*(191672996+76070557*r**2+8478020405*r**4+28443332907*r**6
            +165606121979*r**8+496777525900*r**10+857824558456*r**12+857824558456*r**14
            +496777525900*r**16+165606121979*r**18+28443332907*r**20+8478020405*r**22
            +76070557*r**24+191672996*r**26)+Q2**6*(597348864+4930981659*r**2+55573139276*r**4
            +85617067102*r**6+451818768012*r**8+716659394949*r**10+921327539304*r**12
            +1159428865668*r**14+921327539304*r**16+716659394949*r**18+451818768012*r**20
            +85617067102*r**22+55573139276*r**24+4930981659*r**26+597348864*r**28)
            -12*Q2**5*(3332334+497087087*r**2+4866320891*r**4+18868056894*r**6+84345280666*r**8
            +103944564301*r**10+51307516617*r**12+29242761210*r**14+29242761210*r**16
            +51307516617*r**18+103944564301*r**20+84345280666*r**22+18868056894*r**24
            +4866320891*r**26+497087087*r**28+3332334*r**30)-3*Q2**4*(72031360-827033205*r**2
            -8668888862*r**4-87847859887*r**6-368742067532*r**8-681835524805*r**10
            -765679908450*r**12-708715966231*r**14-653882044776*r**16-708715966231*r**18
            -765679908450*r**20-681835524805*r**22-368742067532*r**24-87847859887*r**26
            -8668888862*r**28-827033205*r**30+72031360*r**32)+18*Q2**3*(6273568+53935553*r**2
            +591111385*r**4-3786313061*r**6-1876574181*r**8-41647307911*r**10-35510936503*r**12
            +2546831683*r**14+7228419467*r**16+7228419467*r**18+2546831683*r**20
            -35510936503*r**22-41647307911*r**24-1876574181*r**26-3786313061*r**28
            +591111385*r**30+53935553*r**32+6273568*r**34)+27*(-1+r**2)**2*(131168
            -3518785*r**2-58920160*r**4-619287648*r**6-3635040800*r**8-2267898684*r**10
            -18930734240*r**12-27418625440*r**14+9249529664*r**16+36565529850*r**18
            +9249529664*r**20-27418625440*r**22-18930734240*r**24-2267898684*r**26
            -3635040800*r**28-619287648*r**30-58920160*r**32-3518785*r**34+131168*r**36)
            +9*Q2**2*(279072-170798511*r**2-2065063292*r**4-9104963680*r**6-72451056548*r**8
            -18625115524*r**10-191123751020*r**12-292303003552*r**14-27944990868*r**16
            +109906527846*r**18-27944990868*r**20-292303003552*r**22-191123751020*r**24
            -18625115524*r**26-72451056548*r**28-9104963680*r**30-2065063292*r**32
            -170798511*r**34+279072*r**36)-54*Q2*(302492-12148353*r**2-157242645*r**4
            -1189049452*r**6-7190405992*r**8+1768383224*r**10-29189468896*r**12-26791867480*r**14
            +17742034576*r**16-5783737474*r**18-5783737474*r**20+17742034576*r**22
            -26791867480*r**24-29189468896*r**26+1768383224*r**28-7190405992*r**30
            -1189049452*r**32-157242645*r**34-12148353*r**36+302492*r**38))*sqrtq2)
            +logq2**3*(-2211840*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(2703360*Q2**23
            -39170112*Q2**22*(1+r**2)+Q2**21*(255121794+522749188*r**2+255121794*r**4)
            -6*Q2**20*(160962937+520735083*r**2+520735083*r**4+160962937*r**6)+10*Q2**19*(227473884
            +1072234917*r**2+1665153938*r**4+1072234917*r**6+227473884*r**8)-10*Q2**18*(319618881
            +2221036475*r**2+4716067788*r**4+4716067788*r**6+2221036475*r**8+319618881*r**10)
            +3*Q2**17*(604561306+8284430871*r**2+20588972310*r**4+25480198450*r**6
            +20588972310*r**8+8284430871*r**10+604561306*r**12)+Q2**16*(2128996359
            -2319678597*r**2+31615842049*r**4+136656921165*r**6+136656921165*r**8
            +31615842049*r**10-2319678597*r**12+2128996359*r**14)-Q2**15*(5307892587
            +37248431048*r**2+267059749368*r**4+915994194192*r**6+1356847689450*r**8
            +915994194192*r**10+267059749368*r**12+37248431048*r**14+5307892587*r**16)
            +15*Q2**14*(276279787+3749355906*r**2+30027961089*r**4+128840758503*r**6
            +254718611707*r**8+254718611707*r**10+128840758503*r**12+30027961089*r**14
            +3749355906*r**16+276279787*r**18)+5*Q2**13*(44508669-6704779155*r**2
            -61883237727*r**4-377342189136*r**6-958327462974*r**8-1266804898682*r**10
            -958327462974*r**12-377342189136*r**14-61883237727*r**16-6704779155*r**18
            +44508669*r**20)-Q2**12*(3315309507+4285582867*r**2+84966897915*r**4
            -104640869205*r**6-84486277230*r**8+1092766253298*r**10+1092766253298*r**12
            -84486277230*r**14-104640869205*r**16+84966897915*r**18+4285582867*r**20
            +3315309507*r**22)+3*Q2**11*(990687203+7885122246*r**2+115134848238*r**4
            +638590467470*r**6+2862876554285*r**8+7674335812172*r**10+10718006960964*r**12
            +7674335812172*r**14+2862876554285*r**16+638590467470*r**18+115134848238*r**20
            +7885122246*r**22+990687203*r**24)-Q2**10*(745883307+25226275068*r**2
            +309052138733*r**4+2278933724637*r**6+12342883124550*r**8+39600934628563*r**10
            +71332862877942*r**12+71332862877942*r**14+39600934628563*r**16+12342883124550*r**18
            +2278933724637*r**20+309052138733*r**22+25226275068*r**24+745883307*r**26)
            +5*Q2**9*(-206948151+3905720137*r**2+32499266463*r**4+261468645030*r**6
            +1395408476509*r**8+4993609591911*r**10+11068937189691*r**12+14384107190612*r**14
            +11068937189691*r**16+4993609591911*r**18+1395408476509*r**20+261468645030*r**22
            +32499266463*r**24+3905720137*r**26-206948151*r**28)+15*Q2**8*(86824045
            -315025605*r**2-2713371231*r**4-32980776425*r**6+22065287821*r**8+335777916667*r**10
            +1162196744041*r**12+2194726075567*r**14+2194726075567*r**16+1162196744041*r**18
            +335777916667*r**20+22065287821*r**22-32980776425*r**24-2713371231*r**26
            -315025605*r**28+86824045*r**30)-Q2**7*(468600417+11885990532*r**2+65340678460*r**4
            -72443532540*r**6+2997629259300*r**8+11715887878748*r**10+44849625073668*r**12
            +98178045901980*r**14+128063305194870*r**16+98178045901980*r**18+44849625073668*r**20
            +11715887878748*r**22+2997629259300*r**24-72443532540*r**26+65340678460*r**28
            +11885990532*r**30+468600417*r**32)+Q2**6*(-288710721+13751786438*r**2
            +115942456749*r**4+490777894935*r**6+3785886741945*r**8+3771318026331*r**10
            +20040024108237*r**12+34100436311791*r**14+47907474104295*r**16+47907474104295*r**18
            +34100436311791*r**20+20040024108237*r**22+3771318026331*r**24+3785886741945*r**26
            +490777894935*r**28+115942456749*r**30+13751786438*r**32-288710721*r**34)
            +9*Q2**5*(39218457-363980317*r**2-8344261007*r**4-98185170268*r**6-549313729500*r**8
            -1300226433572*r**10-4479711135628*r**12-2963992528548*r**14+668937633758*r**16
            +864304773250*r**18+668937633758*r**20-2963992528548*r**22-4479711135628*r**24
            -1300226433572*r**26-549313729500*r**28-98185170268*r**30-8344261007*r**32
            -363980317*r**34+39218457*r**36)-15*Q2**4*(5675701+231726813*r**2-547946423*r**4
            -38215930959*r**6-228997251584*r**8-1329509523216*r**10-3993634943080*r**12
            -4625477490552*r**14-3301606465774*r**16-4192969130926*r**18-4192969130926*r**20
            -3301606465774*r**22-4625477490552*r**24-3993634943080*r**26-1329509523216*r**28
            -228997251584*r**30-38215930959*r**32-547946423*r**34+231726813*r**36
            +5675701*r**38)-45*Q2**3*(1198121-54743880*r**2-431251694*r**4-471856568*r**6
            -2817658779*r**8+182768509328*r**10+164628941176*r**12+659968590960*r**14
            +274403718002*r**16+48345815808*r**18+253260515052*r**20+48345815808*r**22
            +274403718002*r**24+659968590960*r**26+164628941176*r**28+182768509328*r**30
            -2817658779*r**32-471856568*r**34-431251694*r**36-54743880*r**38+1198121*r**40)
            +54*(-1+r**2)**2*(16607+1175762*r**2-9818205*r**4-429266325*r**6-3630259570*r**8
            -25628899233*r**10-90583747668*r**12+52051853340*r**14-516314650550*r**16
            -559741662440*r**18+839466058282*r**20+839466058282*r**22-559741662440*r**24
            -516314650550*r**26+52051853340*r**28-90583747668*r**30-25628899233*r**32
            -3630259570*r**34-429266325*r**36-9818205*r**38+1175762*r**40+16607*r**42)
            +9*Q2**2*(4604777-23995178*r**2-1585900895*r**4-26396839955*r**6-179559135290*r**8
            -511635272963*r**10-3687017630928*r**12+1135686575000*r**14-5785908720670*r**16
            -8051880371940*r**18+800489488042*r**20+800489488042*r**22-8051880371940*r**24
            -5785908720670*r**26+1135686575000*r**28-3687017630928*r**30-511635272963*r**32
            -179559135290*r**34-26396839955*r**36-1585900895*r**38-23995178*r**40
            +4604777*r**42)-27*Q2*(384733+8992246*r**2-173012697*r**4-4662626120*r**6
            -32259682205*r**8-170010425602*r**10-694597635759*r**12+944736823008*r**14
            -2979354630590*r**16-2277342985460*r**18+2037310615558*r**20+1475581165776*r**22
            +2037310615558*r**24-2277342985460*r**26-2979354630590*r**28+944736823008*r**30
            -694597635759*r**32-170010425602*r**34-32259682205*r**36-4662626120*r**38
            -173012697*r**40+8992246*r**42+384733*r**44))+2211840*r**16*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**4*(2703360*Q2**24-41873472*Q2**23*(1+r**2)
            +Q2**22*(294291906+601089412*r**2+294291906*r**4)-8*Q2**21*(152612427
            +487785185*r**2+487785185*r**4+152612427*r**6)+2*Q2**20*(1620258231+7406268645*r**2
            +11450180188*r**4+7406268645*r**6+1620258231*r**8)-10*Q2**19*(547092765
            +3520745276*r**2+7453456643*r**4+7453456643*r**6+3520745276*r**8+547092765*r**10)
            +Q2**18*(5009872728+50259846173*r**2+131137959560*r**4+170761951110*r**6
            +131137959560*r**8+50259846173*r**10+5009872728*r**12)+Q2**17*(315312441
            -28986655128*r**2-55004367494*r**4-1550591115*r**6-1550591115*r**8-55004367494*r**10
            -28986655128*r**12+315312441*r**14)-2*Q2**16*(3718444473+18528874405*r**2
            +148177956410*r**4+542133478703*r**6+815080765890*r**8+542133478703*r**10
            +148177956410*r**12+18528874405*r**14+3718444473*r**16)+Q2**15*(9452089392
            +98796662225*r**2+754727596751*r**4+3115665321105*r**6+6093621059247*r**8
            +6093621059247*r**10+3115665321105*r**12+754727596751*r**14+98796662225*r**16
            +9452089392*r**18)-10*Q2**14*(392165346+9390843117*r**2+81607594356*r**4
            +426974173956*r**6+1054502786802*r**8+1397558284462*r**10+1054502786802*r**12
            +426974173956*r**14+81607594356*r**16+9390843117*r**18+392165346*r**20)
            +Q2**13*(-3537852852+29015769563*r**2+257973186495*r**4+2300768003520*r**6
            +6762834537780*r**8+10032895554982*r**10+10032895554982*r**12+6762834537780*r**14
            +2300768003520*r**16+257973186495*r**18+29015769563*r**20-3537852852*r**22)
            +4*Q2**12*(1571842779+7814064778*r**2+108664256374*r**4+474024357780*r**6
            +2099875629105*r**8+6007821853146*r**10+8584888347372*r**12+6007821853146*r**14
            +2099875629105*r**16+474024357780*r**18+108664256374*r**20+7814064778*r**22
            +1571842779*r**24)-Q2**11*(3717944916+51853703415*r**2+678112050185*r**4
            +4540109671761*r**6+22847284189815*r**8+71212571727934*r**10+126509891197350*r**12
            +126509891197350*r**14+71212571727934*r**16+22847284189815*r**18+4540109671761*r**20
            +678112050185*r**22+51853703415*r**24+3717944916*r**26)+4*Q2**10*(-72214362
            +11375189765*r**2+124193686529*r**4+973832272130*r**6+5399714807933*r**8
            +19227966428167*r**10+41569620863740*r**12+53646565427236*r**14+41569620863740*r**16
            +19227966428167*r**18+5399714807933*r**20+973832272130*r**22+124193686529*r**24
            +11375189765*r**26-72214362*r**28)+5*Q2**9*(467420286-4643848801*r**2
            -44545100293*r**4-392910240768*r**6-1590681258076*r**8-5381684318419*r**10
            -12575956549479*r**12-18868866153602*r**14-18868866153602*r**16-12575956549479*r**18
            -5381684318419*r**20-1590681258076*r**22-392910240768*r**24-44545100293*r**26
            -4643848801*r**28+467420286*r**30)-4*Q2**8*(442740273+2115741783*r**2
            +4978681480*r**4-151963936845*r**6+708474232560*r**8+4270883986517*r**10
            +16829811246072*r**12+37132972049025*r**14+48476271865470*r**16+37132972049025*r**18
            +16829811246072*r**20+4270883986517*r**22+708474232560*r**24-151963936845*r**26
            +4978681480*r**28+2115741783*r**30+442740273*r**32)+Q2**7*(179889696
            +26106377387*r**2+193169125741*r**4+483675040855*r**6+6711072468705*r**8
            +18484835164379*r**10+76605537060653*r**12+177128107287439*r**14+274148825201145*r**16
            +274148825201145*r**18+177128107287439*r**20+76605537060653*r**22+18484835164379*r**24
            +6711072468705*r**26+483675040855*r**28+193169125741*r**30+26106377387*r**32
            +179889696*r**34)+2*Q2**6*(320838417-8369449285*r**2-102396296125*r**4
            -745193442048*r**6-4610244101190*r**8-9629621335212*r**10-32064371177610*r**12
            -40408196588480*r**14-37993735856132*r**16-44018102624670*r**18-37993735856132*r**20
            -40408196588480*r**22-32064371177610*r**24-9629621335212*r**26-4610244101190*r**28
            -745193442048*r**30-102396296125*r**32-8369449285*r**34+320838417*r**36)
            +3*Q2**5*(-146033876-184348485*r**2+28864456087*r**4+510667948620*r**6
            +3087482957224*r**8+12196168105296*r**10+37307987423000*r**12+45458498445288*r**14
            +23393197013240*r**16+16365118433606*r**18+16365118433606*r**20+23393197013240*r**22
            +45458498445288*r**24+37307987423000*r**26+12196168105296*r**28+3087482957224*r**30
            +510667948620*r**32+28864456087*r**34-184348485*r**36-146033876*r**38)
            -54*(-1+r**4)**2*(16607+1159155*r**2-10977360*r**4-418288965*r**6-3211970605*r**8
            -22416928628*r**10-68166819040*r**12+120218672380*r**14-636533322930*r**16
            +76791660490*r**18+762674397792*r**20+76791660490*r**22-636533322930*r**24
            +120218672380*r**26-68166819040*r**28-22416928628*r**30-3211970605*r**32
            -418288965*r**34-10977360*r**36+1159155*r**38+16607*r**40)+30*Q2**4*(1040669
            +200817077*r**2+488767736*r**4-18674153839*r**6-129380103103*r**8-1053406151392*r**10
            -2908515644912*r**12-5299509103256*r**14-4375147555166*r**16-3819806522062*r**18
            -4572859903504*r**20-3819806522062*r**22-4375147555166*r**24-5299509103256*r**26
            -2908515644912*r**28-1053406151392*r**30-129380103103*r**32-18674153839*r**34
            +488767736*r**36+200817077*r**38+1040669*r**40)+9*Q2**3*(10595382-291723973*r**2
            -4015878765*r**4-30912381265*r**6-196006712025*r**8+388118979782*r**10
            -1950030378408*r**12+5258674235680*r**14-1114047175860*r**16-6438132702890*r**18
            +2308521142342*r**20+2308521142342*r**22-6438132702890*r**24-1114047175860*r**26
            +5258674235680*r**28-1950030378408*r**30+388118979782*r**32-196006712025*r**34
            -30912381265*r**36-4015878765*r**38-291723973*r**40+10595382*r**42)-9*Q2**2*(5758976
            +7586337*r**2-2128934164*r**4-41970619210*r**6-302735021860*r**8-1201225685059*r**10
            -6282445811168*r**12+282879413096*r**14-13588286037440*r**16-20669818048990*r**18
            -1139459037224*r**20+6027722473412*r**22-1139459037224*r**24-20669818048990*r**26
            -13588286037440*r**28+282879413096*r**30-6282445811168*r**32-1201225685059*r**34
            -302735021860*r**36-41970619210*r**38-2128934164*r**40+7586337*r**42
            +5758976*r**44)+27*Q2*(417947+11662075*r**2-188326695*r**4-5652547123*r**6
            -42485398575*r**8-239865400643*r**10-950520478905*r**12+665320086135*r**14
            -3456622017378*r**16-4206818632050*r**18+2645237095322*r**20+714476339890*r**22
            +714476339890*r**24+2645237095322*r**26-4206818632050*r**28-3456622017378*r**30
            +665320086135*r**32-950520478905*r**34-239865400643*r**36-42485398575*r**38
            -5652547123*r**40-188326695*r**42+11662075*r**44+417947*r**46))*sqrtq2)
            +logq2**2*(36864*r**12*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(
            -5936896*Q2**26+90491936*Q2**25*(1+r**2)-64*Q2**24*(9407875+19912102*r**2
            +9407875*r**4)+4*Q2**23*(564409465+1933660563*r**2+1933660563*r**4+564409465*r**6)
            -2*Q2**22*(2512194040+12990583399*r**2+20256681822*r**4+12990583399*r**6
            +2512194040*r**8)+4*Q2**21*(1462401040+12431298823*r**2+25638277333*r**4
            +25638277333*r**6+12431298823*r**8+1462401040*r**10)+Q2**20*(92866960
            -41054776113*r**2-70399526100*r**4-48823191590*r**6-70399526100*r**8
            -41054776113*r**10+92866960*r**12)-Q2**19*(11183463950+39942747863*r**2
            +328600062495*r**4+1001296719500*r**6+1001296719500*r**8+328600062495*r**10
            +39942747863*r**12+11183463950*r**14)+Q2**18*(15149819860+152813497567*r**2
            +1092646386232*r**4+4031500723345*r**6+6068789619400*r**8+4031500723345*r**10
            +1092646386232*r**12+152813497567*r**14+15149819860*r**16)-2*Q2**17*(1536542565
            +85786858854*r**2+713740530162*r**4+3638700221834*r**6+7478223173025*r**8
            +7478223173025*r**10+3638700221834*r**12+713740530162*r**14+85786858854*r**16
            +1536542565*r**18)+Q2**16*(-13899218880+34927866807*r**2+407584843632*r**4
            +5126777626832*r**6+13672834903232*r**8+17408953667538*r**10+13672834903232*r**12
            +5126777626832*r**14+407584843632*r**16+34927866807*r**18-13899218880*r**20)
            +2*Q2**15*(7943590800+70223209896*r**2+694657673985*r**4+2417520658075*r**6
            +8735831347885*r**8+21022670642767*r**10+21022670642767*r**12+8735831347885*r**14
            +2417520658075*r**16+694657673985*r**18+70223209896*r**20+7943590800*r**22)
            -4*Q2**14*(436875100+45970811217*r**2+512293632960*r**4+3563028985825*r**6
            +16025019449400*r**8+45668302269870*r**10+65121039887128*r**12+45668302269870*r**14
            +16025019449400*r**16+3563028985825*r**18+512293632960*r**20+45970811217*r**22
            +436875100*r**24)+2*Q2**13*(-5169129620+36339641206*r**2+457114647921*r**4
            +6228033020965*r**6+35287132496050*r**8+135074079046140*r**10+260695523460634*r**12
            +260695523460634*r**14+135074079046140*r**16+35287132496050*r**18+6228033020965*r**20
            +457114647921*r**22+36339641206*r**24-5169129620*r**26)+2*Q2**12*(4383602560
            +32023138081*r**2+240401855818*r**4-1009562683154*r**6-7353612940310*r**8
            -63099782983625*r**10-172241324935316*r**12-227938726899788*r**14-172241324935316*r**16
            -63099782983625*r**18-7353612940310*r**20-1009562683154*r**22+240401855818*r**24
            +32023138081*r**26+4383602560*r**28)-2*Q2**11*(33185930+53675604399*r**2
            +416906334294*r**4+2749900241669*r**6+23067957105849*r**8+82298109261192*r**10
            +231866817245891*r**12+445132998510696*r**14+445132998510696*r**16+231866817245891*r**18
            +82298109261192*r**20+23067957105849*r**22+2749900241669*r**24+416906334294*r**26
            +53675604399*r**28+33185930*r**30)+Q2**10*(-4692350920+54367994942*r**2
            +543009864240*r**4+6370884548090*r**6+55313707421840*r**8+300268628263086*r**10
            +1141287115662032*r**12+2738873031581210*r**14+3720202152232560*r**16
            +2738873031581210*r**18+1141287115662032*r**20+300268628263086*r**22+55313707421840*r**24
            +6370884548090*r**26+543009864240*r**28+54367994942*r**30-4692350920*r**32)
            +2*Q2**9*(1527607450+8073015406*r**2-123210404855*r**4-2396470118075*r**6
            -14968745373650*r**8-96709485382490*r**10-423863077959581*r**12-1247767571856305*r**14
            -2240623179153500*r**16-2240623179153500*r**18-1247767571856305*r**20
            -423863077959581*r**22-96709485382490*r**24-14968745373650*r**26-2396470118075*r**28
            -123210404855*r**30+8073015406*r**32+1527607450*r**34)+Q2**8*(319444960
            -40045027158*r**2-64631549388*r**4+2385319167040*r**6+9326237273100*r**8
            +54309672235080*r**10+26348768685668*r**12+36036454283328*r**14+363748468100220*r**16
            +607775049238300*r**18+363748468100220*r**20+36036454283328*r**22+26348768685668*r**24
            +54309672235080*r**26+9326237273100*r**28+2385319167040*r**30-64631549388*r**32
            -40045027158*r**34+319444960*r**36)+2*Q2**7*(-734816890+10015160246*r**2
            +146015775513*r**4+481411729031*r**6+1076037934355*r**8-4271128521975*r**10
            +162730414237459*r**12+538203839761537*r**14+1382646110422239*r**16+2235058426158485*r**18
            +2235058426158485*r**20+1382646110422239*r**22+538203839761537*r**24+162730414237459*r**26
            -4271128521975*r**28+1076037934355*r**30+481411729031*r**32+146015775513*r**34
            +10015160246*r**36-734816890*r**38)+2*Q2**6*(313421600+1914948941*r**2
            -101691699274*r**4-1381460491699*r**6-5631924466984*r**8-14938290522868*r**10
            -138041349316616*r**12-88141177709876*r**14-592618241670776*r**16-1033288061796466*r**18
            -1269279706191964*r**20-1033288061796466*r**22-592618241670776*r**24-88141177709876*r**26
            -138041349316616*r**28-14938290522868*r**30-5631924466984*r**32-1381460491699*r**34
            -101691699274*r**36+1914948941*r**38+313421600*r**40)+6*Q2**5*(31842420
            -1539135748*r**2-3155462165*r**4+287457661455*r**6+2190514577860*r**8
            +14937861341588*r**10+57985059388824*r**12+66415943298640*r**14+270560500458920*r**16
            +21643548977040*r**18-177367787748834*r**20-177367787748834*r**22+21643548977040*r**24
            +270560500458920*r**26+66415943298640*r**28+57985059388824*r**30+14937861341588*r**32
            +2190514577860*r**34+287457661455*r**36-3155462165*r**38-1539135748*r**40
            +31842420*r**42)-3*Q2**4*(81767600-1193912149*r**2-28276976640*r**4+11734132850*r**6
            +2145975705200*r**8+27167457498015*r**10+109388113557696*r**12+460851142560120*r**14
            +1087104054210000*r**16+606834863616950*r**18+392071361395280*r**20+899127408090156*r**22
            +392071361395280*r**24+606834863616950*r**26+1087104054210000*r**28+460851142560120*r**30
            +109388113557696*r**32+27167457498015*r**34+2145975705200*r**36+11734132850*r**38
            -28276976640*r**40-1193912149*r**42+81767600*r**44)+9*Q2**3*(4793090
            +71774853*r**2-3058935757*r**4-54847672450*r**6-79287385650*r**8+1254545789255*r**10
            +5432124864273*r**12+90581086701618*r**14+38743239992460*r**16+80396763810650*r**18
            +18227403813270*r**20+132199450054388*r**22+132199450054388*r**24+18227403813270*r**26
            +80396763810650*r**28+38743239992460*r**30+90581086701618*r**32+5432124864273*r**34
            +1254545789255*r**36-79287385650*r**38-54847672450*r**40-3058935757*r**42
            +71774853*r**44+4793090*r**46)+27*(-1+r**2)**2*(83552-1447843*r**2-50441298*r**4
            +54213807*r**6+9154483452*r**8+131446182267*r**10+744582511222*r**12
            +3901934238817*r**14+8012603786672*r**16-17771333998158*r**18+88394216002012*r**20
            +13157597111142*r**22-156582101451288*r**24+13157597111142*r**26+88394216002012*r**28
            -17771333998158*r**30+8012603786672*r**32+3901934238817*r**34+744582511222*r**36
            +131446182267*r**38+9154483452*r**40+54213807*r**42-50441298*r**44-1447843*r**46
            +83552*r**48)+9*Q2**2*(3416180-114939197*r**2-1048352216*r**4+29291929093*r**6
            +296609879560*r**8+2953696785625*r**10+13650980955848*r**12+23606292661839*r**14
            +226494647624268*r**16-206135647023010*r**18+207865351413520*r**20+286546664098738*r**22
            +41603119099504*r**24+286546664098738*r**26+207865351413520*r**28-206135647023010*r**30
            +226494647624268*r**32+23606292661839*r**34+13650980955848*r**36+2953696785625*r**38
            +296609879560*r**40+29291929093*r**42-1048352216*r**44-114939197*r**46
            +3416180*r**48)-54*Q2*(294231-6546448*r**2-138133943*r**4+1046471957*r**6
            +25102181627*r**8+308154584807*r**10+1411459381217*r**12+5661279716997*r**14
            +17297723055822*r**16-49616196894933*r**18+118356653970962*r**20+41021966469162*r**22
            -97888740551458*r**24-97888740551458*r**26+41021966469162*r**28+118356653970962*r**30
            -49616196894933*r**32+17297723055822*r**34+5661279716997*r**36+1411459381217*r**38
            +308154584807*r**40+25102181627*r**42+1046471957*r**44-138133943*r**46
            -6546448*r**48+294231*r**50))-36864*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(5936896*Q2**26-90491936*Q2**25*(1+r**2)+64*Q2**24*(9407875
            +19912102*r**2+9407875*r**4)-4*Q2**23*(564409465+1933660563*r**2+1933660563*r**4
            +564409465*r**6)+Q2**22*(5024388080+25981166798*r**2+40513363644*r**4
            +25981166798*r**6+5024388080*r**8)-4*Q2**21*(1462401040+12431298823*r**2
            +25638277333*r**4+25638277333*r**6+12431298823*r**8+1462401040*r**10)
            +Q2**20*(-92866960+41054776113*r**2+70399526100*r**4+48823191590*r**6
            +70399526100*r**8+41054776113*r**10-92866960*r**12)+Q2**19*(11183463950
            +39942747863*r**2+328600062495*r**4+1001296719500*r**6+1001296719500*r**8
            +328600062495*r**10+39942747863*r**12+11183463950*r**14)-Q2**18*(15149819860
            +152813497567*r**2+1092646386232*r**4+4031500723345*r**6+6068789619400*r**8
            +4031500723345*r**10+1092646386232*r**12+152813497567*r**14+15149819860*r**16)
            +2*Q2**17*(1536542565+85786858854*r**2+713740530162*r**4+3638700221834*r**6
            +7478223173025*r**8+7478223173025*r**10+3638700221834*r**12+713740530162*r**14
            +85786858854*r**16+1536542565*r**18)+Q2**16*(13899218880-34927866807*r**2
            -407584843632*r**4-5126777626832*r**6-13672834903232*r**8-17408953667538*r**10
            -13672834903232*r**12-5126777626832*r**14-407584843632*r**16-34927866807*r**18
            +13899218880*r**20)-2*Q2**15*(7943590800+70223209896*r**2+694657673985*r**4
            +2417520658075*r**6+8735831347885*r**8+21022670642767*r**10+21022670642767*r**12
            +8735831347885*r**14+2417520658075*r**16+694657673985*r**18+70223209896*r**20
            +7943590800*r**22)+4*Q2**14*(436875100+45970811217*r**2+512293632960*r**4
            +3563028985825*r**6+16025019449400*r**8+45668302269870*r**10+65121039887128*r**12
            +45668302269870*r**14+16025019449400*r**16+3563028985825*r**18+512293632960*r**20
            +45970811217*r**22+436875100*r**24)+2*Q2**13*(5169129620-36339641206*r**2
            -457114647921*r**4-6228033020965*r**6-35287132496050*r**8-135074079046140*r**10
            -260695523460634*r**12-260695523460634*r**14-135074079046140*r**16-35287132496050*r**18
            -6228033020965*r**20-457114647921*r**22-36339641206*r**24+5169129620*r**26)
            +2*Q2**12*(-4383602560-32023138081*r**2-240401855818*r**4+1009562683154*r**6
            +7353612940310*r**8+63099782983625*r**10+172241324935316*r**12+227938726899788*r**14
            +172241324935316*r**16+63099782983625*r**18+7353612940310*r**20+1009562683154*r**22
            -240401855818*r**24-32023138081*r**26-4383602560*r**28)+2*Q2**11*(33185930
            +53675604399*r**2+416906334294*r**4+2749900241669*r**6+23067957105849*r**8
            +82298109261192*r**10+231866817245891*r**12+445132998510696*r**14+445132998510696*r**16
            +231866817245891*r**18+82298109261192*r**20+23067957105849*r**22+2749900241669*r**24
            +416906334294*r**26+53675604399*r**28+33185930*r**30)+2*Q2**10*(2346175460
            -27183997471*r**2-271504932120*r**4-3185442274045*r**6-27656853710920*r**8
            -150134314131543*r**10-570643557831016*r**12-1369436515790605*r**14-1860101076116280*r**16
            -1369436515790605*r**18-570643557831016*r**20-150134314131543*r**22-27656853710920*r**24
            -3185442274045*r**26-271504932120*r**28-27183997471*r**30+2346175460*r**32)
            +2*Q2**9*(-1527607450-8073015406*r**2+123210404855*r**4+2396470118075*r**6
            +14968745373650*r**8+96709485382490*r**10+423863077959581*r**12+1247767571856305*r**14
            +2240623179153500*r**16+2240623179153500*r**18+1247767571856305*r**20
            +423863077959581*r**22+96709485382490*r**24+14968745373650*r**26+2396470118075*r**28
            +123210404855*r**30-8073015406*r**32-1527607450*r**34)-2*Q2**8*(159722480
            -20022513579*r**2-32315774694*r**4+1192659583520*r**6+4663118636550*r**8
            +27154836117540*r**10+13174384342834*r**12+18018227141664*r**14+181874234050110*r**16
            +303887524619150*r**18+181874234050110*r**20+18018227141664*r**22+13174384342834*r**24
            +27154836117540*r**26+4663118636550*r**28+1192659583520*r**30-32315774694*r**32
            -20022513579*r**34+159722480*r**36)+2*Q2**7*(734816890-10015160246*r**2
            -146015775513*r**4-481411729031*r**6-1076037934355*r**8+4271128521975*r**10
            -162730414237459*r**12-538203839761537*r**14-1382646110422239*r**16-2235058426158485*r**18
            -2235058426158485*r**20-1382646110422239*r**22-538203839761537*r**24-162730414237459*r**26
            +4271128521975*r**28-1076037934355*r**30-481411729031*r**32-146015775513*r**34
            -10015160246*r**36+734816890*r**38)+2*Q2**6*(-313421600-1914948941*r**2
            +101691699274*r**4+1381460491699*r**6+5631924466984*r**8+14938290522868*r**10
            +138041349316616*r**12+88141177709876*r**14+592618241670776*r**16+1033288061796466*r**18
            +1269279706191964*r**20+1033288061796466*r**22+592618241670776*r**24+88141177709876*r**26
            +138041349316616*r**28+14938290522868*r**30+5631924466984*r**32+1381460491699*r**34
            +101691699274*r**36-1914948941*r**38-313421600*r**40)-6*Q2**5*(31842420
            -1539135748*r**2-3155462165*r**4+287457661455*r**6+2190514577860*r**8
            +14937861341588*r**10+57985059388824*r**12+66415943298640*r**14+270560500458920*r**16
            +21643548977040*r**18-177367787748834*r**20-177367787748834*r**22+21643548977040*r**24
            +270560500458920*r**26+66415943298640*r**28+57985059388824*r**30+14937861341588*r**32
            +2190514577860*r**34+287457661455*r**36-3155462165*r**38-1539135748*r**40
            +31842420*r**42)+3*Q2**4*(81767600-1193912149*r**2-28276976640*r**4+11734132850*r**6
            +2145975705200*r**8+27167457498015*r**10+109388113557696*r**12+460851142560120*r**14
            +1087104054210000*r**16+606834863616950*r**18+392071361395280*r**20+899127408090156*r**22
            +392071361395280*r**24+606834863616950*r**26+1087104054210000*r**28+460851142560120*r**30
            +109388113557696*r**32+27167457498015*r**34+2145975705200*r**36+11734132850*r**38
            -28276976640*r**40-1193912149*r**42+81767600*r**44)-9*Q2**3*(4793090
            +71774853*r**2-3058935757*r**4-54847672450*r**6-79287385650*r**8+1254545789255*r**10
            +5432124864273*r**12+90581086701618*r**14+38743239992460*r**16+80396763810650*r**18
            +18227403813270*r**20+132199450054388*r**22+132199450054388*r**24+18227403813270*r**26
            +80396763810650*r**28+38743239992460*r**30+90581086701618*r**32+5432124864273*r**34
            +1254545789255*r**36-79287385650*r**38-54847672450*r**40-3058935757*r**42
            +71774853*r**44+4793090*r**46)-27*(-1+r**2)**2*(83552-1447843*r**2-50441298*r**4
            +54213807*r**6+9154483452*r**8+131446182267*r**10+744582511222*r**12
            +3901934238817*r**14+8012603786672*r**16-17771333998158*r**18+88394216002012*r**20
            +13157597111142*r**22-156582101451288*r**24+13157597111142*r**26+88394216002012*r**28
            -17771333998158*r**30+8012603786672*r**32+3901934238817*r**34+744582511222*r**36
            +131446182267*r**38+9154483452*r**40+54213807*r**42-50441298*r**44-1447843*r**46
            +83552*r**48)-9*Q2**2*(3416180-114939197*r**2-1048352216*r**4+29291929093*r**6
            +296609879560*r**8+2953696785625*r**10+13650980955848*r**12+23606292661839*r**14
            +226494647624268*r**16-206135647023010*r**18+207865351413520*r**20+286546664098738*r**22
            +41603119099504*r**24+286546664098738*r**26+207865351413520*r**28-206135647023010*r**30
            +226494647624268*r**32+23606292661839*r**34+13650980955848*r**36+2953696785625*r**38
            +296609879560*r**40+29291929093*r**42-1048352216*r**44-114939197*r**46
            +3416180*r**48)+54*Q2*(294231-6546448*r**2-138133943*r**4+1046471957*r**6
            +25102181627*r**8+308154584807*r**10+1411459381217*r**12+5661279716997*r**14
            +17297723055822*r**16-49616196894933*r**18+118356653970962*r**20+41021966469162*r**22
            -97888740551458*r**24-97888740551458*r**26+41021966469162*r**28+118356653970962*r**30
            -49616196894933*r**32+17297723055822*r**34+5661279716997*r**36+1411459381217*r**38
            +308154584807*r**40+25102181627*r**42+1046471957*r**44-138133943*r**46
            -6546448*r**48+294231*r**50))*sqrtq2)+logq2*(-3072*r**8*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(54928*Q2**25
            -968654*Q2**24*(1+r**2)+16*Q2**23*(441871+1024561*r**2+441871*r**4)
            -2*Q2**22*(14013332+54831483*r**2+54831483*r**4+14013332*r**6)+Q2**21*(63345386
            +375963554*r**2+577025968*r**4+375963554*r**6+63345386*r**8)-Q2**20*(67308514
            +640656985*r**2+984448233*r**4+984448233*r**6+640656985*r**8+67308514*r**10)
            -Q2**19*(32315059-126416571*r**2+2341638845*r**4+5599041750*r**6+2341638845*r**8
            -126416571*r**10+32315059*r**12)+Q2**18*(196731656+1706405381*r**2+14501550171*r**4
            +42442673840*r**6+42442673840*r**8+14501550171*r**10+1706405381*r**12
            +196731656*r**14)-Q2**17*(206917669+3343276876*r**2+28668575326*r**4
            +114913112104*r**6+172710534370*r**8+114913112104*r**10+28668575326*r**12
            +3343276876*r**14+206917669*r**16)+Q2**16*(-64983894+2016681864*r**2
            +20790793818*r**4+138519895894*r**6+269885591166*r**8+269885591166*r**10
            +138519895894*r**12+20790793818*r**14+2016681864*r**16-64983894*r**18)
            +2*Q2**15*(170586738+970268280*r**2+9214848931*r**4+5501208626*r**6+59531199215*r**8
            +142014548404*r**10+59531199215*r**12+5501208626*r**14+9214848931*r**16
            +970268280*r**18+170586738*r**20)-4*Q2**14*(57653256+1032570141*r**2
            +13224373435*r**4+68856023850*r**6+291134462750*r**8+697740246984*r**10
            +697740246984*r**12+291134462750*r**14+68856023850*r**16+13224373435*r**18
            +1032570141*r**20+57653256*r**22)+2*Q2**13*(-76620292+1010406288*r**2
            +20381606923*r**4+189672062340*r**6+925000865380*r**8+2978900660812*r**10
            +4338146258922*r**12+2978900660812*r**14+925000865380*r**16+189672062340*r**18
            +20381606923*r**20+1010406288*r**22-76620292*r**24)+2*Q2**12*(152413058
            +705041987*r**2+2117930437*r**4-89031308827*r**6-435580421785*r**8-2332848533108*r**10
            -4601956616002*r**12-4601956616002*r**14-2332848533108*r**16-435580421785*r**18
            -89031308827*r**20+2117930437*r**22+705041987*r**24+152413058*r**26)
            -2*Q2**11*(40577317+1209580633*r**2+16700551206*r**4+60666122628*r**6
            +548198193052*r**8+1356724724463*r**10+3520697244537*r**12+5611433758504*r**14
            +3520697244537*r**16+1356724724463*r**18+548198193052*r**20+60666122628*r**22
            +16700551206*r**24+1209580633*r**26+40577317*r**28)+2*Q2**10*(-73663312
            +573679365*r**2+13751454331*r**4+121860027396*r**6+923755283260*r**8
            +4205311059841*r**10+13612819655775*r**12+27610470963184*r**14+27610470963184*r**16
            +13612819655775*r**18+4205311059841*r**20+923755283260*r**22+121860027396*r**24
            +13751454331*r**26+573679365*r**28-73663312*r**30)+2*Q2**9*(60558233
            +136488578*r**2-2364141555*r**4-85827890350*r**6-461297482870*r**8-2958778203458*r**10
            -11068952922973*r**12-30832150405810*r**14-44258461182950*r**16-30832150405810*r**18
            -11068952922973*r**20-2958778203458*r**22-461297482870*r**24-85827890350*r**26
            -2364141555*r**28+136488578*r**30+60558233*r**32)+2*Q2**8*(6265103-393924787*r**2
            -6000789412*r**4+27792089060*r**6+5428682030*r**8+331946644482*r**10
            -1020596697348*r**12+3413225910212*r**14+12466539123060*r**16+12466539123060*r**18
            +3413225910212*r**20-1020596697348*r**22+331946644482*r**24+5428682030*r**26
            +27792089060*r**28-6000789412*r**30-393924787*r**32+6265103*r**34)+2*Q2**7*(
            -27392222+260333772*r**2+6381379797*r**4+11403800638*r**6+47985731925*r**8
            +319762656772*r**10+5755941058623*r**12+12557490473698*r**14+22353006084277*r**16
            +29972058081440*r**18+22353006084277*r**20+12557490473698*r**22+5755941058623*r**24
            +319762656772*r**26+47985731925*r**28+11403800638*r**30+6381379797*r**32
            +260333772*r**34-27392222*r**36)+2*Q2**6*(8857828-6915263*r**2-1622897251*r**4
            -32002270568*r**6-63304013492*r**8-252699972048*r**10-3315946413352*r**12
            -2736210667324*r**14-10844596378892*r**16-16999068897638*r**18-16999068897638*r**20
            -10844596378892*r**22-2736210667324*r**24-3315946413352*r**26-252699972048*r**28
            -63304013492*r**30-32002270568*r**32-1622897251*r**34-6915263*r**36+8857828*r**38)
            +2*Q2**5*(4639243-110066225*r**2-1784707239*r**4+31113936171*r**6+154613151355*r**8
            +912995497384*r**10+3803646597140*r**12+3107894933744*r**14+12790690270074*r**16
            -8316477626770*r**18-6678509569754*r**20-8316477626770*r**22+12790690270074*r**24
            +3107894933744*r**26+3803646597140*r**28+912995497384*r**30+154613151355*r**32
            +31113936171*r**34-1784707239*r**36-110066225*r**38+4639243*r**40)-Q2**4*(7410354
            -128680491*r**2-3013940695*r**4+23180404025*r**6+244111583165*r**8+2077950650094*r**10
            +8252174345484*r**12+24789733107180*r**14+56274613870600*r**16-11459777742650*r**18
            +28260174912934*r**20+28260174912934*r**22-11459777742650*r**24+56274613870600*r**26
            +24789733107180*r**28+8252174345484*r**30+2077950650094*r**32+244111583165*r**34
            +23180404025*r**36-3013940695*r**38-128680491*r**40+7410354*r**42)+3*Q2**3*(176887
            +1335797*r**2-94091293*r**4-3631692630*r**6+4626080655*r**8+147471900497*r**10
            +347359208707*r**12+5385714139832*r**14+1048971745990*r**16-3548974552390*r**18
            +2016207370702*r**20+14417599154492*r**22+2016207370702*r**24-3548974552390*r**26
            +1048971745990*r**28+5385714139832*r**30+347359208707*r**32+147471900497*r**34
            +4626080655*r**36-3631692630*r**38-94091293*r**40+1335797*r**42+176887*r**44)
            +18*(-1+r**2)**2*(2611-93888*r**2-2501328*r**4+47432661*r**6+407674425*r**8
            +5632553856*r**10+26760652592*r**12+66231548847*r**14+419943421006*r**16
            -1746620138800*r**18+5378971673616*r**20-3890098625598*r**22-3890098625598*r**24
            +5378971673616*r**26-1746620138800*r**28+419943421006*r**30+66231548847*r**32
            +26760652592*r**34+5632553856*r**36+407674425*r**38+47432661*r**40-2501328*r**42
            -93888*r**44+2611*r**46)+3*Q2**2*(341512-10869517*r**2-199399267*r**4
            +5139744632*r**6+24359394280*r**8+210833941217*r**10+1162680717103*r**12
            -187912687272*r**14+16029394144352*r**16-23398479700530*r**18+16401143190162*r**20
            +9740481583328*r**22+9740481583328*r**24+16401143190162*r**26-23398479700530*r**28
            +16029394144352*r**30-187912687272*r**32+1162680717103*r**34+210833941217*r**36
            +24359394280*r**38+5139744632*r**40-199399267*r**42-10869517*r**44+341512*r**46)
            -9*Q2*(43821-1469736*r**2-31693292*r**4+700752284*r**6+4051212746*r**8
            +49206863516*r**10+218737505924*r**12+196712600968*r**14+3415538296259*r**16
            -12581028195584*r**18+25667258262376*r**20-6174140072856*r**22-17413630612852*r**24
            -6174140072856*r**26+25667258262376*r**28-12581028195584*r**30+3415538296259*r**32
            +196712600968*r**34+218737505924*r**36+49206863516*r**38+4051212746*r**40
            +700752284*r**42-31693292*r**44-1469736*r**46+43821*r**48))+3072*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(439424*Q2**30-8573152*Q2**29*(1+r**2)
            +2*Q2**28*(35544649+80541138*r**2+35544649*r**4)-16*Q2**27*(20607067
            +77892741*r**2+77892741*r**4+20607067*r**6)+Q2**26*(917476508+5202948494*r**2
            +8210764516*r**4+5202948494*r**6+917476508*r**8)-2*Q2**25*(709057163
            +6091789506*r**2+12136324271*r**4+12136324271*r**6+6091789506*r**8+709057163*r**10)
            +Q2**24*(473746560+12212747385*r**2+12342121064*r**4-4784127778*r**6
            +12342121064*r**8+12212747385*r**10+473746560*r**12)+Q2**23*(2670823185
            +13711617420*r**2+142738323614*r**4+453826997909*r**6+453826997909*r**8
            +142738323614*r**10+13711617420*r**12+2670823185*r**14)-Q2**22*(5195321340
            +61856438595*r**2+491689391046*r**4+1913645899597*r**6+2909141612956*r**8
            +1913645899597*r**10+491689391046*r**12+61856438595*r**14+5195321340*r**16)
            +Q2**21*(2070707135+76853348505*r**2+703437317494*r**4+3814337145294*r**6
            +7910562740372*r**8+7910562740372*r**10+3814337145294*r**12+703437317494*r**14
            +76853348505*r**16+2070707135*r**18)+Q2**20*(5873388320-5821572715*r**2
            -194816500036*r**4-3051406403928*r**6-8159305532364*r**8-10096359740506*r**10
            -8159305532364*r**12-3051406403928*r**14-194816500036*r**16-5821572715*r**18
            +5873388320*r**20)-Q2**19*(8934737845+99947028270*r**2+945232681006*r**4
            +3156091068933*r**6+11383661376726*r**8+29948650370004*r**10+29948650370004*r**12
            +11383661376726*r**14+3156091068933*r**16+945232681006*r**18+99947028270*r**20
            +8934737845*r**22)+Q2**18*(993236780+114061378185*r**2+1537431060214*r**4
            +11123894357529*r**6+49232280466324*r**8+147736731098590*r**10+214027565386132*r**12
            +147736731098590*r**14+49232280466324*r**16+11123894357529*r**18+1537431060214*r**20
            +114061378185*r**22+993236780*r**24)+Q2**17*(8769705455-7830359935*r**2
            -675135958956*r**4-11637312711192*r**6-64950970049121*r**8-260142074233391*r**10
            -509673868212188*r**12-509673868212188*r**14-260142074233391*r**16-64950970049121*r**18
            -11637312711192*r**20-675135958956*r**22-7830359935*r**24+8769705455*r**26)
            -2*Q2**16*(3666403685+47526465480*r**2+414095693843*r**4-756205233972*r**6
            -9193293368111*r**8-80105306720544*r**10-220554113611241*r**12-289758041566760*r**14
            -220554113611241*r**16-80105306720544*r**18-9193293368111*r**20-756205233972*r**22
            +414095693843*r**24+47526465480*r**26+3666403685*r**28)+2*Q2**15*(-1258609875
            +43155600240*r**2+682768254582*r**4+4943596714001*r**6+29209956014983*r**8
            +97780445041070*r**10+251662591372796*r**12+511345846096811*r**14+511345846096811*r**16
            +251662591372796*r**18+97780445041070*r**20+29209956014983*r**22+4943596714001*r**24
            +682768254582*r**26+43155600240*r**28-1258609875*r**30)+2*Q2**14*(3459465660
            -1656804615*r**2-290101297558*r**4-5742573697429*r**6-41818022881828*r**8
            -242099663170399*r**10-869284546627354*r**12-2182898020888837*r**14-3018507430441936*r**16
            -2182898020888837*r**18-869284546627354*r**20-242099663170399*r**22-41818022881828*r**24
            -5742573697429*r**26-290101297558*r**28-1656804615*r**30+3459465660*r**32)
            +2*Q2**13*(-1034164965-26093721855*r**2-225359414778*r**4+2008537106942*r**6
            +19024933775162*r**8+191718409982798*r**10+875316874530002*r**12+2945395857139274*r**14
            +5471656104199868*r**16+5471656104199868*r**18+2945395857139274*r**20
            +875316874530002*r**22+191718409982798*r**24+19024933775162*r**26+2008537106942*r**28
            -225359414778*r**30-26093721855*r**32-1034164965*r**34)-2*Q2**12*(1506986615
            -20981774655*r**2-366474007477*r**4-1632966149964*r**6-7063431076712*r**8
            +15209210557660*r**10+108879672404560*r**12+1050338867405644*r**14+2980767817062358*r**16
            +3981135233305542*r**18+2980767817062358*r**20+1050338867405644*r**22
            +108879672404560*r**24+15209210557660*r**26-7063431076712*r**28-1632966149964*r**30
            -366474007477*r**32-20981774655*r**34+1506986615*r**36)+2*Q2**11*(1209060235
            -849762170*r**2-149262323158*r**4-2576530079493*r**6-14060202772164*r**8
            -101738136053548*r**10-619864767428980*r**12-2055848594686948*r**14-4986668809384414*r**16
            -8639734144999440*r**18-8639734144999440*r**20-4986668809384414*r**22
            -2055848594686948*r**24-619864767428980*r**26-101738136053548*r**28-14060202772164*r**30
            -2576530079493*r**32-149262323158*r**34-849762170*r**36+1209060235*r**38)
            +4*Q2**10*(93943745-5391610320*r**2-46142387464*r**4+821659963758*r**6
            +5223924264189*r**8+53307536837094*r**10+334179331983352*r**12+1576632876196810*r**14
            +5083522936160386*r**16+11127911325178674*r**18+14767093861589152*r**20
            +11127911325178674*r**22+5083522936160386*r**24+1576632876196810*r**26
            +334179331983352*r**28+53307536837094*r**30+5223924264189*r**32+821659963758*r**34
            -46142387464*r**36-5391610320*r**38+93943745*r**40)-2*Q2**9*(554826980
            -7485295995*r**2-133068336997*r**4+244682938999*r**6+6005313896633*r**8
            +67419833220716*r**10+325461217840056*r**12+1810108029452512*r**14+6250294669142776*r**16
            +17013159109607802*r**18+30080845447308118*r**20+30080845447308118*r**22
            +17013159109607802*r**24+6250294669142776*r**26+1810108029452512*r**28
            +325461217840056*r**30+67419833220716*r**32+6005313896633*r**34+244682938999*r**36
            -133068336997*r**38-7485295995*r**40+554826980*r**42)+Q2**8*(254966540
            +1236759305*r**2-70562537476*r**4-1541350533866*r**6+688071957244*r**8
            +49859077697957*r**10+167640550295916*r**12+733761736930344*r**14-1592608741842104*r**16
            -2275002673420974*r**18+1681999736287560*r**20+5130698904863108*r**22
            +1681999736287560*r**24-2275002673420974*r**26-1592608741842104*r**28
            +733761736930344*r**30+167640550295916*r**32+49859077697957*r**34+688071957244*r**36
            -1541350533866*r**38-70562537476*r**40+1236759305*r**42+254966540*r**44)
            +Q2**7*(257374565-6819810780*r**2-67735950826*r**4+1689711305593*r**6
            +7989204349589*r**8+30886124210326*r**10+52865484481788*r**12+209624231648145*r**14
            +5875855652725290*r**16+12647320766702736*r**18+30755251638163876*r**20
            +44502916453759698*r**22+44502916453759698*r**24+30755251638163876*r**26
            +12647320766702736*r**28+5875855652725290*r**30+209624231648145*r**32
            +52865484481788*r**34+30886124210326*r**36+7989204349589*r**38+1689711305593*r**40
            -67735950826*r**42-6819810780*r**44+257374565*r**46)-Q2**6*(145773660
            -2703426945*r**2-54127275634*r**4+440200963881*r**6+6813517841788*r**8
            +69490051440685*r**10+239365857486102*r**12+941345441043419*r**14+4563885491977300*r**16
            +2836216089108054*r**18+16661192658084188*r**20+17061051493383162*r**22
            +17524460567200680*r**24+17061051493383162*r**26+16661192658084188*r**28
            +2836216089108054*r**30+4563885491977300*r**32+941345441043419*r**34+239365857486102*r**36
            +69490051440685*r**38+6813517841788*r**40+440200963881*r**42-54127275634*r**44
            -2703426945*r**46+145773660*r**48)-3*Q2**5*(5412343-315340055*r**2+1031849142*r**4
            +156981953966*r**6-427353981952*r**8-15625374624744*r**10-97554742491338*r**12
            -585919343773922*r**14-1805670219049245*r**16-3419343148022819*r**18-8237931274888724*r**20
            -945902788444836*r**22+1988611549402184*r**24+1988611549402184*r**26-945902788444836*r**28
            -8237931274888724*r**30-3419343148022819*r**32-1805670219049245*r**34
            -585919343773922*r**36-97554742491338*r**38-15625374624744*r**40-427353981952*r**42
            +156981953966*r**44+1031849142*r**46-315340055*r**48+5412343*r**50)-54*(
            -1+r**4)**2*(2611-133053*r**2-1299277*r**4+92539448*r**6-112480402*r**8
            -4386153122*r**10-86696902802*r**12-756840756392*r**14-2344406929667*r**16
            -11876203277267*r**18+1332694288253*r**20+77840920357488*r**22-508020350180412*r**24
            +856477749849188*r**26-508020350180412*r**28+77840920357488*r**30+1332694288253*r**32
            -11876203277267*r**34-2344406929667*r**36-756840756392*r**38-86696902802*r**40
            -4386153122*r**42-112480402*r**44+92539448*r**46-1299277*r**48-133053*r**50
            +2611*r**52)+3*Q2**4*(10590484-338813741*r**2-3607406312*r**4+130604170064*r**6
            +384842125028*r**8-1921569749842*r**10-49453227442412*r**12-423328852910192*r**14
            -1430489476221056*r**16-6149717443283747*r**18-8568644416690412*r**20
            -4902521013385952*r**22-3396872968724152*r**24-9906307215715516*r**26
            -3396872968724152*r**28-4902521013385952*r**30-8568644416690412*r**32
            -6149717443283747*r**34-1430489476221056*r**36-423328852910192*r**38-49453227442412*r**40
            -1921569749842*r**42+384842125028*r**44+130604170064*r**46-3607406312*r**48
            -338813741*r**50+10590484*r**52)-9*Q2**3*(615097-15605586*r**2-423285434*r**4
            +3859764009*r**6+88100984714*r**8+1305168753348*r**10+1489314291108*r**12
            -1584922636662*r**14-16238266875641*r**16-817853094803926*r**18+1004531651549858*r**20
            -2057777538829897*r**22+777000962830668*r**24-392765449551656*r**26-392765449551656*r**28
            +777000962830668*r**30-2057777538829897*r**32+1004531651549858*r**34-817853094803926*r**36
            -16238266875641*r**38-1584922636662*r**40+1489314291108*r**42+1305168753348*r**44
            +88100984714*r**46+3859764009*r**48-423285434*r**50-15605586*r**52+615097*r**54)
            -9*Q2**2*(289292-13706609*r**2-45992470*r**4+8384372615*r**6-24700802396*r**8
            -915788744498*r**10-6264753812924*r**12-53282867581714*r**14-184841526583348*r**16
            -357161128510791*r**18-2304095011239498*r**20+3665334636741521*r**22-5421525512647804*r**24
            -2148997893660188*r**26+3026275227757624*r**28-2148997893660188*r**30
            -5421525512647804*r**32+3665334636741521*r**34-2304095011239498*r**36
            -357161128510791*r**38-184841526583348*r**40-53282867581714*r**42-6264753812924*r**44
            -915788744498*r**46-24700802396*r**48+8384372615*r**50-45992470*r**52
            -13706609*r**54+289292*r**56)+27*Q2*(43821-2060297*r**2-16902496*r**4
            +1299502380*r**6-1562692643*r**8-85699263377*r**10-1017773552332*r**12
            -9238104726012*r**14-30607405490667*r**16-107769792008657*r**18-228932092263652*r**20
            +933754376754648*r**22-2581418815380867*r**24+494256736968143*r**26+1029413539072008*r**28
            +1029413539072008*r**30+494256736968143*r**32-2581418815380867*r**34+933754376754648*r**36
            -228932092263652*r**38-107769792008657*r**40-30607405490667*r**42-9238104726012*r**44
            -1017773552332*r**46-85699263377*r**48-1562692643*r**50+1299502380*r**52
            -16902496*r**54-2060297*r**56+43821*r**58))*sqrtq2))*math.log(mu0))/(210000*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2+210000*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2+logq2**8*(20316635136000000*r**36*(1
            +r**2)**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+20316635136000000*r**36*(1
            +r**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2*(-30240000*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4
            -Q2**3*(1+r**2)-2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4
            +r**6)+4*(1-9*r**2-44*r**4-9*r**6+r**8))-30240000*(-Q2+(-1+r)**2)**3*r**8*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4-Q2**3*(1+r**2)
            -2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4+r**6)+4*(1-9*r**2
            -44*r**4-9*r**6+r**8))*sqrtq2)+logq2**7*(-451480780800000*r**32*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))-451480780800000*r**32*(1+r**2)*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))*sqrtq2)+logq2**3*(-7257600000*(-Q2+(-1+r)**2)**3*r**16*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)
            -Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2+683*r**4+169*r**6)
            +2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)+6*Q2**3*(31+230*r**2
            +159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4
            +8368*r**6+6523*r**8+1184*r**10-131*r**12)-9*Q2*(13+5*r**2-1493*r**4
            -5245*r**6-5245*r**8-1493*r**10+5*r**12+13*r**14)+36*(4-67*r**2-28*r**4
            +2331*r**6+5600*r**8+2331*r**10-28*r**12-67*r**14+4*r**16))-7257600000*(
            -Q2+(-1+r)**2)**3*r**16*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)-Q2**6*(333+410*r**2+333*r**4)
            -Q2**5*(169+683*r**2+683*r**4+169*r**6)+2*Q2**4*(275-725*r**2-3408*r**4
            -725*r**6+275*r**8)+6*Q2**3*(31+230*r**2+159*r**4+159*r**6+230*r**8
            +31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4+8368*r**6+6523*r**8+1184*r**10
            -131*r**12)-9*Q2*(13+5*r**2-1493*r**4-5245*r**6-5245*r**8-1493*r**10
            +5*r**12+13*r**14)+36*(4-67*r**2-28*r**4+2331*r**6+5600*r**8+2331*r**10
            -28*r**12-67*r**14+4*r**16))*sqrtq2)+logq2**2*(1814400000*(-Q2+(-1
            +r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8
            -4*Q2**7*(1+r**2)-Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4
            +5*r**6)+Q2**4*(85-226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1
            -54*r**2-143*r**4-143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4
            +3168*r**6+2871*r**8+468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4
            -2833*r**6-2833*r**8-565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4
            +4368*r**6+11718*r**8+4368*r**10-56*r**12-96*r**14+5*r**16))+1814400000*(
            -Q2+(-1+r)**2)**3*r**12*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8
            -4*Q2**7*(1+r**2)-Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4
            +5*r**6)+Q2**4*(85-226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1
            -54*r**2-143*r**4-143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4
            +3168*r**6+2871*r**8+468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4
            -2833*r**6-2833*r**8-565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4
            +4368*r**6+11718*r**8+4368*r**10-56*r**12-96*r**14+5*r**16))*sqrtq2)
            +logq2**5*(-627056640000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1
            +r**2)-Q2**6*(219+310*r**2+219*r**4)-Q2**5*(977+2179*r**2+2179*r**4
            +977*r**6)+Q2**4*(590-2090*r**2-6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243
            +10*r**2-2073*r**4-2073*r**6+10*r**8+243*r**10)+Q2**2*(-879+8076*r**2
            +41127*r**4+61272*r**6+41127*r**8+8076*r**10-879*r**12)+Q2*(-741+3075*r**2
            +31341*r**4+67125*r**6+67125*r**8+31341*r**10+3075*r**12-741*r**14)
            +12*(41-573*r**2+28*r**4+12789*r**6+25830*r**8+12789*r**10+28*r**12
            -573*r**14+41*r**16))-627056640000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)-Q2**5*(977
            +2179*r**2+2179*r**4+977*r**6)+Q2**4*(590-2090*r**2-6768*r**4-2090*r**6
            +590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4-2073*r**6+10*r**8+243*r**10)
            +Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6+41127*r**8+8076*r**10
            -879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6+67125*r**8+31341*r**10
            +3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4+12789*r**6+25830*r**8
            +12789*r**10+28*r**12-573*r**14+41*r**16))*sqrtq2)+logq2**4*(130636800000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219
            +310*r**2+219*r**4)-24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415
            -1180*r**2-4598*r**4-1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4
            -677*r**6+155*r**8+102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6
            +18377*r**8+3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6
            -3030*r**8-1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4
            +24556*r**6+53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))+130636800000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2
            +219*r**4)-24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415-1180*r**2
            -4598*r**4-1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4-677*r**6
            +155*r**8+102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6+18377*r**8
            +3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8
            -1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6
            +53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))*sqrtq2)+logq2**6*(2508226560000*r**28*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(16*Q2**8+332*Q2**7*(1
            +r**2)+Q2**6*(153+370*r**2+153*r**4)-Q2**5*(2011+4817*r**2+4817*r**4
            +2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4-2410*r**6+295*r**8)+6*Q2**3*(559
            -310*r**2-4869*r**4-4869*r**6-310*r**8+559*r**10)-3*Q2**2*(479-4496*r**2
            -22867*r**4-35272*r**6-22867*r**8-4496*r**10+479*r**12)-9*Q2*(187
            -865*r**2-5807*r**4-10315*r**6-10315*r**8-5807*r**10-865*r**12+187*r**14)
            +9*(109-1432*r**2+392*r**4+26376*r**6+49910*r**8+26376*r**10+392*r**12
            -1432*r**14+109*r**16))+2508226560000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(16*Q2**8+332*Q2**7*(1+r**2)+Q2**6*(153+370*r**2+153*r**4)
            -Q2**5*(2011+4817*r**2+4817*r**4+2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4
            -2410*r**6+295*r**8)+6*Q2**3*(559-310*r**2-4869*r**4-4869*r**6-310*r**8
            +559*r**10)-3*Q2**2*(479-4496*r**2-22867*r**4-35272*r**6-22867*r**8
            -4496*r**10+479*r**12)-9*Q2*(187-865*r**2-5807*r**4-10315*r**6-10315*r**8
            -5807*r**10-865*r**12+187*r**14)+9*(109-1432*r**2+392*r**4+26376*r**6
            +49910*r**8+26376*r**10+392*r**12-1432*r**14+109*r**16))*sqrtq2))+((4*r**2*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))*(92*Q2**18+60*Q2**17*(1+r**2)+4*Q2**16*(
            -1519+3228*r**2+1499*r**4)-Q2**15*(-34969+160589*r**2+1046341*r**4
            +72623*r**6)+Q2**14*(-94735+776500*r**2+10808350*r**4+8852676*r**6+299825*r**8)
            -Q2**13*(-135799+1877655*r**2+43289452*r**4+82368756*r**6+29535579*r**8
            +576101*r**10)+Q2**12*(-76245+2114840*r**2+79598981*r**4+277504064*r**6
            +239240429*r**8+38482536*r**10+381315*r**12)+Q2**11*(-56927+50819*r**2
            -41680119*r**4-387002253*r**6-530987613*r**8-237317447*r**10+20511955*r**12
            +493297*r**14)-Q2**10*(-101673+2723028*r**2+87830460*r**4-63891428*r**6
            +60797850*r**8+280696044*r**10+261376636*r**12+122446116*r**14+1074711*r**16)
            +Q2**9*(9295+1716825*r**2+153045270*r**4+436523258*r**6+1396512740*r**8
            +3429691340*r**10+2103692810*r**12+851014790*r**14+112792173*r**16+341275*r**18)
            +Q2**8*(-120549+2320560*r**2-37227201*r**4-528837568*r**6-1065281922*r**8
            -4841499376*r**10-6297176130*r**12-1670586336*r**14-590459833*r**16+54890208*r**18
            +889251*r**20)-Q2**7*(-89635+3712335*r**2+105058067*r**4-340834967*r**6
            +511955778*r**8+1046459542*r**10+777200710*r**12-778030638*r**14+1950721473*r**16
            +357891963*r**18+168225927*r**20+994085*r**22)+Q2**6*(10907+875276*r**2
            +89263870*r**4-158583284*r**6+193046501*r**8+5395152088*r**10+19515767172*r**12
            +17554642744*r**14+8434570341*r**16+3289645276*r**18+764189182*r**20
            +76673404*r**22+70043*r**24)+Q2**5*(-48803+1674323*r**2+9932888*r**4
            -178260472*r**6+848638885*r**8-1763653493*r**10-16900419912*r**12-39203740728*r**14
            -12693116089*r**16-8386679415*r**18+37241456*r**20-323302736*r**22+63392055*r**24
            +508441*r**26)-Q2**4*(-21065+1300200*r**2+41907245*r**4-417821216*r**6
            +224047815*r**8+975854760*r**10-701297035*r**12-14255612160*r**14-29566065683*r**16
            +20178975160*r**18-714459345*r**20+2445366560*r**22+131177365*r**24+76375224*r**26
            +316975*r**28)+Q2**3*(5283-7655*r**2+13345903*r**4-193648251*r**6-570114849*r**8
            -152368323*r**10-3295991205*r**12-11620863591*r**14+4354598937*r**16
            -12379537797*r**18+26031776957*r**20+3845099135*r**22+1061850213*r**24
            +170056239*r**26+14144121*r**28-9117*r**30)+Q2**2*(-7825+391060*r**2
            +5478336*r**4-108011956*r**6+403896324*r**8+279101876*r**10+2821795840*r**12
            +18885157708*r**14+18283866522*r**16+6908662492*r**18-12997085632*r**20
            +3267499140*r**22-3037842044*r**24+600798684*r**26-57506816*r**28+15657956*r**30
            +84335*r**32)-3*Q2*(-907+59419*r**2+1384374*r**4-40213254*r**6+35892346*r**8
            -134272058*r**10-2180654706*r**12+53763714*r**14-2428061692*r**16-7896633092*r**18
            +23365152962*r**20-15426377970*r**22+4793498550*r**24-336016054*r**26
            +191370746*r**28-2026122*r**30+3122007*r**32+11737*r**34)+3*(-113+8848*r**2
            +237471*r**4-9760736*r**6+6254580*r**8-82272976*r**10-1391081884*r**12
            +1374664192*r**14-13813606422*r**16+43249613040*r**18-52589566534*r**20
            +29995134624*r**22-8274408172*r**24+1532131152*r**26-39342620*r**28+41405248*r**30
            +60287*r**32+528384*r**34+1631*r**36))+4*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(736*Q2**22-164*Q2**21*(1+r**2)+8*Q2**20*(-6209+12830*r**2
            +5863*r**4)-20*Q2**19*(-16107+66795*r**2+425321*r**4+31155*r**6)+5*Q2**18*(
            -191935+1396628*r**2+18982358*r**4+15714020*r**6+573089*r**8)-2*Q2**17*(
            -743353+9181315*r**2+210439090*r**4+398849530*r**6+146667235*r**8+3090527*r**10)
            +Q2**16*(-810729+22144926*r**2+881714845*r**4+3089930340*r**6+2671394545*r**8
            +456317406*r**10+4784571*r**12)+4*Q2**15*(-262898+764215*r**2-150861544*r**4
            -1340268435*r**6-1965172890*r**8-881680183*r**10+28555120*r**12+1497871*r**14)
            -20*Q2**14*(-93439+2025190*r**2+50476392*r**4-115760126*r**6-243169743*r**8
            -99985982*r**10+92556030*r**12+72542542*r**14+777440*r**16)+20*Q2**13*(
            -3010+1456929*r**2+111635934*r**4+325781616*r**6+949127860*r**8+2135860308*r**10
            +1353719658*r**12+589236664*r**14+83141990*r**16+310787*r**18)+4*Q2**12*(
            -535171+9331010*r**2-181465215*r**4-2963189550*r**6-10276258125*r**8
            -33297080804*r**10-35914992495*r**12-11567244990*r**14-3072315480*r**16
            +161712590*r**18+3717974*r**20)-4*Q2**11*(-407524+16519711*r**2+488043590*r**4
            -1921351425*r**6-6025344060*r**8-34993132166*r**10-60171084836*r**12
            -35195915610*r**14-199576200*r**16+817140815*r**18+704045446*r**20+4577651*r**22)
            +2*Q2**10*(318279+4140240*r**2+982978502*r**4+769342920*r**6+8079031035*r**8
            +13582344856*r**10+42152523300*r**12+45037217288*r**14+62067170885*r**16
            +35911777560*r**18+8757214614*r**20+710194160*r**22-453063*r**24)+20*Q2**9*(
            -71399+2452840*r**2+18798472*r**4-477432212*r**6-1516769741*r**8-9461408242*r**10
            -33881513380*r**12-66187424212*r**14-39234036757*r**16-21145306736*r**18
            -3127531220*r**20-609463880*r**22+80244697*r**24+711370*r**26)-10*Q2**8*(
            -34105+2995558*r**2+141045673*r**4-974323856*r**6-1130956499*r**8-14544085038*r**10
            -56616655057*r**12-211406379568*r**14-247458855871*r**16-63840564102*r**18
            -29984342153*r**20+2381844544*r**22+424346443*r**24+193942990*r**26+689969*r**28)
            -4*Q2**7*(-134514+3890235*r**2-99348440*r**4-25783395*r**6-1129268990*r**8
            +8891096539*r**10-32352779520*r**12+90227215265*r**14+275486365090*r**16
            +188817996105*r**18-153500580376*r**20-46982782425*r**22-15990252690*r**24
            -2807960255*r**26+6986640*r**28+1046331*r**30)+4*Q2**6*(-90181+5272454*r**2
            +111293140*r**4-1997881230*r**6+352771815*r**8+8104054886*r**10-48795009914*r**12
            -408055557590*r**14-1154903353125*r**16-1062373628990*r**18-766724823704*r**20
            -261962637994*r**22-103684435335*r**24-5397166830*r**26-1251959810*r**28
            +240196814*r**30+1173194*r**32)-4*Q2**5*(10913+391900*r**2+69513774*r**4
            -1080609260*r**6+1335602940*r**8+200219702*r**10+27021416430*r**12-256778954884*r**14
            -1452661624970*r**16-2738316873530*r**18-1126798664758*r**20-1012961279940*r**22
            -3750177844*r**24-36966938670*r**26+5070769690*r**28+614729268*r**30
            +83498785*r**32+58454*r**34)-20*Q2**4*(-5603+314730*r**2+1921509*r**4
            -103644366*r**6+256539277*r**8+4461509120*r**10+102549015*r**12-11810540434*r**14
            +32699137687*r**16+224241654616*r**18+436852355289*r**20-240878254290*r**22
            +24296863191*r**24-30911507896*r**26-6742984043*r**28-868557006*r**30
            -170253080*r**32+10201334*r**34+64150*r**36)+60*Q2**3*(-405+37606*r**2
            +1103021*r**4-38480558*r**6+139231104*r**8+1105706196*r**10+2296093892*r**12
            +2286272464*r**14+15646171846*r**16+20489197320*r**18-4704403122*r**20
            +38359259308*r**22-106763697016*r**24-42030495588*r**26-3742305372*r**28
            -1948299344*r**30-25594681*r**32-14112094*r**34+2356125*r**36+7298*r**38)
            +3*Q2**2*(-4313+230260*r**2-3126990*r**4+15667060*r**6-58556705*r**8
            +5614189792*r**10-24588920600*r**12-141108574560*r**14-468178935250*r**16
            -2451613456600*r**18-1949622466788*r**20-755144441880*r**22+1851832881590*r**24
            -732358578880*r**26+472408852040*r**28-40098187648*r**30+1342331595*r**32
            -898532540*r**34-174530430*r**36+1803140*r**38+37707*r**40)-18*Q2*(
            -397+31013*r**2+248190*r**4-26348410*r**6+178447315*r**8+1583713473*r**10
            -1272858112*r**12+12536987360*r**14+108715887310*r**16-63624780190*r**18
            +367116721868*r**20+157435300988*r**22-1075475371290*r**24+668805592610*r**26
            -155239831440*r**28-14488694192*r**30-4984570817*r**32-1186756135*r**34
            -54414010*r**36-20533810*r**38+1223623*r**40+5053*r**42)+9*(-113+10430*r**2
            +124221*r**4-13915460*r**6+120458625*r**8+744356342*r**10-690302965*r**12
            +28486145456*r**14+98860868230*r**16+126814542300*r**18+619758474002*r**20
            -3104449405560*r**22+3895904772306*r**24-1922665264580*r**26+283783738150*r**28
            +2408722672*r**30-26605651205*r**32-1809481114*r**34-632078815*r**36
            -9129700*r**38-7490403*r**40+505550*r**42+1631*r**44))*sqrtq2+logq2**6*(2351462400000*(
            -Q2+(-1+r)**2)*(-1+r)*r**26*(1+r)*(1+r**2)*(1-Q2+r**2)*(-1-4*r**2
            +r**4)*(-Q2+(1+r)**2)+2351462400000*r**26*(1+4*r**2-2*r**4-4*r**6
            +r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**5*(-3732480000*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(70*Q2**7*(1+r**2)-10*Q2**6*(23+76*r**2
            +53*r**4)+10*Q2**5*(-23+125*r**2+305*r**4+157*r**6)-2*Q2**4*(-858-1351*r**2
            +1389*r**4+2903*r**6+1133*r**8)+4*Q2**3*(-411-1663*r**2-1744*r**4+554*r**6
            +1372*r**8+326*r**10)+2*Q2**2*(-612+853*r**2+4453*r**4+3032*r**6-664*r**8
            -595*r**10+337*r**12)-3*Q2*(-957-1022*r**2+1047*r**4+1068*r**6-735*r**8
            -498*r**10+645*r**12+452*r**14)+3*(-443-589*r**2-2175*r**4-1587*r**6
            +4321*r**8+989*r**10-985*r**12+291*r**14+178*r**16))+3732480000*r**22*(70*Q2**10*(1
            +r**2)-20*Q2**9*(22+59*r**2+37*r**4)+10*Q2**8*(67+457*r**2+727*r**4
            +337*r**6)-2*Q2**7*(-823+1549*r**2+9669*r**4+11503*r**6+4318*r**8)
            +14*Q2**6*(-518-1149*r**2+268*r**4+2962*r**6+3016*r**8+953*r**10)+Q2**5*(9086
            +36652*r**2+49978*r**4+8436*r**6-47814*r**8-44996*r**10-11606*r**12)
            +5*Q2**4*(-21-4522*r**2-13389*r**4-14272*r**6-4211*r**8+5058*r**10
            +4445*r**12+560*r**14)-3*(-1+r**2)**3*(443+1475*r**2+4239*r**4+8001*r**6
            +5267*r**8-43*r**10-47*r**12+647*r**14+178*r**16)+2*Q2**3*(-5985-5950*r**2
            +9419*r**4+20598*r**6+23613*r**8+8606*r**10-699*r**12+2170*r**14+2660*r**16)
            -2*Q2**2*(-6912-10649*r**2-10887*r**4-16467*r**6+9615*r**8+25745*r**10
            +2747*r**12-1801*r**14+5437*r**16+3172*r**18)+6*Q2*(-1143-1359*r**2
            -3003*r**4-5396*r**6-304*r**8+3532*r**10+7466*r**12+720*r**14-1717*r**16
            +711*r**18+493*r**20))*sqrtq2)+logq2**4*(-10368000*r**18*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-1120*Q2**11+40*Q2**10*(343+463*r**2)
            -20*Q2**9*(3579+9401*r**2+5598*r**4)+16*Q2**8*(12476+47750*r**2+57837*r**4
            +21419*r**6)-4*Q2**7*(78047+391017*r**2+709339*r**4+544057*r**6+135368*r**8)
            +Q2**6*(266133+1567540*r**2+3800814*r**4+4400212*r**6+2291461*r**8+272832*r**10)
            +2*Q2**5*(-74123-361111*r**2-1140282*r**4-1039682*r**6-480911*r**8-6795*r**10
            +220528*r**12)+Q2**4*(127225+661490*r**2+3762451*r**4+1950140*r**6-5468913*r**8
            -5369086*r**10-2200635*r**12-756560*r**14)+12*Q2**3*(-5208-81095*r**2
            -509668*r**4-1039559*r**6-339684*r**8+699975*r**10+506372*r**12+145619*r**14
            +23848*r**16)+3*Q2**2*(-32539+42016*r**2-140156*r**4+3159048*r**6+5155610*r**8
            +1061288*r**10-877892*r**12-176040*r**14-97119*r**16+70584*r**18)-18*Q2*(
            -6999-34505*r**2-390024*r**4-140416*r**6+448558*r**8+65590*r**10-250860*r**12
            +118784*r**14+169481*r**16+8467*r**18+11924*r**20)+9*(-4381-34582*r**2
            -417725*r**4-330832*r**6-95334*r**8+393676*r**10+520586*r**12-228240*r**14
            +14467*r**16+171594*r**18+4915*r**20+5856*r**22))+10368000*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1120*Q2**11-40*Q2**10*(343+463*r**2)
            +20*Q2**9*(3579+9401*r**2+5598*r**4)-16*Q2**8*(12476+47750*r**2+57837*r**4
            +21419*r**6)+4*Q2**7*(78047+391017*r**2+709339*r**4+544057*r**6+135368*r**8)
            -Q2**6*(266133+1567540*r**2+3800814*r**4+4400212*r**6+2291461*r**8+272832*r**10)
            +Q2**5*(148246+722222*r**2+2280564*r**4+2079364*r**6+961822*r**8+13590*r**10
            -441056*r**12)+Q2**4*(-127225-661490*r**2-3762451*r**4-1950140*r**6
            +5468913*r**8+5369086*r**10+2200635*r**12+756560*r**14)-12*Q2**3*(-5208
            -81095*r**2-509668*r**4-1039559*r**6-339684*r**8+699975*r**10+506372*r**12
            +145619*r**14+23848*r**16)-3*Q2**2*(-32539+42016*r**2-140156*r**4+3159048*r**6
            +5155610*r**8+1061288*r**10-877892*r**12-176040*r**14-97119*r**16+70584*r**18)
            +18*Q2*(-6999-34505*r**2-390024*r**4-140416*r**6+448558*r**8+65590*r**10
            -250860*r**12+118784*r**14+169481*r**16+8467*r**18+11924*r**20)-9*(
            -4381-34582*r**2-417725*r**4-330832*r**6-95334*r**8+393676*r**10+520586*r**12
            -228240*r**14+14467*r**16+171594*r**18+4915*r**20+5856*r**22))*sqrtq2)
            +logq2**3*(-691200*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-6040*Q2**14
            +40*Q2**13*(1594+1717*r**2)-6*Q2**12*(47066+105627*r**2+56105*r**4)
            +4*Q2**11*(166353+615914*r**2+672236*r**4+218475*r**6)-4*Q2**10*(213954
            +1233470*r**2+2160818*r**4+1486603*r**6+277725*r**8)+30*Q2**9*(17658
            +159933*r**2+373524*r**4+406142*r**6+203128*r**8+2091*r**10)+10*Q2**8*(
            -8730-81919*r**2+406781*r**4+1318228*r**6+729770*r**8+127157*r**10
            +179709*r**12)-Q2**7*(14103+2215166*r**2+30766055*r**4+93813080*r**6
            +108457305*r**8+49318958*r**10+10896361*r**12+2134140*r**14)+3*Q2**6*(43947
            +359211*r**2+11650609*r**4+48168485*r**6+84376685*r**8+63097297*r**10
            +18606971*r**12+3683359*r**14+75900*r**16)+Q2**5*(-417443-154480*r**2
            -14503246*r**4-79196236*r**6-205266820*r**8-222991528*r**10-86498170*r**12
            +10443884*r**14-1054561*r**16+1426600*r**18)-5*Q2**4*(-69205-403917*r**2
            -1535816*r**4-7263066*r**6-22070188*r**8-7836032*r**10+16436874*r**12
            +21608978*r**14+13610857*r**16+1284133*r**18+216038*r**20)+15*Q2**3*(2201
            -157626*r**2-654129*r**4-4963312*r**6-16774294*r**8-16901308*r**10+5812862*r**12
            +15167456*r**14+9309725*r**16+2630070*r**18+306323*r**20+1232*r**22)
            +3*Q2**2*(-59967+26301*r**2-1108055*r**4+9244205*r**6+37514770*r**8
            +138715514*r**10+94138698*r**12-4616870*r**14-16613515*r**16-16724055*r**18
            +4344493*r**20-24359*r**22+106840*r**24)-9*Q2*(-9483-110254*r**2-1226156*r**4
            -4956660*r**6-27575015*r**8+5724286*r**10+23727088*r**12-9829088*r**14
            +1175335*r**16+11255590*r**18-469828*r**20+2159316*r**22+118219*r**24
            +16650*r**26)+9*(-1349-41985*r**2-471498*r**4-2888708*r**6-19012105*r**8
            +4372743*r**10+20073990*r**12-3066584*r**14-7941439*r**16+2125205*r**18
            +6265906*r**20-12580*r**22+559757*r**24+36197*r**26+2450*r**28))-691200*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(6040*Q2**15-40*Q2**14*(1745+1868*r**2)
            +Q2**13*(346156+766202*r**2+405310*r**4)-2*Q2**12*(473904+1689907*r**2
            +1829668*r**4+605265*r**6)+4*Q2**11*(380307+2015737*r**2+3448968*r**4
            +2377314*r**6+496200*r**8)-2*Q2**10*(692778+5293843*r**2+12391436*r**4
            +13386972*r**6+6575576*r**8+586815*r**10)-20*Q2**9*(-30852-307346*r**2
            -596795*r**4-510385*r**6-549020*r**8-244250*r**10+86718*r**12)+Q2**8*(
            -73197+1308676*r**2+34014675*r**4+111063170*r**6+128937285*r**8+57888228*r**10
            +13965021*r**12+3931230*r**14)-2*Q2**7*(72972+1653451*r**2+33966524*r**4
            +134542295*r**6+227700220*r**8+173534077*r**10+58018116*r**12+12040289*r**14
            +1180920*r**16)+2*Q2**6*(274642+681977*r**2+25266353*r**4+129326759*r**6
            +301451165*r**8+332706737*r**10+165805487*r**12+28213553*r**14+6166169*r**16
            -599450*r**18)+2*Q2**5*(-381734-1295754*r**2-11168403*r**4-65007406*r**6
            -197406998*r**8-233719254*r**10-113652664*r**12+15995302*r**14+38721804*r**16
            +3396352*r**18+1253395*r**20)-10*Q2**4*(-31301-473000*r**2-1951060*r**4
            -11844409*r**6-39828068*r**8-40305072*r**10+13019714*r**12+41774110*r**14
            +31574505*r**16+11392600*r**18+1209570*r**20+109867*r**22)-6*Q2**3*(
            -35486+401713*r**2+1475360*r**4+18665705*r**6+73101400*r**8+153546762*r**10
            +74790464*r**12-54759230*r**14-69499710*r**16-38211515*r**18-5168736*r**20
            -781067*r**22+50340*r**24)+6*Q2**2*(-44208-182214*r**2-2380111*r**4
            -3366915*r**6-17983035*r**8+96701571*r**10+152017738*r**12+30017282*r**14
            -8852190*r**16+214600*r**18-6894523*r**20+5399041*r**22+218569*r**24
            +78395*r**26)-18*Q2*(-5416-80861*r**2-903954*r**4-4535762*r**6-25771890*r**8
            -8738993*r**10+24762682*r**12+5415708*r**14-8297596*r**16+7278065*r**18
            +8525834*r**20+838454*r**22+1418646*r**24+85533*r**26+9550*r**28)+9*(
            -1349-43334*r**2-513483*r**4-3360206*r**6-21900813*r**8-14639362*r**10
            +24446733*r**12+17007406*r**14-11008023*r**16-5816234*r**18+8391111*r**20
            +6253326*r**22+547177*r**24+595954*r**26+38647*r**28+2450*r**30))*sqrtq2)
            +logq2**2*(2880*r**10*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17
            -8*Q2**16*(135817+150101*r**2)+8*Q2**15*(609837+1424108*r**2+709791*r**4)
            -8*Q2**14*(1497790+5665821*r**2+6164498*r**4+1670155*r**6)+8*Q2**13*(2052205
            +11807174*r**2+19627106*r**4+13279952*r**6+1570775*r**8)+Q2**12*(-9276675
            -97625268*r**2-162375498*r**4-170092020*r**6-87823939*r**8+10951320*r**10)
            -4*Q2**11*(1841403-2378739*r**2+72594868*r**4+176570458*r**6+97819623*r**8
            +24693229*r**10+9892734*r**12)+2*Q2**10*(9261111+50180850*r**2+514798421*r**4
            +1698206280*r**6+1881190105*r**8+716700482*r**10+157336027*r**12+14469828*r**14)
            +4*Q2**9*(-3352365-32232891*r**2-271078323*r**4-1352556375*r**6-2375510525*r**8
            -1673827605*r**10-350439261*r**12-63361633*r**14+4846770*r**16)+Q2**8*(
            -2729705+88671816*r**2+290389124*r**4+2654978408*r**6+6371797290*r**8
            +7327078400*r**10+3114119876*r**12-691377336*r**14-92962057*r**16-42913400*r**18)
            +8*Q2**7*(1747270-4971133*r**2+15127487*r**4+266907120*r**6+1492747966*r**8
            +2719556390*r**10+1861043472*r**12+853863832*r**14+317972780*r**16+40114391*r**18
            +1878665*r**20)+4*Q2**6*(-2456967-4677472*r**2+23073081*r**4-603032454*r**6
            -5851481694*r**8-16113018636*r**10-17957269110*r**12-8332675944*r**14
            -2848468779*r**16-372895044*r**18-46067315*r**20+4119774*r**22)-8*Q2**5*(229304
            -8600451*r**2-13472499*r**4-7450835*r**6-1468763325*r**8-6396000186*r**10
            -11704337214*r**12-7844229138*r**14-1198700610*r**16-511036475*r**18
            +106568217*r**20+8467725*r**22+1935887*r**24)+Q2**4*(6068155-55416868*r**2
            -529648674*r**4-565030660*r**6-2269446875*r**8-12054143520*r**10-35736518844*r**12
            -25962685992*r**14+17453038725*r**16+29611067900*r**18+4735543390*r**20
            +1370532012*r**22+129316891*r**24+1225160*r**26)+12*Q2**3*(-174505+109941*r**2
            +26994944*r**4+148392198*r**6+449400505*r**8+2459787075*r**10+4694349898*r**12
            +1521190932*r**14-2935005991*r**16-4346643205*r**18-2161639620*r**20
            -407821914*r**22-28949801*r**24-3480307*r**26+289850*r**28)-6*Q2**2*(189515
            -3931222*r**2-17811067*r**4+102589440*r**6+16192019*r**8+4091115470*r**10
            +11119907829*r**12+14975348124*r**14+4310241465*r**16-1116035738*r**18
            -4526104505*r**20+502957768*r**22-109686807*r**24+45159970*r**26+2918719*r**28
            +229020*r**30)+36*Q2*(26931-379535*r**2-4452807*r**4-14409807*r**6
            -176564787*r**8-451164495*r**10-1711459887*r**12+1089967489*r**14+475970739*r**16
            +27232299*r**18+820620947*r**20-372775221*r**22+286607943*r**24+25195443*r**26
            +5163363*r**28+420867*r**30+518*r**32)+9*(-21679+281592*r**2+4639432*r**4
            +30912240*r**6+319818060*r**8+1430620872*r**10+5770391864*r**12-8304862496*r**14
            -4018542330*r**16+8182983880*r**18-268700232*r**20-3464268304*r**22+686961996*r**24
            -329849160*r**26-36352440*r**28-3686336*r**30-332527*r**32+5568*r**34))
            +2880*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17-8*Q2**16*(135817
            +150101*r**2)+8*Q2**15*(609837+1424108*r**2+709791*r**4)-8*Q2**14*(1497790
            +5665821*r**2+6164498*r**4+1670155*r**6)+8*Q2**13*(2052205+11807174*r**2
            +19627106*r**4+13279952*r**6+1570775*r**8)+Q2**12*(-9276675-97625268*r**2
            -162375498*r**4-170092020*r**6-87823939*r**8+10951320*r**10)-4*Q2**11*(1841403
            -2378739*r**2+72594868*r**4+176570458*r**6+97819623*r**8+24693229*r**10
            +9892734*r**12)+2*Q2**10*(9261111+50180850*r**2+514798421*r**4+1698206280*r**6
            +1881190105*r**8+716700482*r**10+157336027*r**12+14469828*r**14)+4*Q2**9*(
            -3352365-32232891*r**2-271078323*r**4-1352556375*r**6-2375510525*r**8
            -1673827605*r**10-350439261*r**12-63361633*r**14+4846770*r**16)+Q2**8*(
            -2729705+88671816*r**2+290389124*r**4+2654978408*r**6+6371797290*r**8
            +7327078400*r**10+3114119876*r**12-691377336*r**14-92962057*r**16-42913400*r**18)
            +8*Q2**7*(1747270-4971133*r**2+15127487*r**4+266907120*r**6+1492747966*r**8
            +2719556390*r**10+1861043472*r**12+853863832*r**14+317972780*r**16+40114391*r**18
            +1878665*r**20)+4*Q2**6*(-2456967-4677472*r**2+23073081*r**4-603032454*r**6
            -5851481694*r**8-16113018636*r**10-17957269110*r**12-8332675944*r**14
            -2848468779*r**16-372895044*r**18-46067315*r**20+4119774*r**22)-8*Q2**5*(229304
            -8600451*r**2-13472499*r**4-7450835*r**6-1468763325*r**8-6396000186*r**10
            -11704337214*r**12-7844229138*r**14-1198700610*r**16-511036475*r**18
            +106568217*r**20+8467725*r**22+1935887*r**24)+Q2**4*(6068155-55416868*r**2
            -529648674*r**4-565030660*r**6-2269446875*r**8-12054143520*r**10-35736518844*r**12
            -25962685992*r**14+17453038725*r**16+29611067900*r**18+4735543390*r**20
            +1370532012*r**22+129316891*r**24+1225160*r**26)+12*Q2**3*(-174505+109941*r**2
            +26994944*r**4+148392198*r**6+449400505*r**8+2459787075*r**10+4694349898*r**12
            +1521190932*r**14-2935005991*r**16-4346643205*r**18-2161639620*r**20
            -407821914*r**22-28949801*r**24-3480307*r**26+289850*r**28)-6*Q2**2*(189515
            -3931222*r**2-17811067*r**4+102589440*r**6+16192019*r**8+4091115470*r**10
            +11119907829*r**12+14975348124*r**14+4310241465*r**16-1116035738*r**18
            -4526104505*r**20+502957768*r**22-109686807*r**24+45159970*r**26+2918719*r**28
            +229020*r**30)+36*Q2*(26931-379535*r**2-4452807*r**4-14409807*r**6
            -176564787*r**8-451164495*r**10-1711459887*r**12+1089967489*r**14+475970739*r**16
            +27232299*r**18+820620947*r**20-372775221*r**22+286607943*r**24+25195443*r**26
            +5163363*r**28+420867*r**30+518*r**32)+9*(-21679+281592*r**2+4639432*r**4
            +30912240*r**6+319818060*r**8+1430620872*r**10+5770391864*r**12-8304862496*r**14
            -4018542330*r**16+8182983880*r**18-268700232*r**20-3464268304*r**22+686961996*r**24
            -329849160*r**26-36352440*r**28-3686336*r**30-332527*r**32+5568*r**34))*sqrtq2)
            +logq2*(96*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(54928*Q2**20-10*Q2**19*(80571
            +66179*r**2)+10*Q2**18*(454635+932826*r**2+315743*r**4)-10*Q2**17*(1276291
            +4810467*r**2+4156451*r**4+713027*r**6)+10*Q2**16*(1673240+11757431*r**2
            +16884235*r**4+8279349*r**6+491705*r**8)+2*Q2**15*(291279-59156055*r**2
            -97945590*r**4-57271710*r**6-13876615*r**8+5923559*r**10)-10*Q2**14*(3179247
            +6569403*r**2+44188566*r**4+120967604*r**6+75147541*r**8+19669647*r**10
            +2857988*r**12)+5*Q2**13*(6433205+60642984*r**2+332390965*r**4+1097862886*r**6
            +1214635191*r**8+416413088*r**10+71427359*r**12+2563602*r**14)+5*Q2**12*(2841111
            -57953133*r**2-397686891*r**4-1861102247*r**6-3137405283*r**8-2048826147*r**10
            -287234445*r**12-19839849*r**14+5847972*r**16)-10*Q2**11*(4707430-926967*r**2
            -54829074*r**4-505111764*r**6-907956088*r**8-915369848*r**10-228097682*r**12
            +224264136*r**14+38356662*r**16+4072315*r**18)+4*Q2**10*(4510077+57863495*r**2
            +319685970*r**4+1470662320*r**6+7814017520*r**8+15640213853*r**10+10006163165*r**12
            +4434888910*r**14+1170745425*r**16+110393910*r**18+307307*r**20)+5*Q2**9*(5179239
            -46755564*r**2-368681911*r**4-2195790494*r**6-12439153626*r**8-38209590004*r**10
            -42558233486*r**12-16668936056*r**14-5253633789*r**16-332977536*r**18
            +1654389*r**20+6524726*r**22)-5*Q2**8*(4790695-9929301*r**2-197781337*r**4
            -1286268433*r**6-6195004898*r**8-34209666554*r**10-64772250554*r**12
            -44191072906*r**14-4893941093*r**16-1309794993*r**18+635093811*r**20
            +64911899*r**22+3840512*r**24)-10*Q2**7*(418313-13654759*r**2-41127194*r**4
            +269462462*r**6-1165420083*r**8-4237010291*r**10-10083900548*r**12-7245547460*r**14
            -8905623285*r**16-9160838453*r**18-1980677810*r**20-352827146*r**22-18460977*r**24
            +878591*r**26)+10*Q2**6*(1260165-14437827*r**2-105316878*r**4+264511880*r**6
            -381884731*r**8-13983361421*r**10-69660249688*r**12-119098406816*r**14
            -79333297209*r**16-39759741061*r**18-9544382366*r**20-2109246552*r**22
            -23532033*r**24+5803877*r**26+1259540*r**28)+Q2**5*(-2662377+10974120*r**2
            +484828155*r**4+1307981450*r**6-5161804645*r**8+33108765192*r**10+526380826495*r**12
            +1549238069610*r**14+1691496856965*r**16+536428413960*r**18+280893888657*r**20
            -12171448290*r**22+2098864585*r**24-1617715640*r**26-97736715*r**28-1429522*r**30)
            -5*Q2**4*(616103-12728853*r**2-43586543*r**4+1216863773*r**6+2902206467*r**8
            -2592019133*r**10+9559984153*r**12+70032535581*r**14+214049147049*r**16
            +74508298201*r**18-130117787973*r**20-16769631217*r**22-12492555863*r**24
            -1835799047*r**26-184875493*r**28-4948297*r**30+677892*r**32)+30*Q2**3*(49245
            -1005552*r**2-8390298*r**4+119452576*r**6+558599956*r**8+1463384198*r**10
            +4420500082*r**12+16969717740*r**14+13720059258*r**16+1342738458*r**18
            -21945512406*r**20-26796182328*r**22-7139162596*r**24-723747334*r**26
            -178221314*r**28+1417388*r**30+417273*r**32+45654*r**34)+30*Q2**2*(8287
            -277846*r**2+897755*r**4+45300500*r**6-28432468*r**8-1149771430*r**10
            -2275208286*r**12-30409099688*r**14-44294454506*r**16-25153597574*r**18
            -6278370596*r**20+21798649780*r**22-2492912204*r**24+2461427062*r**26
            -384866858*r**28-11605536*r**30-7241173*r**32-294388*r**34+9169*r**36)
            -45*Q2*(6425-211762*r**2-781057*r**4+43411204*r**6+82312436*r**8+322380516*r**10
            +4640825532*r**12+4639058012*r**14+19868199534*r**16-9857533632*r**18
            -6747069582*r**20-23382970028*r**22+18100809572*r**24-6819671780*r**26
            -669629844*r**28-191633484*r**30-25702367*r**32-1765902*r**34-39833*r**36
            +6040*r**38)+9*(5787-220735*r**2-1105095*r**4+57261285*r**6+101088130*r**8
            +1458374292*r**10+12154764580*r**12+29670853060*r**14+98584777970*r**16
            -304538439490*r**18+133768147902*r**20+164166435670*r**22-161489742960*r**24
            +35126704580*r**26-6861747660*r**28-2010898828*r**30-153685765*r**32
            -31511255*r**34-1056335*r**36-10355*r**38+5222*r**40))-96*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(54928*Q2**21-2*Q2**20*(430319+358359*r**2)
            +20*Q2**19*(267603+539788*r**2+190961*r**4)-20*Q2**18*(865463+3098964*r**2
            +2702510*r**4+514385*r**6)+10*Q2**17*(2949531+17844189*r**2+25851153*r**4
            +13148827*r**6+1204732*r**8)+2*Q2**16*(-8074921-126309410*r**2-241153920*r**4
            -183089630*r**6-57731885*r**8+3465034*r**10)-2*Q2**15*(16187514-26017761*r**2
            +63841185*r**4+449620720*r**6+304589380*r**8+90395179*r**10+20213499*r**12)
            +5*Q2**14*(12791699+80140284*r**2+433906903*r**4+1428175226*r**6+1606865481*r**8
            +606047464*r**10+116482629*r**12+8279578*r**14)+10*Q2**13*(-1796047-62514661*r**2
            -395360420*r**4-1645678049*r**6-2724951680*r**8-1839937213*r**10-387537446*r**12
            -46915405*r**14+1642185*r**16)-5*Q2**12*(12255971-56965956*r**2-565298172*r**4
            -3269012666*r**6-6814419706*r**8-7016971126*r**10-2792255956*r**12+141453978*r**14
            +62721447*r**16+13992602*r**18)+2*Q2**11*(32557304+134629305*r**2+360591735*r**4
            +141620450*r**6+8562695780*r**8+22163798026*r**10+14294988680*r**12+8850610090*r**14
            +3654594840*r**16+432932705*r**18+20976189*r**20)+Q2**10*(7855887-483272108*r**2
            -3353607415*r**4-18140345630*r**6-99334487490*r**8-284864875512*r**10
            -315376675502*r**12-141108888580*r**14-48690706285*r**16-6789445020*r**18
            -434532923*r**20+31394402*r**22)-10*Q2**9*(4984967-25752813*r**2-306609406*r**4
            -1925370419*r**6-10414974509*r**8-42429205092*r**10-72770037022*r**12
            -51709121224*r**14-13408255469*r**16-3448203159*r**18+151885332*r**20
            +36545507*r**22+5182619*r**24)+5*Q2**8*(3954069+22170912*r**2-125456250*r**4
            -2022974694*r**6-5150433165*r**8-31930650870*r**10-78814116012*r**12
            -94472228540*r**14-31273767429*r**16+12117940820*r**18+3286654438*r**20
            +1405660002*r**22+105674365*r**24+2083330*r**26)+10*Q2**7*(1678478-27674273*r**2
            -160098831*r**4+492847148*r**6-1277842352*r**8-19385791795*r**10-83981160527*r**12
            -136427854824*r**14-95484467954*r**16-57826202799*r**18-20685898629*r**20
            -4442751508*r**22-394820156*r**24-11778509*r**26+2138131*r**28)+Q2**6*(
            -15264027+142750740*r**2+1682375205*r**4-283968570*r**6-3988076135*r**8
            +176761226712*r**10+1362816937585*r**12+3436824634650*r**14+3675813897215*r**16
            +1727358796660*r**18+773935122927*r**20+104364840890*r**22+23426650435*r**24
            -1440434080*r**26-168370885*r**28-14024922*r**30)-2*Q2**5*(209069-27666261*r**2
            +138934780*r**4+3938564235*r**6+5328604570*r**8+7493432441*r**10+303644756226*r**12
            +1212890787005*r**14+2155490330910*r**16+1300233380965*r**18+83366681376*r**20
            +92437142141*r**22-36267681510*r**24-4348923145*r**26-1319914910*r**28
            -61953861*r**30+979969*r**32)+5*Q2**4*(911573-18146062*r**2-106657184*r**4
            +1889992686*r**6+7470669976*r**8+9090492522*r**10+33490965512*r**12+181410826174*r**14
            +366402038178*r**16+296613875998*r**18-187282564208*r**20-307664513158*r**22
            -72097162656*r**24-18670838914*r**26-3090002424*r**28-181319462*r**30
            -1766767*r**32+951816*r**34)-30*Q2**3*(40958-678461*r**2-10293605*r**4
            +65761778*r**6+706485000*r**8+3171755584*r**10+8159092566*r**12+51799317510*r**14
            +74984231504*r**16+40216395290*r**18-14324403352*r**20-70540344514*r**22
            -31442432720*r**24-10324336992*r**26-517101790*r**28-165198390*r**30
            +9075834*r**32+757315*r**34+36485*r**36)-15*Q2**2*(35849-1174404*r**2
            -1103353*r**4+222630122*r**6+280673372*r**8-1389266248*r**10+7072517164*r**12
            -51451441912*r**14-89802509786*r**16-168468705056*r**18-83105145086*r**20
            -39108351716*r**22+92913903868*r**24-20521985624*r**26+2144230876*r**28
            -1367845240*r**30-114800519*r**32-20368828*r**34-689937*r**36+36458*r**38)
            +18*Q2*(18956-623710*r**2-3034595*r**4+135206010*r**6+364853165*r**8
            +1740919526*r**10+18485397410*r**12+38035135390*r**14+110560532850*r**16
            -127242554990*r**18+25372565916*r**20+6758118810*r**22-93950272620*r**24
            +45766196770*r**26-22154127890*r**28-3158607734*r**30-620182510*r**32
            -84426300*r**34-5042505*r**36-89660*r**38+17711*r**40)-9*(5787-214948*r**2
            -1325830*r**4+56156190*r**6+158349415*r**8+1559462422*r**10+13613138872*r**12
            +41825617640*r**14+128255631030*r**16-205953661520*r**18-170770291588*r**20
            +297934583572*r**22+2676692710*r**24-126363038380*r**26+28264956920*r**28
            -8872646488*r**30-2164584593*r**32-185197020*r**34-32567590*r**36-1066690*r**38
            -5133*r**40+5222*r**42))*sqrtq2))*math.log(mus))/(-12600*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-12600*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2+logq2**6*(564350976000*r**26*(1+r**2)*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -564350976000*r**26*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**3*(435456000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))+435456000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))*sqrtq2)+logq2*(1512000*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)
            -Q2**2*(5+2*r**2+5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))+1512000*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)-Q2**2*(5+2*r**2
            +5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))*sqrtq2)+logq2**2*(-9072000*(
            -Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(16*Q2**4+Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1
            +9*r**2+9*r**4+r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))-9072000*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(16*Q2**4
            +Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1+9*r**2+9*r**4
            +r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))*sqrtq2)+logq2**4*(-1306368000*(
            -Q2+(-1+r)**2)*r**18*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))
            -1306368000*(-Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))*sqrtq2)
            +logq2**5*(6270566400*(-Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2
            +41*r**4)-18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4
            -82*r**6+13*r**8))+6270566400*(-Q2+(-1+r)**2)*r**22*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2+41*r**4)
            -18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4-82*r**6
            +13*r**8))*sqrtq2))+((-12*r**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(92*Q2**18
            +60*Q2**17*(1+r**2)+4*Q2**16*(-1519+3228*r**2+1499*r**4)-Q2**15*(-34969
            +160589*r**2+1046341*r**4+72623*r**6)+Q2**14*(-94735+776500*r**2+10808350*r**4
            +8852676*r**6+299825*r**8)-Q2**13*(-135799+1877655*r**2+43289452*r**4
            +82368756*r**6+29535579*r**8+576101*r**10)+Q2**12*(-76245+2114840*r**2
            +79598981*r**4+277504064*r**6+239240429*r**8+38482536*r**10+381315*r**12)
            +Q2**11*(-56927+50819*r**2-41680119*r**4-387002253*r**6-530987613*r**8
            -237317447*r**10+20511955*r**12+493297*r**14)-Q2**10*(-101673+2723028*r**2
            +87830460*r**4-63891428*r**6+60797850*r**8+280696044*r**10+261376636*r**12
            +122446116*r**14+1074711*r**16)+Q2**9*(9295+1716825*r**2+153045270*r**4
            +436523258*r**6+1396512740*r**8+3429691340*r**10+2103692810*r**12+851014790*r**14
            +112792173*r**16+341275*r**18)+Q2**8*(-120549+2320560*r**2-37227201*r**4
            -528837568*r**6-1065281922*r**8-4841499376*r**10-6297176130*r**12-1670586336*r**14
            -590459833*r**16+54890208*r**18+889251*r**20)-Q2**7*(-89635+3712335*r**2
            +105058067*r**4-340834967*r**6+511955778*r**8+1046459542*r**10+777200710*r**12
            -778030638*r**14+1950721473*r**16+357891963*r**18+168225927*r**20+994085*r**22)
            +Q2**6*(10907+875276*r**2+89263870*r**4-158583284*r**6+193046501*r**8
            +5395152088*r**10+19515767172*r**12+17554642744*r**14+8434570341*r**16
            +3289645276*r**18+764189182*r**20+76673404*r**22+70043*r**24)+Q2**5*(
            -48803+1674323*r**2+9932888*r**4-178260472*r**6+848638885*r**8-1763653493*r**10
            -16900419912*r**12-39203740728*r**14-12693116089*r**16-8386679415*r**18
            +37241456*r**20-323302736*r**22+63392055*r**24+508441*r**26)-Q2**4*(
            -21065+1300200*r**2+41907245*r**4-417821216*r**6+224047815*r**8+975854760*r**10
            -701297035*r**12-14255612160*r**14-29566065683*r**16+20178975160*r**18
            -714459345*r**20+2445366560*r**22+131177365*r**24+76375224*r**26+316975*r**28)
            +Q2**3*(5283-7655*r**2+13345903*r**4-193648251*r**6-570114849*r**8-152368323*r**10
            -3295991205*r**12-11620863591*r**14+4354598937*r**16-12379537797*r**18
            +26031776957*r**20+3845099135*r**22+1061850213*r**24+170056239*r**26
            +14144121*r**28-9117*r**30)+Q2**2*(-7825+391060*r**2+5478336*r**4-108011956*r**6
            +403896324*r**8+279101876*r**10+2821795840*r**12+18885157708*r**14+18283866522*r**16
            +6908662492*r**18-12997085632*r**20+3267499140*r**22-3037842044*r**24
            +600798684*r**26-57506816*r**28+15657956*r**30+84335*r**32)-3*Q2*(-907
            +59419*r**2+1384374*r**4-40213254*r**6+35892346*r**8-134272058*r**10
            -2180654706*r**12+53763714*r**14-2428061692*r**16-7896633092*r**18+23365152962*r**20
            -15426377970*r**22+4793498550*r**24-336016054*r**26+191370746*r**28-2026122*r**30
            +3122007*r**32+11737*r**34)+3*(-113+8848*r**2+237471*r**4-9760736*r**6
            +6254580*r**8-82272976*r**10-1391081884*r**12+1374664192*r**14-13813606422*r**16
            +43249613040*r**18-52589566534*r**20+29995134624*r**22-8274408172*r**24
            +1532131152*r**26-39342620*r**28+41405248*r**30+60287*r**32+528384*r**34
            +1631*r**36))-12*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(736*Q2**22
            -164*Q2**21*(1+r**2)+8*Q2**20*(-6209+12830*r**2+5863*r**4)-20*Q2**19*(
            -16107+66795*r**2+425321*r**4+31155*r**6)+5*Q2**18*(-191935+1396628*r**2
            +18982358*r**4+15714020*r**6+573089*r**8)-2*Q2**17*(-743353+9181315*r**2
            +210439090*r**4+398849530*r**6+146667235*r**8+3090527*r**10)+Q2**16*(
            -810729+22144926*r**2+881714845*r**4+3089930340*r**6+2671394545*r**8
            +456317406*r**10+4784571*r**12)+4*Q2**15*(-262898+764215*r**2-150861544*r**4
            -1340268435*r**6-1965172890*r**8-881680183*r**10+28555120*r**12+1497871*r**14)
            -20*Q2**14*(-93439+2025190*r**2+50476392*r**4-115760126*r**6-243169743*r**8
            -99985982*r**10+92556030*r**12+72542542*r**14+777440*r**16)+20*Q2**13*(
            -3010+1456929*r**2+111635934*r**4+325781616*r**6+949127860*r**8+2135860308*r**10
            +1353719658*r**12+589236664*r**14+83141990*r**16+310787*r**18)+4*Q2**12*(
            -535171+9331010*r**2-181465215*r**4-2963189550*r**6-10276258125*r**8
            -33297080804*r**10-35914992495*r**12-11567244990*r**14-3072315480*r**16
            +161712590*r**18+3717974*r**20)-4*Q2**11*(-407524+16519711*r**2+488043590*r**4
            -1921351425*r**6-6025344060*r**8-34993132166*r**10-60171084836*r**12
            -35195915610*r**14-199576200*r**16+817140815*r**18+704045446*r**20+4577651*r**22)
            +2*Q2**10*(318279+4140240*r**2+982978502*r**4+769342920*r**6+8079031035*r**8
            +13582344856*r**10+42152523300*r**12+45037217288*r**14+62067170885*r**16
            +35911777560*r**18+8757214614*r**20+710194160*r**22-453063*r**24)+20*Q2**9*(
            -71399+2452840*r**2+18798472*r**4-477432212*r**6-1516769741*r**8-9461408242*r**10
            -33881513380*r**12-66187424212*r**14-39234036757*r**16-21145306736*r**18
            -3127531220*r**20-609463880*r**22+80244697*r**24+711370*r**26)-10*Q2**8*(
            -34105+2995558*r**2+141045673*r**4-974323856*r**6-1130956499*r**8-14544085038*r**10
            -56616655057*r**12-211406379568*r**14-247458855871*r**16-63840564102*r**18
            -29984342153*r**20+2381844544*r**22+424346443*r**24+193942990*r**26+689969*r**28)
            -4*Q2**7*(-134514+3890235*r**2-99348440*r**4-25783395*r**6-1129268990*r**8
            +8891096539*r**10-32352779520*r**12+90227215265*r**14+275486365090*r**16
            +188817996105*r**18-153500580376*r**20-46982782425*r**22-15990252690*r**24
            -2807960255*r**26+6986640*r**28+1046331*r**30)+4*Q2**6*(-90181+5272454*r**2
            +111293140*r**4-1997881230*r**6+352771815*r**8+8104054886*r**10-48795009914*r**12
            -408055557590*r**14-1154903353125*r**16-1062373628990*r**18-766724823704*r**20
            -261962637994*r**22-103684435335*r**24-5397166830*r**26-1251959810*r**28
            +240196814*r**30+1173194*r**32)-4*Q2**5*(10913+391900*r**2+69513774*r**4
            -1080609260*r**6+1335602940*r**8+200219702*r**10+27021416430*r**12-256778954884*r**14
            -1452661624970*r**16-2738316873530*r**18-1126798664758*r**20-1012961279940*r**22
            -3750177844*r**24-36966938670*r**26+5070769690*r**28+614729268*r**30
            +83498785*r**32+58454*r**34)-20*Q2**4*(-5603+314730*r**2+1921509*r**4
            -103644366*r**6+256539277*r**8+4461509120*r**10+102549015*r**12-11810540434*r**14
            +32699137687*r**16+224241654616*r**18+436852355289*r**20-240878254290*r**22
            +24296863191*r**24-30911507896*r**26-6742984043*r**28-868557006*r**30
            -170253080*r**32+10201334*r**34+64150*r**36)+60*Q2**3*(-405+37606*r**2
            +1103021*r**4-38480558*r**6+139231104*r**8+1105706196*r**10+2296093892*r**12
            +2286272464*r**14+15646171846*r**16+20489197320*r**18-4704403122*r**20
            +38359259308*r**22-106763697016*r**24-42030495588*r**26-3742305372*r**28
            -1948299344*r**30-25594681*r**32-14112094*r**34+2356125*r**36+7298*r**38)
            +3*Q2**2*(-4313+230260*r**2-3126990*r**4+15667060*r**6-58556705*r**8
            +5614189792*r**10-24588920600*r**12-141108574560*r**14-468178935250*r**16
            -2451613456600*r**18-1949622466788*r**20-755144441880*r**22+1851832881590*r**24
            -732358578880*r**26+472408852040*r**28-40098187648*r**30+1342331595*r**32
            -898532540*r**34-174530430*r**36+1803140*r**38+37707*r**40)-18*Q2*(
            -397+31013*r**2+248190*r**4-26348410*r**6+178447315*r**8+1583713473*r**10
            -1272858112*r**12+12536987360*r**14+108715887310*r**16-63624780190*r**18
            +367116721868*r**20+157435300988*r**22-1075475371290*r**24+668805592610*r**26
            -155239831440*r**28-14488694192*r**30-4984570817*r**32-1186756135*r**34
            -54414010*r**36-20533810*r**38+1223623*r**40+5053*r**42)+9*(-113+10430*r**2
            +124221*r**4-13915460*r**6+120458625*r**8+744356342*r**10-690302965*r**12
            +28486145456*r**14+98860868230*r**16+126814542300*r**18+619758474002*r**20
            -3104449405560*r**22+3895904772306*r**24-1922665264580*r**26+283783738150*r**28
            +2408722672*r**30-26605651205*r**32-1809481114*r**34-632078815*r**36
            -9129700*r**38-7490403*r**40+505550*r**42+1631*r**44))*sqrtq2+logq2**6*(
            -7054387200000*(-Q2+(-1+r)**2)*(-1+r)*r**26*(1+r)*(1+r**2)*(1-Q2
            +r**2)*(-1-4*r**2+r**4)*(-Q2+(1+r)**2)-7054387200000*r**26*(1+4*r**2
            -2*r**4-4*r**6+r**8)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**5*(11197440000*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(70*Q2**7*(1+r**2)-10*Q2**6*(23+76*r**2
            +53*r**4)+10*Q2**5*(-23+125*r**2+305*r**4+157*r**6)-2*Q2**4*(-858-1351*r**2
            +1389*r**4+2903*r**6+1133*r**8)+4*Q2**3*(-411-1663*r**2-1744*r**4+554*r**6
            +1372*r**8+326*r**10)+2*Q2**2*(-612+853*r**2+4453*r**4+3032*r**6-664*r**8
            -595*r**10+337*r**12)-3*Q2*(-957-1022*r**2+1047*r**4+1068*r**6-735*r**8
            -498*r**10+645*r**12+452*r**14)+3*(-443-589*r**2-2175*r**4-1587*r**6
            +4321*r**8+989*r**10-985*r**12+291*r**14+178*r**16))-11197440000*r**22*(70*Q2**10*(1
            +r**2)-20*Q2**9*(22+59*r**2+37*r**4)+10*Q2**8*(67+457*r**2+727*r**4
            +337*r**6)-2*Q2**7*(-823+1549*r**2+9669*r**4+11503*r**6+4318*r**8)
            +14*Q2**6*(-518-1149*r**2+268*r**4+2962*r**6+3016*r**8+953*r**10)+Q2**5*(9086
            +36652*r**2+49978*r**4+8436*r**6-47814*r**8-44996*r**10-11606*r**12)
            +5*Q2**4*(-21-4522*r**2-13389*r**4-14272*r**6-4211*r**8+5058*r**10
            +4445*r**12+560*r**14)-3*(-1+r**2)**3*(443+1475*r**2+4239*r**4+8001*r**6
            +5267*r**8-43*r**10-47*r**12+647*r**14+178*r**16)+2*Q2**3*(-5985-5950*r**2
            +9419*r**4+20598*r**6+23613*r**8+8606*r**10-699*r**12+2170*r**14+2660*r**16)
            -2*Q2**2*(-6912-10649*r**2-10887*r**4-16467*r**6+9615*r**8+25745*r**10
            +2747*r**12-1801*r**14+5437*r**16+3172*r**18)+6*Q2*(-1143-1359*r**2
            -3003*r**4-5396*r**6-304*r**8+3532*r**10+7466*r**12+720*r**14-1717*r**16
            +711*r**18+493*r**20))*sqrtq2)+logq2**4*(31104000*r**18*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-1120*Q2**11+40*Q2**10*(343+463*r**2)
            -20*Q2**9*(3579+9401*r**2+5598*r**4)+16*Q2**8*(12476+47750*r**2+57837*r**4
            +21419*r**6)-4*Q2**7*(78047+391017*r**2+709339*r**4+544057*r**6+135368*r**8)
            +Q2**6*(266133+1567540*r**2+3800814*r**4+4400212*r**6+2291461*r**8+272832*r**10)
            +2*Q2**5*(-74123-361111*r**2-1140282*r**4-1039682*r**6-480911*r**8-6795*r**10
            +220528*r**12)+Q2**4*(127225+661490*r**2+3762451*r**4+1950140*r**6-5468913*r**8
            -5369086*r**10-2200635*r**12-756560*r**14)+12*Q2**3*(-5208-81095*r**2
            -509668*r**4-1039559*r**6-339684*r**8+699975*r**10+506372*r**12+145619*r**14
            +23848*r**16)+3*Q2**2*(-32539+42016*r**2-140156*r**4+3159048*r**6+5155610*r**8
            +1061288*r**10-877892*r**12-176040*r**14-97119*r**16+70584*r**18)-18*Q2*(
            -6999-34505*r**2-390024*r**4-140416*r**6+448558*r**8+65590*r**10-250860*r**12
            +118784*r**14+169481*r**16+8467*r**18+11924*r**20)+9*(-4381-34582*r**2
            -417725*r**4-330832*r**6-95334*r**8+393676*r**10+520586*r**12-228240*r**14
            +14467*r**16+171594*r**18+4915*r**20+5856*r**22))-31104000*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1120*Q2**11-40*Q2**10*(343+463*r**2)
            +20*Q2**9*(3579+9401*r**2+5598*r**4)-16*Q2**8*(12476+47750*r**2+57837*r**4
            +21419*r**6)+4*Q2**7*(78047+391017*r**2+709339*r**4+544057*r**6+135368*r**8)
            -Q2**6*(266133+1567540*r**2+3800814*r**4+4400212*r**6+2291461*r**8+272832*r**10)
            +Q2**5*(148246+722222*r**2+2280564*r**4+2079364*r**6+961822*r**8+13590*r**10
            -441056*r**12)+Q2**4*(-127225-661490*r**2-3762451*r**4-1950140*r**6
            +5468913*r**8+5369086*r**10+2200635*r**12+756560*r**14)-12*Q2**3*(-5208
            -81095*r**2-509668*r**4-1039559*r**6-339684*r**8+699975*r**10+506372*r**12
            +145619*r**14+23848*r**16)-3*Q2**2*(-32539+42016*r**2-140156*r**4+3159048*r**6
            +5155610*r**8+1061288*r**10-877892*r**12-176040*r**14-97119*r**16+70584*r**18)
            +18*Q2*(-6999-34505*r**2-390024*r**4-140416*r**6+448558*r**8+65590*r**10
            -250860*r**12+118784*r**14+169481*r**16+8467*r**18+11924*r**20)-9*(
            -4381-34582*r**2-417725*r**4-330832*r**6-95334*r**8+393676*r**10+520586*r**12
            -228240*r**14+14467*r**16+171594*r**18+4915*r**20+5856*r**22))*sqrtq2)
            +logq2**3*(2073600*r**14*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-6040*Q2**14
            +40*Q2**13*(1594+1717*r**2)-6*Q2**12*(47066+105627*r**2+56105*r**4)
            +4*Q2**11*(166353+615914*r**2+672236*r**4+218475*r**6)-4*Q2**10*(213954
            +1233470*r**2+2160818*r**4+1486603*r**6+277725*r**8)+30*Q2**9*(17658
            +159933*r**2+373524*r**4+406142*r**6+203128*r**8+2091*r**10)+10*Q2**8*(
            -8730-81919*r**2+406781*r**4+1318228*r**6+729770*r**8+127157*r**10
            +179709*r**12)-Q2**7*(14103+2215166*r**2+30766055*r**4+93813080*r**6
            +108457305*r**8+49318958*r**10+10896361*r**12+2134140*r**14)+3*Q2**6*(43947
            +359211*r**2+11650609*r**4+48168485*r**6+84376685*r**8+63097297*r**10
            +18606971*r**12+3683359*r**14+75900*r**16)+Q2**5*(-417443-154480*r**2
            -14503246*r**4-79196236*r**6-205266820*r**8-222991528*r**10-86498170*r**12
            +10443884*r**14-1054561*r**16+1426600*r**18)-5*Q2**4*(-69205-403917*r**2
            -1535816*r**4-7263066*r**6-22070188*r**8-7836032*r**10+16436874*r**12
            +21608978*r**14+13610857*r**16+1284133*r**18+216038*r**20)+15*Q2**3*(2201
            -157626*r**2-654129*r**4-4963312*r**6-16774294*r**8-16901308*r**10+5812862*r**12
            +15167456*r**14+9309725*r**16+2630070*r**18+306323*r**20+1232*r**22)
            +3*Q2**2*(-59967+26301*r**2-1108055*r**4+9244205*r**6+37514770*r**8
            +138715514*r**10+94138698*r**12-4616870*r**14-16613515*r**16-16724055*r**18
            +4344493*r**20-24359*r**22+106840*r**24)-9*Q2*(-9483-110254*r**2-1226156*r**4
            -4956660*r**6-27575015*r**8+5724286*r**10+23727088*r**12-9829088*r**14
            +1175335*r**16+11255590*r**18-469828*r**20+2159316*r**22+118219*r**24
            +16650*r**26)+9*(-1349-41985*r**2-471498*r**4-2888708*r**6-19012105*r**8
            +4372743*r**10+20073990*r**12-3066584*r**14-7941439*r**16+2125205*r**18
            +6265906*r**20-12580*r**22+559757*r**24+36197*r**26+2450*r**28))+2073600*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(6040*Q2**15-40*Q2**14*(1745+1868*r**2)
            +Q2**13*(346156+766202*r**2+405310*r**4)-2*Q2**12*(473904+1689907*r**2
            +1829668*r**4+605265*r**6)+4*Q2**11*(380307+2015737*r**2+3448968*r**4
            +2377314*r**6+496200*r**8)-2*Q2**10*(692778+5293843*r**2+12391436*r**4
            +13386972*r**6+6575576*r**8+586815*r**10)-20*Q2**9*(-30852-307346*r**2
            -596795*r**4-510385*r**6-549020*r**8-244250*r**10+86718*r**12)+Q2**8*(
            -73197+1308676*r**2+34014675*r**4+111063170*r**6+128937285*r**8+57888228*r**10
            +13965021*r**12+3931230*r**14)-2*Q2**7*(72972+1653451*r**2+33966524*r**4
            +134542295*r**6+227700220*r**8+173534077*r**10+58018116*r**12+12040289*r**14
            +1180920*r**16)+2*Q2**6*(274642+681977*r**2+25266353*r**4+129326759*r**6
            +301451165*r**8+332706737*r**10+165805487*r**12+28213553*r**14+6166169*r**16
            -599450*r**18)+2*Q2**5*(-381734-1295754*r**2-11168403*r**4-65007406*r**6
            -197406998*r**8-233719254*r**10-113652664*r**12+15995302*r**14+38721804*r**16
            +3396352*r**18+1253395*r**20)-10*Q2**4*(-31301-473000*r**2-1951060*r**4
            -11844409*r**6-39828068*r**8-40305072*r**10+13019714*r**12+41774110*r**14
            +31574505*r**16+11392600*r**18+1209570*r**20+109867*r**22)-6*Q2**3*(
            -35486+401713*r**2+1475360*r**4+18665705*r**6+73101400*r**8+153546762*r**10
            +74790464*r**12-54759230*r**14-69499710*r**16-38211515*r**18-5168736*r**20
            -781067*r**22+50340*r**24)+6*Q2**2*(-44208-182214*r**2-2380111*r**4
            -3366915*r**6-17983035*r**8+96701571*r**10+152017738*r**12+30017282*r**14
            -8852190*r**16+214600*r**18-6894523*r**20+5399041*r**22+218569*r**24
            +78395*r**26)-18*Q2*(-5416-80861*r**2-903954*r**4-4535762*r**6-25771890*r**8
            -8738993*r**10+24762682*r**12+5415708*r**14-8297596*r**16+7278065*r**18
            +8525834*r**20+838454*r**22+1418646*r**24+85533*r**26+9550*r**28)+9*(
            -1349-43334*r**2-513483*r**4-3360206*r**6-21900813*r**8-14639362*r**10
            +24446733*r**12+17007406*r**14-11008023*r**16-5816234*r**18+8391111*r**20
            +6253326*r**22+547177*r**24+595954*r**26+38647*r**28+2450*r**30))*sqrtq2)
            +logq2**2*(-8640*r**10*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17
            -8*Q2**16*(135817+150101*r**2)+8*Q2**15*(609837+1424108*r**2+709791*r**4)
            -8*Q2**14*(1497790+5665821*r**2+6164498*r**4+1670155*r**6)+8*Q2**13*(2052205
            +11807174*r**2+19627106*r**4+13279952*r**6+1570775*r**8)+Q2**12*(-9276675
            -97625268*r**2-162375498*r**4-170092020*r**6-87823939*r**8+10951320*r**10)
            -4*Q2**11*(1841403-2378739*r**2+72594868*r**4+176570458*r**6+97819623*r**8
            +24693229*r**10+9892734*r**12)+2*Q2**10*(9261111+50180850*r**2+514798421*r**4
            +1698206280*r**6+1881190105*r**8+716700482*r**10+157336027*r**12+14469828*r**14)
            +4*Q2**9*(-3352365-32232891*r**2-271078323*r**4-1352556375*r**6-2375510525*r**8
            -1673827605*r**10-350439261*r**12-63361633*r**14+4846770*r**16)+Q2**8*(
            -2729705+88671816*r**2+290389124*r**4+2654978408*r**6+6371797290*r**8
            +7327078400*r**10+3114119876*r**12-691377336*r**14-92962057*r**16-42913400*r**18)
            +8*Q2**7*(1747270-4971133*r**2+15127487*r**4+266907120*r**6+1492747966*r**8
            +2719556390*r**10+1861043472*r**12+853863832*r**14+317972780*r**16+40114391*r**18
            +1878665*r**20)+4*Q2**6*(-2456967-4677472*r**2+23073081*r**4-603032454*r**6
            -5851481694*r**8-16113018636*r**10-17957269110*r**12-8332675944*r**14
            -2848468779*r**16-372895044*r**18-46067315*r**20+4119774*r**22)-8*Q2**5*(229304
            -8600451*r**2-13472499*r**4-7450835*r**6-1468763325*r**8-6396000186*r**10
            -11704337214*r**12-7844229138*r**14-1198700610*r**16-511036475*r**18
            +106568217*r**20+8467725*r**22+1935887*r**24)+Q2**4*(6068155-55416868*r**2
            -529648674*r**4-565030660*r**6-2269446875*r**8-12054143520*r**10-35736518844*r**12
            -25962685992*r**14+17453038725*r**16+29611067900*r**18+4735543390*r**20
            +1370532012*r**22+129316891*r**24+1225160*r**26)+12*Q2**3*(-174505+109941*r**2
            +26994944*r**4+148392198*r**6+449400505*r**8+2459787075*r**10+4694349898*r**12
            +1521190932*r**14-2935005991*r**16-4346643205*r**18-2161639620*r**20
            -407821914*r**22-28949801*r**24-3480307*r**26+289850*r**28)-6*Q2**2*(189515
            -3931222*r**2-17811067*r**4+102589440*r**6+16192019*r**8+4091115470*r**10
            +11119907829*r**12+14975348124*r**14+4310241465*r**16-1116035738*r**18
            -4526104505*r**20+502957768*r**22-109686807*r**24+45159970*r**26+2918719*r**28
            +229020*r**30)+36*Q2*(26931-379535*r**2-4452807*r**4-14409807*r**6
            -176564787*r**8-451164495*r**10-1711459887*r**12+1089967489*r**14+475970739*r**16
            +27232299*r**18+820620947*r**20-372775221*r**22+286607943*r**24+25195443*r**26
            +5163363*r**28+420867*r**30+518*r**32)+9*(-21679+281592*r**2+4639432*r**4
            +30912240*r**6+319818060*r**8+1430620872*r**10+5770391864*r**12-8304862496*r**14
            -4018542330*r**16+8182983880*r**18-268700232*r**20-3464268304*r**22+686961996*r**24
            -329849160*r**26-36352440*r**28-3686336*r**30-332527*r**32+5568*r**34))
            -8640*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(104480*Q2**17-8*Q2**16*(135817
            +150101*r**2)+8*Q2**15*(609837+1424108*r**2+709791*r**4)-8*Q2**14*(1497790
            +5665821*r**2+6164498*r**4+1670155*r**6)+8*Q2**13*(2052205+11807174*r**2
            +19627106*r**4+13279952*r**6+1570775*r**8)+Q2**12*(-9276675-97625268*r**2
            -162375498*r**4-170092020*r**6-87823939*r**8+10951320*r**10)-4*Q2**11*(1841403
            -2378739*r**2+72594868*r**4+176570458*r**6+97819623*r**8+24693229*r**10
            +9892734*r**12)+2*Q2**10*(9261111+50180850*r**2+514798421*r**4+1698206280*r**6
            +1881190105*r**8+716700482*r**10+157336027*r**12+14469828*r**14)+4*Q2**9*(
            -3352365-32232891*r**2-271078323*r**4-1352556375*r**6-2375510525*r**8
            -1673827605*r**10-350439261*r**12-63361633*r**14+4846770*r**16)+Q2**8*(
            -2729705+88671816*r**2+290389124*r**4+2654978408*r**6+6371797290*r**8
            +7327078400*r**10+3114119876*r**12-691377336*r**14-92962057*r**16-42913400*r**18)
            +8*Q2**7*(1747270-4971133*r**2+15127487*r**4+266907120*r**6+1492747966*r**8
            +2719556390*r**10+1861043472*r**12+853863832*r**14+317972780*r**16+40114391*r**18
            +1878665*r**20)+4*Q2**6*(-2456967-4677472*r**2+23073081*r**4-603032454*r**6
            -5851481694*r**8-16113018636*r**10-17957269110*r**12-8332675944*r**14
            -2848468779*r**16-372895044*r**18-46067315*r**20+4119774*r**22)-8*Q2**5*(229304
            -8600451*r**2-13472499*r**4-7450835*r**6-1468763325*r**8-6396000186*r**10
            -11704337214*r**12-7844229138*r**14-1198700610*r**16-511036475*r**18
            +106568217*r**20+8467725*r**22+1935887*r**24)+Q2**4*(6068155-55416868*r**2
            -529648674*r**4-565030660*r**6-2269446875*r**8-12054143520*r**10-35736518844*r**12
            -25962685992*r**14+17453038725*r**16+29611067900*r**18+4735543390*r**20
            +1370532012*r**22+129316891*r**24+1225160*r**26)+12*Q2**3*(-174505+109941*r**2
            +26994944*r**4+148392198*r**6+449400505*r**8+2459787075*r**10+4694349898*r**12
            +1521190932*r**14-2935005991*r**16-4346643205*r**18-2161639620*r**20
            -407821914*r**22-28949801*r**24-3480307*r**26+289850*r**28)-6*Q2**2*(189515
            -3931222*r**2-17811067*r**4+102589440*r**6+16192019*r**8+4091115470*r**10
            +11119907829*r**12+14975348124*r**14+4310241465*r**16-1116035738*r**18
            -4526104505*r**20+502957768*r**22-109686807*r**24+45159970*r**26+2918719*r**28
            +229020*r**30)+36*Q2*(26931-379535*r**2-4452807*r**4-14409807*r**6
            -176564787*r**8-451164495*r**10-1711459887*r**12+1089967489*r**14+475970739*r**16
            +27232299*r**18+820620947*r**20-372775221*r**22+286607943*r**24+25195443*r**26
            +5163363*r**28+420867*r**30+518*r**32)+9*(-21679+281592*r**2+4639432*r**4
            +30912240*r**6+319818060*r**8+1430620872*r**10+5770391864*r**12-8304862496*r**14
            -4018542330*r**16+8182983880*r**18-268700232*r**20-3464268304*r**22+686961996*r**24
            -329849160*r**26-36352440*r**28-3686336*r**30-332527*r**32+5568*r**34))*sqrtq2)
            +logq2*(-288*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(54928*Q2**20
            -10*Q2**19*(80571+66179*r**2)+10*Q2**18*(454635+932826*r**2+315743*r**4)
            -10*Q2**17*(1276291+4810467*r**2+4156451*r**4+713027*r**6)+10*Q2**16*(1673240
            +11757431*r**2+16884235*r**4+8279349*r**6+491705*r**8)+2*Q2**15*(291279
            -59156055*r**2-97945590*r**4-57271710*r**6-13876615*r**8+5923559*r**10)
            -10*Q2**14*(3179247+6569403*r**2+44188566*r**4+120967604*r**6+75147541*r**8
            +19669647*r**10+2857988*r**12)+5*Q2**13*(6433205+60642984*r**2+332390965*r**4
            +1097862886*r**6+1214635191*r**8+416413088*r**10+71427359*r**12+2563602*r**14)
            +5*Q2**12*(2841111-57953133*r**2-397686891*r**4-1861102247*r**6-3137405283*r**8
            -2048826147*r**10-287234445*r**12-19839849*r**14+5847972*r**16)-10*Q2**11*(4707430
            -926967*r**2-54829074*r**4-505111764*r**6-907956088*r**8-915369848*r**10
            -228097682*r**12+224264136*r**14+38356662*r**16+4072315*r**18)+4*Q2**10*(4510077
            +57863495*r**2+319685970*r**4+1470662320*r**6+7814017520*r**8+15640213853*r**10
            +10006163165*r**12+4434888910*r**14+1170745425*r**16+110393910*r**18
            +307307*r**20)+5*Q2**9*(5179239-46755564*r**2-368681911*r**4-2195790494*r**6
            -12439153626*r**8-38209590004*r**10-42558233486*r**12-16668936056*r**14
            -5253633789*r**16-332977536*r**18+1654389*r**20+6524726*r**22)-5*Q2**8*(4790695
            -9929301*r**2-197781337*r**4-1286268433*r**6-6195004898*r**8-34209666554*r**10
            -64772250554*r**12-44191072906*r**14-4893941093*r**16-1309794993*r**18
            +635093811*r**20+64911899*r**22+3840512*r**24)-10*Q2**7*(418313-13654759*r**2
            -41127194*r**4+269462462*r**6-1165420083*r**8-4237010291*r**10-10083900548*r**12
            -7245547460*r**14-8905623285*r**16-9160838453*r**18-1980677810*r**20
            -352827146*r**22-18460977*r**24+878591*r**26)+10*Q2**6*(1260165-14437827*r**2
            -105316878*r**4+264511880*r**6-381884731*r**8-13983361421*r**10-69660249688*r**12
            -119098406816*r**14-79333297209*r**16-39759741061*r**18-9544382366*r**20
            -2109246552*r**22-23532033*r**24+5803877*r**26+1259540*r**28)+Q2**5*(
            -2662377+10974120*r**2+484828155*r**4+1307981450*r**6-5161804645*r**8
            +33108765192*r**10+526380826495*r**12+1549238069610*r**14+1691496856965*r**16
            +536428413960*r**18+280893888657*r**20-12171448290*r**22+2098864585*r**24
            -1617715640*r**26-97736715*r**28-1429522*r**30)-5*Q2**4*(616103-12728853*r**2
            -43586543*r**4+1216863773*r**6+2902206467*r**8-2592019133*r**10+9559984153*r**12
            +70032535581*r**14+214049147049*r**16+74508298201*r**18-130117787973*r**20
            -16769631217*r**22-12492555863*r**24-1835799047*r**26-184875493*r**28
            -4948297*r**30+677892*r**32)+30*Q2**3*(49245-1005552*r**2-8390298*r**4
            +119452576*r**6+558599956*r**8+1463384198*r**10+4420500082*r**12+16969717740*r**14
            +13720059258*r**16+1342738458*r**18-21945512406*r**20-26796182328*r**22
            -7139162596*r**24-723747334*r**26-178221314*r**28+1417388*r**30+417273*r**32
            +45654*r**34)+30*Q2**2*(8287-277846*r**2+897755*r**4+45300500*r**6-28432468*r**8
            -1149771430*r**10-2275208286*r**12-30409099688*r**14-44294454506*r**16
            -25153597574*r**18-6278370596*r**20+21798649780*r**22-2492912204*r**24
            +2461427062*r**26-384866858*r**28-11605536*r**30-7241173*r**32-294388*r**34
            +9169*r**36)-45*Q2*(6425-211762*r**2-781057*r**4+43411204*r**6+82312436*r**8
            +322380516*r**10+4640825532*r**12+4639058012*r**14+19868199534*r**16
            -9857533632*r**18-6747069582*r**20-23382970028*r**22+18100809572*r**24
            -6819671780*r**26-669629844*r**28-191633484*r**30-25702367*r**32-1765902*r**34
            -39833*r**36+6040*r**38)+9*(5787-220735*r**2-1105095*r**4+57261285*r**6
            +101088130*r**8+1458374292*r**10+12154764580*r**12+29670853060*r**14
            +98584777970*r**16-304538439490*r**18+133768147902*r**20+164166435670*r**22
            -161489742960*r**24+35126704580*r**26-6861747660*r**28-2010898828*r**30
            -153685765*r**32-31511255*r**34-1056335*r**36-10355*r**38+5222*r**40))
            +288*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(54928*Q2**21-2*Q2**20*(430319
            +358359*r**2)+20*Q2**19*(267603+539788*r**2+190961*r**4)-20*Q2**18*(865463
            +3098964*r**2+2702510*r**4+514385*r**6)+10*Q2**17*(2949531+17844189*r**2
            +25851153*r**4+13148827*r**6+1204732*r**8)+2*Q2**16*(-8074921-126309410*r**2
            -241153920*r**4-183089630*r**6-57731885*r**8+3465034*r**10)-2*Q2**15*(16187514
            -26017761*r**2+63841185*r**4+449620720*r**6+304589380*r**8+90395179*r**10
            +20213499*r**12)+5*Q2**14*(12791699+80140284*r**2+433906903*r**4+1428175226*r**6
            +1606865481*r**8+606047464*r**10+116482629*r**12+8279578*r**14)+10*Q2**13*(
            -1796047-62514661*r**2-395360420*r**4-1645678049*r**6-2724951680*r**8
            -1839937213*r**10-387537446*r**12-46915405*r**14+1642185*r**16)-5*Q2**12*(12255971
            -56965956*r**2-565298172*r**4-3269012666*r**6-6814419706*r**8-7016971126*r**10
            -2792255956*r**12+141453978*r**14+62721447*r**16+13992602*r**18)+2*Q2**11*(32557304
            +134629305*r**2+360591735*r**4+141620450*r**6+8562695780*r**8+22163798026*r**10
            +14294988680*r**12+8850610090*r**14+3654594840*r**16+432932705*r**18
            +20976189*r**20)+Q2**10*(7855887-483272108*r**2-3353607415*r**4-18140345630*r**6
            -99334487490*r**8-284864875512*r**10-315376675502*r**12-141108888580*r**14
            -48690706285*r**16-6789445020*r**18-434532923*r**20+31394402*r**22)-10*Q2**9*(4984967
            -25752813*r**2-306609406*r**4-1925370419*r**6-10414974509*r**8-42429205092*r**10
            -72770037022*r**12-51709121224*r**14-13408255469*r**16-3448203159*r**18
            +151885332*r**20+36545507*r**22+5182619*r**24)+5*Q2**8*(3954069+22170912*r**2
            -125456250*r**4-2022974694*r**6-5150433165*r**8-31930650870*r**10-78814116012*r**12
            -94472228540*r**14-31273767429*r**16+12117940820*r**18+3286654438*r**20
            +1405660002*r**22+105674365*r**24+2083330*r**26)+10*Q2**7*(1678478-27674273*r**2
            -160098831*r**4+492847148*r**6-1277842352*r**8-19385791795*r**10-83981160527*r**12
            -136427854824*r**14-95484467954*r**16-57826202799*r**18-20685898629*r**20
            -4442751508*r**22-394820156*r**24-11778509*r**26+2138131*r**28)+Q2**6*(
            -15264027+142750740*r**2+1682375205*r**4-283968570*r**6-3988076135*r**8
            +176761226712*r**10+1362816937585*r**12+3436824634650*r**14+3675813897215*r**16
            +1727358796660*r**18+773935122927*r**20+104364840890*r**22+23426650435*r**24
            -1440434080*r**26-168370885*r**28-14024922*r**30)-2*Q2**5*(209069-27666261*r**2
            +138934780*r**4+3938564235*r**6+5328604570*r**8+7493432441*r**10+303644756226*r**12
            +1212890787005*r**14+2155490330910*r**16+1300233380965*r**18+83366681376*r**20
            +92437142141*r**22-36267681510*r**24-4348923145*r**26-1319914910*r**28
            -61953861*r**30+979969*r**32)+5*Q2**4*(911573-18146062*r**2-106657184*r**4
            +1889992686*r**6+7470669976*r**8+9090492522*r**10+33490965512*r**12+181410826174*r**14
            +366402038178*r**16+296613875998*r**18-187282564208*r**20-307664513158*r**22
            -72097162656*r**24-18670838914*r**26-3090002424*r**28-181319462*r**30
            -1766767*r**32+951816*r**34)-30*Q2**3*(40958-678461*r**2-10293605*r**4
            +65761778*r**6+706485000*r**8+3171755584*r**10+8159092566*r**12+51799317510*r**14
            +74984231504*r**16+40216395290*r**18-14324403352*r**20-70540344514*r**22
            -31442432720*r**24-10324336992*r**26-517101790*r**28-165198390*r**30
            +9075834*r**32+757315*r**34+36485*r**36)-15*Q2**2*(35849-1174404*r**2
            -1103353*r**4+222630122*r**6+280673372*r**8-1389266248*r**10+7072517164*r**12
            -51451441912*r**14-89802509786*r**16-168468705056*r**18-83105145086*r**20
            -39108351716*r**22+92913903868*r**24-20521985624*r**26+2144230876*r**28
            -1367845240*r**30-114800519*r**32-20368828*r**34-689937*r**36+36458*r**38)
            +18*Q2*(18956-623710*r**2-3034595*r**4+135206010*r**6+364853165*r**8
            +1740919526*r**10+18485397410*r**12+38035135390*r**14+110560532850*r**16
            -127242554990*r**18+25372565916*r**20+6758118810*r**22-93950272620*r**24
            +45766196770*r**26-22154127890*r**28-3158607734*r**30-620182510*r**32
            -84426300*r**34-5042505*r**36-89660*r**38+17711*r**40)-9*(5787-214948*r**2
            -1325830*r**4+56156190*r**6+158349415*r**8+1559462422*r**10+13613138872*r**12
            +41825617640*r**14+128255631030*r**16-205953661520*r**18-170770291588*r**20
            +297934583572*r**22+2676692710*r**24-126363038380*r**26+28264956920*r**28
            -8872646488*r**30-2164584593*r**32-185197020*r**34-32567590*r**36-1066690*r**38
            -5133*r**40+5222*r**42))*sqrtq2))*math.log(2*muWC))/(-35000*(-Q2+(-1+r)**2)*r**2*(1
            -Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))-35000*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2+logq2**6*(1567641600000*r**26*(1+r**2)*(
            -1+Q2**3+r**2+r**4-r**6-3*Q2**2*(1+r**2)+Q2*(3+2*r**2+3*r**4))
            -1567641600000*r**26*(1+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)
            +logq2**3*(1209600000*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))+1209600000*(-Q2+(-1+r)**2)*r**14*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(9+4*Q2**4-66*r**2-246*r**4-66*r**6+9*r**8
            +4*Q2**3*(1+r**2)-Q2**2*(11+14*r**2+11*r**4)-6*Q2*(1+4*r**2+4*r**4
            +r**6))*sqrtq2)+logq2*(4200000*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)
            -Q2**2*(5+2*r**2+5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))+4200000*(
            -Q2+(-1+r)**2)*r**6*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*(4*Q2**4-2*Q2**3*(1+r**2)-18*Q2*(r**2+r**4)-Q2**2*(5+2*r**2
            +5*r**4)+3*(1-10*r**2-54*r**4-10*r**6+r**8))*sqrtq2)+logq2**2*(-25200000*(
            -Q2+(-1+r)**2)*r**10*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(16*Q2**4+Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1
            +9*r**2+9*r**4+r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))-25200000*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(16*Q2**4
            +Q2**3*(1+r**2)-Q2**2*(29+26*r**2+29*r**4)-9*Q2*(1+9*r**2+9*r**4
            +r**6)+3*(7-58*r**2-258*r**4-58*r**6+7*r**8))*sqrtq2)+logq2**4*(-3628800000*(
            -Q2+(-1+r)**2)*r**18*(1-Q2+r**2)*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))
            -3628800000*(-Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(8*Q2**4+23*Q2**3*(1+r**2)-Q2**2*(37+58*r**2+37*r**4)-9*Q2*(3
            +7*r**2+7*r**4+3*r**6)+3*(11-74*r**2-234*r**4-74*r**6+11*r**8))*sqrtq2)
            +logq2**5*(17418240000*(-Q2+(-1+r)**2)*r**22*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2
            +41*r**4)-18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4
            -82*r**6+13*r**8))+17418240000*(-Q2+(-1+r)**2)*r**22*(1-Q2+r**2)*(
            -Q2+(1+r)**2)*(4*Q2**4+34*Q2**3*(1+r**2)-Q2**2*(41+74*r**2+41*r**4)
            -18*Q2*(2+3*r**2+3*r**4+2*r**6)+3*(13-82*r**2-222*r**4-82*r**6
            +13*r**8))*sqrtq2))+((16*r**4*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(-92*Q2**23
            +24*Q2**22*(9+269*r**2)+8*Q2**21*(759+16576*r**2+17418*r**4)-Q2**20*(53501
            +2536835*r**2+26069823*r**4+2627753*r**6)+2*Q2**19*(105975+8510556*r**2
            +173236090*r**4+174340172*r**6+8829891*r**8)-2*Q2**18*(238851+31358329*r**2
            +973120058*r**4+2083773094*r**6+983705459*r**8+32615985*r**10)+2*Q2**17*(292443
            +70301554*r**2+2868182263*r**4+10010340012*r**6+10050868541*r**8+2913747242*r**10
            +73087809*r**12)-3*Q2**16*(47651+62569145*r**2+2807340195*r**4+15201366193*r**6
            +22748648245*r**8+15345950367*r**10+2880219445*r**12+64435303*r**14)
            +8*Q2**15*(-88842+14193044*r**2+128094987*r**4+4128980631*r**6+4331591198*r**8
            +4439230734*r**10+4282430247*r**12+163674587*r**14+13800438*r**16)+8*Q2**14*(133025
            +5840983*r**2+2254615695*r**4+9108653796*r**6+42177035281*r**8+76569372060*r**10
            +41734901679*r**12+8826803650*r**14+2243996976*r**16+7831463*r**18)-8*Q2**13*(38199
            +12045222*r**2+3556163584*r**4+24810112247*r**6+110276879583*r**8+276205720627*r**10
            +275464001141*r**12+109325304417*r**14+24501216562*r**16+3603072047*r**18
            +13953411*r**20)+Q2**12*(-767754-61576710*r**2+8688340882*r**4+166080184598*r**6
            +703997289964*r**8+2632378999492*r**10+3659840226596*r**12+2615289390460*r**14
            +696511647982*r**16+165891079154*r**18+9386067002*r**20-66210690*r**22)
            +4*Q2**11*(210613+56244708*r**2+6077530264*r**4+6876864778*r**6+108470004527*r**8
            +125461319304*r**10+508867865472*r**12+513418022012*r**14+129979707531*r**16
            +107805796948*r**18+5779706584*r**20+5962942778*r**22+61360897*r**24)
            -4*Q2**10*(-17391+40152099*r**2+7339287020*r**4+40261241614*r**6+288072430629*r**8
            +1017889621433*r**10+3085679809372*r**12+4931771626080*r**14+3094056262175*r**16
            +1016316212905*r**18+284685915000*r**20+38580252722*r**22+7392547435*r**24
            +42590811*r**26)+4*Q2**9*(-184875-10937266*r**2+474657235*r**4+32593447358*r**6
            +144126753007*r**8+818799400000*r**10+2777275423937*r**12+7049812934500*r**14
            +7056011342107*r**16+2787580439174*r**18+808196909245*r**20+141924575230*r**22
            +31945111265*r**24+643710988*r**26-14234001*r**28)+2*Q2**8*(261579+65621513*r**2
            +9843323771*r**4-26752509867*r**6+81120095251*r**8-158764932159*r**10
            +1009225949619*r**12-4199049125507*r**14-6538471062063*r**16-4210773309045*r**18
            +988848060385*r**20-128755508145*r**22+78974297745*r**24-28856408597*r**26
            +9585717553*r**28+74928927*r**30)-4*Q2**7*(-5559+13413432*r**2+3400888998*r**4
            -1050546858*r**6+32397639576*r**8+125801638724*r**10+1869902245186*r**12
            +1893035779746*r**14+3672177272270*r**16+3665727893104*r**18+1887147795786*r**20
            +1871018224826*r**22+134558490712*r**24+31147374804*r**26-2496044274*r**28
            +3398396430*r**30+14638137*r**32)-8*Q2**6*(29526+4231052*r**2+233519751*r**4
            -5280045336*r**6+8263607027*r**8-52124758382*r**10-399813684427*r**12
            -327292792154*r**14-975272096711*r**16-1670563799140*r**18-963111631943*r**20
            -296670010892*r**22-413414790187*r**24-49088051558*r**26+7905997323*r**28
            -5073574146*r**30+197657897*r**32+5049900*r**34)+8*Q2**5*(15698+5086322*r**2
            +808113108*r**4-7810429365*r**6-5914592575*r**8-133645055569*r**10-310969225215*r**12
            -466504769453*r**14-393962537907*r**16+627970220099*r**18+639883046665*r**20
            -364422836823*r**22-375716870133*r**24-333205091819*r**26-126472023029*r**28
            -6311724999*r**30-8033973739*r**32+780809223*r**34+5820311*r**36)+Q2**4*(3975
            -9859287*r**2-2469103555*r**4+29731865731*r**6+135356515692*r**8+1017842189220*r**10
            +3908495659620*r**12+8322195403500*r**14+16851453424114*r**16-15440367875266*r**18
            +23670120350790*r**20-16516711447094*r**22+16650464082620*r**24+7518855280884*r**26
            +4005728335956*r**28+988771421340*r**30+134114530911*r**32+31311741185*r**34
            -2431921979*r**36-10662357*r**38)-2*Q2**3*(16761+3009796*r**2+317685002*r**4
            -4826403824*r**6+26733572585*r**8+40823715648*r**10+574288549080*r**12
            +1880542409120*r**14+3002889519634*r**16-11128620769144*r**18+10852543165788*r**20
            +10771541060512*r**22-11678283290566*r**24+2892048092704*r**26+1844754808728*r**28
            +545643017376*r**30+46044356437*r**32+26013498644*r**34-4730713814*r**36
            +296112656*r**38+3674877*r**40)+3*(-1+r**2)**2*(113+49077*r**2+9904922*r**4
            -311660206*r**6-1370363115*r**8-14049899095*r**10-112958565256*r**12
            +255598286904*r**14-2879119902302*r**16+11924541035210*r**18-33420178571268*r**20
            +48049635435116*r**22-33870581748174*r**24+12256574682522*r**26-2970052589000*r**28
            +285975212344*r**30-115345032147*r**32-13778318527*r**34-1334723014*r**36
            -319495470*r**38+9564281*r**40+57085*r**42)+2*Q2**2*(8333+2461687*r**2
            +405709042*r**4-8303129902*r**6-6836165371*r**8-184946567365*r**10-814803040560*r**12
            +1110318763472*r**14-10744733590366*r**16+16726697882726*r**18-4673375047260*r**20
            -17719399206684*r**22-4266648604870*r**24+17349546284038*r**26-11216177224064*r**28
            +1398949569408*r**30-867988969775*r**32-176807094269*r**34-6622519270*r**36
            -8446332166*r**38+389507009*r**40+2906207*r**42)-6*Q2*(623+229994*r**2
            +42861447*r**4-1138336984*r**6-2152620703*r**8-34241468834*r**10-210191667951*r**12
            +573077045936*r**14-4563748203018*r**16+15723583040564*r**18-30986852717626*r**20
            +19096666870784*r**22+18608349591170*r**24-31300771559412*r**26+16218070984706*r**28
            -4767721587888*r**30+648282359659*r**32-218912449086*r**34-33289478461*r**36
            -2045521192*r**38-1162212275*r**40+41289014*r**42+269533*r**44))-16*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7
            +2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2*(92*Q2**23-24*Q2**22*(9+269*r**2)-8*Q2**21*(759+16576*r**2
            +17418*r**4)+Q2**20*(53501+2536835*r**2+26069823*r**4+2627753*r**6)
            -2*Q2**19*(105975+8510556*r**2+173236090*r**4+174340172*r**6+8829891*r**8)
            +2*Q2**18*(238851+31358329*r**2+973120058*r**4+2083773094*r**6+983705459*r**8
            +32615985*r**10)-2*Q2**17*(292443+70301554*r**2+2868182263*r**4+10010340012*r**6
            +10050868541*r**8+2913747242*r**10+73087809*r**12)+3*Q2**16*(47651+62569145*r**2
            +2807340195*r**4+15201366193*r**6+22748648245*r**8+15345950367*r**10
            +2880219445*r**12+64435303*r**14)-8*Q2**15*(-88842+14193044*r**2+128094987*r**4
            +4128980631*r**6+4331591198*r**8+4439230734*r**10+4282430247*r**12+163674587*r**14
            +13800438*r**16)-8*Q2**14*(133025+5840983*r**2+2254615695*r**4+9108653796*r**6
            +42177035281*r**8+76569372060*r**10+41734901679*r**12+8826803650*r**14
            +2243996976*r**16+7831463*r**18)+8*Q2**13*(38199+12045222*r**2+3556163584*r**4
            +24810112247*r**6+110276879583*r**8+276205720627*r**10+275464001141*r**12
            +109325304417*r**14+24501216562*r**16+3603072047*r**18+13953411*r**20)
            +2*Q2**12*(383877+30788355*r**2-4344170441*r**4-83040092299*r**6-351998644982*r**8
            -1316189499746*r**10-1829920113298*r**12-1307644695230*r**14-348255823991*r**16
            -82945539577*r**18-4693033501*r**20+33105345*r**22)-4*Q2**11*(210613
            +56244708*r**2+6077530264*r**4+6876864778*r**6+108470004527*r**8+125461319304*r**10
            +508867865472*r**12+513418022012*r**14+129979707531*r**16+107805796948*r**18
            +5779706584*r**20+5962942778*r**22+61360897*r**24)+4*Q2**10*(-17391+40152099*r**2
            +7339287020*r**4+40261241614*r**6+288072430629*r**8+1017889621433*r**10
            +3085679809372*r**12+4931771626080*r**14+3094056262175*r**16+1016316212905*r**18
            +284685915000*r**20+38580252722*r**22+7392547435*r**24+42590811*r**26)
            +4*Q2**9*(184875+10937266*r**2-474657235*r**4-32593447358*r**6-144126753007*r**8
            -818799400000*r**10-2777275423937*r**12-7049812934500*r**14-7056011342107*r**16
            -2787580439174*r**18-808196909245*r**20-141924575230*r**22-31945111265*r**24
            -643710988*r**26+14234001*r**28)-2*Q2**8*(261579+65621513*r**2+9843323771*r**4
            -26752509867*r**6+81120095251*r**8-158764932159*r**10+1009225949619*r**12
            -4199049125507*r**14-6538471062063*r**16-4210773309045*r**18+988848060385*r**20
            -128755508145*r**22+78974297745*r**24-28856408597*r**26+9585717553*r**28
            +74928927*r**30)+4*Q2**7*(-5559+13413432*r**2+3400888998*r**4-1050546858*r**6
            +32397639576*r**8+125801638724*r**10+1869902245186*r**12+1893035779746*r**14
            +3672177272270*r**16+3665727893104*r**18+1887147795786*r**20+1871018224826*r**22
            +134558490712*r**24+31147374804*r**26-2496044274*r**28+3398396430*r**30
            +14638137*r**32)+8*Q2**6*(29526+4231052*r**2+233519751*r**4-5280045336*r**6
            +8263607027*r**8-52124758382*r**10-399813684427*r**12-327292792154*r**14
            -975272096711*r**16-1670563799140*r**18-963111631943*r**20-296670010892*r**22
            -413414790187*r**24-49088051558*r**26+7905997323*r**28-5073574146*r**30
            +197657897*r**32+5049900*r**34)-8*Q2**5*(15698+5086322*r**2+808113108*r**4
            -7810429365*r**6-5914592575*r**8-133645055569*r**10-310969225215*r**12
            -466504769453*r**14-393962537907*r**16+627970220099*r**18+639883046665*r**20
            -364422836823*r**22-375716870133*r**24-333205091819*r**26-126472023029*r**28
            -6311724999*r**30-8033973739*r**32+780809223*r**34+5820311*r**36)+Q2**4*(
            -3975+9859287*r**2+2469103555*r**4-29731865731*r**6-135356515692*r**8
            -1017842189220*r**10-3908495659620*r**12-8322195403500*r**14-16851453424114*r**16
            +15440367875266*r**18-23670120350790*r**20+16516711447094*r**22-16650464082620*r**24
            -7518855280884*r**26-4005728335956*r**28-988771421340*r**30-134114530911*r**32
            -31311741185*r**34+2431921979*r**36+10662357*r**38)+2*Q2**3*(16761+3009796*r**2
            +317685002*r**4-4826403824*r**6+26733572585*r**8+40823715648*r**10+574288549080*r**12
            +1880542409120*r**14+3002889519634*r**16-11128620769144*r**18+10852543165788*r**20
            +10771541060512*r**22-11678283290566*r**24+2892048092704*r**26+1844754808728*r**28
            +545643017376*r**30+46044356437*r**32+26013498644*r**34-4730713814*r**36
            +296112656*r**38+3674877*r**40)-3*(-1+r**2)**2*(113+49077*r**2+9904922*r**4
            -311660206*r**6-1370363115*r**8-14049899095*r**10-112958565256*r**12
            +255598286904*r**14-2879119902302*r**16+11924541035210*r**18-33420178571268*r**20
            +48049635435116*r**22-33870581748174*r**24+12256574682522*r**26-2970052589000*r**28
            +285975212344*r**30-115345032147*r**32-13778318527*r**34-1334723014*r**36
            -319495470*r**38+9564281*r**40+57085*r**42)-2*Q2**2*(8333+2461687*r**2
            +405709042*r**4-8303129902*r**6-6836165371*r**8-184946567365*r**10-814803040560*r**12
            +1110318763472*r**14-10744733590366*r**16+16726697882726*r**18-4673375047260*r**20
            -17719399206684*r**22-4266648604870*r**24+17349546284038*r**26-11216177224064*r**28
            +1398949569408*r**30-867988969775*r**32-176807094269*r**34-6622519270*r**36
            -8446332166*r**38+389507009*r**40+2906207*r**42)+6*Q2*(623+229994*r**2
            +42861447*r**4-1138336984*r**6-2152620703*r**8-34241468834*r**10-210191667951*r**12
            +573077045936*r**14-4563748203018*r**16+15723583040564*r**18-30986852717626*r**20
            +19096666870784*r**22+18608349591170*r**24-31300771559412*r**26+16218070984706*r**28
            -4767721587888*r**30+648282359659*r**32-218912449086*r**34-33289478461*r**36
            -2045521192*r**38-1162212275*r**40+41289014*r**42+269533*r**44))*sqrtq2
            +logq2**8*(20316635136000000*r**36*(1+r**2)**2*(1-Q2+r**2)*(-1+33*r**2
            -115*r**4+35*r**6)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+20316635136000000*(Q2
            -(-1+r)**2)**2*r**36*(1+r**2)**2*(-1+33*r**2-115*r**4+35*r**6)*(Q2-(1
            +r)**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*sqrtq2)+logq2**7*(-32248627200000*r**32*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(-1750*Q2**9*(1+r**2)+50*Q2**8*(185
            +376*r**2+191*r**4)-100*Q2**7*(75+466*r**2+490*r**4+99*r**6)-2*Q2**6*(24003
            +15151*r**2-16179*r**4+7569*r**6+20048*r**8)+2*Q2**5*(68523+138429*r**2
            +75452*r**4+64120*r**6+120727*r**8+62153*r**10)-Q2**4*(112035+359323*r**2
            +274526*r**4+19906*r**6+235299*r**8+326183*r**10+104160*r**12)-Q2**3*(78575
            -1912*r**2-30061*r**4+30032*r**6+40305*r**8-11768*r**10+893*r**12+73360*r**14)
            +6*(-1+r**2)**2*(6619+10492*r**2-14710*r**4+592*r**6+78446*r**8-1368*r**10
            -15746*r**12+9996*r**14+6319*r**16)+Q2**2*(219065+287687*r**2+41965*r**4
            -46837*r**6+282647*r**8-54191*r**10+39227*r**12+273437*r**14+206920*r**16)
            -3*Q2*(52403+43602*r**2-92226*r**4-45106*r**6+380956*r**8+369126*r**10
            -60198*r**12-94870*r**14+41625*r**16+49808*r**18))-32248627200000*r**32*(1
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1750*Q2**10*(1+r**2)-100*Q2**9*(110
            +223*r**2+113*r**4)+50*Q2**8*(335+1493*r**2+1547*r**4+389*r**6)+2*Q2**7*(20253
            -11899*r**2-63979*r**4-21881*r**6+15098*r**8)-14*Q2**6*(13218+25369*r**2
            +10632*r**4+7930*r**6+21192*r**8+11743*r**10)+Q2**5*(249081+773227*r**2
            +702288*r**4+299050*r**6+604993*r**8+691943*r**10+228466*r**12)-10*Q2**4*(3346
            +47327*r**2+66391*r**4+26440*r**6+21490*r**8+57325*r**10+42945*r**12
            +3080*r**14)-2*Q2**3*(148820+182175*r**2+4996*r**4-23433*r**6+176492*r**8
            -12827*r**10+14176*r**12+173845*r**14+140140*r**16)+6*(-1+r**2)**2*(6619
            +17111*r**2-4218*r**4-14118*r**6+79038*r**8+77078*r**10-17114*r**12
            -5750*r**14+16315*r**16+6319*r**18)+2*Q2**2*(188137+318779*r**2+26487*r**4
            -70095*r**6+689339*r**8+667917*r**10-97779*r**12+14027*r**14+302616*r**16
            +178172*r**18)-3*Q2*(65641+90513*r**2-106774*r**4-56324*r**6+460954*r**8
            +434746*r**10+439800*r**12-74828*r**14-112083*r**16+86149*r**18+62446*r**20))*sqrtq2)
            +logq2**6*(-179159040000*r**28*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(28000*Q2**13*(1+r**2)-60*Q2**12*(8237+16554*r**2+8317*r**4)
            +30*Q2**11*(102831+323326*r**2+324719*r**4+104224*r**6)-4*Q2**10*(2393221
            +10408371*r**2+16057667*r**4+10483937*r**6+2431116*r**8)+60*Q2**9*(268197
            +1517316*r**2+3217631*r**4+3227180*r**6+1531314*r**8+272646*r**10)-30*Q2**8*(504431
            +3416761*r**2+9233858*r**4+12657478*r**6+9273253*r**8+3445917*r**10
            +508614*r**12)+5*Q2**7*(2708149+12534858*r**2+34235507*r**4+55775536*r**6
            +55460527*r**8+33828362*r**10+12358481*r**12+2623908*r**14)-30*Q2**6*(913654
            +2312513*r**2+3408314*r**4+3170317*r**6+2098482*r**8+2476451*r**10+2912294*r**12
            +2172527*r**14+881496*r**16)+3*Q2**5*(13969811+45450196*r**2+101497202*r**4
            +144351692*r**6+108808776*r**8+96117456*r**10+122931366*r**12+90981372*r**14
            +43370237*r**16+13676676*r**18)-20*Q2**4*(1184776+5978918*r**2+18902518*r**4
            +35503894*r**6+30023653*r**8+15671650*r**10+26124763*r**12+31847422*r**14
            +17519947*r**16+5761932*r**18+1173023*r**20)-15*Q2**3*(924113-629962*r**2
            -246859*r**4-1143968*r**6-2162006*r**8+3111448*r**10+4563538*r**12+208852*r**14
            -366971*r**16-364846*r**18-623239*r**20+907052*r**22)+18*(-1+r**2)**2*(157407
            +502911*r**2+4304009*r**4+6296021*r**6-1418460*r**8+1659210*r**10+11983146*r**12
            +1385134*r**14-1669601*r**16+5952055*r**18+4080653*r**20+479613*r**22
            +156702*r**24)+30*Q2**2*(913740+1538405*r**2+11270850*r**4+21375795*r**6
            +10917272*r**8-1543270*r**10-2183356*r**12-1463842*r**14+10634084*r**16
            +20306129*r**18+10538010*r**20+1463327*r**22+904856*r**24)-45*Q2*(327413
            +548792*r**2+5787832*r**4+6651516*r**6-5724767*r**8-1398540*r**10+22005616*r**12
            +21317672*r**14-2137281*r**16-5801776*r**18+6323544*r**20+5452124*r**22
            +512683*r**24+325252*r**26))-179159040000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(28000*Q2**13*(1+r**2)-60*Q2**12*(8237+16554*r**2+8317*r**4)
            +30*Q2**11*(102831+323326*r**2+324719*r**4+104224*r**6)-4*Q2**10*(2393221
            +10408371*r**2+16057667*r**4+10483937*r**6+2431116*r**8)+60*Q2**9*(268197
            +1517316*r**2+3217631*r**4+3227180*r**6+1531314*r**8+272646*r**10)-30*Q2**8*(504431
            +3416761*r**2+9233858*r**4+12657478*r**6+9273253*r**8+3445917*r**10
            +508614*r**12)+5*Q2**7*(2708149+12534858*r**2+34235507*r**4+55775536*r**6
            +55460527*r**8+33828362*r**10+12358481*r**12+2623908*r**14)-30*Q2**6*(913654
            +2312513*r**2+3408314*r**4+3170317*r**6+2098482*r**8+2476451*r**10+2912294*r**12
            +2172527*r**14+881496*r**16)+3*Q2**5*(13969811+45450196*r**2+101497202*r**4
            +144351692*r**6+108808776*r**8+96117456*r**10+122931366*r**12+90981372*r**14
            +43370237*r**16+13676676*r**18)-20*Q2**4*(1184776+5978918*r**2+18902518*r**4
            +35503894*r**6+30023653*r**8+15671650*r**10+26124763*r**12+31847422*r**14
            +17519947*r**16+5761932*r**18+1173023*r**20)-15*Q2**3*(924113-629962*r**2
            -246859*r**4-1143968*r**6-2162006*r**8+3111448*r**10+4563538*r**12+208852*r**14
            -366971*r**16-364846*r**18-623239*r**20+907052*r**22)+18*(-1+r**2)**2*(157407
            +502911*r**2+4304009*r**4+6296021*r**6-1418460*r**8+1659210*r**10+11983146*r**12
            +1385134*r**14-1669601*r**16+5952055*r**18+4080653*r**20+479613*r**22
            +156702*r**24)+30*Q2**2*(913740+1538405*r**2+11270850*r**4+21375795*r**6
            +10917272*r**8-1543270*r**10-2183356*r**12-1463842*r**14+10634084*r**16
            +20306129*r**18+10538010*r**20+1463327*r**22+904856*r**24)-45*Q2*(327413
            +548792*r**2+5787832*r**4+6651516*r**6-5724767*r**8-1398540*r**10+22005616*r**12
            +21317672*r**14-2137281*r**16-5801776*r**18+6323544*r**20+5452124*r**22
            +512683*r**24+325252*r**26))*sqrtq2)+logq2**5*(-995328000*r**24*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**4*(-112000*Q2**17+160*Q2**16*(37097+37217*r**2)
            -10*Q2**15*(6078337+12357778*r**2+6095761*r**4)+Q2**14*(299580078+925915722*r**2
            +926641354*r**4+300270894*r**6)-2*Q2**13*(436415361+1844707800*r**2+2818217752*r**4
            +1846209196*r**6+437049963*r**8)+2*Q2**12*(810450954+4430988777*r**2
            +9176519030*r**4+9177363416*r**6+4432197920*r**8+810199647*r**10)-4*Q2**11*(490990263
            +3270537054*r**2+8378856899*r**4+11170855826*r**6+8371760874*r**8+3265967390*r**10
            +488846634*r**12)+Q2**10*(1546391433+10781670480*r**2+28299419299*r**4
            +40274231558*r**6+40132464943*r**8+28103428960*r**10+10706547133*r**12
            +1526112354*r**14)+Q2**9*(-723541281-2639082609*r**2+6885039367*r**4
            +47404286867*r**6+77736214265*r**8+48133777649*r**10+7408463281*r**12
            -2503062323*r**14-703136688*r**16)-2*Q2**8*(78166903+1469002275*r**2
            +17137962586*r**4+71069716118*r**6+138515823834*r**8+138906190678*r**10
            +71704487690*r**12+17429321406*r**14+1529476843*r**16+78674899*r**18)
            +2*Q2**7*(576142517+1493926616*r**2+14156129135*r**4+56655957408*r**6
            +128164706050*r**8+168600178448*r**10+128253738486*r**12+56634040240*r**14
            +14044494833*r**16+1495891960*r**18+568490531*r**20)-2*Q2**6*(901479778
            +2206548199*r**2+17592899114*r**4+32622975411*r**6+37815644634*r**8+45835002138*r**10
            +43520249838*r**12+34131376974*r**14+30549422436*r**16+16819510799*r**18
            +2141313560*r**20+899011519*r**22)+6*Q2**5*(219784624+1415156375*r**2
            +11402282507*r**4+22771465039*r**6+26253187569*r**8+23241392124*r**10
            +16798080204*r**12+18728658084*r**14+22487737824*r**16+21393349709*r**18
            +11066291545*r**20+1386821869*r**22+222198287*r**24)-6*Q2**4*(20588362
            +1238760723*r**2+9234694266*r**4+26569008056*r**6+48516222540*r**8+58045752351*r**10
            +40872565644*r**12+36929165688*r**14+50814236898*r**16+44179431065*r**18
            +25335259242*r**20+9060081888*r**22+1224463576*r**24+22921701*r**26)
            -108*Q2**3*(5113509-8063475*r**2+84468278*r**4-369481166*r**6-556735648*r**8
            -237084413*r**10-14050065*r**12+206231024*r**14+157095357*r**16-108815049*r**18
            -517331796*r**20-355042210*r**22+82753598*r**24-8337991*r**26+5110447*r**28)
            +54*(-1+r**2)**2*(328117+8709659*r**2+97169887*r**4+188355917*r**6+944098579*r**8
            +1162027417*r**10-14856143*r**12-317069329*r**14-295492869*r**16+9266877*r**18
            +1116254145*r**20+884721659*r**22+175661117*r**24+96138127*r**26+8604719*r**28
            +338121*r**30)+9*Q2**2*(48563437+336190596*r**2+4562899455*r**4+4102555378*r**6
            +22725475785*r**8+37964626812*r**10+11824404523*r**12-9724558470*r**14
            -9451895481*r**16+11814357980*r**18+36283244685*r**20+21055122006*r**22
            +3793651715*r**24+4504277028*r**26+328723785*r**28+49192766*r**30)-27*Q2*(5269631
            +76588003*r**2+865746363*r**4+669374287*r**6+6019426783*r**8+5203791143*r**10
            -4497146793*r**12+2478625219*r**14+11746751201*r**16+2156190089*r**18
            -4381985119*r**20+5035995917*r**22+5616697893*r**24+581840237*r**26+856235853*r**28
            +75262945*r**30+5384348*r**32))-995328000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(112000*Q2**18-480*Q2**17*(12599+12639*r**2)+10*Q2**16*(6671889
            +13546802*r**2+6691233*r**4)-8*Q2**15*(45045431+138784609*r**2+138897093*r**4
            +45153563*r**6)+60*Q2**14*(19540180+81915190*r**2+124816543*r**4+81988844*r**6
            +19572847*r**8)-2*Q2**13*(1246866315+6712111938*r**2+13839444582*r**4
            +13841790364*r**6+6715457079*r**8+1247249610*r**10)+Q2**12*(3584862960
            +23565027678*r**2+60730443210*r**4+81391188196*r**6+60706166168*r**8
            +23548664694*r**10+3575785830*r**12)-3*Q2**11*(1170117495+8609259916*r**2
            +24965665037*r**4+39491027486*r**6+39434310581*r**8+24884780672*r**10
            +8575267743*r**12+1160499630*r**14)+2*Q2**10*(1134966357+7483572261*r**2
            +16098025206*r**4+10584681995*r**6+1335241118*r**8+10051058127*r**10
            +15700756406*r**12+7367860905*r**14+1114624521*r**16)-5*Q2**9*(113441495
            +84923868*r**2-7704376386*r**4-39285751694*r**6-80434429760*r**8-80736474654*r**10
            -39790243262*r**12-7952808754*r**14+29449065*r**16+109157378*r**18)-12*Q2**8*(109051570
            +506849299*r**2+5460515666*r**4+24143939352*r**6+56291707667*r**8+74337032160*r**10
            +56477402809*r**12+24294641556*r**14+5500548847*r**16+517340617*r**18
            +107860905*r**20)+Q2**7*(2955244590+8553234664*r**2+66485909730*r**4
            +206870123908*r**6+445272616184*r**8+685199773272*r**10+680748333544*r**12
            +438038311400*r**14+202455915018*r**16+64719795184*r**18+8411392102*r**20
            +2935004100*r**22)-4*Q2**6*(780416825+3676748551*r**2+27003147417*r**4
            +59265134821*r**6+74599091376*r**8+76687411572*r**10+69874746294*r**12
            +66918800532*r**14+66072006441*r**16+55774491181*r**18+26079849497*r**20
            +3600395343*r**22+782803190*r**24)+12*Q2**5*(120186493+1436850861*r**2
            +11026066574*r**4+30371377801*r**6+48770437574*r**8+53770166022*r**10
            +40456018986*r**12+36227951988*r**14+46015316403*r**16+44030259299*r**18
            +28897450248*r**20+10756597651*r**22+1416741866*r**24+122559994*r**26)
            +30*Q2**4*(14290960-280898327*r**2-1790605197*r**4-8490872662*r**6-17021294452*r**8
            -22165898865*r**10-19834243833*r**12-14817914580*r**14-16983137232*r**16
            -19390467769*r**18-15765332527*r**20-8157220182*r**22-1758996140*r**24
            -279493823*r**26+13813269*r**28)-9*Q2**3*(109925545+300791004*r**2+5479757091*r**4
            +682400722*r**6+11610874017*r**8+28438786080*r**10+8810790787*r**12-7418386962*r**14
            -5091978909*r**16+12393721676*r**18+28769482545*r**20+10586633934*r**22
            +526188371*r**24+5397264312*r**26+289993257*r**28+110518130*r**30)+54*(
            -1+r**2)**2*(328117+9037776*r**2+105879546*r**4+285525804*r**6+1132454496*r**8
            +2106125996*r**10+1147171274*r**12-331925472*r**14-612562198*r**16-286225992*r**18
            +1125521022*r**20+2000975804*r**22+1060382776*r**24+271799244*r**26+104742846*r**28
            +8942840*r**30+338121*r**32)+18*Q2**2*(32186165+307259021*r**2+3748164570*r**4
            +5336788847*r**6+22443155756*r**8+38150738013*r**10+18148795478*r**12
            +4767860855*r**14+8031899826*r**16+4415516383*r**18+17475823654*r**20
            +36223177221*r**22+20849433700*r**24+5021724727*r**26+3700854186*r**28
            +301852693*r**30+32672905*r**32)-27*Q2*(5925865+97964484*r**2+1102491738*r**4
            +1540572254*r**6+8017914334*r**8+10147590278*r**10-2082980446*r**12-269180826*r**14
            +14872955712*r**16+14469307862*r**18-621339986*r**20-2023028710*r**22
            +9697637698*r**24+7457613234*r**26+1422055254*r**28+1090032418*r**30
            +96504247*r**32+6060590*r**34))*sqrtq2)+logq2**4*(16588800*r**20*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(6863360*Q2**20-320*Q2**19*(380107
            +380053*r**2)+8*Q2**18*(115366659+234175330*r**2+115358943*r**4)-2*Q2**17*(1984639393
            +6202988778*r**2+6202411121*r**4+1984189096*r**6)+8*Q2**16*(1325870062
            +5774796625*r**2+8850995301*r**4+5772824135*r**6+1324622149*r**8)-2*Q2**15*(8887551471
            +52181403532*r**2+109016699344*r**4+108983711600*r**6+52130413749*r**8
            +8864652792*r**10)+3*Q2**14*(5622137955+46221661955*r**2+120000453874*r**4
            +158084379190*r**6+119842112083*r**8+46106792655*r**10+5589663840*r**12)
            -Q2**13*(3643672971+78621959250*r**2+174580916625*r**4+130434496828*r**6
            +129508394201*r**8+173110879842*r**10+78016954995*r**12+3585564792*r**14)
            -Q2**12*(12285623547+58906448247*r**2+522749060007*r**4+1876927030247*r**6
            +2799974218809*r**8+1879536888373*r**10+524535979653*r**12+59236008909*r**14
            +12126173184*r**16)+2*Q2**11*(9087330491+76612616340*r**2+627260374749*r**4
            +2456774171430*r**6+4689514471089*r**8+4689837351272*r**10+2456757707895*r**12
            +626334579990*r**14+76190832600*r**16+8919681632*r**18)-Q2**10*(13958986489
            +138773822503*r**2+1271001221724*r**4+5665131920044*r**6+13141090325102*r**8
            +17175906034914*r**10+13123942048476*r**12+5648827901564*r**14+1261058451921*r**16
            +136616785231*r**18+13864465168*r**20)+Q2**9*(6077638365+81766300750*r**2
            +597115984431*r**4+2373260022580*r**6+5247107641062*r**8+6793725926440*r**10
            +6744509074970*r**12+5165729868676*r**14+2328841030925*r**16+582276038202*r**18
            +79659019015*r**20+6492870840*r**22)+Q2**8*(3027205751-41993419095*r**2
            +53333776993*r**4+1191010632971*r**6+7124329385022*r**8+19922229677906*r**10
            +27939510045850*r**12+20081808794574*r**14+7263963975371*r**16+1247802892757*r**18
            +62150014293*r**20-41777134505*r**22+2487643952*r**24)-2*Q2**7*(4612466149
            +2022095644*r**2+202669140330*r**4+701186551060*r**6+4156541274491*r**8
            +12537405198480*r**10+21696166131360*r**12+21733008142704*r**14+12585716457159*r**16
            +4172693028716*r**18+713175842438*r**20+201973327788*r**22+1097349353*r**24
            +4556989528*r**26)+Q2**6*(7071003423+59610092915*r**2+666555749030*r**4
            +1058567490770*r**6+5674915851873*r**8+9508568823393*r**10+12872203220100*r**12
            +15973132871724*r**14+12451831268145*r**16+9057391835541*r**18+5407586601334*r**20
            +1018533230530*r**22+663288669391*r**24+57682510935*r**26+7355980896*r**28)
            -3*Q2**5*(129273587+23862890434*r**2+233747100921*r**4+909472599804*r**6
            +4073577651479*r**8+5152040732694*r**10+2861967283309*r**12+1704268382928*r**14
            +1270152702345*r**16+2122854173758*r**18+4717298222795*r**20+3913138542492*r**22
            +883504833261*r**24+233987354986*r**26+23763897423*r**28+213685784*r**30)
            +3*Q2**4*(-868372455+9812186865*r**2+104168548649*r**4+1053238632725*r**6
            +4430312464013*r**8+8355346873045*r**10+9786944958445*r**12+9328996472617*r**14
            +8165455185915*r**16+8112084221379*r**18+8633404947915*r**20+7856671952815*r**22
            +4314086689759*r**24+1036334710135*r**26+104533937183*r**28+10083947795*r**30
            -856316800*r**32)+18*Q2**3*(73763761+660571060*r**2+7072063741*r**4-45104944226*r**6
            -22567926197*r**8-510961280568*r**10-470356508515*r**12-92912896230*r**14
            -71216137123*r**16-6758800636*r**18+11342728943*r**20-408483610990*r**22
            -481581656383*r**24-20591890576*r**26-45421358217*r**28+7127685814*r**30
            +627735270*r**32+77101072*r**34)+9*Q2**2*(5396209-2052247101*r**2-24757630024*r**4
            -109844631624*r**6-873582999676*r**8-267551760028*r**10-2427939758208*r**12
            -3569649073304*r**14-291167695954*r**16+1343044374802*r**18-312207586896*r**20
            -3429258456056*r**22-2232737493420*r**24-219735952220*r**26-861021277376*r**28
            -106668005160*r**30-24876886135*r**32-2044102877*r**34+985048*r**36)
            +27*(-1+r**2)**2*(1590091-41826721*r**2-707177508*r**4-7456719592*r**6
            -44032356120*r**8-31635682988*r**10-238518529292*r**12-326974620616*r**14
            +124765321606*r**16+438404649290*r**18+104568655228*r**20-326993875128*r**22
            -223129820144*r**24-26481748236*r**26-43309540420*r**28-7348066456*r**30
            -707633609*r**32-42575857*r**34+1556472*r**36)-27*Q2*(7435413-290336890*r**2
            -3774023757*r**4-28646143620*r**6-173925220816*r**8+27807439036*r**10
            -735350345560*r**12-636893187884*r**14+452387053810*r**16-135924538392*r**18
            -136900556586*r**20+418676731740*r**22-639451726536*r**24-686718456860*r**26
            +43869817232*r**28-171303901988*r**30-28056498415*r**32-3781597198*r**34
            -292608705*r**36+7065976*r**38))+16588800*r**20*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(6863360*Q2**20-320*Q2**19*(380107+380053*r**2)+8*Q2**18*(115366659
            +234175330*r**2+115358943*r**4)-2*Q2**17*(1984639393+6202988778*r**2
            +6202411121*r**4+1984189096*r**6)+8*Q2**16*(1325870062+5774796625*r**2
            +8850995301*r**4+5772824135*r**6+1324622149*r**8)-2*Q2**15*(8887551471
            +52181403532*r**2+109016699344*r**4+108983711600*r**6+52130413749*r**8
            +8864652792*r**10)+3*Q2**14*(5622137955+46221661955*r**2+120000453874*r**4
            +158084379190*r**6+119842112083*r**8+46106792655*r**10+5589663840*r**12)
            -Q2**13*(3643672971+78621959250*r**2+174580916625*r**4+130434496828*r**6
            +129508394201*r**8+173110879842*r**10+78016954995*r**12+3585564792*r**14)
            -Q2**12*(12285623547+58906448247*r**2+522749060007*r**4+1876927030247*r**6
            +2799974218809*r**8+1879536888373*r**10+524535979653*r**12+59236008909*r**14
            +12126173184*r**16)+2*Q2**11*(9087330491+76612616340*r**2+627260374749*r**4
            +2456774171430*r**6+4689514471089*r**8+4689837351272*r**10+2456757707895*r**12
            +626334579990*r**14+76190832600*r**16+8919681632*r**18)-Q2**10*(13958986489
            +138773822503*r**2+1271001221724*r**4+5665131920044*r**6+13141090325102*r**8
            +17175906034914*r**10+13123942048476*r**12+5648827901564*r**14+1261058451921*r**16
            +136616785231*r**18+13864465168*r**20)+Q2**9*(6077638365+81766300750*r**2
            +597115984431*r**4+2373260022580*r**6+5247107641062*r**8+6793725926440*r**10
            +6744509074970*r**12+5165729868676*r**14+2328841030925*r**16+582276038202*r**18
            +79659019015*r**20+6492870840*r**22)+Q2**8*(3027205751-41993419095*r**2
            +53333776993*r**4+1191010632971*r**6+7124329385022*r**8+19922229677906*r**10
            +27939510045850*r**12+20081808794574*r**14+7263963975371*r**16+1247802892757*r**18
            +62150014293*r**20-41777134505*r**22+2487643952*r**24)-2*Q2**7*(4612466149
            +2022095644*r**2+202669140330*r**4+701186551060*r**6+4156541274491*r**8
            +12537405198480*r**10+21696166131360*r**12+21733008142704*r**14+12585716457159*r**16
            +4172693028716*r**18+713175842438*r**20+201973327788*r**22+1097349353*r**24
            +4556989528*r**26)+Q2**6*(7071003423+59610092915*r**2+666555749030*r**4
            +1058567490770*r**6+5674915851873*r**8+9508568823393*r**10+12872203220100*r**12
            +15973132871724*r**14+12451831268145*r**16+9057391835541*r**18+5407586601334*r**20
            +1018533230530*r**22+663288669391*r**24+57682510935*r**26+7355980896*r**28)
            -3*Q2**5*(129273587+23862890434*r**2+233747100921*r**4+909472599804*r**6
            +4073577651479*r**8+5152040732694*r**10+2861967283309*r**12+1704268382928*r**14
            +1270152702345*r**16+2122854173758*r**18+4717298222795*r**20+3913138542492*r**22
            +883504833261*r**24+233987354986*r**26+23763897423*r**28+213685784*r**30)
            +3*Q2**4*(-868372455+9812186865*r**2+104168548649*r**4+1053238632725*r**6
            +4430312464013*r**8+8355346873045*r**10+9786944958445*r**12+9328996472617*r**14
            +8165455185915*r**16+8112084221379*r**18+8633404947915*r**20+7856671952815*r**22
            +4314086689759*r**24+1036334710135*r**26+104533937183*r**28+10083947795*r**30
            -856316800*r**32)+18*Q2**3*(73763761+660571060*r**2+7072063741*r**4-45104944226*r**6
            -22567926197*r**8-510961280568*r**10-470356508515*r**12-92912896230*r**14
            -71216137123*r**16-6758800636*r**18+11342728943*r**20-408483610990*r**22
            -481581656383*r**24-20591890576*r**26-45421358217*r**28+7127685814*r**30
            +627735270*r**32+77101072*r**34)+9*Q2**2*(5396209-2052247101*r**2-24757630024*r**4
            -109844631624*r**6-873582999676*r**8-267551760028*r**10-2427939758208*r**12
            -3569649073304*r**14-291167695954*r**16+1343044374802*r**18-312207586896*r**20
            -3429258456056*r**22-2232737493420*r**24-219735952220*r**26-861021277376*r**28
            -106668005160*r**30-24876886135*r**32-2044102877*r**34+985048*r**36)
            +27*(-1+r**2)**2*(1590091-41826721*r**2-707177508*r**4-7456719592*r**6
            -44032356120*r**8-31635682988*r**10-238518529292*r**12-326974620616*r**14
            +124765321606*r**16+438404649290*r**18+104568655228*r**20-326993875128*r**22
            -223129820144*r**24-26481748236*r**26-43309540420*r**28-7348066456*r**30
            -707633609*r**32-42575857*r**34+1556472*r**36)-27*Q2*(7435413-290336890*r**2
            -3774023757*r**4-28646143620*r**6-173925220816*r**8+27807439036*r**10
            -735350345560*r**12-636893187884*r**14+452387053810*r**16-135924538392*r**18
            -136900556586*r**20+418676731740*r**22-639451726536*r**24-686718456860*r**26
            +43869817232*r**28-171303901988*r**30-28056498415*r**32-3781597198*r**34
            -292608705*r**36+7065976*r**38))*sqrtq2)+logq2**3*(276480*r**16*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**5*(64815360*Q2**23-64*Q2**22*(14656849+14657841*r**2)
            +2*Q2**21*(3051897101+6253205690*r**2+3050577069*r**4)-6*Q2**20*(3848004021
            +12446845177*r**2+12442709523*r**4+3842504399*r**6)+20*Q2**19*(2717103430
            +12803303913*r**2+19872112016*r**4+12789930685*r**6+2709610320*r**8)
            -10*Q2**18*(7629160937+52983407720*r**2+112351678536*r**4+112271670058*r**6
            +52871086127*r**8+7599904206*r**10)+12*Q2**17*(3598151357+49285805963*r**2
            +121894749055*r**4+150252431800*r**6+121596220030*r**8+49110118087*r**10
            +3599390288*r**12)+Q2**16*(51028651427-51215075760*r**2+786942088133*r**4
            +3344367182070*r**6+3348534440205*r**8+791846154032*r**10-51030359005*r**12
            +49791739938*r**14)-Q2**15*(126762290591+894726402107*r**2+6428323032603*r**4
            +22046977376239*r**6+32654133417345*r**8+22045575919701*r**10+6419147434437*r**12
            +886932589793*r**14+124472683104*r**16)+15*Q2**14*(6561034695+89770876068*r**2
            +720230540056*r**4+3090160717548*r**6+6105680697754*r**8+6103764742444*r**10
            +3086240879512*r**12+717099116996*r**14+88615742575*r**16+6513735680*r**18)
            +5*Q2**13*(1288627985-160026354765*r**2-1481724223704*r**4-9021266018532*r**6
            -22848508989966*r**8-30150413095282*r**10-22809664552068*r**12-8985325389372*r**14
            -1467146979267*r**16-157019595553*r**18+634105884*r**20)-Q2**12*(80013532111
            +106670614774*r**2+2036641677555*r**4-2273901466380*r**6-382362932430*r**8
            +30077743479444*r**10+30338877439226*r**12+44853328920*r**14-2054197467585*r**16
            +2060161423030*r**18+100809795091*r**20+75186433524*r**22)+3*Q2**11*(23504056119
            +190347293975*r**2+2757720110841*r**4+15387679104025*r**6+69382512145570*r**8
            +186339688289186*r**10+260400291586990*r**12+186489507229134*r**14+69430298039015*r**16
            +15371887457415*r**18+2731199208089*r**20+180716275545*r**22+23175070336*r**24)
            -Q2**10*(16440250871+606310860432*r**2+7416531133738*r**4+54806869512104*r**6
            +297582148912545*r**8+956143291403864*r**10+1722489814385308*r**12+1722330415113552*r**14
            +955400794015721*r**16+296415840322400*r**18+54261476560506*r**20+7316568848392*r**22
            +579894375743*r**24+20123690424*r**26)-5*Q2**9*(5085300455-92681586211*r**2
            -780821244222*r**4-6289921939082*r**6-33561561310351*r**8-120049235141181*r**10
            -265208109609100*r**12-343738575710588*r**14-264407114461767*r**16-119182070209101*r**18
            -33034437766846*r**20-6135796345722*r**22-783882776657*r**24-93341603155*r**26
            +4396270920*r**28)+15*Q2**8*(2037658913-6942538450*r**2-63670165517*r**4
            -793870041416*r**6+524813136933*r**8+8334396411458*r**10+29706703826367*r**12
            +56893049326684*r**14+57309667370691*r**16+30470138407026*r**18+8858292602489*r**20
            +696048376832*r**22-769708551305*r**24-71413732706*r**26-8729810219*r**28
            +2047694060*r**30)-Q2**7*(10395505661+290063671449*r**2+1599038538245*r**4
            -1707735129015*r**6+71788129684365*r**8+288158393126329*r**10+1122268488594781*r**12
            +2477758787775825*r**14+3244302880212255*r**16+2487575834878675*r**18
            +1130065623573639*r**20+293779248986131*r**22+72802027847415*r**24-2022352506405*r**26
            +1523414191895*r**28+270785595731*r**30+12294621024*r**32)+Q2**6*(-7058084053
            +326962811660*r**2+2785156127628*r**4+11866982028340*r**6+90907032425940*r**8
            +96562233237948*r**10+517040880430260*r**12+921452975570692*r**14+1319688653841210*r**16
            +1313471850635140*r**18+902470757241268*r**20+497114997018780*r**22+92786288351012*r**24
            +90708630796500*r**26+11316252331020*r**28+2807838304812*r**30+329648461475*r**32
            -6177529632*r**34)+3*Q2**5*(2723530423-24476535189*r**2-593706061346*r**4
            -7092581474808*r**6-39625456955800*r**8-94353746254488*r**10-326428973572576*r**12
            -228762240189824*r**14+22275029348678*r**16+47400702075230*r**18+52261931666292*r**20
            -198443120459416*r**22-309283823571744*r**24-90256804262432*r**26-39472367350080*r**28
            -7014272736752*r**30-611385030469*r**32-28219801361*r**34+2815795662*r**36)
            -15*Q2**4*(124196825+5681607564*r**2-12092763307*r**4-916903997178*r**6
            -5507980296344*r**8-31882039376384*r**10-96168445085728*r**12-114658258838928*r**14
            -87606364390494*r**16-106785707234232*r**18-98707894825582*r**20-73101760382756*r**22
            -105519424006368*r**24-92945762795968*r**26-31195709785624*r**28-5473590423584*r**30
            -923678449155*r**32-13605885972*r**34+5339363665*r**36+147609550*r**38)
            -45*Q2**3*(28482533-1293097895*r**2-10382722953*r**4-12314390669*r**6
            -64840709144*r**8+4367552374360*r**10+4039441446192*r**12+16692517166880*r**14
            +8801355498954*r**16+4829533289602*r**18+9143192030982*r**20+2282108716046*r**22
            +6363795029024*r**24+15175175125904*r**26+3753765406088*r**28+4354591796664*r**30
            -74586351543*r**32-9117651651*r**34-10458190389*r**36-1315500121*r**38
            +27291136*r**40)+54*(-1+r**2)**2*(356411+28918339*r**2-228152360*r**4
            -10315760100*r**6-87204718205*r**8-618409497109*r**10-2213899351576*r**12
            +1006734241880*r**14-12676508351250*r**16-12902877415810*r**18+20471950036536*r**20
            +19649781764944*r**22-13504761861930*r**24-12147500215450*r**26+1272229834360*r**28
            -2166733322264*r**30-606255177641*r**32-86805894465*r**34-10336793200*r**36
            -238242220*r**38+27584551*r**40+416559*r**42)+9*Q2**2*(105248661-461618376*r**2
            -37666561290*r**4-637107769180*r**6-4301554842075*r**8-12385996557244*r**10
            -89017044184936*r**12+23448441375280*r**14-147665288376150*r**16-195481248985440*r**18
            +21831957831476*r**20+21175554260824*r**22-187813064222190*r**24-134047478045160*r**26
            +26847350335480*r**28-87857548454864*r**30-11848685719711*r**32-4315908031800*r**34
            -631083662010*r**36-38431477340*r**38-656824279*r**40+110680324*r**42)
            -27*Q2*(8571479+228608165*r**2-4081673614*r**4-112295695070*r**6-773768210385*r**8
            -4105538446631*r**10-16909478360000*r**12+21164880603016*r**14-73439676121490*r**16
            -52249167548870*r**18+51321240361244*r**20+34384784508060*r**22+46882258796086*r**24
            -54397458528310*r**26-69942244465480*r**28+22634824829864*r**30-16626471226405*r**32
            -3990430396639*r**34-772173957630*r**36-112047793390*r**38-4181496581*r**40
            +205395805*r**42+9446776*r**44))-276480*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(64815360*Q2**24-64*Q2**23*(15669589+15670581*r**2)+2*Q2**22*(3520916269
            +7191275770*r**2+3519627981*r**4)-4*Q2**21*(7297954582+23322819161*r**2
            +23315955664*r**4+7289045133*r**6)+Q2**20*(77430092726+353835173448*r**2
            +546779568520*r**4+353509897232*r**6+77247232794*r**8)-10*Q2**19*(13063367797
            +84024222406*r**2+177702510394*r**4+177595755460*r**6+83870168137*r**8
            +13019124846*r**10)+2*Q2**18*(59734712827+598777679063*r**2+1558043925610*r**4
            +2024631333770*r**6+1555291101105*r**8+597015660187*r**10+59595862758*r**12)
            +Q2**17*(7850835143-685822563600*r**2-1267224572083*r**4+78601011810*r**6
            +86350618245*r**8-1256629903372*r**10-683544459505*r**12+6599056482*r**14)
            -2*Q2**16*(88895471009+447269988887*r**2+3582025022488*r**4+13089143323221*r**6
            +19673517519810*r**8+13092978256969*r**10+3579981614732*r**12+442846985363*r**14
            +87132211521*r**16)+2*Q2**15*(112588905508+1184025916859*r**2+9063253767775*r**4
            +37413855586031*r**6+73143160629947*r**8+73128090236853*r**10+37379168273409*r**12
            +9031283389585*r**14+1170320705761*r**16+111089359152*r**18)-10*Q2**14*(9197238050
            +224511043527*r**2+1955864236038*r**4+10226219895672*r**6+25218016617936*r**8
            +33389374707938*r**10+25189840708968*r**12+10197672689448*r**14+1942145778990*r**16
            +221204015159*r**18+9453550578*r**20)+Q2**13*(-86456672036+687018019126*r**2
            +6172111214790*r**4+54788852677560*r**6+159731237974920*r**8+234916866946796*r**10
            +234461510797524*r**12+158930096378280*r**14+54316559310780*r**16+6060671451070*r**18
            +681117653254*r**20-78356962944*r**22)+2*Q2**12*(75262850234+378863014405*r**2
            +5208236312426*r**4+22962888761625*r**6+102745636018950*r**8+294357222707286*r**10
            +420808747839820*r**12+294926126227774*r**14+103140774989190*r**16+23060813163845*r**18
            +5177284421194*r**20+359072527625*r**22+72355822266*r**24)-2*Q2**11*(43476209614
            +623932455357*r**2+8130366674093*r**4+54621533578351*r**6+275946361330665*r**8
            +861654946354066*r**10+1531354877006918*r**12+1531499905780962*r**14+861580104910084*r**16
            +275411198405845*r**18+54285368278509*r**20+8026157649647*r**22+595784206693*r**24
            +44824450716*r**26)+2*Q2**10*(-4493125702+543079521179*r**2+5963474107640*r**4
            +46836505170626*r**6+260098412488202*r**8+926985808011157*r**10+2002336826917336*r**12
            +2581756554025900*r**14+1999883390719054*r**16+923863492691813*r**18+257924752858568*r**20
            +46128513568754*r**22+5907938553710*r**24+533363040971*r**26-928832088*r**28)
            +10*Q2**9*(5599138597-54211950553*r**2-532256663492*r**4-4726176653776*r**6
            -19138521919317*r**8-64303803608579*r**10-148068616635590*r**12-219133768669818*r**14
            -218108344030141*r**16-146089384724895*r**18-62820815084240*r**20-18541044491036*r**22
            -4614402388147*r**24-545732788965*r**26-57567381446*r**28+5269676550*r**30)
            -2*Q2**8*(20480194678+108245239197*r**2+269923989370*r**4-7285419116505*r**6
            +33876138058560*r**8+210523268176097*r**10+846442496081078*r**12+1888377542535795*r**14
            +2478671815336440*r**16+1902136460772215*r**18+859996044358182*r**20+218547181837973*r**22
            +35848562615160*r**24-7319593383285*r**26+160630524010*r**28+85276926673*r**30
            +21505015962*r**32)+2*Q2**7*(1668710804+313710994385*r**2+2337129168661*r**4
            +5879142718785*r**6+80493713490645*r**8+228254378024321*r**10+963733881075685*r**12
            +2260740125970649*r**14+3520875160914645*r**16+3522675282863035*r**18
            +2260056107846791*r**20+960479934789275*r**22+229683782592279*r**24+80744153068755*r**26
            +5408657008255*r**28+2301019046219*r**30+306364339115*r**32+3058545696*r**34)
            +2*Q2**6*(7614337661-196667166587*r**2-2446618561663*r**4-17964941290196*r**6
            -110825192660840*r**8-235265252213676*r**10-796445017192968*r**12-1062390288285212*r**14
            -1087158270682934*r**16-1245479199125330*r**18-1029578406438766*r**20
            -997457557819148*r**22-758876378042512*r**24-227132665967404*r**26-110220992588880*r**28
            -17583454423044*r**30-2485820928847*r**32-204065167963*r**34+7312458309*r**36)
            -6*Q2**5*(1672257274+3327516527*r**2-339323206535*r**4-6135403761022*r**6
            -37128969956164*r**8-146694700046104*r**10-450812472627852*r**12-564241253978520*r**14
            -322259516396808*r**16-232126402373626*r**18-196938420193194*r**20-255844995353452*r**22
            -517662032031500*r**24-432134720907008*r**26-142853860270316*r**28-36927296102376*r**30
            -6122025006498*r**32-353817130845*r**34+646406313*r**36+1776921706*r**38)
            +30*Q2**4*(19374613+4842549037*r**2+12368506558*r**4-446026794239*r**6
            -3115181083045*r**8-25246338397904*r**10-70084404400344*r**12-130452127712648*r**14
            -114334344863142*r**16-104440335746766*r**18-116461589076380*r**20-89327990678238*r**22
            -98856284738098*r**24-121995356090024*r**26-67701384399928*r**28-24866537799600*r**30
            -3086754909055*r**32-454965690087*r**34+11554024430*r**36+4716736789*r**38
            +32868071*r**40)+18*Q2**3*(123830663-3392347593*r**2-48022832765*r**4
            -375296668645*r**6-2343665170570*r**8+4563780884418*r**10-23491037541088*r**12
            +63554117220320*r**14-10097962523490*r**16-63663402521330*r**18+45847792217198*r**20
            +39151028997982*r**22-72291772748420*r**24-13176313635260*r**26+60746026497720*r**28
            -23657881220552*r**30+4775670752947*r**32-2367214023885*r**34-364481436105*r**36
            -48649964945*r**38-3548934602*r**40+123568002*r**42)-54*(-1+r**2)**2*(356411
            +29274750*r**2-199234021*r**4-10543912460*r**6-97520478305*r**8-705614215314*r**10
            -2832308848685*r**12-1207165109696*r**14-11669774109370*r**16-25579385767060*r**18
            +7569072620726*r**20+40121731801480*r**22+6145019903014*r**24-25652262077380*r**26
            -10875270381090*r**28-894503487904*r**30-2772988499905*r**32-693061072106*r**34
            -97142687665*r**36-10575035420*r**38-210657669*r**40+28001110*r**42+416559*r**44)
            -18*Q2**2*(65481549+164727390*r**2-25186600254*r**4-505830707840*r**6
            -3629983621205*r**8-14502083369606*r**10-76065737911090*r**12-1036980500304*r**14
            -172267937682670*r**16-249947020004100*r**18-9842785035116*r**20+73080932808240*r**22
            -12995366786554*r**24-242526458926140*r**26-158513430553060*r**28+3447138185104*r**30
            -74792823926895*r**32-14067942470714*r**34-3631756783350*r**36-502829259760*r**38
            -25816395681*r**40+35021730*r**42+69510326*r**44)+27*Q2*(9284301+293590678*r**2
            -4424330703*r**4-136038442766*r**6-1019666606185*r**8-5787938298614*r**10
            -23143586957757*r**12+13887649138862*r**14-86082547891646*r**16-98775096613220*r**18
            +66274465846186*r**20+17312033421428*r**22+16602292593582*r**24+61508410814484*r**26
            -100214766187130*r**28-81024806048484*r**30+16007236205953*r**32-22698959345938*r**34
            -5648564718091*r**36-1016962851590*r**38-135894738389*r**40-4562090302*r**42
            +268345447*r**44+10279894*r**46))*sqrtq2)+logq2**2*(-4608*r**12*(1-Q2
            +r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(-140835328*Q2**26+32*Q2**25*(67151989
            +67044589*r**2)-4*Q2**24*(3575510665+7561594066*r**2+3566234185*r**4)
            +2*Q2**23*(26801478845+91801363698*r**2+91697798573*r**4+26726497400*r**6)
            -4*Q2**22*(29779252565+154048637741*r**2+239976156353*r**4+153780937231*r**6
            +29735525990*r**8)+4*Q2**21*(34524522670+294049235524*r**2+605261702519*r**4
            +604741231484*r**6+293661418589*r**8+34700030530*r**10)+2*Q2**20*(1824095075
            -480309024237*r**2-806450878560*r**4-531445844590*r**6-806120155155*r**8
            -482545787337*r**10+235144940*r**12)-Q2**19*(265927438985+972740859794*r**2
            +7950873757575*r**4+24123532840400*r**6+24106306610675*r**8+7917274762770*r**10
            +948013374869*r**12+260958754340*r**14)+2*Q2**18*(178220610620+1823265827183*r**2
            +13083715313168*r**4+48237676109315*r**6+72550544734400*r**8+48155911420085*r**10
            +13017788960168*r**12+1798522484633*r**14+177849567500*r**16)-Q2**17*(67141512585
            +4061789469444*r**2+34046943174502*r**4+173607640623484*r**6+356364788881320*r**8
            +356018780762920*r**10+173090582585074*r**12+33838571601852*r**14+4022886898279*r**16
            +76504184460*r**18)+Q2**16*(-331811867190+785930723766*r**2+9563928324476*r**4
            +121481548714936*r**6+322741893191876*r**8+409220685173324*r**10+321630911641816*r**12
            +120868588487576*r**14+9550320333986*r**16+824298990926*r**18-318416182500*r**20)
            +4*Q2**15*(92743211730+844043186304*r**2+8344626514835*r**4+29267424090535*r**6
            +106290866702125*r**8+255560949316723*r**10+255784666867243*r**12+106464676503085*r**14
            +29117441267185*r**16+8221329429125*r**18+811462238354*r**20+92318061300*r**22)
            -4*Q2**14*(8443270990+1091181245196*r**2+12254770201765*r**4+85444707394300*r**6
            +385009018359000*r**8+1097542864523920*r**10+1564905324467014*r**12+1097194166709600*r**14
            +384086654012350*r**16+84666404882500*r**18+12076534044645*r**20+1062991497796*r**22
            +11910317260*r**24)-4*Q2**13*(61263487465-418007778944*r**2-5420207068379*r**4
            -74460247566265*r**6-422622230048825*r**8-1617115044185420*r**10-3118267345384666*r**12
            -3116770736292266*r**14-1613983578950105*r**16-419995099810900*r**18-73366128447275*r**20
            -5410007595629*r**22-429695206519*r**24+58060697200*r**26)+4*Q2**12*(50230336235
            +396310604279*r**2+2949881301157*r**4-11902517230076*r**6-87568057191020*r**8
            -749031176184995*r**10-2034443207392094*r**12-2682752898900512*r**14-2027673907043729*r**16
            -742726120820495*r**18-84908967221795*r**20-11515472291636*r**22+2720057282482*r**24
            +351234496939*r**26+50871293660*r**28)-2*Q2**11*(-1346842885+1281026848062*r**2
            +10052419934367*r**4+66172221255362*r**6+553261645934457*r**8+1991052605632736*r**10
            +5662805269875233*r**12+10905045033974328*r**14+10917793700677733*r**16
            +5679216096094838*r**18+1997066542979001*r**20+552593712487562*r**22+64146407263367*r**24
            +9600187699212*r**26+1223517567207*r**28+3995992220*r**30)+4*Q2**10*(
            -27252165160+310675887929*r**2+3213913058025*r**4+38322010835165*r**6
            +331946973206690*r**8+1806545857501697*r**10+6888077447014279*r**12+16557146458860725*r**14
            +22500788780792960*r**16+16561178210813035*r**18+6878117837100359*r**20
            +1796868905793527*r**22+328776149631850*r**24+36655515166715*r**26+3227905597065*r**28
            +326188645079*r**30-26195058340*r**32)+2*Q2**9*(34438744945+215650053628*r**2
            -2825424104660*r**4-57552848573450*r**6-360475637845550*r**8-2325392816550940*r**10
            -10199005446825328*r**12-30037594575862870*r**14-53885790705070600*r**16
            -53865747371981200*r**18-29972008683787060*r**20-10111895523783478*r**22
            -2282920261197850*r**24-356805877073500*r**26-56247518121800*r**28-3165942422570*r**30
            +154018140703*r**32+36185992780*r**34)+4*Q2**8*(2014157560-237166613871*r**2
            -411099179906*r**4+14013069240010*r**6+55881323233875*r**8+326965783898220*r**10
            +155929105522241*r**12+145277884267086*r**14+1855952397405335*r**16+3097060027972450*r**18
            +1768233434629425*r**20+45276817302086*r**22+96443374527641*r**24+309539937816180*r**26
            +57299788493475*r**28+14963249929570*r**30-303161529531*r**32-228519895571*r**34
            +1194407725*r**36)+2*Q2**7*(-16756919605+222811141478*r**2+3468227535449*r**4
            +12411134317378*r**6+27267717958730*r**8-104083074978990*r**10+3908627402536162*r**12
            +13223950666709026*r**14+34640730117696232*r**16+56595526492202190*r**18
            +56731994882499740*r**20+34872880839930502*r**22+13445950777152326*r**24
            +3989394033095542*r**26-105262693888290*r**28+23981990721830*r**30+9833254406333*r**32
            +3485704049924*r**34+245383445323*r**36-16828971280*r**38)+4*Q2**6*(3543565675
            +26319387829*r**2-1200574571566*r**4-16671947774401*r**6-67798734317806*r**8
            -180546988259852*r**10-1660358702472304*r**12-1207091293547284*r**14-7783589325593474*r**16
            -13929521522985594*r**18-17263962587005236*r**20-13868141115316254*r**22
            -7603742470911884*r**24-1181241861769724*r**26-1672325982020944*r**28
            -166028405963972*r**30-68078220795521*r**32-16367119651891*r**34-1245202722526*r**36
            +17464353719*r**38+3819573010*r**40)+12*Q2**5*(363872015-17794062452*r**2
            -39739004270*r**4+3367967454165*r**6+26210656741310*r**8+180305894769362*r**10
            +697560239845136*r**12+815627263476920*r**14+3318001767676910*r**16+454421691076840*r**18
            -1865751685168596*r**20-1952748307406286*r**22+239892944474420*r**24+3093595344572860*r**26
            +739988119797040*r**28+695574057563296*r**30+176571745751947*r**32+26448527599180*r**34
            +3527737746690*r**36-31463870815*r**38-17922894202*r**40+340388530*r**42)
            -6*Q2**4*(931521235-12997916181*r**2-338535368970*r**4+7604056750*r**6
            +25701653952975*r**8+327003407964195*r**10+1314102441006924*r**12+5524704824568120*r**14
            +13114195109047950*r**16+7747170674470150*r**18+5344193343130380*r**20
            +10830265121334564*r**22+4287222755586910*r**24+6786932773414350*r**26
            +12600834124085400*r**28+5358939629418840*r**30+1301007760091199*r**32
            +327061409206575*r**34+25684096235950*r**36+260763688350*r**38-335659896525*r**40
            -14771940881*r**42+959941740*r**44)+27*Q2**3*(36623845+604341498*r**2
            -24198258537*r**4-439314673140*r**6-637665550425*r**8+9905234093510*r**10
            +43919178120293*r**12+722719450701588*r**14+333075950114370*r**16+757069935323700*r**18
            +345997002380950*r**20+1274644436448008*r**22+1167173705275358*r**24+149984990617980*r**26
            +600015785424250*r**28+289315415288440*r**30+716736599371113*r**32+40841835170418*r**34
            +10550694226115*r**36-660878026900*r**38-436143444245*r**40-24702632162*r**42
            +495578673*r**44+39885300*r**46)+54*(-1+r**2)**2*(958023-15650637*r**2
            -607704817*r**4+314922603*r**6+110660295543*r**8+1578803410833*r**10
            +8941707934973*r**12+47316484033993*r**14+99512728603388*r**16-200362599317922*r**18
            +1060695223769238*r**20+122811283763278*r**22-1866084392083202*r**24+181602944601218*r**26
            +1046047023011258*r**28-217004132564942*r**30+97133988319823*r**32+46111111014943*r**34
            +8836680276363*r**36+1582518179703*r**38+109766073723*r**40+770138813*r**42
            -597192167*r**44-17787947*r**46+993918*r**48)+18*Q2**2*(38894180-1296792273*r**2
            -12848525034*r**4+337947056067*r**6+3585926493300*r**8+35656899385785*r**10
            +162994935753382*r**12+288806239949661*r**14+2730287251460292*r**16-2382019787935930*r**18
            +2674427512746540*r**20+3463143819687342*r**22+445897411848696*r**24+3308493747176322*r**26
            +2351290862561340*r**28-2438122224179030*r**30+2714669845818012*r**32
            +263669951890011*r**34+164367483998462*r**36+35215958237535*r**38+3565307886900*r**40
            +357346946037*r**42-12096300834*r**44-1361341143*r**46+39284380*r**48)
            -27*Q2*(13457491-288595748*r**2-6701491498*r**4+45922407872*r**6+1218334982772*r**8
            +14822832127632*r**10+67585891051042*r**12+275309280418592*r**14+848650919931087*r**16
            -2301578560828788*r**18+5715486524520412*r**20+1789157585874112*r**22
            -4768062657532288*r**24-4533117044770368*r**26+2041231724113732*r**28
            +5559524318717312*r**30-2387170370753983*r**32+841269271682292*r**34+263936145922862*r**36
            +67156691965312*r**38+14809768955532*r**40+1202507083952*r**42+51883785402*r**44
            -6505863328*r**46-317042403*r**48+13880996*r**50))+4608*r**12*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**5*(140835328*Q2**26-32*Q2**25*(67151989+67044589*r**2)
            +4*Q2**24*(3575510665+7561594066*r**2+3566234185*r**4)-2*Q2**23*(26801478845
            +91801363698*r**2+91697798573*r**4+26726497400*r**6)+4*Q2**22*(29779252565
            +154048637741*r**2+239976156353*r**4+153780937231*r**6+29735525990*r**8)
            -4*Q2**21*(34524522670+294049235524*r**2+605261702519*r**4+604741231484*r**6
            +293661418589*r**8+34700030530*r**10)+2*Q2**20*(-1824095075+480309024237*r**2
            +806450878560*r**4+531445844590*r**6+806120155155*r**8+482545787337*r**10
            -235144940*r**12)+Q2**19*(265927438985+972740859794*r**2+7950873757575*r**4
            +24123532840400*r**6+24106306610675*r**8+7917274762770*r**10+948013374869*r**12
            +260958754340*r**14)-2*Q2**18*(178220610620+1823265827183*r**2+13083715313168*r**4
            +48237676109315*r**6+72550544734400*r**8+48155911420085*r**10+13017788960168*r**12
            +1798522484633*r**14+177849567500*r**16)+Q2**17*(67141512585+4061789469444*r**2
            +34046943174502*r**4+173607640623484*r**6+356364788881320*r**8+356018780762920*r**10
            +173090582585074*r**12+33838571601852*r**14+4022886898279*r**16+76504184460*r**18)
            +2*Q2**16*(165905933595-392965361883*r**2-4781964162238*r**4-60740774357468*r**6
            -161370946595938*r**8-204610342586662*r**10-160815455820908*r**12-60434294243788*r**14
            -4775160166993*r**16-412149495463*r**18+159208091250*r**20)-4*Q2**15*(92743211730
            +844043186304*r**2+8344626514835*r**4+29267424090535*r**6+106290866702125*r**8
            +255560949316723*r**10+255784666867243*r**12+106464676503085*r**14+29117441267185*r**16
            +8221329429125*r**18+811462238354*r**20+92318061300*r**22)+4*Q2**14*(8443270990
            +1091181245196*r**2+12254770201765*r**4+85444707394300*r**6+385009018359000*r**8
            +1097542864523920*r**10+1564905324467014*r**12+1097194166709600*r**14
            +384086654012350*r**16+84666404882500*r**18+12076534044645*r**20+1062991497796*r**22
            +11910317260*r**24)+4*Q2**13*(61263487465-418007778944*r**2-5420207068379*r**4
            -74460247566265*r**6-422622230048825*r**8-1617115044185420*r**10-3118267345384666*r**12
            -3116770736292266*r**14-1613983578950105*r**16-419995099810900*r**18-73366128447275*r**20
            -5410007595629*r**22-429695206519*r**24+58060697200*r**26)-4*Q2**12*(50230336235
            +396310604279*r**2+2949881301157*r**4-11902517230076*r**6-87568057191020*r**8
            -749031176184995*r**10-2034443207392094*r**12-2682752898900512*r**14-2027673907043729*r**16
            -742726120820495*r**18-84908967221795*r**20-11515472291636*r**22+2720057282482*r**24
            +351234496939*r**26+50871293660*r**28)+2*Q2**11*(-1346842885+1281026848062*r**2
            +10052419934367*r**4+66172221255362*r**6+553261645934457*r**8+1991052605632736*r**10
            +5662805269875233*r**12+10905045033974328*r**14+10917793700677733*r**16
            +5679216096094838*r**18+1997066542979001*r**20+552593712487562*r**22+64146407263367*r**24
            +9600187699212*r**26+1223517567207*r**28+3995992220*r**30)+4*Q2**10*(27252165160
            -310675887929*r**2-3213913058025*r**4-38322010835165*r**6-331946973206690*r**8
            -1806545857501697*r**10-6888077447014279*r**12-16557146458860725*r**14
            -22500788780792960*r**16-16561178210813035*r**18-6878117837100359*r**20
            -1796868905793527*r**22-328776149631850*r**24-36655515166715*r**26-3227905597065*r**28
            -326188645079*r**30+26195058340*r**32)+2*Q2**9*(-34438744945-215650053628*r**2
            +2825424104660*r**4+57552848573450*r**6+360475637845550*r**8+2325392816550940*r**10
            +10199005446825328*r**12+30037594575862870*r**14+53885790705070600*r**16
            +53865747371981200*r**18+29972008683787060*r**20+10111895523783478*r**22
            +2282920261197850*r**24+356805877073500*r**26+56247518121800*r**28+3165942422570*r**30
            -154018140703*r**32-36185992780*r**34)-4*Q2**8*(2014157560-237166613871*r**2
            -411099179906*r**4+14013069240010*r**6+55881323233875*r**8+326965783898220*r**10
            +155929105522241*r**12+145277884267086*r**14+1855952397405335*r**16+3097060027972450*r**18
            +1768233434629425*r**20+45276817302086*r**22+96443374527641*r**24+309539937816180*r**26
            +57299788493475*r**28+14963249929570*r**30-303161529531*r**32-228519895571*r**34
            +1194407725*r**36)+2*Q2**7*(16756919605-222811141478*r**2-3468227535449*r**4
            -12411134317378*r**6-27267717958730*r**8+104083074978990*r**10-3908627402536162*r**12
            -13223950666709026*r**14-34640730117696232*r**16-56595526492202190*r**18
            -56731994882499740*r**20-34872880839930502*r**22-13445950777152326*r**24
            -3989394033095542*r**26+105262693888290*r**28-23981990721830*r**30-9833254406333*r**32
            -3485704049924*r**34-245383445323*r**36+16828971280*r**38)+4*Q2**6*(-3543565675
            -26319387829*r**2+1200574571566*r**4+16671947774401*r**6+67798734317806*r**8
            +180546988259852*r**10+1660358702472304*r**12+1207091293547284*r**14+7783589325593474*r**16
            +13929521522985594*r**18+17263962587005236*r**20+13868141115316254*r**22
            +7603742470911884*r**24+1181241861769724*r**26+1672325982020944*r**28
            +166028405963972*r**30+68078220795521*r**32+16367119651891*r**34+1245202722526*r**36
            -17464353719*r**38-3819573010*r**40)-12*Q2**5*(363872015-17794062452*r**2
            -39739004270*r**4+3367967454165*r**6+26210656741310*r**8+180305894769362*r**10
            +697560239845136*r**12+815627263476920*r**14+3318001767676910*r**16+454421691076840*r**18
            -1865751685168596*r**20-1952748307406286*r**22+239892944474420*r**24+3093595344572860*r**26
            +739988119797040*r**28+695574057563296*r**30+176571745751947*r**32+26448527599180*r**34
            +3527737746690*r**36-31463870815*r**38-17922894202*r**40+340388530*r**42)
            +6*Q2**4*(931521235-12997916181*r**2-338535368970*r**4+7604056750*r**6
            +25701653952975*r**8+327003407964195*r**10+1314102441006924*r**12+5524704824568120*r**14
            +13114195109047950*r**16+7747170674470150*r**18+5344193343130380*r**20
            +10830265121334564*r**22+4287222755586910*r**24+6786932773414350*r**26
            +12600834124085400*r**28+5358939629418840*r**30+1301007760091199*r**32
            +327061409206575*r**34+25684096235950*r**36+260763688350*r**38-335659896525*r**40
            -14771940881*r**42+959941740*r**44)-27*Q2**3*(36623845+604341498*r**2
            -24198258537*r**4-439314673140*r**6-637665550425*r**8+9905234093510*r**10
            +43919178120293*r**12+722719450701588*r**14+333075950114370*r**16+757069935323700*r**18
            +345997002380950*r**20+1274644436448008*r**22+1167173705275358*r**24+149984990617980*r**26
            +600015785424250*r**28+289315415288440*r**30+716736599371113*r**32+40841835170418*r**34
            +10550694226115*r**36-660878026900*r**38-436143444245*r**40-24702632162*r**42
            +495578673*r**44+39885300*r**46)-54*(-1+r**2)**2*(958023-15650637*r**2
            -607704817*r**4+314922603*r**6+110660295543*r**8+1578803410833*r**10
            +8941707934973*r**12+47316484033993*r**14+99512728603388*r**16-200362599317922*r**18
            +1060695223769238*r**20+122811283763278*r**22-1866084392083202*r**24+181602944601218*r**26
            +1046047023011258*r**28-217004132564942*r**30+97133988319823*r**32+46111111014943*r**34
            +8836680276363*r**36+1582518179703*r**38+109766073723*r**40+770138813*r**42
            -597192167*r**44-17787947*r**46+993918*r**48)-18*Q2**2*(38894180-1296792273*r**2
            -12848525034*r**4+337947056067*r**6+3585926493300*r**8+35656899385785*r**10
            +162994935753382*r**12+288806239949661*r**14+2730287251460292*r**16-2382019787935930*r**18
            +2674427512746540*r**20+3463143819687342*r**22+445897411848696*r**24+3308493747176322*r**26
            +2351290862561340*r**28-2438122224179030*r**30+2714669845818012*r**32
            +263669951890011*r**34+164367483998462*r**36+35215958237535*r**38+3565307886900*r**40
            +357346946037*r**42-12096300834*r**44-1361341143*r**46+39284380*r**48)
            +27*Q2*(13457491-288595748*r**2-6701491498*r**4+45922407872*r**6+1218334982772*r**8
            +14822832127632*r**10+67585891051042*r**12+275309280418592*r**14+848650919931087*r**16
            -2301578560828788*r**18+5715486524520412*r**20+1789157585874112*r**22
            -4768062657532288*r**24-4533117044770368*r**26+2041231724113732*r**28
            +5559524318717312*r**30-2387170370753983*r**32+841269271682292*r**34+263936145922862*r**36
            +67156691965312*r**38+14809768955532*r**40+1202507083952*r**42+51883785402*r**44
            -6505863328*r**46-317042403*r**48+13880996*r**50))*sqrtq2)+logq2*(384*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7
            +2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(1263344*Q2**25-2*Q2**24*(11138417+11210561*r**2)+8*Q2**23*(20325625
            +47448835*r**2+20553226*r**4)-4*Q2**22*(161190584+634745075*r**2+637428132*r**4
            +163705913*r**6)+2*Q2**21*(729058379+4345929959*r**2+6682574491*r**4
            +4383578909*r**6+744577454*r**8)-2*Q2**20*(776127094+7359917023*r**2
            +11120116760*r**4+11227671450*r**6+7492387888*r**8+803297461*r**10)-Q2**19*(735241019
            -2471770643*r**2+57903438180*r**4+135859103090*r**6+56823326495*r**8
            -3038497011*r**10+696879662*r**12)+2*Q2**18*(2258881085+20248150550*r**2
            +173445242904*r**4+506460027335*r**6+505367524925*r**8+172084805580*r**10
            +19899407390*r**12+2282462759*r**14)-Q2**17*(4761709961+78431072165*r**2
            +680588398973*r**4+2729648668127*r**6+4096766028245*r**8+2722617453191*r**10
            +677657565695*r**12+78304983533*r**14+4901462942*r**16)+Q2**16*(-1483001562
            +46509160778*r**2+487696279452*r**4+3268838710148*r**6+6351046485608*r**8
            +6344114032968*r**10+3263473234268*r**12+490924760372*r**14+47806839018*r**16
            -1369022682*r**18)+4*Q2**15*(1960775733+11670279531*r**2+111834475375*r**4
            +79085895950*r**6+755665078721*r**8+1762256929042*r**10+753623396051*r**12
            +73189449470*r**14+108001660870*r**16+11068009071*r**18+1970765562*r**20)
            -4*Q2**14*(1330129266+24264911718*r**2+314924288815*r**4+1652291331045*r**6
            +7002210824575*r**8+16762303747529*r**10+16749246485277*r**12+6976294520875*r**14
            +1631847531095*r**16+310324060985*r**18+23940675276*r**20+1368412008*r**22)
            +4*Q2**13*(-875598940+11462516580*r**2+239617478307*r**4+2260828198910*r**6
            +11072995821200*r**8+35638001037240*r**10+51835534183250*r**12+35560950072968*r**14
            +11008587915840*r**16+2231995350500*r**18+240109878955*r**20+11918274570*r**22
            -851702788*r**24)+4*Q2**12*(1752056006+8731429655*r**2+28473604453*r**4
            -1051341488233*r**6-5197580270020*r**8-27810292254581*r**10-54660770821090*r**12
            -54547823373238*r**14-27649520663642*r**16-5138202044515*r**18-1039988103859*r**20
            +21082831615*r**22+7856616248*r**24+1761972497*r**26)-2*Q2**11*(941203181
            +28396222571*r**2+397155980374*r**4+1474878253326*r**6+13169465450501*r**8
            +32820672194389*r**10+85896583856934*r**12+137214623201876*r**14+86385130224919*r**16
            +32998284982989*r**18+13102086451106*r**20+1414817276206*r**22+382521716679*r**24
            +27698145731*r**26+984547826*r**28)+4*Q2**10*(-844513777+6347409526*r**2
            +160644353205*r**4+1466290725800*r**6+11104593906596*r**8+50545350847953*r**10
            +163855271827064*r**12+332624131068125*r**14+332850568298355*r**16+163961846430764*r**18
            +50312643502625*r**20+10988511261366*r**22+1410619113770*r**24+160953135965*r**26
            +6792819426*r**28-836001163*r**30)+2*Q2**9*(1396027573+3673454089*r**2
            -52336326345*r**4-2049648015185*r**6-11148709541945*r**8-71235079451803*r**10
            -265955912594609*r**12-739931074425365*r**14-1061646340455415*r**16-740464072483085*r**18
            -265352895608843*r**20-70111103253019*r**22-11048692515155*r**24-1995139249985*r**26
            -64787329755*r**28+2615436193*r**30+1404022894*r**32)+2*Q2**8*(138530005
            -8990149955*r**2-141905792306*r**4+625851344230*r**6+146593697500*r**8
            +8235282188060*r**10-24606009175110*r**12+76714975400146*r**14+283930962047450*r**16
            +283602492460650*r**18+76187229728290*r**20-25850384238550*r**22+7117558207716*r**24
            +290519391460*r**26+685368515350*r**28-132422171810*r**30-8923893935*r**32
            +129850009*r**34)+4*Q2**7*(-314182049+2852187145*r**2+74909934633*r**4
            +158269598182*r**6+600529657105*r**8+3746206868604*r**10+69084453076535*r**12
            +155299503668042*r**14+284848101938763*r**16+384106730821570*r**18+285088230957749*r**20
            +155960883392730*r**22+69852015187307*r**24+3889024654148*r**26+543578998845*r**28
            +109882722166*r**30+74879518810*r**32+3103860213*r**34-313695698*r**36)
            +4*Q2**6*(102629782-43980743*r**2-19023258697*r**4-384658538978*r**6
            -778806151013*r**8-3061053654207*r**10-39684347923417*r**12-36513988849483*r**14
            -145088887760777*r**16-232171826352437*r**18-231915930474347*r**20-141531329735927*r**22
            -35000159257063*r**24-40617671149357*r**26-2687719944267*r**28-814234208153*r**30
            -368865790913*r**32-21196215832*r**34-171029288*r**36+103357117*r**38)
            +2*Q2**5*(105322601-2454680323*r**2-42267791405*r**4+716494357275*r**6
            +3733884099542*r**8+22166481059540*r**10+90893612744908*r**12+76231109120740*r**14
            +316267401541910*r**16-176343348975722*r**18-136708549788454*r**20-185723119583982*r**22
            +293886553100400*r**24+63937472973220*r**26+92543183196508*r**28+21218558897924*r**30
            +3811479587897*r**32+747852907765*r**34-39402888405*r**36-2530066453*r**38
            +104896514*r**40)-2*Q2**4*(85027302-1433208649*r**2-35751161190*r**4
            +258002301180*r**6+2948886274720*r**8+25097152439457*r**10+98793607078056*r**12
            +296725291982560*r**14+680908386363420*r**16-111013474787250*r**18+355122959382972*r**20
            +325540167700296*r**22-147290630736000*r**24+655177976797370*r**26+282984801526440*r**28
            +98843243360352*r**30+24845099280686*r**32+2926772287755*r**34+287991997530*r**36
            -35364854660*r**38-1532240208*r**40+85107861*r**42)+3*Q2**3*(4244735
            +27619145*r**2-2209531744*r**4-86306109590*r**6+105951504075*r**8+3523184537045*r**10
            +8535546625030*r**12+128697121032856*r**14+30097078598830*r**16-66719762434350*r**18
            +71925236755960*r**20+364258176586940*r**22+51251918761406*r**24-88968799744590*r**26
            +22669002056500*r**28+127799595481880*r**30+7568403182675*r**32+3713724280421*r**34
            +85015252600*r**36-83860603350*r**38-2561796745*r**40+19566585*r**42
            +4213686*r**44)+18*(-1+r**2)**2*(59601-2108175*r**2-59968131*r**4+1087495113*r**6
            +10037215325*r**8+135212262321*r**10+640277434185*r**12+1642970835329*r**14
            +10197117215858*r**16-41148155435550*r**18+128287282692106*r**20-95087183175630*r**22
            -90769233898926*r**24+128527116983498*r**26-42526298861750*r**28+10333008465546*r**30
            +1512909025405*r**32+639159725389*r**34+135016327353*r**36+9786810725*r**38
            +1144614801*r**40-58747035*r**42-2227411*r**44+60053*r**46)+6*Q2**2*(3871599
            -121036310*r**2-2393540078*r**4+59355300643*r**6+301103125505*r**8+2545265166454*r**10
            +13795126312490*r**12-1543472327143*r**14+192735299234718*r**16-275650930569460*r**18
            +203220819867324*r**20+115657975591270*r**22+114584856440202*r**24+186113071410868*r**26
            -279393678589220*r**28+194641248925594*r**30-4386506447645*r**32+14193282493962*r**34
            +2470467915538*r**36+298546903175*r**38+61400849029*r**40-2268517930*r**42
            -126681318*r**44+3900733*r**46)-9*Q2*(998593-32904227*r**2-762000303*r**4
            +16131531503*r**6+100799153593*r**8+1181186779443*r**10+5206822966023*r**12
            +5159320205257*r**14+82552124303808*r**16-297521054200142*r**18+614388762917338*r**20
            -158813389704282*r**22-415682078200878*r**24-134879150769642*r**26+608698754066718*r**28
            -304926098805502*r**30+84453328289153*r**32+3836715425697*r**34+5271719523973*r**36
            +1172063485243*r**38+97834193253*r**40+16836264583*r**42-737474773*r**44
            -34650267*r**46+1005838*r**48))-384*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**5*(10106752*Q2**30-32*Q2**29*(6161401+6197473*r**2)+2*Q2**28*(817496255
            +1863704142*r**2+825861647*r**4)-8*Q2**27*(948067531+3604572572*r**2
            +3619007391*r**4+961542862*r**6)+4*Q2**26*(5278400191+30069269722*r**2
            +47575923905*r**4+30306495280*r**6+5377845706*r**8)-2*Q2**25*(16333762453
            +140382480330*r**2+278723867178*r**4+280254774748*r**6+142344883737*r**8
            +16774807474*r**10)+2*Q2**24*(5510545905+138548053015*r**2+123060524566*r**4
            -86753674862*r**6+131711300283*r**8+143531124555*r**10+6021456690*r**12)
            +Q2**23*(61264065225+332117698380*r**2+3457264904947*r**4+10907448766650*r**6
            +10870603404619*r**8+3406476295096*r**10+316667698305*r**12+61370870730*r**14)
            -2*Q2**22*(59724183555+726592398585*r**2+5851137079744*r**4+22775162202483*r**6
            +34572035562204*r**8+22705570564235*r**10+5811507038412*r**12+721833995505*r**14
            +60893532285*r**16)+Q2**21*(47834876455+1786971691860*r**2+16590387741622*r**4
            +90289182496858*r**6+187083930493216*r**8+186922490708666*r**10+90102705709274*r**12
            +16580970517766*r**14+1804542525225*r**16+51133501330*r**18)+2*Q2**20*(67412115575
            -53610325675*r**2-2180948415664*r**4-35640770198544*r**6-95056184472714*r**8
            -117121633505182*r**10-95059330431000*r**12-35782629709752*r**14-2300901067357*r**16
            -79992223615*r**18+67034439080*r**20)-Q2**19*(205622057045+2359354216260*r**2
            +22650103016653*r**4+76869084185634*r**6+278805629556114*r**8+728732665694504*r**10
            +727731218686602*r**12+276702933391668*r**14+75175236068009*r**16+22156863216164*r**18
            +2307214226745*r**20+208959108410*r**22)+2*Q2**18*(11702643875+1323226314445*r**2
            +18177190505186*r**4+132746244458485*r**6+590162654719267*r**8+1770536865661538*r**10
            +2562388272035204*r**12+1766745630943450*r**14+586596169185905*r**16+131135828349217*r**18
            +18026899118858*r**20+1329956625345*r**22+13732613945*r**24)+Q2**17*(201317887795
            -126350736560*r**2-15557520112068*r**4-275604489449906*r**6-1548188908414593*r**8
            -6206960543151886*r**10-12148439710289616*r**12-12135686972373604*r**14
            -6186476394310063*r**16-1537791366262268*r**18-273216694866540*r**20-16006486964394*r**22
            -217980167555*r**24+201020298490*r**26)-2*Q2**16*(84469388605+1126245401160*r**2
            +9983765679319*r**4-16605346209344*r**6-214330497827733*r**8-1893926184973072*r**10
            -5206194501722535*r**12-6819364878831984*r**14-5188793540500829*r**16
            -1883818331076632*r**18-213400252968663*r**20-17766673522032*r**22+9479083109557*r**24
            +1085284324800*r**26+86050263655*r**28)+2*Q2**15*(-28670805915+990811535500*r**2
            +16099311973011*r**4+118744938157266*r**6+703463312963361*r**8+2365497684851144*r**10
            +6128036618606855*r**12+12460475318859598*r**14+12472023125544983*r**16
            +6134772557870972*r**18+2352943320582257*r**20+694559161543150*r**22+114971047566403*r**24
            +15820510411408*r**26+1001523029205*r**28-27466450350*r**30)+4*Q2**14*(39762764805
            -5695635885*r**2-3331134481552*r**4-68276274049251*r**6-500612090689426*r**8
            -2903103353477977*r**10-10441602166323516*r**12-26230551906164983*r**14
            -36267094693894684*r**16-26219391910444959*r**18-10412709968019832*r**20
            -2877189773284081*r**22-494133380679222*r**24-66659565819451*r**26-3460547120476*r**28
            -28861588245*r**30+39881070015*r**32)+2*Q2**13*(-23990611725-611717563020*r**2
            -5429757228494*r**4+46322585579970*r**6+451767966814842*r**8+4584141318825218*r**10
            +20958201382905258*r**12+70489721094815682*r**14+130824866762937560*r**16
            +130755171209072778*r**18+70339216765883622*r**20+20817519837988838*r**22
            +4518883803210534*r**24+449104382037510*r**26+47425888529342*r**28-4944198669162*r**30
            -588078997995*r**32-24756804870*r**34)-2*Q2**12*(34507474435-470552925480*r**2
            -8615094991831*r**4-40626173661112*r**6-173589246022876*r**8+353342013605416*r**10
            +2567034547424524*r**12+24813469678285832*r**14+70161044327148754*r**16
            +93389156942200616*r**18+69898973141119046*r**20+24560894048603800*r**22
            +2436806040434980*r**24+337670395997720*r**26-162569965112276*r**28-35931329523560*r**30
            -8418708497693*r**32-488817973440*r**34+34258739545*r**36)+2*Q2**11*(27851423255
            -8231521540*r**2-3454829388509*r**4-61687426217706*r**6-338475205921692*r**8
            -2446947769817144*r**10-14889366048429612*r**12-49708973358725648*r**14
            -121509724716401294*r**16-211273649960351920*r**18-211497572683627590*r**20
            -121739757102889556*r**22-49751928775361292*r**24-14883724020917096*r**26
            -2380241161902044*r**28-326819417610432*r**30-58504410945633*r**32-3635372471852*r**34
            -32760983125*r**36+28058457230*r**38)+4*Q2**10*(2108035030-122969970825*r**2
            -1103852116197*r**4+18920360482473*r**6+124704722615523*r**8+1282913365998260*r**10
            +8030132304353100*r**12+37946533787993580*r**14+122663717435165200*r**16
            +268921783858951618*r**18+357015504383300442*r**20+268982915374328750*r**22
            +122421895468938738*r**24+37694772316553508*r**26+7972218668005564*r**28
            +1236590824972188*r**30+123735142220850*r**32+19519907591279*r**34-982566274301*r**36
            -121968325215*r**38+2026482835*r**40)-4*Q2**9*(6365890565-83195239355*r**2
            -1571027664743*r**4+2294156379111*r**6+71299704972566*r**8+808756672495528*r**10
            +3919692480027484*r**12+21760505410105108*r**14+75176108968582514*r**16
            +204477647290118134*r**18+360916507454870774*r**20+360754549238940722*r**22
            +203956235038712548*r**24+74409574998358564*r**26+21320848759236284*r**28
            +3877782328120868*r**30+797701762643729*r**32+73644167765437*r**34+3754284143961*r**36
            -1539043965009*r**38-88469723010*r**40+6370146620*r**42)+2*Q2**8*(2963351975
            +15080477735*r**2-820044929824*r**4-18303791358070*r**6+6723358539277*r**8
            +579139043538383*r**10+2015726292918012*r**12+8839314800408376*r**14-19272289675823450*r**16
            -30616523027580802*r**18+8158002510370992*r**20+43033032997482716*r**22
            +6152579433892250*r**24-33411151267990170*r**26-21234448579027352*r**28
            +8271584977366392*r**30+1997407620976227*r**32+640673150181563*r**34+11769784133840*r**36
            -17226337106198*r**38-892483770967*r**40+10362102635*r**42+3004774460*r**44)
            +Q2**7*(5871460285-153121038180*r**2-1632351988153*r**4+38834906242114*r**6
            +195300949646907*r**8+779778636464952*r**10+1286929068519465*r**12+5014706532701130*r**14
            +141495781939140530*r**16+314561831087881768*r**18+779944314900901206*r**20
            +1146359281562823076*r**22+1148446040392918054*r**24+781878825697732128*r**26
            +318806609236228418*r**28+144518757382977732*r**30+4616428199236353*r**32
            +1319885697742684*r**34+659113530701683*r**36+189231914765082*r**38+40414217667375*r**40
            -1499697868664*r**42-157493793915*r**44+5859897970*r**46)-2*Q2**6*(1676223015
            -30276824995*r**2-644932977056*r**4+4920776553511*r**6+82288972425432*r**8
            +831920179650635*r**10+2880613261634204*r**12+11377910810005913*r**14
            +55021112384924939*r**16+38226132687289106*r**18+215607335358361552*r**20
            +238515203285047350*r**22+253794881897371224*r**24+236046675952061414*r**26
            +207974119246478632*r**28+35212423380058306*r**30+55658853340996093*r**32
            +10789179859854337*r**34+2885334977687536*r**36+829802768360115*r**38
            +82068064386992*r**40+5708324656223*r**42-636447069668*r**44-32408359275*r**46
            +1682964465*r**48)-3*Q2**5*(120400319-7066529100*r**2+21062757966*r**4
            +3660157636266*r**6-9482143087244*r**8-366337504337334*r**10-2352230082868790*r**12
            -14134086767007746*r**14-43420742836693701*r**16-82800173662253038*r**18
            -201390921429212916*r**20-33090033216637020*r**22+35701193352354912*r**24
            +41403379168368772*r**26-21740804388457452*r**28-189653365254634628*r**30
            -77457868176531515*r**32-43128438365649000*r**34-13940865767297530*r**36
            -2328606302601006*r**38-383597053744980*r**40-10717801675950*r**42+3601952359618*r**44
            +32007081318*r**46-7044131135*r**48+119510914*r**50)+6*Q2**4*(121061247
            -3809216169*r**2-44185250978*r**4+1509174309176*r**6+4988357050586*r**8
            -21188708132806*r**10-597241216024588*r**12-5086713211563328*r**14-17186233832388179*r**16
            -73730784221296419*r**18-104428449184631286*r**20-64896784259780528*r**22
            -48148835595416548*r**24-121393801255559044*r**26-38327922283885384*r**28
            -54558572007292576*r**30-98814554939316823*r**32-71793902519760383*r**34
            -16795964711321454*r**36-5119790751007944*r**38-587252867807126*r**40
            -25230183922198*r**42+4479360830612*r**44+1561815961376*r**46-41079489589*r**48
            -3961162453*r**50+121412806*r**52)-9*Q2**3*(14230665-355499724*r**2-10093161447*r**4
            +87794705130*r**6+2131471928974*r**8+30922505805736*r**10+37451738773542*r**12
            -32223451447556*r**14-421102605582205*r**16-19515531203414596*r**18+23349789810563931*r**20
            -51506023366008658*r**22+15156769070591284*r**24-14173592560628240*r**26
            -12747927832324956*r**28+16743068234933416*r**30-48157219822875713*r**32
            +24892993915132204*r**34-19735531981063425*r**36-240489842945946*r**38
            -61289546671394*r**40+36041941141352*r**42+31418288991574*r**44+2100149043740*r**46
            +102243072149*r**48-10080568604*r**50-380593299*r**52+14272066*r**54)
            -54*(-1+r**2)**2*(59601-2882988*r**2-38998764*r**4+2088326808*r**6+2603245091*r**8
            -106216985084*r**10-2318173225764*r**12-22381776799444*r**14-95043787170179*r**16
            -422049214544064*r**18-623704600556024*r**20+1559171926128636*r**22-8396581149294609*r**24
            -1731960452231864*r**26+16650231393971896*r**28-2150255815490184*r**30
            -8335991700665069*r**32+1696224950500756*r**34-606164146939164*r**36-411024259444464*r**38
            -93071906485479*r**40-22449845056524*r**42-2295885002964*r**44-109456914404*r**46
            +1491277791*r**48+2142400920*r**50-36276416*r**52-3008100*r**54+60053*r**56)
            -18*Q2**2*(3275589-153416057*r**2-652399350*r**4+97569201615*r**6-259098222019*r**8
            -10771280685902*r**10-76600236480036*r**12-639638879483286*r**14-2208303016953527*r**16
            -4400366497950099*r**18-27878811226040562*r**20+42770424977401629*r**22
            -66184346335622271*r**24-24987477407113012*r**26+36399588209599336*r**28
            -25966551378807492*r**30-63128223435030801*r**32+44059268400161329*r**34
            -27973095530313402*r**36-4007543118437799*r**38-2210908123101417*r**40
            -637449851256606*r**42-74796290259076*r**44-11117946562502*r**46-302802420669*r**48
            +98129281659*r**50-465396254*r**52-158269221*r**54+3300203*r**56)+27*Q2*(998593
            -46362744*r**2-432856924*r**4+30249146834*r**6-24679141079*r**8-2024221892426*r**10
            -24830216260656*r**12-221032317142356*r**14-735333354769571*r**16-2640605971477396*r**18
            -5669375953848876*r**20+21807771812003414*r**22-61811586617213211*r**24
            +12994014555685794*r**26+24758007514021824*r**28+24265934637658504*r**30
            +10820266494142259*r**32-61190955187625616*r**34+22745452669128204*r**36
            -5683742986246306*r**38-2521494694301141*r**40-721060690192166*r**42-221943592483216*r**44
            -24353932434676*r**46-2078498612881*r**48-39911658404*r**50+30828454268*r**52
            -385519302*r**54-48206585*r**56+1005838*r**58))*sqrtq2))*math.log(r))/(630000*r**4*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2+630000*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**7*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*sqrtq2+logq2**8*(60949905408000000*r**36*(1
            +r**2)**2*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3+60949905408000000*r**36*(1
            +r**2)**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*sqrtq2)+logq2*(-90720000*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**7*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4
            -Q2**3*(1+r**2)-2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4
            +r**6)+4*(1-9*r**2-44*r**4-9*r**6+r**8))-90720000*(-Q2+(-1+r)**2)**3*r**8*(1
            -Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(4*Q2**4-Q2**3*(1+r**2)
            -2*Q2**2*(3+2*r**2+3*r**4)-Q2*(1+19*r**2+19*r**4+r**6)+4*(1-9*r**2
            -44*r**4-9*r**6+r**8))*sqrtq2)+logq2**7*(-1354442342400000*r**32*(1+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**4*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))-1354442342400000*r**32*(1+r**2)*(1-Q2+r**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(4*Q2**4+19*Q2**3*(1+r**2)-2*Q2**2*(13
            +22*r**2+13*r**4)-3*Q2*(7+13*r**2+13*r**4+7*r**6)+12*(2-13*r**2
            -38*r**4-13*r**6+2*r**8))*sqrtq2)+logq2**3*(-21772800000*(-Q2+(-1+r)**2)**3*r**16*(
            -Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)
            -Q2**6*(333+410*r**2+333*r**4)-Q2**5*(169+683*r**2+683*r**4+169*r**6)
            +2*Q2**4*(275-725*r**2-3408*r**4-725*r**6+275*r**8)+6*Q2**3*(31+230*r**2
            +159*r**4+159*r**6+230*r**8+31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4
            +8368*r**6+6523*r**8+1184*r**10-131*r**12)-9*Q2*(13+5*r**2-1493*r**4
            -5245*r**6-5245*r**8-1493*r**10+5*r**12+13*r**14)+36*(4-67*r**2-28*r**4
            +2331*r**6+5600*r**8+2331*r**10-28*r**12-67*r**14+4*r**16))-21772800000*(
            -Q2+(-1+r)**2)**3*r**16*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**3*(64*Q2**8+68*Q2**7*(1+r**2)-Q2**6*(333+410*r**2+333*r**4)
            -Q2**5*(169+683*r**2+683*r**4+169*r**6)+2*Q2**4*(275-725*r**2-3408*r**4
            -725*r**6+275*r**8)+6*Q2**3*(31+230*r**2+159*r**4+159*r**6+230*r**8
            +31*r**10)+3*Q2**2*(-131+1184*r**2+6523*r**4+8368*r**6+6523*r**8+1184*r**10
            -131*r**12)-9*Q2*(13+5*r**2-1493*r**4-5245*r**6-5245*r**8-1493*r**10
            +5*r**12+13*r**14)+36*(4-67*r**2-28*r**4+2331*r**6+5600*r**8+2331*r**10
            -28*r**12-67*r**14+4*r**16))*sqrtq2)+logq2**2*(5443200000*(-Q2+(-1
            +r)**2)**3*r**12*(1-Q2+r**2)*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8
            -4*Q2**7*(1+r**2)-Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4
            +5*r**6)+Q2**4*(85-226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1
            -54*r**2-143*r**4-143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4
            +3168*r**6+2871*r**8+468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4
            -2833*r**6-2833*r**8-565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4
            +4368*r**6+11718*r**8+4368*r**10-56*r**12-96*r**14+5*r**16))+5443200000*(
            -Q2+(-1+r)**2)**3*r**12*(-Q2+(1+r)**2)**3*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*(16*Q2**8
            -4*Q2**7*(1+r**2)-Q2**6*(57+50*r**2+57*r**4)+Q2**5*(5-113*r**2-113*r**4
            +5*r**6)+Q2**4*(85-226*r**2-1326*r**4-226*r**6+85*r**8)-6*Q2**3*(1
            -54*r**2-143*r**4-143*r**6-54*r**8+r**10)+Q2**2*(-51+468*r**2+2871*r**4
            +3168*r**6+2871*r**8+468*r**10-51*r**12)-3*Q2*(1+37*r**2-565*r**4
            -2833*r**6-2833*r**8-565*r**10+37*r**12+r**14)+3*(5-96*r**2-56*r**4
            +4368*r**6+11718*r**8+4368*r**10-56*r**12-96*r**14+5*r**16))*sqrtq2)
            +logq2**5*(-1881169920000*r**24*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(32*Q2**8+244*Q2**7*(1
            +r**2)-Q2**6*(219+310*r**2+219*r**4)-Q2**5*(977+2179*r**2+2179*r**4
            +977*r**6)+Q2**4*(590-2090*r**2-6768*r**4-2090*r**6+590*r**8)+6*Q2**3*(243
            +10*r**2-2073*r**4-2073*r**6+10*r**8+243*r**10)+Q2**2*(-879+8076*r**2
            +41127*r**4+61272*r**6+41127*r**8+8076*r**10-879*r**12)+Q2*(-741+3075*r**2
            +31341*r**4+67125*r**6+67125*r**8+31341*r**10+3075*r**12-741*r**14)
            +12*(41-573*r**2+28*r**4+12789*r**6+25830*r**8+12789*r**10+28*r**12
            -573*r**14+41*r**16))-1881169920000*r**24*(1-Q2+r**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(32*Q2**8+244*Q2**7*(1+r**2)-Q2**6*(219+310*r**2+219*r**4)-Q2**5*(977
            +2179*r**2+2179*r**4+977*r**6)+Q2**4*(590-2090*r**2-6768*r**4-2090*r**6
            +590*r**8)+6*Q2**3*(243+10*r**2-2073*r**4-2073*r**6+10*r**8+243*r**10)
            +Q2**2*(-879+8076*r**2+41127*r**4+61272*r**6+41127*r**8+8076*r**10
            -879*r**12)+Q2*(-741+3075*r**2+31341*r**4+67125*r**6+67125*r**8+31341*r**10
            +3075*r**12-741*r**14)+12*(41-573*r**2+28*r**4+12789*r**6+25830*r**8
            +12789*r**10+28*r**12-573*r**14+41*r**16))*sqrtq2)+logq2**4*(391910400000*r**20*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219
            +310*r**2+219*r**4)-24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415
            -1180*r**2-4598*r**4-1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4
            -677*r**6+155*r**8+102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6
            +18377*r**8+3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6
            -3030*r**8-1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4
            +24556*r**6+53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))+391910400000*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**5*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(32*Q2**8+104*Q2**7*(1+r**2)-Q2**6*(219+310*r**2
            +219*r**4)-24*Q2**5*(13+31*r**2+31*r**4+13*r**6)+Q2**4*(415-1180*r**2
            -4598*r**4-1180*r**6+415*r**8)+4*Q2**3*(102+155*r**2-677*r**4-677*r**6
            +155*r**8+102*r**10)+Q2**2*(-389+3526*r**2+18377*r**4+25852*r**6+18377*r**8
            +3526*r**10-389*r**12)-12*Q2*(18-55*r**2-1133*r**4-3030*r**6-3030*r**8
            -1133*r**10-55*r**12+18*r**14)+3*(59-892*r**2-168*r**4+24556*r**6
            +53690*r**8+24556*r**10-168*r**12-892*r**14+59*r**16))*sqrtq2)+logq2**6*(7524679680000*r**28*(1
            -Q2+r**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**4*(16*Q2**8+332*Q2**7*(1
            +r**2)+Q2**6*(153+370*r**2+153*r**4)-Q2**5*(2011+4817*r**2+4817*r**4
            +2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4-2410*r**6+295*r**8)+6*Q2**3*(559
            -310*r**2-4869*r**4-4869*r**6-310*r**8+559*r**10)-3*Q2**2*(479-4496*r**2
            -22867*r**4-35272*r**6-22867*r**8-4496*r**10+479*r**12)-9*Q2*(187
            -865*r**2-5807*r**4-10315*r**6-10315*r**8-5807*r**10-865*r**12+187*r**14)
            +9*(109-1432*r**2+392*r**4+26376*r**6+49910*r**8+26376*r**10+392*r**12
            -1432*r**14+109*r**16))+7524679680000*r**28*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**4*(16*Q2**8+332*Q2**7*(1+r**2)+Q2**6*(153+370*r**2+153*r**4)
            -Q2**5*(2011+4817*r**2+4817*r**4+2011*r**6)+Q2**4*(295-2410*r**2-6114*r**4
            -2410*r**6+295*r**8)+6*Q2**3*(559-310*r**2-4869*r**4-4869*r**6-310*r**8
            +559*r**10)-3*Q2**2*(479-4496*r**2-22867*r**4-35272*r**6-22867*r**8
            -4496*r**10+479*r**12)-9*Q2*(187-865*r**2-5807*r**4-10315*r**6-10315*r**8
            -5807*r**10-865*r**12+187*r**14)+9*(109-1432*r**2+392*r**4+26376*r**6
            +49910*r**8+26376*r**10+392*r**12-1432*r**14+109*r**16))*sqrtq2)))+(flagPERP*muWC**3*(
            -518400*logq2**4*(-Q2+(-1+r)**2)*r**14*(-Q2+(1+r)**2)*(5664-16995*r**2
            +630*Q2**7*r**2+419633*r**4-943589*r**6-2284593*r**8-1779977*r**10-687613*r**12
            +46329*r**14+75141*r**16-10*Q2**6*(128+525*r**2+909*r**4)+10*Q2**5*(1104
            +1797*r**2+4936*r**4+4005*r**6)-2*Q2**4*(22368+24197*r**2+52141*r**4
            +93661*r**6+47637*r**8)+Q2**3*(42624+152665*r**2+312044*r**4+508466*r**6
            +476524*r**8+134361*r**10)-Q2**2*(-16864+146753*r**2+325069*r**4+597974*r**6
            +769814*r**8+429213*r**10+26289*r**12)-Q2*(30176-111367*r**2+155052*r**4
            +414267*r**6+187464*r**8-20629*r**10+86508*r**12+119529*r**14))-288*logq2**2*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-47216-313607*r**2+254970*Q2**13*r**2
            -6960065*r**4-10221580*r**6-12784132*r**8-1487557843*r**10+2402280539*r**12
            -7723283920*r**14-11173560640*r**16-2644997261*r**18+1856898709*r**20
            +114589468*r**22+83926260*r**24+4035495*r**26+395793*r**28-6*Q2**12*(
            -64+421179*r**2+420987*r**4)+36*Q2**11*(-5508+283160*r**2+599047*r**4
            +272144*r**6)-12*Q2**10*(-69712+1495011*r**2+5975640*r**4+5967460*r**6
            +1381551*r**8)+5*Q2**9*(-188656+1594553*r**2+21011528*r**4+36414114*r**6
            +21675960*r**8+979353*r**10)+15*Q2**8*(-51248+1033987*r**2-1947973*r**4
            -5306490*r**6-6410634*r**8-2596597*r**10+1572243*r**12)-6*Q2**7*(-402912
            +2742642*r**2+18566581*r**4+96604370*r**6+158147170*r**8+83267418*r**10
            +20689877*r**12+5235546*r**14)+2*Q2**6*(-599312-3701090*r**2+61350883*r**4
            +546061231*r**6+1481797900*r**8+1461603568*r**10+477798675*r**12+96968823*r**14
            +2227266*r**16)+6*Q2**5*(-196288+2388144*r**2+622995*r**4-48592540*r**6
            -415624591*r**8-784918728*r**10-459092111*r**12-15299580*r**14-8486125*r**16
            +3195024*r**18)-30*Q2**4*(-49696-26182*r**2+1559423*r**4+20782477*r**6
            +13805527*r**8-86447785*r**10-109950561*r**12-7778681*r**14+34420989*r**16
            +3688675*r**18+486198*r**20)+10*Q2**3*(-29368-681310*r**2-852943*r**4
            +30623766*r**6+152182332*r**8+252337680*r**10+171428918*r**12+89570528*r**14
            +157100372*r**16+67698366*r**18+8592753*r**20+68346*r**22)+6*Q2**2*(
            -59376+216296*r**2+1992743*r**4+19794455*r**6-124428660*r**8-782215248*r**10
            -1372469722*r**12-1307337746*r**14-515836600*r**16-309448960*r**18+29109579*r**20
            +867731*r**22+669108*r**24)-3*Q2*(-79504-369515*r**2-4035114*r**4+24655462*r**6
            +131242510*r**8+27103803*r**10+1285275820*r**12+547672468*r**14+385601916*r**16
            +797139515*r**18-199250274*r**20+97176870*r**22+6750246*r**24+715797*r**26))
            -(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(2457+20598*Q2**19-45183*r**2
            -9537843*r**4-1361707*r**6-508302120*r**8-2472736248*r**10+2418346656*r**12
            -44685301296*r**14-176773390542*r**16+641431807858*r**18-1386894518430*r**20
            +480694330722*r**22-78393450704*r**24+26824149120*r**26+2448339624*r**28
            +229743096*r**30+80981805*r**32+105093*r**34-42871*r**36+513*r**38-90906*Q2**18*(1
            +r**2)+18*Q2**17*(3915+22676*r**2+3915*r**4)+2*Q2**16*(45297-130187*r**2
            -293195*r**4+99633*r**6)-Q2**15*(-374043+2532356*r**2+16013554*r**4
            +1404164*r**6+190053*r**8)+Q2**14*(-1575699+5722769*r**2+118581998*r**4
            +108327950*r**6+7428385*r**8-548259*r**10)+Q2**13*(1309143+5197800*r**2
            -289803763*r**4-703899648*r**6-259405219*r**8-9122712*r**10+723303*r**12)
            +Q2**12*(848145-23607359*r**2+217186539*r**4+1658674843*r**6+1682637059*r**8
            +180760147*r**10-6133879*r**12+555225*r**14)-Q2**11*(1464357+6852340*r**2
            -263818368*r**4+1043289420*r**6+2239240438*r**8+1292301260*r**10-345072640*r**12
            -21666700*r**14+1227813*r**16)+Q2**10*(-92379+75594649*r**2-545390420*r**4
            -2030711324*r**6-5939772334*r**8-4409688750*r**10-1942006108*r**12-787355284*r**14
            -8359943*r**16+52869*r**18)+Q2**9*(761079-54901368*r**2+8405999*r**4
            +3328260800*r**6+17196681610*r**8+33783208816*r**10+13473181482*r**12
            +4620148544*r**14+334795615*r**16-14859320*r**18+838599*r**20)-Q2**8*(302943
            +55395087*r**2-667587161*r**4+552790279*r**6+9367556002*r**8+58549961522*r**10
            +60388875266*r**12+5987434674*r**14+2279954879*r**16-627351553*r**18
            -13053417*r**20+304263*r**22)+Q2**7*(164625+83435284*r**2-357177978*r**4
            -1031986876*r**6-11504040193*r**8+11007717736*r**10+44054626836*r**12
            +23685986152*r**14-15011687681*r**16-2227296188*r**18-772942714*r**20
            +1117204*r**22-234735*r**24)+Q2**6*(-3993-4952653*r**2-425024946*r**4
            +189595902*r**6+14963029781*r**8+72554989489*r**10+163778624500*r**12
            +111184896564*r**14+73038754721*r**16+19808660261*r**18+3466991518*r**20
            +16183982*r**22-4979005*r**24+143703*r**26)-Q2**5*(265371+41204360*r**2
            -423584067*r**4+470868480*r**6-2617382457*r**8+50473954232*r**10+204193468097*r**12
            +402011659392*r**14+113278270801*r**16+91626683320*r**18-966270761*r**20
            +1445372416*r**22-418602995*r**24-2916728*r**26+9579*r**28)+Q2**4*(144147
            +19704099*r**2+71114853*r**4+668784725*r**6-10439588745*r**8-20412475097*r**10
            -43641283583*r**12+274326633809*r**14+413348569065*r**16-113130954535*r**18
            +5166088703*r**20-16463343601*r**22-797839667*r**24-184153315*r**26-1046565*r**28
            +2187*r**30)+Q2**3*(59331+3780068*r**2-187120948*r**4+106587852*r**6
            -898711604*r**8+7826818564*r**10+82615201460*r**12+63357385036*r**14
            -135166400414*r**16-162882978612*r**18+127428812084*r**20+40784866436*r**22
            +6990763212*r**24+1188843852*r**26-53628084*r**28-608924*r**30+7491*r**32)
            -Q2**2*(51615+5315843*r**2-34073144*r**4+330955792*r**6-4363126984*r**8
            +489276848*r**10+21610588352*r**12+225146943208*r**14+564114653366*r**16
            +149519559158*r**18+365153425704*r**20-11342048768*r**22+23140560496*r**24
            -4158772488*r**26+262998096*r**28-50996472*r**30-757757*r**32+10335*r**34)
            +Q2*(2631+1314992*r**2+26233243*r**4+106836352*r**6-17543568*r**8+4086157376*r**10
            -35990284952*r**12-67996295936*r**14-136701978890*r**16+327283019616*r**18
            -785879444330*r**20+319806881408*r**22-70286638552*r**24+2322999744*r**26
            -2890964048*r**28-204074752*r**30-8508373*r**32-113680*r**34+1719*r**36))
            +217728000*logq2**5*r**18*(-200+145*r**2+1012*r**4+882*r**6+540*r**8
            +81*r**10)*sqrtq2-17280*logq2**3*r**10*(24780*Q2**12*r**2-120*Q2**11*(32
            +2595*r**2+2691*r**4)+48*Q2**10*(909+36018*r**2+72524*r**4+37836*r**6)
            -80*Q2**9*(1281+68007*r**2+197359*r**4+201712*r**6+68691*r**8)+15*Q2**8*(
            -680+624931*r**2+2462364*r**4+3745126*r**6+2535556*r**8+587315*r**10)
            -20*Q2**7*(-12372+374781*r**2+2087017*r**4+4491606*r**6+4643586*r**8
            +2224229*r**10+244737*r**12)-160*Q2**6*(525+3486*r**2-68041*r**4-351694*r**6
            -525883*r**8-395348*r**10-101234*r**12+40866*r**14)+12*Q2**5*(-35812
            +507101*r**2+2009893*r**4+2227767*r**6+2201295*r**8+2585523*r**10+1577451*r**12
            +1454313*r**14+1081717*r**16)-10*Q2**4*(-47928+413829*r**2+2446028*r**4
            +8618742*r**6+19286412*r**8+26520762*r**10+20182860*r**12+7494918*r**14
            +2451844*r**16+687357*r**18)-20*Q2**3*(1140+13317*r**2-205727*r**4-3980144*r**6
            -7310360*r**8-13084066*r**10-15182986*r**12-8777840*r**14-2018428*r**16
            -792403*r**18+103545*r**20)+120*Q2**2*(-1862+13607*r**2+37312*r**4-393040*r**6
            +615680*r**8+550445*r**10-66496*r**12-280035*r**14+74686*r**16+337296*r**18
            -60536*r**20+33943*r**22)+(-1+r**2)**2*(-22488+30273*r**2+213966*r**4
            -6059043*r**6+20618248*r**8-84888030*r**10-155288556*r**12-91460606*r**14
            -8633472*r**16+14613837*r**18+649678*r**20+266193*r**22)-20*Q2*(-6432
            +35547*r**2+91627*r**4-1218573*r**6+4151043*r**8-8275806*r**10-26134830*r**12
            -22617534*r**14-9896238*r**16-675309*r**18+2545107*r**20-79333*r**22
            +88731*r**24))*sqrtq2+12*logq2*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -2712+287439*r**2-238104*Q2**16*r**2+4900184*r**4+10162132*r**6+497223864*r**8
            -388793812*r**10+4903653544*r**12+41543999724*r**14-90886900584*r**16
            +195164676522*r**18+131529237480*r**20-58690729940*r**22+3872425160*r**24
            -4173200148*r**26-165013736*r**28-48408556*r**30-2352768*r**32+36207*r**34
            +16*Q2**15*(-4352+151701*r**2+138645*r**4)-16*Q2**14*(-25686+517545*r**2
            +1283702*r**4+466173*r**6)+32*Q2**13*(-25797+332281*r**2+2114081*r**4
            +2060996*r**6+306981*r**8)+Q2**12*(202856+1708351*r**2-85903156*r**4
            -156555506*r**6-87507260*r**8+2814687*r**10)-4*Q2**11*(-422464+3694859*r**2
            +6484463*r**4+45325634*r**6+33362354*r**8+5843407*r**10+5880699*r**12)
            +2*Q2**10*(-1174024+549571*r**2+85334662*r**4+639309361*r**6+1198799972*r**8
            +551615169*r**10+110882710*r**12+11183571*r**14)+4*Q2**9*(-6088+5556545*r**2
            -22252209*r**4-410919631*r**6-1613997185*r**8-1575770833*r**10-359844895*r**12
            -55137889*r**14+1688409*r**16)-Q2**8*(-2538008+13910839*r**2+102818064*r**4
            +54873344*r**6-5713077616*r**8-11571455758*r**10-6174435776*r**12+313981504*r**14
            +61814104*r**16+27276759*r**18)+8*Q2**7*(-224864-1718169*r**2+3960199*r**4
            +192721124*r**6+431493580*r**8+688585378*r**10+284038266*r**12+335685764*r**14
            +286466684*r**16+30896815*r**18+1861047*r**20)+4*Q2**6*(-144128+4646441*r**2
            +34104206*r**4-184985647*r**6-2463547672*r**8-9829372794*r**10-15030106684*r**12
            -7774343194*r**14-3006567672*r**16-418407567*r**18-29882146*r**20+1917801*r**22)
            -8*Q2**5*(-157924+225359*r**2+5353541*r**4+73320413*r**6-346886749*r**8
            -3215115490*r**10-11369824342*r**12-11127769486*r**14-2332004022*r**16
            -931884349*r**18+74252225*r**20+6546721*r**22+1523943*r**24)+Q2**4*(
            -379624-8053535*r**2-104498132*r**4+562203742*r**6+3902777140*r**8+15754990063*r**10
            -21767453480*r**12-101722298076*r**14-45148837984*r**16+24545508815*r**18
            +4260298556*r**20+1508646750*r**22+69858388*r**24+3208257*r**26)+4*Q2**3*(
            -53376+1149193*r**2+15158493*r**4+23832418*r**6-53435502*r**8-3272701413*r**10
            -8224444801*r**12-4639433876*r**14+7543003244*r**16-3659209521*r**18
            -6213214101*r**20-1402511342*r**22-142526622*r**24-5563667*r**26+558873*r**28)
            +2*Q2**2*(77528+164963*r**2+10249582*r**4-102552843*r**6-539164740*r**8
            +329288495*r**10+16689289154*r**12+61834524761*r**14+75216986816*r**16
            +30390588585*r**18+31671019986*r**20-269147777*r**22+361278572*r**24
            -151529083*r**26-2091330*r**28-755469*r**30)+4*Q2*(-5336-270731*r**2
            -5784093*r**4+5361281*r**6-173740249*r**8+949921405*r**10+3432897851*r**12
            +4839043361*r**14+8277673463*r**16+4466252503*r**18+21138736753*r**20
            -8336448469*r**22+2365991757*r**24+166280631*r**26+67419121*r**28+1825203*r**30
            +45549*r**32))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(-35271936000*logq2**5*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-816480000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            -1701000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5+70543872000*logq2**6*r**24*sqrtq2
            +7348320000*logq2**4*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+51030000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2+23625*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*sqrtq2)
            +((10450944000*logq2**5*(-Q2+(-1+r)**2)*(-1+r)*r**22*(1+r)*(1+r**2)*(3
            -2*r+3*r**2)*(3+2*r+3*r**2)*(-Q2+(1+r)**2)+276480*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-2790*Q2**10+30*Q2**9*(916+799*r**2)
            -6*Q2**8*(20009+34580*r**2+14951*r**4)+12*Q2**7*(20071+58106*r**2+50519*r**4
            +13809*r**6)-Q2**6*(155967+987070*r**2+1336840*r**4+734730*r**6+124033*r**8)
            +2*Q2**5*(-89733+164654*r**2+310402*r**4+279578*r**6+133871*r**8+11648*r**10)
            +Q2**4*(338415+762300*r**2+2463671*r**4+2792480*r**6+809229*r**8-35860*r**10
            -50715*r**12)+8*Q2**3*(-14997-121975*r**2-542031*r**4-995683*r**6-669907*r**8
            -143004*r**10+16705*r**12+7592*r**14)+Q2**2*(-96507+266978*r**2+814578*r**4
            +4957738*r**6+5433840*r**8+1626502*r**10+85382*r**12-129458*r**14+44147*r**16)
            -6*Q2*(-14577-30555*r**2-377496*r**4+91380*r**6+420598*r**8-39098*r**10
            -172720*r**12+107396*r**14+3395*r**16+11677*r**18)+3*(-6483-30936*r**2
            -487021*r**4-578096*r**6-1258586*r**8+1258586*r**12+578096*r**14+487021*r**16
            +30936*r**18+6483*r**20))-192*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(13396*Q2**16-4*Q2**15*(24446+25937*r**2)+16*Q2**14*(17554+48961*r**2
            +19669*r**4)-4*Q2**13*(83784+595299*r**2+601850*r**4+135189*r**6)+Q2**12*(
            -97551+2373390*r**2+2125528*r**4+2895634*r**6+691239*r**8)+Q2**11*(780156
            +4047924*r**2+26585224*r**4+25079128*r**6+969628*r**8-676044*r**10)
            +2*Q2**10*(-390367-6241380*r**2-44235371*r**4-86365960*r**6-38186349*r**8
            -2282588*r**10+83999*r**12)+4*Q2**9*(-44207+2032777*r**2+22064273*r**4
            +97362585*r**6+88857835*r**8+19747103*r**10+194427*r**12+164623*r**14)
            +Q2**8*(949447+7852222*r**2+49328130*r**4-289515018*r**6-453398040*r**8
            -247599798*r**10-24292098*r**12+1326210*r**14-863663*r**16)+4*Q2**7*(
            -143712-3420495*r**2-44672284*r**4-91616132*r**6-216326232*r**8-221332482*r**10
            -51790940*r**12-2603604*r**14+1217648*r**16+61593*r**18)+4*Q2**6*(-63825
            +897468*r**2+27692333*r**4+216217896*r**6+650437426*r**8+1078346424*r**10
            +544609798*r**12+83048728*r**14+3814991*r**16-1336324*r**18+89325*r**20)
            -4*Q2**5*(-112530-1290951*r**2-14790176*r**4+97752675*r**6+272860776*r**8
            +1330364570*r**10+1141107524*r**12+240470534*r**14-18331110*r**16+5201341*r**18
            +410284*r**20+107463*r**22)+Q2**4*(-120161-4224534*r**2-105966596*r**4
            -388728690*r**6-2291668365*r**8+949333892*r**10+2182681648*r**12+759184572*r**14
            +175020005*r**16-66609390*r**18+28919124*r**20+3066166*r**22+161929*r**24)
            +4*Q2**3*(-20609+137731*r**2+7824130*r**4+106831006*r**6+586231785*r**8
            +991962773*r**10+1797687228*r**12+1830867940*r**14+388095473*r**16-120690835*r**18
            -50579454*r**20-4350914*r**22-90265*r**24+14011*r**26)-2*Q2**2*(-27137
            -366020*r**2-10321129*r**4+18063928*r**6-58655357*r**8+1894507724*r**10
            +2679308355*r**12+4186639248*r**14+1050722109*r**16-423577036*r**18+55085813*r**20
            -34076360*r**22+4770881*r**24+193988*r**26+34993*r**28)+12*Q2*(-521
            -36383*r**2-1349013*r**4-7410651*r**6-72566761*r**8+104709641*r**10
            -472074109*r**12+277425941*r**14+208048717*r**16+75896747*r**18-158855399*r**20
            +39783367*r**22+5260197*r**24+1150059*r**26+16889*r**28+1279*r**30)
            +3*(-409+28718*r**2+1080846*r**4+8142190*r**6+99862834*r**8+90533430*r**10
            +1890398678*r**12-1596202762*r**14+1596202762*r**18-1890398678*r**20
            -90533430*r**22-99862834*r**24-8142190*r**26-1080846*r**28-28718*r**30
            +409*r**32))-8294400*logq2**4*r**18*(140*Q2**9-20*Q2**8*(115+88*r**2)+40*Q2**7*(327
            +497*r**2+177*r**4)-2*Q2**6*(20496+43025*r**2+30370*r**4+6489*r**6)
            +4*Q2**5*(17913+48218*r**2+49630*r**4+23112*r**6+3297*r**8)-Q2**4*(58380
            +202411*r**2+279480*r**4+208630*r**6+78604*r**8+9975*r**10)-6*(-1
            +r**2)**3*(1208+3931*r**2+15964*r**4+24994*r**6+15964*r**8+3931*r**10
            +1208*r**12)+Q2**3*(-3920+68069*r**2+133929*r**4+122710*r**6+71206*r**8
            +26781*r**10+14665*r**12)+Q2**2*(45080+24739*r**2+44732*r**4+41359*r**6
            -46224*r**8-62687*r**10-21204*r**12-25795*r**14)+3*Q2*(-10536-5727*r**2
            -54817*r**4-96971*r**6-2485*r**8+93051*r**10+61397*r**12+8527*r**14
            +7561*r**16))*sqrtq2-13824*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(6870*Q2**13-2*Q2**12*(34631+31164*r**2)+Q2**11*(249264+510790*r**2
            +211346*r**4)-4*Q2**10*(93913+388761*r**2+352219*r**4+79597*r**6)+10*Q2**9*(5794
            +206525*r**2+305769*r**4+171071*r**6+19877*r**8)-5*Q2**8*(-111184+4643*r**2
            -283184*r**4-240546*r**6+74776*r**8+13023*r**10)+Q2**7*(-645496-3731799*r**2
            -17589295*r**4-28609730*r**6-14185890*r**8-1416631*r**10+101561*r**12)
            +Q2**6*(35872+4340595*r**2+24714408*r**4+67930275*r**6+59340080*r**8
            +17555457*r**10+1043560*r**12-9607*r**14)-Q2**5*(-426374+223867*r**2
            -716287*r**4+50953039*r**6+74129665*r**8+36010801*r**10+4277667*r**12
            -556987*r**14+202209*r**16)+5*Q2**4*(-57998-595035*r**2-5650538*r**4
            -4814218*r**6-4863054*r**8-2331956*r**10+152498*r**12+547362*r**14+9268*r**16
            +34231*r**18)+5*Q2**3*(-968+359313*r**2+3779721*r**4+13154588*r**6+31575660*r**8
            +39631194*r**10+17654826*r**12+580852*r**14-1292436*r**16-208859*r**18
            +1309*r**20)-Q2**2*(-86708-257077*r**2-4521320*r**4+33274825*r**6+69220640*r**8
            +178203426*r**10+112172344*r**12+11869670*r**14-11666700*r**16+1963635*r**18
            -141168*r**20+64433*r**22)+3*Q2*(-13312-175545*r**2-2851043*r**4-491835*r**6
            -25448985*r**8+14239594*r**10+19145070*r**12-6700594*r**14+3582810*r**16
            -3410865*r**18+1970293*r**20+143725*r**22+10687*r**24)-2*(-3114-63893*r**2
            -1134207*r**4-3114961*r**6-34594375*r**8-8682972*r**10-10143314*r**12
            +10143314*r**14+8682972*r**16+34594375*r**18+3114961*r**20+1134207*r**22
            +63893*r**24+3114*r**26))*sqrtq2-16*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1776*Q2**18-3468*Q2**17*(1+r**2)-6*Q2**16*(-1795-6550*r**2
            +2733*r**4)+4*Q2**15*(-20851-209509*r**2-46767*r**4+14405*r**6)+Q2**14*(211015
            +4356704*r**2+4549270*r**4+314848*r**6-45845*r**8)-Q2**13*(167133+9528313*r**2
            +25822486*r**4+11190558*r**6+137077*r**8+20673*r**10)+Q2**12*(-76606
            +5679694*r**2+56701204*r**4+54511308*r**6+15791578*r**8+352262*r**10
            -3376*r**12)+2*Q2**11*(77015+7927289*r**2-5673081*r**4+10210061*r**6
            -7082923*r**8-5550301*r**10-698451*r**12+47447*r**14)-Q2**10*(15603
            +32968736*r**2+152150948*r**4+523278936*r**6+509716234*r**8+81226928*r**10
            +696660*r**12-1079272*r**14+51915*r**16)+Q2**9*(-44055+11296537*r**2
            +224148920*r**4+991784624*r**6+2129745570*r**8+938031210*r**10+52926992*r**12
            +7140760*r**14+1034029*r**16-63435*r**18)+2*Q2**8*(24744+14336423*r**2
            -11920579*r**4-127219452*r**6-1625977708*r**8-1394805054*r**10-306353122*r**12
            +20262836*r**14-5681412*r**16-675073*r**18+24909*r**20)+8*Q2**7*(-9573
            -3839233*r**2-26255896*r**4-164488377*r**6+16778018*r**8-83378214*r**10
            -55459992*r**12-18137746*r**14+242363*r**16+2155383*r**18-42040*r**20
            +2907*r**22)+Q2**6*(13105-1566736*r**2+180005438*r**4+1526993696*r**6
            +5468875267*r**8+11317306624*r**10+11321825748*r**12+3073062496*r**14
            +467196311*r**16-63102448*r**18-5727826*r**20+747904*r**22-23819*r**24)
            -Q2**5*(-61493-17574425*r**2-4355610*r**4-43178322*r**6+5191050917*r**8
            +8424304713*r**10+23211331028*r**12+9548742788*r**14-198915307*r**16
            +221615097*r**18-39798138*r**20+13731982*r**22+48315*r**24+2455*r**26)
            +2*Q2**4*(-15855-3771683*r**2-44274320*r**4-539366586*r**6-410911425*r**8
            -5070263425*r**10+9788162226*r**12+4670294020*r**14+1457653247*r**16
            -716619525*r**18+132709500*r**20-1165898*r**22+5572785*r**24-49751*r**26
            +1890*r**28)+2*Q2**3*(-6253-1107579*r**2+24168647*r**4+264488781*r**6
            +1713703359*r**8+6820194833*r**10+1583038483*r**12+12477638121*r**14
            +7058670633*r**16-721654673*r**18-535117467*r**20-150563609*r**22-11666043*r**24
            +586491*r**26-5951*r**28+227*r**30)+Q2**2*(10283+2367888*r**2+2156464*r**4
            +181713208*r**6-1148942972*r**8+269608000*r**10-21925310128*r**12-21919755128*r**14
            -13658835246*r**16+2667949264*r**18-1597710384*r**20+1049031752*r**22
            -107923036*r**24+14773088*r**26-2947792*r**28-9224*r**30-37*r**32)-3*Q2*(135
            +145839*r**2+4082676*r**4+66081356*r**6+121908032*r**8+1760237704*r**10
            -5559059884*r**12+14568260012*r**14-9881973242*r**16-5805684834*r**18
            +5789752572*r**20-1011659964*r**22+14341528*r**24-64526864*r**26-1729348*r**28
            -171836*r**30-3941*r**32+59*r**34)+6*(-81-4463*r**2+658976*r**4+5640224*r**6
            +35588996*r**8+339087356*r**10-293278816*r**12+6023211424*r**14-12400397478*r**16
            +12400397478*r**18-6023211424*r**20+293278816*r**22-339087356*r**24-35588996*r**26
            -5640224*r**28-658976*r**30+4463*r**32+81*r**34))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(
            -31352832000*logq2**6*r**26*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-3265920000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -22680000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**4-10500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**6+362880000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+756000*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2+15676416000*logq2**5*r**22*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC*(209018880000*logq2**5*(-Q2+(-1+r)**2)*r**22*(27
            +70*r**2+68*r**4+42*r**6+9*r**8)*(-Q2+(1+r)**2)-5529600*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1630*Q2**10-10*Q2**9*(1645+1996*r**2)
            +2*Q2**8*(31785+80660*r**2+46959*r**4)-4*Q2**7*(36175+129665*r**2+152426*r**4
            +54961*r**6)+Q2**6*(154455+719250*r**2+1369524*r**4+971590*r**6+186389*r**8)
            +2*Q2**5*(-19390-170325*r**2-700814*r**4-731638*r**6-201108*r**8+81991*r**10)
            +Q2**4*(-16275+439400*r**2+2949625*r**4+3621960*r**6+1295183*r**8-358760*r**10
            -405405*r**12)+8*Q2**3*(-1315-77440*r**2-364041*r**4-660750*r**6-334974*r**8
            +34986*r**10+61240*r**12+21274*r**14)+Q2**2*(-22225-62830*r**2-1140286*r**4
            +820314*r**6-105252*r**8-2510922*r**10-1869482*r**12-459266*r**14+118429*r**16)
            -6*Q2*(-7395-65745*r**2-316436*r**4+902640*r**6+1844286*r**8+1384590*r**10
            +638540*r**12+168456*r**14-31795*r**16+18859*r**18)+3*(-5025-50940*r**2
            -622979*r**4-1951808*r**6-8116502*r**8-10443736*r**10-5599330*r**12
            -795616*r**14+351063*r**16+10932*r**18+7941*r**20))+768*logq2*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-118548*Q2**16+12*Q2**15*(101279+98794*r**2)
            -48*Q2**14*(89565+214963*r**2+86040*r**4)+4*Q2**13*(1642905+8212034*r**2
            +8179279*r**4+1385880*r**6)+Q2**12*(-2360145-45894754*r**2-77423412*r**4
            -43283534*r**6+1583805*r**8)-4*Q2**11*(1515099-1236539*r**2+9405786*r**4
            +11288406*r**6+2611331*r**8+3335349*r**10)+2*Q2**10*(3912783+35136896*r**2
            +210506575*r**4+437994000*r**6+240751685*r**8+54930856*r**10+6284613*r**12)
            +4*Q2**9*(-51165-19639013*r**2-147576285*r**4-539107525*r**6-581631275*r**8
            -159162135*r**10-28830763*r**12+992985*r**14)+Q2**8*(-6270615+9002278*r**2
            +219805578*r**4+2076541950*r**6+3897205500*r**8+2286118050*r**10-148295562*r**12
            -23627782*r**14-15336165*r**16)+4*Q2**7*(1023735+7597252*r**2+44519156*r**4
            +61248732*r**6+381623490*r**8+356592240*r**10+260374692*r**12+254862556*r**14
            +30787967*r**16+2050260*r**18)+4*Q2**6*(321309-5037128*r**2-69264093*r**4
            -554277928*r**6-2608104138*r**8-4824179904*r**10-3137242278*r**12-1220123768*r**14
            -188650803*r**16-16206088*r**18+1087059*r**20)-4*Q2**5*(594369-3063808*r**2
            -39754245*r**4-181895790*r**6-1172793110*r**8-4783011996*r**10-5729297226*r**12
            -1334744320*r**14-762314715*r**16+60203340*r**18+5442367*r**20+1694334*r**22)
            +Q2**4*(367905-2705974*r**2+15472960*r**4+342769950*r**6+54763225*r**8
            -12458255740*r**10-34827589752*r**12-13409002340*r**14+12388205075*r**16
            +1953366450*r**18+689901560*r**20+33747526*r**22+1778355*r**24)+4*Q2**3*(137655
            -2016541*r**2-10057386*r**4+210889570*r**6+1247175625*r**8+4685221725*r**10
            +8567919572*r**12+8733823132*r**14+1665885225*r**16-2287437475*r**18
            -576162730*r**20-70932606*r**22-3156521*r**24+310755*r**26)-2*Q2**2*(111585
            -2456248*r**2-3930219*r**4+163523472*r**6-88637755*r**8+62255520*r**10
            -3857614959*r**12-8362794912*r**14-12000546189*r**16-11528168280*r**18
            +480068095*r**20-97177968*r**22+71529831*r**24+343792*r**26+422235*r**28)
            +12*Q2*(-441+26113*r**2-1383757*r**4-44435747*r**6-242062577*r**8+23429041*r**10
            +802367699*r**12+6770350389*r**14+6423464269*r**16+3542221979*r**18-1294396159*r**20
            +319688063*r**22+18918493*r**24+11111603*r**26+292473*r**28+8559*r**30)
            +3*(2729-145434*r**2+3136590*r**4+68425030*r**6+381892530*r**8+1969116078*r**10
            +12244583462*r**12+10213171470*r**14+53155670340*r**16+26175199090*r**18
            -6659403318*r**20+1063781778*r**22-616735810*r**24-12996870*r**26-7671870*r**28
            -432614*r**30+6819*r**32))-165888000*logq2**4*r**18*(540*Q2**8-6000*Q2**7*(1
            +r**2)+Q2**6*(28014+51700*r**2+26390*r**4)+2*Q2**5*(-26397-68552*r**2
            -65010*r**4-18340*r**6+2835*r**8)+Q2**4*(31395+107742*r**2+137950*r**4
            +67100*r**6-16065*r**8-17010*r**10)+Q2**3*(29925-17383*r**2-86518*r**4
            -65490*r**6-23795*r**8+23905*r**10+11340*r**12)+6*(-1+r**2)**2*(-1471
            -6126*r**2-48546*r**4-82251*r**6-64191*r**8-24480*r**10-680*r**12+945*r**14)
            +Q2**2*(-59535-13988*r**2-99959*r**4-209228*r**6-121645*r**8+7460*r**10
            +31955*r**12+11340*r**14)+3*Q2*(12427+11379*r**2+210669*r**4+543239*r**6
            +597559*r**8+353217*r**10+94455*r**12-2875*r**14-5670*r**16))*sqrtq2
            -276480*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7210*Q2**13
            -2*Q2**12*(31886+35353*r**2)+Q2**11*(247954+550206*r**2+285872*r**4)
            -4*Q2**10*(113543+426323*r**2+462865*r**4+127859*r**6)+10*Q2**9*(32370
            +244495*r**2+420035*r**4+279949*r**6+18287*r**8)+5*Q2**8*(18715-276286*r**2
            -434458*r**4-391820*r**6-206153*r**8+142922*r**10)-Q2**7*(261791+938483*r**2
            +9997690*r**4+20804570*r**6+13401095*r**8+3253651*r**10+1008848*r**12)
            +Q2**6*(130977+2160788*r**2+18414541*r**4+55237280*r**6+63827475*r**8
            +25573492*r**10+5457823*r**12+176456*r**14)+Q2**5*(-32401-948641*r**2
            -5061875*r**4-35069733*r**6-77644545*r**8-50011971*r**10-67921*r**12
            -1729495*r**14+596182*r**16)-5*Q2**4*(2625+26800*r**2+65210*r**4-5902110*r**6
            -22268216*r**8-19737118*r**10-935394*r**12+6263110*r**14+631103*r**16
            +94854*r**18)+5*Q2**3*(8933-43159*r**2-1486012*r**4-9066204*r**6-24803382*r**8
            -29237454*r**10-10882548*r**12+3507532*r**14+3586145*r**16+525013*r**18
            +6656*r**20)+Q2**2*(-24737+39364*r**2-253135*r**4-2497060*r**6-24593190*r**8
            -4378256*r**10-70409338*r**12-81944160*r**14-47438585*r**16+6231820*r**18
            +155273*r**20+126404*r**22)-3*Q2*(-173-116177*r**2-2123929*r**4-4891235*r**6
            -6067660*r**8+88012266*r**10+112196634*r**12+67072078*r**14+22964135*r**16
            -7810265*r**18+2697407*r**20+203093*r**22+23826*r**24)+2*(699-74746*r**2
            -1089995*r**4-5500053*r**6-49603550*r**8-89564293*r**10-320144898*r**12
            -299858270*r**14-72198349*r**16+19585200*r**18+729869*r**20+1178419*r**22
            +53040*r**24+6927*r**26))*sqrtq2-64*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(13732*Q2**19-4*Q2**18*(12931+15151*r**2)+20*Q2**17*(1482+10697*r**2
            +2349*r**4)+2*Q2**16*(25427-90856*r**2-162181*r**4+66422*r**6)-2*Q2**15*(
            -80699+609082*r**2+4165608*r**4+349922*r**6+63351*r**8)+Q2**14*(-594731
            +4886630*r**2+59343314*r**4+58380484*r**6+4367465*r**8-365506*r**10)
            +Q2**13*(378837-5857433*r**2-148076376*r**4-343539118*r**6-139765151*r**8
            -6007713*r**10+482202*r**12)+2*Q2**12*(176635-544790*r**2+72682482*r**4
            +399849463*r**6+405324203*r**8+47402772*r**10-1616960*r**12+185075*r**14)
            -2*Q2**11*(172036-3008573*r**2-26845695*r**4+323646643*r**6+548293041*r**8
            +316597433*r**10-94233645*r**12-6885903*r**14+409271*r**16)+Q2**10*(
            -224329-229218*r**2-263816588*r**4-552671976*r**6-1782756118*r**8-1850569628*r**10
            -907292076*r**12-425176968*r**14-5703593*r**16+35246*r**18)+Q2**9*(241891
            -4310735*r**2+166297122*r**4+1370665232*r**6+5348691790*r**8+11767232394*r**10
            +5617458860*r**12+2226774872*r**14+187076007*r**16-9701155*r**18+559066*r**20)
            -2*Q2**8*(-23124-809014*r**2-66094951*r**4+433428537*r**6+1897284864*r**8
            +9756354284*r**10+10912217554*r**12+1001616514*r**14+594345612*r**16
            -166184126*r**18-4308099*r**20+101421*r**22)-2*Q2**7*(20105+167180*r**2
            +91659234*r**4-75135264*r**6+495570771*r**8-3197207816*r**10-6085701700*r**12
            -4641968016*r**14+3422583391*r**16+454829916*r**18+211551554*r**20-482160*r**22
            +78245*r**24)+Q2**6*(-23293+320594*r**2-6039894*r**4+427847860*r**6
            +3246063569*r**8+17263944246*r**10+49637403068*r**12+49614807448*r**14
            +29243008101*r**16+8545050494*r**18+1643387290*r**20+14765556*r**22-3353401*r**24
            +95802*r**26)-Q2**5*(18661-1171753*r**2-71525724*r**4+715459806*r**6
            +448223223*r**8+9615072441*r**10+36752913962*r**12+95334571428*r**14
            +31130723587*r**16+36564903561*r**18-875743872*r**20+892672446*r**22
            -228057759*r**24-1720793*r**26+6386*r**28)+2*Q2**4*(10179-463010*r**2
            -3679468*r**4+86847717*r**6-649969215*r**8-1069985004*r**10-1381108770*r**12
            +37048261711*r**14+62637602741*r**16-34020692130*r**18+458555496*r**20
            -4010349645*r**22-128694393*r**24-50401808*r**26-293530*r**28+729*r**30)
            +2*Q2**3*(3632-178183*r**2-6287013*r**4+136230421*r**6-518131673*r**8
            -3598952307*r**10-14808900937*r**12-39751589239*r**14-53194278717*r**16
            -67129749989*r**18+22900346593*r**20+7645151823*r**22+1557130277*r**24
            +315403871*r**26-14757363*r**28-179693*r**30+2497*r**32)+Q2**2*(-7075
            +371750*r**2+551024*r**4-118096304*r**6+910130836*r**8+1191311704*r**10
            +1798540160*r**12-6453567568*r**14-45056648602*r**16-86361248012*r**18
            -129419864528*r**20+11135132080*r**22-9798561916*r**24+2358312056*r**26
            -181179424*r**28+27129424*r**30+469285*r**32-6890*r**34)+3*Q2*(87-4551*r**2
            +143122*r**4-3723756*r**6+181436496*r**8+1316577800*r**10+3082088924*r**12
            -10021449900*r**14-27354932906*r**16-70148778142*r**18-129224657136*r**20
            +46722612380*r**22-10777399416*r**24+778745280*r**26-471604604*r**28
            -32783876*r**30-1445253*r**32-24931*r**34+382*r**36)+6*(57-3666*r**2
            +66680*r**4+439421*r**6-45806872*r**8-201821596*r**10-1413749212*r**12
            -4794984160*r**14-27839673918*r**16+6956442576*r**18-117047532204*r**20
            +32392440322*r**22-7727772320*r**24+1977124348*r**26+154068364*r**28
            +10595368*r**30+7029181*r**32+22050*r**34-4476*r**36+57*r**38))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(
            -470292480000*logq2**6*r**26*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-48988800000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -340200000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**4-157500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**6+5443200000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+11340000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2+235146240000*logq2**5*r**22*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC**2*(26127360000*logq2**5*(-Q2+(-1+r)**2)*r**22*(27
            +70*r**2+68*r**4+42*r**6+9*r**8)*(-Q2+(1+r)**2)-691200*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1630*Q2**10-10*Q2**9*(1645+1996*r**2)
            +2*Q2**8*(31785+80660*r**2+46959*r**4)-4*Q2**7*(36175+129665*r**2+152426*r**4
            +54961*r**6)+Q2**6*(154455+719250*r**2+1369524*r**4+971590*r**6+186389*r**8)
            +2*Q2**5*(-19390-170325*r**2-700814*r**4-731638*r**6-201108*r**8+81991*r**10)
            +Q2**4*(-16275+439400*r**2+2949625*r**4+3621960*r**6+1295183*r**8-358760*r**10
            -405405*r**12)+8*Q2**3*(-1315-77440*r**2-364041*r**4-660750*r**6-334974*r**8
            +34986*r**10+61240*r**12+21274*r**14)+Q2**2*(-22225-62830*r**2-1140286*r**4
            +820314*r**6-105252*r**8-2510922*r**10-1869482*r**12-459266*r**14+118429*r**16)
            -6*Q2*(-7395-65745*r**2-316436*r**4+902640*r**6+1844286*r**8+1384590*r**10
            +638540*r**12+168456*r**14-31795*r**16+18859*r**18)+3*(-5025-50940*r**2
            -622979*r**4-1951808*r**6-8116502*r**8-10443736*r**10-5599330*r**12
            -795616*r**14+351063*r**16+10932*r**18+7941*r**20))+96*logq2*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(-118548*Q2**16+12*Q2**15*(101279+98794*r**2)
            -48*Q2**14*(89565+214963*r**2+86040*r**4)+4*Q2**13*(1642905+8212034*r**2
            +8179279*r**4+1385880*r**6)+Q2**12*(-2360145-45894754*r**2-77423412*r**4
            -43283534*r**6+1583805*r**8)-4*Q2**11*(1515099-1236539*r**2+9405786*r**4
            +11288406*r**6+2611331*r**8+3335349*r**10)+2*Q2**10*(3912783+35136896*r**2
            +210506575*r**4+437994000*r**6+240751685*r**8+54930856*r**10+6284613*r**12)
            +4*Q2**9*(-51165-19639013*r**2-147576285*r**4-539107525*r**6-581631275*r**8
            -159162135*r**10-28830763*r**12+992985*r**14)+Q2**8*(-6270615+9002278*r**2
            +219805578*r**4+2076541950*r**6+3897205500*r**8+2286118050*r**10-148295562*r**12
            -23627782*r**14-15336165*r**16)+4*Q2**7*(1023735+7597252*r**2+44519156*r**4
            +61248732*r**6+381623490*r**8+356592240*r**10+260374692*r**12+254862556*r**14
            +30787967*r**16+2050260*r**18)+4*Q2**6*(321309-5037128*r**2-69264093*r**4
            -554277928*r**6-2608104138*r**8-4824179904*r**10-3137242278*r**12-1220123768*r**14
            -188650803*r**16-16206088*r**18+1087059*r**20)-4*Q2**5*(594369-3063808*r**2
            -39754245*r**4-181895790*r**6-1172793110*r**8-4783011996*r**10-5729297226*r**12
            -1334744320*r**14-762314715*r**16+60203340*r**18+5442367*r**20+1694334*r**22)
            +Q2**4*(367905-2705974*r**2+15472960*r**4+342769950*r**6+54763225*r**8
            -12458255740*r**10-34827589752*r**12-13409002340*r**14+12388205075*r**16
            +1953366450*r**18+689901560*r**20+33747526*r**22+1778355*r**24)+4*Q2**3*(137655
            -2016541*r**2-10057386*r**4+210889570*r**6+1247175625*r**8+4685221725*r**10
            +8567919572*r**12+8733823132*r**14+1665885225*r**16-2287437475*r**18
            -576162730*r**20-70932606*r**22-3156521*r**24+310755*r**26)-2*Q2**2*(111585
            -2456248*r**2-3930219*r**4+163523472*r**6-88637755*r**8+62255520*r**10
            -3857614959*r**12-8362794912*r**14-12000546189*r**16-11528168280*r**18
            +480068095*r**20-97177968*r**22+71529831*r**24+343792*r**26+422235*r**28)
            +12*Q2*(-441+26113*r**2-1383757*r**4-44435747*r**6-242062577*r**8+23429041*r**10
            +802367699*r**12+6770350389*r**14+6423464269*r**16+3542221979*r**18-1294396159*r**20
            +319688063*r**22+18918493*r**24+11111603*r**26+292473*r**28+8559*r**30)
            +3*(2729-145434*r**2+3136590*r**4+68425030*r**6+381892530*r**8+1969116078*r**10
            +12244583462*r**12+10213171470*r**14+53155670340*r**16+26175199090*r**18
            -6659403318*r**20+1063781778*r**22-616735810*r**24-12996870*r**26-7671870*r**28
            -432614*r**30+6819*r**32))-20736000*logq2**4*r**18*(540*Q2**8-6000*Q2**7*(1
            +r**2)+Q2**6*(28014+51700*r**2+26390*r**4)+2*Q2**5*(-26397-68552*r**2
            -65010*r**4-18340*r**6+2835*r**8)+Q2**4*(31395+107742*r**2+137950*r**4
            +67100*r**6-16065*r**8-17010*r**10)+Q2**3*(29925-17383*r**2-86518*r**4
            -65490*r**6-23795*r**8+23905*r**10+11340*r**12)+6*(-1+r**2)**2*(-1471
            -6126*r**2-48546*r**4-82251*r**6-64191*r**8-24480*r**10-680*r**12+945*r**14)
            +Q2**2*(-59535-13988*r**2-99959*r**4-209228*r**6-121645*r**8+7460*r**10
            +31955*r**12+11340*r**14)+3*Q2*(12427+11379*r**2+210669*r**4+543239*r**6
            +597559*r**8+353217*r**10+94455*r**12-2875*r**14-5670*r**16))*sqrtq2
            -34560*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(7210*Q2**13
            -2*Q2**12*(31886+35353*r**2)+Q2**11*(247954+550206*r**2+285872*r**4)
            -4*Q2**10*(113543+426323*r**2+462865*r**4+127859*r**6)+10*Q2**9*(32370
            +244495*r**2+420035*r**4+279949*r**6+18287*r**8)+5*Q2**8*(18715-276286*r**2
            -434458*r**4-391820*r**6-206153*r**8+142922*r**10)-Q2**7*(261791+938483*r**2
            +9997690*r**4+20804570*r**6+13401095*r**8+3253651*r**10+1008848*r**12)
            +Q2**6*(130977+2160788*r**2+18414541*r**4+55237280*r**6+63827475*r**8
            +25573492*r**10+5457823*r**12+176456*r**14)+Q2**5*(-32401-948641*r**2
            -5061875*r**4-35069733*r**6-77644545*r**8-50011971*r**10-67921*r**12
            -1729495*r**14+596182*r**16)-5*Q2**4*(2625+26800*r**2+65210*r**4-5902110*r**6
            -22268216*r**8-19737118*r**10-935394*r**12+6263110*r**14+631103*r**16
            +94854*r**18)+5*Q2**3*(8933-43159*r**2-1486012*r**4-9066204*r**6-24803382*r**8
            -29237454*r**10-10882548*r**12+3507532*r**14+3586145*r**16+525013*r**18
            +6656*r**20)+Q2**2*(-24737+39364*r**2-253135*r**4-2497060*r**6-24593190*r**8
            -4378256*r**10-70409338*r**12-81944160*r**14-47438585*r**16+6231820*r**18
            +155273*r**20+126404*r**22)-3*Q2*(-173-116177*r**2-2123929*r**4-4891235*r**6
            -6067660*r**8+88012266*r**10+112196634*r**12+67072078*r**14+22964135*r**16
            -7810265*r**18+2697407*r**20+203093*r**22+23826*r**24)+2*(699-74746*r**2
            -1089995*r**4-5500053*r**6-49603550*r**8-89564293*r**10-320144898*r**12
            -299858270*r**14-72198349*r**16+19585200*r**18+729869*r**20+1178419*r**22
            +53040*r**24+6927*r**26))*sqrtq2-8*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(13732*Q2**19-4*Q2**18*(12931+15151*r**2)+20*Q2**17*(1482+10697*r**2
            +2349*r**4)+2*Q2**16*(25427-90856*r**2-162181*r**4+66422*r**6)-2*Q2**15*(
            -80699+609082*r**2+4165608*r**4+349922*r**6+63351*r**8)+Q2**14*(-594731
            +4886630*r**2+59343314*r**4+58380484*r**6+4367465*r**8-365506*r**10)
            +Q2**13*(378837-5857433*r**2-148076376*r**4-343539118*r**6-139765151*r**8
            -6007713*r**10+482202*r**12)+2*Q2**12*(176635-544790*r**2+72682482*r**4
            +399849463*r**6+405324203*r**8+47402772*r**10-1616960*r**12+185075*r**14)
            -2*Q2**11*(172036-3008573*r**2-26845695*r**4+323646643*r**6+548293041*r**8
            +316597433*r**10-94233645*r**12-6885903*r**14+409271*r**16)+Q2**10*(
            -224329-229218*r**2-263816588*r**4-552671976*r**6-1782756118*r**8-1850569628*r**10
            -907292076*r**12-425176968*r**14-5703593*r**16+35246*r**18)+Q2**9*(241891
            -4310735*r**2+166297122*r**4+1370665232*r**6+5348691790*r**8+11767232394*r**10
            +5617458860*r**12+2226774872*r**14+187076007*r**16-9701155*r**18+559066*r**20)
            -2*Q2**8*(-23124-809014*r**2-66094951*r**4+433428537*r**6+1897284864*r**8
            +9756354284*r**10+10912217554*r**12+1001616514*r**14+594345612*r**16
            -166184126*r**18-4308099*r**20+101421*r**22)-2*Q2**7*(20105+167180*r**2
            +91659234*r**4-75135264*r**6+495570771*r**8-3197207816*r**10-6085701700*r**12
            -4641968016*r**14+3422583391*r**16+454829916*r**18+211551554*r**20-482160*r**22
            +78245*r**24)+Q2**6*(-23293+320594*r**2-6039894*r**4+427847860*r**6
            +3246063569*r**8+17263944246*r**10+49637403068*r**12+49614807448*r**14
            +29243008101*r**16+8545050494*r**18+1643387290*r**20+14765556*r**22-3353401*r**24
            +95802*r**26)-Q2**5*(18661-1171753*r**2-71525724*r**4+715459806*r**6
            +448223223*r**8+9615072441*r**10+36752913962*r**12+95334571428*r**14
            +31130723587*r**16+36564903561*r**18-875743872*r**20+892672446*r**22
            -228057759*r**24-1720793*r**26+6386*r**28)+2*Q2**4*(10179-463010*r**2
            -3679468*r**4+86847717*r**6-649969215*r**8-1069985004*r**10-1381108770*r**12
            +37048261711*r**14+62637602741*r**16-34020692130*r**18+458555496*r**20
            -4010349645*r**22-128694393*r**24-50401808*r**26-293530*r**28+729*r**30)
            +2*Q2**3*(3632-178183*r**2-6287013*r**4+136230421*r**6-518131673*r**8
            -3598952307*r**10-14808900937*r**12-39751589239*r**14-53194278717*r**16
            -67129749989*r**18+22900346593*r**20+7645151823*r**22+1557130277*r**24
            +315403871*r**26-14757363*r**28-179693*r**30+2497*r**32)+Q2**2*(-7075
            +371750*r**2+551024*r**4-118096304*r**6+910130836*r**8+1191311704*r**10
            +1798540160*r**12-6453567568*r**14-45056648602*r**16-86361248012*r**18
            -129419864528*r**20+11135132080*r**22-9798561916*r**24+2358312056*r**26
            -181179424*r**28+27129424*r**30+469285*r**32-6890*r**34)+3*Q2*(87-4551*r**2
            +143122*r**4-3723756*r**6+181436496*r**8+1316577800*r**10+3082088924*r**12
            -10021449900*r**14-27354932906*r**16-70148778142*r**18-129224657136*r**20
            +46722612380*r**22-10777399416*r**24+778745280*r**26-471604604*r**28
            -32783876*r**30-1445253*r**32-24931*r**34+382*r**36)+6*(57-3666*r**2
            +66680*r**4+439421*r**6-45806872*r**8-201821596*r**10-1413749212*r**12
            -4794984160*r**14-27839673918*r**16+6956442576*r**18-117047532204*r**20
            +32392440322*r**22-7727772320*r**24+1977124348*r**26+154068364*r**28
            +10595368*r**30+7029181*r**32+22050*r**34-4476*r**36+57*r**38))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(
            -156764160000*logq2**6*r**26*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-16329600000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -113400000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**4-52500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**6+1814400000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+3780000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2+78382080000*logq2**5*r**22*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC**3*(2073600*logq2**4*r**12*(210*Q2**9*(2+5*r**4)
            -10*Q2**8*(786+1010*r**2+2061*r**4+1725*r**6)+20*Q2**7*(2472+6092*r**2
            +10079*r**4+11189*r**6+4905*r**8)-4*Q2**6*(43512+147242*r**2+264114*r**4
            +331281*r**6+244453*r**8+76860*r**10)+Q2**5*(322308+1350816*r**2+2684769*r**4
            +3789270*r**6+3618476*r**8+2186202*r**10+579915*r**12)-Q2**4*(259980
            +1323884*r**2+2880179*r**4+4497973*r**6+5168142*r**8+4333866*r**10+2368495*r**12
            +565425*r**14)+2*Q2**3*(-13860+172948*r**2+614096*r**4+1103904*r**6
            +1449595*r**8+1651526*r**10+977872*r**12+274010*r**14+27825*r**16)+(
            -1+r**2)**2*(25992+55344*r**2+664923*r**4+3156809*r**6+4955557*r**8
            +5256375*r**10+2339713*r**12-125821*r**14+181023*r**16+96885*r**18)
            +2*Q2**2*(98700+82228*r**2-14263*r**4+599438*r**6+810340*r**8+853055*r**10
            -101875*r**12-242668*r**14+471270*r**16+211575*r**18)-Q2*(125952+63416*r**2
            +1126687*r**4+7867802*r**6+15922196*r**8+20380202*r**10+16370518*r**12
            +4583462*r**14-898548*r**16+520878*r**18+364635*r**20))+1152*logq2**2*(
            -Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(90*Q2**15*(687+3520*r**4)-6*Q2**14*(124455
            +124343*r**2+546456*r**4+630480*r**6)+6*Q2**13*(567105+1150522*r**2
            +3018451*r**4+5427984*r**6+3109320*r**8)-6*Q2**12*(1260975+4168683*r**2
            +10001003*r**4+21347567*r**6+22146476*r**8+7864980*r**10)+Q2**11*(7415580
            +46001272*r**2+108578467*r**4+274883254*r**6+386289468*r**8+277883754*r**10
            +57377745*r**12)-Q2**10*(-2045280+39766508*r**2+36264499*r**4+210424909*r**6
            +386442374*r**8+402707574*r**10+271791171*r**12+2209005*r**14)-Q2**9*(13035840
            +7331084*r**2+301261993*r**4+620443200*r**6+956547715*r**8+1338787400*r**10
            +762416319*r**12+56218428*r**14+88978365*r**16)+Q2**8*(11843340+58227536*r**2
            +669033683*r**4+2133684617*r**6+4011447665*r**8+6432439235*r**10+6366660281*r**12
            +2893731843*r**14+495644367*r**16+107809785*r**18)-2*Q2**7*(-54975+29905952*r**2
            +234021367*r**4+1391101978*r**6+3085737364*r**8+5593892950*r**10+7123742662*r**12
            +5006811242*r**14+1507617363*r**16+278297094*r**18+11884995*r**20)+2*Q2**6*(
            -3988005+6847303*r**2-142936597*r**4+758685741*r**6+1376534262*r**8
            +2919322326*r**10+5683572768*r**12+6255671408*r**14+2836658251*r**16
            -301714713*r**18+59072721*r**20-29216745*r**22)+2*Q2**5*(2836875+12144058*r**2
            +353846074*r**4+237057124*r**6+3238328799*r**8+8683027164*r**10+10064650794*r**12
            +6386675944*r**14+1768112659*r**16+1183579474*r**18+1924605804*r**20
            +152657196*r**22+29019555*r**24)-2*Q2**4*(225465+11526929*r**2+193206148*r**4
            +713230210*r**6+4981773305*r**8+14604908475*r**10+21711848322*r**12+23469256634*r**14
            +17653416625*r**16+8274060145*r**18+2941277810*r**20+1361391324*r**22
            +142018293*r**24+6840315*r**26)+Q2**3*(-1470720+5629832*r**2-84920789*r**4
            +1041102654*r**6+1418990140*r**8+10871126690*r**10+20777483631*r**12
            +27205797188*r**14+28532753992*r**16+13805491140*r**18+7037419105*r**20
            +4776705662*r**22-175488324*r**24+43662354*r**26-11456955*r**28)+(-1
            +r**2)**2*(20640+357172*r**2+15127855*r**4+29715199*r**6+748259144*r**8
            -633916180*r**10+7235019191*r**12+30874593455*r**14+20231739272*r**16
            -2570582188*r**18+960905245*r**20+2521271437*r**22+250444240*r**24+116256204*r**26
            +4817469*r**28+451845*r**30)+Q2**2*(894900+2399752*r**2+198748477*r**4
            -353051117*r**6+5438494634*r**8-2558627110*r**10-13823787769*r**12-15636714679*r**14
            -27331026736*r**16-24293487628*r**18+9307943515*r**20+10229682517*r**22
            -2176716398*r**24+1143231978*r**26+57275169*r**28+10260495*r**30)-Q2*(221820
            +1738628*r**2+90854173*r**4-50911064*r**6+3682686267*r**8-4760061424*r**10
            +10039986089*r**12+77363921564*r**14+104244146783*r**16+52657711316*r**18
            -13874171817*r**20-394721072*r**22+9887178913*r**24-370499944*r**26+586820067*r**28
            +29609196*r**30+3410505*r**32))+4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(20598*Q2**21
            -18*Q2**20*(4971+7339*r**2)+12*Q2**19*(12528+43015*r**2+22740*r**4)
            -4*Q2**18*(-14283+146974*r**2+260506*r**4+8145*r**6)-3*Q2**17*(958127
            +767862*r**2+5860156*r**4+377338*r**6+172705*r**8)+Q2**16*(15215511
            +11407853*r**2+108870186*r**4+154575102*r**6+12261235*r**8+31113*r**10)
            +2*Q2**15*(-18678159-9208626*r**2-78680676*r**4-392718530*r**6-263687393*r**8
            -14896640*r**10+814884*r**12)-6*Q2**14*(-6799212-3383105*r**2+65818145*r**4
            -185404110*r**6-416824442*r**8-138946697*r**10-4180015*r**12+239940*r**14)
            -6*Q2**13*(-1747559+12469802*r**2-359445699*r**4-343334154*r**6+256910171*r**8
            +626228570*r**10+35975407*r**12-3646082*r**14+269160*r**16)+2*Q2**12*(
            -43495776+105987329*r**2-2376674635*r**4-6052272891*r**6-7467190339*r**8
            -4197042013*r**10+306584619*r**12-736874653*r**14-30288349*r**16+1531860*r**18)
            +6*Q2**11*(15572479-39216994*r**2+951218174*r**4+4528806562*r**6+8426680080*r**8
            +10891621946*r**10+5590899982*r**12+1189243646*r**14+406921729*r**16
            +4700520*r**18-82492*r**20)-2*Q2**10*(-656496+45712861*r**2+558942567*r**4
            +17239147380*r**6+36947174748*r**8+70053940026*r**10+70745461230*r**12
            +20418903060*r**14+5584754196*r**16+426854361*r**18-17091349*r**20+964296*r**22)
            +2*Q2**9*(-46533726+268666400*r**2-4144991305*r**4+8809929920*r**6+9146990563*r**8
            +47393718556*r**10+76520663510*r**12+67872797380*r**14-4647640760*r**16
            +2518055828*r**18-930386861*r**20-21901460*r**22+606195*r**24)+6*Q2**8*(12932491
            -85516448*r**2+2127384209*r**4+2780645887*r**6+18360818162*r**8+27831577717*r**10
            +31820938678*r**12+29943087778*r**14+6353591627*r**16+12737396062*r**18
            +834996809*r**20+393781487*r**22+1472648*r**24+51485*r**26)-2*Q2**7*(
            -2495811+30334054*r**2+2391952728*r**4+19055513862*r**6+76292446257*r**8
            +231435960612*r**10+359458283916*r**12+439022207964*r**14+292571304735*r**16
            +120534078462*r**18+34487767320*r**20+4523531454*r**22+197591667*r**24
            -7072744*r**26+265860*r**28)+2*Q2**6*(-23313924+247262097*r**2-3551037033*r**4
            +16240644050*r**6+4146651310*r**8+259916121391*r**10+400314622577*r**12
            +679945055800*r**14+618107545744*r**16+118806338015*r**18+115324227625*r**20
            -6435467654*r**22+2705411750*r**24-551304127*r**26-6690385*r**28+82524*r**30)
            -6*Q2**5*(-4284672+54924982*r**2-1518265589*r**4+1989564010*r**6-26321584405*r**8
            +41291502386*r**10-64863798921*r**12-9702424298*r**14+86557572671*r**16
            +143511853194*r**18-98737769871*r**20+6824500614*r**22-10476330271*r**24
            -107749554*r**26-132025267*r**28-883526*r**30+1077*r**32)-2*Q2**4*(-1198047
            +18782430*r**2+1191640425*r**4+3938011125*r**6+66952064089*r**8+41951131557*r**10
            +733159215705*r**12+939315872565*r**14+885479852955*r**16+789847975257*r**18
            -82683073533*r**20+339380739015*r**22+45607780395*r**24+16373583095*r**26
            +1631134779*r**28+11467023*r**30-475200*r**32+11565*r**34)+2*Q2**3*(
            -3797841+67612948*r**2-1119711062*r**4+7328959842*r**6-7322219598*r**8
            +110273745174*r**10+166690562582*r**12+408344951746*r**14+572352876736*r**16
            +199871644046*r**18+454944209650*r**20+317225826262*r**22+17463494894*r**24
            +45494003282*r**26-4822525198*r**28+852558342*r**30-88977167*r**32-1255178*r**34
            +14940*r**36)+(-1+r**2)**2*(-70353+3361137*r**2-3381621*r**4+565473101*r**6
            +4281210600*r**8-19872491328*r**10+184160281680*r**12-566270532120*r**14
            +1865614985598*r**16+742058085418*r**18-1108760903970*r**20+666220766154*r**22
            -88445257712*r**24+37853824296*r**26+3962655144*r**28+337848576*r**30
            +87039579*r**32+176253*r**34-46945*r**36+513*r**38)-6*Q2**2*(-433406
            +7795369*r**2-292700749*r**4+1268012930*r**6-12733703072*r**8+38247318000*r**10
            -166068035424*r**12+239391580880*r**14+178083496396*r**16+507845767954*r**18
            +125807760518*r**20-364814488644*r**22+174661811712*r**24-55410294872*r**26
            +6028953608*r**28-2399707312*r**30-24654126*r**32-12130643*r**34-175329*r**36
            +2210*r**38)+Q2*(-90135-4140958*r**2-352263114*r**4+383569326*r**6
            -35272544735*r**8+140814523344*r**10-886235742456*r**12+2217838939696*r**14
            -3225525871854*r**16-5694920961180*r**18-697476478140*r**20+3575883902076*r**22
            -2774211460470*r**24+692688756800*r**26-196289326200*r**28-59483712*r**30
            -4046224987*r**32-377647062*r**34-9523722*r**36-29210*r**38+693*r**40))
            +870912000*logq2**5*r**16*(231+938*r**2+1808*r**4+2150*r**6+2277*r**8
            +504*r**10)*sqrtq2+69120*logq2**3*r**8*(30*Q2**12*(279+1105*r**4)-420*Q2**11*(243
            +259*r**2+921*r**4+1005*r**6)+12*Q2**10*(47178+95343*r**2+204576*r**4
            +344312*r**6+195795*r**8)-20*Q2**9*(80109+239880*r**2+481587*r**4+876178*r**6
            +903748*r**8+351030*r**10)+15*Q2**8*(151035+647998*r**2+1443760*r**4
            +2742138*r**6+3664125*r**8+2649224*r**10+738860*r**12)-20*Q2**7*(46719
            +481440*r**2+1187304*r**4+2441119*r**6+3943173*r**8+4048782*r**10+2100248*r**12
            +300735*r**14)-20*Q2**6*(84357-130872*r**2+296046*r**4+1162540*r**6
            +764038*r**8-545258*r**10-1582708*r**12-434182*r**14+408135*r**16)+12*Q2**5*(217209
            +371714*r**2+4756148*r**4+15721471*r**6+25750690*r**8+27259049*r**10
            +18471864*r**12+6635653*r**14+2182481*r**16+1325785*r**18)-10*Q2**4*(108612
            +595770*r**2+6374841*r**4+23084516*r**6+43055064*r**8+55945464*r**10
            +53339556*r**12+34740288*r**14+13414644*r**16+3020794*r**18+831915*r**20)
            -20*Q2**3*(24930-160959*r**2-273465*r**4-3583814*r**6-9955874*r**8-14326208*r**10
            -18161344*r**12-14869798*r**14-5228408*r**16-2332105*r**18-819967*r**20
            +127620*r**22)+60*Q2**2*(11751-8695*r**2+605698*r**4+100520*r**6-1264182*r**8
            -855442*r**10-1688906*r**12-3178692*r**14-2419751*r**16+1985321*r**18
            +1171472*r**20-77124*r**22+82430*r**24)+(-1+r**2)**2*(41481+151428*r**2
            +5642187*r**4+676260*r**6+67435518*r**8+299440504*r**10+389445558*r**12
            +202708848*r**14-3740435*r**16+13210932*r**18+19840815*r**20+1230364*r**22
            +324540*r**24)-20*Q2*(14130+10758*r**2+1248813*r**4-682187*r**6+4898601*r**8
            +37865241*r**10+66691422*r**12+64227870*r**14+25585656*r**16-5893092*r**18
            +1656213*r**20+3529389*r**22+21101*r**24+107685*r**26))*sqrtq2+48*logq2*(
            -100*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(216+105*Q2**7-5322*r**2-111984*r**4
            -82010*r**6+1662425*r**8+2532819*r**10+675257*r**12+45979*r**14-1200*r**16
            -5*Q2**6*(-81+31*r**2+240*r**4)+15*Q2**5*(-29-16*r**2+59*r**4+60*r**6)
            -Q2**4*(-321+243*r**2+50107*r**4+69411*r**6+9180*r**8)+Q2**3*(-624
            -1662*r**2+61810*r**4+163882*r**6+104839*r**8+11400*r**10)+Q2**2*(-414
            -1424*r**2+12832*r**4-28772*r**6-36231*r**8+26019*r**10+5940*r**12)
            +Q2*(426-5234*r**2-72620*r**4+90200*r**6+486565*r**8+305854*r**10
            -12501*r**12-6660*r**14))+21*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(48*Q2**10*(4+41*r**4)
            -48*Q2**9*(15+15*r**2+241*r**4+305*r**6)+Q2**8*(675+1350*r**2+20667*r**4
            +53440*r**6+34920*r**8)-24*Q2**7*(-20+60*r**2+443*r**4+2501*r**6+3145*r**8
            +895*r**10)-12*Q2**6*(75-150*r**2+3356*r**4-1298*r**6-6369*r**8-4276*r**10
            +2910*r**12)-24*Q2**3*r**4*(2293-3645*r**2-11327*r**4-21391*r**6-22491*r**8
            -16137*r**10-5635*r**12+1005*r**14)+8*Q2**5*(-18+270*r**2+14538*r**4
            +21131*r**6+23238*r**8+11628*r**10-4438*r**12+6723*r**14)-6*Q2**4*(
            -95+930*r**2+11077*r**4+26540*r**6+70585*r**8+139978*r**10+94025*r**12
            +7732*r**14+1060*r**16)+24*Q2*r**4*(608-7379*r**2-78584*r**4-141118*r**6
            -82626*r**8+34206*r**10+24448*r**12-18922*r**14-2998*r**16+205*r**18)
            -3*(-1+r**2)**2*(-9+252*r**2+2032*r**4-46052*r**6-261254*r**8-334484*r**10
            +79984*r**12+67924*r**14-42497*r**16-11000*r**18+784*r**20)+4*Q2**2*(
            -45+810*r**2+8748*r**4-35234*r**6+19518*r**8-68982*r**10-189638*r**12
            +25302*r**14+110571*r**16-9200*r**18+2070*r**20))-2*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(30*Q2**15*(3456+39445*r**4)-6*Q2**14*(73200+78688*r**2+1280487*r**4
            +1572495*r**6)+2*Q2**13*(197820+643086*r**2+8337915*r**4+20131384*r**6
            +12163965*r**8)-6*Q2**12*(-117900+192168*r**2+2049159*r**4+9118211*r**6
            +10343387*r**8+2352995*r**10)+Q2**11*(-1219545-146733*r**2-24850959*r**4
            +9092945*r**6+3019964*r**8+12249668*r**10-36392820*r**12)+Q2**10*(-369135
            +3672222*r**2+63003180*r**4+134107090*r**6+442717435*r**8+470273440*r**10
            +67653368*r**12+49296480*r**14)+Q2**9*(1309725-4001619*r**2+75948984*r**4
            +28203080*r**6-696908385*r**8-1625037805*r**10-1167529824*r**12-140073256*r**14
            +21836940*r**16)+Q2**8*(197595-7303494*r**2-322522185*r**4-562583276*r**6
            -380518515*r**8+144626810*r**10+164563161*r**12+57619180*r**14+101744264*r**16
            -62071860*r**18)+2*Q2**7*(-505125+5725983*r**2+87205884*r**4+305814281*r**6
            +990806067*r**8+1193009815*r**10+1475010703*r**12+1654052049*r**14+1196590496*r**16
            +87651472*r**18+2581095*r**20)+2*Q2**6*(-43155+2489358*r**2+114924819*r**4
            -282215755*r**6-1449575204*r**8-3262607418*r**10-5448832282*r**12-4121365236*r**14
            -905303425*r**16-629480024*r**18-138410993*r**20+18810195*r**22)-2*Q2**5*(
            -286065+5846997*r**2+116236365*r**4-29902280*r**6+2645776575*r**8+5351320340*r**10
            +1700020850*r**12-6452482300*r**14-6183830845*r**16-374861625*r**18+1005047185*r**20
            +31035668*r**22+6096255*r**24)+2*Q2**4*(-12825-299814*r**2-2601606*r**4
            +552405595*r**6+5935070055*r**8+12142144435*r**10+16239010638*r**12+20833434442*r**14
            +20492332615*r**16+7415492520*r**18+12783240*r**20+822663851*r**22+113601339*r**24
            -5008485*r**26)+Q2**3*(-181485+5292447*r**2+59451705*r**4-730697867*r**6
            -1561291690*r**8-5438870970*r**10-17667352314*r**12-20463099970*r**14
            -19771511101*r**16-39505652865*r**18-30415490895*r**20-4896904883*r**22
            +243654740*r**24-23682532*r**26+3937680*r**28)-(-1+r**2)**2*(7425-264672*r**2
            -631944*r**4+48141784*r**6+679419297*r**8+6747904360*r**10+51613335724*r**12
            +88847737408*r**14+48344815867*r**16-9524590544*r**18-5344575680*r**20
            +6358196248*r**22+1416170211*r**24+62734024*r**26-6681828*r**28+202320*r**30)
            +Q2**2*(22725-394458*r**2-19036464*r**4-333142546*r**6-4731464387*r**8
            +11329414500*r**10+39243193476*r**12+81531760008*r**14+87418180647*r**16
            +11815193334*r**18-29467233480*r**20-9569789418*r**22+2537100631*r**24
            -442878976*r**26-70191372*r**28+1185780*r**30)+Q2*(30105-1195983*r**2
            +3443796*r**4+316230240*r**6+2335217069*r**8+3531551293*r**10+105777782356*r**12
            +286097476768*r**14+318643199155*r**16+69389855347*r**18-47538591716*r**20
            -5035000928*r**22+20864483311*r**24+2391149855*r**26+181089084*r**28
            +11081568*r**30-121320*r**32)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r))/(-105815808000*logq2**5*r**20*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))-2449440000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            -5103000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5+211631616000*logq2**6*r**24*sqrtq2
            +22044960000*logq2**4*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2+153090000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2+70875*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6*sqrtq2)
            +((5225472000*logq2**5*(-Q2+(-1+r)**2)*(-1+r)*r**22*(1+r)*(1+r**2)*(3
            -2*r+3*r**2)*(3+2*r+3*r**2)*(-Q2+(1+r)**2)+138240*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-2790*Q2**10+30*Q2**9*(916+799*r**2)
            -6*Q2**8*(20009+34580*r**2+14951*r**4)+12*Q2**7*(20071+58106*r**2+50519*r**4
            +13809*r**6)-Q2**6*(155967+987070*r**2+1336840*r**4+734730*r**6+124033*r**8)
            +2*Q2**5*(-89733+164654*r**2+310402*r**4+279578*r**6+133871*r**8+11648*r**10)
            +Q2**4*(338415+762300*r**2+2463671*r**4+2792480*r**6+809229*r**8-35860*r**10
            -50715*r**12)+8*Q2**3*(-14997-121975*r**2-542031*r**4-995683*r**6-669907*r**8
            -143004*r**10+16705*r**12+7592*r**14)+Q2**2*(-96507+266978*r**2+814578*r**4
            +4957738*r**6+5433840*r**8+1626502*r**10+85382*r**12-129458*r**14+44147*r**16)
            -6*Q2*(-14577-30555*r**2-377496*r**4+91380*r**6+420598*r**8-39098*r**10
            -172720*r**12+107396*r**14+3395*r**16+11677*r**18)+3*(-6483-30936*r**2
            -487021*r**4-578096*r**6-1258586*r**8+1258586*r**12+578096*r**14+487021*r**16
            +30936*r**18+6483*r**20))-96*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(13396*Q2**16-4*Q2**15*(24446+25937*r**2)+16*Q2**14*(17554+48961*r**2
            +19669*r**4)-4*Q2**13*(83784+595299*r**2+601850*r**4+135189*r**6)+Q2**12*(
            -97551+2373390*r**2+2125528*r**4+2895634*r**6+691239*r**8)+Q2**11*(780156
            +4047924*r**2+26585224*r**4+25079128*r**6+969628*r**8-676044*r**10)
            +2*Q2**10*(-390367-6241380*r**2-44235371*r**4-86365960*r**6-38186349*r**8
            -2282588*r**10+83999*r**12)+4*Q2**9*(-44207+2032777*r**2+22064273*r**4
            +97362585*r**6+88857835*r**8+19747103*r**10+194427*r**12+164623*r**14)
            +Q2**8*(949447+7852222*r**2+49328130*r**4-289515018*r**6-453398040*r**8
            -247599798*r**10-24292098*r**12+1326210*r**14-863663*r**16)+4*Q2**7*(
            -143712-3420495*r**2-44672284*r**4-91616132*r**6-216326232*r**8-221332482*r**10
            -51790940*r**12-2603604*r**14+1217648*r**16+61593*r**18)+4*Q2**6*(-63825
            +897468*r**2+27692333*r**4+216217896*r**6+650437426*r**8+1078346424*r**10
            +544609798*r**12+83048728*r**14+3814991*r**16-1336324*r**18+89325*r**20)
            -4*Q2**5*(-112530-1290951*r**2-14790176*r**4+97752675*r**6+272860776*r**8
            +1330364570*r**10+1141107524*r**12+240470534*r**14-18331110*r**16+5201341*r**18
            +410284*r**20+107463*r**22)+Q2**4*(-120161-4224534*r**2-105966596*r**4
            -388728690*r**6-2291668365*r**8+949333892*r**10+2182681648*r**12+759184572*r**14
            +175020005*r**16-66609390*r**18+28919124*r**20+3066166*r**22+161929*r**24)
            +4*Q2**3*(-20609+137731*r**2+7824130*r**4+106831006*r**6+586231785*r**8
            +991962773*r**10+1797687228*r**12+1830867940*r**14+388095473*r**16-120690835*r**18
            -50579454*r**20-4350914*r**22-90265*r**24+14011*r**26)-2*Q2**2*(-27137
            -366020*r**2-10321129*r**4+18063928*r**6-58655357*r**8+1894507724*r**10
            +2679308355*r**12+4186639248*r**14+1050722109*r**16-423577036*r**18+55085813*r**20
            -34076360*r**22+4770881*r**24+193988*r**26+34993*r**28)+12*Q2*(-521
            -36383*r**2-1349013*r**4-7410651*r**6-72566761*r**8+104709641*r**10
            -472074109*r**12+277425941*r**14+208048717*r**16+75896747*r**18-158855399*r**20
            +39783367*r**22+5260197*r**24+1150059*r**26+16889*r**28+1279*r**30)
            +3*(-409+28718*r**2+1080846*r**4+8142190*r**6+99862834*r**8+90533430*r**10
            +1890398678*r**12-1596202762*r**14+1596202762*r**18-1890398678*r**20
            -90533430*r**22-99862834*r**24-8142190*r**26-1080846*r**28-28718*r**30
            +409*r**32))-4147200*logq2**4*r**18*(140*Q2**9-20*Q2**8*(115+88*r**2)+40*Q2**7*(327
            +497*r**2+177*r**4)-2*Q2**6*(20496+43025*r**2+30370*r**4+6489*r**6)
            +4*Q2**5*(17913+48218*r**2+49630*r**4+23112*r**6+3297*r**8)-Q2**4*(58380
            +202411*r**2+279480*r**4+208630*r**6+78604*r**8+9975*r**10)-6*(-1
            +r**2)**3*(1208+3931*r**2+15964*r**4+24994*r**6+15964*r**8+3931*r**10
            +1208*r**12)+Q2**3*(-3920+68069*r**2+133929*r**4+122710*r**6+71206*r**8
            +26781*r**10+14665*r**12)+Q2**2*(45080+24739*r**2+44732*r**4+41359*r**6
            -46224*r**8-62687*r**10-21204*r**12-25795*r**14)+3*Q2*(-10536-5727*r**2
            -54817*r**4-96971*r**6-2485*r**8+93051*r**10+61397*r**12+8527*r**14
            +7561*r**16))*sqrtq2-6912*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(6870*Q2**13-2*Q2**12*(34631+31164*r**2)+Q2**11*(249264+510790*r**2
            +211346*r**4)-4*Q2**10*(93913+388761*r**2+352219*r**4+79597*r**6)+10*Q2**9*(5794
            +206525*r**2+305769*r**4+171071*r**6+19877*r**8)-5*Q2**8*(-111184+4643*r**2
            -283184*r**4-240546*r**6+74776*r**8+13023*r**10)+Q2**7*(-645496-3731799*r**2
            -17589295*r**4-28609730*r**6-14185890*r**8-1416631*r**10+101561*r**12)
            +Q2**6*(35872+4340595*r**2+24714408*r**4+67930275*r**6+59340080*r**8
            +17555457*r**10+1043560*r**12-9607*r**14)-Q2**5*(-426374+223867*r**2
            -716287*r**4+50953039*r**6+74129665*r**8+36010801*r**10+4277667*r**12
            -556987*r**14+202209*r**16)+5*Q2**4*(-57998-595035*r**2-5650538*r**4
            -4814218*r**6-4863054*r**8-2331956*r**10+152498*r**12+547362*r**14+9268*r**16
            +34231*r**18)+5*Q2**3*(-968+359313*r**2+3779721*r**4+13154588*r**6+31575660*r**8
            +39631194*r**10+17654826*r**12+580852*r**14-1292436*r**16-208859*r**18
            +1309*r**20)-Q2**2*(-86708-257077*r**2-4521320*r**4+33274825*r**6+69220640*r**8
            +178203426*r**10+112172344*r**12+11869670*r**14-11666700*r**16+1963635*r**18
            -141168*r**20+64433*r**22)+3*Q2*(-13312-175545*r**2-2851043*r**4-491835*r**6
            -25448985*r**8+14239594*r**10+19145070*r**12-6700594*r**14+3582810*r**16
            -3410865*r**18+1970293*r**20+143725*r**22+10687*r**24)-2*(-3114-63893*r**2
            -1134207*r**4-3114961*r**6-34594375*r**8-8682972*r**10-10143314*r**12
            +10143314*r**14+8682972*r**16+34594375*r**18+3114961*r**20+1134207*r**22
            +63893*r**24+3114*r**26))*sqrtq2-8*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1776*Q2**18-3468*Q2**17*(1+r**2)-6*Q2**16*(-1795-6550*r**2
            +2733*r**4)+4*Q2**15*(-20851-209509*r**2-46767*r**4+14405*r**6)+Q2**14*(211015
            +4356704*r**2+4549270*r**4+314848*r**6-45845*r**8)-Q2**13*(167133+9528313*r**2
            +25822486*r**4+11190558*r**6+137077*r**8+20673*r**10)+Q2**12*(-76606
            +5679694*r**2+56701204*r**4+54511308*r**6+15791578*r**8+352262*r**10
            -3376*r**12)+2*Q2**11*(77015+7927289*r**2-5673081*r**4+10210061*r**6
            -7082923*r**8-5550301*r**10-698451*r**12+47447*r**14)-Q2**10*(15603
            +32968736*r**2+152150948*r**4+523278936*r**6+509716234*r**8+81226928*r**10
            +696660*r**12-1079272*r**14+51915*r**16)+Q2**9*(-44055+11296537*r**2
            +224148920*r**4+991784624*r**6+2129745570*r**8+938031210*r**10+52926992*r**12
            +7140760*r**14+1034029*r**16-63435*r**18)+2*Q2**8*(24744+14336423*r**2
            -11920579*r**4-127219452*r**6-1625977708*r**8-1394805054*r**10-306353122*r**12
            +20262836*r**14-5681412*r**16-675073*r**18+24909*r**20)+8*Q2**7*(-9573
            -3839233*r**2-26255896*r**4-164488377*r**6+16778018*r**8-83378214*r**10
            -55459992*r**12-18137746*r**14+242363*r**16+2155383*r**18-42040*r**20
            +2907*r**22)+Q2**6*(13105-1566736*r**2+180005438*r**4+1526993696*r**6
            +5468875267*r**8+11317306624*r**10+11321825748*r**12+3073062496*r**14
            +467196311*r**16-63102448*r**18-5727826*r**20+747904*r**22-23819*r**24)
            -Q2**5*(-61493-17574425*r**2-4355610*r**4-43178322*r**6+5191050917*r**8
            +8424304713*r**10+23211331028*r**12+9548742788*r**14-198915307*r**16
            +221615097*r**18-39798138*r**20+13731982*r**22+48315*r**24+2455*r**26)
            +2*Q2**4*(-15855-3771683*r**2-44274320*r**4-539366586*r**6-410911425*r**8
            -5070263425*r**10+9788162226*r**12+4670294020*r**14+1457653247*r**16
            -716619525*r**18+132709500*r**20-1165898*r**22+5572785*r**24-49751*r**26
            +1890*r**28)+2*Q2**3*(-6253-1107579*r**2+24168647*r**4+264488781*r**6
            +1713703359*r**8+6820194833*r**10+1583038483*r**12+12477638121*r**14
            +7058670633*r**16-721654673*r**18-535117467*r**20-150563609*r**22-11666043*r**24
            +586491*r**26-5951*r**28+227*r**30)+Q2**2*(10283+2367888*r**2+2156464*r**4
            +181713208*r**6-1148942972*r**8+269608000*r**10-21925310128*r**12-21919755128*r**14
            -13658835246*r**16+2667949264*r**18-1597710384*r**20+1049031752*r**22
            -107923036*r**24+14773088*r**26-2947792*r**28-9224*r**30-37*r**32)-3*Q2*(135
            +145839*r**2+4082676*r**4+66081356*r**6+121908032*r**8+1760237704*r**10
            -5559059884*r**12+14568260012*r**14-9881973242*r**16-5805684834*r**18
            +5789752572*r**20-1011659964*r**22+14341528*r**24-64526864*r**26-1729348*r**28
            -171836*r**30-3941*r**32+59*r**34)+6*(-81-4463*r**2+658976*r**4+5640224*r**6
            +35588996*r**8+339087356*r**10-293278816*r**12+6023211424*r**14-12400397478*r**16
            +12400397478*r**18-6023211424*r**20+293278816*r**22-339087356*r**24-35588996*r**26
            -5640224*r**28-658976*r**30+4463*r**32+81*r**34))*sqrtq2)*math.log(mu0)*nlo.X1Q2(0,'SM',Q2,r))/(
            -10450944000*logq2**6*r**26*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-1088640000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -7560000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**4-3500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**6+120960000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+252000*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2+5225472000*logq2**5*r**22*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+((272160000*logq2**4*r**16*(9+28*r**2+34*r**4+28*r**6
            +9*r**8)+7200*logq2**2*(-Q2+(-1+r)**2)*r**8*(-Q2+(1+r)**2)*(755*Q2**10
            -6460*Q2**9*(1+r**2)+19*Q2**8*(1397+2670*r**2+1397*r**4)-2*Q2**7*(22697
            +75917*r**2+75917*r**4+22697*r**6)+Q2**6*(18389+192140*r**2+288058*r**4
            +192140*r**6+18389*r**8)+Q2**5*(33782-72026*r**2-3024*r**4-3024*r**6
            -72026*r**8+33782*r**10)-Q2**4*(39655+164510*r**2+1238017*r**4+2141020*r**6
            +1238017*r**8+164510*r**10+39655*r**12)+2*Q2**3*(3721+115075*r**2+794925*r**4
            +2094619*r**6+2094619*r**8+794925*r**10+115075*r**12+3721*r**14)+4*Q2**2*(2651
            -3949*r**2+57848*r**4-355357*r**6-683806*r**8-355357*r**10+57848*r**12
            -3949*r**14+2651*r**16)-18*Q2*(453+4355*r**2+39700*r**4-68700*r**6
            -202608*r**8-202608*r**10-68700*r**12+39700*r**14+4355*r**16+453*r**18)
            +12*(179+1333*r**2+22836*r**4+74334*r**6+510837*r**8+822162*r**10
            +510837*r**12+74334*r**14+22836*r**16+1333*r**18+179*r**20))+(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(6866*Q2**16-23436*Q2**15*(1+r**2)+8*Q2**14*(865
            +8596*r**2+865*r**4)+8*Q2**13*(5380-11099*r**2-11099*r**4+5380*r**6)
            +Q2**12*(10045-259012*r**2-2562366*r**4-259012*r**6+10045*r**8)-4*Q2**11*(34147
            -324527*r**2-3988562*r**4-3988562*r**6-324527*r**8+34147*r**10)+2*Q2**10*(35759
            -646722*r**2-15796615*r**4-38576020*r**6-15796615*r**8-646722*r**10
            +35759*r**12)+8*Q2**9*(13745-127492*r**2+2119265*r**4+19072200*r**6
            +19072200*r**8+2119265*r**10-127492*r**12+13745*r**14)+Q2**8*(-91205
            +2043184*r**2+31186064*r**4-92196960*r**6-136611350*r**8-92196960*r**10
            +31186064*r**12+2043184*r**14-91205*r**16)-4*Q2**7*(8785+21669*r**2
            +14208392*r**4+33962024*r**6+101173570*r**8+101173570*r**10+33962024*r**12
            +14208392*r**14+21669*r**16+8785*r**18)+4*Q2**6*(10807-257354*r**2+4036831*r**4
            +57257856*r**6+179616146*r**8+416911988*r**10+179616146*r**12+57257856*r**14
            +4036831*r**16-257354*r**18+10807*r**20)-8*Q2**5*(266-53737*r**2-4403625*r**4
            +12575730*r**6+21507400*r**8+309675766*r**10+309675766*r**12+21507400*r**14
            +12575730*r**16-4403625*r**18-53737*r**20+266*r**22)-Q2**4*(2005+87332*r**2
            +26936590*r**4+29645300*r**6+614859675*r**8-231352920*r**10+1158640836*r**12
            -231352920*r**14+614859675*r**16+29645300*r**18+26936590*r**20+87332*r**22
            +2005*r**24)+4*Q2**3*(135-9223*r**2-887018*r**4+22918230*r**6+168130475*r**8
            +734118485*r**10+2173168916*r**12+2173168916*r**14+734118485*r**16+168130475*r**18
            +22918230*r**20-887018*r**22-9223*r**24+135*r**26)-2*Q2**2*(1265-69094*r**2
            -3667317*r**4+24306396*r**6-83158055*r**8+480299590*r**10+308598123*r**12
            +3065234184*r**14+308598123*r**16+480299590*r**18-83158055*r**20+24306396*r**22
            -3667317*r**24-69094*r**26+1265*r**28)+24*Q2*(31-1758*r**2-54453*r**4
            -686878*r**6-12831908*r**8+1292719*r**10-99093084*r**12+519615331*r**14
            +519615331*r**16-99093084*r**18+1292719*r**20-12831908*r**22-686878*r**24
            -54453*r**26-1758*r**28+31*r**30)+3*(57-3672*r**2+19060*r**4+3841960*r**6
            +9425060*r**8+68973464*r**10+826635276*r**12-1542120*r**14+7983061830*r**16
            -1542120*r**18+826635276*r**20+68973464*r**22+9425060*r**24+3841960*r**26
            +19060*r**28-3672*r**30+57*r**32))+432000*logq2**3*r**12*(867+35*Q2**7
            +3267*r**2+42957*r**4+88989*r**6+88989*r**8+42957*r**10+3267*r**12
            +867*r**14-505*Q2**6*(1+r**2)+5*Q2**5*(445+904*r**2+445*r**4)-Q2**4*(5293
            +15125*r**2+15125*r**4+5293*r**6)-3*Q2*(1+r**2)**2*(1111-2778*r**2
            -446*r**4-2778*r**6+1111*r**8)+Q2**3*(4157+17952*r**2+28010*r**4+17952*r**6
            +4157*r**8)+Q2**2*(1847-3657*r**2-14318*r**4-14318*r**6-3657*r**8+1847*r**10))*sqrtq2
            +120*logq2*r**4*(25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(105*Q2**7-555*Q2**6*(1
            +r**2)+15*Q2**5*(19+52*r**2+19*r**4)-Q2**4*(751+5687*r**2+5687*r**4
            +751*r**6)+Q2**3*(1139+8352*r**2+14006*r**4+8352*r**6+1139*r**8)+Q2**2*(719
            +3879*r**2+4474*r**4+4474*r**6+3879*r**8+719*r**10)+Q2*(-681+2244*r**2
            +38061*r**4+66912*r**6+38061*r**8+2244*r**10-681*r**12)+3*(-87+1849*r**2
            +34455*r**4+109943*r**6+109943*r**8+34455*r**10+1849*r**12-87*r**14))
            +2*(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(971+40*Q2**9-18517*r**2-136600*r**4+561592*r**6+1104554*r**8
            +1104554*r**10+561592*r**12-136600*r**14-18517*r**16+971*r**18-889*Q2**8*(1
            +r**2)+23*Q2**7*(169+418*r**2+169*r**4)-Q2**6*(4347+16967*r**2+16967*r**4
            +4347*r**6)-2*Q2**5*(1113+3489*r**2+13232*r**4+3489*r**6+1113*r**8)
            +2*Q2**4*(2240+11225*r**2+82043*r**4+82043*r**6+11225*r**8+2240*r**10)
            +Q2**3*(1659-18836*r**2-355219*r**4-699528*r**6-355219*r**8-18836*r**10
            +1659*r**12)+Q2**2*(-2567+13091*r**2+205549*r**4+793607*r**6+793607*r**8
            +205549*r**10+13091*r**12-2567*r**14)-8*Q2*(126-2129*r**2-34216*r**4
            -21131*r**6-11300*r**8-21131*r**10-34216*r**12-2129*r**14+126*r**16)))*sqrtq2)*math.log(mus)*nlo.X1Q2(0,'SM',Q2,r))/(
            -1045094400*logq2**5*r**20-72576000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -252000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+435456000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+6048000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+4200*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +((-5225472000*logq2**5*(-Q2+(-1+r)**2)*(-1+r)*r**22*(1+r)*(1+r**2)*(3
            -2*r+3*r**2)*(3+2*r+3*r**2)*(-Q2+(1+r)**2)-138240*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(-2790*Q2**10+30*Q2**9*(916+799*r**2)
            -6*Q2**8*(20009+34580*r**2+14951*r**4)+12*Q2**7*(20071+58106*r**2+50519*r**4
            +13809*r**6)-Q2**6*(155967+987070*r**2+1336840*r**4+734730*r**6+124033*r**8)
            +2*Q2**5*(-89733+164654*r**2+310402*r**4+279578*r**6+133871*r**8+11648*r**10)
            +Q2**4*(338415+762300*r**2+2463671*r**4+2792480*r**6+809229*r**8-35860*r**10
            -50715*r**12)+8*Q2**3*(-14997-121975*r**2-542031*r**4-995683*r**6-669907*r**8
            -143004*r**10+16705*r**12+7592*r**14)+Q2**2*(-96507+266978*r**2+814578*r**4
            +4957738*r**6+5433840*r**8+1626502*r**10+85382*r**12-129458*r**14+44147*r**16)
            -6*Q2*(-14577-30555*r**2-377496*r**4+91380*r**6+420598*r**8-39098*r**10
            -172720*r**12+107396*r**14+3395*r**16+11677*r**18)+3*(-6483-30936*r**2
            -487021*r**4-578096*r**6-1258586*r**8+1258586*r**12+578096*r**14+487021*r**16
            +30936*r**18+6483*r**20))+96*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(13396*Q2**16-4*Q2**15*(24446+25937*r**2)+16*Q2**14*(17554+48961*r**2
            +19669*r**4)-4*Q2**13*(83784+595299*r**2+601850*r**4+135189*r**6)+Q2**12*(
            -97551+2373390*r**2+2125528*r**4+2895634*r**6+691239*r**8)+Q2**11*(780156
            +4047924*r**2+26585224*r**4+25079128*r**6+969628*r**8-676044*r**10)
            +2*Q2**10*(-390367-6241380*r**2-44235371*r**4-86365960*r**6-38186349*r**8
            -2282588*r**10+83999*r**12)+4*Q2**9*(-44207+2032777*r**2+22064273*r**4
            +97362585*r**6+88857835*r**8+19747103*r**10+194427*r**12+164623*r**14)
            +Q2**8*(949447+7852222*r**2+49328130*r**4-289515018*r**6-453398040*r**8
            -247599798*r**10-24292098*r**12+1326210*r**14-863663*r**16)+4*Q2**7*(
            -143712-3420495*r**2-44672284*r**4-91616132*r**6-216326232*r**8-221332482*r**10
            -51790940*r**12-2603604*r**14+1217648*r**16+61593*r**18)+4*Q2**6*(-63825
            +897468*r**2+27692333*r**4+216217896*r**6+650437426*r**8+1078346424*r**10
            +544609798*r**12+83048728*r**14+3814991*r**16-1336324*r**18+89325*r**20)
            -4*Q2**5*(-112530-1290951*r**2-14790176*r**4+97752675*r**6+272860776*r**8
            +1330364570*r**10+1141107524*r**12+240470534*r**14-18331110*r**16+5201341*r**18
            +410284*r**20+107463*r**22)+Q2**4*(-120161-4224534*r**2-105966596*r**4
            -388728690*r**6-2291668365*r**8+949333892*r**10+2182681648*r**12+759184572*r**14
            +175020005*r**16-66609390*r**18+28919124*r**20+3066166*r**22+161929*r**24)
            +4*Q2**3*(-20609+137731*r**2+7824130*r**4+106831006*r**6+586231785*r**8
            +991962773*r**10+1797687228*r**12+1830867940*r**14+388095473*r**16-120690835*r**18
            -50579454*r**20-4350914*r**22-90265*r**24+14011*r**26)-2*Q2**2*(-27137
            -366020*r**2-10321129*r**4+18063928*r**6-58655357*r**8+1894507724*r**10
            +2679308355*r**12+4186639248*r**14+1050722109*r**16-423577036*r**18+55085813*r**20
            -34076360*r**22+4770881*r**24+193988*r**26+34993*r**28)+12*Q2*(-521
            -36383*r**2-1349013*r**4-7410651*r**6-72566761*r**8+104709641*r**10
            -472074109*r**12+277425941*r**14+208048717*r**16+75896747*r**18-158855399*r**20
            +39783367*r**22+5260197*r**24+1150059*r**26+16889*r**28+1279*r**30)
            +3*(-409+28718*r**2+1080846*r**4+8142190*r**6+99862834*r**8+90533430*r**10
            +1890398678*r**12-1596202762*r**14+1596202762*r**18-1890398678*r**20
            -90533430*r**22-99862834*r**24-8142190*r**26-1080846*r**28-28718*r**30
            +409*r**32))+4147200*logq2**4*r**18*(140*Q2**9-20*Q2**8*(115+88*r**2)+40*Q2**7*(327
            +497*r**2+177*r**4)-2*Q2**6*(20496+43025*r**2+30370*r**4+6489*r**6)
            +4*Q2**5*(17913+48218*r**2+49630*r**4+23112*r**6+3297*r**8)-Q2**4*(58380
            +202411*r**2+279480*r**4+208630*r**6+78604*r**8+9975*r**10)-6*(-1
            +r**2)**3*(1208+3931*r**2+15964*r**4+24994*r**6+15964*r**8+3931*r**10
            +1208*r**12)+Q2**3*(-3920+68069*r**2+133929*r**4+122710*r**6+71206*r**8
            +26781*r**10+14665*r**12)+Q2**2*(45080+24739*r**2+44732*r**4+41359*r**6
            -46224*r**8-62687*r**10-21204*r**12-25795*r**14)+3*Q2*(-10536-5727*r**2
            -54817*r**4-96971*r**6-2485*r**8+93051*r**10+61397*r**12+8527*r**14
            +7561*r**16))*sqrtq2+6912*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(6870*Q2**13-2*Q2**12*(34631+31164*r**2)+Q2**11*(249264+510790*r**2
            +211346*r**4)-4*Q2**10*(93913+388761*r**2+352219*r**4+79597*r**6)+10*Q2**9*(5794
            +206525*r**2+305769*r**4+171071*r**6+19877*r**8)-5*Q2**8*(-111184+4643*r**2
            -283184*r**4-240546*r**6+74776*r**8+13023*r**10)+Q2**7*(-645496-3731799*r**2
            -17589295*r**4-28609730*r**6-14185890*r**8-1416631*r**10+101561*r**12)
            +Q2**6*(35872+4340595*r**2+24714408*r**4+67930275*r**6+59340080*r**8
            +17555457*r**10+1043560*r**12-9607*r**14)-Q2**5*(-426374+223867*r**2
            -716287*r**4+50953039*r**6+74129665*r**8+36010801*r**10+4277667*r**12
            -556987*r**14+202209*r**16)+5*Q2**4*(-57998-595035*r**2-5650538*r**4
            -4814218*r**6-4863054*r**8-2331956*r**10+152498*r**12+547362*r**14+9268*r**16
            +34231*r**18)+5*Q2**3*(-968+359313*r**2+3779721*r**4+13154588*r**6+31575660*r**8
            +39631194*r**10+17654826*r**12+580852*r**14-1292436*r**16-208859*r**18
            +1309*r**20)-Q2**2*(-86708-257077*r**2-4521320*r**4+33274825*r**6+69220640*r**8
            +178203426*r**10+112172344*r**12+11869670*r**14-11666700*r**16+1963635*r**18
            -141168*r**20+64433*r**22)+3*Q2*(-13312-175545*r**2-2851043*r**4-491835*r**6
            -25448985*r**8+14239594*r**10+19145070*r**12-6700594*r**14+3582810*r**16
            -3410865*r**18+1970293*r**20+143725*r**22+10687*r**24)-2*(-3114-63893*r**2
            -1134207*r**4-3114961*r**6-34594375*r**8-8682972*r**10-10143314*r**12
            +10143314*r**14+8682972*r**16+34594375*r**18+3114961*r**20+1134207*r**22
            +63893*r**24+3114*r**26))*sqrtq2+8*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**3*(1776*Q2**18-3468*Q2**17*(1+r**2)-6*Q2**16*(-1795-6550*r**2
            +2733*r**4)+4*Q2**15*(-20851-209509*r**2-46767*r**4+14405*r**6)+Q2**14*(211015
            +4356704*r**2+4549270*r**4+314848*r**6-45845*r**8)-Q2**13*(167133+9528313*r**2
            +25822486*r**4+11190558*r**6+137077*r**8+20673*r**10)+Q2**12*(-76606
            +5679694*r**2+56701204*r**4+54511308*r**6+15791578*r**8+352262*r**10
            -3376*r**12)+2*Q2**11*(77015+7927289*r**2-5673081*r**4+10210061*r**6
            -7082923*r**8-5550301*r**10-698451*r**12+47447*r**14)-Q2**10*(15603
            +32968736*r**2+152150948*r**4+523278936*r**6+509716234*r**8+81226928*r**10
            +696660*r**12-1079272*r**14+51915*r**16)+Q2**9*(-44055+11296537*r**2
            +224148920*r**4+991784624*r**6+2129745570*r**8+938031210*r**10+52926992*r**12
            +7140760*r**14+1034029*r**16-63435*r**18)+2*Q2**8*(24744+14336423*r**2
            -11920579*r**4-127219452*r**6-1625977708*r**8-1394805054*r**10-306353122*r**12
            +20262836*r**14-5681412*r**16-675073*r**18+24909*r**20)+8*Q2**7*(-9573
            -3839233*r**2-26255896*r**4-164488377*r**6+16778018*r**8-83378214*r**10
            -55459992*r**12-18137746*r**14+242363*r**16+2155383*r**18-42040*r**20
            +2907*r**22)+Q2**6*(13105-1566736*r**2+180005438*r**4+1526993696*r**6
            +5468875267*r**8+11317306624*r**10+11321825748*r**12+3073062496*r**14
            +467196311*r**16-63102448*r**18-5727826*r**20+747904*r**22-23819*r**24)
            -Q2**5*(-61493-17574425*r**2-4355610*r**4-43178322*r**6+5191050917*r**8
            +8424304713*r**10+23211331028*r**12+9548742788*r**14-198915307*r**16
            +221615097*r**18-39798138*r**20+13731982*r**22+48315*r**24+2455*r**26)
            +2*Q2**4*(-15855-3771683*r**2-44274320*r**4-539366586*r**6-410911425*r**8
            -5070263425*r**10+9788162226*r**12+4670294020*r**14+1457653247*r**16
            -716619525*r**18+132709500*r**20-1165898*r**22+5572785*r**24-49751*r**26
            +1890*r**28)+2*Q2**3*(-6253-1107579*r**2+24168647*r**4+264488781*r**6
            +1713703359*r**8+6820194833*r**10+1583038483*r**12+12477638121*r**14
            +7058670633*r**16-721654673*r**18-535117467*r**20-150563609*r**22-11666043*r**24
            +586491*r**26-5951*r**28+227*r**30)+Q2**2*(10283+2367888*r**2+2156464*r**4
            +181713208*r**6-1148942972*r**8+269608000*r**10-21925310128*r**12-21919755128*r**14
            -13658835246*r**16+2667949264*r**18-1597710384*r**20+1049031752*r**22
            -107923036*r**24+14773088*r**26-2947792*r**28-9224*r**30-37*r**32)-3*Q2*(135
            +145839*r**2+4082676*r**4+66081356*r**6+121908032*r**8+1760237704*r**10
            -5559059884*r**12+14568260012*r**14-9881973242*r**16-5805684834*r**18
            +5789752572*r**20-1011659964*r**22+14341528*r**24-64526864*r**26-1729348*r**28
            -171836*r**30-3941*r**32+59*r**34)+6*(-81-4463*r**2+658976*r**4+5640224*r**6
            +35588996*r**8+339087356*r**10-293278816*r**12+6023211424*r**14-12400397478*r**16
            +12400397478*r**18-6023211424*r**20+293278816*r**22-339087356*r**24-35588996*r**26
            -5640224*r**28-658976*r**30+4463*r**32+81*r**34))*sqrtq2)*math.log(r)*nlo.X1Q2(0,'SM',Q2,r))/(
            -10450944000*logq2**6*r**26*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-1088640000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -7560000*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**4-3500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**6+120960000*logq2**3*(-Q2+(-1+r)**2)*r**14*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+252000*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2+5225472000*logq2**5*r**22*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+((-54432000*logq2**4*r**16*(85+260*r**2+342*r**4+260*r**6
            +85*r**8)-4320*logq2**2*(-Q2+(-1+r)**2)*r**8*(-Q2+(1+r)**2)*(930*Q2**10
            -10120*Q2**9*(1+r**2)+Q2**8*(50350+97252*r**2+50350*r**4)-8*Q2**7*(10465
            +35822*r**2+35822*r**4+10465*r**6)+7*Q2**6*(1955+43828*r**2+74330*r**4
            +43828*r**6+1955*r**8)+2*Q2**5*(39585-55391*r**2-125182*r**4-125182*r**6
            -55391*r**8+39585*r**10)-Q2**4*(51205+284970*r**2+2206635*r**4+3785788*r**6
            +2206635*r**8+284970*r**10+51205*r**12)+4*Q2**3*(-2875+113477*r**2+856935*r**4
            +2179403*r**6+2179403*r**8+856935*r**10+113477*r**12-2875*r**14)+Q2**2*(15545
            -1864*r**2+528296*r**4-2253688*r**6-4811938*r**8-2253688*r**10+528296*r**12
            -1864*r**14+15545*r**16)-6*Q2*(785+30981*r**2+220680*r**4-562616*r**6
            -1857030*r**8-1857030*r**10-562616*r**12+220680*r**14+30981*r**16+785*r**18)
            +3*(525+7414*r**2+190453*r**4+1154032*r**6+6490846*r**8+10319860*r**10
            +6490846*r**12+1154032*r**14+190453*r**16+7414*r**18+525*r**20))-(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(13396*Q2**16-45560*Q2**15*(1+r**2)
            +8*Q2**14*(1619+16634*r**2+1619*r**4)+8*Q2**13*(10999-23361*r**2-23361*r**4
            +10999*r**6)-Q2**12*(4483+323404*r**2+3330474*r**4+323404*r**6+4483*r**8)
            -4*Q2**11*(51109-446231*r**2-4524602*r**4-4524602*r**6-446231*r**8+51109*r**10)
            +2*Q2**10*(38161-632142*r**2-13040913*r**4-34735092*r**6-13040913*r**8
            -632142*r**10+38161*r**12)+4*Q2**9*(50099-576931*r**2+571179*r**4+31038045*r**6
            +31038045*r**8+571179*r**10-576931*r**12+50099*r**14)+Q2**8*(-95509
            +2283056*r**2+29336036*r**4-55684464*r**6-34447710*r**8-55684464*r**10
            +29336036*r**12+2283056*r**14-95509*r**16)-32*Q2**7*(3487-50439*r**2
            +1065201*r**4+5692301*r**6+20169492*r**8+20169492*r**10+5692301*r**12
            +1065201*r**14-50439*r**16+3487*r**18)+4*Q2**6*(12421-383162*r**2+948441*r**4
            +50878016*r**6+176112338*r**8+435660276*r**10+176112338*r**12+50878016*r**14
            +948441*r**16-383162*r**18+12421*r**20)+16*Q2**5*(2371-46562*r**2+1715392*r**4
            +1222133*r**6+3434612*r**8-168476626*r**10-168476626*r**12+3434612*r**14
            +1222133*r**16+1715392*r**18-46562*r**20+2371*r**22)-3*Q2**4*(2991-117084*r**2
            +4932006*r**4+24636660*r**6+166299985*r**8-200196952*r**10+330429108*r**12
            -200196952*r**14+166299985*r**16+24636660*r**18+4932006*r**20-117084*r**22
            +2991*r**24)-12*Q2**3*(759-24661*r**2+653454*r**4-3579106*r**6-51137555*r**8
            -335493903*r**10-956242988*r**12-956242988*r**14-335493903*r**16-51137555*r**18
            -3579106*r**20+653454*r**22-24661*r**24+759*r**26)-6*Q2**2*(93-3326*r**2
            -761201*r**4+2805044*r**6-16379467*r**8+158649534*r**10-73401633*r**12
            +794412312*r**14-73401633*r**16+158649534*r**18-16379467*r**20+2805044*r**22
            -761201*r**24-3326*r**26+93*r**28)+12*Q2*(113-5473*r**2+73669*r**4
            -1404381*r**6-22296223*r**8-35615513*r**10-87432779*r**12+1707064587*r**14
            +1707064587*r**16-87432779*r**18-35615513*r**20-22296223*r**22-1404381*r**24
            +73669*r**26-5473*r**28+113*r**30)+3*(59-3688*r**2-33432*r**4+2290152*r**6
            +6168228*r**8+146295864*r**10+1035001240*r**12+2154399304*r**14+12036372546*r**16
            +2154399304*r**18+1035001240*r**20+146295864*r**22+6168228*r**24+2290152*r**26
            -33432*r**28-3688*r**30+59*r**32))-172800*logq2**3*r**12*(35*Q2**7-745*Q2**6*(1
            +r**2)+5*Q2**5*(859+1732*r**2+859*r**4)-3*Q2**4*(4915+13683*r**2+13683*r**4
            +4915*r**6)-12*Q2*(1+r**2)**2*(800-2213*r**2-1689*r**4-2213*r**6+800*r**8)
            +6*Q2**3*(2215+9326*r**2+14292*r**4+9326*r**6+2215*r**8)+6*Q2**2*(955
            -1419*r**2-6760*r**4-6760*r**6-1419*r**8+955*r**10)+12*(145+1648*r**2
            +16656*r**4+35731*r**6+35731*r**8+16656*r**10+1648*r**12+145*r**14))*sqrtq2
            +144*logq2*r**4*(-25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(-167+35*Q2**7+2809*r**2
            +57255*r**4+187063*r**6+187063*r**8+57255*r**10+2809*r**12-167*r**14
            -265*Q2**6*(1+r**2)+5*Q2**5*(31+76*r**2+31*r**4)-Q2**4*(377+2809*r**2
            +2809*r**4+377*r**6)+Q2**3*(533+3944*r**2+6682*r**4+3944*r**6+533*r**8)
            +3*Q2**2*(131+771*r**2+1226*r**4+1226*r**6+771*r**8+131*r**10)+Q2*(
            -307+1468*r**2+21167*r**4+37664*r**6+21167*r**8+1468*r**10-307*r**12))
            -(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(1139+320*Q2**9-20953*r**2-208420*r**4+437188*r**6
            +93446*r**8+93446*r**10+437188*r**12-208420*r**14-20953*r**16+1139*r**18
            -2996*Q2**8*(1+r**2)+4*Q2**7*(1817+4514*r**2+1817*r**4)-Q2**6*(3773
            +26263*r**2+26263*r**4+3773*r**6)-2*Q2**5*(3017+976*r**2+7758*r**4
            +976*r**6+3017*r**8)+Q2**4*(4585+36625*r**2+290534*r**4+290534*r**6
            +36625*r**8+4585*r**10)+8*Q2**3*(497-5613*r**2-76577*r**4-148614*r**6
            -76577*r**8-5613*r**10+497*r**12)+Q2**2*(-2763+10739*r**2+222181*r**4
            +1088643*r**6+1088643*r**8+222181*r**10+10739*r**12-2763*r**14)-2*Q2*(861
            -15824*r**2-193816*r**4+30304*r**6+256150*r**8+30304*r**10-193816*r**12
            -15824*r**14+861*r**16)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r)**2)/(20901888000*logq2**6*r**24
            +2177280000*logq2**4*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+15120000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4+7000*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**6-10450944000*logq2**5*r**20*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2-241920000*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2-504000*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**5*sqrtq2)+((290304000*logq2**4*(-Q2+(-1+r)**2)*r**18*(-58-79*r**2
            +29*r**6)*(-Q2+(1+r)**2)+23040*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-6329+3520*Q2**9-56328*r**2-1262262*r**4-2244126*r**6-5028600*r**8
            -1486026*r**10+549798*r**12+1288782*r**14+74721*r**16+5570*r**18-8*Q2**8*(4718
            +4035*r**2)+16*Q2**7*(6542+12687*r**2+5265*r**4)-Q2**6*(82957+368655*r**2
            +303487*r**4+59325*r**6)+Q2**5*(-74326+217903*r**2+295433*r**4+127429*r**6
            -4095*r**8)+Q2**4*(151025+250670*r**2+949726*r**4+642770*r**6+36845*r**8
            -42420*r**10)+2*Q2**3*(-23618-247275*r**2-1300922*r**4-1990417*r**6
            -971775*r**8-71008*r**10+27615*r**12)+Q2**2*(-44827+160433*r**2+733511*r**4
            +2925841*r**6+1890571*r**8+203743*r**10-75807*r**12+27735*r**14)+Q2*(34202
            +119815*r**2+1348683*r**4-1351915*r**6-2322875*r**8-531207*r**10-97195*r**12
            +117067*r**14-38175*r**16))-16*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(4271
            -8496*Q2**14+741678*r**2-1809847*r**4+64093636*r**6+180773407*r**8+1751974618*r**10
            -2320010991*r**12+4061132664*r**14-1548027147*r**16-146700734*r**18-86620989*r**20
            +4891588*r**22-873667*r**24-16714*r**26+227*r**28+10976*Q2**13*(1+r**2)
            +3*Q2**12*(-11001-44658*r**2+21391*r**4)+Q2**11*(208242+1827494*r**2
            +503302*r**4-143790*r**6)+4*Q2**10*(-73016-1356668*r**2-1281173*r**4
            -68646*r**6+3283*r**8)+2*Q2**9*(-43329+2800565*r**2+10106720*r**4+3407720*r**6
            -418215*r**8+72411*r**10)-Q2**8*(-311933-2761178*r**2+29952625*r**4
            +21482700*r**6+9599165*r**8+7662*r**10+3247*r**12)-4*Q2**7*(-13469+3430973*r**2
            +7090829*r**4+30184535*r**6+11040615*r**8-1540519*r**10-534047*r**12
            +37579*r**14)+8*Q2**6*(-25613+1508024*r**2+12647412*r**4+44942580*r**6
            +40491655*r**8+6252912*r**10+515424*r**12-104048*r**14+4270*r**16)+4*Q2**5*(
            -9433+726161*r**2-10771984*r**4-38599588*r**6-155698976*r**8-43567748*r**10
            +14046296*r**12-826004*r**14-340863*r**16+16379*r**18)+Q2**4*(66879
            -11113330*r**2-62618165*r**4-328725240*r**6+592484950*r**8+199273492*r**10
            +140518150*r**12-15169240*r**14+2665435*r**16+505230*r**18-15201*r**20)
            +2*Q2**3*(17533+2668823*r**2+25466175*r**4+185877325*r**6+179477110*r**8
            +893169154*r**10+480526354*r**12-7579210*r**14-25298675*r**16-3073305*r**18
            +212143*r**20-7427*r**22)+4*Q2**2*(-4162+395004*r**2+2289817*r**4-1537090*r**6
            -197301775*r**8-313265136*r**10-152370098*r**12+35960156*r**14-17908620*r**16
            -338860*r**18-17287*r**20-14266*r**22+317*r**24)+2*Q2*(-5869-1215543*r**2
            -5547624*r**4-63642600*r**6+166142655*r**8-738403587*r**10+1055601136*r**12
            +559967408*r**14-335521815*r**16+10723595*r**18+3336056*r**20+1778232*r**22
            -28859*r**24+815*r**26))+1382400*logq2**3*r**14*(320*Q2**8-80*Q2**7*(32
            +25*r**2)+16*Q2**6*(728+1003*r**2+399*r**4)-Q2**5*(26383+56416*r**2
            +44747*r**4+12754*r**6)+Q2**4*(25865+74064*r**2+90634*r**4+55752*r**6
            +13125*r**8)-2*Q2**3*(455+15783*r**2+24936*r**4+20022*r**6+10029*r**8
            +3535*r**10)+2*Q2**2*(-9275-4513*r**2-20672*r**4-6456*r**6+15035*r**8
            +7121*r**10+3640*r**12)+(-1+r**2)**2*(-3187-13764*r**2-62435*r**4-38740*r**6
            +15195*r**8+8552*r**10+3659*r**12)+Q2*(13757+16286*r**2+152639*r**4
            +218740*r**6+48395*r**8-58082*r**10-19911*r**12-8944*r**14))*sqrtq2
            +384*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-8457+17408*Q2**12
            -46186*r**2-1620872*r**4-13367410*r**6-131025145*r**8-31071516*r**10
            -168493568*r**12-116254156*r**14+117405885*r**16+16036870*r**18+1853448*r**20
            -14146*r**22+13253*r**24-16*Q2**11*(5281+5441*r**2)+16*Q2**10*(8443
            +25109*r**2+8038*r**4)-5*Q2**9*(4997+167344*r**2+158617*r**4+20310*r**6)
            +5*Q2**8*(-32973+40992*r**2-206722*r**4+61672*r**6+46359*r**8)+2*Q2**7*(94182
            +1127595*r**2+6830890*r**4+6644950*r**6+747260*r**8-164613*r**10)-2*Q2**6*(23954
            +1512399*r**2+10915745*r**4+21015140*r**6+8225350*r**8+473109*r**10
            +2639*r**12)+2*Q2**5*(-39903-135429*r**2+201557*r**4+23202915*r**6+18593845*r**8
            +908357*r**10-791399*r**12+139857*r**14)-10*Q2**4*(-11181-256437*r**2
            -2549201*r**4+242153*r**6-415787*r**8+193109*r**10+543853*r**12+6599*r**14
            +12300*r**16)-10*Q2**3*(5106+102291*r**2+1788334*r**4+5700924*r**6+18540042*r**8
            +19298474*r**10+4490962*r**12-714316*r**14-182364*r**16+2547*r**18)
            +2*Q2**2*(-10786-251645*r**2-2166715*r**4+20919110*r**6+50394770*r**8
            +85373312*r**10+16475180*r**12-4828150*r**14+1889600*r**16+23565*r**18
            +13759*r**20)-Q2*(-30479-365554*r**2-7810315*r**4+1248300*r**6-95942850*r**8
            +137813268*r**10+128618838*r**12+28144440*r**14-33252975*r**16+4257950*r**18
            +588661*r**20+26716*r**22))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(2612736000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+181440000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+630000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-15120000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            -10500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
            -1088640000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC**2*(145152000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(174+395*r**2+316*r**4+87*r**6)*(-Q2+(1+r)**2)
            -11520*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-9365-3920*Q2**9
            +17244*r**2-1156182*r**4-9021438*r**6-31087104*r**8-27544530*r**10-6227514*r**12
            +1394862*r**14+148293*r**16+2534*r**18+8*Q2**8*(3020+3703*r**2)-16*Q2**7*(5730
            +12317*r**2+7007*r**4)+Q2**6*(111965+380127*r**2+445295*r**4+135597*r**6)
            +Q2**5*(10990-149769*r**2-419503*r**4-240243*r**6+81221*r**8)+Q2**4*(
            -59955+315630*r**2+1565810*r**4+1258854*r**6+101805*r**8-253400*r**10)
            +2*Q2**3*(-9380-149007*r**2-174560*r**4-11353*r**6+154587*r**8+27260*r**10
            +41853*r**12)+Q2**2*(16555-282113*r**2-2142823*r**4-3795861*r**6-4831131*r**8
            -2672591*r**10-518353*r**12+89117*r**14)-Q2*(-20010-184343*r**2+477365*r**4
            +6900603*r**6+9446875*r**8+6079895*r**10+1923243*r**12-181595*r**14
            +52367*r**16))+8*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(908+17760*Q2**15
            -45501*r**2+213722*r**4+10517117*r**6-26015776*r**8+317064099*r**10
            +2567764502*r**12+4644475701*r**14+11025619356*r**16-732237263*r**18
            -10410042*r**20-176730401*r**22+17218552*r**24-1401623*r**26-66486*r**28
            +1135*r**30-144*Q2**14*(386+445*r**2)+32*Q2**13*(367+5517*r**2+710*r**4)
            +Q2**12*(89672-212691*r**2-313662*r**4+153845*r**6)-2*Q2**11*(-13480
            +184431*r**2+1456717*r**4+36901*r**6+58415*r**8)-4*Q2**10*(55473-432961*r**2
            -3889268*r**4-3964763*r**6-437331*r**8+52190*r**10)+2*Q2**9*(28544-549105*r**2
            -10718395*r**4-28991520*r**6-10111240*r**8-923991*r**10+100955*r**12)
            +Q2**8*(169932-1686703*r**2+6805350*r**4+95555875*r**6+104025800*r**8
            -5554993*r**10-2006298*r**12+166685*r**14)-4*Q2**7*(10656-301573*r**2
            -3331451*r**4+6171845*r**6+917415*r**8+10121631*r**10-8302943*r**12
            -822151*r**14+48235*r**16)-8*Q2**6*(11625-157188*r**2+3162864*r**4+14300972*r**6
            +48496860*r**8+52947785*r**10+20695472*r**12+4155464*r**14-78753*r**16
            +7355*r**18)+4*Q2**5*(4056-140617*r**2+2325489*r**4+10986464*r**6+13678468*r**8
            +118757536*r**10+8710308*r**12+35804744*r**14+773324*r**16-472047*r**18
            +20435*r**20)+Q2**4*(30496-592385*r**2+17493790*r**4+18154715*r**6+94618200*r**8
            -759061882*r**10-1152273340*r**12+563861590*r**14+65603640*r**16+31272555*r**18
            -154034*r**20+15295*r**22)-2*Q2**3*(88+2283*r**2+5622585*r**4-35306775*r**6
            -120539685*r**8-295128326*r**10-246891426*r**12-596177570*r**14+72916850*r**16
            +15458075*r**18+11364713*r**20-192327*r**22+7515*r**24)-4*Q2**2*(1637
            -53531*r**2+1067548*r**4+2752735*r**6-23605445*r**8-268898034*r**10
            -617073568*r**12-777968606*r**14-502159965*r**16-7233915*r**18+5381412*r**20
            +1479839*r**22-43427*r**24+1320*r**26)+2*Q2*(-480+24579*r**2+1380873*r**4
            -23318536*r**6-1040360*r**8+224876495*r**10+1245944477*r**12+2099993904*r**14
            +2544315472*r**16-276787975*r**18+73325835*r**20-14434856*r**22+4374648*r**24
            +1589*r**26+335*r**28))-691200*logq2**3*r**14*(80*Q2**8-80*Q2**7*(15+8*r**2)
            +16*Q2**6*(511+627*r**2+182*r**4)-Q2**5*(13881+23918*r**2+12249*r**4
            +252*r**6)-Q2**4*(-175+17072*r**2+41794*r**4+35384*r**6+12565*r**8)
            +4*Q2**3*(4655+4447*r**2+5591*r**4+8048*r**6+7324*r**8+3115*r**10)
            +2*Q2**2*(-8890+3469*r**2-54945*r**4-75604*r**6-19238*r**8+15103*r**10
            +4025*r**12)+(-1+r**2)**2*(-1299-34612*r**2-251395*r**4-348660*r**6
            -173765*r**8-12296*r**10+5547*r**12)+Q2*(7109+38886*r**2+574967*r**4
            +1231980*r**6+1061635*r**8+364246*r**10+2689*r**12-15592*r**14))*sqrtq2
            +192*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-10727+16528*Q2**12
            +287514*r**2+690568*r**4+2689570*r**6+185502185*r**8+620374204*r**10
            +1516442112*r**12+705556844*r**14-62928845*r**16-26714710*r**18-2783752*r**20
            +255474*r**22-32437*r**24-32*Q2**11*(5703+5623*r**2)+16*Q2**10*(30058
            +72319*r**2+30463*r**4)-5*Q2**9*(74765+477462*r**2+486189*r**4+59452*r**6)
            -5*Q2**8*(39861-436832*r**2-812998*r**4-416152*r**6+119193*r**8)+2*Q2**7*(210117
            +519360*r**2+4264000*r**4+4449940*r**6+899695*r**8+468912*r**10)-2*Q2**6*(80199
            +2119719*r**2+11827750*r**4+24142640*r**6+14518145*r**8+3159009*r**10
            +101514*r**12)-4*Q2**5*(18594-367108*r**2-250256*r**4-6830060*r**6-9134595*r**8
            +103144*r**10-695093*r**12+108474*r**14)+10*Q2**4*(17040+170511*r**2
            +485807*r**4-4477019*r**6-12608933*r**8-4526063*r**10+3578861*r**12
            +433547*r**14+40521*r**16)-10*Q2**3*(11137-1884*r**2-1371106*r**4-3813608*r**6
            -3897236*r**8-4655668*r**10-2603646*r**12+1131544*r**14+282771*r**16
            +13696*r**18)+Q2**2*(-20562-579570*r**2+341600*r**4+55786100*r**6+209780360*r**8
            +329466584*r**10+277619540*r**12+107280620*r**14-7771030*r**16-1129990*r**18
            -69652*r**20)+Q2*(44969-473626*r**2-7596275*r**4+9512100*r**6+144042510*r**8
            +542566692*r**10+533372262*r**12+268129800*r**14-24989175*r**16+4471990*r**18
            +480589*r**20+102164*r**22))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(2612736000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+181440000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+630000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-15120000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            -10500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
            -1088640000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC*(1161216000*logq2**4*(
            -Q2+(-1+r)**2)*r**18*(174+395*r**2+316*r**4+87*r**6)*(-Q2+(1+r)**2)
            -92160*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-9365-3920*Q2**9
            +17244*r**2-1156182*r**4-9021438*r**6-31087104*r**8-27544530*r**10-6227514*r**12
            +1394862*r**14+148293*r**16+2534*r**18+8*Q2**8*(3020+3703*r**2)-16*Q2**7*(5730
            +12317*r**2+7007*r**4)+Q2**6*(111965+380127*r**2+445295*r**4+135597*r**6)
            +Q2**5*(10990-149769*r**2-419503*r**4-240243*r**6+81221*r**8)+Q2**4*(
            -59955+315630*r**2+1565810*r**4+1258854*r**6+101805*r**8-253400*r**10)
            +2*Q2**3*(-9380-149007*r**2-174560*r**4-11353*r**6+154587*r**8+27260*r**10
            +41853*r**12)+Q2**2*(16555-282113*r**2-2142823*r**4-3795861*r**6-4831131*r**8
            -2672591*r**10-518353*r**12+89117*r**14)-Q2*(-20010-184343*r**2+477365*r**4
            +6900603*r**6+9446875*r**8+6079895*r**10+1923243*r**12-181595*r**14
            +52367*r**16))+64*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(908+17760*Q2**15
            -45501*r**2+213722*r**4+10517117*r**6-26015776*r**8+317064099*r**10
            +2567764502*r**12+4644475701*r**14+11025619356*r**16-732237263*r**18
            -10410042*r**20-176730401*r**22+17218552*r**24-1401623*r**26-66486*r**28
            +1135*r**30-144*Q2**14*(386+445*r**2)+32*Q2**13*(367+5517*r**2+710*r**4)
            +Q2**12*(89672-212691*r**2-313662*r**4+153845*r**6)-2*Q2**11*(-13480
            +184431*r**2+1456717*r**4+36901*r**6+58415*r**8)-4*Q2**10*(55473-432961*r**2
            -3889268*r**4-3964763*r**6-437331*r**8+52190*r**10)+2*Q2**9*(28544-549105*r**2
            -10718395*r**4-28991520*r**6-10111240*r**8-923991*r**10+100955*r**12)
            +Q2**8*(169932-1686703*r**2+6805350*r**4+95555875*r**6+104025800*r**8
            -5554993*r**10-2006298*r**12+166685*r**14)-4*Q2**7*(10656-301573*r**2
            -3331451*r**4+6171845*r**6+917415*r**8+10121631*r**10-8302943*r**12
            -822151*r**14+48235*r**16)-8*Q2**6*(11625-157188*r**2+3162864*r**4+14300972*r**6
            +48496860*r**8+52947785*r**10+20695472*r**12+4155464*r**14-78753*r**16
            +7355*r**18)+4*Q2**5*(4056-140617*r**2+2325489*r**4+10986464*r**6+13678468*r**8
            +118757536*r**10+8710308*r**12+35804744*r**14+773324*r**16-472047*r**18
            +20435*r**20)+Q2**4*(30496-592385*r**2+17493790*r**4+18154715*r**6+94618200*r**8
            -759061882*r**10-1152273340*r**12+563861590*r**14+65603640*r**16+31272555*r**18
            -154034*r**20+15295*r**22)-2*Q2**3*(88+2283*r**2+5622585*r**4-35306775*r**6
            -120539685*r**8-295128326*r**10-246891426*r**12-596177570*r**14+72916850*r**16
            +15458075*r**18+11364713*r**20-192327*r**22+7515*r**24)-4*Q2**2*(1637
            -53531*r**2+1067548*r**4+2752735*r**6-23605445*r**8-268898034*r**10
            -617073568*r**12-777968606*r**14-502159965*r**16-7233915*r**18+5381412*r**20
            +1479839*r**22-43427*r**24+1320*r**26)+2*Q2*(-480+24579*r**2+1380873*r**4
            -23318536*r**6-1040360*r**8+224876495*r**10+1245944477*r**12+2099993904*r**14
            +2544315472*r**16-276787975*r**18+73325835*r**20-14434856*r**22+4374648*r**24
            +1589*r**26+335*r**28))-5529600*logq2**3*r**14*(80*Q2**8-80*Q2**7*(15+8*r**2)
            +16*Q2**6*(511+627*r**2+182*r**4)-Q2**5*(13881+23918*r**2+12249*r**4
            +252*r**6)-Q2**4*(-175+17072*r**2+41794*r**4+35384*r**6+12565*r**8)
            +4*Q2**3*(4655+4447*r**2+5591*r**4+8048*r**6+7324*r**8+3115*r**10)
            +2*Q2**2*(-8890+3469*r**2-54945*r**4-75604*r**6-19238*r**8+15103*r**10
            +4025*r**12)+(-1+r**2)**2*(-1299-34612*r**2-251395*r**4-348660*r**6
            -173765*r**8-12296*r**10+5547*r**12)+Q2*(7109+38886*r**2+574967*r**4
            +1231980*r**6+1061635*r**8+364246*r**10+2689*r**12-15592*r**14))*sqrtq2
            +1536*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-10727+16528*Q2**12
            +287514*r**2+690568*r**4+2689570*r**6+185502185*r**8+620374204*r**10
            +1516442112*r**12+705556844*r**14-62928845*r**16-26714710*r**18-2783752*r**20
            +255474*r**22-32437*r**24-32*Q2**11*(5703+5623*r**2)+16*Q2**10*(30058
            +72319*r**2+30463*r**4)-5*Q2**9*(74765+477462*r**2+486189*r**4+59452*r**6)
            -5*Q2**8*(39861-436832*r**2-812998*r**4-416152*r**6+119193*r**8)+2*Q2**7*(210117
            +519360*r**2+4264000*r**4+4449940*r**6+899695*r**8+468912*r**10)-2*Q2**6*(80199
            +2119719*r**2+11827750*r**4+24142640*r**6+14518145*r**8+3159009*r**10
            +101514*r**12)-4*Q2**5*(18594-367108*r**2-250256*r**4-6830060*r**6-9134595*r**8
            +103144*r**10-695093*r**12+108474*r**14)+10*Q2**4*(17040+170511*r**2
            +485807*r**4-4477019*r**6-12608933*r**8-4526063*r**10+3578861*r**12
            +433547*r**14+40521*r**16)-10*Q2**3*(11137-1884*r**2-1371106*r**4-3813608*r**6
            -3897236*r**8-4655668*r**10-2603646*r**12+1131544*r**14+282771*r**16
            +13696*r**18)+Q2**2*(-20562-579570*r**2+341600*r**4+55786100*r**6+209780360*r**8
            +329466584*r**10+277619540*r**12+107280620*r**14-7771030*r**16-1129990*r**18
            -69652*r**20)+Q2*(44969-473626*r**2-7596275*r**4+9512100*r**6+144042510*r**8
            +542566692*r**10+533372262*r**12+268129800*r**14-24989175*r**16+4471990*r**18
            +480589*r**20+102164*r**22))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(7838208000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+544320000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+1890000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-45360000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            -31500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
            -3265920000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(flagPERP*muWC**3*(
            -172800*logq2**3*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(-1442+7134*r**2
            -720*Q2**6*r**2+84890*r**4-404018*r**6-657838*r**8-299046*r**10+918*r**12
            +26202*r**14+80*Q2**5*(7+33*r**2+54*r**4)-16*Q2**4*(322+409*r**2+1314*r**4
            +1053*r**6)+Q2**3*(3878+38179*r**2+101957*r**4+114753*r**6+40377*r**8)
            -2*Q2**2*(-2009+16516*r**2+57826*r**4+98304*r**6+67143*r**8+8844*r**10)
            -Q2*(1862-4943*r**2+69723*r**4+66722*r**6+14292*r**8+23901*r**10+35643*r**12))
            -48*logq2*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(-101808*Q2**12*r**2
            +112*Q2**11*(-235+7788*r**2+7083*r**4)-32*Q2**10*(-3290+64939*r**2+164807*r**4
            +58359*r**6)+5*Q2**9*(-22190+222497*r**2+2320343*r**4+2296843*r**6+193347*r**8)
            +10*Q2**8*(-9135+163233*r**2-720222*r**4-1417474*r**6-877659*r**8+228249*r**10)
            -4*Q2**7*(-68250+246021*r**2+3084900*r**4+18420635*r**6+15563945*r**8
            +2880180*r**10+844641*r**12)+4*Q2**6*(-37590-454398*r**2+5093337*r**4
            +45300410*r**6+86340760*r**8+39146690*r**10+7131117*r**12+188202*r**14)
            +2*Q2**5*(-53130+526743*r**2+754419*r**4-18016617*r**6-192068745*r**8
            -200917545*r**10-7679297*r**12-4115181*r**14+770553*r**16)-20*Q2**4*(
            -9135-47187*r**2+539247*r**4+5701500*r**6-2653947*r**8-25664174*r**10
            -10768931*r**12+8782852*r**14+1008462*r**16+77553*r**18)+20*Q2**3*(-3570
            -26649*r**2-259614*r**4+437919*r**6+11230809*r**8+31457783*r**10+16570635*r**12
            +7067945*r**14+4640257*r**16+573402*r**18+28203*r**20)+4*Q2**2*(-8750
            -41502*r**2+1121175*r**4+7467970*r**6-75715320*r**8-378526980*r**10
            -578662466*r**12-287322900*r**14-122658570*r**16+8108370*r**18+1160955*r**20
            +68418*r**22)-Q2*(-41930-19061*r**2-3554431*r**4+2529925*r**6+169628365*r**8
            +522616090*r**10+462227662*r**12+188564902*r**14+945678100*r**16-90172965*r**18
            +37538865*r**20+2366549*r**22+397929*r**24)+2*(-5635+23581*r**2-761732*r**4
            -5251094*r**6-9261095*r**8-124733085*r**10+108127848*r**12-1593100436*r**14
            -959820297*r**16+281437795*r**18+59019420*r**20+6831146*r**22-327757*r**24
            +61341*r**26))+36288000*logq2**4*r**14*(-132+235*r**2+753*r**4+537*r**6
            +87*r**8)*sqrtq2-2880*logq2**2*r**6*(-22320*Q2**11*r**2+8*Q2**10*(308+29919*r**2
            +30843*r**4)-80*Q2**9*(-98+13657*r**2+26728*r**4+13461*r**6)+10*Q2**8*(
            -6531+226762*r**2+692076*r**4+692166*r**6+215847*r**8)-5*Q2**7*(-19992
            +381695*r**2+1833212*r**4+2916826*r**6+1938612*r**8+299007*r**10)-5*Q2**6*(
            -4032+68383*r**2-662395*r**4-2197288*r**6-2369744*r**8-997311*r**10
            +298179*r**12)+Q2**5*(-171528+1616041*r**2+3353352*r**4+8406375*r**6
            +12388600*r**8+6034527*r**10+1691256*r**12+3286017*r**14)-5*Q2**4*(-24612
            +110483*r**2+773417*r**4+6918843*r**6+17413577*r**8+16947389*r**10+6194119*r**12
            +964677*r**14+319419*r**16)+5*Q2**3*(4872-113389*r**2+359068*r**4+6222044*r**6
            +15034340*r**8+22482482*r**10+16773124*r**12+4389692*r**14+1036788*r**16
            -134109*r**18)+(-1+r**2)**2*(-2086-70565*r**2-228515*r**4-395120*r**6
            +2803540*r**8-53507918*r**10-56937050*r**12-12004400*r**14+7806130*r**16
            +621395*r**18+26589*r**20)+5*Q2**2*(-12432+71435*r**2-123183*r**4-693750*r**6
            +6511046*r**8+508632*r**10-2690928*r**12+172406*r**14+4000170*r**16
            -473763*r**18+189567*r**20)-5*Q2*(-4648-14167*r**2-49720*r**4+388973*r**6
            +2158784*r**8-23789134*r**10-42851296*r**12-26341726*r**14-4523224*r**16
            +5339685*r**18+113496*r**20+62577*r**22))*sqrtq2+2*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(252*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(-3+5*Q2**3
            +5*r**2-19*r**4+5*r**6-5*Q2**2*(1+r**2)+Q2*(-5+8*r**2-5*r**4))*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**3-300*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*(-115+200*Q2**6-4126*r**2+5499*r**4+16524*r**6-2201*r**8
            -486*r**10+25*r**12-150*Q2**5*(1+r**2)-6*Q2**4*(25-54*r**2+25*r**4)
            +Q2**3*(-115+309*r**2-111*r**4+25*r**6)+Q2**2*(-115-6*r**2+886*r**4
            -286*r**6+25*r**8)+Q2*(-115-1111*r**2+3466*r**4+666*r**6-411*r**8
            +25*r**10))-5*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(519+106368*Q2**12+148978*r**2
            -4355210*r**4-24654366*r**6-108019519*r**8-235022020*r**10-941645676*r**12
            -863776228*r**14+108485801*r**16+31887954*r**18+2573686*r**20-175742*r**22
            +4623*r**24-277896*Q2**11*(1+r**2)-8*Q2**10*(4479-91666*r**2+4479*r**4)
            +Q2**9*(365397-618385*r**2-1095889*r**4+524565*r**6)-3*Q2**8*(-63085
            +430316*r**2+2402130*r**4+280236*r**6+11955*r**8)-6*Q2**7*(49398-547333*r**2
            -2558841*r**4-2427681*r**6-657433*r**8+89226*r**10)-6*Q2**6*(46522-241527*r**2
            -2535242*r**4+832310*r**6-2751022*r**8-64631*r**10+518*r**12)+6*Q2**5*(11133
            -466166*r**2-2062990*r**4-1474713*r**6+3860227*r**8-3348834*r**10-827386*r**12
            +58089*r**14)+2*Q2**4*(86469-908955*r**2-9548664*r**4+22830555*r**6
            +81844082*r**8+21835107*r**10-9867120*r**12-272883*r**14+17505*r**16)
            -2*Q2**3*(-28290+191331*r**2+5569971*r**4+27883653*r**6+28438603*r**8
            +35798803*r**10+48342933*r**12-5978685*r**14-1498689*r**16+64530*r**18)
            -6*Q2**2*(6870-128157*r**2-441202*r**4+17509512*r**6+67670800*r**8+58934266*r**10
            +72682440*r**12+15281320*r**14-670134*r**16-91437*r**18+3802*r**20)
            +Q2*(-27387+800389*r**2+592821*r**4-60039771*r**6-278740498*r**8+37997982*r**10
            -501811218*r**12-250631746*r**14+37212621*r**16-1936227*r**18-711395*r**20
            +20829*r**22)))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(2449440000*logq2**4*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+34020000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +23625*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-5878656000*logq2**5*r**20*sqrtq2
            -408240000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-1417500*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+(muWC**3*(345600*logq2**3*r**8*(-480*Q2**8*(2
            +5*r**4)+40*Q2**7*(213+262*r**2+501*r**4+480*r**6)-64*Q2**6*(693+1573*r**2
            +2359*r**4+2781*r**6+1365*r**8)+Q2**5*(101262+315639*r**2+505388*r**4
            +676170*r**6+626694*r**8+235935*r**10)-Q2**4*(90930+334451*r**2+551531*r**4
            +799778*r**6+1113412*r**8+939675*r**10+308175*r**12)+2*Q2**3*(-3150
            +51997*r**2+138424*r**4+226273*r**6+363050*r**8+356399*r**10+180060*r**12
            +41475*r**14)+(-1+r**2)**2*(7398+21041*r**2+486885*r**4+1920961*r**6
            +2605841*r**8+1393483*r**10-87465*r**12+54531*r**14+61965*r**16)+Q2**2*(65100
            -20466*r**2+94786*r**4+806438*r**6+871178*r**8+212426*r**10-382122*r**12
            +292290*r**14+215250*r**16)-Q2*(39738-19231*r**2+946756*r**4+4840976*r**6
            +8924832*r**8+8305234*r**10+2977548*r**12-486744*r**14+112086*r**16
            +217365*r**18))-96*logq2*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(96*Q2**14*(544
            +2665*r**4)-8*Q2**13*(39807+28292*r**2+217755*r**4+293970*r**6)+16*Q2**12*(45474
            +62931*r**2+221709*r**4+816365*r**6+504765*r**8)-Q2**11*(617226+2096929*r**2
            -38396*r**4+22280166*r**6+38792690*r**8+12128985*r**10)+Q2**10*(-293166
            +2723019*r**2-20123161*r**4-7764606*r**6+29785004*r**8+54768835*r**10
            +3097515*r**12)+Q2**9*(962202-874675*r**2+77839440*r**4+160722295*r**6
            +257637250*r**8+194450667*r**10-9882700*r**12+15432945*r**14)-Q2**8*(586938
            +4055583*r**2+144258675*r**4+452104935*r**6+912621655*r**8+1320971413*r**10
            +779063473*r**12+99031845*r**14+21353355*r**16)+2*Q2**7*(-44034+2820099*r**2
            +48371556*r**4+313993110*r**6+752075160*r**8+1291836526*r**10+1219162924*r**12
            +449314966*r**14+74176410*r**16+3649635*r**18)+2*Q2**6*(151626-86241*r**2
            +38363139*r**4-222014394*r**6-437362010*r**8-1160045694*r**10-1587527526*r**12
            -938029506*r**14+101755996*r**16-17495685*r**18+4215735*r**20)-2*Q2**5*(124434
            +1837179*r**2+88535844*r**4+11520729*r**6+961781904*r**8+1571848344*r**10
            +1276891544*r**12+375322624*r**14-85043146*r**16+605588429*r**18+48476460*r**20
            +5739015*r**22)+2*Q2**4*(70662+610625*r**2+50820885*r**4+195436665*r**6
            +1638055475*r**8+2968116696*r**10+3648913600*r**12+5291934920*r**14+3624517010*r**16
            +798186175*r**18+397059267*r**20+37407975*r**22+2694045*r**24)+Q2**3*(6894
            +932619*r**2+16714140*r**4-336862430*r**6-353775870*r**8-1756982163*r**10
            -2833285128*r**12-4782688100*r**14-5039507710*r**16-4222764955*r**18
            -2273719956*r**20+74039234*r**22+6826510*r**24+830115*r**26)-(-1+r**2)**2*(8466
            -104857*r**2+4851571*r**4+16902610*r**6+161192920*r**8-383465687*r**10
            +7718379369*r**12+15438437148*r**14+64272730*r**16-1455722055*r**18+1381820821*r**20
            +288472338*r**22+38861756*r**24-1473865*r**26+270735*r**28)-Q2**2*(77766
            +199769*r**2+52849181*r**4-94582890*r**6+1841018160*r**8-3136935337*r**10
            -5481562913*r**12-9222243932*r**14-12962315170*r**16+741484855*r**18
            +5513164571*r**20-866987706*r**22+321554476*r**24+18917785*r**26+2657385*r**28)
            +Q2*(45474-345639*r**2+27608176*r**4+8302179*r**6+1043983710*r**8-3282048363*r**10
            +14661390668*r**12+45602522583*r**14+38099197022*r**16-2931233845*r**18
            -5993433576*r**20+5317028521*r**22+357653666*r**24+178246599*r**26+470060*r**28
            +1428765*r**30))+145152000*logq2**4*r**12*(186+693*r**2+1211*r**4+1335*r**6
            +423*r**8)*sqrtq2+5760*logq2**2*r**4*(-480*Q2**11*(22+115*r**4)+16*Q2**10*(8628
            +9167*r**2+34971*r**4+39240*r**6)-80*Q2**9*(6741+13643*r**2+33869*r**4
            +56729*r**6+33810*r**8)+5*Q2**8*(178434+553905*r**2+1366138*r**4+2657472*r**6
            +2687964*r**8+1061415*r**10)-10*Q2**7*(43884+330966*r**2+864317*r**4
            +2039408*r**6+2578498*r**8+1729314*r**10+357885*r**12)-10*Q2**6*(61992
            -172200*r**2+198592*r**4-395785*r**6-1279132*r**8-1433162*r**10-710892*r**12
            +363195*r**14)+2*Q2**5*(506772+390978*r**2+13367449*r**4+29722020*r**6
            +39240285*r**8+38355082*r**10+20007723*r**12+3270624*r**14+3921435*r**16)
            -10*Q2**4*(41742+225771*r**2+3200972*r**4+8047679*r**6+11084616*r**8
            +16422017*r**10+17914040*r**12+9338593*r**14+1317078*r**16+379620*r**18)
            -10*Q2**3*(19332-159630*r**2-213557*r**4-2686996*r**6-5035892*r**8-8618108*r**10
            -11855378*r**12-8303812*r**14-4421744*r**16-1179678*r**18+157095*r**20)
            +(-1+r**2)**2*(15858+61813*r**2+2699894*r**4-1824355*r**6+87141416*r**8
            +279304046*r**10+203954072*r**12-3252994*r**14-6580570*r**16+18612509*r**18
            +1613746*r**20+72165*r**22)+10*Q2**2*(26544-24444*r**2+1857668*r**4
            -2095953*r**6-3411012*r**8-3093784*r**10-10487700*r**12-11582946*r**14
            +3767300*r**16+5762028*r**18-337056*r**20+225435*r**22)-10*Q2*(10572
            +14330*r**2+1202597*r**4-2289280*r**6+16184963*r**8+72528128*r**10+98149814*r**12
            +50281964*r**14-6837034*r**16-3168442*r**18+6318501*r**20+254292*r**22
            +76635*r**24))*sqrtq2+(-2016*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**3*(5*Q2**5-Q2**4*(7+15*r**2)
            +2*Q2**3*(4+2*r**2+5*r**4)+(-1+r**2)**2*(17+r**2-11*r**4+5*r**6)
            +2*Q2**2*(7-6*r**2-4*r**4+5*r**6)-Q2*(37+20*r**2+8*r**4-32*r**6
            +15*r**8))+40*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(118368*Q2**14-144*Q2**13*(2511
            +3803*r**2)+16*Q2**12*(21333+74330*r**2+43833*r**4)+Q2**11*(346965-1379861*r**2
            -1898657*r**4+367833*r**6)-Q2**10*(1169835+999944*r**2+5534286*r**4
            -1524544*r**6+1317327*r**8)+Q2**9*(-325083+4329653*r**2+22754680*r**4
            +30957388*r**6+3108635*r**8+164439*r**10)+3*Q2**8*(1157087-2118238*r**2
            -8437489*r**4-8727132*r**6-6648027*r**8-2544694*r**10+380413*r**12)
            -6*Q2**7*(393093-572153*r**2-1516277*r**4-7232623*r**6+966293*r**8+8639551*r**10
            -21085*r**12+51601*r**14)-2*Q2**6*(957471-5816724*r**2-8909442*r**4
            -9130428*r**6-48140918*r**8+6857076*r**10-22409394*r**12-4272852*r**14
            +325083*r**16)+2*Q2**5*(1180749-5335383*r**2+61840392*r**4+51488388*r**6
            -110150612*r**8-209983568*r**10-40599288*r**12+22285812*r**14-833529*r**16
            +89727*r**18)+2*Q2**4*(-152955-4234734*r**2-110129295*r**4-124115796*r**6
            -195008960*r**8-376420404*r**10-148469336*r**12+62312460*r**14-24039309*r**16
            -2669430*r**18+126159*r**20)+Q2**3*(-260727+4848271*r**2+21725067*r**4
            +193300149*r**6+681115494*r**8+222073946*r**10+674502146*r**12+892924878*r**14
            +104590161*r**16-2324649*r**18+1171891*r**20-55107*r**22)+Q2**2*(228105
            +3563792*r**2+99103490*r**4-392865768*r**6-413748173*r**8-1057652048*r**10
            -406280052*r**12+759843712*r**14+324166063*r**16-118256832*r**18+12406898*r**20
            +1721960*r**22-58347*r**24)+(-1+r**2)**2*(102537-1994696*r**2+24377488*r**4
            +187096596*r**6+1252743257*r**8+193943024*r**10-249357024*r**12-452012296*r**14
            +195095219*r**16+35390808*r**18+2647504*r**20-211340*r**22+6123*r**24)
            +Q2*(-273423+1624793*r**2-70347312*r**4-123275452*r**6-2963286875*r**8
            -3363568839*r**10+187222624*r**12+1500207544*r**14+821134179*r**16-697362365*r**18
            -36052528*r**20-7073532*r**22-264697*r**24+7083*r**26)))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r))/(7348320000*logq2**4*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+102060000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +70875*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-17635968000*logq2**5*r**20*sqrtq2
            -1224720000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-4252500*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+((145152000*logq2**4*(-Q2+(-1+r)**2)*r**18*(
            -58-79*r**2+29*r**6)*(-Q2+(1+r)**2)+11520*logq2**2*r**10*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(-6329+3520*Q2**9-56328*r**2-1262262*r**4
            -2244126*r**6-5028600*r**8-1486026*r**10+549798*r**12+1288782*r**14
            +74721*r**16+5570*r**18-8*Q2**8*(4718+4035*r**2)+16*Q2**7*(6542+12687*r**2
            +5265*r**4)-Q2**6*(82957+368655*r**2+303487*r**4+59325*r**6)+Q2**5*(
            -74326+217903*r**2+295433*r**4+127429*r**6-4095*r**8)+Q2**4*(151025
            +250670*r**2+949726*r**4+642770*r**6+36845*r**8-42420*r**10)+2*Q2**3*(
            -23618-247275*r**2-1300922*r**4-1990417*r**6-971775*r**8-71008*r**10
            +27615*r**12)+Q2**2*(-44827+160433*r**2+733511*r**4+2925841*r**6+1890571*r**8
            +203743*r**10-75807*r**12+27735*r**14)+Q2*(34202+119815*r**2+1348683*r**4
            -1351915*r**6-2322875*r**8-531207*r**10-97195*r**12+117067*r**14-38175*r**16))
            -8*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(4271-8496*Q2**14+741678*r**2
            -1809847*r**4+64093636*r**6+180773407*r**8+1751974618*r**10-2320010991*r**12
            +4061132664*r**14-1548027147*r**16-146700734*r**18-86620989*r**20+4891588*r**22
            -873667*r**24-16714*r**26+227*r**28+10976*Q2**13*(1+r**2)+3*Q2**12*(
            -11001-44658*r**2+21391*r**4)+Q2**11*(208242+1827494*r**2+503302*r**4
            -143790*r**6)+4*Q2**10*(-73016-1356668*r**2-1281173*r**4-68646*r**6
            +3283*r**8)+2*Q2**9*(-43329+2800565*r**2+10106720*r**4+3407720*r**6
            -418215*r**8+72411*r**10)-Q2**8*(-311933-2761178*r**2+29952625*r**4
            +21482700*r**6+9599165*r**8+7662*r**10+3247*r**12)-4*Q2**7*(-13469+3430973*r**2
            +7090829*r**4+30184535*r**6+11040615*r**8-1540519*r**10-534047*r**12
            +37579*r**14)+8*Q2**6*(-25613+1508024*r**2+12647412*r**4+44942580*r**6
            +40491655*r**8+6252912*r**10+515424*r**12-104048*r**14+4270*r**16)+4*Q2**5*(
            -9433+726161*r**2-10771984*r**4-38599588*r**6-155698976*r**8-43567748*r**10
            +14046296*r**12-826004*r**14-340863*r**16+16379*r**18)+Q2**4*(66879
            -11113330*r**2-62618165*r**4-328725240*r**6+592484950*r**8+199273492*r**10
            +140518150*r**12-15169240*r**14+2665435*r**16+505230*r**18-15201*r**20)
            +2*Q2**3*(17533+2668823*r**2+25466175*r**4+185877325*r**6+179477110*r**8
            +893169154*r**10+480526354*r**12-7579210*r**14-25298675*r**16-3073305*r**18
            +212143*r**20-7427*r**22)+4*Q2**2*(-4162+395004*r**2+2289817*r**4-1537090*r**6
            -197301775*r**8-313265136*r**10-152370098*r**12+35960156*r**14-17908620*r**16
            -338860*r**18-17287*r**20-14266*r**22+317*r**24)+2*Q2*(-5869-1215543*r**2
            -5547624*r**4-63642600*r**6+166142655*r**8-738403587*r**10+1055601136*r**12
            +559967408*r**14-335521815*r**16+10723595*r**18+3336056*r**20+1778232*r**22
            -28859*r**24+815*r**26))+691200*logq2**3*r**14*(320*Q2**8-80*Q2**7*(32
            +25*r**2)+16*Q2**6*(728+1003*r**2+399*r**4)-Q2**5*(26383+56416*r**2
            +44747*r**4+12754*r**6)+Q2**4*(25865+74064*r**2+90634*r**4+55752*r**6
            +13125*r**8)-2*Q2**3*(455+15783*r**2+24936*r**4+20022*r**6+10029*r**8
            +3535*r**10)+2*Q2**2*(-9275-4513*r**2-20672*r**4-6456*r**6+15035*r**8
            +7121*r**10+3640*r**12)+(-1+r**2)**2*(-3187-13764*r**2-62435*r**4-38740*r**6
            +15195*r**8+8552*r**10+3659*r**12)+Q2*(13757+16286*r**2+152639*r**4
            +218740*r**6+48395*r**8-58082*r**10-19911*r**12-8944*r**14))*sqrtq2
            +192*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-8457+17408*Q2**12
            -46186*r**2-1620872*r**4-13367410*r**6-131025145*r**8-31071516*r**10
            -168493568*r**12-116254156*r**14+117405885*r**16+16036870*r**18+1853448*r**20
            -14146*r**22+13253*r**24-16*Q2**11*(5281+5441*r**2)+16*Q2**10*(8443
            +25109*r**2+8038*r**4)-5*Q2**9*(4997+167344*r**2+158617*r**4+20310*r**6)
            +5*Q2**8*(-32973+40992*r**2-206722*r**4+61672*r**6+46359*r**8)+2*Q2**7*(94182
            +1127595*r**2+6830890*r**4+6644950*r**6+747260*r**8-164613*r**10)-2*Q2**6*(23954
            +1512399*r**2+10915745*r**4+21015140*r**6+8225350*r**8+473109*r**10
            +2639*r**12)+2*Q2**5*(-39903-135429*r**2+201557*r**4+23202915*r**6+18593845*r**8
            +908357*r**10-791399*r**12+139857*r**14)-10*Q2**4*(-11181-256437*r**2
            -2549201*r**4+242153*r**6-415787*r**8+193109*r**10+543853*r**12+6599*r**14
            +12300*r**16)-10*Q2**3*(5106+102291*r**2+1788334*r**4+5700924*r**6+18540042*r**8
            +19298474*r**10+4490962*r**12-714316*r**14-182364*r**16+2547*r**18)
            +2*Q2**2*(-10786-251645*r**2-2166715*r**4+20919110*r**6+50394770*r**8
            +85373312*r**10+16475180*r**12-4828150*r**14+1889600*r**16+23565*r**18
            +13759*r**20)-Q2*(-30479-365554*r**2-7810315*r**4+1248300*r**6-95942850*r**8
            +137813268*r**10+128618838*r**12+28144440*r**14-33252975*r**16+4257950*r**18
            +588661*r**20+26716*r**22))*sqrtq2)*math.log(mu0)*nlo.X1Q2(1,'SM',Q2,r))/(870912000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+60480000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+210000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-5040000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            -3500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
            -362880000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((1512000*logq2**3*r**12*(1
            +r**2)*(29+50*r**2+29*r**4)+60*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1
            +r)**2)*(1873-640*Q2**9-8851*r**2+85460*r**4+1289996*r**6+6796322*r**8
            +6796322*r**10+1289996*r**12+85460*r**14-8851*r**16+1873*r**18+8848*Q2**8*(1
            +r**2)-32*Q2**7*(617+1454*r**2+617*r**4)+Q2**6*(8169+72819*r**2+72819*r**4
            +8169*r**6)+2*Q2**5*(6881-28372*r**2-46826*r**4-28372*r**6+6881*r**8)
            -Q2**4*(13825+65585*r**2+481262*r**4+481262*r**6+65585*r**8+13825*r**10)
            +4*Q2**3*(903+32098*r**2+185817*r**4+339964*r**6+185817*r**8+32098*r**10
            +903*r**12)+Q2**2*(1879+11233*r**2+272487*r**4-159599*r**6-159599*r**8
            +272487*r**10+11233*r**12+1879*r**14)-2*Q2*(1967+21792*r**2+88088*r**4
            -781552*r**6-1382190*r**8-781552*r**10+88088*r**12+21792*r**14+1967*r**16))
            +3600*logq2**2*r**8*(71-160*Q2**6+6084*r**2+70785*r**4+118280*r**6+70785*r**8
            +6084*r**10+71*r**12+960*Q2**5*(1+r**2)-288*Q2**4*(13+24*r**2+13*r**4)
            +Q2**3*(3221+9879*r**2+9879*r**4+3221*r**6)+3*Q2**2*(607-396*r**2-982*r**4
            -396*r**6+607*r**8)-3*Q2*(723-2099*r**2-6184*r**4-6184*r**6-2099*r**8
            +723*r**10))*sqrtq2+(-500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2
            -1133*r**4-2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(
            -6+4*r**2-6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2
            -118*r**4-26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6-31*r**8
            +r**10))+7*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*(13+8*Q2**8-444*r**2-9976*r**4+31692*r**6
            -28170*r**8+31692*r**10-9976*r**12-444*r**14+13*r**16-24*Q2**7*(1+r**2)
            +Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61-193*r**2-193*r**4+61*r**6)
            +Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6-165*r**8)+4*Q2**3*(13-355*r**2
            -6138*r**4-6138*r**6-355*r**8+13*r**10)+Q2**2*(59-406*r**2+10313*r**4
            +35188*r**6+10313*r**8-406*r**10+59*r**12)-2*Q2*(27-595*r**2-7237*r**4
            +6605*r**6+6605*r**8-7237*r**10-595*r**12+27*r**14)))*sqrtq2)*math.log(mus)*nlo.X1Q2(1,'SM',Q2,r))/(8709120*logq2**4*r**16
            +362880*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+420*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-2903040*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-20160*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((-145152000*logq2**4*(-Q2+(-1+r)**2)*r**18*(-58-79*r**2+29*r**6)*(
            -Q2+(1+r)**2)-11520*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -6329+3520*Q2**9-56328*r**2-1262262*r**4-2244126*r**6-5028600*r**8
            -1486026*r**10+549798*r**12+1288782*r**14+74721*r**16+5570*r**18-8*Q2**8*(4718
            +4035*r**2)+16*Q2**7*(6542+12687*r**2+5265*r**4)-Q2**6*(82957+368655*r**2
            +303487*r**4+59325*r**6)+Q2**5*(-74326+217903*r**2+295433*r**4+127429*r**6
            -4095*r**8)+Q2**4*(151025+250670*r**2+949726*r**4+642770*r**6+36845*r**8
            -42420*r**10)+2*Q2**3*(-23618-247275*r**2-1300922*r**4-1990417*r**6
            -971775*r**8-71008*r**10+27615*r**12)+Q2**2*(-44827+160433*r**2+733511*r**4
            +2925841*r**6+1890571*r**8+203743*r**10-75807*r**12+27735*r**14)+Q2*(34202
            +119815*r**2+1348683*r**4-1351915*r**6-2322875*r**8-531207*r**10-97195*r**12
            +117067*r**14-38175*r**16))+8*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(4271
            -8496*Q2**14+741678*r**2-1809847*r**4+64093636*r**6+180773407*r**8+1751974618*r**10
            -2320010991*r**12+4061132664*r**14-1548027147*r**16-146700734*r**18-86620989*r**20
            +4891588*r**22-873667*r**24-16714*r**26+227*r**28+10976*Q2**13*(1+r**2)
            +3*Q2**12*(-11001-44658*r**2+21391*r**4)+Q2**11*(208242+1827494*r**2
            +503302*r**4-143790*r**6)+4*Q2**10*(-73016-1356668*r**2-1281173*r**4
            -68646*r**6+3283*r**8)+2*Q2**9*(-43329+2800565*r**2+10106720*r**4+3407720*r**6
            -418215*r**8+72411*r**10)-Q2**8*(-311933-2761178*r**2+29952625*r**4
            +21482700*r**6+9599165*r**8+7662*r**10+3247*r**12)-4*Q2**7*(-13469+3430973*r**2
            +7090829*r**4+30184535*r**6+11040615*r**8-1540519*r**10-534047*r**12
            +37579*r**14)+8*Q2**6*(-25613+1508024*r**2+12647412*r**4+44942580*r**6
            +40491655*r**8+6252912*r**10+515424*r**12-104048*r**14+4270*r**16)+4*Q2**5*(
            -9433+726161*r**2-10771984*r**4-38599588*r**6-155698976*r**8-43567748*r**10
            +14046296*r**12-826004*r**14-340863*r**16+16379*r**18)+Q2**4*(66879
            -11113330*r**2-62618165*r**4-328725240*r**6+592484950*r**8+199273492*r**10
            +140518150*r**12-15169240*r**14+2665435*r**16+505230*r**18-15201*r**20)
            +2*Q2**3*(17533+2668823*r**2+25466175*r**4+185877325*r**6+179477110*r**8
            +893169154*r**10+480526354*r**12-7579210*r**14-25298675*r**16-3073305*r**18
            +212143*r**20-7427*r**22)+4*Q2**2*(-4162+395004*r**2+2289817*r**4-1537090*r**6
            -197301775*r**8-313265136*r**10-152370098*r**12+35960156*r**14-17908620*r**16
            -338860*r**18-17287*r**20-14266*r**22+317*r**24)+2*Q2*(-5869-1215543*r**2
            -5547624*r**4-63642600*r**6+166142655*r**8-738403587*r**10+1055601136*r**12
            +559967408*r**14-335521815*r**16+10723595*r**18+3336056*r**20+1778232*r**22
            -28859*r**24+815*r**26))-691200*logq2**3*r**14*(320*Q2**8-80*Q2**7*(32
            +25*r**2)+16*Q2**6*(728+1003*r**2+399*r**4)-Q2**5*(26383+56416*r**2
            +44747*r**4+12754*r**6)+Q2**4*(25865+74064*r**2+90634*r**4+55752*r**6
            +13125*r**8)-2*Q2**3*(455+15783*r**2+24936*r**4+20022*r**6+10029*r**8
            +3535*r**10)+2*Q2**2*(-9275-4513*r**2-20672*r**4-6456*r**6+15035*r**8
            +7121*r**10+3640*r**12)+(-1+r**2)**2*(-3187-13764*r**2-62435*r**4-38740*r**6
            +15195*r**8+8552*r**10+3659*r**12)+Q2*(13757+16286*r**2+152639*r**4
            +218740*r**6+48395*r**8-58082*r**10-19911*r**12-8944*r**14))*sqrtq2
            -192*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(-8457+17408*Q2**12
            -46186*r**2-1620872*r**4-13367410*r**6-131025145*r**8-31071516*r**10
            -168493568*r**12-116254156*r**14+117405885*r**16+16036870*r**18+1853448*r**20
            -14146*r**22+13253*r**24-16*Q2**11*(5281+5441*r**2)+16*Q2**10*(8443
            +25109*r**2+8038*r**4)-5*Q2**9*(4997+167344*r**2+158617*r**4+20310*r**6)
            +5*Q2**8*(-32973+40992*r**2-206722*r**4+61672*r**6+46359*r**8)+2*Q2**7*(94182
            +1127595*r**2+6830890*r**4+6644950*r**6+747260*r**8-164613*r**10)-2*Q2**6*(23954
            +1512399*r**2+10915745*r**4+21015140*r**6+8225350*r**8+473109*r**10
            +2639*r**12)+2*Q2**5*(-39903-135429*r**2+201557*r**4+23202915*r**6+18593845*r**8
            +908357*r**10-791399*r**12+139857*r**14)-10*Q2**4*(-11181-256437*r**2
            -2549201*r**4+242153*r**6-415787*r**8+193109*r**10+543853*r**12+6599*r**14
            +12300*r**16)-10*Q2**3*(5106+102291*r**2+1788334*r**4+5700924*r**6+18540042*r**8
            +19298474*r**10+4490962*r**12-714316*r**14-182364*r**16+2547*r**18)
            +2*Q2**2*(-10786-251645*r**2-2166715*r**4+20919110*r**6+50394770*r**8
            +85373312*r**10+16475180*r**12-4828150*r**14+1889600*r**16+23565*r**18
            +13759*r**20)-Q2*(-30479-365554*r**2-7810315*r**4+1248300*r**6-95942850*r**8
            +137813268*r**10+128618838*r**12+28144440*r**14-33252975*r**16+4257950*r**18
            +588661*r**20+26716*r**22))*sqrtq2)*math.log(r)*nlo.X1Q2(1,'SM',Q2,r))/(870912000*logq2**5*r**22*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+60480000*logq2**3*(-Q2+(-1+r)**2)*r**14*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+210000*logq2*(-Q2+(
            -1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-5040000*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2
            -3500*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2
            -362880000*logq2**4*r**18*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((-3024000*logq2**3*r**12*(1
            +r**2)*(37+58*r**2+37*r**4)-600*logq2*(-Q2+(-1+r)**2)*r**4*(-Q2+(1
            +r)**2)*(181-176*Q2**9-1639*r**2+25388*r**4+324980*r**6+1646930*r**8
            +1646930*r**10+324980*r**12+25388*r**14-1639*r**16+181*r**18+2072*Q2**8*(1
            +r**2)-4*Q2**7*(985+2314*r**2+985*r**4)+Q2**6*(245+11351*r**2+11351*r**4
            +245*r**6)+2*Q2**5*(1897-4800*r**2-9682*r**4-4800*r**6+1897*r**8)-Q2**4*(1309
            +12029*r**2+106278*r**4+106278*r**6+12029*r**8+1309*r**10)-8*Q2**3*(119
            -3343*r**2-22587*r**4-41354*r**6-22587*r**8-3343*r**10+119*r**12)+Q2**2*(155
            +3637*r**2+57411*r**4-50115*r**6-50115*r**8+57411*r**10+3637*r**12
            +155*r**14)-2*Q2*(35+5640*r**2+22232*r**4-182584*r**6-355926*r**8
            -182584*r**10+22232*r**12+5640*r**14+35*r**16))+7200*logq2**2*r**8*(17
            +80*Q2**6-8796*r**2-85929*r**4-143224*r**6-85929*r**8-8796*r**10+17*r**12
            -690*Q2**5*(1+r**2)+4*Q2**4*(993+1858*r**2+993*r**4)-Q2**3*(3763+12041*r**2
            +12041*r**4+3763*r**6)+Q2**2*(-2013+1420*r**2+4882*r**4+1420*r**6-2013*r**8)
            +3*Q2*(799-2215*r**2-7824*r**4-7824*r**6-2215*r**8+799*r**10))*sqrtq2
            +(500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4
            -2708*r**6-1133*r**8-34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2
            -6*r**4)+Q2**3*(1-19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4
            -26*r**6+r**8)+Q2*(1-31*r**2-390*r**4-390*r**6-31*r**8+r**10))+42*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))*(-1+14*Q2**8+48*r**2+2512*r**4-2064*r**6+27810*r**8-2064*r**10
            +2512*r**12+48*r**14-r**16-22*Q2**7*(1+r**2)+Q2**6*(-13+30*r**2-13*r**4)
            +6*Q2**5*(1-3*r**2-3*r**4+r**6)+Q2**4*(55-440*r**2-3406*r**4-440*r**6
            +55*r**8)+Q2**3*(-34+610*r**2+7344*r**4+7344*r**6+610*r**8-34*r**10)
            -Q2**2*(23-202*r**2+1421*r**4+8236*r**6+1421*r**8-202*r**10+23*r**12)
            +2*Q2*(9-205*r**2-1699*r**4+4295*r**6+4295*r**8-1699*r**10-205*r**12
            +9*r**14)))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r)*nlo.X1Q2(1,'SM',Q2,r))/(-217728000*logq2**5*r**20
            -15120000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-52500*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4+90720000*logq2**4*r**16*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+1260000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+875*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +((-3600*logq2**2*r**8*(57+98*r**2+57*r**4)-(Q2-(-1+r)**2)*(Q2-(1
            +r)**2)*(41+376*Q2**8-1068*r**2+10408*r**4+108924*r**6+526590*r**8
            +108924*r**10+10408*r**12-1068*r**14+41*r**16-648*Q2**7*(1+r**2)+Q2**6*(
            -367+770*r**2-367*r**4)+Q2**5*(754-2362*r**2-2362*r**4+754*r**6)+Q2**4*(495
            -3160*r**2-31054*r**4-3160*r**6+495*r**8)+Q2**3*(-556+7540*r**2+53496*r**4
            +53496*r**6+7540*r**8-556*r**10)+Q2**2*(-257+2818*r**2+17461*r**4-21724*r**6
            +17461*r**8+2818*r**10-257*r**12)+2*Q2*(81-1945*r**2-4591*r**4+70055*r**6
            +70055*r**8-4591*r**10-1945*r**12+81*r**14))+120*logq2*r**4*(17-20*Q2**5
            -701*r**2-5676*r**4-5676*r**6-701*r**8+17*r**10+232*Q2**4*(1+r**2)
            -Q2**3*(233+546*r**2+233*r**4)+Q2**2*(-133+145*r**2+145*r**4-133*r**6)
            +Q2*(137-570*r**2-1254*r**4-570*r**6+137*r**8))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r)**2)/(1036800*logq2**4*r**16
            +43200*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+50*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-345600*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-2400*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +(flagPERP*muWC**3*(-2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(69+120*Q2**7+439*r**2
            +2841*r**4-6469*r**6+38051*r**8-9423*r**10-1073*r**12+45*r**14-225*Q2**6*(1
            +r**2)-8*Q2**5*(15-62*r**2+15*r**4)+3*Q2**4*(13+87*r**2-249*r**4+125*r**6)
            -4*Q2**3*(-126+445*r**2+2836*r**4+193*r**6)+Q2**2*(-171+1157*r**2+15410*r**4
            +13442*r**6+1853*r**8-195*r**10)+4*Q2*(-54+393*r**2+2366*r**4-3538*r**6
            +2756*r**8+117*r**10))-1440*logq2**2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1
            +r)**2)*(-16*Q2**4*(4+15*r**2+27*r**4)+Q2**3*(-64+2261*r**2+4458*r**4
            +2133*r**6)-Q2**2*(-176+1681*r**2+6451*r**4+6483*r**6+1377*r**8)-3*Q2*(
            -32+367*r**2+846*r**4+14*r**6+206*r**8+639*r**10)+3*(-48+187*r**2
            +473*r**4-6852*r**6-6052*r**8-479*r**10+531*r**12))+259200*logq2**3*r**10*(1
            +r**2)*(-8+33*r**2+9*r**4)*sqrtq2+logq2*(24*(-Q2+(-1+r)**2)*r**4*(
            -Q2+(1+r)**2)*(-633-168*Q2**4+382*r**2-6098*r**4-3458*r**6+1287*r**8
            +1497*Q2**3*(1+r**2)-Q2**2*(1203+3062*r**2+1203*r**4)+Q2*(-1173+223*r**2
            +943*r**4-1413*r**6))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))
            -480*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(8*Q2**4*(2+21*r**2+27*r**4)-7*Q2**3*(2
            +23*r**2+48*r**4+27*r**6)+Q2**2*(-14-143*r**2+79*r**4+147*r**6-189*r**8)
            +3*Q2*(2-61*r**2+34*r**4-66*r**6-136*r**8+27*r**10)+3*(2-67*r**2
            -255*r**4-60*r**6-630*r**8-217*r**10+27*r**12)))*sqrtq2)*nlo.X1Q2(2,'SM',Q2,r))/(
            -1555200*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-10800*logq2*r**4*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+4665600*logq2**4*r**16*sqrtq2+194400*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2+225*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +((-12441600*logq2**3*(-Q2+(-1+r)**2)*r**14*(1+r**2)*(-Q2+(1+r)**2)
            -1152*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(64*Q2**8-192*Q2**7*(1
            +r**2)+Q2**6*(87+345*r**2+2*r**4)+2*Q2**5*(113-239*r**2-209*r**4+63*r**6)
            +Q2**4*(-195-355*r**2-2311*r**4-285*r**6+330*r**8)-4*Q2**3*(21-380*r**2
            -2556*r**4-2761*r**6-455*r**8+71*r**10)+Q2**2*(97-393*r**2-3716*r**4
            -6846*r**6+729*r**8+587*r**10-178*r**12)+6*Q2*(3-115*r**2-753*r**4
            +1895*r**6+2385*r**8+327*r**10-155*r**12+13*r**14)+3*(-7+81*r**2
            +2379*r**4+4877*r**6+12045*r**8+5127*r**10-2611*r**12-309*r**14+18*r**16))
            +69120*logq2**2*r**10*(8*Q2**6*(4+3*r**2)-Q2**5*(122+221*r**2+99*r**4)
            +2*Q2**4*(75+178*r**2+171*r**4+60*r**6)-Q2**3*(20+169*r**2+217*r**4
            +113*r**6+45*r**8)+3*(-1+r**2)**2*(-6-53*r**2-208*r**4-108*r**6+2*r**8
            +13*r**10)+Q2**2*(-100-89*r**2-360*r**4-8*r**6+152*r**8+45*r**10)
            -6*Q2*(-13-37*r**2-263*r**4-343*r**6-98*r**8+20*r**10+14*r**12))*sqrtq2
            +96*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*(-3*Q2**8+5*Q2**7*(1+r**2)+14*Q2**6*(-1-2*r**2
            +r**4)+Q2**5*(57+379*r**2+121*r**4-41*r**6)+2*Q2**4*(-40-407*r**2
            -325*r**4-85*r**6+15*r**8)+Q2**3*(23+431*r**2+314*r**4+238*r**6+15*r**8
            +3*r**10)+(-1+r**2)**2*(3+268*r**2-141*r**4+884*r**6-271*r**8-24*r**10
            +r**12)-2*Q2**2*(-15-218*r**2+73*r**4+58*r**6+257*r**8-40*r**10+5*r**12)
            +Q2*(-21-671*r**2+381*r**4-2193*r**6-1163*r**8+783*r**10+3*r**12
            +r**14))*sqrtq2)/(-2073600*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))
            -86400*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2-100*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4+4800*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+691200*logq2**3*r**14*(Q2**5-3*Q2**4*(1
            +r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)
            +2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)
            +(muWC*(16588800*logq2**3*(-Q2+(-1+r)**2)*r**14*(1+r**2)*(3+2*r**2)*(
            -Q2+(1+r)**2)+7680*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(64*Q2**7*(1
            +r**2)-Q2**6*(103+223*r**2+120*r**4)+Q2**5*(-44+40*r**2+52*r**4-64*r**6)
            +4*Q2**3*(10+2*r**2-425*r**4-384*r**6+17*r**8)+Q2**4*(95-311*r**2
            -1159*r**4-297*r**6+200*r**8)+Q2**2*(-49+623*r**2+3810*r**4+6402*r**6
            +4699*r**8+819*r**10-104*r**12)-12*Q2*(1-2*r**2-204*r**4-618*r**6
            -667*r**8-312*r**10+2*r**12)+3*(3-75*r**2+383*r**4+4977*r**6+12045*r**8
            +5027*r**10-615*r**12-153*r**14+8*r**16))-92160*logq2**2*r**10*(8*Q2**6*(3
            +2*r**2)+Q2**5*(6+35*r**2+29*r**4)-Q2**4*(165+573*r**2+587*r**4+195*r**6)
            +Q2**3*(195+347*r**2+385*r**4+403*r**6+170*r**8)+3*(-1+r**2)**2*(8
            -155*r**2-840*r**4-740*r**6-100*r**8+27*r**10)+Q2**2*(-15-8*r**2-1246*r**4
            -894*r**6+233*r**8+130*r**10)+Q2*(-69+696*r**2+6045*r**4+9750*r**6
            +5055*r**8+354*r**10-231*r**12))*sqrtq2-128*(Q2-(-1+r)**2)*r**2*(Q2
            -(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(8*Q2**9
            -Q2**8*(28+31*r**2)+5*Q2**7*(5+11*r**2+6*r**4)+2*Q2**6*(6-25*r**2
            -32*r**4+13*r**6)+Q2**5*(-17+43*r**2-223*r**4+107*r**6-58*r**8)+2*Q2**4*(
            -9+55*r**2+643*r**4+725*r**6+10*r**8+6*r**10)-10*Q2**2*r**2*(-3+26*r**2
            -7*r**4-10*r**6+121*r**8-8*r**10+r**12)+Q2**3*(23-219*r**2-952*r**4
            -1026*r**6-1145*r**8-227*r**10+26*r**12)+(-1+r**2)**2*(2-39*r**2+262*r**4
            +1345*r**6+2370*r**8-277*r**10-66*r**12+3*r**14)-Q2*(7-105*r**2+159*r**4
            +3649*r**6+6915*r**8+5193*r**10-1295*r**12-129*r**14+6*r**16))*sqrtq2))/(
            -2073600*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))-86400*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -100*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4
            +4800*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**3*sqrtq2+691200*logq2**3*r**14*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC**2*(6220800*logq2**3*(
            -Q2+(-1+r)**2)*r**14*(1+r**2)*(3+2*r**2)*(-Q2+(1+r)**2)+2880*logq2*r**6*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(64*Q2**7*(1+r**2)-Q2**6*(103+223*r**2
            +120*r**4)+Q2**5*(-44+40*r**2+52*r**4-64*r**6)+4*Q2**3*(10+2*r**2
            -425*r**4-384*r**6+17*r**8)+Q2**4*(95-311*r**2-1159*r**4-297*r**6
            +200*r**8)+Q2**2*(-49+623*r**2+3810*r**4+6402*r**6+4699*r**8+819*r**10
            -104*r**12)-12*Q2*(1-2*r**2-204*r**4-618*r**6-667*r**8-312*r**10
            +2*r**12)+3*(3-75*r**2+383*r**4+4977*r**6+12045*r**8+5027*r**10-615*r**12
            -153*r**14+8*r**16))-34560*logq2**2*r**10*(8*Q2**6*(3+2*r**2)+Q2**5*(6
            +35*r**2+29*r**4)-Q2**4*(165+573*r**2+587*r**4+195*r**6)+Q2**3*(195
            +347*r**2+385*r**4+403*r**6+170*r**8)+3*(-1+r**2)**2*(8-155*r**2-840*r**4
            -740*r**6-100*r**8+27*r**10)+Q2**2*(-15-8*r**2-1246*r**4-894*r**6
            +233*r**8+130*r**10)+Q2*(-69+696*r**2+6045*r**4+9750*r**6+5055*r**8
            +354*r**10-231*r**12))*sqrtq2-48*(Q2-(-1+r)**2)*r**2*(Q2-(1+r)**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(8*Q2**9-Q2**8*(28+31*r**2)
            +5*Q2**7*(5+11*r**2+6*r**4)+2*Q2**6*(6-25*r**2-32*r**4+13*r**6)+Q2**5*(
            -17+43*r**2-223*r**4+107*r**6-58*r**8)+2*Q2**4*(-9+55*r**2+643*r**4
            +725*r**6+10*r**8+6*r**10)-10*Q2**2*r**2*(-3+26*r**2-7*r**4-10*r**6
            +121*r**8-8*r**10+r**12)+Q2**3*(23-219*r**2-952*r**4-1026*r**6-1145*r**8
            -227*r**10+26*r**12)+(-1+r**2)**2*(2-39*r**2+262*r**4+1345*r**6+2370*r**8
            -277*r**10-66*r**12+3*r**14)-Q2*(7-105*r**2+159*r**4+3649*r**6+6915*r**8
            +5193*r**10-1295*r**12-129*r**14+6*r**16))*sqrtq2))/(-2073600*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-86400*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-100*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+4800*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+691200*logq2**3*r**14*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC**3*(8*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(120*Q2**9-3*Q2**8*(83
            +155*r**2)+Q2**7*(282+604*r**2+450*r**4)+Q2**6*(480-266*r**2-692*r**4
            +390*r**6)-6*Q2**5*(654+355*r**2+2249*r**4+53*r**6+145*r**8)+4*Q2**4*(1680
            +439*r**2+4230*r**4+10305*r**6+895*r**8+45*r**10)+2*Q2**3*(-1263+242*r**2
            -9397*r**4-4722*r**6-12775*r**8-2248*r**10+195*r**12)-6*Q2**2*(662
            -1893*r**2+2656*r**4-5041*r**6-3990*r**8+4597*r**10+24*r**12+25*r**14)
            +(-1+r**2)**2*(-1251+8491*r**2-52611*r**4-24181*r**6+28379*r**8-10995*r**10
            -1157*r**12+45*r**14)+Q2*(4320-22334*r**2+97590*r**4+124782*r**6+54682*r**8
            -82818*r**10+34026*r**12+2962*r**14-90*r**16))+5760*logq2**2*r**4*(-16*Q2**6*(21
            +28*r**2+60*r**4+45*r**6)+Q2**5*(1146+2404*r**2+4513*r**4+7350*r**6
            +4095*r**8)-Q2**4*(1170+2418*r**2+4699*r**4+11625*r**6+15855*r**8+7425*r**10)
            +2*Q2**3*(-30+386*r**2+1564*r**4+4048*r**6+5345*r**8+4020*r**10+1575*r**12)
            +3*(-1+r**2)**2*(18+162*r**2+4357*r**4+12887*r**6+9462*r**8-826*r**10
            -5*r**12+585*r**14)+2*Q2**2*(390-644*r**2+3161*r**4+8010*r**6+2453*r**8
            -4205*r**10+1680*r**12+2475*r**14)-3*Q2*(138-200*r**2+9379*r**4+33374*r**6
            +45019*r**8+20636*r**10-3191*r**12-530*r**14+1935*r**16))+1036800*logq2**3*r**8*(1
            +r**2)*(15+29*r**2+30*r**4)*sqrtq2+96*logq2*(192*Q2**10*(3+10*r**4)
            -80*Q2**9*(33+26*r**2+129*r**4+180*r**6)+5*Q2**8*(777+1120*r**2+3271*r**4
            +9602*r**6+6930*r**8)-60*Q2**7*(6+127*r**2+203*r**4+851*r**6+1171*r**8
            +370*r**10)-20*Q2**6*(213-517*r**2+1617*r**4+273*r**6-2050*r**8-2388*r**10
            +1620*r**12)+4*Q2**5*(762-985*r**2+46760*r**4+83860*r**6+140330*r**8
            +112547*r**10-860*r**12+12690*r**14)-30*Q2**4*(-33+434*r**2+7857*r**4
            +13040*r**6+23705*r**8+59826*r**10+45889*r**12+3776*r**14+170*r**16)
            -20*Q2**3*(78-625*r**2-507*r**4-4713*r**6-25267*r**8-45633*r**10-50361*r**12
            -41911*r**14-8487*r**16+1170*r**18)+20*Q2**2*(3+151*r**2+6955*r**4
            -15541*r**6-2987*r**8-26345*r**10-89743*r**12+3241*r**14+44428*r**16
            -442*r**18+360*r**20)-3*(-1+r**2)**2*(33-514*r**2-6006*r**4+10812*r**6
            -563770*r**8-1061448*r**10-2916*r**12+147476*r**14-108567*r**16-14310*r**18
            +810*r**20)+60*Q2*(6-109*r**2-1314*r**4+4756*r**6-55304*r**8-155364*r**10
            -126500*r**12+10210*r**14+23010*r**16-17375*r**18-1786*r**20+90*r**22))*sqrtq2))/(
            -4665600*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))-32400*logq2*r**4*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3+13996800*logq2**4*r**16*sqrtq2+583200*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2+675*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4*sqrtq2)
            +((-18662400*logq2**3*(-Q2+(-1+r)**2)*r**14*(1+r**2)*(-Q2+(1+r)**2)
            -1728*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(64*Q2**8-192*Q2**7*(1
            +r**2)+Q2**6*(87+345*r**2+2*r**4)+2*Q2**5*(113-239*r**2-209*r**4+63*r**6)
            +Q2**4*(-195-355*r**2-2311*r**4-285*r**6+330*r**8)-4*Q2**3*(21-380*r**2
            -2556*r**4-2761*r**6-455*r**8+71*r**10)+Q2**2*(97-393*r**2-3716*r**4
            -6846*r**6+729*r**8+587*r**10-178*r**12)+6*Q2*(3-115*r**2-753*r**4
            +1895*r**6+2385*r**8+327*r**10-155*r**12+13*r**14)+3*(-7+81*r**2
            +2379*r**4+4877*r**6+12045*r**8+5127*r**10-2611*r**12-309*r**14+18*r**16))
            +103680*logq2**2*r**10*(8*Q2**6*(4+3*r**2)-Q2**5*(122+221*r**2+99*r**4)
            +2*Q2**4*(75+178*r**2+171*r**4+60*r**6)-Q2**3*(20+169*r**2+217*r**4
            +113*r**6+45*r**8)+3*(-1+r**2)**2*(-6-53*r**2-208*r**4-108*r**6+2*r**8
            +13*r**10)+Q2**2*(-100-89*r**2-360*r**4-8*r**6+152*r**8+45*r**10)
            -6*Q2*(-13-37*r**2-263*r**4-343*r**6-98*r**8+20*r**10+14*r**12))*sqrtq2
            +144*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*(-3*Q2**8+5*Q2**7*(1+r**2)+14*Q2**6*(-1-2*r**2
            +r**4)+Q2**5*(57+379*r**2+121*r**4-41*r**6)+2*Q2**4*(-40-407*r**2
            -325*r**4-85*r**6+15*r**8)+Q2**3*(23+431*r**2+314*r**4+238*r**6+15*r**8
            +3*r**10)+(-1+r**2)**2*(3+268*r**2-141*r**4+884*r**6-271*r**8-24*r**10
            +r**12)-2*Q2**2*(-15-218*r**2+73*r**4+58*r**6+257*r**8-40*r**10+5*r**12)
            +Q2*(-21-671*r**2+381*r**4-2193*r**6-1163*r**8+783*r**10+3*r**12
            +r**14))*sqrtq2)*math.log(mu0))/(-2073600*logq2**4*r**18*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))-86400*logq2**2*(-Q2+(-1+r)**2)*r**10*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-100*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4+4800*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+691200*logq2**3*r**14*(Q2**5-3*Q2**4*(1
            +r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)
            +2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)
            +((32400*logq2**2*r**8*(1+r**2)**2+(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2-360*logq2*r**4*(1+r**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*math.log(mus))/(-6912*logq2**3*r**12
            -144*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+1728*logq2**2*r**8*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((18662400*logq2**3*(-Q2+(-1+r)**2)*r**14*(1
            +r**2)*(-Q2+(1+r)**2)+1728*logq2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(64*Q2**8-192*Q2**7*(1+r**2)+Q2**6*(87+345*r**2+2*r**4)+2*Q2**5*(113
            -239*r**2-209*r**4+63*r**6)+Q2**4*(-195-355*r**2-2311*r**4-285*r**6
            +330*r**8)-4*Q2**3*(21-380*r**2-2556*r**4-2761*r**6-455*r**8+71*r**10)
            +Q2**2*(97-393*r**2-3716*r**4-6846*r**6+729*r**8+587*r**10-178*r**12)
            +6*Q2*(3-115*r**2-753*r**4+1895*r**6+2385*r**8+327*r**10-155*r**12
            +13*r**14)+3*(-7+81*r**2+2379*r**4+4877*r**6+12045*r**8+5127*r**10
            -2611*r**12-309*r**14+18*r**16))-103680*logq2**2*r**10*(8*Q2**6*(4+3*r**2)
            -Q2**5*(122+221*r**2+99*r**4)+2*Q2**4*(75+178*r**2+171*r**4+60*r**6)
            -Q2**3*(20+169*r**2+217*r**4+113*r**6+45*r**8)+3*(-1+r**2)**2*(-6
            -53*r**2-208*r**4-108*r**6+2*r**8+13*r**10)+Q2**2*(-100-89*r**2-360*r**4
            -8*r**6+152*r**8+45*r**10)-6*Q2*(-13-37*r**2-263*r**4-343*r**6-98*r**8
            +20*r**10+14*r**12))*sqrtq2-144*(-Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(-3*Q2**8+5*Q2**7*(1+r**2)
            +14*Q2**6*(-1-2*r**2+r**4)+Q2**5*(57+379*r**2+121*r**4-41*r**6)+2*Q2**4*(
            -40-407*r**2-325*r**4-85*r**6+15*r**8)+Q2**3*(23+431*r**2+314*r**4
            +238*r**6+15*r**8+3*r**10)+(-1+r**2)**2*(3+268*r**2-141*r**4+884*r**6
            -271*r**8-24*r**10+r**12)-2*Q2**2*(-15-218*r**2+73*r**4+58*r**6+257*r**8
            -40*r**10+5*r**12)+Q2*(-21-671*r**2+381*r**4-2193*r**6-1163*r**8
            +783*r**10+3*r**12+r**14))*sqrtq2)*math.log(r))/(-2073600*logq2**4*r**18*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))-86400*logq2**2*(-Q2+(-1+r)**2)*r**10*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-100*(-Q2+(-1+r)**2)*r**2*(
            -Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+4800*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2+691200*logq2**3*r**14*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2))*nlo.X1Q2(2,'SM',Q2,r)+((-291600*logq2**2*r**8*(1+r**2)**2
            -9*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2+3240*logq2*r**4*(1+r**2)*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r)*nlo.X1Q2(2,'SM',Q2,r))/(1036800*logq2**4*r**16
            +43200*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+50*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4-345600*logq2**3*r**12*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2-2400*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((-1080*logq2*r**4*(1+r**2)+6*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7
            +2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*sqrtq2)*nlo.X1Q2(1,'SM',Q2,r)*nlo.X1Q2(2,'SM',Q2,r))/(-8640*logq2**3*r**12
            -180*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+2160*logq2**2*r**8*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+5*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(flagPERP*muWC**3*(-192*logq2*(-Q2+(
            -1+r)**2)*r**2*(-Q2+(1+r)**2)*(-10-11*r**2-36*Q2**4*r**2+14*r**4-1326*r**6
            -416*r**8+189*r**10+2*Q2**3*(-5+132*r**2+117*r**4)-Q2**2*(-10+191*r**2
            +524*r**4+171*r**6)-2*Q2*(-5+93*r**2+2*r**4-68*r**6+108*r**8))+5760*logq2**2*r**6*(
            -4+21*r**2+9*r**4)*sqrtq2+(-40*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(-15+24*Q2**4
            -22*r**2-22*r**4-70*r**6+9*r**8-21*Q2**3*(1+r**2)+Q2**2*(-21+38*r**2
            -21*r**4)+Q2*(-15+29*r**2-43*r**4+9*r**6))+48*(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(-3+5*Q2**3+5*r**2-19*r**4+5*r**6-5*Q2**2*(1+r**2)+Q2*(
            -5+8*r**2-5*r**4))*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)
            +3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8)))*sqrtq2)*nlo.X1Q2(3,'SM',Q2,r))/(58320*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+135*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-233280*logq2**3*r**12*sqrtq2
            -4860*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((-138240*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(2+r**2)*(-Q2+(1+r)**2)-64*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(-17*Q2**6-4*Q2**5*(1+r**2)+Q2**4*(-57-182*r**2
            +75*r**4)+Q2**3*(128+964*r**2+316*r**4-40*r**6)+Q2**2*(13-424*r**2
            +258*r**4+224*r**6-35*r**8)+12*Q2*(-5-28*r**2+149*r**4+77*r**6-14*r**8
            +r**10)+3*(-1+314*r**2+377*r**4+1852*r**6-323*r**8-62*r**10+3*r**12))
            +1536*logq2*r**6*(16*Q2**6-61*Q2**5*(1+r**2)+Q2**4*(75+103*r**2+60*r**4)
            -2*Q2**3*(5+31*r**2+16*r**4+5*r**6)+9*(-1+r**2)**2*(-1-11*r**2-41*r**4
            -11*r**6+4*r**8)+Q2**2*(-50-22*r**2-216*r**4+68*r**6+40*r**8)+Q2*(39
            +123*r**2+1008*r**4+978*r**6+93*r**8-81*r**10))*sqrtq2)/(103680*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+2160*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-60*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-25920*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC*(552960*logq2**2*(-Q2+(-1+r)**2)*r**10*(6+5*r**2)*(
            -Q2+(1+r)**2)+256*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(56*Q2**7
            -Q2**6*(88+105*r**2)-4*Q2**5*(13-29*r**2+14*r**4)+4*Q2**3*(10-30*r**2
            -423*r**4+17*r**6)+Q2**4*(100-357*r**2-482*r**4+175*r**6)+Q2**2*(-56
            +637*r**2+2416*r**4+3098*r**6+848*r**8-91*r**10)-12*Q2*(1-7*r**2
            -189*r**4-173*r**6-294*r**8+2*r**10)+3*(4-85*r**2+302*r**4+3349*r**6
            +4824*r**8-335*r**10-146*r**12+7*r**14))-18432*logq2*r**6*(4*Q2**6+11*Q2**5*(1
            +r**2)-Q2**4*(55+123*r**2+60*r**4)+Q2**3*(50+62*r**2+72*r**4+50*r**6)
            +2*Q2**2*(5-9*r**2-132*r**4+6*r**6+20*r**8)+(-1+r**2)**2*(9-121*r**2
            -451*r**4-121*r**6+24*r**8)+Q2*(-29+207*r**2+1172*r**4+1162*r**6
            +197*r**8-69*r**10))*sqrtq2))/(311040*logq2**3*r**14*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))+6480*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-180*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2-77760*logq2**2*r**10*(Q2**5-3*Q2**4*(1+r**2)
            +2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1
            -2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)
            +(muWC**2*(69120*logq2**2*(-Q2+(-1+r)**2)*r**10*(6+5*r**2)*(-Q2+(1+r)**2)
            +32*(Q2-(-1+r)**2)**2*r**2*(Q2-(1+r)**2)**2*(56*Q2**7-Q2**6*(88+105*r**2)
            -4*Q2**5*(13-29*r**2+14*r**4)+4*Q2**3*(10-30*r**2-423*r**4+17*r**6)
            +Q2**4*(100-357*r**2-482*r**4+175*r**6)+Q2**2*(-56+637*r**2+2416*r**4
            +3098*r**6+848*r**8-91*r**10)-12*Q2*(1-7*r**2-189*r**4-173*r**6-294*r**8
            +2*r**10)+3*(4-85*r**2+302*r**4+3349*r**6+4824*r**8-335*r**10-146*r**12
            +7*r**14))-2304*logq2*r**6*(4*Q2**6+11*Q2**5*(1+r**2)-Q2**4*(55+123*r**2
            +60*r**4)+Q2**3*(50+62*r**2+72*r**4+50*r**6)+2*Q2**2*(5-9*r**2-132*r**4
            +6*r**6+20*r**8)+(-1+r**2)**2*(9-121*r**2-451*r**4-121*r**6+24*r**8)
            +Q2*(-29+207*r**2+1172*r**4+1162*r**6+197*r**8-69*r**10))*sqrtq2))/(103680*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+2160*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-60*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-25920*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+(muWC**3*(-384*logq2*(24*Q2**6*(2+5*r**4)-Q2**5*(168
            +133*r**2+540*r**4+795*r**6)-2*Q2**3*r**2*(73+268*r**2+570*r**4+590*r**6
            +375*r**8)+Q2**4*(180+159*r**2+645*r**4+1825*r**6+1575*r**8)-(-1
            +r**2)**2*(12+37*r**2+2117*r**4+3922*r**6-558*r**8-415*r**10+405*r**12)
            -2*Q2**2*(60-167*r**2+799*r**4+538*r**6-700*r**8-135*r**10+525*r**12)
            +Q2*(72-201*r**2+4924*r**4+10719*r**6+7964*r**8-1103*r**10-1600*r**12
            +1305*r**14))+23040*logq2**2*r**4*(12+19*r**2+15*r**4)*sqrtq2-32*(120*Q2**9
            -3*Q2**8*(87+155*r**2)+Q2**7*(258+596*r**2+450*r**4)+Q2**6*(420-514*r**2
            -808*r**4+390*r**6)-6*Q2**5*(441+230*r**2+1306*r**4-98*r**6+145*r**8)
            +2*Q2**4*(1905+622*r**2+6030*r**4+13410*r**6+955*r**8+90*r**10)+2*Q2**3*(
            -477-362*r**2-6203*r**4-3468*r**6-8555*r**8-1802*r**10+195*r**12)
            -6*Q2**2*(378-1147*r**2+1784*r**4-3549*r**6-2410*r**8+3143*r**10-64*r**12
            +25*r**14)+(-1+r**2)**2*(-549+3179*r**2-33609*r**4-12869*r**6+18541*r**8
            -6915*r**10-943*r**12+45*r**14)+Q2*(2070-9916*r**2+66480*r**4+75468*r**6
            +27908*r**8-53892*r**10+22224*r**12+2228*r**14-90*r**16))*sqrtq2))/(174960*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+405*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3-699840*logq2**3*r**12*sqrtq2
            -14580*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((-69120*logq2**2*(
            -Q2+(-1+r)**2)*r**10*(2+r**2)*(-Q2+(1+r)**2)-32*r**4*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))**2*(-17*Q2**6-4*Q2**5*(1+r**2)+Q2**4*(-57-182*r**2
            +75*r**4)+Q2**3*(128+964*r**2+316*r**4-40*r**6)+Q2**2*(13-424*r**2
            +258*r**4+224*r**6-35*r**8)+12*Q2*(-5-28*r**2+149*r**4+77*r**6-14*r**8
            +r**10)+3*(-1+314*r**2+377*r**4+1852*r**6-323*r**8-62*r**10+3*r**12))
            +768*logq2*r**6*(16*Q2**6-61*Q2**5*(1+r**2)+Q2**4*(75+103*r**2+60*r**4)
            -2*Q2**3*(5+31*r**2+16*r**4+5*r**6)+9*(-1+r**2)**2*(-1-11*r**2-41*r**4
            -11*r**6+4*r**8)+Q2**2*(-50-22*r**2-216*r**4+68*r**6+40*r**8)+Q2*(39
            +123*r**2+1008*r**4+978*r**6+93*r**8-81*r**10))*sqrtq2)*math.log(mu0))/(34560*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+720*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-20*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-8640*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2)+((900*logq2*r**4*(1+r**2)-5*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2)*math.log(mus))/(432*logq2**2*r**8+3*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-72*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((69120*logq2**2*(-Q2+(-1+r)**2)*r**10*(2
            +r**2)*(-Q2+(1+r)**2)+32*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(
            -17*Q2**6-4*Q2**5*(1+r**2)+Q2**4*(-57-182*r**2+75*r**4)+Q2**3*(128
            +964*r**2+316*r**4-40*r**6)+Q2**2*(13-424*r**2+258*r**4+224*r**6-35*r**8)
            +12*Q2*(-5-28*r**2+149*r**4+77*r**6-14*r**8+r**10)+3*(-1+314*r**2
            +377*r**4+1852*r**6-323*r**8-62*r**10+3*r**12))-768*logq2*r**6*(16*Q2**6
            -61*Q2**5*(1+r**2)+Q2**4*(75+103*r**2+60*r**4)-2*Q2**3*(5+31*r**2
            +16*r**4+5*r**6)+9*(-1+r**2)**2*(-1-11*r**2-41*r**4-11*r**6+4*r**8)
            +Q2**2*(-50-22*r**2-216*r**4+68*r**6+40*r**8)+Q2*(39+123*r**2+1008*r**4
            +978*r**6+93*r**8-81*r**10))*sqrtq2)*math.log(r))/(34560*logq2**3*r**14*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))+720*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2-20*(-Q2+(-1+r)**2)*r**2*(-Q2
            +(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2-8640*logq2**2*r**10*(Q2**5
            -3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4
            +r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6
            -3*r**8))*sqrtq2))*nlo.X1Q2(3,'SM',Q2,r)+((-720*logq2*r**4*(1+r**2)+4*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*nlo.X1Q2(0,'SM',Q2,r)*nlo.X1Q2(3,'SM',Q2,r))/(
            -8640*logq2**3*r**12-180*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+2160*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+5*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)-(4*nlo.X1Q2(1,'SM',Q2,r)*nlo.X1Q2(3,'SM',Q2,r))/(144*logq2**2*r**8
            +(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-24*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+(flagPERP*muWC**3*(-4*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(-3+5*Q2**3+5*r**2-19*r**4+5*r**6-5*Q2**2*(1
            +r**2)+Q2*(-5+8*r**2-5*r**4))+48*logq2*r**4*sqrtq2)*nlo.X1Q2(4,'SM',Q2,r))/(
            -216*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))+1296*logq2**2*r**8*sqrtq2
            +9*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)+((muWC**3*(16*(5*Q2**5-Q2**4*(7
            +15*r**2)+2*Q2**3*(4+2*r**2+5*r**4)+(-1+r**2)**2*(17+r**2-11*r**4
            +5*r**6)+2*Q2**2*(7-6*r**2-4*r**4+5*r**6)-Q2*(37+20*r**2+8*r**4
            -32*r**6+15*r**8))+192*logq2*sqrtq2))/(-648*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))+3888*logq2**2*r**8*sqrtq2+27*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2)
            +(-768*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)+64*r**4*(-Q2**4+Q2**3*(1
            +r**2)+2*(-1+r**2)**2*(-2-5*r**2+r**4)+Q2**2*(-3-4*r**2+3*r**4)+Q2*(7
            +29*r**2+17*r**4-5*r**6))*sqrtq2)/(-1728*logq2**2*r**10*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))-12*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+288*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC**2*(1152*logq2*(
            -Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)-32*r**2*(4*Q2**5-Q2**4*(11+12*r**2)
            +Q2**3*(7+7*r**2+8*r**4)+2*(-1+r**2)**2*(1-9*r**2-12*r**4+2*r**6)
            +Q2**2*(5-12*r**2-13*r**4+8*r**6)+Q2*(-7+39*r**2+75*r**4+49*r**6
            -12*r**8))*sqrtq2))/(-1728*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))
            -12*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            +288*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1
            +r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(
            -3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(muWC*(9216*logq2*(-Q2
            +(-1+r)**2)*r**6*(-Q2+(1+r)**2)-256*r**2*(4*Q2**5-Q2**4*(11+12*r**2)
            +Q2**3*(7+7*r**2+8*r**4)+2*(-1+r**2)**2*(1-9*r**2-12*r**4+2*r**6)
            +Q2**2*(5-12*r**2-13*r**4+8*r**6)+Q2*(-7+39*r**2+75*r**4+49*r**6
            -12*r**8))*sqrtq2))/(-5184*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))
            -36*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            +864*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)+(-1
            +r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)+Q2*(
            -3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+((-384*logq2*(-Q2+(-1
            +r)**2)*r**6*(-Q2+(1+r)**2)+32*r**4*(-Q2**4+Q2**3*(1+r**2)+2*(-1+r**2)**2*(
            -2-5*r**2+r**4)+Q2**2*(-3-4*r**2+3*r**4)+Q2*(7+29*r**2+17*r**4
            -5*r**6))*sqrtq2)*math.log(mu0))/(-576*logq2**2*r**10*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))-4*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**2+96*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1+r**2+r**4)
            +(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2-2*r**4+r**6)
            +Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2)+(25*math.log(mus))/(-72*logq2*r**4
            +6*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)
            +((384*logq2*(-Q2+(-1+r)**2)*r**6*(-Q2+(1+r)**2)-32*r**4*(-Q2**4+Q2**3*(1
            +r**2)+2*(-1+r**2)**2*(-2-5*r**2+r**4)+Q2**2*(-3-4*r**2+3*r**4)+Q2*(7
            +29*r**2+17*r**4-5*r**6))*sqrtq2)*math.log(r))/(-576*logq2**2*r**10*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))-4*(-Q2+(-1+r)**2)*r**2*(-Q2+(1+r)**2)*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+96*logq2*r**6*(Q2**5-3*Q2**4*(1+r**2)+2*Q2**3*(1
            +r**2+r**4)+(-1+r**2)**2*(1-7*r**2-7*r**4+r**6)+2*Q2**2*(1-2*r**2
            -2*r**4+r**6)+Q2*(-3+14*r**2+26*r**4+14*r**6-3*r**8))*sqrtq2))*nlo.X1Q2(4,'SM',Q2,r)
            -(nlo.X1Q2(0,'SM',Q2,r)*nlo.X1Q2(4,'SM',Q2,r))/(144*logq2**2*r**8+(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2-24*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)+((272160000*logq2**4*r**16*(9+28*r**2
            +34*r**4+28*r**6+9*r**8)+7200*logq2**2*(-Q2+(-1+r)**2)*r**8*(-Q2+(1
            +r)**2)*(755*Q2**10-6460*Q2**9*(1+r**2)+19*Q2**8*(1397+2670*r**2+1397*r**4)
            -2*Q2**7*(22697+75917*r**2+75917*r**4+22697*r**6)+Q2**6*(18389+192140*r**2
            +288058*r**4+192140*r**6+18389*r**8)+Q2**5*(33782-72026*r**2-3024*r**4
            -3024*r**6-72026*r**8+33782*r**10)-Q2**4*(39655+164510*r**2+1238017*r**4
            +2141020*r**6+1238017*r**8+164510*r**10+39655*r**12)+2*Q2**3*(3721+115075*r**2
            +794925*r**4+2094619*r**6+2094619*r**8+794925*r**10+115075*r**12+3721*r**14)
            +4*Q2**2*(2651-3949*r**2+57848*r**4-355357*r**6-683806*r**8-355357*r**10
            +57848*r**12-3949*r**14+2651*r**16)-18*Q2*(453+4355*r**2+39700*r**4
            -68700*r**6-202608*r**8-202608*r**10-68700*r**12+39700*r**14+4355*r**16
            +453*r**18)+12*(179+1333*r**2+22836*r**4+74334*r**6+510837*r**8+822162*r**10
            +510837*r**12+74334*r**14+22836*r**16+1333*r**18+179*r**20))+(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(6866*Q2**16-23436*Q2**15*(1+r**2)+8*Q2**14*(865
            +8596*r**2+865*r**4)+8*Q2**13*(5380-11099*r**2-11099*r**4+5380*r**6)
            +Q2**12*(10045-259012*r**2-2562366*r**4-259012*r**6+10045*r**8)-4*Q2**11*(34147
            -324527*r**2-3988562*r**4-3988562*r**6-324527*r**8+34147*r**10)+2*Q2**10*(35759
            -646722*r**2-15796615*r**4-38576020*r**6-15796615*r**8-646722*r**10
            +35759*r**12)+8*Q2**9*(13745-127492*r**2+2119265*r**4+19072200*r**6
            +19072200*r**8+2119265*r**10-127492*r**12+13745*r**14)+Q2**8*(-91205
            +2043184*r**2+31186064*r**4-92196960*r**6-136611350*r**8-92196960*r**10
            +31186064*r**12+2043184*r**14-91205*r**16)-4*Q2**7*(8785+21669*r**2
            +14208392*r**4+33962024*r**6+101173570*r**8+101173570*r**10+33962024*r**12
            +14208392*r**14+21669*r**16+8785*r**18)+4*Q2**6*(10807-257354*r**2+4036831*r**4
            +57257856*r**6+179616146*r**8+416911988*r**10+179616146*r**12+57257856*r**14
            +4036831*r**16-257354*r**18+10807*r**20)-8*Q2**5*(266-53737*r**2-4403625*r**4
            +12575730*r**6+21507400*r**8+309675766*r**10+309675766*r**12+21507400*r**14
            +12575730*r**16-4403625*r**18-53737*r**20+266*r**22)-Q2**4*(2005+87332*r**2
            +26936590*r**4+29645300*r**6+614859675*r**8-231352920*r**10+1158640836*r**12
            -231352920*r**14+614859675*r**16+29645300*r**18+26936590*r**20+87332*r**22
            +2005*r**24)+4*Q2**3*(135-9223*r**2-887018*r**4+22918230*r**6+168130475*r**8
            +734118485*r**10+2173168916*r**12+2173168916*r**14+734118485*r**16+168130475*r**18
            +22918230*r**20-887018*r**22-9223*r**24+135*r**26)-2*Q2**2*(1265-69094*r**2
            -3667317*r**4+24306396*r**6-83158055*r**8+480299590*r**10+308598123*r**12
            +3065234184*r**14+308598123*r**16+480299590*r**18-83158055*r**20+24306396*r**22
            -3667317*r**24-69094*r**26+1265*r**28)+24*Q2*(31-1758*r**2-54453*r**4
            -686878*r**6-12831908*r**8+1292719*r**10-99093084*r**12+519615331*r**14
            +519615331*r**16-99093084*r**18+1292719*r**20-12831908*r**22-686878*r**24
            -54453*r**26-1758*r**28+31*r**30)+3*(57-3672*r**2+19060*r**4+3841960*r**6
            +9425060*r**8+68973464*r**10+826635276*r**12-1542120*r**14+7983061830*r**16
            -1542120*r**18+826635276*r**20+68973464*r**22+9425060*r**24+3841960*r**26
            +19060*r**28-3672*r**30+57*r**32))+432000*logq2**3*r**12*(867+35*Q2**7
            +3267*r**2+42957*r**4+88989*r**6+88989*r**8+42957*r**10+3267*r**12
            +867*r**14-505*Q2**6*(1+r**2)+5*Q2**5*(445+904*r**2+445*r**4)-Q2**4*(5293
            +15125*r**2+15125*r**4+5293*r**6)-3*Q2*(1+r**2)**2*(1111-2778*r**2
            -446*r**4-2778*r**6+1111*r**8)+Q2**3*(4157+17952*r**2+28010*r**4+17952*r**6
            +4157*r**8)+Q2**2*(1847-3657*r**2-14318*r**4-14318*r**6-3657*r**8+1847*r**10))*sqrtq2
            +120*logq2*r**4*(25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(105*Q2**7-555*Q2**6*(1
            +r**2)+15*Q2**5*(19+52*r**2+19*r**4)-Q2**4*(751+5687*r**2+5687*r**4
            +751*r**6)+Q2**3*(1139+8352*r**2+14006*r**4+8352*r**6+1139*r**8)+Q2**2*(719
            +3879*r**2+4474*r**4+4474*r**6+3879*r**8+719*r**10)+Q2*(-681+2244*r**2
            +38061*r**4+66912*r**6+38061*r**8+2244*r**10-681*r**12)+3*(-87+1849*r**2
            +34455*r**4+109943*r**6+109943*r**8+34455*r**10+1849*r**12-87*r**14))
            +2*(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(971+40*Q2**9-18517*r**2-136600*r**4+561592*r**6+1104554*r**8
            +1104554*r**10+561592*r**12-136600*r**14-18517*r**16+971*r**18-889*Q2**8*(1
            +r**2)+23*Q2**7*(169+418*r**2+169*r**4)-Q2**6*(4347+16967*r**2+16967*r**4
            +4347*r**6)-2*Q2**5*(1113+3489*r**2+13232*r**4+3489*r**6+1113*r**8)
            +2*Q2**4*(2240+11225*r**2+82043*r**4+82043*r**6+11225*r**8+2240*r**10)
            +Q2**3*(1659-18836*r**2-355219*r**4-699528*r**6-355219*r**8-18836*r**10
            +1659*r**12)+Q2**2*(-2567+13091*r**2+205549*r**4+793607*r**6+793607*r**8
            +205549*r**10+13091*r**12-2567*r**14)-8*Q2*(126-2129*r**2-34216*r**4
            -21131*r**6-11300*r**8-21131*r**10-34216*r**12-2129*r**14+126*r**16)))*sqrtq2)*nnlo.X2Q2(0,Q2,r))/(
            -4354560000*logq2**5*r**20-302400000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -1050000*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+1814400000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+25200000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+17500*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +((1512000*logq2**3*r**12*(1+r**2)*(29+50*r**2+29*r**4)+60*logq2*(-Q2
            +(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(1873-640*Q2**9-8851*r**2+85460*r**4
            +1289996*r**6+6796322*r**8+6796322*r**10+1289996*r**12+85460*r**14-8851*r**16
            +1873*r**18+8848*Q2**8*(1+r**2)-32*Q2**7*(617+1454*r**2+617*r**4)+Q2**6*(8169
            +72819*r**2+72819*r**4+8169*r**6)+2*Q2**5*(6881-28372*r**2-46826*r**4
            -28372*r**6+6881*r**8)-Q2**4*(13825+65585*r**2+481262*r**4+481262*r**6
            +65585*r**8+13825*r**10)+4*Q2**3*(903+32098*r**2+185817*r**4+339964*r**6
            +185817*r**8+32098*r**10+903*r**12)+Q2**2*(1879+11233*r**2+272487*r**4
            -159599*r**6-159599*r**8+272487*r**10+11233*r**12+1879*r**14)-2*Q2*(1967
            +21792*r**2+88088*r**4-781552*r**6-1382190*r**8-781552*r**10+88088*r**12
            +21792*r**14+1967*r**16))+3600*logq2**2*r**8*(71-160*Q2**6+6084*r**2
            +70785*r**4+118280*r**6+70785*r**8+6084*r**10+71*r**12+960*Q2**5*(1
            +r**2)-288*Q2**4*(13+24*r**2+13*r**4)+Q2**3*(3221+9879*r**2+9879*r**4
            +3221*r**6)+3*Q2**2*(607-396*r**2-982*r**4-396*r**6+607*r**8)-3*Q2*(723
            -2099*r**2-6184*r**4-6184*r**6-2099*r**8+723*r**10))*sqrtq2+(-500*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4-2708*r**6-1133*r**8
            -34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1
            -19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4-26*r**6+r**8)+Q2*(1
            -31*r**2-390*r**4-390*r**6-31*r**8+r**10))+7*(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8
            -444*r**2-9976*r**4+31692*r**6-28170*r**8+31692*r**10-9976*r**12-444*r**14
            +13*r**16-24*Q2**7*(1+r**2)+Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61
            -193*r**2-193*r**4+61*r**6)+Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6
            -165*r**8)+4*Q2**3*(13-355*r**2-6138*r**4-6138*r**6-355*r**8+13*r**10)
            +Q2**2*(59-406*r**2+10313*r**4+35188*r**6+10313*r**8-406*r**10+59*r**12)
            -2*Q2*(27-595*r**2-7237*r**4+6605*r**6+6605*r**8-7237*r**10-595*r**12
            +27*r**14)))*sqrtq2)*nnlo.X2Q2(1,Q2,r))/(36288000*logq2**4*r**16+1512000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+1750*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-12096000*logq2**3*r**12*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2-84000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+((97200*logq2**2*r**8*(1+r**2)**2+3*(Q2
            -(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2
            -7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6
            +r**8))**2-1080*logq2*r**4*(1+r**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*sqrtq2)*nnlo.X2Q2(2,Q2,r))/(-86400*logq2**3*r**12-1800*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+21600*logq2**2*r**8*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+50*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*sqrtq2)
            +((360*logq2*r**4*(1+r**2)+2*(-3-8*Q2**4+42*r**2+282*r**4+42*r**6
            -3*r**8+7*Q2**3*(1+r**2)+Q2**2*(7-2*r**2+7*r**4)-3*Q2*(1-11*r**2
            -11*r**4+r**6))*sqrtq2)*nnlo.X2Q2(3,Q2,r))/(720*logq2**2*r**8+5*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))**2-120*logq2*r**4*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))*sqrtq2)+nnlo.X2Q2(4,Q2,r)/(-12*logq2*r**4+(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2))
        if( flagDEBUG == 1):
            print("Q2moment n. 4 NNLO = api^2*",resNNLO*par.mbkin**8)
        res += api**2*resNNLO

    if((kwargs.get('flag_includeNNLO', 1) == 1) and (kwargs.get('flag_includeNLOpw', 1) == 1)):
        resNNLO = 0
        resNNLO +=(FLAGcD*flagPERP*muWC**3*((10368000*logq2**4*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(340-1741*r**2+105*Q2**7*r**2+5955*r**4-5175*r**6+3561*r**8
            +12591*r**10-4573*r**12+841*r**14+801*r**16-5*Q2**6*(16+111*r**2+159*r**4)
            +5*Q2**5*(96+279*r**2+724*r**4+471*r**6)-Q2**4*(1200+2331*r**2+6259*r**4
            +9055*r**6+3399*r**8)+Q2**3*(1075+2834*r**2+6055*r**4+10016*r**6+11036*r**8
            +1956*r**10)+Q2**2*(270-2591*r**2-1978*r**4-3537*r**6-9223*r**8-5456*r**10
            +1011*r**12)-Q2*(885-2989*r**2+1628*r**4+3750*r**6-2139*r**8-6015*r**10
            +746*r**12+2034*r**14))+2880*logq2**2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-4656+9857*r**2+9795*Q2**13*r**2-360589*r**4+1247426*r**6
            +7361182*r**8-110253713*r**10+191149981*r**12+55415668*r**14-108222692*r**16
            +14298391*r**18+43828469*r**20-8037238*r**22+4174646*r**24+77241*r**26
            +36027*r**28-Q2**12*(176+99615*r**2+100143*r**4)+Q2**11*(-5648+421432*r**2
            +902836*r**4+410136*r**6)-2*Q2**10*(-16752+433534*r**2+1590537*r**4
            +1611252*r**6+398709*r**8)+5*Q2**9*(-11871+142514*r**2+1005296*r**4
            +1552692*r**6+1056027*r**8+99342*r**10)+5*Q2**8*(-24+71123*r**2-372041*r**4
            -2468*r**6-278440*r**8-442443*r**10+168525*r**12)-2*Q2**7*(-60246+537940*r**2
            +2273487*r**4+14694780*r**6+25759600*r**8+12425514*r**10+2765355*r**12
            +886122*r**14)+2*Q2**6*(-59052+203748*r**2+2708799*r**4+21785399*r**6
            +64454790*r**8+64322268*r**10+18579313*r**12+4286709*r**14+393714*r**16)
            +Q2**5*(-30498+538711*r**2-1098862*r**4-8740592*r**6-94734134*r**8-181196498*r**10
            -110016034*r**12+744928*r**14-2852712*r**16+893691*r**18)-5*Q2**4*(-21816
            +101869*r**2+36771*r**4+5194326*r**6+7971754*r**8-4244340*r**10-9474900*r**12
            +2307154*r**14+8546022*r**16+621087*r**18+228057*r**20)+10*Q2**3*(-4378
            +1164*r**2-74427*r**4+1524972*r**6+8392172*r**8+11921018*r**10+15535886*r**12
            +7500786*r**14+7836870*r**16+2814850*r**18+305589*r**20+24138*r**22)
            +2*Q2**2*(-11108+77610*r**2-109354*r**4+2494245*r**6-11916315*r**8-37141854*r**10
            -61205670*r**12-93691512*r**14-2752980*r**16-28238020*r**18+4228152*r**20
            -337925*r**22+141531*r**24)-3*Q2*(-7159+23476*r**2-315922*r**4+1964468*r**6
            +4565555*r**8-22863892*r**10+43126788*r**12-35799496*r**14-27648481*r**16
            +25613020*r**18-8809874*r**20+4904436*r**22+63493*r**24+63588*r**26))
            +4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**17*r**2+6*Q2**16*(-503
            +1857*r**2+348*r**4)-Q2**15*(-26898+102167*r**2+795672*r**4+48371*r**6)
            +Q2**14*(-98640-56049*r**2+7994969*r**4+6700457*r**6+211055*r**8)-Q2**13*(
            -177975-1898941*r**2+27560140*r**4+63311870*r**6+22428463*r**8+399935*r**10)
            +2*Q2**12*(-57195-2309884*r**2+17136106*r**4+101613869*r**6+95944414*r**8
            +14856441*r**10+111733*r**12)+Q2**11*(-137556+373945*r**2+19063926*r**4
            -223999621*r**6-431226616*r**8-214206393*r**10+13775206*r**12+451941*r**14)
            -Q2**10*(-294096-13637297*r**2+90239625*r**4+147158379*r**6+237617085*r**8
            +126892013*r**10+149456939*r**12+90174137*r**14+864127*r**16)+Q2**9*(
            -82995-18238327*r**2+48326482*r**4+551909576*r**6+1906001960*r**8+3380058850*r**10
            +1563679558*r**12+632089712*r**14+84181011*r**16+257565*r**18)+2*Q2**8*(
            -126225-1009991*r**2+46086545*r**4-193715485*r**6-853227627*r**8-3255304445*r**10
            -3266464121*r**12-698363155*r**14-250698540*r**16+20066388*r**18+349360*r**20)
            -Q2**7*(-270930-22679187*r**2+132341324*r**4+45799181*r**6+1014675076*r**8
            -843528166*r**10-3741360624*r**12-2052704686*r**14+1341959486*r**16+200656521*r**18
            +125143764*r**20+760881*r**22)+Q2**6*(-14784-14394991*r**2+11307799*r**4
            +195247027*r**6+1774319317*r**8+7423701738*r**10+17856696358*r**12+11717789766*r**14
            +7166277802*r**16+2527824517*r**18+562002755*r**20+57687687*r**22+36929*r**24)
            +Q2**5*(-139311-6909393*r**2+94005896*r**4-225483814*r**6+422091965*r**8
            -4834215971*r**10-21741140296*r**12-43522669716*r**14-12347107893*r**16
            -8634004135*r**18-44297888*r**20-276307526*r**22+46636615*r**24+403867*r**26)
            -2*Q2**4*(-42255-5827438*r**2+34822088*r**4-116753271*r**6+605172420*r**8
            +534178775*r**10+2627004171*r**12-11002393566*r**14-17819750663*r**16
            +6074554120*r**18-930477570*r**20+950406917*r**22+35981378*r**24+28343359*r**26
            +123935*r**28)+Q2**3*(3600-2982709*r**2-596050*r**4-46349435*r**6-106353308*r**8
            +1201901155*r**10+13462806858*r**12+14229490325*r**14+3687037960*r**16
            -6454737479*r**18+18543504930*r**20+3071947751*r**22+885610500*r**24
            +125097625*r**26+10537062*r**28-6785*r**30)+Q2**2*(-23040-2142577*r**2
            +24290137*r**4-132014257*r**6+694056873*r**8-696848773*r**10-872984739*r**12
            -4977016789*r**14-35888913091*r**16+7774277309*r**18-20252527269*r**20
            +2796606109*r**22-2790985173*r**24+437225273*r**26-48682257*r**28+11649257*r**30
            +65007*r**32)+Q2*(9483+1473529*r**2-12345038*r**4+104663644*r**6-278087326*r**8
            +723773040*r**10-4072964318*r**12+4203800668*r**14-17674051888*r**16
            +59843857002*r**18-65906419354*r**20+39123878324*r**22-11142159922*r**24
            +974218744*r**26-446730426*r**28+7287956*r**30-6977035*r**32-27083*r**34)
            +2*(-654-131806*r**2+1042713*r**4-11829543*r**6+9308985*r**8-75573153*r**10
            +468182403*r**12-2736829079*r**14-10699576611*r**16+52263253755*r**18
            -64276935707*r**20+35970149187*r**22-9421707981*r**24+1788128901*r**26
            -61350615*r**28+49334139*r**30-137659*r**32+590847*r**34+1878*r**36))
            -2177280000*logq2**5*r**18*(-3-4*r**2+20*r**4-28*r**6+3*r**8)*sqrtq2
            +172800*logq2**3*r**10*(2265*Q2**12*r**2-10*Q2**11*(-8+2487*r**2+2463*r**4)
            +2*Q2**10*(60+57651*r**2+114071*r**4+57771*r**6)-10*Q2**9*(168+29587*r**2
            +86688*r**4+87891*r**6+29466*r**8)+10*Q2**8*(345+43559*r**2+170411*r**4
            +257585*r**6+177420*r**8+40572*r**10)-5*Q2**7*(639+62946*r**2+327965*r**4
            +670680*r**6+694545*r**8+365346*r**10+36639*r**12)-5*Q2**6*(-945+4277*r**2
            -25333*r**4-189343*r**6-197327*r**8-215481*r**10-98931*r**12+60795*r**14)
            +Q2**5*(-9975+232676*r**2+1416716*r**4+2721336*r**6+4815470*r**8+5443880*r**10
            +2655296*r**12+873516*r**14+546381*r**16)-5*Q2**4*(-1881+33246*r**2
            +266324*r**4+737376*r**6+1289802*r**8+1843588*r**10+1626060*r**12+612432*r**14
            +201183*r**16+58158*r**18)+5*Q2**3*(-45+2092*r**2+31513*r**4+543628*r**6
            +348974*r**8+863344*r**10+1386718*r**12+884156*r**14+44967*r**16+106140*r**18
            -15519*r**20)+(-1+r**2)**2*(-795+6057*r**2+62201*r**4-540963*r**6+687258*r**8
            +728234*r**10+339426*r**12+49434*r**14-147727*r**16+329277*r**18-14379*r**20
            +13977*r**22)+5*Q2**2*(-1141+10783*r**2+93415*r**4-524683*r**6+442474*r**8
            +314470*r**10-47806*r**12-472190*r**14-254261*r**16+360507*r**18-57129*r**20
            +34761*r**22)-5*Q2*(-759+6954*r**2+57322*r**4-424866*r**6+607083*r**8
            +102120*r**10+166800*r**12+757680*r**14-67773*r**16-263202*r**18+284310*r**20
            -32638*r**22+16569*r**24))*sqrtq2+24*logq2*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-11815-17342*r**2+20598*Q2**16*r**2-1539738*r**4-1828220*r**6
            -93296530*r**8+531809700*r**10-1202798314*r**12-12016064876*r**14+34941377640*r**16
            -16859928440*r**18-10427104030*r**20+13402061004*r**22-3848051134*r**24
            +1002915580*r**26-360030*r**28+15413020*r**30+576527*r**32+46998*r**34
            -12*Q2**15*(-1480+23619*r**2+19179*r**4)+4*Q2**14*(-32820+315810*r**2
            +775091*r**4+250170*r**6)-4*Q2**13*(-89680+561415*r**2+3441914*r**4
            +3172239*r**6+501840*r**8)+3*Q2**12*(-102835+108210*r**2+8242288*r**4
            +14188924*r**6+7455783*r**8+347210*r**10)+Q2**11*(-501830+4084716*r**2
            -5212386*r**4-3865176*r**6-7029506*r**8-4035196*r**10+3308706*r**12)
            -2*Q2**10*(-682770+1489843*r**2+22024696*r**4+119695125*r**6+221267970*r**8
            +106897065*r**10+24392896*r**12+3266703*r**14)+2*Q2**9*(-367345-3071840*r**2
            +26710386*r**4+227220060*r**6+714133400*r**8+705569180*r**10+204029050*r**12
            +35732936*r**14+1173645*r**16)+Q2**8*(-1049565+10126620*r**2-78738*r**4
            -171444948*r**6-1341551320*r**8-2311353340*r**10-1458873670*r**12-92048748*r**14
            -9710163*r**16+5670720*r**18)-4*Q2**7*(-406065+252615*r**2+7631982*r**4
            +81058936*r**6+189015752*r**8+480461830*r**10+282469470*r**12+143391072*r**14
            +131845761*r**16+16615587*r**18+1761540*r**20)+4*Q2**6*(-86460-2028669*r**2
            +1555743*r**4+74640153*r**6+482523418*r**8+2086011688*r**10+3349274064*r**12
            +1600218868*r**14+600107578*r**16+136941693*r**18+14561673*r**20+206811*r**22)
            +4*Q2**5*(-201465+1468989*r**2+1303132*r**4+13924205*r**6-125757445*r**8
            -1264814850*r**10-4711887796*r**12-4758378986*r**14-842818895*r**16-375154195*r**18
            +18838800*r**20+882517*r**22+946389*r**24)-Q2**4*(-642845-567190*r**2
            -8788364*r**4+119119700*r**6+481332275*r**8+3568163190*r**10-1523155600*r**12
            -13344747272*r**14-6577893895*r**16+5528768150*r**18+405581180*r**20
            +405698740*r**22+29345361*r**24+2648970*r**26)+2*Q2**3*(-18015-1180230*r**2
            -3200553*r**4-5407748*r**6-36754535*r**8+2081584130*r**10+4548956715*r**12
            +5193822776*r**14+943425851*r**16+2957420990*r**18+3054240885*r**20+424070540*r**22
            +85143627*r**24+6359622*r**26+15945*r**28)+2*Q2**2*(-80690+490665*r**2
            -3006468*r**4+17883911*r**6+95819042*r**8-120874895*r**10-1518601440*r**12
            -4189196169*r**14-9293444622*r**16+968976371*r**18-4244198580*r**20+292174125*r**22
            -168527138*r**24+35301811*r**26+1076312*r**28+351765*r**30)-2*Q2*(-38835
            +44444*r**2-3174082*r**4+2322168*r**6-63994442*r**8+565501168*r**10
            +36509186*r**12-748140236*r**14+1938362164*r**16-8068634516*r**18+7204485794*r**20
            -4164681904*r**22+1469846818*r**24-20195832*r**26+35804958*r**28+1423748*r**30
            +159399*r**32))*sqrtq2)/(4082400000*logq2**4*r**16*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))
            +56700000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+39375*(Q2**2+(
            -1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5-9797760000*logq2**5*r**20*sqrtq2-680400000*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2-2362500*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*sqrtq2)+((-41472000*logq2**4*(-Q2+(-1+r)**2)*r**14*(-Q2+(1
            +r)**2)*(340-1741*r**2+105*Q2**7*r**2+5955*r**4-5175*r**6+3561*r**8
            +12591*r**10-4573*r**12+841*r**14+801*r**16-5*Q2**6*(16+111*r**2+159*r**4)
            +5*Q2**5*(96+279*r**2+724*r**4+471*r**6)-Q2**4*(1200+2331*r**2+6259*r**4
            +9055*r**6+3399*r**8)+Q2**3*(1075+2834*r**2+6055*r**4+10016*r**6+11036*r**8
            +1956*r**10)+Q2**2*(270-2591*r**2-1978*r**4-3537*r**6-9223*r**8-5456*r**10
            +1011*r**12)-Q2*(885-2989*r**2+1628*r**4+3750*r**6-2139*r**8-6015*r**10
            +746*r**12+2034*r**14))-11520*logq2**2*r**6*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-4656+9857*r**2+9795*Q2**13*r**2-360589*r**4+1247426*r**6
            +7361182*r**8-110253713*r**10+191149981*r**12+55415668*r**14-108222692*r**16
            +14298391*r**18+43828469*r**20-8037238*r**22+4174646*r**24+77241*r**26
            +36027*r**28-Q2**12*(176+99615*r**2+100143*r**4)+Q2**11*(-5648+421432*r**2
            +902836*r**4+410136*r**6)-2*Q2**10*(-16752+433534*r**2+1590537*r**4
            +1611252*r**6+398709*r**8)+5*Q2**9*(-11871+142514*r**2+1005296*r**4
            +1552692*r**6+1056027*r**8+99342*r**10)+5*Q2**8*(-24+71123*r**2-372041*r**4
            -2468*r**6-278440*r**8-442443*r**10+168525*r**12)-2*Q2**7*(-60246+537940*r**2
            +2273487*r**4+14694780*r**6+25759600*r**8+12425514*r**10+2765355*r**12
            +886122*r**14)+2*Q2**6*(-59052+203748*r**2+2708799*r**4+21785399*r**6
            +64454790*r**8+64322268*r**10+18579313*r**12+4286709*r**14+393714*r**16)
            +Q2**5*(-30498+538711*r**2-1098862*r**4-8740592*r**6-94734134*r**8-181196498*r**10
            -110016034*r**12+744928*r**14-2852712*r**16+893691*r**18)-5*Q2**4*(-21816
            +101869*r**2+36771*r**4+5194326*r**6+7971754*r**8-4244340*r**10-9474900*r**12
            +2307154*r**14+8546022*r**16+621087*r**18+228057*r**20)+10*Q2**3*(-4378
            +1164*r**2-74427*r**4+1524972*r**6+8392172*r**8+11921018*r**10+15535886*r**12
            +7500786*r**14+7836870*r**16+2814850*r**18+305589*r**20+24138*r**22)
            +2*Q2**2*(-11108+77610*r**2-109354*r**4+2494245*r**6-11916315*r**8-37141854*r**10
            -61205670*r**12-93691512*r**14-2752980*r**16-28238020*r**18+4228152*r**20
            -337925*r**22+141531*r**24)-3*Q2*(-7159+23476*r**2-315922*r**4+1964468*r**6
            +4565555*r**8-22863892*r**10+43126788*r**12-35799496*r**14-27648481*r**16
            +25613020*r**18-8809874*r**20+4904436*r**22+63493*r**24+63588*r**26))
            -16*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(658*Q2**17*r**2+6*Q2**16*(
            -503+1857*r**2+348*r**4)-Q2**15*(-26898+102167*r**2+795672*r**4+48371*r**6)
            +Q2**14*(-98640-56049*r**2+7994969*r**4+6700457*r**6+211055*r**8)-Q2**13*(
            -177975-1898941*r**2+27560140*r**4+63311870*r**6+22428463*r**8+399935*r**10)
            +2*Q2**12*(-57195-2309884*r**2+17136106*r**4+101613869*r**6+95944414*r**8
            +14856441*r**10+111733*r**12)+Q2**11*(-137556+373945*r**2+19063926*r**4
            -223999621*r**6-431226616*r**8-214206393*r**10+13775206*r**12+451941*r**14)
            -Q2**10*(-294096-13637297*r**2+90239625*r**4+147158379*r**6+237617085*r**8
            +126892013*r**10+149456939*r**12+90174137*r**14+864127*r**16)+Q2**9*(
            -82995-18238327*r**2+48326482*r**4+551909576*r**6+1906001960*r**8+3380058850*r**10
            +1563679558*r**12+632089712*r**14+84181011*r**16+257565*r**18)+2*Q2**8*(
            -126225-1009991*r**2+46086545*r**4-193715485*r**6-853227627*r**8-3255304445*r**10
            -3266464121*r**12-698363155*r**14-250698540*r**16+20066388*r**18+349360*r**20)
            -Q2**7*(-270930-22679187*r**2+132341324*r**4+45799181*r**6+1014675076*r**8
            -843528166*r**10-3741360624*r**12-2052704686*r**14+1341959486*r**16+200656521*r**18
            +125143764*r**20+760881*r**22)+Q2**6*(-14784-14394991*r**2+11307799*r**4
            +195247027*r**6+1774319317*r**8+7423701738*r**10+17856696358*r**12+11717789766*r**14
            +7166277802*r**16+2527824517*r**18+562002755*r**20+57687687*r**22+36929*r**24)
            +Q2**5*(-139311-6909393*r**2+94005896*r**4-225483814*r**6+422091965*r**8
            -4834215971*r**10-21741140296*r**12-43522669716*r**14-12347107893*r**16
            -8634004135*r**18-44297888*r**20-276307526*r**22+46636615*r**24+403867*r**26)
            -2*Q2**4*(-42255-5827438*r**2+34822088*r**4-116753271*r**6+605172420*r**8
            +534178775*r**10+2627004171*r**12-11002393566*r**14-17819750663*r**16
            +6074554120*r**18-930477570*r**20+950406917*r**22+35981378*r**24+28343359*r**26
            +123935*r**28)+Q2**3*(3600-2982709*r**2-596050*r**4-46349435*r**6-106353308*r**8
            +1201901155*r**10+13462806858*r**12+14229490325*r**14+3687037960*r**16
            -6454737479*r**18+18543504930*r**20+3071947751*r**22+885610500*r**24
            +125097625*r**26+10537062*r**28-6785*r**30)+Q2**2*(-23040-2142577*r**2
            +24290137*r**4-132014257*r**6+694056873*r**8-696848773*r**10-872984739*r**12
            -4977016789*r**14-35888913091*r**16+7774277309*r**18-20252527269*r**20
            +2796606109*r**22-2790985173*r**24+437225273*r**26-48682257*r**28+11649257*r**30
            +65007*r**32)+Q2*(9483+1473529*r**2-12345038*r**4+104663644*r**6-278087326*r**8
            +723773040*r**10-4072964318*r**12+4203800668*r**14-17674051888*r**16
            +59843857002*r**18-65906419354*r**20+39123878324*r**22-11142159922*r**24
            +974218744*r**26-446730426*r**28+7287956*r**30-6977035*r**32-27083*r**34)
            +2*(-654-131806*r**2+1042713*r**4-11829543*r**6+9308985*r**8-75573153*r**10
            +468182403*r**12-2736829079*r**14-10699576611*r**16+52263253755*r**18
            -64276935707*r**20+35970149187*r**22-9421707981*r**24+1788128901*r**26
            -61350615*r**28+49334139*r**30-137659*r**32+590847*r**34+1878*r**36))
            +8709120000*logq2**5*r**18*(-3-4*r**2+20*r**4-28*r**6+3*r**8)*sqrtq2
            -691200*logq2**3*r**10*(2265*Q2**12*r**2-10*Q2**11*(-8+2487*r**2+2463*r**4)
            +2*Q2**10*(60+57651*r**2+114071*r**4+57771*r**6)-10*Q2**9*(168+29587*r**2
            +86688*r**4+87891*r**6+29466*r**8)+10*Q2**8*(345+43559*r**2+170411*r**4
            +257585*r**6+177420*r**8+40572*r**10)-5*Q2**7*(639+62946*r**2+327965*r**4
            +670680*r**6+694545*r**8+365346*r**10+36639*r**12)-5*Q2**6*(-945+4277*r**2
            -25333*r**4-189343*r**6-197327*r**8-215481*r**10-98931*r**12+60795*r**14)
            +Q2**5*(-9975+232676*r**2+1416716*r**4+2721336*r**6+4815470*r**8+5443880*r**10
            +2655296*r**12+873516*r**14+546381*r**16)-5*Q2**4*(-1881+33246*r**2
            +266324*r**4+737376*r**6+1289802*r**8+1843588*r**10+1626060*r**12+612432*r**14
            +201183*r**16+58158*r**18)+5*Q2**3*(-45+2092*r**2+31513*r**4+543628*r**6
            +348974*r**8+863344*r**10+1386718*r**12+884156*r**14+44967*r**16+106140*r**18
            -15519*r**20)+(-1+r**2)**2*(-795+6057*r**2+62201*r**4-540963*r**6+687258*r**8
            +728234*r**10+339426*r**12+49434*r**14-147727*r**16+329277*r**18-14379*r**20
            +13977*r**22)+5*Q2**2*(-1141+10783*r**2+93415*r**4-524683*r**6+442474*r**8
            +314470*r**10-47806*r**12-472190*r**14-254261*r**16+360507*r**18-57129*r**20
            +34761*r**22)-5*Q2*(-759+6954*r**2+57322*r**4-424866*r**6+607083*r**8
            +102120*r**10+166800*r**12+757680*r**14-67773*r**16-263202*r**18+284310*r**20
            -32638*r**22+16569*r**24))*sqrtq2-96*logq2*r**2*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(-11815-17342*r**2+20598*Q2**16*r**2-1539738*r**4-1828220*r**6
            -93296530*r**8+531809700*r**10-1202798314*r**12-12016064876*r**14+34941377640*r**16
            -16859928440*r**18-10427104030*r**20+13402061004*r**22-3848051134*r**24
            +1002915580*r**26-360030*r**28+15413020*r**30+576527*r**32+46998*r**34
            -12*Q2**15*(-1480+23619*r**2+19179*r**4)+4*Q2**14*(-32820+315810*r**2
            +775091*r**4+250170*r**6)-4*Q2**13*(-89680+561415*r**2+3441914*r**4
            +3172239*r**6+501840*r**8)+3*Q2**12*(-102835+108210*r**2+8242288*r**4
            +14188924*r**6+7455783*r**8+347210*r**10)+Q2**11*(-501830+4084716*r**2
            -5212386*r**4-3865176*r**6-7029506*r**8-4035196*r**10+3308706*r**12)
            -2*Q2**10*(-682770+1489843*r**2+22024696*r**4+119695125*r**6+221267970*r**8
            +106897065*r**10+24392896*r**12+3266703*r**14)+2*Q2**9*(-367345-3071840*r**2
            +26710386*r**4+227220060*r**6+714133400*r**8+705569180*r**10+204029050*r**12
            +35732936*r**14+1173645*r**16)+Q2**8*(-1049565+10126620*r**2-78738*r**4
            -171444948*r**6-1341551320*r**8-2311353340*r**10-1458873670*r**12-92048748*r**14
            -9710163*r**16+5670720*r**18)-4*Q2**7*(-406065+252615*r**2+7631982*r**4
            +81058936*r**6+189015752*r**8+480461830*r**10+282469470*r**12+143391072*r**14
            +131845761*r**16+16615587*r**18+1761540*r**20)+4*Q2**6*(-86460-2028669*r**2
            +1555743*r**4+74640153*r**6+482523418*r**8+2086011688*r**10+3349274064*r**12
            +1600218868*r**14+600107578*r**16+136941693*r**18+14561673*r**20+206811*r**22)
            +4*Q2**5*(-201465+1468989*r**2+1303132*r**4+13924205*r**6-125757445*r**8
            -1264814850*r**10-4711887796*r**12-4758378986*r**14-842818895*r**16-375154195*r**18
            +18838800*r**20+882517*r**22+946389*r**24)-Q2**4*(-642845-567190*r**2
            -8788364*r**4+119119700*r**6+481332275*r**8+3568163190*r**10-1523155600*r**12
            -13344747272*r**14-6577893895*r**16+5528768150*r**18+405581180*r**20
            +405698740*r**22+29345361*r**24+2648970*r**26)+2*Q2**3*(-18015-1180230*r**2
            -3200553*r**4-5407748*r**6-36754535*r**8+2081584130*r**10+4548956715*r**12
            +5193822776*r**14+943425851*r**16+2957420990*r**18+3054240885*r**20+424070540*r**22
            +85143627*r**24+6359622*r**26+15945*r**28)+2*Q2**2*(-80690+490665*r**2
            -3006468*r**4+17883911*r**6+95819042*r**8-120874895*r**10-1518601440*r**12
            -4189196169*r**14-9293444622*r**16+968976371*r**18-4244198580*r**20+292174125*r**22
            -168527138*r**24+35301811*r**26+1076312*r**28+351765*r**30)-2*Q2*(-38835
            +44444*r**2-3174082*r**4+2322168*r**6-63994442*r**8+565501168*r**10
            +36509186*r**12-748140236*r**14+1938362164*r**16-8068634516*r**18+7204485794*r**20
            -4164681904*r**22+1469846818*r**24-20195832*r**26+35804958*r**28+1423748*r**30
            +159399*r**32))*sqrtq2)*math.log(murhoD))/(4408992000*logq2**4*r**16*(Q2**2+(-1
            +r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)
            -Q2*(1+r**4))+61236000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3+42525*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**5-10581580800*logq2**5*r**20*sqrtq2-734832000*logq2**3*r**12*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*sqrtq2-2551500*logq2*r**4*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))**4*sqrtq2))+FLAGcD*muWC**3*((-10368000*logq2**4*r**12*(105*Q2**9*(1
            +5*r**4)-5*Q2**8*(249+361*r**2+1101*r**4+1005*r**6)+10*Q2**7*(597+1621*r**2
            +3496*r**4+4343*r**6+2025*r**8)-2*Q2**6*(7812+29149*r**2+64765*r**4
            +93125*r**6+69133*r**8+22260*r**10)+Q2**5*(22974+106027*r**2+250778*r**4
            +470915*r**6+412871*r**8+222906*r**10+55545*r**12)-Q2**4*(15540+92822*r**2
            +231869*r**4+588590*r**6+701120*r**8+419048*r**10+170935*r**12+31500*r**14)
            +2*Q2**3*(-1575+11024*r**2+40642*r**4+140278*r**6+184250*r**8+213791*r**10
            +81491*r**12+6005*r**14-5250*r**16)+(-1+r**2)**2*(1821+1633*r**2+608*r**4
            +116088*r**6-193788*r**8-187194*r**10+70224*r**12-1996*r**14+12199*r**16
            +4005*r**18)+Q2**2*(13020+15118*r**2-11915*r**4+119156*r**6-143159*r**8
            -108758*r**10-29109*r**12-13188*r**14+70635*r**16+29400*r**18)+Q2*(
            -8331-4469*r**2+12109*r**4-306011*r**6+264845*r**8+760417*r**10+146475*r**12
            -137073*r**14+34282*r**16-38464*r**18-18180*r**20))-2880*logq2**2*(-Q2
            +(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(9795*Q2**15*(1+5*r**4)-Q2**14*(120261
            +121493*r**2+521937*r**4+598665*r**6)+Q2**13*(604329+1271816*r**2+3448100*r**4
            +5662978*r**6+3101085*r**8)-Q2**12*(1583961+5382217*r**2+14984690*r**4
            +28081086*r**6+25269377*r**8+8589165*r**10)+Q2**11*(2105649+11648083*r**2
            +36582862*r**4+85246604*r**6+92230079*r**8+57617593*r**10+12508410*r**12)
            -Q2**10*(491931+12207009*r**2+35377311*r**4+134400931*r**6+171469901*r**8
            +105720395*r**10+60971217*r**12+4741065*r**14)-Q2**9*(2776653-630711*r**2
            +40542531*r**4-18250145*r**6-76727145*r**8+99740803*r**10+137775089*r**12
            +9194301*r**14+14803920*r**16)+Q2**8*(4096917+13919013*r**2+148377380*r**4
            +308632144*r**6+276891690*r**8+613334922*r**10+965758108*r**12+553194480*r**14
            +104109969*r**16+25872705*r**18)-Q2**7*(1474803+15840426*r**2+133162825*r**4
            +526474548*r**6+441833406*r**8+535880328*r**10+1378107826*r**12+1544646700*r**14
            +552418143*r**16+112180446*r**18+12267045*r**20)-Q2**6*(1984323-5804169*r**2
            +37730299*r**4-375497397*r**6+59872778*r**8+1109296634*r**10+899482146*r**12
            -562848086*r**14-848754237*r**16+108366543*r**18-25743789*r**20+10701195*r**22)
            +Q2**5*(2538327+2759198*r**2+163842602*r**4-105799688*r**6+754730047*r**8
            +3936007492*r**10+6253024212*r**12+5020022232*r**14+1457563277*r**16
            +277470622*r**18+679323650*r**20+45080784*r**22+17078205*r**24)-Q2**4*(816711
            +4176143*r**2+106088382*r**4+37433530*r**6+675121145*r**8+5072470653*r**10
            +10494698764*r**12+12060215356*r**14+7391704305*r**16+1851552905*r**18
            +608344086*r**20+492090218*r**22+42539887*r**24+6699915*r**26)+Q2**3*(
            -449121+2478871*r**2-15046580*r**4+146543328*r**6-217727825*r**8+2390168207*r**10
            +6033710428*r**12+8865032760*r**14+8622117469*r**16+3173450165*r**18
            -114834436*r**20+529359176*r**22-28759755*r**24+12234053*r**26-2577540*r**28)
            +(-1+r**2)**2*(22059-8871*r**2+4419683*r**4-20995819*r**6+139149983*r**8
            +108523417*r**10-822294713*r**12+958091149*r**14-873751727*r**16-1787782061*r**18
            +714996889*r**20+332955959*r**22-45911707*r**24+21722171*r**26+603453*r**28
            +180135*r**30)+Q2**2*(491139-1071907*r**2+52895515*r**4-206636041*r**6
            +887443983*r**8+331547957*r**10-575705201*r**12+1159538095*r**14-467647463*r**16
            -3196260881*r**18+1744035569*r**20+1843553133*r**22-528696235*r**24+221511679*r**26
            +1577573*r**28+3503085*r**30)-Q2*(170451-340323*r**2+26200363*r**4
            -129435949*r**6+685390901*r**8+206205825*r**10-1660142489*r**12+533888479*r**14
            -2084679017*r**16-716426537*r**18-4677079583*r**20+1411398297*r**22+1553436983*r**24
            -348894709*r**26+117080461*r**28+1592757*r**30+1314090*r**32))-4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(552*Q2**20+Q2**19*(1230-86*r**2)+8*Q2**18*(993
            +5225*r**2+2309*r**4)-Q2**17*(793689+350881*r**2+3840383*r**4+361615*r**6)
            +Q2**16*(6432021+485746*r**2+21116616*r**4+38837094*r**6+2083563*r**8)
            -2*Q2**15*(11471247-3133150*r**2-25946401*r**4+101248489*r**6+84688408*r**8
            +2973871*r**10)+Q2**14*(40359885-25706302*r**2-675511331*r**4-240427744*r**6
            +819403091*r**8+369434110*r**10+8820563*r**12)-2*Q2**13*(9542901+2669295*r**2
            -1085865336*r**4-1900280100*r**6-466447889*r**8+803851653*r**10+146175660*r**12
            +1926168*r**14)-Q2**12*(59715123-229084978*r**2+3370785104*r**4+12061520622*r**6
            +13661765622*r**8+4700526258*r**10-1023582864*r**12+443437586*r**14+8895575*r**16)
            +2*Q2**11*(59958951-268593854*r**2+1107903779*r**4+11402737423*r**6+22250625111*r**8
            +21253490637*r**10+7314514917*r**12+1008667129*r**14+657468074*r**16
            +7744633*r**18)-Q2**10*(58479135-343542210*r**2-1563244539*r**4+28898194668*r**6
            +83780882714*r**8+119396855352*r**10+86936703870*r**12+20253826772*r**14
            +5147480295*r**16+1012294602*r**18+4642781*r**20)-2*Q2**9*(40320930-289047506*r**2
            +3077122489*r**4-7457575429*r**6-38957895394*r**8-82778419030*r**10-77053270204*r**12
            -39150651796*r**14+935601416*r**16-2231515984*r**18+284894555*r**20+6165809*r**22)
            +Q2**8*(131865747-1224415370*r**2+8366116250*r**4+22850768770*r**6+14448039489*r**8
            -64268195484*r**10-79801386780*r**12+13590947148*r**14+34024103325*r**16
            +42359779974*r**18-138163070*r**20+1608087890*r**22+15087631*r**24)-2*Q2**7*(23013981
            -298988206*r**2+2129722329*r**4+24289171323*r**6+44661674978*r**8+47234796729*r**10
            +36834968682*r**12+99832766070*r**14+112780665993*r**16+70234457628*r**18
            +22785681581*r**20+1785794655*r**22+443650152*r**24+1609065*r**26)+Q2**6*(
            -50293017+573373078*r**2-4626548429*r**4+31899242456*r**6+36006884167*r**8
            +122998331518*r**10-10829320837*r**12+138039439968*r**14+312641956557*r**16
            +104398998674*r**18+120087044929*r**20-4550430776*r**22+3888809861*r**24
            -428397478*r**26-6511471*r**28)+2*Q2**5*(29194197-444109285*r**2+4525970488*r**4
            -275635120*r**6+18388466093*r**8-60188517893*r**10+167931853520*r**12
            +190859318848*r**14+102048773903*r**16-113442017999*r**18+106822746176*r**20
            -18953374040*r**22+21874725359*r**24-911000263*r**26+391781176*r**28
            +2932040*r**30)-Q2**4*(16040505-330507126*r**2+4716323316*r**4+11233089714*r**6
            +15112005104*r**8-109573193430*r**10+588173222796*r**12+1020409892898*r**14
            +1022875599762*r**16+793357092462*r**18-158390301780*r**20+246316285446*r**22
            +12506888136*r**24+28602910174*r**26+237801684*r**28+303592230*r**30
            +1130109*r**32)+2*Q2**3*(-4614882+74166205*r**2-641187947*r**4+4894880565*r**6
            -13870779821*r**8+15069143875*r**10+131583868765*r**12+374509317573*r**14
            +620236955535*r**16+357597187597*r**18+244037521191*r**20+44917866615*r**22
            -6716860655*r**24+18960340425*r**26-1947071001*r**28+487848591*r**30
            -44487185*r**32-543446*r**34)+2*(-1+r**2)**2*(156654-4170412*r**2+84909051*r**4
            -230578818*r**6+358432710*r**8-5882078502*r**10+74768865726*r**12-231116744978*r**14
            +245764096194*r**16+10125137730*r**18-301537274708*r**20+192462278634*r**22
            -40827260622*r**24+11311878366*r**26-1463840190*r**28+470139306*r**30
            -9537448*r**32+2698674*r**34+12633*r**36)+Q2**2*(8644899-184657634*r**2
            +2643449645*r**4-7304295692*r**6+26751377328*r**8-128117752164*r**10
            +487154478120*r**12-363509890492*r**14+372778090654*r**16-540957326056*r**18
            -236996217094*r**20+896363366812*r**22-445606313176*r**24+180868302468*r**26
            -43091242272*r**28+13124189484*r**30-673003673*r**32+121417898*r**34
            +820945*r**36)-Q2*(2682531-67137509*r**2+1183056495*r**4-3779339229*r**6
            +10174715552*r**8-75459588888*r**10+590033884272*r**12-1177510543480*r**14
            +327748803822*r**16+838933914054*r**18-299472890442*r**20-1671324890442*r**22
            +1404998019000*r**24-419673325232*r**26+125884294536*r**28-23421714576*r**30
            +6145926679*r**32-221450265*r**34+42311139*r**36+231983*r**38))-2177280000*logq2**5*r**16*(9
            +33*r**2+124*r**4-512*r**6+163*r**8+15*r**10)*sqrtq2-172800*logq2**3*r**8*(2265*Q2**12*(1
            +5*r**4)-10*Q2**11*(2439+2383*r**2+10431*r**4+12315*r**6)+2*Q2**10*(57951
            +108258*r**2+244605*r**4+469607*r**6+288855*r**8)-10*Q2**9*(29970+83928*r**2
            +146473*r**4+295842*r**6+354501*r**8+147330*r**10)+10*Q2**8*(41607+170403*r**2
            +278381*r**4+438443*r**6+778226*r**8+693972*r**10+202860*r**12)-5*Q2**7*(38556
            +357489*r**2+504564*r**4+81617*r**6+473328*r**8+1688379*r**10+1329480*r**12
            +183195*r**14)-5*Q2**6*(57960-124467*r**2+295925*r**4+2741021*r**6+5136449*r**8
            +4066963*r**10+490035*r**12-165669*r**14+303975*r**16)+Q2**5*(516456
            +573363*r**2+6551210*r**4+31603502*r**6+74308470*r**8+90473156*r**10
            +56145758*r**12+15840170*r**14+4559562*r**16+2731905*r**18)-5*Q2**4*(52515
            +155709*r**2+1212342*r**4+6057464*r**6+18583638*r**8+30158754*r**10
            +25695316*r**12+11271144*r**14+2845431*r**16+897153*r**18+290790*r**20)
            -5*Q2**3*(15654-103659*r**2+43130*r**4-1514209*r**6-9251464*r**8-16383518*r**10
            -20394136*r**12-15196618*r**14-1758062*r**16+32217*r**18-420306*r**20
            +77595*r**22)+(-1+r**2)**2*(11592-18345*r**2+695733*r**4-81745*r**6
            +3122037*r**8-1180470*r**10-14149954*r**12-15771798*r**14+390*r**16
            +4605983*r**18+1554573*r**20-25881*r**22+69885*r**24)+5*Q2**2*(31338
            -69451*r**2+887491*r**4+908653*r**6-272311*r**8+1288894*r**10-641462*r**12
            -3234082*r**14-4073984*r**16+4774573*r**18+1844691*r**20-206955*r**22
            +173805*r**24)-5*Q2*(14292-36669*r**2+633636*r**4+13564*r**6+1113684*r**8
            +2288967*r**10-11520768*r**12-8298456*r**14-2304012*r**16-3015687*r**18
            +2866908*r**20+1350204*r**22-122908*r**24+82845*r**26))*sqrtq2+24*logq2*(250*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*(111+105*Q2**7-4517*r**2-91999*r**4-164085*r**6
            +1160315*r**8+1928089*r**10+482547*r**12+59769*r**14+1530*r**16-5*Q2**6*(
            -81+31*r**2+240*r**4)+15*Q2**5*(-29-16*r**2+59*r**4+60*r**6)-Q2**4*(
            -321+243*r**2+50107*r**4+69411*r**6+9180*r**8)+Q2**3*(-729-1592*r**2
            +81550*r**4+220582*r**6+137739*r**8+14130*r**10)+Q2**2*(-309-1389*r**2
            -6978*r**4-105212*r**6-125831*r**8-9611*r**10+3210*r**12)+Q2*(531
            -5304*r**2-92255*r**4+33430*r**6+433925*r**8+246424*r**10-45401*r**12
            -9390*r**14))-21*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1
            +r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1
            -14*r**2-94*r**4-14*r**6+r**8))**2*(12*Q2**10*(16+205*r**4)-60*Q2**9*(12
            +12*r**2+211*r**4+275*r**6)+5*Q2**8*(135+270*r**2+4314*r**4+11146*r**6
            +7335*r**8)-60*Q2**7*(-8+24*r**2+157*r**4+1047*r**6+1313*r**8+335*r**10)
            -30*Q2**6*(30-60*r**2+1447*r**4-433*r**6-2349*r**8-1871*r**10+1260*r**12)
            -60*Q2**3*r**4*(911-1449*r**2-3631*r**4-8165*r**6-7971*r**8-5223*r**10
            -2237*r**12+405*r**14)+4*Q2**5*(-36+540*r**2+28785*r**4+42905*r**6
            +47430*r**8+26514*r**10-8755*r**12+13545*r**14)-30*Q2**4*(-19+186*r**2
            +2071*r**4+5553*r**6+13432*r**8+25138*r**10+17181*r**12+1723*r**14
            +175*r**16)+120*Q2*r**4*(116-1379*r**2-13454*r**4-26131*r**6-17070*r**8
            +5559*r**10+4294*r**12-3241*r**14-574*r**16+40*r**18)-3*(-1+r**2)**2*(
            -9+252*r**2+1793*r**4-41806*r**6-222100*r**8-331426*r**10+64268*r**12
            +55502*r**14-35299*r**16-10330*r**18+755*r**20)+10*Q2**2*(-18+324*r**2
            +3303*r**4-12811*r**6+4917*r**8-22143*r**10-69061*r**12+4839*r**14
            +41457*r**16-3457*r**18+810*r**20))+5*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*(30*Q2**15*(1408
            +21355*r**4)-2*Q2**14*(96000+94432*r**2+1841499*r**4+2340195*r**6)+2*Q2**13*(104790
            +289648*r**2+3915889*r**4+9514666*r**6+5723805*r**8)-2*Q2**12*(-133320
            +288212*r**2+3327327*r**4+13894203*r**6+15357559*r**8+3207495*r**10)
            -Q2**11*(609120+109589*r**2+10179979*r**4-5890972*r**6+7743536*r**8
            -6924137*r**10+16303365*r**12)+Q2**10*(-40920+1633551*r**2+30535728*r**4
            +65571913*r**6+235481588*r**8+272338493*r**10+42702732*r**12+22088835*r**14)
            +Q2**9*(641100-1712547*r**2+31855101*r**4+21155575*r**6-292239145*r**8
            -760113305*r**10-578560777*r**12-81091979*r**14+9040905*r**16)-Q2**8*(42360
            +3220167*r**2+163398546*r**4+343826564*r**6+457158230*r**8+205758050*r**10
            +11525982*r**12+39997316*r**14-36530286*r**16+27976095*r**18)+2*Q2**7*(
            -254640+2882199*r**2+59353974*r**4+212515616*r**6+792221208*r**8+1247452960*r**10
            +1272164694*r**12+879465024*r**14+591679136*r**16+53346393*r**18+2437740*r**20)
            +2*Q2**6*(27720+789339*r**2+49458789*r**4-137890762*r**6-928880024*r**8
            -2512926912*r**10-3883645666*r**12-2844620746*r**14-654115832*r**16-302888899*r**18
            -64932987*r**20+7687740*r**22)-2*Q2**5*(-155010+3179651*r**2+75489978*r**4
            +9011143*r**6+1178158688*r**8+1814989088*r**10+143656338*r**12-3265427532*r**14
            -2615233912*r**16-196798587*r**18+465594828*r**20+20256957*r**22+3747810*r**24)
            +2*Q2**4*(-34800+429893*r**2+13092911*r**4+254473345*r**6+3066154535*r**8
            +5518907760*r**10+6022535174*r**12+6239930638*r**14+7188662350*r**16
            +3828621065*r**18+247777115*r**20+414022033*r**22+54467051*r**24-1103070*r**26)
            +Q2**3*(-102720+2946871*r**2+35076693*r**4-430516868*r**6-1622270680*r**8
            -2407501785*r**10-3972479207*r**12-2896383656*r**14-1879468064*r**16
            -11455837155*r**18-12282676545*r**20-2245358164*r**22+56844088*r**24
            -12757243*r**26+1697235*r**28)-(-1+r**2)**2*(6840-262821*r**2+694140*r**4
            +53693853*r**6+340327528*r**8+1056435675*r**10+19830812092*r**12+41828023405*r**14
            +31273693864*r**16+1060482649*r**18-2366456780*r**20+2425860079*r**22
            +553946680*r**24+35499633*r**26-2265452*r**28+132615*r**30)-Q2**2*(-29640
            +759349*r**2+18796244*r**4+90389751*r**6+2573379748*r**8-4264509115*r**10
            -16074629528*r**12-38907744713*r**14-43242750992*r**16-9250682441*r**18
            +9496395540*r**20+4191654029*r**22-988650956*r**24+236074191*r**26+30677168*r**28
            +247365*r**30)+Q2*(18180-712839*r**2+5167701*r**4+197422827*r**6+1553553159*r**8
            -2371820983*r**10+36772678093*r**12+121033122043*r**14+172424472631*r**16
            +58661293507*r**18-8400275609*r**20-4648158839*r**22+8076387181*r**24
            +934073467*r**26+119024759*r**28+5960337*r**30+290385*r**32)))*sqrtq2)/(12247200000*logq2**4*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+170100000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +118125*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-29393280000*logq2**5*r**20*sqrtq2
            -2041200000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-7087500*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2)+((41472000*logq2**4*r**12*(105*Q2**9*(1
            +5*r**4)-5*Q2**8*(249+361*r**2+1101*r**4+1005*r**6)+10*Q2**7*(597+1621*r**2
            +3496*r**4+4343*r**6+2025*r**8)-2*Q2**6*(7812+29149*r**2+64765*r**4
            +93125*r**6+69133*r**8+22260*r**10)+Q2**5*(22974+106027*r**2+250778*r**4
            +470915*r**6+412871*r**8+222906*r**10+55545*r**12)-Q2**4*(15540+92822*r**2
            +231869*r**4+588590*r**6+701120*r**8+419048*r**10+170935*r**12+31500*r**14)
            +2*Q2**3*(-1575+11024*r**2+40642*r**4+140278*r**6+184250*r**8+213791*r**10
            +81491*r**12+6005*r**14-5250*r**16)+(-1+r**2)**2*(1821+1633*r**2+608*r**4
            +116088*r**6-193788*r**8-187194*r**10+70224*r**12-1996*r**14+12199*r**16
            +4005*r**18)+Q2**2*(13020+15118*r**2-11915*r**4+119156*r**6-143159*r**8
            -108758*r**10-29109*r**12-13188*r**14+70635*r**16+29400*r**18)+Q2*(
            -8331-4469*r**2+12109*r**4-306011*r**6+264845*r**8+760417*r**10+146475*r**12
            -137073*r**14+34282*r**16-38464*r**18-18180*r**20))+11520*logq2**2*(
            -Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(9795*Q2**15*(1+5*r**4)-Q2**14*(120261
            +121493*r**2+521937*r**4+598665*r**6)+Q2**13*(604329+1271816*r**2+3448100*r**4
            +5662978*r**6+3101085*r**8)-Q2**12*(1583961+5382217*r**2+14984690*r**4
            +28081086*r**6+25269377*r**8+8589165*r**10)+Q2**11*(2105649+11648083*r**2
            +36582862*r**4+85246604*r**6+92230079*r**8+57617593*r**10+12508410*r**12)
            -Q2**10*(491931+12207009*r**2+35377311*r**4+134400931*r**6+171469901*r**8
            +105720395*r**10+60971217*r**12+4741065*r**14)-Q2**9*(2776653-630711*r**2
            +40542531*r**4-18250145*r**6-76727145*r**8+99740803*r**10+137775089*r**12
            +9194301*r**14+14803920*r**16)+Q2**8*(4096917+13919013*r**2+148377380*r**4
            +308632144*r**6+276891690*r**8+613334922*r**10+965758108*r**12+553194480*r**14
            +104109969*r**16+25872705*r**18)-Q2**7*(1474803+15840426*r**2+133162825*r**4
            +526474548*r**6+441833406*r**8+535880328*r**10+1378107826*r**12+1544646700*r**14
            +552418143*r**16+112180446*r**18+12267045*r**20)-Q2**6*(1984323-5804169*r**2
            +37730299*r**4-375497397*r**6+59872778*r**8+1109296634*r**10+899482146*r**12
            -562848086*r**14-848754237*r**16+108366543*r**18-25743789*r**20+10701195*r**22)
            +Q2**5*(2538327+2759198*r**2+163842602*r**4-105799688*r**6+754730047*r**8
            +3936007492*r**10+6253024212*r**12+5020022232*r**14+1457563277*r**16
            +277470622*r**18+679323650*r**20+45080784*r**22+17078205*r**24)-Q2**4*(816711
            +4176143*r**2+106088382*r**4+37433530*r**6+675121145*r**8+5072470653*r**10
            +10494698764*r**12+12060215356*r**14+7391704305*r**16+1851552905*r**18
            +608344086*r**20+492090218*r**22+42539887*r**24+6699915*r**26)+Q2**3*(
            -449121+2478871*r**2-15046580*r**4+146543328*r**6-217727825*r**8+2390168207*r**10
            +6033710428*r**12+8865032760*r**14+8622117469*r**16+3173450165*r**18
            -114834436*r**20+529359176*r**22-28759755*r**24+12234053*r**26-2577540*r**28)
            +(-1+r**2)**2*(22059-8871*r**2+4419683*r**4-20995819*r**6+139149983*r**8
            +108523417*r**10-822294713*r**12+958091149*r**14-873751727*r**16-1787782061*r**18
            +714996889*r**20+332955959*r**22-45911707*r**24+21722171*r**26+603453*r**28
            +180135*r**30)+Q2**2*(491139-1071907*r**2+52895515*r**4-206636041*r**6
            +887443983*r**8+331547957*r**10-575705201*r**12+1159538095*r**14-467647463*r**16
            -3196260881*r**18+1744035569*r**20+1843553133*r**22-528696235*r**24+221511679*r**26
            +1577573*r**28+3503085*r**30)-Q2*(170451-340323*r**2+26200363*r**4
            -129435949*r**6+685390901*r**8+206205825*r**10-1660142489*r**12+533888479*r**14
            -2084679017*r**16-716426537*r**18-4677079583*r**20+1411398297*r**22+1553436983*r**24
            -348894709*r**26+117080461*r**28+1592757*r**30+1314090*r**32))+16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(552*Q2**20+Q2**19*(1230-86*r**2)+8*Q2**18*(993
            +5225*r**2+2309*r**4)-Q2**17*(793689+350881*r**2+3840383*r**4+361615*r**6)
            +Q2**16*(6432021+485746*r**2+21116616*r**4+38837094*r**6+2083563*r**8)
            -2*Q2**15*(11471247-3133150*r**2-25946401*r**4+101248489*r**6+84688408*r**8
            +2973871*r**10)+Q2**14*(40359885-25706302*r**2-675511331*r**4-240427744*r**6
            +819403091*r**8+369434110*r**10+8820563*r**12)-2*Q2**13*(9542901+2669295*r**2
            -1085865336*r**4-1900280100*r**6-466447889*r**8+803851653*r**10+146175660*r**12
            +1926168*r**14)-Q2**12*(59715123-229084978*r**2+3370785104*r**4+12061520622*r**6
            +13661765622*r**8+4700526258*r**10-1023582864*r**12+443437586*r**14+8895575*r**16)
            +2*Q2**11*(59958951-268593854*r**2+1107903779*r**4+11402737423*r**6+22250625111*r**8
            +21253490637*r**10+7314514917*r**12+1008667129*r**14+657468074*r**16
            +7744633*r**18)-Q2**10*(58479135-343542210*r**2-1563244539*r**4+28898194668*r**6
            +83780882714*r**8+119396855352*r**10+86936703870*r**12+20253826772*r**14
            +5147480295*r**16+1012294602*r**18+4642781*r**20)-2*Q2**9*(40320930-289047506*r**2
            +3077122489*r**4-7457575429*r**6-38957895394*r**8-82778419030*r**10-77053270204*r**12
            -39150651796*r**14+935601416*r**16-2231515984*r**18+284894555*r**20+6165809*r**22)
            +Q2**8*(131865747-1224415370*r**2+8366116250*r**4+22850768770*r**6+14448039489*r**8
            -64268195484*r**10-79801386780*r**12+13590947148*r**14+34024103325*r**16
            +42359779974*r**18-138163070*r**20+1608087890*r**22+15087631*r**24)-2*Q2**7*(23013981
            -298988206*r**2+2129722329*r**4+24289171323*r**6+44661674978*r**8+47234796729*r**10
            +36834968682*r**12+99832766070*r**14+112780665993*r**16+70234457628*r**18
            +22785681581*r**20+1785794655*r**22+443650152*r**24+1609065*r**26)+Q2**6*(
            -50293017+573373078*r**2-4626548429*r**4+31899242456*r**6+36006884167*r**8
            +122998331518*r**10-10829320837*r**12+138039439968*r**14+312641956557*r**16
            +104398998674*r**18+120087044929*r**20-4550430776*r**22+3888809861*r**24
            -428397478*r**26-6511471*r**28)+2*Q2**5*(29194197-444109285*r**2+4525970488*r**4
            -275635120*r**6+18388466093*r**8-60188517893*r**10+167931853520*r**12
            +190859318848*r**14+102048773903*r**16-113442017999*r**18+106822746176*r**20
            -18953374040*r**22+21874725359*r**24-911000263*r**26+391781176*r**28
            +2932040*r**30)-Q2**4*(16040505-330507126*r**2+4716323316*r**4+11233089714*r**6
            +15112005104*r**8-109573193430*r**10+588173222796*r**12+1020409892898*r**14
            +1022875599762*r**16+793357092462*r**18-158390301780*r**20+246316285446*r**22
            +12506888136*r**24+28602910174*r**26+237801684*r**28+303592230*r**30
            +1130109*r**32)+2*Q2**3*(-4614882+74166205*r**2-641187947*r**4+4894880565*r**6
            -13870779821*r**8+15069143875*r**10+131583868765*r**12+374509317573*r**14
            +620236955535*r**16+357597187597*r**18+244037521191*r**20+44917866615*r**22
            -6716860655*r**24+18960340425*r**26-1947071001*r**28+487848591*r**30
            -44487185*r**32-543446*r**34)+2*(-1+r**2)**2*(156654-4170412*r**2+84909051*r**4
            -230578818*r**6+358432710*r**8-5882078502*r**10+74768865726*r**12-231116744978*r**14
            +245764096194*r**16+10125137730*r**18-301537274708*r**20+192462278634*r**22
            -40827260622*r**24+11311878366*r**26-1463840190*r**28+470139306*r**30
            -9537448*r**32+2698674*r**34+12633*r**36)+Q2**2*(8644899-184657634*r**2
            +2643449645*r**4-7304295692*r**6+26751377328*r**8-128117752164*r**10
            +487154478120*r**12-363509890492*r**14+372778090654*r**16-540957326056*r**18
            -236996217094*r**20+896363366812*r**22-445606313176*r**24+180868302468*r**26
            -43091242272*r**28+13124189484*r**30-673003673*r**32+121417898*r**34
            +820945*r**36)-Q2*(2682531-67137509*r**2+1183056495*r**4-3779339229*r**6
            +10174715552*r**8-75459588888*r**10+590033884272*r**12-1177510543480*r**14
            +327748803822*r**16+838933914054*r**18-299472890442*r**20-1671324890442*r**22
            +1404998019000*r**24-419673325232*r**26+125884294536*r**28-23421714576*r**30
            +6145926679*r**32-221450265*r**34+42311139*r**36+231983*r**38))+8709120000*logq2**5*r**16*(9
            +33*r**2+124*r**4-512*r**6+163*r**8+15*r**10)*sqrtq2+691200*logq2**3*r**8*(2265*Q2**12*(1
            +5*r**4)-10*Q2**11*(2439+2383*r**2+10431*r**4+12315*r**6)+2*Q2**10*(57951
            +108258*r**2+244605*r**4+469607*r**6+288855*r**8)-10*Q2**9*(29970+83928*r**2
            +146473*r**4+295842*r**6+354501*r**8+147330*r**10)+10*Q2**8*(41607+170403*r**2
            +278381*r**4+438443*r**6+778226*r**8+693972*r**10+202860*r**12)-5*Q2**7*(38556
            +357489*r**2+504564*r**4+81617*r**6+473328*r**8+1688379*r**10+1329480*r**12
            +183195*r**14)-5*Q2**6*(57960-124467*r**2+295925*r**4+2741021*r**6+5136449*r**8
            +4066963*r**10+490035*r**12-165669*r**14+303975*r**16)+Q2**5*(516456
            +573363*r**2+6551210*r**4+31603502*r**6+74308470*r**8+90473156*r**10
            +56145758*r**12+15840170*r**14+4559562*r**16+2731905*r**18)-5*Q2**4*(52515
            +155709*r**2+1212342*r**4+6057464*r**6+18583638*r**8+30158754*r**10
            +25695316*r**12+11271144*r**14+2845431*r**16+897153*r**18+290790*r**20)
            -5*Q2**3*(15654-103659*r**2+43130*r**4-1514209*r**6-9251464*r**8-16383518*r**10
            -20394136*r**12-15196618*r**14-1758062*r**16+32217*r**18-420306*r**20
            +77595*r**22)+(-1+r**2)**2*(11592-18345*r**2+695733*r**4-81745*r**6
            +3122037*r**8-1180470*r**10-14149954*r**12-15771798*r**14+390*r**16
            +4605983*r**18+1554573*r**20-25881*r**22+69885*r**24)+5*Q2**2*(31338
            -69451*r**2+887491*r**4+908653*r**6-272311*r**8+1288894*r**10-641462*r**12
            -3234082*r**14-4073984*r**16+4774573*r**18+1844691*r**20-206955*r**22
            +173805*r**24)-5*Q2*(14292-36669*r**2+633636*r**4+13564*r**6+1113684*r**8
            +2288967*r**10-11520768*r**12-8298456*r**14-2304012*r**16-3015687*r**18
            +2866908*r**20+1350204*r**22-122908*r**24+82845*r**26))*sqrtq2+96*logq2*(
            -250*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3*(111+105*Q2**7-4517*r**2-91999*r**4
            -164085*r**6+1160315*r**8+1928089*r**10+482547*r**12+59769*r**14+1530*r**16
            -5*Q2**6*(-81+31*r**2+240*r**4)+15*Q2**5*(-29-16*r**2+59*r**4+60*r**6)
            -Q2**4*(-321+243*r**2+50107*r**4+69411*r**6+9180*r**8)+Q2**3*(-729
            -1592*r**2+81550*r**4+220582*r**6+137739*r**8+14130*r**10)+Q2**2*(-309
            -1389*r**2-6978*r**4-105212*r**6-125831*r**8-9611*r**10+3210*r**12)
            +Q2*(531-5304*r**2-92255*r**4+33430*r**6+433925*r**8+246424*r**10
            -45401*r**12-9390*r**14))+21*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))**2*(12*Q2**10*(16+205*r**4)
            -60*Q2**9*(12+12*r**2+211*r**4+275*r**6)+5*Q2**8*(135+270*r**2+4314*r**4
            +11146*r**6+7335*r**8)-60*Q2**7*(-8+24*r**2+157*r**4+1047*r**6+1313*r**8
            +335*r**10)-30*Q2**6*(30-60*r**2+1447*r**4-433*r**6-2349*r**8-1871*r**10
            +1260*r**12)-60*Q2**3*r**4*(911-1449*r**2-3631*r**4-8165*r**6-7971*r**8
            -5223*r**10-2237*r**12+405*r**14)+4*Q2**5*(-36+540*r**2+28785*r**4
            +42905*r**6+47430*r**8+26514*r**10-8755*r**12+13545*r**14)-30*Q2**4*(
            -19+186*r**2+2071*r**4+5553*r**6+13432*r**8+25138*r**10+17181*r**12
            +1723*r**14+175*r**16)+120*Q2*r**4*(116-1379*r**2-13454*r**4-26131*r**6
            -17070*r**8+5559*r**10+4294*r**12-3241*r**14-574*r**16+40*r**18)-3*(
            -1+r**2)**2*(-9+252*r**2+1793*r**4-41806*r**6-222100*r**8-331426*r**10
            +64268*r**12+55502*r**14-35299*r**16-10330*r**18+755*r**20)+10*Q2**2*(
            -18+324*r**2+3303*r**4-12811*r**6+4917*r**8-22143*r**10-69061*r**12
            +4839*r**14+41457*r**16-3457*r**18+810*r**20))-5*(Q2**2+(-1+r**2)**2
            -2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*(30*Q2**15*(1408+21355*r**4)-2*Q2**14*(96000+94432*r**2+1841499*r**4
            +2340195*r**6)+2*Q2**13*(104790+289648*r**2+3915889*r**4+9514666*r**6
            +5723805*r**8)-2*Q2**12*(-133320+288212*r**2+3327327*r**4+13894203*r**6
            +15357559*r**8+3207495*r**10)-Q2**11*(609120+109589*r**2+10179979*r**4
            -5890972*r**6+7743536*r**8-6924137*r**10+16303365*r**12)+Q2**10*(-40920
            +1633551*r**2+30535728*r**4+65571913*r**6+235481588*r**8+272338493*r**10
            +42702732*r**12+22088835*r**14)+Q2**9*(641100-1712547*r**2+31855101*r**4
            +21155575*r**6-292239145*r**8-760113305*r**10-578560777*r**12-81091979*r**14
            +9040905*r**16)-Q2**8*(42360+3220167*r**2+163398546*r**4+343826564*r**6
            +457158230*r**8+205758050*r**10+11525982*r**12+39997316*r**14-36530286*r**16
            +27976095*r**18)+2*Q2**7*(-254640+2882199*r**2+59353974*r**4+212515616*r**6
            +792221208*r**8+1247452960*r**10+1272164694*r**12+879465024*r**14+591679136*r**16
            +53346393*r**18+2437740*r**20)+2*Q2**6*(27720+789339*r**2+49458789*r**4
            -137890762*r**6-928880024*r**8-2512926912*r**10-3883645666*r**12-2844620746*r**14
            -654115832*r**16-302888899*r**18-64932987*r**20+7687740*r**22)-2*Q2**5*(
            -155010+3179651*r**2+75489978*r**4+9011143*r**6+1178158688*r**8+1814989088*r**10
            +143656338*r**12-3265427532*r**14-2615233912*r**16-196798587*r**18+465594828*r**20
            +20256957*r**22+3747810*r**24)+2*Q2**4*(-34800+429893*r**2+13092911*r**4
            +254473345*r**6+3066154535*r**8+5518907760*r**10+6022535174*r**12+6239930638*r**14
            +7188662350*r**16+3828621065*r**18+247777115*r**20+414022033*r**22+54467051*r**24
            -1103070*r**26)+Q2**3*(-102720+2946871*r**2+35076693*r**4-430516868*r**6
            -1622270680*r**8-2407501785*r**10-3972479207*r**12-2896383656*r**14-1879468064*r**16
            -11455837155*r**18-12282676545*r**20-2245358164*r**22+56844088*r**24
            -12757243*r**26+1697235*r**28)-(-1+r**2)**2*(6840-262821*r**2+694140*r**4
            +53693853*r**6+340327528*r**8+1056435675*r**10+19830812092*r**12+41828023405*r**14
            +31273693864*r**16+1060482649*r**18-2366456780*r**20+2425860079*r**22
            +553946680*r**24+35499633*r**26-2265452*r**28+132615*r**30)-Q2**2*(-29640
            +759349*r**2+18796244*r**4+90389751*r**6+2573379748*r**8-4264509115*r**10
            -16074629528*r**12-38907744713*r**14-43242750992*r**16-9250682441*r**18
            +9496395540*r**20+4191654029*r**22-988650956*r**24+236074191*r**26+30677168*r**28
            +247365*r**30)+Q2*(18180-712839*r**2+5167701*r**4+197422827*r**6+1553553159*r**8
            -2371820983*r**10+36772678093*r**12+121033122043*r**14+172424472631*r**16
            +58661293507*r**18-8400275609*r**20-4648158839*r**22+8076387181*r**24
            +934073467*r**26+119024759*r**28+5960337*r**30+290385*r**32)))*sqrtq2)*math.log(murhoD))/(13226976000*logq2**4*r**16*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))+183708000*logq2**2*r**8*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**3
            +127575*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**3*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5-31744742400*logq2**5*r**20*sqrtq2
            -2204496000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3
            -7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*sqrtq2-7654500*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**4*sqrtq2))+(muWC**3*(-544320000*logq2**4*r**16*(9
            +28*r**2+34*r**4+28*r**6+9*r**8)-14400*logq2**2*(-Q2+(-1+r)**2)*r**8*(
            -Q2+(1+r)**2)*(755*Q2**10-6460*Q2**9*(1+r**2)+19*Q2**8*(1397+2670*r**2
            +1397*r**4)-2*Q2**7*(22697+75917*r**2+75917*r**4+22697*r**6)+Q2**6*(18389
            +192140*r**2+288058*r**4+192140*r**6+18389*r**8)+Q2**5*(33782-72026*r**2
            -3024*r**4-3024*r**6-72026*r**8+33782*r**10)-Q2**4*(39655+164510*r**2
            +1238017*r**4+2141020*r**6+1238017*r**8+164510*r**10+39655*r**12)+2*Q2**3*(3721
            +115075*r**2+794925*r**4+2094619*r**6+2094619*r**8+794925*r**10+115075*r**12
            +3721*r**14)+4*Q2**2*(2651-3949*r**2+57848*r**4-355357*r**6-683806*r**8
            -355357*r**10+57848*r**12-3949*r**14+2651*r**16)-18*Q2*(453+4355*r**2
            +39700*r**4-68700*r**6-202608*r**8-202608*r**10-68700*r**12+39700*r**14
            +4355*r**16+453*r**18)+12*(179+1333*r**2+22836*r**4+74334*r**6+510837*r**8
            +822162*r**10+510837*r**12+74334*r**14+22836*r**16+1333*r**18+179*r**20))
            -2*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(6866*Q2**16-23436*Q2**15*(1
            +r**2)+8*Q2**14*(865+8596*r**2+865*r**4)+8*Q2**13*(5380-11099*r**2
            -11099*r**4+5380*r**6)+Q2**12*(10045-259012*r**2-2562366*r**4-259012*r**6
            +10045*r**8)-4*Q2**11*(34147-324527*r**2-3988562*r**4-3988562*r**6-324527*r**8
            +34147*r**10)+2*Q2**10*(35759-646722*r**2-15796615*r**4-38576020*r**6
            -15796615*r**8-646722*r**10+35759*r**12)+8*Q2**9*(13745-127492*r**2
            +2119265*r**4+19072200*r**6+19072200*r**8+2119265*r**10-127492*r**12
            +13745*r**14)+Q2**8*(-91205+2043184*r**2+31186064*r**4-92196960*r**6
            -136611350*r**8-92196960*r**10+31186064*r**12+2043184*r**14-91205*r**16)
            -4*Q2**7*(8785+21669*r**2+14208392*r**4+33962024*r**6+101173570*r**8
            +101173570*r**10+33962024*r**12+14208392*r**14+21669*r**16+8785*r**18)
            +4*Q2**6*(10807-257354*r**2+4036831*r**4+57257856*r**6+179616146*r**8
            +416911988*r**10+179616146*r**12+57257856*r**14+4036831*r**16-257354*r**18
            +10807*r**20)-8*Q2**5*(266-53737*r**2-4403625*r**4+12575730*r**6+21507400*r**8
            +309675766*r**10+309675766*r**12+21507400*r**14+12575730*r**16-4403625*r**18
            -53737*r**20+266*r**22)-Q2**4*(2005+87332*r**2+26936590*r**4+29645300*r**6
            +614859675*r**8-231352920*r**10+1158640836*r**12-231352920*r**14+614859675*r**16
            +29645300*r**18+26936590*r**20+87332*r**22+2005*r**24)+4*Q2**3*(135
            -9223*r**2-887018*r**4+22918230*r**6+168130475*r**8+734118485*r**10
            +2173168916*r**12+2173168916*r**14+734118485*r**16+168130475*r**18+22918230*r**20
            -887018*r**22-9223*r**24+135*r**26)-2*Q2**2*(1265-69094*r**2-3667317*r**4
            +24306396*r**6-83158055*r**8+480299590*r**10+308598123*r**12+3065234184*r**14
            +308598123*r**16+480299590*r**18-83158055*r**20+24306396*r**22-3667317*r**24
            -69094*r**26+1265*r**28)+24*Q2*(31-1758*r**2-54453*r**4-686878*r**6
            -12831908*r**8+1292719*r**10-99093084*r**12+519615331*r**14+519615331*r**16
            -99093084*r**18+1292719*r**20-12831908*r**22-686878*r**24-54453*r**26
            -1758*r**28+31*r**30)+3*(57-3672*r**2+19060*r**4+3841960*r**6+9425060*r**8
            +68973464*r**10+826635276*r**12-1542120*r**14+7983061830*r**16-1542120*r**18
            +826635276*r**20+68973464*r**22+9425060*r**24+3841960*r**26+19060*r**28
            -3672*r**30+57*r**32))-864000*logq2**3*r**12*(867+35*Q2**7+3267*r**2
            +42957*r**4+88989*r**6+88989*r**8+42957*r**10+3267*r**12+867*r**14
            -505*Q2**6*(1+r**2)+5*Q2**5*(445+904*r**2+445*r**4)-Q2**4*(5293+15125*r**2
            +15125*r**4+5293*r**6)-3*Q2*(1+r**2)**2*(1111-2778*r**2-446*r**4-2778*r**6
            +1111*r**8)+Q2**3*(4157+17952*r**2+28010*r**4+17952*r**6+4157*r**8)
            +Q2**2*(1847-3657*r**2-14318*r**4-14318*r**6-3657*r**8+1847*r**10))*sqrtq2
            +240*logq2*r**4*(-25*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2*(105*Q2**7-555*Q2**6*(1
            +r**2)+15*Q2**5*(19+52*r**2+19*r**4)-Q2**4*(751+5687*r**2+5687*r**4
            +751*r**6)+Q2**3*(1139+8352*r**2+14006*r**4+8352*r**6+1139*r**8)+Q2**2*(719
            +3879*r**2+4474*r**4+4474*r**6+3879*r**8+719*r**10)+Q2*(-681+2244*r**2
            +38061*r**4+66912*r**6+38061*r**8+2244*r**10-681*r**12)+3*(-87+1849*r**2
            +34455*r**4+109943*r**6+109943*r**8+34455*r**10+1849*r**12-87*r**14))
            -2*(-Q2+(-1+r)**2)*(-Q2+(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))*(971+40*Q2**9-18517*r**2-136600*r**4+561592*r**6+1104554*r**8
            +1104554*r**10+561592*r**12-136600*r**14-18517*r**16+971*r**18-889*Q2**8*(1
            +r**2)+23*Q2**7*(169+418*r**2+169*r**4)-Q2**6*(4347+16967*r**2+16967*r**4
            +4347*r**6)-2*Q2**5*(1113+3489*r**2+13232*r**4+3489*r**6+1113*r**8)
            +2*Q2**4*(2240+11225*r**2+82043*r**4+82043*r**6+11225*r**8+2240*r**10)
            +Q2**3*(1659-18836*r**2-355219*r**4-699528*r**6-355219*r**8-18836*r**10
            +1659*r**12)+Q2**2*(-2567+13091*r**2+205549*r**4+793607*r**6+793607*r**8
            +205549*r**10+13091*r**12-2567*r**14)-8*Q2*(126-2129*r**2-34216*r**4
            -21131*r**6-11300*r**8-21131*r**10-34216*r**12-2129*r**14+126*r**16)))*sqrtq2)*nlopw.X1Q2RhoD(0,Q2,r))/(
            -9797760000*logq2**5*r**20-680400000*logq2**3*r**12*(Q2**2+(-1+r**2)**2-2*Q2*(1
            +r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2
            -2362500*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4+4082400000*logq2**4*r**16*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+56700000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2+39375*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**5*sqrtq2)
            +(muWC**3*(-6048000*logq2**3*r**12*(1+r**2)*(29+50*r**2+29*r**4)-240*logq2*(
            -Q2+(-1+r)**2)*r**4*(-Q2+(1+r)**2)*(1873-640*Q2**9-8851*r**2+85460*r**4
            +1289996*r**6+6796322*r**8+6796322*r**10+1289996*r**12+85460*r**14-8851*r**16
            +1873*r**18+8848*Q2**8*(1+r**2)-32*Q2**7*(617+1454*r**2+617*r**4)+Q2**6*(8169
            +72819*r**2+72819*r**4+8169*r**6)+2*Q2**5*(6881-28372*r**2-46826*r**4
            -28372*r**6+6881*r**8)-Q2**4*(13825+65585*r**2+481262*r**4+481262*r**6
            +65585*r**8+13825*r**10)+4*Q2**3*(903+32098*r**2+185817*r**4+339964*r**6
            +185817*r**8+32098*r**10+903*r**12)+Q2**2*(1879+11233*r**2+272487*r**4
            -159599*r**6-159599*r**8+272487*r**10+11233*r**12+1879*r**14)-2*Q2*(1967
            +21792*r**2+88088*r**4-781552*r**6-1382190*r**8-781552*r**10+88088*r**12
            +21792*r**14+1967*r**16))-14400*logq2**2*r**8*(71-160*Q2**6+6084*r**2
            +70785*r**4+118280*r**6+70785*r**8+6084*r**10+71*r**12+960*Q2**5*(1
            +r**2)-288*Q2**4*(13+24*r**2+13*r**4)+Q2**3*(3221+9879*r**2+9879*r**4
            +3221*r**6)+3*Q2**2*(607-396*r**2-982*r**4-396*r**6+607*r**8)-3*Q2*(723
            -2099*r**2-6184*r**4-6184*r**6-2099*r**8+723*r**10))*sqrtq2+(2000*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2*(1+8*Q2**6-34*r**2-1133*r**4-2708*r**6-1133*r**8
            -34*r**10+r**12-6*Q2**5*(1+r**2)+Q2**4*(-6+4*r**2-6*r**4)+Q2**3*(1
            -19*r**2-19*r**4+r**6)+Q2**2*(1-26*r**2-118*r**4-26*r**6+r**8)+Q2*(1
            -31*r**2-390*r**4-390*r**6-31*r**8+r**10))-28*(Q2-(-1+r)**2)*(Q2
            -(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1
            -11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*(13+8*Q2**8
            -444*r**2-9976*r**4+31692*r**6-28170*r**8+31692*r**10-9976*r**12-444*r**14
            +13*r**16-24*Q2**7*(1+r**2)+Q2**6*(-11+10*r**2-11*r**4)+2*Q2**5*(61
            -193*r**2-193*r**4+61*r**6)+Q2**4*(-165+1480*r**2+10138*r**4+1480*r**6
            -165*r**8)+4*Q2**3*(13-355*r**2-6138*r**4-6138*r**6-355*r**8+13*r**10)
            +Q2**2*(59-406*r**2+10313*r**4+35188*r**6+10313*r**8-406*r**10+59*r**12)
            -2*Q2*(27-595*r**2-7237*r**4+6605*r**6+6605*r**8-7237*r**10-595*r**12
            +27*r**14)))*sqrtq2)*nlopw.X1Q2RhoD(1,Q2,r))/(163296000*logq2**4*r**16+6804000*logq2**2*r**8*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**2+7875*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))**2*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**4-54432000*logq2**3*r**12*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2-378000*logq2*r**4*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(muWC**3*(-129600*logq2**2*r**8*(1+r**2)**2
            -4*(Q2-(-1+r)**2)*(Q2-(1+r)**2)*(8*Q2**4-7*Q2**3*(1+r**2)+Q2**2*(
            -7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2-94*r**4
            -14*r**6+r**8))**2+1440*logq2*r**4*(1+r**2)*(8*Q2**4-7*Q2**3*(1+r**2)
            +Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4+r**6)+3*(1-14*r**2
            -94*r**4-14*r**6+r**8))*sqrtq2)*nlopw.X1Q2RhoD(2,Q2,r))/(-129600*logq2**3*r**12
            -2700*logq2*r**4*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2
            -7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))**2+32400*logq2**2*r**8*(1
            +Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2+75*(Q2**2
            +(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1
            +r**2)-Q2*(1+r**4))**3*sqrtq2)+(muWC**3*(-2880*logq2*r**4*(1+r**2)+16*(8*Q2**4
            -7*Q2**3*(1+r**2)+Q2**2*(-7+2*r**2-7*r**4)+3*Q2*(1-11*r**2-11*r**4
            +r**6)+3*(1-14*r**2-94*r**4-14*r**6+r**8))*sqrtq2)*nlopw.X1Q2RhoD(3,Q2,r))/(6480*logq2**2*r**8
            +45*(Q2**2+(-1+r**2)**2-2*Q2*(1+r**2))*(1+Q2**3-7*r**2-7*r**4+r**6
            -Q2**2*(1+r**2)-Q2*(1+r**4))**2-1080*logq2*r**4*(1+Q2**3-7*r**2-7*r**4
            +r**6-Q2**2*(1+r**2)-Q2*(1+r**4))*sqrtq2)-(8*muWC**3*nlopw.X1Q2RhoD(4,Q2,r))/(
            -108*logq2*r**4+9*(1+Q2**3-7*r**2-7*r**4+r**6-Q2**2*(1+r**2)-Q2*(1
            +r**4))*sqrtq2))
        if( flagDEBUG == 1):
            print("Q2moment n. 4 NNLO pw = api^2*",resNNLO*par.mbkin**8)
        res += api**2*resNNLO

    return res*par.mbkin**8


